var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[Object.keys(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};

// node_modules/aws-embedded-metrics/lib/Constants.js
var require_Constants = __commonJS({
  "node_modules/aws-embedded-metrics/lib/Constants.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Constants;
    (function(Constants2) {
      Constants2[Constants2["MAX_DIMENSIONS"] = 9] = "MAX_DIMENSIONS";
      Constants2["DEFAULT_NAMESPACE"] = "aws-embedded-metrics";
      Constants2[Constants2["MAX_METRICS_PER_EVENT"] = 100] = "MAX_METRICS_PER_EVENT";
      Constants2["DEFAULT_AGENT_HOST"] = "0.0.0.0";
      Constants2[Constants2["DEFAULT_AGENT_PORT"] = 25888] = "DEFAULT_AGENT_PORT";
    })(Constants = exports.Constants || (exports.Constants = {}));
  }
});

// node_modules/aws-embedded-metrics/lib/environment/Environments.js
var require_Environments = __commonJS({
  "node_modules/aws-embedded-metrics/lib/environment/Environments.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Environments;
    (function(Environments2) {
      Environments2["Local"] = "Local";
      Environments2["Lambda"] = "Lambda";
      Environments2["Agent"] = "Agent";
      Environments2["EC2"] = "EC2";
      Environments2["ECS"] = "ECS";
      Environments2["Unknown"] = "";
    })(Environments || (Environments = {}));
    exports.default = Environments;
  }
});

// node_modules/aws-embedded-metrics/lib/config/EnvironmentConfigurationProvider.js
var require_EnvironmentConfigurationProvider = __commonJS({
  "node_modules/aws-embedded-metrics/lib/config/EnvironmentConfigurationProvider.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Constants_1 = require_Constants();
    var Environments_1 = require_Environments();
    var ENV_VAR_PREFIX = "AWS_EMF";
    var ConfigKeys;
    (function(ConfigKeys2) {
      ConfigKeys2["LOG_GROUP_NAME"] = "LOG_GROUP_NAME";
      ConfigKeys2["LOG_STREAM_NAME"] = "LOG_STREAM_NAME";
      ConfigKeys2["ENABLE_DEBUG_LOGGING"] = "ENABLE_DEBUG_LOGGING";
      ConfigKeys2["SERVICE_NAME"] = "SERVICE_NAME";
      ConfigKeys2["SERVICE_TYPE"] = "SERVICE_TYPE";
      ConfigKeys2["AGENT_ENDPOINT"] = "AGENT_ENDPOINT";
      ConfigKeys2["ENVIRONMENT_OVERRIDE"] = "ENVIRONMENT";
      ConfigKeys2["NAMESPACE"] = "NAMESPACE";
    })(ConfigKeys || (ConfigKeys = {}));
    var EnvironmentConfigurationProvider = class {
      getConfiguration() {
        return {
          agentEndpoint: this.getEnvVariable(ConfigKeys.AGENT_ENDPOINT),
          debuggingLoggingEnabled: this.tryGetEnvVariableAsBoolean(ConfigKeys.ENABLE_DEBUG_LOGGING, false),
          logGroupName: this.getEnvVariable(ConfigKeys.LOG_GROUP_NAME),
          logStreamName: this.getEnvVariable(ConfigKeys.LOG_STREAM_NAME),
          serviceName: this.getEnvVariable(ConfigKeys.SERVICE_NAME) || this.getEnvVariableWithoutPrefix(ConfigKeys.SERVICE_NAME),
          serviceType: this.getEnvVariable(ConfigKeys.SERVICE_TYPE) || this.getEnvVariableWithoutPrefix(ConfigKeys.SERVICE_TYPE),
          environmentOverride: this.getEnvironmentOverride(),
          namespace: this.getEnvVariable(ConfigKeys.NAMESPACE) || Constants_1.Constants.DEFAULT_NAMESPACE
        };
      }
      getEnvVariableWithoutPrefix(configKey) {
        return process.env[configKey];
      }
      getEnvVariable(configKey) {
        return process.env[`${ENV_VAR_PREFIX}_${configKey}`];
      }
      tryGetEnvVariableAsBoolean(configKey, fallback) {
        const configValue = this.getEnvVariable(configKey);
        return !configValue ? fallback : configValue.toLowerCase() === "true";
      }
      getEnvironmentOverride() {
        const overrideValue = this.getEnvVariable(ConfigKeys.ENVIRONMENT_OVERRIDE);
        const environment = Environments_1.default[overrideValue];
        if (environment === void 0) {
          return Environments_1.default.Unknown;
        }
        return environment;
      }
    };
    exports.EnvironmentConfigurationProvider = EnvironmentConfigurationProvider;
  }
});

// node_modules/aws-embedded-metrics/lib/config/Configuration.js
var require_Configuration = __commonJS({
  "node_modules/aws-embedded-metrics/lib/config/Configuration.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var EnvironmentConfigurationProvider_1 = require_EnvironmentConfigurationProvider();
    var Configuration = new EnvironmentConfigurationProvider_1.EnvironmentConfigurationProvider().getConfiguration();
    exports.default = Configuration;
  }
});

// node_modules/aws-embedded-metrics/lib/utils/Logger.js
var require_Logger = __commonJS({
  "node_modules/aws-embedded-metrics/lib/utils/Logger.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Configuration_1 = require_Configuration();
    var LOG = (...args) => {
      if (Configuration_1.default.debuggingLoggingEnabled) {
        console.log(...args);
      }
    };
    exports.LOG = LOG;
  }
});

// node_modules/aws-embedded-metrics/lib/logger/MetricValues.js
var require_MetricValues = __commonJS({
  "node_modules/aws-embedded-metrics/lib/logger/MetricValues.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var MetricValues = class {
      constructor(value, unit) {
        this.values = [value];
        this.unit = unit || "None";
      }
      addValue(value) {
        this.values.push(value);
      }
    };
    exports.MetricValues = MetricValues;
  }
});

// node_modules/aws-embedded-metrics/lib/logger/MetricsContext.js
var require_MetricsContext = __commonJS({
  "node_modules/aws-embedded-metrics/lib/logger/MetricsContext.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Configuration_1 = require_Configuration();
    var Logger_1 = require_Logger();
    var MetricValues_1 = require_MetricValues();
    var MetricsContext = class {
      constructor(namespace, properties, dimensions, defaultDimensions, shouldUseDefaultDimensions, timestamp) {
        this.metrics = new Map();
        this.meta = {};
        this.shouldUseDefaultDimensions = true;
        this.namespace = namespace || Configuration_1.default.namespace;
        this.properties = properties || {};
        this.dimensions = dimensions || [];
        this.timestamp = timestamp;
        this.meta.Timestamp = MetricsContext.resolveMetaTimestamp(timestamp);
        this.defaultDimensions = defaultDimensions || {};
        if (shouldUseDefaultDimensions != void 0) {
          this.shouldUseDefaultDimensions = shouldUseDefaultDimensions;
        }
      }
      static empty() {
        return new MetricsContext();
      }
      static resolveMetaTimestamp(timestamp) {
        if (timestamp instanceof Date) {
          return timestamp.getTime();
        } else if (timestamp) {
          return timestamp;
        } else {
          return Date.now();
        }
      }
      setNamespace(value) {
        this.namespace = value;
      }
      setProperty(key, value) {
        this.properties[key] = value;
      }
      setTimestamp(timestamp) {
        this.timestamp = timestamp;
        this.meta.Timestamp = MetricsContext.resolveMetaTimestamp(timestamp);
      }
      setDefaultDimensions(dimensions) {
        Logger_1.LOG(`Received default dimensions`, dimensions);
        this.defaultDimensions = dimensions;
      }
      putDimensions(incomingDimensionSet) {
        if (this.dimensions.length === 0) {
          this.dimensions.push(incomingDimensionSet);
          return;
        }
        for (let i = 0; i < this.dimensions.length; i++) {
          const existingDimensionSet = this.dimensions[i];
          const existingDimensionSetKeys = Object.keys(existingDimensionSet);
          const incomingDimensionSetKeys = Object.keys(incomingDimensionSet);
          if (existingDimensionSetKeys.length !== incomingDimensionSetKeys.length) {
            this.dimensions.push(incomingDimensionSet);
            return;
          }
          for (let j = 0; j < existingDimensionSetKeys.length; j++) {
            if (!incomingDimensionSetKeys.includes(existingDimensionSetKeys[j])) {
              this.dimensions.push(incomingDimensionSet);
              return;
            }
          }
        }
      }
      setDimensions(dimensionSets) {
        this.shouldUseDefaultDimensions = false;
        this.dimensions = dimensionSets;
      }
      getDimensions() {
        if (this.shouldUseDefaultDimensions === false) {
          return this.dimensions;
        }
        if (Object.keys(this.defaultDimensions).length === 0) {
          return this.dimensions;
        }
        if (this.dimensions.length === 0) {
          return [this.defaultDimensions];
        }
        return this.dimensions.map((custom) => {
          return Object.assign(Object.assign({}, this.defaultDimensions), custom);
        });
      }
      putMetric(key, value, unit) {
        const currentMetric = this.metrics.get(key);
        if (currentMetric) {
          currentMetric.addValue(value);
        } else {
          this.metrics.set(key, new MetricValues_1.MetricValues(value, unit));
        }
      }
      createCopyWithContext() {
        return new MetricsContext(this.namespace, Object.assign({}, this.properties), Object.assign([], this.dimensions), this.defaultDimensions, this.shouldUseDefaultDimensions, this.timestamp);
      }
    };
    exports.MetricsContext = MetricsContext;
  }
});

// node_modules/aws-embedded-metrics/lib/logger/MetricsLogger.js
var require_MetricsLogger = __commonJS({
  "node_modules/aws-embedded-metrics/lib/logger/MetricsLogger.js"(exports) {
    "use strict";
    var __awaiter = exports && exports.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    var Configuration_1 = require_Configuration();
    var MetricsContext_1 = require_MetricsContext();
    var MetricsLogger = class {
      constructor(resolveEnvironment, context) {
        this.configureContextForEnvironment = (context2, environment) => {
          const defaultDimensions = {
            LogGroup: environment.getLogGroupName(),
            ServiceName: Configuration_1.default.serviceName || environment.getName(),
            ServiceType: Configuration_1.default.serviceType || environment.getType()
          };
          context2.setDefaultDimensions(defaultDimensions);
          environment.configureContext(context2);
        };
        this.resolveEnvironment = resolveEnvironment;
        this.context = context || MetricsContext_1.MetricsContext.empty();
      }
      flush() {
        return __awaiter(this, void 0, void 0, function* () {
          const environment = yield this.resolveEnvironment();
          this.configureContextForEnvironment(this.context, environment);
          const sink = environment.getSink();
          yield sink.accept(this.context);
          this.context = this.context.createCopyWithContext();
        });
      }
      setProperty(key, value) {
        this.context.setProperty(key, value);
        return this;
      }
      putDimensions(dimensions) {
        this.context.putDimensions(dimensions);
        return this;
      }
      setDimensions(...dimensionSets) {
        this.context.setDimensions(dimensionSets);
        return this;
      }
      putMetric(key, value, unit) {
        this.context.putMetric(key, value, unit);
        return this;
      }
      setNamespace(value) {
        this.context.setNamespace(value);
        return this;
      }
      setTimestamp(timestamp) {
        this.context.setTimestamp(timestamp);
        return this;
      }
      new() {
        return new MetricsLogger(this.resolveEnvironment, this.context.createCopyWithContext());
      }
    };
    exports.MetricsLogger = MetricsLogger;
  }
});

// node_modules/aws-embedded-metrics/lib/serializers/LogSerializer.js
var require_LogSerializer = __commonJS({
  "node_modules/aws-embedded-metrics/lib/serializers/LogSerializer.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Constants_1 = require_Constants();
    var LogSerializer = class {
      serialize(context) {
        const dimensionKeys = [];
        let dimensionProperties = {};
        context.getDimensions().forEach((d) => {
          const keys = Object.keys(d).slice(0, Constants_1.Constants.MAX_DIMENSIONS);
          dimensionKeys.push(keys);
          dimensionProperties = Object.assign(Object.assign({}, dimensionProperties), d);
        });
        const createBody = () => {
          return Object.assign(Object.assign(Object.assign({}, dimensionProperties), context.properties), { _aws: Object.assign(Object.assign({}, context.meta), { CloudWatchMetrics: [
            {
              Dimensions: dimensionKeys,
              Metrics: [],
              Namespace: context.namespace
            }
          ] }) });
        };
        const eventBatches = [];
        let currentBody = createBody();
        const currentMetricsInBody = () => currentBody._aws.CloudWatchMetrics[0].Metrics.length;
        const shouldSerialize = () => currentMetricsInBody() === Constants_1.Constants.MAX_METRICS_PER_EVENT;
        const serializeCurrentBody = () => {
          eventBatches.push(JSON.stringify(currentBody));
          currentBody = createBody();
        };
        for (const [key, metric] of context.metrics) {
          const metricValue = metric.values.length === 1 ? metric.values[0] : metric.values;
          currentBody[key] = metricValue;
          currentBody._aws.CloudWatchMetrics[0].Metrics.push({ Name: key, Unit: metric.unit });
          if (shouldSerialize()) {
            serializeCurrentBody();
          }
        }
        if (eventBatches.length === 0 || currentMetricsInBody() > 0) {
          serializeCurrentBody();
        }
        return eventBatches;
      }
    };
    exports.LogSerializer = LogSerializer;
  }
});

// node_modules/aws-embedded-metrics/lib/sinks/ConsoleSink.js
var require_ConsoleSink = __commonJS({
  "node_modules/aws-embedded-metrics/lib/sinks/ConsoleSink.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var LogSerializer_1 = require_LogSerializer();
    var ConsoleSink = class {
      constructor(serializer) {
        this.name = "ConsoleSink";
        this.serializer = serializer || new LogSerializer_1.LogSerializer();
      }
      accept(context) {
        const events = this.serializer.serialize(context);
        events.forEach((event) => console.log(event));
        return Promise.resolve();
      }
    };
    exports.ConsoleSink = ConsoleSink;
  }
});

// node_modules/aws-embedded-metrics/lib/sinks/connections/TcpClient.js
var require_TcpClient = __commonJS({
  "node_modules/aws-embedded-metrics/lib/sinks/connections/TcpClient.js"(exports) {
    "use strict";
    var __awaiter = exports && exports.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    var net = require("net");
    var Logger_1 = require_Logger();
    var TcpClient = class {
      constructor(endpoint) {
        this.endpoint = endpoint;
        this.socket = new net.Socket({ allowHalfOpen: true, writable: false }).setEncoding("utf8").setKeepAlive(true).setTimeout(5e3).on("timeout", () => this.disconnect("idle timeout")).on("end", () => this.disconnect("end")).on("data", (data) => Logger_1.LOG("TcpClient received data.", data));
      }
      warmup() {
        return __awaiter(this, void 0, void 0, function* () {
          try {
            yield this.establishConnection();
          } catch (err) {
            Logger_1.LOG("Failed to connect", err);
          }
        });
      }
      sendMessage(message) {
        return __awaiter(this, void 0, void 0, function* () {
          yield this.waitForOpenConnection();
          yield new Promise((resolve, reject) => {
            const onSendError = (err) => {
              Logger_1.LOG("Failed to write", err);
              reject(err);
            };
            const wasFlushedToKernel = this.socket.write(message, (err) => {
              if (!err) {
                Logger_1.LOG("Write succeeded");
                resolve();
              } else {
                onSendError(err);
              }
            });
            if (!wasFlushedToKernel) {
              Logger_1.LOG("TcpClient data was not flushed to kernel buffer and was queued in memory.");
            }
          });
        });
      }
      disconnect(eventName) {
        Logger_1.LOG("TcpClient disconnected due to:", eventName);
        this.socket.removeAllListeners();
        this.socket.destroy();
        this.socket.unref();
      }
      waitForOpenConnection() {
        return __awaiter(this, void 0, void 0, function* () {
          if (!this.socket.writeable || this.socket.readyState !== "open") {
            yield this.establishConnection();
          }
        });
      }
      establishConnection() {
        return __awaiter(this, void 0, void 0, function* () {
          yield new Promise((resolve, reject) => {
            const onError = (e) => {
              if (e.message.includes("EISCONN")) {
                resolve();
                return;
              }
              Logger_1.LOG("TCP Client received error", e);
              this.disconnect(e.message);
              reject(e);
            };
            const onConnect = () => {
              this.socket.removeListener("error", onError);
              Logger_1.LOG("TcpClient connected.", this.endpoint);
              resolve();
            };
            switch (this.socket.readyState) {
              case "open":
                resolve();
                break;
              case "opening":
                this.socket.once("connect", onConnect);
                this.socket.once("error", onError);
                break;
              default:
                Logger_1.LOG("opening connection with socket in state: ", this.socket.readyState);
                this.socket.connect(this.endpoint.port, this.endpoint.host, onConnect).once("error", onError);
                break;
            }
          });
        });
      }
    };
    exports.TcpClient = TcpClient;
  }
});

// node_modules/aws-embedded-metrics/lib/sinks/connections/UdpClient.js
var require_UdpClient = __commonJS({
  "node_modules/aws-embedded-metrics/lib/sinks/connections/UdpClient.js"(exports) {
    "use strict";
    var __awaiter = exports && exports.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    var dgram = require("dgram");
    var Logger_1 = require_Logger();
    var UdpClient = class {
      constructor(endpoint) {
        this.endpoint = endpoint;
      }
      warmup() {
        return Promise.resolve();
      }
      sendMessage(message) {
        return __awaiter(this, void 0, void 0, function* () {
          const client = dgram.createSocket("udp4");
          client.send(message, this.endpoint.port, this.endpoint.host, (error) => {
            if (error) {
              Logger_1.LOG(error);
            }
            client.close();
          });
          return Promise.resolve();
        });
      }
    };
    exports.UdpClient = UdpClient;
  }
});

// node_modules/aws-embedded-metrics/lib/sinks/AgentSink.js
var require_AgentSink = __commonJS({
  "node_modules/aws-embedded-metrics/lib/sinks/AgentSink.js"(exports) {
    "use strict";
    var __awaiter = exports && exports.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    var url = require("url");
    var Configuration_1 = require_Configuration();
    var LogSerializer_1 = require_LogSerializer();
    var Logger_1 = require_Logger();
    var TcpClient_1 = require_TcpClient();
    var UdpClient_1 = require_UdpClient();
    var TCP = "tcp:";
    var UDP = "udp:";
    var defaultTcpEndpoint = {
      host: "0.0.0.0",
      port: 25888,
      protocol: TCP
    };
    var parseEndpoint = (endpoint) => {
      try {
        if (!endpoint) {
          return defaultTcpEndpoint;
        }
        const parsedUrl = url.parse(endpoint);
        if (!parsedUrl.hostname || !parsedUrl.port || !parsedUrl.protocol) {
          Logger_1.LOG(`Failed to parse the provided agent endpoint. Falling back to the default TCP endpoint.`, parsedUrl);
          return defaultTcpEndpoint;
        }
        if (parsedUrl.protocol !== TCP && parsedUrl.protocol !== UDP) {
          Logger_1.LOG(`The provided agent endpoint protocol '${parsedUrl.protocol}' is not supported. Please use TCP or UDP. Falling back to the default TCP endpoint.`, parsedUrl);
          return defaultTcpEndpoint;
        }
        return {
          host: parsedUrl.hostname,
          port: Number(parsedUrl.port),
          protocol: parsedUrl.protocol
        };
      } catch (e) {
        Logger_1.LOG("Failed to parse the provided agent endpoint", e);
        return defaultTcpEndpoint;
      }
    };
    var AgentSink = class {
      constructor(logGroupName, logStreamName, serializer) {
        this.name = "AgentSink";
        this.logGroupName = logGroupName;
        this.logStreamName = logStreamName;
        this.serializer = serializer || new LogSerializer_1.LogSerializer();
        this.endpoint = parseEndpoint(Configuration_1.default.agentEndpoint);
        this.socketClient = this.getSocketClient(this.endpoint);
        Logger_1.LOG("Using socket client", this.socketClient.constructor.name);
      }
      accept(context) {
        return __awaiter(this, void 0, void 0, function* () {
          if (this.logGroupName) {
            context.meta.LogGroupName = this.logGroupName;
          }
          if (this.logStreamName) {
            context.meta.LogStreamName = this.logStreamName;
          }
          const events = this.serializer.serialize(context);
          Logger_1.LOG(`Sending {} events to socket.`, events.length);
          for (let index = 0; index < events.length; index++) {
            const event = events[index];
            const message = event + "\n";
            const bytes = Buffer.from(message);
            yield this.socketClient.sendMessage(bytes);
          }
        });
      }
      getSocketClient(endpoint) {
        Logger_1.LOG("Getting socket client for connection.", endpoint);
        const client = endpoint.protocol === TCP ? new TcpClient_1.TcpClient(endpoint) : new UdpClient_1.UdpClient(endpoint);
        client.warmup();
        return client;
      }
    };
    exports.AgentSink = AgentSink;
  }
});

// node_modules/aws-embedded-metrics/lib/environment/DefaultEnvironment.js
var require_DefaultEnvironment = __commonJS({
  "node_modules/aws-embedded-metrics/lib/environment/DefaultEnvironment.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Configuration_1 = require_Configuration();
    var AgentSink_1 = require_AgentSink();
    var Logger_1 = require_Logger();
    var DefaultEnvironment = class {
      probe() {
        return Promise.resolve(true);
      }
      getName() {
        if (!Configuration_1.default.serviceName) {
          Logger_1.LOG("Unknown ServiceName.");
          return "Unknown";
        }
        return Configuration_1.default.serviceName;
      }
      getType() {
        if (!Configuration_1.default.serviceType) {
          Logger_1.LOG("Unknown ServiceType.");
          return "Unknown";
        }
        return Configuration_1.default.serviceType;
      }
      getLogGroupName() {
        if (Configuration_1.default.logGroupName === "") {
          return "";
        }
        return Configuration_1.default.logGroupName ? Configuration_1.default.logGroupName : `${this.getName()}-metrics`;
      }
      configureContext() {
      }
      getSink() {
        if (!this.sink) {
          this.sink = new AgentSink_1.AgentSink(this.getLogGroupName(), Configuration_1.default.logStreamName);
        }
        return this.sink;
      }
    };
    exports.DefaultEnvironment = DefaultEnvironment;
  }
});

// node_modules/aws-embedded-metrics/lib/utils/Fetch.js
var require_Fetch = __commonJS({
  "node_modules/aws-embedded-metrics/lib/utils/Fetch.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var http = require("http");
    var SOCKET_TIMEOUT = 1e3;
    var fetch = (url) => {
      return new Promise((resolve, reject) => {
        const request = http.get(url, { timeout: 2e3 }, (response) => {
          if (!response.statusCode) {
            reject(`Received undefined response status code from '${url}'`);
            return;
          }
          if (response.statusCode < 200 || response.statusCode > 299) {
            reject(new Error("Failed to load page, status code: " + response.statusCode));
            return;
          }
          const body = [];
          let bodyBytes = 0;
          response.on("data", (chunk) => {
            bodyBytes += chunk.length;
            body.push(chunk);
          });
          response.on("end", () => {
            let responseString;
            try {
              const buffer = Buffer.concat(body, bodyBytes);
              responseString = buffer.toString();
              const parsedJson = JSON.parse(responseString);
              resolve(parsedJson);
            } catch (e) {
              reject(`Failed to parse response from '${url}' as JSON. Received: ${responseString}`);
            }
          });
        }).on("error", (err) => {
          reject(err);
        });
        request.on("socket", (socket) => {
          socket.on("timeout", () => {
            request.abort();
            reject(`Socket timeout while connecting to '${url}'`);
          });
          socket.setTimeout(SOCKET_TIMEOUT);
        });
      });
    };
    exports.fetch = fetch;
  }
});

// node_modules/aws-embedded-metrics/lib/environment/ECSEnvironment.js
var require_ECSEnvironment = __commonJS({
  "node_modules/aws-embedded-metrics/lib/environment/ECSEnvironment.js"(exports) {
    "use strict";
    var __awaiter = exports && exports.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    var Configuration_1 = require_Configuration();
    var AgentSink_1 = require_AgentSink();
    var Fetch_1 = require_Fetch();
    var Logger_1 = require_Logger();
    var os2 = require("os");
    var Constants_1 = require_Constants();
    var formatImageName = (imageName) => {
      if (imageName) {
        const splitImageName = imageName.split("/");
        return splitImageName[splitImageName.length - 1];
      }
      return imageName;
    };
    var ECSEnvironment = class {
      probe() {
        return __awaiter(this, void 0, void 0, function* () {
          if (!process.env.ECS_CONTAINER_METADATA_URI) {
            return Promise.resolve(false);
          }
          if (process.env.FLUENT_HOST && !Configuration_1.default.agentEndpoint) {
            this.fluentBitEndpoint = `tcp://${process.env.FLUENT_HOST}:${Constants_1.Constants.DEFAULT_AGENT_PORT}`;
            Configuration_1.default.agentEndpoint = this.fluentBitEndpoint;
            Logger_1.LOG(`Using FluentBit configuration. Endpoint: ${this.fluentBitEndpoint}`);
          }
          try {
            this.metadata = yield Fetch_1.fetch(process.env.ECS_CONTAINER_METADATA_URI);
            if (this.metadata) {
              this.metadata.FormattedImageName = formatImageName(this.metadata.Image);
              Logger_1.LOG(`Successfully collected ECS Container metadata.`);
            }
          } catch (e) {
            Logger_1.LOG("Failed to collect ECS Container Metadata.");
            Logger_1.LOG(e);
          }
          return true;
        });
      }
      getName() {
        var _a;
        if (Configuration_1.default.serviceName) {
          return Configuration_1.default.serviceName;
        }
        return ((_a = this.metadata) === null || _a === void 0 ? void 0 : _a.FormattedImageName) ? this.metadata.FormattedImageName : "Unknown";
      }
      getType() {
        return "AWS::ECS::Container";
      }
      getLogGroupName() {
        if (this.fluentBitEndpoint) {
          return "";
        }
        return Configuration_1.default.logGroupName || this.getName();
      }
      configureContext(context) {
        var _a, _b, _c, _d, _e;
        this.addProperty(context, "containerId", os2.hostname());
        this.addProperty(context, "createdAt", (_a = this.metadata) === null || _a === void 0 ? void 0 : _a.CreatedAt);
        this.addProperty(context, "startedAt", (_b = this.metadata) === null || _b === void 0 ? void 0 : _b.StartedAt);
        this.addProperty(context, "image", (_c = this.metadata) === null || _c === void 0 ? void 0 : _c.Image);
        this.addProperty(context, "cluster", (_d = this.metadata) === null || _d === void 0 ? void 0 : _d.Labels["com.amazonaws.ecs.cluster"]);
        this.addProperty(context, "taskArn", (_e = this.metadata) === null || _e === void 0 ? void 0 : _e.Labels["com.amazonaws.ecs.task-arn"]);
        if (this.fluentBitEndpoint) {
          context.setDefaultDimensions({
            ServiceName: Configuration_1.default.serviceName || this.getName(),
            ServiceType: Configuration_1.default.serviceType || this.getType()
          });
        }
      }
      getSink() {
        if (!this.sink) {
          const logGroupName = this.fluentBitEndpoint ? "" : this.getLogGroupName();
          this.sink = new AgentSink_1.AgentSink(logGroupName);
        }
        return this.sink;
      }
      addProperty(context, key, value) {
        if (value) {
          context.setProperty(key, value);
        }
      }
    };
    exports.ECSEnvironment = ECSEnvironment;
  }
});

// node_modules/aws-embedded-metrics/lib/environment/EC2Environment.js
var require_EC2Environment = __commonJS({
  "node_modules/aws-embedded-metrics/lib/environment/EC2Environment.js"(exports) {
    "use strict";
    var __awaiter = exports && exports.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    var Configuration_1 = require_Configuration();
    var AgentSink_1 = require_AgentSink();
    var Fetch_1 = require_Fetch();
    var Logger_1 = require_Logger();
    var endpoint = "http://169.254.169.254/latest/dynamic/instance-identity/document";
    var EC2Environment = class {
      probe() {
        return __awaiter(this, void 0, void 0, function* () {
          try {
            this.metadata = yield Fetch_1.fetch(endpoint);
            if (this.metadata) {
              return true;
            }
            return false;
          } catch (e) {
            Logger_1.LOG(e);
            return false;
          }
        });
      }
      getName() {
        if (!Configuration_1.default.serviceName) {
          Logger_1.LOG("Unknown ServiceName.");
          return "Unknown";
        }
        return Configuration_1.default.serviceName;
      }
      getType() {
        if (this.metadata) {
          return "AWS::EC2::Instance";
        }
        return "Unknown";
      }
      getLogGroupName() {
        return Configuration_1.default.logGroupName ? Configuration_1.default.logGroupName : `${this.getName()}-metrics`;
      }
      configureContext(context) {
        if (this.metadata) {
          context.setProperty("imageId", this.metadata.imageId);
          context.setProperty("instanceId", this.metadata.instanceId);
          context.setProperty("instanceType", this.metadata.instanceType);
          context.setProperty("privateIP", this.metadata.privateIp);
          context.setProperty("availabilityZone", this.metadata.availabilityZone);
        }
      }
      getSink() {
        if (!this.sink) {
          this.sink = new AgentSink_1.AgentSink(this.getLogGroupName(), Configuration_1.default.logStreamName);
        }
        return this.sink;
      }
    };
    exports.EC2Environment = EC2Environment;
  }
});

// node_modules/aws-embedded-metrics/lib/environment/LambdaEnvironment.js
var require_LambdaEnvironment = __commonJS({
  "node_modules/aws-embedded-metrics/lib/environment/LambdaEnvironment.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var ConsoleSink_1 = require_ConsoleSink();
    var LambdaEnvironment = class {
      probe() {
        return Promise.resolve(process.env.AWS_LAMBDA_FUNCTION_NAME ? true : false);
      }
      getName() {
        return process.env.AWS_LAMBDA_FUNCTION_NAME || "Unknown";
      }
      getType() {
        return "AWS::Lambda::Function";
      }
      getLogGroupName() {
        return this.getName();
      }
      configureContext(context) {
        this.addProperty(context, "executionEnvironment", process.env.AWS_EXECUTION_ENV);
        this.addProperty(context, "memorySize", process.env.AWS_LAMBDA_FUNCTION_MEMORY_SIZE);
        this.addProperty(context, "functionVersion", process.env.AWS_LAMBDA_FUNCTION_VERSION);
        this.addProperty(context, "logStreamId", process.env.AWS_LAMBDA_LOG_STREAM_NAME);
        const trace = this.getSampledTrace();
        if (trace) {
          this.addProperty(context, "traceId", trace);
        }
      }
      getSink() {
        if (!this.sink) {
          this.sink = new ConsoleSink_1.ConsoleSink();
        }
        return this.sink;
      }
      addProperty(context, key, value) {
        if (value) {
          context.setProperty(key, value);
        }
      }
      getSampledTrace() {
        if (process.env._X_AMZN_TRACE_ID && process.env._X_AMZN_TRACE_ID.includes("Sampled=1")) {
          return process.env._X_AMZN_TRACE_ID;
        }
      }
    };
    exports.LambdaEnvironment = LambdaEnvironment;
  }
});

// node_modules/aws-embedded-metrics/lib/environment/LocalEnvironment.js
var require_LocalEnvironment = __commonJS({
  "node_modules/aws-embedded-metrics/lib/environment/LocalEnvironment.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Configuration_1 = require_Configuration();
    var Logger_1 = require_Logger();
    var ConsoleSink_1 = require_ConsoleSink();
    var LocalEnvironment = class {
      probe() {
        return Promise.resolve(false);
      }
      getName() {
        if (!Configuration_1.default.serviceName) {
          Logger_1.LOG("Unknown ServiceName.");
          return "Unknown";
        }
        return Configuration_1.default.serviceName;
      }
      getType() {
        if (!Configuration_1.default.serviceType) {
          Logger_1.LOG("Unknown ServiceType.");
          return "Unknown";
        }
        return Configuration_1.default.serviceType;
      }
      getLogGroupName() {
        return Configuration_1.default.logGroupName ? Configuration_1.default.logGroupName : `${this.getName()}-metrics`;
      }
      configureContext() {
      }
      getSink() {
        if (!this.sink) {
          this.sink = new ConsoleSink_1.ConsoleSink();
        }
        return this.sink;
      }
    };
    exports.LocalEnvironment = LocalEnvironment;
  }
});

// node_modules/aws-embedded-metrics/lib/environment/EnvironmentDetector.js
var require_EnvironmentDetector = __commonJS({
  "node_modules/aws-embedded-metrics/lib/environment/EnvironmentDetector.js"(exports) {
    "use strict";
    var __awaiter = exports && exports.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    var Logger_1 = require_Logger();
    var DefaultEnvironment_1 = require_DefaultEnvironment();
    var ECSEnvironment_1 = require_ECSEnvironment();
    var EC2Environment_1 = require_EC2Environment();
    var LambdaEnvironment_1 = require_LambdaEnvironment();
    var Configuration_1 = require_Configuration();
    var Environments_1 = require_Environments();
    var LocalEnvironment_1 = require_LocalEnvironment();
    var lambdaEnvironment = new LambdaEnvironment_1.LambdaEnvironment();
    var ecsEnvironment = new ECSEnvironment_1.ECSEnvironment();
    var ec2Environment = new EC2Environment_1.EC2Environment();
    var defaultEnvironment = new DefaultEnvironment_1.DefaultEnvironment();
    var environments = [lambdaEnvironment, ecsEnvironment, ec2Environment];
    var environment = void 0;
    var getEnvironmentFromOverride = () => {
      switch (Configuration_1.default.environmentOverride) {
        case Environments_1.default.Agent:
          return defaultEnvironment;
        case Environments_1.default.EC2:
          return ec2Environment;
        case Environments_1.default.Lambda:
          return lambdaEnvironment;
        case Environments_1.default.ECS:
          return ecsEnvironment;
        case Environments_1.default.Local:
          return new LocalEnvironment_1.LocalEnvironment();
        case Environments_1.default.Unknown:
        default:
          return void 0;
      }
    };
    var discoverEnvironment = () => __awaiter(void 0, void 0, void 0, function* () {
      Logger_1.LOG(`Discovering environment`);
      for (const envUnderTest of environments) {
        Logger_1.LOG(`Testing: ${envUnderTest.constructor.name}`);
        try {
          if (yield envUnderTest.probe()) {
            return envUnderTest;
          }
        } catch (e) {
          Logger_1.LOG(`Failed probe: ${envUnderTest.constructor.name}`);
        }
      }
      return defaultEnvironment;
    });
    var _resolveEnvironment = () => __awaiter(void 0, void 0, void 0, function* () {
      Logger_1.LOG("Resolving environment");
      if (environment) {
        return environment;
      }
      if (Configuration_1.default.environmentOverride) {
        Logger_1.LOG("Environment override supplied", Configuration_1.default.environmentOverride);
        environment = getEnvironmentFromOverride();
        if (environment) {
          return environment;
        } else {
          Logger_1.LOG("Invalid environment provided. Falling back to auto-discovery.", Configuration_1.default.environmentOverride);
        }
      }
      environment = yield discoverEnvironment();
      return environment;
    });
    var environmentPromise = _resolveEnvironment();
    var resolveEnvironment = () => __awaiter(void 0, void 0, void 0, function* () {
      return environmentPromise;
    });
    exports.resolveEnvironment = resolveEnvironment;
    var cleanResolveEnvironment = () => __awaiter(void 0, void 0, void 0, function* () {
      yield environmentPromise;
      environment = void 0;
      return yield _resolveEnvironment();
    });
    exports.cleanResolveEnvironment = cleanResolveEnvironment;
  }
});

// node_modules/aws-embedded-metrics/lib/logger/MetricsLoggerFactory.js
var require_MetricsLoggerFactory = __commonJS({
  "node_modules/aws-embedded-metrics/lib/logger/MetricsLoggerFactory.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var __1 = require_lib();
    var EnvironmentDetector_1 = require_EnvironmentDetector();
    var MetricsContext_1 = require_MetricsContext();
    var createMetricsLogger = () => {
      const context = MetricsContext_1.MetricsContext.empty();
      const logger = new __1.MetricsLogger(EnvironmentDetector_1.resolveEnvironment, context);
      return logger;
    };
    exports.createMetricsLogger = createMetricsLogger;
  }
});

// node_modules/aws-embedded-metrics/lib/logger/MetricScope.js
var require_MetricScope = __commonJS({
  "node_modules/aws-embedded-metrics/lib/logger/MetricScope.js"(exports) {
    "use strict";
    var __awaiter = exports && exports.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    var Logger_1 = require_Logger();
    var MetricsLoggerFactory_1 = require_MetricsLoggerFactory();
    var metricScope2 = (handler2) => {
      const wrappedHandler = (...args) => __awaiter(void 0, void 0, void 0, function* () {
        const metrics = MetricsLoggerFactory_1.createMetricsLogger();
        try {
          return yield handler2(metrics)(...args);
        } finally {
          try {
            yield metrics.flush();
          } catch (e) {
            Logger_1.LOG("Failed to flush metrics", e);
          }
        }
      });
      return wrappedHandler;
    };
    exports.metricScope = metricScope2;
  }
});

// node_modules/aws-embedded-metrics/lib/logger/Unit.js
var require_Unit = __commonJS({
  "node_modules/aws-embedded-metrics/lib/logger/Unit.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var Unit2;
    (function(Unit3) {
      Unit3["Seconds"] = "Seconds";
      Unit3["Microseconds"] = "Microseconds";
      Unit3["Milliseconds"] = "Milliseconds";
      Unit3["Bytes"] = "Bytes";
      Unit3["Kilobytes"] = "Kilobytes";
      Unit3["Megabytes"] = "Megabytes";
      Unit3["Gigabytes"] = "Gigabytes";
      Unit3["Terabytes"] = "Terabytes";
      Unit3["Bits"] = "Bits";
      Unit3["Kilobits"] = "Kilobits";
      Unit3["Megabits"] = "Megabits";
      Unit3["Gigabits"] = "Gigabits";
      Unit3["Terabits"] = "Terabits";
      Unit3["Percent"] = "Percent";
      Unit3["Count"] = "Count";
      Unit3["BytesPerSecond"] = "Bytes/Second";
      Unit3["KilobytesPerSecond"] = "Kilobytes/Second";
      Unit3["MegabytesPerSecond"] = "Megabytes/Second";
      Unit3["GigabytesPerSecond"] = "Gigabytes/Second";
      Unit3["TerabytesPerSecond"] = "Terabytes/Second";
      Unit3["BitsPerSecond"] = "Bits/Second";
      Unit3["KilobitsPerSecond"] = "Kilobits/Second";
      Unit3["MegabitsPerSecond"] = "Megabits/Second";
      Unit3["GigabitsPerSecond"] = "Gigabits/Second";
      Unit3["TerabitsPerSecond"] = "Terabits/Second";
      Unit3["CountPerSecond"] = "Count/Second";
      Unit3["None"] = "None";
    })(Unit2 = exports.Unit || (exports.Unit = {}));
  }
});

// node_modules/aws-embedded-metrics/lib/index.js
var require_lib = __commonJS({
  "node_modules/aws-embedded-metrics/lib/index.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var MetricsLogger_1 = require_MetricsLogger();
    exports.MetricsLogger = MetricsLogger_1.MetricsLogger;
    var ConsoleSink_1 = require_ConsoleSink();
    exports.LocalSink = ConsoleSink_1.ConsoleSink;
    var AgentSink_1 = require_AgentSink();
    exports.AgentSink = AgentSink_1.AgentSink;
    var MetricScope_1 = require_MetricScope();
    exports.metricScope = MetricScope_1.metricScope;
    var MetricsLoggerFactory_1 = require_MetricsLoggerFactory();
    exports.createMetricsLogger = MetricsLoggerFactory_1.createMetricsLogger;
    var Unit_1 = require_Unit();
    exports.Unit = Unit_1.Unit;
    var Configuration_1 = require_Configuration();
    exports.Configuration = Configuration_1.default;
  }
});

// node_modules/fs-extra/node_modules/universalify/index.js
var require_universalify = __commonJS({
  "node_modules/fs-extra/node_modules/universalify/index.js"(exports) {
    "use strict";
    exports.fromCallback = function(fn) {
      return Object.defineProperty(function(...args) {
        if (typeof args[args.length - 1] === "function")
          fn.apply(this, args);
        else {
          return new Promise((resolve, reject) => {
            fn.call(this, ...args, (err, res) => err != null ? reject(err) : resolve(res));
          });
        }
      }, "name", { value: fn.name });
    };
    exports.fromPromise = function(fn) {
      return Object.defineProperty(function(...args) {
        const cb = args[args.length - 1];
        if (typeof cb !== "function")
          return fn.apply(this, args);
        else
          fn.apply(this, args.slice(0, -1)).then((r) => cb(null, r), cb);
      }, "name", { value: fn.name });
    };
  }
});

// node_modules/graceful-fs/polyfills.js
var require_polyfills = __commonJS({
  "node_modules/graceful-fs/polyfills.js"(exports, module2) {
    var constants2 = require("constants");
    var origCwd = process.cwd;
    var cwd = null;
    var platform = process.env.GRACEFUL_FS_PLATFORM || process.platform;
    process.cwd = function() {
      if (!cwd)
        cwd = origCwd.call(process);
      return cwd;
    };
    try {
      process.cwd();
    } catch (er) {
    }
    if (typeof process.chdir === "function") {
      chdir = process.chdir;
      process.chdir = function(d) {
        cwd = null;
        chdir.call(process, d);
      };
      if (Object.setPrototypeOf)
        Object.setPrototypeOf(process.chdir, chdir);
    }
    var chdir;
    module2.exports = patch;
    function patch(fs2) {
      if (constants2.hasOwnProperty("O_SYMLINK") && process.version.match(/^v0\.6\.[0-2]|^v0\.5\./)) {
        patchLchmod(fs2);
      }
      if (!fs2.lutimes) {
        patchLutimes(fs2);
      }
      fs2.chown = chownFix(fs2.chown);
      fs2.fchown = chownFix(fs2.fchown);
      fs2.lchown = chownFix(fs2.lchown);
      fs2.chmod = chmodFix(fs2.chmod);
      fs2.fchmod = chmodFix(fs2.fchmod);
      fs2.lchmod = chmodFix(fs2.lchmod);
      fs2.chownSync = chownFixSync(fs2.chownSync);
      fs2.fchownSync = chownFixSync(fs2.fchownSync);
      fs2.lchownSync = chownFixSync(fs2.lchownSync);
      fs2.chmodSync = chmodFixSync(fs2.chmodSync);
      fs2.fchmodSync = chmodFixSync(fs2.fchmodSync);
      fs2.lchmodSync = chmodFixSync(fs2.lchmodSync);
      fs2.stat = statFix(fs2.stat);
      fs2.fstat = statFix(fs2.fstat);
      fs2.lstat = statFix(fs2.lstat);
      fs2.statSync = statFixSync(fs2.statSync);
      fs2.fstatSync = statFixSync(fs2.fstatSync);
      fs2.lstatSync = statFixSync(fs2.lstatSync);
      if (!fs2.lchmod) {
        fs2.lchmod = function(path2, mode, cb) {
          if (cb)
            process.nextTick(cb);
        };
        fs2.lchmodSync = function() {
        };
      }
      if (!fs2.lchown) {
        fs2.lchown = function(path2, uid, gid, cb) {
          if (cb)
            process.nextTick(cb);
        };
        fs2.lchownSync = function() {
        };
      }
      if (platform === "win32") {
        fs2.rename = function(fs$rename) {
          return function(from, to, cb) {
            var start = Date.now();
            var backoff = 0;
            fs$rename(from, to, function CB(er) {
              if (er && (er.code === "EACCES" || er.code === "EPERM") && Date.now() - start < 6e4) {
                setTimeout(function() {
                  fs2.stat(to, function(stater, st) {
                    if (stater && stater.code === "ENOENT")
                      fs$rename(from, to, CB);
                    else
                      cb(er);
                  });
                }, backoff);
                if (backoff < 100)
                  backoff += 10;
                return;
              }
              if (cb)
                cb(er);
            });
          };
        }(fs2.rename);
      }
      fs2.read = function(fs$read) {
        function read(fd, buffer, offset, length, position, callback_) {
          var callback;
          if (callback_ && typeof callback_ === "function") {
            var eagCounter = 0;
            callback = function(er, _, __) {
              if (er && er.code === "EAGAIN" && eagCounter < 10) {
                eagCounter++;
                return fs$read.call(fs2, fd, buffer, offset, length, position, callback);
              }
              callback_.apply(this, arguments);
            };
          }
          return fs$read.call(fs2, fd, buffer, offset, length, position, callback);
        }
        if (Object.setPrototypeOf)
          Object.setPrototypeOf(read, fs$read);
        return read;
      }(fs2.read);
      fs2.readSync = function(fs$readSync) {
        return function(fd, buffer, offset, length, position) {
          var eagCounter = 0;
          while (true) {
            try {
              return fs$readSync.call(fs2, fd, buffer, offset, length, position);
            } catch (er) {
              if (er.code === "EAGAIN" && eagCounter < 10) {
                eagCounter++;
                continue;
              }
              throw er;
            }
          }
        };
      }(fs2.readSync);
      function patchLchmod(fs3) {
        fs3.lchmod = function(path2, mode, callback) {
          fs3.open(path2, constants2.O_WRONLY | constants2.O_SYMLINK, mode, function(err, fd) {
            if (err) {
              if (callback)
                callback(err);
              return;
            }
            fs3.fchmod(fd, mode, function(err2) {
              fs3.close(fd, function(err22) {
                if (callback)
                  callback(err2 || err22);
              });
            });
          });
        };
        fs3.lchmodSync = function(path2, mode) {
          var fd = fs3.openSync(path2, constants2.O_WRONLY | constants2.O_SYMLINK, mode);
          var threw = true;
          var ret;
          try {
            ret = fs3.fchmodSync(fd, mode);
            threw = false;
          } finally {
            if (threw) {
              try {
                fs3.closeSync(fd);
              } catch (er) {
              }
            } else {
              fs3.closeSync(fd);
            }
          }
          return ret;
        };
      }
      function patchLutimes(fs3) {
        if (constants2.hasOwnProperty("O_SYMLINK")) {
          fs3.lutimes = function(path2, at, mt, cb) {
            fs3.open(path2, constants2.O_SYMLINK, function(er, fd) {
              if (er) {
                if (cb)
                  cb(er);
                return;
              }
              fs3.futimes(fd, at, mt, function(er2) {
                fs3.close(fd, function(er22) {
                  if (cb)
                    cb(er2 || er22);
                });
              });
            });
          };
          fs3.lutimesSync = function(path2, at, mt) {
            var fd = fs3.openSync(path2, constants2.O_SYMLINK);
            var ret;
            var threw = true;
            try {
              ret = fs3.futimesSync(fd, at, mt);
              threw = false;
            } finally {
              if (threw) {
                try {
                  fs3.closeSync(fd);
                } catch (er) {
                }
              } else {
                fs3.closeSync(fd);
              }
            }
            return ret;
          };
        } else {
          fs3.lutimes = function(_a, _b, _c, cb) {
            if (cb)
              process.nextTick(cb);
          };
          fs3.lutimesSync = function() {
          };
        }
      }
      function chmodFix(orig) {
        if (!orig)
          return orig;
        return function(target, mode, cb) {
          return orig.call(fs2, target, mode, function(er) {
            if (chownErOk(er))
              er = null;
            if (cb)
              cb.apply(this, arguments);
          });
        };
      }
      function chmodFixSync(orig) {
        if (!orig)
          return orig;
        return function(target, mode) {
          try {
            return orig.call(fs2, target, mode);
          } catch (er) {
            if (!chownErOk(er))
              throw er;
          }
        };
      }
      function chownFix(orig) {
        if (!orig)
          return orig;
        return function(target, uid, gid, cb) {
          return orig.call(fs2, target, uid, gid, function(er) {
            if (chownErOk(er))
              er = null;
            if (cb)
              cb.apply(this, arguments);
          });
        };
      }
      function chownFixSync(orig) {
        if (!orig)
          return orig;
        return function(target, uid, gid) {
          try {
            return orig.call(fs2, target, uid, gid);
          } catch (er) {
            if (!chownErOk(er))
              throw er;
          }
        };
      }
      function statFix(orig) {
        if (!orig)
          return orig;
        return function(target, options, cb) {
          if (typeof options === "function") {
            cb = options;
            options = null;
          }
          function callback(er, stats) {
            if (stats) {
              if (stats.uid < 0)
                stats.uid += 4294967296;
              if (stats.gid < 0)
                stats.gid += 4294967296;
            }
            if (cb)
              cb.apply(this, arguments);
          }
          return options ? orig.call(fs2, target, options, callback) : orig.call(fs2, target, callback);
        };
      }
      function statFixSync(orig) {
        if (!orig)
          return orig;
        return function(target, options) {
          var stats = options ? orig.call(fs2, target, options) : orig.call(fs2, target);
          if (stats.uid < 0)
            stats.uid += 4294967296;
          if (stats.gid < 0)
            stats.gid += 4294967296;
          return stats;
        };
      }
      function chownErOk(er) {
        if (!er)
          return true;
        if (er.code === "ENOSYS")
          return true;
        var nonroot = !process.getuid || process.getuid() !== 0;
        if (nonroot) {
          if (er.code === "EINVAL" || er.code === "EPERM")
            return true;
        }
        return false;
      }
    }
  }
});

// node_modules/graceful-fs/legacy-streams.js
var require_legacy_streams = __commonJS({
  "node_modules/graceful-fs/legacy-streams.js"(exports, module2) {
    var Stream = require("stream").Stream;
    module2.exports = legacy;
    function legacy(fs2) {
      return {
        ReadStream,
        WriteStream
      };
      function ReadStream(path2, options) {
        if (!(this instanceof ReadStream))
          return new ReadStream(path2, options);
        Stream.call(this);
        var self2 = this;
        this.path = path2;
        this.fd = null;
        this.readable = true;
        this.paused = false;
        this.flags = "r";
        this.mode = 438;
        this.bufferSize = 64 * 1024;
        options = options || {};
        var keys = Object.keys(options);
        for (var index = 0, length = keys.length; index < length; index++) {
          var key = keys[index];
          this[key] = options[key];
        }
        if (this.encoding)
          this.setEncoding(this.encoding);
        if (this.start !== void 0) {
          if (typeof this.start !== "number") {
            throw TypeError("start must be a Number");
          }
          if (this.end === void 0) {
            this.end = Infinity;
          } else if (typeof this.end !== "number") {
            throw TypeError("end must be a Number");
          }
          if (this.start > this.end) {
            throw new Error("start must be <= end");
          }
          this.pos = this.start;
        }
        if (this.fd !== null) {
          process.nextTick(function() {
            self2._read();
          });
          return;
        }
        fs2.open(this.path, this.flags, this.mode, function(err, fd) {
          if (err) {
            self2.emit("error", err);
            self2.readable = false;
            return;
          }
          self2.fd = fd;
          self2.emit("open", fd);
          self2._read();
        });
      }
      function WriteStream(path2, options) {
        if (!(this instanceof WriteStream))
          return new WriteStream(path2, options);
        Stream.call(this);
        this.path = path2;
        this.fd = null;
        this.writable = true;
        this.flags = "w";
        this.encoding = "binary";
        this.mode = 438;
        this.bytesWritten = 0;
        options = options || {};
        var keys = Object.keys(options);
        for (var index = 0, length = keys.length; index < length; index++) {
          var key = keys[index];
          this[key] = options[key];
        }
        if (this.start !== void 0) {
          if (typeof this.start !== "number") {
            throw TypeError("start must be a Number");
          }
          if (this.start < 0) {
            throw new Error("start must be >= zero");
          }
          this.pos = this.start;
        }
        this.busy = false;
        this._queue = [];
        if (this.fd === null) {
          this._open = fs2.open;
          this._queue.push([this._open, this.path, this.flags, this.mode, void 0]);
          this.flush();
        }
      }
    }
  }
});

// node_modules/graceful-fs/clone.js
var require_clone = __commonJS({
  "node_modules/graceful-fs/clone.js"(exports, module2) {
    "use strict";
    module2.exports = clone;
    var getPrototypeOf = Object.getPrototypeOf || function(obj) {
      return obj.__proto__;
    };
    function clone(obj) {
      if (obj === null || typeof obj !== "object")
        return obj;
      if (obj instanceof Object)
        var copy = { __proto__: getPrototypeOf(obj) };
      else
        var copy = Object.create(null);
      Object.getOwnPropertyNames(obj).forEach(function(key) {
        Object.defineProperty(copy, key, Object.getOwnPropertyDescriptor(obj, key));
      });
      return copy;
    }
  }
});

// node_modules/graceful-fs/graceful-fs.js
var require_graceful_fs = __commonJS({
  "node_modules/graceful-fs/graceful-fs.js"(exports, module2) {
    var fs2 = require("fs");
    var polyfills = require_polyfills();
    var legacy = require_legacy_streams();
    var clone = require_clone();
    var util = require("util");
    var gracefulQueue;
    var previousSymbol;
    if (typeof Symbol === "function" && typeof Symbol.for === "function") {
      gracefulQueue = Symbol.for("graceful-fs.queue");
      previousSymbol = Symbol.for("graceful-fs.previous");
    } else {
      gracefulQueue = "___graceful-fs.queue";
      previousSymbol = "___graceful-fs.previous";
    }
    function noop() {
    }
    function publishQueue(context, queue2) {
      Object.defineProperty(context, gracefulQueue, {
        get: function() {
          return queue2;
        }
      });
    }
    var debug = noop;
    if (util.debuglog)
      debug = util.debuglog("gfs4");
    else if (/\bgfs4\b/i.test(process.env.NODE_DEBUG || ""))
      debug = function() {
        var m = util.format.apply(util, arguments);
        m = "GFS4: " + m.split(/\n/).join("\nGFS4: ");
        console.error(m);
      };
    if (!fs2[gracefulQueue]) {
      queue = global[gracefulQueue] || [];
      publishQueue(fs2, queue);
      fs2.close = function(fs$close) {
        function close(fd, cb) {
          return fs$close.call(fs2, fd, function(err) {
            if (!err) {
              resetQueue();
            }
            if (typeof cb === "function")
              cb.apply(this, arguments);
          });
        }
        Object.defineProperty(close, previousSymbol, {
          value: fs$close
        });
        return close;
      }(fs2.close);
      fs2.closeSync = function(fs$closeSync) {
        function closeSync(fd) {
          fs$closeSync.apply(fs2, arguments);
          resetQueue();
        }
        Object.defineProperty(closeSync, previousSymbol, {
          value: fs$closeSync
        });
        return closeSync;
      }(fs2.closeSync);
      if (/\bgfs4\b/i.test(process.env.NODE_DEBUG || "")) {
        process.on("exit", function() {
          debug(fs2[gracefulQueue]);
          require("assert").equal(fs2[gracefulQueue].length, 0);
        });
      }
    }
    var queue;
    if (!global[gracefulQueue]) {
      publishQueue(global, fs2[gracefulQueue]);
    }
    module2.exports = patch(clone(fs2));
    if (process.env.TEST_GRACEFUL_FS_GLOBAL_PATCH && !fs2.__patched) {
      module2.exports = patch(fs2);
      fs2.__patched = true;
    }
    function patch(fs3) {
      polyfills(fs3);
      fs3.gracefulify = patch;
      fs3.createReadStream = createReadStream;
      fs3.createWriteStream = createWriteStream;
      var fs$readFile = fs3.readFile;
      fs3.readFile = readFile;
      function readFile(path2, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        return go$readFile(path2, options, cb);
        function go$readFile(path3, options2, cb2, startTime) {
          return fs$readFile(path3, options2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$readFile, [path3, options2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      var fs$writeFile = fs3.writeFile;
      fs3.writeFile = writeFile;
      function writeFile(path2, data, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        return go$writeFile(path2, data, options, cb);
        function go$writeFile(path3, data2, options2, cb2, startTime) {
          return fs$writeFile(path3, data2, options2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$writeFile, [path3, data2, options2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      var fs$appendFile = fs3.appendFile;
      if (fs$appendFile)
        fs3.appendFile = appendFile;
      function appendFile(path2, data, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        return go$appendFile(path2, data, options, cb);
        function go$appendFile(path3, data2, options2, cb2, startTime) {
          return fs$appendFile(path3, data2, options2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$appendFile, [path3, data2, options2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      var fs$copyFile = fs3.copyFile;
      if (fs$copyFile)
        fs3.copyFile = copyFile;
      function copyFile(src, dest, flags, cb) {
        if (typeof flags === "function") {
          cb = flags;
          flags = 0;
        }
        return go$copyFile(src, dest, flags, cb);
        function go$copyFile(src2, dest2, flags2, cb2, startTime) {
          return fs$copyFile(src2, dest2, flags2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$copyFile, [src2, dest2, flags2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      var fs$readdir = fs3.readdir;
      fs3.readdir = readdir;
      function readdir(path2, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        return go$readdir(path2, options, cb);
        function go$readdir(path3, options2, cb2, startTime) {
          return fs$readdir(path3, options2, function(err, files) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$readdir, [path3, options2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (files && files.sort)
                files.sort();
              if (typeof cb2 === "function")
                cb2.call(this, err, files);
            }
          });
        }
      }
      if (process.version.substr(0, 4) === "v0.8") {
        var legStreams = legacy(fs3);
        ReadStream = legStreams.ReadStream;
        WriteStream = legStreams.WriteStream;
      }
      var fs$ReadStream = fs3.ReadStream;
      if (fs$ReadStream) {
        ReadStream.prototype = Object.create(fs$ReadStream.prototype);
        ReadStream.prototype.open = ReadStream$open;
      }
      var fs$WriteStream = fs3.WriteStream;
      if (fs$WriteStream) {
        WriteStream.prototype = Object.create(fs$WriteStream.prototype);
        WriteStream.prototype.open = WriteStream$open;
      }
      Object.defineProperty(fs3, "ReadStream", {
        get: function() {
          return ReadStream;
        },
        set: function(val) {
          ReadStream = val;
        },
        enumerable: true,
        configurable: true
      });
      Object.defineProperty(fs3, "WriteStream", {
        get: function() {
          return WriteStream;
        },
        set: function(val) {
          WriteStream = val;
        },
        enumerable: true,
        configurable: true
      });
      var FileReadStream = ReadStream;
      Object.defineProperty(fs3, "FileReadStream", {
        get: function() {
          return FileReadStream;
        },
        set: function(val) {
          FileReadStream = val;
        },
        enumerable: true,
        configurable: true
      });
      var FileWriteStream = WriteStream;
      Object.defineProperty(fs3, "FileWriteStream", {
        get: function() {
          return FileWriteStream;
        },
        set: function(val) {
          FileWriteStream = val;
        },
        enumerable: true,
        configurable: true
      });
      function ReadStream(path2, options) {
        if (this instanceof ReadStream)
          return fs$ReadStream.apply(this, arguments), this;
        else
          return ReadStream.apply(Object.create(ReadStream.prototype), arguments);
      }
      function ReadStream$open() {
        var that = this;
        open(that.path, that.flags, that.mode, function(err, fd) {
          if (err) {
            if (that.autoClose)
              that.destroy();
            that.emit("error", err);
          } else {
            that.fd = fd;
            that.emit("open", fd);
            that.read();
          }
        });
      }
      function WriteStream(path2, options) {
        if (this instanceof WriteStream)
          return fs$WriteStream.apply(this, arguments), this;
        else
          return WriteStream.apply(Object.create(WriteStream.prototype), arguments);
      }
      function WriteStream$open() {
        var that = this;
        open(that.path, that.flags, that.mode, function(err, fd) {
          if (err) {
            that.destroy();
            that.emit("error", err);
          } else {
            that.fd = fd;
            that.emit("open", fd);
          }
        });
      }
      function createReadStream(path2, options) {
        return new fs3.ReadStream(path2, options);
      }
      function createWriteStream(path2, options) {
        return new fs3.WriteStream(path2, options);
      }
      var fs$open = fs3.open;
      fs3.open = open;
      function open(path2, flags, mode, cb) {
        if (typeof mode === "function")
          cb = mode, mode = null;
        return go$open(path2, flags, mode, cb);
        function go$open(path3, flags2, mode2, cb2, startTime) {
          return fs$open(path3, flags2, mode2, function(err, fd) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$open, [path3, flags2, mode2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      return fs3;
    }
    function enqueue(elem) {
      debug("ENQUEUE", elem[0].name, elem[1]);
      fs2[gracefulQueue].push(elem);
      retry();
    }
    var retryTimer;
    function resetQueue() {
      var now = Date.now();
      for (var i = 0; i < fs2[gracefulQueue].length; ++i) {
        if (fs2[gracefulQueue][i].length > 2) {
          fs2[gracefulQueue][i][3] = now;
          fs2[gracefulQueue][i][4] = now;
        }
      }
      retry();
    }
    function retry() {
      clearTimeout(retryTimer);
      retryTimer = void 0;
      if (fs2[gracefulQueue].length === 0)
        return;
      var elem = fs2[gracefulQueue].shift();
      var fn = elem[0];
      var args = elem[1];
      var err = elem[2];
      var startTime = elem[3];
      var lastTime = elem[4];
      if (startTime === void 0) {
        debug("RETRY", fn.name, args);
        fn.apply(null, args);
      } else if (Date.now() - startTime >= 6e4) {
        debug("TIMEOUT", fn.name, args);
        var cb = args.pop();
        if (typeof cb === "function")
          cb.call(null, err);
      } else {
        var sinceAttempt = Date.now() - lastTime;
        var sinceStart = Math.max(lastTime - startTime, 1);
        var desiredDelay = Math.min(sinceStart * 1.2, 100);
        if (sinceAttempt >= desiredDelay) {
          debug("RETRY", fn.name, args);
          fn.apply(null, args.concat([startTime]));
        } else {
          fs2[gracefulQueue].push(elem);
        }
      }
      if (retryTimer === void 0) {
        retryTimer = setTimeout(retry, 0);
      }
    }
  }
});

// node_modules/fs-extra/lib/fs/index.js
var require_fs = __commonJS({
  "node_modules/fs-extra/lib/fs/index.js"(exports) {
    "use strict";
    var u = require_universalify().fromCallback;
    var fs2 = require_graceful_fs();
    var api = [
      "access",
      "appendFile",
      "chmod",
      "chown",
      "close",
      "copyFile",
      "fchmod",
      "fchown",
      "fdatasync",
      "fstat",
      "fsync",
      "ftruncate",
      "futimes",
      "lchmod",
      "lchown",
      "link",
      "lstat",
      "mkdir",
      "mkdtemp",
      "open",
      "opendir",
      "readdir",
      "readFile",
      "readlink",
      "realpath",
      "rename",
      "rm",
      "rmdir",
      "stat",
      "symlink",
      "truncate",
      "unlink",
      "utimes",
      "writeFile"
    ].filter((key) => {
      return typeof fs2[key] === "function";
    });
    Object.assign(exports, fs2);
    api.forEach((method) => {
      exports[method] = u(fs2[method]);
    });
    exports.realpath.native = u(fs2.realpath.native);
    exports.exists = function(filename, callback) {
      if (typeof callback === "function") {
        return fs2.exists(filename, callback);
      }
      return new Promise((resolve) => {
        return fs2.exists(filename, resolve);
      });
    };
    exports.read = function(fd, buffer, offset, length, position, callback) {
      if (typeof callback === "function") {
        return fs2.read(fd, buffer, offset, length, position, callback);
      }
      return new Promise((resolve, reject) => {
        fs2.read(fd, buffer, offset, length, position, (err, bytesRead, buffer2) => {
          if (err)
            return reject(err);
          resolve({ bytesRead, buffer: buffer2 });
        });
      });
    };
    exports.write = function(fd, buffer, ...args) {
      if (typeof args[args.length - 1] === "function") {
        return fs2.write(fd, buffer, ...args);
      }
      return new Promise((resolve, reject) => {
        fs2.write(fd, buffer, ...args, (err, bytesWritten, buffer2) => {
          if (err)
            return reject(err);
          resolve({ bytesWritten, buffer: buffer2 });
        });
      });
    };
    if (typeof fs2.writev === "function") {
      exports.writev = function(fd, buffers, ...args) {
        if (typeof args[args.length - 1] === "function") {
          return fs2.writev(fd, buffers, ...args);
        }
        return new Promise((resolve, reject) => {
          fs2.writev(fd, buffers, ...args, (err, bytesWritten, buffers2) => {
            if (err)
              return reject(err);
            resolve({ bytesWritten, buffers: buffers2 });
          });
        });
      };
    }
  }
});

// node_modules/fs-extra/lib/mkdirs/utils.js
var require_utils = __commonJS({
  "node_modules/fs-extra/lib/mkdirs/utils.js"(exports, module2) {
    "use strict";
    var path2 = require("path");
    module2.exports.checkPath = function checkPath(pth) {
      if (process.platform === "win32") {
        const pathHasInvalidWinCharacters = /[<>:"|?*]/.test(pth.replace(path2.parse(pth).root, ""));
        if (pathHasInvalidWinCharacters) {
          const error = new Error(`Path contains invalid characters: ${pth}`);
          error.code = "EINVAL";
          throw error;
        }
      }
    };
  }
});

// node_modules/fs-extra/lib/mkdirs/make-dir.js
var require_make_dir = __commonJS({
  "node_modules/fs-extra/lib/mkdirs/make-dir.js"(exports, module2) {
    "use strict";
    var fs2 = require_fs();
    var { checkPath } = require_utils();
    var getMode = (options) => {
      const defaults = { mode: 511 };
      if (typeof options === "number")
        return options;
      return __spreadValues(__spreadValues({}, defaults), options).mode;
    };
    module2.exports.makeDir = async (dir, options) => {
      checkPath(dir);
      return fs2.mkdir(dir, {
        mode: getMode(options),
        recursive: true
      });
    };
    module2.exports.makeDirSync = (dir, options) => {
      checkPath(dir);
      return fs2.mkdirSync(dir, {
        mode: getMode(options),
        recursive: true
      });
    };
  }
});

// node_modules/fs-extra/lib/mkdirs/index.js
var require_mkdirs = __commonJS({
  "node_modules/fs-extra/lib/mkdirs/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify().fromPromise;
    var { makeDir: _makeDir, makeDirSync } = require_make_dir();
    var makeDir = u(_makeDir);
    module2.exports = {
      mkdirs: makeDir,
      mkdirsSync: makeDirSync,
      mkdirp: makeDir,
      mkdirpSync: makeDirSync,
      ensureDir: makeDir,
      ensureDirSync: makeDirSync
    };
  }
});

// node_modules/fs-extra/lib/util/utimes.js
var require_utimes = __commonJS({
  "node_modules/fs-extra/lib/util/utimes.js"(exports, module2) {
    "use strict";
    var fs2 = require_graceful_fs();
    function utimesMillis(path2, atime, mtime, callback) {
      fs2.open(path2, "r+", (err, fd) => {
        if (err)
          return callback(err);
        fs2.futimes(fd, atime, mtime, (futimesErr) => {
          fs2.close(fd, (closeErr) => {
            if (callback)
              callback(futimesErr || closeErr);
          });
        });
      });
    }
    function utimesMillisSync(path2, atime, mtime) {
      const fd = fs2.openSync(path2, "r+");
      fs2.futimesSync(fd, atime, mtime);
      return fs2.closeSync(fd);
    }
    module2.exports = {
      utimesMillis,
      utimesMillisSync
    };
  }
});

// node_modules/fs-extra/lib/util/stat.js
var require_stat = __commonJS({
  "node_modules/fs-extra/lib/util/stat.js"(exports, module2) {
    "use strict";
    var fs2 = require_fs();
    var path2 = require("path");
    var util = require("util");
    function getStats(src, dest, opts) {
      const statFunc = opts.dereference ? (file) => fs2.stat(file, { bigint: true }) : (file) => fs2.lstat(file, { bigint: true });
      return Promise.all([
        statFunc(src),
        statFunc(dest).catch((err) => {
          if (err.code === "ENOENT")
            return null;
          throw err;
        })
      ]).then(([srcStat, destStat]) => ({ srcStat, destStat }));
    }
    function getStatsSync(src, dest, opts) {
      let destStat;
      const statFunc = opts.dereference ? (file) => fs2.statSync(file, { bigint: true }) : (file) => fs2.lstatSync(file, { bigint: true });
      const srcStat = statFunc(src);
      try {
        destStat = statFunc(dest);
      } catch (err) {
        if (err.code === "ENOENT")
          return { srcStat, destStat: null };
        throw err;
      }
      return { srcStat, destStat };
    }
    function checkPaths(src, dest, funcName, opts, cb) {
      util.callbackify(getStats)(src, dest, opts, (err, stats) => {
        if (err)
          return cb(err);
        const { srcStat, destStat } = stats;
        if (destStat) {
          if (areIdentical(srcStat, destStat)) {
            const srcBaseName = path2.basename(src);
            const destBaseName = path2.basename(dest);
            if (funcName === "move" && srcBaseName !== destBaseName && srcBaseName.toLowerCase() === destBaseName.toLowerCase()) {
              return cb(null, { srcStat, destStat, isChangingCase: true });
            }
            return cb(new Error("Source and destination must not be the same."));
          }
          if (srcStat.isDirectory() && !destStat.isDirectory()) {
            return cb(new Error(`Cannot overwrite non-directory '${dest}' with directory '${src}'.`));
          }
          if (!srcStat.isDirectory() && destStat.isDirectory()) {
            return cb(new Error(`Cannot overwrite directory '${dest}' with non-directory '${src}'.`));
          }
        }
        if (srcStat.isDirectory() && isSrcSubdir(src, dest)) {
          return cb(new Error(errMsg(src, dest, funcName)));
        }
        return cb(null, { srcStat, destStat });
      });
    }
    function checkPathsSync(src, dest, funcName, opts) {
      const { srcStat, destStat } = getStatsSync(src, dest, opts);
      if (destStat) {
        if (areIdentical(srcStat, destStat)) {
          const srcBaseName = path2.basename(src);
          const destBaseName = path2.basename(dest);
          if (funcName === "move" && srcBaseName !== destBaseName && srcBaseName.toLowerCase() === destBaseName.toLowerCase()) {
            return { srcStat, destStat, isChangingCase: true };
          }
          throw new Error("Source and destination must not be the same.");
        }
        if (srcStat.isDirectory() && !destStat.isDirectory()) {
          throw new Error(`Cannot overwrite non-directory '${dest}' with directory '${src}'.`);
        }
        if (!srcStat.isDirectory() && destStat.isDirectory()) {
          throw new Error(`Cannot overwrite directory '${dest}' with non-directory '${src}'.`);
        }
      }
      if (srcStat.isDirectory() && isSrcSubdir(src, dest)) {
        throw new Error(errMsg(src, dest, funcName));
      }
      return { srcStat, destStat };
    }
    function checkParentPaths(src, srcStat, dest, funcName, cb) {
      const srcParent = path2.resolve(path2.dirname(src));
      const destParent = path2.resolve(path2.dirname(dest));
      if (destParent === srcParent || destParent === path2.parse(destParent).root)
        return cb();
      fs2.stat(destParent, { bigint: true }, (err, destStat) => {
        if (err) {
          if (err.code === "ENOENT")
            return cb();
          return cb(err);
        }
        if (areIdentical(srcStat, destStat)) {
          return cb(new Error(errMsg(src, dest, funcName)));
        }
        return checkParentPaths(src, srcStat, destParent, funcName, cb);
      });
    }
    function checkParentPathsSync(src, srcStat, dest, funcName) {
      const srcParent = path2.resolve(path2.dirname(src));
      const destParent = path2.resolve(path2.dirname(dest));
      if (destParent === srcParent || destParent === path2.parse(destParent).root)
        return;
      let destStat;
      try {
        destStat = fs2.statSync(destParent, { bigint: true });
      } catch (err) {
        if (err.code === "ENOENT")
          return;
        throw err;
      }
      if (areIdentical(srcStat, destStat)) {
        throw new Error(errMsg(src, dest, funcName));
      }
      return checkParentPathsSync(src, srcStat, destParent, funcName);
    }
    function areIdentical(srcStat, destStat) {
      return destStat.ino && destStat.dev && destStat.ino === srcStat.ino && destStat.dev === srcStat.dev;
    }
    function isSrcSubdir(src, dest) {
      const srcArr = path2.resolve(src).split(path2.sep).filter((i) => i);
      const destArr = path2.resolve(dest).split(path2.sep).filter((i) => i);
      return srcArr.reduce((acc, cur, i) => acc && destArr[i] === cur, true);
    }
    function errMsg(src, dest, funcName) {
      return `Cannot ${funcName} '${src}' to a subdirectory of itself, '${dest}'.`;
    }
    module2.exports = {
      checkPaths,
      checkPathsSync,
      checkParentPaths,
      checkParentPathsSync,
      isSrcSubdir,
      areIdentical
    };
  }
});

// node_modules/fs-extra/lib/copy-sync/copy-sync.js
var require_copy_sync = __commonJS({
  "node_modules/fs-extra/lib/copy-sync/copy-sync.js"(exports, module2) {
    "use strict";
    var fs2 = require_graceful_fs();
    var path2 = require("path");
    var mkdirsSync = require_mkdirs().mkdirsSync;
    var utimesMillisSync = require_utimes().utimesMillisSync;
    var stat = require_stat();
    function copySync(src, dest, opts) {
      if (typeof opts === "function") {
        opts = { filter: opts };
      }
      opts = opts || {};
      opts.clobber = "clobber" in opts ? !!opts.clobber : true;
      opts.overwrite = "overwrite" in opts ? !!opts.overwrite : opts.clobber;
      if (opts.preserveTimestamps && process.arch === "ia32") {
        console.warn(`fs-extra: Using the preserveTimestamps option in 32-bit node is not recommended;

    see https://github.com/jprichardson/node-fs-extra/issues/269`);
      }
      const { srcStat, destStat } = stat.checkPathsSync(src, dest, "copy", opts);
      stat.checkParentPathsSync(src, srcStat, dest, "copy");
      return handleFilterAndCopy(destStat, src, dest, opts);
    }
    function handleFilterAndCopy(destStat, src, dest, opts) {
      if (opts.filter && !opts.filter(src, dest))
        return;
      const destParent = path2.dirname(dest);
      if (!fs2.existsSync(destParent))
        mkdirsSync(destParent);
      return getStats(destStat, src, dest, opts);
    }
    function startCopy(destStat, src, dest, opts) {
      if (opts.filter && !opts.filter(src, dest))
        return;
      return getStats(destStat, src, dest, opts);
    }
    function getStats(destStat, src, dest, opts) {
      const statSync = opts.dereference ? fs2.statSync : fs2.lstatSync;
      const srcStat = statSync(src);
      if (srcStat.isDirectory())
        return onDir(srcStat, destStat, src, dest, opts);
      else if (srcStat.isFile() || srcStat.isCharacterDevice() || srcStat.isBlockDevice())
        return onFile(srcStat, destStat, src, dest, opts);
      else if (srcStat.isSymbolicLink())
        return onLink(destStat, src, dest, opts);
      else if (srcStat.isSocket())
        throw new Error(`Cannot copy a socket file: ${src}`);
      else if (srcStat.isFIFO())
        throw new Error(`Cannot copy a FIFO pipe: ${src}`);
      throw new Error(`Unknown file: ${src}`);
    }
    function onFile(srcStat, destStat, src, dest, opts) {
      if (!destStat)
        return copyFile(srcStat, src, dest, opts);
      return mayCopyFile(srcStat, src, dest, opts);
    }
    function mayCopyFile(srcStat, src, dest, opts) {
      if (opts.overwrite) {
        fs2.unlinkSync(dest);
        return copyFile(srcStat, src, dest, opts);
      } else if (opts.errorOnExist) {
        throw new Error(`'${dest}' already exists`);
      }
    }
    function copyFile(srcStat, src, dest, opts) {
      fs2.copyFileSync(src, dest);
      if (opts.preserveTimestamps)
        handleTimestamps(srcStat.mode, src, dest);
      return setDestMode(dest, srcStat.mode);
    }
    function handleTimestamps(srcMode, src, dest) {
      if (fileIsNotWritable(srcMode))
        makeFileWritable(dest, srcMode);
      return setDestTimestamps(src, dest);
    }
    function fileIsNotWritable(srcMode) {
      return (srcMode & 128) === 0;
    }
    function makeFileWritable(dest, srcMode) {
      return setDestMode(dest, srcMode | 128);
    }
    function setDestMode(dest, srcMode) {
      return fs2.chmodSync(dest, srcMode);
    }
    function setDestTimestamps(src, dest) {
      const updatedSrcStat = fs2.statSync(src);
      return utimesMillisSync(dest, updatedSrcStat.atime, updatedSrcStat.mtime);
    }
    function onDir(srcStat, destStat, src, dest, opts) {
      if (!destStat)
        return mkDirAndCopy(srcStat.mode, src, dest, opts);
      return copyDir(src, dest, opts);
    }
    function mkDirAndCopy(srcMode, src, dest, opts) {
      fs2.mkdirSync(dest);
      copyDir(src, dest, opts);
      return setDestMode(dest, srcMode);
    }
    function copyDir(src, dest, opts) {
      fs2.readdirSync(src).forEach((item) => copyDirItem(item, src, dest, opts));
    }
    function copyDirItem(item, src, dest, opts) {
      const srcItem = path2.join(src, item);
      const destItem = path2.join(dest, item);
      const { destStat } = stat.checkPathsSync(srcItem, destItem, "copy", opts);
      return startCopy(destStat, srcItem, destItem, opts);
    }
    function onLink(destStat, src, dest, opts) {
      let resolvedSrc = fs2.readlinkSync(src);
      if (opts.dereference) {
        resolvedSrc = path2.resolve(process.cwd(), resolvedSrc);
      }
      if (!destStat) {
        return fs2.symlinkSync(resolvedSrc, dest);
      } else {
        let resolvedDest;
        try {
          resolvedDest = fs2.readlinkSync(dest);
        } catch (err) {
          if (err.code === "EINVAL" || err.code === "UNKNOWN")
            return fs2.symlinkSync(resolvedSrc, dest);
          throw err;
        }
        if (opts.dereference) {
          resolvedDest = path2.resolve(process.cwd(), resolvedDest);
        }
        if (stat.isSrcSubdir(resolvedSrc, resolvedDest)) {
          throw new Error(`Cannot copy '${resolvedSrc}' to a subdirectory of itself, '${resolvedDest}'.`);
        }
        if (fs2.statSync(dest).isDirectory() && stat.isSrcSubdir(resolvedDest, resolvedSrc)) {
          throw new Error(`Cannot overwrite '${resolvedDest}' with '${resolvedSrc}'.`);
        }
        return copyLink(resolvedSrc, dest);
      }
    }
    function copyLink(resolvedSrc, dest) {
      fs2.unlinkSync(dest);
      return fs2.symlinkSync(resolvedSrc, dest);
    }
    module2.exports = copySync;
  }
});

// node_modules/fs-extra/lib/copy-sync/index.js
var require_copy_sync2 = __commonJS({
  "node_modules/fs-extra/lib/copy-sync/index.js"(exports, module2) {
    "use strict";
    module2.exports = {
      copySync: require_copy_sync()
    };
  }
});

// node_modules/fs-extra/lib/path-exists/index.js
var require_path_exists = __commonJS({
  "node_modules/fs-extra/lib/path-exists/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify().fromPromise;
    var fs2 = require_fs();
    function pathExists(path2) {
      return fs2.access(path2).then(() => true).catch(() => false);
    }
    module2.exports = {
      pathExists: u(pathExists),
      pathExistsSync: fs2.existsSync
    };
  }
});

// node_modules/fs-extra/lib/copy/copy.js
var require_copy = __commonJS({
  "node_modules/fs-extra/lib/copy/copy.js"(exports, module2) {
    "use strict";
    var fs2 = require_graceful_fs();
    var path2 = require("path");
    var mkdirs = require_mkdirs().mkdirs;
    var pathExists = require_path_exists().pathExists;
    var utimesMillis = require_utimes().utimesMillis;
    var stat = require_stat();
    function copy(src, dest, opts, cb) {
      if (typeof opts === "function" && !cb) {
        cb = opts;
        opts = {};
      } else if (typeof opts === "function") {
        opts = { filter: opts };
      }
      cb = cb || function() {
      };
      opts = opts || {};
      opts.clobber = "clobber" in opts ? !!opts.clobber : true;
      opts.overwrite = "overwrite" in opts ? !!opts.overwrite : opts.clobber;
      if (opts.preserveTimestamps && process.arch === "ia32") {
        console.warn(`fs-extra: Using the preserveTimestamps option in 32-bit node is not recommended;

    see https://github.com/jprichardson/node-fs-extra/issues/269`);
      }
      stat.checkPaths(src, dest, "copy", opts, (err, stats) => {
        if (err)
          return cb(err);
        const { srcStat, destStat } = stats;
        stat.checkParentPaths(src, srcStat, dest, "copy", (err2) => {
          if (err2)
            return cb(err2);
          if (opts.filter)
            return handleFilter(checkParentDir, destStat, src, dest, opts, cb);
          return checkParentDir(destStat, src, dest, opts, cb);
        });
      });
    }
    function checkParentDir(destStat, src, dest, opts, cb) {
      const destParent = path2.dirname(dest);
      pathExists(destParent, (err, dirExists) => {
        if (err)
          return cb(err);
        if (dirExists)
          return getStats(destStat, src, dest, opts, cb);
        mkdirs(destParent, (err2) => {
          if (err2)
            return cb(err2);
          return getStats(destStat, src, dest, opts, cb);
        });
      });
    }
    function handleFilter(onInclude, destStat, src, dest, opts, cb) {
      Promise.resolve(opts.filter(src, dest)).then((include) => {
        if (include)
          return onInclude(destStat, src, dest, opts, cb);
        return cb();
      }, (error) => cb(error));
    }
    function startCopy(destStat, src, dest, opts, cb) {
      if (opts.filter)
        return handleFilter(getStats, destStat, src, dest, opts, cb);
      return getStats(destStat, src, dest, opts, cb);
    }
    function getStats(destStat, src, dest, opts, cb) {
      const stat2 = opts.dereference ? fs2.stat : fs2.lstat;
      stat2(src, (err, srcStat) => {
        if (err)
          return cb(err);
        if (srcStat.isDirectory())
          return onDir(srcStat, destStat, src, dest, opts, cb);
        else if (srcStat.isFile() || srcStat.isCharacterDevice() || srcStat.isBlockDevice())
          return onFile(srcStat, destStat, src, dest, opts, cb);
        else if (srcStat.isSymbolicLink())
          return onLink(destStat, src, dest, opts, cb);
        else if (srcStat.isSocket())
          return cb(new Error(`Cannot copy a socket file: ${src}`));
        else if (srcStat.isFIFO())
          return cb(new Error(`Cannot copy a FIFO pipe: ${src}`));
        return cb(new Error(`Unknown file: ${src}`));
      });
    }
    function onFile(srcStat, destStat, src, dest, opts, cb) {
      if (!destStat)
        return copyFile(srcStat, src, dest, opts, cb);
      return mayCopyFile(srcStat, src, dest, opts, cb);
    }
    function mayCopyFile(srcStat, src, dest, opts, cb) {
      if (opts.overwrite) {
        fs2.unlink(dest, (err) => {
          if (err)
            return cb(err);
          return copyFile(srcStat, src, dest, opts, cb);
        });
      } else if (opts.errorOnExist) {
        return cb(new Error(`'${dest}' already exists`));
      } else
        return cb();
    }
    function copyFile(srcStat, src, dest, opts, cb) {
      fs2.copyFile(src, dest, (err) => {
        if (err)
          return cb(err);
        if (opts.preserveTimestamps)
          return handleTimestampsAndMode(srcStat.mode, src, dest, cb);
        return setDestMode(dest, srcStat.mode, cb);
      });
    }
    function handleTimestampsAndMode(srcMode, src, dest, cb) {
      if (fileIsNotWritable(srcMode)) {
        return makeFileWritable(dest, srcMode, (err) => {
          if (err)
            return cb(err);
          return setDestTimestampsAndMode(srcMode, src, dest, cb);
        });
      }
      return setDestTimestampsAndMode(srcMode, src, dest, cb);
    }
    function fileIsNotWritable(srcMode) {
      return (srcMode & 128) === 0;
    }
    function makeFileWritable(dest, srcMode, cb) {
      return setDestMode(dest, srcMode | 128, cb);
    }
    function setDestTimestampsAndMode(srcMode, src, dest, cb) {
      setDestTimestamps(src, dest, (err) => {
        if (err)
          return cb(err);
        return setDestMode(dest, srcMode, cb);
      });
    }
    function setDestMode(dest, srcMode, cb) {
      return fs2.chmod(dest, srcMode, cb);
    }
    function setDestTimestamps(src, dest, cb) {
      fs2.stat(src, (err, updatedSrcStat) => {
        if (err)
          return cb(err);
        return utimesMillis(dest, updatedSrcStat.atime, updatedSrcStat.mtime, cb);
      });
    }
    function onDir(srcStat, destStat, src, dest, opts, cb) {
      if (!destStat)
        return mkDirAndCopy(srcStat.mode, src, dest, opts, cb);
      return copyDir(src, dest, opts, cb);
    }
    function mkDirAndCopy(srcMode, src, dest, opts, cb) {
      fs2.mkdir(dest, (err) => {
        if (err)
          return cb(err);
        copyDir(src, dest, opts, (err2) => {
          if (err2)
            return cb(err2);
          return setDestMode(dest, srcMode, cb);
        });
      });
    }
    function copyDir(src, dest, opts, cb) {
      fs2.readdir(src, (err, items) => {
        if (err)
          return cb(err);
        return copyDirItems(items, src, dest, opts, cb);
      });
    }
    function copyDirItems(items, src, dest, opts, cb) {
      const item = items.pop();
      if (!item)
        return cb();
      return copyDirItem(items, item, src, dest, opts, cb);
    }
    function copyDirItem(items, item, src, dest, opts, cb) {
      const srcItem = path2.join(src, item);
      const destItem = path2.join(dest, item);
      stat.checkPaths(srcItem, destItem, "copy", opts, (err, stats) => {
        if (err)
          return cb(err);
        const { destStat } = stats;
        startCopy(destStat, srcItem, destItem, opts, (err2) => {
          if (err2)
            return cb(err2);
          return copyDirItems(items, src, dest, opts, cb);
        });
      });
    }
    function onLink(destStat, src, dest, opts, cb) {
      fs2.readlink(src, (err, resolvedSrc) => {
        if (err)
          return cb(err);
        if (opts.dereference) {
          resolvedSrc = path2.resolve(process.cwd(), resolvedSrc);
        }
        if (!destStat) {
          return fs2.symlink(resolvedSrc, dest, cb);
        } else {
          fs2.readlink(dest, (err2, resolvedDest) => {
            if (err2) {
              if (err2.code === "EINVAL" || err2.code === "UNKNOWN")
                return fs2.symlink(resolvedSrc, dest, cb);
              return cb(err2);
            }
            if (opts.dereference) {
              resolvedDest = path2.resolve(process.cwd(), resolvedDest);
            }
            if (stat.isSrcSubdir(resolvedSrc, resolvedDest)) {
              return cb(new Error(`Cannot copy '${resolvedSrc}' to a subdirectory of itself, '${resolvedDest}'.`));
            }
            if (destStat.isDirectory() && stat.isSrcSubdir(resolvedDest, resolvedSrc)) {
              return cb(new Error(`Cannot overwrite '${resolvedDest}' with '${resolvedSrc}'.`));
            }
            return copyLink(resolvedSrc, dest, cb);
          });
        }
      });
    }
    function copyLink(resolvedSrc, dest, cb) {
      fs2.unlink(dest, (err) => {
        if (err)
          return cb(err);
        return fs2.symlink(resolvedSrc, dest, cb);
      });
    }
    module2.exports = copy;
  }
});

// node_modules/fs-extra/lib/copy/index.js
var require_copy2 = __commonJS({
  "node_modules/fs-extra/lib/copy/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify().fromCallback;
    module2.exports = {
      copy: u(require_copy())
    };
  }
});

// node_modules/fs-extra/lib/remove/rimraf.js
var require_rimraf = __commonJS({
  "node_modules/fs-extra/lib/remove/rimraf.js"(exports, module2) {
    "use strict";
    var fs2 = require_graceful_fs();
    var path2 = require("path");
    var assert = require("assert");
    var isWindows = process.platform === "win32";
    function defaults(options) {
      const methods = [
        "unlink",
        "chmod",
        "stat",
        "lstat",
        "rmdir",
        "readdir"
      ];
      methods.forEach((m) => {
        options[m] = options[m] || fs2[m];
        m = m + "Sync";
        options[m] = options[m] || fs2[m];
      });
      options.maxBusyTries = options.maxBusyTries || 3;
    }
    function rimraf(p, options, cb) {
      let busyTries = 0;
      if (typeof options === "function") {
        cb = options;
        options = {};
      }
      assert(p, "rimraf: missing path");
      assert.strictEqual(typeof p, "string", "rimraf: path should be a string");
      assert.strictEqual(typeof cb, "function", "rimraf: callback function required");
      assert(options, "rimraf: invalid options argument provided");
      assert.strictEqual(typeof options, "object", "rimraf: options should be object");
      defaults(options);
      rimraf_(p, options, function CB(er) {
        if (er) {
          if ((er.code === "EBUSY" || er.code === "ENOTEMPTY" || er.code === "EPERM") && busyTries < options.maxBusyTries) {
            busyTries++;
            const time = busyTries * 100;
            return setTimeout(() => rimraf_(p, options, CB), time);
          }
          if (er.code === "ENOENT")
            er = null;
        }
        cb(er);
      });
    }
    function rimraf_(p, options, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.lstat(p, (er, st) => {
        if (er && er.code === "ENOENT") {
          return cb(null);
        }
        if (er && er.code === "EPERM" && isWindows) {
          return fixWinEPERM(p, options, er, cb);
        }
        if (st && st.isDirectory()) {
          return rmdir(p, options, er, cb);
        }
        options.unlink(p, (er2) => {
          if (er2) {
            if (er2.code === "ENOENT") {
              return cb(null);
            }
            if (er2.code === "EPERM") {
              return isWindows ? fixWinEPERM(p, options, er2, cb) : rmdir(p, options, er2, cb);
            }
            if (er2.code === "EISDIR") {
              return rmdir(p, options, er2, cb);
            }
          }
          return cb(er2);
        });
      });
    }
    function fixWinEPERM(p, options, er, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.chmod(p, 438, (er2) => {
        if (er2) {
          cb(er2.code === "ENOENT" ? null : er);
        } else {
          options.stat(p, (er3, stats) => {
            if (er3) {
              cb(er3.code === "ENOENT" ? null : er);
            } else if (stats.isDirectory()) {
              rmdir(p, options, er, cb);
            } else {
              options.unlink(p, cb);
            }
          });
        }
      });
    }
    function fixWinEPERMSync(p, options, er) {
      let stats;
      assert(p);
      assert(options);
      try {
        options.chmodSync(p, 438);
      } catch (er2) {
        if (er2.code === "ENOENT") {
          return;
        } else {
          throw er;
        }
      }
      try {
        stats = options.statSync(p);
      } catch (er3) {
        if (er3.code === "ENOENT") {
          return;
        } else {
          throw er;
        }
      }
      if (stats.isDirectory()) {
        rmdirSync(p, options, er);
      } else {
        options.unlinkSync(p);
      }
    }
    function rmdir(p, options, originalEr, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.rmdir(p, (er) => {
        if (er && (er.code === "ENOTEMPTY" || er.code === "EEXIST" || er.code === "EPERM")) {
          rmkids(p, options, cb);
        } else if (er && er.code === "ENOTDIR") {
          cb(originalEr);
        } else {
          cb(er);
        }
      });
    }
    function rmkids(p, options, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.readdir(p, (er, files) => {
        if (er)
          return cb(er);
        let n = files.length;
        let errState;
        if (n === 0)
          return options.rmdir(p, cb);
        files.forEach((f) => {
          rimraf(path2.join(p, f), options, (er2) => {
            if (errState) {
              return;
            }
            if (er2)
              return cb(errState = er2);
            if (--n === 0) {
              options.rmdir(p, cb);
            }
          });
        });
      });
    }
    function rimrafSync(p, options) {
      let st;
      options = options || {};
      defaults(options);
      assert(p, "rimraf: missing path");
      assert.strictEqual(typeof p, "string", "rimraf: path should be a string");
      assert(options, "rimraf: missing options");
      assert.strictEqual(typeof options, "object", "rimraf: options should be object");
      try {
        st = options.lstatSync(p);
      } catch (er) {
        if (er.code === "ENOENT") {
          return;
        }
        if (er.code === "EPERM" && isWindows) {
          fixWinEPERMSync(p, options, er);
        }
      }
      try {
        if (st && st.isDirectory()) {
          rmdirSync(p, options, null);
        } else {
          options.unlinkSync(p);
        }
      } catch (er) {
        if (er.code === "ENOENT") {
          return;
        } else if (er.code === "EPERM") {
          return isWindows ? fixWinEPERMSync(p, options, er) : rmdirSync(p, options, er);
        } else if (er.code !== "EISDIR") {
          throw er;
        }
        rmdirSync(p, options, er);
      }
    }
    function rmdirSync(p, options, originalEr) {
      assert(p);
      assert(options);
      try {
        options.rmdirSync(p);
      } catch (er) {
        if (er.code === "ENOTDIR") {
          throw originalEr;
        } else if (er.code === "ENOTEMPTY" || er.code === "EEXIST" || er.code === "EPERM") {
          rmkidsSync(p, options);
        } else if (er.code !== "ENOENT") {
          throw er;
        }
      }
    }
    function rmkidsSync(p, options) {
      assert(p);
      assert(options);
      options.readdirSync(p).forEach((f) => rimrafSync(path2.join(p, f), options));
      if (isWindows) {
        const startTime = Date.now();
        do {
          try {
            const ret = options.rmdirSync(p, options);
            return ret;
          } catch {
          }
        } while (Date.now() - startTime < 500);
      } else {
        const ret = options.rmdirSync(p, options);
        return ret;
      }
    }
    module2.exports = rimraf;
    rimraf.sync = rimrafSync;
  }
});

// node_modules/fs-extra/lib/remove/index.js
var require_remove = __commonJS({
  "node_modules/fs-extra/lib/remove/index.js"(exports, module2) {
    "use strict";
    var fs2 = require_graceful_fs();
    var u = require_universalify().fromCallback;
    var rimraf = require_rimraf();
    function remove2(path2, callback) {
      if (fs2.rm)
        return fs2.rm(path2, { recursive: true, force: true }, callback);
      rimraf(path2, callback);
    }
    function removeSync(path2) {
      if (fs2.rmSync)
        return fs2.rmSync(path2, { recursive: true, force: true });
      rimraf.sync(path2);
    }
    module2.exports = {
      remove: u(remove2),
      removeSync
    };
  }
});

// node_modules/fs-extra/lib/empty/index.js
var require_empty = __commonJS({
  "node_modules/fs-extra/lib/empty/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify().fromPromise;
    var fs2 = require_fs();
    var path2 = require("path");
    var mkdir = require_mkdirs();
    var remove2 = require_remove();
    var emptyDir = u(async function emptyDir2(dir) {
      let items;
      try {
        items = await fs2.readdir(dir);
      } catch {
        return mkdir.mkdirs(dir);
      }
      return Promise.all(items.map((item) => remove2.remove(path2.join(dir, item))));
    });
    function emptyDirSync(dir) {
      let items;
      try {
        items = fs2.readdirSync(dir);
      } catch {
        return mkdir.mkdirsSync(dir);
      }
      items.forEach((item) => {
        item = path2.join(dir, item);
        remove2.removeSync(item);
      });
    }
    module2.exports = {
      emptyDirSync,
      emptydirSync: emptyDirSync,
      emptyDir,
      emptydir: emptyDir
    };
  }
});

// node_modules/fs-extra/lib/ensure/file.js
var require_file = __commonJS({
  "node_modules/fs-extra/lib/ensure/file.js"(exports, module2) {
    "use strict";
    var u = require_universalify().fromCallback;
    var path2 = require("path");
    var fs2 = require_graceful_fs();
    var mkdir = require_mkdirs();
    function createFile(file, callback) {
      function makeFile() {
        fs2.writeFile(file, "", (err) => {
          if (err)
            return callback(err);
          callback();
        });
      }
      fs2.stat(file, (err, stats) => {
        if (!err && stats.isFile())
          return callback();
        const dir = path2.dirname(file);
        fs2.stat(dir, (err2, stats2) => {
          if (err2) {
            if (err2.code === "ENOENT") {
              return mkdir.mkdirs(dir, (err3) => {
                if (err3)
                  return callback(err3);
                makeFile();
              });
            }
            return callback(err2);
          }
          if (stats2.isDirectory())
            makeFile();
          else {
            fs2.readdir(dir, (err3) => {
              if (err3)
                return callback(err3);
            });
          }
        });
      });
    }
    function createFileSync(file) {
      let stats;
      try {
        stats = fs2.statSync(file);
      } catch {
      }
      if (stats && stats.isFile())
        return;
      const dir = path2.dirname(file);
      try {
        if (!fs2.statSync(dir).isDirectory()) {
          fs2.readdirSync(dir);
        }
      } catch (err) {
        if (err && err.code === "ENOENT")
          mkdir.mkdirsSync(dir);
        else
          throw err;
      }
      fs2.writeFileSync(file, "");
    }
    module2.exports = {
      createFile: u(createFile),
      createFileSync
    };
  }
});

// node_modules/fs-extra/lib/ensure/link.js
var require_link = __commonJS({
  "node_modules/fs-extra/lib/ensure/link.js"(exports, module2) {
    "use strict";
    var u = require_universalify().fromCallback;
    var path2 = require("path");
    var fs2 = require_graceful_fs();
    var mkdir = require_mkdirs();
    var pathExists = require_path_exists().pathExists;
    var { areIdentical } = require_stat();
    function createLink(srcpath, dstpath, callback) {
      function makeLink(srcpath2, dstpath2) {
        fs2.link(srcpath2, dstpath2, (err) => {
          if (err)
            return callback(err);
          callback(null);
        });
      }
      fs2.lstat(dstpath, (_, dstStat) => {
        fs2.lstat(srcpath, (err, srcStat) => {
          if (err) {
            err.message = err.message.replace("lstat", "ensureLink");
            return callback(err);
          }
          if (dstStat && areIdentical(srcStat, dstStat))
            return callback(null);
          const dir = path2.dirname(dstpath);
          pathExists(dir, (err2, dirExists) => {
            if (err2)
              return callback(err2);
            if (dirExists)
              return makeLink(srcpath, dstpath);
            mkdir.mkdirs(dir, (err3) => {
              if (err3)
                return callback(err3);
              makeLink(srcpath, dstpath);
            });
          });
        });
      });
    }
    function createLinkSync(srcpath, dstpath) {
      let dstStat;
      try {
        dstStat = fs2.lstatSync(dstpath);
      } catch {
      }
      try {
        const srcStat = fs2.lstatSync(srcpath);
        if (dstStat && areIdentical(srcStat, dstStat))
          return;
      } catch (err) {
        err.message = err.message.replace("lstat", "ensureLink");
        throw err;
      }
      const dir = path2.dirname(dstpath);
      const dirExists = fs2.existsSync(dir);
      if (dirExists)
        return fs2.linkSync(srcpath, dstpath);
      mkdir.mkdirsSync(dir);
      return fs2.linkSync(srcpath, dstpath);
    }
    module2.exports = {
      createLink: u(createLink),
      createLinkSync
    };
  }
});

// node_modules/fs-extra/lib/ensure/symlink-paths.js
var require_symlink_paths = __commonJS({
  "node_modules/fs-extra/lib/ensure/symlink-paths.js"(exports, module2) {
    "use strict";
    var path2 = require("path");
    var fs2 = require_graceful_fs();
    var pathExists = require_path_exists().pathExists;
    function symlinkPaths(srcpath, dstpath, callback) {
      if (path2.isAbsolute(srcpath)) {
        return fs2.lstat(srcpath, (err) => {
          if (err) {
            err.message = err.message.replace("lstat", "ensureSymlink");
            return callback(err);
          }
          return callback(null, {
            toCwd: srcpath,
            toDst: srcpath
          });
        });
      } else {
        const dstdir = path2.dirname(dstpath);
        const relativeToDst = path2.join(dstdir, srcpath);
        return pathExists(relativeToDst, (err, exists) => {
          if (err)
            return callback(err);
          if (exists) {
            return callback(null, {
              toCwd: relativeToDst,
              toDst: srcpath
            });
          } else {
            return fs2.lstat(srcpath, (err2) => {
              if (err2) {
                err2.message = err2.message.replace("lstat", "ensureSymlink");
                return callback(err2);
              }
              return callback(null, {
                toCwd: srcpath,
                toDst: path2.relative(dstdir, srcpath)
              });
            });
          }
        });
      }
    }
    function symlinkPathsSync(srcpath, dstpath) {
      let exists;
      if (path2.isAbsolute(srcpath)) {
        exists = fs2.existsSync(srcpath);
        if (!exists)
          throw new Error("absolute srcpath does not exist");
        return {
          toCwd: srcpath,
          toDst: srcpath
        };
      } else {
        const dstdir = path2.dirname(dstpath);
        const relativeToDst = path2.join(dstdir, srcpath);
        exists = fs2.existsSync(relativeToDst);
        if (exists) {
          return {
            toCwd: relativeToDst,
            toDst: srcpath
          };
        } else {
          exists = fs2.existsSync(srcpath);
          if (!exists)
            throw new Error("relative srcpath does not exist");
          return {
            toCwd: srcpath,
            toDst: path2.relative(dstdir, srcpath)
          };
        }
      }
    }
    module2.exports = {
      symlinkPaths,
      symlinkPathsSync
    };
  }
});

// node_modules/fs-extra/lib/ensure/symlink-type.js
var require_symlink_type = __commonJS({
  "node_modules/fs-extra/lib/ensure/symlink-type.js"(exports, module2) {
    "use strict";
    var fs2 = require_graceful_fs();
    function symlinkType(srcpath, type, callback) {
      callback = typeof type === "function" ? type : callback;
      type = typeof type === "function" ? false : type;
      if (type)
        return callback(null, type);
      fs2.lstat(srcpath, (err, stats) => {
        if (err)
          return callback(null, "file");
        type = stats && stats.isDirectory() ? "dir" : "file";
        callback(null, type);
      });
    }
    function symlinkTypeSync(srcpath, type) {
      let stats;
      if (type)
        return type;
      try {
        stats = fs2.lstatSync(srcpath);
      } catch {
        return "file";
      }
      return stats && stats.isDirectory() ? "dir" : "file";
    }
    module2.exports = {
      symlinkType,
      symlinkTypeSync
    };
  }
});

// node_modules/fs-extra/lib/ensure/symlink.js
var require_symlink = __commonJS({
  "node_modules/fs-extra/lib/ensure/symlink.js"(exports, module2) {
    "use strict";
    var u = require_universalify().fromCallback;
    var path2 = require("path");
    var fs2 = require_fs();
    var _mkdirs = require_mkdirs();
    var mkdirs = _mkdirs.mkdirs;
    var mkdirsSync = _mkdirs.mkdirsSync;
    var _symlinkPaths = require_symlink_paths();
    var symlinkPaths = _symlinkPaths.symlinkPaths;
    var symlinkPathsSync = _symlinkPaths.symlinkPathsSync;
    var _symlinkType = require_symlink_type();
    var symlinkType = _symlinkType.symlinkType;
    var symlinkTypeSync = _symlinkType.symlinkTypeSync;
    var pathExists = require_path_exists().pathExists;
    var { areIdentical } = require_stat();
    function createSymlink(srcpath, dstpath, type, callback) {
      callback = typeof type === "function" ? type : callback;
      type = typeof type === "function" ? false : type;
      fs2.lstat(dstpath, (err, stats) => {
        if (!err && stats.isSymbolicLink()) {
          Promise.all([
            fs2.stat(srcpath),
            fs2.stat(dstpath)
          ]).then(([srcStat, dstStat]) => {
            if (areIdentical(srcStat, dstStat))
              return callback(null);
            _createSymlink(srcpath, dstpath, type, callback);
          });
        } else
          _createSymlink(srcpath, dstpath, type, callback);
      });
    }
    function _createSymlink(srcpath, dstpath, type, callback) {
      symlinkPaths(srcpath, dstpath, (err, relative) => {
        if (err)
          return callback(err);
        srcpath = relative.toDst;
        symlinkType(relative.toCwd, type, (err2, type2) => {
          if (err2)
            return callback(err2);
          const dir = path2.dirname(dstpath);
          pathExists(dir, (err3, dirExists) => {
            if (err3)
              return callback(err3);
            if (dirExists)
              return fs2.symlink(srcpath, dstpath, type2, callback);
            mkdirs(dir, (err4) => {
              if (err4)
                return callback(err4);
              fs2.symlink(srcpath, dstpath, type2, callback);
            });
          });
        });
      });
    }
    function createSymlinkSync(srcpath, dstpath, type) {
      let stats;
      try {
        stats = fs2.lstatSync(dstpath);
      } catch {
      }
      if (stats && stats.isSymbolicLink()) {
        const srcStat = fs2.statSync(srcpath);
        const dstStat = fs2.statSync(dstpath);
        if (areIdentical(srcStat, dstStat))
          return;
      }
      const relative = symlinkPathsSync(srcpath, dstpath);
      srcpath = relative.toDst;
      type = symlinkTypeSync(relative.toCwd, type);
      const dir = path2.dirname(dstpath);
      const exists = fs2.existsSync(dir);
      if (exists)
        return fs2.symlinkSync(srcpath, dstpath, type);
      mkdirsSync(dir);
      return fs2.symlinkSync(srcpath, dstpath, type);
    }
    module2.exports = {
      createSymlink: u(createSymlink),
      createSymlinkSync
    };
  }
});

// node_modules/fs-extra/lib/ensure/index.js
var require_ensure = __commonJS({
  "node_modules/fs-extra/lib/ensure/index.js"(exports, module2) {
    "use strict";
    var file = require_file();
    var link = require_link();
    var symlink = require_symlink();
    module2.exports = {
      createFile: file.createFile,
      createFileSync: file.createFileSync,
      ensureFile: file.createFile,
      ensureFileSync: file.createFileSync,
      createLink: link.createLink,
      createLinkSync: link.createLinkSync,
      ensureLink: link.createLink,
      ensureLinkSync: link.createLinkSync,
      createSymlink: symlink.createSymlink,
      createSymlinkSync: symlink.createSymlinkSync,
      ensureSymlink: symlink.createSymlink,
      ensureSymlinkSync: symlink.createSymlinkSync
    };
  }
});

// node_modules/fs-extra/node_modules/jsonfile/utils.js
var require_utils2 = __commonJS({
  "node_modules/fs-extra/node_modules/jsonfile/utils.js"(exports, module2) {
    function stringify(obj, { EOL = "\n", finalEOL = true, replacer = null, spaces } = {}) {
      const EOF = finalEOL ? EOL : "";
      const str = JSON.stringify(obj, replacer, spaces);
      return str.replace(/\n/g, EOL) + EOF;
    }
    function stripBom(content) {
      if (Buffer.isBuffer(content))
        content = content.toString("utf8");
      return content.replace(/^\uFEFF/, "");
    }
    module2.exports = { stringify, stripBom };
  }
});

// node_modules/fs-extra/node_modules/jsonfile/index.js
var require_jsonfile = __commonJS({
  "node_modules/fs-extra/node_modules/jsonfile/index.js"(exports, module2) {
    var _fs;
    try {
      _fs = require_graceful_fs();
    } catch (_) {
      _fs = require("fs");
    }
    var universalify = require_universalify();
    var { stringify, stripBom } = require_utils2();
    async function _readFile(file, options = {}) {
      if (typeof options === "string") {
        options = { encoding: options };
      }
      const fs2 = options.fs || _fs;
      const shouldThrow = "throws" in options ? options.throws : true;
      let data = await universalify.fromCallback(fs2.readFile)(file, options);
      data = stripBom(data);
      let obj;
      try {
        obj = JSON.parse(data, options ? options.reviver : null);
      } catch (err) {
        if (shouldThrow) {
          err.message = `${file}: ${err.message}`;
          throw err;
        } else {
          return null;
        }
      }
      return obj;
    }
    var readFile = universalify.fromPromise(_readFile);
    function readFileSync(file, options = {}) {
      if (typeof options === "string") {
        options = { encoding: options };
      }
      const fs2 = options.fs || _fs;
      const shouldThrow = "throws" in options ? options.throws : true;
      try {
        let content = fs2.readFileSync(file, options);
        content = stripBom(content);
        return JSON.parse(content, options.reviver);
      } catch (err) {
        if (shouldThrow) {
          err.message = `${file}: ${err.message}`;
          throw err;
        } else {
          return null;
        }
      }
    }
    async function _writeFile(file, obj, options = {}) {
      const fs2 = options.fs || _fs;
      const str = stringify(obj, options);
      await universalify.fromCallback(fs2.writeFile)(file, str, options);
    }
    var writeFile = universalify.fromPromise(_writeFile);
    function writeFileSync(file, obj, options = {}) {
      const fs2 = options.fs || _fs;
      const str = stringify(obj, options);
      return fs2.writeFileSync(file, str, options);
    }
    var jsonfile = {
      readFile,
      readFileSync,
      writeFile,
      writeFileSync
    };
    module2.exports = jsonfile;
  }
});

// node_modules/fs-extra/lib/json/jsonfile.js
var require_jsonfile2 = __commonJS({
  "node_modules/fs-extra/lib/json/jsonfile.js"(exports, module2) {
    "use strict";
    var jsonFile = require_jsonfile();
    module2.exports = {
      readJson: jsonFile.readFile,
      readJsonSync: jsonFile.readFileSync,
      writeJson: jsonFile.writeFile,
      writeJsonSync: jsonFile.writeFileSync
    };
  }
});

// node_modules/fs-extra/lib/output/index.js
var require_output = __commonJS({
  "node_modules/fs-extra/lib/output/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify().fromCallback;
    var fs2 = require_graceful_fs();
    var path2 = require("path");
    var mkdir = require_mkdirs();
    var pathExists = require_path_exists().pathExists;
    function outputFile(file, data, encoding, callback) {
      if (typeof encoding === "function") {
        callback = encoding;
        encoding = "utf8";
      }
      const dir = path2.dirname(file);
      pathExists(dir, (err, itDoes) => {
        if (err)
          return callback(err);
        if (itDoes)
          return fs2.writeFile(file, data, encoding, callback);
        mkdir.mkdirs(dir, (err2) => {
          if (err2)
            return callback(err2);
          fs2.writeFile(file, data, encoding, callback);
        });
      });
    }
    function outputFileSync(file, ...args) {
      const dir = path2.dirname(file);
      if (fs2.existsSync(dir)) {
        return fs2.writeFileSync(file, ...args);
      }
      mkdir.mkdirsSync(dir);
      fs2.writeFileSync(file, ...args);
    }
    module2.exports = {
      outputFile: u(outputFile),
      outputFileSync
    };
  }
});

// node_modules/fs-extra/lib/json/output-json.js
var require_output_json = __commonJS({
  "node_modules/fs-extra/lib/json/output-json.js"(exports, module2) {
    "use strict";
    var { stringify } = require_utils2();
    var { outputFile } = require_output();
    async function outputJson(file, data, options = {}) {
      const str = stringify(data, options);
      await outputFile(file, str, options);
    }
    module2.exports = outputJson;
  }
});

// node_modules/fs-extra/lib/json/output-json-sync.js
var require_output_json_sync = __commonJS({
  "node_modules/fs-extra/lib/json/output-json-sync.js"(exports, module2) {
    "use strict";
    var { stringify } = require_utils2();
    var { outputFileSync } = require_output();
    function outputJsonSync(file, data, options) {
      const str = stringify(data, options);
      outputFileSync(file, str, options);
    }
    module2.exports = outputJsonSync;
  }
});

// node_modules/fs-extra/lib/json/index.js
var require_json = __commonJS({
  "node_modules/fs-extra/lib/json/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify().fromPromise;
    var jsonFile = require_jsonfile2();
    jsonFile.outputJson = u(require_output_json());
    jsonFile.outputJsonSync = require_output_json_sync();
    jsonFile.outputJSON = jsonFile.outputJson;
    jsonFile.outputJSONSync = jsonFile.outputJsonSync;
    jsonFile.writeJSON = jsonFile.writeJson;
    jsonFile.writeJSONSync = jsonFile.writeJsonSync;
    jsonFile.readJSON = jsonFile.readJson;
    jsonFile.readJSONSync = jsonFile.readJsonSync;
    module2.exports = jsonFile;
  }
});

// node_modules/fs-extra/lib/move-sync/move-sync.js
var require_move_sync = __commonJS({
  "node_modules/fs-extra/lib/move-sync/move-sync.js"(exports, module2) {
    "use strict";
    var fs2 = require_graceful_fs();
    var path2 = require("path");
    var copySync = require_copy_sync2().copySync;
    var removeSync = require_remove().removeSync;
    var mkdirpSync = require_mkdirs().mkdirpSync;
    var stat = require_stat();
    function moveSync(src, dest, opts) {
      opts = opts || {};
      const overwrite = opts.overwrite || opts.clobber || false;
      const { srcStat, isChangingCase = false } = stat.checkPathsSync(src, dest, "move", opts);
      stat.checkParentPathsSync(src, srcStat, dest, "move");
      if (!isParentRoot(dest))
        mkdirpSync(path2.dirname(dest));
      return doRename(src, dest, overwrite, isChangingCase);
    }
    function isParentRoot(dest) {
      const parent = path2.dirname(dest);
      const parsedPath = path2.parse(parent);
      return parsedPath.root === parent;
    }
    function doRename(src, dest, overwrite, isChangingCase) {
      if (isChangingCase)
        return rename(src, dest, overwrite);
      if (overwrite) {
        removeSync(dest);
        return rename(src, dest, overwrite);
      }
      if (fs2.existsSync(dest))
        throw new Error("dest already exists.");
      return rename(src, dest, overwrite);
    }
    function rename(src, dest, overwrite) {
      try {
        fs2.renameSync(src, dest);
      } catch (err) {
        if (err.code !== "EXDEV")
          throw err;
        return moveAcrossDevice(src, dest, overwrite);
      }
    }
    function moveAcrossDevice(src, dest, overwrite) {
      const opts = {
        overwrite,
        errorOnExist: true
      };
      copySync(src, dest, opts);
      return removeSync(src);
    }
    module2.exports = moveSync;
  }
});

// node_modules/fs-extra/lib/move-sync/index.js
var require_move_sync2 = __commonJS({
  "node_modules/fs-extra/lib/move-sync/index.js"(exports, module2) {
    "use strict";
    module2.exports = {
      moveSync: require_move_sync()
    };
  }
});

// node_modules/fs-extra/lib/move/move.js
var require_move = __commonJS({
  "node_modules/fs-extra/lib/move/move.js"(exports, module2) {
    "use strict";
    var fs2 = require_graceful_fs();
    var path2 = require("path");
    var copy = require_copy2().copy;
    var remove2 = require_remove().remove;
    var mkdirp2 = require_mkdirs().mkdirp;
    var pathExists = require_path_exists().pathExists;
    var stat = require_stat();
    function move(src, dest, opts, cb) {
      if (typeof opts === "function") {
        cb = opts;
        opts = {};
      }
      const overwrite = opts.overwrite || opts.clobber || false;
      stat.checkPaths(src, dest, "move", opts, (err, stats) => {
        if (err)
          return cb(err);
        const { srcStat, isChangingCase = false } = stats;
        stat.checkParentPaths(src, srcStat, dest, "move", (err2) => {
          if (err2)
            return cb(err2);
          if (isParentRoot(dest))
            return doRename(src, dest, overwrite, isChangingCase, cb);
          mkdirp2(path2.dirname(dest), (err3) => {
            if (err3)
              return cb(err3);
            return doRename(src, dest, overwrite, isChangingCase, cb);
          });
        });
      });
    }
    function isParentRoot(dest) {
      const parent = path2.dirname(dest);
      const parsedPath = path2.parse(parent);
      return parsedPath.root === parent;
    }
    function doRename(src, dest, overwrite, isChangingCase, cb) {
      if (isChangingCase)
        return rename(src, dest, overwrite, cb);
      if (overwrite) {
        return remove2(dest, (err) => {
          if (err)
            return cb(err);
          return rename(src, dest, overwrite, cb);
        });
      }
      pathExists(dest, (err, destExists) => {
        if (err)
          return cb(err);
        if (destExists)
          return cb(new Error("dest already exists."));
        return rename(src, dest, overwrite, cb);
      });
    }
    function rename(src, dest, overwrite, cb) {
      fs2.rename(src, dest, (err) => {
        if (!err)
          return cb();
        if (err.code !== "EXDEV")
          return cb(err);
        return moveAcrossDevice(src, dest, overwrite, cb);
      });
    }
    function moveAcrossDevice(src, dest, overwrite, cb) {
      const opts = {
        overwrite,
        errorOnExist: true
      };
      copy(src, dest, opts, (err) => {
        if (err)
          return cb(err);
        return remove2(src, cb);
      });
    }
    module2.exports = move;
  }
});

// node_modules/fs-extra/lib/move/index.js
var require_move2 = __commonJS({
  "node_modules/fs-extra/lib/move/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify().fromCallback;
    module2.exports = {
      move: u(require_move())
    };
  }
});

// node_modules/fs-extra/lib/index.js
var require_lib2 = __commonJS({
  "node_modules/fs-extra/lib/index.js"(exports, module2) {
    "use strict";
    module2.exports = __spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues({}, require_fs()), require_copy_sync2()), require_copy2()), require_empty()), require_ensure()), require_json()), require_mkdirs()), require_move_sync2()), require_move2()), require_output()), require_path_exists()), require_remove());
  }
});

// node_modules/fs.realpath/old.js
var require_old = __commonJS({
  "node_modules/fs.realpath/old.js"(exports) {
    var pathModule = require("path");
    var isWindows = process.platform === "win32";
    var fs2 = require("fs");
    var DEBUG = process.env.NODE_DEBUG && /fs/.test(process.env.NODE_DEBUG);
    function rethrow() {
      var callback;
      if (DEBUG) {
        var backtrace = new Error();
        callback = debugCallback;
      } else
        callback = missingCallback;
      return callback;
      function debugCallback(err) {
        if (err) {
          backtrace.message = err.message;
          err = backtrace;
          missingCallback(err);
        }
      }
      function missingCallback(err) {
        if (err) {
          if (process.throwDeprecation)
            throw err;
          else if (!process.noDeprecation) {
            var msg = "fs: missing callback " + (err.stack || err.message);
            if (process.traceDeprecation)
              console.trace(msg);
            else
              console.error(msg);
          }
        }
      }
    }
    function maybeCallback(cb) {
      return typeof cb === "function" ? cb : rethrow();
    }
    var normalize = pathModule.normalize;
    if (isWindows) {
      nextPartRe = /(.*?)(?:[\/\\]+|$)/g;
    } else {
      nextPartRe = /(.*?)(?:[\/]+|$)/g;
    }
    var nextPartRe;
    if (isWindows) {
      splitRootRe = /^(?:[a-zA-Z]:|[\\\/]{2}[^\\\/]+[\\\/][^\\\/]+)?[\\\/]*/;
    } else {
      splitRootRe = /^[\/]*/;
    }
    var splitRootRe;
    exports.realpathSync = function realpathSync(p, cache) {
      p = pathModule.resolve(p);
      if (cache && Object.prototype.hasOwnProperty.call(cache, p)) {
        return cache[p];
      }
      var original = p, seenLinks = {}, knownHard = {};
      var pos;
      var current;
      var base;
      var previous;
      start();
      function start() {
        var m = splitRootRe.exec(p);
        pos = m[0].length;
        current = m[0];
        base = m[0];
        previous = "";
        if (isWindows && !knownHard[base]) {
          fs2.lstatSync(base);
          knownHard[base] = true;
        }
      }
      while (pos < p.length) {
        nextPartRe.lastIndex = pos;
        var result = nextPartRe.exec(p);
        previous = current;
        current += result[0];
        base = previous + result[1];
        pos = nextPartRe.lastIndex;
        if (knownHard[base] || cache && cache[base] === base) {
          continue;
        }
        var resolvedLink;
        if (cache && Object.prototype.hasOwnProperty.call(cache, base)) {
          resolvedLink = cache[base];
        } else {
          var stat = fs2.lstatSync(base);
          if (!stat.isSymbolicLink()) {
            knownHard[base] = true;
            if (cache)
              cache[base] = base;
            continue;
          }
          var linkTarget = null;
          if (!isWindows) {
            var id = stat.dev.toString(32) + ":" + stat.ino.toString(32);
            if (seenLinks.hasOwnProperty(id)) {
              linkTarget = seenLinks[id];
            }
          }
          if (linkTarget === null) {
            fs2.statSync(base);
            linkTarget = fs2.readlinkSync(base);
          }
          resolvedLink = pathModule.resolve(previous, linkTarget);
          if (cache)
            cache[base] = resolvedLink;
          if (!isWindows)
            seenLinks[id] = linkTarget;
        }
        p = pathModule.resolve(resolvedLink, p.slice(pos));
        start();
      }
      if (cache)
        cache[original] = p;
      return p;
    };
    exports.realpath = function realpath(p, cache, cb) {
      if (typeof cb !== "function") {
        cb = maybeCallback(cache);
        cache = null;
      }
      p = pathModule.resolve(p);
      if (cache && Object.prototype.hasOwnProperty.call(cache, p)) {
        return process.nextTick(cb.bind(null, null, cache[p]));
      }
      var original = p, seenLinks = {}, knownHard = {};
      var pos;
      var current;
      var base;
      var previous;
      start();
      function start() {
        var m = splitRootRe.exec(p);
        pos = m[0].length;
        current = m[0];
        base = m[0];
        previous = "";
        if (isWindows && !knownHard[base]) {
          fs2.lstat(base, function(err) {
            if (err)
              return cb(err);
            knownHard[base] = true;
            LOOP();
          });
        } else {
          process.nextTick(LOOP);
        }
      }
      function LOOP() {
        if (pos >= p.length) {
          if (cache)
            cache[original] = p;
          return cb(null, p);
        }
        nextPartRe.lastIndex = pos;
        var result = nextPartRe.exec(p);
        previous = current;
        current += result[0];
        base = previous + result[1];
        pos = nextPartRe.lastIndex;
        if (knownHard[base] || cache && cache[base] === base) {
          return process.nextTick(LOOP);
        }
        if (cache && Object.prototype.hasOwnProperty.call(cache, base)) {
          return gotResolvedLink(cache[base]);
        }
        return fs2.lstat(base, gotStat);
      }
      function gotStat(err, stat) {
        if (err)
          return cb(err);
        if (!stat.isSymbolicLink()) {
          knownHard[base] = true;
          if (cache)
            cache[base] = base;
          return process.nextTick(LOOP);
        }
        if (!isWindows) {
          var id = stat.dev.toString(32) + ":" + stat.ino.toString(32);
          if (seenLinks.hasOwnProperty(id)) {
            return gotTarget(null, seenLinks[id], base);
          }
        }
        fs2.stat(base, function(err2) {
          if (err2)
            return cb(err2);
          fs2.readlink(base, function(err3, target) {
            if (!isWindows)
              seenLinks[id] = target;
            gotTarget(err3, target);
          });
        });
      }
      function gotTarget(err, target, base2) {
        if (err)
          return cb(err);
        var resolvedLink = pathModule.resolve(previous, target);
        if (cache)
          cache[base2] = resolvedLink;
        gotResolvedLink(resolvedLink);
      }
      function gotResolvedLink(resolvedLink) {
        p = pathModule.resolve(resolvedLink, p.slice(pos));
        start();
      }
    };
  }
});

// node_modules/fs.realpath/index.js
var require_fs2 = __commonJS({
  "node_modules/fs.realpath/index.js"(exports, module2) {
    module2.exports = realpath;
    realpath.realpath = realpath;
    realpath.sync = realpathSync;
    realpath.realpathSync = realpathSync;
    realpath.monkeypatch = monkeypatch;
    realpath.unmonkeypatch = unmonkeypatch;
    var fs2 = require("fs");
    var origRealpath = fs2.realpath;
    var origRealpathSync = fs2.realpathSync;
    var version = process.version;
    var ok = /^v[0-5]\./.test(version);
    var old = require_old();
    function newError(er) {
      return er && er.syscall === "realpath" && (er.code === "ELOOP" || er.code === "ENOMEM" || er.code === "ENAMETOOLONG");
    }
    function realpath(p, cache, cb) {
      if (ok) {
        return origRealpath(p, cache, cb);
      }
      if (typeof cache === "function") {
        cb = cache;
        cache = null;
      }
      origRealpath(p, cache, function(er, result) {
        if (newError(er)) {
          old.realpath(p, cache, cb);
        } else {
          cb(er, result);
        }
      });
    }
    function realpathSync(p, cache) {
      if (ok) {
        return origRealpathSync(p, cache);
      }
      try {
        return origRealpathSync(p, cache);
      } catch (er) {
        if (newError(er)) {
          return old.realpathSync(p, cache);
        } else {
          throw er;
        }
      }
    }
    function monkeypatch() {
      fs2.realpath = realpath;
      fs2.realpathSync = realpathSync;
    }
    function unmonkeypatch() {
      fs2.realpath = origRealpath;
      fs2.realpathSync = origRealpathSync;
    }
  }
});

// node_modules/concat-map/index.js
var require_concat_map = __commonJS({
  "node_modules/concat-map/index.js"(exports, module2) {
    module2.exports = function(xs, fn) {
      var res = [];
      for (var i = 0; i < xs.length; i++) {
        var x = fn(xs[i], i);
        if (isArray(x))
          res.push.apply(res, x);
        else
          res.push(x);
      }
      return res;
    };
    var isArray = Array.isArray || function(xs) {
      return Object.prototype.toString.call(xs) === "[object Array]";
    };
  }
});

// node_modules/balanced-match/index.js
var require_balanced_match = __commonJS({
  "node_modules/balanced-match/index.js"(exports, module2) {
    "use strict";
    module2.exports = balanced;
    function balanced(a, b, str) {
      if (a instanceof RegExp)
        a = maybeMatch(a, str);
      if (b instanceof RegExp)
        b = maybeMatch(b, str);
      var r = range(a, b, str);
      return r && {
        start: r[0],
        end: r[1],
        pre: str.slice(0, r[0]),
        body: str.slice(r[0] + a.length, r[1]),
        post: str.slice(r[1] + b.length)
      };
    }
    function maybeMatch(reg, str) {
      var m = str.match(reg);
      return m ? m[0] : null;
    }
    balanced.range = range;
    function range(a, b, str) {
      var begs, beg, left, right, result;
      var ai = str.indexOf(a);
      var bi = str.indexOf(b, ai + 1);
      var i = ai;
      if (ai >= 0 && bi > 0) {
        if (a === b) {
          return [ai, bi];
        }
        begs = [];
        left = str.length;
        while (i >= 0 && !result) {
          if (i == ai) {
            begs.push(i);
            ai = str.indexOf(a, i + 1);
          } else if (begs.length == 1) {
            result = [begs.pop(), bi];
          } else {
            beg = begs.pop();
            if (beg < left) {
              left = beg;
              right = bi;
            }
            bi = str.indexOf(b, i + 1);
          }
          i = ai < bi && ai >= 0 ? ai : bi;
        }
        if (begs.length) {
          result = [left, right];
        }
      }
      return result;
    }
  }
});

// node_modules/brace-expansion/index.js
var require_brace_expansion = __commonJS({
  "node_modules/brace-expansion/index.js"(exports, module2) {
    var concatMap = require_concat_map();
    var balanced = require_balanced_match();
    module2.exports = expandTop;
    var escSlash = "\0SLASH" + Math.random() + "\0";
    var escOpen = "\0OPEN" + Math.random() + "\0";
    var escClose = "\0CLOSE" + Math.random() + "\0";
    var escComma = "\0COMMA" + Math.random() + "\0";
    var escPeriod = "\0PERIOD" + Math.random() + "\0";
    function numeric(str) {
      return parseInt(str, 10) == str ? parseInt(str, 10) : str.charCodeAt(0);
    }
    function escapeBraces(str) {
      return str.split("\\\\").join(escSlash).split("\\{").join(escOpen).split("\\}").join(escClose).split("\\,").join(escComma).split("\\.").join(escPeriod);
    }
    function unescapeBraces(str) {
      return str.split(escSlash).join("\\").split(escOpen).join("{").split(escClose).join("}").split(escComma).join(",").split(escPeriod).join(".");
    }
    function parseCommaParts(str) {
      if (!str)
        return [""];
      var parts = [];
      var m = balanced("{", "}", str);
      if (!m)
        return str.split(",");
      var pre = m.pre;
      var body = m.body;
      var post = m.post;
      var p = pre.split(",");
      p[p.length - 1] += "{" + body + "}";
      var postParts = parseCommaParts(post);
      if (post.length) {
        p[p.length - 1] += postParts.shift();
        p.push.apply(p, postParts);
      }
      parts.push.apply(parts, p);
      return parts;
    }
    function expandTop(str) {
      if (!str)
        return [];
      if (str.substr(0, 2) === "{}") {
        str = "\\{\\}" + str.substr(2);
      }
      return expand(escapeBraces(str), true).map(unescapeBraces);
    }
    function embrace(str) {
      return "{" + str + "}";
    }
    function isPadded(el) {
      return /^-?0\d/.test(el);
    }
    function lte(i, y) {
      return i <= y;
    }
    function gte(i, y) {
      return i >= y;
    }
    function expand(str, isTop) {
      var expansions = [];
      var m = balanced("{", "}", str);
      if (!m || /\$$/.test(m.pre))
        return [str];
      var isNumericSequence = /^-?\d+\.\.-?\d+(?:\.\.-?\d+)?$/.test(m.body);
      var isAlphaSequence = /^[a-zA-Z]\.\.[a-zA-Z](?:\.\.-?\d+)?$/.test(m.body);
      var isSequence = isNumericSequence || isAlphaSequence;
      var isOptions = m.body.indexOf(",") >= 0;
      if (!isSequence && !isOptions) {
        if (m.post.match(/,.*\}/)) {
          str = m.pre + "{" + m.body + escClose + m.post;
          return expand(str);
        }
        return [str];
      }
      var n;
      if (isSequence) {
        n = m.body.split(/\.\./);
      } else {
        n = parseCommaParts(m.body);
        if (n.length === 1) {
          n = expand(n[0], false).map(embrace);
          if (n.length === 1) {
            var post = m.post.length ? expand(m.post, false) : [""];
            return post.map(function(p) {
              return m.pre + n[0] + p;
            });
          }
        }
      }
      var pre = m.pre;
      var post = m.post.length ? expand(m.post, false) : [""];
      var N;
      if (isSequence) {
        var x = numeric(n[0]);
        var y = numeric(n[1]);
        var width = Math.max(n[0].length, n[1].length);
        var incr = n.length == 3 ? Math.abs(numeric(n[2])) : 1;
        var test = lte;
        var reverse = y < x;
        if (reverse) {
          incr *= -1;
          test = gte;
        }
        var pad = n.some(isPadded);
        N = [];
        for (var i = x; test(i, y); i += incr) {
          var c;
          if (isAlphaSequence) {
            c = String.fromCharCode(i);
            if (c === "\\")
              c = "";
          } else {
            c = String(i);
            if (pad) {
              var need = width - c.length;
              if (need > 0) {
                var z = new Array(need + 1).join("0");
                if (i < 0)
                  c = "-" + z + c.slice(1);
                else
                  c = z + c;
              }
            }
          }
          N.push(c);
        }
      } else {
        N = concatMap(n, function(el) {
          return expand(el, false);
        });
      }
      for (var j = 0; j < N.length; j++) {
        for (var k = 0; k < post.length; k++) {
          var expansion = pre + N[j] + post[k];
          if (!isTop || isSequence || expansion)
            expansions.push(expansion);
        }
      }
      return expansions;
    }
  }
});

// node_modules/minimatch/minimatch.js
var require_minimatch = __commonJS({
  "node_modules/minimatch/minimatch.js"(exports, module2) {
    module2.exports = minimatch;
    minimatch.Minimatch = Minimatch;
    var path2 = { sep: "/" };
    try {
      path2 = require("path");
    } catch (er) {
    }
    var GLOBSTAR = minimatch.GLOBSTAR = Minimatch.GLOBSTAR = {};
    var expand = require_brace_expansion();
    var plTypes = {
      "!": { open: "(?:(?!(?:", close: "))[^/]*?)" },
      "?": { open: "(?:", close: ")?" },
      "+": { open: "(?:", close: ")+" },
      "*": { open: "(?:", close: ")*" },
      "@": { open: "(?:", close: ")" }
    };
    var qmark = "[^/]";
    var star = qmark + "*?";
    var twoStarDot = "(?:(?!(?:\\/|^)(?:\\.{1,2})($|\\/)).)*?";
    var twoStarNoDot = "(?:(?!(?:\\/|^)\\.).)*?";
    var reSpecials = charSet("().*{}+?[]^$\\!");
    function charSet(s) {
      return s.split("").reduce(function(set, c) {
        set[c] = true;
        return set;
      }, {});
    }
    var slashSplit = /\/+/;
    minimatch.filter = filter;
    function filter(pattern, options) {
      options = options || {};
      return function(p, i, list) {
        return minimatch(p, pattern, options);
      };
    }
    function ext(a, b) {
      a = a || {};
      b = b || {};
      var t = {};
      Object.keys(b).forEach(function(k) {
        t[k] = b[k];
      });
      Object.keys(a).forEach(function(k) {
        t[k] = a[k];
      });
      return t;
    }
    minimatch.defaults = function(def) {
      if (!def || !Object.keys(def).length)
        return minimatch;
      var orig = minimatch;
      var m = function minimatch2(p, pattern, options) {
        return orig.minimatch(p, pattern, ext(def, options));
      };
      m.Minimatch = function Minimatch2(pattern, options) {
        return new orig.Minimatch(pattern, ext(def, options));
      };
      return m;
    };
    Minimatch.defaults = function(def) {
      if (!def || !Object.keys(def).length)
        return Minimatch;
      return minimatch.defaults(def).Minimatch;
    };
    function minimatch(p, pattern, options) {
      if (typeof pattern !== "string") {
        throw new TypeError("glob pattern string required");
      }
      if (!options)
        options = {};
      if (!options.nocomment && pattern.charAt(0) === "#") {
        return false;
      }
      if (pattern.trim() === "")
        return p === "";
      return new Minimatch(pattern, options).match(p);
    }
    function Minimatch(pattern, options) {
      if (!(this instanceof Minimatch)) {
        return new Minimatch(pattern, options);
      }
      if (typeof pattern !== "string") {
        throw new TypeError("glob pattern string required");
      }
      if (!options)
        options = {};
      pattern = pattern.trim();
      if (path2.sep !== "/") {
        pattern = pattern.split(path2.sep).join("/");
      }
      this.options = options;
      this.set = [];
      this.pattern = pattern;
      this.regexp = null;
      this.negate = false;
      this.comment = false;
      this.empty = false;
      this.make();
    }
    Minimatch.prototype.debug = function() {
    };
    Minimatch.prototype.make = make;
    function make() {
      if (this._made)
        return;
      var pattern = this.pattern;
      var options = this.options;
      if (!options.nocomment && pattern.charAt(0) === "#") {
        this.comment = true;
        return;
      }
      if (!pattern) {
        this.empty = true;
        return;
      }
      this.parseNegate();
      var set = this.globSet = this.braceExpand();
      if (options.debug)
        this.debug = console.error;
      this.debug(this.pattern, set);
      set = this.globParts = set.map(function(s) {
        return s.split(slashSplit);
      });
      this.debug(this.pattern, set);
      set = set.map(function(s, si, set2) {
        return s.map(this.parse, this);
      }, this);
      this.debug(this.pattern, set);
      set = set.filter(function(s) {
        return s.indexOf(false) === -1;
      });
      this.debug(this.pattern, set);
      this.set = set;
    }
    Minimatch.prototype.parseNegate = parseNegate;
    function parseNegate() {
      var pattern = this.pattern;
      var negate = false;
      var options = this.options;
      var negateOffset = 0;
      if (options.nonegate)
        return;
      for (var i = 0, l = pattern.length; i < l && pattern.charAt(i) === "!"; i++) {
        negate = !negate;
        negateOffset++;
      }
      if (negateOffset)
        this.pattern = pattern.substr(negateOffset);
      this.negate = negate;
    }
    minimatch.braceExpand = function(pattern, options) {
      return braceExpand(pattern, options);
    };
    Minimatch.prototype.braceExpand = braceExpand;
    function braceExpand(pattern, options) {
      if (!options) {
        if (this instanceof Minimatch) {
          options = this.options;
        } else {
          options = {};
        }
      }
      pattern = typeof pattern === "undefined" ? this.pattern : pattern;
      if (typeof pattern === "undefined") {
        throw new TypeError("undefined pattern");
      }
      if (options.nobrace || !pattern.match(/\{.*\}/)) {
        return [pattern];
      }
      return expand(pattern);
    }
    Minimatch.prototype.parse = parse;
    var SUBPARSE = {};
    function parse(pattern, isSub) {
      if (pattern.length > 1024 * 64) {
        throw new TypeError("pattern is too long");
      }
      var options = this.options;
      if (!options.noglobstar && pattern === "**")
        return GLOBSTAR;
      if (pattern === "")
        return "";
      var re = "";
      var hasMagic = !!options.nocase;
      var escaping = false;
      var patternListStack = [];
      var negativeLists = [];
      var stateChar;
      var inClass = false;
      var reClassStart = -1;
      var classStart = -1;
      var patternStart = pattern.charAt(0) === "." ? "" : options.dot ? "(?!(?:^|\\/)\\.{1,2}(?:$|\\/))" : "(?!\\.)";
      var self2 = this;
      function clearStateChar() {
        if (stateChar) {
          switch (stateChar) {
            case "*":
              re += star;
              hasMagic = true;
              break;
            case "?":
              re += qmark;
              hasMagic = true;
              break;
            default:
              re += "\\" + stateChar;
              break;
          }
          self2.debug("clearStateChar %j %j", stateChar, re);
          stateChar = false;
        }
      }
      for (var i = 0, len = pattern.length, c; i < len && (c = pattern.charAt(i)); i++) {
        this.debug("%s	%s %s %j", pattern, i, re, c);
        if (escaping && reSpecials[c]) {
          re += "\\" + c;
          escaping = false;
          continue;
        }
        switch (c) {
          case "/":
            return false;
          case "\\":
            clearStateChar();
            escaping = true;
            continue;
          case "?":
          case "*":
          case "+":
          case "@":
          case "!":
            this.debug("%s	%s %s %j <-- stateChar", pattern, i, re, c);
            if (inClass) {
              this.debug("  in class");
              if (c === "!" && i === classStart + 1)
                c = "^";
              re += c;
              continue;
            }
            self2.debug("call clearStateChar %j", stateChar);
            clearStateChar();
            stateChar = c;
            if (options.noext)
              clearStateChar();
            continue;
          case "(":
            if (inClass) {
              re += "(";
              continue;
            }
            if (!stateChar) {
              re += "\\(";
              continue;
            }
            patternListStack.push({
              type: stateChar,
              start: i - 1,
              reStart: re.length,
              open: plTypes[stateChar].open,
              close: plTypes[stateChar].close
            });
            re += stateChar === "!" ? "(?:(?!(?:" : "(?:";
            this.debug("plType %j %j", stateChar, re);
            stateChar = false;
            continue;
          case ")":
            if (inClass || !patternListStack.length) {
              re += "\\)";
              continue;
            }
            clearStateChar();
            hasMagic = true;
            var pl = patternListStack.pop();
            re += pl.close;
            if (pl.type === "!") {
              negativeLists.push(pl);
            }
            pl.reEnd = re.length;
            continue;
          case "|":
            if (inClass || !patternListStack.length || escaping) {
              re += "\\|";
              escaping = false;
              continue;
            }
            clearStateChar();
            re += "|";
            continue;
          case "[":
            clearStateChar();
            if (inClass) {
              re += "\\" + c;
              continue;
            }
            inClass = true;
            classStart = i;
            reClassStart = re.length;
            re += c;
            continue;
          case "]":
            if (i === classStart + 1 || !inClass) {
              re += "\\" + c;
              escaping = false;
              continue;
            }
            if (inClass) {
              var cs = pattern.substring(classStart + 1, i);
              try {
                RegExp("[" + cs + "]");
              } catch (er) {
                var sp = this.parse(cs, SUBPARSE);
                re = re.substr(0, reClassStart) + "\\[" + sp[0] + "\\]";
                hasMagic = hasMagic || sp[1];
                inClass = false;
                continue;
              }
            }
            hasMagic = true;
            inClass = false;
            re += c;
            continue;
          default:
            clearStateChar();
            if (escaping) {
              escaping = false;
            } else if (reSpecials[c] && !(c === "^" && inClass)) {
              re += "\\";
            }
            re += c;
        }
      }
      if (inClass) {
        cs = pattern.substr(classStart + 1);
        sp = this.parse(cs, SUBPARSE);
        re = re.substr(0, reClassStart) + "\\[" + sp[0];
        hasMagic = hasMagic || sp[1];
      }
      for (pl = patternListStack.pop(); pl; pl = patternListStack.pop()) {
        var tail = re.slice(pl.reStart + pl.open.length);
        this.debug("setting tail", re, pl);
        tail = tail.replace(/((?:\\{2}){0,64})(\\?)\|/g, function(_, $1, $2) {
          if (!$2) {
            $2 = "\\";
          }
          return $1 + $1 + $2 + "|";
        });
        this.debug("tail=%j\n   %s", tail, tail, pl, re);
        var t = pl.type === "*" ? star : pl.type === "?" ? qmark : "\\" + pl.type;
        hasMagic = true;
        re = re.slice(0, pl.reStart) + t + "\\(" + tail;
      }
      clearStateChar();
      if (escaping) {
        re += "\\\\";
      }
      var addPatternStart = false;
      switch (re.charAt(0)) {
        case ".":
        case "[":
        case "(":
          addPatternStart = true;
      }
      for (var n = negativeLists.length - 1; n > -1; n--) {
        var nl = negativeLists[n];
        var nlBefore = re.slice(0, nl.reStart);
        var nlFirst = re.slice(nl.reStart, nl.reEnd - 8);
        var nlLast = re.slice(nl.reEnd - 8, nl.reEnd);
        var nlAfter = re.slice(nl.reEnd);
        nlLast += nlAfter;
        var openParensBefore = nlBefore.split("(").length - 1;
        var cleanAfter = nlAfter;
        for (i = 0; i < openParensBefore; i++) {
          cleanAfter = cleanAfter.replace(/\)[+*?]?/, "");
        }
        nlAfter = cleanAfter;
        var dollar = "";
        if (nlAfter === "" && isSub !== SUBPARSE) {
          dollar = "$";
        }
        var newRe = nlBefore + nlFirst + nlAfter + dollar + nlLast;
        re = newRe;
      }
      if (re !== "" && hasMagic) {
        re = "(?=.)" + re;
      }
      if (addPatternStart) {
        re = patternStart + re;
      }
      if (isSub === SUBPARSE) {
        return [re, hasMagic];
      }
      if (!hasMagic) {
        return globUnescape(pattern);
      }
      var flags = options.nocase ? "i" : "";
      try {
        var regExp = new RegExp("^" + re + "$", flags);
      } catch (er) {
        return new RegExp("$.");
      }
      regExp._glob = pattern;
      regExp._src = re;
      return regExp;
    }
    minimatch.makeRe = function(pattern, options) {
      return new Minimatch(pattern, options || {}).makeRe();
    };
    Minimatch.prototype.makeRe = makeRe;
    function makeRe() {
      if (this.regexp || this.regexp === false)
        return this.regexp;
      var set = this.set;
      if (!set.length) {
        this.regexp = false;
        return this.regexp;
      }
      var options = this.options;
      var twoStar = options.noglobstar ? star : options.dot ? twoStarDot : twoStarNoDot;
      var flags = options.nocase ? "i" : "";
      var re = set.map(function(pattern) {
        return pattern.map(function(p) {
          return p === GLOBSTAR ? twoStar : typeof p === "string" ? regExpEscape(p) : p._src;
        }).join("\\/");
      }).join("|");
      re = "^(?:" + re + ")$";
      if (this.negate)
        re = "^(?!" + re + ").*$";
      try {
        this.regexp = new RegExp(re, flags);
      } catch (ex) {
        this.regexp = false;
      }
      return this.regexp;
    }
    minimatch.match = function(list, pattern, options) {
      options = options || {};
      var mm = new Minimatch(pattern, options);
      list = list.filter(function(f) {
        return mm.match(f);
      });
      if (mm.options.nonull && !list.length) {
        list.push(pattern);
      }
      return list;
    };
    Minimatch.prototype.match = match;
    function match(f, partial) {
      this.debug("match", f, this.pattern);
      if (this.comment)
        return false;
      if (this.empty)
        return f === "";
      if (f === "/" && partial)
        return true;
      var options = this.options;
      if (path2.sep !== "/") {
        f = f.split(path2.sep).join("/");
      }
      f = f.split(slashSplit);
      this.debug(this.pattern, "split", f);
      var set = this.set;
      this.debug(this.pattern, "set", set);
      var filename;
      var i;
      for (i = f.length - 1; i >= 0; i--) {
        filename = f[i];
        if (filename)
          break;
      }
      for (i = 0; i < set.length; i++) {
        var pattern = set[i];
        var file = f;
        if (options.matchBase && pattern.length === 1) {
          file = [filename];
        }
        var hit = this.matchOne(file, pattern, partial);
        if (hit) {
          if (options.flipNegate)
            return true;
          return !this.negate;
        }
      }
      if (options.flipNegate)
        return false;
      return this.negate;
    }
    Minimatch.prototype.matchOne = function(file, pattern, partial) {
      var options = this.options;
      this.debug("matchOne", { "this": this, file, pattern });
      this.debug("matchOne", file.length, pattern.length);
      for (var fi = 0, pi = 0, fl = file.length, pl = pattern.length; fi < fl && pi < pl; fi++, pi++) {
        this.debug("matchOne loop");
        var p = pattern[pi];
        var f = file[fi];
        this.debug(pattern, p, f);
        if (p === false)
          return false;
        if (p === GLOBSTAR) {
          this.debug("GLOBSTAR", [pattern, p, f]);
          var fr = fi;
          var pr = pi + 1;
          if (pr === pl) {
            this.debug("** at the end");
            for (; fi < fl; fi++) {
              if (file[fi] === "." || file[fi] === ".." || !options.dot && file[fi].charAt(0) === ".")
                return false;
            }
            return true;
          }
          while (fr < fl) {
            var swallowee = file[fr];
            this.debug("\nglobstar while", file, fr, pattern, pr, swallowee);
            if (this.matchOne(file.slice(fr), pattern.slice(pr), partial)) {
              this.debug("globstar found match!", fr, fl, swallowee);
              return true;
            } else {
              if (swallowee === "." || swallowee === ".." || !options.dot && swallowee.charAt(0) === ".") {
                this.debug("dot detected!", file, fr, pattern, pr);
                break;
              }
              this.debug("globstar swallow a segment, and continue");
              fr++;
            }
          }
          if (partial) {
            this.debug("\n>>> no match, partial?", file, fr, pattern, pr);
            if (fr === fl)
              return true;
          }
          return false;
        }
        var hit;
        if (typeof p === "string") {
          if (options.nocase) {
            hit = f.toLowerCase() === p.toLowerCase();
          } else {
            hit = f === p;
          }
          this.debug("string match", p, f, hit);
        } else {
          hit = f.match(p);
          this.debug("pattern match", p, f, hit);
        }
        if (!hit)
          return false;
      }
      if (fi === fl && pi === pl) {
        return true;
      } else if (fi === fl) {
        return partial;
      } else if (pi === pl) {
        var emptyFileEnd = fi === fl - 1 && file[fi] === "";
        return emptyFileEnd;
      }
      throw new Error("wtf?");
    };
    function globUnescape(s) {
      return s.replace(/\\(.)/g, "$1");
    }
    function regExpEscape(s) {
      return s.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
    }
  }
});

// node_modules/inherits/inherits_browser.js
var require_inherits_browser = __commonJS({
  "node_modules/inherits/inherits_browser.js"(exports, module2) {
    if (typeof Object.create === "function") {
      module2.exports = function inherits(ctor, superCtor) {
        if (superCtor) {
          ctor.super_ = superCtor;
          ctor.prototype = Object.create(superCtor.prototype, {
            constructor: {
              value: ctor,
              enumerable: false,
              writable: true,
              configurable: true
            }
          });
        }
      };
    } else {
      module2.exports = function inherits(ctor, superCtor) {
        if (superCtor) {
          ctor.super_ = superCtor;
          var TempCtor = function() {
          };
          TempCtor.prototype = superCtor.prototype;
          ctor.prototype = new TempCtor();
          ctor.prototype.constructor = ctor;
        }
      };
    }
  }
});

// node_modules/inherits/inherits.js
var require_inherits = __commonJS({
  "node_modules/inherits/inherits.js"(exports, module2) {
    try {
      util = require("util");
      if (typeof util.inherits !== "function")
        throw "";
      module2.exports = util.inherits;
    } catch (e) {
      module2.exports = require_inherits_browser();
    }
    var util;
  }
});

// node_modules/path-is-absolute/index.js
var require_path_is_absolute = __commonJS({
  "node_modules/path-is-absolute/index.js"(exports, module2) {
    "use strict";
    function posix(path2) {
      return path2.charAt(0) === "/";
    }
    function win32(path2) {
      var splitDeviceRe = /^([a-zA-Z]:|[\\\/]{2}[^\\\/]+[\\\/]+[^\\\/]+)?([\\\/])?([\s\S]*?)$/;
      var result = splitDeviceRe.exec(path2);
      var device = result[1] || "";
      var isUnc = Boolean(device && device.charAt(1) !== ":");
      return Boolean(result[2] || isUnc);
    }
    module2.exports = process.platform === "win32" ? win32 : posix;
    module2.exports.posix = posix;
    module2.exports.win32 = win32;
  }
});

// node_modules/glob/common.js
var require_common = __commonJS({
  "node_modules/glob/common.js"(exports) {
    exports.setopts = setopts;
    exports.ownProp = ownProp;
    exports.makeAbs = makeAbs;
    exports.finish = finish;
    exports.mark = mark;
    exports.isIgnored = isIgnored;
    exports.childrenIgnored = childrenIgnored;
    function ownProp(obj, field) {
      return Object.prototype.hasOwnProperty.call(obj, field);
    }
    var fs2 = require("fs");
    var path2 = require("path");
    var minimatch = require_minimatch();
    var isAbsolute = require_path_is_absolute();
    var Minimatch = minimatch.Minimatch;
    function alphasort(a, b) {
      return a.localeCompare(b, "en");
    }
    function setupIgnores(self2, options) {
      self2.ignore = options.ignore || [];
      if (!Array.isArray(self2.ignore))
        self2.ignore = [self2.ignore];
      if (self2.ignore.length) {
        self2.ignore = self2.ignore.map(ignoreMap);
      }
    }
    function ignoreMap(pattern) {
      var gmatcher = null;
      if (pattern.slice(-3) === "/**") {
        var gpattern = pattern.replace(/(\/\*\*)+$/, "");
        gmatcher = new Minimatch(gpattern, { dot: true });
      }
      return {
        matcher: new Minimatch(pattern, { dot: true }),
        gmatcher
      };
    }
    function setopts(self2, pattern, options) {
      if (!options)
        options = {};
      if (options.matchBase && pattern.indexOf("/") === -1) {
        if (options.noglobstar) {
          throw new Error("base matching requires globstar");
        }
        pattern = "**/" + pattern;
      }
      self2.silent = !!options.silent;
      self2.pattern = pattern;
      self2.strict = options.strict !== false;
      self2.realpath = !!options.realpath;
      self2.realpathCache = options.realpathCache || Object.create(null);
      self2.follow = !!options.follow;
      self2.dot = !!options.dot;
      self2.mark = !!options.mark;
      self2.nodir = !!options.nodir;
      if (self2.nodir)
        self2.mark = true;
      self2.sync = !!options.sync;
      self2.nounique = !!options.nounique;
      self2.nonull = !!options.nonull;
      self2.nosort = !!options.nosort;
      self2.nocase = !!options.nocase;
      self2.stat = !!options.stat;
      self2.noprocess = !!options.noprocess;
      self2.absolute = !!options.absolute;
      self2.fs = options.fs || fs2;
      self2.maxLength = options.maxLength || Infinity;
      self2.cache = options.cache || Object.create(null);
      self2.statCache = options.statCache || Object.create(null);
      self2.symlinks = options.symlinks || Object.create(null);
      setupIgnores(self2, options);
      self2.changedCwd = false;
      var cwd = process.cwd();
      if (!ownProp(options, "cwd"))
        self2.cwd = cwd;
      else {
        self2.cwd = path2.resolve(options.cwd);
        self2.changedCwd = self2.cwd !== cwd;
      }
      self2.root = options.root || path2.resolve(self2.cwd, "/");
      self2.root = path2.resolve(self2.root);
      if (process.platform === "win32")
        self2.root = self2.root.replace(/\\/g, "/");
      self2.cwdAbs = isAbsolute(self2.cwd) ? self2.cwd : makeAbs(self2, self2.cwd);
      if (process.platform === "win32")
        self2.cwdAbs = self2.cwdAbs.replace(/\\/g, "/");
      self2.nomount = !!options.nomount;
      options.nonegate = true;
      options.nocomment = true;
      self2.minimatch = new Minimatch(pattern, options);
      self2.options = self2.minimatch.options;
    }
    function finish(self2) {
      var nou = self2.nounique;
      var all = nou ? [] : Object.create(null);
      for (var i = 0, l = self2.matches.length; i < l; i++) {
        var matches = self2.matches[i];
        if (!matches || Object.keys(matches).length === 0) {
          if (self2.nonull) {
            var literal = self2.minimatch.globSet[i];
            if (nou)
              all.push(literal);
            else
              all[literal] = true;
          }
        } else {
          var m = Object.keys(matches);
          if (nou)
            all.push.apply(all, m);
          else
            m.forEach(function(m2) {
              all[m2] = true;
            });
        }
      }
      if (!nou)
        all = Object.keys(all);
      if (!self2.nosort)
        all = all.sort(alphasort);
      if (self2.mark) {
        for (var i = 0; i < all.length; i++) {
          all[i] = self2._mark(all[i]);
        }
        if (self2.nodir) {
          all = all.filter(function(e) {
            var notDir = !/\/$/.test(e);
            var c = self2.cache[e] || self2.cache[makeAbs(self2, e)];
            if (notDir && c)
              notDir = c !== "DIR" && !Array.isArray(c);
            return notDir;
          });
        }
      }
      if (self2.ignore.length)
        all = all.filter(function(m2) {
          return !isIgnored(self2, m2);
        });
      self2.found = all;
    }
    function mark(self2, p) {
      var abs = makeAbs(self2, p);
      var c = self2.cache[abs];
      var m = p;
      if (c) {
        var isDir = c === "DIR" || Array.isArray(c);
        var slash = p.slice(-1) === "/";
        if (isDir && !slash)
          m += "/";
        else if (!isDir && slash)
          m = m.slice(0, -1);
        if (m !== p) {
          var mabs = makeAbs(self2, m);
          self2.statCache[mabs] = self2.statCache[abs];
          self2.cache[mabs] = self2.cache[abs];
        }
      }
      return m;
    }
    function makeAbs(self2, f) {
      var abs = f;
      if (f.charAt(0) === "/") {
        abs = path2.join(self2.root, f);
      } else if (isAbsolute(f) || f === "") {
        abs = f;
      } else if (self2.changedCwd) {
        abs = path2.resolve(self2.cwd, f);
      } else {
        abs = path2.resolve(f);
      }
      if (process.platform === "win32")
        abs = abs.replace(/\\/g, "/");
      return abs;
    }
    function isIgnored(self2, path3) {
      if (!self2.ignore.length)
        return false;
      return self2.ignore.some(function(item) {
        return item.matcher.match(path3) || !!(item.gmatcher && item.gmatcher.match(path3));
      });
    }
    function childrenIgnored(self2, path3) {
      if (!self2.ignore.length)
        return false;
      return self2.ignore.some(function(item) {
        return !!(item.gmatcher && item.gmatcher.match(path3));
      });
    }
  }
});

// node_modules/glob/sync.js
var require_sync = __commonJS({
  "node_modules/glob/sync.js"(exports, module2) {
    module2.exports = globSync;
    globSync.GlobSync = GlobSync;
    var rp = require_fs2();
    var minimatch = require_minimatch();
    var Minimatch = minimatch.Minimatch;
    var Glob = require_glob().Glob;
    var util = require("util");
    var path2 = require("path");
    var assert = require("assert");
    var isAbsolute = require_path_is_absolute();
    var common = require_common();
    var setopts = common.setopts;
    var ownProp = common.ownProp;
    var childrenIgnored = common.childrenIgnored;
    var isIgnored = common.isIgnored;
    function globSync(pattern, options) {
      if (typeof options === "function" || arguments.length === 3)
        throw new TypeError("callback provided to sync glob\nSee: https://github.com/isaacs/node-glob/issues/167");
      return new GlobSync(pattern, options).found;
    }
    function GlobSync(pattern, options) {
      if (!pattern)
        throw new Error("must provide pattern");
      if (typeof options === "function" || arguments.length === 3)
        throw new TypeError("callback provided to sync glob\nSee: https://github.com/isaacs/node-glob/issues/167");
      if (!(this instanceof GlobSync))
        return new GlobSync(pattern, options);
      setopts(this, pattern, options);
      if (this.noprocess)
        return this;
      var n = this.minimatch.set.length;
      this.matches = new Array(n);
      for (var i = 0; i < n; i++) {
        this._process(this.minimatch.set[i], i, false);
      }
      this._finish();
    }
    GlobSync.prototype._finish = function() {
      assert(this instanceof GlobSync);
      if (this.realpath) {
        var self2 = this;
        this.matches.forEach(function(matchset, index) {
          var set = self2.matches[index] = Object.create(null);
          for (var p in matchset) {
            try {
              p = self2._makeAbs(p);
              var real = rp.realpathSync(p, self2.realpathCache);
              set[real] = true;
            } catch (er) {
              if (er.syscall === "stat")
                set[self2._makeAbs(p)] = true;
              else
                throw er;
            }
          }
        });
      }
      common.finish(this);
    };
    GlobSync.prototype._process = function(pattern, index, inGlobStar) {
      assert(this instanceof GlobSync);
      var n = 0;
      while (typeof pattern[n] === "string") {
        n++;
      }
      var prefix;
      switch (n) {
        case pattern.length:
          this._processSimple(pattern.join("/"), index);
          return;
        case 0:
          prefix = null;
          break;
        default:
          prefix = pattern.slice(0, n).join("/");
          break;
      }
      var remain = pattern.slice(n);
      var read;
      if (prefix === null)
        read = ".";
      else if (isAbsolute(prefix) || isAbsolute(pattern.join("/"))) {
        if (!prefix || !isAbsolute(prefix))
          prefix = "/" + prefix;
        read = prefix;
      } else
        read = prefix;
      var abs = this._makeAbs(read);
      if (childrenIgnored(this, read))
        return;
      var isGlobStar = remain[0] === minimatch.GLOBSTAR;
      if (isGlobStar)
        this._processGlobStar(prefix, read, abs, remain, index, inGlobStar);
      else
        this._processReaddir(prefix, read, abs, remain, index, inGlobStar);
    };
    GlobSync.prototype._processReaddir = function(prefix, read, abs, remain, index, inGlobStar) {
      var entries = this._readdir(abs, inGlobStar);
      if (!entries)
        return;
      var pn = remain[0];
      var negate = !!this.minimatch.negate;
      var rawGlob = pn._glob;
      var dotOk = this.dot || rawGlob.charAt(0) === ".";
      var matchedEntries = [];
      for (var i = 0; i < entries.length; i++) {
        var e = entries[i];
        if (e.charAt(0) !== "." || dotOk) {
          var m;
          if (negate && !prefix) {
            m = !e.match(pn);
          } else {
            m = e.match(pn);
          }
          if (m)
            matchedEntries.push(e);
        }
      }
      var len = matchedEntries.length;
      if (len === 0)
        return;
      if (remain.length === 1 && !this.mark && !this.stat) {
        if (!this.matches[index])
          this.matches[index] = Object.create(null);
        for (var i = 0; i < len; i++) {
          var e = matchedEntries[i];
          if (prefix) {
            if (prefix.slice(-1) !== "/")
              e = prefix + "/" + e;
            else
              e = prefix + e;
          }
          if (e.charAt(0) === "/" && !this.nomount) {
            e = path2.join(this.root, e);
          }
          this._emitMatch(index, e);
        }
        return;
      }
      remain.shift();
      for (var i = 0; i < len; i++) {
        var e = matchedEntries[i];
        var newPattern;
        if (prefix)
          newPattern = [prefix, e];
        else
          newPattern = [e];
        this._process(newPattern.concat(remain), index, inGlobStar);
      }
    };
    GlobSync.prototype._emitMatch = function(index, e) {
      if (isIgnored(this, e))
        return;
      var abs = this._makeAbs(e);
      if (this.mark)
        e = this._mark(e);
      if (this.absolute) {
        e = abs;
      }
      if (this.matches[index][e])
        return;
      if (this.nodir) {
        var c = this.cache[abs];
        if (c === "DIR" || Array.isArray(c))
          return;
      }
      this.matches[index][e] = true;
      if (this.stat)
        this._stat(e);
    };
    GlobSync.prototype._readdirInGlobStar = function(abs) {
      if (this.follow)
        return this._readdir(abs, false);
      var entries;
      var lstat;
      var stat;
      try {
        lstat = this.fs.lstatSync(abs);
      } catch (er) {
        if (er.code === "ENOENT") {
          return null;
        }
      }
      var isSym = lstat && lstat.isSymbolicLink();
      this.symlinks[abs] = isSym;
      if (!isSym && lstat && !lstat.isDirectory())
        this.cache[abs] = "FILE";
      else
        entries = this._readdir(abs, false);
      return entries;
    };
    GlobSync.prototype._readdir = function(abs, inGlobStar) {
      var entries;
      if (inGlobStar && !ownProp(this.symlinks, abs))
        return this._readdirInGlobStar(abs);
      if (ownProp(this.cache, abs)) {
        var c = this.cache[abs];
        if (!c || c === "FILE")
          return null;
        if (Array.isArray(c))
          return c;
      }
      try {
        return this._readdirEntries(abs, this.fs.readdirSync(abs));
      } catch (er) {
        this._readdirError(abs, er);
        return null;
      }
    };
    GlobSync.prototype._readdirEntries = function(abs, entries) {
      if (!this.mark && !this.stat) {
        for (var i = 0; i < entries.length; i++) {
          var e = entries[i];
          if (abs === "/")
            e = abs + e;
          else
            e = abs + "/" + e;
          this.cache[e] = true;
        }
      }
      this.cache[abs] = entries;
      return entries;
    };
    GlobSync.prototype._readdirError = function(f, er) {
      switch (er.code) {
        case "ENOTSUP":
        case "ENOTDIR":
          var abs = this._makeAbs(f);
          this.cache[abs] = "FILE";
          if (abs === this.cwdAbs) {
            var error = new Error(er.code + " invalid cwd " + this.cwd);
            error.path = this.cwd;
            error.code = er.code;
            throw error;
          }
          break;
        case "ENOENT":
        case "ELOOP":
        case "ENAMETOOLONG":
        case "UNKNOWN":
          this.cache[this._makeAbs(f)] = false;
          break;
        default:
          this.cache[this._makeAbs(f)] = false;
          if (this.strict)
            throw er;
          if (!this.silent)
            console.error("glob error", er);
          break;
      }
    };
    GlobSync.prototype._processGlobStar = function(prefix, read, abs, remain, index, inGlobStar) {
      var entries = this._readdir(abs, inGlobStar);
      if (!entries)
        return;
      var remainWithoutGlobStar = remain.slice(1);
      var gspref = prefix ? [prefix] : [];
      var noGlobStar = gspref.concat(remainWithoutGlobStar);
      this._process(noGlobStar, index, false);
      var len = entries.length;
      var isSym = this.symlinks[abs];
      if (isSym && inGlobStar)
        return;
      for (var i = 0; i < len; i++) {
        var e = entries[i];
        if (e.charAt(0) === "." && !this.dot)
          continue;
        var instead = gspref.concat(entries[i], remainWithoutGlobStar);
        this._process(instead, index, true);
        var below = gspref.concat(entries[i], remain);
        this._process(below, index, true);
      }
    };
    GlobSync.prototype._processSimple = function(prefix, index) {
      var exists = this._stat(prefix);
      if (!this.matches[index])
        this.matches[index] = Object.create(null);
      if (!exists)
        return;
      if (prefix && isAbsolute(prefix) && !this.nomount) {
        var trail = /[\/\\]$/.test(prefix);
        if (prefix.charAt(0) === "/") {
          prefix = path2.join(this.root, prefix);
        } else {
          prefix = path2.resolve(this.root, prefix);
          if (trail)
            prefix += "/";
        }
      }
      if (process.platform === "win32")
        prefix = prefix.replace(/\\/g, "/");
      this._emitMatch(index, prefix);
    };
    GlobSync.prototype._stat = function(f) {
      var abs = this._makeAbs(f);
      var needDir = f.slice(-1) === "/";
      if (f.length > this.maxLength)
        return false;
      if (!this.stat && ownProp(this.cache, abs)) {
        var c = this.cache[abs];
        if (Array.isArray(c))
          c = "DIR";
        if (!needDir || c === "DIR")
          return c;
        if (needDir && c === "FILE")
          return false;
      }
      var exists;
      var stat = this.statCache[abs];
      if (!stat) {
        var lstat;
        try {
          lstat = this.fs.lstatSync(abs);
        } catch (er) {
          if (er && (er.code === "ENOENT" || er.code === "ENOTDIR")) {
            this.statCache[abs] = false;
            return false;
          }
        }
        if (lstat && lstat.isSymbolicLink()) {
          try {
            stat = this.fs.statSync(abs);
          } catch (er) {
            stat = lstat;
          }
        } else {
          stat = lstat;
        }
      }
      this.statCache[abs] = stat;
      var c = true;
      if (stat)
        c = stat.isDirectory() ? "DIR" : "FILE";
      this.cache[abs] = this.cache[abs] || c;
      if (needDir && c === "FILE")
        return false;
      return c;
    };
    GlobSync.prototype._mark = function(p) {
      return common.mark(this, p);
    };
    GlobSync.prototype._makeAbs = function(f) {
      return common.makeAbs(this, f);
    };
  }
});

// node_modules/wrappy/wrappy.js
var require_wrappy = __commonJS({
  "node_modules/wrappy/wrappy.js"(exports, module2) {
    module2.exports = wrappy;
    function wrappy(fn, cb) {
      if (fn && cb)
        return wrappy(fn)(cb);
      if (typeof fn !== "function")
        throw new TypeError("need wrapper function");
      Object.keys(fn).forEach(function(k) {
        wrapper[k] = fn[k];
      });
      return wrapper;
      function wrapper() {
        var args = new Array(arguments.length);
        for (var i = 0; i < args.length; i++) {
          args[i] = arguments[i];
        }
        var ret = fn.apply(this, args);
        var cb2 = args[args.length - 1];
        if (typeof ret === "function" && ret !== cb2) {
          Object.keys(cb2).forEach(function(k) {
            ret[k] = cb2[k];
          });
        }
        return ret;
      }
    }
  }
});

// node_modules/once/once.js
var require_once = __commonJS({
  "node_modules/once/once.js"(exports, module2) {
    var wrappy = require_wrappy();
    module2.exports = wrappy(once);
    module2.exports.strict = wrappy(onceStrict);
    once.proto = once(function() {
      Object.defineProperty(Function.prototype, "once", {
        value: function() {
          return once(this);
        },
        configurable: true
      });
      Object.defineProperty(Function.prototype, "onceStrict", {
        value: function() {
          return onceStrict(this);
        },
        configurable: true
      });
    });
    function once(fn) {
      var f = function() {
        if (f.called)
          return f.value;
        f.called = true;
        return f.value = fn.apply(this, arguments);
      };
      f.called = false;
      return f;
    }
    function onceStrict(fn) {
      var f = function() {
        if (f.called)
          throw new Error(f.onceError);
        f.called = true;
        return f.value = fn.apply(this, arguments);
      };
      var name = fn.name || "Function wrapped with `once`";
      f.onceError = name + " shouldn't be called more than once";
      f.called = false;
      return f;
    }
  }
});

// node_modules/inflight/inflight.js
var require_inflight = __commonJS({
  "node_modules/inflight/inflight.js"(exports, module2) {
    var wrappy = require_wrappy();
    var reqs = Object.create(null);
    var once = require_once();
    module2.exports = wrappy(inflight);
    function inflight(key, cb) {
      if (reqs[key]) {
        reqs[key].push(cb);
        return null;
      } else {
        reqs[key] = [cb];
        return makeres(key);
      }
    }
    function makeres(key) {
      return once(function RES() {
        var cbs = reqs[key];
        var len = cbs.length;
        var args = slice(arguments);
        try {
          for (var i = 0; i < len; i++) {
            cbs[i].apply(null, args);
          }
        } finally {
          if (cbs.length > len) {
            cbs.splice(0, len);
            process.nextTick(function() {
              RES.apply(null, args);
            });
          } else {
            delete reqs[key];
          }
        }
      });
    }
    function slice(args) {
      var length = args.length;
      var array = [];
      for (var i = 0; i < length; i++)
        array[i] = args[i];
      return array;
    }
  }
});

// node_modules/glob/glob.js
var require_glob = __commonJS({
  "node_modules/glob/glob.js"(exports, module2) {
    module2.exports = glob;
    var rp = require_fs2();
    var minimatch = require_minimatch();
    var Minimatch = minimatch.Minimatch;
    var inherits = require_inherits();
    var EE = require("events").EventEmitter;
    var path2 = require("path");
    var assert = require("assert");
    var isAbsolute = require_path_is_absolute();
    var globSync = require_sync();
    var common = require_common();
    var setopts = common.setopts;
    var ownProp = common.ownProp;
    var inflight = require_inflight();
    var util = require("util");
    var childrenIgnored = common.childrenIgnored;
    var isIgnored = common.isIgnored;
    var once = require_once();
    function glob(pattern, options, cb) {
      if (typeof options === "function")
        cb = options, options = {};
      if (!options)
        options = {};
      if (options.sync) {
        if (cb)
          throw new TypeError("callback provided to sync glob");
        return globSync(pattern, options);
      }
      return new Glob(pattern, options, cb);
    }
    glob.sync = globSync;
    var GlobSync = glob.GlobSync = globSync.GlobSync;
    glob.glob = glob;
    function extend(origin, add) {
      if (add === null || typeof add !== "object") {
        return origin;
      }
      var keys = Object.keys(add);
      var i = keys.length;
      while (i--) {
        origin[keys[i]] = add[keys[i]];
      }
      return origin;
    }
    glob.hasMagic = function(pattern, options_) {
      var options = extend({}, options_);
      options.noprocess = true;
      var g = new Glob(pattern, options);
      var set = g.minimatch.set;
      if (!pattern)
        return false;
      if (set.length > 1)
        return true;
      for (var j = 0; j < set[0].length; j++) {
        if (typeof set[0][j] !== "string")
          return true;
      }
      return false;
    };
    glob.Glob = Glob;
    inherits(Glob, EE);
    function Glob(pattern, options, cb) {
      if (typeof options === "function") {
        cb = options;
        options = null;
      }
      if (options && options.sync) {
        if (cb)
          throw new TypeError("callback provided to sync glob");
        return new GlobSync(pattern, options);
      }
      if (!(this instanceof Glob))
        return new Glob(pattern, options, cb);
      setopts(this, pattern, options);
      this._didRealPath = false;
      var n = this.minimatch.set.length;
      this.matches = new Array(n);
      if (typeof cb === "function") {
        cb = once(cb);
        this.on("error", cb);
        this.on("end", function(matches) {
          cb(null, matches);
        });
      }
      var self2 = this;
      this._processing = 0;
      this._emitQueue = [];
      this._processQueue = [];
      this.paused = false;
      if (this.noprocess)
        return this;
      if (n === 0)
        return done();
      var sync = true;
      for (var i = 0; i < n; i++) {
        this._process(this.minimatch.set[i], i, false, done);
      }
      sync = false;
      function done() {
        --self2._processing;
        if (self2._processing <= 0) {
          if (sync) {
            process.nextTick(function() {
              self2._finish();
            });
          } else {
            self2._finish();
          }
        }
      }
    }
    Glob.prototype._finish = function() {
      assert(this instanceof Glob);
      if (this.aborted)
        return;
      if (this.realpath && !this._didRealpath)
        return this._realpath();
      common.finish(this);
      this.emit("end", this.found);
    };
    Glob.prototype._realpath = function() {
      if (this._didRealpath)
        return;
      this._didRealpath = true;
      var n = this.matches.length;
      if (n === 0)
        return this._finish();
      var self2 = this;
      for (var i = 0; i < this.matches.length; i++)
        this._realpathSet(i, next);
      function next() {
        if (--n === 0)
          self2._finish();
      }
    };
    Glob.prototype._realpathSet = function(index, cb) {
      var matchset = this.matches[index];
      if (!matchset)
        return cb();
      var found = Object.keys(matchset);
      var self2 = this;
      var n = found.length;
      if (n === 0)
        return cb();
      var set = this.matches[index] = Object.create(null);
      found.forEach(function(p, i) {
        p = self2._makeAbs(p);
        rp.realpath(p, self2.realpathCache, function(er, real) {
          if (!er)
            set[real] = true;
          else if (er.syscall === "stat")
            set[p] = true;
          else
            self2.emit("error", er);
          if (--n === 0) {
            self2.matches[index] = set;
            cb();
          }
        });
      });
    };
    Glob.prototype._mark = function(p) {
      return common.mark(this, p);
    };
    Glob.prototype._makeAbs = function(f) {
      return common.makeAbs(this, f);
    };
    Glob.prototype.abort = function() {
      this.aborted = true;
      this.emit("abort");
    };
    Glob.prototype.pause = function() {
      if (!this.paused) {
        this.paused = true;
        this.emit("pause");
      }
    };
    Glob.prototype.resume = function() {
      if (this.paused) {
        this.emit("resume");
        this.paused = false;
        if (this._emitQueue.length) {
          var eq = this._emitQueue.slice(0);
          this._emitQueue.length = 0;
          for (var i = 0; i < eq.length; i++) {
            var e = eq[i];
            this._emitMatch(e[0], e[1]);
          }
        }
        if (this._processQueue.length) {
          var pq = this._processQueue.slice(0);
          this._processQueue.length = 0;
          for (var i = 0; i < pq.length; i++) {
            var p = pq[i];
            this._processing--;
            this._process(p[0], p[1], p[2], p[3]);
          }
        }
      }
    };
    Glob.prototype._process = function(pattern, index, inGlobStar, cb) {
      assert(this instanceof Glob);
      assert(typeof cb === "function");
      if (this.aborted)
        return;
      this._processing++;
      if (this.paused) {
        this._processQueue.push([pattern, index, inGlobStar, cb]);
        return;
      }
      var n = 0;
      while (typeof pattern[n] === "string") {
        n++;
      }
      var prefix;
      switch (n) {
        case pattern.length:
          this._processSimple(pattern.join("/"), index, cb);
          return;
        case 0:
          prefix = null;
          break;
        default:
          prefix = pattern.slice(0, n).join("/");
          break;
      }
      var remain = pattern.slice(n);
      var read;
      if (prefix === null)
        read = ".";
      else if (isAbsolute(prefix) || isAbsolute(pattern.join("/"))) {
        if (!prefix || !isAbsolute(prefix))
          prefix = "/" + prefix;
        read = prefix;
      } else
        read = prefix;
      var abs = this._makeAbs(read);
      if (childrenIgnored(this, read))
        return cb();
      var isGlobStar = remain[0] === minimatch.GLOBSTAR;
      if (isGlobStar)
        this._processGlobStar(prefix, read, abs, remain, index, inGlobStar, cb);
      else
        this._processReaddir(prefix, read, abs, remain, index, inGlobStar, cb);
    };
    Glob.prototype._processReaddir = function(prefix, read, abs, remain, index, inGlobStar, cb) {
      var self2 = this;
      this._readdir(abs, inGlobStar, function(er, entries) {
        return self2._processReaddir2(prefix, read, abs, remain, index, inGlobStar, entries, cb);
      });
    };
    Glob.prototype._processReaddir2 = function(prefix, read, abs, remain, index, inGlobStar, entries, cb) {
      if (!entries)
        return cb();
      var pn = remain[0];
      var negate = !!this.minimatch.negate;
      var rawGlob = pn._glob;
      var dotOk = this.dot || rawGlob.charAt(0) === ".";
      var matchedEntries = [];
      for (var i = 0; i < entries.length; i++) {
        var e = entries[i];
        if (e.charAt(0) !== "." || dotOk) {
          var m;
          if (negate && !prefix) {
            m = !e.match(pn);
          } else {
            m = e.match(pn);
          }
          if (m)
            matchedEntries.push(e);
        }
      }
      var len = matchedEntries.length;
      if (len === 0)
        return cb();
      if (remain.length === 1 && !this.mark && !this.stat) {
        if (!this.matches[index])
          this.matches[index] = Object.create(null);
        for (var i = 0; i < len; i++) {
          var e = matchedEntries[i];
          if (prefix) {
            if (prefix !== "/")
              e = prefix + "/" + e;
            else
              e = prefix + e;
          }
          if (e.charAt(0) === "/" && !this.nomount) {
            e = path2.join(this.root, e);
          }
          this._emitMatch(index, e);
        }
        return cb();
      }
      remain.shift();
      for (var i = 0; i < len; i++) {
        var e = matchedEntries[i];
        var newPattern;
        if (prefix) {
          if (prefix !== "/")
            e = prefix + "/" + e;
          else
            e = prefix + e;
        }
        this._process([e].concat(remain), index, inGlobStar, cb);
      }
      cb();
    };
    Glob.prototype._emitMatch = function(index, e) {
      if (this.aborted)
        return;
      if (isIgnored(this, e))
        return;
      if (this.paused) {
        this._emitQueue.push([index, e]);
        return;
      }
      var abs = isAbsolute(e) ? e : this._makeAbs(e);
      if (this.mark)
        e = this._mark(e);
      if (this.absolute)
        e = abs;
      if (this.matches[index][e])
        return;
      if (this.nodir) {
        var c = this.cache[abs];
        if (c === "DIR" || Array.isArray(c))
          return;
      }
      this.matches[index][e] = true;
      var st = this.statCache[abs];
      if (st)
        this.emit("stat", e, st);
      this.emit("match", e);
    };
    Glob.prototype._readdirInGlobStar = function(abs, cb) {
      if (this.aborted)
        return;
      if (this.follow)
        return this._readdir(abs, false, cb);
      var lstatkey = "lstat\0" + abs;
      var self2 = this;
      var lstatcb = inflight(lstatkey, lstatcb_);
      if (lstatcb)
        self2.fs.lstat(abs, lstatcb);
      function lstatcb_(er, lstat) {
        if (er && er.code === "ENOENT")
          return cb();
        var isSym = lstat && lstat.isSymbolicLink();
        self2.symlinks[abs] = isSym;
        if (!isSym && lstat && !lstat.isDirectory()) {
          self2.cache[abs] = "FILE";
          cb();
        } else
          self2._readdir(abs, false, cb);
      }
    };
    Glob.prototype._readdir = function(abs, inGlobStar, cb) {
      if (this.aborted)
        return;
      cb = inflight("readdir\0" + abs + "\0" + inGlobStar, cb);
      if (!cb)
        return;
      if (inGlobStar && !ownProp(this.symlinks, abs))
        return this._readdirInGlobStar(abs, cb);
      if (ownProp(this.cache, abs)) {
        var c = this.cache[abs];
        if (!c || c === "FILE")
          return cb();
        if (Array.isArray(c))
          return cb(null, c);
      }
      var self2 = this;
      self2.fs.readdir(abs, readdirCb(this, abs, cb));
    };
    function readdirCb(self2, abs, cb) {
      return function(er, entries) {
        if (er)
          self2._readdirError(abs, er, cb);
        else
          self2._readdirEntries(abs, entries, cb);
      };
    }
    Glob.prototype._readdirEntries = function(abs, entries, cb) {
      if (this.aborted)
        return;
      if (!this.mark && !this.stat) {
        for (var i = 0; i < entries.length; i++) {
          var e = entries[i];
          if (abs === "/")
            e = abs + e;
          else
            e = abs + "/" + e;
          this.cache[e] = true;
        }
      }
      this.cache[abs] = entries;
      return cb(null, entries);
    };
    Glob.prototype._readdirError = function(f, er, cb) {
      if (this.aborted)
        return;
      switch (er.code) {
        case "ENOTSUP":
        case "ENOTDIR":
          var abs = this._makeAbs(f);
          this.cache[abs] = "FILE";
          if (abs === this.cwdAbs) {
            var error = new Error(er.code + " invalid cwd " + this.cwd);
            error.path = this.cwd;
            error.code = er.code;
            this.emit("error", error);
            this.abort();
          }
          break;
        case "ENOENT":
        case "ELOOP":
        case "ENAMETOOLONG":
        case "UNKNOWN":
          this.cache[this._makeAbs(f)] = false;
          break;
        default:
          this.cache[this._makeAbs(f)] = false;
          if (this.strict) {
            this.emit("error", er);
            this.abort();
          }
          if (!this.silent)
            console.error("glob error", er);
          break;
      }
      return cb();
    };
    Glob.prototype._processGlobStar = function(prefix, read, abs, remain, index, inGlobStar, cb) {
      var self2 = this;
      this._readdir(abs, inGlobStar, function(er, entries) {
        self2._processGlobStar2(prefix, read, abs, remain, index, inGlobStar, entries, cb);
      });
    };
    Glob.prototype._processGlobStar2 = function(prefix, read, abs, remain, index, inGlobStar, entries, cb) {
      if (!entries)
        return cb();
      var remainWithoutGlobStar = remain.slice(1);
      var gspref = prefix ? [prefix] : [];
      var noGlobStar = gspref.concat(remainWithoutGlobStar);
      this._process(noGlobStar, index, false, cb);
      var isSym = this.symlinks[abs];
      var len = entries.length;
      if (isSym && inGlobStar)
        return cb();
      for (var i = 0; i < len; i++) {
        var e = entries[i];
        if (e.charAt(0) === "." && !this.dot)
          continue;
        var instead = gspref.concat(entries[i], remainWithoutGlobStar);
        this._process(instead, index, true, cb);
        var below = gspref.concat(entries[i], remain);
        this._process(below, index, true, cb);
      }
      cb();
    };
    Glob.prototype._processSimple = function(prefix, index, cb) {
      var self2 = this;
      this._stat(prefix, function(er, exists) {
        self2._processSimple2(prefix, index, er, exists, cb);
      });
    };
    Glob.prototype._processSimple2 = function(prefix, index, er, exists, cb) {
      if (!this.matches[index])
        this.matches[index] = Object.create(null);
      if (!exists)
        return cb();
      if (prefix && isAbsolute(prefix) && !this.nomount) {
        var trail = /[\/\\]$/.test(prefix);
        if (prefix.charAt(0) === "/") {
          prefix = path2.join(this.root, prefix);
        } else {
          prefix = path2.resolve(this.root, prefix);
          if (trail)
            prefix += "/";
        }
      }
      if (process.platform === "win32")
        prefix = prefix.replace(/\\/g, "/");
      this._emitMatch(index, prefix);
      cb();
    };
    Glob.prototype._stat = function(f, cb) {
      var abs = this._makeAbs(f);
      var needDir = f.slice(-1) === "/";
      if (f.length > this.maxLength)
        return cb();
      if (!this.stat && ownProp(this.cache, abs)) {
        var c = this.cache[abs];
        if (Array.isArray(c))
          c = "DIR";
        if (!needDir || c === "DIR")
          return cb(null, c);
        if (needDir && c === "FILE")
          return cb();
      }
      var exists;
      var stat = this.statCache[abs];
      if (stat !== void 0) {
        if (stat === false)
          return cb(null, stat);
        else {
          var type = stat.isDirectory() ? "DIR" : "FILE";
          if (needDir && type === "FILE")
            return cb();
          else
            return cb(null, type, stat);
        }
      }
      var self2 = this;
      var statcb = inflight("stat\0" + abs, lstatcb_);
      if (statcb)
        self2.fs.lstat(abs, statcb);
      function lstatcb_(er, lstat) {
        if (lstat && lstat.isSymbolicLink()) {
          return self2.fs.stat(abs, function(er2, stat2) {
            if (er2)
              self2._stat2(f, abs, null, lstat, cb);
            else
              self2._stat2(f, abs, er2, stat2, cb);
          });
        } else {
          self2._stat2(f, abs, er, lstat, cb);
        }
      }
    };
    Glob.prototype._stat2 = function(f, abs, er, stat, cb) {
      if (er && (er.code === "ENOENT" || er.code === "ENOTDIR")) {
        this.statCache[abs] = false;
        return cb();
      }
      var needDir = f.slice(-1) === "/";
      this.statCache[abs] = stat;
      if (abs.slice(-1) === "/" && stat && !stat.isDirectory())
        return cb(null, false, stat);
      var c = true;
      if (stat)
        c = stat.isDirectory() ? "DIR" : "FILE";
      this.cache[abs] = this.cache[abs] || c;
      if (needDir && c === "FILE")
        return cb();
      return cb(null, c, stat);
    };
  }
});

// node_modules/glob-promise/lib/index.js
var require_lib3 = __commonJS({
  "node_modules/glob-promise/lib/index.js"(exports, module2) {
    "use strict";
    var glob = require_glob();
    var promise = function(pattern, options) {
      return new Promise((resolve, reject) => {
        glob(pattern, options, (err, files) => err === null ? resolve(files) : reject(err));
      });
    };
    module2.exports = promise;
    module2.exports.glob = glob;
    module2.exports.Glob = glob.Glob;
    module2.exports.hasMagic = glob.hasMagic;
    module2.exports.promise = promise;
    module2.exports.sync = glob.sync;
  }
});

// node_modules/@jsii/spec/lib/assembly.js
var require_assembly = __commonJS({
  "node_modules/@jsii/spec/lib/assembly.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.isDeprecated = exports.describeTypeReference = exports.isClassOrInterfaceType = exports.isEnumType = exports.isInterfaceType = exports.isClassType = exports.TypeKind = exports.isMethod = exports.isUnionTypeReference = exports.isCollectionTypeReference = exports.isPrimitiveTypeReference = exports.isNamedTypeReference = exports.CANONICAL_ANY = exports.PrimitiveType = exports.CollectionKind = exports.Stability = exports.SchemaVersion = exports.SPEC_FILE_NAME = void 0;
    exports.SPEC_FILE_NAME = ".jsii";
    var SchemaVersion;
    (function(SchemaVersion2) {
      SchemaVersion2["LATEST"] = "jsii/0.10.0";
    })(SchemaVersion = exports.SchemaVersion || (exports.SchemaVersion = {}));
    var Stability;
    (function(Stability2) {
      Stability2["Deprecated"] = "deprecated";
      Stability2["Experimental"] = "experimental";
      Stability2["Stable"] = "stable";
      Stability2["External"] = "external";
    })(Stability = exports.Stability || (exports.Stability = {}));
    var CollectionKind;
    (function(CollectionKind2) {
      CollectionKind2["Array"] = "array";
      CollectionKind2["Map"] = "map";
    })(CollectionKind = exports.CollectionKind || (exports.CollectionKind = {}));
    var PrimitiveType;
    (function(PrimitiveType2) {
      PrimitiveType2["Date"] = "date";
      PrimitiveType2["String"] = "string";
      PrimitiveType2["Number"] = "number";
      PrimitiveType2["Boolean"] = "boolean";
      PrimitiveType2["Json"] = "json";
      PrimitiveType2["Any"] = "any";
    })(PrimitiveType = exports.PrimitiveType || (exports.PrimitiveType = {}));
    exports.CANONICAL_ANY = {
      primitive: PrimitiveType.Any
    };
    function isNamedTypeReference(ref) {
      var _a;
      return !!((_a = ref) === null || _a === void 0 ? void 0 : _a.fqn);
    }
    exports.isNamedTypeReference = isNamedTypeReference;
    function isPrimitiveTypeReference(ref) {
      var _a;
      return !!((_a = ref) === null || _a === void 0 ? void 0 : _a.primitive);
    }
    exports.isPrimitiveTypeReference = isPrimitiveTypeReference;
    function isCollectionTypeReference(ref) {
      var _a;
      return !!((_a = ref) === null || _a === void 0 ? void 0 : _a.collection);
    }
    exports.isCollectionTypeReference = isCollectionTypeReference;
    function isUnionTypeReference(ref) {
      var _a;
      return !!((_a = ref) === null || _a === void 0 ? void 0 : _a.union);
    }
    exports.isUnionTypeReference = isUnionTypeReference;
    function isMethod(callable) {
      return !!callable.name;
    }
    exports.isMethod = isMethod;
    var TypeKind;
    (function(TypeKind2) {
      TypeKind2["Class"] = "class";
      TypeKind2["Enum"] = "enum";
      TypeKind2["Interface"] = "interface";
    })(TypeKind = exports.TypeKind || (exports.TypeKind = {}));
    function isClassType(type) {
      return (type === null || type === void 0 ? void 0 : type.kind) === TypeKind.Class;
    }
    exports.isClassType = isClassType;
    function isInterfaceType(type) {
      return (type === null || type === void 0 ? void 0 : type.kind) === TypeKind.Interface;
    }
    exports.isInterfaceType = isInterfaceType;
    function isEnumType(type) {
      return (type === null || type === void 0 ? void 0 : type.kind) === TypeKind.Enum;
    }
    exports.isEnumType = isEnumType;
    function isClassOrInterfaceType(type) {
      return isClassType(type) || isInterfaceType(type);
    }
    exports.isClassOrInterfaceType = isClassOrInterfaceType;
    function describeTypeReference(type) {
      if (type === void 0) {
        return "void";
      }
      if (isNamedTypeReference(type)) {
        return type.fqn;
      }
      if (isPrimitiveTypeReference(type)) {
        return type.primitive;
      }
      if (isCollectionTypeReference(type)) {
        return `${type.collection.kind}<${describeTypeReference(type.collection.elementtype)}>`;
      }
      if (isUnionTypeReference(type)) {
        const unionType = type.union.types.map(describeTypeReference).join(" | ");
        return unionType;
      }
      throw new Error("Unrecognized type reference");
    }
    exports.describeTypeReference = describeTypeReference;
    function isDeprecated(entity) {
      var _a;
      return ((_a = entity === null || entity === void 0 ? void 0 : entity.docs) === null || _a === void 0 ? void 0 : _a.stability) === Stability.Deprecated;
    }
    exports.isDeprecated = isDeprecated;
  }
});

// node_modules/@jsii/spec/lib/configuration.js
var require_configuration = __commonJS({
  "node_modules/@jsii/spec/lib/configuration.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
  }
});

// node_modules/@jsii/spec/lib/name-tree.js
var require_name_tree = __commonJS({
  "node_modules/@jsii/spec/lib/name-tree.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.NameTree = void 0;
    var NameTree = class {
      constructor() {
        this._children = {};
      }
      static of(assm) {
        var _a;
        const nameTree = new NameTree();
        for (const type of Object.values((_a = assm.types) !== null && _a !== void 0 ? _a : {})) {
          nameTree.register(type.fqn);
        }
        return nameTree;
      }
      get children() {
        return this._children;
      }
      get fqn() {
        return this._fqn;
      }
      register(fqn, path2 = fqn.split(".")) {
        if (path2.length === 0) {
          this._fqn = fqn;
        } else {
          const [head, ...rest] = path2;
          if (!this._children[head]) {
            this._children[head] = new NameTree();
          }
          this._children[head].register(fqn, rest);
        }
        return this;
      }
    };
    exports.NameTree = NameTree;
  }
});

// node_modules/jsonschema/lib/helpers.js
var require_helpers = __commonJS({
  "node_modules/jsonschema/lib/helpers.js"(exports, module2) {
    "use strict";
    var uri = require("url");
    var ValidationError = exports.ValidationError = function ValidationError2(message, instance, schema, path2, name, argument) {
      if (Array.isArray(path2)) {
        this.path = path2;
        this.property = path2.reduce(function(sum, item) {
          return sum + makeSuffix(item);
        }, "instance");
      } else if (path2 !== void 0) {
        this.property = path2;
      }
      if (message) {
        this.message = message;
      }
      if (schema) {
        var id = schema.$id || schema.id;
        this.schema = id || schema;
      }
      if (instance !== void 0) {
        this.instance = instance;
      }
      this.name = name;
      this.argument = argument;
      this.stack = this.toString();
    };
    ValidationError.prototype.toString = function toString() {
      return this.property + " " + this.message;
    };
    var ValidatorResult = exports.ValidatorResult = function ValidatorResult2(instance, schema, options, ctx) {
      this.instance = instance;
      this.schema = schema;
      this.options = options;
      this.path = ctx.path;
      this.propertyPath = ctx.propertyPath;
      this.errors = [];
      this.throwError = options && options.throwError;
      this.throwFirst = options && options.throwFirst;
      this.throwAll = options && options.throwAll;
      this.disableFormat = options && options.disableFormat === true;
    };
    ValidatorResult.prototype.addError = function addError(detail) {
      var err;
      if (typeof detail == "string") {
        err = new ValidationError(detail, this.instance, this.schema, this.path);
      } else {
        if (!detail)
          throw new Error("Missing error detail");
        if (!detail.message)
          throw new Error("Missing error message");
        if (!detail.name)
          throw new Error("Missing validator type");
        err = new ValidationError(detail.message, this.instance, this.schema, this.path, detail.name, detail.argument);
      }
      this.errors.push(err);
      if (this.throwFirst) {
        throw new ValidatorResultError(this);
      } else if (this.throwError) {
        throw err;
      }
      return err;
    };
    ValidatorResult.prototype.importErrors = function importErrors(res) {
      if (typeof res == "string" || res && res.validatorType) {
        this.addError(res);
      } else if (res && res.errors) {
        Array.prototype.push.apply(this.errors, res.errors);
      }
    };
    function stringizer(v, i) {
      return i + ": " + v.toString() + "\n";
    }
    ValidatorResult.prototype.toString = function toString(res) {
      return this.errors.map(stringizer).join("");
    };
    Object.defineProperty(ValidatorResult.prototype, "valid", { get: function() {
      return !this.errors.length;
    } });
    module2.exports.ValidatorResultError = ValidatorResultError;
    function ValidatorResultError(result) {
      if (Error.captureStackTrace) {
        Error.captureStackTrace(this, ValidatorResultError);
      }
      this.instance = result.instance;
      this.schema = result.schema;
      this.options = result.options;
      this.errors = result.errors;
    }
    ValidatorResultError.prototype = new Error();
    ValidatorResultError.prototype.constructor = ValidatorResultError;
    ValidatorResultError.prototype.name = "Validation Error";
    var SchemaError = exports.SchemaError = function SchemaError2(msg, schema) {
      this.message = msg;
      this.schema = schema;
      Error.call(this, msg);
      Error.captureStackTrace(this, SchemaError2);
    };
    SchemaError.prototype = Object.create(Error.prototype, {
      constructor: { value: SchemaError, enumerable: false },
      name: { value: "SchemaError", enumerable: false }
    });
    var SchemaContext = exports.SchemaContext = function SchemaContext2(schema, options, path2, base, schemas) {
      this.schema = schema;
      this.options = options;
      if (Array.isArray(path2)) {
        this.path = path2;
        this.propertyPath = path2.reduce(function(sum, item) {
          return sum + makeSuffix(item);
        }, "instance");
      } else {
        this.propertyPath = path2;
      }
      this.base = base;
      this.schemas = schemas;
    };
    SchemaContext.prototype.resolve = function resolve(target) {
      return uri.resolve(this.base, target);
    };
    SchemaContext.prototype.makeChild = function makeChild(schema, propertyName) {
      var path2 = propertyName === void 0 ? this.path : this.path.concat([propertyName]);
      var id = schema.$id || schema.id;
      var base = uri.resolve(this.base, id || "");
      var ctx = new SchemaContext(schema, this.options, path2, base, Object.create(this.schemas));
      if (id && !ctx.schemas[base]) {
        ctx.schemas[base] = schema;
      }
      return ctx;
    };
    var FORMAT_REGEXPS = exports.FORMAT_REGEXPS = {
      "date-time": /^\d{4}-(?:0[0-9]{1}|1[0-2]{1})-(3[01]|0[1-9]|[12][0-9])[tT ](2[0-4]|[01][0-9]):([0-5][0-9]):(60|[0-5][0-9])(\.\d+)?([zZ]|[+-]([0-5][0-9]):(60|[0-5][0-9]))$/,
      "date": /^\d{4}-(?:0[0-9]{1}|1[0-2]{1})-(3[01]|0[1-9]|[12][0-9])$/,
      "time": /^(2[0-4]|[01][0-9]):([0-5][0-9]):(60|[0-5][0-9])$/,
      "email": /^(?:[\w\!\#\$\%\&\'\*\+\-\/\=\?\^\`\{\|\}\~]+\.)*[\w\!\#\$\%\&\'\*\+\-\/\=\?\^\`\{\|\}\~]+@(?:(?:(?:[a-zA-Z0-9](?:[a-zA-Z0-9\-](?!\.)){0,61}[a-zA-Z0-9]?\.)+[a-zA-Z0-9](?:[a-zA-Z0-9\-](?!$)){0,61}[a-zA-Z0-9]?)|(?:\[(?:(?:[01]?\d{1,2}|2[0-4]\d|25[0-5])\.){3}(?:[01]?\d{1,2}|2[0-4]\d|25[0-5])\]))$/,
      "ip-address": /^(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/,
      "ipv6": /^\s*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))(%.+)?\s*$/,
      "uri": /^[a-zA-Z][a-zA-Z0-9+-.]*:[^\s]*$/,
      "uri-reference": /^(((([A-Za-z][+\-.0-9A-Za-z]*(:%[0-9A-Fa-f]{2}|:[!$&-.0-;=?-Z_a-z~]|[/?])|\?)(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~])*|([A-Za-z][+\-.0-9A-Za-z]*:?)?)|([A-Za-z][+\-.0-9A-Za-z]*:)?\/((%[0-9A-Fa-f]{2}|\/((%[0-9A-Fa-f]{2}|[!$&-.0-9;=A-Z_a-z~])+|(\[(([Vv][0-9A-Fa-f]+\.[!$&-.0-;=A-Z_a-z~]+)?|[.0-:A-Fa-f]+)\])?)(:\d*)?[/?]|[!$&-.0-;=?-Z_a-z~])(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~])*|(\/((%[0-9A-Fa-f]{2}|[!$&-.0-9;=A-Z_a-z~])+|(\[(([Vv][0-9A-Fa-f]+\.[!$&-.0-;=A-Z_a-z~]+)?|[.0-:A-Fa-f]+)\])?)(:\d*)?)?))#(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~])*|(([A-Za-z][+\-.0-9A-Za-z]*)?%[0-9A-Fa-f]{2}|[!$&-.0-9;=@_~]|[A-Za-z][+\-.0-9A-Za-z]*[!$&-*,;=@_~])(%[0-9A-Fa-f]{2}|[!$&-.0-9;=@-Z_a-z~])*((([/?](%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~])*)?#|[/?])(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~])*)?|([A-Za-z][+\-.0-9A-Za-z]*(:%[0-9A-Fa-f]{2}|:[!$&-.0-;=?-Z_a-z~]|[/?])|\?)(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~])*|([A-Za-z][+\-.0-9A-Za-z]*:)?\/((%[0-9A-Fa-f]{2}|\/((%[0-9A-Fa-f]{2}|[!$&-.0-9;=A-Z_a-z~])+|(\[(([Vv][0-9A-Fa-f]+\.[!$&-.0-;=A-Z_a-z~]+)?|[.0-:A-Fa-f]+)\])?)(:\d*)?[/?]|[!$&-.0-;=?-Z_a-z~])(%[0-9A-Fa-f]{2}|[!$&-;=?-Z_a-z~])*|\/((%[0-9A-Fa-f]{2}|[!$&-.0-9;=A-Z_a-z~])+(:\d*)?|(\[(([Vv][0-9A-Fa-f]+\.[!$&-.0-;=A-Z_a-z~]+)?|[.0-:A-Fa-f]+)\])?:\d*|\[(([Vv][0-9A-Fa-f]+\.[!$&-.0-;=A-Z_a-z~]+)?|[.0-:A-Fa-f]+)\])?)?|[A-Za-z][+\-.0-9A-Za-z]*:?)?$/,
      "color": /^(#?([0-9A-Fa-f]{3}){1,2}\b|aqua|black|blue|fuchsia|gray|green|lime|maroon|navy|olive|orange|purple|red|silver|teal|white|yellow|(rgb\(\s*\b([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\b\s*,\s*\b([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\b\s*,\s*\b([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\b\s*\))|(rgb\(\s*(\d?\d%|100%)+\s*,\s*(\d?\d%|100%)+\s*,\s*(\d?\d%|100%)+\s*\)))$/,
      "hostname": /^(?=.{1,255}$)[0-9A-Za-z](?:(?:[0-9A-Za-z]|-){0,61}[0-9A-Za-z])?(?:\.[0-9A-Za-z](?:(?:[0-9A-Za-z]|-){0,61}[0-9A-Za-z])?)*\.?$/,
      "host-name": /^(?=.{1,255}$)[0-9A-Za-z](?:(?:[0-9A-Za-z]|-){0,61}[0-9A-Za-z])?(?:\.[0-9A-Za-z](?:(?:[0-9A-Za-z]|-){0,61}[0-9A-Za-z])?)*\.?$/,
      "alpha": /^[a-zA-Z]+$/,
      "alphanumeric": /^[a-zA-Z0-9]+$/,
      "utc-millisec": function(input) {
        return typeof input === "string" && parseFloat(input) === parseInt(input, 10) && !isNaN(input);
      },
      "regex": function(input) {
        var result = true;
        try {
          new RegExp(input);
        } catch (e) {
          result = false;
        }
        return result;
      },
      "style": /\s*(.+?):\s*([^;]+);?/,
      "phone": /^\+(?:[0-9] ?){6,14}[0-9]$/
    };
    FORMAT_REGEXPS.regexp = FORMAT_REGEXPS.regex;
    FORMAT_REGEXPS.pattern = FORMAT_REGEXPS.regex;
    FORMAT_REGEXPS.ipv4 = FORMAT_REGEXPS["ip-address"];
    exports.isFormat = function isFormat(input, format, validator) {
      if (typeof input === "string" && FORMAT_REGEXPS[format] !== void 0) {
        if (FORMAT_REGEXPS[format] instanceof RegExp) {
          return FORMAT_REGEXPS[format].test(input);
        }
        if (typeof FORMAT_REGEXPS[format] === "function") {
          return FORMAT_REGEXPS[format](input);
        }
      } else if (validator && validator.customFormats && typeof validator.customFormats[format] === "function") {
        return validator.customFormats[format](input);
      }
      return true;
    };
    var makeSuffix = exports.makeSuffix = function makeSuffix2(key) {
      key = key.toString();
      if (!key.match(/[.\s\[\]]/) && !key.match(/^[\d]/)) {
        return "." + key;
      }
      if (key.match(/^\d+$/)) {
        return "[" + key + "]";
      }
      return "[" + JSON.stringify(key) + "]";
    };
    exports.deepCompareStrict = function deepCompareStrict(a, b) {
      if (typeof a !== typeof b) {
        return false;
      }
      if (Array.isArray(a)) {
        if (!Array.isArray(b)) {
          return false;
        }
        if (a.length !== b.length) {
          return false;
        }
        return a.every(function(v, i) {
          return deepCompareStrict(a[i], b[i]);
        });
      }
      if (typeof a === "object") {
        if (!a || !b) {
          return a === b;
        }
        var aKeys = Object.keys(a);
        var bKeys = Object.keys(b);
        if (aKeys.length !== bKeys.length) {
          return false;
        }
        return aKeys.every(function(v) {
          return deepCompareStrict(a[v], b[v]);
        });
      }
      return a === b;
    };
    function deepMerger(target, dst, e, i) {
      if (typeof e === "object") {
        dst[i] = deepMerge(target[i], e);
      } else {
        if (target.indexOf(e) === -1) {
          dst.push(e);
        }
      }
    }
    function copyist(src, dst, key) {
      dst[key] = src[key];
    }
    function copyistWithDeepMerge(target, src, dst, key) {
      if (typeof src[key] !== "object" || !src[key]) {
        dst[key] = src[key];
      } else {
        if (!target[key]) {
          dst[key] = src[key];
        } else {
          dst[key] = deepMerge(target[key], src[key]);
        }
      }
    }
    function deepMerge(target, src) {
      var array = Array.isArray(src);
      var dst = array && [] || {};
      if (array) {
        target = target || [];
        dst = dst.concat(target);
        src.forEach(deepMerger.bind(null, target, dst));
      } else {
        if (target && typeof target === "object") {
          Object.keys(target).forEach(copyist.bind(null, target, dst));
        }
        Object.keys(src).forEach(copyistWithDeepMerge.bind(null, target, src, dst));
      }
      return dst;
    }
    module2.exports.deepMerge = deepMerge;
    exports.objectGetPath = function objectGetPath(o, s) {
      var parts = s.split("/").slice(1);
      var k;
      while (typeof (k = parts.shift()) == "string") {
        var n = decodeURIComponent(k.replace(/~0/, "~").replace(/~1/g, "/"));
        if (!(n in o))
          return;
        o = o[n];
      }
      return o;
    };
    function pathEncoder(v) {
      return "/" + encodeURIComponent(v).replace(/~/g, "%7E");
    }
    exports.encodePath = function encodePointer(a) {
      return a.map(pathEncoder).join("");
    };
    exports.getDecimalPlaces = function getDecimalPlaces(number) {
      var decimalPlaces = 0;
      if (isNaN(number))
        return decimalPlaces;
      if (typeof number !== "number") {
        number = Number(number);
      }
      var parts = number.toString().split("e");
      if (parts.length === 2) {
        if (parts[1][0] !== "-") {
          return decimalPlaces;
        } else {
          decimalPlaces = Number(parts[1].slice(1));
        }
      }
      var decimalParts = parts[0].split(".");
      if (decimalParts.length === 2) {
        decimalPlaces += decimalParts[1].length;
      }
      return decimalPlaces;
    };
    exports.isSchema = function isSchema(val) {
      return typeof val === "object" && val || typeof val === "boolean";
    };
  }
});

// node_modules/jsonschema/lib/attribute.js
var require_attribute = __commonJS({
  "node_modules/jsonschema/lib/attribute.js"(exports, module2) {
    "use strict";
    var helpers = require_helpers();
    var ValidatorResult = helpers.ValidatorResult;
    var SchemaError = helpers.SchemaError;
    var attribute = {};
    attribute.ignoreProperties = {
      "id": true,
      "default": true,
      "description": true,
      "title": true,
      "additionalItems": true,
      "then": true,
      "else": true,
      "$schema": true,
      "$ref": true,
      "extends": true
    };
    var validators = attribute.validators = {};
    validators.type = function validateType(instance, schema, options, ctx) {
      if (instance === void 0) {
        return null;
      }
      var result = new ValidatorResult(instance, schema, options, ctx);
      var types = Array.isArray(schema.type) ? schema.type : [schema.type];
      if (!types.some(this.testType.bind(this, instance, schema, options, ctx))) {
        var list = types.map(function(v) {
          if (!v)
            return;
          var id = v.$id || v.id;
          return id ? "<" + id + ">" : v + "";
        });
        result.addError({
          name: "type",
          argument: list,
          message: "is not of a type(s) " + list
        });
      }
      return result;
    };
    function testSchemaNoThrow(instance, options, ctx, callback, schema) {
      var throwError = options.throwError;
      var throwAll = options.throwAll;
      options.throwError = false;
      options.throwAll = false;
      var res = this.validateSchema(instance, schema, options, ctx);
      options.throwError = throwError;
      options.throwAll = throwAll;
      if (!res.valid && callback instanceof Function) {
        callback(res);
      }
      return res.valid;
    }
    validators.anyOf = function validateAnyOf(instance, schema, options, ctx) {
      if (instance === void 0) {
        return null;
      }
      var result = new ValidatorResult(instance, schema, options, ctx);
      var inner = new ValidatorResult(instance, schema, options, ctx);
      if (!Array.isArray(schema.anyOf)) {
        throw new SchemaError("anyOf must be an array");
      }
      if (!schema.anyOf.some(testSchemaNoThrow.bind(this, instance, options, ctx, function(res) {
        inner.importErrors(res);
      }))) {
        var list = schema.anyOf.map(function(v, i) {
          var id = v.$id || v.id;
          if (id)
            return "<" + id + ">";
          return v.title && JSON.stringify(v.title) || v["$ref"] && "<" + v["$ref"] + ">" || "[subschema " + i + "]";
        });
        if (options.nestedErrors) {
          result.importErrors(inner);
        }
        result.addError({
          name: "anyOf",
          argument: list,
          message: "is not any of " + list.join(",")
        });
      }
      return result;
    };
    validators.allOf = function validateAllOf(instance, schema, options, ctx) {
      if (instance === void 0) {
        return null;
      }
      if (!Array.isArray(schema.allOf)) {
        throw new SchemaError("allOf must be an array");
      }
      var result = new ValidatorResult(instance, schema, options, ctx);
      var self2 = this;
      schema.allOf.forEach(function(v, i) {
        var valid = self2.validateSchema(instance, v, options, ctx);
        if (!valid.valid) {
          var id = v.$id || v.id;
          var msg = id || v.title && JSON.stringify(v.title) || v["$ref"] && "<" + v["$ref"] + ">" || "[subschema " + i + "]";
          result.addError({
            name: "allOf",
            argument: { id: msg, length: valid.errors.length, valid },
            message: "does not match allOf schema " + msg + " with " + valid.errors.length + " error[s]:"
          });
          result.importErrors(valid);
        }
      });
      return result;
    };
    validators.oneOf = function validateOneOf(instance, schema, options, ctx) {
      if (instance === void 0) {
        return null;
      }
      if (!Array.isArray(schema.oneOf)) {
        throw new SchemaError("oneOf must be an array");
      }
      var result = new ValidatorResult(instance, schema, options, ctx);
      var inner = new ValidatorResult(instance, schema, options, ctx);
      var count = schema.oneOf.filter(testSchemaNoThrow.bind(this, instance, options, ctx, function(res) {
        inner.importErrors(res);
      })).length;
      var list = schema.oneOf.map(function(v, i) {
        var id = v.$id || v.id;
        return id || v.title && JSON.stringify(v.title) || v["$ref"] && "<" + v["$ref"] + ">" || "[subschema " + i + "]";
      });
      if (count !== 1) {
        if (options.nestedErrors) {
          result.importErrors(inner);
        }
        result.addError({
          name: "oneOf",
          argument: list,
          message: "is not exactly one from " + list.join(",")
        });
      }
      return result;
    };
    validators.if = function validateIf(instance, schema, options, ctx) {
      if (instance === void 0)
        return null;
      if (!helpers.isSchema(schema.if))
        throw new Error('Expected "if" keyword to be a schema');
      var ifValid = testSchemaNoThrow.call(this, instance, options, ctx, null, schema.if);
      var result = new ValidatorResult(instance, schema, options, ctx);
      var res;
      if (ifValid) {
        if (schema.then === void 0)
          return;
        if (!helpers.isSchema(schema.then))
          throw new Error('Expected "then" keyword to be a schema');
        res = this.validateSchema(instance, schema.then, options, ctx.makeChild(schema.then));
        result.importErrors(res);
      } else {
        if (schema.else === void 0)
          return;
        if (!helpers.isSchema(schema.else))
          throw new Error('Expected "else" keyword to be a schema');
        res = this.validateSchema(instance, schema.else, options, ctx.makeChild(schema.else));
        result.importErrors(res);
      }
      return result;
    };
    function getEnumerableProperty(object, key) {
      if (Object.hasOwnProperty.call(object, key))
        return object[key];
      if (!(key in object))
        return;
      while (object = Object.getPrototypeOf(object)) {
        if (Object.propertyIsEnumerable.call(object, key))
          return object[key];
      }
    }
    validators.propertyNames = function validatePropertyNames(instance, schema, options, ctx) {
      if (!this.types.object(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var subschema = schema.propertyNames !== void 0 ? schema.propertyNames : {};
      if (!helpers.isSchema(subschema))
        throw new SchemaError('Expected "propertyNames" to be a schema (object or boolean)');
      for (var property in instance) {
        if (getEnumerableProperty(instance, property) !== void 0) {
          var res = this.validateSchema(property, subschema, options, ctx.makeChild(subschema));
          result.importErrors(res);
        }
      }
      return result;
    };
    validators.properties = function validateProperties(instance, schema, options, ctx) {
      if (!this.types.object(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var properties = schema.properties || {};
      for (var property in properties) {
        var subschema = properties[property];
        if (subschema === void 0) {
          continue;
        } else if (subschema === null) {
          throw new SchemaError('Unexpected null, expected schema in "properties"');
        }
        if (typeof options.preValidateProperty == "function") {
          options.preValidateProperty(instance, property, subschema, options, ctx);
        }
        var prop = getEnumerableProperty(instance, property);
        var res = this.validateSchema(prop, subschema, options, ctx.makeChild(subschema, property));
        if (res.instance !== result.instance[property])
          result.instance[property] = res.instance;
        result.importErrors(res);
      }
      return result;
    };
    function testAdditionalProperty(instance, schema, options, ctx, property, result) {
      if (!this.types.object(instance))
        return;
      if (schema.properties && schema.properties[property] !== void 0) {
        return;
      }
      if (schema.additionalProperties === false) {
        result.addError({
          name: "additionalProperties",
          argument: property,
          message: "is not allowed to have the additional property " + JSON.stringify(property)
        });
      } else {
        var additionalProperties = schema.additionalProperties || {};
        if (typeof options.preValidateProperty == "function") {
          options.preValidateProperty(instance, property, additionalProperties, options, ctx);
        }
        var res = this.validateSchema(instance[property], additionalProperties, options, ctx.makeChild(additionalProperties, property));
        if (res.instance !== result.instance[property])
          result.instance[property] = res.instance;
        result.importErrors(res);
      }
    }
    validators.patternProperties = function validatePatternProperties(instance, schema, options, ctx) {
      if (!this.types.object(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var patternProperties = schema.patternProperties || {};
      for (var property in instance) {
        var test = true;
        for (var pattern in patternProperties) {
          var subschema = patternProperties[pattern];
          if (subschema === void 0) {
            continue;
          } else if (subschema === null) {
            throw new SchemaError('Unexpected null, expected schema in "patternProperties"');
          }
          try {
            var regexp = new RegExp(pattern, "u");
          } catch (_e) {
            regexp = new RegExp(pattern);
          }
          if (!regexp.test(property)) {
            continue;
          }
          test = false;
          if (typeof options.preValidateProperty == "function") {
            options.preValidateProperty(instance, property, subschema, options, ctx);
          }
          var res = this.validateSchema(instance[property], subschema, options, ctx.makeChild(subschema, property));
          if (res.instance !== result.instance[property])
            result.instance[property] = res.instance;
          result.importErrors(res);
        }
        if (test) {
          testAdditionalProperty.call(this, instance, schema, options, ctx, property, result);
        }
      }
      return result;
    };
    validators.additionalProperties = function validateAdditionalProperties(instance, schema, options, ctx) {
      if (!this.types.object(instance))
        return;
      if (schema.patternProperties) {
        return null;
      }
      var result = new ValidatorResult(instance, schema, options, ctx);
      for (var property in instance) {
        testAdditionalProperty.call(this, instance, schema, options, ctx, property, result);
      }
      return result;
    };
    validators.minProperties = function validateMinProperties(instance, schema, options, ctx) {
      if (!this.types.object(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var keys = Object.keys(instance);
      if (!(keys.length >= schema.minProperties)) {
        result.addError({
          name: "minProperties",
          argument: schema.minProperties,
          message: "does not meet minimum property length of " + schema.minProperties
        });
      }
      return result;
    };
    validators.maxProperties = function validateMaxProperties(instance, schema, options, ctx) {
      if (!this.types.object(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var keys = Object.keys(instance);
      if (!(keys.length <= schema.maxProperties)) {
        result.addError({
          name: "maxProperties",
          argument: schema.maxProperties,
          message: "does not meet maximum property length of " + schema.maxProperties
        });
      }
      return result;
    };
    validators.items = function validateItems(instance, schema, options, ctx) {
      var self2 = this;
      if (!this.types.array(instance))
        return;
      if (!schema.items)
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      instance.every(function(value, i) {
        var items = Array.isArray(schema.items) ? schema.items[i] || schema.additionalItems : schema.items;
        if (items === void 0) {
          return true;
        }
        if (items === false) {
          result.addError({
            name: "items",
            message: "additionalItems not permitted"
          });
          return false;
        }
        var res = self2.validateSchema(value, items, options, ctx.makeChild(items, i));
        if (res.instance !== result.instance[i])
          result.instance[i] = res.instance;
        result.importErrors(res);
        return true;
      });
      return result;
    };
    validators.minimum = function validateMinimum(instance, schema, options, ctx) {
      if (!this.types.number(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      if (schema.exclusiveMinimum && schema.exclusiveMinimum === true) {
        if (!(instance > schema.minimum)) {
          result.addError({
            name: "minimum",
            argument: schema.minimum,
            message: "must be greater than " + schema.minimum
          });
        }
      } else {
        if (!(instance >= schema.minimum)) {
          result.addError({
            name: "minimum",
            argument: schema.minimum,
            message: "must be greater than or equal to " + schema.minimum
          });
        }
      }
      return result;
    };
    validators.maximum = function validateMaximum(instance, schema, options, ctx) {
      if (!this.types.number(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      if (schema.exclusiveMaximum && schema.exclusiveMaximum === true) {
        if (!(instance < schema.maximum)) {
          result.addError({
            name: "maximum",
            argument: schema.maximum,
            message: "must be less than " + schema.maximum
          });
        }
      } else {
        if (!(instance <= schema.maximum)) {
          result.addError({
            name: "maximum",
            argument: schema.maximum,
            message: "must be less than or equal to " + schema.maximum
          });
        }
      }
      return result;
    };
    validators.exclusiveMinimum = function validateExclusiveMinimum(instance, schema, options, ctx) {
      if (typeof schema.exclusiveMaximum === "boolean")
        return;
      if (!this.types.number(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var valid = instance > schema.exclusiveMinimum;
      if (!valid) {
        result.addError({
          name: "exclusiveMinimum",
          argument: schema.exclusiveMinimum,
          message: "must be strictly greater than " + schema.exclusiveMinimum
        });
      }
      return result;
    };
    validators.exclusiveMaximum = function validateExclusiveMaximum(instance, schema, options, ctx) {
      if (typeof schema.exclusiveMaximum === "boolean")
        return;
      if (!this.types.number(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var valid = instance < schema.exclusiveMaximum;
      if (!valid) {
        result.addError({
          name: "exclusiveMaximum",
          argument: schema.exclusiveMaximum,
          message: "must be strictly less than " + schema.exclusiveMaximum
        });
      }
      return result;
    };
    var validateMultipleOfOrDivisbleBy = function validateMultipleOfOrDivisbleBy2(instance, schema, options, ctx, validationType, errorMessage) {
      if (!this.types.number(instance))
        return;
      var validationArgument = schema[validationType];
      if (validationArgument == 0) {
        throw new SchemaError(validationType + " cannot be zero");
      }
      var result = new ValidatorResult(instance, schema, options, ctx);
      var instanceDecimals = helpers.getDecimalPlaces(instance);
      var divisorDecimals = helpers.getDecimalPlaces(validationArgument);
      var maxDecimals = Math.max(instanceDecimals, divisorDecimals);
      var multiplier = Math.pow(10, maxDecimals);
      if (Math.round(instance * multiplier) % Math.round(validationArgument * multiplier) !== 0) {
        result.addError({
          name: validationType,
          argument: validationArgument,
          message: errorMessage + JSON.stringify(validationArgument)
        });
      }
      return result;
    };
    validators.multipleOf = function validateMultipleOf(instance, schema, options, ctx) {
      return validateMultipleOfOrDivisbleBy.call(this, instance, schema, options, ctx, "multipleOf", "is not a multiple of (divisible by) ");
    };
    validators.divisibleBy = function validateDivisibleBy(instance, schema, options, ctx) {
      return validateMultipleOfOrDivisbleBy.call(this, instance, schema, options, ctx, "divisibleBy", "is not divisible by (multiple of) ");
    };
    validators.required = function validateRequired(instance, schema, options, ctx) {
      var result = new ValidatorResult(instance, schema, options, ctx);
      if (instance === void 0 && schema.required === true) {
        result.addError({
          name: "required",
          message: "is required"
        });
      } else if (this.types.object(instance) && Array.isArray(schema.required)) {
        schema.required.forEach(function(n) {
          if (getEnumerableProperty(instance, n) === void 0) {
            result.addError({
              name: "required",
              argument: n,
              message: "requires property " + JSON.stringify(n)
            });
          }
        });
      }
      return result;
    };
    validators.pattern = function validatePattern(instance, schema, options, ctx) {
      if (!this.types.string(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var pattern = schema.pattern;
      try {
        var regexp = new RegExp(pattern, "u");
      } catch (_e) {
        regexp = new RegExp(pattern);
      }
      if (!instance.match(regexp)) {
        result.addError({
          name: "pattern",
          argument: schema.pattern,
          message: "does not match pattern " + JSON.stringify(schema.pattern.toString())
        });
      }
      return result;
    };
    validators.format = function validateFormat(instance, schema, options, ctx) {
      if (instance === void 0)
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      if (!result.disableFormat && !helpers.isFormat(instance, schema.format, this)) {
        result.addError({
          name: "format",
          argument: schema.format,
          message: "does not conform to the " + JSON.stringify(schema.format) + " format"
        });
      }
      return result;
    };
    validators.minLength = function validateMinLength(instance, schema, options, ctx) {
      if (!this.types.string(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var hsp = instance.match(/[\uDC00-\uDFFF]/g);
      var length = instance.length - (hsp ? hsp.length : 0);
      if (!(length >= schema.minLength)) {
        result.addError({
          name: "minLength",
          argument: schema.minLength,
          message: "does not meet minimum length of " + schema.minLength
        });
      }
      return result;
    };
    validators.maxLength = function validateMaxLength(instance, schema, options, ctx) {
      if (!this.types.string(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var hsp = instance.match(/[\uDC00-\uDFFF]/g);
      var length = instance.length - (hsp ? hsp.length : 0);
      if (!(length <= schema.maxLength)) {
        result.addError({
          name: "maxLength",
          argument: schema.maxLength,
          message: "does not meet maximum length of " + schema.maxLength
        });
      }
      return result;
    };
    validators.minItems = function validateMinItems(instance, schema, options, ctx) {
      if (!this.types.array(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      if (!(instance.length >= schema.minItems)) {
        result.addError({
          name: "minItems",
          argument: schema.minItems,
          message: "does not meet minimum length of " + schema.minItems
        });
      }
      return result;
    };
    validators.maxItems = function validateMaxItems(instance, schema, options, ctx) {
      if (!this.types.array(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      if (!(instance.length <= schema.maxItems)) {
        result.addError({
          name: "maxItems",
          argument: schema.maxItems,
          message: "does not meet maximum length of " + schema.maxItems
        });
      }
      return result;
    };
    function testArrays(v, i, a) {
      var j, len = a.length;
      for (j = i + 1, len; j < len; j++) {
        if (helpers.deepCompareStrict(v, a[j])) {
          return false;
        }
      }
      return true;
    }
    validators.uniqueItems = function validateUniqueItems(instance, schema, options, ctx) {
      if (schema.uniqueItems !== true)
        return;
      if (!this.types.array(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      if (!instance.every(testArrays)) {
        result.addError({
          name: "uniqueItems",
          message: "contains duplicate item"
        });
      }
      return result;
    };
    validators.dependencies = function validateDependencies(instance, schema, options, ctx) {
      if (!this.types.object(instance))
        return;
      var result = new ValidatorResult(instance, schema, options, ctx);
      for (var property in schema.dependencies) {
        if (instance[property] === void 0) {
          continue;
        }
        var dep = schema.dependencies[property];
        var childContext = ctx.makeChild(dep, property);
        if (typeof dep == "string") {
          dep = [dep];
        }
        if (Array.isArray(dep)) {
          dep.forEach(function(prop) {
            if (instance[prop] === void 0) {
              result.addError({
                name: "dependencies",
                argument: childContext.propertyPath,
                message: "property " + prop + " not found, required by " + childContext.propertyPath
              });
            }
          });
        } else {
          var res = this.validateSchema(instance, dep, options, childContext);
          if (result.instance !== res.instance)
            result.instance = res.instance;
          if (res && res.errors.length) {
            result.addError({
              name: "dependencies",
              argument: childContext.propertyPath,
              message: "does not meet dependency required by " + childContext.propertyPath
            });
            result.importErrors(res);
          }
        }
      }
      return result;
    };
    validators["enum"] = function validateEnum(instance, schema, options, ctx) {
      if (instance === void 0) {
        return null;
      }
      if (!Array.isArray(schema["enum"])) {
        throw new SchemaError("enum expects an array", schema);
      }
      var result = new ValidatorResult(instance, schema, options, ctx);
      if (!schema["enum"].some(helpers.deepCompareStrict.bind(null, instance))) {
        result.addError({
          name: "enum",
          argument: schema["enum"],
          message: "is not one of enum values: " + schema["enum"].map(String).join(",")
        });
      }
      return result;
    };
    validators["const"] = function validateEnum(instance, schema, options, ctx) {
      if (instance === void 0) {
        return null;
      }
      var result = new ValidatorResult(instance, schema, options, ctx);
      if (!helpers.deepCompareStrict(schema["const"], instance)) {
        result.addError({
          name: "const",
          argument: schema["const"],
          message: "does not exactly match expected constant: " + schema["const"]
        });
      }
      return result;
    };
    validators.not = validators.disallow = function validateNot(instance, schema, options, ctx) {
      var self2 = this;
      if (instance === void 0)
        return null;
      var result = new ValidatorResult(instance, schema, options, ctx);
      var notTypes = schema.not || schema.disallow;
      if (!notTypes)
        return null;
      if (!Array.isArray(notTypes))
        notTypes = [notTypes];
      notTypes.forEach(function(type) {
        if (self2.testType(instance, schema, options, ctx, type)) {
          var id = type && (type.$id || type.id);
          var schemaId = id || type;
          result.addError({
            name: "not",
            argument: schemaId,
            message: "is of prohibited type " + schemaId
          });
        }
      });
      return result;
    };
    module2.exports = attribute;
  }
});

// node_modules/jsonschema/lib/scan.js
var require_scan = __commonJS({
  "node_modules/jsonschema/lib/scan.js"(exports, module2) {
    "use strict";
    var urilib = require("url");
    var helpers = require_helpers();
    module2.exports.SchemaScanResult = SchemaScanResult;
    function SchemaScanResult(found, ref) {
      this.id = found;
      this.ref = ref;
    }
    module2.exports.scan = function scan(base, schema) {
      function scanSchema(baseuri, schema2) {
        if (!schema2 || typeof schema2 != "object")
          return;
        if (schema2.$ref) {
          var resolvedUri = urilib.resolve(baseuri, schema2.$ref);
          ref[resolvedUri] = ref[resolvedUri] ? ref[resolvedUri] + 1 : 0;
          return;
        }
        var id = schema2.$id || schema2.id;
        var ourBase = id ? urilib.resolve(baseuri, id) : baseuri;
        if (ourBase) {
          if (ourBase.indexOf("#") < 0)
            ourBase += "#";
          if (found[ourBase]) {
            if (!helpers.deepCompareStrict(found[ourBase], schema2)) {
              throw new Error("Schema <" + ourBase + "> already exists with different definition");
            }
            return found[ourBase];
          }
          found[ourBase] = schema2;
          if (ourBase[ourBase.length - 1] == "#") {
            found[ourBase.substring(0, ourBase.length - 1)] = schema2;
          }
        }
        scanArray(ourBase + "/items", Array.isArray(schema2.items) ? schema2.items : [schema2.items]);
        scanArray(ourBase + "/extends", Array.isArray(schema2.extends) ? schema2.extends : [schema2.extends]);
        scanSchema(ourBase + "/additionalItems", schema2.additionalItems);
        scanObject(ourBase + "/properties", schema2.properties);
        scanSchema(ourBase + "/additionalProperties", schema2.additionalProperties);
        scanObject(ourBase + "/definitions", schema2.definitions);
        scanObject(ourBase + "/patternProperties", schema2.patternProperties);
        scanObject(ourBase + "/dependencies", schema2.dependencies);
        scanArray(ourBase + "/disallow", schema2.disallow);
        scanArray(ourBase + "/allOf", schema2.allOf);
        scanArray(ourBase + "/anyOf", schema2.anyOf);
        scanArray(ourBase + "/oneOf", schema2.oneOf);
        scanSchema(ourBase + "/not", schema2.not);
      }
      function scanArray(baseuri, schemas) {
        if (!Array.isArray(schemas))
          return;
        for (var i = 0; i < schemas.length; i++) {
          scanSchema(baseuri + "/" + i, schemas[i]);
        }
      }
      function scanObject(baseuri, schemas) {
        if (!schemas || typeof schemas != "object")
          return;
        for (var p in schemas) {
          scanSchema(baseuri + "/" + p, schemas[p]);
        }
      }
      var found = {};
      var ref = {};
      scanSchema(base, schema);
      return new SchemaScanResult(found, ref);
    };
  }
});

// node_modules/jsonschema/lib/validator.js
var require_validator = __commonJS({
  "node_modules/jsonschema/lib/validator.js"(exports, module2) {
    "use strict";
    var urilib = require("url");
    var attribute = require_attribute();
    var helpers = require_helpers();
    var scanSchema = require_scan().scan;
    var ValidatorResult = helpers.ValidatorResult;
    var ValidatorResultError = helpers.ValidatorResultError;
    var SchemaError = helpers.SchemaError;
    var SchemaContext = helpers.SchemaContext;
    var anonymousBase = "/";
    var Validator = function Validator2() {
      this.customFormats = Object.create(Validator2.prototype.customFormats);
      this.schemas = {};
      this.unresolvedRefs = [];
      this.types = Object.create(types);
      this.attributes = Object.create(attribute.validators);
    };
    Validator.prototype.customFormats = {};
    Validator.prototype.schemas = null;
    Validator.prototype.types = null;
    Validator.prototype.attributes = null;
    Validator.prototype.unresolvedRefs = null;
    Validator.prototype.addSchema = function addSchema(schema, base) {
      var self2 = this;
      if (!schema) {
        return null;
      }
      var scan = scanSchema(base || anonymousBase, schema);
      var ourUri = base || schema.$id || schema.id;
      for (var uri in scan.id) {
        this.schemas[uri] = scan.id[uri];
      }
      for (var uri in scan.ref) {
        this.unresolvedRefs.push(uri);
      }
      this.unresolvedRefs = this.unresolvedRefs.filter(function(uri2) {
        return typeof self2.schemas[uri2] === "undefined";
      });
      return this.schemas[ourUri];
    };
    Validator.prototype.addSubSchemaArray = function addSubSchemaArray(baseuri, schemas) {
      if (!Array.isArray(schemas))
        return;
      for (var i = 0; i < schemas.length; i++) {
        this.addSubSchema(baseuri, schemas[i]);
      }
    };
    Validator.prototype.addSubSchemaObject = function addSubSchemaArray(baseuri, schemas) {
      if (!schemas || typeof schemas != "object")
        return;
      for (var p in schemas) {
        this.addSubSchema(baseuri, schemas[p]);
      }
    };
    Validator.prototype.setSchemas = function setSchemas(schemas) {
      this.schemas = schemas;
    };
    Validator.prototype.getSchema = function getSchema(urn) {
      return this.schemas[urn];
    };
    Validator.prototype.validate = function validate(instance, schema, options, ctx) {
      if (typeof schema !== "boolean" && typeof schema !== "object" || schema === null) {
        throw new SchemaError("Expected `schema` to be an object or boolean");
      }
      if (!options) {
        options = {};
      }
      var id = schema.$id || schema.id;
      var base = urilib.resolve(options.base || anonymousBase, id || "");
      if (!ctx) {
        ctx = new SchemaContext(schema, options, [], base, Object.create(this.schemas));
        if (!ctx.schemas[base]) {
          ctx.schemas[base] = schema;
        }
        var found = scanSchema(base, schema);
        for (var n in found.id) {
          var sch = found.id[n];
          ctx.schemas[n] = sch;
        }
      }
      if (options.required && instance === void 0) {
        var result = new ValidatorResult(instance, schema, options, ctx);
        result.addError("is required, but is undefined");
        return result;
      }
      var result = this.validateSchema(instance, schema, options, ctx);
      if (!result) {
        throw new Error("Result undefined");
      } else if (options.throwAll && result.errors.length) {
        throw new ValidatorResultError(result);
      }
      return result;
    };
    function shouldResolve(schema) {
      var ref = typeof schema === "string" ? schema : schema.$ref;
      if (typeof ref == "string")
        return ref;
      return false;
    }
    Validator.prototype.validateSchema = function validateSchema(instance, schema, options, ctx) {
      var result = new ValidatorResult(instance, schema, options, ctx);
      if (typeof schema === "boolean") {
        if (schema === true) {
          schema = {};
        } else if (schema === false) {
          schema = { type: [] };
        }
      } else if (!schema) {
        throw new Error("schema is undefined");
      }
      if (schema["extends"]) {
        if (Array.isArray(schema["extends"])) {
          var schemaobj = { schema, ctx };
          schema["extends"].forEach(this.schemaTraverser.bind(this, schemaobj));
          schema = schemaobj.schema;
          schemaobj.schema = null;
          schemaobj.ctx = null;
          schemaobj = null;
        } else {
          schema = helpers.deepMerge(schema, this.superResolve(schema["extends"], ctx));
        }
      }
      var switchSchema = shouldResolve(schema);
      if (switchSchema) {
        var resolved = this.resolve(schema, switchSchema, ctx);
        var subctx = new SchemaContext(resolved.subschema, options, ctx.path, resolved.switchSchema, ctx.schemas);
        return this.validateSchema(instance, resolved.subschema, options, subctx);
      }
      var skipAttributes = options && options.skipAttributes || [];
      for (var key in schema) {
        if (!attribute.ignoreProperties[key] && skipAttributes.indexOf(key) < 0) {
          var validatorErr = null;
          var validator = this.attributes[key];
          if (validator) {
            validatorErr = validator.call(this, instance, schema, options, ctx);
          } else if (options.allowUnknownAttributes === false) {
            throw new SchemaError("Unsupported attribute: " + key, schema);
          }
          if (validatorErr) {
            result.importErrors(validatorErr);
          }
        }
      }
      if (typeof options.rewrite == "function") {
        var value = options.rewrite.call(this, instance, schema, options, ctx);
        result.instance = value;
      }
      return result;
    };
    Validator.prototype.schemaTraverser = function schemaTraverser(schemaobj, s) {
      schemaobj.schema = helpers.deepMerge(schemaobj.schema, this.superResolve(s, schemaobj.ctx));
    };
    Validator.prototype.superResolve = function superResolve(schema, ctx) {
      var ref = shouldResolve(schema);
      if (ref) {
        return this.resolve(schema, ref, ctx).subschema;
      }
      return schema;
    };
    Validator.prototype.resolve = function resolve(schema, switchSchema, ctx) {
      switchSchema = ctx.resolve(switchSchema);
      if (ctx.schemas[switchSchema]) {
        return { subschema: ctx.schemas[switchSchema], switchSchema };
      }
      var parsed = urilib.parse(switchSchema);
      var fragment = parsed && parsed.hash;
      var document = fragment && fragment.length && switchSchema.substr(0, switchSchema.length - fragment.length);
      if (!document || !ctx.schemas[document]) {
        throw new SchemaError("no such schema <" + switchSchema + ">", schema);
      }
      var subschema = helpers.objectGetPath(ctx.schemas[document], fragment.substr(1));
      if (subschema === void 0) {
        throw new SchemaError("no such schema " + fragment + " located in <" + document + ">", schema);
      }
      return { subschema, switchSchema };
    };
    Validator.prototype.testType = function validateType(instance, schema, options, ctx, type) {
      if (type === void 0) {
        return;
      } else if (type === null) {
        throw new SchemaError('Unexpected null in "type" keyword');
      }
      if (typeof this.types[type] == "function") {
        return this.types[type].call(this, instance);
      }
      if (type && typeof type == "object") {
        var res = this.validateSchema(instance, type, options, ctx);
        return res === void 0 || !(res && res.errors.length);
      }
      return true;
    };
    var types = Validator.prototype.types = {};
    types.string = function testString(instance) {
      return typeof instance == "string";
    };
    types.number = function testNumber(instance) {
      return typeof instance == "number" && isFinite(instance);
    };
    types.integer = function testInteger(instance) {
      return typeof instance == "number" && instance % 1 === 0;
    };
    types.boolean = function testBoolean(instance) {
      return typeof instance == "boolean";
    };
    types.array = function testArray(instance) {
      return Array.isArray(instance);
    };
    types["null"] = function testNull(instance) {
      return instance === null;
    };
    types.date = function testDate(instance) {
      return instance instanceof Date;
    };
    types.any = function testAny(instance) {
      return true;
    };
    types.object = function testObject(instance) {
      return instance && typeof instance === "object" && !Array.isArray(instance) && !(instance instanceof Date);
    };
    module2.exports = Validator;
  }
});

// node_modules/jsonschema/lib/index.js
var require_lib4 = __commonJS({
  "node_modules/jsonschema/lib/index.js"(exports, module2) {
    "use strict";
    var Validator = module2.exports.Validator = require_validator();
    module2.exports.ValidatorResult = require_helpers().ValidatorResult;
    module2.exports.ValidatorResultError = require_helpers().ValidatorResultError;
    module2.exports.ValidationError = require_helpers().ValidationError;
    module2.exports.SchemaError = require_helpers().SchemaError;
    module2.exports.SchemaScanResult = require_scan().SchemaScanResult;
    module2.exports.scan = require_scan().scan;
    module2.exports.validate = function(instance, schema, options) {
      var v = new Validator();
      return v.validate(instance, schema, options);
    };
  }
});

// node_modules/@jsii/spec/schema/jsii-spec.schema.json
var require_jsii_spec_schema = __commonJS({
  "node_modules/@jsii/spec/schema/jsii-spec.schema.json"(exports, module2) {
    module2.exports = {
      $ref: "#/definitions/Assembly",
      $schema: "http://json-schema.org/draft-07/schema#",
      definitions: {
        Assembly: {
          description: "A JSII assembly specification.",
          properties: {
            author: {
              $ref: "#/definitions/Person",
              description: "The main author of this package."
            },
            bin: {
              additionalProperties: {
                type: "string"
              },
              default: "none",
              description: "List of bin-scripts",
              type: "object"
            },
            bundled: {
              additionalProperties: {
                type: "string"
              },
              default: "none",
              description: "List if bundled dependencies (these are not expected to be jsii\nassemblies).",
              type: "object"
            },
            contributors: {
              default: "none",
              description: "Additional contributors to this package.",
              items: {
                $ref: "#/definitions/Person"
              },
              type: "array"
            },
            dependencies: {
              additionalProperties: {
                type: "string"
              },
              default: "none",
              description: "Direct dependencies on other assemblies (with semver), the key is the JSII\nassembly name, and the value is a SemVer expression.",
              type: "object"
            },
            dependencyClosure: {
              additionalProperties: {
                $ref: "#/definitions/AssemblyConfiguration"
              },
              default: "none",
              description: "Target configuration for all the assemblies that are direct or transitive\ndependencies of this assembly. This is needed to generate correct native\ntype names for any transitively inherited member, in certain languages.",
              type: "object"
            },
            description: {
              description: 'Description of the assembly, maps to "description" from package.json\nThis is required since some package managers (like Maven) require it.',
              type: "string"
            },
            docs: {
              $ref: "#/definitions/Docs",
              default: "none",
              description: "Documentation for this entity."
            },
            fingerprint: {
              description: "A fingerprint that can be used to determine if the specification has\nchanged.",
              minLength: 1,
              type: "string"
            },
            homepage: {
              description: 'The url to the project homepage. Maps to "homepage" from package.json.',
              type: "string"
            },
            jsiiVersion: {
              description: "The version of the jsii compiler that was used to produce this Assembly.",
              minLength: 1,
              type: "string"
            },
            keywords: {
              description: "Keywords that help discover or identify this packages with respects to it's\nintended usage, audience, etc... Where possible, this will be rendered in\nthe corresponding metadata section of idiomatic package manifests, for\nexample NuGet package tags.",
              items: {
                type: "string"
              },
              type: "array"
            },
            license: {
              description: "The SPDX name of the license this assembly is distributed on.",
              type: "string"
            },
            metadata: {
              additionalProperties: {},
              default: "none",
              description: "Arbitrary key-value pairs of metadata, which the maintainer chose to\ndocument with the assembly. These entries do not carry normative\nsemantics and their interpretation is up to the assembly maintainer.",
              type: "object"
            },
            name: {
              description: "The name of the assembly",
              minLength: 1,
              type: "string"
            },
            readme: {
              $ref: "#/definitions/ReadMe",
              default: "none",
              description: "The readme document for this module (if any)."
            },
            repository: {
              description: 'The module repository, maps to "repository" from package.json\nThis is required since some package managers (like Maven) require it.',
              properties: {
                directory: {
                  default: "the root of the repository",
                  description: "If the package is not in the root directory (for example, when part\nof a monorepo), you should specify the directory in which it lives.",
                  type: "string"
                },
                type: {
                  description: "The type of the repository (``git``, ``svn``, ...)",
                  type: "string"
                },
                url: {
                  description: "The URL of the repository.",
                  type: "string"
                }
              },
              required: [
                "type",
                "url"
              ],
              type: "object"
            },
            schema: {
              description: "The version of the spec schema",
              enum: [
                "jsii/0.10.0"
              ],
              type: "string"
            },
            submodules: {
              additionalProperties: {
                allOf: [
                  {
                    $ref: "#/definitions/SourceLocatable"
                  },
                  {
                    $ref: "#/definitions/Targetable"
                  }
                ],
                description: "A submodule\n\nThe difference between a top-level module (the assembly) and a submodule is\nthat the submodule is annotated with its location in the repository."
              },
              default: "none",
              description: "Submodules declared in this assembly.",
              type: "object"
            },
            targets: {
              $ref: "#/definitions/AssemblyTargets",
              default: "none",
              description: "A map of target name to configuration, which is used when generating\npackages for various languages."
            },
            types: {
              additionalProperties: {
                anyOf: [
                  {
                    allOf: [
                      {
                        $ref: "#/definitions/TypeBase"
                      },
                      {
                        $ref: "#/definitions/ClassType"
                      }
                    ]
                  },
                  {
                    allOf: [
                      {
                        $ref: "#/definitions/TypeBase"
                      },
                      {
                        $ref: "#/definitions/EnumType"
                      }
                    ]
                  },
                  {
                    allOf: [
                      {
                        $ref: "#/definitions/TypeBase"
                      },
                      {
                        $ref: "#/definitions/InterfaceType"
                      }
                    ]
                  }
                ],
                description: "Represents a type definition (not a type reference)."
              },
              default: "none",
              description: "All types in the assembly, keyed by their fully-qualified-name",
              type: "object"
            },
            version: {
              description: "The version of the assembly",
              minLength: 1,
              type: "string"
            }
          },
          required: [
            "author",
            "description",
            "fingerprint",
            "homepage",
            "jsiiVersion",
            "license",
            "name",
            "repository",
            "schema",
            "version"
          ],
          type: "object"
        },
        AssemblyConfiguration: {
          description: "Shareable configuration of a jsii Assembly.",
          properties: {
            readme: {
              $ref: "#/definitions/ReadMe",
              default: "none",
              description: "The readme document for this module (if any)."
            },
            submodules: {
              additionalProperties: {
                allOf: [
                  {
                    $ref: "#/definitions/SourceLocatable"
                  },
                  {
                    $ref: "#/definitions/Targetable"
                  }
                ],
                description: "A submodule\n\nThe difference between a top-level module (the assembly) and a submodule is\nthat the submodule is annotated with its location in the repository."
              },
              default: "none",
              description: "Submodules declared in this assembly.",
              type: "object"
            },
            targets: {
              $ref: "#/definitions/AssemblyTargets",
              default: "none",
              description: "A map of target name to configuration, which is used when generating\npackages for various languages."
            }
          },
          type: "object"
        },
        AssemblyTargets: {
          additionalProperties: {
            additionalProperties: {},
            type: "object"
          },
          description: "Configurable targets for an asembly.",
          type: "object"
        },
        Callable: {
          description: "An Initializer or a Method.",
          properties: {
            docs: {
              $ref: "#/definitions/Docs",
              default: "none",
              description: "Documentation for this entity."
            },
            locationInModule: {
              $ref: "#/definitions/SourceLocation",
              default: "none",
              description: "Where in the module this definition was found\n\nWhy is this not `locationInAssembly`? Because the assembly is the JSII\nfile combining compiled code and its manifest, whereas this is referring\nto the location of the source in the module the assembly was built from."
            },
            overrides: {
              default: "this member is not overriding anything",
              description: "The FQN of the parent type (class or interface) that this entity\noverrides or implements. If undefined, then this entity is the first in\nit's hierarchy to declare this entity.",
              type: "string"
            },
            parameters: {
              default: "none",
              description: "The parameters of the Initializer or Method.",
              items: {
                $ref: "#/definitions/Parameter"
              },
              type: "array"
            },
            protected: {
              default: false,
              description: "Indicates if this Initializer or Method is protected (otherwise it is\npublic, since private members are not modeled).",
              type: "boolean"
            },
            variadic: {
              default: false,
              description: "Indicates whether this Initializer or Method is variadic or not. When\n``true``, the last element of ``#parameters`` will also be flagged\n``#variadic``.",
              type: "boolean"
            }
          },
          type: "object"
        },
        ClassType: {
          description: "Represents classes.",
          properties: {
            abstract: {
              default: false,
              description: "Indicates if this class is an abstract class.",
              type: "boolean"
            },
            assembly: {
              description: "The name of the assembly the type belongs to.",
              minLength: 1,
              type: "string"
            },
            base: {
              default: "no base class",
              description: "The FQN of the base class of this class, if it has one.",
              type: "string"
            },
            docs: {
              $ref: "#/definitions/Docs",
              default: "none",
              description: "Documentation for this entity."
            },
            fqn: {
              description: "The fully qualified name of the type (``<assembly>.<namespace>.<name>``)",
              minLength: 3,
              type: "string"
            },
            initializer: {
              $ref: "#/definitions/Callable",
              default: "no initializer",
              description: "Initializer (constructor) method."
            },
            interfaces: {
              default: "none",
              description: "The FQNs of the interfaces this class implements, if any.",
              items: {
                type: "string"
              },
              type: "array",
              uniqueItems: true
            },
            kind: {
              description: "The kind of the type.",
              enum: [
                "class"
              ],
              type: "string"
            },
            locationInModule: {
              $ref: "#/definitions/SourceLocation",
              default: "none",
              description: "Where in the module this definition was found\n\nWhy is this not `locationInAssembly`? Because the assembly is the JSII\nfile combining compiled code and its manifest, whereas this is referring\nto the location of the source in the module the assembly was built from."
            },
            methods: {
              default: "none",
              description: "List of methods.",
              items: {
                $ref: "#/definitions/Method"
              },
              type: "array"
            },
            name: {
              description: "The simple name of the type (MyClass).",
              minLength: 1,
              type: "string"
            },
            namespace: {
              default: "none",
              description: "The namespace of the type (`foo.bar.baz`).\n\nWhen undefined, the type is located at the root of the assembly (its\n`fqn` would be like `<assembly>.<name>`).\n\nFor types inside other types or inside submodules, the `<namespace>` corresponds to\nthe namespace-qualified name of the container (can contain multiple segments like:\n`<ns1>.<ns2>.<ns3>`).\n\nIn all cases:\n\n <fqn> = <assembly>[.<namespace>].<name>",
              type: "string"
            },
            properties: {
              default: "none",
              description: "List of properties.",
              items: {
                $ref: "#/definitions/Property"
              },
              type: "array"
            },
            symbolId: {
              description: "Unique string representation of the corresponding Typescript symbol",
              type: "string"
            }
          },
          required: [
            "assembly",
            "fqn",
            "kind",
            "name"
          ],
          type: "object"
        },
        CollectionKind: {
          description: "Kinds of collections.",
          enum: [
            "array",
            "map"
          ],
          type: "string"
        },
        CollectionTypeReference: {
          description: "Reference to a collection type.",
          properties: {
            collection: {
              properties: {
                elementtype: {
                  $ref: "#/definitions/TypeReference",
                  description: "The type of an element (map keys are always strings)."
                },
                kind: {
                  $ref: "#/definitions/CollectionKind",
                  description: "The kind of collection."
                }
              },
              required: [
                "elementtype",
                "kind"
              ],
              type: "object"
            }
          },
          required: [
            "collection"
          ],
          type: "object"
        },
        Docs: {
          description: "Key value pairs of documentation nodes.\nBased on TSDoc.",
          properties: {
            custom: {
              additionalProperties: {
                type: "string"
              },
              default: "none",
              description: "Custom tags that are not any of the default ones",
              type: "object"
            },
            default: {
              default: "none",
              description: "Description of the default",
              type: "string"
            },
            deprecated: {
              default: "none",
              description: "If present, this block indicates that an API item is no longer supported\nand may be removed in a future release.  The `@deprecated` tag must be\nfollowed by a sentence describing the recommended alternative.\nDeprecation recursively applies to members of a container. For example,\nif a class is deprecated, then so are all of its members.",
              type: "string"
            },
            example: {
              default: "none",
              description: "Example showing the usage of this API item\n\nStarts off in running text mode, may switch to code using fenced code\nblocks.",
              type: "string"
            },
            remarks: {
              default: "none",
              description: "Detailed information about an API item.\n\nEither the explicitly tagged `@remarks` section, otherwise everything\npast the first paragraph if there is no `@remarks` tag.",
              type: "string"
            },
            returns: {
              default: "none",
              description: "The `@returns` block for this doc comment, or undefined if there is not\none.",
              type: "string"
            },
            see: {
              default: "none",
              description: "A `@see` link with more information",
              type: "string"
            },
            stability: {
              description: "Whether the API item is beta/experimental quality",
              enum: [
                "deprecated",
                "experimental",
                "external",
                "stable"
              ],
              type: "string"
            },
            subclassable: {
              default: false,
              description: "Whether this class or interface was intended to be subclassed/implemented\nby library users.\n\nClasses intended for subclassing, and interfaces intended to be\nimplemented by consumers, are held to stricter standards of API\ncompatibility.",
              type: "boolean"
            },
            summary: {
              default: "none",
              description: "Summary documentation for an API item.\n\nThe first part of the documentation before hitting a `@remarks` tags, or\nthe first line of the doc comment block if there is no `@remarks` tag.",
              type: "string"
            }
          },
          type: "object"
        },
        EnumMember: {
          description: "Represents a member of an enum.",
          properties: {
            docs: {
              $ref: "#/definitions/Docs",
              default: "none",
              description: "Documentation for this entity."
            },
            name: {
              description: "The name/symbol of the member.",
              type: "string"
            }
          },
          required: [
            "name"
          ],
          type: "object"
        },
        EnumType: {
          description: "Represents an enum type.",
          properties: {
            assembly: {
              description: "The name of the assembly the type belongs to.",
              minLength: 1,
              type: "string"
            },
            docs: {
              $ref: "#/definitions/Docs",
              default: "none",
              description: "Documentation for this entity."
            },
            fqn: {
              description: "The fully qualified name of the type (``<assembly>.<namespace>.<name>``)",
              minLength: 3,
              type: "string"
            },
            kind: {
              description: "The kind of the type.",
              enum: [
                "enum"
              ],
              type: "string"
            },
            locationInModule: {
              $ref: "#/definitions/SourceLocation",
              default: "none",
              description: "Where in the module this definition was found\n\nWhy is this not `locationInAssembly`? Because the assembly is the JSII\nfile combining compiled code and its manifest, whereas this is referring\nto the location of the source in the module the assembly was built from."
            },
            members: {
              description: "Members of the enum.",
              items: {
                $ref: "#/definitions/EnumMember"
              },
              type: "array"
            },
            name: {
              description: "The simple name of the type (MyClass).",
              minLength: 1,
              type: "string"
            },
            namespace: {
              default: "none",
              description: "The namespace of the type (`foo.bar.baz`).\n\nWhen undefined, the type is located at the root of the assembly (its\n`fqn` would be like `<assembly>.<name>`).\n\nFor types inside other types or inside submodules, the `<namespace>` corresponds to\nthe namespace-qualified name of the container (can contain multiple segments like:\n`<ns1>.<ns2>.<ns3>`).\n\nIn all cases:\n\n <fqn> = <assembly>[.<namespace>].<name>",
              type: "string"
            },
            symbolId: {
              description: "Unique string representation of the corresponding Typescript symbol",
              type: "string"
            }
          },
          required: [
            "assembly",
            "fqn",
            "kind",
            "members",
            "name"
          ],
          type: "object"
        },
        InterfaceType: {
          properties: {
            assembly: {
              description: "The name of the assembly the type belongs to.",
              minLength: 1,
              type: "string"
            },
            datatype: {
              default: false,
              description: "True if this interface only contains properties. Different backends might\nhave idiomatic ways to allow defining concrete instances such interfaces.\nFor example, in Java, the generator will produce a PoJo and a builder\nwhich will allow users to create a concrete object with data which\nadheres to this interface.",
              type: "boolean"
            },
            docs: {
              $ref: "#/definitions/Docs",
              default: "none",
              description: "Documentation for this entity."
            },
            fqn: {
              description: "The fully qualified name of the type (``<assembly>.<namespace>.<name>``)",
              minLength: 3,
              type: "string"
            },
            interfaces: {
              default: "none",
              description: "The FQNs of the interfaces this interface extends, if any.",
              items: {
                type: "string"
              },
              type: "array",
              uniqueItems: true
            },
            kind: {
              description: "The kind of the type.",
              enum: [
                "interface"
              ],
              type: "string"
            },
            locationInModule: {
              $ref: "#/definitions/SourceLocation",
              default: "none",
              description: "Where in the module this definition was found\n\nWhy is this not `locationInAssembly`? Because the assembly is the JSII\nfile combining compiled code and its manifest, whereas this is referring\nto the location of the source in the module the assembly was built from."
            },
            methods: {
              default: "none",
              description: "List of methods.",
              items: {
                $ref: "#/definitions/Method"
              },
              type: "array"
            },
            name: {
              description: "The simple name of the type (MyClass).",
              minLength: 1,
              type: "string"
            },
            namespace: {
              default: "none",
              description: "The namespace of the type (`foo.bar.baz`).\n\nWhen undefined, the type is located at the root of the assembly (its\n`fqn` would be like `<assembly>.<name>`).\n\nFor types inside other types or inside submodules, the `<namespace>` corresponds to\nthe namespace-qualified name of the container (can contain multiple segments like:\n`<ns1>.<ns2>.<ns3>`).\n\nIn all cases:\n\n <fqn> = <assembly>[.<namespace>].<name>",
              type: "string"
            },
            properties: {
              default: "none",
              description: "List of properties.",
              items: {
                $ref: "#/definitions/Property"
              },
              type: "array"
            },
            symbolId: {
              description: "Unique string representation of the corresponding Typescript symbol",
              type: "string"
            }
          },
          required: [
            "assembly",
            "fqn",
            "kind",
            "name"
          ],
          type: "object"
        },
        Method: {
          description: "A method with a name (i.e: not an initializer).",
          properties: {
            abstract: {
              default: false,
              description: "Is this method an abstract method (this means the class will also be an abstract class)",
              type: "boolean"
            },
            async: {
              default: false,
              description: "Indicates if this is an asynchronous method (it will return a promise).",
              type: "boolean"
            },
            docs: {
              $ref: "#/definitions/Docs",
              default: "none",
              description: "Documentation for this entity."
            },
            locationInModule: {
              $ref: "#/definitions/SourceLocation",
              default: "none",
              description: "Where in the module this definition was found\n\nWhy is this not `locationInAssembly`? Because the assembly is the JSII\nfile combining compiled code and its manifest, whereas this is referring\nto the location of the source in the module the assembly was built from."
            },
            name: {
              description: "The name of the method. Undefined if this method is a initializer.",
              type: "string"
            },
            overrides: {
              default: "this member is not overriding anything",
              description: "The FQN of the parent type (class or interface) that this entity\noverrides or implements. If undefined, then this entity is the first in\nit's hierarchy to declare this entity.",
              type: "string"
            },
            parameters: {
              default: "none",
              description: "The parameters of the Initializer or Method.",
              items: {
                $ref: "#/definitions/Parameter"
              },
              type: "array"
            },
            protected: {
              default: false,
              description: "Indicates if this Initializer or Method is protected (otherwise it is\npublic, since private members are not modeled).",
              type: "boolean"
            },
            returns: {
              $ref: "#/definitions/OptionalValue",
              default: "void",
              description: "The return type of the method (`undefined` if `void`)"
            },
            static: {
              default: false,
              description: "Indicates if this is a static method.",
              type: "boolean"
            },
            variadic: {
              default: false,
              description: "Indicates whether this Initializer or Method is variadic or not. When\n``true``, the last element of ``#parameters`` will also be flagged\n``#variadic``.",
              type: "boolean"
            }
          },
          required: [
            "name"
          ],
          type: "object"
        },
        NamedTypeReference: {
          description: "Reference to a named type, defined by this assembly or one of its\ndependencies.",
          properties: {
            fqn: {
              description: "The fully-qualified-name of the type (can be located in the\n``spec.types[fqn]``` of the assembly that defines the type).",
              type: "string"
            }
          },
          required: [
            "fqn"
          ],
          type: "object"
        },
        OptionalValue: {
          description: "A value that can possibly be optional.",
          properties: {
            optional: {
              default: false,
              description: "Determines whether the value is, indeed, optional.",
              type: "boolean"
            },
            type: {
              $ref: "#/definitions/TypeReference",
              description: "The declared type of the value, when it's present."
            }
          },
          required: [
            "type"
          ],
          type: "object"
        },
        Parameter: {
          description: "Represents a method parameter.",
          properties: {
            docs: {
              $ref: "#/definitions/Docs",
              default: "none",
              description: "Documentation for this entity."
            },
            name: {
              description: "The name of the parameter.",
              minLength: 1,
              type: "string"
            },
            optional: {
              default: false,
              description: "Determines whether the value is, indeed, optional.",
              type: "boolean"
            },
            type: {
              $ref: "#/definitions/TypeReference",
              description: "The declared type of the value, when it's present."
            },
            variadic: {
              default: false,
              description: "Whether this is the last parameter of a variadic method. In such cases,\nthe `#type` attribute is the type of each individual item of the variadic\narguments list (as opposed to some array type, as for example TypeScript\nwould model it).",
              type: "boolean"
            }
          },
          required: [
            "name",
            "type"
          ],
          type: "object"
        },
        Person: {
          description: "Metadata about people or organizations associated with the project that\nresulted in the Assembly. Some of this metadata is required in order to\npublish to certain package repositories (for example, Maven Central), but is\nnot normalized, and the meaning of fields (role, for example), is up to each\nproject maintainer.",
          properties: {
            email: {
              default: "none",
              description: "The email of the person",
              type: "string"
            },
            name: {
              description: "The name of the person",
              type: "string"
            },
            organization: {
              default: false,
              description: "If true, this person is, in fact, an organization",
              type: "boolean"
            },
            roles: {
              description: "A list of roles this person has in the project, for example `maintainer`,\n`contributor`, `owner`, ...",
              items: {
                type: "string"
              },
              type: "array"
            },
            url: {
              default: "none",
              description: "The URL for the person",
              type: "string"
            }
          },
          required: [
            "name",
            "roles"
          ],
          type: "object"
        },
        PrimitiveType: {
          description: "Kinds of primitive types.",
          enum: [
            "any",
            "boolean",
            "date",
            "json",
            "number",
            "string"
          ],
          type: "string"
        },
        PrimitiveTypeReference: {
          description: "Reference to a primitive type.",
          properties: {
            primitive: {
              $ref: "#/definitions/PrimitiveType",
              description: "If this is a reference to a primitive type, this will include the\nprimitive type kind."
            }
          },
          required: [
            "primitive"
          ],
          type: "object"
        },
        Property: {
          description: "A class property.",
          properties: {
            abstract: {
              default: false,
              description: "Indicates if this property is abstract",
              type: "boolean"
            },
            const: {
              default: false,
              description: 'A hint that indicates that this static, immutable property is initialized\nduring startup. This allows emitting "const" idioms in different target\nlanguages. Implies `static` and `immutable`.',
              type: "boolean"
            },
            docs: {
              $ref: "#/definitions/Docs",
              default: "none",
              description: "Documentation for this entity."
            },
            immutable: {
              default: false,
              description: "Indicates if this property only has a getter (immutable).",
              type: "boolean"
            },
            locationInModule: {
              $ref: "#/definitions/SourceLocation",
              default: "none",
              description: "Where in the module this definition was found\n\nWhy is this not `locationInAssembly`? Because the assembly is the JSII\nfile combining compiled code and its manifest, whereas this is referring\nto the location of the source in the module the assembly was built from."
            },
            name: {
              description: "The name of the property.",
              minLength: 1,
              type: "string"
            },
            optional: {
              default: false,
              description: "Determines whether the value is, indeed, optional.",
              type: "boolean"
            },
            overrides: {
              default: "this member is not overriding anything",
              description: "The FQN of the parent type (class or interface) that this entity\noverrides or implements. If undefined, then this entity is the first in\nit's hierarchy to declare this entity.",
              type: "string"
            },
            protected: {
              default: false,
              description: "Indicates if this property is protected (otherwise it is public)",
              type: "boolean"
            },
            static: {
              default: false,
              description: "Indicates if this is a static property.",
              type: "boolean"
            },
            type: {
              $ref: "#/definitions/TypeReference",
              description: "The declared type of the value, when it's present."
            }
          },
          required: [
            "name",
            "type"
          ],
          type: "object"
        },
        ReadMe: {
          description: "README information",
          properties: {
            markdown: {
              type: "string"
            }
          },
          required: [
            "markdown"
          ],
          type: "object"
        },
        SourceLocatable: {
          description: "Indicates that an entity has a source location",
          properties: {
            locationInModule: {
              $ref: "#/definitions/SourceLocation",
              default: "none",
              description: "Where in the module this definition was found\n\nWhy is this not `locationInAssembly`? Because the assembly is the JSII\nfile combining compiled code and its manifest, whereas this is referring\nto the location of the source in the module the assembly was built from."
            }
          },
          type: "object"
        },
        SourceLocation: {
          description: "Where in the module source the definition for this API item was found",
          properties: {
            filename: {
              description: "Relative filename",
              type: "string"
            },
            line: {
              description: "1-based line number in the indicated file",
              type: "number"
            }
          },
          required: [
            "filename",
            "line"
          ],
          type: "object"
        },
        Targetable: {
          description: "A targetable module-like thing\n\nHas targets and a readme. Used for Assemblies and Submodules.",
          properties: {
            readme: {
              $ref: "#/definitions/ReadMe",
              default: "none",
              description: "The readme document for this module (if any)."
            },
            targets: {
              $ref: "#/definitions/AssemblyTargets",
              default: "none",
              description: "A map of target name to configuration, which is used when generating\npackages for various languages."
            }
          },
          type: "object"
        },
        TypeBase: {
          description: "Common attributes of a type definition.",
          properties: {
            assembly: {
              description: "The name of the assembly the type belongs to.",
              minLength: 1,
              type: "string"
            },
            docs: {
              $ref: "#/definitions/Docs",
              default: "none",
              description: "Documentation for this entity."
            },
            fqn: {
              description: "The fully qualified name of the type (``<assembly>.<namespace>.<name>``)",
              minLength: 3,
              type: "string"
            },
            kind: {
              $ref: "#/definitions/TypeKind",
              description: "The kind of the type."
            },
            locationInModule: {
              $ref: "#/definitions/SourceLocation",
              default: "none",
              description: "Where in the module this definition was found\n\nWhy is this not `locationInAssembly`? Because the assembly is the JSII\nfile combining compiled code and its manifest, whereas this is referring\nto the location of the source in the module the assembly was built from."
            },
            name: {
              description: "The simple name of the type (MyClass).",
              minLength: 1,
              type: "string"
            },
            namespace: {
              default: "none",
              description: "The namespace of the type (`foo.bar.baz`).\n\nWhen undefined, the type is located at the root of the assembly (its\n`fqn` would be like `<assembly>.<name>`).\n\nFor types inside other types or inside submodules, the `<namespace>` corresponds to\nthe namespace-qualified name of the container (can contain multiple segments like:\n`<ns1>.<ns2>.<ns3>`).\n\nIn all cases:\n\n <fqn> = <assembly>[.<namespace>].<name>",
              type: "string"
            },
            symbolId: {
              description: "Unique string representation of the corresponding Typescript symbol",
              type: "string"
            }
          },
          required: [
            "assembly",
            "fqn",
            "kind",
            "name"
          ],
          type: "object"
        },
        TypeKind: {
          description: "Kinds of types.",
          enum: [
            "class",
            "enum",
            "interface"
          ],
          type: "string"
        },
        TypeReference: {
          anyOf: [
            {
              $ref: "#/definitions/NamedTypeReference"
            },
            {
              $ref: "#/definitions/PrimitiveTypeReference"
            },
            {
              $ref: "#/definitions/CollectionTypeReference"
            },
            {
              $ref: "#/definitions/UnionTypeReference"
            }
          ],
          description: "A reference to a type (primitive, collection or fqn)."
        },
        UnionTypeReference: {
          description: "Reference to a union type.",
          properties: {
            union: {
              description: "Indicates that this is a union type, which means it can be one of a set\nof types.",
              properties: {
                types: {
                  description: "All the possible types (including the primary type).",
                  items: {
                    $ref: "#/definitions/TypeReference"
                  },
                  minItems: 2,
                  type: "array"
                }
              },
              required: [
                "types"
              ],
              type: "object"
            }
          },
          required: [
            "union"
          ],
          type: "object"
        }
      }
    };
  }
});

// node_modules/@jsii/spec/lib/validate-assembly.js
var require_validate_assembly = __commonJS({
  "node_modules/@jsii/spec/lib/validate-assembly.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.validateAssembly = exports.schema = void 0;
    var jsonschema_1 = require_lib4();
    exports.schema = require_jsii_spec_schema();
    function validateAssembly(obj) {
      const validator = new jsonschema_1.Validator();
      validator.addSchema(exports.schema);
      const result = validator.validate(obj, exports.schema, { nestedErrors: true });
      if (result.valid) {
        return obj;
      }
      throw new Error(`Invalid assembly:
${result.toString()}`);
    }
    exports.validateAssembly = validateAssembly;
  }
});

// node_modules/@jsii/spec/lib/index.js
var require_lib5 = __commonJS({
  "node_modules/@jsii/spec/lib/index.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        if (p !== "default" && !exports2.hasOwnProperty(p))
          __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    __exportStar(require_assembly(), exports);
    __exportStar(require_configuration(), exports);
    __exportStar(require_name_tree(), exports);
    __exportStar(require_validate_assembly(), exports);
  }
});

// node_modules/jsii-reflect/lib/docs.js
var require_docs = __commonJS({
  "node_modules/jsii-reflect/lib/docs.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Docs = void 0;
    var spec_1 = require_lib5();
    var Docs = class {
      constructor(system, target, spec, parentDocs) {
        this.system = system;
        this.target = target;
        this.parentDocs = parentDocs;
        this.docs = spec !== null && spec !== void 0 ? spec : {};
      }
      toString() {
        return [this.docs.summary, this.docs.remarks].filter((txt) => !!txt).join("\n\n");
      }
      get subclassable() {
        return !!this.docs.subclassable;
      }
      get deprecationReason() {
        if (this.docs.deprecated !== void 0) {
          return this.docs.deprecated;
        }
        if (this.parentDocs) {
          return this.parentDocs.deprecationReason;
        }
        return void 0;
      }
      get deprecated() {
        return this.deprecationReason !== void 0;
      }
      get stability() {
        var _a;
        return lowestStability(this.docs.stability, (_a = this.parentDocs) === null || _a === void 0 ? void 0 : _a.stability);
      }
      customTag(tag) {
        var _a;
        return (_a = this.docs.custom) === null || _a === void 0 ? void 0 : _a[tag];
      }
      get summary() {
        var _a;
        return (_a = this.docs.summary) !== null && _a !== void 0 ? _a : "";
      }
      get remarks() {
        var _a;
        return (_a = this.docs.remarks) !== null && _a !== void 0 ? _a : "";
      }
      get example() {
        var _a;
        return (_a = this.docs.example) !== null && _a !== void 0 ? _a : "";
      }
      get link() {
        var _a;
        return (_a = this.docs.see) !== null && _a !== void 0 ? _a : "";
      }
      get returns() {
        var _a;
        return (_a = this.docs.returns) !== null && _a !== void 0 ? _a : "";
      }
    };
    exports.Docs = Docs;
    var stabilityPrecedence = {
      [spec_1.Stability.Deprecated]: 0,
      [spec_1.Stability.Experimental]: 1,
      [spec_1.Stability.External]: 2,
      [spec_1.Stability.Stable]: 3
    };
    function lowestStability(a, b) {
      if (a === void 0) {
        return b;
      }
      if (b === void 0) {
        return a;
      }
      return stabilityPrecedence[a] < stabilityPrecedence[b] ? a : b;
    }
  }
});

// node_modules/jsii-reflect/lib/type-ref.js
var require_type_ref = __commonJS({
  "node_modules/jsii-reflect/lib/type-ref.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.TypeReference = void 0;
    var jsii = require_lib5();
    var TypeReference = class {
      constructor(system, spec) {
        this.system = system;
        this.spec = spec;
      }
      toString() {
        if (this.void) {
          return "void";
        }
        if (this.primitive) {
          return this.primitive;
        }
        if (this.fqn) {
          return this.fqn;
        }
        if (this.arrayOfType) {
          return `Array<${this.arrayOfType.toString()}>`;
        }
        if (this.mapOfType) {
          return `Map<string => ${this.mapOfType.toString()}>`;
        }
        if (this.unionOfTypes) {
          return this.unionOfTypes.map((x) => x.toString()).join(" | ");
        }
        throw new Error("Invalid type reference");
      }
      get void() {
        return !this.spec;
      }
      get isAny() {
        return this.primitive === "any";
      }
      get primitive() {
        if (!jsii.isPrimitiveTypeReference(this.spec)) {
          return void 0;
        }
        return this.spec.primitive;
      }
      get fqn() {
        return jsii.isNamedTypeReference(this.spec) ? this.spec.fqn : void 0;
      }
      get type() {
        if (!jsii.isNamedTypeReference(this.spec)) {
          return void 0;
        }
        return this.system.findFqn(this.spec.fqn);
      }
      get arrayOfType() {
        if (!jsii.isCollectionTypeReference(this.spec)) {
          return void 0;
        }
        if (this.spec.collection.kind !== jsii.CollectionKind.Array) {
          return void 0;
        }
        return new TypeReference(this.system, this.spec.collection.elementtype);
      }
      get mapOfType() {
        if (!jsii.isCollectionTypeReference(this.spec)) {
          return void 0;
        }
        if (this.spec.collection.kind !== jsii.CollectionKind.Map) {
          return void 0;
        }
        return new TypeReference(this.system, this.spec.collection.elementtype);
      }
      get unionOfTypes() {
        if (!jsii.isUnionTypeReference(this.spec)) {
          return void 0;
        }
        return this.spec.union.types.map((t) => new TypeReference(this.system, t));
      }
    };
    exports.TypeReference = TypeReference;
  }
});

// node_modules/jsii-reflect/lib/optional-value.js
var require_optional_value = __commonJS({
  "node_modules/jsii-reflect/lib/optional-value.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.OptionalValue = void 0;
    var type_ref_1 = require_type_ref();
    var OptionalValue = class {
      constructor(system, spec) {
        this.system = system;
        this.spec = spec;
      }
      static describe(optionalValue) {
        let description = optionalValue.type.toString();
        if (optionalValue.optional && !optionalValue.type.isAny) {
          description = `Optional<${description}>`;
        }
        return description;
      }
      toString() {
        return OptionalValue.describe(this);
      }
      get type() {
        var _a;
        return new type_ref_1.TypeReference(this.system, (_a = this.spec) === null || _a === void 0 ? void 0 : _a.type);
      }
      get optional() {
        var _a;
        return !!((_a = this.spec) === null || _a === void 0 ? void 0 : _a.optional);
      }
    };
    exports.OptionalValue = OptionalValue;
  }
});

// node_modules/jsii-reflect/lib/parameter.js
var require_parameter = __commonJS({
  "node_modules/jsii-reflect/lib/parameter.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Parameter = void 0;
    var docs_1 = require_docs();
    var optional_value_1 = require_optional_value();
    var Parameter = class extends optional_value_1.OptionalValue {
      constructor(system, parentType, method, spec) {
        super(system, spec);
        this.parentType = parentType;
        this.method = method;
        this.spec = spec;
      }
      get name() {
        return this.spec.name;
      }
      get variadic() {
        return !!this.spec.variadic;
      }
      get docs() {
        var _a;
        return new docs_1.Docs(this.system, this, (_a = this.spec.docs) !== null && _a !== void 0 ? _a : {});
      }
    };
    exports.Parameter = Parameter;
  }
});

// node_modules/jsii-reflect/lib/source.js
var require_source = __commonJS({
  "node_modules/jsii-reflect/lib/source.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.repositoryUrl = exports.locationInRepository = void 0;
    function locationInRepository(item) {
      const moduleLoc = item.locationInModule;
      if (!moduleLoc) {
        return void 0;
      }
      const moduleDir = item.assembly.repository.directory;
      if (!moduleDir) {
        return moduleLoc;
      }
      return {
        filename: `${moduleDir}/${moduleLoc.filename}`,
        line: moduleLoc.line
      };
    }
    exports.locationInRepository = locationInRepository;
    function repositoryUrl(item, ref = "master") {
      const loc = locationInRepository(item);
      if (!loc) {
        return void 0;
      }
      const repo = item.assembly.repository;
      if (!repo.url.startsWith("https://") || !repo.url.includes("github.com") || !repo.url.endsWith(".git")) {
        return void 0;
      }
      const prefix = repo.url.substr(0, repo.url.length - 4);
      return `${prefix}/blob/${ref}/${loc.filename}#L${loc.line}`;
    }
    exports.repositoryUrl = repositoryUrl;
  }
});

// node_modules/jsii-reflect/lib/callable.js
var require_callable = __commonJS({
  "node_modules/jsii-reflect/lib/callable.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Callable = void 0;
    var docs_1 = require_docs();
    var parameter_1 = require_parameter();
    var source_1 = require_source();
    var Callable = class {
      constructor(system, assembly, parentType, spec) {
        this.system = system;
        this.assembly = assembly;
        this.parentType = parentType;
        this.spec = spec;
      }
      get parameters() {
        var _a;
        return ((_a = this.spec.parameters) !== null && _a !== void 0 ? _a : []).map((p) => new parameter_1.Parameter(this.system, this.parentType, this, p));
      }
      get protected() {
        return !!this.spec.protected;
      }
      get variadic() {
        return !!this.spec.variadic;
      }
      get overrides() {
        if (!this.spec.overrides) {
          return void 0;
        }
        return this.system.findFqn(this.spec.overrides);
      }
      get docs() {
        var _a;
        return new docs_1.Docs(this.system, this, (_a = this.spec.docs) !== null && _a !== void 0 ? _a : {}, this.parentType.docs);
      }
      get locationInModule() {
        return this.spec.locationInModule;
      }
      get locationInRepository() {
        return source_1.locationInRepository(this);
      }
      toString() {
        return `${this.kind}:${this.parentType.fqn}.${this.name}`;
      }
    };
    exports.Callable = Callable;
  }
});

// node_modules/jsii-reflect/lib/type-member.js
var require_type_member = __commonJS({
  "node_modules/jsii-reflect/lib/type-member.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.isProperty = exports.isMethod = exports.isInitializer = exports.MemberKind = void 0;
    var MemberKind;
    (function(MemberKind2) {
      MemberKind2["Initializer"] = "initializer";
      MemberKind2["Method"] = "method";
      MemberKind2["Property"] = "property";
    })(MemberKind = exports.MemberKind || (exports.MemberKind = {}));
    function isInitializer(x) {
      return x.kind === MemberKind.Initializer;
    }
    exports.isInitializer = isInitializer;
    function isMethod(x) {
      return x.kind === MemberKind.Method;
    }
    exports.isMethod = isMethod;
    function isProperty(x) {
      return x.kind === MemberKind.Property;
    }
    exports.isProperty = isProperty;
  }
});

// node_modules/jsii-reflect/lib/initializer.js
var require_initializer = __commonJS({
  "node_modules/jsii-reflect/lib/initializer.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Initializer = void 0;
    var callable_1 = require_callable();
    var type_member_1 = require_type_member();
    var Initializer = class extends callable_1.Callable {
      constructor() {
        super(...arguments);
        this.kind = type_member_1.MemberKind.Initializer;
        this.name = "<initializer>";
        this.abstract = false;
      }
      static isInitializer(x) {
        return x instanceof Initializer;
      }
    };
    exports.Initializer = Initializer;
  }
});

// node_modules/jsii-reflect/lib/method.js
var require_method = __commonJS({
  "node_modules/jsii-reflect/lib/method.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Method = exports.INITIALIZER_NAME = void 0;
    var callable_1 = require_callable();
    var optional_value_1 = require_optional_value();
    var type_member_1 = require_type_member();
    exports.INITIALIZER_NAME = "<initializer>";
    var Method = class extends callable_1.Callable {
      constructor(system, assembly, parentType, definingType, spec) {
        super(system, assembly, parentType, spec);
        this.definingType = definingType;
        this.spec = spec;
        this.kind = type_member_1.MemberKind.Method;
      }
      static isMethod(x) {
        return x instanceof Method;
      }
      get name() {
        return this.spec.name;
      }
      get overrides() {
        if (!this.spec.overrides) {
          return void 0;
        }
        return this.system.findFqn(this.spec.overrides);
      }
      get returns() {
        return new optional_value_1.OptionalValue(this.system, this.spec.returns);
      }
      get abstract() {
        return !!this.spec.abstract;
      }
      get async() {
        return !!this.spec.async;
      }
      get static() {
        return !!this.spec.static;
      }
    };
    exports.Method = Method;
  }
});

// node_modules/jsii-reflect/lib/property.js
var require_property = __commonJS({
  "node_modules/jsii-reflect/lib/property.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Property = void 0;
    var docs_1 = require_docs();
    var optional_value_1 = require_optional_value();
    var source_1 = require_source();
    var type_member_1 = require_type_member();
    var Property = class extends optional_value_1.OptionalValue {
      constructor(system, assembly, parentType, definingType, spec) {
        super(system, spec);
        this.assembly = assembly;
        this.parentType = parentType;
        this.definingType = definingType;
        this.spec = spec;
        this.kind = type_member_1.MemberKind.Property;
      }
      toString() {
        return `property:${this.parentType.fqn}.${this.name}`;
      }
      get name() {
        return this.spec.name;
      }
      get immutable() {
        return !!this.spec.immutable;
      }
      get protected() {
        return !!this.spec.protected;
      }
      get abstract() {
        return !!this.spec.abstract;
      }
      get static() {
        return !!this.spec.static;
      }
      get const() {
        return !!this.spec.const;
      }
      get overrides() {
        if (!this.spec.overrides) {
          return void 0;
        }
        return this.system.findFqn(this.spec.overrides);
      }
      get docs() {
        var _a;
        return new docs_1.Docs(this.system, this, (_a = this.spec.docs) !== null && _a !== void 0 ? _a : {}, this.parentType.docs);
      }
      get locationInModule() {
        return this.spec.locationInModule;
      }
      get locationInRepository() {
        return source_1.locationInRepository(this);
      }
    };
    exports.Property = Property;
  }
});

// node_modules/jsii-reflect/lib/_memoized.js
var require_memoized = __commonJS({
  "node_modules/jsii-reflect/lib/_memoized.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.memoized = void 0;
    var CACHE = new WeakMap();
    function memoized(_prototype, propertyKey, descriptor) {
      if (!descriptor.get) {
        throw new Error(`@memoized can only be applied to property getters!`);
      }
      if (descriptor.set) {
        throw new Error(`@memoized can only be applied to readonly properties!`);
      }
      const original = descriptor.get;
      descriptor.get = function memoizedGet() {
        let cache = CACHE.get(this);
        if (cache == null) {
          cache = new Map();
          CACHE.set(this, cache);
        }
        if (cache.has(propertyKey)) {
          const result2 = cache.get(propertyKey);
          if (Array.isArray(result2)) {
            return Array.from(result2);
          }
          return result2;
        }
        const result = original.call(this);
        cache.set(propertyKey, Array.isArray(result) ? Array.from(result) : result);
        return result;
      };
    }
    exports.memoized = memoized;
  }
});

// node_modules/jsii-reflect/lib/type.js
var require_type = __commonJS({
  "node_modules/jsii-reflect/lib/type.js"(exports) {
    "use strict";
    var __decorate = exports && exports.__decorate || function(decorators, target, key, desc) {
      var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
      if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
      else
        for (var i = decorators.length - 1; i >= 0; i--)
          if (d = decorators[i])
            r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
      return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Type = void 0;
    var _memoized_1 = require_memoized();
    var docs_1 = require_docs();
    var source_1 = require_source();
    var type_ref_1 = require_type_ref();
    var Type = class {
      constructor(system, assembly, spec) {
        this.system = system;
        this.assembly = assembly;
        this.spec = spec;
      }
      toString() {
        return `${this.kind} ${this.fqn}`;
      }
      get fqn() {
        return this.spec.fqn;
      }
      get namespace() {
        return this.spec.namespace;
      }
      get nestingParent() {
        const ns = this.namespace;
        if (ns == null) {
          return void 0;
        }
        return this.assembly.tryFindType(`${this.assembly.name}.${ns}`);
      }
      get name() {
        return this.spec.name;
      }
      get kind() {
        return this.spec.kind;
      }
      get docs() {
        var _a;
        return new docs_1.Docs(this.system, this, (_a = this.spec.docs) !== null && _a !== void 0 ? _a : {});
      }
      get reference() {
        return new type_ref_1.TypeReference(this.system, {
          fqn: this.fqn
        });
      }
      isClassType() {
        return false;
      }
      isDataType() {
        return false;
      }
      isEnumType() {
        return false;
      }
      isInterfaceType() {
        return false;
      }
      extends(base) {
        if (this === base) {
          return true;
        }
        if ((this.isInterfaceType() || this.isClassType()) && base.isInterfaceType()) {
          return this.getInterfaces(true).some((iface) => iface === base);
        }
        if (this.isClassType() && base.isClassType()) {
          return this.getAncestors().some((clazz) => clazz === base);
        }
        return false;
      }
      get allImplementations() {
        if (this.isClassType() || this.isInterfaceType()) {
          return [
            ...this.system.classes.filter((c) => c.extends(this)),
            ...this.system.interfaces.filter((i) => i.extends(this))
          ];
        }
        return [];
      }
      get locationInModule() {
        return this.spec.locationInModule;
      }
      get locationInRepository() {
        return source_1.locationInRepository(this);
      }
    };
    __decorate([
      _memoized_1.memoized
    ], Type.prototype, "nestingParent", null);
    __decorate([
      _memoized_1.memoized
    ], Type.prototype, "allImplementations", null);
    exports.Type = Type;
  }
});

// node_modules/jsii-reflect/lib/reference-type.js
var require_reference_type = __commonJS({
  "node_modules/jsii-reflect/lib/reference-type.js"(exports) {
    "use strict";
    var __decorate = exports && exports.__decorate || function(decorators, target, key, desc) {
      var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
      if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
      else
        for (var i = decorators.length - 1; i >= 0; i--)
          if (d = decorators[i])
            r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
      return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.ReferenceType = void 0;
    var _memoized_1 = require_memoized();
    var type_1 = require_type();
    var ReferenceType = class extends type_1.Type {
      constructor(system, assembly, spec) {
        super(system, assembly, spec);
        this.system = system;
        this.assembly = assembly;
      }
      get interfaces() {
        return this.getInterfaces();
      }
      get ownMethods() {
        return Object.values(this.getMethods(false));
      }
      get allMethods() {
        return Object.values(this.getMethods(true));
      }
      get ownProperties() {
        return Object.values(this.getProperties());
      }
      get allProperties() {
        return Object.values(this.getProperties(true));
      }
      get ownMembers() {
        return Object.values(this.getMembers(false));
      }
      get allMembers() {
        return Object.values(this.getMembers(true));
      }
      getMembers(inherited = false) {
        return Object.assign(this.getMethods(inherited), this.getProperties(inherited));
      }
    };
    __decorate([
      _memoized_1.memoized
    ], ReferenceType.prototype, "interfaces", null);
    __decorate([
      _memoized_1.memoized
    ], ReferenceType.prototype, "ownMethods", null);
    __decorate([
      _memoized_1.memoized
    ], ReferenceType.prototype, "allMethods", null);
    __decorate([
      _memoized_1.memoized
    ], ReferenceType.prototype, "ownProperties", null);
    __decorate([
      _memoized_1.memoized
    ], ReferenceType.prototype, "allProperties", null);
    __decorate([
      _memoized_1.memoized
    ], ReferenceType.prototype, "ownMembers", null);
    __decorate([
      _memoized_1.memoized
    ], ReferenceType.prototype, "allMembers", null);
    exports.ReferenceType = ReferenceType;
  }
});

// node_modules/jsii-reflect/lib/util.js
var require_util = __commonJS({
  "node_modules/jsii-reflect/lib/util.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.indexBy = void 0;
    function indexBy(xs, f) {
      const ret = {};
      for (const x of xs) {
        ret[f(x)] = x;
      }
      return ret;
    }
    exports.indexBy = indexBy;
  }
});

// node_modules/jsii-reflect/lib/class.js
var require_class = __commonJS({
  "node_modules/jsii-reflect/lib/class.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.ClassType = void 0;
    var initializer_1 = require_initializer();
    var method_1 = require_method();
    var property_1 = require_property();
    var reference_type_1 = require_reference_type();
    var util_1 = require_util();
    var ClassType = class extends reference_type_1.ReferenceType {
      constructor(system, assembly, spec) {
        super(system, assembly, spec);
        this.system = system;
        this.assembly = assembly;
        this.spec = spec;
      }
      get base() {
        if (!this.spec.base) {
          return void 0;
        }
        const type = this.system.findFqn(this.spec.base);
        if (!(type instanceof ClassType)) {
          throw new Error(`FQN for base class points to a non-class type: ${this.spec.base}`);
        }
        return type;
      }
      get initializer() {
        if (!this.spec.initializer) {
          return void 0;
        }
        return new initializer_1.Initializer(this.system, this.assembly, this, this.spec.initializer);
      }
      get abstract() {
        return !!this.spec.abstract;
      }
      getAncestors() {
        const out = new Array();
        if (this.base) {
          out.push(this.base);
          out.push(...this.base.getAncestors());
        }
        return out;
      }
      getProperties(inherited = false) {
        return this._getProperties(inherited, this);
      }
      getMethods(inherited = false) {
        return this._getMethods(inherited, this);
      }
      getInterfaces(inherited = false) {
        const out = new Array();
        if (inherited && this.base) {
          out.push(...this.base.getInterfaces(inherited));
        }
        if (this.spec.interfaces) {
          out.push(...flatten(this.spec.interfaces.map((fqn) => this.system.findInterface(fqn)).map((iface) => [
            iface,
            ...inherited ? iface.getInterfaces(true) : []
          ])));
        }
        return out;
      }
      isClassType() {
        return true;
      }
      _getProperties(inherited, parentType) {
        var _a;
        const base = inherited && this.base ? this.base._getProperties(inherited, parentType) : {};
        return Object.assign(base, util_1.indexBy(((_a = this.spec.properties) !== null && _a !== void 0 ? _a : []).map((p) => new property_1.Property(this.system, this.assembly, parentType, this, p)), (p) => p.name));
      }
      _getMethods(inherited, parentType) {
        var _a;
        const base = inherited && this.base ? this.base._getMethods(inherited, parentType) : {};
        return Object.assign(base, util_1.indexBy(((_a = this.spec.methods) !== null && _a !== void 0 ? _a : []).map((m) => new method_1.Method(this.system, this.assembly, parentType, this, m)), (m) => m.name));
      }
    };
    exports.ClassType = ClassType;
    function flatten(xs) {
      return Array.prototype.concat([], ...xs);
    }
  }
});

// node_modules/jsii-reflect/lib/dependency.js
var require_dependency = __commonJS({
  "node_modules/jsii-reflect/lib/dependency.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Dependency = void 0;
    var Dependency = class {
      constructor(system, name, version) {
        this.system = system;
        this.name = name;
        this.version = version;
      }
      get assembly() {
        return this.system.findAssembly(this.name);
      }
    };
    exports.Dependency = Dependency;
  }
});

// node_modules/jsii-reflect/lib/enum.js
var require_enum = __commonJS({
  "node_modules/jsii-reflect/lib/enum.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.EnumMember = exports.EnumType = void 0;
    var docs_1 = require_docs();
    var type_1 = require_type();
    var EnumType = class extends type_1.Type {
      constructor(system, assembly, spec) {
        super(system, assembly, spec);
        this.system = system;
        this.assembly = assembly;
        this.spec = spec;
      }
      get members() {
        return this.spec.members.map((m) => new EnumMember(this, m));
      }
      isEnumType() {
        return true;
      }
    };
    exports.EnumType = EnumType;
    var EnumMember = class {
      constructor(enumType, memberSpec) {
        var _a;
        this.enumType = enumType;
        this.name = memberSpec.name;
        this.docs = new docs_1.Docs(this.system, this, (_a = memberSpec.docs) !== null && _a !== void 0 ? _a : {}, this.enumType.docs);
      }
      get system() {
        return this.enumType.system;
      }
      get assembly() {
        return this.enumType.assembly;
      }
    };
    exports.EnumMember = EnumMember;
  }
});

// node_modules/jsii-reflect/lib/interface.js
var require_interface = __commonJS({
  "node_modules/jsii-reflect/lib/interface.js"(exports) {
    "use strict";
    var __classPrivateFieldGet = exports && exports.__classPrivateFieldGet || function(receiver, privateMap) {
      if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to get private field on non-instance");
      }
      return privateMap.get(receiver);
    };
    var _interfaces;
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.InterfaceType = void 0;
    var method_1 = require_method();
    var property_1 = require_property();
    var reference_type_1 = require_reference_type();
    var util_1 = require_util();
    var InterfaceType = class extends reference_type_1.ReferenceType {
      constructor(system, assembly, spec) {
        super(system, assembly, spec);
        this.system = system;
        this.assembly = assembly;
        this.spec = spec;
        _interfaces.set(this, new Map());
      }
      get datatype() {
        return this.isDataType();
      }
      getInterfaces(inherited = false) {
        if (!this.spec.interfaces) {
          return [];
        }
        if (__classPrivateFieldGet(this, _interfaces).has(inherited)) {
          return Array.from(__classPrivateFieldGet(this, _interfaces).get(inherited));
        }
        const result = new Set();
        for (const iface of this.spec.interfaces) {
          const ifaceType = this.system.findInterface(iface);
          if (!result.has(ifaceType) && inherited) {
            ifaceType.getInterfaces(inherited).forEach((i) => result.add(i));
          }
          result.add(ifaceType);
        }
        __classPrivateFieldGet(this, _interfaces).set(inherited, Array.from(result));
        return Array.from(result);
      }
      getProperties(inherited = false) {
        return this._getProperties(inherited, this);
      }
      getMethods(inherited = false) {
        return this._getMethods(inherited, this);
      }
      isDataType() {
        return !!this.spec.datatype;
      }
      isInterfaceType() {
        return true;
      }
      _getProperties(inherited, parentType) {
        var _a;
        const base = {};
        if (inherited) {
          for (const parent of this.getInterfaces()) {
            Object.assign(base, parent._getProperties(inherited, parentType));
          }
        }
        return Object.assign(base, util_1.indexBy(((_a = this.spec.properties) !== null && _a !== void 0 ? _a : []).map((p) => new property_1.Property(this.system, this.assembly, parentType, this, p)), (p) => p.name));
      }
      _getMethods(inherited, parentType) {
        var _a;
        const base = {};
        if (inherited) {
          for (const parent of this.getInterfaces()) {
            Object.assign(base, parent._getMethods(inherited, parentType));
          }
        }
        return Object.assign(base, util_1.indexBy(((_a = this.spec.methods) !== null && _a !== void 0 ? _a : []).map((m) => new method_1.Method(this.system, this.assembly, parentType, this, m)), (m) => m.name));
      }
    };
    exports.InterfaceType = InterfaceType;
    _interfaces = new WeakMap();
  }
});

// node_modules/jsii-reflect/lib/module-like.js
var require_module_like = __commonJS({
  "node_modules/jsii-reflect/lib/module-like.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.ModuleLike = void 0;
    var class_1 = require_class();
    var enum_1 = require_enum();
    var interface_1 = require_interface();
    var ModuleLike = class {
      constructor(system) {
        this.system = system;
        this.typeLocatorCache = new Map();
      }
      get submodules() {
        return Object.values(this.submoduleMap);
      }
      get types() {
        return Object.values(this.typeMap);
      }
      get classes() {
        return this.types.filter((t) => t instanceof class_1.ClassType).map((t) => t);
      }
      get interfaces() {
        return this.types.filter((t) => t instanceof interface_1.InterfaceType).map((t) => t);
      }
      get enums() {
        return this.types.filter((t) => t instanceof enum_1.EnumType).map((t) => t);
      }
      tryFindType(fqn) {
        if (this.typeLocatorCache.has(fqn)) {
          return this.typeLocatorCache.get(fqn);
        }
        const ownType = this.typeMap[fqn];
        if (ownType != null) {
          this.typeLocatorCache.set(fqn, ownType);
          return ownType;
        }
        if (!fqn.startsWith(`${this.fqn}.`)) {
          this.typeLocatorCache.set(fqn, void 0);
          return void 0;
        }
        const myFqnLength = this.fqn.split(".").length;
        const subFqn = fqn.split(".").slice(0, myFqnLength + 1).join(".");
        const sub = this.submoduleMap[subFqn];
        const submoduleType = sub === null || sub === void 0 ? void 0 : sub.tryFindType(fqn);
        this.typeLocatorCache.set(fqn, submoduleType);
        return submoduleType;
      }
    };
    exports.ModuleLike = ModuleLike;
  }
});

// node_modules/jsii-reflect/lib/submodule.js
var require_submodule = __commonJS({
  "node_modules/jsii-reflect/lib/submodule.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Submodule = void 0;
    var module_like_1 = require_module_like();
    var Submodule = class extends module_like_1.ModuleLike {
      constructor(system, spec, fqn, submoduleMap, typeMap) {
        super(system);
        this.spec = spec;
        this.fqn = fqn;
        this.submoduleMap = submoduleMap;
        this.typeMap = typeMap;
        this.name = fqn.split(".").pop();
      }
      get targets() {
        return this.spec.targets;
      }
      get readme() {
        return this.spec.readme;
      }
    };
    exports.Submodule = Submodule;
  }
});

// node_modules/jsii-reflect/lib/assembly.js
var require_assembly2 = __commonJS({
  "node_modules/jsii-reflect/lib/assembly.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Assembly = void 0;
    var jsii = require_lib5();
    var class_1 = require_class();
    var dependency_1 = require_dependency();
    var enum_1 = require_enum();
    var interface_1 = require_interface();
    var module_like_1 = require_module_like();
    var submodule_1 = require_submodule();
    var Assembly = class extends module_like_1.ModuleLike {
      constructor(system, spec) {
        super(system);
        this.spec = spec;
      }
      get fqn() {
        return this.spec.name;
      }
      get schema() {
        return this.spec.schema;
      }
      get jsiiVersion() {
        return this.spec.jsiiVersion;
      }
      get name() {
        return this.spec.name;
      }
      get description() {
        return this.spec.description;
      }
      get metadata() {
        return this.spec.metadata;
      }
      get homepage() {
        return this.spec.homepage;
      }
      get repository() {
        return this.spec.repository;
      }
      get author() {
        return this.spec.author;
      }
      get contributors() {
        var _a;
        return (_a = this.spec.contributors) !== null && _a !== void 0 ? _a : [];
      }
      get fingerprint() {
        return this.spec.fingerprint;
      }
      get version() {
        return this.spec.version;
      }
      get license() {
        return this.spec.license;
      }
      get targets() {
        return this.spec.targets;
      }
      get dependencies() {
        return Object.keys(this._dependencies).map((name) => this._dependencies[name]);
      }
      findDependency(name) {
        const dep = this._dependencies[name];
        if (!dep) {
          throw new Error(`Dependency ${name} not found for assembly ${this.name}`);
        }
        return dep;
      }
      get bundled() {
        var _a;
        return (_a = this.spec.bundled) !== null && _a !== void 0 ? _a : {};
      }
      get readme() {
        return this.spec.readme;
      }
      get submodules() {
        const { submodules } = this._analyzeTypes();
        return Object.entries(submodules).filter(([name, _]) => name.split(".").length === 2).map(([_, submodule]) => submodule);
      }
      get allSubmodules() {
        const { submodules } = this._analyzeTypes();
        return Object.values(submodules);
      }
      findType(fqn) {
        const type = this.tryFindType(fqn);
        if (!type) {
          throw new Error(`Type '${fqn}' not found in assembly ${this.name}`);
        }
        return type;
      }
      validate() {
        jsii.validateAssembly(this.spec);
      }
      get submoduleMap() {
        return this._analyzeTypes().submodules;
      }
      get typeMap() {
        return this._analyzeTypes().types;
      }
      get _dependencies() {
        if (!this._dependencyCache) {
          this._dependencyCache = {};
          if (this.spec.dependencies) {
            for (const name of Object.keys(this.spec.dependencies)) {
              this._dependencyCache[name] = new dependency_1.Dependency(this.system, name, this.spec.dependencies[name]);
            }
          }
        }
        return this._dependencyCache;
      }
      _analyzeTypes() {
        var _a;
        if (!this._typeCache || !this._submoduleCache) {
          this._typeCache = {};
          const submoduleBuilders = this.discoverSubmodules();
          const ts = (_a = this.spec.types) !== null && _a !== void 0 ? _a : {};
          for (const [fqn, typeSpec] of Object.entries(ts)) {
            let type;
            switch (typeSpec.kind) {
              case jsii.TypeKind.Class:
                type = new class_1.ClassType(this.system, this, typeSpec);
                break;
              case jsii.TypeKind.Interface:
                type = new interface_1.InterfaceType(this.system, this, typeSpec);
                break;
              case jsii.TypeKind.Enum:
                type = new enum_1.EnumType(this.system, this, typeSpec);
                break;
              default:
                throw new Error("Unknown type kind");
            }
            let submodule = typeSpec.namespace;
            while (submodule != null && `${this.spec.name}.${submodule}` in ts) {
              submodule = ts[`${this.spec.name}.${submodule}`].namespace;
            }
            if (submodule != null) {
              const moduleName = `${this.spec.name}.${submodule}`;
              submoduleBuilders[moduleName].addType(type);
            } else {
              this._typeCache[fqn] = type;
            }
          }
          this._submoduleCache = mapValues(submoduleBuilders, (b) => b.build());
        }
        return { types: this._typeCache, submodules: this._submoduleCache };
      }
      discoverSubmodules() {
        var _a;
        const system = this.system;
        const ret = {};
        for (const [submoduleName, submoduleSpec] of Object.entries((_a = this.spec.submodules) !== null && _a !== void 0 ? _a : {})) {
          ret[submoduleName] = new SubmoduleBuilder(system, submoduleSpec, submoduleName, ret);
        }
        return ret;
      }
    };
    exports.Assembly = Assembly;
    var SubmoduleBuilder = class {
      constructor(system, spec, fullName, allModuleBuilders) {
        this.system = system;
        this.spec = spec;
        this.fullName = fullName;
        this.allModuleBuilders = allModuleBuilders;
        this.types = {};
      }
      isChildOf(other) {
        return this.fullName.startsWith(`${other.fullName}.`) && this.fullName.split(".").length === other.fullName.split(".").length + 1;
      }
      build() {
        if (!this._built) {
          this._built = new submodule_1.Submodule(this.system, this.spec, this.fullName, mapValues(this.findSubmoduleBuilders(), (b) => b.build()), this.types);
        }
        return this._built;
      }
      findSubmoduleBuilders() {
        const ret = {};
        for (const [k, child] of Object.entries(this.allModuleBuilders)) {
          if (child.isChildOf(this)) {
            ret[k] = child;
          }
        }
        return ret;
      }
      addType(type) {
        this.types[type.fqn] = type;
      }
    };
    function mapValues(xs, fn) {
      const ret = {};
      for (const [k, v] of Object.entries(xs)) {
        ret[k] = fn(v);
      }
      return ret;
    }
  }
});

// node_modules/jsii-reflect/lib/overridable.js
var require_overridable = __commonJS({
  "node_modules/jsii-reflect/lib/overridable.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
  }
});

// node_modules/colors/lib/styles.js
var require_styles = __commonJS({
  "node_modules/colors/lib/styles.js"(exports, module2) {
    var styles = {};
    module2["exports"] = styles;
    var codes = {
      reset: [0, 0],
      bold: [1, 22],
      dim: [2, 22],
      italic: [3, 23],
      underline: [4, 24],
      inverse: [7, 27],
      hidden: [8, 28],
      strikethrough: [9, 29],
      black: [30, 39],
      red: [31, 39],
      green: [32, 39],
      yellow: [33, 39],
      blue: [34, 39],
      magenta: [35, 39],
      cyan: [36, 39],
      white: [37, 39],
      gray: [90, 39],
      grey: [90, 39],
      brightRed: [91, 39],
      brightGreen: [92, 39],
      brightYellow: [93, 39],
      brightBlue: [94, 39],
      brightMagenta: [95, 39],
      brightCyan: [96, 39],
      brightWhite: [97, 39],
      bgBlack: [40, 49],
      bgRed: [41, 49],
      bgGreen: [42, 49],
      bgYellow: [43, 49],
      bgBlue: [44, 49],
      bgMagenta: [45, 49],
      bgCyan: [46, 49],
      bgWhite: [47, 49],
      bgGray: [100, 49],
      bgGrey: [100, 49],
      bgBrightRed: [101, 49],
      bgBrightGreen: [102, 49],
      bgBrightYellow: [103, 49],
      bgBrightBlue: [104, 49],
      bgBrightMagenta: [105, 49],
      bgBrightCyan: [106, 49],
      bgBrightWhite: [107, 49],
      blackBG: [40, 49],
      redBG: [41, 49],
      greenBG: [42, 49],
      yellowBG: [43, 49],
      blueBG: [44, 49],
      magentaBG: [45, 49],
      cyanBG: [46, 49],
      whiteBG: [47, 49]
    };
    Object.keys(codes).forEach(function(key) {
      var val = codes[key];
      var style = styles[key] = [];
      style.open = "[" + val[0] + "m";
      style.close = "[" + val[1] + "m";
    });
  }
});

// node_modules/colors/lib/system/has-flag.js
var require_has_flag = __commonJS({
  "node_modules/colors/lib/system/has-flag.js"(exports, module2) {
    "use strict";
    module2.exports = function(flag, argv) {
      argv = argv || process.argv;
      var terminatorPos = argv.indexOf("--");
      var prefix = /^-{1,2}/.test(flag) ? "" : "--";
      var pos = argv.indexOf(prefix + flag);
      return pos !== -1 && (terminatorPos === -1 ? true : pos < terminatorPos);
    };
  }
});

// node_modules/colors/lib/system/supports-colors.js
var require_supports_colors = __commonJS({
  "node_modules/colors/lib/system/supports-colors.js"(exports, module2) {
    "use strict";
    var os2 = require("os");
    var hasFlag = require_has_flag();
    var env2 = process.env;
    var forceColor = void 0;
    if (hasFlag("no-color") || hasFlag("no-colors") || hasFlag("color=false")) {
      forceColor = false;
    } else if (hasFlag("color") || hasFlag("colors") || hasFlag("color=true") || hasFlag("color=always")) {
      forceColor = true;
    }
    if ("FORCE_COLOR" in env2) {
      forceColor = env2.FORCE_COLOR.length === 0 || parseInt(env2.FORCE_COLOR, 10) !== 0;
    }
    function translateLevel(level) {
      if (level === 0) {
        return false;
      }
      return {
        level,
        hasBasic: true,
        has256: level >= 2,
        has16m: level >= 3
      };
    }
    function supportsColor(stream) {
      if (forceColor === false) {
        return 0;
      }
      if (hasFlag("color=16m") || hasFlag("color=full") || hasFlag("color=truecolor")) {
        return 3;
      }
      if (hasFlag("color=256")) {
        return 2;
      }
      if (stream && !stream.isTTY && forceColor !== true) {
        return 0;
      }
      var min = forceColor ? 1 : 0;
      if (process.platform === "win32") {
        var osRelease = os2.release().split(".");
        if (Number(process.versions.node.split(".")[0]) >= 8 && Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
          return Number(osRelease[2]) >= 14931 ? 3 : 2;
        }
        return 1;
      }
      if ("CI" in env2) {
        if (["TRAVIS", "CIRCLECI", "APPVEYOR", "GITLAB_CI"].some(function(sign) {
          return sign in env2;
        }) || env2.CI_NAME === "codeship") {
          return 1;
        }
        return min;
      }
      if ("TEAMCITY_VERSION" in env2) {
        return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env2.TEAMCITY_VERSION) ? 1 : 0;
      }
      if ("TERM_PROGRAM" in env2) {
        var version = parseInt((env2.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
        switch (env2.TERM_PROGRAM) {
          case "iTerm.app":
            return version >= 3 ? 3 : 2;
          case "Hyper":
            return 3;
          case "Apple_Terminal":
            return 2;
        }
      }
      if (/-256(color)?$/i.test(env2.TERM)) {
        return 2;
      }
      if (/^screen|^xterm|^vt100|^rxvt|color|ansi|cygwin|linux/i.test(env2.TERM)) {
        return 1;
      }
      if ("COLORTERM" in env2) {
        return 1;
      }
      if (env2.TERM === "dumb") {
        return min;
      }
      return min;
    }
    function getSupportLevel(stream) {
      var level = supportsColor(stream);
      return translateLevel(level);
    }
    module2.exports = {
      supportsColor: getSupportLevel,
      stdout: getSupportLevel(process.stdout),
      stderr: getSupportLevel(process.stderr)
    };
  }
});

// node_modules/colors/lib/custom/trap.js
var require_trap = __commonJS({
  "node_modules/colors/lib/custom/trap.js"(exports, module2) {
    module2["exports"] = function runTheTrap(text, options) {
      var result = "";
      text = text || "Run the trap, drop the bass";
      text = text.split("");
      var trap = {
        a: ["@", "\u0104", "\u023A", "\u0245", "\u0394", "\u039B", "\u0414"],
        b: ["\xDF", "\u0181", "\u0243", "\u026E", "\u03B2", "\u0E3F"],
        c: ["\xA9", "\u023B", "\u03FE"],
        d: ["\xD0", "\u018A", "\u0500", "\u0501", "\u0502", "\u0503"],
        e: [
          "\xCB",
          "\u0115",
          "\u018E",
          "\u0258",
          "\u03A3",
          "\u03BE",
          "\u04BC",
          "\u0A6C"
        ],
        f: ["\u04FA"],
        g: ["\u0262"],
        h: ["\u0126", "\u0195", "\u04A2", "\u04BA", "\u04C7", "\u050A"],
        i: ["\u0F0F"],
        j: ["\u0134"],
        k: ["\u0138", "\u04A0", "\u04C3", "\u051E"],
        l: ["\u0139"],
        m: ["\u028D", "\u04CD", "\u04CE", "\u0520", "\u0521", "\u0D69"],
        n: ["\xD1", "\u014B", "\u019D", "\u0376", "\u03A0", "\u048A"],
        o: [
          "\xD8",
          "\xF5",
          "\xF8",
          "\u01FE",
          "\u0298",
          "\u047A",
          "\u05DD",
          "\u06DD",
          "\u0E4F"
        ],
        p: ["\u01F7", "\u048E"],
        q: ["\u09CD"],
        r: ["\xAE", "\u01A6", "\u0210", "\u024C", "\u0280", "\u042F"],
        s: ["\xA7", "\u03DE", "\u03DF", "\u03E8"],
        t: ["\u0141", "\u0166", "\u0373"],
        u: ["\u01B1", "\u054D"],
        v: ["\u05D8"],
        w: ["\u0428", "\u0460", "\u047C", "\u0D70"],
        x: ["\u04B2", "\u04FE", "\u04FC", "\u04FD"],
        y: ["\xA5", "\u04B0", "\u04CB"],
        z: ["\u01B5", "\u0240"]
      };
      text.forEach(function(c) {
        c = c.toLowerCase();
        var chars = trap[c] || [" "];
        var rand = Math.floor(Math.random() * chars.length);
        if (typeof trap[c] !== "undefined") {
          result += trap[c][rand];
        } else {
          result += c;
        }
      });
      return result;
    };
  }
});

// node_modules/colors/lib/custom/zalgo.js
var require_zalgo = __commonJS({
  "node_modules/colors/lib/custom/zalgo.js"(exports, module2) {
    module2["exports"] = function zalgo(text, options) {
      text = text || "   he is here   ";
      var soul = {
        "up": [
          "\u030D",
          "\u030E",
          "\u0304",
          "\u0305",
          "\u033F",
          "\u0311",
          "\u0306",
          "\u0310",
          "\u0352",
          "\u0357",
          "\u0351",
          "\u0307",
          "\u0308",
          "\u030A",
          "\u0342",
          "\u0313",
          "\u0308",
          "\u034A",
          "\u034B",
          "\u034C",
          "\u0303",
          "\u0302",
          "\u030C",
          "\u0350",
          "\u0300",
          "\u0301",
          "\u030B",
          "\u030F",
          "\u0312",
          "\u0313",
          "\u0314",
          "\u033D",
          "\u0309",
          "\u0363",
          "\u0364",
          "\u0365",
          "\u0366",
          "\u0367",
          "\u0368",
          "\u0369",
          "\u036A",
          "\u036B",
          "\u036C",
          "\u036D",
          "\u036E",
          "\u036F",
          "\u033E",
          "\u035B",
          "\u0346",
          "\u031A"
        ],
        "down": [
          "\u0316",
          "\u0317",
          "\u0318",
          "\u0319",
          "\u031C",
          "\u031D",
          "\u031E",
          "\u031F",
          "\u0320",
          "\u0324",
          "\u0325",
          "\u0326",
          "\u0329",
          "\u032A",
          "\u032B",
          "\u032C",
          "\u032D",
          "\u032E",
          "\u032F",
          "\u0330",
          "\u0331",
          "\u0332",
          "\u0333",
          "\u0339",
          "\u033A",
          "\u033B",
          "\u033C",
          "\u0345",
          "\u0347",
          "\u0348",
          "\u0349",
          "\u034D",
          "\u034E",
          "\u0353",
          "\u0354",
          "\u0355",
          "\u0356",
          "\u0359",
          "\u035A",
          "\u0323"
        ],
        "mid": [
          "\u0315",
          "\u031B",
          "\u0300",
          "\u0301",
          "\u0358",
          "\u0321",
          "\u0322",
          "\u0327",
          "\u0328",
          "\u0334",
          "\u0335",
          "\u0336",
          "\u035C",
          "\u035D",
          "\u035E",
          "\u035F",
          "\u0360",
          "\u0362",
          "\u0338",
          "\u0337",
          "\u0361",
          " \u0489"
        ]
      };
      var all = [].concat(soul.up, soul.down, soul.mid);
      function randomNumber(range) {
        var r = Math.floor(Math.random() * range);
        return r;
      }
      function isChar(character) {
        var bool = false;
        all.filter(function(i) {
          bool = i === character;
        });
        return bool;
      }
      function heComes(text2, options2) {
        var result = "";
        var counts;
        var l;
        options2 = options2 || {};
        options2["up"] = typeof options2["up"] !== "undefined" ? options2["up"] : true;
        options2["mid"] = typeof options2["mid"] !== "undefined" ? options2["mid"] : true;
        options2["down"] = typeof options2["down"] !== "undefined" ? options2["down"] : true;
        options2["size"] = typeof options2["size"] !== "undefined" ? options2["size"] : "maxi";
        text2 = text2.split("");
        for (l in text2) {
          if (isChar(l)) {
            continue;
          }
          result = result + text2[l];
          counts = { "up": 0, "down": 0, "mid": 0 };
          switch (options2.size) {
            case "mini":
              counts.up = randomNumber(8);
              counts.mid = randomNumber(2);
              counts.down = randomNumber(8);
              break;
            case "maxi":
              counts.up = randomNumber(16) + 3;
              counts.mid = randomNumber(4) + 1;
              counts.down = randomNumber(64) + 3;
              break;
            default:
              counts.up = randomNumber(8) + 1;
              counts.mid = randomNumber(6) / 2;
              counts.down = randomNumber(8) + 1;
              break;
          }
          var arr = ["up", "mid", "down"];
          for (var d in arr) {
            var index = arr[d];
            for (var i = 0; i <= counts[index]; i++) {
              if (options2[index]) {
                result = result + soul[index][randomNumber(soul[index].length)];
              }
            }
          }
        }
        return result;
      }
      return heComes(text, options);
    };
  }
});

// node_modules/colors/lib/maps/america.js
var require_america = __commonJS({
  "node_modules/colors/lib/maps/america.js"(exports, module2) {
    module2["exports"] = function(colors) {
      return function(letter, i, exploded) {
        if (letter === " ")
          return letter;
        switch (i % 3) {
          case 0:
            return colors.red(letter);
          case 1:
            return colors.white(letter);
          case 2:
            return colors.blue(letter);
        }
      };
    };
  }
});

// node_modules/colors/lib/maps/zebra.js
var require_zebra = __commonJS({
  "node_modules/colors/lib/maps/zebra.js"(exports, module2) {
    module2["exports"] = function(colors) {
      return function(letter, i, exploded) {
        return i % 2 === 0 ? letter : colors.inverse(letter);
      };
    };
  }
});

// node_modules/colors/lib/maps/rainbow.js
var require_rainbow = __commonJS({
  "node_modules/colors/lib/maps/rainbow.js"(exports, module2) {
    module2["exports"] = function(colors) {
      var rainbowColors = ["red", "yellow", "green", "blue", "magenta"];
      return function(letter, i, exploded) {
        if (letter === " ") {
          return letter;
        } else {
          return colors[rainbowColors[i++ % rainbowColors.length]](letter);
        }
      };
    };
  }
});

// node_modules/colors/lib/maps/random.js
var require_random = __commonJS({
  "node_modules/colors/lib/maps/random.js"(exports, module2) {
    module2["exports"] = function(colors) {
      var available = [
        "underline",
        "inverse",
        "grey",
        "yellow",
        "red",
        "green",
        "blue",
        "white",
        "cyan",
        "magenta",
        "brightYellow",
        "brightRed",
        "brightGreen",
        "brightBlue",
        "brightWhite",
        "brightCyan",
        "brightMagenta"
      ];
      return function(letter, i, exploded) {
        return letter === " " ? letter : colors[available[Math.round(Math.random() * (available.length - 2))]](letter);
      };
    };
  }
});

// node_modules/colors/lib/colors.js
var require_colors = __commonJS({
  "node_modules/colors/lib/colors.js"(exports, module2) {
    var colors = {};
    module2["exports"] = colors;
    colors.themes = {};
    var util = require("util");
    var ansiStyles = colors.styles = require_styles();
    var defineProps = Object.defineProperties;
    var newLineRegex = new RegExp(/[\r\n]+/g);
    colors.supportsColor = require_supports_colors().supportsColor;
    if (typeof colors.enabled === "undefined") {
      colors.enabled = colors.supportsColor() !== false;
    }
    colors.enable = function() {
      colors.enabled = true;
    };
    colors.disable = function() {
      colors.enabled = false;
    };
    colors.stripColors = colors.strip = function(str) {
      return ("" + str).replace(/\x1B\[\d+m/g, "");
    };
    var stylize = colors.stylize = function stylize2(str, style) {
      if (!colors.enabled) {
        return str + "";
      }
      var styleMap = ansiStyles[style];
      if (!styleMap && style in colors) {
        return colors[style](str);
      }
      return styleMap.open + str + styleMap.close;
    };
    var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;
    var escapeStringRegexp = function(str) {
      if (typeof str !== "string") {
        throw new TypeError("Expected a string");
      }
      return str.replace(matchOperatorsRe, "\\$&");
    };
    function build(_styles) {
      var builder = function builder2() {
        return applyStyle.apply(builder2, arguments);
      };
      builder._styles = _styles;
      builder.__proto__ = proto;
      return builder;
    }
    var styles = function() {
      var ret = {};
      ansiStyles.grey = ansiStyles.gray;
      Object.keys(ansiStyles).forEach(function(key) {
        ansiStyles[key].closeRe = new RegExp(escapeStringRegexp(ansiStyles[key].close), "g");
        ret[key] = {
          get: function() {
            return build(this._styles.concat(key));
          }
        };
      });
      return ret;
    }();
    var proto = defineProps(function colors2() {
    }, styles);
    function applyStyle() {
      var args = Array.prototype.slice.call(arguments);
      var str = args.map(function(arg) {
        if (arg != null && arg.constructor === String) {
          return arg;
        } else {
          return util.inspect(arg);
        }
      }).join(" ");
      if (!colors.enabled || !str) {
        return str;
      }
      var newLinesPresent = str.indexOf("\n") != -1;
      var nestedStyles = this._styles;
      var i = nestedStyles.length;
      while (i--) {
        var code = ansiStyles[nestedStyles[i]];
        str = code.open + str.replace(code.closeRe, code.open) + code.close;
        if (newLinesPresent) {
          str = str.replace(newLineRegex, function(match) {
            return code.close + match + code.open;
          });
        }
      }
      return str;
    }
    colors.setTheme = function(theme) {
      if (typeof theme === "string") {
        console.log("colors.setTheme now only accepts an object, not a string.  If you are trying to set a theme from a file, it is now your (the caller's) responsibility to require the file.  The old syntax looked like colors.setTheme(__dirname + '/../themes/generic-logging.js'); The new syntax looks like colors.setTheme(require(__dirname + '/../themes/generic-logging.js'));");
        return;
      }
      for (var style in theme) {
        (function(style2) {
          colors[style2] = function(str) {
            if (typeof theme[style2] === "object") {
              var out = str;
              for (var i in theme[style2]) {
                out = colors[theme[style2][i]](out);
              }
              return out;
            }
            return colors[theme[style2]](str);
          };
        })(style);
      }
    };
    function init() {
      var ret = {};
      Object.keys(styles).forEach(function(name) {
        ret[name] = {
          get: function() {
            return build([name]);
          }
        };
      });
      return ret;
    }
    var sequencer = function sequencer2(map2, str) {
      var exploded = str.split("");
      exploded = exploded.map(map2);
      return exploded.join("");
    };
    colors.trap = require_trap();
    colors.zalgo = require_zalgo();
    colors.maps = {};
    colors.maps.america = require_america()(colors);
    colors.maps.zebra = require_zebra()(colors);
    colors.maps.rainbow = require_rainbow()(colors);
    colors.maps.random = require_random()(colors);
    for (map in colors.maps) {
      (function(map2) {
        colors[map2] = function(str) {
          return sequencer(colors.maps[map2], str);
        };
      })(map);
    }
    var map;
    defineProps(colors, init());
  }
});

// node_modules/colors/safe.js
var require_safe = __commonJS({
  "node_modules/colors/safe.js"(exports, module2) {
    var colors = require_colors();
    module2["exports"] = colors;
  }
});

// node_modules/oo-ascii-tree/lib/ascii-tree.js
var require_ascii_tree = __commonJS({
  "node_modules/oo-ascii-tree/lib/ascii-tree.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.AsciiTree = void 0;
    var AsciiTree = class {
      constructor(text, ...children) {
        this.text = text;
        this._children = new Array();
        for (const child of children) {
          this.add(child);
        }
      }
      printTree(output = process.stdout) {
        let ancestorsPrefix = "";
        for (const parent of this.ancestors) {
          if (parent.level <= 0) {
            continue;
          }
          if (parent.last) {
            ancestorsPrefix += "  ";
          } else {
            ancestorsPrefix += " \u2502";
          }
        }
        let myPrefix = "";
        let multilinePrefix = "";
        if (this.level > 0) {
          if (this.last) {
            if (!this.empty) {
              myPrefix += " \u2514\u2500\u252C ";
              multilinePrefix += " \u2514\u2500\u252C ";
            } else {
              myPrefix += " \u2514\u2500\u2500 ";
              multilinePrefix = "     ";
            }
          } else {
            if (!this.empty) {
              myPrefix += " \u251C\u2500\u252C ";
              multilinePrefix += " \u2502 \u2502 ";
            } else {
              myPrefix += " \u251C\u2500\u2500 ";
              multilinePrefix += " \u2502   ";
            }
          }
        }
        if (this.text) {
          output.write(ancestorsPrefix);
          output.write(myPrefix);
          const lines = this.text.split("\n");
          output.write(lines[0]);
          output.write("\n");
          for (const line of lines.splice(1)) {
            output.write(ancestorsPrefix);
            output.write(multilinePrefix);
            output.write(line);
            output.write("\n");
          }
        }
        for (const child of this._children) {
          child.printTree(output);
        }
      }
      toString() {
        let out = "";
        this.printTree({
          write: (data) => out += data
        });
        return out;
      }
      add(...children) {
        for (const child of children) {
          child.parent = this;
          this._children.push(child);
        }
      }
      get children() {
        return this._children.map((x) => x);
      }
      get root() {
        return !this.parent;
      }
      get last() {
        if (!this.parent) {
          return true;
        }
        return this.parent.children.indexOf(this) === this.parent.children.length - 1;
      }
      get level() {
        if (!this.parent) {
          return this.text ? 0 : -1;
        }
        return this.parent.level + 1;
      }
      get empty() {
        return this.children.length === 0;
      }
      get ancestors() {
        if (!this.parent) {
          return [];
        }
        return [...this.parent.ancestors, this.parent];
      }
    };
    exports.AsciiTree = AsciiTree;
  }
});

// node_modules/oo-ascii-tree/lib/index.js
var require_lib6 = __commonJS({
  "node_modules/oo-ascii-tree/lib/index.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        if (p !== "default" && !exports2.hasOwnProperty(p))
          __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    __exportStar(require_ascii_tree(), exports);
  }
});

// node_modules/jsii-reflect/lib/tree.js
var require_tree = __commonJS({
  "node_modules/jsii-reflect/lib/tree.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.TypeSystemTree = void 0;
    var spec_1 = require_lib5();
    var colors = require_safe();
    var oo_ascii_tree_1 = require_lib6();
    var method_1 = require_method();
    var optional_value_1 = require_optional_value();
    var property_1 = require_property();
    var TypeSystemTree = class extends oo_ascii_tree_1.AsciiTree {
      constructor(typesys, options = {}) {
        super();
        if (options.showAll) {
          options.dependencies = true;
          options.inheritance = true;
          options.members = true;
          options.signatures = true;
          options.types = true;
        }
        const shouldUseColors = options.colors === void 0 ? true : options.colors;
        withColors(shouldUseColors, () => {
          if (typesys.assemblies.length > 0) {
            const assemblies = new TitleNode("assemblies");
            assemblies.add(...typesys.assemblies.map((a) => new AssemblyNode(a, options)));
            this.add(assemblies);
          }
        });
      }
    };
    exports.TypeSystemTree = TypeSystemTree;
    var AssemblyNode = class extends oo_ascii_tree_1.AsciiTree {
      constructor(assembly, options) {
        super(colors.green(assembly.name));
        if (options.dependencies && assembly.dependencies.length > 0) {
          const deps = new TitleNode("dependencies");
          this.add(deps);
          deps.add(...assembly.dependencies.map((d) => new DependencyNode(d, options)));
        }
        const submodules = assembly.submodules;
        if (submodules.length > 0) {
          const title = new TitleNode("submodules");
          this.add(title);
          title.add(...submodules.map((s) => new SubmoduleNode(s, options)));
        }
        if (options.types) {
          const types = new TitleNode("types");
          this.add(types);
          types.add(...assembly.classes.map((c) => new ClassNode(c, options)));
          types.add(...assembly.interfaces.map((c) => new InterfaceNode(c, options)));
          types.add(...assembly.enums.map((c) => new EnumNode(c, options)));
        }
      }
    };
    var SubmoduleNode = class extends oo_ascii_tree_1.AsciiTree {
      constructor(submodule, options) {
        super(colors.green(submodule.name));
        const submodules = submodule.submodules;
        if (submodules.length > 0) {
          const title = new TitleNode("submodules");
          this.add(title);
          title.add(...submodules.map((s) => new SubmoduleNode(s, options)));
        }
        if (options.types) {
          const types = new TitleNode("types");
          this.add(types);
          types.add(...submodule.classes.map((c) => new ClassNode(c, options)));
          types.add(...submodule.interfaces.map((i) => new InterfaceNode(i, options)));
          types.add(...submodule.enums.map((e) => new EnumNode(e, options)));
        }
      }
    };
    var MethodNode = class extends oo_ascii_tree_1.AsciiTree {
      constructor(method, options) {
        const args = method.parameters.map((p) => p.name).join(",");
        super(`${maybeStatic(method)}${method.name}(${args}) ${colors.gray("method")}${describeStability(method, options)}`);
        if (options.signatures) {
          if (method.abstract) {
            this.add(new FlagNode("abstract"));
          }
          if (method.protected) {
            this.add(new FlagNode("protected"));
          }
          if (method.static) {
            this.add(new FlagNode("static"));
          }
          if (method.variadic) {
            this.add(new FlagNode("variadic"));
          }
          if (method.parameters.length > 0) {
            const params = new TitleNode("parameters");
            this.add(params);
            params.add(...method.parameters.map((p) => new ParameterNode(p, options)));
          }
          this.add(new OptionalValueNode("returns", method.returns, {
            asPromise: method.async
          }));
        }
      }
    };
    var InitializerNode = class extends oo_ascii_tree_1.AsciiTree {
      constructor(initializer, options) {
        const args = initializer.parameters.map((p) => p.name).join(",");
        super(`${initializer.name}(${args}) ${colors.gray("initializer")}${describeStability(initializer, options)}`);
        if (options.signatures) {
          if (initializer.protected) {
            this.add(new FlagNode("protected"));
          }
          if (initializer.variadic) {
            this.add(new FlagNode("variadic"));
          }
          if (initializer.parameters.length > 0) {
            const params = new TitleNode("parameters");
            this.add(params);
            params.add(...initializer.parameters.map((p) => new ParameterNode(p, options)));
          }
        }
      }
    };
    var ParameterNode = class extends oo_ascii_tree_1.AsciiTree {
      constructor(param, _options) {
        super(param.name);
        this.add(new OptionalValueNode("type", param));
        if (param.variadic) {
          this.add(new FlagNode("variadic"));
        }
      }
    };
    var PropertyNode = class extends oo_ascii_tree_1.AsciiTree {
      constructor(property, options) {
        super(`${maybeStatic(property)}${property.name} ${colors.gray("property")}${describeStability(property, options)}`);
        if (options.signatures) {
          if (property.abstract) {
            this.add(new FlagNode("abstract"));
          }
          if (property.const) {
            this.add(new FlagNode("const"));
          }
          if (property.immutable) {
            this.add(new FlagNode("immutable"));
          }
          if (property.protected) {
            this.add(new FlagNode("protected"));
          }
          if (property.static) {
            this.add(new FlagNode("static"));
          }
          this.add(new OptionalValueNode("type", property));
        }
      }
    };
    var OptionalValueNode = class extends oo_ascii_tree_1.AsciiTree {
      constructor(name, optionalValue, { asPromise } = { asPromise: false }) {
        let type = optional_value_1.OptionalValue.describe(optionalValue);
        if (asPromise) {
          type = `Promise<${type}>`;
        }
        super(`${colors.underline(name)}: ${type}`);
      }
    };
    var ClassNode = class extends oo_ascii_tree_1.AsciiTree {
      constructor(type, options) {
        super(`${colors.gray("class")} ${colors.cyan(type.name)}${describeStability(type, options)}`);
        if (options.inheritance && type.base) {
          this.add(new KeyValueNode("base", type.base.name));
        }
        if (options.inheritance && type.interfaces.length > 0) {
          this.add(new KeyValueNode("interfaces", type.interfaces.map((i) => i.name).join(",")));
        }
        if (options.members) {
          const members = new TitleNode("members");
          this.add(members);
          if (type.initializer) {
            members.add(new InitializerNode(type.initializer, options));
          }
          members.add(...type.ownMethods.map((m) => new MethodNode(m, options)));
          members.add(...type.ownProperties.map((p) => new PropertyNode(p, options)));
        }
      }
    };
    var InterfaceNode = class extends oo_ascii_tree_1.AsciiTree {
      constructor(type, options) {
        super(`${colors.gray("interface")} ${colors.cyan(type.name)}${describeStability(type, options)}`);
        if (options.inheritance && type.interfaces.length > 0) {
          const interfaces = new TitleNode("interfaces");
          this.add(interfaces);
          interfaces.add(...type.interfaces.map((i) => new TextNode(i.name)));
        }
        if (options.members) {
          const members = new TitleNode("members");
          members.add(...type.ownMethods.map((m) => new MethodNode(m, options)));
          members.add(...type.ownProperties.map((p) => new PropertyNode(p, options)));
          this.add(members);
        }
      }
    };
    var EnumNode = class extends oo_ascii_tree_1.AsciiTree {
      constructor(enumType, options) {
        super(`${colors.gray("enum")} ${colors.cyan(enumType.name)}${describeStability(enumType, options)}`);
        if (options.members) {
          enumType.members.forEach((mem) => {
            this.add(new oo_ascii_tree_1.AsciiTree(mem.name + describeStability(mem, options)));
          });
        }
      }
    };
    var DependencyNode = class extends oo_ascii_tree_1.AsciiTree {
      constructor(dep, _options) {
        super(dep.assembly.name);
      }
    };
    var TitleNode = class extends oo_ascii_tree_1.AsciiTree {
      constructor(name, children = []) {
        super(colors.underline(name), ...children);
      }
    };
    var KeyValueNode = class extends oo_ascii_tree_1.AsciiTree {
      constructor(key, value) {
        super(`${colors.underline(key)}: ${value}`);
      }
    };
    var TextNode = class extends oo_ascii_tree_1.AsciiTree {
    };
    var FlagNode = class extends oo_ascii_tree_1.AsciiTree {
      constructor(flag) {
        super(colors.italic(flag));
      }
    };
    function withColors(enabled, block) {
      const oldEnabled = colors.enabled;
      try {
        if (enabled) {
          colors.enable();
        } else {
          colors.disable();
        }
        block();
      } finally {
        if (oldEnabled) {
          colors.enable();
        } else {
          colors.disable();
        }
      }
    }
    function describeStability(thing, options) {
      if (!options.stabilities || thing.docs.stability == null) {
        return "";
      }
      switch (thing.docs.stability) {
        case spec_1.Stability.Stable:
          return ` (${colors.green("stable")})`;
        case spec_1.Stability.External:
          return ` (${colors.green("external")})`;
        case spec_1.Stability.Experimental:
          return ` (${colors.yellow("experimental")})`;
        case spec_1.Stability.Deprecated:
          return ` (${colors.red("deprecated")})`;
        default:
          return "";
      }
    }
    function maybeStatic(mem) {
      let isStatic;
      if (mem instanceof property_1.Property) {
        isStatic = !!mem.static;
      }
      if (mem instanceof method_1.Method) {
        isStatic = !!mem.static;
      }
      return isStatic ? `${colors.grey("static")} ` : "";
    }
  }
});

// node_modules/jsii-reflect/lib/type-system.js
var require_type_system = __commonJS({
  "node_modules/jsii-reflect/lib/type-system.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.TypeSystem = void 0;
    var jsii = require_lib5();
    var path2 = require("path");
    var util_1 = require("util");
    var assembly_1 = require_assembly2();
    var class_1 = require_class();
    var enum_1 = require_enum();
    var interface_1 = require_interface();
    var TypeSystem = class {
      constructor() {
        this.assemblies = new Array();
        this.roots = new Array();
        this._assemblyLookup = {};
      }
      async loadNpmDependencies(packageRoot, options = {}) {
        const pkg = require(path2.resolve(packageRoot, "package.json"));
        for (const dep of dependenciesOf(pkg)) {
          const depPkgJsonPath = require.resolve(`${dep}/package.json`, {
            paths: [packageRoot]
          });
          const depPkgJson = require(depPkgJsonPath);
          if (!depPkgJson.jsii) {
            continue;
          }
          await this.loadModule(path2.dirname(depPkgJsonPath), options);
        }
      }
      async load(fileOrDirectory, options = {}) {
        if ((await stat(fileOrDirectory)).isDirectory()) {
          return this.loadModule(fileOrDirectory, options);
        }
        return this.loadFile(fileOrDirectory, __spreadProps(__spreadValues({}, options), { isRoot: true }));
      }
      async loadModule(dir, options = {}) {
        const out = await _loadModule.call(this, dir, true);
        if (!out) {
          throw new Error(`Unable to load module from directory: ${dir}`);
        }
        return out;
        async function _loadModule(moduleDirectory, isRoot = false) {
          const filePath = path2.join(moduleDirectory, "package.json");
          const pkg = JSON.parse((await readFile(filePath)).toString());
          if (!pkg.jsii) {
            throw new Error(`No "jsii" section in ${filePath}`);
          }
          const asm = await this.loadAssembly(path2.join(moduleDirectory, ".jsii"), false);
          if (this.includesAssembly(asm.name)) {
            const existing = this.findAssembly(asm.name);
            if (existing.version !== asm.version) {
              throw new Error(`Conflicting versions of ${asm.name} in type system: previously loaded ${existing.version}, trying to load ${asm.version}`);
            }
            if (isRoot) {
              this.addRoot(asm);
            }
            return existing;
          }
          if (options.validate !== false) {
            asm.validate();
          }
          const root = this.addAssembly(asm, { isRoot });
          const bundled = pkg.bundledDependencies || pkg.bundleDependencies || [];
          for (const name of dependenciesOf(pkg)) {
            if (bundled.includes(name)) {
              continue;
            }
            const depDir = require.resolve(`${name}/package.json`, {
              paths: [moduleDirectory]
            });
            await _loadModule.call(this, path2.dirname(depDir));
          }
          return root;
        }
      }
      async loadFile(file, options = {}) {
        const assembly = await this.loadAssembly(file, options.validate !== false);
        return this.addAssembly(assembly, options);
      }
      addAssembly(asm, options = {}) {
        if (asm.system !== this) {
          throw new Error("Assembly has been created for different typesystem");
        }
        if (!this._assemblyLookup[asm.name]) {
          this._assemblyLookup[asm.name] = asm;
          this.assemblies.push(asm);
        }
        if (options.isRoot !== false) {
          this.addRoot(asm);
        }
        return asm;
      }
      includesAssembly(name) {
        return name in this._assemblyLookup;
      }
      isRoot(name) {
        return this.roots.map((r) => r.name).includes(name);
      }
      findAssembly(name) {
        const ret = this.tryFindAssembly(name);
        if (!ret) {
          throw new Error(`Assembly "${name}" not found`);
        }
        return ret;
      }
      tryFindAssembly(name) {
        return this._assemblyLookup[name];
      }
      findFqn(fqn) {
        const [assembly] = fqn.split(".");
        const asm = this.findAssembly(assembly);
        return asm.findType(fqn);
      }
      tryFindFqn(fqn) {
        const [assembly] = fqn.split(".");
        const asm = this.tryFindAssembly(assembly);
        return asm === null || asm === void 0 ? void 0 : asm.tryFindType(fqn);
      }
      findClass(fqn) {
        const type = this.findFqn(fqn);
        if (!(type instanceof class_1.ClassType)) {
          throw new Error(`FQN ${fqn} is not a class`);
        }
        return type;
      }
      findInterface(fqn) {
        const type = this.findFqn(fqn);
        if (!(type instanceof interface_1.InterfaceType)) {
          throw new Error(`FQN ${fqn} is not an interface`);
        }
        return type;
      }
      findEnum(fqn) {
        const type = this.findFqn(fqn);
        if (!(type instanceof enum_1.EnumType)) {
          throw new Error(`FQN ${fqn} is not an enum`);
        }
        return type;
      }
      get methods() {
        const getMethods = (mod) => {
          return [
            ...flatMap(mod.submodules, getMethods),
            ...flatMap(mod.interfaces, (iface) => iface.ownMethods),
            ...flatMap(mod.classes, (clazz) => clazz.ownMethods)
          ];
        };
        return flatMap(this.assemblies, getMethods);
      }
      get properties() {
        const getProperties = (mod) => {
          return [
            ...flatMap(mod.submodules, getProperties),
            ...flatMap(mod.interfaces, (iface) => iface.ownProperties),
            ...flatMap(mod.classes, (clazz) => clazz.ownProperties)
          ];
        };
        return flatMap(this.assemblies, getProperties);
      }
      get classes() {
        const out = new Array();
        this.assemblies.forEach((a) => {
          out.push(...collectTypes(a, (item) => item.classes));
        });
        return out;
      }
      get interfaces() {
        const out = new Array();
        this.assemblies.forEach((a) => {
          out.push(...collectTypes(a, (item) => item.interfaces));
        });
        return out;
      }
      get enums() {
        const out = new Array();
        this.assemblies.forEach((a) => {
          out.push(...collectTypes(a, (item) => item.enums));
        });
        return out;
      }
      async loadAssembly(file, validate = true) {
        const spec = JSON.parse((await readFile(file)).toString());
        const ass = validate ? jsii.validateAssembly(spec) : spec;
        return new assembly_1.Assembly(this, ass);
      }
      addRoot(asm) {
        if (!this.roots.map((r) => r.name).includes(asm.name)) {
          this.roots.push(asm);
        }
      }
    };
    exports.TypeSystem = TypeSystem;
    function dependenciesOf(packageJson) {
      var _a, _b;
      const deps = new Set();
      Object.keys((_a = packageJson.dependencies) !== null && _a !== void 0 ? _a : {}).forEach(deps.add.bind(deps));
      Object.keys((_b = packageJson.peerDependencies) !== null && _b !== void 0 ? _b : {}).forEach(deps.add.bind(deps));
      return Array.from(deps);
    }
    function collectTypes(module3, getter) {
      const result = new Array();
      for (const submodule of module3.submodules) {
        result.push(...collectTypes(submodule, getter));
      }
      result.push(...getter(module3));
      return result;
    }
    function flatMap(collection, mapper) {
      return collection.map(mapper).reduce((acc, elt) => acc.concat(elt), new Array());
    }
    function stat(p) {
      const fs2 = require("fs");
      return util_1.promisify(fs2.stat)(p);
    }
    function readFile(p) {
      const fs2 = require("fs");
      return util_1.promisify(fs2.readFile)(p);
    }
  }
});

// node_modules/jsii-reflect/lib/index.js
var require_lib7 = __commonJS({
  "node_modules/jsii-reflect/lib/index.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        if (p !== "default" && !exports2.hasOwnProperty(p))
          __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    __exportStar(require_assembly2(), exports);
    __exportStar(require_class(), exports);
    __exportStar(require_callable(), exports);
    __exportStar(require_dependency(), exports);
    __exportStar(require_docs(), exports);
    __exportStar(require_enum(), exports);
    __exportStar(require_initializer(), exports);
    __exportStar(require_interface(), exports);
    __exportStar(require_method(), exports);
    __exportStar(require_module_like(), exports);
    __exportStar(require_optional_value(), exports);
    __exportStar(require_overridable(), exports);
    __exportStar(require_parameter(), exports);
    __exportStar(require_property(), exports);
    __exportStar(require_submodule(), exports);
    __exportStar(require_tree(), exports);
    __exportStar(require_type(), exports);
    __exportStar(require_type_member(), exports);
    __exportStar(require_type_ref(), exports);
    __exportStar(require_type_system(), exports);
    __exportStar(require_reference_type(), exports);
    __exportStar(require_source(), exports);
  }
});

// node_modules/source-map/lib/base64.js
var require_base64 = __commonJS({
  "node_modules/source-map/lib/base64.js"(exports) {
    var intToCharMap = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".split("");
    exports.encode = function(number) {
      if (0 <= number && number < intToCharMap.length) {
        return intToCharMap[number];
      }
      throw new TypeError("Must be between 0 and 63: " + number);
    };
    exports.decode = function(charCode) {
      var bigA = 65;
      var bigZ = 90;
      var littleA = 97;
      var littleZ = 122;
      var zero = 48;
      var nine = 57;
      var plus = 43;
      var slash = 47;
      var littleOffset = 26;
      var numberOffset = 52;
      if (bigA <= charCode && charCode <= bigZ) {
        return charCode - bigA;
      }
      if (littleA <= charCode && charCode <= littleZ) {
        return charCode - littleA + littleOffset;
      }
      if (zero <= charCode && charCode <= nine) {
        return charCode - zero + numberOffset;
      }
      if (charCode == plus) {
        return 62;
      }
      if (charCode == slash) {
        return 63;
      }
      return -1;
    };
  }
});

// node_modules/source-map/lib/base64-vlq.js
var require_base64_vlq = __commonJS({
  "node_modules/source-map/lib/base64-vlq.js"(exports) {
    var base64 = require_base64();
    var VLQ_BASE_SHIFT = 5;
    var VLQ_BASE = 1 << VLQ_BASE_SHIFT;
    var VLQ_BASE_MASK = VLQ_BASE - 1;
    var VLQ_CONTINUATION_BIT = VLQ_BASE;
    function toVLQSigned(aValue) {
      return aValue < 0 ? (-aValue << 1) + 1 : (aValue << 1) + 0;
    }
    function fromVLQSigned(aValue) {
      var isNegative = (aValue & 1) === 1;
      var shifted = aValue >> 1;
      return isNegative ? -shifted : shifted;
    }
    exports.encode = function base64VLQ_encode(aValue) {
      var encoded = "";
      var digit;
      var vlq = toVLQSigned(aValue);
      do {
        digit = vlq & VLQ_BASE_MASK;
        vlq >>>= VLQ_BASE_SHIFT;
        if (vlq > 0) {
          digit |= VLQ_CONTINUATION_BIT;
        }
        encoded += base64.encode(digit);
      } while (vlq > 0);
      return encoded;
    };
    exports.decode = function base64VLQ_decode(aStr, aIndex, aOutParam) {
      var strLen = aStr.length;
      var result = 0;
      var shift = 0;
      var continuation, digit;
      do {
        if (aIndex >= strLen) {
          throw new Error("Expected more digits in base 64 VLQ value.");
        }
        digit = base64.decode(aStr.charCodeAt(aIndex++));
        if (digit === -1) {
          throw new Error("Invalid base64 digit: " + aStr.charAt(aIndex - 1));
        }
        continuation = !!(digit & VLQ_CONTINUATION_BIT);
        digit &= VLQ_BASE_MASK;
        result = result + (digit << shift);
        shift += VLQ_BASE_SHIFT;
      } while (continuation);
      aOutParam.value = fromVLQSigned(result);
      aOutParam.rest = aIndex;
    };
  }
});

// node_modules/source-map/lib/util.js
var require_util2 = __commonJS({
  "node_modules/source-map/lib/util.js"(exports) {
    function getArg(aArgs, aName, aDefaultValue) {
      if (aName in aArgs) {
        return aArgs[aName];
      } else if (arguments.length === 3) {
        return aDefaultValue;
      } else {
        throw new Error('"' + aName + '" is a required argument.');
      }
    }
    exports.getArg = getArg;
    var urlRegexp = /^(?:([\w+\-.]+):)?\/\/(?:(\w+:\w+)@)?([\w.-]*)(?::(\d+))?(.*)$/;
    var dataUrlRegexp = /^data:.+\,.+$/;
    function urlParse(aUrl) {
      var match = aUrl.match(urlRegexp);
      if (!match) {
        return null;
      }
      return {
        scheme: match[1],
        auth: match[2],
        host: match[3],
        port: match[4],
        path: match[5]
      };
    }
    exports.urlParse = urlParse;
    function urlGenerate(aParsedUrl) {
      var url = "";
      if (aParsedUrl.scheme) {
        url += aParsedUrl.scheme + ":";
      }
      url += "//";
      if (aParsedUrl.auth) {
        url += aParsedUrl.auth + "@";
      }
      if (aParsedUrl.host) {
        url += aParsedUrl.host;
      }
      if (aParsedUrl.port) {
        url += ":" + aParsedUrl.port;
      }
      if (aParsedUrl.path) {
        url += aParsedUrl.path;
      }
      return url;
    }
    exports.urlGenerate = urlGenerate;
    function normalize(aPath) {
      var path2 = aPath;
      var url = urlParse(aPath);
      if (url) {
        if (!url.path) {
          return aPath;
        }
        path2 = url.path;
      }
      var isAbsolute = exports.isAbsolute(path2);
      var parts = path2.split(/\/+/);
      for (var part, up = 0, i = parts.length - 1; i >= 0; i--) {
        part = parts[i];
        if (part === ".") {
          parts.splice(i, 1);
        } else if (part === "..") {
          up++;
        } else if (up > 0) {
          if (part === "") {
            parts.splice(i + 1, up);
            up = 0;
          } else {
            parts.splice(i, 2);
            up--;
          }
        }
      }
      path2 = parts.join("/");
      if (path2 === "") {
        path2 = isAbsolute ? "/" : ".";
      }
      if (url) {
        url.path = path2;
        return urlGenerate(url);
      }
      return path2;
    }
    exports.normalize = normalize;
    function join2(aRoot, aPath) {
      if (aRoot === "") {
        aRoot = ".";
      }
      if (aPath === "") {
        aPath = ".";
      }
      var aPathUrl = urlParse(aPath);
      var aRootUrl = urlParse(aRoot);
      if (aRootUrl) {
        aRoot = aRootUrl.path || "/";
      }
      if (aPathUrl && !aPathUrl.scheme) {
        if (aRootUrl) {
          aPathUrl.scheme = aRootUrl.scheme;
        }
        return urlGenerate(aPathUrl);
      }
      if (aPathUrl || aPath.match(dataUrlRegexp)) {
        return aPath;
      }
      if (aRootUrl && !aRootUrl.host && !aRootUrl.path) {
        aRootUrl.host = aPath;
        return urlGenerate(aRootUrl);
      }
      var joined = aPath.charAt(0) === "/" ? aPath : normalize(aRoot.replace(/\/+$/, "") + "/" + aPath);
      if (aRootUrl) {
        aRootUrl.path = joined;
        return urlGenerate(aRootUrl);
      }
      return joined;
    }
    exports.join = join2;
    exports.isAbsolute = function(aPath) {
      return aPath.charAt(0) === "/" || urlRegexp.test(aPath);
    };
    function relative(aRoot, aPath) {
      if (aRoot === "") {
        aRoot = ".";
      }
      aRoot = aRoot.replace(/\/$/, "");
      var level = 0;
      while (aPath.indexOf(aRoot + "/") !== 0) {
        var index = aRoot.lastIndexOf("/");
        if (index < 0) {
          return aPath;
        }
        aRoot = aRoot.slice(0, index);
        if (aRoot.match(/^([^\/]+:\/)?\/*$/)) {
          return aPath;
        }
        ++level;
      }
      return Array(level + 1).join("../") + aPath.substr(aRoot.length + 1);
    }
    exports.relative = relative;
    var supportsNullProto = function() {
      var obj = Object.create(null);
      return !("__proto__" in obj);
    }();
    function identity(s) {
      return s;
    }
    function toSetString(aStr) {
      if (isProtoString(aStr)) {
        return "$" + aStr;
      }
      return aStr;
    }
    exports.toSetString = supportsNullProto ? identity : toSetString;
    function fromSetString(aStr) {
      if (isProtoString(aStr)) {
        return aStr.slice(1);
      }
      return aStr;
    }
    exports.fromSetString = supportsNullProto ? identity : fromSetString;
    function isProtoString(s) {
      if (!s) {
        return false;
      }
      var length = s.length;
      if (length < 9) {
        return false;
      }
      if (s.charCodeAt(length - 1) !== 95 || s.charCodeAt(length - 2) !== 95 || s.charCodeAt(length - 3) !== 111 || s.charCodeAt(length - 4) !== 116 || s.charCodeAt(length - 5) !== 111 || s.charCodeAt(length - 6) !== 114 || s.charCodeAt(length - 7) !== 112 || s.charCodeAt(length - 8) !== 95 || s.charCodeAt(length - 9) !== 95) {
        return false;
      }
      for (var i = length - 10; i >= 0; i--) {
        if (s.charCodeAt(i) !== 36) {
          return false;
        }
      }
      return true;
    }
    function compareByOriginalPositions(mappingA, mappingB, onlyCompareOriginal) {
      var cmp = strcmp(mappingA.source, mappingB.source);
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalLine - mappingB.originalLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalColumn - mappingB.originalColumn;
      if (cmp !== 0 || onlyCompareOriginal) {
        return cmp;
      }
      cmp = mappingA.generatedColumn - mappingB.generatedColumn;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.generatedLine - mappingB.generatedLine;
      if (cmp !== 0) {
        return cmp;
      }
      return strcmp(mappingA.name, mappingB.name);
    }
    exports.compareByOriginalPositions = compareByOriginalPositions;
    function compareByGeneratedPositionsDeflated(mappingA, mappingB, onlyCompareGenerated) {
      var cmp = mappingA.generatedLine - mappingB.generatedLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.generatedColumn - mappingB.generatedColumn;
      if (cmp !== 0 || onlyCompareGenerated) {
        return cmp;
      }
      cmp = strcmp(mappingA.source, mappingB.source);
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalLine - mappingB.originalLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalColumn - mappingB.originalColumn;
      if (cmp !== 0) {
        return cmp;
      }
      return strcmp(mappingA.name, mappingB.name);
    }
    exports.compareByGeneratedPositionsDeflated = compareByGeneratedPositionsDeflated;
    function strcmp(aStr1, aStr2) {
      if (aStr1 === aStr2) {
        return 0;
      }
      if (aStr1 === null) {
        return 1;
      }
      if (aStr2 === null) {
        return -1;
      }
      if (aStr1 > aStr2) {
        return 1;
      }
      return -1;
    }
    function compareByGeneratedPositionsInflated(mappingA, mappingB) {
      var cmp = mappingA.generatedLine - mappingB.generatedLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.generatedColumn - mappingB.generatedColumn;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = strcmp(mappingA.source, mappingB.source);
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalLine - mappingB.originalLine;
      if (cmp !== 0) {
        return cmp;
      }
      cmp = mappingA.originalColumn - mappingB.originalColumn;
      if (cmp !== 0) {
        return cmp;
      }
      return strcmp(mappingA.name, mappingB.name);
    }
    exports.compareByGeneratedPositionsInflated = compareByGeneratedPositionsInflated;
    function parseSourceMapInput(str) {
      return JSON.parse(str.replace(/^\)]}'[^\n]*\n/, ""));
    }
    exports.parseSourceMapInput = parseSourceMapInput;
    function computeSourceURL(sourceRoot, sourceURL, sourceMapURL) {
      sourceURL = sourceURL || "";
      if (sourceRoot) {
        if (sourceRoot[sourceRoot.length - 1] !== "/" && sourceURL[0] !== "/") {
          sourceRoot += "/";
        }
        sourceURL = sourceRoot + sourceURL;
      }
      if (sourceMapURL) {
        var parsed = urlParse(sourceMapURL);
        if (!parsed) {
          throw new Error("sourceMapURL could not be parsed");
        }
        if (parsed.path) {
          var index = parsed.path.lastIndexOf("/");
          if (index >= 0) {
            parsed.path = parsed.path.substring(0, index + 1);
          }
        }
        sourceURL = join2(urlGenerate(parsed), sourceURL);
      }
      return normalize(sourceURL);
    }
    exports.computeSourceURL = computeSourceURL;
  }
});

// node_modules/source-map/lib/array-set.js
var require_array_set = __commonJS({
  "node_modules/source-map/lib/array-set.js"(exports) {
    var util = require_util2();
    var has = Object.prototype.hasOwnProperty;
    var hasNativeMap = typeof Map !== "undefined";
    function ArraySet() {
      this._array = [];
      this._set = hasNativeMap ? new Map() : Object.create(null);
    }
    ArraySet.fromArray = function ArraySet_fromArray(aArray, aAllowDuplicates) {
      var set = new ArraySet();
      for (var i = 0, len = aArray.length; i < len; i++) {
        set.add(aArray[i], aAllowDuplicates);
      }
      return set;
    };
    ArraySet.prototype.size = function ArraySet_size() {
      return hasNativeMap ? this._set.size : Object.getOwnPropertyNames(this._set).length;
    };
    ArraySet.prototype.add = function ArraySet_add(aStr, aAllowDuplicates) {
      var sStr = hasNativeMap ? aStr : util.toSetString(aStr);
      var isDuplicate = hasNativeMap ? this.has(aStr) : has.call(this._set, sStr);
      var idx = this._array.length;
      if (!isDuplicate || aAllowDuplicates) {
        this._array.push(aStr);
      }
      if (!isDuplicate) {
        if (hasNativeMap) {
          this._set.set(aStr, idx);
        } else {
          this._set[sStr] = idx;
        }
      }
    };
    ArraySet.prototype.has = function ArraySet_has(aStr) {
      if (hasNativeMap) {
        return this._set.has(aStr);
      } else {
        var sStr = util.toSetString(aStr);
        return has.call(this._set, sStr);
      }
    };
    ArraySet.prototype.indexOf = function ArraySet_indexOf(aStr) {
      if (hasNativeMap) {
        var idx = this._set.get(aStr);
        if (idx >= 0) {
          return idx;
        }
      } else {
        var sStr = util.toSetString(aStr);
        if (has.call(this._set, sStr)) {
          return this._set[sStr];
        }
      }
      throw new Error('"' + aStr + '" is not in the set.');
    };
    ArraySet.prototype.at = function ArraySet_at(aIdx) {
      if (aIdx >= 0 && aIdx < this._array.length) {
        return this._array[aIdx];
      }
      throw new Error("No element indexed by " + aIdx);
    };
    ArraySet.prototype.toArray = function ArraySet_toArray() {
      return this._array.slice();
    };
    exports.ArraySet = ArraySet;
  }
});

// node_modules/source-map/lib/mapping-list.js
var require_mapping_list = __commonJS({
  "node_modules/source-map/lib/mapping-list.js"(exports) {
    var util = require_util2();
    function generatedPositionAfter(mappingA, mappingB) {
      var lineA = mappingA.generatedLine;
      var lineB = mappingB.generatedLine;
      var columnA = mappingA.generatedColumn;
      var columnB = mappingB.generatedColumn;
      return lineB > lineA || lineB == lineA && columnB >= columnA || util.compareByGeneratedPositionsInflated(mappingA, mappingB) <= 0;
    }
    function MappingList() {
      this._array = [];
      this._sorted = true;
      this._last = { generatedLine: -1, generatedColumn: 0 };
    }
    MappingList.prototype.unsortedForEach = function MappingList_forEach(aCallback, aThisArg) {
      this._array.forEach(aCallback, aThisArg);
    };
    MappingList.prototype.add = function MappingList_add(aMapping) {
      if (generatedPositionAfter(this._last, aMapping)) {
        this._last = aMapping;
        this._array.push(aMapping);
      } else {
        this._sorted = false;
        this._array.push(aMapping);
      }
    };
    MappingList.prototype.toArray = function MappingList_toArray() {
      if (!this._sorted) {
        this._array.sort(util.compareByGeneratedPositionsInflated);
        this._sorted = true;
      }
      return this._array;
    };
    exports.MappingList = MappingList;
  }
});

// node_modules/source-map/lib/source-map-generator.js
var require_source_map_generator = __commonJS({
  "node_modules/source-map/lib/source-map-generator.js"(exports) {
    var base64VLQ = require_base64_vlq();
    var util = require_util2();
    var ArraySet = require_array_set().ArraySet;
    var MappingList = require_mapping_list().MappingList;
    function SourceMapGenerator(aArgs) {
      if (!aArgs) {
        aArgs = {};
      }
      this._file = util.getArg(aArgs, "file", null);
      this._sourceRoot = util.getArg(aArgs, "sourceRoot", null);
      this._skipValidation = util.getArg(aArgs, "skipValidation", false);
      this._sources = new ArraySet();
      this._names = new ArraySet();
      this._mappings = new MappingList();
      this._sourcesContents = null;
    }
    SourceMapGenerator.prototype._version = 3;
    SourceMapGenerator.fromSourceMap = function SourceMapGenerator_fromSourceMap(aSourceMapConsumer) {
      var sourceRoot = aSourceMapConsumer.sourceRoot;
      var generator = new SourceMapGenerator({
        file: aSourceMapConsumer.file,
        sourceRoot
      });
      aSourceMapConsumer.eachMapping(function(mapping) {
        var newMapping = {
          generated: {
            line: mapping.generatedLine,
            column: mapping.generatedColumn
          }
        };
        if (mapping.source != null) {
          newMapping.source = mapping.source;
          if (sourceRoot != null) {
            newMapping.source = util.relative(sourceRoot, newMapping.source);
          }
          newMapping.original = {
            line: mapping.originalLine,
            column: mapping.originalColumn
          };
          if (mapping.name != null) {
            newMapping.name = mapping.name;
          }
        }
        generator.addMapping(newMapping);
      });
      aSourceMapConsumer.sources.forEach(function(sourceFile) {
        var sourceRelative = sourceFile;
        if (sourceRoot !== null) {
          sourceRelative = util.relative(sourceRoot, sourceFile);
        }
        if (!generator._sources.has(sourceRelative)) {
          generator._sources.add(sourceRelative);
        }
        var content = aSourceMapConsumer.sourceContentFor(sourceFile);
        if (content != null) {
          generator.setSourceContent(sourceFile, content);
        }
      });
      return generator;
    };
    SourceMapGenerator.prototype.addMapping = function SourceMapGenerator_addMapping(aArgs) {
      var generated = util.getArg(aArgs, "generated");
      var original = util.getArg(aArgs, "original", null);
      var source = util.getArg(aArgs, "source", null);
      var name = util.getArg(aArgs, "name", null);
      if (!this._skipValidation) {
        this._validateMapping(generated, original, source, name);
      }
      if (source != null) {
        source = String(source);
        if (!this._sources.has(source)) {
          this._sources.add(source);
        }
      }
      if (name != null) {
        name = String(name);
        if (!this._names.has(name)) {
          this._names.add(name);
        }
      }
      this._mappings.add({
        generatedLine: generated.line,
        generatedColumn: generated.column,
        originalLine: original != null && original.line,
        originalColumn: original != null && original.column,
        source,
        name
      });
    };
    SourceMapGenerator.prototype.setSourceContent = function SourceMapGenerator_setSourceContent(aSourceFile, aSourceContent) {
      var source = aSourceFile;
      if (this._sourceRoot != null) {
        source = util.relative(this._sourceRoot, source);
      }
      if (aSourceContent != null) {
        if (!this._sourcesContents) {
          this._sourcesContents = Object.create(null);
        }
        this._sourcesContents[util.toSetString(source)] = aSourceContent;
      } else if (this._sourcesContents) {
        delete this._sourcesContents[util.toSetString(source)];
        if (Object.keys(this._sourcesContents).length === 0) {
          this._sourcesContents = null;
        }
      }
    };
    SourceMapGenerator.prototype.applySourceMap = function SourceMapGenerator_applySourceMap(aSourceMapConsumer, aSourceFile, aSourceMapPath) {
      var sourceFile = aSourceFile;
      if (aSourceFile == null) {
        if (aSourceMapConsumer.file == null) {
          throw new Error(`SourceMapGenerator.prototype.applySourceMap requires either an explicit source file, or the source map's "file" property. Both were omitted.`);
        }
        sourceFile = aSourceMapConsumer.file;
      }
      var sourceRoot = this._sourceRoot;
      if (sourceRoot != null) {
        sourceFile = util.relative(sourceRoot, sourceFile);
      }
      var newSources = new ArraySet();
      var newNames = new ArraySet();
      this._mappings.unsortedForEach(function(mapping) {
        if (mapping.source === sourceFile && mapping.originalLine != null) {
          var original = aSourceMapConsumer.originalPositionFor({
            line: mapping.originalLine,
            column: mapping.originalColumn
          });
          if (original.source != null) {
            mapping.source = original.source;
            if (aSourceMapPath != null) {
              mapping.source = util.join(aSourceMapPath, mapping.source);
            }
            if (sourceRoot != null) {
              mapping.source = util.relative(sourceRoot, mapping.source);
            }
            mapping.originalLine = original.line;
            mapping.originalColumn = original.column;
            if (original.name != null) {
              mapping.name = original.name;
            }
          }
        }
        var source = mapping.source;
        if (source != null && !newSources.has(source)) {
          newSources.add(source);
        }
        var name = mapping.name;
        if (name != null && !newNames.has(name)) {
          newNames.add(name);
        }
      }, this);
      this._sources = newSources;
      this._names = newNames;
      aSourceMapConsumer.sources.forEach(function(sourceFile2) {
        var content = aSourceMapConsumer.sourceContentFor(sourceFile2);
        if (content != null) {
          if (aSourceMapPath != null) {
            sourceFile2 = util.join(aSourceMapPath, sourceFile2);
          }
          if (sourceRoot != null) {
            sourceFile2 = util.relative(sourceRoot, sourceFile2);
          }
          this.setSourceContent(sourceFile2, content);
        }
      }, this);
    };
    SourceMapGenerator.prototype._validateMapping = function SourceMapGenerator_validateMapping(aGenerated, aOriginal, aSource, aName) {
      if (aOriginal && typeof aOriginal.line !== "number" && typeof aOriginal.column !== "number") {
        throw new Error("original.line and original.column are not numbers -- you probably meant to omit the original mapping entirely and only map the generated position. If so, pass null for the original mapping instead of an object with empty or null values.");
      }
      if (aGenerated && "line" in aGenerated && "column" in aGenerated && aGenerated.line > 0 && aGenerated.column >= 0 && !aOriginal && !aSource && !aName) {
        return;
      } else if (aGenerated && "line" in aGenerated && "column" in aGenerated && aOriginal && "line" in aOriginal && "column" in aOriginal && aGenerated.line > 0 && aGenerated.column >= 0 && aOriginal.line > 0 && aOriginal.column >= 0 && aSource) {
        return;
      } else {
        throw new Error("Invalid mapping: " + JSON.stringify({
          generated: aGenerated,
          source: aSource,
          original: aOriginal,
          name: aName
        }));
      }
    };
    SourceMapGenerator.prototype._serializeMappings = function SourceMapGenerator_serializeMappings() {
      var previousGeneratedColumn = 0;
      var previousGeneratedLine = 1;
      var previousOriginalColumn = 0;
      var previousOriginalLine = 0;
      var previousName = 0;
      var previousSource = 0;
      var result = "";
      var next;
      var mapping;
      var nameIdx;
      var sourceIdx;
      var mappings = this._mappings.toArray();
      for (var i = 0, len = mappings.length; i < len; i++) {
        mapping = mappings[i];
        next = "";
        if (mapping.generatedLine !== previousGeneratedLine) {
          previousGeneratedColumn = 0;
          while (mapping.generatedLine !== previousGeneratedLine) {
            next += ";";
            previousGeneratedLine++;
          }
        } else {
          if (i > 0) {
            if (!util.compareByGeneratedPositionsInflated(mapping, mappings[i - 1])) {
              continue;
            }
            next += ",";
          }
        }
        next += base64VLQ.encode(mapping.generatedColumn - previousGeneratedColumn);
        previousGeneratedColumn = mapping.generatedColumn;
        if (mapping.source != null) {
          sourceIdx = this._sources.indexOf(mapping.source);
          next += base64VLQ.encode(sourceIdx - previousSource);
          previousSource = sourceIdx;
          next += base64VLQ.encode(mapping.originalLine - 1 - previousOriginalLine);
          previousOriginalLine = mapping.originalLine - 1;
          next += base64VLQ.encode(mapping.originalColumn - previousOriginalColumn);
          previousOriginalColumn = mapping.originalColumn;
          if (mapping.name != null) {
            nameIdx = this._names.indexOf(mapping.name);
            next += base64VLQ.encode(nameIdx - previousName);
            previousName = nameIdx;
          }
        }
        result += next;
      }
      return result;
    };
    SourceMapGenerator.prototype._generateSourcesContent = function SourceMapGenerator_generateSourcesContent(aSources, aSourceRoot) {
      return aSources.map(function(source) {
        if (!this._sourcesContents) {
          return null;
        }
        if (aSourceRoot != null) {
          source = util.relative(aSourceRoot, source);
        }
        var key = util.toSetString(source);
        return Object.prototype.hasOwnProperty.call(this._sourcesContents, key) ? this._sourcesContents[key] : null;
      }, this);
    };
    SourceMapGenerator.prototype.toJSON = function SourceMapGenerator_toJSON() {
      var map = {
        version: this._version,
        sources: this._sources.toArray(),
        names: this._names.toArray(),
        mappings: this._serializeMappings()
      };
      if (this._file != null) {
        map.file = this._file;
      }
      if (this._sourceRoot != null) {
        map.sourceRoot = this._sourceRoot;
      }
      if (this._sourcesContents) {
        map.sourcesContent = this._generateSourcesContent(map.sources, map.sourceRoot);
      }
      return map;
    };
    SourceMapGenerator.prototype.toString = function SourceMapGenerator_toString() {
      return JSON.stringify(this.toJSON());
    };
    exports.SourceMapGenerator = SourceMapGenerator;
  }
});

// node_modules/source-map/lib/binary-search.js
var require_binary_search = __commonJS({
  "node_modules/source-map/lib/binary-search.js"(exports) {
    exports.GREATEST_LOWER_BOUND = 1;
    exports.LEAST_UPPER_BOUND = 2;
    function recursiveSearch(aLow, aHigh, aNeedle, aHaystack, aCompare, aBias) {
      var mid = Math.floor((aHigh - aLow) / 2) + aLow;
      var cmp = aCompare(aNeedle, aHaystack[mid], true);
      if (cmp === 0) {
        return mid;
      } else if (cmp > 0) {
        if (aHigh - mid > 1) {
          return recursiveSearch(mid, aHigh, aNeedle, aHaystack, aCompare, aBias);
        }
        if (aBias == exports.LEAST_UPPER_BOUND) {
          return aHigh < aHaystack.length ? aHigh : -1;
        } else {
          return mid;
        }
      } else {
        if (mid - aLow > 1) {
          return recursiveSearch(aLow, mid, aNeedle, aHaystack, aCompare, aBias);
        }
        if (aBias == exports.LEAST_UPPER_BOUND) {
          return mid;
        } else {
          return aLow < 0 ? -1 : aLow;
        }
      }
    }
    exports.search = function search(aNeedle, aHaystack, aCompare, aBias) {
      if (aHaystack.length === 0) {
        return -1;
      }
      var index = recursiveSearch(-1, aHaystack.length, aNeedle, aHaystack, aCompare, aBias || exports.GREATEST_LOWER_BOUND);
      if (index < 0) {
        return -1;
      }
      while (index - 1 >= 0) {
        if (aCompare(aHaystack[index], aHaystack[index - 1], true) !== 0) {
          break;
        }
        --index;
      }
      return index;
    };
  }
});

// node_modules/source-map/lib/quick-sort.js
var require_quick_sort = __commonJS({
  "node_modules/source-map/lib/quick-sort.js"(exports) {
    function swap(ary, x, y) {
      var temp = ary[x];
      ary[x] = ary[y];
      ary[y] = temp;
    }
    function randomIntInRange(low, high) {
      return Math.round(low + Math.random() * (high - low));
    }
    function doQuickSort(ary, comparator, p, r) {
      if (p < r) {
        var pivotIndex = randomIntInRange(p, r);
        var i = p - 1;
        swap(ary, pivotIndex, r);
        var pivot = ary[r];
        for (var j = p; j < r; j++) {
          if (comparator(ary[j], pivot) <= 0) {
            i += 1;
            swap(ary, i, j);
          }
        }
        swap(ary, i + 1, j);
        var q = i + 1;
        doQuickSort(ary, comparator, p, q - 1);
        doQuickSort(ary, comparator, q + 1, r);
      }
    }
    exports.quickSort = function(ary, comparator) {
      doQuickSort(ary, comparator, 0, ary.length - 1);
    };
  }
});

// node_modules/source-map/lib/source-map-consumer.js
var require_source_map_consumer = __commonJS({
  "node_modules/source-map/lib/source-map-consumer.js"(exports) {
    var util = require_util2();
    var binarySearch = require_binary_search();
    var ArraySet = require_array_set().ArraySet;
    var base64VLQ = require_base64_vlq();
    var quickSort = require_quick_sort().quickSort;
    function SourceMapConsumer(aSourceMap, aSourceMapURL) {
      var sourceMap = aSourceMap;
      if (typeof aSourceMap === "string") {
        sourceMap = util.parseSourceMapInput(aSourceMap);
      }
      return sourceMap.sections != null ? new IndexedSourceMapConsumer(sourceMap, aSourceMapURL) : new BasicSourceMapConsumer(sourceMap, aSourceMapURL);
    }
    SourceMapConsumer.fromSourceMap = function(aSourceMap, aSourceMapURL) {
      return BasicSourceMapConsumer.fromSourceMap(aSourceMap, aSourceMapURL);
    };
    SourceMapConsumer.prototype._version = 3;
    SourceMapConsumer.prototype.__generatedMappings = null;
    Object.defineProperty(SourceMapConsumer.prototype, "_generatedMappings", {
      configurable: true,
      enumerable: true,
      get: function() {
        if (!this.__generatedMappings) {
          this._parseMappings(this._mappings, this.sourceRoot);
        }
        return this.__generatedMappings;
      }
    });
    SourceMapConsumer.prototype.__originalMappings = null;
    Object.defineProperty(SourceMapConsumer.prototype, "_originalMappings", {
      configurable: true,
      enumerable: true,
      get: function() {
        if (!this.__originalMappings) {
          this._parseMappings(this._mappings, this.sourceRoot);
        }
        return this.__originalMappings;
      }
    });
    SourceMapConsumer.prototype._charIsMappingSeparator = function SourceMapConsumer_charIsMappingSeparator(aStr, index) {
      var c = aStr.charAt(index);
      return c === ";" || c === ",";
    };
    SourceMapConsumer.prototype._parseMappings = function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
      throw new Error("Subclasses must implement _parseMappings");
    };
    SourceMapConsumer.GENERATED_ORDER = 1;
    SourceMapConsumer.ORIGINAL_ORDER = 2;
    SourceMapConsumer.GREATEST_LOWER_BOUND = 1;
    SourceMapConsumer.LEAST_UPPER_BOUND = 2;
    SourceMapConsumer.prototype.eachMapping = function SourceMapConsumer_eachMapping(aCallback, aContext, aOrder) {
      var context = aContext || null;
      var order = aOrder || SourceMapConsumer.GENERATED_ORDER;
      var mappings;
      switch (order) {
        case SourceMapConsumer.GENERATED_ORDER:
          mappings = this._generatedMappings;
          break;
        case SourceMapConsumer.ORIGINAL_ORDER:
          mappings = this._originalMappings;
          break;
        default:
          throw new Error("Unknown order of iteration.");
      }
      var sourceRoot = this.sourceRoot;
      mappings.map(function(mapping) {
        var source = mapping.source === null ? null : this._sources.at(mapping.source);
        source = util.computeSourceURL(sourceRoot, source, this._sourceMapURL);
        return {
          source,
          generatedLine: mapping.generatedLine,
          generatedColumn: mapping.generatedColumn,
          originalLine: mapping.originalLine,
          originalColumn: mapping.originalColumn,
          name: mapping.name === null ? null : this._names.at(mapping.name)
        };
      }, this).forEach(aCallback, context);
    };
    SourceMapConsumer.prototype.allGeneratedPositionsFor = function SourceMapConsumer_allGeneratedPositionsFor(aArgs) {
      var line = util.getArg(aArgs, "line");
      var needle = {
        source: util.getArg(aArgs, "source"),
        originalLine: line,
        originalColumn: util.getArg(aArgs, "column", 0)
      };
      needle.source = this._findSourceIndex(needle.source);
      if (needle.source < 0) {
        return [];
      }
      var mappings = [];
      var index = this._findMapping(needle, this._originalMappings, "originalLine", "originalColumn", util.compareByOriginalPositions, binarySearch.LEAST_UPPER_BOUND);
      if (index >= 0) {
        var mapping = this._originalMappings[index];
        if (aArgs.column === void 0) {
          var originalLine = mapping.originalLine;
          while (mapping && mapping.originalLine === originalLine) {
            mappings.push({
              line: util.getArg(mapping, "generatedLine", null),
              column: util.getArg(mapping, "generatedColumn", null),
              lastColumn: util.getArg(mapping, "lastGeneratedColumn", null)
            });
            mapping = this._originalMappings[++index];
          }
        } else {
          var originalColumn = mapping.originalColumn;
          while (mapping && mapping.originalLine === line && mapping.originalColumn == originalColumn) {
            mappings.push({
              line: util.getArg(mapping, "generatedLine", null),
              column: util.getArg(mapping, "generatedColumn", null),
              lastColumn: util.getArg(mapping, "lastGeneratedColumn", null)
            });
            mapping = this._originalMappings[++index];
          }
        }
      }
      return mappings;
    };
    exports.SourceMapConsumer = SourceMapConsumer;
    function BasicSourceMapConsumer(aSourceMap, aSourceMapURL) {
      var sourceMap = aSourceMap;
      if (typeof aSourceMap === "string") {
        sourceMap = util.parseSourceMapInput(aSourceMap);
      }
      var version = util.getArg(sourceMap, "version");
      var sources = util.getArg(sourceMap, "sources");
      var names = util.getArg(sourceMap, "names", []);
      var sourceRoot = util.getArg(sourceMap, "sourceRoot", null);
      var sourcesContent = util.getArg(sourceMap, "sourcesContent", null);
      var mappings = util.getArg(sourceMap, "mappings");
      var file = util.getArg(sourceMap, "file", null);
      if (version != this._version) {
        throw new Error("Unsupported version: " + version);
      }
      if (sourceRoot) {
        sourceRoot = util.normalize(sourceRoot);
      }
      sources = sources.map(String).map(util.normalize).map(function(source) {
        return sourceRoot && util.isAbsolute(sourceRoot) && util.isAbsolute(source) ? util.relative(sourceRoot, source) : source;
      });
      this._names = ArraySet.fromArray(names.map(String), true);
      this._sources = ArraySet.fromArray(sources, true);
      this._absoluteSources = this._sources.toArray().map(function(s) {
        return util.computeSourceURL(sourceRoot, s, aSourceMapURL);
      });
      this.sourceRoot = sourceRoot;
      this.sourcesContent = sourcesContent;
      this._mappings = mappings;
      this._sourceMapURL = aSourceMapURL;
      this.file = file;
    }
    BasicSourceMapConsumer.prototype = Object.create(SourceMapConsumer.prototype);
    BasicSourceMapConsumer.prototype.consumer = SourceMapConsumer;
    BasicSourceMapConsumer.prototype._findSourceIndex = function(aSource) {
      var relativeSource = aSource;
      if (this.sourceRoot != null) {
        relativeSource = util.relative(this.sourceRoot, relativeSource);
      }
      if (this._sources.has(relativeSource)) {
        return this._sources.indexOf(relativeSource);
      }
      var i;
      for (i = 0; i < this._absoluteSources.length; ++i) {
        if (this._absoluteSources[i] == aSource) {
          return i;
        }
      }
      return -1;
    };
    BasicSourceMapConsumer.fromSourceMap = function SourceMapConsumer_fromSourceMap(aSourceMap, aSourceMapURL) {
      var smc = Object.create(BasicSourceMapConsumer.prototype);
      var names = smc._names = ArraySet.fromArray(aSourceMap._names.toArray(), true);
      var sources = smc._sources = ArraySet.fromArray(aSourceMap._sources.toArray(), true);
      smc.sourceRoot = aSourceMap._sourceRoot;
      smc.sourcesContent = aSourceMap._generateSourcesContent(smc._sources.toArray(), smc.sourceRoot);
      smc.file = aSourceMap._file;
      smc._sourceMapURL = aSourceMapURL;
      smc._absoluteSources = smc._sources.toArray().map(function(s) {
        return util.computeSourceURL(smc.sourceRoot, s, aSourceMapURL);
      });
      var generatedMappings = aSourceMap._mappings.toArray().slice();
      var destGeneratedMappings = smc.__generatedMappings = [];
      var destOriginalMappings = smc.__originalMappings = [];
      for (var i = 0, length = generatedMappings.length; i < length; i++) {
        var srcMapping = generatedMappings[i];
        var destMapping = new Mapping();
        destMapping.generatedLine = srcMapping.generatedLine;
        destMapping.generatedColumn = srcMapping.generatedColumn;
        if (srcMapping.source) {
          destMapping.source = sources.indexOf(srcMapping.source);
          destMapping.originalLine = srcMapping.originalLine;
          destMapping.originalColumn = srcMapping.originalColumn;
          if (srcMapping.name) {
            destMapping.name = names.indexOf(srcMapping.name);
          }
          destOriginalMappings.push(destMapping);
        }
        destGeneratedMappings.push(destMapping);
      }
      quickSort(smc.__originalMappings, util.compareByOriginalPositions);
      return smc;
    };
    BasicSourceMapConsumer.prototype._version = 3;
    Object.defineProperty(BasicSourceMapConsumer.prototype, "sources", {
      get: function() {
        return this._absoluteSources.slice();
      }
    });
    function Mapping() {
      this.generatedLine = 0;
      this.generatedColumn = 0;
      this.source = null;
      this.originalLine = null;
      this.originalColumn = null;
      this.name = null;
    }
    BasicSourceMapConsumer.prototype._parseMappings = function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
      var generatedLine = 1;
      var previousGeneratedColumn = 0;
      var previousOriginalLine = 0;
      var previousOriginalColumn = 0;
      var previousSource = 0;
      var previousName = 0;
      var length = aStr.length;
      var index = 0;
      var cachedSegments = {};
      var temp = {};
      var originalMappings = [];
      var generatedMappings = [];
      var mapping, str, segment, end, value;
      while (index < length) {
        if (aStr.charAt(index) === ";") {
          generatedLine++;
          index++;
          previousGeneratedColumn = 0;
        } else if (aStr.charAt(index) === ",") {
          index++;
        } else {
          mapping = new Mapping();
          mapping.generatedLine = generatedLine;
          for (end = index; end < length; end++) {
            if (this._charIsMappingSeparator(aStr, end)) {
              break;
            }
          }
          str = aStr.slice(index, end);
          segment = cachedSegments[str];
          if (segment) {
            index += str.length;
          } else {
            segment = [];
            while (index < end) {
              base64VLQ.decode(aStr, index, temp);
              value = temp.value;
              index = temp.rest;
              segment.push(value);
            }
            if (segment.length === 2) {
              throw new Error("Found a source, but no line and column");
            }
            if (segment.length === 3) {
              throw new Error("Found a source and line, but no column");
            }
            cachedSegments[str] = segment;
          }
          mapping.generatedColumn = previousGeneratedColumn + segment[0];
          previousGeneratedColumn = mapping.generatedColumn;
          if (segment.length > 1) {
            mapping.source = previousSource + segment[1];
            previousSource += segment[1];
            mapping.originalLine = previousOriginalLine + segment[2];
            previousOriginalLine = mapping.originalLine;
            mapping.originalLine += 1;
            mapping.originalColumn = previousOriginalColumn + segment[3];
            previousOriginalColumn = mapping.originalColumn;
            if (segment.length > 4) {
              mapping.name = previousName + segment[4];
              previousName += segment[4];
            }
          }
          generatedMappings.push(mapping);
          if (typeof mapping.originalLine === "number") {
            originalMappings.push(mapping);
          }
        }
      }
      quickSort(generatedMappings, util.compareByGeneratedPositionsDeflated);
      this.__generatedMappings = generatedMappings;
      quickSort(originalMappings, util.compareByOriginalPositions);
      this.__originalMappings = originalMappings;
    };
    BasicSourceMapConsumer.prototype._findMapping = function SourceMapConsumer_findMapping(aNeedle, aMappings, aLineName, aColumnName, aComparator, aBias) {
      if (aNeedle[aLineName] <= 0) {
        throw new TypeError("Line must be greater than or equal to 1, got " + aNeedle[aLineName]);
      }
      if (aNeedle[aColumnName] < 0) {
        throw new TypeError("Column must be greater than or equal to 0, got " + aNeedle[aColumnName]);
      }
      return binarySearch.search(aNeedle, aMappings, aComparator, aBias);
    };
    BasicSourceMapConsumer.prototype.computeColumnSpans = function SourceMapConsumer_computeColumnSpans() {
      for (var index = 0; index < this._generatedMappings.length; ++index) {
        var mapping = this._generatedMappings[index];
        if (index + 1 < this._generatedMappings.length) {
          var nextMapping = this._generatedMappings[index + 1];
          if (mapping.generatedLine === nextMapping.generatedLine) {
            mapping.lastGeneratedColumn = nextMapping.generatedColumn - 1;
            continue;
          }
        }
        mapping.lastGeneratedColumn = Infinity;
      }
    };
    BasicSourceMapConsumer.prototype.originalPositionFor = function SourceMapConsumer_originalPositionFor(aArgs) {
      var needle = {
        generatedLine: util.getArg(aArgs, "line"),
        generatedColumn: util.getArg(aArgs, "column")
      };
      var index = this._findMapping(needle, this._generatedMappings, "generatedLine", "generatedColumn", util.compareByGeneratedPositionsDeflated, util.getArg(aArgs, "bias", SourceMapConsumer.GREATEST_LOWER_BOUND));
      if (index >= 0) {
        var mapping = this._generatedMappings[index];
        if (mapping.generatedLine === needle.generatedLine) {
          var source = util.getArg(mapping, "source", null);
          if (source !== null) {
            source = this._sources.at(source);
            source = util.computeSourceURL(this.sourceRoot, source, this._sourceMapURL);
          }
          var name = util.getArg(mapping, "name", null);
          if (name !== null) {
            name = this._names.at(name);
          }
          return {
            source,
            line: util.getArg(mapping, "originalLine", null),
            column: util.getArg(mapping, "originalColumn", null),
            name
          };
        }
      }
      return {
        source: null,
        line: null,
        column: null,
        name: null
      };
    };
    BasicSourceMapConsumer.prototype.hasContentsOfAllSources = function BasicSourceMapConsumer_hasContentsOfAllSources() {
      if (!this.sourcesContent) {
        return false;
      }
      return this.sourcesContent.length >= this._sources.size() && !this.sourcesContent.some(function(sc) {
        return sc == null;
      });
    };
    BasicSourceMapConsumer.prototype.sourceContentFor = function SourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
      if (!this.sourcesContent) {
        return null;
      }
      var index = this._findSourceIndex(aSource);
      if (index >= 0) {
        return this.sourcesContent[index];
      }
      var relativeSource = aSource;
      if (this.sourceRoot != null) {
        relativeSource = util.relative(this.sourceRoot, relativeSource);
      }
      var url;
      if (this.sourceRoot != null && (url = util.urlParse(this.sourceRoot))) {
        var fileUriAbsPath = relativeSource.replace(/^file:\/\//, "");
        if (url.scheme == "file" && this._sources.has(fileUriAbsPath)) {
          return this.sourcesContent[this._sources.indexOf(fileUriAbsPath)];
        }
        if ((!url.path || url.path == "/") && this._sources.has("/" + relativeSource)) {
          return this.sourcesContent[this._sources.indexOf("/" + relativeSource)];
        }
      }
      if (nullOnMissing) {
        return null;
      } else {
        throw new Error('"' + relativeSource + '" is not in the SourceMap.');
      }
    };
    BasicSourceMapConsumer.prototype.generatedPositionFor = function SourceMapConsumer_generatedPositionFor(aArgs) {
      var source = util.getArg(aArgs, "source");
      source = this._findSourceIndex(source);
      if (source < 0) {
        return {
          line: null,
          column: null,
          lastColumn: null
        };
      }
      var needle = {
        source,
        originalLine: util.getArg(aArgs, "line"),
        originalColumn: util.getArg(aArgs, "column")
      };
      var index = this._findMapping(needle, this._originalMappings, "originalLine", "originalColumn", util.compareByOriginalPositions, util.getArg(aArgs, "bias", SourceMapConsumer.GREATEST_LOWER_BOUND));
      if (index >= 0) {
        var mapping = this._originalMappings[index];
        if (mapping.source === needle.source) {
          return {
            line: util.getArg(mapping, "generatedLine", null),
            column: util.getArg(mapping, "generatedColumn", null),
            lastColumn: util.getArg(mapping, "lastGeneratedColumn", null)
          };
        }
      }
      return {
        line: null,
        column: null,
        lastColumn: null
      };
    };
    exports.BasicSourceMapConsumer = BasicSourceMapConsumer;
    function IndexedSourceMapConsumer(aSourceMap, aSourceMapURL) {
      var sourceMap = aSourceMap;
      if (typeof aSourceMap === "string") {
        sourceMap = util.parseSourceMapInput(aSourceMap);
      }
      var version = util.getArg(sourceMap, "version");
      var sections = util.getArg(sourceMap, "sections");
      if (version != this._version) {
        throw new Error("Unsupported version: " + version);
      }
      this._sources = new ArraySet();
      this._names = new ArraySet();
      var lastOffset = {
        line: -1,
        column: 0
      };
      this._sections = sections.map(function(s) {
        if (s.url) {
          throw new Error("Support for url field in sections not implemented.");
        }
        var offset = util.getArg(s, "offset");
        var offsetLine = util.getArg(offset, "line");
        var offsetColumn = util.getArg(offset, "column");
        if (offsetLine < lastOffset.line || offsetLine === lastOffset.line && offsetColumn < lastOffset.column) {
          throw new Error("Section offsets must be ordered and non-overlapping.");
        }
        lastOffset = offset;
        return {
          generatedOffset: {
            generatedLine: offsetLine + 1,
            generatedColumn: offsetColumn + 1
          },
          consumer: new SourceMapConsumer(util.getArg(s, "map"), aSourceMapURL)
        };
      });
    }
    IndexedSourceMapConsumer.prototype = Object.create(SourceMapConsumer.prototype);
    IndexedSourceMapConsumer.prototype.constructor = SourceMapConsumer;
    IndexedSourceMapConsumer.prototype._version = 3;
    Object.defineProperty(IndexedSourceMapConsumer.prototype, "sources", {
      get: function() {
        var sources = [];
        for (var i = 0; i < this._sections.length; i++) {
          for (var j = 0; j < this._sections[i].consumer.sources.length; j++) {
            sources.push(this._sections[i].consumer.sources[j]);
          }
        }
        return sources;
      }
    });
    IndexedSourceMapConsumer.prototype.originalPositionFor = function IndexedSourceMapConsumer_originalPositionFor(aArgs) {
      var needle = {
        generatedLine: util.getArg(aArgs, "line"),
        generatedColumn: util.getArg(aArgs, "column")
      };
      var sectionIndex = binarySearch.search(needle, this._sections, function(needle2, section2) {
        var cmp = needle2.generatedLine - section2.generatedOffset.generatedLine;
        if (cmp) {
          return cmp;
        }
        return needle2.generatedColumn - section2.generatedOffset.generatedColumn;
      });
      var section = this._sections[sectionIndex];
      if (!section) {
        return {
          source: null,
          line: null,
          column: null,
          name: null
        };
      }
      return section.consumer.originalPositionFor({
        line: needle.generatedLine - (section.generatedOffset.generatedLine - 1),
        column: needle.generatedColumn - (section.generatedOffset.generatedLine === needle.generatedLine ? section.generatedOffset.generatedColumn - 1 : 0),
        bias: aArgs.bias
      });
    };
    IndexedSourceMapConsumer.prototype.hasContentsOfAllSources = function IndexedSourceMapConsumer_hasContentsOfAllSources() {
      return this._sections.every(function(s) {
        return s.consumer.hasContentsOfAllSources();
      });
    };
    IndexedSourceMapConsumer.prototype.sourceContentFor = function IndexedSourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
      for (var i = 0; i < this._sections.length; i++) {
        var section = this._sections[i];
        var content = section.consumer.sourceContentFor(aSource, true);
        if (content) {
          return content;
        }
      }
      if (nullOnMissing) {
        return null;
      } else {
        throw new Error('"' + aSource + '" is not in the SourceMap.');
      }
    };
    IndexedSourceMapConsumer.prototype.generatedPositionFor = function IndexedSourceMapConsumer_generatedPositionFor(aArgs) {
      for (var i = 0; i < this._sections.length; i++) {
        var section = this._sections[i];
        if (section.consumer._findSourceIndex(util.getArg(aArgs, "source")) === -1) {
          continue;
        }
        var generatedPosition = section.consumer.generatedPositionFor(aArgs);
        if (generatedPosition) {
          var ret = {
            line: generatedPosition.line + (section.generatedOffset.generatedLine - 1),
            column: generatedPosition.column + (section.generatedOffset.generatedLine === generatedPosition.line ? section.generatedOffset.generatedColumn - 1 : 0)
          };
          return ret;
        }
      }
      return {
        line: null,
        column: null
      };
    };
    IndexedSourceMapConsumer.prototype._parseMappings = function IndexedSourceMapConsumer_parseMappings(aStr, aSourceRoot) {
      this.__generatedMappings = [];
      this.__originalMappings = [];
      for (var i = 0; i < this._sections.length; i++) {
        var section = this._sections[i];
        var sectionMappings = section.consumer._generatedMappings;
        for (var j = 0; j < sectionMappings.length; j++) {
          var mapping = sectionMappings[j];
          var source = section.consumer._sources.at(mapping.source);
          source = util.computeSourceURL(section.consumer.sourceRoot, source, this._sourceMapURL);
          this._sources.add(source);
          source = this._sources.indexOf(source);
          var name = null;
          if (mapping.name) {
            name = section.consumer._names.at(mapping.name);
            this._names.add(name);
            name = this._names.indexOf(name);
          }
          var adjustedMapping = {
            source,
            generatedLine: mapping.generatedLine + (section.generatedOffset.generatedLine - 1),
            generatedColumn: mapping.generatedColumn + (section.generatedOffset.generatedLine === mapping.generatedLine ? section.generatedOffset.generatedColumn - 1 : 0),
            originalLine: mapping.originalLine,
            originalColumn: mapping.originalColumn,
            name
          };
          this.__generatedMappings.push(adjustedMapping);
          if (typeof adjustedMapping.originalLine === "number") {
            this.__originalMappings.push(adjustedMapping);
          }
        }
      }
      quickSort(this.__generatedMappings, util.compareByGeneratedPositionsDeflated);
      quickSort(this.__originalMappings, util.compareByOriginalPositions);
    };
    exports.IndexedSourceMapConsumer = IndexedSourceMapConsumer;
  }
});

// node_modules/source-map/lib/source-node.js
var require_source_node = __commonJS({
  "node_modules/source-map/lib/source-node.js"(exports) {
    var SourceMapGenerator = require_source_map_generator().SourceMapGenerator;
    var util = require_util2();
    var REGEX_NEWLINE = /(\r?\n)/;
    var NEWLINE_CODE = 10;
    var isSourceNode = "$$$isSourceNode$$$";
    function SourceNode(aLine, aColumn, aSource, aChunks, aName) {
      this.children = [];
      this.sourceContents = {};
      this.line = aLine == null ? null : aLine;
      this.column = aColumn == null ? null : aColumn;
      this.source = aSource == null ? null : aSource;
      this.name = aName == null ? null : aName;
      this[isSourceNode] = true;
      if (aChunks != null)
        this.add(aChunks);
    }
    SourceNode.fromStringWithSourceMap = function SourceNode_fromStringWithSourceMap(aGeneratedCode, aSourceMapConsumer, aRelativePath) {
      var node = new SourceNode();
      var remainingLines = aGeneratedCode.split(REGEX_NEWLINE);
      var remainingLinesIndex = 0;
      var shiftNextLine = function() {
        var lineContents = getNextLine();
        var newLine = getNextLine() || "";
        return lineContents + newLine;
        function getNextLine() {
          return remainingLinesIndex < remainingLines.length ? remainingLines[remainingLinesIndex++] : void 0;
        }
      };
      var lastGeneratedLine = 1, lastGeneratedColumn = 0;
      var lastMapping = null;
      aSourceMapConsumer.eachMapping(function(mapping) {
        if (lastMapping !== null) {
          if (lastGeneratedLine < mapping.generatedLine) {
            addMappingWithCode(lastMapping, shiftNextLine());
            lastGeneratedLine++;
            lastGeneratedColumn = 0;
          } else {
            var nextLine = remainingLines[remainingLinesIndex] || "";
            var code = nextLine.substr(0, mapping.generatedColumn - lastGeneratedColumn);
            remainingLines[remainingLinesIndex] = nextLine.substr(mapping.generatedColumn - lastGeneratedColumn);
            lastGeneratedColumn = mapping.generatedColumn;
            addMappingWithCode(lastMapping, code);
            lastMapping = mapping;
            return;
          }
        }
        while (lastGeneratedLine < mapping.generatedLine) {
          node.add(shiftNextLine());
          lastGeneratedLine++;
        }
        if (lastGeneratedColumn < mapping.generatedColumn) {
          var nextLine = remainingLines[remainingLinesIndex] || "";
          node.add(nextLine.substr(0, mapping.generatedColumn));
          remainingLines[remainingLinesIndex] = nextLine.substr(mapping.generatedColumn);
          lastGeneratedColumn = mapping.generatedColumn;
        }
        lastMapping = mapping;
      }, this);
      if (remainingLinesIndex < remainingLines.length) {
        if (lastMapping) {
          addMappingWithCode(lastMapping, shiftNextLine());
        }
        node.add(remainingLines.splice(remainingLinesIndex).join(""));
      }
      aSourceMapConsumer.sources.forEach(function(sourceFile) {
        var content = aSourceMapConsumer.sourceContentFor(sourceFile);
        if (content != null) {
          if (aRelativePath != null) {
            sourceFile = util.join(aRelativePath, sourceFile);
          }
          node.setSourceContent(sourceFile, content);
        }
      });
      return node;
      function addMappingWithCode(mapping, code) {
        if (mapping === null || mapping.source === void 0) {
          node.add(code);
        } else {
          var source = aRelativePath ? util.join(aRelativePath, mapping.source) : mapping.source;
          node.add(new SourceNode(mapping.originalLine, mapping.originalColumn, source, code, mapping.name));
        }
      }
    };
    SourceNode.prototype.add = function SourceNode_add(aChunk) {
      if (Array.isArray(aChunk)) {
        aChunk.forEach(function(chunk) {
          this.add(chunk);
        }, this);
      } else if (aChunk[isSourceNode] || typeof aChunk === "string") {
        if (aChunk) {
          this.children.push(aChunk);
        }
      } else {
        throw new TypeError("Expected a SourceNode, string, or an array of SourceNodes and strings. Got " + aChunk);
      }
      return this;
    };
    SourceNode.prototype.prepend = function SourceNode_prepend(aChunk) {
      if (Array.isArray(aChunk)) {
        for (var i = aChunk.length - 1; i >= 0; i--) {
          this.prepend(aChunk[i]);
        }
      } else if (aChunk[isSourceNode] || typeof aChunk === "string") {
        this.children.unshift(aChunk);
      } else {
        throw new TypeError("Expected a SourceNode, string, or an array of SourceNodes and strings. Got " + aChunk);
      }
      return this;
    };
    SourceNode.prototype.walk = function SourceNode_walk(aFn) {
      var chunk;
      for (var i = 0, len = this.children.length; i < len; i++) {
        chunk = this.children[i];
        if (chunk[isSourceNode]) {
          chunk.walk(aFn);
        } else {
          if (chunk !== "") {
            aFn(chunk, {
              source: this.source,
              line: this.line,
              column: this.column,
              name: this.name
            });
          }
        }
      }
    };
    SourceNode.prototype.join = function SourceNode_join(aSep) {
      var newChildren;
      var i;
      var len = this.children.length;
      if (len > 0) {
        newChildren = [];
        for (i = 0; i < len - 1; i++) {
          newChildren.push(this.children[i]);
          newChildren.push(aSep);
        }
        newChildren.push(this.children[i]);
        this.children = newChildren;
      }
      return this;
    };
    SourceNode.prototype.replaceRight = function SourceNode_replaceRight(aPattern, aReplacement) {
      var lastChild = this.children[this.children.length - 1];
      if (lastChild[isSourceNode]) {
        lastChild.replaceRight(aPattern, aReplacement);
      } else if (typeof lastChild === "string") {
        this.children[this.children.length - 1] = lastChild.replace(aPattern, aReplacement);
      } else {
        this.children.push("".replace(aPattern, aReplacement));
      }
      return this;
    };
    SourceNode.prototype.setSourceContent = function SourceNode_setSourceContent(aSourceFile, aSourceContent) {
      this.sourceContents[util.toSetString(aSourceFile)] = aSourceContent;
    };
    SourceNode.prototype.walkSourceContents = function SourceNode_walkSourceContents(aFn) {
      for (var i = 0, len = this.children.length; i < len; i++) {
        if (this.children[i][isSourceNode]) {
          this.children[i].walkSourceContents(aFn);
        }
      }
      var sources = Object.keys(this.sourceContents);
      for (var i = 0, len = sources.length; i < len; i++) {
        aFn(util.fromSetString(sources[i]), this.sourceContents[sources[i]]);
      }
    };
    SourceNode.prototype.toString = function SourceNode_toString() {
      var str = "";
      this.walk(function(chunk) {
        str += chunk;
      });
      return str;
    };
    SourceNode.prototype.toStringWithSourceMap = function SourceNode_toStringWithSourceMap(aArgs) {
      var generated = {
        code: "",
        line: 1,
        column: 0
      };
      var map = new SourceMapGenerator(aArgs);
      var sourceMappingActive = false;
      var lastOriginalSource = null;
      var lastOriginalLine = null;
      var lastOriginalColumn = null;
      var lastOriginalName = null;
      this.walk(function(chunk, original) {
        generated.code += chunk;
        if (original.source !== null && original.line !== null && original.column !== null) {
          if (lastOriginalSource !== original.source || lastOriginalLine !== original.line || lastOriginalColumn !== original.column || lastOriginalName !== original.name) {
            map.addMapping({
              source: original.source,
              original: {
                line: original.line,
                column: original.column
              },
              generated: {
                line: generated.line,
                column: generated.column
              },
              name: original.name
            });
          }
          lastOriginalSource = original.source;
          lastOriginalLine = original.line;
          lastOriginalColumn = original.column;
          lastOriginalName = original.name;
          sourceMappingActive = true;
        } else if (sourceMappingActive) {
          map.addMapping({
            generated: {
              line: generated.line,
              column: generated.column
            }
          });
          lastOriginalSource = null;
          sourceMappingActive = false;
        }
        for (var idx = 0, length = chunk.length; idx < length; idx++) {
          if (chunk.charCodeAt(idx) === NEWLINE_CODE) {
            generated.line++;
            generated.column = 0;
            if (idx + 1 === length) {
              lastOriginalSource = null;
              sourceMappingActive = false;
            } else if (sourceMappingActive) {
              map.addMapping({
                source: original.source,
                original: {
                  line: original.line,
                  column: original.column
                },
                generated: {
                  line: generated.line,
                  column: generated.column
                },
                name: original.name
              });
            }
          } else {
            generated.column++;
          }
        }
      });
      this.walkSourceContents(function(sourceFile, sourceContent) {
        map.setSourceContent(sourceFile, sourceContent);
      });
      return { code: generated.code, map };
    };
    exports.SourceNode = SourceNode;
  }
});

// node_modules/source-map/source-map.js
var require_source_map = __commonJS({
  "node_modules/source-map/source-map.js"(exports) {
    exports.SourceMapGenerator = require_source_map_generator().SourceMapGenerator;
    exports.SourceMapConsumer = require_source_map_consumer().SourceMapConsumer;
    exports.SourceNode = require_source_node().SourceNode;
  }
});

// node_modules/buffer-from/index.js
var require_buffer_from = __commonJS({
  "node_modules/buffer-from/index.js"(exports, module2) {
    var toString = Object.prototype.toString;
    var isModern = typeof Buffer !== "undefined" && typeof Buffer.alloc === "function" && typeof Buffer.allocUnsafe === "function" && typeof Buffer.from === "function";
    function isArrayBuffer(input) {
      return toString.call(input).slice(8, -1) === "ArrayBuffer";
    }
    function fromArrayBuffer(obj, byteOffset, length) {
      byteOffset >>>= 0;
      var maxLength = obj.byteLength - byteOffset;
      if (maxLength < 0) {
        throw new RangeError("'offset' is out of bounds");
      }
      if (length === void 0) {
        length = maxLength;
      } else {
        length >>>= 0;
        if (length > maxLength) {
          throw new RangeError("'length' is out of bounds");
        }
      }
      return isModern ? Buffer.from(obj.slice(byteOffset, byteOffset + length)) : new Buffer(new Uint8Array(obj.slice(byteOffset, byteOffset + length)));
    }
    function fromString(string, encoding) {
      if (typeof encoding !== "string" || encoding === "") {
        encoding = "utf8";
      }
      if (!Buffer.isEncoding(encoding)) {
        throw new TypeError('"encoding" must be a valid string encoding');
      }
      return isModern ? Buffer.from(string, encoding) : new Buffer(string, encoding);
    }
    function bufferFrom(value, encodingOrOffset, length) {
      if (typeof value === "number") {
        throw new TypeError('"value" argument must not be a number');
      }
      if (isArrayBuffer(value)) {
        return fromArrayBuffer(value, encodingOrOffset, length);
      }
      if (typeof value === "string") {
        return fromString(value, encodingOrOffset);
      }
      return isModern ? Buffer.from(value) : new Buffer(value);
    }
    module2.exports = bufferFrom;
  }
});

// node_modules/source-map-support/source-map-support.js
var require_source_map_support = __commonJS({
  "node_modules/source-map-support/source-map-support.js"(exports, module2) {
    var SourceMapConsumer = require_source_map().SourceMapConsumer;
    var path2 = require("path");
    var fs2;
    try {
      fs2 = require("fs");
      if (!fs2.existsSync || !fs2.readFileSync) {
        fs2 = null;
      }
    } catch (err) {
    }
    var bufferFrom = require_buffer_from();
    function dynamicRequire(mod, request) {
      return mod.require(request);
    }
    var errorFormatterInstalled = false;
    var uncaughtShimInstalled = false;
    var emptyCacheBetweenOperations = false;
    var environment = "auto";
    var fileContentsCache = {};
    var sourceMapCache = {};
    var reSourceMap = /^data:application\/json[^,]+base64,/;
    var retrieveFileHandlers = [];
    var retrieveMapHandlers = [];
    function isInBrowser() {
      if (environment === "browser")
        return true;
      if (environment === "node")
        return false;
      return typeof window !== "undefined" && typeof XMLHttpRequest === "function" && !(window.require && window.module && window.process && window.process.type === "renderer");
    }
    function hasGlobalProcessEventEmitter() {
      return typeof process === "object" && process !== null && typeof process.on === "function";
    }
    function globalProcessVersion() {
      if (typeof process === "object" && process !== null) {
        return process.version;
      } else {
        return "";
      }
    }
    function globalProcessStderr() {
      if (typeof process === "object" && process !== null) {
        return process.stderr;
      }
    }
    function globalProcessExit(code) {
      if (typeof process === "object" && process !== null && typeof process.exit === "function") {
        return process.exit(code);
      }
    }
    function handlerExec(list) {
      return function(arg) {
        for (var i = 0; i < list.length; i++) {
          var ret = list[i](arg);
          if (ret) {
            return ret;
          }
        }
        return null;
      };
    }
    var retrieveFile = handlerExec(retrieveFileHandlers);
    retrieveFileHandlers.push(function(path3) {
      path3 = path3.trim();
      if (/^file:/.test(path3)) {
        path3 = path3.replace(/file:\/\/\/(\w:)?/, function(protocol, drive) {
          return drive ? "" : "/";
        });
      }
      if (path3 in fileContentsCache) {
        return fileContentsCache[path3];
      }
      var contents = "";
      try {
        if (!fs2) {
          var xhr = new XMLHttpRequest();
          xhr.open("GET", path3, false);
          xhr.send(null);
          if (xhr.readyState === 4 && xhr.status === 200) {
            contents = xhr.responseText;
          }
        } else if (fs2.existsSync(path3)) {
          contents = fs2.readFileSync(path3, "utf8");
        }
      } catch (er) {
      }
      return fileContentsCache[path3] = contents;
    });
    function supportRelativeURL(file, url) {
      if (!file)
        return url;
      var dir = path2.dirname(file);
      var match = /^\w+:\/\/[^\/]*/.exec(dir);
      var protocol = match ? match[0] : "";
      var startPath = dir.slice(protocol.length);
      if (protocol && /^\/\w\:/.test(startPath)) {
        protocol += "/";
        return protocol + path2.resolve(dir.slice(protocol.length), url).replace(/\\/g, "/");
      }
      return protocol + path2.resolve(dir.slice(protocol.length), url);
    }
    function retrieveSourceMapURL(source) {
      var fileData;
      if (isInBrowser()) {
        try {
          var xhr = new XMLHttpRequest();
          xhr.open("GET", source, false);
          xhr.send(null);
          fileData = xhr.readyState === 4 ? xhr.responseText : null;
          var sourceMapHeader = xhr.getResponseHeader("SourceMap") || xhr.getResponseHeader("X-SourceMap");
          if (sourceMapHeader) {
            return sourceMapHeader;
          }
        } catch (e) {
        }
      }
      fileData = retrieveFile(source);
      var re = /(?:\/\/[@#][\s]*sourceMappingURL=([^\s'"]+)[\s]*$)|(?:\/\*[@#][\s]*sourceMappingURL=([^\s*'"]+)[\s]*(?:\*\/)[\s]*$)/mg;
      var lastMatch, match;
      while (match = re.exec(fileData))
        lastMatch = match;
      if (!lastMatch)
        return null;
      return lastMatch[1];
    }
    var retrieveSourceMap = handlerExec(retrieveMapHandlers);
    retrieveMapHandlers.push(function(source) {
      var sourceMappingURL = retrieveSourceMapURL(source);
      if (!sourceMappingURL)
        return null;
      var sourceMapData;
      if (reSourceMap.test(sourceMappingURL)) {
        var rawData = sourceMappingURL.slice(sourceMappingURL.indexOf(",") + 1);
        sourceMapData = bufferFrom(rawData, "base64").toString();
        sourceMappingURL = source;
      } else {
        sourceMappingURL = supportRelativeURL(source, sourceMappingURL);
        sourceMapData = retrieveFile(sourceMappingURL);
      }
      if (!sourceMapData) {
        return null;
      }
      return {
        url: sourceMappingURL,
        map: sourceMapData
      };
    });
    function mapSourcePosition(position) {
      var sourceMap = sourceMapCache[position.source];
      if (!sourceMap) {
        var urlAndMap = retrieveSourceMap(position.source);
        if (urlAndMap) {
          sourceMap = sourceMapCache[position.source] = {
            url: urlAndMap.url,
            map: new SourceMapConsumer(urlAndMap.map)
          };
          if (sourceMap.map.sourcesContent) {
            sourceMap.map.sources.forEach(function(source, i) {
              var contents = sourceMap.map.sourcesContent[i];
              if (contents) {
                var url = supportRelativeURL(sourceMap.url, source);
                fileContentsCache[url] = contents;
              }
            });
          }
        } else {
          sourceMap = sourceMapCache[position.source] = {
            url: null,
            map: null
          };
        }
      }
      if (sourceMap && sourceMap.map && typeof sourceMap.map.originalPositionFor === "function") {
        var originalPosition = sourceMap.map.originalPositionFor(position);
        if (originalPosition.source !== null) {
          originalPosition.source = supportRelativeURL(sourceMap.url, originalPosition.source);
          return originalPosition;
        }
      }
      return position;
    }
    function mapEvalOrigin(origin) {
      var match = /^eval at ([^(]+) \((.+):(\d+):(\d+)\)$/.exec(origin);
      if (match) {
        var position = mapSourcePosition({
          source: match[2],
          line: +match[3],
          column: match[4] - 1
        });
        return "eval at " + match[1] + " (" + position.source + ":" + position.line + ":" + (position.column + 1) + ")";
      }
      match = /^eval at ([^(]+) \((.+)\)$/.exec(origin);
      if (match) {
        return "eval at " + match[1] + " (" + mapEvalOrigin(match[2]) + ")";
      }
      return origin;
    }
    function CallSiteToString() {
      var fileName;
      var fileLocation = "";
      if (this.isNative()) {
        fileLocation = "native";
      } else {
        fileName = this.getScriptNameOrSourceURL();
        if (!fileName && this.isEval()) {
          fileLocation = this.getEvalOrigin();
          fileLocation += ", ";
        }
        if (fileName) {
          fileLocation += fileName;
        } else {
          fileLocation += "<anonymous>";
        }
        var lineNumber = this.getLineNumber();
        if (lineNumber != null) {
          fileLocation += ":" + lineNumber;
          var columnNumber = this.getColumnNumber();
          if (columnNumber) {
            fileLocation += ":" + columnNumber;
          }
        }
      }
      var line = "";
      var functionName = this.getFunctionName();
      var addSuffix = true;
      var isConstructor = this.isConstructor();
      var isMethodCall = !(this.isToplevel() || isConstructor);
      if (isMethodCall) {
        var typeName = this.getTypeName();
        if (typeName === "[object Object]") {
          typeName = "null";
        }
        var methodName = this.getMethodName();
        if (functionName) {
          if (typeName && functionName.indexOf(typeName) != 0) {
            line += typeName + ".";
          }
          line += functionName;
          if (methodName && functionName.indexOf("." + methodName) != functionName.length - methodName.length - 1) {
            line += " [as " + methodName + "]";
          }
        } else {
          line += typeName + "." + (methodName || "<anonymous>");
        }
      } else if (isConstructor) {
        line += "new " + (functionName || "<anonymous>");
      } else if (functionName) {
        line += functionName;
      } else {
        line += fileLocation;
        addSuffix = false;
      }
      if (addSuffix) {
        line += " (" + fileLocation + ")";
      }
      return line;
    }
    function cloneCallSite(frame) {
      var object = {};
      Object.getOwnPropertyNames(Object.getPrototypeOf(frame)).forEach(function(name) {
        object[name] = /^(?:is|get)/.test(name) ? function() {
          return frame[name].call(frame);
        } : frame[name];
      });
      object.toString = CallSiteToString;
      return object;
    }
    function wrapCallSite(frame, state) {
      if (state === void 0) {
        state = { nextPosition: null, curPosition: null };
      }
      if (frame.isNative()) {
        state.curPosition = null;
        return frame;
      }
      var source = frame.getFileName() || frame.getScriptNameOrSourceURL();
      if (source) {
        var line = frame.getLineNumber();
        var column = frame.getColumnNumber() - 1;
        var noHeader = /^v(10\.1[6-9]|10\.[2-9][0-9]|10\.[0-9]{3,}|1[2-9]\d*|[2-9]\d|\d{3,}|11\.11)/;
        var headerLength = noHeader.test(globalProcessVersion()) ? 0 : 62;
        if (line === 1 && column > headerLength && !isInBrowser() && !frame.isEval()) {
          column -= headerLength;
        }
        var position = mapSourcePosition({
          source,
          line,
          column
        });
        state.curPosition = position;
        frame = cloneCallSite(frame);
        var originalFunctionName = frame.getFunctionName;
        frame.getFunctionName = function() {
          if (state.nextPosition == null) {
            return originalFunctionName();
          }
          return state.nextPosition.name || originalFunctionName();
        };
        frame.getFileName = function() {
          return position.source;
        };
        frame.getLineNumber = function() {
          return position.line;
        };
        frame.getColumnNumber = function() {
          return position.column + 1;
        };
        frame.getScriptNameOrSourceURL = function() {
          return position.source;
        };
        return frame;
      }
      var origin = frame.isEval() && frame.getEvalOrigin();
      if (origin) {
        origin = mapEvalOrigin(origin);
        frame = cloneCallSite(frame);
        frame.getEvalOrigin = function() {
          return origin;
        };
        return frame;
      }
      return frame;
    }
    function prepareStackTrace(error, stack) {
      if (emptyCacheBetweenOperations) {
        fileContentsCache = {};
        sourceMapCache = {};
      }
      var name = error.name || "Error";
      var message = error.message || "";
      var errorString = name + ": " + message;
      var state = { nextPosition: null, curPosition: null };
      var processedStack = [];
      for (var i = stack.length - 1; i >= 0; i--) {
        processedStack.push("\n    at " + wrapCallSite(stack[i], state));
        state.nextPosition = state.curPosition;
      }
      state.curPosition = state.nextPosition = null;
      return errorString + processedStack.reverse().join("");
    }
    function getErrorSource(error) {
      var match = /\n    at [^(]+ \((.*):(\d+):(\d+)\)/.exec(error.stack);
      if (match) {
        var source = match[1];
        var line = +match[2];
        var column = +match[3];
        var contents = fileContentsCache[source];
        if (!contents && fs2 && fs2.existsSync(source)) {
          try {
            contents = fs2.readFileSync(source, "utf8");
          } catch (er) {
            contents = "";
          }
        }
        if (contents) {
          var code = contents.split(/(?:\r\n|\r|\n)/)[line - 1];
          if (code) {
            return source + ":" + line + "\n" + code + "\n" + new Array(column).join(" ") + "^";
          }
        }
      }
      return null;
    }
    function printErrorAndExit(error) {
      var source = getErrorSource(error);
      var stderr = globalProcessStderr();
      if (stderr && stderr._handle && stderr._handle.setBlocking) {
        stderr._handle.setBlocking(true);
      }
      if (source) {
        console.error();
        console.error(source);
      }
      console.error(error.stack);
      globalProcessExit(1);
    }
    function shimEmitUncaughtException() {
      var origEmit = process.emit;
      process.emit = function(type) {
        if (type === "uncaughtException") {
          var hasStack = arguments[1] && arguments[1].stack;
          var hasListeners = this.listeners(type).length > 0;
          if (hasStack && !hasListeners) {
            return printErrorAndExit(arguments[1]);
          }
        }
        return origEmit.apply(this, arguments);
      };
    }
    var originalRetrieveFileHandlers = retrieveFileHandlers.slice(0);
    var originalRetrieveMapHandlers = retrieveMapHandlers.slice(0);
    exports.wrapCallSite = wrapCallSite;
    exports.getErrorSource = getErrorSource;
    exports.mapSourcePosition = mapSourcePosition;
    exports.retrieveSourceMap = retrieveSourceMap;
    exports.install = function(options) {
      options = options || {};
      if (options.environment) {
        environment = options.environment;
        if (["node", "browser", "auto"].indexOf(environment) === -1) {
          throw new Error("environment " + environment + " was unknown. Available options are {auto, browser, node}");
        }
      }
      if (options.retrieveFile) {
        if (options.overrideRetrieveFile) {
          retrieveFileHandlers.length = 0;
        }
        retrieveFileHandlers.unshift(options.retrieveFile);
      }
      if (options.retrieveSourceMap) {
        if (options.overrideRetrieveSourceMap) {
          retrieveMapHandlers.length = 0;
        }
        retrieveMapHandlers.unshift(options.retrieveSourceMap);
      }
      if (options.hookRequire && !isInBrowser()) {
        var Module = dynamicRequire(module2, "module");
        var $compile = Module.prototype._compile;
        if (!$compile.__sourceMapSupport) {
          Module.prototype._compile = function(content, filename) {
            fileContentsCache[filename] = content;
            sourceMapCache[filename] = void 0;
            return $compile.call(this, content, filename);
          };
          Module.prototype._compile.__sourceMapSupport = true;
        }
      }
      if (!emptyCacheBetweenOperations) {
        emptyCacheBetweenOperations = "emptyCacheBetweenOperations" in options ? options.emptyCacheBetweenOperations : false;
      }
      if (!errorFormatterInstalled) {
        errorFormatterInstalled = true;
        Error.prepareStackTrace = prepareStackTrace;
      }
      if (!uncaughtShimInstalled) {
        var installHandler = "handleUncaughtExceptions" in options ? options.handleUncaughtExceptions : true;
        try {
          var worker_threads = dynamicRequire(module2, "worker_threads");
          if (worker_threads.isMainThread === false) {
            installHandler = false;
          }
        } catch (e) {
        }
        if (installHandler && hasGlobalProcessEventEmitter()) {
          uncaughtShimInstalled = true;
          shimEmitUncaughtException();
        }
      }
    };
    exports.resetRetrieveHandlers = function() {
      retrieveFileHandlers.length = 0;
      retrieveMapHandlers.length = 0;
      retrieveFileHandlers = originalRetrieveFileHandlers.slice(0);
      retrieveMapHandlers = originalRetrieveMapHandlers.slice(0);
      retrieveSourceMap = handlerExec(retrieveMapHandlers);
      retrieveFile = handlerExec(retrieveFileHandlers);
    };
  }
});

// node_modules/jsii-rosetta/node_modules/typescript/lib/typescript.js
var require_typescript = __commonJS({
  "node_modules/jsii-rosetta/node_modules/typescript/lib/typescript.js"(exports, module2) {
    "use strict";
    var __spreadArrays = exports && exports.__spreadArrays || function() {
      for (var s = 0, i = 0, il = arguments.length; i < il; i++)
        s += arguments[i].length;
      for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
          r[k] = a[j];
      return r;
    };
    var __assign = exports && exports.__assign || function() {
      __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
          s = arguments[i];
          for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p))
              t[p] = s[p];
        }
        return t;
      };
      return __assign.apply(this, arguments);
    };
    var __generator = exports && exports.__generator || function(thisArg, body) {
      var _ = { label: 0, sent: function() {
        if (t[0] & 1)
          throw t[1];
        return t[1];
      }, trys: [], ops: [] }, f, y, t, g;
      return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
      }), g;
      function verb(n) {
        return function(v) {
          return step([n, v]);
        };
      }
      function step(op) {
        if (f)
          throw new TypeError("Generator is already executing.");
        while (_)
          try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
              return t;
            if (y = 0, t)
              op = [op[0] & 2, t.value];
            switch (op[0]) {
              case 0:
              case 1:
                t = op;
                break;
              case 4:
                _.label++;
                return { value: op[1], done: false };
              case 5:
                _.label++;
                y = op[1];
                op = [0];
                continue;
              case 7:
                op = _.ops.pop();
                _.trys.pop();
                continue;
              default:
                if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                  _ = 0;
                  continue;
                }
                if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                  _.label = op[1];
                  break;
                }
                if (op[0] === 6 && _.label < t[1]) {
                  _.label = t[1];
                  t = op;
                  break;
                }
                if (t && _.label < t[2]) {
                  _.label = t[2];
                  _.ops.push(op);
                  break;
                }
                if (t[2])
                  _.ops.pop();
                _.trys.pop();
                continue;
            }
            op = body.call(thisArg, _);
          } catch (e) {
            op = [6, e];
            y = 0;
          } finally {
            f = t = 0;
          }
        if (op[0] & 5)
          throw op[1];
        return { value: op[0] ? op[1] : void 0, done: true };
      }
    };
    var __makeTemplateObject = exports && exports.__makeTemplateObject || function(cooked, raw) {
      if (Object.defineProperty) {
        Object.defineProperty(cooked, "raw", { value: raw });
      } else {
        cooked.raw = raw;
      }
      return cooked;
    };
    var __rest = exports && exports.__rest || function(s, e) {
      var t = {};
      for (var p in s)
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
          t[p] = s[p];
      if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
          if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
            t[p[i]] = s[p[i]];
        }
      return t;
    };
    var __extends = exports && exports.__extends || function() {
      var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d2, b2) {
          d2.__proto__ = b2;
        } || function(d2, b2) {
          for (var p in b2)
            if (b2.hasOwnProperty(p))
              d2[p] = b2[p];
        };
        return extendStatics(d, b);
      };
      return function(d, b) {
        extendStatics(d, b);
        function __() {
          this.constructor = d;
        }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
      };
    }();
    var ts;
    (function(ts2) {
      function createMapShim() {
        function createDictionaryObject() {
          var map = Object.create(null);
          map.__ = void 0;
          delete map.__;
          return map;
        }
        var MapIterator = function() {
          function MapIterator2(currentEntry, selector) {
            this.currentEntry = currentEntry;
            this.selector = selector;
          }
          MapIterator2.prototype.next = function() {
            while (this.currentEntry) {
              var skipNext = !!this.currentEntry.skipNext;
              this.currentEntry = this.currentEntry.nextEntry;
              if (!skipNext) {
                break;
              }
            }
            if (this.currentEntry) {
              return { value: this.selector(this.currentEntry.key, this.currentEntry.value), done: false };
            } else {
              return { value: void 0, done: true };
            }
          };
          return MapIterator2;
        }();
        return function() {
          function class_1() {
            this.data = createDictionaryObject();
            this.size = 0;
            this.firstEntry = {};
            this.lastEntry = this.firstEntry;
          }
          class_1.prototype.get = function(key) {
            var entry = this.data[key];
            return entry && entry.value;
          };
          class_1.prototype.set = function(key, value) {
            if (!this.has(key)) {
              this.size++;
              var newEntry = {
                key,
                value
              };
              this.data[key] = newEntry;
              var previousLastEntry = this.lastEntry;
              previousLastEntry.nextEntry = newEntry;
              newEntry.previousEntry = previousLastEntry;
              this.lastEntry = newEntry;
            } else {
              this.data[key].value = value;
            }
            return this;
          };
          class_1.prototype.has = function(key) {
            return key in this.data;
          };
          class_1.prototype.delete = function(key) {
            if (this.has(key)) {
              this.size--;
              var entry = this.data[key];
              delete this.data[key];
              var previousEntry = entry.previousEntry;
              previousEntry.nextEntry = entry.nextEntry;
              if (entry.nextEntry) {
                entry.nextEntry.previousEntry = previousEntry;
              }
              if (this.lastEntry === entry) {
                this.lastEntry = previousEntry;
              }
              entry.previousEntry = void 0;
              entry.nextEntry = previousEntry;
              entry.skipNext = true;
              return true;
            }
            return false;
          };
          class_1.prototype.clear = function() {
            this.data = createDictionaryObject();
            this.size = 0;
            var firstEntry = this.firstEntry;
            var currentEntry = firstEntry.nextEntry;
            while (currentEntry) {
              var nextEntry = currentEntry.nextEntry;
              currentEntry.previousEntry = void 0;
              currentEntry.nextEntry = firstEntry;
              currentEntry.skipNext = true;
              currentEntry = nextEntry;
            }
            firstEntry.nextEntry = void 0;
            this.lastEntry = firstEntry;
          };
          class_1.prototype.keys = function() {
            return new MapIterator(this.firstEntry, function(key) {
              return key;
            });
          };
          class_1.prototype.values = function() {
            return new MapIterator(this.firstEntry, function(_key, value) {
              return value;
            });
          };
          class_1.prototype.entries = function() {
            return new MapIterator(this.firstEntry, function(key, value) {
              return [key, value];
            });
          };
          class_1.prototype.forEach = function(action) {
            var iterator = this.entries();
            while (true) {
              var iterResult = iterator.next();
              if (iterResult.done) {
                break;
              }
              var _a = iterResult.value, key = _a[0], value = _a[1];
              action(value, key);
            }
          };
          return class_1;
        }();
      }
      ts2.createMapShim = createMapShim;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      ts2.versionMajorMinor = "3.9";
      ts2.version = "3.9.10";
      function tryGetNativeMap() {
        return typeof Map !== "undefined" && "entries" in Map.prototype ? Map : void 0;
      }
      ts2.tryGetNativeMap = tryGetNativeMap;
      ts2.Map = tryGetNativeMap() || function() {
        if (typeof ts2.createMapShim === "function") {
          return ts2.createMapShim();
        }
        throw new Error("TypeScript requires an environment that provides a compatible native Map implementation.");
      }();
      var Comparison;
      (function(Comparison2) {
        Comparison2[Comparison2["LessThan"] = -1] = "LessThan";
        Comparison2[Comparison2["EqualTo"] = 0] = "EqualTo";
        Comparison2[Comparison2["GreaterThan"] = 1] = "GreaterThan";
      })(Comparison = ts2.Comparison || (ts2.Comparison = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      ts2.emptyArray = [];
      function createMap() {
        return new ts2.Map();
      }
      ts2.createMap = createMap;
      function createMapFromEntries(entries) {
        var map2 = createMap();
        for (var _i = 0, entries_1 = entries; _i < entries_1.length; _i++) {
          var _a = entries_1[_i], key = _a[0], value = _a[1];
          map2.set(key, value);
        }
        return map2;
      }
      ts2.createMapFromEntries = createMapFromEntries;
      function createMapFromTemplate(template) {
        var map2 = new ts2.Map();
        for (var key in template) {
          if (hasOwnProperty2.call(template, key)) {
            map2.set(key, template[key]);
          }
        }
        return map2;
      }
      ts2.createMapFromTemplate = createMapFromTemplate;
      function length(array) {
        return array ? array.length : 0;
      }
      ts2.length = length;
      function forEach(array, callback) {
        if (array) {
          for (var i = 0; i < array.length; i++) {
            var result = callback(array[i], i);
            if (result) {
              return result;
            }
          }
        }
        return void 0;
      }
      ts2.forEach = forEach;
      function forEachRight(array, callback) {
        if (array) {
          for (var i = array.length - 1; i >= 0; i--) {
            var result = callback(array[i], i);
            if (result) {
              return result;
            }
          }
        }
        return void 0;
      }
      ts2.forEachRight = forEachRight;
      function firstDefined(array, callback) {
        if (array === void 0) {
          return void 0;
        }
        for (var i = 0; i < array.length; i++) {
          var result = callback(array[i], i);
          if (result !== void 0) {
            return result;
          }
        }
        return void 0;
      }
      ts2.firstDefined = firstDefined;
      function firstDefinedIterator(iter, callback) {
        while (true) {
          var iterResult = iter.next();
          if (iterResult.done) {
            return void 0;
          }
          var result = callback(iterResult.value);
          if (result !== void 0) {
            return result;
          }
        }
      }
      ts2.firstDefinedIterator = firstDefinedIterator;
      function zipWith(arrayA, arrayB, callback) {
        var result = [];
        ts2.Debug.assertEqual(arrayA.length, arrayB.length);
        for (var i = 0; i < arrayA.length; i++) {
          result.push(callback(arrayA[i], arrayB[i], i));
        }
        return result;
      }
      ts2.zipWith = zipWith;
      function zipToIterator(arrayA, arrayB) {
        ts2.Debug.assertEqual(arrayA.length, arrayB.length);
        var i = 0;
        return {
          next: function() {
            if (i === arrayA.length) {
              return { value: void 0, done: true };
            }
            i++;
            return { value: [arrayA[i - 1], arrayB[i - 1]], done: false };
          }
        };
      }
      ts2.zipToIterator = zipToIterator;
      function zipToMap(keys, values) {
        ts2.Debug.assert(keys.length === values.length);
        var map2 = createMap();
        for (var i = 0; i < keys.length; ++i) {
          map2.set(keys[i], values[i]);
        }
        return map2;
      }
      ts2.zipToMap = zipToMap;
      function every(array, callback) {
        if (array) {
          for (var i = 0; i < array.length; i++) {
            if (!callback(array[i], i)) {
              return false;
            }
          }
        }
        return true;
      }
      ts2.every = every;
      function find(array, predicate) {
        for (var i = 0; i < array.length; i++) {
          var value = array[i];
          if (predicate(value, i)) {
            return value;
          }
        }
        return void 0;
      }
      ts2.find = find;
      function findLast(array, predicate) {
        for (var i = array.length - 1; i >= 0; i--) {
          var value = array[i];
          if (predicate(value, i)) {
            return value;
          }
        }
        return void 0;
      }
      ts2.findLast = findLast;
      function findIndex(array, predicate, startIndex) {
        for (var i = startIndex || 0; i < array.length; i++) {
          if (predicate(array[i], i)) {
            return i;
          }
        }
        return -1;
      }
      ts2.findIndex = findIndex;
      function findLastIndex(array, predicate, startIndex) {
        for (var i = startIndex === void 0 ? array.length - 1 : startIndex; i >= 0; i--) {
          if (predicate(array[i], i)) {
            return i;
          }
        }
        return -1;
      }
      ts2.findLastIndex = findLastIndex;
      function findMap(array, callback) {
        for (var i = 0; i < array.length; i++) {
          var result = callback(array[i], i);
          if (result) {
            return result;
          }
        }
        return ts2.Debug.fail();
      }
      ts2.findMap = findMap;
      function contains(array, value, equalityComparer) {
        if (equalityComparer === void 0) {
          equalityComparer = equateValues;
        }
        if (array) {
          for (var _i = 0, array_1 = array; _i < array_1.length; _i++) {
            var v = array_1[_i];
            if (equalityComparer(v, value)) {
              return true;
            }
          }
        }
        return false;
      }
      ts2.contains = contains;
      function arraysEqual(a, b, equalityComparer) {
        if (equalityComparer === void 0) {
          equalityComparer = equateValues;
        }
        return a.length === b.length && a.every(function(x, i) {
          return equalityComparer(x, b[i]);
        });
      }
      ts2.arraysEqual = arraysEqual;
      function indexOfAnyCharCode(text, charCodes, start) {
        for (var i = start || 0; i < text.length; i++) {
          if (contains(charCodes, text.charCodeAt(i))) {
            return i;
          }
        }
        return -1;
      }
      ts2.indexOfAnyCharCode = indexOfAnyCharCode;
      function countWhere(array, predicate) {
        var count = 0;
        if (array) {
          for (var i = 0; i < array.length; i++) {
            var v = array[i];
            if (predicate(v, i)) {
              count++;
            }
          }
        }
        return count;
      }
      ts2.countWhere = countWhere;
      function filter(array, f) {
        if (array) {
          var len = array.length;
          var i = 0;
          while (i < len && f(array[i]))
            i++;
          if (i < len) {
            var result = array.slice(0, i);
            i++;
            while (i < len) {
              var item = array[i];
              if (f(item)) {
                result.push(item);
              }
              i++;
            }
            return result;
          }
        }
        return array;
      }
      ts2.filter = filter;
      function filterMutate(array, f) {
        var outIndex = 0;
        for (var i = 0; i < array.length; i++) {
          if (f(array[i], i, array)) {
            array[outIndex] = array[i];
            outIndex++;
          }
        }
        array.length = outIndex;
      }
      ts2.filterMutate = filterMutate;
      function clear(array) {
        array.length = 0;
      }
      ts2.clear = clear;
      function map(array, f) {
        var result;
        if (array) {
          result = [];
          for (var i = 0; i < array.length; i++) {
            result.push(f(array[i], i));
          }
        }
        return result;
      }
      ts2.map = map;
      function mapIterator(iter, mapFn) {
        return {
          next: function() {
            var iterRes = iter.next();
            return iterRes.done ? iterRes : { value: mapFn(iterRes.value), done: false };
          }
        };
      }
      ts2.mapIterator = mapIterator;
      function sameMap(array, f) {
        if (array) {
          for (var i = 0; i < array.length; i++) {
            var item = array[i];
            var mapped = f(item, i);
            if (item !== mapped) {
              var result = array.slice(0, i);
              result.push(mapped);
              for (i++; i < array.length; i++) {
                result.push(f(array[i], i));
              }
              return result;
            }
          }
        }
        return array;
      }
      ts2.sameMap = sameMap;
      function flatten(array) {
        var result = [];
        for (var _i = 0, array_2 = array; _i < array_2.length; _i++) {
          var v = array_2[_i];
          if (v) {
            if (isArray(v)) {
              addRange(result, v);
            } else {
              result.push(v);
            }
          }
        }
        return result;
      }
      ts2.flatten = flatten;
      function flatMap(array, mapfn) {
        var result;
        if (array) {
          for (var i = 0; i < array.length; i++) {
            var v = mapfn(array[i], i);
            if (v) {
              if (isArray(v)) {
                result = addRange(result, v);
              } else {
                result = append(result, v);
              }
            }
          }
        }
        return result || ts2.emptyArray;
      }
      ts2.flatMap = flatMap;
      function flatMapToMutable(array, mapfn) {
        var result = [];
        if (array) {
          for (var i = 0; i < array.length; i++) {
            var v = mapfn(array[i], i);
            if (v) {
              if (isArray(v)) {
                addRange(result, v);
              } else {
                result.push(v);
              }
            }
          }
        }
        return result;
      }
      ts2.flatMapToMutable = flatMapToMutable;
      function flatMapIterator(iter, mapfn) {
        var first2 = iter.next();
        if (first2.done) {
          return ts2.emptyIterator;
        }
        var currentIter = getIterator(first2.value);
        return {
          next: function() {
            while (true) {
              var currentRes = currentIter.next();
              if (!currentRes.done) {
                return currentRes;
              }
              var iterRes = iter.next();
              if (iterRes.done) {
                return iterRes;
              }
              currentIter = getIterator(iterRes.value);
            }
          }
        };
        function getIterator(x) {
          var res = mapfn(x);
          return res === void 0 ? ts2.emptyIterator : isArray(res) ? arrayIterator(res) : res;
        }
      }
      ts2.flatMapIterator = flatMapIterator;
      function sameFlatMap(array, mapfn) {
        var result;
        if (array) {
          for (var i = 0; i < array.length; i++) {
            var item = array[i];
            var mapped = mapfn(item, i);
            if (result || item !== mapped || isArray(mapped)) {
              if (!result) {
                result = array.slice(0, i);
              }
              if (isArray(mapped)) {
                addRange(result, mapped);
              } else {
                result.push(mapped);
              }
            }
          }
        }
        return result || array;
      }
      ts2.sameFlatMap = sameFlatMap;
      function mapAllOrFail(array, mapFn) {
        var result = [];
        for (var i = 0; i < array.length; i++) {
          var mapped = mapFn(array[i], i);
          if (mapped === void 0) {
            return void 0;
          }
          result.push(mapped);
        }
        return result;
      }
      ts2.mapAllOrFail = mapAllOrFail;
      function mapDefined(array, mapFn) {
        var result = [];
        if (array) {
          for (var i = 0; i < array.length; i++) {
            var mapped = mapFn(array[i], i);
            if (mapped !== void 0) {
              result.push(mapped);
            }
          }
        }
        return result;
      }
      ts2.mapDefined = mapDefined;
      function mapDefinedIterator(iter, mapFn) {
        return {
          next: function() {
            while (true) {
              var res = iter.next();
              if (res.done) {
                return res;
              }
              var value = mapFn(res.value);
              if (value !== void 0) {
                return { value, done: false };
              }
            }
          }
        };
      }
      ts2.mapDefinedIterator = mapDefinedIterator;
      function mapDefinedMap(map2, mapValue, mapKey) {
        if (mapKey === void 0) {
          mapKey = identity;
        }
        var result = createMap();
        map2.forEach(function(value, key) {
          var mapped = mapValue(value, key);
          if (mapped !== void 0) {
            result.set(mapKey(key), mapped);
          }
        });
        return result;
      }
      ts2.mapDefinedMap = mapDefinedMap;
      ts2.emptyIterator = { next: function() {
        return { value: void 0, done: true };
      } };
      function singleIterator(value) {
        var done = false;
        return {
          next: function() {
            var wasDone = done;
            done = true;
            return wasDone ? { value: void 0, done: true } : { value, done: false };
          }
        };
      }
      ts2.singleIterator = singleIterator;
      function spanMap(array, keyfn, mapfn) {
        var result;
        if (array) {
          result = [];
          var len = array.length;
          var previousKey = void 0;
          var key = void 0;
          var start = 0;
          var pos = 0;
          while (start < len) {
            while (pos < len) {
              var value = array[pos];
              key = keyfn(value, pos);
              if (pos === 0) {
                previousKey = key;
              } else if (key !== previousKey) {
                break;
              }
              pos++;
            }
            if (start < pos) {
              var v = mapfn(array.slice(start, pos), previousKey, start, pos);
              if (v) {
                result.push(v);
              }
              start = pos;
            }
            previousKey = key;
            pos++;
          }
        }
        return result;
      }
      ts2.spanMap = spanMap;
      function mapEntries(map2, f) {
        if (!map2) {
          return void 0;
        }
        var result = createMap();
        map2.forEach(function(value, key) {
          var _a = f(key, value), newKey = _a[0], newValue = _a[1];
          result.set(newKey, newValue);
        });
        return result;
      }
      ts2.mapEntries = mapEntries;
      function some(array, predicate) {
        if (array) {
          if (predicate) {
            for (var _i = 0, array_3 = array; _i < array_3.length; _i++) {
              var v = array_3[_i];
              if (predicate(v)) {
                return true;
              }
            }
          } else {
            return array.length > 0;
          }
        }
        return false;
      }
      ts2.some = some;
      function getRangesWhere(arr, pred, cb) {
        var start;
        for (var i = 0; i < arr.length; i++) {
          if (pred(arr[i])) {
            start = start === void 0 ? i : start;
          } else {
            if (start !== void 0) {
              cb(start, i);
              start = void 0;
            }
          }
        }
        if (start !== void 0)
          cb(start, arr.length);
      }
      ts2.getRangesWhere = getRangesWhere;
      function concatenate(array1, array2) {
        if (!some(array2))
          return array1;
        if (!some(array1))
          return array2;
        return __spreadArrays(array1, array2);
      }
      ts2.concatenate = concatenate;
      function selectIndex(_, i) {
        return i;
      }
      function indicesOf(array) {
        return array.map(selectIndex);
      }
      ts2.indicesOf = indicesOf;
      function deduplicateRelational(array, equalityComparer, comparer) {
        var indices = indicesOf(array);
        stableSortIndices(array, indices, comparer);
        var last2 = array[indices[0]];
        var deduplicated = [indices[0]];
        for (var i = 1; i < indices.length; i++) {
          var index = indices[i];
          var item = array[index];
          if (!equalityComparer(last2, item)) {
            deduplicated.push(index);
            last2 = item;
          }
        }
        deduplicated.sort();
        return deduplicated.map(function(i2) {
          return array[i2];
        });
      }
      function deduplicateEquality(array, equalityComparer) {
        var result = [];
        for (var _i = 0, array_4 = array; _i < array_4.length; _i++) {
          var item = array_4[_i];
          pushIfUnique(result, item, equalityComparer);
        }
        return result;
      }
      function deduplicate(array, equalityComparer, comparer) {
        return array.length === 0 ? [] : array.length === 1 ? array.slice() : comparer ? deduplicateRelational(array, equalityComparer, comparer) : deduplicateEquality(array, equalityComparer);
      }
      ts2.deduplicate = deduplicate;
      function deduplicateSorted(array, comparer) {
        if (array.length === 0)
          return ts2.emptyArray;
        var last2 = array[0];
        var deduplicated = [last2];
        for (var i = 1; i < array.length; i++) {
          var next = array[i];
          switch (comparer(next, last2)) {
            case true:
            case 0:
              continue;
            case -1:
              return ts2.Debug.fail("Array is unsorted.");
          }
          deduplicated.push(last2 = next);
        }
        return deduplicated;
      }
      function insertSorted(array, insert, compare) {
        if (array.length === 0) {
          array.push(insert);
          return;
        }
        var insertIndex = binarySearch(array, insert, identity, compare);
        if (insertIndex < 0) {
          array.splice(~insertIndex, 0, insert);
        }
      }
      ts2.insertSorted = insertSorted;
      function sortAndDeduplicate(array, comparer, equalityComparer) {
        return deduplicateSorted(sort(array, comparer), equalityComparer || comparer || compareStringsCaseSensitive);
      }
      ts2.sortAndDeduplicate = sortAndDeduplicate;
      function arrayIsEqualTo(array1, array2, equalityComparer) {
        if (equalityComparer === void 0) {
          equalityComparer = equateValues;
        }
        if (!array1 || !array2) {
          return array1 === array2;
        }
        if (array1.length !== array2.length) {
          return false;
        }
        for (var i = 0; i < array1.length; i++) {
          if (!equalityComparer(array1[i], array2[i], i)) {
            return false;
          }
        }
        return true;
      }
      ts2.arrayIsEqualTo = arrayIsEqualTo;
      function compact(array) {
        var result;
        if (array) {
          for (var i = 0; i < array.length; i++) {
            var v = array[i];
            if (result || !v) {
              if (!result) {
                result = array.slice(0, i);
              }
              if (v) {
                result.push(v);
              }
            }
          }
        }
        return result || array;
      }
      ts2.compact = compact;
      function relativeComplement(arrayA, arrayB, comparer) {
        if (!arrayB || !arrayA || arrayB.length === 0 || arrayA.length === 0)
          return arrayB;
        var result = [];
        loopB:
          for (var offsetA = 0, offsetB = 0; offsetB < arrayB.length; offsetB++) {
            if (offsetB > 0) {
              ts2.Debug.assertGreaterThanOrEqual(comparer(arrayB[offsetB], arrayB[offsetB - 1]), 0);
            }
            loopA:
              for (var startA = offsetA; offsetA < arrayA.length; offsetA++) {
                if (offsetA > startA) {
                  ts2.Debug.assertGreaterThanOrEqual(comparer(arrayA[offsetA], arrayA[offsetA - 1]), 0);
                }
                switch (comparer(arrayB[offsetB], arrayA[offsetA])) {
                  case -1:
                    result.push(arrayB[offsetB]);
                    continue loopB;
                  case 0:
                    continue loopB;
                  case 1:
                    continue loopA;
                }
              }
          }
        return result;
      }
      ts2.relativeComplement = relativeComplement;
      function sum(array, prop) {
        var result = 0;
        for (var _i = 0, array_5 = array; _i < array_5.length; _i++) {
          var v = array_5[_i];
          result += v[prop];
        }
        return result;
      }
      ts2.sum = sum;
      function append(to, value) {
        if (value === void 0)
          return to;
        if (to === void 0)
          return [value];
        to.push(value);
        return to;
      }
      ts2.append = append;
      function combine(xs, ys) {
        if (xs === void 0)
          return ys;
        if (ys === void 0)
          return xs;
        if (isArray(xs))
          return isArray(ys) ? concatenate(xs, ys) : append(xs, ys);
        if (isArray(ys))
          return append(ys, xs);
        return [xs, ys];
      }
      ts2.combine = combine;
      function toOffset(array, offset) {
        return offset < 0 ? array.length + offset : offset;
      }
      function addRange(to, from, start, end) {
        if (from === void 0 || from.length === 0)
          return to;
        if (to === void 0)
          return from.slice(start, end);
        start = start === void 0 ? 0 : toOffset(from, start);
        end = end === void 0 ? from.length : toOffset(from, end);
        for (var i = start; i < end && i < from.length; i++) {
          if (from[i] !== void 0) {
            to.push(from[i]);
          }
        }
        return to;
      }
      ts2.addRange = addRange;
      function pushIfUnique(array, toAdd, equalityComparer) {
        if (contains(array, toAdd, equalityComparer)) {
          return false;
        } else {
          array.push(toAdd);
          return true;
        }
      }
      ts2.pushIfUnique = pushIfUnique;
      function appendIfUnique(array, toAdd, equalityComparer) {
        if (array) {
          pushIfUnique(array, toAdd, equalityComparer);
          return array;
        } else {
          return [toAdd];
        }
      }
      ts2.appendIfUnique = appendIfUnique;
      function stableSortIndices(array, indices, comparer) {
        indices.sort(function(x, y) {
          return comparer(array[x], array[y]) || compareValues(x, y);
        });
      }
      function sort(array, comparer) {
        return array.length === 0 ? array : array.slice().sort(comparer);
      }
      ts2.sort = sort;
      function arrayIterator(array) {
        var i = 0;
        return { next: function() {
          if (i === array.length) {
            return { value: void 0, done: true };
          } else {
            i++;
            return { value: array[i - 1], done: false };
          }
        } };
      }
      ts2.arrayIterator = arrayIterator;
      function arrayReverseIterator(array) {
        var i = array.length;
        return {
          next: function() {
            if (i === 0) {
              return { value: void 0, done: true };
            } else {
              i--;
              return { value: array[i], done: false };
            }
          }
        };
      }
      ts2.arrayReverseIterator = arrayReverseIterator;
      function stableSort(array, comparer) {
        var indices = indicesOf(array);
        stableSortIndices(array, indices, comparer);
        return indices.map(function(i) {
          return array[i];
        });
      }
      ts2.stableSort = stableSort;
      function rangeEquals(array1, array2, pos, end) {
        while (pos < end) {
          if (array1[pos] !== array2[pos]) {
            return false;
          }
          pos++;
        }
        return true;
      }
      ts2.rangeEquals = rangeEquals;
      function elementAt(array, offset) {
        if (array) {
          offset = toOffset(array, offset);
          if (offset < array.length) {
            return array[offset];
          }
        }
        return void 0;
      }
      ts2.elementAt = elementAt;
      function firstOrUndefined(array) {
        return array.length === 0 ? void 0 : array[0];
      }
      ts2.firstOrUndefined = firstOrUndefined;
      function first(array) {
        ts2.Debug.assert(array.length !== 0);
        return array[0];
      }
      ts2.first = first;
      function lastOrUndefined(array) {
        return array.length === 0 ? void 0 : array[array.length - 1];
      }
      ts2.lastOrUndefined = lastOrUndefined;
      function last(array) {
        ts2.Debug.assert(array.length !== 0);
        return array[array.length - 1];
      }
      ts2.last = last;
      function singleOrUndefined(array) {
        return array && array.length === 1 ? array[0] : void 0;
      }
      ts2.singleOrUndefined = singleOrUndefined;
      function singleOrMany(array) {
        return array && array.length === 1 ? array[0] : array;
      }
      ts2.singleOrMany = singleOrMany;
      function replaceElement(array, index, value) {
        var result = array.slice(0);
        result[index] = value;
        return result;
      }
      ts2.replaceElement = replaceElement;
      function binarySearch(array, value, keySelector, keyComparer, offset) {
        return binarySearchKey(array, keySelector(value), keySelector, keyComparer, offset);
      }
      ts2.binarySearch = binarySearch;
      function binarySearchKey(array, key, keySelector, keyComparer, offset) {
        if (!some(array)) {
          return -1;
        }
        var low = offset || 0;
        var high = array.length - 1;
        while (low <= high) {
          var middle = low + (high - low >> 1);
          var midKey = keySelector(array[middle]);
          switch (keyComparer(midKey, key)) {
            case -1:
              low = middle + 1;
              break;
            case 0:
              return middle;
            case 1:
              high = middle - 1;
              break;
          }
        }
        return ~low;
      }
      ts2.binarySearchKey = binarySearchKey;
      function reduceLeft(array, f, initial, start, count) {
        if (array && array.length > 0) {
          var size = array.length;
          if (size > 0) {
            var pos = start === void 0 || start < 0 ? 0 : start;
            var end = count === void 0 || pos + count > size - 1 ? size - 1 : pos + count;
            var result = void 0;
            if (arguments.length <= 2) {
              result = array[pos];
              pos++;
            } else {
              result = initial;
            }
            while (pos <= end) {
              result = f(result, array[pos], pos);
              pos++;
            }
            return result;
          }
        }
        return initial;
      }
      ts2.reduceLeft = reduceLeft;
      var hasOwnProperty2 = Object.prototype.hasOwnProperty;
      function hasProperty(map2, key) {
        return hasOwnProperty2.call(map2, key);
      }
      ts2.hasProperty = hasProperty;
      function getProperty(map2, key) {
        return hasOwnProperty2.call(map2, key) ? map2[key] : void 0;
      }
      ts2.getProperty = getProperty;
      function getOwnKeys(map2) {
        var keys = [];
        for (var key in map2) {
          if (hasOwnProperty2.call(map2, key)) {
            keys.push(key);
          }
        }
        return keys;
      }
      ts2.getOwnKeys = getOwnKeys;
      function getAllKeys(obj) {
        var result = [];
        do {
          var names = Object.getOwnPropertyNames(obj);
          for (var _i = 0, names_1 = names; _i < names_1.length; _i++) {
            var name = names_1[_i];
            pushIfUnique(result, name);
          }
        } while (obj = Object.getPrototypeOf(obj));
        return result;
      }
      ts2.getAllKeys = getAllKeys;
      function getOwnValues(sparseArray) {
        var values = [];
        for (var key in sparseArray) {
          if (hasOwnProperty2.call(sparseArray, key)) {
            values.push(sparseArray[key]);
          }
        }
        return values;
      }
      ts2.getOwnValues = getOwnValues;
      function arrayFrom(iterator, map2) {
        var result = [];
        for (var iterResult = iterator.next(); !iterResult.done; iterResult = iterator.next()) {
          result.push(map2 ? map2(iterResult.value) : iterResult.value);
        }
        return result;
      }
      ts2.arrayFrom = arrayFrom;
      function assign(t) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
          args[_i - 1] = arguments[_i];
        }
        for (var _a = 0, args_1 = args; _a < args_1.length; _a++) {
          var arg = args_1[_a];
          if (arg === void 0)
            continue;
          for (var p in arg) {
            if (hasProperty(arg, p)) {
              t[p] = arg[p];
            }
          }
        }
        return t;
      }
      ts2.assign = assign;
      function equalOwnProperties(left, right, equalityComparer) {
        if (equalityComparer === void 0) {
          equalityComparer = equateValues;
        }
        if (left === right)
          return true;
        if (!left || !right)
          return false;
        for (var key in left) {
          if (hasOwnProperty2.call(left, key)) {
            if (!hasOwnProperty2.call(right, key))
              return false;
            if (!equalityComparer(left[key], right[key]))
              return false;
          }
        }
        for (var key in right) {
          if (hasOwnProperty2.call(right, key)) {
            if (!hasOwnProperty2.call(left, key))
              return false;
          }
        }
        return true;
      }
      ts2.equalOwnProperties = equalOwnProperties;
      function arrayToMap(array, makeKey, makeValue) {
        if (makeValue === void 0) {
          makeValue = identity;
        }
        var result = createMap();
        for (var _i = 0, array_6 = array; _i < array_6.length; _i++) {
          var value = array_6[_i];
          var key = makeKey(value);
          if (key !== void 0)
            result.set(key, makeValue(value));
        }
        return result;
      }
      ts2.arrayToMap = arrayToMap;
      function arrayToNumericMap(array, makeKey, makeValue) {
        if (makeValue === void 0) {
          makeValue = identity;
        }
        var result = [];
        for (var _i = 0, array_7 = array; _i < array_7.length; _i++) {
          var value = array_7[_i];
          result[makeKey(value)] = makeValue(value);
        }
        return result;
      }
      ts2.arrayToNumericMap = arrayToNumericMap;
      function arrayToMultiMap(values, makeKey, makeValue) {
        if (makeValue === void 0) {
          makeValue = identity;
        }
        var result = createMultiMap();
        for (var _i = 0, values_1 = values; _i < values_1.length; _i++) {
          var value = values_1[_i];
          result.add(makeKey(value), makeValue(value));
        }
        return result;
      }
      ts2.arrayToMultiMap = arrayToMultiMap;
      function group(values, getGroupId, resultSelector) {
        if (resultSelector === void 0) {
          resultSelector = identity;
        }
        return arrayFrom(arrayToMultiMap(values, getGroupId).values(), resultSelector);
      }
      ts2.group = group;
      function clone(object) {
        var result = {};
        for (var id in object) {
          if (hasOwnProperty2.call(object, id)) {
            result[id] = object[id];
          }
        }
        return result;
      }
      ts2.clone = clone;
      function extend(first2, second) {
        var result = {};
        for (var id in second) {
          if (hasOwnProperty2.call(second, id)) {
            result[id] = second[id];
          }
        }
        for (var id in first2) {
          if (hasOwnProperty2.call(first2, id)) {
            result[id] = first2[id];
          }
        }
        return result;
      }
      ts2.extend = extend;
      function copyProperties(first2, second) {
        for (var id in second) {
          if (hasOwnProperty2.call(second, id)) {
            first2[id] = second[id];
          }
        }
      }
      ts2.copyProperties = copyProperties;
      function maybeBind(obj, fn) {
        return fn ? fn.bind(obj) : void 0;
      }
      ts2.maybeBind = maybeBind;
      function mapMap(map2, f) {
        var result = createMap();
        map2.forEach(function(t, key) {
          return result.set.apply(result, f(t, key));
        });
        return result;
      }
      ts2.mapMap = mapMap;
      function createMultiMap() {
        var map2 = createMap();
        map2.add = multiMapAdd;
        map2.remove = multiMapRemove;
        return map2;
      }
      ts2.createMultiMap = createMultiMap;
      function multiMapAdd(key, value) {
        var values = this.get(key);
        if (values) {
          values.push(value);
        } else {
          this.set(key, values = [value]);
        }
        return values;
      }
      function multiMapRemove(key, value) {
        var values = this.get(key);
        if (values) {
          unorderedRemoveItem(values, value);
          if (!values.length) {
            this.delete(key);
          }
        }
      }
      function createUnderscoreEscapedMultiMap() {
        return createMultiMap();
      }
      ts2.createUnderscoreEscapedMultiMap = createUnderscoreEscapedMultiMap;
      function isArray(value) {
        return Array.isArray ? Array.isArray(value) : value instanceof Array;
      }
      ts2.isArray = isArray;
      function toArray(value) {
        return isArray(value) ? value : [value];
      }
      ts2.toArray = toArray;
      function isString(text) {
        return typeof text === "string";
      }
      ts2.isString = isString;
      function isNumber(x) {
        return typeof x === "number";
      }
      ts2.isNumber = isNumber;
      function tryCast(value, test) {
        return value !== void 0 && test(value) ? value : void 0;
      }
      ts2.tryCast = tryCast;
      function cast(value, test) {
        if (value !== void 0 && test(value))
          return value;
        return ts2.Debug.fail("Invalid cast. The supplied value " + value + " did not pass the test '" + ts2.Debug.getFunctionName(test) + "'.");
      }
      ts2.cast = cast;
      function noop(_) {
      }
      ts2.noop = noop;
      function returnFalse() {
        return false;
      }
      ts2.returnFalse = returnFalse;
      function returnTrue() {
        return true;
      }
      ts2.returnTrue = returnTrue;
      function returnUndefined() {
        return void 0;
      }
      ts2.returnUndefined = returnUndefined;
      function identity(x) {
        return x;
      }
      ts2.identity = identity;
      function toLowerCase(x) {
        return x.toLowerCase();
      }
      ts2.toLowerCase = toLowerCase;
      var fileNameLowerCaseRegExp = /[^\u0130\u0131\u00DFa-z0-9\\/:\-_\. ]+/g;
      function toFileNameLowerCase(x) {
        return fileNameLowerCaseRegExp.test(x) ? x.replace(fileNameLowerCaseRegExp, toLowerCase) : x;
      }
      ts2.toFileNameLowerCase = toFileNameLowerCase;
      function notImplemented() {
        throw new Error("Not implemented");
      }
      ts2.notImplemented = notImplemented;
      function memoize(callback) {
        var value;
        return function() {
          if (callback) {
            value = callback();
            callback = void 0;
          }
          return value;
        };
      }
      ts2.memoize = memoize;
      function compose(a, b, c, d, e) {
        if (!!e) {
          var args_2 = [];
          for (var i = 0; i < arguments.length; i++) {
            args_2[i] = arguments[i];
          }
          return function(t) {
            return reduceLeft(args_2, function(u, f) {
              return f(u);
            }, t);
          };
        } else if (d) {
          return function(t) {
            return d(c(b(a(t))));
          };
        } else if (c) {
          return function(t) {
            return c(b(a(t)));
          };
        } else if (b) {
          return function(t) {
            return b(a(t));
          };
        } else if (a) {
          return function(t) {
            return a(t);
          };
        } else {
          return function(t) {
            return t;
          };
        }
      }
      ts2.compose = compose;
      var AssertionLevel;
      (function(AssertionLevel2) {
        AssertionLevel2[AssertionLevel2["None"] = 0] = "None";
        AssertionLevel2[AssertionLevel2["Normal"] = 1] = "Normal";
        AssertionLevel2[AssertionLevel2["Aggressive"] = 2] = "Aggressive";
        AssertionLevel2[AssertionLevel2["VeryAggressive"] = 3] = "VeryAggressive";
      })(AssertionLevel = ts2.AssertionLevel || (ts2.AssertionLevel = {}));
      function equateValues(a, b) {
        return a === b;
      }
      ts2.equateValues = equateValues;
      function equateStringsCaseInsensitive(a, b) {
        return a === b || a !== void 0 && b !== void 0 && a.toUpperCase() === b.toUpperCase();
      }
      ts2.equateStringsCaseInsensitive = equateStringsCaseInsensitive;
      function equateStringsCaseSensitive(a, b) {
        return equateValues(a, b);
      }
      ts2.equateStringsCaseSensitive = equateStringsCaseSensitive;
      function compareComparableValues(a, b) {
        return a === b ? 0 : a === void 0 ? -1 : b === void 0 ? 1 : a < b ? -1 : 1;
      }
      function compareValues(a, b) {
        return compareComparableValues(a, b);
      }
      ts2.compareValues = compareValues;
      function compareTextSpans(a, b) {
        return compareValues(a === null || a === void 0 ? void 0 : a.start, b === null || b === void 0 ? void 0 : b.start) || compareValues(a === null || a === void 0 ? void 0 : a.length, b === null || b === void 0 ? void 0 : b.length);
      }
      ts2.compareTextSpans = compareTextSpans;
      function min(a, b, compare) {
        return compare(a, b) === -1 ? a : b;
      }
      ts2.min = min;
      function compareStringsCaseInsensitive(a, b) {
        if (a === b)
          return 0;
        if (a === void 0)
          return -1;
        if (b === void 0)
          return 1;
        a = a.toUpperCase();
        b = b.toUpperCase();
        return a < b ? -1 : a > b ? 1 : 0;
      }
      ts2.compareStringsCaseInsensitive = compareStringsCaseInsensitive;
      function compareStringsCaseSensitive(a, b) {
        return compareComparableValues(a, b);
      }
      ts2.compareStringsCaseSensitive = compareStringsCaseSensitive;
      function getStringComparer(ignoreCase) {
        return ignoreCase ? compareStringsCaseInsensitive : compareStringsCaseSensitive;
      }
      ts2.getStringComparer = getStringComparer;
      var createUIStringComparer = function() {
        var defaultComparer;
        var enUSComparer;
        var stringComparerFactory = getStringComparerFactory();
        return createStringComparer;
        function compareWithCallback(a, b, comparer) {
          if (a === b)
            return 0;
          if (a === void 0)
            return -1;
          if (b === void 0)
            return 1;
          var value = comparer(a, b);
          return value < 0 ? -1 : value > 0 ? 1 : 0;
        }
        function createIntlCollatorStringComparer(locale) {
          var comparer = new Intl.Collator(locale, { usage: "sort", sensitivity: "variant" }).compare;
          return function(a, b) {
            return compareWithCallback(a, b, comparer);
          };
        }
        function createLocaleCompareStringComparer(locale) {
          if (locale !== void 0)
            return createFallbackStringComparer();
          return function(a, b) {
            return compareWithCallback(a, b, compareStrings);
          };
          function compareStrings(a, b) {
            return a.localeCompare(b);
          }
        }
        function createFallbackStringComparer() {
          return function(a, b) {
            return compareWithCallback(a, b, compareDictionaryOrder);
          };
          function compareDictionaryOrder(a, b) {
            return compareStrings(a.toUpperCase(), b.toUpperCase()) || compareStrings(a, b);
          }
          function compareStrings(a, b) {
            return a < b ? -1 : a > b ? 1 : 0;
          }
        }
        function getStringComparerFactory() {
          if (typeof Intl === "object" && typeof Intl.Collator === "function") {
            return createIntlCollatorStringComparer;
          }
          if (typeof String.prototype.localeCompare === "function" && typeof String.prototype.toLocaleUpperCase === "function" && "a".localeCompare("B") < 0) {
            return createLocaleCompareStringComparer;
          }
          return createFallbackStringComparer;
        }
        function createStringComparer(locale) {
          if (locale === void 0) {
            return defaultComparer || (defaultComparer = stringComparerFactory(locale));
          } else if (locale === "en-US") {
            return enUSComparer || (enUSComparer = stringComparerFactory(locale));
          } else {
            return stringComparerFactory(locale);
          }
        }
      }();
      var uiComparerCaseSensitive;
      var uiLocale;
      function getUILocale() {
        return uiLocale;
      }
      ts2.getUILocale = getUILocale;
      function setUILocale(value) {
        if (uiLocale !== value) {
          uiLocale = value;
          uiComparerCaseSensitive = void 0;
        }
      }
      ts2.setUILocale = setUILocale;
      function compareStringsCaseSensitiveUI(a, b) {
        var comparer = uiComparerCaseSensitive || (uiComparerCaseSensitive = createUIStringComparer(uiLocale));
        return comparer(a, b);
      }
      ts2.compareStringsCaseSensitiveUI = compareStringsCaseSensitiveUI;
      function compareProperties(a, b, key, comparer) {
        return a === b ? 0 : a === void 0 ? -1 : b === void 0 ? 1 : comparer(a[key], b[key]);
      }
      ts2.compareProperties = compareProperties;
      function compareBooleans(a, b) {
        return compareValues(a ? 1 : 0, b ? 1 : 0);
      }
      ts2.compareBooleans = compareBooleans;
      function getSpellingSuggestion(name, candidates, getName) {
        var maximumLengthDifference = Math.min(2, Math.floor(name.length * 0.34));
        var bestDistance = Math.floor(name.length * 0.4) + 1;
        var bestCandidate;
        var justCheckExactMatches = false;
        var nameLowerCase = name.toLowerCase();
        for (var _i = 0, candidates_1 = candidates; _i < candidates_1.length; _i++) {
          var candidate = candidates_1[_i];
          var candidateName = getName(candidate);
          if (candidateName !== void 0 && Math.abs(candidateName.length - nameLowerCase.length) <= maximumLengthDifference) {
            var candidateNameLowerCase = candidateName.toLowerCase();
            if (candidateNameLowerCase === nameLowerCase) {
              if (candidateName === name) {
                continue;
              }
              return candidate;
            }
            if (justCheckExactMatches) {
              continue;
            }
            if (candidateName.length < 3) {
              continue;
            }
            var distance = levenshteinWithMax(nameLowerCase, candidateNameLowerCase, bestDistance - 1);
            if (distance === void 0) {
              continue;
            }
            if (distance < 3) {
              justCheckExactMatches = true;
              bestCandidate = candidate;
            } else {
              ts2.Debug.assert(distance < bestDistance);
              bestDistance = distance;
              bestCandidate = candidate;
            }
          }
        }
        return bestCandidate;
      }
      ts2.getSpellingSuggestion = getSpellingSuggestion;
      function levenshteinWithMax(s1, s2, max) {
        var previous = new Array(s2.length + 1);
        var current = new Array(s2.length + 1);
        var big = max + 1;
        for (var i = 0; i <= s2.length; i++) {
          previous[i] = i;
        }
        for (var i = 1; i <= s1.length; i++) {
          var c1 = s1.charCodeAt(i - 1);
          var minJ = i > max ? i - max : 1;
          var maxJ = s2.length > max + i ? max + i : s2.length;
          current[0] = i;
          var colMin = i;
          for (var j = 1; j < minJ; j++) {
            current[j] = big;
          }
          for (var j = minJ; j <= maxJ; j++) {
            var dist = c1 === s2.charCodeAt(j - 1) ? previous[j - 1] : Math.min(previous[j] + 1, current[j - 1] + 1, previous[j - 1] + 2);
            current[j] = dist;
            colMin = Math.min(colMin, dist);
          }
          for (var j = maxJ + 1; j <= s2.length; j++) {
            current[j] = big;
          }
          if (colMin > max) {
            return void 0;
          }
          var temp = previous;
          previous = current;
          current = temp;
        }
        var res = previous[s2.length];
        return res > max ? void 0 : res;
      }
      function endsWith(str, suffix) {
        var expectedPos = str.length - suffix.length;
        return expectedPos >= 0 && str.indexOf(suffix, expectedPos) === expectedPos;
      }
      ts2.endsWith = endsWith;
      function removeSuffix(str, suffix) {
        return endsWith(str, suffix) ? str.slice(0, str.length - suffix.length) : str;
      }
      ts2.removeSuffix = removeSuffix;
      function tryRemoveSuffix(str, suffix) {
        return endsWith(str, suffix) ? str.slice(0, str.length - suffix.length) : void 0;
      }
      ts2.tryRemoveSuffix = tryRemoveSuffix;
      function stringContains(str, substring) {
        return str.indexOf(substring) !== -1;
      }
      ts2.stringContains = stringContains;
      function removeMinAndVersionNumbers(fileName) {
        var trailingMinOrVersion = /[.-]((min)|(\d+(\.\d+)*))$/;
        return fileName.replace(trailingMinOrVersion, "").replace(trailingMinOrVersion, "");
      }
      ts2.removeMinAndVersionNumbers = removeMinAndVersionNumbers;
      function orderedRemoveItem(array, item) {
        for (var i = 0; i < array.length; i++) {
          if (array[i] === item) {
            orderedRemoveItemAt(array, i);
            return true;
          }
        }
        return false;
      }
      ts2.orderedRemoveItem = orderedRemoveItem;
      function orderedRemoveItemAt(array, index) {
        for (var i = index; i < array.length - 1; i++) {
          array[i] = array[i + 1];
        }
        array.pop();
      }
      ts2.orderedRemoveItemAt = orderedRemoveItemAt;
      function unorderedRemoveItemAt(array, index) {
        array[index] = array[array.length - 1];
        array.pop();
      }
      ts2.unorderedRemoveItemAt = unorderedRemoveItemAt;
      function unorderedRemoveItem(array, item) {
        return unorderedRemoveFirstItemWhere(array, function(element) {
          return element === item;
        });
      }
      ts2.unorderedRemoveItem = unorderedRemoveItem;
      function unorderedRemoveFirstItemWhere(array, predicate) {
        for (var i = 0; i < array.length; i++) {
          if (predicate(array[i])) {
            unorderedRemoveItemAt(array, i);
            return true;
          }
        }
        return false;
      }
      function createGetCanonicalFileName(useCaseSensitiveFileNames) {
        return useCaseSensitiveFileNames ? identity : toFileNameLowerCase;
      }
      ts2.createGetCanonicalFileName = createGetCanonicalFileName;
      function patternText(_a) {
        var prefix = _a.prefix, suffix = _a.suffix;
        return prefix + "*" + suffix;
      }
      ts2.patternText = patternText;
      function matchedText(pattern, candidate) {
        ts2.Debug.assert(isPatternMatch(pattern, candidate));
        return candidate.substring(pattern.prefix.length, candidate.length - pattern.suffix.length);
      }
      ts2.matchedText = matchedText;
      function findBestPatternMatch(values, getPattern, candidate) {
        var matchedValue;
        var longestMatchPrefixLength = -1;
        for (var _i = 0, values_2 = values; _i < values_2.length; _i++) {
          var v = values_2[_i];
          var pattern = getPattern(v);
          if (isPatternMatch(pattern, candidate) && pattern.prefix.length > longestMatchPrefixLength) {
            longestMatchPrefixLength = pattern.prefix.length;
            matchedValue = v;
          }
        }
        return matchedValue;
      }
      ts2.findBestPatternMatch = findBestPatternMatch;
      function startsWith(str, prefix) {
        return str.lastIndexOf(prefix, 0) === 0;
      }
      ts2.startsWith = startsWith;
      function removePrefix(str, prefix) {
        return startsWith(str, prefix) ? str.substr(prefix.length) : str;
      }
      ts2.removePrefix = removePrefix;
      function tryRemovePrefix(str, prefix, getCanonicalFileName) {
        if (getCanonicalFileName === void 0) {
          getCanonicalFileName = identity;
        }
        return startsWith(getCanonicalFileName(str), getCanonicalFileName(prefix)) ? str.substring(prefix.length) : void 0;
      }
      ts2.tryRemovePrefix = tryRemovePrefix;
      function isPatternMatch(_a, candidate) {
        var prefix = _a.prefix, suffix = _a.suffix;
        return candidate.length >= prefix.length + suffix.length && startsWith(candidate, prefix) && endsWith(candidate, suffix);
      }
      function and(f, g) {
        return function(arg) {
          return f(arg) && g(arg);
        };
      }
      ts2.and = and;
      function or() {
        var fs2 = [];
        for (var _i = 0; _i < arguments.length; _i++) {
          fs2[_i] = arguments[_i];
        }
        return function() {
          var args = [];
          for (var _i2 = 0; _i2 < arguments.length; _i2++) {
            args[_i2] = arguments[_i2];
          }
          for (var _a = 0, fs_1 = fs2; _a < fs_1.length; _a++) {
            var f = fs_1[_a];
            if (f.apply(void 0, args)) {
              return true;
            }
          }
          return false;
        };
      }
      ts2.or = or;
      function not(fn) {
        return function() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          return !fn.apply(void 0, args);
        };
      }
      ts2.not = not;
      function assertType(_) {
      }
      ts2.assertType = assertType;
      function singleElementArray(t) {
        return t === void 0 ? void 0 : [t];
      }
      ts2.singleElementArray = singleElementArray;
      function enumerateInsertsAndDeletes(newItems, oldItems, comparer, inserted, deleted, unchanged) {
        unchanged = unchanged || noop;
        var newIndex = 0;
        var oldIndex = 0;
        var newLen = newItems.length;
        var oldLen = oldItems.length;
        while (newIndex < newLen && oldIndex < oldLen) {
          var newItem = newItems[newIndex];
          var oldItem = oldItems[oldIndex];
          var compareResult = comparer(newItem, oldItem);
          if (compareResult === -1) {
            inserted(newItem);
            newIndex++;
          } else if (compareResult === 1) {
            deleted(oldItem);
            oldIndex++;
          } else {
            unchanged(oldItem, newItem);
            newIndex++;
            oldIndex++;
          }
        }
        while (newIndex < newLen) {
          inserted(newItems[newIndex++]);
        }
        while (oldIndex < oldLen) {
          deleted(oldItems[oldIndex++]);
        }
      }
      ts2.enumerateInsertsAndDeletes = enumerateInsertsAndDeletes;
      function fill(length2, cb) {
        var result = Array(length2);
        for (var i = 0; i < length2; i++) {
          result[i] = cb(i);
        }
        return result;
      }
      ts2.fill = fill;
      function cartesianProduct(arrays) {
        var result = [];
        cartesianProductWorker(arrays, result, void 0, 0);
        return result;
      }
      ts2.cartesianProduct = cartesianProduct;
      function cartesianProductWorker(arrays, result, outer, index) {
        for (var _i = 0, _a = arrays[index]; _i < _a.length; _i++) {
          var element = _a[_i];
          var inner = void 0;
          if (outer) {
            inner = outer.slice();
            inner.push(element);
          } else {
            inner = [element];
          }
          if (index === arrays.length - 1) {
            result.push(inner);
          } else {
            cartesianProductWorker(arrays, result, inner, index + 1);
          }
        }
      }
      function padLeft(s, length2) {
        while (s.length < length2) {
          s = " " + s;
        }
        return s;
      }
      ts2.padLeft = padLeft;
      function padRight(s, length2) {
        while (s.length < length2) {
          s = s + " ";
        }
        return s;
      }
      ts2.padRight = padRight;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var Debug;
      (function(Debug2) {
        var currentAssertionLevel = 0;
        Debug2.isDebugging = false;
        var assertionCache = {};
        function getAssertionLevel() {
          return currentAssertionLevel;
        }
        Debug2.getAssertionLevel = getAssertionLevel;
        function setAssertionLevel(level) {
          var prevAssertionLevel = currentAssertionLevel;
          currentAssertionLevel = level;
          if (level > prevAssertionLevel) {
            for (var _i = 0, _a = ts2.getOwnKeys(assertionCache); _i < _a.length; _i++) {
              var key = _a[_i];
              var cachedFunc = assertionCache[key];
              if (cachedFunc !== void 0 && Debug2[key] !== cachedFunc.assertion && level >= cachedFunc.level) {
                Debug2[key] = cachedFunc;
                assertionCache[key] = void 0;
              }
            }
          }
        }
        Debug2.setAssertionLevel = setAssertionLevel;
        function shouldAssert(level) {
          return currentAssertionLevel >= level;
        }
        Debug2.shouldAssert = shouldAssert;
        function shouldAssertFunction(level, name) {
          if (!shouldAssert(level)) {
            assertionCache[name] = { level, assertion: Debug2[name] };
            Debug2[name] = ts2.noop;
            return false;
          }
          return true;
        }
        function fail(message, stackCrawlMark) {
          debugger;
          var e = new Error(message ? "Debug Failure. " + message : "Debug Failure.");
          if (Error.captureStackTrace) {
            Error.captureStackTrace(e, stackCrawlMark || fail);
          }
          throw e;
        }
        Debug2.fail = fail;
        function failBadSyntaxKind(node, message, stackCrawlMark) {
          return fail((message || "Unexpected node.") + "\r\nNode " + formatSyntaxKind(node.kind) + " was unexpected.", stackCrawlMark || failBadSyntaxKind);
        }
        Debug2.failBadSyntaxKind = failBadSyntaxKind;
        function assert(expression, message, verboseDebugInfo, stackCrawlMark) {
          if (!expression) {
            message = message ? "False expression: " + message : "False expression.";
            if (verboseDebugInfo) {
              message += "\r\nVerbose Debug Information: " + (typeof verboseDebugInfo === "string" ? verboseDebugInfo : verboseDebugInfo());
            }
            fail(message, stackCrawlMark || assert);
          }
        }
        Debug2.assert = assert;
        function assertEqual(a, b, msg, msg2, stackCrawlMark) {
          if (a !== b) {
            var message = msg ? msg2 ? msg + " " + msg2 : msg : "";
            fail("Expected " + a + " === " + b + ". " + message, stackCrawlMark || assertEqual);
          }
        }
        Debug2.assertEqual = assertEqual;
        function assertLessThan(a, b, msg, stackCrawlMark) {
          if (a >= b) {
            fail("Expected " + a + " < " + b + ". " + (msg || ""), stackCrawlMark || assertLessThan);
          }
        }
        Debug2.assertLessThan = assertLessThan;
        function assertLessThanOrEqual(a, b, stackCrawlMark) {
          if (a > b) {
            fail("Expected " + a + " <= " + b, stackCrawlMark || assertLessThanOrEqual);
          }
        }
        Debug2.assertLessThanOrEqual = assertLessThanOrEqual;
        function assertGreaterThanOrEqual(a, b, stackCrawlMark) {
          if (a < b) {
            fail("Expected " + a + " >= " + b, stackCrawlMark || assertGreaterThanOrEqual);
          }
        }
        Debug2.assertGreaterThanOrEqual = assertGreaterThanOrEqual;
        function assertIsDefined(value, message, stackCrawlMark) {
          if (value === void 0 || value === null) {
            fail(message, stackCrawlMark || assertIsDefined);
          }
        }
        Debug2.assertIsDefined = assertIsDefined;
        function checkDefined(value, message, stackCrawlMark) {
          assertIsDefined(value, message, stackCrawlMark || checkDefined);
          return value;
        }
        Debug2.checkDefined = checkDefined;
        Debug2.assertDefined = checkDefined;
        function assertEachIsDefined(value, message, stackCrawlMark) {
          for (var _i = 0, value_1 = value; _i < value_1.length; _i++) {
            var v = value_1[_i];
            assertIsDefined(v, message, stackCrawlMark || assertEachIsDefined);
          }
        }
        Debug2.assertEachIsDefined = assertEachIsDefined;
        function checkEachDefined(value, message, stackCrawlMark) {
          assertEachIsDefined(value, message, stackCrawlMark || checkEachDefined);
          return value;
        }
        Debug2.checkEachDefined = checkEachDefined;
        Debug2.assertEachDefined = checkEachDefined;
        function assertNever(member, message, stackCrawlMark) {
          if (message === void 0) {
            message = "Illegal value:";
          }
          var detail = typeof member === "object" && ts2.hasProperty(member, "kind") && ts2.hasProperty(member, "pos") && formatSyntaxKind ? "SyntaxKind: " + formatSyntaxKind(member.kind) : JSON.stringify(member);
          return fail(message + " " + detail, stackCrawlMark || assertNever);
        }
        Debug2.assertNever = assertNever;
        function assertEachNode(nodes, test, message, stackCrawlMark) {
          if (shouldAssertFunction(1, "assertEachNode")) {
            assert(test === void 0 || ts2.every(nodes, test), message || "Unexpected node.", function() {
              return "Node array did not pass test '" + getFunctionName(test) + "'.";
            }, stackCrawlMark || assertEachNode);
          }
        }
        Debug2.assertEachNode = assertEachNode;
        function assertNode(node, test, message, stackCrawlMark) {
          if (shouldAssertFunction(1, "assertNode")) {
            assert(node !== void 0 && (test === void 0 || test(node)), message || "Unexpected node.", function() {
              return "Node " + formatSyntaxKind(node.kind) + " did not pass test '" + getFunctionName(test) + "'.";
            }, stackCrawlMark || assertNode);
          }
        }
        Debug2.assertNode = assertNode;
        function assertNotNode(node, test, message, stackCrawlMark) {
          if (shouldAssertFunction(1, "assertNotNode")) {
            assert(node === void 0 || test === void 0 || !test(node), message || "Unexpected node.", function() {
              return "Node " + formatSyntaxKind(node.kind) + " should not have passed test '" + getFunctionName(test) + "'.";
            }, stackCrawlMark || assertNotNode);
          }
        }
        Debug2.assertNotNode = assertNotNode;
        function assertOptionalNode(node, test, message, stackCrawlMark) {
          if (shouldAssertFunction(1, "assertOptionalNode")) {
            assert(test === void 0 || node === void 0 || test(node), message || "Unexpected node.", function() {
              return "Node " + formatSyntaxKind(node.kind) + " did not pass test '" + getFunctionName(test) + "'.";
            }, stackCrawlMark || assertOptionalNode);
          }
        }
        Debug2.assertOptionalNode = assertOptionalNode;
        function assertOptionalToken(node, kind, message, stackCrawlMark) {
          if (shouldAssertFunction(1, "assertOptionalToken")) {
            assert(kind === void 0 || node === void 0 || node.kind === kind, message || "Unexpected node.", function() {
              return "Node " + formatSyntaxKind(node.kind) + " was not a '" + formatSyntaxKind(kind) + "' token.";
            }, stackCrawlMark || assertOptionalToken);
          }
        }
        Debug2.assertOptionalToken = assertOptionalToken;
        function assertMissingNode(node, message, stackCrawlMark) {
          if (shouldAssertFunction(1, "assertMissingNode")) {
            assert(node === void 0, message || "Unexpected node.", function() {
              return "Node " + formatSyntaxKind(node.kind) + " was unexpected'.";
            }, stackCrawlMark || assertMissingNode);
          }
        }
        Debug2.assertMissingNode = assertMissingNode;
        function getFunctionName(func) {
          if (typeof func !== "function") {
            return "";
          } else if (func.hasOwnProperty("name")) {
            return func.name;
          } else {
            var text = Function.prototype.toString.call(func);
            var match = /^function\s+([\w\$]+)\s*\(/.exec(text);
            return match ? match[1] : "";
          }
        }
        Debug2.getFunctionName = getFunctionName;
        function formatSymbol(symbol) {
          return "{ name: " + ts2.unescapeLeadingUnderscores(symbol.escapedName) + "; flags: " + formatSymbolFlags(symbol.flags) + "; declarations: " + ts2.map(symbol.declarations, function(node) {
            return formatSyntaxKind(node.kind);
          }) + " }";
        }
        Debug2.formatSymbol = formatSymbol;
        function formatEnum(value, enumObject, isFlags) {
          if (value === void 0) {
            value = 0;
          }
          var members = getEnumMembers(enumObject);
          if (value === 0) {
            return members.length > 0 && members[0][0] === 0 ? members[0][1] : "0";
          }
          if (isFlags) {
            var result = "";
            var remainingFlags = value;
            for (var _i = 0, members_1 = members; _i < members_1.length; _i++) {
              var _a = members_1[_i], enumValue = _a[0], enumName = _a[1];
              if (enumValue > value) {
                break;
              }
              if (enumValue !== 0 && enumValue & value) {
                result = "" + result + (result ? "|" : "") + enumName;
                remainingFlags &= ~enumValue;
              }
            }
            if (remainingFlags === 0) {
              return result;
            }
          } else {
            for (var _b = 0, members_2 = members; _b < members_2.length; _b++) {
              var _c = members_2[_b], enumValue = _c[0], enumName = _c[1];
              if (enumValue === value) {
                return enumName;
              }
            }
          }
          return value.toString();
        }
        Debug2.formatEnum = formatEnum;
        function getEnumMembers(enumObject) {
          var result = [];
          for (var name in enumObject) {
            var value = enumObject[name];
            if (typeof value === "number") {
              result.push([value, name]);
            }
          }
          return ts2.stableSort(result, function(x, y) {
            return ts2.compareValues(x[0], y[0]);
          });
        }
        function formatSyntaxKind(kind) {
          return formatEnum(kind, ts2.SyntaxKind, false);
        }
        Debug2.formatSyntaxKind = formatSyntaxKind;
        function formatNodeFlags(flags) {
          return formatEnum(flags, ts2.NodeFlags, true);
        }
        Debug2.formatNodeFlags = formatNodeFlags;
        function formatModifierFlags(flags) {
          return formatEnum(flags, ts2.ModifierFlags, true);
        }
        Debug2.formatModifierFlags = formatModifierFlags;
        function formatTransformFlags(flags) {
          return formatEnum(flags, ts2.TransformFlags, true);
        }
        Debug2.formatTransformFlags = formatTransformFlags;
        function formatEmitFlags(flags) {
          return formatEnum(flags, ts2.EmitFlags, true);
        }
        Debug2.formatEmitFlags = formatEmitFlags;
        function formatSymbolFlags(flags) {
          return formatEnum(flags, ts2.SymbolFlags, true);
        }
        Debug2.formatSymbolFlags = formatSymbolFlags;
        function formatTypeFlags(flags) {
          return formatEnum(flags, ts2.TypeFlags, true);
        }
        Debug2.formatTypeFlags = formatTypeFlags;
        function formatObjectFlags(flags) {
          return formatEnum(flags, ts2.ObjectFlags, true);
        }
        Debug2.formatObjectFlags = formatObjectFlags;
        var isDebugInfoEnabled = false;
        var extendedDebugModule;
        function extendedDebug() {
          enableDebugInfo();
          if (!extendedDebugModule) {
            throw new Error("Debugging helpers could not be loaded.");
          }
          return extendedDebugModule;
        }
        function printControlFlowGraph(flowNode) {
          return console.log(formatControlFlowGraph(flowNode));
        }
        Debug2.printControlFlowGraph = printControlFlowGraph;
        function formatControlFlowGraph(flowNode) {
          return extendedDebug().formatControlFlowGraph(flowNode);
        }
        Debug2.formatControlFlowGraph = formatControlFlowGraph;
        function attachFlowNodeDebugInfo(flowNode) {
          if (isDebugInfoEnabled) {
            if (!("__debugFlowFlags" in flowNode)) {
              Object.defineProperties(flowNode, {
                __debugFlowFlags: { get: function() {
                  return formatEnum(this.flags, ts2.FlowFlags, true);
                } },
                __debugToString: { value: function() {
                  return formatControlFlowGraph(this);
                } }
              });
            }
          }
        }
        Debug2.attachFlowNodeDebugInfo = attachFlowNodeDebugInfo;
        function enableDebugInfo() {
          if (isDebugInfoEnabled)
            return;
          Object.defineProperties(ts2.objectAllocator.getSymbolConstructor().prototype, {
            __debugFlags: { get: function() {
              return formatSymbolFlags(this.flags);
            } }
          });
          Object.defineProperties(ts2.objectAllocator.getTypeConstructor().prototype, {
            __debugFlags: { get: function() {
              return formatTypeFlags(this.flags);
            } },
            __debugObjectFlags: { get: function() {
              return this.flags & 524288 ? formatObjectFlags(this.objectFlags) : "";
            } },
            __debugTypeToString: { value: function() {
              return this.checker.typeToString(this);
            } }
          });
          var nodeConstructors = [
            ts2.objectAllocator.getNodeConstructor(),
            ts2.objectAllocator.getIdentifierConstructor(),
            ts2.objectAllocator.getTokenConstructor(),
            ts2.objectAllocator.getSourceFileConstructor()
          ];
          for (var _i = 0, nodeConstructors_1 = nodeConstructors; _i < nodeConstructors_1.length; _i++) {
            var ctor = nodeConstructors_1[_i];
            if (!ctor.prototype.hasOwnProperty("__debugKind")) {
              Object.defineProperties(ctor.prototype, {
                __debugKind: { get: function() {
                  return formatSyntaxKind(this.kind);
                } },
                __debugNodeFlags: { get: function() {
                  return formatNodeFlags(this.flags);
                } },
                __debugModifierFlags: { get: function() {
                  return formatModifierFlags(ts2.getModifierFlagsNoCache(this));
                } },
                __debugTransformFlags: { get: function() {
                  return formatTransformFlags(this.transformFlags);
                } },
                __debugIsParseTreeNode: { get: function() {
                  return ts2.isParseTreeNode(this);
                } },
                __debugEmitFlags: { get: function() {
                  return formatEmitFlags(ts2.getEmitFlags(this));
                } },
                __debugGetText: {
                  value: function(includeTrivia) {
                    if (ts2.nodeIsSynthesized(this))
                      return "";
                    var parseNode = ts2.getParseTreeNode(this);
                    var sourceFile = parseNode && ts2.getSourceFileOfNode(parseNode);
                    return sourceFile ? ts2.getSourceTextOfNodeFromSourceFile(sourceFile, parseNode, includeTrivia) : "";
                  }
                }
              });
            }
          }
          try {
            if (ts2.sys && ts2.sys.require) {
              var basePath = ts2.getDirectoryPath(ts2.resolvePath(ts2.sys.getExecutingFilePath()));
              var result = ts2.sys.require(basePath, "./compiler-debug");
              if (!result.error) {
                result.module.init(ts2);
                extendedDebugModule = result.module;
              }
            }
          } catch (_a) {
          }
          isDebugInfoEnabled = true;
        }
        Debug2.enableDebugInfo = enableDebugInfo;
      })(Debug = ts2.Debug || (ts2.Debug = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      ts2.timestamp = typeof performance !== "undefined" && performance.now ? function() {
        return performance.now();
      } : Date.now ? Date.now : function() {
        return +new Date();
      };
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var performance2;
      (function(performance3) {
        var profilerEvent = typeof onProfilerEvent === "function" && onProfilerEvent.profiler === true ? onProfilerEvent : function() {
        };
        var enabled = false;
        var profilerStart = 0;
        var counts;
        var marks;
        var measures;
        function createTimerIf(condition, measureName, startMarkName, endMarkName) {
          return condition ? createTimer(measureName, startMarkName, endMarkName) : performance3.nullTimer;
        }
        performance3.createTimerIf = createTimerIf;
        function createTimer(measureName, startMarkName, endMarkName) {
          var enterCount = 0;
          return {
            enter,
            exit
          };
          function enter() {
            if (++enterCount === 1) {
              mark(startMarkName);
            }
          }
          function exit() {
            if (--enterCount === 0) {
              mark(endMarkName);
              measure(measureName, startMarkName, endMarkName);
            } else if (enterCount < 0) {
              ts2.Debug.fail("enter/exit count does not match.");
            }
          }
        }
        performance3.createTimer = createTimer;
        performance3.nullTimer = { enter: ts2.noop, exit: ts2.noop };
        function mark(markName) {
          if (enabled) {
            marks.set(markName, ts2.timestamp());
            counts.set(markName, (counts.get(markName) || 0) + 1);
            profilerEvent(markName);
          }
        }
        performance3.mark = mark;
        function measure(measureName, startMarkName, endMarkName) {
          if (enabled) {
            var end = endMarkName && marks.get(endMarkName) || ts2.timestamp();
            var start = startMarkName && marks.get(startMarkName) || profilerStart;
            measures.set(measureName, (measures.get(measureName) || 0) + (end - start));
          }
        }
        performance3.measure = measure;
        function getCount(markName) {
          return counts && counts.get(markName) || 0;
        }
        performance3.getCount = getCount;
        function getDuration(measureName) {
          return measures && measures.get(measureName) || 0;
        }
        performance3.getDuration = getDuration;
        function forEachMeasure(cb) {
          measures.forEach(function(measure2, key) {
            cb(key, measure2);
          });
        }
        performance3.forEachMeasure = forEachMeasure;
        function enable() {
          counts = ts2.createMap();
          marks = ts2.createMap();
          measures = ts2.createMap();
          enabled = true;
          profilerStart = ts2.timestamp();
        }
        performance3.enable = enable;
        function disable() {
          enabled = false;
        }
        performance3.disable = disable;
      })(performance2 = ts2.performance || (ts2.performance = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var _a;
      var nullLogger = {
        logEvent: ts2.noop,
        logErrEvent: ts2.noop,
        logPerfEvent: ts2.noop,
        logInfoEvent: ts2.noop,
        logStartCommand: ts2.noop,
        logStopCommand: ts2.noop,
        logStartUpdateProgram: ts2.noop,
        logStopUpdateProgram: ts2.noop,
        logStartUpdateGraph: ts2.noop,
        logStopUpdateGraph: ts2.noop,
        logStartResolveModule: ts2.noop,
        logStopResolveModule: ts2.noop,
        logStartParseSourceFile: ts2.noop,
        logStopParseSourceFile: ts2.noop,
        logStartReadFile: ts2.noop,
        logStopReadFile: ts2.noop,
        logStartBindFile: ts2.noop,
        logStopBindFile: ts2.noop,
        logStartScheduledOperation: ts2.noop,
        logStopScheduledOperation: ts2.noop
      };
      var etwModule;
      try {
        var etwModulePath = (_a = process.env.TS_ETW_MODULE_PATH) !== null && _a !== void 0 ? _a : "./node_modules/@microsoft/typescript-etw";
        etwModule = require(etwModulePath);
      } catch (e) {
        etwModule = void 0;
      }
      ts2.perfLogger = etwModule && etwModule.logEvent ? etwModule : nullLogger;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var versionRegExp = /^(0|[1-9]\d*)(?:\.(0|[1-9]\d*)(?:\.(0|[1-9]\d*)(?:\-([a-z0-9-.]+))?(?:\+([a-z0-9-.]+))?)?)?$/i;
      var prereleaseRegExp = /^(?:0|[1-9]\d*|[a-z-][a-z0-9-]*)(?:\.(?:0|[1-9]\d*|[a-z-][a-z0-9-]*))*$/i;
      var buildRegExp = /^[a-z0-9-]+(?:\.[a-z0-9-]+)*$/i;
      var numericIdentifierRegExp = /^(0|[1-9]\d*)$/;
      var Version = function() {
        function Version2(major, minor, patch, prerelease, build) {
          if (minor === void 0) {
            minor = 0;
          }
          if (patch === void 0) {
            patch = 0;
          }
          if (prerelease === void 0) {
            prerelease = "";
          }
          if (build === void 0) {
            build = "";
          }
          if (typeof major === "string") {
            var result = ts2.Debug.checkDefined(tryParseComponents(major), "Invalid version");
            major = result.major, minor = result.minor, patch = result.patch, prerelease = result.prerelease, build = result.build;
          }
          ts2.Debug.assert(major >= 0, "Invalid argument: major");
          ts2.Debug.assert(minor >= 0, "Invalid argument: minor");
          ts2.Debug.assert(patch >= 0, "Invalid argument: patch");
          ts2.Debug.assert(!prerelease || prereleaseRegExp.test(prerelease), "Invalid argument: prerelease");
          ts2.Debug.assert(!build || buildRegExp.test(build), "Invalid argument: build");
          this.major = major;
          this.minor = minor;
          this.patch = patch;
          this.prerelease = prerelease ? prerelease.split(".") : ts2.emptyArray;
          this.build = build ? build.split(".") : ts2.emptyArray;
        }
        Version2.tryParse = function(text) {
          var result = tryParseComponents(text);
          if (!result)
            return void 0;
          var major = result.major, minor = result.minor, patch = result.patch, prerelease = result.prerelease, build = result.build;
          return new Version2(major, minor, patch, prerelease, build);
        };
        Version2.prototype.compareTo = function(other) {
          if (this === other)
            return 0;
          if (other === void 0)
            return 1;
          return ts2.compareValues(this.major, other.major) || ts2.compareValues(this.minor, other.minor) || ts2.compareValues(this.patch, other.patch) || comparePrerelaseIdentifiers(this.prerelease, other.prerelease);
        };
        Version2.prototype.increment = function(field) {
          switch (field) {
            case "major":
              return new Version2(this.major + 1, 0, 0);
            case "minor":
              return new Version2(this.major, this.minor + 1, 0);
            case "patch":
              return new Version2(this.major, this.minor, this.patch + 1);
            default:
              return ts2.Debug.assertNever(field);
          }
        };
        Version2.prototype.toString = function() {
          var result = this.major + "." + this.minor + "." + this.patch;
          if (ts2.some(this.prerelease))
            result += "-" + this.prerelease.join(".");
          if (ts2.some(this.build))
            result += "+" + this.build.join(".");
          return result;
        };
        Version2.zero = new Version2(0, 0, 0);
        return Version2;
      }();
      ts2.Version = Version;
      function tryParseComponents(text) {
        var match = versionRegExp.exec(text);
        if (!match)
          return void 0;
        var major = match[1], _a = match[2], minor = _a === void 0 ? "0" : _a, _b = match[3], patch = _b === void 0 ? "0" : _b, _c = match[4], prerelease = _c === void 0 ? "" : _c, _d = match[5], build = _d === void 0 ? "" : _d;
        if (prerelease && !prereleaseRegExp.test(prerelease))
          return void 0;
        if (build && !buildRegExp.test(build))
          return void 0;
        return {
          major: parseInt(major, 10),
          minor: parseInt(minor, 10),
          patch: parseInt(patch, 10),
          prerelease,
          build
        };
      }
      function comparePrerelaseIdentifiers(left, right) {
        if (left === right)
          return 0;
        if (left.length === 0)
          return right.length === 0 ? 0 : 1;
        if (right.length === 0)
          return -1;
        var length = Math.min(left.length, right.length);
        for (var i = 0; i < length; i++) {
          var leftIdentifier = left[i];
          var rightIdentifier = right[i];
          if (leftIdentifier === rightIdentifier)
            continue;
          var leftIsNumeric = numericIdentifierRegExp.test(leftIdentifier);
          var rightIsNumeric = numericIdentifierRegExp.test(rightIdentifier);
          if (leftIsNumeric || rightIsNumeric) {
            if (leftIsNumeric !== rightIsNumeric)
              return leftIsNumeric ? -1 : 1;
            var result = ts2.compareValues(+leftIdentifier, +rightIdentifier);
            if (result)
              return result;
          } else {
            var result = ts2.compareStringsCaseSensitive(leftIdentifier, rightIdentifier);
            if (result)
              return result;
          }
        }
        return ts2.compareValues(left.length, right.length);
      }
      var VersionRange = function() {
        function VersionRange2(spec) {
          this._alternatives = spec ? ts2.Debug.checkDefined(parseRange(spec), "Invalid range spec.") : ts2.emptyArray;
        }
        VersionRange2.tryParse = function(text) {
          var sets = parseRange(text);
          if (sets) {
            var range = new VersionRange2("");
            range._alternatives = sets;
            return range;
          }
          return void 0;
        };
        VersionRange2.prototype.test = function(version) {
          if (typeof version === "string")
            version = new Version(version);
          return testDisjunction(version, this._alternatives);
        };
        VersionRange2.prototype.toString = function() {
          return formatDisjunction(this._alternatives);
        };
        return VersionRange2;
      }();
      ts2.VersionRange = VersionRange;
      var logicalOrRegExp = /\s*\|\|\s*/g;
      var whitespaceRegExp = /\s+/g;
      var partialRegExp = /^([xX*0]|[1-9]\d*)(?:\.([xX*0]|[1-9]\d*)(?:\.([xX*0]|[1-9]\d*)(?:-([a-z0-9-.]+))?(?:\+([a-z0-9-.]+))?)?)?$/i;
      var hyphenRegExp = /^\s*([a-z0-9-+.*]+)\s+-\s+([a-z0-9-+.*]+)\s*$/i;
      var rangeRegExp = /^\s*(~|\^|<|<=|>|>=|=)?\s*([a-z0-9-+.*]+)$/i;
      function parseRange(text) {
        var alternatives = [];
        for (var _i = 0, _a = text.trim().split(logicalOrRegExp); _i < _a.length; _i++) {
          var range = _a[_i];
          if (!range)
            continue;
          var comparators = [];
          var match = hyphenRegExp.exec(range);
          if (match) {
            if (!parseHyphen(match[1], match[2], comparators))
              return void 0;
          } else {
            for (var _b = 0, _c = range.split(whitespaceRegExp); _b < _c.length; _b++) {
              var simple = _c[_b];
              var match_1 = rangeRegExp.exec(simple);
              if (!match_1 || !parseComparator(match_1[1], match_1[2], comparators))
                return void 0;
            }
          }
          alternatives.push(comparators);
        }
        return alternatives;
      }
      function parsePartial(text) {
        var match = partialRegExp.exec(text);
        if (!match)
          return void 0;
        var major = match[1], _a = match[2], minor = _a === void 0 ? "*" : _a, _b = match[3], patch = _b === void 0 ? "*" : _b, prerelease = match[4], build = match[5];
        var version = new Version(isWildcard(major) ? 0 : parseInt(major, 10), isWildcard(major) || isWildcard(minor) ? 0 : parseInt(minor, 10), isWildcard(major) || isWildcard(minor) || isWildcard(patch) ? 0 : parseInt(patch, 10), prerelease, build);
        return { version, major, minor, patch };
      }
      function parseHyphen(left, right, comparators) {
        var leftResult = parsePartial(left);
        if (!leftResult)
          return false;
        var rightResult = parsePartial(right);
        if (!rightResult)
          return false;
        if (!isWildcard(leftResult.major)) {
          comparators.push(createComparator(">=", leftResult.version));
        }
        if (!isWildcard(rightResult.major)) {
          comparators.push(isWildcard(rightResult.minor) ? createComparator("<", rightResult.version.increment("major")) : isWildcard(rightResult.patch) ? createComparator("<", rightResult.version.increment("minor")) : createComparator("<=", rightResult.version));
        }
        return true;
      }
      function parseComparator(operator, text, comparators) {
        var result = parsePartial(text);
        if (!result)
          return false;
        var version = result.version, major = result.major, minor = result.minor, patch = result.patch;
        if (!isWildcard(major)) {
          switch (operator) {
            case "~":
              comparators.push(createComparator(">=", version));
              comparators.push(createComparator("<", version.increment(isWildcard(minor) ? "major" : "minor")));
              break;
            case "^":
              comparators.push(createComparator(">=", version));
              comparators.push(createComparator("<", version.increment(version.major > 0 || isWildcard(minor) ? "major" : version.minor > 0 || isWildcard(patch) ? "minor" : "patch")));
              break;
            case "<":
            case ">=":
              comparators.push(createComparator(operator, version));
              break;
            case "<=":
            case ">":
              comparators.push(isWildcard(minor) ? createComparator(operator === "<=" ? "<" : ">=", version.increment("major")) : isWildcard(patch) ? createComparator(operator === "<=" ? "<" : ">=", version.increment("minor")) : createComparator(operator, version));
              break;
            case "=":
            case void 0:
              if (isWildcard(minor) || isWildcard(patch)) {
                comparators.push(createComparator(">=", version));
                comparators.push(createComparator("<", version.increment(isWildcard(minor) ? "major" : "minor")));
              } else {
                comparators.push(createComparator("=", version));
              }
              break;
            default:
              return false;
          }
        } else if (operator === "<" || operator === ">") {
          comparators.push(createComparator("<", Version.zero));
        }
        return true;
      }
      function isWildcard(part) {
        return part === "*" || part === "x" || part === "X";
      }
      function createComparator(operator, operand) {
        return { operator, operand };
      }
      function testDisjunction(version, alternatives) {
        if (alternatives.length === 0)
          return true;
        for (var _i = 0, alternatives_1 = alternatives; _i < alternatives_1.length; _i++) {
          var alternative = alternatives_1[_i];
          if (testAlternative(version, alternative))
            return true;
        }
        return false;
      }
      function testAlternative(version, comparators) {
        for (var _i = 0, comparators_1 = comparators; _i < comparators_1.length; _i++) {
          var comparator = comparators_1[_i];
          if (!testComparator(version, comparator.operator, comparator.operand))
            return false;
        }
        return true;
      }
      function testComparator(version, operator, operand) {
        var cmp = version.compareTo(operand);
        switch (operator) {
          case "<":
            return cmp < 0;
          case "<=":
            return cmp <= 0;
          case ">":
            return cmp > 0;
          case ">=":
            return cmp >= 0;
          case "=":
            return cmp === 0;
          default:
            return ts2.Debug.assertNever(operator);
        }
      }
      function formatDisjunction(alternatives) {
        return ts2.map(alternatives, formatAlternative).join(" || ") || "*";
      }
      function formatAlternative(comparators) {
        return ts2.map(comparators, formatComparator).join(" ");
      }
      function formatComparator(comparator) {
        return "" + comparator.operator + comparator.operand;
      }
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var SyntaxKind;
      (function(SyntaxKind2) {
        SyntaxKind2[SyntaxKind2["Unknown"] = 0] = "Unknown";
        SyntaxKind2[SyntaxKind2["EndOfFileToken"] = 1] = "EndOfFileToken";
        SyntaxKind2[SyntaxKind2["SingleLineCommentTrivia"] = 2] = "SingleLineCommentTrivia";
        SyntaxKind2[SyntaxKind2["MultiLineCommentTrivia"] = 3] = "MultiLineCommentTrivia";
        SyntaxKind2[SyntaxKind2["NewLineTrivia"] = 4] = "NewLineTrivia";
        SyntaxKind2[SyntaxKind2["WhitespaceTrivia"] = 5] = "WhitespaceTrivia";
        SyntaxKind2[SyntaxKind2["ShebangTrivia"] = 6] = "ShebangTrivia";
        SyntaxKind2[SyntaxKind2["ConflictMarkerTrivia"] = 7] = "ConflictMarkerTrivia";
        SyntaxKind2[SyntaxKind2["NumericLiteral"] = 8] = "NumericLiteral";
        SyntaxKind2[SyntaxKind2["BigIntLiteral"] = 9] = "BigIntLiteral";
        SyntaxKind2[SyntaxKind2["StringLiteral"] = 10] = "StringLiteral";
        SyntaxKind2[SyntaxKind2["JsxText"] = 11] = "JsxText";
        SyntaxKind2[SyntaxKind2["JsxTextAllWhiteSpaces"] = 12] = "JsxTextAllWhiteSpaces";
        SyntaxKind2[SyntaxKind2["RegularExpressionLiteral"] = 13] = "RegularExpressionLiteral";
        SyntaxKind2[SyntaxKind2["NoSubstitutionTemplateLiteral"] = 14] = "NoSubstitutionTemplateLiteral";
        SyntaxKind2[SyntaxKind2["TemplateHead"] = 15] = "TemplateHead";
        SyntaxKind2[SyntaxKind2["TemplateMiddle"] = 16] = "TemplateMiddle";
        SyntaxKind2[SyntaxKind2["TemplateTail"] = 17] = "TemplateTail";
        SyntaxKind2[SyntaxKind2["OpenBraceToken"] = 18] = "OpenBraceToken";
        SyntaxKind2[SyntaxKind2["CloseBraceToken"] = 19] = "CloseBraceToken";
        SyntaxKind2[SyntaxKind2["OpenParenToken"] = 20] = "OpenParenToken";
        SyntaxKind2[SyntaxKind2["CloseParenToken"] = 21] = "CloseParenToken";
        SyntaxKind2[SyntaxKind2["OpenBracketToken"] = 22] = "OpenBracketToken";
        SyntaxKind2[SyntaxKind2["CloseBracketToken"] = 23] = "CloseBracketToken";
        SyntaxKind2[SyntaxKind2["DotToken"] = 24] = "DotToken";
        SyntaxKind2[SyntaxKind2["DotDotDotToken"] = 25] = "DotDotDotToken";
        SyntaxKind2[SyntaxKind2["SemicolonToken"] = 26] = "SemicolonToken";
        SyntaxKind2[SyntaxKind2["CommaToken"] = 27] = "CommaToken";
        SyntaxKind2[SyntaxKind2["QuestionDotToken"] = 28] = "QuestionDotToken";
        SyntaxKind2[SyntaxKind2["LessThanToken"] = 29] = "LessThanToken";
        SyntaxKind2[SyntaxKind2["LessThanSlashToken"] = 30] = "LessThanSlashToken";
        SyntaxKind2[SyntaxKind2["GreaterThanToken"] = 31] = "GreaterThanToken";
        SyntaxKind2[SyntaxKind2["LessThanEqualsToken"] = 32] = "LessThanEqualsToken";
        SyntaxKind2[SyntaxKind2["GreaterThanEqualsToken"] = 33] = "GreaterThanEqualsToken";
        SyntaxKind2[SyntaxKind2["EqualsEqualsToken"] = 34] = "EqualsEqualsToken";
        SyntaxKind2[SyntaxKind2["ExclamationEqualsToken"] = 35] = "ExclamationEqualsToken";
        SyntaxKind2[SyntaxKind2["EqualsEqualsEqualsToken"] = 36] = "EqualsEqualsEqualsToken";
        SyntaxKind2[SyntaxKind2["ExclamationEqualsEqualsToken"] = 37] = "ExclamationEqualsEqualsToken";
        SyntaxKind2[SyntaxKind2["EqualsGreaterThanToken"] = 38] = "EqualsGreaterThanToken";
        SyntaxKind2[SyntaxKind2["PlusToken"] = 39] = "PlusToken";
        SyntaxKind2[SyntaxKind2["MinusToken"] = 40] = "MinusToken";
        SyntaxKind2[SyntaxKind2["AsteriskToken"] = 41] = "AsteriskToken";
        SyntaxKind2[SyntaxKind2["AsteriskAsteriskToken"] = 42] = "AsteriskAsteriskToken";
        SyntaxKind2[SyntaxKind2["SlashToken"] = 43] = "SlashToken";
        SyntaxKind2[SyntaxKind2["PercentToken"] = 44] = "PercentToken";
        SyntaxKind2[SyntaxKind2["PlusPlusToken"] = 45] = "PlusPlusToken";
        SyntaxKind2[SyntaxKind2["MinusMinusToken"] = 46] = "MinusMinusToken";
        SyntaxKind2[SyntaxKind2["LessThanLessThanToken"] = 47] = "LessThanLessThanToken";
        SyntaxKind2[SyntaxKind2["GreaterThanGreaterThanToken"] = 48] = "GreaterThanGreaterThanToken";
        SyntaxKind2[SyntaxKind2["GreaterThanGreaterThanGreaterThanToken"] = 49] = "GreaterThanGreaterThanGreaterThanToken";
        SyntaxKind2[SyntaxKind2["AmpersandToken"] = 50] = "AmpersandToken";
        SyntaxKind2[SyntaxKind2["BarToken"] = 51] = "BarToken";
        SyntaxKind2[SyntaxKind2["CaretToken"] = 52] = "CaretToken";
        SyntaxKind2[SyntaxKind2["ExclamationToken"] = 53] = "ExclamationToken";
        SyntaxKind2[SyntaxKind2["TildeToken"] = 54] = "TildeToken";
        SyntaxKind2[SyntaxKind2["AmpersandAmpersandToken"] = 55] = "AmpersandAmpersandToken";
        SyntaxKind2[SyntaxKind2["BarBarToken"] = 56] = "BarBarToken";
        SyntaxKind2[SyntaxKind2["QuestionToken"] = 57] = "QuestionToken";
        SyntaxKind2[SyntaxKind2["ColonToken"] = 58] = "ColonToken";
        SyntaxKind2[SyntaxKind2["AtToken"] = 59] = "AtToken";
        SyntaxKind2[SyntaxKind2["QuestionQuestionToken"] = 60] = "QuestionQuestionToken";
        SyntaxKind2[SyntaxKind2["BacktickToken"] = 61] = "BacktickToken";
        SyntaxKind2[SyntaxKind2["EqualsToken"] = 62] = "EqualsToken";
        SyntaxKind2[SyntaxKind2["PlusEqualsToken"] = 63] = "PlusEqualsToken";
        SyntaxKind2[SyntaxKind2["MinusEqualsToken"] = 64] = "MinusEqualsToken";
        SyntaxKind2[SyntaxKind2["AsteriskEqualsToken"] = 65] = "AsteriskEqualsToken";
        SyntaxKind2[SyntaxKind2["AsteriskAsteriskEqualsToken"] = 66] = "AsteriskAsteriskEqualsToken";
        SyntaxKind2[SyntaxKind2["SlashEqualsToken"] = 67] = "SlashEqualsToken";
        SyntaxKind2[SyntaxKind2["PercentEqualsToken"] = 68] = "PercentEqualsToken";
        SyntaxKind2[SyntaxKind2["LessThanLessThanEqualsToken"] = 69] = "LessThanLessThanEqualsToken";
        SyntaxKind2[SyntaxKind2["GreaterThanGreaterThanEqualsToken"] = 70] = "GreaterThanGreaterThanEqualsToken";
        SyntaxKind2[SyntaxKind2["GreaterThanGreaterThanGreaterThanEqualsToken"] = 71] = "GreaterThanGreaterThanGreaterThanEqualsToken";
        SyntaxKind2[SyntaxKind2["AmpersandEqualsToken"] = 72] = "AmpersandEqualsToken";
        SyntaxKind2[SyntaxKind2["BarEqualsToken"] = 73] = "BarEqualsToken";
        SyntaxKind2[SyntaxKind2["CaretEqualsToken"] = 74] = "CaretEqualsToken";
        SyntaxKind2[SyntaxKind2["Identifier"] = 75] = "Identifier";
        SyntaxKind2[SyntaxKind2["PrivateIdentifier"] = 76] = "PrivateIdentifier";
        SyntaxKind2[SyntaxKind2["BreakKeyword"] = 77] = "BreakKeyword";
        SyntaxKind2[SyntaxKind2["CaseKeyword"] = 78] = "CaseKeyword";
        SyntaxKind2[SyntaxKind2["CatchKeyword"] = 79] = "CatchKeyword";
        SyntaxKind2[SyntaxKind2["ClassKeyword"] = 80] = "ClassKeyword";
        SyntaxKind2[SyntaxKind2["ConstKeyword"] = 81] = "ConstKeyword";
        SyntaxKind2[SyntaxKind2["ContinueKeyword"] = 82] = "ContinueKeyword";
        SyntaxKind2[SyntaxKind2["DebuggerKeyword"] = 83] = "DebuggerKeyword";
        SyntaxKind2[SyntaxKind2["DefaultKeyword"] = 84] = "DefaultKeyword";
        SyntaxKind2[SyntaxKind2["DeleteKeyword"] = 85] = "DeleteKeyword";
        SyntaxKind2[SyntaxKind2["DoKeyword"] = 86] = "DoKeyword";
        SyntaxKind2[SyntaxKind2["ElseKeyword"] = 87] = "ElseKeyword";
        SyntaxKind2[SyntaxKind2["EnumKeyword"] = 88] = "EnumKeyword";
        SyntaxKind2[SyntaxKind2["ExportKeyword"] = 89] = "ExportKeyword";
        SyntaxKind2[SyntaxKind2["ExtendsKeyword"] = 90] = "ExtendsKeyword";
        SyntaxKind2[SyntaxKind2["FalseKeyword"] = 91] = "FalseKeyword";
        SyntaxKind2[SyntaxKind2["FinallyKeyword"] = 92] = "FinallyKeyword";
        SyntaxKind2[SyntaxKind2["ForKeyword"] = 93] = "ForKeyword";
        SyntaxKind2[SyntaxKind2["FunctionKeyword"] = 94] = "FunctionKeyword";
        SyntaxKind2[SyntaxKind2["IfKeyword"] = 95] = "IfKeyword";
        SyntaxKind2[SyntaxKind2["ImportKeyword"] = 96] = "ImportKeyword";
        SyntaxKind2[SyntaxKind2["InKeyword"] = 97] = "InKeyword";
        SyntaxKind2[SyntaxKind2["InstanceOfKeyword"] = 98] = "InstanceOfKeyword";
        SyntaxKind2[SyntaxKind2["NewKeyword"] = 99] = "NewKeyword";
        SyntaxKind2[SyntaxKind2["NullKeyword"] = 100] = "NullKeyword";
        SyntaxKind2[SyntaxKind2["ReturnKeyword"] = 101] = "ReturnKeyword";
        SyntaxKind2[SyntaxKind2["SuperKeyword"] = 102] = "SuperKeyword";
        SyntaxKind2[SyntaxKind2["SwitchKeyword"] = 103] = "SwitchKeyword";
        SyntaxKind2[SyntaxKind2["ThisKeyword"] = 104] = "ThisKeyword";
        SyntaxKind2[SyntaxKind2["ThrowKeyword"] = 105] = "ThrowKeyword";
        SyntaxKind2[SyntaxKind2["TrueKeyword"] = 106] = "TrueKeyword";
        SyntaxKind2[SyntaxKind2["TryKeyword"] = 107] = "TryKeyword";
        SyntaxKind2[SyntaxKind2["TypeOfKeyword"] = 108] = "TypeOfKeyword";
        SyntaxKind2[SyntaxKind2["VarKeyword"] = 109] = "VarKeyword";
        SyntaxKind2[SyntaxKind2["VoidKeyword"] = 110] = "VoidKeyword";
        SyntaxKind2[SyntaxKind2["WhileKeyword"] = 111] = "WhileKeyword";
        SyntaxKind2[SyntaxKind2["WithKeyword"] = 112] = "WithKeyword";
        SyntaxKind2[SyntaxKind2["ImplementsKeyword"] = 113] = "ImplementsKeyword";
        SyntaxKind2[SyntaxKind2["InterfaceKeyword"] = 114] = "InterfaceKeyword";
        SyntaxKind2[SyntaxKind2["LetKeyword"] = 115] = "LetKeyword";
        SyntaxKind2[SyntaxKind2["PackageKeyword"] = 116] = "PackageKeyword";
        SyntaxKind2[SyntaxKind2["PrivateKeyword"] = 117] = "PrivateKeyword";
        SyntaxKind2[SyntaxKind2["ProtectedKeyword"] = 118] = "ProtectedKeyword";
        SyntaxKind2[SyntaxKind2["PublicKeyword"] = 119] = "PublicKeyword";
        SyntaxKind2[SyntaxKind2["StaticKeyword"] = 120] = "StaticKeyword";
        SyntaxKind2[SyntaxKind2["YieldKeyword"] = 121] = "YieldKeyword";
        SyntaxKind2[SyntaxKind2["AbstractKeyword"] = 122] = "AbstractKeyword";
        SyntaxKind2[SyntaxKind2["AsKeyword"] = 123] = "AsKeyword";
        SyntaxKind2[SyntaxKind2["AssertsKeyword"] = 124] = "AssertsKeyword";
        SyntaxKind2[SyntaxKind2["AnyKeyword"] = 125] = "AnyKeyword";
        SyntaxKind2[SyntaxKind2["AsyncKeyword"] = 126] = "AsyncKeyword";
        SyntaxKind2[SyntaxKind2["AwaitKeyword"] = 127] = "AwaitKeyword";
        SyntaxKind2[SyntaxKind2["BooleanKeyword"] = 128] = "BooleanKeyword";
        SyntaxKind2[SyntaxKind2["ConstructorKeyword"] = 129] = "ConstructorKeyword";
        SyntaxKind2[SyntaxKind2["DeclareKeyword"] = 130] = "DeclareKeyword";
        SyntaxKind2[SyntaxKind2["GetKeyword"] = 131] = "GetKeyword";
        SyntaxKind2[SyntaxKind2["InferKeyword"] = 132] = "InferKeyword";
        SyntaxKind2[SyntaxKind2["IsKeyword"] = 133] = "IsKeyword";
        SyntaxKind2[SyntaxKind2["KeyOfKeyword"] = 134] = "KeyOfKeyword";
        SyntaxKind2[SyntaxKind2["ModuleKeyword"] = 135] = "ModuleKeyword";
        SyntaxKind2[SyntaxKind2["NamespaceKeyword"] = 136] = "NamespaceKeyword";
        SyntaxKind2[SyntaxKind2["NeverKeyword"] = 137] = "NeverKeyword";
        SyntaxKind2[SyntaxKind2["ReadonlyKeyword"] = 138] = "ReadonlyKeyword";
        SyntaxKind2[SyntaxKind2["RequireKeyword"] = 139] = "RequireKeyword";
        SyntaxKind2[SyntaxKind2["NumberKeyword"] = 140] = "NumberKeyword";
        SyntaxKind2[SyntaxKind2["ObjectKeyword"] = 141] = "ObjectKeyword";
        SyntaxKind2[SyntaxKind2["SetKeyword"] = 142] = "SetKeyword";
        SyntaxKind2[SyntaxKind2["StringKeyword"] = 143] = "StringKeyword";
        SyntaxKind2[SyntaxKind2["SymbolKeyword"] = 144] = "SymbolKeyword";
        SyntaxKind2[SyntaxKind2["TypeKeyword"] = 145] = "TypeKeyword";
        SyntaxKind2[SyntaxKind2["UndefinedKeyword"] = 146] = "UndefinedKeyword";
        SyntaxKind2[SyntaxKind2["UniqueKeyword"] = 147] = "UniqueKeyword";
        SyntaxKind2[SyntaxKind2["UnknownKeyword"] = 148] = "UnknownKeyword";
        SyntaxKind2[SyntaxKind2["FromKeyword"] = 149] = "FromKeyword";
        SyntaxKind2[SyntaxKind2["GlobalKeyword"] = 150] = "GlobalKeyword";
        SyntaxKind2[SyntaxKind2["BigIntKeyword"] = 151] = "BigIntKeyword";
        SyntaxKind2[SyntaxKind2["OfKeyword"] = 152] = "OfKeyword";
        SyntaxKind2[SyntaxKind2["QualifiedName"] = 153] = "QualifiedName";
        SyntaxKind2[SyntaxKind2["ComputedPropertyName"] = 154] = "ComputedPropertyName";
        SyntaxKind2[SyntaxKind2["TypeParameter"] = 155] = "TypeParameter";
        SyntaxKind2[SyntaxKind2["Parameter"] = 156] = "Parameter";
        SyntaxKind2[SyntaxKind2["Decorator"] = 157] = "Decorator";
        SyntaxKind2[SyntaxKind2["PropertySignature"] = 158] = "PropertySignature";
        SyntaxKind2[SyntaxKind2["PropertyDeclaration"] = 159] = "PropertyDeclaration";
        SyntaxKind2[SyntaxKind2["MethodSignature"] = 160] = "MethodSignature";
        SyntaxKind2[SyntaxKind2["MethodDeclaration"] = 161] = "MethodDeclaration";
        SyntaxKind2[SyntaxKind2["Constructor"] = 162] = "Constructor";
        SyntaxKind2[SyntaxKind2["GetAccessor"] = 163] = "GetAccessor";
        SyntaxKind2[SyntaxKind2["SetAccessor"] = 164] = "SetAccessor";
        SyntaxKind2[SyntaxKind2["CallSignature"] = 165] = "CallSignature";
        SyntaxKind2[SyntaxKind2["ConstructSignature"] = 166] = "ConstructSignature";
        SyntaxKind2[SyntaxKind2["IndexSignature"] = 167] = "IndexSignature";
        SyntaxKind2[SyntaxKind2["TypePredicate"] = 168] = "TypePredicate";
        SyntaxKind2[SyntaxKind2["TypeReference"] = 169] = "TypeReference";
        SyntaxKind2[SyntaxKind2["FunctionType"] = 170] = "FunctionType";
        SyntaxKind2[SyntaxKind2["ConstructorType"] = 171] = "ConstructorType";
        SyntaxKind2[SyntaxKind2["TypeQuery"] = 172] = "TypeQuery";
        SyntaxKind2[SyntaxKind2["TypeLiteral"] = 173] = "TypeLiteral";
        SyntaxKind2[SyntaxKind2["ArrayType"] = 174] = "ArrayType";
        SyntaxKind2[SyntaxKind2["TupleType"] = 175] = "TupleType";
        SyntaxKind2[SyntaxKind2["OptionalType"] = 176] = "OptionalType";
        SyntaxKind2[SyntaxKind2["RestType"] = 177] = "RestType";
        SyntaxKind2[SyntaxKind2["UnionType"] = 178] = "UnionType";
        SyntaxKind2[SyntaxKind2["IntersectionType"] = 179] = "IntersectionType";
        SyntaxKind2[SyntaxKind2["ConditionalType"] = 180] = "ConditionalType";
        SyntaxKind2[SyntaxKind2["InferType"] = 181] = "InferType";
        SyntaxKind2[SyntaxKind2["ParenthesizedType"] = 182] = "ParenthesizedType";
        SyntaxKind2[SyntaxKind2["ThisType"] = 183] = "ThisType";
        SyntaxKind2[SyntaxKind2["TypeOperator"] = 184] = "TypeOperator";
        SyntaxKind2[SyntaxKind2["IndexedAccessType"] = 185] = "IndexedAccessType";
        SyntaxKind2[SyntaxKind2["MappedType"] = 186] = "MappedType";
        SyntaxKind2[SyntaxKind2["LiteralType"] = 187] = "LiteralType";
        SyntaxKind2[SyntaxKind2["ImportType"] = 188] = "ImportType";
        SyntaxKind2[SyntaxKind2["ObjectBindingPattern"] = 189] = "ObjectBindingPattern";
        SyntaxKind2[SyntaxKind2["ArrayBindingPattern"] = 190] = "ArrayBindingPattern";
        SyntaxKind2[SyntaxKind2["BindingElement"] = 191] = "BindingElement";
        SyntaxKind2[SyntaxKind2["ArrayLiteralExpression"] = 192] = "ArrayLiteralExpression";
        SyntaxKind2[SyntaxKind2["ObjectLiteralExpression"] = 193] = "ObjectLiteralExpression";
        SyntaxKind2[SyntaxKind2["PropertyAccessExpression"] = 194] = "PropertyAccessExpression";
        SyntaxKind2[SyntaxKind2["ElementAccessExpression"] = 195] = "ElementAccessExpression";
        SyntaxKind2[SyntaxKind2["CallExpression"] = 196] = "CallExpression";
        SyntaxKind2[SyntaxKind2["NewExpression"] = 197] = "NewExpression";
        SyntaxKind2[SyntaxKind2["TaggedTemplateExpression"] = 198] = "TaggedTemplateExpression";
        SyntaxKind2[SyntaxKind2["TypeAssertionExpression"] = 199] = "TypeAssertionExpression";
        SyntaxKind2[SyntaxKind2["ParenthesizedExpression"] = 200] = "ParenthesizedExpression";
        SyntaxKind2[SyntaxKind2["FunctionExpression"] = 201] = "FunctionExpression";
        SyntaxKind2[SyntaxKind2["ArrowFunction"] = 202] = "ArrowFunction";
        SyntaxKind2[SyntaxKind2["DeleteExpression"] = 203] = "DeleteExpression";
        SyntaxKind2[SyntaxKind2["TypeOfExpression"] = 204] = "TypeOfExpression";
        SyntaxKind2[SyntaxKind2["VoidExpression"] = 205] = "VoidExpression";
        SyntaxKind2[SyntaxKind2["AwaitExpression"] = 206] = "AwaitExpression";
        SyntaxKind2[SyntaxKind2["PrefixUnaryExpression"] = 207] = "PrefixUnaryExpression";
        SyntaxKind2[SyntaxKind2["PostfixUnaryExpression"] = 208] = "PostfixUnaryExpression";
        SyntaxKind2[SyntaxKind2["BinaryExpression"] = 209] = "BinaryExpression";
        SyntaxKind2[SyntaxKind2["ConditionalExpression"] = 210] = "ConditionalExpression";
        SyntaxKind2[SyntaxKind2["TemplateExpression"] = 211] = "TemplateExpression";
        SyntaxKind2[SyntaxKind2["YieldExpression"] = 212] = "YieldExpression";
        SyntaxKind2[SyntaxKind2["SpreadElement"] = 213] = "SpreadElement";
        SyntaxKind2[SyntaxKind2["ClassExpression"] = 214] = "ClassExpression";
        SyntaxKind2[SyntaxKind2["OmittedExpression"] = 215] = "OmittedExpression";
        SyntaxKind2[SyntaxKind2["ExpressionWithTypeArguments"] = 216] = "ExpressionWithTypeArguments";
        SyntaxKind2[SyntaxKind2["AsExpression"] = 217] = "AsExpression";
        SyntaxKind2[SyntaxKind2["NonNullExpression"] = 218] = "NonNullExpression";
        SyntaxKind2[SyntaxKind2["MetaProperty"] = 219] = "MetaProperty";
        SyntaxKind2[SyntaxKind2["SyntheticExpression"] = 220] = "SyntheticExpression";
        SyntaxKind2[SyntaxKind2["TemplateSpan"] = 221] = "TemplateSpan";
        SyntaxKind2[SyntaxKind2["SemicolonClassElement"] = 222] = "SemicolonClassElement";
        SyntaxKind2[SyntaxKind2["Block"] = 223] = "Block";
        SyntaxKind2[SyntaxKind2["EmptyStatement"] = 224] = "EmptyStatement";
        SyntaxKind2[SyntaxKind2["VariableStatement"] = 225] = "VariableStatement";
        SyntaxKind2[SyntaxKind2["ExpressionStatement"] = 226] = "ExpressionStatement";
        SyntaxKind2[SyntaxKind2["IfStatement"] = 227] = "IfStatement";
        SyntaxKind2[SyntaxKind2["DoStatement"] = 228] = "DoStatement";
        SyntaxKind2[SyntaxKind2["WhileStatement"] = 229] = "WhileStatement";
        SyntaxKind2[SyntaxKind2["ForStatement"] = 230] = "ForStatement";
        SyntaxKind2[SyntaxKind2["ForInStatement"] = 231] = "ForInStatement";
        SyntaxKind2[SyntaxKind2["ForOfStatement"] = 232] = "ForOfStatement";
        SyntaxKind2[SyntaxKind2["ContinueStatement"] = 233] = "ContinueStatement";
        SyntaxKind2[SyntaxKind2["BreakStatement"] = 234] = "BreakStatement";
        SyntaxKind2[SyntaxKind2["ReturnStatement"] = 235] = "ReturnStatement";
        SyntaxKind2[SyntaxKind2["WithStatement"] = 236] = "WithStatement";
        SyntaxKind2[SyntaxKind2["SwitchStatement"] = 237] = "SwitchStatement";
        SyntaxKind2[SyntaxKind2["LabeledStatement"] = 238] = "LabeledStatement";
        SyntaxKind2[SyntaxKind2["ThrowStatement"] = 239] = "ThrowStatement";
        SyntaxKind2[SyntaxKind2["TryStatement"] = 240] = "TryStatement";
        SyntaxKind2[SyntaxKind2["DebuggerStatement"] = 241] = "DebuggerStatement";
        SyntaxKind2[SyntaxKind2["VariableDeclaration"] = 242] = "VariableDeclaration";
        SyntaxKind2[SyntaxKind2["VariableDeclarationList"] = 243] = "VariableDeclarationList";
        SyntaxKind2[SyntaxKind2["FunctionDeclaration"] = 244] = "FunctionDeclaration";
        SyntaxKind2[SyntaxKind2["ClassDeclaration"] = 245] = "ClassDeclaration";
        SyntaxKind2[SyntaxKind2["InterfaceDeclaration"] = 246] = "InterfaceDeclaration";
        SyntaxKind2[SyntaxKind2["TypeAliasDeclaration"] = 247] = "TypeAliasDeclaration";
        SyntaxKind2[SyntaxKind2["EnumDeclaration"] = 248] = "EnumDeclaration";
        SyntaxKind2[SyntaxKind2["ModuleDeclaration"] = 249] = "ModuleDeclaration";
        SyntaxKind2[SyntaxKind2["ModuleBlock"] = 250] = "ModuleBlock";
        SyntaxKind2[SyntaxKind2["CaseBlock"] = 251] = "CaseBlock";
        SyntaxKind2[SyntaxKind2["NamespaceExportDeclaration"] = 252] = "NamespaceExportDeclaration";
        SyntaxKind2[SyntaxKind2["ImportEqualsDeclaration"] = 253] = "ImportEqualsDeclaration";
        SyntaxKind2[SyntaxKind2["ImportDeclaration"] = 254] = "ImportDeclaration";
        SyntaxKind2[SyntaxKind2["ImportClause"] = 255] = "ImportClause";
        SyntaxKind2[SyntaxKind2["NamespaceImport"] = 256] = "NamespaceImport";
        SyntaxKind2[SyntaxKind2["NamedImports"] = 257] = "NamedImports";
        SyntaxKind2[SyntaxKind2["ImportSpecifier"] = 258] = "ImportSpecifier";
        SyntaxKind2[SyntaxKind2["ExportAssignment"] = 259] = "ExportAssignment";
        SyntaxKind2[SyntaxKind2["ExportDeclaration"] = 260] = "ExportDeclaration";
        SyntaxKind2[SyntaxKind2["NamedExports"] = 261] = "NamedExports";
        SyntaxKind2[SyntaxKind2["NamespaceExport"] = 262] = "NamespaceExport";
        SyntaxKind2[SyntaxKind2["ExportSpecifier"] = 263] = "ExportSpecifier";
        SyntaxKind2[SyntaxKind2["MissingDeclaration"] = 264] = "MissingDeclaration";
        SyntaxKind2[SyntaxKind2["ExternalModuleReference"] = 265] = "ExternalModuleReference";
        SyntaxKind2[SyntaxKind2["JsxElement"] = 266] = "JsxElement";
        SyntaxKind2[SyntaxKind2["JsxSelfClosingElement"] = 267] = "JsxSelfClosingElement";
        SyntaxKind2[SyntaxKind2["JsxOpeningElement"] = 268] = "JsxOpeningElement";
        SyntaxKind2[SyntaxKind2["JsxClosingElement"] = 269] = "JsxClosingElement";
        SyntaxKind2[SyntaxKind2["JsxFragment"] = 270] = "JsxFragment";
        SyntaxKind2[SyntaxKind2["JsxOpeningFragment"] = 271] = "JsxOpeningFragment";
        SyntaxKind2[SyntaxKind2["JsxClosingFragment"] = 272] = "JsxClosingFragment";
        SyntaxKind2[SyntaxKind2["JsxAttribute"] = 273] = "JsxAttribute";
        SyntaxKind2[SyntaxKind2["JsxAttributes"] = 274] = "JsxAttributes";
        SyntaxKind2[SyntaxKind2["JsxSpreadAttribute"] = 275] = "JsxSpreadAttribute";
        SyntaxKind2[SyntaxKind2["JsxExpression"] = 276] = "JsxExpression";
        SyntaxKind2[SyntaxKind2["CaseClause"] = 277] = "CaseClause";
        SyntaxKind2[SyntaxKind2["DefaultClause"] = 278] = "DefaultClause";
        SyntaxKind2[SyntaxKind2["HeritageClause"] = 279] = "HeritageClause";
        SyntaxKind2[SyntaxKind2["CatchClause"] = 280] = "CatchClause";
        SyntaxKind2[SyntaxKind2["PropertyAssignment"] = 281] = "PropertyAssignment";
        SyntaxKind2[SyntaxKind2["ShorthandPropertyAssignment"] = 282] = "ShorthandPropertyAssignment";
        SyntaxKind2[SyntaxKind2["SpreadAssignment"] = 283] = "SpreadAssignment";
        SyntaxKind2[SyntaxKind2["EnumMember"] = 284] = "EnumMember";
        SyntaxKind2[SyntaxKind2["UnparsedPrologue"] = 285] = "UnparsedPrologue";
        SyntaxKind2[SyntaxKind2["UnparsedPrepend"] = 286] = "UnparsedPrepend";
        SyntaxKind2[SyntaxKind2["UnparsedText"] = 287] = "UnparsedText";
        SyntaxKind2[SyntaxKind2["UnparsedInternalText"] = 288] = "UnparsedInternalText";
        SyntaxKind2[SyntaxKind2["UnparsedSyntheticReference"] = 289] = "UnparsedSyntheticReference";
        SyntaxKind2[SyntaxKind2["SourceFile"] = 290] = "SourceFile";
        SyntaxKind2[SyntaxKind2["Bundle"] = 291] = "Bundle";
        SyntaxKind2[SyntaxKind2["UnparsedSource"] = 292] = "UnparsedSource";
        SyntaxKind2[SyntaxKind2["InputFiles"] = 293] = "InputFiles";
        SyntaxKind2[SyntaxKind2["JSDocTypeExpression"] = 294] = "JSDocTypeExpression";
        SyntaxKind2[SyntaxKind2["JSDocAllType"] = 295] = "JSDocAllType";
        SyntaxKind2[SyntaxKind2["JSDocUnknownType"] = 296] = "JSDocUnknownType";
        SyntaxKind2[SyntaxKind2["JSDocNullableType"] = 297] = "JSDocNullableType";
        SyntaxKind2[SyntaxKind2["JSDocNonNullableType"] = 298] = "JSDocNonNullableType";
        SyntaxKind2[SyntaxKind2["JSDocOptionalType"] = 299] = "JSDocOptionalType";
        SyntaxKind2[SyntaxKind2["JSDocFunctionType"] = 300] = "JSDocFunctionType";
        SyntaxKind2[SyntaxKind2["JSDocVariadicType"] = 301] = "JSDocVariadicType";
        SyntaxKind2[SyntaxKind2["JSDocNamepathType"] = 302] = "JSDocNamepathType";
        SyntaxKind2[SyntaxKind2["JSDocComment"] = 303] = "JSDocComment";
        SyntaxKind2[SyntaxKind2["JSDocTypeLiteral"] = 304] = "JSDocTypeLiteral";
        SyntaxKind2[SyntaxKind2["JSDocSignature"] = 305] = "JSDocSignature";
        SyntaxKind2[SyntaxKind2["JSDocTag"] = 306] = "JSDocTag";
        SyntaxKind2[SyntaxKind2["JSDocAugmentsTag"] = 307] = "JSDocAugmentsTag";
        SyntaxKind2[SyntaxKind2["JSDocImplementsTag"] = 308] = "JSDocImplementsTag";
        SyntaxKind2[SyntaxKind2["JSDocAuthorTag"] = 309] = "JSDocAuthorTag";
        SyntaxKind2[SyntaxKind2["JSDocClassTag"] = 310] = "JSDocClassTag";
        SyntaxKind2[SyntaxKind2["JSDocPublicTag"] = 311] = "JSDocPublicTag";
        SyntaxKind2[SyntaxKind2["JSDocPrivateTag"] = 312] = "JSDocPrivateTag";
        SyntaxKind2[SyntaxKind2["JSDocProtectedTag"] = 313] = "JSDocProtectedTag";
        SyntaxKind2[SyntaxKind2["JSDocReadonlyTag"] = 314] = "JSDocReadonlyTag";
        SyntaxKind2[SyntaxKind2["JSDocCallbackTag"] = 315] = "JSDocCallbackTag";
        SyntaxKind2[SyntaxKind2["JSDocEnumTag"] = 316] = "JSDocEnumTag";
        SyntaxKind2[SyntaxKind2["JSDocParameterTag"] = 317] = "JSDocParameterTag";
        SyntaxKind2[SyntaxKind2["JSDocReturnTag"] = 318] = "JSDocReturnTag";
        SyntaxKind2[SyntaxKind2["JSDocThisTag"] = 319] = "JSDocThisTag";
        SyntaxKind2[SyntaxKind2["JSDocTypeTag"] = 320] = "JSDocTypeTag";
        SyntaxKind2[SyntaxKind2["JSDocTemplateTag"] = 321] = "JSDocTemplateTag";
        SyntaxKind2[SyntaxKind2["JSDocTypedefTag"] = 322] = "JSDocTypedefTag";
        SyntaxKind2[SyntaxKind2["JSDocPropertyTag"] = 323] = "JSDocPropertyTag";
        SyntaxKind2[SyntaxKind2["SyntaxList"] = 324] = "SyntaxList";
        SyntaxKind2[SyntaxKind2["NotEmittedStatement"] = 325] = "NotEmittedStatement";
        SyntaxKind2[SyntaxKind2["PartiallyEmittedExpression"] = 326] = "PartiallyEmittedExpression";
        SyntaxKind2[SyntaxKind2["CommaListExpression"] = 327] = "CommaListExpression";
        SyntaxKind2[SyntaxKind2["MergeDeclarationMarker"] = 328] = "MergeDeclarationMarker";
        SyntaxKind2[SyntaxKind2["EndOfDeclarationMarker"] = 329] = "EndOfDeclarationMarker";
        SyntaxKind2[SyntaxKind2["SyntheticReferenceExpression"] = 330] = "SyntheticReferenceExpression";
        SyntaxKind2[SyntaxKind2["Count"] = 331] = "Count";
        SyntaxKind2[SyntaxKind2["FirstAssignment"] = 62] = "FirstAssignment";
        SyntaxKind2[SyntaxKind2["LastAssignment"] = 74] = "LastAssignment";
        SyntaxKind2[SyntaxKind2["FirstCompoundAssignment"] = 63] = "FirstCompoundAssignment";
        SyntaxKind2[SyntaxKind2["LastCompoundAssignment"] = 74] = "LastCompoundAssignment";
        SyntaxKind2[SyntaxKind2["FirstReservedWord"] = 77] = "FirstReservedWord";
        SyntaxKind2[SyntaxKind2["LastReservedWord"] = 112] = "LastReservedWord";
        SyntaxKind2[SyntaxKind2["FirstKeyword"] = 77] = "FirstKeyword";
        SyntaxKind2[SyntaxKind2["LastKeyword"] = 152] = "LastKeyword";
        SyntaxKind2[SyntaxKind2["FirstFutureReservedWord"] = 113] = "FirstFutureReservedWord";
        SyntaxKind2[SyntaxKind2["LastFutureReservedWord"] = 121] = "LastFutureReservedWord";
        SyntaxKind2[SyntaxKind2["FirstTypeNode"] = 168] = "FirstTypeNode";
        SyntaxKind2[SyntaxKind2["LastTypeNode"] = 188] = "LastTypeNode";
        SyntaxKind2[SyntaxKind2["FirstPunctuation"] = 18] = "FirstPunctuation";
        SyntaxKind2[SyntaxKind2["LastPunctuation"] = 74] = "LastPunctuation";
        SyntaxKind2[SyntaxKind2["FirstToken"] = 0] = "FirstToken";
        SyntaxKind2[SyntaxKind2["LastToken"] = 152] = "LastToken";
        SyntaxKind2[SyntaxKind2["FirstTriviaToken"] = 2] = "FirstTriviaToken";
        SyntaxKind2[SyntaxKind2["LastTriviaToken"] = 7] = "LastTriviaToken";
        SyntaxKind2[SyntaxKind2["FirstLiteralToken"] = 8] = "FirstLiteralToken";
        SyntaxKind2[SyntaxKind2["LastLiteralToken"] = 14] = "LastLiteralToken";
        SyntaxKind2[SyntaxKind2["FirstTemplateToken"] = 14] = "FirstTemplateToken";
        SyntaxKind2[SyntaxKind2["LastTemplateToken"] = 17] = "LastTemplateToken";
        SyntaxKind2[SyntaxKind2["FirstBinaryOperator"] = 29] = "FirstBinaryOperator";
        SyntaxKind2[SyntaxKind2["LastBinaryOperator"] = 74] = "LastBinaryOperator";
        SyntaxKind2[SyntaxKind2["FirstStatement"] = 225] = "FirstStatement";
        SyntaxKind2[SyntaxKind2["LastStatement"] = 241] = "LastStatement";
        SyntaxKind2[SyntaxKind2["FirstNode"] = 153] = "FirstNode";
        SyntaxKind2[SyntaxKind2["FirstJSDocNode"] = 294] = "FirstJSDocNode";
        SyntaxKind2[SyntaxKind2["LastJSDocNode"] = 323] = "LastJSDocNode";
        SyntaxKind2[SyntaxKind2["FirstJSDocTagNode"] = 306] = "FirstJSDocTagNode";
        SyntaxKind2[SyntaxKind2["LastJSDocTagNode"] = 323] = "LastJSDocTagNode";
        SyntaxKind2[SyntaxKind2["FirstContextualKeyword"] = 122] = "FirstContextualKeyword";
        SyntaxKind2[SyntaxKind2["LastContextualKeyword"] = 152] = "LastContextualKeyword";
      })(SyntaxKind = ts2.SyntaxKind || (ts2.SyntaxKind = {}));
      var NodeFlags;
      (function(NodeFlags2) {
        NodeFlags2[NodeFlags2["None"] = 0] = "None";
        NodeFlags2[NodeFlags2["Let"] = 1] = "Let";
        NodeFlags2[NodeFlags2["Const"] = 2] = "Const";
        NodeFlags2[NodeFlags2["NestedNamespace"] = 4] = "NestedNamespace";
        NodeFlags2[NodeFlags2["Synthesized"] = 8] = "Synthesized";
        NodeFlags2[NodeFlags2["Namespace"] = 16] = "Namespace";
        NodeFlags2[NodeFlags2["OptionalChain"] = 32] = "OptionalChain";
        NodeFlags2[NodeFlags2["ExportContext"] = 64] = "ExportContext";
        NodeFlags2[NodeFlags2["ContainsThis"] = 128] = "ContainsThis";
        NodeFlags2[NodeFlags2["HasImplicitReturn"] = 256] = "HasImplicitReturn";
        NodeFlags2[NodeFlags2["HasExplicitReturn"] = 512] = "HasExplicitReturn";
        NodeFlags2[NodeFlags2["GlobalAugmentation"] = 1024] = "GlobalAugmentation";
        NodeFlags2[NodeFlags2["HasAsyncFunctions"] = 2048] = "HasAsyncFunctions";
        NodeFlags2[NodeFlags2["DisallowInContext"] = 4096] = "DisallowInContext";
        NodeFlags2[NodeFlags2["YieldContext"] = 8192] = "YieldContext";
        NodeFlags2[NodeFlags2["DecoratorContext"] = 16384] = "DecoratorContext";
        NodeFlags2[NodeFlags2["AwaitContext"] = 32768] = "AwaitContext";
        NodeFlags2[NodeFlags2["ThisNodeHasError"] = 65536] = "ThisNodeHasError";
        NodeFlags2[NodeFlags2["JavaScriptFile"] = 131072] = "JavaScriptFile";
        NodeFlags2[NodeFlags2["ThisNodeOrAnySubNodesHasError"] = 262144] = "ThisNodeOrAnySubNodesHasError";
        NodeFlags2[NodeFlags2["HasAggregatedChildData"] = 524288] = "HasAggregatedChildData";
        NodeFlags2[NodeFlags2["PossiblyContainsDynamicImport"] = 1048576] = "PossiblyContainsDynamicImport";
        NodeFlags2[NodeFlags2["PossiblyContainsImportMeta"] = 2097152] = "PossiblyContainsImportMeta";
        NodeFlags2[NodeFlags2["JSDoc"] = 4194304] = "JSDoc";
        NodeFlags2[NodeFlags2["Ambient"] = 8388608] = "Ambient";
        NodeFlags2[NodeFlags2["InWithStatement"] = 16777216] = "InWithStatement";
        NodeFlags2[NodeFlags2["JsonFile"] = 33554432] = "JsonFile";
        NodeFlags2[NodeFlags2["TypeCached"] = 67108864] = "TypeCached";
        NodeFlags2[NodeFlags2["BlockScoped"] = 3] = "BlockScoped";
        NodeFlags2[NodeFlags2["ReachabilityCheckFlags"] = 768] = "ReachabilityCheckFlags";
        NodeFlags2[NodeFlags2["ReachabilityAndEmitFlags"] = 2816] = "ReachabilityAndEmitFlags";
        NodeFlags2[NodeFlags2["ContextFlags"] = 25358336] = "ContextFlags";
        NodeFlags2[NodeFlags2["TypeExcludesFlags"] = 40960] = "TypeExcludesFlags";
        NodeFlags2[NodeFlags2["PermanentlySetIncrementalFlags"] = 3145728] = "PermanentlySetIncrementalFlags";
      })(NodeFlags = ts2.NodeFlags || (ts2.NodeFlags = {}));
      var ModifierFlags;
      (function(ModifierFlags2) {
        ModifierFlags2[ModifierFlags2["None"] = 0] = "None";
        ModifierFlags2[ModifierFlags2["Export"] = 1] = "Export";
        ModifierFlags2[ModifierFlags2["Ambient"] = 2] = "Ambient";
        ModifierFlags2[ModifierFlags2["Public"] = 4] = "Public";
        ModifierFlags2[ModifierFlags2["Private"] = 8] = "Private";
        ModifierFlags2[ModifierFlags2["Protected"] = 16] = "Protected";
        ModifierFlags2[ModifierFlags2["Static"] = 32] = "Static";
        ModifierFlags2[ModifierFlags2["Readonly"] = 64] = "Readonly";
        ModifierFlags2[ModifierFlags2["Abstract"] = 128] = "Abstract";
        ModifierFlags2[ModifierFlags2["Async"] = 256] = "Async";
        ModifierFlags2[ModifierFlags2["Default"] = 512] = "Default";
        ModifierFlags2[ModifierFlags2["Const"] = 2048] = "Const";
        ModifierFlags2[ModifierFlags2["HasComputedFlags"] = 536870912] = "HasComputedFlags";
        ModifierFlags2[ModifierFlags2["AccessibilityModifier"] = 28] = "AccessibilityModifier";
        ModifierFlags2[ModifierFlags2["ParameterPropertyModifier"] = 92] = "ParameterPropertyModifier";
        ModifierFlags2[ModifierFlags2["NonPublicAccessibilityModifier"] = 24] = "NonPublicAccessibilityModifier";
        ModifierFlags2[ModifierFlags2["TypeScriptModifier"] = 2270] = "TypeScriptModifier";
        ModifierFlags2[ModifierFlags2["ExportDefault"] = 513] = "ExportDefault";
        ModifierFlags2[ModifierFlags2["All"] = 3071] = "All";
      })(ModifierFlags = ts2.ModifierFlags || (ts2.ModifierFlags = {}));
      var JsxFlags;
      (function(JsxFlags2) {
        JsxFlags2[JsxFlags2["None"] = 0] = "None";
        JsxFlags2[JsxFlags2["IntrinsicNamedElement"] = 1] = "IntrinsicNamedElement";
        JsxFlags2[JsxFlags2["IntrinsicIndexedElement"] = 2] = "IntrinsicIndexedElement";
        JsxFlags2[JsxFlags2["IntrinsicElement"] = 3] = "IntrinsicElement";
      })(JsxFlags = ts2.JsxFlags || (ts2.JsxFlags = {}));
      var RelationComparisonResult;
      (function(RelationComparisonResult2) {
        RelationComparisonResult2[RelationComparisonResult2["Succeeded"] = 1] = "Succeeded";
        RelationComparisonResult2[RelationComparisonResult2["Failed"] = 2] = "Failed";
        RelationComparisonResult2[RelationComparisonResult2["Reported"] = 4] = "Reported";
        RelationComparisonResult2[RelationComparisonResult2["ReportsUnmeasurable"] = 8] = "ReportsUnmeasurable";
        RelationComparisonResult2[RelationComparisonResult2["ReportsUnreliable"] = 16] = "ReportsUnreliable";
        RelationComparisonResult2[RelationComparisonResult2["ReportsMask"] = 24] = "ReportsMask";
      })(RelationComparisonResult = ts2.RelationComparisonResult || (ts2.RelationComparisonResult = {}));
      var GeneratedIdentifierFlags;
      (function(GeneratedIdentifierFlags2) {
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["None"] = 0] = "None";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["Auto"] = 1] = "Auto";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["Loop"] = 2] = "Loop";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["Unique"] = 3] = "Unique";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["Node"] = 4] = "Node";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["KindMask"] = 7] = "KindMask";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["ReservedInNestedScopes"] = 8] = "ReservedInNestedScopes";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["Optimistic"] = 16] = "Optimistic";
        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["FileLevel"] = 32] = "FileLevel";
      })(GeneratedIdentifierFlags = ts2.GeneratedIdentifierFlags || (ts2.GeneratedIdentifierFlags = {}));
      var TokenFlags;
      (function(TokenFlags2) {
        TokenFlags2[TokenFlags2["None"] = 0] = "None";
        TokenFlags2[TokenFlags2["PrecedingLineBreak"] = 1] = "PrecedingLineBreak";
        TokenFlags2[TokenFlags2["PrecedingJSDocComment"] = 2] = "PrecedingJSDocComment";
        TokenFlags2[TokenFlags2["Unterminated"] = 4] = "Unterminated";
        TokenFlags2[TokenFlags2["ExtendedUnicodeEscape"] = 8] = "ExtendedUnicodeEscape";
        TokenFlags2[TokenFlags2["Scientific"] = 16] = "Scientific";
        TokenFlags2[TokenFlags2["Octal"] = 32] = "Octal";
        TokenFlags2[TokenFlags2["HexSpecifier"] = 64] = "HexSpecifier";
        TokenFlags2[TokenFlags2["BinarySpecifier"] = 128] = "BinarySpecifier";
        TokenFlags2[TokenFlags2["OctalSpecifier"] = 256] = "OctalSpecifier";
        TokenFlags2[TokenFlags2["ContainsSeparator"] = 512] = "ContainsSeparator";
        TokenFlags2[TokenFlags2["UnicodeEscape"] = 1024] = "UnicodeEscape";
        TokenFlags2[TokenFlags2["ContainsInvalidEscape"] = 2048] = "ContainsInvalidEscape";
        TokenFlags2[TokenFlags2["BinaryOrOctalSpecifier"] = 384] = "BinaryOrOctalSpecifier";
        TokenFlags2[TokenFlags2["NumericLiteralFlags"] = 1008] = "NumericLiteralFlags";
      })(TokenFlags = ts2.TokenFlags || (ts2.TokenFlags = {}));
      var FlowFlags;
      (function(FlowFlags2) {
        FlowFlags2[FlowFlags2["Unreachable"] = 1] = "Unreachable";
        FlowFlags2[FlowFlags2["Start"] = 2] = "Start";
        FlowFlags2[FlowFlags2["BranchLabel"] = 4] = "BranchLabel";
        FlowFlags2[FlowFlags2["LoopLabel"] = 8] = "LoopLabel";
        FlowFlags2[FlowFlags2["Assignment"] = 16] = "Assignment";
        FlowFlags2[FlowFlags2["TrueCondition"] = 32] = "TrueCondition";
        FlowFlags2[FlowFlags2["FalseCondition"] = 64] = "FalseCondition";
        FlowFlags2[FlowFlags2["SwitchClause"] = 128] = "SwitchClause";
        FlowFlags2[FlowFlags2["ArrayMutation"] = 256] = "ArrayMutation";
        FlowFlags2[FlowFlags2["Call"] = 512] = "Call";
        FlowFlags2[FlowFlags2["ReduceLabel"] = 1024] = "ReduceLabel";
        FlowFlags2[FlowFlags2["Referenced"] = 2048] = "Referenced";
        FlowFlags2[FlowFlags2["Shared"] = 4096] = "Shared";
        FlowFlags2[FlowFlags2["Label"] = 12] = "Label";
        FlowFlags2[FlowFlags2["Condition"] = 96] = "Condition";
      })(FlowFlags = ts2.FlowFlags || (ts2.FlowFlags = {}));
      var CommentDirectiveType;
      (function(CommentDirectiveType2) {
        CommentDirectiveType2[CommentDirectiveType2["ExpectError"] = 0] = "ExpectError";
        CommentDirectiveType2[CommentDirectiveType2["Ignore"] = 1] = "Ignore";
      })(CommentDirectiveType = ts2.CommentDirectiveType || (ts2.CommentDirectiveType = {}));
      var OperationCanceledException = function() {
        function OperationCanceledException2() {
        }
        return OperationCanceledException2;
      }();
      ts2.OperationCanceledException = OperationCanceledException;
      var RefFileKind;
      (function(RefFileKind2) {
        RefFileKind2[RefFileKind2["Import"] = 0] = "Import";
        RefFileKind2[RefFileKind2["ReferenceFile"] = 1] = "ReferenceFile";
        RefFileKind2[RefFileKind2["TypeReferenceDirective"] = 2] = "TypeReferenceDirective";
      })(RefFileKind = ts2.RefFileKind || (ts2.RefFileKind = {}));
      var StructureIsReused;
      (function(StructureIsReused2) {
        StructureIsReused2[StructureIsReused2["Not"] = 0] = "Not";
        StructureIsReused2[StructureIsReused2["SafeModules"] = 1] = "SafeModules";
        StructureIsReused2[StructureIsReused2["Completely"] = 2] = "Completely";
      })(StructureIsReused = ts2.StructureIsReused || (ts2.StructureIsReused = {}));
      var ExitStatus;
      (function(ExitStatus2) {
        ExitStatus2[ExitStatus2["Success"] = 0] = "Success";
        ExitStatus2[ExitStatus2["DiagnosticsPresent_OutputsSkipped"] = 1] = "DiagnosticsPresent_OutputsSkipped";
        ExitStatus2[ExitStatus2["DiagnosticsPresent_OutputsGenerated"] = 2] = "DiagnosticsPresent_OutputsGenerated";
        ExitStatus2[ExitStatus2["InvalidProject_OutputsSkipped"] = 3] = "InvalidProject_OutputsSkipped";
        ExitStatus2[ExitStatus2["ProjectReferenceCycle_OutputsSkipped"] = 4] = "ProjectReferenceCycle_OutputsSkipped";
        ExitStatus2[ExitStatus2["ProjectReferenceCycle_OutputsSkupped"] = 4] = "ProjectReferenceCycle_OutputsSkupped";
      })(ExitStatus = ts2.ExitStatus || (ts2.ExitStatus = {}));
      var UnionReduction;
      (function(UnionReduction2) {
        UnionReduction2[UnionReduction2["None"] = 0] = "None";
        UnionReduction2[UnionReduction2["Literal"] = 1] = "Literal";
        UnionReduction2[UnionReduction2["Subtype"] = 2] = "Subtype";
      })(UnionReduction = ts2.UnionReduction || (ts2.UnionReduction = {}));
      var ContextFlags;
      (function(ContextFlags2) {
        ContextFlags2[ContextFlags2["None"] = 0] = "None";
        ContextFlags2[ContextFlags2["Signature"] = 1] = "Signature";
        ContextFlags2[ContextFlags2["NoConstraints"] = 2] = "NoConstraints";
        ContextFlags2[ContextFlags2["Completions"] = 4] = "Completions";
      })(ContextFlags = ts2.ContextFlags || (ts2.ContextFlags = {}));
      var NodeBuilderFlags;
      (function(NodeBuilderFlags2) {
        NodeBuilderFlags2[NodeBuilderFlags2["None"] = 0] = "None";
        NodeBuilderFlags2[NodeBuilderFlags2["NoTruncation"] = 1] = "NoTruncation";
        NodeBuilderFlags2[NodeBuilderFlags2["WriteArrayAsGenericType"] = 2] = "WriteArrayAsGenericType";
        NodeBuilderFlags2[NodeBuilderFlags2["GenerateNamesForShadowedTypeParams"] = 4] = "GenerateNamesForShadowedTypeParams";
        NodeBuilderFlags2[NodeBuilderFlags2["UseStructuralFallback"] = 8] = "UseStructuralFallback";
        NodeBuilderFlags2[NodeBuilderFlags2["ForbidIndexedAccessSymbolReferences"] = 16] = "ForbidIndexedAccessSymbolReferences";
        NodeBuilderFlags2[NodeBuilderFlags2["WriteTypeArgumentsOfSignature"] = 32] = "WriteTypeArgumentsOfSignature";
        NodeBuilderFlags2[NodeBuilderFlags2["UseFullyQualifiedType"] = 64] = "UseFullyQualifiedType";
        NodeBuilderFlags2[NodeBuilderFlags2["UseOnlyExternalAliasing"] = 128] = "UseOnlyExternalAliasing";
        NodeBuilderFlags2[NodeBuilderFlags2["SuppressAnyReturnType"] = 256] = "SuppressAnyReturnType";
        NodeBuilderFlags2[NodeBuilderFlags2["WriteTypeParametersInQualifiedName"] = 512] = "WriteTypeParametersInQualifiedName";
        NodeBuilderFlags2[NodeBuilderFlags2["MultilineObjectLiterals"] = 1024] = "MultilineObjectLiterals";
        NodeBuilderFlags2[NodeBuilderFlags2["WriteClassExpressionAsTypeLiteral"] = 2048] = "WriteClassExpressionAsTypeLiteral";
        NodeBuilderFlags2[NodeBuilderFlags2["UseTypeOfFunction"] = 4096] = "UseTypeOfFunction";
        NodeBuilderFlags2[NodeBuilderFlags2["OmitParameterModifiers"] = 8192] = "OmitParameterModifiers";
        NodeBuilderFlags2[NodeBuilderFlags2["UseAliasDefinedOutsideCurrentScope"] = 16384] = "UseAliasDefinedOutsideCurrentScope";
        NodeBuilderFlags2[NodeBuilderFlags2["UseSingleQuotesForStringLiteralType"] = 268435456] = "UseSingleQuotesForStringLiteralType";
        NodeBuilderFlags2[NodeBuilderFlags2["NoTypeReduction"] = 536870912] = "NoTypeReduction";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowThisInObjectLiteral"] = 32768] = "AllowThisInObjectLiteral";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowQualifedNameInPlaceOfIdentifier"] = 65536] = "AllowQualifedNameInPlaceOfIdentifier";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowAnonymousIdentifier"] = 131072] = "AllowAnonymousIdentifier";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowEmptyUnionOrIntersection"] = 262144] = "AllowEmptyUnionOrIntersection";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowEmptyTuple"] = 524288] = "AllowEmptyTuple";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowUniqueESSymbolType"] = 1048576] = "AllowUniqueESSymbolType";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowEmptyIndexInfoType"] = 2097152] = "AllowEmptyIndexInfoType";
        NodeBuilderFlags2[NodeBuilderFlags2["AllowNodeModulesRelativePaths"] = 67108864] = "AllowNodeModulesRelativePaths";
        NodeBuilderFlags2[NodeBuilderFlags2["DoNotIncludeSymbolChain"] = 134217728] = "DoNotIncludeSymbolChain";
        NodeBuilderFlags2[NodeBuilderFlags2["IgnoreErrors"] = 70221824] = "IgnoreErrors";
        NodeBuilderFlags2[NodeBuilderFlags2["InObjectTypeLiteral"] = 4194304] = "InObjectTypeLiteral";
        NodeBuilderFlags2[NodeBuilderFlags2["InTypeAlias"] = 8388608] = "InTypeAlias";
        NodeBuilderFlags2[NodeBuilderFlags2["InInitialEntityName"] = 16777216] = "InInitialEntityName";
        NodeBuilderFlags2[NodeBuilderFlags2["InReverseMappedType"] = 33554432] = "InReverseMappedType";
      })(NodeBuilderFlags = ts2.NodeBuilderFlags || (ts2.NodeBuilderFlags = {}));
      var TypeFormatFlags;
      (function(TypeFormatFlags2) {
        TypeFormatFlags2[TypeFormatFlags2["None"] = 0] = "None";
        TypeFormatFlags2[TypeFormatFlags2["NoTruncation"] = 1] = "NoTruncation";
        TypeFormatFlags2[TypeFormatFlags2["WriteArrayAsGenericType"] = 2] = "WriteArrayAsGenericType";
        TypeFormatFlags2[TypeFormatFlags2["UseStructuralFallback"] = 8] = "UseStructuralFallback";
        TypeFormatFlags2[TypeFormatFlags2["WriteTypeArgumentsOfSignature"] = 32] = "WriteTypeArgumentsOfSignature";
        TypeFormatFlags2[TypeFormatFlags2["UseFullyQualifiedType"] = 64] = "UseFullyQualifiedType";
        TypeFormatFlags2[TypeFormatFlags2["SuppressAnyReturnType"] = 256] = "SuppressAnyReturnType";
        TypeFormatFlags2[TypeFormatFlags2["MultilineObjectLiterals"] = 1024] = "MultilineObjectLiterals";
        TypeFormatFlags2[TypeFormatFlags2["WriteClassExpressionAsTypeLiteral"] = 2048] = "WriteClassExpressionAsTypeLiteral";
        TypeFormatFlags2[TypeFormatFlags2["UseTypeOfFunction"] = 4096] = "UseTypeOfFunction";
        TypeFormatFlags2[TypeFormatFlags2["OmitParameterModifiers"] = 8192] = "OmitParameterModifiers";
        TypeFormatFlags2[TypeFormatFlags2["UseAliasDefinedOutsideCurrentScope"] = 16384] = "UseAliasDefinedOutsideCurrentScope";
        TypeFormatFlags2[TypeFormatFlags2["UseSingleQuotesForStringLiteralType"] = 268435456] = "UseSingleQuotesForStringLiteralType";
        TypeFormatFlags2[TypeFormatFlags2["NoTypeReduction"] = 536870912] = "NoTypeReduction";
        TypeFormatFlags2[TypeFormatFlags2["AllowUniqueESSymbolType"] = 1048576] = "AllowUniqueESSymbolType";
        TypeFormatFlags2[TypeFormatFlags2["AddUndefined"] = 131072] = "AddUndefined";
        TypeFormatFlags2[TypeFormatFlags2["WriteArrowStyleSignature"] = 262144] = "WriteArrowStyleSignature";
        TypeFormatFlags2[TypeFormatFlags2["InArrayType"] = 524288] = "InArrayType";
        TypeFormatFlags2[TypeFormatFlags2["InElementType"] = 2097152] = "InElementType";
        TypeFormatFlags2[TypeFormatFlags2["InFirstTypeArgument"] = 4194304] = "InFirstTypeArgument";
        TypeFormatFlags2[TypeFormatFlags2["InTypeAlias"] = 8388608] = "InTypeAlias";
        TypeFormatFlags2[TypeFormatFlags2["WriteOwnNameForAnyLike"] = 0] = "WriteOwnNameForAnyLike";
        TypeFormatFlags2[TypeFormatFlags2["NodeBuilderFlagsMask"] = 814775659] = "NodeBuilderFlagsMask";
      })(TypeFormatFlags = ts2.TypeFormatFlags || (ts2.TypeFormatFlags = {}));
      var SymbolFormatFlags;
      (function(SymbolFormatFlags2) {
        SymbolFormatFlags2[SymbolFormatFlags2["None"] = 0] = "None";
        SymbolFormatFlags2[SymbolFormatFlags2["WriteTypeParametersOrArguments"] = 1] = "WriteTypeParametersOrArguments";
        SymbolFormatFlags2[SymbolFormatFlags2["UseOnlyExternalAliasing"] = 2] = "UseOnlyExternalAliasing";
        SymbolFormatFlags2[SymbolFormatFlags2["AllowAnyNodeKind"] = 4] = "AllowAnyNodeKind";
        SymbolFormatFlags2[SymbolFormatFlags2["UseAliasDefinedOutsideCurrentScope"] = 8] = "UseAliasDefinedOutsideCurrentScope";
        SymbolFormatFlags2[SymbolFormatFlags2["DoNotIncludeSymbolChain"] = 16] = "DoNotIncludeSymbolChain";
      })(SymbolFormatFlags = ts2.SymbolFormatFlags || (ts2.SymbolFormatFlags = {}));
      var SymbolAccessibility;
      (function(SymbolAccessibility2) {
        SymbolAccessibility2[SymbolAccessibility2["Accessible"] = 0] = "Accessible";
        SymbolAccessibility2[SymbolAccessibility2["NotAccessible"] = 1] = "NotAccessible";
        SymbolAccessibility2[SymbolAccessibility2["CannotBeNamed"] = 2] = "CannotBeNamed";
      })(SymbolAccessibility = ts2.SymbolAccessibility || (ts2.SymbolAccessibility = {}));
      var SyntheticSymbolKind;
      (function(SyntheticSymbolKind2) {
        SyntheticSymbolKind2[SyntheticSymbolKind2["UnionOrIntersection"] = 0] = "UnionOrIntersection";
        SyntheticSymbolKind2[SyntheticSymbolKind2["Spread"] = 1] = "Spread";
      })(SyntheticSymbolKind = ts2.SyntheticSymbolKind || (ts2.SyntheticSymbolKind = {}));
      var TypePredicateKind;
      (function(TypePredicateKind2) {
        TypePredicateKind2[TypePredicateKind2["This"] = 0] = "This";
        TypePredicateKind2[TypePredicateKind2["Identifier"] = 1] = "Identifier";
        TypePredicateKind2[TypePredicateKind2["AssertsThis"] = 2] = "AssertsThis";
        TypePredicateKind2[TypePredicateKind2["AssertsIdentifier"] = 3] = "AssertsIdentifier";
      })(TypePredicateKind = ts2.TypePredicateKind || (ts2.TypePredicateKind = {}));
      var TypeReferenceSerializationKind;
      (function(TypeReferenceSerializationKind2) {
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["Unknown"] = 0] = "Unknown";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["TypeWithConstructSignatureAndValue"] = 1] = "TypeWithConstructSignatureAndValue";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["VoidNullableOrNeverType"] = 2] = "VoidNullableOrNeverType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["NumberLikeType"] = 3] = "NumberLikeType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["BigIntLikeType"] = 4] = "BigIntLikeType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["StringLikeType"] = 5] = "StringLikeType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["BooleanType"] = 6] = "BooleanType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["ArrayLikeType"] = 7] = "ArrayLikeType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["ESSymbolType"] = 8] = "ESSymbolType";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["Promise"] = 9] = "Promise";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["TypeWithCallSignature"] = 10] = "TypeWithCallSignature";
        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["ObjectType"] = 11] = "ObjectType";
      })(TypeReferenceSerializationKind = ts2.TypeReferenceSerializationKind || (ts2.TypeReferenceSerializationKind = {}));
      var SymbolFlags;
      (function(SymbolFlags2) {
        SymbolFlags2[SymbolFlags2["None"] = 0] = "None";
        SymbolFlags2[SymbolFlags2["FunctionScopedVariable"] = 1] = "FunctionScopedVariable";
        SymbolFlags2[SymbolFlags2["BlockScopedVariable"] = 2] = "BlockScopedVariable";
        SymbolFlags2[SymbolFlags2["Property"] = 4] = "Property";
        SymbolFlags2[SymbolFlags2["EnumMember"] = 8] = "EnumMember";
        SymbolFlags2[SymbolFlags2["Function"] = 16] = "Function";
        SymbolFlags2[SymbolFlags2["Class"] = 32] = "Class";
        SymbolFlags2[SymbolFlags2["Interface"] = 64] = "Interface";
        SymbolFlags2[SymbolFlags2["ConstEnum"] = 128] = "ConstEnum";
        SymbolFlags2[SymbolFlags2["RegularEnum"] = 256] = "RegularEnum";
        SymbolFlags2[SymbolFlags2["ValueModule"] = 512] = "ValueModule";
        SymbolFlags2[SymbolFlags2["NamespaceModule"] = 1024] = "NamespaceModule";
        SymbolFlags2[SymbolFlags2["TypeLiteral"] = 2048] = "TypeLiteral";
        SymbolFlags2[SymbolFlags2["ObjectLiteral"] = 4096] = "ObjectLiteral";
        SymbolFlags2[SymbolFlags2["Method"] = 8192] = "Method";
        SymbolFlags2[SymbolFlags2["Constructor"] = 16384] = "Constructor";
        SymbolFlags2[SymbolFlags2["GetAccessor"] = 32768] = "GetAccessor";
        SymbolFlags2[SymbolFlags2["SetAccessor"] = 65536] = "SetAccessor";
        SymbolFlags2[SymbolFlags2["Signature"] = 131072] = "Signature";
        SymbolFlags2[SymbolFlags2["TypeParameter"] = 262144] = "TypeParameter";
        SymbolFlags2[SymbolFlags2["TypeAlias"] = 524288] = "TypeAlias";
        SymbolFlags2[SymbolFlags2["ExportValue"] = 1048576] = "ExportValue";
        SymbolFlags2[SymbolFlags2["Alias"] = 2097152] = "Alias";
        SymbolFlags2[SymbolFlags2["Prototype"] = 4194304] = "Prototype";
        SymbolFlags2[SymbolFlags2["ExportStar"] = 8388608] = "ExportStar";
        SymbolFlags2[SymbolFlags2["Optional"] = 16777216] = "Optional";
        SymbolFlags2[SymbolFlags2["Transient"] = 33554432] = "Transient";
        SymbolFlags2[SymbolFlags2["Assignment"] = 67108864] = "Assignment";
        SymbolFlags2[SymbolFlags2["ModuleExports"] = 134217728] = "ModuleExports";
        SymbolFlags2[SymbolFlags2["All"] = 67108863] = "All";
        SymbolFlags2[SymbolFlags2["Enum"] = 384] = "Enum";
        SymbolFlags2[SymbolFlags2["Variable"] = 3] = "Variable";
        SymbolFlags2[SymbolFlags2["Value"] = 111551] = "Value";
        SymbolFlags2[SymbolFlags2["Type"] = 788968] = "Type";
        SymbolFlags2[SymbolFlags2["Namespace"] = 1920] = "Namespace";
        SymbolFlags2[SymbolFlags2["Module"] = 1536] = "Module";
        SymbolFlags2[SymbolFlags2["Accessor"] = 98304] = "Accessor";
        SymbolFlags2[SymbolFlags2["FunctionScopedVariableExcludes"] = 111550] = "FunctionScopedVariableExcludes";
        SymbolFlags2[SymbolFlags2["BlockScopedVariableExcludes"] = 111551] = "BlockScopedVariableExcludes";
        SymbolFlags2[SymbolFlags2["ParameterExcludes"] = 111551] = "ParameterExcludes";
        SymbolFlags2[SymbolFlags2["PropertyExcludes"] = 0] = "PropertyExcludes";
        SymbolFlags2[SymbolFlags2["EnumMemberExcludes"] = 900095] = "EnumMemberExcludes";
        SymbolFlags2[SymbolFlags2["FunctionExcludes"] = 110991] = "FunctionExcludes";
        SymbolFlags2[SymbolFlags2["ClassExcludes"] = 899503] = "ClassExcludes";
        SymbolFlags2[SymbolFlags2["InterfaceExcludes"] = 788872] = "InterfaceExcludes";
        SymbolFlags2[SymbolFlags2["RegularEnumExcludes"] = 899327] = "RegularEnumExcludes";
        SymbolFlags2[SymbolFlags2["ConstEnumExcludes"] = 899967] = "ConstEnumExcludes";
        SymbolFlags2[SymbolFlags2["ValueModuleExcludes"] = 110735] = "ValueModuleExcludes";
        SymbolFlags2[SymbolFlags2["NamespaceModuleExcludes"] = 0] = "NamespaceModuleExcludes";
        SymbolFlags2[SymbolFlags2["MethodExcludes"] = 103359] = "MethodExcludes";
        SymbolFlags2[SymbolFlags2["GetAccessorExcludes"] = 46015] = "GetAccessorExcludes";
        SymbolFlags2[SymbolFlags2["SetAccessorExcludes"] = 78783] = "SetAccessorExcludes";
        SymbolFlags2[SymbolFlags2["TypeParameterExcludes"] = 526824] = "TypeParameterExcludes";
        SymbolFlags2[SymbolFlags2["TypeAliasExcludes"] = 788968] = "TypeAliasExcludes";
        SymbolFlags2[SymbolFlags2["AliasExcludes"] = 2097152] = "AliasExcludes";
        SymbolFlags2[SymbolFlags2["ModuleMember"] = 2623475] = "ModuleMember";
        SymbolFlags2[SymbolFlags2["ExportHasLocal"] = 944] = "ExportHasLocal";
        SymbolFlags2[SymbolFlags2["BlockScoped"] = 418] = "BlockScoped";
        SymbolFlags2[SymbolFlags2["PropertyOrAccessor"] = 98308] = "PropertyOrAccessor";
        SymbolFlags2[SymbolFlags2["ClassMember"] = 106500] = "ClassMember";
        SymbolFlags2[SymbolFlags2["ExportSupportsDefaultModifier"] = 112] = "ExportSupportsDefaultModifier";
        SymbolFlags2[SymbolFlags2["ExportDoesNotSupportDefaultModifier"] = -113] = "ExportDoesNotSupportDefaultModifier";
        SymbolFlags2[SymbolFlags2["Classifiable"] = 2885600] = "Classifiable";
        SymbolFlags2[SymbolFlags2["LateBindingContainer"] = 6256] = "LateBindingContainer";
      })(SymbolFlags = ts2.SymbolFlags || (ts2.SymbolFlags = {}));
      var EnumKind;
      (function(EnumKind2) {
        EnumKind2[EnumKind2["Numeric"] = 0] = "Numeric";
        EnumKind2[EnumKind2["Literal"] = 1] = "Literal";
      })(EnumKind = ts2.EnumKind || (ts2.EnumKind = {}));
      var CheckFlags;
      (function(CheckFlags2) {
        CheckFlags2[CheckFlags2["Instantiated"] = 1] = "Instantiated";
        CheckFlags2[CheckFlags2["SyntheticProperty"] = 2] = "SyntheticProperty";
        CheckFlags2[CheckFlags2["SyntheticMethod"] = 4] = "SyntheticMethod";
        CheckFlags2[CheckFlags2["Readonly"] = 8] = "Readonly";
        CheckFlags2[CheckFlags2["ReadPartial"] = 16] = "ReadPartial";
        CheckFlags2[CheckFlags2["WritePartial"] = 32] = "WritePartial";
        CheckFlags2[CheckFlags2["HasNonUniformType"] = 64] = "HasNonUniformType";
        CheckFlags2[CheckFlags2["HasLiteralType"] = 128] = "HasLiteralType";
        CheckFlags2[CheckFlags2["ContainsPublic"] = 256] = "ContainsPublic";
        CheckFlags2[CheckFlags2["ContainsProtected"] = 512] = "ContainsProtected";
        CheckFlags2[CheckFlags2["ContainsPrivate"] = 1024] = "ContainsPrivate";
        CheckFlags2[CheckFlags2["ContainsStatic"] = 2048] = "ContainsStatic";
        CheckFlags2[CheckFlags2["Late"] = 4096] = "Late";
        CheckFlags2[CheckFlags2["ReverseMapped"] = 8192] = "ReverseMapped";
        CheckFlags2[CheckFlags2["OptionalParameter"] = 16384] = "OptionalParameter";
        CheckFlags2[CheckFlags2["RestParameter"] = 32768] = "RestParameter";
        CheckFlags2[CheckFlags2["DeferredType"] = 65536] = "DeferredType";
        CheckFlags2[CheckFlags2["HasNeverType"] = 131072] = "HasNeverType";
        CheckFlags2[CheckFlags2["Mapped"] = 262144] = "Mapped";
        CheckFlags2[CheckFlags2["StripOptional"] = 524288] = "StripOptional";
        CheckFlags2[CheckFlags2["Synthetic"] = 6] = "Synthetic";
        CheckFlags2[CheckFlags2["Discriminant"] = 192] = "Discriminant";
        CheckFlags2[CheckFlags2["Partial"] = 48] = "Partial";
      })(CheckFlags = ts2.CheckFlags || (ts2.CheckFlags = {}));
      var InternalSymbolName;
      (function(InternalSymbolName2) {
        InternalSymbolName2["Call"] = "__call";
        InternalSymbolName2["Constructor"] = "__constructor";
        InternalSymbolName2["New"] = "__new";
        InternalSymbolName2["Index"] = "__index";
        InternalSymbolName2["ExportStar"] = "__export";
        InternalSymbolName2["Global"] = "__global";
        InternalSymbolName2["Missing"] = "__missing";
        InternalSymbolName2["Type"] = "__type";
        InternalSymbolName2["Object"] = "__object";
        InternalSymbolName2["JSXAttributes"] = "__jsxAttributes";
        InternalSymbolName2["Class"] = "__class";
        InternalSymbolName2["Function"] = "__function";
        InternalSymbolName2["Computed"] = "__computed";
        InternalSymbolName2["Resolving"] = "__resolving__";
        InternalSymbolName2["ExportEquals"] = "export=";
        InternalSymbolName2["Default"] = "default";
        InternalSymbolName2["This"] = "this";
      })(InternalSymbolName = ts2.InternalSymbolName || (ts2.InternalSymbolName = {}));
      var NodeCheckFlags;
      (function(NodeCheckFlags2) {
        NodeCheckFlags2[NodeCheckFlags2["TypeChecked"] = 1] = "TypeChecked";
        NodeCheckFlags2[NodeCheckFlags2["LexicalThis"] = 2] = "LexicalThis";
        NodeCheckFlags2[NodeCheckFlags2["CaptureThis"] = 4] = "CaptureThis";
        NodeCheckFlags2[NodeCheckFlags2["CaptureNewTarget"] = 8] = "CaptureNewTarget";
        NodeCheckFlags2[NodeCheckFlags2["SuperInstance"] = 256] = "SuperInstance";
        NodeCheckFlags2[NodeCheckFlags2["SuperStatic"] = 512] = "SuperStatic";
        NodeCheckFlags2[NodeCheckFlags2["ContextChecked"] = 1024] = "ContextChecked";
        NodeCheckFlags2[NodeCheckFlags2["AsyncMethodWithSuper"] = 2048] = "AsyncMethodWithSuper";
        NodeCheckFlags2[NodeCheckFlags2["AsyncMethodWithSuperBinding"] = 4096] = "AsyncMethodWithSuperBinding";
        NodeCheckFlags2[NodeCheckFlags2["CaptureArguments"] = 8192] = "CaptureArguments";
        NodeCheckFlags2[NodeCheckFlags2["EnumValuesComputed"] = 16384] = "EnumValuesComputed";
        NodeCheckFlags2[NodeCheckFlags2["LexicalModuleMergesWithClass"] = 32768] = "LexicalModuleMergesWithClass";
        NodeCheckFlags2[NodeCheckFlags2["LoopWithCapturedBlockScopedBinding"] = 65536] = "LoopWithCapturedBlockScopedBinding";
        NodeCheckFlags2[NodeCheckFlags2["ContainsCapturedBlockScopeBinding"] = 131072] = "ContainsCapturedBlockScopeBinding";
        NodeCheckFlags2[NodeCheckFlags2["CapturedBlockScopedBinding"] = 262144] = "CapturedBlockScopedBinding";
        NodeCheckFlags2[NodeCheckFlags2["BlockScopedBindingInLoop"] = 524288] = "BlockScopedBindingInLoop";
        NodeCheckFlags2[NodeCheckFlags2["ClassWithBodyScopedClassBinding"] = 1048576] = "ClassWithBodyScopedClassBinding";
        NodeCheckFlags2[NodeCheckFlags2["BodyScopedClassBinding"] = 2097152] = "BodyScopedClassBinding";
        NodeCheckFlags2[NodeCheckFlags2["NeedsLoopOutParameter"] = 4194304] = "NeedsLoopOutParameter";
        NodeCheckFlags2[NodeCheckFlags2["AssignmentsMarked"] = 8388608] = "AssignmentsMarked";
        NodeCheckFlags2[NodeCheckFlags2["ClassWithConstructorReference"] = 16777216] = "ClassWithConstructorReference";
        NodeCheckFlags2[NodeCheckFlags2["ConstructorReferenceInClass"] = 33554432] = "ConstructorReferenceInClass";
        NodeCheckFlags2[NodeCheckFlags2["ContainsClassWithPrivateIdentifiers"] = 67108864] = "ContainsClassWithPrivateIdentifiers";
      })(NodeCheckFlags = ts2.NodeCheckFlags || (ts2.NodeCheckFlags = {}));
      var TypeFlags;
      (function(TypeFlags2) {
        TypeFlags2[TypeFlags2["Any"] = 1] = "Any";
        TypeFlags2[TypeFlags2["Unknown"] = 2] = "Unknown";
        TypeFlags2[TypeFlags2["String"] = 4] = "String";
        TypeFlags2[TypeFlags2["Number"] = 8] = "Number";
        TypeFlags2[TypeFlags2["Boolean"] = 16] = "Boolean";
        TypeFlags2[TypeFlags2["Enum"] = 32] = "Enum";
        TypeFlags2[TypeFlags2["BigInt"] = 64] = "BigInt";
        TypeFlags2[TypeFlags2["StringLiteral"] = 128] = "StringLiteral";
        TypeFlags2[TypeFlags2["NumberLiteral"] = 256] = "NumberLiteral";
        TypeFlags2[TypeFlags2["BooleanLiteral"] = 512] = "BooleanLiteral";
        TypeFlags2[TypeFlags2["EnumLiteral"] = 1024] = "EnumLiteral";
        TypeFlags2[TypeFlags2["BigIntLiteral"] = 2048] = "BigIntLiteral";
        TypeFlags2[TypeFlags2["ESSymbol"] = 4096] = "ESSymbol";
        TypeFlags2[TypeFlags2["UniqueESSymbol"] = 8192] = "UniqueESSymbol";
        TypeFlags2[TypeFlags2["Void"] = 16384] = "Void";
        TypeFlags2[TypeFlags2["Undefined"] = 32768] = "Undefined";
        TypeFlags2[TypeFlags2["Null"] = 65536] = "Null";
        TypeFlags2[TypeFlags2["Never"] = 131072] = "Never";
        TypeFlags2[TypeFlags2["TypeParameter"] = 262144] = "TypeParameter";
        TypeFlags2[TypeFlags2["Object"] = 524288] = "Object";
        TypeFlags2[TypeFlags2["Union"] = 1048576] = "Union";
        TypeFlags2[TypeFlags2["Intersection"] = 2097152] = "Intersection";
        TypeFlags2[TypeFlags2["Index"] = 4194304] = "Index";
        TypeFlags2[TypeFlags2["IndexedAccess"] = 8388608] = "IndexedAccess";
        TypeFlags2[TypeFlags2["Conditional"] = 16777216] = "Conditional";
        TypeFlags2[TypeFlags2["Substitution"] = 33554432] = "Substitution";
        TypeFlags2[TypeFlags2["NonPrimitive"] = 67108864] = "NonPrimitive";
        TypeFlags2[TypeFlags2["AnyOrUnknown"] = 3] = "AnyOrUnknown";
        TypeFlags2[TypeFlags2["Nullable"] = 98304] = "Nullable";
        TypeFlags2[TypeFlags2["Literal"] = 2944] = "Literal";
        TypeFlags2[TypeFlags2["Unit"] = 109440] = "Unit";
        TypeFlags2[TypeFlags2["StringOrNumberLiteral"] = 384] = "StringOrNumberLiteral";
        TypeFlags2[TypeFlags2["StringOrNumberLiteralOrUnique"] = 8576] = "StringOrNumberLiteralOrUnique";
        TypeFlags2[TypeFlags2["DefinitelyFalsy"] = 117632] = "DefinitelyFalsy";
        TypeFlags2[TypeFlags2["PossiblyFalsy"] = 117724] = "PossiblyFalsy";
        TypeFlags2[TypeFlags2["Intrinsic"] = 67359327] = "Intrinsic";
        TypeFlags2[TypeFlags2["Primitive"] = 131068] = "Primitive";
        TypeFlags2[TypeFlags2["StringLike"] = 132] = "StringLike";
        TypeFlags2[TypeFlags2["NumberLike"] = 296] = "NumberLike";
        TypeFlags2[TypeFlags2["BigIntLike"] = 2112] = "BigIntLike";
        TypeFlags2[TypeFlags2["BooleanLike"] = 528] = "BooleanLike";
        TypeFlags2[TypeFlags2["EnumLike"] = 1056] = "EnumLike";
        TypeFlags2[TypeFlags2["ESSymbolLike"] = 12288] = "ESSymbolLike";
        TypeFlags2[TypeFlags2["VoidLike"] = 49152] = "VoidLike";
        TypeFlags2[TypeFlags2["DisjointDomains"] = 67238908] = "DisjointDomains";
        TypeFlags2[TypeFlags2["UnionOrIntersection"] = 3145728] = "UnionOrIntersection";
        TypeFlags2[TypeFlags2["StructuredType"] = 3670016] = "StructuredType";
        TypeFlags2[TypeFlags2["TypeVariable"] = 8650752] = "TypeVariable";
        TypeFlags2[TypeFlags2["InstantiableNonPrimitive"] = 58982400] = "InstantiableNonPrimitive";
        TypeFlags2[TypeFlags2["InstantiablePrimitive"] = 4194304] = "InstantiablePrimitive";
        TypeFlags2[TypeFlags2["Instantiable"] = 63176704] = "Instantiable";
        TypeFlags2[TypeFlags2["StructuredOrInstantiable"] = 66846720] = "StructuredOrInstantiable";
        TypeFlags2[TypeFlags2["ObjectFlagsType"] = 3899393] = "ObjectFlagsType";
        TypeFlags2[TypeFlags2["Simplifiable"] = 25165824] = "Simplifiable";
        TypeFlags2[TypeFlags2["Substructure"] = 66584576] = "Substructure";
        TypeFlags2[TypeFlags2["Narrowable"] = 133970943] = "Narrowable";
        TypeFlags2[TypeFlags2["NotUnionOrUnit"] = 67637251] = "NotUnionOrUnit";
        TypeFlags2[TypeFlags2["NotPrimitiveUnion"] = 66994211] = "NotPrimitiveUnion";
        TypeFlags2[TypeFlags2["IncludesMask"] = 71041023] = "IncludesMask";
        TypeFlags2[TypeFlags2["IncludesStructuredOrInstantiable"] = 262144] = "IncludesStructuredOrInstantiable";
        TypeFlags2[TypeFlags2["IncludesNonWideningType"] = 4194304] = "IncludesNonWideningType";
        TypeFlags2[TypeFlags2["IncludesWildcard"] = 8388608] = "IncludesWildcard";
        TypeFlags2[TypeFlags2["IncludesEmptyObject"] = 16777216] = "IncludesEmptyObject";
      })(TypeFlags = ts2.TypeFlags || (ts2.TypeFlags = {}));
      var ObjectFlags;
      (function(ObjectFlags2) {
        ObjectFlags2[ObjectFlags2["Class"] = 1] = "Class";
        ObjectFlags2[ObjectFlags2["Interface"] = 2] = "Interface";
        ObjectFlags2[ObjectFlags2["Reference"] = 4] = "Reference";
        ObjectFlags2[ObjectFlags2["Tuple"] = 8] = "Tuple";
        ObjectFlags2[ObjectFlags2["Anonymous"] = 16] = "Anonymous";
        ObjectFlags2[ObjectFlags2["Mapped"] = 32] = "Mapped";
        ObjectFlags2[ObjectFlags2["Instantiated"] = 64] = "Instantiated";
        ObjectFlags2[ObjectFlags2["ObjectLiteral"] = 128] = "ObjectLiteral";
        ObjectFlags2[ObjectFlags2["EvolvingArray"] = 256] = "EvolvingArray";
        ObjectFlags2[ObjectFlags2["ObjectLiteralPatternWithComputedProperties"] = 512] = "ObjectLiteralPatternWithComputedProperties";
        ObjectFlags2[ObjectFlags2["ContainsSpread"] = 1024] = "ContainsSpread";
        ObjectFlags2[ObjectFlags2["ReverseMapped"] = 2048] = "ReverseMapped";
        ObjectFlags2[ObjectFlags2["JsxAttributes"] = 4096] = "JsxAttributes";
        ObjectFlags2[ObjectFlags2["MarkerType"] = 8192] = "MarkerType";
        ObjectFlags2[ObjectFlags2["JSLiteral"] = 16384] = "JSLiteral";
        ObjectFlags2[ObjectFlags2["FreshLiteral"] = 32768] = "FreshLiteral";
        ObjectFlags2[ObjectFlags2["ArrayLiteral"] = 65536] = "ArrayLiteral";
        ObjectFlags2[ObjectFlags2["ObjectRestType"] = 131072] = "ObjectRestType";
        ObjectFlags2[ObjectFlags2["PrimitiveUnion"] = 262144] = "PrimitiveUnion";
        ObjectFlags2[ObjectFlags2["ContainsWideningType"] = 524288] = "ContainsWideningType";
        ObjectFlags2[ObjectFlags2["ContainsObjectOrArrayLiteral"] = 1048576] = "ContainsObjectOrArrayLiteral";
        ObjectFlags2[ObjectFlags2["NonInferrableType"] = 2097152] = "NonInferrableType";
        ObjectFlags2[ObjectFlags2["IsGenericObjectTypeComputed"] = 4194304] = "IsGenericObjectTypeComputed";
        ObjectFlags2[ObjectFlags2["IsGenericObjectType"] = 8388608] = "IsGenericObjectType";
        ObjectFlags2[ObjectFlags2["IsGenericIndexTypeComputed"] = 16777216] = "IsGenericIndexTypeComputed";
        ObjectFlags2[ObjectFlags2["IsGenericIndexType"] = 33554432] = "IsGenericIndexType";
        ObjectFlags2[ObjectFlags2["CouldContainTypeVariablesComputed"] = 67108864] = "CouldContainTypeVariablesComputed";
        ObjectFlags2[ObjectFlags2["CouldContainTypeVariables"] = 134217728] = "CouldContainTypeVariables";
        ObjectFlags2[ObjectFlags2["ContainsIntersections"] = 268435456] = "ContainsIntersections";
        ObjectFlags2[ObjectFlags2["IsNeverIntersectionComputed"] = 268435456] = "IsNeverIntersectionComputed";
        ObjectFlags2[ObjectFlags2["IsNeverIntersection"] = 536870912] = "IsNeverIntersection";
        ObjectFlags2[ObjectFlags2["ClassOrInterface"] = 3] = "ClassOrInterface";
        ObjectFlags2[ObjectFlags2["RequiresWidening"] = 1572864] = "RequiresWidening";
        ObjectFlags2[ObjectFlags2["PropagatingFlags"] = 3670016] = "PropagatingFlags";
      })(ObjectFlags = ts2.ObjectFlags || (ts2.ObjectFlags = {}));
      var VarianceFlags;
      (function(VarianceFlags2) {
        VarianceFlags2[VarianceFlags2["Invariant"] = 0] = "Invariant";
        VarianceFlags2[VarianceFlags2["Covariant"] = 1] = "Covariant";
        VarianceFlags2[VarianceFlags2["Contravariant"] = 2] = "Contravariant";
        VarianceFlags2[VarianceFlags2["Bivariant"] = 3] = "Bivariant";
        VarianceFlags2[VarianceFlags2["Independent"] = 4] = "Independent";
        VarianceFlags2[VarianceFlags2["VarianceMask"] = 7] = "VarianceMask";
        VarianceFlags2[VarianceFlags2["Unmeasurable"] = 8] = "Unmeasurable";
        VarianceFlags2[VarianceFlags2["Unreliable"] = 16] = "Unreliable";
        VarianceFlags2[VarianceFlags2["AllowsStructuralFallback"] = 24] = "AllowsStructuralFallback";
      })(VarianceFlags = ts2.VarianceFlags || (ts2.VarianceFlags = {}));
      var JsxReferenceKind;
      (function(JsxReferenceKind2) {
        JsxReferenceKind2[JsxReferenceKind2["Component"] = 0] = "Component";
        JsxReferenceKind2[JsxReferenceKind2["Function"] = 1] = "Function";
        JsxReferenceKind2[JsxReferenceKind2["Mixed"] = 2] = "Mixed";
      })(JsxReferenceKind = ts2.JsxReferenceKind || (ts2.JsxReferenceKind = {}));
      var SignatureKind;
      (function(SignatureKind2) {
        SignatureKind2[SignatureKind2["Call"] = 0] = "Call";
        SignatureKind2[SignatureKind2["Construct"] = 1] = "Construct";
      })(SignatureKind = ts2.SignatureKind || (ts2.SignatureKind = {}));
      var SignatureFlags;
      (function(SignatureFlags2) {
        SignatureFlags2[SignatureFlags2["None"] = 0] = "None";
        SignatureFlags2[SignatureFlags2["HasRestParameter"] = 1] = "HasRestParameter";
        SignatureFlags2[SignatureFlags2["HasLiteralTypes"] = 2] = "HasLiteralTypes";
        SignatureFlags2[SignatureFlags2["IsInnerCallChain"] = 4] = "IsInnerCallChain";
        SignatureFlags2[SignatureFlags2["IsOuterCallChain"] = 8] = "IsOuterCallChain";
        SignatureFlags2[SignatureFlags2["IsUntypedSignatureInJSFile"] = 16] = "IsUntypedSignatureInJSFile";
        SignatureFlags2[SignatureFlags2["PropagatingFlags"] = 3] = "PropagatingFlags";
        SignatureFlags2[SignatureFlags2["CallChainFlags"] = 12] = "CallChainFlags";
      })(SignatureFlags = ts2.SignatureFlags || (ts2.SignatureFlags = {}));
      var IndexKind;
      (function(IndexKind2) {
        IndexKind2[IndexKind2["String"] = 0] = "String";
        IndexKind2[IndexKind2["Number"] = 1] = "Number";
      })(IndexKind = ts2.IndexKind || (ts2.IndexKind = {}));
      var TypeMapKind;
      (function(TypeMapKind2) {
        TypeMapKind2[TypeMapKind2["Simple"] = 0] = "Simple";
        TypeMapKind2[TypeMapKind2["Array"] = 1] = "Array";
        TypeMapKind2[TypeMapKind2["Function"] = 2] = "Function";
        TypeMapKind2[TypeMapKind2["Composite"] = 3] = "Composite";
        TypeMapKind2[TypeMapKind2["Merged"] = 4] = "Merged";
      })(TypeMapKind = ts2.TypeMapKind || (ts2.TypeMapKind = {}));
      var InferencePriority;
      (function(InferencePriority2) {
        InferencePriority2[InferencePriority2["NakedTypeVariable"] = 1] = "NakedTypeVariable";
        InferencePriority2[InferencePriority2["HomomorphicMappedType"] = 2] = "HomomorphicMappedType";
        InferencePriority2[InferencePriority2["PartialHomomorphicMappedType"] = 4] = "PartialHomomorphicMappedType";
        InferencePriority2[InferencePriority2["MappedTypeConstraint"] = 8] = "MappedTypeConstraint";
        InferencePriority2[InferencePriority2["ContravariantConditional"] = 16] = "ContravariantConditional";
        InferencePriority2[InferencePriority2["ReturnType"] = 32] = "ReturnType";
        InferencePriority2[InferencePriority2["LiteralKeyof"] = 64] = "LiteralKeyof";
        InferencePriority2[InferencePriority2["NoConstraints"] = 128] = "NoConstraints";
        InferencePriority2[InferencePriority2["AlwaysStrict"] = 256] = "AlwaysStrict";
        InferencePriority2[InferencePriority2["MaxValue"] = 512] = "MaxValue";
        InferencePriority2[InferencePriority2["PriorityImpliesCombination"] = 104] = "PriorityImpliesCombination";
        InferencePriority2[InferencePriority2["Circularity"] = -1] = "Circularity";
      })(InferencePriority = ts2.InferencePriority || (ts2.InferencePriority = {}));
      var InferenceFlags;
      (function(InferenceFlags2) {
        InferenceFlags2[InferenceFlags2["None"] = 0] = "None";
        InferenceFlags2[InferenceFlags2["NoDefault"] = 1] = "NoDefault";
        InferenceFlags2[InferenceFlags2["AnyDefault"] = 2] = "AnyDefault";
        InferenceFlags2[InferenceFlags2["SkippedGenericFunction"] = 4] = "SkippedGenericFunction";
      })(InferenceFlags = ts2.InferenceFlags || (ts2.InferenceFlags = {}));
      var Ternary;
      (function(Ternary2) {
        Ternary2[Ternary2["False"] = 0] = "False";
        Ternary2[Ternary2["Maybe"] = 1] = "Maybe";
        Ternary2[Ternary2["True"] = -1] = "True";
      })(Ternary = ts2.Ternary || (ts2.Ternary = {}));
      var AssignmentDeclarationKind;
      (function(AssignmentDeclarationKind2) {
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["None"] = 0] = "None";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ExportsProperty"] = 1] = "ExportsProperty";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ModuleExports"] = 2] = "ModuleExports";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["PrototypeProperty"] = 3] = "PrototypeProperty";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ThisProperty"] = 4] = "ThisProperty";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["Property"] = 5] = "Property";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["Prototype"] = 6] = "Prototype";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ObjectDefinePropertyValue"] = 7] = "ObjectDefinePropertyValue";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ObjectDefinePropertyExports"] = 8] = "ObjectDefinePropertyExports";
        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ObjectDefinePrototypeProperty"] = 9] = "ObjectDefinePrototypeProperty";
      })(AssignmentDeclarationKind = ts2.AssignmentDeclarationKind || (ts2.AssignmentDeclarationKind = {}));
      var DiagnosticCategory;
      (function(DiagnosticCategory2) {
        DiagnosticCategory2[DiagnosticCategory2["Warning"] = 0] = "Warning";
        DiagnosticCategory2[DiagnosticCategory2["Error"] = 1] = "Error";
        DiagnosticCategory2[DiagnosticCategory2["Suggestion"] = 2] = "Suggestion";
        DiagnosticCategory2[DiagnosticCategory2["Message"] = 3] = "Message";
      })(DiagnosticCategory = ts2.DiagnosticCategory || (ts2.DiagnosticCategory = {}));
      function diagnosticCategoryName(d, lowerCase) {
        if (lowerCase === void 0) {
          lowerCase = true;
        }
        var name = DiagnosticCategory[d.category];
        return lowerCase ? name.toLowerCase() : name;
      }
      ts2.diagnosticCategoryName = diagnosticCategoryName;
      var ModuleResolutionKind;
      (function(ModuleResolutionKind2) {
        ModuleResolutionKind2[ModuleResolutionKind2["Classic"] = 1] = "Classic";
        ModuleResolutionKind2[ModuleResolutionKind2["NodeJs"] = 2] = "NodeJs";
      })(ModuleResolutionKind = ts2.ModuleResolutionKind || (ts2.ModuleResolutionKind = {}));
      var WatchFileKind;
      (function(WatchFileKind2) {
        WatchFileKind2[WatchFileKind2["FixedPollingInterval"] = 0] = "FixedPollingInterval";
        WatchFileKind2[WatchFileKind2["PriorityPollingInterval"] = 1] = "PriorityPollingInterval";
        WatchFileKind2[WatchFileKind2["DynamicPriorityPolling"] = 2] = "DynamicPriorityPolling";
        WatchFileKind2[WatchFileKind2["UseFsEvents"] = 3] = "UseFsEvents";
        WatchFileKind2[WatchFileKind2["UseFsEventsOnParentDirectory"] = 4] = "UseFsEventsOnParentDirectory";
      })(WatchFileKind = ts2.WatchFileKind || (ts2.WatchFileKind = {}));
      var WatchDirectoryKind;
      (function(WatchDirectoryKind2) {
        WatchDirectoryKind2[WatchDirectoryKind2["UseFsEvents"] = 0] = "UseFsEvents";
        WatchDirectoryKind2[WatchDirectoryKind2["FixedPollingInterval"] = 1] = "FixedPollingInterval";
        WatchDirectoryKind2[WatchDirectoryKind2["DynamicPriorityPolling"] = 2] = "DynamicPriorityPolling";
      })(WatchDirectoryKind = ts2.WatchDirectoryKind || (ts2.WatchDirectoryKind = {}));
      var PollingWatchKind;
      (function(PollingWatchKind2) {
        PollingWatchKind2[PollingWatchKind2["FixedInterval"] = 0] = "FixedInterval";
        PollingWatchKind2[PollingWatchKind2["PriorityInterval"] = 1] = "PriorityInterval";
        PollingWatchKind2[PollingWatchKind2["DynamicPriority"] = 2] = "DynamicPriority";
      })(PollingWatchKind = ts2.PollingWatchKind || (ts2.PollingWatchKind = {}));
      var ModuleKind;
      (function(ModuleKind2) {
        ModuleKind2[ModuleKind2["None"] = 0] = "None";
        ModuleKind2[ModuleKind2["CommonJS"] = 1] = "CommonJS";
        ModuleKind2[ModuleKind2["AMD"] = 2] = "AMD";
        ModuleKind2[ModuleKind2["UMD"] = 3] = "UMD";
        ModuleKind2[ModuleKind2["System"] = 4] = "System";
        ModuleKind2[ModuleKind2["ES2015"] = 5] = "ES2015";
        ModuleKind2[ModuleKind2["ES2020"] = 6] = "ES2020";
        ModuleKind2[ModuleKind2["ESNext"] = 99] = "ESNext";
      })(ModuleKind = ts2.ModuleKind || (ts2.ModuleKind = {}));
      var JsxEmit;
      (function(JsxEmit2) {
        JsxEmit2[JsxEmit2["None"] = 0] = "None";
        JsxEmit2[JsxEmit2["Preserve"] = 1] = "Preserve";
        JsxEmit2[JsxEmit2["React"] = 2] = "React";
        JsxEmit2[JsxEmit2["ReactNative"] = 3] = "ReactNative";
      })(JsxEmit = ts2.JsxEmit || (ts2.JsxEmit = {}));
      var ImportsNotUsedAsValues;
      (function(ImportsNotUsedAsValues2) {
        ImportsNotUsedAsValues2[ImportsNotUsedAsValues2["Remove"] = 0] = "Remove";
        ImportsNotUsedAsValues2[ImportsNotUsedAsValues2["Preserve"] = 1] = "Preserve";
        ImportsNotUsedAsValues2[ImportsNotUsedAsValues2["Error"] = 2] = "Error";
      })(ImportsNotUsedAsValues = ts2.ImportsNotUsedAsValues || (ts2.ImportsNotUsedAsValues = {}));
      var NewLineKind;
      (function(NewLineKind2) {
        NewLineKind2[NewLineKind2["CarriageReturnLineFeed"] = 0] = "CarriageReturnLineFeed";
        NewLineKind2[NewLineKind2["LineFeed"] = 1] = "LineFeed";
      })(NewLineKind = ts2.NewLineKind || (ts2.NewLineKind = {}));
      var ScriptKind;
      (function(ScriptKind2) {
        ScriptKind2[ScriptKind2["Unknown"] = 0] = "Unknown";
        ScriptKind2[ScriptKind2["JS"] = 1] = "JS";
        ScriptKind2[ScriptKind2["JSX"] = 2] = "JSX";
        ScriptKind2[ScriptKind2["TS"] = 3] = "TS";
        ScriptKind2[ScriptKind2["TSX"] = 4] = "TSX";
        ScriptKind2[ScriptKind2["External"] = 5] = "External";
        ScriptKind2[ScriptKind2["JSON"] = 6] = "JSON";
        ScriptKind2[ScriptKind2["Deferred"] = 7] = "Deferred";
      })(ScriptKind = ts2.ScriptKind || (ts2.ScriptKind = {}));
      var ScriptTarget;
      (function(ScriptTarget2) {
        ScriptTarget2[ScriptTarget2["ES3"] = 0] = "ES3";
        ScriptTarget2[ScriptTarget2["ES5"] = 1] = "ES5";
        ScriptTarget2[ScriptTarget2["ES2015"] = 2] = "ES2015";
        ScriptTarget2[ScriptTarget2["ES2016"] = 3] = "ES2016";
        ScriptTarget2[ScriptTarget2["ES2017"] = 4] = "ES2017";
        ScriptTarget2[ScriptTarget2["ES2018"] = 5] = "ES2018";
        ScriptTarget2[ScriptTarget2["ES2019"] = 6] = "ES2019";
        ScriptTarget2[ScriptTarget2["ES2020"] = 7] = "ES2020";
        ScriptTarget2[ScriptTarget2["ESNext"] = 99] = "ESNext";
        ScriptTarget2[ScriptTarget2["JSON"] = 100] = "JSON";
        ScriptTarget2[ScriptTarget2["Latest"] = 99] = "Latest";
      })(ScriptTarget = ts2.ScriptTarget || (ts2.ScriptTarget = {}));
      var LanguageVariant;
      (function(LanguageVariant2) {
        LanguageVariant2[LanguageVariant2["Standard"] = 0] = "Standard";
        LanguageVariant2[LanguageVariant2["JSX"] = 1] = "JSX";
      })(LanguageVariant = ts2.LanguageVariant || (ts2.LanguageVariant = {}));
      var WatchDirectoryFlags;
      (function(WatchDirectoryFlags2) {
        WatchDirectoryFlags2[WatchDirectoryFlags2["None"] = 0] = "None";
        WatchDirectoryFlags2[WatchDirectoryFlags2["Recursive"] = 1] = "Recursive";
      })(WatchDirectoryFlags = ts2.WatchDirectoryFlags || (ts2.WatchDirectoryFlags = {}));
      var CharacterCodes;
      (function(CharacterCodes2) {
        CharacterCodes2[CharacterCodes2["nullCharacter"] = 0] = "nullCharacter";
        CharacterCodes2[CharacterCodes2["maxAsciiCharacter"] = 127] = "maxAsciiCharacter";
        CharacterCodes2[CharacterCodes2["lineFeed"] = 10] = "lineFeed";
        CharacterCodes2[CharacterCodes2["carriageReturn"] = 13] = "carriageReturn";
        CharacterCodes2[CharacterCodes2["lineSeparator"] = 8232] = "lineSeparator";
        CharacterCodes2[CharacterCodes2["paragraphSeparator"] = 8233] = "paragraphSeparator";
        CharacterCodes2[CharacterCodes2["nextLine"] = 133] = "nextLine";
        CharacterCodes2[CharacterCodes2["space"] = 32] = "space";
        CharacterCodes2[CharacterCodes2["nonBreakingSpace"] = 160] = "nonBreakingSpace";
        CharacterCodes2[CharacterCodes2["enQuad"] = 8192] = "enQuad";
        CharacterCodes2[CharacterCodes2["emQuad"] = 8193] = "emQuad";
        CharacterCodes2[CharacterCodes2["enSpace"] = 8194] = "enSpace";
        CharacterCodes2[CharacterCodes2["emSpace"] = 8195] = "emSpace";
        CharacterCodes2[CharacterCodes2["threePerEmSpace"] = 8196] = "threePerEmSpace";
        CharacterCodes2[CharacterCodes2["fourPerEmSpace"] = 8197] = "fourPerEmSpace";
        CharacterCodes2[CharacterCodes2["sixPerEmSpace"] = 8198] = "sixPerEmSpace";
        CharacterCodes2[CharacterCodes2["figureSpace"] = 8199] = "figureSpace";
        CharacterCodes2[CharacterCodes2["punctuationSpace"] = 8200] = "punctuationSpace";
        CharacterCodes2[CharacterCodes2["thinSpace"] = 8201] = "thinSpace";
        CharacterCodes2[CharacterCodes2["hairSpace"] = 8202] = "hairSpace";
        CharacterCodes2[CharacterCodes2["zeroWidthSpace"] = 8203] = "zeroWidthSpace";
        CharacterCodes2[CharacterCodes2["narrowNoBreakSpace"] = 8239] = "narrowNoBreakSpace";
        CharacterCodes2[CharacterCodes2["ideographicSpace"] = 12288] = "ideographicSpace";
        CharacterCodes2[CharacterCodes2["mathematicalSpace"] = 8287] = "mathematicalSpace";
        CharacterCodes2[CharacterCodes2["ogham"] = 5760] = "ogham";
        CharacterCodes2[CharacterCodes2["_"] = 95] = "_";
        CharacterCodes2[CharacterCodes2["$"] = 36] = "$";
        CharacterCodes2[CharacterCodes2["_0"] = 48] = "_0";
        CharacterCodes2[CharacterCodes2["_1"] = 49] = "_1";
        CharacterCodes2[CharacterCodes2["_2"] = 50] = "_2";
        CharacterCodes2[CharacterCodes2["_3"] = 51] = "_3";
        CharacterCodes2[CharacterCodes2["_4"] = 52] = "_4";
        CharacterCodes2[CharacterCodes2["_5"] = 53] = "_5";
        CharacterCodes2[CharacterCodes2["_6"] = 54] = "_6";
        CharacterCodes2[CharacterCodes2["_7"] = 55] = "_7";
        CharacterCodes2[CharacterCodes2["_8"] = 56] = "_8";
        CharacterCodes2[CharacterCodes2["_9"] = 57] = "_9";
        CharacterCodes2[CharacterCodes2["a"] = 97] = "a";
        CharacterCodes2[CharacterCodes2["b"] = 98] = "b";
        CharacterCodes2[CharacterCodes2["c"] = 99] = "c";
        CharacterCodes2[CharacterCodes2["d"] = 100] = "d";
        CharacterCodes2[CharacterCodes2["e"] = 101] = "e";
        CharacterCodes2[CharacterCodes2["f"] = 102] = "f";
        CharacterCodes2[CharacterCodes2["g"] = 103] = "g";
        CharacterCodes2[CharacterCodes2["h"] = 104] = "h";
        CharacterCodes2[CharacterCodes2["i"] = 105] = "i";
        CharacterCodes2[CharacterCodes2["j"] = 106] = "j";
        CharacterCodes2[CharacterCodes2["k"] = 107] = "k";
        CharacterCodes2[CharacterCodes2["l"] = 108] = "l";
        CharacterCodes2[CharacterCodes2["m"] = 109] = "m";
        CharacterCodes2[CharacterCodes2["n"] = 110] = "n";
        CharacterCodes2[CharacterCodes2["o"] = 111] = "o";
        CharacterCodes2[CharacterCodes2["p"] = 112] = "p";
        CharacterCodes2[CharacterCodes2["q"] = 113] = "q";
        CharacterCodes2[CharacterCodes2["r"] = 114] = "r";
        CharacterCodes2[CharacterCodes2["s"] = 115] = "s";
        CharacterCodes2[CharacterCodes2["t"] = 116] = "t";
        CharacterCodes2[CharacterCodes2["u"] = 117] = "u";
        CharacterCodes2[CharacterCodes2["v"] = 118] = "v";
        CharacterCodes2[CharacterCodes2["w"] = 119] = "w";
        CharacterCodes2[CharacterCodes2["x"] = 120] = "x";
        CharacterCodes2[CharacterCodes2["y"] = 121] = "y";
        CharacterCodes2[CharacterCodes2["z"] = 122] = "z";
        CharacterCodes2[CharacterCodes2["A"] = 65] = "A";
        CharacterCodes2[CharacterCodes2["B"] = 66] = "B";
        CharacterCodes2[CharacterCodes2["C"] = 67] = "C";
        CharacterCodes2[CharacterCodes2["D"] = 68] = "D";
        CharacterCodes2[CharacterCodes2["E"] = 69] = "E";
        CharacterCodes2[CharacterCodes2["F"] = 70] = "F";
        CharacterCodes2[CharacterCodes2["G"] = 71] = "G";
        CharacterCodes2[CharacterCodes2["H"] = 72] = "H";
        CharacterCodes2[CharacterCodes2["I"] = 73] = "I";
        CharacterCodes2[CharacterCodes2["J"] = 74] = "J";
        CharacterCodes2[CharacterCodes2["K"] = 75] = "K";
        CharacterCodes2[CharacterCodes2["L"] = 76] = "L";
        CharacterCodes2[CharacterCodes2["M"] = 77] = "M";
        CharacterCodes2[CharacterCodes2["N"] = 78] = "N";
        CharacterCodes2[CharacterCodes2["O"] = 79] = "O";
        CharacterCodes2[CharacterCodes2["P"] = 80] = "P";
        CharacterCodes2[CharacterCodes2["Q"] = 81] = "Q";
        CharacterCodes2[CharacterCodes2["R"] = 82] = "R";
        CharacterCodes2[CharacterCodes2["S"] = 83] = "S";
        CharacterCodes2[CharacterCodes2["T"] = 84] = "T";
        CharacterCodes2[CharacterCodes2["U"] = 85] = "U";
        CharacterCodes2[CharacterCodes2["V"] = 86] = "V";
        CharacterCodes2[CharacterCodes2["W"] = 87] = "W";
        CharacterCodes2[CharacterCodes2["X"] = 88] = "X";
        CharacterCodes2[CharacterCodes2["Y"] = 89] = "Y";
        CharacterCodes2[CharacterCodes2["Z"] = 90] = "Z";
        CharacterCodes2[CharacterCodes2["ampersand"] = 38] = "ampersand";
        CharacterCodes2[CharacterCodes2["asterisk"] = 42] = "asterisk";
        CharacterCodes2[CharacterCodes2["at"] = 64] = "at";
        CharacterCodes2[CharacterCodes2["backslash"] = 92] = "backslash";
        CharacterCodes2[CharacterCodes2["backtick"] = 96] = "backtick";
        CharacterCodes2[CharacterCodes2["bar"] = 124] = "bar";
        CharacterCodes2[CharacterCodes2["caret"] = 94] = "caret";
        CharacterCodes2[CharacterCodes2["closeBrace"] = 125] = "closeBrace";
        CharacterCodes2[CharacterCodes2["closeBracket"] = 93] = "closeBracket";
        CharacterCodes2[CharacterCodes2["closeParen"] = 41] = "closeParen";
        CharacterCodes2[CharacterCodes2["colon"] = 58] = "colon";
        CharacterCodes2[CharacterCodes2["comma"] = 44] = "comma";
        CharacterCodes2[CharacterCodes2["dot"] = 46] = "dot";
        CharacterCodes2[CharacterCodes2["doubleQuote"] = 34] = "doubleQuote";
        CharacterCodes2[CharacterCodes2["equals"] = 61] = "equals";
        CharacterCodes2[CharacterCodes2["exclamation"] = 33] = "exclamation";
        CharacterCodes2[CharacterCodes2["greaterThan"] = 62] = "greaterThan";
        CharacterCodes2[CharacterCodes2["hash"] = 35] = "hash";
        CharacterCodes2[CharacterCodes2["lessThan"] = 60] = "lessThan";
        CharacterCodes2[CharacterCodes2["minus"] = 45] = "minus";
        CharacterCodes2[CharacterCodes2["openBrace"] = 123] = "openBrace";
        CharacterCodes2[CharacterCodes2["openBracket"] = 91] = "openBracket";
        CharacterCodes2[CharacterCodes2["openParen"] = 40] = "openParen";
        CharacterCodes2[CharacterCodes2["percent"] = 37] = "percent";
        CharacterCodes2[CharacterCodes2["plus"] = 43] = "plus";
        CharacterCodes2[CharacterCodes2["question"] = 63] = "question";
        CharacterCodes2[CharacterCodes2["semicolon"] = 59] = "semicolon";
        CharacterCodes2[CharacterCodes2["singleQuote"] = 39] = "singleQuote";
        CharacterCodes2[CharacterCodes2["slash"] = 47] = "slash";
        CharacterCodes2[CharacterCodes2["tilde"] = 126] = "tilde";
        CharacterCodes2[CharacterCodes2["backspace"] = 8] = "backspace";
        CharacterCodes2[CharacterCodes2["formFeed"] = 12] = "formFeed";
        CharacterCodes2[CharacterCodes2["byteOrderMark"] = 65279] = "byteOrderMark";
        CharacterCodes2[CharacterCodes2["tab"] = 9] = "tab";
        CharacterCodes2[CharacterCodes2["verticalTab"] = 11] = "verticalTab";
      })(CharacterCodes = ts2.CharacterCodes || (ts2.CharacterCodes = {}));
      var Extension;
      (function(Extension2) {
        Extension2["Ts"] = ".ts";
        Extension2["Tsx"] = ".tsx";
        Extension2["Dts"] = ".d.ts";
        Extension2["Js"] = ".js";
        Extension2["Jsx"] = ".jsx";
        Extension2["Json"] = ".json";
        Extension2["TsBuildInfo"] = ".tsbuildinfo";
      })(Extension = ts2.Extension || (ts2.Extension = {}));
      var TransformFlags;
      (function(TransformFlags2) {
        TransformFlags2[TransformFlags2["None"] = 0] = "None";
        TransformFlags2[TransformFlags2["ContainsTypeScript"] = 1] = "ContainsTypeScript";
        TransformFlags2[TransformFlags2["ContainsJsx"] = 2] = "ContainsJsx";
        TransformFlags2[TransformFlags2["ContainsESNext"] = 4] = "ContainsESNext";
        TransformFlags2[TransformFlags2["ContainsES2020"] = 8] = "ContainsES2020";
        TransformFlags2[TransformFlags2["ContainsES2019"] = 16] = "ContainsES2019";
        TransformFlags2[TransformFlags2["ContainsES2018"] = 32] = "ContainsES2018";
        TransformFlags2[TransformFlags2["ContainsES2017"] = 64] = "ContainsES2017";
        TransformFlags2[TransformFlags2["ContainsES2016"] = 128] = "ContainsES2016";
        TransformFlags2[TransformFlags2["ContainsES2015"] = 256] = "ContainsES2015";
        TransformFlags2[TransformFlags2["ContainsGenerator"] = 512] = "ContainsGenerator";
        TransformFlags2[TransformFlags2["ContainsDestructuringAssignment"] = 1024] = "ContainsDestructuringAssignment";
        TransformFlags2[TransformFlags2["ContainsTypeScriptClassSyntax"] = 2048] = "ContainsTypeScriptClassSyntax";
        TransformFlags2[TransformFlags2["ContainsLexicalThis"] = 4096] = "ContainsLexicalThis";
        TransformFlags2[TransformFlags2["ContainsRestOrSpread"] = 8192] = "ContainsRestOrSpread";
        TransformFlags2[TransformFlags2["ContainsObjectRestOrSpread"] = 16384] = "ContainsObjectRestOrSpread";
        TransformFlags2[TransformFlags2["ContainsComputedPropertyName"] = 32768] = "ContainsComputedPropertyName";
        TransformFlags2[TransformFlags2["ContainsBlockScopedBinding"] = 65536] = "ContainsBlockScopedBinding";
        TransformFlags2[TransformFlags2["ContainsBindingPattern"] = 131072] = "ContainsBindingPattern";
        TransformFlags2[TransformFlags2["ContainsYield"] = 262144] = "ContainsYield";
        TransformFlags2[TransformFlags2["ContainsAwait"] = 524288] = "ContainsAwait";
        TransformFlags2[TransformFlags2["ContainsHoistedDeclarationOrCompletion"] = 1048576] = "ContainsHoistedDeclarationOrCompletion";
        TransformFlags2[TransformFlags2["ContainsDynamicImport"] = 2097152] = "ContainsDynamicImport";
        TransformFlags2[TransformFlags2["ContainsClassFields"] = 4194304] = "ContainsClassFields";
        TransformFlags2[TransformFlags2["HasComputedFlags"] = 536870912] = "HasComputedFlags";
        TransformFlags2[TransformFlags2["AssertTypeScript"] = 1] = "AssertTypeScript";
        TransformFlags2[TransformFlags2["AssertJsx"] = 2] = "AssertJsx";
        TransformFlags2[TransformFlags2["AssertESNext"] = 4] = "AssertESNext";
        TransformFlags2[TransformFlags2["AssertES2020"] = 8] = "AssertES2020";
        TransformFlags2[TransformFlags2["AssertES2019"] = 16] = "AssertES2019";
        TransformFlags2[TransformFlags2["AssertES2018"] = 32] = "AssertES2018";
        TransformFlags2[TransformFlags2["AssertES2017"] = 64] = "AssertES2017";
        TransformFlags2[TransformFlags2["AssertES2016"] = 128] = "AssertES2016";
        TransformFlags2[TransformFlags2["AssertES2015"] = 256] = "AssertES2015";
        TransformFlags2[TransformFlags2["AssertGenerator"] = 512] = "AssertGenerator";
        TransformFlags2[TransformFlags2["AssertDestructuringAssignment"] = 1024] = "AssertDestructuringAssignment";
        TransformFlags2[TransformFlags2["OuterExpressionExcludes"] = 536870912] = "OuterExpressionExcludes";
        TransformFlags2[TransformFlags2["PropertyAccessExcludes"] = 536870912] = "PropertyAccessExcludes";
        TransformFlags2[TransformFlags2["NodeExcludes"] = 536870912] = "NodeExcludes";
        TransformFlags2[TransformFlags2["ArrowFunctionExcludes"] = 538920960] = "ArrowFunctionExcludes";
        TransformFlags2[TransformFlags2["FunctionExcludes"] = 538925056] = "FunctionExcludes";
        TransformFlags2[TransformFlags2["ConstructorExcludes"] = 538923008] = "ConstructorExcludes";
        TransformFlags2[TransformFlags2["MethodOrAccessorExcludes"] = 538923008] = "MethodOrAccessorExcludes";
        TransformFlags2[TransformFlags2["PropertyExcludes"] = 536875008] = "PropertyExcludes";
        TransformFlags2[TransformFlags2["ClassExcludes"] = 536905728] = "ClassExcludes";
        TransformFlags2[TransformFlags2["ModuleExcludes"] = 537991168] = "ModuleExcludes";
        TransformFlags2[TransformFlags2["TypeExcludes"] = -2] = "TypeExcludes";
        TransformFlags2[TransformFlags2["ObjectLiteralExcludes"] = 536922112] = "ObjectLiteralExcludes";
        TransformFlags2[TransformFlags2["ArrayLiteralOrCallOrNewExcludes"] = 536879104] = "ArrayLiteralOrCallOrNewExcludes";
        TransformFlags2[TransformFlags2["VariableDeclarationListExcludes"] = 537018368] = "VariableDeclarationListExcludes";
        TransformFlags2[TransformFlags2["ParameterExcludes"] = 536870912] = "ParameterExcludes";
        TransformFlags2[TransformFlags2["CatchClauseExcludes"] = 536887296] = "CatchClauseExcludes";
        TransformFlags2[TransformFlags2["BindingPatternExcludes"] = 536879104] = "BindingPatternExcludes";
        TransformFlags2[TransformFlags2["PropertyNamePropagatingFlags"] = 4096] = "PropertyNamePropagatingFlags";
      })(TransformFlags = ts2.TransformFlags || (ts2.TransformFlags = {}));
      var EmitFlags;
      (function(EmitFlags2) {
        EmitFlags2[EmitFlags2["None"] = 0] = "None";
        EmitFlags2[EmitFlags2["SingleLine"] = 1] = "SingleLine";
        EmitFlags2[EmitFlags2["AdviseOnEmitNode"] = 2] = "AdviseOnEmitNode";
        EmitFlags2[EmitFlags2["NoSubstitution"] = 4] = "NoSubstitution";
        EmitFlags2[EmitFlags2["CapturesThis"] = 8] = "CapturesThis";
        EmitFlags2[EmitFlags2["NoLeadingSourceMap"] = 16] = "NoLeadingSourceMap";
        EmitFlags2[EmitFlags2["NoTrailingSourceMap"] = 32] = "NoTrailingSourceMap";
        EmitFlags2[EmitFlags2["NoSourceMap"] = 48] = "NoSourceMap";
        EmitFlags2[EmitFlags2["NoNestedSourceMaps"] = 64] = "NoNestedSourceMaps";
        EmitFlags2[EmitFlags2["NoTokenLeadingSourceMaps"] = 128] = "NoTokenLeadingSourceMaps";
        EmitFlags2[EmitFlags2["NoTokenTrailingSourceMaps"] = 256] = "NoTokenTrailingSourceMaps";
        EmitFlags2[EmitFlags2["NoTokenSourceMaps"] = 384] = "NoTokenSourceMaps";
        EmitFlags2[EmitFlags2["NoLeadingComments"] = 512] = "NoLeadingComments";
        EmitFlags2[EmitFlags2["NoTrailingComments"] = 1024] = "NoTrailingComments";
        EmitFlags2[EmitFlags2["NoComments"] = 1536] = "NoComments";
        EmitFlags2[EmitFlags2["NoNestedComments"] = 2048] = "NoNestedComments";
        EmitFlags2[EmitFlags2["HelperName"] = 4096] = "HelperName";
        EmitFlags2[EmitFlags2["ExportName"] = 8192] = "ExportName";
        EmitFlags2[EmitFlags2["LocalName"] = 16384] = "LocalName";
        EmitFlags2[EmitFlags2["InternalName"] = 32768] = "InternalName";
        EmitFlags2[EmitFlags2["Indented"] = 65536] = "Indented";
        EmitFlags2[EmitFlags2["NoIndentation"] = 131072] = "NoIndentation";
        EmitFlags2[EmitFlags2["AsyncFunctionBody"] = 262144] = "AsyncFunctionBody";
        EmitFlags2[EmitFlags2["ReuseTempVariableScope"] = 524288] = "ReuseTempVariableScope";
        EmitFlags2[EmitFlags2["CustomPrologue"] = 1048576] = "CustomPrologue";
        EmitFlags2[EmitFlags2["NoHoisting"] = 2097152] = "NoHoisting";
        EmitFlags2[EmitFlags2["HasEndOfDeclarationMarker"] = 4194304] = "HasEndOfDeclarationMarker";
        EmitFlags2[EmitFlags2["Iterator"] = 8388608] = "Iterator";
        EmitFlags2[EmitFlags2["NoAsciiEscaping"] = 16777216] = "NoAsciiEscaping";
        EmitFlags2[EmitFlags2["TypeScriptClassWrapper"] = 33554432] = "TypeScriptClassWrapper";
        EmitFlags2[EmitFlags2["NeverApplyImportHelper"] = 67108864] = "NeverApplyImportHelper";
        EmitFlags2[EmitFlags2["IgnoreSourceNewlines"] = 134217728] = "IgnoreSourceNewlines";
      })(EmitFlags = ts2.EmitFlags || (ts2.EmitFlags = {}));
      var ExternalEmitHelpers;
      (function(ExternalEmitHelpers2) {
        ExternalEmitHelpers2[ExternalEmitHelpers2["Extends"] = 1] = "Extends";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Assign"] = 2] = "Assign";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Rest"] = 4] = "Rest";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Decorate"] = 8] = "Decorate";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Metadata"] = 16] = "Metadata";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Param"] = 32] = "Param";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Awaiter"] = 64] = "Awaiter";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Generator"] = 128] = "Generator";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Values"] = 256] = "Values";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Read"] = 512] = "Read";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Spread"] = 1024] = "Spread";
        ExternalEmitHelpers2[ExternalEmitHelpers2["SpreadArrays"] = 2048] = "SpreadArrays";
        ExternalEmitHelpers2[ExternalEmitHelpers2["Await"] = 4096] = "Await";
        ExternalEmitHelpers2[ExternalEmitHelpers2["AsyncGenerator"] = 8192] = "AsyncGenerator";
        ExternalEmitHelpers2[ExternalEmitHelpers2["AsyncDelegator"] = 16384] = "AsyncDelegator";
        ExternalEmitHelpers2[ExternalEmitHelpers2["AsyncValues"] = 32768] = "AsyncValues";
        ExternalEmitHelpers2[ExternalEmitHelpers2["ExportStar"] = 65536] = "ExportStar";
        ExternalEmitHelpers2[ExternalEmitHelpers2["MakeTemplateObject"] = 131072] = "MakeTemplateObject";
        ExternalEmitHelpers2[ExternalEmitHelpers2["ClassPrivateFieldGet"] = 262144] = "ClassPrivateFieldGet";
        ExternalEmitHelpers2[ExternalEmitHelpers2["ClassPrivateFieldSet"] = 524288] = "ClassPrivateFieldSet";
        ExternalEmitHelpers2[ExternalEmitHelpers2["CreateBinding"] = 1048576] = "CreateBinding";
        ExternalEmitHelpers2[ExternalEmitHelpers2["FirstEmitHelper"] = 1] = "FirstEmitHelper";
        ExternalEmitHelpers2[ExternalEmitHelpers2["LastEmitHelper"] = 1048576] = "LastEmitHelper";
        ExternalEmitHelpers2[ExternalEmitHelpers2["ForOfIncludes"] = 256] = "ForOfIncludes";
        ExternalEmitHelpers2[ExternalEmitHelpers2["ForAwaitOfIncludes"] = 32768] = "ForAwaitOfIncludes";
        ExternalEmitHelpers2[ExternalEmitHelpers2["AsyncGeneratorIncludes"] = 12288] = "AsyncGeneratorIncludes";
        ExternalEmitHelpers2[ExternalEmitHelpers2["AsyncDelegatorIncludes"] = 53248] = "AsyncDelegatorIncludes";
        ExternalEmitHelpers2[ExternalEmitHelpers2["SpreadIncludes"] = 1536] = "SpreadIncludes";
      })(ExternalEmitHelpers = ts2.ExternalEmitHelpers || (ts2.ExternalEmitHelpers = {}));
      var EmitHint;
      (function(EmitHint2) {
        EmitHint2[EmitHint2["SourceFile"] = 0] = "SourceFile";
        EmitHint2[EmitHint2["Expression"] = 1] = "Expression";
        EmitHint2[EmitHint2["IdentifierName"] = 2] = "IdentifierName";
        EmitHint2[EmitHint2["MappedTypeParameter"] = 3] = "MappedTypeParameter";
        EmitHint2[EmitHint2["Unspecified"] = 4] = "Unspecified";
        EmitHint2[EmitHint2["EmbeddedStatement"] = 5] = "EmbeddedStatement";
        EmitHint2[EmitHint2["JsxAttributeValue"] = 6] = "JsxAttributeValue";
      })(EmitHint = ts2.EmitHint || (ts2.EmitHint = {}));
      var LexicalEnvironmentFlags;
      (function(LexicalEnvironmentFlags2) {
        LexicalEnvironmentFlags2[LexicalEnvironmentFlags2["None"] = 0] = "None";
        LexicalEnvironmentFlags2[LexicalEnvironmentFlags2["InParameters"] = 1] = "InParameters";
        LexicalEnvironmentFlags2[LexicalEnvironmentFlags2["VariablesHoistedInParameters"] = 2] = "VariablesHoistedInParameters";
      })(LexicalEnvironmentFlags = ts2.LexicalEnvironmentFlags || (ts2.LexicalEnvironmentFlags = {}));
      var BundleFileSectionKind;
      (function(BundleFileSectionKind2) {
        BundleFileSectionKind2["Prologue"] = "prologue";
        BundleFileSectionKind2["EmitHelpers"] = "emitHelpers";
        BundleFileSectionKind2["NoDefaultLib"] = "no-default-lib";
        BundleFileSectionKind2["Reference"] = "reference";
        BundleFileSectionKind2["Type"] = "type";
        BundleFileSectionKind2["Lib"] = "lib";
        BundleFileSectionKind2["Prepend"] = "prepend";
        BundleFileSectionKind2["Text"] = "text";
        BundleFileSectionKind2["Internal"] = "internal";
      })(BundleFileSectionKind = ts2.BundleFileSectionKind || (ts2.BundleFileSectionKind = {}));
      var ListFormat;
      (function(ListFormat2) {
        ListFormat2[ListFormat2["None"] = 0] = "None";
        ListFormat2[ListFormat2["SingleLine"] = 0] = "SingleLine";
        ListFormat2[ListFormat2["MultiLine"] = 1] = "MultiLine";
        ListFormat2[ListFormat2["PreserveLines"] = 2] = "PreserveLines";
        ListFormat2[ListFormat2["LinesMask"] = 3] = "LinesMask";
        ListFormat2[ListFormat2["NotDelimited"] = 0] = "NotDelimited";
        ListFormat2[ListFormat2["BarDelimited"] = 4] = "BarDelimited";
        ListFormat2[ListFormat2["AmpersandDelimited"] = 8] = "AmpersandDelimited";
        ListFormat2[ListFormat2["CommaDelimited"] = 16] = "CommaDelimited";
        ListFormat2[ListFormat2["AsteriskDelimited"] = 32] = "AsteriskDelimited";
        ListFormat2[ListFormat2["DelimitersMask"] = 60] = "DelimitersMask";
        ListFormat2[ListFormat2["AllowTrailingComma"] = 64] = "AllowTrailingComma";
        ListFormat2[ListFormat2["Indented"] = 128] = "Indented";
        ListFormat2[ListFormat2["SpaceBetweenBraces"] = 256] = "SpaceBetweenBraces";
        ListFormat2[ListFormat2["SpaceBetweenSiblings"] = 512] = "SpaceBetweenSiblings";
        ListFormat2[ListFormat2["Braces"] = 1024] = "Braces";
        ListFormat2[ListFormat2["Parenthesis"] = 2048] = "Parenthesis";
        ListFormat2[ListFormat2["AngleBrackets"] = 4096] = "AngleBrackets";
        ListFormat2[ListFormat2["SquareBrackets"] = 8192] = "SquareBrackets";
        ListFormat2[ListFormat2["BracketsMask"] = 15360] = "BracketsMask";
        ListFormat2[ListFormat2["OptionalIfUndefined"] = 16384] = "OptionalIfUndefined";
        ListFormat2[ListFormat2["OptionalIfEmpty"] = 32768] = "OptionalIfEmpty";
        ListFormat2[ListFormat2["Optional"] = 49152] = "Optional";
        ListFormat2[ListFormat2["PreferNewLine"] = 65536] = "PreferNewLine";
        ListFormat2[ListFormat2["NoTrailingNewLine"] = 131072] = "NoTrailingNewLine";
        ListFormat2[ListFormat2["NoInterveningComments"] = 262144] = "NoInterveningComments";
        ListFormat2[ListFormat2["NoSpaceIfEmpty"] = 524288] = "NoSpaceIfEmpty";
        ListFormat2[ListFormat2["SingleElement"] = 1048576] = "SingleElement";
        ListFormat2[ListFormat2["SpaceAfterList"] = 2097152] = "SpaceAfterList";
        ListFormat2[ListFormat2["Modifiers"] = 262656] = "Modifiers";
        ListFormat2[ListFormat2["HeritageClauses"] = 512] = "HeritageClauses";
        ListFormat2[ListFormat2["SingleLineTypeLiteralMembers"] = 768] = "SingleLineTypeLiteralMembers";
        ListFormat2[ListFormat2["MultiLineTypeLiteralMembers"] = 32897] = "MultiLineTypeLiteralMembers";
        ListFormat2[ListFormat2["TupleTypeElements"] = 528] = "TupleTypeElements";
        ListFormat2[ListFormat2["UnionTypeConstituents"] = 516] = "UnionTypeConstituents";
        ListFormat2[ListFormat2["IntersectionTypeConstituents"] = 520] = "IntersectionTypeConstituents";
        ListFormat2[ListFormat2["ObjectBindingPatternElements"] = 525136] = "ObjectBindingPatternElements";
        ListFormat2[ListFormat2["ArrayBindingPatternElements"] = 524880] = "ArrayBindingPatternElements";
        ListFormat2[ListFormat2["ObjectLiteralExpressionProperties"] = 526226] = "ObjectLiteralExpressionProperties";
        ListFormat2[ListFormat2["ArrayLiteralExpressionElements"] = 8914] = "ArrayLiteralExpressionElements";
        ListFormat2[ListFormat2["CommaListElements"] = 528] = "CommaListElements";
        ListFormat2[ListFormat2["CallExpressionArguments"] = 2576] = "CallExpressionArguments";
        ListFormat2[ListFormat2["NewExpressionArguments"] = 18960] = "NewExpressionArguments";
        ListFormat2[ListFormat2["TemplateExpressionSpans"] = 262144] = "TemplateExpressionSpans";
        ListFormat2[ListFormat2["SingleLineBlockStatements"] = 768] = "SingleLineBlockStatements";
        ListFormat2[ListFormat2["MultiLineBlockStatements"] = 129] = "MultiLineBlockStatements";
        ListFormat2[ListFormat2["VariableDeclarationList"] = 528] = "VariableDeclarationList";
        ListFormat2[ListFormat2["SingleLineFunctionBodyStatements"] = 768] = "SingleLineFunctionBodyStatements";
        ListFormat2[ListFormat2["MultiLineFunctionBodyStatements"] = 1] = "MultiLineFunctionBodyStatements";
        ListFormat2[ListFormat2["ClassHeritageClauses"] = 0] = "ClassHeritageClauses";
        ListFormat2[ListFormat2["ClassMembers"] = 129] = "ClassMembers";
        ListFormat2[ListFormat2["InterfaceMembers"] = 129] = "InterfaceMembers";
        ListFormat2[ListFormat2["EnumMembers"] = 145] = "EnumMembers";
        ListFormat2[ListFormat2["CaseBlockClauses"] = 129] = "CaseBlockClauses";
        ListFormat2[ListFormat2["NamedImportsOrExportsElements"] = 525136] = "NamedImportsOrExportsElements";
        ListFormat2[ListFormat2["JsxElementOrFragmentChildren"] = 262144] = "JsxElementOrFragmentChildren";
        ListFormat2[ListFormat2["JsxElementAttributes"] = 262656] = "JsxElementAttributes";
        ListFormat2[ListFormat2["CaseOrDefaultClauseStatements"] = 163969] = "CaseOrDefaultClauseStatements";
        ListFormat2[ListFormat2["HeritageClauseTypes"] = 528] = "HeritageClauseTypes";
        ListFormat2[ListFormat2["SourceFileStatements"] = 131073] = "SourceFileStatements";
        ListFormat2[ListFormat2["Decorators"] = 2146305] = "Decorators";
        ListFormat2[ListFormat2["TypeArguments"] = 53776] = "TypeArguments";
        ListFormat2[ListFormat2["TypeParameters"] = 53776] = "TypeParameters";
        ListFormat2[ListFormat2["Parameters"] = 2576] = "Parameters";
        ListFormat2[ListFormat2["IndexSignatureParameters"] = 8848] = "IndexSignatureParameters";
        ListFormat2[ListFormat2["JSDocComment"] = 33] = "JSDocComment";
      })(ListFormat = ts2.ListFormat || (ts2.ListFormat = {}));
      var PragmaKindFlags;
      (function(PragmaKindFlags2) {
        PragmaKindFlags2[PragmaKindFlags2["None"] = 0] = "None";
        PragmaKindFlags2[PragmaKindFlags2["TripleSlashXML"] = 1] = "TripleSlashXML";
        PragmaKindFlags2[PragmaKindFlags2["SingleLine"] = 2] = "SingleLine";
        PragmaKindFlags2[PragmaKindFlags2["MultiLine"] = 4] = "MultiLine";
        PragmaKindFlags2[PragmaKindFlags2["All"] = 7] = "All";
        PragmaKindFlags2[PragmaKindFlags2["Default"] = 7] = "Default";
      })(PragmaKindFlags = ts2.PragmaKindFlags || (ts2.PragmaKindFlags = {}));
      ts2.commentPragmas = {
        "reference": {
          args: [
            { name: "types", optional: true, captureSpan: true },
            { name: "lib", optional: true, captureSpan: true },
            { name: "path", optional: true, captureSpan: true },
            { name: "no-default-lib", optional: true }
          ],
          kind: 1
        },
        "amd-dependency": {
          args: [{ name: "path" }, { name: "name", optional: true }],
          kind: 1
        },
        "amd-module": {
          args: [{ name: "name" }],
          kind: 1
        },
        "ts-check": {
          kind: 2
        },
        "ts-nocheck": {
          kind: 2
        },
        "jsx": {
          args: [{ name: "factory" }],
          kind: 4
        }
      };
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function generateDjb2Hash(data) {
        var acc = 5381;
        for (var i = 0; i < data.length; i++) {
          acc = (acc << 5) + acc + data.charCodeAt(i);
        }
        return acc.toString();
      }
      ts2.generateDjb2Hash = generateDjb2Hash;
      function setStackTraceLimit() {
        if (Error.stackTraceLimit < 100) {
          Error.stackTraceLimit = 100;
        }
      }
      ts2.setStackTraceLimit = setStackTraceLimit;
      var FileWatcherEventKind;
      (function(FileWatcherEventKind2) {
        FileWatcherEventKind2[FileWatcherEventKind2["Created"] = 0] = "Created";
        FileWatcherEventKind2[FileWatcherEventKind2["Changed"] = 1] = "Changed";
        FileWatcherEventKind2[FileWatcherEventKind2["Deleted"] = 2] = "Deleted";
      })(FileWatcherEventKind = ts2.FileWatcherEventKind || (ts2.FileWatcherEventKind = {}));
      var PollingInterval;
      (function(PollingInterval2) {
        PollingInterval2[PollingInterval2["High"] = 2e3] = "High";
        PollingInterval2[PollingInterval2["Medium"] = 500] = "Medium";
        PollingInterval2[PollingInterval2["Low"] = 250] = "Low";
      })(PollingInterval = ts2.PollingInterval || (ts2.PollingInterval = {}));
      ts2.missingFileModifiedTime = new Date(0);
      function createPollingIntervalBasedLevels(levels) {
        var _a;
        return _a = {}, _a[PollingInterval.Low] = levels.Low, _a[PollingInterval.Medium] = levels.Medium, _a[PollingInterval.High] = levels.High, _a;
      }
      var defaultChunkLevels = { Low: 32, Medium: 64, High: 256 };
      var pollingChunkSize = createPollingIntervalBasedLevels(defaultChunkLevels);
      ts2.unchangedPollThresholds = createPollingIntervalBasedLevels(defaultChunkLevels);
      function setCustomPollingValues(system) {
        if (!system.getEnvironmentVariable) {
          return;
        }
        var pollingIntervalChanged = setCustomLevels("TSC_WATCH_POLLINGINTERVAL", PollingInterval);
        pollingChunkSize = getCustomPollingBasedLevels("TSC_WATCH_POLLINGCHUNKSIZE", defaultChunkLevels) || pollingChunkSize;
        ts2.unchangedPollThresholds = getCustomPollingBasedLevels("TSC_WATCH_UNCHANGEDPOLLTHRESHOLDS", defaultChunkLevels) || ts2.unchangedPollThresholds;
        function getLevel(envVar, level) {
          return system.getEnvironmentVariable(envVar + "_" + level.toUpperCase());
        }
        function getCustomLevels(baseVariable) {
          var customLevels;
          setCustomLevel("Low");
          setCustomLevel("Medium");
          setCustomLevel("High");
          return customLevels;
          function setCustomLevel(level) {
            var customLevel = getLevel(baseVariable, level);
            if (customLevel) {
              (customLevels || (customLevels = {}))[level] = Number(customLevel);
            }
          }
        }
        function setCustomLevels(baseVariable, levels) {
          var customLevels = getCustomLevels(baseVariable);
          if (customLevels) {
            setLevel("Low");
            setLevel("Medium");
            setLevel("High");
            return true;
          }
          return false;
          function setLevel(level) {
            levels[level] = customLevels[level] || levels[level];
          }
        }
        function getCustomPollingBasedLevels(baseVariable, defaultLevels) {
          var customLevels = getCustomLevels(baseVariable);
          return (pollingIntervalChanged || customLevels) && createPollingIntervalBasedLevels(customLevels ? __assign(__assign({}, defaultLevels), customLevels) : defaultLevels);
        }
      }
      ts2.setCustomPollingValues = setCustomPollingValues;
      function createDynamicPriorityPollingWatchFile(host) {
        var watchedFiles = [];
        var changedFilesInLastPoll = [];
        var lowPollingIntervalQueue = createPollingIntervalQueue(PollingInterval.Low);
        var mediumPollingIntervalQueue = createPollingIntervalQueue(PollingInterval.Medium);
        var highPollingIntervalQueue = createPollingIntervalQueue(PollingInterval.High);
        return watchFile;
        function watchFile(fileName, callback, defaultPollingInterval) {
          var file = {
            fileName,
            callback,
            unchangedPolls: 0,
            mtime: getModifiedTime(fileName)
          };
          watchedFiles.push(file);
          addToPollingIntervalQueue(file, defaultPollingInterval);
          return {
            close: function() {
              file.isClosed = true;
              ts2.unorderedRemoveItem(watchedFiles, file);
            }
          };
        }
        function createPollingIntervalQueue(pollingInterval) {
          var queue = [];
          queue.pollingInterval = pollingInterval;
          queue.pollIndex = 0;
          queue.pollScheduled = false;
          return queue;
        }
        function pollPollingIntervalQueue(queue) {
          queue.pollIndex = pollQueue(queue, queue.pollingInterval, queue.pollIndex, pollingChunkSize[queue.pollingInterval]);
          if (queue.length) {
            scheduleNextPoll(queue.pollingInterval);
          } else {
            ts2.Debug.assert(queue.pollIndex === 0);
            queue.pollScheduled = false;
          }
        }
        function pollLowPollingIntervalQueue(queue) {
          pollQueue(changedFilesInLastPoll, PollingInterval.Low, 0, changedFilesInLastPoll.length);
          pollPollingIntervalQueue(queue);
          if (!queue.pollScheduled && changedFilesInLastPoll.length) {
            scheduleNextPoll(PollingInterval.Low);
          }
        }
        function pollQueue(queue, pollingInterval, pollIndex, chunkSize) {
          var needsVisit = queue.length;
          var definedValueCopyToIndex = pollIndex;
          for (var polled = 0; polled < chunkSize && needsVisit > 0; nextPollIndex(), needsVisit--) {
            var watchedFile = queue[pollIndex];
            if (!watchedFile) {
              continue;
            } else if (watchedFile.isClosed) {
              queue[pollIndex] = void 0;
              continue;
            }
            polled++;
            var fileChanged = onWatchedFileStat(watchedFile, getModifiedTime(watchedFile.fileName));
            if (watchedFile.isClosed) {
              queue[pollIndex] = void 0;
            } else if (fileChanged) {
              watchedFile.unchangedPolls = 0;
              if (queue !== changedFilesInLastPoll) {
                queue[pollIndex] = void 0;
                addChangedFileToLowPollingIntervalQueue(watchedFile);
              }
            } else if (watchedFile.unchangedPolls !== ts2.unchangedPollThresholds[pollingInterval]) {
              watchedFile.unchangedPolls++;
            } else if (queue === changedFilesInLastPoll) {
              watchedFile.unchangedPolls = 1;
              queue[pollIndex] = void 0;
              addToPollingIntervalQueue(watchedFile, PollingInterval.Low);
            } else if (pollingInterval !== PollingInterval.High) {
              watchedFile.unchangedPolls++;
              queue[pollIndex] = void 0;
              addToPollingIntervalQueue(watchedFile, pollingInterval === PollingInterval.Low ? PollingInterval.Medium : PollingInterval.High);
            }
            if (queue[pollIndex]) {
              if (definedValueCopyToIndex < pollIndex) {
                queue[definedValueCopyToIndex] = watchedFile;
                queue[pollIndex] = void 0;
              }
              definedValueCopyToIndex++;
            }
          }
          return pollIndex;
          function nextPollIndex() {
            pollIndex++;
            if (pollIndex === queue.length) {
              if (definedValueCopyToIndex < pollIndex) {
                queue.length = definedValueCopyToIndex;
              }
              pollIndex = 0;
              definedValueCopyToIndex = 0;
            }
          }
        }
        function pollingIntervalQueue(pollingInterval) {
          switch (pollingInterval) {
            case PollingInterval.Low:
              return lowPollingIntervalQueue;
            case PollingInterval.Medium:
              return mediumPollingIntervalQueue;
            case PollingInterval.High:
              return highPollingIntervalQueue;
          }
        }
        function addToPollingIntervalQueue(file, pollingInterval) {
          pollingIntervalQueue(pollingInterval).push(file);
          scheduleNextPollIfNotAlreadyScheduled(pollingInterval);
        }
        function addChangedFileToLowPollingIntervalQueue(file) {
          changedFilesInLastPoll.push(file);
          scheduleNextPollIfNotAlreadyScheduled(PollingInterval.Low);
        }
        function scheduleNextPollIfNotAlreadyScheduled(pollingInterval) {
          if (!pollingIntervalQueue(pollingInterval).pollScheduled) {
            scheduleNextPoll(pollingInterval);
          }
        }
        function scheduleNextPoll(pollingInterval) {
          pollingIntervalQueue(pollingInterval).pollScheduled = host.setTimeout(pollingInterval === PollingInterval.Low ? pollLowPollingIntervalQueue : pollPollingIntervalQueue, pollingInterval, pollingIntervalQueue(pollingInterval));
        }
        function getModifiedTime(fileName) {
          return host.getModifiedTime(fileName) || ts2.missingFileModifiedTime;
        }
      }
      ts2.createDynamicPriorityPollingWatchFile = createDynamicPriorityPollingWatchFile;
      function createUseFsEventsOnParentDirectoryWatchFile(fsWatch, useCaseSensitiveFileNames) {
        var fileWatcherCallbacks = ts2.createMultiMap();
        var dirWatchers = ts2.createMap();
        var toCanonicalName = ts2.createGetCanonicalFileName(useCaseSensitiveFileNames);
        return nonPollingWatchFile;
        function nonPollingWatchFile(fileName, callback, _pollingInterval, fallbackOptions) {
          var filePath = toCanonicalName(fileName);
          fileWatcherCallbacks.add(filePath, callback);
          var dirPath = ts2.getDirectoryPath(filePath) || ".";
          var watcher = dirWatchers.get(dirPath) || createDirectoryWatcher(ts2.getDirectoryPath(fileName) || ".", dirPath, fallbackOptions);
          watcher.referenceCount++;
          return {
            close: function() {
              if (watcher.referenceCount === 1) {
                watcher.close();
                dirWatchers.delete(dirPath);
              } else {
                watcher.referenceCount--;
              }
              fileWatcherCallbacks.remove(filePath, callback);
            }
          };
        }
        function createDirectoryWatcher(dirName, dirPath, fallbackOptions) {
          var watcher = fsWatch(dirName, 1, function(_eventName, relativeFileName) {
            if (!ts2.isString(relativeFileName)) {
              return;
            }
            var fileName = ts2.getNormalizedAbsolutePath(relativeFileName, dirName);
            var callbacks = fileName && fileWatcherCallbacks.get(toCanonicalName(fileName));
            if (callbacks) {
              for (var _i = 0, callbacks_1 = callbacks; _i < callbacks_1.length; _i++) {
                var fileCallback = callbacks_1[_i];
                fileCallback(fileName, FileWatcherEventKind.Changed);
              }
            }
          }, false, PollingInterval.Medium, fallbackOptions);
          watcher.referenceCount = 0;
          dirWatchers.set(dirPath, watcher);
          return watcher;
        }
      }
      function createSingleFileWatcherPerName(watchFile, useCaseSensitiveFileNames) {
        var cache = ts2.createMap();
        var callbacksCache = ts2.createMultiMap();
        var toCanonicalFileName = ts2.createGetCanonicalFileName(useCaseSensitiveFileNames);
        return function(fileName, callback, pollingInterval, options) {
          var path2 = toCanonicalFileName(fileName);
          var existing = cache.get(path2);
          if (existing) {
            existing.refCount++;
          } else {
            cache.set(path2, {
              watcher: watchFile(fileName, function(fileName2, eventKind) {
                return ts2.forEach(callbacksCache.get(path2), function(cb) {
                  return cb(fileName2, eventKind);
                });
              }, pollingInterval, options),
              refCount: 1
            });
          }
          callbacksCache.add(path2, callback);
          return {
            close: function() {
              var watcher = ts2.Debug.checkDefined(cache.get(path2));
              callbacksCache.remove(path2, callback);
              watcher.refCount--;
              if (watcher.refCount)
                return;
              cache.delete(path2);
              ts2.closeFileWatcherOf(watcher);
            }
          };
        };
      }
      ts2.createSingleFileWatcherPerName = createSingleFileWatcherPerName;
      function onWatchedFileStat(watchedFile, modifiedTime) {
        var oldTime = watchedFile.mtime.getTime();
        var newTime = modifiedTime.getTime();
        if (oldTime !== newTime) {
          watchedFile.mtime = modifiedTime;
          watchedFile.callback(watchedFile.fileName, getFileWatcherEventKind(oldTime, newTime));
          return true;
        }
        return false;
      }
      ts2.onWatchedFileStat = onWatchedFileStat;
      function getFileWatcherEventKind(oldTime, newTime) {
        return oldTime === 0 ? FileWatcherEventKind.Created : newTime === 0 ? FileWatcherEventKind.Deleted : FileWatcherEventKind.Changed;
      }
      ts2.getFileWatcherEventKind = getFileWatcherEventKind;
      ts2.ignoredPaths = ["/node_modules/.", "/.git", "/.#"];
      ts2.sysLog = ts2.noop;
      function setSysLog(logger) {
        ts2.sysLog = logger;
      }
      ts2.setSysLog = setSysLog;
      function createDirectoryWatcherSupportingRecursive(host) {
        var cache = ts2.createMap();
        var callbackCache = ts2.createMultiMap();
        var cacheToUpdateChildWatches = ts2.createMap();
        var timerToUpdateChildWatches;
        var filePathComparer = ts2.getStringComparer(!host.useCaseSensitiveFileNames);
        var toCanonicalFilePath = ts2.createGetCanonicalFileName(host.useCaseSensitiveFileNames);
        return function(dirName, callback, recursive, options) {
          return recursive ? createDirectoryWatcher(dirName, options, callback) : host.watchDirectory(dirName, callback, recursive, options);
        };
        function createDirectoryWatcher(dirName, options, callback) {
          var dirPath = toCanonicalFilePath(dirName);
          var directoryWatcher = cache.get(dirPath);
          if (directoryWatcher) {
            directoryWatcher.refCount++;
          } else {
            directoryWatcher = {
              watcher: host.watchDirectory(dirName, function(fileName) {
                if (isIgnoredPath(fileName))
                  return;
                if (options === null || options === void 0 ? void 0 : options.synchronousWatchDirectory) {
                  invokeCallbacks(dirPath, fileName);
                  updateChildWatches(dirName, dirPath, options);
                } else {
                  nonSyncUpdateChildWatches(dirName, dirPath, fileName, options);
                }
              }, false, options),
              refCount: 1,
              childWatches: ts2.emptyArray
            };
            cache.set(dirPath, directoryWatcher);
            updateChildWatches(dirName, dirPath, options);
          }
          var callbackToAdd = callback && { dirName, callback };
          if (callbackToAdd) {
            callbackCache.add(dirPath, callbackToAdd);
          }
          return {
            dirName,
            close: function() {
              var directoryWatcher2 = ts2.Debug.checkDefined(cache.get(dirPath));
              if (callbackToAdd)
                callbackCache.remove(dirPath, callbackToAdd);
              directoryWatcher2.refCount--;
              if (directoryWatcher2.refCount)
                return;
              cache.delete(dirPath);
              ts2.closeFileWatcherOf(directoryWatcher2);
              directoryWatcher2.childWatches.forEach(ts2.closeFileWatcher);
            }
          };
        }
        function invokeCallbacks(dirPath, fileNameOrInvokeMap) {
          var fileName;
          var invokeMap;
          if (ts2.isString(fileNameOrInvokeMap)) {
            fileName = fileNameOrInvokeMap;
          } else {
            invokeMap = fileNameOrInvokeMap;
          }
          callbackCache.forEach(function(callbacks, rootDirName) {
            if (invokeMap && invokeMap.has(rootDirName))
              return;
            if (rootDirName === dirPath || ts2.startsWith(dirPath, rootDirName) && dirPath[rootDirName.length] === ts2.directorySeparator) {
              if (invokeMap) {
                invokeMap.set(rootDirName, true);
              } else {
                callbacks.forEach(function(_a) {
                  var callback = _a.callback;
                  return callback(fileName);
                });
              }
            }
          });
        }
        function nonSyncUpdateChildWatches(dirName, dirPath, fileName, options) {
          var parentWatcher = cache.get(dirPath);
          if (parentWatcher && host.directoryExists(dirName)) {
            scheduleUpdateChildWatches(dirName, dirPath, options);
            return;
          }
          invokeCallbacks(dirPath, fileName);
          removeChildWatches(parentWatcher);
        }
        function scheduleUpdateChildWatches(dirName, dirPath, options) {
          if (!cacheToUpdateChildWatches.has(dirPath)) {
            cacheToUpdateChildWatches.set(dirPath, { dirName, options });
          }
          if (timerToUpdateChildWatches) {
            host.clearTimeout(timerToUpdateChildWatches);
            timerToUpdateChildWatches = void 0;
          }
          timerToUpdateChildWatches = host.setTimeout(onTimerToUpdateChildWatches, 1e3);
        }
        function onTimerToUpdateChildWatches() {
          timerToUpdateChildWatches = void 0;
          ts2.sysLog("sysLog:: onTimerToUpdateChildWatches:: " + cacheToUpdateChildWatches.size);
          var start = ts2.timestamp();
          var invokeMap = ts2.createMap();
          while (!timerToUpdateChildWatches && cacheToUpdateChildWatches.size) {
            var _a = cacheToUpdateChildWatches.entries().next(), _b = _a.value, dirPath = _b[0], _c = _b[1], dirName = _c.dirName, options = _c.options, done = _a.done;
            ts2.Debug.assert(!done);
            cacheToUpdateChildWatches.delete(dirPath);
            invokeCallbacks(dirPath, invokeMap);
            updateChildWatches(dirName, dirPath, options);
          }
          ts2.sysLog("sysLog:: invokingWatchers:: " + (ts2.timestamp() - start) + "ms:: " + cacheToUpdateChildWatches.size);
          callbackCache.forEach(function(callbacks, rootDirName) {
            if (invokeMap.has(rootDirName)) {
              callbacks.forEach(function(_a2) {
                var callback = _a2.callback, dirName2 = _a2.dirName;
                return callback(dirName2);
              });
            }
          });
          var elapsed = ts2.timestamp() - start;
          ts2.sysLog("sysLog:: Elapsed " + elapsed + "ms:: onTimerToUpdateChildWatches:: " + cacheToUpdateChildWatches.size + " " + timerToUpdateChildWatches);
        }
        function removeChildWatches(parentWatcher) {
          if (!parentWatcher)
            return;
          var existingChildWatches = parentWatcher.childWatches;
          parentWatcher.childWatches = ts2.emptyArray;
          for (var _i = 0, existingChildWatches_1 = existingChildWatches; _i < existingChildWatches_1.length; _i++) {
            var childWatcher = existingChildWatches_1[_i];
            childWatcher.close();
            removeChildWatches(cache.get(toCanonicalFilePath(childWatcher.dirName)));
          }
        }
        function updateChildWatches(dirName, dirPath, options) {
          var parentWatcher = cache.get(dirPath);
          if (parentWatcher) {
            parentWatcher.childWatches = watchChildDirectories(dirName, parentWatcher.childWatches, options);
          }
        }
        function watchChildDirectories(parentDir, existingChildWatches, options) {
          var newChildWatches;
          ts2.enumerateInsertsAndDeletes(host.directoryExists(parentDir) ? ts2.mapDefined(host.getAccessibleSortedChildDirectories(parentDir), function(child) {
            var childFullName = ts2.getNormalizedAbsolutePath(child, parentDir);
            return !isIgnoredPath(childFullName) && filePathComparer(childFullName, ts2.normalizePath(host.realpath(childFullName))) === 0 ? childFullName : void 0;
          }) : ts2.emptyArray, existingChildWatches, function(child, childWatcher) {
            return filePathComparer(child, childWatcher.dirName);
          }, createAndAddChildDirectoryWatcher, ts2.closeFileWatcher, addChildDirectoryWatcher);
          return newChildWatches || ts2.emptyArray;
          function createAndAddChildDirectoryWatcher(childName) {
            var result = createDirectoryWatcher(childName, options);
            addChildDirectoryWatcher(result);
          }
          function addChildDirectoryWatcher(childWatcher) {
            (newChildWatches || (newChildWatches = [])).push(childWatcher);
          }
        }
        function isIgnoredPath(path2) {
          return ts2.some(ts2.ignoredPaths, function(searchPath) {
            return isInPath(path2, searchPath);
          });
        }
        function isInPath(path2, searchPath) {
          if (ts2.stringContains(path2, searchPath))
            return true;
          if (host.useCaseSensitiveFileNames)
            return false;
          return ts2.stringContains(toCanonicalFilePath(path2), searchPath);
        }
      }
      ts2.createDirectoryWatcherSupportingRecursive = createDirectoryWatcherSupportingRecursive;
      var FileSystemEntryKind;
      (function(FileSystemEntryKind2) {
        FileSystemEntryKind2[FileSystemEntryKind2["File"] = 0] = "File";
        FileSystemEntryKind2[FileSystemEntryKind2["Directory"] = 1] = "Directory";
      })(FileSystemEntryKind = ts2.FileSystemEntryKind || (ts2.FileSystemEntryKind = {}));
      function createFileWatcherCallback(callback) {
        return function(_fileName, eventKind) {
          return callback(eventKind === FileWatcherEventKind.Changed ? "change" : "rename", "");
        };
      }
      ts2.createFileWatcherCallback = createFileWatcherCallback;
      function createFsWatchCallbackForFileWatcherCallback(fileName, callback, fileExists) {
        return function(eventName) {
          if (eventName === "rename") {
            callback(fileName, fileExists(fileName) ? FileWatcherEventKind.Created : FileWatcherEventKind.Deleted);
          } else {
            callback(fileName, FileWatcherEventKind.Changed);
          }
        };
      }
      function createFsWatchCallbackForDirectoryWatcherCallback(directoryName, callback) {
        return function(eventName, relativeFileName) {
          if (eventName === "rename") {
            callback(!relativeFileName ? directoryName : ts2.normalizePath(ts2.combinePaths(directoryName, relativeFileName)));
          }
        };
      }
      function createSystemWatchFunctions(_a) {
        var pollingWatchFile = _a.pollingWatchFile, getModifiedTime = _a.getModifiedTime, setTimeout2 = _a.setTimeout, clearTimeout2 = _a.clearTimeout, fsWatch = _a.fsWatch, fileExists = _a.fileExists, useCaseSensitiveFileNames = _a.useCaseSensitiveFileNames, fsSupportsRecursiveFsWatch = _a.fsSupportsRecursiveFsWatch, directoryExists = _a.directoryExists, getAccessibleSortedChildDirectories = _a.getAccessibleSortedChildDirectories, realpath = _a.realpath, tscWatchFile = _a.tscWatchFile, useNonPollingWatchers = _a.useNonPollingWatchers, tscWatchDirectory = _a.tscWatchDirectory;
        var dynamicPollingWatchFile;
        var nonPollingWatchFile;
        var hostRecursiveDirectoryWatcher;
        return {
          watchFile,
          watchDirectory
        };
        function watchFile(fileName, callback, pollingInterval, options) {
          options = updateOptionsForWatchFile(options, useNonPollingWatchers);
          var watchFileKind = ts2.Debug.checkDefined(options.watchFile);
          switch (watchFileKind) {
            case ts2.WatchFileKind.FixedPollingInterval:
              return pollingWatchFile(fileName, callback, PollingInterval.Low, void 0);
            case ts2.WatchFileKind.PriorityPollingInterval:
              return pollingWatchFile(fileName, callback, pollingInterval, void 0);
            case ts2.WatchFileKind.DynamicPriorityPolling:
              return ensureDynamicPollingWatchFile()(fileName, callback, pollingInterval, void 0);
            case ts2.WatchFileKind.UseFsEvents:
              return fsWatch(fileName, 0, createFsWatchCallbackForFileWatcherCallback(fileName, callback, fileExists), false, pollingInterval, ts2.getFallbackOptions(options));
            case ts2.WatchFileKind.UseFsEventsOnParentDirectory:
              if (!nonPollingWatchFile) {
                nonPollingWatchFile = createUseFsEventsOnParentDirectoryWatchFile(fsWatch, useCaseSensitiveFileNames);
              }
              return nonPollingWatchFile(fileName, callback, pollingInterval, ts2.getFallbackOptions(options));
            default:
              ts2.Debug.assertNever(watchFileKind);
          }
        }
        function ensureDynamicPollingWatchFile() {
          return dynamicPollingWatchFile || (dynamicPollingWatchFile = createDynamicPriorityPollingWatchFile({ getModifiedTime, setTimeout: setTimeout2 }));
        }
        function updateOptionsForWatchFile(options, useNonPollingWatchers2) {
          if (options && options.watchFile !== void 0)
            return options;
          switch (tscWatchFile) {
            case "PriorityPollingInterval":
              return { watchFile: ts2.WatchFileKind.PriorityPollingInterval };
            case "DynamicPriorityPolling":
              return { watchFile: ts2.WatchFileKind.DynamicPriorityPolling };
            case "UseFsEvents":
              return generateWatchFileOptions(ts2.WatchFileKind.UseFsEvents, ts2.PollingWatchKind.PriorityInterval, options);
            case "UseFsEventsWithFallbackDynamicPolling":
              return generateWatchFileOptions(ts2.WatchFileKind.UseFsEvents, ts2.PollingWatchKind.DynamicPriority, options);
            case "UseFsEventsOnParentDirectory":
              useNonPollingWatchers2 = true;
            default:
              return useNonPollingWatchers2 ? generateWatchFileOptions(ts2.WatchFileKind.UseFsEventsOnParentDirectory, ts2.PollingWatchKind.PriorityInterval, options) : { watchFile: ts2.WatchFileKind.FixedPollingInterval };
          }
        }
        function generateWatchFileOptions(watchFile2, fallbackPolling, options) {
          var defaultFallbackPolling = options === null || options === void 0 ? void 0 : options.fallbackPolling;
          return {
            watchFile: watchFile2,
            fallbackPolling: defaultFallbackPolling === void 0 ? fallbackPolling : defaultFallbackPolling
          };
        }
        function watchDirectory(directoryName, callback, recursive, options) {
          if (fsSupportsRecursiveFsWatch) {
            return fsWatch(directoryName, 1, createFsWatchCallbackForDirectoryWatcherCallback(directoryName, callback), recursive, PollingInterval.Medium, ts2.getFallbackOptions(options));
          }
          if (!hostRecursiveDirectoryWatcher) {
            hostRecursiveDirectoryWatcher = createDirectoryWatcherSupportingRecursive({
              useCaseSensitiveFileNames,
              directoryExists,
              getAccessibleSortedChildDirectories,
              watchDirectory: nonRecursiveWatchDirectory,
              realpath,
              setTimeout: setTimeout2,
              clearTimeout: clearTimeout2
            });
          }
          return hostRecursiveDirectoryWatcher(directoryName, callback, recursive, options);
        }
        function nonRecursiveWatchDirectory(directoryName, callback, recursive, options) {
          ts2.Debug.assert(!recursive);
          options = updateOptionsForWatchDirectory(options);
          var watchDirectoryKind = ts2.Debug.checkDefined(options.watchDirectory);
          switch (watchDirectoryKind) {
            case ts2.WatchDirectoryKind.FixedPollingInterval:
              return pollingWatchFile(directoryName, function() {
                return callback(directoryName);
              }, PollingInterval.Medium, void 0);
            case ts2.WatchDirectoryKind.DynamicPriorityPolling:
              return ensureDynamicPollingWatchFile()(directoryName, function() {
                return callback(directoryName);
              }, PollingInterval.Medium, void 0);
            case ts2.WatchDirectoryKind.UseFsEvents:
              return fsWatch(directoryName, 1, createFsWatchCallbackForDirectoryWatcherCallback(directoryName, callback), recursive, PollingInterval.Medium, ts2.getFallbackOptions(options));
            default:
              ts2.Debug.assertNever(watchDirectoryKind);
          }
        }
        function updateOptionsForWatchDirectory(options) {
          if (options && options.watchDirectory !== void 0)
            return options;
          switch (tscWatchDirectory) {
            case "RecursiveDirectoryUsingFsWatchFile":
              return { watchDirectory: ts2.WatchDirectoryKind.FixedPollingInterval };
            case "RecursiveDirectoryUsingDynamicPriorityPolling":
              return { watchDirectory: ts2.WatchDirectoryKind.DynamicPriorityPolling };
            default:
              var defaultFallbackPolling = options === null || options === void 0 ? void 0 : options.fallbackPolling;
              return {
                watchDirectory: ts2.WatchDirectoryKind.UseFsEvents,
                fallbackPolling: defaultFallbackPolling !== void 0 ? defaultFallbackPolling : void 0
              };
          }
        }
      }
      ts2.createSystemWatchFunctions = createSystemWatchFunctions;
      function patchWriteFileEnsuringDirectory(sys) {
        var originalWriteFile = sys.writeFile;
        sys.writeFile = function(path2, data, writeBom) {
          return ts2.writeFileEnsuringDirectories(path2, data, !!writeBom, function(path3, data2, writeByteOrderMark) {
            return originalWriteFile.call(sys, path3, data2, writeByteOrderMark);
          }, function(path3) {
            return sys.createDirectory(path3);
          }, function(path3) {
            return sys.directoryExists(path3);
          });
        };
      }
      ts2.patchWriteFileEnsuringDirectory = patchWriteFileEnsuringDirectory;
      function getNodeMajorVersion() {
        if (typeof process === "undefined") {
          return void 0;
        }
        var version = process.version;
        if (!version) {
          return void 0;
        }
        var dot = version.indexOf(".");
        if (dot === -1) {
          return void 0;
        }
        return parseInt(version.substring(1, dot));
      }
      ts2.getNodeMajorVersion = getNodeMajorVersion;
      ts2.sys = function() {
        var byteOrderMarkIndicator = "\uFEFF";
        function getNodeSystem() {
          var nativePattern = /^native |^\([^)]+\)$|^(internal[\\/]|[a-zA-Z0-9_\s]+(\.js)?$)/;
          var _fs = require("fs");
          var _path = require("path");
          var _os = require("os");
          var _crypto;
          try {
            _crypto = require("crypto");
          } catch (_a) {
            _crypto = void 0;
          }
          var activeSession;
          var profilePath = "./profile.cpuprofile";
          var Buffer2 = require("buffer").Buffer;
          var nodeVersion = getNodeMajorVersion();
          var isNode4OrLater = nodeVersion >= 4;
          var isLinuxOrMacOs = process.platform === "linux" || process.platform === "darwin";
          var platform = _os.platform();
          var useCaseSensitiveFileNames = isFileSystemCaseSensitive();
          var fsSupportsRecursiveFsWatch = isNode4OrLater && (process.platform === "win32" || process.platform === "darwin");
          var _b = createSystemWatchFunctions({
            pollingWatchFile: createSingleFileWatcherPerName(fsWatchFileWorker, useCaseSensitiveFileNames),
            getModifiedTime,
            setTimeout,
            clearTimeout,
            fsWatch,
            useCaseSensitiveFileNames,
            fileExists,
            fsSupportsRecursiveFsWatch,
            directoryExists,
            getAccessibleSortedChildDirectories: function(path2) {
              return getAccessibleFileSystemEntries(path2).directories;
            },
            realpath,
            tscWatchFile: process.env.TSC_WATCHFILE,
            useNonPollingWatchers: process.env.TSC_NONPOLLING_WATCHER,
            tscWatchDirectory: process.env.TSC_WATCHDIRECTORY
          }), watchFile = _b.watchFile, watchDirectory = _b.watchDirectory;
          var nodeSystem = {
            args: process.argv.slice(2),
            newLine: _os.EOL,
            useCaseSensitiveFileNames,
            write: function(s) {
              process.stdout.write(s);
            },
            writeOutputIsTTY: function() {
              return process.stdout.isTTY;
            },
            readFile,
            writeFile,
            watchFile,
            watchDirectory,
            resolvePath: function(path2) {
              return _path.resolve(path2);
            },
            fileExists,
            directoryExists,
            createDirectory: function(directoryName) {
              if (!nodeSystem.directoryExists(directoryName)) {
                try {
                  _fs.mkdirSync(directoryName);
                } catch (e) {
                  if (e.code !== "EEXIST") {
                    throw e;
                  }
                }
              }
            },
            getExecutingFilePath: function() {
              return __filename;
            },
            getCurrentDirectory: function() {
              return process.cwd();
            },
            getDirectories,
            getEnvironmentVariable: function(name) {
              return process.env[name] || "";
            },
            readDirectory,
            getModifiedTime,
            setModifiedTime,
            deleteFile,
            createHash: _crypto ? createSHA256Hash : generateDjb2Hash,
            createSHA256Hash: _crypto ? createSHA256Hash : void 0,
            getMemoryUsage: function() {
              if (global.gc) {
                global.gc();
              }
              return process.memoryUsage().heapUsed;
            },
            getFileSize: function(path2) {
              try {
                var stat = statSync(path2);
                if (stat === null || stat === void 0 ? void 0 : stat.isFile()) {
                  return stat.size;
                }
              } catch (_a) {
              }
              return 0;
            },
            exit: function(exitCode) {
              disableCPUProfiler(function() {
                return process.exit(exitCode);
              });
            },
            enableCPUProfiler,
            disableCPUProfiler,
            realpath,
            debugMode: !!process.env.NODE_INSPECTOR_IPC || ts2.some(process.execArgv, function(arg) {
              return /^--(inspect|debug)(-brk)?(=\d+)?$/i.test(arg);
            }),
            tryEnableSourceMapsForHost: function() {
              try {
                require_source_map_support().install();
              } catch (_a) {
              }
            },
            setTimeout,
            clearTimeout,
            clearScreen: function() {
              process.stdout.write("c");
            },
            setBlocking: function() {
              if (process.stdout && process.stdout._handle && process.stdout._handle.setBlocking) {
                process.stdout._handle.setBlocking(true);
              }
            },
            bufferFrom,
            base64decode: function(input) {
              return bufferFrom(input, "base64").toString("utf8");
            },
            base64encode: function(input) {
              return bufferFrom(input).toString("base64");
            },
            require: function(baseDir, moduleName) {
              try {
                var modulePath = ts2.resolveJSModule(moduleName, baseDir, nodeSystem);
                return { module: require(modulePath), modulePath, error: void 0 };
              } catch (error) {
                return { module: void 0, modulePath: void 0, error };
              }
            }
          };
          return nodeSystem;
          function statSync(path2) {
            return _fs.statSync(path2, { throwIfNoEntry: false });
          }
          function enableCPUProfiler(path2, cb) {
            if (activeSession) {
              cb();
              return false;
            }
            var inspector = require("inspector");
            if (!inspector || !inspector.Session) {
              cb();
              return false;
            }
            var session = new inspector.Session();
            session.connect();
            session.post("Profiler.enable", function() {
              session.post("Profiler.start", function() {
                activeSession = session;
                profilePath = path2;
                cb();
              });
            });
            return true;
          }
          function cleanupPaths(profile) {
            var externalFileCounter = 0;
            var remappedPaths = ts2.createMap();
            var normalizedDir = ts2.normalizeSlashes(__dirname);
            var fileUrlRoot = "file://" + (ts2.getRootLength(normalizedDir) === 1 ? "" : "/") + normalizedDir;
            for (var _i = 0, _a = profile.nodes; _i < _a.length; _i++) {
              var node = _a[_i];
              if (node.callFrame.url) {
                var url = ts2.normalizeSlashes(node.callFrame.url);
                if (ts2.containsPath(fileUrlRoot, url, useCaseSensitiveFileNames)) {
                  node.callFrame.url = ts2.getRelativePathToDirectoryOrUrl(fileUrlRoot, url, fileUrlRoot, ts2.createGetCanonicalFileName(useCaseSensitiveFileNames), true);
                } else if (!nativePattern.test(url)) {
                  node.callFrame.url = (remappedPaths.has(url) ? remappedPaths : remappedPaths.set(url, "external" + externalFileCounter + ".js")).get(url);
                  externalFileCounter++;
                }
              }
            }
            return profile;
          }
          function disableCPUProfiler(cb) {
            if (activeSession && activeSession !== "stopping") {
              var s_1 = activeSession;
              activeSession.post("Profiler.stop", function(err, _a) {
                var _b2;
                var profile = _a.profile;
                if (!err) {
                  try {
                    if ((_b2 = statSync(profilePath)) === null || _b2 === void 0 ? void 0 : _b2.isDirectory()) {
                      profilePath = _path.join(profilePath, new Date().toISOString().replace(/:/g, "-") + "+P" + process.pid + ".cpuprofile");
                    }
                  } catch (_c) {
                  }
                  try {
                    _fs.mkdirSync(_path.dirname(profilePath), { recursive: true });
                  } catch (_d) {
                  }
                  _fs.writeFileSync(profilePath, JSON.stringify(cleanupPaths(profile)));
                }
                activeSession = void 0;
                s_1.disconnect();
                cb();
              });
              activeSession = "stopping";
              return true;
            } else {
              cb();
              return false;
            }
          }
          function bufferFrom(input, encoding) {
            return Buffer2.from && Buffer2.from !== Int8Array.from ? Buffer2.from(input, encoding) : new Buffer2(input, encoding);
          }
          function isFileSystemCaseSensitive() {
            if (platform === "win32" || platform === "win64") {
              return false;
            }
            return !fileExists(swapCase(__filename));
          }
          function swapCase(s) {
            return s.replace(/\w/g, function(ch) {
              var up = ch.toUpperCase();
              return ch === up ? ch.toLowerCase() : up;
            });
          }
          function fsWatchFileWorker(fileName, callback, pollingInterval) {
            _fs.watchFile(fileName, { persistent: true, interval: pollingInterval }, fileChanged);
            var eventKind;
            return {
              close: function() {
                return _fs.unwatchFile(fileName, fileChanged);
              }
            };
            function fileChanged(curr, prev) {
              var isPreviouslyDeleted = +prev.mtime === 0 || eventKind === FileWatcherEventKind.Deleted;
              if (+curr.mtime === 0) {
                if (isPreviouslyDeleted) {
                  return;
                }
                eventKind = FileWatcherEventKind.Deleted;
              } else if (isPreviouslyDeleted) {
                eventKind = FileWatcherEventKind.Created;
              } else if (+curr.mtime === +prev.mtime) {
                return;
              } else {
                eventKind = FileWatcherEventKind.Changed;
              }
              callback(fileName, eventKind);
            }
          }
          function fsWatch(fileOrDirectory, entryKind, callback, recursive, fallbackPollingInterval, fallbackOptions) {
            var options;
            var lastDirectoryPartWithDirectorySeparator;
            var lastDirectoryPart;
            if (isLinuxOrMacOs) {
              lastDirectoryPartWithDirectorySeparator = fileOrDirectory.substr(fileOrDirectory.lastIndexOf(ts2.directorySeparator));
              lastDirectoryPart = lastDirectoryPartWithDirectorySeparator.slice(ts2.directorySeparator.length);
            }
            var watcher = !fileSystemEntryExists(fileOrDirectory, entryKind) ? watchMissingFileSystemEntry() : watchPresentFileSystemEntry();
            return {
              close: function() {
                watcher.close();
                watcher = void 0;
              }
            };
            function invokeCallbackAndUpdateWatcher(createWatcher) {
              ts2.sysLog("sysLog:: " + fileOrDirectory + ":: Changing watcher to " + (createWatcher === watchPresentFileSystemEntry ? "Present" : "Missing") + "FileSystemEntryWatcher");
              callback("rename", "");
              if (watcher) {
                watcher.close();
                watcher = createWatcher();
              }
            }
            function watchPresentFileSystemEntry() {
              if (options === void 0) {
                if (fsSupportsRecursiveFsWatch) {
                  options = { persistent: true, recursive: !!recursive };
                } else {
                  options = { persistent: true };
                }
              }
              try {
                var presentWatcher = _fs.watch(fileOrDirectory, options, isLinuxOrMacOs ? callbackChangingToMissingFileSystemEntry : callback);
                presentWatcher.on("error", function() {
                  return invokeCallbackAndUpdateWatcher(watchMissingFileSystemEntry);
                });
                return presentWatcher;
              } catch (e) {
                return watchPresentFileSystemEntryWithFsWatchFile();
              }
            }
            function callbackChangingToMissingFileSystemEntry(event, relativeName) {
              return event === "rename" && (!relativeName || relativeName === lastDirectoryPart || relativeName.lastIndexOf(lastDirectoryPartWithDirectorySeparator) === relativeName.length - lastDirectoryPartWithDirectorySeparator.length) && !fileSystemEntryExists(fileOrDirectory, entryKind) ? invokeCallbackAndUpdateWatcher(watchMissingFileSystemEntry) : callback(event, relativeName);
            }
            function watchPresentFileSystemEntryWithFsWatchFile() {
              ts2.sysLog("sysLog:: " + fileOrDirectory + ":: Changing to fsWatchFile");
              return watchFile(fileOrDirectory, createFileWatcherCallback(callback), fallbackPollingInterval, fallbackOptions);
            }
            function watchMissingFileSystemEntry() {
              return watchFile(fileOrDirectory, function(_fileName, eventKind) {
                if (eventKind === FileWatcherEventKind.Created && fileSystemEntryExists(fileOrDirectory, entryKind)) {
                  invokeCallbackAndUpdateWatcher(watchPresentFileSystemEntry);
                }
              }, fallbackPollingInterval, fallbackOptions);
            }
          }
          function readFileWorker(fileName, _encoding) {
            var buffer;
            try {
              buffer = _fs.readFileSync(fileName);
            } catch (e) {
              return void 0;
            }
            var len = buffer.length;
            if (len >= 2 && buffer[0] === 254 && buffer[1] === 255) {
              len &= ~1;
              for (var i = 0; i < len; i += 2) {
                var temp = buffer[i];
                buffer[i] = buffer[i + 1];
                buffer[i + 1] = temp;
              }
              return buffer.toString("utf16le", 2);
            }
            if (len >= 2 && buffer[0] === 255 && buffer[1] === 254) {
              return buffer.toString("utf16le", 2);
            }
            if (len >= 3 && buffer[0] === 239 && buffer[1] === 187 && buffer[2] === 191) {
              return buffer.toString("utf8", 3);
            }
            return buffer.toString("utf8");
          }
          function readFile(fileName, _encoding) {
            ts2.perfLogger.logStartReadFile(fileName);
            var file = readFileWorker(fileName, _encoding);
            ts2.perfLogger.logStopReadFile();
            return file;
          }
          function writeFile(fileName, data, writeByteOrderMark) {
            ts2.perfLogger.logEvent("WriteFile: " + fileName);
            if (writeByteOrderMark) {
              data = byteOrderMarkIndicator + data;
            }
            var fd;
            try {
              fd = _fs.openSync(fileName, "w");
              _fs.writeSync(fd, data, void 0, "utf8");
            } finally {
              if (fd !== void 0) {
                _fs.closeSync(fd);
              }
            }
          }
          function getAccessibleFileSystemEntries(path2) {
            ts2.perfLogger.logEvent("ReadDir: " + (path2 || "."));
            try {
              var entries = _fs.readdirSync(path2 || ".", { withFileTypes: true });
              var files = [];
              var directories = [];
              for (var _i = 0, entries_2 = entries; _i < entries_2.length; _i++) {
                var dirent = entries_2[_i];
                var entry = typeof dirent === "string" ? dirent : dirent.name;
                if (entry === "." || entry === "..") {
                  continue;
                }
                var stat = void 0;
                if (typeof dirent === "string" || dirent.isSymbolicLink()) {
                  var name = ts2.combinePaths(path2, entry);
                  try {
                    stat = statSync(name);
                    if (!stat) {
                      continue;
                    }
                  } catch (e) {
                    continue;
                  }
                } else {
                  stat = dirent;
                }
                if (stat.isFile()) {
                  files.push(entry);
                } else if (stat.isDirectory()) {
                  directories.push(entry);
                }
              }
              files.sort();
              directories.sort();
              return { files, directories };
            } catch (e) {
              return ts2.emptyFileSystemEntries;
            }
          }
          function readDirectory(path2, extensions, excludes, includes, depth) {
            return ts2.matchFiles(path2, extensions, excludes, includes, useCaseSensitiveFileNames, process.cwd(), depth, getAccessibleFileSystemEntries, realpath);
          }
          function fileSystemEntryExists(path2, entryKind) {
            try {
              var stat = statSync(path2);
              if (!stat) {
                return false;
              }
              switch (entryKind) {
                case 0:
                  return stat.isFile();
                case 1:
                  return stat.isDirectory();
                default:
                  return false;
              }
            } catch (e) {
              return false;
            }
          }
          function fileExists(path2) {
            return fileSystemEntryExists(path2, 0);
          }
          function directoryExists(path2) {
            return fileSystemEntryExists(path2, 1);
          }
          function getDirectories(path2) {
            return getAccessibleFileSystemEntries(path2).directories.slice();
          }
          function realpath(path2) {
            try {
              return _fs.realpathSync(path2);
            } catch (_a) {
              return path2;
            }
          }
          function getModifiedTime(path2) {
            var _a;
            try {
              return (_a = statSync(path2)) === null || _a === void 0 ? void 0 : _a.mtime;
            } catch (e) {
              return void 0;
            }
          }
          function setModifiedTime(path2, time) {
            try {
              _fs.utimesSync(path2, time, time);
            } catch (e) {
              return;
            }
          }
          function deleteFile(path2) {
            try {
              return _fs.unlinkSync(path2);
            } catch (e) {
              return;
            }
          }
          function createSHA256Hash(data) {
            var hash = _crypto.createHash("sha256");
            hash.update(data);
            return hash.digest("hex");
          }
        }
        var sys;
        if (typeof process !== "undefined" && process.nextTick && !process.browser && typeof require !== "undefined") {
          sys = getNodeSystem();
        }
        if (sys) {
          patchWriteFileEnsuringDirectory(sys);
        }
        return sys;
      }();
      if (ts2.sys && ts2.sys.getEnvironmentVariable) {
        setCustomPollingValues(ts2.sys);
        ts2.Debug.setAssertionLevel(/^development$/i.test(ts2.sys.getEnvironmentVariable("NODE_ENV")) ? 1 : 0);
      }
      if (ts2.sys && ts2.sys.debugMode) {
        ts2.Debug.isDebugging = true;
      }
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      ts2.directorySeparator = "/";
      var altDirectorySeparator = "\\";
      var urlSchemeSeparator = "://";
      var backslashRegExp = /\\/g;
      function isAnyDirectorySeparator(charCode) {
        return charCode === 47 || charCode === 92;
      }
      ts2.isAnyDirectorySeparator = isAnyDirectorySeparator;
      function isUrl(path2) {
        return getEncodedRootLength(path2) < 0;
      }
      ts2.isUrl = isUrl;
      function isRootedDiskPath(path2) {
        return getEncodedRootLength(path2) > 0;
      }
      ts2.isRootedDiskPath = isRootedDiskPath;
      function isDiskPathRoot(path2) {
        var rootLength = getEncodedRootLength(path2);
        return rootLength > 0 && rootLength === path2.length;
      }
      ts2.isDiskPathRoot = isDiskPathRoot;
      function pathIsAbsolute(path2) {
        return getEncodedRootLength(path2) !== 0;
      }
      ts2.pathIsAbsolute = pathIsAbsolute;
      function pathIsRelative(path2) {
        return /^\.\.?($|[\\/])/.test(path2);
      }
      ts2.pathIsRelative = pathIsRelative;
      function hasExtension(fileName) {
        return ts2.stringContains(getBaseFileName(fileName), ".");
      }
      ts2.hasExtension = hasExtension;
      function fileExtensionIs(path2, extension) {
        return path2.length > extension.length && ts2.endsWith(path2, extension);
      }
      ts2.fileExtensionIs = fileExtensionIs;
      function fileExtensionIsOneOf(path2, extensions) {
        for (var _i = 0, extensions_1 = extensions; _i < extensions_1.length; _i++) {
          var extension = extensions_1[_i];
          if (fileExtensionIs(path2, extension)) {
            return true;
          }
        }
        return false;
      }
      ts2.fileExtensionIsOneOf = fileExtensionIsOneOf;
      function hasTrailingDirectorySeparator(path2) {
        return path2.length > 0 && isAnyDirectorySeparator(path2.charCodeAt(path2.length - 1));
      }
      ts2.hasTrailingDirectorySeparator = hasTrailingDirectorySeparator;
      function isVolumeCharacter(charCode) {
        return charCode >= 97 && charCode <= 122 || charCode >= 65 && charCode <= 90;
      }
      function getFileUrlVolumeSeparatorEnd(url, start) {
        var ch0 = url.charCodeAt(start);
        if (ch0 === 58)
          return start + 1;
        if (ch0 === 37 && url.charCodeAt(start + 1) === 51) {
          var ch2 = url.charCodeAt(start + 2);
          if (ch2 === 97 || ch2 === 65)
            return start + 3;
        }
        return -1;
      }
      function getEncodedRootLength(path2) {
        if (!path2)
          return 0;
        var ch0 = path2.charCodeAt(0);
        if (ch0 === 47 || ch0 === 92) {
          if (path2.charCodeAt(1) !== ch0)
            return 1;
          var p1 = path2.indexOf(ch0 === 47 ? ts2.directorySeparator : altDirectorySeparator, 2);
          if (p1 < 0)
            return path2.length;
          return p1 + 1;
        }
        if (isVolumeCharacter(ch0) && path2.charCodeAt(1) === 58) {
          var ch2 = path2.charCodeAt(2);
          if (ch2 === 47 || ch2 === 92)
            return 3;
          if (path2.length === 2)
            return 2;
        }
        var schemeEnd = path2.indexOf(urlSchemeSeparator);
        if (schemeEnd !== -1) {
          var authorityStart = schemeEnd + urlSchemeSeparator.length;
          var authorityEnd = path2.indexOf(ts2.directorySeparator, authorityStart);
          if (authorityEnd !== -1) {
            var scheme = path2.slice(0, schemeEnd);
            var authority = path2.slice(authorityStart, authorityEnd);
            if (scheme === "file" && (authority === "" || authority === "localhost") && isVolumeCharacter(path2.charCodeAt(authorityEnd + 1))) {
              var volumeSeparatorEnd = getFileUrlVolumeSeparatorEnd(path2, authorityEnd + 2);
              if (volumeSeparatorEnd !== -1) {
                if (path2.charCodeAt(volumeSeparatorEnd) === 47) {
                  return ~(volumeSeparatorEnd + 1);
                }
                if (volumeSeparatorEnd === path2.length) {
                  return ~volumeSeparatorEnd;
                }
              }
            }
            return ~(authorityEnd + 1);
          }
          return ~path2.length;
        }
        return 0;
      }
      function getRootLength(path2) {
        var rootLength = getEncodedRootLength(path2);
        return rootLength < 0 ? ~rootLength : rootLength;
      }
      ts2.getRootLength = getRootLength;
      function getDirectoryPath(path2) {
        path2 = normalizeSlashes(path2);
        var rootLength = getRootLength(path2);
        if (rootLength === path2.length)
          return path2;
        path2 = removeTrailingDirectorySeparator(path2);
        return path2.slice(0, Math.max(rootLength, path2.lastIndexOf(ts2.directorySeparator)));
      }
      ts2.getDirectoryPath = getDirectoryPath;
      function getBaseFileName(path2, extensions, ignoreCase) {
        path2 = normalizeSlashes(path2);
        var rootLength = getRootLength(path2);
        if (rootLength === path2.length)
          return "";
        path2 = removeTrailingDirectorySeparator(path2);
        var name = path2.slice(Math.max(getRootLength(path2), path2.lastIndexOf(ts2.directorySeparator) + 1));
        var extension = extensions !== void 0 && ignoreCase !== void 0 ? getAnyExtensionFromPath(name, extensions, ignoreCase) : void 0;
        return extension ? name.slice(0, name.length - extension.length) : name;
      }
      ts2.getBaseFileName = getBaseFileName;
      function tryGetExtensionFromPath(path2, extension, stringEqualityComparer) {
        if (!ts2.startsWith(extension, "."))
          extension = "." + extension;
        if (path2.length >= extension.length && path2.charCodeAt(path2.length - extension.length) === 46) {
          var pathExtension = path2.slice(path2.length - extension.length);
          if (stringEqualityComparer(pathExtension, extension)) {
            return pathExtension;
          }
        }
      }
      function getAnyExtensionFromPathWorker(path2, extensions, stringEqualityComparer) {
        if (typeof extensions === "string") {
          return tryGetExtensionFromPath(path2, extensions, stringEqualityComparer) || "";
        }
        for (var _i = 0, extensions_2 = extensions; _i < extensions_2.length; _i++) {
          var extension = extensions_2[_i];
          var result = tryGetExtensionFromPath(path2, extension, stringEqualityComparer);
          if (result)
            return result;
        }
        return "";
      }
      function getAnyExtensionFromPath(path2, extensions, ignoreCase) {
        if (extensions) {
          return getAnyExtensionFromPathWorker(removeTrailingDirectorySeparator(path2), extensions, ignoreCase ? ts2.equateStringsCaseInsensitive : ts2.equateStringsCaseSensitive);
        }
        var baseFileName = getBaseFileName(path2);
        var extensionIndex = baseFileName.lastIndexOf(".");
        if (extensionIndex >= 0) {
          return baseFileName.substring(extensionIndex);
        }
        return "";
      }
      ts2.getAnyExtensionFromPath = getAnyExtensionFromPath;
      function pathComponents(path2, rootLength) {
        var root = path2.substring(0, rootLength);
        var rest = path2.substring(rootLength).split(ts2.directorySeparator);
        if (rest.length && !ts2.lastOrUndefined(rest))
          rest.pop();
        return __spreadArrays([root], rest);
      }
      function getPathComponents(path2, currentDirectory) {
        if (currentDirectory === void 0) {
          currentDirectory = "";
        }
        path2 = combinePaths(currentDirectory, path2);
        return pathComponents(path2, getRootLength(path2));
      }
      ts2.getPathComponents = getPathComponents;
      function getPathFromPathComponents(pathComponents2) {
        if (pathComponents2.length === 0)
          return "";
        var root = pathComponents2[0] && ensureTrailingDirectorySeparator(pathComponents2[0]);
        return root + pathComponents2.slice(1).join(ts2.directorySeparator);
      }
      ts2.getPathFromPathComponents = getPathFromPathComponents;
      function normalizeSlashes(path2) {
        return path2.replace(backslashRegExp, ts2.directorySeparator);
      }
      ts2.normalizeSlashes = normalizeSlashes;
      function reducePathComponents(components) {
        if (!ts2.some(components))
          return [];
        var reduced = [components[0]];
        for (var i = 1; i < components.length; i++) {
          var component = components[i];
          if (!component)
            continue;
          if (component === ".")
            continue;
          if (component === "..") {
            if (reduced.length > 1) {
              if (reduced[reduced.length - 1] !== "..") {
                reduced.pop();
                continue;
              }
            } else if (reduced[0])
              continue;
          }
          reduced.push(component);
        }
        return reduced;
      }
      ts2.reducePathComponents = reducePathComponents;
      function combinePaths(path2) {
        var paths = [];
        for (var _i = 1; _i < arguments.length; _i++) {
          paths[_i - 1] = arguments[_i];
        }
        if (path2)
          path2 = normalizeSlashes(path2);
        for (var _a = 0, paths_1 = paths; _a < paths_1.length; _a++) {
          var relativePath = paths_1[_a];
          if (!relativePath)
            continue;
          relativePath = normalizeSlashes(relativePath);
          if (!path2 || getRootLength(relativePath) !== 0) {
            path2 = relativePath;
          } else {
            path2 = ensureTrailingDirectorySeparator(path2) + relativePath;
          }
        }
        return path2;
      }
      ts2.combinePaths = combinePaths;
      function resolvePath(path2) {
        var paths = [];
        for (var _i = 1; _i < arguments.length; _i++) {
          paths[_i - 1] = arguments[_i];
        }
        return normalizePath(ts2.some(paths) ? combinePaths.apply(void 0, __spreadArrays([path2], paths)) : normalizeSlashes(path2));
      }
      ts2.resolvePath = resolvePath;
      function getNormalizedPathComponents(path2, currentDirectory) {
        return reducePathComponents(getPathComponents(path2, currentDirectory));
      }
      ts2.getNormalizedPathComponents = getNormalizedPathComponents;
      function getNormalizedAbsolutePath(fileName, currentDirectory) {
        return getPathFromPathComponents(getNormalizedPathComponents(fileName, currentDirectory));
      }
      ts2.getNormalizedAbsolutePath = getNormalizedAbsolutePath;
      function normalizePath(path2) {
        path2 = normalizeSlashes(path2);
        var normalized = getPathFromPathComponents(reducePathComponents(getPathComponents(path2)));
        return normalized && hasTrailingDirectorySeparator(path2) ? ensureTrailingDirectorySeparator(normalized) : normalized;
      }
      ts2.normalizePath = normalizePath;
      function getPathWithoutRoot(pathComponents2) {
        if (pathComponents2.length === 0)
          return "";
        return pathComponents2.slice(1).join(ts2.directorySeparator);
      }
      function getNormalizedAbsolutePathWithoutRoot(fileName, currentDirectory) {
        return getPathWithoutRoot(getNormalizedPathComponents(fileName, currentDirectory));
      }
      ts2.getNormalizedAbsolutePathWithoutRoot = getNormalizedAbsolutePathWithoutRoot;
      function toPath(fileName, basePath, getCanonicalFileName) {
        var nonCanonicalizedPath = isRootedDiskPath(fileName) ? normalizePath(fileName) : getNormalizedAbsolutePath(fileName, basePath);
        return getCanonicalFileName(nonCanonicalizedPath);
      }
      ts2.toPath = toPath;
      function normalizePathAndParts(path2) {
        path2 = normalizeSlashes(path2);
        var _a = reducePathComponents(getPathComponents(path2)), root = _a[0], parts = _a.slice(1);
        if (parts.length) {
          var joinedParts = root + parts.join(ts2.directorySeparator);
          return { path: hasTrailingDirectorySeparator(path2) ? ensureTrailingDirectorySeparator(joinedParts) : joinedParts, parts };
        } else {
          return { path: root, parts };
        }
      }
      ts2.normalizePathAndParts = normalizePathAndParts;
      function removeTrailingDirectorySeparator(path2) {
        if (hasTrailingDirectorySeparator(path2)) {
          return path2.substr(0, path2.length - 1);
        }
        return path2;
      }
      ts2.removeTrailingDirectorySeparator = removeTrailingDirectorySeparator;
      function ensureTrailingDirectorySeparator(path2) {
        if (!hasTrailingDirectorySeparator(path2)) {
          return path2 + ts2.directorySeparator;
        }
        return path2;
      }
      ts2.ensureTrailingDirectorySeparator = ensureTrailingDirectorySeparator;
      function ensurePathIsNonModuleName(path2) {
        return !pathIsAbsolute(path2) && !pathIsRelative(path2) ? "./" + path2 : path2;
      }
      ts2.ensurePathIsNonModuleName = ensurePathIsNonModuleName;
      function changeAnyExtension(path2, ext, extensions, ignoreCase) {
        var pathext = extensions !== void 0 && ignoreCase !== void 0 ? getAnyExtensionFromPath(path2, extensions, ignoreCase) : getAnyExtensionFromPath(path2);
        return pathext ? path2.slice(0, path2.length - pathext.length) + (ts2.startsWith(ext, ".") ? ext : "." + ext) : path2;
      }
      ts2.changeAnyExtension = changeAnyExtension;
      var relativePathSegmentRegExp = /(^|\/)\.{0,2}($|\/)/;
      function comparePathsWorker(a, b, componentComparer) {
        if (a === b)
          return 0;
        if (a === void 0)
          return -1;
        if (b === void 0)
          return 1;
        var aRoot = a.substring(0, getRootLength(a));
        var bRoot = b.substring(0, getRootLength(b));
        var result = ts2.compareStringsCaseInsensitive(aRoot, bRoot);
        if (result !== 0) {
          return result;
        }
        var aRest = a.substring(aRoot.length);
        var bRest = b.substring(bRoot.length);
        if (!relativePathSegmentRegExp.test(aRest) && !relativePathSegmentRegExp.test(bRest)) {
          return componentComparer(aRest, bRest);
        }
        var aComponents = reducePathComponents(getPathComponents(a));
        var bComponents = reducePathComponents(getPathComponents(b));
        var sharedLength = Math.min(aComponents.length, bComponents.length);
        for (var i = 1; i < sharedLength; i++) {
          var result_1 = componentComparer(aComponents[i], bComponents[i]);
          if (result_1 !== 0) {
            return result_1;
          }
        }
        return ts2.compareValues(aComponents.length, bComponents.length);
      }
      function comparePathsCaseSensitive(a, b) {
        return comparePathsWorker(a, b, ts2.compareStringsCaseSensitive);
      }
      ts2.comparePathsCaseSensitive = comparePathsCaseSensitive;
      function comparePathsCaseInsensitive(a, b) {
        return comparePathsWorker(a, b, ts2.compareStringsCaseInsensitive);
      }
      ts2.comparePathsCaseInsensitive = comparePathsCaseInsensitive;
      function comparePaths(a, b, currentDirectory, ignoreCase) {
        if (typeof currentDirectory === "string") {
          a = combinePaths(currentDirectory, a);
          b = combinePaths(currentDirectory, b);
        } else if (typeof currentDirectory === "boolean") {
          ignoreCase = currentDirectory;
        }
        return comparePathsWorker(a, b, ts2.getStringComparer(ignoreCase));
      }
      ts2.comparePaths = comparePaths;
      function containsPath(parent, child, currentDirectory, ignoreCase) {
        if (typeof currentDirectory === "string") {
          parent = combinePaths(currentDirectory, parent);
          child = combinePaths(currentDirectory, child);
        } else if (typeof currentDirectory === "boolean") {
          ignoreCase = currentDirectory;
        }
        if (parent === void 0 || child === void 0)
          return false;
        if (parent === child)
          return true;
        var parentComponents = reducePathComponents(getPathComponents(parent));
        var childComponents = reducePathComponents(getPathComponents(child));
        if (childComponents.length < parentComponents.length) {
          return false;
        }
        var componentEqualityComparer = ignoreCase ? ts2.equateStringsCaseInsensitive : ts2.equateStringsCaseSensitive;
        for (var i = 0; i < parentComponents.length; i++) {
          var equalityComparer = i === 0 ? ts2.equateStringsCaseInsensitive : componentEqualityComparer;
          if (!equalityComparer(parentComponents[i], childComponents[i])) {
            return false;
          }
        }
        return true;
      }
      ts2.containsPath = containsPath;
      function startsWithDirectory(fileName, directoryName, getCanonicalFileName) {
        var canonicalFileName = getCanonicalFileName(fileName);
        var canonicalDirectoryName = getCanonicalFileName(directoryName);
        return ts2.startsWith(canonicalFileName, canonicalDirectoryName + "/") || ts2.startsWith(canonicalFileName, canonicalDirectoryName + "\\");
      }
      ts2.startsWithDirectory = startsWithDirectory;
      function getPathComponentsRelativeTo(from, to, stringEqualityComparer, getCanonicalFileName) {
        var fromComponents = reducePathComponents(getPathComponents(from));
        var toComponents = reducePathComponents(getPathComponents(to));
        var start;
        for (start = 0; start < fromComponents.length && start < toComponents.length; start++) {
          var fromComponent = getCanonicalFileName(fromComponents[start]);
          var toComponent = getCanonicalFileName(toComponents[start]);
          var comparer = start === 0 ? ts2.equateStringsCaseInsensitive : stringEqualityComparer;
          if (!comparer(fromComponent, toComponent))
            break;
        }
        if (start === 0) {
          return toComponents;
        }
        var components = toComponents.slice(start);
        var relative = [];
        for (; start < fromComponents.length; start++) {
          relative.push("..");
        }
        return __spreadArrays([""], relative, components);
      }
      ts2.getPathComponentsRelativeTo = getPathComponentsRelativeTo;
      function getRelativePathFromDirectory(fromDirectory, to, getCanonicalFileNameOrIgnoreCase) {
        ts2.Debug.assert(getRootLength(fromDirectory) > 0 === getRootLength(to) > 0, "Paths must either both be absolute or both be relative");
        var getCanonicalFileName = typeof getCanonicalFileNameOrIgnoreCase === "function" ? getCanonicalFileNameOrIgnoreCase : ts2.identity;
        var ignoreCase = typeof getCanonicalFileNameOrIgnoreCase === "boolean" ? getCanonicalFileNameOrIgnoreCase : false;
        var pathComponents2 = getPathComponentsRelativeTo(fromDirectory, to, ignoreCase ? ts2.equateStringsCaseInsensitive : ts2.equateStringsCaseSensitive, getCanonicalFileName);
        return getPathFromPathComponents(pathComponents2);
      }
      ts2.getRelativePathFromDirectory = getRelativePathFromDirectory;
      function convertToRelativePath(absoluteOrRelativePath, basePath, getCanonicalFileName) {
        return !isRootedDiskPath(absoluteOrRelativePath) ? absoluteOrRelativePath : getRelativePathToDirectoryOrUrl(basePath, absoluteOrRelativePath, basePath, getCanonicalFileName, false);
      }
      ts2.convertToRelativePath = convertToRelativePath;
      function getRelativePathFromFile(from, to, getCanonicalFileName) {
        return ensurePathIsNonModuleName(getRelativePathFromDirectory(getDirectoryPath(from), to, getCanonicalFileName));
      }
      ts2.getRelativePathFromFile = getRelativePathFromFile;
      function getRelativePathToDirectoryOrUrl(directoryPathOrUrl, relativeOrAbsolutePath, currentDirectory, getCanonicalFileName, isAbsolutePathAnUrl) {
        var pathComponents2 = getPathComponentsRelativeTo(resolvePath(currentDirectory, directoryPathOrUrl), resolvePath(currentDirectory, relativeOrAbsolutePath), ts2.equateStringsCaseSensitive, getCanonicalFileName);
        var firstComponent = pathComponents2[0];
        if (isAbsolutePathAnUrl && isRootedDiskPath(firstComponent)) {
          var prefix = firstComponent.charAt(0) === ts2.directorySeparator ? "file://" : "file:///";
          pathComponents2[0] = prefix + firstComponent;
        }
        return getPathFromPathComponents(pathComponents2);
      }
      ts2.getRelativePathToDirectoryOrUrl = getRelativePathToDirectoryOrUrl;
      function forEachAncestorDirectory(directory, callback) {
        while (true) {
          var result = callback(directory);
          if (result !== void 0) {
            return result;
          }
          var parentPath = getDirectoryPath(directory);
          if (parentPath === directory) {
            return void 0;
          }
          directory = parentPath;
        }
      }
      ts2.forEachAncestorDirectory = forEachAncestorDirectory;
      function isNodeModulesDirectory(dirPath) {
        return ts2.endsWith(dirPath, "/node_modules");
      }
      ts2.isNodeModulesDirectory = isNodeModulesDirectory;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function diag(code, category, key, message, reportsUnnecessary, elidedInCompatabilityPyramid) {
        return { code, category, key, message, reportsUnnecessary, elidedInCompatabilityPyramid };
      }
      ts2.Diagnostics = {
        Unterminated_string_literal: diag(1002, ts2.DiagnosticCategory.Error, "Unterminated_string_literal_1002", "Unterminated string literal."),
        Identifier_expected: diag(1003, ts2.DiagnosticCategory.Error, "Identifier_expected_1003", "Identifier expected."),
        _0_expected: diag(1005, ts2.DiagnosticCategory.Error, "_0_expected_1005", "'{0}' expected."),
        A_file_cannot_have_a_reference_to_itself: diag(1006, ts2.DiagnosticCategory.Error, "A_file_cannot_have_a_reference_to_itself_1006", "A file cannot have a reference to itself."),
        The_parser_expected_to_find_a_to_match_the_token_here: diag(1007, ts2.DiagnosticCategory.Error, "The_parser_expected_to_find_a_to_match_the_token_here_1007", "The parser expected to find a '}' to match the '{' token here."),
        Trailing_comma_not_allowed: diag(1009, ts2.DiagnosticCategory.Error, "Trailing_comma_not_allowed_1009", "Trailing comma not allowed."),
        Asterisk_Slash_expected: diag(1010, ts2.DiagnosticCategory.Error, "Asterisk_Slash_expected_1010", "'*/' expected."),
        An_element_access_expression_should_take_an_argument: diag(1011, ts2.DiagnosticCategory.Error, "An_element_access_expression_should_take_an_argument_1011", "An element access expression should take an argument."),
        Unexpected_token: diag(1012, ts2.DiagnosticCategory.Error, "Unexpected_token_1012", "Unexpected token."),
        A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma: diag(1013, ts2.DiagnosticCategory.Error, "A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma_1013", "A rest parameter or binding pattern may not have a trailing comma."),
        A_rest_parameter_must_be_last_in_a_parameter_list: diag(1014, ts2.DiagnosticCategory.Error, "A_rest_parameter_must_be_last_in_a_parameter_list_1014", "A rest parameter must be last in a parameter list."),
        Parameter_cannot_have_question_mark_and_initializer: diag(1015, ts2.DiagnosticCategory.Error, "Parameter_cannot_have_question_mark_and_initializer_1015", "Parameter cannot have question mark and initializer."),
        A_required_parameter_cannot_follow_an_optional_parameter: diag(1016, ts2.DiagnosticCategory.Error, "A_required_parameter_cannot_follow_an_optional_parameter_1016", "A required parameter cannot follow an optional parameter."),
        An_index_signature_cannot_have_a_rest_parameter: diag(1017, ts2.DiagnosticCategory.Error, "An_index_signature_cannot_have_a_rest_parameter_1017", "An index signature cannot have a rest parameter."),
        An_index_signature_parameter_cannot_have_an_accessibility_modifier: diag(1018, ts2.DiagnosticCategory.Error, "An_index_signature_parameter_cannot_have_an_accessibility_modifier_1018", "An index signature parameter cannot have an accessibility modifier."),
        An_index_signature_parameter_cannot_have_a_question_mark: diag(1019, ts2.DiagnosticCategory.Error, "An_index_signature_parameter_cannot_have_a_question_mark_1019", "An index signature parameter cannot have a question mark."),
        An_index_signature_parameter_cannot_have_an_initializer: diag(1020, ts2.DiagnosticCategory.Error, "An_index_signature_parameter_cannot_have_an_initializer_1020", "An index signature parameter cannot have an initializer."),
        An_index_signature_must_have_a_type_annotation: diag(1021, ts2.DiagnosticCategory.Error, "An_index_signature_must_have_a_type_annotation_1021", "An index signature must have a type annotation."),
        An_index_signature_parameter_must_have_a_type_annotation: diag(1022, ts2.DiagnosticCategory.Error, "An_index_signature_parameter_must_have_a_type_annotation_1022", "An index signature parameter must have a type annotation."),
        An_index_signature_parameter_type_must_be_either_string_or_number: diag(1023, ts2.DiagnosticCategory.Error, "An_index_signature_parameter_type_must_be_either_string_or_number_1023", "An index signature parameter type must be either 'string' or 'number'."),
        readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature: diag(1024, ts2.DiagnosticCategory.Error, "readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature_1024", "'readonly' modifier can only appear on a property declaration or index signature."),
        An_index_signature_cannot_have_a_trailing_comma: diag(1025, ts2.DiagnosticCategory.Error, "An_index_signature_cannot_have_a_trailing_comma_1025", "An index signature cannot have a trailing comma."),
        Accessibility_modifier_already_seen: diag(1028, ts2.DiagnosticCategory.Error, "Accessibility_modifier_already_seen_1028", "Accessibility modifier already seen."),
        _0_modifier_must_precede_1_modifier: diag(1029, ts2.DiagnosticCategory.Error, "_0_modifier_must_precede_1_modifier_1029", "'{0}' modifier must precede '{1}' modifier."),
        _0_modifier_already_seen: diag(1030, ts2.DiagnosticCategory.Error, "_0_modifier_already_seen_1030", "'{0}' modifier already seen."),
        _0_modifier_cannot_appear_on_a_class_element: diag(1031, ts2.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_class_element_1031", "'{0}' modifier cannot appear on a class element."),
        super_must_be_followed_by_an_argument_list_or_member_access: diag(1034, ts2.DiagnosticCategory.Error, "super_must_be_followed_by_an_argument_list_or_member_access_1034", "'super' must be followed by an argument list or member access."),
        Only_ambient_modules_can_use_quoted_names: diag(1035, ts2.DiagnosticCategory.Error, "Only_ambient_modules_can_use_quoted_names_1035", "Only ambient modules can use quoted names."),
        Statements_are_not_allowed_in_ambient_contexts: diag(1036, ts2.DiagnosticCategory.Error, "Statements_are_not_allowed_in_ambient_contexts_1036", "Statements are not allowed in ambient contexts."),
        A_declare_modifier_cannot_be_used_in_an_already_ambient_context: diag(1038, ts2.DiagnosticCategory.Error, "A_declare_modifier_cannot_be_used_in_an_already_ambient_context_1038", "A 'declare' modifier cannot be used in an already ambient context."),
        Initializers_are_not_allowed_in_ambient_contexts: diag(1039, ts2.DiagnosticCategory.Error, "Initializers_are_not_allowed_in_ambient_contexts_1039", "Initializers are not allowed in ambient contexts."),
        _0_modifier_cannot_be_used_in_an_ambient_context: diag(1040, ts2.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_in_an_ambient_context_1040", "'{0}' modifier cannot be used in an ambient context."),
        _0_modifier_cannot_be_used_with_a_class_declaration: diag(1041, ts2.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_with_a_class_declaration_1041", "'{0}' modifier cannot be used with a class declaration."),
        _0_modifier_cannot_be_used_here: diag(1042, ts2.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_here_1042", "'{0}' modifier cannot be used here."),
        _0_modifier_cannot_appear_on_a_data_property: diag(1043, ts2.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_data_property_1043", "'{0}' modifier cannot appear on a data property."),
        _0_modifier_cannot_appear_on_a_module_or_namespace_element: diag(1044, ts2.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_module_or_namespace_element_1044", "'{0}' modifier cannot appear on a module or namespace element."),
        A_0_modifier_cannot_be_used_with_an_interface_declaration: diag(1045, ts2.DiagnosticCategory.Error, "A_0_modifier_cannot_be_used_with_an_interface_declaration_1045", "A '{0}' modifier cannot be used with an interface declaration."),
        Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier: diag(1046, ts2.DiagnosticCategory.Error, "Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier_1046", "Top-level declarations in .d.ts files must start with either a 'declare' or 'export' modifier."),
        A_rest_parameter_cannot_be_optional: diag(1047, ts2.DiagnosticCategory.Error, "A_rest_parameter_cannot_be_optional_1047", "A rest parameter cannot be optional."),
        A_rest_parameter_cannot_have_an_initializer: diag(1048, ts2.DiagnosticCategory.Error, "A_rest_parameter_cannot_have_an_initializer_1048", "A rest parameter cannot have an initializer."),
        A_set_accessor_must_have_exactly_one_parameter: diag(1049, ts2.DiagnosticCategory.Error, "A_set_accessor_must_have_exactly_one_parameter_1049", "A 'set' accessor must have exactly one parameter."),
        A_set_accessor_cannot_have_an_optional_parameter: diag(1051, ts2.DiagnosticCategory.Error, "A_set_accessor_cannot_have_an_optional_parameter_1051", "A 'set' accessor cannot have an optional parameter."),
        A_set_accessor_parameter_cannot_have_an_initializer: diag(1052, ts2.DiagnosticCategory.Error, "A_set_accessor_parameter_cannot_have_an_initializer_1052", "A 'set' accessor parameter cannot have an initializer."),
        A_set_accessor_cannot_have_rest_parameter: diag(1053, ts2.DiagnosticCategory.Error, "A_set_accessor_cannot_have_rest_parameter_1053", "A 'set' accessor cannot have rest parameter."),
        A_get_accessor_cannot_have_parameters: diag(1054, ts2.DiagnosticCategory.Error, "A_get_accessor_cannot_have_parameters_1054", "A 'get' accessor cannot have parameters."),
        Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value: diag(1055, ts2.DiagnosticCategory.Error, "Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Prom_1055", "Type '{0}' is not a valid async function return type in ES5/ES3 because it does not refer to a Promise-compatible constructor value."),
        Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher: diag(1056, ts2.DiagnosticCategory.Error, "Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher_1056", "Accessors are only available when targeting ECMAScript 5 and higher."),
        An_async_function_or_method_must_have_a_valid_awaitable_return_type: diag(1057, ts2.DiagnosticCategory.Error, "An_async_function_or_method_must_have_a_valid_awaitable_return_type_1057", "An async function or method must have a valid awaitable return type."),
        The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: diag(1058, ts2.DiagnosticCategory.Error, "The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_t_1058", "The return type of an async function must either be a valid promise or must not contain a callable 'then' member."),
        A_promise_must_have_a_then_method: diag(1059, ts2.DiagnosticCategory.Error, "A_promise_must_have_a_then_method_1059", "A promise must have a 'then' method."),
        The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback: diag(1060, ts2.DiagnosticCategory.Error, "The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback_1060", "The first parameter of the 'then' method of a promise must be a callback."),
        Enum_member_must_have_initializer: diag(1061, ts2.DiagnosticCategory.Error, "Enum_member_must_have_initializer_1061", "Enum member must have initializer."),
        Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method: diag(1062, ts2.DiagnosticCategory.Error, "Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method_1062", "Type is referenced directly or indirectly in the fulfillment callback of its own 'then' method."),
        An_export_assignment_cannot_be_used_in_a_namespace: diag(1063, ts2.DiagnosticCategory.Error, "An_export_assignment_cannot_be_used_in_a_namespace_1063", "An export assignment cannot be used in a namespace."),
        The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type: diag(1064, ts2.DiagnosticCategory.Error, "The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_1064", "The return type of an async function or method must be the global Promise<T> type."),
        In_ambient_enum_declarations_member_initializer_must_be_constant_expression: diag(1066, ts2.DiagnosticCategory.Error, "In_ambient_enum_declarations_member_initializer_must_be_constant_expression_1066", "In ambient enum declarations member initializer must be constant expression."),
        Unexpected_token_A_constructor_method_accessor_or_property_was_expected: diag(1068, ts2.DiagnosticCategory.Error, "Unexpected_token_A_constructor_method_accessor_or_property_was_expected_1068", "Unexpected token. A constructor, method, accessor, or property was expected."),
        Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces: diag(1069, ts2.DiagnosticCategory.Error, "Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces_1069", "Unexpected token. A type parameter name was expected without curly braces."),
        _0_modifier_cannot_appear_on_a_type_member: diag(1070, ts2.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_type_member_1070", "'{0}' modifier cannot appear on a type member."),
        _0_modifier_cannot_appear_on_an_index_signature: diag(1071, ts2.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_an_index_signature_1071", "'{0}' modifier cannot appear on an index signature."),
        A_0_modifier_cannot_be_used_with_an_import_declaration: diag(1079, ts2.DiagnosticCategory.Error, "A_0_modifier_cannot_be_used_with_an_import_declaration_1079", "A '{0}' modifier cannot be used with an import declaration."),
        Invalid_reference_directive_syntax: diag(1084, ts2.DiagnosticCategory.Error, "Invalid_reference_directive_syntax_1084", "Invalid 'reference' directive syntax."),
        Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0: diag(1085, ts2.DiagnosticCategory.Error, "Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0_1085", "Octal literals are not available when targeting ECMAScript 5 and higher. Use the syntax '{0}'."),
        _0_modifier_cannot_appear_on_a_constructor_declaration: diag(1089, ts2.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_constructor_declaration_1089", "'{0}' modifier cannot appear on a constructor declaration."),
        _0_modifier_cannot_appear_on_a_parameter: diag(1090, ts2.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_parameter_1090", "'{0}' modifier cannot appear on a parameter."),
        Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement: diag(1091, ts2.DiagnosticCategory.Error, "Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement_1091", "Only a single variable declaration is allowed in a 'for...in' statement."),
        Type_parameters_cannot_appear_on_a_constructor_declaration: diag(1092, ts2.DiagnosticCategory.Error, "Type_parameters_cannot_appear_on_a_constructor_declaration_1092", "Type parameters cannot appear on a constructor declaration."),
        Type_annotation_cannot_appear_on_a_constructor_declaration: diag(1093, ts2.DiagnosticCategory.Error, "Type_annotation_cannot_appear_on_a_constructor_declaration_1093", "Type annotation cannot appear on a constructor declaration."),
        An_accessor_cannot_have_type_parameters: diag(1094, ts2.DiagnosticCategory.Error, "An_accessor_cannot_have_type_parameters_1094", "An accessor cannot have type parameters."),
        A_set_accessor_cannot_have_a_return_type_annotation: diag(1095, ts2.DiagnosticCategory.Error, "A_set_accessor_cannot_have_a_return_type_annotation_1095", "A 'set' accessor cannot have a return type annotation."),
        An_index_signature_must_have_exactly_one_parameter: diag(1096, ts2.DiagnosticCategory.Error, "An_index_signature_must_have_exactly_one_parameter_1096", "An index signature must have exactly one parameter."),
        _0_list_cannot_be_empty: diag(1097, ts2.DiagnosticCategory.Error, "_0_list_cannot_be_empty_1097", "'{0}' list cannot be empty."),
        Type_parameter_list_cannot_be_empty: diag(1098, ts2.DiagnosticCategory.Error, "Type_parameter_list_cannot_be_empty_1098", "Type parameter list cannot be empty."),
        Type_argument_list_cannot_be_empty: diag(1099, ts2.DiagnosticCategory.Error, "Type_argument_list_cannot_be_empty_1099", "Type argument list cannot be empty."),
        Invalid_use_of_0_in_strict_mode: diag(1100, ts2.DiagnosticCategory.Error, "Invalid_use_of_0_in_strict_mode_1100", "Invalid use of '{0}' in strict mode."),
        with_statements_are_not_allowed_in_strict_mode: diag(1101, ts2.DiagnosticCategory.Error, "with_statements_are_not_allowed_in_strict_mode_1101", "'with' statements are not allowed in strict mode."),
        delete_cannot_be_called_on_an_identifier_in_strict_mode: diag(1102, ts2.DiagnosticCategory.Error, "delete_cannot_be_called_on_an_identifier_in_strict_mode_1102", "'delete' cannot be called on an identifier in strict mode."),
        A_for_await_of_statement_is_only_allowed_within_an_async_function_or_async_generator: diag(1103, ts2.DiagnosticCategory.Error, "A_for_await_of_statement_is_only_allowed_within_an_async_function_or_async_generator_1103", "A 'for-await-of' statement is only allowed within an async function or async generator."),
        A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement: diag(1104, ts2.DiagnosticCategory.Error, "A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement_1104", "A 'continue' statement can only be used within an enclosing iteration statement."),
        A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement: diag(1105, ts2.DiagnosticCategory.Error, "A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement_1105", "A 'break' statement can only be used within an enclosing iteration or switch statement."),
        Jump_target_cannot_cross_function_boundary: diag(1107, ts2.DiagnosticCategory.Error, "Jump_target_cannot_cross_function_boundary_1107", "Jump target cannot cross function boundary."),
        A_return_statement_can_only_be_used_within_a_function_body: diag(1108, ts2.DiagnosticCategory.Error, "A_return_statement_can_only_be_used_within_a_function_body_1108", "A 'return' statement can only be used within a function body."),
        Expression_expected: diag(1109, ts2.DiagnosticCategory.Error, "Expression_expected_1109", "Expression expected."),
        Type_expected: diag(1110, ts2.DiagnosticCategory.Error, "Type_expected_1110", "Type expected."),
        A_default_clause_cannot_appear_more_than_once_in_a_switch_statement: diag(1113, ts2.DiagnosticCategory.Error, "A_default_clause_cannot_appear_more_than_once_in_a_switch_statement_1113", "A 'default' clause cannot appear more than once in a 'switch' statement."),
        Duplicate_label_0: diag(1114, ts2.DiagnosticCategory.Error, "Duplicate_label_0_1114", "Duplicate label '{0}'."),
        A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement: diag(1115, ts2.DiagnosticCategory.Error, "A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement_1115", "A 'continue' statement can only jump to a label of an enclosing iteration statement."),
        A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement: diag(1116, ts2.DiagnosticCategory.Error, "A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement_1116", "A 'break' statement can only jump to a label of an enclosing statement."),
        An_object_literal_cannot_have_multiple_properties_with_the_same_name_in_strict_mode: diag(1117, ts2.DiagnosticCategory.Error, "An_object_literal_cannot_have_multiple_properties_with_the_same_name_in_strict_mode_1117", "An object literal cannot have multiple properties with the same name in strict mode."),
        An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name: diag(1118, ts2.DiagnosticCategory.Error, "An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name_1118", "An object literal cannot have multiple get/set accessors with the same name."),
        An_object_literal_cannot_have_property_and_accessor_with_the_same_name: diag(1119, ts2.DiagnosticCategory.Error, "An_object_literal_cannot_have_property_and_accessor_with_the_same_name_1119", "An object literal cannot have property and accessor with the same name."),
        An_export_assignment_cannot_have_modifiers: diag(1120, ts2.DiagnosticCategory.Error, "An_export_assignment_cannot_have_modifiers_1120", "An export assignment cannot have modifiers."),
        Octal_literals_are_not_allowed_in_strict_mode: diag(1121, ts2.DiagnosticCategory.Error, "Octal_literals_are_not_allowed_in_strict_mode_1121", "Octal literals are not allowed in strict mode."),
        Variable_declaration_list_cannot_be_empty: diag(1123, ts2.DiagnosticCategory.Error, "Variable_declaration_list_cannot_be_empty_1123", "Variable declaration list cannot be empty."),
        Digit_expected: diag(1124, ts2.DiagnosticCategory.Error, "Digit_expected_1124", "Digit expected."),
        Hexadecimal_digit_expected: diag(1125, ts2.DiagnosticCategory.Error, "Hexadecimal_digit_expected_1125", "Hexadecimal digit expected."),
        Unexpected_end_of_text: diag(1126, ts2.DiagnosticCategory.Error, "Unexpected_end_of_text_1126", "Unexpected end of text."),
        Invalid_character: diag(1127, ts2.DiagnosticCategory.Error, "Invalid_character_1127", "Invalid character."),
        Declaration_or_statement_expected: diag(1128, ts2.DiagnosticCategory.Error, "Declaration_or_statement_expected_1128", "Declaration or statement expected."),
        Statement_expected: diag(1129, ts2.DiagnosticCategory.Error, "Statement_expected_1129", "Statement expected."),
        case_or_default_expected: diag(1130, ts2.DiagnosticCategory.Error, "case_or_default_expected_1130", "'case' or 'default' expected."),
        Property_or_signature_expected: diag(1131, ts2.DiagnosticCategory.Error, "Property_or_signature_expected_1131", "Property or signature expected."),
        Enum_member_expected: diag(1132, ts2.DiagnosticCategory.Error, "Enum_member_expected_1132", "Enum member expected."),
        Variable_declaration_expected: diag(1134, ts2.DiagnosticCategory.Error, "Variable_declaration_expected_1134", "Variable declaration expected."),
        Argument_expression_expected: diag(1135, ts2.DiagnosticCategory.Error, "Argument_expression_expected_1135", "Argument expression expected."),
        Property_assignment_expected: diag(1136, ts2.DiagnosticCategory.Error, "Property_assignment_expected_1136", "Property assignment expected."),
        Expression_or_comma_expected: diag(1137, ts2.DiagnosticCategory.Error, "Expression_or_comma_expected_1137", "Expression or comma expected."),
        Parameter_declaration_expected: diag(1138, ts2.DiagnosticCategory.Error, "Parameter_declaration_expected_1138", "Parameter declaration expected."),
        Type_parameter_declaration_expected: diag(1139, ts2.DiagnosticCategory.Error, "Type_parameter_declaration_expected_1139", "Type parameter declaration expected."),
        Type_argument_expected: diag(1140, ts2.DiagnosticCategory.Error, "Type_argument_expected_1140", "Type argument expected."),
        String_literal_expected: diag(1141, ts2.DiagnosticCategory.Error, "String_literal_expected_1141", "String literal expected."),
        Line_break_not_permitted_here: diag(1142, ts2.DiagnosticCategory.Error, "Line_break_not_permitted_here_1142", "Line break not permitted here."),
        or_expected: diag(1144, ts2.DiagnosticCategory.Error, "or_expected_1144", "'{' or ';' expected."),
        Declaration_expected: diag(1146, ts2.DiagnosticCategory.Error, "Declaration_expected_1146", "Declaration expected."),
        Import_declarations_in_a_namespace_cannot_reference_a_module: diag(1147, ts2.DiagnosticCategory.Error, "Import_declarations_in_a_namespace_cannot_reference_a_module_1147", "Import declarations in a namespace cannot reference a module."),
        Cannot_use_imports_exports_or_module_augmentations_when_module_is_none: diag(1148, ts2.DiagnosticCategory.Error, "Cannot_use_imports_exports_or_module_augmentations_when_module_is_none_1148", "Cannot use imports, exports, or module augmentations when '--module' is 'none'."),
        File_name_0_differs_from_already_included_file_name_1_only_in_casing: diag(1149, ts2.DiagnosticCategory.Error, "File_name_0_differs_from_already_included_file_name_1_only_in_casing_1149", "File name '{0}' differs from already included file name '{1}' only in casing."),
        const_declarations_must_be_initialized: diag(1155, ts2.DiagnosticCategory.Error, "const_declarations_must_be_initialized_1155", "'const' declarations must be initialized."),
        const_declarations_can_only_be_declared_inside_a_block: diag(1156, ts2.DiagnosticCategory.Error, "const_declarations_can_only_be_declared_inside_a_block_1156", "'const' declarations can only be declared inside a block."),
        let_declarations_can_only_be_declared_inside_a_block: diag(1157, ts2.DiagnosticCategory.Error, "let_declarations_can_only_be_declared_inside_a_block_1157", "'let' declarations can only be declared inside a block."),
        Unterminated_template_literal: diag(1160, ts2.DiagnosticCategory.Error, "Unterminated_template_literal_1160", "Unterminated template literal."),
        Unterminated_regular_expression_literal: diag(1161, ts2.DiagnosticCategory.Error, "Unterminated_regular_expression_literal_1161", "Unterminated regular expression literal."),
        An_object_member_cannot_be_declared_optional: diag(1162, ts2.DiagnosticCategory.Error, "An_object_member_cannot_be_declared_optional_1162", "An object member cannot be declared optional."),
        A_yield_expression_is_only_allowed_in_a_generator_body: diag(1163, ts2.DiagnosticCategory.Error, "A_yield_expression_is_only_allowed_in_a_generator_body_1163", "A 'yield' expression is only allowed in a generator body."),
        Computed_property_names_are_not_allowed_in_enums: diag(1164, ts2.DiagnosticCategory.Error, "Computed_property_names_are_not_allowed_in_enums_1164", "Computed property names are not allowed in enums."),
        A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: diag(1165, ts2.DiagnosticCategory.Error, "A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_t_1165", "A computed property name in an ambient context must refer to an expression whose type is a literal type or a 'unique symbol' type."),
        A_computed_property_name_in_a_class_property_declaration_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: diag(1166, ts2.DiagnosticCategory.Error, "A_computed_property_name_in_a_class_property_declaration_must_refer_to_an_expression_whose_type_is_a_1166", "A computed property name in a class property declaration must refer to an expression whose type is a literal type or a 'unique symbol' type."),
        A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: diag(1168, ts2.DiagnosticCategory.Error, "A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_ty_1168", "A computed property name in a method overload must refer to an expression whose type is a literal type or a 'unique symbol' type."),
        A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: diag(1169, ts2.DiagnosticCategory.Error, "A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_1169", "A computed property name in an interface must refer to an expression whose type is a literal type or a 'unique symbol' type."),
        A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: diag(1170, ts2.DiagnosticCategory.Error, "A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type__1170", "A computed property name in a type literal must refer to an expression whose type is a literal type or a 'unique symbol' type."),
        A_comma_expression_is_not_allowed_in_a_computed_property_name: diag(1171, ts2.DiagnosticCategory.Error, "A_comma_expression_is_not_allowed_in_a_computed_property_name_1171", "A comma expression is not allowed in a computed property name."),
        extends_clause_already_seen: diag(1172, ts2.DiagnosticCategory.Error, "extends_clause_already_seen_1172", "'extends' clause already seen."),
        extends_clause_must_precede_implements_clause: diag(1173, ts2.DiagnosticCategory.Error, "extends_clause_must_precede_implements_clause_1173", "'extends' clause must precede 'implements' clause."),
        Classes_can_only_extend_a_single_class: diag(1174, ts2.DiagnosticCategory.Error, "Classes_can_only_extend_a_single_class_1174", "Classes can only extend a single class."),
        implements_clause_already_seen: diag(1175, ts2.DiagnosticCategory.Error, "implements_clause_already_seen_1175", "'implements' clause already seen."),
        Interface_declaration_cannot_have_implements_clause: diag(1176, ts2.DiagnosticCategory.Error, "Interface_declaration_cannot_have_implements_clause_1176", "Interface declaration cannot have 'implements' clause."),
        Binary_digit_expected: diag(1177, ts2.DiagnosticCategory.Error, "Binary_digit_expected_1177", "Binary digit expected."),
        Octal_digit_expected: diag(1178, ts2.DiagnosticCategory.Error, "Octal_digit_expected_1178", "Octal digit expected."),
        Unexpected_token_expected: diag(1179, ts2.DiagnosticCategory.Error, "Unexpected_token_expected_1179", "Unexpected token. '{' expected."),
        Property_destructuring_pattern_expected: diag(1180, ts2.DiagnosticCategory.Error, "Property_destructuring_pattern_expected_1180", "Property destructuring pattern expected."),
        Array_element_destructuring_pattern_expected: diag(1181, ts2.DiagnosticCategory.Error, "Array_element_destructuring_pattern_expected_1181", "Array element destructuring pattern expected."),
        A_destructuring_declaration_must_have_an_initializer: diag(1182, ts2.DiagnosticCategory.Error, "A_destructuring_declaration_must_have_an_initializer_1182", "A destructuring declaration must have an initializer."),
        An_implementation_cannot_be_declared_in_ambient_contexts: diag(1183, ts2.DiagnosticCategory.Error, "An_implementation_cannot_be_declared_in_ambient_contexts_1183", "An implementation cannot be declared in ambient contexts."),
        Modifiers_cannot_appear_here: diag(1184, ts2.DiagnosticCategory.Error, "Modifiers_cannot_appear_here_1184", "Modifiers cannot appear here."),
        Merge_conflict_marker_encountered: diag(1185, ts2.DiagnosticCategory.Error, "Merge_conflict_marker_encountered_1185", "Merge conflict marker encountered."),
        A_rest_element_cannot_have_an_initializer: diag(1186, ts2.DiagnosticCategory.Error, "A_rest_element_cannot_have_an_initializer_1186", "A rest element cannot have an initializer."),
        A_parameter_property_may_not_be_declared_using_a_binding_pattern: diag(1187, ts2.DiagnosticCategory.Error, "A_parameter_property_may_not_be_declared_using_a_binding_pattern_1187", "A parameter property may not be declared using a binding pattern."),
        Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement: diag(1188, ts2.DiagnosticCategory.Error, "Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement_1188", "Only a single variable declaration is allowed in a 'for...of' statement."),
        The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer: diag(1189, ts2.DiagnosticCategory.Error, "The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer_1189", "The variable declaration of a 'for...in' statement cannot have an initializer."),
        The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer: diag(1190, ts2.DiagnosticCategory.Error, "The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer_1190", "The variable declaration of a 'for...of' statement cannot have an initializer."),
        An_import_declaration_cannot_have_modifiers: diag(1191, ts2.DiagnosticCategory.Error, "An_import_declaration_cannot_have_modifiers_1191", "An import declaration cannot have modifiers."),
        Module_0_has_no_default_export: diag(1192, ts2.DiagnosticCategory.Error, "Module_0_has_no_default_export_1192", "Module '{0}' has no default export."),
        An_export_declaration_cannot_have_modifiers: diag(1193, ts2.DiagnosticCategory.Error, "An_export_declaration_cannot_have_modifiers_1193", "An export declaration cannot have modifiers."),
        Export_declarations_are_not_permitted_in_a_namespace: diag(1194, ts2.DiagnosticCategory.Error, "Export_declarations_are_not_permitted_in_a_namespace_1194", "Export declarations are not permitted in a namespace."),
        export_Asterisk_does_not_re_export_a_default: diag(1195, ts2.DiagnosticCategory.Error, "export_Asterisk_does_not_re_export_a_default_1195", "'export *' does not re-export a default."),
        Catch_clause_variable_cannot_have_a_type_annotation: diag(1196, ts2.DiagnosticCategory.Error, "Catch_clause_variable_cannot_have_a_type_annotation_1196", "Catch clause variable cannot have a type annotation."),
        Catch_clause_variable_cannot_have_an_initializer: diag(1197, ts2.DiagnosticCategory.Error, "Catch_clause_variable_cannot_have_an_initializer_1197", "Catch clause variable cannot have an initializer."),
        An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive: diag(1198, ts2.DiagnosticCategory.Error, "An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive_1198", "An extended Unicode escape value must be between 0x0 and 0x10FFFF inclusive."),
        Unterminated_Unicode_escape_sequence: diag(1199, ts2.DiagnosticCategory.Error, "Unterminated_Unicode_escape_sequence_1199", "Unterminated Unicode escape sequence."),
        Line_terminator_not_permitted_before_arrow: diag(1200, ts2.DiagnosticCategory.Error, "Line_terminator_not_permitted_before_arrow_1200", "Line terminator not permitted before arrow."),
        Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead: diag(1202, ts2.DiagnosticCategory.Error, "Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_1202", `Import assignment cannot be used when targeting ECMAScript modules. Consider using 'import * as ns from "mod"', 'import {a} from "mod"', 'import d from "mod"', or another module format instead.`),
        Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or_another_module_format_instead: diag(1203, ts2.DiagnosticCategory.Error, "Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or__1203", "Export assignment cannot be used when targeting ECMAScript modules. Consider using 'export default' or another module format instead."),
        Re_exporting_a_type_when_the_isolatedModules_flag_is_provided_requires_using_export_type: diag(1205, ts2.DiagnosticCategory.Error, "Re_exporting_a_type_when_the_isolatedModules_flag_is_provided_requires_using_export_type_1205", "Re-exporting a type when the '--isolatedModules' flag is provided requires using 'export type'."),
        Decorators_are_not_valid_here: diag(1206, ts2.DiagnosticCategory.Error, "Decorators_are_not_valid_here_1206", "Decorators are not valid here."),
        Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name: diag(1207, ts2.DiagnosticCategory.Error, "Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name_1207", "Decorators cannot be applied to multiple get/set accessors of the same name."),
        All_files_must_be_modules_when_the_isolatedModules_flag_is_provided: diag(1208, ts2.DiagnosticCategory.Error, "All_files_must_be_modules_when_the_isolatedModules_flag_is_provided_1208", "All files must be modules when the '--isolatedModules' flag is provided."),
        Invalid_use_of_0_Class_definitions_are_automatically_in_strict_mode: diag(1210, ts2.DiagnosticCategory.Error, "Invalid_use_of_0_Class_definitions_are_automatically_in_strict_mode_1210", "Invalid use of '{0}'. Class definitions are automatically in strict mode."),
        A_class_declaration_without_the_default_modifier_must_have_a_name: diag(1211, ts2.DiagnosticCategory.Error, "A_class_declaration_without_the_default_modifier_must_have_a_name_1211", "A class declaration without the 'default' modifier must have a name."),
        Identifier_expected_0_is_a_reserved_word_in_strict_mode: diag(1212, ts2.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_in_strict_mode_1212", "Identifier expected. '{0}' is a reserved word in strict mode."),
        Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode: diag(1213, ts2.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_stric_1213", "Identifier expected. '{0}' is a reserved word in strict mode. Class definitions are automatically in strict mode."),
        Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode: diag(1214, ts2.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode_1214", "Identifier expected. '{0}' is a reserved word in strict mode. Modules are automatically in strict mode."),
        Invalid_use_of_0_Modules_are_automatically_in_strict_mode: diag(1215, ts2.DiagnosticCategory.Error, "Invalid_use_of_0_Modules_are_automatically_in_strict_mode_1215", "Invalid use of '{0}'. Modules are automatically in strict mode."),
        Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules: diag(1216, ts2.DiagnosticCategory.Error, "Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules_1216", "Identifier expected. '__esModule' is reserved as an exported marker when transforming ECMAScript modules."),
        Export_assignment_is_not_supported_when_module_flag_is_system: diag(1218, ts2.DiagnosticCategory.Error, "Export_assignment_is_not_supported_when_module_flag_is_system_1218", "Export assignment is not supported when '--module' flag is 'system'."),
        Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning: diag(1219, ts2.DiagnosticCategory.Error, "Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_t_1219", "Experimental support for decorators is a feature that is subject to change in a future release. Set the 'experimentalDecorators' option in your 'tsconfig' or 'jsconfig' to remove this warning."),
        Generators_are_only_available_when_targeting_ECMAScript_2015_or_higher: diag(1220, ts2.DiagnosticCategory.Error, "Generators_are_only_available_when_targeting_ECMAScript_2015_or_higher_1220", "Generators are only available when targeting ECMAScript 2015 or higher."),
        Generators_are_not_allowed_in_an_ambient_context: diag(1221, ts2.DiagnosticCategory.Error, "Generators_are_not_allowed_in_an_ambient_context_1221", "Generators are not allowed in an ambient context."),
        An_overload_signature_cannot_be_declared_as_a_generator: diag(1222, ts2.DiagnosticCategory.Error, "An_overload_signature_cannot_be_declared_as_a_generator_1222", "An overload signature cannot be declared as a generator."),
        _0_tag_already_specified: diag(1223, ts2.DiagnosticCategory.Error, "_0_tag_already_specified_1223", "'{0}' tag already specified."),
        Signature_0_must_be_a_type_predicate: diag(1224, ts2.DiagnosticCategory.Error, "Signature_0_must_be_a_type_predicate_1224", "Signature '{0}' must be a type predicate."),
        Cannot_find_parameter_0: diag(1225, ts2.DiagnosticCategory.Error, "Cannot_find_parameter_0_1225", "Cannot find parameter '{0}'."),
        Type_predicate_0_is_not_assignable_to_1: diag(1226, ts2.DiagnosticCategory.Error, "Type_predicate_0_is_not_assignable_to_1_1226", "Type predicate '{0}' is not assignable to '{1}'."),
        Parameter_0_is_not_in_the_same_position_as_parameter_1: diag(1227, ts2.DiagnosticCategory.Error, "Parameter_0_is_not_in_the_same_position_as_parameter_1_1227", "Parameter '{0}' is not in the same position as parameter '{1}'."),
        A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods: diag(1228, ts2.DiagnosticCategory.Error, "A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods_1228", "A type predicate is only allowed in return type position for functions and methods."),
        A_type_predicate_cannot_reference_a_rest_parameter: diag(1229, ts2.DiagnosticCategory.Error, "A_type_predicate_cannot_reference_a_rest_parameter_1229", "A type predicate cannot reference a rest parameter."),
        A_type_predicate_cannot_reference_element_0_in_a_binding_pattern: diag(1230, ts2.DiagnosticCategory.Error, "A_type_predicate_cannot_reference_element_0_in_a_binding_pattern_1230", "A type predicate cannot reference element '{0}' in a binding pattern."),
        An_export_assignment_can_only_be_used_in_a_module: diag(1231, ts2.DiagnosticCategory.Error, "An_export_assignment_can_only_be_used_in_a_module_1231", "An export assignment can only be used in a module."),
        An_import_declaration_can_only_be_used_in_a_namespace_or_module: diag(1232, ts2.DiagnosticCategory.Error, "An_import_declaration_can_only_be_used_in_a_namespace_or_module_1232", "An import declaration can only be used in a namespace or module."),
        An_export_declaration_can_only_be_used_in_a_module: diag(1233, ts2.DiagnosticCategory.Error, "An_export_declaration_can_only_be_used_in_a_module_1233", "An export declaration can only be used in a module."),
        An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file: diag(1234, ts2.DiagnosticCategory.Error, "An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file_1234", "An ambient module declaration is only allowed at the top level in a file."),
        A_namespace_declaration_is_only_allowed_in_a_namespace_or_module: diag(1235, ts2.DiagnosticCategory.Error, "A_namespace_declaration_is_only_allowed_in_a_namespace_or_module_1235", "A namespace declaration is only allowed in a namespace or module."),
        The_return_type_of_a_property_decorator_function_must_be_either_void_or_any: diag(1236, ts2.DiagnosticCategory.Error, "The_return_type_of_a_property_decorator_function_must_be_either_void_or_any_1236", "The return type of a property decorator function must be either 'void' or 'any'."),
        The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any: diag(1237, ts2.DiagnosticCategory.Error, "The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any_1237", "The return type of a parameter decorator function must be either 'void' or 'any'."),
        Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression: diag(1238, ts2.DiagnosticCategory.Error, "Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression_1238", "Unable to resolve signature of class decorator when called as an expression."),
        Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression: diag(1239, ts2.DiagnosticCategory.Error, "Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression_1239", "Unable to resolve signature of parameter decorator when called as an expression."),
        Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression: diag(1240, ts2.DiagnosticCategory.Error, "Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression_1240", "Unable to resolve signature of property decorator when called as an expression."),
        Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression: diag(1241, ts2.DiagnosticCategory.Error, "Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression_1241", "Unable to resolve signature of method decorator when called as an expression."),
        abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration: diag(1242, ts2.DiagnosticCategory.Error, "abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration_1242", "'abstract' modifier can only appear on a class, method, or property declaration."),
        _0_modifier_cannot_be_used_with_1_modifier: diag(1243, ts2.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_with_1_modifier_1243", "'{0}' modifier cannot be used with '{1}' modifier."),
        Abstract_methods_can_only_appear_within_an_abstract_class: diag(1244, ts2.DiagnosticCategory.Error, "Abstract_methods_can_only_appear_within_an_abstract_class_1244", "Abstract methods can only appear within an abstract class."),
        Method_0_cannot_have_an_implementation_because_it_is_marked_abstract: diag(1245, ts2.DiagnosticCategory.Error, "Method_0_cannot_have_an_implementation_because_it_is_marked_abstract_1245", "Method '{0}' cannot have an implementation because it is marked abstract."),
        An_interface_property_cannot_have_an_initializer: diag(1246, ts2.DiagnosticCategory.Error, "An_interface_property_cannot_have_an_initializer_1246", "An interface property cannot have an initializer."),
        A_type_literal_property_cannot_have_an_initializer: diag(1247, ts2.DiagnosticCategory.Error, "A_type_literal_property_cannot_have_an_initializer_1247", "A type literal property cannot have an initializer."),
        A_class_member_cannot_have_the_0_keyword: diag(1248, ts2.DiagnosticCategory.Error, "A_class_member_cannot_have_the_0_keyword_1248", "A class member cannot have the '{0}' keyword."),
        A_decorator_can_only_decorate_a_method_implementation_not_an_overload: diag(1249, ts2.DiagnosticCategory.Error, "A_decorator_can_only_decorate_a_method_implementation_not_an_overload_1249", "A decorator can only decorate a method implementation, not an overload."),
        Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5: diag(1250, ts2.DiagnosticCategory.Error, "Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_1250", "Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'."),
        Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_definitions_are_automatically_in_strict_mode: diag(1251, ts2.DiagnosticCategory.Error, "Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_d_1251", "Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'. Class definitions are automatically in strict mode."),
        Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_are_automatically_in_strict_mode: diag(1252, ts2.DiagnosticCategory.Error, "Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_1252", "Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'. Modules are automatically in strict mode."),
        _0_tag_cannot_be_used_independently_as_a_top_level_JSDoc_tag: diag(1253, ts2.DiagnosticCategory.Error, "_0_tag_cannot_be_used_independently_as_a_top_level_JSDoc_tag_1253", "'{0}' tag cannot be used independently as a top level JSDoc tag."),
        A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_reference: diag(1254, ts2.DiagnosticCategory.Error, "A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_refere_1254", "A 'const' initializer in an ambient context must be a string or numeric literal or literal enum reference."),
        A_definite_assignment_assertion_is_not_permitted_in_this_context: diag(1255, ts2.DiagnosticCategory.Error, "A_definite_assignment_assertion_is_not_permitted_in_this_context_1255", "A definite assignment assertion '!' is not permitted in this context."),
        A_rest_element_must_be_last_in_a_tuple_type: diag(1256, ts2.DiagnosticCategory.Error, "A_rest_element_must_be_last_in_a_tuple_type_1256", "A rest element must be last in a tuple type."),
        A_required_element_cannot_follow_an_optional_element: diag(1257, ts2.DiagnosticCategory.Error, "A_required_element_cannot_follow_an_optional_element_1257", "A required element cannot follow an optional element."),
        Definite_assignment_assertions_can_only_be_used_along_with_a_type_annotation: diag(1258, ts2.DiagnosticCategory.Error, "Definite_assignment_assertions_can_only_be_used_along_with_a_type_annotation_1258", "Definite assignment assertions can only be used along with a type annotation."),
        Module_0_can_only_be_default_imported_using_the_1_flag: diag(1259, ts2.DiagnosticCategory.Error, "Module_0_can_only_be_default_imported_using_the_1_flag_1259", "Module '{0}' can only be default-imported using the '{1}' flag"),
        Keywords_cannot_contain_escape_characters: diag(1260, ts2.DiagnosticCategory.Error, "Keywords_cannot_contain_escape_characters_1260", "Keywords cannot contain escape characters."),
        Already_included_file_name_0_differs_from_file_name_1_only_in_casing: diag(1261, ts2.DiagnosticCategory.Error, "Already_included_file_name_0_differs_from_file_name_1_only_in_casing_1261", "Already included file name '{0}' differs from file name '{1}' only in casing."),
        with_statements_are_not_allowed_in_an_async_function_block: diag(1300, ts2.DiagnosticCategory.Error, "with_statements_are_not_allowed_in_an_async_function_block_1300", "'with' statements are not allowed in an async function block."),
        await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules: diag(1308, ts2.DiagnosticCategory.Error, "await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules_1308", "'await' expressions are only allowed within async functions and at the top levels of modules."),
        can_only_be_used_in_an_object_literal_property_inside_a_destructuring_assignment: diag(1312, ts2.DiagnosticCategory.Error, "can_only_be_used_in_an_object_literal_property_inside_a_destructuring_assignment_1312", "'=' can only be used in an object literal property inside a destructuring assignment."),
        The_body_of_an_if_statement_cannot_be_the_empty_statement: diag(1313, ts2.DiagnosticCategory.Error, "The_body_of_an_if_statement_cannot_be_the_empty_statement_1313", "The body of an 'if' statement cannot be the empty statement."),
        Global_module_exports_may_only_appear_in_module_files: diag(1314, ts2.DiagnosticCategory.Error, "Global_module_exports_may_only_appear_in_module_files_1314", "Global module exports may only appear in module files."),
        Global_module_exports_may_only_appear_in_declaration_files: diag(1315, ts2.DiagnosticCategory.Error, "Global_module_exports_may_only_appear_in_declaration_files_1315", "Global module exports may only appear in declaration files."),
        Global_module_exports_may_only_appear_at_top_level: diag(1316, ts2.DiagnosticCategory.Error, "Global_module_exports_may_only_appear_at_top_level_1316", "Global module exports may only appear at top level."),
        A_parameter_property_cannot_be_declared_using_a_rest_parameter: diag(1317, ts2.DiagnosticCategory.Error, "A_parameter_property_cannot_be_declared_using_a_rest_parameter_1317", "A parameter property cannot be declared using a rest parameter."),
        An_abstract_accessor_cannot_have_an_implementation: diag(1318, ts2.DiagnosticCategory.Error, "An_abstract_accessor_cannot_have_an_implementation_1318", "An abstract accessor cannot have an implementation."),
        A_default_export_can_only_be_used_in_an_ECMAScript_style_module: diag(1319, ts2.DiagnosticCategory.Error, "A_default_export_can_only_be_used_in_an_ECMAScript_style_module_1319", "A default export can only be used in an ECMAScript-style module."),
        Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: diag(1320, ts2.DiagnosticCategory.Error, "Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member_1320", "Type of 'await' operand must either be a valid promise or must not contain a callable 'then' member."),
        Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: diag(1321, ts2.DiagnosticCategory.Error, "Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_cal_1321", "Type of 'yield' operand in an async generator must either be a valid promise or must not contain a callable 'then' member."),
        Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: diag(1322, ts2.DiagnosticCategory.Error, "Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_con_1322", "Type of iterated elements of a 'yield*' operand must either be a valid promise or must not contain a callable 'then' member."),
        Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_esnext_commonjs_amd_system_or_umd: diag(1323, ts2.DiagnosticCategory.Error, "Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_esnext_commonjs_amd_system__1323", "Dynamic imports are only supported when the '--module' flag is set to 'es2020', 'esnext', 'commonjs', 'amd', 'system', or 'umd'."),
        Dynamic_import_must_have_one_specifier_as_an_argument: diag(1324, ts2.DiagnosticCategory.Error, "Dynamic_import_must_have_one_specifier_as_an_argument_1324", "Dynamic import must have one specifier as an argument."),
        Specifier_of_dynamic_import_cannot_be_spread_element: diag(1325, ts2.DiagnosticCategory.Error, "Specifier_of_dynamic_import_cannot_be_spread_element_1325", "Specifier of dynamic import cannot be spread element."),
        Dynamic_import_cannot_have_type_arguments: diag(1326, ts2.DiagnosticCategory.Error, "Dynamic_import_cannot_have_type_arguments_1326", "Dynamic import cannot have type arguments"),
        String_literal_with_double_quotes_expected: diag(1327, ts2.DiagnosticCategory.Error, "String_literal_with_double_quotes_expected_1327", "String literal with double quotes expected."),
        Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_literal: diag(1328, ts2.DiagnosticCategory.Error, "Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_li_1328", "Property value can only be string literal, numeric literal, 'true', 'false', 'null', object literal or array literal."),
        _0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0: diag(1329, ts2.DiagnosticCategory.Error, "_0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write__1329", "'{0}' accepts too few arguments to be used as a decorator here. Did you mean to call it first and write '@{0}()'?"),
        A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly: diag(1330, ts2.DiagnosticCategory.Error, "A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly_1330", "A property of an interface or type literal whose type is a 'unique symbol' type must be 'readonly'."),
        A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly: diag(1331, ts2.DiagnosticCategory.Error, "A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly_1331", "A property of a class whose type is a 'unique symbol' type must be both 'static' and 'readonly'."),
        A_variable_whose_type_is_a_unique_symbol_type_must_be_const: diag(1332, ts2.DiagnosticCategory.Error, "A_variable_whose_type_is_a_unique_symbol_type_must_be_const_1332", "A variable whose type is a 'unique symbol' type must be 'const'."),
        unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name: diag(1333, ts2.DiagnosticCategory.Error, "unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name_1333", "'unique symbol' types may not be used on a variable declaration with a binding name."),
        unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement: diag(1334, ts2.DiagnosticCategory.Error, "unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement_1334", "'unique symbol' types are only allowed on variables in a variable statement."),
        unique_symbol_types_are_not_allowed_here: diag(1335, ts2.DiagnosticCategory.Error, "unique_symbol_types_are_not_allowed_here_1335", "'unique symbol' types are not allowed here."),
        An_index_signature_parameter_type_cannot_be_a_type_alias_Consider_writing_0_Colon_1_Colon_2_instead: diag(1336, ts2.DiagnosticCategory.Error, "An_index_signature_parameter_type_cannot_be_a_type_alias_Consider_writing_0_Colon_1_Colon_2_instead_1336", "An index signature parameter type cannot be a type alias. Consider writing '[{0}: {1}]: {2}' instead."),
        An_index_signature_parameter_type_cannot_be_a_union_type_Consider_using_a_mapped_object_type_instead: diag(1337, ts2.DiagnosticCategory.Error, "An_index_signature_parameter_type_cannot_be_a_union_type_Consider_using_a_mapped_object_type_instead_1337", "An index signature parameter type cannot be a union type. Consider using a mapped object type instead."),
        infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type: diag(1338, ts2.DiagnosticCategory.Error, "infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type_1338", "'infer' declarations are only permitted in the 'extends' clause of a conditional type."),
        Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here: diag(1339, ts2.DiagnosticCategory.Error, "Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here_1339", "Module '{0}' does not refer to a value, but is used as a value here."),
        Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0: diag(1340, ts2.DiagnosticCategory.Error, "Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0_1340", "Module '{0}' does not refer to a type, but is used as a type here. Did you mean 'typeof import('{0}')'?"),
        Type_arguments_cannot_be_used_here: diag(1342, ts2.DiagnosticCategory.Error, "Type_arguments_cannot_be_used_here_1342", "Type arguments cannot be used here."),
        The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_esnext_or_system: diag(1343, ts2.DiagnosticCategory.Error, "The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_esnext_or_system_1343", "The 'import.meta' meta-property is only allowed when the '--module' option is 'esnext' or 'system'."),
        A_label_is_not_allowed_here: diag(1344, ts2.DiagnosticCategory.Error, "A_label_is_not_allowed_here_1344", "'A label is not allowed here."),
        An_expression_of_type_void_cannot_be_tested_for_truthiness: diag(1345, ts2.DiagnosticCategory.Error, "An_expression_of_type_void_cannot_be_tested_for_truthiness_1345", "An expression of type 'void' cannot be tested for truthiness"),
        This_parameter_is_not_allowed_with_use_strict_directive: diag(1346, ts2.DiagnosticCategory.Error, "This_parameter_is_not_allowed_with_use_strict_directive_1346", "This parameter is not allowed with 'use strict' directive."),
        use_strict_directive_cannot_be_used_with_non_simple_parameter_list: diag(1347, ts2.DiagnosticCategory.Error, "use_strict_directive_cannot_be_used_with_non_simple_parameter_list_1347", "'use strict' directive cannot be used with non-simple parameter list."),
        Non_simple_parameter_declared_here: diag(1348, ts2.DiagnosticCategory.Error, "Non_simple_parameter_declared_here_1348", "Non-simple parameter declared here."),
        use_strict_directive_used_here: diag(1349, ts2.DiagnosticCategory.Error, "use_strict_directive_used_here_1349", "'use strict' directive used here."),
        Print_the_final_configuration_instead_of_building: diag(1350, ts2.DiagnosticCategory.Message, "Print_the_final_configuration_instead_of_building_1350", "Print the final configuration instead of building."),
        An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal: diag(1351, ts2.DiagnosticCategory.Error, "An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal_1351", "An identifier or keyword cannot immediately follow a numeric literal."),
        A_bigint_literal_cannot_use_exponential_notation: diag(1352, ts2.DiagnosticCategory.Error, "A_bigint_literal_cannot_use_exponential_notation_1352", "A bigint literal cannot use exponential notation."),
        A_bigint_literal_must_be_an_integer: diag(1353, ts2.DiagnosticCategory.Error, "A_bigint_literal_must_be_an_integer_1353", "A bigint literal must be an integer."),
        readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types: diag(1354, ts2.DiagnosticCategory.Error, "readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types_1354", "'readonly' type modifier is only permitted on array and tuple literal types."),
        A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array_or_object_literals: diag(1355, ts2.DiagnosticCategory.Error, "A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array__1355", "A 'const' assertions can only be applied to references to enum members, or string, number, boolean, array, or object literals."),
        Did_you_mean_to_mark_this_function_as_async: diag(1356, ts2.DiagnosticCategory.Error, "Did_you_mean_to_mark_this_function_as_async_1356", "Did you mean to mark this function as 'async'?"),
        An_enum_member_name_must_be_followed_by_a_or: diag(1357, ts2.DiagnosticCategory.Error, "An_enum_member_name_must_be_followed_by_a_or_1357", "An enum member name must be followed by a ',', '=', or '}'."),
        Tagged_template_expressions_are_not_permitted_in_an_optional_chain: diag(1358, ts2.DiagnosticCategory.Error, "Tagged_template_expressions_are_not_permitted_in_an_optional_chain_1358", "Tagged template expressions are not permitted in an optional chain."),
        Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here: diag(1359, ts2.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here_1359", "Identifier expected. '{0}' is a reserved word that cannot be used here."),
        Did_you_mean_to_parenthesize_this_function_type: diag(1360, ts2.DiagnosticCategory.Error, "Did_you_mean_to_parenthesize_this_function_type_1360", "Did you mean to parenthesize this function type?"),
        _0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type: diag(1361, ts2.DiagnosticCategory.Error, "_0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type_1361", "'{0}' cannot be used as a value because it was imported using 'import type'."),
        _0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type: diag(1362, ts2.DiagnosticCategory.Error, "_0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type_1362", "'{0}' cannot be used as a value because it was exported using 'export type'."),
        A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both: diag(1363, ts2.DiagnosticCategory.Error, "A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both_1363", "A type-only import can specify a default import or named bindings, but not both."),
        Convert_to_type_only_export: diag(1364, ts2.DiagnosticCategory.Message, "Convert_to_type_only_export_1364", "Convert to type-only export"),
        Convert_all_re_exported_types_to_type_only_exports: diag(1365, ts2.DiagnosticCategory.Message, "Convert_all_re_exported_types_to_type_only_exports_1365", "Convert all re-exported types to type-only exports"),
        Split_into_two_separate_import_declarations: diag(1366, ts2.DiagnosticCategory.Message, "Split_into_two_separate_import_declarations_1366", "Split into two separate import declarations"),
        Split_all_invalid_type_only_imports: diag(1367, ts2.DiagnosticCategory.Message, "Split_all_invalid_type_only_imports_1367", "Split all invalid type-only imports"),
        Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types: diag(1368, ts2.DiagnosticCategory.Message, "Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types_1368", "Specify emit/checking behavior for imports that are only used for types"),
        Did_you_mean_0: diag(1369, ts2.DiagnosticCategory.Message, "Did_you_mean_0_1369", "Did you mean '{0}'?"),
        Only_ECMAScript_imports_may_use_import_type: diag(1370, ts2.DiagnosticCategory.Error, "Only_ECMAScript_imports_may_use_import_type_1370", "Only ECMAScript imports may use 'import type'."),
        This_import_is_never_used_as_a_value_and_must_use_import_type_because_the_importsNotUsedAsValues_is_set_to_error: diag(1371, ts2.DiagnosticCategory.Error, "This_import_is_never_used_as_a_value_and_must_use_import_type_because_the_importsNotUsedAsValues_is__1371", "This import is never used as a value and must use 'import type' because the 'importsNotUsedAsValues' is set to 'error'."),
        Convert_to_type_only_import: diag(1373, ts2.DiagnosticCategory.Message, "Convert_to_type_only_import_1373", "Convert to type-only import"),
        Convert_all_imports_not_used_as_a_value_to_type_only_imports: diag(1374, ts2.DiagnosticCategory.Message, "Convert_all_imports_not_used_as_a_value_to_type_only_imports_1374", "Convert all imports not used as a value to type-only imports"),
        await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module: diag(1375, ts2.DiagnosticCategory.Error, "await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_fi_1375", "'await' expressions are only allowed at the top level of a file when that file is a module, but this file has no imports or exports. Consider adding an empty 'export {}' to make this file a module."),
        _0_was_imported_here: diag(1376, ts2.DiagnosticCategory.Message, "_0_was_imported_here_1376", "'{0}' was imported here."),
        _0_was_exported_here: diag(1377, ts2.DiagnosticCategory.Message, "_0_was_exported_here_1377", "'{0}' was exported here."),
        Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_esnext_or_system_and_the_target_option_is_set_to_es2017_or_higher: diag(1378, ts2.DiagnosticCategory.Error, "Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_esnext_or_system_and_t_1378", "Top-level 'await' expressions are only allowed when the 'module' option is set to 'esnext' or 'system', and the 'target' option is set to 'es2017' or higher."),
        An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type: diag(1379, ts2.DiagnosticCategory.Error, "An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type_1379", "An import alias cannot reference a declaration that was exported using 'export type'."),
        An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type: diag(1380, ts2.DiagnosticCategory.Error, "An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type_1380", "An import alias cannot reference a declaration that was imported using 'import type'."),
        Unexpected_token_Did_you_mean_or_rbrace: diag(1381, ts2.DiagnosticCategory.Error, "Unexpected_token_Did_you_mean_or_rbrace_1381", "Unexpected token. Did you mean `{'}'}` or `&rbrace;`?"),
        Unexpected_token_Did_you_mean_or_gt: diag(1382, ts2.DiagnosticCategory.Error, "Unexpected_token_Did_you_mean_or_gt_1382", "Unexpected token. Did you mean `{'>'}` or `&gt;`?"),
        Only_named_exports_may_use_export_type: diag(1383, ts2.DiagnosticCategory.Error, "Only_named_exports_may_use_export_type_1383", "Only named exports may use 'export type'."),
        A_new_expression_with_type_arguments_must_always_be_followed_by_a_parenthesized_argument_list: diag(1384, ts2.DiagnosticCategory.Error, "A_new_expression_with_type_arguments_must_always_be_followed_by_a_parenthesized_argument_list_1384", "A 'new' expression with type arguments must always be followed by a parenthesized argument list."),
        The_types_of_0_are_incompatible_between_these_types: diag(2200, ts2.DiagnosticCategory.Error, "The_types_of_0_are_incompatible_between_these_types_2200", "The types of '{0}' are incompatible between these types."),
        The_types_returned_by_0_are_incompatible_between_these_types: diag(2201, ts2.DiagnosticCategory.Error, "The_types_returned_by_0_are_incompatible_between_these_types_2201", "The types returned by '{0}' are incompatible between these types."),
        Call_signature_return_types_0_and_1_are_incompatible: diag(2202, ts2.DiagnosticCategory.Error, "Call_signature_return_types_0_and_1_are_incompatible_2202", "Call signature return types '{0}' and '{1}' are incompatible.", void 0, true),
        Construct_signature_return_types_0_and_1_are_incompatible: diag(2203, ts2.DiagnosticCategory.Error, "Construct_signature_return_types_0_and_1_are_incompatible_2203", "Construct signature return types '{0}' and '{1}' are incompatible.", void 0, true),
        Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1: diag(2204, ts2.DiagnosticCategory.Error, "Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1_2204", "Call signatures with no arguments have incompatible return types '{0}' and '{1}'.", void 0, true),
        Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1: diag(2205, ts2.DiagnosticCategory.Error, "Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1_2205", "Construct signatures with no arguments have incompatible return types '{0}' and '{1}'.", void 0, true),
        Duplicate_identifier_0: diag(2300, ts2.DiagnosticCategory.Error, "Duplicate_identifier_0_2300", "Duplicate identifier '{0}'."),
        Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor: diag(2301, ts2.DiagnosticCategory.Error, "Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor_2301", "Initializer of instance member variable '{0}' cannot reference identifier '{1}' declared in the constructor."),
        Static_members_cannot_reference_class_type_parameters: diag(2302, ts2.DiagnosticCategory.Error, "Static_members_cannot_reference_class_type_parameters_2302", "Static members cannot reference class type parameters."),
        Circular_definition_of_import_alias_0: diag(2303, ts2.DiagnosticCategory.Error, "Circular_definition_of_import_alias_0_2303", "Circular definition of import alias '{0}'."),
        Cannot_find_name_0: diag(2304, ts2.DiagnosticCategory.Error, "Cannot_find_name_0_2304", "Cannot find name '{0}'."),
        Module_0_has_no_exported_member_1: diag(2305, ts2.DiagnosticCategory.Error, "Module_0_has_no_exported_member_1_2305", "Module '{0}' has no exported member '{1}'."),
        File_0_is_not_a_module: diag(2306, ts2.DiagnosticCategory.Error, "File_0_is_not_a_module_2306", "File '{0}' is not a module."),
        Cannot_find_module_0_or_its_corresponding_type_declarations: diag(2307, ts2.DiagnosticCategory.Error, "Cannot_find_module_0_or_its_corresponding_type_declarations_2307", "Cannot find module '{0}' or its corresponding type declarations."),
        Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity: diag(2308, ts2.DiagnosticCategory.Error, "Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambig_2308", "Module {0} has already exported a member named '{1}'. Consider explicitly re-exporting to resolve the ambiguity."),
        An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements: diag(2309, ts2.DiagnosticCategory.Error, "An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements_2309", "An export assignment cannot be used in a module with other exported elements."),
        Type_0_recursively_references_itself_as_a_base_type: diag(2310, ts2.DiagnosticCategory.Error, "Type_0_recursively_references_itself_as_a_base_type_2310", "Type '{0}' recursively references itself as a base type."),
        A_class_may_only_extend_another_class: diag(2311, ts2.DiagnosticCategory.Error, "A_class_may_only_extend_another_class_2311", "A class may only extend another class."),
        An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_members: diag(2312, ts2.DiagnosticCategory.Error, "An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_me_2312", "An interface can only extend an object type or intersection of object types with statically known members."),
        Type_parameter_0_has_a_circular_constraint: diag(2313, ts2.DiagnosticCategory.Error, "Type_parameter_0_has_a_circular_constraint_2313", "Type parameter '{0}' has a circular constraint."),
        Generic_type_0_requires_1_type_argument_s: diag(2314, ts2.DiagnosticCategory.Error, "Generic_type_0_requires_1_type_argument_s_2314", "Generic type '{0}' requires {1} type argument(s)."),
        Type_0_is_not_generic: diag(2315, ts2.DiagnosticCategory.Error, "Type_0_is_not_generic_2315", "Type '{0}' is not generic."),
        Global_type_0_must_be_a_class_or_interface_type: diag(2316, ts2.DiagnosticCategory.Error, "Global_type_0_must_be_a_class_or_interface_type_2316", "Global type '{0}' must be a class or interface type."),
        Global_type_0_must_have_1_type_parameter_s: diag(2317, ts2.DiagnosticCategory.Error, "Global_type_0_must_have_1_type_parameter_s_2317", "Global type '{0}' must have {1} type parameter(s)."),
        Cannot_find_global_type_0: diag(2318, ts2.DiagnosticCategory.Error, "Cannot_find_global_type_0_2318", "Cannot find global type '{0}'."),
        Named_property_0_of_types_1_and_2_are_not_identical: diag(2319, ts2.DiagnosticCategory.Error, "Named_property_0_of_types_1_and_2_are_not_identical_2319", "Named property '{0}' of types '{1}' and '{2}' are not identical."),
        Interface_0_cannot_simultaneously_extend_types_1_and_2: diag(2320, ts2.DiagnosticCategory.Error, "Interface_0_cannot_simultaneously_extend_types_1_and_2_2320", "Interface '{0}' cannot simultaneously extend types '{1}' and '{2}'."),
        Excessive_stack_depth_comparing_types_0_and_1: diag(2321, ts2.DiagnosticCategory.Error, "Excessive_stack_depth_comparing_types_0_and_1_2321", "Excessive stack depth comparing types '{0}' and '{1}'."),
        Type_0_is_not_assignable_to_type_1: diag(2322, ts2.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_2322", "Type '{0}' is not assignable to type '{1}'."),
        Cannot_redeclare_exported_variable_0: diag(2323, ts2.DiagnosticCategory.Error, "Cannot_redeclare_exported_variable_0_2323", "Cannot redeclare exported variable '{0}'."),
        Property_0_is_missing_in_type_1: diag(2324, ts2.DiagnosticCategory.Error, "Property_0_is_missing_in_type_1_2324", "Property '{0}' is missing in type '{1}'."),
        Property_0_is_private_in_type_1_but_not_in_type_2: diag(2325, ts2.DiagnosticCategory.Error, "Property_0_is_private_in_type_1_but_not_in_type_2_2325", "Property '{0}' is private in type '{1}' but not in type '{2}'."),
        Types_of_property_0_are_incompatible: diag(2326, ts2.DiagnosticCategory.Error, "Types_of_property_0_are_incompatible_2326", "Types of property '{0}' are incompatible."),
        Property_0_is_optional_in_type_1_but_required_in_type_2: diag(2327, ts2.DiagnosticCategory.Error, "Property_0_is_optional_in_type_1_but_required_in_type_2_2327", "Property '{0}' is optional in type '{1}' but required in type '{2}'."),
        Types_of_parameters_0_and_1_are_incompatible: diag(2328, ts2.DiagnosticCategory.Error, "Types_of_parameters_0_and_1_are_incompatible_2328", "Types of parameters '{0}' and '{1}' are incompatible."),
        Index_signature_is_missing_in_type_0: diag(2329, ts2.DiagnosticCategory.Error, "Index_signature_is_missing_in_type_0_2329", "Index signature is missing in type '{0}'."),
        Index_signatures_are_incompatible: diag(2330, ts2.DiagnosticCategory.Error, "Index_signatures_are_incompatible_2330", "Index signatures are incompatible."),
        this_cannot_be_referenced_in_a_module_or_namespace_body: diag(2331, ts2.DiagnosticCategory.Error, "this_cannot_be_referenced_in_a_module_or_namespace_body_2331", "'this' cannot be referenced in a module or namespace body."),
        this_cannot_be_referenced_in_current_location: diag(2332, ts2.DiagnosticCategory.Error, "this_cannot_be_referenced_in_current_location_2332", "'this' cannot be referenced in current location."),
        this_cannot_be_referenced_in_constructor_arguments: diag(2333, ts2.DiagnosticCategory.Error, "this_cannot_be_referenced_in_constructor_arguments_2333", "'this' cannot be referenced in constructor arguments."),
        this_cannot_be_referenced_in_a_static_property_initializer: diag(2334, ts2.DiagnosticCategory.Error, "this_cannot_be_referenced_in_a_static_property_initializer_2334", "'this' cannot be referenced in a static property initializer."),
        super_can_only_be_referenced_in_a_derived_class: diag(2335, ts2.DiagnosticCategory.Error, "super_can_only_be_referenced_in_a_derived_class_2335", "'super' can only be referenced in a derived class."),
        super_cannot_be_referenced_in_constructor_arguments: diag(2336, ts2.DiagnosticCategory.Error, "super_cannot_be_referenced_in_constructor_arguments_2336", "'super' cannot be referenced in constructor arguments."),
        Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors: diag(2337, ts2.DiagnosticCategory.Error, "Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors_2337", "Super calls are not permitted outside constructors or in nested functions inside constructors."),
        super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class: diag(2338, ts2.DiagnosticCategory.Error, "super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_der_2338", "'super' property access is permitted only in a constructor, member function, or member accessor of a derived class."),
        Property_0_does_not_exist_on_type_1: diag(2339, ts2.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_2339", "Property '{0}' does not exist on type '{1}'."),
        Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword: diag(2340, ts2.DiagnosticCategory.Error, "Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword_2340", "Only public and protected methods of the base class are accessible via the 'super' keyword."),
        Property_0_is_private_and_only_accessible_within_class_1: diag(2341, ts2.DiagnosticCategory.Error, "Property_0_is_private_and_only_accessible_within_class_1_2341", "Property '{0}' is private and only accessible within class '{1}'."),
        An_index_expression_argument_must_be_of_type_string_number_symbol_or_any: diag(2342, ts2.DiagnosticCategory.Error, "An_index_expression_argument_must_be_of_type_string_number_symbol_or_any_2342", "An index expression argument must be of type 'string', 'number', 'symbol', or 'any'."),
        This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_version_of_0: diag(2343, ts2.DiagnosticCategory.Error, "This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_ve_2343", "This syntax requires an imported helper named '{1}' which does not exist in '{0}'. Consider upgrading your version of '{0}'."),
        Type_0_does_not_satisfy_the_constraint_1: diag(2344, ts2.DiagnosticCategory.Error, "Type_0_does_not_satisfy_the_constraint_1_2344", "Type '{0}' does not satisfy the constraint '{1}'."),
        Argument_of_type_0_is_not_assignable_to_parameter_of_type_1: diag(2345, ts2.DiagnosticCategory.Error, "Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_2345", "Argument of type '{0}' is not assignable to parameter of type '{1}'."),
        Call_target_does_not_contain_any_signatures: diag(2346, ts2.DiagnosticCategory.Error, "Call_target_does_not_contain_any_signatures_2346", "Call target does not contain any signatures."),
        Untyped_function_calls_may_not_accept_type_arguments: diag(2347, ts2.DiagnosticCategory.Error, "Untyped_function_calls_may_not_accept_type_arguments_2347", "Untyped function calls may not accept type arguments."),
        Value_of_type_0_is_not_callable_Did_you_mean_to_include_new: diag(2348, ts2.DiagnosticCategory.Error, "Value_of_type_0_is_not_callable_Did_you_mean_to_include_new_2348", "Value of type '{0}' is not callable. Did you mean to include 'new'?"),
        This_expression_is_not_callable: diag(2349, ts2.DiagnosticCategory.Error, "This_expression_is_not_callable_2349", "This expression is not callable."),
        Only_a_void_function_can_be_called_with_the_new_keyword: diag(2350, ts2.DiagnosticCategory.Error, "Only_a_void_function_can_be_called_with_the_new_keyword_2350", "Only a void function can be called with the 'new' keyword."),
        This_expression_is_not_constructable: diag(2351, ts2.DiagnosticCategory.Error, "This_expression_is_not_constructable_2351", "This expression is not constructable."),
        Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first: diag(2352, ts2.DiagnosticCategory.Error, "Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the__2352", "Conversion of type '{0}' to type '{1}' may be a mistake because neither type sufficiently overlaps with the other. If this was intentional, convert the expression to 'unknown' first."),
        Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1: diag(2353, ts2.DiagnosticCategory.Error, "Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1_2353", "Object literal may only specify known properties, and '{0}' does not exist in type '{1}'."),
        This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found: diag(2354, ts2.DiagnosticCategory.Error, "This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found_2354", "This syntax requires an imported helper but module '{0}' cannot be found."),
        A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value: diag(2355, ts2.DiagnosticCategory.Error, "A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value_2355", "A function whose declared type is neither 'void' nor 'any' must return a value."),
        An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type: diag(2356, ts2.DiagnosticCategory.Error, "An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type_2356", "An arithmetic operand must be of type 'any', 'number', 'bigint' or an enum type."),
        The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access: diag(2357, ts2.DiagnosticCategory.Error, "The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access_2357", "The operand of an increment or decrement operator must be a variable or a property access."),
        The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter: diag(2358, ts2.DiagnosticCategory.Error, "The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_paramete_2358", "The left-hand side of an 'instanceof' expression must be of type 'any', an object type or a type parameter."),
        The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_Function_interface_type: diag(2359, ts2.DiagnosticCategory.Error, "The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_F_2359", "The right-hand side of an 'instanceof' expression must be of type 'any' or of a type assignable to the 'Function' interface type."),
        The_left_hand_side_of_an_in_expression_must_be_of_type_any_string_number_or_symbol: diag(2360, ts2.DiagnosticCategory.Error, "The_left_hand_side_of_an_in_expression_must_be_of_type_any_string_number_or_symbol_2360", "The left-hand side of an 'in' expression must be of type 'any', 'string', 'number', or 'symbol'."),
        The_right_hand_side_of_an_in_expression_must_be_of_type_any_an_object_type_or_a_type_parameter: diag(2361, ts2.DiagnosticCategory.Error, "The_right_hand_side_of_an_in_expression_must_be_of_type_any_an_object_type_or_a_type_parameter_2361", "The right-hand side of an 'in' expression must be of type 'any', an object type or a type parameter."),
        The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type: diag(2362, ts2.DiagnosticCategory.Error, "The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type_2362", "The left-hand side of an arithmetic operation must be of type 'any', 'number', 'bigint' or an enum type."),
        The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type: diag(2363, ts2.DiagnosticCategory.Error, "The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type_2363", "The right-hand side of an arithmetic operation must be of type 'any', 'number', 'bigint' or an enum type."),
        The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access: diag(2364, ts2.DiagnosticCategory.Error, "The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access_2364", "The left-hand side of an assignment expression must be a variable or a property access."),
        Operator_0_cannot_be_applied_to_types_1_and_2: diag(2365, ts2.DiagnosticCategory.Error, "Operator_0_cannot_be_applied_to_types_1_and_2_2365", "Operator '{0}' cannot be applied to types '{1}' and '{2}'."),
        Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined: diag(2366, ts2.DiagnosticCategory.Error, "Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined_2366", "Function lacks ending return statement and return type does not include 'undefined'."),
        This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap: diag(2367, ts2.DiagnosticCategory.Error, "This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap_2367", "This condition will always return '{0}' since the types '{1}' and '{2}' have no overlap."),
        Type_parameter_name_cannot_be_0: diag(2368, ts2.DiagnosticCategory.Error, "Type_parameter_name_cannot_be_0_2368", "Type parameter name cannot be '{0}'."),
        A_parameter_property_is_only_allowed_in_a_constructor_implementation: diag(2369, ts2.DiagnosticCategory.Error, "A_parameter_property_is_only_allowed_in_a_constructor_implementation_2369", "A parameter property is only allowed in a constructor implementation."),
        A_rest_parameter_must_be_of_an_array_type: diag(2370, ts2.DiagnosticCategory.Error, "A_rest_parameter_must_be_of_an_array_type_2370", "A rest parameter must be of an array type."),
        A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation: diag(2371, ts2.DiagnosticCategory.Error, "A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation_2371", "A parameter initializer is only allowed in a function or constructor implementation."),
        Parameter_0_cannot_reference_itself: diag(2372, ts2.DiagnosticCategory.Error, "Parameter_0_cannot_reference_itself_2372", "Parameter '{0}' cannot reference itself."),
        Parameter_0_cannot_reference_identifier_1_declared_after_it: diag(2373, ts2.DiagnosticCategory.Error, "Parameter_0_cannot_reference_identifier_1_declared_after_it_2373", "Parameter '{0}' cannot reference identifier '{1}' declared after it."),
        Duplicate_string_index_signature: diag(2374, ts2.DiagnosticCategory.Error, "Duplicate_string_index_signature_2374", "Duplicate string index signature."),
        Duplicate_number_index_signature: diag(2375, ts2.DiagnosticCategory.Error, "Duplicate_number_index_signature_2375", "Duplicate number index signature."),
        A_super_call_must_be_the_first_statement_in_the_constructor_when_a_class_contains_initialized_properties_parameter_properties_or_private_identifiers: diag(2376, ts2.DiagnosticCategory.Error, "A_super_call_must_be_the_first_statement_in_the_constructor_when_a_class_contains_initialized_proper_2376", "A 'super' call must be the first statement in the constructor when a class contains initialized properties, parameter properties, or private identifiers."),
        Constructors_for_derived_classes_must_contain_a_super_call: diag(2377, ts2.DiagnosticCategory.Error, "Constructors_for_derived_classes_must_contain_a_super_call_2377", "Constructors for derived classes must contain a 'super' call."),
        A_get_accessor_must_return_a_value: diag(2378, ts2.DiagnosticCategory.Error, "A_get_accessor_must_return_a_value_2378", "A 'get' accessor must return a value."),
        Getter_and_setter_accessors_do_not_agree_in_visibility: diag(2379, ts2.DiagnosticCategory.Error, "Getter_and_setter_accessors_do_not_agree_in_visibility_2379", "Getter and setter accessors do not agree in visibility."),
        get_and_set_accessor_must_have_the_same_type: diag(2380, ts2.DiagnosticCategory.Error, "get_and_set_accessor_must_have_the_same_type_2380", "'get' and 'set' accessor must have the same type."),
        A_signature_with_an_implementation_cannot_use_a_string_literal_type: diag(2381, ts2.DiagnosticCategory.Error, "A_signature_with_an_implementation_cannot_use_a_string_literal_type_2381", "A signature with an implementation cannot use a string literal type."),
        Specialized_overload_signature_is_not_assignable_to_any_non_specialized_signature: diag(2382, ts2.DiagnosticCategory.Error, "Specialized_overload_signature_is_not_assignable_to_any_non_specialized_signature_2382", "Specialized overload signature is not assignable to any non-specialized signature."),
        Overload_signatures_must_all_be_exported_or_non_exported: diag(2383, ts2.DiagnosticCategory.Error, "Overload_signatures_must_all_be_exported_or_non_exported_2383", "Overload signatures must all be exported or non-exported."),
        Overload_signatures_must_all_be_ambient_or_non_ambient: diag(2384, ts2.DiagnosticCategory.Error, "Overload_signatures_must_all_be_ambient_or_non_ambient_2384", "Overload signatures must all be ambient or non-ambient."),
        Overload_signatures_must_all_be_public_private_or_protected: diag(2385, ts2.DiagnosticCategory.Error, "Overload_signatures_must_all_be_public_private_or_protected_2385", "Overload signatures must all be public, private or protected."),
        Overload_signatures_must_all_be_optional_or_required: diag(2386, ts2.DiagnosticCategory.Error, "Overload_signatures_must_all_be_optional_or_required_2386", "Overload signatures must all be optional or required."),
        Function_overload_must_be_static: diag(2387, ts2.DiagnosticCategory.Error, "Function_overload_must_be_static_2387", "Function overload must be static."),
        Function_overload_must_not_be_static: diag(2388, ts2.DiagnosticCategory.Error, "Function_overload_must_not_be_static_2388", "Function overload must not be static."),
        Function_implementation_name_must_be_0: diag(2389, ts2.DiagnosticCategory.Error, "Function_implementation_name_must_be_0_2389", "Function implementation name must be '{0}'."),
        Constructor_implementation_is_missing: diag(2390, ts2.DiagnosticCategory.Error, "Constructor_implementation_is_missing_2390", "Constructor implementation is missing."),
        Function_implementation_is_missing_or_not_immediately_following_the_declaration: diag(2391, ts2.DiagnosticCategory.Error, "Function_implementation_is_missing_or_not_immediately_following_the_declaration_2391", "Function implementation is missing or not immediately following the declaration."),
        Multiple_constructor_implementations_are_not_allowed: diag(2392, ts2.DiagnosticCategory.Error, "Multiple_constructor_implementations_are_not_allowed_2392", "Multiple constructor implementations are not allowed."),
        Duplicate_function_implementation: diag(2393, ts2.DiagnosticCategory.Error, "Duplicate_function_implementation_2393", "Duplicate function implementation."),
        This_overload_signature_is_not_compatible_with_its_implementation_signature: diag(2394, ts2.DiagnosticCategory.Error, "This_overload_signature_is_not_compatible_with_its_implementation_signature_2394", "This overload signature is not compatible with its implementation signature."),
        Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local: diag(2395, ts2.DiagnosticCategory.Error, "Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local_2395", "Individual declarations in merged declaration '{0}' must be all exported or all local."),
        Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters: diag(2396, ts2.DiagnosticCategory.Error, "Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters_2396", "Duplicate identifier 'arguments'. Compiler uses 'arguments' to initialize rest parameters."),
        Declaration_name_conflicts_with_built_in_global_identifier_0: diag(2397, ts2.DiagnosticCategory.Error, "Declaration_name_conflicts_with_built_in_global_identifier_0_2397", "Declaration name conflicts with built-in global identifier '{0}'."),
        constructor_cannot_be_used_as_a_parameter_property_name: diag(2398, ts2.DiagnosticCategory.Error, "constructor_cannot_be_used_as_a_parameter_property_name_2398", "'constructor' cannot be used as a parameter property name."),
        Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference: diag(2399, ts2.DiagnosticCategory.Error, "Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference_2399", "Duplicate identifier '_this'. Compiler uses variable declaration '_this' to capture 'this' reference."),
        Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference: diag(2400, ts2.DiagnosticCategory.Error, "Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference_2400", "Expression resolves to variable declaration '_this' that compiler uses to capture 'this' reference."),
        Duplicate_identifier_super_Compiler_uses_super_to_capture_base_class_reference: diag(2401, ts2.DiagnosticCategory.Error, "Duplicate_identifier_super_Compiler_uses_super_to_capture_base_class_reference_2401", "Duplicate identifier '_super'. Compiler uses '_super' to capture base class reference."),
        Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference: diag(2402, ts2.DiagnosticCategory.Error, "Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference_2402", "Expression resolves to '_super' that compiler uses to capture base class reference."),
        Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2: diag(2403, ts2.DiagnosticCategory.Error, "Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_t_2403", "Subsequent variable declarations must have the same type.  Variable '{0}' must be of type '{1}', but here has type '{2}'."),
        The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation: diag(2404, ts2.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation_2404", "The left-hand side of a 'for...in' statement cannot use a type annotation."),
        The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any: diag(2405, ts2.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any_2405", "The left-hand side of a 'for...in' statement must be of type 'string' or 'any'."),
        The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access: diag(2406, ts2.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access_2406", "The left-hand side of a 'for...in' statement must be a variable or a property access."),
        The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_here_has_type_0: diag(2407, ts2.DiagnosticCategory.Error, "The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_2407", "The right-hand side of a 'for...in' statement must be of type 'any', an object type or a type parameter, but here has type '{0}'."),
        Setters_cannot_return_a_value: diag(2408, ts2.DiagnosticCategory.Error, "Setters_cannot_return_a_value_2408", "Setters cannot return a value."),
        Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class: diag(2409, ts2.DiagnosticCategory.Error, "Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class_2409", "Return type of constructor signature must be assignable to the instance type of the class."),
        The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any: diag(2410, ts2.DiagnosticCategory.Error, "The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any_2410", "The 'with' statement is not supported. All symbols in a 'with' block will have type 'any'."),
        Property_0_of_type_1_is_not_assignable_to_string_index_type_2: diag(2411, ts2.DiagnosticCategory.Error, "Property_0_of_type_1_is_not_assignable_to_string_index_type_2_2411", "Property '{0}' of type '{1}' is not assignable to string index type '{2}'."),
        Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2: diag(2412, ts2.DiagnosticCategory.Error, "Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2_2412", "Property '{0}' of type '{1}' is not assignable to numeric index type '{2}'."),
        Numeric_index_type_0_is_not_assignable_to_string_index_type_1: diag(2413, ts2.DiagnosticCategory.Error, "Numeric_index_type_0_is_not_assignable_to_string_index_type_1_2413", "Numeric index type '{0}' is not assignable to string index type '{1}'."),
        Class_name_cannot_be_0: diag(2414, ts2.DiagnosticCategory.Error, "Class_name_cannot_be_0_2414", "Class name cannot be '{0}'."),
        Class_0_incorrectly_extends_base_class_1: diag(2415, ts2.DiagnosticCategory.Error, "Class_0_incorrectly_extends_base_class_1_2415", "Class '{0}' incorrectly extends base class '{1}'."),
        Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2: diag(2416, ts2.DiagnosticCategory.Error, "Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2_2416", "Property '{0}' in type '{1}' is not assignable to the same property in base type '{2}'."),
        Class_static_side_0_incorrectly_extends_base_class_static_side_1: diag(2417, ts2.DiagnosticCategory.Error, "Class_static_side_0_incorrectly_extends_base_class_static_side_1_2417", "Class static side '{0}' incorrectly extends base class static side '{1}'."),
        Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1: diag(2418, ts2.DiagnosticCategory.Error, "Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1_2418", "Type of computed property's value is '{0}', which is not assignable to type '{1}'."),
        Class_0_incorrectly_implements_interface_1: diag(2420, ts2.DiagnosticCategory.Error, "Class_0_incorrectly_implements_interface_1_2420", "Class '{0}' incorrectly implements interface '{1}'."),
        A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_members: diag(2422, ts2.DiagnosticCategory.Error, "A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_memb_2422", "A class can only implement an object type or intersection of object types with statically known members."),
        Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor: diag(2423, ts2.DiagnosticCategory.Error, "Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_access_2423", "Class '{0}' defines instance member function '{1}', but extended class '{2}' defines it as instance member accessor."),
        Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function: diag(2425, ts2.DiagnosticCategory.Error, "Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_functi_2425", "Class '{0}' defines instance member property '{1}', but extended class '{2}' defines it as instance member function."),
        Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function: diag(2426, ts2.DiagnosticCategory.Error, "Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_functi_2426", "Class '{0}' defines instance member accessor '{1}', but extended class '{2}' defines it as instance member function."),
        Interface_name_cannot_be_0: diag(2427, ts2.DiagnosticCategory.Error, "Interface_name_cannot_be_0_2427", "Interface name cannot be '{0}'."),
        All_declarations_of_0_must_have_identical_type_parameters: diag(2428, ts2.DiagnosticCategory.Error, "All_declarations_of_0_must_have_identical_type_parameters_2428", "All declarations of '{0}' must have identical type parameters."),
        Interface_0_incorrectly_extends_interface_1: diag(2430, ts2.DiagnosticCategory.Error, "Interface_0_incorrectly_extends_interface_1_2430", "Interface '{0}' incorrectly extends interface '{1}'."),
        Enum_name_cannot_be_0: diag(2431, ts2.DiagnosticCategory.Error, "Enum_name_cannot_be_0_2431", "Enum name cannot be '{0}'."),
        In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element: diag(2432, ts2.DiagnosticCategory.Error, "In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enu_2432", "In an enum with multiple declarations, only one declaration can omit an initializer for its first enum element."),
        A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged: diag(2433, ts2.DiagnosticCategory.Error, "A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merg_2433", "A namespace declaration cannot be in a different file from a class or function with which it is merged."),
        A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged: diag(2434, ts2.DiagnosticCategory.Error, "A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged_2434", "A namespace declaration cannot be located prior to a class or function with which it is merged."),
        Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces: diag(2435, ts2.DiagnosticCategory.Error, "Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces_2435", "Ambient modules cannot be nested in other modules or namespaces."),
        Ambient_module_declaration_cannot_specify_relative_module_name: diag(2436, ts2.DiagnosticCategory.Error, "Ambient_module_declaration_cannot_specify_relative_module_name_2436", "Ambient module declaration cannot specify relative module name."),
        Module_0_is_hidden_by_a_local_declaration_with_the_same_name: diag(2437, ts2.DiagnosticCategory.Error, "Module_0_is_hidden_by_a_local_declaration_with_the_same_name_2437", "Module '{0}' is hidden by a local declaration with the same name."),
        Import_name_cannot_be_0: diag(2438, ts2.DiagnosticCategory.Error, "Import_name_cannot_be_0_2438", "Import name cannot be '{0}'."),
        Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name: diag(2439, ts2.DiagnosticCategory.Error, "Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relati_2439", "Import or export declaration in an ambient module declaration cannot reference module through relative module name."),
        Import_declaration_conflicts_with_local_declaration_of_0: diag(2440, ts2.DiagnosticCategory.Error, "Import_declaration_conflicts_with_local_declaration_of_0_2440", "Import declaration conflicts with local declaration of '{0}'."),
        Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module: diag(2441, ts2.DiagnosticCategory.Error, "Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_2441", "Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module."),
        Types_have_separate_declarations_of_a_private_property_0: diag(2442, ts2.DiagnosticCategory.Error, "Types_have_separate_declarations_of_a_private_property_0_2442", "Types have separate declarations of a private property '{0}'."),
        Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2: diag(2443, ts2.DiagnosticCategory.Error, "Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2_2443", "Property '{0}' is protected but type '{1}' is not a class derived from '{2}'."),
        Property_0_is_protected_in_type_1_but_public_in_type_2: diag(2444, ts2.DiagnosticCategory.Error, "Property_0_is_protected_in_type_1_but_public_in_type_2_2444", "Property '{0}' is protected in type '{1}' but public in type '{2}'."),
        Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses: diag(2445, ts2.DiagnosticCategory.Error, "Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses_2445", "Property '{0}' is protected and only accessible within class '{1}' and its subclasses."),
        Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1: diag(2446, ts2.DiagnosticCategory.Error, "Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_2446", "Property '{0}' is protected and only accessible through an instance of class '{1}'."),
        The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead: diag(2447, ts2.DiagnosticCategory.Error, "The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead_2447", "The '{0}' operator is not allowed for boolean types. Consider using '{1}' instead."),
        Block_scoped_variable_0_used_before_its_declaration: diag(2448, ts2.DiagnosticCategory.Error, "Block_scoped_variable_0_used_before_its_declaration_2448", "Block-scoped variable '{0}' used before its declaration."),
        Class_0_used_before_its_declaration: diag(2449, ts2.DiagnosticCategory.Error, "Class_0_used_before_its_declaration_2449", "Class '{0}' used before its declaration."),
        Enum_0_used_before_its_declaration: diag(2450, ts2.DiagnosticCategory.Error, "Enum_0_used_before_its_declaration_2450", "Enum '{0}' used before its declaration."),
        Cannot_redeclare_block_scoped_variable_0: diag(2451, ts2.DiagnosticCategory.Error, "Cannot_redeclare_block_scoped_variable_0_2451", "Cannot redeclare block-scoped variable '{0}'."),
        An_enum_member_cannot_have_a_numeric_name: diag(2452, ts2.DiagnosticCategory.Error, "An_enum_member_cannot_have_a_numeric_name_2452", "An enum member cannot have a numeric name."),
        The_type_argument_for_type_parameter_0_cannot_be_inferred_from_the_usage_Consider_specifying_the_type_arguments_explicitly: diag(2453, ts2.DiagnosticCategory.Error, "The_type_argument_for_type_parameter_0_cannot_be_inferred_from_the_usage_Consider_specifying_the_typ_2453", "The type argument for type parameter '{0}' cannot be inferred from the usage. Consider specifying the type arguments explicitly."),
        Variable_0_is_used_before_being_assigned: diag(2454, ts2.DiagnosticCategory.Error, "Variable_0_is_used_before_being_assigned_2454", "Variable '{0}' is used before being assigned."),
        Type_argument_candidate_1_is_not_a_valid_type_argument_because_it_is_not_a_supertype_of_candidate_0: diag(2455, ts2.DiagnosticCategory.Error, "Type_argument_candidate_1_is_not_a_valid_type_argument_because_it_is_not_a_supertype_of_candidate_0_2455", "Type argument candidate '{1}' is not a valid type argument because it is not a supertype of candidate '{0}'."),
        Type_alias_0_circularly_references_itself: diag(2456, ts2.DiagnosticCategory.Error, "Type_alias_0_circularly_references_itself_2456", "Type alias '{0}' circularly references itself."),
        Type_alias_name_cannot_be_0: diag(2457, ts2.DiagnosticCategory.Error, "Type_alias_name_cannot_be_0_2457", "Type alias name cannot be '{0}'."),
        An_AMD_module_cannot_have_multiple_name_assignments: diag(2458, ts2.DiagnosticCategory.Error, "An_AMD_module_cannot_have_multiple_name_assignments_2458", "An AMD module cannot have multiple name assignments."),
        Module_0_declares_1_locally_but_it_is_not_exported: diag(2459, ts2.DiagnosticCategory.Error, "Module_0_declares_1_locally_but_it_is_not_exported_2459", "Module '{0}' declares '{1}' locally, but it is not exported."),
        Module_0_declares_1_locally_but_it_is_exported_as_2: diag(2460, ts2.DiagnosticCategory.Error, "Module_0_declares_1_locally_but_it_is_exported_as_2_2460", "Module '{0}' declares '{1}' locally, but it is exported as '{2}'."),
        Type_0_is_not_an_array_type: diag(2461, ts2.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_2461", "Type '{0}' is not an array type."),
        A_rest_element_must_be_last_in_a_destructuring_pattern: diag(2462, ts2.DiagnosticCategory.Error, "A_rest_element_must_be_last_in_a_destructuring_pattern_2462", "A rest element must be last in a destructuring pattern."),
        A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature: diag(2463, ts2.DiagnosticCategory.Error, "A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature_2463", "A binding pattern parameter cannot be optional in an implementation signature."),
        A_computed_property_name_must_be_of_type_string_number_symbol_or_any: diag(2464, ts2.DiagnosticCategory.Error, "A_computed_property_name_must_be_of_type_string_number_symbol_or_any_2464", "A computed property name must be of type 'string', 'number', 'symbol', or 'any'."),
        this_cannot_be_referenced_in_a_computed_property_name: diag(2465, ts2.DiagnosticCategory.Error, "this_cannot_be_referenced_in_a_computed_property_name_2465", "'this' cannot be referenced in a computed property name."),
        super_cannot_be_referenced_in_a_computed_property_name: diag(2466, ts2.DiagnosticCategory.Error, "super_cannot_be_referenced_in_a_computed_property_name_2466", "'super' cannot be referenced in a computed property name."),
        A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type: diag(2467, ts2.DiagnosticCategory.Error, "A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type_2467", "A computed property name cannot reference a type parameter from its containing type."),
        Cannot_find_global_value_0: diag(2468, ts2.DiagnosticCategory.Error, "Cannot_find_global_value_0_2468", "Cannot find global value '{0}'."),
        The_0_operator_cannot_be_applied_to_type_symbol: diag(2469, ts2.DiagnosticCategory.Error, "The_0_operator_cannot_be_applied_to_type_symbol_2469", "The '{0}' operator cannot be applied to type 'symbol'."),
        Symbol_reference_does_not_refer_to_the_global_Symbol_constructor_object: diag(2470, ts2.DiagnosticCategory.Error, "Symbol_reference_does_not_refer_to_the_global_Symbol_constructor_object_2470", "'Symbol' reference does not refer to the global Symbol constructor object."),
        A_computed_property_name_of_the_form_0_must_be_of_type_symbol: diag(2471, ts2.DiagnosticCategory.Error, "A_computed_property_name_of_the_form_0_must_be_of_type_symbol_2471", "A computed property name of the form '{0}' must be of type 'symbol'."),
        Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher: diag(2472, ts2.DiagnosticCategory.Error, "Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher_2472", "Spread operator in 'new' expressions is only available when targeting ECMAScript 5 and higher."),
        Enum_declarations_must_all_be_const_or_non_const: diag(2473, ts2.DiagnosticCategory.Error, "Enum_declarations_must_all_be_const_or_non_const_2473", "Enum declarations must all be const or non-const."),
        const_enum_member_initializers_can_only_contain_literal_values_and_other_computed_enum_values: diag(2474, ts2.DiagnosticCategory.Error, "const_enum_member_initializers_can_only_contain_literal_values_and_other_computed_enum_values_2474", "const enum member initializers can only contain literal values and other computed enum values."),
        const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment_or_type_query: diag(2475, ts2.DiagnosticCategory.Error, "const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_im_2475", "'const' enums can only be used in property or index access expressions or the right hand side of an import declaration or export assignment or type query."),
        A_const_enum_member_can_only_be_accessed_using_a_string_literal: diag(2476, ts2.DiagnosticCategory.Error, "A_const_enum_member_can_only_be_accessed_using_a_string_literal_2476", "A const enum member can only be accessed using a string literal."),
        const_enum_member_initializer_was_evaluated_to_a_non_finite_value: diag(2477, ts2.DiagnosticCategory.Error, "const_enum_member_initializer_was_evaluated_to_a_non_finite_value_2477", "'const' enum member initializer was evaluated to a non-finite value."),
        const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN: diag(2478, ts2.DiagnosticCategory.Error, "const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN_2478", "'const' enum member initializer was evaluated to disallowed value 'NaN'."),
        Property_0_does_not_exist_on_const_enum_1: diag(2479, ts2.DiagnosticCategory.Error, "Property_0_does_not_exist_on_const_enum_1_2479", "Property '{0}' does not exist on 'const' enum '{1}'."),
        let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations: diag(2480, ts2.DiagnosticCategory.Error, "let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations_2480", "'let' is not allowed to be used as a name in 'let' or 'const' declarations."),
        Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1: diag(2481, ts2.DiagnosticCategory.Error, "Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1_2481", "Cannot initialize outer scoped variable '{0}' in the same scope as block scoped declaration '{1}'."),
        The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation: diag(2483, ts2.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation_2483", "The left-hand side of a 'for...of' statement cannot use a type annotation."),
        Export_declaration_conflicts_with_exported_declaration_of_0: diag(2484, ts2.DiagnosticCategory.Error, "Export_declaration_conflicts_with_exported_declaration_of_0_2484", "Export declaration conflicts with exported declaration of '{0}'."),
        The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access: diag(2487, ts2.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access_2487", "The left-hand side of a 'for...of' statement must be a variable or a property access."),
        Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator: diag(2488, ts2.DiagnosticCategory.Error, "Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator_2488", "Type '{0}' must have a '[Symbol.iterator]()' method that returns an iterator."),
        An_iterator_must_have_a_next_method: diag(2489, ts2.DiagnosticCategory.Error, "An_iterator_must_have_a_next_method_2489", "An iterator must have a 'next()' method."),
        The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property: diag(2490, ts2.DiagnosticCategory.Error, "The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property_2490", "The type returned by the '{0}()' method of an iterator must have a 'value' property."),
        The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern: diag(2491, ts2.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern_2491", "The left-hand side of a 'for...in' statement cannot be a destructuring pattern."),
        Cannot_redeclare_identifier_0_in_catch_clause: diag(2492, ts2.DiagnosticCategory.Error, "Cannot_redeclare_identifier_0_in_catch_clause_2492", "Cannot redeclare identifier '{0}' in catch clause."),
        Tuple_type_0_of_length_1_has_no_element_at_index_2: diag(2493, ts2.DiagnosticCategory.Error, "Tuple_type_0_of_length_1_has_no_element_at_index_2_2493", "Tuple type '{0}' of length '{1}' has no element at index '{2}'."),
        Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher: diag(2494, ts2.DiagnosticCategory.Error, "Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher_2494", "Using a string in a 'for...of' statement is only supported in ECMAScript 5 and higher."),
        Type_0_is_not_an_array_type_or_a_string_type: diag(2495, ts2.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_or_a_string_type_2495", "Type '{0}' is not an array type or a string type."),
        The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_standard_function_expression: diag(2496, ts2.DiagnosticCategory.Error, "The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_stand_2496", "The 'arguments' object cannot be referenced in an arrow function in ES3 and ES5. Consider using a standard function expression."),
        This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_referencing_its_default_export: diag(2497, ts2.DiagnosticCategory.Error, "This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_2497", "This module can only be referenced with ECMAScript imports/exports by turning on the '{0}' flag and referencing its default export."),
        Module_0_uses_export_and_cannot_be_used_with_export_Asterisk: diag(2498, ts2.DiagnosticCategory.Error, "Module_0_uses_export_and_cannot_be_used_with_export_Asterisk_2498", "Module '{0}' uses 'export =' and cannot be used with 'export *'."),
        An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments: diag(2499, ts2.DiagnosticCategory.Error, "An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments_2499", "An interface can only extend an identifier/qualified-name with optional type arguments."),
        A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments: diag(2500, ts2.DiagnosticCategory.Error, "A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments_2500", "A class can only implement an identifier/qualified-name with optional type arguments."),
        A_rest_element_cannot_contain_a_binding_pattern: diag(2501, ts2.DiagnosticCategory.Error, "A_rest_element_cannot_contain_a_binding_pattern_2501", "A rest element cannot contain a binding pattern."),
        _0_is_referenced_directly_or_indirectly_in_its_own_type_annotation: diag(2502, ts2.DiagnosticCategory.Error, "_0_is_referenced_directly_or_indirectly_in_its_own_type_annotation_2502", "'{0}' is referenced directly or indirectly in its own type annotation."),
        Cannot_find_namespace_0: diag(2503, ts2.DiagnosticCategory.Error, "Cannot_find_namespace_0_2503", "Cannot find namespace '{0}'."),
        Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator: diag(2504, ts2.DiagnosticCategory.Error, "Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator_2504", "Type '{0}' must have a '[Symbol.asyncIterator]()' method that returns an async iterator."),
        A_generator_cannot_have_a_void_type_annotation: diag(2505, ts2.DiagnosticCategory.Error, "A_generator_cannot_have_a_void_type_annotation_2505", "A generator cannot have a 'void' type annotation."),
        _0_is_referenced_directly_or_indirectly_in_its_own_base_expression: diag(2506, ts2.DiagnosticCategory.Error, "_0_is_referenced_directly_or_indirectly_in_its_own_base_expression_2506", "'{0}' is referenced directly or indirectly in its own base expression."),
        Type_0_is_not_a_constructor_function_type: diag(2507, ts2.DiagnosticCategory.Error, "Type_0_is_not_a_constructor_function_type_2507", "Type '{0}' is not a constructor function type."),
        No_base_constructor_has_the_specified_number_of_type_arguments: diag(2508, ts2.DiagnosticCategory.Error, "No_base_constructor_has_the_specified_number_of_type_arguments_2508", "No base constructor has the specified number of type arguments."),
        Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_known_members: diag(2509, ts2.DiagnosticCategory.Error, "Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_2509", "Base constructor return type '{0}' is not an object type or intersection of object types with statically known members."),
        Base_constructors_must_all_have_the_same_return_type: diag(2510, ts2.DiagnosticCategory.Error, "Base_constructors_must_all_have_the_same_return_type_2510", "Base constructors must all have the same return type."),
        Cannot_create_an_instance_of_an_abstract_class: diag(2511, ts2.DiagnosticCategory.Error, "Cannot_create_an_instance_of_an_abstract_class_2511", "Cannot create an instance of an abstract class."),
        Overload_signatures_must_all_be_abstract_or_non_abstract: diag(2512, ts2.DiagnosticCategory.Error, "Overload_signatures_must_all_be_abstract_or_non_abstract_2512", "Overload signatures must all be abstract or non-abstract."),
        Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression: diag(2513, ts2.DiagnosticCategory.Error, "Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression_2513", "Abstract method '{0}' in class '{1}' cannot be accessed via super expression."),
        Classes_containing_abstract_methods_must_be_marked_abstract: diag(2514, ts2.DiagnosticCategory.Error, "Classes_containing_abstract_methods_must_be_marked_abstract_2514", "Classes containing abstract methods must be marked abstract."),
        Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2: diag(2515, ts2.DiagnosticCategory.Error, "Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2_2515", "Non-abstract class '{0}' does not implement inherited abstract member '{1}' from class '{2}'."),
        All_declarations_of_an_abstract_method_must_be_consecutive: diag(2516, ts2.DiagnosticCategory.Error, "All_declarations_of_an_abstract_method_must_be_consecutive_2516", "All declarations of an abstract method must be consecutive."),
        Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type: diag(2517, ts2.DiagnosticCategory.Error, "Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type_2517", "Cannot assign an abstract constructor type to a non-abstract constructor type."),
        A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard: diag(2518, ts2.DiagnosticCategory.Error, "A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard_2518", "A 'this'-based type guard is not compatible with a parameter-based type guard."),
        An_async_iterator_must_have_a_next_method: diag(2519, ts2.DiagnosticCategory.Error, "An_async_iterator_must_have_a_next_method_2519", "An async iterator must have a 'next()' method."),
        Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions: diag(2520, ts2.DiagnosticCategory.Error, "Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions_2520", "Duplicate identifier '{0}'. Compiler uses declaration '{1}' to support async functions."),
        Expression_resolves_to_variable_declaration_0_that_compiler_uses_to_support_async_functions: diag(2521, ts2.DiagnosticCategory.Error, "Expression_resolves_to_variable_declaration_0_that_compiler_uses_to_support_async_functions_2521", "Expression resolves to variable declaration '{0}' that compiler uses to support async functions."),
        The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_using_a_standard_function_or_method: diag(2522, ts2.DiagnosticCategory.Error, "The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_usi_2522", "The 'arguments' object cannot be referenced in an async function or method in ES3 and ES5. Consider using a standard function or method."),
        yield_expressions_cannot_be_used_in_a_parameter_initializer: diag(2523, ts2.DiagnosticCategory.Error, "yield_expressions_cannot_be_used_in_a_parameter_initializer_2523", "'yield' expressions cannot be used in a parameter initializer."),
        await_expressions_cannot_be_used_in_a_parameter_initializer: diag(2524, ts2.DiagnosticCategory.Error, "await_expressions_cannot_be_used_in_a_parameter_initializer_2524", "'await' expressions cannot be used in a parameter initializer."),
        Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value: diag(2525, ts2.DiagnosticCategory.Error, "Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value_2525", "Initializer provides no value for this binding element and the binding element has no default value."),
        A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface: diag(2526, ts2.DiagnosticCategory.Error, "A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface_2526", "A 'this' type is available only in a non-static member of a class or interface."),
        The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary: diag(2527, ts2.DiagnosticCategory.Error, "The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary_2527", "The inferred type of '{0}' references an inaccessible '{1}' type. A type annotation is necessary."),
        A_module_cannot_have_multiple_default_exports: diag(2528, ts2.DiagnosticCategory.Error, "A_module_cannot_have_multiple_default_exports_2528", "A module cannot have multiple default exports."),
        Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions: diag(2529, ts2.DiagnosticCategory.Error, "Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_func_2529", "Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module containing async functions."),
        Property_0_is_incompatible_with_index_signature: diag(2530, ts2.DiagnosticCategory.Error, "Property_0_is_incompatible_with_index_signature_2530", "Property '{0}' is incompatible with index signature."),
        Object_is_possibly_null: diag(2531, ts2.DiagnosticCategory.Error, "Object_is_possibly_null_2531", "Object is possibly 'null'."),
        Object_is_possibly_undefined: diag(2532, ts2.DiagnosticCategory.Error, "Object_is_possibly_undefined_2532", "Object is possibly 'undefined'."),
        Object_is_possibly_null_or_undefined: diag(2533, ts2.DiagnosticCategory.Error, "Object_is_possibly_null_or_undefined_2533", "Object is possibly 'null' or 'undefined'."),
        A_function_returning_never_cannot_have_a_reachable_end_point: diag(2534, ts2.DiagnosticCategory.Error, "A_function_returning_never_cannot_have_a_reachable_end_point_2534", "A function returning 'never' cannot have a reachable end point."),
        Enum_type_0_has_members_with_initializers_that_are_not_literals: diag(2535, ts2.DiagnosticCategory.Error, "Enum_type_0_has_members_with_initializers_that_are_not_literals_2535", "Enum type '{0}' has members with initializers that are not literals."),
        Type_0_cannot_be_used_to_index_type_1: diag(2536, ts2.DiagnosticCategory.Error, "Type_0_cannot_be_used_to_index_type_1_2536", "Type '{0}' cannot be used to index type '{1}'."),
        Type_0_has_no_matching_index_signature_for_type_1: diag(2537, ts2.DiagnosticCategory.Error, "Type_0_has_no_matching_index_signature_for_type_1_2537", "Type '{0}' has no matching index signature for type '{1}'."),
        Type_0_cannot_be_used_as_an_index_type: diag(2538, ts2.DiagnosticCategory.Error, "Type_0_cannot_be_used_as_an_index_type_2538", "Type '{0}' cannot be used as an index type."),
        Cannot_assign_to_0_because_it_is_not_a_variable: diag(2539, ts2.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_not_a_variable_2539", "Cannot assign to '{0}' because it is not a variable."),
        Cannot_assign_to_0_because_it_is_a_read_only_property: diag(2540, ts2.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_read_only_property_2540", "Cannot assign to '{0}' because it is a read-only property."),
        The_target_of_an_assignment_must_be_a_variable_or_a_property_access: diag(2541, ts2.DiagnosticCategory.Error, "The_target_of_an_assignment_must_be_a_variable_or_a_property_access_2541", "The target of an assignment must be a variable or a property access."),
        Index_signature_in_type_0_only_permits_reading: diag(2542, ts2.DiagnosticCategory.Error, "Index_signature_in_type_0_only_permits_reading_2542", "Index signature in type '{0}' only permits reading."),
        Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_meta_property_reference: diag(2543, ts2.DiagnosticCategory.Error, "Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_me_2543", "Duplicate identifier '_newTarget'. Compiler uses variable declaration '_newTarget' to capture 'new.target' meta-property reference."),
        Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta_property_reference: diag(2544, ts2.DiagnosticCategory.Error, "Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta__2544", "Expression resolves to variable declaration '_newTarget' that compiler uses to capture 'new.target' meta-property reference."),
        A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any: diag(2545, ts2.DiagnosticCategory.Error, "A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any_2545", "A mixin class must have a constructor with a single rest parameter of type 'any[]'."),
        The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property: diag(2547, ts2.DiagnosticCategory.Error, "The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_pro_2547", "The type returned by the '{0}()' method of an async iterator must be a promise for a type with a 'value' property."),
        Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator: diag(2548, ts2.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator_2548", "Type '{0}' is not an array type or does not have a '[Symbol.iterator]()' method that returns an iterator."),
        Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator: diag(2549, ts2.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns__2549", "Type '{0}' is not an array type or a string type or does not have a '[Symbol.iterator]()' method that returns an iterator."),
        Property_0_does_not_exist_on_type_1_Did_you_mean_2: diag(2551, ts2.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_Did_you_mean_2_2551", "Property '{0}' does not exist on type '{1}'. Did you mean '{2}'?"),
        Cannot_find_name_0_Did_you_mean_1: diag(2552, ts2.DiagnosticCategory.Error, "Cannot_find_name_0_Did_you_mean_1_2552", "Cannot find name '{0}'. Did you mean '{1}'?"),
        Computed_values_are_not_permitted_in_an_enum_with_string_valued_members: diag(2553, ts2.DiagnosticCategory.Error, "Computed_values_are_not_permitted_in_an_enum_with_string_valued_members_2553", "Computed values are not permitted in an enum with string valued members."),
        Expected_0_arguments_but_got_1: diag(2554, ts2.DiagnosticCategory.Error, "Expected_0_arguments_but_got_1_2554", "Expected {0} arguments, but got {1}."),
        Expected_at_least_0_arguments_but_got_1: diag(2555, ts2.DiagnosticCategory.Error, "Expected_at_least_0_arguments_but_got_1_2555", "Expected at least {0} arguments, but got {1}."),
        Expected_0_arguments_but_got_1_or_more: diag(2556, ts2.DiagnosticCategory.Error, "Expected_0_arguments_but_got_1_or_more_2556", "Expected {0} arguments, but got {1} or more."),
        Expected_at_least_0_arguments_but_got_1_or_more: diag(2557, ts2.DiagnosticCategory.Error, "Expected_at_least_0_arguments_but_got_1_or_more_2557", "Expected at least {0} arguments, but got {1} or more."),
        Expected_0_type_arguments_but_got_1: diag(2558, ts2.DiagnosticCategory.Error, "Expected_0_type_arguments_but_got_1_2558", "Expected {0} type arguments, but got {1}."),
        Type_0_has_no_properties_in_common_with_type_1: diag(2559, ts2.DiagnosticCategory.Error, "Type_0_has_no_properties_in_common_with_type_1_2559", "Type '{0}' has no properties in common with type '{1}'."),
        Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it: diag(2560, ts2.DiagnosticCategory.Error, "Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it_2560", "Value of type '{0}' has no properties in common with type '{1}'. Did you mean to call it?"),
        Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_write_2: diag(2561, ts2.DiagnosticCategory.Error, "Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_writ_2561", "Object literal may only specify known properties, but '{0}' does not exist in type '{1}'. Did you mean to write '{2}'?"),
        Base_class_expressions_cannot_reference_class_type_parameters: diag(2562, ts2.DiagnosticCategory.Error, "Base_class_expressions_cannot_reference_class_type_parameters_2562", "Base class expressions cannot reference class type parameters."),
        The_containing_function_or_module_body_is_too_large_for_control_flow_analysis: diag(2563, ts2.DiagnosticCategory.Error, "The_containing_function_or_module_body_is_too_large_for_control_flow_analysis_2563", "The containing function or module body is too large for control flow analysis."),
        Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor: diag(2564, ts2.DiagnosticCategory.Error, "Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor_2564", "Property '{0}' has no initializer and is not definitely assigned in the constructor."),
        Property_0_is_used_before_being_assigned: diag(2565, ts2.DiagnosticCategory.Error, "Property_0_is_used_before_being_assigned_2565", "Property '{0}' is used before being assigned."),
        A_rest_element_cannot_have_a_property_name: diag(2566, ts2.DiagnosticCategory.Error, "A_rest_element_cannot_have_a_property_name_2566", "A rest element cannot have a property name."),
        Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations: diag(2567, ts2.DiagnosticCategory.Error, "Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations_2567", "Enum declarations can only merge with namespace or other enum declarations."),
        Type_0_is_not_an_array_type_or_a_string_type_Use_compiler_option_downlevelIteration_to_allow_iterating_of_iterators: diag(2569, ts2.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_or_a_string_type_Use_compiler_option_downlevelIteration_to_allow_iterati_2569", "Type '{0}' is not an array type or a string type. Use compiler option '--downlevelIteration' to allow iterating of iterators."),
        Object_is_of_type_unknown: diag(2571, ts2.DiagnosticCategory.Error, "Object_is_of_type_unknown_2571", "Object is of type 'unknown'."),
        Rest_signatures_are_incompatible: diag(2572, ts2.DiagnosticCategory.Error, "Rest_signatures_are_incompatible_2572", "Rest signatures are incompatible."),
        Property_0_is_incompatible_with_rest_element_type: diag(2573, ts2.DiagnosticCategory.Error, "Property_0_is_incompatible_with_rest_element_type_2573", "Property '{0}' is incompatible with rest element type."),
        A_rest_element_type_must_be_an_array_type: diag(2574, ts2.DiagnosticCategory.Error, "A_rest_element_type_must_be_an_array_type_2574", "A rest element type must be an array type."),
        No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments: diag(2575, ts2.DiagnosticCategory.Error, "No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments_2575", "No overload expects {0} arguments, but overloads do exist that expect either {1} or {2} arguments."),
        Property_0_is_a_static_member_of_type_1: diag(2576, ts2.DiagnosticCategory.Error, "Property_0_is_a_static_member_of_type_1_2576", "Property '{0}' is a static member of type '{1}'"),
        Return_type_annotation_circularly_references_itself: diag(2577, ts2.DiagnosticCategory.Error, "Return_type_annotation_circularly_references_itself_2577", "Return type annotation circularly references itself."),
        Unused_ts_expect_error_directive: diag(2578, ts2.DiagnosticCategory.Error, "Unused_ts_expect_error_directive_2578", "Unused '@ts-expect-error' directive."),
        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_types_Slashnode: diag(2580, ts2.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_types_Slashnode_2580", "Cannot find name '{0}'. Do you need to install type definitions for node? Try `npm i @types/node`."),
        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_types_Slashjquery: diag(2581, ts2.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_types_Slashjquery_2581", "Cannot find name '{0}'. Do you need to install type definitions for jQuery? Try `npm i @types/jquery`."),
        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_types_Slashjest_or_npm_i_types_Slashmocha: diag(2582, ts2.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_types_Slashje_2582", "Cannot find name '{0}'. Do you need to install type definitions for a test runner? Try `npm i @types/jest` or `npm i @types/mocha`."),
        Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later: diag(2583, ts2.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2583", "Cannot find name '{0}'. Do you need to change your target library? Try changing the `lib` compiler option to es2015 or later."),
        Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom: diag(2584, ts2.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2584", "Cannot find name '{0}'. Do you need to change your target library? Try changing the `lib` compiler option to include 'dom'."),
        _0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later: diag(2585, ts2.DiagnosticCategory.Error, "_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_2585", "'{0}' only refers to a type, but is being used as a value here. Do you need to change your target library? Try changing the `lib` compiler option to es2015 or later."),
        Enum_type_0_circularly_references_itself: diag(2586, ts2.DiagnosticCategory.Error, "Enum_type_0_circularly_references_itself_2586", "Enum type '{0}' circularly references itself."),
        JSDoc_type_0_circularly_references_itself: diag(2587, ts2.DiagnosticCategory.Error, "JSDoc_type_0_circularly_references_itself_2587", "JSDoc type '{0}' circularly references itself."),
        Cannot_assign_to_0_because_it_is_a_constant: diag(2588, ts2.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_constant_2588", "Cannot assign to '{0}' because it is a constant."),
        Type_instantiation_is_excessively_deep_and_possibly_infinite: diag(2589, ts2.DiagnosticCategory.Error, "Type_instantiation_is_excessively_deep_and_possibly_infinite_2589", "Type instantiation is excessively deep and possibly infinite."),
        Expression_produces_a_union_type_that_is_too_complex_to_represent: diag(2590, ts2.DiagnosticCategory.Error, "Expression_produces_a_union_type_that_is_too_complex_to_represent_2590", "Expression produces a union type that is too complex to represent."),
        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig: diag(2591, ts2.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_types_Slashnode_and_th_2591", "Cannot find name '{0}'. Do you need to install type definitions for node? Try `npm i @types/node` and then add `node` to the types field in your tsconfig."),
        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig: diag(2592, ts2.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_types_Slashjquery_an_2592", "Cannot find name '{0}'. Do you need to install type definitions for jQuery? Try `npm i @types/jquery` and then add `jquery` to the types field in your tsconfig."),
        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_types_Slashjest_or_npm_i_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig: diag(2593, ts2.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_types_Slashje_2593", "Cannot find name '{0}'. Do you need to install type definitions for a test runner? Try `npm i @types/jest` or `npm i @types/mocha` and then add `jest` or `mocha` to the types field in your tsconfig."),
        This_module_is_declared_with_using_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag: diag(2594, ts2.DiagnosticCategory.Error, "This_module_is_declared_with_using_export_and_can_only_be_used_with_a_default_import_when_using_the__2594", "This module is declared with using 'export =', and can only be used with a default import when using the '{0}' flag."),
        _0_can_only_be_imported_by_using_a_default_import: diag(2595, ts2.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_a_default_import_2595", "'{0}' can only be imported by using a default import."),
        _0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import: diag(2596, ts2.DiagnosticCategory.Error, "_0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import_2596", "'{0}' can only be imported by turning on the 'esModuleInterop' flag and using a default import."),
        _0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import: diag(2597, ts2.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import_2597", "'{0}' can only be imported by using a 'require' call or by using a default import."),
        _0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import: diag(2598, ts2.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using__2598", "'{0}' can only be imported by using a 'require' call or by turning on the 'esModuleInterop' flag and using a default import."),
        JSX_element_attributes_type_0_may_not_be_a_union_type: diag(2600, ts2.DiagnosticCategory.Error, "JSX_element_attributes_type_0_may_not_be_a_union_type_2600", "JSX element attributes type '{0}' may not be a union type."),
        The_return_type_of_a_JSX_element_constructor_must_return_an_object_type: diag(2601, ts2.DiagnosticCategory.Error, "The_return_type_of_a_JSX_element_constructor_must_return_an_object_type_2601", "The return type of a JSX element constructor must return an object type."),
        JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist: diag(2602, ts2.DiagnosticCategory.Error, "JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist_2602", "JSX element implicitly has type 'any' because the global type 'JSX.Element' does not exist."),
        Property_0_in_type_1_is_not_assignable_to_type_2: diag(2603, ts2.DiagnosticCategory.Error, "Property_0_in_type_1_is_not_assignable_to_type_2_2603", "Property '{0}' in type '{1}' is not assignable to type '{2}'."),
        JSX_element_type_0_does_not_have_any_construct_or_call_signatures: diag(2604, ts2.DiagnosticCategory.Error, "JSX_element_type_0_does_not_have_any_construct_or_call_signatures_2604", "JSX element type '{0}' does not have any construct or call signatures."),
        JSX_element_type_0_is_not_a_constructor_function_for_JSX_elements: diag(2605, ts2.DiagnosticCategory.Error, "JSX_element_type_0_is_not_a_constructor_function_for_JSX_elements_2605", "JSX element type '{0}' is not a constructor function for JSX elements."),
        Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property: diag(2606, ts2.DiagnosticCategory.Error, "Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property_2606", "Property '{0}' of JSX spread attribute is not assignable to target property."),
        JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property: diag(2607, ts2.DiagnosticCategory.Error, "JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property_2607", "JSX element class does not support attributes because it does not have a '{0}' property."),
        The_global_type_JSX_0_may_not_have_more_than_one_property: diag(2608, ts2.DiagnosticCategory.Error, "The_global_type_JSX_0_may_not_have_more_than_one_property_2608", "The global type 'JSX.{0}' may not have more than one property."),
        JSX_spread_child_must_be_an_array_type: diag(2609, ts2.DiagnosticCategory.Error, "JSX_spread_child_must_be_an_array_type_2609", "JSX spread child must be an array type."),
        _0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property: diag(2610, ts2.DiagnosticCategory.Error, "_0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property_2610", "'{0}' is defined as an accessor in class '{1}', but is overridden here in '{2}' as an instance property."),
        _0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor: diag(2611, ts2.DiagnosticCategory.Error, "_0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor_2611", "'{0}' is defined as a property in class '{1}', but is overridden here in '{2}' as an accessor."),
        Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration: diag(2612, ts2.DiagnosticCategory.Error, "Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_2612", "Property '{0}' will overwrite the base property in '{1}'. If this is intentional, add an initializer. Otherwise, add a 'declare' modifier or remove the redundant declaration."),
        Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead: diag(2613, ts2.DiagnosticCategory.Error, "Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead_2613", "Module '{0}' has no default export. Did you mean to use 'import { {1} } from {0}' instead?"),
        Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead: diag(2614, ts2.DiagnosticCategory.Error, "Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead_2614", "Module '{0}' has no exported member '{1}'. Did you mean to use 'import {1} from {0}' instead?"),
        Type_of_property_0_circularly_references_itself_in_mapped_type_1: diag(2615, ts2.DiagnosticCategory.Error, "Type_of_property_0_circularly_references_itself_in_mapped_type_1_2615", "Type of property '{0}' circularly references itself in mapped type '{1}'."),
        _0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import: diag(2616, ts2.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import_2616", "'{0}' can only be imported by using 'import {1} = require({2})' or a default import."),
        _0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import: diag(2617, ts2.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_us_2617", "'{0}' can only be imported by using 'import {1} = require({2})' or by turning on the 'esModuleInterop' flag and using a default import."),
        Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity: diag(2649, ts2.DiagnosticCategory.Error, "Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity_2649", "Cannot augment module '{0}' with value exports because it resolves to a non-module entity."),
        A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums: diag(2651, ts2.DiagnosticCategory.Error, "A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_memb_2651", "A member initializer in a enum declaration cannot reference members declared after it, including members defined in other enums."),
        Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead: diag(2652, ts2.DiagnosticCategory.Error, "Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_d_2652", "Merged declaration '{0}' cannot include a default export declaration. Consider adding a separate 'export default {0}' declaration instead."),
        Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1: diag(2653, ts2.DiagnosticCategory.Error, "Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1_2653", "Non-abstract class expression does not implement inherited abstract member '{0}' from class '{1}'."),
        Exported_external_package_typings_file_cannot_contain_tripleslash_references_Please_contact_the_package_author_to_update_the_package_definition: diag(2654, ts2.DiagnosticCategory.Error, "Exported_external_package_typings_file_cannot_contain_tripleslash_references_Please_contact_the_pack_2654", "Exported external package typings file cannot contain tripleslash references. Please contact the package author to update the package definition."),
        Exported_external_package_typings_file_0_is_not_a_module_Please_contact_the_package_author_to_update_the_package_definition: diag(2656, ts2.DiagnosticCategory.Error, "Exported_external_package_typings_file_0_is_not_a_module_Please_contact_the_package_author_to_update_2656", "Exported external package typings file '{0}' is not a module. Please contact the package author to update the package definition."),
        JSX_expressions_must_have_one_parent_element: diag(2657, ts2.DiagnosticCategory.Error, "JSX_expressions_must_have_one_parent_element_2657", "JSX expressions must have one parent element."),
        Type_0_provides_no_match_for_the_signature_1: diag(2658, ts2.DiagnosticCategory.Error, "Type_0_provides_no_match_for_the_signature_1_2658", "Type '{0}' provides no match for the signature '{1}'."),
        super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher: diag(2659, ts2.DiagnosticCategory.Error, "super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_highe_2659", "'super' is only allowed in members of object literal expressions when option 'target' is 'ES2015' or higher."),
        super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions: diag(2660, ts2.DiagnosticCategory.Error, "super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions_2660", "'super' can only be referenced in members of derived classes or object literal expressions."),
        Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module: diag(2661, ts2.DiagnosticCategory.Error, "Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module_2661", "Cannot export '{0}'. Only local declarations can be exported from a module."),
        Cannot_find_name_0_Did_you_mean_the_static_member_1_0: diag(2662, ts2.DiagnosticCategory.Error, "Cannot_find_name_0_Did_you_mean_the_static_member_1_0_2662", "Cannot find name '{0}'. Did you mean the static member '{1}.{0}'?"),
        Cannot_find_name_0_Did_you_mean_the_instance_member_this_0: diag(2663, ts2.DiagnosticCategory.Error, "Cannot_find_name_0_Did_you_mean_the_instance_member_this_0_2663", "Cannot find name '{0}'. Did you mean the instance member 'this.{0}'?"),
        Invalid_module_name_in_augmentation_module_0_cannot_be_found: diag(2664, ts2.DiagnosticCategory.Error, "Invalid_module_name_in_augmentation_module_0_cannot_be_found_2664", "Invalid module name in augmentation, module '{0}' cannot be found."),
        Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augmented: diag(2665, ts2.DiagnosticCategory.Error, "Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augm_2665", "Invalid module name in augmentation. Module '{0}' resolves to an untyped module at '{1}', which cannot be augmented."),
        Exports_and_export_assignments_are_not_permitted_in_module_augmentations: diag(2666, ts2.DiagnosticCategory.Error, "Exports_and_export_assignments_are_not_permitted_in_module_augmentations_2666", "Exports and export assignments are not permitted in module augmentations."),
        Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module: diag(2667, ts2.DiagnosticCategory.Error, "Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_mod_2667", "Imports are not permitted in module augmentations. Consider moving them to the enclosing external module."),
        export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible: diag(2668, ts2.DiagnosticCategory.Error, "export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always__2668", "'export' modifier cannot be applied to ambient modules and module augmentations since they are always visible."),
        Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations: diag(2669, ts2.DiagnosticCategory.Error, "Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_2669", "Augmentations for the global scope can only be directly nested in external modules or ambient module declarations."),
        Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context: diag(2670, ts2.DiagnosticCategory.Error, "Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambien_2670", "Augmentations for the global scope should have 'declare' modifier unless they appear in already ambient context."),
        Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity: diag(2671, ts2.DiagnosticCategory.Error, "Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity_2671", "Cannot augment module '{0}' because it resolves to a non-module entity."),
        Cannot_assign_a_0_constructor_type_to_a_1_constructor_type: diag(2672, ts2.DiagnosticCategory.Error, "Cannot_assign_a_0_constructor_type_to_a_1_constructor_type_2672", "Cannot assign a '{0}' constructor type to a '{1}' constructor type."),
        Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration: diag(2673, ts2.DiagnosticCategory.Error, "Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration_2673", "Constructor of class '{0}' is private and only accessible within the class declaration."),
        Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration: diag(2674, ts2.DiagnosticCategory.Error, "Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration_2674", "Constructor of class '{0}' is protected and only accessible within the class declaration."),
        Cannot_extend_a_class_0_Class_constructor_is_marked_as_private: diag(2675, ts2.DiagnosticCategory.Error, "Cannot_extend_a_class_0_Class_constructor_is_marked_as_private_2675", "Cannot extend a class '{0}'. Class constructor is marked as private."),
        Accessors_must_both_be_abstract_or_non_abstract: diag(2676, ts2.DiagnosticCategory.Error, "Accessors_must_both_be_abstract_or_non_abstract_2676", "Accessors must both be abstract or non-abstract."),
        A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type: diag(2677, ts2.DiagnosticCategory.Error, "A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type_2677", "A type predicate's type must be assignable to its parameter's type."),
        Type_0_is_not_comparable_to_type_1: diag(2678, ts2.DiagnosticCategory.Error, "Type_0_is_not_comparable_to_type_1_2678", "Type '{0}' is not comparable to type '{1}'."),
        A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void: diag(2679, ts2.DiagnosticCategory.Error, "A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void_2679", "A function that is called with the 'new' keyword cannot have a 'this' type that is 'void'."),
        A_0_parameter_must_be_the_first_parameter: diag(2680, ts2.DiagnosticCategory.Error, "A_0_parameter_must_be_the_first_parameter_2680", "A '{0}' parameter must be the first parameter."),
        A_constructor_cannot_have_a_this_parameter: diag(2681, ts2.DiagnosticCategory.Error, "A_constructor_cannot_have_a_this_parameter_2681", "A constructor cannot have a 'this' parameter."),
        get_and_set_accessor_must_have_the_same_this_type: diag(2682, ts2.DiagnosticCategory.Error, "get_and_set_accessor_must_have_the_same_this_type_2682", "'get' and 'set' accessor must have the same 'this' type."),
        this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation: diag(2683, ts2.DiagnosticCategory.Error, "this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_2683", "'this' implicitly has type 'any' because it does not have a type annotation."),
        The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1: diag(2684, ts2.DiagnosticCategory.Error, "The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1_2684", "The 'this' context of type '{0}' is not assignable to method's 'this' of type '{1}'."),
        The_this_types_of_each_signature_are_incompatible: diag(2685, ts2.DiagnosticCategory.Error, "The_this_types_of_each_signature_are_incompatible_2685", "The 'this' types of each signature are incompatible."),
        _0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead: diag(2686, ts2.DiagnosticCategory.Error, "_0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead_2686", "'{0}' refers to a UMD global, but the current file is a module. Consider adding an import instead."),
        All_declarations_of_0_must_have_identical_modifiers: diag(2687, ts2.DiagnosticCategory.Error, "All_declarations_of_0_must_have_identical_modifiers_2687", "All declarations of '{0}' must have identical modifiers."),
        Cannot_find_type_definition_file_for_0: diag(2688, ts2.DiagnosticCategory.Error, "Cannot_find_type_definition_file_for_0_2688", "Cannot find type definition file for '{0}'."),
        Cannot_extend_an_interface_0_Did_you_mean_implements: diag(2689, ts2.DiagnosticCategory.Error, "Cannot_extend_an_interface_0_Did_you_mean_implements_2689", "Cannot extend an interface '{0}'. Did you mean 'implements'?"),
        An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead: diag(2691, ts2.DiagnosticCategory.Error, "An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead_2691", "An import path cannot end with a '{0}' extension. Consider importing '{1}' instead."),
        _0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible: diag(2692, ts2.DiagnosticCategory.Error, "_0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible_2692", "'{0}' is a primitive, but '{1}' is a wrapper object. Prefer using '{0}' when possible."),
        _0_only_refers_to_a_type_but_is_being_used_as_a_value_here: diag(2693, ts2.DiagnosticCategory.Error, "_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_2693", "'{0}' only refers to a type, but is being used as a value here."),
        Namespace_0_has_no_exported_member_1: diag(2694, ts2.DiagnosticCategory.Error, "Namespace_0_has_no_exported_member_1_2694", "Namespace '{0}' has no exported member '{1}'."),
        Left_side_of_comma_operator_is_unused_and_has_no_side_effects: diag(2695, ts2.DiagnosticCategory.Error, "Left_side_of_comma_operator_is_unused_and_has_no_side_effects_2695", "Left side of comma operator is unused and has no side effects.", true),
        The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead: diag(2696, ts2.DiagnosticCategory.Error, "The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead_2696", "The 'Object' type is assignable to very few other types. Did you mean to use the 'any' type instead?"),
        An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option: diag(2697, ts2.DiagnosticCategory.Error, "An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_in_2697", "An async function or method must return a 'Promise'. Make sure you have a declaration for 'Promise' or include 'ES2015' in your `--lib` option."),
        Spread_types_may_only_be_created_from_object_types: diag(2698, ts2.DiagnosticCategory.Error, "Spread_types_may_only_be_created_from_object_types_2698", "Spread types may only be created from object types."),
        Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1: diag(2699, ts2.DiagnosticCategory.Error, "Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1_2699", "Static property '{0}' conflicts with built-in property 'Function.{0}' of constructor function '{1}'."),
        Rest_types_may_only_be_created_from_object_types: diag(2700, ts2.DiagnosticCategory.Error, "Rest_types_may_only_be_created_from_object_types_2700", "Rest types may only be created from object types."),
        The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access: diag(2701, ts2.DiagnosticCategory.Error, "The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access_2701", "The target of an object rest assignment must be a variable or a property access."),
        _0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here: diag(2702, ts2.DiagnosticCategory.Error, "_0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here_2702", "'{0}' only refers to a type, but is being used as a namespace here."),
        The_operand_of_a_delete_operator_must_be_a_property_reference: diag(2703, ts2.DiagnosticCategory.Error, "The_operand_of_a_delete_operator_must_be_a_property_reference_2703", "The operand of a 'delete' operator must be a property reference."),
        The_operand_of_a_delete_operator_cannot_be_a_read_only_property: diag(2704, ts2.DiagnosticCategory.Error, "The_operand_of_a_delete_operator_cannot_be_a_read_only_property_2704", "The operand of a 'delete' operator cannot be a read-only property."),
        An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option: diag(2705, ts2.DiagnosticCategory.Error, "An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_de_2705", "An async function or method in ES5/ES3 requires the 'Promise' constructor.  Make sure you have a declaration for the 'Promise' constructor or include 'ES2015' in your `--lib` option."),
        Required_type_parameters_may_not_follow_optional_type_parameters: diag(2706, ts2.DiagnosticCategory.Error, "Required_type_parameters_may_not_follow_optional_type_parameters_2706", "Required type parameters may not follow optional type parameters."),
        Generic_type_0_requires_between_1_and_2_type_arguments: diag(2707, ts2.DiagnosticCategory.Error, "Generic_type_0_requires_between_1_and_2_type_arguments_2707", "Generic type '{0}' requires between {1} and {2} type arguments."),
        Cannot_use_namespace_0_as_a_value: diag(2708, ts2.DiagnosticCategory.Error, "Cannot_use_namespace_0_as_a_value_2708", "Cannot use namespace '{0}' as a value."),
        Cannot_use_namespace_0_as_a_type: diag(2709, ts2.DiagnosticCategory.Error, "Cannot_use_namespace_0_as_a_type_2709", "Cannot use namespace '{0}' as a type."),
        _0_are_specified_twice_The_attribute_named_0_will_be_overwritten: diag(2710, ts2.DiagnosticCategory.Error, "_0_are_specified_twice_The_attribute_named_0_will_be_overwritten_2710", "'{0}' are specified twice. The attribute named '{0}' will be overwritten."),
        A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option: diag(2711, ts2.DiagnosticCategory.Error, "A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES20_2711", "A dynamic import call returns a 'Promise'. Make sure you have a declaration for 'Promise' or include 'ES2015' in your `--lib` option."),
        A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option: diag(2712, ts2.DiagnosticCategory.Error, "A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declarat_2712", "A dynamic import call in ES5/ES3 requires the 'Promise' constructor.  Make sure you have a declaration for the 'Promise' constructor or include 'ES2015' in your `--lib` option."),
        Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1: diag(2713, ts2.DiagnosticCategory.Error, "Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_p_2713", `Cannot access '{0}.{1}' because '{0}' is a type, but not a namespace. Did you mean to retrieve the type of the property '{1}' in '{0}' with '{0}["{1}"]'?`),
        The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context: diag(2714, ts2.DiagnosticCategory.Error, "The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context_2714", "The expression of an export assignment must be an identifier or qualified name in an ambient context."),
        Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor: diag(2715, ts2.DiagnosticCategory.Error, "Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor_2715", "Abstract property '{0}' in class '{1}' cannot be accessed in the constructor."),
        Type_parameter_0_has_a_circular_default: diag(2716, ts2.DiagnosticCategory.Error, "Type_parameter_0_has_a_circular_default_2716", "Type parameter '{0}' has a circular default."),
        Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_type_2: diag(2717, ts2.DiagnosticCategory.Error, "Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_t_2717", "Subsequent property declarations must have the same type.  Property '{0}' must be of type '{1}', but here has type '{2}'."),
        Duplicate_property_0: diag(2718, ts2.DiagnosticCategory.Error, "Duplicate_property_0_2718", "Duplicate property '{0}'."),
        Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated: diag(2719, ts2.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated_2719", "Type '{0}' is not assignable to type '{1}'. Two different types with this name exist, but they are unrelated."),
        Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass: diag(2720, ts2.DiagnosticCategory.Error, "Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclas_2720", "Class '{0}' incorrectly implements class '{1}'. Did you mean to extend '{1}' and inherit its members as a subclass?"),
        Cannot_invoke_an_object_which_is_possibly_null: diag(2721, ts2.DiagnosticCategory.Error, "Cannot_invoke_an_object_which_is_possibly_null_2721", "Cannot invoke an object which is possibly 'null'."),
        Cannot_invoke_an_object_which_is_possibly_undefined: diag(2722, ts2.DiagnosticCategory.Error, "Cannot_invoke_an_object_which_is_possibly_undefined_2722", "Cannot invoke an object which is possibly 'undefined'."),
        Cannot_invoke_an_object_which_is_possibly_null_or_undefined: diag(2723, ts2.DiagnosticCategory.Error, "Cannot_invoke_an_object_which_is_possibly_null_or_undefined_2723", "Cannot invoke an object which is possibly 'null' or 'undefined'."),
        Module_0_has_no_exported_member_1_Did_you_mean_2: diag(2724, ts2.DiagnosticCategory.Error, "Module_0_has_no_exported_member_1_Did_you_mean_2_2724", "Module '{0}' has no exported member '{1}'. Did you mean '{2}'?"),
        Class_name_cannot_be_Object_when_targeting_ES5_with_module_0: diag(2725, ts2.DiagnosticCategory.Error, "Class_name_cannot_be_Object_when_targeting_ES5_with_module_0_2725", "Class name cannot be 'Object' when targeting ES5 with module {0}."),
        Cannot_find_lib_definition_for_0: diag(2726, ts2.DiagnosticCategory.Error, "Cannot_find_lib_definition_for_0_2726", "Cannot find lib definition for '{0}'."),
        Cannot_find_lib_definition_for_0_Did_you_mean_1: diag(2727, ts2.DiagnosticCategory.Error, "Cannot_find_lib_definition_for_0_Did_you_mean_1_2727", "Cannot find lib definition for '{0}'. Did you mean '{1}'?"),
        _0_is_declared_here: diag(2728, ts2.DiagnosticCategory.Message, "_0_is_declared_here_2728", "'{0}' is declared here."),
        Property_0_is_used_before_its_initialization: diag(2729, ts2.DiagnosticCategory.Error, "Property_0_is_used_before_its_initialization_2729", "Property '{0}' is used before its initialization."),
        An_arrow_function_cannot_have_a_this_parameter: diag(2730, ts2.DiagnosticCategory.Error, "An_arrow_function_cannot_have_a_this_parameter_2730", "An arrow function cannot have a 'this' parameter."),
        Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_in_String: diag(2731, ts2.DiagnosticCategory.Error, "Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_i_2731", "Implicit conversion of a 'symbol' to a 'string' will fail at runtime. Consider wrapping this expression in 'String(...)'."),
        Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension: diag(2732, ts2.DiagnosticCategory.Error, "Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension_2732", "Cannot find module '{0}'. Consider using '--resolveJsonModule' to import module with '.json' extension"),
        Property_0_was_also_declared_here: diag(2733, ts2.DiagnosticCategory.Error, "Property_0_was_also_declared_here_2733", "Property '{0}' was also declared here."),
        Are_you_missing_a_semicolon: diag(2734, ts2.DiagnosticCategory.Error, "Are_you_missing_a_semicolon_2734", "Are you missing a semicolon?"),
        Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1: diag(2735, ts2.DiagnosticCategory.Error, "Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1_2735", "Did you mean for '{0}' to be constrained to type 'new (...args: any[]) => {1}'?"),
        Operator_0_cannot_be_applied_to_type_1: diag(2736, ts2.DiagnosticCategory.Error, "Operator_0_cannot_be_applied_to_type_1_2736", "Operator '{0}' cannot be applied to type '{1}'."),
        BigInt_literals_are_not_available_when_targeting_lower_than_ES2020: diag(2737, ts2.DiagnosticCategory.Error, "BigInt_literals_are_not_available_when_targeting_lower_than_ES2020_2737", "BigInt literals are not available when targeting lower than ES2020."),
        An_outer_value_of_this_is_shadowed_by_this_container: diag(2738, ts2.DiagnosticCategory.Message, "An_outer_value_of_this_is_shadowed_by_this_container_2738", "An outer value of 'this' is shadowed by this container."),
        Type_0_is_missing_the_following_properties_from_type_1_Colon_2: diag(2739, ts2.DiagnosticCategory.Error, "Type_0_is_missing_the_following_properties_from_type_1_Colon_2_2739", "Type '{0}' is missing the following properties from type '{1}': {2}"),
        Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more: diag(2740, ts2.DiagnosticCategory.Error, "Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more_2740", "Type '{0}' is missing the following properties from type '{1}': {2}, and {3} more."),
        Property_0_is_missing_in_type_1_but_required_in_type_2: diag(2741, ts2.DiagnosticCategory.Error, "Property_0_is_missing_in_type_1_but_required_in_type_2_2741", "Property '{0}' is missing in type '{1}' but required in type '{2}'."),
        The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_annotation_is_necessary: diag(2742, ts2.DiagnosticCategory.Error, "The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_a_2742", "The inferred type of '{0}' cannot be named without a reference to '{1}'. This is likely not portable. A type annotation is necessary."),
        No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments: diag(2743, ts2.DiagnosticCategory.Error, "No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments_2743", "No overload expects {0} type arguments, but overloads do exist that expect either {1} or {2} type arguments."),
        Type_parameter_defaults_can_only_reference_previously_declared_type_parameters: diag(2744, ts2.DiagnosticCategory.Error, "Type_parameter_defaults_can_only_reference_previously_declared_type_parameters_2744", "Type parameter defaults can only reference previously declared type parameters."),
        This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_provided: diag(2745, ts2.DiagnosticCategory.Error, "This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_pr_2745", "This JSX tag's '{0}' prop expects type '{1}' which requires multiple children, but only a single child was provided."),
        This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided: diag(2746, ts2.DiagnosticCategory.Error, "This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided_2746", "This JSX tag's '{0}' prop expects a single child of type '{1}', but multiple children were provided."),
        _0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_type_of_1_is_2: diag(2747, ts2.DiagnosticCategory.Error, "_0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_t_2747", "'{0}' components don't accept text as child elements. Text in JSX has the type 'string', but the expected type of '{1}' is '{2}'."),
        Cannot_access_ambient_const_enums_when_the_isolatedModules_flag_is_provided: diag(2748, ts2.DiagnosticCategory.Error, "Cannot_access_ambient_const_enums_when_the_isolatedModules_flag_is_provided_2748", "Cannot access ambient const enums when the '--isolatedModules' flag is provided."),
        _0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0: diag(2749, ts2.DiagnosticCategory.Error, "_0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0_2749", "'{0}' refers to a value, but is being used as a type here. Did you mean 'typeof {0}'?"),
        The_implementation_signature_is_declared_here: diag(2750, ts2.DiagnosticCategory.Error, "The_implementation_signature_is_declared_here_2750", "The implementation signature is declared here."),
        Circularity_originates_in_type_at_this_location: diag(2751, ts2.DiagnosticCategory.Error, "Circularity_originates_in_type_at_this_location_2751", "Circularity originates in type at this location."),
        The_first_export_default_is_here: diag(2752, ts2.DiagnosticCategory.Error, "The_first_export_default_is_here_2752", "The first export default is here."),
        Another_export_default_is_here: diag(2753, ts2.DiagnosticCategory.Error, "Another_export_default_is_here_2753", "Another export default is here."),
        super_may_not_use_type_arguments: diag(2754, ts2.DiagnosticCategory.Error, "super_may_not_use_type_arguments_2754", "'super' may not use type arguments."),
        No_constituent_of_type_0_is_callable: diag(2755, ts2.DiagnosticCategory.Error, "No_constituent_of_type_0_is_callable_2755", "No constituent of type '{0}' is callable."),
        Not_all_constituents_of_type_0_are_callable: diag(2756, ts2.DiagnosticCategory.Error, "Not_all_constituents_of_type_0_are_callable_2756", "Not all constituents of type '{0}' are callable."),
        Type_0_has_no_call_signatures: diag(2757, ts2.DiagnosticCategory.Error, "Type_0_has_no_call_signatures_2757", "Type '{0}' has no call signatures."),
        Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_other: diag(2758, ts2.DiagnosticCategory.Error, "Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_2758", "Each member of the union type '{0}' has signatures, but none of those signatures are compatible with each other."),
        No_constituent_of_type_0_is_constructable: diag(2759, ts2.DiagnosticCategory.Error, "No_constituent_of_type_0_is_constructable_2759", "No constituent of type '{0}' is constructable."),
        Not_all_constituents_of_type_0_are_constructable: diag(2760, ts2.DiagnosticCategory.Error, "Not_all_constituents_of_type_0_are_constructable_2760", "Not all constituents of type '{0}' are constructable."),
        Type_0_has_no_construct_signatures: diag(2761, ts2.DiagnosticCategory.Error, "Type_0_has_no_construct_signatures_2761", "Type '{0}' has no construct signatures."),
        Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_with_each_other: diag(2762, ts2.DiagnosticCategory.Error, "Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_2762", "Each member of the union type '{0}' has construct signatures, but none of those signatures are compatible with each other."),
        Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_send_0: diag(2763, ts2.DiagnosticCategory.Error, "Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_s_2763", "Cannot iterate value because the 'next' method of its iterator expects type '{1}', but for-of will always send '{0}'."),
        Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_always_send_0: diag(2764, ts2.DiagnosticCategory.Error, "Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_al_2764", "Cannot iterate value because the 'next' method of its iterator expects type '{1}', but array spread will always send '{0}'."),
        Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring_will_always_send_0: diag(2765, ts2.DiagnosticCategory.Error, "Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring__2765", "Cannot iterate value because the 'next' method of its iterator expects type '{1}', but array destructuring will always send '{0}'."),
        Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_containing_generator_will_always_send_0: diag(2766, ts2.DiagnosticCategory.Error, "Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_co_2766", "Cannot delegate iteration to value because the 'next' method of its iterator expects type '{1}', but the containing generator will always send '{0}'."),
        The_0_property_of_an_iterator_must_be_a_method: diag(2767, ts2.DiagnosticCategory.Error, "The_0_property_of_an_iterator_must_be_a_method_2767", "The '{0}' property of an iterator must be a method."),
        The_0_property_of_an_async_iterator_must_be_a_method: diag(2768, ts2.DiagnosticCategory.Error, "The_0_property_of_an_async_iterator_must_be_a_method_2768", "The '{0}' property of an async iterator must be a method."),
        No_overload_matches_this_call: diag(2769, ts2.DiagnosticCategory.Error, "No_overload_matches_this_call_2769", "No overload matches this call."),
        The_last_overload_gave_the_following_error: diag(2770, ts2.DiagnosticCategory.Error, "The_last_overload_gave_the_following_error_2770", "The last overload gave the following error."),
        The_last_overload_is_declared_here: diag(2771, ts2.DiagnosticCategory.Error, "The_last_overload_is_declared_here_2771", "The last overload is declared here."),
        Overload_0_of_1_2_gave_the_following_error: diag(2772, ts2.DiagnosticCategory.Error, "Overload_0_of_1_2_gave_the_following_error_2772", "Overload {0} of {1}, '{2}', gave the following error."),
        Did_you_forget_to_use_await: diag(2773, ts2.DiagnosticCategory.Error, "Did_you_forget_to_use_await_2773", "Did you forget to use 'await'?"),
        This_condition_will_always_return_true_since_the_function_is_always_defined_Did_you_mean_to_call_it_instead: diag(2774, ts2.DiagnosticCategory.Error, "This_condition_will_always_return_true_since_the_function_is_always_defined_Did_you_mean_to_call_it__2774", "This condition will always return true since the function is always defined. Did you mean to call it instead?"),
        Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation: diag(2775, ts2.DiagnosticCategory.Error, "Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation_2775", "Assertions require every name in the call target to be declared with an explicit type annotation."),
        Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name: diag(2776, ts2.DiagnosticCategory.Error, "Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name_2776", "Assertions require the call target to be an identifier or qualified name."),
        The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access: diag(2777, ts2.DiagnosticCategory.Error, "The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access_2777", "The operand of an increment or decrement operator may not be an optional property access."),
        The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access: diag(2778, ts2.DiagnosticCategory.Error, "The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access_2778", "The target of an object rest assignment may not be an optional property access."),
        The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access: diag(2779, ts2.DiagnosticCategory.Error, "The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access_2779", "The left-hand side of an assignment expression may not be an optional property access."),
        The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access: diag(2780, ts2.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access_2780", "The left-hand side of a 'for...in' statement may not be an optional property access."),
        The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access: diag(2781, ts2.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access_2781", "The left-hand side of a 'for...of' statement may not be an optional property access."),
        _0_needs_an_explicit_type_annotation: diag(2782, ts2.DiagnosticCategory.Message, "_0_needs_an_explicit_type_annotation_2782", "'{0}' needs an explicit type annotation."),
        _0_is_specified_more_than_once_so_this_usage_will_be_overwritten: diag(2783, ts2.DiagnosticCategory.Error, "_0_is_specified_more_than_once_so_this_usage_will_be_overwritten_2783", "'{0}' is specified more than once, so this usage will be overwritten."),
        get_and_set_accessors_cannot_declare_this_parameters: diag(2784, ts2.DiagnosticCategory.Error, "get_and_set_accessors_cannot_declare_this_parameters_2784", "'get' and 'set' accessors cannot declare 'this' parameters."),
        This_spread_always_overwrites_this_property: diag(2785, ts2.DiagnosticCategory.Error, "This_spread_always_overwrites_this_property_2785", "This spread always overwrites this property."),
        _0_cannot_be_used_as_a_JSX_component: diag(2786, ts2.DiagnosticCategory.Error, "_0_cannot_be_used_as_a_JSX_component_2786", "'{0}' cannot be used as a JSX component."),
        Its_return_type_0_is_not_a_valid_JSX_element: diag(2787, ts2.DiagnosticCategory.Error, "Its_return_type_0_is_not_a_valid_JSX_element_2787", "Its return type '{0}' is not a valid JSX element."),
        Its_instance_type_0_is_not_a_valid_JSX_element: diag(2788, ts2.DiagnosticCategory.Error, "Its_instance_type_0_is_not_a_valid_JSX_element_2788", "Its instance type '{0}' is not a valid JSX element."),
        Its_element_type_0_is_not_a_valid_JSX_element: diag(2789, ts2.DiagnosticCategory.Error, "Its_element_type_0_is_not_a_valid_JSX_element_2789", "Its element type '{0}' is not a valid JSX element."),
        Import_declaration_0_is_using_private_name_1: diag(4e3, ts2.DiagnosticCategory.Error, "Import_declaration_0_is_using_private_name_1_4000", "Import declaration '{0}' is using private name '{1}'."),
        Type_parameter_0_of_exported_class_has_or_is_using_private_name_1: diag(4002, ts2.DiagnosticCategory.Error, "Type_parameter_0_of_exported_class_has_or_is_using_private_name_1_4002", "Type parameter '{0}' of exported class has or is using private name '{1}'."),
        Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1: diag(4004, ts2.DiagnosticCategory.Error, "Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1_4004", "Type parameter '{0}' of exported interface has or is using private name '{1}'."),
        Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1: diag(4006, ts2.DiagnosticCategory.Error, "Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4006", "Type parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."),
        Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1: diag(4008, ts2.DiagnosticCategory.Error, "Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4008", "Type parameter '{0}' of call signature from exported interface has or is using private name '{1}'."),
        Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1: diag(4010, ts2.DiagnosticCategory.Error, "Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4010", "Type parameter '{0}' of public static method from exported class has or is using private name '{1}'."),
        Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1: diag(4012, ts2.DiagnosticCategory.Error, "Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4012", "Type parameter '{0}' of public method from exported class has or is using private name '{1}'."),
        Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1: diag(4014, ts2.DiagnosticCategory.Error, "Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4014", "Type parameter '{0}' of method from exported interface has or is using private name '{1}'."),
        Type_parameter_0_of_exported_function_has_or_is_using_private_name_1: diag(4016, ts2.DiagnosticCategory.Error, "Type_parameter_0_of_exported_function_has_or_is_using_private_name_1_4016", "Type parameter '{0}' of exported function has or is using private name '{1}'."),
        Implements_clause_of_exported_class_0_has_or_is_using_private_name_1: diag(4019, ts2.DiagnosticCategory.Error, "Implements_clause_of_exported_class_0_has_or_is_using_private_name_1_4019", "Implements clause of exported class '{0}' has or is using private name '{1}'."),
        extends_clause_of_exported_class_0_has_or_is_using_private_name_1: diag(4020, ts2.DiagnosticCategory.Error, "extends_clause_of_exported_class_0_has_or_is_using_private_name_1_4020", "'extends' clause of exported class '{0}' has or is using private name '{1}'."),
        extends_clause_of_exported_interface_0_has_or_is_using_private_name_1: diag(4022, ts2.DiagnosticCategory.Error, "extends_clause_of_exported_interface_0_has_or_is_using_private_name_1_4022", "'extends' clause of exported interface '{0}' has or is using private name '{1}'."),
        Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4023, ts2.DiagnosticCategory.Error, "Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4023", "Exported variable '{0}' has or is using name '{1}' from external module {2} but cannot be named."),
        Exported_variable_0_has_or_is_using_name_1_from_private_module_2: diag(4024, ts2.DiagnosticCategory.Error, "Exported_variable_0_has_or_is_using_name_1_from_private_module_2_4024", "Exported variable '{0}' has or is using name '{1}' from private module '{2}'."),
        Exported_variable_0_has_or_is_using_private_name_1: diag(4025, ts2.DiagnosticCategory.Error, "Exported_variable_0_has_or_is_using_private_name_1_4025", "Exported variable '{0}' has or is using private name '{1}'."),
        Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4026, ts2.DiagnosticCategory.Error, "Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot__4026", "Public static property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4027, ts2.DiagnosticCategory.Error, "Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4027", "Public static property '{0}' of exported class has or is using name '{1}' from private module '{2}'."),
        Public_static_property_0_of_exported_class_has_or_is_using_private_name_1: diag(4028, ts2.DiagnosticCategory.Error, "Public_static_property_0_of_exported_class_has_or_is_using_private_name_1_4028", "Public static property '{0}' of exported class has or is using private name '{1}'."),
        Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4029, ts2.DiagnosticCategory.Error, "Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_name_4029", "Public property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4030, ts2.DiagnosticCategory.Error, "Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4030", "Public property '{0}' of exported class has or is using name '{1}' from private module '{2}'."),
        Public_property_0_of_exported_class_has_or_is_using_private_name_1: diag(4031, ts2.DiagnosticCategory.Error, "Public_property_0_of_exported_class_has_or_is_using_private_name_1_4031", "Public property '{0}' of exported class has or is using private name '{1}'."),
        Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4032, ts2.DiagnosticCategory.Error, "Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2_4032", "Property '{0}' of exported interface has or is using name '{1}' from private module '{2}'."),
        Property_0_of_exported_interface_has_or_is_using_private_name_1: diag(4033, ts2.DiagnosticCategory.Error, "Property_0_of_exported_interface_has_or_is_using_private_name_1_4033", "Property '{0}' of exported interface has or is using private name '{1}'."),
        Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4034, ts2.DiagnosticCategory.Error, "Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_mod_4034", "Parameter type of public static setter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),
        Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1: diag(4035, ts2.DiagnosticCategory.Error, "Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1_4035", "Parameter type of public static setter '{0}' from exported class has or is using private name '{1}'."),
        Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4036, ts2.DiagnosticCategory.Error, "Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2_4036", "Parameter type of public setter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),
        Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1: diag(4037, ts2.DiagnosticCategory.Error, "Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1_4037", "Parameter type of public setter '{0}' from exported class has or is using private name '{1}'."),
        Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4038, ts2.DiagnosticCategory.Error, "Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_modul_4038", "Return type of public static getter '{0}' from exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4039, ts2.DiagnosticCategory.Error, "Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_4039", "Return type of public static getter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),
        Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1: diag(4040, ts2.DiagnosticCategory.Error, "Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1_4040", "Return type of public static getter '{0}' from exported class has or is using private name '{1}'."),
        Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4041, ts2.DiagnosticCategory.Error, "Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_4041", "Return type of public getter '{0}' from exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4042, ts2.DiagnosticCategory.Error, "Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2_4042", "Return type of public getter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),
        Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1: diag(4043, ts2.DiagnosticCategory.Error, "Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1_4043", "Return type of public getter '{0}' from exported class has or is using private name '{1}'."),
        Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1: diag(4044, ts2.DiagnosticCategory.Error, "Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_mod_4044", "Return type of constructor signature from exported interface has or is using name '{0}' from private module '{1}'."),
        Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0: diag(4045, ts2.DiagnosticCategory.Error, "Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0_4045", "Return type of constructor signature from exported interface has or is using private name '{0}'."),
        Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1: diag(4046, ts2.DiagnosticCategory.Error, "Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4046", "Return type of call signature from exported interface has or is using name '{0}' from private module '{1}'."),
        Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0: diag(4047, ts2.DiagnosticCategory.Error, "Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0_4047", "Return type of call signature from exported interface has or is using private name '{0}'."),
        Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1: diag(4048, ts2.DiagnosticCategory.Error, "Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4048", "Return type of index signature from exported interface has or is using name '{0}' from private module '{1}'."),
        Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0: diag(4049, ts2.DiagnosticCategory.Error, "Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0_4049", "Return type of index signature from exported interface has or is using private name '{0}'."),
        Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named: diag(4050, ts2.DiagnosticCategory.Error, "Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module__4050", "Return type of public static method from exported class has or is using name '{0}' from external module {1} but cannot be named."),
        Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1: diag(4051, ts2.DiagnosticCategory.Error, "Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4051", "Return type of public static method from exported class has or is using name '{0}' from private module '{1}'."),
        Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0: diag(4052, ts2.DiagnosticCategory.Error, "Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0_4052", "Return type of public static method from exported class has or is using private name '{0}'."),
        Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named: diag(4053, ts2.DiagnosticCategory.Error, "Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_c_4053", "Return type of public method from exported class has or is using name '{0}' from external module {1} but cannot be named."),
        Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1: diag(4054, ts2.DiagnosticCategory.Error, "Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4054", "Return type of public method from exported class has or is using name '{0}' from private module '{1}'."),
        Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0: diag(4055, ts2.DiagnosticCategory.Error, "Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0_4055", "Return type of public method from exported class has or is using private name '{0}'."),
        Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1: diag(4056, ts2.DiagnosticCategory.Error, "Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4056", "Return type of method from exported interface has or is using name '{0}' from private module '{1}'."),
        Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0: diag(4057, ts2.DiagnosticCategory.Error, "Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0_4057", "Return type of method from exported interface has or is using private name '{0}'."),
        Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named: diag(4058, ts2.DiagnosticCategory.Error, "Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named_4058", "Return type of exported function has or is using name '{0}' from external module {1} but cannot be named."),
        Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1: diag(4059, ts2.DiagnosticCategory.Error, "Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1_4059", "Return type of exported function has or is using name '{0}' from private module '{1}'."),
        Return_type_of_exported_function_has_or_is_using_private_name_0: diag(4060, ts2.DiagnosticCategory.Error, "Return_type_of_exported_function_has_or_is_using_private_name_0_4060", "Return type of exported function has or is using private name '{0}'."),
        Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4061, ts2.DiagnosticCategory.Error, "Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_can_4061", "Parameter '{0}' of constructor from exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4062, ts2.DiagnosticCategory.Error, "Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2_4062", "Parameter '{0}' of constructor from exported class has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1: diag(4063, ts2.DiagnosticCategory.Error, "Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1_4063", "Parameter '{0}' of constructor from exported class has or is using private name '{1}'."),
        Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4064, ts2.DiagnosticCategory.Error, "Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_mod_4064", "Parameter '{0}' of constructor signature from exported interface has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1: diag(4065, ts2.DiagnosticCategory.Error, "Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4065", "Parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."),
        Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4066, ts2.DiagnosticCategory.Error, "Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4066", "Parameter '{0}' of call signature from exported interface has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1: diag(4067, ts2.DiagnosticCategory.Error, "Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4067", "Parameter '{0}' of call signature from exported interface has or is using private name '{1}'."),
        Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4068, ts2.DiagnosticCategory.Error, "Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module__4068", "Parameter '{0}' of public static method from exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4069, ts2.DiagnosticCategory.Error, "Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4069", "Parameter '{0}' of public static method from exported class has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1: diag(4070, ts2.DiagnosticCategory.Error, "Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4070", "Parameter '{0}' of public static method from exported class has or is using private name '{1}'."),
        Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4071, ts2.DiagnosticCategory.Error, "Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_c_4071", "Parameter '{0}' of public method from exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4072, ts2.DiagnosticCategory.Error, "Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4072", "Parameter '{0}' of public method from exported class has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1: diag(4073, ts2.DiagnosticCategory.Error, "Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4073", "Parameter '{0}' of public method from exported class has or is using private name '{1}'."),
        Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4074, ts2.DiagnosticCategory.Error, "Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4074", "Parameter '{0}' of method from exported interface has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1: diag(4075, ts2.DiagnosticCategory.Error, "Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4075", "Parameter '{0}' of method from exported interface has or is using private name '{1}'."),
        Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4076, ts2.DiagnosticCategory.Error, "Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4076", "Parameter '{0}' of exported function has or is using name '{1}' from external module {2} but cannot be named."),
        Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2: diag(4077, ts2.DiagnosticCategory.Error, "Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2_4077", "Parameter '{0}' of exported function has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_exported_function_has_or_is_using_private_name_1: diag(4078, ts2.DiagnosticCategory.Error, "Parameter_0_of_exported_function_has_or_is_using_private_name_1_4078", "Parameter '{0}' of exported function has or is using private name '{1}'."),
        Exported_type_alias_0_has_or_is_using_private_name_1: diag(4081, ts2.DiagnosticCategory.Error, "Exported_type_alias_0_has_or_is_using_private_name_1_4081", "Exported type alias '{0}' has or is using private name '{1}'."),
        Default_export_of_the_module_has_or_is_using_private_name_0: diag(4082, ts2.DiagnosticCategory.Error, "Default_export_of_the_module_has_or_is_using_private_name_0_4082", "Default export of the module has or is using private name '{0}'."),
        Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1: diag(4083, ts2.DiagnosticCategory.Error, "Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1_4083", "Type parameter '{0}' of exported type alias has or is using private name '{1}'."),
        Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_library_to_resolve_the_conflict: diag(4090, ts2.DiagnosticCategory.Error, "Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_librar_4090", "Conflicting definitions for '{0}' found at '{1}' and '{2}'. Consider installing a specific version of this library to resolve the conflict."),
        Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4091, ts2.DiagnosticCategory.Error, "Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4091", "Parameter '{0}' of index signature from exported interface has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1: diag(4092, ts2.DiagnosticCategory.Error, "Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1_4092", "Parameter '{0}' of index signature from exported interface has or is using private name '{1}'."),
        Property_0_of_exported_class_expression_may_not_be_private_or_protected: diag(4094, ts2.DiagnosticCategory.Error, "Property_0_of_exported_class_expression_may_not_be_private_or_protected_4094", "Property '{0}' of exported class expression may not be private or protected."),
        Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4095, ts2.DiagnosticCategory.Error, "Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_4095", "Public static method '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4096, ts2.DiagnosticCategory.Error, "Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4096", "Public static method '{0}' of exported class has or is using name '{1}' from private module '{2}'."),
        Public_static_method_0_of_exported_class_has_or_is_using_private_name_1: diag(4097, ts2.DiagnosticCategory.Error, "Public_static_method_0_of_exported_class_has_or_is_using_private_name_1_4097", "Public static method '{0}' of exported class has or is using private name '{1}'."),
        Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4098, ts2.DiagnosticCategory.Error, "Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4098", "Public method '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),
        Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4099, ts2.DiagnosticCategory.Error, "Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4099", "Public method '{0}' of exported class has or is using name '{1}' from private module '{2}'."),
        Public_method_0_of_exported_class_has_or_is_using_private_name_1: diag(4100, ts2.DiagnosticCategory.Error, "Public_method_0_of_exported_class_has_or_is_using_private_name_1_4100", "Public method '{0}' of exported class has or is using private name '{1}'."),
        Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4101, ts2.DiagnosticCategory.Error, "Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2_4101", "Method '{0}' of exported interface has or is using name '{1}' from private module '{2}'."),
        Method_0_of_exported_interface_has_or_is_using_private_name_1: diag(4102, ts2.DiagnosticCategory.Error, "Method_0_of_exported_interface_has_or_is_using_private_name_1_4102", "Method '{0}' of exported interface has or is using private name '{1}'."),
        Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1: diag(4103, ts2.DiagnosticCategory.Error, "Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1_4103", "Type parameter '{0}' of exported mapped object type is using private name '{1}'."),
        The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1: diag(4104, ts2.DiagnosticCategory.Error, "The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1_4104", "The type '{0}' is 'readonly' and cannot be assigned to the mutable type '{1}'."),
        Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter: diag(4105, ts2.DiagnosticCategory.Error, "Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter_4105", "Private or protected member '{0}' cannot be accessed on a type parameter."),
        Parameter_0_of_accessor_has_or_is_using_private_name_1: diag(4106, ts2.DiagnosticCategory.Error, "Parameter_0_of_accessor_has_or_is_using_private_name_1_4106", "Parameter '{0}' of accessor has or is using private name '{1}'."),
        Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2: diag(4107, ts2.DiagnosticCategory.Error, "Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2_4107", "Parameter '{0}' of accessor has or is using name '{1}' from private module '{2}'."),
        Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4108, ts2.DiagnosticCategory.Error, "Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4108", "Parameter '{0}' of accessor has or is using name '{1}' from external module '{2}' but cannot be named."),
        Type_arguments_for_0_circularly_reference_themselves: diag(4109, ts2.DiagnosticCategory.Error, "Type_arguments_for_0_circularly_reference_themselves_4109", "Type arguments for '{0}' circularly reference themselves."),
        Tuple_type_arguments_circularly_reference_themselves: diag(4110, ts2.DiagnosticCategory.Error, "Tuple_type_arguments_circularly_reference_themselves_4110", "Tuple type arguments circularly reference themselves."),
        The_current_host_does_not_support_the_0_option: diag(5001, ts2.DiagnosticCategory.Error, "The_current_host_does_not_support_the_0_option_5001", "The current host does not support the '{0}' option."),
        Cannot_find_the_common_subdirectory_path_for_the_input_files: diag(5009, ts2.DiagnosticCategory.Error, "Cannot_find_the_common_subdirectory_path_for_the_input_files_5009", "Cannot find the common subdirectory path for the input files."),
        File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0: diag(5010, ts2.DiagnosticCategory.Error, "File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0_5010", "File specification cannot end in a recursive directory wildcard ('**'): '{0}'."),
        Cannot_read_file_0_Colon_1: diag(5012, ts2.DiagnosticCategory.Error, "Cannot_read_file_0_Colon_1_5012", "Cannot read file '{0}': {1}."),
        Failed_to_parse_file_0_Colon_1: diag(5014, ts2.DiagnosticCategory.Error, "Failed_to_parse_file_0_Colon_1_5014", "Failed to parse file '{0}': {1}."),
        Unknown_compiler_option_0: diag(5023, ts2.DiagnosticCategory.Error, "Unknown_compiler_option_0_5023", "Unknown compiler option '{0}'."),
        Compiler_option_0_requires_a_value_of_type_1: diag(5024, ts2.DiagnosticCategory.Error, "Compiler_option_0_requires_a_value_of_type_1_5024", "Compiler option '{0}' requires a value of type {1}."),
        Unknown_compiler_option_0_Did_you_mean_1: diag(5025, ts2.DiagnosticCategory.Error, "Unknown_compiler_option_0_Did_you_mean_1_5025", "Unknown compiler option '{0}'. Did you mean '{1}'?"),
        Could_not_write_file_0_Colon_1: diag(5033, ts2.DiagnosticCategory.Error, "Could_not_write_file_0_Colon_1_5033", "Could not write file '{0}': {1}."),
        Option_project_cannot_be_mixed_with_source_files_on_a_command_line: diag(5042, ts2.DiagnosticCategory.Error, "Option_project_cannot_be_mixed_with_source_files_on_a_command_line_5042", "Option 'project' cannot be mixed with source files on a command line."),
        Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher: diag(5047, ts2.DiagnosticCategory.Error, "Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES_5047", "Option 'isolatedModules' can only be used when either option '--module' is provided or option 'target' is 'ES2015' or higher."),
        Option_0_cannot_be_specified_when_option_target_is_ES3: diag(5048, ts2.DiagnosticCategory.Error, "Option_0_cannot_be_specified_when_option_target_is_ES3_5048", "Option '{0}' cannot be specified when option 'target' is 'ES3'."),
        Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided: diag(5051, ts2.DiagnosticCategory.Error, "Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided_5051", "Option '{0} can only be used when either option '--inlineSourceMap' or option '--sourceMap' is provided."),
        Option_0_cannot_be_specified_without_specifying_option_1: diag(5052, ts2.DiagnosticCategory.Error, "Option_0_cannot_be_specified_without_specifying_option_1_5052", "Option '{0}' cannot be specified without specifying option '{1}'."),
        Option_0_cannot_be_specified_with_option_1: diag(5053, ts2.DiagnosticCategory.Error, "Option_0_cannot_be_specified_with_option_1_5053", "Option '{0}' cannot be specified with option '{1}'."),
        A_tsconfig_json_file_is_already_defined_at_Colon_0: diag(5054, ts2.DiagnosticCategory.Error, "A_tsconfig_json_file_is_already_defined_at_Colon_0_5054", "A 'tsconfig.json' file is already defined at: '{0}'."),
        Cannot_write_file_0_because_it_would_overwrite_input_file: diag(5055, ts2.DiagnosticCategory.Error, "Cannot_write_file_0_because_it_would_overwrite_input_file_5055", "Cannot write file '{0}' because it would overwrite input file."),
        Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files: diag(5056, ts2.DiagnosticCategory.Error, "Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files_5056", "Cannot write file '{0}' because it would be overwritten by multiple input files."),
        Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0: diag(5057, ts2.DiagnosticCategory.Error, "Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0_5057", "Cannot find a tsconfig.json file at the specified directory: '{0}'."),
        The_specified_path_does_not_exist_Colon_0: diag(5058, ts2.DiagnosticCategory.Error, "The_specified_path_does_not_exist_Colon_0_5058", "The specified path does not exist: '{0}'."),
        Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier: diag(5059, ts2.DiagnosticCategory.Error, "Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier_5059", "Invalid value for '--reactNamespace'. '{0}' is not a valid identifier."),
        Option_paths_cannot_be_used_without_specifying_baseUrl_option: diag(5060, ts2.DiagnosticCategory.Error, "Option_paths_cannot_be_used_without_specifying_baseUrl_option_5060", "Option 'paths' cannot be used without specifying '--baseUrl' option."),
        Pattern_0_can_have_at_most_one_Asterisk_character: diag(5061, ts2.DiagnosticCategory.Error, "Pattern_0_can_have_at_most_one_Asterisk_character_5061", "Pattern '{0}' can have at most one '*' character."),
        Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character: diag(5062, ts2.DiagnosticCategory.Error, "Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character_5062", "Substitution '{0}' in pattern '{1}' can have at most one '*' character."),
        Substitutions_for_pattern_0_should_be_an_array: diag(5063, ts2.DiagnosticCategory.Error, "Substitutions_for_pattern_0_should_be_an_array_5063", "Substitutions for pattern '{0}' should be an array."),
        Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2: diag(5064, ts2.DiagnosticCategory.Error, "Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2_5064", "Substitution '{0}' for pattern '{1}' has incorrect type, expected 'string', got '{2}'."),
        File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0: diag(5065, ts2.DiagnosticCategory.Error, "File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildca_5065", "File specification cannot contain a parent directory ('..') that appears after a recursive directory wildcard ('**'): '{0}'."),
        Substitutions_for_pattern_0_shouldn_t_be_an_empty_array: diag(5066, ts2.DiagnosticCategory.Error, "Substitutions_for_pattern_0_shouldn_t_be_an_empty_array_5066", "Substitutions for pattern '{0}' shouldn't be an empty array."),
        Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name: diag(5067, ts2.DiagnosticCategory.Error, "Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name_5067", "Invalid value for 'jsxFactory'. '{0}' is not a valid identifier or qualified-name."),
        Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript_files_Learn_more_at_https_Colon_Slash_Slashaka_ms_Slashtsconfig: diag(5068, ts2.DiagnosticCategory.Error, "Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript__5068", "Adding a tsconfig.json file will help organize projects that contain both TypeScript and JavaScript files. Learn more at https://aka.ms/tsconfig."),
        Option_0_cannot_be_specified_without_specifying_option_1_or_option_2: diag(5069, ts2.DiagnosticCategory.Error, "Option_0_cannot_be_specified_without_specifying_option_1_or_option_2_5069", "Option '{0}' cannot be specified without specifying option '{1}' or option '{2}'."),
        Option_resolveJsonModule_cannot_be_specified_without_node_module_resolution_strategy: diag(5070, ts2.DiagnosticCategory.Error, "Option_resolveJsonModule_cannot_be_specified_without_node_module_resolution_strategy_5070", "Option '--resolveJsonModule' cannot be specified without 'node' module resolution strategy."),
        Option_resolveJsonModule_can_only_be_specified_when_module_code_generation_is_commonjs_amd_es2015_or_esNext: diag(5071, ts2.DiagnosticCategory.Error, "Option_resolveJsonModule_can_only_be_specified_when_module_code_generation_is_commonjs_amd_es2015_or_5071", "Option '--resolveJsonModule' can only be specified when module code generation is 'commonjs', 'amd', 'es2015' or 'esNext'."),
        Unknown_build_option_0: diag(5072, ts2.DiagnosticCategory.Error, "Unknown_build_option_0_5072", "Unknown build option '{0}'."),
        Build_option_0_requires_a_value_of_type_1: diag(5073, ts2.DiagnosticCategory.Error, "Build_option_0_requires_a_value_of_type_1_5073", "Build option '{0}' requires a value of type {1}."),
        Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBuildInfoFile_is_specified: diag(5074, ts2.DiagnosticCategory.Error, "Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBui_5074", "Option '--incremental' can only be specified using tsconfig, emitting to single file or when option `--tsBuildInfoFile` is specified."),
        _0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_constraint_2: diag(5075, ts2.DiagnosticCategory.Error, "_0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_5075", "'{0}' is assignable to the constraint of type '{1}', but '{1}' could be instantiated with a different subtype of constraint '{2}'."),
        _0_and_1_operations_cannot_be_mixed_without_parentheses: diag(5076, ts2.DiagnosticCategory.Error, "_0_and_1_operations_cannot_be_mixed_without_parentheses_5076", "'{0}' and '{1}' operations cannot be mixed without parentheses."),
        Unknown_build_option_0_Did_you_mean_1: diag(5077, ts2.DiagnosticCategory.Error, "Unknown_build_option_0_Did_you_mean_1_5077", "Unknown build option '{0}'. Did you mean '{1}'?"),
        Unknown_watch_option_0: diag(5078, ts2.DiagnosticCategory.Error, "Unknown_watch_option_0_5078", "Unknown watch option '{0}'."),
        Unknown_watch_option_0_Did_you_mean_1: diag(5079, ts2.DiagnosticCategory.Error, "Unknown_watch_option_0_Did_you_mean_1_5079", "Unknown watch option '{0}'. Did you mean '{1}'?"),
        Watch_option_0_requires_a_value_of_type_1: diag(5080, ts2.DiagnosticCategory.Error, "Watch_option_0_requires_a_value_of_type_1_5080", "Watch option '{0}' requires a value of type {1}."),
        Cannot_find_a_tsconfig_json_file_at_the_current_directory_Colon_0: diag(5081, ts2.DiagnosticCategory.Error, "Cannot_find_a_tsconfig_json_file_at_the_current_directory_Colon_0_5081", "Cannot find a tsconfig.json file at the current directory: {0}."),
        _0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1: diag(5082, ts2.DiagnosticCategory.Error, "_0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1_5082", "'{0}' could be instantiated with an arbitrary type which could be unrelated to '{1}'."),
        Cannot_read_file_0: diag(5083, ts2.DiagnosticCategory.Error, "Cannot_read_file_0_5083", "Cannot read file '{0}'."),
        The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialized_A_type_annotation_is_necessary: diag(5088, ts2.DiagnosticCategory.Error, "The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialize_5088", "The inferred type of '{0}' references a type with a cyclic structure which cannot be trivially serialized. A type annotation is necessary."),
        Generates_a_sourcemap_for_each_corresponding_d_ts_file: diag(6e3, ts2.DiagnosticCategory.Message, "Generates_a_sourcemap_for_each_corresponding_d_ts_file_6000", "Generates a sourcemap for each corresponding '.d.ts' file."),
        Concatenate_and_emit_output_to_single_file: diag(6001, ts2.DiagnosticCategory.Message, "Concatenate_and_emit_output_to_single_file_6001", "Concatenate and emit output to single file."),
        Generates_corresponding_d_ts_file: diag(6002, ts2.DiagnosticCategory.Message, "Generates_corresponding_d_ts_file_6002", "Generates corresponding '.d.ts' file."),
        Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations: diag(6003, ts2.DiagnosticCategory.Message, "Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations_6003", "Specify the location where debugger should locate map files instead of generated locations."),
        Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations: diag(6004, ts2.DiagnosticCategory.Message, "Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations_6004", "Specify the location where debugger should locate TypeScript files instead of source locations."),
        Watch_input_files: diag(6005, ts2.DiagnosticCategory.Message, "Watch_input_files_6005", "Watch input files."),
        Redirect_output_structure_to_the_directory: diag(6006, ts2.DiagnosticCategory.Message, "Redirect_output_structure_to_the_directory_6006", "Redirect output structure to the directory."),
        Do_not_erase_const_enum_declarations_in_generated_code: diag(6007, ts2.DiagnosticCategory.Message, "Do_not_erase_const_enum_declarations_in_generated_code_6007", "Do not erase const enum declarations in generated code."),
        Do_not_emit_outputs_if_any_errors_were_reported: diag(6008, ts2.DiagnosticCategory.Message, "Do_not_emit_outputs_if_any_errors_were_reported_6008", "Do not emit outputs if any errors were reported."),
        Do_not_emit_comments_to_output: diag(6009, ts2.DiagnosticCategory.Message, "Do_not_emit_comments_to_output_6009", "Do not emit comments to output."),
        Do_not_emit_outputs: diag(6010, ts2.DiagnosticCategory.Message, "Do_not_emit_outputs_6010", "Do not emit outputs."),
        Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typechecking: diag(6011, ts2.DiagnosticCategory.Message, "Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typech_6011", "Allow default imports from modules with no default export. This does not affect code emit, just typechecking."),
        Skip_type_checking_of_declaration_files: diag(6012, ts2.DiagnosticCategory.Message, "Skip_type_checking_of_declaration_files_6012", "Skip type checking of declaration files."),
        Do_not_resolve_the_real_path_of_symlinks: diag(6013, ts2.DiagnosticCategory.Message, "Do_not_resolve_the_real_path_of_symlinks_6013", "Do not resolve the real path of symlinks."),
        Only_emit_d_ts_declaration_files: diag(6014, ts2.DiagnosticCategory.Message, "Only_emit_d_ts_declaration_files_6014", "Only emit '.d.ts' declaration files."),
        Specify_ECMAScript_target_version_Colon_ES3_default_ES5_ES2015_ES2016_ES2017_ES2018_ES2019_ES2020_or_ESNEXT: diag(6015, ts2.DiagnosticCategory.Message, "Specify_ECMAScript_target_version_Colon_ES3_default_ES5_ES2015_ES2016_ES2017_ES2018_ES2019_ES2020_or_6015", "Specify ECMAScript target version: 'ES3' (default), 'ES5', 'ES2015', 'ES2016', 'ES2017', 'ES2018', 'ES2019', 'ES2020', or 'ESNEXT'."),
        Specify_module_code_generation_Colon_none_commonjs_amd_system_umd_es2015_es2020_or_ESNext: diag(6016, ts2.DiagnosticCategory.Message, "Specify_module_code_generation_Colon_none_commonjs_amd_system_umd_es2015_es2020_or_ESNext_6016", "Specify module code generation: 'none', 'commonjs', 'amd', 'system', 'umd', 'es2015', 'es2020', or 'ESNext'."),
        Print_this_message: diag(6017, ts2.DiagnosticCategory.Message, "Print_this_message_6017", "Print this message."),
        Print_the_compiler_s_version: diag(6019, ts2.DiagnosticCategory.Message, "Print_the_compiler_s_version_6019", "Print the compiler's version."),
        Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json: diag(6020, ts2.DiagnosticCategory.Message, "Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json_6020", "Compile the project given the path to its configuration file, or to a folder with a 'tsconfig.json'."),
        Syntax_Colon_0: diag(6023, ts2.DiagnosticCategory.Message, "Syntax_Colon_0_6023", "Syntax: {0}"),
        options: diag(6024, ts2.DiagnosticCategory.Message, "options_6024", "options"),
        file: diag(6025, ts2.DiagnosticCategory.Message, "file_6025", "file"),
        Examples_Colon_0: diag(6026, ts2.DiagnosticCategory.Message, "Examples_Colon_0_6026", "Examples: {0}"),
        Options_Colon: diag(6027, ts2.DiagnosticCategory.Message, "Options_Colon_6027", "Options:"),
        Version_0: diag(6029, ts2.DiagnosticCategory.Message, "Version_0_6029", "Version {0}"),
        Insert_command_line_options_and_files_from_a_file: diag(6030, ts2.DiagnosticCategory.Message, "Insert_command_line_options_and_files_from_a_file_6030", "Insert command line options and files from a file."),
        Starting_compilation_in_watch_mode: diag(6031, ts2.DiagnosticCategory.Message, "Starting_compilation_in_watch_mode_6031", "Starting compilation in watch mode..."),
        File_change_detected_Starting_incremental_compilation: diag(6032, ts2.DiagnosticCategory.Message, "File_change_detected_Starting_incremental_compilation_6032", "File change detected. Starting incremental compilation..."),
        KIND: diag(6034, ts2.DiagnosticCategory.Message, "KIND_6034", "KIND"),
        FILE: diag(6035, ts2.DiagnosticCategory.Message, "FILE_6035", "FILE"),
        VERSION: diag(6036, ts2.DiagnosticCategory.Message, "VERSION_6036", "VERSION"),
        LOCATION: diag(6037, ts2.DiagnosticCategory.Message, "LOCATION_6037", "LOCATION"),
        DIRECTORY: diag(6038, ts2.DiagnosticCategory.Message, "DIRECTORY_6038", "DIRECTORY"),
        STRATEGY: diag(6039, ts2.DiagnosticCategory.Message, "STRATEGY_6039", "STRATEGY"),
        FILE_OR_DIRECTORY: diag(6040, ts2.DiagnosticCategory.Message, "FILE_OR_DIRECTORY_6040", "FILE OR DIRECTORY"),
        Generates_corresponding_map_file: diag(6043, ts2.DiagnosticCategory.Message, "Generates_corresponding_map_file_6043", "Generates corresponding '.map' file."),
        Compiler_option_0_expects_an_argument: diag(6044, ts2.DiagnosticCategory.Error, "Compiler_option_0_expects_an_argument_6044", "Compiler option '{0}' expects an argument."),
        Unterminated_quoted_string_in_response_file_0: diag(6045, ts2.DiagnosticCategory.Error, "Unterminated_quoted_string_in_response_file_0_6045", "Unterminated quoted string in response file '{0}'."),
        Argument_for_0_option_must_be_Colon_1: diag(6046, ts2.DiagnosticCategory.Error, "Argument_for_0_option_must_be_Colon_1_6046", "Argument for '{0}' option must be: {1}."),
        Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1: diag(6048, ts2.DiagnosticCategory.Error, "Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1_6048", "Locale must be of the form <language> or <language>-<territory>. For example '{0}' or '{1}'."),
        Unsupported_locale_0: diag(6049, ts2.DiagnosticCategory.Error, "Unsupported_locale_0_6049", "Unsupported locale '{0}'."),
        Unable_to_open_file_0: diag(6050, ts2.DiagnosticCategory.Error, "Unable_to_open_file_0_6050", "Unable to open file '{0}'."),
        Corrupted_locale_file_0: diag(6051, ts2.DiagnosticCategory.Error, "Corrupted_locale_file_0_6051", "Corrupted locale file {0}."),
        Raise_error_on_expressions_and_declarations_with_an_implied_any_type: diag(6052, ts2.DiagnosticCategory.Message, "Raise_error_on_expressions_and_declarations_with_an_implied_any_type_6052", "Raise error on expressions and declarations with an implied 'any' type."),
        File_0_not_found: diag(6053, ts2.DiagnosticCategory.Error, "File_0_not_found_6053", "File '{0}' not found."),
        File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1: diag(6054, ts2.DiagnosticCategory.Error, "File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1_6054", "File '{0}' has an unsupported extension. The only supported extensions are {1}."),
        Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures: diag(6055, ts2.DiagnosticCategory.Message, "Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures_6055", "Suppress noImplicitAny errors for indexing objects lacking index signatures."),
        Do_not_emit_declarations_for_code_that_has_an_internal_annotation: diag(6056, ts2.DiagnosticCategory.Message, "Do_not_emit_declarations_for_code_that_has_an_internal_annotation_6056", "Do not emit declarations for code that has an '@internal' annotation."),
        Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir: diag(6058, ts2.DiagnosticCategory.Message, "Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir_6058", "Specify the root directory of input files. Use to control the output directory structure with --outDir."),
        File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files: diag(6059, ts2.DiagnosticCategory.Error, "File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files_6059", "File '{0}' is not under 'rootDir' '{1}'. 'rootDir' is expected to contain all source files."),
        Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix: diag(6060, ts2.DiagnosticCategory.Message, "Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix_6060", "Specify the end of line sequence to be used when emitting files: 'CRLF' (dos) or 'LF' (unix)."),
        NEWLINE: diag(6061, ts2.DiagnosticCategory.Message, "NEWLINE_6061", "NEWLINE"),
        Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line: diag(6064, ts2.DiagnosticCategory.Error, "Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line_6064", "Option '{0}' can only be specified in 'tsconfig.json' file or set to 'null' on command line."),
        Enables_experimental_support_for_ES7_decorators: diag(6065, ts2.DiagnosticCategory.Message, "Enables_experimental_support_for_ES7_decorators_6065", "Enables experimental support for ES7 decorators."),
        Enables_experimental_support_for_emitting_type_metadata_for_decorators: diag(6066, ts2.DiagnosticCategory.Message, "Enables_experimental_support_for_emitting_type_metadata_for_decorators_6066", "Enables experimental support for emitting type metadata for decorators."),
        Enables_experimental_support_for_ES7_async_functions: diag(6068, ts2.DiagnosticCategory.Message, "Enables_experimental_support_for_ES7_async_functions_6068", "Enables experimental support for ES7 async functions."),
        Specify_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6: diag(6069, ts2.DiagnosticCategory.Message, "Specify_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6_6069", "Specify module resolution strategy: 'node' (Node.js) or 'classic' (TypeScript pre-1.6)."),
        Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file: diag(6070, ts2.DiagnosticCategory.Message, "Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file_6070", "Initializes a TypeScript project and creates a tsconfig.json file."),
        Successfully_created_a_tsconfig_json_file: diag(6071, ts2.DiagnosticCategory.Message, "Successfully_created_a_tsconfig_json_file_6071", "Successfully created a tsconfig.json file."),
        Suppress_excess_property_checks_for_object_literals: diag(6072, ts2.DiagnosticCategory.Message, "Suppress_excess_property_checks_for_object_literals_6072", "Suppress excess property checks for object literals."),
        Stylize_errors_and_messages_using_color_and_context_experimental: diag(6073, ts2.DiagnosticCategory.Message, "Stylize_errors_and_messages_using_color_and_context_experimental_6073", "Stylize errors and messages using color and context (experimental)."),
        Do_not_report_errors_on_unused_labels: diag(6074, ts2.DiagnosticCategory.Message, "Do_not_report_errors_on_unused_labels_6074", "Do not report errors on unused labels."),
        Report_error_when_not_all_code_paths_in_function_return_a_value: diag(6075, ts2.DiagnosticCategory.Message, "Report_error_when_not_all_code_paths_in_function_return_a_value_6075", "Report error when not all code paths in function return a value."),
        Report_errors_for_fallthrough_cases_in_switch_statement: diag(6076, ts2.DiagnosticCategory.Message, "Report_errors_for_fallthrough_cases_in_switch_statement_6076", "Report errors for fallthrough cases in switch statement."),
        Do_not_report_errors_on_unreachable_code: diag(6077, ts2.DiagnosticCategory.Message, "Do_not_report_errors_on_unreachable_code_6077", "Do not report errors on unreachable code."),
        Disallow_inconsistently_cased_references_to_the_same_file: diag(6078, ts2.DiagnosticCategory.Message, "Disallow_inconsistently_cased_references_to_the_same_file_6078", "Disallow inconsistently-cased references to the same file."),
        Specify_library_files_to_be_included_in_the_compilation: diag(6079, ts2.DiagnosticCategory.Message, "Specify_library_files_to_be_included_in_the_compilation_6079", "Specify library files to be included in the compilation."),
        Specify_JSX_code_generation_Colon_preserve_react_native_or_react: diag(6080, ts2.DiagnosticCategory.Message, "Specify_JSX_code_generation_Colon_preserve_react_native_or_react_6080", "Specify JSX code generation: 'preserve', 'react-native', or 'react'."),
        File_0_has_an_unsupported_extension_so_skipping_it: diag(6081, ts2.DiagnosticCategory.Message, "File_0_has_an_unsupported_extension_so_skipping_it_6081", "File '{0}' has an unsupported extension, so skipping it."),
        Only_amd_and_system_modules_are_supported_alongside_0: diag(6082, ts2.DiagnosticCategory.Error, "Only_amd_and_system_modules_are_supported_alongside_0_6082", "Only 'amd' and 'system' modules are supported alongside --{0}."),
        Base_directory_to_resolve_non_absolute_module_names: diag(6083, ts2.DiagnosticCategory.Message, "Base_directory_to_resolve_non_absolute_module_names_6083", "Base directory to resolve non-absolute module names."),
        Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react_JSX_emit: diag(6084, ts2.DiagnosticCategory.Message, "Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react__6084", "[Deprecated] Use '--jsxFactory' instead. Specify the object invoked for createElement when targeting 'react' JSX emit"),
        Enable_tracing_of_the_name_resolution_process: diag(6085, ts2.DiagnosticCategory.Message, "Enable_tracing_of_the_name_resolution_process_6085", "Enable tracing of the name resolution process."),
        Resolving_module_0_from_1: diag(6086, ts2.DiagnosticCategory.Message, "Resolving_module_0_from_1_6086", "======== Resolving module '{0}' from '{1}'. ========"),
        Explicitly_specified_module_resolution_kind_Colon_0: diag(6087, ts2.DiagnosticCategory.Message, "Explicitly_specified_module_resolution_kind_Colon_0_6087", "Explicitly specified module resolution kind: '{0}'."),
        Module_resolution_kind_is_not_specified_using_0: diag(6088, ts2.DiagnosticCategory.Message, "Module_resolution_kind_is_not_specified_using_0_6088", "Module resolution kind is not specified, using '{0}'."),
        Module_name_0_was_successfully_resolved_to_1: diag(6089, ts2.DiagnosticCategory.Message, "Module_name_0_was_successfully_resolved_to_1_6089", "======== Module name '{0}' was successfully resolved to '{1}'. ========"),
        Module_name_0_was_not_resolved: diag(6090, ts2.DiagnosticCategory.Message, "Module_name_0_was_not_resolved_6090", "======== Module name '{0}' was not resolved. ========"),
        paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0: diag(6091, ts2.DiagnosticCategory.Message, "paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0_6091", "'paths' option is specified, looking for a pattern to match module name '{0}'."),
        Module_name_0_matched_pattern_1: diag(6092, ts2.DiagnosticCategory.Message, "Module_name_0_matched_pattern_1_6092", "Module name '{0}', matched pattern '{1}'."),
        Trying_substitution_0_candidate_module_location_Colon_1: diag(6093, ts2.DiagnosticCategory.Message, "Trying_substitution_0_candidate_module_location_Colon_1_6093", "Trying substitution '{0}', candidate module location: '{1}'."),
        Resolving_module_name_0_relative_to_base_url_1_2: diag(6094, ts2.DiagnosticCategory.Message, "Resolving_module_name_0_relative_to_base_url_1_2_6094", "Resolving module name '{0}' relative to base url '{1}' - '{2}'."),
        Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1: diag(6095, ts2.DiagnosticCategory.Message, "Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1_6095", "Loading module as file / folder, candidate module location '{0}', target file type '{1}'."),
        File_0_does_not_exist: diag(6096, ts2.DiagnosticCategory.Message, "File_0_does_not_exist_6096", "File '{0}' does not exist."),
        File_0_exist_use_it_as_a_name_resolution_result: diag(6097, ts2.DiagnosticCategory.Message, "File_0_exist_use_it_as_a_name_resolution_result_6097", "File '{0}' exist - use it as a name resolution result."),
        Loading_module_0_from_node_modules_folder_target_file_type_1: diag(6098, ts2.DiagnosticCategory.Message, "Loading_module_0_from_node_modules_folder_target_file_type_1_6098", "Loading module '{0}' from 'node_modules' folder, target file type '{1}'."),
        Found_package_json_at_0: diag(6099, ts2.DiagnosticCategory.Message, "Found_package_json_at_0_6099", "Found 'package.json' at '{0}'."),
        package_json_does_not_have_a_0_field: diag(6100, ts2.DiagnosticCategory.Message, "package_json_does_not_have_a_0_field_6100", "'package.json' does not have a '{0}' field."),
        package_json_has_0_field_1_that_references_2: diag(6101, ts2.DiagnosticCategory.Message, "package_json_has_0_field_1_that_references_2_6101", "'package.json' has '{0}' field '{1}' that references '{2}'."),
        Allow_javascript_files_to_be_compiled: diag(6102, ts2.DiagnosticCategory.Message, "Allow_javascript_files_to_be_compiled_6102", "Allow javascript files to be compiled."),
        Option_0_should_have_array_of_strings_as_a_value: diag(6103, ts2.DiagnosticCategory.Error, "Option_0_should_have_array_of_strings_as_a_value_6103", "Option '{0}' should have array of strings as a value."),
        Checking_if_0_is_the_longest_matching_prefix_for_1_2: diag(6104, ts2.DiagnosticCategory.Message, "Checking_if_0_is_the_longest_matching_prefix_for_1_2_6104", "Checking if '{0}' is the longest matching prefix for '{1}' - '{2}'."),
        Expected_type_of_0_field_in_package_json_to_be_1_got_2: diag(6105, ts2.DiagnosticCategory.Message, "Expected_type_of_0_field_in_package_json_to_be_1_got_2_6105", "Expected type of '{0}' field in 'package.json' to be '{1}', got '{2}'."),
        baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1: diag(6106, ts2.DiagnosticCategory.Message, "baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1_6106", "'baseUrl' option is set to '{0}', using this value to resolve non-relative module name '{1}'."),
        rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0: diag(6107, ts2.DiagnosticCategory.Message, "rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0_6107", "'rootDirs' option is set, using it to resolve relative module name '{0}'."),
        Longest_matching_prefix_for_0_is_1: diag(6108, ts2.DiagnosticCategory.Message, "Longest_matching_prefix_for_0_is_1_6108", "Longest matching prefix for '{0}' is '{1}'."),
        Loading_0_from_the_root_dir_1_candidate_location_2: diag(6109, ts2.DiagnosticCategory.Message, "Loading_0_from_the_root_dir_1_candidate_location_2_6109", "Loading '{0}' from the root dir '{1}', candidate location '{2}'."),
        Trying_other_entries_in_rootDirs: diag(6110, ts2.DiagnosticCategory.Message, "Trying_other_entries_in_rootDirs_6110", "Trying other entries in 'rootDirs'."),
        Module_resolution_using_rootDirs_has_failed: diag(6111, ts2.DiagnosticCategory.Message, "Module_resolution_using_rootDirs_has_failed_6111", "Module resolution using 'rootDirs' has failed."),
        Do_not_emit_use_strict_directives_in_module_output: diag(6112, ts2.DiagnosticCategory.Message, "Do_not_emit_use_strict_directives_in_module_output_6112", "Do not emit 'use strict' directives in module output."),
        Enable_strict_null_checks: diag(6113, ts2.DiagnosticCategory.Message, "Enable_strict_null_checks_6113", "Enable strict null checks."),
        Unknown_option_excludes_Did_you_mean_exclude: diag(6114, ts2.DiagnosticCategory.Error, "Unknown_option_excludes_Did_you_mean_exclude_6114", "Unknown option 'excludes'. Did you mean 'exclude'?"),
        Raise_error_on_this_expressions_with_an_implied_any_type: diag(6115, ts2.DiagnosticCategory.Message, "Raise_error_on_this_expressions_with_an_implied_any_type_6115", "Raise error on 'this' expressions with an implied 'any' type."),
        Resolving_type_reference_directive_0_containing_file_1_root_directory_2: diag(6116, ts2.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_1_root_directory_2_6116", "======== Resolving type reference directive '{0}', containing file '{1}', root directory '{2}'. ========"),
        Resolving_using_primary_search_paths: diag(6117, ts2.DiagnosticCategory.Message, "Resolving_using_primary_search_paths_6117", "Resolving using primary search paths..."),
        Resolving_from_node_modules_folder: diag(6118, ts2.DiagnosticCategory.Message, "Resolving_from_node_modules_folder_6118", "Resolving from node_modules folder..."),
        Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2: diag(6119, ts2.DiagnosticCategory.Message, "Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2_6119", "======== Type reference directive '{0}' was successfully resolved to '{1}', primary: {2}. ========"),
        Type_reference_directive_0_was_not_resolved: diag(6120, ts2.DiagnosticCategory.Message, "Type_reference_directive_0_was_not_resolved_6120", "======== Type reference directive '{0}' was not resolved. ========"),
        Resolving_with_primary_search_path_0: diag(6121, ts2.DiagnosticCategory.Message, "Resolving_with_primary_search_path_0_6121", "Resolving with primary search path '{0}'."),
        Root_directory_cannot_be_determined_skipping_primary_search_paths: diag(6122, ts2.DiagnosticCategory.Message, "Root_directory_cannot_be_determined_skipping_primary_search_paths_6122", "Root directory cannot be determined, skipping primary search paths."),
        Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set: diag(6123, ts2.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set_6123", "======== Resolving type reference directive '{0}', containing file '{1}', root directory not set. ========"),
        Type_declaration_files_to_be_included_in_compilation: diag(6124, ts2.DiagnosticCategory.Message, "Type_declaration_files_to_be_included_in_compilation_6124", "Type declaration files to be included in compilation."),
        Looking_up_in_node_modules_folder_initial_location_0: diag(6125, ts2.DiagnosticCategory.Message, "Looking_up_in_node_modules_folder_initial_location_0_6125", "Looking up in 'node_modules' folder, initial location '{0}'."),
        Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_modules_folder: diag(6126, ts2.DiagnosticCategory.Message, "Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_mod_6126", "Containing file is not specified and root directory cannot be determined, skipping lookup in 'node_modules' folder."),
        Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1: diag(6127, ts2.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1_6127", "======== Resolving type reference directive '{0}', containing file not set, root directory '{1}'. ========"),
        Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set: diag(6128, ts2.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set_6128", "======== Resolving type reference directive '{0}', containing file not set, root directory not set. ========"),
        Resolving_real_path_for_0_result_1: diag(6130, ts2.DiagnosticCategory.Message, "Resolving_real_path_for_0_result_1_6130", "Resolving real path for '{0}', result '{1}'."),
        Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system: diag(6131, ts2.DiagnosticCategory.Error, "Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system_6131", "Cannot compile modules using option '{0}' unless the '--module' flag is 'amd' or 'system'."),
        File_name_0_has_a_1_extension_stripping_it: diag(6132, ts2.DiagnosticCategory.Message, "File_name_0_has_a_1_extension_stripping_it_6132", "File name '{0}' has a '{1}' extension - stripping it."),
        _0_is_declared_but_its_value_is_never_read: diag(6133, ts2.DiagnosticCategory.Error, "_0_is_declared_but_its_value_is_never_read_6133", "'{0}' is declared but its value is never read.", true),
        Report_errors_on_unused_locals: diag(6134, ts2.DiagnosticCategory.Message, "Report_errors_on_unused_locals_6134", "Report errors on unused locals."),
        Report_errors_on_unused_parameters: diag(6135, ts2.DiagnosticCategory.Message, "Report_errors_on_unused_parameters_6135", "Report errors on unused parameters."),
        The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files: diag(6136, ts2.DiagnosticCategory.Message, "The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files_6136", "The maximum dependency depth to search under node_modules and load JavaScript files."),
        Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1: diag(6137, ts2.DiagnosticCategory.Error, "Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1_6137", "Cannot import type declaration files. Consider importing '{0}' instead of '{1}'."),
        Property_0_is_declared_but_its_value_is_never_read: diag(6138, ts2.DiagnosticCategory.Error, "Property_0_is_declared_but_its_value_is_never_read_6138", "Property '{0}' is declared but its value is never read.", true),
        Import_emit_helpers_from_tslib: diag(6139, ts2.DiagnosticCategory.Message, "Import_emit_helpers_from_tslib_6139", "Import emit helpers from 'tslib'."),
        Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using_cache_location_2: diag(6140, ts2.DiagnosticCategory.Error, "Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using__6140", "Auto discovery for typings is enabled in project '{0}'. Running extra resolution pass for module '{1}' using cache location '{2}'."),
        Parse_in_strict_mode_and_emit_use_strict_for_each_source_file: diag(6141, ts2.DiagnosticCategory.Message, "Parse_in_strict_mode_and_emit_use_strict_for_each_source_file_6141", 'Parse in strict mode and emit "use strict" for each source file.'),
        Module_0_was_resolved_to_1_but_jsx_is_not_set: diag(6142, ts2.DiagnosticCategory.Error, "Module_0_was_resolved_to_1_but_jsx_is_not_set_6142", "Module '{0}' was resolved to '{1}', but '--jsx' is not set."),
        Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1: diag(6144, ts2.DiagnosticCategory.Message, "Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1_6144", "Module '{0}' was resolved as locally declared ambient module in file '{1}'."),
        Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified: diag(6145, ts2.DiagnosticCategory.Message, "Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified_6145", "Module '{0}' was resolved as ambient module declared in '{1}' since this file was not modified."),
        Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h: diag(6146, ts2.DiagnosticCategory.Message, "Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h_6146", "Specify the JSX factory function to use when targeting 'react' JSX emit, e.g. 'React.createElement' or 'h'."),
        Resolution_for_module_0_was_found_in_cache_from_location_1: diag(6147, ts2.DiagnosticCategory.Message, "Resolution_for_module_0_was_found_in_cache_from_location_1_6147", "Resolution for module '{0}' was found in cache from location '{1}'."),
        Directory_0_does_not_exist_skipping_all_lookups_in_it: diag(6148, ts2.DiagnosticCategory.Message, "Directory_0_does_not_exist_skipping_all_lookups_in_it_6148", "Directory '{0}' does not exist, skipping all lookups in it."),
        Show_diagnostic_information: diag(6149, ts2.DiagnosticCategory.Message, "Show_diagnostic_information_6149", "Show diagnostic information."),
        Show_verbose_diagnostic_information: diag(6150, ts2.DiagnosticCategory.Message, "Show_verbose_diagnostic_information_6150", "Show verbose diagnostic information."),
        Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file: diag(6151, ts2.DiagnosticCategory.Message, "Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file_6151", "Emit a single file with source maps instead of having a separate file."),
        Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap_to_be_set: diag(6152, ts2.DiagnosticCategory.Message, "Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap__6152", "Emit the source alongside the sourcemaps within a single file; requires '--inlineSourceMap' or '--sourceMap' to be set."),
        Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule: diag(6153, ts2.DiagnosticCategory.Message, "Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule_6153", "Transpile each file as a separate module (similar to 'ts.transpileModule')."),
        Print_names_of_generated_files_part_of_the_compilation: diag(6154, ts2.DiagnosticCategory.Message, "Print_names_of_generated_files_part_of_the_compilation_6154", "Print names of generated files part of the compilation."),
        Print_names_of_files_part_of_the_compilation: diag(6155, ts2.DiagnosticCategory.Message, "Print_names_of_files_part_of_the_compilation_6155", "Print names of files part of the compilation."),
        The_locale_used_when_displaying_messages_to_the_user_e_g_en_us: diag(6156, ts2.DiagnosticCategory.Message, "The_locale_used_when_displaying_messages_to_the_user_e_g_en_us_6156", "The locale used when displaying messages to the user (e.g. 'en-us')"),
        Do_not_generate_custom_helper_functions_like_extends_in_compiled_output: diag(6157, ts2.DiagnosticCategory.Message, "Do_not_generate_custom_helper_functions_like_extends_in_compiled_output_6157", "Do not generate custom helper functions like '__extends' in compiled output."),
        Do_not_include_the_default_library_file_lib_d_ts: diag(6158, ts2.DiagnosticCategory.Message, "Do_not_include_the_default_library_file_lib_d_ts_6158", "Do not include the default library file (lib.d.ts)."),
        Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files: diag(6159, ts2.DiagnosticCategory.Message, "Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files_6159", "Do not add triple-slash references or imported modules to the list of compiled files."),
        Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files: diag(6160, ts2.DiagnosticCategory.Message, "Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files_6160", "[Deprecated] Use '--skipLibCheck' instead. Skip type checking of default library declaration files."),
        List_of_folders_to_include_type_definitions_from: diag(6161, ts2.DiagnosticCategory.Message, "List_of_folders_to_include_type_definitions_from_6161", "List of folders to include type definitions from."),
        Disable_size_limitations_on_JavaScript_projects: diag(6162, ts2.DiagnosticCategory.Message, "Disable_size_limitations_on_JavaScript_projects_6162", "Disable size limitations on JavaScript projects."),
        The_character_set_of_the_input_files: diag(6163, ts2.DiagnosticCategory.Message, "The_character_set_of_the_input_files_6163", "The character set of the input files."),
        Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files: diag(6164, ts2.DiagnosticCategory.Message, "Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files_6164", "Emit a UTF-8 Byte Order Mark (BOM) in the beginning of output files."),
        Do_not_truncate_error_messages: diag(6165, ts2.DiagnosticCategory.Message, "Do_not_truncate_error_messages_6165", "Do not truncate error messages."),
        Output_directory_for_generated_declaration_files: diag(6166, ts2.DiagnosticCategory.Message, "Output_directory_for_generated_declaration_files_6166", "Output directory for generated declaration files."),
        A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl: diag(6167, ts2.DiagnosticCategory.Message, "A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl_6167", "A series of entries which re-map imports to lookup locations relative to the 'baseUrl'."),
        List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime: diag(6168, ts2.DiagnosticCategory.Message, "List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime_6168", "List of root folders whose combined content represents the structure of the project at runtime."),
        Show_all_compiler_options: diag(6169, ts2.DiagnosticCategory.Message, "Show_all_compiler_options_6169", "Show all compiler options."),
        Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file: diag(6170, ts2.DiagnosticCategory.Message, "Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file_6170", "[Deprecated] Use '--outFile' instead. Concatenate and emit output to single file"),
        Command_line_Options: diag(6171, ts2.DiagnosticCategory.Message, "Command_line_Options_6171", "Command-line Options"),
        Basic_Options: diag(6172, ts2.DiagnosticCategory.Message, "Basic_Options_6172", "Basic Options"),
        Strict_Type_Checking_Options: diag(6173, ts2.DiagnosticCategory.Message, "Strict_Type_Checking_Options_6173", "Strict Type-Checking Options"),
        Module_Resolution_Options: diag(6174, ts2.DiagnosticCategory.Message, "Module_Resolution_Options_6174", "Module Resolution Options"),
        Source_Map_Options: diag(6175, ts2.DiagnosticCategory.Message, "Source_Map_Options_6175", "Source Map Options"),
        Additional_Checks: diag(6176, ts2.DiagnosticCategory.Message, "Additional_Checks_6176", "Additional Checks"),
        Experimental_Options: diag(6177, ts2.DiagnosticCategory.Message, "Experimental_Options_6177", "Experimental Options"),
        Advanced_Options: diag(6178, ts2.DiagnosticCategory.Message, "Advanced_Options_6178", "Advanced Options"),
        Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3: diag(6179, ts2.DiagnosticCategory.Message, "Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3_6179", "Provide full support for iterables in 'for-of', spread, and destructuring when targeting 'ES5' or 'ES3'."),
        Enable_all_strict_type_checking_options: diag(6180, ts2.DiagnosticCategory.Message, "Enable_all_strict_type_checking_options_6180", "Enable all strict type-checking options."),
        List_of_language_service_plugins: diag(6181, ts2.DiagnosticCategory.Message, "List_of_language_service_plugins_6181", "List of language service plugins."),
        Scoped_package_detected_looking_in_0: diag(6182, ts2.DiagnosticCategory.Message, "Scoped_package_detected_looking_in_0_6182", "Scoped package detected, looking in '{0}'"),
        Reusing_resolution_of_module_0_to_file_1_from_old_program: diag(6183, ts2.DiagnosticCategory.Message, "Reusing_resolution_of_module_0_to_file_1_from_old_program_6183", "Reusing resolution of module '{0}' to file '{1}' from old program."),
        Reusing_module_resolutions_originating_in_0_since_resolutions_are_unchanged_from_old_program: diag(6184, ts2.DiagnosticCategory.Message, "Reusing_module_resolutions_originating_in_0_since_resolutions_are_unchanged_from_old_program_6184", "Reusing module resolutions originating in '{0}' since resolutions are unchanged from old program."),
        Disable_strict_checking_of_generic_signatures_in_function_types: diag(6185, ts2.DiagnosticCategory.Message, "Disable_strict_checking_of_generic_signatures_in_function_types_6185", "Disable strict checking of generic signatures in function types."),
        Enable_strict_checking_of_function_types: diag(6186, ts2.DiagnosticCategory.Message, "Enable_strict_checking_of_function_types_6186", "Enable strict checking of function types."),
        Enable_strict_checking_of_property_initialization_in_classes: diag(6187, ts2.DiagnosticCategory.Message, "Enable_strict_checking_of_property_initialization_in_classes_6187", "Enable strict checking of property initialization in classes."),
        Numeric_separators_are_not_allowed_here: diag(6188, ts2.DiagnosticCategory.Error, "Numeric_separators_are_not_allowed_here_6188", "Numeric separators are not allowed here."),
        Multiple_consecutive_numeric_separators_are_not_permitted: diag(6189, ts2.DiagnosticCategory.Error, "Multiple_consecutive_numeric_separators_are_not_permitted_6189", "Multiple consecutive numeric separators are not permitted."),
        Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen: diag(6191, ts2.DiagnosticCategory.Message, "Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen_6191", "Whether to keep outdated console output in watch mode instead of clearing the screen."),
        All_imports_in_import_declaration_are_unused: diag(6192, ts2.DiagnosticCategory.Error, "All_imports_in_import_declaration_are_unused_6192", "All imports in import declaration are unused.", true),
        Found_1_error_Watching_for_file_changes: diag(6193, ts2.DiagnosticCategory.Message, "Found_1_error_Watching_for_file_changes_6193", "Found 1 error. Watching for file changes."),
        Found_0_errors_Watching_for_file_changes: diag(6194, ts2.DiagnosticCategory.Message, "Found_0_errors_Watching_for_file_changes_6194", "Found {0} errors. Watching for file changes."),
        Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols: diag(6195, ts2.DiagnosticCategory.Message, "Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols_6195", "Resolve 'keyof' to string valued property names only (no numbers or symbols)."),
        _0_is_declared_but_never_used: diag(6196, ts2.DiagnosticCategory.Error, "_0_is_declared_but_never_used_6196", "'{0}' is declared but never used.", true),
        Include_modules_imported_with_json_extension: diag(6197, ts2.DiagnosticCategory.Message, "Include_modules_imported_with_json_extension_6197", "Include modules imported with '.json' extension"),
        All_destructured_elements_are_unused: diag(6198, ts2.DiagnosticCategory.Error, "All_destructured_elements_are_unused_6198", "All destructured elements are unused.", true),
        All_variables_are_unused: diag(6199, ts2.DiagnosticCategory.Error, "All_variables_are_unused_6199", "All variables are unused.", true),
        Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0: diag(6200, ts2.DiagnosticCategory.Error, "Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0_6200", "Definitions of the following identifiers conflict with those in another file: {0}"),
        Conflicts_are_in_this_file: diag(6201, ts2.DiagnosticCategory.Message, "Conflicts_are_in_this_file_6201", "Conflicts are in this file."),
        Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0: diag(6202, ts2.DiagnosticCategory.Error, "Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0_6202", "Project references may not form a circular graph. Cycle detected: {0}"),
        _0_was_also_declared_here: diag(6203, ts2.DiagnosticCategory.Message, "_0_was_also_declared_here_6203", "'{0}' was also declared here."),
        and_here: diag(6204, ts2.DiagnosticCategory.Message, "and_here_6204", "and here."),
        All_type_parameters_are_unused: diag(6205, ts2.DiagnosticCategory.Error, "All_type_parameters_are_unused_6205", "All type parameters are unused"),
        package_json_has_a_typesVersions_field_with_version_specific_path_mappings: diag(6206, ts2.DiagnosticCategory.Message, "package_json_has_a_typesVersions_field_with_version_specific_path_mappings_6206", "'package.json' has a 'typesVersions' field with version-specific path mappings."),
        package_json_does_not_have_a_typesVersions_entry_that_matches_version_0: diag(6207, ts2.DiagnosticCategory.Message, "package_json_does_not_have_a_typesVersions_entry_that_matches_version_0_6207", "'package.json' does not have a 'typesVersions' entry that matches version '{0}'."),
        package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2: diag(6208, ts2.DiagnosticCategory.Message, "package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_ma_6208", "'package.json' has a 'typesVersions' entry '{0}' that matches compiler version '{1}', looking for a pattern to match module name '{2}'."),
        package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range: diag(6209, ts2.DiagnosticCategory.Message, "package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range_6209", "'package.json' has a 'typesVersions' entry '{0}' that is not a valid semver range."),
        An_argument_for_0_was_not_provided: diag(6210, ts2.DiagnosticCategory.Message, "An_argument_for_0_was_not_provided_6210", "An argument for '{0}' was not provided."),
        An_argument_matching_this_binding_pattern_was_not_provided: diag(6211, ts2.DiagnosticCategory.Message, "An_argument_matching_this_binding_pattern_was_not_provided_6211", "An argument matching this binding pattern was not provided."),
        Did_you_mean_to_call_this_expression: diag(6212, ts2.DiagnosticCategory.Message, "Did_you_mean_to_call_this_expression_6212", "Did you mean to call this expression?"),
        Did_you_mean_to_use_new_with_this_expression: diag(6213, ts2.DiagnosticCategory.Message, "Did_you_mean_to_use_new_with_this_expression_6213", "Did you mean to use 'new' with this expression?"),
        Enable_strict_bind_call_and_apply_methods_on_functions: diag(6214, ts2.DiagnosticCategory.Message, "Enable_strict_bind_call_and_apply_methods_on_functions_6214", "Enable strict 'bind', 'call', and 'apply' methods on functions."),
        Using_compiler_options_of_project_reference_redirect_0: diag(6215, ts2.DiagnosticCategory.Message, "Using_compiler_options_of_project_reference_redirect_0_6215", "Using compiler options of project reference redirect '{0}'."),
        Found_1_error: diag(6216, ts2.DiagnosticCategory.Message, "Found_1_error_6216", "Found 1 error."),
        Found_0_errors: diag(6217, ts2.DiagnosticCategory.Message, "Found_0_errors_6217", "Found {0} errors."),
        Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2: diag(6218, ts2.DiagnosticCategory.Message, "Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2_6218", "======== Module name '{0}' was successfully resolved to '{1}' with Package ID '{2}'. ========"),
        Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3: diag(6219, ts2.DiagnosticCategory.Message, "Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3_6219", "======== Type reference directive '{0}' was successfully resolved to '{1}' with Package ID '{2}', primary: {3}. ========"),
        package_json_had_a_falsy_0_field: diag(6220, ts2.DiagnosticCategory.Message, "package_json_had_a_falsy_0_field_6220", "'package.json' had a falsy '{0}' field."),
        Disable_use_of_source_files_instead_of_declaration_files_from_referenced_projects: diag(6221, ts2.DiagnosticCategory.Message, "Disable_use_of_source_files_instead_of_declaration_files_from_referenced_projects_6221", "Disable use of source files instead of declaration files from referenced projects."),
        Emit_class_fields_with_Define_instead_of_Set: diag(6222, ts2.DiagnosticCategory.Message, "Emit_class_fields_with_Define_instead_of_Set_6222", "Emit class fields with Define instead of Set."),
        Generates_a_CPU_profile: diag(6223, ts2.DiagnosticCategory.Message, "Generates_a_CPU_profile_6223", "Generates a CPU profile."),
        Disable_solution_searching_for_this_project: diag(6224, ts2.DiagnosticCategory.Message, "Disable_solution_searching_for_this_project_6224", "Disable solution searching for this project."),
        Specify_strategy_for_watching_file_Colon_FixedPollingInterval_default_PriorityPollingInterval_DynamicPriorityPolling_UseFsEvents_UseFsEventsOnParentDirectory: diag(6225, ts2.DiagnosticCategory.Message, "Specify_strategy_for_watching_file_Colon_FixedPollingInterval_default_PriorityPollingInterval_Dynami_6225", "Specify strategy for watching file: 'FixedPollingInterval' (default), 'PriorityPollingInterval', 'DynamicPriorityPolling', 'UseFsEvents', 'UseFsEventsOnParentDirectory'."),
        Specify_strategy_for_watching_directory_on_platforms_that_don_t_support_recursive_watching_natively_Colon_UseFsEvents_default_FixedPollingInterval_DynamicPriorityPolling: diag(6226, ts2.DiagnosticCategory.Message, "Specify_strategy_for_watching_directory_on_platforms_that_don_t_support_recursive_watching_natively__6226", "Specify strategy for watching directory on platforms that don't support recursive watching natively: 'UseFsEvents' (default), 'FixedPollingInterval', 'DynamicPriorityPolling'."),
        Specify_strategy_for_creating_a_polling_watch_when_it_fails_to_create_using_file_system_events_Colon_FixedInterval_default_PriorityInterval_DynamicPriority: diag(6227, ts2.DiagnosticCategory.Message, "Specify_strategy_for_creating_a_polling_watch_when_it_fails_to_create_using_file_system_events_Colon_6227", "Specify strategy for creating a polling watch when it fails to create using file system events: 'FixedInterval' (default), 'PriorityInterval', 'DynamicPriority'."),
        Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_support_recursive_watching_natively: diag(6228, ts2.DiagnosticCategory.Message, "Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_supp_6228", "Synchronously call callbacks and update the state of directory watchers on platforms that don't support recursive watching natively."),
        Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3: diag(6229, ts2.DiagnosticCategory.Error, "Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3_6229", "Tag '{0}' expects at least '{1}' arguments, but the JSX factory '{2}' provides at most '{3}'."),
        Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line: diag(6230, ts2.DiagnosticCategory.Error, "Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line_6230", "Option '{0}' can only be specified in 'tsconfig.json' file or set to 'false' or 'null' on command line."),
        Could_not_resolve_the_path_0_with_the_extensions_Colon_1: diag(6231, ts2.DiagnosticCategory.Error, "Could_not_resolve_the_path_0_with_the_extensions_Colon_1_6231", "Could not resolve the path '{0}' with the extensions: {1}."),
        Declaration_augments_declaration_in_another_file_This_cannot_be_serialized: diag(6232, ts2.DiagnosticCategory.Error, "Declaration_augments_declaration_in_another_file_This_cannot_be_serialized_6232", "Declaration augments declaration in another file. This cannot be serialized."),
        This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_file: diag(6233, ts2.DiagnosticCategory.Error, "This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_fil_6233", "This is the declaration being augmented. Consider moving the augmenting declaration into the same file."),
        Projects_to_reference: diag(6300, ts2.DiagnosticCategory.Message, "Projects_to_reference_6300", "Projects to reference"),
        Enable_project_compilation: diag(6302, ts2.DiagnosticCategory.Message, "Enable_project_compilation_6302", "Enable project compilation"),
        Composite_projects_may_not_disable_declaration_emit: diag(6304, ts2.DiagnosticCategory.Error, "Composite_projects_may_not_disable_declaration_emit_6304", "Composite projects may not disable declaration emit."),
        Output_file_0_has_not_been_built_from_source_file_1: diag(6305, ts2.DiagnosticCategory.Error, "Output_file_0_has_not_been_built_from_source_file_1_6305", "Output file '{0}' has not been built from source file '{1}'."),
        Referenced_project_0_must_have_setting_composite_Colon_true: diag(6306, ts2.DiagnosticCategory.Error, "Referenced_project_0_must_have_setting_composite_Colon_true_6306", `Referenced project '{0}' must have setting "composite": true.`),
        File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_include_pattern: diag(6307, ts2.DiagnosticCategory.Error, "File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_includ_6307", "File '{0}' is not listed within the file list of project '{1}'. Projects must list all files or use an 'include' pattern."),
        Cannot_prepend_project_0_because_it_does_not_have_outFile_set: diag(6308, ts2.DiagnosticCategory.Error, "Cannot_prepend_project_0_because_it_does_not_have_outFile_set_6308", "Cannot prepend project '{0}' because it does not have 'outFile' set"),
        Output_file_0_from_project_1_does_not_exist: diag(6309, ts2.DiagnosticCategory.Error, "Output_file_0_from_project_1_does_not_exist_6309", "Output file '{0}' from project '{1}' does not exist"),
        Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2: diag(6350, ts2.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2_6350", "Project '{0}' is out of date because oldest output '{1}' is older than newest input '{2}'"),
        Project_0_is_up_to_date_because_newest_input_1_is_older_than_oldest_output_2: diag(6351, ts2.DiagnosticCategory.Message, "Project_0_is_up_to_date_because_newest_input_1_is_older_than_oldest_output_2_6351", "Project '{0}' is up to date because newest input '{1}' is older than oldest output '{2}'"),
        Project_0_is_out_of_date_because_output_file_1_does_not_exist: diag(6352, ts2.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_output_file_1_does_not_exist_6352", "Project '{0}' is out of date because output file '{1}' does not exist"),
        Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date: diag(6353, ts2.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date_6353", "Project '{0}' is out of date because its dependency '{1}' is out of date"),
        Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies: diag(6354, ts2.DiagnosticCategory.Message, "Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies_6354", "Project '{0}' is up to date with .d.ts files from its dependencies"),
        Projects_in_this_build_Colon_0: diag(6355, ts2.DiagnosticCategory.Message, "Projects_in_this_build_Colon_0_6355", "Projects in this build: {0}"),
        A_non_dry_build_would_delete_the_following_files_Colon_0: diag(6356, ts2.DiagnosticCategory.Message, "A_non_dry_build_would_delete_the_following_files_Colon_0_6356", "A non-dry build would delete the following files: {0}"),
        A_non_dry_build_would_build_project_0: diag(6357, ts2.DiagnosticCategory.Message, "A_non_dry_build_would_build_project_0_6357", "A non-dry build would build project '{0}'"),
        Building_project_0: diag(6358, ts2.DiagnosticCategory.Message, "Building_project_0_6358", "Building project '{0}'..."),
        Updating_output_timestamps_of_project_0: diag(6359, ts2.DiagnosticCategory.Message, "Updating_output_timestamps_of_project_0_6359", "Updating output timestamps of project '{0}'..."),
        delete_this_Project_0_is_up_to_date_because_it_was_previously_built: diag(6360, ts2.DiagnosticCategory.Message, "delete_this_Project_0_is_up_to_date_because_it_was_previously_built_6360", "delete this - Project '{0}' is up to date because it was previously built"),
        Project_0_is_up_to_date: diag(6361, ts2.DiagnosticCategory.Message, "Project_0_is_up_to_date_6361", "Project '{0}' is up to date"),
        Skipping_build_of_project_0_because_its_dependency_1_has_errors: diag(6362, ts2.DiagnosticCategory.Message, "Skipping_build_of_project_0_because_its_dependency_1_has_errors_6362", "Skipping build of project '{0}' because its dependency '{1}' has errors"),
        Project_0_can_t_be_built_because_its_dependency_1_has_errors: diag(6363, ts2.DiagnosticCategory.Message, "Project_0_can_t_be_built_because_its_dependency_1_has_errors_6363", "Project '{0}' can't be built because its dependency '{1}' has errors"),
        Build_one_or_more_projects_and_their_dependencies_if_out_of_date: diag(6364, ts2.DiagnosticCategory.Message, "Build_one_or_more_projects_and_their_dependencies_if_out_of_date_6364", "Build one or more projects and their dependencies, if out of date"),
        Delete_the_outputs_of_all_projects: diag(6365, ts2.DiagnosticCategory.Message, "Delete_the_outputs_of_all_projects_6365", "Delete the outputs of all projects"),
        Enable_verbose_logging: diag(6366, ts2.DiagnosticCategory.Message, "Enable_verbose_logging_6366", "Enable verbose logging"),
        Show_what_would_be_built_or_deleted_if_specified_with_clean: diag(6367, ts2.DiagnosticCategory.Message, "Show_what_would_be_built_or_deleted_if_specified_with_clean_6367", "Show what would be built (or deleted, if specified with '--clean')"),
        Build_all_projects_including_those_that_appear_to_be_up_to_date: diag(6368, ts2.DiagnosticCategory.Message, "Build_all_projects_including_those_that_appear_to_be_up_to_date_6368", "Build all projects, including those that appear to be up to date"),
        Option_build_must_be_the_first_command_line_argument: diag(6369, ts2.DiagnosticCategory.Error, "Option_build_must_be_the_first_command_line_argument_6369", "Option '--build' must be the first command line argument."),
        Options_0_and_1_cannot_be_combined: diag(6370, ts2.DiagnosticCategory.Error, "Options_0_and_1_cannot_be_combined_6370", "Options '{0}' and '{1}' cannot be combined."),
        Updating_unchanged_output_timestamps_of_project_0: diag(6371, ts2.DiagnosticCategory.Message, "Updating_unchanged_output_timestamps_of_project_0_6371", "Updating unchanged output timestamps of project '{0}'..."),
        Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed: diag(6372, ts2.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed_6372", "Project '{0}' is out of date because output of its dependency '{1}' has changed"),
        Updating_output_of_project_0: diag(6373, ts2.DiagnosticCategory.Message, "Updating_output_of_project_0_6373", "Updating output of project '{0}'..."),
        A_non_dry_build_would_update_timestamps_for_output_of_project_0: diag(6374, ts2.DiagnosticCategory.Message, "A_non_dry_build_would_update_timestamps_for_output_of_project_0_6374", "A non-dry build would update timestamps for output of project '{0}'"),
        A_non_dry_build_would_update_output_of_project_0: diag(6375, ts2.DiagnosticCategory.Message, "A_non_dry_build_would_update_output_of_project_0_6375", "A non-dry build would update output of project '{0}'"),
        Cannot_update_output_of_project_0_because_there_was_error_reading_file_1: diag(6376, ts2.DiagnosticCategory.Message, "Cannot_update_output_of_project_0_because_there_was_error_reading_file_1_6376", "Cannot update output of project '{0}' because there was error reading file '{1}'"),
        Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1: diag(6377, ts2.DiagnosticCategory.Error, "Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1_6377", "Cannot write file '{0}' because it will overwrite '.tsbuildinfo' file generated by referenced project '{1}'"),
        Enable_incremental_compilation: diag(6378, ts2.DiagnosticCategory.Message, "Enable_incremental_compilation_6378", "Enable incremental compilation"),
        Composite_projects_may_not_disable_incremental_compilation: diag(6379, ts2.DiagnosticCategory.Error, "Composite_projects_may_not_disable_incremental_compilation_6379", "Composite projects may not disable incremental compilation."),
        Specify_file_to_store_incremental_compilation_information: diag(6380, ts2.DiagnosticCategory.Message, "Specify_file_to_store_incremental_compilation_information_6380", "Specify file to store incremental compilation information"),
        Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_current_version_2: diag(6381, ts2.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_curren_6381", "Project '{0}' is out of date because output for it was generated with version '{1}' that differs with current version '{2}'"),
        Skipping_build_of_project_0_because_its_dependency_1_was_not_built: diag(6382, ts2.DiagnosticCategory.Message, "Skipping_build_of_project_0_because_its_dependency_1_was_not_built_6382", "Skipping build of project '{0}' because its dependency '{1}' was not built"),
        Project_0_can_t_be_built_because_its_dependency_1_was_not_built: diag(6383, ts2.DiagnosticCategory.Message, "Project_0_can_t_be_built_because_its_dependency_1_was_not_built_6383", "Project '{0}' can't be built because its dependency '{1}' was not built"),
        Have_recompiles_in_incremental_and_watch_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it: diag(6384, ts2.DiagnosticCategory.Message, "Have_recompiles_in_incremental_and_watch_assume_that_changes_within_a_file_will_only_affect_files_di_6384", "Have recompiles in '--incremental' and '--watch' assume that changes within a file will only affect files directly depending on it."),
        The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1: diag(6500, ts2.DiagnosticCategory.Message, "The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1_6500", "The expected type comes from property '{0}' which is declared here on type '{1}'"),
        The_expected_type_comes_from_this_index_signature: diag(6501, ts2.DiagnosticCategory.Message, "The_expected_type_comes_from_this_index_signature_6501", "The expected type comes from this index signature."),
        The_expected_type_comes_from_the_return_type_of_this_signature: diag(6502, ts2.DiagnosticCategory.Message, "The_expected_type_comes_from_the_return_type_of_this_signature_6502", "The expected type comes from the return type of this signature."),
        Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing: diag(6503, ts2.DiagnosticCategory.Message, "Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing_6503", "Print names of files that are part of the compilation and then stop processing."),
        File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option: diag(6504, ts2.DiagnosticCategory.Error, "File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option_6504", "File '{0}' is a JavaScript file. Did you mean to enable the 'allowJs' option?"),
        Variable_0_implicitly_has_an_1_type: diag(7005, ts2.DiagnosticCategory.Error, "Variable_0_implicitly_has_an_1_type_7005", "Variable '{0}' implicitly has an '{1}' type."),
        Parameter_0_implicitly_has_an_1_type: diag(7006, ts2.DiagnosticCategory.Error, "Parameter_0_implicitly_has_an_1_type_7006", "Parameter '{0}' implicitly has an '{1}' type."),
        Member_0_implicitly_has_an_1_type: diag(7008, ts2.DiagnosticCategory.Error, "Member_0_implicitly_has_an_1_type_7008", "Member '{0}' implicitly has an '{1}' type."),
        new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type: diag(7009, ts2.DiagnosticCategory.Error, "new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type_7009", "'new' expression, whose target lacks a construct signature, implicitly has an 'any' type."),
        _0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type: diag(7010, ts2.DiagnosticCategory.Error, "_0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type_7010", "'{0}', which lacks return-type annotation, implicitly has an '{1}' return type."),
        Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type: diag(7011, ts2.DiagnosticCategory.Error, "Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type_7011", "Function expression, which lacks return-type annotation, implicitly has an '{0}' return type."),
        Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type: diag(7013, ts2.DiagnosticCategory.Error, "Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7013", "Construct signature, which lacks return-type annotation, implicitly has an 'any' return type."),
        Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type: diag(7014, ts2.DiagnosticCategory.Error, "Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type_7014", "Function type, which lacks return-type annotation, implicitly has an '{0}' return type."),
        Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number: diag(7015, ts2.DiagnosticCategory.Error, "Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number_7015", "Element implicitly has an 'any' type because index expression is not of type 'number'."),
        Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type: diag(7016, ts2.DiagnosticCategory.Error, "Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type_7016", "Could not find a declaration file for module '{0}'. '{1}' implicitly has an 'any' type."),
        Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature: diag(7017, ts2.DiagnosticCategory.Error, "Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_7017", "Element implicitly has an 'any' type because type '{0}' has no index signature."),
        Object_literal_s_property_0_implicitly_has_an_1_type: diag(7018, ts2.DiagnosticCategory.Error, "Object_literal_s_property_0_implicitly_has_an_1_type_7018", "Object literal's property '{0}' implicitly has an '{1}' type."),
        Rest_parameter_0_implicitly_has_an_any_type: diag(7019, ts2.DiagnosticCategory.Error, "Rest_parameter_0_implicitly_has_an_any_type_7019", "Rest parameter '{0}' implicitly has an 'any[]' type."),
        Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type: diag(7020, ts2.DiagnosticCategory.Error, "Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7020", "Call signature, which lacks return-type annotation, implicitly has an 'any' return type."),
        _0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer: diag(7022, ts2.DiagnosticCategory.Error, "_0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or__7022", "'{0}' implicitly has type 'any' because it does not have a type annotation and is referenced directly or indirectly in its own initializer."),
        _0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions: diag(7023, ts2.DiagnosticCategory.Error, "_0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_reference_7023", "'{0}' implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."),
        Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions: diag(7024, ts2.DiagnosticCategory.Error, "Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_ref_7024", "Function implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."),
        Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type_annotation: diag(7025, ts2.DiagnosticCategory.Error, "Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_retu_7025", "Generator implicitly has yield type '{0}' because it does not yield any values. Consider supplying a return type annotation."),
        JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists: diag(7026, ts2.DiagnosticCategory.Error, "JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists_7026", "JSX element implicitly has type 'any' because no interface 'JSX.{0}' exists."),
        Unreachable_code_detected: diag(7027, ts2.DiagnosticCategory.Error, "Unreachable_code_detected_7027", "Unreachable code detected.", true),
        Unused_label: diag(7028, ts2.DiagnosticCategory.Error, "Unused_label_7028", "Unused label.", true),
        Fallthrough_case_in_switch: diag(7029, ts2.DiagnosticCategory.Error, "Fallthrough_case_in_switch_7029", "Fallthrough case in switch."),
        Not_all_code_paths_return_a_value: diag(7030, ts2.DiagnosticCategory.Error, "Not_all_code_paths_return_a_value_7030", "Not all code paths return a value."),
        Binding_element_0_implicitly_has_an_1_type: diag(7031, ts2.DiagnosticCategory.Error, "Binding_element_0_implicitly_has_an_1_type_7031", "Binding element '{0}' implicitly has an '{1}' type."),
        Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation: diag(7032, ts2.DiagnosticCategory.Error, "Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation_7032", "Property '{0}' implicitly has type 'any', because its set accessor lacks a parameter type annotation."),
        Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation: diag(7033, ts2.DiagnosticCategory.Error, "Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation_7033", "Property '{0}' implicitly has type 'any', because its get accessor lacks a return type annotation."),
        Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined: diag(7034, ts2.DiagnosticCategory.Error, "Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined_7034", "Variable '{0}' implicitly has type '{1}' in some locations where its type cannot be determined."),
        Try_npm_install_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_module_0: diag(7035, ts2.DiagnosticCategory.Error, "Try_npm_install_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_mod_7035", "Try `npm install @types/{1}` if it exists or add a new declaration (.d.ts) file containing `declare module '{0}';`"),
        Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0: diag(7036, ts2.DiagnosticCategory.Error, "Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0_7036", "Dynamic import's specifier must be of type 'string', but here has type '{0}'."),
        Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for_all_imports_Implies_allowSyntheticDefaultImports: diag(7037, ts2.DiagnosticCategory.Message, "Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for__7037", "Enables emit interoperability between CommonJS and ES Modules via creation of namespace objects for all imports. Implies 'allowSyntheticDefaultImports'."),
        Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead: diag(7038, ts2.DiagnosticCategory.Message, "Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cau_7038", "Type originates at this import. A namespace-style import cannot be called or constructed, and will cause a failure at runtime. Consider using a default import or import require here instead."),
        Mapped_object_type_implicitly_has_an_any_template_type: diag(7039, ts2.DiagnosticCategory.Error, "Mapped_object_type_implicitly_has_an_any_template_type_7039", "Mapped object type implicitly has an 'any' template type."),
        If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_Slash_Slashgithub_com_SlashDefinitelyTyped_SlashDefinitelyTyped_Slashtree_Slashmaster_Slashtypes_Slash_1: diag(7040, ts2.DiagnosticCategory.Error, "If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_S_7040", "If the '{0}' package actually exposes this module, consider sending a pull request to amend 'https://github.com/DefinitelyTyped/DefinitelyTyped/tree/master/types/{1}`"),
        The_containing_arrow_function_captures_the_global_value_of_this: diag(7041, ts2.DiagnosticCategory.Error, "The_containing_arrow_function_captures_the_global_value_of_this_7041", "The containing arrow function captures the global value of 'this'."),
        Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used: diag(7042, ts2.DiagnosticCategory.Error, "Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used_7042", "Module '{0}' was resolved to '{1}', but '--resolveJsonModule' is not used."),
        Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage: diag(7043, ts2.DiagnosticCategory.Suggestion, "Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7043", "Variable '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),
        Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage: diag(7044, ts2.DiagnosticCategory.Suggestion, "Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7044", "Parameter '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),
        Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage: diag(7045, ts2.DiagnosticCategory.Suggestion, "Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7045", "Member '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),
        Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage: diag(7046, ts2.DiagnosticCategory.Suggestion, "Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage_7046", "Variable '{0}' implicitly has type '{1}' in some locations, but a better type may be inferred from usage."),
        Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage: diag(7047, ts2.DiagnosticCategory.Suggestion, "Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage_7047", "Rest parameter '{0}' implicitly has an 'any[]' type, but a better type may be inferred from usage."),
        Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage: diag(7048, ts2.DiagnosticCategory.Suggestion, "Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage_7048", "Property '{0}' implicitly has type 'any', but a better type for its get accessor may be inferred from usage."),
        Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage: diag(7049, ts2.DiagnosticCategory.Suggestion, "Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage_7049", "Property '{0}' implicitly has type 'any', but a better type for its set accessor may be inferred from usage."),
        _0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage: diag(7050, ts2.DiagnosticCategory.Suggestion, "_0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage_7050", "'{0}' implicitly has an '{1}' return type, but a better type may be inferred from usage."),
        Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1: diag(7051, ts2.DiagnosticCategory.Error, "Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1_7051", "Parameter has a name but no type. Did you mean '{0}: {1}'?"),
        Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1: diag(7052, ts2.DiagnosticCategory.Error, "Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1_7052", "Element implicitly has an 'any' type because type '{0}' has no index signature. Did you mean to call '{1}'?"),
        Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1: diag(7053, ts2.DiagnosticCategory.Error, "Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1_7053", "Element implicitly has an 'any' type because expression of type '{0}' can't be used to index type '{1}'."),
        No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1: diag(7054, ts2.DiagnosticCategory.Error, "No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1_7054", "No index signature with a parameter of type '{0}' was found on type '{1}'."),
        _0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type: diag(7055, ts2.DiagnosticCategory.Error, "_0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type_7055", "'{0}', which lacks return-type annotation, implicitly has an '{1}' yield type."),
        You_cannot_rename_this_element: diag(8e3, ts2.DiagnosticCategory.Error, "You_cannot_rename_this_element_8000", "You cannot rename this element."),
        You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library: diag(8001, ts2.DiagnosticCategory.Error, "You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library_8001", "You cannot rename elements that are defined in the standard TypeScript library."),
        import_can_only_be_used_in_TypeScript_files: diag(8002, ts2.DiagnosticCategory.Error, "import_can_only_be_used_in_TypeScript_files_8002", "'import ... =' can only be used in TypeScript files."),
        export_can_only_be_used_in_TypeScript_files: diag(8003, ts2.DiagnosticCategory.Error, "export_can_only_be_used_in_TypeScript_files_8003", "'export =' can only be used in TypeScript files."),
        Type_parameter_declarations_can_only_be_used_in_TypeScript_files: diag(8004, ts2.DiagnosticCategory.Error, "Type_parameter_declarations_can_only_be_used_in_TypeScript_files_8004", "Type parameter declarations can only be used in TypeScript files."),
        implements_clauses_can_only_be_used_in_TypeScript_files: diag(8005, ts2.DiagnosticCategory.Error, "implements_clauses_can_only_be_used_in_TypeScript_files_8005", "'implements' clauses can only be used in TypeScript files."),
        _0_declarations_can_only_be_used_in_TypeScript_files: diag(8006, ts2.DiagnosticCategory.Error, "_0_declarations_can_only_be_used_in_TypeScript_files_8006", "'{0}' declarations can only be used in TypeScript files."),
        Type_aliases_can_only_be_used_in_TypeScript_files: diag(8008, ts2.DiagnosticCategory.Error, "Type_aliases_can_only_be_used_in_TypeScript_files_8008", "Type aliases can only be used in TypeScript files."),
        The_0_modifier_can_only_be_used_in_TypeScript_files: diag(8009, ts2.DiagnosticCategory.Error, "The_0_modifier_can_only_be_used_in_TypeScript_files_8009", "The '{0}' modifier can only be used in TypeScript files."),
        Type_annotations_can_only_be_used_in_TypeScript_files: diag(8010, ts2.DiagnosticCategory.Error, "Type_annotations_can_only_be_used_in_TypeScript_files_8010", "Type annotations can only be used in TypeScript files."),
        Type_arguments_can_only_be_used_in_TypeScript_files: diag(8011, ts2.DiagnosticCategory.Error, "Type_arguments_can_only_be_used_in_TypeScript_files_8011", "Type arguments can only be used in TypeScript files."),
        Parameter_modifiers_can_only_be_used_in_TypeScript_files: diag(8012, ts2.DiagnosticCategory.Error, "Parameter_modifiers_can_only_be_used_in_TypeScript_files_8012", "Parameter modifiers can only be used in TypeScript files."),
        Non_null_assertions_can_only_be_used_in_TypeScript_files: diag(8013, ts2.DiagnosticCategory.Error, "Non_null_assertions_can_only_be_used_in_TypeScript_files_8013", "Non-null assertions can only be used in TypeScript files."),
        Type_assertion_expressions_can_only_be_used_in_TypeScript_files: diag(8016, ts2.DiagnosticCategory.Error, "Type_assertion_expressions_can_only_be_used_in_TypeScript_files_8016", "Type assertion expressions can only be used in TypeScript files."),
        Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0: diag(8017, ts2.DiagnosticCategory.Error, "Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0_8017", "Octal literal types must use ES2015 syntax. Use the syntax '{0}'."),
        Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0: diag(8018, ts2.DiagnosticCategory.Error, "Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0_8018", "Octal literals are not allowed in enums members initializer. Use the syntax '{0}'."),
        Report_errors_in_js_files: diag(8019, ts2.DiagnosticCategory.Message, "Report_errors_in_js_files_8019", "Report errors in .js files."),
        JSDoc_types_can_only_be_used_inside_documentation_comments: diag(8020, ts2.DiagnosticCategory.Error, "JSDoc_types_can_only_be_used_inside_documentation_comments_8020", "JSDoc types can only be used inside documentation comments."),
        JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags: diag(8021, ts2.DiagnosticCategory.Error, "JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags_8021", "JSDoc '@typedef' tag should either have a type annotation or be followed by '@property' or '@member' tags."),
        JSDoc_0_is_not_attached_to_a_class: diag(8022, ts2.DiagnosticCategory.Error, "JSDoc_0_is_not_attached_to_a_class_8022", "JSDoc '@{0}' is not attached to a class."),
        JSDoc_0_1_does_not_match_the_extends_2_clause: diag(8023, ts2.DiagnosticCategory.Error, "JSDoc_0_1_does_not_match_the_extends_2_clause_8023", "JSDoc '@{0} {1}' does not match the 'extends {2}' clause."),
        JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name: diag(8024, ts2.DiagnosticCategory.Error, "JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_8024", "JSDoc '@param' tag has name '{0}', but there is no parameter with that name."),
        Class_declarations_cannot_have_more_than_one_augments_or_extends_tag: diag(8025, ts2.DiagnosticCategory.Error, "Class_declarations_cannot_have_more_than_one_augments_or_extends_tag_8025", "Class declarations cannot have more than one `@augments` or `@extends` tag."),
        Expected_0_type_arguments_provide_these_with_an_extends_tag: diag(8026, ts2.DiagnosticCategory.Error, "Expected_0_type_arguments_provide_these_with_an_extends_tag_8026", "Expected {0} type arguments; provide these with an '@extends' tag."),
        Expected_0_1_type_arguments_provide_these_with_an_extends_tag: diag(8027, ts2.DiagnosticCategory.Error, "Expected_0_1_type_arguments_provide_these_with_an_extends_tag_8027", "Expected {0}-{1} type arguments; provide these with an '@extends' tag."),
        JSDoc_may_only_appear_in_the_last_parameter_of_a_signature: diag(8028, ts2.DiagnosticCategory.Error, "JSDoc_may_only_appear_in_the_last_parameter_of_a_signature_8028", "JSDoc '...' may only appear in the last parameter of a signature."),
        JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_had_an_array_type: diag(8029, ts2.DiagnosticCategory.Error, "JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_h_8029", "JSDoc '@param' tag has name '{0}', but there is no parameter with that name. It would match 'arguments' if it had an array type."),
        The_type_of_a_function_declaration_must_match_the_function_s_signature: diag(8030, ts2.DiagnosticCategory.Error, "The_type_of_a_function_declaration_must_match_the_function_s_signature_8030", "The type of a function declaration must match the function's signature."),
        You_cannot_rename_a_module_via_a_global_import: diag(8031, ts2.DiagnosticCategory.Error, "You_cannot_rename_a_module_via_a_global_import_8031", "You cannot rename a module via a global import."),
        Qualified_name_0_is_not_allowed_without_a_leading_param_object_1: diag(8032, ts2.DiagnosticCategory.Error, "Qualified_name_0_is_not_allowed_without_a_leading_param_object_1_8032", "Qualified name '{0}' is not allowed without a leading '@param {object} {1}'."),
        Only_identifiers_Slashqualified_names_with_optional_type_arguments_are_currently_supported_in_a_class_extends_clause: diag(9002, ts2.DiagnosticCategory.Error, "Only_identifiers_Slashqualified_names_with_optional_type_arguments_are_currently_supported_in_a_clas_9002", "Only identifiers/qualified-names with optional type arguments are currently supported in a class 'extends' clause."),
        class_expressions_are_not_currently_supported: diag(9003, ts2.DiagnosticCategory.Error, "class_expressions_are_not_currently_supported_9003", "'class' expressions are not currently supported."),
        Language_service_is_disabled: diag(9004, ts2.DiagnosticCategory.Error, "Language_service_is_disabled_9004", "Language service is disabled."),
        Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_declaration_emit: diag(9005, ts2.DiagnosticCategory.Error, "Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_9005", "Declaration emit for this file requires using private name '{0}'. An explicit type annotation may unblock declaration emit."),
        Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotation_may_unblock_declaration_emit: diag(9006, ts2.DiagnosticCategory.Error, "Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotati_9006", "Declaration emit for this file requires using private name '{0}' from module '{1}'. An explicit type annotation may unblock declaration emit."),
        JSX_attributes_must_only_be_assigned_a_non_empty_expression: diag(17e3, ts2.DiagnosticCategory.Error, "JSX_attributes_must_only_be_assigned_a_non_empty_expression_17000", "JSX attributes must only be assigned a non-empty 'expression'."),
        JSX_elements_cannot_have_multiple_attributes_with_the_same_name: diag(17001, ts2.DiagnosticCategory.Error, "JSX_elements_cannot_have_multiple_attributes_with_the_same_name_17001", "JSX elements cannot have multiple attributes with the same name."),
        Expected_corresponding_JSX_closing_tag_for_0: diag(17002, ts2.DiagnosticCategory.Error, "Expected_corresponding_JSX_closing_tag_for_0_17002", "Expected corresponding JSX closing tag for '{0}'."),
        JSX_attribute_expected: diag(17003, ts2.DiagnosticCategory.Error, "JSX_attribute_expected_17003", "JSX attribute expected."),
        Cannot_use_JSX_unless_the_jsx_flag_is_provided: diag(17004, ts2.DiagnosticCategory.Error, "Cannot_use_JSX_unless_the_jsx_flag_is_provided_17004", "Cannot use JSX unless the '--jsx' flag is provided."),
        A_constructor_cannot_contain_a_super_call_when_its_class_extends_null: diag(17005, ts2.DiagnosticCategory.Error, "A_constructor_cannot_contain_a_super_call_when_its_class_extends_null_17005", "A constructor cannot contain a 'super' call when its class extends 'null'."),
        An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses: diag(17006, ts2.DiagnosticCategory.Error, "An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_ex_17006", "An unary expression with the '{0}' operator is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."),
        A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses: diag(17007, ts2.DiagnosticCategory.Error, "A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Con_17007", "A type assertion expression is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."),
        JSX_element_0_has_no_corresponding_closing_tag: diag(17008, ts2.DiagnosticCategory.Error, "JSX_element_0_has_no_corresponding_closing_tag_17008", "JSX element '{0}' has no corresponding closing tag."),
        super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class: diag(17009, ts2.DiagnosticCategory.Error, "super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class_17009", "'super' must be called before accessing 'this' in the constructor of a derived class."),
        Unknown_type_acquisition_option_0: diag(17010, ts2.DiagnosticCategory.Error, "Unknown_type_acquisition_option_0_17010", "Unknown type acquisition option '{0}'."),
        super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class: diag(17011, ts2.DiagnosticCategory.Error, "super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class_17011", "'super' must be called before accessing a property of 'super' in the constructor of a derived class."),
        _0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2: diag(17012, ts2.DiagnosticCategory.Error, "_0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2_17012", "'{0}' is not a valid meta-property for keyword '{1}'. Did you mean '{2}'?"),
        Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constructor: diag(17013, ts2.DiagnosticCategory.Error, "Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constru_17013", "Meta-property '{0}' is only allowed in the body of a function declaration, function expression, or constructor."),
        JSX_fragment_has_no_corresponding_closing_tag: diag(17014, ts2.DiagnosticCategory.Error, "JSX_fragment_has_no_corresponding_closing_tag_17014", "JSX fragment has no corresponding closing tag."),
        Expected_corresponding_closing_tag_for_JSX_fragment: diag(17015, ts2.DiagnosticCategory.Error, "Expected_corresponding_closing_tag_for_JSX_fragment_17015", "Expected corresponding closing tag for JSX fragment."),
        JSX_fragment_is_not_supported_when_using_jsxFactory: diag(17016, ts2.DiagnosticCategory.Error, "JSX_fragment_is_not_supported_when_using_jsxFactory_17016", "JSX fragment is not supported when using --jsxFactory"),
        JSX_fragment_is_not_supported_when_using_an_inline_JSX_factory_pragma: diag(17017, ts2.DiagnosticCategory.Error, "JSX_fragment_is_not_supported_when_using_an_inline_JSX_factory_pragma_17017", "JSX fragment is not supported when using an inline JSX factory pragma"),
        Unknown_type_acquisition_option_0_Did_you_mean_1: diag(17018, ts2.DiagnosticCategory.Error, "Unknown_type_acquisition_option_0_Did_you_mean_1_17018", "Unknown type acquisition option '{0}'. Did you mean '{1}'?"),
        Circularity_detected_while_resolving_configuration_Colon_0: diag(18e3, ts2.DiagnosticCategory.Error, "Circularity_detected_while_resolving_configuration_Colon_0_18000", "Circularity detected while resolving configuration: {0}"),
        A_path_in_an_extends_option_must_be_relative_or_rooted_but_0_is_not: diag(18001, ts2.DiagnosticCategory.Error, "A_path_in_an_extends_option_must_be_relative_or_rooted_but_0_is_not_18001", "A path in an 'extends' option must be relative or rooted, but '{0}' is not."),
        The_files_list_in_config_file_0_is_empty: diag(18002, ts2.DiagnosticCategory.Error, "The_files_list_in_config_file_0_is_empty_18002", "The 'files' list in config file '{0}' is empty."),
        No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2: diag(18003, ts2.DiagnosticCategory.Error, "No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2_18003", "No inputs were found in config file '{0}'. Specified 'include' paths were '{1}' and 'exclude' paths were '{2}'."),
        File_is_a_CommonJS_module_it_may_be_converted_to_an_ES6_module: diag(80001, ts2.DiagnosticCategory.Suggestion, "File_is_a_CommonJS_module_it_may_be_converted_to_an_ES6_module_80001", "File is a CommonJS module; it may be converted to an ES6 module."),
        This_constructor_function_may_be_converted_to_a_class_declaration: diag(80002, ts2.DiagnosticCategory.Suggestion, "This_constructor_function_may_be_converted_to_a_class_declaration_80002", "This constructor function may be converted to a class declaration."),
        Import_may_be_converted_to_a_default_import: diag(80003, ts2.DiagnosticCategory.Suggestion, "Import_may_be_converted_to_a_default_import_80003", "Import may be converted to a default import."),
        JSDoc_types_may_be_moved_to_TypeScript_types: diag(80004, ts2.DiagnosticCategory.Suggestion, "JSDoc_types_may_be_moved_to_TypeScript_types_80004", "JSDoc types may be moved to TypeScript types."),
        require_call_may_be_converted_to_an_import: diag(80005, ts2.DiagnosticCategory.Suggestion, "require_call_may_be_converted_to_an_import_80005", "'require' call may be converted to an import."),
        This_may_be_converted_to_an_async_function: diag(80006, ts2.DiagnosticCategory.Suggestion, "This_may_be_converted_to_an_async_function_80006", "This may be converted to an async function."),
        await_has_no_effect_on_the_type_of_this_expression: diag(80007, ts2.DiagnosticCategory.Suggestion, "await_has_no_effect_on_the_type_of_this_expression_80007", "'await' has no effect on the type of this expression."),
        Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers: diag(80008, ts2.DiagnosticCategory.Suggestion, "Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accur_80008", "Numeric literals with absolute values equal to 2^53 or greater are too large to be represented accurately as integers."),
        Add_missing_super_call: diag(90001, ts2.DiagnosticCategory.Message, "Add_missing_super_call_90001", "Add missing 'super()' call"),
        Make_super_call_the_first_statement_in_the_constructor: diag(90002, ts2.DiagnosticCategory.Message, "Make_super_call_the_first_statement_in_the_constructor_90002", "Make 'super()' call the first statement in the constructor"),
        Change_extends_to_implements: diag(90003, ts2.DiagnosticCategory.Message, "Change_extends_to_implements_90003", "Change 'extends' to 'implements'"),
        Remove_unused_declaration_for_Colon_0: diag(90004, ts2.DiagnosticCategory.Message, "Remove_unused_declaration_for_Colon_0_90004", "Remove unused declaration for: '{0}'"),
        Remove_import_from_0: diag(90005, ts2.DiagnosticCategory.Message, "Remove_import_from_0_90005", "Remove import from '{0}'"),
        Implement_interface_0: diag(90006, ts2.DiagnosticCategory.Message, "Implement_interface_0_90006", "Implement interface '{0}'"),
        Implement_inherited_abstract_class: diag(90007, ts2.DiagnosticCategory.Message, "Implement_inherited_abstract_class_90007", "Implement inherited abstract class"),
        Add_0_to_unresolved_variable: diag(90008, ts2.DiagnosticCategory.Message, "Add_0_to_unresolved_variable_90008", "Add '{0}.' to unresolved variable"),
        Remove_destructuring: diag(90009, ts2.DiagnosticCategory.Message, "Remove_destructuring_90009", "Remove destructuring"),
        Remove_variable_statement: diag(90010, ts2.DiagnosticCategory.Message, "Remove_variable_statement_90010", "Remove variable statement"),
        Remove_template_tag: diag(90011, ts2.DiagnosticCategory.Message, "Remove_template_tag_90011", "Remove template tag"),
        Remove_type_parameters: diag(90012, ts2.DiagnosticCategory.Message, "Remove_type_parameters_90012", "Remove type parameters"),
        Import_0_from_module_1: diag(90013, ts2.DiagnosticCategory.Message, "Import_0_from_module_1_90013", `Import '{0}' from module "{1}"`),
        Change_0_to_1: diag(90014, ts2.DiagnosticCategory.Message, "Change_0_to_1_90014", "Change '{0}' to '{1}'"),
        Add_0_to_existing_import_declaration_from_1: diag(90015, ts2.DiagnosticCategory.Message, "Add_0_to_existing_import_declaration_from_1_90015", `Add '{0}' to existing import declaration from "{1}"`),
        Declare_property_0: diag(90016, ts2.DiagnosticCategory.Message, "Declare_property_0_90016", "Declare property '{0}'"),
        Add_index_signature_for_property_0: diag(90017, ts2.DiagnosticCategory.Message, "Add_index_signature_for_property_0_90017", "Add index signature for property '{0}'"),
        Disable_checking_for_this_file: diag(90018, ts2.DiagnosticCategory.Message, "Disable_checking_for_this_file_90018", "Disable checking for this file"),
        Ignore_this_error_message: diag(90019, ts2.DiagnosticCategory.Message, "Ignore_this_error_message_90019", "Ignore this error message"),
        Initialize_property_0_in_the_constructor: diag(90020, ts2.DiagnosticCategory.Message, "Initialize_property_0_in_the_constructor_90020", "Initialize property '{0}' in the constructor"),
        Initialize_static_property_0: diag(90021, ts2.DiagnosticCategory.Message, "Initialize_static_property_0_90021", "Initialize static property '{0}'"),
        Change_spelling_to_0: diag(90022, ts2.DiagnosticCategory.Message, "Change_spelling_to_0_90022", "Change spelling to '{0}'"),
        Declare_method_0: diag(90023, ts2.DiagnosticCategory.Message, "Declare_method_0_90023", "Declare method '{0}'"),
        Declare_static_method_0: diag(90024, ts2.DiagnosticCategory.Message, "Declare_static_method_0_90024", "Declare static method '{0}'"),
        Prefix_0_with_an_underscore: diag(90025, ts2.DiagnosticCategory.Message, "Prefix_0_with_an_underscore_90025", "Prefix '{0}' with an underscore"),
        Rewrite_as_the_indexed_access_type_0: diag(90026, ts2.DiagnosticCategory.Message, "Rewrite_as_the_indexed_access_type_0_90026", "Rewrite as the indexed access type '{0}'"),
        Declare_static_property_0: diag(90027, ts2.DiagnosticCategory.Message, "Declare_static_property_0_90027", "Declare static property '{0}'"),
        Call_decorator_expression: diag(90028, ts2.DiagnosticCategory.Message, "Call_decorator_expression_90028", "Call decorator expression"),
        Add_async_modifier_to_containing_function: diag(90029, ts2.DiagnosticCategory.Message, "Add_async_modifier_to_containing_function_90029", "Add async modifier to containing function"),
        Replace_infer_0_with_unknown: diag(90030, ts2.DiagnosticCategory.Message, "Replace_infer_0_with_unknown_90030", "Replace 'infer {0}' with 'unknown'"),
        Replace_all_unused_infer_with_unknown: diag(90031, ts2.DiagnosticCategory.Message, "Replace_all_unused_infer_with_unknown_90031", "Replace all unused 'infer' with 'unknown'"),
        Import_default_0_from_module_1: diag(90032, ts2.DiagnosticCategory.Message, "Import_default_0_from_module_1_90032", `Import default '{0}' from module "{1}"`),
        Add_default_import_0_to_existing_import_declaration_from_1: diag(90033, ts2.DiagnosticCategory.Message, "Add_default_import_0_to_existing_import_declaration_from_1_90033", `Add default import '{0}' to existing import declaration from "{1}"`),
        Add_parameter_name: diag(90034, ts2.DiagnosticCategory.Message, "Add_parameter_name_90034", "Add parameter name"),
        Declare_private_property_0: diag(90035, ts2.DiagnosticCategory.Message, "Declare_private_property_0_90035", "Declare private property '{0}'"),
        Declare_a_private_field_named_0: diag(90053, ts2.DiagnosticCategory.Message, "Declare_a_private_field_named_0_90053", "Declare a private field named '{0}'."),
        Convert_function_to_an_ES2015_class: diag(95001, ts2.DiagnosticCategory.Message, "Convert_function_to_an_ES2015_class_95001", "Convert function to an ES2015 class"),
        Convert_function_0_to_class: diag(95002, ts2.DiagnosticCategory.Message, "Convert_function_0_to_class_95002", "Convert function '{0}' to class"),
        Extract_to_0_in_1: diag(95004, ts2.DiagnosticCategory.Message, "Extract_to_0_in_1_95004", "Extract to {0} in {1}"),
        Extract_function: diag(95005, ts2.DiagnosticCategory.Message, "Extract_function_95005", "Extract function"),
        Extract_constant: diag(95006, ts2.DiagnosticCategory.Message, "Extract_constant_95006", "Extract constant"),
        Extract_to_0_in_enclosing_scope: diag(95007, ts2.DiagnosticCategory.Message, "Extract_to_0_in_enclosing_scope_95007", "Extract to {0} in enclosing scope"),
        Extract_to_0_in_1_scope: diag(95008, ts2.DiagnosticCategory.Message, "Extract_to_0_in_1_scope_95008", "Extract to {0} in {1} scope"),
        Annotate_with_type_from_JSDoc: diag(95009, ts2.DiagnosticCategory.Message, "Annotate_with_type_from_JSDoc_95009", "Annotate with type from JSDoc"),
        Annotate_with_types_from_JSDoc: diag(95010, ts2.DiagnosticCategory.Message, "Annotate_with_types_from_JSDoc_95010", "Annotate with types from JSDoc"),
        Infer_type_of_0_from_usage: diag(95011, ts2.DiagnosticCategory.Message, "Infer_type_of_0_from_usage_95011", "Infer type of '{0}' from usage"),
        Infer_parameter_types_from_usage: diag(95012, ts2.DiagnosticCategory.Message, "Infer_parameter_types_from_usage_95012", "Infer parameter types from usage"),
        Convert_to_default_import: diag(95013, ts2.DiagnosticCategory.Message, "Convert_to_default_import_95013", "Convert to default import"),
        Install_0: diag(95014, ts2.DiagnosticCategory.Message, "Install_0_95014", "Install '{0}'"),
        Replace_import_with_0: diag(95015, ts2.DiagnosticCategory.Message, "Replace_import_with_0_95015", "Replace import with '{0}'."),
        Use_synthetic_default_member: diag(95016, ts2.DiagnosticCategory.Message, "Use_synthetic_default_member_95016", "Use synthetic 'default' member."),
        Convert_to_ES6_module: diag(95017, ts2.DiagnosticCategory.Message, "Convert_to_ES6_module_95017", "Convert to ES6 module"),
        Add_undefined_type_to_property_0: diag(95018, ts2.DiagnosticCategory.Message, "Add_undefined_type_to_property_0_95018", "Add 'undefined' type to property '{0}'"),
        Add_initializer_to_property_0: diag(95019, ts2.DiagnosticCategory.Message, "Add_initializer_to_property_0_95019", "Add initializer to property '{0}'"),
        Add_definite_assignment_assertion_to_property_0: diag(95020, ts2.DiagnosticCategory.Message, "Add_definite_assignment_assertion_to_property_0_95020", "Add definite assignment assertion to property '{0}'"),
        Add_all_missing_members: diag(95022, ts2.DiagnosticCategory.Message, "Add_all_missing_members_95022", "Add all missing members"),
        Infer_all_types_from_usage: diag(95023, ts2.DiagnosticCategory.Message, "Infer_all_types_from_usage_95023", "Infer all types from usage"),
        Delete_all_unused_declarations: diag(95024, ts2.DiagnosticCategory.Message, "Delete_all_unused_declarations_95024", "Delete all unused declarations"),
        Prefix_all_unused_declarations_with_where_possible: diag(95025, ts2.DiagnosticCategory.Message, "Prefix_all_unused_declarations_with_where_possible_95025", "Prefix all unused declarations with '_' where possible"),
        Fix_all_detected_spelling_errors: diag(95026, ts2.DiagnosticCategory.Message, "Fix_all_detected_spelling_errors_95026", "Fix all detected spelling errors"),
        Add_initializers_to_all_uninitialized_properties: diag(95027, ts2.DiagnosticCategory.Message, "Add_initializers_to_all_uninitialized_properties_95027", "Add initializers to all uninitialized properties"),
        Add_definite_assignment_assertions_to_all_uninitialized_properties: diag(95028, ts2.DiagnosticCategory.Message, "Add_definite_assignment_assertions_to_all_uninitialized_properties_95028", "Add definite assignment assertions to all uninitialized properties"),
        Add_undefined_type_to_all_uninitialized_properties: diag(95029, ts2.DiagnosticCategory.Message, "Add_undefined_type_to_all_uninitialized_properties_95029", "Add undefined type to all uninitialized properties"),
        Change_all_jsdoc_style_types_to_TypeScript: diag(95030, ts2.DiagnosticCategory.Message, "Change_all_jsdoc_style_types_to_TypeScript_95030", "Change all jsdoc-style types to TypeScript"),
        Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types: diag(95031, ts2.DiagnosticCategory.Message, "Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types_95031", "Change all jsdoc-style types to TypeScript (and add '| undefined' to nullable types)"),
        Implement_all_unimplemented_interfaces: diag(95032, ts2.DiagnosticCategory.Message, "Implement_all_unimplemented_interfaces_95032", "Implement all unimplemented interfaces"),
        Install_all_missing_types_packages: diag(95033, ts2.DiagnosticCategory.Message, "Install_all_missing_types_packages_95033", "Install all missing types packages"),
        Rewrite_all_as_indexed_access_types: diag(95034, ts2.DiagnosticCategory.Message, "Rewrite_all_as_indexed_access_types_95034", "Rewrite all as indexed access types"),
        Convert_all_to_default_imports: diag(95035, ts2.DiagnosticCategory.Message, "Convert_all_to_default_imports_95035", "Convert all to default imports"),
        Make_all_super_calls_the_first_statement_in_their_constructor: diag(95036, ts2.DiagnosticCategory.Message, "Make_all_super_calls_the_first_statement_in_their_constructor_95036", "Make all 'super()' calls the first statement in their constructor"),
        Add_qualifier_to_all_unresolved_variables_matching_a_member_name: diag(95037, ts2.DiagnosticCategory.Message, "Add_qualifier_to_all_unresolved_variables_matching_a_member_name_95037", "Add qualifier to all unresolved variables matching a member name"),
        Change_all_extended_interfaces_to_implements: diag(95038, ts2.DiagnosticCategory.Message, "Change_all_extended_interfaces_to_implements_95038", "Change all extended interfaces to 'implements'"),
        Add_all_missing_super_calls: diag(95039, ts2.DiagnosticCategory.Message, "Add_all_missing_super_calls_95039", "Add all missing super calls"),
        Implement_all_inherited_abstract_classes: diag(95040, ts2.DiagnosticCategory.Message, "Implement_all_inherited_abstract_classes_95040", "Implement all inherited abstract classes"),
        Add_all_missing_async_modifiers: diag(95041, ts2.DiagnosticCategory.Message, "Add_all_missing_async_modifiers_95041", "Add all missing 'async' modifiers"),
        Add_ts_ignore_to_all_error_messages: diag(95042, ts2.DiagnosticCategory.Message, "Add_ts_ignore_to_all_error_messages_95042", "Add '@ts-ignore' to all error messages"),
        Annotate_everything_with_types_from_JSDoc: diag(95043, ts2.DiagnosticCategory.Message, "Annotate_everything_with_types_from_JSDoc_95043", "Annotate everything with types from JSDoc"),
        Add_to_all_uncalled_decorators: diag(95044, ts2.DiagnosticCategory.Message, "Add_to_all_uncalled_decorators_95044", "Add '()' to all uncalled decorators"),
        Convert_all_constructor_functions_to_classes: diag(95045, ts2.DiagnosticCategory.Message, "Convert_all_constructor_functions_to_classes_95045", "Convert all constructor functions to classes"),
        Generate_get_and_set_accessors: diag(95046, ts2.DiagnosticCategory.Message, "Generate_get_and_set_accessors_95046", "Generate 'get' and 'set' accessors"),
        Convert_require_to_import: diag(95047, ts2.DiagnosticCategory.Message, "Convert_require_to_import_95047", "Convert 'require' to 'import'"),
        Convert_all_require_to_import: diag(95048, ts2.DiagnosticCategory.Message, "Convert_all_require_to_import_95048", "Convert all 'require' to 'import'"),
        Move_to_a_new_file: diag(95049, ts2.DiagnosticCategory.Message, "Move_to_a_new_file_95049", "Move to a new file"),
        Remove_unreachable_code: diag(95050, ts2.DiagnosticCategory.Message, "Remove_unreachable_code_95050", "Remove unreachable code"),
        Remove_all_unreachable_code: diag(95051, ts2.DiagnosticCategory.Message, "Remove_all_unreachable_code_95051", "Remove all unreachable code"),
        Add_missing_typeof: diag(95052, ts2.DiagnosticCategory.Message, "Add_missing_typeof_95052", "Add missing 'typeof'"),
        Remove_unused_label: diag(95053, ts2.DiagnosticCategory.Message, "Remove_unused_label_95053", "Remove unused label"),
        Remove_all_unused_labels: diag(95054, ts2.DiagnosticCategory.Message, "Remove_all_unused_labels_95054", "Remove all unused labels"),
        Convert_0_to_mapped_object_type: diag(95055, ts2.DiagnosticCategory.Message, "Convert_0_to_mapped_object_type_95055", "Convert '{0}' to mapped object type"),
        Convert_namespace_import_to_named_imports: diag(95056, ts2.DiagnosticCategory.Message, "Convert_namespace_import_to_named_imports_95056", "Convert namespace import to named imports"),
        Convert_named_imports_to_namespace_import: diag(95057, ts2.DiagnosticCategory.Message, "Convert_named_imports_to_namespace_import_95057", "Convert named imports to namespace import"),
        Add_or_remove_braces_in_an_arrow_function: diag(95058, ts2.DiagnosticCategory.Message, "Add_or_remove_braces_in_an_arrow_function_95058", "Add or remove braces in an arrow function"),
        Add_braces_to_arrow_function: diag(95059, ts2.DiagnosticCategory.Message, "Add_braces_to_arrow_function_95059", "Add braces to arrow function"),
        Remove_braces_from_arrow_function: diag(95060, ts2.DiagnosticCategory.Message, "Remove_braces_from_arrow_function_95060", "Remove braces from arrow function"),
        Convert_default_export_to_named_export: diag(95061, ts2.DiagnosticCategory.Message, "Convert_default_export_to_named_export_95061", "Convert default export to named export"),
        Convert_named_export_to_default_export: diag(95062, ts2.DiagnosticCategory.Message, "Convert_named_export_to_default_export_95062", "Convert named export to default export"),
        Add_missing_enum_member_0: diag(95063, ts2.DiagnosticCategory.Message, "Add_missing_enum_member_0_95063", "Add missing enum member '{0}'"),
        Add_all_missing_imports: diag(95064, ts2.DiagnosticCategory.Message, "Add_all_missing_imports_95064", "Add all missing imports"),
        Convert_to_async_function: diag(95065, ts2.DiagnosticCategory.Message, "Convert_to_async_function_95065", "Convert to async function"),
        Convert_all_to_async_functions: diag(95066, ts2.DiagnosticCategory.Message, "Convert_all_to_async_functions_95066", "Convert all to async functions"),
        Add_missing_call_parentheses: diag(95067, ts2.DiagnosticCategory.Message, "Add_missing_call_parentheses_95067", "Add missing call parentheses"),
        Add_all_missing_call_parentheses: diag(95068, ts2.DiagnosticCategory.Message, "Add_all_missing_call_parentheses_95068", "Add all missing call parentheses"),
        Add_unknown_conversion_for_non_overlapping_types: diag(95069, ts2.DiagnosticCategory.Message, "Add_unknown_conversion_for_non_overlapping_types_95069", "Add 'unknown' conversion for non-overlapping types"),
        Add_unknown_to_all_conversions_of_non_overlapping_types: diag(95070, ts2.DiagnosticCategory.Message, "Add_unknown_to_all_conversions_of_non_overlapping_types_95070", "Add 'unknown' to all conversions of non-overlapping types"),
        Add_missing_new_operator_to_call: diag(95071, ts2.DiagnosticCategory.Message, "Add_missing_new_operator_to_call_95071", "Add missing 'new' operator to call"),
        Add_missing_new_operator_to_all_calls: diag(95072, ts2.DiagnosticCategory.Message, "Add_missing_new_operator_to_all_calls_95072", "Add missing 'new' operator to all calls"),
        Add_names_to_all_parameters_without_names: diag(95073, ts2.DiagnosticCategory.Message, "Add_names_to_all_parameters_without_names_95073", "Add names to all parameters without names"),
        Enable_the_experimentalDecorators_option_in_your_configuration_file: diag(95074, ts2.DiagnosticCategory.Message, "Enable_the_experimentalDecorators_option_in_your_configuration_file_95074", "Enable the 'experimentalDecorators' option in your configuration file"),
        Convert_parameters_to_destructured_object: diag(95075, ts2.DiagnosticCategory.Message, "Convert_parameters_to_destructured_object_95075", "Convert parameters to destructured object"),
        Allow_accessing_UMD_globals_from_modules: diag(95076, ts2.DiagnosticCategory.Message, "Allow_accessing_UMD_globals_from_modules_95076", "Allow accessing UMD globals from modules."),
        Extract_type: diag(95077, ts2.DiagnosticCategory.Message, "Extract_type_95077", "Extract type"),
        Extract_to_type_alias: diag(95078, ts2.DiagnosticCategory.Message, "Extract_to_type_alias_95078", "Extract to type alias"),
        Extract_to_typedef: diag(95079, ts2.DiagnosticCategory.Message, "Extract_to_typedef_95079", "Extract to typedef"),
        Infer_this_type_of_0_from_usage: diag(95080, ts2.DiagnosticCategory.Message, "Infer_this_type_of_0_from_usage_95080", "Infer 'this' type of '{0}' from usage"),
        Add_const_to_unresolved_variable: diag(95081, ts2.DiagnosticCategory.Message, "Add_const_to_unresolved_variable_95081", "Add 'const' to unresolved variable"),
        Add_const_to_all_unresolved_variables: diag(95082, ts2.DiagnosticCategory.Message, "Add_const_to_all_unresolved_variables_95082", "Add 'const' to all unresolved variables"),
        Add_await: diag(95083, ts2.DiagnosticCategory.Message, "Add_await_95083", "Add 'await'"),
        Add_await_to_initializer_for_0: diag(95084, ts2.DiagnosticCategory.Message, "Add_await_to_initializer_for_0_95084", "Add 'await' to initializer for '{0}'"),
        Fix_all_expressions_possibly_missing_await: diag(95085, ts2.DiagnosticCategory.Message, "Fix_all_expressions_possibly_missing_await_95085", "Fix all expressions possibly missing 'await'"),
        Remove_unnecessary_await: diag(95086, ts2.DiagnosticCategory.Message, "Remove_unnecessary_await_95086", "Remove unnecessary 'await'"),
        Remove_all_unnecessary_uses_of_await: diag(95087, ts2.DiagnosticCategory.Message, "Remove_all_unnecessary_uses_of_await_95087", "Remove all unnecessary uses of 'await'"),
        Enable_the_jsx_flag_in_your_configuration_file: diag(95088, ts2.DiagnosticCategory.Message, "Enable_the_jsx_flag_in_your_configuration_file_95088", "Enable the '--jsx' flag in your configuration file"),
        Add_await_to_initializers: diag(95089, ts2.DiagnosticCategory.Message, "Add_await_to_initializers_95089", "Add 'await' to initializers"),
        Extract_to_interface: diag(95090, ts2.DiagnosticCategory.Message, "Extract_to_interface_95090", "Extract to interface"),
        Convert_to_a_bigint_numeric_literal: diag(95091, ts2.DiagnosticCategory.Message, "Convert_to_a_bigint_numeric_literal_95091", "Convert to a bigint numeric literal"),
        Convert_all_to_bigint_numeric_literals: diag(95092, ts2.DiagnosticCategory.Message, "Convert_all_to_bigint_numeric_literals_95092", "Convert all to bigint numeric literals"),
        Convert_const_to_let: diag(95093, ts2.DiagnosticCategory.Message, "Convert_const_to_let_95093", "Convert 'const' to 'let'"),
        Prefix_with_declare: diag(95094, ts2.DiagnosticCategory.Message, "Prefix_with_declare_95094", "Prefix with 'declare'"),
        Prefix_all_incorrect_property_declarations_with_declare: diag(95095, ts2.DiagnosticCategory.Message, "Prefix_all_incorrect_property_declarations_with_declare_95095", "Prefix all incorrect property declarations with 'declare'"),
        Convert_to_template_string: diag(95096, ts2.DiagnosticCategory.Message, "Convert_to_template_string_95096", "Convert to template string"),
        Add_export_to_make_this_file_into_a_module: diag(95097, ts2.DiagnosticCategory.Message, "Add_export_to_make_this_file_into_a_module_95097", "Add 'export {}' to make this file into a module"),
        Set_the_target_option_in_your_configuration_file_to_0: diag(95098, ts2.DiagnosticCategory.Message, "Set_the_target_option_in_your_configuration_file_to_0_95098", "Set the 'target' option in your configuration file to '{0}'"),
        Set_the_module_option_in_your_configuration_file_to_0: diag(95099, ts2.DiagnosticCategory.Message, "Set_the_module_option_in_your_configuration_file_to_0_95099", "Set the 'module' option in your configuration file to '{0}'"),
        Convert_invalid_character_to_its_html_entity_code: diag(95100, ts2.DiagnosticCategory.Message, "Convert_invalid_character_to_its_html_entity_code_95100", "Convert invalid character to its html entity code"),
        Convert_all_invalid_characters_to_HTML_entity_code: diag(95101, ts2.DiagnosticCategory.Message, "Convert_all_invalid_characters_to_HTML_entity_code_95101", "Convert all invalid characters to HTML entity code"),
        Add_class_tag: diag(95102, ts2.DiagnosticCategory.Message, "Add_class_tag_95102", "Add '@class' tag"),
        Add_this_tag: diag(95103, ts2.DiagnosticCategory.Message, "Add_this_tag_95103", "Add '@this' tag"),
        Add_this_parameter: diag(95104, ts2.DiagnosticCategory.Message, "Add_this_parameter_95104", "Add 'this' parameter."),
        Convert_function_expression_0_to_arrow_function: diag(95105, ts2.DiagnosticCategory.Message, "Convert_function_expression_0_to_arrow_function_95105", "Convert function expression '{0}' to arrow function"),
        Convert_function_declaration_0_to_arrow_function: diag(95106, ts2.DiagnosticCategory.Message, "Convert_function_declaration_0_to_arrow_function_95106", "Convert function declaration '{0}' to arrow function"),
        Fix_all_implicit_this_errors: diag(95107, ts2.DiagnosticCategory.Message, "Fix_all_implicit_this_errors_95107", "Fix all implicit-'this' errors"),
        Wrap_invalid_character_in_an_expression_container: diag(95108, ts2.DiagnosticCategory.Message, "Wrap_invalid_character_in_an_expression_container_95108", "Wrap invalid character in an expression container"),
        Wrap_all_invalid_characters_in_an_expression_container: diag(95109, ts2.DiagnosticCategory.Message, "Wrap_all_invalid_characters_in_an_expression_container_95109", "Wrap all invalid characters in an expression container"),
        Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_json_to_read_more_about_this_file: diag(95110, ts2.DiagnosticCategory.Message, "Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_json_to_read_more_about_this_file_95110", "Visit https://aka.ms/tsconfig.json to read more about this file"),
        Add_a_return_statement: diag(95111, ts2.DiagnosticCategory.Message, "Add_a_return_statement_95111", "Add a return statement"),
        Remove_block_body_braces: diag(95112, ts2.DiagnosticCategory.Message, "Remove_block_body_braces_95112", "Remove block body braces"),
        Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal: diag(95113, ts2.DiagnosticCategory.Message, "Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal_95113", "Wrap the following body with parentheses which should be an object literal"),
        Add_all_missing_return_statement: diag(95114, ts2.DiagnosticCategory.Message, "Add_all_missing_return_statement_95114", "Add all missing return statement"),
        Remove_all_incorrect_body_block_braces: diag(95115, ts2.DiagnosticCategory.Message, "Remove_all_incorrect_body_block_braces_95115", "Remove all incorrect body block braces"),
        Wrap_all_object_literal_with_parentheses: diag(95116, ts2.DiagnosticCategory.Message, "Wrap_all_object_literal_with_parentheses_95116", "Wrap all object literal with parentheses"),
        No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer: diag(18004, ts2.DiagnosticCategory.Error, "No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer_18004", "No value exists in scope for the shorthand property '{0}'. Either declare one or provide an initializer."),
        Classes_may_not_have_a_field_named_constructor: diag(18006, ts2.DiagnosticCategory.Error, "Classes_may_not_have_a_field_named_constructor_18006", "Classes may not have a field named 'constructor'."),
        JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array: diag(18007, ts2.DiagnosticCategory.Error, "JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array_18007", "JSX expressions may not use the comma operator. Did you mean to write an array?"),
        Private_identifiers_cannot_be_used_as_parameters: diag(18009, ts2.DiagnosticCategory.Error, "Private_identifiers_cannot_be_used_as_parameters_18009", "Private identifiers cannot be used as parameters"),
        An_accessibility_modifier_cannot_be_used_with_a_private_identifier: diag(18010, ts2.DiagnosticCategory.Error, "An_accessibility_modifier_cannot_be_used_with_a_private_identifier_18010", "An accessibility modifier cannot be used with a private identifier."),
        The_operand_of_a_delete_operator_cannot_be_a_private_identifier: diag(18011, ts2.DiagnosticCategory.Error, "The_operand_of_a_delete_operator_cannot_be_a_private_identifier_18011", "The operand of a 'delete' operator cannot be a private identifier."),
        constructor_is_a_reserved_word: diag(18012, ts2.DiagnosticCategory.Error, "constructor_is_a_reserved_word_18012", "'#constructor' is a reserved word."),
        Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier: diag(18013, ts2.DiagnosticCategory.Error, "Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier_18013", "Property '{0}' is not accessible outside class '{1}' because it has a private identifier."),
        The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_private_identifier_with_the_same_spelling: diag(18014, ts2.DiagnosticCategory.Error, "The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_priv_18014", "The property '{0}' cannot be accessed on type '{1}' within this class because it is shadowed by another private identifier with the same spelling."),
        Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2: diag(18015, ts2.DiagnosticCategory.Error, "Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2_18015", "Property '{0}' in type '{1}' refers to a different member that cannot be accessed from within type '{2}'."),
        Private_identifiers_are_not_allowed_outside_class_bodies: diag(18016, ts2.DiagnosticCategory.Error, "Private_identifiers_are_not_allowed_outside_class_bodies_18016", "Private identifiers are not allowed outside class bodies."),
        The_shadowing_declaration_of_0_is_defined_here: diag(18017, ts2.DiagnosticCategory.Error, "The_shadowing_declaration_of_0_is_defined_here_18017", "The shadowing declaration of '{0}' is defined here"),
        The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here: diag(18018, ts2.DiagnosticCategory.Error, "The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here_18018", "The declaration of '{0}' that you probably intended to use is defined here"),
        _0_modifier_cannot_be_used_with_a_private_identifier: diag(18019, ts2.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_with_a_private_identifier_18019", "'{0}' modifier cannot be used with a private identifier"),
        A_method_cannot_be_named_with_a_private_identifier: diag(18022, ts2.DiagnosticCategory.Error, "A_method_cannot_be_named_with_a_private_identifier_18022", "A method cannot be named with a private identifier."),
        An_accessor_cannot_be_named_with_a_private_identifier: diag(18023, ts2.DiagnosticCategory.Error, "An_accessor_cannot_be_named_with_a_private_identifier_18023", "An accessor cannot be named with a private identifier."),
        An_enum_member_cannot_be_named_with_a_private_identifier: diag(18024, ts2.DiagnosticCategory.Error, "An_enum_member_cannot_be_named_with_a_private_identifier_18024", "An enum member cannot be named with a private identifier."),
        can_only_be_used_at_the_start_of_a_file: diag(18026, ts2.DiagnosticCategory.Error, "can_only_be_used_at_the_start_of_a_file_18026", "'#!' can only be used at the start of a file."),
        Compiler_reserves_name_0_when_emitting_private_identifier_downlevel: diag(18027, ts2.DiagnosticCategory.Error, "Compiler_reserves_name_0_when_emitting_private_identifier_downlevel_18027", "Compiler reserves name '{0}' when emitting private identifier downlevel."),
        Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher: diag(18028, ts2.DiagnosticCategory.Error, "Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher_18028", "Private identifiers are only available when targeting ECMAScript 2015 and higher."),
        Private_identifiers_are_not_allowed_in_variable_declarations: diag(18029, ts2.DiagnosticCategory.Error, "Private_identifiers_are_not_allowed_in_variable_declarations_18029", "Private identifiers are not allowed in variable declarations."),
        An_optional_chain_cannot_contain_private_identifiers: diag(18030, ts2.DiagnosticCategory.Error, "An_optional_chain_cannot_contain_private_identifiers_18030", "An optional chain cannot contain private identifiers."),
        The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituents: diag(18031, ts2.DiagnosticCategory.Error, "The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituent_18031", "The intersection '{0}' was reduced to 'never' because property '{1}' has conflicting types in some constituents."),
        The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_private_in_some: diag(18032, ts2.DiagnosticCategory.Error, "The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_pr_18032", "The intersection '{0}' was reduced to 'never' because property '{1}' exists in multiple constituents and is private in some."),
        Only_numeric_enums_can_have_computed_members_but_this_expression_has_type_0_If_you_do_not_need_exhaustiveness_checks_consider_using_an_object_literal_instead: diag(18033, ts2.DiagnosticCategory.Error, "Only_numeric_enums_can_have_computed_members_but_this_expression_has_type_0_If_you_do_not_need_exhau_18033", "Only numeric enums can have computed members, but this expression has type '{0}'. If you do not need exhaustiveness checks, consider using an object literal instead.")
      };
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var _a;
      function tokenIsIdentifierOrKeyword(token) {
        return token >= 75;
      }
      ts2.tokenIsIdentifierOrKeyword = tokenIsIdentifierOrKeyword;
      function tokenIsIdentifierOrKeywordOrGreaterThan(token) {
        return token === 31 || tokenIsIdentifierOrKeyword(token);
      }
      ts2.tokenIsIdentifierOrKeywordOrGreaterThan = tokenIsIdentifierOrKeywordOrGreaterThan;
      var textToKeywordObj = (_a = {
        abstract: 122,
        any: 125,
        as: 123,
        asserts: 124,
        bigint: 151,
        boolean: 128,
        break: 77,
        case: 78,
        catch: 79,
        class: 80,
        continue: 82,
        const: 81
      }, _a["constructor"] = 129, _a.debugger = 83, _a.declare = 130, _a.default = 84, _a.delete = 85, _a.do = 86, _a.else = 87, _a.enum = 88, _a.export = 89, _a.extends = 90, _a.false = 91, _a.finally = 92, _a.for = 93, _a.from = 149, _a.function = 94, _a.get = 131, _a.if = 95, _a.implements = 113, _a.import = 96, _a.in = 97, _a.infer = 132, _a.instanceof = 98, _a.interface = 114, _a.is = 133, _a.keyof = 134, _a.let = 115, _a.module = 135, _a.namespace = 136, _a.never = 137, _a.new = 99, _a.null = 100, _a.number = 140, _a.object = 141, _a.package = 116, _a.private = 117, _a.protected = 118, _a.public = 119, _a.readonly = 138, _a.require = 139, _a.global = 150, _a.return = 101, _a.set = 142, _a.static = 120, _a.string = 143, _a.super = 102, _a.switch = 103, _a.symbol = 144, _a.this = 104, _a.throw = 105, _a.true = 106, _a.try = 107, _a.type = 145, _a.typeof = 108, _a.undefined = 146, _a.unique = 147, _a.unknown = 148, _a.var = 109, _a.void = 110, _a.while = 111, _a.with = 112, _a.yield = 121, _a.async = 126, _a.await = 127, _a.of = 152, _a);
      var textToKeyword = ts2.createMapFromTemplate(textToKeywordObj);
      var textToToken = ts2.createMapFromTemplate(__assign(__assign({}, textToKeywordObj), { "{": 18, "}": 19, "(": 20, ")": 21, "[": 22, "]": 23, ".": 24, "...": 25, ";": 26, ",": 27, "<": 29, ">": 31, "<=": 32, ">=": 33, "==": 34, "!=": 35, "===": 36, "!==": 37, "=>": 38, "+": 39, "-": 40, "**": 42, "*": 41, "/": 43, "%": 44, "++": 45, "--": 46, "<<": 47, "</": 30, ">>": 48, ">>>": 49, "&": 50, "|": 51, "^": 52, "!": 53, "~": 54, "&&": 55, "||": 56, "?": 57, "??": 60, "?.": 28, ":": 58, "=": 62, "+=": 63, "-=": 64, "*=": 65, "**=": 66, "/=": 67, "%=": 68, "<<=": 69, ">>=": 70, ">>>=": 71, "&=": 72, "|=": 73, "^=": 74, "@": 59, "`": 61 }));
      var unicodeES3IdentifierStart = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 543, 546, 563, 592, 685, 688, 696, 699, 705, 720, 721, 736, 740, 750, 750, 890, 890, 902, 902, 904, 906, 908, 908, 910, 929, 931, 974, 976, 983, 986, 1011, 1024, 1153, 1164, 1220, 1223, 1224, 1227, 1228, 1232, 1269, 1272, 1273, 1329, 1366, 1369, 1369, 1377, 1415, 1488, 1514, 1520, 1522, 1569, 1594, 1600, 1610, 1649, 1747, 1749, 1749, 1765, 1766, 1786, 1788, 1808, 1808, 1810, 1836, 1920, 1957, 2309, 2361, 2365, 2365, 2384, 2384, 2392, 2401, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2524, 2525, 2527, 2529, 2544, 2545, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2649, 2652, 2654, 2654, 2674, 2676, 2693, 2699, 2701, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2749, 2749, 2768, 2768, 2784, 2784, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2870, 2873, 2877, 2877, 2908, 2909, 2911, 2913, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 2997, 2999, 3001, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3168, 3169, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3294, 3294, 3296, 3297, 3333, 3340, 3342, 3344, 3346, 3368, 3370, 3385, 3424, 3425, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3585, 3632, 3634, 3635, 3648, 3654, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3760, 3762, 3763, 3773, 3773, 3776, 3780, 3782, 3782, 3804, 3805, 3840, 3840, 3904, 3911, 3913, 3946, 3976, 3979, 4096, 4129, 4131, 4135, 4137, 4138, 4176, 4181, 4256, 4293, 4304, 4342, 4352, 4441, 4447, 4514, 4520, 4601, 4608, 4614, 4616, 4678, 4680, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4742, 4744, 4744, 4746, 4749, 4752, 4782, 4784, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4814, 4816, 4822, 4824, 4846, 4848, 4878, 4880, 4880, 4882, 4885, 4888, 4894, 4896, 4934, 4936, 4954, 5024, 5108, 5121, 5740, 5743, 5750, 5761, 5786, 5792, 5866, 6016, 6067, 6176, 6263, 6272, 6312, 7680, 7835, 7840, 7929, 7936, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8319, 8319, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8497, 8499, 8505, 8544, 8579, 12293, 12295, 12321, 12329, 12337, 12341, 12344, 12346, 12353, 12436, 12445, 12446, 12449, 12538, 12540, 12542, 12549, 12588, 12593, 12686, 12704, 12727, 13312, 19893, 19968, 40869, 40960, 42124, 44032, 55203, 63744, 64045, 64256, 64262, 64275, 64279, 64285, 64285, 64287, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65136, 65138, 65140, 65140, 65142, 65276, 65313, 65338, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500];
      var unicodeES3IdentifierPart = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 543, 546, 563, 592, 685, 688, 696, 699, 705, 720, 721, 736, 740, 750, 750, 768, 846, 864, 866, 890, 890, 902, 902, 904, 906, 908, 908, 910, 929, 931, 974, 976, 983, 986, 1011, 1024, 1153, 1155, 1158, 1164, 1220, 1223, 1224, 1227, 1228, 1232, 1269, 1272, 1273, 1329, 1366, 1369, 1369, 1377, 1415, 1425, 1441, 1443, 1465, 1467, 1469, 1471, 1471, 1473, 1474, 1476, 1476, 1488, 1514, 1520, 1522, 1569, 1594, 1600, 1621, 1632, 1641, 1648, 1747, 1749, 1756, 1759, 1768, 1770, 1773, 1776, 1788, 1808, 1836, 1840, 1866, 1920, 1968, 2305, 2307, 2309, 2361, 2364, 2381, 2384, 2388, 2392, 2403, 2406, 2415, 2433, 2435, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2492, 2492, 2494, 2500, 2503, 2504, 2507, 2509, 2519, 2519, 2524, 2525, 2527, 2531, 2534, 2545, 2562, 2562, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2620, 2620, 2622, 2626, 2631, 2632, 2635, 2637, 2649, 2652, 2654, 2654, 2662, 2676, 2689, 2691, 2693, 2699, 2701, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2748, 2757, 2759, 2761, 2763, 2765, 2768, 2768, 2784, 2784, 2790, 2799, 2817, 2819, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2870, 2873, 2876, 2883, 2887, 2888, 2891, 2893, 2902, 2903, 2908, 2909, 2911, 2913, 2918, 2927, 2946, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 2997, 2999, 3001, 3006, 3010, 3014, 3016, 3018, 3021, 3031, 3031, 3047, 3055, 3073, 3075, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3134, 3140, 3142, 3144, 3146, 3149, 3157, 3158, 3168, 3169, 3174, 3183, 3202, 3203, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3262, 3268, 3270, 3272, 3274, 3277, 3285, 3286, 3294, 3294, 3296, 3297, 3302, 3311, 3330, 3331, 3333, 3340, 3342, 3344, 3346, 3368, 3370, 3385, 3390, 3395, 3398, 3400, 3402, 3405, 3415, 3415, 3424, 3425, 3430, 3439, 3458, 3459, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3530, 3530, 3535, 3540, 3542, 3542, 3544, 3551, 3570, 3571, 3585, 3642, 3648, 3662, 3664, 3673, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3769, 3771, 3773, 3776, 3780, 3782, 3782, 3784, 3789, 3792, 3801, 3804, 3805, 3840, 3840, 3864, 3865, 3872, 3881, 3893, 3893, 3895, 3895, 3897, 3897, 3902, 3911, 3913, 3946, 3953, 3972, 3974, 3979, 3984, 3991, 3993, 4028, 4038, 4038, 4096, 4129, 4131, 4135, 4137, 4138, 4140, 4146, 4150, 4153, 4160, 4169, 4176, 4185, 4256, 4293, 4304, 4342, 4352, 4441, 4447, 4514, 4520, 4601, 4608, 4614, 4616, 4678, 4680, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4742, 4744, 4744, 4746, 4749, 4752, 4782, 4784, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4814, 4816, 4822, 4824, 4846, 4848, 4878, 4880, 4880, 4882, 4885, 4888, 4894, 4896, 4934, 4936, 4954, 4969, 4977, 5024, 5108, 5121, 5740, 5743, 5750, 5761, 5786, 5792, 5866, 6016, 6099, 6112, 6121, 6160, 6169, 6176, 6263, 6272, 6313, 7680, 7835, 7840, 7929, 7936, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8255, 8256, 8319, 8319, 8400, 8412, 8417, 8417, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8497, 8499, 8505, 8544, 8579, 12293, 12295, 12321, 12335, 12337, 12341, 12344, 12346, 12353, 12436, 12441, 12442, 12445, 12446, 12449, 12542, 12549, 12588, 12593, 12686, 12704, 12727, 13312, 19893, 19968, 40869, 40960, 42124, 44032, 55203, 63744, 64045, 64256, 64262, 64275, 64279, 64285, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65056, 65059, 65075, 65076, 65101, 65103, 65136, 65138, 65140, 65140, 65142, 65276, 65296, 65305, 65313, 65338, 65343, 65343, 65345, 65370, 65381, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500];
      var unicodeES5IdentifierStart = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 880, 884, 886, 887, 890, 893, 902, 902, 904, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1162, 1319, 1329, 1366, 1369, 1369, 1377, 1415, 1488, 1514, 1520, 1522, 1568, 1610, 1646, 1647, 1649, 1747, 1749, 1749, 1765, 1766, 1774, 1775, 1786, 1788, 1791, 1791, 1808, 1808, 1810, 1839, 1869, 1957, 1969, 1969, 1994, 2026, 2036, 2037, 2042, 2042, 2048, 2069, 2074, 2074, 2084, 2084, 2088, 2088, 2112, 2136, 2208, 2208, 2210, 2220, 2308, 2361, 2365, 2365, 2384, 2384, 2392, 2401, 2417, 2423, 2425, 2431, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2493, 2493, 2510, 2510, 2524, 2525, 2527, 2529, 2544, 2545, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2649, 2652, 2654, 2654, 2674, 2676, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2749, 2749, 2768, 2768, 2784, 2785, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2877, 2877, 2908, 2909, 2911, 2913, 2929, 2929, 2947, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3024, 3024, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3133, 3133, 3160, 3161, 3168, 3169, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3261, 3261, 3294, 3294, 3296, 3297, 3313, 3314, 3333, 3340, 3342, 3344, 3346, 3386, 3389, 3389, 3406, 3406, 3424, 3425, 3450, 3455, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3585, 3632, 3634, 3635, 3648, 3654, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3760, 3762, 3763, 3773, 3773, 3776, 3780, 3782, 3782, 3804, 3807, 3840, 3840, 3904, 3911, 3913, 3948, 3976, 3980, 4096, 4138, 4159, 4159, 4176, 4181, 4186, 4189, 4193, 4193, 4197, 4198, 4206, 4208, 4213, 4225, 4238, 4238, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4992, 5007, 5024, 5108, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5872, 5888, 5900, 5902, 5905, 5920, 5937, 5952, 5969, 5984, 5996, 5998, 6e3, 6016, 6067, 6103, 6103, 6108, 6108, 6176, 6263, 6272, 6312, 6314, 6314, 6320, 6389, 6400, 6428, 6480, 6509, 6512, 6516, 6528, 6571, 6593, 6599, 6656, 6678, 6688, 6740, 6823, 6823, 6917, 6963, 6981, 6987, 7043, 7072, 7086, 7087, 7098, 7141, 7168, 7203, 7245, 7247, 7258, 7293, 7401, 7404, 7406, 7409, 7413, 7414, 7424, 7615, 7680, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8305, 8305, 8319, 8319, 8336, 8348, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11502, 11506, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11648, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 11823, 11823, 12293, 12295, 12321, 12329, 12337, 12341, 12344, 12348, 12353, 12438, 12445, 12447, 12449, 12538, 12540, 12543, 12549, 12589, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40908, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42527, 42538, 42539, 42560, 42606, 42623, 42647, 42656, 42735, 42775, 42783, 42786, 42888, 42891, 42894, 42896, 42899, 42912, 42922, 43e3, 43009, 43011, 43013, 43015, 43018, 43020, 43042, 43072, 43123, 43138, 43187, 43250, 43255, 43259, 43259, 43274, 43301, 43312, 43334, 43360, 43388, 43396, 43442, 43471, 43471, 43520, 43560, 43584, 43586, 43588, 43595, 43616, 43638, 43642, 43642, 43648, 43695, 43697, 43697, 43701, 43702, 43705, 43709, 43712, 43712, 43714, 43714, 43739, 43741, 43744, 43754, 43762, 43764, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43968, 44002, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64285, 64287, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65136, 65140, 65142, 65276, 65313, 65338, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500];
      var unicodeES5IdentifierPart = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 768, 884, 886, 887, 890, 893, 902, 902, 904, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1155, 1159, 1162, 1319, 1329, 1366, 1369, 1369, 1377, 1415, 1425, 1469, 1471, 1471, 1473, 1474, 1476, 1477, 1479, 1479, 1488, 1514, 1520, 1522, 1552, 1562, 1568, 1641, 1646, 1747, 1749, 1756, 1759, 1768, 1770, 1788, 1791, 1791, 1808, 1866, 1869, 1969, 1984, 2037, 2042, 2042, 2048, 2093, 2112, 2139, 2208, 2208, 2210, 2220, 2276, 2302, 2304, 2403, 2406, 2415, 2417, 2423, 2425, 2431, 2433, 2435, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2492, 2500, 2503, 2504, 2507, 2510, 2519, 2519, 2524, 2525, 2527, 2531, 2534, 2545, 2561, 2563, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2620, 2620, 2622, 2626, 2631, 2632, 2635, 2637, 2641, 2641, 2649, 2652, 2654, 2654, 2662, 2677, 2689, 2691, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2748, 2757, 2759, 2761, 2763, 2765, 2768, 2768, 2784, 2787, 2790, 2799, 2817, 2819, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2876, 2884, 2887, 2888, 2891, 2893, 2902, 2903, 2908, 2909, 2911, 2915, 2918, 2927, 2929, 2929, 2946, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3006, 3010, 3014, 3016, 3018, 3021, 3024, 3024, 3031, 3031, 3046, 3055, 3073, 3075, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3133, 3140, 3142, 3144, 3146, 3149, 3157, 3158, 3160, 3161, 3168, 3171, 3174, 3183, 3202, 3203, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3260, 3268, 3270, 3272, 3274, 3277, 3285, 3286, 3294, 3294, 3296, 3299, 3302, 3311, 3313, 3314, 3330, 3331, 3333, 3340, 3342, 3344, 3346, 3386, 3389, 3396, 3398, 3400, 3402, 3406, 3415, 3415, 3424, 3427, 3430, 3439, 3450, 3455, 3458, 3459, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3530, 3530, 3535, 3540, 3542, 3542, 3544, 3551, 3570, 3571, 3585, 3642, 3648, 3662, 3664, 3673, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3769, 3771, 3773, 3776, 3780, 3782, 3782, 3784, 3789, 3792, 3801, 3804, 3807, 3840, 3840, 3864, 3865, 3872, 3881, 3893, 3893, 3895, 3895, 3897, 3897, 3902, 3911, 3913, 3948, 3953, 3972, 3974, 3991, 3993, 4028, 4038, 4038, 4096, 4169, 4176, 4253, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4957, 4959, 4992, 5007, 5024, 5108, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5872, 5888, 5900, 5902, 5908, 5920, 5940, 5952, 5971, 5984, 5996, 5998, 6e3, 6002, 6003, 6016, 6099, 6103, 6103, 6108, 6109, 6112, 6121, 6155, 6157, 6160, 6169, 6176, 6263, 6272, 6314, 6320, 6389, 6400, 6428, 6432, 6443, 6448, 6459, 6470, 6509, 6512, 6516, 6528, 6571, 6576, 6601, 6608, 6617, 6656, 6683, 6688, 6750, 6752, 6780, 6783, 6793, 6800, 6809, 6823, 6823, 6912, 6987, 6992, 7001, 7019, 7027, 7040, 7155, 7168, 7223, 7232, 7241, 7245, 7293, 7376, 7378, 7380, 7414, 7424, 7654, 7676, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8204, 8205, 8255, 8256, 8276, 8276, 8305, 8305, 8319, 8319, 8336, 8348, 8400, 8412, 8417, 8417, 8421, 8432, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11647, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 11744, 11775, 11823, 11823, 12293, 12295, 12321, 12335, 12337, 12341, 12344, 12348, 12353, 12438, 12441, 12442, 12445, 12447, 12449, 12538, 12540, 12543, 12549, 12589, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40908, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42539, 42560, 42607, 42612, 42621, 42623, 42647, 42655, 42737, 42775, 42783, 42786, 42888, 42891, 42894, 42896, 42899, 42912, 42922, 43e3, 43047, 43072, 43123, 43136, 43204, 43216, 43225, 43232, 43255, 43259, 43259, 43264, 43309, 43312, 43347, 43360, 43388, 43392, 43456, 43471, 43481, 43520, 43574, 43584, 43597, 43600, 43609, 43616, 43638, 43642, 43643, 43648, 43714, 43739, 43741, 43744, 43759, 43762, 43766, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43968, 44010, 44012, 44013, 44016, 44025, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65024, 65039, 65056, 65062, 65075, 65076, 65101, 65103, 65136, 65140, 65142, 65276, 65296, 65305, 65313, 65338, 65343, 65343, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500];
      var unicodeESNextIdentifierStart = [65, 90, 97, 122, 170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 880, 884, 886, 887, 890, 893, 895, 895, 902, 902, 904, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1162, 1327, 1329, 1366, 1369, 1369, 1376, 1416, 1488, 1514, 1519, 1522, 1568, 1610, 1646, 1647, 1649, 1747, 1749, 1749, 1765, 1766, 1774, 1775, 1786, 1788, 1791, 1791, 1808, 1808, 1810, 1839, 1869, 1957, 1969, 1969, 1994, 2026, 2036, 2037, 2042, 2042, 2048, 2069, 2074, 2074, 2084, 2084, 2088, 2088, 2112, 2136, 2144, 2154, 2208, 2228, 2230, 2237, 2308, 2361, 2365, 2365, 2384, 2384, 2392, 2401, 2417, 2432, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2493, 2493, 2510, 2510, 2524, 2525, 2527, 2529, 2544, 2545, 2556, 2556, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2649, 2652, 2654, 2654, 2674, 2676, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2749, 2749, 2768, 2768, 2784, 2785, 2809, 2809, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2877, 2877, 2908, 2909, 2911, 2913, 2929, 2929, 2947, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3024, 3024, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3129, 3133, 3133, 3160, 3162, 3168, 3169, 3200, 3200, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3261, 3261, 3294, 3294, 3296, 3297, 3313, 3314, 3333, 3340, 3342, 3344, 3346, 3386, 3389, 3389, 3406, 3406, 3412, 3414, 3423, 3425, 3450, 3455, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3585, 3632, 3634, 3635, 3648, 3654, 3713, 3714, 3716, 3716, 3718, 3722, 3724, 3747, 3749, 3749, 3751, 3760, 3762, 3763, 3773, 3773, 3776, 3780, 3782, 3782, 3804, 3807, 3840, 3840, 3904, 3911, 3913, 3948, 3976, 3980, 4096, 4138, 4159, 4159, 4176, 4181, 4186, 4189, 4193, 4193, 4197, 4198, 4206, 4208, 4213, 4225, 4238, 4238, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4992, 5007, 5024, 5109, 5112, 5117, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5880, 5888, 5900, 5902, 5905, 5920, 5937, 5952, 5969, 5984, 5996, 5998, 6e3, 6016, 6067, 6103, 6103, 6108, 6108, 6176, 6264, 6272, 6312, 6314, 6314, 6320, 6389, 6400, 6430, 6480, 6509, 6512, 6516, 6528, 6571, 6576, 6601, 6656, 6678, 6688, 6740, 6823, 6823, 6917, 6963, 6981, 6987, 7043, 7072, 7086, 7087, 7098, 7141, 7168, 7203, 7245, 7247, 7258, 7293, 7296, 7304, 7312, 7354, 7357, 7359, 7401, 7404, 7406, 7411, 7413, 7414, 7418, 7418, 7424, 7615, 7680, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8305, 8305, 8319, 8319, 8336, 8348, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8472, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11502, 11506, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11648, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 12293, 12295, 12321, 12329, 12337, 12341, 12344, 12348, 12353, 12438, 12443, 12447, 12449, 12538, 12540, 12543, 12549, 12591, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40943, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42527, 42538, 42539, 42560, 42606, 42623, 42653, 42656, 42735, 42775, 42783, 42786, 42888, 42891, 42943, 42946, 42950, 42999, 43009, 43011, 43013, 43015, 43018, 43020, 43042, 43072, 43123, 43138, 43187, 43250, 43255, 43259, 43259, 43261, 43262, 43274, 43301, 43312, 43334, 43360, 43388, 43396, 43442, 43471, 43471, 43488, 43492, 43494, 43503, 43514, 43518, 43520, 43560, 43584, 43586, 43588, 43595, 43616, 43638, 43642, 43642, 43646, 43695, 43697, 43697, 43701, 43702, 43705, 43709, 43712, 43712, 43714, 43714, 43739, 43741, 43744, 43754, 43762, 43764, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43824, 43866, 43868, 43879, 43888, 44002, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64285, 64287, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65136, 65140, 65142, 65276, 65313, 65338, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500, 65536, 65547, 65549, 65574, 65576, 65594, 65596, 65597, 65599, 65613, 65616, 65629, 65664, 65786, 65856, 65908, 66176, 66204, 66208, 66256, 66304, 66335, 66349, 66378, 66384, 66421, 66432, 66461, 66464, 66499, 66504, 66511, 66513, 66517, 66560, 66717, 66736, 66771, 66776, 66811, 66816, 66855, 66864, 66915, 67072, 67382, 67392, 67413, 67424, 67431, 67584, 67589, 67592, 67592, 67594, 67637, 67639, 67640, 67644, 67644, 67647, 67669, 67680, 67702, 67712, 67742, 67808, 67826, 67828, 67829, 67840, 67861, 67872, 67897, 67968, 68023, 68030, 68031, 68096, 68096, 68112, 68115, 68117, 68119, 68121, 68149, 68192, 68220, 68224, 68252, 68288, 68295, 68297, 68324, 68352, 68405, 68416, 68437, 68448, 68466, 68480, 68497, 68608, 68680, 68736, 68786, 68800, 68850, 68864, 68899, 69376, 69404, 69415, 69415, 69424, 69445, 69600, 69622, 69635, 69687, 69763, 69807, 69840, 69864, 69891, 69926, 69956, 69956, 69968, 70002, 70006, 70006, 70019, 70066, 70081, 70084, 70106, 70106, 70108, 70108, 70144, 70161, 70163, 70187, 70272, 70278, 70280, 70280, 70282, 70285, 70287, 70301, 70303, 70312, 70320, 70366, 70405, 70412, 70415, 70416, 70419, 70440, 70442, 70448, 70450, 70451, 70453, 70457, 70461, 70461, 70480, 70480, 70493, 70497, 70656, 70708, 70727, 70730, 70751, 70751, 70784, 70831, 70852, 70853, 70855, 70855, 71040, 71086, 71128, 71131, 71168, 71215, 71236, 71236, 71296, 71338, 71352, 71352, 71424, 71450, 71680, 71723, 71840, 71903, 71935, 71935, 72096, 72103, 72106, 72144, 72161, 72161, 72163, 72163, 72192, 72192, 72203, 72242, 72250, 72250, 72272, 72272, 72284, 72329, 72349, 72349, 72384, 72440, 72704, 72712, 72714, 72750, 72768, 72768, 72818, 72847, 72960, 72966, 72968, 72969, 72971, 73008, 73030, 73030, 73056, 73061, 73063, 73064, 73066, 73097, 73112, 73112, 73440, 73458, 73728, 74649, 74752, 74862, 74880, 75075, 77824, 78894, 82944, 83526, 92160, 92728, 92736, 92766, 92880, 92909, 92928, 92975, 92992, 92995, 93027, 93047, 93053, 93071, 93760, 93823, 93952, 94026, 94032, 94032, 94099, 94111, 94176, 94177, 94179, 94179, 94208, 100343, 100352, 101106, 110592, 110878, 110928, 110930, 110948, 110951, 110960, 111355, 113664, 113770, 113776, 113788, 113792, 113800, 113808, 113817, 119808, 119892, 119894, 119964, 119966, 119967, 119970, 119970, 119973, 119974, 119977, 119980, 119982, 119993, 119995, 119995, 119997, 120003, 120005, 120069, 120071, 120074, 120077, 120084, 120086, 120092, 120094, 120121, 120123, 120126, 120128, 120132, 120134, 120134, 120138, 120144, 120146, 120485, 120488, 120512, 120514, 120538, 120540, 120570, 120572, 120596, 120598, 120628, 120630, 120654, 120656, 120686, 120688, 120712, 120714, 120744, 120746, 120770, 120772, 120779, 123136, 123180, 123191, 123197, 123214, 123214, 123584, 123627, 124928, 125124, 125184, 125251, 125259, 125259, 126464, 126467, 126469, 126495, 126497, 126498, 126500, 126500, 126503, 126503, 126505, 126514, 126516, 126519, 126521, 126521, 126523, 126523, 126530, 126530, 126535, 126535, 126537, 126537, 126539, 126539, 126541, 126543, 126545, 126546, 126548, 126548, 126551, 126551, 126553, 126553, 126555, 126555, 126557, 126557, 126559, 126559, 126561, 126562, 126564, 126564, 126567, 126570, 126572, 126578, 126580, 126583, 126585, 126588, 126590, 126590, 126592, 126601, 126603, 126619, 126625, 126627, 126629, 126633, 126635, 126651, 131072, 173782, 173824, 177972, 177984, 178205, 178208, 183969, 183984, 191456, 194560, 195101];
      var unicodeESNextIdentifierPart = [48, 57, 65, 90, 95, 95, 97, 122, 170, 170, 181, 181, 183, 183, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 768, 884, 886, 887, 890, 893, 895, 895, 902, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1155, 1159, 1162, 1327, 1329, 1366, 1369, 1369, 1376, 1416, 1425, 1469, 1471, 1471, 1473, 1474, 1476, 1477, 1479, 1479, 1488, 1514, 1519, 1522, 1552, 1562, 1568, 1641, 1646, 1747, 1749, 1756, 1759, 1768, 1770, 1788, 1791, 1791, 1808, 1866, 1869, 1969, 1984, 2037, 2042, 2042, 2045, 2045, 2048, 2093, 2112, 2139, 2144, 2154, 2208, 2228, 2230, 2237, 2259, 2273, 2275, 2403, 2406, 2415, 2417, 2435, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2492, 2500, 2503, 2504, 2507, 2510, 2519, 2519, 2524, 2525, 2527, 2531, 2534, 2545, 2556, 2556, 2558, 2558, 2561, 2563, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2620, 2620, 2622, 2626, 2631, 2632, 2635, 2637, 2641, 2641, 2649, 2652, 2654, 2654, 2662, 2677, 2689, 2691, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2748, 2757, 2759, 2761, 2763, 2765, 2768, 2768, 2784, 2787, 2790, 2799, 2809, 2815, 2817, 2819, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2876, 2884, 2887, 2888, 2891, 2893, 2902, 2903, 2908, 2909, 2911, 2915, 2918, 2927, 2929, 2929, 2946, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3006, 3010, 3014, 3016, 3018, 3021, 3024, 3024, 3031, 3031, 3046, 3055, 3072, 3084, 3086, 3088, 3090, 3112, 3114, 3129, 3133, 3140, 3142, 3144, 3146, 3149, 3157, 3158, 3160, 3162, 3168, 3171, 3174, 3183, 3200, 3203, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3260, 3268, 3270, 3272, 3274, 3277, 3285, 3286, 3294, 3294, 3296, 3299, 3302, 3311, 3313, 3314, 3328, 3331, 3333, 3340, 3342, 3344, 3346, 3396, 3398, 3400, 3402, 3406, 3412, 3415, 3423, 3427, 3430, 3439, 3450, 3455, 3458, 3459, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3530, 3530, 3535, 3540, 3542, 3542, 3544, 3551, 3558, 3567, 3570, 3571, 3585, 3642, 3648, 3662, 3664, 3673, 3713, 3714, 3716, 3716, 3718, 3722, 3724, 3747, 3749, 3749, 3751, 3773, 3776, 3780, 3782, 3782, 3784, 3789, 3792, 3801, 3804, 3807, 3840, 3840, 3864, 3865, 3872, 3881, 3893, 3893, 3895, 3895, 3897, 3897, 3902, 3911, 3913, 3948, 3953, 3972, 3974, 3991, 3993, 4028, 4038, 4038, 4096, 4169, 4176, 4253, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4957, 4959, 4969, 4977, 4992, 5007, 5024, 5109, 5112, 5117, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5880, 5888, 5900, 5902, 5908, 5920, 5940, 5952, 5971, 5984, 5996, 5998, 6e3, 6002, 6003, 6016, 6099, 6103, 6103, 6108, 6109, 6112, 6121, 6155, 6157, 6160, 6169, 6176, 6264, 6272, 6314, 6320, 6389, 6400, 6430, 6432, 6443, 6448, 6459, 6470, 6509, 6512, 6516, 6528, 6571, 6576, 6601, 6608, 6618, 6656, 6683, 6688, 6750, 6752, 6780, 6783, 6793, 6800, 6809, 6823, 6823, 6832, 6845, 6912, 6987, 6992, 7001, 7019, 7027, 7040, 7155, 7168, 7223, 7232, 7241, 7245, 7293, 7296, 7304, 7312, 7354, 7357, 7359, 7376, 7378, 7380, 7418, 7424, 7673, 7675, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8255, 8256, 8276, 8276, 8305, 8305, 8319, 8319, 8336, 8348, 8400, 8412, 8417, 8417, 8421, 8432, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8472, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11647, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 11744, 11775, 12293, 12295, 12321, 12335, 12337, 12341, 12344, 12348, 12353, 12438, 12441, 12447, 12449, 12538, 12540, 12543, 12549, 12591, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40943, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42539, 42560, 42607, 42612, 42621, 42623, 42737, 42775, 42783, 42786, 42888, 42891, 42943, 42946, 42950, 42999, 43047, 43072, 43123, 43136, 43205, 43216, 43225, 43232, 43255, 43259, 43259, 43261, 43309, 43312, 43347, 43360, 43388, 43392, 43456, 43471, 43481, 43488, 43518, 43520, 43574, 43584, 43597, 43600, 43609, 43616, 43638, 43642, 43714, 43739, 43741, 43744, 43759, 43762, 43766, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43824, 43866, 43868, 43879, 43888, 44010, 44012, 44013, 44016, 44025, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65024, 65039, 65056, 65071, 65075, 65076, 65101, 65103, 65136, 65140, 65142, 65276, 65296, 65305, 65313, 65338, 65343, 65343, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500, 65536, 65547, 65549, 65574, 65576, 65594, 65596, 65597, 65599, 65613, 65616, 65629, 65664, 65786, 65856, 65908, 66045, 66045, 66176, 66204, 66208, 66256, 66272, 66272, 66304, 66335, 66349, 66378, 66384, 66426, 66432, 66461, 66464, 66499, 66504, 66511, 66513, 66517, 66560, 66717, 66720, 66729, 66736, 66771, 66776, 66811, 66816, 66855, 66864, 66915, 67072, 67382, 67392, 67413, 67424, 67431, 67584, 67589, 67592, 67592, 67594, 67637, 67639, 67640, 67644, 67644, 67647, 67669, 67680, 67702, 67712, 67742, 67808, 67826, 67828, 67829, 67840, 67861, 67872, 67897, 67968, 68023, 68030, 68031, 68096, 68099, 68101, 68102, 68108, 68115, 68117, 68119, 68121, 68149, 68152, 68154, 68159, 68159, 68192, 68220, 68224, 68252, 68288, 68295, 68297, 68326, 68352, 68405, 68416, 68437, 68448, 68466, 68480, 68497, 68608, 68680, 68736, 68786, 68800, 68850, 68864, 68903, 68912, 68921, 69376, 69404, 69415, 69415, 69424, 69456, 69600, 69622, 69632, 69702, 69734, 69743, 69759, 69818, 69840, 69864, 69872, 69881, 69888, 69940, 69942, 69951, 69956, 69958, 69968, 70003, 70006, 70006, 70016, 70084, 70089, 70092, 70096, 70106, 70108, 70108, 70144, 70161, 70163, 70199, 70206, 70206, 70272, 70278, 70280, 70280, 70282, 70285, 70287, 70301, 70303, 70312, 70320, 70378, 70384, 70393, 70400, 70403, 70405, 70412, 70415, 70416, 70419, 70440, 70442, 70448, 70450, 70451, 70453, 70457, 70459, 70468, 70471, 70472, 70475, 70477, 70480, 70480, 70487, 70487, 70493, 70499, 70502, 70508, 70512, 70516, 70656, 70730, 70736, 70745, 70750, 70751, 70784, 70853, 70855, 70855, 70864, 70873, 71040, 71093, 71096, 71104, 71128, 71133, 71168, 71232, 71236, 71236, 71248, 71257, 71296, 71352, 71360, 71369, 71424, 71450, 71453, 71467, 71472, 71481, 71680, 71738, 71840, 71913, 71935, 71935, 72096, 72103, 72106, 72151, 72154, 72161, 72163, 72164, 72192, 72254, 72263, 72263, 72272, 72345, 72349, 72349, 72384, 72440, 72704, 72712, 72714, 72758, 72760, 72768, 72784, 72793, 72818, 72847, 72850, 72871, 72873, 72886, 72960, 72966, 72968, 72969, 72971, 73014, 73018, 73018, 73020, 73021, 73023, 73031, 73040, 73049, 73056, 73061, 73063, 73064, 73066, 73102, 73104, 73105, 73107, 73112, 73120, 73129, 73440, 73462, 73728, 74649, 74752, 74862, 74880, 75075, 77824, 78894, 82944, 83526, 92160, 92728, 92736, 92766, 92768, 92777, 92880, 92909, 92912, 92916, 92928, 92982, 92992, 92995, 93008, 93017, 93027, 93047, 93053, 93071, 93760, 93823, 93952, 94026, 94031, 94087, 94095, 94111, 94176, 94177, 94179, 94179, 94208, 100343, 100352, 101106, 110592, 110878, 110928, 110930, 110948, 110951, 110960, 111355, 113664, 113770, 113776, 113788, 113792, 113800, 113808, 113817, 113821, 113822, 119141, 119145, 119149, 119154, 119163, 119170, 119173, 119179, 119210, 119213, 119362, 119364, 119808, 119892, 119894, 119964, 119966, 119967, 119970, 119970, 119973, 119974, 119977, 119980, 119982, 119993, 119995, 119995, 119997, 120003, 120005, 120069, 120071, 120074, 120077, 120084, 120086, 120092, 120094, 120121, 120123, 120126, 120128, 120132, 120134, 120134, 120138, 120144, 120146, 120485, 120488, 120512, 120514, 120538, 120540, 120570, 120572, 120596, 120598, 120628, 120630, 120654, 120656, 120686, 120688, 120712, 120714, 120744, 120746, 120770, 120772, 120779, 120782, 120831, 121344, 121398, 121403, 121452, 121461, 121461, 121476, 121476, 121499, 121503, 121505, 121519, 122880, 122886, 122888, 122904, 122907, 122913, 122915, 122916, 122918, 122922, 123136, 123180, 123184, 123197, 123200, 123209, 123214, 123214, 123584, 123641, 124928, 125124, 125136, 125142, 125184, 125259, 125264, 125273, 126464, 126467, 126469, 126495, 126497, 126498, 126500, 126500, 126503, 126503, 126505, 126514, 126516, 126519, 126521, 126521, 126523, 126523, 126530, 126530, 126535, 126535, 126537, 126537, 126539, 126539, 126541, 126543, 126545, 126546, 126548, 126548, 126551, 126551, 126553, 126553, 126555, 126555, 126557, 126557, 126559, 126559, 126561, 126562, 126564, 126564, 126567, 126570, 126572, 126578, 126580, 126583, 126585, 126588, 126590, 126590, 126592, 126601, 126603, 126619, 126625, 126627, 126629, 126633, 126635, 126651, 131072, 173782, 173824, 177972, 177984, 178205, 178208, 183969, 183984, 191456, 194560, 195101, 917760, 917999];
      var commentDirectiveRegExSingleLine = /^\s*\/\/\/?\s*@(ts-expect-error|ts-ignore)/;
      var commentDirectiveRegExMultiLine = /^\s*(?:\/|\*)*\s*@(ts-expect-error|ts-ignore)/;
      function lookupInUnicodeMap(code, map) {
        if (code < map[0]) {
          return false;
        }
        var lo = 0;
        var hi = map.length;
        var mid;
        while (lo + 1 < hi) {
          mid = lo + (hi - lo) / 2;
          mid -= mid % 2;
          if (map[mid] <= code && code <= map[mid + 1]) {
            return true;
          }
          if (code < map[mid]) {
            hi = mid;
          } else {
            lo = mid + 2;
          }
        }
        return false;
      }
      function isUnicodeIdentifierStart(code, languageVersion) {
        return languageVersion >= 2 ? lookupInUnicodeMap(code, unicodeESNextIdentifierStart) : languageVersion === 1 ? lookupInUnicodeMap(code, unicodeES5IdentifierStart) : lookupInUnicodeMap(code, unicodeES3IdentifierStart);
      }
      ts2.isUnicodeIdentifierStart = isUnicodeIdentifierStart;
      function isUnicodeIdentifierPart(code, languageVersion) {
        return languageVersion >= 2 ? lookupInUnicodeMap(code, unicodeESNextIdentifierPart) : languageVersion === 1 ? lookupInUnicodeMap(code, unicodeES5IdentifierPart) : lookupInUnicodeMap(code, unicodeES3IdentifierPart);
      }
      function makeReverseMap(source) {
        var result = [];
        source.forEach(function(value, name) {
          result[value] = name;
        });
        return result;
      }
      var tokenStrings = makeReverseMap(textToToken);
      function tokenToString(t) {
        return tokenStrings[t];
      }
      ts2.tokenToString = tokenToString;
      function stringToToken(s) {
        return textToToken.get(s);
      }
      ts2.stringToToken = stringToToken;
      function computeLineStarts(text) {
        var result = new Array();
        var pos = 0;
        var lineStart = 0;
        while (pos < text.length) {
          var ch = text.charCodeAt(pos);
          pos++;
          switch (ch) {
            case 13:
              if (text.charCodeAt(pos) === 10) {
                pos++;
              }
            case 10:
              result.push(lineStart);
              lineStart = pos;
              break;
            default:
              if (ch > 127 && isLineBreak(ch)) {
                result.push(lineStart);
                lineStart = pos;
              }
              break;
          }
        }
        result.push(lineStart);
        return result;
      }
      ts2.computeLineStarts = computeLineStarts;
      function getPositionOfLineAndCharacter(sourceFile, line, character, allowEdits) {
        return sourceFile.getPositionOfLineAndCharacter ? sourceFile.getPositionOfLineAndCharacter(line, character, allowEdits) : computePositionOfLineAndCharacter(getLineStarts(sourceFile), line, character, sourceFile.text, allowEdits);
      }
      ts2.getPositionOfLineAndCharacter = getPositionOfLineAndCharacter;
      function computePositionOfLineAndCharacter(lineStarts, line, character, debugText, allowEdits) {
        if (line < 0 || line >= lineStarts.length) {
          if (allowEdits) {
            line = line < 0 ? 0 : line >= lineStarts.length ? lineStarts.length - 1 : line;
          } else {
            ts2.Debug.fail("Bad line number. Line: " + line + ", lineStarts.length: " + lineStarts.length + " , line map is correct? " + (debugText !== void 0 ? ts2.arraysEqual(lineStarts, computeLineStarts(debugText)) : "unknown"));
          }
        }
        var res = lineStarts[line] + character;
        if (allowEdits) {
          return res > lineStarts[line + 1] ? lineStarts[line + 1] : typeof debugText === "string" && res > debugText.length ? debugText.length : res;
        }
        if (line < lineStarts.length - 1) {
          ts2.Debug.assert(res < lineStarts[line + 1]);
        } else if (debugText !== void 0) {
          ts2.Debug.assert(res <= debugText.length);
        }
        return res;
      }
      ts2.computePositionOfLineAndCharacter = computePositionOfLineAndCharacter;
      function getLineStarts(sourceFile) {
        return sourceFile.lineMap || (sourceFile.lineMap = computeLineStarts(sourceFile.text));
      }
      ts2.getLineStarts = getLineStarts;
      function computeLineAndCharacterOfPosition(lineStarts, position) {
        var lineNumber = computeLineOfPosition(lineStarts, position);
        return {
          line: lineNumber,
          character: position - lineStarts[lineNumber]
        };
      }
      ts2.computeLineAndCharacterOfPosition = computeLineAndCharacterOfPosition;
      function computeLineOfPosition(lineStarts, position, lowerBound) {
        var lineNumber = ts2.binarySearch(lineStarts, position, ts2.identity, ts2.compareValues, lowerBound);
        if (lineNumber < 0) {
          lineNumber = ~lineNumber - 1;
          ts2.Debug.assert(lineNumber !== -1, "position cannot precede the beginning of the file");
        }
        return lineNumber;
      }
      ts2.computeLineOfPosition = computeLineOfPosition;
      function getLinesBetweenPositions(sourceFile, pos1, pos2) {
        if (pos1 === pos2)
          return 0;
        var lineStarts = getLineStarts(sourceFile);
        var lower = Math.min(pos1, pos2);
        var isNegative = lower === pos2;
        var upper = isNegative ? pos1 : pos2;
        var lowerLine = computeLineOfPosition(lineStarts, lower);
        var upperLine = computeLineOfPosition(lineStarts, upper, lowerLine);
        return isNegative ? lowerLine - upperLine : upperLine - lowerLine;
      }
      ts2.getLinesBetweenPositions = getLinesBetweenPositions;
      function getLineAndCharacterOfPosition(sourceFile, position) {
        return computeLineAndCharacterOfPosition(getLineStarts(sourceFile), position);
      }
      ts2.getLineAndCharacterOfPosition = getLineAndCharacterOfPosition;
      function isWhiteSpaceLike(ch) {
        return isWhiteSpaceSingleLine(ch) || isLineBreak(ch);
      }
      ts2.isWhiteSpaceLike = isWhiteSpaceLike;
      function isWhiteSpaceSingleLine(ch) {
        return ch === 32 || ch === 9 || ch === 11 || ch === 12 || ch === 160 || ch === 133 || ch === 5760 || ch >= 8192 && ch <= 8203 || ch === 8239 || ch === 8287 || ch === 12288 || ch === 65279;
      }
      ts2.isWhiteSpaceSingleLine = isWhiteSpaceSingleLine;
      function isLineBreak(ch) {
        return ch === 10 || ch === 13 || ch === 8232 || ch === 8233;
      }
      ts2.isLineBreak = isLineBreak;
      function isDigit(ch) {
        return ch >= 48 && ch <= 57;
      }
      function isHexDigit(ch) {
        return isDigit(ch) || ch >= 65 && ch <= 70 || ch >= 97 && ch <= 102;
      }
      function isCodePoint(code) {
        return code <= 1114111;
      }
      function isOctalDigit(ch) {
        return ch >= 48 && ch <= 55;
      }
      ts2.isOctalDigit = isOctalDigit;
      function couldStartTrivia(text, pos) {
        var ch = text.charCodeAt(pos);
        switch (ch) {
          case 13:
          case 10:
          case 9:
          case 11:
          case 12:
          case 32:
          case 47:
          case 60:
          case 124:
          case 61:
          case 62:
            return true;
          case 35:
            return pos === 0;
          default:
            return ch > 127;
        }
      }
      ts2.couldStartTrivia = couldStartTrivia;
      function skipTrivia(text, pos, stopAfterLineBreak, stopAtComments) {
        if (stopAtComments === void 0) {
          stopAtComments = false;
        }
        if (ts2.positionIsSynthesized(pos)) {
          return pos;
        }
        while (true) {
          var ch = text.charCodeAt(pos);
          switch (ch) {
            case 13:
              if (text.charCodeAt(pos + 1) === 10) {
                pos++;
              }
            case 10:
              pos++;
              if (stopAfterLineBreak) {
                return pos;
              }
              continue;
            case 9:
            case 11:
            case 12:
            case 32:
              pos++;
              continue;
            case 47:
              if (stopAtComments) {
                break;
              }
              if (text.charCodeAt(pos + 1) === 47) {
                pos += 2;
                while (pos < text.length) {
                  if (isLineBreak(text.charCodeAt(pos))) {
                    break;
                  }
                  pos++;
                }
                continue;
              }
              if (text.charCodeAt(pos + 1) === 42) {
                pos += 2;
                while (pos < text.length) {
                  if (text.charCodeAt(pos) === 42 && text.charCodeAt(pos + 1) === 47) {
                    pos += 2;
                    break;
                  }
                  pos++;
                }
                continue;
              }
              break;
            case 60:
            case 124:
            case 61:
            case 62:
              if (isConflictMarkerTrivia(text, pos)) {
                pos = scanConflictMarkerTrivia(text, pos);
                continue;
              }
              break;
            case 35:
              if (pos === 0 && isShebangTrivia(text, pos)) {
                pos = scanShebangTrivia(text, pos);
                continue;
              }
              break;
            default:
              if (ch > 127 && isWhiteSpaceLike(ch)) {
                pos++;
                continue;
              }
              break;
          }
          return pos;
        }
      }
      ts2.skipTrivia = skipTrivia;
      var mergeConflictMarkerLength = "<<<<<<<".length;
      function isConflictMarkerTrivia(text, pos) {
        ts2.Debug.assert(pos >= 0);
        if (pos === 0 || isLineBreak(text.charCodeAt(pos - 1))) {
          var ch = text.charCodeAt(pos);
          if (pos + mergeConflictMarkerLength < text.length) {
            for (var i = 0; i < mergeConflictMarkerLength; i++) {
              if (text.charCodeAt(pos + i) !== ch) {
                return false;
              }
            }
            return ch === 61 || text.charCodeAt(pos + mergeConflictMarkerLength) === 32;
          }
        }
        return false;
      }
      function scanConflictMarkerTrivia(text, pos, error) {
        if (error) {
          error(ts2.Diagnostics.Merge_conflict_marker_encountered, pos, mergeConflictMarkerLength);
        }
        var ch = text.charCodeAt(pos);
        var len = text.length;
        if (ch === 60 || ch === 62) {
          while (pos < len && !isLineBreak(text.charCodeAt(pos))) {
            pos++;
          }
        } else {
          ts2.Debug.assert(ch === 124 || ch === 61);
          while (pos < len) {
            var currentChar = text.charCodeAt(pos);
            if ((currentChar === 61 || currentChar === 62) && currentChar !== ch && isConflictMarkerTrivia(text, pos)) {
              break;
            }
            pos++;
          }
        }
        return pos;
      }
      var shebangTriviaRegex = /^#!.*/;
      function isShebangTrivia(text, pos) {
        ts2.Debug.assert(pos === 0);
        return shebangTriviaRegex.test(text);
      }
      ts2.isShebangTrivia = isShebangTrivia;
      function scanShebangTrivia(text, pos) {
        var shebang = shebangTriviaRegex.exec(text)[0];
        pos = pos + shebang.length;
        return pos;
      }
      ts2.scanShebangTrivia = scanShebangTrivia;
      function iterateCommentRanges(reduce, text, pos, trailing, cb, state, initial) {
        var pendingPos;
        var pendingEnd;
        var pendingKind;
        var pendingHasTrailingNewLine;
        var hasPendingCommentRange = false;
        var collecting = trailing;
        var accumulator = initial;
        if (pos === 0) {
          collecting = true;
          var shebang = getShebang(text);
          if (shebang) {
            pos = shebang.length;
          }
        }
        scan:
          while (pos >= 0 && pos < text.length) {
            var ch = text.charCodeAt(pos);
            switch (ch) {
              case 13:
                if (text.charCodeAt(pos + 1) === 10) {
                  pos++;
                }
              case 10:
                pos++;
                if (trailing) {
                  break scan;
                }
                collecting = true;
                if (hasPendingCommentRange) {
                  pendingHasTrailingNewLine = true;
                }
                continue;
              case 9:
              case 11:
              case 12:
              case 32:
                pos++;
                continue;
              case 47:
                var nextChar = text.charCodeAt(pos + 1);
                var hasTrailingNewLine = false;
                if (nextChar === 47 || nextChar === 42) {
                  var kind = nextChar === 47 ? 2 : 3;
                  var startPos = pos;
                  pos += 2;
                  if (nextChar === 47) {
                    while (pos < text.length) {
                      if (isLineBreak(text.charCodeAt(pos))) {
                        hasTrailingNewLine = true;
                        break;
                      }
                      pos++;
                    }
                  } else {
                    while (pos < text.length) {
                      if (text.charCodeAt(pos) === 42 && text.charCodeAt(pos + 1) === 47) {
                        pos += 2;
                        break;
                      }
                      pos++;
                    }
                  }
                  if (collecting) {
                    if (hasPendingCommentRange) {
                      accumulator = cb(pendingPos, pendingEnd, pendingKind, pendingHasTrailingNewLine, state, accumulator);
                      if (!reduce && accumulator) {
                        return accumulator;
                      }
                    }
                    pendingPos = startPos;
                    pendingEnd = pos;
                    pendingKind = kind;
                    pendingHasTrailingNewLine = hasTrailingNewLine;
                    hasPendingCommentRange = true;
                  }
                  continue;
                }
                break scan;
              default:
                if (ch > 127 && isWhiteSpaceLike(ch)) {
                  if (hasPendingCommentRange && isLineBreak(ch)) {
                    pendingHasTrailingNewLine = true;
                  }
                  pos++;
                  continue;
                }
                break scan;
            }
          }
        if (hasPendingCommentRange) {
          accumulator = cb(pendingPos, pendingEnd, pendingKind, pendingHasTrailingNewLine, state, accumulator);
        }
        return accumulator;
      }
      function forEachLeadingCommentRange(text, pos, cb, state) {
        return iterateCommentRanges(false, text, pos, false, cb, state);
      }
      ts2.forEachLeadingCommentRange = forEachLeadingCommentRange;
      function forEachTrailingCommentRange(text, pos, cb, state) {
        return iterateCommentRanges(false, text, pos, true, cb, state);
      }
      ts2.forEachTrailingCommentRange = forEachTrailingCommentRange;
      function reduceEachLeadingCommentRange(text, pos, cb, state, initial) {
        return iterateCommentRanges(true, text, pos, false, cb, state, initial);
      }
      ts2.reduceEachLeadingCommentRange = reduceEachLeadingCommentRange;
      function reduceEachTrailingCommentRange(text, pos, cb, state, initial) {
        return iterateCommentRanges(true, text, pos, true, cb, state, initial);
      }
      ts2.reduceEachTrailingCommentRange = reduceEachTrailingCommentRange;
      function appendCommentRange(pos, end, kind, hasTrailingNewLine, _state, comments) {
        if (!comments) {
          comments = [];
        }
        comments.push({ kind, pos, end, hasTrailingNewLine });
        return comments;
      }
      function getLeadingCommentRanges(text, pos) {
        return reduceEachLeadingCommentRange(text, pos, appendCommentRange, void 0, void 0);
      }
      ts2.getLeadingCommentRanges = getLeadingCommentRanges;
      function getTrailingCommentRanges(text, pos) {
        return reduceEachTrailingCommentRange(text, pos, appendCommentRange, void 0, void 0);
      }
      ts2.getTrailingCommentRanges = getTrailingCommentRanges;
      function getShebang(text) {
        var match = shebangTriviaRegex.exec(text);
        if (match) {
          return match[0];
        }
      }
      ts2.getShebang = getShebang;
      function isIdentifierStart(ch, languageVersion) {
        return ch >= 65 && ch <= 90 || ch >= 97 && ch <= 122 || ch === 36 || ch === 95 || ch > 127 && isUnicodeIdentifierStart(ch, languageVersion);
      }
      ts2.isIdentifierStart = isIdentifierStart;
      function isIdentifierPart(ch, languageVersion, identifierVariant) {
        return ch >= 65 && ch <= 90 || ch >= 97 && ch <= 122 || ch >= 48 && ch <= 57 || ch === 36 || ch === 95 || (identifierVariant === 1 ? ch === 45 || ch === 58 : false) || ch > 127 && isUnicodeIdentifierPart(ch, languageVersion);
      }
      ts2.isIdentifierPart = isIdentifierPart;
      function isIdentifierText(name, languageVersion, identifierVariant) {
        var ch = codePointAt(name, 0);
        if (!isIdentifierStart(ch, languageVersion)) {
          return false;
        }
        for (var i = charSize(ch); i < name.length; i += charSize(ch)) {
          if (!isIdentifierPart(ch = codePointAt(name, i), languageVersion, identifierVariant)) {
            return false;
          }
        }
        return true;
      }
      ts2.isIdentifierText = isIdentifierText;
      function createScanner(languageVersion, skipTrivia2, languageVariant, textInitial, onError, start, length) {
        if (languageVariant === void 0) {
          languageVariant = 0;
        }
        var text = textInitial;
        var pos;
        var end;
        var startPos;
        var tokenPos;
        var token;
        var tokenValue;
        var tokenFlags;
        var commentDirectives;
        var inJSDocType = 0;
        setText(text, start, length);
        var scanner = {
          getStartPos: function() {
            return startPos;
          },
          getTextPos: function() {
            return pos;
          },
          getToken: function() {
            return token;
          },
          getTokenPos: function() {
            return tokenPos;
          },
          getTokenText: function() {
            return text.substring(tokenPos, pos);
          },
          getTokenValue: function() {
            return tokenValue;
          },
          hasUnicodeEscape: function() {
            return (tokenFlags & 1024) !== 0;
          },
          hasExtendedUnicodeEscape: function() {
            return (tokenFlags & 8) !== 0;
          },
          hasPrecedingLineBreak: function() {
            return (tokenFlags & 1) !== 0;
          },
          isIdentifier: function() {
            return token === 75 || token > 112;
          },
          isReservedWord: function() {
            return token >= 77 && token <= 112;
          },
          isUnterminated: function() {
            return (tokenFlags & 4) !== 0;
          },
          getCommentDirectives: function() {
            return commentDirectives;
          },
          getTokenFlags: function() {
            return tokenFlags;
          },
          reScanGreaterToken,
          reScanSlashToken,
          reScanTemplateToken,
          reScanTemplateHeadOrNoSubstitutionTemplate,
          scanJsxIdentifier,
          scanJsxAttributeValue,
          reScanJsxAttributeValue,
          reScanJsxToken,
          reScanLessThanToken,
          reScanQuestionToken,
          scanJsxToken,
          scanJsDocToken,
          scan,
          getText,
          clearCommentDirectives,
          setText,
          setScriptTarget,
          setLanguageVariant,
          setOnError,
          setTextPos,
          setInJSDocType,
          tryScan,
          lookAhead,
          scanRange
        };
        if (ts2.Debug.isDebugging) {
          Object.defineProperty(scanner, "__debugShowCurrentPositionInText", {
            get: function() {
              var text2 = scanner.getText();
              return text2.slice(0, scanner.getStartPos()) + "\u2551" + text2.slice(scanner.getStartPos());
            }
          });
        }
        return scanner;
        function error(message, errPos, length2) {
          if (errPos === void 0) {
            errPos = pos;
          }
          if (onError) {
            var oldPos = pos;
            pos = errPos;
            onError(message, length2 || 0);
            pos = oldPos;
          }
        }
        function scanNumberFragment() {
          var start2 = pos;
          var allowSeparator = false;
          var isPreviousTokenSeparator = false;
          var result = "";
          while (true) {
            var ch = text.charCodeAt(pos);
            if (ch === 95) {
              tokenFlags |= 512;
              if (allowSeparator) {
                allowSeparator = false;
                isPreviousTokenSeparator = true;
                result += text.substring(start2, pos);
              } else if (isPreviousTokenSeparator) {
                error(ts2.Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted, pos, 1);
              } else {
                error(ts2.Diagnostics.Numeric_separators_are_not_allowed_here, pos, 1);
              }
              pos++;
              start2 = pos;
              continue;
            }
            if (isDigit(ch)) {
              allowSeparator = true;
              isPreviousTokenSeparator = false;
              pos++;
              continue;
            }
            break;
          }
          if (text.charCodeAt(pos - 1) === 95) {
            error(ts2.Diagnostics.Numeric_separators_are_not_allowed_here, pos - 1, 1);
          }
          return result + text.substring(start2, pos);
        }
        function scanNumber() {
          var start2 = pos;
          var mainFragment = scanNumberFragment();
          var decimalFragment;
          var scientificFragment;
          if (text.charCodeAt(pos) === 46) {
            pos++;
            decimalFragment = scanNumberFragment();
          }
          var end2 = pos;
          if (text.charCodeAt(pos) === 69 || text.charCodeAt(pos) === 101) {
            pos++;
            tokenFlags |= 16;
            if (text.charCodeAt(pos) === 43 || text.charCodeAt(pos) === 45)
              pos++;
            var preNumericPart = pos;
            var finalFragment = scanNumberFragment();
            if (!finalFragment) {
              error(ts2.Diagnostics.Digit_expected);
            } else {
              scientificFragment = text.substring(end2, preNumericPart) + finalFragment;
              end2 = pos;
            }
          }
          var result;
          if (tokenFlags & 512) {
            result = mainFragment;
            if (decimalFragment) {
              result += "." + decimalFragment;
            }
            if (scientificFragment) {
              result += scientificFragment;
            }
          } else {
            result = text.substring(start2, end2);
          }
          if (decimalFragment !== void 0 || tokenFlags & 16) {
            checkForIdentifierStartAfterNumericLiteral(start2, decimalFragment === void 0 && !!(tokenFlags & 16));
            return {
              type: 8,
              value: "" + +result
            };
          } else {
            tokenValue = result;
            var type = checkBigIntSuffix();
            checkForIdentifierStartAfterNumericLiteral(start2);
            return { type, value: tokenValue };
          }
        }
        function checkForIdentifierStartAfterNumericLiteral(numericStart, isScientific) {
          if (!isIdentifierStart(codePointAt(text, pos), languageVersion)) {
            return;
          }
          var identifierStart = pos;
          var length2 = scanIdentifierParts().length;
          if (length2 === 1 && text[identifierStart] === "n") {
            if (isScientific) {
              error(ts2.Diagnostics.A_bigint_literal_cannot_use_exponential_notation, numericStart, identifierStart - numericStart + 1);
            } else {
              error(ts2.Diagnostics.A_bigint_literal_must_be_an_integer, numericStart, identifierStart - numericStart + 1);
            }
          } else {
            error(ts2.Diagnostics.An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal, identifierStart, length2);
            pos = identifierStart;
          }
        }
        function scanOctalDigits() {
          var start2 = pos;
          while (isOctalDigit(text.charCodeAt(pos))) {
            pos++;
          }
          return +text.substring(start2, pos);
        }
        function scanExactNumberOfHexDigits(count, canHaveSeparators) {
          var valueString = scanHexDigits(count, false, canHaveSeparators);
          return valueString ? parseInt(valueString, 16) : -1;
        }
        function scanMinimumNumberOfHexDigits(count, canHaveSeparators) {
          return scanHexDigits(count, true, canHaveSeparators);
        }
        function scanHexDigits(minCount, scanAsManyAsPossible, canHaveSeparators) {
          var valueChars = [];
          var allowSeparator = false;
          var isPreviousTokenSeparator = false;
          while (valueChars.length < minCount || scanAsManyAsPossible) {
            var ch = text.charCodeAt(pos);
            if (canHaveSeparators && ch === 95) {
              tokenFlags |= 512;
              if (allowSeparator) {
                allowSeparator = false;
                isPreviousTokenSeparator = true;
              } else if (isPreviousTokenSeparator) {
                error(ts2.Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted, pos, 1);
              } else {
                error(ts2.Diagnostics.Numeric_separators_are_not_allowed_here, pos, 1);
              }
              pos++;
              continue;
            }
            allowSeparator = canHaveSeparators;
            if (ch >= 65 && ch <= 70) {
              ch += 97 - 65;
            } else if (!(ch >= 48 && ch <= 57 || ch >= 97 && ch <= 102)) {
              break;
            }
            valueChars.push(ch);
            pos++;
            isPreviousTokenSeparator = false;
          }
          if (valueChars.length < minCount) {
            valueChars = [];
          }
          if (text.charCodeAt(pos - 1) === 95) {
            error(ts2.Diagnostics.Numeric_separators_are_not_allowed_here, pos - 1, 1);
          }
          return String.fromCharCode.apply(String, valueChars);
        }
        function scanString(jsxAttributeString) {
          if (jsxAttributeString === void 0) {
            jsxAttributeString = false;
          }
          var quote = text.charCodeAt(pos);
          pos++;
          var result = "";
          var start2 = pos;
          while (true) {
            if (pos >= end) {
              result += text.substring(start2, pos);
              tokenFlags |= 4;
              error(ts2.Diagnostics.Unterminated_string_literal);
              break;
            }
            var ch = text.charCodeAt(pos);
            if (ch === quote) {
              result += text.substring(start2, pos);
              pos++;
              break;
            }
            if (ch === 92 && !jsxAttributeString) {
              result += text.substring(start2, pos);
              result += scanEscapeSequence();
              start2 = pos;
              continue;
            }
            if (isLineBreak(ch) && !jsxAttributeString) {
              result += text.substring(start2, pos);
              tokenFlags |= 4;
              error(ts2.Diagnostics.Unterminated_string_literal);
              break;
            }
            pos++;
          }
          return result;
        }
        function scanTemplateAndSetTokenValue(isTaggedTemplate) {
          var startedWithBacktick = text.charCodeAt(pos) === 96;
          pos++;
          var start2 = pos;
          var contents = "";
          var resultingToken;
          while (true) {
            if (pos >= end) {
              contents += text.substring(start2, pos);
              tokenFlags |= 4;
              error(ts2.Diagnostics.Unterminated_template_literal);
              resultingToken = startedWithBacktick ? 14 : 17;
              break;
            }
            var currChar = text.charCodeAt(pos);
            if (currChar === 96) {
              contents += text.substring(start2, pos);
              pos++;
              resultingToken = startedWithBacktick ? 14 : 17;
              break;
            }
            if (currChar === 36 && pos + 1 < end && text.charCodeAt(pos + 1) === 123) {
              contents += text.substring(start2, pos);
              pos += 2;
              resultingToken = startedWithBacktick ? 15 : 16;
              break;
            }
            if (currChar === 92) {
              contents += text.substring(start2, pos);
              contents += scanEscapeSequence(isTaggedTemplate);
              start2 = pos;
              continue;
            }
            if (currChar === 13) {
              contents += text.substring(start2, pos);
              pos++;
              if (pos < end && text.charCodeAt(pos) === 10) {
                pos++;
              }
              contents += "\n";
              start2 = pos;
              continue;
            }
            pos++;
          }
          ts2.Debug.assert(resultingToken !== void 0);
          tokenValue = contents;
          return resultingToken;
        }
        function scanEscapeSequence(isTaggedTemplate) {
          var start2 = pos;
          pos++;
          if (pos >= end) {
            error(ts2.Diagnostics.Unexpected_end_of_text);
            return "";
          }
          var ch = text.charCodeAt(pos);
          pos++;
          switch (ch) {
            case 48:
              if (isTaggedTemplate && pos < end && isDigit(text.charCodeAt(pos))) {
                pos++;
                tokenFlags |= 2048;
                return text.substring(start2, pos);
              }
              return "\0";
            case 98:
              return "\b";
            case 116:
              return "	";
            case 110:
              return "\n";
            case 118:
              return "\v";
            case 102:
              return "\f";
            case 114:
              return "\r";
            case 39:
              return "'";
            case 34:
              return '"';
            case 117:
              if (isTaggedTemplate) {
                for (var escapePos = pos; escapePos < pos + 4; escapePos++) {
                  if (escapePos < end && !isHexDigit(text.charCodeAt(escapePos)) && text.charCodeAt(escapePos) !== 123) {
                    pos = escapePos;
                    tokenFlags |= 2048;
                    return text.substring(start2, pos);
                  }
                }
              }
              if (pos < end && text.charCodeAt(pos) === 123) {
                pos++;
                if (isTaggedTemplate && !isHexDigit(text.charCodeAt(pos))) {
                  tokenFlags |= 2048;
                  return text.substring(start2, pos);
                }
                if (isTaggedTemplate) {
                  var savePos = pos;
                  var escapedValueString = scanMinimumNumberOfHexDigits(1, false);
                  var escapedValue = escapedValueString ? parseInt(escapedValueString, 16) : -1;
                  if (!isCodePoint(escapedValue) || text.charCodeAt(pos) !== 125) {
                    tokenFlags |= 2048;
                    return text.substring(start2, pos);
                  } else {
                    pos = savePos;
                  }
                }
                tokenFlags |= 8;
                return scanExtendedUnicodeEscape();
              }
              tokenFlags |= 1024;
              return scanHexadecimalEscape(4);
            case 120:
              if (isTaggedTemplate) {
                if (!isHexDigit(text.charCodeAt(pos))) {
                  tokenFlags |= 2048;
                  return text.substring(start2, pos);
                } else if (!isHexDigit(text.charCodeAt(pos + 1))) {
                  pos++;
                  tokenFlags |= 2048;
                  return text.substring(start2, pos);
                }
              }
              return scanHexadecimalEscape(2);
            case 13:
              if (pos < end && text.charCodeAt(pos) === 10) {
                pos++;
              }
            case 10:
            case 8232:
            case 8233:
              return "";
            default:
              return String.fromCharCode(ch);
          }
        }
        function scanHexadecimalEscape(numDigits) {
          var escapedValue = scanExactNumberOfHexDigits(numDigits, false);
          if (escapedValue >= 0) {
            return String.fromCharCode(escapedValue);
          } else {
            error(ts2.Diagnostics.Hexadecimal_digit_expected);
            return "";
          }
        }
        function scanExtendedUnicodeEscape() {
          var escapedValueString = scanMinimumNumberOfHexDigits(1, false);
          var escapedValue = escapedValueString ? parseInt(escapedValueString, 16) : -1;
          var isInvalidExtendedEscape = false;
          if (escapedValue < 0) {
            error(ts2.Diagnostics.Hexadecimal_digit_expected);
            isInvalidExtendedEscape = true;
          } else if (escapedValue > 1114111) {
            error(ts2.Diagnostics.An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive);
            isInvalidExtendedEscape = true;
          }
          if (pos >= end) {
            error(ts2.Diagnostics.Unexpected_end_of_text);
            isInvalidExtendedEscape = true;
          } else if (text.charCodeAt(pos) === 125) {
            pos++;
          } else {
            error(ts2.Diagnostics.Unterminated_Unicode_escape_sequence);
            isInvalidExtendedEscape = true;
          }
          if (isInvalidExtendedEscape) {
            return "";
          }
          return utf16EncodeAsString(escapedValue);
        }
        function peekUnicodeEscape() {
          if (pos + 5 < end && text.charCodeAt(pos + 1) === 117) {
            var start_1 = pos;
            pos += 2;
            var value = scanExactNumberOfHexDigits(4, false);
            pos = start_1;
            return value;
          }
          return -1;
        }
        function peekExtendedUnicodeEscape() {
          if (languageVersion >= 2 && codePointAt(text, pos + 1) === 117 && codePointAt(text, pos + 2) === 123) {
            var start_2 = pos;
            pos += 3;
            var escapedValueString = scanMinimumNumberOfHexDigits(1, false);
            var escapedValue = escapedValueString ? parseInt(escapedValueString, 16) : -1;
            pos = start_2;
            return escapedValue;
          }
          return -1;
        }
        function scanIdentifierParts() {
          var result = "";
          var start2 = pos;
          while (pos < end) {
            var ch = codePointAt(text, pos);
            if (isIdentifierPart(ch, languageVersion)) {
              pos += charSize(ch);
            } else if (ch === 92) {
              ch = peekExtendedUnicodeEscape();
              if (ch >= 0 && isIdentifierPart(ch, languageVersion)) {
                pos += 3;
                tokenFlags |= 8;
                result += scanExtendedUnicodeEscape();
                start2 = pos;
                continue;
              }
              ch = peekUnicodeEscape();
              if (!(ch >= 0 && isIdentifierPart(ch, languageVersion))) {
                break;
              }
              tokenFlags |= 1024;
              result += text.substring(start2, pos);
              result += utf16EncodeAsString(ch);
              pos += 6;
              start2 = pos;
            } else {
              break;
            }
          }
          result += text.substring(start2, pos);
          return result;
        }
        function getIdentifierToken() {
          var len = tokenValue.length;
          if (len >= 2 && len <= 11) {
            var ch = tokenValue.charCodeAt(0);
            if (ch >= 97 && ch <= 122) {
              var keyword = textToKeyword.get(tokenValue);
              if (keyword !== void 0) {
                return token = keyword;
              }
            }
          }
          return token = 75;
        }
        function scanBinaryOrOctalDigits(base) {
          var value = "";
          var separatorAllowed = false;
          var isPreviousTokenSeparator = false;
          while (true) {
            var ch = text.charCodeAt(pos);
            if (ch === 95) {
              tokenFlags |= 512;
              if (separatorAllowed) {
                separatorAllowed = false;
                isPreviousTokenSeparator = true;
              } else if (isPreviousTokenSeparator) {
                error(ts2.Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted, pos, 1);
              } else {
                error(ts2.Diagnostics.Numeric_separators_are_not_allowed_here, pos, 1);
              }
              pos++;
              continue;
            }
            separatorAllowed = true;
            if (!isDigit(ch) || ch - 48 >= base) {
              break;
            }
            value += text[pos];
            pos++;
            isPreviousTokenSeparator = false;
          }
          if (text.charCodeAt(pos - 1) === 95) {
            error(ts2.Diagnostics.Numeric_separators_are_not_allowed_here, pos - 1, 1);
          }
          return value;
        }
        function checkBigIntSuffix() {
          if (text.charCodeAt(pos) === 110) {
            tokenValue += "n";
            if (tokenFlags & 384) {
              tokenValue = ts2.parsePseudoBigInt(tokenValue) + "n";
            }
            pos++;
            return 9;
          } else {
            var numericValue = tokenFlags & 128 ? parseInt(tokenValue.slice(2), 2) : tokenFlags & 256 ? parseInt(tokenValue.slice(2), 8) : +tokenValue;
            tokenValue = "" + numericValue;
            return 8;
          }
        }
        function scan() {
          var _a2;
          startPos = pos;
          tokenFlags = 0;
          var asteriskSeen = false;
          while (true) {
            tokenPos = pos;
            if (pos >= end) {
              return token = 1;
            }
            var ch = codePointAt(text, pos);
            if (ch === 35 && pos === 0 && isShebangTrivia(text, pos)) {
              pos = scanShebangTrivia(text, pos);
              if (skipTrivia2) {
                continue;
              } else {
                return token = 6;
              }
            }
            switch (ch) {
              case 10:
              case 13:
                tokenFlags |= 1;
                if (skipTrivia2) {
                  pos++;
                  continue;
                } else {
                  if (ch === 13 && pos + 1 < end && text.charCodeAt(pos + 1) === 10) {
                    pos += 2;
                  } else {
                    pos++;
                  }
                  return token = 4;
                }
              case 9:
              case 11:
              case 12:
              case 32:
              case 160:
              case 5760:
              case 8192:
              case 8193:
              case 8194:
              case 8195:
              case 8196:
              case 8197:
              case 8198:
              case 8199:
              case 8200:
              case 8201:
              case 8202:
              case 8203:
              case 8239:
              case 8287:
              case 12288:
              case 65279:
                if (skipTrivia2) {
                  pos++;
                  continue;
                } else {
                  while (pos < end && isWhiteSpaceSingleLine(text.charCodeAt(pos))) {
                    pos++;
                  }
                  return token = 5;
                }
              case 33:
                if (text.charCodeAt(pos + 1) === 61) {
                  if (text.charCodeAt(pos + 2) === 61) {
                    return pos += 3, token = 37;
                  }
                  return pos += 2, token = 35;
                }
                pos++;
                return token = 53;
              case 34:
              case 39:
                tokenValue = scanString();
                return token = 10;
              case 96:
                return token = scanTemplateAndSetTokenValue(false);
              case 37:
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 68;
                }
                pos++;
                return token = 44;
              case 38:
                if (text.charCodeAt(pos + 1) === 38) {
                  return pos += 2, token = 55;
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 72;
                }
                pos++;
                return token = 50;
              case 40:
                pos++;
                return token = 20;
              case 41:
                pos++;
                return token = 21;
              case 42:
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 65;
                }
                if (text.charCodeAt(pos + 1) === 42) {
                  if (text.charCodeAt(pos + 2) === 61) {
                    return pos += 3, token = 66;
                  }
                  return pos += 2, token = 42;
                }
                pos++;
                if (inJSDocType && !asteriskSeen && tokenFlags & 1) {
                  asteriskSeen = true;
                  continue;
                }
                return token = 41;
              case 43:
                if (text.charCodeAt(pos + 1) === 43) {
                  return pos += 2, token = 45;
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 63;
                }
                pos++;
                return token = 39;
              case 44:
                pos++;
                return token = 27;
              case 45:
                if (text.charCodeAt(pos + 1) === 45) {
                  return pos += 2, token = 46;
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 64;
                }
                pos++;
                return token = 40;
              case 46:
                if (isDigit(text.charCodeAt(pos + 1))) {
                  tokenValue = scanNumber().value;
                  return token = 8;
                }
                if (text.charCodeAt(pos + 1) === 46 && text.charCodeAt(pos + 2) === 46) {
                  return pos += 3, token = 25;
                }
                pos++;
                return token = 24;
              case 47:
                if (text.charCodeAt(pos + 1) === 47) {
                  pos += 2;
                  while (pos < end) {
                    if (isLineBreak(text.charCodeAt(pos))) {
                      break;
                    }
                    pos++;
                  }
                  commentDirectives = appendIfCommentDirective(commentDirectives, text.slice(tokenPos, pos), commentDirectiveRegExSingleLine, tokenPos);
                  if (skipTrivia2) {
                    continue;
                  } else {
                    return token = 2;
                  }
                }
                if (text.charCodeAt(pos + 1) === 42) {
                  pos += 2;
                  if (text.charCodeAt(pos) === 42 && text.charCodeAt(pos + 1) !== 47) {
                    tokenFlags |= 2;
                  }
                  var commentClosed = false;
                  var lastLineStart = tokenPos;
                  while (pos < end) {
                    var ch_1 = text.charCodeAt(pos);
                    if (ch_1 === 42 && text.charCodeAt(pos + 1) === 47) {
                      pos += 2;
                      commentClosed = true;
                      break;
                    }
                    pos++;
                    if (isLineBreak(ch_1)) {
                      lastLineStart = pos;
                      tokenFlags |= 1;
                    }
                  }
                  commentDirectives = appendIfCommentDirective(commentDirectives, text.slice(lastLineStart, pos), commentDirectiveRegExMultiLine, lastLineStart);
                  if (!commentClosed) {
                    error(ts2.Diagnostics.Asterisk_Slash_expected);
                  }
                  if (skipTrivia2) {
                    continue;
                  } else {
                    if (!commentClosed) {
                      tokenFlags |= 4;
                    }
                    return token = 3;
                  }
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 67;
                }
                pos++;
                return token = 43;
              case 48:
                if (pos + 2 < end && (text.charCodeAt(pos + 1) === 88 || text.charCodeAt(pos + 1) === 120)) {
                  pos += 2;
                  tokenValue = scanMinimumNumberOfHexDigits(1, true);
                  if (!tokenValue) {
                    error(ts2.Diagnostics.Hexadecimal_digit_expected);
                    tokenValue = "0";
                  }
                  tokenValue = "0x" + tokenValue;
                  tokenFlags |= 64;
                  return token = checkBigIntSuffix();
                } else if (pos + 2 < end && (text.charCodeAt(pos + 1) === 66 || text.charCodeAt(pos + 1) === 98)) {
                  pos += 2;
                  tokenValue = scanBinaryOrOctalDigits(2);
                  if (!tokenValue) {
                    error(ts2.Diagnostics.Binary_digit_expected);
                    tokenValue = "0";
                  }
                  tokenValue = "0b" + tokenValue;
                  tokenFlags |= 128;
                  return token = checkBigIntSuffix();
                } else if (pos + 2 < end && (text.charCodeAt(pos + 1) === 79 || text.charCodeAt(pos + 1) === 111)) {
                  pos += 2;
                  tokenValue = scanBinaryOrOctalDigits(8);
                  if (!tokenValue) {
                    error(ts2.Diagnostics.Octal_digit_expected);
                    tokenValue = "0";
                  }
                  tokenValue = "0o" + tokenValue;
                  tokenFlags |= 256;
                  return token = checkBigIntSuffix();
                }
                if (pos + 1 < end && isOctalDigit(text.charCodeAt(pos + 1))) {
                  tokenValue = "" + scanOctalDigits();
                  tokenFlags |= 32;
                  return token = 8;
                }
              case 49:
              case 50:
              case 51:
              case 52:
              case 53:
              case 54:
              case 55:
              case 56:
              case 57:
                _a2 = scanNumber(), token = _a2.type, tokenValue = _a2.value;
                return token;
              case 58:
                pos++;
                return token = 58;
              case 59:
                pos++;
                return token = 26;
              case 60:
                if (isConflictMarkerTrivia(text, pos)) {
                  pos = scanConflictMarkerTrivia(text, pos, error);
                  if (skipTrivia2) {
                    continue;
                  } else {
                    return token = 7;
                  }
                }
                if (text.charCodeAt(pos + 1) === 60) {
                  if (text.charCodeAt(pos + 2) === 61) {
                    return pos += 3, token = 69;
                  }
                  return pos += 2, token = 47;
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 32;
                }
                if (languageVariant === 1 && text.charCodeAt(pos + 1) === 47 && text.charCodeAt(pos + 2) !== 42) {
                  return pos += 2, token = 30;
                }
                pos++;
                return token = 29;
              case 61:
                if (isConflictMarkerTrivia(text, pos)) {
                  pos = scanConflictMarkerTrivia(text, pos, error);
                  if (skipTrivia2) {
                    continue;
                  } else {
                    return token = 7;
                  }
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  if (text.charCodeAt(pos + 2) === 61) {
                    return pos += 3, token = 36;
                  }
                  return pos += 2, token = 34;
                }
                if (text.charCodeAt(pos + 1) === 62) {
                  return pos += 2, token = 38;
                }
                pos++;
                return token = 62;
              case 62:
                if (isConflictMarkerTrivia(text, pos)) {
                  pos = scanConflictMarkerTrivia(text, pos, error);
                  if (skipTrivia2) {
                    continue;
                  } else {
                    return token = 7;
                  }
                }
                pos++;
                return token = 31;
              case 63:
                pos++;
                if (text.charCodeAt(pos) === 46 && !isDigit(text.charCodeAt(pos + 1))) {
                  pos++;
                  return token = 28;
                }
                if (text.charCodeAt(pos) === 63) {
                  pos++;
                  return token = 60;
                }
                return token = 57;
              case 91:
                pos++;
                return token = 22;
              case 93:
                pos++;
                return token = 23;
              case 94:
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 74;
                }
                pos++;
                return token = 52;
              case 123:
                pos++;
                return token = 18;
              case 124:
                if (isConflictMarkerTrivia(text, pos)) {
                  pos = scanConflictMarkerTrivia(text, pos, error);
                  if (skipTrivia2) {
                    continue;
                  } else {
                    return token = 7;
                  }
                }
                if (text.charCodeAt(pos + 1) === 124) {
                  return pos += 2, token = 56;
                }
                if (text.charCodeAt(pos + 1) === 61) {
                  return pos += 2, token = 73;
                }
                pos++;
                return token = 51;
              case 125:
                pos++;
                return token = 19;
              case 126:
                pos++;
                return token = 54;
              case 64:
                pos++;
                return token = 59;
              case 92:
                var extendedCookedChar = peekExtendedUnicodeEscape();
                if (extendedCookedChar >= 0 && isIdentifierStart(extendedCookedChar, languageVersion)) {
                  pos += 3;
                  tokenFlags |= 8;
                  tokenValue = scanExtendedUnicodeEscape() + scanIdentifierParts();
                  return token = getIdentifierToken();
                }
                var cookedChar = peekUnicodeEscape();
                if (cookedChar >= 0 && isIdentifierStart(cookedChar, languageVersion)) {
                  pos += 6;
                  tokenFlags |= 1024;
                  tokenValue = String.fromCharCode(cookedChar) + scanIdentifierParts();
                  return token = getIdentifierToken();
                }
                error(ts2.Diagnostics.Invalid_character);
                pos++;
                return token = 0;
              case 35:
                if (pos !== 0 && text[pos + 1] === "!") {
                  error(ts2.Diagnostics.can_only_be_used_at_the_start_of_a_file);
                  pos++;
                  return token = 0;
                }
                pos++;
                if (isIdentifierStart(ch = text.charCodeAt(pos), languageVersion)) {
                  pos++;
                  while (pos < end && isIdentifierPart(ch = text.charCodeAt(pos), languageVersion))
                    pos++;
                  tokenValue = text.substring(tokenPos, pos);
                  if (ch === 92) {
                    tokenValue += scanIdentifierParts();
                  }
                } else {
                  tokenValue = "#";
                  error(ts2.Diagnostics.Invalid_character);
                }
                return token = 76;
              default:
                if (isIdentifierStart(ch, languageVersion)) {
                  pos += charSize(ch);
                  while (pos < end && isIdentifierPart(ch = codePointAt(text, pos), languageVersion))
                    pos += charSize(ch);
                  tokenValue = text.substring(tokenPos, pos);
                  if (ch === 92) {
                    tokenValue += scanIdentifierParts();
                  }
                  return token = getIdentifierToken();
                } else if (isWhiteSpaceSingleLine(ch)) {
                  pos += charSize(ch);
                  continue;
                } else if (isLineBreak(ch)) {
                  tokenFlags |= 1;
                  pos += charSize(ch);
                  continue;
                }
                error(ts2.Diagnostics.Invalid_character);
                pos += charSize(ch);
                return token = 0;
            }
          }
        }
        function reScanGreaterToken() {
          if (token === 31) {
            if (text.charCodeAt(pos) === 62) {
              if (text.charCodeAt(pos + 1) === 62) {
                if (text.charCodeAt(pos + 2) === 61) {
                  return pos += 3, token = 71;
                }
                return pos += 2, token = 49;
              }
              if (text.charCodeAt(pos + 1) === 61) {
                return pos += 2, token = 70;
              }
              pos++;
              return token = 48;
            }
            if (text.charCodeAt(pos) === 61) {
              pos++;
              return token = 33;
            }
          }
          return token;
        }
        function reScanSlashToken() {
          if (token === 43 || token === 67) {
            var p = tokenPos + 1;
            var inEscape = false;
            var inCharacterClass = false;
            while (true) {
              if (p >= end) {
                tokenFlags |= 4;
                error(ts2.Diagnostics.Unterminated_regular_expression_literal);
                break;
              }
              var ch = text.charCodeAt(p);
              if (isLineBreak(ch)) {
                tokenFlags |= 4;
                error(ts2.Diagnostics.Unterminated_regular_expression_literal);
                break;
              }
              if (inEscape) {
                inEscape = false;
              } else if (ch === 47 && !inCharacterClass) {
                p++;
                break;
              } else if (ch === 91) {
                inCharacterClass = true;
              } else if (ch === 92) {
                inEscape = true;
              } else if (ch === 93) {
                inCharacterClass = false;
              }
              p++;
            }
            while (p < end && isIdentifierPart(text.charCodeAt(p), languageVersion)) {
              p++;
            }
            pos = p;
            tokenValue = text.substring(tokenPos, pos);
            token = 13;
          }
          return token;
        }
        function appendIfCommentDirective(commentDirectives2, text2, commentDirectiveRegEx, lineStart) {
          var type = getDirectiveFromComment(text2, commentDirectiveRegEx);
          if (type === void 0) {
            return commentDirectives2;
          }
          return ts2.append(commentDirectives2, {
            range: { pos: lineStart, end: pos },
            type
          });
        }
        function getDirectiveFromComment(text2, commentDirectiveRegEx) {
          var match = commentDirectiveRegEx.exec(text2);
          if (!match) {
            return void 0;
          }
          switch (match[1]) {
            case "ts-expect-error":
              return 0;
            case "ts-ignore":
              return 1;
          }
          return void 0;
        }
        function reScanTemplateToken(isTaggedTemplate) {
          ts2.Debug.assert(token === 19, "'reScanTemplateToken' should only be called on a '}'");
          pos = tokenPos;
          return token = scanTemplateAndSetTokenValue(isTaggedTemplate);
        }
        function reScanTemplateHeadOrNoSubstitutionTemplate() {
          pos = tokenPos;
          return token = scanTemplateAndSetTokenValue(true);
        }
        function reScanJsxToken() {
          pos = tokenPos = startPos;
          return token = scanJsxToken();
        }
        function reScanLessThanToken() {
          if (token === 47) {
            pos = tokenPos + 1;
            return token = 29;
          }
          return token;
        }
        function reScanQuestionToken() {
          ts2.Debug.assert(token === 60, "'reScanQuestionToken' should only be called on a '??'");
          pos = tokenPos + 1;
          return token = 57;
        }
        function scanJsxToken() {
          startPos = tokenPos = pos;
          if (pos >= end) {
            return token = 1;
          }
          var char = text.charCodeAt(pos);
          if (char === 60) {
            if (text.charCodeAt(pos + 1) === 47) {
              pos += 2;
              return token = 30;
            }
            pos++;
            return token = 29;
          }
          if (char === 123) {
            pos++;
            return token = 18;
          }
          var firstNonWhitespace = 0;
          var lastNonWhitespace = -1;
          while (pos < end) {
            if (!isWhiteSpaceSingleLine(char)) {
              lastNonWhitespace = pos;
            }
            char = text.charCodeAt(pos);
            if (char === 123) {
              break;
            }
            if (char === 60) {
              if (isConflictMarkerTrivia(text, pos)) {
                pos = scanConflictMarkerTrivia(text, pos, error);
                return token = 7;
              }
              break;
            }
            if (char === 62) {
              error(ts2.Diagnostics.Unexpected_token_Did_you_mean_or_gt, pos, 1);
            }
            if (char === 125) {
              error(ts2.Diagnostics.Unexpected_token_Did_you_mean_or_rbrace, pos, 1);
            }
            if (lastNonWhitespace > 0)
              lastNonWhitespace++;
            if (isLineBreak(char) && firstNonWhitespace === 0) {
              firstNonWhitespace = -1;
            } else if (!isWhiteSpaceLike(char)) {
              firstNonWhitespace = pos;
            }
            pos++;
          }
          var endPosition = lastNonWhitespace === -1 ? pos : lastNonWhitespace;
          tokenValue = text.substring(startPos, endPosition);
          return firstNonWhitespace === -1 ? 12 : 11;
        }
        function scanJsxIdentifier() {
          if (tokenIsIdentifierOrKeyword(token)) {
            while (pos < end) {
              var ch = text.charCodeAt(pos);
              if (ch === 45) {
                tokenValue += "-";
                pos++;
                continue;
              }
              var oldPos = pos;
              tokenValue += scanIdentifierParts();
              if (pos === oldPos) {
                break;
              }
            }
          }
          return token;
        }
        function scanJsxAttributeValue() {
          startPos = pos;
          switch (text.charCodeAt(pos)) {
            case 34:
            case 39:
              tokenValue = scanString(true);
              return token = 10;
            default:
              return scan();
          }
        }
        function reScanJsxAttributeValue() {
          pos = tokenPos = startPos;
          return scanJsxAttributeValue();
        }
        function scanJsDocToken() {
          startPos = tokenPos = pos;
          tokenFlags = 0;
          if (pos >= end) {
            return token = 1;
          }
          var ch = codePointAt(text, pos);
          pos += charSize(ch);
          switch (ch) {
            case 9:
            case 11:
            case 12:
            case 32:
              while (pos < end && isWhiteSpaceSingleLine(text.charCodeAt(pos))) {
                pos++;
              }
              return token = 5;
            case 64:
              return token = 59;
            case 10:
            case 13:
              tokenFlags |= 1;
              return token = 4;
            case 42:
              return token = 41;
            case 123:
              return token = 18;
            case 125:
              return token = 19;
            case 91:
              return token = 22;
            case 93:
              return token = 23;
            case 60:
              return token = 29;
            case 62:
              return token = 31;
            case 61:
              return token = 62;
            case 44:
              return token = 27;
            case 46:
              return token = 24;
            case 96:
              return token = 61;
            case 92:
              pos--;
              var extendedCookedChar = peekExtendedUnicodeEscape();
              if (extendedCookedChar >= 0 && isIdentifierStart(extendedCookedChar, languageVersion)) {
                pos += 3;
                tokenFlags |= 8;
                tokenValue = scanExtendedUnicodeEscape() + scanIdentifierParts();
                return token = getIdentifierToken();
              }
              var cookedChar = peekUnicodeEscape();
              if (cookedChar >= 0 && isIdentifierStart(cookedChar, languageVersion)) {
                pos += 6;
                tokenFlags |= 1024;
                tokenValue = String.fromCharCode(cookedChar) + scanIdentifierParts();
                return token = getIdentifierToken();
              }
              pos++;
              return token = 0;
          }
          if (isIdentifierStart(ch, languageVersion)) {
            var char = ch;
            while (pos < end && isIdentifierPart(char = codePointAt(text, pos), languageVersion) || text.charCodeAt(pos) === 45)
              pos += charSize(char);
            tokenValue = text.substring(tokenPos, pos);
            if (char === 92) {
              tokenValue += scanIdentifierParts();
            }
            return token = getIdentifierToken();
          } else {
            return token = 0;
          }
        }
        function speculationHelper(callback, isLookahead) {
          var savePos = pos;
          var saveStartPos = startPos;
          var saveTokenPos = tokenPos;
          var saveToken = token;
          var saveTokenValue = tokenValue;
          var saveTokenFlags = tokenFlags;
          var result = callback();
          if (!result || isLookahead) {
            pos = savePos;
            startPos = saveStartPos;
            tokenPos = saveTokenPos;
            token = saveToken;
            tokenValue = saveTokenValue;
            tokenFlags = saveTokenFlags;
          }
          return result;
        }
        function scanRange(start2, length2, callback) {
          var saveEnd = end;
          var savePos = pos;
          var saveStartPos = startPos;
          var saveTokenPos = tokenPos;
          var saveToken = token;
          var saveTokenValue = tokenValue;
          var saveTokenFlags = tokenFlags;
          var saveErrorExpectations = commentDirectives;
          setText(text, start2, length2);
          var result = callback();
          end = saveEnd;
          pos = savePos;
          startPos = saveStartPos;
          tokenPos = saveTokenPos;
          token = saveToken;
          tokenValue = saveTokenValue;
          tokenFlags = saveTokenFlags;
          commentDirectives = saveErrorExpectations;
          return result;
        }
        function lookAhead(callback) {
          return speculationHelper(callback, true);
        }
        function tryScan(callback) {
          return speculationHelper(callback, false);
        }
        function getText() {
          return text;
        }
        function clearCommentDirectives() {
          commentDirectives = void 0;
        }
        function setText(newText, start2, length2) {
          text = newText || "";
          end = length2 === void 0 ? text.length : start2 + length2;
          setTextPos(start2 || 0);
        }
        function setOnError(errorCallback) {
          onError = errorCallback;
        }
        function setScriptTarget(scriptTarget) {
          languageVersion = scriptTarget;
        }
        function setLanguageVariant(variant) {
          languageVariant = variant;
        }
        function setTextPos(textPos) {
          ts2.Debug.assert(textPos >= 0);
          pos = textPos;
          startPos = textPos;
          tokenPos = textPos;
          token = 0;
          tokenValue = void 0;
          tokenFlags = 0;
        }
        function setInJSDocType(inType) {
          inJSDocType += inType ? 1 : -1;
        }
      }
      ts2.createScanner = createScanner;
      var codePointAt = String.prototype.codePointAt ? function(s, i) {
        return s.codePointAt(i);
      } : function codePointAt2(str, i) {
        var size = str.length;
        if (i < 0 || i >= size) {
          return void 0;
        }
        var first = str.charCodeAt(i);
        if (first >= 55296 && first <= 56319 && size > i + 1) {
          var second = str.charCodeAt(i + 1);
          if (second >= 56320 && second <= 57343) {
            return (first - 55296) * 1024 + second - 56320 + 65536;
          }
        }
        return first;
      };
      function charSize(ch) {
        if (ch >= 65536) {
          return 2;
        }
        return 1;
      }
      function utf16EncodeAsStringFallback(codePoint) {
        ts2.Debug.assert(0 <= codePoint && codePoint <= 1114111);
        if (codePoint <= 65535) {
          return String.fromCharCode(codePoint);
        }
        var codeUnit1 = Math.floor((codePoint - 65536) / 1024) + 55296;
        var codeUnit2 = (codePoint - 65536) % 1024 + 56320;
        return String.fromCharCode(codeUnit1, codeUnit2);
      }
      var utf16EncodeAsStringWorker = String.fromCodePoint ? function(codePoint) {
        return String.fromCodePoint(codePoint);
      } : utf16EncodeAsStringFallback;
      function utf16EncodeAsString(codePoint) {
        return utf16EncodeAsStringWorker(codePoint);
      }
      ts2.utf16EncodeAsString = utf16EncodeAsString;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function isExternalModuleNameRelative(moduleName) {
        return ts2.pathIsRelative(moduleName) || ts2.isRootedDiskPath(moduleName);
      }
      ts2.isExternalModuleNameRelative = isExternalModuleNameRelative;
      function sortAndDeduplicateDiagnostics(diagnostics) {
        return ts2.sortAndDeduplicate(diagnostics, ts2.compareDiagnostics);
      }
      ts2.sortAndDeduplicateDiagnostics = sortAndDeduplicateDiagnostics;
      function getDefaultLibFileName(options) {
        switch (options.target) {
          case 99:
            return "lib.esnext.full.d.ts";
          case 7:
            return "lib.es2020.full.d.ts";
          case 6:
            return "lib.es2019.full.d.ts";
          case 5:
            return "lib.es2018.full.d.ts";
          case 4:
            return "lib.es2017.full.d.ts";
          case 3:
            return "lib.es2016.full.d.ts";
          case 2:
            return "lib.es6.d.ts";
          default:
            return "lib.d.ts";
        }
      }
      ts2.getDefaultLibFileName = getDefaultLibFileName;
      function textSpanEnd(span) {
        return span.start + span.length;
      }
      ts2.textSpanEnd = textSpanEnd;
      function textSpanIsEmpty(span) {
        return span.length === 0;
      }
      ts2.textSpanIsEmpty = textSpanIsEmpty;
      function textSpanContainsPosition(span, position) {
        return position >= span.start && position < textSpanEnd(span);
      }
      ts2.textSpanContainsPosition = textSpanContainsPosition;
      function textRangeContainsPositionInclusive(span, position) {
        return position >= span.pos && position <= span.end;
      }
      ts2.textRangeContainsPositionInclusive = textRangeContainsPositionInclusive;
      function textSpanContainsTextSpan(span, other) {
        return other.start >= span.start && textSpanEnd(other) <= textSpanEnd(span);
      }
      ts2.textSpanContainsTextSpan = textSpanContainsTextSpan;
      function textSpanOverlapsWith(span, other) {
        return textSpanOverlap(span, other) !== void 0;
      }
      ts2.textSpanOverlapsWith = textSpanOverlapsWith;
      function textSpanOverlap(span1, span2) {
        var overlap = textSpanIntersection(span1, span2);
        return overlap && overlap.length === 0 ? void 0 : overlap;
      }
      ts2.textSpanOverlap = textSpanOverlap;
      function textSpanIntersectsWithTextSpan(span, other) {
        return decodedTextSpanIntersectsWith(span.start, span.length, other.start, other.length);
      }
      ts2.textSpanIntersectsWithTextSpan = textSpanIntersectsWithTextSpan;
      function textSpanIntersectsWith(span, start, length) {
        return decodedTextSpanIntersectsWith(span.start, span.length, start, length);
      }
      ts2.textSpanIntersectsWith = textSpanIntersectsWith;
      function decodedTextSpanIntersectsWith(start1, length1, start2, length2) {
        var end1 = start1 + length1;
        var end2 = start2 + length2;
        return start2 <= end1 && end2 >= start1;
      }
      ts2.decodedTextSpanIntersectsWith = decodedTextSpanIntersectsWith;
      function textSpanIntersectsWithPosition(span, position) {
        return position <= textSpanEnd(span) && position >= span.start;
      }
      ts2.textSpanIntersectsWithPosition = textSpanIntersectsWithPosition;
      function textSpanIntersection(span1, span2) {
        var start = Math.max(span1.start, span2.start);
        var end = Math.min(textSpanEnd(span1), textSpanEnd(span2));
        return start <= end ? createTextSpanFromBounds(start, end) : void 0;
      }
      ts2.textSpanIntersection = textSpanIntersection;
      function createTextSpan(start, length) {
        if (start < 0) {
          throw new Error("start < 0");
        }
        if (length < 0) {
          throw new Error("length < 0");
        }
        return { start, length };
      }
      ts2.createTextSpan = createTextSpan;
      function createTextSpanFromBounds(start, end) {
        return createTextSpan(start, end - start);
      }
      ts2.createTextSpanFromBounds = createTextSpanFromBounds;
      function textChangeRangeNewSpan(range) {
        return createTextSpan(range.span.start, range.newLength);
      }
      ts2.textChangeRangeNewSpan = textChangeRangeNewSpan;
      function textChangeRangeIsUnchanged(range) {
        return textSpanIsEmpty(range.span) && range.newLength === 0;
      }
      ts2.textChangeRangeIsUnchanged = textChangeRangeIsUnchanged;
      function createTextChangeRange(span, newLength) {
        if (newLength < 0) {
          throw new Error("newLength < 0");
        }
        return { span, newLength };
      }
      ts2.createTextChangeRange = createTextChangeRange;
      ts2.unchangedTextChangeRange = createTextChangeRange(createTextSpan(0, 0), 0);
      function collapseTextChangeRangesAcrossMultipleVersions(changes) {
        if (changes.length === 0) {
          return ts2.unchangedTextChangeRange;
        }
        if (changes.length === 1) {
          return changes[0];
        }
        var change0 = changes[0];
        var oldStartN = change0.span.start;
        var oldEndN = textSpanEnd(change0.span);
        var newEndN = oldStartN + change0.newLength;
        for (var i = 1; i < changes.length; i++) {
          var nextChange = changes[i];
          var oldStart1 = oldStartN;
          var oldEnd1 = oldEndN;
          var newEnd1 = newEndN;
          var oldStart2 = nextChange.span.start;
          var oldEnd2 = textSpanEnd(nextChange.span);
          var newEnd2 = oldStart2 + nextChange.newLength;
          oldStartN = Math.min(oldStart1, oldStart2);
          oldEndN = Math.max(oldEnd1, oldEnd1 + (oldEnd2 - newEnd1));
          newEndN = Math.max(newEnd2, newEnd2 + (newEnd1 - oldEnd2));
        }
        return createTextChangeRange(createTextSpanFromBounds(oldStartN, oldEndN), newEndN - oldStartN);
      }
      ts2.collapseTextChangeRangesAcrossMultipleVersions = collapseTextChangeRangesAcrossMultipleVersions;
      function getTypeParameterOwner(d) {
        if (d && d.kind === 155) {
          for (var current = d; current; current = current.parent) {
            if (isFunctionLike(current) || isClassLike(current) || current.kind === 246) {
              return current;
            }
          }
        }
      }
      ts2.getTypeParameterOwner = getTypeParameterOwner;
      function isParameterPropertyDeclaration(node, parent) {
        return ts2.hasModifier(node, 92) && parent.kind === 162;
      }
      ts2.isParameterPropertyDeclaration = isParameterPropertyDeclaration;
      function isEmptyBindingPattern(node) {
        if (isBindingPattern(node)) {
          return ts2.every(node.elements, isEmptyBindingElement);
        }
        return false;
      }
      ts2.isEmptyBindingPattern = isEmptyBindingPattern;
      function isEmptyBindingElement(node) {
        if (isOmittedExpression(node)) {
          return true;
        }
        return isEmptyBindingPattern(node.name);
      }
      ts2.isEmptyBindingElement = isEmptyBindingElement;
      function walkUpBindingElementsAndPatterns(binding) {
        var node = binding.parent;
        while (isBindingElement(node.parent)) {
          node = node.parent.parent;
        }
        return node.parent;
      }
      ts2.walkUpBindingElementsAndPatterns = walkUpBindingElementsAndPatterns;
      function getCombinedFlags(node, getFlags) {
        if (isBindingElement(node)) {
          node = walkUpBindingElementsAndPatterns(node);
        }
        var flags = getFlags(node);
        if (node.kind === 242) {
          node = node.parent;
        }
        if (node && node.kind === 243) {
          flags |= getFlags(node);
          node = node.parent;
        }
        if (node && node.kind === 225) {
          flags |= getFlags(node);
        }
        return flags;
      }
      function getCombinedModifierFlags(node) {
        return getCombinedFlags(node, ts2.getModifierFlags);
      }
      ts2.getCombinedModifierFlags = getCombinedModifierFlags;
      function getCombinedNodeFlags(node) {
        return getCombinedFlags(node, function(n) {
          return n.flags;
        });
      }
      ts2.getCombinedNodeFlags = getCombinedNodeFlags;
      function validateLocaleAndSetLanguage(locale, sys, errors) {
        var matchResult = /^([a-z]+)([_\-]([a-z]+))?$/.exec(locale.toLowerCase());
        if (!matchResult) {
          if (errors) {
            errors.push(ts2.createCompilerDiagnostic(ts2.Diagnostics.Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1, "en", "ja-jp"));
          }
          return;
        }
        var language = matchResult[1];
        var territory = matchResult[3];
        if (!trySetLanguageAndTerritory(language, territory, errors)) {
          trySetLanguageAndTerritory(language, void 0, errors);
        }
        ts2.setUILocale(locale);
        function trySetLanguageAndTerritory(language2, territory2, errors2) {
          var compilerFilePath = ts2.normalizePath(sys.getExecutingFilePath());
          var containingDirectoryPath = ts2.getDirectoryPath(compilerFilePath);
          var filePath = ts2.combinePaths(containingDirectoryPath, language2);
          if (territory2) {
            filePath = filePath + "-" + territory2;
          }
          filePath = sys.resolvePath(ts2.combinePaths(filePath, "diagnosticMessages.generated.json"));
          if (!sys.fileExists(filePath)) {
            return false;
          }
          var fileContents = "";
          try {
            fileContents = sys.readFile(filePath);
          } catch (e) {
            if (errors2) {
              errors2.push(ts2.createCompilerDiagnostic(ts2.Diagnostics.Unable_to_open_file_0, filePath));
            }
            return false;
          }
          try {
            ts2.setLocalizedDiagnosticMessages(JSON.parse(fileContents));
          } catch (_a) {
            if (errors2) {
              errors2.push(ts2.createCompilerDiagnostic(ts2.Diagnostics.Corrupted_locale_file_0, filePath));
            }
            return false;
          }
          return true;
        }
      }
      ts2.validateLocaleAndSetLanguage = validateLocaleAndSetLanguage;
      function getOriginalNode(node, nodeTest) {
        if (node) {
          while (node.original !== void 0) {
            node = node.original;
          }
        }
        return !nodeTest || nodeTest(node) ? node : void 0;
      }
      ts2.getOriginalNode = getOriginalNode;
      function isParseTreeNode(node) {
        return (node.flags & 8) === 0;
      }
      ts2.isParseTreeNode = isParseTreeNode;
      function getParseTreeNode(node, nodeTest) {
        if (node === void 0 || isParseTreeNode(node)) {
          return node;
        }
        node = getOriginalNode(node);
        if (isParseTreeNode(node) && (!nodeTest || nodeTest(node))) {
          return node;
        }
        return void 0;
      }
      ts2.getParseTreeNode = getParseTreeNode;
      function escapeLeadingUnderscores(identifier) {
        return identifier.length >= 2 && identifier.charCodeAt(0) === 95 && identifier.charCodeAt(1) === 95 ? "_" + identifier : identifier;
      }
      ts2.escapeLeadingUnderscores = escapeLeadingUnderscores;
      function unescapeLeadingUnderscores(identifier) {
        var id = identifier;
        return id.length >= 3 && id.charCodeAt(0) === 95 && id.charCodeAt(1) === 95 && id.charCodeAt(2) === 95 ? id.substr(1) : id;
      }
      ts2.unescapeLeadingUnderscores = unescapeLeadingUnderscores;
      function idText(identifierOrPrivateName) {
        return unescapeLeadingUnderscores(identifierOrPrivateName.escapedText);
      }
      ts2.idText = idText;
      function symbolName(symbol) {
        if (symbol.valueDeclaration && isPrivateIdentifierPropertyDeclaration(symbol.valueDeclaration)) {
          return idText(symbol.valueDeclaration.name);
        }
        return unescapeLeadingUnderscores(symbol.escapedName);
      }
      ts2.symbolName = symbolName;
      function nameForNamelessJSDocTypedef(declaration) {
        var hostNode = declaration.parent.parent;
        if (!hostNode) {
          return void 0;
        }
        if (isDeclaration(hostNode)) {
          return getDeclarationIdentifier(hostNode);
        }
        switch (hostNode.kind) {
          case 225:
            if (hostNode.declarationList && hostNode.declarationList.declarations[0]) {
              return getDeclarationIdentifier(hostNode.declarationList.declarations[0]);
            }
            break;
          case 226:
            var expr = hostNode.expression;
            if (expr.kind === 209 && expr.operatorToken.kind === 62) {
              expr = expr.left;
            }
            switch (expr.kind) {
              case 194:
                return expr.name;
              case 195:
                var arg = expr.argumentExpression;
                if (isIdentifier(arg)) {
                  return arg;
                }
            }
            break;
          case 200: {
            return getDeclarationIdentifier(hostNode.expression);
          }
          case 238: {
            if (isDeclaration(hostNode.statement) || isExpression(hostNode.statement)) {
              return getDeclarationIdentifier(hostNode.statement);
            }
            break;
          }
        }
      }
      function getDeclarationIdentifier(node) {
        var name = getNameOfDeclaration(node);
        return name && isIdentifier(name) ? name : void 0;
      }
      function nodeHasName(statement, name) {
        if (isNamedDeclaration(statement) && isIdentifier(statement.name) && idText(statement.name) === idText(name)) {
          return true;
        }
        if (isVariableStatement(statement) && ts2.some(statement.declarationList.declarations, function(d) {
          return nodeHasName(d, name);
        })) {
          return true;
        }
        return false;
      }
      ts2.nodeHasName = nodeHasName;
      function getNameOfJSDocTypedef(declaration) {
        return declaration.name || nameForNamelessJSDocTypedef(declaration);
      }
      ts2.getNameOfJSDocTypedef = getNameOfJSDocTypedef;
      function isNamedDeclaration(node) {
        return !!node.name;
      }
      ts2.isNamedDeclaration = isNamedDeclaration;
      function getNonAssignedNameOfDeclaration(declaration) {
        switch (declaration.kind) {
          case 75:
            return declaration;
          case 323:
          case 317: {
            var name = declaration.name;
            if (name.kind === 153) {
              return name.right;
            }
            break;
          }
          case 196:
          case 209: {
            var expr_1 = declaration;
            switch (ts2.getAssignmentDeclarationKind(expr_1)) {
              case 1:
              case 4:
              case 5:
              case 3:
                return ts2.getElementOrPropertyAccessArgumentExpressionOrName(expr_1.left);
              case 7:
              case 8:
              case 9:
                return expr_1.arguments[1];
              default:
                return void 0;
            }
          }
          case 322:
            return getNameOfJSDocTypedef(declaration);
          case 316:
            return nameForNamelessJSDocTypedef(declaration);
          case 259: {
            var expression = declaration.expression;
            return isIdentifier(expression) ? expression : void 0;
          }
          case 195:
            var expr = declaration;
            if (ts2.isBindableStaticElementAccessExpression(expr)) {
              return expr.argumentExpression;
            }
        }
        return declaration.name;
      }
      ts2.getNonAssignedNameOfDeclaration = getNonAssignedNameOfDeclaration;
      function getNameOfDeclaration(declaration) {
        if (declaration === void 0)
          return void 0;
        return getNonAssignedNameOfDeclaration(declaration) || (isFunctionExpression(declaration) || isClassExpression(declaration) ? getAssignedName(declaration) : void 0);
      }
      ts2.getNameOfDeclaration = getNameOfDeclaration;
      function getAssignedName(node) {
        if (!node.parent) {
          return void 0;
        } else if (isPropertyAssignment(node.parent) || isBindingElement(node.parent)) {
          return node.parent.name;
        } else if (isBinaryExpression(node.parent) && node === node.parent.right) {
          if (isIdentifier(node.parent.left)) {
            return node.parent.left;
          } else if (ts2.isAccessExpression(node.parent.left)) {
            return ts2.getElementOrPropertyAccessArgumentExpressionOrName(node.parent.left);
          }
        } else if (isVariableDeclaration(node.parent) && isIdentifier(node.parent.name)) {
          return node.parent.name;
        }
      }
      function getJSDocParameterTags(param) {
        if (param.name) {
          if (isIdentifier(param.name)) {
            var name_1 = param.name.escapedText;
            return getJSDocTags(param.parent).filter(function(tag) {
              return isJSDocParameterTag(tag) && isIdentifier(tag.name) && tag.name.escapedText === name_1;
            });
          } else {
            var i = param.parent.parameters.indexOf(param);
            ts2.Debug.assert(i > -1, "Parameters should always be in their parents' parameter list");
            var paramTags = getJSDocTags(param.parent).filter(isJSDocParameterTag);
            if (i < paramTags.length) {
              return [paramTags[i]];
            }
          }
        }
        return ts2.emptyArray;
      }
      ts2.getJSDocParameterTags = getJSDocParameterTags;
      function getJSDocTypeParameterTags(param) {
        var name = param.name.escapedText;
        return getJSDocTags(param.parent).filter(function(tag) {
          return isJSDocTemplateTag(tag) && tag.typeParameters.some(function(tp) {
            return tp.name.escapedText === name;
          });
        });
      }
      ts2.getJSDocTypeParameterTags = getJSDocTypeParameterTags;
      function hasJSDocParameterTags(node) {
        return !!getFirstJSDocTag(node, isJSDocParameterTag);
      }
      ts2.hasJSDocParameterTags = hasJSDocParameterTags;
      function getJSDocAugmentsTag(node) {
        return getFirstJSDocTag(node, isJSDocAugmentsTag);
      }
      ts2.getJSDocAugmentsTag = getJSDocAugmentsTag;
      function getJSDocImplementsTags(node) {
        return getAllJSDocTags(node, isJSDocImplementsTag);
      }
      ts2.getJSDocImplementsTags = getJSDocImplementsTags;
      function getJSDocClassTag(node) {
        return getFirstJSDocTag(node, isJSDocClassTag);
      }
      ts2.getJSDocClassTag = getJSDocClassTag;
      function getJSDocPublicTag(node) {
        return getFirstJSDocTag(node, isJSDocPublicTag);
      }
      ts2.getJSDocPublicTag = getJSDocPublicTag;
      function getJSDocPrivateTag(node) {
        return getFirstJSDocTag(node, isJSDocPrivateTag);
      }
      ts2.getJSDocPrivateTag = getJSDocPrivateTag;
      function getJSDocProtectedTag(node) {
        return getFirstJSDocTag(node, isJSDocProtectedTag);
      }
      ts2.getJSDocProtectedTag = getJSDocProtectedTag;
      function getJSDocReadonlyTag(node) {
        return getFirstJSDocTag(node, isJSDocReadonlyTag);
      }
      ts2.getJSDocReadonlyTag = getJSDocReadonlyTag;
      function getJSDocEnumTag(node) {
        return getFirstJSDocTag(node, isJSDocEnumTag);
      }
      ts2.getJSDocEnumTag = getJSDocEnumTag;
      function getJSDocThisTag(node) {
        return getFirstJSDocTag(node, isJSDocThisTag);
      }
      ts2.getJSDocThisTag = getJSDocThisTag;
      function getJSDocReturnTag(node) {
        return getFirstJSDocTag(node, isJSDocReturnTag);
      }
      ts2.getJSDocReturnTag = getJSDocReturnTag;
      function getJSDocTemplateTag(node) {
        return getFirstJSDocTag(node, isJSDocTemplateTag);
      }
      ts2.getJSDocTemplateTag = getJSDocTemplateTag;
      function getJSDocTypeTag(node) {
        var tag = getFirstJSDocTag(node, isJSDocTypeTag);
        if (tag && tag.typeExpression && tag.typeExpression.type) {
          return tag;
        }
        return void 0;
      }
      ts2.getJSDocTypeTag = getJSDocTypeTag;
      function getJSDocType(node) {
        var tag = getFirstJSDocTag(node, isJSDocTypeTag);
        if (!tag && isParameter(node)) {
          tag = ts2.find(getJSDocParameterTags(node), function(tag2) {
            return !!tag2.typeExpression;
          });
        }
        return tag && tag.typeExpression && tag.typeExpression.type;
      }
      ts2.getJSDocType = getJSDocType;
      function getJSDocReturnType(node) {
        var returnTag = getJSDocReturnTag(node);
        if (returnTag && returnTag.typeExpression) {
          return returnTag.typeExpression.type;
        }
        var typeTag = getJSDocTypeTag(node);
        if (typeTag && typeTag.typeExpression) {
          var type = typeTag.typeExpression.type;
          if (isTypeLiteralNode(type)) {
            var sig = ts2.find(type.members, isCallSignatureDeclaration);
            return sig && sig.type;
          }
          if (isFunctionTypeNode(type) || isJSDocFunctionType(type)) {
            return type.type;
          }
        }
      }
      ts2.getJSDocReturnType = getJSDocReturnType;
      function getJSDocTags(node) {
        var tags = node.jsDocCache;
        if (tags === void 0) {
          var comments = ts2.getJSDocCommentsAndTags(node);
          ts2.Debug.assert(comments.length < 2 || comments[0] !== comments[1]);
          node.jsDocCache = tags = ts2.flatMap(comments, function(j) {
            return isJSDoc(j) ? j.tags : j;
          });
        }
        return tags;
      }
      ts2.getJSDocTags = getJSDocTags;
      function getFirstJSDocTag(node, predicate) {
        return ts2.find(getJSDocTags(node), predicate);
      }
      function getAllJSDocTags(node, predicate) {
        return getJSDocTags(node).filter(predicate);
      }
      ts2.getAllJSDocTags = getAllJSDocTags;
      function getAllJSDocTagsOfKind(node, kind) {
        return getJSDocTags(node).filter(function(doc) {
          return doc.kind === kind;
        });
      }
      ts2.getAllJSDocTagsOfKind = getAllJSDocTagsOfKind;
      function getEffectiveTypeParameterDeclarations(node) {
        if (isJSDocSignature(node)) {
          return ts2.emptyArray;
        }
        if (ts2.isJSDocTypeAlias(node)) {
          ts2.Debug.assert(node.parent.kind === 303);
          return ts2.flatMap(node.parent.tags, function(tag) {
            return isJSDocTemplateTag(tag) ? tag.typeParameters : void 0;
          });
        }
        if (node.typeParameters) {
          return node.typeParameters;
        }
        if (ts2.isInJSFile(node)) {
          var decls = ts2.getJSDocTypeParameterDeclarations(node);
          if (decls.length) {
            return decls;
          }
          var typeTag = getJSDocType(node);
          if (typeTag && isFunctionTypeNode(typeTag) && typeTag.typeParameters) {
            return typeTag.typeParameters;
          }
        }
        return ts2.emptyArray;
      }
      ts2.getEffectiveTypeParameterDeclarations = getEffectiveTypeParameterDeclarations;
      function getEffectiveConstraintOfTypeParameter(node) {
        return node.constraint ? node.constraint : isJSDocTemplateTag(node.parent) && node === node.parent.typeParameters[0] ? node.parent.constraint : void 0;
      }
      ts2.getEffectiveConstraintOfTypeParameter = getEffectiveConstraintOfTypeParameter;
      function isNumericLiteral(node) {
        return node.kind === 8;
      }
      ts2.isNumericLiteral = isNumericLiteral;
      function isBigIntLiteral(node) {
        return node.kind === 9;
      }
      ts2.isBigIntLiteral = isBigIntLiteral;
      function isStringLiteral(node) {
        return node.kind === 10;
      }
      ts2.isStringLiteral = isStringLiteral;
      function isJsxText(node) {
        return node.kind === 11;
      }
      ts2.isJsxText = isJsxText;
      function isRegularExpressionLiteral(node) {
        return node.kind === 13;
      }
      ts2.isRegularExpressionLiteral = isRegularExpressionLiteral;
      function isNoSubstitutionTemplateLiteral(node) {
        return node.kind === 14;
      }
      ts2.isNoSubstitutionTemplateLiteral = isNoSubstitutionTemplateLiteral;
      function isTemplateHead(node) {
        return node.kind === 15;
      }
      ts2.isTemplateHead = isTemplateHead;
      function isTemplateMiddle(node) {
        return node.kind === 16;
      }
      ts2.isTemplateMiddle = isTemplateMiddle;
      function isTemplateTail(node) {
        return node.kind === 17;
      }
      ts2.isTemplateTail = isTemplateTail;
      function isIdentifier(node) {
        return node.kind === 75;
      }
      ts2.isIdentifier = isIdentifier;
      function isQualifiedName(node) {
        return node.kind === 153;
      }
      ts2.isQualifiedName = isQualifiedName;
      function isComputedPropertyName(node) {
        return node.kind === 154;
      }
      ts2.isComputedPropertyName = isComputedPropertyName;
      function isPrivateIdentifier(node) {
        return node.kind === 76;
      }
      ts2.isPrivateIdentifier = isPrivateIdentifier;
      function isIdentifierOrPrivateIdentifier(node) {
        return node.kind === 75 || node.kind === 76;
      }
      ts2.isIdentifierOrPrivateIdentifier = isIdentifierOrPrivateIdentifier;
      function isTypeParameterDeclaration(node) {
        return node.kind === 155;
      }
      ts2.isTypeParameterDeclaration = isTypeParameterDeclaration;
      function isParameter(node) {
        return node.kind === 156;
      }
      ts2.isParameter = isParameter;
      function isDecorator(node) {
        return node.kind === 157;
      }
      ts2.isDecorator = isDecorator;
      function isPropertySignature(node) {
        return node.kind === 158;
      }
      ts2.isPropertySignature = isPropertySignature;
      function isPropertyDeclaration(node) {
        return node.kind === 159;
      }
      ts2.isPropertyDeclaration = isPropertyDeclaration;
      function isMethodSignature(node) {
        return node.kind === 160;
      }
      ts2.isMethodSignature = isMethodSignature;
      function isMethodDeclaration(node) {
        return node.kind === 161;
      }
      ts2.isMethodDeclaration = isMethodDeclaration;
      function isConstructorDeclaration(node) {
        return node.kind === 162;
      }
      ts2.isConstructorDeclaration = isConstructorDeclaration;
      function isGetAccessorDeclaration(node) {
        return node.kind === 163;
      }
      ts2.isGetAccessorDeclaration = isGetAccessorDeclaration;
      function isSetAccessorDeclaration(node) {
        return node.kind === 164;
      }
      ts2.isSetAccessorDeclaration = isSetAccessorDeclaration;
      function isCallSignatureDeclaration(node) {
        return node.kind === 165;
      }
      ts2.isCallSignatureDeclaration = isCallSignatureDeclaration;
      function isConstructSignatureDeclaration(node) {
        return node.kind === 166;
      }
      ts2.isConstructSignatureDeclaration = isConstructSignatureDeclaration;
      function isIndexSignatureDeclaration(node) {
        return node.kind === 167;
      }
      ts2.isIndexSignatureDeclaration = isIndexSignatureDeclaration;
      function isGetOrSetAccessorDeclaration(node) {
        return node.kind === 164 || node.kind === 163;
      }
      ts2.isGetOrSetAccessorDeclaration = isGetOrSetAccessorDeclaration;
      function isTypePredicateNode(node) {
        return node.kind === 168;
      }
      ts2.isTypePredicateNode = isTypePredicateNode;
      function isTypeReferenceNode(node) {
        return node.kind === 169;
      }
      ts2.isTypeReferenceNode = isTypeReferenceNode;
      function isFunctionTypeNode(node) {
        return node.kind === 170;
      }
      ts2.isFunctionTypeNode = isFunctionTypeNode;
      function isConstructorTypeNode(node) {
        return node.kind === 171;
      }
      ts2.isConstructorTypeNode = isConstructorTypeNode;
      function isTypeQueryNode(node) {
        return node.kind === 172;
      }
      ts2.isTypeQueryNode = isTypeQueryNode;
      function isTypeLiteralNode(node) {
        return node.kind === 173;
      }
      ts2.isTypeLiteralNode = isTypeLiteralNode;
      function isArrayTypeNode(node) {
        return node.kind === 174;
      }
      ts2.isArrayTypeNode = isArrayTypeNode;
      function isTupleTypeNode(node) {
        return node.kind === 175;
      }
      ts2.isTupleTypeNode = isTupleTypeNode;
      function isUnionTypeNode(node) {
        return node.kind === 178;
      }
      ts2.isUnionTypeNode = isUnionTypeNode;
      function isIntersectionTypeNode(node) {
        return node.kind === 179;
      }
      ts2.isIntersectionTypeNode = isIntersectionTypeNode;
      function isConditionalTypeNode(node) {
        return node.kind === 180;
      }
      ts2.isConditionalTypeNode = isConditionalTypeNode;
      function isInferTypeNode(node) {
        return node.kind === 181;
      }
      ts2.isInferTypeNode = isInferTypeNode;
      function isParenthesizedTypeNode(node) {
        return node.kind === 182;
      }
      ts2.isParenthesizedTypeNode = isParenthesizedTypeNode;
      function isThisTypeNode(node) {
        return node.kind === 183;
      }
      ts2.isThisTypeNode = isThisTypeNode;
      function isTypeOperatorNode(node) {
        return node.kind === 184;
      }
      ts2.isTypeOperatorNode = isTypeOperatorNode;
      function isIndexedAccessTypeNode(node) {
        return node.kind === 185;
      }
      ts2.isIndexedAccessTypeNode = isIndexedAccessTypeNode;
      function isMappedTypeNode(node) {
        return node.kind === 186;
      }
      ts2.isMappedTypeNode = isMappedTypeNode;
      function isLiteralTypeNode(node) {
        return node.kind === 187;
      }
      ts2.isLiteralTypeNode = isLiteralTypeNode;
      function isImportTypeNode(node) {
        return node.kind === 188;
      }
      ts2.isImportTypeNode = isImportTypeNode;
      function isObjectBindingPattern(node) {
        return node.kind === 189;
      }
      ts2.isObjectBindingPattern = isObjectBindingPattern;
      function isArrayBindingPattern(node) {
        return node.kind === 190;
      }
      ts2.isArrayBindingPattern = isArrayBindingPattern;
      function isBindingElement(node) {
        return node.kind === 191;
      }
      ts2.isBindingElement = isBindingElement;
      function isArrayLiteralExpression(node) {
        return node.kind === 192;
      }
      ts2.isArrayLiteralExpression = isArrayLiteralExpression;
      function isObjectLiteralExpression(node) {
        return node.kind === 193;
      }
      ts2.isObjectLiteralExpression = isObjectLiteralExpression;
      function isPropertyAccessExpression(node) {
        return node.kind === 194;
      }
      ts2.isPropertyAccessExpression = isPropertyAccessExpression;
      function isPropertyAccessChain(node) {
        return isPropertyAccessExpression(node) && !!(node.flags & 32);
      }
      ts2.isPropertyAccessChain = isPropertyAccessChain;
      function isElementAccessExpression(node) {
        return node.kind === 195;
      }
      ts2.isElementAccessExpression = isElementAccessExpression;
      function isElementAccessChain(node) {
        return isElementAccessExpression(node) && !!(node.flags & 32);
      }
      ts2.isElementAccessChain = isElementAccessChain;
      function isCallExpression(node) {
        return node.kind === 196;
      }
      ts2.isCallExpression = isCallExpression;
      function isCallChain(node) {
        return isCallExpression(node) && !!(node.flags & 32);
      }
      ts2.isCallChain = isCallChain;
      function isOptionalChain(node) {
        var kind = node.kind;
        return !!(node.flags & 32) && (kind === 194 || kind === 195 || kind === 196 || kind === 218);
      }
      ts2.isOptionalChain = isOptionalChain;
      function isOptionalChainRoot(node) {
        return isOptionalChain(node) && !isNonNullExpression(node) && !!node.questionDotToken;
      }
      ts2.isOptionalChainRoot = isOptionalChainRoot;
      function isExpressionOfOptionalChainRoot(node) {
        return isOptionalChainRoot(node.parent) && node.parent.expression === node;
      }
      ts2.isExpressionOfOptionalChainRoot = isExpressionOfOptionalChainRoot;
      function isOutermostOptionalChain(node) {
        return !isOptionalChain(node.parent) || isOptionalChainRoot(node.parent) || node !== node.parent.expression;
      }
      ts2.isOutermostOptionalChain = isOutermostOptionalChain;
      function isNullishCoalesce(node) {
        return node.kind === 209 && node.operatorToken.kind === 60;
      }
      ts2.isNullishCoalesce = isNullishCoalesce;
      function isNewExpression(node) {
        return node.kind === 197;
      }
      ts2.isNewExpression = isNewExpression;
      function isTaggedTemplateExpression(node) {
        return node.kind === 198;
      }
      ts2.isTaggedTemplateExpression = isTaggedTemplateExpression;
      function isTypeAssertion(node) {
        return node.kind === 199;
      }
      ts2.isTypeAssertion = isTypeAssertion;
      function isConstTypeReference(node) {
        return isTypeReferenceNode(node) && isIdentifier(node.typeName) && node.typeName.escapedText === "const" && !node.typeArguments;
      }
      ts2.isConstTypeReference = isConstTypeReference;
      function isParenthesizedExpression(node) {
        return node.kind === 200;
      }
      ts2.isParenthesizedExpression = isParenthesizedExpression;
      function skipPartiallyEmittedExpressions(node) {
        return ts2.skipOuterExpressions(node, 8);
      }
      ts2.skipPartiallyEmittedExpressions = skipPartiallyEmittedExpressions;
      function isFunctionExpression(node) {
        return node.kind === 201;
      }
      ts2.isFunctionExpression = isFunctionExpression;
      function isArrowFunction(node) {
        return node.kind === 202;
      }
      ts2.isArrowFunction = isArrowFunction;
      function isDeleteExpression(node) {
        return node.kind === 203;
      }
      ts2.isDeleteExpression = isDeleteExpression;
      function isTypeOfExpression(node) {
        return node.kind === 204;
      }
      ts2.isTypeOfExpression = isTypeOfExpression;
      function isVoidExpression(node) {
        return node.kind === 205;
      }
      ts2.isVoidExpression = isVoidExpression;
      function isAwaitExpression(node) {
        return node.kind === 206;
      }
      ts2.isAwaitExpression = isAwaitExpression;
      function isPrefixUnaryExpression(node) {
        return node.kind === 207;
      }
      ts2.isPrefixUnaryExpression = isPrefixUnaryExpression;
      function isPostfixUnaryExpression(node) {
        return node.kind === 208;
      }
      ts2.isPostfixUnaryExpression = isPostfixUnaryExpression;
      function isBinaryExpression(node) {
        return node.kind === 209;
      }
      ts2.isBinaryExpression = isBinaryExpression;
      function isConditionalExpression(node) {
        return node.kind === 210;
      }
      ts2.isConditionalExpression = isConditionalExpression;
      function isTemplateExpression(node) {
        return node.kind === 211;
      }
      ts2.isTemplateExpression = isTemplateExpression;
      function isYieldExpression(node) {
        return node.kind === 212;
      }
      ts2.isYieldExpression = isYieldExpression;
      function isSpreadElement(node) {
        return node.kind === 213;
      }
      ts2.isSpreadElement = isSpreadElement;
      function isClassExpression(node) {
        return node.kind === 214;
      }
      ts2.isClassExpression = isClassExpression;
      function isOmittedExpression(node) {
        return node.kind === 215;
      }
      ts2.isOmittedExpression = isOmittedExpression;
      function isExpressionWithTypeArguments(node) {
        return node.kind === 216;
      }
      ts2.isExpressionWithTypeArguments = isExpressionWithTypeArguments;
      function isAsExpression(node) {
        return node.kind === 217;
      }
      ts2.isAsExpression = isAsExpression;
      function isNonNullExpression(node) {
        return node.kind === 218;
      }
      ts2.isNonNullExpression = isNonNullExpression;
      function isNonNullChain(node) {
        return isNonNullExpression(node) && !!(node.flags & 32);
      }
      ts2.isNonNullChain = isNonNullChain;
      function isMetaProperty(node) {
        return node.kind === 219;
      }
      ts2.isMetaProperty = isMetaProperty;
      function isTemplateSpan(node) {
        return node.kind === 221;
      }
      ts2.isTemplateSpan = isTemplateSpan;
      function isSemicolonClassElement(node) {
        return node.kind === 222;
      }
      ts2.isSemicolonClassElement = isSemicolonClassElement;
      function isBlock(node) {
        return node.kind === 223;
      }
      ts2.isBlock = isBlock;
      function isVariableStatement(node) {
        return node.kind === 225;
      }
      ts2.isVariableStatement = isVariableStatement;
      function isEmptyStatement(node) {
        return node.kind === 224;
      }
      ts2.isEmptyStatement = isEmptyStatement;
      function isExpressionStatement(node) {
        return node.kind === 226;
      }
      ts2.isExpressionStatement = isExpressionStatement;
      function isIfStatement(node) {
        return node.kind === 227;
      }
      ts2.isIfStatement = isIfStatement;
      function isDoStatement(node) {
        return node.kind === 228;
      }
      ts2.isDoStatement = isDoStatement;
      function isWhileStatement(node) {
        return node.kind === 229;
      }
      ts2.isWhileStatement = isWhileStatement;
      function isForStatement(node) {
        return node.kind === 230;
      }
      ts2.isForStatement = isForStatement;
      function isForInStatement(node) {
        return node.kind === 231;
      }
      ts2.isForInStatement = isForInStatement;
      function isForOfStatement(node) {
        return node.kind === 232;
      }
      ts2.isForOfStatement = isForOfStatement;
      function isContinueStatement(node) {
        return node.kind === 233;
      }
      ts2.isContinueStatement = isContinueStatement;
      function isBreakStatement(node) {
        return node.kind === 234;
      }
      ts2.isBreakStatement = isBreakStatement;
      function isBreakOrContinueStatement(node) {
        return node.kind === 234 || node.kind === 233;
      }
      ts2.isBreakOrContinueStatement = isBreakOrContinueStatement;
      function isReturnStatement(node) {
        return node.kind === 235;
      }
      ts2.isReturnStatement = isReturnStatement;
      function isWithStatement(node) {
        return node.kind === 236;
      }
      ts2.isWithStatement = isWithStatement;
      function isSwitchStatement(node) {
        return node.kind === 237;
      }
      ts2.isSwitchStatement = isSwitchStatement;
      function isLabeledStatement(node) {
        return node.kind === 238;
      }
      ts2.isLabeledStatement = isLabeledStatement;
      function isThrowStatement(node) {
        return node.kind === 239;
      }
      ts2.isThrowStatement = isThrowStatement;
      function isTryStatement(node) {
        return node.kind === 240;
      }
      ts2.isTryStatement = isTryStatement;
      function isDebuggerStatement(node) {
        return node.kind === 241;
      }
      ts2.isDebuggerStatement = isDebuggerStatement;
      function isVariableDeclaration(node) {
        return node.kind === 242;
      }
      ts2.isVariableDeclaration = isVariableDeclaration;
      function isVariableDeclarationList(node) {
        return node.kind === 243;
      }
      ts2.isVariableDeclarationList = isVariableDeclarationList;
      function isFunctionDeclaration(node) {
        return node.kind === 244;
      }
      ts2.isFunctionDeclaration = isFunctionDeclaration;
      function isClassDeclaration(node) {
        return node.kind === 245;
      }
      ts2.isClassDeclaration = isClassDeclaration;
      function isInterfaceDeclaration(node) {
        return node.kind === 246;
      }
      ts2.isInterfaceDeclaration = isInterfaceDeclaration;
      function isTypeAliasDeclaration(node) {
        return node.kind === 247;
      }
      ts2.isTypeAliasDeclaration = isTypeAliasDeclaration;
      function isEnumDeclaration(node) {
        return node.kind === 248;
      }
      ts2.isEnumDeclaration = isEnumDeclaration;
      function isModuleDeclaration(node) {
        return node.kind === 249;
      }
      ts2.isModuleDeclaration = isModuleDeclaration;
      function isModuleBlock(node) {
        return node.kind === 250;
      }
      ts2.isModuleBlock = isModuleBlock;
      function isCaseBlock(node) {
        return node.kind === 251;
      }
      ts2.isCaseBlock = isCaseBlock;
      function isNamespaceExportDeclaration(node) {
        return node.kind === 252;
      }
      ts2.isNamespaceExportDeclaration = isNamespaceExportDeclaration;
      function isImportEqualsDeclaration(node) {
        return node.kind === 253;
      }
      ts2.isImportEqualsDeclaration = isImportEqualsDeclaration;
      function isImportDeclaration(node) {
        return node.kind === 254;
      }
      ts2.isImportDeclaration = isImportDeclaration;
      function isImportClause(node) {
        return node.kind === 255;
      }
      ts2.isImportClause = isImportClause;
      function isNamespaceImport(node) {
        return node.kind === 256;
      }
      ts2.isNamespaceImport = isNamespaceImport;
      function isNamespaceExport(node) {
        return node.kind === 262;
      }
      ts2.isNamespaceExport = isNamespaceExport;
      function isNamedExportBindings(node) {
        return node.kind === 262 || node.kind === 261;
      }
      ts2.isNamedExportBindings = isNamedExportBindings;
      function isNamedImports(node) {
        return node.kind === 257;
      }
      ts2.isNamedImports = isNamedImports;
      function isImportSpecifier(node) {
        return node.kind === 258;
      }
      ts2.isImportSpecifier = isImportSpecifier;
      function isExportAssignment(node) {
        return node.kind === 259;
      }
      ts2.isExportAssignment = isExportAssignment;
      function isExportDeclaration(node) {
        return node.kind === 260;
      }
      ts2.isExportDeclaration = isExportDeclaration;
      function isNamedExports(node) {
        return node.kind === 261;
      }
      ts2.isNamedExports = isNamedExports;
      function isExportSpecifier(node) {
        return node.kind === 263;
      }
      ts2.isExportSpecifier = isExportSpecifier;
      function isMissingDeclaration(node) {
        return node.kind === 264;
      }
      ts2.isMissingDeclaration = isMissingDeclaration;
      function isExternalModuleReference(node) {
        return node.kind === 265;
      }
      ts2.isExternalModuleReference = isExternalModuleReference;
      function isJsxElement(node) {
        return node.kind === 266;
      }
      ts2.isJsxElement = isJsxElement;
      function isJsxSelfClosingElement(node) {
        return node.kind === 267;
      }
      ts2.isJsxSelfClosingElement = isJsxSelfClosingElement;
      function isJsxOpeningElement(node) {
        return node.kind === 268;
      }
      ts2.isJsxOpeningElement = isJsxOpeningElement;
      function isJsxClosingElement(node) {
        return node.kind === 269;
      }
      ts2.isJsxClosingElement = isJsxClosingElement;
      function isJsxFragment(node) {
        return node.kind === 270;
      }
      ts2.isJsxFragment = isJsxFragment;
      function isJsxOpeningFragment(node) {
        return node.kind === 271;
      }
      ts2.isJsxOpeningFragment = isJsxOpeningFragment;
      function isJsxClosingFragment(node) {
        return node.kind === 272;
      }
      ts2.isJsxClosingFragment = isJsxClosingFragment;
      function isJsxAttribute(node) {
        return node.kind === 273;
      }
      ts2.isJsxAttribute = isJsxAttribute;
      function isJsxAttributes(node) {
        return node.kind === 274;
      }
      ts2.isJsxAttributes = isJsxAttributes;
      function isJsxSpreadAttribute(node) {
        return node.kind === 275;
      }
      ts2.isJsxSpreadAttribute = isJsxSpreadAttribute;
      function isJsxExpression(node) {
        return node.kind === 276;
      }
      ts2.isJsxExpression = isJsxExpression;
      function isCaseClause(node) {
        return node.kind === 277;
      }
      ts2.isCaseClause = isCaseClause;
      function isDefaultClause(node) {
        return node.kind === 278;
      }
      ts2.isDefaultClause = isDefaultClause;
      function isHeritageClause(node) {
        return node.kind === 279;
      }
      ts2.isHeritageClause = isHeritageClause;
      function isCatchClause(node) {
        return node.kind === 280;
      }
      ts2.isCatchClause = isCatchClause;
      function isPropertyAssignment(node) {
        return node.kind === 281;
      }
      ts2.isPropertyAssignment = isPropertyAssignment;
      function isShorthandPropertyAssignment(node) {
        return node.kind === 282;
      }
      ts2.isShorthandPropertyAssignment = isShorthandPropertyAssignment;
      function isSpreadAssignment(node) {
        return node.kind === 283;
      }
      ts2.isSpreadAssignment = isSpreadAssignment;
      function isEnumMember(node) {
        return node.kind === 284;
      }
      ts2.isEnumMember = isEnumMember;
      function isSourceFile(node) {
        return node.kind === 290;
      }
      ts2.isSourceFile = isSourceFile;
      function isBundle(node) {
        return node.kind === 291;
      }
      ts2.isBundle = isBundle;
      function isUnparsedSource(node) {
        return node.kind === 292;
      }
      ts2.isUnparsedSource = isUnparsedSource;
      function isUnparsedPrepend(node) {
        return node.kind === 286;
      }
      ts2.isUnparsedPrepend = isUnparsedPrepend;
      function isUnparsedTextLike(node) {
        switch (node.kind) {
          case 287:
          case 288:
            return true;
          default:
            return false;
        }
      }
      ts2.isUnparsedTextLike = isUnparsedTextLike;
      function isUnparsedNode(node) {
        return isUnparsedTextLike(node) || node.kind === 285 || node.kind === 289;
      }
      ts2.isUnparsedNode = isUnparsedNode;
      function isJSDocTypeExpression(node) {
        return node.kind === 294;
      }
      ts2.isJSDocTypeExpression = isJSDocTypeExpression;
      function isJSDocAllType(node) {
        return node.kind === 295;
      }
      ts2.isJSDocAllType = isJSDocAllType;
      function isJSDocUnknownType(node) {
        return node.kind === 296;
      }
      ts2.isJSDocUnknownType = isJSDocUnknownType;
      function isJSDocNullableType(node) {
        return node.kind === 297;
      }
      ts2.isJSDocNullableType = isJSDocNullableType;
      function isJSDocNonNullableType(node) {
        return node.kind === 298;
      }
      ts2.isJSDocNonNullableType = isJSDocNonNullableType;
      function isJSDocOptionalType(node) {
        return node.kind === 299;
      }
      ts2.isJSDocOptionalType = isJSDocOptionalType;
      function isJSDocFunctionType(node) {
        return node.kind === 300;
      }
      ts2.isJSDocFunctionType = isJSDocFunctionType;
      function isJSDocVariadicType(node) {
        return node.kind === 301;
      }
      ts2.isJSDocVariadicType = isJSDocVariadicType;
      function isJSDoc(node) {
        return node.kind === 303;
      }
      ts2.isJSDoc = isJSDoc;
      function isJSDocAuthorTag(node) {
        return node.kind === 309;
      }
      ts2.isJSDocAuthorTag = isJSDocAuthorTag;
      function isJSDocAugmentsTag(node) {
        return node.kind === 307;
      }
      ts2.isJSDocAugmentsTag = isJSDocAugmentsTag;
      function isJSDocImplementsTag(node) {
        return node.kind === 308;
      }
      ts2.isJSDocImplementsTag = isJSDocImplementsTag;
      function isJSDocClassTag(node) {
        return node.kind === 310;
      }
      ts2.isJSDocClassTag = isJSDocClassTag;
      function isJSDocPublicTag(node) {
        return node.kind === 311;
      }
      ts2.isJSDocPublicTag = isJSDocPublicTag;
      function isJSDocPrivateTag(node) {
        return node.kind === 312;
      }
      ts2.isJSDocPrivateTag = isJSDocPrivateTag;
      function isJSDocProtectedTag(node) {
        return node.kind === 313;
      }
      ts2.isJSDocProtectedTag = isJSDocProtectedTag;
      function isJSDocReadonlyTag(node) {
        return node.kind === 314;
      }
      ts2.isJSDocReadonlyTag = isJSDocReadonlyTag;
      function isJSDocEnumTag(node) {
        return node.kind === 316;
      }
      ts2.isJSDocEnumTag = isJSDocEnumTag;
      function isJSDocThisTag(node) {
        return node.kind === 319;
      }
      ts2.isJSDocThisTag = isJSDocThisTag;
      function isJSDocParameterTag(node) {
        return node.kind === 317;
      }
      ts2.isJSDocParameterTag = isJSDocParameterTag;
      function isJSDocReturnTag(node) {
        return node.kind === 318;
      }
      ts2.isJSDocReturnTag = isJSDocReturnTag;
      function isJSDocTypeTag(node) {
        return node.kind === 320;
      }
      ts2.isJSDocTypeTag = isJSDocTypeTag;
      function isJSDocTemplateTag(node) {
        return node.kind === 321;
      }
      ts2.isJSDocTemplateTag = isJSDocTemplateTag;
      function isJSDocTypedefTag(node) {
        return node.kind === 322;
      }
      ts2.isJSDocTypedefTag = isJSDocTypedefTag;
      function isJSDocPropertyTag(node) {
        return node.kind === 323;
      }
      ts2.isJSDocPropertyTag = isJSDocPropertyTag;
      function isJSDocPropertyLikeTag(node) {
        return node.kind === 323 || node.kind === 317;
      }
      ts2.isJSDocPropertyLikeTag = isJSDocPropertyLikeTag;
      function isJSDocTypeLiteral(node) {
        return node.kind === 304;
      }
      ts2.isJSDocTypeLiteral = isJSDocTypeLiteral;
      function isJSDocCallbackTag(node) {
        return node.kind === 315;
      }
      ts2.isJSDocCallbackTag = isJSDocCallbackTag;
      function isJSDocSignature(node) {
        return node.kind === 305;
      }
      ts2.isJSDocSignature = isJSDocSignature;
      function isSyntaxList(n) {
        return n.kind === 324;
      }
      ts2.isSyntaxList = isSyntaxList;
      function isNode(node) {
        return isNodeKind(node.kind);
      }
      ts2.isNode = isNode;
      function isNodeKind(kind) {
        return kind >= 153;
      }
      ts2.isNodeKind = isNodeKind;
      function isToken(n) {
        return n.kind >= 0 && n.kind <= 152;
      }
      ts2.isToken = isToken;
      function isNodeArray(array) {
        return array.hasOwnProperty("pos") && array.hasOwnProperty("end");
      }
      ts2.isNodeArray = isNodeArray;
      function isLiteralKind(kind) {
        return 8 <= kind && kind <= 14;
      }
      ts2.isLiteralKind = isLiteralKind;
      function isLiteralExpression(node) {
        return isLiteralKind(node.kind);
      }
      ts2.isLiteralExpression = isLiteralExpression;
      function isTemplateLiteralKind(kind) {
        return 14 <= kind && kind <= 17;
      }
      ts2.isTemplateLiteralKind = isTemplateLiteralKind;
      function isTemplateLiteralToken(node) {
        return isTemplateLiteralKind(node.kind);
      }
      ts2.isTemplateLiteralToken = isTemplateLiteralToken;
      function isTemplateMiddleOrTemplateTail(node) {
        var kind = node.kind;
        return kind === 16 || kind === 17;
      }
      ts2.isTemplateMiddleOrTemplateTail = isTemplateMiddleOrTemplateTail;
      function isImportOrExportSpecifier(node) {
        return isImportSpecifier(node) || isExportSpecifier(node);
      }
      ts2.isImportOrExportSpecifier = isImportOrExportSpecifier;
      function isTypeOnlyImportOrExportDeclaration(node) {
        switch (node.kind) {
          case 258:
          case 263:
            return node.parent.parent.isTypeOnly;
          case 256:
            return node.parent.isTypeOnly;
          case 255:
            return node.isTypeOnly;
          default:
            return false;
        }
      }
      ts2.isTypeOnlyImportOrExportDeclaration = isTypeOnlyImportOrExportDeclaration;
      function isStringTextContainingNode(node) {
        return node.kind === 10 || isTemplateLiteralKind(node.kind);
      }
      ts2.isStringTextContainingNode = isStringTextContainingNode;
      function isGeneratedIdentifier(node) {
        return isIdentifier(node) && (node.autoGenerateFlags & 7) > 0;
      }
      ts2.isGeneratedIdentifier = isGeneratedIdentifier;
      function isPrivateIdentifierPropertyDeclaration(node) {
        return isPropertyDeclaration(node) && isPrivateIdentifier(node.name);
      }
      ts2.isPrivateIdentifierPropertyDeclaration = isPrivateIdentifierPropertyDeclaration;
      function isPrivateIdentifierPropertyAccessExpression(node) {
        return isPropertyAccessExpression(node) && isPrivateIdentifier(node.name);
      }
      ts2.isPrivateIdentifierPropertyAccessExpression = isPrivateIdentifierPropertyAccessExpression;
      function isModifierKind(token) {
        switch (token) {
          case 122:
          case 126:
          case 81:
          case 130:
          case 84:
          case 89:
          case 119:
          case 117:
          case 118:
          case 138:
          case 120:
            return true;
        }
        return false;
      }
      ts2.isModifierKind = isModifierKind;
      function isParameterPropertyModifier(kind) {
        return !!(ts2.modifierToFlag(kind) & 92);
      }
      ts2.isParameterPropertyModifier = isParameterPropertyModifier;
      function isClassMemberModifier(idToken) {
        return isParameterPropertyModifier(idToken) || idToken === 120;
      }
      ts2.isClassMemberModifier = isClassMemberModifier;
      function isModifier(node) {
        return isModifierKind(node.kind);
      }
      ts2.isModifier = isModifier;
      function isEntityName(node) {
        var kind = node.kind;
        return kind === 153 || kind === 75;
      }
      ts2.isEntityName = isEntityName;
      function isPropertyName(node) {
        var kind = node.kind;
        return kind === 75 || kind === 76 || kind === 10 || kind === 8 || kind === 154;
      }
      ts2.isPropertyName = isPropertyName;
      function isBindingName(node) {
        var kind = node.kind;
        return kind === 75 || kind === 189 || kind === 190;
      }
      ts2.isBindingName = isBindingName;
      function isFunctionLike(node) {
        return node && isFunctionLikeKind(node.kind);
      }
      ts2.isFunctionLike = isFunctionLike;
      function isFunctionLikeDeclaration(node) {
        return node && isFunctionLikeDeclarationKind(node.kind);
      }
      ts2.isFunctionLikeDeclaration = isFunctionLikeDeclaration;
      function isFunctionLikeDeclarationKind(kind) {
        switch (kind) {
          case 244:
          case 161:
          case 162:
          case 163:
          case 164:
          case 201:
          case 202:
            return true;
          default:
            return false;
        }
      }
      function isFunctionLikeKind(kind) {
        switch (kind) {
          case 160:
          case 165:
          case 305:
          case 166:
          case 167:
          case 170:
          case 300:
          case 171:
            return true;
          default:
            return isFunctionLikeDeclarationKind(kind);
        }
      }
      ts2.isFunctionLikeKind = isFunctionLikeKind;
      function isFunctionOrModuleBlock(node) {
        return isSourceFile(node) || isModuleBlock(node) || isBlock(node) && isFunctionLike(node.parent);
      }
      ts2.isFunctionOrModuleBlock = isFunctionOrModuleBlock;
      function isClassElement(node) {
        var kind = node.kind;
        return kind === 162 || kind === 159 || kind === 161 || kind === 163 || kind === 164 || kind === 167 || kind === 222;
      }
      ts2.isClassElement = isClassElement;
      function isClassLike(node) {
        return node && (node.kind === 245 || node.kind === 214);
      }
      ts2.isClassLike = isClassLike;
      function isAccessor(node) {
        return node && (node.kind === 163 || node.kind === 164);
      }
      ts2.isAccessor = isAccessor;
      function isMethodOrAccessor(node) {
        switch (node.kind) {
          case 161:
          case 163:
          case 164:
            return true;
          default:
            return false;
        }
      }
      ts2.isMethodOrAccessor = isMethodOrAccessor;
      function isTypeElement(node) {
        var kind = node.kind;
        return kind === 166 || kind === 165 || kind === 158 || kind === 160 || kind === 167;
      }
      ts2.isTypeElement = isTypeElement;
      function isClassOrTypeElement(node) {
        return isTypeElement(node) || isClassElement(node);
      }
      ts2.isClassOrTypeElement = isClassOrTypeElement;
      function isObjectLiteralElementLike(node) {
        var kind = node.kind;
        return kind === 281 || kind === 282 || kind === 283 || kind === 161 || kind === 163 || kind === 164;
      }
      ts2.isObjectLiteralElementLike = isObjectLiteralElementLike;
      function isTypeNode(node) {
        return ts2.isTypeNodeKind(node.kind);
      }
      ts2.isTypeNode = isTypeNode;
      function isFunctionOrConstructorTypeNode(node) {
        switch (node.kind) {
          case 170:
          case 171:
            return true;
        }
        return false;
      }
      ts2.isFunctionOrConstructorTypeNode = isFunctionOrConstructorTypeNode;
      function isBindingPattern(node) {
        if (node) {
          var kind = node.kind;
          return kind === 190 || kind === 189;
        }
        return false;
      }
      ts2.isBindingPattern = isBindingPattern;
      function isAssignmentPattern(node) {
        var kind = node.kind;
        return kind === 192 || kind === 193;
      }
      ts2.isAssignmentPattern = isAssignmentPattern;
      function isArrayBindingElement(node) {
        var kind = node.kind;
        return kind === 191 || kind === 215;
      }
      ts2.isArrayBindingElement = isArrayBindingElement;
      function isDeclarationBindingElement(bindingElement) {
        switch (bindingElement.kind) {
          case 242:
          case 156:
          case 191:
            return true;
        }
        return false;
      }
      ts2.isDeclarationBindingElement = isDeclarationBindingElement;
      function isBindingOrAssignmentPattern(node) {
        return isObjectBindingOrAssignmentPattern(node) || isArrayBindingOrAssignmentPattern(node);
      }
      ts2.isBindingOrAssignmentPattern = isBindingOrAssignmentPattern;
      function isObjectBindingOrAssignmentPattern(node) {
        switch (node.kind) {
          case 189:
          case 193:
            return true;
        }
        return false;
      }
      ts2.isObjectBindingOrAssignmentPattern = isObjectBindingOrAssignmentPattern;
      function isArrayBindingOrAssignmentPattern(node) {
        switch (node.kind) {
          case 190:
          case 192:
            return true;
        }
        return false;
      }
      ts2.isArrayBindingOrAssignmentPattern = isArrayBindingOrAssignmentPattern;
      function isPropertyAccessOrQualifiedNameOrImportTypeNode(node) {
        var kind = node.kind;
        return kind === 194 || kind === 153 || kind === 188;
      }
      ts2.isPropertyAccessOrQualifiedNameOrImportTypeNode = isPropertyAccessOrQualifiedNameOrImportTypeNode;
      function isPropertyAccessOrQualifiedName(node) {
        var kind = node.kind;
        return kind === 194 || kind === 153;
      }
      ts2.isPropertyAccessOrQualifiedName = isPropertyAccessOrQualifiedName;
      function isCallLikeExpression(node) {
        switch (node.kind) {
          case 268:
          case 267:
          case 196:
          case 197:
          case 198:
          case 157:
            return true;
          default:
            return false;
        }
      }
      ts2.isCallLikeExpression = isCallLikeExpression;
      function isCallOrNewExpression(node) {
        return node.kind === 196 || node.kind === 197;
      }
      ts2.isCallOrNewExpression = isCallOrNewExpression;
      function isTemplateLiteral(node) {
        var kind = node.kind;
        return kind === 211 || kind === 14;
      }
      ts2.isTemplateLiteral = isTemplateLiteral;
      function isLeftHandSideExpression(node) {
        return isLeftHandSideExpressionKind(skipPartiallyEmittedExpressions(node).kind);
      }
      ts2.isLeftHandSideExpression = isLeftHandSideExpression;
      function isLeftHandSideExpressionKind(kind) {
        switch (kind) {
          case 194:
          case 195:
          case 197:
          case 196:
          case 266:
          case 267:
          case 270:
          case 198:
          case 192:
          case 200:
          case 193:
          case 214:
          case 201:
          case 75:
          case 13:
          case 8:
          case 9:
          case 10:
          case 14:
          case 211:
          case 91:
          case 100:
          case 104:
          case 106:
          case 102:
          case 218:
          case 219:
          case 96:
            return true;
          default:
            return false;
        }
      }
      function isUnaryExpression(node) {
        return isUnaryExpressionKind(skipPartiallyEmittedExpressions(node).kind);
      }
      ts2.isUnaryExpression = isUnaryExpression;
      function isUnaryExpressionKind(kind) {
        switch (kind) {
          case 207:
          case 208:
          case 203:
          case 204:
          case 205:
          case 206:
          case 199:
            return true;
          default:
            return isLeftHandSideExpressionKind(kind);
        }
      }
      function isUnaryExpressionWithWrite(expr) {
        switch (expr.kind) {
          case 208:
            return true;
          case 207:
            return expr.operator === 45 || expr.operator === 46;
          default:
            return false;
        }
      }
      ts2.isUnaryExpressionWithWrite = isUnaryExpressionWithWrite;
      function isExpression(node) {
        return isExpressionKind(skipPartiallyEmittedExpressions(node).kind);
      }
      ts2.isExpression = isExpression;
      function isExpressionKind(kind) {
        switch (kind) {
          case 210:
          case 212:
          case 202:
          case 209:
          case 213:
          case 217:
          case 215:
          case 327:
          case 326:
            return true;
          default:
            return isUnaryExpressionKind(kind);
        }
      }
      function isAssertionExpression(node) {
        var kind = node.kind;
        return kind === 199 || kind === 217;
      }
      ts2.isAssertionExpression = isAssertionExpression;
      function isPartiallyEmittedExpression(node) {
        return node.kind === 326;
      }
      ts2.isPartiallyEmittedExpression = isPartiallyEmittedExpression;
      function isNotEmittedStatement(node) {
        return node.kind === 325;
      }
      ts2.isNotEmittedStatement = isNotEmittedStatement;
      function isSyntheticReference(node) {
        return node.kind === 330;
      }
      ts2.isSyntheticReference = isSyntheticReference;
      function isNotEmittedOrPartiallyEmittedNode(node) {
        return isNotEmittedStatement(node) || isPartiallyEmittedExpression(node);
      }
      ts2.isNotEmittedOrPartiallyEmittedNode = isNotEmittedOrPartiallyEmittedNode;
      function isIterationStatement(node, lookInLabeledStatements) {
        switch (node.kind) {
          case 230:
          case 231:
          case 232:
          case 228:
          case 229:
            return true;
          case 238:
            return lookInLabeledStatements && isIterationStatement(node.statement, lookInLabeledStatements);
        }
        return false;
      }
      ts2.isIterationStatement = isIterationStatement;
      function isScopeMarker(node) {
        return isExportAssignment(node) || isExportDeclaration(node);
      }
      ts2.isScopeMarker = isScopeMarker;
      function hasScopeMarker(statements) {
        return ts2.some(statements, isScopeMarker);
      }
      ts2.hasScopeMarker = hasScopeMarker;
      function needsScopeMarker(result) {
        return !ts2.isAnyImportOrReExport(result) && !isExportAssignment(result) && !ts2.hasModifier(result, 1) && !ts2.isAmbientModule(result);
      }
      ts2.needsScopeMarker = needsScopeMarker;
      function isExternalModuleIndicator(result) {
        return ts2.isAnyImportOrReExport(result) || isExportAssignment(result) || ts2.hasModifier(result, 1);
      }
      ts2.isExternalModuleIndicator = isExternalModuleIndicator;
      function isForInOrOfStatement(node) {
        return node.kind === 231 || node.kind === 232;
      }
      ts2.isForInOrOfStatement = isForInOrOfStatement;
      function isConciseBody(node) {
        return isBlock(node) || isExpression(node);
      }
      ts2.isConciseBody = isConciseBody;
      function isFunctionBody(node) {
        return isBlock(node);
      }
      ts2.isFunctionBody = isFunctionBody;
      function isForInitializer(node) {
        return isVariableDeclarationList(node) || isExpression(node);
      }
      ts2.isForInitializer = isForInitializer;
      function isModuleBody(node) {
        var kind = node.kind;
        return kind === 250 || kind === 249 || kind === 75;
      }
      ts2.isModuleBody = isModuleBody;
      function isNamespaceBody(node) {
        var kind = node.kind;
        return kind === 250 || kind === 249;
      }
      ts2.isNamespaceBody = isNamespaceBody;
      function isJSDocNamespaceBody(node) {
        var kind = node.kind;
        return kind === 75 || kind === 249;
      }
      ts2.isJSDocNamespaceBody = isJSDocNamespaceBody;
      function isNamedImportBindings(node) {
        var kind = node.kind;
        return kind === 257 || kind === 256;
      }
      ts2.isNamedImportBindings = isNamedImportBindings;
      function isModuleOrEnumDeclaration(node) {
        return node.kind === 249 || node.kind === 248;
      }
      ts2.isModuleOrEnumDeclaration = isModuleOrEnumDeclaration;
      function isDeclarationKind(kind) {
        return kind === 202 || kind === 191 || kind === 245 || kind === 214 || kind === 162 || kind === 248 || kind === 284 || kind === 263 || kind === 244 || kind === 201 || kind === 163 || kind === 255 || kind === 253 || kind === 258 || kind === 246 || kind === 273 || kind === 161 || kind === 160 || kind === 249 || kind === 252 || kind === 256 || kind === 262 || kind === 156 || kind === 281 || kind === 159 || kind === 158 || kind === 164 || kind === 282 || kind === 247 || kind === 155 || kind === 242 || kind === 322 || kind === 315 || kind === 323;
      }
      function isDeclarationStatementKind(kind) {
        return kind === 244 || kind === 264 || kind === 245 || kind === 246 || kind === 247 || kind === 248 || kind === 249 || kind === 254 || kind === 253 || kind === 260 || kind === 259 || kind === 252;
      }
      function isStatementKindButNotDeclarationKind(kind) {
        return kind === 234 || kind === 233 || kind === 241 || kind === 228 || kind === 226 || kind === 224 || kind === 231 || kind === 232 || kind === 230 || kind === 227 || kind === 238 || kind === 235 || kind === 237 || kind === 239 || kind === 240 || kind === 225 || kind === 229 || kind === 236 || kind === 325 || kind === 329 || kind === 328;
      }
      function isDeclaration(node) {
        if (node.kind === 155) {
          return node.parent && node.parent.kind !== 321 || ts2.isInJSFile(node);
        }
        return isDeclarationKind(node.kind);
      }
      ts2.isDeclaration = isDeclaration;
      function isDeclarationStatement(node) {
        return isDeclarationStatementKind(node.kind);
      }
      ts2.isDeclarationStatement = isDeclarationStatement;
      function isStatementButNotDeclaration(node) {
        return isStatementKindButNotDeclarationKind(node.kind);
      }
      ts2.isStatementButNotDeclaration = isStatementButNotDeclaration;
      function isStatement(node) {
        var kind = node.kind;
        return isStatementKindButNotDeclarationKind(kind) || isDeclarationStatementKind(kind) || isBlockStatement(node);
      }
      ts2.isStatement = isStatement;
      function isBlockStatement(node) {
        if (node.kind !== 223)
          return false;
        if (node.parent !== void 0) {
          if (node.parent.kind === 240 || node.parent.kind === 280) {
            return false;
          }
        }
        return !ts2.isFunctionBlock(node);
      }
      function isModuleReference(node) {
        var kind = node.kind;
        return kind === 265 || kind === 153 || kind === 75;
      }
      ts2.isModuleReference = isModuleReference;
      function isJsxTagNameExpression(node) {
        var kind = node.kind;
        return kind === 104 || kind === 75 || kind === 194;
      }
      ts2.isJsxTagNameExpression = isJsxTagNameExpression;
      function isJsxChild(node) {
        var kind = node.kind;
        return kind === 266 || kind === 276 || kind === 267 || kind === 11 || kind === 270;
      }
      ts2.isJsxChild = isJsxChild;
      function isJsxAttributeLike(node) {
        var kind = node.kind;
        return kind === 273 || kind === 275;
      }
      ts2.isJsxAttributeLike = isJsxAttributeLike;
      function isStringLiteralOrJsxExpression(node) {
        var kind = node.kind;
        return kind === 10 || kind === 276;
      }
      ts2.isStringLiteralOrJsxExpression = isStringLiteralOrJsxExpression;
      function isJsxOpeningLikeElement(node) {
        var kind = node.kind;
        return kind === 268 || kind === 267;
      }
      ts2.isJsxOpeningLikeElement = isJsxOpeningLikeElement;
      function isCaseOrDefaultClause(node) {
        var kind = node.kind;
        return kind === 277 || kind === 278;
      }
      ts2.isCaseOrDefaultClause = isCaseOrDefaultClause;
      function isJSDocNode(node) {
        return node.kind >= 294 && node.kind <= 323;
      }
      ts2.isJSDocNode = isJSDocNode;
      function isJSDocCommentContainingNode(node) {
        return node.kind === 303 || node.kind === 302 || isJSDocTag(node) || isJSDocTypeLiteral(node) || isJSDocSignature(node);
      }
      ts2.isJSDocCommentContainingNode = isJSDocCommentContainingNode;
      function isJSDocTag(node) {
        return node.kind >= 306 && node.kind <= 323;
      }
      ts2.isJSDocTag = isJSDocTag;
      function isSetAccessor(node) {
        return node.kind === 164;
      }
      ts2.isSetAccessor = isSetAccessor;
      function isGetAccessor(node) {
        return node.kind === 163;
      }
      ts2.isGetAccessor = isGetAccessor;
      function hasJSDocNodes(node) {
        var jsDoc = node.jsDoc;
        return !!jsDoc && jsDoc.length > 0;
      }
      ts2.hasJSDocNodes = hasJSDocNodes;
      function hasType(node) {
        return !!node.type;
      }
      ts2.hasType = hasType;
      function hasInitializer(node) {
        return !!node.initializer;
      }
      ts2.hasInitializer = hasInitializer;
      function hasOnlyExpressionInitializer(node) {
        switch (node.kind) {
          case 242:
          case 156:
          case 191:
          case 158:
          case 159:
          case 281:
          case 284:
            return true;
          default:
            return false;
        }
      }
      ts2.hasOnlyExpressionInitializer = hasOnlyExpressionInitializer;
      function isObjectLiteralElement(node) {
        return node.kind === 273 || node.kind === 275 || isObjectLiteralElementLike(node);
      }
      ts2.isObjectLiteralElement = isObjectLiteralElement;
      function isTypeReferenceType(node) {
        return node.kind === 169 || node.kind === 216;
      }
      ts2.isTypeReferenceType = isTypeReferenceType;
      var MAX_SMI_X86 = 1073741823;
      function guessIndentation(lines) {
        var indentation = MAX_SMI_X86;
        for (var _i = 0, lines_1 = lines; _i < lines_1.length; _i++) {
          var line = lines_1[_i];
          if (!line.length) {
            continue;
          }
          var i = 0;
          for (; i < line.length && i < indentation; i++) {
            if (!ts2.isWhiteSpaceLike(line.charCodeAt(i))) {
              break;
            }
          }
          if (i < indentation) {
            indentation = i;
          }
          if (indentation === 0) {
            return 0;
          }
        }
        return indentation === MAX_SMI_X86 ? void 0 : indentation;
      }
      ts2.guessIndentation = guessIndentation;
      function isStringLiteralLike(node) {
        return node.kind === 10 || node.kind === 14;
      }
      ts2.isStringLiteralLike = isStringLiteralLike;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      ts2.resolvingEmptyArray = [];
      ts2.emptyMap = ts2.createMap();
      ts2.emptyUnderscoreEscapedMap = ts2.emptyMap;
      ts2.externalHelpersModuleNameText = "tslib";
      ts2.defaultMaximumTruncationLength = 160;
      ts2.noTruncationMaximumTruncationLength = 1e6;
      function getDeclarationOfKind(symbol, kind) {
        var declarations = symbol.declarations;
        if (declarations) {
          for (var _i = 0, declarations_1 = declarations; _i < declarations_1.length; _i++) {
            var declaration = declarations_1[_i];
            if (declaration.kind === kind) {
              return declaration;
            }
          }
        }
        return void 0;
      }
      ts2.getDeclarationOfKind = getDeclarationOfKind;
      function createUnderscoreEscapedMap() {
        return new ts2.Map();
      }
      ts2.createUnderscoreEscapedMap = createUnderscoreEscapedMap;
      function hasEntries(map) {
        return !!map && !!map.size;
      }
      ts2.hasEntries = hasEntries;
      function createSymbolTable(symbols) {
        var result = ts2.createMap();
        if (symbols) {
          for (var _i = 0, symbols_1 = symbols; _i < symbols_1.length; _i++) {
            var symbol = symbols_1[_i];
            result.set(symbol.escapedName, symbol);
          }
        }
        return result;
      }
      ts2.createSymbolTable = createSymbolTable;
      function isTransientSymbol(symbol) {
        return (symbol.flags & 33554432) !== 0;
      }
      ts2.isTransientSymbol = isTransientSymbol;
      var stringWriter = createSingleLineStringWriter();
      function createSingleLineStringWriter() {
        var str = "";
        var writeText = function(text) {
          return str += text;
        };
        return {
          getText: function() {
            return str;
          },
          write: writeText,
          rawWrite: writeText,
          writeKeyword: writeText,
          writeOperator: writeText,
          writePunctuation: writeText,
          writeSpace: writeText,
          writeStringLiteral: writeText,
          writeLiteral: writeText,
          writeParameter: writeText,
          writeProperty: writeText,
          writeSymbol: function(s, _) {
            return writeText(s);
          },
          writeTrailingSemicolon: writeText,
          writeComment: writeText,
          getTextPos: function() {
            return str.length;
          },
          getLine: function() {
            return 0;
          },
          getColumn: function() {
            return 0;
          },
          getIndent: function() {
            return 0;
          },
          isAtStartOfLine: function() {
            return false;
          },
          hasTrailingComment: function() {
            return false;
          },
          hasTrailingWhitespace: function() {
            return !!str.length && ts2.isWhiteSpaceLike(str.charCodeAt(str.length - 1));
          },
          writeLine: function() {
            return str += " ";
          },
          increaseIndent: ts2.noop,
          decreaseIndent: ts2.noop,
          clear: function() {
            return str = "";
          },
          trackSymbol: ts2.noop,
          reportInaccessibleThisError: ts2.noop,
          reportInaccessibleUniqueSymbolError: ts2.noop,
          reportPrivateInBaseOfClassExpression: ts2.noop
        };
      }
      function changesAffectModuleResolution(oldOptions, newOptions) {
        return oldOptions.configFilePath !== newOptions.configFilePath || optionsHaveModuleResolutionChanges(oldOptions, newOptions);
      }
      ts2.changesAffectModuleResolution = changesAffectModuleResolution;
      function optionsHaveModuleResolutionChanges(oldOptions, newOptions) {
        return ts2.moduleResolutionOptionDeclarations.some(function(o) {
          return !isJsonEqual(getCompilerOptionValue(oldOptions, o), getCompilerOptionValue(newOptions, o));
        });
      }
      ts2.optionsHaveModuleResolutionChanges = optionsHaveModuleResolutionChanges;
      function findAncestor(node, callback) {
        while (node) {
          var result = callback(node);
          if (result === "quit") {
            return void 0;
          } else if (result) {
            return node;
          }
          node = node.parent;
        }
        return void 0;
      }
      ts2.findAncestor = findAncestor;
      function forEachAncestor(node, callback) {
        while (true) {
          var res = callback(node);
          if (res === "quit")
            return void 0;
          if (res !== void 0)
            return res;
          if (ts2.isSourceFile(node))
            return void 0;
          node = node.parent;
        }
      }
      ts2.forEachAncestor = forEachAncestor;
      function forEachEntry(map, callback) {
        var iterator = map.entries();
        for (var iterResult = iterator.next(); !iterResult.done; iterResult = iterator.next()) {
          var _a = iterResult.value, key = _a[0], value = _a[1];
          var result = callback(value, key);
          if (result) {
            return result;
          }
        }
        return void 0;
      }
      ts2.forEachEntry = forEachEntry;
      function forEachKey(map, callback) {
        var iterator = map.keys();
        for (var iterResult = iterator.next(); !iterResult.done; iterResult = iterator.next()) {
          var result = callback(iterResult.value);
          if (result) {
            return result;
          }
        }
        return void 0;
      }
      ts2.forEachKey = forEachKey;
      function copyEntries(source, target) {
        source.forEach(function(value, key) {
          target.set(key, value);
        });
      }
      ts2.copyEntries = copyEntries;
      function arrayToSet(array, makeKey) {
        return ts2.arrayToMap(array, makeKey || function(s) {
          return s;
        }, ts2.returnTrue);
      }
      ts2.arrayToSet = arrayToSet;
      function cloneMap(map) {
        var clone = ts2.createMap();
        copyEntries(map, clone);
        return clone;
      }
      ts2.cloneMap = cloneMap;
      function usingSingleLineStringWriter(action) {
        var oldString = stringWriter.getText();
        try {
          action(stringWriter);
          return stringWriter.getText();
        } finally {
          stringWriter.clear();
          stringWriter.writeKeyword(oldString);
        }
      }
      ts2.usingSingleLineStringWriter = usingSingleLineStringWriter;
      function getFullWidth(node) {
        return node.end - node.pos;
      }
      ts2.getFullWidth = getFullWidth;
      function getResolvedModule(sourceFile, moduleNameText) {
        return sourceFile && sourceFile.resolvedModules && sourceFile.resolvedModules.get(moduleNameText);
      }
      ts2.getResolvedModule = getResolvedModule;
      function setResolvedModule(sourceFile, moduleNameText, resolvedModule) {
        if (!sourceFile.resolvedModules) {
          sourceFile.resolvedModules = ts2.createMap();
        }
        sourceFile.resolvedModules.set(moduleNameText, resolvedModule);
      }
      ts2.setResolvedModule = setResolvedModule;
      function setResolvedTypeReferenceDirective(sourceFile, typeReferenceDirectiveName, resolvedTypeReferenceDirective) {
        if (!sourceFile.resolvedTypeReferenceDirectiveNames) {
          sourceFile.resolvedTypeReferenceDirectiveNames = ts2.createMap();
        }
        sourceFile.resolvedTypeReferenceDirectiveNames.set(typeReferenceDirectiveName, resolvedTypeReferenceDirective);
      }
      ts2.setResolvedTypeReferenceDirective = setResolvedTypeReferenceDirective;
      function projectReferenceIsEqualTo(oldRef, newRef) {
        return oldRef.path === newRef.path && !oldRef.prepend === !newRef.prepend && !oldRef.circular === !newRef.circular;
      }
      ts2.projectReferenceIsEqualTo = projectReferenceIsEqualTo;
      function moduleResolutionIsEqualTo(oldResolution, newResolution) {
        return oldResolution.isExternalLibraryImport === newResolution.isExternalLibraryImport && oldResolution.extension === newResolution.extension && oldResolution.resolvedFileName === newResolution.resolvedFileName && oldResolution.originalPath === newResolution.originalPath && packageIdIsEqual(oldResolution.packageId, newResolution.packageId);
      }
      ts2.moduleResolutionIsEqualTo = moduleResolutionIsEqualTo;
      function packageIdIsEqual(a, b) {
        return a === b || !!a && !!b && a.name === b.name && a.subModuleName === b.subModuleName && a.version === b.version;
      }
      function packageIdToString(_a) {
        var name = _a.name, subModuleName = _a.subModuleName, version = _a.version;
        var fullName = subModuleName ? name + "/" + subModuleName : name;
        return fullName + "@" + version;
      }
      ts2.packageIdToString = packageIdToString;
      function typeDirectiveIsEqualTo(oldResolution, newResolution) {
        return oldResolution.resolvedFileName === newResolution.resolvedFileName && oldResolution.primary === newResolution.primary;
      }
      ts2.typeDirectiveIsEqualTo = typeDirectiveIsEqualTo;
      function hasChangesInResolutions(names, newResolutions, oldResolutions, comparer) {
        ts2.Debug.assert(names.length === newResolutions.length);
        for (var i = 0; i < names.length; i++) {
          var newResolution = newResolutions[i];
          var oldResolution = oldResolutions && oldResolutions.get(names[i]);
          var changed = oldResolution ? !newResolution || !comparer(oldResolution, newResolution) : newResolution;
          if (changed) {
            return true;
          }
        }
        return false;
      }
      ts2.hasChangesInResolutions = hasChangesInResolutions;
      function containsParseError(node) {
        aggregateChildData(node);
        return (node.flags & 262144) !== 0;
      }
      ts2.containsParseError = containsParseError;
      function aggregateChildData(node) {
        if (!(node.flags & 524288)) {
          var thisNodeOrAnySubNodesHasError = (node.flags & 65536) !== 0 || ts2.forEachChild(node, containsParseError);
          if (thisNodeOrAnySubNodesHasError) {
            node.flags |= 262144;
          }
          node.flags |= 524288;
        }
      }
      function getSourceFileOfNode(node) {
        while (node && node.kind !== 290) {
          node = node.parent;
        }
        return node;
      }
      ts2.getSourceFileOfNode = getSourceFileOfNode;
      function isStatementWithLocals(node) {
        switch (node.kind) {
          case 223:
          case 251:
          case 230:
          case 231:
          case 232:
            return true;
        }
        return false;
      }
      ts2.isStatementWithLocals = isStatementWithLocals;
      function getStartPositionOfLine(line, sourceFile) {
        ts2.Debug.assert(line >= 0);
        return ts2.getLineStarts(sourceFile)[line];
      }
      ts2.getStartPositionOfLine = getStartPositionOfLine;
      function nodePosToString(node) {
        var file = getSourceFileOfNode(node);
        var loc = ts2.getLineAndCharacterOfPosition(file, node.pos);
        return file.fileName + "(" + (loc.line + 1) + "," + (loc.character + 1) + ")";
      }
      ts2.nodePosToString = nodePosToString;
      function getEndLinePosition(line, sourceFile) {
        ts2.Debug.assert(line >= 0);
        var lineStarts = ts2.getLineStarts(sourceFile);
        var lineIndex = line;
        var sourceText = sourceFile.text;
        if (lineIndex + 1 === lineStarts.length) {
          return sourceText.length - 1;
        } else {
          var start = lineStarts[lineIndex];
          var pos = lineStarts[lineIndex + 1] - 1;
          ts2.Debug.assert(ts2.isLineBreak(sourceText.charCodeAt(pos)));
          while (start <= pos && ts2.isLineBreak(sourceText.charCodeAt(pos))) {
            pos--;
          }
          return pos;
        }
      }
      ts2.getEndLinePosition = getEndLinePosition;
      function isFileLevelUniqueName(sourceFile, name, hasGlobalName) {
        return !(hasGlobalName && hasGlobalName(name)) && !sourceFile.identifiers.has(name);
      }
      ts2.isFileLevelUniqueName = isFileLevelUniqueName;
      function nodeIsMissing(node) {
        if (node === void 0) {
          return true;
        }
        return node.pos === node.end && node.pos >= 0 && node.kind !== 1;
      }
      ts2.nodeIsMissing = nodeIsMissing;
      function nodeIsPresent(node) {
        return !nodeIsMissing(node);
      }
      ts2.nodeIsPresent = nodeIsPresent;
      function insertStatementsAfterPrologue(to, from, isPrologueDirective2) {
        if (from === void 0 || from.length === 0)
          return to;
        var statementIndex = 0;
        for (; statementIndex < to.length; ++statementIndex) {
          if (!isPrologueDirective2(to[statementIndex])) {
            break;
          }
        }
        to.splice.apply(to, __spreadArrays([statementIndex, 0], from));
        return to;
      }
      function insertStatementAfterPrologue(to, statement, isPrologueDirective2) {
        if (statement === void 0)
          return to;
        var statementIndex = 0;
        for (; statementIndex < to.length; ++statementIndex) {
          if (!isPrologueDirective2(to[statementIndex])) {
            break;
          }
        }
        to.splice(statementIndex, 0, statement);
        return to;
      }
      function isAnyPrologueDirective(node) {
        return isPrologueDirective(node) || !!(getEmitFlags(node) & 1048576);
      }
      function insertStatementsAfterStandardPrologue(to, from) {
        return insertStatementsAfterPrologue(to, from, isPrologueDirective);
      }
      ts2.insertStatementsAfterStandardPrologue = insertStatementsAfterStandardPrologue;
      function insertStatementsAfterCustomPrologue(to, from) {
        return insertStatementsAfterPrologue(to, from, isAnyPrologueDirective);
      }
      ts2.insertStatementsAfterCustomPrologue = insertStatementsAfterCustomPrologue;
      function insertStatementAfterStandardPrologue(to, statement) {
        return insertStatementAfterPrologue(to, statement, isPrologueDirective);
      }
      ts2.insertStatementAfterStandardPrologue = insertStatementAfterStandardPrologue;
      function insertStatementAfterCustomPrologue(to, statement) {
        return insertStatementAfterPrologue(to, statement, isAnyPrologueDirective);
      }
      ts2.insertStatementAfterCustomPrologue = insertStatementAfterCustomPrologue;
      function isRecognizedTripleSlashComment(text, commentPos, commentEnd) {
        if (text.charCodeAt(commentPos + 1) === 47 && commentPos + 2 < commentEnd && text.charCodeAt(commentPos + 2) === 47) {
          var textSubStr = text.substring(commentPos, commentEnd);
          return textSubStr.match(ts2.fullTripleSlashReferencePathRegEx) || textSubStr.match(ts2.fullTripleSlashAMDReferencePathRegEx) || textSubStr.match(fullTripleSlashReferenceTypeReferenceDirectiveRegEx) || textSubStr.match(defaultLibReferenceRegEx) ? true : false;
        }
        return false;
      }
      ts2.isRecognizedTripleSlashComment = isRecognizedTripleSlashComment;
      function isPinnedComment(text, start) {
        return text.charCodeAt(start + 1) === 42 && text.charCodeAt(start + 2) === 33;
      }
      ts2.isPinnedComment = isPinnedComment;
      function createCommentDirectivesMap(sourceFile, commentDirectives) {
        var directivesByLine = ts2.createMapFromEntries(commentDirectives.map(function(commentDirective) {
          return [
            "" + ts2.getLineAndCharacterOfPosition(sourceFile, commentDirective.range.end).line,
            commentDirective
          ];
        }));
        var usedLines = ts2.createMap();
        return { getUnusedExpectations, markUsed };
        function getUnusedExpectations() {
          return ts2.arrayFrom(directivesByLine.entries()).filter(function(_a) {
            var line = _a[0], directive = _a[1];
            return directive.type === 0 && !usedLines.get(line);
          }).map(function(_a) {
            var _ = _a[0], directive = _a[1];
            return directive;
          });
        }
        function markUsed(line) {
          if (!directivesByLine.has("" + line)) {
            return false;
          }
          usedLines.set("" + line, true);
          return true;
        }
      }
      ts2.createCommentDirectivesMap = createCommentDirectivesMap;
      function getTokenPosOfNode(node, sourceFile, includeJsDoc) {
        if (nodeIsMissing(node)) {
          return node.pos;
        }
        if (ts2.isJSDocNode(node)) {
          return ts2.skipTrivia((sourceFile || getSourceFileOfNode(node)).text, node.pos, false, true);
        }
        if (includeJsDoc && ts2.hasJSDocNodes(node)) {
          return getTokenPosOfNode(node.jsDoc[0], sourceFile);
        }
        if (node.kind === 324 && node._children.length > 0) {
          return getTokenPosOfNode(node._children[0], sourceFile, includeJsDoc);
        }
        return ts2.skipTrivia((sourceFile || getSourceFileOfNode(node)).text, node.pos);
      }
      ts2.getTokenPosOfNode = getTokenPosOfNode;
      function getNonDecoratorTokenPosOfNode(node, sourceFile) {
        if (nodeIsMissing(node) || !node.decorators) {
          return getTokenPosOfNode(node, sourceFile);
        }
        return ts2.skipTrivia((sourceFile || getSourceFileOfNode(node)).text, node.decorators.end);
      }
      ts2.getNonDecoratorTokenPosOfNode = getNonDecoratorTokenPosOfNode;
      function getSourceTextOfNodeFromSourceFile(sourceFile, node, includeTrivia) {
        if (includeTrivia === void 0) {
          includeTrivia = false;
        }
        return getTextOfNodeFromSourceText(sourceFile.text, node, includeTrivia);
      }
      ts2.getSourceTextOfNodeFromSourceFile = getSourceTextOfNodeFromSourceFile;
      function isJSDocTypeExpressionOrChild(node) {
        return !!findAncestor(node, ts2.isJSDocTypeExpression);
      }
      function getTextOfNodeFromSourceText(sourceText, node, includeTrivia) {
        if (includeTrivia === void 0) {
          includeTrivia = false;
        }
        if (nodeIsMissing(node)) {
          return "";
        }
        var text = sourceText.substring(includeTrivia ? node.pos : ts2.skipTrivia(sourceText, node.pos), node.end);
        if (isJSDocTypeExpressionOrChild(node)) {
          text = text.replace(/(^|\r?\n|\r)\s*\*\s*/g, "$1");
        }
        return text;
      }
      ts2.getTextOfNodeFromSourceText = getTextOfNodeFromSourceText;
      function getTextOfNode(node, includeTrivia) {
        if (includeTrivia === void 0) {
          includeTrivia = false;
        }
        return getSourceTextOfNodeFromSourceFile(getSourceFileOfNode(node), node, includeTrivia);
      }
      ts2.getTextOfNode = getTextOfNode;
      function getPos(range) {
        return range.pos;
      }
      function indexOfNode(nodeArray, node) {
        return ts2.binarySearch(nodeArray, node, getPos, ts2.compareValues);
      }
      ts2.indexOfNode = indexOfNode;
      function getEmitFlags(node) {
        var emitNode = node.emitNode;
        return emitNode && emitNode.flags || 0;
      }
      ts2.getEmitFlags = getEmitFlags;
      function getLiteralText(node, sourceFile, neverAsciiEscape, jsxAttributeEscape) {
        if (!nodeIsSynthesized(node) && node.parent && !(ts2.isNumericLiteral(node) && node.numericLiteralFlags & 512 || ts2.isBigIntLiteral(node))) {
          return getSourceTextOfNodeFromSourceFile(sourceFile, node);
        }
        switch (node.kind) {
          case 10: {
            var escapeText = jsxAttributeEscape ? escapeJsxAttributeString : neverAsciiEscape || getEmitFlags(node) & 16777216 ? escapeString : escapeNonAsciiString;
            if (node.singleQuote) {
              return "'" + escapeText(node.text, 39) + "'";
            } else {
              return '"' + escapeText(node.text, 34) + '"';
            }
          }
          case 14:
          case 15:
          case 16:
          case 17: {
            var escapeText = neverAsciiEscape || getEmitFlags(node) & 16777216 ? escapeString : escapeNonAsciiString;
            var rawText = node.rawText || escapeTemplateSubstitution(escapeText(node.text, 96));
            switch (node.kind) {
              case 14:
                return "`" + rawText + "`";
              case 15:
                return "`" + rawText + "${";
              case 16:
                return "}" + rawText + "${";
              case 17:
                return "}" + rawText + "`";
            }
            break;
          }
          case 8:
          case 9:
          case 13:
            return node.text;
        }
        return ts2.Debug.fail("Literal kind '" + node.kind + "' not accounted for.");
      }
      ts2.getLiteralText = getLiteralText;
      function getTextOfConstantValue(value) {
        return ts2.isString(value) ? '"' + escapeNonAsciiString(value) + '"' : "" + value;
      }
      ts2.getTextOfConstantValue = getTextOfConstantValue;
      function makeIdentifierFromModuleName(moduleName) {
        return ts2.getBaseFileName(moduleName).replace(/^(\d)/, "_$1").replace(/\W/g, "_");
      }
      ts2.makeIdentifierFromModuleName = makeIdentifierFromModuleName;
      function isBlockOrCatchScoped(declaration) {
        return (ts2.getCombinedNodeFlags(declaration) & 3) !== 0 || isCatchClauseVariableDeclarationOrBindingElement(declaration);
      }
      ts2.isBlockOrCatchScoped = isBlockOrCatchScoped;
      function isCatchClauseVariableDeclarationOrBindingElement(declaration) {
        var node = getRootDeclaration(declaration);
        return node.kind === 242 && node.parent.kind === 280;
      }
      ts2.isCatchClauseVariableDeclarationOrBindingElement = isCatchClauseVariableDeclarationOrBindingElement;
      function isAmbientModule(node) {
        return ts2.isModuleDeclaration(node) && (node.name.kind === 10 || isGlobalScopeAugmentation(node));
      }
      ts2.isAmbientModule = isAmbientModule;
      function isModuleWithStringLiteralName(node) {
        return ts2.isModuleDeclaration(node) && node.name.kind === 10;
      }
      ts2.isModuleWithStringLiteralName = isModuleWithStringLiteralName;
      function isNonGlobalAmbientModule(node) {
        return ts2.isModuleDeclaration(node) && ts2.isStringLiteral(node.name);
      }
      ts2.isNonGlobalAmbientModule = isNonGlobalAmbientModule;
      function isEffectiveModuleDeclaration(node) {
        return ts2.isModuleDeclaration(node) || ts2.isIdentifier(node);
      }
      ts2.isEffectiveModuleDeclaration = isEffectiveModuleDeclaration;
      function isShorthandAmbientModuleSymbol(moduleSymbol) {
        return isShorthandAmbientModule(moduleSymbol.valueDeclaration);
      }
      ts2.isShorthandAmbientModuleSymbol = isShorthandAmbientModuleSymbol;
      function isShorthandAmbientModule(node) {
        return node && node.kind === 249 && !node.body;
      }
      function isBlockScopedContainerTopLevel(node) {
        return node.kind === 290 || node.kind === 249 || ts2.isFunctionLike(node);
      }
      ts2.isBlockScopedContainerTopLevel = isBlockScopedContainerTopLevel;
      function isGlobalScopeAugmentation(module3) {
        return !!(module3.flags & 1024);
      }
      ts2.isGlobalScopeAugmentation = isGlobalScopeAugmentation;
      function isExternalModuleAugmentation(node) {
        return isAmbientModule(node) && isModuleAugmentationExternal(node);
      }
      ts2.isExternalModuleAugmentation = isExternalModuleAugmentation;
      function isModuleAugmentationExternal(node) {
        switch (node.parent.kind) {
          case 290:
            return ts2.isExternalModule(node.parent);
          case 250:
            return isAmbientModule(node.parent.parent) && ts2.isSourceFile(node.parent.parent.parent) && !ts2.isExternalModule(node.parent.parent.parent);
        }
        return false;
      }
      ts2.isModuleAugmentationExternal = isModuleAugmentationExternal;
      function getNonAugmentationDeclaration(symbol) {
        return ts2.find(symbol.declarations, function(d) {
          return !isExternalModuleAugmentation(d) && !(ts2.isModuleDeclaration(d) && isGlobalScopeAugmentation(d));
        });
      }
      ts2.getNonAugmentationDeclaration = getNonAugmentationDeclaration;
      function isEffectiveExternalModule(node, compilerOptions) {
        return ts2.isExternalModule(node) || compilerOptions.isolatedModules || getEmitModuleKind(compilerOptions) === ts2.ModuleKind.CommonJS && !!node.commonJsModuleIndicator;
      }
      ts2.isEffectiveExternalModule = isEffectiveExternalModule;
      function isEffectiveStrictModeSourceFile(node, compilerOptions) {
        switch (node.scriptKind) {
          case 1:
          case 3:
          case 2:
          case 4:
            break;
          default:
            return false;
        }
        if (node.isDeclarationFile) {
          return false;
        }
        if (getStrictOptionValue(compilerOptions, "alwaysStrict")) {
          return true;
        }
        if (ts2.startsWithUseStrict(node.statements)) {
          return true;
        }
        if (ts2.isExternalModule(node) || compilerOptions.isolatedModules) {
          if (getEmitModuleKind(compilerOptions) >= ts2.ModuleKind.ES2015) {
            return true;
          }
          return !compilerOptions.noImplicitUseStrict;
        }
        return false;
      }
      ts2.isEffectiveStrictModeSourceFile = isEffectiveStrictModeSourceFile;
      function isBlockScope(node, parentNode) {
        switch (node.kind) {
          case 290:
          case 251:
          case 280:
          case 249:
          case 230:
          case 231:
          case 232:
          case 162:
          case 161:
          case 163:
          case 164:
          case 244:
          case 201:
          case 202:
            return true;
          case 223:
            return !ts2.isFunctionLike(parentNode);
        }
        return false;
      }
      ts2.isBlockScope = isBlockScope;
      function isDeclarationWithTypeParameters(node) {
        switch (node.kind) {
          case 315:
          case 322:
          case 305:
            return true;
          default:
            ts2.assertType(node);
            return isDeclarationWithTypeParameterChildren(node);
        }
      }
      ts2.isDeclarationWithTypeParameters = isDeclarationWithTypeParameters;
      function isDeclarationWithTypeParameterChildren(node) {
        switch (node.kind) {
          case 165:
          case 166:
          case 160:
          case 167:
          case 170:
          case 171:
          case 300:
          case 245:
          case 214:
          case 246:
          case 247:
          case 321:
          case 244:
          case 161:
          case 162:
          case 163:
          case 164:
          case 201:
          case 202:
            return true;
          default:
            ts2.assertType(node);
            return false;
        }
      }
      ts2.isDeclarationWithTypeParameterChildren = isDeclarationWithTypeParameterChildren;
      function isAnyImportSyntax(node) {
        switch (node.kind) {
          case 254:
          case 253:
            return true;
          default:
            return false;
        }
      }
      ts2.isAnyImportSyntax = isAnyImportSyntax;
      function isLateVisibilityPaintedStatement(node) {
        switch (node.kind) {
          case 254:
          case 253:
          case 225:
          case 245:
          case 244:
          case 249:
          case 247:
          case 246:
          case 248:
            return true;
          default:
            return false;
        }
      }
      ts2.isLateVisibilityPaintedStatement = isLateVisibilityPaintedStatement;
      function isAnyImportOrReExport(node) {
        return isAnyImportSyntax(node) || ts2.isExportDeclaration(node);
      }
      ts2.isAnyImportOrReExport = isAnyImportOrReExport;
      function getEnclosingBlockScopeContainer(node) {
        return findAncestor(node.parent, function(current) {
          return isBlockScope(current, current.parent);
        });
      }
      ts2.getEnclosingBlockScopeContainer = getEnclosingBlockScopeContainer;
      function declarationNameToString(name) {
        return !name || getFullWidth(name) === 0 ? "(Missing)" : getTextOfNode(name);
      }
      ts2.declarationNameToString = declarationNameToString;
      function getNameFromIndexInfo(info) {
        return info.declaration ? declarationNameToString(info.declaration.parameters[0].name) : void 0;
      }
      ts2.getNameFromIndexInfo = getNameFromIndexInfo;
      function isComputedNonLiteralName(name) {
        return name.kind === 154 && !isStringOrNumericLiteralLike(name.expression);
      }
      ts2.isComputedNonLiteralName = isComputedNonLiteralName;
      function getTextOfPropertyName(name) {
        switch (name.kind) {
          case 75:
          case 76:
            return name.escapedText;
          case 10:
          case 8:
          case 14:
            return ts2.escapeLeadingUnderscores(name.text);
          case 154:
            if (isStringOrNumericLiteralLike(name.expression))
              return ts2.escapeLeadingUnderscores(name.expression.text);
            return ts2.Debug.fail("Text of property name cannot be read from non-literal-valued ComputedPropertyNames");
          default:
            return ts2.Debug.assertNever(name);
        }
      }
      ts2.getTextOfPropertyName = getTextOfPropertyName;
      function entityNameToString(name) {
        switch (name.kind) {
          case 104:
            return "this";
          case 76:
          case 75:
            return getFullWidth(name) === 0 ? ts2.idText(name) : getTextOfNode(name);
          case 153:
            return entityNameToString(name.left) + "." + entityNameToString(name.right);
          case 194:
            if (ts2.isIdentifier(name.name) || ts2.isPrivateIdentifier(name.name)) {
              return entityNameToString(name.expression) + "." + entityNameToString(name.name);
            } else {
              return ts2.Debug.assertNever(name.name);
            }
          default:
            return ts2.Debug.assertNever(name);
        }
      }
      ts2.entityNameToString = entityNameToString;
      function createDiagnosticForNode(node, message, arg0, arg1, arg2, arg3) {
        var sourceFile = getSourceFileOfNode(node);
        return createDiagnosticForNodeInSourceFile(sourceFile, node, message, arg0, arg1, arg2, arg3);
      }
      ts2.createDiagnosticForNode = createDiagnosticForNode;
      function createDiagnosticForNodeArray(sourceFile, nodes, message, arg0, arg1, arg2, arg3) {
        var start = ts2.skipTrivia(sourceFile.text, nodes.pos);
        return createFileDiagnostic(sourceFile, start, nodes.end - start, message, arg0, arg1, arg2, arg3);
      }
      ts2.createDiagnosticForNodeArray = createDiagnosticForNodeArray;
      function createDiagnosticForNodeInSourceFile(sourceFile, node, message, arg0, arg1, arg2, arg3) {
        var span = getErrorSpanForNode(sourceFile, node);
        return createFileDiagnostic(sourceFile, span.start, span.length, message, arg0, arg1, arg2, arg3);
      }
      ts2.createDiagnosticForNodeInSourceFile = createDiagnosticForNodeInSourceFile;
      function createDiagnosticForNodeFromMessageChain(node, messageChain, relatedInformation) {
        var sourceFile = getSourceFileOfNode(node);
        var span = getErrorSpanForNode(sourceFile, node);
        return {
          file: sourceFile,
          start: span.start,
          length: span.length,
          code: messageChain.code,
          category: messageChain.category,
          messageText: messageChain.next ? messageChain : messageChain.messageText,
          relatedInformation
        };
      }
      ts2.createDiagnosticForNodeFromMessageChain = createDiagnosticForNodeFromMessageChain;
      function createDiagnosticForRange(sourceFile, range, message) {
        return {
          file: sourceFile,
          start: range.pos,
          length: range.end - range.pos,
          code: message.code,
          category: message.category,
          messageText: message.message
        };
      }
      ts2.createDiagnosticForRange = createDiagnosticForRange;
      function getSpanOfTokenAtPosition(sourceFile, pos) {
        var scanner = ts2.createScanner(sourceFile.languageVersion, true, sourceFile.languageVariant, sourceFile.text, void 0, pos);
        scanner.scan();
        var start = scanner.getTokenPos();
        return ts2.createTextSpanFromBounds(start, scanner.getTextPos());
      }
      ts2.getSpanOfTokenAtPosition = getSpanOfTokenAtPosition;
      function getErrorSpanForArrowFunction(sourceFile, node) {
        var pos = ts2.skipTrivia(sourceFile.text, node.pos);
        if (node.body && node.body.kind === 223) {
          var startLine = ts2.getLineAndCharacterOfPosition(sourceFile, node.body.pos).line;
          var endLine = ts2.getLineAndCharacterOfPosition(sourceFile, node.body.end).line;
          if (startLine < endLine) {
            return ts2.createTextSpan(pos, getEndLinePosition(startLine, sourceFile) - pos + 1);
          }
        }
        return ts2.createTextSpanFromBounds(pos, node.end);
      }
      function getErrorSpanForNode(sourceFile, node) {
        var errorNode = node;
        switch (node.kind) {
          case 290:
            var pos_1 = ts2.skipTrivia(sourceFile.text, 0, false);
            if (pos_1 === sourceFile.text.length) {
              return ts2.createTextSpan(0, 0);
            }
            return getSpanOfTokenAtPosition(sourceFile, pos_1);
          case 242:
          case 191:
          case 245:
          case 214:
          case 246:
          case 249:
          case 248:
          case 284:
          case 244:
          case 201:
          case 161:
          case 163:
          case 164:
          case 247:
          case 159:
          case 158:
            errorNode = node.name;
            break;
          case 202:
            return getErrorSpanForArrowFunction(sourceFile, node);
          case 277:
          case 278:
            var start = ts2.skipTrivia(sourceFile.text, node.pos);
            var end = node.statements.length > 0 ? node.statements[0].pos : node.end;
            return ts2.createTextSpanFromBounds(start, end);
        }
        if (errorNode === void 0) {
          return getSpanOfTokenAtPosition(sourceFile, node.pos);
        }
        ts2.Debug.assert(!ts2.isJSDoc(errorNode));
        var isMissing = nodeIsMissing(errorNode);
        var pos = isMissing || ts2.isJsxText(node) ? errorNode.pos : ts2.skipTrivia(sourceFile.text, errorNode.pos);
        if (isMissing) {
          ts2.Debug.assert(pos === errorNode.pos, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809");
          ts2.Debug.assert(pos === errorNode.end, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809");
        } else {
          ts2.Debug.assert(pos >= errorNode.pos, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809");
          ts2.Debug.assert(pos <= errorNode.end, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809");
        }
        return ts2.createTextSpanFromBounds(pos, errorNode.end);
      }
      ts2.getErrorSpanForNode = getErrorSpanForNode;
      function isExternalOrCommonJsModule(file) {
        return (file.externalModuleIndicator || file.commonJsModuleIndicator) !== void 0;
      }
      ts2.isExternalOrCommonJsModule = isExternalOrCommonJsModule;
      function isJsonSourceFile(file) {
        return file.scriptKind === 6;
      }
      ts2.isJsonSourceFile = isJsonSourceFile;
      function isEnumConst(node) {
        return !!(ts2.getCombinedModifierFlags(node) & 2048);
      }
      ts2.isEnumConst = isEnumConst;
      function isDeclarationReadonly(declaration) {
        return !!(ts2.getCombinedModifierFlags(declaration) & 64 && !ts2.isParameterPropertyDeclaration(declaration, declaration.parent));
      }
      ts2.isDeclarationReadonly = isDeclarationReadonly;
      function isVarConst(node) {
        return !!(ts2.getCombinedNodeFlags(node) & 2);
      }
      ts2.isVarConst = isVarConst;
      function isLet(node) {
        return !!(ts2.getCombinedNodeFlags(node) & 1);
      }
      ts2.isLet = isLet;
      function isSuperCall(n) {
        return n.kind === 196 && n.expression.kind === 102;
      }
      ts2.isSuperCall = isSuperCall;
      function isImportCall(n) {
        return n.kind === 196 && n.expression.kind === 96;
      }
      ts2.isImportCall = isImportCall;
      function isImportMeta(n) {
        return ts2.isMetaProperty(n) && n.keywordToken === 96 && n.name.escapedText === "meta";
      }
      ts2.isImportMeta = isImportMeta;
      function isLiteralImportTypeNode(n) {
        return ts2.isImportTypeNode(n) && ts2.isLiteralTypeNode(n.argument) && ts2.isStringLiteral(n.argument.literal);
      }
      ts2.isLiteralImportTypeNode = isLiteralImportTypeNode;
      function isPrologueDirective(node) {
        return node.kind === 226 && node.expression.kind === 10;
      }
      ts2.isPrologueDirective = isPrologueDirective;
      function isCustomPrologue(node) {
        return !!(getEmitFlags(node) & 1048576);
      }
      ts2.isCustomPrologue = isCustomPrologue;
      function isHoistedFunction(node) {
        return isCustomPrologue(node) && ts2.isFunctionDeclaration(node);
      }
      ts2.isHoistedFunction = isHoistedFunction;
      function isHoistedVariable(node) {
        return ts2.isIdentifier(node.name) && !node.initializer;
      }
      function isHoistedVariableStatement(node) {
        return isCustomPrologue(node) && ts2.isVariableStatement(node) && ts2.every(node.declarationList.declarations, isHoistedVariable);
      }
      ts2.isHoistedVariableStatement = isHoistedVariableStatement;
      function getLeadingCommentRangesOfNode(node, sourceFileOfNode) {
        return node.kind !== 11 ? ts2.getLeadingCommentRanges(sourceFileOfNode.text, node.pos) : void 0;
      }
      ts2.getLeadingCommentRangesOfNode = getLeadingCommentRangesOfNode;
      function getJSDocCommentRanges(node, text) {
        var commentRanges = node.kind === 156 || node.kind === 155 || node.kind === 201 || node.kind === 202 || node.kind === 200 ? ts2.concatenate(ts2.getTrailingCommentRanges(text, node.pos), ts2.getLeadingCommentRanges(text, node.pos)) : ts2.getLeadingCommentRanges(text, node.pos);
        return ts2.filter(commentRanges, function(comment) {
          return text.charCodeAt(comment.pos + 1) === 42 && text.charCodeAt(comment.pos + 2) === 42 && text.charCodeAt(comment.pos + 3) !== 47;
        });
      }
      ts2.getJSDocCommentRanges = getJSDocCommentRanges;
      ts2.fullTripleSlashReferencePathRegEx = /^(\/\/\/\s*<reference\s+path\s*=\s*)('|")(.+?)\2.*?\/>/;
      var fullTripleSlashReferenceTypeReferenceDirectiveRegEx = /^(\/\/\/\s*<reference\s+types\s*=\s*)('|")(.+?)\2.*?\/>/;
      ts2.fullTripleSlashAMDReferencePathRegEx = /^(\/\/\/\s*<amd-dependency\s+path\s*=\s*)('|")(.+?)\2.*?\/>/;
      var defaultLibReferenceRegEx = /^(\/\/\/\s*<reference\s+no-default-lib\s*=\s*)('|")(.+?)\2\s*\/>/;
      function isPartOfTypeNode(node) {
        if (168 <= node.kind && node.kind <= 188) {
          return true;
        }
        switch (node.kind) {
          case 125:
          case 148:
          case 140:
          case 151:
          case 143:
          case 128:
          case 144:
          case 141:
          case 146:
          case 137:
            return true;
          case 110:
            return node.parent.kind !== 205;
          case 216:
            return !isExpressionWithTypeArgumentsInClassExtendsClause(node);
          case 155:
            return node.parent.kind === 186 || node.parent.kind === 181;
          case 75:
            if (node.parent.kind === 153 && node.parent.right === node) {
              node = node.parent;
            } else if (node.parent.kind === 194 && node.parent.name === node) {
              node = node.parent;
            }
            ts2.Debug.assert(node.kind === 75 || node.kind === 153 || node.kind === 194, "'node' was expected to be a qualified name, identifier or property access in 'isPartOfTypeNode'.");
          case 153:
          case 194:
          case 104: {
            var parent = node.parent;
            if (parent.kind === 172) {
              return false;
            }
            if (parent.kind === 188) {
              return !parent.isTypeOf;
            }
            if (168 <= parent.kind && parent.kind <= 188) {
              return true;
            }
            switch (parent.kind) {
              case 216:
                return !isExpressionWithTypeArgumentsInClassExtendsClause(parent);
              case 155:
                return node === parent.constraint;
              case 321:
                return node === parent.constraint;
              case 159:
              case 158:
              case 156:
              case 242:
                return node === parent.type;
              case 244:
              case 201:
              case 202:
              case 162:
              case 161:
              case 160:
              case 163:
              case 164:
                return node === parent.type;
              case 165:
              case 166:
              case 167:
                return node === parent.type;
              case 199:
                return node === parent.type;
              case 196:
              case 197:
                return ts2.contains(parent.typeArguments, node);
              case 198:
                return false;
            }
          }
        }
        return false;
      }
      ts2.isPartOfTypeNode = isPartOfTypeNode;
      function isChildOfNodeWithKind(node, kind) {
        while (node) {
          if (node.kind === kind) {
            return true;
          }
          node = node.parent;
        }
        return false;
      }
      ts2.isChildOfNodeWithKind = isChildOfNodeWithKind;
      function forEachReturnStatement(body, visitor) {
        return traverse(body);
        function traverse(node) {
          switch (node.kind) {
            case 235:
              return visitor(node);
            case 251:
            case 223:
            case 227:
            case 228:
            case 229:
            case 230:
            case 231:
            case 232:
            case 236:
            case 237:
            case 277:
            case 278:
            case 238:
            case 240:
            case 280:
              return ts2.forEachChild(node, traverse);
          }
        }
      }
      ts2.forEachReturnStatement = forEachReturnStatement;
      function forEachYieldExpression(body, visitor) {
        return traverse(body);
        function traverse(node) {
          switch (node.kind) {
            case 212:
              visitor(node);
              var operand = node.expression;
              if (operand) {
                traverse(operand);
              }
              return;
            case 248:
            case 246:
            case 249:
            case 247:
              return;
            default:
              if (ts2.isFunctionLike(node)) {
                if (node.name && node.name.kind === 154) {
                  traverse(node.name.expression);
                  return;
                }
              } else if (!isPartOfTypeNode(node)) {
                ts2.forEachChild(node, traverse);
              }
          }
        }
      }
      ts2.forEachYieldExpression = forEachYieldExpression;
      function getRestParameterElementType(node) {
        if (node && node.kind === 174) {
          return node.elementType;
        } else if (node && node.kind === 169) {
          return ts2.singleOrUndefined(node.typeArguments);
        } else {
          return void 0;
        }
      }
      ts2.getRestParameterElementType = getRestParameterElementType;
      function getMembersOfDeclaration(node) {
        switch (node.kind) {
          case 246:
          case 245:
          case 214:
          case 173:
            return node.members;
          case 193:
            return node.properties;
        }
      }
      ts2.getMembersOfDeclaration = getMembersOfDeclaration;
      function isVariableLike(node) {
        if (node) {
          switch (node.kind) {
            case 191:
            case 284:
            case 156:
            case 281:
            case 159:
            case 158:
            case 282:
            case 242:
              return true;
          }
        }
        return false;
      }
      ts2.isVariableLike = isVariableLike;
      function isVariableLikeOrAccessor(node) {
        return isVariableLike(node) || ts2.isAccessor(node);
      }
      ts2.isVariableLikeOrAccessor = isVariableLikeOrAccessor;
      function isVariableDeclarationInVariableStatement(node) {
        return node.parent.kind === 243 && node.parent.parent.kind === 225;
      }
      ts2.isVariableDeclarationInVariableStatement = isVariableDeclarationInVariableStatement;
      function isValidESSymbolDeclaration(node) {
        return ts2.isVariableDeclaration(node) ? isVarConst(node) && ts2.isIdentifier(node.name) && isVariableDeclarationInVariableStatement(node) : ts2.isPropertyDeclaration(node) ? hasReadonlyModifier(node) && hasStaticModifier(node) : ts2.isPropertySignature(node) && hasReadonlyModifier(node);
      }
      ts2.isValidESSymbolDeclaration = isValidESSymbolDeclaration;
      function introducesArgumentsExoticObject(node) {
        switch (node.kind) {
          case 161:
          case 160:
          case 162:
          case 163:
          case 164:
          case 244:
          case 201:
            return true;
        }
        return false;
      }
      ts2.introducesArgumentsExoticObject = introducesArgumentsExoticObject;
      function unwrapInnermostStatementOfLabel(node, beforeUnwrapLabelCallback) {
        while (true) {
          if (beforeUnwrapLabelCallback) {
            beforeUnwrapLabelCallback(node);
          }
          if (node.statement.kind !== 238) {
            return node.statement;
          }
          node = node.statement;
        }
      }
      ts2.unwrapInnermostStatementOfLabel = unwrapInnermostStatementOfLabel;
      function isFunctionBlock(node) {
        return node && node.kind === 223 && ts2.isFunctionLike(node.parent);
      }
      ts2.isFunctionBlock = isFunctionBlock;
      function isObjectLiteralMethod(node) {
        return node && node.kind === 161 && node.parent.kind === 193;
      }
      ts2.isObjectLiteralMethod = isObjectLiteralMethod;
      function isObjectLiteralOrClassExpressionMethod(node) {
        return node.kind === 161 && (node.parent.kind === 193 || node.parent.kind === 214);
      }
      ts2.isObjectLiteralOrClassExpressionMethod = isObjectLiteralOrClassExpressionMethod;
      function isIdentifierTypePredicate(predicate) {
        return predicate && predicate.kind === 1;
      }
      ts2.isIdentifierTypePredicate = isIdentifierTypePredicate;
      function isThisTypePredicate(predicate) {
        return predicate && predicate.kind === 0;
      }
      ts2.isThisTypePredicate = isThisTypePredicate;
      function getPropertyAssignment(objectLiteral, key, key2) {
        return objectLiteral.properties.filter(function(property) {
          if (property.kind === 281) {
            var propName = getTextOfPropertyName(property.name);
            return key === propName || !!key2 && key2 === propName;
          }
          return false;
        });
      }
      ts2.getPropertyAssignment = getPropertyAssignment;
      function getTsConfigObjectLiteralExpression(tsConfigSourceFile) {
        if (tsConfigSourceFile && tsConfigSourceFile.statements.length) {
          var expression = tsConfigSourceFile.statements[0].expression;
          return ts2.tryCast(expression, ts2.isObjectLiteralExpression);
        }
      }
      ts2.getTsConfigObjectLiteralExpression = getTsConfigObjectLiteralExpression;
      function getTsConfigPropArrayElementValue(tsConfigSourceFile, propKey, elementValue) {
        return ts2.firstDefined(getTsConfigPropArray(tsConfigSourceFile, propKey), function(property) {
          return ts2.isArrayLiteralExpression(property.initializer) ? ts2.find(property.initializer.elements, function(element) {
            return ts2.isStringLiteral(element) && element.text === elementValue;
          }) : void 0;
        });
      }
      ts2.getTsConfigPropArrayElementValue = getTsConfigPropArrayElementValue;
      function getTsConfigPropArray(tsConfigSourceFile, propKey) {
        var jsonObjectLiteral = getTsConfigObjectLiteralExpression(tsConfigSourceFile);
        return jsonObjectLiteral ? getPropertyAssignment(jsonObjectLiteral, propKey) : ts2.emptyArray;
      }
      ts2.getTsConfigPropArray = getTsConfigPropArray;
      function getContainingFunction(node) {
        return findAncestor(node.parent, ts2.isFunctionLike);
      }
      ts2.getContainingFunction = getContainingFunction;
      function getContainingFunctionDeclaration(node) {
        return findAncestor(node.parent, ts2.isFunctionLikeDeclaration);
      }
      ts2.getContainingFunctionDeclaration = getContainingFunctionDeclaration;
      function getContainingClass(node) {
        return findAncestor(node.parent, ts2.isClassLike);
      }
      ts2.getContainingClass = getContainingClass;
      function getThisContainer(node, includeArrowFunctions) {
        ts2.Debug.assert(node.kind !== 290);
        while (true) {
          node = node.parent;
          if (!node) {
            return ts2.Debug.fail();
          }
          switch (node.kind) {
            case 154:
              if (ts2.isClassLike(node.parent.parent)) {
                return node;
              }
              node = node.parent;
              break;
            case 157:
              if (node.parent.kind === 156 && ts2.isClassElement(node.parent.parent)) {
                node = node.parent.parent;
              } else if (ts2.isClassElement(node.parent)) {
                node = node.parent;
              }
              break;
            case 202:
              if (!includeArrowFunctions) {
                continue;
              }
            case 244:
            case 201:
            case 249:
            case 159:
            case 158:
            case 161:
            case 160:
            case 162:
            case 163:
            case 164:
            case 165:
            case 166:
            case 167:
            case 248:
            case 290:
              return node;
          }
        }
      }
      ts2.getThisContainer = getThisContainer;
      function getNewTargetContainer(node) {
        var container = getThisContainer(node, false);
        if (container) {
          switch (container.kind) {
            case 162:
            case 244:
            case 201:
              return container;
          }
        }
        return void 0;
      }
      ts2.getNewTargetContainer = getNewTargetContainer;
      function getSuperContainer(node, stopOnFunctions) {
        while (true) {
          node = node.parent;
          if (!node) {
            return node;
          }
          switch (node.kind) {
            case 154:
              node = node.parent;
              break;
            case 244:
            case 201:
            case 202:
              if (!stopOnFunctions) {
                continue;
              }
            case 159:
            case 158:
            case 161:
            case 160:
            case 162:
            case 163:
            case 164:
              return node;
            case 157:
              if (node.parent.kind === 156 && ts2.isClassElement(node.parent.parent)) {
                node = node.parent.parent;
              } else if (ts2.isClassElement(node.parent)) {
                node = node.parent;
              }
              break;
          }
        }
      }
      ts2.getSuperContainer = getSuperContainer;
      function getImmediatelyInvokedFunctionExpression(func) {
        if (func.kind === 201 || func.kind === 202) {
          var prev = func;
          var parent = func.parent;
          while (parent.kind === 200) {
            prev = parent;
            parent = parent.parent;
          }
          if (parent.kind === 196 && parent.expression === prev) {
            return parent;
          }
        }
      }
      ts2.getImmediatelyInvokedFunctionExpression = getImmediatelyInvokedFunctionExpression;
      function isSuperOrSuperProperty(node) {
        return node.kind === 102 || isSuperProperty(node);
      }
      ts2.isSuperOrSuperProperty = isSuperOrSuperProperty;
      function isSuperProperty(node) {
        var kind = node.kind;
        return (kind === 194 || kind === 195) && node.expression.kind === 102;
      }
      ts2.isSuperProperty = isSuperProperty;
      function isThisProperty(node) {
        var kind = node.kind;
        return (kind === 194 || kind === 195) && node.expression.kind === 104;
      }
      ts2.isThisProperty = isThisProperty;
      function getEntityNameFromTypeNode(node) {
        switch (node.kind) {
          case 169:
            return node.typeName;
          case 216:
            return isEntityNameExpression(node.expression) ? node.expression : void 0;
          case 75:
          case 153:
            return node;
        }
        return void 0;
      }
      ts2.getEntityNameFromTypeNode = getEntityNameFromTypeNode;
      function getInvokedExpression(node) {
        switch (node.kind) {
          case 198:
            return node.tag;
          case 268:
          case 267:
            return node.tagName;
          default:
            return node.expression;
        }
      }
      ts2.getInvokedExpression = getInvokedExpression;
      function nodeCanBeDecorated(node, parent, grandparent) {
        if (ts2.isNamedDeclaration(node) && ts2.isPrivateIdentifier(node.name)) {
          return false;
        }
        switch (node.kind) {
          case 245:
            return true;
          case 159:
            return parent.kind === 245;
          case 163:
          case 164:
          case 161:
            return node.body !== void 0 && parent.kind === 245;
          case 156:
            return parent.body !== void 0 && (parent.kind === 162 || parent.kind === 161 || parent.kind === 164) && grandparent.kind === 245;
        }
        return false;
      }
      ts2.nodeCanBeDecorated = nodeCanBeDecorated;
      function nodeIsDecorated(node, parent, grandparent) {
        return node.decorators !== void 0 && nodeCanBeDecorated(node, parent, grandparent);
      }
      ts2.nodeIsDecorated = nodeIsDecorated;
      function nodeOrChildIsDecorated(node, parent, grandparent) {
        return nodeIsDecorated(node, parent, grandparent) || childIsDecorated(node, parent);
      }
      ts2.nodeOrChildIsDecorated = nodeOrChildIsDecorated;
      function childIsDecorated(node, parent) {
        switch (node.kind) {
          case 245:
            return ts2.some(node.members, function(m) {
              return nodeOrChildIsDecorated(m, node, parent);
            });
          case 161:
          case 164:
            return ts2.some(node.parameters, function(p) {
              return nodeIsDecorated(p, node, parent);
            });
          default:
            return false;
        }
      }
      ts2.childIsDecorated = childIsDecorated;
      function isJSXTagName(node) {
        var parent = node.parent;
        if (parent.kind === 268 || parent.kind === 267 || parent.kind === 269) {
          return parent.tagName === node;
        }
        return false;
      }
      ts2.isJSXTagName = isJSXTagName;
      function isExpressionNode(node) {
        switch (node.kind) {
          case 102:
          case 100:
          case 106:
          case 91:
          case 13:
          case 192:
          case 193:
          case 194:
          case 195:
          case 196:
          case 197:
          case 198:
          case 217:
          case 199:
          case 218:
          case 200:
          case 201:
          case 214:
          case 202:
          case 205:
          case 203:
          case 204:
          case 207:
          case 208:
          case 209:
          case 210:
          case 213:
          case 211:
          case 215:
          case 266:
          case 267:
          case 270:
          case 212:
          case 206:
          case 219:
            return true;
          case 153:
            while (node.parent.kind === 153) {
              node = node.parent;
            }
            return node.parent.kind === 172 || isJSXTagName(node);
          case 75:
            if (node.parent.kind === 172 || isJSXTagName(node)) {
              return true;
            }
          case 8:
          case 9:
          case 10:
          case 14:
          case 104:
            return isInExpressionContext(node);
          default:
            return false;
        }
      }
      ts2.isExpressionNode = isExpressionNode;
      function isInExpressionContext(node) {
        var parent = node.parent;
        switch (parent.kind) {
          case 242:
          case 156:
          case 159:
          case 158:
          case 284:
          case 281:
          case 191:
            return parent.initializer === node;
          case 226:
          case 227:
          case 228:
          case 229:
          case 235:
          case 236:
          case 237:
          case 277:
          case 239:
            return parent.expression === node;
          case 230:
            var forStatement = parent;
            return forStatement.initializer === node && forStatement.initializer.kind !== 243 || forStatement.condition === node || forStatement.incrementor === node;
          case 231:
          case 232:
            var forInStatement = parent;
            return forInStatement.initializer === node && forInStatement.initializer.kind !== 243 || forInStatement.expression === node;
          case 199:
          case 217:
            return node === parent.expression;
          case 221:
            return node === parent.expression;
          case 154:
            return node === parent.expression;
          case 157:
          case 276:
          case 275:
          case 283:
            return true;
          case 216:
            return parent.expression === node && isExpressionWithTypeArgumentsInClassExtendsClause(parent);
          case 282:
            return parent.objectAssignmentInitializer === node;
          default:
            return isExpressionNode(parent);
        }
      }
      ts2.isInExpressionContext = isInExpressionContext;
      function isPartOfTypeQuery(node) {
        while (node.kind === 153 || node.kind === 75) {
          node = node.parent;
        }
        return node.kind === 172;
      }
      ts2.isPartOfTypeQuery = isPartOfTypeQuery;
      function isExternalModuleImportEqualsDeclaration(node) {
        return node.kind === 253 && node.moduleReference.kind === 265;
      }
      ts2.isExternalModuleImportEqualsDeclaration = isExternalModuleImportEqualsDeclaration;
      function getExternalModuleImportEqualsDeclarationExpression(node) {
        ts2.Debug.assert(isExternalModuleImportEqualsDeclaration(node));
        return node.moduleReference.expression;
      }
      ts2.getExternalModuleImportEqualsDeclarationExpression = getExternalModuleImportEqualsDeclarationExpression;
      function isInternalModuleImportEqualsDeclaration(node) {
        return node.kind === 253 && node.moduleReference.kind !== 265;
      }
      ts2.isInternalModuleImportEqualsDeclaration = isInternalModuleImportEqualsDeclaration;
      function isSourceFileJS(file) {
        return isInJSFile(file);
      }
      ts2.isSourceFileJS = isSourceFileJS;
      function isSourceFileNotJS(file) {
        return !isInJSFile(file);
      }
      ts2.isSourceFileNotJS = isSourceFileNotJS;
      function isInJSFile(node) {
        return !!node && !!(node.flags & 131072);
      }
      ts2.isInJSFile = isInJSFile;
      function isInJsonFile(node) {
        return !!node && !!(node.flags & 33554432);
      }
      ts2.isInJsonFile = isInJsonFile;
      function isSourceFileNotJson(file) {
        return !isJsonSourceFile(file);
      }
      ts2.isSourceFileNotJson = isSourceFileNotJson;
      function isInJSDoc(node) {
        return !!node && !!(node.flags & 4194304);
      }
      ts2.isInJSDoc = isInJSDoc;
      function isJSDocIndexSignature(node) {
        return ts2.isTypeReferenceNode(node) && ts2.isIdentifier(node.typeName) && node.typeName.escapedText === "Object" && node.typeArguments && node.typeArguments.length === 2 && (node.typeArguments[0].kind === 143 || node.typeArguments[0].kind === 140);
      }
      ts2.isJSDocIndexSignature = isJSDocIndexSignature;
      function isRequireCall(callExpression, requireStringLiteralLikeArgument) {
        if (callExpression.kind !== 196) {
          return false;
        }
        var _a = callExpression, expression = _a.expression, args = _a.arguments;
        if (expression.kind !== 75 || expression.escapedText !== "require") {
          return false;
        }
        if (args.length !== 1) {
          return false;
        }
        var arg = args[0];
        return !requireStringLiteralLikeArgument || ts2.isStringLiteralLike(arg);
      }
      ts2.isRequireCall = isRequireCall;
      function isRequireVariableDeclaration(node, requireStringLiteralLikeArgument) {
        return ts2.isVariableDeclaration(node) && !!node.initializer && isRequireCall(node.initializer, requireStringLiteralLikeArgument);
      }
      ts2.isRequireVariableDeclaration = isRequireVariableDeclaration;
      function isRequireVariableDeclarationStatement(node, requireStringLiteralLikeArgument) {
        if (requireStringLiteralLikeArgument === void 0) {
          requireStringLiteralLikeArgument = true;
        }
        return ts2.isVariableStatement(node) && ts2.every(node.declarationList.declarations, function(decl) {
          return isRequireVariableDeclaration(decl, requireStringLiteralLikeArgument);
        });
      }
      ts2.isRequireVariableDeclarationStatement = isRequireVariableDeclarationStatement;
      function isSingleOrDoubleQuote(charCode) {
        return charCode === 39 || charCode === 34;
      }
      ts2.isSingleOrDoubleQuote = isSingleOrDoubleQuote;
      function isStringDoubleQuoted(str, sourceFile) {
        return getSourceTextOfNodeFromSourceFile(sourceFile, str).charCodeAt(0) === 34;
      }
      ts2.isStringDoubleQuoted = isStringDoubleQuoted;
      function getDeclarationOfExpando(node) {
        if (!node.parent) {
          return void 0;
        }
        var name;
        var decl;
        if (ts2.isVariableDeclaration(node.parent) && node.parent.initializer === node) {
          if (!isInJSFile(node) && !isVarConst(node.parent)) {
            return void 0;
          }
          name = node.parent.name;
          decl = node.parent;
        } else if (ts2.isBinaryExpression(node.parent)) {
          var parentNode = node.parent;
          var parentNodeOperator = node.parent.operatorToken.kind;
          if (parentNodeOperator === 62 && parentNode.right === node) {
            name = parentNode.left;
            decl = name;
          } else if (parentNodeOperator === 56 || parentNodeOperator === 60) {
            if (ts2.isVariableDeclaration(parentNode.parent) && parentNode.parent.initializer === parentNode) {
              name = parentNode.parent.name;
              decl = parentNode.parent;
            } else if (ts2.isBinaryExpression(parentNode.parent) && parentNode.parent.operatorToken.kind === 62 && parentNode.parent.right === parentNode) {
              name = parentNode.parent.left;
              decl = name;
            }
            if (!name || !isBindableStaticNameExpression(name) || !isSameEntityName(name, parentNode.left)) {
              return void 0;
            }
          }
        }
        if (!name || !getExpandoInitializer(node, isPrototypeAccess(name))) {
          return void 0;
        }
        return decl;
      }
      ts2.getDeclarationOfExpando = getDeclarationOfExpando;
      function isAssignmentDeclaration(decl) {
        return ts2.isBinaryExpression(decl) || isAccessExpression(decl) || ts2.isIdentifier(decl) || ts2.isCallExpression(decl);
      }
      ts2.isAssignmentDeclaration = isAssignmentDeclaration;
      function getEffectiveInitializer(node) {
        if (isInJSFile(node) && node.initializer && ts2.isBinaryExpression(node.initializer) && (node.initializer.operatorToken.kind === 56 || node.initializer.operatorToken.kind === 60) && node.name && isEntityNameExpression(node.name) && isSameEntityName(node.name, node.initializer.left)) {
          return node.initializer.right;
        }
        return node.initializer;
      }
      ts2.getEffectiveInitializer = getEffectiveInitializer;
      function getDeclaredExpandoInitializer(node) {
        var init = getEffectiveInitializer(node);
        return init && getExpandoInitializer(init, isPrototypeAccess(node.name));
      }
      ts2.getDeclaredExpandoInitializer = getDeclaredExpandoInitializer;
      function hasExpandoValueProperty(node, isPrototypeAssignment) {
        return ts2.forEach(node.properties, function(p) {
          return ts2.isPropertyAssignment(p) && ts2.isIdentifier(p.name) && p.name.escapedText === "value" && p.initializer && getExpandoInitializer(p.initializer, isPrototypeAssignment);
        });
      }
      function getAssignedExpandoInitializer(node) {
        if (node && node.parent && ts2.isBinaryExpression(node.parent) && node.parent.operatorToken.kind === 62) {
          var isPrototypeAssignment = isPrototypeAccess(node.parent.left);
          return getExpandoInitializer(node.parent.right, isPrototypeAssignment) || getDefaultedExpandoInitializer(node.parent.left, node.parent.right, isPrototypeAssignment);
        }
        if (node && ts2.isCallExpression(node) && isBindableObjectDefinePropertyCall(node)) {
          var result = hasExpandoValueProperty(node.arguments[2], node.arguments[1].text === "prototype");
          if (result) {
            return result;
          }
        }
      }
      ts2.getAssignedExpandoInitializer = getAssignedExpandoInitializer;
      function getExpandoInitializer(initializer, isPrototypeAssignment) {
        if (ts2.isCallExpression(initializer)) {
          var e = skipParentheses(initializer.expression);
          return e.kind === 201 || e.kind === 202 ? initializer : void 0;
        }
        if (initializer.kind === 201 || initializer.kind === 214 || initializer.kind === 202) {
          return initializer;
        }
        if (ts2.isObjectLiteralExpression(initializer) && (initializer.properties.length === 0 || isPrototypeAssignment)) {
          return initializer;
        }
      }
      ts2.getExpandoInitializer = getExpandoInitializer;
      function getDefaultedExpandoInitializer(name, initializer, isPrototypeAssignment) {
        var e = ts2.isBinaryExpression(initializer) && (initializer.operatorToken.kind === 56 || initializer.operatorToken.kind === 60) && getExpandoInitializer(initializer.right, isPrototypeAssignment);
        if (e && isSameEntityName(name, initializer.left)) {
          return e;
        }
      }
      function isDefaultedExpandoInitializer(node) {
        var name = ts2.isVariableDeclaration(node.parent) ? node.parent.name : ts2.isBinaryExpression(node.parent) && node.parent.operatorToken.kind === 62 ? node.parent.left : void 0;
        return name && getExpandoInitializer(node.right, isPrototypeAccess(name)) && isEntityNameExpression(name) && isSameEntityName(name, node.left);
      }
      ts2.isDefaultedExpandoInitializer = isDefaultedExpandoInitializer;
      function getNameOfExpando(node) {
        if (ts2.isBinaryExpression(node.parent)) {
          var parent = (node.parent.operatorToken.kind === 56 || node.parent.operatorToken.kind === 60) && ts2.isBinaryExpression(node.parent.parent) ? node.parent.parent : node.parent;
          if (parent.operatorToken.kind === 62 && ts2.isIdentifier(parent.left)) {
            return parent.left;
          }
        } else if (ts2.isVariableDeclaration(node.parent)) {
          return node.parent.name;
        }
      }
      ts2.getNameOfExpando = getNameOfExpando;
      function isSameEntityName(name, initializer) {
        if (isPropertyNameLiteral(name) && isPropertyNameLiteral(initializer)) {
          return getTextOfIdentifierOrLiteral(name) === getTextOfIdentifierOrLiteral(name);
        }
        if (ts2.isIdentifier(name) && isLiteralLikeAccess(initializer) && (initializer.expression.kind === 104 || ts2.isIdentifier(initializer.expression) && (initializer.expression.escapedText === "window" || initializer.expression.escapedText === "self" || initializer.expression.escapedText === "global"))) {
          var nameOrArgument = getNameOrArgument(initializer);
          if (ts2.isPrivateIdentifier(nameOrArgument)) {
            ts2.Debug.fail("Unexpected PrivateIdentifier in name expression with literal-like access.");
          }
          return isSameEntityName(name, nameOrArgument);
        }
        if (isLiteralLikeAccess(name) && isLiteralLikeAccess(initializer)) {
          return getElementOrPropertyAccessName(name) === getElementOrPropertyAccessName(initializer) && isSameEntityName(name.expression, initializer.expression);
        }
        return false;
      }
      function getRightMostAssignedExpression(node) {
        while (isAssignmentExpression(node, true)) {
          node = node.right;
        }
        return node;
      }
      ts2.getRightMostAssignedExpression = getRightMostAssignedExpression;
      function isExportsIdentifier(node) {
        return ts2.isIdentifier(node) && node.escapedText === "exports";
      }
      ts2.isExportsIdentifier = isExportsIdentifier;
      function isModuleIdentifier(node) {
        return ts2.isIdentifier(node) && node.escapedText === "module";
      }
      ts2.isModuleIdentifier = isModuleIdentifier;
      function isModuleExportsAccessExpression(node) {
        return (ts2.isPropertyAccessExpression(node) || isLiteralLikeElementAccess(node)) && isModuleIdentifier(node.expression) && getElementOrPropertyAccessName(node) === "exports";
      }
      ts2.isModuleExportsAccessExpression = isModuleExportsAccessExpression;
      function getAssignmentDeclarationKind(expr) {
        var special = getAssignmentDeclarationKindWorker(expr);
        return special === 5 || isInJSFile(expr) ? special : 0;
      }
      ts2.getAssignmentDeclarationKind = getAssignmentDeclarationKind;
      function isBindableObjectDefinePropertyCall(expr) {
        return ts2.length(expr.arguments) === 3 && ts2.isPropertyAccessExpression(expr.expression) && ts2.isIdentifier(expr.expression.expression) && ts2.idText(expr.expression.expression) === "Object" && ts2.idText(expr.expression.name) === "defineProperty" && isStringOrNumericLiteralLike(expr.arguments[1]) && isBindableStaticNameExpression(expr.arguments[0], true);
      }
      ts2.isBindableObjectDefinePropertyCall = isBindableObjectDefinePropertyCall;
      function isLiteralLikeAccess(node) {
        return ts2.isPropertyAccessExpression(node) || isLiteralLikeElementAccess(node);
      }
      ts2.isLiteralLikeAccess = isLiteralLikeAccess;
      function isLiteralLikeElementAccess(node) {
        return ts2.isElementAccessExpression(node) && (isStringOrNumericLiteralLike(node.argumentExpression) || isWellKnownSymbolSyntactically(node.argumentExpression));
      }
      ts2.isLiteralLikeElementAccess = isLiteralLikeElementAccess;
      function isBindableStaticAccessExpression(node, excludeThisKeyword) {
        return ts2.isPropertyAccessExpression(node) && (!excludeThisKeyword && node.expression.kind === 104 || ts2.isIdentifier(node.name) && isBindableStaticNameExpression(node.expression, true)) || isBindableStaticElementAccessExpression(node, excludeThisKeyword);
      }
      ts2.isBindableStaticAccessExpression = isBindableStaticAccessExpression;
      function isBindableStaticElementAccessExpression(node, excludeThisKeyword) {
        return isLiteralLikeElementAccess(node) && (!excludeThisKeyword && node.expression.kind === 104 || isEntityNameExpression(node.expression) || isBindableStaticAccessExpression(node.expression, true));
      }
      ts2.isBindableStaticElementAccessExpression = isBindableStaticElementAccessExpression;
      function isBindableStaticNameExpression(node, excludeThisKeyword) {
        return isEntityNameExpression(node) || isBindableStaticAccessExpression(node, excludeThisKeyword);
      }
      ts2.isBindableStaticNameExpression = isBindableStaticNameExpression;
      function getNameOrArgument(expr) {
        if (ts2.isPropertyAccessExpression(expr)) {
          return expr.name;
        }
        return expr.argumentExpression;
      }
      ts2.getNameOrArgument = getNameOrArgument;
      function getAssignmentDeclarationKindWorker(expr) {
        if (ts2.isCallExpression(expr)) {
          if (!isBindableObjectDefinePropertyCall(expr)) {
            return 0;
          }
          var entityName = expr.arguments[0];
          if (isExportsIdentifier(entityName) || isModuleExportsAccessExpression(entityName)) {
            return 8;
          }
          if (isBindableStaticAccessExpression(entityName) && getElementOrPropertyAccessName(entityName) === "prototype") {
            return 9;
          }
          return 7;
        }
        if (expr.operatorToken.kind !== 62 || !isAccessExpression(expr.left)) {
          return 0;
        }
        if (isBindableStaticNameExpression(expr.left.expression, true) && getElementOrPropertyAccessName(expr.left) === "prototype" && ts2.isObjectLiteralExpression(getInitializerOfBinaryExpression(expr))) {
          return 6;
        }
        return getAssignmentDeclarationPropertyAccessKind(expr.left);
      }
      function getElementOrPropertyAccessArgumentExpressionOrName(node) {
        if (ts2.isPropertyAccessExpression(node)) {
          return node.name;
        }
        var arg = skipParentheses(node.argumentExpression);
        if (ts2.isNumericLiteral(arg) || ts2.isStringLiteralLike(arg)) {
          return arg;
        }
        return node;
      }
      ts2.getElementOrPropertyAccessArgumentExpressionOrName = getElementOrPropertyAccessArgumentExpressionOrName;
      function getElementOrPropertyAccessName(node) {
        var name = getElementOrPropertyAccessArgumentExpressionOrName(node);
        if (name) {
          if (ts2.isIdentifier(name)) {
            return name.escapedText;
          }
          if (ts2.isStringLiteralLike(name) || ts2.isNumericLiteral(name)) {
            return ts2.escapeLeadingUnderscores(name.text);
          }
        }
        if (ts2.isElementAccessExpression(node) && isWellKnownSymbolSyntactically(node.argumentExpression)) {
          return getPropertyNameForKnownSymbolName(ts2.idText(node.argumentExpression.name));
        }
        return void 0;
      }
      ts2.getElementOrPropertyAccessName = getElementOrPropertyAccessName;
      function getAssignmentDeclarationPropertyAccessKind(lhs) {
        if (lhs.expression.kind === 104) {
          return 4;
        } else if (isModuleExportsAccessExpression(lhs)) {
          return 2;
        } else if (isBindableStaticNameExpression(lhs.expression, true)) {
          if (isPrototypeAccess(lhs.expression)) {
            return 3;
          }
          var nextToLast = lhs;
          while (!ts2.isIdentifier(nextToLast.expression)) {
            nextToLast = nextToLast.expression;
          }
          var id = nextToLast.expression;
          if ((id.escapedText === "exports" || id.escapedText === "module" && getElementOrPropertyAccessName(nextToLast) === "exports") && isBindableStaticAccessExpression(lhs)) {
            return 1;
          }
          if (isBindableStaticNameExpression(lhs, true) || ts2.isElementAccessExpression(lhs) && isDynamicName(lhs)) {
            return 5;
          }
        }
        return 0;
      }
      ts2.getAssignmentDeclarationPropertyAccessKind = getAssignmentDeclarationPropertyAccessKind;
      function getInitializerOfBinaryExpression(expr) {
        while (ts2.isBinaryExpression(expr.right)) {
          expr = expr.right;
        }
        return expr.right;
      }
      ts2.getInitializerOfBinaryExpression = getInitializerOfBinaryExpression;
      function isPrototypePropertyAssignment(node) {
        return ts2.isBinaryExpression(node) && getAssignmentDeclarationKind(node) === 3;
      }
      ts2.isPrototypePropertyAssignment = isPrototypePropertyAssignment;
      function isSpecialPropertyDeclaration(expr) {
        return isInJSFile(expr) && expr.parent && expr.parent.kind === 226 && (!ts2.isElementAccessExpression(expr) || isLiteralLikeElementAccess(expr)) && !!ts2.getJSDocTypeTag(expr.parent);
      }
      ts2.isSpecialPropertyDeclaration = isSpecialPropertyDeclaration;
      function setValueDeclaration(symbol, node) {
        var valueDeclaration = symbol.valueDeclaration;
        if (!valueDeclaration || !(node.flags & 8388608 && !(valueDeclaration.flags & 8388608)) && (isAssignmentDeclaration(valueDeclaration) && !isAssignmentDeclaration(node)) || valueDeclaration.kind !== node.kind && isEffectiveModuleDeclaration(valueDeclaration)) {
          symbol.valueDeclaration = node;
        }
      }
      ts2.setValueDeclaration = setValueDeclaration;
      function isFunctionSymbol(symbol) {
        if (!symbol || !symbol.valueDeclaration) {
          return false;
        }
        var decl = symbol.valueDeclaration;
        return decl.kind === 244 || ts2.isVariableDeclaration(decl) && decl.initializer && ts2.isFunctionLike(decl.initializer);
      }
      ts2.isFunctionSymbol = isFunctionSymbol;
      function importFromModuleSpecifier(node) {
        return tryGetImportFromModuleSpecifier(node) || ts2.Debug.failBadSyntaxKind(node.parent);
      }
      ts2.importFromModuleSpecifier = importFromModuleSpecifier;
      function tryGetImportFromModuleSpecifier(node) {
        switch (node.parent.kind) {
          case 254:
          case 260:
            return node.parent;
          case 265:
            return node.parent.parent;
          case 196:
            return isImportCall(node.parent) || isRequireCall(node.parent, false) ? node.parent : void 0;
          case 187:
            ts2.Debug.assert(ts2.isStringLiteral(node));
            return ts2.tryCast(node.parent.parent, ts2.isImportTypeNode);
          default:
            return void 0;
        }
      }
      ts2.tryGetImportFromModuleSpecifier = tryGetImportFromModuleSpecifier;
      function getExternalModuleName(node) {
        switch (node.kind) {
          case 254:
          case 260:
            return node.moduleSpecifier;
          case 253:
            return node.moduleReference.kind === 265 ? node.moduleReference.expression : void 0;
          case 188:
            return isLiteralImportTypeNode(node) ? node.argument.literal : void 0;
          default:
            return ts2.Debug.assertNever(node);
        }
      }
      ts2.getExternalModuleName = getExternalModuleName;
      function getNamespaceDeclarationNode(node) {
        switch (node.kind) {
          case 254:
            return node.importClause && ts2.tryCast(node.importClause.namedBindings, ts2.isNamespaceImport);
          case 253:
            return node;
          case 260:
            return node.exportClause && ts2.tryCast(node.exportClause, ts2.isNamespaceExport);
          default:
            return ts2.Debug.assertNever(node);
        }
      }
      ts2.getNamespaceDeclarationNode = getNamespaceDeclarationNode;
      function isDefaultImport(node) {
        return node.kind === 254 && !!node.importClause && !!node.importClause.name;
      }
      ts2.isDefaultImport = isDefaultImport;
      function forEachImportClauseDeclaration(node, action) {
        if (node.name) {
          var result = action(node);
          if (result)
            return result;
        }
        if (node.namedBindings) {
          var result = ts2.isNamespaceImport(node.namedBindings) ? action(node.namedBindings) : ts2.forEach(node.namedBindings.elements, action);
          if (result)
            return result;
        }
      }
      ts2.forEachImportClauseDeclaration = forEachImportClauseDeclaration;
      function hasQuestionToken(node) {
        if (node) {
          switch (node.kind) {
            case 156:
            case 161:
            case 160:
            case 282:
            case 281:
            case 159:
            case 158:
              return node.questionToken !== void 0;
          }
        }
        return false;
      }
      ts2.hasQuestionToken = hasQuestionToken;
      function isJSDocConstructSignature(node) {
        var param = ts2.isJSDocFunctionType(node) ? ts2.firstOrUndefined(node.parameters) : void 0;
        var name = ts2.tryCast(param && param.name, ts2.isIdentifier);
        return !!name && name.escapedText === "new";
      }
      ts2.isJSDocConstructSignature = isJSDocConstructSignature;
      function isJSDocTypeAlias(node) {
        return node.kind === 322 || node.kind === 315 || node.kind === 316;
      }
      ts2.isJSDocTypeAlias = isJSDocTypeAlias;
      function isTypeAlias(node) {
        return isJSDocTypeAlias(node) || ts2.isTypeAliasDeclaration(node);
      }
      ts2.isTypeAlias = isTypeAlias;
      function getSourceOfAssignment(node) {
        return ts2.isExpressionStatement(node) && ts2.isBinaryExpression(node.expression) && node.expression.operatorToken.kind === 62 ? getRightMostAssignedExpression(node.expression) : void 0;
      }
      function getSourceOfDefaultedAssignment(node) {
        return ts2.isExpressionStatement(node) && ts2.isBinaryExpression(node.expression) && getAssignmentDeclarationKind(node.expression) !== 0 && ts2.isBinaryExpression(node.expression.right) && (node.expression.right.operatorToken.kind === 56 || node.expression.right.operatorToken.kind === 60) ? node.expression.right.right : void 0;
      }
      function getSingleInitializerOfVariableStatementOrPropertyDeclaration(node) {
        switch (node.kind) {
          case 225:
            var v = getSingleVariableOfVariableStatement(node);
            return v && v.initializer;
          case 159:
            return node.initializer;
          case 281:
            return node.initializer;
        }
      }
      ts2.getSingleInitializerOfVariableStatementOrPropertyDeclaration = getSingleInitializerOfVariableStatementOrPropertyDeclaration;
      function getSingleVariableOfVariableStatement(node) {
        return ts2.isVariableStatement(node) ? ts2.firstOrUndefined(node.declarationList.declarations) : void 0;
      }
      function getNestedModuleDeclaration(node) {
        return ts2.isModuleDeclaration(node) && node.body && node.body.kind === 249 ? node.body : void 0;
      }
      function getJSDocCommentsAndTags(hostNode) {
        var result;
        if (isVariableLike(hostNode) && ts2.hasInitializer(hostNode) && ts2.hasJSDocNodes(hostNode.initializer)) {
          result = ts2.append(result, ts2.last(hostNode.initializer.jsDoc));
        }
        var node = hostNode;
        while (node && node.parent) {
          if (ts2.hasJSDocNodes(node)) {
            result = ts2.append(result, ts2.last(node.jsDoc));
          }
          if (node.kind === 156) {
            result = ts2.addRange(result, ts2.getJSDocParameterTags(node));
            break;
          }
          if (node.kind === 155) {
            result = ts2.addRange(result, ts2.getJSDocTypeParameterTags(node));
            break;
          }
          node = getNextJSDocCommentLocation(node);
        }
        return result || ts2.emptyArray;
      }
      ts2.getJSDocCommentsAndTags = getJSDocCommentsAndTags;
      function getNextJSDocCommentLocation(node) {
        var parent = node.parent;
        if (parent.kind === 281 || parent.kind === 259 || parent.kind === 159 || parent.kind === 226 && node.kind === 194 || getNestedModuleDeclaration(parent) || ts2.isBinaryExpression(node) && node.operatorToken.kind === 62) {
          return parent;
        } else if (parent.parent && (getSingleVariableOfVariableStatement(parent.parent) === node || ts2.isBinaryExpression(parent) && parent.operatorToken.kind === 62)) {
          return parent.parent;
        } else if (parent.parent && parent.parent.parent && (getSingleVariableOfVariableStatement(parent.parent.parent) || getSingleInitializerOfVariableStatementOrPropertyDeclaration(parent.parent.parent) === node || getSourceOfDefaultedAssignment(parent.parent.parent))) {
          return parent.parent.parent;
        }
      }
      function getParameterSymbolFromJSDoc(node) {
        if (node.symbol) {
          return node.symbol;
        }
        if (!ts2.isIdentifier(node.name)) {
          return void 0;
        }
        var name = node.name.escapedText;
        var decl = getHostSignatureFromJSDoc(node);
        if (!decl) {
          return void 0;
        }
        var parameter = ts2.find(decl.parameters, function(p) {
          return p.name.kind === 75 && p.name.escapedText === name;
        });
        return parameter && parameter.symbol;
      }
      ts2.getParameterSymbolFromJSDoc = getParameterSymbolFromJSDoc;
      function getHostSignatureFromJSDoc(node) {
        var host = getEffectiveJSDocHost(node);
        return host && ts2.isFunctionLike(host) ? host : void 0;
      }
      ts2.getHostSignatureFromJSDoc = getHostSignatureFromJSDoc;
      function getEffectiveJSDocHost(node) {
        var host = getJSDocHost(node);
        var decl = getSourceOfDefaultedAssignment(host) || getSourceOfAssignment(host) || getSingleInitializerOfVariableStatementOrPropertyDeclaration(host) || getSingleVariableOfVariableStatement(host) || getNestedModuleDeclaration(host) || host;
        return decl;
      }
      ts2.getEffectiveJSDocHost = getEffectiveJSDocHost;
      function getJSDocHost(node) {
        return ts2.Debug.checkDefined(findAncestor(node.parent, ts2.isJSDoc)).parent;
      }
      ts2.getJSDocHost = getJSDocHost;
      function getTypeParameterFromJsDoc(node) {
        var name = node.name.escapedText;
        var typeParameters = node.parent.parent.parent.typeParameters;
        return typeParameters && ts2.find(typeParameters, function(p) {
          return p.name.escapedText === name;
        });
      }
      ts2.getTypeParameterFromJsDoc = getTypeParameterFromJsDoc;
      function hasRestParameter(s) {
        var last = ts2.lastOrUndefined(s.parameters);
        return !!last && isRestParameter(last);
      }
      ts2.hasRestParameter = hasRestParameter;
      function isRestParameter(node) {
        var type = ts2.isJSDocParameterTag(node) ? node.typeExpression && node.typeExpression.type : node.type;
        return node.dotDotDotToken !== void 0 || !!type && type.kind === 301;
      }
      ts2.isRestParameter = isRestParameter;
      function hasTypeArguments(node) {
        return !!node.typeArguments;
      }
      ts2.hasTypeArguments = hasTypeArguments;
      var AssignmentKind;
      (function(AssignmentKind2) {
        AssignmentKind2[AssignmentKind2["None"] = 0] = "None";
        AssignmentKind2[AssignmentKind2["Definite"] = 1] = "Definite";
        AssignmentKind2[AssignmentKind2["Compound"] = 2] = "Compound";
      })(AssignmentKind = ts2.AssignmentKind || (ts2.AssignmentKind = {}));
      function getAssignmentTargetKind(node) {
        var parent = node.parent;
        while (true) {
          switch (parent.kind) {
            case 209:
              var binaryOperator = parent.operatorToken.kind;
              return isAssignmentOperator(binaryOperator) && parent.left === node ? binaryOperator === 62 ? 1 : 2 : 0;
            case 207:
            case 208:
              var unaryOperator = parent.operator;
              return unaryOperator === 45 || unaryOperator === 46 ? 2 : 0;
            case 231:
            case 232:
              return parent.initializer === node ? 1 : 0;
            case 200:
            case 192:
            case 213:
            case 218:
              node = parent;
              break;
            case 282:
              if (parent.name !== node) {
                return 0;
              }
              node = parent.parent;
              break;
            case 281:
              if (parent.name === node) {
                return 0;
              }
              node = parent.parent;
              break;
            default:
              return 0;
          }
          parent = node.parent;
        }
      }
      ts2.getAssignmentTargetKind = getAssignmentTargetKind;
      function isAssignmentTarget(node) {
        return getAssignmentTargetKind(node) !== 0;
      }
      ts2.isAssignmentTarget = isAssignmentTarget;
      function isNodeWithPossibleHoistedDeclaration(node) {
        switch (node.kind) {
          case 223:
          case 225:
          case 236:
          case 227:
          case 237:
          case 251:
          case 277:
          case 278:
          case 238:
          case 230:
          case 231:
          case 232:
          case 228:
          case 229:
          case 240:
          case 280:
            return true;
        }
        return false;
      }
      ts2.isNodeWithPossibleHoistedDeclaration = isNodeWithPossibleHoistedDeclaration;
      function isValueSignatureDeclaration(node) {
        return ts2.isFunctionExpression(node) || ts2.isArrowFunction(node) || ts2.isMethodOrAccessor(node) || ts2.isFunctionDeclaration(node) || ts2.isConstructorDeclaration(node);
      }
      ts2.isValueSignatureDeclaration = isValueSignatureDeclaration;
      function walkUp(node, kind) {
        while (node && node.kind === kind) {
          node = node.parent;
        }
        return node;
      }
      function walkUpParenthesizedTypes(node) {
        return walkUp(node, 182);
      }
      ts2.walkUpParenthesizedTypes = walkUpParenthesizedTypes;
      function walkUpParenthesizedExpressions(node) {
        return walkUp(node, 200);
      }
      ts2.walkUpParenthesizedExpressions = walkUpParenthesizedExpressions;
      function skipParentheses(node) {
        return ts2.skipOuterExpressions(node, 1);
      }
      ts2.skipParentheses = skipParentheses;
      function skipParenthesesUp(node) {
        while (node.kind === 200) {
          node = node.parent;
        }
        return node;
      }
      function isDeleteTarget(node) {
        if (node.kind !== 194 && node.kind !== 195) {
          return false;
        }
        node = walkUpParenthesizedExpressions(node.parent);
        return node && node.kind === 203;
      }
      ts2.isDeleteTarget = isDeleteTarget;
      function isNodeDescendantOf(node, ancestor) {
        while (node) {
          if (node === ancestor)
            return true;
          node = node.parent;
        }
        return false;
      }
      ts2.isNodeDescendantOf = isNodeDescendantOf;
      function isDeclarationName(name) {
        return !ts2.isSourceFile(name) && !ts2.isBindingPattern(name) && ts2.isDeclaration(name.parent) && name.parent.name === name;
      }
      ts2.isDeclarationName = isDeclarationName;
      function getDeclarationFromName(name) {
        var parent = name.parent;
        switch (name.kind) {
          case 10:
          case 14:
          case 8:
            if (ts2.isComputedPropertyName(parent))
              return parent.parent;
          case 75:
            if (ts2.isDeclaration(parent)) {
              return parent.name === name ? parent : void 0;
            } else if (ts2.isQualifiedName(parent)) {
              var tag = parent.parent;
              return ts2.isJSDocParameterTag(tag) && tag.name === parent ? tag : void 0;
            } else {
              var binExp = parent.parent;
              return ts2.isBinaryExpression(binExp) && getAssignmentDeclarationKind(binExp) !== 0 && (binExp.left.symbol || binExp.symbol) && ts2.getNameOfDeclaration(binExp) === name ? binExp : void 0;
            }
          case 76:
            return ts2.isDeclaration(parent) && parent.name === name ? parent : void 0;
          default:
            return void 0;
        }
      }
      ts2.getDeclarationFromName = getDeclarationFromName;
      function isLiteralComputedPropertyDeclarationName(node) {
        return isStringOrNumericLiteralLike(node) && node.parent.kind === 154 && ts2.isDeclaration(node.parent.parent);
      }
      ts2.isLiteralComputedPropertyDeclarationName = isLiteralComputedPropertyDeclarationName;
      function isIdentifierName(node) {
        var parent = node.parent;
        switch (parent.kind) {
          case 159:
          case 158:
          case 161:
          case 160:
          case 163:
          case 164:
          case 284:
          case 281:
          case 194:
            return parent.name === node;
          case 153:
            if (parent.right === node) {
              while (parent.kind === 153) {
                parent = parent.parent;
              }
              return parent.kind === 172 || parent.kind === 169;
            }
            return false;
          case 191:
          case 258:
            return parent.propertyName === node;
          case 263:
          case 273:
            return true;
        }
        return false;
      }
      ts2.isIdentifierName = isIdentifierName;
      function isAliasSymbolDeclaration(node) {
        return node.kind === 253 || node.kind === 252 || node.kind === 255 && !!node.name || node.kind === 256 || node.kind === 262 || node.kind === 258 || node.kind === 263 || node.kind === 259 && exportAssignmentIsAlias(node) || ts2.isBinaryExpression(node) && getAssignmentDeclarationKind(node) === 2 && exportAssignmentIsAlias(node) || ts2.isPropertyAccessExpression(node) && ts2.isBinaryExpression(node.parent) && node.parent.left === node && node.parent.operatorToken.kind === 62 && isAliasableExpression(node.parent.right) || node.kind === 282 || node.kind === 281 && isAliasableExpression(node.initializer);
      }
      ts2.isAliasSymbolDeclaration = isAliasSymbolDeclaration;
      function getAliasDeclarationFromName(node) {
        switch (node.parent.kind) {
          case 255:
          case 258:
          case 256:
          case 263:
          case 259:
          case 253:
            return node.parent;
          case 153:
            do {
              node = node.parent;
            } while (node.parent.kind === 153);
            return getAliasDeclarationFromName(node);
        }
      }
      ts2.getAliasDeclarationFromName = getAliasDeclarationFromName;
      function isAliasableExpression(e) {
        return isEntityNameExpression(e) || ts2.isClassExpression(e);
      }
      ts2.isAliasableExpression = isAliasableExpression;
      function exportAssignmentIsAlias(node) {
        var e = getExportAssignmentExpression(node);
        return isAliasableExpression(e);
      }
      ts2.exportAssignmentIsAlias = exportAssignmentIsAlias;
      function getExportAssignmentExpression(node) {
        return ts2.isExportAssignment(node) ? node.expression : node.right;
      }
      ts2.getExportAssignmentExpression = getExportAssignmentExpression;
      function getPropertyAssignmentAliasLikeExpression(node) {
        return node.kind === 282 ? node.name : node.kind === 281 ? node.initializer : node.parent.right;
      }
      ts2.getPropertyAssignmentAliasLikeExpression = getPropertyAssignmentAliasLikeExpression;
      function getEffectiveBaseTypeNode(node) {
        var baseType = getClassExtendsHeritageElement(node);
        if (baseType && isInJSFile(node)) {
          var tag = ts2.getJSDocAugmentsTag(node);
          if (tag) {
            return tag.class;
          }
        }
        return baseType;
      }
      ts2.getEffectiveBaseTypeNode = getEffectiveBaseTypeNode;
      function getClassExtendsHeritageElement(node) {
        var heritageClause = getHeritageClause(node.heritageClauses, 90);
        return heritageClause && heritageClause.types.length > 0 ? heritageClause.types[0] : void 0;
      }
      ts2.getClassExtendsHeritageElement = getClassExtendsHeritageElement;
      function getEffectiveImplementsTypeNodes(node) {
        if (isInJSFile(node)) {
          return ts2.getJSDocImplementsTags(node).map(function(n) {
            return n.class;
          });
        } else {
          var heritageClause = getHeritageClause(node.heritageClauses, 113);
          return heritageClause === null || heritageClause === void 0 ? void 0 : heritageClause.types;
        }
      }
      ts2.getEffectiveImplementsTypeNodes = getEffectiveImplementsTypeNodes;
      function getAllSuperTypeNodes(node) {
        return ts2.isInterfaceDeclaration(node) ? getInterfaceBaseTypeNodes(node) || ts2.emptyArray : ts2.isClassLike(node) ? ts2.concatenate(ts2.singleElementArray(getEffectiveBaseTypeNode(node)), getEffectiveImplementsTypeNodes(node)) || ts2.emptyArray : ts2.emptyArray;
      }
      ts2.getAllSuperTypeNodes = getAllSuperTypeNodes;
      function getInterfaceBaseTypeNodes(node) {
        var heritageClause = getHeritageClause(node.heritageClauses, 90);
        return heritageClause ? heritageClause.types : void 0;
      }
      ts2.getInterfaceBaseTypeNodes = getInterfaceBaseTypeNodes;
      function getHeritageClause(clauses, kind) {
        if (clauses) {
          for (var _i = 0, clauses_1 = clauses; _i < clauses_1.length; _i++) {
            var clause = clauses_1[_i];
            if (clause.token === kind) {
              return clause;
            }
          }
        }
        return void 0;
      }
      ts2.getHeritageClause = getHeritageClause;
      function getAncestor(node, kind) {
        while (node) {
          if (node.kind === kind) {
            return node;
          }
          node = node.parent;
        }
        return void 0;
      }
      ts2.getAncestor = getAncestor;
      function isKeyword(token) {
        return 77 <= token && token <= 152;
      }
      ts2.isKeyword = isKeyword;
      function isContextualKeyword(token) {
        return 122 <= token && token <= 152;
      }
      ts2.isContextualKeyword = isContextualKeyword;
      function isNonContextualKeyword(token) {
        return isKeyword(token) && !isContextualKeyword(token);
      }
      ts2.isNonContextualKeyword = isNonContextualKeyword;
      function isFutureReservedKeyword(token) {
        return 113 <= token && token <= 121;
      }
      ts2.isFutureReservedKeyword = isFutureReservedKeyword;
      function isStringANonContextualKeyword(name) {
        var token = ts2.stringToToken(name);
        return token !== void 0 && isNonContextualKeyword(token);
      }
      ts2.isStringANonContextualKeyword = isStringANonContextualKeyword;
      function isStringAKeyword(name) {
        var token = ts2.stringToToken(name);
        return token !== void 0 && isKeyword(token);
      }
      ts2.isStringAKeyword = isStringAKeyword;
      function isIdentifierANonContextualKeyword(_a) {
        var originalKeywordKind = _a.originalKeywordKind;
        return !!originalKeywordKind && !isContextualKeyword(originalKeywordKind);
      }
      ts2.isIdentifierANonContextualKeyword = isIdentifierANonContextualKeyword;
      function isTrivia(token) {
        return 2 <= token && token <= 7;
      }
      ts2.isTrivia = isTrivia;
      var FunctionFlags;
      (function(FunctionFlags2) {
        FunctionFlags2[FunctionFlags2["Normal"] = 0] = "Normal";
        FunctionFlags2[FunctionFlags2["Generator"] = 1] = "Generator";
        FunctionFlags2[FunctionFlags2["Async"] = 2] = "Async";
        FunctionFlags2[FunctionFlags2["Invalid"] = 4] = "Invalid";
        FunctionFlags2[FunctionFlags2["AsyncGenerator"] = 3] = "AsyncGenerator";
      })(FunctionFlags = ts2.FunctionFlags || (ts2.FunctionFlags = {}));
      function getFunctionFlags(node) {
        if (!node) {
          return 4;
        }
        var flags = 0;
        switch (node.kind) {
          case 244:
          case 201:
          case 161:
            if (node.asteriskToken) {
              flags |= 1;
            }
          case 202:
            if (hasModifier(node, 256)) {
              flags |= 2;
            }
            break;
        }
        if (!node.body) {
          flags |= 4;
        }
        return flags;
      }
      ts2.getFunctionFlags = getFunctionFlags;
      function isAsyncFunction(node) {
        switch (node.kind) {
          case 244:
          case 201:
          case 202:
          case 161:
            return node.body !== void 0 && node.asteriskToken === void 0 && hasModifier(node, 256);
        }
        return false;
      }
      ts2.isAsyncFunction = isAsyncFunction;
      function isStringOrNumericLiteralLike(node) {
        return ts2.isStringLiteralLike(node) || ts2.isNumericLiteral(node);
      }
      ts2.isStringOrNumericLiteralLike = isStringOrNumericLiteralLike;
      function isSignedNumericLiteral(node) {
        return ts2.isPrefixUnaryExpression(node) && (node.operator === 39 || node.operator === 40) && ts2.isNumericLiteral(node.operand);
      }
      ts2.isSignedNumericLiteral = isSignedNumericLiteral;
      function hasDynamicName(declaration) {
        var name = ts2.getNameOfDeclaration(declaration);
        return !!name && isDynamicName(name);
      }
      ts2.hasDynamicName = hasDynamicName;
      function isDynamicName(name) {
        if (!(name.kind === 154 || name.kind === 195)) {
          return false;
        }
        var expr = ts2.isElementAccessExpression(name) ? skipParentheses(name.argumentExpression) : name.expression;
        return !isStringOrNumericLiteralLike(expr) && !isSignedNumericLiteral(expr) && !isWellKnownSymbolSyntactically(expr);
      }
      ts2.isDynamicName = isDynamicName;
      function isWellKnownSymbolSyntactically(node) {
        return ts2.isPropertyAccessExpression(node) && isESSymbolIdentifier(node.expression);
      }
      ts2.isWellKnownSymbolSyntactically = isWellKnownSymbolSyntactically;
      function getPropertyNameForPropertyNameNode(name) {
        switch (name.kind) {
          case 75:
          case 76:
            return name.escapedText;
          case 10:
          case 8:
            return ts2.escapeLeadingUnderscores(name.text);
          case 154:
            var nameExpression = name.expression;
            if (isWellKnownSymbolSyntactically(nameExpression)) {
              return getPropertyNameForKnownSymbolName(ts2.idText(nameExpression.name));
            } else if (isStringOrNumericLiteralLike(nameExpression)) {
              return ts2.escapeLeadingUnderscores(nameExpression.text);
            }
            return void 0;
          default:
            return ts2.Debug.assertNever(name);
        }
      }
      ts2.getPropertyNameForPropertyNameNode = getPropertyNameForPropertyNameNode;
      function isPropertyNameLiteral(node) {
        switch (node.kind) {
          case 75:
          case 10:
          case 14:
          case 8:
            return true;
          default:
            return false;
        }
      }
      ts2.isPropertyNameLiteral = isPropertyNameLiteral;
      function getTextOfIdentifierOrLiteral(node) {
        return ts2.isIdentifierOrPrivateIdentifier(node) ? ts2.idText(node) : node.text;
      }
      ts2.getTextOfIdentifierOrLiteral = getTextOfIdentifierOrLiteral;
      function getEscapedTextOfIdentifierOrLiteral(node) {
        return ts2.isIdentifierOrPrivateIdentifier(node) ? node.escapedText : ts2.escapeLeadingUnderscores(node.text);
      }
      ts2.getEscapedTextOfIdentifierOrLiteral = getEscapedTextOfIdentifierOrLiteral;
      function getPropertyNameForUniqueESSymbol(symbol) {
        return "__@" + ts2.getSymbolId(symbol) + "@" + symbol.escapedName;
      }
      ts2.getPropertyNameForUniqueESSymbol = getPropertyNameForUniqueESSymbol;
      function getPropertyNameForKnownSymbolName(symbolName) {
        return "__@" + symbolName;
      }
      ts2.getPropertyNameForKnownSymbolName = getPropertyNameForKnownSymbolName;
      function getSymbolNameForPrivateIdentifier(containingClassSymbol, description) {
        return "__#" + ts2.getSymbolId(containingClassSymbol) + "@" + description;
      }
      ts2.getSymbolNameForPrivateIdentifier = getSymbolNameForPrivateIdentifier;
      function isKnownSymbol(symbol) {
        return ts2.startsWith(symbol.escapedName, "__@");
      }
      ts2.isKnownSymbol = isKnownSymbol;
      function isESSymbolIdentifier(node) {
        return node.kind === 75 && node.escapedText === "Symbol";
      }
      ts2.isESSymbolIdentifier = isESSymbolIdentifier;
      function isPushOrUnshiftIdentifier(node) {
        return node.escapedText === "push" || node.escapedText === "unshift";
      }
      ts2.isPushOrUnshiftIdentifier = isPushOrUnshiftIdentifier;
      function isParameterDeclaration(node) {
        var root = getRootDeclaration(node);
        return root.kind === 156;
      }
      ts2.isParameterDeclaration = isParameterDeclaration;
      function getRootDeclaration(node) {
        while (node.kind === 191) {
          node = node.parent.parent;
        }
        return node;
      }
      ts2.getRootDeclaration = getRootDeclaration;
      function nodeStartsNewLexicalEnvironment(node) {
        var kind = node.kind;
        return kind === 162 || kind === 201 || kind === 244 || kind === 202 || kind === 161 || kind === 163 || kind === 164 || kind === 249 || kind === 290;
      }
      ts2.nodeStartsNewLexicalEnvironment = nodeStartsNewLexicalEnvironment;
      function nodeIsSynthesized(range) {
        return positionIsSynthesized(range.pos) || positionIsSynthesized(range.end);
      }
      ts2.nodeIsSynthesized = nodeIsSynthesized;
      function getOriginalSourceFile(sourceFile) {
        return ts2.getParseTreeNode(sourceFile, ts2.isSourceFile) || sourceFile;
      }
      ts2.getOriginalSourceFile = getOriginalSourceFile;
      var Associativity;
      (function(Associativity2) {
        Associativity2[Associativity2["Left"] = 0] = "Left";
        Associativity2[Associativity2["Right"] = 1] = "Right";
      })(Associativity = ts2.Associativity || (ts2.Associativity = {}));
      function getExpressionAssociativity(expression) {
        var operator = getOperator(expression);
        var hasArguments = expression.kind === 197 && expression.arguments !== void 0;
        return getOperatorAssociativity(expression.kind, operator, hasArguments);
      }
      ts2.getExpressionAssociativity = getExpressionAssociativity;
      function getOperatorAssociativity(kind, operator, hasArguments) {
        switch (kind) {
          case 197:
            return hasArguments ? 0 : 1;
          case 207:
          case 204:
          case 205:
          case 203:
          case 206:
          case 210:
          case 212:
            return 1;
          case 209:
            switch (operator) {
              case 42:
              case 62:
              case 63:
              case 64:
              case 66:
              case 65:
              case 67:
              case 68:
              case 69:
              case 70:
              case 71:
              case 72:
              case 74:
              case 73:
                return 1;
            }
        }
        return 0;
      }
      ts2.getOperatorAssociativity = getOperatorAssociativity;
      function getExpressionPrecedence(expression) {
        var operator = getOperator(expression);
        var hasArguments = expression.kind === 197 && expression.arguments !== void 0;
        return getOperatorPrecedence(expression.kind, operator, hasArguments);
      }
      ts2.getExpressionPrecedence = getExpressionPrecedence;
      function getOperator(expression) {
        if (expression.kind === 209) {
          return expression.operatorToken.kind;
        } else if (expression.kind === 207 || expression.kind === 208) {
          return expression.operator;
        } else {
          return expression.kind;
        }
      }
      ts2.getOperator = getOperator;
      function getOperatorPrecedence(nodeKind, operatorKind, hasArguments) {
        switch (nodeKind) {
          case 327:
            return 0;
          case 213:
            return 1;
          case 212:
            return 2;
          case 210:
            return 4;
          case 209:
            switch (operatorKind) {
              case 27:
                return 0;
              case 62:
              case 63:
              case 64:
              case 66:
              case 65:
              case 67:
              case 68:
              case 69:
              case 70:
              case 71:
              case 72:
              case 74:
              case 73:
                return 3;
              default:
                return getBinaryOperatorPrecedence(operatorKind);
            }
          case 207:
          case 204:
          case 205:
          case 203:
          case 206:
            return 16;
          case 208:
            return 17;
          case 196:
            return 18;
          case 197:
            return hasArguments ? 19 : 18;
          case 198:
          case 194:
          case 195:
            return 19;
          case 104:
          case 102:
          case 75:
          case 100:
          case 106:
          case 91:
          case 8:
          case 9:
          case 10:
          case 192:
          case 193:
          case 201:
          case 202:
          case 214:
          case 266:
          case 267:
          case 270:
          case 13:
          case 14:
          case 211:
          case 200:
          case 215:
            return 20;
          default:
            return -1;
        }
      }
      ts2.getOperatorPrecedence = getOperatorPrecedence;
      function getBinaryOperatorPrecedence(kind) {
        switch (kind) {
          case 60:
            return 4;
          case 56:
            return 5;
          case 55:
            return 6;
          case 51:
            return 7;
          case 52:
            return 8;
          case 50:
            return 9;
          case 34:
          case 35:
          case 36:
          case 37:
            return 10;
          case 29:
          case 31:
          case 32:
          case 33:
          case 98:
          case 97:
          case 123:
            return 11;
          case 47:
          case 48:
          case 49:
            return 12;
          case 39:
          case 40:
            return 13;
          case 41:
          case 43:
          case 44:
            return 14;
          case 42:
            return 15;
        }
        return -1;
      }
      ts2.getBinaryOperatorPrecedence = getBinaryOperatorPrecedence;
      function createDiagnosticCollection() {
        var nonFileDiagnostics = [];
        var filesWithDiagnostics = [];
        var fileDiagnostics = ts2.createMap();
        var hasReadNonFileDiagnostics = false;
        return {
          add,
          lookup,
          getGlobalDiagnostics,
          getDiagnostics,
          reattachFileDiagnostics
        };
        function reattachFileDiagnostics(newFile) {
          ts2.forEach(fileDiagnostics.get(newFile.fileName), function(diagnostic) {
            return diagnostic.file = newFile;
          });
        }
        function lookup(diagnostic) {
          var diagnostics;
          if (diagnostic.file) {
            diagnostics = fileDiagnostics.get(diagnostic.file.fileName);
          } else {
            diagnostics = nonFileDiagnostics;
          }
          if (!diagnostics) {
            return void 0;
          }
          var result = ts2.binarySearch(diagnostics, diagnostic, ts2.identity, compareDiagnosticsSkipRelatedInformation);
          if (result >= 0) {
            return diagnostics[result];
          }
          return void 0;
        }
        function add(diagnostic) {
          var diagnostics;
          if (diagnostic.file) {
            diagnostics = fileDiagnostics.get(diagnostic.file.fileName);
            if (!diagnostics) {
              diagnostics = [];
              fileDiagnostics.set(diagnostic.file.fileName, diagnostics);
              ts2.insertSorted(filesWithDiagnostics, diagnostic.file.fileName, ts2.compareStringsCaseSensitive);
            }
          } else {
            if (hasReadNonFileDiagnostics) {
              hasReadNonFileDiagnostics = false;
              nonFileDiagnostics = nonFileDiagnostics.slice();
            }
            diagnostics = nonFileDiagnostics;
          }
          ts2.insertSorted(diagnostics, diagnostic, compareDiagnostics);
        }
        function getGlobalDiagnostics() {
          hasReadNonFileDiagnostics = true;
          return nonFileDiagnostics;
        }
        function getDiagnostics(fileName) {
          if (fileName) {
            return fileDiagnostics.get(fileName) || [];
          }
          var fileDiags = ts2.flatMapToMutable(filesWithDiagnostics, function(f) {
            return fileDiagnostics.get(f);
          });
          if (!nonFileDiagnostics.length) {
            return fileDiags;
          }
          fileDiags.unshift.apply(fileDiags, nonFileDiagnostics);
          return fileDiags;
        }
      }
      ts2.createDiagnosticCollection = createDiagnosticCollection;
      var templateSubstitutionRegExp = /\$\{/g;
      function escapeTemplateSubstitution(str) {
        return str.replace(templateSubstitutionRegExp, "\\${");
      }
      function hasInvalidEscape(template) {
        return template && !!(ts2.isNoSubstitutionTemplateLiteral(template) ? template.templateFlags : template.head.templateFlags || ts2.some(template.templateSpans, function(span) {
          return !!span.literal.templateFlags;
        }));
      }
      ts2.hasInvalidEscape = hasInvalidEscape;
      var doubleQuoteEscapedCharsRegExp = /[\\\"\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g;
      var singleQuoteEscapedCharsRegExp = /[\\\'\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g;
      var backtickQuoteEscapedCharsRegExp = /[\\`]/g;
      var escapedCharsMap = ts2.createMapFromTemplate({
        "	": "\\t",
        "\v": "\\v",
        "\f": "\\f",
        "\b": "\\b",
        "\r": "\\r",
        "\n": "\\n",
        "\\": "\\\\",
        '"': '\\"',
        "'": "\\'",
        "`": "\\`",
        "\u2028": "\\u2028",
        "\u2029": "\\u2029",
        "\x85": "\\u0085"
      });
      function encodeUtf16EscapeSequence(charCode) {
        var hexCharCode = charCode.toString(16).toUpperCase();
        var paddedHexCode = ("0000" + hexCharCode).slice(-4);
        return "\\u" + paddedHexCode;
      }
      function getReplacement(c, offset, input) {
        if (c.charCodeAt(0) === 0) {
          var lookAhead = input.charCodeAt(offset + c.length);
          if (lookAhead >= 48 && lookAhead <= 57) {
            return "\\x00";
          }
          return "\\0";
        }
        return escapedCharsMap.get(c) || encodeUtf16EscapeSequence(c.charCodeAt(0));
      }
      function escapeString(s, quoteChar) {
        var escapedCharsRegExp = quoteChar === 96 ? backtickQuoteEscapedCharsRegExp : quoteChar === 39 ? singleQuoteEscapedCharsRegExp : doubleQuoteEscapedCharsRegExp;
        return s.replace(escapedCharsRegExp, getReplacement);
      }
      ts2.escapeString = escapeString;
      var nonAsciiCharacters = /[^\u0000-\u007F]/g;
      function escapeNonAsciiString(s, quoteChar) {
        s = escapeString(s, quoteChar);
        return nonAsciiCharacters.test(s) ? s.replace(nonAsciiCharacters, function(c) {
          return encodeUtf16EscapeSequence(c.charCodeAt(0));
        }) : s;
      }
      ts2.escapeNonAsciiString = escapeNonAsciiString;
      var jsxDoubleQuoteEscapedCharsRegExp = /[\"\u0000-\u001f\u2028\u2029\u0085]/g;
      var jsxSingleQuoteEscapedCharsRegExp = /[\'\u0000-\u001f\u2028\u2029\u0085]/g;
      var jsxEscapedCharsMap = ts2.createMapFromTemplate({
        '"': "&quot;",
        "'": "&apos;"
      });
      function encodeJsxCharacterEntity(charCode) {
        var hexCharCode = charCode.toString(16).toUpperCase();
        return "&#x" + hexCharCode + ";";
      }
      function getJsxAttributeStringReplacement(c) {
        if (c.charCodeAt(0) === 0) {
          return "&#0;";
        }
        return jsxEscapedCharsMap.get(c) || encodeJsxCharacterEntity(c.charCodeAt(0));
      }
      function escapeJsxAttributeString(s, quoteChar) {
        var escapedCharsRegExp = quoteChar === 39 ? jsxSingleQuoteEscapedCharsRegExp : jsxDoubleQuoteEscapedCharsRegExp;
        return s.replace(escapedCharsRegExp, getJsxAttributeStringReplacement);
      }
      ts2.escapeJsxAttributeString = escapeJsxAttributeString;
      function stripQuotes(name) {
        var length = name.length;
        if (length >= 2 && name.charCodeAt(0) === name.charCodeAt(length - 1) && isQuoteOrBacktick(name.charCodeAt(0))) {
          return name.substring(1, length - 1);
        }
        return name;
      }
      ts2.stripQuotes = stripQuotes;
      function isQuoteOrBacktick(charCode) {
        return charCode === 39 || charCode === 34 || charCode === 96;
      }
      function isIntrinsicJsxName(name) {
        var ch = name.charCodeAt(0);
        return ch >= 97 && ch <= 122 || ts2.stringContains(name, "-");
      }
      ts2.isIntrinsicJsxName = isIntrinsicJsxName;
      var indentStrings = ["", "    "];
      function getIndentString(level) {
        if (indentStrings[level] === void 0) {
          indentStrings[level] = getIndentString(level - 1) + indentStrings[1];
        }
        return indentStrings[level];
      }
      ts2.getIndentString = getIndentString;
      function getIndentSize() {
        return indentStrings[1].length;
      }
      ts2.getIndentSize = getIndentSize;
      function createTextWriter(newLine) {
        var output;
        var indent;
        var lineStart;
        var lineCount;
        var linePos;
        var hasTrailingComment = false;
        function updateLineCountAndPosFor(s) {
          var lineStartsOfS = ts2.computeLineStarts(s);
          if (lineStartsOfS.length > 1) {
            lineCount = lineCount + lineStartsOfS.length - 1;
            linePos = output.length - s.length + ts2.last(lineStartsOfS);
            lineStart = linePos - output.length === 0;
          } else {
            lineStart = false;
          }
        }
        function writeText(s) {
          if (s && s.length) {
            if (lineStart) {
              s = getIndentString(indent) + s;
              lineStart = false;
            }
            output += s;
            updateLineCountAndPosFor(s);
          }
        }
        function write(s) {
          if (s)
            hasTrailingComment = false;
          writeText(s);
        }
        function writeComment(s) {
          if (s)
            hasTrailingComment = true;
          writeText(s);
        }
        function reset() {
          output = "";
          indent = 0;
          lineStart = true;
          lineCount = 0;
          linePos = 0;
          hasTrailingComment = false;
        }
        function rawWrite(s) {
          if (s !== void 0) {
            output += s;
            updateLineCountAndPosFor(s);
            hasTrailingComment = false;
          }
        }
        function writeLiteral(s) {
          if (s && s.length) {
            write(s);
          }
        }
        function writeLine(force) {
          if (!lineStart || force) {
            output += newLine;
            lineCount++;
            linePos = output.length;
            lineStart = true;
            hasTrailingComment = false;
          }
        }
        function getTextPosWithWriteLine() {
          return lineStart ? output.length : output.length + newLine.length;
        }
        reset();
        return {
          write,
          rawWrite,
          writeLiteral,
          writeLine,
          increaseIndent: function() {
            indent++;
          },
          decreaseIndent: function() {
            indent--;
          },
          getIndent: function() {
            return indent;
          },
          getTextPos: function() {
            return output.length;
          },
          getLine: function() {
            return lineCount;
          },
          getColumn: function() {
            return lineStart ? indent * getIndentSize() : output.length - linePos;
          },
          getText: function() {
            return output;
          },
          isAtStartOfLine: function() {
            return lineStart;
          },
          hasTrailingComment: function() {
            return hasTrailingComment;
          },
          hasTrailingWhitespace: function() {
            return !!output.length && ts2.isWhiteSpaceLike(output.charCodeAt(output.length - 1));
          },
          clear: reset,
          reportInaccessibleThisError: ts2.noop,
          reportPrivateInBaseOfClassExpression: ts2.noop,
          reportInaccessibleUniqueSymbolError: ts2.noop,
          trackSymbol: ts2.noop,
          writeKeyword: write,
          writeOperator: write,
          writeParameter: write,
          writeProperty: write,
          writePunctuation: write,
          writeSpace: write,
          writeStringLiteral: write,
          writeSymbol: function(s, _) {
            return write(s);
          },
          writeTrailingSemicolon: write,
          writeComment,
          getTextPosWithWriteLine
        };
      }
      ts2.createTextWriter = createTextWriter;
      function getTrailingSemicolonDeferringWriter(writer) {
        var pendingTrailingSemicolon = false;
        function commitPendingTrailingSemicolon() {
          if (pendingTrailingSemicolon) {
            writer.writeTrailingSemicolon(";");
            pendingTrailingSemicolon = false;
          }
        }
        return __assign(__assign({}, writer), {
          writeTrailingSemicolon: function() {
            pendingTrailingSemicolon = true;
          },
          writeLiteral: function(s) {
            commitPendingTrailingSemicolon();
            writer.writeLiteral(s);
          },
          writeStringLiteral: function(s) {
            commitPendingTrailingSemicolon();
            writer.writeStringLiteral(s);
          },
          writeSymbol: function(s, sym) {
            commitPendingTrailingSemicolon();
            writer.writeSymbol(s, sym);
          },
          writePunctuation: function(s) {
            commitPendingTrailingSemicolon();
            writer.writePunctuation(s);
          },
          writeKeyword: function(s) {
            commitPendingTrailingSemicolon();
            writer.writeKeyword(s);
          },
          writeOperator: function(s) {
            commitPendingTrailingSemicolon();
            writer.writeOperator(s);
          },
          writeParameter: function(s) {
            commitPendingTrailingSemicolon();
            writer.writeParameter(s);
          },
          writeSpace: function(s) {
            commitPendingTrailingSemicolon();
            writer.writeSpace(s);
          },
          writeProperty: function(s) {
            commitPendingTrailingSemicolon();
            writer.writeProperty(s);
          },
          writeComment: function(s) {
            commitPendingTrailingSemicolon();
            writer.writeComment(s);
          },
          writeLine: function() {
            commitPendingTrailingSemicolon();
            writer.writeLine();
          },
          increaseIndent: function() {
            commitPendingTrailingSemicolon();
            writer.increaseIndent();
          },
          decreaseIndent: function() {
            commitPendingTrailingSemicolon();
            writer.decreaseIndent();
          }
        });
      }
      ts2.getTrailingSemicolonDeferringWriter = getTrailingSemicolonDeferringWriter;
      function hostUsesCaseSensitiveFileNames(host) {
        return host.useCaseSensitiveFileNames ? host.useCaseSensitiveFileNames() : false;
      }
      ts2.hostUsesCaseSensitiveFileNames = hostUsesCaseSensitiveFileNames;
      function hostGetCanonicalFileName(host) {
        return ts2.createGetCanonicalFileName(hostUsesCaseSensitiveFileNames(host));
      }
      ts2.hostGetCanonicalFileName = hostGetCanonicalFileName;
      function getResolvedExternalModuleName(host, file, referenceFile) {
        return file.moduleName || getExternalModuleNameFromPath(host, file.fileName, referenceFile && referenceFile.fileName);
      }
      ts2.getResolvedExternalModuleName = getResolvedExternalModuleName;
      function getExternalModuleNameFromDeclaration(host, resolver, declaration) {
        var file = resolver.getExternalModuleFileFromDeclaration(declaration);
        if (!file || file.isDeclarationFile) {
          return void 0;
        }
        return getResolvedExternalModuleName(host, file);
      }
      ts2.getExternalModuleNameFromDeclaration = getExternalModuleNameFromDeclaration;
      function getExternalModuleNameFromPath(host, fileName, referencePath) {
        var getCanonicalFileName = function(f) {
          return host.getCanonicalFileName(f);
        };
        var dir = ts2.toPath(referencePath ? ts2.getDirectoryPath(referencePath) : host.getCommonSourceDirectory(), host.getCurrentDirectory(), getCanonicalFileName);
        var filePath = ts2.getNormalizedAbsolutePath(fileName, host.getCurrentDirectory());
        var relativePath = ts2.getRelativePathToDirectoryOrUrl(dir, filePath, dir, getCanonicalFileName, false);
        var extensionless = removeFileExtension(relativePath);
        return referencePath ? ts2.ensurePathIsNonModuleName(extensionless) : extensionless;
      }
      ts2.getExternalModuleNameFromPath = getExternalModuleNameFromPath;
      function getOwnEmitOutputFilePath(fileName, host, extension) {
        var compilerOptions = host.getCompilerOptions();
        var emitOutputFilePathWithoutExtension;
        if (compilerOptions.outDir) {
          emitOutputFilePathWithoutExtension = removeFileExtension(getSourceFilePathInNewDir(fileName, host, compilerOptions.outDir));
        } else {
          emitOutputFilePathWithoutExtension = removeFileExtension(fileName);
        }
        return emitOutputFilePathWithoutExtension + extension;
      }
      ts2.getOwnEmitOutputFilePath = getOwnEmitOutputFilePath;
      function getDeclarationEmitOutputFilePath(fileName, host) {
        return getDeclarationEmitOutputFilePathWorker(fileName, host.getCompilerOptions(), host.getCurrentDirectory(), host.getCommonSourceDirectory(), function(f) {
          return host.getCanonicalFileName(f);
        });
      }
      ts2.getDeclarationEmitOutputFilePath = getDeclarationEmitOutputFilePath;
      function getDeclarationEmitOutputFilePathWorker(fileName, options, currentDirectory, commonSourceDirectory, getCanonicalFileName) {
        var outputDir = options.declarationDir || options.outDir;
        var path2 = outputDir ? getSourceFilePathInNewDirWorker(fileName, outputDir, currentDirectory, commonSourceDirectory, getCanonicalFileName) : fileName;
        return removeFileExtension(path2) + ".d.ts";
      }
      ts2.getDeclarationEmitOutputFilePathWorker = getDeclarationEmitOutputFilePathWorker;
      function getSourceFilesToEmit(host, targetSourceFile, forceDtsEmit) {
        var options = host.getCompilerOptions();
        if (options.outFile || options.out) {
          var moduleKind = getEmitModuleKind(options);
          var moduleEmitEnabled_1 = options.emitDeclarationOnly || moduleKind === ts2.ModuleKind.AMD || moduleKind === ts2.ModuleKind.System;
          return ts2.filter(host.getSourceFiles(), function(sourceFile) {
            return (moduleEmitEnabled_1 || !ts2.isExternalModule(sourceFile)) && sourceFileMayBeEmitted(sourceFile, host, forceDtsEmit);
          });
        } else {
          var sourceFiles = targetSourceFile === void 0 ? host.getSourceFiles() : [targetSourceFile];
          return ts2.filter(sourceFiles, function(sourceFile) {
            return sourceFileMayBeEmitted(sourceFile, host, forceDtsEmit);
          });
        }
      }
      ts2.getSourceFilesToEmit = getSourceFilesToEmit;
      function sourceFileMayBeEmitted(sourceFile, host, forceDtsEmit) {
        var options = host.getCompilerOptions();
        return !(options.noEmitForJsFiles && isSourceFileJS(sourceFile)) && !sourceFile.isDeclarationFile && !host.isSourceFileFromExternalLibrary(sourceFile) && !(isJsonSourceFile(sourceFile) && host.getResolvedProjectReferenceToRedirect(sourceFile.fileName)) && (forceDtsEmit || !host.isSourceOfProjectReferenceRedirect(sourceFile.fileName));
      }
      ts2.sourceFileMayBeEmitted = sourceFileMayBeEmitted;
      function getSourceFilePathInNewDir(fileName, host, newDirPath) {
        return getSourceFilePathInNewDirWorker(fileName, newDirPath, host.getCurrentDirectory(), host.getCommonSourceDirectory(), function(f) {
          return host.getCanonicalFileName(f);
        });
      }
      ts2.getSourceFilePathInNewDir = getSourceFilePathInNewDir;
      function getSourceFilePathInNewDirWorker(fileName, newDirPath, currentDirectory, commonSourceDirectory, getCanonicalFileName) {
        var sourceFilePath = ts2.getNormalizedAbsolutePath(fileName, currentDirectory);
        var isSourceFileInCommonSourceDirectory = getCanonicalFileName(sourceFilePath).indexOf(getCanonicalFileName(commonSourceDirectory)) === 0;
        sourceFilePath = isSourceFileInCommonSourceDirectory ? sourceFilePath.substring(commonSourceDirectory.length) : sourceFilePath;
        return ts2.combinePaths(newDirPath, sourceFilePath);
      }
      ts2.getSourceFilePathInNewDirWorker = getSourceFilePathInNewDirWorker;
      function writeFile(host, diagnostics, fileName, data, writeByteOrderMark, sourceFiles) {
        host.writeFile(fileName, data, writeByteOrderMark, function(hostErrorMessage) {
          diagnostics.add(createCompilerDiagnostic(ts2.Diagnostics.Could_not_write_file_0_Colon_1, fileName, hostErrorMessage));
        }, sourceFiles);
      }
      ts2.writeFile = writeFile;
      function ensureDirectoriesExist(directoryPath, createDirectory, directoryExists) {
        if (directoryPath.length > ts2.getRootLength(directoryPath) && !directoryExists(directoryPath)) {
          var parentDirectory = ts2.getDirectoryPath(directoryPath);
          ensureDirectoriesExist(parentDirectory, createDirectory, directoryExists);
          createDirectory(directoryPath);
        }
      }
      function writeFileEnsuringDirectories(path2, data, writeByteOrderMark, writeFile2, createDirectory, directoryExists) {
        try {
          writeFile2(path2, data, writeByteOrderMark);
        } catch (_a) {
          ensureDirectoriesExist(ts2.getDirectoryPath(ts2.normalizePath(path2)), createDirectory, directoryExists);
          writeFile2(path2, data, writeByteOrderMark);
        }
      }
      ts2.writeFileEnsuringDirectories = writeFileEnsuringDirectories;
      function getLineOfLocalPosition(sourceFile, pos) {
        var lineStarts = ts2.getLineStarts(sourceFile);
        return ts2.computeLineOfPosition(lineStarts, pos);
      }
      ts2.getLineOfLocalPosition = getLineOfLocalPosition;
      function getLineOfLocalPositionFromLineMap(lineMap, pos) {
        return ts2.computeLineOfPosition(lineMap, pos);
      }
      ts2.getLineOfLocalPositionFromLineMap = getLineOfLocalPositionFromLineMap;
      function getFirstConstructorWithBody(node) {
        return ts2.find(node.members, function(member) {
          return ts2.isConstructorDeclaration(member) && nodeIsPresent(member.body);
        });
      }
      ts2.getFirstConstructorWithBody = getFirstConstructorWithBody;
      function getSetAccessorValueParameter(accessor) {
        if (accessor && accessor.parameters.length > 0) {
          var hasThis = accessor.parameters.length === 2 && parameterIsThisKeyword(accessor.parameters[0]);
          return accessor.parameters[hasThis ? 1 : 0];
        }
      }
      ts2.getSetAccessorValueParameter = getSetAccessorValueParameter;
      function getSetAccessorTypeAnnotationNode(accessor) {
        var parameter = getSetAccessorValueParameter(accessor);
        return parameter && parameter.type;
      }
      ts2.getSetAccessorTypeAnnotationNode = getSetAccessorTypeAnnotationNode;
      function getThisParameter(signature) {
        if (signature.parameters.length && !ts2.isJSDocSignature(signature)) {
          var thisParameter = signature.parameters[0];
          if (parameterIsThisKeyword(thisParameter)) {
            return thisParameter;
          }
        }
      }
      ts2.getThisParameter = getThisParameter;
      function parameterIsThisKeyword(parameter) {
        return isThisIdentifier(parameter.name);
      }
      ts2.parameterIsThisKeyword = parameterIsThisKeyword;
      function isThisIdentifier(node) {
        return !!node && node.kind === 75 && identifierIsThisKeyword(node);
      }
      ts2.isThisIdentifier = isThisIdentifier;
      function identifierIsThisKeyword(id) {
        return id.originalKeywordKind === 104;
      }
      ts2.identifierIsThisKeyword = identifierIsThisKeyword;
      function getAllAccessorDeclarations(declarations, accessor) {
        var firstAccessor;
        var secondAccessor;
        var getAccessor;
        var setAccessor;
        if (hasDynamicName(accessor)) {
          firstAccessor = accessor;
          if (accessor.kind === 163) {
            getAccessor = accessor;
          } else if (accessor.kind === 164) {
            setAccessor = accessor;
          } else {
            ts2.Debug.fail("Accessor has wrong kind");
          }
        } else {
          ts2.forEach(declarations, function(member) {
            if (ts2.isAccessor(member) && hasModifier(member, 32) === hasModifier(accessor, 32)) {
              var memberName = getPropertyNameForPropertyNameNode(member.name);
              var accessorName = getPropertyNameForPropertyNameNode(accessor.name);
              if (memberName === accessorName) {
                if (!firstAccessor) {
                  firstAccessor = member;
                } else if (!secondAccessor) {
                  secondAccessor = member;
                }
                if (member.kind === 163 && !getAccessor) {
                  getAccessor = member;
                }
                if (member.kind === 164 && !setAccessor) {
                  setAccessor = member;
                }
              }
            }
          });
        }
        return {
          firstAccessor,
          secondAccessor,
          getAccessor,
          setAccessor
        };
      }
      ts2.getAllAccessorDeclarations = getAllAccessorDeclarations;
      function getEffectiveTypeAnnotationNode(node) {
        if (!isInJSFile(node) && ts2.isFunctionDeclaration(node))
          return void 0;
        var type = node.type;
        if (type || !isInJSFile(node))
          return type;
        return ts2.isJSDocPropertyLikeTag(node) ? node.typeExpression && node.typeExpression.type : ts2.getJSDocType(node);
      }
      ts2.getEffectiveTypeAnnotationNode = getEffectiveTypeAnnotationNode;
      function getTypeAnnotationNode(node) {
        return node.type;
      }
      ts2.getTypeAnnotationNode = getTypeAnnotationNode;
      function getEffectiveReturnTypeNode(node) {
        return ts2.isJSDocSignature(node) ? node.type && node.type.typeExpression && node.type.typeExpression.type : node.type || (isInJSFile(node) ? ts2.getJSDocReturnType(node) : void 0);
      }
      ts2.getEffectiveReturnTypeNode = getEffectiveReturnTypeNode;
      function getJSDocTypeParameterDeclarations(node) {
        return ts2.flatMap(ts2.getJSDocTags(node), function(tag) {
          return isNonTypeAliasTemplate(tag) ? tag.typeParameters : void 0;
        });
      }
      ts2.getJSDocTypeParameterDeclarations = getJSDocTypeParameterDeclarations;
      function isNonTypeAliasTemplate(tag) {
        return ts2.isJSDocTemplateTag(tag) && !(tag.parent.kind === 303 && tag.parent.tags.some(isJSDocTypeAlias));
      }
      function getEffectiveSetAccessorTypeAnnotationNode(node) {
        var parameter = getSetAccessorValueParameter(node);
        return parameter && getEffectiveTypeAnnotationNode(parameter);
      }
      ts2.getEffectiveSetAccessorTypeAnnotationNode = getEffectiveSetAccessorTypeAnnotationNode;
      function emitNewLineBeforeLeadingComments(lineMap, writer, node, leadingComments) {
        emitNewLineBeforeLeadingCommentsOfPosition(lineMap, writer, node.pos, leadingComments);
      }
      ts2.emitNewLineBeforeLeadingComments = emitNewLineBeforeLeadingComments;
      function emitNewLineBeforeLeadingCommentsOfPosition(lineMap, writer, pos, leadingComments) {
        if (leadingComments && leadingComments.length && pos !== leadingComments[0].pos && getLineOfLocalPositionFromLineMap(lineMap, pos) !== getLineOfLocalPositionFromLineMap(lineMap, leadingComments[0].pos)) {
          writer.writeLine();
        }
      }
      ts2.emitNewLineBeforeLeadingCommentsOfPosition = emitNewLineBeforeLeadingCommentsOfPosition;
      function emitNewLineBeforeLeadingCommentOfPosition(lineMap, writer, pos, commentPos) {
        if (pos !== commentPos && getLineOfLocalPositionFromLineMap(lineMap, pos) !== getLineOfLocalPositionFromLineMap(lineMap, commentPos)) {
          writer.writeLine();
        }
      }
      ts2.emitNewLineBeforeLeadingCommentOfPosition = emitNewLineBeforeLeadingCommentOfPosition;
      function emitComments(text, lineMap, writer, comments, leadingSeparator, trailingSeparator, newLine, writeComment) {
        if (comments && comments.length > 0) {
          if (leadingSeparator) {
            writer.writeSpace(" ");
          }
          var emitInterveningSeparator = false;
          for (var _i = 0, comments_1 = comments; _i < comments_1.length; _i++) {
            var comment = comments_1[_i];
            if (emitInterveningSeparator) {
              writer.writeSpace(" ");
              emitInterveningSeparator = false;
            }
            writeComment(text, lineMap, writer, comment.pos, comment.end, newLine);
            if (comment.hasTrailingNewLine) {
              writer.writeLine();
            } else {
              emitInterveningSeparator = true;
            }
          }
          if (emitInterveningSeparator && trailingSeparator) {
            writer.writeSpace(" ");
          }
        }
      }
      ts2.emitComments = emitComments;
      function emitDetachedComments(text, lineMap, writer, writeComment, node, newLine, removeComments) {
        var leadingComments;
        var currentDetachedCommentInfo;
        if (removeComments) {
          if (node.pos === 0) {
            leadingComments = ts2.filter(ts2.getLeadingCommentRanges(text, node.pos), isPinnedCommentLocal);
          }
        } else {
          leadingComments = ts2.getLeadingCommentRanges(text, node.pos);
        }
        if (leadingComments) {
          var detachedComments = [];
          var lastComment = void 0;
          for (var _i = 0, leadingComments_1 = leadingComments; _i < leadingComments_1.length; _i++) {
            var comment = leadingComments_1[_i];
            if (lastComment) {
              var lastCommentLine = getLineOfLocalPositionFromLineMap(lineMap, lastComment.end);
              var commentLine = getLineOfLocalPositionFromLineMap(lineMap, comment.pos);
              if (commentLine >= lastCommentLine + 2) {
                break;
              }
            }
            detachedComments.push(comment);
            lastComment = comment;
          }
          if (detachedComments.length) {
            var lastCommentLine = getLineOfLocalPositionFromLineMap(lineMap, ts2.last(detachedComments).end);
            var nodeLine = getLineOfLocalPositionFromLineMap(lineMap, ts2.skipTrivia(text, node.pos));
            if (nodeLine >= lastCommentLine + 2) {
              emitNewLineBeforeLeadingComments(lineMap, writer, node, leadingComments);
              emitComments(text, lineMap, writer, detachedComments, false, true, newLine, writeComment);
              currentDetachedCommentInfo = { nodePos: node.pos, detachedCommentEndPos: ts2.last(detachedComments).end };
            }
          }
        }
        return currentDetachedCommentInfo;
        function isPinnedCommentLocal(comment2) {
          return isPinnedComment(text, comment2.pos);
        }
      }
      ts2.emitDetachedComments = emitDetachedComments;
      function writeCommentRange(text, lineMap, writer, commentPos, commentEnd, newLine) {
        if (text.charCodeAt(commentPos + 1) === 42) {
          var firstCommentLineAndCharacter = ts2.computeLineAndCharacterOfPosition(lineMap, commentPos);
          var lineCount = lineMap.length;
          var firstCommentLineIndent = void 0;
          for (var pos = commentPos, currentLine = firstCommentLineAndCharacter.line; pos < commentEnd; currentLine++) {
            var nextLineStart = currentLine + 1 === lineCount ? text.length + 1 : lineMap[currentLine + 1];
            if (pos !== commentPos) {
              if (firstCommentLineIndent === void 0) {
                firstCommentLineIndent = calculateIndent(text, lineMap[firstCommentLineAndCharacter.line], commentPos);
              }
              var currentWriterIndentSpacing = writer.getIndent() * getIndentSize();
              var spacesToEmit = currentWriterIndentSpacing - firstCommentLineIndent + calculateIndent(text, pos, nextLineStart);
              if (spacesToEmit > 0) {
                var numberOfSingleSpacesToEmit = spacesToEmit % getIndentSize();
                var indentSizeSpaceString = getIndentString((spacesToEmit - numberOfSingleSpacesToEmit) / getIndentSize());
                writer.rawWrite(indentSizeSpaceString);
                while (numberOfSingleSpacesToEmit) {
                  writer.rawWrite(" ");
                  numberOfSingleSpacesToEmit--;
                }
              } else {
                writer.rawWrite("");
              }
            }
            writeTrimmedCurrentLine(text, commentEnd, writer, newLine, pos, nextLineStart);
            pos = nextLineStart;
          }
        } else {
          writer.writeComment(text.substring(commentPos, commentEnd));
        }
      }
      ts2.writeCommentRange = writeCommentRange;
      function writeTrimmedCurrentLine(text, commentEnd, writer, newLine, pos, nextLineStart) {
        var end = Math.min(commentEnd, nextLineStart - 1);
        var currentLineText = text.substring(pos, end).replace(/^\s+|\s+$/g, "");
        if (currentLineText) {
          writer.writeComment(currentLineText);
          if (end !== commentEnd) {
            writer.writeLine();
          }
        } else {
          writer.rawWrite(newLine);
        }
      }
      function calculateIndent(text, pos, end) {
        var currentLineIndent = 0;
        for (; pos < end && ts2.isWhiteSpaceSingleLine(text.charCodeAt(pos)); pos++) {
          if (text.charCodeAt(pos) === 9) {
            currentLineIndent += getIndentSize() - currentLineIndent % getIndentSize();
          } else {
            currentLineIndent++;
          }
        }
        return currentLineIndent;
      }
      function hasModifiers(node) {
        return getModifierFlags(node) !== 0;
      }
      ts2.hasModifiers = hasModifiers;
      function hasModifier(node, flags) {
        return !!getSelectedModifierFlags(node, flags);
      }
      ts2.hasModifier = hasModifier;
      function hasStaticModifier(node) {
        return hasModifier(node, 32);
      }
      ts2.hasStaticModifier = hasStaticModifier;
      function hasReadonlyModifier(node) {
        return hasModifier(node, 64);
      }
      ts2.hasReadonlyModifier = hasReadonlyModifier;
      function getSelectedModifierFlags(node, flags) {
        return getModifierFlags(node) & flags;
      }
      ts2.getSelectedModifierFlags = getSelectedModifierFlags;
      function getModifierFlags(node) {
        if (node.kind >= 0 && node.kind <= 152) {
          return 0;
        }
        if (node.modifierFlagsCache & 536870912) {
          return node.modifierFlagsCache & ~536870912;
        }
        var flags = getModifierFlagsNoCache(node);
        node.modifierFlagsCache = flags | 536870912;
        return flags;
      }
      ts2.getModifierFlags = getModifierFlags;
      function getModifierFlagsNoCache(node) {
        var flags = 0;
        if (node.modifiers) {
          for (var _i = 0, _a = node.modifiers; _i < _a.length; _i++) {
            var modifier = _a[_i];
            flags |= modifierToFlag(modifier.kind);
          }
        }
        if (isInJSFile(node) && !!node.parent) {
          var tags = (ts2.getJSDocPublicTag(node) ? 4 : 0) | (ts2.getJSDocPrivateTag(node) ? 8 : 0) | (ts2.getJSDocProtectedTag(node) ? 16 : 0) | (ts2.getJSDocReadonlyTag(node) ? 64 : 0);
          flags |= tags;
        }
        if (node.flags & 4 || node.kind === 75 && node.isInJSDocNamespace) {
          flags |= 1;
        }
        return flags;
      }
      ts2.getModifierFlagsNoCache = getModifierFlagsNoCache;
      function modifierToFlag(token) {
        switch (token) {
          case 120:
            return 32;
          case 119:
            return 4;
          case 118:
            return 16;
          case 117:
            return 8;
          case 122:
            return 128;
          case 89:
            return 1;
          case 130:
            return 2;
          case 81:
            return 2048;
          case 84:
            return 512;
          case 126:
            return 256;
          case 138:
            return 64;
        }
        return 0;
      }
      ts2.modifierToFlag = modifierToFlag;
      function isLogicalOperator(token) {
        return token === 56 || token === 55 || token === 53;
      }
      ts2.isLogicalOperator = isLogicalOperator;
      function isAssignmentOperator(token) {
        return token >= 62 && token <= 74;
      }
      ts2.isAssignmentOperator = isAssignmentOperator;
      function tryGetClassExtendingExpressionWithTypeArguments(node) {
        var cls = tryGetClassImplementingOrExtendingExpressionWithTypeArguments(node);
        return cls && !cls.isImplements ? cls.class : void 0;
      }
      ts2.tryGetClassExtendingExpressionWithTypeArguments = tryGetClassExtendingExpressionWithTypeArguments;
      function tryGetClassImplementingOrExtendingExpressionWithTypeArguments(node) {
        return ts2.isExpressionWithTypeArguments(node) && ts2.isHeritageClause(node.parent) && ts2.isClassLike(node.parent.parent) ? { class: node.parent.parent, isImplements: node.parent.token === 113 } : void 0;
      }
      ts2.tryGetClassImplementingOrExtendingExpressionWithTypeArguments = tryGetClassImplementingOrExtendingExpressionWithTypeArguments;
      function isAssignmentExpression(node, excludeCompoundAssignment) {
        return ts2.isBinaryExpression(node) && (excludeCompoundAssignment ? node.operatorToken.kind === 62 : isAssignmentOperator(node.operatorToken.kind)) && ts2.isLeftHandSideExpression(node.left);
      }
      ts2.isAssignmentExpression = isAssignmentExpression;
      function isDestructuringAssignment(node) {
        if (isAssignmentExpression(node, true)) {
          var kind = node.left.kind;
          return kind === 193 || kind === 192;
        }
        return false;
      }
      ts2.isDestructuringAssignment = isDestructuringAssignment;
      function isExpressionWithTypeArgumentsInClassExtendsClause(node) {
        return tryGetClassExtendingExpressionWithTypeArguments(node) !== void 0;
      }
      ts2.isExpressionWithTypeArgumentsInClassExtendsClause = isExpressionWithTypeArgumentsInClassExtendsClause;
      function isEntityNameExpression(node) {
        return node.kind === 75 || isPropertyAccessEntityNameExpression(node);
      }
      ts2.isEntityNameExpression = isEntityNameExpression;
      function getFirstIdentifier(node) {
        switch (node.kind) {
          case 75:
            return node;
          case 153:
            do {
              node = node.left;
            } while (node.kind !== 75);
            return node;
          case 194:
            do {
              node = node.expression;
            } while (node.kind !== 75);
            return node;
        }
      }
      ts2.getFirstIdentifier = getFirstIdentifier;
      function isDottedName(node) {
        return node.kind === 75 || node.kind === 104 || node.kind === 102 || node.kind === 194 && isDottedName(node.expression) || node.kind === 200 && isDottedName(node.expression);
      }
      ts2.isDottedName = isDottedName;
      function isPropertyAccessEntityNameExpression(node) {
        return ts2.isPropertyAccessExpression(node) && ts2.isIdentifier(node.name) && isEntityNameExpression(node.expression);
      }
      ts2.isPropertyAccessEntityNameExpression = isPropertyAccessEntityNameExpression;
      function tryGetPropertyAccessOrIdentifierToString(expr) {
        if (ts2.isPropertyAccessExpression(expr)) {
          var baseStr = tryGetPropertyAccessOrIdentifierToString(expr.expression);
          if (baseStr !== void 0) {
            return baseStr + "." + expr.name;
          }
        } else if (ts2.isIdentifier(expr)) {
          return ts2.unescapeLeadingUnderscores(expr.escapedText);
        }
        return void 0;
      }
      ts2.tryGetPropertyAccessOrIdentifierToString = tryGetPropertyAccessOrIdentifierToString;
      function isPrototypeAccess(node) {
        return isBindableStaticAccessExpression(node) && getElementOrPropertyAccessName(node) === "prototype";
      }
      ts2.isPrototypeAccess = isPrototypeAccess;
      function isRightSideOfQualifiedNameOrPropertyAccess(node) {
        return node.parent.kind === 153 && node.parent.right === node || node.parent.kind === 194 && node.parent.name === node;
      }
      ts2.isRightSideOfQualifiedNameOrPropertyAccess = isRightSideOfQualifiedNameOrPropertyAccess;
      function isEmptyObjectLiteral(expression) {
        return expression.kind === 193 && expression.properties.length === 0;
      }
      ts2.isEmptyObjectLiteral = isEmptyObjectLiteral;
      function isEmptyArrayLiteral(expression) {
        return expression.kind === 192 && expression.elements.length === 0;
      }
      ts2.isEmptyArrayLiteral = isEmptyArrayLiteral;
      function getLocalSymbolForExportDefault(symbol) {
        return isExportDefaultSymbol(symbol) ? symbol.declarations[0].localSymbol : void 0;
      }
      ts2.getLocalSymbolForExportDefault = getLocalSymbolForExportDefault;
      function isExportDefaultSymbol(symbol) {
        return symbol && ts2.length(symbol.declarations) > 0 && hasModifier(symbol.declarations[0], 512);
      }
      function tryExtractTSExtension(fileName) {
        return ts2.find(ts2.supportedTSExtensionsForExtractExtension, function(extension) {
          return ts2.fileExtensionIs(fileName, extension);
        });
      }
      ts2.tryExtractTSExtension = tryExtractTSExtension;
      function getExpandedCharCodes(input) {
        var output = [];
        var length = input.length;
        for (var i = 0; i < length; i++) {
          var charCode = input.charCodeAt(i);
          if (charCode < 128) {
            output.push(charCode);
          } else if (charCode < 2048) {
            output.push(charCode >> 6 | 192);
            output.push(charCode & 63 | 128);
          } else if (charCode < 65536) {
            output.push(charCode >> 12 | 224);
            output.push(charCode >> 6 & 63 | 128);
            output.push(charCode & 63 | 128);
          } else if (charCode < 131072) {
            output.push(charCode >> 18 | 240);
            output.push(charCode >> 12 & 63 | 128);
            output.push(charCode >> 6 & 63 | 128);
            output.push(charCode & 63 | 128);
          } else {
            ts2.Debug.assert(false, "Unexpected code point");
          }
        }
        return output;
      }
      var base64Digits = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
      function convertToBase64(input) {
        var result = "";
        var charCodes = getExpandedCharCodes(input);
        var i = 0;
        var length = charCodes.length;
        var byte1, byte2, byte3, byte4;
        while (i < length) {
          byte1 = charCodes[i] >> 2;
          byte2 = (charCodes[i] & 3) << 4 | charCodes[i + 1] >> 4;
          byte3 = (charCodes[i + 1] & 15) << 2 | charCodes[i + 2] >> 6;
          byte4 = charCodes[i + 2] & 63;
          if (i + 1 >= length) {
            byte3 = byte4 = 64;
          } else if (i + 2 >= length) {
            byte4 = 64;
          }
          result += base64Digits.charAt(byte1) + base64Digits.charAt(byte2) + base64Digits.charAt(byte3) + base64Digits.charAt(byte4);
          i += 3;
        }
        return result;
      }
      ts2.convertToBase64 = convertToBase64;
      function getStringFromExpandedCharCodes(codes) {
        var output = "";
        var i = 0;
        var length = codes.length;
        while (i < length) {
          var charCode = codes[i];
          if (charCode < 128) {
            output += String.fromCharCode(charCode);
            i++;
          } else if ((charCode & 192) === 192) {
            var value = charCode & 63;
            i++;
            var nextCode = codes[i];
            while ((nextCode & 192) === 128) {
              value = value << 6 | nextCode & 63;
              i++;
              nextCode = codes[i];
            }
            output += String.fromCharCode(value);
          } else {
            output += String.fromCharCode(charCode);
            i++;
          }
        }
        return output;
      }
      function base64encode(host, input) {
        if (host && host.base64encode) {
          return host.base64encode(input);
        }
        return convertToBase64(input);
      }
      ts2.base64encode = base64encode;
      function base64decode(host, input) {
        if (host && host.base64decode) {
          return host.base64decode(input);
        }
        var length = input.length;
        var expandedCharCodes = [];
        var i = 0;
        while (i < length) {
          if (input.charCodeAt(i) === base64Digits.charCodeAt(64)) {
            break;
          }
          var ch1 = base64Digits.indexOf(input[i]);
          var ch2 = base64Digits.indexOf(input[i + 1]);
          var ch3 = base64Digits.indexOf(input[i + 2]);
          var ch4 = base64Digits.indexOf(input[i + 3]);
          var code1 = (ch1 & 63) << 2 | ch2 >> 4 & 3;
          var code2 = (ch2 & 15) << 4 | ch3 >> 2 & 15;
          var code3 = (ch3 & 3) << 6 | ch4 & 63;
          if (code2 === 0 && ch3 !== 0) {
            expandedCharCodes.push(code1);
          } else if (code3 === 0 && ch4 !== 0) {
            expandedCharCodes.push(code1, code2);
          } else {
            expandedCharCodes.push(code1, code2, code3);
          }
          i += 4;
        }
        return getStringFromExpandedCharCodes(expandedCharCodes);
      }
      ts2.base64decode = base64decode;
      function readJson(path2, host) {
        try {
          var jsonText = host.readFile(path2);
          if (!jsonText)
            return {};
          var result = ts2.parseConfigFileTextToJson(path2, jsonText);
          if (result.error) {
            return {};
          }
          return result.config;
        } catch (e) {
          return {};
        }
      }
      ts2.readJson = readJson;
      function directoryProbablyExists(directoryName, host) {
        return !host.directoryExists || host.directoryExists(directoryName);
      }
      ts2.directoryProbablyExists = directoryProbablyExists;
      var carriageReturnLineFeed = "\r\n";
      var lineFeed = "\n";
      function getNewLineCharacter(options, getNewLine) {
        switch (options.newLine) {
          case 0:
            return carriageReturnLineFeed;
          case 1:
            return lineFeed;
        }
        return getNewLine ? getNewLine() : ts2.sys ? ts2.sys.newLine : carriageReturnLineFeed;
      }
      ts2.getNewLineCharacter = getNewLineCharacter;
      function createRange(pos, end) {
        if (end === void 0) {
          end = pos;
        }
        ts2.Debug.assert(end >= pos || end === -1);
        return { pos, end };
      }
      ts2.createRange = createRange;
      function moveRangeEnd(range, end) {
        return createRange(range.pos, end);
      }
      ts2.moveRangeEnd = moveRangeEnd;
      function moveRangePos(range, pos) {
        return createRange(pos, range.end);
      }
      ts2.moveRangePos = moveRangePos;
      function moveRangePastDecorators(node) {
        return node.decorators && node.decorators.length > 0 ? moveRangePos(node, node.decorators.end) : node;
      }
      ts2.moveRangePastDecorators = moveRangePastDecorators;
      function moveRangePastModifiers(node) {
        return node.modifiers && node.modifiers.length > 0 ? moveRangePos(node, node.modifiers.end) : moveRangePastDecorators(node);
      }
      ts2.moveRangePastModifiers = moveRangePastModifiers;
      function isCollapsedRange(range) {
        return range.pos === range.end;
      }
      ts2.isCollapsedRange = isCollapsedRange;
      function createTokenRange(pos, token) {
        return createRange(pos, pos + ts2.tokenToString(token).length);
      }
      ts2.createTokenRange = createTokenRange;
      function rangeIsOnSingleLine(range, sourceFile) {
        return rangeStartIsOnSameLineAsRangeEnd(range, range, sourceFile);
      }
      ts2.rangeIsOnSingleLine = rangeIsOnSingleLine;
      function rangeStartPositionsAreOnSameLine(range1, range2, sourceFile) {
        return positionsAreOnSameLine(getStartPositionOfRange(range1, sourceFile, false), getStartPositionOfRange(range2, sourceFile, false), sourceFile);
      }
      ts2.rangeStartPositionsAreOnSameLine = rangeStartPositionsAreOnSameLine;
      function rangeEndPositionsAreOnSameLine(range1, range2, sourceFile) {
        return positionsAreOnSameLine(range1.end, range2.end, sourceFile);
      }
      ts2.rangeEndPositionsAreOnSameLine = rangeEndPositionsAreOnSameLine;
      function rangeStartIsOnSameLineAsRangeEnd(range1, range2, sourceFile) {
        return positionsAreOnSameLine(getStartPositionOfRange(range1, sourceFile, false), range2.end, sourceFile);
      }
      ts2.rangeStartIsOnSameLineAsRangeEnd = rangeStartIsOnSameLineAsRangeEnd;
      function rangeEndIsOnSameLineAsRangeStart(range1, range2, sourceFile) {
        return positionsAreOnSameLine(range1.end, getStartPositionOfRange(range2, sourceFile, false), sourceFile);
      }
      ts2.rangeEndIsOnSameLineAsRangeStart = rangeEndIsOnSameLineAsRangeStart;
      function getLinesBetweenRangeEndAndRangeStart(range1, range2, sourceFile, includeSecondRangeComments) {
        var range2Start = getStartPositionOfRange(range2, sourceFile, includeSecondRangeComments);
        return ts2.getLinesBetweenPositions(sourceFile, range1.end, range2Start);
      }
      ts2.getLinesBetweenRangeEndAndRangeStart = getLinesBetweenRangeEndAndRangeStart;
      function getLinesBetweenRangeEndPositions(range1, range2, sourceFile) {
        return ts2.getLinesBetweenPositions(sourceFile, range1.end, range2.end);
      }
      ts2.getLinesBetweenRangeEndPositions = getLinesBetweenRangeEndPositions;
      function isNodeArrayMultiLine(list, sourceFile) {
        return !positionsAreOnSameLine(list.pos, list.end, sourceFile);
      }
      ts2.isNodeArrayMultiLine = isNodeArrayMultiLine;
      function positionsAreOnSameLine(pos1, pos2, sourceFile) {
        return ts2.getLinesBetweenPositions(sourceFile, pos1, pos2) === 0;
      }
      ts2.positionsAreOnSameLine = positionsAreOnSameLine;
      function getStartPositionOfRange(range, sourceFile, includeComments) {
        return positionIsSynthesized(range.pos) ? -1 : ts2.skipTrivia(sourceFile.text, range.pos, false, includeComments);
      }
      ts2.getStartPositionOfRange = getStartPositionOfRange;
      function getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter(pos, stopPos, sourceFile, includeComments) {
        var startPos = ts2.skipTrivia(sourceFile.text, pos, false, includeComments);
        var prevPos = getPreviousNonWhitespacePosition(startPos, stopPos, sourceFile);
        return ts2.getLinesBetweenPositions(sourceFile, prevPos !== null && prevPos !== void 0 ? prevPos : stopPos, startPos);
      }
      ts2.getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter = getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter;
      function getLinesBetweenPositionAndNextNonWhitespaceCharacter(pos, stopPos, sourceFile, includeComments) {
        var nextPos = ts2.skipTrivia(sourceFile.text, pos, false, includeComments);
        return ts2.getLinesBetweenPositions(sourceFile, pos, Math.min(stopPos, nextPos));
      }
      ts2.getLinesBetweenPositionAndNextNonWhitespaceCharacter = getLinesBetweenPositionAndNextNonWhitespaceCharacter;
      function getPreviousNonWhitespacePosition(pos, stopPos, sourceFile) {
        if (stopPos === void 0) {
          stopPos = 0;
        }
        while (pos-- > stopPos) {
          if (!ts2.isWhiteSpaceLike(sourceFile.text.charCodeAt(pos))) {
            return pos;
          }
        }
      }
      function isDeclarationNameOfEnumOrNamespace(node) {
        var parseNode = ts2.getParseTreeNode(node);
        if (parseNode) {
          switch (parseNode.parent.kind) {
            case 248:
            case 249:
              return parseNode === parseNode.parent.name;
          }
        }
        return false;
      }
      ts2.isDeclarationNameOfEnumOrNamespace = isDeclarationNameOfEnumOrNamespace;
      function getInitializedVariables(node) {
        return ts2.filter(node.declarations, isInitializedVariable);
      }
      ts2.getInitializedVariables = getInitializedVariables;
      function isInitializedVariable(node) {
        return node.initializer !== void 0;
      }
      function isWatchSet(options) {
        return options.watch && options.hasOwnProperty("watch");
      }
      ts2.isWatchSet = isWatchSet;
      function closeFileWatcher(watcher) {
        watcher.close();
      }
      ts2.closeFileWatcher = closeFileWatcher;
      function getCheckFlags(symbol) {
        return symbol.flags & 33554432 ? symbol.checkFlags : 0;
      }
      ts2.getCheckFlags = getCheckFlags;
      function getDeclarationModifierFlagsFromSymbol(s) {
        if (s.valueDeclaration) {
          var flags = ts2.getCombinedModifierFlags(s.valueDeclaration);
          return s.parent && s.parent.flags & 32 ? flags : flags & ~28;
        }
        if (getCheckFlags(s) & 6) {
          var checkFlags = s.checkFlags;
          var accessModifier = checkFlags & 1024 ? 8 : checkFlags & 256 ? 4 : 16;
          var staticModifier = checkFlags & 2048 ? 32 : 0;
          return accessModifier | staticModifier;
        }
        if (s.flags & 4194304) {
          return 4 | 32;
        }
        return 0;
      }
      ts2.getDeclarationModifierFlagsFromSymbol = getDeclarationModifierFlagsFromSymbol;
      function skipAlias(symbol, checker) {
        return symbol.flags & 2097152 ? checker.getAliasedSymbol(symbol) : symbol;
      }
      ts2.skipAlias = skipAlias;
      function getCombinedLocalAndExportSymbolFlags(symbol) {
        return symbol.exportSymbol ? symbol.exportSymbol.flags | symbol.flags : symbol.flags;
      }
      ts2.getCombinedLocalAndExportSymbolFlags = getCombinedLocalAndExportSymbolFlags;
      function isWriteOnlyAccess(node) {
        return accessKind(node) === 1;
      }
      ts2.isWriteOnlyAccess = isWriteOnlyAccess;
      function isWriteAccess(node) {
        return accessKind(node) !== 0;
      }
      ts2.isWriteAccess = isWriteAccess;
      var AccessKind;
      (function(AccessKind2) {
        AccessKind2[AccessKind2["Read"] = 0] = "Read";
        AccessKind2[AccessKind2["Write"] = 1] = "Write";
        AccessKind2[AccessKind2["ReadWrite"] = 2] = "ReadWrite";
      })(AccessKind || (AccessKind = {}));
      function accessKind(node) {
        var parent = node.parent;
        if (!parent)
          return 0;
        switch (parent.kind) {
          case 200:
            return accessKind(parent);
          case 208:
          case 207:
            var operator = parent.operator;
            return operator === 45 || operator === 46 ? writeOrReadWrite() : 0;
          case 209:
            var _a = parent, left = _a.left, operatorToken = _a.operatorToken;
            return left === node && isAssignmentOperator(operatorToken.kind) ? operatorToken.kind === 62 ? 1 : writeOrReadWrite() : 0;
          case 194:
            return parent.name !== node ? 0 : accessKind(parent);
          case 281: {
            var parentAccess = accessKind(parent.parent);
            return node === parent.name ? reverseAccessKind(parentAccess) : parentAccess;
          }
          case 282:
            return node === parent.objectAssignmentInitializer ? 0 : accessKind(parent.parent);
          case 192:
            return accessKind(parent);
          default:
            return 0;
        }
        function writeOrReadWrite() {
          return parent.parent && skipParenthesesUp(parent.parent).kind === 226 ? 1 : 2;
        }
      }
      function reverseAccessKind(a) {
        switch (a) {
          case 0:
            return 1;
          case 1:
            return 0;
          case 2:
            return 2;
          default:
            return ts2.Debug.assertNever(a);
        }
      }
      function compareDataObjects(dst, src) {
        if (!dst || !src || Object.keys(dst).length !== Object.keys(src).length) {
          return false;
        }
        for (var e in dst) {
          if (typeof dst[e] === "object") {
            if (!compareDataObjects(dst[e], src[e])) {
              return false;
            }
          } else if (typeof dst[e] !== "function") {
            if (dst[e] !== src[e]) {
              return false;
            }
          }
        }
        return true;
      }
      ts2.compareDataObjects = compareDataObjects;
      function clearMap(map, onDeleteValue) {
        map.forEach(onDeleteValue);
        map.clear();
      }
      ts2.clearMap = clearMap;
      function mutateMapSkippingNewValues(map, newMap, options) {
        var onDeleteValue = options.onDeleteValue, onExistingValue = options.onExistingValue;
        map.forEach(function(existingValue, key) {
          var valueInNewMap = newMap.get(key);
          if (valueInNewMap === void 0) {
            map.delete(key);
            onDeleteValue(existingValue, key);
          } else if (onExistingValue) {
            onExistingValue(existingValue, valueInNewMap, key);
          }
        });
      }
      ts2.mutateMapSkippingNewValues = mutateMapSkippingNewValues;
      function mutateMap(map, newMap, options) {
        mutateMapSkippingNewValues(map, newMap, options);
        var createNewValue = options.createNewValue;
        newMap.forEach(function(valueInNewMap, key) {
          if (!map.has(key)) {
            map.set(key, createNewValue(key, valueInNewMap));
          }
        });
      }
      ts2.mutateMap = mutateMap;
      function isAbstractConstructorType(type) {
        return !!(getObjectFlags(type) & 16) && !!type.symbol && isAbstractConstructorSymbol(type.symbol);
      }
      ts2.isAbstractConstructorType = isAbstractConstructorType;
      function isAbstractConstructorSymbol(symbol) {
        if (symbol.flags & 32) {
          var declaration = getClassLikeDeclarationOfSymbol(symbol);
          return !!declaration && hasModifier(declaration, 128);
        }
        return false;
      }
      ts2.isAbstractConstructorSymbol = isAbstractConstructorSymbol;
      function getClassLikeDeclarationOfSymbol(symbol) {
        return ts2.find(symbol.declarations, ts2.isClassLike);
      }
      ts2.getClassLikeDeclarationOfSymbol = getClassLikeDeclarationOfSymbol;
      function getObjectFlags(type) {
        return type.flags & 3899393 ? type.objectFlags : 0;
      }
      ts2.getObjectFlags = getObjectFlags;
      function typeHasCallOrConstructSignatures(type, checker) {
        return checker.getSignaturesOfType(type, 0).length !== 0 || checker.getSignaturesOfType(type, 1).length !== 0;
      }
      ts2.typeHasCallOrConstructSignatures = typeHasCallOrConstructSignatures;
      function forSomeAncestorDirectory(directory, callback) {
        return !!ts2.forEachAncestorDirectory(directory, function(d) {
          return callback(d) ? true : void 0;
        });
      }
      ts2.forSomeAncestorDirectory = forSomeAncestorDirectory;
      function isUMDExportSymbol(symbol) {
        return !!symbol && !!symbol.declarations && !!symbol.declarations[0] && ts2.isNamespaceExportDeclaration(symbol.declarations[0]);
      }
      ts2.isUMDExportSymbol = isUMDExportSymbol;
      function showModuleSpecifier(_a) {
        var moduleSpecifier = _a.moduleSpecifier;
        return ts2.isStringLiteral(moduleSpecifier) ? moduleSpecifier.text : getTextOfNode(moduleSpecifier);
      }
      ts2.showModuleSpecifier = showModuleSpecifier;
      function getLastChild(node) {
        var lastChild;
        ts2.forEachChild(node, function(child) {
          if (nodeIsPresent(child))
            lastChild = child;
        }, function(children) {
          for (var i = children.length - 1; i >= 0; i--) {
            if (nodeIsPresent(children[i])) {
              lastChild = children[i];
              break;
            }
          }
        });
        return lastChild;
      }
      ts2.getLastChild = getLastChild;
      function addToSeen(seen, key, value) {
        if (value === void 0) {
          value = true;
        }
        key = String(key);
        if (seen.has(key)) {
          return false;
        }
        seen.set(key, value);
        return true;
      }
      ts2.addToSeen = addToSeen;
      function isObjectTypeDeclaration(node) {
        return ts2.isClassLike(node) || ts2.isInterfaceDeclaration(node) || ts2.isTypeLiteralNode(node);
      }
      ts2.isObjectTypeDeclaration = isObjectTypeDeclaration;
      function isTypeNodeKind(kind) {
        return kind >= 168 && kind <= 188 || kind === 125 || kind === 148 || kind === 140 || kind === 151 || kind === 141 || kind === 128 || kind === 143 || kind === 144 || kind === 104 || kind === 110 || kind === 146 || kind === 100 || kind === 137 || kind === 216 || kind === 295 || kind === 296 || kind === 297 || kind === 298 || kind === 299 || kind === 300 || kind === 301;
      }
      ts2.isTypeNodeKind = isTypeNodeKind;
      function isAccessExpression(node) {
        return node.kind === 194 || node.kind === 195;
      }
      ts2.isAccessExpression = isAccessExpression;
      function getNameOfAccessExpression(node) {
        if (node.kind === 194) {
          return node.name;
        }
        ts2.Debug.assert(node.kind === 195);
        return node.argumentExpression;
      }
      ts2.getNameOfAccessExpression = getNameOfAccessExpression;
      function isBundleFileTextLike(section) {
        switch (section.kind) {
          case "text":
          case "internal":
            return true;
          default:
            return false;
        }
      }
      ts2.isBundleFileTextLike = isBundleFileTextLike;
      function isNamedImportsOrExports(node) {
        return node.kind === 257 || node.kind === 261;
      }
      ts2.isNamedImportsOrExports = isNamedImportsOrExports;
      function Symbol2(flags, name) {
        this.flags = flags;
        this.escapedName = name;
        this.declarations = void 0;
        this.valueDeclaration = void 0;
        this.id = void 0;
        this.mergeId = void 0;
        this.parent = void 0;
      }
      function Type(checker, flags) {
        this.flags = flags;
        if (ts2.Debug.isDebugging) {
          this.checker = checker;
        }
      }
      function Signature(checker, flags) {
        this.flags = flags;
        if (ts2.Debug.isDebugging) {
          this.checker = checker;
        }
      }
      function Node(kind, pos, end) {
        this.pos = pos;
        this.end = end;
        this.kind = kind;
        this.id = 0;
        this.flags = 0;
        this.modifierFlagsCache = 0;
        this.transformFlags = 0;
        this.parent = void 0;
        this.original = void 0;
      }
      function Token(kind, pos, end) {
        this.pos = pos;
        this.end = end;
        this.kind = kind;
        this.id = 0;
        this.flags = 0;
        this.transformFlags = 0;
        this.parent = void 0;
      }
      function Identifier(kind, pos, end) {
        this.pos = pos;
        this.end = end;
        this.kind = kind;
        this.id = 0;
        this.flags = 0;
        this.transformFlags = 0;
        this.parent = void 0;
        this.original = void 0;
        this.flowNode = void 0;
      }
      function SourceMapSource(fileName, text, skipTrivia) {
        this.fileName = fileName;
        this.text = text;
        this.skipTrivia = skipTrivia || function(pos) {
          return pos;
        };
      }
      ts2.objectAllocator = {
        getNodeConstructor: function() {
          return Node;
        },
        getTokenConstructor: function() {
          return Token;
        },
        getIdentifierConstructor: function() {
          return Identifier;
        },
        getPrivateIdentifierConstructor: function() {
          return Node;
        },
        getSourceFileConstructor: function() {
          return Node;
        },
        getSymbolConstructor: function() {
          return Symbol2;
        },
        getTypeConstructor: function() {
          return Type;
        },
        getSignatureConstructor: function() {
          return Signature;
        },
        getSourceMapSourceConstructor: function() {
          return SourceMapSource;
        }
      };
      function setObjectAllocator(alloc) {
        ts2.objectAllocator = alloc;
      }
      ts2.setObjectAllocator = setObjectAllocator;
      function formatStringFromArgs(text, args, baseIndex) {
        if (baseIndex === void 0) {
          baseIndex = 0;
        }
        return text.replace(/{(\d+)}/g, function(_match, index) {
          return "" + ts2.Debug.checkDefined(args[+index + baseIndex]);
        });
      }
      ts2.formatStringFromArgs = formatStringFromArgs;
      function setLocalizedDiagnosticMessages(messages) {
        ts2.localizedDiagnosticMessages = messages;
      }
      ts2.setLocalizedDiagnosticMessages = setLocalizedDiagnosticMessages;
      function getLocaleSpecificMessage(message) {
        return ts2.localizedDiagnosticMessages && ts2.localizedDiagnosticMessages[message.key] || message.message;
      }
      ts2.getLocaleSpecificMessage = getLocaleSpecificMessage;
      function createFileDiagnostic(file, start, length, message) {
        ts2.Debug.assertGreaterThanOrEqual(start, 0);
        ts2.Debug.assertGreaterThanOrEqual(length, 0);
        if (file) {
          ts2.Debug.assertLessThanOrEqual(start, file.text.length);
          ts2.Debug.assertLessThanOrEqual(start + length, file.text.length);
        }
        var text = getLocaleSpecificMessage(message);
        if (arguments.length > 4) {
          text = formatStringFromArgs(text, arguments, 4);
        }
        return {
          file,
          start,
          length,
          messageText: text,
          category: message.category,
          code: message.code,
          reportsUnnecessary: message.reportsUnnecessary
        };
      }
      ts2.createFileDiagnostic = createFileDiagnostic;
      function formatMessage(_dummy, message) {
        var text = getLocaleSpecificMessage(message);
        if (arguments.length > 2) {
          text = formatStringFromArgs(text, arguments, 2);
        }
        return text;
      }
      ts2.formatMessage = formatMessage;
      function createCompilerDiagnostic(message) {
        var text = getLocaleSpecificMessage(message);
        if (arguments.length > 1) {
          text = formatStringFromArgs(text, arguments, 1);
        }
        return {
          file: void 0,
          start: void 0,
          length: void 0,
          messageText: text,
          category: message.category,
          code: message.code,
          reportsUnnecessary: message.reportsUnnecessary
        };
      }
      ts2.createCompilerDiagnostic = createCompilerDiagnostic;
      function createCompilerDiagnosticFromMessageChain(chain) {
        return {
          file: void 0,
          start: void 0,
          length: void 0,
          code: chain.code,
          category: chain.category,
          messageText: chain.next ? chain : chain.messageText
        };
      }
      ts2.createCompilerDiagnosticFromMessageChain = createCompilerDiagnosticFromMessageChain;
      function chainDiagnosticMessages(details, message) {
        var text = getLocaleSpecificMessage(message);
        if (arguments.length > 2) {
          text = formatStringFromArgs(text, arguments, 2);
        }
        return {
          messageText: text,
          category: message.category,
          code: message.code,
          next: details === void 0 || Array.isArray(details) ? details : [details]
        };
      }
      ts2.chainDiagnosticMessages = chainDiagnosticMessages;
      function concatenateDiagnosticMessageChains(headChain, tailChain) {
        var lastChain = headChain;
        while (lastChain.next) {
          lastChain = lastChain.next[0];
        }
        lastChain.next = [tailChain];
      }
      ts2.concatenateDiagnosticMessageChains = concatenateDiagnosticMessageChains;
      function getDiagnosticFilePath(diagnostic) {
        return diagnostic.file ? diagnostic.file.path : void 0;
      }
      function compareDiagnostics(d1, d2) {
        return compareDiagnosticsSkipRelatedInformation(d1, d2) || compareRelatedInformation(d1, d2) || 0;
      }
      ts2.compareDiagnostics = compareDiagnostics;
      function compareDiagnosticsSkipRelatedInformation(d1, d2) {
        return ts2.compareStringsCaseSensitive(getDiagnosticFilePath(d1), getDiagnosticFilePath(d2)) || ts2.compareValues(d1.start, d2.start) || ts2.compareValues(d1.length, d2.length) || ts2.compareValues(d1.code, d2.code) || compareMessageText(d1.messageText, d2.messageText) || 0;
      }
      ts2.compareDiagnosticsSkipRelatedInformation = compareDiagnosticsSkipRelatedInformation;
      function compareRelatedInformation(d1, d2) {
        if (!d1.relatedInformation && !d2.relatedInformation) {
          return 0;
        }
        if (d1.relatedInformation && d2.relatedInformation) {
          return ts2.compareValues(d1.relatedInformation.length, d2.relatedInformation.length) || ts2.forEach(d1.relatedInformation, function(d1i, index) {
            var d2i = d2.relatedInformation[index];
            return compareDiagnostics(d1i, d2i);
          }) || 0;
        }
        return d1.relatedInformation ? -1 : 1;
      }
      function compareMessageText(t1, t2) {
        if (typeof t1 === "string" && typeof t2 === "string") {
          return ts2.compareStringsCaseSensitive(t1, t2);
        } else if (typeof t1 === "string") {
          return -1;
        } else if (typeof t2 === "string") {
          return 1;
        }
        var res = ts2.compareStringsCaseSensitive(t1.messageText, t2.messageText);
        if (res) {
          return res;
        }
        if (!t1.next && !t2.next) {
          return 0;
        }
        if (!t1.next) {
          return -1;
        }
        if (!t2.next) {
          return 1;
        }
        var len = Math.min(t1.next.length, t2.next.length);
        for (var i = 0; i < len; i++) {
          res = compareMessageText(t1.next[i], t2.next[i]);
          if (res) {
            return res;
          }
        }
        if (t1.next.length < t2.next.length) {
          return -1;
        } else if (t1.next.length > t2.next.length) {
          return 1;
        }
        return 0;
      }
      function getEmitScriptTarget(compilerOptions) {
        return compilerOptions.target || 0;
      }
      ts2.getEmitScriptTarget = getEmitScriptTarget;
      function getEmitModuleKind(compilerOptions) {
        return typeof compilerOptions.module === "number" ? compilerOptions.module : getEmitScriptTarget(compilerOptions) >= 2 ? ts2.ModuleKind.ES2015 : ts2.ModuleKind.CommonJS;
      }
      ts2.getEmitModuleKind = getEmitModuleKind;
      function getEmitModuleResolutionKind(compilerOptions) {
        var moduleResolution = compilerOptions.moduleResolution;
        if (moduleResolution === void 0) {
          moduleResolution = getEmitModuleKind(compilerOptions) === ts2.ModuleKind.CommonJS ? ts2.ModuleResolutionKind.NodeJs : ts2.ModuleResolutionKind.Classic;
        }
        return moduleResolution;
      }
      ts2.getEmitModuleResolutionKind = getEmitModuleResolutionKind;
      function hasJsonModuleEmitEnabled(options) {
        switch (getEmitModuleKind(options)) {
          case ts2.ModuleKind.CommonJS:
          case ts2.ModuleKind.AMD:
          case ts2.ModuleKind.ES2015:
          case ts2.ModuleKind.ES2020:
          case ts2.ModuleKind.ESNext:
            return true;
          default:
            return false;
        }
      }
      ts2.hasJsonModuleEmitEnabled = hasJsonModuleEmitEnabled;
      function unreachableCodeIsError(options) {
        return options.allowUnreachableCode === false;
      }
      ts2.unreachableCodeIsError = unreachableCodeIsError;
      function unusedLabelIsError(options) {
        return options.allowUnusedLabels === false;
      }
      ts2.unusedLabelIsError = unusedLabelIsError;
      function getAreDeclarationMapsEnabled(options) {
        return !!(getEmitDeclarations(options) && options.declarationMap);
      }
      ts2.getAreDeclarationMapsEnabled = getAreDeclarationMapsEnabled;
      function getAllowSyntheticDefaultImports(compilerOptions) {
        var moduleKind = getEmitModuleKind(compilerOptions);
        return compilerOptions.allowSyntheticDefaultImports !== void 0 ? compilerOptions.allowSyntheticDefaultImports : compilerOptions.esModuleInterop || moduleKind === ts2.ModuleKind.System;
      }
      ts2.getAllowSyntheticDefaultImports = getAllowSyntheticDefaultImports;
      function getEmitDeclarations(compilerOptions) {
        return !!(compilerOptions.declaration || compilerOptions.composite);
      }
      ts2.getEmitDeclarations = getEmitDeclarations;
      function isIncrementalCompilation(options) {
        return !!(options.incremental || options.composite);
      }
      ts2.isIncrementalCompilation = isIncrementalCompilation;
      function getStrictOptionValue(compilerOptions, flag) {
        return compilerOptions[flag] === void 0 ? !!compilerOptions.strict : !!compilerOptions[flag];
      }
      ts2.getStrictOptionValue = getStrictOptionValue;
      function compilerOptionsAffectSemanticDiagnostics(newOptions, oldOptions) {
        return oldOptions !== newOptions && ts2.semanticDiagnosticsOptionDeclarations.some(function(option) {
          return !isJsonEqual(getCompilerOptionValue(oldOptions, option), getCompilerOptionValue(newOptions, option));
        });
      }
      ts2.compilerOptionsAffectSemanticDiagnostics = compilerOptionsAffectSemanticDiagnostics;
      function compilerOptionsAffectEmit(newOptions, oldOptions) {
        return oldOptions !== newOptions && ts2.affectsEmitOptionDeclarations.some(function(option) {
          return !isJsonEqual(getCompilerOptionValue(oldOptions, option), getCompilerOptionValue(newOptions, option));
        });
      }
      ts2.compilerOptionsAffectEmit = compilerOptionsAffectEmit;
      function getCompilerOptionValue(options, option) {
        return option.strictFlag ? getStrictOptionValue(options, option.name) : options[option.name];
      }
      ts2.getCompilerOptionValue = getCompilerOptionValue;
      function hasZeroOrOneAsteriskCharacter(str) {
        var seenAsterisk = false;
        for (var i = 0; i < str.length; i++) {
          if (str.charCodeAt(i) === 42) {
            if (!seenAsterisk) {
              seenAsterisk = true;
            } else {
              return false;
            }
          }
        }
        return true;
      }
      ts2.hasZeroOrOneAsteriskCharacter = hasZeroOrOneAsteriskCharacter;
      function discoverProbableSymlinks(files, getCanonicalFileName, cwd) {
        var result = ts2.createMap();
        var symlinks = ts2.flatten(ts2.mapDefined(files, function(sf) {
          return sf.resolvedModules && ts2.compact(ts2.arrayFrom(ts2.mapIterator(sf.resolvedModules.values(), function(res) {
            return res && res.originalPath && res.resolvedFileName !== res.originalPath ? [res.resolvedFileName, res.originalPath] : void 0;
          })));
        }));
        for (var _i = 0, symlinks_1 = symlinks; _i < symlinks_1.length; _i++) {
          var _a = symlinks_1[_i], resolvedPath = _a[0], originalPath = _a[1];
          var _b = guessDirectorySymlink(resolvedPath, originalPath, cwd, getCanonicalFileName), commonResolved = _b[0], commonOriginal = _b[1];
          result.set(commonOriginal, commonResolved);
        }
        return result;
      }
      ts2.discoverProbableSymlinks = discoverProbableSymlinks;
      function guessDirectorySymlink(a, b, cwd, getCanonicalFileName) {
        var aParts = ts2.getPathComponents(ts2.toPath(a, cwd, getCanonicalFileName));
        var bParts = ts2.getPathComponents(ts2.toPath(b, cwd, getCanonicalFileName));
        while (!isNodeModulesOrScopedPackageDirectory(aParts[aParts.length - 2], getCanonicalFileName) && !isNodeModulesOrScopedPackageDirectory(bParts[bParts.length - 2], getCanonicalFileName) && getCanonicalFileName(aParts[aParts.length - 1]) === getCanonicalFileName(bParts[bParts.length - 1])) {
          aParts.pop();
          bParts.pop();
        }
        return [ts2.getPathFromPathComponents(aParts), ts2.getPathFromPathComponents(bParts)];
      }
      function isNodeModulesOrScopedPackageDirectory(s, getCanonicalFileName) {
        return getCanonicalFileName(s) === "node_modules" || ts2.startsWith(s, "@");
      }
      function stripLeadingDirectorySeparator(s) {
        return ts2.isAnyDirectorySeparator(s.charCodeAt(0)) ? s.slice(1) : void 0;
      }
      function tryRemoveDirectoryPrefix(path2, dirPath, getCanonicalFileName) {
        var withoutPrefix = ts2.tryRemovePrefix(path2, dirPath, getCanonicalFileName);
        return withoutPrefix === void 0 ? void 0 : stripLeadingDirectorySeparator(withoutPrefix);
      }
      ts2.tryRemoveDirectoryPrefix = tryRemoveDirectoryPrefix;
      var reservedCharacterPattern = /[^\w\s\/]/g;
      function regExpEscape(text) {
        return text.replace(reservedCharacterPattern, escapeRegExpCharacter);
      }
      ts2.regExpEscape = regExpEscape;
      function escapeRegExpCharacter(match) {
        return "\\" + match;
      }
      var wildcardCharCodes = [42, 63];
      ts2.commonPackageFolders = ["node_modules", "bower_components", "jspm_packages"];
      var implicitExcludePathRegexPattern = "(?!(" + ts2.commonPackageFolders.join("|") + ")(/|$))";
      var filesMatcher = {
        singleAsteriskRegexFragment: "([^./]|(\\.(?!min\\.js$))?)*",
        doubleAsteriskRegexFragment: "(/" + implicitExcludePathRegexPattern + "[^/.][^/]*)*?",
        replaceWildcardCharacter: function(match) {
          return replaceWildcardCharacter(match, filesMatcher.singleAsteriskRegexFragment);
        }
      };
      var directoriesMatcher = {
        singleAsteriskRegexFragment: "[^/]*",
        doubleAsteriskRegexFragment: "(/" + implicitExcludePathRegexPattern + "[^/.][^/]*)*?",
        replaceWildcardCharacter: function(match) {
          return replaceWildcardCharacter(match, directoriesMatcher.singleAsteriskRegexFragment);
        }
      };
      var excludeMatcher = {
        singleAsteriskRegexFragment: "[^/]*",
        doubleAsteriskRegexFragment: "(/.+?)?",
        replaceWildcardCharacter: function(match) {
          return replaceWildcardCharacter(match, excludeMatcher.singleAsteriskRegexFragment);
        }
      };
      var wildcardMatchers = {
        files: filesMatcher,
        directories: directoriesMatcher,
        exclude: excludeMatcher
      };
      function getRegularExpressionForWildcard(specs, basePath, usage) {
        var patterns = getRegularExpressionsForWildcards(specs, basePath, usage);
        if (!patterns || !patterns.length) {
          return void 0;
        }
        var pattern = patterns.map(function(pattern2) {
          return "(" + pattern2 + ")";
        }).join("|");
        var terminator = usage === "exclude" ? "($|/)" : "$";
        return "^(" + pattern + ")" + terminator;
      }
      ts2.getRegularExpressionForWildcard = getRegularExpressionForWildcard;
      function getRegularExpressionsForWildcards(specs, basePath, usage) {
        if (specs === void 0 || specs.length === 0) {
          return void 0;
        }
        return ts2.flatMap(specs, function(spec) {
          return spec && getSubPatternFromSpec(spec, basePath, usage, wildcardMatchers[usage]);
        });
      }
      ts2.getRegularExpressionsForWildcards = getRegularExpressionsForWildcards;
      function isImplicitGlob(lastPathComponent) {
        return !/[.*?]/.test(lastPathComponent);
      }
      ts2.isImplicitGlob = isImplicitGlob;
      function getSubPatternFromSpec(spec, basePath, usage, _a) {
        var singleAsteriskRegexFragment = _a.singleAsteriskRegexFragment, doubleAsteriskRegexFragment = _a.doubleAsteriskRegexFragment, replaceWildcardCharacter2 = _a.replaceWildcardCharacter;
        var subpattern = "";
        var hasWrittenComponent = false;
        var components = ts2.getNormalizedPathComponents(spec, basePath);
        var lastComponent = ts2.last(components);
        if (usage !== "exclude" && lastComponent === "**") {
          return void 0;
        }
        components[0] = ts2.removeTrailingDirectorySeparator(components[0]);
        if (isImplicitGlob(lastComponent)) {
          components.push("**", "*");
        }
        var optionalCount = 0;
        for (var _i = 0, components_1 = components; _i < components_1.length; _i++) {
          var component = components_1[_i];
          if (component === "**") {
            subpattern += doubleAsteriskRegexFragment;
          } else {
            if (usage === "directories") {
              subpattern += "(";
              optionalCount++;
            }
            if (hasWrittenComponent) {
              subpattern += ts2.directorySeparator;
            }
            if (usage !== "exclude") {
              var componentPattern = "";
              if (component.charCodeAt(0) === 42) {
                componentPattern += "([^./]" + singleAsteriskRegexFragment + ")?";
                component = component.substr(1);
              } else if (component.charCodeAt(0) === 63) {
                componentPattern += "[^./]";
                component = component.substr(1);
              }
              componentPattern += component.replace(reservedCharacterPattern, replaceWildcardCharacter2);
              if (componentPattern !== component) {
                subpattern += implicitExcludePathRegexPattern;
              }
              subpattern += componentPattern;
            } else {
              subpattern += component.replace(reservedCharacterPattern, replaceWildcardCharacter2);
            }
          }
          hasWrittenComponent = true;
        }
        while (optionalCount > 0) {
          subpattern += ")?";
          optionalCount--;
        }
        return subpattern;
      }
      function replaceWildcardCharacter(match, singleAsteriskRegexFragment) {
        return match === "*" ? singleAsteriskRegexFragment : match === "?" ? "[^/]" : "\\" + match;
      }
      function getFileMatcherPatterns(path2, excludes, includes, useCaseSensitiveFileNames, currentDirectory) {
        path2 = ts2.normalizePath(path2);
        currentDirectory = ts2.normalizePath(currentDirectory);
        var absolutePath = ts2.combinePaths(currentDirectory, path2);
        return {
          includeFilePatterns: ts2.map(getRegularExpressionsForWildcards(includes, absolutePath, "files"), function(pattern) {
            return "^" + pattern + "$";
          }),
          includeFilePattern: getRegularExpressionForWildcard(includes, absolutePath, "files"),
          includeDirectoryPattern: getRegularExpressionForWildcard(includes, absolutePath, "directories"),
          excludePattern: getRegularExpressionForWildcard(excludes, absolutePath, "exclude"),
          basePaths: getBasePaths(path2, includes, useCaseSensitiveFileNames)
        };
      }
      ts2.getFileMatcherPatterns = getFileMatcherPatterns;
      function getRegexFromPattern(pattern, useCaseSensitiveFileNames) {
        return new RegExp(pattern, useCaseSensitiveFileNames ? "" : "i");
      }
      ts2.getRegexFromPattern = getRegexFromPattern;
      function matchFiles(path2, extensions, excludes, includes, useCaseSensitiveFileNames, currentDirectory, depth, getFileSystemEntries, realpath) {
        path2 = ts2.normalizePath(path2);
        currentDirectory = ts2.normalizePath(currentDirectory);
        var patterns = getFileMatcherPatterns(path2, excludes, includes, useCaseSensitiveFileNames, currentDirectory);
        var includeFileRegexes = patterns.includeFilePatterns && patterns.includeFilePatterns.map(function(pattern) {
          return getRegexFromPattern(pattern, useCaseSensitiveFileNames);
        });
        var includeDirectoryRegex = patterns.includeDirectoryPattern && getRegexFromPattern(patterns.includeDirectoryPattern, useCaseSensitiveFileNames);
        var excludeRegex = patterns.excludePattern && getRegexFromPattern(patterns.excludePattern, useCaseSensitiveFileNames);
        var results = includeFileRegexes ? includeFileRegexes.map(function() {
          return [];
        }) : [[]];
        var visited = ts2.createMap();
        var toCanonical = ts2.createGetCanonicalFileName(useCaseSensitiveFileNames);
        for (var _i = 0, _a = patterns.basePaths; _i < _a.length; _i++) {
          var basePath = _a[_i];
          visitDirectory(basePath, ts2.combinePaths(currentDirectory, basePath), depth);
        }
        return ts2.flatten(results);
        function visitDirectory(path3, absolutePath, depth2) {
          var canonicalPath = toCanonical(realpath(absolutePath));
          if (visited.has(canonicalPath))
            return;
          visited.set(canonicalPath, true);
          var _a2 = getFileSystemEntries(path3), files = _a2.files, directories = _a2.directories;
          var _loop_1 = function(current2) {
            var name2 = ts2.combinePaths(path3, current2);
            var absoluteName2 = ts2.combinePaths(absolutePath, current2);
            if (extensions && !ts2.fileExtensionIsOneOf(name2, extensions))
              return "continue";
            if (excludeRegex && excludeRegex.test(absoluteName2))
              return "continue";
            if (!includeFileRegexes) {
              results[0].push(name2);
            } else {
              var includeIndex = ts2.findIndex(includeFileRegexes, function(re) {
                return re.test(absoluteName2);
              });
              if (includeIndex !== -1) {
                results[includeIndex].push(name2);
              }
            }
          };
          for (var _i2 = 0, _b = ts2.sort(files, ts2.compareStringsCaseSensitive); _i2 < _b.length; _i2++) {
            var current = _b[_i2];
            _loop_1(current);
          }
          if (depth2 !== void 0) {
            depth2--;
            if (depth2 === 0) {
              return;
            }
          }
          for (var _c = 0, _d = ts2.sort(directories, ts2.compareStringsCaseSensitive); _c < _d.length; _c++) {
            var current = _d[_c];
            var name = ts2.combinePaths(path3, current);
            var absoluteName = ts2.combinePaths(absolutePath, current);
            if ((!includeDirectoryRegex || includeDirectoryRegex.test(absoluteName)) && (!excludeRegex || !excludeRegex.test(absoluteName))) {
              visitDirectory(name, absoluteName, depth2);
            }
          }
        }
      }
      ts2.matchFiles = matchFiles;
      function getBasePaths(path2, includes, useCaseSensitiveFileNames) {
        var basePaths = [path2];
        if (includes) {
          var includeBasePaths = [];
          for (var _i = 0, includes_1 = includes; _i < includes_1.length; _i++) {
            var include = includes_1[_i];
            var absolute = ts2.isRootedDiskPath(include) ? include : ts2.normalizePath(ts2.combinePaths(path2, include));
            includeBasePaths.push(getIncludeBasePath(absolute));
          }
          includeBasePaths.sort(ts2.getStringComparer(!useCaseSensitiveFileNames));
          var _loop_2 = function(includeBasePath2) {
            if (ts2.every(basePaths, function(basePath) {
              return !ts2.containsPath(basePath, includeBasePath2, path2, !useCaseSensitiveFileNames);
            })) {
              basePaths.push(includeBasePath2);
            }
          };
          for (var _a = 0, includeBasePaths_1 = includeBasePaths; _a < includeBasePaths_1.length; _a++) {
            var includeBasePath = includeBasePaths_1[_a];
            _loop_2(includeBasePath);
          }
        }
        return basePaths;
      }
      function getIncludeBasePath(absolute) {
        var wildcardOffset = ts2.indexOfAnyCharCode(absolute, wildcardCharCodes);
        if (wildcardOffset < 0) {
          return !ts2.hasExtension(absolute) ? absolute : ts2.removeTrailingDirectorySeparator(ts2.getDirectoryPath(absolute));
        }
        return absolute.substring(0, absolute.lastIndexOf(ts2.directorySeparator, wildcardOffset));
      }
      function ensureScriptKind(fileName, scriptKind) {
        return scriptKind || getScriptKindFromFileName(fileName) || 3;
      }
      ts2.ensureScriptKind = ensureScriptKind;
      function getScriptKindFromFileName(fileName) {
        var ext = fileName.substr(fileName.lastIndexOf("."));
        switch (ext.toLowerCase()) {
          case ".js":
            return 1;
          case ".jsx":
            return 2;
          case ".ts":
            return 3;
          case ".tsx":
            return 4;
          case ".json":
            return 6;
          default:
            return 0;
        }
      }
      ts2.getScriptKindFromFileName = getScriptKindFromFileName;
      ts2.supportedTSExtensions = [".ts", ".tsx", ".d.ts"];
      ts2.supportedTSExtensionsWithJson = [".ts", ".tsx", ".d.ts", ".json"];
      ts2.supportedTSExtensionsForExtractExtension = [".d.ts", ".ts", ".tsx"];
      ts2.supportedJSExtensions = [".js", ".jsx"];
      ts2.supportedJSAndJsonExtensions = [".js", ".jsx", ".json"];
      var allSupportedExtensions = __spreadArrays(ts2.supportedTSExtensions, ts2.supportedJSExtensions);
      var allSupportedExtensionsWithJson = __spreadArrays(ts2.supportedTSExtensions, ts2.supportedJSExtensions, [".json"]);
      function getSupportedExtensions(options, extraFileExtensions) {
        var needJsExtensions = options && options.allowJs;
        if (!extraFileExtensions || extraFileExtensions.length === 0) {
          return needJsExtensions ? allSupportedExtensions : ts2.supportedTSExtensions;
        }
        var extensions = __spreadArrays(needJsExtensions ? allSupportedExtensions : ts2.supportedTSExtensions, ts2.mapDefined(extraFileExtensions, function(x) {
          return x.scriptKind === 7 || needJsExtensions && isJSLike(x.scriptKind) ? x.extension : void 0;
        }));
        return ts2.deduplicate(extensions, ts2.equateStringsCaseSensitive, ts2.compareStringsCaseSensitive);
      }
      ts2.getSupportedExtensions = getSupportedExtensions;
      function getSuppoertedExtensionsWithJsonIfResolveJsonModule(options, supportedExtensions) {
        if (!options || !options.resolveJsonModule) {
          return supportedExtensions;
        }
        if (supportedExtensions === allSupportedExtensions) {
          return allSupportedExtensionsWithJson;
        }
        if (supportedExtensions === ts2.supportedTSExtensions) {
          return ts2.supportedTSExtensionsWithJson;
        }
        return __spreadArrays(supportedExtensions, [".json"]);
      }
      ts2.getSuppoertedExtensionsWithJsonIfResolveJsonModule = getSuppoertedExtensionsWithJsonIfResolveJsonModule;
      function isJSLike(scriptKind) {
        return scriptKind === 1 || scriptKind === 2;
      }
      function hasJSFileExtension(fileName) {
        return ts2.some(ts2.supportedJSExtensions, function(extension) {
          return ts2.fileExtensionIs(fileName, extension);
        });
      }
      ts2.hasJSFileExtension = hasJSFileExtension;
      function hasTSFileExtension(fileName) {
        return ts2.some(ts2.supportedTSExtensions, function(extension) {
          return ts2.fileExtensionIs(fileName, extension);
        });
      }
      ts2.hasTSFileExtension = hasTSFileExtension;
      function isSupportedSourceFileName(fileName, compilerOptions, extraFileExtensions) {
        if (!fileName) {
          return false;
        }
        var supportedExtensions = getSupportedExtensions(compilerOptions, extraFileExtensions);
        for (var _i = 0, _a = getSuppoertedExtensionsWithJsonIfResolveJsonModule(compilerOptions, supportedExtensions); _i < _a.length; _i++) {
          var extension = _a[_i];
          if (ts2.fileExtensionIs(fileName, extension)) {
            return true;
          }
        }
        return false;
      }
      ts2.isSupportedSourceFileName = isSupportedSourceFileName;
      var ExtensionPriority;
      (function(ExtensionPriority2) {
        ExtensionPriority2[ExtensionPriority2["TypeScriptFiles"] = 0] = "TypeScriptFiles";
        ExtensionPriority2[ExtensionPriority2["DeclarationAndJavaScriptFiles"] = 2] = "DeclarationAndJavaScriptFiles";
        ExtensionPriority2[ExtensionPriority2["Highest"] = 0] = "Highest";
        ExtensionPriority2[ExtensionPriority2["Lowest"] = 2] = "Lowest";
      })(ExtensionPriority = ts2.ExtensionPriority || (ts2.ExtensionPriority = {}));
      function getExtensionPriority(path2, supportedExtensions) {
        for (var i = supportedExtensions.length - 1; i >= 0; i--) {
          if (ts2.fileExtensionIs(path2, supportedExtensions[i])) {
            return adjustExtensionPriority(i, supportedExtensions);
          }
        }
        return 0;
      }
      ts2.getExtensionPriority = getExtensionPriority;
      function adjustExtensionPriority(extensionPriority, supportedExtensions) {
        if (extensionPriority < 2) {
          return 0;
        } else if (extensionPriority < supportedExtensions.length) {
          return 2;
        } else {
          return supportedExtensions.length;
        }
      }
      ts2.adjustExtensionPriority = adjustExtensionPriority;
      function getNextLowestExtensionPriority(extensionPriority, supportedExtensions) {
        if (extensionPriority < 2) {
          return 2;
        } else {
          return supportedExtensions.length;
        }
      }
      ts2.getNextLowestExtensionPriority = getNextLowestExtensionPriority;
      var extensionsToRemove = [".d.ts", ".ts", ".js", ".tsx", ".jsx", ".json"];
      function removeFileExtension(path2) {
        for (var _i = 0, extensionsToRemove_1 = extensionsToRemove; _i < extensionsToRemove_1.length; _i++) {
          var ext = extensionsToRemove_1[_i];
          var extensionless = tryRemoveExtension(path2, ext);
          if (extensionless !== void 0) {
            return extensionless;
          }
        }
        return path2;
      }
      ts2.removeFileExtension = removeFileExtension;
      function tryRemoveExtension(path2, extension) {
        return ts2.fileExtensionIs(path2, extension) ? removeExtension(path2, extension) : void 0;
      }
      ts2.tryRemoveExtension = tryRemoveExtension;
      function removeExtension(path2, extension) {
        return path2.substring(0, path2.length - extension.length);
      }
      ts2.removeExtension = removeExtension;
      function changeExtension(path2, newExtension) {
        return ts2.changeAnyExtension(path2, newExtension, extensionsToRemove, false);
      }
      ts2.changeExtension = changeExtension;
      function tryParsePattern(pattern) {
        ts2.Debug.assert(hasZeroOrOneAsteriskCharacter(pattern));
        var indexOfStar = pattern.indexOf("*");
        return indexOfStar === -1 ? void 0 : {
          prefix: pattern.substr(0, indexOfStar),
          suffix: pattern.substr(indexOfStar + 1)
        };
      }
      ts2.tryParsePattern = tryParsePattern;
      function positionIsSynthesized(pos) {
        return !(pos >= 0);
      }
      ts2.positionIsSynthesized = positionIsSynthesized;
      function extensionIsTS(ext) {
        return ext === ".ts" || ext === ".tsx" || ext === ".d.ts";
      }
      ts2.extensionIsTS = extensionIsTS;
      function resolutionExtensionIsTSOrJson(ext) {
        return extensionIsTS(ext) || ext === ".json";
      }
      ts2.resolutionExtensionIsTSOrJson = resolutionExtensionIsTSOrJson;
      function extensionFromPath(path2) {
        var ext = tryGetExtensionFromPath(path2);
        return ext !== void 0 ? ext : ts2.Debug.fail("File " + path2 + " has unknown extension.");
      }
      ts2.extensionFromPath = extensionFromPath;
      function isAnySupportedFileExtension(path2) {
        return tryGetExtensionFromPath(path2) !== void 0;
      }
      ts2.isAnySupportedFileExtension = isAnySupportedFileExtension;
      function tryGetExtensionFromPath(path2) {
        return ts2.find(extensionsToRemove, function(e) {
          return ts2.fileExtensionIs(path2, e);
        });
      }
      ts2.tryGetExtensionFromPath = tryGetExtensionFromPath;
      function isCheckJsEnabledForFile(sourceFile, compilerOptions) {
        return sourceFile.checkJsDirective ? sourceFile.checkJsDirective.enabled : compilerOptions.checkJs;
      }
      ts2.isCheckJsEnabledForFile = isCheckJsEnabledForFile;
      ts2.emptyFileSystemEntries = {
        files: ts2.emptyArray,
        directories: ts2.emptyArray
      };
      function matchPatternOrExact(patternStrings, candidate) {
        var patterns = [];
        for (var _i = 0, patternStrings_1 = patternStrings; _i < patternStrings_1.length; _i++) {
          var patternString = patternStrings_1[_i];
          if (!hasZeroOrOneAsteriskCharacter(patternString))
            continue;
          var pattern = tryParsePattern(patternString);
          if (pattern) {
            patterns.push(pattern);
          } else if (patternString === candidate) {
            return patternString;
          }
        }
        return ts2.findBestPatternMatch(patterns, function(_) {
          return _;
        }, candidate);
      }
      ts2.matchPatternOrExact = matchPatternOrExact;
      function sliceAfter(arr, value) {
        var index = arr.indexOf(value);
        ts2.Debug.assert(index !== -1);
        return arr.slice(index);
      }
      ts2.sliceAfter = sliceAfter;
      function addRelatedInfo(diagnostic) {
        var _a;
        var relatedInformation = [];
        for (var _i = 1; _i < arguments.length; _i++) {
          relatedInformation[_i - 1] = arguments[_i];
        }
        if (!relatedInformation.length) {
          return diagnostic;
        }
        if (!diagnostic.relatedInformation) {
          diagnostic.relatedInformation = [];
        }
        (_a = diagnostic.relatedInformation).push.apply(_a, relatedInformation);
        return diagnostic;
      }
      ts2.addRelatedInfo = addRelatedInfo;
      function minAndMax(arr, getValue) {
        ts2.Debug.assert(arr.length !== 0);
        var min = getValue(arr[0]);
        var max = min;
        for (var i = 1; i < arr.length; i++) {
          var value = getValue(arr[i]);
          if (value < min) {
            min = value;
          } else if (value > max) {
            max = value;
          }
        }
        return { min, max };
      }
      ts2.minAndMax = minAndMax;
      var NodeSet = function() {
        function NodeSet2() {
          this.map = ts2.createMap();
        }
        NodeSet2.prototype.add = function(node) {
          this.map.set(String(ts2.getNodeId(node)), node);
        };
        NodeSet2.prototype.tryAdd = function(node) {
          if (this.has(node))
            return false;
          this.add(node);
          return true;
        };
        NodeSet2.prototype.has = function(node) {
          return this.map.has(String(ts2.getNodeId(node)));
        };
        NodeSet2.prototype.forEach = function(cb) {
          this.map.forEach(cb);
        };
        NodeSet2.prototype.some = function(pred) {
          return forEachEntry(this.map, pred) || false;
        };
        return NodeSet2;
      }();
      ts2.NodeSet = NodeSet;
      var NodeMap = function() {
        function NodeMap2() {
          this.map = ts2.createMap();
        }
        NodeMap2.prototype.get = function(node) {
          var res = this.map.get(String(ts2.getNodeId(node)));
          return res && res.value;
        };
        NodeMap2.prototype.getOrUpdate = function(node, setValue) {
          var res = this.get(node);
          if (res)
            return res;
          var value = setValue();
          this.set(node, value);
          return value;
        };
        NodeMap2.prototype.set = function(node, value) {
          this.map.set(String(ts2.getNodeId(node)), { node, value });
        };
        NodeMap2.prototype.has = function(node) {
          return this.map.has(String(ts2.getNodeId(node)));
        };
        NodeMap2.prototype.forEach = function(cb) {
          this.map.forEach(function(_a) {
            var node = _a.node, value = _a.value;
            return cb(value, node);
          });
        };
        return NodeMap2;
      }();
      ts2.NodeMap = NodeMap;
      function rangeOfNode(node) {
        return { pos: getTokenPosOfNode(node), end: node.end };
      }
      ts2.rangeOfNode = rangeOfNode;
      function rangeOfTypeParameters(typeParameters) {
        return { pos: typeParameters.pos - 1, end: typeParameters.end + 1 };
      }
      ts2.rangeOfTypeParameters = rangeOfTypeParameters;
      function skipTypeChecking(sourceFile, options, host) {
        return options.skipLibCheck && sourceFile.isDeclarationFile || options.skipDefaultLibCheck && sourceFile.hasNoDefaultLib || host.isSourceOfProjectReferenceRedirect(sourceFile.fileName);
      }
      ts2.skipTypeChecking = skipTypeChecking;
      function isJsonEqual(a, b) {
        return a === b || typeof a === "object" && a !== null && typeof b === "object" && b !== null && ts2.equalOwnProperties(a, b, isJsonEqual);
      }
      ts2.isJsonEqual = isJsonEqual;
      function getOrUpdate(map, key, getDefault) {
        var got = map.get(key);
        if (got === void 0) {
          var value = getDefault();
          map.set(key, value);
          return value;
        } else {
          return got;
        }
      }
      ts2.getOrUpdate = getOrUpdate;
      function parsePseudoBigInt(stringValue) {
        var log2Base;
        switch (stringValue.charCodeAt(1)) {
          case 98:
          case 66:
            log2Base = 1;
            break;
          case 111:
          case 79:
            log2Base = 3;
            break;
          case 120:
          case 88:
            log2Base = 4;
            break;
          default:
            var nIndex = stringValue.length - 1;
            var nonZeroStart = 0;
            while (stringValue.charCodeAt(nonZeroStart) === 48) {
              nonZeroStart++;
            }
            return stringValue.slice(nonZeroStart, nIndex) || "0";
        }
        var startIndex = 2, endIndex = stringValue.length - 1;
        var bitsNeeded = (endIndex - startIndex) * log2Base;
        var segments = new Uint16Array((bitsNeeded >>> 4) + (bitsNeeded & 15 ? 1 : 0));
        for (var i = endIndex - 1, bitOffset = 0; i >= startIndex; i--, bitOffset += log2Base) {
          var segment = bitOffset >>> 4;
          var digitChar = stringValue.charCodeAt(i);
          var digit = digitChar <= 57 ? digitChar - 48 : 10 + digitChar - (digitChar <= 70 ? 65 : 97);
          var shiftedDigit = digit << (bitOffset & 15);
          segments[segment] |= shiftedDigit;
          var residual = shiftedDigit >>> 16;
          if (residual)
            segments[segment + 1] |= residual;
        }
        var base10Value = "";
        var firstNonzeroSegment = segments.length - 1;
        var segmentsRemaining = true;
        while (segmentsRemaining) {
          var mod10 = 0;
          segmentsRemaining = false;
          for (var segment = firstNonzeroSegment; segment >= 0; segment--) {
            var newSegment = mod10 << 16 | segments[segment];
            var segmentValue = newSegment / 10 | 0;
            segments[segment] = segmentValue;
            mod10 = newSegment - segmentValue * 10;
            if (segmentValue && !segmentsRemaining) {
              firstNonzeroSegment = segment;
              segmentsRemaining = true;
            }
          }
          base10Value = mod10 + base10Value;
        }
        return base10Value;
      }
      ts2.parsePseudoBigInt = parsePseudoBigInt;
      function pseudoBigIntToString(_a) {
        var negative = _a.negative, base10Value = _a.base10Value;
        return (negative && base10Value !== "0" ? "-" : "") + base10Value;
      }
      ts2.pseudoBigIntToString = pseudoBigIntToString;
      function isValidTypeOnlyAliasUseSite(useSite) {
        return !!(useSite.flags & 8388608) || isPartOfTypeQuery(useSite) || isIdentifierInNonEmittingHeritageClause(useSite) || isPartOfPossiblyValidTypeOrAbstractComputedPropertyName(useSite) || !isExpressionNode(useSite);
      }
      ts2.isValidTypeOnlyAliasUseSite = isValidTypeOnlyAliasUseSite;
      function typeOnlyDeclarationIsExport(typeOnlyDeclaration) {
        return typeOnlyDeclaration.kind === 263;
      }
      ts2.typeOnlyDeclarationIsExport = typeOnlyDeclarationIsExport;
      function isPartOfPossiblyValidTypeOrAbstractComputedPropertyName(node) {
        while (node.kind === 75 || node.kind === 194) {
          node = node.parent;
        }
        if (node.kind !== 154) {
          return false;
        }
        if (hasModifier(node.parent, 128)) {
          return true;
        }
        var containerKind = node.parent.parent.kind;
        return containerKind === 246 || containerKind === 173;
      }
      function isIdentifierInNonEmittingHeritageClause(node) {
        if (node.kind !== 75)
          return false;
        var heritageClause = findAncestor(node.parent, function(parent) {
          switch (parent.kind) {
            case 279:
              return true;
            case 194:
            case 216:
              return false;
            default:
              return "quit";
          }
        });
        return (heritageClause === null || heritageClause === void 0 ? void 0 : heritageClause.token) === 113 || (heritageClause === null || heritageClause === void 0 ? void 0 : heritageClause.parent.kind) === 246;
      }
      function isIdentifierTypeReference(node) {
        return ts2.isTypeReferenceNode(node) && ts2.isIdentifier(node.typeName);
      }
      ts2.isIdentifierTypeReference = isIdentifierTypeReference;
      function arrayIsHomogeneous(array, comparer) {
        if (comparer === void 0) {
          comparer = ts2.equateValues;
        }
        if (array.length < 2)
          return true;
        var first = array[0];
        for (var i = 1, length_1 = array.length; i < length_1; i++) {
          var target = array[i];
          if (!comparer(first, target))
            return false;
        }
        return true;
      }
      ts2.arrayIsHomogeneous = arrayIsHomogeneous;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var SignatureFlags;
      (function(SignatureFlags2) {
        SignatureFlags2[SignatureFlags2["None"] = 0] = "None";
        SignatureFlags2[SignatureFlags2["Yield"] = 1] = "Yield";
        SignatureFlags2[SignatureFlags2["Await"] = 2] = "Await";
        SignatureFlags2[SignatureFlags2["Type"] = 4] = "Type";
        SignatureFlags2[SignatureFlags2["IgnoreMissingOpenBrace"] = 16] = "IgnoreMissingOpenBrace";
        SignatureFlags2[SignatureFlags2["JSDoc"] = 32] = "JSDoc";
      })(SignatureFlags || (SignatureFlags = {}));
      var NodeConstructor;
      var TokenConstructor;
      var IdentifierConstructor;
      var PrivateIdentifierConstructor;
      var SourceFileConstructor;
      function createNode(kind, pos, end) {
        if (kind === 290) {
          return new (SourceFileConstructor || (SourceFileConstructor = ts2.objectAllocator.getSourceFileConstructor()))(kind, pos, end);
        } else if (kind === 75) {
          return new (IdentifierConstructor || (IdentifierConstructor = ts2.objectAllocator.getIdentifierConstructor()))(kind, pos, end);
        } else if (kind === 76) {
          return new (PrivateIdentifierConstructor || (PrivateIdentifierConstructor = ts2.objectAllocator.getPrivateIdentifierConstructor()))(kind, pos, end);
        } else if (!ts2.isNodeKind(kind)) {
          return new (TokenConstructor || (TokenConstructor = ts2.objectAllocator.getTokenConstructor()))(kind, pos, end);
        } else {
          return new (NodeConstructor || (NodeConstructor = ts2.objectAllocator.getNodeConstructor()))(kind, pos, end);
        }
      }
      ts2.createNode = createNode;
      function visitNode(cbNode, node) {
        return node && cbNode(node);
      }
      function visitNodes(cbNode, cbNodes, nodes) {
        if (nodes) {
          if (cbNodes) {
            return cbNodes(nodes);
          }
          for (var _i = 0, nodes_1 = nodes; _i < nodes_1.length; _i++) {
            var node = nodes_1[_i];
            var result = cbNode(node);
            if (result) {
              return result;
            }
          }
        }
      }
      function isJSDocLikeText(text, start) {
        return text.charCodeAt(start + 1) === 42 && text.charCodeAt(start + 2) === 42 && text.charCodeAt(start + 3) !== 47;
      }
      ts2.isJSDocLikeText = isJSDocLikeText;
      function forEachChild(node, cbNode, cbNodes) {
        if (!node || node.kind <= 152) {
          return;
        }
        switch (node.kind) {
          case 153:
            return visitNode(cbNode, node.left) || visitNode(cbNode, node.right);
          case 155:
            return visitNode(cbNode, node.name) || visitNode(cbNode, node.constraint) || visitNode(cbNode, node.default) || visitNode(cbNode, node.expression);
          case 282:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.exclamationToken) || visitNode(cbNode, node.equalsToken) || visitNode(cbNode, node.objectAssignmentInitializer);
          case 283:
            return visitNode(cbNode, node.expression);
          case 156:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.dotDotDotToken) || visitNode(cbNode, node.name) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.type) || visitNode(cbNode, node.initializer);
          case 159:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.exclamationToken) || visitNode(cbNode, node.type) || visitNode(cbNode, node.initializer);
          case 158:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.type) || visitNode(cbNode, node.initializer);
          case 281:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.initializer);
          case 242:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.exclamationToken) || visitNode(cbNode, node.type) || visitNode(cbNode, node.initializer);
          case 191:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.dotDotDotToken) || visitNode(cbNode, node.propertyName) || visitNode(cbNode, node.name) || visitNode(cbNode, node.initializer);
          case 170:
          case 171:
          case 165:
          case 166:
          case 167:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.parameters) || visitNode(cbNode, node.type);
          case 161:
          case 160:
          case 162:
          case 163:
          case 164:
          case 201:
          case 244:
          case 202:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.asteriskToken) || visitNode(cbNode, node.name) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.exclamationToken) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.parameters) || visitNode(cbNode, node.type) || visitNode(cbNode, node.equalsGreaterThanToken) || visitNode(cbNode, node.body);
          case 169:
            return visitNode(cbNode, node.typeName) || visitNodes(cbNode, cbNodes, node.typeArguments);
          case 168:
            return visitNode(cbNode, node.assertsModifier) || visitNode(cbNode, node.parameterName) || visitNode(cbNode, node.type);
          case 172:
            return visitNode(cbNode, node.exprName);
          case 173:
            return visitNodes(cbNode, cbNodes, node.members);
          case 174:
            return visitNode(cbNode, node.elementType);
          case 175:
            return visitNodes(cbNode, cbNodes, node.elementTypes);
          case 178:
          case 179:
            return visitNodes(cbNode, cbNodes, node.types);
          case 180:
            return visitNode(cbNode, node.checkType) || visitNode(cbNode, node.extendsType) || visitNode(cbNode, node.trueType) || visitNode(cbNode, node.falseType);
          case 181:
            return visitNode(cbNode, node.typeParameter);
          case 188:
            return visitNode(cbNode, node.argument) || visitNode(cbNode, node.qualifier) || visitNodes(cbNode, cbNodes, node.typeArguments);
          case 182:
          case 184:
            return visitNode(cbNode, node.type);
          case 185:
            return visitNode(cbNode, node.objectType) || visitNode(cbNode, node.indexType);
          case 186:
            return visitNode(cbNode, node.readonlyToken) || visitNode(cbNode, node.typeParameter) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.type);
          case 187:
            return visitNode(cbNode, node.literal);
          case 189:
          case 190:
            return visitNodes(cbNode, cbNodes, node.elements);
          case 192:
            return visitNodes(cbNode, cbNodes, node.elements);
          case 193:
            return visitNodes(cbNode, cbNodes, node.properties);
          case 194:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.questionDotToken) || visitNode(cbNode, node.name);
          case 195:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.questionDotToken) || visitNode(cbNode, node.argumentExpression);
          case 196:
          case 197:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.questionDotToken) || visitNodes(cbNode, cbNodes, node.typeArguments) || visitNodes(cbNode, cbNodes, node.arguments);
          case 198:
            return visitNode(cbNode, node.tag) || visitNode(cbNode, node.questionDotToken) || visitNodes(cbNode, cbNodes, node.typeArguments) || visitNode(cbNode, node.template);
          case 199:
            return visitNode(cbNode, node.type) || visitNode(cbNode, node.expression);
          case 200:
            return visitNode(cbNode, node.expression);
          case 203:
            return visitNode(cbNode, node.expression);
          case 204:
            return visitNode(cbNode, node.expression);
          case 205:
            return visitNode(cbNode, node.expression);
          case 207:
            return visitNode(cbNode, node.operand);
          case 212:
            return visitNode(cbNode, node.asteriskToken) || visitNode(cbNode, node.expression);
          case 206:
            return visitNode(cbNode, node.expression);
          case 208:
            return visitNode(cbNode, node.operand);
          case 209:
            return visitNode(cbNode, node.left) || visitNode(cbNode, node.operatorToken) || visitNode(cbNode, node.right);
          case 217:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.type);
          case 218:
            return visitNode(cbNode, node.expression);
          case 219:
            return visitNode(cbNode, node.name);
          case 210:
            return visitNode(cbNode, node.condition) || visitNode(cbNode, node.questionToken) || visitNode(cbNode, node.whenTrue) || visitNode(cbNode, node.colonToken) || visitNode(cbNode, node.whenFalse);
          case 213:
            return visitNode(cbNode, node.expression);
          case 223:
          case 250:
            return visitNodes(cbNode, cbNodes, node.statements);
          case 290:
            return visitNodes(cbNode, cbNodes, node.statements) || visitNode(cbNode, node.endOfFileToken);
          case 225:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.declarationList);
          case 243:
            return visitNodes(cbNode, cbNodes, node.declarations);
          case 226:
            return visitNode(cbNode, node.expression);
          case 227:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.thenStatement) || visitNode(cbNode, node.elseStatement);
          case 228:
            return visitNode(cbNode, node.statement) || visitNode(cbNode, node.expression);
          case 229:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.statement);
          case 230:
            return visitNode(cbNode, node.initializer) || visitNode(cbNode, node.condition) || visitNode(cbNode, node.incrementor) || visitNode(cbNode, node.statement);
          case 231:
            return visitNode(cbNode, node.initializer) || visitNode(cbNode, node.expression) || visitNode(cbNode, node.statement);
          case 232:
            return visitNode(cbNode, node.awaitModifier) || visitNode(cbNode, node.initializer) || visitNode(cbNode, node.expression) || visitNode(cbNode, node.statement);
          case 233:
          case 234:
            return visitNode(cbNode, node.label);
          case 235:
            return visitNode(cbNode, node.expression);
          case 236:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.statement);
          case 237:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.caseBlock);
          case 251:
            return visitNodes(cbNode, cbNodes, node.clauses);
          case 277:
            return visitNode(cbNode, node.expression) || visitNodes(cbNode, cbNodes, node.statements);
          case 278:
            return visitNodes(cbNode, cbNodes, node.statements);
          case 238:
            return visitNode(cbNode, node.label) || visitNode(cbNode, node.statement);
          case 239:
            return visitNode(cbNode, node.expression);
          case 240:
            return visitNode(cbNode, node.tryBlock) || visitNode(cbNode, node.catchClause) || visitNode(cbNode, node.finallyBlock);
          case 280:
            return visitNode(cbNode, node.variableDeclaration) || visitNode(cbNode, node.block);
          case 157:
            return visitNode(cbNode, node.expression);
          case 245:
          case 214:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.heritageClauses) || visitNodes(cbNode, cbNodes, node.members);
          case 246:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.heritageClauses) || visitNodes(cbNode, cbNodes, node.members);
          case 247:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNode(cbNode, node.type);
          case 248:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.members);
          case 284:
            return visitNode(cbNode, node.name) || visitNode(cbNode, node.initializer);
          case 249:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.body);
          case 253:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.name) || visitNode(cbNode, node.moduleReference);
          case 254:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.importClause) || visitNode(cbNode, node.moduleSpecifier);
          case 255:
            return visitNode(cbNode, node.name) || visitNode(cbNode, node.namedBindings);
          case 252:
            return visitNode(cbNode, node.name);
          case 256:
            return visitNode(cbNode, node.name);
          case 262:
            return visitNode(cbNode, node.name);
          case 257:
          case 261:
            return visitNodes(cbNode, cbNodes, node.elements);
          case 260:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.exportClause) || visitNode(cbNode, node.moduleSpecifier);
          case 258:
          case 263:
            return visitNode(cbNode, node.propertyName) || visitNode(cbNode, node.name);
          case 259:
            return visitNodes(cbNode, cbNodes, node.decorators) || visitNodes(cbNode, cbNodes, node.modifiers) || visitNode(cbNode, node.expression);
          case 211:
            return visitNode(cbNode, node.head) || visitNodes(cbNode, cbNodes, node.templateSpans);
          case 221:
            return visitNode(cbNode, node.expression) || visitNode(cbNode, node.literal);
          case 154:
            return visitNode(cbNode, node.expression);
          case 279:
            return visitNodes(cbNode, cbNodes, node.types);
          case 216:
            return visitNode(cbNode, node.expression) || visitNodes(cbNode, cbNodes, node.typeArguments);
          case 265:
            return visitNode(cbNode, node.expression);
          case 264:
            return visitNodes(cbNode, cbNodes, node.decorators);
          case 327:
            return visitNodes(cbNode, cbNodes, node.elements);
          case 266:
            return visitNode(cbNode, node.openingElement) || visitNodes(cbNode, cbNodes, node.children) || visitNode(cbNode, node.closingElement);
          case 270:
            return visitNode(cbNode, node.openingFragment) || visitNodes(cbNode, cbNodes, node.children) || visitNode(cbNode, node.closingFragment);
          case 267:
          case 268:
            return visitNode(cbNode, node.tagName) || visitNodes(cbNode, cbNodes, node.typeArguments) || visitNode(cbNode, node.attributes);
          case 274:
            return visitNodes(cbNode, cbNodes, node.properties);
          case 273:
            return visitNode(cbNode, node.name) || visitNode(cbNode, node.initializer);
          case 275:
            return visitNode(cbNode, node.expression);
          case 276:
            return visitNode(cbNode, node.dotDotDotToken) || visitNode(cbNode, node.expression);
          case 269:
            return visitNode(cbNode, node.tagName);
          case 176:
          case 177:
          case 294:
          case 298:
          case 297:
          case 299:
          case 301:
            return visitNode(cbNode, node.type);
          case 300:
            return visitNodes(cbNode, cbNodes, node.parameters) || visitNode(cbNode, node.type);
          case 303:
            return visitNodes(cbNode, cbNodes, node.tags);
          case 317:
          case 323:
            return visitNode(cbNode, node.tagName) || (node.isNameFirst ? visitNode(cbNode, node.name) || visitNode(cbNode, node.typeExpression) : visitNode(cbNode, node.typeExpression) || visitNode(cbNode, node.name));
          case 309:
            return visitNode(cbNode, node.tagName);
          case 308:
            return visitNode(cbNode, node.tagName) || visitNode(cbNode, node.class);
          case 307:
            return visitNode(cbNode, node.tagName) || visitNode(cbNode, node.class);
          case 321:
            return visitNode(cbNode, node.tagName) || visitNode(cbNode, node.constraint) || visitNodes(cbNode, cbNodes, node.typeParameters);
          case 322:
            return visitNode(cbNode, node.tagName) || (node.typeExpression && node.typeExpression.kind === 294 ? visitNode(cbNode, node.typeExpression) || visitNode(cbNode, node.fullName) : visitNode(cbNode, node.fullName) || visitNode(cbNode, node.typeExpression));
          case 315:
            return visitNode(cbNode, node.tagName) || visitNode(cbNode, node.fullName) || visitNode(cbNode, node.typeExpression);
          case 318:
          case 320:
          case 319:
          case 316:
            return visitNode(cbNode, node.tagName) || visitNode(cbNode, node.typeExpression);
          case 305:
            return ts2.forEach(node.typeParameters, cbNode) || ts2.forEach(node.parameters, cbNode) || visitNode(cbNode, node.type);
          case 304:
            return ts2.forEach(node.jsDocPropertyTags, cbNode);
          case 306:
          case 310:
          case 311:
          case 312:
          case 313:
          case 314:
            return visitNode(cbNode, node.tagName);
          case 326:
            return visitNode(cbNode, node.expression);
        }
      }
      ts2.forEachChild = forEachChild;
      function forEachChildRecursively(rootNode, cbNode, cbNodes) {
        var stack = [rootNode];
        while (stack.length) {
          var parent = stack.pop();
          var res = visitAllPossibleChildren(parent, gatherPossibleChildren(parent));
          if (res) {
            return res;
          }
        }
        return;
        function gatherPossibleChildren(node) {
          var children = [];
          forEachChild(node, addWorkItem, addWorkItem);
          return children;
          function addWorkItem(n) {
            children.unshift(n);
          }
        }
        function visitAllPossibleChildren(parent2, children) {
          for (var _i = 0, children_1 = children; _i < children_1.length; _i++) {
            var child = children_1[_i];
            if (ts2.isArray(child)) {
              if (cbNodes) {
                var res2 = cbNodes(child, parent2);
                if (res2) {
                  if (res2 === "skip")
                    continue;
                  return res2;
                }
              }
              for (var i = child.length - 1; i >= 0; i--) {
                var realChild = child[i];
                var res2 = cbNode(realChild, parent2);
                if (res2) {
                  if (res2 === "skip")
                    continue;
                  return res2;
                }
                stack.push(realChild);
              }
            } else {
              stack.push(child);
              var res2 = cbNode(child, parent2);
              if (res2) {
                if (res2 === "skip")
                  continue;
                return res2;
              }
            }
          }
        }
      }
      ts2.forEachChildRecursively = forEachChildRecursively;
      function createSourceFile(fileName, sourceText, languageVersion, setParentNodes, scriptKind) {
        if (setParentNodes === void 0) {
          setParentNodes = false;
        }
        ts2.performance.mark("beforeParse");
        var result;
        ts2.perfLogger.logStartParseSourceFile(fileName);
        if (languageVersion === 100) {
          result = Parser.parseSourceFile(fileName, sourceText, languageVersion, void 0, setParentNodes, 6);
        } else {
          result = Parser.parseSourceFile(fileName, sourceText, languageVersion, void 0, setParentNodes, scriptKind);
        }
        ts2.perfLogger.logStopParseSourceFile();
        ts2.performance.mark("afterParse");
        ts2.performance.measure("Parse", "beforeParse", "afterParse");
        return result;
      }
      ts2.createSourceFile = createSourceFile;
      function parseIsolatedEntityName(text, languageVersion) {
        return Parser.parseIsolatedEntityName(text, languageVersion);
      }
      ts2.parseIsolatedEntityName = parseIsolatedEntityName;
      function parseJsonText(fileName, sourceText) {
        return Parser.parseJsonText(fileName, sourceText);
      }
      ts2.parseJsonText = parseJsonText;
      function isExternalModule(file) {
        return file.externalModuleIndicator !== void 0;
      }
      ts2.isExternalModule = isExternalModule;
      function updateSourceFile(sourceFile, newText, textChangeRange, aggressiveChecks) {
        if (aggressiveChecks === void 0) {
          aggressiveChecks = false;
        }
        var newSourceFile = IncrementalParser.updateSourceFile(sourceFile, newText, textChangeRange, aggressiveChecks);
        newSourceFile.flags |= sourceFile.flags & 3145728;
        return newSourceFile;
      }
      ts2.updateSourceFile = updateSourceFile;
      function parseIsolatedJSDocComment(content, start, length) {
        var result = Parser.JSDocParser.parseIsolatedJSDocComment(content, start, length);
        if (result && result.jsDoc) {
          Parser.fixupParentReferences(result.jsDoc);
        }
        return result;
      }
      ts2.parseIsolatedJSDocComment = parseIsolatedJSDocComment;
      function parseJSDocTypeExpressionForTests(content, start, length) {
        return Parser.JSDocParser.parseJSDocTypeExpressionForTests(content, start, length);
      }
      ts2.parseJSDocTypeExpressionForTests = parseJSDocTypeExpressionForTests;
      var Parser;
      (function(Parser2) {
        var scanner = ts2.createScanner(99, true);
        var disallowInAndDecoratorContext = 4096 | 16384;
        var NodeConstructor2;
        var TokenConstructor2;
        var IdentifierConstructor2;
        var PrivateIdentifierConstructor2;
        var SourceFileConstructor2;
        var sourceFile;
        var parseDiagnostics;
        var syntaxCursor;
        var currentToken;
        var sourceText;
        var nodeCount;
        var identifiers;
        var privateIdentifiers;
        var identifierCount;
        var parsingContext;
        var notParenthesizedArrow;
        var contextFlags;
        var parseErrorBeforeNextFinishedNode = false;
        function parseSourceFile(fileName, sourceText2, languageVersion, syntaxCursor2, setParentNodes, scriptKind) {
          if (setParentNodes === void 0) {
            setParentNodes = false;
          }
          scriptKind = ts2.ensureScriptKind(fileName, scriptKind);
          if (scriptKind === 6) {
            var result_2 = parseJsonText2(fileName, sourceText2, languageVersion, syntaxCursor2, setParentNodes);
            ts2.convertToObjectWorker(result_2, result_2.parseDiagnostics, false, void 0, void 0);
            result_2.referencedFiles = ts2.emptyArray;
            result_2.typeReferenceDirectives = ts2.emptyArray;
            result_2.libReferenceDirectives = ts2.emptyArray;
            result_2.amdDependencies = ts2.emptyArray;
            result_2.hasNoDefaultLib = false;
            result_2.pragmas = ts2.emptyMap;
            return result_2;
          }
          initializeState(sourceText2, languageVersion, syntaxCursor2, scriptKind);
          var result = parseSourceFileWorker(fileName, languageVersion, setParentNodes, scriptKind);
          clearState();
          return result;
        }
        Parser2.parseSourceFile = parseSourceFile;
        function parseIsolatedEntityName2(content, languageVersion) {
          initializeState(content, languageVersion, void 0, 1);
          nextToken();
          var entityName = parseEntityName(true);
          var isInvalid = token() === 1 && !parseDiagnostics.length;
          clearState();
          return isInvalid ? entityName : void 0;
        }
        Parser2.parseIsolatedEntityName = parseIsolatedEntityName2;
        function parseJsonText2(fileName, sourceText2, languageVersion, syntaxCursor2, setParentNodes) {
          if (languageVersion === void 0) {
            languageVersion = 2;
          }
          initializeState(sourceText2, languageVersion, syntaxCursor2, 6);
          sourceFile = createSourceFile2(fileName, 2, 6, false);
          sourceFile.flags = contextFlags;
          nextToken();
          var pos = getNodePos();
          if (token() === 1) {
            sourceFile.statements = createNodeArray([], pos, pos);
            sourceFile.endOfFileToken = parseTokenNode();
          } else {
            var statement = createNode2(226);
            switch (token()) {
              case 22:
                statement.expression = parseArrayLiteralExpression();
                break;
              case 106:
              case 91:
              case 100:
                statement.expression = parseTokenNode();
                break;
              case 40:
                if (lookAhead(function() {
                  return nextToken() === 8 && nextToken() !== 58;
                })) {
                  statement.expression = parsePrefixUnaryExpression();
                } else {
                  statement.expression = parseObjectLiteralExpression();
                }
                break;
              case 8:
              case 10:
                if (lookAhead(function() {
                  return nextToken() !== 58;
                })) {
                  statement.expression = parseLiteralNode();
                  break;
                }
              default:
                statement.expression = parseObjectLiteralExpression();
                break;
            }
            finishNode(statement);
            sourceFile.statements = createNodeArray([statement], pos);
            sourceFile.endOfFileToken = parseExpectedToken(1, ts2.Diagnostics.Unexpected_token);
          }
          if (setParentNodes) {
            fixupParentReferences(sourceFile);
          }
          sourceFile.nodeCount = nodeCount;
          sourceFile.identifierCount = identifierCount;
          sourceFile.identifiers = identifiers;
          sourceFile.parseDiagnostics = parseDiagnostics;
          var result = sourceFile;
          clearState();
          return result;
        }
        Parser2.parseJsonText = parseJsonText2;
        function getLanguageVariant(scriptKind) {
          return scriptKind === 4 || scriptKind === 2 || scriptKind === 1 || scriptKind === 6 ? 1 : 0;
        }
        function initializeState(_sourceText, languageVersion, _syntaxCursor, scriptKind) {
          NodeConstructor2 = ts2.objectAllocator.getNodeConstructor();
          TokenConstructor2 = ts2.objectAllocator.getTokenConstructor();
          IdentifierConstructor2 = ts2.objectAllocator.getIdentifierConstructor();
          PrivateIdentifierConstructor2 = ts2.objectAllocator.getPrivateIdentifierConstructor();
          SourceFileConstructor2 = ts2.objectAllocator.getSourceFileConstructor();
          sourceText = _sourceText;
          syntaxCursor = _syntaxCursor;
          parseDiagnostics = [];
          parsingContext = 0;
          identifiers = ts2.createMap();
          privateIdentifiers = ts2.createMap();
          identifierCount = 0;
          nodeCount = 0;
          switch (scriptKind) {
            case 1:
            case 2:
              contextFlags = 131072;
              break;
            case 6:
              contextFlags = 131072 | 33554432;
              break;
            default:
              contextFlags = 0;
              break;
          }
          parseErrorBeforeNextFinishedNode = false;
          scanner.setText(sourceText);
          scanner.setOnError(scanError);
          scanner.setScriptTarget(languageVersion);
          scanner.setLanguageVariant(getLanguageVariant(scriptKind));
        }
        function clearState() {
          scanner.clearCommentDirectives();
          scanner.setText("");
          scanner.setOnError(void 0);
          parseDiagnostics = void 0;
          sourceFile = void 0;
          identifiers = void 0;
          syntaxCursor = void 0;
          sourceText = void 0;
          notParenthesizedArrow = void 0;
        }
        function parseSourceFileWorker(fileName, languageVersion, setParentNodes, scriptKind) {
          var isDeclarationFile = isDeclarationFileName(fileName);
          if (isDeclarationFile) {
            contextFlags |= 8388608;
          }
          sourceFile = createSourceFile2(fileName, languageVersion, scriptKind, isDeclarationFile);
          sourceFile.flags = contextFlags;
          nextToken();
          processCommentPragmas(sourceFile, sourceText);
          processPragmasIntoFields(sourceFile, reportPragmaDiagnostic);
          sourceFile.statements = parseList(0, parseStatement);
          ts2.Debug.assert(token() === 1);
          sourceFile.endOfFileToken = addJSDocComment(parseTokenNode());
          setExternalModuleIndicator(sourceFile);
          sourceFile.commentDirectives = scanner.getCommentDirectives();
          sourceFile.nodeCount = nodeCount;
          sourceFile.identifierCount = identifierCount;
          sourceFile.identifiers = identifiers;
          sourceFile.parseDiagnostics = parseDiagnostics;
          if (setParentNodes) {
            fixupParentReferences(sourceFile);
          }
          return sourceFile;
          function reportPragmaDiagnostic(pos, end, diagnostic) {
            parseDiagnostics.push(ts2.createFileDiagnostic(sourceFile, pos, end, diagnostic));
          }
        }
        function addJSDocComment(node) {
          ts2.Debug.assert(!node.jsDoc);
          var jsDoc = ts2.mapDefined(ts2.getJSDocCommentRanges(node, sourceFile.text), function(comment) {
            return JSDocParser.parseJSDocComment(node, comment.pos, comment.end - comment.pos);
          });
          if (jsDoc.length)
            node.jsDoc = jsDoc;
          return node;
        }
        function fixupParentReferences(rootNode) {
          forEachChildRecursively(rootNode, bindParentToChild);
          function bindParentToChild(child, parent) {
            child.parent = parent;
            if (ts2.hasJSDocNodes(child)) {
              for (var _i = 0, _a = child.jsDoc; _i < _a.length; _i++) {
                var doc = _a[_i];
                bindParentToChild(doc, child);
                forEachChildRecursively(doc, bindParentToChild);
              }
            }
          }
        }
        Parser2.fixupParentReferences = fixupParentReferences;
        function createSourceFile2(fileName, languageVersion, scriptKind, isDeclarationFile) {
          var sourceFile2 = new SourceFileConstructor2(290, 0, sourceText.length);
          nodeCount++;
          sourceFile2.text = sourceText;
          sourceFile2.bindDiagnostics = [];
          sourceFile2.bindSuggestionDiagnostics = void 0;
          sourceFile2.languageVersion = languageVersion;
          sourceFile2.fileName = ts2.normalizePath(fileName);
          sourceFile2.languageVariant = getLanguageVariant(scriptKind);
          sourceFile2.isDeclarationFile = isDeclarationFile;
          sourceFile2.scriptKind = scriptKind;
          return sourceFile2;
        }
        function setContextFlag(val, flag) {
          if (val) {
            contextFlags |= flag;
          } else {
            contextFlags &= ~flag;
          }
        }
        function setDisallowInContext(val) {
          setContextFlag(val, 4096);
        }
        function setYieldContext(val) {
          setContextFlag(val, 8192);
        }
        function setDecoratorContext(val) {
          setContextFlag(val, 16384);
        }
        function setAwaitContext(val) {
          setContextFlag(val, 32768);
        }
        function doOutsideOfContext(context, func) {
          var contextFlagsToClear = context & contextFlags;
          if (contextFlagsToClear) {
            setContextFlag(false, contextFlagsToClear);
            var result = func();
            setContextFlag(true, contextFlagsToClear);
            return result;
          }
          return func();
        }
        function doInsideOfContext(context, func) {
          var contextFlagsToSet = context & ~contextFlags;
          if (contextFlagsToSet) {
            setContextFlag(true, contextFlagsToSet);
            var result = func();
            setContextFlag(false, contextFlagsToSet);
            return result;
          }
          return func();
        }
        function allowInAnd(func) {
          return doOutsideOfContext(4096, func);
        }
        function disallowInAnd(func) {
          return doInsideOfContext(4096, func);
        }
        function doInYieldContext(func) {
          return doInsideOfContext(8192, func);
        }
        function doInDecoratorContext(func) {
          return doInsideOfContext(16384, func);
        }
        function doInAwaitContext(func) {
          return doInsideOfContext(32768, func);
        }
        function doOutsideOfAwaitContext(func) {
          return doOutsideOfContext(32768, func);
        }
        function doInYieldAndAwaitContext(func) {
          return doInsideOfContext(8192 | 32768, func);
        }
        function doOutsideOfYieldAndAwaitContext(func) {
          return doOutsideOfContext(8192 | 32768, func);
        }
        function inContext(flags) {
          return (contextFlags & flags) !== 0;
        }
        function inYieldContext() {
          return inContext(8192);
        }
        function inDisallowInContext() {
          return inContext(4096);
        }
        function inDecoratorContext() {
          return inContext(16384);
        }
        function inAwaitContext() {
          return inContext(32768);
        }
        function parseErrorAtCurrentToken(message, arg0) {
          parseErrorAt(scanner.getTokenPos(), scanner.getTextPos(), message, arg0);
        }
        function parseErrorAtPosition(start, length, message, arg0) {
          var lastError = ts2.lastOrUndefined(parseDiagnostics);
          if (!lastError || start !== lastError.start) {
            parseDiagnostics.push(ts2.createFileDiagnostic(sourceFile, start, length, message, arg0));
          }
          parseErrorBeforeNextFinishedNode = true;
        }
        function parseErrorAt(start, end, message, arg0) {
          parseErrorAtPosition(start, end - start, message, arg0);
        }
        function parseErrorAtRange(range, message, arg0) {
          parseErrorAt(range.pos, range.end, message, arg0);
        }
        function scanError(message, length) {
          parseErrorAtPosition(scanner.getTextPos(), length, message);
        }
        function getNodePos() {
          return scanner.getStartPos();
        }
        function token() {
          return currentToken;
        }
        function nextTokenWithoutCheck() {
          return currentToken = scanner.scan();
        }
        function nextToken() {
          if (ts2.isKeyword(currentToken) && (scanner.hasUnicodeEscape() || scanner.hasExtendedUnicodeEscape())) {
            parseErrorAt(scanner.getTokenPos(), scanner.getTextPos(), ts2.Diagnostics.Keywords_cannot_contain_escape_characters);
          }
          return nextTokenWithoutCheck();
        }
        function nextTokenJSDoc() {
          return currentToken = scanner.scanJsDocToken();
        }
        function reScanGreaterToken() {
          return currentToken = scanner.reScanGreaterToken();
        }
        function reScanSlashToken() {
          return currentToken = scanner.reScanSlashToken();
        }
        function reScanTemplateToken(isTaggedTemplate) {
          return currentToken = scanner.reScanTemplateToken(isTaggedTemplate);
        }
        function reScanTemplateHeadOrNoSubstitutionTemplate() {
          return currentToken = scanner.reScanTemplateHeadOrNoSubstitutionTemplate();
        }
        function reScanLessThanToken() {
          return currentToken = scanner.reScanLessThanToken();
        }
        function scanJsxIdentifier() {
          return currentToken = scanner.scanJsxIdentifier();
        }
        function scanJsxText() {
          return currentToken = scanner.scanJsxToken();
        }
        function scanJsxAttributeValue() {
          return currentToken = scanner.scanJsxAttributeValue();
        }
        function speculationHelper(callback, isLookAhead) {
          var saveToken = currentToken;
          var saveParseDiagnosticsLength = parseDiagnostics.length;
          var saveParseErrorBeforeNextFinishedNode = parseErrorBeforeNextFinishedNode;
          var saveContextFlags = contextFlags;
          var result = isLookAhead ? scanner.lookAhead(callback) : scanner.tryScan(callback);
          ts2.Debug.assert(saveContextFlags === contextFlags);
          if (!result || isLookAhead) {
            currentToken = saveToken;
            parseDiagnostics.length = saveParseDiagnosticsLength;
            parseErrorBeforeNextFinishedNode = saveParseErrorBeforeNextFinishedNode;
          }
          return result;
        }
        function lookAhead(callback) {
          return speculationHelper(callback, true);
        }
        function tryParse(callback) {
          return speculationHelper(callback, false);
        }
        function isIdentifier() {
          if (token() === 75) {
            return true;
          }
          if (token() === 121 && inYieldContext()) {
            return false;
          }
          if (token() === 127 && inAwaitContext()) {
            return false;
          }
          return token() > 112;
        }
        function parseExpected(kind, diagnosticMessage, shouldAdvance) {
          if (shouldAdvance === void 0) {
            shouldAdvance = true;
          }
          if (token() === kind) {
            if (shouldAdvance) {
              nextToken();
            }
            return true;
          }
          if (diagnosticMessage) {
            parseErrorAtCurrentToken(diagnosticMessage);
          } else {
            parseErrorAtCurrentToken(ts2.Diagnostics._0_expected, ts2.tokenToString(kind));
          }
          return false;
        }
        function parseExpectedJSDoc(kind) {
          if (token() === kind) {
            nextTokenJSDoc();
            return true;
          }
          parseErrorAtCurrentToken(ts2.Diagnostics._0_expected, ts2.tokenToString(kind));
          return false;
        }
        function parseOptional(t) {
          if (token() === t) {
            nextToken();
            return true;
          }
          return false;
        }
        function parseOptionalToken(t) {
          if (token() === t) {
            return parseTokenNode();
          }
          return void 0;
        }
        function parseOptionalTokenJSDoc(t) {
          if (token() === t) {
            return parseTokenNodeJSDoc();
          }
          return void 0;
        }
        function parseExpectedToken(t, diagnosticMessage, arg0) {
          return parseOptionalToken(t) || createMissingNode(t, false, diagnosticMessage || ts2.Diagnostics._0_expected, arg0 || ts2.tokenToString(t));
        }
        function parseExpectedTokenJSDoc(t) {
          return parseOptionalTokenJSDoc(t) || createMissingNode(t, false, ts2.Diagnostics._0_expected, ts2.tokenToString(t));
        }
        function parseTokenNode() {
          var node = createNode2(token());
          nextToken();
          return finishNode(node);
        }
        function parseTokenNodeJSDoc() {
          var node = createNode2(token());
          nextTokenJSDoc();
          return finishNode(node);
        }
        function canParseSemicolon() {
          if (token() === 26) {
            return true;
          }
          return token() === 19 || token() === 1 || scanner.hasPrecedingLineBreak();
        }
        function parseSemicolon() {
          if (canParseSemicolon()) {
            if (token() === 26) {
              nextToken();
            }
            return true;
          } else {
            return parseExpected(26);
          }
        }
        function createNode2(kind, pos) {
          nodeCount++;
          var p = pos >= 0 ? pos : scanner.getStartPos();
          return ts2.isNodeKind(kind) || kind === 0 ? new NodeConstructor2(kind, p, p) : kind === 75 ? new IdentifierConstructor2(kind, p, p) : kind === 76 ? new PrivateIdentifierConstructor2(kind, p, p) : new TokenConstructor2(kind, p, p);
        }
        function createNodeWithJSDoc(kind, pos) {
          var node = createNode2(kind, pos);
          if (scanner.getTokenFlags() & 2 && (kind !== 226 || token() !== 20)) {
            addJSDocComment(node);
          }
          return node;
        }
        function createNodeArray(elements, pos, end) {
          var length = elements.length;
          var array = length >= 1 && length <= 4 ? elements.slice() : elements;
          array.pos = pos;
          array.end = end === void 0 ? scanner.getStartPos() : end;
          return array;
        }
        function finishNode(node, end) {
          node.end = end === void 0 ? scanner.getStartPos() : end;
          if (contextFlags) {
            node.flags |= contextFlags;
          }
          if (parseErrorBeforeNextFinishedNode) {
            parseErrorBeforeNextFinishedNode = false;
            node.flags |= 65536;
          }
          return node;
        }
        function createMissingNode(kind, reportAtCurrentPosition, diagnosticMessage, arg0) {
          if (reportAtCurrentPosition) {
            parseErrorAtPosition(scanner.getStartPos(), 0, diagnosticMessage, arg0);
          } else if (diagnosticMessage) {
            parseErrorAtCurrentToken(diagnosticMessage, arg0);
          }
          var result = createNode2(kind);
          if (kind === 75) {
            result.escapedText = "";
          } else if (ts2.isLiteralKind(kind) || ts2.isTemplateLiteralKind(kind)) {
            result.text = "";
          }
          return finishNode(result);
        }
        function internIdentifier(text) {
          var identifier = identifiers.get(text);
          if (identifier === void 0) {
            identifiers.set(text, identifier = text);
          }
          return identifier;
        }
        function createIdentifier(isIdentifier2, diagnosticMessage, privateIdentifierDiagnosticMessage) {
          identifierCount++;
          if (isIdentifier2) {
            var node = createNode2(75);
            if (token() !== 75) {
              node.originalKeywordKind = token();
            }
            node.escapedText = ts2.escapeLeadingUnderscores(internIdentifier(scanner.getTokenValue()));
            nextTokenWithoutCheck();
            return finishNode(node);
          }
          if (token() === 76) {
            parseErrorAtCurrentToken(privateIdentifierDiagnosticMessage || ts2.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
            return createIdentifier(true);
          }
          var reportAtCurrentPosition = token() === 1;
          var isReservedWord = scanner.isReservedWord();
          var msgArg = scanner.getTokenText();
          var defaultMessage = isReservedWord ? ts2.Diagnostics.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here : ts2.Diagnostics.Identifier_expected;
          return createMissingNode(75, reportAtCurrentPosition, diagnosticMessage || defaultMessage, msgArg);
        }
        function parseIdentifier(diagnosticMessage, privateIdentifierDiagnosticMessage) {
          return createIdentifier(isIdentifier(), diagnosticMessage, privateIdentifierDiagnosticMessage);
        }
        function parseIdentifierName(diagnosticMessage) {
          return createIdentifier(ts2.tokenIsIdentifierOrKeyword(token()), diagnosticMessage);
        }
        function isLiteralPropertyName() {
          return ts2.tokenIsIdentifierOrKeyword(token()) || token() === 10 || token() === 8;
        }
        function parsePropertyNameWorker(allowComputedPropertyNames) {
          if (token() === 10 || token() === 8) {
            var node = parseLiteralNode();
            node.text = internIdentifier(node.text);
            return node;
          }
          if (allowComputedPropertyNames && token() === 22) {
            return parseComputedPropertyName();
          }
          if (token() === 76) {
            return parsePrivateIdentifier();
          }
          return parseIdentifierName();
        }
        function parsePropertyName() {
          return parsePropertyNameWorker(true);
        }
        function parseComputedPropertyName() {
          var node = createNode2(154);
          parseExpected(22);
          node.expression = allowInAnd(parseExpression);
          parseExpected(23);
          return finishNode(node);
        }
        function internPrivateIdentifier(text) {
          var privateIdentifier = privateIdentifiers.get(text);
          if (privateIdentifier === void 0) {
            privateIdentifiers.set(text, privateIdentifier = text);
          }
          return privateIdentifier;
        }
        function parsePrivateIdentifier() {
          var node = createNode2(76);
          node.escapedText = ts2.escapeLeadingUnderscores(internPrivateIdentifier(scanner.getTokenText()));
          nextToken();
          return finishNode(node);
        }
        function parseContextualModifier(t) {
          return token() === t && tryParse(nextTokenCanFollowModifier);
        }
        function nextTokenIsOnSameLineAndCanFollowModifier() {
          nextToken();
          if (scanner.hasPrecedingLineBreak()) {
            return false;
          }
          return canFollowModifier();
        }
        function nextTokenCanFollowModifier() {
          switch (token()) {
            case 81:
              return nextToken() === 88;
            case 89:
              nextToken();
              if (token() === 84) {
                return lookAhead(nextTokenCanFollowDefaultKeyword);
              }
              if (token() === 145) {
                return lookAhead(nextTokenCanFollowExportModifier);
              }
              return canFollowExportModifier();
            case 84:
              return nextTokenCanFollowDefaultKeyword();
            case 120:
            case 131:
            case 142:
              nextToken();
              return canFollowModifier();
            default:
              return nextTokenIsOnSameLineAndCanFollowModifier();
          }
        }
        function canFollowExportModifier() {
          return token() !== 41 && token() !== 123 && token() !== 18 && canFollowModifier();
        }
        function nextTokenCanFollowExportModifier() {
          nextToken();
          return canFollowExportModifier();
        }
        function parseAnyContextualModifier() {
          return ts2.isModifierKind(token()) && tryParse(nextTokenCanFollowModifier);
        }
        function canFollowModifier() {
          return token() === 22 || token() === 18 || token() === 41 || token() === 25 || isLiteralPropertyName();
        }
        function nextTokenCanFollowDefaultKeyword() {
          nextToken();
          return token() === 80 || token() === 94 || token() === 114 || token() === 122 && lookAhead(nextTokenIsClassKeywordOnSameLine) || token() === 126 && lookAhead(nextTokenIsFunctionKeywordOnSameLine);
        }
        function isListElement(parsingContext2, inErrorRecovery) {
          var node = currentNode(parsingContext2);
          if (node) {
            return true;
          }
          switch (parsingContext2) {
            case 0:
            case 1:
            case 3:
              return !(token() === 26 && inErrorRecovery) && isStartOfStatement();
            case 2:
              return token() === 78 || token() === 84;
            case 4:
              return lookAhead(isTypeMemberStart);
            case 5:
              return lookAhead(isClassMemberStart) || token() === 26 && !inErrorRecovery;
            case 6:
              return token() === 22 || isLiteralPropertyName();
            case 12:
              switch (token()) {
                case 22:
                case 41:
                case 25:
                case 24:
                  return true;
                default:
                  return isLiteralPropertyName();
              }
            case 18:
              return isLiteralPropertyName();
            case 9:
              return token() === 22 || token() === 25 || isLiteralPropertyName();
            case 7:
              if (token() === 18) {
                return lookAhead(isValidHeritageClauseObjectLiteral);
              }
              if (!inErrorRecovery) {
                return isStartOfLeftHandSideExpression() && !isHeritageClauseExtendsOrImplementsKeyword();
              } else {
                return isIdentifier() && !isHeritageClauseExtendsOrImplementsKeyword();
              }
            case 8:
              return isIdentifierOrPrivateIdentifierOrPattern();
            case 10:
              return token() === 27 || token() === 25 || isIdentifierOrPrivateIdentifierOrPattern();
            case 19:
              return isIdentifier();
            case 15:
              switch (token()) {
                case 27:
                case 24:
                  return true;
              }
            case 11:
              return token() === 25 || isStartOfExpression();
            case 16:
              return isStartOfParameter(false);
            case 17:
              return isStartOfParameter(true);
            case 20:
            case 21:
              return token() === 27 || isStartOfType();
            case 22:
              return isHeritageClause();
            case 23:
              return ts2.tokenIsIdentifierOrKeyword(token());
            case 13:
              return ts2.tokenIsIdentifierOrKeyword(token()) || token() === 18;
            case 14:
              return true;
          }
          return ts2.Debug.fail("Non-exhaustive case in 'isListElement'.");
        }
        function isValidHeritageClauseObjectLiteral() {
          ts2.Debug.assert(token() === 18);
          if (nextToken() === 19) {
            var next = nextToken();
            return next === 27 || next === 18 || next === 90 || next === 113;
          }
          return true;
        }
        function nextTokenIsIdentifier() {
          nextToken();
          return isIdentifier();
        }
        function nextTokenIsIdentifierOrKeyword() {
          nextToken();
          return ts2.tokenIsIdentifierOrKeyword(token());
        }
        function nextTokenIsIdentifierOrKeywordOrGreaterThan() {
          nextToken();
          return ts2.tokenIsIdentifierOrKeywordOrGreaterThan(token());
        }
        function isHeritageClauseExtendsOrImplementsKeyword() {
          if (token() === 113 || token() === 90) {
            return lookAhead(nextTokenIsStartOfExpression);
          }
          return false;
        }
        function nextTokenIsStartOfExpression() {
          nextToken();
          return isStartOfExpression();
        }
        function nextTokenIsStartOfType() {
          nextToken();
          return isStartOfType();
        }
        function isListTerminator(kind) {
          if (token() === 1) {
            return true;
          }
          switch (kind) {
            case 1:
            case 2:
            case 4:
            case 5:
            case 6:
            case 12:
            case 9:
            case 23:
              return token() === 19;
            case 3:
              return token() === 19 || token() === 78 || token() === 84;
            case 7:
              return token() === 18 || token() === 90 || token() === 113;
            case 8:
              return isVariableDeclaratorListTerminator();
            case 19:
              return token() === 31 || token() === 20 || token() === 18 || token() === 90 || token() === 113;
            case 11:
              return token() === 21 || token() === 26;
            case 15:
            case 21:
            case 10:
              return token() === 23;
            case 17:
            case 16:
            case 18:
              return token() === 21 || token() === 23;
            case 20:
              return token() !== 27;
            case 22:
              return token() === 18 || token() === 19;
            case 13:
              return token() === 31 || token() === 43;
            case 14:
              return token() === 29 && lookAhead(nextTokenIsSlash);
            default:
              return false;
          }
        }
        function isVariableDeclaratorListTerminator() {
          if (canParseSemicolon()) {
            return true;
          }
          if (isInOrOfKeyword(token())) {
            return true;
          }
          if (token() === 38) {
            return true;
          }
          return false;
        }
        function isInSomeParsingContext() {
          for (var kind = 0; kind < 24; kind++) {
            if (parsingContext & 1 << kind) {
              if (isListElement(kind, true) || isListTerminator(kind)) {
                return true;
              }
            }
          }
          return false;
        }
        function parseList(kind, parseElement) {
          var saveParsingContext = parsingContext;
          parsingContext |= 1 << kind;
          var list = [];
          var listPos = getNodePos();
          while (!isListTerminator(kind)) {
            if (isListElement(kind, false)) {
              var element = parseListElement(kind, parseElement);
              list.push(element);
              continue;
            }
            if (abortParsingListOrMoveToNextToken(kind)) {
              break;
            }
          }
          parsingContext = saveParsingContext;
          return createNodeArray(list, listPos);
        }
        function parseListElement(parsingContext2, parseElement) {
          var node = currentNode(parsingContext2);
          if (node) {
            return consumeNode(node);
          }
          return parseElement();
        }
        function currentNode(parsingContext2) {
          if (!syntaxCursor || !isReusableParsingContext(parsingContext2) || parseErrorBeforeNextFinishedNode) {
            return void 0;
          }
          var node = syntaxCursor.currentNode(scanner.getStartPos());
          if (ts2.nodeIsMissing(node) || node.intersectsChange || ts2.containsParseError(node)) {
            return void 0;
          }
          var nodeContextFlags = node.flags & 25358336;
          if (nodeContextFlags !== contextFlags) {
            return void 0;
          }
          if (!canReuseNode(node, parsingContext2)) {
            return void 0;
          }
          if (node.jsDocCache) {
            node.jsDocCache = void 0;
          }
          return node;
        }
        function consumeNode(node) {
          scanner.setTextPos(node.end);
          nextToken();
          return node;
        }
        function isReusableParsingContext(parsingContext2) {
          switch (parsingContext2) {
            case 5:
            case 2:
            case 0:
            case 1:
            case 3:
            case 6:
            case 4:
            case 8:
            case 17:
            case 16:
              return true;
          }
          return false;
        }
        function canReuseNode(node, parsingContext2) {
          switch (parsingContext2) {
            case 5:
              return isReusableClassMember(node);
            case 2:
              return isReusableSwitchClause(node);
            case 0:
            case 1:
            case 3:
              return isReusableStatement(node);
            case 6:
              return isReusableEnumMember(node);
            case 4:
              return isReusableTypeMember(node);
            case 8:
              return isReusableVariableDeclaration(node);
            case 17:
            case 16:
              return isReusableParameter(node);
          }
          return false;
        }
        function isReusableClassMember(node) {
          if (node) {
            switch (node.kind) {
              case 162:
              case 167:
              case 163:
              case 164:
              case 159:
              case 222:
                return true;
              case 161:
                var methodDeclaration = node;
                var nameIsConstructor = methodDeclaration.name.kind === 75 && methodDeclaration.name.originalKeywordKind === 129;
                return !nameIsConstructor;
            }
          }
          return false;
        }
        function isReusableSwitchClause(node) {
          if (node) {
            switch (node.kind) {
              case 277:
              case 278:
                return true;
            }
          }
          return false;
        }
        function isReusableStatement(node) {
          if (node) {
            switch (node.kind) {
              case 244:
              case 225:
              case 223:
              case 227:
              case 226:
              case 239:
              case 235:
              case 237:
              case 234:
              case 233:
              case 231:
              case 232:
              case 230:
              case 229:
              case 236:
              case 224:
              case 240:
              case 238:
              case 228:
              case 241:
              case 254:
              case 253:
              case 260:
              case 259:
              case 249:
              case 245:
              case 246:
              case 248:
              case 247:
                return true;
            }
          }
          return false;
        }
        function isReusableEnumMember(node) {
          return node.kind === 284;
        }
        function isReusableTypeMember(node) {
          if (node) {
            switch (node.kind) {
              case 166:
              case 160:
              case 167:
              case 158:
              case 165:
                return true;
            }
          }
          return false;
        }
        function isReusableVariableDeclaration(node) {
          if (node.kind !== 242) {
            return false;
          }
          var variableDeclarator = node;
          return variableDeclarator.initializer === void 0;
        }
        function isReusableParameter(node) {
          if (node.kind !== 156) {
            return false;
          }
          var parameter = node;
          return parameter.initializer === void 0;
        }
        function abortParsingListOrMoveToNextToken(kind) {
          parseErrorAtCurrentToken(parsingContextErrors(kind));
          if (isInSomeParsingContext()) {
            return true;
          }
          nextToken();
          return false;
        }
        function parsingContextErrors(context) {
          switch (context) {
            case 0:
              return ts2.Diagnostics.Declaration_or_statement_expected;
            case 1:
              return ts2.Diagnostics.Declaration_or_statement_expected;
            case 2:
              return ts2.Diagnostics.case_or_default_expected;
            case 3:
              return ts2.Diagnostics.Statement_expected;
            case 18:
            case 4:
              return ts2.Diagnostics.Property_or_signature_expected;
            case 5:
              return ts2.Diagnostics.Unexpected_token_A_constructor_method_accessor_or_property_was_expected;
            case 6:
              return ts2.Diagnostics.Enum_member_expected;
            case 7:
              return ts2.Diagnostics.Expression_expected;
            case 8:
              return ts2.Diagnostics.Variable_declaration_expected;
            case 9:
              return ts2.Diagnostics.Property_destructuring_pattern_expected;
            case 10:
              return ts2.Diagnostics.Array_element_destructuring_pattern_expected;
            case 11:
              return ts2.Diagnostics.Argument_expression_expected;
            case 12:
              return ts2.Diagnostics.Property_assignment_expected;
            case 15:
              return ts2.Diagnostics.Expression_or_comma_expected;
            case 17:
              return ts2.Diagnostics.Parameter_declaration_expected;
            case 16:
              return ts2.Diagnostics.Parameter_declaration_expected;
            case 19:
              return ts2.Diagnostics.Type_parameter_declaration_expected;
            case 20:
              return ts2.Diagnostics.Type_argument_expected;
            case 21:
              return ts2.Diagnostics.Type_expected;
            case 22:
              return ts2.Diagnostics.Unexpected_token_expected;
            case 23:
              return ts2.Diagnostics.Identifier_expected;
            case 13:
              return ts2.Diagnostics.Identifier_expected;
            case 14:
              return ts2.Diagnostics.Identifier_expected;
            default:
              return void 0;
          }
        }
        function parseDelimitedList(kind, parseElement, considerSemicolonAsDelimiter) {
          var saveParsingContext = parsingContext;
          parsingContext |= 1 << kind;
          var list = [];
          var listPos = getNodePos();
          var commaStart = -1;
          while (true) {
            if (isListElement(kind, false)) {
              var startPos = scanner.getStartPos();
              list.push(parseListElement(kind, parseElement));
              commaStart = scanner.getTokenPos();
              if (parseOptional(27)) {
                continue;
              }
              commaStart = -1;
              if (isListTerminator(kind)) {
                break;
              }
              parseExpected(27, getExpectedCommaDiagnostic(kind));
              if (considerSemicolonAsDelimiter && token() === 26 && !scanner.hasPrecedingLineBreak()) {
                nextToken();
              }
              if (startPos === scanner.getStartPos()) {
                nextToken();
              }
              continue;
            }
            if (isListTerminator(kind)) {
              break;
            }
            if (abortParsingListOrMoveToNextToken(kind)) {
              break;
            }
          }
          parsingContext = saveParsingContext;
          var result = createNodeArray(list, listPos);
          if (commaStart >= 0) {
            result.hasTrailingComma = true;
          }
          return result;
        }
        function getExpectedCommaDiagnostic(kind) {
          return kind === 6 ? ts2.Diagnostics.An_enum_member_name_must_be_followed_by_a_or : void 0;
        }
        function createMissingList() {
          var list = createNodeArray([], getNodePos());
          list.isMissingList = true;
          return list;
        }
        function isMissingList(arr) {
          return !!arr.isMissingList;
        }
        function parseBracketedList(kind, parseElement, open, close) {
          if (parseExpected(open)) {
            var result = parseDelimitedList(kind, parseElement);
            parseExpected(close);
            return result;
          }
          return createMissingList();
        }
        function parseEntityName(allowReservedWords, diagnosticMessage) {
          var entity = allowReservedWords ? parseIdentifierName(diagnosticMessage) : parseIdentifier(diagnosticMessage);
          var dotPos = scanner.getStartPos();
          while (parseOptional(24)) {
            if (token() === 29) {
              entity.jsdocDotPos = dotPos;
              break;
            }
            dotPos = scanner.getStartPos();
            entity = createQualifiedName(entity, parseRightSideOfDot(allowReservedWords, false));
          }
          return entity;
        }
        function createQualifiedName(entity, name) {
          var node = createNode2(153, entity.pos);
          node.left = entity;
          node.right = name;
          return finishNode(node);
        }
        function parseRightSideOfDot(allowIdentifierNames, allowPrivateIdentifiers) {
          if (scanner.hasPrecedingLineBreak() && ts2.tokenIsIdentifierOrKeyword(token())) {
            var matchesPattern = lookAhead(nextTokenIsIdentifierOrKeywordOnSameLine);
            if (matchesPattern) {
              return createMissingNode(75, true, ts2.Diagnostics.Identifier_expected);
            }
          }
          if (token() === 76) {
            var node = parsePrivateIdentifier();
            return allowPrivateIdentifiers ? node : createMissingNode(75, true, ts2.Diagnostics.Identifier_expected);
          }
          return allowIdentifierNames ? parseIdentifierName() : parseIdentifier();
        }
        function parseTemplateExpression(isTaggedTemplate) {
          var template = createNode2(211);
          template.head = parseTemplateHead(isTaggedTemplate);
          ts2.Debug.assert(template.head.kind === 15, "Template head has wrong token kind");
          var list = [];
          var listPos = getNodePos();
          do {
            list.push(parseTemplateSpan(isTaggedTemplate));
          } while (ts2.last(list).literal.kind === 16);
          template.templateSpans = createNodeArray(list, listPos);
          return finishNode(template);
        }
        function parseTemplateSpan(isTaggedTemplate) {
          var span = createNode2(221);
          span.expression = allowInAnd(parseExpression);
          var literal;
          if (token() === 19) {
            reScanTemplateToken(isTaggedTemplate);
            literal = parseTemplateMiddleOrTemplateTail();
          } else {
            literal = parseExpectedToken(17, ts2.Diagnostics._0_expected, ts2.tokenToString(19));
          }
          span.literal = literal;
          return finishNode(span);
        }
        function parseLiteralNode() {
          return parseLiteralLikeNode(token());
        }
        function parseTemplateHead(isTaggedTemplate) {
          if (isTaggedTemplate) {
            reScanTemplateHeadOrNoSubstitutionTemplate();
          }
          var fragment = parseLiteralLikeNode(token());
          ts2.Debug.assert(fragment.kind === 15, "Template head has wrong token kind");
          return fragment;
        }
        function parseTemplateMiddleOrTemplateTail() {
          var fragment = parseLiteralLikeNode(token());
          ts2.Debug.assert(fragment.kind === 16 || fragment.kind === 17, "Template fragment has wrong token kind");
          return fragment;
        }
        function parseLiteralLikeNode(kind) {
          var node = createNode2(kind);
          node.text = scanner.getTokenValue();
          switch (kind) {
            case 14:
            case 15:
            case 16:
            case 17:
              var isLast = kind === 14 || kind === 17;
              var tokenText = scanner.getTokenText();
              node.rawText = tokenText.substring(1, tokenText.length - (scanner.isUnterminated() ? 0 : isLast ? 1 : 2));
              break;
          }
          if (scanner.hasExtendedUnicodeEscape()) {
            node.hasExtendedUnicodeEscape = true;
          }
          if (scanner.isUnterminated()) {
            node.isUnterminated = true;
          }
          if (node.kind === 8) {
            node.numericLiteralFlags = scanner.getTokenFlags() & 1008;
          }
          if (ts2.isTemplateLiteralKind(node.kind)) {
            node.templateFlags = scanner.getTokenFlags() & 2048;
          }
          nextToken();
          finishNode(node);
          return node;
        }
        function parseTypeReference() {
          var node = createNode2(169);
          node.typeName = parseEntityName(true, ts2.Diagnostics.Type_expected);
          if (!scanner.hasPrecedingLineBreak() && reScanLessThanToken() === 29) {
            node.typeArguments = parseBracketedList(20, parseType, 29, 31);
          }
          return finishNode(node);
        }
        function typeHasArrowFunctionBlockingParseError(node) {
          switch (node.kind) {
            case 169:
              return ts2.nodeIsMissing(node.typeName);
            case 170:
            case 171: {
              var _a = node, parameters = _a.parameters, type = _a.type;
              return isMissingList(parameters) || typeHasArrowFunctionBlockingParseError(type);
            }
            case 182:
              return typeHasArrowFunctionBlockingParseError(node.type);
            default:
              return false;
          }
        }
        function parseThisTypePredicate(lhs) {
          nextToken();
          var node = createNode2(168, lhs.pos);
          node.parameterName = lhs;
          node.type = parseType();
          return finishNode(node);
        }
        function parseThisTypeNode() {
          var node = createNode2(183);
          nextToken();
          return finishNode(node);
        }
        function parseJSDocAllType(postFixEquals) {
          var result = createNode2(295);
          if (postFixEquals) {
            return createPostfixType(299, result);
          } else {
            nextToken();
          }
          return finishNode(result);
        }
        function parseJSDocNonNullableType() {
          var result = createNode2(298);
          nextToken();
          result.type = parseNonArrayType();
          return finishNode(result);
        }
        function parseJSDocUnknownOrNullableType() {
          var pos = scanner.getStartPos();
          nextToken();
          if (token() === 27 || token() === 19 || token() === 21 || token() === 31 || token() === 62 || token() === 51) {
            var result = createNode2(296, pos);
            return finishNode(result);
          } else {
            var result = createNode2(297, pos);
            result.type = parseType();
            return finishNode(result);
          }
        }
        function parseJSDocFunctionType() {
          if (lookAhead(nextTokenIsOpenParen)) {
            var result = createNodeWithJSDoc(300);
            nextToken();
            fillSignature(58, 4 | 32, result);
            return finishNode(result);
          }
          var node = createNode2(169);
          node.typeName = parseIdentifierName();
          return finishNode(node);
        }
        function parseJSDocParameter() {
          var parameter = createNode2(156);
          if (token() === 104 || token() === 99) {
            parameter.name = parseIdentifierName();
            parseExpected(58);
          }
          parameter.type = parseJSDocType();
          return finishNode(parameter);
        }
        function parseJSDocType() {
          scanner.setInJSDocType(true);
          var moduleSpecifier = parseOptionalToken(135);
          if (moduleSpecifier) {
            var moduleTag = createNode2(302, moduleSpecifier.pos);
            terminate:
              while (true) {
                switch (token()) {
                  case 19:
                  case 1:
                  case 27:
                  case 5:
                    break terminate;
                  default:
                    nextTokenJSDoc();
                }
              }
            scanner.setInJSDocType(false);
            return finishNode(moduleTag);
          }
          var dotdotdot = parseOptionalToken(25);
          var type = parseTypeOrTypePredicate();
          scanner.setInJSDocType(false);
          if (dotdotdot) {
            var variadic = createNode2(301, dotdotdot.pos);
            variadic.type = type;
            type = finishNode(variadic);
          }
          if (token() === 62) {
            return createPostfixType(299, type);
          }
          return type;
        }
        function parseTypeQuery() {
          var node = createNode2(172);
          parseExpected(108);
          node.exprName = parseEntityName(true);
          return finishNode(node);
        }
        function parseTypeParameter() {
          var node = createNode2(155);
          node.name = parseIdentifier();
          if (parseOptional(90)) {
            if (isStartOfType() || !isStartOfExpression()) {
              node.constraint = parseType();
            } else {
              node.expression = parseUnaryExpressionOrHigher();
            }
          }
          if (parseOptional(62)) {
            node.default = parseType();
          }
          return finishNode(node);
        }
        function parseTypeParameters() {
          if (token() === 29) {
            return parseBracketedList(19, parseTypeParameter, 29, 31);
          }
        }
        function parseParameterType() {
          if (parseOptional(58)) {
            return parseType();
          }
          return void 0;
        }
        function isStartOfParameter(isJSDocParameter) {
          return token() === 25 || isIdentifierOrPrivateIdentifierOrPattern() || ts2.isModifierKind(token()) || token() === 59 || isStartOfType(!isJSDocParameter);
        }
        function parseParameter() {
          var node = createNodeWithJSDoc(156);
          if (token() === 104) {
            node.name = createIdentifier(true);
            node.type = parseParameterType();
            return finishNode(node);
          }
          node.decorators = parseDecorators();
          node.modifiers = parseModifiers();
          node.dotDotDotToken = parseOptionalToken(25);
          node.name = parseIdentifierOrPattern(ts2.Diagnostics.Private_identifiers_cannot_be_used_as_parameters);
          if (ts2.getFullWidth(node.name) === 0 && !node.modifiers && ts2.isModifierKind(token())) {
            nextToken();
          }
          node.questionToken = parseOptionalToken(57);
          node.type = parseParameterType();
          node.initializer = parseInitializer();
          return finishNode(node);
        }
        function fillSignature(returnToken, flags, signature) {
          if (!(flags & 32)) {
            signature.typeParameters = parseTypeParameters();
          }
          var parametersParsedSuccessfully = parseParameterList(signature, flags);
          if (shouldParseReturnType(returnToken, !!(flags & 4))) {
            signature.type = parseTypeOrTypePredicate();
            if (typeHasArrowFunctionBlockingParseError(signature.type))
              return false;
          }
          return parametersParsedSuccessfully;
        }
        function shouldParseReturnType(returnToken, isType) {
          if (returnToken === 38) {
            parseExpected(returnToken);
            return true;
          } else if (parseOptional(58)) {
            return true;
          } else if (isType && token() === 38) {
            parseErrorAtCurrentToken(ts2.Diagnostics._0_expected, ts2.tokenToString(58));
            nextToken();
            return true;
          }
          return false;
        }
        function parseParameterList(signature, flags) {
          if (!parseExpected(20)) {
            signature.parameters = createMissingList();
            return false;
          }
          var savedYieldContext = inYieldContext();
          var savedAwaitContext = inAwaitContext();
          setYieldContext(!!(flags & 1));
          setAwaitContext(!!(flags & 2));
          signature.parameters = flags & 32 ? parseDelimitedList(17, parseJSDocParameter) : parseDelimitedList(16, parseParameter);
          setYieldContext(savedYieldContext);
          setAwaitContext(savedAwaitContext);
          return parseExpected(21);
        }
        function parseTypeMemberSemicolon() {
          if (parseOptional(27)) {
            return;
          }
          parseSemicolon();
        }
        function parseSignatureMember(kind) {
          var node = createNodeWithJSDoc(kind);
          if (kind === 166) {
            parseExpected(99);
          }
          fillSignature(58, 4, node);
          parseTypeMemberSemicolon();
          return finishNode(node);
        }
        function isIndexSignature() {
          return token() === 22 && lookAhead(isUnambiguouslyIndexSignature);
        }
        function isUnambiguouslyIndexSignature() {
          nextToken();
          if (token() === 25 || token() === 23) {
            return true;
          }
          if (ts2.isModifierKind(token())) {
            nextToken();
            if (isIdentifier()) {
              return true;
            }
          } else if (!isIdentifier()) {
            return false;
          } else {
            nextToken();
          }
          if (token() === 58 || token() === 27) {
            return true;
          }
          if (token() !== 57) {
            return false;
          }
          nextToken();
          return token() === 58 || token() === 27 || token() === 23;
        }
        function parseIndexSignatureDeclaration(node) {
          node.kind = 167;
          node.parameters = parseBracketedList(16, parseParameter, 22, 23);
          node.type = parseTypeAnnotation();
          parseTypeMemberSemicolon();
          return finishNode(node);
        }
        function parsePropertyOrMethodSignature(node) {
          node.name = parsePropertyName();
          node.questionToken = parseOptionalToken(57);
          if (token() === 20 || token() === 29) {
            node.kind = 160;
            fillSignature(58, 4, node);
          } else {
            node.kind = 158;
            node.type = parseTypeAnnotation();
            if (token() === 62) {
              node.initializer = parseInitializer();
            }
          }
          parseTypeMemberSemicolon();
          return finishNode(node);
        }
        function isTypeMemberStart() {
          if (token() === 20 || token() === 29) {
            return true;
          }
          var idToken = false;
          while (ts2.isModifierKind(token())) {
            idToken = true;
            nextToken();
          }
          if (token() === 22) {
            return true;
          }
          if (isLiteralPropertyName()) {
            idToken = true;
            nextToken();
          }
          if (idToken) {
            return token() === 20 || token() === 29 || token() === 57 || token() === 58 || token() === 27 || canParseSemicolon();
          }
          return false;
        }
        function parseTypeMember() {
          if (token() === 20 || token() === 29) {
            return parseSignatureMember(165);
          }
          if (token() === 99 && lookAhead(nextTokenIsOpenParenOrLessThan)) {
            return parseSignatureMember(166);
          }
          var node = createNodeWithJSDoc(0);
          node.modifiers = parseModifiers();
          if (isIndexSignature()) {
            return parseIndexSignatureDeclaration(node);
          }
          return parsePropertyOrMethodSignature(node);
        }
        function nextTokenIsOpenParenOrLessThan() {
          nextToken();
          return token() === 20 || token() === 29;
        }
        function nextTokenIsDot() {
          return nextToken() === 24;
        }
        function nextTokenIsOpenParenOrLessThanOrDot() {
          switch (nextToken()) {
            case 20:
            case 29:
            case 24:
              return true;
          }
          return false;
        }
        function parseTypeLiteral() {
          var node = createNode2(173);
          node.members = parseObjectTypeMembers();
          return finishNode(node);
        }
        function parseObjectTypeMembers() {
          var members;
          if (parseExpected(18)) {
            members = parseList(4, parseTypeMember);
            parseExpected(19);
          } else {
            members = createMissingList();
          }
          return members;
        }
        function isStartOfMappedType() {
          nextToken();
          if (token() === 39 || token() === 40) {
            return nextToken() === 138;
          }
          if (token() === 138) {
            nextToken();
          }
          return token() === 22 && nextTokenIsIdentifier() && nextToken() === 97;
        }
        function parseMappedTypeParameter() {
          var node = createNode2(155);
          node.name = parseIdentifier();
          parseExpected(97);
          node.constraint = parseType();
          return finishNode(node);
        }
        function parseMappedType() {
          var node = createNode2(186);
          parseExpected(18);
          if (token() === 138 || token() === 39 || token() === 40) {
            node.readonlyToken = parseTokenNode();
            if (node.readonlyToken.kind !== 138) {
              parseExpectedToken(138);
            }
          }
          parseExpected(22);
          node.typeParameter = parseMappedTypeParameter();
          parseExpected(23);
          if (token() === 57 || token() === 39 || token() === 40) {
            node.questionToken = parseTokenNode();
            if (node.questionToken.kind !== 57) {
              parseExpectedToken(57);
            }
          }
          node.type = parseTypeAnnotation();
          parseSemicolon();
          parseExpected(19);
          return finishNode(node);
        }
        function parseTupleElementType() {
          var pos = getNodePos();
          if (parseOptional(25)) {
            var node = createNode2(177, pos);
            node.type = parseType();
            return finishNode(node);
          }
          var type = parseType();
          if (!(contextFlags & 4194304) && type.kind === 297 && type.pos === type.type.pos) {
            type.kind = 176;
          }
          return type;
        }
        function parseTupleType() {
          var node = createNode2(175);
          node.elementTypes = parseBracketedList(21, parseTupleElementType, 22, 23);
          return finishNode(node);
        }
        function parseParenthesizedType() {
          var node = createNode2(182);
          parseExpected(20);
          node.type = parseType();
          parseExpected(21);
          return finishNode(node);
        }
        function parseFunctionOrConstructorType() {
          var pos = getNodePos();
          var kind = parseOptional(99) ? 171 : 170;
          var node = createNodeWithJSDoc(kind, pos);
          fillSignature(38, 4, node);
          return finishNode(node);
        }
        function parseKeywordAndNoDot() {
          var node = parseTokenNode();
          return token() === 24 ? void 0 : node;
        }
        function parseLiteralTypeNode(negative) {
          var node = createNode2(187);
          var unaryMinusExpression;
          if (negative) {
            unaryMinusExpression = createNode2(207);
            unaryMinusExpression.operator = 40;
            nextToken();
          }
          var expression = token() === 106 || token() === 91 ? parseTokenNode() : parseLiteralLikeNode(token());
          if (negative) {
            unaryMinusExpression.operand = expression;
            finishNode(unaryMinusExpression);
            expression = unaryMinusExpression;
          }
          node.literal = expression;
          return finishNode(node);
        }
        function isStartOfTypeOfImportType() {
          nextToken();
          return token() === 96;
        }
        function parseImportType() {
          sourceFile.flags |= 1048576;
          var node = createNode2(188);
          if (parseOptional(108)) {
            node.isTypeOf = true;
          }
          parseExpected(96);
          parseExpected(20);
          node.argument = parseType();
          parseExpected(21);
          if (parseOptional(24)) {
            node.qualifier = parseEntityName(true, ts2.Diagnostics.Type_expected);
          }
          if (!scanner.hasPrecedingLineBreak() && reScanLessThanToken() === 29) {
            node.typeArguments = parseBracketedList(20, parseType, 29, 31);
          }
          return finishNode(node);
        }
        function nextTokenIsNumericOrBigIntLiteral() {
          nextToken();
          return token() === 8 || token() === 9;
        }
        function parseNonArrayType() {
          switch (token()) {
            case 125:
            case 148:
            case 143:
            case 140:
            case 151:
            case 144:
            case 128:
            case 146:
            case 137:
            case 141:
              return tryParse(parseKeywordAndNoDot) || parseTypeReference();
            case 41:
              return parseJSDocAllType(false);
            case 65:
              return parseJSDocAllType(true);
            case 60:
              scanner.reScanQuestionToken();
            case 57:
              return parseJSDocUnknownOrNullableType();
            case 94:
              return parseJSDocFunctionType();
            case 53:
              return parseJSDocNonNullableType();
            case 14:
            case 10:
            case 8:
            case 9:
            case 106:
            case 91:
              return parseLiteralTypeNode();
            case 40:
              return lookAhead(nextTokenIsNumericOrBigIntLiteral) ? parseLiteralTypeNode(true) : parseTypeReference();
            case 110:
            case 100:
              return parseTokenNode();
            case 104: {
              var thisKeyword = parseThisTypeNode();
              if (token() === 133 && !scanner.hasPrecedingLineBreak()) {
                return parseThisTypePredicate(thisKeyword);
              } else {
                return thisKeyword;
              }
            }
            case 108:
              return lookAhead(isStartOfTypeOfImportType) ? parseImportType() : parseTypeQuery();
            case 18:
              return lookAhead(isStartOfMappedType) ? parseMappedType() : parseTypeLiteral();
            case 22:
              return parseTupleType();
            case 20:
              return parseParenthesizedType();
            case 96:
              return parseImportType();
            case 124:
              return lookAhead(nextTokenIsIdentifierOrKeywordOnSameLine) ? parseAssertsTypePredicate() : parseTypeReference();
            default:
              return parseTypeReference();
          }
        }
        function isStartOfType(inStartOfParameter) {
          switch (token()) {
            case 125:
            case 148:
            case 143:
            case 140:
            case 151:
            case 128:
            case 138:
            case 144:
            case 147:
            case 110:
            case 146:
            case 100:
            case 104:
            case 108:
            case 137:
            case 18:
            case 22:
            case 29:
            case 51:
            case 50:
            case 99:
            case 10:
            case 8:
            case 9:
            case 106:
            case 91:
            case 141:
            case 41:
            case 57:
            case 53:
            case 25:
            case 132:
            case 96:
            case 124:
              return true;
            case 94:
              return !inStartOfParameter;
            case 40:
              return !inStartOfParameter && lookAhead(nextTokenIsNumericOrBigIntLiteral);
            case 20:
              return !inStartOfParameter && lookAhead(isStartOfParenthesizedOrFunctionType);
            default:
              return isIdentifier();
          }
        }
        function isStartOfParenthesizedOrFunctionType() {
          nextToken();
          return token() === 21 || isStartOfParameter(false) || isStartOfType();
        }
        function parsePostfixTypeOrHigher() {
          var type = parseNonArrayType();
          while (!scanner.hasPrecedingLineBreak()) {
            switch (token()) {
              case 53:
                type = createPostfixType(298, type);
                break;
              case 57:
                if (!(contextFlags & 4194304) && lookAhead(nextTokenIsStartOfType)) {
                  return type;
                }
                type = createPostfixType(297, type);
                break;
              case 22:
                parseExpected(22);
                if (isStartOfType()) {
                  var node = createNode2(185, type.pos);
                  node.objectType = type;
                  node.indexType = parseType();
                  parseExpected(23);
                  type = finishNode(node);
                } else {
                  var node = createNode2(174, type.pos);
                  node.elementType = type;
                  parseExpected(23);
                  type = finishNode(node);
                }
                break;
              default:
                return type;
            }
          }
          return type;
        }
        function createPostfixType(kind, type) {
          nextToken();
          var postfix = createNode2(kind, type.pos);
          postfix.type = type;
          return finishNode(postfix);
        }
        function parseTypeOperator(operator) {
          var node = createNode2(184);
          parseExpected(operator);
          node.operator = operator;
          node.type = parseTypeOperatorOrHigher();
          return finishNode(node);
        }
        function parseInferType() {
          var node = createNode2(181);
          parseExpected(132);
          var typeParameter = createNode2(155);
          typeParameter.name = parseIdentifier();
          node.typeParameter = finishNode(typeParameter);
          return finishNode(node);
        }
        function parseTypeOperatorOrHigher() {
          var operator = token();
          switch (operator) {
            case 134:
            case 147:
            case 138:
              return parseTypeOperator(operator);
            case 132:
              return parseInferType();
          }
          return parsePostfixTypeOrHigher();
        }
        function parseUnionOrIntersectionType(kind, parseConstituentType, operator) {
          var start = scanner.getStartPos();
          var hasLeadingOperator = parseOptional(operator);
          var type = parseConstituentType();
          if (token() === operator || hasLeadingOperator) {
            var types = [type];
            while (parseOptional(operator)) {
              types.push(parseConstituentType());
            }
            var node = createNode2(kind, start);
            node.types = createNodeArray(types, start);
            type = finishNode(node);
          }
          return type;
        }
        function parseIntersectionTypeOrHigher() {
          return parseUnionOrIntersectionType(179, parseTypeOperatorOrHigher, 50);
        }
        function parseUnionTypeOrHigher() {
          return parseUnionOrIntersectionType(178, parseIntersectionTypeOrHigher, 51);
        }
        function isStartOfFunctionType() {
          if (token() === 29) {
            return true;
          }
          return token() === 20 && lookAhead(isUnambiguouslyStartOfFunctionType);
        }
        function skipParameterStart() {
          if (ts2.isModifierKind(token())) {
            parseModifiers();
          }
          if (isIdentifier() || token() === 104) {
            nextToken();
            return true;
          }
          if (token() === 22 || token() === 18) {
            var previousErrorCount = parseDiagnostics.length;
            parseIdentifierOrPattern();
            return previousErrorCount === parseDiagnostics.length;
          }
          return false;
        }
        function isUnambiguouslyStartOfFunctionType() {
          nextToken();
          if (token() === 21 || token() === 25) {
            return true;
          }
          if (skipParameterStart()) {
            if (token() === 58 || token() === 27 || token() === 57 || token() === 62) {
              return true;
            }
            if (token() === 21) {
              nextToken();
              if (token() === 38) {
                return true;
              }
            }
          }
          return false;
        }
        function parseTypeOrTypePredicate() {
          var typePredicateVariable = isIdentifier() && tryParse(parseTypePredicatePrefix);
          var type = parseType();
          if (typePredicateVariable) {
            var node = createNode2(168, typePredicateVariable.pos);
            node.assertsModifier = void 0;
            node.parameterName = typePredicateVariable;
            node.type = type;
            return finishNode(node);
          } else {
            return type;
          }
        }
        function parseTypePredicatePrefix() {
          var id = parseIdentifier();
          if (token() === 133 && !scanner.hasPrecedingLineBreak()) {
            nextToken();
            return id;
          }
        }
        function parseAssertsTypePredicate() {
          var node = createNode2(168);
          node.assertsModifier = parseExpectedToken(124);
          node.parameterName = token() === 104 ? parseThisTypeNode() : parseIdentifier();
          node.type = parseOptional(133) ? parseType() : void 0;
          return finishNode(node);
        }
        function parseType() {
          return doOutsideOfContext(40960, parseTypeWorker);
        }
        function parseTypeWorker(noConditionalTypes) {
          if (isStartOfFunctionType() || token() === 99) {
            return parseFunctionOrConstructorType();
          }
          var type = parseUnionTypeOrHigher();
          if (!noConditionalTypes && !scanner.hasPrecedingLineBreak() && parseOptional(90)) {
            var node = createNode2(180, type.pos);
            node.checkType = type;
            node.extendsType = parseTypeWorker(true);
            parseExpected(57);
            node.trueType = parseTypeWorker();
            parseExpected(58);
            node.falseType = parseTypeWorker();
            return finishNode(node);
          }
          return type;
        }
        function parseTypeAnnotation() {
          return parseOptional(58) ? parseType() : void 0;
        }
        function isStartOfLeftHandSideExpression() {
          switch (token()) {
            case 104:
            case 102:
            case 100:
            case 106:
            case 91:
            case 8:
            case 9:
            case 10:
            case 14:
            case 15:
            case 20:
            case 22:
            case 18:
            case 94:
            case 80:
            case 99:
            case 43:
            case 67:
            case 75:
              return true;
            case 96:
              return lookAhead(nextTokenIsOpenParenOrLessThanOrDot);
            default:
              return isIdentifier();
          }
        }
        function isStartOfExpression() {
          if (isStartOfLeftHandSideExpression()) {
            return true;
          }
          switch (token()) {
            case 39:
            case 40:
            case 54:
            case 53:
            case 85:
            case 108:
            case 110:
            case 45:
            case 46:
            case 29:
            case 127:
            case 121:
            case 76:
              return true;
            default:
              if (isBinaryOperator()) {
                return true;
              }
              return isIdentifier();
          }
        }
        function isStartOfExpressionStatement() {
          return token() !== 18 && token() !== 94 && token() !== 80 && token() !== 59 && isStartOfExpression();
        }
        function parseExpression() {
          var saveDecoratorContext = inDecoratorContext();
          if (saveDecoratorContext) {
            setDecoratorContext(false);
          }
          var expr = parseAssignmentExpressionOrHigher();
          var operatorToken;
          while (operatorToken = parseOptionalToken(27)) {
            expr = makeBinaryExpression(expr, operatorToken, parseAssignmentExpressionOrHigher());
          }
          if (saveDecoratorContext) {
            setDecoratorContext(true);
          }
          return expr;
        }
        function parseInitializer() {
          return parseOptional(62) ? parseAssignmentExpressionOrHigher() : void 0;
        }
        function parseAssignmentExpressionOrHigher() {
          if (isYieldExpression()) {
            return parseYieldExpression();
          }
          var arrowExpression = tryParseParenthesizedArrowFunctionExpression() || tryParseAsyncSimpleArrowFunctionExpression();
          if (arrowExpression) {
            return arrowExpression;
          }
          var expr = parseBinaryExpressionOrHigher(0);
          if (expr.kind === 75 && token() === 38) {
            return parseSimpleArrowFunctionExpression(expr);
          }
          if (ts2.isLeftHandSideExpression(expr) && ts2.isAssignmentOperator(reScanGreaterToken())) {
            return makeBinaryExpression(expr, parseTokenNode(), parseAssignmentExpressionOrHigher());
          }
          return parseConditionalExpressionRest(expr);
        }
        function isYieldExpression() {
          if (token() === 121) {
            if (inYieldContext()) {
              return true;
            }
            return lookAhead(nextTokenIsIdentifierOrKeywordOrLiteralOnSameLine);
          }
          return false;
        }
        function nextTokenIsIdentifierOnSameLine() {
          nextToken();
          return !scanner.hasPrecedingLineBreak() && isIdentifier();
        }
        function parseYieldExpression() {
          var node = createNode2(212);
          nextToken();
          if (!scanner.hasPrecedingLineBreak() && (token() === 41 || isStartOfExpression())) {
            node.asteriskToken = parseOptionalToken(41);
            node.expression = parseAssignmentExpressionOrHigher();
            return finishNode(node);
          } else {
            return finishNode(node);
          }
        }
        function parseSimpleArrowFunctionExpression(identifier, asyncModifier) {
          ts2.Debug.assert(token() === 38, "parseSimpleArrowFunctionExpression should only have been called if we had a =>");
          var node;
          if (asyncModifier) {
            node = createNode2(202, asyncModifier.pos);
            node.modifiers = asyncModifier;
          } else {
            node = createNode2(202, identifier.pos);
          }
          var parameter = createNode2(156, identifier.pos);
          parameter.name = identifier;
          finishNode(parameter);
          node.parameters = createNodeArray([parameter], parameter.pos, parameter.end);
          node.equalsGreaterThanToken = parseExpectedToken(38);
          node.body = parseArrowFunctionExpressionBody(!!asyncModifier);
          return addJSDocComment(finishNode(node));
        }
        function tryParseParenthesizedArrowFunctionExpression() {
          var triState = isParenthesizedArrowFunctionExpression();
          if (triState === 0) {
            return void 0;
          }
          var arrowFunction = triState === 1 ? parseParenthesizedArrowFunctionExpressionHead(true) : tryParse(parsePossibleParenthesizedArrowFunctionExpressionHead);
          if (!arrowFunction) {
            return void 0;
          }
          var isAsync = hasModifierOfKind(arrowFunction, 126);
          var lastToken = token();
          arrowFunction.equalsGreaterThanToken = parseExpectedToken(38);
          arrowFunction.body = lastToken === 38 || lastToken === 18 ? parseArrowFunctionExpressionBody(isAsync) : parseIdentifier();
          return finishNode(arrowFunction);
        }
        function isParenthesizedArrowFunctionExpression() {
          if (token() === 20 || token() === 29 || token() === 126) {
            return lookAhead(isParenthesizedArrowFunctionExpressionWorker);
          }
          if (token() === 38) {
            return 1;
          }
          return 0;
        }
        function isParenthesizedArrowFunctionExpressionWorker() {
          if (token() === 126) {
            nextToken();
            if (scanner.hasPrecedingLineBreak()) {
              return 0;
            }
            if (token() !== 20 && token() !== 29) {
              return 0;
            }
          }
          var first = token();
          var second = nextToken();
          if (first === 20) {
            if (second === 21) {
              var third = nextToken();
              switch (third) {
                case 38:
                case 58:
                case 18:
                  return 1;
                default:
                  return 0;
              }
            }
            if (second === 22 || second === 18) {
              return 2;
            }
            if (second === 25) {
              return 1;
            }
            if (ts2.isModifierKind(second) && second !== 126 && lookAhead(nextTokenIsIdentifier)) {
              return 1;
            }
            if (!isIdentifier() && second !== 104) {
              return 0;
            }
            switch (nextToken()) {
              case 58:
                return 1;
              case 57:
                nextToken();
                if (token() === 58 || token() === 27 || token() === 62 || token() === 21) {
                  return 1;
                }
                return 0;
              case 27:
              case 62:
              case 21:
                return 2;
            }
            return 0;
          } else {
            ts2.Debug.assert(first === 29);
            if (!isIdentifier()) {
              return 0;
            }
            if (sourceFile.languageVariant === 1) {
              var isArrowFunctionInJsx = lookAhead(function() {
                var third2 = nextToken();
                if (third2 === 90) {
                  var fourth = nextToken();
                  switch (fourth) {
                    case 62:
                    case 31:
                      return false;
                    default:
                      return true;
                  }
                } else if (third2 === 27) {
                  return true;
                }
                return false;
              });
              if (isArrowFunctionInJsx) {
                return 1;
              }
              return 0;
            }
            return 2;
          }
        }
        function parsePossibleParenthesizedArrowFunctionExpressionHead() {
          var tokenPos = scanner.getTokenPos();
          if (notParenthesizedArrow && notParenthesizedArrow.has(tokenPos.toString())) {
            return void 0;
          }
          var result = parseParenthesizedArrowFunctionExpressionHead(false);
          if (!result) {
            (notParenthesizedArrow || (notParenthesizedArrow = ts2.createMap())).set(tokenPos.toString(), true);
          }
          return result;
        }
        function tryParseAsyncSimpleArrowFunctionExpression() {
          if (token() === 126) {
            if (lookAhead(isUnParenthesizedAsyncArrowFunctionWorker) === 1) {
              var asyncModifier = parseModifiersForArrowFunction();
              var expr = parseBinaryExpressionOrHigher(0);
              return parseSimpleArrowFunctionExpression(expr, asyncModifier);
            }
          }
          return void 0;
        }
        function isUnParenthesizedAsyncArrowFunctionWorker() {
          if (token() === 126) {
            nextToken();
            if (scanner.hasPrecedingLineBreak() || token() === 38) {
              return 0;
            }
            var expr = parseBinaryExpressionOrHigher(0);
            if (!scanner.hasPrecedingLineBreak() && expr.kind === 75 && token() === 38) {
              return 1;
            }
          }
          return 0;
        }
        function parseParenthesizedArrowFunctionExpressionHead(allowAmbiguity) {
          var node = createNodeWithJSDoc(202);
          node.modifiers = parseModifiersForArrowFunction();
          var isAsync = hasModifierOfKind(node, 126) ? 2 : 0;
          if (!fillSignature(58, isAsync, node) && !allowAmbiguity) {
            return void 0;
          }
          var hasJSDocFunctionType = node.type && ts2.isJSDocFunctionType(node.type);
          if (!allowAmbiguity && token() !== 38 && (hasJSDocFunctionType || token() !== 18)) {
            return void 0;
          }
          return node;
        }
        function parseArrowFunctionExpressionBody(isAsync) {
          if (token() === 18) {
            return parseFunctionBlock(isAsync ? 2 : 0);
          }
          if (token() !== 26 && token() !== 94 && token() !== 80 && isStartOfStatement() && !isStartOfExpressionStatement()) {
            return parseFunctionBlock(16 | (isAsync ? 2 : 0));
          }
          return isAsync ? doInAwaitContext(parseAssignmentExpressionOrHigher) : doOutsideOfAwaitContext(parseAssignmentExpressionOrHigher);
        }
        function parseConditionalExpressionRest(leftOperand) {
          var questionToken = parseOptionalToken(57);
          if (!questionToken) {
            return leftOperand;
          }
          var node = createNode2(210, leftOperand.pos);
          node.condition = leftOperand;
          node.questionToken = questionToken;
          node.whenTrue = doOutsideOfContext(disallowInAndDecoratorContext, parseAssignmentExpressionOrHigher);
          node.colonToken = parseExpectedToken(58);
          node.whenFalse = ts2.nodeIsPresent(node.colonToken) ? parseAssignmentExpressionOrHigher() : createMissingNode(75, false, ts2.Diagnostics._0_expected, ts2.tokenToString(58));
          return finishNode(node);
        }
        function parseBinaryExpressionOrHigher(precedence) {
          var leftOperand = parseUnaryExpressionOrHigher();
          return parseBinaryExpressionRest(precedence, leftOperand);
        }
        function isInOrOfKeyword(t) {
          return t === 97 || t === 152;
        }
        function parseBinaryExpressionRest(precedence, leftOperand) {
          while (true) {
            reScanGreaterToken();
            var newPrecedence = ts2.getBinaryOperatorPrecedence(token());
            var consumeCurrentOperator = token() === 42 ? newPrecedence >= precedence : newPrecedence > precedence;
            if (!consumeCurrentOperator) {
              break;
            }
            if (token() === 97 && inDisallowInContext()) {
              break;
            }
            if (token() === 123) {
              if (scanner.hasPrecedingLineBreak()) {
                break;
              } else {
                nextToken();
                leftOperand = makeAsExpression(leftOperand, parseType());
              }
            } else {
              leftOperand = makeBinaryExpression(leftOperand, parseTokenNode(), parseBinaryExpressionOrHigher(newPrecedence));
            }
          }
          return leftOperand;
        }
        function isBinaryOperator() {
          if (inDisallowInContext() && token() === 97) {
            return false;
          }
          return ts2.getBinaryOperatorPrecedence(token()) > 0;
        }
        function makeBinaryExpression(left, operatorToken, right) {
          var node = createNode2(209, left.pos);
          node.left = left;
          node.operatorToken = operatorToken;
          node.right = right;
          return finishNode(node);
        }
        function makeAsExpression(left, right) {
          var node = createNode2(217, left.pos);
          node.expression = left;
          node.type = right;
          return finishNode(node);
        }
        function parsePrefixUnaryExpression() {
          var node = createNode2(207);
          node.operator = token();
          nextToken();
          node.operand = parseSimpleUnaryExpression();
          return finishNode(node);
        }
        function parseDeleteExpression() {
          var node = createNode2(203);
          nextToken();
          node.expression = parseSimpleUnaryExpression();
          return finishNode(node);
        }
        function parseTypeOfExpression() {
          var node = createNode2(204);
          nextToken();
          node.expression = parseSimpleUnaryExpression();
          return finishNode(node);
        }
        function parseVoidExpression() {
          var node = createNode2(205);
          nextToken();
          node.expression = parseSimpleUnaryExpression();
          return finishNode(node);
        }
        function isAwaitExpression() {
          if (token() === 127) {
            if (inAwaitContext()) {
              return true;
            }
            return lookAhead(nextTokenIsIdentifierOrKeywordOrLiteralOnSameLine);
          }
          return false;
        }
        function parseAwaitExpression() {
          var node = createNode2(206);
          nextToken();
          node.expression = parseSimpleUnaryExpression();
          return finishNode(node);
        }
        function parseUnaryExpressionOrHigher() {
          if (isUpdateExpression()) {
            var updateExpression = parseUpdateExpression();
            return token() === 42 ? parseBinaryExpressionRest(ts2.getBinaryOperatorPrecedence(token()), updateExpression) : updateExpression;
          }
          var unaryOperator = token();
          var simpleUnaryExpression = parseSimpleUnaryExpression();
          if (token() === 42) {
            var pos = ts2.skipTrivia(sourceText, simpleUnaryExpression.pos);
            var end = simpleUnaryExpression.end;
            if (simpleUnaryExpression.kind === 199) {
              parseErrorAt(pos, end, ts2.Diagnostics.A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses);
            } else {
              parseErrorAt(pos, end, ts2.Diagnostics.An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses, ts2.tokenToString(unaryOperator));
            }
          }
          return simpleUnaryExpression;
        }
        function parseSimpleUnaryExpression() {
          switch (token()) {
            case 39:
            case 40:
            case 54:
            case 53:
              return parsePrefixUnaryExpression();
            case 85:
              return parseDeleteExpression();
            case 108:
              return parseTypeOfExpression();
            case 110:
              return parseVoidExpression();
            case 29:
              return parseTypeAssertion();
            case 127:
              if (isAwaitExpression()) {
                return parseAwaitExpression();
              }
            default:
              return parseUpdateExpression();
          }
        }
        function isUpdateExpression() {
          switch (token()) {
            case 39:
            case 40:
            case 54:
            case 53:
            case 85:
            case 108:
            case 110:
            case 127:
              return false;
            case 29:
              if (sourceFile.languageVariant !== 1) {
                return false;
              }
            default:
              return true;
          }
        }
        function parseUpdateExpression() {
          if (token() === 45 || token() === 46) {
            var node = createNode2(207);
            node.operator = token();
            nextToken();
            node.operand = parseLeftHandSideExpressionOrHigher();
            return finishNode(node);
          } else if (sourceFile.languageVariant === 1 && token() === 29 && lookAhead(nextTokenIsIdentifierOrKeywordOrGreaterThan)) {
            return parseJsxElementOrSelfClosingElementOrFragment(true);
          }
          var expression = parseLeftHandSideExpressionOrHigher();
          ts2.Debug.assert(ts2.isLeftHandSideExpression(expression));
          if ((token() === 45 || token() === 46) && !scanner.hasPrecedingLineBreak()) {
            var node = createNode2(208, expression.pos);
            node.operand = expression;
            node.operator = token();
            nextToken();
            return finishNode(node);
          }
          return expression;
        }
        function parseLeftHandSideExpressionOrHigher() {
          var expression;
          if (token() === 96) {
            if (lookAhead(nextTokenIsOpenParenOrLessThan)) {
              sourceFile.flags |= 1048576;
              expression = parseTokenNode();
            } else if (lookAhead(nextTokenIsDot)) {
              var fullStart = scanner.getStartPos();
              nextToken();
              nextToken();
              var node = createNode2(219, fullStart);
              node.keywordToken = 96;
              node.name = parseIdentifierName();
              expression = finishNode(node);
              sourceFile.flags |= 2097152;
            } else {
              expression = parseMemberExpressionOrHigher();
            }
          } else {
            expression = token() === 102 ? parseSuperExpression() : parseMemberExpressionOrHigher();
          }
          return parseCallExpressionRest(expression);
        }
        function parseMemberExpressionOrHigher() {
          var expression = parsePrimaryExpression();
          return parseMemberExpressionRest(expression, true);
        }
        function parseSuperExpression() {
          var expression = parseTokenNode();
          if (token() === 29) {
            var startPos = getNodePos();
            var typeArguments = tryParse(parseTypeArgumentsInExpression);
            if (typeArguments !== void 0) {
              parseErrorAt(startPos, getNodePos(), ts2.Diagnostics.super_may_not_use_type_arguments);
            }
          }
          if (token() === 20 || token() === 24 || token() === 22) {
            return expression;
          }
          var node = createNode2(194, expression.pos);
          node.expression = expression;
          parseExpectedToken(24, ts2.Diagnostics.super_must_be_followed_by_an_argument_list_or_member_access);
          node.name = parseRightSideOfDot(true, true);
          return finishNode(node);
        }
        function parseJsxElementOrSelfClosingElementOrFragment(inExpressionContext) {
          var opening = parseJsxOpeningOrSelfClosingElementOrOpeningFragment(inExpressionContext);
          var result;
          if (opening.kind === 268) {
            var node = createNode2(266, opening.pos);
            node.openingElement = opening;
            node.children = parseJsxChildren(node.openingElement);
            node.closingElement = parseJsxClosingElement(inExpressionContext);
            if (!tagNamesAreEquivalent(node.openingElement.tagName, node.closingElement.tagName)) {
              parseErrorAtRange(node.closingElement, ts2.Diagnostics.Expected_corresponding_JSX_closing_tag_for_0, ts2.getTextOfNodeFromSourceText(sourceText, node.openingElement.tagName));
            }
            result = finishNode(node);
          } else if (opening.kind === 271) {
            var node = createNode2(270, opening.pos);
            node.openingFragment = opening;
            node.children = parseJsxChildren(node.openingFragment);
            node.closingFragment = parseJsxClosingFragment(inExpressionContext);
            result = finishNode(node);
          } else {
            ts2.Debug.assert(opening.kind === 267);
            result = opening;
          }
          if (inExpressionContext && token() === 29) {
            var invalidElement = tryParse(function() {
              return parseJsxElementOrSelfClosingElementOrFragment(true);
            });
            if (invalidElement) {
              parseErrorAtCurrentToken(ts2.Diagnostics.JSX_expressions_must_have_one_parent_element);
              var badNode = createNode2(209, result.pos);
              badNode.end = invalidElement.end;
              badNode.left = result;
              badNode.right = invalidElement;
              badNode.operatorToken = createMissingNode(27, false);
              badNode.operatorToken.pos = badNode.operatorToken.end = badNode.right.pos;
              return badNode;
            }
          }
          return result;
        }
        function parseJsxText() {
          var node = createNode2(11);
          node.text = scanner.getTokenValue();
          node.containsOnlyTriviaWhiteSpaces = currentToken === 12;
          currentToken = scanner.scanJsxToken();
          return finishNode(node);
        }
        function parseJsxChild(openingTag, token2) {
          switch (token2) {
            case 1:
              if (ts2.isJsxOpeningFragment(openingTag)) {
                parseErrorAtRange(openingTag, ts2.Diagnostics.JSX_fragment_has_no_corresponding_closing_tag);
              } else {
                var tag = openingTag.tagName;
                var start = ts2.skipTrivia(sourceText, tag.pos);
                parseErrorAt(start, tag.end, ts2.Diagnostics.JSX_element_0_has_no_corresponding_closing_tag, ts2.getTextOfNodeFromSourceText(sourceText, openingTag.tagName));
              }
              return void 0;
            case 30:
            case 7:
              return void 0;
            case 11:
            case 12:
              return parseJsxText();
            case 18:
              return parseJsxExpression(false);
            case 29:
              return parseJsxElementOrSelfClosingElementOrFragment(false);
            default:
              return ts2.Debug.assertNever(token2);
          }
        }
        function parseJsxChildren(openingTag) {
          var list = [];
          var listPos = getNodePos();
          var saveParsingContext = parsingContext;
          parsingContext |= 1 << 14;
          while (true) {
            var child = parseJsxChild(openingTag, currentToken = scanner.reScanJsxToken());
            if (!child)
              break;
            list.push(child);
          }
          parsingContext = saveParsingContext;
          return createNodeArray(list, listPos);
        }
        function parseJsxAttributes() {
          var jsxAttributes = createNode2(274);
          jsxAttributes.properties = parseList(13, parseJsxAttribute);
          return finishNode(jsxAttributes);
        }
        function parseJsxOpeningOrSelfClosingElementOrOpeningFragment(inExpressionContext) {
          var fullStart = scanner.getStartPos();
          parseExpected(29);
          if (token() === 31) {
            var node_1 = createNode2(271, fullStart);
            scanJsxText();
            return finishNode(node_1);
          }
          var tagName = parseJsxElementName();
          var typeArguments = tryParseTypeArguments();
          var attributes = parseJsxAttributes();
          var node;
          if (token() === 31) {
            node = createNode2(268, fullStart);
            scanJsxText();
          } else {
            parseExpected(43);
            if (inExpressionContext) {
              parseExpected(31);
            } else {
              parseExpected(31, void 0, false);
              scanJsxText();
            }
            node = createNode2(267, fullStart);
          }
          node.tagName = tagName;
          node.typeArguments = typeArguments;
          node.attributes = attributes;
          return finishNode(node);
        }
        function parseJsxElementName() {
          scanJsxIdentifier();
          var expression = token() === 104 ? parseTokenNode() : parseIdentifierName();
          while (parseOptional(24)) {
            var propertyAccess = createNode2(194, expression.pos);
            propertyAccess.expression = expression;
            propertyAccess.name = parseRightSideOfDot(true, false);
            expression = finishNode(propertyAccess);
          }
          return expression;
        }
        function parseJsxExpression(inExpressionContext) {
          var node = createNode2(276);
          if (!parseExpected(18)) {
            return void 0;
          }
          if (token() !== 19) {
            node.dotDotDotToken = parseOptionalToken(25);
            node.expression = parseExpression();
          }
          if (inExpressionContext) {
            parseExpected(19);
          } else {
            if (parseExpected(19, void 0, false)) {
              scanJsxText();
            }
          }
          return finishNode(node);
        }
        function parseJsxAttribute() {
          if (token() === 18) {
            return parseJsxSpreadAttribute();
          }
          scanJsxIdentifier();
          var node = createNode2(273);
          node.name = parseIdentifierName();
          if (token() === 62) {
            switch (scanJsxAttributeValue()) {
              case 10:
                node.initializer = parseLiteralNode();
                break;
              default:
                node.initializer = parseJsxExpression(true);
                break;
            }
          }
          return finishNode(node);
        }
        function parseJsxSpreadAttribute() {
          var node = createNode2(275);
          parseExpected(18);
          parseExpected(25);
          node.expression = parseExpression();
          parseExpected(19);
          return finishNode(node);
        }
        function parseJsxClosingElement(inExpressionContext) {
          var node = createNode2(269);
          parseExpected(30);
          node.tagName = parseJsxElementName();
          if (inExpressionContext) {
            parseExpected(31);
          } else {
            parseExpected(31, void 0, false);
            scanJsxText();
          }
          return finishNode(node);
        }
        function parseJsxClosingFragment(inExpressionContext) {
          var node = createNode2(272);
          parseExpected(30);
          if (ts2.tokenIsIdentifierOrKeyword(token())) {
            parseErrorAtRange(parseJsxElementName(), ts2.Diagnostics.Expected_corresponding_closing_tag_for_JSX_fragment);
          }
          if (inExpressionContext) {
            parseExpected(31);
          } else {
            parseExpected(31, void 0, false);
            scanJsxText();
          }
          return finishNode(node);
        }
        function parseTypeAssertion() {
          var node = createNode2(199);
          parseExpected(29);
          node.type = parseType();
          parseExpected(31);
          node.expression = parseSimpleUnaryExpression();
          return finishNode(node);
        }
        function nextTokenIsIdentifierOrKeywordOrOpenBracketOrTemplate() {
          nextToken();
          return ts2.tokenIsIdentifierOrKeyword(token()) || token() === 22 || isTemplateStartOfTaggedTemplate();
        }
        function isStartOfOptionalPropertyOrElementAccessChain() {
          return token() === 28 && lookAhead(nextTokenIsIdentifierOrKeywordOrOpenBracketOrTemplate);
        }
        function tryReparseOptionalChain(node) {
          if (node.flags & 32) {
            return true;
          }
          if (ts2.isNonNullExpression(node)) {
            var expr = node.expression;
            while (ts2.isNonNullExpression(expr) && !(expr.flags & 32)) {
              expr = expr.expression;
            }
            if (expr.flags & 32) {
              while (ts2.isNonNullExpression(node)) {
                node.flags |= 32;
                node = node.expression;
              }
              return true;
            }
          }
          return false;
        }
        function parsePropertyAccessExpressionRest(expression, questionDotToken) {
          var propertyAccess = createNode2(194, expression.pos);
          propertyAccess.expression = expression;
          propertyAccess.questionDotToken = questionDotToken;
          propertyAccess.name = parseRightSideOfDot(true, true);
          if (questionDotToken || tryReparseOptionalChain(expression)) {
            propertyAccess.flags |= 32;
            if (ts2.isPrivateIdentifier(propertyAccess.name)) {
              parseErrorAtRange(propertyAccess.name, ts2.Diagnostics.An_optional_chain_cannot_contain_private_identifiers);
            }
          }
          return finishNode(propertyAccess);
        }
        function parseElementAccessExpressionRest(expression, questionDotToken) {
          var indexedAccess = createNode2(195, expression.pos);
          indexedAccess.expression = expression;
          indexedAccess.questionDotToken = questionDotToken;
          if (token() === 23) {
            indexedAccess.argumentExpression = createMissingNode(75, true, ts2.Diagnostics.An_element_access_expression_should_take_an_argument);
          } else {
            var argument = allowInAnd(parseExpression);
            if (ts2.isStringOrNumericLiteralLike(argument)) {
              argument.text = internIdentifier(argument.text);
            }
            indexedAccess.argumentExpression = argument;
          }
          parseExpected(23);
          if (questionDotToken || tryReparseOptionalChain(expression)) {
            indexedAccess.flags |= 32;
          }
          return finishNode(indexedAccess);
        }
        function parseMemberExpressionRest(expression, allowOptionalChain) {
          while (true) {
            var questionDotToken = void 0;
            var isPropertyAccess = false;
            if (allowOptionalChain && isStartOfOptionalPropertyOrElementAccessChain()) {
              questionDotToken = parseExpectedToken(28);
              isPropertyAccess = ts2.tokenIsIdentifierOrKeyword(token());
            } else {
              isPropertyAccess = parseOptional(24);
            }
            if (isPropertyAccess) {
              expression = parsePropertyAccessExpressionRest(expression, questionDotToken);
              continue;
            }
            if (!questionDotToken && token() === 53 && !scanner.hasPrecedingLineBreak()) {
              nextToken();
              var nonNullExpression = createNode2(218, expression.pos);
              nonNullExpression.expression = expression;
              expression = finishNode(nonNullExpression);
              continue;
            }
            if ((questionDotToken || !inDecoratorContext()) && parseOptional(22)) {
              expression = parseElementAccessExpressionRest(expression, questionDotToken);
              continue;
            }
            if (isTemplateStartOfTaggedTemplate()) {
              expression = parseTaggedTemplateRest(expression, questionDotToken, void 0);
              continue;
            }
            return expression;
          }
        }
        function isTemplateStartOfTaggedTemplate() {
          return token() === 14 || token() === 15;
        }
        function parseTaggedTemplateRest(tag, questionDotToken, typeArguments) {
          var tagExpression = createNode2(198, tag.pos);
          tagExpression.tag = tag;
          tagExpression.questionDotToken = questionDotToken;
          tagExpression.typeArguments = typeArguments;
          tagExpression.template = token() === 14 ? (reScanTemplateHeadOrNoSubstitutionTemplate(), parseLiteralNode()) : parseTemplateExpression(true);
          if (questionDotToken || tag.flags & 32) {
            tagExpression.flags |= 32;
          }
          return finishNode(tagExpression);
        }
        function parseCallExpressionRest(expression) {
          while (true) {
            expression = parseMemberExpressionRest(expression, true);
            var questionDotToken = parseOptionalToken(28);
            if (token() === 29 || token() === 47) {
              var typeArguments = tryParse(parseTypeArgumentsInExpression);
              if (typeArguments) {
                if (isTemplateStartOfTaggedTemplate()) {
                  expression = parseTaggedTemplateRest(expression, questionDotToken, typeArguments);
                  continue;
                }
                var callExpr = createNode2(196, expression.pos);
                callExpr.expression = expression;
                callExpr.questionDotToken = questionDotToken;
                callExpr.typeArguments = typeArguments;
                callExpr.arguments = parseArgumentList();
                if (questionDotToken || tryReparseOptionalChain(expression)) {
                  callExpr.flags |= 32;
                }
                expression = finishNode(callExpr);
                continue;
              }
            } else if (token() === 20) {
              var callExpr = createNode2(196, expression.pos);
              callExpr.expression = expression;
              callExpr.questionDotToken = questionDotToken;
              callExpr.arguments = parseArgumentList();
              if (questionDotToken || tryReparseOptionalChain(expression)) {
                callExpr.flags |= 32;
              }
              expression = finishNode(callExpr);
              continue;
            }
            if (questionDotToken) {
              var propertyAccess = createNode2(194, expression.pos);
              propertyAccess.expression = expression;
              propertyAccess.questionDotToken = questionDotToken;
              propertyAccess.name = createMissingNode(75, false, ts2.Diagnostics.Identifier_expected);
              propertyAccess.flags |= 32;
              expression = finishNode(propertyAccess);
            }
            break;
          }
          return expression;
        }
        function parseArgumentList() {
          parseExpected(20);
          var result = parseDelimitedList(11, parseArgumentExpression);
          parseExpected(21);
          return result;
        }
        function parseTypeArgumentsInExpression() {
          if (reScanLessThanToken() !== 29) {
            return void 0;
          }
          nextToken();
          var typeArguments = parseDelimitedList(20, parseType);
          if (!parseExpected(31)) {
            return void 0;
          }
          return typeArguments && canFollowTypeArgumentsInExpression() ? typeArguments : void 0;
        }
        function canFollowTypeArgumentsInExpression() {
          switch (token()) {
            case 20:
            case 14:
            case 15:
            case 24:
            case 21:
            case 23:
            case 58:
            case 26:
            case 57:
            case 34:
            case 36:
            case 35:
            case 37:
            case 55:
            case 56:
            case 60:
            case 52:
            case 50:
            case 51:
            case 19:
            case 1:
              return true;
            case 27:
            case 18:
            default:
              return false;
          }
        }
        function parsePrimaryExpression() {
          switch (token()) {
            case 8:
            case 9:
            case 10:
            case 14:
              return parseLiteralNode();
            case 104:
            case 102:
            case 100:
            case 106:
            case 91:
              return parseTokenNode();
            case 20:
              return parseParenthesizedExpression();
            case 22:
              return parseArrayLiteralExpression();
            case 18:
              return parseObjectLiteralExpression();
            case 126:
              if (!lookAhead(nextTokenIsFunctionKeywordOnSameLine)) {
                break;
              }
              return parseFunctionExpression();
            case 80:
              return parseClassExpression();
            case 94:
              return parseFunctionExpression();
            case 99:
              return parseNewExpressionOrNewDotTarget();
            case 43:
            case 67:
              if (reScanSlashToken() === 13) {
                return parseLiteralNode();
              }
              break;
            case 15:
              return parseTemplateExpression(false);
          }
          return parseIdentifier(ts2.Diagnostics.Expression_expected);
        }
        function parseParenthesizedExpression() {
          var node = createNodeWithJSDoc(200);
          parseExpected(20);
          node.expression = allowInAnd(parseExpression);
          parseExpected(21);
          return finishNode(node);
        }
        function parseSpreadElement() {
          var node = createNode2(213);
          parseExpected(25);
          node.expression = parseAssignmentExpressionOrHigher();
          return finishNode(node);
        }
        function parseArgumentOrArrayLiteralElement() {
          return token() === 25 ? parseSpreadElement() : token() === 27 ? createNode2(215) : parseAssignmentExpressionOrHigher();
        }
        function parseArgumentExpression() {
          return doOutsideOfContext(disallowInAndDecoratorContext, parseArgumentOrArrayLiteralElement);
        }
        function parseArrayLiteralExpression() {
          var node = createNode2(192);
          parseExpected(22);
          if (scanner.hasPrecedingLineBreak()) {
            node.multiLine = true;
          }
          node.elements = parseDelimitedList(15, parseArgumentOrArrayLiteralElement);
          parseExpected(23);
          return finishNode(node);
        }
        function parseObjectLiteralElement() {
          var node = createNodeWithJSDoc(0);
          if (parseOptionalToken(25)) {
            node.kind = 283;
            node.expression = parseAssignmentExpressionOrHigher();
            return finishNode(node);
          }
          node.decorators = parseDecorators();
          node.modifiers = parseModifiers();
          if (parseContextualModifier(131)) {
            return parseAccessorDeclaration(node, 163);
          }
          if (parseContextualModifier(142)) {
            return parseAccessorDeclaration(node, 164);
          }
          var asteriskToken = parseOptionalToken(41);
          var tokenIsIdentifier = isIdentifier();
          node.name = parsePropertyName();
          node.questionToken = parseOptionalToken(57);
          node.exclamationToken = parseOptionalToken(53);
          if (asteriskToken || token() === 20 || token() === 29) {
            return parseMethodDeclaration(node, asteriskToken);
          }
          var isShorthandPropertyAssignment = tokenIsIdentifier && token() !== 58;
          if (isShorthandPropertyAssignment) {
            node.kind = 282;
            var equalsToken = parseOptionalToken(62);
            if (equalsToken) {
              node.equalsToken = equalsToken;
              node.objectAssignmentInitializer = allowInAnd(parseAssignmentExpressionOrHigher);
            }
          } else {
            node.kind = 281;
            parseExpected(58);
            node.initializer = allowInAnd(parseAssignmentExpressionOrHigher);
          }
          return finishNode(node);
        }
        function parseObjectLiteralExpression() {
          var node = createNode2(193);
          var openBracePosition = scanner.getTokenPos();
          parseExpected(18);
          if (scanner.hasPrecedingLineBreak()) {
            node.multiLine = true;
          }
          node.properties = parseDelimitedList(12, parseObjectLiteralElement, true);
          if (!parseExpected(19)) {
            var lastError = ts2.lastOrUndefined(parseDiagnostics);
            if (lastError && lastError.code === ts2.Diagnostics._0_expected.code) {
              ts2.addRelatedInfo(lastError, ts2.createFileDiagnostic(sourceFile, openBracePosition, 1, ts2.Diagnostics.The_parser_expected_to_find_a_to_match_the_token_here));
            }
          }
          return finishNode(node);
        }
        function parseFunctionExpression() {
          var saveDecoratorContext = inDecoratorContext();
          if (saveDecoratorContext) {
            setDecoratorContext(false);
          }
          var node = createNodeWithJSDoc(201);
          node.modifiers = parseModifiers();
          parseExpected(94);
          node.asteriskToken = parseOptionalToken(41);
          var isGenerator = node.asteriskToken ? 1 : 0;
          var isAsync = hasModifierOfKind(node, 126) ? 2 : 0;
          node.name = isGenerator && isAsync ? doInYieldAndAwaitContext(parseOptionalIdentifier) : isGenerator ? doInYieldContext(parseOptionalIdentifier) : isAsync ? doInAwaitContext(parseOptionalIdentifier) : parseOptionalIdentifier();
          fillSignature(58, isGenerator | isAsync, node);
          node.body = parseFunctionBlock(isGenerator | isAsync);
          if (saveDecoratorContext) {
            setDecoratorContext(true);
          }
          return finishNode(node);
        }
        function parseOptionalIdentifier() {
          return isIdentifier() ? parseIdentifier() : void 0;
        }
        function parseNewExpressionOrNewDotTarget() {
          var fullStart = scanner.getStartPos();
          parseExpected(99);
          if (parseOptional(24)) {
            var node_2 = createNode2(219, fullStart);
            node_2.keywordToken = 99;
            node_2.name = parseIdentifierName();
            return finishNode(node_2);
          }
          var expression = parsePrimaryExpression();
          var typeArguments;
          while (true) {
            expression = parseMemberExpressionRest(expression, false);
            typeArguments = tryParse(parseTypeArgumentsInExpression);
            if (isTemplateStartOfTaggedTemplate()) {
              ts2.Debug.assert(!!typeArguments, "Expected a type argument list; all plain tagged template starts should be consumed in 'parseMemberExpressionRest'");
              expression = parseTaggedTemplateRest(expression, void 0, typeArguments);
              typeArguments = void 0;
            }
            break;
          }
          var node = createNode2(197, fullStart);
          node.expression = expression;
          node.typeArguments = typeArguments;
          if (token() === 20) {
            node.arguments = parseArgumentList();
          } else if (node.typeArguments) {
            parseErrorAt(fullStart, scanner.getStartPos(), ts2.Diagnostics.A_new_expression_with_type_arguments_must_always_be_followed_by_a_parenthesized_argument_list);
          }
          return finishNode(node);
        }
        function parseBlock(ignoreMissingOpenBrace, diagnosticMessage) {
          var node = createNode2(223);
          var openBracePosition = scanner.getTokenPos();
          if (parseExpected(18, diagnosticMessage) || ignoreMissingOpenBrace) {
            if (scanner.hasPrecedingLineBreak()) {
              node.multiLine = true;
            }
            node.statements = parseList(1, parseStatement);
            if (!parseExpected(19)) {
              var lastError = ts2.lastOrUndefined(parseDiagnostics);
              if (lastError && lastError.code === ts2.Diagnostics._0_expected.code) {
                ts2.addRelatedInfo(lastError, ts2.createFileDiagnostic(sourceFile, openBracePosition, 1, ts2.Diagnostics.The_parser_expected_to_find_a_to_match_the_token_here));
              }
            }
          } else {
            node.statements = createMissingList();
          }
          return finishNode(node);
        }
        function parseFunctionBlock(flags, diagnosticMessage) {
          var savedYieldContext = inYieldContext();
          setYieldContext(!!(flags & 1));
          var savedAwaitContext = inAwaitContext();
          setAwaitContext(!!(flags & 2));
          var saveDecoratorContext = inDecoratorContext();
          if (saveDecoratorContext) {
            setDecoratorContext(false);
          }
          var block = parseBlock(!!(flags & 16), diagnosticMessage);
          if (saveDecoratorContext) {
            setDecoratorContext(true);
          }
          setYieldContext(savedYieldContext);
          setAwaitContext(savedAwaitContext);
          return block;
        }
        function parseEmptyStatement() {
          var node = createNode2(224);
          parseExpected(26);
          return finishNode(node);
        }
        function parseIfStatement() {
          var node = createNode2(227);
          parseExpected(95);
          parseExpected(20);
          node.expression = allowInAnd(parseExpression);
          parseExpected(21);
          node.thenStatement = parseStatement();
          node.elseStatement = parseOptional(87) ? parseStatement() : void 0;
          return finishNode(node);
        }
        function parseDoStatement() {
          var node = createNode2(228);
          parseExpected(86);
          node.statement = parseStatement();
          parseExpected(111);
          parseExpected(20);
          node.expression = allowInAnd(parseExpression);
          parseExpected(21);
          parseOptional(26);
          return finishNode(node);
        }
        function parseWhileStatement() {
          var node = createNode2(229);
          parseExpected(111);
          parseExpected(20);
          node.expression = allowInAnd(parseExpression);
          parseExpected(21);
          node.statement = parseStatement();
          return finishNode(node);
        }
        function parseForOrForInOrForOfStatement() {
          var pos = getNodePos();
          parseExpected(93);
          var awaitToken = parseOptionalToken(127);
          parseExpected(20);
          var initializer;
          if (token() !== 26) {
            if (token() === 109 || token() === 115 || token() === 81) {
              initializer = parseVariableDeclarationList(true);
            } else {
              initializer = disallowInAnd(parseExpression);
            }
          }
          var forOrForInOrForOfStatement;
          if (awaitToken ? parseExpected(152) : parseOptional(152)) {
            var forOfStatement = createNode2(232, pos);
            forOfStatement.awaitModifier = awaitToken;
            forOfStatement.initializer = initializer;
            forOfStatement.expression = allowInAnd(parseAssignmentExpressionOrHigher);
            parseExpected(21);
            forOrForInOrForOfStatement = forOfStatement;
          } else if (parseOptional(97)) {
            var forInStatement = createNode2(231, pos);
            forInStatement.initializer = initializer;
            forInStatement.expression = allowInAnd(parseExpression);
            parseExpected(21);
            forOrForInOrForOfStatement = forInStatement;
          } else {
            var forStatement = createNode2(230, pos);
            forStatement.initializer = initializer;
            parseExpected(26);
            if (token() !== 26 && token() !== 21) {
              forStatement.condition = allowInAnd(parseExpression);
            }
            parseExpected(26);
            if (token() !== 21) {
              forStatement.incrementor = allowInAnd(parseExpression);
            }
            parseExpected(21);
            forOrForInOrForOfStatement = forStatement;
          }
          forOrForInOrForOfStatement.statement = parseStatement();
          return finishNode(forOrForInOrForOfStatement);
        }
        function parseBreakOrContinueStatement(kind) {
          var node = createNode2(kind);
          parseExpected(kind === 234 ? 77 : 82);
          if (!canParseSemicolon()) {
            node.label = parseIdentifier();
          }
          parseSemicolon();
          return finishNode(node);
        }
        function parseReturnStatement() {
          var node = createNode2(235);
          parseExpected(101);
          if (!canParseSemicolon()) {
            node.expression = allowInAnd(parseExpression);
          }
          parseSemicolon();
          return finishNode(node);
        }
        function parseWithStatement() {
          var node = createNode2(236);
          parseExpected(112);
          parseExpected(20);
          node.expression = allowInAnd(parseExpression);
          parseExpected(21);
          node.statement = doInsideOfContext(16777216, parseStatement);
          return finishNode(node);
        }
        function parseCaseClause() {
          var node = createNode2(277);
          parseExpected(78);
          node.expression = allowInAnd(parseExpression);
          parseExpected(58);
          node.statements = parseList(3, parseStatement);
          return finishNode(node);
        }
        function parseDefaultClause() {
          var node = createNode2(278);
          parseExpected(84);
          parseExpected(58);
          node.statements = parseList(3, parseStatement);
          return finishNode(node);
        }
        function parseCaseOrDefaultClause() {
          return token() === 78 ? parseCaseClause() : parseDefaultClause();
        }
        function parseSwitchStatement() {
          var node = createNode2(237);
          parseExpected(103);
          parseExpected(20);
          node.expression = allowInAnd(parseExpression);
          parseExpected(21);
          var caseBlock = createNode2(251);
          parseExpected(18);
          caseBlock.clauses = parseList(2, parseCaseOrDefaultClause);
          parseExpected(19);
          node.caseBlock = finishNode(caseBlock);
          return finishNode(node);
        }
        function parseThrowStatement() {
          var node = createNode2(239);
          parseExpected(105);
          node.expression = scanner.hasPrecedingLineBreak() ? void 0 : allowInAnd(parseExpression);
          parseSemicolon();
          return finishNode(node);
        }
        function parseTryStatement() {
          var node = createNode2(240);
          parseExpected(107);
          node.tryBlock = parseBlock(false);
          node.catchClause = token() === 79 ? parseCatchClause() : void 0;
          if (!node.catchClause || token() === 92) {
            parseExpected(92);
            node.finallyBlock = parseBlock(false);
          }
          return finishNode(node);
        }
        function parseCatchClause() {
          var result = createNode2(280);
          parseExpected(79);
          if (parseOptional(20)) {
            result.variableDeclaration = parseVariableDeclaration();
            parseExpected(21);
          } else {
            result.variableDeclaration = void 0;
          }
          result.block = parseBlock(false);
          return finishNode(result);
        }
        function parseDebuggerStatement() {
          var node = createNode2(241);
          parseExpected(83);
          parseSemicolon();
          return finishNode(node);
        }
        function parseExpressionOrLabeledStatement() {
          var node = createNodeWithJSDoc(token() === 75 ? 0 : 226);
          var expression = allowInAnd(parseExpression);
          if (expression.kind === 75 && parseOptional(58)) {
            node.kind = 238;
            node.label = expression;
            node.statement = parseStatement();
          } else {
            node.kind = 226;
            node.expression = expression;
            parseSemicolon();
          }
          return finishNode(node);
        }
        function nextTokenIsIdentifierOrKeywordOnSameLine() {
          nextToken();
          return ts2.tokenIsIdentifierOrKeyword(token()) && !scanner.hasPrecedingLineBreak();
        }
        function nextTokenIsClassKeywordOnSameLine() {
          nextToken();
          return token() === 80 && !scanner.hasPrecedingLineBreak();
        }
        function nextTokenIsFunctionKeywordOnSameLine() {
          nextToken();
          return token() === 94 && !scanner.hasPrecedingLineBreak();
        }
        function nextTokenIsIdentifierOrKeywordOrLiteralOnSameLine() {
          nextToken();
          return (ts2.tokenIsIdentifierOrKeyword(token()) || token() === 8 || token() === 9 || token() === 10) && !scanner.hasPrecedingLineBreak();
        }
        function isDeclaration() {
          while (true) {
            switch (token()) {
              case 109:
              case 115:
              case 81:
              case 94:
              case 80:
              case 88:
                return true;
              case 114:
              case 145:
                return nextTokenIsIdentifierOnSameLine();
              case 135:
              case 136:
                return nextTokenIsIdentifierOrStringLiteralOnSameLine();
              case 122:
              case 126:
              case 130:
              case 117:
              case 118:
              case 119:
              case 138:
                nextToken();
                if (scanner.hasPrecedingLineBreak()) {
                  return false;
                }
                continue;
              case 150:
                nextToken();
                return token() === 18 || token() === 75 || token() === 89;
              case 96:
                nextToken();
                return token() === 10 || token() === 41 || token() === 18 || ts2.tokenIsIdentifierOrKeyword(token());
              case 89:
                var currentToken_1 = nextToken();
                if (currentToken_1 === 145) {
                  currentToken_1 = lookAhead(nextToken);
                }
                if (currentToken_1 === 62 || currentToken_1 === 41 || currentToken_1 === 18 || currentToken_1 === 84 || currentToken_1 === 123) {
                  return true;
                }
                continue;
              case 120:
                nextToken();
                continue;
              default:
                return false;
            }
          }
        }
        function isStartOfDeclaration() {
          return lookAhead(isDeclaration);
        }
        function isStartOfStatement() {
          switch (token()) {
            case 59:
            case 26:
            case 18:
            case 109:
            case 115:
            case 94:
            case 80:
            case 88:
            case 95:
            case 86:
            case 111:
            case 93:
            case 82:
            case 77:
            case 101:
            case 112:
            case 103:
            case 105:
            case 107:
            case 83:
            case 79:
            case 92:
              return true;
            case 96:
              return isStartOfDeclaration() || lookAhead(nextTokenIsOpenParenOrLessThanOrDot);
            case 81:
            case 89:
              return isStartOfDeclaration();
            case 126:
            case 130:
            case 114:
            case 135:
            case 136:
            case 145:
            case 150:
              return true;
            case 119:
            case 117:
            case 118:
            case 120:
            case 138:
              return isStartOfDeclaration() || !lookAhead(nextTokenIsIdentifierOrKeywordOnSameLine);
            default:
              return isStartOfExpression();
          }
        }
        function nextTokenIsIdentifierOrStartOfDestructuring() {
          nextToken();
          return isIdentifier() || token() === 18 || token() === 22;
        }
        function isLetDeclaration() {
          return lookAhead(nextTokenIsIdentifierOrStartOfDestructuring);
        }
        function parseStatement() {
          switch (token()) {
            case 26:
              return parseEmptyStatement();
            case 18:
              return parseBlock(false);
            case 109:
              return parseVariableStatement(createNodeWithJSDoc(242));
            case 115:
              if (isLetDeclaration()) {
                return parseVariableStatement(createNodeWithJSDoc(242));
              }
              break;
            case 94:
              return parseFunctionDeclaration(createNodeWithJSDoc(244));
            case 80:
              return parseClassDeclaration(createNodeWithJSDoc(245));
            case 95:
              return parseIfStatement();
            case 86:
              return parseDoStatement();
            case 111:
              return parseWhileStatement();
            case 93:
              return parseForOrForInOrForOfStatement();
            case 82:
              return parseBreakOrContinueStatement(233);
            case 77:
              return parseBreakOrContinueStatement(234);
            case 101:
              return parseReturnStatement();
            case 112:
              return parseWithStatement();
            case 103:
              return parseSwitchStatement();
            case 105:
              return parseThrowStatement();
            case 107:
            case 79:
            case 92:
              return parseTryStatement();
            case 83:
              return parseDebuggerStatement();
            case 59:
              return parseDeclaration();
            case 126:
            case 114:
            case 145:
            case 135:
            case 136:
            case 130:
            case 81:
            case 88:
            case 89:
            case 96:
            case 117:
            case 118:
            case 119:
            case 122:
            case 120:
            case 138:
            case 150:
              if (isStartOfDeclaration()) {
                return parseDeclaration();
              }
              break;
          }
          return parseExpressionOrLabeledStatement();
        }
        function isDeclareModifier(modifier) {
          return modifier.kind === 130;
        }
        function parseDeclaration() {
          var modifiers = lookAhead(function() {
            return parseDecorators(), parseModifiers();
          });
          var isAmbient = ts2.some(modifiers, isDeclareModifier);
          if (isAmbient) {
            var node_3 = tryReuseAmbientDeclaration();
            if (node_3) {
              return node_3;
            }
          }
          var node = createNodeWithJSDoc(0);
          node.decorators = parseDecorators();
          node.modifiers = parseModifiers();
          if (isAmbient) {
            for (var _i = 0, _a = node.modifiers; _i < _a.length; _i++) {
              var m = _a[_i];
              m.flags |= 8388608;
            }
            return doInsideOfContext(8388608, function() {
              return parseDeclarationWorker(node);
            });
          } else {
            return parseDeclarationWorker(node);
          }
        }
        function tryReuseAmbientDeclaration() {
          return doInsideOfContext(8388608, function() {
            var node = currentNode(parsingContext);
            if (node) {
              return consumeNode(node);
            }
          });
        }
        function parseDeclarationWorker(node) {
          switch (token()) {
            case 109:
            case 115:
            case 81:
              return parseVariableStatement(node);
            case 94:
              return parseFunctionDeclaration(node);
            case 80:
              return parseClassDeclaration(node);
            case 114:
              return parseInterfaceDeclaration(node);
            case 145:
              return parseTypeAliasDeclaration(node);
            case 88:
              return parseEnumDeclaration(node);
            case 150:
            case 135:
            case 136:
              return parseModuleDeclaration(node);
            case 96:
              return parseImportDeclarationOrImportEqualsDeclaration(node);
            case 89:
              nextToken();
              switch (token()) {
                case 84:
                case 62:
                  return parseExportAssignment(node);
                case 123:
                  return parseNamespaceExportDeclaration(node);
                default:
                  return parseExportDeclaration(node);
              }
            default:
              if (node.decorators || node.modifiers) {
                var missing = createMissingNode(264, true, ts2.Diagnostics.Declaration_expected);
                missing.pos = node.pos;
                missing.decorators = node.decorators;
                missing.modifiers = node.modifiers;
                return finishNode(missing);
              }
              return void 0;
          }
        }
        function nextTokenIsIdentifierOrStringLiteralOnSameLine() {
          nextToken();
          return !scanner.hasPrecedingLineBreak() && (isIdentifier() || token() === 10);
        }
        function parseFunctionBlockOrSemicolon(flags, diagnosticMessage) {
          if (token() !== 18 && canParseSemicolon()) {
            parseSemicolon();
            return;
          }
          return parseFunctionBlock(flags, diagnosticMessage);
        }
        function parseArrayBindingElement() {
          if (token() === 27) {
            return createNode2(215);
          }
          var node = createNode2(191);
          node.dotDotDotToken = parseOptionalToken(25);
          node.name = parseIdentifierOrPattern();
          node.initializer = parseInitializer();
          return finishNode(node);
        }
        function parseObjectBindingElement() {
          var node = createNode2(191);
          node.dotDotDotToken = parseOptionalToken(25);
          var tokenIsIdentifier = isIdentifier();
          var propertyName = parsePropertyName();
          if (tokenIsIdentifier && token() !== 58) {
            node.name = propertyName;
          } else {
            parseExpected(58);
            node.propertyName = propertyName;
            node.name = parseIdentifierOrPattern();
          }
          node.initializer = parseInitializer();
          return finishNode(node);
        }
        function parseObjectBindingPattern() {
          var node = createNode2(189);
          parseExpected(18);
          node.elements = parseDelimitedList(9, parseObjectBindingElement);
          parseExpected(19);
          return finishNode(node);
        }
        function parseArrayBindingPattern() {
          var node = createNode2(190);
          parseExpected(22);
          node.elements = parseDelimitedList(10, parseArrayBindingElement);
          parseExpected(23);
          return finishNode(node);
        }
        function isIdentifierOrPrivateIdentifierOrPattern() {
          return token() === 18 || token() === 22 || token() === 76 || isIdentifier();
        }
        function parseIdentifierOrPattern(privateIdentifierDiagnosticMessage) {
          if (token() === 22) {
            return parseArrayBindingPattern();
          }
          if (token() === 18) {
            return parseObjectBindingPattern();
          }
          return parseIdentifier(void 0, privateIdentifierDiagnosticMessage);
        }
        function parseVariableDeclarationAllowExclamation() {
          return parseVariableDeclaration(true);
        }
        function parseVariableDeclaration(allowExclamation) {
          var node = createNode2(242);
          node.name = parseIdentifierOrPattern(ts2.Diagnostics.Private_identifiers_are_not_allowed_in_variable_declarations);
          if (allowExclamation && node.name.kind === 75 && token() === 53 && !scanner.hasPrecedingLineBreak()) {
            node.exclamationToken = parseTokenNode();
          }
          node.type = parseTypeAnnotation();
          if (!isInOrOfKeyword(token())) {
            node.initializer = parseInitializer();
          }
          return finishNode(node);
        }
        function parseVariableDeclarationList(inForStatementInitializer) {
          var node = createNode2(243);
          switch (token()) {
            case 109:
              break;
            case 115:
              node.flags |= 1;
              break;
            case 81:
              node.flags |= 2;
              break;
            default:
              ts2.Debug.fail();
          }
          nextToken();
          if (token() === 152 && lookAhead(canFollowContextualOfKeyword)) {
            node.declarations = createMissingList();
          } else {
            var savedDisallowIn = inDisallowInContext();
            setDisallowInContext(inForStatementInitializer);
            node.declarations = parseDelimitedList(8, inForStatementInitializer ? parseVariableDeclaration : parseVariableDeclarationAllowExclamation);
            setDisallowInContext(savedDisallowIn);
          }
          return finishNode(node);
        }
        function canFollowContextualOfKeyword() {
          return nextTokenIsIdentifier() && nextToken() === 21;
        }
        function parseVariableStatement(node) {
          node.kind = 225;
          node.declarationList = parseVariableDeclarationList(false);
          parseSemicolon();
          return finishNode(node);
        }
        function parseFunctionDeclaration(node) {
          node.kind = 244;
          parseExpected(94);
          node.asteriskToken = parseOptionalToken(41);
          node.name = hasModifierOfKind(node, 84) ? parseOptionalIdentifier() : parseIdentifier();
          var isGenerator = node.asteriskToken ? 1 : 0;
          var isAsync = hasModifierOfKind(node, 126) ? 2 : 0;
          fillSignature(58, isGenerator | isAsync, node);
          node.body = parseFunctionBlockOrSemicolon(isGenerator | isAsync, ts2.Diagnostics.or_expected);
          return finishNode(node);
        }
        function parseConstructorName() {
          if (token() === 129) {
            return parseExpected(129);
          }
          if (token() === 10 && lookAhead(nextToken) === 20) {
            return tryParse(function() {
              var literalNode = parseLiteralNode();
              return literalNode.text === "constructor" ? literalNode : void 0;
            });
          }
        }
        function tryParseConstructorDeclaration(node) {
          return tryParse(function() {
            if (parseConstructorName()) {
              node.kind = 162;
              fillSignature(58, 0, node);
              node.body = parseFunctionBlockOrSemicolon(0, ts2.Diagnostics.or_expected);
              return finishNode(node);
            }
          });
        }
        function parseMethodDeclaration(node, asteriskToken, diagnosticMessage) {
          node.kind = 161;
          node.asteriskToken = asteriskToken;
          var isGenerator = asteriskToken ? 1 : 0;
          var isAsync = hasModifierOfKind(node, 126) ? 2 : 0;
          fillSignature(58, isGenerator | isAsync, node);
          node.body = parseFunctionBlockOrSemicolon(isGenerator | isAsync, diagnosticMessage);
          return finishNode(node);
        }
        function parsePropertyDeclaration(node) {
          node.kind = 159;
          if (!node.questionToken && token() === 53 && !scanner.hasPrecedingLineBreak()) {
            node.exclamationToken = parseTokenNode();
          }
          node.type = parseTypeAnnotation();
          node.initializer = doOutsideOfContext(8192 | 32768 | 4096, parseInitializer);
          parseSemicolon();
          return finishNode(node);
        }
        function parsePropertyOrMethodDeclaration(node) {
          var asteriskToken = parseOptionalToken(41);
          node.name = parsePropertyName();
          node.questionToken = parseOptionalToken(57);
          if (asteriskToken || token() === 20 || token() === 29) {
            return parseMethodDeclaration(node, asteriskToken, ts2.Diagnostics.or_expected);
          }
          return parsePropertyDeclaration(node);
        }
        function parseAccessorDeclaration(node, kind) {
          node.kind = kind;
          node.name = parsePropertyName();
          fillSignature(58, 0, node);
          node.body = parseFunctionBlockOrSemicolon(0);
          return finishNode(node);
        }
        function isClassMemberStart() {
          var idToken;
          if (token() === 59) {
            return true;
          }
          while (ts2.isModifierKind(token())) {
            idToken = token();
            if (ts2.isClassMemberModifier(idToken)) {
              return true;
            }
            nextToken();
          }
          if (token() === 41) {
            return true;
          }
          if (isLiteralPropertyName()) {
            idToken = token();
            nextToken();
          }
          if (token() === 22) {
            return true;
          }
          if (idToken !== void 0) {
            if (!ts2.isKeyword(idToken) || idToken === 142 || idToken === 131) {
              return true;
            }
            switch (token()) {
              case 20:
              case 29:
              case 53:
              case 58:
              case 62:
              case 57:
                return true;
              default:
                return canParseSemicolon();
            }
          }
          return false;
        }
        function parseDecorators() {
          var list;
          var listPos = getNodePos();
          while (true) {
            var decoratorStart = getNodePos();
            if (!parseOptional(59)) {
              break;
            }
            var decorator = createNode2(157, decoratorStart);
            decorator.expression = doInDecoratorContext(parseLeftHandSideExpressionOrHigher);
            finishNode(decorator);
            (list || (list = [])).push(decorator);
          }
          return list && createNodeArray(list, listPos);
        }
        function parseModifiers(permitInvalidConstAsModifier) {
          var list;
          var listPos = getNodePos();
          while (true) {
            var modifierStart = scanner.getStartPos();
            var modifierKind = token();
            if (token() === 81 && permitInvalidConstAsModifier) {
              if (!tryParse(nextTokenIsOnSameLineAndCanFollowModifier)) {
                break;
              }
            } else {
              if (!parseAnyContextualModifier()) {
                break;
              }
            }
            var modifier = finishNode(createNode2(modifierKind, modifierStart));
            (list || (list = [])).push(modifier);
          }
          return list && createNodeArray(list, listPos);
        }
        function parseModifiersForArrowFunction() {
          var modifiers;
          if (token() === 126) {
            var modifierStart = scanner.getStartPos();
            var modifierKind = token();
            nextToken();
            var modifier = finishNode(createNode2(modifierKind, modifierStart));
            modifiers = createNodeArray([modifier], modifierStart);
          }
          return modifiers;
        }
        function parseClassElement() {
          if (token() === 26) {
            var result = createNode2(222);
            nextToken();
            return finishNode(result);
          }
          var node = createNodeWithJSDoc(0);
          node.decorators = parseDecorators();
          node.modifiers = parseModifiers(true);
          if (parseContextualModifier(131)) {
            return parseAccessorDeclaration(node, 163);
          }
          if (parseContextualModifier(142)) {
            return parseAccessorDeclaration(node, 164);
          }
          if (token() === 129 || token() === 10) {
            var constructorDeclaration = tryParseConstructorDeclaration(node);
            if (constructorDeclaration) {
              return constructorDeclaration;
            }
          }
          if (isIndexSignature()) {
            return parseIndexSignatureDeclaration(node);
          }
          if (ts2.tokenIsIdentifierOrKeyword(token()) || token() === 10 || token() === 8 || token() === 41 || token() === 22) {
            var isAmbient = node.modifiers && ts2.some(node.modifiers, isDeclareModifier);
            if (isAmbient) {
              for (var _i = 0, _a = node.modifiers; _i < _a.length; _i++) {
                var m = _a[_i];
                m.flags |= 8388608;
              }
              return doInsideOfContext(8388608, function() {
                return parsePropertyOrMethodDeclaration(node);
              });
            } else {
              return parsePropertyOrMethodDeclaration(node);
            }
          }
          if (node.decorators || node.modifiers) {
            node.name = createMissingNode(75, true, ts2.Diagnostics.Declaration_expected);
            return parsePropertyDeclaration(node);
          }
          return ts2.Debug.fail("Should not have attempted to parse class member declaration.");
        }
        function parseClassExpression() {
          return parseClassDeclarationOrExpression(createNodeWithJSDoc(0), 214);
        }
        function parseClassDeclaration(node) {
          return parseClassDeclarationOrExpression(node, 245);
        }
        function parseClassDeclarationOrExpression(node, kind) {
          node.kind = kind;
          parseExpected(80);
          node.name = parseNameOfClassDeclarationOrExpression();
          node.typeParameters = parseTypeParameters();
          node.heritageClauses = parseHeritageClauses();
          if (parseExpected(18)) {
            node.members = parseClassMembers();
            parseExpected(19);
          } else {
            node.members = createMissingList();
          }
          return finishNode(node);
        }
        function parseNameOfClassDeclarationOrExpression() {
          return isIdentifier() && !isImplementsClause() ? parseIdentifier() : void 0;
        }
        function isImplementsClause() {
          return token() === 113 && lookAhead(nextTokenIsIdentifierOrKeyword);
        }
        function parseHeritageClauses() {
          if (isHeritageClause()) {
            return parseList(22, parseHeritageClause);
          }
          return void 0;
        }
        function parseHeritageClause() {
          var tok = token();
          ts2.Debug.assert(tok === 90 || tok === 113);
          var node = createNode2(279);
          node.token = tok;
          nextToken();
          node.types = parseDelimitedList(7, parseExpressionWithTypeArguments);
          return finishNode(node);
        }
        function parseExpressionWithTypeArguments() {
          var node = createNode2(216);
          node.expression = parseLeftHandSideExpressionOrHigher();
          node.typeArguments = tryParseTypeArguments();
          return finishNode(node);
        }
        function tryParseTypeArguments() {
          return token() === 29 ? parseBracketedList(20, parseType, 29, 31) : void 0;
        }
        function isHeritageClause() {
          return token() === 90 || token() === 113;
        }
        function parseClassMembers() {
          return parseList(5, parseClassElement);
        }
        function parseInterfaceDeclaration(node) {
          node.kind = 246;
          parseExpected(114);
          node.name = parseIdentifier();
          node.typeParameters = parseTypeParameters();
          node.heritageClauses = parseHeritageClauses();
          node.members = parseObjectTypeMembers();
          return finishNode(node);
        }
        function parseTypeAliasDeclaration(node) {
          node.kind = 247;
          parseExpected(145);
          node.name = parseIdentifier();
          node.typeParameters = parseTypeParameters();
          parseExpected(62);
          node.type = parseType();
          parseSemicolon();
          return finishNode(node);
        }
        function parseEnumMember() {
          var node = createNodeWithJSDoc(284);
          node.name = parsePropertyName();
          node.initializer = allowInAnd(parseInitializer);
          return finishNode(node);
        }
        function parseEnumDeclaration(node) {
          node.kind = 248;
          parseExpected(88);
          node.name = parseIdentifier();
          if (parseExpected(18)) {
            node.members = doOutsideOfYieldAndAwaitContext(function() {
              return parseDelimitedList(6, parseEnumMember);
            });
            parseExpected(19);
          } else {
            node.members = createMissingList();
          }
          return finishNode(node);
        }
        function parseModuleBlock() {
          var node = createNode2(250);
          if (parseExpected(18)) {
            node.statements = parseList(1, parseStatement);
            parseExpected(19);
          } else {
            node.statements = createMissingList();
          }
          return finishNode(node);
        }
        function parseModuleOrNamespaceDeclaration(node, flags) {
          node.kind = 249;
          var namespaceFlag = flags & 16;
          node.flags |= flags;
          node.name = parseIdentifier();
          node.body = parseOptional(24) ? parseModuleOrNamespaceDeclaration(createNode2(0), 4 | namespaceFlag) : parseModuleBlock();
          return finishNode(node);
        }
        function parseAmbientExternalModuleDeclaration(node) {
          node.kind = 249;
          if (token() === 150) {
            node.name = parseIdentifier();
            node.flags |= 1024;
          } else {
            node.name = parseLiteralNode();
            node.name.text = internIdentifier(node.name.text);
          }
          if (token() === 18) {
            node.body = parseModuleBlock();
          } else {
            parseSemicolon();
          }
          return finishNode(node);
        }
        function parseModuleDeclaration(node) {
          var flags = 0;
          if (token() === 150) {
            return parseAmbientExternalModuleDeclaration(node);
          } else if (parseOptional(136)) {
            flags |= 16;
          } else {
            parseExpected(135);
            if (token() === 10) {
              return parseAmbientExternalModuleDeclaration(node);
            }
          }
          return parseModuleOrNamespaceDeclaration(node, flags);
        }
        function isExternalModuleReference() {
          return token() === 139 && lookAhead(nextTokenIsOpenParen);
        }
        function nextTokenIsOpenParen() {
          return nextToken() === 20;
        }
        function nextTokenIsSlash() {
          return nextToken() === 43;
        }
        function parseNamespaceExportDeclaration(node) {
          node.kind = 252;
          parseExpected(123);
          parseExpected(136);
          node.name = parseIdentifier();
          parseSemicolon();
          return finishNode(node);
        }
        function parseImportDeclarationOrImportEqualsDeclaration(node) {
          parseExpected(96);
          var afterImportPos = scanner.getStartPos();
          var identifier;
          if (isIdentifier()) {
            identifier = parseIdentifier();
          }
          var isTypeOnly = false;
          if (token() !== 149 && (identifier === null || identifier === void 0 ? void 0 : identifier.escapedText) === "type" && (isIdentifier() || tokenAfterImportDefinitelyProducesImportDeclaration())) {
            isTypeOnly = true;
            identifier = isIdentifier() ? parseIdentifier() : void 0;
          }
          if (identifier && !tokenAfterImportedIdentifierDefinitelyProducesImportDeclaration()) {
            return parseImportEqualsDeclaration(node, identifier, isTypeOnly);
          }
          node.kind = 254;
          if (identifier || token() === 41 || token() === 18) {
            node.importClause = parseImportClause(identifier, afterImportPos, isTypeOnly);
            parseExpected(149);
          }
          node.moduleSpecifier = parseModuleSpecifier();
          parseSemicolon();
          return finishNode(node);
        }
        function tokenAfterImportDefinitelyProducesImportDeclaration() {
          return token() === 41 || token() === 18;
        }
        function tokenAfterImportedIdentifierDefinitelyProducesImportDeclaration() {
          return token() === 27 || token() === 149;
        }
        function parseImportEqualsDeclaration(node, identifier, isTypeOnly) {
          node.kind = 253;
          node.name = identifier;
          parseExpected(62);
          node.moduleReference = parseModuleReference();
          parseSemicolon();
          var finished = finishNode(node);
          if (isTypeOnly) {
            parseErrorAtRange(finished, ts2.Diagnostics.Only_ECMAScript_imports_may_use_import_type);
          }
          return finished;
        }
        function parseImportClause(identifier, fullStart, isTypeOnly) {
          var importClause = createNode2(255, fullStart);
          importClause.isTypeOnly = isTypeOnly;
          if (identifier) {
            importClause.name = identifier;
          }
          if (!importClause.name || parseOptional(27)) {
            importClause.namedBindings = token() === 41 ? parseNamespaceImport() : parseNamedImportsOrExports(257);
          }
          return finishNode(importClause);
        }
        function parseModuleReference() {
          return isExternalModuleReference() ? parseExternalModuleReference() : parseEntityName(false);
        }
        function parseExternalModuleReference() {
          var node = createNode2(265);
          parseExpected(139);
          parseExpected(20);
          node.expression = parseModuleSpecifier();
          parseExpected(21);
          return finishNode(node);
        }
        function parseModuleSpecifier() {
          if (token() === 10) {
            var result = parseLiteralNode();
            result.text = internIdentifier(result.text);
            return result;
          } else {
            return parseExpression();
          }
        }
        function parseNamespaceImport() {
          var namespaceImport = createNode2(256);
          parseExpected(41);
          parseExpected(123);
          namespaceImport.name = parseIdentifier();
          return finishNode(namespaceImport);
        }
        function parseNamedImportsOrExports(kind) {
          var node = createNode2(kind);
          node.elements = parseBracketedList(23, kind === 257 ? parseImportSpecifier : parseExportSpecifier, 18, 19);
          return finishNode(node);
        }
        function parseExportSpecifier() {
          return parseImportOrExportSpecifier(263);
        }
        function parseImportSpecifier() {
          return parseImportOrExportSpecifier(258);
        }
        function parseImportOrExportSpecifier(kind) {
          var node = createNode2(kind);
          var checkIdentifierIsKeyword = ts2.isKeyword(token()) && !isIdentifier();
          var checkIdentifierStart = scanner.getTokenPos();
          var checkIdentifierEnd = scanner.getTextPos();
          var identifierName = parseIdentifierName();
          if (token() === 123) {
            node.propertyName = identifierName;
            parseExpected(123);
            checkIdentifierIsKeyword = ts2.isKeyword(token()) && !isIdentifier();
            checkIdentifierStart = scanner.getTokenPos();
            checkIdentifierEnd = scanner.getTextPos();
            node.name = parseIdentifierName();
          } else {
            node.name = identifierName;
          }
          if (kind === 258 && checkIdentifierIsKeyword) {
            parseErrorAt(checkIdentifierStart, checkIdentifierEnd, ts2.Diagnostics.Identifier_expected);
          }
          return finishNode(node);
        }
        function parseNamespaceExport(pos) {
          var node = createNode2(262, pos);
          node.name = parseIdentifier();
          return finishNode(node);
        }
        function parseExportDeclaration(node) {
          node.kind = 260;
          node.isTypeOnly = parseOptional(145);
          var namespaceExportPos = scanner.getStartPos();
          if (parseOptional(41)) {
            if (parseOptional(123)) {
              node.exportClause = parseNamespaceExport(namespaceExportPos);
            }
            parseExpected(149);
            node.moduleSpecifier = parseModuleSpecifier();
          } else {
            node.exportClause = parseNamedImportsOrExports(261);
            if (token() === 149 || token() === 10 && !scanner.hasPrecedingLineBreak()) {
              parseExpected(149);
              node.moduleSpecifier = parseModuleSpecifier();
            }
          }
          parseSemicolon();
          return finishNode(node);
        }
        function parseExportAssignment(node) {
          node.kind = 259;
          if (parseOptional(62)) {
            node.isExportEquals = true;
          } else {
            parseExpected(84);
          }
          node.expression = parseAssignmentExpressionOrHigher();
          parseSemicolon();
          return finishNode(node);
        }
        function setExternalModuleIndicator(sourceFile2) {
          sourceFile2.externalModuleIndicator = ts2.forEach(sourceFile2.statements, isAnExternalModuleIndicatorNode) || getImportMetaIfNecessary(sourceFile2);
        }
        function isAnExternalModuleIndicatorNode(node) {
          return hasModifierOfKind(node, 89) || node.kind === 253 && node.moduleReference.kind === 265 || node.kind === 254 || node.kind === 259 || node.kind === 260 ? node : void 0;
        }
        function getImportMetaIfNecessary(sourceFile2) {
          return sourceFile2.flags & 2097152 ? walkTreeForExternalModuleIndicators(sourceFile2) : void 0;
        }
        function walkTreeForExternalModuleIndicators(node) {
          return isImportMeta(node) ? node : forEachChild(node, walkTreeForExternalModuleIndicators);
        }
        function hasModifierOfKind(node, kind) {
          return ts2.some(node.modifiers, function(m) {
            return m.kind === kind;
          });
        }
        function isImportMeta(node) {
          return ts2.isMetaProperty(node) && node.keywordToken === 96 && node.name.escapedText === "meta";
        }
        var ParsingContext;
        (function(ParsingContext2) {
          ParsingContext2[ParsingContext2["SourceElements"] = 0] = "SourceElements";
          ParsingContext2[ParsingContext2["BlockStatements"] = 1] = "BlockStatements";
          ParsingContext2[ParsingContext2["SwitchClauses"] = 2] = "SwitchClauses";
          ParsingContext2[ParsingContext2["SwitchClauseStatements"] = 3] = "SwitchClauseStatements";
          ParsingContext2[ParsingContext2["TypeMembers"] = 4] = "TypeMembers";
          ParsingContext2[ParsingContext2["ClassMembers"] = 5] = "ClassMembers";
          ParsingContext2[ParsingContext2["EnumMembers"] = 6] = "EnumMembers";
          ParsingContext2[ParsingContext2["HeritageClauseElement"] = 7] = "HeritageClauseElement";
          ParsingContext2[ParsingContext2["VariableDeclarations"] = 8] = "VariableDeclarations";
          ParsingContext2[ParsingContext2["ObjectBindingElements"] = 9] = "ObjectBindingElements";
          ParsingContext2[ParsingContext2["ArrayBindingElements"] = 10] = "ArrayBindingElements";
          ParsingContext2[ParsingContext2["ArgumentExpressions"] = 11] = "ArgumentExpressions";
          ParsingContext2[ParsingContext2["ObjectLiteralMembers"] = 12] = "ObjectLiteralMembers";
          ParsingContext2[ParsingContext2["JsxAttributes"] = 13] = "JsxAttributes";
          ParsingContext2[ParsingContext2["JsxChildren"] = 14] = "JsxChildren";
          ParsingContext2[ParsingContext2["ArrayLiteralMembers"] = 15] = "ArrayLiteralMembers";
          ParsingContext2[ParsingContext2["Parameters"] = 16] = "Parameters";
          ParsingContext2[ParsingContext2["JSDocParameters"] = 17] = "JSDocParameters";
          ParsingContext2[ParsingContext2["RestProperties"] = 18] = "RestProperties";
          ParsingContext2[ParsingContext2["TypeParameters"] = 19] = "TypeParameters";
          ParsingContext2[ParsingContext2["TypeArguments"] = 20] = "TypeArguments";
          ParsingContext2[ParsingContext2["TupleElementTypes"] = 21] = "TupleElementTypes";
          ParsingContext2[ParsingContext2["HeritageClauses"] = 22] = "HeritageClauses";
          ParsingContext2[ParsingContext2["ImportOrExportSpecifiers"] = 23] = "ImportOrExportSpecifiers";
          ParsingContext2[ParsingContext2["Count"] = 24] = "Count";
        })(ParsingContext || (ParsingContext = {}));
        var Tristate;
        (function(Tristate2) {
          Tristate2[Tristate2["False"] = 0] = "False";
          Tristate2[Tristate2["True"] = 1] = "True";
          Tristate2[Tristate2["Unknown"] = 2] = "Unknown";
        })(Tristate || (Tristate = {}));
        var JSDocParser;
        (function(JSDocParser2) {
          function parseJSDocTypeExpressionForTests2(content, start, length) {
            initializeState(content, 99, void 0, 1);
            sourceFile = createSourceFile2("file.js", 99, 1, false);
            scanner.setText(content, start, length);
            currentToken = scanner.scan();
            var jsDocTypeExpression = parseJSDocTypeExpression();
            var diagnostics = parseDiagnostics;
            clearState();
            return jsDocTypeExpression ? { jsDocTypeExpression, diagnostics } : void 0;
          }
          JSDocParser2.parseJSDocTypeExpressionForTests = parseJSDocTypeExpressionForTests2;
          function parseJSDocTypeExpression(mayOmitBraces) {
            var result = createNode2(294);
            var hasBrace = (mayOmitBraces ? parseOptional : parseExpected)(18);
            result.type = doInsideOfContext(4194304, parseJSDocType);
            if (!mayOmitBraces || hasBrace) {
              parseExpectedJSDoc(19);
            }
            fixupParentReferences(result);
            return finishNode(result);
          }
          JSDocParser2.parseJSDocTypeExpression = parseJSDocTypeExpression;
          function parseIsolatedJSDocComment2(content, start, length) {
            initializeState(content, 99, void 0, 1);
            sourceFile = { languageVariant: 0, text: content };
            var jsDoc = doInsideOfContext(4194304, function() {
              return parseJSDocCommentWorker(start, length);
            });
            var diagnostics = parseDiagnostics;
            clearState();
            return jsDoc ? { jsDoc, diagnostics } : void 0;
          }
          JSDocParser2.parseIsolatedJSDocComment = parseIsolatedJSDocComment2;
          function parseJSDocComment(parent, start, length) {
            var _a;
            var saveToken = currentToken;
            var saveParseDiagnosticsLength = parseDiagnostics.length;
            var saveParseErrorBeforeNextFinishedNode = parseErrorBeforeNextFinishedNode;
            var comment = doInsideOfContext(4194304, function() {
              return parseJSDocCommentWorker(start, length);
            });
            if (comment) {
              comment.parent = parent;
            }
            if (contextFlags & 131072) {
              if (!sourceFile.jsDocDiagnostics) {
                sourceFile.jsDocDiagnostics = [];
              }
              (_a = sourceFile.jsDocDiagnostics).push.apply(_a, parseDiagnostics);
            }
            currentToken = saveToken;
            parseDiagnostics.length = saveParseDiagnosticsLength;
            parseErrorBeforeNextFinishedNode = saveParseErrorBeforeNextFinishedNode;
            return comment;
          }
          JSDocParser2.parseJSDocComment = parseJSDocComment;
          var JSDocState;
          (function(JSDocState2) {
            JSDocState2[JSDocState2["BeginningOfLine"] = 0] = "BeginningOfLine";
            JSDocState2[JSDocState2["SawAsterisk"] = 1] = "SawAsterisk";
            JSDocState2[JSDocState2["SavingComments"] = 2] = "SavingComments";
            JSDocState2[JSDocState2["SavingBackticks"] = 3] = "SavingBackticks";
          })(JSDocState || (JSDocState = {}));
          var PropertyLikeParse;
          (function(PropertyLikeParse2) {
            PropertyLikeParse2[PropertyLikeParse2["Property"] = 1] = "Property";
            PropertyLikeParse2[PropertyLikeParse2["Parameter"] = 2] = "Parameter";
            PropertyLikeParse2[PropertyLikeParse2["CallbackParameter"] = 4] = "CallbackParameter";
          })(PropertyLikeParse || (PropertyLikeParse = {}));
          function parseJSDocCommentWorker(start, length) {
            if (start === void 0) {
              start = 0;
            }
            var content = sourceText;
            var end = length === void 0 ? content.length : start + length;
            length = end - start;
            ts2.Debug.assert(start >= 0);
            ts2.Debug.assert(start <= end);
            ts2.Debug.assert(end <= content.length);
            if (!isJSDocLikeText(content, start)) {
              return void 0;
            }
            var tags;
            var tagsPos;
            var tagsEnd;
            var comments = [];
            return scanner.scanRange(start + 3, length - 5, function() {
              var state = 1;
              var margin;
              var indent = start - Math.max(content.lastIndexOf("\n", start), 0) + 4;
              function pushComment(text) {
                if (!margin) {
                  margin = indent;
                }
                comments.push(text);
                indent += text.length;
              }
              nextTokenJSDoc();
              while (parseOptionalJsdoc(5))
                ;
              if (parseOptionalJsdoc(4)) {
                state = 0;
                indent = 0;
              }
              loop:
                while (true) {
                  switch (token()) {
                    case 59:
                      if (state === 0 || state === 1) {
                        removeTrailingWhitespace(comments);
                        addTag(parseTag(indent));
                        state = 0;
                        margin = void 0;
                      } else {
                        pushComment(scanner.getTokenText());
                      }
                      break;
                    case 4:
                      comments.push(scanner.getTokenText());
                      state = 0;
                      indent = 0;
                      break;
                    case 41:
                      var asterisk = scanner.getTokenText();
                      if (state === 1 || state === 2) {
                        state = 2;
                        pushComment(asterisk);
                      } else {
                        state = 1;
                        indent += asterisk.length;
                      }
                      break;
                    case 5:
                      var whitespace = scanner.getTokenText();
                      if (state === 2) {
                        comments.push(whitespace);
                      } else if (margin !== void 0 && indent + whitespace.length > margin) {
                        comments.push(whitespace.slice(margin - indent - 1));
                      }
                      indent += whitespace.length;
                      break;
                    case 1:
                      break loop;
                    default:
                      state = 2;
                      pushComment(scanner.getTokenText());
                      break;
                  }
                  nextTokenJSDoc();
                }
              removeLeadingNewlines(comments);
              removeTrailingWhitespace(comments);
              return createJSDocComment();
            });
            function removeLeadingNewlines(comments2) {
              while (comments2.length && (comments2[0] === "\n" || comments2[0] === "\r")) {
                comments2.shift();
              }
            }
            function removeTrailingWhitespace(comments2) {
              while (comments2.length && comments2[comments2.length - 1].trim() === "") {
                comments2.pop();
              }
            }
            function createJSDocComment() {
              var result = createNode2(303, start);
              result.tags = tags && createNodeArray(tags, tagsPos, tagsEnd);
              result.comment = comments.length ? comments.join("") : void 0;
              return finishNode(result, end);
            }
            function isNextNonwhitespaceTokenEndOfFile() {
              while (true) {
                nextTokenJSDoc();
                if (token() === 1) {
                  return true;
                }
                if (!(token() === 5 || token() === 4)) {
                  return false;
                }
              }
            }
            function skipWhitespace() {
              if (token() === 5 || token() === 4) {
                if (lookAhead(isNextNonwhitespaceTokenEndOfFile)) {
                  return;
                }
              }
              while (token() === 5 || token() === 4) {
                nextTokenJSDoc();
              }
            }
            function skipWhitespaceOrAsterisk() {
              if (token() === 5 || token() === 4) {
                if (lookAhead(isNextNonwhitespaceTokenEndOfFile)) {
                  return "";
                }
              }
              var precedingLineBreak = scanner.hasPrecedingLineBreak();
              var seenLineBreak = false;
              var indentText = "";
              while (precedingLineBreak && token() === 41 || token() === 5 || token() === 4) {
                indentText += scanner.getTokenText();
                if (token() === 4) {
                  precedingLineBreak = true;
                  seenLineBreak = true;
                  indentText = "";
                } else if (token() === 41) {
                  precedingLineBreak = false;
                }
                nextTokenJSDoc();
              }
              return seenLineBreak ? indentText : "";
            }
            function parseTag(margin) {
              ts2.Debug.assert(token() === 59);
              var start2 = scanner.getTokenPos();
              nextTokenJSDoc();
              var tagName = parseJSDocIdentifierName(void 0);
              var indentText = skipWhitespaceOrAsterisk();
              var tag;
              switch (tagName.escapedText) {
                case "author":
                  tag = parseAuthorTag(start2, tagName, margin);
                  break;
                case "implements":
                  tag = parseImplementsTag(start2, tagName);
                  break;
                case "augments":
                case "extends":
                  tag = parseAugmentsTag(start2, tagName);
                  break;
                case "class":
                case "constructor":
                  tag = parseSimpleTag(start2, 310, tagName);
                  break;
                case "public":
                  tag = parseSimpleTag(start2, 311, tagName);
                  break;
                case "private":
                  tag = parseSimpleTag(start2, 312, tagName);
                  break;
                case "protected":
                  tag = parseSimpleTag(start2, 313, tagName);
                  break;
                case "readonly":
                  tag = parseSimpleTag(start2, 314, tagName);
                  break;
                case "this":
                  tag = parseThisTag(start2, tagName);
                  break;
                case "enum":
                  tag = parseEnumTag(start2, tagName);
                  break;
                case "arg":
                case "argument":
                case "param":
                  return parseParameterOrPropertyTag(start2, tagName, 2, margin);
                case "return":
                case "returns":
                  tag = parseReturnTag(start2, tagName);
                  break;
                case "template":
                  tag = parseTemplateTag(start2, tagName);
                  break;
                case "type":
                  tag = parseTypeTag(start2, tagName);
                  break;
                case "typedef":
                  tag = parseTypedefTag(start2, tagName, margin);
                  break;
                case "callback":
                  tag = parseCallbackTag(start2, tagName, margin);
                  break;
                default:
                  tag = parseUnknownTag(start2, tagName);
                  break;
              }
              if (!tag.comment) {
                if (!indentText) {
                  margin += tag.end - tag.pos;
                }
                tag.comment = parseTagComments(margin, indentText.slice(margin));
              }
              return tag;
            }
            function parseTagComments(indent, initialMargin) {
              var comments2 = [];
              var state = 0;
              var margin;
              function pushComment(text) {
                if (!margin) {
                  margin = indent;
                }
                comments2.push(text);
                indent += text.length;
              }
              if (initialMargin !== void 0) {
                if (initialMargin !== "") {
                  pushComment(initialMargin);
                }
                state = 1;
              }
              var tok = token();
              loop:
                while (true) {
                  switch (tok) {
                    case 4:
                      if (state >= 1) {
                        state = 0;
                        comments2.push(scanner.getTokenText());
                      }
                      indent = 0;
                      break;
                    case 59:
                      if (state === 3) {
                        comments2.push(scanner.getTokenText());
                        break;
                      }
                      scanner.setTextPos(scanner.getTextPos() - 1);
                    case 1:
                      break loop;
                    case 5:
                      if (state === 2 || state === 3) {
                        pushComment(scanner.getTokenText());
                      } else {
                        var whitespace = scanner.getTokenText();
                        if (margin !== void 0 && indent + whitespace.length > margin) {
                          comments2.push(whitespace.slice(margin - indent));
                        }
                        indent += whitespace.length;
                      }
                      break;
                    case 18:
                      state = 2;
                      if (lookAhead(function() {
                        return nextTokenJSDoc() === 59 && ts2.tokenIsIdentifierOrKeyword(nextTokenJSDoc()) && scanner.getTokenText() === "link";
                      })) {
                        pushComment(scanner.getTokenText());
                        nextTokenJSDoc();
                        pushComment(scanner.getTokenText());
                        nextTokenJSDoc();
                      }
                      pushComment(scanner.getTokenText());
                      break;
                    case 61:
                      if (state === 3) {
                        state = 2;
                      } else {
                        state = 3;
                      }
                      pushComment(scanner.getTokenText());
                      break;
                    case 41:
                      if (state === 0) {
                        state = 1;
                        indent += 1;
                        break;
                      }
                    default:
                      if (state !== 3) {
                        state = 2;
                      }
                      pushComment(scanner.getTokenText());
                      break;
                  }
                  tok = nextTokenJSDoc();
                }
              removeLeadingNewlines(comments2);
              removeTrailingWhitespace(comments2);
              return comments2.length === 0 ? void 0 : comments2.join("");
            }
            function parseUnknownTag(start2, tagName) {
              var result = createNode2(306, start2);
              result.tagName = tagName;
              return finishNode(result);
            }
            function addTag(tag) {
              if (!tag) {
                return;
              }
              if (!tags) {
                tags = [tag];
                tagsPos = tag.pos;
              } else {
                tags.push(tag);
              }
              tagsEnd = tag.end;
            }
            function tryParseTypeExpression() {
              skipWhitespaceOrAsterisk();
              return token() === 18 ? parseJSDocTypeExpression() : void 0;
            }
            function parseBracketNameInPropertyAndParamTag() {
              var isBracketed = parseOptionalJsdoc(22);
              if (isBracketed) {
                skipWhitespace();
              }
              var isBackquoted = parseOptionalJsdoc(61);
              var name = parseJSDocEntityName();
              if (isBackquoted) {
                parseExpectedTokenJSDoc(61);
              }
              if (isBracketed) {
                skipWhitespace();
                if (parseOptionalToken(62)) {
                  parseExpression();
                }
                parseExpected(23);
              }
              return { name, isBracketed };
            }
            function isObjectOrObjectArrayTypeReference(node) {
              switch (node.kind) {
                case 141:
                  return true;
                case 174:
                  return isObjectOrObjectArrayTypeReference(node.elementType);
                default:
                  return ts2.isTypeReferenceNode(node) && ts2.isIdentifier(node.typeName) && node.typeName.escapedText === "Object" && !node.typeArguments;
              }
            }
            function parseParameterOrPropertyTag(start2, tagName, target, indent) {
              var typeExpression = tryParseTypeExpression();
              var isNameFirst = !typeExpression;
              skipWhitespaceOrAsterisk();
              var _a = parseBracketNameInPropertyAndParamTag(), name = _a.name, isBracketed = _a.isBracketed;
              skipWhitespace();
              if (isNameFirst) {
                typeExpression = tryParseTypeExpression();
              }
              var result = target === 1 ? createNode2(323, start2) : createNode2(317, start2);
              var comment = parseTagComments(indent + scanner.getStartPos() - start2);
              var nestedTypeLiteral = target !== 4 && parseNestedTypeLiteral(typeExpression, name, target, indent);
              if (nestedTypeLiteral) {
                typeExpression = nestedTypeLiteral;
                isNameFirst = true;
              }
              result.tagName = tagName;
              result.typeExpression = typeExpression;
              result.name = name;
              result.isNameFirst = isNameFirst;
              result.isBracketed = isBracketed;
              result.comment = comment;
              return finishNode(result);
            }
            function parseNestedTypeLiteral(typeExpression, name, target, indent) {
              if (typeExpression && isObjectOrObjectArrayTypeReference(typeExpression.type)) {
                var typeLiteralExpression = createNode2(294, scanner.getTokenPos());
                var child = void 0;
                var jsdocTypeLiteral = void 0;
                var start_3 = scanner.getStartPos();
                var children = void 0;
                while (child = tryParse(function() {
                  return parseChildParameterOrPropertyTag(target, indent, name);
                })) {
                  if (child.kind === 317 || child.kind === 323) {
                    children = ts2.append(children, child);
                  }
                }
                if (children) {
                  jsdocTypeLiteral = createNode2(304, start_3);
                  jsdocTypeLiteral.jsDocPropertyTags = children;
                  if (typeExpression.type.kind === 174) {
                    jsdocTypeLiteral.isArrayType = true;
                  }
                  typeLiteralExpression.type = finishNode(jsdocTypeLiteral);
                  return finishNode(typeLiteralExpression);
                }
              }
            }
            function parseReturnTag(start2, tagName) {
              if (ts2.some(tags, ts2.isJSDocReturnTag)) {
                parseErrorAt(tagName.pos, scanner.getTokenPos(), ts2.Diagnostics._0_tag_already_specified, tagName.escapedText);
              }
              var result = createNode2(318, start2);
              result.tagName = tagName;
              result.typeExpression = tryParseTypeExpression();
              return finishNode(result);
            }
            function parseTypeTag(start2, tagName) {
              if (ts2.some(tags, ts2.isJSDocTypeTag)) {
                parseErrorAt(tagName.pos, scanner.getTokenPos(), ts2.Diagnostics._0_tag_already_specified, tagName.escapedText);
              }
              var result = createNode2(320, start2);
              result.tagName = tagName;
              result.typeExpression = parseJSDocTypeExpression(true);
              return finishNode(result);
            }
            function parseAuthorTag(start2, tagName, indent) {
              var result = createNode2(309, start2);
              result.tagName = tagName;
              var authorInfoWithEmail = tryParse(function() {
                return tryParseAuthorNameAndEmail();
              });
              if (!authorInfoWithEmail) {
                return finishNode(result);
              }
              result.comment = authorInfoWithEmail;
              if (lookAhead(function() {
                return nextToken() !== 4;
              })) {
                var comment = parseTagComments(indent);
                if (comment) {
                  result.comment += comment;
                }
              }
              return finishNode(result);
            }
            function tryParseAuthorNameAndEmail() {
              var comments2 = [];
              var seenLessThan = false;
              var seenGreaterThan = false;
              var token2 = scanner.getToken();
              loop:
                while (true) {
                  switch (token2) {
                    case 75:
                    case 5:
                    case 24:
                    case 59:
                      comments2.push(scanner.getTokenText());
                      break;
                    case 29:
                      if (seenLessThan || seenGreaterThan) {
                        return;
                      }
                      seenLessThan = true;
                      comments2.push(scanner.getTokenText());
                      break;
                    case 31:
                      if (!seenLessThan || seenGreaterThan) {
                        return;
                      }
                      seenGreaterThan = true;
                      comments2.push(scanner.getTokenText());
                      scanner.setTextPos(scanner.getTokenPos() + 1);
                      break loop;
                    case 4:
                    case 1:
                      break loop;
                  }
                  token2 = nextTokenJSDoc();
                }
              if (seenLessThan && seenGreaterThan) {
                return comments2.length === 0 ? void 0 : comments2.join("");
              }
            }
            function parseImplementsTag(start2, tagName) {
              var result = createNode2(308, start2);
              result.tagName = tagName;
              result.class = parseExpressionWithTypeArgumentsForAugments();
              return finishNode(result);
            }
            function parseAugmentsTag(start2, tagName) {
              var result = createNode2(307, start2);
              result.tagName = tagName;
              result.class = parseExpressionWithTypeArgumentsForAugments();
              return finishNode(result);
            }
            function parseExpressionWithTypeArgumentsForAugments() {
              var usedBrace = parseOptional(18);
              var node = createNode2(216);
              node.expression = parsePropertyAccessEntityNameExpression();
              node.typeArguments = tryParseTypeArguments();
              var res = finishNode(node);
              if (usedBrace) {
                parseExpected(19);
              }
              return res;
            }
            function parsePropertyAccessEntityNameExpression() {
              var node = parseJSDocIdentifierName();
              while (parseOptional(24)) {
                var prop = createNode2(194, node.pos);
                prop.expression = node;
                prop.name = parseJSDocIdentifierName();
                node = finishNode(prop);
              }
              return node;
            }
            function parseSimpleTag(start2, kind, tagName) {
              var tag = createNode2(kind, start2);
              tag.tagName = tagName;
              return finishNode(tag);
            }
            function parseThisTag(start2, tagName) {
              var tag = createNode2(319, start2);
              tag.tagName = tagName;
              tag.typeExpression = parseJSDocTypeExpression(true);
              skipWhitespace();
              return finishNode(tag);
            }
            function parseEnumTag(start2, tagName) {
              var tag = createNode2(316, start2);
              tag.tagName = tagName;
              tag.typeExpression = parseJSDocTypeExpression(true);
              skipWhitespace();
              return finishNode(tag);
            }
            function parseTypedefTag(start2, tagName, indent) {
              var typeExpression = tryParseTypeExpression();
              skipWhitespaceOrAsterisk();
              var typedefTag = createNode2(322, start2);
              typedefTag.tagName = tagName;
              typedefTag.fullName = parseJSDocTypeNameWithNamespace();
              typedefTag.name = getJSDocTypeAliasName(typedefTag.fullName);
              skipWhitespace();
              typedefTag.comment = parseTagComments(indent);
              typedefTag.typeExpression = typeExpression;
              var end2;
              if (!typeExpression || isObjectOrObjectArrayTypeReference(typeExpression.type)) {
                var child = void 0;
                var jsdocTypeLiteral = void 0;
                var childTypeTag = void 0;
                while (child = tryParse(function() {
                  return parseChildPropertyTag(indent);
                })) {
                  if (!jsdocTypeLiteral) {
                    jsdocTypeLiteral = createNode2(304, start2);
                  }
                  if (child.kind === 320) {
                    if (childTypeTag) {
                      break;
                    } else {
                      childTypeTag = child;
                    }
                  } else {
                    jsdocTypeLiteral.jsDocPropertyTags = ts2.append(jsdocTypeLiteral.jsDocPropertyTags, child);
                  }
                }
                if (jsdocTypeLiteral) {
                  if (typeExpression && typeExpression.type.kind === 174) {
                    jsdocTypeLiteral.isArrayType = true;
                  }
                  typedefTag.typeExpression = childTypeTag && childTypeTag.typeExpression && !isObjectOrObjectArrayTypeReference(childTypeTag.typeExpression.type) ? childTypeTag.typeExpression : finishNode(jsdocTypeLiteral);
                  end2 = typedefTag.typeExpression.end;
                }
              }
              return finishNode(typedefTag, end2 || typedefTag.comment !== void 0 ? scanner.getStartPos() : (typedefTag.fullName || typedefTag.typeExpression || typedefTag.tagName).end);
            }
            function parseJSDocTypeNameWithNamespace(nested) {
              var pos = scanner.getTokenPos();
              if (!ts2.tokenIsIdentifierOrKeyword(token())) {
                return void 0;
              }
              var typeNameOrNamespaceName = parseJSDocIdentifierName();
              if (parseOptional(24)) {
                var jsDocNamespaceNode = createNode2(249, pos);
                if (nested) {
                  jsDocNamespaceNode.flags |= 4;
                }
                jsDocNamespaceNode.name = typeNameOrNamespaceName;
                jsDocNamespaceNode.body = parseJSDocTypeNameWithNamespace(true);
                return finishNode(jsDocNamespaceNode);
              }
              if (nested) {
                typeNameOrNamespaceName.isInJSDocNamespace = true;
              }
              return typeNameOrNamespaceName;
            }
            function parseCallbackTag(start2, tagName, indent) {
              var callbackTag = createNode2(315, start2);
              callbackTag.tagName = tagName;
              callbackTag.fullName = parseJSDocTypeNameWithNamespace();
              callbackTag.name = getJSDocTypeAliasName(callbackTag.fullName);
              skipWhitespace();
              callbackTag.comment = parseTagComments(indent);
              var child;
              var jsdocSignature = createNode2(305, start2);
              jsdocSignature.parameters = [];
              while (child = tryParse(function() {
                return parseChildParameterOrPropertyTag(4, indent);
              })) {
                jsdocSignature.parameters = ts2.append(jsdocSignature.parameters, child);
              }
              var returnTag = tryParse(function() {
                if (parseOptionalJsdoc(59)) {
                  var tag = parseTag(indent);
                  if (tag && tag.kind === 318) {
                    return tag;
                  }
                }
              });
              if (returnTag) {
                jsdocSignature.type = returnTag;
              }
              callbackTag.typeExpression = finishNode(jsdocSignature);
              return finishNode(callbackTag);
            }
            function getJSDocTypeAliasName(fullName) {
              if (fullName) {
                var rightNode = fullName;
                while (true) {
                  if (ts2.isIdentifier(rightNode) || !rightNode.body) {
                    return ts2.isIdentifier(rightNode) ? rightNode : rightNode.name;
                  }
                  rightNode = rightNode.body;
                }
              }
            }
            function escapedTextsEqual(a, b) {
              while (!ts2.isIdentifier(a) || !ts2.isIdentifier(b)) {
                if (!ts2.isIdentifier(a) && !ts2.isIdentifier(b) && a.right.escapedText === b.right.escapedText) {
                  a = a.left;
                  b = b.left;
                } else {
                  return false;
                }
              }
              return a.escapedText === b.escapedText;
            }
            function parseChildPropertyTag(indent) {
              return parseChildParameterOrPropertyTag(1, indent);
            }
            function parseChildParameterOrPropertyTag(target, indent, name) {
              var canParseTag = true;
              var seenAsterisk = false;
              while (true) {
                switch (nextTokenJSDoc()) {
                  case 59:
                    if (canParseTag) {
                      var child = tryParseChildTag(target, indent);
                      if (child && (child.kind === 317 || child.kind === 323) && target !== 4 && name && (ts2.isIdentifier(child.name) || !escapedTextsEqual(name, child.name.left))) {
                        return false;
                      }
                      return child;
                    }
                    seenAsterisk = false;
                    break;
                  case 4:
                    canParseTag = true;
                    seenAsterisk = false;
                    break;
                  case 41:
                    if (seenAsterisk) {
                      canParseTag = false;
                    }
                    seenAsterisk = true;
                    break;
                  case 75:
                    canParseTag = false;
                    break;
                  case 1:
                    return false;
                }
              }
            }
            function tryParseChildTag(target, indent) {
              ts2.Debug.assert(token() === 59);
              var start2 = scanner.getStartPos();
              nextTokenJSDoc();
              var tagName = parseJSDocIdentifierName();
              skipWhitespace();
              var t;
              switch (tagName.escapedText) {
                case "type":
                  return target === 1 && parseTypeTag(start2, tagName);
                case "prop":
                case "property":
                  t = 1;
                  break;
                case "arg":
                case "argument":
                case "param":
                  t = 2 | 4;
                  break;
                default:
                  return false;
              }
              if (!(target & t)) {
                return false;
              }
              return parseParameterOrPropertyTag(start2, tagName, target, indent);
            }
            function parseTemplateTag(start2, tagName) {
              var constraint;
              if (token() === 18) {
                constraint = parseJSDocTypeExpression();
              }
              var typeParameters = [];
              var typeParametersPos = getNodePos();
              do {
                skipWhitespace();
                var typeParameter = createNode2(155);
                typeParameter.name = parseJSDocIdentifierName(ts2.Diagnostics.Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces);
                finishNode(typeParameter);
                skipWhitespaceOrAsterisk();
                typeParameters.push(typeParameter);
              } while (parseOptionalJsdoc(27));
              var result = createNode2(321, start2);
              result.tagName = tagName;
              result.constraint = constraint;
              result.typeParameters = createNodeArray(typeParameters, typeParametersPos);
              finishNode(result);
              return result;
            }
            function parseOptionalJsdoc(t) {
              if (token() === t) {
                nextTokenJSDoc();
                return true;
              }
              return false;
            }
            function parseJSDocEntityName() {
              var entity = parseJSDocIdentifierName();
              if (parseOptional(22)) {
                parseExpected(23);
              }
              while (parseOptional(24)) {
                var name = parseJSDocIdentifierName();
                if (parseOptional(22)) {
                  parseExpected(23);
                }
                entity = createQualifiedName(entity, name);
              }
              return entity;
            }
            function parseJSDocIdentifierName(message) {
              if (!ts2.tokenIsIdentifierOrKeyword(token())) {
                return createMissingNode(75, !message, message || ts2.Diagnostics.Identifier_expected);
              }
              identifierCount++;
              var pos = scanner.getTokenPos();
              var end2 = scanner.getTextPos();
              var result = createNode2(75, pos);
              if (token() !== 75) {
                result.originalKeywordKind = token();
              }
              result.escapedText = ts2.escapeLeadingUnderscores(internIdentifier(scanner.getTokenValue()));
              finishNode(result, end2);
              nextTokenJSDoc();
              return result;
            }
          }
        })(JSDocParser = Parser2.JSDocParser || (Parser2.JSDocParser = {}));
      })(Parser || (Parser = {}));
      var IncrementalParser;
      (function(IncrementalParser2) {
        function updateSourceFile2(sourceFile, newText, textChangeRange, aggressiveChecks) {
          aggressiveChecks = aggressiveChecks || ts2.Debug.shouldAssert(2);
          checkChangeRange(sourceFile, newText, textChangeRange, aggressiveChecks);
          if (ts2.textChangeRangeIsUnchanged(textChangeRange)) {
            return sourceFile;
          }
          if (sourceFile.statements.length === 0) {
            return Parser.parseSourceFile(sourceFile.fileName, newText, sourceFile.languageVersion, void 0, true, sourceFile.scriptKind);
          }
          var incrementalSourceFile = sourceFile;
          ts2.Debug.assert(!incrementalSourceFile.hasBeenIncrementallyParsed);
          incrementalSourceFile.hasBeenIncrementallyParsed = true;
          var oldText = sourceFile.text;
          var syntaxCursor = createSyntaxCursor(sourceFile);
          var changeRange = extendToAffectedRange(sourceFile, textChangeRange);
          checkChangeRange(sourceFile, newText, changeRange, aggressiveChecks);
          ts2.Debug.assert(changeRange.span.start <= textChangeRange.span.start);
          ts2.Debug.assert(ts2.textSpanEnd(changeRange.span) === ts2.textSpanEnd(textChangeRange.span));
          ts2.Debug.assert(ts2.textSpanEnd(ts2.textChangeRangeNewSpan(changeRange)) === ts2.textSpanEnd(ts2.textChangeRangeNewSpan(textChangeRange)));
          var delta = ts2.textChangeRangeNewSpan(changeRange).length - changeRange.span.length;
          updateTokenPositionsAndMarkElements(incrementalSourceFile, changeRange.span.start, ts2.textSpanEnd(changeRange.span), ts2.textSpanEnd(ts2.textChangeRangeNewSpan(changeRange)), delta, oldText, newText, aggressiveChecks);
          var result = Parser.parseSourceFile(sourceFile.fileName, newText, sourceFile.languageVersion, syntaxCursor, true, sourceFile.scriptKind);
          result.commentDirectives = getNewCommentDirectives(sourceFile.commentDirectives, result.commentDirectives, changeRange.span.start, ts2.textSpanEnd(changeRange.span), delta, oldText, newText, aggressiveChecks);
          return result;
        }
        IncrementalParser2.updateSourceFile = updateSourceFile2;
        function getNewCommentDirectives(oldDirectives, newDirectives, changeStart, changeRangeOldEnd, delta, oldText, newText, aggressiveChecks) {
          if (!oldDirectives)
            return newDirectives;
          var commentDirectives;
          var addedNewlyScannedDirectives = false;
          for (var _i = 0, oldDirectives_1 = oldDirectives; _i < oldDirectives_1.length; _i++) {
            var directive = oldDirectives_1[_i];
            var range = directive.range, type = directive.type;
            if (range.end < changeStart) {
              commentDirectives = ts2.append(commentDirectives, directive);
            } else if (range.pos > changeRangeOldEnd) {
              addNewlyScannedDirectives();
              var updatedDirective = {
                range: { pos: range.pos + delta, end: range.end + delta },
                type
              };
              commentDirectives = ts2.append(commentDirectives, updatedDirective);
              if (aggressiveChecks) {
                ts2.Debug.assert(oldText.substring(range.pos, range.end) === newText.substring(updatedDirective.range.pos, updatedDirective.range.end));
              }
            }
          }
          addNewlyScannedDirectives();
          return commentDirectives;
          function addNewlyScannedDirectives() {
            if (addedNewlyScannedDirectives)
              return;
            addedNewlyScannedDirectives = true;
            if (!commentDirectives) {
              commentDirectives = newDirectives;
            } else if (newDirectives) {
              commentDirectives.push.apply(commentDirectives, newDirectives);
            }
          }
        }
        function moveElementEntirelyPastChangeRange(element, isArray, delta, oldText, newText, aggressiveChecks) {
          if (isArray) {
            visitArray(element);
          } else {
            visitNode2(element);
          }
          return;
          function visitNode2(node) {
            var text = "";
            if (aggressiveChecks && shouldCheckNode(node)) {
              text = oldText.substring(node.pos, node.end);
            }
            if (node._children) {
              node._children = void 0;
            }
            node.pos += delta;
            node.end += delta;
            if (aggressiveChecks && shouldCheckNode(node)) {
              ts2.Debug.assert(text === newText.substring(node.pos, node.end));
            }
            forEachChild(node, visitNode2, visitArray);
            if (ts2.hasJSDocNodes(node)) {
              for (var _i = 0, _a = node.jsDoc; _i < _a.length; _i++) {
                var jsDocComment = _a[_i];
                visitNode2(jsDocComment);
              }
            }
            checkNodePositions(node, aggressiveChecks);
          }
          function visitArray(array) {
            array._children = void 0;
            array.pos += delta;
            array.end += delta;
            for (var _i = 0, array_8 = array; _i < array_8.length; _i++) {
              var node = array_8[_i];
              visitNode2(node);
            }
          }
        }
        function shouldCheckNode(node) {
          switch (node.kind) {
            case 10:
            case 8:
            case 75:
              return true;
          }
          return false;
        }
        function adjustIntersectingElement(element, changeStart, changeRangeOldEnd, changeRangeNewEnd, delta) {
          ts2.Debug.assert(element.end >= changeStart, "Adjusting an element that was entirely before the change range");
          ts2.Debug.assert(element.pos <= changeRangeOldEnd, "Adjusting an element that was entirely after the change range");
          ts2.Debug.assert(element.pos <= element.end);
          element.pos = Math.min(element.pos, changeRangeNewEnd);
          if (element.end >= changeRangeOldEnd) {
            element.end += delta;
          } else {
            element.end = Math.min(element.end, changeRangeNewEnd);
          }
          ts2.Debug.assert(element.pos <= element.end);
          if (element.parent) {
            ts2.Debug.assert(element.pos >= element.parent.pos);
            ts2.Debug.assert(element.end <= element.parent.end);
          }
        }
        function checkNodePositions(node, aggressiveChecks) {
          if (aggressiveChecks) {
            var pos_2 = node.pos;
            var visitNode_1 = function(child) {
              ts2.Debug.assert(child.pos >= pos_2);
              pos_2 = child.end;
            };
            if (ts2.hasJSDocNodes(node)) {
              for (var _i = 0, _a = node.jsDoc; _i < _a.length; _i++) {
                var jsDocComment = _a[_i];
                visitNode_1(jsDocComment);
              }
            }
            forEachChild(node, visitNode_1);
            ts2.Debug.assert(pos_2 <= node.end);
          }
        }
        function updateTokenPositionsAndMarkElements(sourceFile, changeStart, changeRangeOldEnd, changeRangeNewEnd, delta, oldText, newText, aggressiveChecks) {
          visitNode2(sourceFile);
          return;
          function visitNode2(child) {
            ts2.Debug.assert(child.pos <= child.end);
            if (child.pos > changeRangeOldEnd) {
              moveElementEntirelyPastChangeRange(child, false, delta, oldText, newText, aggressiveChecks);
              return;
            }
            var fullEnd = child.end;
            if (fullEnd >= changeStart) {
              child.intersectsChange = true;
              child._children = void 0;
              adjustIntersectingElement(child, changeStart, changeRangeOldEnd, changeRangeNewEnd, delta);
              forEachChild(child, visitNode2, visitArray);
              if (ts2.hasJSDocNodes(child)) {
                for (var _i = 0, _a = child.jsDoc; _i < _a.length; _i++) {
                  var jsDocComment = _a[_i];
                  visitNode2(jsDocComment);
                }
              }
              checkNodePositions(child, aggressiveChecks);
              return;
            }
            ts2.Debug.assert(fullEnd < changeStart);
          }
          function visitArray(array) {
            ts2.Debug.assert(array.pos <= array.end);
            if (array.pos > changeRangeOldEnd) {
              moveElementEntirelyPastChangeRange(array, true, delta, oldText, newText, aggressiveChecks);
              return;
            }
            var fullEnd = array.end;
            if (fullEnd >= changeStart) {
              array.intersectsChange = true;
              array._children = void 0;
              adjustIntersectingElement(array, changeStart, changeRangeOldEnd, changeRangeNewEnd, delta);
              for (var _i = 0, array_9 = array; _i < array_9.length; _i++) {
                var node = array_9[_i];
                visitNode2(node);
              }
              return;
            }
            ts2.Debug.assert(fullEnd < changeStart);
          }
        }
        function extendToAffectedRange(sourceFile, changeRange) {
          var maxLookahead = 1;
          var start = changeRange.span.start;
          for (var i = 0; start > 0 && i <= maxLookahead; i++) {
            var nearestNode = findNearestNodeStartingBeforeOrAtPosition(sourceFile, start);
            ts2.Debug.assert(nearestNode.pos <= start);
            var position = nearestNode.pos;
            start = Math.max(0, position - 1);
          }
          var finalSpan = ts2.createTextSpanFromBounds(start, ts2.textSpanEnd(changeRange.span));
          var finalLength = changeRange.newLength + (changeRange.span.start - start);
          return ts2.createTextChangeRange(finalSpan, finalLength);
        }
        function findNearestNodeStartingBeforeOrAtPosition(sourceFile, position) {
          var bestResult = sourceFile;
          var lastNodeEntirelyBeforePosition;
          forEachChild(sourceFile, visit);
          if (lastNodeEntirelyBeforePosition) {
            var lastChildOfLastEntireNodeBeforePosition = getLastDescendant(lastNodeEntirelyBeforePosition);
            if (lastChildOfLastEntireNodeBeforePosition.pos > bestResult.pos) {
              bestResult = lastChildOfLastEntireNodeBeforePosition;
            }
          }
          return bestResult;
          function getLastDescendant(node) {
            while (true) {
              var lastChild = ts2.getLastChild(node);
              if (lastChild) {
                node = lastChild;
              } else {
                return node;
              }
            }
          }
          function visit(child) {
            if (ts2.nodeIsMissing(child)) {
              return;
            }
            if (child.pos <= position) {
              if (child.pos >= bestResult.pos) {
                bestResult = child;
              }
              if (position < child.end) {
                forEachChild(child, visit);
                return true;
              } else {
                ts2.Debug.assert(child.end <= position);
                lastNodeEntirelyBeforePosition = child;
              }
            } else {
              ts2.Debug.assert(child.pos > position);
              return true;
            }
          }
        }
        function checkChangeRange(sourceFile, newText, textChangeRange, aggressiveChecks) {
          var oldText = sourceFile.text;
          if (textChangeRange) {
            ts2.Debug.assert(oldText.length - textChangeRange.span.length + textChangeRange.newLength === newText.length);
            if (aggressiveChecks || ts2.Debug.shouldAssert(3)) {
              var oldTextPrefix = oldText.substr(0, textChangeRange.span.start);
              var newTextPrefix = newText.substr(0, textChangeRange.span.start);
              ts2.Debug.assert(oldTextPrefix === newTextPrefix);
              var oldTextSuffix = oldText.substring(ts2.textSpanEnd(textChangeRange.span), oldText.length);
              var newTextSuffix = newText.substring(ts2.textSpanEnd(ts2.textChangeRangeNewSpan(textChangeRange)), newText.length);
              ts2.Debug.assert(oldTextSuffix === newTextSuffix);
            }
          }
        }
        function createSyntaxCursor(sourceFile) {
          var currentArray = sourceFile.statements;
          var currentArrayIndex = 0;
          ts2.Debug.assert(currentArrayIndex < currentArray.length);
          var current = currentArray[currentArrayIndex];
          var lastQueriedPosition = -1;
          return {
            currentNode: function(position) {
              if (position !== lastQueriedPosition) {
                if (current && current.end === position && currentArrayIndex < currentArray.length - 1) {
                  currentArrayIndex++;
                  current = currentArray[currentArrayIndex];
                }
                if (!current || current.pos !== position) {
                  findHighestListElementThatStartsAtPosition(position);
                }
              }
              lastQueriedPosition = position;
              ts2.Debug.assert(!current || current.pos === position);
              return current;
            }
          };
          function findHighestListElementThatStartsAtPosition(position) {
            currentArray = void 0;
            currentArrayIndex = -1;
            current = void 0;
            forEachChild(sourceFile, visitNode2, visitArray);
            return;
            function visitNode2(node) {
              if (position >= node.pos && position < node.end) {
                forEachChild(node, visitNode2, visitArray);
                return true;
              }
              return false;
            }
            function visitArray(array) {
              if (position >= array.pos && position < array.end) {
                for (var i = 0; i < array.length; i++) {
                  var child = array[i];
                  if (child) {
                    if (child.pos === position) {
                      currentArray = array;
                      currentArrayIndex = i;
                      current = child;
                      return true;
                    } else {
                      if (child.pos < position && position < child.end) {
                        forEachChild(child, visitNode2, visitArray);
                        return true;
                      }
                    }
                  }
                }
              }
              return false;
            }
          }
        }
        var InvalidPosition;
        (function(InvalidPosition2) {
          InvalidPosition2[InvalidPosition2["Value"] = -1] = "Value";
        })(InvalidPosition || (InvalidPosition = {}));
      })(IncrementalParser || (IncrementalParser = {}));
      function isDeclarationFileName(fileName) {
        return ts2.fileExtensionIs(fileName, ".d.ts");
      }
      ts2.isDeclarationFileName = isDeclarationFileName;
      function processCommentPragmas(context, sourceText) {
        var pragmas = [];
        for (var _i = 0, _a = ts2.getLeadingCommentRanges(sourceText, 0) || ts2.emptyArray; _i < _a.length; _i++) {
          var range = _a[_i];
          var comment = sourceText.substring(range.pos, range.end);
          extractPragmas(pragmas, range, comment);
        }
        context.pragmas = ts2.createMap();
        for (var _b = 0, pragmas_1 = pragmas; _b < pragmas_1.length; _b++) {
          var pragma = pragmas_1[_b];
          if (context.pragmas.has(pragma.name)) {
            var currentValue = context.pragmas.get(pragma.name);
            if (currentValue instanceof Array) {
              currentValue.push(pragma.args);
            } else {
              context.pragmas.set(pragma.name, [currentValue, pragma.args]);
            }
            continue;
          }
          context.pragmas.set(pragma.name, pragma.args);
        }
      }
      ts2.processCommentPragmas = processCommentPragmas;
      function processPragmasIntoFields(context, reportDiagnostic) {
        context.checkJsDirective = void 0;
        context.referencedFiles = [];
        context.typeReferenceDirectives = [];
        context.libReferenceDirectives = [];
        context.amdDependencies = [];
        context.hasNoDefaultLib = false;
        context.pragmas.forEach(function(entryOrList, key) {
          switch (key) {
            case "reference": {
              var referencedFiles_1 = context.referencedFiles;
              var typeReferenceDirectives_1 = context.typeReferenceDirectives;
              var libReferenceDirectives_1 = context.libReferenceDirectives;
              ts2.forEach(ts2.toArray(entryOrList), function(arg) {
                var _a = arg.arguments, types = _a.types, lib = _a.lib, path2 = _a.path;
                if (arg.arguments["no-default-lib"]) {
                  context.hasNoDefaultLib = true;
                } else if (types) {
                  typeReferenceDirectives_1.push({ pos: types.pos, end: types.end, fileName: types.value });
                } else if (lib) {
                  libReferenceDirectives_1.push({ pos: lib.pos, end: lib.end, fileName: lib.value });
                } else if (path2) {
                  referencedFiles_1.push({ pos: path2.pos, end: path2.end, fileName: path2.value });
                } else {
                  reportDiagnostic(arg.range.pos, arg.range.end - arg.range.pos, ts2.Diagnostics.Invalid_reference_directive_syntax);
                }
              });
              break;
            }
            case "amd-dependency": {
              context.amdDependencies = ts2.map(ts2.toArray(entryOrList), function(x) {
                return { name: x.arguments.name, path: x.arguments.path };
              });
              break;
            }
            case "amd-module": {
              if (entryOrList instanceof Array) {
                for (var _i = 0, entryOrList_1 = entryOrList; _i < entryOrList_1.length; _i++) {
                  var entry = entryOrList_1[_i];
                  if (context.moduleName) {
                    reportDiagnostic(entry.range.pos, entry.range.end - entry.range.pos, ts2.Diagnostics.An_AMD_module_cannot_have_multiple_name_assignments);
                  }
                  context.moduleName = entry.arguments.name;
                }
              } else {
                context.moduleName = entryOrList.arguments.name;
              }
              break;
            }
            case "ts-nocheck":
            case "ts-check": {
              ts2.forEach(ts2.toArray(entryOrList), function(entry2) {
                if (!context.checkJsDirective || entry2.range.pos > context.checkJsDirective.pos) {
                  context.checkJsDirective = {
                    enabled: key === "ts-check",
                    end: entry2.range.end,
                    pos: entry2.range.pos
                  };
                }
              });
              break;
            }
            case "jsx":
              return;
            default:
              ts2.Debug.fail("Unhandled pragma kind");
          }
        });
      }
      ts2.processPragmasIntoFields = processPragmasIntoFields;
      var namedArgRegExCache = ts2.createMap();
      function getNamedArgRegEx(name) {
        if (namedArgRegExCache.has(name)) {
          return namedArgRegExCache.get(name);
        }
        var result = new RegExp("(\\s" + name + `\\s*=\\s*)('|")(.+?)\\2`, "im");
        namedArgRegExCache.set(name, result);
        return result;
      }
      var tripleSlashXMLCommentStartRegEx = /^\/\/\/\s*<(\S+)\s.*?\/>/im;
      var singleLinePragmaRegEx = /^\/\/\/?\s*@(\S+)\s*(.*)\s*$/im;
      function extractPragmas(pragmas, range, text) {
        var tripleSlash = range.kind === 2 && tripleSlashXMLCommentStartRegEx.exec(text);
        if (tripleSlash) {
          var name = tripleSlash[1].toLowerCase();
          var pragma = ts2.commentPragmas[name];
          if (!pragma || !(pragma.kind & 1)) {
            return;
          }
          if (pragma.args) {
            var argument = {};
            for (var _i = 0, _a = pragma.args; _i < _a.length; _i++) {
              var arg = _a[_i];
              var matcher = getNamedArgRegEx(arg.name);
              var matchResult = matcher.exec(text);
              if (!matchResult && !arg.optional) {
                return;
              } else if (matchResult) {
                if (arg.captureSpan) {
                  var startPos = range.pos + matchResult.index + matchResult[1].length + matchResult[2].length;
                  argument[arg.name] = {
                    value: matchResult[3],
                    pos: startPos,
                    end: startPos + matchResult[3].length
                  };
                } else {
                  argument[arg.name] = matchResult[3];
                }
              }
            }
            pragmas.push({ name, args: { arguments: argument, range } });
          } else {
            pragmas.push({ name, args: { arguments: {}, range } });
          }
          return;
        }
        var singleLine = range.kind === 2 && singleLinePragmaRegEx.exec(text);
        if (singleLine) {
          return addPragmaForMatch(pragmas, range, 2, singleLine);
        }
        if (range.kind === 3) {
          var multiLinePragmaRegEx = /\s*@(\S+)\s*(.*)\s*$/gim;
          var multiLineMatch = void 0;
          while (multiLineMatch = multiLinePragmaRegEx.exec(text)) {
            addPragmaForMatch(pragmas, range, 4, multiLineMatch);
          }
        }
      }
      function addPragmaForMatch(pragmas, range, kind, match) {
        if (!match)
          return;
        var name = match[1].toLowerCase();
        var pragma = ts2.commentPragmas[name];
        if (!pragma || !(pragma.kind & kind)) {
          return;
        }
        var args = match[2];
        var argument = getNamedPragmaArguments(pragma, args);
        if (argument === "fail")
          return;
        pragmas.push({ name, args: { arguments: argument, range } });
        return;
      }
      function getNamedPragmaArguments(pragma, text) {
        if (!text)
          return {};
        if (!pragma.args)
          return {};
        var args = text.split(/\s+/);
        var argMap = {};
        for (var i = 0; i < pragma.args.length; i++) {
          var argument = pragma.args[i];
          if (!args[i] && !argument.optional) {
            return "fail";
          }
          if (argument.captureSpan) {
            return ts2.Debug.fail("Capture spans not yet implemented for non-xml pragmas");
          }
          argMap[argument.name] = args[i];
        }
        return argMap;
      }
      function tagNamesAreEquivalent(lhs, rhs) {
        if (lhs.kind !== rhs.kind) {
          return false;
        }
        if (lhs.kind === 75) {
          return lhs.escapedText === rhs.escapedText;
        }
        if (lhs.kind === 104) {
          return true;
        }
        return lhs.name.escapedText === rhs.name.escapedText && tagNamesAreEquivalent(lhs.expression, rhs.expression);
      }
      ts2.tagNamesAreEquivalent = tagNamesAreEquivalent;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      ts2.compileOnSaveCommandLineOption = { name: "compileOnSave", type: "boolean" };
      var libEntries = [
        ["es5", "lib.es5.d.ts"],
        ["es6", "lib.es2015.d.ts"],
        ["es2015", "lib.es2015.d.ts"],
        ["es7", "lib.es2016.d.ts"],
        ["es2016", "lib.es2016.d.ts"],
        ["es2017", "lib.es2017.d.ts"],
        ["es2018", "lib.es2018.d.ts"],
        ["es2019", "lib.es2019.d.ts"],
        ["es2020", "lib.es2020.d.ts"],
        ["esnext", "lib.esnext.d.ts"],
        ["dom", "lib.dom.d.ts"],
        ["dom.iterable", "lib.dom.iterable.d.ts"],
        ["webworker", "lib.webworker.d.ts"],
        ["webworker.importscripts", "lib.webworker.importscripts.d.ts"],
        ["scripthost", "lib.scripthost.d.ts"],
        ["es2015.core", "lib.es2015.core.d.ts"],
        ["es2015.collection", "lib.es2015.collection.d.ts"],
        ["es2015.generator", "lib.es2015.generator.d.ts"],
        ["es2015.iterable", "lib.es2015.iterable.d.ts"],
        ["es2015.promise", "lib.es2015.promise.d.ts"],
        ["es2015.proxy", "lib.es2015.proxy.d.ts"],
        ["es2015.reflect", "lib.es2015.reflect.d.ts"],
        ["es2015.symbol", "lib.es2015.symbol.d.ts"],
        ["es2015.symbol.wellknown", "lib.es2015.symbol.wellknown.d.ts"],
        ["es2016.array.include", "lib.es2016.array.include.d.ts"],
        ["es2017.object", "lib.es2017.object.d.ts"],
        ["es2017.sharedmemory", "lib.es2017.sharedmemory.d.ts"],
        ["es2017.string", "lib.es2017.string.d.ts"],
        ["es2017.intl", "lib.es2017.intl.d.ts"],
        ["es2017.typedarrays", "lib.es2017.typedarrays.d.ts"],
        ["es2018.asyncgenerator", "lib.es2018.asyncgenerator.d.ts"],
        ["es2018.asynciterable", "lib.es2018.asynciterable.d.ts"],
        ["es2018.intl", "lib.es2018.intl.d.ts"],
        ["es2018.promise", "lib.es2018.promise.d.ts"],
        ["es2018.regexp", "lib.es2018.regexp.d.ts"],
        ["es2019.array", "lib.es2019.array.d.ts"],
        ["es2019.object", "lib.es2019.object.d.ts"],
        ["es2019.string", "lib.es2019.string.d.ts"],
        ["es2019.symbol", "lib.es2019.symbol.d.ts"],
        ["es2020.bigint", "lib.es2020.bigint.d.ts"],
        ["es2020.promise", "lib.es2020.promise.d.ts"],
        ["es2020.string", "lib.es2020.string.d.ts"],
        ["es2020.symbol.wellknown", "lib.es2020.symbol.wellknown.d.ts"],
        ["esnext.array", "lib.es2019.array.d.ts"],
        ["esnext.symbol", "lib.es2019.symbol.d.ts"],
        ["esnext.asynciterable", "lib.es2018.asynciterable.d.ts"],
        ["esnext.intl", "lib.esnext.intl.d.ts"],
        ["esnext.bigint", "lib.es2020.bigint.d.ts"],
        ["esnext.string", "lib.esnext.string.d.ts"],
        ["esnext.promise", "lib.esnext.promise.d.ts"]
      ];
      ts2.libs = libEntries.map(function(entry) {
        return entry[0];
      });
      ts2.libMap = ts2.createMapFromEntries(libEntries);
      ts2.optionsForWatch = [
        {
          name: "watchFile",
          type: ts2.createMapFromTemplate({
            fixedpollinginterval: ts2.WatchFileKind.FixedPollingInterval,
            prioritypollinginterval: ts2.WatchFileKind.PriorityPollingInterval,
            dynamicprioritypolling: ts2.WatchFileKind.DynamicPriorityPolling,
            usefsevents: ts2.WatchFileKind.UseFsEvents,
            usefseventsonparentdirectory: ts2.WatchFileKind.UseFsEventsOnParentDirectory
          }),
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Specify_strategy_for_watching_file_Colon_FixedPollingInterval_default_PriorityPollingInterval_DynamicPriorityPolling_UseFsEvents_UseFsEventsOnParentDirectory
        },
        {
          name: "watchDirectory",
          type: ts2.createMapFromTemplate({
            usefsevents: ts2.WatchDirectoryKind.UseFsEvents,
            fixedpollinginterval: ts2.WatchDirectoryKind.FixedPollingInterval,
            dynamicprioritypolling: ts2.WatchDirectoryKind.DynamicPriorityPolling
          }),
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Specify_strategy_for_watching_directory_on_platforms_that_don_t_support_recursive_watching_natively_Colon_UseFsEvents_default_FixedPollingInterval_DynamicPriorityPolling
        },
        {
          name: "fallbackPolling",
          type: ts2.createMapFromTemplate({
            fixedinterval: ts2.PollingWatchKind.FixedInterval,
            priorityinterval: ts2.PollingWatchKind.PriorityInterval,
            dynamicpriority: ts2.PollingWatchKind.DynamicPriority
          }),
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Specify_strategy_for_creating_a_polling_watch_when_it_fails_to_create_using_file_system_events_Colon_FixedInterval_default_PriorityInterval_DynamicPriority
        },
        {
          name: "synchronousWatchDirectory",
          type: "boolean",
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_support_recursive_watching_natively
        }
      ];
      ts2.commonOptionsWithBuild = [
        {
          name: "help",
          shortName: "h",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Command_line_Options,
          description: ts2.Diagnostics.Print_this_message
        },
        {
          name: "help",
          shortName: "?",
          type: "boolean"
        },
        {
          name: "watch",
          shortName: "w",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Command_line_Options,
          description: ts2.Diagnostics.Watch_input_files
        },
        {
          name: "preserveWatchOutput",
          type: "boolean",
          showInSimplifiedHelpView: false,
          category: ts2.Diagnostics.Command_line_Options,
          description: ts2.Diagnostics.Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen
        },
        {
          name: "listFiles",
          type: "boolean",
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Print_names_of_files_part_of_the_compilation
        },
        {
          name: "listEmittedFiles",
          type: "boolean",
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Print_names_of_generated_files_part_of_the_compilation
        },
        {
          name: "pretty",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Command_line_Options,
          description: ts2.Diagnostics.Stylize_errors_and_messages_using_color_and_context_experimental
        },
        {
          name: "traceResolution",
          type: "boolean",
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Enable_tracing_of_the_name_resolution_process
        },
        {
          name: "diagnostics",
          type: "boolean",
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Show_diagnostic_information
        },
        {
          name: "extendedDiagnostics",
          type: "boolean",
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Show_verbose_diagnostic_information
        },
        {
          name: "generateCpuProfile",
          type: "string",
          isFilePath: true,
          paramType: ts2.Diagnostics.FILE_OR_DIRECTORY,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Generates_a_CPU_profile
        },
        {
          name: "incremental",
          shortName: "i",
          type: "boolean",
          category: ts2.Diagnostics.Basic_Options,
          description: ts2.Diagnostics.Enable_incremental_compilation,
          transpileOptionValue: void 0
        },
        {
          name: "assumeChangesOnlyAffectDirectDependencies",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          affectsEmit: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Have_recompiles_in_incremental_and_watch_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it
        },
        {
          name: "locale",
          type: "string",
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.The_locale_used_when_displaying_messages_to_the_user_e_g_en_us
        }
      ];
      ts2.optionDeclarations = __spreadArrays(ts2.commonOptionsWithBuild, [
        {
          name: "all",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Command_line_Options,
          description: ts2.Diagnostics.Show_all_compiler_options
        },
        {
          name: "version",
          shortName: "v",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Command_line_Options,
          description: ts2.Diagnostics.Print_the_compiler_s_version
        },
        {
          name: "init",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Command_line_Options,
          description: ts2.Diagnostics.Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file
        },
        {
          name: "project",
          shortName: "p",
          type: "string",
          isFilePath: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Command_line_Options,
          paramType: ts2.Diagnostics.FILE_OR_DIRECTORY,
          description: ts2.Diagnostics.Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json
        },
        {
          name: "build",
          type: "boolean",
          shortName: "b",
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Command_line_Options,
          description: ts2.Diagnostics.Build_one_or_more_projects_and_their_dependencies_if_out_of_date
        },
        {
          name: "showConfig",
          type: "boolean",
          category: ts2.Diagnostics.Command_line_Options,
          isCommandLineOnly: true,
          description: ts2.Diagnostics.Print_the_final_configuration_instead_of_building
        },
        {
          name: "listFilesOnly",
          type: "boolean",
          category: ts2.Diagnostics.Command_line_Options,
          affectsSemanticDiagnostics: true,
          affectsEmit: true,
          isCommandLineOnly: true,
          description: ts2.Diagnostics.Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing
        },
        {
          name: "target",
          shortName: "t",
          type: ts2.createMapFromTemplate({
            es3: 0,
            es5: 1,
            es6: 2,
            es2015: 2,
            es2016: 3,
            es2017: 4,
            es2018: 5,
            es2019: 6,
            es2020: 7,
            esnext: 99
          }),
          affectsSourceFile: true,
          affectsModuleResolution: true,
          affectsEmit: true,
          paramType: ts2.Diagnostics.VERSION,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Basic_Options,
          description: ts2.Diagnostics.Specify_ECMAScript_target_version_Colon_ES3_default_ES5_ES2015_ES2016_ES2017_ES2018_ES2019_ES2020_or_ESNEXT
        },
        {
          name: "module",
          shortName: "m",
          type: ts2.createMapFromTemplate({
            none: ts2.ModuleKind.None,
            commonjs: ts2.ModuleKind.CommonJS,
            amd: ts2.ModuleKind.AMD,
            system: ts2.ModuleKind.System,
            umd: ts2.ModuleKind.UMD,
            es6: ts2.ModuleKind.ES2015,
            es2015: ts2.ModuleKind.ES2015,
            es2020: ts2.ModuleKind.ES2020,
            esnext: ts2.ModuleKind.ESNext
          }),
          affectsModuleResolution: true,
          affectsEmit: true,
          paramType: ts2.Diagnostics.KIND,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Basic_Options,
          description: ts2.Diagnostics.Specify_module_code_generation_Colon_none_commonjs_amd_system_umd_es2015_es2020_or_ESNext
        },
        {
          name: "lib",
          type: "list",
          element: {
            name: "lib",
            type: ts2.libMap
          },
          affectsModuleResolution: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Basic_Options,
          description: ts2.Diagnostics.Specify_library_files_to_be_included_in_the_compilation,
          transpileOptionValue: void 0
        },
        {
          name: "allowJs",
          type: "boolean",
          affectsModuleResolution: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Basic_Options,
          description: ts2.Diagnostics.Allow_javascript_files_to_be_compiled
        },
        {
          name: "checkJs",
          type: "boolean",
          category: ts2.Diagnostics.Basic_Options,
          description: ts2.Diagnostics.Report_errors_in_js_files
        },
        {
          name: "jsx",
          type: ts2.createMapFromTemplate({
            "preserve": 1,
            "react-native": 3,
            "react": 2
          }),
          affectsSourceFile: true,
          paramType: ts2.Diagnostics.KIND,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Basic_Options,
          description: ts2.Diagnostics.Specify_JSX_code_generation_Colon_preserve_react_native_or_react
        },
        {
          name: "declaration",
          shortName: "d",
          type: "boolean",
          affectsEmit: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Basic_Options,
          description: ts2.Diagnostics.Generates_corresponding_d_ts_file,
          transpileOptionValue: void 0
        },
        {
          name: "declarationMap",
          type: "boolean",
          affectsEmit: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Basic_Options,
          description: ts2.Diagnostics.Generates_a_sourcemap_for_each_corresponding_d_ts_file,
          transpileOptionValue: void 0
        },
        {
          name: "emitDeclarationOnly",
          type: "boolean",
          affectsEmit: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Only_emit_d_ts_declaration_files,
          transpileOptionValue: void 0
        },
        {
          name: "sourceMap",
          type: "boolean",
          affectsEmit: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Basic_Options,
          description: ts2.Diagnostics.Generates_corresponding_map_file
        },
        {
          name: "outFile",
          type: "string",
          affectsEmit: true,
          isFilePath: true,
          paramType: ts2.Diagnostics.FILE,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Basic_Options,
          description: ts2.Diagnostics.Concatenate_and_emit_output_to_single_file,
          transpileOptionValue: void 0
        },
        {
          name: "outDir",
          type: "string",
          affectsEmit: true,
          isFilePath: true,
          paramType: ts2.Diagnostics.DIRECTORY,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Basic_Options,
          description: ts2.Diagnostics.Redirect_output_structure_to_the_directory
        },
        {
          name: "rootDir",
          type: "string",
          affectsEmit: true,
          isFilePath: true,
          paramType: ts2.Diagnostics.LOCATION,
          category: ts2.Diagnostics.Basic_Options,
          description: ts2.Diagnostics.Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir
        },
        {
          name: "composite",
          type: "boolean",
          affectsEmit: true,
          isTSConfigOnly: true,
          category: ts2.Diagnostics.Basic_Options,
          description: ts2.Diagnostics.Enable_project_compilation,
          transpileOptionValue: void 0
        },
        {
          name: "tsBuildInfoFile",
          type: "string",
          affectsEmit: true,
          isFilePath: true,
          paramType: ts2.Diagnostics.FILE,
          category: ts2.Diagnostics.Basic_Options,
          description: ts2.Diagnostics.Specify_file_to_store_incremental_compilation_information,
          transpileOptionValue: void 0
        },
        {
          name: "removeComments",
          type: "boolean",
          affectsEmit: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Basic_Options,
          description: ts2.Diagnostics.Do_not_emit_comments_to_output
        },
        {
          name: "noEmit",
          type: "boolean",
          affectsEmit: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Basic_Options,
          description: ts2.Diagnostics.Do_not_emit_outputs,
          transpileOptionValue: void 0
        },
        {
          name: "importHelpers",
          type: "boolean",
          affectsEmit: true,
          category: ts2.Diagnostics.Basic_Options,
          description: ts2.Diagnostics.Import_emit_helpers_from_tslib
        },
        {
          name: "importsNotUsedAsValues",
          type: ts2.createMapFromTemplate({
            remove: 0,
            preserve: 1,
            error: 2
          }),
          affectsEmit: true,
          affectsSemanticDiagnostics: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types
        },
        {
          name: "downlevelIteration",
          type: "boolean",
          affectsEmit: true,
          category: ts2.Diagnostics.Basic_Options,
          description: ts2.Diagnostics.Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3
        },
        {
          name: "isolatedModules",
          type: "boolean",
          category: ts2.Diagnostics.Basic_Options,
          description: ts2.Diagnostics.Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule,
          transpileOptionValue: true
        },
        {
          name: "strict",
          type: "boolean",
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Strict_Type_Checking_Options,
          description: ts2.Diagnostics.Enable_all_strict_type_checking_options
        },
        {
          name: "noImplicitAny",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          strictFlag: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Strict_Type_Checking_Options,
          description: ts2.Diagnostics.Raise_error_on_expressions_and_declarations_with_an_implied_any_type
        },
        {
          name: "strictNullChecks",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          strictFlag: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Strict_Type_Checking_Options,
          description: ts2.Diagnostics.Enable_strict_null_checks
        },
        {
          name: "strictFunctionTypes",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          strictFlag: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Strict_Type_Checking_Options,
          description: ts2.Diagnostics.Enable_strict_checking_of_function_types
        },
        {
          name: "strictBindCallApply",
          type: "boolean",
          strictFlag: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Strict_Type_Checking_Options,
          description: ts2.Diagnostics.Enable_strict_bind_call_and_apply_methods_on_functions
        },
        {
          name: "strictPropertyInitialization",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          strictFlag: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Strict_Type_Checking_Options,
          description: ts2.Diagnostics.Enable_strict_checking_of_property_initialization_in_classes
        },
        {
          name: "noImplicitThis",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          strictFlag: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Strict_Type_Checking_Options,
          description: ts2.Diagnostics.Raise_error_on_this_expressions_with_an_implied_any_type
        },
        {
          name: "alwaysStrict",
          type: "boolean",
          affectsSourceFile: true,
          strictFlag: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Strict_Type_Checking_Options,
          description: ts2.Diagnostics.Parse_in_strict_mode_and_emit_use_strict_for_each_source_file
        },
        {
          name: "noUnusedLocals",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Additional_Checks,
          description: ts2.Diagnostics.Report_errors_on_unused_locals
        },
        {
          name: "noUnusedParameters",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Additional_Checks,
          description: ts2.Diagnostics.Report_errors_on_unused_parameters
        },
        {
          name: "noImplicitReturns",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Additional_Checks,
          description: ts2.Diagnostics.Report_error_when_not_all_code_paths_in_function_return_a_value
        },
        {
          name: "noFallthroughCasesInSwitch",
          type: "boolean",
          affectsBindDiagnostics: true,
          affectsSemanticDiagnostics: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Additional_Checks,
          description: ts2.Diagnostics.Report_errors_for_fallthrough_cases_in_switch_statement
        },
        {
          name: "moduleResolution",
          type: ts2.createMapFromTemplate({
            node: ts2.ModuleResolutionKind.NodeJs,
            classic: ts2.ModuleResolutionKind.Classic
          }),
          affectsModuleResolution: true,
          paramType: ts2.Diagnostics.STRATEGY,
          category: ts2.Diagnostics.Module_Resolution_Options,
          description: ts2.Diagnostics.Specify_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6
        },
        {
          name: "baseUrl",
          type: "string",
          affectsModuleResolution: true,
          isFilePath: true,
          category: ts2.Diagnostics.Module_Resolution_Options,
          description: ts2.Diagnostics.Base_directory_to_resolve_non_absolute_module_names
        },
        {
          name: "paths",
          type: "object",
          affectsModuleResolution: true,
          isTSConfigOnly: true,
          category: ts2.Diagnostics.Module_Resolution_Options,
          description: ts2.Diagnostics.A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl,
          transpileOptionValue: void 0
        },
        {
          name: "rootDirs",
          type: "list",
          isTSConfigOnly: true,
          element: {
            name: "rootDirs",
            type: "string",
            isFilePath: true
          },
          affectsModuleResolution: true,
          category: ts2.Diagnostics.Module_Resolution_Options,
          description: ts2.Diagnostics.List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime,
          transpileOptionValue: void 0
        },
        {
          name: "typeRoots",
          type: "list",
          element: {
            name: "typeRoots",
            type: "string",
            isFilePath: true
          },
          affectsModuleResolution: true,
          category: ts2.Diagnostics.Module_Resolution_Options,
          description: ts2.Diagnostics.List_of_folders_to_include_type_definitions_from
        },
        {
          name: "types",
          type: "list",
          element: {
            name: "types",
            type: "string"
          },
          affectsModuleResolution: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Module_Resolution_Options,
          description: ts2.Diagnostics.Type_declaration_files_to_be_included_in_compilation,
          transpileOptionValue: void 0
        },
        {
          name: "allowSyntheticDefaultImports",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts2.Diagnostics.Module_Resolution_Options,
          description: ts2.Diagnostics.Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typechecking
        },
        {
          name: "esModuleInterop",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          affectsEmit: true,
          showInSimplifiedHelpView: true,
          category: ts2.Diagnostics.Module_Resolution_Options,
          description: ts2.Diagnostics.Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for_all_imports_Implies_allowSyntheticDefaultImports
        },
        {
          name: "preserveSymlinks",
          type: "boolean",
          category: ts2.Diagnostics.Module_Resolution_Options,
          description: ts2.Diagnostics.Do_not_resolve_the_real_path_of_symlinks
        },
        {
          name: "allowUmdGlobalAccess",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts2.Diagnostics.Module_Resolution_Options,
          description: ts2.Diagnostics.Allow_accessing_UMD_globals_from_modules
        },
        {
          name: "sourceRoot",
          type: "string",
          affectsEmit: true,
          paramType: ts2.Diagnostics.LOCATION,
          category: ts2.Diagnostics.Source_Map_Options,
          description: ts2.Diagnostics.Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations
        },
        {
          name: "mapRoot",
          type: "string",
          affectsEmit: true,
          paramType: ts2.Diagnostics.LOCATION,
          category: ts2.Diagnostics.Source_Map_Options,
          description: ts2.Diagnostics.Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations
        },
        {
          name: "inlineSourceMap",
          type: "boolean",
          affectsEmit: true,
          category: ts2.Diagnostics.Source_Map_Options,
          description: ts2.Diagnostics.Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file
        },
        {
          name: "inlineSources",
          type: "boolean",
          affectsEmit: true,
          category: ts2.Diagnostics.Source_Map_Options,
          description: ts2.Diagnostics.Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap_to_be_set
        },
        {
          name: "experimentalDecorators",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts2.Diagnostics.Experimental_Options,
          description: ts2.Diagnostics.Enables_experimental_support_for_ES7_decorators
        },
        {
          name: "emitDecoratorMetadata",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          affectsEmit: true,
          category: ts2.Diagnostics.Experimental_Options,
          description: ts2.Diagnostics.Enables_experimental_support_for_emitting_type_metadata_for_decorators
        },
        {
          name: "jsxFactory",
          type: "string",
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h
        },
        {
          name: "resolveJsonModule",
          type: "boolean",
          affectsModuleResolution: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Include_modules_imported_with_json_extension
        },
        {
          name: "out",
          type: "string",
          affectsEmit: true,
          isFilePath: false,
          category: ts2.Diagnostics.Advanced_Options,
          paramType: ts2.Diagnostics.FILE,
          description: ts2.Diagnostics.Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file,
          transpileOptionValue: void 0
        },
        {
          name: "reactNamespace",
          type: "string",
          affectsEmit: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react_JSX_emit
        },
        {
          name: "skipDefaultLibCheck",
          type: "boolean",
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files
        },
        {
          name: "charset",
          type: "string",
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.The_character_set_of_the_input_files
        },
        {
          name: "emitBOM",
          type: "boolean",
          affectsEmit: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files
        },
        {
          name: "newLine",
          type: ts2.createMapFromTemplate({
            crlf: 0,
            lf: 1
          }),
          affectsEmit: true,
          paramType: ts2.Diagnostics.NEWLINE,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix
        },
        {
          name: "noErrorTruncation",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Do_not_truncate_error_messages
        },
        {
          name: "noLib",
          type: "boolean",
          affectsModuleResolution: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Do_not_include_the_default_library_file_lib_d_ts,
          transpileOptionValue: true
        },
        {
          name: "noResolve",
          type: "boolean",
          affectsModuleResolution: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files,
          transpileOptionValue: true
        },
        {
          name: "stripInternal",
          type: "boolean",
          affectsEmit: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Do_not_emit_declarations_for_code_that_has_an_internal_annotation
        },
        {
          name: "disableSizeLimit",
          type: "boolean",
          affectsSourceFile: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Disable_size_limitations_on_JavaScript_projects
        },
        {
          name: "disableSourceOfProjectReferenceRedirect",
          type: "boolean",
          isTSConfigOnly: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Disable_use_of_source_files_instead_of_declaration_files_from_referenced_projects
        },
        {
          name: "disableSolutionSearching",
          type: "boolean",
          isTSConfigOnly: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Disable_solution_searching_for_this_project
        },
        {
          name: "noImplicitUseStrict",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Do_not_emit_use_strict_directives_in_module_output
        },
        {
          name: "noEmitHelpers",
          type: "boolean",
          affectsEmit: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Do_not_generate_custom_helper_functions_like_extends_in_compiled_output
        },
        {
          name: "noEmitOnError",
          type: "boolean",
          affectsEmit: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Do_not_emit_outputs_if_any_errors_were_reported,
          transpileOptionValue: void 0
        },
        {
          name: "preserveConstEnums",
          type: "boolean",
          affectsEmit: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Do_not_erase_const_enum_declarations_in_generated_code
        },
        {
          name: "declarationDir",
          type: "string",
          affectsEmit: true,
          isFilePath: true,
          paramType: ts2.Diagnostics.DIRECTORY,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Output_directory_for_generated_declaration_files,
          transpileOptionValue: void 0
        },
        {
          name: "skipLibCheck",
          type: "boolean",
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Skip_type_checking_of_declaration_files
        },
        {
          name: "allowUnusedLabels",
          type: "boolean",
          affectsBindDiagnostics: true,
          affectsSemanticDiagnostics: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Do_not_report_errors_on_unused_labels
        },
        {
          name: "allowUnreachableCode",
          type: "boolean",
          affectsBindDiagnostics: true,
          affectsSemanticDiagnostics: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Do_not_report_errors_on_unreachable_code
        },
        {
          name: "suppressExcessPropertyErrors",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Suppress_excess_property_checks_for_object_literals
        },
        {
          name: "suppressImplicitAnyIndexErrors",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures
        },
        {
          name: "forceConsistentCasingInFileNames",
          type: "boolean",
          affectsModuleResolution: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Disallow_inconsistently_cased_references_to_the_same_file
        },
        {
          name: "maxNodeModuleJsDepth",
          type: "number",
          affectsModuleResolution: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files
        },
        {
          name: "noStrictGenericChecks",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Disable_strict_checking_of_generic_signatures_in_function_types
        },
        {
          name: "useDefineForClassFields",
          type: "boolean",
          affectsSemanticDiagnostics: true,
          affectsEmit: true,
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Emit_class_fields_with_Define_instead_of_Set
        },
        {
          name: "keyofStringsOnly",
          type: "boolean",
          category: ts2.Diagnostics.Advanced_Options,
          description: ts2.Diagnostics.Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols
        },
        {
          name: "plugins",
          type: "list",
          isTSConfigOnly: true,
          element: {
            name: "plugin",
            type: "object"
          },
          description: ts2.Diagnostics.List_of_language_service_plugins
        }
      ]);
      ts2.semanticDiagnosticsOptionDeclarations = ts2.optionDeclarations.filter(function(option) {
        return !!option.affectsSemanticDiagnostics;
      });
      ts2.affectsEmitOptionDeclarations = ts2.optionDeclarations.filter(function(option) {
        return !!option.affectsEmit;
      });
      ts2.moduleResolutionOptionDeclarations = ts2.optionDeclarations.filter(function(option) {
        return !!option.affectsModuleResolution;
      });
      ts2.sourceFileAffectingCompilerOptions = ts2.optionDeclarations.filter(function(option) {
        return !!option.affectsSourceFile || !!option.affectsModuleResolution || !!option.affectsBindDiagnostics;
      });
      ts2.transpileOptionValueCompilerOptions = ts2.optionDeclarations.filter(function(option) {
        return ts2.hasProperty(option, "transpileOptionValue");
      });
      ts2.buildOpts = __spreadArrays(ts2.commonOptionsWithBuild, [
        {
          name: "verbose",
          shortName: "v",
          category: ts2.Diagnostics.Command_line_Options,
          description: ts2.Diagnostics.Enable_verbose_logging,
          type: "boolean"
        },
        {
          name: "dry",
          shortName: "d",
          category: ts2.Diagnostics.Command_line_Options,
          description: ts2.Diagnostics.Show_what_would_be_built_or_deleted_if_specified_with_clean,
          type: "boolean"
        },
        {
          name: "force",
          shortName: "f",
          category: ts2.Diagnostics.Command_line_Options,
          description: ts2.Diagnostics.Build_all_projects_including_those_that_appear_to_be_up_to_date,
          type: "boolean"
        },
        {
          name: "clean",
          category: ts2.Diagnostics.Command_line_Options,
          description: ts2.Diagnostics.Delete_the_outputs_of_all_projects,
          type: "boolean"
        }
      ]);
      ts2.typeAcquisitionDeclarations = [
        {
          name: "enableAutoDiscovery",
          type: "boolean"
        },
        {
          name: "enable",
          type: "boolean"
        },
        {
          name: "include",
          type: "list",
          element: {
            name: "include",
            type: "string"
          }
        },
        {
          name: "exclude",
          type: "list",
          element: {
            name: "exclude",
            type: "string"
          }
        }
      ];
      function createOptionNameMap(optionDeclarations) {
        var optionsNameMap = ts2.createMap();
        var shortOptionNames = ts2.createMap();
        ts2.forEach(optionDeclarations, function(option) {
          optionsNameMap.set(option.name.toLowerCase(), option);
          if (option.shortName) {
            shortOptionNames.set(option.shortName, option.name);
          }
        });
        return { optionsNameMap, shortOptionNames };
      }
      ts2.createOptionNameMap = createOptionNameMap;
      var optionsNameMapCache;
      function getOptionsNameMap() {
        return optionsNameMapCache || (optionsNameMapCache = createOptionNameMap(ts2.optionDeclarations));
      }
      ts2.getOptionsNameMap = getOptionsNameMap;
      ts2.defaultInitCompilerOptions = {
        module: ts2.ModuleKind.CommonJS,
        target: 1,
        strict: true,
        esModuleInterop: true,
        forceConsistentCasingInFileNames: true,
        skipLibCheck: true
      };
      function convertEnableAutoDiscoveryToEnable(typeAcquisition) {
        if (typeAcquisition && typeAcquisition.enableAutoDiscovery !== void 0 && typeAcquisition.enable === void 0) {
          return {
            enable: typeAcquisition.enableAutoDiscovery,
            include: typeAcquisition.include || [],
            exclude: typeAcquisition.exclude || []
          };
        }
        return typeAcquisition;
      }
      ts2.convertEnableAutoDiscoveryToEnable = convertEnableAutoDiscoveryToEnable;
      function createCompilerDiagnosticForInvalidCustomType(opt) {
        return createDiagnosticForInvalidCustomType(opt, ts2.createCompilerDiagnostic);
      }
      ts2.createCompilerDiagnosticForInvalidCustomType = createCompilerDiagnosticForInvalidCustomType;
      function createDiagnosticForInvalidCustomType(opt, createDiagnostic) {
        var namesOfType = ts2.arrayFrom(opt.type.keys()).map(function(key) {
          return "'" + key + "'";
        }).join(", ");
        return createDiagnostic(ts2.Diagnostics.Argument_for_0_option_must_be_Colon_1, "--" + opt.name, namesOfType);
      }
      function parseCustomTypeOption(opt, value, errors) {
        return convertJsonOptionOfCustomType(opt, trimString(value || ""), errors);
      }
      ts2.parseCustomTypeOption = parseCustomTypeOption;
      function parseListTypeOption(opt, value, errors) {
        if (value === void 0) {
          value = "";
        }
        value = trimString(value);
        if (ts2.startsWith(value, "-")) {
          return void 0;
        }
        if (value === "") {
          return [];
        }
        var values = value.split(",");
        switch (opt.element.type) {
          case "number":
            return ts2.map(values, parseInt);
          case "string":
            return ts2.map(values, function(v) {
              return v || "";
            });
          default:
            return ts2.mapDefined(values, function(v) {
              return parseCustomTypeOption(opt.element, v, errors);
            });
        }
      }
      ts2.parseListTypeOption = parseListTypeOption;
      function getOptionName(option) {
        return option.name;
      }
      function createUnknownOptionError(unknownOption, diagnostics, createDiagnostics, unknownOptionErrorText) {
        var possibleOption = ts2.getSpellingSuggestion(unknownOption, diagnostics.optionDeclarations, getOptionName);
        return possibleOption ? createDiagnostics(diagnostics.unknownDidYouMeanDiagnostic, unknownOptionErrorText || unknownOption, possibleOption.name) : createDiagnostics(diagnostics.unknownOptionDiagnostic, unknownOptionErrorText || unknownOption);
      }
      function parseCommandLineWorker(diagnostics, commandLine, readFile) {
        var options = {};
        var watchOptions;
        var fileNames = [];
        var errors = [];
        parseStrings(commandLine);
        return {
          options,
          watchOptions,
          fileNames,
          errors
        };
        function parseStrings(args) {
          var i = 0;
          while (i < args.length) {
            var s = args[i];
            i++;
            if (s.charCodeAt(0) === 64) {
              parseResponseFile(s.slice(1));
            } else if (s.charCodeAt(0) === 45) {
              var inputOptionName = s.slice(s.charCodeAt(1) === 45 ? 2 : 1);
              var opt = getOptionDeclarationFromName(diagnostics.getOptionsNameMap, inputOptionName, true);
              if (opt) {
                i = parseOptionValue(args, i, diagnostics, opt, options, errors);
              } else {
                var watchOpt = getOptionDeclarationFromName(watchOptionsDidYouMeanDiagnostics.getOptionsNameMap, inputOptionName, true);
                if (watchOpt) {
                  i = parseOptionValue(args, i, watchOptionsDidYouMeanDiagnostics, watchOpt, watchOptions || (watchOptions = {}), errors);
                } else {
                  errors.push(createUnknownOptionError(inputOptionName, diagnostics, ts2.createCompilerDiagnostic, s));
                }
              }
            } else {
              fileNames.push(s);
            }
          }
        }
        function parseResponseFile(fileName) {
          var text = tryReadFile(fileName, readFile || function(fileName2) {
            return ts2.sys.readFile(fileName2);
          });
          if (!ts2.isString(text)) {
            errors.push(text);
            return;
          }
          var args = [];
          var pos = 0;
          while (true) {
            while (pos < text.length && text.charCodeAt(pos) <= 32)
              pos++;
            if (pos >= text.length)
              break;
            var start = pos;
            if (text.charCodeAt(start) === 34) {
              pos++;
              while (pos < text.length && text.charCodeAt(pos) !== 34)
                pos++;
              if (pos < text.length) {
                args.push(text.substring(start + 1, pos));
                pos++;
              } else {
                errors.push(ts2.createCompilerDiagnostic(ts2.Diagnostics.Unterminated_quoted_string_in_response_file_0, fileName));
              }
            } else {
              while (text.charCodeAt(pos) > 32)
                pos++;
              args.push(text.substring(start, pos));
            }
          }
          parseStrings(args);
        }
      }
      ts2.parseCommandLineWorker = parseCommandLineWorker;
      function parseOptionValue(args, i, diagnostics, opt, options, errors) {
        if (opt.isTSConfigOnly) {
          var optValue = args[i];
          if (optValue === "null") {
            options[opt.name] = void 0;
            i++;
          } else if (opt.type === "boolean") {
            if (optValue === "false") {
              options[opt.name] = false;
              i++;
            } else {
              if (optValue === "true")
                i++;
              errors.push(ts2.createCompilerDiagnostic(ts2.Diagnostics.Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line, opt.name));
            }
          } else {
            errors.push(ts2.createCompilerDiagnostic(ts2.Diagnostics.Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line, opt.name));
            if (optValue && !ts2.startsWith(optValue, "-"))
              i++;
          }
        } else {
          if (!args[i] && opt.type !== "boolean") {
            errors.push(ts2.createCompilerDiagnostic(diagnostics.optionTypeMismatchDiagnostic, opt.name, getCompilerOptionValueTypeString(opt)));
          }
          if (args[i] !== "null") {
            switch (opt.type) {
              case "number":
                options[opt.name] = parseInt(args[i]);
                i++;
                break;
              case "boolean":
                var optValue = args[i];
                options[opt.name] = optValue !== "false";
                if (optValue === "false" || optValue === "true") {
                  i++;
                }
                break;
              case "string":
                options[opt.name] = args[i] || "";
                i++;
                break;
              case "list":
                var result = parseListTypeOption(opt, args[i], errors);
                options[opt.name] = result || [];
                if (result) {
                  i++;
                }
                break;
              default:
                options[opt.name] = parseCustomTypeOption(opt, args[i], errors);
                i++;
                break;
            }
          } else {
            options[opt.name] = void 0;
            i++;
          }
        }
        return i;
      }
      ts2.compilerOptionsDidYouMeanDiagnostics = {
        getOptionsNameMap,
        optionDeclarations: ts2.optionDeclarations,
        unknownOptionDiagnostic: ts2.Diagnostics.Unknown_compiler_option_0,
        unknownDidYouMeanDiagnostic: ts2.Diagnostics.Unknown_compiler_option_0_Did_you_mean_1,
        optionTypeMismatchDiagnostic: ts2.Diagnostics.Compiler_option_0_expects_an_argument
      };
      function parseCommandLine(commandLine, readFile) {
        return parseCommandLineWorker(ts2.compilerOptionsDidYouMeanDiagnostics, commandLine, readFile);
      }
      ts2.parseCommandLine = parseCommandLine;
      function getOptionFromName(optionName, allowShort) {
        return getOptionDeclarationFromName(getOptionsNameMap, optionName, allowShort);
      }
      ts2.getOptionFromName = getOptionFromName;
      function getOptionDeclarationFromName(getOptionNameMap, optionName, allowShort) {
        if (allowShort === void 0) {
          allowShort = false;
        }
        optionName = optionName.toLowerCase();
        var _a = getOptionNameMap(), optionsNameMap = _a.optionsNameMap, shortOptionNames = _a.shortOptionNames;
        if (allowShort) {
          var short = shortOptionNames.get(optionName);
          if (short !== void 0) {
            optionName = short;
          }
        }
        return optionsNameMap.get(optionName);
      }
      var buildOptionsNameMapCache;
      function getBuildOptionsNameMap() {
        return buildOptionsNameMapCache || (buildOptionsNameMapCache = createOptionNameMap(ts2.buildOpts));
      }
      var buildOptionsDidYouMeanDiagnostics = {
        getOptionsNameMap: getBuildOptionsNameMap,
        optionDeclarations: ts2.buildOpts,
        unknownOptionDiagnostic: ts2.Diagnostics.Unknown_build_option_0,
        unknownDidYouMeanDiagnostic: ts2.Diagnostics.Unknown_build_option_0_Did_you_mean_1,
        optionTypeMismatchDiagnostic: ts2.Diagnostics.Build_option_0_requires_a_value_of_type_1
      };
      function parseBuildCommand(args) {
        var _a = parseCommandLineWorker(buildOptionsDidYouMeanDiagnostics, args), options = _a.options, watchOptions = _a.watchOptions, projects = _a.fileNames, errors = _a.errors;
        var buildOptions = options;
        if (projects.length === 0) {
          projects.push(".");
        }
        if (buildOptions.clean && buildOptions.force) {
          errors.push(ts2.createCompilerDiagnostic(ts2.Diagnostics.Options_0_and_1_cannot_be_combined, "clean", "force"));
        }
        if (buildOptions.clean && buildOptions.verbose) {
          errors.push(ts2.createCompilerDiagnostic(ts2.Diagnostics.Options_0_and_1_cannot_be_combined, "clean", "verbose"));
        }
        if (buildOptions.clean && buildOptions.watch) {
          errors.push(ts2.createCompilerDiagnostic(ts2.Diagnostics.Options_0_and_1_cannot_be_combined, "clean", "watch"));
        }
        if (buildOptions.watch && buildOptions.dry) {
          errors.push(ts2.createCompilerDiagnostic(ts2.Diagnostics.Options_0_and_1_cannot_be_combined, "watch", "dry"));
        }
        return { buildOptions, watchOptions, projects, errors };
      }
      ts2.parseBuildCommand = parseBuildCommand;
      function getDiagnosticText(_message) {
        var _args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
          _args[_i - 1] = arguments[_i];
        }
        var diagnostic = ts2.createCompilerDiagnostic.apply(void 0, arguments);
        return diagnostic.messageText;
      }
      ts2.getDiagnosticText = getDiagnosticText;
      function getParsedCommandLineOfConfigFile(configFileName, optionsToExtend, host, extendedConfigCache, watchOptionsToExtend, extraFileExtensions) {
        var configFileText = tryReadFile(configFileName, function(fileName) {
          return host.readFile(fileName);
        });
        if (!ts2.isString(configFileText)) {
          host.onUnRecoverableConfigFileDiagnostic(configFileText);
          return void 0;
        }
        var result = ts2.parseJsonText(configFileName, configFileText);
        var cwd = host.getCurrentDirectory();
        result.path = ts2.toPath(configFileName, cwd, ts2.createGetCanonicalFileName(host.useCaseSensitiveFileNames));
        result.resolvedPath = result.path;
        result.originalFileName = result.fileName;
        return parseJsonSourceFileConfigFileContent(result, host, ts2.getNormalizedAbsolutePath(ts2.getDirectoryPath(configFileName), cwd), optionsToExtend, ts2.getNormalizedAbsolutePath(configFileName, cwd), void 0, extraFileExtensions, extendedConfigCache, watchOptionsToExtend);
      }
      ts2.getParsedCommandLineOfConfigFile = getParsedCommandLineOfConfigFile;
      function readConfigFile(fileName, readFile) {
        var textOrDiagnostic = tryReadFile(fileName, readFile);
        return ts2.isString(textOrDiagnostic) ? parseConfigFileTextToJson(fileName, textOrDiagnostic) : { config: {}, error: textOrDiagnostic };
      }
      ts2.readConfigFile = readConfigFile;
      function parseConfigFileTextToJson(fileName, jsonText) {
        var jsonSourceFile = ts2.parseJsonText(fileName, jsonText);
        return {
          config: convertToObject(jsonSourceFile, jsonSourceFile.parseDiagnostics),
          error: jsonSourceFile.parseDiagnostics.length ? jsonSourceFile.parseDiagnostics[0] : void 0
        };
      }
      ts2.parseConfigFileTextToJson = parseConfigFileTextToJson;
      function readJsonConfigFile(fileName, readFile) {
        var textOrDiagnostic = tryReadFile(fileName, readFile);
        return ts2.isString(textOrDiagnostic) ? ts2.parseJsonText(fileName, textOrDiagnostic) : { parseDiagnostics: [textOrDiagnostic] };
      }
      ts2.readJsonConfigFile = readJsonConfigFile;
      function tryReadFile(fileName, readFile) {
        var text;
        try {
          text = readFile(fileName);
        } catch (e) {
          return ts2.createCompilerDiagnostic(ts2.Diagnostics.Cannot_read_file_0_Colon_1, fileName, e.message);
        }
        return text === void 0 ? ts2.createCompilerDiagnostic(ts2.Diagnostics.Cannot_read_file_0, fileName) : text;
      }
      ts2.tryReadFile = tryReadFile;
      function commandLineOptionsToMap(options) {
        return ts2.arrayToMap(options, getOptionName);
      }
      var typeAcquisitionDidYouMeanDiagnostics = {
        optionDeclarations: ts2.typeAcquisitionDeclarations,
        unknownOptionDiagnostic: ts2.Diagnostics.Unknown_type_acquisition_option_0,
        unknownDidYouMeanDiagnostic: ts2.Diagnostics.Unknown_type_acquisition_option_0_Did_you_mean_1
      };
      var watchOptionsNameMapCache;
      function getWatchOptionsNameMap() {
        return watchOptionsNameMapCache || (watchOptionsNameMapCache = createOptionNameMap(ts2.optionsForWatch));
      }
      var watchOptionsDidYouMeanDiagnostics = {
        getOptionsNameMap: getWatchOptionsNameMap,
        optionDeclarations: ts2.optionsForWatch,
        unknownOptionDiagnostic: ts2.Diagnostics.Unknown_watch_option_0,
        unknownDidYouMeanDiagnostic: ts2.Diagnostics.Unknown_watch_option_0_Did_you_mean_1,
        optionTypeMismatchDiagnostic: ts2.Diagnostics.Watch_option_0_requires_a_value_of_type_1
      };
      var commandLineCompilerOptionsMapCache;
      function getCommandLineCompilerOptionsMap() {
        return commandLineCompilerOptionsMapCache || (commandLineCompilerOptionsMapCache = commandLineOptionsToMap(ts2.optionDeclarations));
      }
      var commandLineWatchOptionsMapCache;
      function getCommandLineWatchOptionsMap() {
        return commandLineWatchOptionsMapCache || (commandLineWatchOptionsMapCache = commandLineOptionsToMap(ts2.optionsForWatch));
      }
      var commandLineTypeAcquisitionMapCache;
      function getCommandLineTypeAcquisitionMap() {
        return commandLineTypeAcquisitionMapCache || (commandLineTypeAcquisitionMapCache = commandLineOptionsToMap(ts2.typeAcquisitionDeclarations));
      }
      var _tsconfigRootOptions;
      function getTsconfigRootOptionsMap() {
        if (_tsconfigRootOptions === void 0) {
          _tsconfigRootOptions = {
            name: void 0,
            type: "object",
            elementOptions: commandLineOptionsToMap([
              {
                name: "compilerOptions",
                type: "object",
                elementOptions: getCommandLineCompilerOptionsMap(),
                extraKeyDiagnostics: ts2.compilerOptionsDidYouMeanDiagnostics
              },
              {
                name: "watchOptions",
                type: "object",
                elementOptions: getCommandLineWatchOptionsMap(),
                extraKeyDiagnostics: watchOptionsDidYouMeanDiagnostics
              },
              {
                name: "typingOptions",
                type: "object",
                elementOptions: getCommandLineTypeAcquisitionMap(),
                extraKeyDiagnostics: typeAcquisitionDidYouMeanDiagnostics
              },
              {
                name: "typeAcquisition",
                type: "object",
                elementOptions: getCommandLineTypeAcquisitionMap(),
                extraKeyDiagnostics: typeAcquisitionDidYouMeanDiagnostics
              },
              {
                name: "extends",
                type: "string"
              },
              {
                name: "references",
                type: "list",
                element: {
                  name: "references",
                  type: "object"
                }
              },
              {
                name: "files",
                type: "list",
                element: {
                  name: "files",
                  type: "string"
                }
              },
              {
                name: "include",
                type: "list",
                element: {
                  name: "include",
                  type: "string"
                }
              },
              {
                name: "exclude",
                type: "list",
                element: {
                  name: "exclude",
                  type: "string"
                }
              },
              ts2.compileOnSaveCommandLineOption
            ])
          };
        }
        return _tsconfigRootOptions;
      }
      function convertToObject(sourceFile, errors) {
        return convertToObjectWorker(sourceFile, errors, true, void 0, void 0);
      }
      ts2.convertToObject = convertToObject;
      function convertToObjectWorker(sourceFile, errors, returnValue, knownRootOptions, jsonConversionNotifier) {
        if (!sourceFile.statements.length) {
          return returnValue ? {} : void 0;
        }
        return convertPropertyValueToJson(sourceFile.statements[0].expression, knownRootOptions);
        function isRootOptionMap(knownOptions) {
          return knownRootOptions && knownRootOptions.elementOptions === knownOptions;
        }
        function convertObjectLiteralExpressionToJson(node, knownOptions, extraKeyDiagnostics, parentOption) {
          var result = returnValue ? {} : void 0;
          var _loop_3 = function(element2) {
            if (element2.kind !== 281) {
              errors.push(ts2.createDiagnosticForNodeInSourceFile(sourceFile, element2, ts2.Diagnostics.Property_assignment_expected));
              return "continue";
            }
            if (element2.questionToken) {
              errors.push(ts2.createDiagnosticForNodeInSourceFile(sourceFile, element2.questionToken, ts2.Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, "?"));
            }
            if (!isDoubleQuotedString(element2.name)) {
              errors.push(ts2.createDiagnosticForNodeInSourceFile(sourceFile, element2.name, ts2.Diagnostics.String_literal_with_double_quotes_expected));
            }
            var textOfKey = ts2.isComputedNonLiteralName(element2.name) ? void 0 : ts2.getTextOfPropertyName(element2.name);
            var keyText = textOfKey && ts2.unescapeLeadingUnderscores(textOfKey);
            var option = keyText && knownOptions ? knownOptions.get(keyText) : void 0;
            if (keyText && extraKeyDiagnostics && !option) {
              if (knownOptions) {
                errors.push(createUnknownOptionError(keyText, extraKeyDiagnostics, function(message, arg0, arg1) {
                  return ts2.createDiagnosticForNodeInSourceFile(sourceFile, element2.name, message, arg0, arg1);
                }));
              } else {
                errors.push(ts2.createDiagnosticForNodeInSourceFile(sourceFile, element2.name, extraKeyDiagnostics.unknownOptionDiagnostic, keyText));
              }
            }
            var value = convertPropertyValueToJson(element2.initializer, option);
            if (typeof keyText !== "undefined") {
              if (returnValue) {
                result[keyText] = value;
              }
              if (jsonConversionNotifier && (parentOption || isRootOptionMap(knownOptions))) {
                var isValidOptionValue = isCompilerOptionsValue(option, value);
                if (parentOption) {
                  if (isValidOptionValue) {
                    jsonConversionNotifier.onSetValidOptionKeyValueInParent(parentOption, option, value);
                  }
                } else if (isRootOptionMap(knownOptions)) {
                  if (isValidOptionValue) {
                    jsonConversionNotifier.onSetValidOptionKeyValueInRoot(keyText, element2.name, value, element2.initializer);
                  } else if (!option) {
                    jsonConversionNotifier.onSetUnknownOptionKeyValueInRoot(keyText, element2.name, value, element2.initializer);
                  }
                }
              }
            }
          };
          for (var _i = 0, _a = node.properties; _i < _a.length; _i++) {
            var element = _a[_i];
            _loop_3(element);
          }
          return result;
        }
        function convertArrayLiteralExpressionToJson(elements, elementOption) {
          if (!returnValue) {
            return elements.forEach(function(element) {
              return convertPropertyValueToJson(element, elementOption);
            });
          }
          return ts2.filter(elements.map(function(element) {
            return convertPropertyValueToJson(element, elementOption);
          }), function(v) {
            return v !== void 0;
          });
        }
        function convertPropertyValueToJson(valueExpression, option) {
          switch (valueExpression.kind) {
            case 106:
              reportInvalidOptionValue(option && option.type !== "boolean");
              return true;
            case 91:
              reportInvalidOptionValue(option && option.type !== "boolean");
              return false;
            case 100:
              reportInvalidOptionValue(option && option.name === "extends");
              return null;
            case 10:
              if (!isDoubleQuotedString(valueExpression)) {
                errors.push(ts2.createDiagnosticForNodeInSourceFile(sourceFile, valueExpression, ts2.Diagnostics.String_literal_with_double_quotes_expected));
              }
              reportInvalidOptionValue(option && (ts2.isString(option.type) && option.type !== "string"));
              var text = valueExpression.text;
              if (option && !ts2.isString(option.type)) {
                var customOption = option;
                if (!customOption.type.has(text.toLowerCase())) {
                  errors.push(createDiagnosticForInvalidCustomType(customOption, function(message, arg0, arg1) {
                    return ts2.createDiagnosticForNodeInSourceFile(sourceFile, valueExpression, message, arg0, arg1);
                  }));
                }
              }
              return text;
            case 8:
              reportInvalidOptionValue(option && option.type !== "number");
              return Number(valueExpression.text);
            case 207:
              if (valueExpression.operator !== 40 || valueExpression.operand.kind !== 8) {
                break;
              }
              reportInvalidOptionValue(option && option.type !== "number");
              return -Number(valueExpression.operand.text);
            case 193:
              reportInvalidOptionValue(option && option.type !== "object");
              var objectLiteralExpression = valueExpression;
              if (option) {
                var _a = option, elementOptions = _a.elementOptions, extraKeyDiagnostics = _a.extraKeyDiagnostics, optionName = _a.name;
                return convertObjectLiteralExpressionToJson(objectLiteralExpression, elementOptions, extraKeyDiagnostics, optionName);
              } else {
                return convertObjectLiteralExpressionToJson(objectLiteralExpression, void 0, void 0, void 0);
              }
            case 192:
              reportInvalidOptionValue(option && option.type !== "list");
              return convertArrayLiteralExpressionToJson(valueExpression.elements, option && option.element);
          }
          if (option) {
            reportInvalidOptionValue(true);
          } else {
            errors.push(ts2.createDiagnosticForNodeInSourceFile(sourceFile, valueExpression, ts2.Diagnostics.Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_literal));
          }
          return void 0;
          function reportInvalidOptionValue(isError) {
            if (isError) {
              errors.push(ts2.createDiagnosticForNodeInSourceFile(sourceFile, valueExpression, ts2.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, option.name, getCompilerOptionValueTypeString(option)));
            }
          }
        }
        function isDoubleQuotedString(node) {
          return ts2.isStringLiteral(node) && ts2.isStringDoubleQuoted(node, sourceFile);
        }
      }
      ts2.convertToObjectWorker = convertToObjectWorker;
      function getCompilerOptionValueTypeString(option) {
        return option.type === "list" ? "Array" : ts2.isString(option.type) ? option.type : "string";
      }
      function isCompilerOptionsValue(option, value) {
        if (option) {
          if (isNullOrUndefined(value))
            return true;
          if (option.type === "list") {
            return ts2.isArray(value);
          }
          var expectedType = ts2.isString(option.type) ? option.type : "string";
          return typeof value === expectedType;
        }
        return false;
      }
      function convertToTSConfig(configParseResult, configFileName, host) {
        var getCanonicalFileName = ts2.createGetCanonicalFileName(host.useCaseSensitiveFileNames);
        var files = ts2.map(ts2.filter(configParseResult.fileNames, !configParseResult.configFileSpecs || !configParseResult.configFileSpecs.validatedIncludeSpecs ? function(_) {
          return true;
        } : matchesSpecs(configFileName, configParseResult.configFileSpecs.validatedIncludeSpecs, configParseResult.configFileSpecs.validatedExcludeSpecs, host)), function(f) {
          return ts2.getRelativePathFromFile(ts2.getNormalizedAbsolutePath(configFileName, host.getCurrentDirectory()), ts2.getNormalizedAbsolutePath(f, host.getCurrentDirectory()), getCanonicalFileName);
        });
        var optionMap = serializeCompilerOptions(configParseResult.options, { configFilePath: ts2.getNormalizedAbsolutePath(configFileName, host.getCurrentDirectory()), useCaseSensitiveFileNames: host.useCaseSensitiveFileNames });
        var watchOptionMap = configParseResult.watchOptions && serializeWatchOptions(configParseResult.watchOptions);
        var config = __assign(__assign({ compilerOptions: __assign(__assign({}, optionMapToObject(optionMap)), { showConfig: void 0, configFile: void 0, configFilePath: void 0, help: void 0, init: void 0, listFiles: void 0, listEmittedFiles: void 0, project: void 0, build: void 0, version: void 0 }), watchOptions: watchOptionMap && optionMapToObject(watchOptionMap), references: ts2.map(configParseResult.projectReferences, function(r) {
          return __assign(__assign({}, r), { path: r.originalPath ? r.originalPath : "", originalPath: void 0 });
        }), files: ts2.length(files) ? files : void 0 }, configParseResult.configFileSpecs ? {
          include: filterSameAsDefaultInclude(configParseResult.configFileSpecs.validatedIncludeSpecs),
          exclude: configParseResult.configFileSpecs.validatedExcludeSpecs
        } : {}), { compileOnSave: !!configParseResult.compileOnSave ? true : void 0 });
        return config;
      }
      ts2.convertToTSConfig = convertToTSConfig;
      function optionMapToObject(optionMap) {
        return __assign({}, ts2.arrayFrom(optionMap.entries()).reduce(function(prev, cur) {
          var _a;
          return __assign(__assign({}, prev), (_a = {}, _a[cur[0]] = cur[1], _a));
        }, {}));
      }
      function filterSameAsDefaultInclude(specs) {
        if (!ts2.length(specs))
          return void 0;
        if (ts2.length(specs) !== 1)
          return specs;
        if (specs[0] === "**/*")
          return void 0;
        return specs;
      }
      function matchesSpecs(path2, includeSpecs, excludeSpecs, host) {
        if (!includeSpecs)
          return function(_) {
            return true;
          };
        var patterns = ts2.getFileMatcherPatterns(path2, excludeSpecs, includeSpecs, host.useCaseSensitiveFileNames, host.getCurrentDirectory());
        var excludeRe = patterns.excludePattern && ts2.getRegexFromPattern(patterns.excludePattern, host.useCaseSensitiveFileNames);
        var includeRe = patterns.includeFilePattern && ts2.getRegexFromPattern(patterns.includeFilePattern, host.useCaseSensitiveFileNames);
        if (includeRe) {
          if (excludeRe) {
            return function(path3) {
              return !(includeRe.test(path3) && !excludeRe.test(path3));
            };
          }
          return function(path3) {
            return !includeRe.test(path3);
          };
        }
        if (excludeRe) {
          return function(path3) {
            return excludeRe.test(path3);
          };
        }
        return function(_) {
          return true;
        };
      }
      function getCustomTypeMapOfCommandLineOption(optionDefinition) {
        if (optionDefinition.type === "string" || optionDefinition.type === "number" || optionDefinition.type === "boolean" || optionDefinition.type === "object") {
          return void 0;
        } else if (optionDefinition.type === "list") {
          return getCustomTypeMapOfCommandLineOption(optionDefinition.element);
        } else {
          return optionDefinition.type;
        }
      }
      function getNameOfCompilerOptionValue(value, customTypeMap) {
        return ts2.forEachEntry(customTypeMap, function(mapValue, key) {
          if (mapValue === value) {
            return key;
          }
        });
      }
      function serializeCompilerOptions(options, pathOptions) {
        return serializeOptionBaseObject(options, getOptionsNameMap(), pathOptions);
      }
      function serializeWatchOptions(options) {
        return serializeOptionBaseObject(options, getWatchOptionsNameMap());
      }
      function serializeOptionBaseObject(options, _a, pathOptions) {
        var optionsNameMap = _a.optionsNameMap;
        var result = ts2.createMap();
        var getCanonicalFileName = pathOptions && ts2.createGetCanonicalFileName(pathOptions.useCaseSensitiveFileNames);
        var _loop_4 = function(name2) {
          if (ts2.hasProperty(options, name2)) {
            if (optionsNameMap.has(name2) && optionsNameMap.get(name2).category === ts2.Diagnostics.Command_line_Options) {
              return "continue";
            }
            var value = options[name2];
            var optionDefinition = optionsNameMap.get(name2.toLowerCase());
            if (optionDefinition) {
              var customTypeMap_1 = getCustomTypeMapOfCommandLineOption(optionDefinition);
              if (!customTypeMap_1) {
                if (pathOptions && optionDefinition.isFilePath) {
                  result.set(name2, ts2.getRelativePathFromFile(pathOptions.configFilePath, ts2.getNormalizedAbsolutePath(value, ts2.getDirectoryPath(pathOptions.configFilePath)), getCanonicalFileName));
                } else {
                  result.set(name2, value);
                }
              } else {
                if (optionDefinition.type === "list") {
                  result.set(name2, value.map(function(element) {
                    return getNameOfCompilerOptionValue(element, customTypeMap_1);
                  }));
                } else {
                  result.set(name2, getNameOfCompilerOptionValue(value, customTypeMap_1));
                }
              }
            }
          }
        };
        for (var name in options) {
          _loop_4(name);
        }
        return result;
      }
      function generateTSConfig(options, fileNames, newLine) {
        var compilerOptions = ts2.extend(options, ts2.defaultInitCompilerOptions);
        var compilerOptionsMap = serializeCompilerOptions(compilerOptions);
        return writeConfigurations();
        function getDefaultValueForOption(option) {
          switch (option.type) {
            case "number":
              return 1;
            case "boolean":
              return true;
            case "string":
              return option.isFilePath ? "./" : "";
            case "list":
              return [];
            case "object":
              return {};
            default:
              var iterResult = option.type.keys().next();
              if (!iterResult.done)
                return iterResult.value;
              return ts2.Debug.fail("Expected 'option.type' to have entries.");
          }
        }
        function makePadding(paddingLength) {
          return Array(paddingLength + 1).join(" ");
        }
        function isAllowedOption(_a) {
          var category = _a.category, name = _a.name;
          return category !== void 0 && category !== ts2.Diagnostics.Command_line_Options && (category !== ts2.Diagnostics.Advanced_Options || compilerOptionsMap.has(name));
        }
        function writeConfigurations() {
          var categorizedOptions = ts2.createMultiMap();
          for (var _i = 0, optionDeclarations_1 = ts2.optionDeclarations; _i < optionDeclarations_1.length; _i++) {
            var option = optionDeclarations_1[_i];
            var category = option.category;
            if (isAllowedOption(option)) {
              categorizedOptions.add(ts2.getLocaleSpecificMessage(category), option);
            }
          }
          var marginLength = 0;
          var seenKnownKeys = 0;
          var entries = [];
          categorizedOptions.forEach(function(options2, category2) {
            if (entries.length !== 0) {
              entries.push({ value: "" });
            }
            entries.push({ value: "/* " + category2 + " */" });
            for (var _i2 = 0, options_1 = options2; _i2 < options_1.length; _i2++) {
              var option2 = options_1[_i2];
              var optionName = void 0;
              if (compilerOptionsMap.has(option2.name)) {
                optionName = '"' + option2.name + '": ' + JSON.stringify(compilerOptionsMap.get(option2.name)) + ((seenKnownKeys += 1) === compilerOptionsMap.size ? "" : ",");
              } else {
                optionName = '// "' + option2.name + '": ' + JSON.stringify(getDefaultValueForOption(option2)) + ",";
              }
              entries.push({
                value: optionName,
                description: "/* " + (option2.description && ts2.getLocaleSpecificMessage(option2.description) || option2.name) + " */"
              });
              marginLength = Math.max(optionName.length, marginLength);
            }
          });
          var tab = makePadding(2);
          var result = [];
          result.push("{");
          result.push(tab + '"compilerOptions": {');
          result.push("" + tab + tab + "/* " + ts2.getLocaleSpecificMessage(ts2.Diagnostics.Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_json_to_read_more_about_this_file) + " */");
          result.push("");
          for (var _a = 0, entries_3 = entries; _a < entries_3.length; _a++) {
            var entry = entries_3[_a];
            var value = entry.value, _b = entry.description, description = _b === void 0 ? "" : _b;
            result.push(value && "" + tab + tab + value + (description && makePadding(marginLength - value.length + 2) + description));
          }
          if (fileNames.length) {
            result.push(tab + "},");
            result.push(tab + '"files": [');
            for (var i = 0; i < fileNames.length; i++) {
              result.push("" + tab + tab + JSON.stringify(fileNames[i]) + (i === fileNames.length - 1 ? "" : ","));
            }
            result.push(tab + "]");
          } else {
            result.push(tab + "}");
          }
          result.push("}");
          return result.join(newLine) + newLine;
        }
      }
      ts2.generateTSConfig = generateTSConfig;
      function convertToOptionsWithAbsolutePaths(options, toAbsolutePath) {
        var result = {};
        var optionsNameMap = getOptionsNameMap().optionsNameMap;
        for (var name in options) {
          if (ts2.hasProperty(options, name)) {
            result[name] = convertToOptionValueWithAbsolutePaths(optionsNameMap.get(name.toLowerCase()), options[name], toAbsolutePath);
          }
        }
        if (result.configFilePath) {
          result.configFilePath = toAbsolutePath(result.configFilePath);
        }
        return result;
      }
      ts2.convertToOptionsWithAbsolutePaths = convertToOptionsWithAbsolutePaths;
      function convertToOptionValueWithAbsolutePaths(option, value, toAbsolutePath) {
        if (option && !isNullOrUndefined(value)) {
          if (option.type === "list") {
            var values = value;
            if (option.element.isFilePath && values.length) {
              return values.map(toAbsolutePath);
            }
          } else if (option.isFilePath) {
            return toAbsolutePath(value);
          }
        }
        return value;
      }
      function parseJsonConfigFileContent(json, host, basePath, existingOptions, configFileName, resolutionStack, extraFileExtensions, extendedConfigCache, existingWatchOptions) {
        return parseJsonConfigFileContentWorker(json, void 0, host, basePath, existingOptions, existingWatchOptions, configFileName, resolutionStack, extraFileExtensions, extendedConfigCache);
      }
      ts2.parseJsonConfigFileContent = parseJsonConfigFileContent;
      function parseJsonSourceFileConfigFileContent(sourceFile, host, basePath, existingOptions, configFileName, resolutionStack, extraFileExtensions, extendedConfigCache, existingWatchOptions) {
        return parseJsonConfigFileContentWorker(void 0, sourceFile, host, basePath, existingOptions, existingWatchOptions, configFileName, resolutionStack, extraFileExtensions, extendedConfigCache);
      }
      ts2.parseJsonSourceFileConfigFileContent = parseJsonSourceFileConfigFileContent;
      function setConfigFileInOptions(options, configFile) {
        if (configFile) {
          Object.defineProperty(options, "configFile", { enumerable: false, writable: false, value: configFile });
        }
      }
      ts2.setConfigFileInOptions = setConfigFileInOptions;
      function isNullOrUndefined(x) {
        return x === void 0 || x === null;
      }
      function directoryOfCombinedPath(fileName, basePath) {
        return ts2.getDirectoryPath(ts2.getNormalizedAbsolutePath(fileName, basePath));
      }
      function parseJsonConfigFileContentWorker(json, sourceFile, host, basePath, existingOptions, existingWatchOptions, configFileName, resolutionStack, extraFileExtensions, extendedConfigCache) {
        if (existingOptions === void 0) {
          existingOptions = {};
        }
        if (resolutionStack === void 0) {
          resolutionStack = [];
        }
        if (extraFileExtensions === void 0) {
          extraFileExtensions = [];
        }
        ts2.Debug.assert(json === void 0 && sourceFile !== void 0 || json !== void 0 && sourceFile === void 0);
        var errors = [];
        var parsedConfig = parseConfig(json, sourceFile, host, basePath, configFileName, resolutionStack, errors, extendedConfigCache);
        var raw = parsedConfig.raw;
        var options = ts2.extend(existingOptions, parsedConfig.options || {});
        var watchOptions = existingWatchOptions && parsedConfig.watchOptions ? ts2.extend(existingWatchOptions, parsedConfig.watchOptions) : parsedConfig.watchOptions || existingWatchOptions;
        options.configFilePath = configFileName && ts2.normalizeSlashes(configFileName);
        setConfigFileInOptions(options, sourceFile);
        var projectReferences;
        var _a = getFileNames(), fileNames = _a.fileNames, wildcardDirectories = _a.wildcardDirectories, spec = _a.spec;
        return {
          options,
          watchOptions,
          fileNames,
          projectReferences,
          typeAcquisition: parsedConfig.typeAcquisition || getDefaultTypeAcquisition(),
          raw,
          errors,
          wildcardDirectories,
          compileOnSave: !!raw.compileOnSave,
          configFileSpecs: spec
        };
        function getFileNames() {
          var filesSpecs;
          if (ts2.hasProperty(raw, "files") && !isNullOrUndefined(raw.files)) {
            if (ts2.isArray(raw.files)) {
              filesSpecs = raw.files;
              var hasReferences = ts2.hasProperty(raw, "references") && !isNullOrUndefined(raw.references);
              var hasZeroOrNoReferences = !hasReferences || raw.references.length === 0;
              var hasExtends = ts2.hasProperty(raw, "extends");
              if (filesSpecs.length === 0 && hasZeroOrNoReferences && !hasExtends) {
                if (sourceFile) {
                  var fileName = configFileName || "tsconfig.json";
                  var diagnosticMessage = ts2.Diagnostics.The_files_list_in_config_file_0_is_empty;
                  var nodeValue = ts2.firstDefined(ts2.getTsConfigPropArray(sourceFile, "files"), function(property) {
                    return property.initializer;
                  });
                  var error = nodeValue ? ts2.createDiagnosticForNodeInSourceFile(sourceFile, nodeValue, diagnosticMessage, fileName) : ts2.createCompilerDiagnostic(diagnosticMessage, fileName);
                  errors.push(error);
                } else {
                  createCompilerDiagnosticOnlyIfJson(ts2.Diagnostics.The_files_list_in_config_file_0_is_empty, configFileName || "tsconfig.json");
                }
              }
            } else {
              createCompilerDiagnosticOnlyIfJson(ts2.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, "files", "Array");
            }
          }
          var includeSpecs;
          if (ts2.hasProperty(raw, "include") && !isNullOrUndefined(raw.include)) {
            if (ts2.isArray(raw.include)) {
              includeSpecs = raw.include;
            } else {
              createCompilerDiagnosticOnlyIfJson(ts2.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, "include", "Array");
            }
          }
          var excludeSpecs;
          if (ts2.hasProperty(raw, "exclude") && !isNullOrUndefined(raw.exclude)) {
            if (ts2.isArray(raw.exclude)) {
              excludeSpecs = raw.exclude;
            } else {
              createCompilerDiagnosticOnlyIfJson(ts2.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, "exclude", "Array");
            }
          } else if (raw.compilerOptions) {
            var outDir = raw.compilerOptions.outDir;
            var declarationDir = raw.compilerOptions.declarationDir;
            if (outDir || declarationDir) {
              excludeSpecs = [outDir, declarationDir].filter(function(d) {
                return !!d;
              });
            }
          }
          if (filesSpecs === void 0 && includeSpecs === void 0) {
            includeSpecs = ["**/*"];
          }
          var result = matchFileNames(filesSpecs, includeSpecs, excludeSpecs, configFileName ? directoryOfCombinedPath(configFileName, basePath) : basePath, options, host, errors, extraFileExtensions, sourceFile);
          if (shouldReportNoInputFiles(result, canJsonReportNoInutFiles(raw), resolutionStack)) {
            errors.push(getErrorForNoInputFiles(result.spec, configFileName));
          }
          if (ts2.hasProperty(raw, "references") && !isNullOrUndefined(raw.references)) {
            if (ts2.isArray(raw.references)) {
              for (var _i = 0, _a2 = raw.references; _i < _a2.length; _i++) {
                var ref = _a2[_i];
                if (typeof ref.path !== "string") {
                  createCompilerDiagnosticOnlyIfJson(ts2.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, "reference.path", "string");
                } else {
                  (projectReferences || (projectReferences = [])).push({
                    path: ts2.getNormalizedAbsolutePath(ref.path, basePath),
                    originalPath: ref.path,
                    prepend: ref.prepend,
                    circular: ref.circular
                  });
                }
              }
            } else {
              createCompilerDiagnosticOnlyIfJson(ts2.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, "references", "Array");
            }
          }
          return result;
        }
        function createCompilerDiagnosticOnlyIfJson(message, arg0, arg1) {
          if (!sourceFile) {
            errors.push(ts2.createCompilerDiagnostic(message, arg0, arg1));
          }
        }
      }
      function isErrorNoInputFiles(error) {
        return error.code === ts2.Diagnostics.No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2.code;
      }
      function getErrorForNoInputFiles(_a, configFileName) {
        var includeSpecs = _a.includeSpecs, excludeSpecs = _a.excludeSpecs;
        return ts2.createCompilerDiagnostic(ts2.Diagnostics.No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2, configFileName || "tsconfig.json", JSON.stringify(includeSpecs || []), JSON.stringify(excludeSpecs || []));
      }
      function shouldReportNoInputFiles(result, canJsonReportNoInutFiles2, resolutionStack) {
        return result.fileNames.length === 0 && canJsonReportNoInutFiles2 && (!resolutionStack || resolutionStack.length === 0);
      }
      function canJsonReportNoInutFiles(raw) {
        return !ts2.hasProperty(raw, "files") && !ts2.hasProperty(raw, "references");
      }
      ts2.canJsonReportNoInutFiles = canJsonReportNoInutFiles;
      function updateErrorForNoInputFiles(result, configFileName, configFileSpecs, configParseDiagnostics, canJsonReportNoInutFiles2) {
        var existingErrors = configParseDiagnostics.length;
        if (shouldReportNoInputFiles(result, canJsonReportNoInutFiles2)) {
          configParseDiagnostics.push(getErrorForNoInputFiles(configFileSpecs, configFileName));
        } else {
          ts2.filterMutate(configParseDiagnostics, function(error) {
            return !isErrorNoInputFiles(error);
          });
        }
        return existingErrors !== configParseDiagnostics.length;
      }
      ts2.updateErrorForNoInputFiles = updateErrorForNoInputFiles;
      function isSuccessfulParsedTsconfig(value) {
        return !!value.options;
      }
      function parseConfig(json, sourceFile, host, basePath, configFileName, resolutionStack, errors, extendedConfigCache) {
        basePath = ts2.normalizeSlashes(basePath);
        var resolvedPath = ts2.getNormalizedAbsolutePath(configFileName || "", basePath);
        if (resolutionStack.indexOf(resolvedPath) >= 0) {
          errors.push(ts2.createCompilerDiagnostic(ts2.Diagnostics.Circularity_detected_while_resolving_configuration_Colon_0, __spreadArrays(resolutionStack, [resolvedPath]).join(" -> ")));
          return { raw: json || convertToObject(sourceFile, errors) };
        }
        var ownConfig = json ? parseOwnConfigOfJson(json, host, basePath, configFileName, errors) : parseOwnConfigOfJsonSourceFile(sourceFile, host, basePath, configFileName, errors);
        if (ownConfig.extendedConfigPath) {
          resolutionStack = resolutionStack.concat([resolvedPath]);
          var extendedConfig = getExtendedConfig(sourceFile, ownConfig.extendedConfigPath, host, basePath, resolutionStack, errors, extendedConfigCache);
          if (extendedConfig && isSuccessfulParsedTsconfig(extendedConfig)) {
            var baseRaw_1 = extendedConfig.raw;
            var raw_1 = ownConfig.raw;
            var setPropertyInRawIfNotUndefined = function(propertyName) {
              var value = raw_1[propertyName] || baseRaw_1[propertyName];
              if (value) {
                raw_1[propertyName] = value;
              }
            };
            setPropertyInRawIfNotUndefined("include");
            setPropertyInRawIfNotUndefined("exclude");
            setPropertyInRawIfNotUndefined("files");
            if (raw_1.compileOnSave === void 0) {
              raw_1.compileOnSave = baseRaw_1.compileOnSave;
            }
            ownConfig.options = ts2.assign({}, extendedConfig.options, ownConfig.options);
            ownConfig.watchOptions = ownConfig.watchOptions && extendedConfig.watchOptions ? ts2.assign({}, extendedConfig.watchOptions, ownConfig.watchOptions) : ownConfig.watchOptions || extendedConfig.watchOptions;
          }
        }
        return ownConfig;
      }
      function parseOwnConfigOfJson(json, host, basePath, configFileName, errors) {
        if (ts2.hasProperty(json, "excludes")) {
          errors.push(ts2.createCompilerDiagnostic(ts2.Diagnostics.Unknown_option_excludes_Did_you_mean_exclude));
        }
        var options = convertCompilerOptionsFromJsonWorker(json.compilerOptions, basePath, errors, configFileName);
        var typeAcquisition = convertTypeAcquisitionFromJsonWorker(json.typeAcquisition || json.typingOptions, basePath, errors, configFileName);
        var watchOptions = convertWatchOptionsFromJsonWorker(json.watchOptions, basePath, errors);
        json.compileOnSave = convertCompileOnSaveOptionFromJson(json, basePath, errors);
        var extendedConfigPath;
        if (json.extends) {
          if (!ts2.isString(json.extends)) {
            errors.push(ts2.createCompilerDiagnostic(ts2.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, "extends", "string"));
          } else {
            var newBase = configFileName ? directoryOfCombinedPath(configFileName, basePath) : basePath;
            extendedConfigPath = getExtendsConfigPath(json.extends, host, newBase, errors, ts2.createCompilerDiagnostic);
          }
        }
        return { raw: json, options, watchOptions, typeAcquisition, extendedConfigPath };
      }
      function parseOwnConfigOfJsonSourceFile(sourceFile, host, basePath, configFileName, errors) {
        var options = getDefaultCompilerOptions(configFileName);
        var typeAcquisition, typingOptionstypeAcquisition;
        var watchOptions;
        var extendedConfigPath;
        var optionsIterator = {
          onSetValidOptionKeyValueInParent: function(parentOption, option, value) {
            var currentOption;
            switch (parentOption) {
              case "compilerOptions":
                currentOption = options;
                break;
              case "watchOptions":
                currentOption = watchOptions || (watchOptions = {});
                break;
              case "typeAcquisition":
                currentOption = typeAcquisition || (typeAcquisition = getDefaultTypeAcquisition(configFileName));
                break;
              case "typingOptions":
                currentOption = typingOptionstypeAcquisition || (typingOptionstypeAcquisition = getDefaultTypeAcquisition(configFileName));
                break;
              default:
                ts2.Debug.fail("Unknown option");
            }
            currentOption[option.name] = normalizeOptionValue(option, basePath, value);
          },
          onSetValidOptionKeyValueInRoot: function(key, _keyNode, value, valueNode) {
            switch (key) {
              case "extends":
                var newBase = configFileName ? directoryOfCombinedPath(configFileName, basePath) : basePath;
                extendedConfigPath = getExtendsConfigPath(value, host, newBase, errors, function(message, arg0) {
                  return ts2.createDiagnosticForNodeInSourceFile(sourceFile, valueNode, message, arg0);
                });
                return;
            }
          },
          onSetUnknownOptionKeyValueInRoot: function(key, keyNode, _value, _valueNode) {
            if (key === "excludes") {
              errors.push(ts2.createDiagnosticForNodeInSourceFile(sourceFile, keyNode, ts2.Diagnostics.Unknown_option_excludes_Did_you_mean_exclude));
            }
          }
        };
        var json = convertToObjectWorker(sourceFile, errors, true, getTsconfigRootOptionsMap(), optionsIterator);
        if (!typeAcquisition) {
          if (typingOptionstypeAcquisition) {
            typeAcquisition = typingOptionstypeAcquisition.enableAutoDiscovery !== void 0 ? {
              enable: typingOptionstypeAcquisition.enableAutoDiscovery,
              include: typingOptionstypeAcquisition.include,
              exclude: typingOptionstypeAcquisition.exclude
            } : typingOptionstypeAcquisition;
          } else {
            typeAcquisition = getDefaultTypeAcquisition(configFileName);
          }
        }
        return { raw: json, options, watchOptions, typeAcquisition, extendedConfigPath };
      }
      function getExtendsConfigPath(extendedConfig, host, basePath, errors, createDiagnostic) {
        extendedConfig = ts2.normalizeSlashes(extendedConfig);
        if (ts2.isRootedDiskPath(extendedConfig) || ts2.startsWith(extendedConfig, "./") || ts2.startsWith(extendedConfig, "../")) {
          var extendedConfigPath = ts2.getNormalizedAbsolutePath(extendedConfig, basePath);
          if (!host.fileExists(extendedConfigPath) && !ts2.endsWith(extendedConfigPath, ".json")) {
            extendedConfigPath = extendedConfigPath + ".json";
            if (!host.fileExists(extendedConfigPath)) {
              errors.push(createDiagnostic(ts2.Diagnostics.File_0_not_found, extendedConfig));
              return void 0;
            }
          }
          return extendedConfigPath;
        }
        var resolved = ts2.nodeModuleNameResolver(extendedConfig, ts2.combinePaths(basePath, "tsconfig.json"), { moduleResolution: ts2.ModuleResolutionKind.NodeJs }, host, void 0, void 0, true);
        if (resolved.resolvedModule) {
          return resolved.resolvedModule.resolvedFileName;
        }
        errors.push(createDiagnostic(ts2.Diagnostics.File_0_not_found, extendedConfig));
        return void 0;
      }
      function getExtendedConfig(sourceFile, extendedConfigPath, host, basePath, resolutionStack, errors, extendedConfigCache) {
        var _a;
        var path2 = host.useCaseSensitiveFileNames ? extendedConfigPath : ts2.toFileNameLowerCase(extendedConfigPath);
        var value;
        var extendedResult;
        var extendedConfig;
        if (extendedConfigCache && (value = extendedConfigCache.get(path2))) {
          extendedResult = value.extendedResult, extendedConfig = value.extendedConfig;
        } else {
          extendedResult = readJsonConfigFile(extendedConfigPath, function(path3) {
            return host.readFile(path3);
          });
          if (!extendedResult.parseDiagnostics.length) {
            var extendedDirname = ts2.getDirectoryPath(extendedConfigPath);
            extendedConfig = parseConfig(void 0, extendedResult, host, extendedDirname, ts2.getBaseFileName(extendedConfigPath), resolutionStack, errors, extendedConfigCache);
            if (isSuccessfulParsedTsconfig(extendedConfig)) {
              var relativeDifference_1 = ts2.convertToRelativePath(extendedDirname, basePath, ts2.identity);
              var updatePath_1 = function(path3) {
                return ts2.isRootedDiskPath(path3) ? path3 : ts2.combinePaths(relativeDifference_1, path3);
              };
              var mapPropertiesInRawIfNotUndefined = function(propertyName) {
                if (raw_2[propertyName]) {
                  raw_2[propertyName] = ts2.map(raw_2[propertyName], updatePath_1);
                }
              };
              var raw_2 = extendedConfig.raw;
              mapPropertiesInRawIfNotUndefined("include");
              mapPropertiesInRawIfNotUndefined("exclude");
              mapPropertiesInRawIfNotUndefined("files");
            }
          }
          if (extendedConfigCache) {
            extendedConfigCache.set(path2, { extendedResult, extendedConfig });
          }
        }
        if (sourceFile) {
          sourceFile.extendedSourceFiles = [extendedResult.fileName];
          if (extendedResult.extendedSourceFiles) {
            (_a = sourceFile.extendedSourceFiles).push.apply(_a, extendedResult.extendedSourceFiles);
          }
        }
        if (extendedResult.parseDiagnostics.length) {
          errors.push.apply(errors, extendedResult.parseDiagnostics);
          return void 0;
        }
        return extendedConfig;
      }
      function convertCompileOnSaveOptionFromJson(jsonOption, basePath, errors) {
        if (!ts2.hasProperty(jsonOption, ts2.compileOnSaveCommandLineOption.name)) {
          return false;
        }
        var result = convertJsonOption(ts2.compileOnSaveCommandLineOption, jsonOption.compileOnSave, basePath, errors);
        return typeof result === "boolean" && result;
      }
      function convertCompilerOptionsFromJson(jsonOptions, basePath, configFileName) {
        var errors = [];
        var options = convertCompilerOptionsFromJsonWorker(jsonOptions, basePath, errors, configFileName);
        return { options, errors };
      }
      ts2.convertCompilerOptionsFromJson = convertCompilerOptionsFromJson;
      function convertTypeAcquisitionFromJson(jsonOptions, basePath, configFileName) {
        var errors = [];
        var options = convertTypeAcquisitionFromJsonWorker(jsonOptions, basePath, errors, configFileName);
        return { options, errors };
      }
      ts2.convertTypeAcquisitionFromJson = convertTypeAcquisitionFromJson;
      function getDefaultCompilerOptions(configFileName) {
        var options = configFileName && ts2.getBaseFileName(configFileName) === "jsconfig.json" ? { allowJs: true, maxNodeModuleJsDepth: 2, allowSyntheticDefaultImports: true, skipLibCheck: true, noEmit: true } : {};
        return options;
      }
      function convertCompilerOptionsFromJsonWorker(jsonOptions, basePath, errors, configFileName) {
        var options = getDefaultCompilerOptions(configFileName);
        convertOptionsFromJson(getCommandLineCompilerOptionsMap(), jsonOptions, basePath, options, ts2.compilerOptionsDidYouMeanDiagnostics, errors);
        if (configFileName) {
          options.configFilePath = ts2.normalizeSlashes(configFileName);
        }
        return options;
      }
      function getDefaultTypeAcquisition(configFileName) {
        return { enable: !!configFileName && ts2.getBaseFileName(configFileName) === "jsconfig.json", include: [], exclude: [] };
      }
      function convertTypeAcquisitionFromJsonWorker(jsonOptions, basePath, errors, configFileName) {
        var options = getDefaultTypeAcquisition(configFileName);
        var typeAcquisition = convertEnableAutoDiscoveryToEnable(jsonOptions);
        convertOptionsFromJson(getCommandLineTypeAcquisitionMap(), typeAcquisition, basePath, options, typeAcquisitionDidYouMeanDiagnostics, errors);
        return options;
      }
      function convertWatchOptionsFromJsonWorker(jsonOptions, basePath, errors) {
        return convertOptionsFromJson(getCommandLineWatchOptionsMap(), jsonOptions, basePath, void 0, watchOptionsDidYouMeanDiagnostics, errors);
      }
      function convertOptionsFromJson(optionsNameMap, jsonOptions, basePath, defaultOptions, diagnostics, errors) {
        if (!jsonOptions) {
          return;
        }
        for (var id in jsonOptions) {
          var opt = optionsNameMap.get(id);
          if (opt) {
            (defaultOptions || (defaultOptions = {}))[opt.name] = convertJsonOption(opt, jsonOptions[id], basePath, errors);
          } else {
            errors.push(createUnknownOptionError(id, diagnostics, ts2.createCompilerDiagnostic));
          }
        }
        return defaultOptions;
      }
      function convertJsonOption(opt, value, basePath, errors) {
        if (isCompilerOptionsValue(opt, value)) {
          var optType = opt.type;
          if (optType === "list" && ts2.isArray(value)) {
            return convertJsonOptionOfListType(opt, value, basePath, errors);
          } else if (!ts2.isString(optType)) {
            return convertJsonOptionOfCustomType(opt, value, errors);
          }
          return normalizeNonListOptionValue(opt, basePath, value);
        } else {
          errors.push(ts2.createCompilerDiagnostic(ts2.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, opt.name, getCompilerOptionValueTypeString(opt)));
        }
      }
      function normalizeOptionValue(option, basePath, value) {
        if (isNullOrUndefined(value))
          return void 0;
        if (option.type === "list") {
          var listOption_1 = option;
          if (listOption_1.element.isFilePath || !ts2.isString(listOption_1.element.type)) {
            return ts2.filter(ts2.map(value, function(v) {
              return normalizeOptionValue(listOption_1.element, basePath, v);
            }), function(v) {
              return !!v;
            });
          }
          return value;
        } else if (!ts2.isString(option.type)) {
          return option.type.get(ts2.isString(value) ? value.toLowerCase() : value);
        }
        return normalizeNonListOptionValue(option, basePath, value);
      }
      function normalizeNonListOptionValue(option, basePath, value) {
        if (option.isFilePath) {
          value = ts2.getNormalizedAbsolutePath(value, basePath);
          if (value === "") {
            value = ".";
          }
        }
        return value;
      }
      function convertJsonOptionOfCustomType(opt, value, errors) {
        if (isNullOrUndefined(value))
          return void 0;
        var key = value.toLowerCase();
        var val = opt.type.get(key);
        if (val !== void 0) {
          return val;
        } else {
          errors.push(createCompilerDiagnosticForInvalidCustomType(opt));
        }
      }
      function convertJsonOptionOfListType(option, values, basePath, errors) {
        return ts2.filter(ts2.map(values, function(v) {
          return convertJsonOption(option.element, v, basePath, errors);
        }), function(v) {
          return !!v;
        });
      }
      function trimString(s) {
        return typeof s.trim === "function" ? s.trim() : s.replace(/^[\s]+|[\s]+$/g, "");
      }
      var invalidTrailingRecursionPattern = /(^|\/)\*\*\/?$/;
      var invalidDotDotAfterRecursiveWildcardPattern = /(^|\/)\*\*\/(.*\/)?\.\.($|\/)/;
      var watchRecursivePattern = /\/[^/]*?[*?][^/]*\//;
      var wildcardDirectoryPattern = /^[^*?]*(?=\/[^/]*[*?])/;
      function matchFileNames(filesSpecs, includeSpecs, excludeSpecs, basePath, options, host, errors, extraFileExtensions, jsonSourceFile) {
        basePath = ts2.normalizePath(basePath);
        var validatedIncludeSpecs, validatedExcludeSpecs;
        if (includeSpecs) {
          validatedIncludeSpecs = validateSpecs(includeSpecs, errors, false, jsonSourceFile, "include");
        }
        if (excludeSpecs) {
          validatedExcludeSpecs = validateSpecs(excludeSpecs, errors, true, jsonSourceFile, "exclude");
        }
        var wildcardDirectories = getWildcardDirectories(validatedIncludeSpecs, validatedExcludeSpecs, basePath, host.useCaseSensitiveFileNames);
        var spec = { filesSpecs, includeSpecs, excludeSpecs, validatedIncludeSpecs, validatedExcludeSpecs, wildcardDirectories };
        return getFileNamesFromConfigSpecs(spec, basePath, options, host, extraFileExtensions);
      }
      function getFileNamesFromConfigSpecs(spec, basePath, options, host, extraFileExtensions) {
        if (extraFileExtensions === void 0) {
          extraFileExtensions = [];
        }
        basePath = ts2.normalizePath(basePath);
        var keyMapper = ts2.createGetCanonicalFileName(host.useCaseSensitiveFileNames);
        var literalFileMap = ts2.createMap();
        var wildcardFileMap = ts2.createMap();
        var wildCardJsonFileMap = ts2.createMap();
        var filesSpecs = spec.filesSpecs, validatedIncludeSpecs = spec.validatedIncludeSpecs, validatedExcludeSpecs = spec.validatedExcludeSpecs, wildcardDirectories = spec.wildcardDirectories;
        var supportedExtensions = ts2.getSupportedExtensions(options, extraFileExtensions);
        var supportedExtensionsWithJsonIfResolveJsonModule = ts2.getSuppoertedExtensionsWithJsonIfResolveJsonModule(options, supportedExtensions);
        if (filesSpecs) {
          for (var _i = 0, filesSpecs_1 = filesSpecs; _i < filesSpecs_1.length; _i++) {
            var fileName = filesSpecs_1[_i];
            var file = ts2.getNormalizedAbsolutePath(fileName, basePath);
            literalFileMap.set(keyMapper(file), file);
          }
        }
        var jsonOnlyIncludeRegexes;
        if (validatedIncludeSpecs && validatedIncludeSpecs.length > 0) {
          var _loop_5 = function(file2) {
            if (ts2.fileExtensionIs(file2, ".json")) {
              if (!jsonOnlyIncludeRegexes) {
                var includes = validatedIncludeSpecs.filter(function(s) {
                  return ts2.endsWith(s, ".json");
                });
                var includeFilePatterns = ts2.map(ts2.getRegularExpressionsForWildcards(includes, basePath, "files"), function(pattern) {
                  return "^" + pattern + "$";
                });
                jsonOnlyIncludeRegexes = includeFilePatterns ? includeFilePatterns.map(function(pattern) {
                  return ts2.getRegexFromPattern(pattern, host.useCaseSensitiveFileNames);
                }) : ts2.emptyArray;
              }
              var includeIndex = ts2.findIndex(jsonOnlyIncludeRegexes, function(re) {
                return re.test(file2);
              });
              if (includeIndex !== -1) {
                var key_1 = keyMapper(file2);
                if (!literalFileMap.has(key_1) && !wildCardJsonFileMap.has(key_1)) {
                  wildCardJsonFileMap.set(key_1, file2);
                }
              }
              return "continue";
            }
            if (hasFileWithHigherPriorityExtension(file2, literalFileMap, wildcardFileMap, supportedExtensions, keyMapper)) {
              return "continue";
            }
            removeWildcardFilesWithLowerPriorityExtension(file2, wildcardFileMap, supportedExtensions, keyMapper);
            var key = keyMapper(file2);
            if (!literalFileMap.has(key) && !wildcardFileMap.has(key)) {
              wildcardFileMap.set(key, file2);
            }
          };
          for (var _a = 0, _b = host.readDirectory(basePath, supportedExtensionsWithJsonIfResolveJsonModule, validatedExcludeSpecs, validatedIncludeSpecs, void 0); _a < _b.length; _a++) {
            var file = _b[_a];
            _loop_5(file);
          }
        }
        var literalFiles = ts2.arrayFrom(literalFileMap.values());
        var wildcardFiles = ts2.arrayFrom(wildcardFileMap.values());
        return {
          fileNames: literalFiles.concat(wildcardFiles, ts2.arrayFrom(wildCardJsonFileMap.values())),
          wildcardDirectories,
          spec
        };
      }
      ts2.getFileNamesFromConfigSpecs = getFileNamesFromConfigSpecs;
      function validateSpecs(specs, errors, allowTrailingRecursion, jsonSourceFile, specKey) {
        return specs.filter(function(spec) {
          var diag = specToDiagnostic(spec, allowTrailingRecursion);
          if (diag !== void 0) {
            errors.push(createDiagnostic(diag, spec));
          }
          return diag === void 0;
        });
        function createDiagnostic(message, spec) {
          var element = ts2.getTsConfigPropArrayElementValue(jsonSourceFile, specKey, spec);
          return element ? ts2.createDiagnosticForNodeInSourceFile(jsonSourceFile, element, message, spec) : ts2.createCompilerDiagnostic(message, spec);
        }
      }
      function specToDiagnostic(spec, allowTrailingRecursion) {
        if (!allowTrailingRecursion && invalidTrailingRecursionPattern.test(spec)) {
          return ts2.Diagnostics.File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0;
        } else if (invalidDotDotAfterRecursiveWildcardPattern.test(spec)) {
          return ts2.Diagnostics.File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0;
        }
      }
      function getWildcardDirectories(include, exclude, path2, useCaseSensitiveFileNames) {
        var rawExcludeRegex = ts2.getRegularExpressionForWildcard(exclude, path2, "exclude");
        var excludeRegex = rawExcludeRegex && new RegExp(rawExcludeRegex, useCaseSensitiveFileNames ? "" : "i");
        var wildcardDirectories = {};
        if (include !== void 0) {
          var recursiveKeys = [];
          for (var _i = 0, include_1 = include; _i < include_1.length; _i++) {
            var file = include_1[_i];
            var spec = ts2.normalizePath(ts2.combinePaths(path2, file));
            if (excludeRegex && excludeRegex.test(spec)) {
              continue;
            }
            var match = getWildcardDirectoryFromSpec(spec, useCaseSensitiveFileNames);
            if (match) {
              var key = match.key, flags = match.flags;
              var existingFlags = wildcardDirectories[key];
              if (existingFlags === void 0 || existingFlags < flags) {
                wildcardDirectories[key] = flags;
                if (flags === 1) {
                  recursiveKeys.push(key);
                }
              }
            }
          }
          for (var key in wildcardDirectories) {
            if (ts2.hasProperty(wildcardDirectories, key)) {
              for (var _a = 0, recursiveKeys_1 = recursiveKeys; _a < recursiveKeys_1.length; _a++) {
                var recursiveKey = recursiveKeys_1[_a];
                if (key !== recursiveKey && ts2.containsPath(recursiveKey, key, path2, !useCaseSensitiveFileNames)) {
                  delete wildcardDirectories[key];
                }
              }
            }
          }
        }
        return wildcardDirectories;
      }
      function getWildcardDirectoryFromSpec(spec, useCaseSensitiveFileNames) {
        var match = wildcardDirectoryPattern.exec(spec);
        if (match) {
          return {
            key: useCaseSensitiveFileNames ? match[0] : ts2.toFileNameLowerCase(match[0]),
            flags: watchRecursivePattern.test(spec) ? 1 : 0
          };
        }
        if (ts2.isImplicitGlob(spec)) {
          return { key: spec, flags: 1 };
        }
        return void 0;
      }
      function hasFileWithHigherPriorityExtension(file, literalFiles, wildcardFiles, extensions, keyMapper) {
        var extensionPriority = ts2.getExtensionPriority(file, extensions);
        var adjustedExtensionPriority = ts2.adjustExtensionPriority(extensionPriority, extensions);
        for (var i = 0; i < adjustedExtensionPriority; i++) {
          var higherPriorityExtension = extensions[i];
          var higherPriorityPath = keyMapper(ts2.changeExtension(file, higherPriorityExtension));
          if (literalFiles.has(higherPriorityPath) || wildcardFiles.has(higherPriorityPath)) {
            return true;
          }
        }
        return false;
      }
      function removeWildcardFilesWithLowerPriorityExtension(file, wildcardFiles, extensions, keyMapper) {
        var extensionPriority = ts2.getExtensionPriority(file, extensions);
        var nextExtensionPriority = ts2.getNextLowestExtensionPriority(extensionPriority, extensions);
        for (var i = nextExtensionPriority; i < extensions.length; i++) {
          var lowerPriorityExtension = extensions[i];
          var lowerPriorityPath = keyMapper(ts2.changeExtension(file, lowerPriorityExtension));
          wildcardFiles.delete(lowerPriorityPath);
        }
      }
      function convertCompilerOptionsForTelemetry(opts) {
        var out = {};
        for (var key in opts) {
          if (opts.hasOwnProperty(key)) {
            var type = getOptionFromName(key);
            if (type !== void 0) {
              out[key] = getOptionValueWithEmptyStrings(opts[key], type);
            }
          }
        }
        return out;
      }
      ts2.convertCompilerOptionsForTelemetry = convertCompilerOptionsForTelemetry;
      function getOptionValueWithEmptyStrings(value, option) {
        switch (option.type) {
          case "object":
            return "";
          case "string":
            return "";
          case "number":
            return typeof value === "number" ? value : "";
          case "boolean":
            return typeof value === "boolean" ? value : "";
          case "list":
            var elementType_1 = option.element;
            return ts2.isArray(value) ? value.map(function(v) {
              return getOptionValueWithEmptyStrings(v, elementType_1);
            }) : "";
          default:
            return ts2.forEachEntry(option.type, function(optionEnumValue, optionStringValue) {
              if (optionEnumValue === value) {
                return optionStringValue;
              }
            });
        }
      }
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function trace(host) {
        host.trace(ts2.formatMessage.apply(void 0, arguments));
      }
      ts2.trace = trace;
      function isTraceEnabled(compilerOptions, host) {
        return !!compilerOptions.traceResolution && host.trace !== void 0;
      }
      ts2.isTraceEnabled = isTraceEnabled;
      function withPackageId(packageInfo, r) {
        var packageId;
        if (r && packageInfo) {
          var packageJsonContent = packageInfo.packageJsonContent;
          if (typeof packageJsonContent.name === "string" && typeof packageJsonContent.version === "string") {
            packageId = {
              name: packageJsonContent.name,
              subModuleName: r.path.slice(packageInfo.packageDirectory.length + ts2.directorySeparator.length),
              version: packageJsonContent.version
            };
          }
        }
        return r && { path: r.path, extension: r.ext, packageId };
      }
      function noPackageId(r) {
        return withPackageId(void 0, r);
      }
      function removeIgnoredPackageId(r) {
        if (r) {
          ts2.Debug.assert(r.packageId === void 0);
          return { path: r.path, ext: r.extension };
        }
      }
      var Extensions;
      (function(Extensions2) {
        Extensions2[Extensions2["TypeScript"] = 0] = "TypeScript";
        Extensions2[Extensions2["JavaScript"] = 1] = "JavaScript";
        Extensions2[Extensions2["Json"] = 2] = "Json";
        Extensions2[Extensions2["TSConfig"] = 3] = "TSConfig";
        Extensions2[Extensions2["DtsOnly"] = 4] = "DtsOnly";
      })(Extensions || (Extensions = {}));
      function resolvedTypeScriptOnly(resolved) {
        if (!resolved) {
          return void 0;
        }
        ts2.Debug.assert(ts2.extensionIsTS(resolved.extension));
        return { fileName: resolved.path, packageId: resolved.packageId };
      }
      function createResolvedModuleWithFailedLookupLocations(resolved, isExternalLibraryImport, failedLookupLocations, resultFromCache) {
        var _a;
        if (resultFromCache) {
          (_a = resultFromCache.failedLookupLocations).push.apply(_a, failedLookupLocations);
          return resultFromCache;
        }
        return {
          resolvedModule: resolved && { resolvedFileName: resolved.path, originalPath: resolved.originalPath === true ? void 0 : resolved.originalPath, extension: resolved.extension, isExternalLibraryImport, packageId: resolved.packageId },
          failedLookupLocations
        };
      }
      function readPackageJsonField(jsonContent, fieldName, typeOfTag, state) {
        if (!ts2.hasProperty(jsonContent, fieldName)) {
          if (state.traceEnabled) {
            trace(state.host, ts2.Diagnostics.package_json_does_not_have_a_0_field, fieldName);
          }
          return;
        }
        var value = jsonContent[fieldName];
        if (typeof value !== typeOfTag || value === null) {
          if (state.traceEnabled) {
            trace(state.host, ts2.Diagnostics.Expected_type_of_0_field_in_package_json_to_be_1_got_2, fieldName, typeOfTag, value === null ? "null" : typeof value);
          }
          return;
        }
        return value;
      }
      function readPackageJsonPathField(jsonContent, fieldName, baseDirectory, state) {
        var fileName = readPackageJsonField(jsonContent, fieldName, "string", state);
        if (fileName === void 0) {
          return;
        }
        if (!fileName) {
          if (state.traceEnabled) {
            trace(state.host, ts2.Diagnostics.package_json_had_a_falsy_0_field, fieldName);
          }
          return;
        }
        var path2 = ts2.normalizePath(ts2.combinePaths(baseDirectory, fileName));
        if (state.traceEnabled) {
          trace(state.host, ts2.Diagnostics.package_json_has_0_field_1_that_references_2, fieldName, fileName, path2);
        }
        return path2;
      }
      function readPackageJsonTypesFields(jsonContent, baseDirectory, state) {
        return readPackageJsonPathField(jsonContent, "typings", baseDirectory, state) || readPackageJsonPathField(jsonContent, "types", baseDirectory, state);
      }
      function readPackageJsonTSConfigField(jsonContent, baseDirectory, state) {
        return readPackageJsonPathField(jsonContent, "tsconfig", baseDirectory, state);
      }
      function readPackageJsonMainField(jsonContent, baseDirectory, state) {
        return readPackageJsonPathField(jsonContent, "main", baseDirectory, state);
      }
      function readPackageJsonTypesVersionsField(jsonContent, state) {
        var typesVersions = readPackageJsonField(jsonContent, "typesVersions", "object", state);
        if (typesVersions === void 0)
          return;
        if (state.traceEnabled) {
          trace(state.host, ts2.Diagnostics.package_json_has_a_typesVersions_field_with_version_specific_path_mappings);
        }
        return typesVersions;
      }
      function readPackageJsonTypesVersionPaths(jsonContent, state) {
        var typesVersions = readPackageJsonTypesVersionsField(jsonContent, state);
        if (typesVersions === void 0)
          return;
        if (state.traceEnabled) {
          for (var key in typesVersions) {
            if (ts2.hasProperty(typesVersions, key) && !ts2.VersionRange.tryParse(key)) {
              trace(state.host, ts2.Diagnostics.package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range, key);
            }
          }
        }
        var result = getPackageJsonTypesVersionsPaths(typesVersions);
        if (!result) {
          if (state.traceEnabled) {
            trace(state.host, ts2.Diagnostics.package_json_does_not_have_a_typesVersions_entry_that_matches_version_0, ts2.versionMajorMinor);
          }
          return;
        }
        var bestVersionKey = result.version, bestVersionPaths = result.paths;
        if (typeof bestVersionPaths !== "object") {
          if (state.traceEnabled) {
            trace(state.host, ts2.Diagnostics.Expected_type_of_0_field_in_package_json_to_be_1_got_2, "typesVersions['" + bestVersionKey + "']", "object", typeof bestVersionPaths);
          }
          return;
        }
        return result;
      }
      var typeScriptVersion;
      function getPackageJsonTypesVersionsPaths(typesVersions) {
        if (!typeScriptVersion)
          typeScriptVersion = new ts2.Version(ts2.version);
        for (var key in typesVersions) {
          if (!ts2.hasProperty(typesVersions, key))
            continue;
          var keyRange = ts2.VersionRange.tryParse(key);
          if (keyRange === void 0) {
            continue;
          }
          if (keyRange.test(typeScriptVersion)) {
            return { version: key, paths: typesVersions[key] };
          }
        }
      }
      ts2.getPackageJsonTypesVersionsPaths = getPackageJsonTypesVersionsPaths;
      function getEffectiveTypeRoots(options, host) {
        if (options.typeRoots) {
          return options.typeRoots;
        }
        var currentDirectory;
        if (options.configFilePath) {
          currentDirectory = ts2.getDirectoryPath(options.configFilePath);
        } else if (host.getCurrentDirectory) {
          currentDirectory = host.getCurrentDirectory();
        }
        if (currentDirectory !== void 0) {
          return getDefaultTypeRoots(currentDirectory, host);
        }
      }
      ts2.getEffectiveTypeRoots = getEffectiveTypeRoots;
      function getDefaultTypeRoots(currentDirectory, host) {
        if (!host.directoryExists) {
          return [ts2.combinePaths(currentDirectory, nodeModulesAtTypes)];
        }
        var typeRoots;
        ts2.forEachAncestorDirectory(ts2.normalizePath(currentDirectory), function(directory) {
          var atTypes = ts2.combinePaths(directory, nodeModulesAtTypes);
          if (host.directoryExists(atTypes)) {
            (typeRoots || (typeRoots = [])).push(atTypes);
          }
          return void 0;
        });
        return typeRoots;
      }
      var nodeModulesAtTypes = ts2.combinePaths("node_modules", "@types");
      function resolveTypeReferenceDirective(typeReferenceDirectiveName, containingFile, options, host, redirectedReference) {
        var traceEnabled = isTraceEnabled(options, host);
        if (redirectedReference) {
          options = redirectedReference.commandLine.options;
        }
        var failedLookupLocations = [];
        var moduleResolutionState = { compilerOptions: options, host, traceEnabled, failedLookupLocations };
        var typeRoots = getEffectiveTypeRoots(options, host);
        if (traceEnabled) {
          if (containingFile === void 0) {
            if (typeRoots === void 0) {
              trace(host, ts2.Diagnostics.Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set, typeReferenceDirectiveName);
            } else {
              trace(host, ts2.Diagnostics.Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1, typeReferenceDirectiveName, typeRoots);
            }
          } else {
            if (typeRoots === void 0) {
              trace(host, ts2.Diagnostics.Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set, typeReferenceDirectiveName, containingFile);
            } else {
              trace(host, ts2.Diagnostics.Resolving_type_reference_directive_0_containing_file_1_root_directory_2, typeReferenceDirectiveName, containingFile, typeRoots);
            }
          }
          if (redirectedReference) {
            trace(host, ts2.Diagnostics.Using_compiler_options_of_project_reference_redirect_0, redirectedReference.sourceFile.fileName);
          }
        }
        var resolved = primaryLookup();
        var primary = true;
        if (!resolved) {
          resolved = secondaryLookup();
          primary = false;
        }
        var resolvedTypeReferenceDirective;
        if (resolved) {
          var fileName = resolved.fileName, packageId = resolved.packageId;
          var resolvedFileName = options.preserveSymlinks ? fileName : realPath(fileName, host, traceEnabled);
          if (traceEnabled) {
            if (packageId) {
              trace(host, ts2.Diagnostics.Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3, typeReferenceDirectiveName, resolvedFileName, ts2.packageIdToString(packageId), primary);
            } else {
              trace(host, ts2.Diagnostics.Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2, typeReferenceDirectiveName, resolvedFileName, primary);
            }
          }
          resolvedTypeReferenceDirective = { primary, resolvedFileName, packageId, isExternalLibraryImport: pathContainsNodeModules(fileName) };
        }
        return { resolvedTypeReferenceDirective, failedLookupLocations };
        function primaryLookup() {
          if (typeRoots && typeRoots.length) {
            if (traceEnabled) {
              trace(host, ts2.Diagnostics.Resolving_with_primary_search_path_0, typeRoots.join(", "));
            }
            return ts2.firstDefined(typeRoots, function(typeRoot) {
              var candidate = ts2.combinePaths(typeRoot, typeReferenceDirectiveName);
              var candidateDirectory = ts2.getDirectoryPath(candidate);
              var directoryExists = ts2.directoryProbablyExists(candidateDirectory, host);
              if (!directoryExists && traceEnabled) {
                trace(host, ts2.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, candidateDirectory);
              }
              return resolvedTypeScriptOnly(loadNodeModuleFromDirectory(Extensions.DtsOnly, candidate, !directoryExists, moduleResolutionState));
            });
          } else {
            if (traceEnabled) {
              trace(host, ts2.Diagnostics.Root_directory_cannot_be_determined_skipping_primary_search_paths);
            }
          }
        }
        function secondaryLookup() {
          var initialLocationForSecondaryLookup = containingFile && ts2.getDirectoryPath(containingFile);
          if (initialLocationForSecondaryLookup !== void 0) {
            if (traceEnabled) {
              trace(host, ts2.Diagnostics.Looking_up_in_node_modules_folder_initial_location_0, initialLocationForSecondaryLookup);
            }
            var result = void 0;
            if (!ts2.isExternalModuleNameRelative(typeReferenceDirectiveName)) {
              var searchResult = loadModuleFromNearestNodeModulesDirectory(Extensions.DtsOnly, typeReferenceDirectiveName, initialLocationForSecondaryLookup, moduleResolutionState, void 0, void 0);
              result = searchResult && searchResult.value;
            } else {
              var candidate = ts2.normalizePathAndParts(ts2.combinePaths(initialLocationForSecondaryLookup, typeReferenceDirectiveName)).path;
              result = nodeLoadModuleByRelativeName(Extensions.DtsOnly, candidate, false, moduleResolutionState, true);
            }
            var resolvedFile = resolvedTypeScriptOnly(result);
            if (!resolvedFile && traceEnabled) {
              trace(host, ts2.Diagnostics.Type_reference_directive_0_was_not_resolved, typeReferenceDirectiveName);
            }
            return resolvedFile;
          } else {
            if (traceEnabled) {
              trace(host, ts2.Diagnostics.Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_modules_folder);
            }
          }
        }
      }
      ts2.resolveTypeReferenceDirective = resolveTypeReferenceDirective;
      function getAutomaticTypeDirectiveNames(options, host) {
        if (options.types) {
          return options.types;
        }
        var result = [];
        if (host.directoryExists && host.getDirectories) {
          var typeRoots = getEffectiveTypeRoots(options, host);
          if (typeRoots) {
            for (var _i = 0, typeRoots_1 = typeRoots; _i < typeRoots_1.length; _i++) {
              var root = typeRoots_1[_i];
              if (host.directoryExists(root)) {
                for (var _a = 0, _b = host.getDirectories(root); _a < _b.length; _a++) {
                  var typeDirectivePath = _b[_a];
                  var normalized = ts2.normalizePath(typeDirectivePath);
                  var packageJsonPath = ts2.combinePaths(root, normalized, "package.json");
                  var isNotNeededPackage = host.fileExists(packageJsonPath) && ts2.readJson(packageJsonPath, host).typings === null;
                  if (!isNotNeededPackage) {
                    var baseFileName = ts2.getBaseFileName(normalized);
                    if (baseFileName.charCodeAt(0) !== 46) {
                      result.push(baseFileName);
                    }
                  }
                }
              }
            }
          }
        }
        return result;
      }
      ts2.getAutomaticTypeDirectiveNames = getAutomaticTypeDirectiveNames;
      function createModuleResolutionCache(currentDirectory, getCanonicalFileName, options) {
        return createModuleResolutionCacheWithMaps(createCacheWithRedirects(options), createCacheWithRedirects(options), currentDirectory, getCanonicalFileName);
      }
      ts2.createModuleResolutionCache = createModuleResolutionCache;
      function createCacheWithRedirects(options) {
        var ownMap = ts2.createMap();
        var redirectsMap = ts2.createMap();
        return {
          ownMap,
          redirectsMap,
          getOrCreateMapOfCacheRedirects,
          clear,
          setOwnOptions,
          setOwnMap
        };
        function setOwnOptions(newOptions) {
          options = newOptions;
        }
        function setOwnMap(newOwnMap) {
          ownMap = newOwnMap;
        }
        function getOrCreateMapOfCacheRedirects(redirectedReference) {
          if (!redirectedReference) {
            return ownMap;
          }
          var path2 = redirectedReference.sourceFile.path;
          var redirects = redirectsMap.get(path2);
          if (!redirects) {
            redirects = !options || ts2.optionsHaveModuleResolutionChanges(options, redirectedReference.commandLine.options) ? ts2.createMap() : ownMap;
            redirectsMap.set(path2, redirects);
          }
          return redirects;
        }
        function clear() {
          ownMap.clear();
          redirectsMap.clear();
        }
      }
      ts2.createCacheWithRedirects = createCacheWithRedirects;
      function createModuleResolutionCacheWithMaps(directoryToModuleNameMap, moduleNameToDirectoryMap, currentDirectory, getCanonicalFileName) {
        return { getOrCreateCacheForDirectory, getOrCreateCacheForModuleName, directoryToModuleNameMap, moduleNameToDirectoryMap };
        function getOrCreateCacheForDirectory(directoryName, redirectedReference) {
          var path2 = ts2.toPath(directoryName, currentDirectory, getCanonicalFileName);
          return getOrCreateCache(directoryToModuleNameMap, redirectedReference, path2, ts2.createMap);
        }
        function getOrCreateCacheForModuleName(nonRelativeModuleName, redirectedReference) {
          ts2.Debug.assert(!ts2.isExternalModuleNameRelative(nonRelativeModuleName));
          return getOrCreateCache(moduleNameToDirectoryMap, redirectedReference, nonRelativeModuleName, createPerModuleNameCache);
        }
        function getOrCreateCache(cacheWithRedirects, redirectedReference, key, create) {
          var cache = cacheWithRedirects.getOrCreateMapOfCacheRedirects(redirectedReference);
          var result = cache.get(key);
          if (!result) {
            result = create();
            cache.set(key, result);
          }
          return result;
        }
        function createPerModuleNameCache() {
          var directoryPathMap = ts2.createMap();
          return { get, set };
          function get(directory) {
            return directoryPathMap.get(ts2.toPath(directory, currentDirectory, getCanonicalFileName));
          }
          function set(directory, result) {
            var path2 = ts2.toPath(directory, currentDirectory, getCanonicalFileName);
            if (directoryPathMap.has(path2)) {
              return;
            }
            directoryPathMap.set(path2, result);
            var resolvedFileName = result.resolvedModule && (result.resolvedModule.originalPath || result.resolvedModule.resolvedFileName);
            var commonPrefix = resolvedFileName && getCommonPrefix(path2, resolvedFileName);
            var current = path2;
            while (current !== commonPrefix) {
              var parent = ts2.getDirectoryPath(current);
              if (parent === current || directoryPathMap.has(parent)) {
                break;
              }
              directoryPathMap.set(parent, result);
              current = parent;
            }
          }
          function getCommonPrefix(directory, resolution) {
            var resolutionDirectory = ts2.toPath(ts2.getDirectoryPath(resolution), currentDirectory, getCanonicalFileName);
            var i = 0;
            var limit = Math.min(directory.length, resolutionDirectory.length);
            while (i < limit && directory.charCodeAt(i) === resolutionDirectory.charCodeAt(i)) {
              i++;
            }
            if (i === directory.length && (resolutionDirectory.length === i || resolutionDirectory[i] === ts2.directorySeparator)) {
              return directory;
            }
            var rootLength = ts2.getRootLength(directory);
            if (i < rootLength) {
              return void 0;
            }
            var sep = directory.lastIndexOf(ts2.directorySeparator, i - 1);
            if (sep === -1) {
              return void 0;
            }
            return directory.substr(0, Math.max(sep, rootLength));
          }
        }
      }
      ts2.createModuleResolutionCacheWithMaps = createModuleResolutionCacheWithMaps;
      function resolveModuleNameFromCache(moduleName, containingFile, cache) {
        var containingDirectory = ts2.getDirectoryPath(containingFile);
        var perFolderCache = cache && cache.getOrCreateCacheForDirectory(containingDirectory);
        return perFolderCache && perFolderCache.get(moduleName);
      }
      ts2.resolveModuleNameFromCache = resolveModuleNameFromCache;
      function resolveModuleName(moduleName, containingFile, compilerOptions, host, cache, redirectedReference) {
        var traceEnabled = isTraceEnabled(compilerOptions, host);
        if (redirectedReference) {
          compilerOptions = redirectedReference.commandLine.options;
        }
        if (traceEnabled) {
          trace(host, ts2.Diagnostics.Resolving_module_0_from_1, moduleName, containingFile);
          if (redirectedReference) {
            trace(host, ts2.Diagnostics.Using_compiler_options_of_project_reference_redirect_0, redirectedReference.sourceFile.fileName);
          }
        }
        var containingDirectory = ts2.getDirectoryPath(containingFile);
        var perFolderCache = cache && cache.getOrCreateCacheForDirectory(containingDirectory, redirectedReference);
        var result = perFolderCache && perFolderCache.get(moduleName);
        if (result) {
          if (traceEnabled) {
            trace(host, ts2.Diagnostics.Resolution_for_module_0_was_found_in_cache_from_location_1, moduleName, containingDirectory);
          }
        } else {
          var moduleResolution = compilerOptions.moduleResolution;
          if (moduleResolution === void 0) {
            moduleResolution = ts2.getEmitModuleKind(compilerOptions) === ts2.ModuleKind.CommonJS ? ts2.ModuleResolutionKind.NodeJs : ts2.ModuleResolutionKind.Classic;
            if (traceEnabled) {
              trace(host, ts2.Diagnostics.Module_resolution_kind_is_not_specified_using_0, ts2.ModuleResolutionKind[moduleResolution]);
            }
          } else {
            if (traceEnabled) {
              trace(host, ts2.Diagnostics.Explicitly_specified_module_resolution_kind_Colon_0, ts2.ModuleResolutionKind[moduleResolution]);
            }
          }
          ts2.perfLogger.logStartResolveModule(moduleName);
          switch (moduleResolution) {
            case ts2.ModuleResolutionKind.NodeJs:
              result = nodeModuleNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference);
              break;
            case ts2.ModuleResolutionKind.Classic:
              result = classicNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference);
              break;
            default:
              return ts2.Debug.fail("Unexpected moduleResolution: " + moduleResolution);
          }
          if (result && result.resolvedModule)
            ts2.perfLogger.logInfoEvent('Module "' + moduleName + '" resolved to "' + result.resolvedModule.resolvedFileName + '"');
          ts2.perfLogger.logStopResolveModule(result && result.resolvedModule ? "" + result.resolvedModule.resolvedFileName : "null");
          if (perFolderCache) {
            perFolderCache.set(moduleName, result);
            if (!ts2.isExternalModuleNameRelative(moduleName)) {
              cache.getOrCreateCacheForModuleName(moduleName, redirectedReference).set(containingDirectory, result);
            }
          }
        }
        if (traceEnabled) {
          if (result.resolvedModule) {
            if (result.resolvedModule.packageId) {
              trace(host, ts2.Diagnostics.Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2, moduleName, result.resolvedModule.resolvedFileName, ts2.packageIdToString(result.resolvedModule.packageId));
            } else {
              trace(host, ts2.Diagnostics.Module_name_0_was_successfully_resolved_to_1, moduleName, result.resolvedModule.resolvedFileName);
            }
          } else {
            trace(host, ts2.Diagnostics.Module_name_0_was_not_resolved, moduleName);
          }
        }
        return result;
      }
      ts2.resolveModuleName = resolveModuleName;
      function tryLoadModuleUsingOptionalResolutionSettings(extensions, moduleName, containingDirectory, loader, state) {
        var resolved = tryLoadModuleUsingPathsIfEligible(extensions, moduleName, loader, state);
        if (resolved)
          return resolved.value;
        if (!ts2.isExternalModuleNameRelative(moduleName)) {
          return tryLoadModuleUsingBaseUrl(extensions, moduleName, loader, state);
        } else {
          return tryLoadModuleUsingRootDirs(extensions, moduleName, containingDirectory, loader, state);
        }
      }
      function tryLoadModuleUsingPathsIfEligible(extensions, moduleName, loader, state) {
        var _a = state.compilerOptions, baseUrl = _a.baseUrl, paths = _a.paths;
        if (baseUrl && paths && !ts2.pathIsRelative(moduleName)) {
          if (state.traceEnabled) {
            trace(state.host, ts2.Diagnostics.baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1, baseUrl, moduleName);
            trace(state.host, ts2.Diagnostics.paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0, moduleName);
          }
          return tryLoadModuleUsingPaths(extensions, moduleName, baseUrl, paths, loader, false, state);
        }
      }
      function tryLoadModuleUsingRootDirs(extensions, moduleName, containingDirectory, loader, state) {
        if (!state.compilerOptions.rootDirs) {
          return void 0;
        }
        if (state.traceEnabled) {
          trace(state.host, ts2.Diagnostics.rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0, moduleName);
        }
        var candidate = ts2.normalizePath(ts2.combinePaths(containingDirectory, moduleName));
        var matchedRootDir;
        var matchedNormalizedPrefix;
        for (var _i = 0, _a = state.compilerOptions.rootDirs; _i < _a.length; _i++) {
          var rootDir = _a[_i];
          var normalizedRoot = ts2.normalizePath(rootDir);
          if (!ts2.endsWith(normalizedRoot, ts2.directorySeparator)) {
            normalizedRoot += ts2.directorySeparator;
          }
          var isLongestMatchingPrefix = ts2.startsWith(candidate, normalizedRoot) && (matchedNormalizedPrefix === void 0 || matchedNormalizedPrefix.length < normalizedRoot.length);
          if (state.traceEnabled) {
            trace(state.host, ts2.Diagnostics.Checking_if_0_is_the_longest_matching_prefix_for_1_2, normalizedRoot, candidate, isLongestMatchingPrefix);
          }
          if (isLongestMatchingPrefix) {
            matchedNormalizedPrefix = normalizedRoot;
            matchedRootDir = rootDir;
          }
        }
        if (matchedNormalizedPrefix) {
          if (state.traceEnabled) {
            trace(state.host, ts2.Diagnostics.Longest_matching_prefix_for_0_is_1, candidate, matchedNormalizedPrefix);
          }
          var suffix = candidate.substr(matchedNormalizedPrefix.length);
          if (state.traceEnabled) {
            trace(state.host, ts2.Diagnostics.Loading_0_from_the_root_dir_1_candidate_location_2, suffix, matchedNormalizedPrefix, candidate);
          }
          var resolvedFileName = loader(extensions, candidate, !ts2.directoryProbablyExists(containingDirectory, state.host), state);
          if (resolvedFileName) {
            return resolvedFileName;
          }
          if (state.traceEnabled) {
            trace(state.host, ts2.Diagnostics.Trying_other_entries_in_rootDirs);
          }
          for (var _b = 0, _c = state.compilerOptions.rootDirs; _b < _c.length; _b++) {
            var rootDir = _c[_b];
            if (rootDir === matchedRootDir) {
              continue;
            }
            var candidate_1 = ts2.combinePaths(ts2.normalizePath(rootDir), suffix);
            if (state.traceEnabled) {
              trace(state.host, ts2.Diagnostics.Loading_0_from_the_root_dir_1_candidate_location_2, suffix, rootDir, candidate_1);
            }
            var baseDirectory = ts2.getDirectoryPath(candidate_1);
            var resolvedFileName_1 = loader(extensions, candidate_1, !ts2.directoryProbablyExists(baseDirectory, state.host), state);
            if (resolvedFileName_1) {
              return resolvedFileName_1;
            }
          }
          if (state.traceEnabled) {
            trace(state.host, ts2.Diagnostics.Module_resolution_using_rootDirs_has_failed);
          }
        }
        return void 0;
      }
      function tryLoadModuleUsingBaseUrl(extensions, moduleName, loader, state) {
        var baseUrl = state.compilerOptions.baseUrl;
        if (!baseUrl) {
          return void 0;
        }
        if (state.traceEnabled) {
          trace(state.host, ts2.Diagnostics.baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1, baseUrl, moduleName);
        }
        var candidate = ts2.normalizePath(ts2.combinePaths(baseUrl, moduleName));
        if (state.traceEnabled) {
          trace(state.host, ts2.Diagnostics.Resolving_module_name_0_relative_to_base_url_1_2, moduleName, baseUrl, candidate);
        }
        return loader(extensions, candidate, !ts2.directoryProbablyExists(ts2.getDirectoryPath(candidate), state.host), state);
      }
      function resolveJSModule(moduleName, initialDir, host) {
        var _a = tryResolveJSModuleWorker(moduleName, initialDir, host), resolvedModule = _a.resolvedModule, failedLookupLocations = _a.failedLookupLocations;
        if (!resolvedModule) {
          throw new Error("Could not resolve JS module '" + moduleName + "' starting at '" + initialDir + "'. Looked in: " + failedLookupLocations.join(", "));
        }
        return resolvedModule.resolvedFileName;
      }
      ts2.resolveJSModule = resolveJSModule;
      function tryResolveJSModule(moduleName, initialDir, host) {
        var resolvedModule = tryResolveJSModuleWorker(moduleName, initialDir, host).resolvedModule;
        return resolvedModule && resolvedModule.resolvedFileName;
      }
      ts2.tryResolveJSModule = tryResolveJSModule;
      var jsOnlyExtensions = [Extensions.JavaScript];
      var tsExtensions = [Extensions.TypeScript, Extensions.JavaScript];
      var tsPlusJsonExtensions = __spreadArrays(tsExtensions, [Extensions.Json]);
      var tsconfigExtensions = [Extensions.TSConfig];
      function tryResolveJSModuleWorker(moduleName, initialDir, host) {
        return nodeModuleNameResolverWorker(moduleName, initialDir, { moduleResolution: ts2.ModuleResolutionKind.NodeJs, allowJs: true }, host, void 0, jsOnlyExtensions, void 0);
      }
      function nodeModuleNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference, lookupConfig) {
        return nodeModuleNameResolverWorker(moduleName, ts2.getDirectoryPath(containingFile), compilerOptions, host, cache, lookupConfig ? tsconfigExtensions : compilerOptions.resolveJsonModule ? tsPlusJsonExtensions : tsExtensions, redirectedReference);
      }
      ts2.nodeModuleNameResolver = nodeModuleNameResolver;
      function nodeModuleNameResolverWorker(moduleName, containingDirectory, compilerOptions, host, cache, extensions, redirectedReference) {
        var _a, _b;
        var traceEnabled = isTraceEnabled(compilerOptions, host);
        var failedLookupLocations = [];
        var state = { compilerOptions, host, traceEnabled, failedLookupLocations };
        var result = ts2.forEach(extensions, function(ext) {
          return tryResolve(ext);
        });
        return createResolvedModuleWithFailedLookupLocations((_a = result === null || result === void 0 ? void 0 : result.value) === null || _a === void 0 ? void 0 : _a.resolved, (_b = result === null || result === void 0 ? void 0 : result.value) === null || _b === void 0 ? void 0 : _b.isExternalLibraryImport, failedLookupLocations, state.resultFromCache);
        function tryResolve(extensions2) {
          var loader = function(extensions3, candidate2, onlyRecordFailures, state2) {
            return nodeLoadModuleByRelativeName(extensions3, candidate2, onlyRecordFailures, state2, true);
          };
          var resolved = tryLoadModuleUsingOptionalResolutionSettings(extensions2, moduleName, containingDirectory, loader, state);
          if (resolved) {
            return toSearchResult({ resolved, isExternalLibraryImport: pathContainsNodeModules(resolved.path) });
          }
          if (!ts2.isExternalModuleNameRelative(moduleName)) {
            if (traceEnabled) {
              trace(host, ts2.Diagnostics.Loading_module_0_from_node_modules_folder_target_file_type_1, moduleName, Extensions[extensions2]);
            }
            var resolved_1 = loadModuleFromNearestNodeModulesDirectory(extensions2, moduleName, containingDirectory, state, cache, redirectedReference);
            if (!resolved_1)
              return void 0;
            var resolvedValue = resolved_1.value;
            if (!compilerOptions.preserveSymlinks && resolvedValue && !resolvedValue.originalPath) {
              var path2 = realPath(resolvedValue.path, host, traceEnabled);
              var originalPath = path2 === resolvedValue.path ? void 0 : resolvedValue.path;
              resolvedValue = __assign(__assign({}, resolvedValue), { path: path2, originalPath });
            }
            return { value: resolvedValue && { resolved: resolvedValue, isExternalLibraryImport: true } };
          } else {
            var _a2 = ts2.normalizePathAndParts(ts2.combinePaths(containingDirectory, moduleName)), candidate = _a2.path, parts = _a2.parts;
            var resolved_2 = nodeLoadModuleByRelativeName(extensions2, candidate, false, state, true);
            return resolved_2 && toSearchResult({ resolved: resolved_2, isExternalLibraryImport: ts2.contains(parts, "node_modules") });
          }
        }
      }
      function realPath(path2, host, traceEnabled) {
        if (!host.realpath) {
          return path2;
        }
        var real = ts2.normalizePath(host.realpath(path2));
        if (traceEnabled) {
          trace(host, ts2.Diagnostics.Resolving_real_path_for_0_result_1, path2, real);
        }
        ts2.Debug.assert(host.fileExists(real), path2 + " linked to nonexistent file " + real);
        return real;
      }
      function nodeLoadModuleByRelativeName(extensions, candidate, onlyRecordFailures, state, considerPackageJson) {
        if (state.traceEnabled) {
          trace(state.host, ts2.Diagnostics.Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1, candidate, Extensions[extensions]);
        }
        if (!ts2.hasTrailingDirectorySeparator(candidate)) {
          if (!onlyRecordFailures) {
            var parentOfCandidate = ts2.getDirectoryPath(candidate);
            if (!ts2.directoryProbablyExists(parentOfCandidate, state.host)) {
              if (state.traceEnabled) {
                trace(state.host, ts2.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, parentOfCandidate);
              }
              onlyRecordFailures = true;
            }
          }
          var resolvedFromFile = loadModuleFromFile(extensions, candidate, onlyRecordFailures, state);
          if (resolvedFromFile) {
            var packageDirectory = considerPackageJson ? parseNodeModuleFromPath(resolvedFromFile) : void 0;
            var packageInfo = packageDirectory ? getPackageJsonInfo(packageDirectory, false, state) : void 0;
            return withPackageId(packageInfo, resolvedFromFile);
          }
        }
        if (!onlyRecordFailures) {
          var candidateExists = ts2.directoryProbablyExists(candidate, state.host);
          if (!candidateExists) {
            if (state.traceEnabled) {
              trace(state.host, ts2.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, candidate);
            }
            onlyRecordFailures = true;
          }
        }
        return loadNodeModuleFromDirectory(extensions, candidate, onlyRecordFailures, state, considerPackageJson);
      }
      ts2.nodeModulesPathPart = "/node_modules/";
      function pathContainsNodeModules(path2) {
        return ts2.stringContains(path2, ts2.nodeModulesPathPart);
      }
      ts2.pathContainsNodeModules = pathContainsNodeModules;
      function parseNodeModuleFromPath(resolved) {
        var path2 = ts2.normalizePath(resolved.path);
        var idx = path2.lastIndexOf(ts2.nodeModulesPathPart);
        if (idx === -1) {
          return void 0;
        }
        var indexAfterNodeModules = idx + ts2.nodeModulesPathPart.length;
        var indexAfterPackageName = moveToNextDirectorySeparatorIfAvailable(path2, indexAfterNodeModules);
        if (path2.charCodeAt(indexAfterNodeModules) === 64) {
          indexAfterPackageName = moveToNextDirectorySeparatorIfAvailable(path2, indexAfterPackageName);
        }
        return path2.slice(0, indexAfterPackageName);
      }
      function moveToNextDirectorySeparatorIfAvailable(path2, prevSeparatorIndex) {
        var nextSeparatorIndex = path2.indexOf(ts2.directorySeparator, prevSeparatorIndex + 1);
        return nextSeparatorIndex === -1 ? prevSeparatorIndex : nextSeparatorIndex;
      }
      function loadModuleFromFileNoPackageId(extensions, candidate, onlyRecordFailures, state) {
        return noPackageId(loadModuleFromFile(extensions, candidate, onlyRecordFailures, state));
      }
      function loadModuleFromFile(extensions, candidate, onlyRecordFailures, state) {
        if (extensions === Extensions.Json || extensions === Extensions.TSConfig) {
          var extensionLess = ts2.tryRemoveExtension(candidate, ".json");
          return extensionLess === void 0 && extensions === Extensions.Json ? void 0 : tryAddingExtensions(extensionLess || candidate, extensions, onlyRecordFailures, state);
        }
        var resolvedByAddingExtension = tryAddingExtensions(candidate, extensions, onlyRecordFailures, state);
        if (resolvedByAddingExtension) {
          return resolvedByAddingExtension;
        }
        if (ts2.hasJSFileExtension(candidate)) {
          var extensionless = ts2.removeFileExtension(candidate);
          if (state.traceEnabled) {
            var extension = candidate.substring(extensionless.length);
            trace(state.host, ts2.Diagnostics.File_name_0_has_a_1_extension_stripping_it, candidate, extension);
          }
          return tryAddingExtensions(extensionless, extensions, onlyRecordFailures, state);
        }
      }
      function tryAddingExtensions(candidate, extensions, onlyRecordFailures, state) {
        if (!onlyRecordFailures) {
          var directory = ts2.getDirectoryPath(candidate);
          if (directory) {
            onlyRecordFailures = !ts2.directoryProbablyExists(directory, state.host);
          }
        }
        switch (extensions) {
          case Extensions.DtsOnly:
            return tryExtension(".d.ts");
          case Extensions.TypeScript:
            return tryExtension(".ts") || tryExtension(".tsx") || tryExtension(".d.ts");
          case Extensions.JavaScript:
            return tryExtension(".js") || tryExtension(".jsx");
          case Extensions.TSConfig:
          case Extensions.Json:
            return tryExtension(".json");
        }
        function tryExtension(ext) {
          var path2 = tryFile(candidate + ext, onlyRecordFailures, state);
          return path2 === void 0 ? void 0 : { path: path2, ext };
        }
      }
      function tryFile(fileName, onlyRecordFailures, state) {
        if (!onlyRecordFailures) {
          if (state.host.fileExists(fileName)) {
            if (state.traceEnabled) {
              trace(state.host, ts2.Diagnostics.File_0_exist_use_it_as_a_name_resolution_result, fileName);
            }
            return fileName;
          } else {
            if (state.traceEnabled) {
              trace(state.host, ts2.Diagnostics.File_0_does_not_exist, fileName);
            }
          }
        }
        state.failedLookupLocations.push(fileName);
        return void 0;
      }
      function loadNodeModuleFromDirectory(extensions, candidate, onlyRecordFailures, state, considerPackageJson) {
        if (considerPackageJson === void 0) {
          considerPackageJson = true;
        }
        var packageInfo = considerPackageJson ? getPackageJsonInfo(candidate, onlyRecordFailures, state) : void 0;
        var packageJsonContent = packageInfo && packageInfo.packageJsonContent;
        var versionPaths = packageInfo && packageInfo.versionPaths;
        return withPackageId(packageInfo, loadNodeModuleFromDirectoryWorker(extensions, candidate, onlyRecordFailures, state, packageJsonContent, versionPaths));
      }
      function getPackageJsonInfo(packageDirectory, onlyRecordFailures, state) {
        var host = state.host, traceEnabled = state.traceEnabled;
        var directoryExists = !onlyRecordFailures && ts2.directoryProbablyExists(packageDirectory, host);
        var packageJsonPath = ts2.combinePaths(packageDirectory, "package.json");
        if (directoryExists && host.fileExists(packageJsonPath)) {
          var packageJsonContent = ts2.readJson(packageJsonPath, host);
          if (traceEnabled) {
            trace(host, ts2.Diagnostics.Found_package_json_at_0, packageJsonPath);
          }
          var versionPaths = readPackageJsonTypesVersionPaths(packageJsonContent, state);
          return { packageDirectory, packageJsonContent, versionPaths };
        } else {
          if (directoryExists && traceEnabled) {
            trace(host, ts2.Diagnostics.File_0_does_not_exist, packageJsonPath);
          }
          state.failedLookupLocations.push(packageJsonPath);
        }
      }
      function loadNodeModuleFromDirectoryWorker(extensions, candidate, onlyRecordFailures, state, jsonContent, versionPaths) {
        var packageFile;
        if (jsonContent) {
          switch (extensions) {
            case Extensions.JavaScript:
            case Extensions.Json:
              packageFile = readPackageJsonMainField(jsonContent, candidate, state);
              break;
            case Extensions.TypeScript:
              packageFile = readPackageJsonTypesFields(jsonContent, candidate, state) || readPackageJsonMainField(jsonContent, candidate, state);
              break;
            case Extensions.DtsOnly:
              packageFile = readPackageJsonTypesFields(jsonContent, candidate, state);
              break;
            case Extensions.TSConfig:
              packageFile = readPackageJsonTSConfigField(jsonContent, candidate, state);
              break;
            default:
              return ts2.Debug.assertNever(extensions);
          }
        }
        var loader = function(extensions2, candidate2, onlyRecordFailures2, state2) {
          var fromFile = tryFile(candidate2, onlyRecordFailures2, state2);
          if (fromFile) {
            var resolved = resolvedIfExtensionMatches(extensions2, fromFile);
            if (resolved) {
              return noPackageId(resolved);
            }
            if (state2.traceEnabled) {
              trace(state2.host, ts2.Diagnostics.File_0_has_an_unsupported_extension_so_skipping_it, fromFile);
            }
          }
          var nextExtensions = extensions2 === Extensions.DtsOnly ? Extensions.TypeScript : extensions2;
          return nodeLoadModuleByRelativeName(nextExtensions, candidate2, onlyRecordFailures2, state2, false);
        };
        var onlyRecordFailuresForPackageFile = packageFile ? !ts2.directoryProbablyExists(ts2.getDirectoryPath(packageFile), state.host) : void 0;
        var onlyRecordFailuresForIndex = onlyRecordFailures || !ts2.directoryProbablyExists(candidate, state.host);
        var indexPath = ts2.combinePaths(candidate, extensions === Extensions.TSConfig ? "tsconfig" : "index");
        if (versionPaths && (!packageFile || ts2.containsPath(candidate, packageFile))) {
          var moduleName = ts2.getRelativePathFromDirectory(candidate, packageFile || indexPath, false);
          if (state.traceEnabled) {
            trace(state.host, ts2.Diagnostics.package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2, versionPaths.version, ts2.version, moduleName);
          }
          var result = tryLoadModuleUsingPaths(extensions, moduleName, candidate, versionPaths.paths, loader, onlyRecordFailuresForPackageFile || onlyRecordFailuresForIndex, state);
          if (result) {
            return removeIgnoredPackageId(result.value);
          }
        }
        var packageFileResult = packageFile && removeIgnoredPackageId(loader(extensions, packageFile, onlyRecordFailuresForPackageFile, state));
        if (packageFileResult)
          return packageFileResult;
        return loadModuleFromFile(extensions, indexPath, onlyRecordFailuresForIndex, state);
      }
      function resolvedIfExtensionMatches(extensions, path2) {
        var ext = ts2.tryGetExtensionFromPath(path2);
        return ext !== void 0 && extensionIsOk(extensions, ext) ? { path: path2, ext } : void 0;
      }
      function extensionIsOk(extensions, extension) {
        switch (extensions) {
          case Extensions.JavaScript:
            return extension === ".js" || extension === ".jsx";
          case Extensions.TSConfig:
          case Extensions.Json:
            return extension === ".json";
          case Extensions.TypeScript:
            return extension === ".ts" || extension === ".tsx" || extension === ".d.ts";
          case Extensions.DtsOnly:
            return extension === ".d.ts";
        }
      }
      function parsePackageName(moduleName) {
        var idx = moduleName.indexOf(ts2.directorySeparator);
        if (moduleName[0] === "@") {
          idx = moduleName.indexOf(ts2.directorySeparator, idx + 1);
        }
        return idx === -1 ? { packageName: moduleName, rest: "" } : { packageName: moduleName.slice(0, idx), rest: moduleName.slice(idx + 1) };
      }
      ts2.parsePackageName = parsePackageName;
      function loadModuleFromNearestNodeModulesDirectory(extensions, moduleName, directory, state, cache, redirectedReference) {
        return loadModuleFromNearestNodeModulesDirectoryWorker(extensions, moduleName, directory, state, false, cache, redirectedReference);
      }
      function loadModuleFromNearestNodeModulesDirectoryTypesScope(moduleName, directory, state) {
        return loadModuleFromNearestNodeModulesDirectoryWorker(Extensions.DtsOnly, moduleName, directory, state, true, void 0, void 0);
      }
      function loadModuleFromNearestNodeModulesDirectoryWorker(extensions, moduleName, directory, state, typesScopeOnly, cache, redirectedReference) {
        var perModuleNameCache = cache && cache.getOrCreateCacheForModuleName(moduleName, redirectedReference);
        return ts2.forEachAncestorDirectory(ts2.normalizeSlashes(directory), function(ancestorDirectory) {
          if (ts2.getBaseFileName(ancestorDirectory) !== "node_modules") {
            var resolutionFromCache = tryFindNonRelativeModuleNameInCache(perModuleNameCache, moduleName, ancestorDirectory, state);
            if (resolutionFromCache) {
              return resolutionFromCache;
            }
            return toSearchResult(loadModuleFromImmediateNodeModulesDirectory(extensions, moduleName, ancestorDirectory, state, typesScopeOnly));
          }
        });
      }
      function loadModuleFromImmediateNodeModulesDirectory(extensions, moduleName, directory, state, typesScopeOnly) {
        var nodeModulesFolder = ts2.combinePaths(directory, "node_modules");
        var nodeModulesFolderExists = ts2.directoryProbablyExists(nodeModulesFolder, state.host);
        if (!nodeModulesFolderExists && state.traceEnabled) {
          trace(state.host, ts2.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, nodeModulesFolder);
        }
        var packageResult = typesScopeOnly ? void 0 : loadModuleFromSpecificNodeModulesDirectory(extensions, moduleName, nodeModulesFolder, nodeModulesFolderExists, state);
        if (packageResult) {
          return packageResult;
        }
        if (extensions === Extensions.TypeScript || extensions === Extensions.DtsOnly) {
          var nodeModulesAtTypes_1 = ts2.combinePaths(nodeModulesFolder, "@types");
          var nodeModulesAtTypesExists = nodeModulesFolderExists;
          if (nodeModulesFolderExists && !ts2.directoryProbablyExists(nodeModulesAtTypes_1, state.host)) {
            if (state.traceEnabled) {
              trace(state.host, ts2.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, nodeModulesAtTypes_1);
            }
            nodeModulesAtTypesExists = false;
          }
          return loadModuleFromSpecificNodeModulesDirectory(Extensions.DtsOnly, mangleScopedPackageNameWithTrace(moduleName, state), nodeModulesAtTypes_1, nodeModulesAtTypesExists, state);
        }
      }
      function loadModuleFromSpecificNodeModulesDirectory(extensions, moduleName, nodeModulesDirectory, nodeModulesDirectoryExists, state) {
        var candidate = ts2.normalizePath(ts2.combinePaths(nodeModulesDirectory, moduleName));
        var packageInfo = getPackageJsonInfo(candidate, !nodeModulesDirectoryExists, state);
        if (packageInfo) {
          var fromFile = loadModuleFromFile(extensions, candidate, !nodeModulesDirectoryExists, state);
          if (fromFile) {
            return noPackageId(fromFile);
          }
          var fromDirectory = loadNodeModuleFromDirectoryWorker(extensions, candidate, !nodeModulesDirectoryExists, state, packageInfo.packageJsonContent, packageInfo.versionPaths);
          return withPackageId(packageInfo, fromDirectory);
        }
        var loader = function(extensions2, candidate2, onlyRecordFailures, state2) {
          var pathAndExtension = loadModuleFromFile(extensions2, candidate2, onlyRecordFailures, state2) || loadNodeModuleFromDirectoryWorker(extensions2, candidate2, onlyRecordFailures, state2, packageInfo && packageInfo.packageJsonContent, packageInfo && packageInfo.versionPaths);
          return withPackageId(packageInfo, pathAndExtension);
        };
        var _a = parsePackageName(moduleName), packageName = _a.packageName, rest = _a.rest;
        if (rest !== "") {
          var packageDirectory = ts2.combinePaths(nodeModulesDirectory, packageName);
          packageInfo = getPackageJsonInfo(packageDirectory, !nodeModulesDirectoryExists, state);
          if (packageInfo && packageInfo.versionPaths) {
            if (state.traceEnabled) {
              trace(state.host, ts2.Diagnostics.package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2, packageInfo.versionPaths.version, ts2.version, rest);
            }
            var packageDirectoryExists = nodeModulesDirectoryExists && ts2.directoryProbablyExists(packageDirectory, state.host);
            var fromPaths = tryLoadModuleUsingPaths(extensions, rest, packageDirectory, packageInfo.versionPaths.paths, loader, !packageDirectoryExists, state);
            if (fromPaths) {
              return fromPaths.value;
            }
          }
        }
        return loader(extensions, candidate, !nodeModulesDirectoryExists, state);
      }
      function tryLoadModuleUsingPaths(extensions, moduleName, baseDirectory, paths, loader, onlyRecordFailures, state) {
        var matchedPattern = ts2.matchPatternOrExact(ts2.getOwnKeys(paths), moduleName);
        if (matchedPattern) {
          var matchedStar_1 = ts2.isString(matchedPattern) ? void 0 : ts2.matchedText(matchedPattern, moduleName);
          var matchedPatternText = ts2.isString(matchedPattern) ? matchedPattern : ts2.patternText(matchedPattern);
          if (state.traceEnabled) {
            trace(state.host, ts2.Diagnostics.Module_name_0_matched_pattern_1, moduleName, matchedPatternText);
          }
          var resolved = ts2.forEach(paths[matchedPatternText], function(subst) {
            var path2 = matchedStar_1 ? subst.replace("*", matchedStar_1) : subst;
            var candidate = ts2.normalizePath(ts2.combinePaths(baseDirectory, path2));
            if (state.traceEnabled) {
              trace(state.host, ts2.Diagnostics.Trying_substitution_0_candidate_module_location_Colon_1, subst, path2);
            }
            var extension = ts2.tryGetExtensionFromPath(candidate);
            if (extension !== void 0) {
              var path_1 = tryFile(candidate, onlyRecordFailures, state);
              if (path_1 !== void 0) {
                return noPackageId({ path: path_1, ext: extension });
              }
            }
            return loader(extensions, candidate, onlyRecordFailures || !ts2.directoryProbablyExists(ts2.getDirectoryPath(candidate), state.host), state);
          });
          return { value: resolved };
        }
      }
      var mangledScopedPackageSeparator = "__";
      function mangleScopedPackageNameWithTrace(packageName, state) {
        var mangled = mangleScopedPackageName(packageName);
        if (state.traceEnabled && mangled !== packageName) {
          trace(state.host, ts2.Diagnostics.Scoped_package_detected_looking_in_0, mangled);
        }
        return mangled;
      }
      function getTypesPackageName(packageName) {
        return "@types/" + mangleScopedPackageName(packageName);
      }
      ts2.getTypesPackageName = getTypesPackageName;
      function mangleScopedPackageName(packageName) {
        if (ts2.startsWith(packageName, "@")) {
          var replaceSlash = packageName.replace(ts2.directorySeparator, mangledScopedPackageSeparator);
          if (replaceSlash !== packageName) {
            return replaceSlash.slice(1);
          }
        }
        return packageName;
      }
      ts2.mangleScopedPackageName = mangleScopedPackageName;
      function getPackageNameFromTypesPackageName(mangledName) {
        var withoutAtTypePrefix = ts2.removePrefix(mangledName, "@types/");
        if (withoutAtTypePrefix !== mangledName) {
          return unmangleScopedPackageName(withoutAtTypePrefix);
        }
        return mangledName;
      }
      ts2.getPackageNameFromTypesPackageName = getPackageNameFromTypesPackageName;
      function unmangleScopedPackageName(typesPackageName) {
        return ts2.stringContains(typesPackageName, mangledScopedPackageSeparator) ? "@" + typesPackageName.replace(mangledScopedPackageSeparator, ts2.directorySeparator) : typesPackageName;
      }
      ts2.unmangleScopedPackageName = unmangleScopedPackageName;
      function tryFindNonRelativeModuleNameInCache(cache, moduleName, containingDirectory, state) {
        var result = cache && cache.get(containingDirectory);
        if (result) {
          if (state.traceEnabled) {
            trace(state.host, ts2.Diagnostics.Resolution_for_module_0_was_found_in_cache_from_location_1, moduleName, containingDirectory);
          }
          state.resultFromCache = result;
          return { value: result.resolvedModule && { path: result.resolvedModule.resolvedFileName, originalPath: result.resolvedModule.originalPath || true, extension: result.resolvedModule.extension, packageId: result.resolvedModule.packageId } };
        }
      }
      function classicNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference) {
        var traceEnabled = isTraceEnabled(compilerOptions, host);
        var failedLookupLocations = [];
        var state = { compilerOptions, host, traceEnabled, failedLookupLocations };
        var containingDirectory = ts2.getDirectoryPath(containingFile);
        var resolved = tryResolve(Extensions.TypeScript) || tryResolve(Extensions.JavaScript);
        return createResolvedModuleWithFailedLookupLocations(resolved && resolved.value, false, failedLookupLocations, state.resultFromCache);
        function tryResolve(extensions) {
          var resolvedUsingSettings = tryLoadModuleUsingOptionalResolutionSettings(extensions, moduleName, containingDirectory, loadModuleFromFileNoPackageId, state);
          if (resolvedUsingSettings) {
            return { value: resolvedUsingSettings };
          }
          if (!ts2.isExternalModuleNameRelative(moduleName)) {
            var perModuleNameCache_1 = cache && cache.getOrCreateCacheForModuleName(moduleName, redirectedReference);
            var resolved_3 = ts2.forEachAncestorDirectory(containingDirectory, function(directory) {
              var resolutionFromCache = tryFindNonRelativeModuleNameInCache(perModuleNameCache_1, moduleName, directory, state);
              if (resolutionFromCache) {
                return resolutionFromCache;
              }
              var searchName = ts2.normalizePath(ts2.combinePaths(directory, moduleName));
              return toSearchResult(loadModuleFromFileNoPackageId(extensions, searchName, false, state));
            });
            if (resolved_3) {
              return resolved_3;
            }
            if (extensions === Extensions.TypeScript) {
              return loadModuleFromNearestNodeModulesDirectoryTypesScope(moduleName, containingDirectory, state);
            }
          } else {
            var candidate = ts2.normalizePath(ts2.combinePaths(containingDirectory, moduleName));
            return toSearchResult(loadModuleFromFileNoPackageId(extensions, candidate, false, state));
          }
        }
      }
      ts2.classicNameResolver = classicNameResolver;
      function loadModuleFromGlobalCache(moduleName, projectName, compilerOptions, host, globalCache) {
        var traceEnabled = isTraceEnabled(compilerOptions, host);
        if (traceEnabled) {
          trace(host, ts2.Diagnostics.Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using_cache_location_2, projectName, moduleName, globalCache);
        }
        var failedLookupLocations = [];
        var state = { compilerOptions, host, traceEnabled, failedLookupLocations };
        var resolved = loadModuleFromImmediateNodeModulesDirectory(Extensions.DtsOnly, moduleName, globalCache, state, false);
        return createResolvedModuleWithFailedLookupLocations(resolved, true, failedLookupLocations, state.resultFromCache);
      }
      ts2.loadModuleFromGlobalCache = loadModuleFromGlobalCache;
      function toSearchResult(value) {
        return value !== void 0 ? { value } : void 0;
      }
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var ModuleInstanceState;
      (function(ModuleInstanceState2) {
        ModuleInstanceState2[ModuleInstanceState2["NonInstantiated"] = 0] = "NonInstantiated";
        ModuleInstanceState2[ModuleInstanceState2["Instantiated"] = 1] = "Instantiated";
        ModuleInstanceState2[ModuleInstanceState2["ConstEnumOnly"] = 2] = "ConstEnumOnly";
      })(ModuleInstanceState = ts2.ModuleInstanceState || (ts2.ModuleInstanceState = {}));
      function getModuleInstanceState(node, visited) {
        if (node.body && !node.body.parent) {
          setParentPointers(node, node.body);
        }
        return node.body ? getModuleInstanceStateCached(node.body, visited) : 1;
      }
      ts2.getModuleInstanceState = getModuleInstanceState;
      function getModuleInstanceStateCached(node, visited) {
        if (visited === void 0) {
          visited = ts2.createMap();
        }
        var nodeId = "" + ts2.getNodeId(node);
        if (visited.has(nodeId)) {
          return visited.get(nodeId) || 0;
        }
        visited.set(nodeId, void 0);
        var result = getModuleInstanceStateWorker(node, visited);
        visited.set(nodeId, result);
        return result;
      }
      function getModuleInstanceStateWorker(node, visited) {
        switch (node.kind) {
          case 246:
          case 247:
            return 0;
          case 248:
            if (ts2.isEnumConst(node)) {
              return 2;
            }
            break;
          case 254:
          case 253:
            if (!ts2.hasModifier(node, 1)) {
              return 0;
            }
            break;
          case 260:
            var exportDeclaration = node;
            if (!exportDeclaration.moduleSpecifier && exportDeclaration.exportClause && exportDeclaration.exportClause.kind === 261) {
              var state = 0;
              for (var _i = 0, _a = exportDeclaration.exportClause.elements; _i < _a.length; _i++) {
                var specifier = _a[_i];
                var specifierState = getModuleInstanceStateForAliasTarget(specifier, visited);
                if (specifierState > state) {
                  state = specifierState;
                }
                if (state === 1) {
                  return state;
                }
              }
              return state;
            }
            break;
          case 250: {
            var state_1 = 0;
            ts2.forEachChild(node, function(n) {
              var childState = getModuleInstanceStateCached(n, visited);
              switch (childState) {
                case 0:
                  return;
                case 2:
                  state_1 = 2;
                  return;
                case 1:
                  state_1 = 1;
                  return true;
                default:
                  ts2.Debug.assertNever(childState);
              }
            });
            return state_1;
          }
          case 249:
            return getModuleInstanceState(node, visited);
          case 75:
            if (node.isInJSDocNamespace) {
              return 0;
            }
        }
        return 1;
      }
      function getModuleInstanceStateForAliasTarget(specifier, visited) {
        var name = specifier.propertyName || specifier.name;
        var p = specifier.parent;
        while (p) {
          if (ts2.isBlock(p) || ts2.isModuleBlock(p) || ts2.isSourceFile(p)) {
            var statements = p.statements;
            var found = void 0;
            for (var _i = 0, statements_1 = statements; _i < statements_1.length; _i++) {
              var statement = statements_1[_i];
              if (ts2.nodeHasName(statement, name)) {
                if (!statement.parent) {
                  setParentPointers(p, statement);
                }
                var state = getModuleInstanceStateCached(statement, visited);
                if (found === void 0 || state > found) {
                  found = state;
                }
                if (found === 1) {
                  return found;
                }
              }
            }
            if (found !== void 0) {
              return found;
            }
          }
          p = p.parent;
        }
        return 1;
      }
      var ContainerFlags;
      (function(ContainerFlags2) {
        ContainerFlags2[ContainerFlags2["None"] = 0] = "None";
        ContainerFlags2[ContainerFlags2["IsContainer"] = 1] = "IsContainer";
        ContainerFlags2[ContainerFlags2["IsBlockScopedContainer"] = 2] = "IsBlockScopedContainer";
        ContainerFlags2[ContainerFlags2["IsControlFlowContainer"] = 4] = "IsControlFlowContainer";
        ContainerFlags2[ContainerFlags2["IsFunctionLike"] = 8] = "IsFunctionLike";
        ContainerFlags2[ContainerFlags2["IsFunctionExpression"] = 16] = "IsFunctionExpression";
        ContainerFlags2[ContainerFlags2["HasLocals"] = 32] = "HasLocals";
        ContainerFlags2[ContainerFlags2["IsInterface"] = 64] = "IsInterface";
        ContainerFlags2[ContainerFlags2["IsObjectLiteralOrClassExpressionMethod"] = 128] = "IsObjectLiteralOrClassExpressionMethod";
      })(ContainerFlags || (ContainerFlags = {}));
      function initFlowNode(node) {
        ts2.Debug.attachFlowNodeDebugInfo(node);
        return node;
      }
      var binder = createBinder();
      function bindSourceFile(file, options) {
        ts2.performance.mark("beforeBind");
        ts2.perfLogger.logStartBindFile("" + file.fileName);
        binder(file, options);
        ts2.perfLogger.logStopBindFile();
        ts2.performance.mark("afterBind");
        ts2.performance.measure("Bind", "beforeBind", "afterBind");
      }
      ts2.bindSourceFile = bindSourceFile;
      function createBinder() {
        var file;
        var options;
        var languageVersion;
        var parent;
        var container;
        var thisParentContainer;
        var blockScopeContainer;
        var lastContainer;
        var delayedTypeAliases;
        var seenThisKeyword;
        var currentFlow;
        var currentBreakTarget;
        var currentContinueTarget;
        var currentReturnTarget;
        var currentTrueTarget;
        var currentFalseTarget;
        var currentExceptionTarget;
        var preSwitchCaseFlow;
        var activeLabelList;
        var hasExplicitReturn;
        var emitFlags;
        var inStrictMode;
        var symbolCount = 0;
        var Symbol2;
        var classifiableNames;
        var unreachableFlow = { flags: 1 };
        var reportedUnreachableFlow = { flags: 1 };
        var subtreeTransformFlags = 0;
        var skipTransformFlagAggregation;
        function createDiagnosticForNode(node, message, arg0, arg1, arg2) {
          return ts2.createDiagnosticForNodeInSourceFile(ts2.getSourceFileOfNode(node) || file, node, message, arg0, arg1, arg2);
        }
        function bindSourceFile2(f, opts) {
          file = f;
          options = opts;
          languageVersion = ts2.getEmitScriptTarget(options);
          inStrictMode = bindInStrictMode(file, opts);
          classifiableNames = ts2.createUnderscoreEscapedMap();
          symbolCount = 0;
          skipTransformFlagAggregation = file.isDeclarationFile;
          Symbol2 = ts2.objectAllocator.getSymbolConstructor();
          ts2.Debug.attachFlowNodeDebugInfo(unreachableFlow);
          ts2.Debug.attachFlowNodeDebugInfo(reportedUnreachableFlow);
          if (!file.locals) {
            bind(file);
            file.symbolCount = symbolCount;
            file.classifiableNames = classifiableNames;
            delayedBindJSDocTypedefTag();
          }
          file = void 0;
          options = void 0;
          languageVersion = void 0;
          parent = void 0;
          container = void 0;
          thisParentContainer = void 0;
          blockScopeContainer = void 0;
          lastContainer = void 0;
          delayedTypeAliases = void 0;
          seenThisKeyword = false;
          currentFlow = void 0;
          currentBreakTarget = void 0;
          currentContinueTarget = void 0;
          currentReturnTarget = void 0;
          currentTrueTarget = void 0;
          currentFalseTarget = void 0;
          currentExceptionTarget = void 0;
          activeLabelList = void 0;
          hasExplicitReturn = false;
          emitFlags = 0;
          subtreeTransformFlags = 0;
        }
        return bindSourceFile2;
        function bindInStrictMode(file2, opts) {
          if (ts2.getStrictOptionValue(opts, "alwaysStrict") && !file2.isDeclarationFile) {
            return true;
          } else {
            return !!file2.externalModuleIndicator;
          }
        }
        function createSymbol(flags, name) {
          symbolCount++;
          return new Symbol2(flags, name);
        }
        function addDeclarationToSymbol(symbol, node, symbolFlags) {
          symbol.flags |= symbolFlags;
          node.symbol = symbol;
          symbol.declarations = ts2.appendIfUnique(symbol.declarations, node);
          if (symbolFlags & (32 | 384 | 1536 | 3) && !symbol.exports) {
            symbol.exports = ts2.createSymbolTable();
          }
          if (symbolFlags & (32 | 64 | 2048 | 4096) && !symbol.members) {
            symbol.members = ts2.createSymbolTable();
          }
          if (symbol.constEnumOnlyModule && symbol.flags & (16 | 32 | 256)) {
            symbol.constEnumOnlyModule = false;
          }
          if (symbolFlags & 111551) {
            ts2.setValueDeclaration(symbol, node);
          }
        }
        function getDeclarationName(node) {
          if (node.kind === 259) {
            return node.isExportEquals ? "export=" : "default";
          }
          var name = ts2.getNameOfDeclaration(node);
          if (name) {
            if (ts2.isAmbientModule(node)) {
              var moduleName = ts2.getTextOfIdentifierOrLiteral(name);
              return ts2.isGlobalScopeAugmentation(node) ? "__global" : '"' + moduleName + '"';
            }
            if (name.kind === 154) {
              var nameExpression = name.expression;
              if (ts2.isStringOrNumericLiteralLike(nameExpression)) {
                return ts2.escapeLeadingUnderscores(nameExpression.text);
              }
              if (ts2.isSignedNumericLiteral(nameExpression)) {
                return ts2.tokenToString(nameExpression.operator) + nameExpression.operand.text;
              }
              ts2.Debug.assert(ts2.isWellKnownSymbolSyntactically(nameExpression));
              return ts2.getPropertyNameForKnownSymbolName(ts2.idText(nameExpression.name));
            }
            if (ts2.isWellKnownSymbolSyntactically(name)) {
              return ts2.getPropertyNameForKnownSymbolName(ts2.idText(name.name));
            }
            if (ts2.isPrivateIdentifier(name)) {
              var containingClass = ts2.getContainingClass(node);
              if (!containingClass) {
                return void 0;
              }
              var containingClassSymbol = containingClass.symbol;
              return ts2.getSymbolNameForPrivateIdentifier(containingClassSymbol, name.escapedText);
            }
            return ts2.isPropertyNameLiteral(name) ? ts2.getEscapedTextOfIdentifierOrLiteral(name) : void 0;
          }
          switch (node.kind) {
            case 162:
              return "__constructor";
            case 170:
            case 165:
            case 305:
              return "__call";
            case 171:
            case 166:
              return "__new";
            case 167:
              return "__index";
            case 260:
              return "__export";
            case 290:
              return "export=";
            case 209:
              if (ts2.getAssignmentDeclarationKind(node) === 2) {
                return "export=";
              }
              ts2.Debug.fail("Unknown binary declaration kind");
              break;
            case 300:
              return ts2.isJSDocConstructSignature(node) ? "__new" : "__call";
            case 156:
              ts2.Debug.assert(node.parent.kind === 300, "Impossible parameter parent kind", function() {
                return "parent is: " + (ts2.SyntaxKind ? ts2.SyntaxKind[node.parent.kind] : node.parent.kind) + ", expected JSDocFunctionType";
              });
              var functionType = node.parent;
              var index = functionType.parameters.indexOf(node);
              return "arg" + index;
          }
        }
        function getDisplayName(node) {
          return ts2.isNamedDeclaration(node) ? ts2.declarationNameToString(node.name) : ts2.unescapeLeadingUnderscores(ts2.Debug.checkDefined(getDeclarationName(node)));
        }
        function declareSymbol(symbolTable, parent2, node, includes, excludes, isReplaceableByMethod) {
          ts2.Debug.assert(!ts2.hasDynamicName(node));
          var isDefaultExport = ts2.hasModifier(node, 512) || ts2.isExportSpecifier(node) && node.name.escapedText === "default";
          var name = isDefaultExport && parent2 ? "default" : getDeclarationName(node);
          var symbol;
          if (name === void 0) {
            symbol = createSymbol(0, "__missing");
          } else {
            symbol = symbolTable.get(name);
            if (includes & 2885600) {
              classifiableNames.set(name, true);
            }
            if (!symbol) {
              symbolTable.set(name, symbol = createSymbol(0, name));
              if (isReplaceableByMethod)
                symbol.isReplaceableByMethod = true;
            } else if (isReplaceableByMethod && !symbol.isReplaceableByMethod) {
              return symbol;
            } else if (symbol.flags & excludes) {
              if (symbol.isReplaceableByMethod) {
                symbolTable.set(name, symbol = createSymbol(0, name));
              } else if (!(includes & 3 && symbol.flags & 67108864)) {
                if (ts2.isNamedDeclaration(node)) {
                  node.name.parent = node;
                }
                var message_1 = symbol.flags & 2 ? ts2.Diagnostics.Cannot_redeclare_block_scoped_variable_0 : ts2.Diagnostics.Duplicate_identifier_0;
                var messageNeedsName_1 = true;
                if (symbol.flags & 384 || includes & 384) {
                  message_1 = ts2.Diagnostics.Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations;
                  messageNeedsName_1 = false;
                }
                var multipleDefaultExports_1 = false;
                if (ts2.length(symbol.declarations)) {
                  if (isDefaultExport) {
                    message_1 = ts2.Diagnostics.A_module_cannot_have_multiple_default_exports;
                    messageNeedsName_1 = false;
                    multipleDefaultExports_1 = true;
                  } else {
                    if (symbol.declarations && symbol.declarations.length && (node.kind === 259 && !node.isExportEquals)) {
                      message_1 = ts2.Diagnostics.A_module_cannot_have_multiple_default_exports;
                      messageNeedsName_1 = false;
                      multipleDefaultExports_1 = true;
                    }
                  }
                }
                var relatedInformation_1 = [];
                if (ts2.isTypeAliasDeclaration(node) && ts2.nodeIsMissing(node.type) && ts2.hasModifier(node, 1) && symbol.flags & (2097152 | 788968 | 1920)) {
                  relatedInformation_1.push(createDiagnosticForNode(node, ts2.Diagnostics.Did_you_mean_0, "export type { " + ts2.unescapeLeadingUnderscores(node.name.escapedText) + " }"));
                }
                var declarationName_1 = ts2.getNameOfDeclaration(node) || node;
                ts2.forEach(symbol.declarations, function(declaration, index) {
                  var decl = ts2.getNameOfDeclaration(declaration) || declaration;
                  var diag2 = createDiagnosticForNode(decl, message_1, messageNeedsName_1 ? getDisplayName(declaration) : void 0);
                  file.bindDiagnostics.push(multipleDefaultExports_1 ? ts2.addRelatedInfo(diag2, createDiagnosticForNode(declarationName_1, index === 0 ? ts2.Diagnostics.Another_export_default_is_here : ts2.Diagnostics.and_here)) : diag2);
                  if (multipleDefaultExports_1) {
                    relatedInformation_1.push(createDiagnosticForNode(decl, ts2.Diagnostics.The_first_export_default_is_here));
                  }
                });
                var diag = createDiagnosticForNode(declarationName_1, message_1, messageNeedsName_1 ? getDisplayName(node) : void 0);
                file.bindDiagnostics.push(ts2.addRelatedInfo.apply(void 0, __spreadArrays([diag], relatedInformation_1)));
                symbol = createSymbol(0, name);
              }
            }
          }
          addDeclarationToSymbol(symbol, node, includes);
          if (symbol.parent) {
            ts2.Debug.assert(symbol.parent === parent2, "Existing symbol parent should match new one");
          } else {
            symbol.parent = parent2;
          }
          return symbol;
        }
        function declareModuleMember(node, symbolFlags, symbolExcludes) {
          var hasExportModifier = ts2.getCombinedModifierFlags(node) & 1;
          if (symbolFlags & 2097152) {
            if (node.kind === 263 || node.kind === 253 && hasExportModifier) {
              return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
            } else {
              return declareSymbol(container.locals, void 0, node, symbolFlags, symbolExcludes);
            }
          } else {
            if (ts2.isJSDocTypeAlias(node))
              ts2.Debug.assert(ts2.isInJSFile(node));
            if (!ts2.isAmbientModule(node) && (hasExportModifier || container.flags & 64) || ts2.isJSDocTypeAlias(node)) {
              if (!container.locals || ts2.hasModifier(node, 512) && !getDeclarationName(node)) {
                return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
              }
              var exportKind = symbolFlags & 111551 ? 1048576 : 0;
              var local = declareSymbol(container.locals, void 0, node, exportKind, symbolExcludes);
              local.exportSymbol = declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
              node.localSymbol = local;
              return local;
            } else {
              return declareSymbol(container.locals, void 0, node, symbolFlags, symbolExcludes);
            }
          }
        }
        function bindContainer(node, containerFlags) {
          var saveContainer = container;
          var saveThisParentContainer = thisParentContainer;
          var savedBlockScopeContainer = blockScopeContainer;
          if (containerFlags & 1) {
            if (node.kind !== 202) {
              thisParentContainer = container;
            }
            container = blockScopeContainer = node;
            if (containerFlags & 32) {
              container.locals = ts2.createSymbolTable();
            }
            addToContainerChain(container);
          } else if (containerFlags & 2) {
            blockScopeContainer = node;
            blockScopeContainer.locals = void 0;
          }
          if (containerFlags & 4) {
            var saveCurrentFlow = currentFlow;
            var saveBreakTarget = currentBreakTarget;
            var saveContinueTarget = currentContinueTarget;
            var saveReturnTarget = currentReturnTarget;
            var saveExceptionTarget = currentExceptionTarget;
            var saveActiveLabelList = activeLabelList;
            var saveHasExplicitReturn = hasExplicitReturn;
            var isIIFE = containerFlags & 16 && !ts2.hasModifier(node, 256) && !node.asteriskToken && !!ts2.getImmediatelyInvokedFunctionExpression(node);
            if (!isIIFE) {
              currentFlow = initFlowNode({ flags: 2 });
              if (containerFlags & (16 | 128)) {
                currentFlow.node = node;
              }
            }
            currentReturnTarget = isIIFE || node.kind === 162 ? createBranchLabel() : void 0;
            currentExceptionTarget = void 0;
            currentBreakTarget = void 0;
            currentContinueTarget = void 0;
            activeLabelList = void 0;
            hasExplicitReturn = false;
            bindChildren(node);
            node.flags &= ~2816;
            if (!(currentFlow.flags & 1) && containerFlags & 8 && ts2.nodeIsPresent(node.body)) {
              node.flags |= 256;
              if (hasExplicitReturn)
                node.flags |= 512;
              node.endFlowNode = currentFlow;
            }
            if (node.kind === 290) {
              node.flags |= emitFlags;
            }
            if (currentReturnTarget) {
              addAntecedent(currentReturnTarget, currentFlow);
              currentFlow = finishFlowLabel(currentReturnTarget);
              if (node.kind === 162) {
                node.returnFlowNode = currentFlow;
              }
            }
            if (!isIIFE) {
              currentFlow = saveCurrentFlow;
            }
            currentBreakTarget = saveBreakTarget;
            currentContinueTarget = saveContinueTarget;
            currentReturnTarget = saveReturnTarget;
            currentExceptionTarget = saveExceptionTarget;
            activeLabelList = saveActiveLabelList;
            hasExplicitReturn = saveHasExplicitReturn;
          } else if (containerFlags & 64) {
            seenThisKeyword = false;
            bindChildren(node);
            node.flags = seenThisKeyword ? node.flags | 128 : node.flags & ~128;
          } else {
            bindChildren(node);
          }
          container = saveContainer;
          thisParentContainer = saveThisParentContainer;
          blockScopeContainer = savedBlockScopeContainer;
        }
        function bindChildren(node) {
          if (skipTransformFlagAggregation) {
            bindChildrenWorker(node);
          } else if (node.transformFlags & 536870912) {
            skipTransformFlagAggregation = true;
            bindChildrenWorker(node);
            skipTransformFlagAggregation = false;
            subtreeTransformFlags |= node.transformFlags & ~getTransformFlagsSubtreeExclusions(node.kind);
          } else {
            var savedSubtreeTransformFlags = subtreeTransformFlags;
            subtreeTransformFlags = 0;
            bindChildrenWorker(node);
            subtreeTransformFlags = savedSubtreeTransformFlags | computeTransformFlagsForNode(node, subtreeTransformFlags);
          }
        }
        function bindEachFunctionsFirst(nodes) {
          bindEach(nodes, function(n) {
            return n.kind === 244 ? bind(n) : void 0;
          });
          bindEach(nodes, function(n) {
            return n.kind !== 244 ? bind(n) : void 0;
          });
        }
        function bindEach(nodes, bindFunction) {
          if (bindFunction === void 0) {
            bindFunction = bind;
          }
          if (nodes === void 0) {
            return;
          }
          if (skipTransformFlagAggregation) {
            ts2.forEach(nodes, bindFunction);
          } else {
            var savedSubtreeTransformFlags = subtreeTransformFlags;
            subtreeTransformFlags = 0;
            var nodeArrayFlags = 0;
            for (var _i = 0, nodes_2 = nodes; _i < nodes_2.length; _i++) {
              var node = nodes_2[_i];
              bindFunction(node);
              nodeArrayFlags |= node.transformFlags & ~536870912;
            }
            nodes.transformFlags = nodeArrayFlags | 536870912;
            subtreeTransformFlags |= savedSubtreeTransformFlags;
          }
        }
        function bindEachChild(node) {
          ts2.forEachChild(node, bind, bindEach);
        }
        function bindChildrenWorker(node) {
          if (checkUnreachable(node)) {
            bindEachChild(node);
            bindJSDoc(node);
            return;
          }
          if (node.kind >= 225 && node.kind <= 241 && !options.allowUnreachableCode) {
            node.flowNode = currentFlow;
          }
          switch (node.kind) {
            case 229:
              bindWhileStatement(node);
              break;
            case 228:
              bindDoStatement(node);
              break;
            case 230:
              bindForStatement(node);
              break;
            case 231:
            case 232:
              bindForInOrForOfStatement(node);
              break;
            case 227:
              bindIfStatement(node);
              break;
            case 235:
            case 239:
              bindReturnOrThrow(node);
              break;
            case 234:
            case 233:
              bindBreakOrContinueStatement(node);
              break;
            case 240:
              bindTryStatement(node);
              break;
            case 237:
              bindSwitchStatement(node);
              break;
            case 251:
              bindCaseBlock(node);
              break;
            case 277:
              bindCaseClause(node);
              break;
            case 226:
              bindExpressionStatement(node);
              break;
            case 238:
              bindLabeledStatement(node);
              break;
            case 207:
              bindPrefixUnaryExpressionFlow(node);
              break;
            case 208:
              bindPostfixUnaryExpressionFlow(node);
              break;
            case 209:
              bindBinaryExpressionFlow(node);
              break;
            case 203:
              bindDeleteExpressionFlow(node);
              break;
            case 210:
              bindConditionalExpressionFlow(node);
              break;
            case 242:
              bindVariableDeclarationFlow(node);
              break;
            case 194:
            case 195:
              bindAccessExpressionFlow(node);
              break;
            case 196:
              bindCallExpressionFlow(node);
              break;
            case 218:
              bindNonNullExpressionFlow(node);
              break;
            case 322:
            case 315:
            case 316:
              bindJSDocTypeAlias(node);
              break;
            case 290: {
              bindEachFunctionsFirst(node.statements);
              bind(node.endOfFileToken);
              break;
            }
            case 223:
            case 250:
              bindEachFunctionsFirst(node.statements);
              break;
            default:
              bindEachChild(node);
              break;
          }
          bindJSDoc(node);
        }
        function isNarrowingExpression(expr) {
          switch (expr.kind) {
            case 75:
            case 104:
            case 194:
            case 195:
              return containsNarrowableReference(expr);
            case 196:
              return hasNarrowableArgument(expr);
            case 200:
              return isNarrowingExpression(expr.expression);
            case 209:
              return isNarrowingBinaryExpression(expr);
            case 207:
              return expr.operator === 53 && isNarrowingExpression(expr.operand);
            case 204:
              return isNarrowingExpression(expr.expression);
          }
          return false;
        }
        function isNarrowableReference(expr) {
          return expr.kind === 75 || expr.kind === 104 || expr.kind === 102 || (ts2.isPropertyAccessExpression(expr) || ts2.isNonNullExpression(expr) || ts2.isParenthesizedExpression(expr)) && isNarrowableReference(expr.expression) || ts2.isElementAccessExpression(expr) && ts2.isStringOrNumericLiteralLike(expr.argumentExpression) && isNarrowableReference(expr.expression);
        }
        function containsNarrowableReference(expr) {
          return isNarrowableReference(expr) || ts2.isOptionalChain(expr) && containsNarrowableReference(expr.expression);
        }
        function hasNarrowableArgument(expr) {
          if (expr.arguments) {
            for (var _i = 0, _a = expr.arguments; _i < _a.length; _i++) {
              var argument = _a[_i];
              if (containsNarrowableReference(argument)) {
                return true;
              }
            }
          }
          if (expr.expression.kind === 194 && containsNarrowableReference(expr.expression.expression)) {
            return true;
          }
          return false;
        }
        function isNarrowingTypeofOperands(expr1, expr2) {
          return ts2.isTypeOfExpression(expr1) && isNarrowableOperand(expr1.expression) && ts2.isStringLiteralLike(expr2);
        }
        function isNarrowableInOperands(left, right) {
          return ts2.isStringLiteralLike(left) && isNarrowingExpression(right);
        }
        function isNarrowingBinaryExpression(expr) {
          switch (expr.operatorToken.kind) {
            case 62:
              return containsNarrowableReference(expr.left);
            case 34:
            case 35:
            case 36:
            case 37:
              return isNarrowableOperand(expr.left) || isNarrowableOperand(expr.right) || isNarrowingTypeofOperands(expr.right, expr.left) || isNarrowingTypeofOperands(expr.left, expr.right);
            case 98:
              return isNarrowableOperand(expr.left);
            case 97:
              return isNarrowableInOperands(expr.left, expr.right);
            case 27:
              return isNarrowingExpression(expr.right);
          }
          return false;
        }
        function isNarrowableOperand(expr) {
          switch (expr.kind) {
            case 200:
              return isNarrowableOperand(expr.expression);
            case 209:
              switch (expr.operatorToken.kind) {
                case 62:
                  return isNarrowableOperand(expr.left);
                case 27:
                  return isNarrowableOperand(expr.right);
              }
          }
          return containsNarrowableReference(expr);
        }
        function createBranchLabel() {
          return initFlowNode({ flags: 4, antecedents: void 0 });
        }
        function createLoopLabel() {
          return initFlowNode({ flags: 8, antecedents: void 0 });
        }
        function createReduceLabel(target, antecedents, antecedent) {
          return initFlowNode({ flags: 1024, target, antecedents, antecedent });
        }
        function setFlowNodeReferenced(flow) {
          flow.flags |= flow.flags & 2048 ? 4096 : 2048;
        }
        function addAntecedent(label, antecedent) {
          if (!(antecedent.flags & 1) && !ts2.contains(label.antecedents, antecedent)) {
            (label.antecedents || (label.antecedents = [])).push(antecedent);
            setFlowNodeReferenced(antecedent);
          }
        }
        function createFlowCondition(flags, antecedent, expression) {
          if (antecedent.flags & 1) {
            return antecedent;
          }
          if (!expression) {
            return flags & 32 ? antecedent : unreachableFlow;
          }
          if ((expression.kind === 106 && flags & 64 || expression.kind === 91 && flags & 32) && !ts2.isExpressionOfOptionalChainRoot(expression) && !ts2.isNullishCoalesce(expression.parent)) {
            return unreachableFlow;
          }
          if (!isNarrowingExpression(expression)) {
            return antecedent;
          }
          setFlowNodeReferenced(antecedent);
          return initFlowNode({ flags, antecedent, node: expression });
        }
        function createFlowSwitchClause(antecedent, switchStatement, clauseStart, clauseEnd) {
          setFlowNodeReferenced(antecedent);
          return initFlowNode({ flags: 128, antecedent, switchStatement, clauseStart, clauseEnd });
        }
        function createFlowMutation(flags, antecedent, node) {
          setFlowNodeReferenced(antecedent);
          var result = initFlowNode({ flags, antecedent, node });
          if (currentExceptionTarget) {
            addAntecedent(currentExceptionTarget, result);
          }
          return result;
        }
        function createFlowCall(antecedent, node) {
          setFlowNodeReferenced(antecedent);
          return initFlowNode({ flags: 512, antecedent, node });
        }
        function finishFlowLabel(flow) {
          var antecedents = flow.antecedents;
          if (!antecedents) {
            return unreachableFlow;
          }
          if (antecedents.length === 1) {
            return antecedents[0];
          }
          return flow;
        }
        function isStatementCondition(node) {
          var parent2 = node.parent;
          switch (parent2.kind) {
            case 227:
            case 229:
            case 228:
              return parent2.expression === node;
            case 230:
            case 210:
              return parent2.condition === node;
          }
          return false;
        }
        function isLogicalExpression(node) {
          while (true) {
            if (node.kind === 200) {
              node = node.expression;
            } else if (node.kind === 207 && node.operator === 53) {
              node = node.operand;
            } else {
              return node.kind === 209 && (node.operatorToken.kind === 55 || node.operatorToken.kind === 56 || node.operatorToken.kind === 60);
            }
          }
        }
        function isTopLevelLogicalExpression(node) {
          while (ts2.isParenthesizedExpression(node.parent) || ts2.isPrefixUnaryExpression(node.parent) && node.parent.operator === 53) {
            node = node.parent;
          }
          return !isStatementCondition(node) && !isLogicalExpression(node.parent) && !(ts2.isOptionalChain(node.parent) && node.parent.expression === node);
        }
        function doWithConditionalBranches(action, value, trueTarget, falseTarget) {
          var savedTrueTarget = currentTrueTarget;
          var savedFalseTarget = currentFalseTarget;
          currentTrueTarget = trueTarget;
          currentFalseTarget = falseTarget;
          action(value);
          currentTrueTarget = savedTrueTarget;
          currentFalseTarget = savedFalseTarget;
        }
        function bindCondition(node, trueTarget, falseTarget) {
          doWithConditionalBranches(bind, node, trueTarget, falseTarget);
          if (!node || !isLogicalExpression(node) && !(ts2.isOptionalChain(node) && ts2.isOutermostOptionalChain(node))) {
            addAntecedent(trueTarget, createFlowCondition(32, currentFlow, node));
            addAntecedent(falseTarget, createFlowCondition(64, currentFlow, node));
          }
        }
        function bindIterativeStatement(node, breakTarget, continueTarget) {
          var saveBreakTarget = currentBreakTarget;
          var saveContinueTarget = currentContinueTarget;
          currentBreakTarget = breakTarget;
          currentContinueTarget = continueTarget;
          bind(node);
          currentBreakTarget = saveBreakTarget;
          currentContinueTarget = saveContinueTarget;
        }
        function setContinueTarget(node, target) {
          var label = activeLabelList;
          while (label && node.parent.kind === 238) {
            label.continueTarget = target;
            label = label.next;
            node = node.parent;
          }
          return target;
        }
        function bindWhileStatement(node) {
          var preWhileLabel = setContinueTarget(node, createLoopLabel());
          var preBodyLabel = createBranchLabel();
          var postWhileLabel = createBranchLabel();
          addAntecedent(preWhileLabel, currentFlow);
          currentFlow = preWhileLabel;
          bindCondition(node.expression, preBodyLabel, postWhileLabel);
          currentFlow = finishFlowLabel(preBodyLabel);
          bindIterativeStatement(node.statement, postWhileLabel, preWhileLabel);
          addAntecedent(preWhileLabel, currentFlow);
          currentFlow = finishFlowLabel(postWhileLabel);
        }
        function bindDoStatement(node) {
          var preDoLabel = createLoopLabel();
          var preConditionLabel = setContinueTarget(node, createBranchLabel());
          var postDoLabel = createBranchLabel();
          addAntecedent(preDoLabel, currentFlow);
          currentFlow = preDoLabel;
          bindIterativeStatement(node.statement, postDoLabel, preConditionLabel);
          addAntecedent(preConditionLabel, currentFlow);
          currentFlow = finishFlowLabel(preConditionLabel);
          bindCondition(node.expression, preDoLabel, postDoLabel);
          currentFlow = finishFlowLabel(postDoLabel);
        }
        function bindForStatement(node) {
          var preLoopLabel = setContinueTarget(node, createLoopLabel());
          var preBodyLabel = createBranchLabel();
          var postLoopLabel = createBranchLabel();
          bind(node.initializer);
          addAntecedent(preLoopLabel, currentFlow);
          currentFlow = preLoopLabel;
          bindCondition(node.condition, preBodyLabel, postLoopLabel);
          currentFlow = finishFlowLabel(preBodyLabel);
          bindIterativeStatement(node.statement, postLoopLabel, preLoopLabel);
          bind(node.incrementor);
          addAntecedent(preLoopLabel, currentFlow);
          currentFlow = finishFlowLabel(postLoopLabel);
        }
        function bindForInOrForOfStatement(node) {
          var preLoopLabel = setContinueTarget(node, createLoopLabel());
          var postLoopLabel = createBranchLabel();
          bind(node.expression);
          addAntecedent(preLoopLabel, currentFlow);
          currentFlow = preLoopLabel;
          if (node.kind === 232) {
            bind(node.awaitModifier);
          }
          addAntecedent(postLoopLabel, currentFlow);
          bind(node.initializer);
          if (node.initializer.kind !== 243) {
            bindAssignmentTargetFlow(node.initializer);
          }
          bindIterativeStatement(node.statement, postLoopLabel, preLoopLabel);
          addAntecedent(preLoopLabel, currentFlow);
          currentFlow = finishFlowLabel(postLoopLabel);
        }
        function bindIfStatement(node) {
          var thenLabel = createBranchLabel();
          var elseLabel = createBranchLabel();
          var postIfLabel = createBranchLabel();
          bindCondition(node.expression, thenLabel, elseLabel);
          currentFlow = finishFlowLabel(thenLabel);
          bind(node.thenStatement);
          addAntecedent(postIfLabel, currentFlow);
          currentFlow = finishFlowLabel(elseLabel);
          bind(node.elseStatement);
          addAntecedent(postIfLabel, currentFlow);
          currentFlow = finishFlowLabel(postIfLabel);
        }
        function bindReturnOrThrow(node) {
          bind(node.expression);
          if (node.kind === 235) {
            hasExplicitReturn = true;
            if (currentReturnTarget) {
              addAntecedent(currentReturnTarget, currentFlow);
            }
          }
          currentFlow = unreachableFlow;
        }
        function findActiveLabel(name) {
          for (var label = activeLabelList; label; label = label.next) {
            if (label.name === name) {
              return label;
            }
          }
          return void 0;
        }
        function bindBreakOrContinueFlow(node, breakTarget, continueTarget) {
          var flowLabel = node.kind === 234 ? breakTarget : continueTarget;
          if (flowLabel) {
            addAntecedent(flowLabel, currentFlow);
            currentFlow = unreachableFlow;
          }
        }
        function bindBreakOrContinueStatement(node) {
          bind(node.label);
          if (node.label) {
            var activeLabel = findActiveLabel(node.label.escapedText);
            if (activeLabel) {
              activeLabel.referenced = true;
              bindBreakOrContinueFlow(node, activeLabel.breakTarget, activeLabel.continueTarget);
            }
          } else {
            bindBreakOrContinueFlow(node, currentBreakTarget, currentContinueTarget);
          }
        }
        function bindTryStatement(node) {
          var saveReturnTarget = currentReturnTarget;
          var saveExceptionTarget = currentExceptionTarget;
          var normalExitLabel = createBranchLabel();
          var returnLabel = createBranchLabel();
          var exceptionLabel = createBranchLabel();
          if (node.finallyBlock) {
            currentReturnTarget = returnLabel;
          }
          addAntecedent(exceptionLabel, currentFlow);
          currentExceptionTarget = exceptionLabel;
          bind(node.tryBlock);
          addAntecedent(normalExitLabel, currentFlow);
          if (node.catchClause) {
            currentFlow = finishFlowLabel(exceptionLabel);
            exceptionLabel = createBranchLabel();
            addAntecedent(exceptionLabel, currentFlow);
            currentExceptionTarget = exceptionLabel;
            bind(node.catchClause);
            addAntecedent(normalExitLabel, currentFlow);
          }
          currentReturnTarget = saveReturnTarget;
          currentExceptionTarget = saveExceptionTarget;
          if (node.finallyBlock) {
            var finallyLabel = createBranchLabel();
            finallyLabel.antecedents = ts2.concatenate(ts2.concatenate(normalExitLabel.antecedents, exceptionLabel.antecedents), returnLabel.antecedents);
            currentFlow = finallyLabel;
            bind(node.finallyBlock);
            if (currentFlow.flags & 1) {
              currentFlow = unreachableFlow;
            } else {
              if (currentReturnTarget && returnLabel.antecedents) {
                addAntecedent(currentReturnTarget, createReduceLabel(finallyLabel, returnLabel.antecedents, currentFlow));
              }
              currentFlow = normalExitLabel.antecedents ? createReduceLabel(finallyLabel, normalExitLabel.antecedents, currentFlow) : unreachableFlow;
            }
          } else {
            currentFlow = finishFlowLabel(normalExitLabel);
          }
        }
        function bindSwitchStatement(node) {
          var postSwitchLabel = createBranchLabel();
          bind(node.expression);
          var saveBreakTarget = currentBreakTarget;
          var savePreSwitchCaseFlow = preSwitchCaseFlow;
          currentBreakTarget = postSwitchLabel;
          preSwitchCaseFlow = currentFlow;
          bind(node.caseBlock);
          addAntecedent(postSwitchLabel, currentFlow);
          var hasDefault = ts2.forEach(node.caseBlock.clauses, function(c) {
            return c.kind === 278;
          });
          node.possiblyExhaustive = !hasDefault && !postSwitchLabel.antecedents;
          if (!hasDefault) {
            addAntecedent(postSwitchLabel, createFlowSwitchClause(preSwitchCaseFlow, node, 0, 0));
          }
          currentBreakTarget = saveBreakTarget;
          preSwitchCaseFlow = savePreSwitchCaseFlow;
          currentFlow = finishFlowLabel(postSwitchLabel);
        }
        function bindCaseBlock(node) {
          var savedSubtreeTransformFlags = subtreeTransformFlags;
          subtreeTransformFlags = 0;
          var clauses = node.clauses;
          var isNarrowingSwitch = isNarrowingExpression(node.parent.expression);
          var fallthroughFlow = unreachableFlow;
          for (var i = 0; i < clauses.length; i++) {
            var clauseStart = i;
            while (!clauses[i].statements.length && i + 1 < clauses.length) {
              bind(clauses[i]);
              i++;
            }
            var preCaseLabel = createBranchLabel();
            addAntecedent(preCaseLabel, isNarrowingSwitch ? createFlowSwitchClause(preSwitchCaseFlow, node.parent, clauseStart, i + 1) : preSwitchCaseFlow);
            addAntecedent(preCaseLabel, fallthroughFlow);
            currentFlow = finishFlowLabel(preCaseLabel);
            var clause = clauses[i];
            bind(clause);
            fallthroughFlow = currentFlow;
            if (!(currentFlow.flags & 1) && i !== clauses.length - 1 && options.noFallthroughCasesInSwitch) {
              clause.fallthroughFlowNode = currentFlow;
            }
          }
          clauses.transformFlags = subtreeTransformFlags | 536870912;
          subtreeTransformFlags |= savedSubtreeTransformFlags;
        }
        function bindCaseClause(node) {
          var saveCurrentFlow = currentFlow;
          currentFlow = preSwitchCaseFlow;
          bind(node.expression);
          currentFlow = saveCurrentFlow;
          bindEach(node.statements);
        }
        function bindExpressionStatement(node) {
          bind(node.expression);
          if (node.expression.kind === 196) {
            var call = node.expression;
            if (ts2.isDottedName(call.expression)) {
              currentFlow = createFlowCall(currentFlow, call);
            }
          }
        }
        function bindLabeledStatement(node) {
          var postStatementLabel = createBranchLabel();
          activeLabelList = {
            next: activeLabelList,
            name: node.label.escapedText,
            breakTarget: postStatementLabel,
            continueTarget: void 0,
            referenced: false
          };
          bind(node.label);
          bind(node.statement);
          if (!activeLabelList.referenced && !options.allowUnusedLabels) {
            errorOrSuggestionOnNode(ts2.unusedLabelIsError(options), node.label, ts2.Diagnostics.Unused_label);
          }
          activeLabelList = activeLabelList.next;
          addAntecedent(postStatementLabel, currentFlow);
          currentFlow = finishFlowLabel(postStatementLabel);
        }
        function bindDestructuringTargetFlow(node) {
          if (node.kind === 209 && node.operatorToken.kind === 62) {
            bindAssignmentTargetFlow(node.left);
          } else {
            bindAssignmentTargetFlow(node);
          }
        }
        function bindAssignmentTargetFlow(node) {
          if (isNarrowableReference(node)) {
            currentFlow = createFlowMutation(16, currentFlow, node);
          } else if (node.kind === 192) {
            for (var _i = 0, _a = node.elements; _i < _a.length; _i++) {
              var e = _a[_i];
              if (e.kind === 213) {
                bindAssignmentTargetFlow(e.expression);
              } else {
                bindDestructuringTargetFlow(e);
              }
            }
          } else if (node.kind === 193) {
            for (var _b = 0, _c = node.properties; _b < _c.length; _b++) {
              var p = _c[_b];
              if (p.kind === 281) {
                bindDestructuringTargetFlow(p.initializer);
              } else if (p.kind === 282) {
                bindAssignmentTargetFlow(p.name);
              } else if (p.kind === 283) {
                bindAssignmentTargetFlow(p.expression);
              }
            }
          }
        }
        function bindLogicalExpression(node, trueTarget, falseTarget) {
          var preRightLabel = createBranchLabel();
          if (node.operatorToken.kind === 55) {
            bindCondition(node.left, preRightLabel, falseTarget);
          } else {
            bindCondition(node.left, trueTarget, preRightLabel);
          }
          currentFlow = finishFlowLabel(preRightLabel);
          bind(node.operatorToken);
          bindCondition(node.right, trueTarget, falseTarget);
        }
        function bindPrefixUnaryExpressionFlow(node) {
          if (node.operator === 53) {
            var saveTrueTarget = currentTrueTarget;
            currentTrueTarget = currentFalseTarget;
            currentFalseTarget = saveTrueTarget;
            bindEachChild(node);
            currentFalseTarget = currentTrueTarget;
            currentTrueTarget = saveTrueTarget;
          } else {
            bindEachChild(node);
            if (node.operator === 45 || node.operator === 46) {
              bindAssignmentTargetFlow(node.operand);
            }
          }
        }
        function bindPostfixUnaryExpressionFlow(node) {
          bindEachChild(node);
          if (node.operator === 45 || node.operator === 46) {
            bindAssignmentTargetFlow(node.operand);
          }
        }
        var BindBinaryExpressionFlowState;
        (function(BindBinaryExpressionFlowState2) {
          BindBinaryExpressionFlowState2[BindBinaryExpressionFlowState2["BindThenBindChildren"] = 0] = "BindThenBindChildren";
          BindBinaryExpressionFlowState2[BindBinaryExpressionFlowState2["MaybeBindLeft"] = 1] = "MaybeBindLeft";
          BindBinaryExpressionFlowState2[BindBinaryExpressionFlowState2["BindToken"] = 2] = "BindToken";
          BindBinaryExpressionFlowState2[BindBinaryExpressionFlowState2["BindRight"] = 3] = "BindRight";
          BindBinaryExpressionFlowState2[BindBinaryExpressionFlowState2["FinishBind"] = 4] = "FinishBind";
        })(BindBinaryExpressionFlowState || (BindBinaryExpressionFlowState = {}));
        function bindBinaryExpressionFlow(node) {
          var workStacks = {
            expr: [node],
            state: [1],
            inStrictMode: [void 0],
            parent: [void 0],
            subtreeFlags: [void 0]
          };
          var stackIndex = 0;
          while (stackIndex >= 0) {
            node = workStacks.expr[stackIndex];
            switch (workStacks.state[stackIndex]) {
              case 0: {
                node.parent = parent;
                var saveInStrictMode = inStrictMode;
                bindWorker(node);
                var saveParent = parent;
                parent = node;
                var subtreeFlagsState = void 0;
                if (skipTransformFlagAggregation) {
                } else if (node.transformFlags & 536870912) {
                  skipTransformFlagAggregation = true;
                  subtreeFlagsState = -1;
                } else {
                  var savedSubtreeTransformFlags = subtreeTransformFlags;
                  subtreeTransformFlags = 0;
                  subtreeFlagsState = savedSubtreeTransformFlags;
                }
                advanceState(1, saveInStrictMode, saveParent, subtreeFlagsState);
                break;
              }
              case 1: {
                var operator = node.operatorToken.kind;
                if (operator === 55 || operator === 56 || operator === 60) {
                  if (isTopLevelLogicalExpression(node)) {
                    var postExpressionLabel = createBranchLabel();
                    bindLogicalExpression(node, postExpressionLabel, postExpressionLabel);
                    currentFlow = finishFlowLabel(postExpressionLabel);
                  } else {
                    bindLogicalExpression(node, currentTrueTarget, currentFalseTarget);
                  }
                  completeNode();
                } else {
                  advanceState(2);
                  maybeBind(node.left);
                }
                break;
              }
              case 2: {
                advanceState(3);
                maybeBind(node.operatorToken);
                break;
              }
              case 3: {
                advanceState(4);
                maybeBind(node.right);
                break;
              }
              case 4: {
                var operator = node.operatorToken.kind;
                if (ts2.isAssignmentOperator(operator) && !ts2.isAssignmentTarget(node)) {
                  bindAssignmentTargetFlow(node.left);
                  if (operator === 62 && node.left.kind === 195) {
                    var elementAccess = node.left;
                    if (isNarrowableOperand(elementAccess.expression)) {
                      currentFlow = createFlowMutation(256, currentFlow, node);
                    }
                  }
                }
                completeNode();
                break;
              }
              default:
                return ts2.Debug.fail("Invalid state " + workStacks.state[stackIndex] + " for bindBinaryExpressionFlow");
            }
          }
          function advanceState(state, isInStrictMode, parent2, subtreeFlags) {
            workStacks.state[stackIndex] = state;
            if (isInStrictMode !== void 0) {
              workStacks.inStrictMode[stackIndex] = isInStrictMode;
            }
            if (parent2 !== void 0) {
              workStacks.parent[stackIndex] = parent2;
            }
            if (subtreeFlags !== void 0) {
              workStacks.subtreeFlags[stackIndex] = subtreeFlags;
            }
          }
          function completeNode() {
            if (workStacks.inStrictMode[stackIndex] !== void 0) {
              if (workStacks.subtreeFlags[stackIndex] === -1) {
                skipTransformFlagAggregation = false;
                subtreeTransformFlags |= node.transformFlags & ~getTransformFlagsSubtreeExclusions(node.kind);
              } else if (workStacks.subtreeFlags[stackIndex] !== void 0) {
                subtreeTransformFlags = workStacks.subtreeFlags[stackIndex] | computeTransformFlagsForNode(node, subtreeTransformFlags);
              }
              inStrictMode = workStacks.inStrictMode[stackIndex];
              parent = workStacks.parent[stackIndex];
            }
            stackIndex--;
          }
          function maybeBind(node2) {
            if (node2 && ts2.isBinaryExpression(node2)) {
              stackIndex++;
              workStacks.expr[stackIndex] = node2;
              workStacks.state[stackIndex] = 0;
              workStacks.inStrictMode[stackIndex] = void 0;
              workStacks.parent[stackIndex] = void 0;
              workStacks.subtreeFlags[stackIndex] = void 0;
            } else {
              bind(node2);
            }
          }
        }
        function bindDeleteExpressionFlow(node) {
          bindEachChild(node);
          if (node.expression.kind === 194) {
            bindAssignmentTargetFlow(node.expression);
          }
        }
        function bindConditionalExpressionFlow(node) {
          var trueLabel = createBranchLabel();
          var falseLabel = createBranchLabel();
          var postExpressionLabel = createBranchLabel();
          bindCondition(node.condition, trueLabel, falseLabel);
          currentFlow = finishFlowLabel(trueLabel);
          bind(node.questionToken);
          bind(node.whenTrue);
          addAntecedent(postExpressionLabel, currentFlow);
          currentFlow = finishFlowLabel(falseLabel);
          bind(node.colonToken);
          bind(node.whenFalse);
          addAntecedent(postExpressionLabel, currentFlow);
          currentFlow = finishFlowLabel(postExpressionLabel);
        }
        function bindInitializedVariableFlow(node) {
          var name = !ts2.isOmittedExpression(node) ? node.name : void 0;
          if (ts2.isBindingPattern(name)) {
            for (var _i = 0, _a = name.elements; _i < _a.length; _i++) {
              var child = _a[_i];
              bindInitializedVariableFlow(child);
            }
          } else {
            currentFlow = createFlowMutation(16, currentFlow, node);
          }
        }
        function bindVariableDeclarationFlow(node) {
          bindEachChild(node);
          if (node.initializer || ts2.isForInOrOfStatement(node.parent.parent)) {
            bindInitializedVariableFlow(node);
          }
        }
        function bindJSDocTypeAlias(node) {
          node.tagName.parent = node;
          if (node.kind !== 316 && node.fullName) {
            setParentPointers(node, node.fullName);
          }
        }
        function bindJSDocClassTag(node) {
          bindEachChild(node);
          var host = ts2.getHostSignatureFromJSDoc(node);
          if (host && host.kind !== 161) {
            addDeclarationToSymbol(host.symbol, host, 32);
          }
        }
        function bindOptionalExpression(node, trueTarget, falseTarget) {
          doWithConditionalBranches(bind, node, trueTarget, falseTarget);
          if (!ts2.isOptionalChain(node) || ts2.isOutermostOptionalChain(node)) {
            addAntecedent(trueTarget, createFlowCondition(32, currentFlow, node));
            addAntecedent(falseTarget, createFlowCondition(64, currentFlow, node));
          }
        }
        function bindOptionalChainRest(node) {
          switch (node.kind) {
            case 194:
              bind(node.questionDotToken);
              bind(node.name);
              break;
            case 195:
              bind(node.questionDotToken);
              bind(node.argumentExpression);
              break;
            case 196:
              bind(node.questionDotToken);
              bindEach(node.typeArguments);
              bindEach(node.arguments);
              break;
          }
        }
        function bindOptionalChain(node, trueTarget, falseTarget) {
          var preChainLabel = ts2.isOptionalChainRoot(node) ? createBranchLabel() : void 0;
          bindOptionalExpression(node.expression, preChainLabel || trueTarget, falseTarget);
          if (preChainLabel) {
            currentFlow = finishFlowLabel(preChainLabel);
          }
          doWithConditionalBranches(bindOptionalChainRest, node, trueTarget, falseTarget);
          if (ts2.isOutermostOptionalChain(node)) {
            addAntecedent(trueTarget, createFlowCondition(32, currentFlow, node));
            addAntecedent(falseTarget, createFlowCondition(64, currentFlow, node));
          }
        }
        function bindOptionalChainFlow(node) {
          if (isTopLevelLogicalExpression(node)) {
            var postExpressionLabel = createBranchLabel();
            bindOptionalChain(node, postExpressionLabel, postExpressionLabel);
            currentFlow = finishFlowLabel(postExpressionLabel);
          } else {
            bindOptionalChain(node, currentTrueTarget, currentFalseTarget);
          }
        }
        function bindNonNullExpressionFlow(node) {
          if (ts2.isOptionalChain(node)) {
            bindOptionalChainFlow(node);
          } else {
            bindEachChild(node);
          }
        }
        function bindAccessExpressionFlow(node) {
          if (ts2.isOptionalChain(node)) {
            bindOptionalChainFlow(node);
          } else {
            bindEachChild(node);
          }
        }
        function bindCallExpressionFlow(node) {
          if (ts2.isOptionalChain(node)) {
            bindOptionalChainFlow(node);
          } else {
            var expr = ts2.skipParentheses(node.expression);
            if (expr.kind === 201 || expr.kind === 202) {
              bindEach(node.typeArguments);
              bindEach(node.arguments);
              bind(node.expression);
            } else {
              bindEachChild(node);
            }
          }
          if (node.expression.kind === 194) {
            var propertyAccess = node.expression;
            if (ts2.isIdentifier(propertyAccess.name) && isNarrowableOperand(propertyAccess.expression) && ts2.isPushOrUnshiftIdentifier(propertyAccess.name)) {
              currentFlow = createFlowMutation(256, currentFlow, node);
            }
          }
        }
        function getContainerFlags(node) {
          switch (node.kind) {
            case 214:
            case 245:
            case 248:
            case 193:
            case 173:
            case 304:
            case 274:
              return 1;
            case 246:
              return 1 | 64;
            case 249:
            case 247:
            case 186:
              return 1 | 32;
            case 290:
              return 1 | 4 | 32;
            case 161:
              if (ts2.isObjectLiteralOrClassExpressionMethod(node)) {
                return 1 | 4 | 32 | 8 | 128;
              }
            case 162:
            case 244:
            case 160:
            case 163:
            case 164:
            case 165:
            case 305:
            case 300:
            case 170:
            case 166:
            case 167:
            case 171:
              return 1 | 4 | 32 | 8;
            case 201:
            case 202:
              return 1 | 4 | 32 | 8 | 16;
            case 250:
              return 4;
            case 159:
              return node.initializer ? 4 : 0;
            case 280:
            case 230:
            case 231:
            case 232:
            case 251:
              return 2;
            case 223:
              return ts2.isFunctionLike(node.parent) ? 0 : 2;
          }
          return 0;
        }
        function addToContainerChain(next) {
          if (lastContainer) {
            lastContainer.nextContainer = next;
          }
          lastContainer = next;
        }
        function declareSymbolAndAddToSymbolTable(node, symbolFlags, symbolExcludes) {
          switch (container.kind) {
            case 249:
              return declareModuleMember(node, symbolFlags, symbolExcludes);
            case 290:
              return declareSourceFileMember(node, symbolFlags, symbolExcludes);
            case 214:
            case 245:
              return declareClassMember(node, symbolFlags, symbolExcludes);
            case 248:
              return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
            case 173:
            case 304:
            case 193:
            case 246:
            case 274:
              return declareSymbol(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
            case 170:
            case 171:
            case 165:
            case 166:
            case 305:
            case 167:
            case 161:
            case 160:
            case 162:
            case 163:
            case 164:
            case 244:
            case 201:
            case 202:
            case 300:
            case 322:
            case 315:
            case 247:
            case 186:
              return declareSymbol(container.locals, void 0, node, symbolFlags, symbolExcludes);
          }
        }
        function declareClassMember(node, symbolFlags, symbolExcludes) {
          return ts2.hasModifier(node, 32) ? declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes) : declareSymbol(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
        }
        function declareSourceFileMember(node, symbolFlags, symbolExcludes) {
          return ts2.isExternalModule(file) ? declareModuleMember(node, symbolFlags, symbolExcludes) : declareSymbol(file.locals, void 0, node, symbolFlags, symbolExcludes);
        }
        function hasExportDeclarations(node) {
          var body = ts2.isSourceFile(node) ? node : ts2.tryCast(node.body, ts2.isModuleBlock);
          return !!body && body.statements.some(function(s) {
            return ts2.isExportDeclaration(s) || ts2.isExportAssignment(s);
          });
        }
        function setExportContextFlag(node) {
          if (node.flags & 8388608 && !hasExportDeclarations(node)) {
            node.flags |= 64;
          } else {
            node.flags &= ~64;
          }
        }
        function bindModuleDeclaration(node) {
          setExportContextFlag(node);
          if (ts2.isAmbientModule(node)) {
            if (ts2.hasModifier(node, 1)) {
              errorOnFirstToken(node, ts2.Diagnostics.export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible);
            }
            if (ts2.isModuleAugmentationExternal(node)) {
              declareModuleSymbol(node);
            } else {
              var pattern = void 0;
              if (node.name.kind === 10) {
                var text = node.name.text;
                if (ts2.hasZeroOrOneAsteriskCharacter(text)) {
                  pattern = ts2.tryParsePattern(text);
                } else {
                  errorOnFirstToken(node.name, ts2.Diagnostics.Pattern_0_can_have_at_most_one_Asterisk_character, text);
                }
              }
              var symbol = declareSymbolAndAddToSymbolTable(node, 512, 110735);
              file.patternAmbientModules = ts2.append(file.patternAmbientModules, pattern && { pattern, symbol });
            }
          } else {
            var state = declareModuleSymbol(node);
            if (state !== 0) {
              var symbol = node.symbol;
              symbol.constEnumOnlyModule = !(symbol.flags & (16 | 32 | 256)) && state === 2 && symbol.constEnumOnlyModule !== false;
            }
          }
        }
        function declareModuleSymbol(node) {
          var state = getModuleInstanceState(node);
          var instantiated = state !== 0;
          declareSymbolAndAddToSymbolTable(node, instantiated ? 512 : 1024, instantiated ? 110735 : 0);
          return state;
        }
        function bindFunctionOrConstructorType(node) {
          var symbol = createSymbol(131072, getDeclarationName(node));
          addDeclarationToSymbol(symbol, node, 131072);
          var typeLiteralSymbol = createSymbol(2048, "__type");
          addDeclarationToSymbol(typeLiteralSymbol, node, 2048);
          typeLiteralSymbol.members = ts2.createSymbolTable();
          typeLiteralSymbol.members.set(symbol.escapedName, symbol);
        }
        function bindObjectLiteralExpression(node) {
          var ElementKind;
          (function(ElementKind2) {
            ElementKind2[ElementKind2["Property"] = 1] = "Property";
            ElementKind2[ElementKind2["Accessor"] = 2] = "Accessor";
          })(ElementKind || (ElementKind = {}));
          if (inStrictMode && !ts2.isAssignmentTarget(node)) {
            var seen = ts2.createUnderscoreEscapedMap();
            for (var _i = 0, _a = node.properties; _i < _a.length; _i++) {
              var prop = _a[_i];
              if (prop.kind === 283 || prop.name.kind !== 75) {
                continue;
              }
              var identifier = prop.name;
              var currentKind = prop.kind === 281 || prop.kind === 282 || prop.kind === 161 ? 1 : 2;
              var existingKind = seen.get(identifier.escapedText);
              if (!existingKind) {
                seen.set(identifier.escapedText, currentKind);
                continue;
              }
              if (currentKind === 1 && existingKind === 1) {
                var span = ts2.getErrorSpanForNode(file, identifier);
                file.bindDiagnostics.push(ts2.createFileDiagnostic(file, span.start, span.length, ts2.Diagnostics.An_object_literal_cannot_have_multiple_properties_with_the_same_name_in_strict_mode));
              }
            }
          }
          return bindAnonymousDeclaration(node, 4096, "__object");
        }
        function bindJsxAttributes(node) {
          return bindAnonymousDeclaration(node, 4096, "__jsxAttributes");
        }
        function bindJsxAttribute(node, symbolFlags, symbolExcludes) {
          return declareSymbolAndAddToSymbolTable(node, symbolFlags, symbolExcludes);
        }
        function bindAnonymousDeclaration(node, symbolFlags, name) {
          var symbol = createSymbol(symbolFlags, name);
          if (symbolFlags & (8 | 106500)) {
            symbol.parent = container.symbol;
          }
          addDeclarationToSymbol(symbol, node, symbolFlags);
          return symbol;
        }
        function bindBlockScopedDeclaration(node, symbolFlags, symbolExcludes) {
          switch (blockScopeContainer.kind) {
            case 249:
              declareModuleMember(node, symbolFlags, symbolExcludes);
              break;
            case 290:
              if (ts2.isExternalOrCommonJsModule(container)) {
                declareModuleMember(node, symbolFlags, symbolExcludes);
                break;
              }
            default:
              if (!blockScopeContainer.locals) {
                blockScopeContainer.locals = ts2.createSymbolTable();
                addToContainerChain(blockScopeContainer);
              }
              declareSymbol(blockScopeContainer.locals, void 0, node, symbolFlags, symbolExcludes);
          }
        }
        function delayedBindJSDocTypedefTag() {
          if (!delayedTypeAliases) {
            return;
          }
          var saveContainer = container;
          var saveLastContainer = lastContainer;
          var saveBlockScopeContainer = blockScopeContainer;
          var saveParent = parent;
          var saveCurrentFlow = currentFlow;
          for (var _i = 0, delayedTypeAliases_1 = delayedTypeAliases; _i < delayedTypeAliases_1.length; _i++) {
            var typeAlias = delayedTypeAliases_1[_i];
            var host = ts2.getJSDocHost(typeAlias);
            container = ts2.findAncestor(host.parent, function(n) {
              return !!(getContainerFlags(n) & 1);
            }) || file;
            blockScopeContainer = ts2.getEnclosingBlockScopeContainer(host) || file;
            currentFlow = initFlowNode({ flags: 2 });
            parent = typeAlias;
            bind(typeAlias.typeExpression);
            var declName = ts2.getNameOfDeclaration(typeAlias);
            if ((ts2.isJSDocEnumTag(typeAlias) || !typeAlias.fullName) && declName && ts2.isPropertyAccessEntityNameExpression(declName.parent)) {
              var isTopLevel = isTopLevelNamespaceAssignment(declName.parent);
              if (isTopLevel) {
                bindPotentiallyMissingNamespaces(file.symbol, declName.parent, isTopLevel, !!ts2.findAncestor(declName, function(d) {
                  return ts2.isPropertyAccessExpression(d) && d.name.escapedText === "prototype";
                }), false);
                var oldContainer = container;
                switch (ts2.getAssignmentDeclarationPropertyAccessKind(declName.parent)) {
                  case 1:
                  case 2:
                    if (!ts2.isExternalOrCommonJsModule(file)) {
                      container = void 0;
                    } else {
                      container = file;
                    }
                    break;
                  case 4:
                    container = declName.parent.expression;
                    break;
                  case 3:
                    container = declName.parent.expression.name;
                    break;
                  case 5:
                    container = isExportsOrModuleExportsOrAlias(file, declName.parent.expression) ? file : ts2.isPropertyAccessExpression(declName.parent.expression) ? declName.parent.expression.name : declName.parent.expression;
                    break;
                  case 0:
                    return ts2.Debug.fail("Shouldn't have detected typedef or enum on non-assignment declaration");
                }
                if (container) {
                  declareModuleMember(typeAlias, 524288, 788968);
                }
                container = oldContainer;
              }
            } else if (ts2.isJSDocEnumTag(typeAlias) || !typeAlias.fullName || typeAlias.fullName.kind === 75) {
              parent = typeAlias.parent;
              bindBlockScopedDeclaration(typeAlias, 524288, 788968);
            } else {
              bind(typeAlias.fullName);
            }
          }
          container = saveContainer;
          lastContainer = saveLastContainer;
          blockScopeContainer = saveBlockScopeContainer;
          parent = saveParent;
          currentFlow = saveCurrentFlow;
        }
        function checkStrictModeIdentifier(node) {
          if (inStrictMode && node.originalKeywordKind >= 113 && node.originalKeywordKind <= 121 && !ts2.isIdentifierName(node) && !(node.flags & 8388608) && !(node.flags & 4194304)) {
            if (!file.parseDiagnostics.length) {
              file.bindDiagnostics.push(createDiagnosticForNode(node, getStrictModeIdentifierMessage(node), ts2.declarationNameToString(node)));
            }
          }
        }
        function getStrictModeIdentifierMessage(node) {
          if (ts2.getContainingClass(node)) {
            return ts2.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode;
          }
          if (file.externalModuleIndicator) {
            return ts2.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode;
          }
          return ts2.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode;
        }
        function checkPrivateIdentifier(node) {
          if (node.escapedText === "#constructor") {
            if (!file.parseDiagnostics.length) {
              file.bindDiagnostics.push(createDiagnosticForNode(node, ts2.Diagnostics.constructor_is_a_reserved_word, ts2.declarationNameToString(node)));
            }
          }
        }
        function checkStrictModeBinaryExpression(node) {
          if (inStrictMode && ts2.isLeftHandSideExpression(node.left) && ts2.isAssignmentOperator(node.operatorToken.kind)) {
            checkStrictModeEvalOrArguments(node, node.left);
          }
        }
        function checkStrictModeCatchClause(node) {
          if (inStrictMode && node.variableDeclaration) {
            checkStrictModeEvalOrArguments(node, node.variableDeclaration.name);
          }
        }
        function checkStrictModeDeleteExpression(node) {
          if (inStrictMode && node.expression.kind === 75) {
            var span = ts2.getErrorSpanForNode(file, node.expression);
            file.bindDiagnostics.push(ts2.createFileDiagnostic(file, span.start, span.length, ts2.Diagnostics.delete_cannot_be_called_on_an_identifier_in_strict_mode));
          }
        }
        function isEvalOrArgumentsIdentifier(node) {
          return ts2.isIdentifier(node) && (node.escapedText === "eval" || node.escapedText === "arguments");
        }
        function checkStrictModeEvalOrArguments(contextNode, name) {
          if (name && name.kind === 75) {
            var identifier = name;
            if (isEvalOrArgumentsIdentifier(identifier)) {
              var span = ts2.getErrorSpanForNode(file, name);
              file.bindDiagnostics.push(ts2.createFileDiagnostic(file, span.start, span.length, getStrictModeEvalOrArgumentsMessage(contextNode), ts2.idText(identifier)));
            }
          }
        }
        function getStrictModeEvalOrArgumentsMessage(node) {
          if (ts2.getContainingClass(node)) {
            return ts2.Diagnostics.Invalid_use_of_0_Class_definitions_are_automatically_in_strict_mode;
          }
          if (file.externalModuleIndicator) {
            return ts2.Diagnostics.Invalid_use_of_0_Modules_are_automatically_in_strict_mode;
          }
          return ts2.Diagnostics.Invalid_use_of_0_in_strict_mode;
        }
        function checkStrictModeFunctionName(node) {
          if (inStrictMode) {
            checkStrictModeEvalOrArguments(node, node.name);
          }
        }
        function getStrictModeBlockScopeFunctionDeclarationMessage(node) {
          if (ts2.getContainingClass(node)) {
            return ts2.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_definitions_are_automatically_in_strict_mode;
          }
          if (file.externalModuleIndicator) {
            return ts2.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_are_automatically_in_strict_mode;
          }
          return ts2.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5;
        }
        function checkStrictModeFunctionDeclaration(node) {
          if (languageVersion < 2) {
            if (blockScopeContainer.kind !== 290 && blockScopeContainer.kind !== 249 && !ts2.isFunctionLike(blockScopeContainer)) {
              var errorSpan = ts2.getErrorSpanForNode(file, node);
              file.bindDiagnostics.push(ts2.createFileDiagnostic(file, errorSpan.start, errorSpan.length, getStrictModeBlockScopeFunctionDeclarationMessage(node)));
            }
          }
        }
        function checkStrictModeNumericLiteral(node) {
          if (inStrictMode && node.numericLiteralFlags & 32) {
            file.bindDiagnostics.push(createDiagnosticForNode(node, ts2.Diagnostics.Octal_literals_are_not_allowed_in_strict_mode));
          }
        }
        function checkStrictModePostfixUnaryExpression(node) {
          if (inStrictMode) {
            checkStrictModeEvalOrArguments(node, node.operand);
          }
        }
        function checkStrictModePrefixUnaryExpression(node) {
          if (inStrictMode) {
            if (node.operator === 45 || node.operator === 46) {
              checkStrictModeEvalOrArguments(node, node.operand);
            }
          }
        }
        function checkStrictModeWithStatement(node) {
          if (inStrictMode) {
            errorOnFirstToken(node, ts2.Diagnostics.with_statements_are_not_allowed_in_strict_mode);
          }
        }
        function checkStrictModeLabeledStatement(node) {
          if (inStrictMode && options.target >= 2) {
            if (ts2.isDeclarationStatement(node.statement) || ts2.isVariableStatement(node.statement)) {
              errorOnFirstToken(node.label, ts2.Diagnostics.A_label_is_not_allowed_here);
            }
          }
        }
        function errorOnFirstToken(node, message, arg0, arg1, arg2) {
          var span = ts2.getSpanOfTokenAtPosition(file, node.pos);
          file.bindDiagnostics.push(ts2.createFileDiagnostic(file, span.start, span.length, message, arg0, arg1, arg2));
        }
        function errorOrSuggestionOnNode(isError, node, message) {
          errorOrSuggestionOnRange(isError, node, node, message);
        }
        function errorOrSuggestionOnRange(isError, startNode, endNode, message) {
          addErrorOrSuggestionDiagnostic(isError, { pos: ts2.getTokenPosOfNode(startNode, file), end: endNode.end }, message);
        }
        function addErrorOrSuggestionDiagnostic(isError, range, message) {
          var diag = ts2.createFileDiagnostic(file, range.pos, range.end - range.pos, message);
          if (isError) {
            file.bindDiagnostics.push(diag);
          } else {
            file.bindSuggestionDiagnostics = ts2.append(file.bindSuggestionDiagnostics, __assign(__assign({}, diag), { category: ts2.DiagnosticCategory.Suggestion }));
          }
        }
        function bind(node) {
          if (!node) {
            return;
          }
          node.parent = parent;
          var saveInStrictMode = inStrictMode;
          bindWorker(node);
          if (node.kind > 152) {
            var saveParent = parent;
            parent = node;
            var containerFlags = getContainerFlags(node);
            if (containerFlags === 0) {
              bindChildren(node);
            } else {
              bindContainer(node, containerFlags);
            }
            parent = saveParent;
          } else if (!skipTransformFlagAggregation && (node.transformFlags & 536870912) === 0) {
            subtreeTransformFlags |= computeTransformFlagsForNode(node, 0);
            var saveParent = parent;
            if (node.kind === 1)
              parent = node;
            bindJSDoc(node);
            parent = saveParent;
          }
          inStrictMode = saveInStrictMode;
        }
        function bindJSDoc(node) {
          if (ts2.hasJSDocNodes(node)) {
            if (ts2.isInJSFile(node)) {
              for (var _i = 0, _a = node.jsDoc; _i < _a.length; _i++) {
                var j = _a[_i];
                bind(j);
              }
            } else {
              for (var _b = 0, _c = node.jsDoc; _b < _c.length; _b++) {
                var j = _c[_b];
                setParentPointers(node, j);
              }
            }
          }
        }
        function updateStrictModeStatementList(statements) {
          if (!inStrictMode) {
            for (var _i = 0, statements_2 = statements; _i < statements_2.length; _i++) {
              var statement = statements_2[_i];
              if (!ts2.isPrologueDirective(statement)) {
                return;
              }
              if (isUseStrictPrologueDirective(statement)) {
                inStrictMode = true;
                return;
              }
            }
          }
        }
        function isUseStrictPrologueDirective(node) {
          var nodeText = ts2.getSourceTextOfNodeFromSourceFile(file, node.expression);
          return nodeText === '"use strict"' || nodeText === "'use strict'";
        }
        function bindWorker(node) {
          switch (node.kind) {
            case 75:
              if (node.isInJSDocNamespace) {
                var parentNode = node.parent;
                while (parentNode && !ts2.isJSDocTypeAlias(parentNode)) {
                  parentNode = parentNode.parent;
                }
                bindBlockScopedDeclaration(parentNode, 524288, 788968);
                break;
              }
            case 104:
              if (currentFlow && (ts2.isExpression(node) || parent.kind === 282)) {
                node.flowNode = currentFlow;
              }
              return checkStrictModeIdentifier(node);
            case 76:
              return checkPrivateIdentifier(node);
            case 194:
            case 195:
              var expr = node;
              if (currentFlow && isNarrowableReference(expr)) {
                expr.flowNode = currentFlow;
              }
              if (ts2.isSpecialPropertyDeclaration(expr)) {
                bindSpecialPropertyDeclaration(expr);
              }
              if (ts2.isInJSFile(expr) && file.commonJsModuleIndicator && ts2.isModuleExportsAccessExpression(expr) && !lookupSymbolForNameWorker(blockScopeContainer, "module")) {
                declareSymbol(file.locals, void 0, expr.expression, 1 | 134217728, 111550);
              }
              break;
            case 209:
              var specialKind = ts2.getAssignmentDeclarationKind(node);
              switch (specialKind) {
                case 1:
                  bindExportsPropertyAssignment(node);
                  break;
                case 2:
                  bindModuleExportsAssignment(node);
                  break;
                case 3:
                  bindPrototypePropertyAssignment(node.left, node);
                  break;
                case 6:
                  bindPrototypeAssignment(node);
                  break;
                case 4:
                  bindThisPropertyAssignment(node);
                  break;
                case 5:
                  bindSpecialPropertyAssignment(node);
                  break;
                case 0:
                  break;
                default:
                  ts2.Debug.fail("Unknown binary expression special property assignment kind");
              }
              return checkStrictModeBinaryExpression(node);
            case 280:
              return checkStrictModeCatchClause(node);
            case 203:
              return checkStrictModeDeleteExpression(node);
            case 8:
              return checkStrictModeNumericLiteral(node);
            case 208:
              return checkStrictModePostfixUnaryExpression(node);
            case 207:
              return checkStrictModePrefixUnaryExpression(node);
            case 236:
              return checkStrictModeWithStatement(node);
            case 238:
              return checkStrictModeLabeledStatement(node);
            case 183:
              seenThisKeyword = true;
              return;
            case 168:
              break;
            case 155:
              return bindTypeParameter(node);
            case 156:
              return bindParameter(node);
            case 242:
              return bindVariableDeclarationOrBindingElement(node);
            case 191:
              node.flowNode = currentFlow;
              return bindVariableDeclarationOrBindingElement(node);
            case 159:
            case 158:
              return bindPropertyWorker(node);
            case 281:
            case 282:
              return bindPropertyOrMethodOrAccessor(node, 4, 0);
            case 284:
              return bindPropertyOrMethodOrAccessor(node, 8, 900095);
            case 165:
            case 166:
            case 167:
              return declareSymbolAndAddToSymbolTable(node, 131072, 0);
            case 161:
            case 160:
              return bindPropertyOrMethodOrAccessor(node, 8192 | (node.questionToken ? 16777216 : 0), ts2.isObjectLiteralMethod(node) ? 0 : 103359);
            case 244:
              return bindFunctionDeclaration(node);
            case 162:
              return declareSymbolAndAddToSymbolTable(node, 16384, 0);
            case 163:
              return bindPropertyOrMethodOrAccessor(node, 32768, 46015);
            case 164:
              return bindPropertyOrMethodOrAccessor(node, 65536, 78783);
            case 170:
            case 300:
            case 305:
            case 171:
              return bindFunctionOrConstructorType(node);
            case 173:
            case 304:
            case 186:
              return bindAnonymousTypeWorker(node);
            case 310:
              return bindJSDocClassTag(node);
            case 193:
              return bindObjectLiteralExpression(node);
            case 201:
            case 202:
              return bindFunctionExpression(node);
            case 196:
              var assignmentKind = ts2.getAssignmentDeclarationKind(node);
              switch (assignmentKind) {
                case 7:
                  return bindObjectDefinePropertyAssignment(node);
                case 8:
                  return bindObjectDefinePropertyExport(node);
                case 9:
                  return bindObjectDefinePrototypeProperty(node);
                case 0:
                  break;
                default:
                  return ts2.Debug.fail("Unknown call expression assignment declaration kind");
              }
              if (ts2.isInJSFile(node)) {
                bindCallExpression(node);
              }
              break;
            case 214:
            case 245:
              inStrictMode = true;
              return bindClassLikeDeclaration(node);
            case 246:
              return bindBlockScopedDeclaration(node, 64, 788872);
            case 247:
              return bindBlockScopedDeclaration(node, 524288, 788968);
            case 248:
              return bindEnumDeclaration(node);
            case 249:
              return bindModuleDeclaration(node);
            case 274:
              return bindJsxAttributes(node);
            case 273:
              return bindJsxAttribute(node, 4, 0);
            case 253:
            case 256:
            case 258:
            case 263:
              return declareSymbolAndAddToSymbolTable(node, 2097152, 2097152);
            case 252:
              return bindNamespaceExportDeclaration(node);
            case 255:
              return bindImportClause(node);
            case 260:
              return bindExportDeclaration(node);
            case 259:
              return bindExportAssignment(node);
            case 290:
              updateStrictModeStatementList(node.statements);
              return bindSourceFileIfExternalModule();
            case 223:
              if (!ts2.isFunctionLike(node.parent)) {
                return;
              }
            case 250:
              return updateStrictModeStatementList(node.statements);
            case 317:
              if (node.parent.kind === 305) {
                return bindParameter(node);
              }
              if (node.parent.kind !== 304) {
                break;
              }
            case 323:
              var propTag = node;
              var flags = propTag.isBracketed || propTag.typeExpression && propTag.typeExpression.type.kind === 299 ? 4 | 16777216 : 4;
              return declareSymbolAndAddToSymbolTable(propTag, flags, 0);
            case 322:
            case 315:
            case 316:
              return (delayedTypeAliases || (delayedTypeAliases = [])).push(node);
          }
        }
        function bindPropertyWorker(node) {
          return bindPropertyOrMethodOrAccessor(node, 4 | (node.questionToken ? 16777216 : 0), 0);
        }
        function bindAnonymousTypeWorker(node) {
          return bindAnonymousDeclaration(node, 2048, "__type");
        }
        function bindSourceFileIfExternalModule() {
          setExportContextFlag(file);
          if (ts2.isExternalModule(file)) {
            bindSourceFileAsExternalModule();
          } else if (ts2.isJsonSourceFile(file)) {
            bindSourceFileAsExternalModule();
            var originalSymbol = file.symbol;
            declareSymbol(file.symbol.exports, file.symbol, file, 4, 67108863);
            file.symbol = originalSymbol;
          }
        }
        function bindSourceFileAsExternalModule() {
          bindAnonymousDeclaration(file, 512, '"' + ts2.removeFileExtension(file.fileName) + '"');
        }
        function bindExportAssignment(node) {
          if (!container.symbol || !container.symbol.exports) {
            bindAnonymousDeclaration(node, 2097152, getDeclarationName(node));
          } else {
            var flags = ts2.exportAssignmentIsAlias(node) ? 2097152 : 4;
            var symbol = declareSymbol(container.symbol.exports, container.symbol, node, flags, 67108863);
            if (node.isExportEquals) {
              ts2.setValueDeclaration(symbol, node);
            }
          }
        }
        function bindNamespaceExportDeclaration(node) {
          if (node.modifiers && node.modifiers.length) {
            file.bindDiagnostics.push(createDiagnosticForNode(node, ts2.Diagnostics.Modifiers_cannot_appear_here));
          }
          var diag = !ts2.isSourceFile(node.parent) ? ts2.Diagnostics.Global_module_exports_may_only_appear_at_top_level : !ts2.isExternalModule(node.parent) ? ts2.Diagnostics.Global_module_exports_may_only_appear_in_module_files : !node.parent.isDeclarationFile ? ts2.Diagnostics.Global_module_exports_may_only_appear_in_declaration_files : void 0;
          if (diag) {
            file.bindDiagnostics.push(createDiagnosticForNode(node, diag));
          } else {
            file.symbol.globalExports = file.symbol.globalExports || ts2.createSymbolTable();
            declareSymbol(file.symbol.globalExports, file.symbol, node, 2097152, 2097152);
          }
        }
        function bindExportDeclaration(node) {
          if (!container.symbol || !container.symbol.exports) {
            bindAnonymousDeclaration(node, 8388608, getDeclarationName(node));
          } else if (!node.exportClause) {
            declareSymbol(container.symbol.exports, container.symbol, node, 8388608, 0);
          } else if (ts2.isNamespaceExport(node.exportClause)) {
            node.exportClause.parent = node;
            declareSymbol(container.symbol.exports, container.symbol, node.exportClause, 2097152, 2097152);
          }
        }
        function bindImportClause(node) {
          if (node.name) {
            declareSymbolAndAddToSymbolTable(node, 2097152, 2097152);
          }
        }
        function setCommonJsModuleIndicator(node) {
          if (file.externalModuleIndicator) {
            return false;
          }
          if (!file.commonJsModuleIndicator) {
            file.commonJsModuleIndicator = node;
            bindSourceFileAsExternalModule();
          }
          return true;
        }
        function bindObjectDefinePropertyExport(node) {
          if (!setCommonJsModuleIndicator(node)) {
            return;
          }
          var symbol = forEachIdentifierInEntityName(node.arguments[0], void 0, function(id, symbol2) {
            if (symbol2) {
              addDeclarationToSymbol(symbol2, id, 1536 | 67108864);
            }
            return symbol2;
          });
          if (symbol) {
            var flags = 4 | 1048576;
            declareSymbol(symbol.exports, symbol, node, flags, 0);
          }
        }
        function bindExportsPropertyAssignment(node) {
          if (!setCommonJsModuleIndicator(node)) {
            return;
          }
          var symbol = forEachIdentifierInEntityName(node.left.expression, void 0, function(id, symbol2) {
            if (symbol2) {
              addDeclarationToSymbol(symbol2, id, 1536 | 67108864);
            }
            return symbol2;
          });
          if (symbol) {
            var flags = ts2.isClassExpression(node.right) ? 4 | 1048576 | 32 : 4 | 1048576;
            declareSymbol(symbol.exports, symbol, node.left, flags, 0);
          }
        }
        function bindModuleExportsAssignment(node) {
          if (!setCommonJsModuleIndicator(node)) {
            return;
          }
          var assignedExpression = ts2.getRightMostAssignedExpression(node.right);
          if (ts2.isEmptyObjectLiteral(assignedExpression) || container === file && isExportsOrModuleExportsOrAlias(file, assignedExpression)) {
            return;
          }
          var flags = ts2.exportAssignmentIsAlias(node) ? 2097152 : 4 | 1048576 | 512;
          var symbol = declareSymbol(file.symbol.exports, file.symbol, node, flags | 67108864, 0);
          ts2.setValueDeclaration(symbol, node);
        }
        function bindThisPropertyAssignment(node) {
          ts2.Debug.assert(ts2.isInJSFile(node));
          var hasPrivateIdentifier = ts2.isBinaryExpression(node) && ts2.isPropertyAccessExpression(node.left) && ts2.isPrivateIdentifier(node.left.name) || ts2.isPropertyAccessExpression(node) && ts2.isPrivateIdentifier(node.name);
          if (hasPrivateIdentifier) {
            return;
          }
          var thisContainer = ts2.getThisContainer(node, false);
          switch (thisContainer.kind) {
            case 244:
            case 201:
              var constructorSymbol = thisContainer.symbol;
              if (ts2.isBinaryExpression(thisContainer.parent) && thisContainer.parent.operatorToken.kind === 62) {
                var l = thisContainer.parent.left;
                if (ts2.isBindableStaticAccessExpression(l) && ts2.isPrototypeAccess(l.expression)) {
                  constructorSymbol = lookupSymbolForPropertyAccess(l.expression.expression, thisParentContainer);
                }
              }
              if (constructorSymbol && constructorSymbol.valueDeclaration) {
                constructorSymbol.members = constructorSymbol.members || ts2.createSymbolTable();
                if (ts2.hasDynamicName(node)) {
                  bindDynamicallyNamedThisPropertyAssignment(node, constructorSymbol);
                } else {
                  declareSymbol(constructorSymbol.members, constructorSymbol, node, 4 | 67108864, 0 & ~4);
                }
                addDeclarationToSymbol(constructorSymbol, constructorSymbol.valueDeclaration, 32);
              }
              break;
            case 162:
            case 159:
            case 161:
            case 163:
            case 164:
              var containingClass = thisContainer.parent;
              var symbolTable = ts2.hasModifier(thisContainer, 32) ? containingClass.symbol.exports : containingClass.symbol.members;
              if (ts2.hasDynamicName(node)) {
                bindDynamicallyNamedThisPropertyAssignment(node, containingClass.symbol);
              } else {
                declareSymbol(symbolTable, containingClass.symbol, node, 4 | 67108864, 0, true);
              }
              break;
            case 290:
              if (ts2.hasDynamicName(node)) {
                break;
              } else if (thisContainer.commonJsModuleIndicator) {
                declareSymbol(thisContainer.symbol.exports, thisContainer.symbol, node, 4 | 1048576, 0);
              } else {
                declareSymbolAndAddToSymbolTable(node, 1, 111550);
              }
              break;
            default:
              ts2.Debug.failBadSyntaxKind(thisContainer);
          }
        }
        function bindDynamicallyNamedThisPropertyAssignment(node, symbol) {
          bindAnonymousDeclaration(node, 4, "__computed");
          addLateBoundAssignmentDeclarationToSymbol(node, symbol);
        }
        function addLateBoundAssignmentDeclarationToSymbol(node, symbol) {
          if (symbol) {
            var members = symbol.assignmentDeclarationMembers || (symbol.assignmentDeclarationMembers = ts2.createMap());
            members.set("" + ts2.getNodeId(node), node);
          }
        }
        function bindSpecialPropertyDeclaration(node) {
          if (node.expression.kind === 104) {
            bindThisPropertyAssignment(node);
          } else if (ts2.isBindableStaticAccessExpression(node) && node.parent.parent.kind === 290) {
            if (ts2.isPrototypeAccess(node.expression)) {
              bindPrototypePropertyAssignment(node, node.parent);
            } else {
              bindStaticPropertyAssignment(node);
            }
          }
        }
        function bindPrototypeAssignment(node) {
          node.left.parent = node;
          node.right.parent = node;
          bindPropertyAssignment(node.left.expression, node.left, false, true);
        }
        function bindObjectDefinePrototypeProperty(node) {
          var namespaceSymbol = lookupSymbolForPropertyAccess(node.arguments[0].expression);
          if (namespaceSymbol && namespaceSymbol.valueDeclaration) {
            addDeclarationToSymbol(namespaceSymbol, namespaceSymbol.valueDeclaration, 32);
          }
          bindPotentiallyNewExpandoMemberToNamespace(node, namespaceSymbol, true);
        }
        function bindPrototypePropertyAssignment(lhs, parent2) {
          var classPrototype = lhs.expression;
          var constructorFunction = classPrototype.expression;
          lhs.parent = parent2;
          constructorFunction.parent = classPrototype;
          classPrototype.parent = lhs;
          bindPropertyAssignment(constructorFunction, lhs, true, true);
        }
        function bindObjectDefinePropertyAssignment(node) {
          var namespaceSymbol = lookupSymbolForPropertyAccess(node.arguments[0]);
          var isToplevel = node.parent.parent.kind === 290;
          namespaceSymbol = bindPotentiallyMissingNamespaces(namespaceSymbol, node.arguments[0], isToplevel, false, false);
          bindPotentiallyNewExpandoMemberToNamespace(node, namespaceSymbol, false);
        }
        function bindSpecialPropertyAssignment(node) {
          var parentSymbol = lookupSymbolForPropertyAccess(node.left.expression);
          if (!ts2.isInJSFile(node) && !ts2.isFunctionSymbol(parentSymbol)) {
            return;
          }
          node.left.parent = node;
          node.right.parent = node;
          if (ts2.isIdentifier(node.left.expression) && container === file && isExportsOrModuleExportsOrAlias(file, node.left.expression)) {
            bindExportsPropertyAssignment(node);
          } else if (ts2.hasDynamicName(node)) {
            bindAnonymousDeclaration(node, 4 | 67108864, "__computed");
            var sym = bindPotentiallyMissingNamespaces(parentSymbol, node.left.expression, isTopLevelNamespaceAssignment(node.left), false, false);
            addLateBoundAssignmentDeclarationToSymbol(node, sym);
          } else {
            bindStaticPropertyAssignment(ts2.cast(node.left, ts2.isBindableStaticNameExpression));
          }
        }
        function bindStaticPropertyAssignment(node) {
          ts2.Debug.assert(!ts2.isIdentifier(node));
          node.expression.parent = node;
          bindPropertyAssignment(node.expression, node, false, false);
        }
        function bindPotentiallyMissingNamespaces(namespaceSymbol, entityName, isToplevel, isPrototypeProperty, containerIsClass) {
          if (isToplevel && !isPrototypeProperty) {
            var flags_1 = 1536 | 67108864;
            var excludeFlags_1 = 110735 & ~67108864;
            namespaceSymbol = forEachIdentifierInEntityName(entityName, namespaceSymbol, function(id, symbol, parent2) {
              if (symbol) {
                addDeclarationToSymbol(symbol, id, flags_1);
                return symbol;
              } else {
                var table = parent2 ? parent2.exports : file.jsGlobalAugmentations || (file.jsGlobalAugmentations = ts2.createSymbolTable());
                return declareSymbol(table, parent2, id, flags_1, excludeFlags_1);
              }
            });
          }
          if (containerIsClass && namespaceSymbol && namespaceSymbol.valueDeclaration) {
            addDeclarationToSymbol(namespaceSymbol, namespaceSymbol.valueDeclaration, 32);
          }
          return namespaceSymbol;
        }
        function bindPotentiallyNewExpandoMemberToNamespace(declaration, namespaceSymbol, isPrototypeProperty) {
          if (!namespaceSymbol || !isExpandoSymbol(namespaceSymbol)) {
            return;
          }
          var symbolTable = isPrototypeProperty ? namespaceSymbol.members || (namespaceSymbol.members = ts2.createSymbolTable()) : namespaceSymbol.exports || (namespaceSymbol.exports = ts2.createSymbolTable());
          var includes = 0;
          var excludes = 0;
          if (ts2.isFunctionLikeDeclaration(ts2.getAssignedExpandoInitializer(declaration))) {
            includes = 8192;
            excludes = 103359;
          } else if (ts2.isCallExpression(declaration) && ts2.isBindableObjectDefinePropertyCall(declaration)) {
            if (ts2.some(declaration.arguments[2].properties, function(p) {
              var id = ts2.getNameOfDeclaration(p);
              return !!id && ts2.isIdentifier(id) && ts2.idText(id) === "set";
            })) {
              includes |= 65536 | 4;
              excludes |= 78783;
            }
            if (ts2.some(declaration.arguments[2].properties, function(p) {
              var id = ts2.getNameOfDeclaration(p);
              return !!id && ts2.isIdentifier(id) && ts2.idText(id) === "get";
            })) {
              includes |= 32768 | 4;
              excludes |= 46015;
            }
          }
          if (includes === 0) {
            includes = 4;
            excludes = 0;
          }
          declareSymbol(symbolTable, namespaceSymbol, declaration, includes | 67108864, excludes & ~67108864);
        }
        function isTopLevelNamespaceAssignment(propertyAccess) {
          return ts2.isBinaryExpression(propertyAccess.parent) ? getParentOfBinaryExpression(propertyAccess.parent).parent.kind === 290 : propertyAccess.parent.parent.kind === 290;
        }
        function bindPropertyAssignment(name, propertyAccess, isPrototypeProperty, containerIsClass) {
          var namespaceSymbol = lookupSymbolForPropertyAccess(name);
          var isToplevel = isTopLevelNamespaceAssignment(propertyAccess);
          namespaceSymbol = bindPotentiallyMissingNamespaces(namespaceSymbol, propertyAccess.expression, isToplevel, isPrototypeProperty, containerIsClass);
          bindPotentiallyNewExpandoMemberToNamespace(propertyAccess, namespaceSymbol, isPrototypeProperty);
        }
        function isExpandoSymbol(symbol) {
          if (symbol.flags & (16 | 32 | 1024)) {
            return true;
          }
          var node = symbol.valueDeclaration;
          if (node && ts2.isCallExpression(node)) {
            return !!ts2.getAssignedExpandoInitializer(node);
          }
          var init = !node ? void 0 : ts2.isVariableDeclaration(node) ? node.initializer : ts2.isBinaryExpression(node) ? node.right : ts2.isPropertyAccessExpression(node) && ts2.isBinaryExpression(node.parent) ? node.parent.right : void 0;
          init = init && ts2.getRightMostAssignedExpression(init);
          if (init) {
            var isPrototypeAssignment = ts2.isPrototypeAccess(ts2.isVariableDeclaration(node) ? node.name : ts2.isBinaryExpression(node) ? node.left : node);
            return !!ts2.getExpandoInitializer(ts2.isBinaryExpression(init) && (init.operatorToken.kind === 56 || init.operatorToken.kind === 60) ? init.right : init, isPrototypeAssignment);
          }
          return false;
        }
        function getParentOfBinaryExpression(expr) {
          while (ts2.isBinaryExpression(expr.parent)) {
            expr = expr.parent;
          }
          return expr.parent;
        }
        function lookupSymbolForPropertyAccess(node, lookupContainer) {
          if (lookupContainer === void 0) {
            lookupContainer = container;
          }
          if (ts2.isIdentifier(node)) {
            return lookupSymbolForNameWorker(lookupContainer, node.escapedText);
          } else {
            var symbol = lookupSymbolForPropertyAccess(node.expression);
            return symbol && symbol.exports && symbol.exports.get(ts2.getElementOrPropertyAccessName(node));
          }
        }
        function forEachIdentifierInEntityName(e, parent2, action) {
          if (isExportsOrModuleExportsOrAlias(file, e)) {
            return file.symbol;
          } else if (ts2.isIdentifier(e)) {
            return action(e, lookupSymbolForPropertyAccess(e), parent2);
          } else {
            var s = forEachIdentifierInEntityName(e.expression, parent2, action);
            var name = ts2.getNameOrArgument(e);
            if (ts2.isPrivateIdentifier(name)) {
              ts2.Debug.fail("unexpected PrivateIdentifier");
            }
            return action(name, s && s.exports && s.exports.get(ts2.getElementOrPropertyAccessName(e)), s);
          }
        }
        function bindCallExpression(node) {
          if (!file.commonJsModuleIndicator && ts2.isRequireCall(node, false)) {
            setCommonJsModuleIndicator(node);
          }
        }
        function bindClassLikeDeclaration(node) {
          if (node.kind === 245) {
            bindBlockScopedDeclaration(node, 32, 899503);
          } else {
            var bindingName = node.name ? node.name.escapedText : "__class";
            bindAnonymousDeclaration(node, 32, bindingName);
            if (node.name) {
              classifiableNames.set(node.name.escapedText, true);
            }
          }
          var symbol = node.symbol;
          var prototypeSymbol = createSymbol(4 | 4194304, "prototype");
          var symbolExport = symbol.exports.get(prototypeSymbol.escapedName);
          if (symbolExport) {
            if (node.name) {
              node.name.parent = node;
            }
            file.bindDiagnostics.push(createDiagnosticForNode(symbolExport.declarations[0], ts2.Diagnostics.Duplicate_identifier_0, ts2.symbolName(prototypeSymbol)));
          }
          symbol.exports.set(prototypeSymbol.escapedName, prototypeSymbol);
          prototypeSymbol.parent = symbol;
        }
        function bindEnumDeclaration(node) {
          return ts2.isEnumConst(node) ? bindBlockScopedDeclaration(node, 128, 899967) : bindBlockScopedDeclaration(node, 256, 899327);
        }
        function bindVariableDeclarationOrBindingElement(node) {
          if (inStrictMode) {
            checkStrictModeEvalOrArguments(node, node.name);
          }
          if (!ts2.isBindingPattern(node.name)) {
            if (ts2.isBlockOrCatchScoped(node)) {
              bindBlockScopedDeclaration(node, 2, 111551);
            } else if (ts2.isParameterDeclaration(node)) {
              declareSymbolAndAddToSymbolTable(node, 1, 111551);
            } else {
              declareSymbolAndAddToSymbolTable(node, 1, 111550);
            }
          }
        }
        function bindParameter(node) {
          if (node.kind === 317 && container.kind !== 305) {
            return;
          }
          if (inStrictMode && !(node.flags & 8388608)) {
            checkStrictModeEvalOrArguments(node, node.name);
          }
          if (ts2.isBindingPattern(node.name)) {
            bindAnonymousDeclaration(node, 1, "__" + node.parent.parameters.indexOf(node));
          } else {
            declareSymbolAndAddToSymbolTable(node, 1, 111551);
          }
          if (ts2.isParameterPropertyDeclaration(node, node.parent)) {
            var classDeclaration = node.parent.parent;
            declareSymbol(classDeclaration.symbol.members, classDeclaration.symbol, node, 4 | (node.questionToken ? 16777216 : 0), 0);
          }
        }
        function bindFunctionDeclaration(node) {
          if (!file.isDeclarationFile && !(node.flags & 8388608)) {
            if (ts2.isAsyncFunction(node)) {
              emitFlags |= 2048;
            }
          }
          checkStrictModeFunctionName(node);
          if (inStrictMode) {
            checkStrictModeFunctionDeclaration(node);
            bindBlockScopedDeclaration(node, 16, 110991);
          } else {
            declareSymbolAndAddToSymbolTable(node, 16, 110991);
          }
        }
        function bindFunctionExpression(node) {
          if (!file.isDeclarationFile && !(node.flags & 8388608)) {
            if (ts2.isAsyncFunction(node)) {
              emitFlags |= 2048;
            }
          }
          if (currentFlow) {
            node.flowNode = currentFlow;
          }
          checkStrictModeFunctionName(node);
          var bindingName = node.name ? node.name.escapedText : "__function";
          return bindAnonymousDeclaration(node, 16, bindingName);
        }
        function bindPropertyOrMethodOrAccessor(node, symbolFlags, symbolExcludes) {
          if (!file.isDeclarationFile && !(node.flags & 8388608) && ts2.isAsyncFunction(node)) {
            emitFlags |= 2048;
          }
          if (currentFlow && ts2.isObjectLiteralOrClassExpressionMethod(node)) {
            node.flowNode = currentFlow;
          }
          return ts2.hasDynamicName(node) ? bindAnonymousDeclaration(node, symbolFlags, "__computed") : declareSymbolAndAddToSymbolTable(node, symbolFlags, symbolExcludes);
        }
        function getInferTypeContainer(node) {
          var extendsType = ts2.findAncestor(node, function(n) {
            return n.parent && ts2.isConditionalTypeNode(n.parent) && n.parent.extendsType === n;
          });
          return extendsType && extendsType.parent;
        }
        function bindTypeParameter(node) {
          if (ts2.isJSDocTemplateTag(node.parent)) {
            var container_1 = ts2.find(node.parent.parent.tags, ts2.isJSDocTypeAlias) || ts2.getHostSignatureFromJSDoc(node.parent);
            if (container_1) {
              if (!container_1.locals) {
                container_1.locals = ts2.createSymbolTable();
              }
              declareSymbol(container_1.locals, void 0, node, 262144, 526824);
            } else {
              declareSymbolAndAddToSymbolTable(node, 262144, 526824);
            }
          } else if (node.parent.kind === 181) {
            var container_2 = getInferTypeContainer(node.parent);
            if (container_2) {
              if (!container_2.locals) {
                container_2.locals = ts2.createSymbolTable();
              }
              declareSymbol(container_2.locals, void 0, node, 262144, 526824);
            } else {
              bindAnonymousDeclaration(node, 262144, getDeclarationName(node));
            }
          } else {
            declareSymbolAndAddToSymbolTable(node, 262144, 526824);
          }
        }
        function shouldReportErrorOnModuleDeclaration(node) {
          var instanceState = getModuleInstanceState(node);
          return instanceState === 1 || instanceState === 2 && !!options.preserveConstEnums;
        }
        function checkUnreachable(node) {
          if (!(currentFlow.flags & 1)) {
            return false;
          }
          if (currentFlow === unreachableFlow) {
            var reportError = ts2.isStatementButNotDeclaration(node) && node.kind !== 224 || node.kind === 245 || node.kind === 249 && shouldReportErrorOnModuleDeclaration(node);
            if (reportError) {
              currentFlow = reportedUnreachableFlow;
              if (!options.allowUnreachableCode) {
                var isError_1 = ts2.unreachableCodeIsError(options) && !(node.flags & 8388608) && (!ts2.isVariableStatement(node) || !!(ts2.getCombinedNodeFlags(node.declarationList) & 3) || node.declarationList.declarations.some(function(d) {
                  return !!d.initializer;
                }));
                eachUnreachableRange(node, function(start, end) {
                  return errorOrSuggestionOnRange(isError_1, start, end, ts2.Diagnostics.Unreachable_code_detected);
                });
              }
            }
          }
          return true;
        }
      }
      function eachUnreachableRange(node, cb) {
        if (ts2.isStatement(node) && isExecutableStatement(node) && ts2.isBlock(node.parent)) {
          var statements = node.parent.statements;
          var slice_1 = ts2.sliceAfter(statements, node);
          ts2.getRangesWhere(slice_1, isExecutableStatement, function(start, afterEnd) {
            return cb(slice_1[start], slice_1[afterEnd - 1]);
          });
        } else {
          cb(node, node);
        }
      }
      function isExecutableStatement(s) {
        return !ts2.isFunctionDeclaration(s) && !isPurelyTypeDeclaration(s) && !ts2.isEnumDeclaration(s) && !(ts2.isVariableStatement(s) && !(ts2.getCombinedNodeFlags(s) & (1 | 2)) && s.declarationList.declarations.some(function(d) {
          return !d.initializer;
        }));
      }
      function isPurelyTypeDeclaration(s) {
        switch (s.kind) {
          case 246:
          case 247:
            return true;
          case 249:
            return getModuleInstanceState(s) !== 1;
          case 248:
            return ts2.hasModifier(s, 2048);
          default:
            return false;
        }
      }
      function isExportsOrModuleExportsOrAlias(sourceFile, node) {
        var i = 0;
        var q = [node];
        while (q.length && i < 100) {
          i++;
          node = q.shift();
          if (ts2.isExportsIdentifier(node) || ts2.isModuleExportsAccessExpression(node)) {
            return true;
          } else if (ts2.isIdentifier(node)) {
            var symbol = lookupSymbolForNameWorker(sourceFile, node.escapedText);
            if (!!symbol && !!symbol.valueDeclaration && ts2.isVariableDeclaration(symbol.valueDeclaration) && !!symbol.valueDeclaration.initializer) {
              var init = symbol.valueDeclaration.initializer;
              q.push(init);
              if (ts2.isAssignmentExpression(init, true)) {
                q.push(init.left);
                q.push(init.right);
              }
            }
          }
        }
        return false;
      }
      ts2.isExportsOrModuleExportsOrAlias = isExportsOrModuleExportsOrAlias;
      function lookupSymbolForNameWorker(container, name) {
        var local = container.locals && container.locals.get(name);
        if (local) {
          return local.exportSymbol || local;
        }
        if (ts2.isSourceFile(container) && container.jsGlobalAugmentations && container.jsGlobalAugmentations.has(name)) {
          return container.jsGlobalAugmentations.get(name);
        }
        return container.symbol && container.symbol.exports && container.symbol.exports.get(name);
      }
      function computeTransformFlagsForNode(node, subtreeFlags) {
        var kind = node.kind;
        switch (kind) {
          case 196:
            return computeCallExpression(node, subtreeFlags);
          case 197:
            return computeNewExpression(node, subtreeFlags);
          case 249:
            return computeModuleDeclaration(node, subtreeFlags);
          case 200:
            return computeParenthesizedExpression(node, subtreeFlags);
          case 209:
            return computeBinaryExpression(node, subtreeFlags);
          case 226:
            return computeExpressionStatement(node, subtreeFlags);
          case 156:
            return computeParameter(node, subtreeFlags);
          case 202:
            return computeArrowFunction(node, subtreeFlags);
          case 201:
            return computeFunctionExpression(node, subtreeFlags);
          case 244:
            return computeFunctionDeclaration(node, subtreeFlags);
          case 242:
            return computeVariableDeclaration(node, subtreeFlags);
          case 243:
            return computeVariableDeclarationList(node, subtreeFlags);
          case 225:
            return computeVariableStatement(node, subtreeFlags);
          case 238:
            return computeLabeledStatement(node, subtreeFlags);
          case 245:
            return computeClassDeclaration(node, subtreeFlags);
          case 214:
            return computeClassExpression(node, subtreeFlags);
          case 279:
            return computeHeritageClause(node, subtreeFlags);
          case 280:
            return computeCatchClause(node, subtreeFlags);
          case 216:
            return computeExpressionWithTypeArguments(node, subtreeFlags);
          case 162:
            return computeConstructor(node, subtreeFlags);
          case 159:
            return computePropertyDeclaration(node, subtreeFlags);
          case 161:
            return computeMethod(node, subtreeFlags);
          case 163:
          case 164:
            return computeAccessor(node, subtreeFlags);
          case 253:
            return computeImportEquals(node, subtreeFlags);
          case 194:
            return computePropertyAccess(node, subtreeFlags);
          case 195:
            return computeElementAccess(node, subtreeFlags);
          case 267:
          case 268:
            return computeJsxOpeningLikeElement(node, subtreeFlags);
          default:
            return computeOther(node, kind, subtreeFlags);
        }
      }
      ts2.computeTransformFlagsForNode = computeTransformFlagsForNode;
      function computeCallExpression(node, subtreeFlags) {
        var transformFlags = subtreeFlags;
        var callee = ts2.skipOuterExpressions(node.expression);
        var expression = node.expression;
        if (node.flags & 32) {
          transformFlags |= 8;
        }
        if (node.typeArguments) {
          transformFlags |= 1;
        }
        if (subtreeFlags & 8192 || ts2.isSuperOrSuperProperty(callee)) {
          transformFlags |= 256;
          if (ts2.isSuperProperty(callee)) {
            transformFlags |= 4096;
          }
        }
        if (expression.kind === 96) {
          transformFlags |= 2097152;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~536879104;
      }
      function computeNewExpression(node, subtreeFlags) {
        var transformFlags = subtreeFlags;
        if (node.typeArguments) {
          transformFlags |= 1;
        }
        if (subtreeFlags & 8192) {
          transformFlags |= 256;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~536879104;
      }
      function computeJsxOpeningLikeElement(node, subtreeFlags) {
        var transformFlags = subtreeFlags | 2;
        if (node.typeArguments) {
          transformFlags |= 1;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~536870912;
      }
      function computeBinaryExpression(node, subtreeFlags) {
        var transformFlags = subtreeFlags;
        var operatorTokenKind = node.operatorToken.kind;
        var leftKind = node.left.kind;
        if (operatorTokenKind === 60) {
          transformFlags |= 8;
        } else if (operatorTokenKind === 62 && leftKind === 193) {
          transformFlags |= 32 | 256 | 1024;
        } else if (operatorTokenKind === 62 && leftKind === 192) {
          transformFlags |= 256 | 1024;
        } else if (operatorTokenKind === 42 || operatorTokenKind === 66) {
          transformFlags |= 128;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~536870912;
      }
      function computeParameter(node, subtreeFlags) {
        var transformFlags = subtreeFlags;
        var name = node.name;
        var initializer = node.initializer;
        var dotDotDotToken = node.dotDotDotToken;
        if (node.questionToken || node.type || subtreeFlags & 2048 && ts2.some(node.decorators) || ts2.isThisIdentifier(name)) {
          transformFlags |= 1;
        }
        if (ts2.hasModifier(node, 92)) {
          transformFlags |= 1 | 2048;
        }
        if (subtreeFlags & 16384) {
          transformFlags |= 32;
        }
        if (subtreeFlags & 131072 || initializer || dotDotDotToken) {
          transformFlags |= 256;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~536870912;
      }
      function computeParenthesizedExpression(node, subtreeFlags) {
        var transformFlags = subtreeFlags;
        var expression = node.expression;
        var expressionKind = expression.kind;
        if (expressionKind === 217 || expressionKind === 199) {
          transformFlags |= 1;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~536870912;
      }
      function computeClassDeclaration(node, subtreeFlags) {
        var transformFlags;
        if (ts2.hasModifier(node, 2)) {
          transformFlags = 1;
        } else {
          transformFlags = subtreeFlags | 256;
          if (subtreeFlags & 2048 || node.typeParameters) {
            transformFlags |= 1;
          }
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~536905728;
      }
      function computeClassExpression(node, subtreeFlags) {
        var transformFlags = subtreeFlags | 256;
        if (subtreeFlags & 2048 || node.typeParameters) {
          transformFlags |= 1;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~536905728;
      }
      function computeHeritageClause(node, subtreeFlags) {
        var transformFlags = subtreeFlags;
        switch (node.token) {
          case 90:
            transformFlags |= 256;
            break;
          case 113:
            transformFlags |= 1;
            break;
          default:
            ts2.Debug.fail("Unexpected token for heritage clause");
            break;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~536870912;
      }
      function computeCatchClause(node, subtreeFlags) {
        var transformFlags = subtreeFlags;
        if (!node.variableDeclaration) {
          transformFlags |= 16;
        } else if (ts2.isBindingPattern(node.variableDeclaration.name)) {
          transformFlags |= 256;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~536887296;
      }
      function computeExpressionWithTypeArguments(node, subtreeFlags) {
        var transformFlags = subtreeFlags | 256;
        if (node.typeArguments) {
          transformFlags |= 1;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~536870912;
      }
      function computeConstructor(node, subtreeFlags) {
        var transformFlags = subtreeFlags;
        if (ts2.hasModifier(node, 2270) || !node.body) {
          transformFlags |= 1;
        }
        if (subtreeFlags & 16384) {
          transformFlags |= 32;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~538923008;
      }
      function computeMethod(node, subtreeFlags) {
        var transformFlags = subtreeFlags | 256;
        if (node.decorators || ts2.hasModifier(node, 2270) || node.typeParameters || node.type || !node.body || node.questionToken) {
          transformFlags |= 1;
        }
        if (subtreeFlags & 16384) {
          transformFlags |= 32;
        }
        if (ts2.hasModifier(node, 256)) {
          transformFlags |= node.asteriskToken ? 32 : 64;
        }
        if (node.asteriskToken) {
          transformFlags |= 512;
        }
        node.transformFlags = transformFlags | 536870912;
        return propagatePropertyNameFlags(node.name, transformFlags & ~538923008);
      }
      function computeAccessor(node, subtreeFlags) {
        var transformFlags = subtreeFlags;
        if (node.decorators || ts2.hasModifier(node, 2270) || node.type || !node.body) {
          transformFlags |= 1;
        }
        if (subtreeFlags & 16384) {
          transformFlags |= 32;
        }
        node.transformFlags = transformFlags | 536870912;
        return propagatePropertyNameFlags(node.name, transformFlags & ~538923008);
      }
      function computePropertyDeclaration(node, subtreeFlags) {
        var transformFlags = subtreeFlags | 4194304;
        if (ts2.some(node.decorators) || ts2.hasModifier(node, 2270) || node.type || node.questionToken || node.exclamationToken) {
          transformFlags |= 1;
        }
        if (ts2.isComputedPropertyName(node.name) || ts2.hasStaticModifier(node) && node.initializer) {
          transformFlags |= 2048;
        }
        node.transformFlags = transformFlags | 536870912;
        return propagatePropertyNameFlags(node.name, transformFlags & ~536875008);
      }
      function computeFunctionDeclaration(node, subtreeFlags) {
        var transformFlags;
        var modifierFlags = ts2.getModifierFlags(node);
        var body = node.body;
        if (!body || modifierFlags & 2) {
          transformFlags = 1;
        } else {
          transformFlags = subtreeFlags | 1048576;
          if (modifierFlags & 2270 || node.typeParameters || node.type) {
            transformFlags |= 1;
          }
          if (modifierFlags & 256) {
            transformFlags |= node.asteriskToken ? 32 : 64;
          }
          if (subtreeFlags & 16384) {
            transformFlags |= 32;
          }
          if (node.asteriskToken) {
            transformFlags |= 512;
          }
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~538925056;
      }
      function computeFunctionExpression(node, subtreeFlags) {
        var transformFlags = subtreeFlags;
        if (ts2.hasModifier(node, 2270) || node.typeParameters || node.type) {
          transformFlags |= 1;
        }
        if (ts2.hasModifier(node, 256)) {
          transformFlags |= node.asteriskToken ? 32 : 64;
        }
        if (subtreeFlags & 16384) {
          transformFlags |= 32;
        }
        if (node.asteriskToken) {
          transformFlags |= 512;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~538925056;
      }
      function computeArrowFunction(node, subtreeFlags) {
        var transformFlags = subtreeFlags | 256;
        if (ts2.hasModifier(node, 2270) || node.typeParameters || node.type) {
          transformFlags |= 1;
        }
        if (ts2.hasModifier(node, 256)) {
          transformFlags |= 64;
        }
        if (subtreeFlags & 16384) {
          transformFlags |= 32;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~538920960;
      }
      function computePropertyAccess(node, subtreeFlags) {
        var transformFlags = subtreeFlags;
        if (node.flags & 32) {
          transformFlags |= 8;
        }
        if (node.expression.kind === 102) {
          transformFlags |= 64 | 32;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~536870912;
      }
      function computeElementAccess(node, subtreeFlags) {
        var transformFlags = subtreeFlags;
        if (node.flags & 32) {
          transformFlags |= 8;
        }
        if (node.expression.kind === 102) {
          transformFlags |= 64 | 32;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~536870912;
      }
      function computeVariableDeclaration(node, subtreeFlags) {
        var transformFlags = subtreeFlags;
        transformFlags |= 256 | 131072;
        if (subtreeFlags & 16384) {
          transformFlags |= 32;
        }
        if (node.type || node.exclamationToken) {
          transformFlags |= 1;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~536870912;
      }
      function computeVariableStatement(node, subtreeFlags) {
        var transformFlags;
        var declarationListTransformFlags = node.declarationList.transformFlags;
        if (ts2.hasModifier(node, 2)) {
          transformFlags = 1;
        } else {
          transformFlags = subtreeFlags;
          if (declarationListTransformFlags & 131072) {
            transformFlags |= 256;
          }
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~536870912;
      }
      function computeLabeledStatement(node, subtreeFlags) {
        var transformFlags = subtreeFlags;
        if (subtreeFlags & 65536 && ts2.isIterationStatement(node, true)) {
          transformFlags |= 256;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~536870912;
      }
      function computeImportEquals(node, subtreeFlags) {
        var transformFlags = subtreeFlags;
        if (!ts2.isExternalModuleImportEqualsDeclaration(node)) {
          transformFlags |= 1;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~536870912;
      }
      function computeExpressionStatement(node, subtreeFlags) {
        var transformFlags = subtreeFlags;
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~536870912;
      }
      function computeModuleDeclaration(node, subtreeFlags) {
        var transformFlags = 1;
        var modifierFlags = ts2.getModifierFlags(node);
        if ((modifierFlags & 2) === 0) {
          transformFlags |= subtreeFlags;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~537991168;
      }
      function computeVariableDeclarationList(node, subtreeFlags) {
        var transformFlags = subtreeFlags | 1048576;
        if (subtreeFlags & 131072) {
          transformFlags |= 256;
        }
        if (node.flags & 3) {
          transformFlags |= 256 | 65536;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~537018368;
      }
      function computeOther(node, kind, subtreeFlags) {
        var transformFlags = subtreeFlags;
        var excludeFlags = 536870912;
        switch (kind) {
          case 126:
            transformFlags |= 32 | 64;
            break;
          case 206:
            transformFlags |= 32 | 64 | 524288;
            break;
          case 199:
          case 217:
          case 326:
            transformFlags |= 1;
            excludeFlags = 536870912;
            break;
          case 119:
          case 117:
          case 118:
          case 122:
          case 130:
          case 81:
          case 248:
          case 284:
          case 218:
          case 138:
            transformFlags |= 1;
            break;
          case 266:
          case 11:
          case 269:
          case 270:
          case 271:
          case 272:
          case 273:
          case 274:
          case 275:
          case 276:
            transformFlags |= 2;
            break;
          case 14:
          case 15:
          case 16:
          case 17:
            if (node.templateFlags) {
              transformFlags |= 32;
              break;
            }
          case 198:
            if (ts2.hasInvalidEscape(node.template)) {
              transformFlags |= 32;
              break;
            }
          case 211:
          case 282:
          case 120:
          case 219:
            transformFlags |= 256;
            break;
          case 10:
            if (node.hasExtendedUnicodeEscape) {
              transformFlags |= 256;
            }
            break;
          case 8:
            if (node.numericLiteralFlags & 384) {
              transformFlags |= 256;
            }
            break;
          case 9:
            transformFlags |= 4;
            break;
          case 232:
            if (node.awaitModifier) {
              transformFlags |= 32;
            }
            transformFlags |= 256;
            break;
          case 212:
            transformFlags |= 32 | 256 | 262144;
            break;
          case 125:
          case 140:
          case 151:
          case 137:
          case 141:
          case 143:
          case 128:
          case 144:
          case 110:
          case 155:
          case 158:
          case 160:
          case 165:
          case 166:
          case 167:
          case 168:
          case 169:
          case 170:
          case 171:
          case 172:
          case 173:
          case 174:
          case 175:
          case 176:
          case 177:
          case 178:
          case 179:
          case 180:
          case 181:
          case 182:
          case 246:
          case 247:
          case 183:
          case 184:
          case 185:
          case 186:
          case 187:
          case 252:
            transformFlags = 1;
            excludeFlags = -2;
            break;
          case 154:
            transformFlags |= 32768;
            break;
          case 213:
            transformFlags |= 256 | 8192;
            break;
          case 283:
            transformFlags |= 32 | 16384;
            break;
          case 102:
            transformFlags |= 256;
            excludeFlags = 536870912;
            break;
          case 104:
            transformFlags |= 4096;
            break;
          case 189:
            transformFlags |= 256 | 131072;
            if (subtreeFlags & 8192) {
              transformFlags |= 32 | 16384;
            }
            excludeFlags = 536879104;
            break;
          case 190:
            transformFlags |= 256 | 131072;
            excludeFlags = 536879104;
            break;
          case 191:
            transformFlags |= 256;
            if (node.dotDotDotToken) {
              transformFlags |= 8192;
            }
            break;
          case 157:
            transformFlags |= 1 | 2048;
            break;
          case 193:
            excludeFlags = 536922112;
            if (subtreeFlags & 32768) {
              transformFlags |= 256;
            }
            if (subtreeFlags & 16384) {
              transformFlags |= 32;
            }
            break;
          case 192:
            excludeFlags = 536879104;
            break;
          case 228:
          case 229:
          case 230:
          case 231:
            if (subtreeFlags & 65536) {
              transformFlags |= 256;
            }
            break;
          case 290:
            break;
          case 262:
            transformFlags |= 4;
            break;
          case 235:
            transformFlags |= 1048576 | 32;
            break;
          case 233:
          case 234:
            transformFlags |= 1048576;
            break;
          case 76:
            transformFlags |= 4194304;
            break;
        }
        node.transformFlags = transformFlags | 536870912;
        return transformFlags & ~excludeFlags;
      }
      function propagatePropertyNameFlags(node, transformFlags) {
        return transformFlags | node.transformFlags & 4096;
      }
      function getTransformFlagsSubtreeExclusions(kind) {
        if (kind >= 168 && kind <= 188) {
          return -2;
        }
        switch (kind) {
          case 196:
          case 197:
          case 192:
            return 536879104;
          case 249:
            return 537991168;
          case 156:
            return 536870912;
          case 202:
            return 538920960;
          case 201:
          case 244:
            return 538925056;
          case 243:
            return 537018368;
          case 245:
          case 214:
            return 536905728;
          case 162:
            return 538923008;
          case 161:
          case 163:
          case 164:
            return 538923008;
          case 125:
          case 140:
          case 151:
          case 137:
          case 143:
          case 141:
          case 128:
          case 144:
          case 110:
          case 155:
          case 158:
          case 160:
          case 165:
          case 166:
          case 167:
          case 246:
          case 247:
            return -2;
          case 193:
            return 536922112;
          case 280:
            return 536887296;
          case 189:
          case 190:
            return 536879104;
          case 199:
          case 217:
          case 326:
          case 200:
          case 102:
            return 536870912;
          case 194:
          case 195:
            return 536870912;
          default:
            return 536870912;
        }
      }
      ts2.getTransformFlagsSubtreeExclusions = getTransformFlagsSubtreeExclusions;
      function setParentPointers(parent, child) {
        child.parent = parent;
        ts2.forEachChild(child, function(grandchild) {
          return setParentPointers(child, grandchild);
        });
      }
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function createGetSymbolWalker(getRestTypeOfSignature, getTypePredicateOfSignature, getReturnTypeOfSignature, getBaseTypes, resolveStructuredTypeMembers, getTypeOfSymbol, getResolvedSymbol, getIndexTypeOfStructuredType, getConstraintOfTypeParameter, getFirstIdentifier, getTypeArguments) {
        return getSymbolWalker;
        function getSymbolWalker(accept) {
          if (accept === void 0) {
            accept = function() {
              return true;
            };
          }
          var visitedTypes = [];
          var visitedSymbols = [];
          return {
            walkType: function(type) {
              try {
                visitType(type);
                return { visitedTypes: ts2.getOwnValues(visitedTypes), visitedSymbols: ts2.getOwnValues(visitedSymbols) };
              } finally {
                ts2.clear(visitedTypes);
                ts2.clear(visitedSymbols);
              }
            },
            walkSymbol: function(symbol) {
              try {
                visitSymbol(symbol);
                return { visitedTypes: ts2.getOwnValues(visitedTypes), visitedSymbols: ts2.getOwnValues(visitedSymbols) };
              } finally {
                ts2.clear(visitedTypes);
                ts2.clear(visitedSymbols);
              }
            }
          };
          function visitType(type) {
            if (!type) {
              return;
            }
            if (visitedTypes[type.id]) {
              return;
            }
            visitedTypes[type.id] = type;
            var shouldBail = visitSymbol(type.symbol);
            if (shouldBail)
              return;
            if (type.flags & 524288) {
              var objectType = type;
              var objectFlags = objectType.objectFlags;
              if (objectFlags & 4) {
                visitTypeReference(type);
              }
              if (objectFlags & 32) {
                visitMappedType(type);
              }
              if (objectFlags & (1 | 2)) {
                visitInterfaceType(type);
              }
              if (objectFlags & (8 | 16)) {
                visitObjectType(objectType);
              }
            }
            if (type.flags & 262144) {
              visitTypeParameter(type);
            }
            if (type.flags & 3145728) {
              visitUnionOrIntersectionType(type);
            }
            if (type.flags & 4194304) {
              visitIndexType(type);
            }
            if (type.flags & 8388608) {
              visitIndexedAccessType(type);
            }
          }
          function visitTypeReference(type) {
            visitType(type.target);
            ts2.forEach(getTypeArguments(type), visitType);
          }
          function visitTypeParameter(type) {
            visitType(getConstraintOfTypeParameter(type));
          }
          function visitUnionOrIntersectionType(type) {
            ts2.forEach(type.types, visitType);
          }
          function visitIndexType(type) {
            visitType(type.type);
          }
          function visitIndexedAccessType(type) {
            visitType(type.objectType);
            visitType(type.indexType);
            visitType(type.constraint);
          }
          function visitMappedType(type) {
            visitType(type.typeParameter);
            visitType(type.constraintType);
            visitType(type.templateType);
            visitType(type.modifiersType);
          }
          function visitSignature(signature) {
            var typePredicate = getTypePredicateOfSignature(signature);
            if (typePredicate) {
              visitType(typePredicate.type);
            }
            ts2.forEach(signature.typeParameters, visitType);
            for (var _i = 0, _a = signature.parameters; _i < _a.length; _i++) {
              var parameter = _a[_i];
              visitSymbol(parameter);
            }
            visitType(getRestTypeOfSignature(signature));
            visitType(getReturnTypeOfSignature(signature));
          }
          function visitInterfaceType(interfaceT) {
            visitObjectType(interfaceT);
            ts2.forEach(interfaceT.typeParameters, visitType);
            ts2.forEach(getBaseTypes(interfaceT), visitType);
            visitType(interfaceT.thisType);
          }
          function visitObjectType(type) {
            var stringIndexType = getIndexTypeOfStructuredType(type, 0);
            visitType(stringIndexType);
            var numberIndexType = getIndexTypeOfStructuredType(type, 1);
            visitType(numberIndexType);
            var resolved = resolveStructuredTypeMembers(type);
            for (var _i = 0, _a = resolved.callSignatures; _i < _a.length; _i++) {
              var signature = _a[_i];
              visitSignature(signature);
            }
            for (var _b = 0, _c = resolved.constructSignatures; _b < _c.length; _b++) {
              var signature = _c[_b];
              visitSignature(signature);
            }
            for (var _d = 0, _e = resolved.properties; _d < _e.length; _d++) {
              var p = _e[_d];
              visitSymbol(p);
            }
          }
          function visitSymbol(symbol) {
            if (!symbol) {
              return false;
            }
            var symbolId = ts2.getSymbolId(symbol);
            if (visitedSymbols[symbolId]) {
              return false;
            }
            visitedSymbols[symbolId] = symbol;
            if (!accept(symbol)) {
              return true;
            }
            var t = getTypeOfSymbol(symbol);
            visitType(t);
            if (symbol.exports) {
              symbol.exports.forEach(visitSymbol);
            }
            ts2.forEach(symbol.declarations, function(d) {
              if (d.type && d.type.kind === 172) {
                var query = d.type;
                var entity = getResolvedSymbol(getFirstIdentifier(query.exprName));
                visitSymbol(entity);
              }
            });
            return false;
          }
        }
      }
      ts2.createGetSymbolWalker = createGetSymbolWalker;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var ambientModuleSymbolRegex = /^".+"$/;
      var anon = "(anonymous)";
      var nextSymbolId = 1;
      var nextNodeId = 1;
      var nextMergeId = 1;
      var nextFlowId = 1;
      var IterationUse;
      (function(IterationUse2) {
        IterationUse2[IterationUse2["AllowsSyncIterablesFlag"] = 1] = "AllowsSyncIterablesFlag";
        IterationUse2[IterationUse2["AllowsAsyncIterablesFlag"] = 2] = "AllowsAsyncIterablesFlag";
        IterationUse2[IterationUse2["AllowsStringInputFlag"] = 4] = "AllowsStringInputFlag";
        IterationUse2[IterationUse2["ForOfFlag"] = 8] = "ForOfFlag";
        IterationUse2[IterationUse2["YieldStarFlag"] = 16] = "YieldStarFlag";
        IterationUse2[IterationUse2["SpreadFlag"] = 32] = "SpreadFlag";
        IterationUse2[IterationUse2["DestructuringFlag"] = 64] = "DestructuringFlag";
        IterationUse2[IterationUse2["Element"] = 1] = "Element";
        IterationUse2[IterationUse2["Spread"] = 33] = "Spread";
        IterationUse2[IterationUse2["Destructuring"] = 65] = "Destructuring";
        IterationUse2[IterationUse2["ForOf"] = 13] = "ForOf";
        IterationUse2[IterationUse2["ForAwaitOf"] = 15] = "ForAwaitOf";
        IterationUse2[IterationUse2["YieldStar"] = 17] = "YieldStar";
        IterationUse2[IterationUse2["AsyncYieldStar"] = 19] = "AsyncYieldStar";
        IterationUse2[IterationUse2["GeneratorReturnType"] = 1] = "GeneratorReturnType";
        IterationUse2[IterationUse2["AsyncGeneratorReturnType"] = 2] = "AsyncGeneratorReturnType";
      })(IterationUse || (IterationUse = {}));
      var IterationTypeKind;
      (function(IterationTypeKind2) {
        IterationTypeKind2[IterationTypeKind2["Yield"] = 0] = "Yield";
        IterationTypeKind2[IterationTypeKind2["Return"] = 1] = "Return";
        IterationTypeKind2[IterationTypeKind2["Next"] = 2] = "Next";
      })(IterationTypeKind || (IterationTypeKind = {}));
      var WideningKind;
      (function(WideningKind2) {
        WideningKind2[WideningKind2["Normal"] = 0] = "Normal";
        WideningKind2[WideningKind2["FunctionReturn"] = 1] = "FunctionReturn";
        WideningKind2[WideningKind2["GeneratorNext"] = 2] = "GeneratorNext";
        WideningKind2[WideningKind2["GeneratorYield"] = 3] = "GeneratorYield";
      })(WideningKind || (WideningKind = {}));
      var TypeFacts;
      (function(TypeFacts2) {
        TypeFacts2[TypeFacts2["None"] = 0] = "None";
        TypeFacts2[TypeFacts2["TypeofEQString"] = 1] = "TypeofEQString";
        TypeFacts2[TypeFacts2["TypeofEQNumber"] = 2] = "TypeofEQNumber";
        TypeFacts2[TypeFacts2["TypeofEQBigInt"] = 4] = "TypeofEQBigInt";
        TypeFacts2[TypeFacts2["TypeofEQBoolean"] = 8] = "TypeofEQBoolean";
        TypeFacts2[TypeFacts2["TypeofEQSymbol"] = 16] = "TypeofEQSymbol";
        TypeFacts2[TypeFacts2["TypeofEQObject"] = 32] = "TypeofEQObject";
        TypeFacts2[TypeFacts2["TypeofEQFunction"] = 64] = "TypeofEQFunction";
        TypeFacts2[TypeFacts2["TypeofEQHostObject"] = 128] = "TypeofEQHostObject";
        TypeFacts2[TypeFacts2["TypeofNEString"] = 256] = "TypeofNEString";
        TypeFacts2[TypeFacts2["TypeofNENumber"] = 512] = "TypeofNENumber";
        TypeFacts2[TypeFacts2["TypeofNEBigInt"] = 1024] = "TypeofNEBigInt";
        TypeFacts2[TypeFacts2["TypeofNEBoolean"] = 2048] = "TypeofNEBoolean";
        TypeFacts2[TypeFacts2["TypeofNESymbol"] = 4096] = "TypeofNESymbol";
        TypeFacts2[TypeFacts2["TypeofNEObject"] = 8192] = "TypeofNEObject";
        TypeFacts2[TypeFacts2["TypeofNEFunction"] = 16384] = "TypeofNEFunction";
        TypeFacts2[TypeFacts2["TypeofNEHostObject"] = 32768] = "TypeofNEHostObject";
        TypeFacts2[TypeFacts2["EQUndefined"] = 65536] = "EQUndefined";
        TypeFacts2[TypeFacts2["EQNull"] = 131072] = "EQNull";
        TypeFacts2[TypeFacts2["EQUndefinedOrNull"] = 262144] = "EQUndefinedOrNull";
        TypeFacts2[TypeFacts2["NEUndefined"] = 524288] = "NEUndefined";
        TypeFacts2[TypeFacts2["NENull"] = 1048576] = "NENull";
        TypeFacts2[TypeFacts2["NEUndefinedOrNull"] = 2097152] = "NEUndefinedOrNull";
        TypeFacts2[TypeFacts2["Truthy"] = 4194304] = "Truthy";
        TypeFacts2[TypeFacts2["Falsy"] = 8388608] = "Falsy";
        TypeFacts2[TypeFacts2["All"] = 16777215] = "All";
        TypeFacts2[TypeFacts2["BaseStringStrictFacts"] = 3735041] = "BaseStringStrictFacts";
        TypeFacts2[TypeFacts2["BaseStringFacts"] = 12582401] = "BaseStringFacts";
        TypeFacts2[TypeFacts2["StringStrictFacts"] = 16317953] = "StringStrictFacts";
        TypeFacts2[TypeFacts2["StringFacts"] = 16776705] = "StringFacts";
        TypeFacts2[TypeFacts2["EmptyStringStrictFacts"] = 12123649] = "EmptyStringStrictFacts";
        TypeFacts2[TypeFacts2["EmptyStringFacts"] = 12582401] = "EmptyStringFacts";
        TypeFacts2[TypeFacts2["NonEmptyStringStrictFacts"] = 7929345] = "NonEmptyStringStrictFacts";
        TypeFacts2[TypeFacts2["NonEmptyStringFacts"] = 16776705] = "NonEmptyStringFacts";
        TypeFacts2[TypeFacts2["BaseNumberStrictFacts"] = 3734786] = "BaseNumberStrictFacts";
        TypeFacts2[TypeFacts2["BaseNumberFacts"] = 12582146] = "BaseNumberFacts";
        TypeFacts2[TypeFacts2["NumberStrictFacts"] = 16317698] = "NumberStrictFacts";
        TypeFacts2[TypeFacts2["NumberFacts"] = 16776450] = "NumberFacts";
        TypeFacts2[TypeFacts2["ZeroNumberStrictFacts"] = 12123394] = "ZeroNumberStrictFacts";
        TypeFacts2[TypeFacts2["ZeroNumberFacts"] = 12582146] = "ZeroNumberFacts";
        TypeFacts2[TypeFacts2["NonZeroNumberStrictFacts"] = 7929090] = "NonZeroNumberStrictFacts";
        TypeFacts2[TypeFacts2["NonZeroNumberFacts"] = 16776450] = "NonZeroNumberFacts";
        TypeFacts2[TypeFacts2["BaseBigIntStrictFacts"] = 3734276] = "BaseBigIntStrictFacts";
        TypeFacts2[TypeFacts2["BaseBigIntFacts"] = 12581636] = "BaseBigIntFacts";
        TypeFacts2[TypeFacts2["BigIntStrictFacts"] = 16317188] = "BigIntStrictFacts";
        TypeFacts2[TypeFacts2["BigIntFacts"] = 16775940] = "BigIntFacts";
        TypeFacts2[TypeFacts2["ZeroBigIntStrictFacts"] = 12122884] = "ZeroBigIntStrictFacts";
        TypeFacts2[TypeFacts2["ZeroBigIntFacts"] = 12581636] = "ZeroBigIntFacts";
        TypeFacts2[TypeFacts2["NonZeroBigIntStrictFacts"] = 7928580] = "NonZeroBigIntStrictFacts";
        TypeFacts2[TypeFacts2["NonZeroBigIntFacts"] = 16775940] = "NonZeroBigIntFacts";
        TypeFacts2[TypeFacts2["BaseBooleanStrictFacts"] = 3733256] = "BaseBooleanStrictFacts";
        TypeFacts2[TypeFacts2["BaseBooleanFacts"] = 12580616] = "BaseBooleanFacts";
        TypeFacts2[TypeFacts2["BooleanStrictFacts"] = 16316168] = "BooleanStrictFacts";
        TypeFacts2[TypeFacts2["BooleanFacts"] = 16774920] = "BooleanFacts";
        TypeFacts2[TypeFacts2["FalseStrictFacts"] = 12121864] = "FalseStrictFacts";
        TypeFacts2[TypeFacts2["FalseFacts"] = 12580616] = "FalseFacts";
        TypeFacts2[TypeFacts2["TrueStrictFacts"] = 7927560] = "TrueStrictFacts";
        TypeFacts2[TypeFacts2["TrueFacts"] = 16774920] = "TrueFacts";
        TypeFacts2[TypeFacts2["SymbolStrictFacts"] = 7925520] = "SymbolStrictFacts";
        TypeFacts2[TypeFacts2["SymbolFacts"] = 16772880] = "SymbolFacts";
        TypeFacts2[TypeFacts2["ObjectStrictFacts"] = 7888800] = "ObjectStrictFacts";
        TypeFacts2[TypeFacts2["ObjectFacts"] = 16736160] = "ObjectFacts";
        TypeFacts2[TypeFacts2["FunctionStrictFacts"] = 7880640] = "FunctionStrictFacts";
        TypeFacts2[TypeFacts2["FunctionFacts"] = 16728e3] = "FunctionFacts";
        TypeFacts2[TypeFacts2["UndefinedFacts"] = 9830144] = "UndefinedFacts";
        TypeFacts2[TypeFacts2["NullFacts"] = 9363232] = "NullFacts";
        TypeFacts2[TypeFacts2["EmptyObjectStrictFacts"] = 16318463] = "EmptyObjectStrictFacts";
        TypeFacts2[TypeFacts2["EmptyObjectFacts"] = 16777215] = "EmptyObjectFacts";
      })(TypeFacts || (TypeFacts = {}));
      var typeofEQFacts = ts2.createMapFromTemplate({
        string: 1,
        number: 2,
        bigint: 4,
        boolean: 8,
        symbol: 16,
        undefined: 65536,
        object: 32,
        function: 64
      });
      var typeofNEFacts = ts2.createMapFromTemplate({
        string: 256,
        number: 512,
        bigint: 1024,
        boolean: 2048,
        symbol: 4096,
        undefined: 524288,
        object: 8192,
        function: 16384
      });
      var TypeSystemPropertyName;
      (function(TypeSystemPropertyName2) {
        TypeSystemPropertyName2[TypeSystemPropertyName2["Type"] = 0] = "Type";
        TypeSystemPropertyName2[TypeSystemPropertyName2["ResolvedBaseConstructorType"] = 1] = "ResolvedBaseConstructorType";
        TypeSystemPropertyName2[TypeSystemPropertyName2["DeclaredType"] = 2] = "DeclaredType";
        TypeSystemPropertyName2[TypeSystemPropertyName2["ResolvedReturnType"] = 3] = "ResolvedReturnType";
        TypeSystemPropertyName2[TypeSystemPropertyName2["ImmediateBaseConstraint"] = 4] = "ImmediateBaseConstraint";
        TypeSystemPropertyName2[TypeSystemPropertyName2["EnumTagType"] = 5] = "EnumTagType";
        TypeSystemPropertyName2[TypeSystemPropertyName2["ResolvedTypeArguments"] = 6] = "ResolvedTypeArguments";
      })(TypeSystemPropertyName || (TypeSystemPropertyName = {}));
      var CheckMode;
      (function(CheckMode2) {
        CheckMode2[CheckMode2["Normal"] = 0] = "Normal";
        CheckMode2[CheckMode2["Contextual"] = 1] = "Contextual";
        CheckMode2[CheckMode2["Inferential"] = 2] = "Inferential";
        CheckMode2[CheckMode2["SkipContextSensitive"] = 4] = "SkipContextSensitive";
        CheckMode2[CheckMode2["SkipGenericFunctions"] = 8] = "SkipGenericFunctions";
        CheckMode2[CheckMode2["IsForSignatureHelp"] = 16] = "IsForSignatureHelp";
      })(CheckMode || (CheckMode = {}));
      var AccessFlags;
      (function(AccessFlags2) {
        AccessFlags2[AccessFlags2["None"] = 0] = "None";
        AccessFlags2[AccessFlags2["NoIndexSignatures"] = 1] = "NoIndexSignatures";
        AccessFlags2[AccessFlags2["Writing"] = 2] = "Writing";
        AccessFlags2[AccessFlags2["CacheSymbol"] = 4] = "CacheSymbol";
        AccessFlags2[AccessFlags2["NoTupleBoundsCheck"] = 8] = "NoTupleBoundsCheck";
      })(AccessFlags || (AccessFlags = {}));
      var SignatureCheckMode;
      (function(SignatureCheckMode2) {
        SignatureCheckMode2[SignatureCheckMode2["BivariantCallback"] = 1] = "BivariantCallback";
        SignatureCheckMode2[SignatureCheckMode2["StrictCallback"] = 2] = "StrictCallback";
        SignatureCheckMode2[SignatureCheckMode2["IgnoreReturnTypes"] = 4] = "IgnoreReturnTypes";
        SignatureCheckMode2[SignatureCheckMode2["StrictArity"] = 8] = "StrictArity";
        SignatureCheckMode2[SignatureCheckMode2["Callback"] = 3] = "Callback";
      })(SignatureCheckMode || (SignatureCheckMode = {}));
      var IntersectionState;
      (function(IntersectionState2) {
        IntersectionState2[IntersectionState2["None"] = 0] = "None";
        IntersectionState2[IntersectionState2["Source"] = 1] = "Source";
        IntersectionState2[IntersectionState2["Target"] = 2] = "Target";
        IntersectionState2[IntersectionState2["PropertyCheck"] = 4] = "PropertyCheck";
        IntersectionState2[IntersectionState2["InPropertyCheck"] = 8] = "InPropertyCheck";
      })(IntersectionState || (IntersectionState = {}));
      var MappedTypeModifiers;
      (function(MappedTypeModifiers2) {
        MappedTypeModifiers2[MappedTypeModifiers2["IncludeReadonly"] = 1] = "IncludeReadonly";
        MappedTypeModifiers2[MappedTypeModifiers2["ExcludeReadonly"] = 2] = "ExcludeReadonly";
        MappedTypeModifiers2[MappedTypeModifiers2["IncludeOptional"] = 4] = "IncludeOptional";
        MappedTypeModifiers2[MappedTypeModifiers2["ExcludeOptional"] = 8] = "ExcludeOptional";
      })(MappedTypeModifiers || (MappedTypeModifiers = {}));
      var ExpandingFlags;
      (function(ExpandingFlags2) {
        ExpandingFlags2[ExpandingFlags2["None"] = 0] = "None";
        ExpandingFlags2[ExpandingFlags2["Source"] = 1] = "Source";
        ExpandingFlags2[ExpandingFlags2["Target"] = 2] = "Target";
        ExpandingFlags2[ExpandingFlags2["Both"] = 3] = "Both";
      })(ExpandingFlags || (ExpandingFlags = {}));
      var MembersOrExportsResolutionKind;
      (function(MembersOrExportsResolutionKind2) {
        MembersOrExportsResolutionKind2["resolvedExports"] = "resolvedExports";
        MembersOrExportsResolutionKind2["resolvedMembers"] = "resolvedMembers";
      })(MembersOrExportsResolutionKind || (MembersOrExportsResolutionKind = {}));
      var UnusedKind;
      (function(UnusedKind2) {
        UnusedKind2[UnusedKind2["Local"] = 0] = "Local";
        UnusedKind2[UnusedKind2["Parameter"] = 1] = "Parameter";
      })(UnusedKind || (UnusedKind = {}));
      var isNotOverloadAndNotAccessor = ts2.and(isNotOverload, isNotAccessor);
      var DeclarationMeaning;
      (function(DeclarationMeaning2) {
        DeclarationMeaning2[DeclarationMeaning2["GetAccessor"] = 1] = "GetAccessor";
        DeclarationMeaning2[DeclarationMeaning2["SetAccessor"] = 2] = "SetAccessor";
        DeclarationMeaning2[DeclarationMeaning2["PropertyAssignment"] = 4] = "PropertyAssignment";
        DeclarationMeaning2[DeclarationMeaning2["Method"] = 8] = "Method";
        DeclarationMeaning2[DeclarationMeaning2["GetOrSetAccessor"] = 3] = "GetOrSetAccessor";
        DeclarationMeaning2[DeclarationMeaning2["PropertyAssignmentOrMethod"] = 12] = "PropertyAssignmentOrMethod";
      })(DeclarationMeaning || (DeclarationMeaning = {}));
      var DeclarationSpaces;
      (function(DeclarationSpaces2) {
        DeclarationSpaces2[DeclarationSpaces2["None"] = 0] = "None";
        DeclarationSpaces2[DeclarationSpaces2["ExportValue"] = 1] = "ExportValue";
        DeclarationSpaces2[DeclarationSpaces2["ExportType"] = 2] = "ExportType";
        DeclarationSpaces2[DeclarationSpaces2["ExportNamespace"] = 4] = "ExportNamespace";
      })(DeclarationSpaces || (DeclarationSpaces = {}));
      function SymbolLinks() {
      }
      function NodeLinks() {
        this.flags = 0;
      }
      function getNodeId(node) {
        if (!node.id) {
          node.id = nextNodeId;
          nextNodeId++;
        }
        return node.id;
      }
      ts2.getNodeId = getNodeId;
      function getSymbolId(symbol) {
        if (!symbol.id) {
          symbol.id = nextSymbolId;
          nextSymbolId++;
        }
        return symbol.id;
      }
      ts2.getSymbolId = getSymbolId;
      function isInstantiatedModule(node, preserveConstEnums) {
        var moduleState = ts2.getModuleInstanceState(node);
        return moduleState === 1 || preserveConstEnums && moduleState === 2;
      }
      ts2.isInstantiatedModule = isInstantiatedModule;
      function createTypeChecker(host, produceDiagnostics) {
        var getPackagesSet = ts2.memoize(function() {
          var set = ts2.createMap();
          host.getSourceFiles().forEach(function(sf) {
            if (!sf.resolvedModules)
              return;
            ts2.forEachEntry(sf.resolvedModules, function(r) {
              if (r && r.packageId)
                set.set(r.packageId.name, true);
            });
          });
          return set;
        });
        var cancellationToken;
        var requestedExternalEmitHelpers;
        var externalHelpersModule;
        var Symbol2 = ts2.objectAllocator.getSymbolConstructor();
        var Type = ts2.objectAllocator.getTypeConstructor();
        var Signature = ts2.objectAllocator.getSignatureConstructor();
        var typeCount = 0;
        var symbolCount = 0;
        var enumCount = 0;
        var totalInstantiationCount = 0;
        var instantiationCount = 0;
        var instantiationDepth = 0;
        var constraintDepth = 0;
        var currentNode;
        var emptySymbols = ts2.createSymbolTable();
        var arrayVariances = [1];
        var compilerOptions = host.getCompilerOptions();
        var languageVersion = ts2.getEmitScriptTarget(compilerOptions);
        var moduleKind = ts2.getEmitModuleKind(compilerOptions);
        var allowSyntheticDefaultImports = ts2.getAllowSyntheticDefaultImports(compilerOptions);
        var strictNullChecks = ts2.getStrictOptionValue(compilerOptions, "strictNullChecks");
        var strictFunctionTypes = ts2.getStrictOptionValue(compilerOptions, "strictFunctionTypes");
        var strictBindCallApply = ts2.getStrictOptionValue(compilerOptions, "strictBindCallApply");
        var strictPropertyInitialization = ts2.getStrictOptionValue(compilerOptions, "strictPropertyInitialization");
        var noImplicitAny = ts2.getStrictOptionValue(compilerOptions, "noImplicitAny");
        var noImplicitThis = ts2.getStrictOptionValue(compilerOptions, "noImplicitThis");
        var keyofStringsOnly = !!compilerOptions.keyofStringsOnly;
        var freshObjectLiteralFlag = compilerOptions.suppressExcessPropertyErrors ? 0 : 32768;
        var emitResolver = createResolver();
        var nodeBuilder = createNodeBuilder();
        var globals = ts2.createSymbolTable();
        var undefinedSymbol = createSymbol(4, "undefined");
        undefinedSymbol.declarations = [];
        var globalThisSymbol = createSymbol(1536, "globalThis", 8);
        globalThisSymbol.exports = globals;
        globalThisSymbol.declarations = [];
        globals.set(globalThisSymbol.escapedName, globalThisSymbol);
        var argumentsSymbol = createSymbol(4, "arguments");
        var requireSymbol = createSymbol(4, "require");
        var apparentArgumentCount;
        var checker = {
          getNodeCount: function() {
            return ts2.sum(host.getSourceFiles(), "nodeCount");
          },
          getIdentifierCount: function() {
            return ts2.sum(host.getSourceFiles(), "identifierCount");
          },
          getSymbolCount: function() {
            return ts2.sum(host.getSourceFiles(), "symbolCount") + symbolCount;
          },
          getTypeCount: function() {
            return typeCount;
          },
          getInstantiationCount: function() {
            return totalInstantiationCount;
          },
          getRelationCacheSizes: function() {
            return {
              assignable: assignableRelation.size,
              identity: identityRelation.size,
              subtype: subtypeRelation.size,
              strictSubtype: strictSubtypeRelation.size
            };
          },
          isUndefinedSymbol: function(symbol) {
            return symbol === undefinedSymbol;
          },
          isArgumentsSymbol: function(symbol) {
            return symbol === argumentsSymbol;
          },
          isUnknownSymbol: function(symbol) {
            return symbol === unknownSymbol;
          },
          getMergedSymbol,
          getDiagnostics,
          getGlobalDiagnostics,
          getTypeOfSymbolAtLocation: function(symbol, location) {
            location = ts2.getParseTreeNode(location);
            return location ? getTypeOfSymbolAtLocation(symbol, location) : errorType;
          },
          getSymbolsOfParameterPropertyDeclaration: function(parameterIn, parameterName) {
            var parameter = ts2.getParseTreeNode(parameterIn, ts2.isParameter);
            if (parameter === void 0)
              return ts2.Debug.fail("Cannot get symbols of a synthetic parameter that cannot be resolved to a parse-tree node.");
            return getSymbolsOfParameterPropertyDeclaration(parameter, ts2.escapeLeadingUnderscores(parameterName));
          },
          getDeclaredTypeOfSymbol,
          getPropertiesOfType,
          getPropertyOfType: function(type, name) {
            return getPropertyOfType(type, ts2.escapeLeadingUnderscores(name));
          },
          getPrivateIdentifierPropertyOfType: function(leftType, name, location) {
            var node = ts2.getParseTreeNode(location);
            if (!node) {
              return void 0;
            }
            var propName = ts2.escapeLeadingUnderscores(name);
            var lexicallyScopedIdentifier = lookupSymbolForPrivateIdentifierDeclaration(propName, node);
            return lexicallyScopedIdentifier ? getPrivateIdentifierPropertyOfType(leftType, lexicallyScopedIdentifier) : void 0;
          },
          getTypeOfPropertyOfType: function(type, name) {
            return getTypeOfPropertyOfType(type, ts2.escapeLeadingUnderscores(name));
          },
          getIndexInfoOfType,
          getSignaturesOfType,
          getIndexTypeOfType,
          getBaseTypes,
          getBaseTypeOfLiteralType,
          getWidenedType,
          getTypeFromTypeNode: function(nodeIn) {
            var node = ts2.getParseTreeNode(nodeIn, ts2.isTypeNode);
            return node ? getTypeFromTypeNode(node) : errorType;
          },
          getParameterType: getTypeAtPosition,
          getPromisedTypeOfPromise,
          getReturnTypeOfSignature,
          isNullableType,
          getNullableType,
          getNonNullableType,
          getNonOptionalType: removeOptionalTypeMarker,
          getTypeArguments,
          typeToTypeNode: nodeBuilder.typeToTypeNode,
          indexInfoToIndexSignatureDeclaration: nodeBuilder.indexInfoToIndexSignatureDeclaration,
          signatureToSignatureDeclaration: nodeBuilder.signatureToSignatureDeclaration,
          symbolToEntityName: nodeBuilder.symbolToEntityName,
          symbolToExpression: nodeBuilder.symbolToExpression,
          symbolToTypeParameterDeclarations: nodeBuilder.symbolToTypeParameterDeclarations,
          symbolToParameterDeclaration: nodeBuilder.symbolToParameterDeclaration,
          typeParameterToDeclaration: nodeBuilder.typeParameterToDeclaration,
          getSymbolsInScope: function(location, meaning) {
            location = ts2.getParseTreeNode(location);
            return location ? getSymbolsInScope(location, meaning) : [];
          },
          getSymbolAtLocation: function(node) {
            node = ts2.getParseTreeNode(node);
            return node ? getSymbolAtLocation(node, true) : void 0;
          },
          getShorthandAssignmentValueSymbol: function(node) {
            node = ts2.getParseTreeNode(node);
            return node ? getShorthandAssignmentValueSymbol(node) : void 0;
          },
          getExportSpecifierLocalTargetSymbol: function(nodeIn) {
            var node = ts2.getParseTreeNode(nodeIn, ts2.isExportSpecifier);
            return node ? getExportSpecifierLocalTargetSymbol(node) : void 0;
          },
          getExportSymbolOfSymbol: function(symbol) {
            return getMergedSymbol(symbol.exportSymbol || symbol);
          },
          getTypeAtLocation: function(node) {
            node = ts2.getParseTreeNode(node);
            return node ? getTypeOfNode(node) : errorType;
          },
          getTypeOfAssignmentPattern: function(nodeIn) {
            var node = ts2.getParseTreeNode(nodeIn, ts2.isAssignmentPattern);
            return node && getTypeOfAssignmentPattern(node) || errorType;
          },
          getPropertySymbolOfDestructuringAssignment: function(locationIn) {
            var location = ts2.getParseTreeNode(locationIn, ts2.isIdentifier);
            return location ? getPropertySymbolOfDestructuringAssignment(location) : void 0;
          },
          signatureToString: function(signature, enclosingDeclaration, flags, kind) {
            return signatureToString(signature, ts2.getParseTreeNode(enclosingDeclaration), flags, kind);
          },
          typeToString: function(type, enclosingDeclaration, flags) {
            return typeToString(type, ts2.getParseTreeNode(enclosingDeclaration), flags);
          },
          symbolToString: function(symbol, enclosingDeclaration, meaning, flags) {
            return symbolToString(symbol, ts2.getParseTreeNode(enclosingDeclaration), meaning, flags);
          },
          typePredicateToString: function(predicate, enclosingDeclaration, flags) {
            return typePredicateToString(predicate, ts2.getParseTreeNode(enclosingDeclaration), flags);
          },
          writeSignature: function(signature, enclosingDeclaration, flags, kind, writer) {
            return signatureToString(signature, ts2.getParseTreeNode(enclosingDeclaration), flags, kind, writer);
          },
          writeType: function(type, enclosingDeclaration, flags, writer) {
            return typeToString(type, ts2.getParseTreeNode(enclosingDeclaration), flags, writer);
          },
          writeSymbol: function(symbol, enclosingDeclaration, meaning, flags, writer) {
            return symbolToString(symbol, ts2.getParseTreeNode(enclosingDeclaration), meaning, flags, writer);
          },
          writeTypePredicate: function(predicate, enclosingDeclaration, flags, writer) {
            return typePredicateToString(predicate, ts2.getParseTreeNode(enclosingDeclaration), flags, writer);
          },
          getAugmentedPropertiesOfType,
          getRootSymbols,
          getContextualType: function(nodeIn, contextFlags) {
            var node = ts2.getParseTreeNode(nodeIn, ts2.isExpression);
            if (!node) {
              return void 0;
            }
            var containingCall = ts2.findAncestor(node, ts2.isCallLikeExpression);
            var containingCallResolvedSignature = containingCall && getNodeLinks(containingCall).resolvedSignature;
            if (contextFlags & 4 && containingCall) {
              var toMarkSkip = node;
              do {
                getNodeLinks(toMarkSkip).skipDirectInference = true;
                toMarkSkip = toMarkSkip.parent;
              } while (toMarkSkip && toMarkSkip !== containingCall);
              getNodeLinks(containingCall).resolvedSignature = void 0;
            }
            var result = getContextualType(node, contextFlags);
            if (contextFlags & 4 && containingCall) {
              var toMarkSkip = node;
              do {
                getNodeLinks(toMarkSkip).skipDirectInference = void 0;
                toMarkSkip = toMarkSkip.parent;
              } while (toMarkSkip && toMarkSkip !== containingCall);
              getNodeLinks(containingCall).resolvedSignature = containingCallResolvedSignature;
            }
            return result;
          },
          getContextualTypeForObjectLiteralElement: function(nodeIn) {
            var node = ts2.getParseTreeNode(nodeIn, ts2.isObjectLiteralElementLike);
            return node ? getContextualTypeForObjectLiteralElement(node) : void 0;
          },
          getContextualTypeForArgumentAtIndex: function(nodeIn, argIndex) {
            var node = ts2.getParseTreeNode(nodeIn, ts2.isCallLikeExpression);
            return node && getContextualTypeForArgumentAtIndex(node, argIndex);
          },
          getContextualTypeForJsxAttribute: function(nodeIn) {
            var node = ts2.getParseTreeNode(nodeIn, ts2.isJsxAttributeLike);
            return node && getContextualTypeForJsxAttribute(node);
          },
          isContextSensitive,
          getFullyQualifiedName,
          getResolvedSignature: function(node, candidatesOutArray, argumentCount) {
            return getResolvedSignatureWorker(node, candidatesOutArray, argumentCount, 0);
          },
          getResolvedSignatureForSignatureHelp: function(node, candidatesOutArray, argumentCount) {
            return getResolvedSignatureWorker(node, candidatesOutArray, argumentCount, 16);
          },
          getExpandedParameters,
          hasEffectiveRestParameter,
          getConstantValue: function(nodeIn) {
            var node = ts2.getParseTreeNode(nodeIn, canHaveConstantValue);
            return node ? getConstantValue(node) : void 0;
          },
          isValidPropertyAccess: function(nodeIn, propertyName) {
            var node = ts2.getParseTreeNode(nodeIn, ts2.isPropertyAccessOrQualifiedNameOrImportTypeNode);
            return !!node && isValidPropertyAccess(node, ts2.escapeLeadingUnderscores(propertyName));
          },
          isValidPropertyAccessForCompletions: function(nodeIn, type, property) {
            var node = ts2.getParseTreeNode(nodeIn, ts2.isPropertyAccessExpression);
            return !!node && isValidPropertyAccessForCompletions(node, type, property);
          },
          getSignatureFromDeclaration: function(declarationIn) {
            var declaration = ts2.getParseTreeNode(declarationIn, ts2.isFunctionLike);
            return declaration ? getSignatureFromDeclaration(declaration) : void 0;
          },
          isImplementationOfOverload: function(node) {
            var parsed = ts2.getParseTreeNode(node, ts2.isFunctionLike);
            return parsed ? isImplementationOfOverload(parsed) : void 0;
          },
          getImmediateAliasedSymbol,
          getAliasedSymbol: resolveAlias,
          getEmitResolver,
          getExportsOfModule: getExportsOfModuleAsArray,
          getExportsAndPropertiesOfModule,
          getSymbolWalker: ts2.createGetSymbolWalker(getRestTypeOfSignature, getTypePredicateOfSignature, getReturnTypeOfSignature, getBaseTypes, resolveStructuredTypeMembers, getTypeOfSymbol, getResolvedSymbol, getIndexTypeOfStructuredType, getConstraintOfTypeParameter, ts2.getFirstIdentifier, getTypeArguments),
          getAmbientModules,
          getJsxIntrinsicTagNamesAt,
          isOptionalParameter: function(nodeIn) {
            var node = ts2.getParseTreeNode(nodeIn, ts2.isParameter);
            return node ? isOptionalParameter(node) : false;
          },
          tryGetMemberInModuleExports: function(name, symbol) {
            return tryGetMemberInModuleExports(ts2.escapeLeadingUnderscores(name), symbol);
          },
          tryGetMemberInModuleExportsAndProperties: function(name, symbol) {
            return tryGetMemberInModuleExportsAndProperties(ts2.escapeLeadingUnderscores(name), symbol);
          },
          tryFindAmbientModuleWithoutAugmentations: function(moduleName) {
            return tryFindAmbientModule(moduleName, false);
          },
          getApparentType,
          getUnionType,
          isTypeAssignableTo,
          createAnonymousType,
          createSignature,
          createSymbol,
          createIndexInfo,
          getAnyType: function() {
            return anyType;
          },
          getStringType: function() {
            return stringType;
          },
          getNumberType: function() {
            return numberType;
          },
          createPromiseType,
          createArrayType,
          getElementTypeOfArrayType,
          getBooleanType: function() {
            return booleanType;
          },
          getFalseType: function(fresh) {
            return fresh ? falseType : regularFalseType;
          },
          getTrueType: function(fresh) {
            return fresh ? trueType : regularTrueType;
          },
          getVoidType: function() {
            return voidType;
          },
          getUndefinedType: function() {
            return undefinedType;
          },
          getNullType: function() {
            return nullType;
          },
          getESSymbolType: function() {
            return esSymbolType;
          },
          getNeverType: function() {
            return neverType;
          },
          getOptionalType: function() {
            return optionalType;
          },
          isSymbolAccessible,
          isArrayType,
          isTupleType,
          isArrayLikeType,
          isTypeInvalidDueToUnionDiscriminant,
          getAllPossiblePropertiesOfTypes,
          getSuggestedSymbolForNonexistentProperty,
          getSuggestionForNonexistentProperty,
          getSuggestedSymbolForNonexistentSymbol: function(location, name, meaning) {
            return getSuggestedSymbolForNonexistentSymbol(location, ts2.escapeLeadingUnderscores(name), meaning);
          },
          getSuggestionForNonexistentSymbol: function(location, name, meaning) {
            return getSuggestionForNonexistentSymbol(location, ts2.escapeLeadingUnderscores(name), meaning);
          },
          getSuggestedSymbolForNonexistentModule,
          getSuggestionForNonexistentExport,
          getBaseConstraintOfType,
          getDefaultFromTypeParameter: function(type) {
            return type && type.flags & 262144 ? getDefaultFromTypeParameter(type) : void 0;
          },
          resolveName: function(name, location, meaning, excludeGlobals) {
            return resolveName(location, ts2.escapeLeadingUnderscores(name), meaning, void 0, void 0, false, excludeGlobals);
          },
          getJsxNamespace: function(n) {
            return ts2.unescapeLeadingUnderscores(getJsxNamespace(n));
          },
          getAccessibleSymbolChain,
          getTypePredicateOfSignature,
          resolveExternalModuleName: function(moduleSpecifier) {
            return resolveExternalModuleName(moduleSpecifier, moduleSpecifier, true);
          },
          resolveExternalModuleSymbol,
          tryGetThisTypeAt: function(node, includeGlobalThis) {
            node = ts2.getParseTreeNode(node);
            return node && tryGetThisTypeAt(node, includeGlobalThis);
          },
          getTypeArgumentConstraint: function(nodeIn) {
            var node = ts2.getParseTreeNode(nodeIn, ts2.isTypeNode);
            return node && getTypeArgumentConstraint(node);
          },
          getSuggestionDiagnostics: function(file, ct) {
            if (ts2.skipTypeChecking(file, compilerOptions, host)) {
              return ts2.emptyArray;
            }
            var diagnostics2;
            try {
              cancellationToken = ct;
              checkSourceFile(file);
              ts2.Debug.assert(!!(getNodeLinks(file).flags & 1));
              diagnostics2 = ts2.addRange(diagnostics2, suggestionDiagnostics.getDiagnostics(file.fileName));
              checkUnusedIdentifiers(getPotentiallyUnusedIdentifiers(file), function(containingNode, kind, diag) {
                if (!ts2.containsParseError(containingNode) && !unusedIsError(kind, !!(containingNode.flags & 8388608))) {
                  (diagnostics2 || (diagnostics2 = [])).push(__assign(__assign({}, diag), { category: ts2.DiagnosticCategory.Suggestion }));
                }
              });
              return diagnostics2 || ts2.emptyArray;
            } finally {
              cancellationToken = void 0;
            }
          },
          runWithCancellationToken: function(token, callback) {
            try {
              cancellationToken = token;
              return callback(checker);
            } finally {
              cancellationToken = void 0;
            }
          },
          getLocalTypeParametersOfClassOrInterfaceOrTypeAlias,
          isDeclarationVisible
        };
        function getResolvedSignatureWorker(nodeIn, candidatesOutArray, argumentCount, checkMode) {
          var node = ts2.getParseTreeNode(nodeIn, ts2.isCallLikeExpression);
          apparentArgumentCount = argumentCount;
          var res = node ? getResolvedSignature(node, candidatesOutArray, checkMode) : void 0;
          apparentArgumentCount = void 0;
          return res;
        }
        var tupleTypes = ts2.createMap();
        var unionTypes = ts2.createMap();
        var intersectionTypes = ts2.createMap();
        var literalTypes = ts2.createMap();
        var indexedAccessTypes = ts2.createMap();
        var substitutionTypes = ts2.createMap();
        var evolvingArrayTypes = [];
        var undefinedProperties = ts2.createMap();
        var unknownSymbol = createSymbol(4, "unknown");
        var resolvingSymbol = createSymbol(0, "__resolving__");
        var anyType = createIntrinsicType(1, "any");
        var autoType = createIntrinsicType(1, "any");
        var wildcardType = createIntrinsicType(1, "any");
        var errorType = createIntrinsicType(1, "error");
        var nonInferrableAnyType = createIntrinsicType(1, "any", 524288);
        var unknownType = createIntrinsicType(2, "unknown");
        var undefinedType = createIntrinsicType(32768, "undefined");
        var undefinedWideningType = strictNullChecks ? undefinedType : createIntrinsicType(32768, "undefined", 524288);
        var optionalType = createIntrinsicType(32768, "undefined");
        var nullType = createIntrinsicType(65536, "null");
        var nullWideningType = strictNullChecks ? nullType : createIntrinsicType(65536, "null", 524288);
        var stringType = createIntrinsicType(4, "string");
        var numberType = createIntrinsicType(8, "number");
        var bigintType = createIntrinsicType(64, "bigint");
        var falseType = createIntrinsicType(512, "false");
        var regularFalseType = createIntrinsicType(512, "false");
        var trueType = createIntrinsicType(512, "true");
        var regularTrueType = createIntrinsicType(512, "true");
        trueType.regularType = regularTrueType;
        trueType.freshType = trueType;
        regularTrueType.regularType = regularTrueType;
        regularTrueType.freshType = trueType;
        falseType.regularType = regularFalseType;
        falseType.freshType = falseType;
        regularFalseType.regularType = regularFalseType;
        regularFalseType.freshType = falseType;
        var booleanType = createBooleanType([regularFalseType, regularTrueType]);
        createBooleanType([regularFalseType, trueType]);
        createBooleanType([falseType, regularTrueType]);
        createBooleanType([falseType, trueType]);
        var esSymbolType = createIntrinsicType(4096, "symbol");
        var voidType = createIntrinsicType(16384, "void");
        var neverType = createIntrinsicType(131072, "never");
        var silentNeverType = createIntrinsicType(131072, "never");
        var nonInferrableType = createIntrinsicType(131072, "never", 2097152);
        var implicitNeverType = createIntrinsicType(131072, "never");
        var unreachableNeverType = createIntrinsicType(131072, "never");
        var nonPrimitiveType = createIntrinsicType(67108864, "object");
        var stringNumberSymbolType = getUnionType([stringType, numberType, esSymbolType]);
        var keyofConstraintType = keyofStringsOnly ? stringType : stringNumberSymbolType;
        var numberOrBigIntType = getUnionType([numberType, bigintType]);
        var restrictiveMapper = makeFunctionTypeMapper(function(t) {
          return t.flags & 262144 ? getRestrictiveTypeParameter(t) : t;
        });
        var permissiveMapper = makeFunctionTypeMapper(function(t) {
          return t.flags & 262144 ? wildcardType : t;
        });
        var emptyObjectType = createAnonymousType(void 0, emptySymbols, ts2.emptyArray, ts2.emptyArray, void 0, void 0);
        var emptyJsxObjectType = createAnonymousType(void 0, emptySymbols, ts2.emptyArray, ts2.emptyArray, void 0, void 0);
        emptyJsxObjectType.objectFlags |= 4096;
        var emptyTypeLiteralSymbol = createSymbol(2048, "__type");
        emptyTypeLiteralSymbol.members = ts2.createSymbolTable();
        var emptyTypeLiteralType = createAnonymousType(emptyTypeLiteralSymbol, emptySymbols, ts2.emptyArray, ts2.emptyArray, void 0, void 0);
        var emptyGenericType = createAnonymousType(void 0, emptySymbols, ts2.emptyArray, ts2.emptyArray, void 0, void 0);
        emptyGenericType.instantiations = ts2.createMap();
        var anyFunctionType = createAnonymousType(void 0, emptySymbols, ts2.emptyArray, ts2.emptyArray, void 0, void 0);
        anyFunctionType.objectFlags |= 2097152;
        var noConstraintType = createAnonymousType(void 0, emptySymbols, ts2.emptyArray, ts2.emptyArray, void 0, void 0);
        var circularConstraintType = createAnonymousType(void 0, emptySymbols, ts2.emptyArray, ts2.emptyArray, void 0, void 0);
        var resolvingDefaultType = createAnonymousType(void 0, emptySymbols, ts2.emptyArray, ts2.emptyArray, void 0, void 0);
        var markerSuperType = createTypeParameter();
        var markerSubType = createTypeParameter();
        markerSubType.constraint = markerSuperType;
        var markerOtherType = createTypeParameter();
        var noTypePredicate = createTypePredicate(1, "<<unresolved>>", 0, anyType);
        var anySignature = createSignature(void 0, void 0, void 0, ts2.emptyArray, anyType, void 0, 0, 0);
        var unknownSignature = createSignature(void 0, void 0, void 0, ts2.emptyArray, errorType, void 0, 0, 0);
        var resolvingSignature = createSignature(void 0, void 0, void 0, ts2.emptyArray, anyType, void 0, 0, 0);
        var silentNeverSignature = createSignature(void 0, void 0, void 0, ts2.emptyArray, silentNeverType, void 0, 0, 0);
        var enumNumberIndexInfo = createIndexInfo(stringType, true);
        var iterationTypesCache = ts2.createMap();
        var noIterationTypes = {
          get yieldType() {
            return ts2.Debug.fail("Not supported");
          },
          get returnType() {
            return ts2.Debug.fail("Not supported");
          },
          get nextType() {
            return ts2.Debug.fail("Not supported");
          }
        };
        var anyIterationTypes = createIterationTypes(anyType, anyType, anyType);
        var anyIterationTypesExceptNext = createIterationTypes(anyType, anyType, unknownType);
        var defaultIterationTypes = createIterationTypes(neverType, anyType, undefinedType);
        var asyncIterationTypesResolver = {
          iterableCacheKey: "iterationTypesOfAsyncIterable",
          iteratorCacheKey: "iterationTypesOfAsyncIterator",
          iteratorSymbolName: "asyncIterator",
          getGlobalIteratorType: getGlobalAsyncIteratorType,
          getGlobalIterableType: getGlobalAsyncIterableType,
          getGlobalIterableIteratorType: getGlobalAsyncIterableIteratorType,
          getGlobalGeneratorType: getGlobalAsyncGeneratorType,
          resolveIterationType: getAwaitedType,
          mustHaveANextMethodDiagnostic: ts2.Diagnostics.An_async_iterator_must_have_a_next_method,
          mustBeAMethodDiagnostic: ts2.Diagnostics.The_0_property_of_an_async_iterator_must_be_a_method,
          mustHaveAValueDiagnostic: ts2.Diagnostics.The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property
        };
        var syncIterationTypesResolver = {
          iterableCacheKey: "iterationTypesOfIterable",
          iteratorCacheKey: "iterationTypesOfIterator",
          iteratorSymbolName: "iterator",
          getGlobalIteratorType,
          getGlobalIterableType,
          getGlobalIterableIteratorType,
          getGlobalGeneratorType,
          resolveIterationType: function(type, _errorNode) {
            return type;
          },
          mustHaveANextMethodDiagnostic: ts2.Diagnostics.An_iterator_must_have_a_next_method,
          mustBeAMethodDiagnostic: ts2.Diagnostics.The_0_property_of_an_iterator_must_be_a_method,
          mustHaveAValueDiagnostic: ts2.Diagnostics.The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property
        };
        var amalgamatedDuplicates;
        var reverseMappedCache = ts2.createMap();
        var ambientModulesCache;
        var patternAmbientModules;
        var patternAmbientModuleAugmentations;
        var globalObjectType;
        var globalFunctionType;
        var globalCallableFunctionType;
        var globalNewableFunctionType;
        var globalArrayType;
        var globalReadonlyArrayType;
        var globalStringType;
        var globalNumberType;
        var globalBooleanType;
        var globalRegExpType;
        var globalThisType;
        var anyArrayType;
        var autoArrayType;
        var anyReadonlyArrayType;
        var deferredGlobalNonNullableTypeAlias;
        var deferredGlobalESSymbolConstructorSymbol;
        var deferredGlobalESSymbolType;
        var deferredGlobalTypedPropertyDescriptorType;
        var deferredGlobalPromiseType;
        var deferredGlobalPromiseLikeType;
        var deferredGlobalPromiseConstructorSymbol;
        var deferredGlobalPromiseConstructorLikeType;
        var deferredGlobalIterableType;
        var deferredGlobalIteratorType;
        var deferredGlobalIterableIteratorType;
        var deferredGlobalGeneratorType;
        var deferredGlobalIteratorYieldResultType;
        var deferredGlobalIteratorReturnResultType;
        var deferredGlobalAsyncIterableType;
        var deferredGlobalAsyncIteratorType;
        var deferredGlobalAsyncIterableIteratorType;
        var deferredGlobalAsyncGeneratorType;
        var deferredGlobalTemplateStringsArrayType;
        var deferredGlobalImportMetaType;
        var deferredGlobalExtractSymbol;
        var deferredGlobalOmitSymbol;
        var deferredGlobalBigIntType;
        var allPotentiallyUnusedIdentifiers = ts2.createMap();
        var flowLoopStart = 0;
        var flowLoopCount = 0;
        var sharedFlowCount = 0;
        var flowAnalysisDisabled = false;
        var flowInvocationCount = 0;
        var lastFlowNode;
        var lastFlowNodeReachable;
        var flowTypeCache;
        var emptyStringType = getLiteralType("");
        var zeroType = getLiteralType(0);
        var zeroBigIntType = getLiteralType({ negative: false, base10Value: "0" });
        var resolutionTargets = [];
        var resolutionResults = [];
        var resolutionPropertyNames = [];
        var suggestionCount = 0;
        var maximumSuggestionCount = 10;
        var mergedSymbols = [];
        var symbolLinks = [];
        var nodeLinks = [];
        var flowLoopCaches = [];
        var flowLoopNodes = [];
        var flowLoopKeys = [];
        var flowLoopTypes = [];
        var sharedFlowNodes = [];
        var sharedFlowTypes = [];
        var flowNodeReachable = [];
        var potentialThisCollisions = [];
        var potentialNewTargetCollisions = [];
        var potentialWeakMapCollisions = [];
        var awaitedTypeStack = [];
        var diagnostics = ts2.createDiagnosticCollection();
        var suggestionDiagnostics = ts2.createDiagnosticCollection();
        var typeofTypesByName = ts2.createMapFromTemplate({
          string: stringType,
          number: numberType,
          bigint: bigintType,
          boolean: booleanType,
          symbol: esSymbolType,
          undefined: undefinedType
        });
        var typeofType = createTypeofType();
        var _jsxNamespace;
        var _jsxFactoryEntity;
        var outofbandVarianceMarkerHandler;
        var subtypeRelation = ts2.createMap();
        var strictSubtypeRelation = ts2.createMap();
        var assignableRelation = ts2.createMap();
        var comparableRelation = ts2.createMap();
        var identityRelation = ts2.createMap();
        var enumRelation = ts2.createMap();
        var builtinGlobals = ts2.createSymbolTable();
        builtinGlobals.set(undefinedSymbol.escapedName, undefinedSymbol);
        initializeTypeChecker();
        return checker;
        function getJsxNamespace(location) {
          if (location) {
            var file = ts2.getSourceFileOfNode(location);
            if (file) {
              if (file.localJsxNamespace) {
                return file.localJsxNamespace;
              }
              var jsxPragma = file.pragmas.get("jsx");
              if (jsxPragma) {
                var chosenpragma = ts2.isArray(jsxPragma) ? jsxPragma[0] : jsxPragma;
                file.localJsxFactory = ts2.parseIsolatedEntityName(chosenpragma.arguments.factory, languageVersion);
                ts2.visitNode(file.localJsxFactory, markAsSynthetic);
                if (file.localJsxFactory) {
                  return file.localJsxNamespace = ts2.getFirstIdentifier(file.localJsxFactory).escapedText;
                }
              }
            }
          }
          if (!_jsxNamespace) {
            _jsxNamespace = "React";
            if (compilerOptions.jsxFactory) {
              _jsxFactoryEntity = ts2.parseIsolatedEntityName(compilerOptions.jsxFactory, languageVersion);
              ts2.visitNode(_jsxFactoryEntity, markAsSynthetic);
              if (_jsxFactoryEntity) {
                _jsxNamespace = ts2.getFirstIdentifier(_jsxFactoryEntity).escapedText;
              }
            } else if (compilerOptions.reactNamespace) {
              _jsxNamespace = ts2.escapeLeadingUnderscores(compilerOptions.reactNamespace);
            }
          }
          if (!_jsxFactoryEntity) {
            _jsxFactoryEntity = ts2.createQualifiedName(ts2.createIdentifier(ts2.unescapeLeadingUnderscores(_jsxNamespace)), "createElement");
          }
          return _jsxNamespace;
          function markAsSynthetic(node) {
            node.pos = -1;
            node.end = -1;
            return ts2.visitEachChild(node, markAsSynthetic, ts2.nullTransformationContext);
          }
        }
        function getEmitResolver(sourceFile, cancellationToken2) {
          getDiagnostics(sourceFile, cancellationToken2);
          return emitResolver;
        }
        function lookupOrIssueError(location, message, arg0, arg1, arg2, arg3) {
          var diagnostic = location ? ts2.createDiagnosticForNode(location, message, arg0, arg1, arg2, arg3) : ts2.createCompilerDiagnostic(message, arg0, arg1, arg2, arg3);
          var existing = diagnostics.lookup(diagnostic);
          if (existing) {
            return existing;
          } else {
            diagnostics.add(diagnostic);
            return diagnostic;
          }
        }
        function error(location, message, arg0, arg1, arg2, arg3) {
          var diagnostic = location ? ts2.createDiagnosticForNode(location, message, arg0, arg1, arg2, arg3) : ts2.createCompilerDiagnostic(message, arg0, arg1, arg2, arg3);
          diagnostics.add(diagnostic);
          return diagnostic;
        }
        function addErrorOrSuggestion(isError, diagnostic) {
          if (isError) {
            diagnostics.add(diagnostic);
          } else {
            suggestionDiagnostics.add(__assign(__assign({}, diagnostic), { category: ts2.DiagnosticCategory.Suggestion }));
          }
        }
        function errorOrSuggestion(isError, location, message, arg0, arg1, arg2, arg3) {
          addErrorOrSuggestion(isError, "message" in message ? ts2.createDiagnosticForNode(location, message, arg0, arg1, arg2, arg3) : ts2.createDiagnosticForNodeFromMessageChain(location, message));
        }
        function errorAndMaybeSuggestAwait(location, maybeMissingAwait, message, arg0, arg1, arg2, arg3) {
          var diagnostic = error(location, message, arg0, arg1, arg2, arg3);
          if (maybeMissingAwait) {
            var related = ts2.createDiagnosticForNode(location, ts2.Diagnostics.Did_you_forget_to_use_await);
            ts2.addRelatedInfo(diagnostic, related);
          }
          return diagnostic;
        }
        function createSymbol(flags, name, checkFlags) {
          symbolCount++;
          var symbol = new Symbol2(flags | 33554432, name);
          symbol.checkFlags = checkFlags || 0;
          return symbol;
        }
        function getExcludedSymbolFlags(flags) {
          var result = 0;
          if (flags & 2)
            result |= 111551;
          if (flags & 1)
            result |= 111550;
          if (flags & 4)
            result |= 0;
          if (flags & 8)
            result |= 900095;
          if (flags & 16)
            result |= 110991;
          if (flags & 32)
            result |= 899503;
          if (flags & 64)
            result |= 788872;
          if (flags & 256)
            result |= 899327;
          if (flags & 128)
            result |= 899967;
          if (flags & 512)
            result |= 110735;
          if (flags & 8192)
            result |= 103359;
          if (flags & 32768)
            result |= 46015;
          if (flags & 65536)
            result |= 78783;
          if (flags & 262144)
            result |= 526824;
          if (flags & 524288)
            result |= 788968;
          if (flags & 2097152)
            result |= 2097152;
          return result;
        }
        function recordMergedSymbol(target, source) {
          if (!source.mergeId) {
            source.mergeId = nextMergeId;
            nextMergeId++;
          }
          mergedSymbols[source.mergeId] = target;
        }
        function cloneSymbol(symbol) {
          var result = createSymbol(symbol.flags, symbol.escapedName);
          result.declarations = symbol.declarations ? symbol.declarations.slice() : [];
          result.parent = symbol.parent;
          if (symbol.valueDeclaration)
            result.valueDeclaration = symbol.valueDeclaration;
          if (symbol.constEnumOnlyModule)
            result.constEnumOnlyModule = true;
          if (symbol.members)
            result.members = ts2.cloneMap(symbol.members);
          if (symbol.exports)
            result.exports = ts2.cloneMap(symbol.exports);
          recordMergedSymbol(result, symbol);
          return result;
        }
        function mergeSymbol(target, source, unidirectional) {
          if (unidirectional === void 0) {
            unidirectional = false;
          }
          if (!(target.flags & getExcludedSymbolFlags(source.flags)) || (source.flags | target.flags) & 67108864) {
            if (source === target) {
              return target;
            }
            if (!(target.flags & 33554432)) {
              var resolvedTarget = resolveSymbol(target);
              if (resolvedTarget === unknownSymbol) {
                return source;
              }
              target = cloneSymbol(resolvedTarget);
            }
            if (source.flags & 512 && target.flags & 512 && target.constEnumOnlyModule && !source.constEnumOnlyModule) {
              target.constEnumOnlyModule = false;
            }
            target.flags |= source.flags;
            if (source.valueDeclaration) {
              ts2.setValueDeclaration(target, source.valueDeclaration);
            }
            ts2.addRange(target.declarations, source.declarations);
            if (source.members) {
              if (!target.members)
                target.members = ts2.createSymbolTable();
              mergeSymbolTable(target.members, source.members, unidirectional);
            }
            if (source.exports) {
              if (!target.exports)
                target.exports = ts2.createSymbolTable();
              mergeSymbolTable(target.exports, source.exports, unidirectional);
            }
            if (!unidirectional) {
              recordMergedSymbol(target, source);
            }
          } else if (target.flags & 1024) {
            if (target !== globalThisSymbol) {
              error(ts2.getNameOfDeclaration(source.declarations[0]), ts2.Diagnostics.Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity, symbolToString(target));
            }
          } else {
            var isEitherEnum = !!(target.flags & 384 || source.flags & 384);
            var isEitherBlockScoped_1 = !!(target.flags & 2 || source.flags & 2);
            var message = isEitherEnum ? ts2.Diagnostics.Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations : isEitherBlockScoped_1 ? ts2.Diagnostics.Cannot_redeclare_block_scoped_variable_0 : ts2.Diagnostics.Duplicate_identifier_0;
            var sourceSymbolFile = source.declarations && ts2.getSourceFileOfNode(source.declarations[0]);
            var targetSymbolFile = target.declarations && ts2.getSourceFileOfNode(target.declarations[0]);
            var symbolName_1 = symbolToString(source);
            if (sourceSymbolFile && targetSymbolFile && amalgamatedDuplicates && !isEitherEnum && sourceSymbolFile !== targetSymbolFile) {
              var firstFile_1 = ts2.comparePaths(sourceSymbolFile.path, targetSymbolFile.path) === -1 ? sourceSymbolFile : targetSymbolFile;
              var secondFile_1 = firstFile_1 === sourceSymbolFile ? targetSymbolFile : sourceSymbolFile;
              var filesDuplicates = ts2.getOrUpdate(amalgamatedDuplicates, firstFile_1.path + "|" + secondFile_1.path, function() {
                return { firstFile: firstFile_1, secondFile: secondFile_1, conflictingSymbols: ts2.createMap() };
              });
              var conflictingSymbolInfo = ts2.getOrUpdate(filesDuplicates.conflictingSymbols, symbolName_1, function() {
                return { isBlockScoped: isEitherBlockScoped_1, firstFileLocations: [], secondFileLocations: [] };
              });
              addDuplicateLocations(conflictingSymbolInfo.firstFileLocations, source);
              addDuplicateLocations(conflictingSymbolInfo.secondFileLocations, target);
            } else {
              addDuplicateDeclarationErrorsForSymbols(source, message, symbolName_1, target);
              addDuplicateDeclarationErrorsForSymbols(target, message, symbolName_1, source);
            }
          }
          return target;
          function addDuplicateLocations(locs, symbol) {
            for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
              var decl = _a[_i];
              ts2.pushIfUnique(locs, decl);
            }
          }
        }
        function addDuplicateDeclarationErrorsForSymbols(target, message, symbolName, source) {
          ts2.forEach(target.declarations, function(node) {
            addDuplicateDeclarationError(node, message, symbolName, source.declarations);
          });
        }
        function addDuplicateDeclarationError(node, message, symbolName, relatedNodes) {
          var errorNode = (ts2.getExpandoInitializer(node, false) ? ts2.getNameOfExpando(node) : ts2.getNameOfDeclaration(node)) || node;
          var err = lookupOrIssueError(errorNode, message, symbolName);
          var _loop_6 = function(relatedNode2) {
            var adjustedNode = (ts2.getExpandoInitializer(relatedNode2, false) ? ts2.getNameOfExpando(relatedNode2) : ts2.getNameOfDeclaration(relatedNode2)) || relatedNode2;
            if (adjustedNode === errorNode)
              return "continue";
            err.relatedInformation = err.relatedInformation || [];
            var leadingMessage = ts2.createDiagnosticForNode(adjustedNode, ts2.Diagnostics._0_was_also_declared_here, symbolName);
            var followOnMessage = ts2.createDiagnosticForNode(adjustedNode, ts2.Diagnostics.and_here);
            if (ts2.length(err.relatedInformation) >= 5 || ts2.some(err.relatedInformation, function(r) {
              return ts2.compareDiagnostics(r, followOnMessage) === 0 || ts2.compareDiagnostics(r, leadingMessage) === 0;
            }))
              return "continue";
            ts2.addRelatedInfo(err, !ts2.length(err.relatedInformation) ? leadingMessage : followOnMessage);
          };
          for (var _i = 0, _a = relatedNodes || ts2.emptyArray; _i < _a.length; _i++) {
            var relatedNode = _a[_i];
            _loop_6(relatedNode);
          }
        }
        function combineSymbolTables(first, second) {
          if (!ts2.hasEntries(first))
            return second;
          if (!ts2.hasEntries(second))
            return first;
          var combined = ts2.createSymbolTable();
          mergeSymbolTable(combined, first);
          mergeSymbolTable(combined, second);
          return combined;
        }
        function mergeSymbolTable(target, source, unidirectional) {
          if (unidirectional === void 0) {
            unidirectional = false;
          }
          source.forEach(function(sourceSymbol, id) {
            var targetSymbol = target.get(id);
            target.set(id, targetSymbol ? mergeSymbol(targetSymbol, sourceSymbol, unidirectional) : sourceSymbol);
          });
        }
        function mergeModuleAugmentation(moduleName) {
          var _a, _b;
          var moduleAugmentation = moduleName.parent;
          if (moduleAugmentation.symbol.declarations[0] !== moduleAugmentation) {
            ts2.Debug.assert(moduleAugmentation.symbol.declarations.length > 1);
            return;
          }
          if (ts2.isGlobalScopeAugmentation(moduleAugmentation)) {
            mergeSymbolTable(globals, moduleAugmentation.symbol.exports);
          } else {
            var moduleNotFoundError = !(moduleName.parent.parent.flags & 8388608) ? ts2.Diagnostics.Invalid_module_name_in_augmentation_module_0_cannot_be_found : void 0;
            var mainModule_1 = resolveExternalModuleNameWorker(moduleName, moduleName, moduleNotFoundError, true);
            if (!mainModule_1) {
              return;
            }
            mainModule_1 = resolveExternalModuleSymbol(mainModule_1);
            if (mainModule_1.flags & 1920) {
              if (ts2.some(patternAmbientModules, function(module3) {
                return mainModule_1 === module3.symbol;
              })) {
                var merged = mergeSymbol(moduleAugmentation.symbol, mainModule_1, true);
                if (!patternAmbientModuleAugmentations) {
                  patternAmbientModuleAugmentations = ts2.createMap();
                }
                patternAmbientModuleAugmentations.set(moduleName.text, merged);
              } else {
                if (((_a = mainModule_1.exports) === null || _a === void 0 ? void 0 : _a.get("__export")) && ((_b = moduleAugmentation.symbol.exports) === null || _b === void 0 ? void 0 : _b.size)) {
                  var resolvedExports = getResolvedMembersOrExportsOfSymbol(mainModule_1, "resolvedExports");
                  for (var _i = 0, _c = ts2.arrayFrom(moduleAugmentation.symbol.exports.entries()); _i < _c.length; _i++) {
                    var _d = _c[_i], key = _d[0], value = _d[1];
                    if (resolvedExports.has(key) && !mainModule_1.exports.has(key)) {
                      mergeSymbol(resolvedExports.get(key), value);
                    }
                  }
                }
                mergeSymbol(mainModule_1, moduleAugmentation.symbol);
              }
            } else {
              error(moduleName, ts2.Diagnostics.Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity, moduleName.text);
            }
          }
        }
        function addToSymbolTable(target, source, message) {
          source.forEach(function(sourceSymbol, id) {
            var targetSymbol = target.get(id);
            if (targetSymbol) {
              ts2.forEach(targetSymbol.declarations, addDeclarationDiagnostic(ts2.unescapeLeadingUnderscores(id), message));
            } else {
              target.set(id, sourceSymbol);
            }
          });
          function addDeclarationDiagnostic(id, message2) {
            return function(declaration) {
              return diagnostics.add(ts2.createDiagnosticForNode(declaration, message2, id));
            };
          }
        }
        function getSymbolLinks(symbol) {
          if (symbol.flags & 33554432)
            return symbol;
          var id = getSymbolId(symbol);
          return symbolLinks[id] || (symbolLinks[id] = new SymbolLinks());
        }
        function getNodeLinks(node) {
          var nodeId = getNodeId(node);
          return nodeLinks[nodeId] || (nodeLinks[nodeId] = new NodeLinks());
        }
        function isGlobalSourceFile(node) {
          return node.kind === 290 && !ts2.isExternalOrCommonJsModule(node);
        }
        function getSymbol(symbols, name, meaning) {
          if (meaning) {
            var symbol = getMergedSymbol(symbols.get(name));
            if (symbol) {
              ts2.Debug.assert((ts2.getCheckFlags(symbol) & 1) === 0, "Should never get an instantiated symbol here.");
              if (symbol.flags & meaning) {
                return symbol;
              }
              if (symbol.flags & 2097152) {
                var target = resolveAlias(symbol);
                if (target === unknownSymbol || target.flags & meaning) {
                  return symbol;
                }
              }
            }
          }
        }
        function getSymbolsOfParameterPropertyDeclaration(parameter, parameterName) {
          var constructorDeclaration = parameter.parent;
          var classDeclaration = parameter.parent.parent;
          var parameterSymbol = getSymbol(constructorDeclaration.locals, parameterName, 111551);
          var propertySymbol = getSymbol(getMembersOfSymbol(classDeclaration.symbol), parameterName, 111551);
          if (parameterSymbol && propertySymbol) {
            return [parameterSymbol, propertySymbol];
          }
          return ts2.Debug.fail("There should exist two symbols, one as property declaration and one as parameter declaration");
        }
        function isBlockScopedNameDeclaredBeforeUse(declaration, usage) {
          var declarationFile = ts2.getSourceFileOfNode(declaration);
          var useFile = ts2.getSourceFileOfNode(usage);
          var declContainer = ts2.getEnclosingBlockScopeContainer(declaration);
          if (declarationFile !== useFile) {
            if (moduleKind && (declarationFile.externalModuleIndicator || useFile.externalModuleIndicator) || !compilerOptions.outFile && !compilerOptions.out || isInTypeQuery(usage) || declaration.flags & 8388608) {
              return true;
            }
            if (isUsedInFunctionOrInstanceProperty(usage, declaration)) {
              return true;
            }
            var sourceFiles = host.getSourceFiles();
            return sourceFiles.indexOf(declarationFile) <= sourceFiles.indexOf(useFile);
          }
          if (declaration.pos <= usage.pos) {
            if (declaration.kind === 191) {
              var errorBindingElement = ts2.getAncestor(usage, 191);
              if (errorBindingElement) {
                return ts2.findAncestor(errorBindingElement, ts2.isBindingElement) !== ts2.findAncestor(declaration, ts2.isBindingElement) || declaration.pos < errorBindingElement.pos;
              }
              return isBlockScopedNameDeclaredBeforeUse(ts2.getAncestor(declaration, 242), usage);
            } else if (declaration.kind === 242) {
              return !isImmediatelyUsedInInitializerOfBlockScopedVariable(declaration, usage);
            } else if (ts2.isClassDeclaration(declaration)) {
              return !ts2.findAncestor(usage, function(n) {
                return ts2.isComputedPropertyName(n) && n.parent.parent === declaration;
              });
            } else if (ts2.isPropertyDeclaration(declaration)) {
              return !isPropertyImmediatelyReferencedWithinDeclaration(declaration, usage, false);
            } else if (ts2.isParameterPropertyDeclaration(declaration, declaration.parent)) {
              return !(compilerOptions.target === 99 && !!compilerOptions.useDefineForClassFields && ts2.getContainingClass(declaration) === ts2.getContainingClass(usage) && isUsedInFunctionOrInstanceProperty(usage, declaration));
            }
            return true;
          }
          if (usage.parent.kind === 263 || usage.parent.kind === 259 && usage.parent.isExportEquals) {
            return true;
          }
          if (usage.kind === 259 && usage.isExportEquals) {
            return true;
          }
          if (!!(usage.flags & 4194304) || isInTypeQuery(usage) || usageInTypeDeclaration()) {
            return true;
          }
          if (isUsedInFunctionOrInstanceProperty(usage, declaration)) {
            if (compilerOptions.target === 99 && !!compilerOptions.useDefineForClassFields && ts2.getContainingClass(declaration) && (ts2.isPropertyDeclaration(declaration) || ts2.isParameterPropertyDeclaration(declaration, declaration.parent))) {
              return !isPropertyImmediatelyReferencedWithinDeclaration(declaration, usage, true);
            } else {
              return true;
            }
          }
          return false;
          function usageInTypeDeclaration() {
            return !!ts2.findAncestor(usage, function(node) {
              return ts2.isInterfaceDeclaration(node) || ts2.isTypeAliasDeclaration(node);
            });
          }
          function isImmediatelyUsedInInitializerOfBlockScopedVariable(declaration2, usage2) {
            switch (declaration2.parent.parent.kind) {
              case 225:
              case 230:
              case 232:
                if (isSameScopeDescendentOf(usage2, declaration2, declContainer)) {
                  return true;
                }
                break;
            }
            var grandparent = declaration2.parent.parent;
            return ts2.isForInOrOfStatement(grandparent) && isSameScopeDescendentOf(usage2, grandparent.expression, declContainer);
          }
          function isUsedInFunctionOrInstanceProperty(usage2, declaration2) {
            return !!ts2.findAncestor(usage2, function(current) {
              if (current === declContainer) {
                return "quit";
              }
              if (ts2.isFunctionLike(current)) {
                return true;
              }
              var initializerOfProperty = current.parent && current.parent.kind === 159 && current.parent.initializer === current;
              if (initializerOfProperty) {
                if (ts2.hasModifier(current.parent, 32)) {
                  if (declaration2.kind === 161) {
                    return true;
                  }
                } else {
                  var isDeclarationInstanceProperty = declaration2.kind === 159 && !ts2.hasModifier(declaration2, 32);
                  if (!isDeclarationInstanceProperty || ts2.getContainingClass(usage2) !== ts2.getContainingClass(declaration2)) {
                    return true;
                  }
                }
              }
              return false;
            });
          }
          function isPropertyImmediatelyReferencedWithinDeclaration(declaration2, usage2, stopAtAnyPropertyDeclaration) {
            if (usage2.end > declaration2.end) {
              return false;
            }
            var ancestorChangingReferenceScope = ts2.findAncestor(usage2, function(node) {
              if (node === declaration2) {
                return "quit";
              }
              switch (node.kind) {
                case 202:
                  return true;
                case 159:
                  return stopAtAnyPropertyDeclaration && (ts2.isPropertyDeclaration(declaration2) && node.parent === declaration2.parent || ts2.isParameterPropertyDeclaration(declaration2, declaration2.parent) && node.parent === declaration2.parent.parent) ? "quit" : true;
                case 223:
                  switch (node.parent.kind) {
                    case 163:
                    case 161:
                    case 164:
                      return true;
                    default:
                      return false;
                  }
                default:
                  return false;
              }
            });
            return ancestorChangingReferenceScope === void 0;
          }
        }
        function useOuterVariableScopeInParameter(result, location, lastLocation) {
          var target = ts2.getEmitScriptTarget(compilerOptions);
          var functionLocation = location;
          if (ts2.isParameter(lastLocation) && functionLocation.body && result.valueDeclaration.pos >= functionLocation.body.pos && result.valueDeclaration.end <= functionLocation.body.end) {
            if (target >= 2) {
              var links = getNodeLinks(functionLocation);
              if (links.declarationRequiresScopeChange === void 0) {
                links.declarationRequiresScopeChange = ts2.forEach(functionLocation.parameters, requiresScopeChange) || false;
              }
              return !links.declarationRequiresScopeChange;
            }
          }
          return false;
          function requiresScopeChange(node) {
            return requiresScopeChangeWorker(node.name) || !!node.initializer && requiresScopeChangeWorker(node.initializer);
          }
          function requiresScopeChangeWorker(node) {
            switch (node.kind) {
              case 202:
              case 201:
              case 244:
              case 162:
                return false;
              case 161:
              case 163:
              case 164:
              case 281:
                return requiresScopeChangeWorker(node.name);
              case 159:
                if (ts2.hasStaticModifier(node)) {
                  return target < 99 || !compilerOptions.useDefineForClassFields;
                }
                return requiresScopeChangeWorker(node.name);
              default:
                if (ts2.isNullishCoalesce(node) || ts2.isOptionalChain(node)) {
                  return target < 7;
                }
                if (ts2.isBindingElement(node) && node.dotDotDotToken && ts2.isObjectBindingPattern(node.parent)) {
                  return target < 4;
                }
                if (ts2.isTypeNode(node))
                  return false;
                return ts2.forEachChild(node, requiresScopeChangeWorker) || false;
            }
          }
        }
        function resolveName(location, name, meaning, nameNotFoundMessage, nameArg, isUse, excludeGlobals, suggestedNameNotFoundMessage) {
          if (excludeGlobals === void 0) {
            excludeGlobals = false;
          }
          return resolveNameHelper(location, name, meaning, nameNotFoundMessage, nameArg, isUse, excludeGlobals, getSymbol, suggestedNameNotFoundMessage);
        }
        function resolveNameHelper(location, name, meaning, nameNotFoundMessage, nameArg, isUse, excludeGlobals, lookup, suggestedNameNotFoundMessage) {
          var originalLocation = location;
          var result;
          var lastLocation;
          var lastSelfReferenceLocation;
          var propertyWithInvalidInitializer;
          var associatedDeclarationForContainingInitializerOrBindingName;
          var withinDeferredContext = false;
          var errorLocation = location;
          var grandparent;
          var isInExternalModule = false;
          loop:
            while (location) {
              if (location.locals && !isGlobalSourceFile(location)) {
                if (result = lookup(location.locals, name, meaning)) {
                  var useResult = true;
                  if (ts2.isFunctionLike(location) && lastLocation && lastLocation !== location.body) {
                    if (meaning & result.flags & 788968 && lastLocation.kind !== 303) {
                      useResult = result.flags & 262144 ? lastLocation === location.type || lastLocation.kind === 156 || lastLocation.kind === 155 : false;
                    }
                    if (meaning & result.flags & 3) {
                      if (useOuterVariableScopeInParameter(result, location, lastLocation)) {
                        useResult = false;
                      } else if (result.flags & 1) {
                        useResult = lastLocation.kind === 156 || lastLocation === location.type && !!ts2.findAncestor(result.valueDeclaration, ts2.isParameter);
                      }
                    }
                  } else if (location.kind === 180) {
                    useResult = lastLocation === location.trueType;
                  }
                  if (useResult) {
                    break loop;
                  } else {
                    result = void 0;
                  }
                }
              }
              withinDeferredContext = withinDeferredContext || getIsDeferredContext(location, lastLocation);
              switch (location.kind) {
                case 290:
                  if (!ts2.isExternalOrCommonJsModule(location))
                    break;
                  isInExternalModule = true;
                case 249:
                  var moduleExports = getSymbolOfNode(location).exports || emptySymbols;
                  if (location.kind === 290 || ts2.isModuleDeclaration(location) && location.flags & 8388608 && !ts2.isGlobalScopeAugmentation(location)) {
                    if (result = moduleExports.get("default")) {
                      var localSymbol = ts2.getLocalSymbolForExportDefault(result);
                      if (localSymbol && result.flags & meaning && localSymbol.escapedName === name) {
                        break loop;
                      }
                      result = void 0;
                    }
                    var moduleExport = moduleExports.get(name);
                    if (moduleExport && moduleExport.flags === 2097152 && (ts2.getDeclarationOfKind(moduleExport, 263) || ts2.getDeclarationOfKind(moduleExport, 262))) {
                      break;
                    }
                  }
                  if (name !== "default" && (result = lookup(moduleExports, name, meaning & 2623475))) {
                    if (ts2.isSourceFile(location) && location.commonJsModuleIndicator && !result.declarations.some(ts2.isJSDocTypeAlias)) {
                      result = void 0;
                    } else {
                      break loop;
                    }
                  }
                  break;
                case 248:
                  if (result = lookup(getSymbolOfNode(location).exports, name, meaning & 8)) {
                    break loop;
                  }
                  break;
                case 159:
                  if (!ts2.hasModifier(location, 32)) {
                    var ctor = findConstructorDeclaration(location.parent);
                    if (ctor && ctor.locals) {
                      if (lookup(ctor.locals, name, meaning & 111551)) {
                        propertyWithInvalidInitializer = location;
                      }
                    }
                  }
                  break;
                case 245:
                case 214:
                case 246:
                  if (result = lookup(getSymbolOfNode(location).members || emptySymbols, name, meaning & 788968)) {
                    if (!isTypeParameterSymbolDeclaredInContainer(result, location)) {
                      result = void 0;
                      break;
                    }
                    if (lastLocation && ts2.hasModifier(lastLocation, 32)) {
                      error(errorLocation, ts2.Diagnostics.Static_members_cannot_reference_class_type_parameters);
                      return void 0;
                    }
                    break loop;
                  }
                  if (location.kind === 214 && meaning & 32) {
                    var className = location.name;
                    if (className && name === className.escapedText) {
                      result = location.symbol;
                      break loop;
                    }
                  }
                  break;
                case 216:
                  if (lastLocation === location.expression && location.parent.token === 90) {
                    var container = location.parent.parent;
                    if (ts2.isClassLike(container) && (result = lookup(getSymbolOfNode(container).members, name, meaning & 788968))) {
                      if (nameNotFoundMessage) {
                        error(errorLocation, ts2.Diagnostics.Base_class_expressions_cannot_reference_class_type_parameters);
                      }
                      return void 0;
                    }
                  }
                  break;
                case 154:
                  grandparent = location.parent.parent;
                  if (ts2.isClassLike(grandparent) || grandparent.kind === 246) {
                    if (result = lookup(getSymbolOfNode(grandparent).members, name, meaning & 788968)) {
                      error(errorLocation, ts2.Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);
                      return void 0;
                    }
                  }
                  break;
                case 202:
                  if (compilerOptions.target >= 2) {
                    break;
                  }
                case 161:
                case 162:
                case 163:
                case 164:
                case 244:
                  if (meaning & 3 && name === "arguments") {
                    result = argumentsSymbol;
                    break loop;
                  }
                  break;
                case 201:
                  if (meaning & 3 && name === "arguments") {
                    result = argumentsSymbol;
                    break loop;
                  }
                  if (meaning & 16) {
                    var functionName = location.name;
                    if (functionName && name === functionName.escapedText) {
                      result = location.symbol;
                      break loop;
                    }
                  }
                  break;
                case 157:
                  if (location.parent && location.parent.kind === 156) {
                    location = location.parent;
                  }
                  if (location.parent && (ts2.isClassElement(location.parent) || location.parent.kind === 245)) {
                    location = location.parent;
                  }
                  break;
                case 322:
                case 315:
                case 316:
                  location = ts2.getJSDocHost(location);
                  break;
                case 156:
                  if (lastLocation && (lastLocation === location.initializer || lastLocation === location.name && ts2.isBindingPattern(lastLocation))) {
                    if (!associatedDeclarationForContainingInitializerOrBindingName) {
                      associatedDeclarationForContainingInitializerOrBindingName = location;
                    }
                  }
                  break;
                case 191:
                  if (lastLocation && (lastLocation === location.initializer || lastLocation === location.name && ts2.isBindingPattern(lastLocation))) {
                    var root = ts2.getRootDeclaration(location);
                    if (root.kind === 156) {
                      if (!associatedDeclarationForContainingInitializerOrBindingName) {
                        associatedDeclarationForContainingInitializerOrBindingName = location;
                      }
                    }
                  }
                  break;
              }
              if (isSelfReferenceLocation(location)) {
                lastSelfReferenceLocation = location;
              }
              lastLocation = location;
              location = location.parent;
            }
          if (isUse && result && (!lastSelfReferenceLocation || result !== lastSelfReferenceLocation.symbol)) {
            result.isReferenced |= meaning;
          }
          if (!result) {
            if (lastLocation) {
              ts2.Debug.assert(lastLocation.kind === 290);
              if (lastLocation.commonJsModuleIndicator && name === "exports" && meaning & lastLocation.symbol.flags) {
                return lastLocation.symbol;
              }
            }
            if (!excludeGlobals) {
              result = lookup(globals, name, meaning);
            }
          }
          if (!result) {
            if (originalLocation && ts2.isInJSFile(originalLocation) && originalLocation.parent) {
              if (ts2.isRequireCall(originalLocation.parent, false)) {
                return requireSymbol;
              }
            }
          }
          if (!result) {
            if (nameNotFoundMessage) {
              if (!errorLocation || !checkAndReportErrorForMissingPrefix(errorLocation, name, nameArg) && !checkAndReportErrorForExtendingInterface(errorLocation) && !checkAndReportErrorForUsingTypeAsNamespace(errorLocation, name, meaning) && !checkAndReportErrorForExportingPrimitiveType(errorLocation, name) && !checkAndReportErrorForUsingTypeAsValue(errorLocation, name, meaning) && !checkAndReportErrorForUsingNamespaceModuleAsValue(errorLocation, name, meaning) && !checkAndReportErrorForUsingValueAsType(errorLocation, name, meaning)) {
                var suggestion = void 0;
                if (suggestedNameNotFoundMessage && suggestionCount < maximumSuggestionCount) {
                  suggestion = getSuggestedSymbolForNonexistentSymbol(originalLocation, name, meaning);
                  if (suggestion) {
                    var suggestionName = symbolToString(suggestion);
                    var diagnostic = error(errorLocation, suggestedNameNotFoundMessage, diagnosticName(nameArg), suggestionName);
                    if (suggestion.valueDeclaration) {
                      ts2.addRelatedInfo(diagnostic, ts2.createDiagnosticForNode(suggestion.valueDeclaration, ts2.Diagnostics._0_is_declared_here, suggestionName));
                    }
                  }
                }
                if (!suggestion) {
                  error(errorLocation, nameNotFoundMessage, diagnosticName(nameArg));
                }
                suggestionCount++;
              }
            }
            return void 0;
          }
          if (nameNotFoundMessage) {
            if (propertyWithInvalidInitializer && !(compilerOptions.target === 99 && compilerOptions.useDefineForClassFields)) {
              var propertyName = propertyWithInvalidInitializer.name;
              error(errorLocation, ts2.Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor, ts2.declarationNameToString(propertyName), diagnosticName(nameArg));
              return void 0;
            }
            if (errorLocation && (meaning & 2 || (meaning & 32 || meaning & 384) && (meaning & 111551) === 111551)) {
              var exportOrLocalSymbol = getExportSymbolOfValueSymbolIfExported(result);
              if (exportOrLocalSymbol.flags & 2 || exportOrLocalSymbol.flags & 32 || exportOrLocalSymbol.flags & 384) {
                checkResolvedBlockScopedVariable(exportOrLocalSymbol, errorLocation);
              }
            }
            if (result && isInExternalModule && (meaning & 111551) === 111551 && !(originalLocation.flags & 4194304)) {
              var merged = getMergedSymbol(result);
              if (ts2.length(merged.declarations) && ts2.every(merged.declarations, function(d) {
                return ts2.isNamespaceExportDeclaration(d) || ts2.isSourceFile(d) && !!d.symbol.globalExports;
              })) {
                errorOrSuggestion(!compilerOptions.allowUmdGlobalAccess, errorLocation, ts2.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead, ts2.unescapeLeadingUnderscores(name));
              }
            }
            if (result && associatedDeclarationForContainingInitializerOrBindingName && !withinDeferredContext && (meaning & 111551) === 111551) {
              var candidate = getMergedSymbol(getLateBoundSymbol(result));
              var root = ts2.getRootDeclaration(associatedDeclarationForContainingInitializerOrBindingName);
              if (candidate === getSymbolOfNode(associatedDeclarationForContainingInitializerOrBindingName)) {
                error(errorLocation, ts2.Diagnostics.Parameter_0_cannot_reference_itself, ts2.declarationNameToString(associatedDeclarationForContainingInitializerOrBindingName.name));
              } else if (candidate.valueDeclaration && candidate.valueDeclaration.pos > associatedDeclarationForContainingInitializerOrBindingName.pos && root.parent.locals && lookup(root.parent.locals, candidate.escapedName, meaning) === candidate) {
                error(errorLocation, ts2.Diagnostics.Parameter_0_cannot_reference_identifier_1_declared_after_it, ts2.declarationNameToString(associatedDeclarationForContainingInitializerOrBindingName.name), ts2.declarationNameToString(errorLocation));
              }
            }
            if (result && errorLocation && meaning & 111551 && result.flags & 2097152) {
              checkSymbolUsageInExpressionContext(result, name, errorLocation);
            }
          }
          return result;
        }
        function checkSymbolUsageInExpressionContext(symbol, name, useSite) {
          if (!ts2.isValidTypeOnlyAliasUseSite(useSite)) {
            var typeOnlyDeclaration = getTypeOnlyAliasDeclaration(symbol);
            if (typeOnlyDeclaration) {
              var isExport = ts2.typeOnlyDeclarationIsExport(typeOnlyDeclaration);
              var message = isExport ? ts2.Diagnostics._0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type : ts2.Diagnostics._0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type;
              var relatedMessage = isExport ? ts2.Diagnostics._0_was_exported_here : ts2.Diagnostics._0_was_imported_here;
              var unescapedName = ts2.unescapeLeadingUnderscores(name);
              ts2.addRelatedInfo(error(useSite, message, unescapedName), ts2.createDiagnosticForNode(typeOnlyDeclaration, relatedMessage, unescapedName));
            }
          }
        }
        function getIsDeferredContext(location, lastLocation) {
          if (location.kind !== 202 && location.kind !== 201) {
            return ts2.isTypeQueryNode(location) || (ts2.isFunctionLikeDeclaration(location) || location.kind === 159 && !ts2.hasModifier(location, 32)) && (!lastLocation || lastLocation !== location.name);
          }
          if (lastLocation && lastLocation === location.name) {
            return false;
          }
          if (location.asteriskToken || ts2.hasModifier(location, 256)) {
            return true;
          }
          return !ts2.getImmediatelyInvokedFunctionExpression(location);
        }
        function isSelfReferenceLocation(node) {
          switch (node.kind) {
            case 244:
            case 245:
            case 246:
            case 248:
            case 247:
            case 249:
              return true;
            default:
              return false;
          }
        }
        function diagnosticName(nameArg) {
          return ts2.isString(nameArg) ? ts2.unescapeLeadingUnderscores(nameArg) : ts2.declarationNameToString(nameArg);
        }
        function isTypeParameterSymbolDeclaredInContainer(symbol, container) {
          for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
            var decl = _a[_i];
            if (decl.kind === 155) {
              var parent = ts2.isJSDocTemplateTag(decl.parent) ? ts2.getJSDocHost(decl.parent) : decl.parent;
              if (parent === container) {
                return !(ts2.isJSDocTemplateTag(decl.parent) && ts2.find(decl.parent.parent.tags, ts2.isJSDocTypeAlias));
              }
            }
          }
          return false;
        }
        function checkAndReportErrorForMissingPrefix(errorLocation, name, nameArg) {
          if (!ts2.isIdentifier(errorLocation) || errorLocation.escapedText !== name || isTypeReferenceIdentifier(errorLocation) || isInTypeQuery(errorLocation)) {
            return false;
          }
          var container = ts2.getThisContainer(errorLocation, false);
          var location = container;
          while (location) {
            if (ts2.isClassLike(location.parent)) {
              var classSymbol = getSymbolOfNode(location.parent);
              if (!classSymbol) {
                break;
              }
              var constructorType = getTypeOfSymbol(classSymbol);
              if (getPropertyOfType(constructorType, name)) {
                error(errorLocation, ts2.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0, diagnosticName(nameArg), symbolToString(classSymbol));
                return true;
              }
              if (location === container && !ts2.hasModifier(location, 32)) {
                var instanceType = getDeclaredTypeOfSymbol(classSymbol).thisType;
                if (getPropertyOfType(instanceType, name)) {
                  error(errorLocation, ts2.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0, diagnosticName(nameArg));
                  return true;
                }
              }
            }
            location = location.parent;
          }
          return false;
        }
        function checkAndReportErrorForExtendingInterface(errorLocation) {
          var expression = getEntityNameForExtendingInterface(errorLocation);
          if (expression && resolveEntityName(expression, 64, true)) {
            error(errorLocation, ts2.Diagnostics.Cannot_extend_an_interface_0_Did_you_mean_implements, ts2.getTextOfNode(expression));
            return true;
          }
          return false;
        }
        function getEntityNameForExtendingInterface(node) {
          switch (node.kind) {
            case 75:
            case 194:
              return node.parent ? getEntityNameForExtendingInterface(node.parent) : void 0;
            case 216:
              if (ts2.isEntityNameExpression(node.expression)) {
                return node.expression;
              }
            default:
              return void 0;
          }
        }
        function checkAndReportErrorForUsingTypeAsNamespace(errorLocation, name, meaning) {
          var namespaceMeaning = 1920 | (ts2.isInJSFile(errorLocation) ? 111551 : 0);
          if (meaning === namespaceMeaning) {
            var symbol = resolveSymbol(resolveName(errorLocation, name, 788968 & ~namespaceMeaning, void 0, void 0, false));
            var parent = errorLocation.parent;
            if (symbol) {
              if (ts2.isQualifiedName(parent)) {
                ts2.Debug.assert(parent.left === errorLocation, "Should only be resolving left side of qualified name as a namespace");
                var propName = parent.right.escapedText;
                var propType = getPropertyOfType(getDeclaredTypeOfSymbol(symbol), propName);
                if (propType) {
                  error(parent, ts2.Diagnostics.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1, ts2.unescapeLeadingUnderscores(name), ts2.unescapeLeadingUnderscores(propName));
                  return true;
                }
              }
              error(errorLocation, ts2.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here, ts2.unescapeLeadingUnderscores(name));
              return true;
            }
          }
          return false;
        }
        function checkAndReportErrorForUsingValueAsType(errorLocation, name, meaning) {
          if (meaning & (788968 & ~1920)) {
            var symbol = resolveSymbol(resolveName(errorLocation, name, ~788968 & 111551, void 0, void 0, false));
            if (symbol && !(symbol.flags & 1920)) {
              error(errorLocation, ts2.Diagnostics._0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0, ts2.unescapeLeadingUnderscores(name));
              return true;
            }
          }
          return false;
        }
        function isPrimitiveTypeName(name) {
          return name === "any" || name === "string" || name === "number" || name === "boolean" || name === "never" || name === "unknown";
        }
        function checkAndReportErrorForExportingPrimitiveType(errorLocation, name) {
          if (isPrimitiveTypeName(name) && errorLocation.parent.kind === 263) {
            error(errorLocation, ts2.Diagnostics.Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module, name);
            return true;
          }
          return false;
        }
        function checkAndReportErrorForUsingTypeAsValue(errorLocation, name, meaning) {
          if (meaning & (111551 & ~1024)) {
            if (isPrimitiveTypeName(name)) {
              error(errorLocation, ts2.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here, ts2.unescapeLeadingUnderscores(name));
              return true;
            }
            var symbol = resolveSymbol(resolveName(errorLocation, name, 788968 & ~111551, void 0, void 0, false));
            if (symbol && !(symbol.flags & 1024)) {
              var message = isES2015OrLaterConstructorName(name) ? ts2.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later : ts2.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here;
              error(errorLocation, message, ts2.unescapeLeadingUnderscores(name));
              return true;
            }
          }
          return false;
        }
        function isES2015OrLaterConstructorName(n) {
          switch (n) {
            case "Promise":
            case "Symbol":
            case "Map":
            case "WeakMap":
            case "Set":
            case "WeakSet":
              return true;
          }
          return false;
        }
        function checkAndReportErrorForUsingNamespaceModuleAsValue(errorLocation, name, meaning) {
          if (meaning & (111551 & ~1024 & ~788968)) {
            var symbol = resolveSymbol(resolveName(errorLocation, name, 1024 & ~111551, void 0, void 0, false));
            if (symbol) {
              error(errorLocation, ts2.Diagnostics.Cannot_use_namespace_0_as_a_value, ts2.unescapeLeadingUnderscores(name));
              return true;
            }
          } else if (meaning & (788968 & ~1024 & ~111551)) {
            var symbol = resolveSymbol(resolveName(errorLocation, name, (512 | 1024) & ~788968, void 0, void 0, false));
            if (symbol) {
              error(errorLocation, ts2.Diagnostics.Cannot_use_namespace_0_as_a_type, ts2.unescapeLeadingUnderscores(name));
              return true;
            }
          }
          return false;
        }
        function checkResolvedBlockScopedVariable(result, errorLocation) {
          ts2.Debug.assert(!!(result.flags & 2 || result.flags & 32 || result.flags & 384));
          if (result.flags & (16 | 1 | 67108864) && result.flags & 32) {
            return;
          }
          var declaration = ts2.find(result.declarations, function(d) {
            return ts2.isBlockOrCatchScoped(d) || ts2.isClassLike(d) || d.kind === 248;
          });
          if (declaration === void 0)
            return ts2.Debug.fail("checkResolvedBlockScopedVariable could not find block-scoped declaration");
          if (!(declaration.flags & 8388608) && !isBlockScopedNameDeclaredBeforeUse(declaration, errorLocation)) {
            var diagnosticMessage = void 0;
            var declarationName = ts2.declarationNameToString(ts2.getNameOfDeclaration(declaration));
            if (result.flags & 2) {
              diagnosticMessage = error(errorLocation, ts2.Diagnostics.Block_scoped_variable_0_used_before_its_declaration, declarationName);
            } else if (result.flags & 32) {
              diagnosticMessage = error(errorLocation, ts2.Diagnostics.Class_0_used_before_its_declaration, declarationName);
            } else if (result.flags & 256) {
              diagnosticMessage = error(errorLocation, ts2.Diagnostics.Enum_0_used_before_its_declaration, declarationName);
            } else {
              ts2.Debug.assert(!!(result.flags & 128));
              if (compilerOptions.preserveConstEnums) {
                diagnosticMessage = error(errorLocation, ts2.Diagnostics.Class_0_used_before_its_declaration, declarationName);
              }
            }
            if (diagnosticMessage) {
              ts2.addRelatedInfo(diagnosticMessage, ts2.createDiagnosticForNode(declaration, ts2.Diagnostics._0_is_declared_here, declarationName));
            }
          }
        }
        function isSameScopeDescendentOf(initial, parent, stopAt) {
          return !!parent && !!ts2.findAncestor(initial, function(n) {
            return n === stopAt || ts2.isFunctionLike(n) ? "quit" : n === parent;
          });
        }
        function getAnyImportSyntax(node) {
          switch (node.kind) {
            case 253:
              return node;
            case 255:
              return node.parent;
            case 256:
              return node.parent.parent;
            case 258:
              return node.parent.parent.parent;
            default:
              return void 0;
          }
        }
        function getDeclarationOfAliasSymbol(symbol) {
          return ts2.find(symbol.declarations, isAliasSymbolDeclaration);
        }
        function isAliasSymbolDeclaration(node) {
          return node.kind === 253 || node.kind === 252 || node.kind === 255 && !!node.name || node.kind === 256 || node.kind === 262 || node.kind === 258 || node.kind === 263 || node.kind === 259 && ts2.exportAssignmentIsAlias(node) || ts2.isBinaryExpression(node) && ts2.getAssignmentDeclarationKind(node) === 2 && ts2.exportAssignmentIsAlias(node) || ts2.isPropertyAccessExpression(node) && ts2.isBinaryExpression(node.parent) && node.parent.left === node && node.parent.operatorToken.kind === 62 && isAliasableOrJsExpression(node.parent.right) || node.kind === 282 || node.kind === 281 && isAliasableOrJsExpression(node.initializer);
        }
        function isAliasableOrJsExpression(e) {
          return ts2.isAliasableExpression(e) || ts2.isFunctionExpression(e) && isJSConstructor(e);
        }
        function getTargetOfImportEqualsDeclaration(node, dontResolveAlias) {
          if (node.moduleReference.kind === 265) {
            var immediate = resolveExternalModuleName(node, ts2.getExternalModuleImportEqualsDeclarationExpression(node));
            var resolved_4 = resolveExternalModuleSymbol(immediate);
            markSymbolOfAliasDeclarationIfTypeOnly(node, immediate, resolved_4, false);
            return resolved_4;
          }
          var resolved = getSymbolOfPartOfRightHandSideOfImportEquals(node.moduleReference, dontResolveAlias);
          checkAndReportErrorForResolvingImportAliasToTypeOnlySymbol(node, resolved);
          return resolved;
        }
        function checkAndReportErrorForResolvingImportAliasToTypeOnlySymbol(node, resolved) {
          if (markSymbolOfAliasDeclarationIfTypeOnly(node, void 0, resolved, false)) {
            var typeOnlyDeclaration = getTypeOnlyAliasDeclaration(getSymbolOfNode(node));
            var isExport = ts2.typeOnlyDeclarationIsExport(typeOnlyDeclaration);
            var message = isExport ? ts2.Diagnostics.An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type : ts2.Diagnostics.An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type;
            var relatedMessage = isExport ? ts2.Diagnostics._0_was_exported_here : ts2.Diagnostics._0_was_imported_here;
            var name = ts2.unescapeLeadingUnderscores(typeOnlyDeclaration.name.escapedText);
            ts2.addRelatedInfo(error(node.moduleReference, message), ts2.createDiagnosticForNode(typeOnlyDeclaration, relatedMessage, name));
          }
        }
        function resolveExportByName(moduleSymbol, name, sourceNode, dontResolveAlias) {
          var exportValue = moduleSymbol.exports.get("export=");
          if (exportValue) {
            return getPropertyOfType(getTypeOfSymbol(exportValue), name);
          }
          var exportSymbol = moduleSymbol.exports.get(name);
          var resolved = resolveSymbol(exportSymbol, dontResolveAlias);
          markSymbolOfAliasDeclarationIfTypeOnly(sourceNode, exportSymbol, resolved, false);
          return resolved;
        }
        function isSyntacticDefault(node) {
          return ts2.isExportAssignment(node) && !node.isExportEquals || ts2.hasModifier(node, 512) || ts2.isExportSpecifier(node);
        }
        function canHaveSyntheticDefault(file, moduleSymbol, dontResolveAlias) {
          if (!allowSyntheticDefaultImports) {
            return false;
          }
          if (!file || file.isDeclarationFile) {
            var defaultExportSymbol = resolveExportByName(moduleSymbol, "default", void 0, true);
            if (defaultExportSymbol && ts2.some(defaultExportSymbol.declarations, isSyntacticDefault)) {
              return false;
            }
            if (resolveExportByName(moduleSymbol, ts2.escapeLeadingUnderscores("__esModule"), void 0, dontResolveAlias)) {
              return false;
            }
            return true;
          }
          if (!ts2.isSourceFileJS(file)) {
            return hasExportAssignmentSymbol(moduleSymbol);
          }
          return !file.externalModuleIndicator && !resolveExportByName(moduleSymbol, ts2.escapeLeadingUnderscores("__esModule"), void 0, dontResolveAlias);
        }
        function getTargetOfImportClause(node, dontResolveAlias) {
          var moduleSymbol = resolveExternalModuleName(node, node.parent.moduleSpecifier);
          if (moduleSymbol) {
            var exportDefaultSymbol = void 0;
            if (ts2.isShorthandAmbientModuleSymbol(moduleSymbol)) {
              exportDefaultSymbol = moduleSymbol;
            } else {
              exportDefaultSymbol = resolveExportByName(moduleSymbol, "default", node, dontResolveAlias);
            }
            var file = ts2.find(moduleSymbol.declarations, ts2.isSourceFile);
            var hasSyntheticDefault = canHaveSyntheticDefault(file, moduleSymbol, dontResolveAlias);
            if (!exportDefaultSymbol && !hasSyntheticDefault) {
              if (hasExportAssignmentSymbol(moduleSymbol)) {
                var compilerOptionName = moduleKind >= ts2.ModuleKind.ES2015 ? "allowSyntheticDefaultImports" : "esModuleInterop";
                var exportEqualsSymbol = moduleSymbol.exports.get("export=");
                var exportAssignment = exportEqualsSymbol.valueDeclaration;
                var err = error(node.name, ts2.Diagnostics.Module_0_can_only_be_default_imported_using_the_1_flag, symbolToString(moduleSymbol), compilerOptionName);
                ts2.addRelatedInfo(err, ts2.createDiagnosticForNode(exportAssignment, ts2.Diagnostics.This_module_is_declared_with_using_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag, compilerOptionName));
              } else {
                reportNonDefaultExport(moduleSymbol, node);
              }
            } else if (hasSyntheticDefault) {
              var resolved = resolveExternalModuleSymbol(moduleSymbol, dontResolveAlias) || resolveSymbol(moduleSymbol, dontResolveAlias);
              markSymbolOfAliasDeclarationIfTypeOnly(node, moduleSymbol, resolved, false);
              return resolved;
            }
            markSymbolOfAliasDeclarationIfTypeOnly(node, exportDefaultSymbol, void 0, false);
            return exportDefaultSymbol;
          }
        }
        function reportNonDefaultExport(moduleSymbol, node) {
          var _a, _b;
          if ((_a = moduleSymbol.exports) === null || _a === void 0 ? void 0 : _a.has(node.symbol.escapedName)) {
            error(node.name, ts2.Diagnostics.Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead, symbolToString(moduleSymbol), symbolToString(node.symbol));
          } else {
            var diagnostic = error(node.name, ts2.Diagnostics.Module_0_has_no_default_export, symbolToString(moduleSymbol));
            var exportStar = (_b = moduleSymbol.exports) === null || _b === void 0 ? void 0 : _b.get("__export");
            if (exportStar) {
              var defaultExport = ts2.find(exportStar.declarations, function(decl) {
                var _a2, _b2;
                return !!(ts2.isExportDeclaration(decl) && decl.moduleSpecifier && ((_b2 = (_a2 = resolveExternalModuleName(decl, decl.moduleSpecifier)) === null || _a2 === void 0 ? void 0 : _a2.exports) === null || _b2 === void 0 ? void 0 : _b2.has("default")));
              });
              if (defaultExport) {
                ts2.addRelatedInfo(diagnostic, ts2.createDiagnosticForNode(defaultExport, ts2.Diagnostics.export_Asterisk_does_not_re_export_a_default));
              }
            }
          }
        }
        function getTargetOfNamespaceImport(node, dontResolveAlias) {
          var moduleSpecifier = node.parent.parent.moduleSpecifier;
          var immediate = resolveExternalModuleName(node, moduleSpecifier);
          var resolved = resolveESModuleSymbol(immediate, moduleSpecifier, dontResolveAlias, false);
          markSymbolOfAliasDeclarationIfTypeOnly(node, immediate, resolved, false);
          return resolved;
        }
        function getTargetOfNamespaceExport(node, dontResolveAlias) {
          var moduleSpecifier = node.parent.moduleSpecifier;
          var immediate = moduleSpecifier && resolveExternalModuleName(node, moduleSpecifier);
          var resolved = moduleSpecifier && resolveESModuleSymbol(immediate, moduleSpecifier, dontResolveAlias, false);
          markSymbolOfAliasDeclarationIfTypeOnly(node, immediate, resolved, false);
          return resolved;
        }
        function combineValueAndTypeSymbols(valueSymbol, typeSymbol) {
          if (valueSymbol === unknownSymbol && typeSymbol === unknownSymbol) {
            return unknownSymbol;
          }
          if (valueSymbol.flags & (788968 | 1920)) {
            return valueSymbol;
          }
          var result = createSymbol(valueSymbol.flags | typeSymbol.flags, valueSymbol.escapedName);
          result.declarations = ts2.deduplicate(ts2.concatenate(valueSymbol.declarations, typeSymbol.declarations), ts2.equateValues);
          result.parent = valueSymbol.parent || typeSymbol.parent;
          if (valueSymbol.valueDeclaration)
            result.valueDeclaration = valueSymbol.valueDeclaration;
          if (typeSymbol.members)
            result.members = ts2.cloneMap(typeSymbol.members);
          if (valueSymbol.exports)
            result.exports = ts2.cloneMap(valueSymbol.exports);
          return result;
        }
        function getExportOfModule(symbol, specifier, dontResolveAlias) {
          var _a;
          if (symbol.flags & 1536) {
            var name = ((_a = specifier.propertyName) !== null && _a !== void 0 ? _a : specifier.name).escapedText;
            var exportSymbol = getExportsOfSymbol(symbol).get(name);
            var resolved = resolveSymbol(exportSymbol, dontResolveAlias);
            markSymbolOfAliasDeclarationIfTypeOnly(specifier, exportSymbol, resolved, false);
            return resolved;
          }
        }
        function getPropertyOfVariable(symbol, name) {
          if (symbol.flags & 3) {
            var typeAnnotation = symbol.valueDeclaration.type;
            if (typeAnnotation) {
              return resolveSymbol(getPropertyOfType(getTypeFromTypeNode(typeAnnotation), name));
            }
          }
        }
        function getExternalModuleMember(node, specifier, dontResolveAlias) {
          var _a;
          if (dontResolveAlias === void 0) {
            dontResolveAlias = false;
          }
          var moduleSymbol = resolveExternalModuleName(node, node.moduleSpecifier);
          var name = specifier.propertyName || specifier.name;
          var suppressInteropError = name.escapedText === "default" && !!(compilerOptions.allowSyntheticDefaultImports || compilerOptions.esModuleInterop);
          var targetSymbol = resolveESModuleSymbol(moduleSymbol, node.moduleSpecifier, dontResolveAlias, suppressInteropError);
          if (targetSymbol) {
            if (name.escapedText) {
              if (ts2.isShorthandAmbientModuleSymbol(moduleSymbol)) {
                return moduleSymbol;
              }
              var symbolFromVariable = void 0;
              if (moduleSymbol && moduleSymbol.exports && moduleSymbol.exports.get("export=")) {
                symbolFromVariable = getPropertyOfType(getTypeOfSymbol(targetSymbol), name.escapedText);
              } else {
                symbolFromVariable = getPropertyOfVariable(targetSymbol, name.escapedText);
              }
              symbolFromVariable = resolveSymbol(symbolFromVariable, dontResolveAlias);
              var symbolFromModule = getExportOfModule(targetSymbol, specifier, dontResolveAlias);
              if (symbolFromModule === void 0 && name.escapedText === "default") {
                var file = ts2.find(moduleSymbol.declarations, ts2.isSourceFile);
                if (canHaveSyntheticDefault(file, moduleSymbol, dontResolveAlias)) {
                  symbolFromModule = resolveExternalModuleSymbol(moduleSymbol, dontResolveAlias) || resolveSymbol(moduleSymbol, dontResolveAlias);
                }
              }
              var symbol = symbolFromModule && symbolFromVariable && symbolFromModule !== symbolFromVariable ? combineValueAndTypeSymbols(symbolFromVariable, symbolFromModule) : symbolFromModule || symbolFromVariable;
              if (!symbol) {
                var moduleName = getFullyQualifiedName(moduleSymbol, node);
                var declarationName = ts2.declarationNameToString(name);
                var suggestion = getSuggestedSymbolForNonexistentModule(name, targetSymbol);
                if (suggestion !== void 0) {
                  var suggestionName = symbolToString(suggestion);
                  var diagnostic = error(name, ts2.Diagnostics.Module_0_has_no_exported_member_1_Did_you_mean_2, moduleName, declarationName, suggestionName);
                  if (suggestion.valueDeclaration) {
                    ts2.addRelatedInfo(diagnostic, ts2.createDiagnosticForNode(suggestion.valueDeclaration, ts2.Diagnostics._0_is_declared_here, suggestionName));
                  }
                } else {
                  if ((_a = moduleSymbol.exports) === null || _a === void 0 ? void 0 : _a.has("default")) {
                    error(name, ts2.Diagnostics.Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead, moduleName, declarationName);
                  } else {
                    reportNonExportedMember(node, name, declarationName, moduleSymbol, moduleName);
                  }
                }
              }
              return symbol;
            }
          }
        }
        function reportNonExportedMember(node, name, declarationName, moduleSymbol, moduleName) {
          var _a;
          var localSymbol = (_a = moduleSymbol.valueDeclaration.locals) === null || _a === void 0 ? void 0 : _a.get(name.escapedText);
          var exports2 = moduleSymbol.exports;
          if (localSymbol) {
            var exportedEqualsSymbol = exports2 === null || exports2 === void 0 ? void 0 : exports2.get("export=");
            if (exportedEqualsSymbol) {
              getSymbolIfSameReference(exportedEqualsSymbol, localSymbol) ? reportInvalidImportEqualsExportMember(node, name, declarationName, moduleName) : error(name, ts2.Diagnostics.Module_0_has_no_exported_member_1, moduleName, declarationName);
            } else {
              var exportedSymbol = exports2 ? ts2.find(symbolsToArray(exports2), function(symbol) {
                return !!getSymbolIfSameReference(symbol, localSymbol);
              }) : void 0;
              var diagnostic = exportedSymbol ? error(name, ts2.Diagnostics.Module_0_declares_1_locally_but_it_is_exported_as_2, moduleName, declarationName, symbolToString(exportedSymbol)) : error(name, ts2.Diagnostics.Module_0_declares_1_locally_but_it_is_not_exported, moduleName, declarationName);
              ts2.addRelatedInfo.apply(void 0, __spreadArrays([diagnostic], ts2.map(localSymbol.declarations, function(decl, index) {
                return ts2.createDiagnosticForNode(decl, index === 0 ? ts2.Diagnostics._0_is_declared_here : ts2.Diagnostics.and_here, declarationName);
              })));
            }
          } else {
            error(name, ts2.Diagnostics.Module_0_has_no_exported_member_1, moduleName, declarationName);
          }
        }
        function reportInvalidImportEqualsExportMember(node, name, declarationName, moduleName) {
          if (moduleKind >= ts2.ModuleKind.ES2015) {
            var message = compilerOptions.esModuleInterop ? ts2.Diagnostics._0_can_only_be_imported_by_using_a_default_import : ts2.Diagnostics._0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;
            error(name, message, declarationName);
          } else {
            if (ts2.isInJSFile(node)) {
              var message = compilerOptions.esModuleInterop ? ts2.Diagnostics._0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import : ts2.Diagnostics._0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;
              error(name, message, declarationName);
            } else {
              var message = compilerOptions.esModuleInterop ? ts2.Diagnostics._0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import : ts2.Diagnostics._0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;
              error(name, message, declarationName, declarationName, moduleName);
            }
          }
        }
        function getTargetOfImportSpecifier(node, dontResolveAlias) {
          var resolved = getExternalModuleMember(node.parent.parent.parent, node, dontResolveAlias);
          markSymbolOfAliasDeclarationIfTypeOnly(node, void 0, resolved, false);
          return resolved;
        }
        function getTargetOfNamespaceExportDeclaration(node, dontResolveAlias) {
          var resolved = resolveExternalModuleSymbol(node.parent.symbol, dontResolveAlias);
          markSymbolOfAliasDeclarationIfTypeOnly(node, void 0, resolved, false);
          return resolved;
        }
        function getTargetOfExportSpecifier(node, meaning, dontResolveAlias) {
          var resolved = node.parent.parent.moduleSpecifier ? getExternalModuleMember(node.parent.parent, node, dontResolveAlias) : resolveEntityName(node.propertyName || node.name, meaning, false, dontResolveAlias);
          markSymbolOfAliasDeclarationIfTypeOnly(node, void 0, resolved, false);
          return resolved;
        }
        function getTargetOfExportAssignment(node, dontResolveAlias) {
          var expression = ts2.isExportAssignment(node) ? node.expression : node.right;
          var resolved = getTargetOfAliasLikeExpression(expression, dontResolveAlias);
          markSymbolOfAliasDeclarationIfTypeOnly(node, void 0, resolved, false);
          return resolved;
        }
        function getTargetOfAliasLikeExpression(expression, dontResolveAlias) {
          if (ts2.isClassExpression(expression)) {
            return checkExpressionCached(expression).symbol;
          }
          if (!ts2.isEntityName(expression) && !ts2.isEntityNameExpression(expression)) {
            return void 0;
          }
          var aliasLike = resolveEntityName(expression, 111551 | 788968 | 1920, true, dontResolveAlias);
          if (aliasLike) {
            return aliasLike;
          }
          checkExpressionCached(expression);
          return getNodeLinks(expression).resolvedSymbol;
        }
        function getTargetOfPropertyAssignment(node, dontRecursivelyResolve) {
          var expression = node.initializer;
          return getTargetOfAliasLikeExpression(expression, dontRecursivelyResolve);
        }
        function getTargetOfPropertyAccessExpression(node, dontRecursivelyResolve) {
          if (!(ts2.isBinaryExpression(node.parent) && node.parent.left === node && node.parent.operatorToken.kind === 62)) {
            return void 0;
          }
          return getTargetOfAliasLikeExpression(node.parent.right, dontRecursivelyResolve);
        }
        function getTargetOfAliasDeclaration(node, dontRecursivelyResolve) {
          if (dontRecursivelyResolve === void 0) {
            dontRecursivelyResolve = false;
          }
          switch (node.kind) {
            case 253:
              return getTargetOfImportEqualsDeclaration(node, dontRecursivelyResolve);
            case 255:
              return getTargetOfImportClause(node, dontRecursivelyResolve);
            case 256:
              return getTargetOfNamespaceImport(node, dontRecursivelyResolve);
            case 262:
              return getTargetOfNamespaceExport(node, dontRecursivelyResolve);
            case 258:
              return getTargetOfImportSpecifier(node, dontRecursivelyResolve);
            case 263:
              return getTargetOfExportSpecifier(node, 111551 | 788968 | 1920, dontRecursivelyResolve);
            case 259:
            case 209:
              return getTargetOfExportAssignment(node, dontRecursivelyResolve);
            case 252:
              return getTargetOfNamespaceExportDeclaration(node, dontRecursivelyResolve);
            case 282:
              return resolveEntityName(node.name, 111551 | 788968 | 1920, true, dontRecursivelyResolve);
            case 281:
              return getTargetOfPropertyAssignment(node, dontRecursivelyResolve);
            case 194:
              return getTargetOfPropertyAccessExpression(node, dontRecursivelyResolve);
            default:
              return ts2.Debug.fail();
          }
        }
        function isNonLocalAlias(symbol, excludes) {
          if (excludes === void 0) {
            excludes = 111551 | 788968 | 1920;
          }
          if (!symbol)
            return false;
          return (symbol.flags & (2097152 | excludes)) === 2097152 || !!(symbol.flags & 2097152 && symbol.flags & 67108864);
        }
        function resolveSymbol(symbol, dontResolveAlias) {
          return !dontResolveAlias && isNonLocalAlias(symbol) ? resolveAlias(symbol) : symbol;
        }
        function resolveAlias(symbol) {
          ts2.Debug.assert((symbol.flags & 2097152) !== 0, "Should only get Alias here.");
          var links = getSymbolLinks(symbol);
          if (!links.target) {
            links.target = resolvingSymbol;
            var node = getDeclarationOfAliasSymbol(symbol);
            if (!node)
              return ts2.Debug.fail();
            var target = getTargetOfAliasDeclaration(node);
            if (links.target === resolvingSymbol) {
              links.target = target || unknownSymbol;
            } else {
              error(node, ts2.Diagnostics.Circular_definition_of_import_alias_0, symbolToString(symbol));
            }
          } else if (links.target === resolvingSymbol) {
            links.target = unknownSymbol;
          }
          return links.target;
        }
        function tryResolveAlias(symbol) {
          var links = getSymbolLinks(symbol);
          if (links.target !== resolvingSymbol) {
            return resolveAlias(symbol);
          }
          return void 0;
        }
        function markSymbolOfAliasDeclarationIfTypeOnly(aliasDeclaration, immediateTarget, finalTarget, overwriteEmpty) {
          if (!aliasDeclaration)
            return false;
          var sourceSymbol = getSymbolOfNode(aliasDeclaration);
          if (ts2.isTypeOnlyImportOrExportDeclaration(aliasDeclaration)) {
            var links_1 = getSymbolLinks(sourceSymbol);
            links_1.typeOnlyDeclaration = aliasDeclaration;
            return true;
          }
          var links = getSymbolLinks(sourceSymbol);
          return markSymbolOfAliasDeclarationIfTypeOnlyWorker(links, immediateTarget, overwriteEmpty) || markSymbolOfAliasDeclarationIfTypeOnlyWorker(links, finalTarget, overwriteEmpty);
        }
        function markSymbolOfAliasDeclarationIfTypeOnlyWorker(aliasDeclarationLinks, target, overwriteEmpty) {
          var _a, _b, _c;
          if (target && (aliasDeclarationLinks.typeOnlyDeclaration === void 0 || overwriteEmpty && aliasDeclarationLinks.typeOnlyDeclaration === false)) {
            var exportSymbol = (_b = (_a = target.exports) === null || _a === void 0 ? void 0 : _a.get("export=")) !== null && _b !== void 0 ? _b : target;
            var typeOnly = exportSymbol.declarations && ts2.find(exportSymbol.declarations, ts2.isTypeOnlyImportOrExportDeclaration);
            aliasDeclarationLinks.typeOnlyDeclaration = (_c = typeOnly !== null && typeOnly !== void 0 ? typeOnly : getSymbolLinks(exportSymbol).typeOnlyDeclaration) !== null && _c !== void 0 ? _c : false;
          }
          return !!aliasDeclarationLinks.typeOnlyDeclaration;
        }
        function getTypeOnlyAliasDeclaration(symbol) {
          if (!(symbol.flags & 2097152)) {
            return void 0;
          }
          var links = getSymbolLinks(symbol);
          return links.typeOnlyDeclaration || void 0;
        }
        function markExportAsReferenced(node) {
          var symbol = getSymbolOfNode(node);
          var target = resolveAlias(symbol);
          if (target) {
            var markAlias = target === unknownSymbol || target.flags & 111551 && !isConstEnumOrConstEnumOnlyModule(target) && !getTypeOnlyAliasDeclaration(symbol);
            if (markAlias) {
              markAliasSymbolAsReferenced(symbol);
            }
          }
        }
        function markAliasSymbolAsReferenced(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.referenced) {
            links.referenced = true;
            var node = getDeclarationOfAliasSymbol(symbol);
            if (!node)
              return ts2.Debug.fail();
            if (ts2.isInternalModuleImportEqualsDeclaration(node)) {
              var target = resolveSymbol(symbol);
              if (target === unknownSymbol || target.flags & 111551) {
                checkExpressionCached(node.moduleReference);
              }
            }
          }
        }
        function markConstEnumAliasAsReferenced(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.constEnumReferenced) {
            links.constEnumReferenced = true;
          }
        }
        function getSymbolOfPartOfRightHandSideOfImportEquals(entityName, dontResolveAlias) {
          if (entityName.kind === 75 && ts2.isRightSideOfQualifiedNameOrPropertyAccess(entityName)) {
            entityName = entityName.parent;
          }
          if (entityName.kind === 75 || entityName.parent.kind === 153) {
            return resolveEntityName(entityName, 1920, false, dontResolveAlias);
          } else {
            ts2.Debug.assert(entityName.parent.kind === 253);
            return resolveEntityName(entityName, 111551 | 788968 | 1920, false, dontResolveAlias);
          }
        }
        function getFullyQualifiedName(symbol, containingLocation) {
          return symbol.parent ? getFullyQualifiedName(symbol.parent, containingLocation) + "." + symbolToString(symbol) : symbolToString(symbol, containingLocation, void 0, 16 | 4);
        }
        function resolveEntityName(name, meaning, ignoreErrors, dontResolveAlias, location) {
          if (ts2.nodeIsMissing(name)) {
            return void 0;
          }
          var namespaceMeaning = 1920 | (ts2.isInJSFile(name) ? meaning & 111551 : 0);
          var symbol;
          if (name.kind === 75) {
            var message = meaning === namespaceMeaning || ts2.nodeIsSynthesized(name) ? ts2.Diagnostics.Cannot_find_namespace_0 : getCannotFindNameDiagnosticForName(ts2.getFirstIdentifier(name));
            var symbolFromJSPrototype = ts2.isInJSFile(name) && !ts2.nodeIsSynthesized(name) ? resolveEntityNameFromAssignmentDeclaration(name, meaning) : void 0;
            symbol = getMergedSymbol(resolveName(location || name, name.escapedText, meaning, ignoreErrors || symbolFromJSPrototype ? void 0 : message, name, true));
            if (!symbol) {
              return getMergedSymbol(symbolFromJSPrototype);
            }
          } else if (name.kind === 153 || name.kind === 194) {
            var left = name.kind === 153 ? name.left : name.expression;
            var right = name.kind === 153 ? name.right : name.name;
            var namespace = resolveEntityName(left, namespaceMeaning, ignoreErrors, false, location);
            if (!namespace || ts2.nodeIsMissing(right)) {
              return void 0;
            } else if (namespace === unknownSymbol) {
              return namespace;
            }
            if (ts2.isInJSFile(name)) {
              if (namespace.valueDeclaration && ts2.isVariableDeclaration(namespace.valueDeclaration) && namespace.valueDeclaration.initializer && isCommonJsRequire(namespace.valueDeclaration.initializer)) {
                var moduleName = namespace.valueDeclaration.initializer.arguments[0];
                var moduleSym = resolveExternalModuleName(moduleName, moduleName);
                if (moduleSym) {
                  var resolvedModuleSymbol = resolveExternalModuleSymbol(moduleSym);
                  if (resolvedModuleSymbol) {
                    namespace = resolvedModuleSymbol;
                  }
                }
              }
            }
            symbol = getMergedSymbol(getSymbol(getExportsOfSymbol(namespace), right.escapedText, meaning));
            if (!symbol) {
              if (!ignoreErrors) {
                error(right, ts2.Diagnostics.Namespace_0_has_no_exported_member_1, getFullyQualifiedName(namespace), ts2.declarationNameToString(right));
              }
              return void 0;
            }
          } else {
            throw ts2.Debug.assertNever(name, "Unknown entity name kind.");
          }
          ts2.Debug.assert((ts2.getCheckFlags(symbol) & 1) === 0, "Should never get an instantiated symbol here.");
          if (!ts2.nodeIsSynthesized(name) && ts2.isEntityName(name) && (symbol.flags & 2097152 || name.parent.kind === 259)) {
            markSymbolOfAliasDeclarationIfTypeOnly(ts2.getAliasDeclarationFromName(name), symbol, void 0, true);
          }
          return symbol.flags & meaning || dontResolveAlias ? symbol : resolveAlias(symbol);
        }
        function resolveEntityNameFromAssignmentDeclaration(name, meaning) {
          if (isJSDocTypeReference(name.parent)) {
            var secondaryLocation = getAssignmentDeclarationLocation(name.parent);
            if (secondaryLocation) {
              return resolveName(secondaryLocation, name.escapedText, meaning, void 0, name, true);
            }
          }
        }
        function getAssignmentDeclarationLocation(node) {
          var typeAlias = ts2.findAncestor(node, function(node2) {
            return !(ts2.isJSDocNode(node2) || node2.flags & 4194304) ? "quit" : ts2.isJSDocTypeAlias(node2);
          });
          if (typeAlias) {
            return;
          }
          var host2 = ts2.getJSDocHost(node);
          if (ts2.isExpressionStatement(host2) && ts2.isBinaryExpression(host2.expression) && ts2.getAssignmentDeclarationKind(host2.expression) === 3) {
            var symbol = getSymbolOfNode(host2.expression.left);
            if (symbol) {
              return getDeclarationOfJSPrototypeContainer(symbol);
            }
          }
          if ((ts2.isObjectLiteralMethod(host2) || ts2.isPropertyAssignment(host2)) && ts2.isBinaryExpression(host2.parent.parent) && ts2.getAssignmentDeclarationKind(host2.parent.parent) === 6) {
            var symbol = getSymbolOfNode(host2.parent.parent.left);
            if (symbol) {
              return getDeclarationOfJSPrototypeContainer(symbol);
            }
          }
          var sig = ts2.getEffectiveJSDocHost(node);
          if (sig && ts2.isFunctionLike(sig)) {
            var symbol = getSymbolOfNode(sig);
            return symbol && symbol.valueDeclaration;
          }
        }
        function getDeclarationOfJSPrototypeContainer(symbol) {
          var decl = symbol.parent.valueDeclaration;
          if (!decl) {
            return void 0;
          }
          var initializer = ts2.isAssignmentDeclaration(decl) ? ts2.getAssignedExpandoInitializer(decl) : ts2.hasOnlyExpressionInitializer(decl) ? ts2.getDeclaredExpandoInitializer(decl) : void 0;
          return initializer || decl;
        }
        function getExpandoSymbol(symbol) {
          var decl = symbol.valueDeclaration;
          if (!decl || !ts2.isInJSFile(decl) || symbol.flags & 524288 || ts2.getExpandoInitializer(decl, false)) {
            return void 0;
          }
          var init = ts2.isVariableDeclaration(decl) ? ts2.getDeclaredExpandoInitializer(decl) : ts2.getAssignedExpandoInitializer(decl);
          if (init) {
            var initSymbol = getSymbolOfNode(init);
            if (initSymbol) {
              return mergeJSSymbols(initSymbol, symbol);
            }
          }
        }
        function resolveExternalModuleName(location, moduleReferenceExpression, ignoreErrors) {
          return resolveExternalModuleNameWorker(location, moduleReferenceExpression, ignoreErrors ? void 0 : ts2.Diagnostics.Cannot_find_module_0_or_its_corresponding_type_declarations);
        }
        function resolveExternalModuleNameWorker(location, moduleReferenceExpression, moduleNotFoundError, isForAugmentation) {
          if (isForAugmentation === void 0) {
            isForAugmentation = false;
          }
          return ts2.isStringLiteralLike(moduleReferenceExpression) ? resolveExternalModule(location, moduleReferenceExpression.text, moduleNotFoundError, moduleReferenceExpression, isForAugmentation) : void 0;
        }
        function resolveExternalModule(location, moduleReference, moduleNotFoundError, errorNode, isForAugmentation) {
          if (isForAugmentation === void 0) {
            isForAugmentation = false;
          }
          if (ts2.startsWith(moduleReference, "@types/")) {
            var diag = ts2.Diagnostics.Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1;
            var withoutAtTypePrefix = ts2.removePrefix(moduleReference, "@types/");
            error(errorNode, diag, withoutAtTypePrefix, moduleReference);
          }
          var ambientModule = tryFindAmbientModule(moduleReference, true);
          if (ambientModule) {
            return ambientModule;
          }
          var currentSourceFile = ts2.getSourceFileOfNode(location);
          var resolvedModule = ts2.getResolvedModule(currentSourceFile, moduleReference);
          var resolutionDiagnostic = resolvedModule && ts2.getResolutionDiagnostic(compilerOptions, resolvedModule);
          var sourceFile = resolvedModule && !resolutionDiagnostic && host.getSourceFile(resolvedModule.resolvedFileName);
          if (sourceFile) {
            if (sourceFile.symbol) {
              if (resolvedModule.isExternalLibraryImport && !ts2.resolutionExtensionIsTSOrJson(resolvedModule.extension)) {
                errorOnImplicitAnyModule(false, errorNode, resolvedModule, moduleReference);
              }
              return getMergedSymbol(sourceFile.symbol);
            }
            if (moduleNotFoundError) {
              error(errorNode, ts2.Diagnostics.File_0_is_not_a_module, sourceFile.fileName);
            }
            return void 0;
          }
          if (patternAmbientModules) {
            var pattern = ts2.findBestPatternMatch(patternAmbientModules, function(_) {
              return _.pattern;
            }, moduleReference);
            if (pattern) {
              var augmentation = patternAmbientModuleAugmentations && patternAmbientModuleAugmentations.get(moduleReference);
              if (augmentation) {
                return getMergedSymbol(augmentation);
              }
              return getMergedSymbol(pattern.symbol);
            }
          }
          if (resolvedModule && !ts2.resolutionExtensionIsTSOrJson(resolvedModule.extension) && resolutionDiagnostic === void 0 || resolutionDiagnostic === ts2.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type) {
            if (isForAugmentation) {
              var diag = ts2.Diagnostics.Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augmented;
              error(errorNode, diag, moduleReference, resolvedModule.resolvedFileName);
            } else {
              errorOnImplicitAnyModule(noImplicitAny && !!moduleNotFoundError, errorNode, resolvedModule, moduleReference);
            }
            return void 0;
          }
          if (moduleNotFoundError) {
            if (resolvedModule) {
              var redirect = host.getProjectReferenceRedirect(resolvedModule.resolvedFileName);
              if (redirect) {
                error(errorNode, ts2.Diagnostics.Output_file_0_has_not_been_built_from_source_file_1, redirect, resolvedModule.resolvedFileName);
                return void 0;
              }
            }
            if (resolutionDiagnostic) {
              error(errorNode, resolutionDiagnostic, moduleReference, resolvedModule.resolvedFileName);
            } else {
              var tsExtension = ts2.tryExtractTSExtension(moduleReference);
              if (tsExtension) {
                var diag = ts2.Diagnostics.An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead;
                error(errorNode, diag, tsExtension, ts2.removeExtension(moduleReference, tsExtension));
              } else if (!compilerOptions.resolveJsonModule && ts2.fileExtensionIs(moduleReference, ".json") && ts2.getEmitModuleResolutionKind(compilerOptions) === ts2.ModuleResolutionKind.NodeJs && ts2.hasJsonModuleEmitEnabled(compilerOptions)) {
                error(errorNode, ts2.Diagnostics.Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension, moduleReference);
              } else {
                error(errorNode, moduleNotFoundError, moduleReference);
              }
            }
          }
          return void 0;
        }
        function errorOnImplicitAnyModule(isError, errorNode, _a, moduleReference) {
          var packageId = _a.packageId, resolvedFileName = _a.resolvedFileName;
          var errorInfo = !ts2.isExternalModuleNameRelative(moduleReference) && packageId ? typesPackageExists(packageId.name) ? ts2.chainDiagnosticMessages(void 0, ts2.Diagnostics.If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_Slash_Slashgithub_com_SlashDefinitelyTyped_SlashDefinitelyTyped_Slashtree_Slashmaster_Slashtypes_Slash_1, packageId.name, ts2.mangleScopedPackageName(packageId.name)) : ts2.chainDiagnosticMessages(void 0, ts2.Diagnostics.Try_npm_install_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_module_0, moduleReference, ts2.mangleScopedPackageName(packageId.name)) : void 0;
          errorOrSuggestion(isError, errorNode, ts2.chainDiagnosticMessages(errorInfo, ts2.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type, moduleReference, resolvedFileName));
        }
        function typesPackageExists(packageName) {
          return getPackagesSet().has(ts2.getTypesPackageName(packageName));
        }
        function resolveExternalModuleSymbol(moduleSymbol, dontResolveAlias) {
          if (moduleSymbol === null || moduleSymbol === void 0 ? void 0 : moduleSymbol.exports) {
            var exportEquals = resolveSymbol(moduleSymbol.exports.get("export="), dontResolveAlias);
            var exported = getCommonJsExportEquals(getMergedSymbol(exportEquals), getMergedSymbol(moduleSymbol));
            return getMergedSymbol(exported) || moduleSymbol;
          }
          return void 0;
        }
        function getCommonJsExportEquals(exported, moduleSymbol) {
          if (!exported || exported === unknownSymbol || exported === moduleSymbol || moduleSymbol.exports.size === 1 || exported.flags & 2097152) {
            return exported;
          }
          var links = getSymbolLinks(exported);
          if (links.cjsExportMerged) {
            return links.cjsExportMerged;
          }
          var merged = exported.flags & 33554432 ? exported : cloneSymbol(exported);
          merged.flags = merged.flags | 512;
          if (merged.exports === void 0) {
            merged.exports = ts2.createSymbolTable();
          }
          moduleSymbol.exports.forEach(function(s, name) {
            if (name === "export=")
              return;
            merged.exports.set(name, merged.exports.has(name) ? mergeSymbol(merged.exports.get(name), s) : s);
          });
          getSymbolLinks(merged).cjsExportMerged = merged;
          return links.cjsExportMerged = merged;
        }
        function resolveESModuleSymbol(moduleSymbol, referencingLocation, dontResolveAlias, suppressInteropError) {
          var symbol = resolveExternalModuleSymbol(moduleSymbol, dontResolveAlias);
          if (!dontResolveAlias && symbol) {
            if (!suppressInteropError && !(symbol.flags & (1536 | 3)) && !ts2.getDeclarationOfKind(symbol, 290)) {
              var compilerOptionName = moduleKind >= ts2.ModuleKind.ES2015 ? "allowSyntheticDefaultImports" : "esModuleInterop";
              error(referencingLocation, ts2.Diagnostics.This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_referencing_its_default_export, compilerOptionName);
              return symbol;
            }
            if (compilerOptions.esModuleInterop) {
              var referenceParent = referencingLocation.parent;
              if (ts2.isImportDeclaration(referenceParent) && ts2.getNamespaceDeclarationNode(referenceParent) || ts2.isImportCall(referenceParent)) {
                var type = getTypeOfSymbol(symbol);
                var sigs = getSignaturesOfStructuredType(type, 0);
                if (!sigs || !sigs.length) {
                  sigs = getSignaturesOfStructuredType(type, 1);
                }
                if (sigs && sigs.length) {
                  var moduleType = getTypeWithSyntheticDefaultImportType(type, symbol, moduleSymbol);
                  var result = createSymbol(symbol.flags, symbol.escapedName);
                  result.declarations = symbol.declarations ? symbol.declarations.slice() : [];
                  result.parent = symbol.parent;
                  result.target = symbol;
                  result.originatingImport = referenceParent;
                  if (symbol.valueDeclaration)
                    result.valueDeclaration = symbol.valueDeclaration;
                  if (symbol.constEnumOnlyModule)
                    result.constEnumOnlyModule = true;
                  if (symbol.members)
                    result.members = ts2.cloneMap(symbol.members);
                  if (symbol.exports)
                    result.exports = ts2.cloneMap(symbol.exports);
                  var resolvedModuleType = resolveStructuredTypeMembers(moduleType);
                  result.type = createAnonymousType(result, resolvedModuleType.members, ts2.emptyArray, ts2.emptyArray, resolvedModuleType.stringIndexInfo, resolvedModuleType.numberIndexInfo);
                  return result;
                }
              }
            }
          }
          return symbol;
        }
        function hasExportAssignmentSymbol(moduleSymbol) {
          return moduleSymbol.exports.get("export=") !== void 0;
        }
        function getExportsOfModuleAsArray(moduleSymbol) {
          return symbolsToArray(getExportsOfModule(moduleSymbol));
        }
        function getExportsAndPropertiesOfModule(moduleSymbol) {
          var exports2 = getExportsOfModuleAsArray(moduleSymbol);
          var exportEquals = resolveExternalModuleSymbol(moduleSymbol);
          if (exportEquals !== moduleSymbol) {
            ts2.addRange(exports2, getPropertiesOfType(getTypeOfSymbol(exportEquals)));
          }
          return exports2;
        }
        function tryGetMemberInModuleExports(memberName, moduleSymbol) {
          var symbolTable = getExportsOfModule(moduleSymbol);
          if (symbolTable) {
            return symbolTable.get(memberName);
          }
        }
        function tryGetMemberInModuleExportsAndProperties(memberName, moduleSymbol) {
          var symbol = tryGetMemberInModuleExports(memberName, moduleSymbol);
          if (symbol) {
            return symbol;
          }
          var exportEquals = resolveExternalModuleSymbol(moduleSymbol);
          if (exportEquals === moduleSymbol) {
            return void 0;
          }
          var type = getTypeOfSymbol(exportEquals);
          return type.flags & 131068 || ts2.getObjectFlags(type) & 1 || isArrayOrTupleLikeType(type) ? void 0 : getPropertyOfType(type, memberName);
        }
        function getExportsOfSymbol(symbol) {
          return symbol.flags & 6256 ? getResolvedMembersOrExportsOfSymbol(symbol, "resolvedExports") : symbol.flags & 1536 ? getExportsOfModule(symbol) : symbol.exports || emptySymbols;
        }
        function getExportsOfModule(moduleSymbol) {
          var links = getSymbolLinks(moduleSymbol);
          return links.resolvedExports || (links.resolvedExports = getExportsOfModuleWorker(moduleSymbol));
        }
        function extendExportSymbols(target, source, lookupTable, exportNode) {
          if (!source)
            return;
          source.forEach(function(sourceSymbol, id) {
            if (id === "default")
              return;
            var targetSymbol = target.get(id);
            if (!targetSymbol) {
              target.set(id, sourceSymbol);
              if (lookupTable && exportNode) {
                lookupTable.set(id, {
                  specifierText: ts2.getTextOfNode(exportNode.moduleSpecifier)
                });
              }
            } else if (lookupTable && exportNode && targetSymbol && resolveSymbol(targetSymbol) !== resolveSymbol(sourceSymbol)) {
              var collisionTracker = lookupTable.get(id);
              if (!collisionTracker.exportsWithDuplicate) {
                collisionTracker.exportsWithDuplicate = [exportNode];
              } else {
                collisionTracker.exportsWithDuplicate.push(exportNode);
              }
            }
          });
        }
        function getExportsOfModuleWorker(moduleSymbol) {
          var visitedSymbols = [];
          moduleSymbol = resolveExternalModuleSymbol(moduleSymbol);
          return visit(moduleSymbol) || emptySymbols;
          function visit(symbol) {
            if (!(symbol && symbol.exports && ts2.pushIfUnique(visitedSymbols, symbol))) {
              return;
            }
            var symbols = ts2.cloneMap(symbol.exports);
            var exportStars = symbol.exports.get("__export");
            if (exportStars) {
              var nestedSymbols = ts2.createSymbolTable();
              var lookupTable_1 = ts2.createMap();
              for (var _i = 0, _a = exportStars.declarations; _i < _a.length; _i++) {
                var node = _a[_i];
                var resolvedModule = resolveExternalModuleName(node, node.moduleSpecifier);
                var exportedSymbols = visit(resolvedModule);
                extendExportSymbols(nestedSymbols, exportedSymbols, lookupTable_1, node);
              }
              lookupTable_1.forEach(function(_a2, id) {
                var exportsWithDuplicate = _a2.exportsWithDuplicate;
                if (id === "export=" || !(exportsWithDuplicate && exportsWithDuplicate.length) || symbols.has(id)) {
                  return;
                }
                for (var _i2 = 0, exportsWithDuplicate_1 = exportsWithDuplicate; _i2 < exportsWithDuplicate_1.length; _i2++) {
                  var node2 = exportsWithDuplicate_1[_i2];
                  diagnostics.add(ts2.createDiagnosticForNode(node2, ts2.Diagnostics.Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity, lookupTable_1.get(id).specifierText, ts2.unescapeLeadingUnderscores(id)));
                }
              });
              extendExportSymbols(symbols, nestedSymbols);
            }
            return symbols;
          }
        }
        function getMergedSymbol(symbol) {
          var merged;
          return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
        }
        function getSymbolOfNode(node) {
          return getMergedSymbol(node.symbol && getLateBoundSymbol(node.symbol));
        }
        function getParentOfSymbol(symbol) {
          return getMergedSymbol(symbol.parent && getLateBoundSymbol(symbol.parent));
        }
        function getAlternativeContainingModules(symbol, enclosingDeclaration) {
          var containingFile = ts2.getSourceFileOfNode(enclosingDeclaration);
          var id = "" + getNodeId(containingFile);
          var links = getSymbolLinks(symbol);
          var results;
          if (links.extendedContainersByFile && (results = links.extendedContainersByFile.get(id))) {
            return results;
          }
          if (containingFile && containingFile.imports) {
            for (var _i = 0, _a = containingFile.imports; _i < _a.length; _i++) {
              var importRef = _a[_i];
              if (ts2.nodeIsSynthesized(importRef))
                continue;
              var resolvedModule = resolveExternalModuleName(enclosingDeclaration, importRef, true);
              if (!resolvedModule)
                continue;
              var ref = getAliasForSymbolInContainer(resolvedModule, symbol);
              if (!ref)
                continue;
              results = ts2.append(results, resolvedModule);
            }
            if (ts2.length(results)) {
              (links.extendedContainersByFile || (links.extendedContainersByFile = ts2.createMap())).set(id, results);
              return results;
            }
          }
          if (links.extendedContainers) {
            return links.extendedContainers;
          }
          var otherFiles = host.getSourceFiles();
          for (var _b = 0, otherFiles_1 = otherFiles; _b < otherFiles_1.length; _b++) {
            var file = otherFiles_1[_b];
            if (!ts2.isExternalModule(file))
              continue;
            var sym = getSymbolOfNode(file);
            var ref = getAliasForSymbolInContainer(sym, symbol);
            if (!ref)
              continue;
            results = ts2.append(results, sym);
          }
          return links.extendedContainers = results || ts2.emptyArray;
        }
        function getContainersOfSymbol(symbol, enclosingDeclaration) {
          var container = getParentOfSymbol(symbol);
          if (container && !(symbol.flags & 262144)) {
            var additionalContainers = ts2.mapDefined(container.declarations, fileSymbolIfFileSymbolExportEqualsContainer);
            var reexportContainers = enclosingDeclaration && getAlternativeContainingModules(symbol, enclosingDeclaration);
            if (enclosingDeclaration && getAccessibleSymbolChain(container, enclosingDeclaration, 1920, false)) {
              return ts2.concatenate(ts2.concatenate([container], additionalContainers), reexportContainers);
            }
            var res = ts2.append(additionalContainers, container);
            return ts2.concatenate(res, reexportContainers);
          }
          var candidates = ts2.mapDefined(symbol.declarations, function(d) {
            if (!ts2.isAmbientModule(d) && d.parent && hasNonGlobalAugmentationExternalModuleSymbol(d.parent)) {
              return getSymbolOfNode(d.parent);
            }
            if (ts2.isClassExpression(d) && ts2.isBinaryExpression(d.parent) && d.parent.operatorToken.kind === 62 && ts2.isAccessExpression(d.parent.left) && ts2.isEntityNameExpression(d.parent.left.expression)) {
              if (ts2.isModuleExportsAccessExpression(d.parent.left) || ts2.isExportsIdentifier(d.parent.left.expression)) {
                return getSymbolOfNode(ts2.getSourceFileOfNode(d));
              }
              checkExpressionCached(d.parent.left.expression);
              return getNodeLinks(d.parent.left.expression).resolvedSymbol;
            }
          });
          if (!ts2.length(candidates)) {
            return void 0;
          }
          return ts2.mapDefined(candidates, function(candidate) {
            return getAliasForSymbolInContainer(candidate, symbol) ? candidate : void 0;
          });
          function fileSymbolIfFileSymbolExportEqualsContainer(d) {
            return container && getFileSymbolIfFileSymbolExportEqualsContainer(d, container);
          }
        }
        function getFileSymbolIfFileSymbolExportEqualsContainer(d, container) {
          var fileSymbol = getExternalModuleContainer(d);
          var exported = fileSymbol && fileSymbol.exports && fileSymbol.exports.get("export=");
          return exported && getSymbolIfSameReference(exported, container) ? fileSymbol : void 0;
        }
        function getAliasForSymbolInContainer(container, symbol) {
          if (container === getParentOfSymbol(symbol)) {
            return symbol;
          }
          var exportEquals = container.exports && container.exports.get("export=");
          if (exportEquals && getSymbolIfSameReference(exportEquals, symbol)) {
            return container;
          }
          var exports2 = getExportsOfSymbol(container);
          var quick = exports2.get(symbol.escapedName);
          if (quick && getSymbolIfSameReference(quick, symbol)) {
            return quick;
          }
          return ts2.forEachEntry(exports2, function(exported) {
            if (getSymbolIfSameReference(exported, symbol)) {
              return exported;
            }
          });
        }
        function getSymbolIfSameReference(s1, s2) {
          if (getMergedSymbol(resolveSymbol(getMergedSymbol(s1))) === getMergedSymbol(resolveSymbol(getMergedSymbol(s2)))) {
            return s1;
          }
        }
        function getExportSymbolOfValueSymbolIfExported(symbol) {
          return getMergedSymbol(symbol && (symbol.flags & 1048576) !== 0 ? symbol.exportSymbol : symbol);
        }
        function symbolIsValue(symbol) {
          return !!(symbol.flags & 111551 || symbol.flags & 2097152 && resolveAlias(symbol).flags & 111551 && !getTypeOnlyAliasDeclaration(symbol));
        }
        function findConstructorDeclaration(node) {
          var members = node.members;
          for (var _i = 0, members_3 = members; _i < members_3.length; _i++) {
            var member = members_3[_i];
            if (member.kind === 162 && ts2.nodeIsPresent(member.body)) {
              return member;
            }
          }
        }
        function createType(flags) {
          var result = new Type(checker, flags);
          typeCount++;
          result.id = typeCount;
          return result;
        }
        function createIntrinsicType(kind, intrinsicName, objectFlags) {
          if (objectFlags === void 0) {
            objectFlags = 0;
          }
          var type = createType(kind);
          type.intrinsicName = intrinsicName;
          type.objectFlags = objectFlags;
          return type;
        }
        function createBooleanType(trueFalseTypes) {
          var type = getUnionType(trueFalseTypes);
          type.flags |= 16;
          type.intrinsicName = "boolean";
          return type;
        }
        function createObjectType(objectFlags, symbol) {
          var type = createType(524288);
          type.objectFlags = objectFlags;
          type.symbol = symbol;
          type.members = void 0;
          type.properties = void 0;
          type.callSignatures = void 0;
          type.constructSignatures = void 0;
          type.stringIndexInfo = void 0;
          type.numberIndexInfo = void 0;
          return type;
        }
        function createTypeofType() {
          return getUnionType(ts2.arrayFrom(typeofEQFacts.keys(), getLiteralType));
        }
        function createTypeParameter(symbol) {
          var type = createType(262144);
          if (symbol)
            type.symbol = symbol;
          return type;
        }
        function isReservedMemberName(name) {
          return name.charCodeAt(0) === 95 && name.charCodeAt(1) === 95 && name.charCodeAt(2) !== 95 && name.charCodeAt(2) !== 64 && name.charCodeAt(2) !== 35;
        }
        function getNamedMembers(members) {
          var result;
          members.forEach(function(symbol, id) {
            if (!isReservedMemberName(id) && symbolIsValue(symbol)) {
              (result || (result = [])).push(symbol);
            }
          });
          return result || ts2.emptyArray;
        }
        function setStructuredTypeMembers(type, members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo) {
          type.members = members;
          type.properties = members === emptySymbols ? ts2.emptyArray : getNamedMembers(members);
          type.callSignatures = callSignatures;
          type.constructSignatures = constructSignatures;
          type.stringIndexInfo = stringIndexInfo;
          type.numberIndexInfo = numberIndexInfo;
          return type;
        }
        function createAnonymousType(symbol, members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo) {
          return setStructuredTypeMembers(createObjectType(16, symbol), members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo);
        }
        function forEachSymbolTableInScope(enclosingDeclaration, callback) {
          var result;
          var _loop_7 = function(location2) {
            if (location2.locals && !isGlobalSourceFile(location2)) {
              if (result = callback(location2.locals)) {
                return { value: result };
              }
            }
            switch (location2.kind) {
              case 290:
                if (!ts2.isExternalOrCommonJsModule(location2)) {
                  break;
                }
              case 249:
                var sym = getSymbolOfNode(location2);
                if (result = callback((sym === null || sym === void 0 ? void 0 : sym.exports) || emptySymbols)) {
                  return { value: result };
                }
                break;
              case 245:
              case 214:
              case 246:
                var table_1;
                (getSymbolOfNode(location2).members || emptySymbols).forEach(function(memberSymbol, key) {
                  if (memberSymbol.flags & (788968 & ~67108864)) {
                    (table_1 || (table_1 = ts2.createSymbolTable())).set(key, memberSymbol);
                  }
                });
                if (table_1 && (result = callback(table_1))) {
                  return { value: result };
                }
                break;
            }
          };
          for (var location = enclosingDeclaration; location; location = location.parent) {
            var state_2 = _loop_7(location);
            if (typeof state_2 === "object")
              return state_2.value;
          }
          return callback(globals);
        }
        function getQualifiedLeftMeaning(rightMeaning) {
          return rightMeaning === 111551 ? 111551 : 1920;
        }
        function getAccessibleSymbolChain(symbol, enclosingDeclaration, meaning, useOnlyExternalAliasing, visitedSymbolTablesMap) {
          if (visitedSymbolTablesMap === void 0) {
            visitedSymbolTablesMap = ts2.createMap();
          }
          if (!(symbol && !isPropertyOrMethodDeclarationSymbol(symbol))) {
            return void 0;
          }
          var id = "" + getSymbolId(symbol);
          var visitedSymbolTables = visitedSymbolTablesMap.get(id);
          if (!visitedSymbolTables) {
            visitedSymbolTablesMap.set(id, visitedSymbolTables = []);
          }
          return forEachSymbolTableInScope(enclosingDeclaration, getAccessibleSymbolChainFromSymbolTable);
          function getAccessibleSymbolChainFromSymbolTable(symbols, ignoreQualification) {
            if (!ts2.pushIfUnique(visitedSymbolTables, symbols)) {
              return void 0;
            }
            var result = trySymbolTable(symbols, ignoreQualification);
            visitedSymbolTables.pop();
            return result;
          }
          function canQualifySymbol(symbolFromSymbolTable, meaning2) {
            return !needsQualification(symbolFromSymbolTable, enclosingDeclaration, meaning2) || !!getAccessibleSymbolChain(symbolFromSymbolTable.parent, enclosingDeclaration, getQualifiedLeftMeaning(meaning2), useOnlyExternalAliasing, visitedSymbolTablesMap);
          }
          function isAccessible(symbolFromSymbolTable, resolvedAliasSymbol, ignoreQualification) {
            return (symbol === (resolvedAliasSymbol || symbolFromSymbolTable) || getMergedSymbol(symbol) === getMergedSymbol(resolvedAliasSymbol || symbolFromSymbolTable)) && !ts2.some(symbolFromSymbolTable.declarations, hasNonGlobalAugmentationExternalModuleSymbol) && (ignoreQualification || canQualifySymbol(getMergedSymbol(symbolFromSymbolTable), meaning));
          }
          function trySymbolTable(symbols, ignoreQualification) {
            if (isAccessible(symbols.get(symbol.escapedName), void 0, ignoreQualification)) {
              return [symbol];
            }
            var result = ts2.forEachEntry(symbols, function(symbolFromSymbolTable) {
              if (symbolFromSymbolTable.flags & 2097152 && symbolFromSymbolTable.escapedName !== "export=" && symbolFromSymbolTable.escapedName !== "default" && !(ts2.isUMDExportSymbol(symbolFromSymbolTable) && enclosingDeclaration && ts2.isExternalModule(ts2.getSourceFileOfNode(enclosingDeclaration))) && (!useOnlyExternalAliasing || ts2.some(symbolFromSymbolTable.declarations, ts2.isExternalModuleImportEqualsDeclaration)) && (ignoreQualification || !ts2.getDeclarationOfKind(symbolFromSymbolTable, 263))) {
                var resolvedImportedSymbol = resolveAlias(symbolFromSymbolTable);
                var candidate = getCandidateListForSymbol(symbolFromSymbolTable, resolvedImportedSymbol, ignoreQualification);
                if (candidate) {
                  return candidate;
                }
              }
              if (symbolFromSymbolTable.escapedName === symbol.escapedName && symbolFromSymbolTable.exportSymbol) {
                if (isAccessible(getMergedSymbol(symbolFromSymbolTable.exportSymbol), void 0, ignoreQualification)) {
                  return [symbol];
                }
              }
            });
            return result || (symbols === globals ? getCandidateListForSymbol(globalThisSymbol, globalThisSymbol, ignoreQualification) : void 0);
          }
          function getCandidateListForSymbol(symbolFromSymbolTable, resolvedImportedSymbol, ignoreQualification) {
            if (isAccessible(symbolFromSymbolTable, resolvedImportedSymbol, ignoreQualification)) {
              return [symbolFromSymbolTable];
            }
            var candidateTable = getExportsOfSymbol(resolvedImportedSymbol);
            var accessibleSymbolsFromExports = candidateTable && getAccessibleSymbolChainFromSymbolTable(candidateTable, true);
            if (accessibleSymbolsFromExports && canQualifySymbol(symbolFromSymbolTable, getQualifiedLeftMeaning(meaning))) {
              return [symbolFromSymbolTable].concat(accessibleSymbolsFromExports);
            }
          }
        }
        function needsQualification(symbol, enclosingDeclaration, meaning) {
          var qualify = false;
          forEachSymbolTableInScope(enclosingDeclaration, function(symbolTable) {
            var symbolFromSymbolTable = getMergedSymbol(symbolTable.get(symbol.escapedName));
            if (!symbolFromSymbolTable) {
              return false;
            }
            if (symbolFromSymbolTable === symbol) {
              return true;
            }
            symbolFromSymbolTable = symbolFromSymbolTable.flags & 2097152 && !ts2.getDeclarationOfKind(symbolFromSymbolTable, 263) ? resolveAlias(symbolFromSymbolTable) : symbolFromSymbolTable;
            if (symbolFromSymbolTable.flags & meaning) {
              qualify = true;
              return true;
            }
            return false;
          });
          return qualify;
        }
        function isPropertyOrMethodDeclarationSymbol(symbol) {
          if (symbol.declarations && symbol.declarations.length) {
            for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
              var declaration = _a[_i];
              switch (declaration.kind) {
                case 159:
                case 161:
                case 163:
                case 164:
                  continue;
                default:
                  return false;
              }
            }
            return true;
          }
          return false;
        }
        function isTypeSymbolAccessible(typeSymbol, enclosingDeclaration) {
          var access = isSymbolAccessible(typeSymbol, enclosingDeclaration, 788968, false);
          return access.accessibility === 0;
        }
        function isValueSymbolAccessible(typeSymbol, enclosingDeclaration) {
          var access = isSymbolAccessible(typeSymbol, enclosingDeclaration, 111551, false);
          return access.accessibility === 0;
        }
        function isAnySymbolAccessible(symbols, enclosingDeclaration, initialSymbol, meaning, shouldComputeAliasesToMakeVisible) {
          if (!ts2.length(symbols))
            return;
          var hadAccessibleChain;
          var earlyModuleBail = false;
          for (var _i = 0, _a = symbols; _i < _a.length; _i++) {
            var symbol = _a[_i];
            var accessibleSymbolChain = getAccessibleSymbolChain(symbol, enclosingDeclaration, meaning, false);
            if (accessibleSymbolChain) {
              hadAccessibleChain = symbol;
              var hasAccessibleDeclarations = hasVisibleDeclarations(accessibleSymbolChain[0], shouldComputeAliasesToMakeVisible);
              if (hasAccessibleDeclarations) {
                return hasAccessibleDeclarations;
              }
            } else {
              if (ts2.some(symbol.declarations, hasNonGlobalAugmentationExternalModuleSymbol)) {
                if (shouldComputeAliasesToMakeVisible) {
                  earlyModuleBail = true;
                  continue;
                }
                return {
                  accessibility: 0
                };
              }
            }
            var containers = getContainersOfSymbol(symbol, enclosingDeclaration);
            var firstDecl = !!ts2.length(symbol.declarations) && ts2.first(symbol.declarations);
            if (!ts2.length(containers) && meaning & 111551 && firstDecl && ts2.isObjectLiteralExpression(firstDecl)) {
              if (firstDecl.parent && ts2.isVariableDeclaration(firstDecl.parent) && firstDecl === firstDecl.parent.initializer) {
                containers = [getSymbolOfNode(firstDecl.parent)];
              }
            }
            var parentResult = isAnySymbolAccessible(containers, enclosingDeclaration, initialSymbol, initialSymbol === symbol ? getQualifiedLeftMeaning(meaning) : meaning, shouldComputeAliasesToMakeVisible);
            if (parentResult) {
              return parentResult;
            }
          }
          if (earlyModuleBail) {
            return {
              accessibility: 0
            };
          }
          if (hadAccessibleChain) {
            return {
              accessibility: 1,
              errorSymbolName: symbolToString(initialSymbol, enclosingDeclaration, meaning),
              errorModuleName: hadAccessibleChain !== initialSymbol ? symbolToString(hadAccessibleChain, enclosingDeclaration, 1920) : void 0
            };
          }
        }
        function isSymbolAccessible(symbol, enclosingDeclaration, meaning, shouldComputeAliasesToMakeVisible) {
          if (symbol && enclosingDeclaration) {
            var result = isAnySymbolAccessible([symbol], enclosingDeclaration, symbol, meaning, shouldComputeAliasesToMakeVisible);
            if (result) {
              return result;
            }
            var symbolExternalModule = ts2.forEach(symbol.declarations, getExternalModuleContainer);
            if (symbolExternalModule) {
              var enclosingExternalModule = getExternalModuleContainer(enclosingDeclaration);
              if (symbolExternalModule !== enclosingExternalModule) {
                return {
                  accessibility: 2,
                  errorSymbolName: symbolToString(symbol, enclosingDeclaration, meaning),
                  errorModuleName: symbolToString(symbolExternalModule)
                };
              }
            }
            return {
              accessibility: 1,
              errorSymbolName: symbolToString(symbol, enclosingDeclaration, meaning)
            };
          }
          return { accessibility: 0 };
        }
        function getExternalModuleContainer(declaration) {
          var node = ts2.findAncestor(declaration, hasExternalModuleSymbol);
          return node && getSymbolOfNode(node);
        }
        function hasExternalModuleSymbol(declaration) {
          return ts2.isAmbientModule(declaration) || declaration.kind === 290 && ts2.isExternalOrCommonJsModule(declaration);
        }
        function hasNonGlobalAugmentationExternalModuleSymbol(declaration) {
          return ts2.isModuleWithStringLiteralName(declaration) || declaration.kind === 290 && ts2.isExternalOrCommonJsModule(declaration);
        }
        function hasVisibleDeclarations(symbol, shouldComputeAliasToMakeVisible) {
          var aliasesToMakeVisible;
          if (!ts2.every(ts2.filter(symbol.declarations, function(d) {
            return d.kind !== 75;
          }), getIsDeclarationVisible)) {
            return void 0;
          }
          return { accessibility: 0, aliasesToMakeVisible };
          function getIsDeclarationVisible(declaration) {
            if (!isDeclarationVisible(declaration)) {
              var anyImportSyntax = getAnyImportSyntax(declaration);
              if (anyImportSyntax && !ts2.hasModifier(anyImportSyntax, 1) && isDeclarationVisible(anyImportSyntax.parent)) {
                return addVisibleAlias(declaration, anyImportSyntax);
              } else if (ts2.isVariableDeclaration(declaration) && ts2.isVariableStatement(declaration.parent.parent) && !ts2.hasModifier(declaration.parent.parent, 1) && isDeclarationVisible(declaration.parent.parent.parent)) {
                return addVisibleAlias(declaration, declaration.parent.parent);
              } else if (ts2.isLateVisibilityPaintedStatement(declaration) && !ts2.hasModifier(declaration, 1) && isDeclarationVisible(declaration.parent)) {
                return addVisibleAlias(declaration, declaration);
              }
              return false;
            }
            return true;
          }
          function addVisibleAlias(declaration, aliasingStatement) {
            if (shouldComputeAliasToMakeVisible) {
              getNodeLinks(declaration).isVisible = true;
              aliasesToMakeVisible = ts2.appendIfUnique(aliasesToMakeVisible, aliasingStatement);
            }
            return true;
          }
        }
        function isEntityNameVisible(entityName, enclosingDeclaration) {
          var meaning;
          if (entityName.parent.kind === 172 || ts2.isExpressionWithTypeArgumentsInClassExtendsClause(entityName.parent) || entityName.parent.kind === 154) {
            meaning = 111551 | 1048576;
          } else if (entityName.kind === 153 || entityName.kind === 194 || entityName.parent.kind === 253) {
            meaning = 1920;
          } else {
            meaning = 788968;
          }
          var firstIdentifier = ts2.getFirstIdentifier(entityName);
          var symbol = resolveName(enclosingDeclaration, firstIdentifier.escapedText, meaning, void 0, void 0, false);
          return symbol && hasVisibleDeclarations(symbol, true) || {
            accessibility: 1,
            errorSymbolName: ts2.getTextOfNode(firstIdentifier),
            errorNode: firstIdentifier
          };
        }
        function symbolToString(symbol, enclosingDeclaration, meaning, flags, writer) {
          if (flags === void 0) {
            flags = 4;
          }
          var nodeFlags = 70221824;
          if (flags & 2) {
            nodeFlags |= 128;
          }
          if (flags & 1) {
            nodeFlags |= 512;
          }
          if (flags & 8) {
            nodeFlags |= 16384;
          }
          if (flags & 16) {
            nodeFlags |= 134217728;
          }
          var builder = flags & 4 ? nodeBuilder.symbolToExpression : nodeBuilder.symbolToEntityName;
          return writer ? symbolToStringWorker(writer).getText() : ts2.usingSingleLineStringWriter(symbolToStringWorker);
          function symbolToStringWorker(writer2) {
            var entity = builder(symbol, meaning, enclosingDeclaration, nodeFlags);
            var printer = ts2.createPrinter({ removeComments: true });
            var sourceFile = enclosingDeclaration && ts2.getSourceFileOfNode(enclosingDeclaration);
            printer.writeNode(4, entity, sourceFile, writer2);
            return writer2;
          }
        }
        function signatureToString(signature, enclosingDeclaration, flags, kind, writer) {
          if (flags === void 0) {
            flags = 0;
          }
          return writer ? signatureToStringWorker(writer).getText() : ts2.usingSingleLineStringWriter(signatureToStringWorker);
          function signatureToStringWorker(writer2) {
            var sigOutput;
            if (flags & 262144) {
              sigOutput = kind === 1 ? 171 : 170;
            } else {
              sigOutput = kind === 1 ? 166 : 165;
            }
            var sig = nodeBuilder.signatureToSignatureDeclaration(signature, sigOutput, enclosingDeclaration, toNodeBuilderFlags(flags) | 70221824 | 512);
            var printer = ts2.createPrinter({ removeComments: true, omitTrailingSemicolon: true });
            var sourceFile = enclosingDeclaration && ts2.getSourceFileOfNode(enclosingDeclaration);
            printer.writeNode(4, sig, sourceFile, ts2.getTrailingSemicolonDeferringWriter(writer2));
            return writer2;
          }
        }
        function typeToString(type, enclosingDeclaration, flags, writer) {
          if (flags === void 0) {
            flags = 1048576 | 16384;
          }
          if (writer === void 0) {
            writer = ts2.createTextWriter("");
          }
          var noTruncation = compilerOptions.noErrorTruncation || flags & 1;
          var typeNode = nodeBuilder.typeToTypeNode(type, enclosingDeclaration, toNodeBuilderFlags(flags) | 70221824 | (noTruncation ? 1 : 0), writer);
          if (typeNode === void 0)
            return ts2.Debug.fail("should always get typenode");
          var options = { removeComments: true };
          var printer = ts2.createPrinter(options);
          var sourceFile = enclosingDeclaration && ts2.getSourceFileOfNode(enclosingDeclaration);
          printer.writeNode(4, typeNode, sourceFile, writer);
          var result = writer.getText();
          var maxLength = noTruncation ? ts2.noTruncationMaximumTruncationLength * 2 : ts2.defaultMaximumTruncationLength * 2;
          if (maxLength && result && result.length >= maxLength) {
            return result.substr(0, maxLength - "...".length) + "...";
          }
          return result;
        }
        function getTypeNamesForErrorDisplay(left, right) {
          var leftStr = symbolValueDeclarationIsContextSensitive(left.symbol) ? typeToString(left, left.symbol.valueDeclaration) : typeToString(left);
          var rightStr = symbolValueDeclarationIsContextSensitive(right.symbol) ? typeToString(right, right.symbol.valueDeclaration) : typeToString(right);
          if (leftStr === rightStr) {
            leftStr = typeToString(left, void 0, 64);
            rightStr = typeToString(right, void 0, 64);
          }
          return [leftStr, rightStr];
        }
        function symbolValueDeclarationIsContextSensitive(symbol) {
          return symbol && symbol.valueDeclaration && ts2.isExpression(symbol.valueDeclaration) && !isContextSensitive(symbol.valueDeclaration);
        }
        function toNodeBuilderFlags(flags) {
          if (flags === void 0) {
            flags = 0;
          }
          return flags & 814775659;
        }
        function createNodeBuilder() {
          return {
            typeToTypeNode: function(type, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return typeToTypeNodeHelper(type, context);
              });
            },
            indexInfoToIndexSignatureDeclaration: function(indexInfo, kind, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return indexInfoToIndexSignatureDeclarationHelper(indexInfo, kind, context);
              });
            },
            signatureToSignatureDeclaration: function(signature, kind, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return signatureToSignatureDeclarationHelper(signature, kind, context);
              });
            },
            symbolToEntityName: function(symbol, meaning, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return symbolToName(symbol, context, meaning, false);
              });
            },
            symbolToExpression: function(symbol, meaning, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return symbolToExpression(symbol, context, meaning);
              });
            },
            symbolToTypeParameterDeclarations: function(symbol, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return typeParametersToTypeParameterDeclarations(symbol, context);
              });
            },
            symbolToParameterDeclaration: function(symbol, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return symbolToParameterDeclaration(symbol, context);
              });
            },
            typeParameterToDeclaration: function(parameter, enclosingDeclaration, flags, tracker) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return typeParameterToDeclaration(parameter, context);
              });
            },
            symbolTableToDeclarationStatements: function(symbolTable, enclosingDeclaration, flags, tracker, bundled) {
              return withContext(enclosingDeclaration, flags, tracker, function(context) {
                return symbolTableToDeclarationStatements(symbolTable, context, bundled);
              });
            }
          };
          function withContext(enclosingDeclaration, flags, tracker, cb) {
            ts2.Debug.assert(enclosingDeclaration === void 0 || (enclosingDeclaration.flags & 8) === 0);
            var context = {
              enclosingDeclaration,
              flags: flags || 0,
              tracker: tracker && tracker.trackSymbol ? tracker : { trackSymbol: ts2.noop, moduleResolverHost: flags & 134217728 ? {
                getCommonSourceDirectory: !!host.getCommonSourceDirectory ? function() {
                  return host.getCommonSourceDirectory();
                } : function() {
                  return "";
                },
                getSourceFiles: function() {
                  return host.getSourceFiles();
                },
                getCurrentDirectory: function() {
                  return host.getCurrentDirectory();
                },
                getProbableSymlinks: ts2.maybeBind(host, host.getProbableSymlinks),
                useCaseSensitiveFileNames: ts2.maybeBind(host, host.useCaseSensitiveFileNames),
                redirectTargetsMap: host.redirectTargetsMap,
                getProjectReferenceRedirect: function(fileName) {
                  return host.getProjectReferenceRedirect(fileName);
                },
                isSourceOfProjectReferenceRedirect: function(fileName) {
                  return host.isSourceOfProjectReferenceRedirect(fileName);
                },
                fileExists: function(fileName) {
                  return host.fileExists(fileName);
                }
              } : void 0 },
              encounteredError: false,
              visitedTypes: void 0,
              symbolDepth: void 0,
              inferTypeParameters: void 0,
              approximateLength: 0
            };
            var resultingNode = cb(context);
            return context.encounteredError ? void 0 : resultingNode;
          }
          function checkTruncationLength(context) {
            if (context.truncating)
              return context.truncating;
            return context.truncating = context.approximateLength > (context.flags & 1 ? ts2.noTruncationMaximumTruncationLength : ts2.defaultMaximumTruncationLength);
          }
          function typeToTypeNodeHelper(type, context) {
            if (cancellationToken && cancellationToken.throwIfCancellationRequested) {
              cancellationToken.throwIfCancellationRequested();
            }
            var inTypeAlias = context.flags & 8388608;
            context.flags &= ~8388608;
            if (!type) {
              if (!(context.flags & 262144)) {
                context.encounteredError = true;
                return void 0;
              }
              context.approximateLength += 3;
              return ts2.createKeywordTypeNode(125);
            }
            if (!(context.flags & 536870912)) {
              type = getReducedType(type);
            }
            if (type.flags & 1) {
              context.approximateLength += 3;
              return ts2.createKeywordTypeNode(125);
            }
            if (type.flags & 2) {
              return ts2.createKeywordTypeNode(148);
            }
            if (type.flags & 4) {
              context.approximateLength += 6;
              return ts2.createKeywordTypeNode(143);
            }
            if (type.flags & 8) {
              context.approximateLength += 6;
              return ts2.createKeywordTypeNode(140);
            }
            if (type.flags & 64) {
              context.approximateLength += 6;
              return ts2.createKeywordTypeNode(151);
            }
            if (type.flags & 16) {
              context.approximateLength += 7;
              return ts2.createKeywordTypeNode(128);
            }
            if (type.flags & 1024 && !(type.flags & 1048576)) {
              var parentSymbol = getParentOfSymbol(type.symbol);
              var parentName = symbolToTypeNode(parentSymbol, context, 788968);
              var enumLiteralName = getDeclaredTypeOfSymbol(parentSymbol) === type ? parentName : appendReferenceToType(parentName, ts2.createTypeReferenceNode(ts2.symbolName(type.symbol), void 0));
              return enumLiteralName;
            }
            if (type.flags & 1056) {
              return symbolToTypeNode(type.symbol, context, 788968);
            }
            if (type.flags & 128) {
              context.approximateLength += type.value.length + 2;
              return ts2.createLiteralTypeNode(ts2.setEmitFlags(ts2.createLiteral(type.value, !!(context.flags & 268435456)), 16777216));
            }
            if (type.flags & 256) {
              var value = type.value;
              context.approximateLength += ("" + value).length;
              return ts2.createLiteralTypeNode(value < 0 ? ts2.createPrefix(40, ts2.createLiteral(-value)) : ts2.createLiteral(value));
            }
            if (type.flags & 2048) {
              context.approximateLength += ts2.pseudoBigIntToString(type.value).length + 1;
              return ts2.createLiteralTypeNode(ts2.createLiteral(type.value));
            }
            if (type.flags & 512) {
              context.approximateLength += type.intrinsicName.length;
              return type.intrinsicName === "true" ? ts2.createTrue() : ts2.createFalse();
            }
            if (type.flags & 8192) {
              if (!(context.flags & 1048576)) {
                if (isValueSymbolAccessible(type.symbol, context.enclosingDeclaration)) {
                  context.approximateLength += 6;
                  return symbolToTypeNode(type.symbol, context, 111551);
                }
                if (context.tracker.reportInaccessibleUniqueSymbolError) {
                  context.tracker.reportInaccessibleUniqueSymbolError();
                }
              }
              context.approximateLength += 13;
              return ts2.createTypeOperatorNode(147, ts2.createKeywordTypeNode(144));
            }
            if (type.flags & 16384) {
              context.approximateLength += 4;
              return ts2.createKeywordTypeNode(110);
            }
            if (type.flags & 32768) {
              context.approximateLength += 9;
              return ts2.createKeywordTypeNode(146);
            }
            if (type.flags & 65536) {
              context.approximateLength += 4;
              return ts2.createKeywordTypeNode(100);
            }
            if (type.flags & 131072) {
              context.approximateLength += 5;
              return ts2.createKeywordTypeNode(137);
            }
            if (type.flags & 4096) {
              context.approximateLength += 6;
              return ts2.createKeywordTypeNode(144);
            }
            if (type.flags & 67108864) {
              context.approximateLength += 6;
              return ts2.createKeywordTypeNode(141);
            }
            if (isThisTypeParameter(type)) {
              if (context.flags & 4194304) {
                if (!context.encounteredError && !(context.flags & 32768)) {
                  context.encounteredError = true;
                }
                if (context.tracker.reportInaccessibleThisError) {
                  context.tracker.reportInaccessibleThisError();
                }
              }
              context.approximateLength += 4;
              return ts2.createThis();
            }
            if (!inTypeAlias && type.aliasSymbol && (context.flags & 16384 || isTypeSymbolAccessible(type.aliasSymbol, context.enclosingDeclaration))) {
              var typeArgumentNodes = mapToTypeNodes(type.aliasTypeArguments, context);
              if (isReservedMemberName(type.aliasSymbol.escapedName) && !(type.aliasSymbol.flags & 32))
                return ts2.createTypeReferenceNode(ts2.createIdentifier(""), typeArgumentNodes);
              return symbolToTypeNode(type.aliasSymbol, context, 788968, typeArgumentNodes);
            }
            var objectFlags = ts2.getObjectFlags(type);
            if (objectFlags & 4) {
              ts2.Debug.assert(!!(type.flags & 524288));
              return type.node ? visitAndTransformType(type, typeReferenceToTypeNode) : typeReferenceToTypeNode(type);
            }
            if (type.flags & 262144 || objectFlags & 3) {
              if (type.flags & 262144 && ts2.contains(context.inferTypeParameters, type)) {
                context.approximateLength += ts2.symbolName(type.symbol).length + 6;
                return ts2.createInferTypeNode(typeParameterToDeclarationWithConstraint(type, context, void 0));
              }
              if (context.flags & 4 && type.flags & 262144 && !isTypeSymbolAccessible(type.symbol, context.enclosingDeclaration)) {
                var name = typeParameterToName(type, context);
                context.approximateLength += ts2.idText(name).length;
                return ts2.createTypeReferenceNode(ts2.createIdentifier(ts2.idText(name)), void 0);
              }
              return type.symbol ? symbolToTypeNode(type.symbol, context, 788968) : ts2.createTypeReferenceNode(ts2.createIdentifier("?"), void 0);
            }
            if (type.flags & (1048576 | 2097152)) {
              var types = type.flags & 1048576 ? formatUnionTypes(type.types) : type.types;
              if (ts2.length(types) === 1) {
                return typeToTypeNodeHelper(types[0], context);
              }
              var typeNodes = mapToTypeNodes(types, context, true);
              if (typeNodes && typeNodes.length > 0) {
                var unionOrIntersectionTypeNode = ts2.createUnionOrIntersectionTypeNode(type.flags & 1048576 ? 178 : 179, typeNodes);
                return unionOrIntersectionTypeNode;
              } else {
                if (!context.encounteredError && !(context.flags & 262144)) {
                  context.encounteredError = true;
                }
                return void 0;
              }
            }
            if (objectFlags & (16 | 32)) {
              ts2.Debug.assert(!!(type.flags & 524288));
              return createAnonymousTypeNode(type);
            }
            if (type.flags & 4194304) {
              var indexedType = type.type;
              context.approximateLength += 6;
              var indexTypeNode = typeToTypeNodeHelper(indexedType, context);
              return ts2.createTypeOperatorNode(indexTypeNode);
            }
            if (type.flags & 8388608) {
              var objectTypeNode = typeToTypeNodeHelper(type.objectType, context);
              var indexTypeNode = typeToTypeNodeHelper(type.indexType, context);
              context.approximateLength += 2;
              return ts2.createIndexedAccessTypeNode(objectTypeNode, indexTypeNode);
            }
            if (type.flags & 16777216) {
              var checkTypeNode = typeToTypeNodeHelper(type.checkType, context);
              var saveInferTypeParameters = context.inferTypeParameters;
              context.inferTypeParameters = type.root.inferTypeParameters;
              var extendsTypeNode = typeToTypeNodeHelper(type.extendsType, context);
              context.inferTypeParameters = saveInferTypeParameters;
              var trueTypeNode = typeToTypeNodeOrCircularityElision(getTrueTypeFromConditionalType(type));
              var falseTypeNode = typeToTypeNodeOrCircularityElision(getFalseTypeFromConditionalType(type));
              context.approximateLength += 15;
              return ts2.createConditionalTypeNode(checkTypeNode, extendsTypeNode, trueTypeNode, falseTypeNode);
            }
            if (type.flags & 33554432) {
              return typeToTypeNodeHelper(type.baseType, context);
            }
            return ts2.Debug.fail("Should be unreachable.");
            function typeToTypeNodeOrCircularityElision(type2) {
              var _a, _b;
              if (type2.flags & 1048576) {
                if (context.visitedTypes && context.visitedTypes.has("" + getTypeId(type2))) {
                  if (!(context.flags & 131072)) {
                    context.encounteredError = true;
                    (_b = (_a = context.tracker) === null || _a === void 0 ? void 0 : _a.reportCyclicStructureError) === null || _b === void 0 ? void 0 : _b.call(_a);
                  }
                  return createElidedInformationPlaceholder(context);
                }
                return visitAndTransformType(type2, function(type3) {
                  return typeToTypeNodeHelper(type3, context);
                });
              }
              return typeToTypeNodeHelper(type2, context);
            }
            function createMappedTypeNodeFromType(type2) {
              ts2.Debug.assert(!!(type2.flags & 524288));
              var readonlyToken = type2.declaration.readonlyToken ? ts2.createToken(type2.declaration.readonlyToken.kind) : void 0;
              var questionToken = type2.declaration.questionToken ? ts2.createToken(type2.declaration.questionToken.kind) : void 0;
              var appropriateConstraintTypeNode;
              if (isMappedTypeWithKeyofConstraintDeclaration(type2)) {
                appropriateConstraintTypeNode = ts2.createTypeOperatorNode(typeToTypeNodeHelper(getModifiersTypeFromMappedType(type2), context));
              } else {
                appropriateConstraintTypeNode = typeToTypeNodeHelper(getConstraintTypeFromMappedType(type2), context);
              }
              var typeParameterNode = typeParameterToDeclarationWithConstraint(getTypeParameterFromMappedType(type2), context, appropriateConstraintTypeNode);
              var templateTypeNode = typeToTypeNodeHelper(getTemplateTypeFromMappedType(type2), context);
              var mappedTypeNode = ts2.createMappedTypeNode(readonlyToken, typeParameterNode, questionToken, templateTypeNode);
              context.approximateLength += 10;
              return ts2.setEmitFlags(mappedTypeNode, 1);
            }
            function createAnonymousTypeNode(type2) {
              var typeId = "" + type2.id;
              var symbol = type2.symbol;
              if (symbol) {
                if (isJSConstructor(symbol.valueDeclaration)) {
                  var isInstanceType = type2 === getDeclaredTypeOfClassOrInterface(symbol) ? 788968 : 111551;
                  return symbolToTypeNode(symbol, context, isInstanceType);
                } else if (symbol.flags & 32 && !getBaseTypeVariableOfClass(symbol) && !(symbol.valueDeclaration.kind === 214 && context.flags & 2048) || symbol.flags & (384 | 512) || shouldWriteTypeOfFunctionSymbol()) {
                  return symbolToTypeNode(symbol, context, 111551);
                } else if (context.visitedTypes && context.visitedTypes.has(typeId)) {
                  var typeAlias = getTypeAliasForTypeLiteral(type2);
                  if (typeAlias) {
                    return symbolToTypeNode(typeAlias, context, 788968);
                  } else {
                    return createElidedInformationPlaceholder(context);
                  }
                } else {
                  return visitAndTransformType(type2, createTypeNodeFromObjectType);
                }
              } else {
                return createTypeNodeFromObjectType(type2);
              }
              function shouldWriteTypeOfFunctionSymbol() {
                var isStaticMethodSymbol = !!(symbol.flags & 8192) && ts2.some(symbol.declarations, function(declaration) {
                  return ts2.hasModifier(declaration, 32);
                });
                var isNonLocalFunctionSymbol = !!(symbol.flags & 16) && (symbol.parent || ts2.forEach(symbol.declarations, function(declaration) {
                  return declaration.parent.kind === 290 || declaration.parent.kind === 250;
                }));
                if (isStaticMethodSymbol || isNonLocalFunctionSymbol) {
                  return (!!(context.flags & 4096) || context.visitedTypes && context.visitedTypes.has(typeId)) && (!(context.flags & 8) || isValueSymbolAccessible(symbol, context.enclosingDeclaration));
                }
              }
            }
            function visitAndTransformType(type2, transform) {
              var typeId = "" + type2.id;
              var isConstructorObject = ts2.getObjectFlags(type2) & 16 && type2.symbol && type2.symbol.flags & 32;
              var id = ts2.getObjectFlags(type2) & 4 && type2.node ? "N" + getNodeId(type2.node) : type2.symbol ? (isConstructorObject ? "+" : "") + getSymbolId(type2.symbol) : void 0;
              if (!context.visitedTypes) {
                context.visitedTypes = ts2.createMap();
              }
              if (id && !context.symbolDepth) {
                context.symbolDepth = ts2.createMap();
              }
              var depth;
              if (id) {
                depth = context.symbolDepth.get(id) || 0;
                if (depth > 10) {
                  return createElidedInformationPlaceholder(context);
                }
                context.symbolDepth.set(id, depth + 1);
              }
              context.visitedTypes.set(typeId, true);
              var result = transform(type2);
              context.visitedTypes.delete(typeId);
              if (id) {
                context.symbolDepth.set(id, depth);
              }
              return result;
            }
            function createTypeNodeFromObjectType(type2) {
              if (isGenericMappedType(type2)) {
                return createMappedTypeNodeFromType(type2);
              }
              var resolved = resolveStructuredTypeMembers(type2);
              if (!resolved.properties.length && !resolved.stringIndexInfo && !resolved.numberIndexInfo) {
                if (!resolved.callSignatures.length && !resolved.constructSignatures.length) {
                  context.approximateLength += 2;
                  return ts2.setEmitFlags(ts2.createTypeLiteralNode(void 0), 1);
                }
                if (resolved.callSignatures.length === 1 && !resolved.constructSignatures.length) {
                  var signature = resolved.callSignatures[0];
                  var signatureNode = signatureToSignatureDeclarationHelper(signature, 170, context);
                  return signatureNode;
                }
                if (resolved.constructSignatures.length === 1 && !resolved.callSignatures.length) {
                  var signature = resolved.constructSignatures[0];
                  var signatureNode = signatureToSignatureDeclarationHelper(signature, 171, context);
                  return signatureNode;
                }
              }
              var savedFlags = context.flags;
              context.flags |= 4194304;
              var members = createTypeNodesFromResolvedType(resolved);
              context.flags = savedFlags;
              var typeLiteralNode = ts2.createTypeLiteralNode(members);
              context.approximateLength += 2;
              return ts2.setEmitFlags(typeLiteralNode, context.flags & 1024 ? 0 : 1);
            }
            function typeReferenceToTypeNode(type2) {
              var typeArguments = getTypeArguments(type2);
              if (type2.target === globalArrayType || type2.target === globalReadonlyArrayType) {
                if (context.flags & 2) {
                  var typeArgumentNode = typeToTypeNodeHelper(typeArguments[0], context);
                  return ts2.createTypeReferenceNode(type2.target === globalArrayType ? "Array" : "ReadonlyArray", [typeArgumentNode]);
                }
                var elementType = typeToTypeNodeHelper(typeArguments[0], context);
                var arrayType = ts2.createArrayTypeNode(elementType);
                return type2.target === globalArrayType ? arrayType : ts2.createTypeOperatorNode(138, arrayType);
              } else if (type2.target.objectFlags & 8) {
                if (typeArguments.length > 0) {
                  var arity = getTypeReferenceArity(type2);
                  var tupleConstituentNodes = mapToTypeNodes(typeArguments.slice(0, arity), context);
                  var hasRestElement = type2.target.hasRestElement;
                  if (tupleConstituentNodes) {
                    for (var i = type2.target.minLength; i < Math.min(arity, tupleConstituentNodes.length); i++) {
                      tupleConstituentNodes[i] = hasRestElement && i === arity - 1 ? ts2.createRestTypeNode(ts2.createArrayTypeNode(tupleConstituentNodes[i])) : ts2.createOptionalTypeNode(tupleConstituentNodes[i]);
                    }
                    var tupleTypeNode = ts2.createTupleTypeNode(tupleConstituentNodes);
                    return type2.target.readonly ? ts2.createTypeOperatorNode(138, tupleTypeNode) : tupleTypeNode;
                  }
                }
                if (context.encounteredError || context.flags & 524288) {
                  var tupleTypeNode = ts2.createTupleTypeNode([]);
                  return type2.target.readonly ? ts2.createTypeOperatorNode(138, tupleTypeNode) : tupleTypeNode;
                }
                context.encounteredError = true;
                return void 0;
              } else if (context.flags & 2048 && type2.symbol.valueDeclaration && ts2.isClassLike(type2.symbol.valueDeclaration) && !isValueSymbolAccessible(type2.symbol, context.enclosingDeclaration)) {
                return createAnonymousTypeNode(type2);
              } else {
                var outerTypeParameters = type2.target.outerTypeParameters;
                var i = 0;
                var resultType = void 0;
                if (outerTypeParameters) {
                  var length_2 = outerTypeParameters.length;
                  while (i < length_2) {
                    var start = i;
                    var parent = getParentSymbolOfTypeParameter(outerTypeParameters[i]);
                    do {
                      i++;
                    } while (i < length_2 && getParentSymbolOfTypeParameter(outerTypeParameters[i]) === parent);
                    if (!ts2.rangeEquals(outerTypeParameters, typeArguments, start, i)) {
                      var typeArgumentSlice = mapToTypeNodes(typeArguments.slice(start, i), context);
                      var flags_2 = context.flags;
                      context.flags |= 16;
                      var ref = symbolToTypeNode(parent, context, 788968, typeArgumentSlice);
                      context.flags = flags_2;
                      resultType = !resultType ? ref : appendReferenceToType(resultType, ref);
                    }
                  }
                }
                var typeArgumentNodes2 = void 0;
                if (typeArguments.length > 0) {
                  var typeParameterCount = (type2.target.typeParameters || ts2.emptyArray).length;
                  typeArgumentNodes2 = mapToTypeNodes(typeArguments.slice(i, typeParameterCount), context);
                }
                var flags = context.flags;
                context.flags |= 16;
                var finalRef = symbolToTypeNode(type2.symbol, context, 788968, typeArgumentNodes2);
                context.flags = flags;
                return !resultType ? finalRef : appendReferenceToType(resultType, finalRef);
              }
            }
            function appendReferenceToType(root, ref) {
              if (ts2.isImportTypeNode(root)) {
                var innerParams = root.typeArguments;
                if (root.qualifier) {
                  (ts2.isIdentifier(root.qualifier) ? root.qualifier : root.qualifier.right).typeArguments = innerParams;
                }
                root.typeArguments = ref.typeArguments;
                var ids = getAccessStack(ref);
                for (var _i = 0, ids_1 = ids; _i < ids_1.length; _i++) {
                  var id = ids_1[_i];
                  root.qualifier = root.qualifier ? ts2.createQualifiedName(root.qualifier, id) : id;
                }
                return root;
              } else {
                var innerParams = root.typeArguments;
                (ts2.isIdentifier(root.typeName) ? root.typeName : root.typeName.right).typeArguments = innerParams;
                root.typeArguments = ref.typeArguments;
                var ids = getAccessStack(ref);
                for (var _a = 0, ids_2 = ids; _a < ids_2.length; _a++) {
                  var id = ids_2[_a];
                  root.typeName = ts2.createQualifiedName(root.typeName, id);
                }
                return root;
              }
            }
            function getAccessStack(ref) {
              var state = ref.typeName;
              var ids = [];
              while (!ts2.isIdentifier(state)) {
                ids.unshift(state.right);
                state = state.left;
              }
              ids.unshift(state);
              return ids;
            }
            function createTypeNodesFromResolvedType(resolvedType) {
              if (checkTruncationLength(context)) {
                return [ts2.createPropertySignature(void 0, "...", void 0, void 0, void 0)];
              }
              var typeElements = [];
              for (var _i = 0, _a = resolvedType.callSignatures; _i < _a.length; _i++) {
                var signature = _a[_i];
                typeElements.push(signatureToSignatureDeclarationHelper(signature, 165, context));
              }
              for (var _b = 0, _c = resolvedType.constructSignatures; _b < _c.length; _b++) {
                var signature = _c[_b];
                typeElements.push(signatureToSignatureDeclarationHelper(signature, 166, context));
              }
              if (resolvedType.stringIndexInfo) {
                var indexSignature = void 0;
                if (resolvedType.objectFlags & 2048) {
                  indexSignature = indexInfoToIndexSignatureDeclarationHelper(createIndexInfo(anyType, resolvedType.stringIndexInfo.isReadonly, resolvedType.stringIndexInfo.declaration), 0, context);
                  indexSignature.type = createElidedInformationPlaceholder(context);
                } else {
                  indexSignature = indexInfoToIndexSignatureDeclarationHelper(resolvedType.stringIndexInfo, 0, context);
                }
                typeElements.push(indexSignature);
              }
              if (resolvedType.numberIndexInfo) {
                typeElements.push(indexInfoToIndexSignatureDeclarationHelper(resolvedType.numberIndexInfo, 1, context));
              }
              var properties = resolvedType.properties;
              if (!properties) {
                return typeElements;
              }
              var i = 0;
              for (var _d = 0, properties_1 = properties; _d < properties_1.length; _d++) {
                var propertySymbol = properties_1[_d];
                i++;
                if (context.flags & 2048) {
                  if (propertySymbol.flags & 4194304) {
                    continue;
                  }
                  if (ts2.getDeclarationModifierFlagsFromSymbol(propertySymbol) & (8 | 16) && context.tracker.reportPrivateInBaseOfClassExpression) {
                    context.tracker.reportPrivateInBaseOfClassExpression(ts2.unescapeLeadingUnderscores(propertySymbol.escapedName));
                  }
                }
                if (checkTruncationLength(context) && i + 2 < properties.length - 1) {
                  typeElements.push(ts2.createPropertySignature(void 0, "... " + (properties.length - i) + " more ...", void 0, void 0, void 0));
                  addPropertyToElementList(properties[properties.length - 1], context, typeElements);
                  break;
                }
                addPropertyToElementList(propertySymbol, context, typeElements);
              }
              return typeElements.length ? typeElements : void 0;
            }
          }
          function createElidedInformationPlaceholder(context) {
            context.approximateLength += 3;
            if (!(context.flags & 1)) {
              return ts2.createTypeReferenceNode(ts2.createIdentifier("..."), void 0);
            }
            return ts2.createKeywordTypeNode(125);
          }
          function addPropertyToElementList(propertySymbol, context, typeElements) {
            var propertyIsReverseMapped = !!(ts2.getCheckFlags(propertySymbol) & 8192);
            var propertyType = propertyIsReverseMapped && context.flags & 33554432 ? anyType : getTypeOfSymbol(propertySymbol);
            var saveEnclosingDeclaration = context.enclosingDeclaration;
            context.enclosingDeclaration = void 0;
            if (context.tracker.trackSymbol && ts2.getCheckFlags(propertySymbol) & 4096) {
              var decl = ts2.first(propertySymbol.declarations);
              if (hasLateBindableName(decl)) {
                if (ts2.isBinaryExpression(decl)) {
                  var name = ts2.getNameOfDeclaration(decl);
                  if (name && ts2.isElementAccessExpression(name) && ts2.isPropertyAccessEntityNameExpression(name.argumentExpression)) {
                    trackComputedName(name.argumentExpression, saveEnclosingDeclaration, context);
                  }
                } else {
                  trackComputedName(decl.name.expression, saveEnclosingDeclaration, context);
                }
              }
            }
            context.enclosingDeclaration = saveEnclosingDeclaration;
            var propertyName = getPropertyNameNodeForSymbol(propertySymbol, context);
            context.approximateLength += ts2.symbolName(propertySymbol).length + 1;
            var optionalToken = propertySymbol.flags & 16777216 ? ts2.createToken(57) : void 0;
            if (propertySymbol.flags & (16 | 8192) && !getPropertiesOfObjectType(propertyType).length && !isReadonlySymbol(propertySymbol)) {
              var signatures = getSignaturesOfType(filterType(propertyType, function(t) {
                return !(t.flags & 32768);
              }), 0);
              for (var _i = 0, signatures_1 = signatures; _i < signatures_1.length; _i++) {
                var signature = signatures_1[_i];
                var methodDeclaration = signatureToSignatureDeclarationHelper(signature, 160, context);
                methodDeclaration.name = propertyName;
                methodDeclaration.questionToken = optionalToken;
                typeElements.push(preserveCommentsOn(methodDeclaration));
              }
            } else {
              var savedFlags = context.flags;
              context.flags |= propertyIsReverseMapped ? 33554432 : 0;
              var propertyTypeNode = void 0;
              if (propertyIsReverseMapped && !!(savedFlags & 33554432)) {
                propertyTypeNode = createElidedInformationPlaceholder(context);
              } else {
                propertyTypeNode = propertyType ? serializeTypeForDeclaration(context, propertyType, propertySymbol, saveEnclosingDeclaration) : ts2.createKeywordTypeNode(125);
              }
              context.flags = savedFlags;
              var modifiers = isReadonlySymbol(propertySymbol) ? [ts2.createToken(138)] : void 0;
              if (modifiers) {
                context.approximateLength += 9;
              }
              var propertySignature = ts2.createPropertySignature(modifiers, propertyName, optionalToken, propertyTypeNode, void 0);
              typeElements.push(preserveCommentsOn(propertySignature));
            }
            function preserveCommentsOn(node) {
              if (ts2.some(propertySymbol.declarations, function(d2) {
                return d2.kind === 323;
              })) {
                var d = ts2.find(propertySymbol.declarations, function(d2) {
                  return d2.kind === 323;
                });
                var commentText = d.comment;
                if (commentText) {
                  ts2.setSyntheticLeadingComments(node, [{ kind: 3, text: "*\n * " + commentText.replace(/\n/g, "\n * ") + "\n ", pos: -1, end: -1, hasTrailingNewLine: true }]);
                }
              } else if (propertySymbol.valueDeclaration) {
                ts2.setCommentRange(node, propertySymbol.valueDeclaration);
              }
              return node;
            }
          }
          function mapToTypeNodes(types, context, isBareList) {
            if (ts2.some(types)) {
              if (checkTruncationLength(context)) {
                if (!isBareList) {
                  return [ts2.createTypeReferenceNode("...", void 0)];
                } else if (types.length > 2) {
                  return [
                    typeToTypeNodeHelper(types[0], context),
                    ts2.createTypeReferenceNode("... " + (types.length - 2) + " more ...", void 0),
                    typeToTypeNodeHelper(types[types.length - 1], context)
                  ];
                }
              }
              var mayHaveNameCollisions = !(context.flags & 64);
              var seenNames = mayHaveNameCollisions ? ts2.createUnderscoreEscapedMultiMap() : void 0;
              var result_3 = [];
              var i = 0;
              for (var _i = 0, types_1 = types; _i < types_1.length; _i++) {
                var type = types_1[_i];
                i++;
                if (checkTruncationLength(context) && i + 2 < types.length - 1) {
                  result_3.push(ts2.createTypeReferenceNode("... " + (types.length - i) + " more ...", void 0));
                  var typeNode_1 = typeToTypeNodeHelper(types[types.length - 1], context);
                  if (typeNode_1) {
                    result_3.push(typeNode_1);
                  }
                  break;
                }
                context.approximateLength += 2;
                var typeNode = typeToTypeNodeHelper(type, context);
                if (typeNode) {
                  result_3.push(typeNode);
                  if (seenNames && ts2.isIdentifierTypeReference(typeNode)) {
                    seenNames.add(typeNode.typeName.escapedText, [type, result_3.length - 1]);
                  }
                }
              }
              if (seenNames) {
                var saveContextFlags = context.flags;
                context.flags |= 64;
                seenNames.forEach(function(types2) {
                  if (!ts2.arrayIsHomogeneous(types2, function(_a2, _b) {
                    var a = _a2[0];
                    var b = _b[0];
                    return typesAreSameReference(a, b);
                  })) {
                    for (var _i2 = 0, types_2 = types2; _i2 < types_2.length; _i2++) {
                      var _a = types_2[_i2], type2 = _a[0], resultIndex = _a[1];
                      result_3[resultIndex] = typeToTypeNodeHelper(type2, context);
                    }
                  }
                });
                context.flags = saveContextFlags;
              }
              return result_3;
            }
          }
          function typesAreSameReference(a, b) {
            return a === b || !!a.symbol && a.symbol === b.symbol || !!a.aliasSymbol && a.aliasSymbol === b.aliasSymbol;
          }
          function indexInfoToIndexSignatureDeclarationHelper(indexInfo, kind, context) {
            var name = ts2.getNameFromIndexInfo(indexInfo) || "x";
            var indexerTypeNode = ts2.createKeywordTypeNode(kind === 0 ? 143 : 140);
            var indexingParameter = ts2.createParameter(void 0, void 0, void 0, name, void 0, indexerTypeNode, void 0);
            var typeNode = typeToTypeNodeHelper(indexInfo.type || anyType, context);
            if (!indexInfo.type && !(context.flags & 2097152)) {
              context.encounteredError = true;
            }
            context.approximateLength += name.length + 4;
            return ts2.createIndexSignature(void 0, indexInfo.isReadonly ? [ts2.createToken(138)] : void 0, [indexingParameter], typeNode);
          }
          function signatureToSignatureDeclarationHelper(signature, kind, context, privateSymbolVisitor, bundledImports) {
            var suppressAny = context.flags & 256;
            if (suppressAny)
              context.flags &= ~256;
            var typeParameters;
            var typeArguments;
            if (context.flags & 32 && signature.target && signature.mapper && signature.target.typeParameters) {
              typeArguments = signature.target.typeParameters.map(function(parameter) {
                return typeToTypeNodeHelper(instantiateType(parameter, signature.mapper), context);
              });
            } else {
              typeParameters = signature.typeParameters && signature.typeParameters.map(function(parameter) {
                return typeParameterToDeclaration(parameter, context);
              });
            }
            var parameters = getExpandedParameters(signature).map(function(parameter) {
              return symbolToParameterDeclaration(parameter, context, kind === 162, privateSymbolVisitor, bundledImports);
            });
            if (signature.thisParameter) {
              var thisParameter = symbolToParameterDeclaration(signature.thisParameter, context);
              parameters.unshift(thisParameter);
            }
            var returnTypeNode;
            var typePredicate = getTypePredicateOfSignature(signature);
            if (typePredicate) {
              var assertsModifier = typePredicate.kind === 2 || typePredicate.kind === 3 ? ts2.createToken(124) : void 0;
              var parameterName = typePredicate.kind === 1 || typePredicate.kind === 3 ? ts2.setEmitFlags(ts2.createIdentifier(typePredicate.parameterName), 16777216) : ts2.createThisTypeNode();
              var typeNode = typePredicate.type && typeToTypeNodeHelper(typePredicate.type, context);
              returnTypeNode = ts2.createTypePredicateNodeWithModifier(assertsModifier, parameterName, typeNode);
            } else {
              var returnType = getReturnTypeOfSignature(signature);
              if (returnType && !(suppressAny && isTypeAny(returnType))) {
                returnTypeNode = serializeReturnTypeForSignature(context, returnType, signature, privateSymbolVisitor, bundledImports);
              } else if (!suppressAny) {
                returnTypeNode = ts2.createKeywordTypeNode(125);
              }
            }
            context.approximateLength += 3;
            return ts2.createSignatureDeclaration(kind, typeParameters, parameters, returnTypeNode, typeArguments);
          }
          function typeParameterToDeclarationWithConstraint(type, context, constraintNode) {
            var savedContextFlags = context.flags;
            context.flags &= ~512;
            var name = typeParameterToName(type, context);
            var defaultParameter = getDefaultFromTypeParameter(type);
            var defaultParameterNode = defaultParameter && typeToTypeNodeHelper(defaultParameter, context);
            context.flags = savedContextFlags;
            return ts2.createTypeParameterDeclaration(name, constraintNode, defaultParameterNode);
          }
          function typeParameterToDeclaration(type, context, constraint) {
            if (constraint === void 0) {
              constraint = getConstraintOfTypeParameter(type);
            }
            var constraintNode = constraint && typeToTypeNodeHelper(constraint, context);
            return typeParameterToDeclarationWithConstraint(type, context, constraintNode);
          }
          function symbolToParameterDeclaration(parameterSymbol, context, preserveModifierFlags, privateSymbolVisitor, bundledImports) {
            var parameterDeclaration = ts2.getDeclarationOfKind(parameterSymbol, 156);
            if (!parameterDeclaration && !ts2.isTransientSymbol(parameterSymbol)) {
              parameterDeclaration = ts2.getDeclarationOfKind(parameterSymbol, 317);
            }
            var parameterType = getTypeOfSymbol(parameterSymbol);
            if (parameterDeclaration && isRequiredInitializedParameter(parameterDeclaration)) {
              parameterType = getOptionalType(parameterType);
            }
            var parameterTypeNode = serializeTypeForDeclaration(context, parameterType, parameterSymbol, context.enclosingDeclaration, privateSymbolVisitor, bundledImports);
            var modifiers = !(context.flags & 8192) && preserveModifierFlags && parameterDeclaration && parameterDeclaration.modifiers ? parameterDeclaration.modifiers.map(ts2.getSynthesizedClone) : void 0;
            var isRest = parameterDeclaration && ts2.isRestParameter(parameterDeclaration) || ts2.getCheckFlags(parameterSymbol) & 32768;
            var dotDotDotToken = isRest ? ts2.createToken(25) : void 0;
            var name = parameterDeclaration ? parameterDeclaration.name ? parameterDeclaration.name.kind === 75 ? ts2.setEmitFlags(ts2.getSynthesizedClone(parameterDeclaration.name), 16777216) : parameterDeclaration.name.kind === 153 ? ts2.setEmitFlags(ts2.getSynthesizedClone(parameterDeclaration.name.right), 16777216) : cloneBindingName(parameterDeclaration.name) : ts2.symbolName(parameterSymbol) : ts2.symbolName(parameterSymbol);
            var isOptional = parameterDeclaration && isOptionalParameter(parameterDeclaration) || ts2.getCheckFlags(parameterSymbol) & 16384;
            var questionToken = isOptional ? ts2.createToken(57) : void 0;
            var parameterNode = ts2.createParameter(void 0, modifiers, dotDotDotToken, name, questionToken, parameterTypeNode, void 0);
            context.approximateLength += ts2.symbolName(parameterSymbol).length + 3;
            return parameterNode;
            function cloneBindingName(node) {
              return elideInitializerAndSetEmitFlags(node);
              function elideInitializerAndSetEmitFlags(node2) {
                if (context.tracker.trackSymbol && ts2.isComputedPropertyName(node2) && isLateBindableName(node2)) {
                  trackComputedName(node2.expression, context.enclosingDeclaration, context);
                }
                var visited = ts2.visitEachChild(node2, elideInitializerAndSetEmitFlags, ts2.nullTransformationContext, void 0, elideInitializerAndSetEmitFlags);
                var clone = ts2.nodeIsSynthesized(visited) ? visited : ts2.getSynthesizedClone(visited);
                if (clone.kind === 191) {
                  clone.initializer = void 0;
                }
                return ts2.setEmitFlags(clone, 1 | 16777216);
              }
            }
          }
          function trackComputedName(accessExpression, enclosingDeclaration, context) {
            if (!context.tracker.trackSymbol)
              return;
            var firstIdentifier = ts2.getFirstIdentifier(accessExpression);
            var name = resolveName(firstIdentifier, firstIdentifier.escapedText, 111551 | 1048576, void 0, void 0, true);
            if (name) {
              context.tracker.trackSymbol(name, enclosingDeclaration, 111551);
            }
          }
          function lookupSymbolChain(symbol, context, meaning, yieldModuleSymbol) {
            context.tracker.trackSymbol(symbol, context.enclosingDeclaration, meaning);
            return lookupSymbolChainWorker(symbol, context, meaning, yieldModuleSymbol);
          }
          function lookupSymbolChainWorker(symbol, context, meaning, yieldModuleSymbol) {
            var chain;
            var isTypeParameter = symbol.flags & 262144;
            if (!isTypeParameter && (context.enclosingDeclaration || context.flags & 64) && !(context.flags & 134217728)) {
              chain = ts2.Debug.checkDefined(getSymbolChain(symbol, meaning, true));
              ts2.Debug.assert(chain && chain.length > 0);
            } else {
              chain = [symbol];
            }
            return chain;
            function getSymbolChain(symbol2, meaning2, endOfChain) {
              var accessibleSymbolChain = getAccessibleSymbolChain(symbol2, context.enclosingDeclaration, meaning2, !!(context.flags & 128));
              var parentSpecifiers;
              if (!accessibleSymbolChain || needsQualification(accessibleSymbolChain[0], context.enclosingDeclaration, accessibleSymbolChain.length === 1 ? meaning2 : getQualifiedLeftMeaning(meaning2))) {
                var parents_1 = getContainersOfSymbol(accessibleSymbolChain ? accessibleSymbolChain[0] : symbol2, context.enclosingDeclaration);
                if (ts2.length(parents_1)) {
                  parentSpecifiers = parents_1.map(function(symbol3) {
                    return ts2.some(symbol3.declarations, hasNonGlobalAugmentationExternalModuleSymbol) ? getSpecifierForModuleSymbol(symbol3, context) : void 0;
                  });
                  var indices = parents_1.map(function(_, i) {
                    return i;
                  });
                  indices.sort(sortByBestName);
                  var sortedParents = indices.map(function(i) {
                    return parents_1[i];
                  });
                  for (var _i = 0, sortedParents_1 = sortedParents; _i < sortedParents_1.length; _i++) {
                    var parent = sortedParents_1[_i];
                    var parentChain = getSymbolChain(parent, getQualifiedLeftMeaning(meaning2), false);
                    if (parentChain) {
                      if (parent.exports && parent.exports.get("export=") && getSymbolIfSameReference(parent.exports.get("export="), symbol2)) {
                        accessibleSymbolChain = parentChain;
                        break;
                      }
                      accessibleSymbolChain = parentChain.concat(accessibleSymbolChain || [getAliasForSymbolInContainer(parent, symbol2) || symbol2]);
                      break;
                    }
                  }
                }
              }
              if (accessibleSymbolChain) {
                return accessibleSymbolChain;
              }
              if (endOfChain || !(symbol2.flags & (2048 | 4096))) {
                if (!endOfChain && !yieldModuleSymbol && !!ts2.forEach(symbol2.declarations, hasNonGlobalAugmentationExternalModuleSymbol)) {
                  return;
                }
                return [symbol2];
              }
              function sortByBestName(a, b) {
                var specifierA = parentSpecifiers[a];
                var specifierB = parentSpecifiers[b];
                if (specifierA && specifierB) {
                  var isBRelative = ts2.pathIsRelative(specifierB);
                  if (ts2.pathIsRelative(specifierA) === isBRelative) {
                    return ts2.moduleSpecifiers.countPathComponents(specifierA) - ts2.moduleSpecifiers.countPathComponents(specifierB);
                  }
                  if (isBRelative) {
                    return -1;
                  }
                  return 1;
                }
                return 0;
              }
            }
          }
          function typeParametersToTypeParameterDeclarations(symbol, context) {
            var typeParameterNodes;
            var targetSymbol = getTargetSymbol(symbol);
            if (targetSymbol.flags & (32 | 64 | 524288)) {
              typeParameterNodes = ts2.createNodeArray(ts2.map(getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol), function(tp) {
                return typeParameterToDeclaration(tp, context);
              }));
            }
            return typeParameterNodes;
          }
          function lookupTypeParameterNodes(chain, index, context) {
            ts2.Debug.assert(chain && 0 <= index && index < chain.length);
            var symbol = chain[index];
            var symbolId = "" + getSymbolId(symbol);
            if (context.typeParameterSymbolList && context.typeParameterSymbolList.get(symbolId)) {
              return void 0;
            }
            (context.typeParameterSymbolList || (context.typeParameterSymbolList = ts2.createMap())).set(symbolId, true);
            var typeParameterNodes;
            if (context.flags & 512 && index < chain.length - 1) {
              var parentSymbol = symbol;
              var nextSymbol_1 = chain[index + 1];
              if (ts2.getCheckFlags(nextSymbol_1) & 1) {
                var params = getTypeParametersOfClassOrInterface(parentSymbol.flags & 2097152 ? resolveAlias(parentSymbol) : parentSymbol);
                typeParameterNodes = mapToTypeNodes(ts2.map(params, function(t) {
                  return getMappedType(t, nextSymbol_1.mapper);
                }), context);
              } else {
                typeParameterNodes = typeParametersToTypeParameterDeclarations(symbol, context);
              }
            }
            return typeParameterNodes;
          }
          function getTopmostIndexedAccessType(top) {
            if (ts2.isIndexedAccessTypeNode(top.objectType)) {
              return getTopmostIndexedAccessType(top.objectType);
            }
            return top;
          }
          function getSpecifierForModuleSymbol(symbol, context) {
            var file = ts2.getDeclarationOfKind(symbol, 290);
            if (!file) {
              var equivalentFileSymbol = ts2.firstDefined(symbol.declarations, function(d) {
                return getFileSymbolIfFileSymbolExportEqualsContainer(d, symbol);
              });
              if (equivalentFileSymbol) {
                file = ts2.getDeclarationOfKind(equivalentFileSymbol, 290);
              }
            }
            if (file && file.moduleName !== void 0) {
              return file.moduleName;
            }
            if (!file) {
              if (context.tracker.trackReferencedAmbientModule) {
                var ambientDecls = ts2.filter(symbol.declarations, ts2.isAmbientModule);
                if (ts2.length(ambientDecls)) {
                  for (var _i = 0, ambientDecls_1 = ambientDecls; _i < ambientDecls_1.length; _i++) {
                    var decl = ambientDecls_1[_i];
                    context.tracker.trackReferencedAmbientModule(decl, symbol);
                  }
                }
              }
              if (ambientModuleSymbolRegex.test(symbol.escapedName)) {
                return symbol.escapedName.substring(1, symbol.escapedName.length - 1);
              }
            }
            if (!context.enclosingDeclaration || !context.tracker.moduleResolverHost) {
              if (ambientModuleSymbolRegex.test(symbol.escapedName)) {
                return symbol.escapedName.substring(1, symbol.escapedName.length - 1);
              }
              return ts2.getSourceFileOfNode(ts2.getNonAugmentationDeclaration(symbol)).fileName;
            }
            var contextFile = ts2.getSourceFileOfNode(ts2.getOriginalNode(context.enclosingDeclaration));
            var links = getSymbolLinks(symbol);
            var specifier = links.specifierCache && links.specifierCache.get(contextFile.path);
            if (!specifier) {
              var isBundle_1 = compilerOptions.out || compilerOptions.outFile;
              var moduleResolverHost = context.tracker.moduleResolverHost;
              var specifierCompilerOptions = isBundle_1 ? __assign(__assign({}, compilerOptions), { baseUrl: moduleResolverHost.getCommonSourceDirectory() }) : compilerOptions;
              specifier = ts2.first(ts2.moduleSpecifiers.getModuleSpecifiers(symbol, specifierCompilerOptions, contextFile, moduleResolverHost, { importModuleSpecifierPreference: isBundle_1 ? "non-relative" : "relative" }));
              links.specifierCache = links.specifierCache || ts2.createMap();
              links.specifierCache.set(contextFile.path, specifier);
            }
            return specifier;
          }
          function symbolToTypeNode(symbol, context, meaning, overrideTypeArguments) {
            var chain = lookupSymbolChain(symbol, context, meaning, !(context.flags & 16384));
            var isTypeOf = meaning === 111551;
            if (ts2.some(chain[0].declarations, hasNonGlobalAugmentationExternalModuleSymbol)) {
              var nonRootParts = chain.length > 1 ? createAccessFromSymbolChain(chain, chain.length - 1, 1) : void 0;
              var typeParameterNodes = overrideTypeArguments || lookupTypeParameterNodes(chain, 0, context);
              var specifier = getSpecifierForModuleSymbol(chain[0], context);
              if (!(context.flags & 67108864) && ts2.getEmitModuleResolutionKind(compilerOptions) === ts2.ModuleResolutionKind.NodeJs && specifier.indexOf("/node_modules/") >= 0) {
                context.encounteredError = true;
                if (context.tracker.reportLikelyUnsafeImportRequiredError) {
                  context.tracker.reportLikelyUnsafeImportRequiredError(specifier);
                }
              }
              var lit = ts2.createLiteralTypeNode(ts2.createLiteral(specifier));
              if (context.tracker.trackExternalModuleSymbolOfImportTypeNode)
                context.tracker.trackExternalModuleSymbolOfImportTypeNode(chain[0]);
              context.approximateLength += specifier.length + 10;
              if (!nonRootParts || ts2.isEntityName(nonRootParts)) {
                if (nonRootParts) {
                  var lastId = ts2.isIdentifier(nonRootParts) ? nonRootParts : nonRootParts.right;
                  lastId.typeArguments = void 0;
                }
                return ts2.createImportTypeNode(lit, nonRootParts, typeParameterNodes, isTypeOf);
              } else {
                var splitNode = getTopmostIndexedAccessType(nonRootParts);
                var qualifier = splitNode.objectType.typeName;
                return ts2.createIndexedAccessTypeNode(ts2.createImportTypeNode(lit, qualifier, typeParameterNodes, isTypeOf), splitNode.indexType);
              }
            }
            var entityName = createAccessFromSymbolChain(chain, chain.length - 1, 0);
            if (ts2.isIndexedAccessTypeNode(entityName)) {
              return entityName;
            }
            if (isTypeOf) {
              return ts2.createTypeQueryNode(entityName);
            } else {
              var lastId = ts2.isIdentifier(entityName) ? entityName : entityName.right;
              var lastTypeArgs = lastId.typeArguments;
              lastId.typeArguments = void 0;
              return ts2.createTypeReferenceNode(entityName, lastTypeArgs);
            }
            function createAccessFromSymbolChain(chain2, index, stopper) {
              var typeParameterNodes2 = index === chain2.length - 1 ? overrideTypeArguments : lookupTypeParameterNodes(chain2, index, context);
              var symbol2 = chain2[index];
              var parent = chain2[index - 1];
              var symbolName;
              if (index === 0) {
                context.flags |= 16777216;
                symbolName = getNameOfSymbolAsWritten(symbol2, context);
                context.approximateLength += (symbolName ? symbolName.length : 0) + 1;
                context.flags ^= 16777216;
              } else {
                if (parent && getExportsOfSymbol(parent)) {
                  var exports_1 = getExportsOfSymbol(parent);
                  ts2.forEachEntry(exports_1, function(ex, name) {
                    if (getSymbolIfSameReference(ex, symbol2) && !isLateBoundName(name) && name !== "export=") {
                      symbolName = ts2.unescapeLeadingUnderscores(name);
                      return true;
                    }
                  });
                }
              }
              if (!symbolName) {
                symbolName = getNameOfSymbolAsWritten(symbol2, context);
              }
              context.approximateLength += symbolName.length + 1;
              if (!(context.flags & 16) && parent && getMembersOfSymbol(parent) && getMembersOfSymbol(parent).get(symbol2.escapedName) && getSymbolIfSameReference(getMembersOfSymbol(parent).get(symbol2.escapedName), symbol2)) {
                var LHS = createAccessFromSymbolChain(chain2, index - 1, stopper);
                if (ts2.isIndexedAccessTypeNode(LHS)) {
                  return ts2.createIndexedAccessTypeNode(LHS, ts2.createLiteralTypeNode(ts2.createLiteral(symbolName)));
                } else {
                  return ts2.createIndexedAccessTypeNode(ts2.createTypeReferenceNode(LHS, typeParameterNodes2), ts2.createLiteralTypeNode(ts2.createLiteral(symbolName)));
                }
              }
              var identifier = ts2.setEmitFlags(ts2.createIdentifier(symbolName, typeParameterNodes2), 16777216);
              identifier.symbol = symbol2;
              if (index > stopper) {
                var LHS = createAccessFromSymbolChain(chain2, index - 1, stopper);
                if (!ts2.isEntityName(LHS)) {
                  return ts2.Debug.fail("Impossible construct - an export of an indexed access cannot be reachable");
                }
                return ts2.createQualifiedName(LHS, identifier);
              }
              return identifier;
            }
          }
          function typeParameterShadowsNameInScope(escapedName, context, type) {
            var result = resolveName(context.enclosingDeclaration, escapedName, 788968, void 0, escapedName, false);
            if (result) {
              if (result.flags & 262144 && result === type.symbol) {
                return false;
              }
              return true;
            }
            return false;
          }
          function typeParameterToName(type, context) {
            if (context.flags & 4 && context.typeParameterNames) {
              var cached = context.typeParameterNames.get("" + getTypeId(type));
              if (cached) {
                return cached;
              }
            }
            var result = symbolToName(type.symbol, context, 788968, true);
            if (!(result.kind & 75)) {
              return ts2.createIdentifier("(Missing type parameter)");
            }
            if (context.flags & 4) {
              var rawtext = result.escapedText;
              var i = 0;
              var text = rawtext;
              while (context.typeParameterNamesByText && context.typeParameterNamesByText.get(text) || typeParameterShadowsNameInScope(text, context, type)) {
                i++;
                text = rawtext + "_" + i;
              }
              if (text !== rawtext) {
                result = ts2.createIdentifier(text, result.typeArguments);
              }
              (context.typeParameterNames || (context.typeParameterNames = ts2.createMap())).set("" + getTypeId(type), result);
              (context.typeParameterNamesByText || (context.typeParameterNamesByText = ts2.createMap())).set(result.escapedText, true);
            }
            return result;
          }
          function symbolToName(symbol, context, meaning, expectsIdentifier) {
            var chain = lookupSymbolChain(symbol, context, meaning);
            if (expectsIdentifier && chain.length !== 1 && !context.encounteredError && !(context.flags & 65536)) {
              context.encounteredError = true;
            }
            return createEntityNameFromSymbolChain(chain, chain.length - 1);
            function createEntityNameFromSymbolChain(chain2, index) {
              var typeParameterNodes = lookupTypeParameterNodes(chain2, index, context);
              var symbol2 = chain2[index];
              if (index === 0) {
                context.flags |= 16777216;
              }
              var symbolName = getNameOfSymbolAsWritten(symbol2, context);
              if (index === 0) {
                context.flags ^= 16777216;
              }
              var identifier = ts2.setEmitFlags(ts2.createIdentifier(symbolName, typeParameterNodes), 16777216);
              identifier.symbol = symbol2;
              return index > 0 ? ts2.createQualifiedName(createEntityNameFromSymbolChain(chain2, index - 1), identifier) : identifier;
            }
          }
          function symbolToExpression(symbol, context, meaning) {
            var chain = lookupSymbolChain(symbol, context, meaning);
            return createExpressionFromSymbolChain(chain, chain.length - 1);
            function createExpressionFromSymbolChain(chain2, index) {
              var typeParameterNodes = lookupTypeParameterNodes(chain2, index, context);
              var symbol2 = chain2[index];
              if (index === 0) {
                context.flags |= 16777216;
              }
              var symbolName = getNameOfSymbolAsWritten(symbol2, context);
              if (index === 0) {
                context.flags ^= 16777216;
              }
              var firstChar = symbolName.charCodeAt(0);
              if (ts2.isSingleOrDoubleQuote(firstChar) && ts2.some(symbol2.declarations, hasNonGlobalAugmentationExternalModuleSymbol)) {
                return ts2.createLiteral(getSpecifierForModuleSymbol(symbol2, context));
              }
              var canUsePropertyAccess = firstChar === 35 ? symbolName.length > 1 && ts2.isIdentifierStart(symbolName.charCodeAt(1), languageVersion) : ts2.isIdentifierStart(firstChar, languageVersion);
              if (index === 0 || canUsePropertyAccess) {
                var identifier = ts2.setEmitFlags(ts2.createIdentifier(symbolName, typeParameterNodes), 16777216);
                identifier.symbol = symbol2;
                return index > 0 ? ts2.createPropertyAccess(createExpressionFromSymbolChain(chain2, index - 1), identifier) : identifier;
              } else {
                if (firstChar === 91) {
                  symbolName = symbolName.substring(1, symbolName.length - 1);
                  firstChar = symbolName.charCodeAt(0);
                }
                var expression = void 0;
                if (ts2.isSingleOrDoubleQuote(firstChar)) {
                  expression = ts2.createLiteral(symbolName.substring(1, symbolName.length - 1).replace(/\\./g, function(s) {
                    return s.substring(1);
                  }));
                  expression.singleQuote = firstChar === 39;
                } else if ("" + +symbolName === symbolName) {
                  expression = ts2.createLiteral(+symbolName);
                }
                if (!expression) {
                  expression = ts2.setEmitFlags(ts2.createIdentifier(symbolName, typeParameterNodes), 16777216);
                  expression.symbol = symbol2;
                }
                return ts2.createElementAccess(createExpressionFromSymbolChain(chain2, index - 1), expression);
              }
            }
          }
          function isSingleQuotedStringNamed(d) {
            var name = ts2.getNameOfDeclaration(d);
            if (name && ts2.isStringLiteral(name) && (name.singleQuote || !ts2.nodeIsSynthesized(name) && ts2.startsWith(ts2.getTextOfNode(name, false), "'"))) {
              return true;
            }
            return false;
          }
          function getPropertyNameNodeForSymbol(symbol, context) {
            var singleQuote = !!ts2.length(symbol.declarations) && ts2.every(symbol.declarations, isSingleQuotedStringNamed);
            var fromNameType = getPropertyNameNodeForSymbolFromNameType(symbol, context, singleQuote);
            if (fromNameType) {
              return fromNameType;
            }
            if (ts2.isKnownSymbol(symbol)) {
              return ts2.createComputedPropertyName(ts2.createPropertyAccess(ts2.createIdentifier("Symbol"), symbol.escapedName.substr(3)));
            }
            var rawName = ts2.unescapeLeadingUnderscores(symbol.escapedName);
            return createPropertyNameNodeForIdentifierOrLiteral(rawName, singleQuote);
          }
          function getPropertyNameNodeForSymbolFromNameType(symbol, context, singleQuote) {
            var nameType = getSymbolLinks(symbol).nameType;
            if (nameType) {
              if (nameType.flags & 384) {
                var name = "" + nameType.value;
                if (!ts2.isIdentifierText(name, compilerOptions.target) && !isNumericLiteralName(name)) {
                  return ts2.createLiteral(name, !!singleQuote);
                }
                if (isNumericLiteralName(name) && ts2.startsWith(name, "-")) {
                  return ts2.createComputedPropertyName(ts2.createLiteral(+name));
                }
                return createPropertyNameNodeForIdentifierOrLiteral(name);
              }
              if (nameType.flags & 8192) {
                return ts2.createComputedPropertyName(symbolToExpression(nameType.symbol, context, 111551));
              }
            }
          }
          function createPropertyNameNodeForIdentifierOrLiteral(name, singleQuote) {
            return ts2.isIdentifierText(name, compilerOptions.target) ? ts2.createIdentifier(name) : ts2.createLiteral(isNumericLiteralName(name) && +name >= 0 ? +name : name, !!singleQuote);
          }
          function cloneNodeBuilderContext(context) {
            var initial = __assign({}, context);
            if (initial.typeParameterNames) {
              initial.typeParameterNames = ts2.cloneMap(initial.typeParameterNames);
            }
            if (initial.typeParameterNamesByText) {
              initial.typeParameterNamesByText = ts2.cloneMap(initial.typeParameterNamesByText);
            }
            if (initial.typeParameterSymbolList) {
              initial.typeParameterSymbolList = ts2.cloneMap(initial.typeParameterSymbolList);
            }
            return initial;
          }
          function getDeclarationWithTypeAnnotation(symbol, enclosingDeclaration) {
            return symbol.declarations && ts2.find(symbol.declarations, function(s) {
              return !!ts2.getEffectiveTypeAnnotationNode(s) && (!enclosingDeclaration || !!ts2.findAncestor(s, function(n) {
                return n === enclosingDeclaration;
              }));
            });
          }
          function existingTypeNodeIsNotReferenceOrIsReferenceWithCompatibleTypeArgumentCount(existing, type) {
            return !(ts2.getObjectFlags(type) & 4) || !ts2.isTypeReferenceNode(existing) || ts2.length(existing.typeArguments) >= getMinTypeArgumentCount(type.target.typeParameters);
          }
          function serializeTypeForDeclaration(context, type, symbol, enclosingDeclaration, includePrivateSymbol, bundled) {
            if (type !== errorType && enclosingDeclaration) {
              var declWithExistingAnnotation = getDeclarationWithTypeAnnotation(symbol, enclosingDeclaration);
              if (declWithExistingAnnotation && !ts2.isFunctionLikeDeclaration(declWithExistingAnnotation)) {
                var existing = ts2.getEffectiveTypeAnnotationNode(declWithExistingAnnotation);
                if (getTypeFromTypeNode(existing) === type && existingTypeNodeIsNotReferenceOrIsReferenceWithCompatibleTypeArgumentCount(existing, type)) {
                  var result_4 = serializeExistingTypeNode(context, existing, includePrivateSymbol, bundled);
                  if (result_4) {
                    return result_4;
                  }
                }
              }
            }
            var oldFlags = context.flags;
            if (type.flags & 8192 && type.symbol === symbol) {
              context.flags |= 1048576;
            }
            var result = typeToTypeNodeHelper(type, context);
            context.flags = oldFlags;
            return result;
          }
          function serializeReturnTypeForSignature(context, type, signature, includePrivateSymbol, bundled) {
            if (type !== errorType && context.enclosingDeclaration) {
              var annotation = signature.declaration && ts2.getEffectiveReturnTypeNode(signature.declaration);
              if (!!ts2.findAncestor(annotation, function(n) {
                return n === context.enclosingDeclaration;
              }) && annotation && instantiateType(getTypeFromTypeNode(annotation), signature.mapper) === type && existingTypeNodeIsNotReferenceOrIsReferenceWithCompatibleTypeArgumentCount(annotation, type)) {
                var result = serializeExistingTypeNode(context, annotation, includePrivateSymbol, bundled);
                if (result) {
                  return result;
                }
              }
            }
            return typeToTypeNodeHelper(type, context);
          }
          function serializeExistingTypeNode(context, existing, includePrivateSymbol, bundled) {
            if (cancellationToken && cancellationToken.throwIfCancellationRequested) {
              cancellationToken.throwIfCancellationRequested();
            }
            var hadError = false;
            var transformed = ts2.visitNode(existing, visitExistingNodeTreeSymbols);
            if (hadError) {
              return void 0;
            }
            return transformed === existing ? ts2.getMutableClone(existing) : transformed;
            function visitExistingNodeTreeSymbols(node) {
              var _a, _b;
              if (ts2.isJSDocAllType(node) || node.kind === 302) {
                return ts2.createKeywordTypeNode(125);
              }
              if (ts2.isJSDocUnknownType(node)) {
                return ts2.createKeywordTypeNode(148);
              }
              if (ts2.isJSDocNullableType(node)) {
                return ts2.createUnionTypeNode([ts2.visitNode(node.type, visitExistingNodeTreeSymbols), ts2.createKeywordTypeNode(100)]);
              }
              if (ts2.isJSDocOptionalType(node)) {
                return ts2.createUnionTypeNode([ts2.visitNode(node.type, visitExistingNodeTreeSymbols), ts2.createKeywordTypeNode(146)]);
              }
              if (ts2.isJSDocNonNullableType(node)) {
                return ts2.visitNode(node.type, visitExistingNodeTreeSymbols);
              }
              if (ts2.isJSDocVariadicType(node)) {
                return ts2.createArrayTypeNode(ts2.visitNode(node.type, visitExistingNodeTreeSymbols));
              }
              if (ts2.isJSDocTypeLiteral(node)) {
                return ts2.createTypeLiteralNode(ts2.map(node.jsDocPropertyTags, function(t) {
                  var name2 = ts2.isIdentifier(t.name) ? t.name : t.name.right;
                  var typeViaParent = getTypeOfPropertyOfType(getTypeFromTypeNode(node), name2.escapedText);
                  var overrideTypeNode = typeViaParent && t.typeExpression && getTypeFromTypeNode(t.typeExpression.type) !== typeViaParent ? typeToTypeNodeHelper(typeViaParent, context) : void 0;
                  return ts2.createPropertySignature(void 0, name2, t.typeExpression && ts2.isJSDocOptionalType(t.typeExpression.type) ? ts2.createToken(57) : void 0, overrideTypeNode || t.typeExpression && ts2.visitNode(t.typeExpression.type, visitExistingNodeTreeSymbols) || ts2.createKeywordTypeNode(125), void 0);
                }));
              }
              if (ts2.isTypeReferenceNode(node) && ts2.isIdentifier(node.typeName) && node.typeName.escapedText === "") {
                return ts2.setOriginalNode(ts2.createKeywordTypeNode(125), node);
              }
              if ((ts2.isExpressionWithTypeArguments(node) || ts2.isTypeReferenceNode(node)) && ts2.isJSDocIndexSignature(node)) {
                return ts2.createTypeLiteralNode([ts2.createIndexSignature(void 0, void 0, [ts2.createParameter(void 0, void 0, void 0, "x", void 0, ts2.visitNode(node.typeArguments[0], visitExistingNodeTreeSymbols))], ts2.visitNode(node.typeArguments[1], visitExistingNodeTreeSymbols))]);
              }
              if (ts2.isJSDocFunctionType(node)) {
                if (ts2.isJSDocConstructSignature(node)) {
                  var newTypeNode_1;
                  return ts2.createConstructorTypeNode(ts2.visitNodes(node.typeParameters, visitExistingNodeTreeSymbols), ts2.mapDefined(node.parameters, function(p, i) {
                    return p.name && ts2.isIdentifier(p.name) && p.name.escapedText === "new" ? (newTypeNode_1 = p.type, void 0) : ts2.createParameter(void 0, void 0, getEffectiveDotDotDotForParameter(p), p.name || getEffectiveDotDotDotForParameter(p) ? "args" : "arg" + i, p.questionToken, ts2.visitNode(p.type, visitExistingNodeTreeSymbols), void 0);
                  }), ts2.visitNode(newTypeNode_1 || node.type, visitExistingNodeTreeSymbols));
                } else {
                  return ts2.createFunctionTypeNode(ts2.visitNodes(node.typeParameters, visitExistingNodeTreeSymbols), ts2.map(node.parameters, function(p, i) {
                    return ts2.createParameter(void 0, void 0, getEffectiveDotDotDotForParameter(p), p.name || getEffectiveDotDotDotForParameter(p) ? "args" : "arg" + i, p.questionToken, ts2.visitNode(p.type, visitExistingNodeTreeSymbols), void 0);
                  }), ts2.visitNode(node.type, visitExistingNodeTreeSymbols));
                }
              }
              if (ts2.isTypeReferenceNode(node) && ts2.isInJSDoc(node) && (getIntendedTypeFromJSDocTypeReference(node) || unknownSymbol === resolveTypeReferenceName(getTypeReferenceName(node), 788968, true))) {
                return ts2.setOriginalNode(typeToTypeNodeHelper(getTypeFromTypeNode(node), context), node);
              }
              if (ts2.isLiteralImportTypeNode(node)) {
                return ts2.updateImportTypeNode(node, ts2.updateLiteralTypeNode(node.argument, rewriteModuleSpecifier(node, node.argument.literal)), node.qualifier, ts2.visitNodes(node.typeArguments, visitExistingNodeTreeSymbols, ts2.isTypeNode), node.isTypeOf);
              }
              if (ts2.isEntityName(node) || ts2.isEntityNameExpression(node)) {
                var leftmost = ts2.getFirstIdentifier(node);
                if (ts2.isInJSFile(node) && (ts2.isExportsIdentifier(leftmost) || ts2.isModuleExportsAccessExpression(leftmost.parent) || ts2.isQualifiedName(leftmost.parent) && ts2.isModuleIdentifier(leftmost.parent.left) && ts2.isExportsIdentifier(leftmost.parent.right))) {
                  hadError = true;
                  return node;
                }
                var sym = resolveEntityName(leftmost, 67108863, true, true);
                if (sym) {
                  if (isSymbolAccessible(sym, context.enclosingDeclaration, 67108863, false).accessibility !== 0) {
                    hadError = true;
                  } else {
                    (_b = (_a = context.tracker) === null || _a === void 0 ? void 0 : _a.trackSymbol) === null || _b === void 0 ? void 0 : _b.call(_a, sym, context.enclosingDeclaration, 67108863);
                    includePrivateSymbol === null || includePrivateSymbol === void 0 ? void 0 : includePrivateSymbol(sym);
                  }
                  if (ts2.isIdentifier(node)) {
                    var name = sym.flags & 262144 ? typeParameterToName(getDeclaredTypeOfSymbol(sym), context) : ts2.getMutableClone(node);
                    name.symbol = sym;
                    return ts2.setEmitFlags(ts2.setOriginalNode(name, node), 16777216);
                  }
                }
              }
              return ts2.visitEachChild(node, visitExistingNodeTreeSymbols, ts2.nullTransformationContext);
              function getEffectiveDotDotDotForParameter(p) {
                return p.dotDotDotToken || (p.type && ts2.isJSDocVariadicType(p.type) ? ts2.createToken(25) : void 0);
              }
              function rewriteModuleSpecifier(parent, lit) {
                if (bundled) {
                  if (context.tracker && context.tracker.moduleResolverHost) {
                    var targetFile = getExternalModuleFileFromDeclaration(parent);
                    if (targetFile) {
                      var getCanonicalFileName = ts2.createGetCanonicalFileName(!!host.useCaseSensitiveFileNames);
                      var resolverHost = {
                        getCanonicalFileName,
                        getCurrentDirectory: function() {
                          return context.tracker.moduleResolverHost.getCurrentDirectory();
                        },
                        getCommonSourceDirectory: function() {
                          return context.tracker.moduleResolverHost.getCommonSourceDirectory();
                        }
                      };
                      var newName = ts2.getResolvedExternalModuleName(resolverHost, targetFile);
                      return ts2.createLiteral(newName);
                    }
                  }
                } else {
                  if (context.tracker && context.tracker.trackExternalModuleSymbolOfImportTypeNode) {
                    var moduleSym = resolveExternalModuleNameWorker(lit, lit, void 0);
                    if (moduleSym) {
                      context.tracker.trackExternalModuleSymbolOfImportTypeNode(moduleSym);
                    }
                  }
                }
                return lit;
              }
            }
          }
          function symbolTableToDeclarationStatements(symbolTable, context, bundled) {
            var serializePropertySymbolForClass = makeSerializePropertySymbol(ts2.createProperty, 161, true);
            var serializePropertySymbolForInterfaceWorker = makeSerializePropertySymbol(function(_decorators, mods, name, question, type, initializer) {
              return ts2.createPropertySignature(mods, name, question, type, initializer);
            }, 160, false);
            var enclosingDeclaration = context.enclosingDeclaration;
            var results = [];
            var visitedSymbols = ts2.createMap();
            var deferredPrivates;
            var oldcontext = context;
            context = __assign(__assign({}, oldcontext), { usedSymbolNames: ts2.createMap(), remappedSymbolNames: ts2.createMap(), tracker: __assign(__assign({}, oldcontext.tracker), { trackSymbol: function(sym, decl, meaning) {
              var accessibleResult = isSymbolAccessible(sym, decl, meaning, false);
              if (accessibleResult.accessibility === 0) {
                var chain = lookupSymbolChainWorker(sym, context, meaning);
                if (!(sym.flags & 4)) {
                  includePrivateSymbol(chain[0]);
                }
              } else if (oldcontext.tracker && oldcontext.tracker.trackSymbol) {
                oldcontext.tracker.trackSymbol(sym, decl, meaning);
              }
            } }) });
            if (oldcontext.usedSymbolNames) {
              oldcontext.usedSymbolNames.forEach(function(_, name) {
                context.usedSymbolNames.set(name, true);
              });
            }
            ts2.forEachEntry(symbolTable, function(symbol, name) {
              var baseName = ts2.unescapeLeadingUnderscores(name);
              void getInternalSymbolName(symbol, baseName);
            });
            var addingDeclare = !bundled;
            var exportEquals = symbolTable.get("export=");
            if (exportEquals && symbolTable.size > 1 && exportEquals.flags & 2097152) {
              symbolTable = ts2.createSymbolTable();
              symbolTable.set("export=", exportEquals);
            }
            visitSymbolTable(symbolTable);
            return mergeRedundantStatements(results);
            function isIdentifierAndNotUndefined(node) {
              return !!node && node.kind === 75;
            }
            function getNamesOfDeclaration(statement) {
              if (ts2.isVariableStatement(statement)) {
                return ts2.filter(ts2.map(statement.declarationList.declarations, ts2.getNameOfDeclaration), isIdentifierAndNotUndefined);
              }
              return ts2.filter([ts2.getNameOfDeclaration(statement)], isIdentifierAndNotUndefined);
            }
            function flattenExportAssignedNamespace(statements) {
              var exportAssignment = ts2.find(statements, ts2.isExportAssignment);
              var ns = ts2.find(statements, ts2.isModuleDeclaration);
              if (ns && exportAssignment && exportAssignment.isExportEquals && ts2.isIdentifier(exportAssignment.expression) && ts2.isIdentifier(ns.name) && ts2.idText(ns.name) === ts2.idText(exportAssignment.expression) && ns.body && ts2.isModuleBlock(ns.body)) {
                var excessExports = ts2.filter(statements, function(s) {
                  return !!(ts2.getModifierFlags(s) & 1);
                });
                if (ts2.length(excessExports)) {
                  ns.body.statements = ts2.createNodeArray(__spreadArrays(ns.body.statements, [ts2.createExportDeclaration(void 0, void 0, ts2.createNamedExports(ts2.map(ts2.flatMap(excessExports, function(e) {
                    return getNamesOfDeclaration(e);
                  }), function(id) {
                    return ts2.createExportSpecifier(void 0, id);
                  })), void 0)]));
                }
                if (!ts2.find(statements, function(s) {
                  return s !== ns && ts2.nodeHasName(s, ns.name);
                })) {
                  results = [];
                  ts2.forEach(ns.body.statements, function(s) {
                    addResult(s, 0);
                  });
                  statements = __spreadArrays(ts2.filter(statements, function(s) {
                    return s !== ns && s !== exportAssignment;
                  }), results);
                }
              }
              return statements;
            }
            function mergeExportDeclarations(statements) {
              var exports2 = ts2.filter(statements, function(d) {
                return ts2.isExportDeclaration(d) && !d.moduleSpecifier && !!d.exportClause && ts2.isNamedExports(d.exportClause);
              });
              if (ts2.length(exports2) > 1) {
                var nonExports = ts2.filter(statements, function(d) {
                  return !ts2.isExportDeclaration(d) || !!d.moduleSpecifier || !d.exportClause;
                });
                statements = __spreadArrays(nonExports, [ts2.createExportDeclaration(void 0, void 0, ts2.createNamedExports(ts2.flatMap(exports2, function(e) {
                  return ts2.cast(e.exportClause, ts2.isNamedExports).elements;
                })), void 0)]);
              }
              var reexports = ts2.filter(statements, function(d) {
                return ts2.isExportDeclaration(d) && !!d.moduleSpecifier && !!d.exportClause && ts2.isNamedExports(d.exportClause);
              });
              if (ts2.length(reexports) > 1) {
                var groups = ts2.group(reexports, function(decl) {
                  return ts2.isStringLiteral(decl.moduleSpecifier) ? ">" + decl.moduleSpecifier.text : ">";
                });
                if (groups.length !== reexports.length) {
                  var _loop_8 = function(group_12) {
                    if (group_12.length > 1) {
                      statements = __spreadArrays(ts2.filter(statements, function(s) {
                        return group_12.indexOf(s) === -1;
                      }), [
                        ts2.createExportDeclaration(void 0, void 0, ts2.createNamedExports(ts2.flatMap(group_12, function(e) {
                          return ts2.cast(e.exportClause, ts2.isNamedExports).elements;
                        })), group_12[0].moduleSpecifier)
                      ]);
                    }
                  };
                  for (var _i = 0, groups_1 = groups; _i < groups_1.length; _i++) {
                    var group_1 = groups_1[_i];
                    _loop_8(group_1);
                  }
                }
              }
              return statements;
            }
            function inlineExportModifiers(statements) {
              var exportDecl = ts2.find(statements, function(d) {
                return ts2.isExportDeclaration(d) && !d.moduleSpecifier && !!d.exportClause;
              });
              if (exportDecl && exportDecl.exportClause && ts2.isNamedExports(exportDecl.exportClause)) {
                var replacements = ts2.mapDefined(exportDecl.exportClause.elements, function(e) {
                  if (!e.propertyName) {
                    var associated = ts2.filter(statements, function(s) {
                      return ts2.nodeHasName(s, e.name);
                    });
                    if (ts2.length(associated) && ts2.every(associated, canHaveExportModifier)) {
                      ts2.forEach(associated, addExportModifier);
                      return void 0;
                    }
                  }
                  return e;
                });
                if (!ts2.length(replacements)) {
                  statements = ts2.filter(statements, function(s) {
                    return s !== exportDecl;
                  });
                } else {
                  exportDecl.exportClause.elements = ts2.createNodeArray(replacements);
                }
              }
              return statements;
            }
            function mergeRedundantStatements(statements) {
              statements = flattenExportAssignedNamespace(statements);
              statements = mergeExportDeclarations(statements);
              statements = inlineExportModifiers(statements);
              if (enclosingDeclaration && (ts2.isSourceFile(enclosingDeclaration) && ts2.isExternalOrCommonJsModule(enclosingDeclaration) || ts2.isModuleDeclaration(enclosingDeclaration)) && (!ts2.some(statements, ts2.isExternalModuleIndicator) || !ts2.hasScopeMarker(statements) && ts2.some(statements, ts2.needsScopeMarker))) {
                statements.push(ts2.createEmptyExports());
              }
              return statements;
            }
            function canHaveExportModifier(node) {
              return ts2.isEnumDeclaration(node) || ts2.isVariableStatement(node) || ts2.isFunctionDeclaration(node) || ts2.isClassDeclaration(node) || ts2.isModuleDeclaration(node) && !ts2.isExternalModuleAugmentation(node) && !ts2.isGlobalScopeAugmentation(node) || ts2.isInterfaceDeclaration(node) || isTypeDeclaration(node);
            }
            function addExportModifier(statement) {
              var flags = (ts2.getModifierFlags(statement) | 1) & ~2;
              statement.modifiers = ts2.createNodeArray(ts2.createModifiersFromModifierFlags(flags));
              statement.modifierFlagsCache = 0;
            }
            function visitSymbolTable(symbolTable2, suppressNewPrivateContext, propertyAsAlias) {
              var oldDeferredPrivates = deferredPrivates;
              if (!suppressNewPrivateContext) {
                deferredPrivates = ts2.createMap();
              }
              symbolTable2.forEach(function(symbol) {
                serializeSymbol(symbol, false, !!propertyAsAlias);
              });
              if (!suppressNewPrivateContext) {
                deferredPrivates.forEach(function(symbol) {
                  serializeSymbol(symbol, true, !!propertyAsAlias);
                });
              }
              deferredPrivates = oldDeferredPrivates;
            }
            function serializeSymbol(symbol, isPrivate, propertyAsAlias) {
              var visitedSym = getMergedSymbol(symbol);
              if (visitedSymbols.has("" + getSymbolId(visitedSym))) {
                return;
              }
              visitedSymbols.set("" + getSymbolId(visitedSym), true);
              var skipMembershipCheck = !isPrivate;
              if (skipMembershipCheck || !!ts2.length(symbol.declarations) && ts2.some(symbol.declarations, function(d) {
                return !!ts2.findAncestor(d, function(n) {
                  return n === enclosingDeclaration;
                });
              })) {
                var oldContext = context;
                context = cloneNodeBuilderContext(context);
                var result = serializeSymbolWorker(symbol, isPrivate, propertyAsAlias);
                context = oldContext;
                return result;
              }
            }
            function serializeSymbolWorker(symbol, isPrivate, propertyAsAlias) {
              var symbolName = ts2.unescapeLeadingUnderscores(symbol.escapedName);
              var isDefault = symbol.escapedName === "default";
              if (!(context.flags & 131072) && ts2.isStringANonContextualKeyword(symbolName) && !isDefault) {
                context.encounteredError = true;
                return;
              }
              var needsPostExportDefault = isDefault && !!(symbol.flags & -113 || symbol.flags & 16 && ts2.length(getPropertiesOfType(getTypeOfSymbol(symbol)))) && !(symbol.flags & 2097152);
              if (needsPostExportDefault) {
                isPrivate = true;
              }
              var modifierFlags = (!isPrivate ? 1 : 0) | (isDefault && !needsPostExportDefault ? 512 : 0);
              var isConstMergedWithNS = symbol.flags & 1536 && symbol.flags & (2 | 1 | 4) && symbol.escapedName !== "export=";
              var isConstMergedWithNSPrintableAsSignatureMerge = isConstMergedWithNS && isTypeRepresentableAsFunctionNamespaceMerge(getTypeOfSymbol(symbol), symbol);
              if (symbol.flags & (16 | 8192) || isConstMergedWithNSPrintableAsSignatureMerge) {
                serializeAsFunctionNamespaceMerge(getTypeOfSymbol(symbol), symbol, getInternalSymbolName(symbol, symbolName), modifierFlags);
              }
              if (symbol.flags & 524288) {
                serializeTypeAlias(symbol, symbolName, modifierFlags);
              }
              if (symbol.flags & (2 | 1 | 4) && symbol.escapedName !== "export=" && !(symbol.flags & 4194304) && !(symbol.flags & 32) && !isConstMergedWithNSPrintableAsSignatureMerge) {
                serializeVariableOrProperty(symbol, symbolName, isPrivate, needsPostExportDefault, propertyAsAlias, modifierFlags);
              }
              if (symbol.flags & 384) {
                serializeEnum(symbol, symbolName, modifierFlags);
              }
              if (symbol.flags & 32) {
                if (symbol.flags & 4 && ts2.isBinaryExpression(symbol.valueDeclaration.parent) && ts2.isClassExpression(symbol.valueDeclaration.parent.right)) {
                  serializeAsAlias(symbol, getInternalSymbolName(symbol, symbolName), modifierFlags);
                } else {
                  serializeAsClass(symbol, getInternalSymbolName(symbol, symbolName), modifierFlags);
                }
              }
              if (symbol.flags & (512 | 1024) && (!isConstMergedWithNS || isTypeOnlyNamespace(symbol)) || isConstMergedWithNSPrintableAsSignatureMerge) {
                serializeModule(symbol, symbolName, modifierFlags);
              }
              if (symbol.flags & 64) {
                serializeInterface(symbol, symbolName, modifierFlags);
              }
              if (symbol.flags & 2097152) {
                serializeAsAlias(symbol, getInternalSymbolName(symbol, symbolName), modifierFlags);
              }
              if (symbol.flags & 4 && symbol.escapedName === "export=") {
                serializeMaybeAliasAssignment(symbol);
              }
              if (symbol.flags & 8388608) {
                for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
                  var node = _a[_i];
                  var resolvedModule = resolveExternalModuleName(node, node.moduleSpecifier);
                  if (!resolvedModule)
                    continue;
                  addResult(ts2.createExportDeclaration(void 0, void 0, void 0, ts2.createLiteral(getSpecifierForModuleSymbol(resolvedModule, context))), 0);
                }
              }
              if (needsPostExportDefault) {
                addResult(ts2.createExportAssignment(void 0, void 0, false, ts2.createIdentifier(getInternalSymbolName(symbol, symbolName))), 0);
              }
            }
            function includePrivateSymbol(symbol) {
              if (ts2.some(symbol.declarations, ts2.isParameterDeclaration))
                return;
              ts2.Debug.assertIsDefined(deferredPrivates);
              getUnusedName(ts2.unescapeLeadingUnderscores(symbol.escapedName), symbol);
              deferredPrivates.set("" + getSymbolId(symbol), symbol);
            }
            function isExportingScope(enclosingDeclaration2) {
              return ts2.isSourceFile(enclosingDeclaration2) && (ts2.isExternalOrCommonJsModule(enclosingDeclaration2) || ts2.isJsonSourceFile(enclosingDeclaration2)) || ts2.isAmbientModule(enclosingDeclaration2) && !ts2.isGlobalScopeAugmentation(enclosingDeclaration2);
            }
            function addResult(node, additionalModifierFlags) {
              var newModifierFlags = 0;
              if (additionalModifierFlags & 1 && enclosingDeclaration && isExportingScope(enclosingDeclaration) && canHaveExportModifier(node)) {
                newModifierFlags |= 1;
              }
              if (addingDeclare && !(newModifierFlags & 1) && (!enclosingDeclaration || !(enclosingDeclaration.flags & 8388608)) && (ts2.isEnumDeclaration(node) || ts2.isVariableStatement(node) || ts2.isFunctionDeclaration(node) || ts2.isClassDeclaration(node) || ts2.isModuleDeclaration(node))) {
                newModifierFlags |= 2;
              }
              if (additionalModifierFlags & 512 && (ts2.isClassDeclaration(node) || ts2.isInterfaceDeclaration(node) || ts2.isFunctionDeclaration(node))) {
                newModifierFlags |= 512;
              }
              if (newModifierFlags) {
                node.modifiers = ts2.createNodeArray(ts2.createModifiersFromModifierFlags(newModifierFlags | ts2.getModifierFlags(node)));
                node.modifierFlagsCache = 0;
              }
              results.push(node);
            }
            function serializeTypeAlias(symbol, symbolName, modifierFlags) {
              var aliasType = getDeclaredTypeOfTypeAlias(symbol);
              var typeParams = getSymbolLinks(symbol).typeParameters;
              var typeParamDecls = ts2.map(typeParams, function(p) {
                return typeParameterToDeclaration(p, context);
              });
              var jsdocAliasDecl = ts2.find(symbol.declarations, ts2.isJSDocTypeAlias);
              var commentText = jsdocAliasDecl ? jsdocAliasDecl.comment || jsdocAliasDecl.parent.comment : void 0;
              var oldFlags = context.flags;
              context.flags |= 8388608;
              addResult(ts2.setSyntheticLeadingComments(ts2.createTypeAliasDeclaration(void 0, void 0, getInternalSymbolName(symbol, symbolName), typeParamDecls, typeToTypeNodeHelper(aliasType, context)), !commentText ? [] : [{ kind: 3, text: "*\n * " + commentText.replace(/\n/g, "\n * ") + "\n ", pos: -1, end: -1, hasTrailingNewLine: true }]), modifierFlags);
              context.flags = oldFlags;
            }
            function serializeInterface(symbol, symbolName, modifierFlags) {
              var interfaceType = getDeclaredTypeOfClassOrInterface(symbol);
              var localParams = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
              var typeParamDecls = ts2.map(localParams, function(p) {
                return typeParameterToDeclaration(p, context);
              });
              var baseTypes = getBaseTypes(interfaceType);
              var baseType = ts2.length(baseTypes) ? getIntersectionType(baseTypes) : void 0;
              var members = ts2.flatMap(getPropertiesOfType(interfaceType), function(p) {
                return serializePropertySymbolForInterface(p, baseType);
              });
              var callSignatures = serializeSignatures(0, interfaceType, baseType, 165);
              var constructSignatures = serializeSignatures(1, interfaceType, baseType, 166);
              var indexSignatures = serializeIndexSignatures(interfaceType, baseType);
              var heritageClauses = !ts2.length(baseTypes) ? void 0 : [ts2.createHeritageClause(90, ts2.mapDefined(baseTypes, function(b) {
                return trySerializeAsTypeReference(b);
              }))];
              addResult(ts2.createInterfaceDeclaration(void 0, void 0, getInternalSymbolName(symbol, symbolName), typeParamDecls, heritageClauses, __spreadArrays(indexSignatures, constructSignatures, callSignatures, members)), modifierFlags);
            }
            function getNamespaceMembersForSerialization(symbol) {
              return !symbol.exports ? [] : ts2.filter(ts2.arrayFrom(symbol.exports.values()), isNamespaceMember);
            }
            function isTypeOnlyNamespace(symbol) {
              return ts2.every(getNamespaceMembersForSerialization(symbol), function(m) {
                return !(resolveSymbol(m).flags & 111551);
              });
            }
            function serializeModule(symbol, symbolName, modifierFlags) {
              var members = getNamespaceMembersForSerialization(symbol);
              var locationMap = ts2.arrayToMultiMap(members, function(m) {
                return m.parent && m.parent === symbol ? "real" : "merged";
              });
              var realMembers = locationMap.get("real") || ts2.emptyArray;
              var mergedMembers = locationMap.get("merged") || ts2.emptyArray;
              if (ts2.length(realMembers)) {
                var localName = getInternalSymbolName(symbol, symbolName);
                serializeAsNamespaceDeclaration(realMembers, localName, modifierFlags, !!(symbol.flags & (16 | 67108864)));
              }
              if (ts2.length(mergedMembers)) {
                var containingFile_1 = ts2.getSourceFileOfNode(context.enclosingDeclaration);
                var localName = getInternalSymbolName(symbol, symbolName);
                var nsBody = ts2.createModuleBlock([ts2.createExportDeclaration(void 0, void 0, ts2.createNamedExports(ts2.mapDefined(ts2.filter(mergedMembers, function(n) {
                  return n.escapedName !== "export=";
                }), function(s) {
                  var _a, _b;
                  var name = ts2.unescapeLeadingUnderscores(s.escapedName);
                  var localName2 = getInternalSymbolName(s, name);
                  var aliasDecl = s.declarations && getDeclarationOfAliasSymbol(s);
                  if (containingFile_1 && (aliasDecl ? containingFile_1 !== ts2.getSourceFileOfNode(aliasDecl) : !ts2.some(s.declarations, function(d) {
                    return ts2.getSourceFileOfNode(d) === containingFile_1;
                  }))) {
                    (_b = (_a = context.tracker) === null || _a === void 0 ? void 0 : _a.reportNonlocalAugmentation) === null || _b === void 0 ? void 0 : _b.call(_a, containingFile_1, symbol, s);
                    return void 0;
                  }
                  var target = aliasDecl && getTargetOfAliasDeclaration(aliasDecl, true);
                  includePrivateSymbol(target || s);
                  var targetName = target ? getInternalSymbolName(target, ts2.unescapeLeadingUnderscores(target.escapedName)) : localName2;
                  return ts2.createExportSpecifier(name === targetName ? void 0 : targetName, name);
                })))]);
                addResult(ts2.createModuleDeclaration(void 0, void 0, ts2.createIdentifier(localName), nsBody, 16), 0);
              }
            }
            function serializeEnum(symbol, symbolName, modifierFlags) {
              addResult(ts2.createEnumDeclaration(void 0, ts2.createModifiersFromModifierFlags(isConstEnumSymbol(symbol) ? 2048 : 0), getInternalSymbolName(symbol, symbolName), ts2.map(ts2.filter(getPropertiesOfType(getTypeOfSymbol(symbol)), function(p) {
                return !!(p.flags & 8);
              }), function(p) {
                var initializedValue = p.declarations && p.declarations[0] && ts2.isEnumMember(p.declarations[0]) && getConstantValue(p.declarations[0]);
                return ts2.createEnumMember(ts2.unescapeLeadingUnderscores(p.escapedName), initializedValue === void 0 ? void 0 : ts2.createLiteral(initializedValue));
              })), modifierFlags);
            }
            function serializeVariableOrProperty(symbol, symbolName, isPrivate, needsPostExportDefault, propertyAsAlias, modifierFlags) {
              if (propertyAsAlias) {
                serializeMaybeAliasAssignment(symbol);
              } else {
                var type = getTypeOfSymbol(symbol);
                var localName = getInternalSymbolName(symbol, symbolName);
                if (!(symbol.flags & 16) && isTypeRepresentableAsFunctionNamespaceMerge(type, symbol)) {
                  serializeAsFunctionNamespaceMerge(type, symbol, localName, modifierFlags);
                } else {
                  var flags = !(symbol.flags & 2) ? void 0 : isConstVariable(symbol) ? 2 : 1;
                  var name = needsPostExportDefault || !(symbol.flags & 4) ? localName : getUnusedName(localName, symbol);
                  var textRange = symbol.declarations && ts2.find(symbol.declarations, function(d) {
                    return ts2.isVariableDeclaration(d);
                  });
                  if (textRange && ts2.isVariableDeclarationList(textRange.parent) && textRange.parent.declarations.length === 1) {
                    textRange = textRange.parent.parent;
                  }
                  var statement = ts2.setTextRange(ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([
                    ts2.createVariableDeclaration(name, serializeTypeForDeclaration(context, type, symbol, enclosingDeclaration, includePrivateSymbol, bundled))
                  ], flags)), textRange);
                  addResult(statement, name !== localName ? modifierFlags & ~1 : modifierFlags);
                  if (name !== localName && !isPrivate) {
                    addResult(ts2.createExportDeclaration(void 0, void 0, ts2.createNamedExports([ts2.createExportSpecifier(name, localName)])), 0);
                  }
                }
              }
            }
            function serializeAsFunctionNamespaceMerge(type, symbol, localName, modifierFlags) {
              var signatures = getSignaturesOfType(type, 0);
              for (var _i = 0, signatures_2 = signatures; _i < signatures_2.length; _i++) {
                var sig = signatures_2[_i];
                var decl = signatureToSignatureDeclarationHelper(sig, 244, context, includePrivateSymbol, bundled);
                decl.name = ts2.createIdentifier(localName);
                addResult(ts2.setTextRange(decl, sig.declaration && ts2.isVariableDeclaration(sig.declaration.parent) && sig.declaration.parent.parent || sig.declaration), modifierFlags);
              }
              if (!(symbol.flags & (512 | 1024) && !!symbol.exports && !!symbol.exports.size)) {
                var props = ts2.filter(getPropertiesOfType(type), isNamespaceMember);
                serializeAsNamespaceDeclaration(props, localName, modifierFlags, true);
              }
            }
            function serializeAsNamespaceDeclaration(props, localName, modifierFlags, suppressNewPrivateContext) {
              if (ts2.length(props)) {
                var localVsRemoteMap = ts2.arrayToMultiMap(props, function(p) {
                  return !ts2.length(p.declarations) || ts2.some(p.declarations, function(d) {
                    return ts2.getSourceFileOfNode(d) === ts2.getSourceFileOfNode(context.enclosingDeclaration);
                  }) ? "local" : "remote";
                });
                var localProps = localVsRemoteMap.get("local") || ts2.emptyArray;
                var fakespace = ts2.createModuleDeclaration(void 0, void 0, ts2.createIdentifier(localName), ts2.createModuleBlock([]), 16);
                fakespace.flags ^= 8;
                fakespace.parent = enclosingDeclaration;
                fakespace.locals = ts2.createSymbolTable(props);
                fakespace.symbol = props[0].parent;
                var oldResults = results;
                results = [];
                var oldAddingDeclare = addingDeclare;
                addingDeclare = false;
                var subcontext = __assign(__assign({}, context), { enclosingDeclaration: fakespace });
                var oldContext = context;
                context = subcontext;
                visitSymbolTable(ts2.createSymbolTable(localProps), suppressNewPrivateContext, true);
                context = oldContext;
                addingDeclare = oldAddingDeclare;
                var declarations = results;
                results = oldResults;
                fakespace.flags ^= 8;
                fakespace.parent = void 0;
                fakespace.locals = void 0;
                fakespace.symbol = void 0;
                fakespace.body = ts2.createModuleBlock(declarations);
                addResult(fakespace, modifierFlags);
              }
            }
            function isNamespaceMember(p) {
              return !(p.flags & 4194304 || p.escapedName === "prototype" || p.valueDeclaration && ts2.isClassLike(p.valueDeclaration.parent));
            }
            function serializeAsClass(symbol, localName, modifierFlags) {
              var localParams = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
              var typeParamDecls = ts2.map(localParams, function(p) {
                return typeParameterToDeclaration(p, context);
              });
              var classType = getDeclaredTypeOfClassOrInterface(symbol);
              var baseTypes = getBaseTypes(classType);
              var implementsTypes = getImplementsTypes(classType);
              var staticType = getTypeOfSymbol(symbol);
              var staticBaseType = getBaseConstructorTypeOfClass(staticType);
              var heritageClauses = __spreadArrays(!ts2.length(baseTypes) ? [] : [ts2.createHeritageClause(90, ts2.map(baseTypes, function(b) {
                return serializeBaseType(b, staticBaseType, localName);
              }))], !ts2.length(implementsTypes) ? [] : [ts2.createHeritageClause(113, ts2.map(implementsTypes, function(b) {
                return serializeBaseType(b, staticBaseType, localName);
              }))]);
              var symbolProps = getNonInterhitedProperties(classType, baseTypes, getPropertiesOfType(classType));
              var publicSymbolProps = ts2.filter(symbolProps, function(s) {
                var valueDecl = s.valueDeclaration;
                return valueDecl && !(ts2.isNamedDeclaration(valueDecl) && ts2.isPrivateIdentifier(valueDecl.name));
              });
              var hasPrivateIdentifier = ts2.some(symbolProps, function(s) {
                var valueDecl = s.valueDeclaration;
                return valueDecl && ts2.isNamedDeclaration(valueDecl) && ts2.isPrivateIdentifier(valueDecl.name);
              });
              var privateProperties = hasPrivateIdentifier ? [ts2.createProperty(void 0, void 0, ts2.createPrivateIdentifier("#private"), void 0, void 0, void 0)] : ts2.emptyArray;
              var publicProperties = ts2.flatMap(publicSymbolProps, function(p) {
                return serializePropertySymbolForClass(p, false, baseTypes[0]);
              });
              var staticMembers = ts2.flatMap(ts2.filter(getPropertiesOfType(staticType), function(p) {
                return !(p.flags & 4194304) && p.escapedName !== "prototype" && !isNamespaceMember(p);
              }), function(p) {
                return serializePropertySymbolForClass(p, true, staticBaseType);
              });
              var constructors = serializeSignatures(1, staticType, baseTypes[0], 162);
              for (var _i = 0, constructors_1 = constructors; _i < constructors_1.length; _i++) {
                var c = constructors_1[_i];
                c.type = void 0;
                c.typeParameters = void 0;
              }
              var indexSignatures = serializeIndexSignatures(classType, baseTypes[0]);
              addResult(ts2.setTextRange(ts2.createClassDeclaration(void 0, void 0, localName, typeParamDecls, heritageClauses, __spreadArrays(indexSignatures, staticMembers, constructors, publicProperties, privateProperties)), symbol.declarations && ts2.filter(symbol.declarations, function(d) {
                return ts2.isClassDeclaration(d) || ts2.isClassExpression(d);
              })[0]), modifierFlags);
            }
            function serializeAsAlias(symbol, localName, modifierFlags) {
              var node = getDeclarationOfAliasSymbol(symbol);
              if (!node)
                return ts2.Debug.fail();
              var target = getMergedSymbol(getTargetOfAliasDeclaration(node, true));
              if (!target) {
                return;
              }
              var verbatimTargetName = ts2.unescapeLeadingUnderscores(target.escapedName);
              if (verbatimTargetName === "export=" && (compilerOptions.esModuleInterop || compilerOptions.allowSyntheticDefaultImports)) {
                verbatimTargetName = "default";
              }
              var targetName = getInternalSymbolName(target, verbatimTargetName);
              includePrivateSymbol(target);
              switch (node.kind) {
                case 253:
                  var isLocalImport = !(target.flags & 512);
                  addResult(ts2.createImportEqualsDeclaration(void 0, void 0, ts2.createIdentifier(localName), isLocalImport ? symbolToName(target, context, 67108863, false) : ts2.createExternalModuleReference(ts2.createLiteral(getSpecifierForModuleSymbol(symbol, context)))), isLocalImport ? modifierFlags : 0);
                  break;
                case 252:
                  addResult(ts2.createNamespaceExportDeclaration(ts2.idText(node.name)), 0);
                  break;
                case 255:
                  addResult(ts2.createImportDeclaration(void 0, void 0, ts2.createImportClause(ts2.createIdentifier(localName), void 0), ts2.createLiteral(getSpecifierForModuleSymbol(target.parent || target, context))), 0);
                  break;
                case 256:
                  addResult(ts2.createImportDeclaration(void 0, void 0, ts2.createImportClause(void 0, ts2.createNamespaceImport(ts2.createIdentifier(localName))), ts2.createLiteral(getSpecifierForModuleSymbol(target, context))), 0);
                  break;
                case 262:
                  addResult(ts2.createExportDeclaration(void 0, void 0, ts2.createNamespaceExport(ts2.createIdentifier(localName)), ts2.createLiteral(getSpecifierForModuleSymbol(target, context))), 0);
                  break;
                case 258:
                  addResult(ts2.createImportDeclaration(void 0, void 0, ts2.createImportClause(void 0, ts2.createNamedImports([
                    ts2.createImportSpecifier(localName !== verbatimTargetName ? ts2.createIdentifier(verbatimTargetName) : void 0, ts2.createIdentifier(localName))
                  ])), ts2.createLiteral(getSpecifierForModuleSymbol(target.parent || target, context))), 0);
                  break;
                case 263:
                  var specifier = node.parent.parent.moduleSpecifier;
                  serializeExportSpecifier(ts2.unescapeLeadingUnderscores(symbol.escapedName), specifier ? verbatimTargetName : targetName, specifier && ts2.isStringLiteralLike(specifier) ? ts2.createLiteral(specifier.text) : void 0);
                  break;
                case 259:
                  serializeMaybeAliasAssignment(symbol);
                  break;
                case 209:
                case 194:
                  if (symbol.escapedName === "default" || symbol.escapedName === "export=") {
                    serializeMaybeAliasAssignment(symbol);
                  } else {
                    serializeExportSpecifier(localName, targetName);
                  }
                  break;
                default:
                  return ts2.Debug.failBadSyntaxKind(node, "Unhandled alias declaration kind in symbol serializer!");
              }
            }
            function serializeExportSpecifier(localName, targetName, specifier) {
              addResult(ts2.createExportDeclaration(void 0, void 0, ts2.createNamedExports([ts2.createExportSpecifier(localName !== targetName ? targetName : void 0, localName)]), specifier), 0);
            }
            function serializeMaybeAliasAssignment(symbol) {
              if (symbol.flags & 4194304) {
                return;
              }
              var name = ts2.unescapeLeadingUnderscores(symbol.escapedName);
              var isExportEquals = name === "export=";
              var isDefault = name === "default";
              var isExportAssignment = isExportEquals || isDefault;
              var aliasDecl = symbol.declarations && getDeclarationOfAliasSymbol(symbol);
              var target = aliasDecl && getTargetOfAliasDeclaration(aliasDecl, true);
              if (target && ts2.length(target.declarations) && ts2.some(target.declarations, function(d) {
                return ts2.getSourceFileOfNode(d) === ts2.getSourceFileOfNode(enclosingDeclaration);
              })) {
                var expr = isExportAssignment ? ts2.getExportAssignmentExpression(aliasDecl) : ts2.getPropertyAssignmentAliasLikeExpression(aliasDecl);
                var first_1 = ts2.isEntityNameExpression(expr) ? getFirstNonModuleExportsIdentifier(expr) : void 0;
                var referenced = first_1 && resolveEntityName(first_1, 67108863, true, true, enclosingDeclaration);
                if (referenced || target) {
                  includePrivateSymbol(referenced || target);
                }
                var oldTrack = context.tracker.trackSymbol;
                context.tracker.trackSymbol = ts2.noop;
                if (isExportAssignment) {
                  results.push(ts2.createExportAssignment(void 0, void 0, isExportEquals, symbolToExpression(target, context, 67108863)));
                } else {
                  if (first_1 === expr) {
                    serializeExportSpecifier(name, ts2.idText(first_1));
                  } else if (ts2.isClassExpression(expr)) {
                    serializeExportSpecifier(name, getInternalSymbolName(target, ts2.symbolName(target)));
                  } else {
                    var varName = getUnusedName(name, symbol);
                    addResult(ts2.createImportEqualsDeclaration(void 0, void 0, ts2.createIdentifier(varName), symbolToName(target, context, 67108863, false)), 0);
                    serializeExportSpecifier(name, varName);
                  }
                }
                context.tracker.trackSymbol = oldTrack;
              } else {
                var varName = getUnusedName(name, symbol);
                var typeToSerialize = getWidenedType(getTypeOfSymbol(getMergedSymbol(symbol)));
                if (isTypeRepresentableAsFunctionNamespaceMerge(typeToSerialize, symbol)) {
                  serializeAsFunctionNamespaceMerge(typeToSerialize, symbol, varName, isExportAssignment ? 0 : 1);
                } else {
                  var statement = ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([
                    ts2.createVariableDeclaration(varName, serializeTypeForDeclaration(context, typeToSerialize, symbol, enclosingDeclaration, includePrivateSymbol, bundled))
                  ], 2));
                  addResult(statement, name === varName ? 1 : 0);
                }
                if (isExportAssignment) {
                  results.push(ts2.createExportAssignment(void 0, void 0, isExportEquals, ts2.createIdentifier(varName)));
                } else if (name !== varName) {
                  serializeExportSpecifier(name, varName);
                }
              }
            }
            function isTypeRepresentableAsFunctionNamespaceMerge(typeToSerialize, hostSymbol) {
              var ctxSrc = ts2.getSourceFileOfNode(context.enclosingDeclaration);
              return ts2.getObjectFlags(typeToSerialize) & (16 | 32) && !getIndexInfoOfType(typeToSerialize, 0) && !getIndexInfoOfType(typeToSerialize, 1) && !!(ts2.length(getPropertiesOfType(typeToSerialize)) || ts2.length(getSignaturesOfType(typeToSerialize, 0))) && !ts2.length(getSignaturesOfType(typeToSerialize, 1)) && !getDeclarationWithTypeAnnotation(hostSymbol, enclosingDeclaration) && !(typeToSerialize.symbol && ts2.some(typeToSerialize.symbol.declarations, function(d) {
                return ts2.getSourceFileOfNode(d) !== ctxSrc;
              })) && !ts2.some(getPropertiesOfType(typeToSerialize), function(p) {
                return isLateBoundName(p.escapedName);
              }) && !ts2.some(getPropertiesOfType(typeToSerialize), function(p) {
                return ts2.some(p.declarations, function(d) {
                  return ts2.getSourceFileOfNode(d) !== ctxSrc;
                });
              }) && ts2.every(getPropertiesOfType(typeToSerialize), function(p) {
                return ts2.isIdentifierText(ts2.symbolName(p), languageVersion) && !ts2.isStringAKeyword(ts2.symbolName(p));
              });
            }
            function makeSerializePropertySymbol(createProperty, methodKind, useAccessors) {
              return function serializePropertySymbol(p, isStatic, baseType) {
                var modifierFlags = ts2.getDeclarationModifierFlagsFromSymbol(p);
                var isPrivate = !!(modifierFlags & 8);
                if (isStatic && p.flags & (788968 | 1920 | 2097152)) {
                  return [];
                }
                if (p.flags & 4194304 || baseType && getPropertyOfType(baseType, p.escapedName) && isReadonlySymbol(getPropertyOfType(baseType, p.escapedName)) === isReadonlySymbol(p) && (p.flags & 16777216) === (getPropertyOfType(baseType, p.escapedName).flags & 16777216) && isTypeIdenticalTo(getTypeOfSymbol(p), getTypeOfPropertyOfType(baseType, p.escapedName))) {
                  return [];
                }
                var flag = modifierFlags & ~256 | (isStatic ? 32 : 0);
                var name = getPropertyNameNodeForSymbol(p, context);
                var firstPropertyLikeDecl = ts2.find(p.declarations, ts2.or(ts2.isPropertyDeclaration, ts2.isAccessor, ts2.isVariableDeclaration, ts2.isPropertySignature, ts2.isBinaryExpression, ts2.isPropertyAccessExpression));
                if (p.flags & 98304 && useAccessors) {
                  var result = [];
                  if (p.flags & 65536) {
                    result.push(ts2.setTextRange(ts2.createSetAccessor(void 0, ts2.createModifiersFromModifierFlags(flag), name, [ts2.createParameter(void 0, void 0, void 0, "arg", void 0, isPrivate ? void 0 : serializeTypeForDeclaration(context, getTypeOfSymbol(p), p, enclosingDeclaration, includePrivateSymbol, bundled))], void 0), ts2.find(p.declarations, ts2.isSetAccessor) || firstPropertyLikeDecl));
                  }
                  if (p.flags & 32768) {
                    var isPrivate_1 = modifierFlags & 8;
                    result.push(ts2.setTextRange(ts2.createGetAccessor(void 0, ts2.createModifiersFromModifierFlags(flag), name, [], isPrivate_1 ? void 0 : serializeTypeForDeclaration(context, getTypeOfSymbol(p), p, enclosingDeclaration, includePrivateSymbol, bundled), void 0), ts2.find(p.declarations, ts2.isGetAccessor) || firstPropertyLikeDecl));
                  }
                  return result;
                } else if (p.flags & (4 | 3)) {
                  return ts2.setTextRange(createProperty(void 0, ts2.createModifiersFromModifierFlags((isReadonlySymbol(p) ? 64 : 0) | flag), name, p.flags & 16777216 ? ts2.createToken(57) : void 0, isPrivate ? void 0 : serializeTypeForDeclaration(context, getTypeOfSymbol(p), p, enclosingDeclaration, includePrivateSymbol, bundled), void 0), ts2.find(p.declarations, ts2.or(ts2.isPropertyDeclaration, ts2.isVariableDeclaration)) || firstPropertyLikeDecl);
                }
                if (p.flags & (8192 | 16)) {
                  var type = getTypeOfSymbol(p);
                  var signatures = getSignaturesOfType(type, 0);
                  if (flag & 8) {
                    return ts2.setTextRange(createProperty(void 0, ts2.createModifiersFromModifierFlags((isReadonlySymbol(p) ? 64 : 0) | flag), name, p.flags & 16777216 ? ts2.createToken(57) : void 0, void 0, void 0), ts2.find(p.declarations, ts2.isFunctionLikeDeclaration) || signatures[0] && signatures[0].declaration || p.declarations[0]);
                  }
                  var results_1 = [];
                  for (var _i = 0, signatures_3 = signatures; _i < signatures_3.length; _i++) {
                    var sig = signatures_3[_i];
                    var decl = signatureToSignatureDeclarationHelper(sig, methodKind, context);
                    decl.name = name;
                    if (flag) {
                      decl.modifiers = ts2.createNodeArray(ts2.createModifiersFromModifierFlags(flag));
                    }
                    if (p.flags & 16777216) {
                      decl.questionToken = ts2.createToken(57);
                    }
                    results_1.push(ts2.setTextRange(decl, sig.declaration));
                  }
                  return results_1;
                }
                return ts2.Debug.fail("Unhandled class member kind! " + (p.__debugFlags || p.flags));
              };
            }
            function serializePropertySymbolForInterface(p, baseType) {
              return serializePropertySymbolForInterfaceWorker(p, false, baseType);
            }
            function serializeSignatures(kind, input, baseType, outputKind) {
              var signatures = getSignaturesOfType(input, kind);
              if (kind === 1) {
                if (!baseType && ts2.every(signatures, function(s2) {
                  return ts2.length(s2.parameters) === 0;
                })) {
                  return [];
                }
                if (baseType) {
                  var baseSigs = getSignaturesOfType(baseType, 1);
                  if (!ts2.length(baseSigs) && ts2.every(signatures, function(s2) {
                    return ts2.length(s2.parameters) === 0;
                  })) {
                    return [];
                  }
                  if (baseSigs.length === signatures.length) {
                    var failed = false;
                    for (var i = 0; i < baseSigs.length; i++) {
                      if (!compareSignaturesIdentical(signatures[i], baseSigs[i], false, false, true, compareTypesIdentical)) {
                        failed = true;
                        break;
                      }
                    }
                    if (!failed) {
                      return [];
                    }
                  }
                }
                var privateProtected = 0;
                for (var _i = 0, signatures_4 = signatures; _i < signatures_4.length; _i++) {
                  var s = signatures_4[_i];
                  if (s.declaration) {
                    privateProtected |= ts2.getSelectedModifierFlags(s.declaration, 8 | 16);
                  }
                }
                if (privateProtected) {
                  return [ts2.setTextRange(ts2.createConstructor(void 0, ts2.createModifiersFromModifierFlags(privateProtected), [], void 0), signatures[0].declaration)];
                }
              }
              var results2 = [];
              for (var _a = 0, signatures_5 = signatures; _a < signatures_5.length; _a++) {
                var sig = signatures_5[_a];
                var decl = signatureToSignatureDeclarationHelper(sig, outputKind, context);
                results2.push(ts2.setTextRange(decl, sig.declaration));
              }
              return results2;
            }
            function serializeIndexSignatures(input, baseType) {
              var results2 = [];
              for (var _i = 0, _a = [0, 1]; _i < _a.length; _i++) {
                var type = _a[_i];
                var info = getIndexInfoOfType(input, type);
                if (info) {
                  if (baseType) {
                    var baseInfo = getIndexInfoOfType(baseType, type);
                    if (baseInfo) {
                      if (isTypeIdenticalTo(info.type, baseInfo.type)) {
                        continue;
                      }
                    }
                  }
                  results2.push(indexInfoToIndexSignatureDeclarationHelper(info, type, context));
                }
              }
              return results2;
            }
            function serializeBaseType(t, staticType, rootName) {
              var ref = trySerializeAsTypeReference(t);
              if (ref) {
                return ref;
              }
              var tempName = getUnusedName(rootName + "_base");
              var statement = ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([
                ts2.createVariableDeclaration(tempName, typeToTypeNodeHelper(staticType, context))
              ], 2));
              addResult(statement, 0);
              return ts2.createExpressionWithTypeArguments(void 0, ts2.createIdentifier(tempName));
            }
            function trySerializeAsTypeReference(t) {
              var typeArgs;
              var reference;
              if (t.target && getAccessibleSymbolChain(t.target.symbol, enclosingDeclaration, 111551, false)) {
                typeArgs = ts2.map(getTypeArguments(t), function(t2) {
                  return typeToTypeNodeHelper(t2, context);
                });
                reference = symbolToExpression(t.target.symbol, context, 788968);
              } else if (t.symbol && getAccessibleSymbolChain(t.symbol, enclosingDeclaration, 111551, false)) {
                reference = symbolToExpression(t.symbol, context, 788968);
              }
              if (reference) {
                return ts2.createExpressionWithTypeArguments(typeArgs, reference);
              }
            }
            function getUnusedName(input, symbol) {
              if (symbol) {
                if (context.remappedSymbolNames.has("" + getSymbolId(symbol))) {
                  return context.remappedSymbolNames.get("" + getSymbolId(symbol));
                }
              }
              if (symbol) {
                input = getNameCandidateWorker(symbol, input);
              }
              var i = 0;
              var original = input;
              while (context.usedSymbolNames.has(input)) {
                i++;
                input = original + "_" + i;
              }
              context.usedSymbolNames.set(input, true);
              if (symbol) {
                context.remappedSymbolNames.set("" + getSymbolId(symbol), input);
              }
              return input;
            }
            function getNameCandidateWorker(symbol, localName) {
              if (localName === "default" || localName === "__class" || localName === "__function") {
                var flags = context.flags;
                context.flags |= 16777216;
                var nameCandidate = getNameOfSymbolAsWritten(symbol, context);
                context.flags = flags;
                localName = nameCandidate.length > 0 && ts2.isSingleOrDoubleQuote(nameCandidate.charCodeAt(0)) ? ts2.stripQuotes(nameCandidate) : nameCandidate;
              }
              if (localName === "default") {
                localName = "_default";
              } else if (localName === "export=") {
                localName = "_exports";
              }
              localName = ts2.isIdentifierText(localName, languageVersion) && !ts2.isStringANonContextualKeyword(localName) ? localName : "_" + localName.replace(/[^a-zA-Z0-9]/g, "_");
              return localName;
            }
            function getInternalSymbolName(symbol, localName) {
              if (context.remappedSymbolNames.has("" + getSymbolId(symbol))) {
                return context.remappedSymbolNames.get("" + getSymbolId(symbol));
              }
              localName = getNameCandidateWorker(symbol, localName);
              context.remappedSymbolNames.set("" + getSymbolId(symbol), localName);
              return localName;
            }
          }
        }
        function typePredicateToString(typePredicate, enclosingDeclaration, flags, writer) {
          if (flags === void 0) {
            flags = 16384;
          }
          return writer ? typePredicateToStringWorker(writer).getText() : ts2.usingSingleLineStringWriter(typePredicateToStringWorker);
          function typePredicateToStringWorker(writer2) {
            var predicate = ts2.createTypePredicateNodeWithModifier(typePredicate.kind === 2 || typePredicate.kind === 3 ? ts2.createToken(124) : void 0, typePredicate.kind === 1 || typePredicate.kind === 3 ? ts2.createIdentifier(typePredicate.parameterName) : ts2.createThisTypeNode(), typePredicate.type && nodeBuilder.typeToTypeNode(typePredicate.type, enclosingDeclaration, toNodeBuilderFlags(flags) | 70221824 | 512));
            var printer = ts2.createPrinter({ removeComments: true });
            var sourceFile = enclosingDeclaration && ts2.getSourceFileOfNode(enclosingDeclaration);
            printer.writeNode(4, predicate, sourceFile, writer2);
            return writer2;
          }
        }
        function formatUnionTypes(types) {
          var result = [];
          var flags = 0;
          for (var i = 0; i < types.length; i++) {
            var t = types[i];
            flags |= t.flags;
            if (!(t.flags & 98304)) {
              if (t.flags & (512 | 1024)) {
                var baseType = t.flags & 512 ? booleanType : getBaseTypeOfEnumLiteralType(t);
                if (baseType.flags & 1048576) {
                  var count = baseType.types.length;
                  if (i + count <= types.length && getRegularTypeOfLiteralType(types[i + count - 1]) === getRegularTypeOfLiteralType(baseType.types[count - 1])) {
                    result.push(baseType);
                    i += count - 1;
                    continue;
                  }
                }
              }
              result.push(t);
            }
          }
          if (flags & 65536)
            result.push(nullType);
          if (flags & 32768)
            result.push(undefinedType);
          return result || types;
        }
        function visibilityToString(flags) {
          if (flags === 8) {
            return "private";
          }
          if (flags === 16) {
            return "protected";
          }
          return "public";
        }
        function getTypeAliasForTypeLiteral(type) {
          if (type.symbol && type.symbol.flags & 2048) {
            var node = ts2.findAncestor(type.symbol.declarations[0].parent, function(n) {
              return n.kind !== 182;
            });
            if (node.kind === 247) {
              return getSymbolOfNode(node);
            }
          }
          return void 0;
        }
        function isTopLevelInExternalModuleAugmentation(node) {
          return node && node.parent && node.parent.kind === 250 && ts2.isExternalModuleAugmentation(node.parent.parent);
        }
        function isDefaultBindingContext(location) {
          return location.kind === 290 || ts2.isAmbientModule(location);
        }
        function getNameOfSymbolFromNameType(symbol, context) {
          var nameType = getSymbolLinks(symbol).nameType;
          if (nameType) {
            if (nameType.flags & 384) {
              var name = "" + nameType.value;
              if (!ts2.isIdentifierText(name, compilerOptions.target) && !isNumericLiteralName(name)) {
                return '"' + ts2.escapeString(name, 34) + '"';
              }
              if (isNumericLiteralName(name) && ts2.startsWith(name, "-")) {
                return "[" + name + "]";
              }
              return name;
            }
            if (nameType.flags & 8192) {
              return "[" + getNameOfSymbolAsWritten(nameType.symbol, context) + "]";
            }
          }
        }
        function getNameOfSymbolAsWritten(symbol, context) {
          if (context && symbol.escapedName === "default" && !(context.flags & 16384) && (!(context.flags & 16777216) || !symbol.declarations || context.enclosingDeclaration && ts2.findAncestor(symbol.declarations[0], isDefaultBindingContext) !== ts2.findAncestor(context.enclosingDeclaration, isDefaultBindingContext))) {
            return "default";
          }
          if (symbol.declarations && symbol.declarations.length) {
            var declaration = ts2.firstDefined(symbol.declarations, function(d) {
              return ts2.getNameOfDeclaration(d) ? d : void 0;
            });
            var name_2 = declaration && ts2.getNameOfDeclaration(declaration);
            if (declaration && name_2) {
              if (ts2.isCallExpression(declaration) && ts2.isBindableObjectDefinePropertyCall(declaration)) {
                return ts2.symbolName(symbol);
              }
              if (ts2.isComputedPropertyName(name_2) && !(ts2.getCheckFlags(symbol) & 4096)) {
                var nameType = getSymbolLinks(symbol).nameType;
                if (nameType && nameType.flags & 384) {
                  var result = getNameOfSymbolFromNameType(symbol, context);
                  if (result !== void 0) {
                    return result;
                  }
                }
              }
              return ts2.declarationNameToString(name_2);
            }
            if (!declaration) {
              declaration = symbol.declarations[0];
            }
            if (declaration.parent && declaration.parent.kind === 242) {
              return ts2.declarationNameToString(declaration.parent.name);
            }
            switch (declaration.kind) {
              case 214:
              case 201:
              case 202:
                if (context && !context.encounteredError && !(context.flags & 131072)) {
                  context.encounteredError = true;
                }
                return declaration.kind === 214 ? "(Anonymous class)" : "(Anonymous function)";
            }
          }
          var name = getNameOfSymbolFromNameType(symbol, context);
          return name !== void 0 ? name : ts2.symbolName(symbol);
        }
        function isDeclarationVisible(node) {
          if (node) {
            var links = getNodeLinks(node);
            if (links.isVisible === void 0) {
              links.isVisible = !!determineIfDeclarationIsVisible();
            }
            return links.isVisible;
          }
          return false;
          function determineIfDeclarationIsVisible() {
            switch (node.kind) {
              case 315:
              case 322:
              case 316:
                return !!(node.parent && node.parent.parent && node.parent.parent.parent && ts2.isSourceFile(node.parent.parent.parent));
              case 191:
                return isDeclarationVisible(node.parent.parent);
              case 242:
                if (ts2.isBindingPattern(node.name) && !node.name.elements.length) {
                  return false;
                }
              case 249:
              case 245:
              case 246:
              case 247:
              case 244:
              case 248:
              case 253:
                if (ts2.isExternalModuleAugmentation(node)) {
                  return true;
                }
                var parent = getDeclarationContainer(node);
                if (!(ts2.getCombinedModifierFlags(node) & 1) && !(node.kind !== 253 && parent.kind !== 290 && parent.flags & 8388608)) {
                  return isGlobalSourceFile(parent);
                }
                return isDeclarationVisible(parent);
              case 159:
              case 158:
              case 163:
              case 164:
              case 161:
              case 160:
                if (ts2.hasModifier(node, 8 | 16)) {
                  return false;
                }
              case 162:
              case 166:
              case 165:
              case 167:
              case 156:
              case 250:
              case 170:
              case 171:
              case 173:
              case 169:
              case 174:
              case 175:
              case 178:
              case 179:
              case 182:
                return isDeclarationVisible(node.parent);
              case 255:
              case 256:
              case 258:
                return false;
              case 155:
              case 290:
              case 252:
                return true;
              case 259:
                return false;
              default:
                return false;
            }
          }
        }
        function collectLinkedAliases(node, setVisibility) {
          var exportSymbol;
          if (node.parent && node.parent.kind === 259) {
            exportSymbol = resolveName(node, node.escapedText, 111551 | 788968 | 1920 | 2097152, void 0, node, false);
          } else if (node.parent.kind === 263) {
            exportSymbol = getTargetOfExportSpecifier(node.parent, 111551 | 788968 | 1920 | 2097152);
          }
          var result;
          var visited;
          if (exportSymbol) {
            visited = ts2.createMap();
            visited.set("" + getSymbolId(exportSymbol), true);
            buildVisibleNodeList(exportSymbol.declarations);
          }
          return result;
          function buildVisibleNodeList(declarations) {
            ts2.forEach(declarations, function(declaration) {
              var resultNode = getAnyImportSyntax(declaration) || declaration;
              if (setVisibility) {
                getNodeLinks(declaration).isVisible = true;
              } else {
                result = result || [];
                ts2.pushIfUnique(result, resultNode);
              }
              if (ts2.isInternalModuleImportEqualsDeclaration(declaration)) {
                var internalModuleReference = declaration.moduleReference;
                var firstIdentifier = ts2.getFirstIdentifier(internalModuleReference);
                var importSymbol = resolveName(declaration, firstIdentifier.escapedText, 111551 | 788968 | 1920, void 0, void 0, false);
                var id = importSymbol && "" + getSymbolId(importSymbol);
                if (importSymbol && !visited.has(id)) {
                  visited.set(id, true);
                  buildVisibleNodeList(importSymbol.declarations);
                }
              }
            });
          }
        }
        function pushTypeResolution(target, propertyName) {
          var resolutionCycleStartIndex = findResolutionCycleStartIndex(target, propertyName);
          if (resolutionCycleStartIndex >= 0) {
            var length_3 = resolutionTargets.length;
            for (var i = resolutionCycleStartIndex; i < length_3; i++) {
              resolutionResults[i] = false;
            }
            return false;
          }
          resolutionTargets.push(target);
          resolutionResults.push(true);
          resolutionPropertyNames.push(propertyName);
          return true;
        }
        function findResolutionCycleStartIndex(target, propertyName) {
          for (var i = resolutionTargets.length - 1; i >= 0; i--) {
            if (hasType(resolutionTargets[i], resolutionPropertyNames[i])) {
              return -1;
            }
            if (resolutionTargets[i] === target && resolutionPropertyNames[i] === propertyName) {
              return i;
            }
          }
          return -1;
        }
        function hasType(target, propertyName) {
          switch (propertyName) {
            case 0:
              return !!getSymbolLinks(target).type;
            case 5:
              return !!getNodeLinks(target).resolvedEnumType;
            case 2:
              return !!getSymbolLinks(target).declaredType;
            case 1:
              return !!target.resolvedBaseConstructorType;
            case 3:
              return !!target.resolvedReturnType;
            case 4:
              return !!target.immediateBaseConstraint;
            case 6:
              return !!target.resolvedTypeArguments;
          }
          return ts2.Debug.assertNever(propertyName);
        }
        function popTypeResolution() {
          resolutionTargets.pop();
          resolutionPropertyNames.pop();
          return resolutionResults.pop();
        }
        function getDeclarationContainer(node) {
          return ts2.findAncestor(ts2.getRootDeclaration(node), function(node2) {
            switch (node2.kind) {
              case 242:
              case 243:
              case 258:
              case 257:
              case 256:
              case 255:
                return false;
              default:
                return true;
            }
          }).parent;
        }
        function getTypeOfPrototypeProperty(prototype) {
          var classType = getDeclaredTypeOfSymbol(getParentOfSymbol(prototype));
          return classType.typeParameters ? createTypeReference(classType, ts2.map(classType.typeParameters, function(_) {
            return anyType;
          })) : classType;
        }
        function getTypeOfPropertyOfType(type, name) {
          var prop = getPropertyOfType(type, name);
          return prop ? getTypeOfSymbol(prop) : void 0;
        }
        function getTypeOfPropertyOrIndexSignature(type, name) {
          return getTypeOfPropertyOfType(type, name) || isNumericLiteralName(name) && getIndexTypeOfType(type, 1) || getIndexTypeOfType(type, 0) || unknownType;
        }
        function isTypeAny(type) {
          return type && (type.flags & 1) !== 0;
        }
        function getTypeForBindingElementParent(node) {
          var symbol = getSymbolOfNode(node);
          return symbol && getSymbolLinks(symbol).type || getTypeForVariableLikeDeclaration(node, false);
        }
        function getRestType(source, properties, symbol) {
          source = filterType(source, function(t) {
            return !(t.flags & 98304);
          });
          if (source.flags & 131072) {
            return emptyObjectType;
          }
          if (source.flags & 1048576) {
            return mapType(source, function(t) {
              return getRestType(t, properties, symbol);
            });
          }
          var omitKeyType = getUnionType(ts2.map(properties, getLiteralTypeFromPropertyName));
          if (isGenericObjectType(source) || isGenericIndexType(omitKeyType)) {
            if (omitKeyType.flags & 131072) {
              return source;
            }
            var omitTypeAlias = getGlobalOmitSymbol();
            if (!omitTypeAlias) {
              return errorType;
            }
            return getTypeAliasInstantiation(omitTypeAlias, [source, omitKeyType]);
          }
          var members = ts2.createSymbolTable();
          for (var _i = 0, _a = getPropertiesOfType(source); _i < _a.length; _i++) {
            var prop = _a[_i];
            if (!isTypeAssignableTo(getLiteralTypeFromProperty(prop, 8576), omitKeyType) && !(ts2.getDeclarationModifierFlagsFromSymbol(prop) & (8 | 16)) && isSpreadableProperty(prop)) {
              members.set(prop.escapedName, getSpreadSymbol(prop, false));
            }
          }
          var stringIndexInfo = getIndexInfoOfType(source, 0);
          var numberIndexInfo = getIndexInfoOfType(source, 1);
          var result = createAnonymousType(symbol, members, ts2.emptyArray, ts2.emptyArray, stringIndexInfo, numberIndexInfo);
          result.objectFlags |= 131072;
          return result;
        }
        function getFlowTypeOfDestructuring(node, declaredType) {
          var reference = getSyntheticElementAccess(node);
          return reference ? getFlowTypeOfReference(reference, declaredType) : declaredType;
        }
        function getSyntheticElementAccess(node) {
          var parentAccess = getParentElementAccess(node);
          if (parentAccess && parentAccess.flowNode) {
            var propName = getDestructuringPropertyName(node);
            if (propName) {
              var result = ts2.createNode(195, node.pos, node.end);
              result.parent = node;
              result.expression = parentAccess;
              var literal = ts2.createNode(10, node.pos, node.end);
              literal.parent = result;
              literal.text = propName;
              result.argumentExpression = literal;
              result.flowNode = parentAccess.flowNode;
              return result;
            }
          }
        }
        function getParentElementAccess(node) {
          var ancestor = node.parent.parent;
          switch (ancestor.kind) {
            case 191:
            case 281:
              return getSyntheticElementAccess(ancestor);
            case 192:
              return getSyntheticElementAccess(node.parent);
            case 242:
              return ancestor.initializer;
            case 209:
              return ancestor.right;
          }
        }
        function getDestructuringPropertyName(node) {
          var parent = node.parent;
          if (node.kind === 191 && parent.kind === 189) {
            return getLiteralPropertyNameText(node.propertyName || node.name);
          }
          if (node.kind === 281 || node.kind === 282) {
            return getLiteralPropertyNameText(node.name);
          }
          return "" + parent.elements.indexOf(node);
        }
        function getLiteralPropertyNameText(name) {
          var type = getLiteralTypeFromPropertyName(name);
          return type.flags & (128 | 256) ? "" + type.value : void 0;
        }
        function getTypeForBindingElement(declaration) {
          var pattern = declaration.parent;
          var parentType = getTypeForBindingElementParent(pattern.parent);
          if (!parentType || isTypeAny(parentType)) {
            return parentType;
          }
          if (strictNullChecks && declaration.flags & 8388608 && ts2.isParameterDeclaration(declaration)) {
            parentType = getNonNullableType(parentType);
          } else if (strictNullChecks && pattern.parent.initializer && !(getTypeFacts(getTypeOfInitializer(pattern.parent.initializer)) & 65536)) {
            parentType = getTypeWithFacts(parentType, 524288);
          }
          var type;
          if (pattern.kind === 189) {
            if (declaration.dotDotDotToken) {
              parentType = getReducedType(parentType);
              if (parentType.flags & 2 || !isValidSpreadType(parentType)) {
                error(declaration, ts2.Diagnostics.Rest_types_may_only_be_created_from_object_types);
                return errorType;
              }
              var literalMembers = [];
              for (var _i = 0, _a = pattern.elements; _i < _a.length; _i++) {
                var element = _a[_i];
                if (!element.dotDotDotToken) {
                  literalMembers.push(element.propertyName || element.name);
                }
              }
              type = getRestType(parentType, literalMembers, declaration.symbol);
            } else {
              var name = declaration.propertyName || declaration.name;
              var indexType = getLiteralTypeFromPropertyName(name);
              var declaredType = getConstraintForLocation(getIndexedAccessType(parentType, indexType, name), declaration.name);
              type = getFlowTypeOfDestructuring(declaration, declaredType);
            }
          } else {
            var elementType = checkIteratedTypeOrElementType(65, parentType, undefinedType, pattern);
            var index_1 = pattern.elements.indexOf(declaration);
            if (declaration.dotDotDotToken) {
              type = everyType(parentType, isTupleType) ? mapType(parentType, function(t) {
                return sliceTupleType(t, index_1);
              }) : createArrayType(elementType);
            } else if (isArrayLikeType(parentType)) {
              var indexType = getLiteralType(index_1);
              var accessFlags = hasDefaultValue(declaration) ? 8 : 0;
              var declaredType = getConstraintForLocation(getIndexedAccessTypeOrUndefined(parentType, indexType, declaration.name, accessFlags) || errorType, declaration.name);
              type = getFlowTypeOfDestructuring(declaration, declaredType);
            } else {
              type = elementType;
            }
          }
          if (!declaration.initializer) {
            return type;
          }
          if (ts2.getEffectiveTypeAnnotationNode(ts2.walkUpBindingElementsAndPatterns(declaration))) {
            return strictNullChecks && !(getFalsyFlags(checkDeclarationInitializer(declaration)) & 32768) ? getTypeWithFacts(type, 524288) : type;
          }
          return widenTypeInferredFromInitializer(declaration, getUnionType([getTypeWithFacts(type, 524288), checkDeclarationInitializer(declaration)], 2));
        }
        function getTypeForDeclarationFromJSDocComment(declaration) {
          var jsdocType = ts2.getJSDocType(declaration);
          if (jsdocType) {
            return getTypeFromTypeNode(jsdocType);
          }
          return void 0;
        }
        function isNullOrUndefined(node) {
          var expr = ts2.skipParentheses(node);
          return expr.kind === 100 || expr.kind === 75 && getResolvedSymbol(expr) === undefinedSymbol;
        }
        function isEmptyArrayLiteral(node) {
          var expr = ts2.skipParentheses(node);
          return expr.kind === 192 && expr.elements.length === 0;
        }
        function addOptionality(type, optional) {
          if (optional === void 0) {
            optional = true;
          }
          return strictNullChecks && optional ? getOptionalType(type) : type;
        }
        function getTypeForVariableLikeDeclaration(declaration, includeOptionality) {
          if (ts2.isVariableDeclaration(declaration) && declaration.parent.parent.kind === 231) {
            var indexType = getIndexType(getNonNullableTypeIfNeeded(checkExpression(declaration.parent.parent.expression)));
            return indexType.flags & (262144 | 4194304) ? getExtractStringType(indexType) : stringType;
          }
          if (ts2.isVariableDeclaration(declaration) && declaration.parent.parent.kind === 232) {
            var forOfStatement = declaration.parent.parent;
            return checkRightHandSideOfForOf(forOfStatement) || anyType;
          }
          if (ts2.isBindingPattern(declaration.parent)) {
            return getTypeForBindingElement(declaration);
          }
          var isOptional = includeOptionality && (ts2.isParameter(declaration) && isJSDocOptionalParameter(declaration) || !ts2.isBindingElement(declaration) && !ts2.isVariableDeclaration(declaration) && !!declaration.questionToken);
          var declaredType = tryGetTypeFromEffectiveTypeNode(declaration);
          if (declaredType) {
            return addOptionality(declaredType, isOptional);
          }
          if ((noImplicitAny || ts2.isInJSFile(declaration)) && declaration.kind === 242 && !ts2.isBindingPattern(declaration.name) && !(ts2.getCombinedModifierFlags(declaration) & 1) && !(declaration.flags & 8388608)) {
            if (!(ts2.getCombinedNodeFlags(declaration) & 2) && (!declaration.initializer || isNullOrUndefined(declaration.initializer))) {
              return autoType;
            }
            if (declaration.initializer && isEmptyArrayLiteral(declaration.initializer)) {
              return autoArrayType;
            }
          }
          if (declaration.kind === 156) {
            var func = declaration.parent;
            if (func.kind === 164 && !hasNonBindableDynamicName(func)) {
              var getter = ts2.getDeclarationOfKind(getSymbolOfNode(declaration.parent), 163);
              if (getter) {
                var getterSignature = getSignatureFromDeclaration(getter);
                var thisParameter = getAccessorThisParameter(func);
                if (thisParameter && declaration === thisParameter) {
                  ts2.Debug.assert(!thisParameter.type);
                  return getTypeOfSymbol(getterSignature.thisParameter);
                }
                return getReturnTypeOfSignature(getterSignature);
              }
            }
            if (ts2.isInJSFile(declaration)) {
              var typeTag = ts2.getJSDocType(func);
              if (typeTag && ts2.isFunctionTypeNode(typeTag)) {
                return getTypeAtPosition(getSignatureFromDeclaration(typeTag), func.parameters.indexOf(declaration));
              }
            }
            var type = declaration.symbol.escapedName === "this" ? getContextualThisParameterType(func) : getContextuallyTypedParameterType(declaration);
            if (type) {
              return addOptionality(type, isOptional);
            }
          } else if (ts2.isInJSFile(declaration)) {
            var containerObjectType = getJSContainerObjectType(declaration, getSymbolOfNode(declaration), ts2.getDeclaredExpandoInitializer(declaration));
            if (containerObjectType) {
              return containerObjectType;
            }
          }
          if (declaration.initializer) {
            var type = widenTypeInferredFromInitializer(declaration, checkDeclarationInitializer(declaration));
            return addOptionality(type, isOptional);
          }
          if (ts2.isJsxAttribute(declaration)) {
            return trueType;
          }
          if (ts2.isBindingPattern(declaration.name)) {
            return getTypeFromBindingPattern(declaration.name, false, true);
          }
          return void 0;
        }
        function getWidenedTypeForAssignmentDeclaration(symbol, resolvedSymbol) {
          var container = ts2.getAssignedExpandoInitializer(symbol.valueDeclaration);
          if (container) {
            var tag = ts2.getJSDocTypeTag(container);
            if (tag && tag.typeExpression) {
              return getTypeFromTypeNode(tag.typeExpression);
            }
            var containerObjectType = getJSContainerObjectType(symbol.valueDeclaration, symbol, container);
            return containerObjectType || getWidenedLiteralType(checkExpressionCached(container));
          }
          var definedInConstructor = false;
          var definedInMethod = false;
          var jsdocType;
          var types;
          for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
            var declaration = _a[_i];
            var expression = ts2.isBinaryExpression(declaration) || ts2.isCallExpression(declaration) ? declaration : ts2.isAccessExpression(declaration) ? ts2.isBinaryExpression(declaration.parent) ? declaration.parent : declaration : void 0;
            if (!expression) {
              continue;
            }
            var kind = ts2.isAccessExpression(expression) ? ts2.getAssignmentDeclarationPropertyAccessKind(expression) : ts2.getAssignmentDeclarationKind(expression);
            if (kind === 4) {
              if (isDeclarationInConstructor(expression)) {
                definedInConstructor = true;
              } else {
                definedInMethod = true;
              }
            }
            if (!ts2.isCallExpression(expression)) {
              jsdocType = getAnnotatedTypeForAssignmentDeclaration(jsdocType, expression, symbol, declaration);
            }
            if (!jsdocType) {
              (types || (types = [])).push(ts2.isBinaryExpression(expression) || ts2.isCallExpression(expression) ? getInitializerTypeFromAssignmentDeclaration(symbol, resolvedSymbol, expression, kind) : neverType);
            }
          }
          var type = jsdocType;
          if (!type) {
            if (!ts2.length(types)) {
              return errorType;
            }
            var constructorTypes = definedInConstructor ? getConstructorDefinedThisAssignmentTypes(types, symbol.declarations) : void 0;
            if (definedInMethod) {
              var propType = getTypeOfAssignmentDeclarationPropertyOfBaseType(symbol);
              if (propType) {
                (constructorTypes || (constructorTypes = [])).push(propType);
                definedInConstructor = true;
              }
            }
            var sourceTypes = ts2.some(constructorTypes, function(t) {
              return !!(t.flags & ~98304);
            }) ? constructorTypes : types;
            type = getUnionType(sourceTypes, 2);
          }
          var widened = getWidenedType(addOptionality(type, definedInMethod && !definedInConstructor));
          if (filterType(widened, function(t) {
            return !!(t.flags & ~98304);
          }) === neverType) {
            reportImplicitAny(symbol.valueDeclaration, anyType);
            return anyType;
          }
          return widened;
        }
        function getJSContainerObjectType(decl, symbol, init) {
          if (!ts2.isInJSFile(decl) || !init || !ts2.isObjectLiteralExpression(init) || init.properties.length) {
            return void 0;
          }
          var exports2 = ts2.createSymbolTable();
          while (ts2.isBinaryExpression(decl) || ts2.isPropertyAccessExpression(decl)) {
            var s_2 = getSymbolOfNode(decl);
            if (s_2 && ts2.hasEntries(s_2.exports)) {
              mergeSymbolTable(exports2, s_2.exports);
            }
            decl = ts2.isBinaryExpression(decl) ? decl.parent : decl.parent.parent;
          }
          var s = getSymbolOfNode(decl);
          if (s && ts2.hasEntries(s.exports)) {
            mergeSymbolTable(exports2, s.exports);
          }
          var type = createAnonymousType(symbol, exports2, ts2.emptyArray, ts2.emptyArray, void 0, void 0);
          type.objectFlags |= 16384;
          return type;
        }
        function getAnnotatedTypeForAssignmentDeclaration(declaredType, expression, symbol, declaration) {
          var typeNode = ts2.getEffectiveTypeAnnotationNode(expression.parent);
          if (typeNode) {
            var type = getWidenedType(getTypeFromTypeNode(typeNode));
            if (!declaredType) {
              return type;
            } else if (declaredType !== errorType && type !== errorType && !isTypeIdenticalTo(declaredType, type)) {
              errorNextVariableOrPropertyDeclarationMustHaveSameType(void 0, declaredType, declaration, type);
            }
          }
          if (symbol.parent) {
            var typeNode_2 = ts2.getEffectiveTypeAnnotationNode(symbol.parent.valueDeclaration);
            if (typeNode_2) {
              return getTypeOfPropertyOfType(getTypeFromTypeNode(typeNode_2), symbol.escapedName);
            }
          }
          return declaredType;
        }
        function getInitializerTypeFromAssignmentDeclaration(symbol, resolvedSymbol, expression, kind) {
          if (ts2.isCallExpression(expression)) {
            if (resolvedSymbol) {
              return getTypeOfSymbol(resolvedSymbol);
            }
            var objectLitType = checkExpressionCached(expression.arguments[2]);
            var valueType = getTypeOfPropertyOfType(objectLitType, "value");
            if (valueType) {
              return valueType;
            }
            var getFunc = getTypeOfPropertyOfType(objectLitType, "get");
            if (getFunc) {
              var getSig = getSingleCallSignature(getFunc);
              if (getSig) {
                return getReturnTypeOfSignature(getSig);
              }
            }
            var setFunc = getTypeOfPropertyOfType(objectLitType, "set");
            if (setFunc) {
              var setSig = getSingleCallSignature(setFunc);
              if (setSig) {
                return getTypeOfFirstParameterOfSignature(setSig);
              }
            }
            return anyType;
          }
          if (containsSameNamedThisProperty(expression.left, expression.right)) {
            return anyType;
          }
          var type = resolvedSymbol ? getTypeOfSymbol(resolvedSymbol) : getWidenedLiteralType(checkExpressionCached(expression.right));
          if (type.flags & 524288 && kind === 2 && symbol.escapedName === "export=") {
            var exportedType = resolveStructuredTypeMembers(type);
            var members_4 = ts2.createSymbolTable();
            ts2.copyEntries(exportedType.members, members_4);
            if (resolvedSymbol && !resolvedSymbol.exports) {
              resolvedSymbol.exports = ts2.createSymbolTable();
            }
            (resolvedSymbol || symbol).exports.forEach(function(s, name) {
              var _a;
              var exportedMember = members_4.get(name);
              if (exportedMember && exportedMember !== s) {
                if (s.flags & 111551) {
                  if (ts2.getSourceFileOfNode(s.valueDeclaration) !== ts2.getSourceFileOfNode(exportedMember.valueDeclaration)) {
                    var unescapedName = ts2.unescapeLeadingUnderscores(s.escapedName);
                    var exportedMemberName = ((_a = ts2.tryCast(exportedMember.valueDeclaration, ts2.isNamedDeclaration)) === null || _a === void 0 ? void 0 : _a.name) || exportedMember.valueDeclaration;
                    ts2.addRelatedInfo(error(s.valueDeclaration, ts2.Diagnostics.Duplicate_identifier_0, unescapedName), ts2.createDiagnosticForNode(exportedMemberName, ts2.Diagnostics._0_was_also_declared_here, unescapedName));
                    ts2.addRelatedInfo(error(exportedMemberName, ts2.Diagnostics.Duplicate_identifier_0, unescapedName), ts2.createDiagnosticForNode(s.valueDeclaration, ts2.Diagnostics._0_was_also_declared_here, unescapedName));
                  }
                  var union = createSymbol(s.flags | exportedMember.flags, name);
                  union.type = getUnionType([getTypeOfSymbol(s), getTypeOfSymbol(exportedMember)]);
                  union.valueDeclaration = exportedMember.valueDeclaration;
                  union.declarations = ts2.concatenate(exportedMember.declarations, s.declarations);
                  members_4.set(name, union);
                } else {
                  members_4.set(name, mergeSymbol(s, exportedMember));
                }
              } else {
                members_4.set(name, s);
              }
            });
            var result = createAnonymousType(exportedType.symbol, members_4, exportedType.callSignatures, exportedType.constructSignatures, exportedType.stringIndexInfo, exportedType.numberIndexInfo);
            result.objectFlags |= ts2.getObjectFlags(type) & 16384;
            return result;
          }
          if (isEmptyArrayLiteralType(type)) {
            reportImplicitAny(expression, anyArrayType);
            return anyArrayType;
          }
          return type;
        }
        function containsSameNamedThisProperty(thisProperty, expression) {
          return ts2.isPropertyAccessExpression(thisProperty) && thisProperty.expression.kind === 104 && ts2.forEachChildRecursively(expression, function(n) {
            return isMatchingReference(thisProperty, n);
          });
        }
        function isDeclarationInConstructor(expression) {
          var thisContainer = ts2.getThisContainer(expression, false);
          return thisContainer.kind === 162 || thisContainer.kind === 244 || thisContainer.kind === 201 && !ts2.isPrototypePropertyAssignment(thisContainer.parent);
        }
        function getConstructorDefinedThisAssignmentTypes(types, declarations) {
          ts2.Debug.assert(types.length === declarations.length);
          return types.filter(function(_, i) {
            var declaration = declarations[i];
            var expression = ts2.isBinaryExpression(declaration) ? declaration : ts2.isBinaryExpression(declaration.parent) ? declaration.parent : void 0;
            return expression && isDeclarationInConstructor(expression);
          });
        }
        function getTypeOfAssignmentDeclarationPropertyOfBaseType(property) {
          var parentDeclaration = ts2.forEach(property.declarations, function(d) {
            var parent = ts2.getThisContainer(d, false).parent;
            return ts2.isClassLike(parent) && parent;
          });
          if (parentDeclaration) {
            var classType = getDeclaredTypeOfSymbol(getSymbolOfNode(parentDeclaration));
            var baseClassType = classType && getBaseTypes(classType)[0];
            if (baseClassType) {
              return getTypeOfPropertyOfType(baseClassType, property.escapedName);
            }
          }
        }
        function getTypeFromBindingElement(element, includePatternInType, reportErrors) {
          if (element.initializer) {
            var contextualType = ts2.isBindingPattern(element.name) ? getTypeFromBindingPattern(element.name, true, false) : unknownType;
            return addOptionality(widenTypeInferredFromInitializer(element, checkDeclarationInitializer(element, contextualType)));
          }
          if (ts2.isBindingPattern(element.name)) {
            return getTypeFromBindingPattern(element.name, includePatternInType, reportErrors);
          }
          if (reportErrors && !declarationBelongsToPrivateAmbientMember(element)) {
            reportImplicitAny(element, anyType);
          }
          return includePatternInType ? nonInferrableAnyType : anyType;
        }
        function getTypeFromObjectBindingPattern(pattern, includePatternInType, reportErrors) {
          var members = ts2.createSymbolTable();
          var stringIndexInfo;
          var objectFlags = 128 | 1048576;
          ts2.forEach(pattern.elements, function(e) {
            var name = e.propertyName || e.name;
            if (e.dotDotDotToken) {
              stringIndexInfo = createIndexInfo(anyType, false);
              return;
            }
            var exprType = getLiteralTypeFromPropertyName(name);
            if (!isTypeUsableAsPropertyName(exprType)) {
              objectFlags |= 512;
              return;
            }
            var text = getPropertyNameFromType(exprType);
            var flags = 4 | (e.initializer ? 16777216 : 0);
            var symbol = createSymbol(flags, text);
            symbol.type = getTypeFromBindingElement(e, includePatternInType, reportErrors);
            symbol.bindingElement = e;
            members.set(symbol.escapedName, symbol);
          });
          var result = createAnonymousType(void 0, members, ts2.emptyArray, ts2.emptyArray, stringIndexInfo, void 0);
          result.objectFlags |= objectFlags;
          if (includePatternInType) {
            result.pattern = pattern;
            result.objectFlags |= 1048576;
          }
          return result;
        }
        function getTypeFromArrayBindingPattern(pattern, includePatternInType, reportErrors) {
          var elements = pattern.elements;
          var lastElement = ts2.lastOrUndefined(elements);
          var hasRestElement = !!(lastElement && lastElement.kind === 191 && lastElement.dotDotDotToken);
          if (elements.length === 0 || elements.length === 1 && hasRestElement) {
            return languageVersion >= 2 ? createIterableType(anyType) : anyArrayType;
          }
          var elementTypes = ts2.map(elements, function(e) {
            return ts2.isOmittedExpression(e) ? anyType : getTypeFromBindingElement(e, includePatternInType, reportErrors);
          });
          var minLength = ts2.findLastIndex(elements, function(e) {
            return !ts2.isOmittedExpression(e) && !hasDefaultValue(e);
          }, elements.length - (hasRestElement ? 2 : 1)) + 1;
          var result = createTupleType(elementTypes, minLength, hasRestElement);
          if (includePatternInType) {
            result = cloneTypeReference(result);
            result.pattern = pattern;
            result.objectFlags |= 1048576;
          }
          return result;
        }
        function getTypeFromBindingPattern(pattern, includePatternInType, reportErrors) {
          if (includePatternInType === void 0) {
            includePatternInType = false;
          }
          if (reportErrors === void 0) {
            reportErrors = false;
          }
          return pattern.kind === 189 ? getTypeFromObjectBindingPattern(pattern, includePatternInType, reportErrors) : getTypeFromArrayBindingPattern(pattern, includePatternInType, reportErrors);
        }
        function getWidenedTypeForVariableLikeDeclaration(declaration, reportErrors) {
          return widenTypeForVariableLikeDeclaration(getTypeForVariableLikeDeclaration(declaration, true), declaration, reportErrors);
        }
        function widenTypeForVariableLikeDeclaration(type, declaration, reportErrors) {
          if (type) {
            if (reportErrors) {
              reportErrorsFromWidening(declaration, type);
            }
            if (type.flags & 8192 && (ts2.isBindingElement(declaration) || !declaration.type) && type.symbol !== getSymbolOfNode(declaration)) {
              type = esSymbolType;
            }
            return getWidenedType(type);
          }
          type = ts2.isParameter(declaration) && declaration.dotDotDotToken ? anyArrayType : anyType;
          if (reportErrors) {
            if (!declarationBelongsToPrivateAmbientMember(declaration)) {
              reportImplicitAny(declaration, type);
            }
          }
          return type;
        }
        function declarationBelongsToPrivateAmbientMember(declaration) {
          var root = ts2.getRootDeclaration(declaration);
          var memberDeclaration = root.kind === 156 ? root.parent : root;
          return isPrivateWithinAmbient(memberDeclaration);
        }
        function tryGetTypeFromEffectiveTypeNode(declaration) {
          var typeNode = ts2.getEffectiveTypeAnnotationNode(declaration);
          if (typeNode) {
            return getTypeFromTypeNode(typeNode);
          }
        }
        function getTypeOfVariableOrParameterOrProperty(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.type) {
            var type = getTypeOfVariableOrParameterOrPropertyWorker(symbol);
            if (!links.type) {
              links.type = type;
            }
          }
          return links.type;
        }
        function getTypeOfVariableOrParameterOrPropertyWorker(symbol) {
          if (symbol.flags & 4194304) {
            return getTypeOfPrototypeProperty(symbol);
          }
          if (symbol === requireSymbol) {
            return anyType;
          }
          if (symbol.flags & 134217728) {
            var fileSymbol = getSymbolOfNode(ts2.getSourceFileOfNode(symbol.valueDeclaration));
            var members = ts2.createSymbolTable();
            members.set("exports", fileSymbol);
            return createAnonymousType(symbol, members, ts2.emptyArray, ts2.emptyArray, void 0, void 0);
          }
          var declaration = symbol.valueDeclaration;
          if (ts2.isCatchClauseVariableDeclarationOrBindingElement(declaration)) {
            return anyType;
          }
          if (ts2.isSourceFile(declaration) && ts2.isJsonSourceFile(declaration)) {
            if (!declaration.statements.length) {
              return emptyObjectType;
            }
            return getWidenedType(getWidenedLiteralType(checkExpression(declaration.statements[0].expression)));
          }
          if (!pushTypeResolution(symbol, 0)) {
            if (symbol.flags & 512 && !(symbol.flags & 67108864)) {
              return getTypeOfFuncClassEnumModule(symbol);
            }
            return reportCircularityError(symbol);
          }
          var type;
          if (declaration.kind === 259) {
            type = widenTypeForVariableLikeDeclaration(checkExpressionCached(declaration.expression), declaration);
          } else if (ts2.isBinaryExpression(declaration) || ts2.isInJSFile(declaration) && (ts2.isCallExpression(declaration) || (ts2.isPropertyAccessExpression(declaration) || ts2.isBindableStaticElementAccessExpression(declaration)) && ts2.isBinaryExpression(declaration.parent))) {
            type = getWidenedTypeForAssignmentDeclaration(symbol);
          } else if (ts2.isJSDocPropertyLikeTag(declaration) || ts2.isPropertyAccessExpression(declaration) || ts2.isElementAccessExpression(declaration) || ts2.isIdentifier(declaration) || ts2.isStringLiteralLike(declaration) || ts2.isNumericLiteral(declaration) || ts2.isClassDeclaration(declaration) || ts2.isFunctionDeclaration(declaration) || ts2.isMethodDeclaration(declaration) && !ts2.isObjectLiteralMethod(declaration) || ts2.isMethodSignature(declaration) || ts2.isSourceFile(declaration)) {
            if (symbol.flags & (16 | 8192 | 32 | 384 | 512)) {
              return getTypeOfFuncClassEnumModule(symbol);
            }
            type = ts2.isBinaryExpression(declaration.parent) ? getWidenedTypeForAssignmentDeclaration(symbol) : tryGetTypeFromEffectiveTypeNode(declaration) || anyType;
          } else if (ts2.isPropertyAssignment(declaration)) {
            type = tryGetTypeFromEffectiveTypeNode(declaration) || checkPropertyAssignment(declaration);
          } else if (ts2.isJsxAttribute(declaration)) {
            type = tryGetTypeFromEffectiveTypeNode(declaration) || checkJsxAttribute(declaration);
          } else if (ts2.isShorthandPropertyAssignment(declaration)) {
            type = tryGetTypeFromEffectiveTypeNode(declaration) || checkExpressionForMutableLocation(declaration.name, 0);
          } else if (ts2.isObjectLiteralMethod(declaration)) {
            type = tryGetTypeFromEffectiveTypeNode(declaration) || checkObjectLiteralMethod(declaration, 0);
          } else if (ts2.isParameter(declaration) || ts2.isPropertyDeclaration(declaration) || ts2.isPropertySignature(declaration) || ts2.isVariableDeclaration(declaration) || ts2.isBindingElement(declaration)) {
            type = getWidenedTypeForVariableLikeDeclaration(declaration, true);
          } else if (ts2.isEnumDeclaration(declaration)) {
            type = getTypeOfFuncClassEnumModule(symbol);
          } else if (ts2.isEnumMember(declaration)) {
            type = getTypeOfEnumMember(symbol);
          } else if (ts2.isAccessor(declaration)) {
            type = resolveTypeOfAccessors(symbol);
          } else {
            return ts2.Debug.fail("Unhandled declaration kind! " + ts2.Debug.formatSyntaxKind(declaration.kind) + " for " + ts2.Debug.formatSymbol(symbol));
          }
          if (!popTypeResolution()) {
            if (symbol.flags & 512 && !(symbol.flags & 67108864)) {
              return getTypeOfFuncClassEnumModule(symbol);
            }
            return reportCircularityError(symbol);
          }
          return type;
        }
        function getAnnotatedAccessorTypeNode(accessor) {
          if (accessor) {
            if (accessor.kind === 163) {
              var getterTypeAnnotation = ts2.getEffectiveReturnTypeNode(accessor);
              return getterTypeAnnotation;
            } else {
              var setterTypeAnnotation = ts2.getEffectiveSetAccessorTypeAnnotationNode(accessor);
              return setterTypeAnnotation;
            }
          }
          return void 0;
        }
        function getAnnotatedAccessorType(accessor) {
          var node = getAnnotatedAccessorTypeNode(accessor);
          return node && getTypeFromTypeNode(node);
        }
        function getAnnotatedAccessorThisParameter(accessor) {
          var parameter = getAccessorThisParameter(accessor);
          return parameter && parameter.symbol;
        }
        function getThisTypeOfDeclaration(declaration) {
          return getThisTypeOfSignature(getSignatureFromDeclaration(declaration));
        }
        function getTypeOfAccessors(symbol) {
          var links = getSymbolLinks(symbol);
          return links.type || (links.type = getTypeOfAccessorsWorker(symbol));
        }
        function getTypeOfAccessorsWorker(symbol) {
          if (!pushTypeResolution(symbol, 0)) {
            return errorType;
          }
          var type = resolveTypeOfAccessors(symbol);
          if (!popTypeResolution()) {
            type = anyType;
            if (noImplicitAny) {
              var getter = ts2.getDeclarationOfKind(symbol, 163);
              error(getter, ts2.Diagnostics._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions, symbolToString(symbol));
            }
          }
          return type;
        }
        function resolveTypeOfAccessors(symbol) {
          var getter = ts2.getDeclarationOfKind(symbol, 163);
          var setter = ts2.getDeclarationOfKind(symbol, 164);
          if (getter && ts2.isInJSFile(getter)) {
            var jsDocType = getTypeForDeclarationFromJSDocComment(getter);
            if (jsDocType) {
              return jsDocType;
            }
          }
          var getterReturnType = getAnnotatedAccessorType(getter);
          if (getterReturnType) {
            return getterReturnType;
          } else {
            var setterParameterType = getAnnotatedAccessorType(setter);
            if (setterParameterType) {
              return setterParameterType;
            } else {
              if (getter && getter.body) {
                return getReturnTypeFromBody(getter);
              } else {
                if (setter) {
                  if (!isPrivateWithinAmbient(setter)) {
                    errorOrSuggestion(noImplicitAny, setter, ts2.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation, symbolToString(symbol));
                  }
                } else {
                  ts2.Debug.assert(!!getter, "there must exist a getter as we are current checking either setter or getter in this function");
                  if (!isPrivateWithinAmbient(getter)) {
                    errorOrSuggestion(noImplicitAny, getter, ts2.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation, symbolToString(symbol));
                  }
                }
                return anyType;
              }
            }
          }
        }
        function getBaseTypeVariableOfClass(symbol) {
          var baseConstructorType = getBaseConstructorTypeOfClass(getDeclaredTypeOfClassOrInterface(symbol));
          return baseConstructorType.flags & 8650752 ? baseConstructorType : baseConstructorType.flags & 2097152 ? ts2.find(baseConstructorType.types, function(t) {
            return !!(t.flags & 8650752);
          }) : void 0;
        }
        function getTypeOfFuncClassEnumModule(symbol) {
          var links = getSymbolLinks(symbol);
          var originalLinks = links;
          if (!links.type) {
            var jsDeclaration = symbol.valueDeclaration && ts2.getDeclarationOfExpando(symbol.valueDeclaration);
            if (jsDeclaration) {
              var merged = mergeJSSymbols(symbol, getSymbolOfNode(jsDeclaration));
              if (merged) {
                symbol = links = merged;
              }
            }
            originalLinks.type = links.type = getTypeOfFuncClassEnumModuleWorker(symbol);
          }
          return links.type;
        }
        function getTypeOfFuncClassEnumModuleWorker(symbol) {
          var declaration = symbol.valueDeclaration;
          if (symbol.flags & 1536 && ts2.isShorthandAmbientModuleSymbol(symbol)) {
            return anyType;
          } else if (declaration && (declaration.kind === 209 || ts2.isAccessExpression(declaration) && declaration.parent.kind === 209)) {
            return getWidenedTypeForAssignmentDeclaration(symbol);
          } else if (symbol.flags & 512 && declaration && ts2.isSourceFile(declaration) && declaration.commonJsModuleIndicator) {
            var resolvedModule = resolveExternalModuleSymbol(symbol);
            if (resolvedModule !== symbol) {
              if (!pushTypeResolution(symbol, 0)) {
                return errorType;
              }
              var exportEquals = getMergedSymbol(symbol.exports.get("export="));
              var type_1 = getWidenedTypeForAssignmentDeclaration(exportEquals, exportEquals === resolvedModule ? void 0 : resolvedModule);
              if (!popTypeResolution()) {
                return reportCircularityError(symbol);
              }
              return type_1;
            }
          }
          var type = createObjectType(16, symbol);
          if (symbol.flags & 32) {
            var baseTypeVariable = getBaseTypeVariableOfClass(symbol);
            return baseTypeVariable ? getIntersectionType([type, baseTypeVariable]) : type;
          } else {
            return strictNullChecks && symbol.flags & 16777216 ? getOptionalType(type) : type;
          }
        }
        function getTypeOfEnumMember(symbol) {
          var links = getSymbolLinks(symbol);
          return links.type || (links.type = getDeclaredTypeOfEnumMember(symbol));
        }
        function getTypeOfAlias(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.type) {
            var targetSymbol = resolveAlias(symbol);
            links.type = targetSymbol.flags & 111551 ? getTypeOfSymbol(targetSymbol) : errorType;
          }
          return links.type;
        }
        function getTypeOfInstantiatedSymbol(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.type) {
            if (!pushTypeResolution(symbol, 0)) {
              return links.type = errorType;
            }
            var type = instantiateType(getTypeOfSymbol(links.target), links.mapper);
            if (!popTypeResolution()) {
              type = reportCircularityError(symbol);
            }
            links.type = type;
          }
          return links.type;
        }
        function reportCircularityError(symbol) {
          var declaration = symbol.valueDeclaration;
          if (ts2.getEffectiveTypeAnnotationNode(declaration)) {
            error(symbol.valueDeclaration, ts2.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation, symbolToString(symbol));
            return errorType;
          }
          if (noImplicitAny && (declaration.kind !== 156 || declaration.initializer)) {
            error(symbol.valueDeclaration, ts2.Diagnostics._0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer, symbolToString(symbol));
          }
          return anyType;
        }
        function getTypeOfSymbolWithDeferredType(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.type) {
            ts2.Debug.assertIsDefined(links.deferralParent);
            ts2.Debug.assertIsDefined(links.deferralConstituents);
            links.type = links.deferralParent.flags & 1048576 ? getUnionType(links.deferralConstituents) : getIntersectionType(links.deferralConstituents);
          }
          return links.type;
        }
        function getTypeOfSymbol(symbol) {
          var checkFlags = ts2.getCheckFlags(symbol);
          if (checkFlags & 65536) {
            return getTypeOfSymbolWithDeferredType(symbol);
          }
          if (checkFlags & 1) {
            return getTypeOfInstantiatedSymbol(symbol);
          }
          if (checkFlags & 262144) {
            return getTypeOfMappedSymbol(symbol);
          }
          if (checkFlags & 8192) {
            return getTypeOfReverseMappedSymbol(symbol);
          }
          if (symbol.flags & (3 | 4)) {
            return getTypeOfVariableOrParameterOrProperty(symbol);
          }
          if (symbol.flags & (16 | 8192 | 32 | 384 | 512)) {
            return getTypeOfFuncClassEnumModule(symbol);
          }
          if (symbol.flags & 8) {
            return getTypeOfEnumMember(symbol);
          }
          if (symbol.flags & 98304) {
            return getTypeOfAccessors(symbol);
          }
          if (symbol.flags & 2097152) {
            return getTypeOfAlias(symbol);
          }
          return errorType;
        }
        function isReferenceToType(type, target) {
          return type !== void 0 && target !== void 0 && (ts2.getObjectFlags(type) & 4) !== 0 && type.target === target;
        }
        function getTargetType(type) {
          return ts2.getObjectFlags(type) & 4 ? type.target : type;
        }
        function hasBaseType(type, checkBase) {
          return check(type);
          function check(type2) {
            if (ts2.getObjectFlags(type2) & (3 | 4)) {
              var target = getTargetType(type2);
              return target === checkBase || ts2.some(getBaseTypes(target), check);
            } else if (type2.flags & 2097152) {
              return ts2.some(type2.types, check);
            }
            return false;
          }
        }
        function appendTypeParameters(typeParameters, declarations) {
          for (var _i = 0, declarations_2 = declarations; _i < declarations_2.length; _i++) {
            var declaration = declarations_2[_i];
            typeParameters = ts2.appendIfUnique(typeParameters, getDeclaredTypeOfTypeParameter(getSymbolOfNode(declaration)));
          }
          return typeParameters;
        }
        function getOuterTypeParameters(node, includeThisTypes) {
          while (true) {
            node = node.parent;
            if (node && ts2.isBinaryExpression(node)) {
              var assignmentKind = ts2.getAssignmentDeclarationKind(node);
              if (assignmentKind === 6 || assignmentKind === 3) {
                var symbol = getSymbolOfNode(node.left);
                if (symbol && symbol.parent && !ts2.findAncestor(symbol.parent.valueDeclaration, function(d) {
                  return node === d;
                })) {
                  node = symbol.parent.valueDeclaration;
                }
              }
            }
            if (!node) {
              return void 0;
            }
            switch (node.kind) {
              case 225:
              case 245:
              case 214:
              case 246:
              case 165:
              case 166:
              case 160:
              case 170:
              case 171:
              case 300:
              case 244:
              case 161:
              case 201:
              case 202:
              case 247:
              case 321:
              case 322:
              case 316:
              case 315:
              case 186:
              case 180:
                var outerTypeParameters = getOuterTypeParameters(node, includeThisTypes);
                if (node.kind === 186) {
                  return ts2.append(outerTypeParameters, getDeclaredTypeOfTypeParameter(getSymbolOfNode(node.typeParameter)));
                } else if (node.kind === 180) {
                  return ts2.concatenate(outerTypeParameters, getInferTypeParameters(node));
                } else if (node.kind === 225 && !ts2.isInJSFile(node)) {
                  break;
                }
                var outerAndOwnTypeParameters = appendTypeParameters(outerTypeParameters, ts2.getEffectiveTypeParameterDeclarations(node));
                var thisType = includeThisTypes && (node.kind === 245 || node.kind === 214 || node.kind === 246 || isJSConstructor(node)) && getDeclaredTypeOfClassOrInterface(getSymbolOfNode(node)).thisType;
                return thisType ? ts2.append(outerAndOwnTypeParameters, thisType) : outerAndOwnTypeParameters;
            }
          }
        }
        function getOuterTypeParametersOfClassOrInterface(symbol) {
          var declaration = symbol.flags & 32 ? symbol.valueDeclaration : ts2.getDeclarationOfKind(symbol, 246);
          ts2.Debug.assert(!!declaration, "Class was missing valueDeclaration -OR- non-class had no interface declarations");
          return getOuterTypeParameters(declaration);
        }
        function getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol) {
          var result;
          for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
            var node = _a[_i];
            if (node.kind === 246 || node.kind === 245 || node.kind === 214 || isJSConstructor(node) || ts2.isTypeAlias(node)) {
              var declaration = node;
              result = appendTypeParameters(result, ts2.getEffectiveTypeParameterDeclarations(declaration));
            }
          }
          return result;
        }
        function getTypeParametersOfClassOrInterface(symbol) {
          return ts2.concatenate(getOuterTypeParametersOfClassOrInterface(symbol), getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol));
        }
        function isMixinConstructorType(type) {
          var signatures = getSignaturesOfType(type, 1);
          if (signatures.length === 1) {
            var s = signatures[0];
            return !s.typeParameters && s.parameters.length === 1 && signatureHasRestParameter(s) && getElementTypeOfArrayType(getTypeOfParameter(s.parameters[0])) === anyType;
          }
          return false;
        }
        function isConstructorType(type) {
          if (getSignaturesOfType(type, 1).length > 0) {
            return true;
          }
          if (type.flags & 8650752) {
            var constraint = getBaseConstraintOfType(type);
            return !!constraint && isMixinConstructorType(constraint);
          }
          return false;
        }
        function getBaseTypeNodeOfClass(type) {
          return ts2.getEffectiveBaseTypeNode(type.symbol.valueDeclaration);
        }
        function getConstructorsForTypeArguments(type, typeArgumentNodes, location) {
          var typeArgCount = ts2.length(typeArgumentNodes);
          var isJavascript = ts2.isInJSFile(location);
          return ts2.filter(getSignaturesOfType(type, 1), function(sig) {
            return (isJavascript || typeArgCount >= getMinTypeArgumentCount(sig.typeParameters)) && typeArgCount <= ts2.length(sig.typeParameters);
          });
        }
        function getInstantiatedConstructorsForTypeArguments(type, typeArgumentNodes, location) {
          var signatures = getConstructorsForTypeArguments(type, typeArgumentNodes, location);
          var typeArguments = ts2.map(typeArgumentNodes, getTypeFromTypeNode);
          return ts2.sameMap(signatures, function(sig) {
            return ts2.some(sig.typeParameters) ? getSignatureInstantiation(sig, typeArguments, ts2.isInJSFile(location)) : sig;
          });
        }
        function getBaseConstructorTypeOfClass(type) {
          if (!type.resolvedBaseConstructorType) {
            var decl = type.symbol.valueDeclaration;
            var extended = ts2.getEffectiveBaseTypeNode(decl);
            var baseTypeNode = getBaseTypeNodeOfClass(type);
            if (!baseTypeNode) {
              return type.resolvedBaseConstructorType = undefinedType;
            }
            if (!pushTypeResolution(type, 1)) {
              return errorType;
            }
            var baseConstructorType = checkExpression(baseTypeNode.expression);
            if (extended && baseTypeNode !== extended) {
              ts2.Debug.assert(!extended.typeArguments);
              checkExpression(extended.expression);
            }
            if (baseConstructorType.flags & (524288 | 2097152)) {
              resolveStructuredTypeMembers(baseConstructorType);
            }
            if (!popTypeResolution()) {
              error(type.symbol.valueDeclaration, ts2.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_base_expression, symbolToString(type.symbol));
              return type.resolvedBaseConstructorType = errorType;
            }
            if (!(baseConstructorType.flags & 1) && baseConstructorType !== nullWideningType && !isConstructorType(baseConstructorType)) {
              var err = error(baseTypeNode.expression, ts2.Diagnostics.Type_0_is_not_a_constructor_function_type, typeToString(baseConstructorType));
              if (baseConstructorType.flags & 262144) {
                var constraint = getConstraintFromTypeParameter(baseConstructorType);
                var ctorReturn = unknownType;
                if (constraint) {
                  var ctorSig = getSignaturesOfType(constraint, 1);
                  if (ctorSig[0]) {
                    ctorReturn = getReturnTypeOfSignature(ctorSig[0]);
                  }
                }
                ts2.addRelatedInfo(err, ts2.createDiagnosticForNode(baseConstructorType.symbol.declarations[0], ts2.Diagnostics.Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1, symbolToString(baseConstructorType.symbol), typeToString(ctorReturn)));
              }
              return type.resolvedBaseConstructorType = errorType;
            }
            type.resolvedBaseConstructorType = baseConstructorType;
          }
          return type.resolvedBaseConstructorType;
        }
        function getImplementsTypes(type) {
          var resolvedImplementsTypes = ts2.emptyArray;
          for (var _i = 0, _a = type.symbol.declarations; _i < _a.length; _i++) {
            var declaration = _a[_i];
            var implementsTypeNodes = ts2.getEffectiveImplementsTypeNodes(declaration);
            if (!implementsTypeNodes)
              continue;
            for (var _b = 0, implementsTypeNodes_1 = implementsTypeNodes; _b < implementsTypeNodes_1.length; _b++) {
              var node = implementsTypeNodes_1[_b];
              var implementsType = getTypeFromTypeNode(node);
              if (implementsType !== errorType) {
                if (resolvedImplementsTypes === ts2.emptyArray) {
                  resolvedImplementsTypes = [implementsType];
                } else {
                  resolvedImplementsTypes.push(implementsType);
                }
              }
            }
          }
          return resolvedImplementsTypes;
        }
        function getBaseTypes(type) {
          if (!type.resolvedBaseTypes) {
            if (type.objectFlags & 8) {
              type.resolvedBaseTypes = [createArrayType(getUnionType(type.typeParameters || ts2.emptyArray), type.readonly)];
            } else if (type.symbol.flags & (32 | 64)) {
              if (type.symbol.flags & 32) {
                resolveBaseTypesOfClass(type);
              }
              if (type.symbol.flags & 64) {
                resolveBaseTypesOfInterface(type);
              }
            } else {
              ts2.Debug.fail("type must be class or interface");
            }
          }
          return type.resolvedBaseTypes;
        }
        function resolveBaseTypesOfClass(type) {
          type.resolvedBaseTypes = ts2.resolvingEmptyArray;
          var baseConstructorType = getApparentType(getBaseConstructorTypeOfClass(type));
          if (!(baseConstructorType.flags & (524288 | 2097152 | 1))) {
            return type.resolvedBaseTypes = ts2.emptyArray;
          }
          var baseTypeNode = getBaseTypeNodeOfClass(type);
          var baseType;
          var originalBaseType = baseConstructorType.symbol ? getDeclaredTypeOfSymbol(baseConstructorType.symbol) : void 0;
          if (baseConstructorType.symbol && baseConstructorType.symbol.flags & 32 && areAllOuterTypeParametersApplied(originalBaseType)) {
            baseType = getTypeFromClassOrInterfaceReference(baseTypeNode, baseConstructorType.symbol);
          } else if (baseConstructorType.flags & 1) {
            baseType = baseConstructorType;
          } else {
            var constructors = getInstantiatedConstructorsForTypeArguments(baseConstructorType, baseTypeNode.typeArguments, baseTypeNode);
            if (!constructors.length) {
              error(baseTypeNode.expression, ts2.Diagnostics.No_base_constructor_has_the_specified_number_of_type_arguments);
              return type.resolvedBaseTypes = ts2.emptyArray;
            }
            baseType = getReturnTypeOfSignature(constructors[0]);
          }
          if (baseType === errorType) {
            return type.resolvedBaseTypes = ts2.emptyArray;
          }
          var reducedBaseType = getReducedType(baseType);
          if (!isValidBaseType(reducedBaseType)) {
            var elaboration = elaborateNeverIntersection(void 0, baseType);
            var diagnostic = ts2.chainDiagnosticMessages(elaboration, ts2.Diagnostics.Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_known_members, typeToString(reducedBaseType));
            diagnostics.add(ts2.createDiagnosticForNodeFromMessageChain(baseTypeNode.expression, diagnostic));
            return type.resolvedBaseTypes = ts2.emptyArray;
          }
          if (type === reducedBaseType || hasBaseType(reducedBaseType, type)) {
            error(type.symbol.valueDeclaration, ts2.Diagnostics.Type_0_recursively_references_itself_as_a_base_type, typeToString(type, void 0, 2));
            return type.resolvedBaseTypes = ts2.emptyArray;
          }
          if (type.resolvedBaseTypes === ts2.resolvingEmptyArray) {
            type.members = void 0;
          }
          return type.resolvedBaseTypes = [reducedBaseType];
        }
        function areAllOuterTypeParametersApplied(type) {
          var outerTypeParameters = type.outerTypeParameters;
          if (outerTypeParameters) {
            var last_1 = outerTypeParameters.length - 1;
            var typeArguments = getTypeArguments(type);
            return outerTypeParameters[last_1].symbol !== typeArguments[last_1].symbol;
          }
          return true;
        }
        function isValidBaseType(type) {
          if (type.flags & 262144) {
            var constraint = getBaseConstraintOfType(type);
            if (constraint) {
              return isValidBaseType(constraint);
            }
          }
          return !!(type.flags & (524288 | 67108864 | 1) && !isGenericMappedType(type) || type.flags & 2097152 && ts2.every(type.types, isValidBaseType));
        }
        function resolveBaseTypesOfInterface(type) {
          type.resolvedBaseTypes = type.resolvedBaseTypes || ts2.emptyArray;
          for (var _i = 0, _a = type.symbol.declarations; _i < _a.length; _i++) {
            var declaration = _a[_i];
            if (declaration.kind === 246 && ts2.getInterfaceBaseTypeNodes(declaration)) {
              for (var _b = 0, _c = ts2.getInterfaceBaseTypeNodes(declaration); _b < _c.length; _b++) {
                var node = _c[_b];
                var baseType = getReducedType(getTypeFromTypeNode(node));
                if (baseType !== errorType) {
                  if (isValidBaseType(baseType)) {
                    if (type !== baseType && !hasBaseType(baseType, type)) {
                      if (type.resolvedBaseTypes === ts2.emptyArray) {
                        type.resolvedBaseTypes = [baseType];
                      } else {
                        type.resolvedBaseTypes.push(baseType);
                      }
                    } else {
                      error(declaration, ts2.Diagnostics.Type_0_recursively_references_itself_as_a_base_type, typeToString(type, void 0, 2));
                    }
                  } else {
                    error(node, ts2.Diagnostics.An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_members);
                  }
                }
              }
            }
          }
        }
        function isThislessInterface(symbol) {
          for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
            var declaration = _a[_i];
            if (declaration.kind === 246) {
              if (declaration.flags & 128) {
                return false;
              }
              var baseTypeNodes = ts2.getInterfaceBaseTypeNodes(declaration);
              if (baseTypeNodes) {
                for (var _b = 0, baseTypeNodes_1 = baseTypeNodes; _b < baseTypeNodes_1.length; _b++) {
                  var node = baseTypeNodes_1[_b];
                  if (ts2.isEntityNameExpression(node.expression)) {
                    var baseSymbol = resolveEntityName(node.expression, 788968, true);
                    if (!baseSymbol || !(baseSymbol.flags & 64) || getDeclaredTypeOfClassOrInterface(baseSymbol).thisType) {
                      return false;
                    }
                  }
                }
              }
            }
          }
          return true;
        }
        function getDeclaredTypeOfClassOrInterface(symbol) {
          var links = getSymbolLinks(symbol);
          var originalLinks = links;
          if (!links.declaredType) {
            var kind = symbol.flags & 32 ? 1 : 2;
            var merged = mergeJSSymbols(symbol, getAssignedClassSymbol(symbol.valueDeclaration));
            if (merged) {
              symbol = links = merged;
            }
            var type = originalLinks.declaredType = links.declaredType = createObjectType(kind, symbol);
            var outerTypeParameters = getOuterTypeParametersOfClassOrInterface(symbol);
            var localTypeParameters = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
            if (outerTypeParameters || localTypeParameters || kind === 1 || !isThislessInterface(symbol)) {
              type.objectFlags |= 4;
              type.typeParameters = ts2.concatenate(outerTypeParameters, localTypeParameters);
              type.outerTypeParameters = outerTypeParameters;
              type.localTypeParameters = localTypeParameters;
              type.instantiations = ts2.createMap();
              type.instantiations.set(getTypeListId(type.typeParameters), type);
              type.target = type;
              type.resolvedTypeArguments = type.typeParameters;
              type.thisType = createTypeParameter(symbol);
              type.thisType.isThisType = true;
              type.thisType.constraint = type;
            }
          }
          return links.declaredType;
        }
        function getDeclaredTypeOfTypeAlias(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.declaredType) {
            if (!pushTypeResolution(symbol, 2)) {
              return errorType;
            }
            var declaration = ts2.Debug.checkDefined(ts2.find(symbol.declarations, ts2.isTypeAlias), "Type alias symbol with no valid declaration found");
            var typeNode = ts2.isJSDocTypeAlias(declaration) ? declaration.typeExpression : declaration.type;
            var type = typeNode ? getTypeFromTypeNode(typeNode) : errorType;
            if (popTypeResolution()) {
              var typeParameters = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
              if (typeParameters) {
                links.typeParameters = typeParameters;
                links.instantiations = ts2.createMap();
                links.instantiations.set(getTypeListId(typeParameters), type);
              }
            } else {
              type = errorType;
              error(ts2.isNamedDeclaration(declaration) ? declaration.name : declaration || declaration, ts2.Diagnostics.Type_alias_0_circularly_references_itself, symbolToString(symbol));
            }
            links.declaredType = type;
          }
          return links.declaredType;
        }
        function isStringConcatExpression(expr) {
          if (ts2.isStringLiteralLike(expr)) {
            return true;
          } else if (expr.kind === 209) {
            return isStringConcatExpression(expr.left) && isStringConcatExpression(expr.right);
          }
          return false;
        }
        function isLiteralEnumMember(member) {
          var expr = member.initializer;
          if (!expr) {
            return !(member.flags & 8388608);
          }
          switch (expr.kind) {
            case 10:
            case 8:
            case 14:
              return true;
            case 207:
              return expr.operator === 40 && expr.operand.kind === 8;
            case 75:
              return ts2.nodeIsMissing(expr) || !!getSymbolOfNode(member.parent).exports.get(expr.escapedText);
            case 209:
              return isStringConcatExpression(expr);
            default:
              return false;
          }
        }
        function getEnumKind(symbol) {
          var links = getSymbolLinks(symbol);
          if (links.enumKind !== void 0) {
            return links.enumKind;
          }
          var hasNonLiteralMember = false;
          for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
            var declaration = _a[_i];
            if (declaration.kind === 248) {
              for (var _b = 0, _c = declaration.members; _b < _c.length; _b++) {
                var member = _c[_b];
                if (member.initializer && ts2.isStringLiteralLike(member.initializer)) {
                  return links.enumKind = 1;
                }
                if (!isLiteralEnumMember(member)) {
                  hasNonLiteralMember = true;
                }
              }
            }
          }
          return links.enumKind = hasNonLiteralMember ? 0 : 1;
        }
        function getBaseTypeOfEnumLiteralType(type) {
          return type.flags & 1024 && !(type.flags & 1048576) ? getDeclaredTypeOfSymbol(getParentOfSymbol(type.symbol)) : type;
        }
        function getDeclaredTypeOfEnum(symbol) {
          var links = getSymbolLinks(symbol);
          if (links.declaredType) {
            return links.declaredType;
          }
          if (getEnumKind(symbol) === 1) {
            enumCount++;
            var memberTypeList = [];
            for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
              var declaration = _a[_i];
              if (declaration.kind === 248) {
                for (var _b = 0, _c = declaration.members; _b < _c.length; _b++) {
                  var member = _c[_b];
                  var value = getEnumMemberValue(member);
                  var memberType = getFreshTypeOfLiteralType(getLiteralType(value !== void 0 ? value : 0, enumCount, getSymbolOfNode(member)));
                  getSymbolLinks(getSymbolOfNode(member)).declaredType = memberType;
                  memberTypeList.push(getRegularTypeOfLiteralType(memberType));
                }
              }
            }
            if (memberTypeList.length) {
              var enumType_1 = getUnionType(memberTypeList, 1, symbol, void 0);
              if (enumType_1.flags & 1048576) {
                enumType_1.flags |= 1024;
                enumType_1.symbol = symbol;
              }
              return links.declaredType = enumType_1;
            }
          }
          var enumType = createType(32);
          enumType.symbol = symbol;
          return links.declaredType = enumType;
        }
        function getDeclaredTypeOfEnumMember(symbol) {
          var links = getSymbolLinks(symbol);
          if (!links.declaredType) {
            var enumType = getDeclaredTypeOfEnum(getParentOfSymbol(symbol));
            if (!links.declaredType) {
              links.declaredType = enumType;
            }
          }
          return links.declaredType;
        }
        function getDeclaredTypeOfTypeParameter(symbol) {
          var links = getSymbolLinks(symbol);
          return links.declaredType || (links.declaredType = createTypeParameter(symbol));
        }
        function getDeclaredTypeOfAlias(symbol) {
          var links = getSymbolLinks(symbol);
          return links.declaredType || (links.declaredType = getDeclaredTypeOfSymbol(resolveAlias(symbol)));
        }
        function getDeclaredTypeOfSymbol(symbol) {
          return tryGetDeclaredTypeOfSymbol(symbol) || errorType;
        }
        function tryGetDeclaredTypeOfSymbol(symbol) {
          if (symbol.flags & (32 | 64)) {
            return getDeclaredTypeOfClassOrInterface(symbol);
          }
          if (symbol.flags & 524288) {
            return getDeclaredTypeOfTypeAlias(symbol);
          }
          if (symbol.flags & 262144) {
            return getDeclaredTypeOfTypeParameter(symbol);
          }
          if (symbol.flags & 384) {
            return getDeclaredTypeOfEnum(symbol);
          }
          if (symbol.flags & 8) {
            return getDeclaredTypeOfEnumMember(symbol);
          }
          if (symbol.flags & 2097152) {
            return getDeclaredTypeOfAlias(symbol);
          }
          return void 0;
        }
        function isThislessType(node) {
          switch (node.kind) {
            case 125:
            case 148:
            case 143:
            case 140:
            case 151:
            case 128:
            case 144:
            case 141:
            case 110:
            case 146:
            case 100:
            case 137:
            case 187:
              return true;
            case 174:
              return isThislessType(node.elementType);
            case 169:
              return !node.typeArguments || node.typeArguments.every(isThislessType);
          }
          return false;
        }
        function isThislessTypeParameter(node) {
          var constraint = ts2.getEffectiveConstraintOfTypeParameter(node);
          return !constraint || isThislessType(constraint);
        }
        function isThislessVariableLikeDeclaration(node) {
          var typeNode = ts2.getEffectiveTypeAnnotationNode(node);
          return typeNode ? isThislessType(typeNode) : !ts2.hasInitializer(node);
        }
        function isThislessFunctionLikeDeclaration(node) {
          var returnType = ts2.getEffectiveReturnTypeNode(node);
          var typeParameters = ts2.getEffectiveTypeParameterDeclarations(node);
          return (node.kind === 162 || !!returnType && isThislessType(returnType)) && node.parameters.every(isThislessVariableLikeDeclaration) && typeParameters.every(isThislessTypeParameter);
        }
        function isThisless(symbol) {
          if (symbol.declarations && symbol.declarations.length === 1) {
            var declaration = symbol.declarations[0];
            if (declaration) {
              switch (declaration.kind) {
                case 159:
                case 158:
                  return isThislessVariableLikeDeclaration(declaration);
                case 161:
                case 160:
                case 162:
                case 163:
                case 164:
                  return isThislessFunctionLikeDeclaration(declaration);
              }
            }
          }
          return false;
        }
        function createInstantiatedSymbolTable(symbols, mapper, mappingThisOnly) {
          var result = ts2.createSymbolTable();
          for (var _i = 0, symbols_2 = symbols; _i < symbols_2.length; _i++) {
            var symbol = symbols_2[_i];
            result.set(symbol.escapedName, mappingThisOnly && isThisless(symbol) ? symbol : instantiateSymbol(symbol, mapper));
          }
          return result;
        }
        function addInheritedMembers(symbols, baseSymbols) {
          for (var _i = 0, baseSymbols_1 = baseSymbols; _i < baseSymbols_1.length; _i++) {
            var s = baseSymbols_1[_i];
            if (!symbols.has(s.escapedName) && !isStaticPrivateIdentifierProperty(s)) {
              symbols.set(s.escapedName, s);
            }
          }
        }
        function isStaticPrivateIdentifierProperty(s) {
          return !!s.valueDeclaration && ts2.isPrivateIdentifierPropertyDeclaration(s.valueDeclaration) && ts2.hasModifier(s.valueDeclaration, 32);
        }
        function resolveDeclaredMembers(type) {
          if (!type.declaredProperties) {
            var symbol = type.symbol;
            var members = getMembersOfSymbol(symbol);
            type.declaredProperties = getNamedMembers(members);
            type.declaredCallSignatures = ts2.emptyArray;
            type.declaredConstructSignatures = ts2.emptyArray;
            type.declaredCallSignatures = getSignaturesOfSymbol(members.get("__call"));
            type.declaredConstructSignatures = getSignaturesOfSymbol(members.get("__new"));
            type.declaredStringIndexInfo = getIndexInfoOfSymbol(symbol, 0);
            type.declaredNumberIndexInfo = getIndexInfoOfSymbol(symbol, 1);
          }
          return type;
        }
        function isTypeUsableAsPropertyName(type) {
          return !!(type.flags & 8576);
        }
        function isLateBindableName(node) {
          if (!ts2.isComputedPropertyName(node) && !ts2.isElementAccessExpression(node)) {
            return false;
          }
          var expr = ts2.isComputedPropertyName(node) ? node.expression : node.argumentExpression;
          return ts2.isEntityNameExpression(expr) && isTypeUsableAsPropertyName(ts2.isComputedPropertyName(node) ? checkComputedPropertyName(node) : checkExpressionCached(expr));
        }
        function isLateBoundName(name) {
          return name.charCodeAt(0) === 95 && name.charCodeAt(1) === 95 && name.charCodeAt(2) === 64;
        }
        function hasLateBindableName(node) {
          var name = ts2.getNameOfDeclaration(node);
          return !!name && isLateBindableName(name);
        }
        function hasNonBindableDynamicName(node) {
          return ts2.hasDynamicName(node) && !hasLateBindableName(node);
        }
        function isNonBindableDynamicName(node) {
          return ts2.isDynamicName(node) && !isLateBindableName(node);
        }
        function getPropertyNameFromType(type) {
          if (type.flags & 8192) {
            return type.escapedName;
          }
          if (type.flags & (128 | 256)) {
            return ts2.escapeLeadingUnderscores("" + type.value);
          }
          return ts2.Debug.fail();
        }
        function addDeclarationToLateBoundSymbol(symbol, member, symbolFlags) {
          ts2.Debug.assert(!!(ts2.getCheckFlags(symbol) & 4096), "Expected a late-bound symbol.");
          symbol.flags |= symbolFlags;
          getSymbolLinks(member.symbol).lateSymbol = symbol;
          if (!symbol.declarations) {
            symbol.declarations = [member];
          } else {
            symbol.declarations.push(member);
          }
          if (symbolFlags & 111551) {
            if (!symbol.valueDeclaration || symbol.valueDeclaration.kind !== member.kind) {
              symbol.valueDeclaration = member;
            }
          }
        }
        function lateBindMember(parent, earlySymbols, lateSymbols, decl) {
          ts2.Debug.assert(!!decl.symbol, "The member is expected to have a symbol.");
          var links = getNodeLinks(decl);
          if (!links.resolvedSymbol) {
            links.resolvedSymbol = decl.symbol;
            var declName = ts2.isBinaryExpression(decl) ? decl.left : decl.name;
            var type = ts2.isElementAccessExpression(declName) ? checkExpressionCached(declName.argumentExpression) : checkComputedPropertyName(declName);
            if (isTypeUsableAsPropertyName(type)) {
              var memberName = getPropertyNameFromType(type);
              var symbolFlags = decl.symbol.flags;
              var lateSymbol = lateSymbols.get(memberName);
              if (!lateSymbol)
                lateSymbols.set(memberName, lateSymbol = createSymbol(0, memberName, 4096));
              var earlySymbol = earlySymbols && earlySymbols.get(memberName);
              if (lateSymbol.flags & getExcludedSymbolFlags(symbolFlags) || earlySymbol) {
                var declarations = earlySymbol ? ts2.concatenate(earlySymbol.declarations, lateSymbol.declarations) : lateSymbol.declarations;
                var name_3 = !(type.flags & 8192) && ts2.unescapeLeadingUnderscores(memberName) || ts2.declarationNameToString(declName);
                ts2.forEach(declarations, function(declaration) {
                  return error(ts2.getNameOfDeclaration(declaration) || declaration, ts2.Diagnostics.Property_0_was_also_declared_here, name_3);
                });
                error(declName || decl, ts2.Diagnostics.Duplicate_property_0, name_3);
                lateSymbol = createSymbol(0, memberName, 4096);
              }
              lateSymbol.nameType = type;
              addDeclarationToLateBoundSymbol(lateSymbol, decl, symbolFlags);
              if (lateSymbol.parent) {
                ts2.Debug.assert(lateSymbol.parent === parent, "Existing symbol parent should match new one");
              } else {
                lateSymbol.parent = parent;
              }
              return links.resolvedSymbol = lateSymbol;
            }
          }
          return links.resolvedSymbol;
        }
        function getResolvedMembersOrExportsOfSymbol(symbol, resolutionKind) {
          var links = getSymbolLinks(symbol);
          if (!links[resolutionKind]) {
            var isStatic = resolutionKind === "resolvedExports";
            var earlySymbols = !isStatic ? symbol.members : symbol.flags & 1536 ? getExportsOfModuleWorker(symbol) : symbol.exports;
            links[resolutionKind] = earlySymbols || emptySymbols;
            var lateSymbols = ts2.createSymbolTable();
            for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
              var decl = _a[_i];
              var members = ts2.getMembersOfDeclaration(decl);
              if (members) {
                for (var _b = 0, members_5 = members; _b < members_5.length; _b++) {
                  var member = members_5[_b];
                  if (isStatic === ts2.hasStaticModifier(member) && hasLateBindableName(member)) {
                    lateBindMember(symbol, earlySymbols, lateSymbols, member);
                  }
                }
              }
            }
            var assignments = symbol.assignmentDeclarationMembers;
            if (assignments) {
              var decls = ts2.arrayFrom(assignments.values());
              for (var _c = 0, decls_1 = decls; _c < decls_1.length; _c++) {
                var member = decls_1[_c];
                var assignmentKind = ts2.getAssignmentDeclarationKind(member);
                var isInstanceMember = assignmentKind === 3 || assignmentKind === 4 || assignmentKind === 9 || assignmentKind === 6;
                if (isStatic === !isInstanceMember && hasLateBindableName(member)) {
                  lateBindMember(symbol, earlySymbols, lateSymbols, member);
                }
              }
            }
            links[resolutionKind] = combineSymbolTables(earlySymbols, lateSymbols) || emptySymbols;
          }
          return links[resolutionKind];
        }
        function getMembersOfSymbol(symbol) {
          return symbol.flags & 6256 ? getResolvedMembersOrExportsOfSymbol(symbol, "resolvedMembers") : symbol.members || emptySymbols;
        }
        function getLateBoundSymbol(symbol) {
          if (symbol.flags & 106500 && symbol.escapedName === "__computed") {
            var links = getSymbolLinks(symbol);
            if (!links.lateSymbol && ts2.some(symbol.declarations, hasLateBindableName)) {
              var parent = getMergedSymbol(symbol.parent);
              if (ts2.some(symbol.declarations, ts2.hasStaticModifier)) {
                getExportsOfSymbol(parent);
              } else {
                getMembersOfSymbol(parent);
              }
            }
            return links.lateSymbol || (links.lateSymbol = symbol);
          }
          return symbol;
        }
        function getTypeWithThisArgument(type, thisArgument, needApparentType) {
          if (ts2.getObjectFlags(type) & 4) {
            var target = type.target;
            var typeArguments = getTypeArguments(type);
            if (ts2.length(target.typeParameters) === ts2.length(typeArguments)) {
              var ref = createTypeReference(target, ts2.concatenate(typeArguments, [thisArgument || target.thisType]));
              return needApparentType ? getApparentType(ref) : ref;
            }
          } else if (type.flags & 2097152) {
            return getIntersectionType(ts2.map(type.types, function(t) {
              return getTypeWithThisArgument(t, thisArgument, needApparentType);
            }));
          }
          return needApparentType ? getApparentType(type) : type;
        }
        function resolveObjectTypeMembers(type, source, typeParameters, typeArguments) {
          var mapper;
          var members;
          var callSignatures;
          var constructSignatures;
          var stringIndexInfo;
          var numberIndexInfo;
          if (ts2.rangeEquals(typeParameters, typeArguments, 0, typeParameters.length)) {
            members = source.symbol ? getMembersOfSymbol(source.symbol) : ts2.createSymbolTable(source.declaredProperties);
            callSignatures = source.declaredCallSignatures;
            constructSignatures = source.declaredConstructSignatures;
            stringIndexInfo = source.declaredStringIndexInfo;
            numberIndexInfo = source.declaredNumberIndexInfo;
          } else {
            mapper = createTypeMapper(typeParameters, typeArguments);
            members = createInstantiatedSymbolTable(source.declaredProperties, mapper, typeParameters.length === 1);
            callSignatures = instantiateSignatures(source.declaredCallSignatures, mapper);
            constructSignatures = instantiateSignatures(source.declaredConstructSignatures, mapper);
            stringIndexInfo = instantiateIndexInfo(source.declaredStringIndexInfo, mapper);
            numberIndexInfo = instantiateIndexInfo(source.declaredNumberIndexInfo, mapper);
          }
          var baseTypes = getBaseTypes(source);
          if (baseTypes.length) {
            if (source.symbol && members === getMembersOfSymbol(source.symbol)) {
              members = ts2.createSymbolTable(source.declaredProperties);
            }
            setStructuredTypeMembers(type, members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo);
            var thisArgument = ts2.lastOrUndefined(typeArguments);
            for (var _i = 0, baseTypes_1 = baseTypes; _i < baseTypes_1.length; _i++) {
              var baseType = baseTypes_1[_i];
              var instantiatedBaseType = thisArgument ? getTypeWithThisArgument(instantiateType(baseType, mapper), thisArgument) : baseType;
              addInheritedMembers(members, getPropertiesOfType(instantiatedBaseType));
              callSignatures = ts2.concatenate(callSignatures, getSignaturesOfType(instantiatedBaseType, 0));
              constructSignatures = ts2.concatenate(constructSignatures, getSignaturesOfType(instantiatedBaseType, 1));
              if (!stringIndexInfo) {
                stringIndexInfo = instantiatedBaseType === anyType ? createIndexInfo(anyType, false) : getIndexInfoOfType(instantiatedBaseType, 0);
              }
              numberIndexInfo = numberIndexInfo || getIndexInfoOfType(instantiatedBaseType, 1);
            }
          }
          setStructuredTypeMembers(type, members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo);
        }
        function resolveClassOrInterfaceMembers(type) {
          resolveObjectTypeMembers(type, resolveDeclaredMembers(type), ts2.emptyArray, ts2.emptyArray);
        }
        function resolveTypeReferenceMembers(type) {
          var source = resolveDeclaredMembers(type.target);
          var typeParameters = ts2.concatenate(source.typeParameters, [source.thisType]);
          var typeArguments = getTypeArguments(type);
          var paddedTypeArguments = typeArguments.length === typeParameters.length ? typeArguments : ts2.concatenate(typeArguments, [type]);
          resolveObjectTypeMembers(type, source, typeParameters, paddedTypeArguments);
        }
        function createSignature(declaration, typeParameters, thisParameter, parameters, resolvedReturnType, resolvedTypePredicate, minArgumentCount, flags) {
          var sig = new Signature(checker, flags);
          sig.declaration = declaration;
          sig.typeParameters = typeParameters;
          sig.parameters = parameters;
          sig.thisParameter = thisParameter;
          sig.resolvedReturnType = resolvedReturnType;
          sig.resolvedTypePredicate = resolvedTypePredicate;
          sig.minArgumentCount = minArgumentCount;
          sig.target = void 0;
          sig.mapper = void 0;
          sig.unionSignatures = void 0;
          return sig;
        }
        function cloneSignature(sig) {
          var result = createSignature(sig.declaration, sig.typeParameters, sig.thisParameter, sig.parameters, void 0, void 0, sig.minArgumentCount, sig.flags & 3);
          result.target = sig.target;
          result.mapper = sig.mapper;
          result.unionSignatures = sig.unionSignatures;
          return result;
        }
        function createUnionSignature(signature, unionSignatures) {
          var result = cloneSignature(signature);
          result.unionSignatures = unionSignatures;
          result.target = void 0;
          result.mapper = void 0;
          return result;
        }
        function getOptionalCallSignature(signature, callChainFlags) {
          if ((signature.flags & 12) === callChainFlags) {
            return signature;
          }
          if (!signature.optionalCallSignatureCache) {
            signature.optionalCallSignatureCache = {};
          }
          var key = callChainFlags === 4 ? "inner" : "outer";
          return signature.optionalCallSignatureCache[key] || (signature.optionalCallSignatureCache[key] = createOptionalCallSignature(signature, callChainFlags));
        }
        function createOptionalCallSignature(signature, callChainFlags) {
          ts2.Debug.assert(callChainFlags === 4 || callChainFlags === 8, "An optional call signature can either be for an inner call chain or an outer call chain, but not both.");
          var result = cloneSignature(signature);
          result.flags |= callChainFlags;
          return result;
        }
        function getExpandedParameters(sig) {
          if (signatureHasRestParameter(sig)) {
            var restIndex_1 = sig.parameters.length - 1;
            var restParameter = sig.parameters[restIndex_1];
            var restType = getTypeOfSymbol(restParameter);
            if (isTupleType(restType)) {
              var elementTypes = getTypeArguments(restType);
              var minLength_1 = restType.target.minLength;
              var tupleRestIndex_1 = restType.target.hasRestElement ? elementTypes.length - 1 : -1;
              var restParams = ts2.map(elementTypes, function(t, i) {
                var name = getParameterNameAtPosition(sig, restIndex_1 + i);
                var checkFlags = i === tupleRestIndex_1 ? 32768 : i >= minLength_1 ? 16384 : 0;
                var symbol = createSymbol(1, name, checkFlags);
                symbol.type = i === tupleRestIndex_1 ? createArrayType(t) : t;
                return symbol;
              });
              return ts2.concatenate(sig.parameters.slice(0, restIndex_1), restParams);
            }
          }
          return sig.parameters;
        }
        function getDefaultConstructSignatures(classType) {
          var baseConstructorType = getBaseConstructorTypeOfClass(classType);
          var baseSignatures = getSignaturesOfType(baseConstructorType, 1);
          if (baseSignatures.length === 0) {
            return [createSignature(void 0, classType.localTypeParameters, void 0, ts2.emptyArray, classType, void 0, 0, 0)];
          }
          var baseTypeNode = getBaseTypeNodeOfClass(classType);
          var isJavaScript = ts2.isInJSFile(baseTypeNode);
          var typeArguments = typeArgumentsFromTypeReferenceNode(baseTypeNode);
          var typeArgCount = ts2.length(typeArguments);
          var result = [];
          for (var _i = 0, baseSignatures_1 = baseSignatures; _i < baseSignatures_1.length; _i++) {
            var baseSig = baseSignatures_1[_i];
            var minTypeArgumentCount = getMinTypeArgumentCount(baseSig.typeParameters);
            var typeParamCount = ts2.length(baseSig.typeParameters);
            if (isJavaScript || typeArgCount >= minTypeArgumentCount && typeArgCount <= typeParamCount) {
              var sig = typeParamCount ? createSignatureInstantiation(baseSig, fillMissingTypeArguments(typeArguments, baseSig.typeParameters, minTypeArgumentCount, isJavaScript)) : cloneSignature(baseSig);
              sig.typeParameters = classType.localTypeParameters;
              sig.resolvedReturnType = classType;
              result.push(sig);
            }
          }
          return result;
        }
        function findMatchingSignature(signatureList, signature, partialMatch, ignoreThisTypes, ignoreReturnTypes) {
          for (var _i = 0, signatureList_1 = signatureList; _i < signatureList_1.length; _i++) {
            var s = signatureList_1[_i];
            if (compareSignaturesIdentical(s, signature, partialMatch, ignoreThisTypes, ignoreReturnTypes, partialMatch ? compareTypesSubtypeOf : compareTypesIdentical)) {
              return s;
            }
          }
        }
        function findMatchingSignatures(signatureLists, signature, listIndex) {
          if (signature.typeParameters) {
            if (listIndex > 0) {
              return void 0;
            }
            for (var i = 1; i < signatureLists.length; i++) {
              if (!findMatchingSignature(signatureLists[i], signature, false, false, false)) {
                return void 0;
              }
            }
            return [signature];
          }
          var result;
          for (var i = 0; i < signatureLists.length; i++) {
            var match = i === listIndex ? signature : findMatchingSignature(signatureLists[i], signature, true, false, true);
            if (!match) {
              return void 0;
            }
            result = ts2.appendIfUnique(result, match);
          }
          return result;
        }
        function getUnionSignatures(signatureLists) {
          var result;
          var indexWithLengthOverOne;
          for (var i = 0; i < signatureLists.length; i++) {
            if (signatureLists[i].length === 0)
              return ts2.emptyArray;
            if (signatureLists[i].length > 1) {
              indexWithLengthOverOne = indexWithLengthOverOne === void 0 ? i : -1;
            }
            for (var _i = 0, _a = signatureLists[i]; _i < _a.length; _i++) {
              var signature = _a[_i];
              if (!result || !findMatchingSignature(result, signature, false, false, true)) {
                var unionSignatures = findMatchingSignatures(signatureLists, signature, i);
                if (unionSignatures) {
                  var s = signature;
                  if (unionSignatures.length > 1) {
                    var thisParameter = signature.thisParameter;
                    var firstThisParameterOfUnionSignatures = ts2.forEach(unionSignatures, function(sig) {
                      return sig.thisParameter;
                    });
                    if (firstThisParameterOfUnionSignatures) {
                      var thisType = getIntersectionType(ts2.mapDefined(unionSignatures, function(sig) {
                        return sig.thisParameter && getTypeOfSymbol(sig.thisParameter);
                      }));
                      thisParameter = createSymbolWithType(firstThisParameterOfUnionSignatures, thisType);
                    }
                    s = createUnionSignature(signature, unionSignatures);
                    s.thisParameter = thisParameter;
                  }
                  (result || (result = [])).push(s);
                }
              }
            }
          }
          if (!ts2.length(result) && indexWithLengthOverOne !== -1) {
            var masterList = signatureLists[indexWithLengthOverOne !== void 0 ? indexWithLengthOverOne : 0];
            var results = masterList.slice();
            var _loop_9 = function(signatures2) {
              if (signatures2 !== masterList) {
                var signature_1 = signatures2[0];
                ts2.Debug.assert(!!signature_1, "getUnionSignatures bails early on empty signature lists and should not have empty lists on second pass");
                results = signature_1.typeParameters && ts2.some(results, function(s2) {
                  return !!s2.typeParameters;
                }) ? void 0 : ts2.map(results, function(sig) {
                  return combineSignaturesOfUnionMembers(sig, signature_1);
                });
                if (!results) {
                  return "break";
                }
              }
            };
            for (var _b = 0, signatureLists_1 = signatureLists; _b < signatureLists_1.length; _b++) {
              var signatures = signatureLists_1[_b];
              var state_3 = _loop_9(signatures);
              if (state_3 === "break")
                break;
            }
            result = results;
          }
          return result || ts2.emptyArray;
        }
        function combineUnionThisParam(left, right) {
          if (!left || !right) {
            return left || right;
          }
          var thisType = getIntersectionType([getTypeOfSymbol(left), getTypeOfSymbol(right)]);
          return createSymbolWithType(left, thisType);
        }
        function combineUnionParameters(left, right) {
          var leftCount = getParameterCount(left);
          var rightCount = getParameterCount(right);
          var longest = leftCount >= rightCount ? left : right;
          var shorter = longest === left ? right : left;
          var longestCount = longest === left ? leftCount : rightCount;
          var eitherHasEffectiveRest = hasEffectiveRestParameter(left) || hasEffectiveRestParameter(right);
          var needsExtraRestElement = eitherHasEffectiveRest && !hasEffectiveRestParameter(longest);
          var params = new Array(longestCount + (needsExtraRestElement ? 1 : 0));
          for (var i = 0; i < longestCount; i++) {
            var longestParamType = tryGetTypeAtPosition(longest, i);
            var shorterParamType = tryGetTypeAtPosition(shorter, i) || unknownType;
            var unionParamType = getIntersectionType([longestParamType, shorterParamType]);
            var isRestParam = eitherHasEffectiveRest && !needsExtraRestElement && i === longestCount - 1;
            var isOptional = i >= getMinArgumentCount(longest) && i >= getMinArgumentCount(shorter);
            var leftName = i >= leftCount ? void 0 : getParameterNameAtPosition(left, i);
            var rightName = i >= rightCount ? void 0 : getParameterNameAtPosition(right, i);
            var paramName = leftName === rightName ? leftName : !leftName ? rightName : !rightName ? leftName : void 0;
            var paramSymbol = createSymbol(1 | (isOptional && !isRestParam ? 16777216 : 0), paramName || "arg" + i);
            paramSymbol.type = isRestParam ? createArrayType(unionParamType) : unionParamType;
            params[i] = paramSymbol;
          }
          if (needsExtraRestElement) {
            var restParamSymbol = createSymbol(1, "args");
            restParamSymbol.type = createArrayType(getTypeAtPosition(shorter, longestCount));
            params[longestCount] = restParamSymbol;
          }
          return params;
        }
        function combineSignaturesOfUnionMembers(left, right) {
          var declaration = left.declaration;
          var params = combineUnionParameters(left, right);
          var thisParam = combineUnionThisParam(left.thisParameter, right.thisParameter);
          var minArgCount = Math.max(left.minArgumentCount, right.minArgumentCount);
          var result = createSignature(declaration, left.typeParameters || right.typeParameters, thisParam, params, void 0, void 0, minArgCount, (left.flags | right.flags) & 3);
          result.unionSignatures = ts2.concatenate(left.unionSignatures || [left], [right]);
          return result;
        }
        function getUnionIndexInfo(types, kind) {
          var indexTypes = [];
          var isAnyReadonly = false;
          for (var _i = 0, types_3 = types; _i < types_3.length; _i++) {
            var type = types_3[_i];
            var indexInfo = getIndexInfoOfType(getApparentType(type), kind);
            if (!indexInfo) {
              return void 0;
            }
            indexTypes.push(indexInfo.type);
            isAnyReadonly = isAnyReadonly || indexInfo.isReadonly;
          }
          return createIndexInfo(getUnionType(indexTypes, 2), isAnyReadonly);
        }
        function resolveUnionTypeMembers(type) {
          var callSignatures = getUnionSignatures(ts2.map(type.types, function(t) {
            return t === globalFunctionType ? [unknownSignature] : getSignaturesOfType(t, 0);
          }));
          var constructSignatures = getUnionSignatures(ts2.map(type.types, function(t) {
            return getSignaturesOfType(t, 1);
          }));
          var stringIndexInfo = getUnionIndexInfo(type.types, 0);
          var numberIndexInfo = getUnionIndexInfo(type.types, 1);
          setStructuredTypeMembers(type, emptySymbols, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo);
        }
        function intersectTypes(type1, type2) {
          return !type1 ? type2 : !type2 ? type1 : getIntersectionType([type1, type2]);
        }
        function intersectIndexInfos(info1, info2) {
          return !info1 ? info2 : !info2 ? info1 : createIndexInfo(getIntersectionType([info1.type, info2.type]), info1.isReadonly && info2.isReadonly);
        }
        function unionSpreadIndexInfos(info1, info2) {
          return info1 && info2 && createIndexInfo(getUnionType([info1.type, info2.type]), info1.isReadonly || info2.isReadonly);
        }
        function findMixins(types) {
          var constructorTypeCount = ts2.countWhere(types, function(t) {
            return getSignaturesOfType(t, 1).length > 0;
          });
          var mixinFlags = ts2.map(types, isMixinConstructorType);
          if (constructorTypeCount > 0 && constructorTypeCount === ts2.countWhere(mixinFlags, function(b) {
            return b;
          })) {
            var firstMixinIndex = mixinFlags.indexOf(true);
            mixinFlags[firstMixinIndex] = false;
          }
          return mixinFlags;
        }
        function includeMixinType(type, types, mixinFlags, index) {
          var mixedTypes = [];
          for (var i = 0; i < types.length; i++) {
            if (i === index) {
              mixedTypes.push(type);
            } else if (mixinFlags[i]) {
              mixedTypes.push(getReturnTypeOfSignature(getSignaturesOfType(types[i], 1)[0]));
            }
          }
          return getIntersectionType(mixedTypes);
        }
        function resolveIntersectionTypeMembers(type) {
          var callSignatures;
          var constructSignatures;
          var stringIndexInfo;
          var numberIndexInfo;
          var types = type.types;
          var mixinFlags = findMixins(types);
          var mixinCount = ts2.countWhere(mixinFlags, function(b) {
            return b;
          });
          var _loop_10 = function(i2) {
            var t = type.types[i2];
            if (!mixinFlags[i2]) {
              var signatures = getSignaturesOfType(t, 1);
              if (signatures.length && mixinCount > 0) {
                signatures = ts2.map(signatures, function(s) {
                  var clone = cloneSignature(s);
                  clone.resolvedReturnType = includeMixinType(getReturnTypeOfSignature(s), types, mixinFlags, i2);
                  return clone;
                });
              }
              constructSignatures = appendSignatures(constructSignatures, signatures);
            }
            callSignatures = appendSignatures(callSignatures, getSignaturesOfType(t, 0));
            stringIndexInfo = intersectIndexInfos(stringIndexInfo, getIndexInfoOfType(t, 0));
            numberIndexInfo = intersectIndexInfos(numberIndexInfo, getIndexInfoOfType(t, 1));
          };
          for (var i = 0; i < types.length; i++) {
            _loop_10(i);
          }
          setStructuredTypeMembers(type, emptySymbols, callSignatures || ts2.emptyArray, constructSignatures || ts2.emptyArray, stringIndexInfo, numberIndexInfo);
        }
        function appendSignatures(signatures, newSignatures) {
          var _loop_11 = function(sig2) {
            if (!signatures || ts2.every(signatures, function(s) {
              return !compareSignaturesIdentical(s, sig2, false, false, false, compareTypesIdentical);
            })) {
              signatures = ts2.append(signatures, sig2);
            }
          };
          for (var _i = 0, newSignatures_1 = newSignatures; _i < newSignatures_1.length; _i++) {
            var sig = newSignatures_1[_i];
            _loop_11(sig);
          }
          return signatures;
        }
        function resolveAnonymousTypeMembers(type) {
          var symbol = getMergedSymbol(type.symbol);
          if (type.target) {
            setStructuredTypeMembers(type, emptySymbols, ts2.emptyArray, ts2.emptyArray, void 0, void 0);
            var members = createInstantiatedSymbolTable(getPropertiesOfObjectType(type.target), type.mapper, false);
            var callSignatures = instantiateSignatures(getSignaturesOfType(type.target, 0), type.mapper);
            var constructSignatures = instantiateSignatures(getSignaturesOfType(type.target, 1), type.mapper);
            var stringIndexInfo = instantiateIndexInfo(getIndexInfoOfType(type.target, 0), type.mapper);
            var numberIndexInfo = instantiateIndexInfo(getIndexInfoOfType(type.target, 1), type.mapper);
            setStructuredTypeMembers(type, members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo);
          } else if (symbol.flags & 2048) {
            setStructuredTypeMembers(type, emptySymbols, ts2.emptyArray, ts2.emptyArray, void 0, void 0);
            var members = getMembersOfSymbol(symbol);
            var callSignatures = getSignaturesOfSymbol(members.get("__call"));
            var constructSignatures = getSignaturesOfSymbol(members.get("__new"));
            var stringIndexInfo = getIndexInfoOfSymbol(symbol, 0);
            var numberIndexInfo = getIndexInfoOfSymbol(symbol, 1);
            setStructuredTypeMembers(type, members, callSignatures, constructSignatures, stringIndexInfo, numberIndexInfo);
          } else {
            var members = emptySymbols;
            var stringIndexInfo = void 0;
            if (symbol.exports) {
              members = getExportsOfSymbol(symbol);
              if (symbol === globalThisSymbol) {
                var varsOnly_1 = ts2.createMap();
                members.forEach(function(p) {
                  if (!(p.flags & 418)) {
                    varsOnly_1.set(p.escapedName, p);
                  }
                });
                members = varsOnly_1;
              }
            }
            setStructuredTypeMembers(type, members, ts2.emptyArray, ts2.emptyArray, void 0, void 0);
            if (symbol.flags & 32) {
              var classType = getDeclaredTypeOfClassOrInterface(symbol);
              var baseConstructorType = getBaseConstructorTypeOfClass(classType);
              if (baseConstructorType.flags & (524288 | 2097152 | 8650752)) {
                members = ts2.createSymbolTable(getNamedMembers(members));
                addInheritedMembers(members, getPropertiesOfType(baseConstructorType));
              } else if (baseConstructorType === anyType) {
                stringIndexInfo = createIndexInfo(anyType, false);
              }
            }
            var numberIndexInfo = symbol.flags & 384 && (getDeclaredTypeOfSymbol(symbol).flags & 32 || ts2.some(type.properties, function(prop) {
              return !!(getTypeOfSymbol(prop).flags & 296);
            })) ? enumNumberIndexInfo : void 0;
            setStructuredTypeMembers(type, members, ts2.emptyArray, ts2.emptyArray, stringIndexInfo, numberIndexInfo);
            if (symbol.flags & (16 | 8192)) {
              type.callSignatures = getSignaturesOfSymbol(symbol);
            }
            if (symbol.flags & 32) {
              var classType_1 = getDeclaredTypeOfClassOrInterface(symbol);
              var constructSignatures = symbol.members ? getSignaturesOfSymbol(symbol.members.get("__constructor")) : ts2.emptyArray;
              if (symbol.flags & 16) {
                constructSignatures = ts2.addRange(constructSignatures.slice(), ts2.mapDefined(type.callSignatures, function(sig) {
                  return isJSConstructor(sig.declaration) ? createSignature(sig.declaration, sig.typeParameters, sig.thisParameter, sig.parameters, classType_1, void 0, sig.minArgumentCount, sig.flags & 3) : void 0;
                }));
              }
              if (!constructSignatures.length) {
                constructSignatures = getDefaultConstructSignatures(classType_1);
              }
              type.constructSignatures = constructSignatures;
            }
          }
        }
        function resolveReverseMappedTypeMembers(type) {
          var indexInfo = getIndexInfoOfType(type.source, 0);
          var modifiers = getMappedTypeModifiers(type.mappedType);
          var readonlyMask = modifiers & 1 ? false : true;
          var optionalMask = modifiers & 4 ? 0 : 16777216;
          var stringIndexInfo = indexInfo && createIndexInfo(inferReverseMappedType(indexInfo.type, type.mappedType, type.constraintType), readonlyMask && indexInfo.isReadonly);
          var members = ts2.createSymbolTable();
          for (var _i = 0, _a = getPropertiesOfType(type.source); _i < _a.length; _i++) {
            var prop = _a[_i];
            var checkFlags = 8192 | (readonlyMask && isReadonlySymbol(prop) ? 8 : 0);
            var inferredProp = createSymbol(4 | prop.flags & optionalMask, prop.escapedName, checkFlags);
            inferredProp.declarations = prop.declarations;
            inferredProp.nameType = getSymbolLinks(prop).nameType;
            inferredProp.propertyType = getTypeOfSymbol(prop);
            inferredProp.mappedType = type.mappedType;
            inferredProp.constraintType = type.constraintType;
            members.set(prop.escapedName, inferredProp);
          }
          setStructuredTypeMembers(type, members, ts2.emptyArray, ts2.emptyArray, stringIndexInfo, void 0);
        }
        function getLowerBoundOfKeyType(type) {
          if (type.flags & (1 | 131068)) {
            return type;
          }
          if (type.flags & 4194304) {
            return getIndexType(getApparentType(type.type));
          }
          if (type.flags & 16777216) {
            if (type.root.isDistributive) {
              var checkType = type.checkType;
              var constraint = getLowerBoundOfKeyType(checkType);
              if (constraint !== checkType) {
                return getConditionalTypeInstantiation(type, prependTypeMapping(type.root.checkType, constraint, type.mapper));
              }
            }
            return type;
          }
          if (type.flags & 1048576) {
            return getUnionType(ts2.sameMap(type.types, getLowerBoundOfKeyType));
          }
          if (type.flags & 2097152) {
            return getIntersectionType(ts2.sameMap(type.types, getLowerBoundOfKeyType));
          }
          return neverType;
        }
        function resolveMappedTypeMembers(type) {
          var members = ts2.createSymbolTable();
          var stringIndexInfo;
          var numberIndexInfo;
          setStructuredTypeMembers(type, emptySymbols, ts2.emptyArray, ts2.emptyArray, void 0, void 0);
          var typeParameter = getTypeParameterFromMappedType(type);
          var constraintType = getConstraintTypeFromMappedType(type);
          var templateType = getTemplateTypeFromMappedType(type.target || type);
          var modifiersType = getApparentType(getModifiersTypeFromMappedType(type));
          var templateModifiers = getMappedTypeModifiers(type);
          var include = keyofStringsOnly ? 128 : 8576;
          if (isMappedTypeWithKeyofConstraintDeclaration(type)) {
            for (var _i = 0, _a = getPropertiesOfType(modifiersType); _i < _a.length; _i++) {
              var prop = _a[_i];
              addMemberForKeyType(getLiteralTypeFromProperty(prop, include));
            }
            if (modifiersType.flags & 1 || getIndexInfoOfType(modifiersType, 0)) {
              addMemberForKeyType(stringType);
            }
            if (!keyofStringsOnly && getIndexInfoOfType(modifiersType, 1)) {
              addMemberForKeyType(numberType);
            }
          } else {
            forEachType(getLowerBoundOfKeyType(constraintType), addMemberForKeyType);
          }
          setStructuredTypeMembers(type, members, ts2.emptyArray, ts2.emptyArray, stringIndexInfo, numberIndexInfo);
          function addMemberForKeyType(t) {
            var templateMapper = appendTypeMapping(type.mapper, typeParameter, t);
            if (isTypeUsableAsPropertyName(t)) {
              var propName = getPropertyNameFromType(t);
              var modifiersProp = getPropertyOfType(modifiersType, propName);
              var isOptional = !!(templateModifiers & 4 || !(templateModifiers & 8) && modifiersProp && modifiersProp.flags & 16777216);
              var isReadonly = !!(templateModifiers & 1 || !(templateModifiers & 2) && modifiersProp && isReadonlySymbol(modifiersProp));
              var stripOptional = strictNullChecks && !isOptional && modifiersProp && modifiersProp.flags & 16777216;
              var prop2 = createSymbol(4 | (isOptional ? 16777216 : 0), propName, 262144 | (isReadonly ? 8 : 0) | (stripOptional ? 524288 : 0));
              prop2.mappedType = type;
              prop2.mapper = templateMapper;
              if (modifiersProp) {
                prop2.syntheticOrigin = modifiersProp;
                prop2.declarations = modifiersProp.declarations;
              }
              prop2.nameType = t;
              members.set(propName, prop2);
            } else if (t.flags & (1 | 4 | 8 | 32)) {
              var propType = instantiateType(templateType, templateMapper);
              if (t.flags & (1 | 4)) {
                stringIndexInfo = createIndexInfo(propType, !!(templateModifiers & 1));
              } else {
                numberIndexInfo = createIndexInfo(numberIndexInfo ? getUnionType([numberIndexInfo.type, propType]) : propType, !!(templateModifiers & 1));
              }
            }
          }
        }
        function getTypeOfMappedSymbol(symbol) {
          if (!symbol.type) {
            if (!pushTypeResolution(symbol, 0)) {
              return errorType;
            }
            var templateType = getTemplateTypeFromMappedType(symbol.mappedType.target || symbol.mappedType);
            var propType = instantiateType(templateType, symbol.mapper);
            var type = strictNullChecks && symbol.flags & 16777216 && !maybeTypeOfKind(propType, 32768 | 16384) ? getOptionalType(propType) : symbol.checkFlags & 524288 ? getTypeWithFacts(propType, 524288) : propType;
            if (!popTypeResolution()) {
              error(currentNode, ts2.Diagnostics.Type_of_property_0_circularly_references_itself_in_mapped_type_1, symbolToString(symbol), typeToString(symbol.mappedType));
              type = errorType;
            }
            symbol.type = type;
            symbol.mapper = void 0;
          }
          return symbol.type;
        }
        function getTypeParameterFromMappedType(type) {
          return type.typeParameter || (type.typeParameter = getDeclaredTypeOfTypeParameter(getSymbolOfNode(type.declaration.typeParameter)));
        }
        function getConstraintTypeFromMappedType(type) {
          return type.constraintType || (type.constraintType = getConstraintOfTypeParameter(getTypeParameterFromMappedType(type)) || errorType);
        }
        function getTemplateTypeFromMappedType(type) {
          return type.templateType || (type.templateType = type.declaration.type ? instantiateType(addOptionality(getTypeFromTypeNode(type.declaration.type), !!(getMappedTypeModifiers(type) & 4)), type.mapper) : errorType);
        }
        function getConstraintDeclarationForMappedType(type) {
          return ts2.getEffectiveConstraintOfTypeParameter(type.declaration.typeParameter);
        }
        function isMappedTypeWithKeyofConstraintDeclaration(type) {
          var constraintDeclaration = getConstraintDeclarationForMappedType(type);
          return constraintDeclaration.kind === 184 && constraintDeclaration.operator === 134;
        }
        function getModifiersTypeFromMappedType(type) {
          if (!type.modifiersType) {
            if (isMappedTypeWithKeyofConstraintDeclaration(type)) {
              type.modifiersType = instantiateType(getTypeFromTypeNode(getConstraintDeclarationForMappedType(type).type), type.mapper);
            } else {
              var declaredType = getTypeFromMappedTypeNode(type.declaration);
              var constraint = getConstraintTypeFromMappedType(declaredType);
              var extendedConstraint = constraint && constraint.flags & 262144 ? getConstraintOfTypeParameter(constraint) : constraint;
              type.modifiersType = extendedConstraint && extendedConstraint.flags & 4194304 ? instantiateType(extendedConstraint.type, type.mapper) : unknownType;
            }
          }
          return type.modifiersType;
        }
        function getMappedTypeModifiers(type) {
          var declaration = type.declaration;
          return (declaration.readonlyToken ? declaration.readonlyToken.kind === 40 ? 2 : 1 : 0) | (declaration.questionToken ? declaration.questionToken.kind === 40 ? 8 : 4 : 0);
        }
        function getMappedTypeOptionality(type) {
          var modifiers = getMappedTypeModifiers(type);
          return modifiers & 8 ? -1 : modifiers & 4 ? 1 : 0;
        }
        function getCombinedMappedTypeOptionality(type) {
          var optionality = getMappedTypeOptionality(type);
          var modifiersType = getModifiersTypeFromMappedType(type);
          return optionality || (isGenericMappedType(modifiersType) ? getMappedTypeOptionality(modifiersType) : 0);
        }
        function isPartialMappedType(type) {
          return !!(ts2.getObjectFlags(type) & 32 && getMappedTypeModifiers(type) & 4);
        }
        function isGenericMappedType(type) {
          return !!(ts2.getObjectFlags(type) & 32) && isGenericIndexType(getConstraintTypeFromMappedType(type));
        }
        function resolveStructuredTypeMembers(type) {
          if (!type.members) {
            if (type.flags & 524288) {
              if (type.objectFlags & 4) {
                resolveTypeReferenceMembers(type);
              } else if (type.objectFlags & 3) {
                resolveClassOrInterfaceMembers(type);
              } else if (type.objectFlags & 2048) {
                resolveReverseMappedTypeMembers(type);
              } else if (type.objectFlags & 16) {
                resolveAnonymousTypeMembers(type);
              } else if (type.objectFlags & 32) {
                resolveMappedTypeMembers(type);
              }
            } else if (type.flags & 1048576) {
              resolveUnionTypeMembers(type);
            } else if (type.flags & 2097152) {
              resolveIntersectionTypeMembers(type);
            }
          }
          return type;
        }
        function getPropertiesOfObjectType(type) {
          if (type.flags & 524288) {
            return resolveStructuredTypeMembers(type).properties;
          }
          return ts2.emptyArray;
        }
        function getPropertyOfObjectType(type, name) {
          if (type.flags & 524288) {
            var resolved = resolveStructuredTypeMembers(type);
            var symbol = resolved.members.get(name);
            if (symbol && symbolIsValue(symbol)) {
              return symbol;
            }
          }
        }
        function getPropertiesOfUnionOrIntersectionType(type) {
          if (!type.resolvedProperties) {
            var members = ts2.createSymbolTable();
            for (var _i = 0, _a = type.types; _i < _a.length; _i++) {
              var current = _a[_i];
              for (var _b = 0, _c = getPropertiesOfType(current); _b < _c.length; _b++) {
                var prop = _c[_b];
                if (!members.has(prop.escapedName)) {
                  var combinedProp = getPropertyOfUnionOrIntersectionType(type, prop.escapedName);
                  if (combinedProp) {
                    members.set(prop.escapedName, combinedProp);
                  }
                }
              }
              if (type.flags & 1048576 && !getIndexInfoOfType(current, 0) && !getIndexInfoOfType(current, 1)) {
                break;
              }
            }
            type.resolvedProperties = getNamedMembers(members);
          }
          return type.resolvedProperties;
        }
        function getPropertiesOfType(type) {
          type = getReducedApparentType(type);
          return type.flags & 3145728 ? getPropertiesOfUnionOrIntersectionType(type) : getPropertiesOfObjectType(type);
        }
        function isTypeInvalidDueToUnionDiscriminant(contextualType, obj) {
          var list = obj.properties;
          return list.some(function(property) {
            var nameType = property.name && getLiteralTypeFromPropertyName(property.name);
            var name = nameType && isTypeUsableAsPropertyName(nameType) ? getPropertyNameFromType(nameType) : void 0;
            var expected = name === void 0 ? void 0 : getTypeOfPropertyOfType(contextualType, name);
            return !!expected && isLiteralType(expected) && !isTypeAssignableTo(getTypeOfNode(property), expected);
          });
        }
        function getAllPossiblePropertiesOfTypes(types) {
          var unionType = getUnionType(types);
          if (!(unionType.flags & 1048576)) {
            return getAugmentedPropertiesOfType(unionType);
          }
          var props = ts2.createSymbolTable();
          for (var _i = 0, types_4 = types; _i < types_4.length; _i++) {
            var memberType = types_4[_i];
            for (var _a = 0, _b = getAugmentedPropertiesOfType(memberType); _a < _b.length; _a++) {
              var escapedName = _b[_a].escapedName;
              if (!props.has(escapedName)) {
                var prop = createUnionOrIntersectionProperty(unionType, escapedName);
                if (prop)
                  props.set(escapedName, prop);
              }
            }
          }
          return ts2.arrayFrom(props.values());
        }
        function getConstraintOfType(type) {
          return type.flags & 262144 ? getConstraintOfTypeParameter(type) : type.flags & 8388608 ? getConstraintOfIndexedAccess(type) : type.flags & 16777216 ? getConstraintOfConditionalType(type) : getBaseConstraintOfType(type);
        }
        function getConstraintOfTypeParameter(typeParameter) {
          return hasNonCircularBaseConstraint(typeParameter) ? getConstraintFromTypeParameter(typeParameter) : void 0;
        }
        function getConstraintOfIndexedAccess(type) {
          return hasNonCircularBaseConstraint(type) ? getConstraintFromIndexedAccess(type) : void 0;
        }
        function getSimplifiedTypeOrConstraint(type) {
          var simplified = getSimplifiedType(type, false);
          return simplified !== type ? simplified : getConstraintOfType(type);
        }
        function getConstraintFromIndexedAccess(type) {
          var indexConstraint = getSimplifiedTypeOrConstraint(type.indexType);
          if (indexConstraint && indexConstraint !== type.indexType) {
            var indexedAccess = getIndexedAccessTypeOrUndefined(type.objectType, indexConstraint);
            if (indexedAccess) {
              return indexedAccess;
            }
          }
          var objectConstraint = getSimplifiedTypeOrConstraint(type.objectType);
          if (objectConstraint && objectConstraint !== type.objectType) {
            return getIndexedAccessTypeOrUndefined(objectConstraint, type.indexType);
          }
          return void 0;
        }
        function getDefaultConstraintOfConditionalType(type) {
          if (!type.resolvedDefaultConstraint) {
            var trueConstraint = getInferredTrueTypeFromConditionalType(type);
            var falseConstraint = getFalseTypeFromConditionalType(type);
            type.resolvedDefaultConstraint = isTypeAny(trueConstraint) ? falseConstraint : isTypeAny(falseConstraint) ? trueConstraint : getUnionType([trueConstraint, falseConstraint]);
          }
          return type.resolvedDefaultConstraint;
        }
        function getConstraintOfDistributiveConditionalType(type) {
          if (type.root.isDistributive && type.restrictiveInstantiation !== type) {
            var simplified = getSimplifiedType(type.checkType, false);
            var constraint = simplified === type.checkType ? getConstraintOfType(simplified) : simplified;
            if (constraint && constraint !== type.checkType) {
              var instantiated = getConditionalTypeInstantiation(type, prependTypeMapping(type.root.checkType, constraint, type.mapper));
              if (!(instantiated.flags & 131072)) {
                return instantiated;
              }
            }
          }
          return void 0;
        }
        function getConstraintFromConditionalType(type) {
          return getConstraintOfDistributiveConditionalType(type) || getDefaultConstraintOfConditionalType(type);
        }
        function getConstraintOfConditionalType(type) {
          return hasNonCircularBaseConstraint(type) ? getConstraintFromConditionalType(type) : void 0;
        }
        function getEffectiveConstraintOfIntersection(types, targetIsUnion) {
          var constraints;
          var hasDisjointDomainType = false;
          for (var _i = 0, types_5 = types; _i < types_5.length; _i++) {
            var t = types_5[_i];
            if (t.flags & 63176704) {
              var constraint = getConstraintOfType(t);
              while (constraint && constraint.flags & (262144 | 4194304 | 16777216)) {
                constraint = getConstraintOfType(constraint);
              }
              if (constraint) {
                constraints = ts2.append(constraints, constraint);
                if (targetIsUnion) {
                  constraints = ts2.append(constraints, t);
                }
              }
            } else if (t.flags & 67238908) {
              hasDisjointDomainType = true;
            }
          }
          if (constraints && (targetIsUnion || hasDisjointDomainType)) {
            if (hasDisjointDomainType) {
              for (var _a = 0, types_6 = types; _a < types_6.length; _a++) {
                var t = types_6[_a];
                if (t.flags & 67238908) {
                  constraints = ts2.append(constraints, t);
                }
              }
            }
            return getIntersectionType(constraints);
          }
          return void 0;
        }
        function getBaseConstraintOfType(type) {
          if (type.flags & (58982400 | 3145728)) {
            var constraint = getResolvedBaseConstraint(type);
            return constraint !== noConstraintType && constraint !== circularConstraintType ? constraint : void 0;
          }
          return type.flags & 4194304 ? keyofConstraintType : void 0;
        }
        function getBaseConstraintOrType(type) {
          return getBaseConstraintOfType(type) || type;
        }
        function hasNonCircularBaseConstraint(type) {
          return getResolvedBaseConstraint(type) !== circularConstraintType;
        }
        function getResolvedBaseConstraint(type) {
          var nonTerminating = false;
          return type.resolvedBaseConstraint || (type.resolvedBaseConstraint = getTypeWithThisArgument(getImmediateBaseConstraint(type), type));
          function getImmediateBaseConstraint(t) {
            if (!t.immediateBaseConstraint) {
              if (!pushTypeResolution(t, 4)) {
                return circularConstraintType;
              }
              if (constraintDepth >= 50) {
                error(currentNode, ts2.Diagnostics.Type_instantiation_is_excessively_deep_and_possibly_infinite);
                nonTerminating = true;
                return t.immediateBaseConstraint = noConstraintType;
              }
              constraintDepth++;
              var result = computeBaseConstraint(getSimplifiedType(t, false));
              constraintDepth--;
              if (!popTypeResolution()) {
                if (t.flags & 262144) {
                  var errorNode = getConstraintDeclaration(t);
                  if (errorNode) {
                    var diagnostic = error(errorNode, ts2.Diagnostics.Type_parameter_0_has_a_circular_constraint, typeToString(t));
                    if (currentNode && !ts2.isNodeDescendantOf(errorNode, currentNode) && !ts2.isNodeDescendantOf(currentNode, errorNode)) {
                      ts2.addRelatedInfo(diagnostic, ts2.createDiagnosticForNode(currentNode, ts2.Diagnostics.Circularity_originates_in_type_at_this_location));
                    }
                  }
                }
                result = circularConstraintType;
              }
              if (nonTerminating) {
                result = circularConstraintType;
              }
              t.immediateBaseConstraint = result || noConstraintType;
            }
            return t.immediateBaseConstraint;
          }
          function getBaseConstraint(t) {
            var c = getImmediateBaseConstraint(t);
            return c !== noConstraintType && c !== circularConstraintType ? c : void 0;
          }
          function computeBaseConstraint(t) {
            if (t.flags & 262144) {
              var constraint = getConstraintFromTypeParameter(t);
              return t.isThisType || !constraint ? constraint : getBaseConstraint(constraint);
            }
            if (t.flags & 3145728) {
              var types = t.types;
              var baseTypes = [];
              for (var _i = 0, types_7 = types; _i < types_7.length; _i++) {
                var type_2 = types_7[_i];
                var baseType = getBaseConstraint(type_2);
                if (baseType) {
                  baseTypes.push(baseType);
                }
              }
              return t.flags & 1048576 && baseTypes.length === types.length ? getUnionType(baseTypes) : t.flags & 2097152 && baseTypes.length ? getIntersectionType(baseTypes) : void 0;
            }
            if (t.flags & 4194304) {
              return keyofConstraintType;
            }
            if (t.flags & 8388608) {
              var baseObjectType = getBaseConstraint(t.objectType);
              var baseIndexType = getBaseConstraint(t.indexType);
              var baseIndexedAccess = baseObjectType && baseIndexType && getIndexedAccessTypeOrUndefined(baseObjectType, baseIndexType);
              return baseIndexedAccess && getBaseConstraint(baseIndexedAccess);
            }
            if (t.flags & 16777216) {
              var constraint = getConstraintFromConditionalType(t);
              constraintDepth++;
              var result = constraint && getBaseConstraint(constraint);
              constraintDepth--;
              return result;
            }
            if (t.flags & 33554432) {
              return getBaseConstraint(t.substitute);
            }
            return t;
          }
        }
        function getApparentTypeOfIntersectionType(type) {
          return type.resolvedApparentType || (type.resolvedApparentType = getTypeWithThisArgument(type, type, true));
        }
        function getResolvedTypeParameterDefault(typeParameter) {
          if (!typeParameter.default) {
            if (typeParameter.target) {
              var targetDefault = getResolvedTypeParameterDefault(typeParameter.target);
              typeParameter.default = targetDefault ? instantiateType(targetDefault, typeParameter.mapper) : noConstraintType;
            } else {
              typeParameter.default = resolvingDefaultType;
              var defaultDeclaration = typeParameter.symbol && ts2.forEach(typeParameter.symbol.declarations, function(decl) {
                return ts2.isTypeParameterDeclaration(decl) && decl.default;
              });
              var defaultType = defaultDeclaration ? getTypeFromTypeNode(defaultDeclaration) : noConstraintType;
              if (typeParameter.default === resolvingDefaultType) {
                typeParameter.default = defaultType;
              }
            }
          } else if (typeParameter.default === resolvingDefaultType) {
            typeParameter.default = circularConstraintType;
          }
          return typeParameter.default;
        }
        function getDefaultFromTypeParameter(typeParameter) {
          var defaultType = getResolvedTypeParameterDefault(typeParameter);
          return defaultType !== noConstraintType && defaultType !== circularConstraintType ? defaultType : void 0;
        }
        function hasNonCircularTypeParameterDefault(typeParameter) {
          return getResolvedTypeParameterDefault(typeParameter) !== circularConstraintType;
        }
        function hasTypeParameterDefault(typeParameter) {
          return !!(typeParameter.symbol && ts2.forEach(typeParameter.symbol.declarations, function(decl) {
            return ts2.isTypeParameterDeclaration(decl) && decl.default;
          }));
        }
        function getApparentTypeOfMappedType(type) {
          return type.resolvedApparentType || (type.resolvedApparentType = getResolvedApparentTypeOfMappedType(type));
        }
        function getResolvedApparentTypeOfMappedType(type) {
          var typeVariable = getHomomorphicTypeVariable(type);
          if (typeVariable) {
            var constraint = getConstraintOfTypeParameter(typeVariable);
            if (constraint && (isArrayType(constraint) || isTupleType(constraint))) {
              return instantiateType(type, prependTypeMapping(typeVariable, constraint, type.mapper));
            }
          }
          return type;
        }
        function getApparentType(type) {
          var t = type.flags & 63176704 ? getBaseConstraintOfType(type) || unknownType : type;
          return ts2.getObjectFlags(t) & 32 ? getApparentTypeOfMappedType(t) : t.flags & 2097152 ? getApparentTypeOfIntersectionType(t) : t.flags & 132 ? globalStringType : t.flags & 296 ? globalNumberType : t.flags & 2112 ? getGlobalBigIntType(languageVersion >= 7) : t.flags & 528 ? globalBooleanType : t.flags & 12288 ? getGlobalESSymbolType(languageVersion >= 2) : t.flags & 67108864 ? emptyObjectType : t.flags & 4194304 ? keyofConstraintType : t.flags & 2 && !strictNullChecks ? emptyObjectType : t;
        }
        function getReducedApparentType(type) {
          return getReducedType(getApparentType(getReducedType(type)));
        }
        function createUnionOrIntersectionProperty(containingType, name) {
          var singleProp;
          var propSet;
          var indexTypes;
          var isUnion = containingType.flags & 1048576;
          var optionalFlag = isUnion ? 0 : 16777216;
          var syntheticFlag = 4;
          var checkFlags = 0;
          for (var _i = 0, _a = containingType.types; _i < _a.length; _i++) {
            var current = _a[_i];
            var type = getApparentType(current);
            if (!(type === errorType || type.flags & 131072)) {
              var prop = getPropertyOfType(type, name);
              var modifiers = prop ? ts2.getDeclarationModifierFlagsFromSymbol(prop) : 0;
              if (prop) {
                if (isUnion) {
                  optionalFlag |= prop.flags & 16777216;
                } else {
                  optionalFlag &= prop.flags;
                }
                if (!singleProp) {
                  singleProp = prop;
                } else if (prop !== singleProp) {
                  if (!propSet) {
                    propSet = ts2.createMap();
                    propSet.set("" + getSymbolId(singleProp), singleProp);
                  }
                  var id = "" + getSymbolId(prop);
                  if (!propSet.has(id)) {
                    propSet.set(id, prop);
                  }
                }
                checkFlags |= (isReadonlySymbol(prop) ? 8 : 0) | (!(modifiers & 24) ? 256 : 0) | (modifiers & 16 ? 512 : 0) | (modifiers & 8 ? 1024 : 0) | (modifiers & 32 ? 2048 : 0);
                if (!isPrototypeProperty(prop)) {
                  syntheticFlag = 2;
                }
              } else if (isUnion) {
                var indexInfo = !isLateBoundName(name) && (isNumericLiteralName(name) && getIndexInfoOfType(type, 1) || getIndexInfoOfType(type, 0));
                if (indexInfo) {
                  checkFlags |= 32 | (indexInfo.isReadonly ? 8 : 0);
                  indexTypes = ts2.append(indexTypes, isTupleType(type) ? getRestTypeOfTupleType(type) || undefinedType : indexInfo.type);
                } else if (isObjectLiteralType(type)) {
                  checkFlags |= 32;
                  indexTypes = ts2.append(indexTypes, undefinedType);
                } else {
                  checkFlags |= 16;
                }
              }
            }
          }
          if (!singleProp || isUnion && (propSet || checkFlags & 48) && checkFlags & (1024 | 512)) {
            return void 0;
          }
          if (!propSet && !(checkFlags & 16) && !indexTypes) {
            return singleProp;
          }
          var props = propSet ? ts2.arrayFrom(propSet.values()) : [singleProp];
          var declarations;
          var firstType;
          var nameType;
          var propTypes = [];
          var firstValueDeclaration;
          var hasNonUniformValueDeclaration = false;
          for (var _b = 0, props_1 = props; _b < props_1.length; _b++) {
            var prop = props_1[_b];
            if (!firstValueDeclaration) {
              firstValueDeclaration = prop.valueDeclaration;
            } else if (prop.valueDeclaration && prop.valueDeclaration !== firstValueDeclaration) {
              hasNonUniformValueDeclaration = true;
            }
            declarations = ts2.addRange(declarations, prop.declarations);
            var type = getTypeOfSymbol(prop);
            if (!firstType) {
              firstType = type;
              nameType = getSymbolLinks(prop).nameType;
            } else if (type !== firstType) {
              checkFlags |= 64;
            }
            if (isLiteralType(type)) {
              checkFlags |= 128;
            }
            if (type.flags & 131072) {
              checkFlags |= 131072;
            }
            propTypes.push(type);
          }
          ts2.addRange(propTypes, indexTypes);
          var result = createSymbol(4 | optionalFlag, name, syntheticFlag | checkFlags);
          result.containingType = containingType;
          if (!hasNonUniformValueDeclaration && firstValueDeclaration) {
            result.valueDeclaration = firstValueDeclaration;
            if (firstValueDeclaration.symbol.parent) {
              result.parent = firstValueDeclaration.symbol.parent;
            }
          }
          result.declarations = declarations;
          result.nameType = nameType;
          if (propTypes.length > 2) {
            result.checkFlags |= 65536;
            result.deferralParent = containingType;
            result.deferralConstituents = propTypes;
          } else {
            result.type = isUnion ? getUnionType(propTypes) : getIntersectionType(propTypes);
          }
          return result;
        }
        function getUnionOrIntersectionProperty(type, name) {
          var properties = type.propertyCache || (type.propertyCache = ts2.createSymbolTable());
          var property = properties.get(name);
          if (!property) {
            property = createUnionOrIntersectionProperty(type, name);
            if (property) {
              properties.set(name, property);
            }
          }
          return property;
        }
        function getPropertyOfUnionOrIntersectionType(type, name) {
          var property = getUnionOrIntersectionProperty(type, name);
          return property && !(ts2.getCheckFlags(property) & 16) ? property : void 0;
        }
        function getReducedType(type) {
          if (type.flags & 1048576 && type.objectFlags & 268435456) {
            return type.resolvedReducedType || (type.resolvedReducedType = getReducedUnionType(type));
          } else if (type.flags & 2097152) {
            if (!(type.objectFlags & 268435456)) {
              type.objectFlags |= 268435456 | (ts2.some(getPropertiesOfUnionOrIntersectionType(type), isNeverReducedProperty) ? 536870912 : 0);
            }
            return type.objectFlags & 536870912 ? neverType : type;
          }
          return type;
        }
        function getReducedUnionType(unionType) {
          var reducedTypes = ts2.sameMap(unionType.types, getReducedType);
          if (reducedTypes === unionType.types) {
            return unionType;
          }
          var reduced = getUnionType(reducedTypes);
          if (reduced.flags & 1048576) {
            reduced.resolvedReducedType = reduced;
          }
          return reduced;
        }
        function isNeverReducedProperty(prop) {
          return isDiscriminantWithNeverType(prop) || isConflictingPrivateProperty(prop);
        }
        function isDiscriminantWithNeverType(prop) {
          return !(prop.flags & 16777216) && (ts2.getCheckFlags(prop) & (192 | 131072)) === 192 && !!(getTypeOfSymbol(prop).flags & 131072);
        }
        function isConflictingPrivateProperty(prop) {
          return !prop.valueDeclaration && !!(ts2.getCheckFlags(prop) & 1024);
        }
        function elaborateNeverIntersection(errorInfo, type) {
          if (ts2.getObjectFlags(type) & 536870912) {
            var neverProp = ts2.find(getPropertiesOfUnionOrIntersectionType(type), isDiscriminantWithNeverType);
            if (neverProp) {
              return ts2.chainDiagnosticMessages(errorInfo, ts2.Diagnostics.The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituents, typeToString(type, void 0, 536870912), symbolToString(neverProp));
            }
            var privateProp = ts2.find(getPropertiesOfUnionOrIntersectionType(type), isConflictingPrivateProperty);
            if (privateProp) {
              return ts2.chainDiagnosticMessages(errorInfo, ts2.Diagnostics.The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_private_in_some, typeToString(type, void 0, 536870912), symbolToString(privateProp));
            }
          }
          return errorInfo;
        }
        function getPropertyOfType(type, name) {
          type = getReducedApparentType(type);
          if (type.flags & 524288) {
            var resolved = resolveStructuredTypeMembers(type);
            var symbol = resolved.members.get(name);
            if (symbol && symbolIsValue(symbol)) {
              return symbol;
            }
            var functionType = resolved === anyFunctionType ? globalFunctionType : resolved.callSignatures.length ? globalCallableFunctionType : resolved.constructSignatures.length ? globalNewableFunctionType : void 0;
            if (functionType) {
              var symbol_1 = getPropertyOfObjectType(functionType, name);
              if (symbol_1) {
                return symbol_1;
              }
            }
            return getPropertyOfObjectType(globalObjectType, name);
          }
          if (type.flags & 3145728) {
            return getPropertyOfUnionOrIntersectionType(type, name);
          }
          return void 0;
        }
        function getSignaturesOfStructuredType(type, kind) {
          if (type.flags & 3670016) {
            var resolved = resolveStructuredTypeMembers(type);
            return kind === 0 ? resolved.callSignatures : resolved.constructSignatures;
          }
          return ts2.emptyArray;
        }
        function getSignaturesOfType(type, kind) {
          return getSignaturesOfStructuredType(getReducedApparentType(type), kind);
        }
        function getIndexInfoOfStructuredType(type, kind) {
          if (type.flags & 3670016) {
            var resolved = resolveStructuredTypeMembers(type);
            return kind === 0 ? resolved.stringIndexInfo : resolved.numberIndexInfo;
          }
        }
        function getIndexTypeOfStructuredType(type, kind) {
          var info = getIndexInfoOfStructuredType(type, kind);
          return info && info.type;
        }
        function getIndexInfoOfType(type, kind) {
          return getIndexInfoOfStructuredType(getReducedApparentType(type), kind);
        }
        function getIndexTypeOfType(type, kind) {
          return getIndexTypeOfStructuredType(getReducedApparentType(type), kind);
        }
        function getImplicitIndexTypeOfType(type, kind) {
          if (isObjectTypeWithInferableIndex(type)) {
            var propTypes = [];
            for (var _i = 0, _a = getPropertiesOfType(type); _i < _a.length; _i++) {
              var prop = _a[_i];
              if (kind === 0 || isNumericLiteralName(prop.escapedName)) {
                propTypes.push(getTypeOfSymbol(prop));
              }
            }
            if (kind === 0) {
              ts2.append(propTypes, getIndexTypeOfType(type, 1));
            }
            if (propTypes.length) {
              return getUnionType(propTypes);
            }
          }
          return void 0;
        }
        function getTypeParametersFromDeclaration(declaration) {
          var result;
          for (var _i = 0, _a = ts2.getEffectiveTypeParameterDeclarations(declaration); _i < _a.length; _i++) {
            var node = _a[_i];
            result = ts2.appendIfUnique(result, getDeclaredTypeOfTypeParameter(node.symbol));
          }
          return result;
        }
        function symbolsToArray(symbols) {
          var result = [];
          symbols.forEach(function(symbol, id) {
            if (!isReservedMemberName(id)) {
              result.push(symbol);
            }
          });
          return result;
        }
        function isJSDocOptionalParameter(node) {
          return ts2.isInJSFile(node) && (node.type && node.type.kind === 299 || ts2.getJSDocParameterTags(node).some(function(_a) {
            var isBracketed = _a.isBracketed, typeExpression = _a.typeExpression;
            return isBracketed || !!typeExpression && typeExpression.type.kind === 299;
          }));
        }
        function tryFindAmbientModule(moduleName, withAugmentations) {
          if (ts2.isExternalModuleNameRelative(moduleName)) {
            return void 0;
          }
          var symbol = getSymbol(globals, '"' + moduleName + '"', 512);
          return symbol && withAugmentations ? getMergedSymbol(symbol) : symbol;
        }
        function isOptionalParameter(node) {
          if (ts2.hasQuestionToken(node) || isOptionalJSDocParameterTag(node) || isJSDocOptionalParameter(node)) {
            return true;
          }
          if (node.initializer) {
            var signature = getSignatureFromDeclaration(node.parent);
            var parameterIndex = node.parent.parameters.indexOf(node);
            ts2.Debug.assert(parameterIndex >= 0);
            return parameterIndex >= getMinArgumentCount(signature, true);
          }
          var iife = ts2.getImmediatelyInvokedFunctionExpression(node.parent);
          if (iife) {
            return !node.type && !node.dotDotDotToken && node.parent.parameters.indexOf(node) >= iife.arguments.length;
          }
          return false;
        }
        function isOptionalJSDocParameterTag(node) {
          if (!ts2.isJSDocParameterTag(node)) {
            return false;
          }
          var isBracketed = node.isBracketed, typeExpression = node.typeExpression;
          return isBracketed || !!typeExpression && typeExpression.type.kind === 299;
        }
        function createTypePredicate(kind, parameterName, parameterIndex, type) {
          return { kind, parameterName, parameterIndex, type };
        }
        function getMinTypeArgumentCount(typeParameters) {
          var minTypeArgumentCount = 0;
          if (typeParameters) {
            for (var i = 0; i < typeParameters.length; i++) {
              if (!hasTypeParameterDefault(typeParameters[i])) {
                minTypeArgumentCount = i + 1;
              }
            }
          }
          return minTypeArgumentCount;
        }
        function fillMissingTypeArguments(typeArguments, typeParameters, minTypeArgumentCount, isJavaScriptImplicitAny) {
          var numTypeParameters = ts2.length(typeParameters);
          if (!numTypeParameters) {
            return [];
          }
          var numTypeArguments = ts2.length(typeArguments);
          if (isJavaScriptImplicitAny || numTypeArguments >= minTypeArgumentCount && numTypeArguments <= numTypeParameters) {
            var result = typeArguments ? typeArguments.slice() : [];
            for (var i = numTypeArguments; i < numTypeParameters; i++) {
              result[i] = errorType;
            }
            var baseDefaultType = getDefaultTypeArgumentType(isJavaScriptImplicitAny);
            for (var i = numTypeArguments; i < numTypeParameters; i++) {
              var defaultType = getDefaultFromTypeParameter(typeParameters[i]);
              if (isJavaScriptImplicitAny && defaultType && (isTypeIdenticalTo(defaultType, unknownType) || isTypeIdenticalTo(defaultType, emptyObjectType))) {
                defaultType = anyType;
              }
              result[i] = defaultType ? instantiateType(defaultType, createTypeMapper(typeParameters, result)) : baseDefaultType;
            }
            result.length = typeParameters.length;
            return result;
          }
          return typeArguments && typeArguments.slice();
        }
        function getSignatureFromDeclaration(declaration) {
          var links = getNodeLinks(declaration);
          if (!links.resolvedSignature) {
            var parameters = [];
            var flags = 0;
            var minArgumentCount = 0;
            var thisParameter = void 0;
            var hasThisParameter = false;
            var iife = ts2.getImmediatelyInvokedFunctionExpression(declaration);
            var isJSConstructSignature = ts2.isJSDocConstructSignature(declaration);
            var isUntypedSignatureInJSFile = !iife && ts2.isInJSFile(declaration) && ts2.isValueSignatureDeclaration(declaration) && !ts2.hasJSDocParameterTags(declaration) && !ts2.getJSDocType(declaration);
            if (isUntypedSignatureInJSFile) {
              flags |= 16;
            }
            for (var i = isJSConstructSignature ? 1 : 0; i < declaration.parameters.length; i++) {
              var param = declaration.parameters[i];
              var paramSymbol = param.symbol;
              var type = ts2.isJSDocParameterTag(param) ? param.typeExpression && param.typeExpression.type : param.type;
              if (paramSymbol && !!(paramSymbol.flags & 4) && !ts2.isBindingPattern(param.name)) {
                var resolvedSymbol = resolveName(param, paramSymbol.escapedName, 111551, void 0, void 0, false);
                paramSymbol = resolvedSymbol;
              }
              if (i === 0 && paramSymbol.escapedName === "this") {
                hasThisParameter = true;
                thisParameter = param.symbol;
              } else {
                parameters.push(paramSymbol);
              }
              if (type && type.kind === 187) {
                flags |= 2;
              }
              var isOptionalParameter_1 = isOptionalJSDocParameterTag(param) || param.initializer || param.questionToken || param.dotDotDotToken || iife && parameters.length > iife.arguments.length && !type || isJSDocOptionalParameter(param);
              if (!isOptionalParameter_1) {
                minArgumentCount = parameters.length;
              }
            }
            if ((declaration.kind === 163 || declaration.kind === 164) && !hasNonBindableDynamicName(declaration) && (!hasThisParameter || !thisParameter)) {
              var otherKind = declaration.kind === 163 ? 164 : 163;
              var other = ts2.getDeclarationOfKind(getSymbolOfNode(declaration), otherKind);
              if (other) {
                thisParameter = getAnnotatedAccessorThisParameter(other);
              }
            }
            var classType = declaration.kind === 162 ? getDeclaredTypeOfClassOrInterface(getMergedSymbol(declaration.parent.symbol)) : void 0;
            var typeParameters = classType ? classType.localTypeParameters : getTypeParametersFromDeclaration(declaration);
            if (ts2.hasRestParameter(declaration) || ts2.isInJSFile(declaration) && maybeAddJsSyntheticRestParameter(declaration, parameters)) {
              flags |= 1;
            }
            links.resolvedSignature = createSignature(declaration, typeParameters, thisParameter, parameters, void 0, void 0, minArgumentCount, flags);
          }
          return links.resolvedSignature;
        }
        function maybeAddJsSyntheticRestParameter(declaration, parameters) {
          if (ts2.isJSDocSignature(declaration) || !containsArgumentsReference(declaration)) {
            return false;
          }
          var lastParam = ts2.lastOrUndefined(declaration.parameters);
          var lastParamTags = lastParam ? ts2.getJSDocParameterTags(lastParam) : ts2.getJSDocTags(declaration).filter(ts2.isJSDocParameterTag);
          var lastParamVariadicType = ts2.firstDefined(lastParamTags, function(p) {
            return p.typeExpression && ts2.isJSDocVariadicType(p.typeExpression.type) ? p.typeExpression.type : void 0;
          });
          var syntheticArgsSymbol = createSymbol(3, "args", 32768);
          syntheticArgsSymbol.type = lastParamVariadicType ? createArrayType(getTypeFromTypeNode(lastParamVariadicType.type)) : anyArrayType;
          if (lastParamVariadicType) {
            parameters.pop();
          }
          parameters.push(syntheticArgsSymbol);
          return true;
        }
        function getSignatureOfTypeTag(node) {
          if (!(ts2.isInJSFile(node) && ts2.isFunctionLikeDeclaration(node)))
            return void 0;
          var typeTag = ts2.getJSDocTypeTag(node);
          var signature = typeTag && typeTag.typeExpression && getSingleCallSignature(getTypeFromTypeNode(typeTag.typeExpression));
          return signature && getErasedSignature(signature);
        }
        function getReturnTypeOfTypeTag(node) {
          var signature = getSignatureOfTypeTag(node);
          return signature && getReturnTypeOfSignature(signature);
        }
        function containsArgumentsReference(declaration) {
          var links = getNodeLinks(declaration);
          if (links.containsArgumentsReference === void 0) {
            if (links.flags & 8192) {
              links.containsArgumentsReference = true;
            } else {
              links.containsArgumentsReference = traverse(declaration.body);
            }
          }
          return links.containsArgumentsReference;
          function traverse(node) {
            if (!node)
              return false;
            switch (node.kind) {
              case 75:
                return node.escapedText === "arguments" && ts2.isExpressionNode(node);
              case 159:
              case 161:
              case 163:
              case 164:
                return node.name.kind === 154 && traverse(node.name);
              default:
                return !ts2.nodeStartsNewLexicalEnvironment(node) && !ts2.isPartOfTypeNode(node) && !!ts2.forEachChild(node, traverse);
            }
          }
        }
        function getSignaturesOfSymbol(symbol) {
          if (!symbol)
            return ts2.emptyArray;
          var result = [];
          for (var i = 0; i < symbol.declarations.length; i++) {
            var decl = symbol.declarations[i];
            if (!ts2.isFunctionLike(decl))
              continue;
            if (i > 0 && decl.body) {
              var previous = symbol.declarations[i - 1];
              if (decl.parent === previous.parent && decl.kind === previous.kind && decl.pos === previous.end) {
                continue;
              }
            }
            result.push(getSignatureFromDeclaration(decl));
          }
          return result;
        }
        function resolveExternalModuleTypeByLiteral(name) {
          var moduleSym = resolveExternalModuleName(name, name);
          if (moduleSym) {
            var resolvedModuleSymbol = resolveExternalModuleSymbol(moduleSym);
            if (resolvedModuleSymbol) {
              return getTypeOfSymbol(resolvedModuleSymbol);
            }
          }
          return anyType;
        }
        function getThisTypeOfSignature(signature) {
          if (signature.thisParameter) {
            return getTypeOfSymbol(signature.thisParameter);
          }
        }
        function getTypePredicateOfSignature(signature) {
          if (!signature.resolvedTypePredicate) {
            if (signature.target) {
              var targetTypePredicate = getTypePredicateOfSignature(signature.target);
              signature.resolvedTypePredicate = targetTypePredicate ? instantiateTypePredicate(targetTypePredicate, signature.mapper) : noTypePredicate;
            } else if (signature.unionSignatures) {
              signature.resolvedTypePredicate = getUnionTypePredicate(signature.unionSignatures) || noTypePredicate;
            } else {
              var type = signature.declaration && ts2.getEffectiveReturnTypeNode(signature.declaration);
              var jsdocPredicate = void 0;
              if (!type && ts2.isInJSFile(signature.declaration)) {
                var jsdocSignature = getSignatureOfTypeTag(signature.declaration);
                if (jsdocSignature && signature !== jsdocSignature) {
                  jsdocPredicate = getTypePredicateOfSignature(jsdocSignature);
                }
              }
              signature.resolvedTypePredicate = type && ts2.isTypePredicateNode(type) ? createTypePredicateFromTypePredicateNode(type, signature) : jsdocPredicate || noTypePredicate;
            }
            ts2.Debug.assert(!!signature.resolvedTypePredicate);
          }
          return signature.resolvedTypePredicate === noTypePredicate ? void 0 : signature.resolvedTypePredicate;
        }
        function createTypePredicateFromTypePredicateNode(node, signature) {
          var parameterName = node.parameterName;
          var type = node.type && getTypeFromTypeNode(node.type);
          return parameterName.kind === 183 ? createTypePredicate(node.assertsModifier ? 2 : 0, void 0, void 0, type) : createTypePredicate(node.assertsModifier ? 3 : 1, parameterName.escapedText, ts2.findIndex(signature.parameters, function(p) {
            return p.escapedName === parameterName.escapedText;
          }), type);
        }
        function getReturnTypeOfSignature(signature) {
          if (!signature.resolvedReturnType) {
            if (!pushTypeResolution(signature, 3)) {
              return errorType;
            }
            var type = signature.target ? instantiateType(getReturnTypeOfSignature(signature.target), signature.mapper) : signature.unionSignatures ? getUnionType(ts2.map(signature.unionSignatures, getReturnTypeOfSignature), 2) : getReturnTypeFromAnnotation(signature.declaration) || (ts2.nodeIsMissing(signature.declaration.body) ? anyType : getReturnTypeFromBody(signature.declaration));
            if (signature.flags & 4) {
              type = addOptionalTypeMarker(type);
            } else if (signature.flags & 8) {
              type = getOptionalType(type);
            }
            if (!popTypeResolution()) {
              if (signature.declaration) {
                var typeNode = ts2.getEffectiveReturnTypeNode(signature.declaration);
                if (typeNode) {
                  error(typeNode, ts2.Diagnostics.Return_type_annotation_circularly_references_itself);
                } else if (noImplicitAny) {
                  var declaration = signature.declaration;
                  var name = ts2.getNameOfDeclaration(declaration);
                  if (name) {
                    error(name, ts2.Diagnostics._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions, ts2.declarationNameToString(name));
                  } else {
                    error(declaration, ts2.Diagnostics.Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions);
                  }
                }
              }
              type = anyType;
            }
            signature.resolvedReturnType = type;
          }
          return signature.resolvedReturnType;
        }
        function getReturnTypeFromAnnotation(declaration) {
          if (declaration.kind === 162) {
            return getDeclaredTypeOfClassOrInterface(getMergedSymbol(declaration.parent.symbol));
          }
          if (ts2.isJSDocConstructSignature(declaration)) {
            return getTypeFromTypeNode(declaration.parameters[0].type);
          }
          var typeNode = ts2.getEffectiveReturnTypeNode(declaration);
          if (typeNode) {
            return getTypeFromTypeNode(typeNode);
          }
          if (declaration.kind === 163 && !hasNonBindableDynamicName(declaration)) {
            var jsDocType = ts2.isInJSFile(declaration) && getTypeForDeclarationFromJSDocComment(declaration);
            if (jsDocType) {
              return jsDocType;
            }
            var setter = ts2.getDeclarationOfKind(getSymbolOfNode(declaration), 164);
            var setterType = getAnnotatedAccessorType(setter);
            if (setterType) {
              return setterType;
            }
          }
          return getReturnTypeOfTypeTag(declaration);
        }
        function isResolvingReturnTypeOfSignature(signature) {
          return !signature.resolvedReturnType && findResolutionCycleStartIndex(signature, 3) >= 0;
        }
        function getRestTypeOfSignature(signature) {
          return tryGetRestTypeOfSignature(signature) || anyType;
        }
        function tryGetRestTypeOfSignature(signature) {
          if (signatureHasRestParameter(signature)) {
            var sigRestType = getTypeOfSymbol(signature.parameters[signature.parameters.length - 1]);
            var restType = isTupleType(sigRestType) ? getRestTypeOfTupleType(sigRestType) : sigRestType;
            return restType && getIndexTypeOfType(restType, 1);
          }
          return void 0;
        }
        function getSignatureInstantiation(signature, typeArguments, isJavascript, inferredTypeParameters) {
          var instantiatedSignature = getSignatureInstantiationWithoutFillingInTypeArguments(signature, fillMissingTypeArguments(typeArguments, signature.typeParameters, getMinTypeArgumentCount(signature.typeParameters), isJavascript));
          if (inferredTypeParameters) {
            var returnSignature = getSingleCallOrConstructSignature(getReturnTypeOfSignature(instantiatedSignature));
            if (returnSignature) {
              var newReturnSignature = cloneSignature(returnSignature);
              newReturnSignature.typeParameters = inferredTypeParameters;
              var newInstantiatedSignature = cloneSignature(instantiatedSignature);
              newInstantiatedSignature.resolvedReturnType = getOrCreateTypeFromSignature(newReturnSignature);
              return newInstantiatedSignature;
            }
          }
          return instantiatedSignature;
        }
        function getSignatureInstantiationWithoutFillingInTypeArguments(signature, typeArguments) {
          var instantiations = signature.instantiations || (signature.instantiations = ts2.createMap());
          var id = getTypeListId(typeArguments);
          var instantiation = instantiations.get(id);
          if (!instantiation) {
            instantiations.set(id, instantiation = createSignatureInstantiation(signature, typeArguments));
          }
          return instantiation;
        }
        function createSignatureInstantiation(signature, typeArguments) {
          return instantiateSignature(signature, createSignatureTypeMapper(signature, typeArguments), true);
        }
        function createSignatureTypeMapper(signature, typeArguments) {
          return createTypeMapper(signature.typeParameters, typeArguments);
        }
        function getErasedSignature(signature) {
          return signature.typeParameters ? signature.erasedSignatureCache || (signature.erasedSignatureCache = createErasedSignature(signature)) : signature;
        }
        function createErasedSignature(signature) {
          return instantiateSignature(signature, createTypeEraser(signature.typeParameters), true);
        }
        function getCanonicalSignature(signature) {
          return signature.typeParameters ? signature.canonicalSignatureCache || (signature.canonicalSignatureCache = createCanonicalSignature(signature)) : signature;
        }
        function createCanonicalSignature(signature) {
          return getSignatureInstantiation(signature, ts2.map(signature.typeParameters, function(tp) {
            return tp.target && !getConstraintOfTypeParameter(tp.target) ? tp.target : tp;
          }), ts2.isInJSFile(signature.declaration));
        }
        function getBaseSignature(signature) {
          var typeParameters = signature.typeParameters;
          if (typeParameters) {
            var typeEraser_1 = createTypeEraser(typeParameters);
            var baseConstraints = ts2.map(typeParameters, function(tp) {
              return instantiateType(getBaseConstraintOfType(tp), typeEraser_1) || unknownType;
            });
            return instantiateSignature(signature, createTypeMapper(typeParameters, baseConstraints), true);
          }
          return signature;
        }
        function getOrCreateTypeFromSignature(signature) {
          if (!signature.isolatedSignatureType) {
            var kind = signature.declaration ? signature.declaration.kind : 0;
            var isConstructor = kind === 162 || kind === 166 || kind === 171;
            var type = createObjectType(16);
            type.members = emptySymbols;
            type.properties = ts2.emptyArray;
            type.callSignatures = !isConstructor ? [signature] : ts2.emptyArray;
            type.constructSignatures = isConstructor ? [signature] : ts2.emptyArray;
            signature.isolatedSignatureType = type;
          }
          return signature.isolatedSignatureType;
        }
        function getIndexSymbol(symbol) {
          return symbol.members.get("__index");
        }
        function getIndexDeclarationOfSymbol(symbol, kind) {
          var syntaxKind = kind === 1 ? 140 : 143;
          var indexSymbol = getIndexSymbol(symbol);
          if (indexSymbol) {
            for (var _i = 0, _a = indexSymbol.declarations; _i < _a.length; _i++) {
              var decl = _a[_i];
              var node = ts2.cast(decl, ts2.isIndexSignatureDeclaration);
              if (node.parameters.length === 1) {
                var parameter = node.parameters[0];
                if (parameter.type && parameter.type.kind === syntaxKind) {
                  return node;
                }
              }
            }
          }
          return void 0;
        }
        function createIndexInfo(type, isReadonly, declaration) {
          return { type, isReadonly, declaration };
        }
        function getIndexInfoOfSymbol(symbol, kind) {
          var declaration = getIndexDeclarationOfSymbol(symbol, kind);
          if (declaration) {
            return createIndexInfo(declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, ts2.hasModifier(declaration, 64), declaration);
          }
          return void 0;
        }
        function getConstraintDeclaration(type) {
          return ts2.mapDefined(ts2.filter(type.symbol && type.symbol.declarations, ts2.isTypeParameterDeclaration), ts2.getEffectiveConstraintOfTypeParameter)[0];
        }
        function getInferredTypeParameterConstraint(typeParameter) {
          var inferences;
          if (typeParameter.symbol) {
            for (var _i = 0, _a = typeParameter.symbol.declarations; _i < _a.length; _i++) {
              var declaration = _a[_i];
              if (declaration.parent.kind === 181) {
                var grandParent = declaration.parent.parent;
                if (grandParent.kind === 169) {
                  var typeReference = grandParent;
                  var typeParameters = getTypeParametersForTypeReference(typeReference);
                  if (typeParameters) {
                    var index = typeReference.typeArguments.indexOf(declaration.parent);
                    if (index < typeParameters.length) {
                      var declaredConstraint = getConstraintOfTypeParameter(typeParameters[index]);
                      if (declaredConstraint) {
                        var mapper = createTypeMapper(typeParameters, getEffectiveTypeArguments(typeReference, typeParameters));
                        var constraint = instantiateType(declaredConstraint, mapper);
                        if (constraint !== typeParameter) {
                          inferences = ts2.append(inferences, constraint);
                        }
                      }
                    }
                  }
                } else if (grandParent.kind === 156 && grandParent.dotDotDotToken) {
                  inferences = ts2.append(inferences, createArrayType(unknownType));
                }
              }
            }
          }
          return inferences && getIntersectionType(inferences);
        }
        function getConstraintFromTypeParameter(typeParameter) {
          if (!typeParameter.constraint) {
            if (typeParameter.target) {
              var targetConstraint = getConstraintOfTypeParameter(typeParameter.target);
              typeParameter.constraint = targetConstraint ? instantiateType(targetConstraint, typeParameter.mapper) : noConstraintType;
            } else {
              var constraintDeclaration = getConstraintDeclaration(typeParameter);
              if (!constraintDeclaration) {
                typeParameter.constraint = getInferredTypeParameterConstraint(typeParameter) || noConstraintType;
              } else {
                var type = getTypeFromTypeNode(constraintDeclaration);
                if (type.flags & 1 && type !== errorType) {
                  type = constraintDeclaration.parent.parent.kind === 186 ? keyofConstraintType : unknownType;
                }
                typeParameter.constraint = type;
              }
            }
          }
          return typeParameter.constraint === noConstraintType ? void 0 : typeParameter.constraint;
        }
        function getParentSymbolOfTypeParameter(typeParameter) {
          var tp = ts2.getDeclarationOfKind(typeParameter.symbol, 155);
          var host2 = ts2.isJSDocTemplateTag(tp.parent) ? ts2.getHostSignatureFromJSDoc(tp.parent) : tp.parent;
          return host2 && getSymbolOfNode(host2);
        }
        function getTypeListId(types) {
          var result = "";
          if (types) {
            var length_4 = types.length;
            var i = 0;
            while (i < length_4) {
              var startId = types[i].id;
              var count = 1;
              while (i + count < length_4 && types[i + count].id === startId + count) {
                count++;
              }
              if (result.length) {
                result += ",";
              }
              result += startId;
              if (count > 1) {
                result += ":" + count;
              }
              i += count;
            }
          }
          return result;
        }
        function getPropagatingFlagsOfTypes(types, excludeKinds) {
          var result = 0;
          for (var _i = 0, types_8 = types; _i < types_8.length; _i++) {
            var type = types_8[_i];
            if (!(type.flags & excludeKinds)) {
              result |= ts2.getObjectFlags(type);
            }
          }
          return result & 3670016;
        }
        function createTypeReference(target, typeArguments) {
          var id = getTypeListId(typeArguments);
          var type = target.instantiations.get(id);
          if (!type) {
            type = createObjectType(4, target.symbol);
            target.instantiations.set(id, type);
            type.objectFlags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments, 0) : 0;
            type.target = target;
            type.resolvedTypeArguments = typeArguments;
          }
          return type;
        }
        function cloneTypeReference(source) {
          var type = createType(source.flags);
          type.symbol = source.symbol;
          type.objectFlags = source.objectFlags;
          type.target = source.target;
          type.resolvedTypeArguments = source.resolvedTypeArguments;
          return type;
        }
        function createDeferredTypeReference(target, node, mapper) {
          var aliasSymbol = getAliasSymbolForTypeNode(node);
          var aliasTypeArguments = getTypeArgumentsForAliasSymbol(aliasSymbol);
          var type = createObjectType(4, target.symbol);
          type.target = target;
          type.node = node;
          type.mapper = mapper;
          type.aliasSymbol = aliasSymbol;
          type.aliasTypeArguments = mapper ? instantiateTypes(aliasTypeArguments, mapper) : aliasTypeArguments;
          return type;
        }
        function getTypeArguments(type) {
          var _a, _b;
          if (!type.resolvedTypeArguments) {
            if (!pushTypeResolution(type, 6)) {
              return ((_a = type.target.localTypeParameters) === null || _a === void 0 ? void 0 : _a.map(function() {
                return errorType;
              })) || ts2.emptyArray;
            }
            var node = type.node;
            var typeArguments = !node ? ts2.emptyArray : node.kind === 169 ? ts2.concatenate(type.target.outerTypeParameters, getEffectiveTypeArguments(node, type.target.localTypeParameters)) : node.kind === 174 ? [getTypeFromTypeNode(node.elementType)] : ts2.map(node.elementTypes, getTypeFromTypeNode);
            if (popTypeResolution()) {
              type.resolvedTypeArguments = type.mapper ? instantiateTypes(typeArguments, type.mapper) : typeArguments;
            } else {
              type.resolvedTypeArguments = ((_b = type.target.localTypeParameters) === null || _b === void 0 ? void 0 : _b.map(function() {
                return errorType;
              })) || ts2.emptyArray;
              error(type.node || currentNode, type.target.symbol ? ts2.Diagnostics.Type_arguments_for_0_circularly_reference_themselves : ts2.Diagnostics.Tuple_type_arguments_circularly_reference_themselves, type.target.symbol && symbolToString(type.target.symbol));
            }
          }
          return type.resolvedTypeArguments;
        }
        function getTypeReferenceArity(type) {
          return ts2.length(type.target.typeParameters);
        }
        function getTypeFromClassOrInterfaceReference(node, symbol) {
          var type = getDeclaredTypeOfSymbol(getMergedSymbol(symbol));
          var typeParameters = type.localTypeParameters;
          if (typeParameters) {
            var numTypeArguments = ts2.length(node.typeArguments);
            var minTypeArgumentCount = getMinTypeArgumentCount(typeParameters);
            var isJs = ts2.isInJSFile(node);
            var isJsImplicitAny = !noImplicitAny && isJs;
            if (!isJsImplicitAny && (numTypeArguments < minTypeArgumentCount || numTypeArguments > typeParameters.length)) {
              var missingAugmentsTag = isJs && ts2.isExpressionWithTypeArguments(node) && !ts2.isJSDocAugmentsTag(node.parent);
              var diag = minTypeArgumentCount === typeParameters.length ? missingAugmentsTag ? ts2.Diagnostics.Expected_0_type_arguments_provide_these_with_an_extends_tag : ts2.Diagnostics.Generic_type_0_requires_1_type_argument_s : missingAugmentsTag ? ts2.Diagnostics.Expected_0_1_type_arguments_provide_these_with_an_extends_tag : ts2.Diagnostics.Generic_type_0_requires_between_1_and_2_type_arguments;
              var typeStr = typeToString(type, void 0, 2);
              error(node, diag, typeStr, minTypeArgumentCount, typeParameters.length);
              if (!isJs) {
                return errorType;
              }
            }
            if (node.kind === 169 && isDeferredTypeReferenceNode(node, ts2.length(node.typeArguments) !== typeParameters.length)) {
              return createDeferredTypeReference(type, node, void 0);
            }
            var typeArguments = ts2.concatenate(type.outerTypeParameters, fillMissingTypeArguments(typeArgumentsFromTypeReferenceNode(node), typeParameters, minTypeArgumentCount, isJs));
            return createTypeReference(type, typeArguments);
          }
          return checkNoTypeArguments(node, symbol) ? type : errorType;
        }
        function getTypeAliasInstantiation(symbol, typeArguments) {
          var type = getDeclaredTypeOfSymbol(symbol);
          var links = getSymbolLinks(symbol);
          var typeParameters = links.typeParameters;
          var id = getTypeListId(typeArguments);
          var instantiation = links.instantiations.get(id);
          if (!instantiation) {
            links.instantiations.set(id, instantiation = instantiateType(type, createTypeMapper(typeParameters, fillMissingTypeArguments(typeArguments, typeParameters, getMinTypeArgumentCount(typeParameters), ts2.isInJSFile(symbol.valueDeclaration)))));
          }
          return instantiation;
        }
        function getTypeFromTypeAliasReference(node, symbol) {
          var type = getDeclaredTypeOfSymbol(symbol);
          var typeParameters = getSymbolLinks(symbol).typeParameters;
          if (typeParameters) {
            var numTypeArguments = ts2.length(node.typeArguments);
            var minTypeArgumentCount = getMinTypeArgumentCount(typeParameters);
            if (numTypeArguments < minTypeArgumentCount || numTypeArguments > typeParameters.length) {
              error(node, minTypeArgumentCount === typeParameters.length ? ts2.Diagnostics.Generic_type_0_requires_1_type_argument_s : ts2.Diagnostics.Generic_type_0_requires_between_1_and_2_type_arguments, symbolToString(symbol), minTypeArgumentCount, typeParameters.length);
              return errorType;
            }
            return getTypeAliasInstantiation(symbol, typeArgumentsFromTypeReferenceNode(node));
          }
          return checkNoTypeArguments(node, symbol) ? type : errorType;
        }
        function getTypeReferenceName(node) {
          switch (node.kind) {
            case 169:
              return node.typeName;
            case 216:
              var expr = node.expression;
              if (ts2.isEntityNameExpression(expr)) {
                return expr;
              }
          }
          return void 0;
        }
        function resolveTypeReferenceName(typeReferenceName, meaning, ignoreErrors) {
          if (!typeReferenceName) {
            return unknownSymbol;
          }
          return resolveEntityName(typeReferenceName, meaning, ignoreErrors) || unknownSymbol;
        }
        function getTypeReferenceType(node, symbol) {
          if (symbol === unknownSymbol) {
            return errorType;
          }
          symbol = getExpandoSymbol(symbol) || symbol;
          if (symbol.flags & (32 | 64)) {
            return getTypeFromClassOrInterfaceReference(node, symbol);
          }
          if (symbol.flags & 524288) {
            return getTypeFromTypeAliasReference(node, symbol);
          }
          var res = tryGetDeclaredTypeOfSymbol(symbol);
          if (res) {
            return checkNoTypeArguments(node, symbol) ? getRegularTypeOfLiteralType(res) : errorType;
          }
          if (symbol.flags & 111551 && isJSDocTypeReference(node)) {
            var jsdocType = getTypeFromJSDocValueReference(node, symbol);
            if (jsdocType) {
              return jsdocType;
            } else {
              resolveTypeReferenceName(getTypeReferenceName(node), 788968);
              return getTypeOfSymbol(symbol);
            }
          }
          return errorType;
        }
        function getTypeFromJSDocValueReference(node, symbol) {
          var links = getNodeLinks(node);
          if (!links.resolvedJSDocType) {
            var valueType = getTypeOfSymbol(symbol);
            var typeType = valueType;
            if (symbol.valueDeclaration) {
              var decl = ts2.getRootDeclaration(symbol.valueDeclaration);
              var isRequireAlias = false;
              if (ts2.isVariableDeclaration(decl) && decl.initializer) {
                var expr = decl.initializer;
                while (ts2.isPropertyAccessExpression(expr)) {
                  expr = expr.expression;
                }
                isRequireAlias = ts2.isCallExpression(expr) && ts2.isRequireCall(expr, true) && !!valueType.symbol;
              }
              var isImportTypeWithQualifier = node.kind === 188 && node.qualifier;
              if (valueType.symbol && (isRequireAlias || isImportTypeWithQualifier)) {
                typeType = getTypeReferenceType(node, valueType.symbol);
              }
            }
            links.resolvedJSDocType = typeType;
          }
          return links.resolvedJSDocType;
        }
        function getSubstitutionType(baseType, substitute) {
          if (substitute.flags & 3 || substitute === baseType) {
            return baseType;
          }
          var id = getTypeId(baseType) + ">" + getTypeId(substitute);
          var cached = substitutionTypes.get(id);
          if (cached) {
            return cached;
          }
          var result = createType(33554432);
          result.baseType = baseType;
          result.substitute = substitute;
          substitutionTypes.set(id, result);
          return result;
        }
        function isUnaryTupleTypeNode(node) {
          return node.kind === 175 && node.elementTypes.length === 1;
        }
        function getImpliedConstraint(type, checkNode, extendsNode) {
          return isUnaryTupleTypeNode(checkNode) && isUnaryTupleTypeNode(extendsNode) ? getImpliedConstraint(type, checkNode.elementTypes[0], extendsNode.elementTypes[0]) : getActualTypeVariable(getTypeFromTypeNode(checkNode)) === type ? getTypeFromTypeNode(extendsNode) : void 0;
        }
        function getConditionalFlowTypeOfType(type, node) {
          var constraints;
          while (node && !ts2.isStatement(node) && node.kind !== 303) {
            var parent = node.parent;
            if (parent.kind === 180 && node === parent.trueType) {
              var constraint = getImpliedConstraint(type, parent.checkType, parent.extendsType);
              if (constraint) {
                constraints = ts2.append(constraints, constraint);
              }
            }
            node = parent;
          }
          return constraints ? getSubstitutionType(type, getIntersectionType(ts2.append(constraints, type))) : type;
        }
        function isJSDocTypeReference(node) {
          return !!(node.flags & 4194304) && (node.kind === 169 || node.kind === 188);
        }
        function checkNoTypeArguments(node, symbol) {
          if (node.typeArguments) {
            error(node, ts2.Diagnostics.Type_0_is_not_generic, symbol ? symbolToString(symbol) : node.typeName ? ts2.declarationNameToString(node.typeName) : anon);
            return false;
          }
          return true;
        }
        function getIntendedTypeFromJSDocTypeReference(node) {
          if (ts2.isIdentifier(node.typeName)) {
            var typeArgs = node.typeArguments;
            switch (node.typeName.escapedText) {
              case "String":
                checkNoTypeArguments(node);
                return stringType;
              case "Number":
                checkNoTypeArguments(node);
                return numberType;
              case "Boolean":
                checkNoTypeArguments(node);
                return booleanType;
              case "Void":
                checkNoTypeArguments(node);
                return voidType;
              case "Undefined":
                checkNoTypeArguments(node);
                return undefinedType;
              case "Null":
                checkNoTypeArguments(node);
                return nullType;
              case "Function":
              case "function":
                checkNoTypeArguments(node);
                return globalFunctionType;
              case "array":
                return (!typeArgs || !typeArgs.length) && !noImplicitAny ? anyArrayType : void 0;
              case "promise":
                return (!typeArgs || !typeArgs.length) && !noImplicitAny ? createPromiseType(anyType) : void 0;
              case "Object":
                if (typeArgs && typeArgs.length === 2) {
                  if (ts2.isJSDocIndexSignature(node)) {
                    var indexed = getTypeFromTypeNode(typeArgs[0]);
                    var target = getTypeFromTypeNode(typeArgs[1]);
                    var index = createIndexInfo(target, false);
                    return createAnonymousType(void 0, emptySymbols, ts2.emptyArray, ts2.emptyArray, indexed === stringType ? index : void 0, indexed === numberType ? index : void 0);
                  }
                  return anyType;
                }
                checkNoTypeArguments(node);
                return !noImplicitAny ? anyType : void 0;
            }
          }
        }
        function getTypeFromJSDocNullableTypeNode(node) {
          var type = getTypeFromTypeNode(node.type);
          return strictNullChecks ? getNullableType(type, 65536) : type;
        }
        function getTypeFromTypeReference(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            if (ts2.isConstTypeReference(node) && ts2.isAssertionExpression(node.parent)) {
              links.resolvedSymbol = unknownSymbol;
              return links.resolvedType = checkExpressionCached(node.parent.expression);
            }
            var symbol = void 0;
            var type = void 0;
            var meaning = 788968;
            if (isJSDocTypeReference(node)) {
              type = getIntendedTypeFromJSDocTypeReference(node);
              if (!type) {
                symbol = resolveTypeReferenceName(getTypeReferenceName(node), meaning, true);
                if (symbol === unknownSymbol) {
                  symbol = resolveTypeReferenceName(getTypeReferenceName(node), meaning | 111551);
                } else {
                  resolveTypeReferenceName(getTypeReferenceName(node), meaning);
                }
                type = getTypeReferenceType(node, symbol);
              }
            }
            if (!type) {
              symbol = resolveTypeReferenceName(getTypeReferenceName(node), meaning);
              type = getTypeReferenceType(node, symbol);
            }
            links.resolvedSymbol = symbol;
            links.resolvedType = type;
          }
          return links.resolvedType;
        }
        function typeArgumentsFromTypeReferenceNode(node) {
          return ts2.map(node.typeArguments, getTypeFromTypeNode);
        }
        function getTypeFromTypeQueryNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            links.resolvedType = getRegularTypeOfLiteralType(getWidenedType(checkExpression(node.exprName)));
          }
          return links.resolvedType;
        }
        function getTypeOfGlobalSymbol(symbol, arity) {
          function getTypeDeclaration(symbol2) {
            var declarations = symbol2.declarations;
            for (var _i = 0, declarations_3 = declarations; _i < declarations_3.length; _i++) {
              var declaration = declarations_3[_i];
              switch (declaration.kind) {
                case 245:
                case 246:
                case 248:
                  return declaration;
              }
            }
          }
          if (!symbol) {
            return arity ? emptyGenericType : emptyObjectType;
          }
          var type = getDeclaredTypeOfSymbol(symbol);
          if (!(type.flags & 524288)) {
            error(getTypeDeclaration(symbol), ts2.Diagnostics.Global_type_0_must_be_a_class_or_interface_type, ts2.symbolName(symbol));
            return arity ? emptyGenericType : emptyObjectType;
          }
          if (ts2.length(type.typeParameters) !== arity) {
            error(getTypeDeclaration(symbol), ts2.Diagnostics.Global_type_0_must_have_1_type_parameter_s, ts2.symbolName(symbol), arity);
            return arity ? emptyGenericType : emptyObjectType;
          }
          return type;
        }
        function getGlobalValueSymbol(name, reportErrors) {
          return getGlobalSymbol(name, 111551, reportErrors ? ts2.Diagnostics.Cannot_find_global_value_0 : void 0);
        }
        function getGlobalTypeSymbol(name, reportErrors) {
          return getGlobalSymbol(name, 788968, reportErrors ? ts2.Diagnostics.Cannot_find_global_type_0 : void 0);
        }
        function getGlobalSymbol(name, meaning, diagnostic) {
          return resolveName(void 0, name, meaning, diagnostic, name, false);
        }
        function getGlobalType(name, arity, reportErrors) {
          var symbol = getGlobalTypeSymbol(name, reportErrors);
          return symbol || reportErrors ? getTypeOfGlobalSymbol(symbol, arity) : void 0;
        }
        function getGlobalTypedPropertyDescriptorType() {
          return deferredGlobalTypedPropertyDescriptorType || (deferredGlobalTypedPropertyDescriptorType = getGlobalType("TypedPropertyDescriptor", 1, true)) || emptyGenericType;
        }
        function getGlobalTemplateStringsArrayType() {
          return deferredGlobalTemplateStringsArrayType || (deferredGlobalTemplateStringsArrayType = getGlobalType("TemplateStringsArray", 0, true)) || emptyObjectType;
        }
        function getGlobalImportMetaType() {
          return deferredGlobalImportMetaType || (deferredGlobalImportMetaType = getGlobalType("ImportMeta", 0, true)) || emptyObjectType;
        }
        function getGlobalESSymbolConstructorSymbol(reportErrors) {
          return deferredGlobalESSymbolConstructorSymbol || (deferredGlobalESSymbolConstructorSymbol = getGlobalValueSymbol("Symbol", reportErrors));
        }
        function getGlobalESSymbolType(reportErrors) {
          return deferredGlobalESSymbolType || (deferredGlobalESSymbolType = getGlobalType("Symbol", 0, reportErrors)) || emptyObjectType;
        }
        function getGlobalPromiseType(reportErrors) {
          return deferredGlobalPromiseType || (deferredGlobalPromiseType = getGlobalType("Promise", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalPromiseLikeType(reportErrors) {
          return deferredGlobalPromiseLikeType || (deferredGlobalPromiseLikeType = getGlobalType("PromiseLike", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalPromiseConstructorSymbol(reportErrors) {
          return deferredGlobalPromiseConstructorSymbol || (deferredGlobalPromiseConstructorSymbol = getGlobalValueSymbol("Promise", reportErrors));
        }
        function getGlobalPromiseConstructorLikeType(reportErrors) {
          return deferredGlobalPromiseConstructorLikeType || (deferredGlobalPromiseConstructorLikeType = getGlobalType("PromiseConstructorLike", 0, reportErrors)) || emptyObjectType;
        }
        function getGlobalAsyncIterableType(reportErrors) {
          return deferredGlobalAsyncIterableType || (deferredGlobalAsyncIterableType = getGlobalType("AsyncIterable", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalAsyncIteratorType(reportErrors) {
          return deferredGlobalAsyncIteratorType || (deferredGlobalAsyncIteratorType = getGlobalType("AsyncIterator", 3, reportErrors)) || emptyGenericType;
        }
        function getGlobalAsyncIterableIteratorType(reportErrors) {
          return deferredGlobalAsyncIterableIteratorType || (deferredGlobalAsyncIterableIteratorType = getGlobalType("AsyncIterableIterator", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalAsyncGeneratorType(reportErrors) {
          return deferredGlobalAsyncGeneratorType || (deferredGlobalAsyncGeneratorType = getGlobalType("AsyncGenerator", 3, reportErrors)) || emptyGenericType;
        }
        function getGlobalIterableType(reportErrors) {
          return deferredGlobalIterableType || (deferredGlobalIterableType = getGlobalType("Iterable", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalIteratorType(reportErrors) {
          return deferredGlobalIteratorType || (deferredGlobalIteratorType = getGlobalType("Iterator", 3, reportErrors)) || emptyGenericType;
        }
        function getGlobalIterableIteratorType(reportErrors) {
          return deferredGlobalIterableIteratorType || (deferredGlobalIterableIteratorType = getGlobalType("IterableIterator", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalGeneratorType(reportErrors) {
          return deferredGlobalGeneratorType || (deferredGlobalGeneratorType = getGlobalType("Generator", 3, reportErrors)) || emptyGenericType;
        }
        function getGlobalIteratorYieldResultType(reportErrors) {
          return deferredGlobalIteratorYieldResultType || (deferredGlobalIteratorYieldResultType = getGlobalType("IteratorYieldResult", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalIteratorReturnResultType(reportErrors) {
          return deferredGlobalIteratorReturnResultType || (deferredGlobalIteratorReturnResultType = getGlobalType("IteratorReturnResult", 1, reportErrors)) || emptyGenericType;
        }
        function getGlobalTypeOrUndefined(name, arity) {
          if (arity === void 0) {
            arity = 0;
          }
          var symbol = getGlobalSymbol(name, 788968, void 0);
          return symbol && getTypeOfGlobalSymbol(symbol, arity);
        }
        function getGlobalExtractSymbol() {
          return deferredGlobalExtractSymbol || (deferredGlobalExtractSymbol = getGlobalSymbol("Extract", 524288, ts2.Diagnostics.Cannot_find_global_type_0));
        }
        function getGlobalOmitSymbol() {
          return deferredGlobalOmitSymbol || (deferredGlobalOmitSymbol = getGlobalSymbol("Omit", 524288, ts2.Diagnostics.Cannot_find_global_type_0));
        }
        function getGlobalBigIntType(reportErrors) {
          return deferredGlobalBigIntType || (deferredGlobalBigIntType = getGlobalType("BigInt", 0, reportErrors)) || emptyObjectType;
        }
        function createTypeFromGenericGlobalType(genericGlobalType, typeArguments) {
          return genericGlobalType !== emptyGenericType ? createTypeReference(genericGlobalType, typeArguments) : emptyObjectType;
        }
        function createTypedPropertyDescriptorType(propertyType) {
          return createTypeFromGenericGlobalType(getGlobalTypedPropertyDescriptorType(), [propertyType]);
        }
        function createIterableType(iteratedType) {
          return createTypeFromGenericGlobalType(getGlobalIterableType(true), [iteratedType]);
        }
        function createArrayType(elementType, readonly) {
          return createTypeFromGenericGlobalType(readonly ? globalReadonlyArrayType : globalArrayType, [elementType]);
        }
        function getArrayOrTupleTargetType(node) {
          var readonly = isReadonlyTypeOperator(node.parent);
          if (node.kind === 174 || node.elementTypes.length === 1 && node.elementTypes[0].kind === 177) {
            return readonly ? globalReadonlyArrayType : globalArrayType;
          }
          var lastElement = ts2.lastOrUndefined(node.elementTypes);
          var restElement = lastElement && lastElement.kind === 177 ? lastElement : void 0;
          var minLength = ts2.findLastIndex(node.elementTypes, function(n) {
            return n.kind !== 176 && n !== restElement;
          }) + 1;
          return getTupleTypeOfArity(node.elementTypes.length, minLength, !!restElement, readonly, void 0);
        }
        function isDeferredTypeReferenceNode(node, hasDefaultTypeArguments) {
          return !!getAliasSymbolForTypeNode(node) || isResolvedByTypeAlias(node) && (node.kind === 174 ? mayResolveTypeAlias(node.elementType) : node.kind === 175 ? ts2.some(node.elementTypes, mayResolveTypeAlias) : hasDefaultTypeArguments || ts2.some(node.typeArguments, mayResolveTypeAlias));
        }
        function isResolvedByTypeAlias(node) {
          var parent = node.parent;
          switch (parent.kind) {
            case 182:
            case 169:
            case 178:
            case 179:
            case 185:
            case 180:
            case 184:
            case 174:
            case 175:
              return isResolvedByTypeAlias(parent);
            case 247:
              return true;
          }
          return false;
        }
        function mayResolveTypeAlias(node) {
          switch (node.kind) {
            case 169:
              return isJSDocTypeReference(node) || !!(resolveTypeReferenceName(node.typeName, 788968).flags & 524288);
            case 172:
              return true;
            case 184:
              return node.operator !== 147 && mayResolveTypeAlias(node.type);
            case 182:
            case 176:
            case 299:
            case 297:
            case 298:
            case 294:
              return mayResolveTypeAlias(node.type);
            case 177:
              return node.type.kind !== 174 || mayResolveTypeAlias(node.type.elementType);
            case 178:
            case 179:
              return ts2.some(node.types, mayResolveTypeAlias);
            case 185:
              return mayResolveTypeAlias(node.objectType) || mayResolveTypeAlias(node.indexType);
            case 180:
              return mayResolveTypeAlias(node.checkType) || mayResolveTypeAlias(node.extendsType) || mayResolveTypeAlias(node.trueType) || mayResolveTypeAlias(node.falseType);
          }
          return false;
        }
        function getTypeFromArrayOrTupleTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var target = getArrayOrTupleTargetType(node);
            if (target === emptyGenericType) {
              links.resolvedType = emptyObjectType;
            } else if (isDeferredTypeReferenceNode(node)) {
              links.resolvedType = node.kind === 175 && node.elementTypes.length === 0 ? target : createDeferredTypeReference(target, node, void 0);
            } else {
              var elementTypes = node.kind === 174 ? [getTypeFromTypeNode(node.elementType)] : ts2.map(node.elementTypes, getTypeFromTypeNode);
              links.resolvedType = createTypeReference(target, elementTypes);
            }
          }
          return links.resolvedType;
        }
        function isReadonlyTypeOperator(node) {
          return ts2.isTypeOperatorNode(node) && node.operator === 138;
        }
        function createTupleTypeOfArity(arity, minLength, hasRestElement, readonly, associatedNames) {
          var typeParameters;
          var properties = [];
          var maxLength = hasRestElement ? arity - 1 : arity;
          if (arity) {
            typeParameters = new Array(arity);
            for (var i = 0; i < arity; i++) {
              var typeParameter = typeParameters[i] = createTypeParameter();
              if (i < maxLength) {
                var property = createSymbol(4 | (i >= minLength ? 16777216 : 0), "" + i, readonly ? 8 : 0);
                property.type = typeParameter;
                properties.push(property);
              }
            }
          }
          var literalTypes2 = [];
          for (var i = minLength; i <= maxLength; i++)
            literalTypes2.push(getLiteralType(i));
          var lengthSymbol = createSymbol(4, "length");
          lengthSymbol.type = hasRestElement ? numberType : getUnionType(literalTypes2);
          properties.push(lengthSymbol);
          var type = createObjectType(8 | 4);
          type.typeParameters = typeParameters;
          type.outerTypeParameters = void 0;
          type.localTypeParameters = typeParameters;
          type.instantiations = ts2.createMap();
          type.instantiations.set(getTypeListId(type.typeParameters), type);
          type.target = type;
          type.resolvedTypeArguments = type.typeParameters;
          type.thisType = createTypeParameter();
          type.thisType.isThisType = true;
          type.thisType.constraint = type;
          type.declaredProperties = properties;
          type.declaredCallSignatures = ts2.emptyArray;
          type.declaredConstructSignatures = ts2.emptyArray;
          type.declaredStringIndexInfo = void 0;
          type.declaredNumberIndexInfo = void 0;
          type.minLength = minLength;
          type.hasRestElement = hasRestElement;
          type.readonly = readonly;
          type.associatedNames = associatedNames;
          return type;
        }
        function getTupleTypeOfArity(arity, minLength, hasRestElement, readonly, associatedNames) {
          var key = arity + (hasRestElement ? "+" : ",") + minLength + (readonly ? "R" : "") + (associatedNames && associatedNames.length ? "," + associatedNames.join(",") : "");
          var type = tupleTypes.get(key);
          if (!type) {
            tupleTypes.set(key, type = createTupleTypeOfArity(arity, minLength, hasRestElement, readonly, associatedNames));
          }
          return type;
        }
        function createTupleType(elementTypes, minLength, hasRestElement, readonly, associatedNames) {
          if (minLength === void 0) {
            minLength = elementTypes.length;
          }
          if (hasRestElement === void 0) {
            hasRestElement = false;
          }
          if (readonly === void 0) {
            readonly = false;
          }
          var arity = elementTypes.length;
          if (arity === 1 && hasRestElement) {
            return createArrayType(elementTypes[0], readonly);
          }
          var tupleType = getTupleTypeOfArity(arity, minLength, arity > 0 && hasRestElement, readonly, associatedNames);
          return elementTypes.length ? createTypeReference(tupleType, elementTypes) : tupleType;
        }
        function sliceTupleType(type, index) {
          var tuple = type.target;
          if (tuple.hasRestElement) {
            index = Math.min(index, getTypeReferenceArity(type) - 1);
          }
          return createTupleType(getTypeArguments(type).slice(index), Math.max(0, tuple.minLength - index), tuple.hasRestElement, tuple.readonly, tuple.associatedNames && tuple.associatedNames.slice(index));
        }
        function getTypeFromOptionalTypeNode(node) {
          var type = getTypeFromTypeNode(node.type);
          return strictNullChecks ? getOptionalType(type) : type;
        }
        function getTypeId(type) {
          return type.id;
        }
        function containsType(types, type) {
          return ts2.binarySearch(types, type, getTypeId, ts2.compareValues) >= 0;
        }
        function insertType(types, type) {
          var index = ts2.binarySearch(types, type, getTypeId, ts2.compareValues);
          if (index < 0) {
            types.splice(~index, 0, type);
            return true;
          }
          return false;
        }
        function addTypeToUnion(typeSet, includes, type) {
          var flags = type.flags;
          if (flags & 1048576) {
            return addTypesToUnion(typeSet, includes, type.types);
          }
          if (!(flags & 131072)) {
            includes |= flags & 71041023;
            if (flags & 66846720)
              includes |= 262144;
            if (type === wildcardType)
              includes |= 8388608;
            if (!strictNullChecks && flags & 98304) {
              if (!(ts2.getObjectFlags(type) & 524288))
                includes |= 4194304;
            } else {
              var len = typeSet.length;
              var index = len && type.id > typeSet[len - 1].id ? ~len : ts2.binarySearch(typeSet, type, getTypeId, ts2.compareValues);
              if (index < 0) {
                typeSet.splice(~index, 0, type);
              }
            }
          }
          return includes;
        }
        function addTypesToUnion(typeSet, includes, types) {
          for (var _i = 0, types_9 = types; _i < types_9.length; _i++) {
            var type = types_9[_i];
            includes = addTypeToUnion(typeSet, includes, type);
          }
          return includes;
        }
        function isSetOfLiteralsFromSameEnum(types) {
          var first = types[0];
          if (first.flags & 1024) {
            var firstEnum = getParentOfSymbol(first.symbol);
            for (var i = 1; i < types.length; i++) {
              var other = types[i];
              if (!(other.flags & 1024) || firstEnum !== getParentOfSymbol(other.symbol)) {
                return false;
              }
            }
            return true;
          }
          return false;
        }
        function removeSubtypes(types, primitivesOnly) {
          var len = types.length;
          if (len === 0 || isSetOfLiteralsFromSameEnum(types)) {
            return true;
          }
          var i = len;
          var count = 0;
          while (i > 0) {
            i--;
            var source = types[i];
            for (var _i = 0, types_10 = types; _i < types_10.length; _i++) {
              var target = types_10[_i];
              if (source !== target) {
                if (count === 1e5) {
                  var estimatedCount = count / (len - i) * len;
                  if (estimatedCount > (primitivesOnly ? 25e6 : 1e6)) {
                    error(currentNode, ts2.Diagnostics.Expression_produces_a_union_type_that_is_too_complex_to_represent);
                    return false;
                  }
                }
                count++;
                if (isTypeRelatedTo(source, target, strictSubtypeRelation) && (!(ts2.getObjectFlags(getTargetType(source)) & 1) || !(ts2.getObjectFlags(getTargetType(target)) & 1) || isTypeDerivedFrom(source, target))) {
                  ts2.orderedRemoveItemAt(types, i);
                  break;
                }
              }
            }
          }
          return true;
        }
        function removeRedundantLiteralTypes(types, includes) {
          var i = types.length;
          while (i > 0) {
            i--;
            var t = types[i];
            var remove2 = t.flags & 128 && includes & 4 || t.flags & 256 && includes & 8 || t.flags & 2048 && includes & 64 || t.flags & 8192 && includes & 4096 || isFreshLiteralType(t) && containsType(types, t.regularType);
            if (remove2) {
              ts2.orderedRemoveItemAt(types, i);
            }
          }
        }
        function getUnionType(types, unionReduction, aliasSymbol, aliasTypeArguments) {
          if (unionReduction === void 0) {
            unionReduction = 1;
          }
          if (types.length === 0) {
            return neverType;
          }
          if (types.length === 1) {
            return types[0];
          }
          var typeSet = [];
          var includes = addTypesToUnion(typeSet, 0, types);
          if (unionReduction !== 0) {
            if (includes & 3) {
              return includes & 1 ? includes & 8388608 ? wildcardType : anyType : unknownType;
            }
            switch (unionReduction) {
              case 1:
                if (includes & (2944 | 8192)) {
                  removeRedundantLiteralTypes(typeSet, includes);
                }
                break;
              case 2:
                if (!removeSubtypes(typeSet, !(includes & 262144))) {
                  return errorType;
                }
                break;
            }
            if (typeSet.length === 0) {
              return includes & 65536 ? includes & 4194304 ? nullType : nullWideningType : includes & 32768 ? includes & 4194304 ? undefinedType : undefinedWideningType : neverType;
            }
          }
          var objectFlags = (includes & 66994211 ? 0 : 262144) | (includes & 2097152 ? 268435456 : 0);
          return getUnionTypeFromSortedList(typeSet, objectFlags, aliasSymbol, aliasTypeArguments);
        }
        function getUnionTypePredicate(signatures) {
          var first;
          var types = [];
          for (var _i = 0, signatures_6 = signatures; _i < signatures_6.length; _i++) {
            var sig = signatures_6[_i];
            var pred = getTypePredicateOfSignature(sig);
            if (!pred || pred.kind === 2 || pred.kind === 3) {
              continue;
            }
            if (first) {
              if (!typePredicateKindsMatch(first, pred)) {
                return void 0;
              }
            } else {
              first = pred;
            }
            types.push(pred.type);
          }
          if (!first) {
            return void 0;
          }
          var unionType = getUnionType(types);
          return createTypePredicate(first.kind, first.parameterName, first.parameterIndex, unionType);
        }
        function typePredicateKindsMatch(a, b) {
          return a.kind === b.kind && a.parameterIndex === b.parameterIndex;
        }
        function getUnionTypeFromSortedList(types, objectFlags, aliasSymbol, aliasTypeArguments) {
          if (types.length === 0) {
            return neverType;
          }
          if (types.length === 1) {
            return types[0];
          }
          var id = getTypeListId(types);
          var type = unionTypes.get(id);
          if (!type) {
            type = createType(1048576);
            unionTypes.set(id, type);
            type.objectFlags = objectFlags | getPropagatingFlagsOfTypes(types, 98304);
            type.types = types;
            type.aliasSymbol = aliasSymbol;
            type.aliasTypeArguments = aliasTypeArguments;
          }
          return type;
        }
        function getTypeFromUnionTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var aliasSymbol = getAliasSymbolForTypeNode(node);
            links.resolvedType = getUnionType(ts2.map(node.types, getTypeFromTypeNode), 1, aliasSymbol, getTypeArgumentsForAliasSymbol(aliasSymbol));
          }
          return links.resolvedType;
        }
        function addTypeToIntersection(typeSet, includes, type) {
          var flags = type.flags;
          if (flags & 2097152) {
            return addTypesToIntersection(typeSet, includes, type.types);
          }
          if (isEmptyAnonymousObjectType(type)) {
            if (!(includes & 16777216)) {
              includes |= 16777216;
              typeSet.set(type.id.toString(), type);
            }
          } else {
            if (flags & 3) {
              if (type === wildcardType)
                includes |= 8388608;
            } else if ((strictNullChecks || !(flags & 98304)) && !typeSet.has(type.id.toString())) {
              if (type.flags & 109440 && includes & 109440) {
                includes |= 67108864;
              }
              typeSet.set(type.id.toString(), type);
            }
            includes |= flags & 71041023;
          }
          return includes;
        }
        function addTypesToIntersection(typeSet, includes, types) {
          for (var _i = 0, types_11 = types; _i < types_11.length; _i++) {
            var type = types_11[_i];
            includes = addTypeToIntersection(typeSet, includes, getRegularTypeOfLiteralType(type));
          }
          return includes;
        }
        function removeRedundantPrimitiveTypes(types, includes) {
          var i = types.length;
          while (i > 0) {
            i--;
            var t = types[i];
            var remove2 = t.flags & 4 && includes & 128 || t.flags & 8 && includes & 256 || t.flags & 64 && includes & 2048 || t.flags & 4096 && includes & 8192;
            if (remove2) {
              ts2.orderedRemoveItemAt(types, i);
            }
          }
        }
        function eachUnionContains(unionTypes2, type) {
          for (var _i = 0, unionTypes_1 = unionTypes2; _i < unionTypes_1.length; _i++) {
            var u = unionTypes_1[_i];
            if (!containsType(u.types, type)) {
              var primitive = type.flags & 128 ? stringType : type.flags & 256 ? numberType : type.flags & 2048 ? bigintType : type.flags & 8192 ? esSymbolType : void 0;
              if (!primitive || !containsType(u.types, primitive)) {
                return false;
              }
            }
          }
          return true;
        }
        function extractIrreducible(types, flag) {
          if (ts2.every(types, function(t) {
            return !!(t.flags & 1048576) && ts2.some(t.types, function(tt) {
              return !!(tt.flags & flag);
            });
          })) {
            for (var i = 0; i < types.length; i++) {
              types[i] = filterType(types[i], function(t) {
                return !(t.flags & flag);
              });
            }
            return true;
          }
          return false;
        }
        function intersectUnionsOfPrimitiveTypes(types) {
          var unionTypes2;
          var index = ts2.findIndex(types, function(t2) {
            return !!(ts2.getObjectFlags(t2) & 262144);
          });
          if (index < 0) {
            return false;
          }
          var i = index + 1;
          while (i < types.length) {
            var t = types[i];
            if (ts2.getObjectFlags(t) & 262144) {
              (unionTypes2 || (unionTypes2 = [types[index]])).push(t);
              ts2.orderedRemoveItemAt(types, i);
            } else {
              i++;
            }
          }
          if (!unionTypes2) {
            return false;
          }
          var checked = [];
          var result = [];
          for (var _i = 0, unionTypes_2 = unionTypes2; _i < unionTypes_2.length; _i++) {
            var u = unionTypes_2[_i];
            for (var _a = 0, _b = u.types; _a < _b.length; _a++) {
              var t = _b[_a];
              if (insertType(checked, t)) {
                if (eachUnionContains(unionTypes2, t)) {
                  insertType(result, t);
                }
              }
            }
          }
          types[index] = getUnionTypeFromSortedList(result, 262144);
          return true;
        }
        function createIntersectionType(types, aliasSymbol, aliasTypeArguments) {
          var result = createType(2097152);
          result.objectFlags = getPropagatingFlagsOfTypes(types, 98304);
          result.types = types;
          result.aliasSymbol = aliasSymbol;
          result.aliasTypeArguments = aliasTypeArguments;
          return result;
        }
        function getIntersectionType(types, aliasSymbol, aliasTypeArguments) {
          var typeMembershipMap = ts2.createMap();
          var includes = addTypesToIntersection(typeMembershipMap, 0, types);
          var typeSet = ts2.arrayFrom(typeMembershipMap.values());
          if (includes & 131072 || strictNullChecks && includes & 98304 && includes & (524288 | 67108864 | 16777216) || includes & 67108864 && includes & (67238908 & ~67108864) || includes & 132 && includes & (67238908 & ~132) || includes & 296 && includes & (67238908 & ~296) || includes & 2112 && includes & (67238908 & ~2112) || includes & 12288 && includes & (67238908 & ~12288) || includes & 49152 && includes & (67238908 & ~49152)) {
            return neverType;
          }
          if (includes & 1) {
            return includes & 8388608 ? wildcardType : anyType;
          }
          if (!strictNullChecks && includes & 98304) {
            return includes & 32768 ? undefinedType : nullType;
          }
          if (includes & 4 && includes & 128 || includes & 8 && includes & 256 || includes & 64 && includes & 2048 || includes & 4096 && includes & 8192) {
            removeRedundantPrimitiveTypes(typeSet, includes);
          }
          if (includes & 16777216 && includes & 524288) {
            ts2.orderedRemoveItemAt(typeSet, ts2.findIndex(typeSet, isEmptyAnonymousObjectType));
          }
          if (typeSet.length === 0) {
            return unknownType;
          }
          if (typeSet.length === 1) {
            return typeSet[0];
          }
          var id = getTypeListId(typeSet);
          var result = intersectionTypes.get(id);
          if (!result) {
            if (includes & 1048576) {
              if (intersectUnionsOfPrimitiveTypes(typeSet)) {
                result = getIntersectionType(typeSet, aliasSymbol, aliasTypeArguments);
              } else if (extractIrreducible(typeSet, 32768)) {
                result = getUnionType([getIntersectionType(typeSet), undefinedType], 1, aliasSymbol, aliasTypeArguments);
              } else if (extractIrreducible(typeSet, 65536)) {
                result = getUnionType([getIntersectionType(typeSet), nullType], 1, aliasSymbol, aliasTypeArguments);
              } else {
                var size = ts2.reduceLeft(typeSet, function(n, t) {
                  return n * (t.flags & 1048576 ? t.types.length : 1);
                }, 1);
                if (size >= 1e5) {
                  error(currentNode, ts2.Diagnostics.Expression_produces_a_union_type_that_is_too_complex_to_represent);
                  return errorType;
                }
                var unionIndex_1 = ts2.findIndex(typeSet, function(t) {
                  return (t.flags & 1048576) !== 0;
                });
                var unionType = typeSet[unionIndex_1];
                result = getUnionType(ts2.map(unionType.types, function(t) {
                  return getIntersectionType(ts2.replaceElement(typeSet, unionIndex_1, t));
                }), 1, aliasSymbol, aliasTypeArguments);
              }
            } else {
              result = createIntersectionType(typeSet, aliasSymbol, aliasTypeArguments);
            }
            intersectionTypes.set(id, result);
          }
          return result;
        }
        function getTypeFromIntersectionTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var aliasSymbol = getAliasSymbolForTypeNode(node);
            links.resolvedType = getIntersectionType(ts2.map(node.types, getTypeFromTypeNode), aliasSymbol, getTypeArgumentsForAliasSymbol(aliasSymbol));
          }
          return links.resolvedType;
        }
        function createIndexType(type, stringsOnly) {
          var result = createType(4194304);
          result.type = type;
          result.stringsOnly = stringsOnly;
          return result;
        }
        function getIndexTypeForGenericType(type, stringsOnly) {
          return stringsOnly ? type.resolvedStringIndexType || (type.resolvedStringIndexType = createIndexType(type, true)) : type.resolvedIndexType || (type.resolvedIndexType = createIndexType(type, false));
        }
        function getLiteralTypeFromPropertyName(name) {
          if (ts2.isPrivateIdentifier(name)) {
            return neverType;
          }
          return ts2.isIdentifier(name) ? getLiteralType(ts2.unescapeLeadingUnderscores(name.escapedText)) : getRegularTypeOfLiteralType(ts2.isComputedPropertyName(name) ? checkComputedPropertyName(name) : checkExpression(name));
        }
        function getBigIntLiteralType(node) {
          return getLiteralType({
            negative: false,
            base10Value: ts2.parsePseudoBigInt(node.text)
          });
        }
        function getLiteralTypeFromProperty(prop, include) {
          if (!(ts2.getDeclarationModifierFlagsFromSymbol(prop) & 24)) {
            var type = getSymbolLinks(getLateBoundSymbol(prop)).nameType;
            if (!type && !ts2.isKnownSymbol(prop)) {
              if (prop.escapedName === "default") {
                type = getLiteralType("default");
              } else {
                var name = prop.valueDeclaration && ts2.getNameOfDeclaration(prop.valueDeclaration);
                type = name && getLiteralTypeFromPropertyName(name) || getLiteralType(ts2.symbolName(prop));
              }
            }
            if (type && type.flags & include) {
              return type;
            }
          }
          return neverType;
        }
        function getLiteralTypeFromProperties(type, include) {
          return getUnionType(ts2.map(getPropertiesOfType(type), function(p) {
            return getLiteralTypeFromProperty(p, include);
          }));
        }
        function getNonEnumNumberIndexInfo(type) {
          var numberIndexInfo = getIndexInfoOfType(type, 1);
          return numberIndexInfo !== enumNumberIndexInfo ? numberIndexInfo : void 0;
        }
        function getIndexType(type, stringsOnly, noIndexSignatures) {
          if (stringsOnly === void 0) {
            stringsOnly = keyofStringsOnly;
          }
          type = getReducedType(type);
          return type.flags & 1048576 ? getIntersectionType(ts2.map(type.types, function(t) {
            return getIndexType(t, stringsOnly, noIndexSignatures);
          })) : type.flags & 2097152 ? getUnionType(ts2.map(type.types, function(t) {
            return getIndexType(t, stringsOnly, noIndexSignatures);
          })) : maybeTypeOfKind(type, 58982400) ? getIndexTypeForGenericType(type, stringsOnly) : ts2.getObjectFlags(type) & 32 ? filterType(getConstraintTypeFromMappedType(type), function(t) {
            return !(noIndexSignatures && t.flags & (1 | 4));
          }) : type === wildcardType ? wildcardType : type.flags & 2 ? neverType : type.flags & (1 | 131072) ? keyofConstraintType : stringsOnly ? !noIndexSignatures && getIndexInfoOfType(type, 0) ? stringType : getLiteralTypeFromProperties(type, 128) : !noIndexSignatures && getIndexInfoOfType(type, 0) ? getUnionType([stringType, numberType, getLiteralTypeFromProperties(type, 8192)]) : getNonEnumNumberIndexInfo(type) ? getUnionType([numberType, getLiteralTypeFromProperties(type, 128 | 8192)]) : getLiteralTypeFromProperties(type, 8576);
        }
        function getExtractStringType(type) {
          if (keyofStringsOnly) {
            return type;
          }
          var extractTypeAlias = getGlobalExtractSymbol();
          return extractTypeAlias ? getTypeAliasInstantiation(extractTypeAlias, [type, stringType]) : stringType;
        }
        function getIndexTypeOrString(type) {
          var indexType = getExtractStringType(getIndexType(type));
          return indexType.flags & 131072 ? stringType : indexType;
        }
        function getTypeFromTypeOperatorNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            switch (node.operator) {
              case 134:
                links.resolvedType = getIndexType(getTypeFromTypeNode(node.type));
                break;
              case 147:
                links.resolvedType = node.type.kind === 144 ? getESSymbolLikeTypeForNode(ts2.walkUpParenthesizedTypes(node.parent)) : errorType;
                break;
              case 138:
                links.resolvedType = getTypeFromTypeNode(node.type);
                break;
              default:
                throw ts2.Debug.assertNever(node.operator);
            }
          }
          return links.resolvedType;
        }
        function createIndexedAccessType(objectType, indexType, aliasSymbol, aliasTypeArguments) {
          var type = createType(8388608);
          type.objectType = objectType;
          type.indexType = indexType;
          type.aliasSymbol = aliasSymbol;
          type.aliasTypeArguments = aliasTypeArguments;
          return type;
        }
        function isJSLiteralType(type) {
          if (noImplicitAny) {
            return false;
          }
          if (ts2.getObjectFlags(type) & 16384) {
            return true;
          }
          if (type.flags & 1048576) {
            return ts2.every(type.types, isJSLiteralType);
          }
          if (type.flags & 2097152) {
            return ts2.some(type.types, isJSLiteralType);
          }
          if (type.flags & 63176704) {
            return isJSLiteralType(getResolvedBaseConstraint(type));
          }
          return false;
        }
        function getPropertyNameFromIndex(indexType, accessNode) {
          var accessExpression = accessNode && accessNode.kind === 195 ? accessNode : void 0;
          return isTypeUsableAsPropertyName(indexType) ? getPropertyNameFromType(indexType) : accessExpression && checkThatExpressionIsProperSymbolReference(accessExpression.argumentExpression, indexType, false) ? ts2.getPropertyNameForKnownSymbolName(ts2.idText(accessExpression.argumentExpression.name)) : accessNode && ts2.isPropertyName(accessNode) ? ts2.getPropertyNameForPropertyNameNode(accessNode) : void 0;
        }
        function getPropertyTypeForIndexType(originalObjectType, objectType, indexType, fullIndexType, suppressNoImplicitAnyError, accessNode, accessFlags) {
          var accessExpression = accessNode && accessNode.kind === 195 ? accessNode : void 0;
          var propName = accessNode && ts2.isPrivateIdentifier(accessNode) ? void 0 : getPropertyNameFromIndex(indexType, accessNode);
          if (propName !== void 0) {
            var prop = getPropertyOfType(objectType, propName);
            if (prop) {
              if (accessExpression) {
                markPropertyAsReferenced(prop, accessExpression, accessExpression.expression.kind === 104);
                if (isAssignmentToReadonlyEntity(accessExpression, prop, ts2.getAssignmentTargetKind(accessExpression))) {
                  error(accessExpression.argumentExpression, ts2.Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property, symbolToString(prop));
                  return void 0;
                }
                if (accessFlags & 4) {
                  getNodeLinks(accessNode).resolvedSymbol = prop;
                }
              }
              var propType = getTypeOfSymbol(prop);
              return accessExpression && ts2.getAssignmentTargetKind(accessExpression) !== 1 ? getFlowTypeOfReference(accessExpression, propType) : propType;
            }
            if (everyType(objectType, isTupleType) && isNumericLiteralName(propName) && +propName >= 0) {
              if (accessNode && everyType(objectType, function(t) {
                return !t.target.hasRestElement;
              }) && !(accessFlags & 8)) {
                var indexNode = getIndexNodeForAccessExpression(accessNode);
                if (isTupleType(objectType)) {
                  error(indexNode, ts2.Diagnostics.Tuple_type_0_of_length_1_has_no_element_at_index_2, typeToString(objectType), getTypeReferenceArity(objectType), ts2.unescapeLeadingUnderscores(propName));
                } else {
                  error(indexNode, ts2.Diagnostics.Property_0_does_not_exist_on_type_1, ts2.unescapeLeadingUnderscores(propName), typeToString(objectType));
                }
              }
              errorIfWritingToReadonlyIndex(getIndexInfoOfType(objectType, 1));
              return mapType(objectType, function(t) {
                return getRestTypeOfTupleType(t) || undefinedType;
              });
            }
          }
          if (!(indexType.flags & 98304) && isTypeAssignableToKind(indexType, 132 | 296 | 12288)) {
            if (objectType.flags & (1 | 131072)) {
              return objectType;
            }
            var stringIndexInfo = getIndexInfoOfType(objectType, 0);
            var indexInfo = isTypeAssignableToKind(indexType, 296) && getIndexInfoOfType(objectType, 1) || stringIndexInfo;
            if (indexInfo) {
              if (accessFlags & 1 && indexInfo === stringIndexInfo) {
                if (accessExpression) {
                  error(accessExpression, ts2.Diagnostics.Type_0_cannot_be_used_to_index_type_1, typeToString(indexType), typeToString(originalObjectType));
                }
                return void 0;
              }
              if (accessNode && !isTypeAssignableToKind(indexType, 4 | 8)) {
                var indexNode = getIndexNodeForAccessExpression(accessNode);
                error(indexNode, ts2.Diagnostics.Type_0_cannot_be_used_as_an_index_type, typeToString(indexType));
                return indexInfo.type;
              }
              errorIfWritingToReadonlyIndex(indexInfo);
              return indexInfo.type;
            }
            if (indexType.flags & 131072) {
              return neverType;
            }
            if (isJSLiteralType(objectType)) {
              return anyType;
            }
            if (accessExpression && !isConstEnumObjectType(objectType)) {
              if (objectType.symbol === globalThisSymbol && propName !== void 0 && globalThisSymbol.exports.has(propName) && globalThisSymbol.exports.get(propName).flags & 418) {
                error(accessExpression, ts2.Diagnostics.Property_0_does_not_exist_on_type_1, ts2.unescapeLeadingUnderscores(propName), typeToString(objectType));
              } else if (noImplicitAny && !compilerOptions.suppressImplicitAnyIndexErrors && !suppressNoImplicitAnyError) {
                if (propName !== void 0 && typeHasStaticProperty(propName, objectType)) {
                  error(accessExpression, ts2.Diagnostics.Property_0_is_a_static_member_of_type_1, propName, typeToString(objectType));
                } else if (getIndexTypeOfType(objectType, 1)) {
                  error(accessExpression.argumentExpression, ts2.Diagnostics.Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number);
                } else {
                  var suggestion = void 0;
                  if (propName !== void 0 && (suggestion = getSuggestionForNonexistentProperty(propName, objectType))) {
                    if (suggestion !== void 0) {
                      error(accessExpression.argumentExpression, ts2.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2, propName, typeToString(objectType), suggestion);
                    }
                  } else {
                    var suggestion_1 = getSuggestionForNonexistentIndexSignature(objectType, accessExpression, indexType);
                    if (suggestion_1 !== void 0) {
                      error(accessExpression, ts2.Diagnostics.Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1, typeToString(objectType), suggestion_1);
                    } else {
                      var errorInfo = void 0;
                      if (indexType.flags & 1024) {
                        errorInfo = ts2.chainDiagnosticMessages(void 0, ts2.Diagnostics.Property_0_does_not_exist_on_type_1, "[" + typeToString(indexType) + "]", typeToString(objectType));
                      } else if (indexType.flags & 8192) {
                        var symbolName_2 = getFullyQualifiedName(indexType.symbol, accessExpression);
                        errorInfo = ts2.chainDiagnosticMessages(void 0, ts2.Diagnostics.Property_0_does_not_exist_on_type_1, "[" + symbolName_2 + "]", typeToString(objectType));
                      } else if (indexType.flags & 128) {
                        errorInfo = ts2.chainDiagnosticMessages(void 0, ts2.Diagnostics.Property_0_does_not_exist_on_type_1, indexType.value, typeToString(objectType));
                      } else if (indexType.flags & 256) {
                        errorInfo = ts2.chainDiagnosticMessages(void 0, ts2.Diagnostics.Property_0_does_not_exist_on_type_1, indexType.value, typeToString(objectType));
                      } else if (indexType.flags & (8 | 4)) {
                        errorInfo = ts2.chainDiagnosticMessages(void 0, ts2.Diagnostics.No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1, typeToString(indexType), typeToString(objectType));
                      }
                      errorInfo = ts2.chainDiagnosticMessages(errorInfo, ts2.Diagnostics.Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1, typeToString(fullIndexType), typeToString(objectType));
                      diagnostics.add(ts2.createDiagnosticForNodeFromMessageChain(accessExpression, errorInfo));
                    }
                  }
                }
              }
              return void 0;
            }
          }
          if (isJSLiteralType(objectType)) {
            return anyType;
          }
          if (accessNode) {
            var indexNode = getIndexNodeForAccessExpression(accessNode);
            if (indexType.flags & (128 | 256)) {
              error(indexNode, ts2.Diagnostics.Property_0_does_not_exist_on_type_1, "" + indexType.value, typeToString(objectType));
            } else if (indexType.flags & (4 | 8)) {
              error(indexNode, ts2.Diagnostics.Type_0_has_no_matching_index_signature_for_type_1, typeToString(objectType), typeToString(indexType));
            } else {
              error(indexNode, ts2.Diagnostics.Type_0_cannot_be_used_as_an_index_type, typeToString(indexType));
            }
          }
          if (isTypeAny(indexType)) {
            return indexType;
          }
          return void 0;
          function errorIfWritingToReadonlyIndex(indexInfo2) {
            if (indexInfo2 && indexInfo2.isReadonly && accessExpression && (ts2.isAssignmentTarget(accessExpression) || ts2.isDeleteTarget(accessExpression))) {
              error(accessExpression, ts2.Diagnostics.Index_signature_in_type_0_only_permits_reading, typeToString(objectType));
            }
          }
        }
        function getIndexNodeForAccessExpression(accessNode) {
          return accessNode.kind === 195 ? accessNode.argumentExpression : accessNode.kind === 185 ? accessNode.indexType : accessNode.kind === 154 ? accessNode.expression : accessNode;
        }
        function isGenericObjectType(type) {
          if (type.flags & 3145728) {
            if (!(type.objectFlags & 4194304)) {
              type.objectFlags |= 4194304 | (ts2.some(type.types, isGenericObjectType) ? 8388608 : 0);
            }
            return !!(type.objectFlags & 8388608);
          }
          return !!(type.flags & 58982400) || isGenericMappedType(type);
        }
        function isGenericIndexType(type) {
          if (type.flags & 3145728) {
            if (!(type.objectFlags & 16777216)) {
              type.objectFlags |= 16777216 | (ts2.some(type.types, isGenericIndexType) ? 33554432 : 0);
            }
            return !!(type.objectFlags & 33554432);
          }
          return !!(type.flags & (58982400 | 4194304));
        }
        function isThisTypeParameter(type) {
          return !!(type.flags & 262144 && type.isThisType);
        }
        function getSimplifiedType(type, writing) {
          return type.flags & 8388608 ? getSimplifiedIndexedAccessType(type, writing) : type.flags & 16777216 ? getSimplifiedConditionalType(type, writing) : type;
        }
        function distributeIndexOverObjectType(objectType, indexType, writing) {
          if (objectType.flags & 3145728) {
            var types = ts2.map(objectType.types, function(t) {
              return getSimplifiedType(getIndexedAccessType(t, indexType), writing);
            });
            return objectType.flags & 2097152 || writing ? getIntersectionType(types) : getUnionType(types);
          }
        }
        function distributeObjectOverIndexType(objectType, indexType, writing) {
          if (indexType.flags & 1048576) {
            var types = ts2.map(indexType.types, function(t) {
              return getSimplifiedType(getIndexedAccessType(objectType, t), writing);
            });
            return writing ? getIntersectionType(types) : getUnionType(types);
          }
        }
        function unwrapSubstitution(type) {
          if (type.flags & 33554432) {
            return type.substitute;
          }
          return type;
        }
        function getSimplifiedIndexedAccessType(type, writing) {
          var cache = writing ? "simplifiedForWriting" : "simplifiedForReading";
          if (type[cache]) {
            return type[cache] === circularConstraintType ? type : type[cache];
          }
          type[cache] = circularConstraintType;
          var objectType = unwrapSubstitution(getSimplifiedType(type.objectType, writing));
          var indexType = getSimplifiedType(type.indexType, writing);
          var distributedOverIndex = distributeObjectOverIndexType(objectType, indexType, writing);
          if (distributedOverIndex) {
            return type[cache] = distributedOverIndex;
          }
          if (!(indexType.flags & 63176704)) {
            var distributedOverObject = distributeIndexOverObjectType(objectType, indexType, writing);
            if (distributedOverObject) {
              return type[cache] = distributedOverObject;
            }
          }
          if (isGenericMappedType(objectType)) {
            return type[cache] = mapType(substituteIndexedMappedType(objectType, type.indexType), function(t) {
              return getSimplifiedType(t, writing);
            });
          }
          return type[cache] = type;
        }
        function getSimplifiedConditionalType(type, writing) {
          var checkType = type.checkType;
          var extendsType = type.extendsType;
          var trueType2 = getTrueTypeFromConditionalType(type);
          var falseType2 = getFalseTypeFromConditionalType(type);
          if (falseType2.flags & 131072 && getActualTypeVariable(trueType2) === getActualTypeVariable(checkType)) {
            if (checkType.flags & 1 || isTypeAssignableTo(getRestrictiveInstantiation(checkType), getRestrictiveInstantiation(extendsType))) {
              return getSimplifiedType(trueType2, writing);
            } else if (isIntersectionEmpty(checkType, extendsType)) {
              return neverType;
            }
          } else if (trueType2.flags & 131072 && getActualTypeVariable(falseType2) === getActualTypeVariable(checkType)) {
            if (!(checkType.flags & 1) && isTypeAssignableTo(getRestrictiveInstantiation(checkType), getRestrictiveInstantiation(extendsType))) {
              return neverType;
            } else if (checkType.flags & 1 || isIntersectionEmpty(checkType, extendsType)) {
              return getSimplifiedType(falseType2, writing);
            }
          }
          return type;
        }
        function isIntersectionEmpty(type1, type2) {
          return !!(getUnionType([intersectTypes(type1, type2), neverType]).flags & 131072);
        }
        function substituteIndexedMappedType(objectType, index) {
          var mapper = createTypeMapper([getTypeParameterFromMappedType(objectType)], [index]);
          var templateMapper = combineTypeMappers(objectType.mapper, mapper);
          return instantiateType(getTemplateTypeFromMappedType(objectType), templateMapper);
        }
        function getIndexedAccessType(objectType, indexType, accessNode, aliasSymbol, aliasTypeArguments) {
          return getIndexedAccessTypeOrUndefined(objectType, indexType, accessNode, 0, aliasSymbol, aliasTypeArguments) || (accessNode ? errorType : unknownType);
        }
        function getIndexedAccessTypeOrUndefined(objectType, indexType, accessNode, accessFlags, aliasSymbol, aliasTypeArguments) {
          if (accessFlags === void 0) {
            accessFlags = 0;
          }
          if (objectType === wildcardType || indexType === wildcardType) {
            return wildcardType;
          }
          if (isStringIndexSignatureOnlyType(objectType) && !(indexType.flags & 98304) && isTypeAssignableToKind(indexType, 4 | 8)) {
            indexType = stringType;
          }
          if (isGenericIndexType(indexType) || !(accessNode && accessNode.kind !== 185) && isGenericObjectType(objectType)) {
            if (objectType.flags & 3) {
              return objectType;
            }
            var id = objectType.id + "," + indexType.id;
            var type = indexedAccessTypes.get(id);
            if (!type) {
              indexedAccessTypes.set(id, type = createIndexedAccessType(objectType, indexType, aliasSymbol, aliasTypeArguments));
            }
            return type;
          }
          var apparentObjectType = getReducedApparentType(objectType);
          if (indexType.flags & 1048576 && !(indexType.flags & 16)) {
            var propTypes = [];
            var wasMissingProp = false;
            for (var _i = 0, _a = indexType.types; _i < _a.length; _i++) {
              var t = _a[_i];
              var propType = getPropertyTypeForIndexType(objectType, apparentObjectType, t, indexType, wasMissingProp, accessNode, accessFlags);
              if (propType) {
                propTypes.push(propType);
              } else if (!accessNode) {
                return void 0;
              } else {
                wasMissingProp = true;
              }
            }
            if (wasMissingProp) {
              return void 0;
            }
            return accessFlags & 2 ? getIntersectionType(propTypes, aliasSymbol, aliasTypeArguments) : getUnionType(propTypes, 1, aliasSymbol, aliasTypeArguments);
          }
          return getPropertyTypeForIndexType(objectType, apparentObjectType, indexType, indexType, false, accessNode, accessFlags | 4);
        }
        function getTypeFromIndexedAccessTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var objectType = getTypeFromTypeNode(node.objectType);
            var indexType = getTypeFromTypeNode(node.indexType);
            var potentialAlias = getAliasSymbolForTypeNode(node);
            var resolved = getIndexedAccessType(objectType, indexType, node, potentialAlias, getTypeArgumentsForAliasSymbol(potentialAlias));
            links.resolvedType = resolved.flags & 8388608 && resolved.objectType === objectType && resolved.indexType === indexType ? getConditionalFlowTypeOfType(resolved, node) : resolved;
          }
          return links.resolvedType;
        }
        function getTypeFromMappedTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var type = createObjectType(32, node.symbol);
            type.declaration = node;
            type.aliasSymbol = getAliasSymbolForTypeNode(node);
            type.aliasTypeArguments = getTypeArgumentsForAliasSymbol(type.aliasSymbol);
            links.resolvedType = type;
            getConstraintTypeFromMappedType(type);
          }
          return links.resolvedType;
        }
        function getActualTypeVariable(type) {
          if (type.flags & 33554432) {
            return type.baseType;
          }
          if (type.flags & 8388608 && (type.objectType.flags & 33554432 || type.indexType.flags & 33554432)) {
            return getIndexedAccessType(getActualTypeVariable(type.objectType), getActualTypeVariable(type.indexType));
          }
          return type;
        }
        function getConditionalType(root, mapper) {
          var result;
          var extraTypes;
          var _loop_12 = function() {
            var checkType = instantiateType(root.checkType, mapper);
            var checkTypeInstantiable = isGenericObjectType(checkType) || isGenericIndexType(checkType);
            var extendsType = instantiateType(root.extendsType, mapper);
            if (checkType === wildcardType || extendsType === wildcardType) {
              return { value: wildcardType };
            }
            var combinedMapper = void 0;
            if (root.inferTypeParameters) {
              var context = createInferenceContext(root.inferTypeParameters, void 0, 0);
              if (!checkTypeInstantiable || !ts2.some(root.inferTypeParameters, function(t) {
                return t === extendsType;
              })) {
                inferTypes(context.inferences, checkType, extendsType, 128 | 256);
              }
              combinedMapper = mergeTypeMappers(mapper, context.mapper);
            }
            var inferredExtendsType = combinedMapper ? instantiateType(root.extendsType, combinedMapper) : extendsType;
            if (!checkTypeInstantiable && !isGenericObjectType(inferredExtendsType) && !isGenericIndexType(inferredExtendsType)) {
              if (!(inferredExtendsType.flags & 3) && (checkType.flags & 1 || !isTypeAssignableTo(getPermissiveInstantiation(checkType), getPermissiveInstantiation(inferredExtendsType)))) {
                if (checkType.flags & 1) {
                  (extraTypes || (extraTypes = [])).push(instantiateTypeWithoutDepthIncrease(root.trueType, combinedMapper || mapper));
                }
                var falseType_1 = root.falseType;
                if (falseType_1.flags & 16777216) {
                  var newRoot = falseType_1.root;
                  if (newRoot.node.parent === root.node && (!newRoot.isDistributive || newRoot.checkType === root.checkType)) {
                    root = newRoot;
                    return "continue";
                  }
                }
                result = instantiateTypeWithoutDepthIncrease(falseType_1, mapper);
                return "break";
              }
              if (inferredExtendsType.flags & 3 || isTypeAssignableTo(getRestrictiveInstantiation(checkType), getRestrictiveInstantiation(inferredExtendsType))) {
                result = instantiateTypeWithoutDepthIncrease(root.trueType, combinedMapper || mapper);
                return "break";
              }
            }
            var erasedCheckType = getActualTypeVariable(checkType);
            result = createType(16777216);
            result.root = root;
            result.checkType = erasedCheckType;
            result.extendsType = extendsType;
            result.mapper = mapper;
            result.combinedMapper = combinedMapper;
            result.aliasSymbol = root.aliasSymbol;
            result.aliasTypeArguments = instantiateTypes(root.aliasTypeArguments, mapper);
            return "break";
          };
          while (true) {
            var state_4 = _loop_12();
            if (typeof state_4 === "object")
              return state_4.value;
            if (state_4 === "break")
              break;
          }
          return extraTypes ? getUnionType(ts2.append(extraTypes, result)) : result;
        }
        function getTrueTypeFromConditionalType(type) {
          return type.resolvedTrueType || (type.resolvedTrueType = instantiateType(type.root.trueType, type.mapper));
        }
        function getFalseTypeFromConditionalType(type) {
          return type.resolvedFalseType || (type.resolvedFalseType = instantiateType(type.root.falseType, type.mapper));
        }
        function getInferredTrueTypeFromConditionalType(type) {
          return type.resolvedInferredTrueType || (type.resolvedInferredTrueType = type.combinedMapper ? instantiateType(type.root.trueType, type.combinedMapper) : getTrueTypeFromConditionalType(type));
        }
        function getInferTypeParameters(node) {
          var result;
          if (node.locals) {
            node.locals.forEach(function(symbol) {
              if (symbol.flags & 262144) {
                result = ts2.append(result, getDeclaredTypeOfSymbol(symbol));
              }
            });
          }
          return result;
        }
        function getTypeFromConditionalTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var checkType = getTypeFromTypeNode(node.checkType);
            var aliasSymbol = getAliasSymbolForTypeNode(node);
            var aliasTypeArguments = getTypeArgumentsForAliasSymbol(aliasSymbol);
            var allOuterTypeParameters = getOuterTypeParameters(node, true);
            var outerTypeParameters = aliasTypeArguments ? allOuterTypeParameters : ts2.filter(allOuterTypeParameters, function(tp) {
              return isTypeParameterPossiblyReferenced(tp, node);
            });
            var root = {
              node,
              checkType,
              extendsType: getTypeFromTypeNode(node.extendsType),
              trueType: getTypeFromTypeNode(node.trueType),
              falseType: getTypeFromTypeNode(node.falseType),
              isDistributive: !!(checkType.flags & 262144),
              inferTypeParameters: getInferTypeParameters(node),
              outerTypeParameters,
              instantiations: void 0,
              aliasSymbol,
              aliasTypeArguments
            };
            links.resolvedType = getConditionalType(root, void 0);
            if (outerTypeParameters) {
              root.instantiations = ts2.createMap();
              root.instantiations.set(getTypeListId(outerTypeParameters), links.resolvedType);
            }
          }
          return links.resolvedType;
        }
        function getTypeFromInferTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            links.resolvedType = getDeclaredTypeOfTypeParameter(getSymbolOfNode(node.typeParameter));
          }
          return links.resolvedType;
        }
        function getIdentifierChain(node) {
          if (ts2.isIdentifier(node)) {
            return [node];
          } else {
            return ts2.append(getIdentifierChain(node.left), node.right);
          }
        }
        function getTypeFromImportTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            if (node.isTypeOf && node.typeArguments) {
              error(node, ts2.Diagnostics.Type_arguments_cannot_be_used_here);
              links.resolvedSymbol = unknownSymbol;
              return links.resolvedType = errorType;
            }
            if (!ts2.isLiteralImportTypeNode(node)) {
              error(node.argument, ts2.Diagnostics.String_literal_expected);
              links.resolvedSymbol = unknownSymbol;
              return links.resolvedType = errorType;
            }
            var targetMeaning = node.isTypeOf ? 111551 : node.flags & 4194304 ? 111551 | 788968 : 788968;
            var innerModuleSymbol = resolveExternalModuleName(node, node.argument.literal);
            if (!innerModuleSymbol) {
              links.resolvedSymbol = unknownSymbol;
              return links.resolvedType = errorType;
            }
            var moduleSymbol = resolveExternalModuleSymbol(innerModuleSymbol, false);
            if (!ts2.nodeIsMissing(node.qualifier)) {
              var nameStack = getIdentifierChain(node.qualifier);
              var currentNamespace = moduleSymbol;
              var current = void 0;
              while (current = nameStack.shift()) {
                var meaning = nameStack.length ? 1920 : targetMeaning;
                var next = getSymbol(getExportsOfSymbol(getMergedSymbol(resolveSymbol(currentNamespace))), current.escapedText, meaning);
                if (!next) {
                  error(current, ts2.Diagnostics.Namespace_0_has_no_exported_member_1, getFullyQualifiedName(currentNamespace), ts2.declarationNameToString(current));
                  return links.resolvedType = errorType;
                }
                getNodeLinks(current).resolvedSymbol = next;
                getNodeLinks(current.parent).resolvedSymbol = next;
                currentNamespace = next;
              }
              links.resolvedType = resolveImportSymbolType(node, links, currentNamespace, targetMeaning);
            } else {
              if (moduleSymbol.flags & targetMeaning) {
                links.resolvedType = resolveImportSymbolType(node, links, moduleSymbol, targetMeaning);
              } else {
                var errorMessage = targetMeaning === 111551 ? ts2.Diagnostics.Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here : ts2.Diagnostics.Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0;
                error(node, errorMessage, node.argument.literal.text);
                links.resolvedSymbol = unknownSymbol;
                links.resolvedType = errorType;
              }
            }
          }
          return links.resolvedType;
        }
        function resolveImportSymbolType(node, links, symbol, meaning) {
          var resolvedSymbol = resolveSymbol(symbol);
          links.resolvedSymbol = resolvedSymbol;
          if (meaning === 111551) {
            return getTypeOfSymbol(symbol);
          } else {
            return getTypeReferenceType(node, resolvedSymbol);
          }
        }
        function getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            var aliasSymbol = getAliasSymbolForTypeNode(node);
            if (getMembersOfSymbol(node.symbol).size === 0 && !aliasSymbol) {
              links.resolvedType = emptyTypeLiteralType;
            } else {
              var type = createObjectType(16, node.symbol);
              type.aliasSymbol = aliasSymbol;
              type.aliasTypeArguments = getTypeArgumentsForAliasSymbol(aliasSymbol);
              if (ts2.isJSDocTypeLiteral(node) && node.isArrayType) {
                type = createArrayType(type);
              }
              links.resolvedType = type;
            }
          }
          return links.resolvedType;
        }
        function getAliasSymbolForTypeNode(node) {
          var host2 = node.parent;
          while (ts2.isParenthesizedTypeNode(host2) || ts2.isTypeOperatorNode(host2) && host2.operator === 138) {
            host2 = host2.parent;
          }
          return ts2.isTypeAlias(host2) ? getSymbolOfNode(host2) : void 0;
        }
        function getTypeArgumentsForAliasSymbol(symbol) {
          return symbol ? getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol) : void 0;
        }
        function isNonGenericObjectType(type) {
          return !!(type.flags & 524288) && !isGenericMappedType(type);
        }
        function isEmptyObjectTypeOrSpreadsIntoEmptyObject(type) {
          return isEmptyObjectType(type) || !!(type.flags & (65536 | 32768 | 528 | 296 | 2112 | 132 | 1056 | 67108864 | 4194304));
        }
        function isSinglePropertyAnonymousObjectType(type) {
          return !!(type.flags & 524288) && !!(ts2.getObjectFlags(type) & 16) && (ts2.length(getPropertiesOfType(type)) === 1 || ts2.every(getPropertiesOfType(type), function(p) {
            return !!(p.flags & 16777216);
          }));
        }
        function tryMergeUnionOfObjectTypeAndEmptyObject(type, readonly) {
          if (type.types.length === 2) {
            var firstType = type.types[0];
            var secondType = type.types[1];
            if (ts2.every(type.types, isEmptyObjectTypeOrSpreadsIntoEmptyObject)) {
              return isEmptyObjectType(firstType) ? firstType : isEmptyObjectType(secondType) ? secondType : emptyObjectType;
            }
            if (isEmptyObjectTypeOrSpreadsIntoEmptyObject(firstType) && isSinglePropertyAnonymousObjectType(secondType)) {
              return getAnonymousPartialType(secondType);
            }
            if (isEmptyObjectTypeOrSpreadsIntoEmptyObject(secondType) && isSinglePropertyAnonymousObjectType(firstType)) {
              return getAnonymousPartialType(firstType);
            }
          }
          function getAnonymousPartialType(type2) {
            var members = ts2.createSymbolTable();
            for (var _i = 0, _a = getPropertiesOfType(type2); _i < _a.length; _i++) {
              var prop = _a[_i];
              if (ts2.getDeclarationModifierFlagsFromSymbol(prop) & (8 | 16)) {
              } else if (isSpreadableProperty(prop)) {
                var isSetonlyAccessor = prop.flags & 65536 && !(prop.flags & 32768);
                var flags = 4 | 16777216;
                var result = createSymbol(flags, prop.escapedName, readonly ? 8 : 0);
                result.type = isSetonlyAccessor ? undefinedType : getTypeOfSymbol(prop);
                result.declarations = prop.declarations;
                result.nameType = getSymbolLinks(prop).nameType;
                result.syntheticOrigin = prop;
                members.set(prop.escapedName, result);
              }
            }
            var spread = createAnonymousType(type2.symbol, members, ts2.emptyArray, ts2.emptyArray, getIndexInfoOfType(type2, 0), getIndexInfoOfType(type2, 1));
            spread.objectFlags |= 128 | 1048576;
            return spread;
          }
        }
        function getSpreadType(left, right, symbol, objectFlags, readonly) {
          if (left.flags & 1 || right.flags & 1) {
            return anyType;
          }
          if (left.flags & 2 || right.flags & 2) {
            return unknownType;
          }
          if (left.flags & 131072) {
            return right;
          }
          if (right.flags & 131072) {
            return left;
          }
          if (left.flags & 1048576) {
            var merged = tryMergeUnionOfObjectTypeAndEmptyObject(left, readonly);
            if (merged) {
              return getSpreadType(merged, right, symbol, objectFlags, readonly);
            }
            return mapType(left, function(t) {
              return getSpreadType(t, right, symbol, objectFlags, readonly);
            });
          }
          if (right.flags & 1048576) {
            var merged = tryMergeUnionOfObjectTypeAndEmptyObject(right, readonly);
            if (merged) {
              return getSpreadType(left, merged, symbol, objectFlags, readonly);
            }
            return mapType(right, function(t) {
              return getSpreadType(left, t, symbol, objectFlags, readonly);
            });
          }
          if (right.flags & (528 | 296 | 2112 | 132 | 1056 | 67108864 | 4194304)) {
            return left;
          }
          if (isGenericObjectType(left) || isGenericObjectType(right)) {
            if (isEmptyObjectType(left)) {
              return right;
            }
            if (left.flags & 2097152) {
              var types = left.types;
              var lastLeft = types[types.length - 1];
              if (isNonGenericObjectType(lastLeft) && isNonGenericObjectType(right)) {
                return getIntersectionType(ts2.concatenate(types.slice(0, types.length - 1), [getSpreadType(lastLeft, right, symbol, objectFlags, readonly)]));
              }
            }
            return getIntersectionType([left, right]);
          }
          var members = ts2.createSymbolTable();
          var skippedPrivateMembers = ts2.createUnderscoreEscapedMap();
          var stringIndexInfo;
          var numberIndexInfo;
          if (left === emptyObjectType) {
            stringIndexInfo = getIndexInfoOfType(right, 0);
            numberIndexInfo = getIndexInfoOfType(right, 1);
          } else {
            stringIndexInfo = unionSpreadIndexInfos(getIndexInfoOfType(left, 0), getIndexInfoOfType(right, 0));
            numberIndexInfo = unionSpreadIndexInfos(getIndexInfoOfType(left, 1), getIndexInfoOfType(right, 1));
          }
          for (var _i = 0, _a = getPropertiesOfType(right); _i < _a.length; _i++) {
            var rightProp = _a[_i];
            if (ts2.getDeclarationModifierFlagsFromSymbol(rightProp) & (8 | 16)) {
              skippedPrivateMembers.set(rightProp.escapedName, true);
            } else if (isSpreadableProperty(rightProp)) {
              members.set(rightProp.escapedName, getSpreadSymbol(rightProp, readonly));
            }
          }
          for (var _b = 0, _c = getPropertiesOfType(left); _b < _c.length; _b++) {
            var leftProp = _c[_b];
            if (skippedPrivateMembers.has(leftProp.escapedName) || !isSpreadableProperty(leftProp)) {
              continue;
            }
            if (members.has(leftProp.escapedName)) {
              var rightProp = members.get(leftProp.escapedName);
              var rightType = getTypeOfSymbol(rightProp);
              if (rightProp.flags & 16777216) {
                var declarations = ts2.concatenate(leftProp.declarations, rightProp.declarations);
                var flags = 4 | leftProp.flags & 16777216;
                var result = createSymbol(flags, leftProp.escapedName);
                result.type = getUnionType([getTypeOfSymbol(leftProp), getTypeWithFacts(rightType, 524288)]);
                result.leftSpread = leftProp;
                result.rightSpread = rightProp;
                result.declarations = declarations;
                result.nameType = getSymbolLinks(leftProp).nameType;
                members.set(leftProp.escapedName, result);
              }
            } else {
              members.set(leftProp.escapedName, getSpreadSymbol(leftProp, readonly));
            }
          }
          var spread = createAnonymousType(symbol, members, ts2.emptyArray, ts2.emptyArray, getIndexInfoWithReadonly(stringIndexInfo, readonly), getIndexInfoWithReadonly(numberIndexInfo, readonly));
          spread.objectFlags |= 128 | 1048576 | 1024 | objectFlags;
          return spread;
        }
        function isSpreadableProperty(prop) {
          return !ts2.some(prop.declarations, ts2.isPrivateIdentifierPropertyDeclaration) && (!(prop.flags & (8192 | 32768 | 65536)) || !prop.declarations.some(function(decl) {
            return ts2.isClassLike(decl.parent);
          }));
        }
        function getSpreadSymbol(prop, readonly) {
          var isSetonlyAccessor = prop.flags & 65536 && !(prop.flags & 32768);
          if (!isSetonlyAccessor && readonly === isReadonlySymbol(prop)) {
            return prop;
          }
          var flags = 4 | prop.flags & 16777216;
          var result = createSymbol(flags, prop.escapedName, readonly ? 8 : 0);
          result.type = isSetonlyAccessor ? undefinedType : getTypeOfSymbol(prop);
          result.declarations = prop.declarations;
          result.nameType = getSymbolLinks(prop).nameType;
          result.syntheticOrigin = prop;
          return result;
        }
        function getIndexInfoWithReadonly(info, readonly) {
          return info && info.isReadonly !== readonly ? createIndexInfo(info.type, readonly, info.declaration) : info;
        }
        function createLiteralType(flags, value, symbol) {
          var type = createType(flags);
          type.symbol = symbol;
          type.value = value;
          return type;
        }
        function getFreshTypeOfLiteralType(type) {
          if (type.flags & 2944) {
            if (!type.freshType) {
              var freshType = createLiteralType(type.flags, type.value, type.symbol);
              freshType.regularType = type;
              freshType.freshType = freshType;
              type.freshType = freshType;
            }
            return type.freshType;
          }
          return type;
        }
        function getRegularTypeOfLiteralType(type) {
          return type.flags & 2944 ? type.regularType : type.flags & 1048576 ? type.regularType || (type.regularType = getUnionType(ts2.sameMap(type.types, getRegularTypeOfLiteralType))) : type;
        }
        function isFreshLiteralType(type) {
          return !!(type.flags & 2944) && type.freshType === type;
        }
        function getLiteralType(value, enumId, symbol) {
          var qualifier = typeof value === "number" ? "#" : typeof value === "string" ? "@" : "n";
          var key = (enumId ? enumId : "") + qualifier + (typeof value === "object" ? ts2.pseudoBigIntToString(value) : value);
          var type = literalTypes.get(key);
          if (!type) {
            var flags = (typeof value === "number" ? 256 : typeof value === "string" ? 128 : 2048) | (enumId ? 1024 : 0);
            literalTypes.set(key, type = createLiteralType(flags, value, symbol));
            type.regularType = type;
          }
          return type;
        }
        function getTypeFromLiteralTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            links.resolvedType = getRegularTypeOfLiteralType(checkExpression(node.literal));
          }
          return links.resolvedType;
        }
        function createUniqueESSymbolType(symbol) {
          var type = createType(8192);
          type.symbol = symbol;
          type.escapedName = "__@" + type.symbol.escapedName + "@" + getSymbolId(type.symbol);
          return type;
        }
        function getESSymbolLikeTypeForNode(node) {
          if (ts2.isValidESSymbolDeclaration(node)) {
            var symbol = getSymbolOfNode(node);
            var links = getSymbolLinks(symbol);
            return links.uniqueESSymbolType || (links.uniqueESSymbolType = createUniqueESSymbolType(symbol));
          }
          return esSymbolType;
        }
        function getThisType(node) {
          var container = ts2.getThisContainer(node, false);
          var parent = container && container.parent;
          if (parent && (ts2.isClassLike(parent) || parent.kind === 246)) {
            if (!ts2.hasModifier(container, 32) && (!ts2.isConstructorDeclaration(container) || ts2.isNodeDescendantOf(node, container.body))) {
              return getDeclaredTypeOfClassOrInterface(getSymbolOfNode(parent)).thisType;
            }
          }
          if (parent && ts2.isObjectLiteralExpression(parent) && ts2.isBinaryExpression(parent.parent) && ts2.getAssignmentDeclarationKind(parent.parent) === 6) {
            return getDeclaredTypeOfClassOrInterface(getSymbolOfNode(parent.parent.left).parent).thisType;
          }
          var host2 = node.flags & 4194304 ? ts2.getHostSignatureFromJSDoc(node) : void 0;
          if (host2 && ts2.isFunctionExpression(host2) && ts2.isBinaryExpression(host2.parent) && ts2.getAssignmentDeclarationKind(host2.parent) === 3) {
            return getDeclaredTypeOfClassOrInterface(getSymbolOfNode(host2.parent.left).parent).thisType;
          }
          if (isJSConstructor(container) && ts2.isNodeDescendantOf(node, container.body)) {
            return getDeclaredTypeOfClassOrInterface(getSymbolOfNode(container)).thisType;
          }
          error(node, ts2.Diagnostics.A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface);
          return errorType;
        }
        function getTypeFromThisTypeNode(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            links.resolvedType = getThisType(node);
          }
          return links.resolvedType;
        }
        function getTypeFromTypeNode(node) {
          return getConditionalFlowTypeOfType(getTypeFromTypeNodeWorker(node), node);
        }
        function getTypeFromTypeNodeWorker(node) {
          switch (node.kind) {
            case 125:
            case 295:
            case 296:
              return anyType;
            case 148:
              return unknownType;
            case 143:
              return stringType;
            case 140:
              return numberType;
            case 151:
              return bigintType;
            case 128:
              return booleanType;
            case 144:
              return esSymbolType;
            case 110:
              return voidType;
            case 146:
              return undefinedType;
            case 100:
              return nullType;
            case 137:
              return neverType;
            case 141:
              return node.flags & 131072 && !noImplicitAny ? anyType : nonPrimitiveType;
            case 183:
            case 104:
              return getTypeFromThisTypeNode(node);
            case 187:
              return getTypeFromLiteralTypeNode(node);
            case 169:
              return getTypeFromTypeReference(node);
            case 168:
              return node.assertsModifier ? voidType : booleanType;
            case 216:
              return getTypeFromTypeReference(node);
            case 172:
              return getTypeFromTypeQueryNode(node);
            case 174:
            case 175:
              return getTypeFromArrayOrTupleTypeNode(node);
            case 176:
              return getTypeFromOptionalTypeNode(node);
            case 178:
              return getTypeFromUnionTypeNode(node);
            case 179:
              return getTypeFromIntersectionTypeNode(node);
            case 297:
              return getTypeFromJSDocNullableTypeNode(node);
            case 299:
              return addOptionality(getTypeFromTypeNode(node.type));
            case 182:
            case 298:
            case 294:
              return getTypeFromTypeNode(node.type);
            case 177:
              return getElementTypeOfArrayType(getTypeFromTypeNode(node.type)) || errorType;
            case 301:
              return getTypeFromJSDocVariadicType(node);
            case 170:
            case 171:
            case 173:
            case 304:
            case 300:
            case 305:
              return getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node);
            case 184:
              return getTypeFromTypeOperatorNode(node);
            case 185:
              return getTypeFromIndexedAccessTypeNode(node);
            case 186:
              return getTypeFromMappedTypeNode(node);
            case 180:
              return getTypeFromConditionalTypeNode(node);
            case 181:
              return getTypeFromInferTypeNode(node);
            case 188:
              return getTypeFromImportTypeNode(node);
            case 75:
            case 153:
              var symbol = getSymbolAtLocation(node);
              return symbol ? getDeclaredTypeOfSymbol(symbol) : errorType;
            default:
              return errorType;
          }
        }
        function instantiateList(items, mapper, instantiator) {
          if (items && items.length) {
            for (var i = 0; i < items.length; i++) {
              var item = items[i];
              var mapped = instantiator(item, mapper);
              if (item !== mapped) {
                var result = i === 0 ? [] : items.slice(0, i);
                result.push(mapped);
                for (i++; i < items.length; i++) {
                  result.push(instantiator(items[i], mapper));
                }
                return result;
              }
            }
          }
          return items;
        }
        function instantiateTypes(types, mapper) {
          return instantiateList(types, mapper, instantiateType);
        }
        function instantiateSignatures(signatures, mapper) {
          return instantiateList(signatures, mapper, instantiateSignature);
        }
        function createTypeMapper(sources, targets) {
          return sources.length === 1 ? makeUnaryTypeMapper(sources[0], targets ? targets[0] : anyType) : makeArrayTypeMapper(sources, targets);
        }
        function getMappedType(type, mapper) {
          switch (mapper.kind) {
            case 0:
              return type === mapper.source ? mapper.target : type;
            case 1:
              var sources = mapper.sources;
              var targets = mapper.targets;
              for (var i = 0; i < sources.length; i++) {
                if (type === sources[i]) {
                  return targets ? targets[i] : anyType;
                }
              }
              return type;
            case 2:
              return mapper.func(type);
            case 3:
            case 4:
              var t1 = getMappedType(type, mapper.mapper1);
              return t1 !== type && mapper.kind === 3 ? instantiateType(t1, mapper.mapper2) : getMappedType(t1, mapper.mapper2);
          }
        }
        function makeUnaryTypeMapper(source, target) {
          return { kind: 0, source, target };
        }
        function makeArrayTypeMapper(sources, targets) {
          return { kind: 1, sources, targets };
        }
        function makeFunctionTypeMapper(func) {
          return { kind: 2, func };
        }
        function makeCompositeTypeMapper(kind, mapper1, mapper2) {
          return { kind, mapper1, mapper2 };
        }
        function createTypeEraser(sources) {
          return createTypeMapper(sources, void 0);
        }
        function createBackreferenceMapper(context, index) {
          return makeFunctionTypeMapper(function(t) {
            return ts2.findIndex(context.inferences, function(info) {
              return info.typeParameter === t;
            }) >= index ? unknownType : t;
          });
        }
        function combineTypeMappers(mapper1, mapper2) {
          return mapper1 ? makeCompositeTypeMapper(3, mapper1, mapper2) : mapper2;
        }
        function mergeTypeMappers(mapper1, mapper2) {
          return mapper1 ? makeCompositeTypeMapper(4, mapper1, mapper2) : mapper2;
        }
        function prependTypeMapping(source, target, mapper) {
          return !mapper ? makeUnaryTypeMapper(source, target) : makeCompositeTypeMapper(4, makeUnaryTypeMapper(source, target), mapper);
        }
        function appendTypeMapping(mapper, source, target) {
          return !mapper ? makeUnaryTypeMapper(source, target) : makeCompositeTypeMapper(4, mapper, makeUnaryTypeMapper(source, target));
        }
        function getRestrictiveTypeParameter(tp) {
          return tp.constraint === unknownType ? tp : tp.restrictiveInstantiation || (tp.restrictiveInstantiation = createTypeParameter(tp.symbol), tp.restrictiveInstantiation.constraint = unknownType, tp.restrictiveInstantiation);
        }
        function cloneTypeParameter(typeParameter) {
          var result = createTypeParameter(typeParameter.symbol);
          result.target = typeParameter;
          return result;
        }
        function instantiateTypePredicate(predicate, mapper) {
          return createTypePredicate(predicate.kind, predicate.parameterName, predicate.parameterIndex, instantiateType(predicate.type, mapper));
        }
        function instantiateSignature(signature, mapper, eraseTypeParameters) {
          var freshTypeParameters;
          if (signature.typeParameters && !eraseTypeParameters) {
            freshTypeParameters = ts2.map(signature.typeParameters, cloneTypeParameter);
            mapper = combineTypeMappers(createTypeMapper(signature.typeParameters, freshTypeParameters), mapper);
            for (var _i = 0, freshTypeParameters_1 = freshTypeParameters; _i < freshTypeParameters_1.length; _i++) {
              var tp = freshTypeParameters_1[_i];
              tp.mapper = mapper;
            }
          }
          var result = createSignature(signature.declaration, freshTypeParameters, signature.thisParameter && instantiateSymbol(signature.thisParameter, mapper), instantiateList(signature.parameters, mapper, instantiateSymbol), void 0, void 0, signature.minArgumentCount, signature.flags & 3);
          result.target = signature;
          result.mapper = mapper;
          return result;
        }
        function instantiateSymbol(symbol, mapper) {
          var links = getSymbolLinks(symbol);
          if (links.type && !couldContainTypeVariables(links.type)) {
            return symbol;
          }
          if (ts2.getCheckFlags(symbol) & 1) {
            symbol = links.target;
            mapper = combineTypeMappers(links.mapper, mapper);
          }
          var result = createSymbol(symbol.flags, symbol.escapedName, 1 | ts2.getCheckFlags(symbol) & (8 | 4096 | 16384 | 32768));
          result.declarations = symbol.declarations;
          result.parent = symbol.parent;
          result.target = symbol;
          result.mapper = mapper;
          if (symbol.valueDeclaration) {
            result.valueDeclaration = symbol.valueDeclaration;
          }
          if (links.nameType) {
            result.nameType = links.nameType;
          }
          return result;
        }
        function getObjectTypeInstantiation(type, mapper) {
          var target = type.objectFlags & 64 ? type.target : type;
          var node = type.objectFlags & 4 ? type.node : type.symbol.declarations[0];
          var links = getNodeLinks(node);
          var typeParameters = links.outerTypeParameters;
          if (!typeParameters) {
            var declaration_1 = node;
            if (ts2.isInJSFile(declaration_1)) {
              var paramTag = ts2.findAncestor(declaration_1, ts2.isJSDocParameterTag);
              if (paramTag) {
                var paramSymbol = ts2.getParameterSymbolFromJSDoc(paramTag);
                if (paramSymbol) {
                  declaration_1 = paramSymbol.valueDeclaration;
                }
              }
            }
            var outerTypeParameters = getOuterTypeParameters(declaration_1, true);
            if (isJSConstructor(declaration_1)) {
              var templateTagParameters = getTypeParametersFromDeclaration(declaration_1);
              outerTypeParameters = ts2.addRange(outerTypeParameters, templateTagParameters);
            }
            typeParameters = outerTypeParameters || ts2.emptyArray;
            typeParameters = (target.objectFlags & 4 || target.symbol.flags & 2048) && !target.aliasTypeArguments ? ts2.filter(typeParameters, function(tp) {
              return isTypeParameterPossiblyReferenced(tp, declaration_1);
            }) : typeParameters;
            links.outerTypeParameters = typeParameters;
            if (typeParameters.length) {
              links.instantiations = ts2.createMap();
              links.instantiations.set(getTypeListId(typeParameters), target);
            }
          }
          if (typeParameters.length) {
            var combinedMapper_1 = combineTypeMappers(type.mapper, mapper);
            var typeArguments = ts2.map(typeParameters, function(t) {
              return getMappedType(t, combinedMapper_1);
            });
            var id = getTypeListId(typeArguments);
            var result = links.instantiations.get(id);
            if (!result) {
              var newMapper = createTypeMapper(typeParameters, typeArguments);
              result = target.objectFlags & 4 ? createDeferredTypeReference(type.target, type.node, newMapper) : target.objectFlags & 32 ? instantiateMappedType(target, newMapper) : instantiateAnonymousType(target, newMapper);
              links.instantiations.set(id, result);
            }
            return result;
          }
          return type;
        }
        function maybeTypeParameterReference(node) {
          return !(node.kind === 153 || node.parent.kind === 169 && node.parent.typeArguments && node === node.parent.typeName || node.parent.kind === 188 && node.parent.typeArguments && node === node.parent.qualifier);
        }
        function isTypeParameterPossiblyReferenced(tp, node) {
          if (tp.symbol && tp.symbol.declarations && tp.symbol.declarations.length === 1) {
            var container = tp.symbol.declarations[0].parent;
            for (var n = node; n !== container; n = n.parent) {
              if (!n || n.kind === 223 || n.kind === 180 && ts2.forEachChild(n.extendsType, containsReference)) {
                return true;
              }
            }
            return !!ts2.forEachChild(node, containsReference);
          }
          return true;
          function containsReference(node2) {
            switch (node2.kind) {
              case 183:
                return !!tp.isThisType;
              case 75:
                return !tp.isThisType && ts2.isPartOfTypeNode(node2) && maybeTypeParameterReference(node2) && getTypeFromTypeNodeWorker(node2) === tp;
              case 172:
                return true;
            }
            return !!ts2.forEachChild(node2, containsReference);
          }
        }
        function getHomomorphicTypeVariable(type) {
          var constraintType = getConstraintTypeFromMappedType(type);
          if (constraintType.flags & 4194304) {
            var typeVariable = getActualTypeVariable(constraintType.type);
            if (typeVariable.flags & 262144) {
              return typeVariable;
            }
          }
          return void 0;
        }
        function instantiateMappedType(type, mapper) {
          var typeVariable = getHomomorphicTypeVariable(type);
          if (typeVariable) {
            var mappedTypeVariable = instantiateType(typeVariable, mapper);
            if (typeVariable !== mappedTypeVariable) {
              return mapType(getReducedType(mappedTypeVariable), function(t) {
                if (t.flags & (3 | 58982400 | 524288 | 2097152) && t !== wildcardType && t !== errorType) {
                  var replacementMapper = prependTypeMapping(typeVariable, t, mapper);
                  return isArrayType(t) ? instantiateMappedArrayType(t, type, replacementMapper) : isTupleType(t) ? instantiateMappedTupleType(t, type, replacementMapper) : instantiateAnonymousType(type, replacementMapper);
                }
                return t;
              });
            }
          }
          return instantiateAnonymousType(type, mapper);
        }
        function getModifiedReadonlyState(state, modifiers) {
          return modifiers & 1 ? true : modifiers & 2 ? false : state;
        }
        function instantiateMappedArrayType(arrayType, mappedType, mapper) {
          var elementType = instantiateMappedTypeTemplate(mappedType, numberType, true, mapper);
          return elementType === errorType ? errorType : createArrayType(elementType, getModifiedReadonlyState(isReadonlyArrayType(arrayType), getMappedTypeModifiers(mappedType)));
        }
        function instantiateMappedTupleType(tupleType, mappedType, mapper) {
          var minLength = tupleType.target.minLength;
          var elementTypes = ts2.map(getTypeArguments(tupleType), function(_, i) {
            return instantiateMappedTypeTemplate(mappedType, getLiteralType("" + i), i >= minLength, mapper);
          });
          var modifiers = getMappedTypeModifiers(mappedType);
          var newMinLength = modifiers & 4 ? 0 : modifiers & 8 ? getTypeReferenceArity(tupleType) - (tupleType.target.hasRestElement ? 1 : 0) : minLength;
          var newReadonly = getModifiedReadonlyState(tupleType.target.readonly, modifiers);
          return ts2.contains(elementTypes, errorType) ? errorType : createTupleType(elementTypes, newMinLength, tupleType.target.hasRestElement, newReadonly, tupleType.target.associatedNames);
        }
        function instantiateMappedTypeTemplate(type, key, isOptional, mapper) {
          var templateMapper = appendTypeMapping(mapper, getTypeParameterFromMappedType(type), key);
          var propType = instantiateType(getTemplateTypeFromMappedType(type.target || type), templateMapper);
          var modifiers = getMappedTypeModifiers(type);
          return strictNullChecks && modifiers & 4 && !maybeTypeOfKind(propType, 32768 | 16384) ? getOptionalType(propType) : strictNullChecks && modifiers & 8 && isOptional ? getTypeWithFacts(propType, 524288) : propType;
        }
        function instantiateAnonymousType(type, mapper) {
          var result = createObjectType(type.objectFlags | 64, type.symbol);
          if (type.objectFlags & 32) {
            result.declaration = type.declaration;
            var origTypeParameter = getTypeParameterFromMappedType(type);
            var freshTypeParameter = cloneTypeParameter(origTypeParameter);
            result.typeParameter = freshTypeParameter;
            mapper = combineTypeMappers(makeUnaryTypeMapper(origTypeParameter, freshTypeParameter), mapper);
            freshTypeParameter.mapper = mapper;
          }
          result.target = type;
          result.mapper = mapper;
          result.aliasSymbol = type.aliasSymbol;
          result.aliasTypeArguments = instantiateTypes(type.aliasTypeArguments, mapper);
          return result;
        }
        function getConditionalTypeInstantiation(type, mapper) {
          var root = type.root;
          if (root.outerTypeParameters) {
            var typeArguments = ts2.map(root.outerTypeParameters, function(t) {
              return getMappedType(t, mapper);
            });
            var id = getTypeListId(typeArguments);
            var result = root.instantiations.get(id);
            if (!result) {
              var newMapper = createTypeMapper(root.outerTypeParameters, typeArguments);
              result = instantiateConditionalType(root, newMapper);
              root.instantiations.set(id, result);
            }
            return result;
          }
          return type;
        }
        function instantiateConditionalType(root, mapper) {
          if (root.isDistributive) {
            var checkType_1 = root.checkType;
            var instantiatedType = getMappedType(checkType_1, mapper);
            if (checkType_1 !== instantiatedType && instantiatedType.flags & (1048576 | 131072)) {
              return mapType(instantiatedType, function(t) {
                return getConditionalType(root, prependTypeMapping(checkType_1, t, mapper));
              });
            }
          }
          return getConditionalType(root, mapper);
        }
        function instantiateType(type, mapper) {
          if (!type || !mapper) {
            return type;
          }
          if (instantiationDepth === 50 || instantiationCount >= 5e6) {
            error(currentNode, ts2.Diagnostics.Type_instantiation_is_excessively_deep_and_possibly_infinite);
            return errorType;
          }
          totalInstantiationCount++;
          instantiationCount++;
          instantiationDepth++;
          var result = instantiateTypeWorker(type, mapper);
          instantiationDepth--;
          return result;
        }
        function instantiateTypeWithoutDepthIncrease(type, mapper) {
          instantiationDepth--;
          var result = instantiateType(type, mapper);
          instantiationDepth++;
          return result;
        }
        function instantiateTypeWorker(type, mapper) {
          var flags = type.flags;
          if (flags & 262144) {
            return getMappedType(type, mapper);
          }
          if (flags & 524288) {
            var objectFlags = type.objectFlags;
            if (objectFlags & 16) {
              return couldContainTypeVariables(type) ? getObjectTypeInstantiation(type, mapper) : type;
            }
            if (objectFlags & 32) {
              return getObjectTypeInstantiation(type, mapper);
            }
            if (objectFlags & 4) {
              if (type.node) {
                return getObjectTypeInstantiation(type, mapper);
              }
              var resolvedTypeArguments = type.resolvedTypeArguments;
              var newTypeArguments = instantiateTypes(resolvedTypeArguments, mapper);
              return newTypeArguments !== resolvedTypeArguments ? createTypeReference(type.target, newTypeArguments) : type;
            }
            return type;
          }
          if (flags & 2097152 || flags & 1048576 && !(flags & 131068)) {
            if (!couldContainTypeVariables(type)) {
              return type;
            }
            var types = type.types;
            var newTypes = instantiateTypes(types, mapper);
            return newTypes === types ? type : flags & 2097152 ? getIntersectionType(newTypes, type.aliasSymbol, instantiateTypes(type.aliasTypeArguments, mapper)) : getUnionType(newTypes, 1, type.aliasSymbol, instantiateTypes(type.aliasTypeArguments, mapper));
          }
          if (flags & 4194304) {
            return getIndexType(instantiateType(type.type, mapper));
          }
          if (flags & 8388608) {
            return getIndexedAccessType(instantiateType(type.objectType, mapper), instantiateType(type.indexType, mapper), void 0, type.aliasSymbol, instantiateTypes(type.aliasTypeArguments, mapper));
          }
          if (flags & 16777216) {
            return getConditionalTypeInstantiation(type, combineTypeMappers(type.mapper, mapper));
          }
          if (flags & 33554432) {
            var maybeVariable = instantiateType(type.baseType, mapper);
            if (maybeVariable.flags & 8650752) {
              return getSubstitutionType(maybeVariable, instantiateType(type.substitute, mapper));
            } else {
              var sub = instantiateType(type.substitute, mapper);
              if (sub.flags & 3 || isTypeAssignableTo(getRestrictiveInstantiation(maybeVariable), getRestrictiveInstantiation(sub))) {
                return maybeVariable;
              }
              return sub;
            }
          }
          return type;
        }
        function getPermissiveInstantiation(type) {
          return type.flags & (131068 | 3 | 131072) ? type : type.permissiveInstantiation || (type.permissiveInstantiation = instantiateType(type, permissiveMapper));
        }
        function getRestrictiveInstantiation(type) {
          if (type.flags & (131068 | 3 | 131072)) {
            return type;
          }
          if (type.restrictiveInstantiation) {
            return type.restrictiveInstantiation;
          }
          type.restrictiveInstantiation = instantiateType(type, restrictiveMapper);
          type.restrictiveInstantiation.restrictiveInstantiation = type.restrictiveInstantiation;
          return type.restrictiveInstantiation;
        }
        function instantiateIndexInfo(info, mapper) {
          return info && createIndexInfo(instantiateType(info.type, mapper), info.isReadonly, info.declaration);
        }
        function isContextSensitive(node) {
          ts2.Debug.assert(node.kind !== 161 || ts2.isObjectLiteralMethod(node));
          switch (node.kind) {
            case 201:
            case 202:
            case 161:
            case 244:
              return isContextSensitiveFunctionLikeDeclaration(node);
            case 193:
              return ts2.some(node.properties, isContextSensitive);
            case 192:
              return ts2.some(node.elements, isContextSensitive);
            case 210:
              return isContextSensitive(node.whenTrue) || isContextSensitive(node.whenFalse);
            case 209:
              return (node.operatorToken.kind === 56 || node.operatorToken.kind === 60) && (isContextSensitive(node.left) || isContextSensitive(node.right));
            case 281:
              return isContextSensitive(node.initializer);
            case 200:
              return isContextSensitive(node.expression);
            case 274:
              return ts2.some(node.properties, isContextSensitive) || ts2.isJsxOpeningElement(node.parent) && ts2.some(node.parent.parent.children, isContextSensitive);
            case 273: {
              var initializer = node.initializer;
              return !!initializer && isContextSensitive(initializer);
            }
            case 276: {
              var expression = node.expression;
              return !!expression && isContextSensitive(expression);
            }
          }
          return false;
        }
        function isContextSensitiveFunctionLikeDeclaration(node) {
          return (!ts2.isFunctionDeclaration(node) || ts2.isInJSFile(node) && !!getTypeForDeclarationFromJSDocComment(node)) && (hasContextSensitiveParameters(node) || hasContextSensitiveReturnExpression(node));
        }
        function hasContextSensitiveParameters(node) {
          if (!node.typeParameters) {
            if (ts2.some(node.parameters, function(p) {
              return !ts2.getEffectiveTypeAnnotationNode(p);
            })) {
              return true;
            }
            if (node.kind !== 202) {
              var parameter = ts2.firstOrUndefined(node.parameters);
              if (!(parameter && ts2.parameterIsThisKeyword(parameter))) {
                return true;
              }
            }
          }
          return false;
        }
        function hasContextSensitiveReturnExpression(node) {
          return !node.typeParameters && !ts2.getEffectiveReturnTypeNode(node) && !!node.body && node.body.kind !== 223 && isContextSensitive(node.body);
        }
        function isContextSensitiveFunctionOrObjectLiteralMethod(func) {
          return (ts2.isInJSFile(func) && ts2.isFunctionDeclaration(func) || isFunctionExpressionOrArrowFunction(func) || ts2.isObjectLiteralMethod(func)) && isContextSensitiveFunctionLikeDeclaration(func);
        }
        function getTypeWithoutSignatures(type) {
          if (type.flags & 524288) {
            var resolved = resolveStructuredTypeMembers(type);
            if (resolved.constructSignatures.length || resolved.callSignatures.length) {
              var result = createObjectType(16, type.symbol);
              result.members = resolved.members;
              result.properties = resolved.properties;
              result.callSignatures = ts2.emptyArray;
              result.constructSignatures = ts2.emptyArray;
              return result;
            }
          } else if (type.flags & 2097152) {
            return getIntersectionType(ts2.map(type.types, getTypeWithoutSignatures));
          }
          return type;
        }
        function isTypeIdenticalTo(source, target) {
          return isTypeRelatedTo(source, target, identityRelation);
        }
        function compareTypesIdentical(source, target) {
          return isTypeRelatedTo(source, target, identityRelation) ? -1 : 0;
        }
        function compareTypesAssignable(source, target) {
          return isTypeRelatedTo(source, target, assignableRelation) ? -1 : 0;
        }
        function compareTypesSubtypeOf(source, target) {
          return isTypeRelatedTo(source, target, subtypeRelation) ? -1 : 0;
        }
        function isTypeSubtypeOf(source, target) {
          return isTypeRelatedTo(source, target, subtypeRelation);
        }
        function isTypeAssignableTo(source, target) {
          return isTypeRelatedTo(source, target, assignableRelation);
        }
        function isTypeDerivedFrom(source, target) {
          return source.flags & 1048576 ? ts2.every(source.types, function(t) {
            return isTypeDerivedFrom(t, target);
          }) : target.flags & 1048576 ? ts2.some(target.types, function(t) {
            return isTypeDerivedFrom(source, t);
          }) : source.flags & 58982400 ? isTypeDerivedFrom(getBaseConstraintOfType(source) || unknownType, target) : target === globalObjectType ? !!(source.flags & (524288 | 67108864)) : target === globalFunctionType ? !!(source.flags & 524288) && isFunctionObjectType(source) : hasBaseType(source, getTargetType(target));
        }
        function isTypeComparableTo(source, target) {
          return isTypeRelatedTo(source, target, comparableRelation);
        }
        function areTypesComparable(type1, type2) {
          return isTypeComparableTo(type1, type2) || isTypeComparableTo(type2, type1);
        }
        function checkTypeAssignableTo(source, target, errorNode, headMessage, containingMessageChain, errorOutputObject) {
          return checkTypeRelatedTo(source, target, assignableRelation, errorNode, headMessage, containingMessageChain, errorOutputObject);
        }
        function checkTypeAssignableToAndOptionallyElaborate(source, target, errorNode, expr, headMessage, containingMessageChain) {
          return checkTypeRelatedToAndOptionallyElaborate(source, target, assignableRelation, errorNode, expr, headMessage, containingMessageChain, void 0);
        }
        function checkTypeRelatedToAndOptionallyElaborate(source, target, relation, errorNode, expr, headMessage, containingMessageChain, errorOutputContainer) {
          if (isTypeRelatedTo(source, target, relation))
            return true;
          if (!errorNode || !elaborateError(expr, source, target, relation, headMessage, containingMessageChain, errorOutputContainer)) {
            return checkTypeRelatedTo(source, target, relation, errorNode, headMessage, containingMessageChain, errorOutputContainer);
          }
          return false;
        }
        function isOrHasGenericConditional(type) {
          return !!(type.flags & 16777216 || type.flags & 2097152 && ts2.some(type.types, isOrHasGenericConditional));
        }
        function elaborateError(node, source, target, relation, headMessage, containingMessageChain, errorOutputContainer) {
          if (!node || isOrHasGenericConditional(target))
            return false;
          if (!checkTypeRelatedTo(source, target, relation, void 0) && elaborateDidYouMeanToCallOrConstruct(node, source, target, relation, headMessage, containingMessageChain, errorOutputContainer)) {
            return true;
          }
          switch (node.kind) {
            case 276:
            case 200:
              return elaborateError(node.expression, source, target, relation, headMessage, containingMessageChain, errorOutputContainer);
            case 209:
              switch (node.operatorToken.kind) {
                case 62:
                case 27:
                  return elaborateError(node.right, source, target, relation, headMessage, containingMessageChain, errorOutputContainer);
              }
              break;
            case 193:
              return elaborateObjectLiteral(node, source, target, relation, containingMessageChain, errorOutputContainer);
            case 192:
              return elaborateArrayLiteral(node, source, target, relation, containingMessageChain, errorOutputContainer);
            case 274:
              return elaborateJsxComponents(node, source, target, relation, containingMessageChain, errorOutputContainer);
            case 202:
              return elaborateArrowFunction(node, source, target, relation, containingMessageChain, errorOutputContainer);
          }
          return false;
        }
        function elaborateDidYouMeanToCallOrConstruct(node, source, target, relation, headMessage, containingMessageChain, errorOutputContainer) {
          var callSignatures = getSignaturesOfType(source, 0);
          var constructSignatures = getSignaturesOfType(source, 1);
          for (var _i = 0, _a = [constructSignatures, callSignatures]; _i < _a.length; _i++) {
            var signatures = _a[_i];
            if (ts2.some(signatures, function(s) {
              var returnType = getReturnTypeOfSignature(s);
              return !(returnType.flags & (1 | 131072)) && checkTypeRelatedTo(returnType, target, relation, void 0);
            })) {
              var resultObj = errorOutputContainer || {};
              checkTypeAssignableTo(source, target, node, headMessage, containingMessageChain, resultObj);
              var diagnostic = resultObj.errors[resultObj.errors.length - 1];
              ts2.addRelatedInfo(diagnostic, ts2.createDiagnosticForNode(node, signatures === constructSignatures ? ts2.Diagnostics.Did_you_mean_to_use_new_with_this_expression : ts2.Diagnostics.Did_you_mean_to_call_this_expression));
              return true;
            }
          }
          return false;
        }
        function elaborateArrowFunction(node, source, target, relation, containingMessageChain, errorOutputContainer) {
          if (ts2.isBlock(node.body)) {
            return false;
          }
          if (ts2.some(node.parameters, ts2.hasType)) {
            return false;
          }
          var sourceSig = getSingleCallSignature(source);
          if (!sourceSig) {
            return false;
          }
          var targetSignatures = getSignaturesOfType(target, 0);
          if (!ts2.length(targetSignatures)) {
            return false;
          }
          var returnExpression = node.body;
          var sourceReturn = getReturnTypeOfSignature(sourceSig);
          var targetReturn = getUnionType(ts2.map(targetSignatures, getReturnTypeOfSignature));
          if (!checkTypeRelatedTo(sourceReturn, targetReturn, relation, void 0)) {
            var elaborated = returnExpression && elaborateError(returnExpression, sourceReturn, targetReturn, relation, void 0, containingMessageChain, errorOutputContainer);
            if (elaborated) {
              return elaborated;
            }
            var resultObj = errorOutputContainer || {};
            checkTypeRelatedTo(sourceReturn, targetReturn, relation, returnExpression, void 0, containingMessageChain, resultObj);
            if (resultObj.errors) {
              if (target.symbol && ts2.length(target.symbol.declarations)) {
                ts2.addRelatedInfo(resultObj.errors[resultObj.errors.length - 1], ts2.createDiagnosticForNode(target.symbol.declarations[0], ts2.Diagnostics.The_expected_type_comes_from_the_return_type_of_this_signature));
              }
              if ((ts2.getFunctionFlags(node) & 2) === 0 && !getTypeOfPropertyOfType(sourceReturn, "then") && checkTypeRelatedTo(createPromiseType(sourceReturn), targetReturn, relation, void 0)) {
                ts2.addRelatedInfo(resultObj.errors[resultObj.errors.length - 1], ts2.createDiagnosticForNode(node, ts2.Diagnostics.Did_you_mean_to_mark_this_function_as_async));
              }
              return true;
            }
          }
          return false;
        }
        function getBestMatchIndexedAccessTypeOrUndefined(source, target, nameType) {
          var idx = getIndexedAccessTypeOrUndefined(target, nameType);
          if (idx) {
            return idx;
          }
          if (target.flags & 1048576) {
            var best = getBestMatchingType(source, target);
            if (best) {
              return getIndexedAccessTypeOrUndefined(best, nameType);
            }
          }
        }
        function checkExpressionForMutableLocationWithContextualType(next, sourcePropType) {
          next.contextualType = sourcePropType;
          try {
            return checkExpressionForMutableLocation(next, 1, sourcePropType);
          } finally {
            next.contextualType = void 0;
          }
        }
        function elaborateElementwise(iterator, source, target, relation, containingMessageChain, errorOutputContainer) {
          var reportedError = false;
          for (var status = iterator.next(); !status.done; status = iterator.next()) {
            var _a = status.value, prop = _a.errorNode, next = _a.innerExpression, nameType = _a.nameType, errorMessage = _a.errorMessage;
            var targetPropType = getBestMatchIndexedAccessTypeOrUndefined(source, target, nameType);
            if (!targetPropType || targetPropType.flags & 8388608)
              continue;
            var sourcePropType = getIndexedAccessTypeOrUndefined(source, nameType);
            if (sourcePropType && !checkTypeRelatedTo(sourcePropType, targetPropType, relation, void 0)) {
              var elaborated = next && elaborateError(next, sourcePropType, targetPropType, relation, void 0, containingMessageChain, errorOutputContainer);
              if (elaborated) {
                reportedError = true;
              } else {
                var resultObj = errorOutputContainer || {};
                var specificSource = next ? checkExpressionForMutableLocationWithContextualType(next, sourcePropType) : sourcePropType;
                var result = checkTypeRelatedTo(specificSource, targetPropType, relation, prop, errorMessage, containingMessageChain, resultObj);
                if (result && specificSource !== sourcePropType) {
                  checkTypeRelatedTo(sourcePropType, targetPropType, relation, prop, errorMessage, containingMessageChain, resultObj);
                }
                if (resultObj.errors) {
                  var reportedDiag = resultObj.errors[resultObj.errors.length - 1];
                  var propertyName = isTypeUsableAsPropertyName(nameType) ? getPropertyNameFromType(nameType) : void 0;
                  var targetProp = propertyName !== void 0 ? getPropertyOfType(target, propertyName) : void 0;
                  var issuedElaboration = false;
                  if (!targetProp) {
                    var indexInfo = isTypeAssignableToKind(nameType, 296) && getIndexInfoOfType(target, 1) || getIndexInfoOfType(target, 0) || void 0;
                    if (indexInfo && indexInfo.declaration && !ts2.getSourceFileOfNode(indexInfo.declaration).hasNoDefaultLib) {
                      issuedElaboration = true;
                      ts2.addRelatedInfo(reportedDiag, ts2.createDiagnosticForNode(indexInfo.declaration, ts2.Diagnostics.The_expected_type_comes_from_this_index_signature));
                    }
                  }
                  if (!issuedElaboration && (targetProp && ts2.length(targetProp.declarations) || target.symbol && ts2.length(target.symbol.declarations))) {
                    var targetNode = targetProp && ts2.length(targetProp.declarations) ? targetProp.declarations[0] : target.symbol.declarations[0];
                    if (!ts2.getSourceFileOfNode(targetNode).hasNoDefaultLib) {
                      ts2.addRelatedInfo(reportedDiag, ts2.createDiagnosticForNode(targetNode, ts2.Diagnostics.The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1, propertyName && !(nameType.flags & 8192) ? ts2.unescapeLeadingUnderscores(propertyName) : typeToString(nameType), typeToString(target)));
                    }
                  }
                }
                reportedError = true;
              }
            }
          }
          return reportedError;
        }
        function generateJsxAttributes(node) {
          var _i, _a, prop;
          return __generator(this, function(_b) {
            switch (_b.label) {
              case 0:
                if (!ts2.length(node.properties))
                  return [2];
                _i = 0, _a = node.properties;
                _b.label = 1;
              case 1:
                if (!(_i < _a.length))
                  return [3, 4];
                prop = _a[_i];
                if (ts2.isJsxSpreadAttribute(prop))
                  return [3, 3];
                return [4, { errorNode: prop.name, innerExpression: prop.initializer, nameType: getLiteralType(ts2.idText(prop.name)) }];
              case 2:
                _b.sent();
                _b.label = 3;
              case 3:
                _i++;
                return [3, 1];
              case 4:
                return [2];
            }
          });
        }
        function generateJsxChildren(node, getInvalidTextDiagnostic) {
          var memberOffset, i, child, nameType, elem;
          return __generator(this, function(_a) {
            switch (_a.label) {
              case 0:
                if (!ts2.length(node.children))
                  return [2];
                memberOffset = 0;
                i = 0;
                _a.label = 1;
              case 1:
                if (!(i < node.children.length))
                  return [3, 5];
                child = node.children[i];
                nameType = getLiteralType(i - memberOffset);
                elem = getElaborationElementForJsxChild(child, nameType, getInvalidTextDiagnostic);
                if (!elem)
                  return [3, 3];
                return [4, elem];
              case 2:
                _a.sent();
                return [3, 4];
              case 3:
                memberOffset++;
                _a.label = 4;
              case 4:
                i++;
                return [3, 1];
              case 5:
                return [2];
            }
          });
        }
        function getElaborationElementForJsxChild(child, nameType, getInvalidTextDiagnostic) {
          switch (child.kind) {
            case 276:
              return { errorNode: child, innerExpression: child.expression, nameType };
            case 11:
              if (child.containsOnlyTriviaWhiteSpaces) {
                break;
              }
              return { errorNode: child, innerExpression: void 0, nameType, errorMessage: getInvalidTextDiagnostic() };
            case 266:
            case 267:
            case 270:
              return { errorNode: child, innerExpression: child, nameType };
            default:
              return ts2.Debug.assertNever(child, "Found invalid jsx child");
          }
        }
        function getSemanticJsxChildren(children) {
          return ts2.filter(children, function(i) {
            return !ts2.isJsxText(i) || !i.containsOnlyTriviaWhiteSpaces;
          });
        }
        function elaborateJsxComponents(node, source, target, relation, containingMessageChain, errorOutputContainer) {
          var result = elaborateElementwise(generateJsxAttributes(node), source, target, relation, containingMessageChain, errorOutputContainer);
          var invalidTextDiagnostic;
          if (ts2.isJsxOpeningElement(node.parent) && ts2.isJsxElement(node.parent.parent)) {
            var containingElement = node.parent.parent;
            var childPropName = getJsxElementChildrenPropertyName(getJsxNamespaceAt(node));
            var childrenPropName = childPropName === void 0 ? "children" : ts2.unescapeLeadingUnderscores(childPropName);
            var childrenNameType = getLiteralType(childrenPropName);
            var childrenTargetType = getIndexedAccessType(target, childrenNameType);
            var validChildren = getSemanticJsxChildren(containingElement.children);
            if (!ts2.length(validChildren)) {
              return result;
            }
            var moreThanOneRealChildren = ts2.length(validChildren) > 1;
            var arrayLikeTargetParts = filterType(childrenTargetType, isArrayOrTupleLikeType);
            var nonArrayLikeTargetParts = filterType(childrenTargetType, function(t) {
              return !isArrayOrTupleLikeType(t);
            });
            if (moreThanOneRealChildren) {
              if (arrayLikeTargetParts !== neverType) {
                var realSource = createTupleType(checkJsxChildren(containingElement, 0));
                var children = generateJsxChildren(containingElement, getInvalidTextualChildDiagnostic);
                result = elaborateElementwise(children, realSource, arrayLikeTargetParts, relation, containingMessageChain, errorOutputContainer) || result;
              } else if (!isTypeRelatedTo(getIndexedAccessType(source, childrenNameType), childrenTargetType, relation)) {
                result = true;
                var diag = error(containingElement.openingElement.tagName, ts2.Diagnostics.This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided, childrenPropName, typeToString(childrenTargetType));
                if (errorOutputContainer && errorOutputContainer.skipLogging) {
                  (errorOutputContainer.errors || (errorOutputContainer.errors = [])).push(diag);
                }
              }
            } else {
              if (nonArrayLikeTargetParts !== neverType) {
                var child = validChildren[0];
                var elem_1 = getElaborationElementForJsxChild(child, childrenNameType, getInvalidTextualChildDiagnostic);
                if (elem_1) {
                  result = elaborateElementwise(function() {
                    return __generator(this, function(_a) {
                      switch (_a.label) {
                        case 0:
                          return [4, elem_1];
                        case 1:
                          _a.sent();
                          return [2];
                      }
                    });
                  }(), source, target, relation, containingMessageChain, errorOutputContainer) || result;
                }
              } else if (!isTypeRelatedTo(getIndexedAccessType(source, childrenNameType), childrenTargetType, relation)) {
                result = true;
                var diag = error(containingElement.openingElement.tagName, ts2.Diagnostics.This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_provided, childrenPropName, typeToString(childrenTargetType));
                if (errorOutputContainer && errorOutputContainer.skipLogging) {
                  (errorOutputContainer.errors || (errorOutputContainer.errors = [])).push(diag);
                }
              }
            }
          }
          return result;
          function getInvalidTextualChildDiagnostic() {
            if (!invalidTextDiagnostic) {
              var tagNameText = ts2.getTextOfNode(node.parent.tagName);
              var childPropName2 = getJsxElementChildrenPropertyName(getJsxNamespaceAt(node));
              var childrenPropName2 = childPropName2 === void 0 ? "children" : ts2.unescapeLeadingUnderscores(childPropName2);
              var childrenTargetType2 = getIndexedAccessType(target, getLiteralType(childrenPropName2));
              var diagnostic = ts2.Diagnostics._0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_type_of_1_is_2;
              invalidTextDiagnostic = __assign(__assign({}, diagnostic), { key: "!!ALREADY FORMATTED!!", message: ts2.formatMessage(void 0, diagnostic, tagNameText, childrenPropName2, typeToString(childrenTargetType2)) });
            }
            return invalidTextDiagnostic;
          }
        }
        function generateLimitedTupleElements(node, target) {
          var len, i, elem, nameType;
          return __generator(this, function(_a) {
            switch (_a.label) {
              case 0:
                len = ts2.length(node.elements);
                if (!len)
                  return [2];
                i = 0;
                _a.label = 1;
              case 1:
                if (!(i < len))
                  return [3, 4];
                if (isTupleLikeType(target) && !getPropertyOfType(target, "" + i))
                  return [3, 3];
                elem = node.elements[i];
                if (ts2.isOmittedExpression(elem))
                  return [3, 3];
                nameType = getLiteralType(i);
                return [4, { errorNode: elem, innerExpression: elem, nameType }];
              case 2:
                _a.sent();
                _a.label = 3;
              case 3:
                i++;
                return [3, 1];
              case 4:
                return [2];
            }
          });
        }
        function elaborateArrayLiteral(node, source, target, relation, containingMessageChain, errorOutputContainer) {
          if (target.flags & 131068)
            return false;
          if (isTupleLikeType(source)) {
            return elaborateElementwise(generateLimitedTupleElements(node, target), source, target, relation, containingMessageChain, errorOutputContainer);
          }
          var oldContext = node.contextualType;
          node.contextualType = target;
          try {
            var tupleizedType = checkArrayLiteral(node, 1, true);
            node.contextualType = oldContext;
            if (isTupleLikeType(tupleizedType)) {
              return elaborateElementwise(generateLimitedTupleElements(node, target), tupleizedType, target, relation, containingMessageChain, errorOutputContainer);
            }
            return false;
          } finally {
            node.contextualType = oldContext;
          }
        }
        function generateObjectLiteralElements(node) {
          var _i, _a, prop, type, _b;
          return __generator(this, function(_c) {
            switch (_c.label) {
              case 0:
                if (!ts2.length(node.properties))
                  return [2];
                _i = 0, _a = node.properties;
                _c.label = 1;
              case 1:
                if (!(_i < _a.length))
                  return [3, 8];
                prop = _a[_i];
                if (ts2.isSpreadAssignment(prop))
                  return [3, 7];
                type = getLiteralTypeFromProperty(getSymbolOfNode(prop), 8576);
                if (!type || type.flags & 131072) {
                  return [3, 7];
                }
                _b = prop.kind;
                switch (_b) {
                  case 164:
                    return [3, 2];
                  case 163:
                    return [3, 2];
                  case 161:
                    return [3, 2];
                  case 282:
                    return [3, 2];
                  case 281:
                    return [3, 4];
                }
                return [3, 6];
              case 2:
                return [4, { errorNode: prop.name, innerExpression: void 0, nameType: type }];
              case 3:
                _c.sent();
                return [3, 7];
              case 4:
                return [4, { errorNode: prop.name, innerExpression: prop.initializer, nameType: type, errorMessage: ts2.isComputedNonLiteralName(prop.name) ? ts2.Diagnostics.Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1 : void 0 }];
              case 5:
                _c.sent();
                return [3, 7];
              case 6:
                ts2.Debug.assertNever(prop);
                _c.label = 7;
              case 7:
                _i++;
                return [3, 1];
              case 8:
                return [2];
            }
          });
        }
        function elaborateObjectLiteral(node, source, target, relation, containingMessageChain, errorOutputContainer) {
          if (target.flags & 131068)
            return false;
          return elaborateElementwise(generateObjectLiteralElements(node), source, target, relation, containingMessageChain, errorOutputContainer);
        }
        function checkTypeComparableTo(source, target, errorNode, headMessage, containingMessageChain) {
          return checkTypeRelatedTo(source, target, comparableRelation, errorNode, headMessage, containingMessageChain);
        }
        function isSignatureAssignableTo(source, target, ignoreReturnTypes) {
          return compareSignaturesRelated(source, target, ignoreReturnTypes ? 4 : 0, false, void 0, void 0, compareTypesAssignable, void 0) !== 0;
        }
        function isAnySignature(s) {
          return !s.typeParameters && (!s.thisParameter || isTypeAny(getTypeOfParameter(s.thisParameter))) && s.parameters.length === 1 && signatureHasRestParameter(s) && (getTypeOfParameter(s.parameters[0]) === anyArrayType || isTypeAny(getTypeOfParameter(s.parameters[0]))) && isTypeAny(getReturnTypeOfSignature(s));
        }
        function compareSignaturesRelated(source, target, checkMode, reportErrors, errorReporter, incompatibleErrorReporter, compareTypes, reportUnreliableMarkers) {
          if (source === target) {
            return -1;
          }
          if (isAnySignature(target)) {
            return -1;
          }
          var targetCount = getParameterCount(target);
          var sourceHasMoreParameters = !hasEffectiveRestParameter(target) && (checkMode & 8 ? hasEffectiveRestParameter(source) || getParameterCount(source) > targetCount : getMinArgumentCount(source) > targetCount);
          if (sourceHasMoreParameters) {
            return 0;
          }
          if (source.typeParameters && source.typeParameters !== target.typeParameters) {
            target = getCanonicalSignature(target);
            source = instantiateSignatureInContextOf(source, target, void 0, compareTypes);
          }
          var sourceCount = getParameterCount(source);
          var sourceRestType = getNonArrayRestType(source);
          var targetRestType = getNonArrayRestType(target);
          if (sourceRestType || targetRestType) {
            void instantiateType(sourceRestType || targetRestType, reportUnreliableMarkers);
          }
          if (sourceRestType && targetRestType && sourceCount !== targetCount) {
            return 0;
          }
          var kind = target.declaration ? target.declaration.kind : 0;
          var strictVariance = !(checkMode & 3) && strictFunctionTypes && kind !== 161 && kind !== 160 && kind !== 162;
          var result = -1;
          var sourceThisType = getThisTypeOfSignature(source);
          if (sourceThisType && sourceThisType !== voidType) {
            var targetThisType = getThisTypeOfSignature(target);
            if (targetThisType) {
              var related = !strictVariance && compareTypes(sourceThisType, targetThisType, false) || compareTypes(targetThisType, sourceThisType, reportErrors);
              if (!related) {
                if (reportErrors) {
                  errorReporter(ts2.Diagnostics.The_this_types_of_each_signature_are_incompatible);
                }
                return 0;
              }
              result &= related;
            }
          }
          var paramCount = sourceRestType || targetRestType ? Math.min(sourceCount, targetCount) : Math.max(sourceCount, targetCount);
          var restIndex = sourceRestType || targetRestType ? paramCount - 1 : -1;
          for (var i = 0; i < paramCount; i++) {
            var sourceType = i === restIndex ? getRestTypeAtPosition(source, i) : getTypeAtPosition(source, i);
            var targetType = i === restIndex ? getRestTypeAtPosition(target, i) : getTypeAtPosition(target, i);
            var sourceSig = checkMode & 3 ? void 0 : getSingleCallSignature(getNonNullableType(sourceType));
            var targetSig = checkMode & 3 ? void 0 : getSingleCallSignature(getNonNullableType(targetType));
            var callbacks = sourceSig && targetSig && !getTypePredicateOfSignature(sourceSig) && !getTypePredicateOfSignature(targetSig) && (getFalsyFlags(sourceType) & 98304) === (getFalsyFlags(targetType) & 98304);
            var related = callbacks ? compareSignaturesRelated(targetSig, sourceSig, checkMode & 8 | (strictVariance ? 2 : 1), reportErrors, errorReporter, incompatibleErrorReporter, compareTypes, reportUnreliableMarkers) : !(checkMode & 3) && !strictVariance && compareTypes(sourceType, targetType, false) || compareTypes(targetType, sourceType, reportErrors);
            if (related && checkMode & 8 && i >= getMinArgumentCount(source) && i < getMinArgumentCount(target) && compareTypes(sourceType, targetType, false)) {
              related = 0;
            }
            if (!related) {
              if (reportErrors) {
                errorReporter(ts2.Diagnostics.Types_of_parameters_0_and_1_are_incompatible, ts2.unescapeLeadingUnderscores(getParameterNameAtPosition(source, i)), ts2.unescapeLeadingUnderscores(getParameterNameAtPosition(target, i)));
              }
              return 0;
            }
            result &= related;
          }
          if (!(checkMode & 4)) {
            var targetReturnType = isResolvingReturnTypeOfSignature(target) ? anyType : target.declaration && isJSConstructor(target.declaration) ? getDeclaredTypeOfClassOrInterface(getMergedSymbol(target.declaration.symbol)) : getReturnTypeOfSignature(target);
            if (targetReturnType === voidType) {
              return result;
            }
            var sourceReturnType = isResolvingReturnTypeOfSignature(source) ? anyType : source.declaration && isJSConstructor(source.declaration) ? getDeclaredTypeOfClassOrInterface(getMergedSymbol(source.declaration.symbol)) : getReturnTypeOfSignature(source);
            var targetTypePredicate = getTypePredicateOfSignature(target);
            if (targetTypePredicate) {
              var sourceTypePredicate = getTypePredicateOfSignature(source);
              if (sourceTypePredicate) {
                result &= compareTypePredicateRelatedTo(sourceTypePredicate, targetTypePredicate, reportErrors, errorReporter, compareTypes);
              } else if (ts2.isIdentifierTypePredicate(targetTypePredicate)) {
                if (reportErrors) {
                  errorReporter(ts2.Diagnostics.Signature_0_must_be_a_type_predicate, signatureToString(source));
                }
                return 0;
              }
            } else {
              result &= checkMode & 1 && compareTypes(targetReturnType, sourceReturnType, false) || compareTypes(sourceReturnType, targetReturnType, reportErrors);
              if (!result && reportErrors && incompatibleErrorReporter) {
                incompatibleErrorReporter(sourceReturnType, targetReturnType);
              }
            }
          }
          return result;
        }
        function compareTypePredicateRelatedTo(source, target, reportErrors, errorReporter, compareTypes) {
          if (source.kind !== target.kind) {
            if (reportErrors) {
              errorReporter(ts2.Diagnostics.A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard);
              errorReporter(ts2.Diagnostics.Type_predicate_0_is_not_assignable_to_1, typePredicateToString(source), typePredicateToString(target));
            }
            return 0;
          }
          if (source.kind === 1 || source.kind === 3) {
            if (source.parameterIndex !== target.parameterIndex) {
              if (reportErrors) {
                errorReporter(ts2.Diagnostics.Parameter_0_is_not_in_the_same_position_as_parameter_1, source.parameterName, target.parameterName);
                errorReporter(ts2.Diagnostics.Type_predicate_0_is_not_assignable_to_1, typePredicateToString(source), typePredicateToString(target));
              }
              return 0;
            }
          }
          var related = source.type === target.type ? -1 : source.type && target.type ? compareTypes(source.type, target.type, reportErrors) : 0;
          if (related === 0 && reportErrors) {
            errorReporter(ts2.Diagnostics.Type_predicate_0_is_not_assignable_to_1, typePredicateToString(source), typePredicateToString(target));
          }
          return related;
        }
        function isImplementationCompatibleWithOverload(implementation, overload) {
          var erasedSource = getErasedSignature(implementation);
          var erasedTarget = getErasedSignature(overload);
          var sourceReturnType = getReturnTypeOfSignature(erasedSource);
          var targetReturnType = getReturnTypeOfSignature(erasedTarget);
          if (targetReturnType === voidType || isTypeRelatedTo(targetReturnType, sourceReturnType, assignableRelation) || isTypeRelatedTo(sourceReturnType, targetReturnType, assignableRelation)) {
            return isSignatureAssignableTo(erasedSource, erasedTarget, true);
          }
          return false;
        }
        function isEmptyResolvedType(t) {
          return t !== anyFunctionType && t.properties.length === 0 && t.callSignatures.length === 0 && t.constructSignatures.length === 0 && !t.stringIndexInfo && !t.numberIndexInfo;
        }
        function isEmptyObjectType(type) {
          return type.flags & 524288 ? !isGenericMappedType(type) && isEmptyResolvedType(resolveStructuredTypeMembers(type)) : type.flags & 67108864 ? true : type.flags & 1048576 ? ts2.some(type.types, isEmptyObjectType) : type.flags & 2097152 ? ts2.every(type.types, isEmptyObjectType) : false;
        }
        function isEmptyAnonymousObjectType(type) {
          return !!(ts2.getObjectFlags(type) & 16) && isEmptyObjectType(type);
        }
        function isStringIndexSignatureOnlyType(type) {
          return type.flags & 524288 && !isGenericMappedType(type) && getPropertiesOfType(type).length === 0 && getIndexInfoOfType(type, 0) && !getIndexInfoOfType(type, 1) || type.flags & 3145728 && ts2.every(type.types, isStringIndexSignatureOnlyType) || false;
        }
        function isEnumTypeRelatedTo(sourceSymbol, targetSymbol, errorReporter) {
          if (sourceSymbol === targetSymbol) {
            return true;
          }
          var id = getSymbolId(sourceSymbol) + "," + getSymbolId(targetSymbol);
          var entry = enumRelation.get(id);
          if (entry !== void 0 && !(!(entry & 4) && entry & 2 && errorReporter)) {
            return !!(entry & 1);
          }
          if (sourceSymbol.escapedName !== targetSymbol.escapedName || !(sourceSymbol.flags & 256) || !(targetSymbol.flags & 256)) {
            enumRelation.set(id, 2 | 4);
            return false;
          }
          var targetEnumType = getTypeOfSymbol(targetSymbol);
          for (var _i = 0, _a = getPropertiesOfType(getTypeOfSymbol(sourceSymbol)); _i < _a.length; _i++) {
            var property = _a[_i];
            if (property.flags & 8) {
              var targetProperty = getPropertyOfType(targetEnumType, property.escapedName);
              if (!targetProperty || !(targetProperty.flags & 8)) {
                if (errorReporter) {
                  errorReporter(ts2.Diagnostics.Property_0_is_missing_in_type_1, ts2.symbolName(property), typeToString(getDeclaredTypeOfSymbol(targetSymbol), void 0, 64));
                  enumRelation.set(id, 2 | 4);
                } else {
                  enumRelation.set(id, 2);
                }
                return false;
              }
            }
          }
          enumRelation.set(id, 1);
          return true;
        }
        function isSimpleTypeRelatedTo(source, target, relation, errorReporter) {
          var s = source.flags;
          var t = target.flags;
          if (t & 3 || s & 131072 || source === wildcardType)
            return true;
          if (t & 131072)
            return false;
          if (s & 132 && t & 4)
            return true;
          if (s & 128 && s & 1024 && t & 128 && !(t & 1024) && source.value === target.value)
            return true;
          if (s & 296 && t & 8)
            return true;
          if (s & 256 && s & 1024 && t & 256 && !(t & 1024) && source.value === target.value)
            return true;
          if (s & 2112 && t & 64)
            return true;
          if (s & 528 && t & 16)
            return true;
          if (s & 12288 && t & 4096)
            return true;
          if (s & 32 && t & 32 && isEnumTypeRelatedTo(source.symbol, target.symbol, errorReporter))
            return true;
          if (s & 1024 && t & 1024) {
            if (s & 1048576 && t & 1048576 && isEnumTypeRelatedTo(source.symbol, target.symbol, errorReporter))
              return true;
            if (s & 2944 && t & 2944 && source.value === target.value && isEnumTypeRelatedTo(getParentOfSymbol(source.symbol), getParentOfSymbol(target.symbol), errorReporter))
              return true;
          }
          if (s & 32768 && (!strictNullChecks || t & (32768 | 16384)))
            return true;
          if (s & 65536 && (!strictNullChecks || t & 65536))
            return true;
          if (s & 524288 && t & 67108864)
            return true;
          if (relation === assignableRelation || relation === comparableRelation) {
            if (s & 1)
              return true;
            if (s & (8 | 256) && !(s & 1024) && (t & 32 || t & 256 && t & 1024))
              return true;
          }
          return false;
        }
        function isTypeRelatedTo(source, target, relation) {
          if (isFreshLiteralType(source)) {
            source = source.regularType;
          }
          if (isFreshLiteralType(target)) {
            target = target.regularType;
          }
          if (source === target) {
            return true;
          }
          if (relation !== identityRelation) {
            if (relation === comparableRelation && !(target.flags & 131072) && isSimpleTypeRelatedTo(target, source, relation) || isSimpleTypeRelatedTo(source, target, relation)) {
              return true;
            }
          } else {
            if (!(source.flags & 3145728) && !(target.flags & 3145728) && source.flags !== target.flags && !(source.flags & 66584576))
              return false;
          }
          if (source.flags & 524288 && target.flags & 524288) {
            var related = relation.get(getRelationKey(source, target, 0, relation));
            if (related !== void 0) {
              return !!(related & 1);
            }
          }
          if (source.flags & 66846720 || target.flags & 66846720) {
            return checkTypeRelatedTo(source, target, relation, void 0);
          }
          return false;
        }
        function isIgnoredJsxProperty(source, sourceProp) {
          return ts2.getObjectFlags(source) & 4096 && !isUnhyphenatedJsxName(sourceProp.escapedName);
        }
        function getNormalizedType(type, writing) {
          while (true) {
            var t = isFreshLiteralType(type) ? type.regularType : ts2.getObjectFlags(type) & 4 && type.node ? createTypeReference(type.target, getTypeArguments(type)) : type.flags & 3145728 ? getReducedType(type) : type.flags & 33554432 ? writing ? type.baseType : type.substitute : type.flags & 25165824 ? getSimplifiedType(type, writing) : type;
            if (t === type)
              break;
            type = t;
          }
          return type;
        }
        function checkTypeRelatedTo(source, target, relation, errorNode, headMessage, containingMessageChain, errorOutputContainer) {
          var errorInfo;
          var relatedInfo;
          var maybeKeys;
          var sourceStack;
          var targetStack;
          var maybeCount = 0;
          var depth = 0;
          var expandingFlags = 0;
          var overflow = false;
          var overrideNextErrorInfo = 0;
          var lastSkippedInfo;
          var incompatibleStack = [];
          var inPropertyCheck = false;
          ts2.Debug.assert(relation !== identityRelation || !errorNode, "no error reporting in identity checking");
          var result = isRelatedTo(source, target, !!errorNode, headMessage);
          if (incompatibleStack.length) {
            reportIncompatibleStack();
          }
          if (overflow) {
            var diag = error(errorNode || currentNode, ts2.Diagnostics.Excessive_stack_depth_comparing_types_0_and_1, typeToString(source), typeToString(target));
            if (errorOutputContainer) {
              (errorOutputContainer.errors || (errorOutputContainer.errors = [])).push(diag);
            }
          } else if (errorInfo) {
            if (containingMessageChain) {
              var chain = containingMessageChain();
              if (chain) {
                ts2.concatenateDiagnosticMessageChains(chain, errorInfo);
                errorInfo = chain;
              }
            }
            var relatedInformation = void 0;
            if (headMessage && errorNode && !result && source.symbol) {
              var links = getSymbolLinks(source.symbol);
              if (links.originatingImport && !ts2.isImportCall(links.originatingImport)) {
                var helpfulRetry = checkTypeRelatedTo(getTypeOfSymbol(links.target), target, relation, void 0);
                if (helpfulRetry) {
                  var diag_1 = ts2.createDiagnosticForNode(links.originatingImport, ts2.Diagnostics.Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead);
                  relatedInformation = ts2.append(relatedInformation, diag_1);
                }
              }
            }
            var diag = ts2.createDiagnosticForNodeFromMessageChain(errorNode, errorInfo, relatedInformation);
            if (relatedInfo) {
              ts2.addRelatedInfo.apply(void 0, __spreadArrays([diag], relatedInfo));
            }
            if (errorOutputContainer) {
              (errorOutputContainer.errors || (errorOutputContainer.errors = [])).push(diag);
            }
            if (!errorOutputContainer || !errorOutputContainer.skipLogging) {
              diagnostics.add(diag);
            }
          }
          if (errorNode && errorOutputContainer && errorOutputContainer.skipLogging && result === 0) {
            ts2.Debug.assert(!!errorOutputContainer.errors, "missed opportunity to interact with error.");
          }
          return result !== 0;
          function resetErrorInfo(saved) {
            errorInfo = saved.errorInfo;
            lastSkippedInfo = saved.lastSkippedInfo;
            incompatibleStack = saved.incompatibleStack;
            overrideNextErrorInfo = saved.overrideNextErrorInfo;
            relatedInfo = saved.relatedInfo;
          }
          function captureErrorCalculationState() {
            return {
              errorInfo,
              lastSkippedInfo,
              incompatibleStack: incompatibleStack.slice(),
              overrideNextErrorInfo,
              relatedInfo: !relatedInfo ? void 0 : relatedInfo.slice()
            };
          }
          function reportIncompatibleError(message, arg0, arg1, arg2, arg3) {
            overrideNextErrorInfo++;
            lastSkippedInfo = void 0;
            incompatibleStack.push([message, arg0, arg1, arg2, arg3]);
          }
          function reportIncompatibleStack() {
            var stack = incompatibleStack;
            incompatibleStack = [];
            var info = lastSkippedInfo;
            lastSkippedInfo = void 0;
            if (stack.length === 1) {
              reportError.apply(void 0, stack[0]);
              if (info) {
                reportRelationError.apply(void 0, __spreadArrays([void 0], info));
              }
              return;
            }
            var path2 = "";
            var secondaryRootErrors = [];
            while (stack.length) {
              var _a = stack.pop(), msg = _a[0], args = _a.slice(1);
              switch (msg.code) {
                case ts2.Diagnostics.Types_of_property_0_are_incompatible.code: {
                  if (path2.indexOf("new ") === 0) {
                    path2 = "(" + path2 + ")";
                  }
                  var str = "" + args[0];
                  if (path2.length === 0) {
                    path2 = "" + str;
                  } else if (ts2.isIdentifierText(str, compilerOptions.target)) {
                    path2 = path2 + "." + str;
                  } else if (str[0] === "[" && str[str.length - 1] === "]") {
                    path2 = "" + path2 + str;
                  } else {
                    path2 = path2 + "[" + str + "]";
                  }
                  break;
                }
                case ts2.Diagnostics.Call_signature_return_types_0_and_1_are_incompatible.code:
                case ts2.Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible.code:
                case ts2.Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code:
                case ts2.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code: {
                  if (path2.length === 0) {
                    var mappedMsg = msg;
                    if (msg.code === ts2.Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code) {
                      mappedMsg = ts2.Diagnostics.Call_signature_return_types_0_and_1_are_incompatible;
                    } else if (msg.code === ts2.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code) {
                      mappedMsg = ts2.Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible;
                    }
                    secondaryRootErrors.unshift([mappedMsg, args[0], args[1]]);
                  } else {
                    var prefix = msg.code === ts2.Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible.code || msg.code === ts2.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code ? "new " : "";
                    var params = msg.code === ts2.Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code || msg.code === ts2.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code ? "" : "...";
                    path2 = "" + prefix + path2 + "(" + params + ")";
                  }
                  break;
                }
                default:
                  return ts2.Debug.fail("Unhandled Diagnostic: " + msg.code);
              }
            }
            if (path2) {
              reportError(path2[path2.length - 1] === ")" ? ts2.Diagnostics.The_types_returned_by_0_are_incompatible_between_these_types : ts2.Diagnostics.The_types_of_0_are_incompatible_between_these_types, path2);
            } else {
              secondaryRootErrors.shift();
            }
            for (var _i = 0, secondaryRootErrors_1 = secondaryRootErrors; _i < secondaryRootErrors_1.length; _i++) {
              var _b = secondaryRootErrors_1[_i], msg = _b[0], args = _b.slice(1);
              var originalValue = msg.elidedInCompatabilityPyramid;
              msg.elidedInCompatabilityPyramid = false;
              reportError.apply(void 0, __spreadArrays([msg], args));
              msg.elidedInCompatabilityPyramid = originalValue;
            }
            if (info) {
              reportRelationError.apply(void 0, __spreadArrays([void 0], info));
            }
          }
          function reportError(message, arg0, arg1, arg2, arg3) {
            ts2.Debug.assert(!!errorNode);
            if (incompatibleStack.length)
              reportIncompatibleStack();
            if (message.elidedInCompatabilityPyramid)
              return;
            errorInfo = ts2.chainDiagnosticMessages(errorInfo, message, arg0, arg1, arg2, arg3);
          }
          function associateRelatedInfo(info) {
            ts2.Debug.assert(!!errorInfo);
            if (!relatedInfo) {
              relatedInfo = [info];
            } else {
              relatedInfo.push(info);
            }
          }
          function reportRelationError(message, source2, target2) {
            if (incompatibleStack.length)
              reportIncompatibleStack();
            var _a = getTypeNamesForErrorDisplay(source2, target2), sourceType = _a[0], targetType = _a[1];
            if (target2.flags & 262144) {
              var constraint = getBaseConstraintOfType(target2);
              var constraintElab = constraint && isTypeAssignableTo(source2, constraint);
              if (constraintElab) {
                reportError(ts2.Diagnostics._0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_constraint_2, sourceType, targetType, typeToString(constraint));
              } else {
                reportError(ts2.Diagnostics._0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1, targetType, sourceType);
              }
            }
            if (!message) {
              if (relation === comparableRelation) {
                message = ts2.Diagnostics.Type_0_is_not_comparable_to_type_1;
              } else if (sourceType === targetType) {
                message = ts2.Diagnostics.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated;
              } else {
                message = ts2.Diagnostics.Type_0_is_not_assignable_to_type_1;
              }
            }
            reportError(message, sourceType, targetType);
          }
          function tryElaborateErrorsForPrimitivesAndObjects(source2, target2) {
            var sourceType = symbolValueDeclarationIsContextSensitive(source2.symbol) ? typeToString(source2, source2.symbol.valueDeclaration) : typeToString(source2);
            var targetType = symbolValueDeclarationIsContextSensitive(target2.symbol) ? typeToString(target2, target2.symbol.valueDeclaration) : typeToString(target2);
            if (globalStringType === source2 && stringType === target2 || globalNumberType === source2 && numberType === target2 || globalBooleanType === source2 && booleanType === target2 || getGlobalESSymbolType(false) === source2 && esSymbolType === target2) {
              reportError(ts2.Diagnostics._0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible, targetType, sourceType);
            }
          }
          function tryElaborateArrayLikeErrors(source2, target2, reportErrors) {
            if (isTupleType(source2)) {
              if (source2.target.readonly && isMutableArrayOrTuple(target2)) {
                if (reportErrors) {
                  reportError(ts2.Diagnostics.The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1, typeToString(source2), typeToString(target2));
                }
                return false;
              }
              return isTupleType(target2) || isArrayType(target2);
            }
            if (isReadonlyArrayType(source2) && isMutableArrayOrTuple(target2)) {
              if (reportErrors) {
                reportError(ts2.Diagnostics.The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1, typeToString(source2), typeToString(target2));
              }
              return false;
            }
            if (isTupleType(target2)) {
              return isArrayType(source2);
            }
            return true;
          }
          function isRelatedTo(originalSource, originalTarget, reportErrors, headMessage2, intersectionState) {
            if (reportErrors === void 0) {
              reportErrors = false;
            }
            if (intersectionState === void 0) {
              intersectionState = 0;
            }
            if (originalSource.flags & 524288 && originalTarget.flags & 131068) {
              if (isSimpleTypeRelatedTo(originalSource, originalTarget, relation, reportErrors ? reportError : void 0)) {
                return -1;
              }
              reportErrorResults(originalSource, originalTarget, 0, !!(ts2.getObjectFlags(originalSource) & 4096));
              return 0;
            }
            var source2 = getNormalizedType(originalSource, false);
            var target2 = getNormalizedType(originalTarget, true);
            if (source2 === target2)
              return -1;
            if (relation === identityRelation) {
              return isIdenticalTo(source2, target2);
            }
            if (source2.flags & 262144 && getConstraintOfType(source2) === target2) {
              return -1;
            }
            if (target2.flags & 1048576 && source2.flags & 524288 && target2.types.length <= 3 && maybeTypeOfKind(target2, 98304)) {
              var nullStrippedTarget = extractTypesOfKind(target2, ~98304);
              if (!(nullStrippedTarget.flags & (1048576 | 131072))) {
                if (source2 === nullStrippedTarget)
                  return -1;
                target2 = nullStrippedTarget;
              }
            }
            if (relation === comparableRelation && !(target2.flags & 131072) && isSimpleTypeRelatedTo(target2, source2, relation) || isSimpleTypeRelatedTo(source2, target2, relation, reportErrors ? reportError : void 0))
              return -1;
            var isComparingJsxAttributes = !!(ts2.getObjectFlags(source2) & 4096);
            var isPerformingExcessPropertyChecks = !(intersectionState & 2) && (isObjectLiteralType(source2) && ts2.getObjectFlags(source2) & 32768);
            if (isPerformingExcessPropertyChecks) {
              if (hasExcessProperties(source2, target2, reportErrors)) {
                if (reportErrors) {
                  reportRelationError(headMessage2, source2, target2);
                }
                return 0;
              }
            }
            var isPerformingCommonPropertyChecks = relation !== comparableRelation && !(intersectionState & 2) && source2.flags & (131068 | 524288 | 2097152) && source2 !== globalObjectType && target2.flags & (524288 | 2097152) && isWeakType(target2) && (getPropertiesOfType(source2).length > 0 || typeHasCallOrConstructSignatures(source2));
            if (isPerformingCommonPropertyChecks && !hasCommonProperties(source2, target2, isComparingJsxAttributes)) {
              if (reportErrors) {
                var calls = getSignaturesOfType(source2, 0);
                var constructs = getSignaturesOfType(source2, 1);
                if (calls.length > 0 && isRelatedTo(getReturnTypeOfSignature(calls[0]), target2, false) || constructs.length > 0 && isRelatedTo(getReturnTypeOfSignature(constructs[0]), target2, false)) {
                  reportError(ts2.Diagnostics.Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it, typeToString(source2), typeToString(target2));
                } else {
                  reportError(ts2.Diagnostics.Type_0_has_no_properties_in_common_with_type_1, typeToString(source2), typeToString(target2));
                }
              }
              return 0;
            }
            var result2 = 0;
            var saveErrorInfo = captureErrorCalculationState();
            if (source2.flags & 1048576) {
              result2 = relation === comparableRelation ? someTypeRelatedToType(source2, target2, reportErrors && !(source2.flags & 131068), intersectionState) : eachTypeRelatedToType(source2, target2, reportErrors && !(source2.flags & 131068), intersectionState);
            } else {
              if (target2.flags & 1048576) {
                result2 = typeRelatedToSomeType(getRegularTypeOfObjectLiteral(source2), target2, reportErrors && !(source2.flags & 131068) && !(target2.flags & 131068));
              } else if (target2.flags & 2097152) {
                result2 = typeRelatedToEachType(getRegularTypeOfObjectLiteral(source2), target2, reportErrors, 2);
              } else if (source2.flags & 2097152) {
                result2 = someTypeRelatedToType(source2, target2, false, 1);
              }
              if (!result2 && (source2.flags & 66846720 || target2.flags & 66846720)) {
                if (result2 = recursiveTypeRelatedTo(source2, target2, reportErrors, intersectionState)) {
                  resetErrorInfo(saveErrorInfo);
                }
              }
            }
            if (!result2 && source2.flags & (2097152 | 262144)) {
              var constraint = getEffectiveConstraintOfIntersection(source2.flags & 2097152 ? source2.types : [source2], !!(target2.flags & 1048576));
              if (constraint && (source2.flags & 2097152 || target2.flags & 1048576)) {
                if (everyType(constraint, function(c) {
                  return c !== source2;
                })) {
                  if (result2 = isRelatedTo(constraint, target2, false, void 0, intersectionState)) {
                    resetErrorInfo(saveErrorInfo);
                  }
                }
              }
            }
            if (result2 && !inPropertyCheck && (target2.flags & 2097152 && (isPerformingExcessPropertyChecks || isPerformingCommonPropertyChecks) || isNonGenericObjectType(target2) && !isArrayType(target2) && !isTupleType(target2) && source2.flags & 2097152 && getApparentType(source2).flags & 3670016 && !ts2.some(source2.types, function(t) {
              return !!(ts2.getObjectFlags(t) & 2097152);
            }))) {
              inPropertyCheck = true;
              result2 &= recursiveTypeRelatedTo(source2, target2, reportErrors, 4);
              inPropertyCheck = false;
            }
            reportErrorResults(source2, target2, result2, isComparingJsxAttributes);
            return result2;
            function reportErrorResults(source3, target3, result3, isComparingJsxAttributes2) {
              if (!result3 && reportErrors) {
                source3 = originalSource.aliasSymbol ? originalSource : source3;
                target3 = originalTarget.aliasSymbol ? originalTarget : target3;
                var maybeSuppress = overrideNextErrorInfo > 0;
                if (maybeSuppress) {
                  overrideNextErrorInfo--;
                }
                if (source3.flags & 524288 && target3.flags & 524288) {
                  var currentError = errorInfo;
                  tryElaborateArrayLikeErrors(source3, target3, reportErrors);
                  if (errorInfo !== currentError) {
                    maybeSuppress = !!errorInfo;
                  }
                }
                if (source3.flags & 524288 && target3.flags & 131068) {
                  tryElaborateErrorsForPrimitivesAndObjects(source3, target3);
                } else if (source3.symbol && source3.flags & 524288 && globalObjectType === source3) {
                  reportError(ts2.Diagnostics.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead);
                } else if (isComparingJsxAttributes2 && target3.flags & 2097152) {
                  var targetTypes = target3.types;
                  var intrinsicAttributes = getJsxType(JsxNames.IntrinsicAttributes, errorNode);
                  var intrinsicClassAttributes = getJsxType(JsxNames.IntrinsicClassAttributes, errorNode);
                  if (intrinsicAttributes !== errorType && intrinsicClassAttributes !== errorType && (ts2.contains(targetTypes, intrinsicAttributes) || ts2.contains(targetTypes, intrinsicClassAttributes))) {
                    return result3;
                  }
                } else {
                  errorInfo = elaborateNeverIntersection(errorInfo, originalTarget);
                }
                if (!headMessage2 && maybeSuppress) {
                  lastSkippedInfo = [source3, target3];
                  return result3;
                }
                reportRelationError(headMessage2, source3, target3);
              }
            }
          }
          function isIdenticalTo(source2, target2) {
            var flags = source2.flags & target2.flags;
            if (!(flags & 66584576)) {
              return 0;
            }
            if (flags & 3145728) {
              var result_5 = eachTypeRelatedToSomeType(source2, target2);
              if (result_5) {
                result_5 &= eachTypeRelatedToSomeType(target2, source2);
              }
              return result_5;
            }
            return recursiveTypeRelatedTo(source2, target2, false, 0);
          }
          function getTypeOfPropertyInTypes(types, name) {
            var appendPropType = function(propTypes, type) {
              type = getApparentType(type);
              var prop = type.flags & 3145728 ? getPropertyOfUnionOrIntersectionType(type, name) : getPropertyOfObjectType(type, name);
              var propType = prop && getTypeOfSymbol(prop) || isNumericLiteralName(name) && getIndexTypeOfType(type, 1) || getIndexTypeOfType(type, 0) || undefinedType;
              return ts2.append(propTypes, propType);
            };
            return getUnionType(ts2.reduceLeft(types, appendPropType, void 0) || ts2.emptyArray);
          }
          function hasExcessProperties(source2, target2, reportErrors) {
            if (!isExcessPropertyCheckTarget(target2) || !noImplicitAny && ts2.getObjectFlags(target2) & 16384) {
              return false;
            }
            var isComparingJsxAttributes = !!(ts2.getObjectFlags(source2) & 4096);
            if ((relation === assignableRelation || relation === comparableRelation) && (isTypeSubsetOf(globalObjectType, target2) || !isComparingJsxAttributes && isEmptyObjectType(target2))) {
              return false;
            }
            var reducedTarget = target2;
            var checkTypes;
            if (target2.flags & 1048576) {
              reducedTarget = findMatchingDiscriminantType(source2, target2, isRelatedTo) || filterPrimitivesIfContainsNonPrimitive(target2);
              checkTypes = reducedTarget.flags & 1048576 ? reducedTarget.types : [reducedTarget];
            }
            var _loop_13 = function(prop2) {
              if (shouldCheckAsExcessProperty(prop2, source2.symbol) && !isIgnoredJsxProperty(source2, prop2)) {
                if (!isKnownProperty(reducedTarget, prop2.escapedName, isComparingJsxAttributes)) {
                  if (reportErrors) {
                    var errorTarget = filterType(reducedTarget, isExcessPropertyCheckTarget);
                    if (!errorNode)
                      return { value: ts2.Debug.fail() };
                    if (ts2.isJsxAttributes(errorNode) || ts2.isJsxOpeningLikeElement(errorNode) || ts2.isJsxOpeningLikeElement(errorNode.parent)) {
                      if (prop2.valueDeclaration && ts2.isJsxAttribute(prop2.valueDeclaration) && ts2.getSourceFileOfNode(errorNode) === ts2.getSourceFileOfNode(prop2.valueDeclaration.name)) {
                        errorNode = prop2.valueDeclaration.name;
                      }
                      reportError(ts2.Diagnostics.Property_0_does_not_exist_on_type_1, symbolToString(prop2), typeToString(errorTarget));
                    } else {
                      var objectLiteralDeclaration_1 = source2.symbol && ts2.firstOrUndefined(source2.symbol.declarations);
                      var suggestion = void 0;
                      if (prop2.valueDeclaration && ts2.findAncestor(prop2.valueDeclaration, function(d) {
                        return d === objectLiteralDeclaration_1;
                      }) && ts2.getSourceFileOfNode(objectLiteralDeclaration_1) === ts2.getSourceFileOfNode(errorNode)) {
                        var propDeclaration = prop2.valueDeclaration;
                        ts2.Debug.assertNode(propDeclaration, ts2.isObjectLiteralElementLike);
                        errorNode = propDeclaration;
                        var name = propDeclaration.name;
                        if (ts2.isIdentifier(name)) {
                          suggestion = getSuggestionForNonexistentProperty(name, errorTarget);
                        }
                      }
                      if (suggestion !== void 0) {
                        reportError(ts2.Diagnostics.Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_write_2, symbolToString(prop2), typeToString(errorTarget), suggestion);
                      } else {
                        reportError(ts2.Diagnostics.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1, symbolToString(prop2), typeToString(errorTarget));
                      }
                    }
                  }
                  return { value: true };
                }
                if (checkTypes && !isRelatedTo(getTypeOfSymbol(prop2), getTypeOfPropertyInTypes(checkTypes, prop2.escapedName), reportErrors)) {
                  if (reportErrors) {
                    reportIncompatibleError(ts2.Diagnostics.Types_of_property_0_are_incompatible, symbolToString(prop2));
                  }
                  return { value: true };
                }
              }
            };
            for (var _i = 0, _a = getPropertiesOfType(source2); _i < _a.length; _i++) {
              var prop = _a[_i];
              var state_5 = _loop_13(prop);
              if (typeof state_5 === "object")
                return state_5.value;
            }
            return false;
          }
          function shouldCheckAsExcessProperty(prop, container) {
            return prop.valueDeclaration && container.valueDeclaration && prop.valueDeclaration.parent === container.valueDeclaration;
          }
          function eachTypeRelatedToSomeType(source2, target2) {
            var result2 = -1;
            var sourceTypes = source2.types;
            for (var _i = 0, sourceTypes_1 = sourceTypes; _i < sourceTypes_1.length; _i++) {
              var sourceType = sourceTypes_1[_i];
              var related = typeRelatedToSomeType(sourceType, target2, false);
              if (!related) {
                return 0;
              }
              result2 &= related;
            }
            return result2;
          }
          function typeRelatedToSomeType(source2, target2, reportErrors) {
            var targetTypes = target2.types;
            if (target2.flags & 1048576 && containsType(targetTypes, source2)) {
              return -1;
            }
            for (var _i = 0, targetTypes_1 = targetTypes; _i < targetTypes_1.length; _i++) {
              var type = targetTypes_1[_i];
              var related = isRelatedTo(source2, type, false);
              if (related) {
                return related;
              }
            }
            if (reportErrors) {
              var bestMatchingType = getBestMatchingType(source2, target2, isRelatedTo);
              isRelatedTo(source2, bestMatchingType || targetTypes[targetTypes.length - 1], true);
            }
            return 0;
          }
          function typeRelatedToEachType(source2, target2, reportErrors, intersectionState) {
            var result2 = -1;
            var targetTypes = target2.types;
            for (var _i = 0, targetTypes_2 = targetTypes; _i < targetTypes_2.length; _i++) {
              var targetType = targetTypes_2[_i];
              var related = isRelatedTo(source2, targetType, reportErrors, void 0, intersectionState);
              if (!related) {
                return 0;
              }
              result2 &= related;
            }
            return result2;
          }
          function someTypeRelatedToType(source2, target2, reportErrors, intersectionState) {
            var sourceTypes = source2.types;
            if (source2.flags & 1048576 && containsType(sourceTypes, target2)) {
              return -1;
            }
            var len = sourceTypes.length;
            for (var i = 0; i < len; i++) {
              var related = isRelatedTo(sourceTypes[i], target2, reportErrors && i === len - 1, void 0, intersectionState);
              if (related) {
                return related;
              }
            }
            return 0;
          }
          function eachTypeRelatedToType(source2, target2, reportErrors, intersectionState) {
            var result2 = -1;
            var sourceTypes = source2.types;
            for (var i = 0; i < sourceTypes.length; i++) {
              var sourceType = sourceTypes[i];
              if (target2.flags & 1048576 && target2.types.length === sourceTypes.length) {
                var related_1 = isRelatedTo(sourceType, target2.types[i], false, void 0, intersectionState);
                if (related_1) {
                  result2 &= related_1;
                  continue;
                }
              }
              var related = isRelatedTo(sourceType, target2, reportErrors, void 0, intersectionState);
              if (!related) {
                return 0;
              }
              result2 &= related;
            }
            return result2;
          }
          function typeArgumentsRelatedTo(sources, targets, variances, reportErrors, intersectionState) {
            if (sources === void 0) {
              sources = ts2.emptyArray;
            }
            if (targets === void 0) {
              targets = ts2.emptyArray;
            }
            if (variances === void 0) {
              variances = ts2.emptyArray;
            }
            if (sources.length !== targets.length && relation === identityRelation) {
              return 0;
            }
            var length = sources.length <= targets.length ? sources.length : targets.length;
            var result2 = -1;
            for (var i = 0; i < length; i++) {
              var varianceFlags = i < variances.length ? variances[i] : 1;
              var variance = varianceFlags & 7;
              if (variance !== 4) {
                var s = sources[i];
                var t = targets[i];
                var related = -1;
                if (varianceFlags & 8) {
                  related = relation === identityRelation ? isRelatedTo(s, t, false) : compareTypesIdentical(s, t);
                } else if (variance === 1) {
                  related = isRelatedTo(s, t, reportErrors, void 0, intersectionState);
                } else if (variance === 2) {
                  related = isRelatedTo(t, s, reportErrors, void 0, intersectionState);
                } else if (variance === 3) {
                  related = isRelatedTo(t, s, false);
                  if (!related) {
                    related = isRelatedTo(s, t, reportErrors, void 0, intersectionState);
                  }
                } else {
                  related = isRelatedTo(s, t, reportErrors, void 0, intersectionState);
                  if (related) {
                    related &= isRelatedTo(t, s, reportErrors, void 0, intersectionState);
                  }
                }
                if (!related) {
                  return 0;
                }
                result2 &= related;
              }
            }
            return result2;
          }
          function recursiveTypeRelatedTo(source2, target2, reportErrors, intersectionState) {
            if (overflow) {
              return 0;
            }
            var id = getRelationKey(source2, target2, intersectionState | (inPropertyCheck ? 8 : 0), relation);
            var entry = relation.get(id);
            if (entry !== void 0) {
              if (reportErrors && entry & 2 && !(entry & 4)) {
              } else {
                if (outofbandVarianceMarkerHandler) {
                  var saved = entry & 24;
                  if (saved & 8) {
                    instantiateType(source2, makeFunctionTypeMapper(reportUnmeasurableMarkers));
                  }
                  if (saved & 16) {
                    instantiateType(source2, makeFunctionTypeMapper(reportUnreliableMarkers));
                  }
                }
                return entry & 1 ? -1 : 0;
              }
            }
            if (!maybeKeys) {
              maybeKeys = [];
              sourceStack = [];
              targetStack = [];
            } else {
              for (var i = 0; i < maybeCount; i++) {
                if (id === maybeKeys[i]) {
                  return 1;
                }
              }
              if (depth === 100) {
                overflow = true;
                return 0;
              }
            }
            var maybeStart = maybeCount;
            maybeKeys[maybeCount] = id;
            maybeCount++;
            sourceStack[depth] = source2;
            targetStack[depth] = target2;
            depth++;
            var saveExpandingFlags = expandingFlags;
            if (!(expandingFlags & 1) && isDeeplyNestedType(source2, sourceStack, depth))
              expandingFlags |= 1;
            if (!(expandingFlags & 2) && isDeeplyNestedType(target2, targetStack, depth))
              expandingFlags |= 2;
            var originalHandler;
            var propagatingVarianceFlags = 0;
            if (outofbandVarianceMarkerHandler) {
              originalHandler = outofbandVarianceMarkerHandler;
              outofbandVarianceMarkerHandler = function(onlyUnreliable) {
                propagatingVarianceFlags |= onlyUnreliable ? 16 : 8;
                return originalHandler(onlyUnreliable);
              };
            }
            var result2 = expandingFlags !== 3 ? structuredTypeRelatedTo(source2, target2, reportErrors, intersectionState) : 1;
            if (outofbandVarianceMarkerHandler) {
              outofbandVarianceMarkerHandler = originalHandler;
            }
            expandingFlags = saveExpandingFlags;
            depth--;
            if (result2) {
              if (result2 === -1 || depth === 0) {
                for (var i = maybeStart; i < maybeCount; i++) {
                  relation.set(maybeKeys[i], 1 | propagatingVarianceFlags);
                }
                maybeCount = maybeStart;
              }
            } else {
              relation.set(id, (reportErrors ? 4 : 0) | 2 | propagatingVarianceFlags);
              maybeCount = maybeStart;
            }
            return result2;
          }
          function structuredTypeRelatedTo(source2, target2, reportErrors, intersectionState) {
            if (intersectionState & 4) {
              return propertiesRelatedTo(source2, target2, reportErrors, void 0, 0);
            }
            var flags = source2.flags & target2.flags;
            if (relation === identityRelation && !(flags & 524288)) {
              if (flags & 4194304) {
                return isRelatedTo(source2.type, target2.type, false);
              }
              var result_6 = 0;
              if (flags & 8388608) {
                if (result_6 = isRelatedTo(source2.objectType, target2.objectType, false)) {
                  if (result_6 &= isRelatedTo(source2.indexType, target2.indexType, false)) {
                    return result_6;
                  }
                }
              }
              if (flags & 16777216) {
                if (source2.root.isDistributive === target2.root.isDistributive) {
                  if (result_6 = isRelatedTo(source2.checkType, target2.checkType, false)) {
                    if (result_6 &= isRelatedTo(source2.extendsType, target2.extendsType, false)) {
                      if (result_6 &= isRelatedTo(getTrueTypeFromConditionalType(source2), getTrueTypeFromConditionalType(target2), false)) {
                        if (result_6 &= isRelatedTo(getFalseTypeFromConditionalType(source2), getFalseTypeFromConditionalType(target2), false)) {
                          return result_6;
                        }
                      }
                    }
                  }
                }
              }
              if (flags & 33554432) {
                return isRelatedTo(source2.substitute, target2.substitute, false);
              }
              return 0;
            }
            var result2;
            var originalErrorInfo;
            var varianceCheckFailed = false;
            var saveErrorInfo = captureErrorCalculationState();
            if (source2.flags & (524288 | 16777216) && source2.aliasSymbol && source2.aliasTypeArguments && source2.aliasSymbol === target2.aliasSymbol && !(source2.aliasTypeArgumentsContainsMarker || target2.aliasTypeArgumentsContainsMarker)) {
              var variances = getAliasVariances(source2.aliasSymbol);
              if (variances === ts2.emptyArray) {
                return 1;
              }
              var varianceResult = relateVariances(source2.aliasTypeArguments, target2.aliasTypeArguments, variances, intersectionState);
              if (varianceResult !== void 0) {
                return varianceResult;
              }
            }
            if (target2.flags & 262144) {
              if (ts2.getObjectFlags(source2) & 32 && isRelatedTo(getIndexType(target2), getConstraintTypeFromMappedType(source2))) {
                if (!(getMappedTypeModifiers(source2) & 4)) {
                  var templateType = getTemplateTypeFromMappedType(source2);
                  var indexedAccessType = getIndexedAccessType(target2, getTypeParameterFromMappedType(source2));
                  if (result2 = isRelatedTo(templateType, indexedAccessType, reportErrors)) {
                    return result2;
                  }
                }
              }
            } else if (target2.flags & 4194304) {
              if (source2.flags & 4194304) {
                if (result2 = isRelatedTo(target2.type, source2.type, false)) {
                  return result2;
                }
              }
              var constraint = getSimplifiedTypeOrConstraint(target2.type);
              if (constraint) {
                if (isRelatedTo(source2, getIndexType(constraint, target2.stringsOnly), reportErrors) === -1) {
                  return -1;
                }
              }
            } else if (target2.flags & 8388608) {
              if (relation !== identityRelation) {
                var objectType = target2.objectType;
                var indexType = target2.indexType;
                var baseObjectType = getBaseConstraintOfType(objectType) || objectType;
                var baseIndexType = getBaseConstraintOfType(indexType) || indexType;
                if (!isGenericObjectType(baseObjectType) && !isGenericIndexType(baseIndexType)) {
                  var accessFlags = 2 | (baseObjectType !== objectType ? 1 : 0);
                  var constraint = getIndexedAccessTypeOrUndefined(baseObjectType, baseIndexType, void 0, accessFlags);
                  if (constraint && (result2 = isRelatedTo(source2, constraint, reportErrors))) {
                    return result2;
                  }
                }
              }
            } else if (isGenericMappedType(target2)) {
              var template = getTemplateTypeFromMappedType(target2);
              var modifiers = getMappedTypeModifiers(target2);
              if (!(modifiers & 8)) {
                if (template.flags & 8388608 && template.objectType === source2 && template.indexType === getTypeParameterFromMappedType(target2)) {
                  return -1;
                }
                if (!isGenericMappedType(source2)) {
                  var targetConstraint = getConstraintTypeFromMappedType(target2);
                  var sourceKeys = getIndexType(source2, void 0, true);
                  var includeOptional = modifiers & 4;
                  var filteredByApplicability = includeOptional ? intersectTypes(targetConstraint, sourceKeys) : void 0;
                  if (includeOptional ? !(filteredByApplicability.flags & 131072) : isRelatedTo(targetConstraint, sourceKeys)) {
                    var typeParameter = getTypeParameterFromMappedType(target2);
                    var indexingType = filteredByApplicability ? getIntersectionType([filteredByApplicability, typeParameter]) : typeParameter;
                    var indexedAccessType = getIndexedAccessType(source2, indexingType);
                    var templateType = getTemplateTypeFromMappedType(target2);
                    if (result2 = isRelatedTo(indexedAccessType, templateType, reportErrors)) {
                      return result2;
                    }
                  }
                  originalErrorInfo = errorInfo;
                  resetErrorInfo(saveErrorInfo);
                }
              }
            }
            if (source2.flags & 8650752) {
              if (source2.flags & 8388608 && target2.flags & 8388608) {
                if (result2 = isRelatedTo(source2.objectType, target2.objectType, reportErrors)) {
                  result2 &= isRelatedTo(source2.indexType, target2.indexType, reportErrors);
                }
                if (result2) {
                  resetErrorInfo(saveErrorInfo);
                  return result2;
                }
              } else {
                var constraint = getConstraintOfType(source2);
                if (!constraint || source2.flags & 262144 && constraint.flags & 1) {
                  if (result2 = isRelatedTo(emptyObjectType, extractTypesOfKind(target2, ~67108864))) {
                    resetErrorInfo(saveErrorInfo);
                    return result2;
                  }
                } else if (result2 = isRelatedTo(constraint, target2, false, void 0, intersectionState)) {
                  resetErrorInfo(saveErrorInfo);
                  return result2;
                } else if (result2 = isRelatedTo(getTypeWithThisArgument(constraint, source2), target2, reportErrors, void 0, intersectionState)) {
                  resetErrorInfo(saveErrorInfo);
                  return result2;
                }
              }
            } else if (source2.flags & 4194304) {
              if (result2 = isRelatedTo(keyofConstraintType, target2, reportErrors)) {
                resetErrorInfo(saveErrorInfo);
                return result2;
              }
            } else if (source2.flags & 16777216) {
              if (target2.flags & 16777216) {
                var sourceParams = source2.root.inferTypeParameters;
                var sourceExtends = source2.extendsType;
                var mapper = void 0;
                if (sourceParams) {
                  var ctx = createInferenceContext(sourceParams, void 0, 0, isRelatedTo);
                  inferTypes(ctx.inferences, target2.extendsType, sourceExtends, 128 | 256);
                  sourceExtends = instantiateType(sourceExtends, ctx.mapper);
                  mapper = ctx.mapper;
                }
                if (isTypeIdenticalTo(sourceExtends, target2.extendsType) && (isRelatedTo(source2.checkType, target2.checkType) || isRelatedTo(target2.checkType, source2.checkType))) {
                  if (result2 = isRelatedTo(instantiateType(getTrueTypeFromConditionalType(source2), mapper), getTrueTypeFromConditionalType(target2), reportErrors)) {
                    result2 &= isRelatedTo(getFalseTypeFromConditionalType(source2), getFalseTypeFromConditionalType(target2), reportErrors);
                  }
                  if (result2) {
                    resetErrorInfo(saveErrorInfo);
                    return result2;
                  }
                }
              } else {
                var distributiveConstraint = getConstraintOfDistributiveConditionalType(source2);
                if (distributiveConstraint) {
                  if (result2 = isRelatedTo(distributiveConstraint, target2, reportErrors)) {
                    resetErrorInfo(saveErrorInfo);
                    return result2;
                  }
                }
              }
              var defaultConstraint = getDefaultConstraintOfConditionalType(source2);
              if (defaultConstraint) {
                if (result2 = isRelatedTo(defaultConstraint, target2, reportErrors)) {
                  resetErrorInfo(saveErrorInfo);
                  return result2;
                }
              }
            } else {
              if (relation !== subtypeRelation && relation !== strictSubtypeRelation && isPartialMappedType(target2) && isEmptyObjectType(source2)) {
                return -1;
              }
              if (isGenericMappedType(target2)) {
                if (isGenericMappedType(source2)) {
                  if (result2 = mappedTypeRelatedTo(source2, target2, reportErrors)) {
                    resetErrorInfo(saveErrorInfo);
                    return result2;
                  }
                }
                return 0;
              }
              var sourceIsPrimitive = !!(source2.flags & 131068);
              if (relation !== identityRelation) {
                source2 = getApparentType(source2);
              } else if (isGenericMappedType(source2)) {
                return 0;
              }
              if (ts2.getObjectFlags(source2) & 4 && ts2.getObjectFlags(target2) & 4 && source2.target === target2.target && !(ts2.getObjectFlags(source2) & 8192 || ts2.getObjectFlags(target2) & 8192)) {
                var variances = getVariances(source2.target);
                if (variances === ts2.emptyArray) {
                  return 1;
                }
                var varianceResult = relateVariances(getTypeArguments(source2), getTypeArguments(target2), variances, intersectionState);
                if (varianceResult !== void 0) {
                  return varianceResult;
                }
              } else if (isReadonlyArrayType(target2) ? isArrayType(source2) || isTupleType(source2) : isArrayType(target2) && isTupleType(source2) && !source2.target.readonly) {
                if (relation !== identityRelation) {
                  return isRelatedTo(getIndexTypeOfType(source2, 1) || anyType, getIndexTypeOfType(target2, 1) || anyType, reportErrors);
                } else {
                  return 0;
                }
              } else if ((relation === subtypeRelation || relation === strictSubtypeRelation) && isEmptyObjectType(target2) && ts2.getObjectFlags(target2) & 32768 && !isEmptyObjectType(source2)) {
                return 0;
              }
              if (source2.flags & (524288 | 2097152) && target2.flags & 524288) {
                var reportStructuralErrors = reportErrors && errorInfo === saveErrorInfo.errorInfo && !sourceIsPrimitive;
                result2 = propertiesRelatedTo(source2, target2, reportStructuralErrors, void 0, intersectionState);
                if (result2) {
                  result2 &= signaturesRelatedTo(source2, target2, 0, reportStructuralErrors);
                  if (result2) {
                    result2 &= signaturesRelatedTo(source2, target2, 1, reportStructuralErrors);
                    if (result2) {
                      result2 &= indexTypesRelatedTo(source2, target2, 0, sourceIsPrimitive, reportStructuralErrors, intersectionState);
                      if (result2) {
                        result2 &= indexTypesRelatedTo(source2, target2, 1, sourceIsPrimitive, reportStructuralErrors, intersectionState);
                      }
                    }
                  }
                }
                if (varianceCheckFailed && result2) {
                  errorInfo = originalErrorInfo || errorInfo || saveErrorInfo.errorInfo;
                } else if (result2) {
                  return result2;
                }
              }
              if (source2.flags & (524288 | 2097152) && target2.flags & 1048576) {
                var objectOnlyTarget = extractTypesOfKind(target2, 524288 | 2097152 | 33554432);
                if (objectOnlyTarget.flags & 1048576) {
                  var result_7 = typeRelatedToDiscriminatedType(source2, objectOnlyTarget);
                  if (result_7) {
                    return result_7;
                  }
                }
              }
            }
            return 0;
            function relateVariances(sourceTypeArguments, targetTypeArguments, variances2, intersectionState2) {
              if (result2 = typeArgumentsRelatedTo(sourceTypeArguments, targetTypeArguments, variances2, reportErrors, intersectionState2)) {
                return result2;
              }
              if (ts2.some(variances2, function(v) {
                return !!(v & 24);
              })) {
                originalErrorInfo = void 0;
                resetErrorInfo(saveErrorInfo);
                return void 0;
              }
              var allowStructuralFallback = targetTypeArguments && hasCovariantVoidArgument(targetTypeArguments, variances2);
              varianceCheckFailed = !allowStructuralFallback;
              if (variances2 !== ts2.emptyArray && !allowStructuralFallback) {
                if (varianceCheckFailed && !(reportErrors && ts2.some(variances2, function(v) {
                  return (v & 7) === 0;
                }))) {
                  return 0;
                }
                originalErrorInfo = errorInfo;
                resetErrorInfo(saveErrorInfo);
              }
            }
          }
          function reportUnmeasurableMarkers(p) {
            if (outofbandVarianceMarkerHandler && (p === markerSuperType || p === markerSubType || p === markerOtherType)) {
              outofbandVarianceMarkerHandler(false);
            }
            return p;
          }
          function reportUnreliableMarkers(p) {
            if (outofbandVarianceMarkerHandler && (p === markerSuperType || p === markerSubType || p === markerOtherType)) {
              outofbandVarianceMarkerHandler(true);
            }
            return p;
          }
          function mappedTypeRelatedTo(source2, target2, reportErrors) {
            var modifiersRelated = relation === comparableRelation || (relation === identityRelation ? getMappedTypeModifiers(source2) === getMappedTypeModifiers(target2) : getCombinedMappedTypeOptionality(source2) <= getCombinedMappedTypeOptionality(target2));
            if (modifiersRelated) {
              var result_8;
              var targetConstraint = getConstraintTypeFromMappedType(target2);
              var sourceConstraint = instantiateType(getConstraintTypeFromMappedType(source2), makeFunctionTypeMapper(getCombinedMappedTypeOptionality(source2) < 0 ? reportUnmeasurableMarkers : reportUnreliableMarkers));
              if (result_8 = isRelatedTo(targetConstraint, sourceConstraint, reportErrors)) {
                var mapper = createTypeMapper([getTypeParameterFromMappedType(source2)], [getTypeParameterFromMappedType(target2)]);
                return result_8 & isRelatedTo(instantiateType(getTemplateTypeFromMappedType(source2), mapper), getTemplateTypeFromMappedType(target2), reportErrors);
              }
            }
            return 0;
          }
          function typeRelatedToDiscriminatedType(source2, target2) {
            var sourceProperties = getPropertiesOfType(source2);
            var sourcePropertiesFiltered = findDiscriminantProperties(sourceProperties, target2);
            if (!sourcePropertiesFiltered)
              return 0;
            var numCombinations = 1;
            for (var _i = 0, sourcePropertiesFiltered_1 = sourcePropertiesFiltered; _i < sourcePropertiesFiltered_1.length; _i++) {
              var sourceProperty = sourcePropertiesFiltered_1[_i];
              numCombinations *= countTypes(getTypeOfSymbol(sourceProperty));
              if (numCombinations > 25) {
                return 0;
              }
            }
            var sourceDiscriminantTypes = new Array(sourcePropertiesFiltered.length);
            var excludedProperties = ts2.createUnderscoreEscapedMap();
            for (var i = 0; i < sourcePropertiesFiltered.length; i++) {
              var sourceProperty = sourcePropertiesFiltered[i];
              var sourcePropertyType = getTypeOfSymbol(sourceProperty);
              sourceDiscriminantTypes[i] = sourcePropertyType.flags & 1048576 ? sourcePropertyType.types : [sourcePropertyType];
              excludedProperties.set(sourceProperty.escapedName, true);
            }
            var discriminantCombinations = ts2.cartesianProduct(sourceDiscriminantTypes);
            var matchingTypes = [];
            var _loop_14 = function(combination2) {
              var hasMatch = false;
              outer:
                for (var _i2 = 0, _a2 = target2.types; _i2 < _a2.length; _i2++) {
                  var type2 = _a2[_i2];
                  var _loop_15 = function(i3) {
                    var sourceProperty2 = sourcePropertiesFiltered[i3];
                    var targetProperty = getPropertyOfType(type2, sourceProperty2.escapedName);
                    if (!targetProperty)
                      return "continue-outer";
                    if (sourceProperty2 === targetProperty)
                      return "continue";
                    var related = propertyRelatedTo(source2, target2, sourceProperty2, targetProperty, function(_) {
                      return combination2[i3];
                    }, false, 0, strictNullChecks || relation === comparableRelation);
                    if (!related) {
                      return "continue-outer";
                    }
                  };
                  for (var i2 = 0; i2 < sourcePropertiesFiltered.length; i2++) {
                    var state_7 = _loop_15(i2);
                    switch (state_7) {
                      case "continue-outer":
                        continue outer;
                    }
                  }
                  ts2.pushIfUnique(matchingTypes, type2, ts2.equateValues);
                  hasMatch = true;
                }
              if (!hasMatch) {
                return { value: 0 };
              }
            };
            for (var _a = 0, discriminantCombinations_1 = discriminantCombinations; _a < discriminantCombinations_1.length; _a++) {
              var combination = discriminantCombinations_1[_a];
              var state_6 = _loop_14(combination);
              if (typeof state_6 === "object")
                return state_6.value;
            }
            var result2 = -1;
            for (var _b = 0, matchingTypes_1 = matchingTypes; _b < matchingTypes_1.length; _b++) {
              var type = matchingTypes_1[_b];
              result2 &= propertiesRelatedTo(source2, type, false, excludedProperties, 0);
              if (result2) {
                result2 &= signaturesRelatedTo(source2, type, 0, false);
                if (result2) {
                  result2 &= signaturesRelatedTo(source2, type, 1, false);
                  if (result2) {
                    result2 &= indexTypesRelatedTo(source2, type, 0, false, false, 0);
                    if (result2) {
                      result2 &= indexTypesRelatedTo(source2, type, 1, false, false, 0);
                    }
                  }
                }
              }
              if (!result2) {
                return result2;
              }
            }
            return result2;
          }
          function excludeProperties(properties, excludedProperties) {
            if (!excludedProperties || properties.length === 0)
              return properties;
            var result2;
            for (var i = 0; i < properties.length; i++) {
              if (!excludedProperties.has(properties[i].escapedName)) {
                if (result2) {
                  result2.push(properties[i]);
                }
              } else if (!result2) {
                result2 = properties.slice(0, i);
              }
            }
            return result2 || properties;
          }
          function isPropertySymbolTypeRelated(sourceProp, targetProp, getTypeOfSourceProperty, reportErrors, intersectionState) {
            var targetIsOptional = strictNullChecks && !!(ts2.getCheckFlags(targetProp) & 48);
            var source2 = getTypeOfSourceProperty(sourceProp);
            if (ts2.getCheckFlags(targetProp) & 65536 && !getSymbolLinks(targetProp).type) {
              var links2 = getSymbolLinks(targetProp);
              ts2.Debug.assertIsDefined(links2.deferralParent);
              ts2.Debug.assertIsDefined(links2.deferralConstituents);
              var unionParent = !!(links2.deferralParent.flags & 1048576);
              var result_9 = unionParent ? 0 : -1;
              var targetTypes = links2.deferralConstituents;
              for (var _i = 0, targetTypes_3 = targetTypes; _i < targetTypes_3.length; _i++) {
                var targetType = targetTypes_3[_i];
                var related = isRelatedTo(source2, targetType, false, void 0, unionParent ? 0 : 2);
                if (!unionParent) {
                  if (!related) {
                    return isRelatedTo(source2, addOptionality(getTypeOfSymbol(targetProp), targetIsOptional), reportErrors);
                  }
                  result_9 &= related;
                } else {
                  if (related) {
                    return related;
                  }
                }
              }
              if (unionParent && !result_9 && targetIsOptional) {
                result_9 = isRelatedTo(source2, undefinedType);
              }
              if (unionParent && !result_9 && reportErrors) {
                return isRelatedTo(source2, addOptionality(getTypeOfSymbol(targetProp), targetIsOptional), reportErrors);
              }
              return result_9;
            } else {
              return isRelatedTo(source2, addOptionality(getTypeOfSymbol(targetProp), targetIsOptional), reportErrors, void 0, intersectionState);
            }
          }
          function propertyRelatedTo(source2, target2, sourceProp, targetProp, getTypeOfSourceProperty, reportErrors, intersectionState, skipOptional) {
            var sourcePropFlags = ts2.getDeclarationModifierFlagsFromSymbol(sourceProp);
            var targetPropFlags = ts2.getDeclarationModifierFlagsFromSymbol(targetProp);
            if (sourcePropFlags & 8 || targetPropFlags & 8) {
              if (sourceProp.valueDeclaration !== targetProp.valueDeclaration) {
                if (reportErrors) {
                  if (sourcePropFlags & 8 && targetPropFlags & 8) {
                    reportError(ts2.Diagnostics.Types_have_separate_declarations_of_a_private_property_0, symbolToString(targetProp));
                  } else {
                    reportError(ts2.Diagnostics.Property_0_is_private_in_type_1_but_not_in_type_2, symbolToString(targetProp), typeToString(sourcePropFlags & 8 ? source2 : target2), typeToString(sourcePropFlags & 8 ? target2 : source2));
                  }
                }
                return 0;
              }
            } else if (targetPropFlags & 16) {
              if (!isValidOverrideOf(sourceProp, targetProp)) {
                if (reportErrors) {
                  reportError(ts2.Diagnostics.Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2, symbolToString(targetProp), typeToString(getDeclaringClass(sourceProp) || source2), typeToString(getDeclaringClass(targetProp) || target2));
                }
                return 0;
              }
            } else if (sourcePropFlags & 16) {
              if (reportErrors) {
                reportError(ts2.Diagnostics.Property_0_is_protected_in_type_1_but_public_in_type_2, symbolToString(targetProp), typeToString(source2), typeToString(target2));
              }
              return 0;
            }
            var related = isPropertySymbolTypeRelated(sourceProp, targetProp, getTypeOfSourceProperty, reportErrors, intersectionState);
            if (!related) {
              if (reportErrors) {
                reportIncompatibleError(ts2.Diagnostics.Types_of_property_0_are_incompatible, symbolToString(targetProp));
              }
              return 0;
            }
            if (!skipOptional && sourceProp.flags & 16777216 && !(targetProp.flags & 16777216)) {
              if (reportErrors) {
                reportError(ts2.Diagnostics.Property_0_is_optional_in_type_1_but_required_in_type_2, symbolToString(targetProp), typeToString(source2), typeToString(target2));
              }
              return 0;
            }
            return related;
          }
          function reportUnmatchedProperty(source2, target2, unmatchedProperty, requireOptionalProperties) {
            var shouldSkipElaboration = false;
            if (unmatchedProperty.valueDeclaration && ts2.isNamedDeclaration(unmatchedProperty.valueDeclaration) && ts2.isPrivateIdentifier(unmatchedProperty.valueDeclaration.name) && source2.symbol && source2.symbol.flags & 32) {
              var privateIdentifierDescription = unmatchedProperty.valueDeclaration.name.escapedText;
              var symbolTableKey = ts2.getSymbolNameForPrivateIdentifier(source2.symbol, privateIdentifierDescription);
              if (symbolTableKey && getPropertyOfType(source2, symbolTableKey)) {
                var sourceName = ts2.getDeclarationName(source2.symbol.valueDeclaration);
                var targetName = ts2.getDeclarationName(target2.symbol.valueDeclaration);
                reportError(ts2.Diagnostics.Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2, diagnosticName(privateIdentifierDescription), diagnosticName(sourceName.escapedText === "" ? anon : sourceName), diagnosticName(targetName.escapedText === "" ? anon : targetName));
                return;
              }
            }
            var props = ts2.arrayFrom(getUnmatchedProperties(source2, target2, requireOptionalProperties, false));
            if (!headMessage || headMessage.code !== ts2.Diagnostics.Class_0_incorrectly_implements_interface_1.code && headMessage.code !== ts2.Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass.code) {
              shouldSkipElaboration = true;
            }
            if (props.length === 1) {
              var propName = symbolToString(unmatchedProperty);
              reportError.apply(void 0, __spreadArrays([ts2.Diagnostics.Property_0_is_missing_in_type_1_but_required_in_type_2, propName], getTypeNamesForErrorDisplay(source2, target2)));
              if (ts2.length(unmatchedProperty.declarations)) {
                associateRelatedInfo(ts2.createDiagnosticForNode(unmatchedProperty.declarations[0], ts2.Diagnostics._0_is_declared_here, propName));
              }
              if (shouldSkipElaboration && errorInfo) {
                overrideNextErrorInfo++;
              }
            } else if (tryElaborateArrayLikeErrors(source2, target2, false)) {
              if (props.length > 5) {
                reportError(ts2.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more, typeToString(source2), typeToString(target2), ts2.map(props.slice(0, 4), function(p) {
                  return symbolToString(p);
                }).join(", "), props.length - 4);
              } else {
                reportError(ts2.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2, typeToString(source2), typeToString(target2), ts2.map(props, function(p) {
                  return symbolToString(p);
                }).join(", "));
              }
              if (shouldSkipElaboration && errorInfo) {
                overrideNextErrorInfo++;
              }
            }
          }
          function propertiesRelatedTo(source2, target2, reportErrors, excludedProperties, intersectionState) {
            if (relation === identityRelation) {
              return propertiesIdenticalTo(source2, target2, excludedProperties);
            }
            var requireOptionalProperties = (relation === subtypeRelation || relation === strictSubtypeRelation) && !isObjectLiteralType(source2) && !isEmptyArrayLiteralType(source2) && !isTupleType(source2);
            var unmatchedProperty = getUnmatchedProperty(source2, target2, requireOptionalProperties, false);
            if (unmatchedProperty) {
              if (reportErrors) {
                reportUnmatchedProperty(source2, target2, unmatchedProperty, requireOptionalProperties);
              }
              return 0;
            }
            if (isObjectLiteralType(target2)) {
              for (var _i = 0, _a = excludeProperties(getPropertiesOfType(source2), excludedProperties); _i < _a.length; _i++) {
                var sourceProp = _a[_i];
                if (!getPropertyOfObjectType(target2, sourceProp.escapedName)) {
                  var sourceType = getTypeOfSymbol(sourceProp);
                  if (!(sourceType === undefinedType || sourceType === undefinedWideningType || sourceType === optionalType)) {
                    if (reportErrors) {
                      reportError(ts2.Diagnostics.Property_0_does_not_exist_on_type_1, symbolToString(sourceProp), typeToString(target2));
                    }
                    return 0;
                  }
                }
              }
            }
            var result2 = -1;
            if (isTupleType(target2)) {
              var targetRestType = getRestTypeOfTupleType(target2);
              if (targetRestType) {
                if (!isTupleType(source2)) {
                  return 0;
                }
                var sourceRestType = getRestTypeOfTupleType(source2);
                if (sourceRestType && !isRelatedTo(sourceRestType, targetRestType, reportErrors)) {
                  if (reportErrors) {
                    reportError(ts2.Diagnostics.Rest_signatures_are_incompatible);
                  }
                  return 0;
                }
                var targetCount = getTypeReferenceArity(target2) - 1;
                var sourceCount = getTypeReferenceArity(source2) - (sourceRestType ? 1 : 0);
                var sourceTypeArguments = getTypeArguments(source2);
                for (var i = targetCount; i < sourceCount; i++) {
                  var related = isRelatedTo(sourceTypeArguments[i], targetRestType, reportErrors);
                  if (!related) {
                    if (reportErrors) {
                      reportError(ts2.Diagnostics.Property_0_is_incompatible_with_rest_element_type, "" + i);
                    }
                    return 0;
                  }
                  result2 &= related;
                }
              }
            }
            var properties = getPropertiesOfType(target2);
            var numericNamesOnly = isTupleType(source2) && isTupleType(target2);
            for (var _b = 0, _c = excludeProperties(properties, excludedProperties); _b < _c.length; _b++) {
              var targetProp = _c[_b];
              var name = targetProp.escapedName;
              if (!(targetProp.flags & 4194304) && (!numericNamesOnly || isNumericLiteralName(name) || name === "length")) {
                var sourceProp = getPropertyOfType(source2, name);
                if (sourceProp && sourceProp !== targetProp) {
                  var related = propertyRelatedTo(source2, target2, sourceProp, targetProp, getTypeOfSymbol, reportErrors, intersectionState, relation === comparableRelation);
                  if (!related) {
                    return 0;
                  }
                  result2 &= related;
                }
              }
            }
            return result2;
          }
          function propertiesIdenticalTo(source2, target2, excludedProperties) {
            if (!(source2.flags & 524288 && target2.flags & 524288)) {
              return 0;
            }
            var sourceProperties = excludeProperties(getPropertiesOfObjectType(source2), excludedProperties);
            var targetProperties = excludeProperties(getPropertiesOfObjectType(target2), excludedProperties);
            if (sourceProperties.length !== targetProperties.length) {
              return 0;
            }
            var result2 = -1;
            for (var _i = 0, sourceProperties_1 = sourceProperties; _i < sourceProperties_1.length; _i++) {
              var sourceProp = sourceProperties_1[_i];
              var targetProp = getPropertyOfObjectType(target2, sourceProp.escapedName);
              if (!targetProp) {
                return 0;
              }
              var related = compareProperties(sourceProp, targetProp, isRelatedTo);
              if (!related) {
                return 0;
              }
              result2 &= related;
            }
            return result2;
          }
          function signaturesRelatedTo(source2, target2, kind, reportErrors) {
            if (relation === identityRelation) {
              return signaturesIdenticalTo(source2, target2, kind);
            }
            if (target2 === anyFunctionType || source2 === anyFunctionType) {
              return -1;
            }
            var sourceIsJSConstructor = source2.symbol && isJSConstructor(source2.symbol.valueDeclaration);
            var targetIsJSConstructor = target2.symbol && isJSConstructor(target2.symbol.valueDeclaration);
            var sourceSignatures = getSignaturesOfType(source2, sourceIsJSConstructor && kind === 1 ? 0 : kind);
            var targetSignatures = getSignaturesOfType(target2, targetIsJSConstructor && kind === 1 ? 0 : kind);
            if (kind === 1 && sourceSignatures.length && targetSignatures.length) {
              if (ts2.isAbstractConstructorType(source2) && !ts2.isAbstractConstructorType(target2)) {
                if (reportErrors) {
                  reportError(ts2.Diagnostics.Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type);
                }
                return 0;
              }
              if (!constructorVisibilitiesAreCompatible(sourceSignatures[0], targetSignatures[0], reportErrors)) {
                return 0;
              }
            }
            var result2 = -1;
            var saveErrorInfo = captureErrorCalculationState();
            var incompatibleReporter = kind === 1 ? reportIncompatibleConstructSignatureReturn : reportIncompatibleCallSignatureReturn;
            if (ts2.getObjectFlags(source2) & 64 && ts2.getObjectFlags(target2) & 64 && source2.symbol === target2.symbol) {
              for (var i = 0; i < targetSignatures.length; i++) {
                var related = signatureRelatedTo(sourceSignatures[i], targetSignatures[i], true, reportErrors, incompatibleReporter(sourceSignatures[i], targetSignatures[i]));
                if (!related) {
                  return 0;
                }
                result2 &= related;
              }
            } else if (sourceSignatures.length === 1 && targetSignatures.length === 1) {
              var eraseGenerics = relation === comparableRelation || !!compilerOptions.noStrictGenericChecks;
              result2 = signatureRelatedTo(sourceSignatures[0], targetSignatures[0], eraseGenerics, reportErrors, incompatibleReporter(sourceSignatures[0], targetSignatures[0]));
            } else {
              outer:
                for (var _i = 0, targetSignatures_1 = targetSignatures; _i < targetSignatures_1.length; _i++) {
                  var t = targetSignatures_1[_i];
                  var shouldElaborateErrors = reportErrors;
                  for (var _a = 0, sourceSignatures_1 = sourceSignatures; _a < sourceSignatures_1.length; _a++) {
                    var s = sourceSignatures_1[_a];
                    var related = signatureRelatedTo(s, t, true, shouldElaborateErrors, incompatibleReporter(s, t));
                    if (related) {
                      result2 &= related;
                      resetErrorInfo(saveErrorInfo);
                      continue outer;
                    }
                    shouldElaborateErrors = false;
                  }
                  if (shouldElaborateErrors) {
                    reportError(ts2.Diagnostics.Type_0_provides_no_match_for_the_signature_1, typeToString(source2), signatureToString(t, void 0, void 0, kind));
                  }
                  return 0;
                }
            }
            return result2;
          }
          function reportIncompatibleCallSignatureReturn(siga, sigb) {
            if (siga.parameters.length === 0 && sigb.parameters.length === 0) {
              return function(source2, target2) {
                return reportIncompatibleError(ts2.Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1, typeToString(source2), typeToString(target2));
              };
            }
            return function(source2, target2) {
              return reportIncompatibleError(ts2.Diagnostics.Call_signature_return_types_0_and_1_are_incompatible, typeToString(source2), typeToString(target2));
            };
          }
          function reportIncompatibleConstructSignatureReturn(siga, sigb) {
            if (siga.parameters.length === 0 && sigb.parameters.length === 0) {
              return function(source2, target2) {
                return reportIncompatibleError(ts2.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1, typeToString(source2), typeToString(target2));
              };
            }
            return function(source2, target2) {
              return reportIncompatibleError(ts2.Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible, typeToString(source2), typeToString(target2));
            };
          }
          function signatureRelatedTo(source2, target2, erase, reportErrors, incompatibleReporter) {
            return compareSignaturesRelated(erase ? getErasedSignature(source2) : source2, erase ? getErasedSignature(target2) : target2, relation === strictSubtypeRelation ? 8 : 0, reportErrors, reportError, incompatibleReporter, isRelatedTo, makeFunctionTypeMapper(reportUnreliableMarkers));
          }
          function signaturesIdenticalTo(source2, target2, kind) {
            var sourceSignatures = getSignaturesOfType(source2, kind);
            var targetSignatures = getSignaturesOfType(target2, kind);
            if (sourceSignatures.length !== targetSignatures.length) {
              return 0;
            }
            var result2 = -1;
            for (var i = 0; i < sourceSignatures.length; i++) {
              var related = compareSignaturesIdentical(sourceSignatures[i], targetSignatures[i], false, false, false, isRelatedTo);
              if (!related) {
                return 0;
              }
              result2 &= related;
            }
            return result2;
          }
          function eachPropertyRelatedTo(source2, target2, kind, reportErrors) {
            var result2 = -1;
            var props = source2.flags & 2097152 ? getPropertiesOfUnionOrIntersectionType(source2) : getPropertiesOfObjectType(source2);
            for (var _i = 0, props_2 = props; _i < props_2.length; _i++) {
              var prop = props_2[_i];
              if (isIgnoredJsxProperty(source2, prop)) {
                continue;
              }
              var nameType = getSymbolLinks(prop).nameType;
              if (nameType && nameType.flags & 8192) {
                continue;
              }
              if (kind === 0 || isNumericLiteralName(prop.escapedName)) {
                var related = isRelatedTo(getTypeOfSymbol(prop), target2, reportErrors);
                if (!related) {
                  if (reportErrors) {
                    reportError(ts2.Diagnostics.Property_0_is_incompatible_with_index_signature, symbolToString(prop));
                  }
                  return 0;
                }
                result2 &= related;
              }
            }
            return result2;
          }
          function indexTypeRelatedTo(sourceType, targetType, reportErrors) {
            var related = isRelatedTo(sourceType, targetType, reportErrors);
            if (!related && reportErrors) {
              reportError(ts2.Diagnostics.Index_signatures_are_incompatible);
            }
            return related;
          }
          function indexTypesRelatedTo(source2, target2, kind, sourceIsPrimitive, reportErrors, intersectionState) {
            if (relation === identityRelation) {
              return indexTypesIdenticalTo(source2, target2, kind);
            }
            var targetType = getIndexTypeOfType(target2, kind);
            if (!targetType || targetType.flags & 1 && !sourceIsPrimitive) {
              return -1;
            }
            if (isGenericMappedType(source2)) {
              return kind === 0 ? isRelatedTo(getTemplateTypeFromMappedType(source2), targetType, reportErrors) : 0;
            }
            var indexType = getIndexTypeOfType(source2, kind) || kind === 1 && getIndexTypeOfType(source2, 0);
            if (indexType) {
              return indexTypeRelatedTo(indexType, targetType, reportErrors);
            }
            if (!(intersectionState & 1) && isObjectTypeWithInferableIndex(source2)) {
              var related = eachPropertyRelatedTo(source2, targetType, kind, reportErrors);
              if (related && kind === 0) {
                var numberIndexType = getIndexTypeOfType(source2, 1);
                if (numberIndexType) {
                  related &= indexTypeRelatedTo(numberIndexType, targetType, reportErrors);
                }
              }
              return related;
            }
            if (reportErrors) {
              reportError(ts2.Diagnostics.Index_signature_is_missing_in_type_0, typeToString(source2));
            }
            return 0;
          }
          function indexTypesIdenticalTo(source2, target2, indexKind) {
            var targetInfo = getIndexInfoOfType(target2, indexKind);
            var sourceInfo = getIndexInfoOfType(source2, indexKind);
            if (!sourceInfo && !targetInfo) {
              return -1;
            }
            if (sourceInfo && targetInfo && sourceInfo.isReadonly === targetInfo.isReadonly) {
              return isRelatedTo(sourceInfo.type, targetInfo.type);
            }
            return 0;
          }
          function constructorVisibilitiesAreCompatible(sourceSignature, targetSignature, reportErrors) {
            if (!sourceSignature.declaration || !targetSignature.declaration) {
              return true;
            }
            var sourceAccessibility = ts2.getSelectedModifierFlags(sourceSignature.declaration, 24);
            var targetAccessibility = ts2.getSelectedModifierFlags(targetSignature.declaration, 24);
            if (targetAccessibility === 8) {
              return true;
            }
            if (targetAccessibility === 16 && sourceAccessibility !== 8) {
              return true;
            }
            if (targetAccessibility !== 16 && !sourceAccessibility) {
              return true;
            }
            if (reportErrors) {
              reportError(ts2.Diagnostics.Cannot_assign_a_0_constructor_type_to_a_1_constructor_type, visibilityToString(sourceAccessibility), visibilityToString(targetAccessibility));
            }
            return false;
          }
        }
        function getBestMatchingType(source, target, isRelatedTo) {
          if (isRelatedTo === void 0) {
            isRelatedTo = compareTypesAssignable;
          }
          return findMatchingDiscriminantType(source, target, isRelatedTo, true) || findMatchingTypeReferenceOrTypeAliasReference(source, target) || findBestTypeForObjectLiteral(source, target) || findBestTypeForInvokable(source, target) || findMostOverlappyType(source, target);
        }
        function discriminateTypeByDiscriminableItems(target, discriminators, related, defaultValue, skipPartial) {
          var discriminable = target.types.map(function(_) {
            return void 0;
          });
          for (var _i = 0, discriminators_1 = discriminators; _i < discriminators_1.length; _i++) {
            var _a = discriminators_1[_i], getDiscriminatingType = _a[0], propertyName = _a[1];
            var targetProp = getUnionOrIntersectionProperty(target, propertyName);
            if (skipPartial && targetProp && ts2.getCheckFlags(targetProp) & 16) {
              continue;
            }
            var i = 0;
            for (var _b = 0, _c = target.types; _b < _c.length; _b++) {
              var type = _c[_b];
              var targetType = getTypeOfPropertyOfType(type, propertyName);
              if (targetType && related(getDiscriminatingType(), targetType)) {
                discriminable[i] = discriminable[i] === void 0 ? true : discriminable[i];
              } else {
                discriminable[i] = false;
              }
              i++;
            }
          }
          var match = discriminable.indexOf(true);
          return match === -1 || discriminable.indexOf(true, match + 1) !== -1 ? defaultValue : target.types[match];
        }
        function isWeakType(type) {
          if (type.flags & 524288) {
            var resolved = resolveStructuredTypeMembers(type);
            return resolved.callSignatures.length === 0 && resolved.constructSignatures.length === 0 && !resolved.stringIndexInfo && !resolved.numberIndexInfo && resolved.properties.length > 0 && ts2.every(resolved.properties, function(p) {
              return !!(p.flags & 16777216);
            });
          }
          if (type.flags & 2097152) {
            return ts2.every(type.types, isWeakType);
          }
          return false;
        }
        function hasCommonProperties(source, target, isComparingJsxAttributes) {
          for (var _i = 0, _a = getPropertiesOfType(source); _i < _a.length; _i++) {
            var prop = _a[_i];
            if (isKnownProperty(target, prop.escapedName, isComparingJsxAttributes)) {
              return true;
            }
          }
          return false;
        }
        function getMarkerTypeReference(type, source, target) {
          var result = createTypeReference(type, ts2.map(type.typeParameters, function(t) {
            return t === source ? target : t;
          }));
          result.objectFlags |= 8192;
          return result;
        }
        function getAliasVariances(symbol) {
          var links = getSymbolLinks(symbol);
          return getVariancesWorker(links.typeParameters, links, function(_links, param, marker) {
            var type = getTypeAliasInstantiation(symbol, instantiateTypes(links.typeParameters, makeUnaryTypeMapper(param, marker)));
            type.aliasTypeArgumentsContainsMarker = true;
            return type;
          });
        }
        function getVariancesWorker(typeParameters, cache, createMarkerType) {
          if (typeParameters === void 0) {
            typeParameters = ts2.emptyArray;
          }
          var variances = cache.variances;
          if (!variances) {
            cache.variances = ts2.emptyArray;
            variances = [];
            var _loop_16 = function(tp2) {
              var unmeasurable = false;
              var unreliable = false;
              var oldHandler = outofbandVarianceMarkerHandler;
              outofbandVarianceMarkerHandler = function(onlyUnreliable) {
                return onlyUnreliable ? unreliable = true : unmeasurable = true;
              };
              var typeWithSuper = createMarkerType(cache, tp2, markerSuperType);
              var typeWithSub = createMarkerType(cache, tp2, markerSubType);
              var variance = (isTypeAssignableTo(typeWithSub, typeWithSuper) ? 1 : 0) | (isTypeAssignableTo(typeWithSuper, typeWithSub) ? 2 : 0);
              if (variance === 3 && isTypeAssignableTo(createMarkerType(cache, tp2, markerOtherType), typeWithSuper)) {
                variance = 4;
              }
              outofbandVarianceMarkerHandler = oldHandler;
              if (unmeasurable || unreliable) {
                if (unmeasurable) {
                  variance |= 8;
                }
                if (unreliable) {
                  variance |= 16;
                }
              }
              variances.push(variance);
            };
            for (var _i = 0, typeParameters_1 = typeParameters; _i < typeParameters_1.length; _i++) {
              var tp = typeParameters_1[_i];
              _loop_16(tp);
            }
            cache.variances = variances;
          }
          return variances;
        }
        function getVariances(type) {
          if (type === globalArrayType || type === globalReadonlyArrayType || type.objectFlags & 8) {
            return arrayVariances;
          }
          return getVariancesWorker(type.typeParameters, type, getMarkerTypeReference);
        }
        function hasCovariantVoidArgument(typeArguments, variances) {
          for (var i = 0; i < variances.length; i++) {
            if ((variances[i] & 7) === 1 && typeArguments[i].flags & 16384) {
              return true;
            }
          }
          return false;
        }
        function isUnconstrainedTypeParameter(type) {
          return type.flags & 262144 && !getConstraintOfTypeParameter(type);
        }
        function isNonDeferredTypeReference(type) {
          return !!(ts2.getObjectFlags(type) & 4) && !type.node;
        }
        function isTypeReferenceWithGenericArguments(type) {
          return isNonDeferredTypeReference(type) && ts2.some(getTypeArguments(type), function(t) {
            return isUnconstrainedTypeParameter(t) || isTypeReferenceWithGenericArguments(t);
          });
        }
        function getTypeReferenceId(type, typeParameters, depth) {
          if (depth === void 0) {
            depth = 0;
          }
          var result = "" + type.target.id;
          for (var _i = 0, _a = getTypeArguments(type); _i < _a.length; _i++) {
            var t = _a[_i];
            if (isUnconstrainedTypeParameter(t)) {
              var index = typeParameters.indexOf(t);
              if (index < 0) {
                index = typeParameters.length;
                typeParameters.push(t);
              }
              result += "=" + index;
            } else if (depth < 4 && isTypeReferenceWithGenericArguments(t)) {
              result += "<" + getTypeReferenceId(t, typeParameters, depth + 1) + ">";
            } else {
              result += "-" + t.id;
            }
          }
          return result;
        }
        function getRelationKey(source, target, intersectionState, relation) {
          if (relation === identityRelation && source.id > target.id) {
            var temp = source;
            source = target;
            target = temp;
          }
          var postFix = intersectionState ? ":" + intersectionState : "";
          if (isTypeReferenceWithGenericArguments(source) && isTypeReferenceWithGenericArguments(target)) {
            var typeParameters = [];
            return getTypeReferenceId(source, typeParameters) + "," + getTypeReferenceId(target, typeParameters) + postFix;
          }
          return source.id + "," + target.id + postFix;
        }
        function forEachProperty(prop, callback) {
          if (ts2.getCheckFlags(prop) & 6) {
            for (var _i = 0, _a = prop.containingType.types; _i < _a.length; _i++) {
              var t = _a[_i];
              var p = getPropertyOfType(t, prop.escapedName);
              var result = p && forEachProperty(p, callback);
              if (result) {
                return result;
              }
            }
            return void 0;
          }
          return callback(prop);
        }
        function getDeclaringClass(prop) {
          return prop.parent && prop.parent.flags & 32 ? getDeclaredTypeOfSymbol(getParentOfSymbol(prop)) : void 0;
        }
        function isPropertyInClassDerivedFrom(prop, baseClass) {
          return forEachProperty(prop, function(sp) {
            var sourceClass = getDeclaringClass(sp);
            return sourceClass ? hasBaseType(sourceClass, baseClass) : false;
          });
        }
        function isValidOverrideOf(sourceProp, targetProp) {
          return !forEachProperty(targetProp, function(tp) {
            return ts2.getDeclarationModifierFlagsFromSymbol(tp) & 16 ? !isPropertyInClassDerivedFrom(sourceProp, getDeclaringClass(tp)) : false;
          });
        }
        function isClassDerivedFromDeclaringClasses(checkClass, prop) {
          return forEachProperty(prop, function(p) {
            return ts2.getDeclarationModifierFlagsFromSymbol(p) & 16 ? !hasBaseType(checkClass, getDeclaringClass(p)) : false;
          }) ? void 0 : checkClass;
        }
        function isDeeplyNestedType(type, stack, depth) {
          if (depth >= 5 && type.flags & 524288 && !isObjectOrArrayLiteralType(type)) {
            var symbol = type.symbol;
            if (symbol) {
              var count = 0;
              for (var i = 0; i < depth; i++) {
                var t = stack[i];
                if (t.flags & 524288 && t.symbol === symbol) {
                  count++;
                  if (count >= 5)
                    return true;
                }
              }
            }
          }
          if (depth >= 5 && type.flags & 8388608) {
            var root = getRootObjectTypeFromIndexedAccessChain(type);
            var count = 0;
            for (var i = 0; i < depth; i++) {
              var t = stack[i];
              if (getRootObjectTypeFromIndexedAccessChain(t) === root) {
                count++;
                if (count >= 5)
                  return true;
              }
            }
          }
          return false;
        }
        function getRootObjectTypeFromIndexedAccessChain(type) {
          var t = type;
          while (t.flags & 8388608) {
            t = t.objectType;
          }
          return t;
        }
        function isPropertyIdenticalTo(sourceProp, targetProp) {
          return compareProperties(sourceProp, targetProp, compareTypesIdentical) !== 0;
        }
        function compareProperties(sourceProp, targetProp, compareTypes) {
          if (sourceProp === targetProp) {
            return -1;
          }
          var sourcePropAccessibility = ts2.getDeclarationModifierFlagsFromSymbol(sourceProp) & 24;
          var targetPropAccessibility = ts2.getDeclarationModifierFlagsFromSymbol(targetProp) & 24;
          if (sourcePropAccessibility !== targetPropAccessibility) {
            return 0;
          }
          if (sourcePropAccessibility) {
            if (getTargetSymbol(sourceProp) !== getTargetSymbol(targetProp)) {
              return 0;
            }
          } else {
            if ((sourceProp.flags & 16777216) !== (targetProp.flags & 16777216)) {
              return 0;
            }
          }
          if (isReadonlySymbol(sourceProp) !== isReadonlySymbol(targetProp)) {
            return 0;
          }
          return compareTypes(getTypeOfSymbol(sourceProp), getTypeOfSymbol(targetProp));
        }
        function isMatchingSignature(source, target, partialMatch) {
          var sourceParameterCount = getParameterCount(source);
          var targetParameterCount = getParameterCount(target);
          var sourceMinArgumentCount = getMinArgumentCount(source);
          var targetMinArgumentCount = getMinArgumentCount(target);
          var sourceHasRestParameter = hasEffectiveRestParameter(source);
          var targetHasRestParameter = hasEffectiveRestParameter(target);
          if (sourceParameterCount === targetParameterCount && sourceMinArgumentCount === targetMinArgumentCount && sourceHasRestParameter === targetHasRestParameter) {
            return true;
          }
          if (partialMatch && sourceMinArgumentCount <= targetMinArgumentCount) {
            return true;
          }
          return false;
        }
        function compareSignaturesIdentical(source, target, partialMatch, ignoreThisTypes, ignoreReturnTypes, compareTypes) {
          if (source === target) {
            return -1;
          }
          if (!isMatchingSignature(source, target, partialMatch)) {
            return 0;
          }
          if (ts2.length(source.typeParameters) !== ts2.length(target.typeParameters)) {
            return 0;
          }
          if (target.typeParameters) {
            var mapper = createTypeMapper(source.typeParameters, target.typeParameters);
            for (var i = 0; i < target.typeParameters.length; i++) {
              var s = source.typeParameters[i];
              var t = target.typeParameters[i];
              if (!(s === t || compareTypes(instantiateType(getConstraintFromTypeParameter(s), mapper) || unknownType, getConstraintFromTypeParameter(t) || unknownType) && compareTypes(instantiateType(getDefaultFromTypeParameter(s), mapper) || unknownType, getDefaultFromTypeParameter(t) || unknownType))) {
                return 0;
              }
            }
            source = instantiateSignature(source, mapper, true);
          }
          var result = -1;
          if (!ignoreThisTypes) {
            var sourceThisType = getThisTypeOfSignature(source);
            if (sourceThisType) {
              var targetThisType = getThisTypeOfSignature(target);
              if (targetThisType) {
                var related = compareTypes(sourceThisType, targetThisType);
                if (!related) {
                  return 0;
                }
                result &= related;
              }
            }
          }
          var targetLen = getParameterCount(target);
          for (var i = 0; i < targetLen; i++) {
            var s = getTypeAtPosition(source, i);
            var t = getTypeAtPosition(target, i);
            var related = compareTypes(t, s);
            if (!related) {
              return 0;
            }
            result &= related;
          }
          if (!ignoreReturnTypes) {
            var sourceTypePredicate = getTypePredicateOfSignature(source);
            var targetTypePredicate = getTypePredicateOfSignature(target);
            result &= sourceTypePredicate || targetTypePredicate ? compareTypePredicatesIdentical(sourceTypePredicate, targetTypePredicate, compareTypes) : compareTypes(getReturnTypeOfSignature(source), getReturnTypeOfSignature(target));
          }
          return result;
        }
        function compareTypePredicatesIdentical(source, target, compareTypes) {
          return !(source && target && typePredicateKindsMatch(source, target)) ? 0 : source.type === target.type ? -1 : source.type && target.type ? compareTypes(source.type, target.type) : 0;
        }
        function literalTypesWithSameBaseType(types) {
          var commonBaseType;
          for (var _i = 0, types_12 = types; _i < types_12.length; _i++) {
            var t = types_12[_i];
            var baseType = getBaseTypeOfLiteralType(t);
            if (!commonBaseType) {
              commonBaseType = baseType;
            }
            if (baseType === t || baseType !== commonBaseType) {
              return false;
            }
          }
          return true;
        }
        function getSupertypeOrUnion(types) {
          return literalTypesWithSameBaseType(types) ? getUnionType(types) : ts2.reduceLeft(types, function(s, t) {
            return isTypeSubtypeOf(s, t) ? t : s;
          });
        }
        function getCommonSupertype(types) {
          if (!strictNullChecks) {
            return getSupertypeOrUnion(types);
          }
          var primaryTypes = ts2.filter(types, function(t) {
            return !(t.flags & 98304);
          });
          return primaryTypes.length ? getNullableType(getSupertypeOrUnion(primaryTypes), getFalsyFlagsOfTypes(types) & 98304) : getUnionType(types, 2);
        }
        function getCommonSubtype(types) {
          return ts2.reduceLeft(types, function(s, t) {
            return isTypeSubtypeOf(t, s) ? t : s;
          });
        }
        function isArrayType(type) {
          return !!(ts2.getObjectFlags(type) & 4) && (type.target === globalArrayType || type.target === globalReadonlyArrayType);
        }
        function isReadonlyArrayType(type) {
          return !!(ts2.getObjectFlags(type) & 4) && type.target === globalReadonlyArrayType;
        }
        function isMutableArrayOrTuple(type) {
          return isArrayType(type) && !isReadonlyArrayType(type) || isTupleType(type) && !type.target.readonly;
        }
        function getElementTypeOfArrayType(type) {
          return isArrayType(type) ? getTypeArguments(type)[0] : void 0;
        }
        function isArrayLikeType(type) {
          return isArrayType(type) || !(type.flags & 98304) && isTypeAssignableTo(type, anyReadonlyArrayType);
        }
        function isEmptyArrayLiteralType(type) {
          var elementType = isArrayType(type) ? getTypeArguments(type)[0] : void 0;
          return elementType === undefinedWideningType || elementType === implicitNeverType;
        }
        function isTupleLikeType(type) {
          return isTupleType(type) || !!getPropertyOfType(type, "0");
        }
        function isArrayOrTupleLikeType(type) {
          return isArrayLikeType(type) || isTupleLikeType(type);
        }
        function getTupleElementType(type, index) {
          var propType = getTypeOfPropertyOfType(type, "" + index);
          if (propType) {
            return propType;
          }
          if (everyType(type, isTupleType)) {
            return mapType(type, function(t) {
              return getRestTypeOfTupleType(t) || undefinedType;
            });
          }
          return void 0;
        }
        function isNeitherUnitTypeNorNever(type) {
          return !(type.flags & (109440 | 131072));
        }
        function isUnitType(type) {
          return !!(type.flags & 109440);
        }
        function isLiteralType(type) {
          return type.flags & 16 ? true : type.flags & 1048576 ? type.flags & 1024 ? true : ts2.every(type.types, isUnitType) : isUnitType(type);
        }
        function getBaseTypeOfLiteralType(type) {
          return type.flags & 1024 ? getBaseTypeOfEnumLiteralType(type) : type.flags & 128 ? stringType : type.flags & 256 ? numberType : type.flags & 2048 ? bigintType : type.flags & 512 ? booleanType : type.flags & 1048576 ? getUnionType(ts2.sameMap(type.types, getBaseTypeOfLiteralType)) : type;
        }
        function getWidenedLiteralType(type) {
          return type.flags & 1024 && isFreshLiteralType(type) ? getBaseTypeOfEnumLiteralType(type) : type.flags & 128 && isFreshLiteralType(type) ? stringType : type.flags & 256 && isFreshLiteralType(type) ? numberType : type.flags & 2048 && isFreshLiteralType(type) ? bigintType : type.flags & 512 && isFreshLiteralType(type) ? booleanType : type.flags & 1048576 ? getUnionType(ts2.sameMap(type.types, getWidenedLiteralType)) : type;
        }
        function getWidenedUniqueESSymbolType(type) {
          return type.flags & 8192 ? esSymbolType : type.flags & 1048576 ? getUnionType(ts2.sameMap(type.types, getWidenedUniqueESSymbolType)) : type;
        }
        function getWidenedLiteralLikeTypeForContextualType(type, contextualType) {
          if (!isLiteralOfContextualType(type, contextualType)) {
            type = getWidenedUniqueESSymbolType(getWidenedLiteralType(type));
          }
          return type;
        }
        function getWidenedLiteralLikeTypeForContextualReturnTypeIfNeeded(type, contextualSignatureReturnType, isAsync) {
          if (type && isUnitType(type)) {
            var contextualType = !contextualSignatureReturnType ? void 0 : isAsync ? getPromisedTypeOfPromise(contextualSignatureReturnType) : contextualSignatureReturnType;
            type = getWidenedLiteralLikeTypeForContextualType(type, contextualType);
          }
          return type;
        }
        function getWidenedLiteralLikeTypeForContextualIterationTypeIfNeeded(type, contextualSignatureReturnType, kind, isAsyncGenerator) {
          if (type && isUnitType(type)) {
            var contextualType = !contextualSignatureReturnType ? void 0 : getIterationTypeOfGeneratorFunctionReturnType(kind, contextualSignatureReturnType, isAsyncGenerator);
            type = getWidenedLiteralLikeTypeForContextualType(type, contextualType);
          }
          return type;
        }
        function isTupleType(type) {
          return !!(ts2.getObjectFlags(type) & 4 && type.target.objectFlags & 8);
        }
        function getRestTypeOfTupleType(type) {
          return type.target.hasRestElement ? getTypeArguments(type)[type.target.typeParameters.length - 1] : void 0;
        }
        function getRestArrayTypeOfTupleType(type) {
          var restType = getRestTypeOfTupleType(type);
          return restType && createArrayType(restType);
        }
        function getLengthOfTupleType(type) {
          return getTypeReferenceArity(type) - (type.target.hasRestElement ? 1 : 0);
        }
        function isZeroBigInt(_a) {
          var value = _a.value;
          return value.base10Value === "0";
        }
        function getFalsyFlagsOfTypes(types) {
          var result = 0;
          for (var _i = 0, types_13 = types; _i < types_13.length; _i++) {
            var t = types_13[_i];
            result |= getFalsyFlags(t);
          }
          return result;
        }
        function getFalsyFlags(type) {
          return type.flags & 1048576 ? getFalsyFlagsOfTypes(type.types) : type.flags & 128 ? type.value === "" ? 128 : 0 : type.flags & 256 ? type.value === 0 ? 256 : 0 : type.flags & 2048 ? isZeroBigInt(type) ? 2048 : 0 : type.flags & 512 ? type === falseType || type === regularFalseType ? 512 : 0 : type.flags & 117724;
        }
        function removeDefinitelyFalsyTypes(type) {
          return getFalsyFlags(type) & 117632 ? filterType(type, function(t) {
            return !(getFalsyFlags(t) & 117632);
          }) : type;
        }
        function extractDefinitelyFalsyTypes(type) {
          return mapType(type, getDefinitelyFalsyPartOfType);
        }
        function getDefinitelyFalsyPartOfType(type) {
          return type.flags & 4 ? emptyStringType : type.flags & 8 ? zeroType : type.flags & 64 ? zeroBigIntType : type === regularFalseType || type === falseType || type.flags & (16384 | 32768 | 65536) || type.flags & 128 && type.value === "" || type.flags & 256 && type.value === 0 || type.flags & 2048 && isZeroBigInt(type) ? type : neverType;
        }
        function getNullableType(type, flags) {
          var missing = flags & ~type.flags & (32768 | 65536);
          return missing === 0 ? type : missing === 32768 ? getUnionType([type, undefinedType]) : missing === 65536 ? getUnionType([type, nullType]) : getUnionType([type, undefinedType, nullType]);
        }
        function getOptionalType(type) {
          ts2.Debug.assert(strictNullChecks);
          return type.flags & 32768 ? type : getUnionType([type, undefinedType]);
        }
        function getGlobalNonNullableTypeInstantiation(type) {
          if (!deferredGlobalNonNullableTypeAlias) {
            deferredGlobalNonNullableTypeAlias = getGlobalSymbol("NonNullable", 524288, void 0) || unknownSymbol;
          }
          if (deferredGlobalNonNullableTypeAlias !== unknownSymbol) {
            return getTypeAliasInstantiation(deferredGlobalNonNullableTypeAlias, [type]);
          }
          return getTypeWithFacts(type, 2097152);
        }
        function getNonNullableType(type) {
          return strictNullChecks ? getGlobalNonNullableTypeInstantiation(type) : type;
        }
        function addOptionalTypeMarker(type) {
          return strictNullChecks ? getUnionType([type, optionalType]) : type;
        }
        function isNotOptionalTypeMarker(type) {
          return type !== optionalType;
        }
        function removeOptionalTypeMarker(type) {
          return strictNullChecks ? filterType(type, isNotOptionalTypeMarker) : type;
        }
        function propagateOptionalTypeMarker(type, node, wasOptional) {
          return wasOptional ? ts2.isOutermostOptionalChain(node) ? getOptionalType(type) : addOptionalTypeMarker(type) : type;
        }
        function getOptionalExpressionType(exprType, expression) {
          return ts2.isExpressionOfOptionalChainRoot(expression) ? getNonNullableType(exprType) : ts2.isOptionalChain(expression) ? removeOptionalTypeMarker(exprType) : exprType;
        }
        function isCoercibleUnderDoubleEquals(source, target) {
          return (source.flags & (8 | 4 | 512)) !== 0 && (target.flags & (8 | 4 | 16)) !== 0;
        }
        function isObjectTypeWithInferableIndex(type) {
          return type.flags & 2097152 ? ts2.every(type.types, isObjectTypeWithInferableIndex) : !!(type.symbol && (type.symbol.flags & (4096 | 2048 | 384 | 512)) !== 0 && !typeHasCallOrConstructSignatures(type)) || !!(ts2.getObjectFlags(type) & 2048 && isObjectTypeWithInferableIndex(type.source));
        }
        function createSymbolWithType(source, type) {
          var symbol = createSymbol(source.flags, source.escapedName, ts2.getCheckFlags(source) & 8);
          symbol.declarations = source.declarations;
          symbol.parent = source.parent;
          symbol.type = type;
          symbol.target = source;
          if (source.valueDeclaration) {
            symbol.valueDeclaration = source.valueDeclaration;
          }
          var nameType = getSymbolLinks(source).nameType;
          if (nameType) {
            symbol.nameType = nameType;
          }
          return symbol;
        }
        function transformTypeOfMembers(type, f) {
          var members = ts2.createSymbolTable();
          for (var _i = 0, _a = getPropertiesOfObjectType(type); _i < _a.length; _i++) {
            var property = _a[_i];
            var original = getTypeOfSymbol(property);
            var updated = f(original);
            members.set(property.escapedName, updated === original ? property : createSymbolWithType(property, updated));
          }
          return members;
        }
        function getRegularTypeOfObjectLiteral(type) {
          if (!(isObjectLiteralType(type) && ts2.getObjectFlags(type) & 32768)) {
            return type;
          }
          var regularType = type.regularType;
          if (regularType) {
            return regularType;
          }
          var resolved = type;
          var members = transformTypeOfMembers(type, getRegularTypeOfObjectLiteral);
          var regularNew = createAnonymousType(resolved.symbol, members, resolved.callSignatures, resolved.constructSignatures, resolved.stringIndexInfo, resolved.numberIndexInfo);
          regularNew.flags = resolved.flags;
          regularNew.objectFlags |= resolved.objectFlags & ~32768;
          type.regularType = regularNew;
          return regularNew;
        }
        function createWideningContext(parent, propertyName, siblings) {
          return { parent, propertyName, siblings, resolvedProperties: void 0 };
        }
        function getSiblingsOfContext(context) {
          if (!context.siblings) {
            var siblings_1 = [];
            for (var _i = 0, _a = getSiblingsOfContext(context.parent); _i < _a.length; _i++) {
              var type = _a[_i];
              if (isObjectLiteralType(type)) {
                var prop = getPropertyOfObjectType(type, context.propertyName);
                if (prop) {
                  forEachType(getTypeOfSymbol(prop), function(t) {
                    siblings_1.push(t);
                  });
                }
              }
            }
            context.siblings = siblings_1;
          }
          return context.siblings;
        }
        function getPropertiesOfContext(context) {
          if (!context.resolvedProperties) {
            var names = ts2.createMap();
            for (var _i = 0, _a = getSiblingsOfContext(context); _i < _a.length; _i++) {
              var t = _a[_i];
              if (isObjectLiteralType(t) && !(ts2.getObjectFlags(t) & 1024)) {
                for (var _b = 0, _c = getPropertiesOfType(t); _b < _c.length; _b++) {
                  var prop = _c[_b];
                  names.set(prop.escapedName, prop);
                }
              }
            }
            context.resolvedProperties = ts2.arrayFrom(names.values());
          }
          return context.resolvedProperties;
        }
        function getWidenedProperty(prop, context) {
          if (!(prop.flags & 4)) {
            return prop;
          }
          var original = getTypeOfSymbol(prop);
          var propContext = context && createWideningContext(context, prop.escapedName, void 0);
          var widened = getWidenedTypeWithContext(original, propContext);
          return widened === original ? prop : createSymbolWithType(prop, widened);
        }
        function getUndefinedProperty(prop) {
          var cached = undefinedProperties.get(prop.escapedName);
          if (cached) {
            return cached;
          }
          var result = createSymbolWithType(prop, undefinedType);
          result.flags |= 16777216;
          undefinedProperties.set(prop.escapedName, result);
          return result;
        }
        function getWidenedTypeOfObjectLiteral(type, context) {
          var members = ts2.createSymbolTable();
          for (var _i = 0, _a = getPropertiesOfObjectType(type); _i < _a.length; _i++) {
            var prop = _a[_i];
            members.set(prop.escapedName, getWidenedProperty(prop, context));
          }
          if (context) {
            for (var _b = 0, _c = getPropertiesOfContext(context); _b < _c.length; _b++) {
              var prop = _c[_b];
              if (!members.has(prop.escapedName)) {
                members.set(prop.escapedName, getUndefinedProperty(prop));
              }
            }
          }
          var stringIndexInfo = getIndexInfoOfType(type, 0);
          var numberIndexInfo = getIndexInfoOfType(type, 1);
          var result = createAnonymousType(type.symbol, members, ts2.emptyArray, ts2.emptyArray, stringIndexInfo && createIndexInfo(getWidenedType(stringIndexInfo.type), stringIndexInfo.isReadonly), numberIndexInfo && createIndexInfo(getWidenedType(numberIndexInfo.type), numberIndexInfo.isReadonly));
          result.objectFlags |= ts2.getObjectFlags(type) & (16384 | 2097152);
          return result;
        }
        function getWidenedType(type) {
          return getWidenedTypeWithContext(type, void 0);
        }
        function getWidenedTypeWithContext(type, context) {
          if (ts2.getObjectFlags(type) & 1572864) {
            if (context === void 0 && type.widened) {
              return type.widened;
            }
            var result = void 0;
            if (type.flags & (1 | 98304)) {
              result = anyType;
            } else if (isObjectLiteralType(type)) {
              result = getWidenedTypeOfObjectLiteral(type, context);
            } else if (type.flags & 1048576) {
              var unionContext_1 = context || createWideningContext(void 0, void 0, type.types);
              var widenedTypes = ts2.sameMap(type.types, function(t) {
                return t.flags & 98304 ? t : getWidenedTypeWithContext(t, unionContext_1);
              });
              result = getUnionType(widenedTypes, ts2.some(widenedTypes, isEmptyObjectType) ? 2 : 1);
            } else if (type.flags & 2097152) {
              result = getIntersectionType(ts2.sameMap(type.types, getWidenedType));
            } else if (isArrayType(type) || isTupleType(type)) {
              result = createTypeReference(type.target, ts2.sameMap(getTypeArguments(type), getWidenedType));
            }
            if (result && context === void 0) {
              type.widened = result;
            }
            return result || type;
          }
          return type;
        }
        function reportWideningErrorsInType(type) {
          var errorReported = false;
          if (ts2.getObjectFlags(type) & 524288) {
            if (type.flags & 1048576) {
              if (ts2.some(type.types, isEmptyObjectType)) {
                errorReported = true;
              } else {
                for (var _i = 0, _a = type.types; _i < _a.length; _i++) {
                  var t = _a[_i];
                  if (reportWideningErrorsInType(t)) {
                    errorReported = true;
                  }
                }
              }
            }
            if (isArrayType(type) || isTupleType(type)) {
              for (var _b = 0, _c = getTypeArguments(type); _b < _c.length; _b++) {
                var t = _c[_b];
                if (reportWideningErrorsInType(t)) {
                  errorReported = true;
                }
              }
            }
            if (isObjectLiteralType(type)) {
              for (var _d = 0, _e = getPropertiesOfObjectType(type); _d < _e.length; _d++) {
                var p = _e[_d];
                var t = getTypeOfSymbol(p);
                if (ts2.getObjectFlags(t) & 524288) {
                  if (!reportWideningErrorsInType(t)) {
                    error(p.valueDeclaration, ts2.Diagnostics.Object_literal_s_property_0_implicitly_has_an_1_type, symbolToString(p), typeToString(getWidenedType(t)));
                  }
                  errorReported = true;
                }
              }
            }
          }
          return errorReported;
        }
        function reportImplicitAny(declaration, type, wideningKind) {
          var typeAsString = typeToString(getWidenedType(type));
          if (ts2.isInJSFile(declaration) && !ts2.isCheckJsEnabledForFile(ts2.getSourceFileOfNode(declaration), compilerOptions)) {
            return;
          }
          var diagnostic;
          switch (declaration.kind) {
            case 209:
            case 159:
            case 158:
              diagnostic = noImplicitAny ? ts2.Diagnostics.Member_0_implicitly_has_an_1_type : ts2.Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;
              break;
            case 156:
              var param = declaration;
              if (ts2.isIdentifier(param.name) && (ts2.isCallSignatureDeclaration(param.parent) || ts2.isMethodSignature(param.parent) || ts2.isFunctionTypeNode(param.parent)) && param.parent.parameters.indexOf(param) > -1 && (resolveName(param, param.name.escapedText, 788968, void 0, param.name.escapedText, true) || param.name.originalKeywordKind && ts2.isTypeNodeKind(param.name.originalKeywordKind))) {
                var newName = "arg" + param.parent.parameters.indexOf(param);
                errorOrSuggestion(noImplicitAny, declaration, ts2.Diagnostics.Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1, newName, ts2.declarationNameToString(param.name));
                return;
              }
              diagnostic = declaration.dotDotDotToken ? noImplicitAny ? ts2.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type : ts2.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage : noImplicitAny ? ts2.Diagnostics.Parameter_0_implicitly_has_an_1_type : ts2.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;
              break;
            case 191:
              diagnostic = ts2.Diagnostics.Binding_element_0_implicitly_has_an_1_type;
              if (!noImplicitAny) {
                return;
              }
              break;
            case 300:
              error(declaration, ts2.Diagnostics.Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type, typeAsString);
              return;
            case 244:
            case 161:
            case 160:
            case 163:
            case 164:
            case 201:
            case 202:
              if (noImplicitAny && !declaration.name) {
                if (wideningKind === 3) {
                  error(declaration, ts2.Diagnostics.Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type_annotation, typeAsString);
                } else {
                  error(declaration, ts2.Diagnostics.Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type, typeAsString);
                }
                return;
              }
              diagnostic = !noImplicitAny ? ts2.Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage : wideningKind === 3 ? ts2.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type : ts2.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type;
              break;
            case 186:
              if (noImplicitAny) {
                error(declaration, ts2.Diagnostics.Mapped_object_type_implicitly_has_an_any_template_type);
              }
              return;
            default:
              diagnostic = noImplicitAny ? ts2.Diagnostics.Variable_0_implicitly_has_an_1_type : ts2.Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;
          }
          errorOrSuggestion(noImplicitAny, declaration, diagnostic, ts2.declarationNameToString(ts2.getNameOfDeclaration(declaration)), typeAsString);
        }
        function reportErrorsFromWidening(declaration, type, wideningKind) {
          if (produceDiagnostics && noImplicitAny && ts2.getObjectFlags(type) & 524288 && (!wideningKind || !getContextualSignatureForFunctionLikeDeclaration(declaration))) {
            if (!reportWideningErrorsInType(type)) {
              reportImplicitAny(declaration, type, wideningKind);
            }
          }
        }
        function applyToParameterTypes(source, target, callback) {
          var sourceCount = getParameterCount(source);
          var targetCount = getParameterCount(target);
          var sourceRestType = getEffectiveRestType(source);
          var targetRestType = getEffectiveRestType(target);
          var targetNonRestCount = targetRestType ? targetCount - 1 : targetCount;
          var paramCount = sourceRestType ? targetNonRestCount : Math.min(sourceCount, targetNonRestCount);
          var sourceThisType = getThisTypeOfSignature(source);
          if (sourceThisType) {
            var targetThisType = getThisTypeOfSignature(target);
            if (targetThisType) {
              callback(sourceThisType, targetThisType);
            }
          }
          for (var i = 0; i < paramCount; i++) {
            callback(getTypeAtPosition(source, i), getTypeAtPosition(target, i));
          }
          if (targetRestType) {
            callback(getRestTypeAtPosition(source, paramCount), targetRestType);
          }
        }
        function applyToReturnTypes(source, target, callback) {
          var sourceTypePredicate = getTypePredicateOfSignature(source);
          var targetTypePredicate = getTypePredicateOfSignature(target);
          if (sourceTypePredicate && targetTypePredicate && typePredicateKindsMatch(sourceTypePredicate, targetTypePredicate) && sourceTypePredicate.type && targetTypePredicate.type) {
            callback(sourceTypePredicate.type, targetTypePredicate.type);
          } else {
            callback(getReturnTypeOfSignature(source), getReturnTypeOfSignature(target));
          }
        }
        function createInferenceContext(typeParameters, signature, flags, compareTypes) {
          return createInferenceContextWorker(typeParameters.map(createInferenceInfo), signature, flags, compareTypes || compareTypesAssignable);
        }
        function cloneInferenceContext(context, extraFlags) {
          if (extraFlags === void 0) {
            extraFlags = 0;
          }
          return context && createInferenceContextWorker(ts2.map(context.inferences, cloneInferenceInfo), context.signature, context.flags | extraFlags, context.compareTypes);
        }
        function createInferenceContextWorker(inferences, signature, flags, compareTypes) {
          var context = {
            inferences,
            signature,
            flags,
            compareTypes,
            mapper: makeFunctionTypeMapper(function(t) {
              return mapToInferredType(context, t, true);
            }),
            nonFixingMapper: makeFunctionTypeMapper(function(t) {
              return mapToInferredType(context, t, false);
            })
          };
          return context;
        }
        function mapToInferredType(context, t, fix) {
          var inferences = context.inferences;
          for (var i = 0; i < inferences.length; i++) {
            var inference = inferences[i];
            if (t === inference.typeParameter) {
              if (fix && !inference.isFixed) {
                clearCachedInferences(inferences);
                inference.isFixed = true;
              }
              return getInferredType(context, i);
            }
          }
          return t;
        }
        function clearCachedInferences(inferences) {
          for (var _i = 0, inferences_1 = inferences; _i < inferences_1.length; _i++) {
            var inference = inferences_1[_i];
            if (!inference.isFixed) {
              inference.inferredType = void 0;
            }
          }
        }
        function createInferenceInfo(typeParameter) {
          return {
            typeParameter,
            candidates: void 0,
            contraCandidates: void 0,
            inferredType: void 0,
            priority: void 0,
            topLevel: true,
            isFixed: false
          };
        }
        function cloneInferenceInfo(inference) {
          return {
            typeParameter: inference.typeParameter,
            candidates: inference.candidates && inference.candidates.slice(),
            contraCandidates: inference.contraCandidates && inference.contraCandidates.slice(),
            inferredType: inference.inferredType,
            priority: inference.priority,
            topLevel: inference.topLevel,
            isFixed: inference.isFixed
          };
        }
        function cloneInferredPartOfContext(context) {
          var inferences = ts2.filter(context.inferences, hasInferenceCandidates);
          return inferences.length ? createInferenceContextWorker(ts2.map(inferences, cloneInferenceInfo), context.signature, context.flags, context.compareTypes) : void 0;
        }
        function getMapperFromContext(context) {
          return context && context.mapper;
        }
        function couldContainTypeVariables(type) {
          var objectFlags = ts2.getObjectFlags(type);
          if (objectFlags & 67108864) {
            return !!(objectFlags & 134217728);
          }
          var result = !!(type.flags & 63176704 || objectFlags & 4 && (type.node || ts2.forEach(getTypeArguments(type), couldContainTypeVariables)) || objectFlags & 16 && type.symbol && type.symbol.flags & (16 | 8192 | 32 | 2048 | 4096) && type.symbol.declarations || objectFlags & (32 | 131072) || type.flags & 3145728 && !(type.flags & 1024) && ts2.some(type.types, couldContainTypeVariables));
          if (type.flags & 3899393) {
            type.objectFlags |= 67108864 | (result ? 134217728 : 0);
          }
          return result;
        }
        function isTypeParameterAtTopLevel(type, typeParameter) {
          return !!(type === typeParameter || type.flags & 3145728 && ts2.some(type.types, function(t) {
            return isTypeParameterAtTopLevel(t, typeParameter);
          }) || type.flags & 16777216 && (isTypeParameterAtTopLevel(getTrueTypeFromConditionalType(type), typeParameter) || isTypeParameterAtTopLevel(getFalseTypeFromConditionalType(type), typeParameter)));
        }
        function createEmptyObjectTypeFromStringLiteral(type) {
          var members = ts2.createSymbolTable();
          forEachType(type, function(t) {
            if (!(t.flags & 128)) {
              return;
            }
            var name = ts2.escapeLeadingUnderscores(t.value);
            var literalProp = createSymbol(4, name);
            literalProp.type = anyType;
            if (t.symbol) {
              literalProp.declarations = t.symbol.declarations;
              literalProp.valueDeclaration = t.symbol.valueDeclaration;
            }
            members.set(name, literalProp);
          });
          var indexInfo = type.flags & 4 ? createIndexInfo(emptyObjectType, false) : void 0;
          return createAnonymousType(void 0, members, ts2.emptyArray, ts2.emptyArray, indexInfo, void 0);
        }
        function inferTypeForHomomorphicMappedType(source, target, constraint) {
          var key = source.id + "," + target.id + "," + constraint.id;
          if (reverseMappedCache.has(key)) {
            return reverseMappedCache.get(key);
          }
          reverseMappedCache.set(key, void 0);
          var type = createReverseMappedType(source, target, constraint);
          reverseMappedCache.set(key, type);
          return type;
        }
        function isPartiallyInferableType(type) {
          return !(ts2.getObjectFlags(type) & 2097152) || isObjectLiteralType(type) && ts2.some(getPropertiesOfType(type), function(prop) {
            return isPartiallyInferableType(getTypeOfSymbol(prop));
          });
        }
        function createReverseMappedType(source, target, constraint) {
          if (!(getIndexInfoOfType(source, 0) || getPropertiesOfType(source).length !== 0 && isPartiallyInferableType(source))) {
            return void 0;
          }
          if (isArrayType(source)) {
            return createArrayType(inferReverseMappedType(getTypeArguments(source)[0], target, constraint), isReadonlyArrayType(source));
          }
          if (isTupleType(source)) {
            var elementTypes = ts2.map(getTypeArguments(source), function(t) {
              return inferReverseMappedType(t, target, constraint);
            });
            var minLength = getMappedTypeModifiers(target) & 4 ? getTypeReferenceArity(source) - (source.target.hasRestElement ? 1 : 0) : source.target.minLength;
            return createTupleType(elementTypes, minLength, source.target.hasRestElement, source.target.readonly, source.target.associatedNames);
          }
          var reversed = createObjectType(2048 | 16, void 0);
          reversed.source = source;
          reversed.mappedType = target;
          reversed.constraintType = constraint;
          return reversed;
        }
        function getTypeOfReverseMappedSymbol(symbol) {
          return inferReverseMappedType(symbol.propertyType, symbol.mappedType, symbol.constraintType);
        }
        function inferReverseMappedType(sourceType, target, constraint) {
          var typeParameter = getIndexedAccessType(constraint.type, getTypeParameterFromMappedType(target));
          var templateType = getTemplateTypeFromMappedType(target);
          var inference = createInferenceInfo(typeParameter);
          inferTypes([inference], sourceType, templateType);
          return getTypeFromInference(inference) || unknownType;
        }
        function getUnmatchedProperties(source, target, requireOptionalProperties, matchDiscriminantProperties) {
          var properties, _i, properties_2, targetProp, sourceProp, targetType, sourceType;
          return __generator(this, function(_a) {
            switch (_a.label) {
              case 0:
                properties = getPropertiesOfType(target);
                _i = 0, properties_2 = properties;
                _a.label = 1;
              case 1:
                if (!(_i < properties_2.length))
                  return [3, 6];
                targetProp = properties_2[_i];
                if (isStaticPrivateIdentifierProperty(targetProp)) {
                  return [3, 5];
                }
                if (!(requireOptionalProperties || !(targetProp.flags & 16777216 || ts2.getCheckFlags(targetProp) & 48)))
                  return [3, 5];
                sourceProp = getPropertyOfType(source, targetProp.escapedName);
                if (!!sourceProp)
                  return [3, 3];
                return [4, targetProp];
              case 2:
                _a.sent();
                return [3, 5];
              case 3:
                if (!matchDiscriminantProperties)
                  return [3, 5];
                targetType = getTypeOfSymbol(targetProp);
                if (!(targetType.flags & 109440))
                  return [3, 5];
                sourceType = getTypeOfSymbol(sourceProp);
                if (!!(sourceType.flags & 1 || getRegularTypeOfLiteralType(sourceType) === getRegularTypeOfLiteralType(targetType)))
                  return [3, 5];
                return [4, targetProp];
              case 4:
                _a.sent();
                _a.label = 5;
              case 5:
                _i++;
                return [3, 1];
              case 6:
                return [2];
            }
          });
        }
        function getUnmatchedProperty(source, target, requireOptionalProperties, matchDiscriminantProperties) {
          var result = getUnmatchedProperties(source, target, requireOptionalProperties, matchDiscriminantProperties).next();
          if (!result.done)
            return result.value;
        }
        function tupleTypesDefinitelyUnrelated(source, target) {
          return target.target.minLength > source.target.minLength || !getRestTypeOfTupleType(target) && (!!getRestTypeOfTupleType(source) || getLengthOfTupleType(target) < getLengthOfTupleType(source));
        }
        function typesDefinitelyUnrelated(source, target) {
          return isTupleType(source) && isTupleType(target) && tupleTypesDefinitelyUnrelated(source, target) || !!getUnmatchedProperty(source, target, false, true) && !!getUnmatchedProperty(target, source, false, true);
        }
        function getTypeFromInference(inference) {
          return inference.candidates ? getUnionType(inference.candidates, 2) : inference.contraCandidates ? getIntersectionType(inference.contraCandidates) : void 0;
        }
        function hasSkipDirectInferenceFlag(node) {
          return !!getNodeLinks(node).skipDirectInference;
        }
        function isFromInferenceBlockedSource(type) {
          return !!(type.symbol && ts2.some(type.symbol.declarations, hasSkipDirectInferenceFlag));
        }
        function inferTypes(inferences, originalSource, originalTarget, priority, contravariant) {
          if (priority === void 0) {
            priority = 0;
          }
          if (contravariant === void 0) {
            contravariant = false;
          }
          var symbolOrTypeStack;
          var visited;
          var bivariant = false;
          var propagationType;
          var inferencePriority = 512;
          var allowComplexConstraintInference = true;
          inferFromTypes(originalSource, originalTarget);
          function inferFromTypes(source, target) {
            if (!couldContainTypeVariables(target)) {
              return;
            }
            if (source === wildcardType) {
              var savePropagationType = propagationType;
              propagationType = source;
              inferFromTypes(target, target);
              propagationType = savePropagationType;
              return;
            }
            if (source.aliasSymbol && source.aliasTypeArguments && source.aliasSymbol === target.aliasSymbol) {
              inferFromTypeArguments(source.aliasTypeArguments, target.aliasTypeArguments, getAliasVariances(source.aliasSymbol));
              return;
            }
            if (source === target && source.flags & 3145728) {
              for (var _i = 0, _a = source.types; _i < _a.length; _i++) {
                var t = _a[_i];
                inferFromTypes(t, t);
              }
              return;
            }
            if (target.flags & 1048576) {
              var _b = inferFromMatchingTypes(source.flags & 1048576 ? source.types : [source], target.types, isTypeOrBaseIdenticalTo), tempSources = _b[0], tempTargets = _b[1];
              var _c = inferFromMatchingTypes(tempSources, tempTargets, isTypeCloselyMatchedBy), sources = _c[0], targets = _c[1];
              if (targets.length === 0) {
                return;
              }
              target = getUnionType(targets);
              if (sources.length === 0) {
                inferWithPriority(source, target, 1);
                return;
              }
              source = getUnionType(sources);
            } else if (target.flags & 2097152 && ts2.some(target.types, function(t2) {
              return !!getInferenceInfoForType(t2) || isGenericMappedType(t2) && !!getInferenceInfoForType(getHomomorphicTypeVariable(t2) || neverType);
            })) {
              if (!(source.flags & 1048576)) {
                var _d = inferFromMatchingTypes(source.flags & 2097152 ? source.types : [source], target.types, isTypeIdenticalTo), sources = _d[0], targets = _d[1];
                if (sources.length === 0 || targets.length === 0) {
                  return;
                }
                source = getIntersectionType(sources);
                target = getIntersectionType(targets);
              }
            } else if (target.flags & (8388608 | 33554432)) {
              target = getActualTypeVariable(target);
            }
            if (target.flags & 8650752) {
              if (ts2.getObjectFlags(source) & 2097152 || source === nonInferrableAnyType || source === silentNeverType || priority & 32 && (source === autoType || source === autoArrayType) || isFromInferenceBlockedSource(source)) {
                return;
              }
              var inference = getInferenceInfoForType(target);
              if (inference) {
                if (!inference.isFixed) {
                  if (inference.priority === void 0 || priority < inference.priority) {
                    inference.candidates = void 0;
                    inference.contraCandidates = void 0;
                    inference.topLevel = true;
                    inference.priority = priority;
                  }
                  if (priority === inference.priority) {
                    var candidate = propagationType || source;
                    if (contravariant && !bivariant) {
                      if (!ts2.contains(inference.contraCandidates, candidate)) {
                        inference.contraCandidates = ts2.append(inference.contraCandidates, candidate);
                        clearCachedInferences(inferences);
                      }
                    } else if (!ts2.contains(inference.candidates, candidate)) {
                      inference.candidates = ts2.append(inference.candidates, candidate);
                      clearCachedInferences(inferences);
                    }
                  }
                  if (!(priority & 32) && target.flags & 262144 && inference.topLevel && !isTypeParameterAtTopLevel(originalTarget, target)) {
                    inference.topLevel = false;
                    clearCachedInferences(inferences);
                  }
                }
                inferencePriority = Math.min(inferencePriority, priority);
                return;
              } else {
                var simplified = getSimplifiedType(target, false);
                if (simplified !== target) {
                  invokeOnce(source, simplified, inferFromTypes);
                } else if (target.flags & 8388608) {
                  var indexType = getSimplifiedType(target.indexType, false);
                  if (indexType.flags & 63176704) {
                    var simplified_1 = distributeIndexOverObjectType(getSimplifiedType(target.objectType, false), indexType, false);
                    if (simplified_1 && simplified_1 !== target) {
                      invokeOnce(source, simplified_1, inferFromTypes);
                    }
                  }
                }
              }
            }
            if (ts2.getObjectFlags(source) & 4 && ts2.getObjectFlags(target) & 4 && (source.target === target.target || isArrayType(source) && isArrayType(target)) && !(source.node && target.node)) {
              inferFromTypeArguments(getTypeArguments(source), getTypeArguments(target), getVariances(source.target));
            } else if (source.flags & 4194304 && target.flags & 4194304) {
              contravariant = !contravariant;
              inferFromTypes(source.type, target.type);
              contravariant = !contravariant;
            } else if ((isLiteralType(source) || source.flags & 4) && target.flags & 4194304) {
              var empty = createEmptyObjectTypeFromStringLiteral(source);
              contravariant = !contravariant;
              inferWithPriority(empty, target.type, 64);
              contravariant = !contravariant;
            } else if (source.flags & 8388608 && target.flags & 8388608) {
              inferFromTypes(source.objectType, target.objectType);
              inferFromTypes(source.indexType, target.indexType);
            } else if (source.flags & 16777216 && target.flags & 16777216) {
              inferFromTypes(source.checkType, target.checkType);
              inferFromTypes(source.extendsType, target.extendsType);
              inferFromTypes(getTrueTypeFromConditionalType(source), getTrueTypeFromConditionalType(target));
              inferFromTypes(getFalseTypeFromConditionalType(source), getFalseTypeFromConditionalType(target));
            } else if (target.flags & 16777216) {
              var savePriority = priority;
              priority |= contravariant ? 16 : 0;
              var targetTypes = [getTrueTypeFromConditionalType(target), getFalseTypeFromConditionalType(target)];
              inferToMultipleTypes(source, targetTypes, target.flags);
              priority = savePriority;
            } else if (target.flags & 3145728) {
              inferToMultipleTypes(source, target.types, target.flags);
            } else if (source.flags & 1048576) {
              var sourceTypes = source.types;
              for (var _e = 0, sourceTypes_2 = sourceTypes; _e < sourceTypes_2.length; _e++) {
                var sourceType = sourceTypes_2[_e];
                inferFromTypes(sourceType, target);
              }
            } else {
              source = getReducedType(source);
              if (!(priority & 128 && source.flags & (2097152 | 63176704))) {
                var apparentSource = getApparentType(source);
                if (apparentSource !== source && allowComplexConstraintInference && !(apparentSource.flags & (524288 | 2097152))) {
                  allowComplexConstraintInference = false;
                  return inferFromTypes(apparentSource, target);
                }
                source = apparentSource;
              }
              if (source.flags & (524288 | 2097152)) {
                invokeOnce(source, target, inferFromObjectTypes);
              }
            }
            if (source.flags & 25165824) {
              var simplified = getSimplifiedType(source, contravariant);
              if (simplified !== source) {
                inferFromTypes(simplified, target);
              }
            }
          }
          function inferWithPriority(source, target, newPriority) {
            var savePriority = priority;
            priority |= newPriority;
            inferFromTypes(source, target);
            priority = savePriority;
          }
          function invokeOnce(source, target, action) {
            var key = source.id + "," + target.id;
            var status = visited && visited.get(key);
            if (status !== void 0) {
              inferencePriority = Math.min(inferencePriority, status);
              return;
            }
            (visited || (visited = ts2.createMap())).set(key, -1);
            var saveInferencePriority = inferencePriority;
            inferencePriority = 512;
            action(source, target);
            visited.set(key, inferencePriority);
            inferencePriority = Math.min(inferencePriority, saveInferencePriority);
          }
          function inferFromMatchingTypes(sources, targets, matches) {
            var matchedSources;
            var matchedTargets;
            for (var _i = 0, targets_1 = targets; _i < targets_1.length; _i++) {
              var t = targets_1[_i];
              for (var _a = 0, sources_1 = sources; _a < sources_1.length; _a++) {
                var s = sources_1[_a];
                if (matches(s, t)) {
                  inferFromTypes(s, t);
                  matchedSources = ts2.appendIfUnique(matchedSources, s);
                  matchedTargets = ts2.appendIfUnique(matchedTargets, t);
                }
              }
            }
            return [
              matchedSources ? ts2.filter(sources, function(t2) {
                return !ts2.contains(matchedSources, t2);
              }) : sources,
              matchedTargets ? ts2.filter(targets, function(t2) {
                return !ts2.contains(matchedTargets, t2);
              }) : targets
            ];
          }
          function inferFromTypeArguments(sourceTypes, targetTypes, variances) {
            var count = sourceTypes.length < targetTypes.length ? sourceTypes.length : targetTypes.length;
            for (var i = 0; i < count; i++) {
              if (i < variances.length && (variances[i] & 7) === 2) {
                inferFromContravariantTypes(sourceTypes[i], targetTypes[i]);
              } else {
                inferFromTypes(sourceTypes[i], targetTypes[i]);
              }
            }
          }
          function inferFromContravariantTypes(source, target) {
            if (strictFunctionTypes || priority & 256) {
              contravariant = !contravariant;
              inferFromTypes(source, target);
              contravariant = !contravariant;
            } else {
              inferFromTypes(source, target);
            }
          }
          function getInferenceInfoForType(type) {
            if (type.flags & 8650752) {
              for (var _i = 0, inferences_2 = inferences; _i < inferences_2.length; _i++) {
                var inference = inferences_2[_i];
                if (type === inference.typeParameter) {
                  return inference;
                }
              }
            }
            return void 0;
          }
          function getSingleTypeVariableFromIntersectionTypes(types) {
            var typeVariable;
            for (var _i = 0, types_14 = types; _i < types_14.length; _i++) {
              var type = types_14[_i];
              var t = type.flags & 2097152 && ts2.find(type.types, function(t2) {
                return !!getInferenceInfoForType(t2);
              });
              if (!t || typeVariable && t !== typeVariable) {
                return void 0;
              }
              typeVariable = t;
            }
            return typeVariable;
          }
          function inferToMultipleTypes(source, targets, targetFlags) {
            var typeVariableCount = 0;
            if (targetFlags & 1048576) {
              var nakedTypeVariable = void 0;
              var sources = source.flags & 1048576 ? source.types : [source];
              var matched_1 = new Array(sources.length);
              var inferenceCircularity = false;
              for (var _i = 0, targets_2 = targets; _i < targets_2.length; _i++) {
                var t = targets_2[_i];
                if (getInferenceInfoForType(t)) {
                  nakedTypeVariable = t;
                  typeVariableCount++;
                } else {
                  for (var i = 0; i < sources.length; i++) {
                    var saveInferencePriority = inferencePriority;
                    inferencePriority = 512;
                    inferFromTypes(sources[i], t);
                    if (inferencePriority === priority)
                      matched_1[i] = true;
                    inferenceCircularity = inferenceCircularity || inferencePriority === -1;
                    inferencePriority = Math.min(inferencePriority, saveInferencePriority);
                  }
                }
              }
              if (typeVariableCount === 0) {
                var intersectionTypeVariable = getSingleTypeVariableFromIntersectionTypes(targets);
                if (intersectionTypeVariable) {
                  inferWithPriority(source, intersectionTypeVariable, 1);
                }
                return;
              }
              if (typeVariableCount === 1 && !inferenceCircularity) {
                var unmatched = ts2.flatMap(sources, function(s, i2) {
                  return matched_1[i2] ? void 0 : s;
                });
                if (unmatched.length) {
                  inferFromTypes(getUnionType(unmatched), nakedTypeVariable);
                  return;
                }
              }
            } else {
              for (var _a = 0, targets_3 = targets; _a < targets_3.length; _a++) {
                var t = targets_3[_a];
                if (getInferenceInfoForType(t)) {
                  typeVariableCount++;
                } else {
                  inferFromTypes(source, t);
                }
              }
            }
            if (targetFlags & 2097152 ? typeVariableCount === 1 : typeVariableCount > 0) {
              for (var _b = 0, targets_4 = targets; _b < targets_4.length; _b++) {
                var t = targets_4[_b];
                if (getInferenceInfoForType(t)) {
                  inferWithPriority(source, t, 1);
                }
              }
            }
          }
          function inferToMappedType(source, target, constraintType) {
            if (constraintType.flags & 1048576) {
              var result = false;
              for (var _i = 0, _a = constraintType.types; _i < _a.length; _i++) {
                var type = _a[_i];
                result = inferToMappedType(source, target, type) || result;
              }
              return result;
            }
            if (constraintType.flags & 4194304) {
              var inference = getInferenceInfoForType(constraintType.type);
              if (inference && !inference.isFixed && !isFromInferenceBlockedSource(source)) {
                var inferredType = inferTypeForHomomorphicMappedType(source, target, constraintType);
                if (inferredType) {
                  inferWithPriority(inferredType, inference.typeParameter, ts2.getObjectFlags(source) & 2097152 ? 4 : 2);
                }
              }
              return true;
            }
            if (constraintType.flags & 262144) {
              inferWithPriority(getIndexType(source), constraintType, 8);
              var extendedConstraint = getConstraintOfType(constraintType);
              if (extendedConstraint && inferToMappedType(source, target, extendedConstraint)) {
                return true;
              }
              var propTypes = ts2.map(getPropertiesOfType(source), getTypeOfSymbol);
              var stringIndexType = getIndexTypeOfType(source, 0);
              var numberIndexInfo = getNonEnumNumberIndexInfo(source);
              var numberIndexType = numberIndexInfo && numberIndexInfo.type;
              inferFromTypes(getUnionType(ts2.append(ts2.append(propTypes, stringIndexType), numberIndexType)), getTemplateTypeFromMappedType(target));
              return true;
            }
            return false;
          }
          function inferFromObjectTypes(source, target) {
            var isNonConstructorObject = target.flags & 524288 && !(ts2.getObjectFlags(target) & 16 && target.symbol && target.symbol.flags & 32);
            var symbolOrType = isNonConstructorObject ? isTupleType(target) ? target.target : target.symbol : void 0;
            if (symbolOrType) {
              if (ts2.contains(symbolOrTypeStack, symbolOrType)) {
                inferencePriority = -1;
                return;
              }
              (symbolOrTypeStack || (symbolOrTypeStack = [])).push(symbolOrType);
              inferFromObjectTypesWorker(source, target);
              symbolOrTypeStack.pop();
            } else {
              inferFromObjectTypesWorker(source, target);
            }
          }
          function inferFromObjectTypesWorker(source, target) {
            if (ts2.getObjectFlags(source) & 4 && ts2.getObjectFlags(target) & 4 && (source.target === target.target || isArrayType(source) && isArrayType(target))) {
              inferFromTypeArguments(getTypeArguments(source), getTypeArguments(target), getVariances(source.target));
              return;
            }
            if (isGenericMappedType(source) && isGenericMappedType(target)) {
              inferFromTypes(getConstraintTypeFromMappedType(source), getConstraintTypeFromMappedType(target));
              inferFromTypes(getTemplateTypeFromMappedType(source), getTemplateTypeFromMappedType(target));
            }
            if (ts2.getObjectFlags(target) & 32) {
              var constraintType = getConstraintTypeFromMappedType(target);
              if (inferToMappedType(source, target, constraintType)) {
                return;
              }
            }
            if (!typesDefinitelyUnrelated(source, target)) {
              if (isArrayType(source) || isTupleType(source)) {
                if (isTupleType(target)) {
                  var sourceLength = isTupleType(source) ? getLengthOfTupleType(source) : 0;
                  var targetLength = getLengthOfTupleType(target);
                  var sourceRestType = isTupleType(source) ? getRestTypeOfTupleType(source) : getElementTypeOfArrayType(source);
                  var targetRestType = getRestTypeOfTupleType(target);
                  var fixedLength = targetLength < sourceLength || sourceRestType ? targetLength : sourceLength;
                  for (var i = 0; i < fixedLength; i++) {
                    inferFromTypes(i < sourceLength ? getTypeArguments(source)[i] : sourceRestType, getTypeArguments(target)[i]);
                  }
                  if (targetRestType) {
                    var types = fixedLength < sourceLength ? getTypeArguments(source).slice(fixedLength, sourceLength) : [];
                    if (sourceRestType) {
                      types.push(sourceRestType);
                    }
                    if (types.length) {
                      inferFromTypes(getUnionType(types), targetRestType);
                    }
                  }
                  return;
                }
                if (isArrayType(target)) {
                  inferFromIndexTypes(source, target);
                  return;
                }
              }
              inferFromProperties(source, target);
              inferFromSignatures(source, target, 0);
              inferFromSignatures(source, target, 1);
              inferFromIndexTypes(source, target);
            }
          }
          function inferFromProperties(source, target) {
            var properties = getPropertiesOfObjectType(target);
            for (var _i = 0, properties_3 = properties; _i < properties_3.length; _i++) {
              var targetProp = properties_3[_i];
              var sourceProp = getPropertyOfType(source, targetProp.escapedName);
              if (sourceProp) {
                inferFromTypes(getTypeOfSymbol(sourceProp), getTypeOfSymbol(targetProp));
              }
            }
          }
          function inferFromSignatures(source, target, kind) {
            var sourceSignatures = getSignaturesOfType(source, kind);
            var targetSignatures = getSignaturesOfType(target, kind);
            var sourceLen = sourceSignatures.length;
            var targetLen = targetSignatures.length;
            var len = sourceLen < targetLen ? sourceLen : targetLen;
            var skipParameters = !!(ts2.getObjectFlags(source) & 2097152);
            for (var i = 0; i < len; i++) {
              inferFromSignature(getBaseSignature(sourceSignatures[sourceLen - len + i]), getErasedSignature(targetSignatures[targetLen - len + i]), skipParameters);
            }
          }
          function inferFromSignature(source, target, skipParameters) {
            if (!skipParameters) {
              var saveBivariant = bivariant;
              var kind = target.declaration ? target.declaration.kind : 0;
              bivariant = bivariant || kind === 161 || kind === 160 || kind === 162;
              applyToParameterTypes(source, target, inferFromContravariantTypes);
              bivariant = saveBivariant;
            }
            applyToReturnTypes(source, target, inferFromTypes);
          }
          function inferFromIndexTypes(source, target) {
            var targetStringIndexType = getIndexTypeOfType(target, 0);
            if (targetStringIndexType) {
              var sourceIndexType = getIndexTypeOfType(source, 0) || getImplicitIndexTypeOfType(source, 0);
              if (sourceIndexType) {
                inferFromTypes(sourceIndexType, targetStringIndexType);
              }
            }
            var targetNumberIndexType = getIndexTypeOfType(target, 1);
            if (targetNumberIndexType) {
              var sourceIndexType = getIndexTypeOfType(source, 1) || getIndexTypeOfType(source, 0) || getImplicitIndexTypeOfType(source, 1);
              if (sourceIndexType) {
                inferFromTypes(sourceIndexType, targetNumberIndexType);
              }
            }
          }
        }
        function isTypeOrBaseIdenticalTo(s, t) {
          return isTypeIdenticalTo(s, t) || !!(t.flags & 4 && s.flags & 128 || t.flags & 8 && s.flags & 256);
        }
        function isTypeCloselyMatchedBy(s, t) {
          return !!(s.flags & 524288 && t.flags & 524288 && s.symbol && s.symbol === t.symbol || s.aliasSymbol && s.aliasTypeArguments && s.aliasSymbol === t.aliasSymbol);
        }
        function hasPrimitiveConstraint(type) {
          var constraint = getConstraintOfTypeParameter(type);
          return !!constraint && maybeTypeOfKind(constraint.flags & 16777216 ? getDefaultConstraintOfConditionalType(constraint) : constraint, 131068 | 4194304);
        }
        function isObjectLiteralType(type) {
          return !!(ts2.getObjectFlags(type) & 128);
        }
        function isObjectOrArrayLiteralType(type) {
          return !!(ts2.getObjectFlags(type) & (128 | 65536));
        }
        function unionObjectAndArrayLiteralCandidates(candidates) {
          if (candidates.length > 1) {
            var objectLiterals = ts2.filter(candidates, isObjectOrArrayLiteralType);
            if (objectLiterals.length) {
              var literalsType = getUnionType(objectLiterals, 2);
              return ts2.concatenate(ts2.filter(candidates, function(t) {
                return !isObjectOrArrayLiteralType(t);
              }), [literalsType]);
            }
          }
          return candidates;
        }
        function getContravariantInference(inference) {
          return inference.priority & 104 ? getIntersectionType(inference.contraCandidates) : getCommonSubtype(inference.contraCandidates);
        }
        function getCovariantInference(inference, signature) {
          var candidates = unionObjectAndArrayLiteralCandidates(inference.candidates);
          var primitiveConstraint = hasPrimitiveConstraint(inference.typeParameter);
          var widenLiteralTypes = !primitiveConstraint && inference.topLevel && (inference.isFixed || !isTypeParameterAtTopLevel(getReturnTypeOfSignature(signature), inference.typeParameter));
          var baseCandidates = primitiveConstraint ? ts2.sameMap(candidates, getRegularTypeOfLiteralType) : widenLiteralTypes ? ts2.sameMap(candidates, getWidenedLiteralType) : candidates;
          var unwidenedType = inference.priority & 104 ? getUnionType(baseCandidates, 2) : getCommonSupertype(baseCandidates);
          return getWidenedType(unwidenedType);
        }
        function getInferredType(context, index) {
          var inference = context.inferences[index];
          if (!inference.inferredType) {
            var inferredType = void 0;
            var signature = context.signature;
            if (signature) {
              var inferredCovariantType = inference.candidates ? getCovariantInference(inference, signature) : void 0;
              if (inference.contraCandidates) {
                var inferredContravariantType = getContravariantInference(inference);
                inferredType = inferredCovariantType && !(inferredCovariantType.flags & 131072) && isTypeSubtypeOf(inferredCovariantType, inferredContravariantType) ? inferredCovariantType : inferredContravariantType;
              } else if (inferredCovariantType) {
                inferredType = inferredCovariantType;
              } else if (context.flags & 1) {
                inferredType = silentNeverType;
              } else {
                var defaultType = getDefaultFromTypeParameter(inference.typeParameter);
                if (defaultType) {
                  inferredType = instantiateType(defaultType, mergeTypeMappers(createBackreferenceMapper(context, index), context.nonFixingMapper));
                }
              }
            } else {
              inferredType = getTypeFromInference(inference);
            }
            inference.inferredType = inferredType || getDefaultTypeArgumentType(!!(context.flags & 2));
            var constraint = getConstraintOfTypeParameter(inference.typeParameter);
            if (constraint) {
              var instantiatedConstraint = instantiateType(constraint, context.nonFixingMapper);
              if (!inferredType || !context.compareTypes(inferredType, getTypeWithThisArgument(instantiatedConstraint, inferredType))) {
                inference.inferredType = inferredType = instantiatedConstraint;
              }
            }
          }
          return inference.inferredType;
        }
        function getDefaultTypeArgumentType(isInJavaScriptFile) {
          return isInJavaScriptFile ? anyType : unknownType;
        }
        function getInferredTypes(context) {
          var result = [];
          for (var i = 0; i < context.inferences.length; i++) {
            result.push(getInferredType(context, i));
          }
          return result;
        }
        function getCannotFindNameDiagnosticForName(node) {
          switch (node.escapedText) {
            case "document":
            case "console":
              return ts2.Diagnostics.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom;
            case "$":
              return compilerOptions.types ? ts2.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig : ts2.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_types_Slashjquery;
            case "describe":
            case "suite":
            case "it":
            case "test":
              return compilerOptions.types ? ts2.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_types_Slashjest_or_npm_i_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig : ts2.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_types_Slashjest_or_npm_i_types_Slashmocha;
            case "process":
            case "require":
            case "Buffer":
            case "module":
              return compilerOptions.types ? ts2.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig : ts2.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_types_Slashnode;
            case "Map":
            case "Set":
            case "Promise":
            case "Symbol":
            case "WeakMap":
            case "WeakSet":
            case "Iterator":
            case "AsyncIterator":
              return ts2.Diagnostics.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later;
            default:
              if (node.parent.kind === 282) {
                return ts2.Diagnostics.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer;
              } else {
                return ts2.Diagnostics.Cannot_find_name_0;
              }
          }
        }
        function getResolvedSymbol(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedSymbol) {
            links.resolvedSymbol = !ts2.nodeIsMissing(node) && resolveName(node, node.escapedText, 111551 | 1048576, getCannotFindNameDiagnosticForName(node), node, !ts2.isWriteOnlyAccess(node), false, ts2.Diagnostics.Cannot_find_name_0_Did_you_mean_1) || unknownSymbol;
          }
          return links.resolvedSymbol;
        }
        function isInTypeQuery(node) {
          return !!ts2.findAncestor(node, function(n) {
            return n.kind === 172 ? true : n.kind === 75 || n.kind === 153 ? false : "quit";
          });
        }
        function getFlowCacheKey(node, declaredType, initialType, flowContainer) {
          switch (node.kind) {
            case 75:
              var symbol = getResolvedSymbol(node);
              return symbol !== unknownSymbol ? (flowContainer ? getNodeId(flowContainer) : "-1") + "|" + getTypeId(declaredType) + "|" + getTypeId(initialType) + "|" + (isConstraintPosition(node) ? "@" : "") + getSymbolId(symbol) : void 0;
            case 104:
              return "0";
            case 218:
            case 200:
              return getFlowCacheKey(node.expression, declaredType, initialType, flowContainer);
            case 194:
            case 195:
              var propName = getAccessedPropertyName(node);
              if (propName !== void 0) {
                var key = getFlowCacheKey(node.expression, declaredType, initialType, flowContainer);
                return key && key + "." + propName;
              }
          }
          return void 0;
        }
        function isMatchingReference(source, target) {
          switch (target.kind) {
            case 200:
            case 218:
              return isMatchingReference(source, target.expression);
          }
          switch (source.kind) {
            case 75:
              return target.kind === 75 && getResolvedSymbol(source) === getResolvedSymbol(target) || (target.kind === 242 || target.kind === 191) && getExportSymbolOfValueSymbolIfExported(getResolvedSymbol(source)) === getSymbolOfNode(target);
            case 104:
              return target.kind === 104;
            case 102:
              return target.kind === 102;
            case 218:
            case 200:
              return isMatchingReference(source.expression, target);
            case 194:
            case 195:
              return ts2.isAccessExpression(target) && getAccessedPropertyName(source) === getAccessedPropertyName(target) && isMatchingReference(source.expression, target.expression);
          }
          return false;
        }
        function containsTruthyCheck(source, target) {
          return isMatchingReference(source, target) || target.kind === 209 && target.operatorToken.kind === 55 && (containsTruthyCheck(source, target.left) || containsTruthyCheck(source, target.right));
        }
        function getAccessedPropertyName(access) {
          return access.kind === 194 ? access.name.escapedText : ts2.isStringOrNumericLiteralLike(access.argumentExpression) ? ts2.escapeLeadingUnderscores(access.argumentExpression.text) : void 0;
        }
        function containsMatchingReference(source, target) {
          while (ts2.isAccessExpression(source)) {
            source = source.expression;
            if (isMatchingReference(source, target)) {
              return true;
            }
          }
          return false;
        }
        function optionalChainContainsReference(source, target) {
          while (ts2.isOptionalChain(source)) {
            source = source.expression;
            if (isMatchingReference(source, target)) {
              return true;
            }
          }
          return false;
        }
        function isDiscriminantProperty(type, name) {
          if (type && type.flags & 1048576) {
            var prop = getUnionOrIntersectionProperty(type, name);
            if (prop && ts2.getCheckFlags(prop) & 2) {
              if (prop.isDiscriminantProperty === void 0) {
                prop.isDiscriminantProperty = (prop.checkFlags & 192) === 192 && !maybeTypeOfKind(getTypeOfSymbol(prop), 63176704);
              }
              return !!prop.isDiscriminantProperty;
            }
          }
          return false;
        }
        function findDiscriminantProperties(sourceProperties, target) {
          var result;
          for (var _i = 0, sourceProperties_2 = sourceProperties; _i < sourceProperties_2.length; _i++) {
            var sourceProperty = sourceProperties_2[_i];
            if (isDiscriminantProperty(target, sourceProperty.escapedName)) {
              if (result) {
                result.push(sourceProperty);
                continue;
              }
              result = [sourceProperty];
            }
          }
          return result;
        }
        function isOrContainsMatchingReference(source, target) {
          return isMatchingReference(source, target) || containsMatchingReference(source, target);
        }
        function hasMatchingArgument(callExpression, reference) {
          if (callExpression.arguments) {
            for (var _i = 0, _a = callExpression.arguments; _i < _a.length; _i++) {
              var argument = _a[_i];
              if (isOrContainsMatchingReference(reference, argument)) {
                return true;
              }
            }
          }
          if (callExpression.expression.kind === 194 && isOrContainsMatchingReference(reference, callExpression.expression.expression)) {
            return true;
          }
          return false;
        }
        function getFlowNodeId(flow) {
          if (!flow.id || flow.id < 0) {
            flow.id = nextFlowId;
            nextFlowId++;
          }
          return flow.id;
        }
        function typeMaybeAssignableTo(source, target) {
          if (!(source.flags & 1048576)) {
            return isTypeAssignableTo(source, target);
          }
          for (var _i = 0, _a = source.types; _i < _a.length; _i++) {
            var t = _a[_i];
            if (isTypeAssignableTo(t, target)) {
              return true;
            }
          }
          return false;
        }
        function getAssignmentReducedType(declaredType, assignedType) {
          if (declaredType !== assignedType) {
            if (assignedType.flags & 131072) {
              return assignedType;
            }
            var reducedType = filterType(declaredType, function(t) {
              return typeMaybeAssignableTo(assignedType, t);
            });
            if (assignedType.flags & 512 && isFreshLiteralType(assignedType)) {
              reducedType = mapType(reducedType, getFreshTypeOfLiteralType);
            }
            if (isTypeAssignableTo(assignedType, reducedType)) {
              return reducedType;
            }
          }
          return declaredType;
        }
        function getTypeFactsOfTypes(types) {
          var result = 0;
          for (var _i = 0, types_15 = types; _i < types_15.length; _i++) {
            var t = types_15[_i];
            result |= getTypeFacts(t);
          }
          return result;
        }
        function isFunctionObjectType(type) {
          var resolved = resolveStructuredTypeMembers(type);
          return !!(resolved.callSignatures.length || resolved.constructSignatures.length || resolved.members.get("bind") && isTypeSubtypeOf(type, globalFunctionType));
        }
        function getTypeFacts(type) {
          var flags = type.flags;
          if (flags & 4) {
            return strictNullChecks ? 16317953 : 16776705;
          }
          if (flags & 128) {
            var isEmpty = type.value === "";
            return strictNullChecks ? isEmpty ? 12123649 : 7929345 : isEmpty ? 12582401 : 16776705;
          }
          if (flags & (8 | 32)) {
            return strictNullChecks ? 16317698 : 16776450;
          }
          if (flags & 256) {
            var isZero = type.value === 0;
            return strictNullChecks ? isZero ? 12123394 : 7929090 : isZero ? 12582146 : 16776450;
          }
          if (flags & 64) {
            return strictNullChecks ? 16317188 : 16775940;
          }
          if (flags & 2048) {
            var isZero = isZeroBigInt(type);
            return strictNullChecks ? isZero ? 12122884 : 7928580 : isZero ? 12581636 : 16775940;
          }
          if (flags & 16) {
            return strictNullChecks ? 16316168 : 16774920;
          }
          if (flags & 528) {
            return strictNullChecks ? type === falseType || type === regularFalseType ? 12121864 : 7927560 : type === falseType || type === regularFalseType ? 12580616 : 16774920;
          }
          if (flags & 524288) {
            return ts2.getObjectFlags(type) & 16 && isEmptyObjectType(type) ? strictNullChecks ? 16318463 : 16777215 : isFunctionObjectType(type) ? strictNullChecks ? 7880640 : 16728e3 : strictNullChecks ? 7888800 : 16736160;
          }
          if (flags & (16384 | 32768)) {
            return 9830144;
          }
          if (flags & 65536) {
            return 9363232;
          }
          if (flags & 12288) {
            return strictNullChecks ? 7925520 : 16772880;
          }
          if (flags & 67108864) {
            return strictNullChecks ? 7888800 : 16736160;
          }
          if (flags & 131072) {
            return 0;
          }
          if (flags & 63176704) {
            return getTypeFacts(getBaseConstraintOfType(type) || unknownType);
          }
          if (flags & 3145728) {
            return getTypeFactsOfTypes(type.types);
          }
          return 16777215;
        }
        function getTypeWithFacts(type, include) {
          return filterType(type, function(t) {
            return (getTypeFacts(t) & include) !== 0;
          });
        }
        function getTypeWithDefault(type, defaultExpression) {
          if (defaultExpression) {
            var defaultType = getTypeOfExpression(defaultExpression);
            return getUnionType([getTypeWithFacts(type, 524288), defaultType]);
          }
          return type;
        }
        function getTypeOfDestructuredProperty(type, name) {
          var nameType = getLiteralTypeFromPropertyName(name);
          if (!isTypeUsableAsPropertyName(nameType))
            return errorType;
          var text = getPropertyNameFromType(nameType);
          return getConstraintForLocation(getTypeOfPropertyOfType(type, text), name) || isNumericLiteralName(text) && getIndexTypeOfType(type, 1) || getIndexTypeOfType(type, 0) || errorType;
        }
        function getTypeOfDestructuredArrayElement(type, index) {
          return everyType(type, isTupleLikeType) && getTupleElementType(type, index) || checkIteratedTypeOrElementType(65, type, undefinedType, void 0) || errorType;
        }
        function getTypeOfDestructuredSpreadExpression(type) {
          return createArrayType(checkIteratedTypeOrElementType(65, type, undefinedType, void 0) || errorType);
        }
        function getAssignedTypeOfBinaryExpression(node) {
          var isDestructuringDefaultAssignment = node.parent.kind === 192 && isDestructuringAssignmentTarget(node.parent) || node.parent.kind === 281 && isDestructuringAssignmentTarget(node.parent.parent);
          return isDestructuringDefaultAssignment ? getTypeWithDefault(getAssignedType(node), node.right) : getTypeOfExpression(node.right);
        }
        function isDestructuringAssignmentTarget(parent) {
          return parent.parent.kind === 209 && parent.parent.left === parent || parent.parent.kind === 232 && parent.parent.initializer === parent;
        }
        function getAssignedTypeOfArrayLiteralElement(node, element) {
          return getTypeOfDestructuredArrayElement(getAssignedType(node), node.elements.indexOf(element));
        }
        function getAssignedTypeOfSpreadExpression(node) {
          return getTypeOfDestructuredSpreadExpression(getAssignedType(node.parent));
        }
        function getAssignedTypeOfPropertyAssignment(node) {
          return getTypeOfDestructuredProperty(getAssignedType(node.parent), node.name);
        }
        function getAssignedTypeOfShorthandPropertyAssignment(node) {
          return getTypeWithDefault(getAssignedTypeOfPropertyAssignment(node), node.objectAssignmentInitializer);
        }
        function getAssignedType(node) {
          var parent = node.parent;
          switch (parent.kind) {
            case 231:
              return stringType;
            case 232:
              return checkRightHandSideOfForOf(parent) || errorType;
            case 209:
              return getAssignedTypeOfBinaryExpression(parent);
            case 203:
              return undefinedType;
            case 192:
              return getAssignedTypeOfArrayLiteralElement(parent, node);
            case 213:
              return getAssignedTypeOfSpreadExpression(parent);
            case 281:
              return getAssignedTypeOfPropertyAssignment(parent);
            case 282:
              return getAssignedTypeOfShorthandPropertyAssignment(parent);
          }
          return errorType;
        }
        function getInitialTypeOfBindingElement(node) {
          var pattern = node.parent;
          var parentType = getInitialType(pattern.parent);
          var type = pattern.kind === 189 ? getTypeOfDestructuredProperty(parentType, node.propertyName || node.name) : !node.dotDotDotToken ? getTypeOfDestructuredArrayElement(parentType, pattern.elements.indexOf(node)) : getTypeOfDestructuredSpreadExpression(parentType);
          return getTypeWithDefault(type, node.initializer);
        }
        function getTypeOfInitializer(node) {
          var links = getNodeLinks(node);
          return links.resolvedType || getTypeOfExpression(node);
        }
        function getInitialTypeOfVariableDeclaration(node) {
          if (node.initializer) {
            return getTypeOfInitializer(node.initializer);
          }
          if (node.parent.parent.kind === 231) {
            return stringType;
          }
          if (node.parent.parent.kind === 232) {
            return checkRightHandSideOfForOf(node.parent.parent) || errorType;
          }
          return errorType;
        }
        function getInitialType(node) {
          return node.kind === 242 ? getInitialTypeOfVariableDeclaration(node) : getInitialTypeOfBindingElement(node);
        }
        function isEmptyArrayAssignment(node) {
          return node.kind === 242 && node.initializer && isEmptyArrayLiteral(node.initializer) || node.kind !== 191 && node.parent.kind === 209 && isEmptyArrayLiteral(node.parent.right);
        }
        function getReferenceCandidate(node) {
          switch (node.kind) {
            case 200:
              return getReferenceCandidate(node.expression);
            case 209:
              switch (node.operatorToken.kind) {
                case 62:
                  return getReferenceCandidate(node.left);
                case 27:
                  return getReferenceCandidate(node.right);
              }
          }
          return node;
        }
        function getReferenceRoot(node) {
          var parent = node.parent;
          return parent.kind === 200 || parent.kind === 209 && parent.operatorToken.kind === 62 && parent.left === node || parent.kind === 209 && parent.operatorToken.kind === 27 && parent.right === node ? getReferenceRoot(parent) : node;
        }
        function getTypeOfSwitchClause(clause) {
          if (clause.kind === 277) {
            return getRegularTypeOfLiteralType(getTypeOfExpression(clause.expression));
          }
          return neverType;
        }
        function getSwitchClauseTypes(switchStatement) {
          var links = getNodeLinks(switchStatement);
          if (!links.switchTypes) {
            links.switchTypes = [];
            for (var _i = 0, _a = switchStatement.caseBlock.clauses; _i < _a.length; _i++) {
              var clause = _a[_i];
              links.switchTypes.push(getTypeOfSwitchClause(clause));
            }
          }
          return links.switchTypes;
        }
        function getSwitchClauseTypeOfWitnesses(switchStatement, retainDefault) {
          var witnesses = [];
          for (var _i = 0, _a = switchStatement.caseBlock.clauses; _i < _a.length; _i++) {
            var clause = _a[_i];
            if (clause.kind === 277) {
              if (ts2.isStringLiteralLike(clause.expression)) {
                witnesses.push(clause.expression.text);
                continue;
              }
              return ts2.emptyArray;
            }
            if (retainDefault)
              witnesses.push(void 0);
          }
          return witnesses;
        }
        function eachTypeContainedIn(source, types) {
          return source.flags & 1048576 ? !ts2.forEach(source.types, function(t) {
            return !ts2.contains(types, t);
          }) : ts2.contains(types, source);
        }
        function isTypeSubsetOf(source, target) {
          return source === target || target.flags & 1048576 && isTypeSubsetOfUnion(source, target);
        }
        function isTypeSubsetOfUnion(source, target) {
          if (source.flags & 1048576) {
            for (var _i = 0, _a = source.types; _i < _a.length; _i++) {
              var t = _a[_i];
              if (!containsType(target.types, t)) {
                return false;
              }
            }
            return true;
          }
          if (source.flags & 1024 && getBaseTypeOfEnumLiteralType(source) === target) {
            return true;
          }
          return containsType(target.types, source);
        }
        function forEachType(type, f) {
          return type.flags & 1048576 ? ts2.forEach(type.types, f) : f(type);
        }
        function everyType(type, f) {
          return type.flags & 1048576 ? ts2.every(type.types, f) : f(type);
        }
        function filterType(type, f) {
          if (type.flags & 1048576) {
            var types = type.types;
            var filtered = ts2.filter(types, f);
            return filtered === types ? type : getUnionTypeFromSortedList(filtered, type.objectFlags);
          }
          return type.flags & 131072 || f(type) ? type : neverType;
        }
        function countTypes(type) {
          return type.flags & 1048576 ? type.types.length : 1;
        }
        function mapType(type, mapper, noReductions) {
          if (type.flags & 131072) {
            return type;
          }
          if (!(type.flags & 1048576)) {
            return mapper(type);
          }
          var mappedTypes;
          for (var _i = 0, _a = type.types; _i < _a.length; _i++) {
            var t = _a[_i];
            var mapped = mapper(t);
            if (mapped) {
              if (!mappedTypes) {
                mappedTypes = [mapped];
              } else {
                mappedTypes.push(mapped);
              }
            }
          }
          return mappedTypes && getUnionType(mappedTypes, noReductions ? 0 : 1);
        }
        function extractTypesOfKind(type, kind) {
          return filterType(type, function(t) {
            return (t.flags & kind) !== 0;
          });
        }
        function replacePrimitivesWithLiterals(typeWithPrimitives, typeWithLiterals) {
          if (isTypeSubsetOf(stringType, typeWithPrimitives) && maybeTypeOfKind(typeWithLiterals, 128) || isTypeSubsetOf(numberType, typeWithPrimitives) && maybeTypeOfKind(typeWithLiterals, 256) || isTypeSubsetOf(bigintType, typeWithPrimitives) && maybeTypeOfKind(typeWithLiterals, 2048)) {
            return mapType(typeWithPrimitives, function(t) {
              return t.flags & 4 ? extractTypesOfKind(typeWithLiterals, 4 | 128) : t.flags & 8 ? extractTypesOfKind(typeWithLiterals, 8 | 256) : t.flags & 64 ? extractTypesOfKind(typeWithLiterals, 64 | 2048) : t;
            });
          }
          return typeWithPrimitives;
        }
        function isIncomplete(flowType) {
          return flowType.flags === 0;
        }
        function getTypeFromFlowType(flowType) {
          return flowType.flags === 0 ? flowType.type : flowType;
        }
        function createFlowType(type, incomplete) {
          return incomplete ? { flags: 0, type } : type;
        }
        function createEvolvingArrayType(elementType) {
          var result = createObjectType(256);
          result.elementType = elementType;
          return result;
        }
        function getEvolvingArrayType(elementType) {
          return evolvingArrayTypes[elementType.id] || (evolvingArrayTypes[elementType.id] = createEvolvingArrayType(elementType));
        }
        function addEvolvingArrayElementType(evolvingArrayType, node) {
          var elementType = getBaseTypeOfLiteralType(getContextFreeTypeOfExpression(node));
          return isTypeSubsetOf(elementType, evolvingArrayType.elementType) ? evolvingArrayType : getEvolvingArrayType(getUnionType([evolvingArrayType.elementType, elementType]));
        }
        function createFinalArrayType(elementType) {
          return elementType.flags & 131072 ? autoArrayType : createArrayType(elementType.flags & 1048576 ? getUnionType(elementType.types, 2) : elementType);
        }
        function getFinalArrayType(evolvingArrayType) {
          return evolvingArrayType.finalArrayType || (evolvingArrayType.finalArrayType = createFinalArrayType(evolvingArrayType.elementType));
        }
        function finalizeEvolvingArrayType(type) {
          return ts2.getObjectFlags(type) & 256 ? getFinalArrayType(type) : type;
        }
        function getElementTypeOfEvolvingArrayType(type) {
          return ts2.getObjectFlags(type) & 256 ? type.elementType : neverType;
        }
        function isEvolvingArrayTypeList(types) {
          var hasEvolvingArrayType = false;
          for (var _i = 0, types_16 = types; _i < types_16.length; _i++) {
            var t = types_16[_i];
            if (!(t.flags & 131072)) {
              if (!(ts2.getObjectFlags(t) & 256)) {
                return false;
              }
              hasEvolvingArrayType = true;
            }
          }
          return hasEvolvingArrayType;
        }
        function getUnionOrEvolvingArrayType(types, subtypeReduction) {
          return isEvolvingArrayTypeList(types) ? getEvolvingArrayType(getUnionType(ts2.map(types, getElementTypeOfEvolvingArrayType))) : getUnionType(ts2.sameMap(types, finalizeEvolvingArrayType), subtypeReduction);
        }
        function isEvolvingArrayOperationTarget(node) {
          var root = getReferenceRoot(node);
          var parent = root.parent;
          var isLengthPushOrUnshift = ts2.isPropertyAccessExpression(parent) && (parent.name.escapedText === "length" || parent.parent.kind === 196 && ts2.isIdentifier(parent.name) && ts2.isPushOrUnshiftIdentifier(parent.name));
          var isElementAssignment = parent.kind === 195 && parent.expression === root && parent.parent.kind === 209 && parent.parent.operatorToken.kind === 62 && parent.parent.left === parent && !ts2.isAssignmentTarget(parent.parent) && isTypeAssignableToKind(getTypeOfExpression(parent.argumentExpression), 296);
          return isLengthPushOrUnshift || isElementAssignment;
        }
        function isDeclarationWithExplicitTypeAnnotation(declaration) {
          return (declaration.kind === 242 || declaration.kind === 156 || declaration.kind === 159 || declaration.kind === 158) && !!ts2.getEffectiveTypeAnnotationNode(declaration);
        }
        function getExplicitTypeOfSymbol(symbol, diagnostic) {
          if (symbol.flags & (16 | 8192 | 32 | 512)) {
            return getTypeOfSymbol(symbol);
          }
          if (symbol.flags & (3 | 4)) {
            var declaration = symbol.valueDeclaration;
            if (declaration) {
              if (isDeclarationWithExplicitTypeAnnotation(declaration)) {
                return getTypeOfSymbol(symbol);
              }
              if (ts2.isVariableDeclaration(declaration) && declaration.parent.parent.kind === 232) {
                var statement = declaration.parent.parent;
                var expressionType = getTypeOfDottedName(statement.expression, void 0);
                if (expressionType) {
                  var use = statement.awaitModifier ? 15 : 13;
                  return checkIteratedTypeOrElementType(use, expressionType, undefinedType, void 0);
                }
              }
              if (diagnostic) {
                ts2.addRelatedInfo(diagnostic, ts2.createDiagnosticForNode(declaration, ts2.Diagnostics._0_needs_an_explicit_type_annotation, symbolToString(symbol)));
              }
            }
          }
        }
        function getTypeOfDottedName(node, diagnostic) {
          if (!(node.flags & 16777216)) {
            switch (node.kind) {
              case 75:
                var symbol = getExportSymbolOfValueSymbolIfExported(getResolvedSymbol(node));
                return getExplicitTypeOfSymbol(symbol.flags & 2097152 ? resolveAlias(symbol) : symbol, diagnostic);
              case 104:
                return getExplicitThisType(node);
              case 102:
                return checkSuperExpression(node);
              case 194:
                var type = getTypeOfDottedName(node.expression, diagnostic);
                var prop = type && getPropertyOfType(type, node.name.escapedText);
                return prop && getExplicitTypeOfSymbol(prop, diagnostic);
              case 200:
                return getTypeOfDottedName(node.expression, diagnostic);
            }
          }
        }
        function getEffectsSignature(node) {
          var links = getNodeLinks(node);
          var signature = links.effectsSignature;
          if (signature === void 0) {
            var funcType = void 0;
            if (node.parent.kind === 226) {
              funcType = getTypeOfDottedName(node.expression, void 0);
            } else if (node.expression.kind !== 102) {
              if (ts2.isOptionalChain(node)) {
                funcType = checkNonNullType(getOptionalExpressionType(checkExpression(node.expression), node.expression), node.expression);
              } else {
                funcType = checkNonNullExpression(node.expression);
              }
            }
            var signatures = getSignaturesOfType(funcType && getApparentType(funcType) || unknownType, 0);
            var candidate = signatures.length === 1 && !signatures[0].typeParameters ? signatures[0] : ts2.some(signatures, hasTypePredicateOrNeverReturnType) ? getResolvedSignature(node) : void 0;
            signature = links.effectsSignature = candidate && hasTypePredicateOrNeverReturnType(candidate) ? candidate : unknownSignature;
          }
          return signature === unknownSignature ? void 0 : signature;
        }
        function hasTypePredicateOrNeverReturnType(signature) {
          return !!(getTypePredicateOfSignature(signature) || signature.declaration && (getReturnTypeFromAnnotation(signature.declaration) || unknownType).flags & 131072);
        }
        function getTypePredicateArgument(predicate, callExpression) {
          if (predicate.kind === 1 || predicate.kind === 3) {
            return callExpression.arguments[predicate.parameterIndex];
          }
          var invokedExpression = ts2.skipParentheses(callExpression.expression);
          return ts2.isAccessExpression(invokedExpression) ? ts2.skipParentheses(invokedExpression.expression) : void 0;
        }
        function reportFlowControlError(node) {
          var block = ts2.findAncestor(node, ts2.isFunctionOrModuleBlock);
          var sourceFile = ts2.getSourceFileOfNode(node);
          var span = ts2.getSpanOfTokenAtPosition(sourceFile, block.statements.pos);
          diagnostics.add(ts2.createFileDiagnostic(sourceFile, span.start, span.length, ts2.Diagnostics.The_containing_function_or_module_body_is_too_large_for_control_flow_analysis));
        }
        function isReachableFlowNode(flow) {
          var result = isReachableFlowNodeWorker(flow, false);
          lastFlowNode = flow;
          lastFlowNodeReachable = result;
          return result;
        }
        function isFalseExpression(expr) {
          var node = ts2.skipParentheses(expr);
          return node.kind === 91 || node.kind === 209 && (node.operatorToken.kind === 55 && (isFalseExpression(node.left) || isFalseExpression(node.right)) || node.operatorToken.kind === 56 && isFalseExpression(node.left) && isFalseExpression(node.right));
        }
        function isReachableFlowNodeWorker(flow, noCacheCheck) {
          while (true) {
            if (flow === lastFlowNode) {
              return lastFlowNodeReachable;
            }
            var flags = flow.flags;
            if (flags & 4096) {
              if (!noCacheCheck) {
                var id = getFlowNodeId(flow);
                var reachable = flowNodeReachable[id];
                return reachable !== void 0 ? reachable : flowNodeReachable[id] = isReachableFlowNodeWorker(flow, true);
              }
              noCacheCheck = false;
            }
            if (flags & (16 | 96 | 256)) {
              flow = flow.antecedent;
            } else if (flags & 512) {
              var signature = getEffectsSignature(flow.node);
              if (signature) {
                var predicate = getTypePredicateOfSignature(signature);
                if (predicate && predicate.kind === 3) {
                  var predicateArgument = flow.node.arguments[predicate.parameterIndex];
                  if (predicateArgument && isFalseExpression(predicateArgument)) {
                    return false;
                  }
                }
                if (getReturnTypeOfSignature(signature).flags & 131072) {
                  return false;
                }
              }
              flow = flow.antecedent;
            } else if (flags & 4) {
              return ts2.some(flow.antecedents, function(f) {
                return isReachableFlowNodeWorker(f, false);
              });
            } else if (flags & 8) {
              flow = flow.antecedents[0];
            } else if (flags & 128) {
              if (flow.clauseStart === flow.clauseEnd && isExhaustiveSwitchStatement(flow.switchStatement)) {
                return false;
              }
              flow = flow.antecedent;
            } else if (flags & 1024) {
              lastFlowNode = void 0;
              var target = flow.target;
              var saveAntecedents = target.antecedents;
              target.antecedents = flow.antecedents;
              var result = isReachableFlowNodeWorker(flow.antecedent, false);
              target.antecedents = saveAntecedents;
              return result;
            } else {
              return !(flags & 1);
            }
          }
        }
        function getFlowTypeOfReference(reference, declaredType, initialType, flowContainer, couldBeUninitialized) {
          if (initialType === void 0) {
            initialType = declaredType;
          }
          var key;
          var keySet = false;
          var flowDepth = 0;
          if (flowAnalysisDisabled) {
            return errorType;
          }
          if (!reference.flowNode || !couldBeUninitialized && !(declaredType.flags & 133970943)) {
            return declaredType;
          }
          flowInvocationCount++;
          var sharedFlowStart = sharedFlowCount;
          var evolvedType = getTypeFromFlowType(getTypeAtFlowNode(reference.flowNode));
          sharedFlowCount = sharedFlowStart;
          var resultType = ts2.getObjectFlags(evolvedType) & 256 && isEvolvingArrayOperationTarget(reference) ? autoArrayType : finalizeEvolvingArrayType(evolvedType);
          if (resultType === unreachableNeverType || reference.parent && reference.parent.kind === 218 && getTypeWithFacts(resultType, 2097152).flags & 131072) {
            return declaredType;
          }
          return resultType;
          function getOrSetCacheKey() {
            if (keySet) {
              return key;
            }
            keySet = true;
            return key = getFlowCacheKey(reference, declaredType, initialType, flowContainer);
          }
          function getTypeAtFlowNode(flow) {
            if (flowDepth === 2e3) {
              flowAnalysisDisabled = true;
              reportFlowControlError(reference);
              return errorType;
            }
            flowDepth++;
            while (true) {
              var flags = flow.flags;
              if (flags & 4096) {
                for (var i = sharedFlowStart; i < sharedFlowCount; i++) {
                  if (sharedFlowNodes[i] === flow) {
                    flowDepth--;
                    return sharedFlowTypes[i];
                  }
                }
              }
              var type = void 0;
              if (flags & 16) {
                type = getTypeAtFlowAssignment(flow);
                if (!type) {
                  flow = flow.antecedent;
                  continue;
                }
              } else if (flags & 512) {
                type = getTypeAtFlowCall(flow);
                if (!type) {
                  flow = flow.antecedent;
                  continue;
                }
              } else if (flags & 96) {
                type = getTypeAtFlowCondition(flow);
              } else if (flags & 128) {
                type = getTypeAtSwitchClause(flow);
              } else if (flags & 12) {
                if (flow.antecedents.length === 1) {
                  flow = flow.antecedents[0];
                  continue;
                }
                type = flags & 4 ? getTypeAtFlowBranchLabel(flow) : getTypeAtFlowLoopLabel(flow);
              } else if (flags & 256) {
                type = getTypeAtFlowArrayMutation(flow);
                if (!type) {
                  flow = flow.antecedent;
                  continue;
                }
              } else if (flags & 1024) {
                var target = flow.target;
                var saveAntecedents = target.antecedents;
                target.antecedents = flow.antecedents;
                type = getTypeAtFlowNode(flow.antecedent);
                target.antecedents = saveAntecedents;
              } else if (flags & 2) {
                var container = flow.node;
                if (container && container !== flowContainer && reference.kind !== 194 && reference.kind !== 195 && reference.kind !== 104) {
                  flow = container.flowNode;
                  continue;
                }
                type = initialType;
              } else {
                type = convertAutoToAny(declaredType);
              }
              if (flags & 4096) {
                sharedFlowNodes[sharedFlowCount] = flow;
                sharedFlowTypes[sharedFlowCount] = type;
                sharedFlowCount++;
              }
              flowDepth--;
              return type;
            }
          }
          function getInitialOrAssignedType(flow) {
            var node = flow.node;
            return getConstraintForLocation(node.kind === 242 || node.kind === 191 ? getInitialType(node) : getAssignedType(node), reference);
          }
          function getTypeAtFlowAssignment(flow) {
            var node = flow.node;
            if (isMatchingReference(reference, node)) {
              if (!isReachableFlowNode(flow)) {
                return unreachableNeverType;
              }
              if (ts2.getAssignmentTargetKind(node) === 2) {
                var flowType = getTypeAtFlowNode(flow.antecedent);
                return createFlowType(getBaseTypeOfLiteralType(getTypeFromFlowType(flowType)), isIncomplete(flowType));
              }
              if (declaredType === autoType || declaredType === autoArrayType) {
                if (isEmptyArrayAssignment(node)) {
                  return getEvolvingArrayType(neverType);
                }
                var assignedType = getBaseTypeOfLiteralType(getInitialOrAssignedType(flow));
                return isTypeAssignableTo(assignedType, declaredType) ? assignedType : anyArrayType;
              }
              if (declaredType.flags & 1048576) {
                return getAssignmentReducedType(declaredType, getInitialOrAssignedType(flow));
              }
              return declaredType;
            }
            if (containsMatchingReference(reference, node)) {
              if (!isReachableFlowNode(flow)) {
                return unreachableNeverType;
              }
              if (ts2.isVariableDeclaration(node) && (ts2.isInJSFile(node) || ts2.isVarConst(node))) {
                var init = ts2.getDeclaredExpandoInitializer(node);
                if (init && (init.kind === 201 || init.kind === 202)) {
                  return getTypeAtFlowNode(flow.antecedent);
                }
              }
              return declaredType;
            }
            if (ts2.isVariableDeclaration(node) && node.parent.parent.kind === 231 && isMatchingReference(reference, node.parent.parent.expression)) {
              return getNonNullableTypeIfNeeded(getTypeFromFlowType(getTypeAtFlowNode(flow.antecedent)));
            }
            return void 0;
          }
          function narrowTypeByAssertion(type, expr) {
            var node = ts2.skipParentheses(expr);
            if (node.kind === 91) {
              return unreachableNeverType;
            }
            if (node.kind === 209) {
              if (node.operatorToken.kind === 55) {
                return narrowTypeByAssertion(narrowTypeByAssertion(type, node.left), node.right);
              }
              if (node.operatorToken.kind === 56) {
                return getUnionType([narrowTypeByAssertion(type, node.left), narrowTypeByAssertion(type, node.right)]);
              }
            }
            return narrowType(type, node, true);
          }
          function getTypeAtFlowCall(flow) {
            var signature = getEffectsSignature(flow.node);
            if (signature) {
              var predicate = getTypePredicateOfSignature(signature);
              if (predicate && (predicate.kind === 2 || predicate.kind === 3)) {
                var flowType = getTypeAtFlowNode(flow.antecedent);
                var type = finalizeEvolvingArrayType(getTypeFromFlowType(flowType));
                var narrowedType = predicate.type ? narrowTypeByTypePredicate(type, predicate, flow.node, true) : predicate.kind === 3 && predicate.parameterIndex >= 0 && predicate.parameterIndex < flow.node.arguments.length ? narrowTypeByAssertion(type, flow.node.arguments[predicate.parameterIndex]) : type;
                return narrowedType === type ? flowType : createFlowType(narrowedType, isIncomplete(flowType));
              }
              if (getReturnTypeOfSignature(signature).flags & 131072) {
                return unreachableNeverType;
              }
            }
            return void 0;
          }
          function getTypeAtFlowArrayMutation(flow) {
            if (declaredType === autoType || declaredType === autoArrayType) {
              var node = flow.node;
              var expr = node.kind === 196 ? node.expression.expression : node.left.expression;
              if (isMatchingReference(reference, getReferenceCandidate(expr))) {
                var flowType = getTypeAtFlowNode(flow.antecedent);
                var type = getTypeFromFlowType(flowType);
                if (ts2.getObjectFlags(type) & 256) {
                  var evolvedType_1 = type;
                  if (node.kind === 196) {
                    for (var _i = 0, _a = node.arguments; _i < _a.length; _i++) {
                      var arg = _a[_i];
                      evolvedType_1 = addEvolvingArrayElementType(evolvedType_1, arg);
                    }
                  } else {
                    var indexType = getContextFreeTypeOfExpression(node.left.argumentExpression);
                    if (isTypeAssignableToKind(indexType, 296)) {
                      evolvedType_1 = addEvolvingArrayElementType(evolvedType_1, node.right);
                    }
                  }
                  return evolvedType_1 === type ? flowType : createFlowType(evolvedType_1, isIncomplete(flowType));
                }
                return flowType;
              }
            }
            return void 0;
          }
          function getTypeAtFlowCondition(flow) {
            var flowType = getTypeAtFlowNode(flow.antecedent);
            var type = getTypeFromFlowType(flowType);
            if (type.flags & 131072) {
              return flowType;
            }
            var assumeTrue = (flow.flags & 32) !== 0;
            var nonEvolvingType = finalizeEvolvingArrayType(type);
            var narrowedType = narrowType(nonEvolvingType, flow.node, assumeTrue);
            if (narrowedType === nonEvolvingType) {
              return flowType;
            }
            var incomplete = isIncomplete(flowType);
            var resultType2 = incomplete && narrowedType.flags & 131072 ? silentNeverType : narrowedType;
            return createFlowType(resultType2, incomplete);
          }
          function getTypeAtSwitchClause(flow) {
            var expr = flow.switchStatement.expression;
            var flowType = getTypeAtFlowNode(flow.antecedent);
            var type = getTypeFromFlowType(flowType);
            if (isMatchingReference(reference, expr)) {
              type = narrowTypeBySwitchOnDiscriminant(type, flow.switchStatement, flow.clauseStart, flow.clauseEnd);
            } else if (expr.kind === 204 && isMatchingReference(reference, expr.expression)) {
              type = narrowBySwitchOnTypeOf(type, flow.switchStatement, flow.clauseStart, flow.clauseEnd);
            } else {
              if (strictNullChecks) {
                if (optionalChainContainsReference(expr, reference)) {
                  type = narrowTypeBySwitchOptionalChainContainment(type, flow.switchStatement, flow.clauseStart, flow.clauseEnd, function(t) {
                    return !(t.flags & (32768 | 131072));
                  });
                } else if (expr.kind === 204 && optionalChainContainsReference(expr.expression, reference)) {
                  type = narrowTypeBySwitchOptionalChainContainment(type, flow.switchStatement, flow.clauseStart, flow.clauseEnd, function(t) {
                    return !(t.flags & 131072 || t.flags & 128 && t.value === "undefined");
                  });
                }
              }
              if (isMatchingReferenceDiscriminant(expr, type)) {
                type = narrowTypeByDiscriminant(type, expr, function(t) {
                  return narrowTypeBySwitchOnDiscriminant(t, flow.switchStatement, flow.clauseStart, flow.clauseEnd);
                });
              }
            }
            return createFlowType(type, isIncomplete(flowType));
          }
          function getTypeAtFlowBranchLabel(flow) {
            var antecedentTypes = [];
            var subtypeReduction = false;
            var seenIncomplete = false;
            var bypassFlow;
            for (var _i = 0, _a = flow.antecedents; _i < _a.length; _i++) {
              var antecedent = _a[_i];
              if (!bypassFlow && antecedent.flags & 128 && antecedent.clauseStart === antecedent.clauseEnd) {
                bypassFlow = antecedent;
                continue;
              }
              var flowType = getTypeAtFlowNode(antecedent);
              var type = getTypeFromFlowType(flowType);
              if (type === declaredType && declaredType === initialType) {
                return type;
              }
              ts2.pushIfUnique(antecedentTypes, type);
              if (!isTypeSubsetOf(type, declaredType)) {
                subtypeReduction = true;
              }
              if (isIncomplete(flowType)) {
                seenIncomplete = true;
              }
            }
            if (bypassFlow) {
              var flowType = getTypeAtFlowNode(bypassFlow);
              var type = getTypeFromFlowType(flowType);
              if (!ts2.contains(antecedentTypes, type) && !isExhaustiveSwitchStatement(bypassFlow.switchStatement)) {
                if (type === declaredType && declaredType === initialType) {
                  return type;
                }
                antecedentTypes.push(type);
                if (!isTypeSubsetOf(type, declaredType)) {
                  subtypeReduction = true;
                }
                if (isIncomplete(flowType)) {
                  seenIncomplete = true;
                }
              }
            }
            return createFlowType(getUnionOrEvolvingArrayType(antecedentTypes, subtypeReduction ? 2 : 1), seenIncomplete);
          }
          function getTypeAtFlowLoopLabel(flow) {
            var id = getFlowNodeId(flow);
            var cache = flowLoopCaches[id] || (flowLoopCaches[id] = ts2.createMap());
            var key2 = getOrSetCacheKey();
            if (!key2) {
              return declaredType;
            }
            var cached = cache.get(key2);
            if (cached) {
              return cached;
            }
            for (var i = flowLoopStart; i < flowLoopCount; i++) {
              if (flowLoopNodes[i] === flow && flowLoopKeys[i] === key2 && flowLoopTypes[i].length) {
                return createFlowType(getUnionOrEvolvingArrayType(flowLoopTypes[i], 1), true);
              }
            }
            var antecedentTypes = [];
            var subtypeReduction = false;
            var firstAntecedentType;
            for (var _i = 0, _a = flow.antecedents; _i < _a.length; _i++) {
              var antecedent = _a[_i];
              var flowType = void 0;
              if (!firstAntecedentType) {
                flowType = firstAntecedentType = getTypeAtFlowNode(antecedent);
              } else {
                flowLoopNodes[flowLoopCount] = flow;
                flowLoopKeys[flowLoopCount] = key2;
                flowLoopTypes[flowLoopCount] = antecedentTypes;
                flowLoopCount++;
                var saveFlowTypeCache = flowTypeCache;
                flowTypeCache = void 0;
                flowType = getTypeAtFlowNode(antecedent);
                flowTypeCache = saveFlowTypeCache;
                flowLoopCount--;
                var cached_1 = cache.get(key2);
                if (cached_1) {
                  return cached_1;
                }
              }
              var type = getTypeFromFlowType(flowType);
              ts2.pushIfUnique(antecedentTypes, type);
              if (!isTypeSubsetOf(type, declaredType)) {
                subtypeReduction = true;
              }
              if (type === declaredType) {
                break;
              }
            }
            var result = getUnionOrEvolvingArrayType(antecedentTypes, subtypeReduction ? 2 : 1);
            if (isIncomplete(firstAntecedentType)) {
              return createFlowType(result, true);
            }
            cache.set(key2, result);
            return result;
          }
          function isMatchingReferenceDiscriminant(expr, computedType) {
            if (!(computedType.flags & 1048576) || !ts2.isAccessExpression(expr)) {
              return false;
            }
            var name = getAccessedPropertyName(expr);
            if (name === void 0) {
              return false;
            }
            return isMatchingReference(reference, expr.expression) && isDiscriminantProperty(computedType, name);
          }
          function narrowTypeByDiscriminant(type, access, narrowType2) {
            var propName = getAccessedPropertyName(access);
            if (propName === void 0) {
              return type;
            }
            var propType = getTypeOfPropertyOfType(type, propName);
            if (!propType) {
              return type;
            }
            var narrowedPropType = narrowType2(propType);
            return filterType(type, function(t) {
              var discriminantType = getTypeOfPropertyOrIndexSignature(t, propName);
              return !(discriminantType.flags & 131072) && isTypeComparableTo(discriminantType, narrowedPropType);
            });
          }
          function narrowTypeByTruthiness(type, expr, assumeTrue) {
            if (isMatchingReference(reference, expr)) {
              return getTypeWithFacts(type, assumeTrue ? 4194304 : 8388608);
            }
            if (strictNullChecks && assumeTrue && optionalChainContainsReference(expr, reference)) {
              type = getTypeWithFacts(type, 2097152);
            }
            if (isMatchingReferenceDiscriminant(expr, declaredType)) {
              return narrowTypeByDiscriminant(type, expr, function(t) {
                return getTypeWithFacts(t, assumeTrue ? 4194304 : 8388608);
              });
            }
            return type;
          }
          function isTypePresencePossible(type, propName, assumeTrue) {
            if (getIndexInfoOfType(type, 0)) {
              return true;
            }
            var prop = getPropertyOfType(type, propName);
            if (prop) {
              return prop.flags & 16777216 ? true : assumeTrue;
            }
            return !assumeTrue;
          }
          function narrowByInKeyword(type, literal, assumeTrue) {
            if (type.flags & (1048576 | 524288) || isThisTypeParameter(type)) {
              var propName_1 = ts2.escapeLeadingUnderscores(literal.text);
              return filterType(type, function(t) {
                return isTypePresencePossible(t, propName_1, assumeTrue);
              });
            }
            return type;
          }
          function narrowTypeByBinaryExpression(type, expr, assumeTrue) {
            switch (expr.operatorToken.kind) {
              case 62:
                return narrowTypeByTruthiness(narrowType(type, expr.right, assumeTrue), expr.left, assumeTrue);
              case 34:
              case 35:
              case 36:
              case 37:
                var operator_1 = expr.operatorToken.kind;
                var left_1 = getReferenceCandidate(expr.left);
                var right_1 = getReferenceCandidate(expr.right);
                if (left_1.kind === 204 && ts2.isStringLiteralLike(right_1)) {
                  return narrowTypeByTypeof(type, left_1, operator_1, right_1, assumeTrue);
                }
                if (right_1.kind === 204 && ts2.isStringLiteralLike(left_1)) {
                  return narrowTypeByTypeof(type, right_1, operator_1, left_1, assumeTrue);
                }
                if (isMatchingReference(reference, left_1)) {
                  return narrowTypeByEquality(type, operator_1, right_1, assumeTrue);
                }
                if (isMatchingReference(reference, right_1)) {
                  return narrowTypeByEquality(type, operator_1, left_1, assumeTrue);
                }
                if (strictNullChecks) {
                  if (optionalChainContainsReference(left_1, reference)) {
                    type = narrowTypeByOptionalChainContainment(type, operator_1, right_1, assumeTrue);
                  } else if (optionalChainContainsReference(right_1, reference)) {
                    type = narrowTypeByOptionalChainContainment(type, operator_1, left_1, assumeTrue);
                  }
                }
                if (isMatchingReferenceDiscriminant(left_1, declaredType)) {
                  return narrowTypeByDiscriminant(type, left_1, function(t) {
                    return narrowTypeByEquality(t, operator_1, right_1, assumeTrue);
                  });
                }
                if (isMatchingReferenceDiscriminant(right_1, declaredType)) {
                  return narrowTypeByDiscriminant(type, right_1, function(t) {
                    return narrowTypeByEquality(t, operator_1, left_1, assumeTrue);
                  });
                }
                if (isMatchingConstructorReference(left_1)) {
                  return narrowTypeByConstructor(type, operator_1, right_1, assumeTrue);
                }
                if (isMatchingConstructorReference(right_1)) {
                  return narrowTypeByConstructor(type, operator_1, left_1, assumeTrue);
                }
                break;
              case 98:
                return narrowTypeByInstanceof(type, expr, assumeTrue);
              case 97:
                var target = getReferenceCandidate(expr.right);
                if (ts2.isStringLiteralLike(expr.left) && isMatchingReference(reference, target)) {
                  return narrowByInKeyword(type, expr.left, assumeTrue);
                }
                break;
              case 27:
                return narrowType(type, expr.right, assumeTrue);
            }
            return type;
          }
          function narrowTypeByOptionalChainContainment(type, operator, value, assumeTrue) {
            var equalsOperator = operator === 34 || operator === 36;
            var nullableFlags = operator === 34 || operator === 35 ? 98304 : 32768;
            var valueType = getTypeOfExpression(value);
            var removeNullable = equalsOperator !== assumeTrue && everyType(valueType, function(t) {
              return !!(t.flags & nullableFlags);
            }) || equalsOperator === assumeTrue && everyType(valueType, function(t) {
              return !(t.flags & (3 | nullableFlags));
            });
            return removeNullable ? getTypeWithFacts(type, 2097152) : type;
          }
          function narrowTypeByEquality(type, operator, value, assumeTrue) {
            if (type.flags & 1) {
              return type;
            }
            if (operator === 35 || operator === 37) {
              assumeTrue = !assumeTrue;
            }
            var valueType = getTypeOfExpression(value);
            if (type.flags & 2 && assumeTrue && (operator === 36 || operator === 37)) {
              if (valueType.flags & (131068 | 67108864)) {
                return valueType;
              }
              if (valueType.flags & 524288) {
                return nonPrimitiveType;
              }
              return type;
            }
            if (valueType.flags & 98304) {
              if (!strictNullChecks) {
                return type;
              }
              var doubleEquals = operator === 34 || operator === 35;
              var facts = doubleEquals ? assumeTrue ? 262144 : 2097152 : valueType.flags & 65536 ? assumeTrue ? 131072 : 1048576 : assumeTrue ? 65536 : 524288;
              return getTypeWithFacts(type, facts);
            }
            if (type.flags & 67637251) {
              return type;
            }
            if (assumeTrue) {
              var filterFn = operator === 34 ? function(t) {
                return areTypesComparable(t, valueType) || isCoercibleUnderDoubleEquals(t, valueType);
              } : function(t) {
                return areTypesComparable(t, valueType);
              };
              var narrowedType = filterType(type, filterFn);
              return narrowedType.flags & 131072 ? type : replacePrimitivesWithLiterals(narrowedType, valueType);
            }
            if (isUnitType(valueType)) {
              var regularType_1 = getRegularTypeOfLiteralType(valueType);
              return filterType(type, function(t) {
                return isUnitType(t) ? !areTypesComparable(t, valueType) : getRegularTypeOfLiteralType(t) !== regularType_1;
              });
            }
            return type;
          }
          function narrowTypeByTypeof(type, typeOfExpr, operator, literal, assumeTrue) {
            if (operator === 35 || operator === 37) {
              assumeTrue = !assumeTrue;
            }
            var target = getReferenceCandidate(typeOfExpr.expression);
            if (!isMatchingReference(reference, target)) {
              if (strictNullChecks && optionalChainContainsReference(target, reference) && assumeTrue === (literal.text !== "undefined")) {
                return getTypeWithFacts(type, 2097152);
              }
              return type;
            }
            if (type.flags & 1 && literal.text === "function") {
              return type;
            }
            if (assumeTrue && type.flags & 2 && literal.text === "object") {
              if (typeOfExpr.parent.parent.kind === 209) {
                var expr = typeOfExpr.parent.parent;
                if (expr.operatorToken.kind === 55 && expr.right === typeOfExpr.parent && containsTruthyCheck(reference, expr.left)) {
                  return nonPrimitiveType;
                }
              }
              return getUnionType([nonPrimitiveType, nullType]);
            }
            var facts = assumeTrue ? typeofEQFacts.get(literal.text) || 128 : typeofNEFacts.get(literal.text) || 32768;
            return getTypeWithFacts(assumeTrue ? mapType(type, narrowTypeForTypeof) : type, facts);
            function narrowTypeForTypeof(type2) {
              var targetType = literal.text === "function" ? globalFunctionType : typeofTypesByName.get(literal.text);
              if (targetType) {
                if (isTypeSubtypeOf(type2, targetType)) {
                  return type2;
                }
                if (isTypeSubtypeOf(targetType, type2)) {
                  return targetType;
                }
                if (type2.flags & 63176704) {
                  var constraint = getBaseConstraintOfType(type2) || anyType;
                  if (isTypeSubtypeOf(targetType, constraint)) {
                    return getIntersectionType([type2, targetType]);
                  }
                }
              }
              return type2;
            }
          }
          function narrowTypeBySwitchOptionalChainContainment(type, switchStatement, clauseStart, clauseEnd, clauseCheck) {
            var everyClauseChecks = clauseStart !== clauseEnd && ts2.every(getSwitchClauseTypes(switchStatement).slice(clauseStart, clauseEnd), clauseCheck);
            return everyClauseChecks ? getTypeWithFacts(type, 2097152) : type;
          }
          function narrowTypeBySwitchOnDiscriminant(type, switchStatement, clauseStart, clauseEnd) {
            var switchTypes = getSwitchClauseTypes(switchStatement);
            if (!switchTypes.length) {
              return type;
            }
            var clauseTypes = switchTypes.slice(clauseStart, clauseEnd);
            var hasDefaultClause = clauseStart === clauseEnd || ts2.contains(clauseTypes, neverType);
            if (type.flags & 2 && !hasDefaultClause) {
              var groundClauseTypes = void 0;
              for (var i = 0; i < clauseTypes.length; i += 1) {
                var t = clauseTypes[i];
                if (t.flags & (131068 | 67108864)) {
                  if (groundClauseTypes !== void 0) {
                    groundClauseTypes.push(t);
                  }
                } else if (t.flags & 524288) {
                  if (groundClauseTypes === void 0) {
                    groundClauseTypes = clauseTypes.slice(0, i);
                  }
                  groundClauseTypes.push(nonPrimitiveType);
                } else {
                  return type;
                }
              }
              return getUnionType(groundClauseTypes === void 0 ? clauseTypes : groundClauseTypes);
            }
            var discriminantType = getUnionType(clauseTypes);
            var caseType = discriminantType.flags & 131072 ? neverType : replacePrimitivesWithLiterals(filterType(type, function(t2) {
              return areTypesComparable(discriminantType, t2);
            }), discriminantType);
            if (!hasDefaultClause) {
              return caseType;
            }
            var defaultType = filterType(type, function(t2) {
              return !(isUnitType(t2) && ts2.contains(switchTypes, getRegularTypeOfLiteralType(t2)));
            });
            return caseType.flags & 131072 ? defaultType : getUnionType([caseType, defaultType]);
          }
          function getImpliedTypeFromTypeofCase(type, text) {
            switch (text) {
              case "function":
                return type.flags & 1 ? type : globalFunctionType;
              case "object":
                return type.flags & 2 ? getUnionType([nonPrimitiveType, nullType]) : type;
              default:
                return typeofTypesByName.get(text) || type;
            }
          }
          function narrowTypeForTypeofSwitch(candidate) {
            return function(type) {
              if (isTypeSubtypeOf(candidate, type)) {
                return candidate;
              }
              if (type.flags & 63176704) {
                var constraint = getBaseConstraintOfType(type) || anyType;
                if (isTypeSubtypeOf(candidate, constraint)) {
                  return getIntersectionType([type, candidate]);
                }
              }
              return type;
            };
          }
          function narrowBySwitchOnTypeOf(type, switchStatement, clauseStart, clauseEnd) {
            var switchWitnesses = getSwitchClauseTypeOfWitnesses(switchStatement, true);
            if (!switchWitnesses.length) {
              return type;
            }
            var defaultCaseLocation = ts2.findIndex(switchWitnesses, function(elem) {
              return elem === void 0;
            });
            var hasDefaultClause = clauseStart === clauseEnd || defaultCaseLocation >= clauseStart && defaultCaseLocation < clauseEnd;
            var clauseWitnesses;
            var switchFacts;
            if (defaultCaseLocation > -1) {
              var witnesses = switchWitnesses.filter(function(witness) {
                return witness !== void 0;
              });
              var fixedClauseStart = defaultCaseLocation < clauseStart ? clauseStart - 1 : clauseStart;
              var fixedClauseEnd = defaultCaseLocation < clauseEnd ? clauseEnd - 1 : clauseEnd;
              clauseWitnesses = witnesses.slice(fixedClauseStart, fixedClauseEnd);
              switchFacts = getFactsFromTypeofSwitch(fixedClauseStart, fixedClauseEnd, witnesses, hasDefaultClause);
            } else {
              clauseWitnesses = switchWitnesses.slice(clauseStart, clauseEnd);
              switchFacts = getFactsFromTypeofSwitch(clauseStart, clauseEnd, switchWitnesses, hasDefaultClause);
            }
            if (hasDefaultClause) {
              return filterType(type, function(t) {
                return (getTypeFacts(t) & switchFacts) === switchFacts;
              });
            }
            var impliedType = getTypeWithFacts(getUnionType(clauseWitnesses.map(function(text) {
              return getImpliedTypeFromTypeofCase(type, text);
            })), switchFacts);
            if (impliedType.flags & 1048576) {
              impliedType = getAssignmentReducedType(impliedType, getBaseConstraintOrType(type));
            }
            return getTypeWithFacts(mapType(type, narrowTypeForTypeofSwitch(impliedType)), switchFacts);
          }
          function isMatchingConstructorReference(expr) {
            return (ts2.isPropertyAccessExpression(expr) && ts2.idText(expr.name) === "constructor" || ts2.isElementAccessExpression(expr) && ts2.isStringLiteralLike(expr.argumentExpression) && expr.argumentExpression.text === "constructor") && isMatchingReference(reference, expr.expression);
          }
          function narrowTypeByConstructor(type, operator, identifier, assumeTrue) {
            if (assumeTrue ? operator !== 34 && operator !== 36 : operator !== 35 && operator !== 37) {
              return type;
            }
            var identifierType = getTypeOfExpression(identifier);
            if (!isFunctionType(identifierType) && !isConstructorType(identifierType)) {
              return type;
            }
            var prototypeProperty = getPropertyOfType(identifierType, "prototype");
            if (!prototypeProperty) {
              return type;
            }
            var prototypeType = getTypeOfSymbol(prototypeProperty);
            var candidate = !isTypeAny(prototypeType) ? prototypeType : void 0;
            if (!candidate || candidate === globalObjectType || candidate === globalFunctionType) {
              return type;
            }
            if (isTypeAny(type)) {
              return candidate;
            }
            return filterType(type, function(t) {
              return isConstructedBy(t, candidate);
            });
            function isConstructedBy(source, target) {
              if (source.flags & 524288 && ts2.getObjectFlags(source) & 1 || target.flags & 524288 && ts2.getObjectFlags(target) & 1) {
                return source.symbol === target.symbol;
              }
              return isTypeSubtypeOf(source, target);
            }
          }
          function narrowTypeByInstanceof(type, expr, assumeTrue) {
            var left = getReferenceCandidate(expr.left);
            if (!isMatchingReference(reference, left)) {
              if (assumeTrue && strictNullChecks && optionalChainContainsReference(left, reference)) {
                return getTypeWithFacts(type, 2097152);
              }
              return type;
            }
            var rightType = getTypeOfExpression(expr.right);
            if (!isTypeDerivedFrom(rightType, globalFunctionType)) {
              return type;
            }
            var targetType;
            var prototypeProperty = getPropertyOfType(rightType, "prototype");
            if (prototypeProperty) {
              var prototypePropertyType = getTypeOfSymbol(prototypeProperty);
              if (!isTypeAny(prototypePropertyType)) {
                targetType = prototypePropertyType;
              }
            }
            if (isTypeAny(type) && (targetType === globalObjectType || targetType === globalFunctionType)) {
              return type;
            }
            if (!targetType) {
              var constructSignatures = getSignaturesOfType(rightType, 1);
              targetType = constructSignatures.length ? getUnionType(ts2.map(constructSignatures, function(signature) {
                return getReturnTypeOfSignature(getErasedSignature(signature));
              })) : emptyObjectType;
            }
            return getNarrowedType(type, targetType, assumeTrue, isTypeDerivedFrom);
          }
          function getNarrowedType(type, candidate, assumeTrue, isRelated) {
            if (!assumeTrue) {
              return filterType(type, function(t) {
                return !isRelated(t, candidate);
              });
            }
            if (type.flags & 1048576) {
              var assignableType = filterType(type, function(t) {
                return isRelated(t, candidate);
              });
              if (!(assignableType.flags & 131072)) {
                return assignableType;
              }
            }
            return isTypeSubtypeOf(candidate, type) ? candidate : isTypeAssignableTo(type, candidate) ? type : isTypeAssignableTo(candidate, type) ? candidate : getIntersectionType([type, candidate]);
          }
          function narrowTypeByCallExpression(type, callExpression, assumeTrue) {
            if (hasMatchingArgument(callExpression, reference)) {
              var signature = assumeTrue || !ts2.isCallChain(callExpression) ? getEffectsSignature(callExpression) : void 0;
              var predicate = signature && getTypePredicateOfSignature(signature);
              if (predicate && (predicate.kind === 0 || predicate.kind === 1)) {
                return narrowTypeByTypePredicate(type, predicate, callExpression, assumeTrue);
              }
            }
            return type;
          }
          function narrowTypeByTypePredicate(type, predicate, callExpression, assumeTrue) {
            if (predicate.type && !(isTypeAny(type) && (predicate.type === globalObjectType || predicate.type === globalFunctionType))) {
              var predicateArgument = getTypePredicateArgument(predicate, callExpression);
              if (predicateArgument) {
                if (isMatchingReference(reference, predicateArgument)) {
                  return getNarrowedType(type, predicate.type, assumeTrue, isTypeSubtypeOf);
                }
                if (strictNullChecks && assumeTrue && optionalChainContainsReference(predicateArgument, reference) && !(getTypeFacts(predicate.type) & 65536)) {
                  type = getTypeWithFacts(type, 2097152);
                }
                if (isMatchingReferenceDiscriminant(predicateArgument, declaredType)) {
                  return narrowTypeByDiscriminant(type, predicateArgument, function(t) {
                    return getNarrowedType(t, predicate.type, assumeTrue, isTypeSubtypeOf);
                  });
                }
              }
            }
            return type;
          }
          function narrowType(type, expr, assumeTrue) {
            if (ts2.isExpressionOfOptionalChainRoot(expr) || ts2.isBinaryExpression(expr.parent) && expr.parent.operatorToken.kind === 60 && expr.parent.left === expr) {
              return narrowTypeByOptionality(type, expr, assumeTrue);
            }
            switch (expr.kind) {
              case 75:
              case 104:
              case 102:
              case 194:
              case 195:
                return narrowTypeByTruthiness(type, expr, assumeTrue);
              case 196:
                return narrowTypeByCallExpression(type, expr, assumeTrue);
              case 200:
                return narrowType(type, expr.expression, assumeTrue);
              case 209:
                return narrowTypeByBinaryExpression(type, expr, assumeTrue);
              case 207:
                if (expr.operator === 53) {
                  return narrowType(type, expr.operand, !assumeTrue);
                }
                break;
            }
            return type;
          }
          function narrowTypeByOptionality(type, expr, assumePresent) {
            if (isMatchingReference(reference, expr)) {
              return getTypeWithFacts(type, assumePresent ? 2097152 : 262144);
            }
            if (isMatchingReferenceDiscriminant(expr, declaredType)) {
              return narrowTypeByDiscriminant(type, expr, function(t) {
                return getTypeWithFacts(t, assumePresent ? 2097152 : 262144);
              });
            }
            return type;
          }
        }
        function getTypeOfSymbolAtLocation(symbol, location) {
          symbol = symbol.exportSymbol || symbol;
          if (location.kind === 75) {
            if (ts2.isRightSideOfQualifiedNameOrPropertyAccess(location)) {
              location = location.parent;
            }
            if (ts2.isExpressionNode(location) && !ts2.isAssignmentTarget(location)) {
              var type = getTypeOfExpression(location);
              if (getExportSymbolOfValueSymbolIfExported(getNodeLinks(location).resolvedSymbol) === symbol) {
                return type;
              }
            }
          }
          return getTypeOfSymbol(symbol);
        }
        function getControlFlowContainer(node) {
          return ts2.findAncestor(node.parent, function(node2) {
            return ts2.isFunctionLike(node2) && !ts2.getImmediatelyInvokedFunctionExpression(node2) || node2.kind === 250 || node2.kind === 290 || node2.kind === 159;
          });
        }
        function isParameterAssigned(symbol) {
          var func = ts2.getRootDeclaration(symbol.valueDeclaration).parent;
          var links = getNodeLinks(func);
          if (!(links.flags & 8388608)) {
            links.flags |= 8388608;
            if (!hasParentWithAssignmentsMarked(func)) {
              markParameterAssignments(func);
            }
          }
          return symbol.isAssigned || false;
        }
        function hasParentWithAssignmentsMarked(node) {
          return !!ts2.findAncestor(node.parent, function(node2) {
            return ts2.isFunctionLike(node2) && !!(getNodeLinks(node2).flags & 8388608);
          });
        }
        function markParameterAssignments(node) {
          if (node.kind === 75) {
            if (ts2.isAssignmentTarget(node)) {
              var symbol = getResolvedSymbol(node);
              if (symbol.valueDeclaration && ts2.getRootDeclaration(symbol.valueDeclaration).kind === 156) {
                symbol.isAssigned = true;
              }
            }
          } else {
            ts2.forEachChild(node, markParameterAssignments);
          }
        }
        function isConstVariable(symbol) {
          return symbol.flags & 3 && (getDeclarationNodeFlagsFromSymbol(symbol) & 2) !== 0 && getTypeOfSymbol(symbol) !== autoArrayType;
        }
        function removeOptionalityFromDeclaredType(declaredType, declaration) {
          if (pushTypeResolution(declaration.symbol, 2)) {
            var annotationIncludesUndefined = strictNullChecks && declaration.kind === 156 && declaration.initializer && getFalsyFlags(declaredType) & 32768 && !(getFalsyFlags(checkExpression(declaration.initializer)) & 32768);
            popTypeResolution();
            return annotationIncludesUndefined ? getTypeWithFacts(declaredType, 524288) : declaredType;
          } else {
            reportCircularityError(declaration.symbol);
            return declaredType;
          }
        }
        function isConstraintPosition(node) {
          var parent = node.parent;
          return parent.kind === 194 || parent.kind === 196 && parent.expression === node || parent.kind === 195 && parent.expression === node || parent.kind === 191 && parent.name === node && !!parent.initializer;
        }
        function typeHasNullableConstraint(type) {
          return type.flags & 58982400 && maybeTypeOfKind(getBaseConstraintOfType(type) || unknownType, 98304);
        }
        function getConstraintForLocation(type, node) {
          if (type && isConstraintPosition(node) && forEachType(type, typeHasNullableConstraint)) {
            return mapType(getWidenedType(type), getBaseConstraintOrType);
          }
          return type;
        }
        function isExportOrExportExpression(location) {
          return !!ts2.findAncestor(location, function(e) {
            return e.parent && ts2.isExportAssignment(e.parent) && e.parent.expression === e && ts2.isEntityNameExpression(e);
          });
        }
        function markAliasReferenced(symbol, location) {
          if (isNonLocalAlias(symbol, 111551) && !isInTypeQuery(location) && !getTypeOnlyAliasDeclaration(symbol)) {
            if (compilerOptions.preserveConstEnums && isExportOrExportExpression(location) || !isConstEnumOrConstEnumOnlyModule(resolveAlias(symbol))) {
              markAliasSymbolAsReferenced(symbol);
            } else {
              markConstEnumAliasAsReferenced(symbol);
            }
          }
        }
        function checkIdentifier(node) {
          var symbol = getResolvedSymbol(node);
          if (symbol === unknownSymbol) {
            return errorType;
          }
          if (symbol === argumentsSymbol) {
            var container = ts2.getContainingFunction(node);
            if (languageVersion < 2) {
              if (container.kind === 202) {
                error(node, ts2.Diagnostics.The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_standard_function_expression);
              } else if (ts2.hasModifier(container, 256)) {
                error(node, ts2.Diagnostics.The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_using_a_standard_function_or_method);
              }
            }
            getNodeLinks(container).flags |= 8192;
            return getTypeOfSymbol(symbol);
          }
          if (!(node.parent && ts2.isPropertyAccessExpression(node.parent) && node.parent.expression === node)) {
            markAliasReferenced(symbol, node);
          }
          var localOrExportSymbol = getExportSymbolOfValueSymbolIfExported(symbol);
          var declaration = localOrExportSymbol.valueDeclaration;
          if (localOrExportSymbol.flags & 32) {
            if (declaration.kind === 245 && ts2.nodeIsDecorated(declaration)) {
              var container = ts2.getContainingClass(node);
              while (container !== void 0) {
                if (container === declaration && container.name !== node) {
                  getNodeLinks(declaration).flags |= 16777216;
                  getNodeLinks(node).flags |= 33554432;
                  break;
                }
                container = ts2.getContainingClass(container);
              }
            } else if (declaration.kind === 214) {
              var container = ts2.getThisContainer(node, false);
              while (container.kind !== 290) {
                if (container.parent === declaration) {
                  if (container.kind === 159 && ts2.hasModifier(container, 32)) {
                    getNodeLinks(declaration).flags |= 16777216;
                    getNodeLinks(node).flags |= 33554432;
                  }
                  break;
                }
                container = ts2.getThisContainer(container, false);
              }
            }
          }
          checkNestedBlockScopedBinding(node, symbol);
          var type = getConstraintForLocation(getTypeOfSymbol(localOrExportSymbol), node);
          var assignmentKind = ts2.getAssignmentTargetKind(node);
          if (assignmentKind) {
            if (!(localOrExportSymbol.flags & 3) && !(ts2.isInJSFile(node) && localOrExportSymbol.flags & 512)) {
              error(node, ts2.Diagnostics.Cannot_assign_to_0_because_it_is_not_a_variable, symbolToString(symbol));
              return errorType;
            }
            if (isReadonlySymbol(localOrExportSymbol)) {
              if (localOrExportSymbol.flags & 3) {
                error(node, ts2.Diagnostics.Cannot_assign_to_0_because_it_is_a_constant, symbolToString(symbol));
              } else {
                error(node, ts2.Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property, symbolToString(symbol));
              }
              return errorType;
            }
          }
          var isAlias = localOrExportSymbol.flags & 2097152;
          if (localOrExportSymbol.flags & 3) {
            if (assignmentKind === 1) {
              return type;
            }
          } else if (isAlias) {
            declaration = ts2.find(symbol.declarations, isSomeImportDeclaration);
          } else {
            return type;
          }
          if (!declaration) {
            return type;
          }
          var isParameter = ts2.getRootDeclaration(declaration).kind === 156;
          var declarationContainer = getControlFlowContainer(declaration);
          var flowContainer = getControlFlowContainer(node);
          var isOuterVariable = flowContainer !== declarationContainer;
          var isSpreadDestructuringAssignmentTarget = node.parent && node.parent.parent && ts2.isSpreadAssignment(node.parent) && isDestructuringAssignmentTarget(node.parent.parent);
          var isModuleExports = symbol.flags & 134217728;
          while (flowContainer !== declarationContainer && (flowContainer.kind === 201 || flowContainer.kind === 202 || ts2.isObjectLiteralOrClassExpressionMethod(flowContainer)) && (isConstVariable(localOrExportSymbol) || isParameter && !isParameterAssigned(localOrExportSymbol))) {
            flowContainer = getControlFlowContainer(flowContainer);
          }
          var assumeInitialized = isParameter || isAlias || isOuterVariable || isSpreadDestructuringAssignmentTarget || isModuleExports || ts2.isBindingElement(declaration) || type !== autoType && type !== autoArrayType && (!strictNullChecks || (type.flags & (3 | 16384)) !== 0 || isInTypeQuery(node) || node.parent.kind === 263) || node.parent.kind === 218 || declaration.kind === 242 && declaration.exclamationToken || declaration.flags & 8388608;
          var initialType = assumeInitialized ? isParameter ? removeOptionalityFromDeclaredType(type, declaration) : type : type === autoType || type === autoArrayType ? undefinedType : getOptionalType(type);
          var flowType = getFlowTypeOfReference(node, type, initialType, flowContainer, !assumeInitialized);
          if (!isEvolvingArrayOperationTarget(node) && (type === autoType || type === autoArrayType)) {
            if (flowType === autoType || flowType === autoArrayType) {
              if (noImplicitAny) {
                error(ts2.getNameOfDeclaration(declaration), ts2.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined, symbolToString(symbol), typeToString(flowType));
                error(node, ts2.Diagnostics.Variable_0_implicitly_has_an_1_type, symbolToString(symbol), typeToString(flowType));
              }
              return convertAutoToAny(flowType);
            }
          } else if (!assumeInitialized && !(getFalsyFlags(type) & 32768) && getFalsyFlags(flowType) & 32768) {
            error(node, ts2.Diagnostics.Variable_0_is_used_before_being_assigned, symbolToString(symbol));
            return type;
          }
          return assignmentKind ? getBaseTypeOfLiteralType(flowType) : flowType;
        }
        function isInsideFunction(node, threshold) {
          return !!ts2.findAncestor(node, function(n) {
            return n === threshold ? "quit" : ts2.isFunctionLike(n);
          });
        }
        function getPartOfForStatementContainingNode(node, container) {
          return ts2.findAncestor(node, function(n) {
            return n === container ? "quit" : n === container.initializer || n === container.condition || n === container.incrementor || n === container.statement;
          });
        }
        function checkNestedBlockScopedBinding(node, symbol) {
          if (languageVersion >= 2 || (symbol.flags & (2 | 32)) === 0 || ts2.isSourceFile(symbol.valueDeclaration) || symbol.valueDeclaration.parent.kind === 280) {
            return;
          }
          var container = ts2.getEnclosingBlockScopeContainer(symbol.valueDeclaration);
          var usedInFunction = isInsideFunction(node.parent, container);
          var current = container;
          var containedInIterationStatement = false;
          while (current && !ts2.nodeStartsNewLexicalEnvironment(current)) {
            if (ts2.isIterationStatement(current, false)) {
              containedInIterationStatement = true;
              break;
            }
            current = current.parent;
          }
          if (containedInIterationStatement) {
            if (usedInFunction) {
              var capturesBlockScopeBindingInLoopBody = true;
              if (ts2.isForStatement(container)) {
                var varDeclList = ts2.getAncestor(symbol.valueDeclaration, 243);
                if (varDeclList && varDeclList.parent === container) {
                  var part = getPartOfForStatementContainingNode(node.parent, container);
                  if (part) {
                    var links = getNodeLinks(part);
                    links.flags |= 131072;
                    var capturedBindings = links.capturedBlockScopeBindings || (links.capturedBlockScopeBindings = []);
                    ts2.pushIfUnique(capturedBindings, symbol);
                    if (part === container.initializer) {
                      capturesBlockScopeBindingInLoopBody = false;
                    }
                  }
                }
              }
              if (capturesBlockScopeBindingInLoopBody) {
                getNodeLinks(current).flags |= 65536;
              }
            }
            if (ts2.isForStatement(container)) {
              var varDeclList = ts2.getAncestor(symbol.valueDeclaration, 243);
              if (varDeclList && varDeclList.parent === container && isAssignedInBodyOfForStatement(node, container)) {
                getNodeLinks(symbol.valueDeclaration).flags |= 4194304;
              }
            }
            getNodeLinks(symbol.valueDeclaration).flags |= 524288;
          }
          if (usedInFunction) {
            getNodeLinks(symbol.valueDeclaration).flags |= 262144;
          }
        }
        function isBindingCapturedByNode(node, decl) {
          var links = getNodeLinks(node);
          return !!links && ts2.contains(links.capturedBlockScopeBindings, getSymbolOfNode(decl));
        }
        function isAssignedInBodyOfForStatement(node, container) {
          var current = node;
          while (current.parent.kind === 200) {
            current = current.parent;
          }
          var isAssigned = false;
          if (ts2.isAssignmentTarget(current)) {
            isAssigned = true;
          } else if (current.parent.kind === 207 || current.parent.kind === 208) {
            var expr = current.parent;
            isAssigned = expr.operator === 45 || expr.operator === 46;
          }
          if (!isAssigned) {
            return false;
          }
          return !!ts2.findAncestor(current, function(n) {
            return n === container ? "quit" : n === container.statement;
          });
        }
        function captureLexicalThis(node, container) {
          getNodeLinks(node).flags |= 2;
          if (container.kind === 159 || container.kind === 162) {
            var classNode = container.parent;
            getNodeLinks(classNode).flags |= 4;
          } else {
            getNodeLinks(container).flags |= 4;
          }
        }
        function findFirstSuperCall(n) {
          if (ts2.isSuperCall(n)) {
            return n;
          } else if (ts2.isFunctionLike(n)) {
            return void 0;
          }
          return ts2.forEachChild(n, findFirstSuperCall);
        }
        function getSuperCallInConstructor(constructor) {
          var links = getNodeLinks(constructor);
          if (links.hasSuperCall === void 0) {
            links.superCall = findFirstSuperCall(constructor.body);
            links.hasSuperCall = links.superCall ? true : false;
          }
          return links.superCall;
        }
        function classDeclarationExtendsNull(classDecl) {
          var classSymbol = getSymbolOfNode(classDecl);
          var classInstanceType = getDeclaredTypeOfSymbol(classSymbol);
          var baseConstructorType = getBaseConstructorTypeOfClass(classInstanceType);
          return baseConstructorType === nullWideningType;
        }
        function checkThisBeforeSuper(node, container, diagnosticMessage) {
          var containingClassDecl = container.parent;
          var baseTypeNode = ts2.getClassExtendsHeritageElement(containingClassDecl);
          if (baseTypeNode && !classDeclarationExtendsNull(containingClassDecl)) {
            var superCall = getSuperCallInConstructor(container);
            if (!superCall || superCall.end > node.pos) {
              error(node, diagnosticMessage);
            }
          }
        }
        function checkThisExpression(node) {
          var container = ts2.getThisContainer(node, true);
          var capturedByArrowFunction = false;
          if (container.kind === 162) {
            checkThisBeforeSuper(node, container, ts2.Diagnostics.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class);
          }
          if (container.kind === 202) {
            container = ts2.getThisContainer(container, false);
            capturedByArrowFunction = true;
          }
          switch (container.kind) {
            case 249:
              error(node, ts2.Diagnostics.this_cannot_be_referenced_in_a_module_or_namespace_body);
              break;
            case 248:
              error(node, ts2.Diagnostics.this_cannot_be_referenced_in_current_location);
              break;
            case 162:
              if (isInConstructorArgumentInitializer(node, container)) {
                error(node, ts2.Diagnostics.this_cannot_be_referenced_in_constructor_arguments);
              }
              break;
            case 159:
            case 158:
              if (ts2.hasModifier(container, 32) && !(compilerOptions.target === 99 && compilerOptions.useDefineForClassFields)) {
                error(node, ts2.Diagnostics.this_cannot_be_referenced_in_a_static_property_initializer);
              }
              break;
            case 154:
              error(node, ts2.Diagnostics.this_cannot_be_referenced_in_a_computed_property_name);
              break;
          }
          if (capturedByArrowFunction && languageVersion < 2) {
            captureLexicalThis(node, container);
          }
          var type = tryGetThisTypeAt(node, true, container);
          if (noImplicitThis) {
            var globalThisType_1 = getTypeOfSymbol(globalThisSymbol);
            if (type === globalThisType_1 && capturedByArrowFunction) {
              error(node, ts2.Diagnostics.The_containing_arrow_function_captures_the_global_value_of_this);
            } else if (!type) {
              var diag = error(node, ts2.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation);
              if (!ts2.isSourceFile(container)) {
                var outsideThis = tryGetThisTypeAt(container);
                if (outsideThis && outsideThis !== globalThisType_1) {
                  ts2.addRelatedInfo(diag, ts2.createDiagnosticForNode(container, ts2.Diagnostics.An_outer_value_of_this_is_shadowed_by_this_container));
                }
              }
            }
          }
          return type || anyType;
        }
        function tryGetThisTypeAt(node, includeGlobalThis, container) {
          if (includeGlobalThis === void 0) {
            includeGlobalThis = true;
          }
          if (container === void 0) {
            container = ts2.getThisContainer(node, false);
          }
          var isInJS = ts2.isInJSFile(node);
          if (ts2.isFunctionLike(container) && (!isInParameterInitializerBeforeContainingFunction(node) || ts2.getThisParameter(container))) {
            var className = getClassNameFromPrototypeMethod(container);
            if (isInJS && className) {
              var classSymbol = checkExpression(className).symbol;
              if (classSymbol && classSymbol.members && classSymbol.flags & 16) {
                var classType = getDeclaredTypeOfSymbol(classSymbol).thisType;
                if (classType) {
                  return getFlowTypeOfReference(node, classType);
                }
              }
            } else if (isInJS && (container.kind === 201 || container.kind === 244) && ts2.getJSDocClassTag(container)) {
              var classType = getDeclaredTypeOfSymbol(getMergedSymbol(container.symbol)).thisType;
              return getFlowTypeOfReference(node, classType);
            }
            var thisType = getThisTypeOfDeclaration(container) || getContextualThisParameterType(container);
            if (thisType) {
              return getFlowTypeOfReference(node, thisType);
            }
          }
          if (ts2.isClassLike(container.parent)) {
            var symbol = getSymbolOfNode(container.parent);
            var type = ts2.hasModifier(container, 32) ? getTypeOfSymbol(symbol) : getDeclaredTypeOfSymbol(symbol).thisType;
            return getFlowTypeOfReference(node, type);
          }
          if (isInJS) {
            var type = getTypeForThisExpressionFromJSDoc(container);
            if (type && type !== errorType) {
              return getFlowTypeOfReference(node, type);
            }
          }
          if (ts2.isSourceFile(container)) {
            if (container.commonJsModuleIndicator) {
              var fileSymbol = getSymbolOfNode(container);
              return fileSymbol && getTypeOfSymbol(fileSymbol);
            } else if (includeGlobalThis) {
              return getTypeOfSymbol(globalThisSymbol);
            }
          }
        }
        function getExplicitThisType(node) {
          var container = ts2.getThisContainer(node, false);
          if (ts2.isFunctionLike(container)) {
            var signature = getSignatureFromDeclaration(container);
            if (signature.thisParameter) {
              return getExplicitTypeOfSymbol(signature.thisParameter);
            }
          }
          if (ts2.isClassLike(container.parent)) {
            var symbol = getSymbolOfNode(container.parent);
            return ts2.hasModifier(container, 32) ? getTypeOfSymbol(symbol) : getDeclaredTypeOfSymbol(symbol).thisType;
          }
        }
        function getClassNameFromPrototypeMethod(container) {
          if (container.kind === 201 && ts2.isBinaryExpression(container.parent) && ts2.getAssignmentDeclarationKind(container.parent) === 3) {
            return container.parent.left.expression.expression;
          } else if (container.kind === 161 && container.parent.kind === 193 && ts2.isBinaryExpression(container.parent.parent) && ts2.getAssignmentDeclarationKind(container.parent.parent) === 6) {
            return container.parent.parent.left.expression;
          } else if (container.kind === 201 && container.parent.kind === 281 && container.parent.parent.kind === 193 && ts2.isBinaryExpression(container.parent.parent.parent) && ts2.getAssignmentDeclarationKind(container.parent.parent.parent) === 6) {
            return container.parent.parent.parent.left.expression;
          } else if (container.kind === 201 && ts2.isPropertyAssignment(container.parent) && ts2.isIdentifier(container.parent.name) && (container.parent.name.escapedText === "value" || container.parent.name.escapedText === "get" || container.parent.name.escapedText === "set") && ts2.isObjectLiteralExpression(container.parent.parent) && ts2.isCallExpression(container.parent.parent.parent) && container.parent.parent.parent.arguments[2] === container.parent.parent && ts2.getAssignmentDeclarationKind(container.parent.parent.parent) === 9) {
            return container.parent.parent.parent.arguments[0].expression;
          } else if (ts2.isMethodDeclaration(container) && ts2.isIdentifier(container.name) && (container.name.escapedText === "value" || container.name.escapedText === "get" || container.name.escapedText === "set") && ts2.isObjectLiteralExpression(container.parent) && ts2.isCallExpression(container.parent.parent) && container.parent.parent.arguments[2] === container.parent && ts2.getAssignmentDeclarationKind(container.parent.parent) === 9) {
            return container.parent.parent.arguments[0].expression;
          }
        }
        function getTypeForThisExpressionFromJSDoc(node) {
          var jsdocType = ts2.getJSDocType(node);
          if (jsdocType && jsdocType.kind === 300) {
            var jsDocFunctionType = jsdocType;
            if (jsDocFunctionType.parameters.length > 0 && jsDocFunctionType.parameters[0].name && jsDocFunctionType.parameters[0].name.escapedText === "this") {
              return getTypeFromTypeNode(jsDocFunctionType.parameters[0].type);
            }
          }
          var thisTag = ts2.getJSDocThisTag(node);
          if (thisTag && thisTag.typeExpression) {
            return getTypeFromTypeNode(thisTag.typeExpression);
          }
        }
        function isInConstructorArgumentInitializer(node, constructorDecl) {
          return !!ts2.findAncestor(node, function(n) {
            return ts2.isFunctionLikeDeclaration(n) ? "quit" : n.kind === 156 && n.parent === constructorDecl;
          });
        }
        function checkSuperExpression(node) {
          var isCallExpression = node.parent.kind === 196 && node.parent.expression === node;
          var container = ts2.getSuperContainer(node, true);
          var needToCaptureLexicalThis = false;
          if (!isCallExpression) {
            while (container && container.kind === 202) {
              container = ts2.getSuperContainer(container, true);
              needToCaptureLexicalThis = languageVersion < 2;
            }
          }
          var canUseSuperExpression = isLegalUsageOfSuperExpression(container);
          var nodeCheckFlag = 0;
          if (!canUseSuperExpression) {
            var current = ts2.findAncestor(node, function(n) {
              return n === container ? "quit" : n.kind === 154;
            });
            if (current && current.kind === 154) {
              error(node, ts2.Diagnostics.super_cannot_be_referenced_in_a_computed_property_name);
            } else if (isCallExpression) {
              error(node, ts2.Diagnostics.Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors);
            } else if (!container || !container.parent || !(ts2.isClassLike(container.parent) || container.parent.kind === 193)) {
              error(node, ts2.Diagnostics.super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions);
            } else {
              error(node, ts2.Diagnostics.super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class);
            }
            return errorType;
          }
          if (!isCallExpression && container.kind === 162) {
            checkThisBeforeSuper(node, container, ts2.Diagnostics.super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class);
          }
          if (ts2.hasModifier(container, 32) || isCallExpression) {
            nodeCheckFlag = 512;
          } else {
            nodeCheckFlag = 256;
          }
          getNodeLinks(node).flags |= nodeCheckFlag;
          if (container.kind === 161 && ts2.hasModifier(container, 256)) {
            if (ts2.isSuperProperty(node.parent) && ts2.isAssignmentTarget(node.parent)) {
              getNodeLinks(container).flags |= 4096;
            } else {
              getNodeLinks(container).flags |= 2048;
            }
          }
          if (needToCaptureLexicalThis) {
            captureLexicalThis(node.parent, container);
          }
          if (container.parent.kind === 193) {
            if (languageVersion < 2) {
              error(node, ts2.Diagnostics.super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher);
              return errorType;
            } else {
              return anyType;
            }
          }
          var classLikeDeclaration = container.parent;
          if (!ts2.getClassExtendsHeritageElement(classLikeDeclaration)) {
            error(node, ts2.Diagnostics.super_can_only_be_referenced_in_a_derived_class);
            return errorType;
          }
          var classType = getDeclaredTypeOfSymbol(getSymbolOfNode(classLikeDeclaration));
          var baseClassType = classType && getBaseTypes(classType)[0];
          if (!baseClassType) {
            return errorType;
          }
          if (container.kind === 162 && isInConstructorArgumentInitializer(node, container)) {
            error(node, ts2.Diagnostics.super_cannot_be_referenced_in_constructor_arguments);
            return errorType;
          }
          return nodeCheckFlag === 512 ? getBaseConstructorTypeOfClass(classType) : getTypeWithThisArgument(baseClassType, classType.thisType);
          function isLegalUsageOfSuperExpression(container2) {
            if (!container2) {
              return false;
            }
            if (isCallExpression) {
              return container2.kind === 162;
            } else {
              if (ts2.isClassLike(container2.parent) || container2.parent.kind === 193) {
                if (ts2.hasModifier(container2, 32)) {
                  return container2.kind === 161 || container2.kind === 160 || container2.kind === 163 || container2.kind === 164;
                } else {
                  return container2.kind === 161 || container2.kind === 160 || container2.kind === 163 || container2.kind === 164 || container2.kind === 159 || container2.kind === 158 || container2.kind === 162;
                }
              }
            }
            return false;
          }
        }
        function getContainingObjectLiteral(func) {
          return (func.kind === 161 || func.kind === 163 || func.kind === 164) && func.parent.kind === 193 ? func.parent : func.kind === 201 && func.parent.kind === 281 ? func.parent.parent : void 0;
        }
        function getThisTypeArgument(type) {
          return ts2.getObjectFlags(type) & 4 && type.target === globalThisType ? getTypeArguments(type)[0] : void 0;
        }
        function getThisTypeFromContextualType(type) {
          return mapType(type, function(t) {
            return t.flags & 2097152 ? ts2.forEach(t.types, getThisTypeArgument) : getThisTypeArgument(t);
          });
        }
        function getContextualThisParameterType(func) {
          if (func.kind === 202) {
            return void 0;
          }
          if (isContextSensitiveFunctionOrObjectLiteralMethod(func)) {
            var contextualSignature = getContextualSignature(func);
            if (contextualSignature) {
              var thisParameter = contextualSignature.thisParameter;
              if (thisParameter) {
                return getTypeOfSymbol(thisParameter);
              }
            }
          }
          var inJs = ts2.isInJSFile(func);
          if (noImplicitThis || inJs) {
            var containingLiteral = getContainingObjectLiteral(func);
            if (containingLiteral) {
              var contextualType = getApparentTypeOfContextualType(containingLiteral);
              var literal = containingLiteral;
              var type = contextualType;
              while (type) {
                var thisType = getThisTypeFromContextualType(type);
                if (thisType) {
                  return instantiateType(thisType, getMapperFromContext(getInferenceContext(containingLiteral)));
                }
                if (literal.parent.kind !== 281) {
                  break;
                }
                literal = literal.parent.parent;
                type = getApparentTypeOfContextualType(literal);
              }
              return getWidenedType(contextualType ? getNonNullableType(contextualType) : checkExpressionCached(containingLiteral));
            }
            var parent = ts2.walkUpParenthesizedExpressions(func.parent);
            if (parent.kind === 209 && parent.operatorToken.kind === 62) {
              var target = parent.left;
              if (ts2.isAccessExpression(target)) {
                var expression = target.expression;
                if (inJs && ts2.isIdentifier(expression)) {
                  var sourceFile = ts2.getSourceFileOfNode(parent);
                  if (sourceFile.commonJsModuleIndicator && getResolvedSymbol(expression) === sourceFile.symbol) {
                    return void 0;
                  }
                }
                return getWidenedType(checkExpressionCached(expression));
              }
            }
          }
          return void 0;
        }
        function getContextuallyTypedParameterType(parameter) {
          var func = parameter.parent;
          if (!isContextSensitiveFunctionOrObjectLiteralMethod(func)) {
            return void 0;
          }
          var iife = ts2.getImmediatelyInvokedFunctionExpression(func);
          if (iife && iife.arguments) {
            var args = getEffectiveCallArguments(iife);
            var indexOfParameter = func.parameters.indexOf(parameter);
            if (parameter.dotDotDotToken) {
              return getSpreadArgumentType(args, indexOfParameter, args.length, anyType, void 0);
            }
            var links = getNodeLinks(iife);
            var cached = links.resolvedSignature;
            links.resolvedSignature = anySignature;
            var type = indexOfParameter < args.length ? getWidenedLiteralType(checkExpression(args[indexOfParameter])) : parameter.initializer ? void 0 : undefinedWideningType;
            links.resolvedSignature = cached;
            return type;
          }
          var contextualSignature = getContextualSignature(func);
          if (contextualSignature) {
            var index = func.parameters.indexOf(parameter) - (ts2.getThisParameter(func) ? 1 : 0);
            return parameter.dotDotDotToken && ts2.lastOrUndefined(func.parameters) === parameter ? getRestTypeAtPosition(contextualSignature, index) : tryGetTypeAtPosition(contextualSignature, index);
          }
        }
        function getContextualTypeForVariableLikeDeclaration(declaration) {
          var typeNode = ts2.getEffectiveTypeAnnotationNode(declaration);
          if (typeNode) {
            return getTypeFromTypeNode(typeNode);
          }
          switch (declaration.kind) {
            case 156:
              return getContextuallyTypedParameterType(declaration);
            case 191:
              return getContextualTypeForBindingElement(declaration);
          }
        }
        function getContextualTypeForBindingElement(declaration) {
          var parent = declaration.parent.parent;
          var name = declaration.propertyName || declaration.name;
          var parentType = getContextualTypeForVariableLikeDeclaration(parent) || parent.kind !== 191 && parent.initializer && checkDeclarationInitializer(parent);
          if (parentType && !ts2.isBindingPattern(name) && !ts2.isComputedNonLiteralName(name)) {
            var nameType = getLiteralTypeFromPropertyName(name);
            if (isTypeUsableAsPropertyName(nameType)) {
              var text = getPropertyNameFromType(nameType);
              return getTypeOfPropertyOfType(parentType, text);
            }
          }
        }
        function getContextualTypeForInitializerExpression(node) {
          var declaration = node.parent;
          if (ts2.hasInitializer(declaration) && node === declaration.initializer) {
            var result = getContextualTypeForVariableLikeDeclaration(declaration);
            if (result) {
              return result;
            }
            if (ts2.isBindingPattern(declaration.name)) {
              return getTypeFromBindingPattern(declaration.name, true, false);
            }
          }
          return void 0;
        }
        function getContextualTypeForReturnExpression(node) {
          var func = ts2.getContainingFunction(node);
          if (func) {
            var functionFlags = ts2.getFunctionFlags(func);
            if (functionFlags & 1) {
              return void 0;
            }
            var contextualReturnType = getContextualReturnType(func);
            if (contextualReturnType) {
              if (functionFlags & 2) {
                var contextualAwaitedType = mapType(contextualReturnType, getAwaitedTypeOfPromise);
                return contextualAwaitedType && getUnionType([contextualAwaitedType, createPromiseLikeType(contextualAwaitedType)]);
              }
              return contextualReturnType;
            }
          }
          return void 0;
        }
        function getContextualTypeForAwaitOperand(node) {
          var contextualType = getContextualType(node);
          if (contextualType) {
            var contextualAwaitedType = getAwaitedType(contextualType);
            return contextualAwaitedType && getUnionType([contextualAwaitedType, createPromiseLikeType(contextualAwaitedType)]);
          }
          return void 0;
        }
        function getContextualTypeForYieldOperand(node) {
          var func = ts2.getContainingFunction(node);
          if (func) {
            var functionFlags = ts2.getFunctionFlags(func);
            var contextualReturnType = getContextualReturnType(func);
            if (contextualReturnType) {
              return node.asteriskToken ? contextualReturnType : getIterationTypeOfGeneratorFunctionReturnType(0, contextualReturnType, (functionFlags & 2) !== 0);
            }
          }
          return void 0;
        }
        function isInParameterInitializerBeforeContainingFunction(node) {
          var inBindingInitializer = false;
          while (node.parent && !ts2.isFunctionLike(node.parent)) {
            if (ts2.isParameter(node.parent) && (inBindingInitializer || node.parent.initializer === node)) {
              return true;
            }
            if (ts2.isBindingElement(node.parent) && node.parent.initializer === node) {
              inBindingInitializer = true;
            }
            node = node.parent;
          }
          return false;
        }
        function getContextualIterationType(kind, functionDecl) {
          var isAsync = !!(ts2.getFunctionFlags(functionDecl) & 2);
          var contextualReturnType = getContextualReturnType(functionDecl);
          if (contextualReturnType) {
            return getIterationTypeOfGeneratorFunctionReturnType(kind, contextualReturnType, isAsync) || void 0;
          }
          return void 0;
        }
        function getContextualReturnType(functionDecl) {
          var returnType = getReturnTypeFromAnnotation(functionDecl);
          if (returnType) {
            return returnType;
          }
          var signature = getContextualSignatureForFunctionLikeDeclaration(functionDecl);
          if (signature && !isResolvingReturnTypeOfSignature(signature)) {
            return getReturnTypeOfSignature(signature);
          }
          return void 0;
        }
        function getContextualTypeForArgument(callTarget, arg) {
          var args = getEffectiveCallArguments(callTarget);
          var argIndex = args.indexOf(arg);
          return argIndex === -1 ? void 0 : getContextualTypeForArgumentAtIndex(callTarget, argIndex);
        }
        function getContextualTypeForArgumentAtIndex(callTarget, argIndex) {
          var signature = getNodeLinks(callTarget).resolvedSignature === resolvingSignature ? resolvingSignature : getResolvedSignature(callTarget);
          if (ts2.isJsxOpeningLikeElement(callTarget) && argIndex === 0) {
            return getEffectiveFirstArgumentForJsxSignature(signature, callTarget);
          }
          return getTypeAtPosition(signature, argIndex);
        }
        function getContextualTypeForSubstitutionExpression(template, substitutionExpression) {
          if (template.parent.kind === 198) {
            return getContextualTypeForArgument(template.parent, substitutionExpression);
          }
          return void 0;
        }
        function getContextualTypeForBinaryOperand(node, contextFlags) {
          var binaryExpression = node.parent;
          var left = binaryExpression.left, operatorToken = binaryExpression.operatorToken, right = binaryExpression.right;
          switch (operatorToken.kind) {
            case 62:
              if (node !== right) {
                return void 0;
              }
              var contextSensitive = getIsContextSensitiveAssignmentOrContextType(binaryExpression);
              if (!contextSensitive) {
                return void 0;
              }
              return contextSensitive === true ? getTypeOfExpression(left) : contextSensitive;
            case 56:
            case 60:
              var type = getContextualType(binaryExpression, contextFlags);
              return node === right && (type && type.pattern || !type && !ts2.isDefaultedExpandoInitializer(binaryExpression)) ? getTypeOfExpression(left) : type;
            case 55:
            case 27:
              return node === right ? getContextualType(binaryExpression, contextFlags) : void 0;
            default:
              return void 0;
          }
        }
        function getIsContextSensitiveAssignmentOrContextType(binaryExpression) {
          var kind = ts2.getAssignmentDeclarationKind(binaryExpression);
          switch (kind) {
            case 0:
              return true;
            case 5:
            case 1:
            case 6:
            case 3:
              if (!binaryExpression.left.symbol) {
                return true;
              } else {
                var decl = binaryExpression.left.symbol.valueDeclaration;
                if (!decl) {
                  return false;
                }
                var lhs = ts2.cast(binaryExpression.left, ts2.isAccessExpression);
                var overallAnnotation = ts2.getEffectiveTypeAnnotationNode(decl);
                if (overallAnnotation) {
                  return getTypeFromTypeNode(overallAnnotation);
                } else if (ts2.isIdentifier(lhs.expression)) {
                  var id = lhs.expression;
                  var parentSymbol = resolveName(id, id.escapedText, 111551, void 0, id.escapedText, true);
                  if (parentSymbol) {
                    var annotated = ts2.getEffectiveTypeAnnotationNode(parentSymbol.valueDeclaration);
                    if (annotated) {
                      var nameStr_1 = ts2.getElementOrPropertyAccessName(lhs);
                      if (nameStr_1 !== void 0) {
                        var type = getTypeOfPropertyOfContextualType(getTypeFromTypeNode(annotated), nameStr_1);
                        return type || false;
                      }
                    }
                    return false;
                  }
                }
                return !ts2.isInJSFile(decl);
              }
            case 2:
            case 4:
              if (!binaryExpression.symbol)
                return true;
              if (binaryExpression.symbol.valueDeclaration) {
                var annotated = ts2.getEffectiveTypeAnnotationNode(binaryExpression.symbol.valueDeclaration);
                if (annotated) {
                  var type = getTypeFromTypeNode(annotated);
                  if (type) {
                    return type;
                  }
                }
              }
              if (kind === 2)
                return false;
              var thisAccess = ts2.cast(binaryExpression.left, ts2.isAccessExpression);
              if (!ts2.isObjectLiteralMethod(ts2.getThisContainer(thisAccess.expression, false))) {
                return false;
              }
              var thisType = checkThisExpression(thisAccess.expression);
              var nameStr = ts2.getElementOrPropertyAccessName(thisAccess);
              return nameStr !== void 0 && thisType && getTypeOfPropertyOfContextualType(thisType, nameStr) || false;
            case 7:
            case 8:
            case 9:
              return ts2.Debug.fail("Does not apply");
            default:
              return ts2.Debug.assertNever(kind);
          }
        }
        function isCircularMappedProperty(symbol) {
          return !!(ts2.getCheckFlags(symbol) & 262144 && !symbol.type && findResolutionCycleStartIndex(symbol, 0) >= 0);
        }
        function getTypeOfPropertyOfContextualType(type, name) {
          return mapType(type, function(t) {
            if (isGenericMappedType(t)) {
              var constraint = getConstraintTypeFromMappedType(t);
              var constraintOfConstraint = getBaseConstraintOfType(constraint) || constraint;
              var propertyNameType = getLiteralType(ts2.unescapeLeadingUnderscores(name));
              if (isTypeAssignableTo(propertyNameType, constraintOfConstraint)) {
                return substituteIndexedMappedType(t, propertyNameType);
              }
            } else if (t.flags & 3670016) {
              var prop = getPropertyOfType(t, name);
              if (prop) {
                return isCircularMappedProperty(prop) ? void 0 : getTypeOfSymbol(prop);
              }
              if (isTupleType(t)) {
                var restType = getRestTypeOfTupleType(t);
                if (restType && isNumericLiteralName(name) && +name >= 0) {
                  return restType;
                }
              }
              return isNumericLiteralName(name) && getIndexTypeOfContextualType(t, 1) || getIndexTypeOfContextualType(t, 0);
            }
            return void 0;
          }, true);
        }
        function getIndexTypeOfContextualType(type, kind) {
          return mapType(type, function(t) {
            return getIndexTypeOfStructuredType(t, kind);
          }, true);
        }
        function getContextualTypeForObjectLiteralMethod(node, contextFlags) {
          ts2.Debug.assert(ts2.isObjectLiteralMethod(node));
          if (node.flags & 16777216) {
            return void 0;
          }
          return getContextualTypeForObjectLiteralElement(node, contextFlags);
        }
        function getContextualTypeForObjectLiteralElement(element, contextFlags) {
          var objectLiteral = element.parent;
          var type = getApparentTypeOfContextualType(objectLiteral, contextFlags);
          if (type) {
            if (!hasNonBindableDynamicName(element)) {
              var symbolName_3 = getSymbolOfNode(element).escapedName;
              var propertyType = getTypeOfPropertyOfContextualType(type, symbolName_3);
              if (propertyType) {
                return propertyType;
              }
            }
            return isNumericName(element.name) && getIndexTypeOfContextualType(type, 1) || getIndexTypeOfContextualType(type, 0);
          }
          return void 0;
        }
        function getContextualTypeForElementExpression(arrayContextualType, index) {
          return arrayContextualType && (getTypeOfPropertyOfContextualType(arrayContextualType, "" + index) || getIteratedTypeOrElementType(1, arrayContextualType, undefinedType, void 0, false));
        }
        function getContextualTypeForConditionalOperand(node, contextFlags) {
          var conditional = node.parent;
          return node === conditional.whenTrue || node === conditional.whenFalse ? getContextualType(conditional, contextFlags) : void 0;
        }
        function getContextualTypeForChildJsxExpression(node, child) {
          var attributesType = getApparentTypeOfContextualType(node.openingElement.tagName);
          var jsxChildrenPropertyName = getJsxElementChildrenPropertyName(getJsxNamespaceAt(node));
          if (!(attributesType && !isTypeAny(attributesType) && jsxChildrenPropertyName && jsxChildrenPropertyName !== "")) {
            return void 0;
          }
          var realChildren = getSemanticJsxChildren(node.children);
          var childIndex = realChildren.indexOf(child);
          var childFieldType = getTypeOfPropertyOfContextualType(attributesType, jsxChildrenPropertyName);
          return childFieldType && (realChildren.length === 1 ? childFieldType : mapType(childFieldType, function(t) {
            if (isArrayLikeType(t)) {
              return getIndexedAccessType(t, getLiteralType(childIndex));
            } else {
              return t;
            }
          }, true));
        }
        function getContextualTypeForJsxExpression(node) {
          var exprParent = node.parent;
          return ts2.isJsxAttributeLike(exprParent) ? getContextualType(node) : ts2.isJsxElement(exprParent) ? getContextualTypeForChildJsxExpression(exprParent, node) : void 0;
        }
        function getContextualTypeForJsxAttribute(attribute) {
          if (ts2.isJsxAttribute(attribute)) {
            var attributesType = getApparentTypeOfContextualType(attribute.parent);
            if (!attributesType || isTypeAny(attributesType)) {
              return void 0;
            }
            return getTypeOfPropertyOfContextualType(attributesType, attribute.name.escapedText);
          } else {
            return getContextualType(attribute.parent);
          }
        }
        function isPossiblyDiscriminantValue(node) {
          switch (node.kind) {
            case 10:
            case 8:
            case 9:
            case 14:
            case 106:
            case 91:
            case 100:
            case 75:
            case 146:
              return true;
            case 194:
            case 200:
              return isPossiblyDiscriminantValue(node.expression);
            case 276:
              return !node.expression || isPossiblyDiscriminantValue(node.expression);
          }
          return false;
        }
        function discriminateContextualTypeByObjectMembers(node, contextualType) {
          return discriminateTypeByDiscriminableItems(contextualType, ts2.map(ts2.filter(node.properties, function(p) {
            return !!p.symbol && p.kind === 281 && isPossiblyDiscriminantValue(p.initializer) && isDiscriminantProperty(contextualType, p.symbol.escapedName);
          }), function(prop) {
            return [function() {
              return checkExpression(prop.initializer);
            }, prop.symbol.escapedName];
          }), isTypeAssignableTo, contextualType);
        }
        function discriminateContextualTypeByJSXAttributes(node, contextualType) {
          return discriminateTypeByDiscriminableItems(contextualType, ts2.map(ts2.filter(node.properties, function(p) {
            return !!p.symbol && p.kind === 273 && isDiscriminantProperty(contextualType, p.symbol.escapedName) && (!p.initializer || isPossiblyDiscriminantValue(p.initializer));
          }), function(prop) {
            return [!prop.initializer ? function() {
              return trueType;
            } : function() {
              return checkExpression(prop.initializer);
            }, prop.symbol.escapedName];
          }), isTypeAssignableTo, contextualType);
        }
        function getApparentTypeOfContextualType(node, contextFlags) {
          var contextualType = ts2.isObjectLiteralMethod(node) ? getContextualTypeForObjectLiteralMethod(node, contextFlags) : getContextualType(node, contextFlags);
          var instantiatedType = instantiateContextualType(contextualType, node, contextFlags);
          if (instantiatedType && !(contextFlags && contextFlags & 2 && instantiatedType.flags & 8650752)) {
            var apparentType = mapType(instantiatedType, getApparentType, true);
            if (apparentType.flags & 1048576) {
              if (ts2.isObjectLiteralExpression(node)) {
                return discriminateContextualTypeByObjectMembers(node, apparentType);
              } else if (ts2.isJsxAttributes(node)) {
                return discriminateContextualTypeByJSXAttributes(node, apparentType);
              }
            }
            return apparentType;
          }
        }
        function instantiateContextualType(contextualType, node, contextFlags) {
          if (contextualType && maybeTypeOfKind(contextualType, 63176704)) {
            var inferenceContext = getInferenceContext(node);
            if (inferenceContext && ts2.some(inferenceContext.inferences, hasInferenceCandidates)) {
              if (contextFlags && contextFlags & 1) {
                return instantiateInstantiableTypes(contextualType, inferenceContext.nonFixingMapper);
              }
              if (inferenceContext.returnMapper) {
                return instantiateInstantiableTypes(contextualType, inferenceContext.returnMapper);
              }
            }
          }
          return contextualType;
        }
        function instantiateInstantiableTypes(type, mapper) {
          if (type.flags & 63176704) {
            return instantiateType(type, mapper);
          }
          if (type.flags & 1048576) {
            return getUnionType(ts2.map(type.types, function(t) {
              return instantiateInstantiableTypes(t, mapper);
            }), 0);
          }
          if (type.flags & 2097152) {
            return getIntersectionType(ts2.map(type.types, function(t) {
              return instantiateInstantiableTypes(t, mapper);
            }));
          }
          return type;
        }
        function getContextualType(node, contextFlags) {
          if (node.flags & 16777216) {
            return void 0;
          }
          if (node.contextualType) {
            return node.contextualType;
          }
          var parent = node.parent;
          switch (parent.kind) {
            case 242:
            case 156:
            case 159:
            case 158:
            case 191:
              return getContextualTypeForInitializerExpression(node);
            case 202:
            case 235:
              return getContextualTypeForReturnExpression(node);
            case 212:
              return getContextualTypeForYieldOperand(parent);
            case 206:
              return getContextualTypeForAwaitOperand(parent);
            case 196:
              if (parent.expression.kind === 96) {
                return stringType;
              }
            case 197:
              return getContextualTypeForArgument(parent, node);
            case 199:
            case 217:
              return ts2.isConstTypeReference(parent.type) ? void 0 : getTypeFromTypeNode(parent.type);
            case 209:
              return getContextualTypeForBinaryOperand(node, contextFlags);
            case 281:
            case 282:
              return getContextualTypeForObjectLiteralElement(parent, contextFlags);
            case 283:
              return getApparentTypeOfContextualType(parent.parent, contextFlags);
            case 192: {
              var arrayLiteral = parent;
              var type = getApparentTypeOfContextualType(arrayLiteral, contextFlags);
              return getContextualTypeForElementExpression(type, ts2.indexOfNode(arrayLiteral.elements, node));
            }
            case 210:
              return getContextualTypeForConditionalOperand(node, contextFlags);
            case 221:
              ts2.Debug.assert(parent.parent.kind === 211);
              return getContextualTypeForSubstitutionExpression(parent.parent, node);
            case 200: {
              var tag = ts2.isInJSFile(parent) ? ts2.getJSDocTypeTag(parent) : void 0;
              return tag ? getTypeFromTypeNode(tag.typeExpression.type) : getContextualType(parent, contextFlags);
            }
            case 276:
              return getContextualTypeForJsxExpression(parent);
            case 273:
            case 275:
              return getContextualTypeForJsxAttribute(parent);
            case 268:
            case 267:
              return getContextualJsxElementAttributesType(parent, contextFlags);
          }
          return void 0;
        }
        function getInferenceContext(node) {
          var ancestor = ts2.findAncestor(node, function(n) {
            return !!n.inferenceContext;
          });
          return ancestor && ancestor.inferenceContext;
        }
        function getContextualJsxElementAttributesType(node, contextFlags) {
          if (ts2.isJsxOpeningElement(node) && node.parent.contextualType && contextFlags !== 4) {
            return node.parent.contextualType;
          }
          return getContextualTypeForArgumentAtIndex(node, 0);
        }
        function getEffectiveFirstArgumentForJsxSignature(signature, node) {
          return getJsxReferenceKind(node) !== 0 ? getJsxPropsTypeFromCallSignature(signature, node) : getJsxPropsTypeFromClassType(signature, node);
        }
        function getJsxPropsTypeFromCallSignature(sig, context) {
          var propsType = getTypeOfFirstParameterOfSignatureWithFallback(sig, unknownType);
          propsType = getJsxManagedAttributesFromLocatedAttributes(context, getJsxNamespaceAt(context), propsType);
          var intrinsicAttribs = getJsxType(JsxNames.IntrinsicAttributes, context);
          if (intrinsicAttribs !== errorType) {
            propsType = intersectTypes(intrinsicAttribs, propsType);
          }
          return propsType;
        }
        function getJsxPropsTypeForSignatureFromMember(sig, forcedLookupLocation) {
          if (sig.unionSignatures) {
            var results = [];
            for (var _i = 0, _a = sig.unionSignatures; _i < _a.length; _i++) {
              var signature = _a[_i];
              var instance = getReturnTypeOfSignature(signature);
              if (isTypeAny(instance)) {
                return instance;
              }
              var propType = getTypeOfPropertyOfType(instance, forcedLookupLocation);
              if (!propType) {
                return;
              }
              results.push(propType);
            }
            return getIntersectionType(results);
          }
          var instanceType = getReturnTypeOfSignature(sig);
          return isTypeAny(instanceType) ? instanceType : getTypeOfPropertyOfType(instanceType, forcedLookupLocation);
        }
        function getStaticTypeOfReferencedJsxConstructor(context) {
          if (isJsxIntrinsicIdentifier(context.tagName)) {
            var result = getIntrinsicAttributesTypeFromJsxOpeningLikeElement(context);
            var fakeSignature = createSignatureForJSXIntrinsic(context, result);
            return getOrCreateTypeFromSignature(fakeSignature);
          }
          var tagType = checkExpressionCached(context.tagName);
          if (tagType.flags & 128) {
            var result = getIntrinsicAttributesTypeFromStringLiteralType(tagType, context);
            if (!result) {
              return errorType;
            }
            var fakeSignature = createSignatureForJSXIntrinsic(context, result);
            return getOrCreateTypeFromSignature(fakeSignature);
          }
          return tagType;
        }
        function getJsxManagedAttributesFromLocatedAttributes(context, ns, attributesType) {
          var managedSym = getJsxLibraryManagedAttributes(ns);
          if (managedSym) {
            var declaredManagedType = getDeclaredTypeOfSymbol(managedSym);
            var ctorType = getStaticTypeOfReferencedJsxConstructor(context);
            if (ts2.length(declaredManagedType.typeParameters) >= 2) {
              var args = fillMissingTypeArguments([ctorType, attributesType], declaredManagedType.typeParameters, 2, ts2.isInJSFile(context));
              return createTypeReference(declaredManagedType, args);
            } else if (ts2.length(declaredManagedType.aliasTypeArguments) >= 2) {
              var args = fillMissingTypeArguments([ctorType, attributesType], declaredManagedType.aliasTypeArguments, 2, ts2.isInJSFile(context));
              return getTypeAliasInstantiation(declaredManagedType.aliasSymbol, args);
            }
          }
          return attributesType;
        }
        function getJsxPropsTypeFromClassType(sig, context) {
          var ns = getJsxNamespaceAt(context);
          var forcedLookupLocation = getJsxElementPropertiesName(ns);
          var attributesType = forcedLookupLocation === void 0 ? getTypeOfFirstParameterOfSignatureWithFallback(sig, unknownType) : forcedLookupLocation === "" ? getReturnTypeOfSignature(sig) : getJsxPropsTypeForSignatureFromMember(sig, forcedLookupLocation);
          if (!attributesType) {
            if (!!forcedLookupLocation && !!ts2.length(context.attributes.properties)) {
              error(context, ts2.Diagnostics.JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property, ts2.unescapeLeadingUnderscores(forcedLookupLocation));
            }
            return unknownType;
          }
          attributesType = getJsxManagedAttributesFromLocatedAttributes(context, ns, attributesType);
          if (isTypeAny(attributesType)) {
            return attributesType;
          } else {
            var apparentAttributesType = attributesType;
            var intrinsicClassAttribs = getJsxType(JsxNames.IntrinsicClassAttributes, context);
            if (intrinsicClassAttribs !== errorType) {
              var typeParams = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(intrinsicClassAttribs.symbol);
              var hostClassType = getReturnTypeOfSignature(sig);
              apparentAttributesType = intersectTypes(typeParams ? createTypeReference(intrinsicClassAttribs, fillMissingTypeArguments([hostClassType], typeParams, getMinTypeArgumentCount(typeParams), ts2.isInJSFile(context))) : intrinsicClassAttribs, apparentAttributesType);
            }
            var intrinsicAttribs = getJsxType(JsxNames.IntrinsicAttributes, context);
            if (intrinsicAttribs !== errorType) {
              apparentAttributesType = intersectTypes(intrinsicAttribs, apparentAttributesType);
            }
            return apparentAttributesType;
          }
        }
        function getContextualCallSignature(type, node) {
          var signatures = getSignaturesOfType(type, 0);
          if (signatures.length === 1) {
            var signature = signatures[0];
            if (!isAritySmaller(signature, node)) {
              return signature;
            }
          }
        }
        function isAritySmaller(signature, target) {
          var targetParameterCount = 0;
          for (; targetParameterCount < target.parameters.length; targetParameterCount++) {
            var param = target.parameters[targetParameterCount];
            if (param.initializer || param.questionToken || param.dotDotDotToken || isJSDocOptionalParameter(param)) {
              break;
            }
          }
          if (target.parameters.length && ts2.parameterIsThisKeyword(target.parameters[0])) {
            targetParameterCount--;
          }
          return !hasEffectiveRestParameter(signature) && getParameterCount(signature) < targetParameterCount;
        }
        function isFunctionExpressionOrArrowFunction(node) {
          return node.kind === 201 || node.kind === 202;
        }
        function getContextualSignatureForFunctionLikeDeclaration(node) {
          return isFunctionExpressionOrArrowFunction(node) || ts2.isObjectLiteralMethod(node) ? getContextualSignature(node) : void 0;
        }
        function getContextualSignature(node) {
          ts2.Debug.assert(node.kind !== 161 || ts2.isObjectLiteralMethod(node));
          var typeTagSignature = getSignatureOfTypeTag(node);
          if (typeTagSignature) {
            return typeTagSignature;
          }
          var type = getApparentTypeOfContextualType(node, 1);
          if (!type) {
            return void 0;
          }
          if (!(type.flags & 1048576)) {
            return getContextualCallSignature(type, node);
          }
          var signatureList;
          var types = type.types;
          for (var _i = 0, types_17 = types; _i < types_17.length; _i++) {
            var current = types_17[_i];
            var signature = getContextualCallSignature(current, node);
            if (signature) {
              if (!signatureList) {
                signatureList = [signature];
              } else if (!compareSignaturesIdentical(signatureList[0], signature, false, true, true, compareTypesIdentical)) {
                return void 0;
              } else {
                signatureList.push(signature);
              }
            }
          }
          if (signatureList) {
            return signatureList.length === 1 ? signatureList[0] : createUnionSignature(signatureList[0], signatureList);
          }
        }
        function checkSpreadExpression(node, checkMode) {
          if (languageVersion < 2) {
            checkExternalEmitHelpers(node, compilerOptions.downlevelIteration ? 1536 : 2048);
          }
          var arrayOrIterableType = checkExpression(node.expression, checkMode);
          return checkIteratedTypeOrElementType(33, arrayOrIterableType, undefinedType, node.expression);
        }
        function hasDefaultValue(node) {
          return node.kind === 191 && !!node.initializer || node.kind === 209 && node.operatorToken.kind === 62;
        }
        function checkArrayLiteral(node, checkMode, forceTuple) {
          var elements = node.elements;
          var elementCount = elements.length;
          var elementTypes = [];
          var hasEndingSpreadElement = false;
          var hasNonEndingSpreadElement = false;
          var contextualType = getApparentTypeOfContextualType(node);
          var inDestructuringPattern = ts2.isAssignmentTarget(node);
          var inConstContext = isConstContext(node);
          for (var i = 0; i < elementCount; i++) {
            var e = elements[i];
            var spread = e.kind === 213 && e.expression;
            var spreadType = spread && checkExpression(spread, checkMode, forceTuple);
            if (spreadType && isTupleType(spreadType)) {
              elementTypes.push.apply(elementTypes, getTypeArguments(spreadType));
              if (spreadType.target.hasRestElement) {
                if (i === elementCount - 1)
                  hasEndingSpreadElement = true;
                else
                  hasNonEndingSpreadElement = true;
              }
            } else {
              if (inDestructuringPattern && spreadType) {
                var restElementType = getIndexTypeOfType(spreadType, 1) || getIteratedTypeOrElementType(65, spreadType, undefinedType, void 0, false);
                if (restElementType) {
                  elementTypes.push(restElementType);
                }
              } else {
                var elementContextualType = getContextualTypeForElementExpression(contextualType, elementTypes.length);
                var type = checkExpressionForMutableLocation(e, checkMode, elementContextualType, forceTuple);
                elementTypes.push(type);
              }
              if (spread) {
                if (i === elementCount - 1)
                  hasEndingSpreadElement = true;
                else
                  hasNonEndingSpreadElement = true;
              }
            }
          }
          if (!hasNonEndingSpreadElement) {
            var minLength = elementTypes.length - (hasEndingSpreadElement ? 1 : 0);
            var tupleResult = void 0;
            if (inDestructuringPattern && minLength > 0) {
              var type = cloneTypeReference(createTupleType(elementTypes, minLength, hasEndingSpreadElement));
              type.pattern = node;
              return type;
            } else if (tupleResult = getArrayLiteralTupleTypeIfApplicable(elementTypes, contextualType, hasEndingSpreadElement, elementTypes.length, inConstContext)) {
              return createArrayLiteralType(tupleResult);
            } else if (forceTuple) {
              return createArrayLiteralType(createTupleType(elementTypes, minLength, hasEndingSpreadElement));
            }
          }
          return createArrayLiteralType(createArrayType(elementTypes.length ? getUnionType(elementTypes, 2) : strictNullChecks ? implicitNeverType : undefinedWideningType, inConstContext));
        }
        function createArrayLiteralType(type) {
          if (!(ts2.getObjectFlags(type) & 4)) {
            return type;
          }
          var literalType = type.literalType;
          if (!literalType) {
            literalType = type.literalType = cloneTypeReference(type);
            literalType.objectFlags |= 65536 | 1048576;
          }
          return literalType;
        }
        function getArrayLiteralTupleTypeIfApplicable(elementTypes, contextualType, hasRestElement, elementCount, readonly) {
          if (elementCount === void 0) {
            elementCount = elementTypes.length;
          }
          if (readonly === void 0) {
            readonly = false;
          }
          if (readonly || contextualType && forEachType(contextualType, isTupleLikeType)) {
            return createTupleType(elementTypes, elementCount - (hasRestElement ? 1 : 0), hasRestElement, readonly);
          }
        }
        function isNumericName(name) {
          switch (name.kind) {
            case 154:
              return isNumericComputedName(name);
            case 75:
              return isNumericLiteralName(name.escapedText);
            case 8:
            case 10:
              return isNumericLiteralName(name.text);
            default:
              return false;
          }
        }
        function isNumericComputedName(name) {
          return isTypeAssignableToKind(checkComputedPropertyName(name), 296);
        }
        function isInfinityOrNaNString(name) {
          return name === "Infinity" || name === "-Infinity" || name === "NaN";
        }
        function isNumericLiteralName(name) {
          return (+name).toString() === name;
        }
        function checkComputedPropertyName(node) {
          var links = getNodeLinks(node.expression);
          if (!links.resolvedType) {
            links.resolvedType = checkExpression(node.expression);
            if (links.resolvedType.flags & 98304 || !isTypeAssignableToKind(links.resolvedType, 132 | 296 | 12288) && !isTypeAssignableTo(links.resolvedType, stringNumberSymbolType)) {
              error(node, ts2.Diagnostics.A_computed_property_name_must_be_of_type_string_number_symbol_or_any);
            } else {
              checkThatExpressionIsProperSymbolReference(node.expression, links.resolvedType, true);
            }
          }
          return links.resolvedType;
        }
        function getObjectLiteralIndexInfo(node, offset, properties, kind) {
          var propTypes = [];
          for (var i = 0; i < properties.length; i++) {
            if (kind === 0 || isNumericName(node.properties[i + offset].name)) {
              propTypes.push(getTypeOfSymbol(properties[i]));
            }
          }
          var unionType = propTypes.length ? getUnionType(propTypes, 2) : undefinedType;
          return createIndexInfo(unionType, isConstContext(node));
        }
        function getImmediateAliasedSymbol(symbol) {
          ts2.Debug.assert((symbol.flags & 2097152) !== 0, "Should only get Alias here.");
          var links = getSymbolLinks(symbol);
          if (!links.immediateTarget) {
            var node = getDeclarationOfAliasSymbol(symbol);
            if (!node)
              return ts2.Debug.fail();
            links.immediateTarget = getTargetOfAliasDeclaration(node, true);
          }
          return links.immediateTarget;
        }
        function checkObjectLiteral(node, checkMode) {
          var inDestructuringPattern = ts2.isAssignmentTarget(node);
          checkGrammarObjectLiteralExpression(node, inDestructuringPattern);
          var allPropertiesTable = strictNullChecks ? ts2.createSymbolTable() : void 0;
          var propertiesTable = ts2.createSymbolTable();
          var propertiesArray = [];
          var spread = emptyObjectType;
          var contextualType = getApparentTypeOfContextualType(node);
          var contextualTypeHasPattern = contextualType && contextualType.pattern && (contextualType.pattern.kind === 189 || contextualType.pattern.kind === 193);
          var inConstContext = isConstContext(node);
          var checkFlags = inConstContext ? 8 : 0;
          var isInJavascript = ts2.isInJSFile(node) && !ts2.isInJsonFile(node);
          var enumTag = ts2.getJSDocEnumTag(node);
          var isJSObjectLiteral = !contextualType && isInJavascript && !enumTag;
          var objectFlags = freshObjectLiteralFlag;
          var patternWithComputedProperties = false;
          var hasComputedStringProperty = false;
          var hasComputedNumberProperty = false;
          for (var _i = 0, _a = node.properties; _i < _a.length; _i++) {
            var elem = _a[_i];
            if (elem.name && ts2.isComputedPropertyName(elem.name) && !ts2.isWellKnownSymbolSyntactically(elem.name)) {
              checkComputedPropertyName(elem.name);
            }
          }
          var offset = 0;
          for (var i = 0; i < node.properties.length; i++) {
            var memberDecl = node.properties[i];
            var member = getSymbolOfNode(memberDecl);
            var computedNameType = memberDecl.name && memberDecl.name.kind === 154 && !ts2.isWellKnownSymbolSyntactically(memberDecl.name.expression) ? checkComputedPropertyName(memberDecl.name) : void 0;
            if (memberDecl.kind === 281 || memberDecl.kind === 282 || ts2.isObjectLiteralMethod(memberDecl)) {
              var type = memberDecl.kind === 281 ? checkPropertyAssignment(memberDecl, checkMode) : memberDecl.kind === 282 ? checkExpressionForMutableLocation(memberDecl.name, checkMode) : checkObjectLiteralMethod(memberDecl, checkMode);
              if (isInJavascript) {
                var jsDocType = getTypeForDeclarationFromJSDocComment(memberDecl);
                if (jsDocType) {
                  checkTypeAssignableTo(type, jsDocType, memberDecl);
                  type = jsDocType;
                } else if (enumTag && enumTag.typeExpression) {
                  checkTypeAssignableTo(type, getTypeFromTypeNode(enumTag.typeExpression), memberDecl);
                }
              }
              objectFlags |= ts2.getObjectFlags(type) & 3670016;
              var nameType = computedNameType && isTypeUsableAsPropertyName(computedNameType) ? computedNameType : void 0;
              var prop = nameType ? createSymbol(4 | member.flags, getPropertyNameFromType(nameType), checkFlags | 4096) : createSymbol(4 | member.flags, member.escapedName, checkFlags);
              if (nameType) {
                prop.nameType = nameType;
              }
              if (inDestructuringPattern) {
                var isOptional = memberDecl.kind === 281 && hasDefaultValue(memberDecl.initializer) || memberDecl.kind === 282 && memberDecl.objectAssignmentInitializer;
                if (isOptional) {
                  prop.flags |= 16777216;
                }
              } else if (contextualTypeHasPattern && !(ts2.getObjectFlags(contextualType) & 512)) {
                var impliedProp = getPropertyOfType(contextualType, member.escapedName);
                if (impliedProp) {
                  prop.flags |= impliedProp.flags & 16777216;
                } else if (!compilerOptions.suppressExcessPropertyErrors && !getIndexInfoOfType(contextualType, 0)) {
                  error(memberDecl.name, ts2.Diagnostics.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1, symbolToString(member), typeToString(contextualType));
                }
              }
              prop.declarations = member.declarations;
              prop.parent = member.parent;
              if (member.valueDeclaration) {
                prop.valueDeclaration = member.valueDeclaration;
              }
              prop.type = type;
              prop.target = member;
              member = prop;
              allPropertiesTable === null || allPropertiesTable === void 0 ? void 0 : allPropertiesTable.set(prop.escapedName, prop);
            } else if (memberDecl.kind === 283) {
              if (languageVersion < 2) {
                checkExternalEmitHelpers(memberDecl, 2);
              }
              if (propertiesArray.length > 0) {
                spread = getSpreadType(spread, createObjectLiteralType(), node.symbol, objectFlags, inConstContext);
                propertiesArray = [];
                propertiesTable = ts2.createSymbolTable();
                hasComputedStringProperty = false;
                hasComputedNumberProperty = false;
              }
              var type = getReducedType(checkExpression(memberDecl.expression));
              if (!isValidSpreadType(type)) {
                error(memberDecl, ts2.Diagnostics.Spread_types_may_only_be_created_from_object_types);
                return errorType;
              }
              if (allPropertiesTable) {
                checkSpreadPropOverrides(type, allPropertiesTable, memberDecl);
              }
              spread = getSpreadType(spread, type, node.symbol, objectFlags, inConstContext);
              offset = i + 1;
              continue;
            } else {
              ts2.Debug.assert(memberDecl.kind === 163 || memberDecl.kind === 164);
              checkNodeDeferred(memberDecl);
            }
            if (computedNameType && !(computedNameType.flags & 8576)) {
              if (isTypeAssignableTo(computedNameType, stringNumberSymbolType)) {
                if (isTypeAssignableTo(computedNameType, numberType)) {
                  hasComputedNumberProperty = true;
                } else {
                  hasComputedStringProperty = true;
                }
                if (inDestructuringPattern) {
                  patternWithComputedProperties = true;
                }
              }
            } else {
              propertiesTable.set(member.escapedName, member);
            }
            propertiesArray.push(member);
          }
          if (contextualTypeHasPattern && node.parent.kind !== 283) {
            for (var _b = 0, _c = getPropertiesOfType(contextualType); _b < _c.length; _b++) {
              var prop = _c[_b];
              if (!propertiesTable.get(prop.escapedName) && !getPropertyOfType(spread, prop.escapedName)) {
                if (!(prop.flags & 16777216)) {
                  error(prop.valueDeclaration || prop.bindingElement, ts2.Diagnostics.Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value);
                }
                propertiesTable.set(prop.escapedName, prop);
                propertiesArray.push(prop);
              }
            }
          }
          if (spread !== emptyObjectType) {
            if (propertiesArray.length > 0) {
              spread = getSpreadType(spread, createObjectLiteralType(), node.symbol, objectFlags, inConstContext);
              propertiesArray = [];
              propertiesTable = ts2.createSymbolTable();
              hasComputedStringProperty = false;
              hasComputedNumberProperty = false;
            }
            return mapType(spread, function(t) {
              return t === emptyObjectType ? createObjectLiteralType() : t;
            });
          }
          return createObjectLiteralType();
          function createObjectLiteralType() {
            var stringIndexInfo = hasComputedStringProperty ? getObjectLiteralIndexInfo(node, offset, propertiesArray, 0) : void 0;
            var numberIndexInfo = hasComputedNumberProperty ? getObjectLiteralIndexInfo(node, offset, propertiesArray, 1) : void 0;
            var result = createAnonymousType(node.symbol, propertiesTable, ts2.emptyArray, ts2.emptyArray, stringIndexInfo, numberIndexInfo);
            result.objectFlags |= objectFlags | 128 | 1048576;
            if (isJSObjectLiteral) {
              result.objectFlags |= 16384;
            }
            if (patternWithComputedProperties) {
              result.objectFlags |= 512;
            }
            if (inDestructuringPattern) {
              result.pattern = node;
            }
            return result;
          }
        }
        function isValidSpreadType(type) {
          if (type.flags & 63176704) {
            var constraint = getBaseConstraintOfType(type);
            if (constraint !== void 0) {
              return isValidSpreadType(constraint);
            }
          }
          return !!(type.flags & (1 | 67108864 | 524288 | 58982400) || getFalsyFlags(type) & 117632 && isValidSpreadType(removeDefinitelyFalsyTypes(type)) || type.flags & 3145728 && ts2.every(type.types, isValidSpreadType));
        }
        function checkJsxSelfClosingElementDeferred(node) {
          checkJsxOpeningLikeElementOrOpeningFragment(node);
          resolveUntypedCall(node);
        }
        function checkJsxSelfClosingElement(node, _checkMode) {
          checkNodeDeferred(node);
          return getJsxElementTypeAt(node) || anyType;
        }
        function checkJsxElementDeferred(node) {
          checkJsxOpeningLikeElementOrOpeningFragment(node.openingElement);
          if (isJsxIntrinsicIdentifier(node.closingElement.tagName)) {
            getIntrinsicTagSymbol(node.closingElement);
          } else {
            checkExpression(node.closingElement.tagName);
          }
          checkJsxChildren(node);
        }
        function checkJsxElement(node, _checkMode) {
          checkNodeDeferred(node);
          return getJsxElementTypeAt(node) || anyType;
        }
        function checkJsxFragment(node) {
          checkJsxOpeningLikeElementOrOpeningFragment(node.openingFragment);
          if (compilerOptions.jsx === 2 && (compilerOptions.jsxFactory || ts2.getSourceFileOfNode(node).pragmas.has("jsx"))) {
            error(node, compilerOptions.jsxFactory ? ts2.Diagnostics.JSX_fragment_is_not_supported_when_using_jsxFactory : ts2.Diagnostics.JSX_fragment_is_not_supported_when_using_an_inline_JSX_factory_pragma);
          }
          checkJsxChildren(node);
          return getJsxElementTypeAt(node) || anyType;
        }
        function isUnhyphenatedJsxName(name) {
          return !ts2.stringContains(name, "-");
        }
        function isJsxIntrinsicIdentifier(tagName) {
          return tagName.kind === 75 && ts2.isIntrinsicJsxName(tagName.escapedText);
        }
        function checkJsxAttribute(node, checkMode) {
          return node.initializer ? checkExpressionForMutableLocation(node.initializer, checkMode) : trueType;
        }
        function createJsxAttributesTypeFromAttributesProperty(openingLikeElement, checkMode) {
          var attributes = openingLikeElement.attributes;
          var allAttributesTable = strictNullChecks ? ts2.createSymbolTable() : void 0;
          var attributesTable = ts2.createSymbolTable();
          var spread = emptyJsxObjectType;
          var hasSpreadAnyType = false;
          var typeToIntersect;
          var explicitlySpecifyChildrenAttribute = false;
          var objectFlags = 4096;
          var jsxChildrenPropertyName = getJsxElementChildrenPropertyName(getJsxNamespaceAt(openingLikeElement));
          for (var _i = 0, _a = attributes.properties; _i < _a.length; _i++) {
            var attributeDecl = _a[_i];
            var member = attributeDecl.symbol;
            if (ts2.isJsxAttribute(attributeDecl)) {
              var exprType = checkJsxAttribute(attributeDecl, checkMode);
              objectFlags |= ts2.getObjectFlags(exprType) & 3670016;
              var attributeSymbol = createSymbol(4 | 33554432 | member.flags, member.escapedName);
              attributeSymbol.declarations = member.declarations;
              attributeSymbol.parent = member.parent;
              if (member.valueDeclaration) {
                attributeSymbol.valueDeclaration = member.valueDeclaration;
              }
              attributeSymbol.type = exprType;
              attributeSymbol.target = member;
              attributesTable.set(attributeSymbol.escapedName, attributeSymbol);
              allAttributesTable === null || allAttributesTable === void 0 ? void 0 : allAttributesTable.set(attributeSymbol.escapedName, attributeSymbol);
              if (attributeDecl.name.escapedText === jsxChildrenPropertyName) {
                explicitlySpecifyChildrenAttribute = true;
              }
            } else {
              ts2.Debug.assert(attributeDecl.kind === 275);
              if (attributesTable.size > 0) {
                spread = getSpreadType(spread, createJsxAttributesType(), attributes.symbol, objectFlags, false);
                attributesTable = ts2.createSymbolTable();
              }
              var exprType = getReducedType(checkExpressionCached(attributeDecl.expression, checkMode));
              if (isTypeAny(exprType)) {
                hasSpreadAnyType = true;
              }
              if (isValidSpreadType(exprType)) {
                spread = getSpreadType(spread, exprType, attributes.symbol, objectFlags, false);
                if (allAttributesTable) {
                  checkSpreadPropOverrides(exprType, allAttributesTable, attributeDecl);
                }
              } else {
                typeToIntersect = typeToIntersect ? getIntersectionType([typeToIntersect, exprType]) : exprType;
              }
            }
          }
          if (!hasSpreadAnyType) {
            if (attributesTable.size > 0) {
              spread = getSpreadType(spread, createJsxAttributesType(), attributes.symbol, objectFlags, false);
            }
          }
          var parent = openingLikeElement.parent.kind === 266 ? openingLikeElement.parent : void 0;
          if (parent && parent.openingElement === openingLikeElement && parent.children.length > 0) {
            var childrenTypes = checkJsxChildren(parent, checkMode);
            if (!hasSpreadAnyType && jsxChildrenPropertyName && jsxChildrenPropertyName !== "") {
              if (explicitlySpecifyChildrenAttribute) {
                error(attributes, ts2.Diagnostics._0_are_specified_twice_The_attribute_named_0_will_be_overwritten, ts2.unescapeLeadingUnderscores(jsxChildrenPropertyName));
              }
              var contextualType = getApparentTypeOfContextualType(openingLikeElement.attributes);
              var childrenContextualType = contextualType && getTypeOfPropertyOfContextualType(contextualType, jsxChildrenPropertyName);
              var childrenPropSymbol = createSymbol(4 | 33554432, jsxChildrenPropertyName);
              childrenPropSymbol.type = childrenTypes.length === 1 ? childrenTypes[0] : getArrayLiteralTupleTypeIfApplicable(childrenTypes, childrenContextualType, false) || createArrayType(getUnionType(childrenTypes));
              childrenPropSymbol.valueDeclaration = ts2.createPropertySignature(void 0, ts2.unescapeLeadingUnderscores(jsxChildrenPropertyName), void 0, void 0, void 0);
              childrenPropSymbol.valueDeclaration.parent = attributes;
              childrenPropSymbol.valueDeclaration.symbol = childrenPropSymbol;
              var childPropMap = ts2.createSymbolTable();
              childPropMap.set(jsxChildrenPropertyName, childrenPropSymbol);
              spread = getSpreadType(spread, createAnonymousType(attributes.symbol, childPropMap, ts2.emptyArray, ts2.emptyArray, void 0, void 0), attributes.symbol, objectFlags, false);
            }
          }
          if (hasSpreadAnyType) {
            return anyType;
          }
          if (typeToIntersect && spread !== emptyJsxObjectType) {
            return getIntersectionType([typeToIntersect, spread]);
          }
          return typeToIntersect || (spread === emptyJsxObjectType ? createJsxAttributesType() : spread);
          function createJsxAttributesType() {
            objectFlags |= freshObjectLiteralFlag;
            var result = createAnonymousType(attributes.symbol, attributesTable, ts2.emptyArray, ts2.emptyArray, void 0, void 0);
            result.objectFlags |= objectFlags | 128 | 1048576;
            return result;
          }
        }
        function checkJsxChildren(node, checkMode) {
          var childrenTypes = [];
          for (var _i = 0, _a = node.children; _i < _a.length; _i++) {
            var child = _a[_i];
            if (child.kind === 11) {
              if (!child.containsOnlyTriviaWhiteSpaces) {
                childrenTypes.push(stringType);
              }
            } else {
              childrenTypes.push(checkExpressionForMutableLocation(child, checkMode));
            }
          }
          return childrenTypes;
        }
        function checkSpreadPropOverrides(type, props, spread) {
          for (var _i = 0, _a = getPropertiesOfType(type); _i < _a.length; _i++) {
            var right = _a[_i];
            var left = props.get(right.escapedName);
            var rightType = getTypeOfSymbol(right);
            if (left && !maybeTypeOfKind(rightType, 98304) && !(maybeTypeOfKind(rightType, 3) && right.flags & 16777216)) {
              var diagnostic = error(left.valueDeclaration, ts2.Diagnostics._0_is_specified_more_than_once_so_this_usage_will_be_overwritten, ts2.unescapeLeadingUnderscores(left.escapedName));
              ts2.addRelatedInfo(diagnostic, ts2.createDiagnosticForNode(spread, ts2.Diagnostics.This_spread_always_overwrites_this_property));
            }
          }
        }
        function checkJsxAttributes(node, checkMode) {
          return createJsxAttributesTypeFromAttributesProperty(node.parent, checkMode);
        }
        function getJsxType(name, location) {
          var namespace = getJsxNamespaceAt(location);
          var exports2 = namespace && getExportsOfSymbol(namespace);
          var typeSymbol = exports2 && getSymbol(exports2, name, 788968);
          return typeSymbol ? getDeclaredTypeOfSymbol(typeSymbol) : errorType;
        }
        function getIntrinsicTagSymbol(node) {
          var links = getNodeLinks(node);
          if (!links.resolvedSymbol) {
            var intrinsicElementsType = getJsxType(JsxNames.IntrinsicElements, node);
            if (intrinsicElementsType !== errorType) {
              if (!ts2.isIdentifier(node.tagName))
                return ts2.Debug.fail();
              var intrinsicProp = getPropertyOfType(intrinsicElementsType, node.tagName.escapedText);
              if (intrinsicProp) {
                links.jsxFlags |= 1;
                return links.resolvedSymbol = intrinsicProp;
              }
              var indexSignatureType = getIndexTypeOfType(intrinsicElementsType, 0);
              if (indexSignatureType) {
                links.jsxFlags |= 2;
                return links.resolvedSymbol = intrinsicElementsType.symbol;
              }
              error(node, ts2.Diagnostics.Property_0_does_not_exist_on_type_1, ts2.idText(node.tagName), "JSX." + JsxNames.IntrinsicElements);
              return links.resolvedSymbol = unknownSymbol;
            } else {
              if (noImplicitAny) {
                error(node, ts2.Diagnostics.JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists, ts2.unescapeLeadingUnderscores(JsxNames.IntrinsicElements));
              }
              return links.resolvedSymbol = unknownSymbol;
            }
          }
          return links.resolvedSymbol;
        }
        function getJsxNamespaceAt(location) {
          var links = location && getNodeLinks(location);
          if (links && links.jsxNamespace) {
            return links.jsxNamespace;
          }
          if (!links || links.jsxNamespace !== false) {
            var namespaceName = getJsxNamespace(location);
            var resolvedNamespace = resolveName(location, namespaceName, 1920, void 0, namespaceName, false);
            if (resolvedNamespace) {
              var candidate = resolveSymbol(getSymbol(getExportsOfSymbol(resolveSymbol(resolvedNamespace)), JsxNames.JSX, 1920));
              if (candidate) {
                if (links) {
                  links.jsxNamespace = candidate;
                }
                return candidate;
              }
              if (links) {
                links.jsxNamespace = false;
              }
            }
          }
          return getGlobalSymbol(JsxNames.JSX, 1920, void 0);
        }
        function getNameFromJsxElementAttributesContainer(nameOfAttribPropContainer, jsxNamespace) {
          var jsxElementAttribPropInterfaceSym = jsxNamespace && getSymbol(jsxNamespace.exports, nameOfAttribPropContainer, 788968);
          var jsxElementAttribPropInterfaceType = jsxElementAttribPropInterfaceSym && getDeclaredTypeOfSymbol(jsxElementAttribPropInterfaceSym);
          var propertiesOfJsxElementAttribPropInterface = jsxElementAttribPropInterfaceType && getPropertiesOfType(jsxElementAttribPropInterfaceType);
          if (propertiesOfJsxElementAttribPropInterface) {
            if (propertiesOfJsxElementAttribPropInterface.length === 0) {
              return "";
            } else if (propertiesOfJsxElementAttribPropInterface.length === 1) {
              return propertiesOfJsxElementAttribPropInterface[0].escapedName;
            } else if (propertiesOfJsxElementAttribPropInterface.length > 1) {
              error(jsxElementAttribPropInterfaceSym.declarations[0], ts2.Diagnostics.The_global_type_JSX_0_may_not_have_more_than_one_property, ts2.unescapeLeadingUnderscores(nameOfAttribPropContainer));
            }
          }
          return void 0;
        }
        function getJsxLibraryManagedAttributes(jsxNamespace) {
          return jsxNamespace && getSymbol(jsxNamespace.exports, JsxNames.LibraryManagedAttributes, 788968);
        }
        function getJsxElementPropertiesName(jsxNamespace) {
          return getNameFromJsxElementAttributesContainer(JsxNames.ElementAttributesPropertyNameContainer, jsxNamespace);
        }
        function getJsxElementChildrenPropertyName(jsxNamespace) {
          return getNameFromJsxElementAttributesContainer(JsxNames.ElementChildrenAttributeNameContainer, jsxNamespace);
        }
        function getUninstantiatedJsxSignaturesOfType(elementType, caller) {
          if (elementType.flags & 4) {
            return [anySignature];
          } else if (elementType.flags & 128) {
            var intrinsicType = getIntrinsicAttributesTypeFromStringLiteralType(elementType, caller);
            if (!intrinsicType) {
              error(caller, ts2.Diagnostics.Property_0_does_not_exist_on_type_1, elementType.value, "JSX." + JsxNames.IntrinsicElements);
              return ts2.emptyArray;
            } else {
              var fakeSignature = createSignatureForJSXIntrinsic(caller, intrinsicType);
              return [fakeSignature];
            }
          }
          var apparentElemType = getApparentType(elementType);
          var signatures = getSignaturesOfType(apparentElemType, 1);
          if (signatures.length === 0) {
            signatures = getSignaturesOfType(apparentElemType, 0);
          }
          if (signatures.length === 0 && apparentElemType.flags & 1048576) {
            signatures = getUnionSignatures(ts2.map(apparentElemType.types, function(t) {
              return getUninstantiatedJsxSignaturesOfType(t, caller);
            }));
          }
          return signatures;
        }
        function getIntrinsicAttributesTypeFromStringLiteralType(type, location) {
          var intrinsicElementsType = getJsxType(JsxNames.IntrinsicElements, location);
          if (intrinsicElementsType !== errorType) {
            var stringLiteralTypeName = type.value;
            var intrinsicProp = getPropertyOfType(intrinsicElementsType, ts2.escapeLeadingUnderscores(stringLiteralTypeName));
            if (intrinsicProp) {
              return getTypeOfSymbol(intrinsicProp);
            }
            var indexSignatureType = getIndexTypeOfType(intrinsicElementsType, 0);
            if (indexSignatureType) {
              return indexSignatureType;
            }
            return void 0;
          }
          return anyType;
        }
        function checkJsxReturnAssignableToAppropriateBound(refKind, elemInstanceType, openingLikeElement) {
          if (refKind === 1) {
            var sfcReturnConstraint = getJsxStatelessElementTypeAt(openingLikeElement);
            if (sfcReturnConstraint) {
              checkTypeRelatedTo(elemInstanceType, sfcReturnConstraint, assignableRelation, openingLikeElement.tagName, ts2.Diagnostics.Its_return_type_0_is_not_a_valid_JSX_element, generateInitialErrorChain);
            }
          } else if (refKind === 0) {
            var classConstraint = getJsxElementClassTypeAt(openingLikeElement);
            if (classConstraint) {
              checkTypeRelatedTo(elemInstanceType, classConstraint, assignableRelation, openingLikeElement.tagName, ts2.Diagnostics.Its_instance_type_0_is_not_a_valid_JSX_element, generateInitialErrorChain);
            }
          } else {
            var sfcReturnConstraint = getJsxStatelessElementTypeAt(openingLikeElement);
            var classConstraint = getJsxElementClassTypeAt(openingLikeElement);
            if (!sfcReturnConstraint || !classConstraint) {
              return;
            }
            var combined = getUnionType([sfcReturnConstraint, classConstraint]);
            checkTypeRelatedTo(elemInstanceType, combined, assignableRelation, openingLikeElement.tagName, ts2.Diagnostics.Its_element_type_0_is_not_a_valid_JSX_element, generateInitialErrorChain);
          }
          function generateInitialErrorChain() {
            var componentName = ts2.getTextOfNode(openingLikeElement.tagName);
            return ts2.chainDiagnosticMessages(void 0, ts2.Diagnostics._0_cannot_be_used_as_a_JSX_component, componentName);
          }
        }
        function getIntrinsicAttributesTypeFromJsxOpeningLikeElement(node) {
          ts2.Debug.assert(isJsxIntrinsicIdentifier(node.tagName));
          var links = getNodeLinks(node);
          if (!links.resolvedJsxElementAttributesType) {
            var symbol = getIntrinsicTagSymbol(node);
            if (links.jsxFlags & 1) {
              return links.resolvedJsxElementAttributesType = getTypeOfSymbol(symbol);
            } else if (links.jsxFlags & 2) {
              return links.resolvedJsxElementAttributesType = getIndexTypeOfType(getDeclaredTypeOfSymbol(symbol), 0);
            } else {
              return links.resolvedJsxElementAttributesType = errorType;
            }
          }
          return links.resolvedJsxElementAttributesType;
        }
        function getJsxElementClassTypeAt(location) {
          var type = getJsxType(JsxNames.ElementClass, location);
          if (type === errorType)
            return void 0;
          return type;
        }
        function getJsxElementTypeAt(location) {
          return getJsxType(JsxNames.Element, location);
        }
        function getJsxStatelessElementTypeAt(location) {
          var jsxElementType = getJsxElementTypeAt(location);
          if (jsxElementType) {
            return getUnionType([jsxElementType, nullType]);
          }
        }
        function getJsxIntrinsicTagNamesAt(location) {
          var intrinsics = getJsxType(JsxNames.IntrinsicElements, location);
          return intrinsics ? getPropertiesOfType(intrinsics) : ts2.emptyArray;
        }
        function checkJsxPreconditions(errorNode) {
          if ((compilerOptions.jsx || 0) === 0) {
            error(errorNode, ts2.Diagnostics.Cannot_use_JSX_unless_the_jsx_flag_is_provided);
          }
          if (getJsxElementTypeAt(errorNode) === void 0) {
            if (noImplicitAny) {
              error(errorNode, ts2.Diagnostics.JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist);
            }
          }
        }
        function checkJsxOpeningLikeElementOrOpeningFragment(node) {
          var isNodeOpeningLikeElement = ts2.isJsxOpeningLikeElement(node);
          if (isNodeOpeningLikeElement) {
            checkGrammarJsxElement(node);
          }
          checkJsxPreconditions(node);
          var reactRefErr = diagnostics && compilerOptions.jsx === 2 ? ts2.Diagnostics.Cannot_find_name_0 : void 0;
          var reactNamespace = getJsxNamespace(node);
          var reactLocation = isNodeOpeningLikeElement ? node.tagName : node;
          var reactSym = resolveName(reactLocation, reactNamespace, 111551, reactRefErr, reactNamespace, true);
          if (reactSym) {
            reactSym.isReferenced = 67108863;
            if (reactSym.flags & 2097152 && !getTypeOnlyAliasDeclaration(reactSym)) {
              markAliasSymbolAsReferenced(reactSym);
            }
          }
          if (isNodeOpeningLikeElement) {
            var jsxOpeningLikeNode = node;
            var sig = getResolvedSignature(jsxOpeningLikeNode);
            checkJsxReturnAssignableToAppropriateBound(getJsxReferenceKind(jsxOpeningLikeNode), getReturnTypeOfSignature(sig), jsxOpeningLikeNode);
          }
        }
        function isKnownProperty(targetType, name, isComparingJsxAttributes) {
          if (targetType.flags & 524288) {
            var resolved = resolveStructuredTypeMembers(targetType);
            if (resolved.stringIndexInfo || resolved.numberIndexInfo && isNumericLiteralName(name) || getPropertyOfObjectType(targetType, name) || isComparingJsxAttributes && !isUnhyphenatedJsxName(name)) {
              return true;
            }
          } else if (targetType.flags & 3145728 && isExcessPropertyCheckTarget(targetType)) {
            for (var _i = 0, _a = targetType.types; _i < _a.length; _i++) {
              var t = _a[_i];
              if (isKnownProperty(t, name, isComparingJsxAttributes)) {
                return true;
              }
            }
          }
          return false;
        }
        function isExcessPropertyCheckTarget(type) {
          return !!(type.flags & 524288 && !(ts2.getObjectFlags(type) & 512) || type.flags & 67108864 || type.flags & 1048576 && ts2.some(type.types, isExcessPropertyCheckTarget) || type.flags & 2097152 && ts2.every(type.types, isExcessPropertyCheckTarget));
        }
        function checkJsxExpression(node, checkMode) {
          checkGrammarJsxExpression(node);
          if (node.expression) {
            var type = checkExpression(node.expression, checkMode);
            if (node.dotDotDotToken && type !== anyType && !isArrayType(type)) {
              error(node, ts2.Diagnostics.JSX_spread_child_must_be_an_array_type);
            }
            return type;
          } else {
            return errorType;
          }
        }
        function getDeclarationNodeFlagsFromSymbol(s) {
          return s.valueDeclaration ? ts2.getCombinedNodeFlags(s.valueDeclaration) : 0;
        }
        function isPrototypeProperty(symbol) {
          if (symbol.flags & 8192 || ts2.getCheckFlags(symbol) & 4) {
            return true;
          }
          if (ts2.isInJSFile(symbol.valueDeclaration)) {
            var parent = symbol.valueDeclaration.parent;
            return parent && ts2.isBinaryExpression(parent) && ts2.getAssignmentDeclarationKind(parent) === 3;
          }
        }
        function checkPropertyAccessibility(node, isSuper, type, prop) {
          var flags = ts2.getDeclarationModifierFlagsFromSymbol(prop);
          var errorNode = node.kind === 153 ? node.right : node.kind === 188 ? node : node.name;
          if (isSuper) {
            if (languageVersion < 2) {
              if (symbolHasNonMethodDeclaration(prop)) {
                error(errorNode, ts2.Diagnostics.Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword);
                return false;
              }
            }
            if (flags & 128) {
              error(errorNode, ts2.Diagnostics.Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression, symbolToString(prop), typeToString(getDeclaringClass(prop)));
              return false;
            }
          }
          if (flags & 128 && ts2.isThisProperty(node) && symbolHasNonMethodDeclaration(prop)) {
            var declaringClassDeclaration = ts2.getClassLikeDeclarationOfSymbol(getParentOfSymbol(prop));
            if (declaringClassDeclaration && isNodeUsedDuringClassInitialization(node)) {
              error(errorNode, ts2.Diagnostics.Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor, symbolToString(prop), ts2.getTextOfIdentifierOrLiteral(declaringClassDeclaration.name));
              return false;
            }
          }
          if (ts2.isPropertyAccessExpression(node) && ts2.isPrivateIdentifier(node.name)) {
            if (!ts2.getContainingClass(node)) {
              error(errorNode, ts2.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
              return false;
            }
            return true;
          }
          if (!(flags & 24)) {
            return true;
          }
          if (flags & 8) {
            var declaringClassDeclaration = ts2.getClassLikeDeclarationOfSymbol(getParentOfSymbol(prop));
            if (!isNodeWithinClass(node, declaringClassDeclaration)) {
              error(errorNode, ts2.Diagnostics.Property_0_is_private_and_only_accessible_within_class_1, symbolToString(prop), typeToString(getDeclaringClass(prop)));
              return false;
            }
            return true;
          }
          if (isSuper) {
            return true;
          }
          var enclosingClass = forEachEnclosingClass(node, function(enclosingDeclaration) {
            var enclosingClass2 = getDeclaredTypeOfSymbol(getSymbolOfNode(enclosingDeclaration));
            return isClassDerivedFromDeclaringClasses(enclosingClass2, prop) ? enclosingClass2 : void 0;
          });
          if (!enclosingClass) {
            var thisParameter = void 0;
            if (flags & 32 || !(thisParameter = getThisParameterFromNodeContext(node)) || !thisParameter.type) {
              error(errorNode, ts2.Diagnostics.Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses, symbolToString(prop), typeToString(getDeclaringClass(prop) || type));
              return false;
            }
            var thisType = getTypeFromTypeNode(thisParameter.type);
            enclosingClass = (thisType.flags & 262144 ? getConstraintOfTypeParameter(thisType) : thisType).target;
          }
          if (flags & 32) {
            return true;
          }
          if (type.flags & 262144) {
            type = type.isThisType ? getConstraintOfTypeParameter(type) : getBaseConstraintOfType(type);
          }
          if (!type || !hasBaseType(type, enclosingClass)) {
            error(errorNode, ts2.Diagnostics.Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1, symbolToString(prop), typeToString(enclosingClass));
            return false;
          }
          return true;
        }
        function getThisParameterFromNodeContext(node) {
          var thisContainer = ts2.getThisContainer(node, false);
          return thisContainer && ts2.isFunctionLike(thisContainer) ? ts2.getThisParameter(thisContainer) : void 0;
        }
        function symbolHasNonMethodDeclaration(symbol) {
          return !!forEachProperty(symbol, function(prop) {
            return !(prop.flags & 8192);
          });
        }
        function checkNonNullExpression(node) {
          return checkNonNullType(checkExpression(node), node);
        }
        function isNullableType(type) {
          return !!((strictNullChecks ? getFalsyFlags(type) : type.flags) & 98304);
        }
        function getNonNullableTypeIfNeeded(type) {
          return isNullableType(type) ? getNonNullableType(type) : type;
        }
        function reportObjectPossiblyNullOrUndefinedError(node, flags) {
          error(node, flags & 32768 ? flags & 65536 ? ts2.Diagnostics.Object_is_possibly_null_or_undefined : ts2.Diagnostics.Object_is_possibly_undefined : ts2.Diagnostics.Object_is_possibly_null);
        }
        function reportCannotInvokePossiblyNullOrUndefinedError(node, flags) {
          error(node, flags & 32768 ? flags & 65536 ? ts2.Diagnostics.Cannot_invoke_an_object_which_is_possibly_null_or_undefined : ts2.Diagnostics.Cannot_invoke_an_object_which_is_possibly_undefined : ts2.Diagnostics.Cannot_invoke_an_object_which_is_possibly_null);
        }
        function checkNonNullTypeWithReporter(type, node, reportError) {
          if (strictNullChecks && type.flags & 2) {
            error(node, ts2.Diagnostics.Object_is_of_type_unknown);
            return errorType;
          }
          var kind = (strictNullChecks ? getFalsyFlags(type) : type.flags) & 98304;
          if (kind) {
            reportError(node, kind);
            var t = getNonNullableType(type);
            return t.flags & (98304 | 131072) ? errorType : t;
          }
          return type;
        }
        function checkNonNullType(type, node) {
          return checkNonNullTypeWithReporter(type, node, reportObjectPossiblyNullOrUndefinedError);
        }
        function checkNonNullNonVoidType(type, node) {
          var nonNullType = checkNonNullType(type, node);
          if (nonNullType !== errorType && nonNullType.flags & 16384) {
            error(node, ts2.Diagnostics.Object_is_possibly_undefined);
          }
          return nonNullType;
        }
        function checkPropertyAccessExpression(node) {
          return node.flags & 32 ? checkPropertyAccessChain(node) : checkPropertyAccessExpressionOrQualifiedName(node, node.expression, checkNonNullExpression(node.expression), node.name);
        }
        function checkPropertyAccessChain(node) {
          var leftType = checkExpression(node.expression);
          var nonOptionalType = getOptionalExpressionType(leftType, node.expression);
          return propagateOptionalTypeMarker(checkPropertyAccessExpressionOrQualifiedName(node, node.expression, checkNonNullType(nonOptionalType, node.expression), node.name), node, nonOptionalType !== leftType);
        }
        function checkQualifiedName(node) {
          return checkPropertyAccessExpressionOrQualifiedName(node, node.left, checkNonNullExpression(node.left), node.right);
        }
        function isMethodAccessForCall(node) {
          while (node.parent.kind === 200) {
            node = node.parent;
          }
          return ts2.isCallOrNewExpression(node.parent) && node.parent.expression === node;
        }
        function lookupSymbolForPrivateIdentifierDeclaration(propName, location) {
          for (var containingClass = ts2.getContainingClass(location); !!containingClass; containingClass = ts2.getContainingClass(containingClass)) {
            var symbol = containingClass.symbol;
            var name = ts2.getSymbolNameForPrivateIdentifier(symbol, propName);
            var prop = symbol.members && symbol.members.get(name) || symbol.exports && symbol.exports.get(name);
            if (prop) {
              return prop;
            }
          }
        }
        function getPrivateIdentifierPropertyOfType(leftType, lexicallyScopedIdentifier) {
          return getPropertyOfType(leftType, lexicallyScopedIdentifier.escapedName);
        }
        function checkPrivateIdentifierPropertyAccess(leftType, right, lexicallyScopedIdentifier) {
          var propertyOnType;
          var properties = getPropertiesOfType(leftType);
          if (properties) {
            ts2.forEach(properties, function(symbol) {
              var decl = symbol.valueDeclaration;
              if (decl && ts2.isNamedDeclaration(decl) && ts2.isPrivateIdentifier(decl.name) && decl.name.escapedText === right.escapedText) {
                propertyOnType = symbol;
                return true;
              }
            });
          }
          var diagName = diagnosticName(right);
          if (propertyOnType) {
            var typeValueDecl = propertyOnType.valueDeclaration;
            var typeClass_1 = ts2.getContainingClass(typeValueDecl);
            ts2.Debug.assert(!!typeClass_1);
            if (lexicallyScopedIdentifier) {
              var lexicalValueDecl = lexicallyScopedIdentifier.valueDeclaration;
              var lexicalClass = ts2.getContainingClass(lexicalValueDecl);
              ts2.Debug.assert(!!lexicalClass);
              if (ts2.findAncestor(lexicalClass, function(n) {
                return typeClass_1 === n;
              })) {
                var diagnostic = error(right, ts2.Diagnostics.The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_private_identifier_with_the_same_spelling, diagName, typeToString(leftType));
                ts2.addRelatedInfo(diagnostic, ts2.createDiagnosticForNode(lexicalValueDecl, ts2.Diagnostics.The_shadowing_declaration_of_0_is_defined_here, diagName), ts2.createDiagnosticForNode(typeValueDecl, ts2.Diagnostics.The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here, diagName));
                return true;
              }
            }
            error(right, ts2.Diagnostics.Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier, diagName, diagnosticName(typeClass_1.name || anon));
            return true;
          }
          return false;
        }
        function checkPropertyAccessExpressionOrQualifiedName(node, left, leftType, right) {
          var parentSymbol = getNodeLinks(left).resolvedSymbol;
          var assignmentKind = ts2.getAssignmentTargetKind(node);
          var apparentType = getApparentType(assignmentKind !== 0 || isMethodAccessForCall(node) ? getWidenedType(leftType) : leftType);
          if (ts2.isPrivateIdentifier(right)) {
            checkExternalEmitHelpers(node, 262144);
          }
          var isAnyLike = isTypeAny(apparentType) || apparentType === silentNeverType;
          var prop;
          if (ts2.isPrivateIdentifier(right)) {
            var lexicallyScopedSymbol = lookupSymbolForPrivateIdentifierDeclaration(right.escapedText, right);
            if (isAnyLike) {
              if (lexicallyScopedSymbol) {
                return apparentType;
              }
              if (!ts2.getContainingClass(right)) {
                grammarErrorOnNode(right, ts2.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
                return anyType;
              }
            }
            prop = lexicallyScopedSymbol ? getPrivateIdentifierPropertyOfType(leftType, lexicallyScopedSymbol) : void 0;
            if (!prop && checkPrivateIdentifierPropertyAccess(leftType, right, lexicallyScopedSymbol)) {
              return errorType;
            }
          } else {
            if (isAnyLike) {
              if (ts2.isIdentifier(left) && parentSymbol) {
                markAliasReferenced(parentSymbol, node);
              }
              return apparentType;
            }
            prop = getPropertyOfType(apparentType, right.escapedText);
          }
          if (ts2.isIdentifier(left) && parentSymbol && !(prop && isConstEnumOrConstEnumOnlyModule(prop))) {
            markAliasReferenced(parentSymbol, node);
          }
          var propType;
          if (!prop) {
            var indexInfo = !ts2.isPrivateIdentifier(right) && (assignmentKind === 0 || !isGenericObjectType(leftType) || isThisTypeParameter(leftType)) ? getIndexInfoOfType(apparentType, 0) : void 0;
            if (!(indexInfo && indexInfo.type)) {
              if (isJSLiteralType(leftType)) {
                return anyType;
              }
              if (leftType.symbol === globalThisSymbol) {
                if (globalThisSymbol.exports.has(right.escapedText) && globalThisSymbol.exports.get(right.escapedText).flags & 418) {
                  error(right, ts2.Diagnostics.Property_0_does_not_exist_on_type_1, ts2.unescapeLeadingUnderscores(right.escapedText), typeToString(leftType));
                } else if (noImplicitAny) {
                  error(right, ts2.Diagnostics.Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature, typeToString(leftType));
                }
                return anyType;
              }
              if (right.escapedText && !checkAndReportErrorForExtendingInterface(node)) {
                reportNonexistentProperty(right, isThisTypeParameter(leftType) ? apparentType : leftType);
              }
              return errorType;
            }
            if (indexInfo.isReadonly && (ts2.isAssignmentTarget(node) || ts2.isDeleteTarget(node))) {
              error(node, ts2.Diagnostics.Index_signature_in_type_0_only_permits_reading, typeToString(apparentType));
            }
            propType = indexInfo.type;
          } else {
            checkPropertyNotUsedBeforeDeclaration(prop, node, right);
            markPropertyAsReferenced(prop, node, left.kind === 104);
            getNodeLinks(node).resolvedSymbol = prop;
            checkPropertyAccessibility(node, left.kind === 102, apparentType, prop);
            if (isAssignmentToReadonlyEntity(node, prop, assignmentKind)) {
              error(right, ts2.Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property, ts2.idText(right));
              return errorType;
            }
            propType = getConstraintForLocation(getTypeOfSymbol(prop), node);
          }
          return getFlowTypeOfAccessExpression(node, prop, propType, right);
        }
        function getFlowTypeOfAccessExpression(node, prop, propType, errorNode) {
          var assignmentKind = ts2.getAssignmentTargetKind(node);
          if (!ts2.isAccessExpression(node) || assignmentKind === 1 || prop && !(prop.flags & (3 | 4 | 98304)) && !(prop.flags & 8192 && propType.flags & 1048576)) {
            return propType;
          }
          var assumeUninitialized = false;
          if (strictNullChecks && strictPropertyInitialization && node.expression.kind === 104) {
            var declaration = prop && prop.valueDeclaration;
            if (declaration && isInstancePropertyWithoutInitializer(declaration)) {
              var flowContainer = getControlFlowContainer(node);
              if (flowContainer.kind === 162 && flowContainer.parent === declaration.parent && !(declaration.flags & 8388608)) {
                assumeUninitialized = true;
              }
            }
          } else if (strictNullChecks && prop && prop.valueDeclaration && ts2.isPropertyAccessExpression(prop.valueDeclaration) && ts2.getAssignmentDeclarationPropertyAccessKind(prop.valueDeclaration) && getControlFlowContainer(node) === getControlFlowContainer(prop.valueDeclaration)) {
            assumeUninitialized = true;
          }
          var flowType = getFlowTypeOfReference(node, propType, assumeUninitialized ? getOptionalType(propType) : propType);
          if (assumeUninitialized && !(getFalsyFlags(propType) & 32768) && getFalsyFlags(flowType) & 32768) {
            error(errorNode, ts2.Diagnostics.Property_0_is_used_before_being_assigned, symbolToString(prop));
            return propType;
          }
          return assignmentKind ? getBaseTypeOfLiteralType(flowType) : flowType;
        }
        function checkPropertyNotUsedBeforeDeclaration(prop, node, right) {
          var valueDeclaration = prop.valueDeclaration;
          if (!valueDeclaration || ts2.getSourceFileOfNode(node).isDeclarationFile) {
            return;
          }
          var diagnosticMessage;
          var declarationName = ts2.idText(right);
          if (isInPropertyInitializer(node) && !(ts2.isAccessExpression(node) && ts2.isAccessExpression(node.expression)) && !isBlockScopedNameDeclaredBeforeUse(valueDeclaration, right) && !isPropertyDeclaredInAncestorClass(prop)) {
            diagnosticMessage = error(right, ts2.Diagnostics.Property_0_is_used_before_its_initialization, declarationName);
          } else if (valueDeclaration.kind === 245 && node.parent.kind !== 169 && !(valueDeclaration.flags & 8388608) && !isBlockScopedNameDeclaredBeforeUse(valueDeclaration, right)) {
            diagnosticMessage = error(right, ts2.Diagnostics.Class_0_used_before_its_declaration, declarationName);
          }
          if (diagnosticMessage) {
            ts2.addRelatedInfo(diagnosticMessage, ts2.createDiagnosticForNode(valueDeclaration, ts2.Diagnostics._0_is_declared_here, declarationName));
          }
        }
        function isInPropertyInitializer(node) {
          return !!ts2.findAncestor(node, function(node2) {
            switch (node2.kind) {
              case 159:
                return true;
              case 281:
              case 161:
              case 163:
              case 164:
              case 283:
              case 154:
              case 221:
              case 276:
              case 273:
              case 274:
              case 275:
              case 268:
              case 216:
              case 279:
                return false;
              default:
                return ts2.isExpressionNode(node2) ? false : "quit";
            }
          });
        }
        function isPropertyDeclaredInAncestorClass(prop) {
          if (!(prop.parent.flags & 32)) {
            return false;
          }
          var classType = getTypeOfSymbol(prop.parent);
          while (true) {
            classType = classType.symbol && getSuperClass(classType);
            if (!classType) {
              return false;
            }
            var superProperty = getPropertyOfType(classType, prop.escapedName);
            if (superProperty && superProperty.valueDeclaration) {
              return true;
            }
          }
        }
        function getSuperClass(classType) {
          var x = getBaseTypes(classType);
          if (x.length === 0) {
            return void 0;
          }
          return getIntersectionType(x);
        }
        function reportNonexistentProperty(propNode, containingType) {
          var errorInfo;
          var relatedInfo;
          if (!ts2.isPrivateIdentifier(propNode) && containingType.flags & 1048576 && !(containingType.flags & 131068)) {
            for (var _i = 0, _a = containingType.types; _i < _a.length; _i++) {
              var subtype = _a[_i];
              if (!getPropertyOfType(subtype, propNode.escapedText) && !getIndexInfoOfType(subtype, 0)) {
                errorInfo = ts2.chainDiagnosticMessages(errorInfo, ts2.Diagnostics.Property_0_does_not_exist_on_type_1, ts2.declarationNameToString(propNode), typeToString(subtype));
                break;
              }
            }
          }
          if (typeHasStaticProperty(propNode.escapedText, containingType)) {
            errorInfo = ts2.chainDiagnosticMessages(errorInfo, ts2.Diagnostics.Property_0_is_a_static_member_of_type_1, ts2.declarationNameToString(propNode), typeToString(containingType));
          } else {
            var promisedType = getPromisedTypeOfPromise(containingType);
            if (promisedType && getPropertyOfType(promisedType, propNode.escapedText)) {
              errorInfo = ts2.chainDiagnosticMessages(errorInfo, ts2.Diagnostics.Property_0_does_not_exist_on_type_1, ts2.declarationNameToString(propNode), typeToString(containingType));
              relatedInfo = ts2.createDiagnosticForNode(propNode, ts2.Diagnostics.Did_you_forget_to_use_await);
            } else {
              var suggestion = getSuggestedSymbolForNonexistentProperty(propNode, containingType);
              if (suggestion !== void 0) {
                var suggestedName = ts2.symbolName(suggestion);
                errorInfo = ts2.chainDiagnosticMessages(errorInfo, ts2.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2, ts2.declarationNameToString(propNode), typeToString(containingType), suggestedName);
                relatedInfo = suggestion.valueDeclaration && ts2.createDiagnosticForNode(suggestion.valueDeclaration, ts2.Diagnostics._0_is_declared_here, suggestedName);
              } else {
                errorInfo = ts2.chainDiagnosticMessages(elaborateNeverIntersection(errorInfo, containingType), ts2.Diagnostics.Property_0_does_not_exist_on_type_1, ts2.declarationNameToString(propNode), typeToString(containingType));
              }
            }
          }
          var resultDiagnostic = ts2.createDiagnosticForNodeFromMessageChain(propNode, errorInfo);
          if (relatedInfo) {
            ts2.addRelatedInfo(resultDiagnostic, relatedInfo);
          }
          diagnostics.add(resultDiagnostic);
        }
        function typeHasStaticProperty(propName, containingType) {
          var prop = containingType.symbol && getPropertyOfType(getTypeOfSymbol(containingType.symbol), propName);
          return prop !== void 0 && prop.valueDeclaration && ts2.hasModifier(prop.valueDeclaration, 32);
        }
        function getSuggestedSymbolForNonexistentProperty(name, containingType) {
          return getSpellingSuggestionForName(ts2.isString(name) ? name : ts2.idText(name), getPropertiesOfType(containingType), 111551);
        }
        function getSuggestionForNonexistentProperty(name, containingType) {
          var suggestion = getSuggestedSymbolForNonexistentProperty(name, containingType);
          return suggestion && ts2.symbolName(suggestion);
        }
        function getSuggestedSymbolForNonexistentSymbol(location, outerName, meaning) {
          ts2.Debug.assert(outerName !== void 0, "outername should always be defined");
          var result = resolveNameHelper(location, outerName, meaning, void 0, outerName, false, false, function(symbols, name, meaning2) {
            ts2.Debug.assertEqual(outerName, name, "name should equal outerName");
            var symbol = getSymbol(symbols, name, meaning2);
            return symbol || getSpellingSuggestionForName(ts2.unescapeLeadingUnderscores(name), ts2.arrayFrom(symbols.values()), meaning2);
          });
          return result;
        }
        function getSuggestionForNonexistentSymbol(location, outerName, meaning) {
          var symbolResult = getSuggestedSymbolForNonexistentSymbol(location, outerName, meaning);
          return symbolResult && ts2.symbolName(symbolResult);
        }
        function getSuggestedSymbolForNonexistentModule(name, targetModule) {
          return targetModule.exports && getSpellingSuggestionForName(ts2.idText(name), getExportsOfModuleAsArray(targetModule), 2623475);
        }
        function getSuggestionForNonexistentExport(name, targetModule) {
          var suggestion = getSuggestedSymbolForNonexistentModule(name, targetModule);
          return suggestion && ts2.symbolName(suggestion);
        }
        function getSuggestionForNonexistentIndexSignature(objectType, expr, keyedType) {
          function hasProp(name) {
            var prop = getPropertyOfObjectType(objectType, name);
            if (prop) {
              var s = getSingleCallSignature(getTypeOfSymbol(prop));
              return !!s && getMinArgumentCount(s) >= 1 && isTypeAssignableTo(keyedType, getTypeAtPosition(s, 0));
            }
            return false;
          }
          ;
          var suggestedMethod = ts2.isAssignmentTarget(expr) ? "set" : "get";
          if (!hasProp(suggestedMethod)) {
            return void 0;
          }
          var suggestion = ts2.tryGetPropertyAccessOrIdentifierToString(expr.expression);
          if (suggestion === void 0) {
            suggestion = suggestedMethod;
          } else {
            suggestion += "." + suggestedMethod;
          }
          return suggestion;
        }
        function getSpellingSuggestionForName(name, symbols, meaning) {
          return ts2.getSpellingSuggestion(name, symbols, getCandidateName);
          function getCandidateName(candidate) {
            var candidateName = ts2.symbolName(candidate);
            if (ts2.startsWith(candidateName, '"')) {
              return void 0;
            }
            if (candidate.flags & meaning) {
              return candidateName;
            }
            if (candidate.flags & 2097152) {
              var alias = tryResolveAlias(candidate);
              if (alias && alias.flags & meaning) {
                return candidateName;
              }
            }
            return void 0;
          }
        }
        function markPropertyAsReferenced(prop, nodeForCheckWriteOnly, isThisAccess) {
          var valueDeclaration = prop && prop.flags & 106500 && prop.valueDeclaration;
          if (!valueDeclaration) {
            return;
          }
          var hasPrivateModifier = ts2.hasModifier(valueDeclaration, 8);
          var hasPrivateIdentifier = ts2.isNamedDeclaration(prop.valueDeclaration) && ts2.isPrivateIdentifier(prop.valueDeclaration.name);
          if (!hasPrivateModifier && !hasPrivateIdentifier) {
            return;
          }
          if (nodeForCheckWriteOnly && ts2.isWriteOnlyAccess(nodeForCheckWriteOnly) && !(prop.flags & 65536)) {
            return;
          }
          if (isThisAccess) {
            var containingMethod = ts2.findAncestor(nodeForCheckWriteOnly, ts2.isFunctionLikeDeclaration);
            if (containingMethod && containingMethod.symbol === prop) {
              return;
            }
          }
          (ts2.getCheckFlags(prop) & 1 ? getSymbolLinks(prop).target : prop).isReferenced = 67108863;
        }
        function isValidPropertyAccess(node, propertyName) {
          switch (node.kind) {
            case 194:
              return isValidPropertyAccessWithType(node, node.expression.kind === 102, propertyName, getWidenedType(checkExpression(node.expression)));
            case 153:
              return isValidPropertyAccessWithType(node, false, propertyName, getWidenedType(checkExpression(node.left)));
            case 188:
              return isValidPropertyAccessWithType(node, false, propertyName, getTypeFromTypeNode(node));
          }
        }
        function isValidPropertyAccessForCompletions(node, type, property) {
          return isValidPropertyAccessWithType(node, node.kind === 194 && node.expression.kind === 102, property.escapedName, type);
        }
        function isValidPropertyAccessWithType(node, isSuper, propertyName, type) {
          if (type === errorType || isTypeAny(type)) {
            return true;
          }
          var prop = getPropertyOfType(type, propertyName);
          if (prop) {
            if (ts2.isPropertyAccessExpression(node) && prop.valueDeclaration && ts2.isPrivateIdentifierPropertyDeclaration(prop.valueDeclaration)) {
              var declClass_1 = ts2.getContainingClass(prop.valueDeclaration);
              return !ts2.isOptionalChain(node) && !!ts2.findAncestor(node, function(parent) {
                return parent === declClass_1;
              });
            }
            return checkPropertyAccessibility(node, isSuper, type, prop);
          }
          return ts2.isInJSFile(node) && (type.flags & 1048576) !== 0 && type.types.some(function(elementType) {
            return isValidPropertyAccessWithType(node, isSuper, propertyName, elementType);
          });
        }
        function getForInVariableSymbol(node) {
          var initializer = node.initializer;
          if (initializer.kind === 243) {
            var variable = initializer.declarations[0];
            if (variable && !ts2.isBindingPattern(variable.name)) {
              return getSymbolOfNode(variable);
            }
          } else if (initializer.kind === 75) {
            return getResolvedSymbol(initializer);
          }
          return void 0;
        }
        function hasNumericPropertyNames(type) {
          return getIndexTypeOfType(type, 1) && !getIndexTypeOfType(type, 0);
        }
        function isForInVariableForNumericPropertyNames(expr) {
          var e = ts2.skipParentheses(expr);
          if (e.kind === 75) {
            var symbol = getResolvedSymbol(e);
            if (symbol.flags & 3) {
              var child = expr;
              var node = expr.parent;
              while (node) {
                if (node.kind === 231 && child === node.statement && getForInVariableSymbol(node) === symbol && hasNumericPropertyNames(getTypeOfExpression(node.expression))) {
                  return true;
                }
                child = node;
                node = node.parent;
              }
            }
          }
          return false;
        }
        function checkIndexedAccess(node) {
          return node.flags & 32 ? checkElementAccessChain(node) : checkElementAccessExpression(node, checkNonNullExpression(node.expression));
        }
        function checkElementAccessChain(node) {
          var exprType = checkExpression(node.expression);
          var nonOptionalType = getOptionalExpressionType(exprType, node.expression);
          return propagateOptionalTypeMarker(checkElementAccessExpression(node, checkNonNullType(nonOptionalType, node.expression)), node, nonOptionalType !== exprType);
        }
        function checkElementAccessExpression(node, exprType) {
          var objectType = ts2.getAssignmentTargetKind(node) !== 0 || isMethodAccessForCall(node) ? getWidenedType(exprType) : exprType;
          var indexExpression = node.argumentExpression;
          var indexType = checkExpression(indexExpression);
          if (objectType === errorType || objectType === silentNeverType) {
            return objectType;
          }
          if (isConstEnumObjectType(objectType) && !ts2.isStringLiteralLike(indexExpression)) {
            error(indexExpression, ts2.Diagnostics.A_const_enum_member_can_only_be_accessed_using_a_string_literal);
            return errorType;
          }
          var effectiveIndexType = isForInVariableForNumericPropertyNames(indexExpression) ? numberType : indexType;
          var accessFlags = ts2.isAssignmentTarget(node) ? 2 | (isGenericObjectType(objectType) && !isThisTypeParameter(objectType) ? 1 : 0) : 0;
          var indexedAccessType = getIndexedAccessTypeOrUndefined(objectType, effectiveIndexType, node, accessFlags) || errorType;
          return checkIndexedAccessIndexType(getFlowTypeOfAccessExpression(node, indexedAccessType.symbol, indexedAccessType, indexExpression), node);
        }
        function checkThatExpressionIsProperSymbolReference(expression, expressionType, reportError) {
          if (expressionType === errorType) {
            return false;
          }
          if (!ts2.isWellKnownSymbolSyntactically(expression)) {
            return false;
          }
          if ((expressionType.flags & 12288) === 0) {
            if (reportError) {
              error(expression, ts2.Diagnostics.A_computed_property_name_of_the_form_0_must_be_of_type_symbol, ts2.getTextOfNode(expression));
            }
            return false;
          }
          var leftHandSide = expression.expression;
          var leftHandSideSymbol = getResolvedSymbol(leftHandSide);
          if (!leftHandSideSymbol) {
            return false;
          }
          var globalESSymbol = getGlobalESSymbolConstructorSymbol(true);
          if (!globalESSymbol) {
            return false;
          }
          if (leftHandSideSymbol !== globalESSymbol) {
            if (reportError) {
              error(leftHandSide, ts2.Diagnostics.Symbol_reference_does_not_refer_to_the_global_Symbol_constructor_object);
            }
            return false;
          }
          return true;
        }
        function callLikeExpressionMayHaveTypeArguments(node) {
          return ts2.isCallOrNewExpression(node) || ts2.isTaggedTemplateExpression(node) || ts2.isJsxOpeningLikeElement(node);
        }
        function resolveUntypedCall(node) {
          if (callLikeExpressionMayHaveTypeArguments(node)) {
            ts2.forEach(node.typeArguments, checkSourceElement);
          }
          if (node.kind === 198) {
            checkExpression(node.template);
          } else if (ts2.isJsxOpeningLikeElement(node)) {
            checkExpression(node.attributes);
          } else if (node.kind !== 157) {
            ts2.forEach(node.arguments, function(argument) {
              checkExpression(argument);
            });
          }
          return anySignature;
        }
        function resolveErrorCall(node) {
          resolveUntypedCall(node);
          return unknownSignature;
        }
        function reorderCandidates(signatures, result, callChainFlags) {
          var lastParent;
          var lastSymbol;
          var cutoffIndex = 0;
          var index;
          var specializedIndex = -1;
          var spliceIndex;
          ts2.Debug.assert(!result.length);
          for (var _i = 0, signatures_7 = signatures; _i < signatures_7.length; _i++) {
            var signature = signatures_7[_i];
            var symbol = signature.declaration && getSymbolOfNode(signature.declaration);
            var parent = signature.declaration && signature.declaration.parent;
            if (!lastSymbol || symbol === lastSymbol) {
              if (lastParent && parent === lastParent) {
                index = index + 1;
              } else {
                lastParent = parent;
                index = cutoffIndex;
              }
            } else {
              index = cutoffIndex = result.length;
              lastParent = parent;
            }
            lastSymbol = symbol;
            if (signatureHasLiteralTypes(signature)) {
              specializedIndex++;
              spliceIndex = specializedIndex;
              cutoffIndex++;
            } else {
              spliceIndex = index;
            }
            result.splice(spliceIndex, 0, callChainFlags ? getOptionalCallSignature(signature, callChainFlags) : signature);
          }
        }
        function isSpreadArgument(arg) {
          return !!arg && (arg.kind === 213 || arg.kind === 220 && arg.isSpread);
        }
        function getSpreadArgumentIndex(args) {
          return ts2.findIndex(args, isSpreadArgument);
        }
        function acceptsVoid(t) {
          return !!(t.flags & 16384);
        }
        function hasCorrectArity(node, args, signature, signatureHelpTrailingComma) {
          if (signatureHelpTrailingComma === void 0) {
            signatureHelpTrailingComma = false;
          }
          var argCount;
          var callIsIncomplete = false;
          var effectiveParameterCount = getParameterCount(signature);
          var effectiveMinimumArguments = getMinArgumentCount(signature);
          if (node.kind === 198) {
            argCount = args.length;
            if (node.template.kind === 211) {
              var lastSpan = ts2.last(node.template.templateSpans);
              callIsIncomplete = ts2.nodeIsMissing(lastSpan.literal) || !!lastSpan.literal.isUnterminated;
            } else {
              var templateLiteral = node.template;
              ts2.Debug.assert(templateLiteral.kind === 14);
              callIsIncomplete = !!templateLiteral.isUnterminated;
            }
          } else if (node.kind === 157) {
            argCount = getDecoratorArgumentCount(node, signature);
          } else if (ts2.isJsxOpeningLikeElement(node)) {
            callIsIncomplete = node.attributes.end === node.end;
            if (callIsIncomplete) {
              return true;
            }
            argCount = effectiveMinimumArguments === 0 ? args.length : 1;
            effectiveParameterCount = args.length === 0 ? effectiveParameterCount : 1;
            effectiveMinimumArguments = Math.min(effectiveMinimumArguments, 1);
          } else {
            if (!node.arguments) {
              ts2.Debug.assert(node.kind === 197);
              return getMinArgumentCount(signature) === 0;
            }
            argCount = signatureHelpTrailingComma ? args.length + 1 : args.length;
            callIsIncomplete = node.arguments.end === node.end;
            var spreadArgIndex = getSpreadArgumentIndex(args);
            if (spreadArgIndex >= 0) {
              return spreadArgIndex >= getMinArgumentCount(signature) && (hasEffectiveRestParameter(signature) || spreadArgIndex < getParameterCount(signature));
            }
          }
          if (!hasEffectiveRestParameter(signature) && argCount > effectiveParameterCount) {
            return false;
          }
          if (callIsIncomplete || argCount >= effectiveMinimumArguments) {
            return true;
          }
          for (var i = argCount; i < effectiveMinimumArguments; i++) {
            var type = getTypeAtPosition(signature, i);
            if (filterType(type, acceptsVoid).flags & 131072) {
              return false;
            }
          }
          return true;
        }
        function hasCorrectTypeArgumentArity(signature, typeArguments) {
          var numTypeParameters = ts2.length(signature.typeParameters);
          var minTypeArgumentCount = getMinTypeArgumentCount(signature.typeParameters);
          return !ts2.some(typeArguments) || typeArguments.length >= minTypeArgumentCount && typeArguments.length <= numTypeParameters;
        }
        function getSingleCallSignature(type) {
          return getSingleSignature(type, 0, false);
        }
        function getSingleCallOrConstructSignature(type) {
          return getSingleSignature(type, 0, false) || getSingleSignature(type, 1, false);
        }
        function getSingleSignature(type, kind, allowMembers) {
          if (type.flags & 524288) {
            var resolved = resolveStructuredTypeMembers(type);
            if (allowMembers || resolved.properties.length === 0 && !resolved.stringIndexInfo && !resolved.numberIndexInfo) {
              if (kind === 0 && resolved.callSignatures.length === 1 && resolved.constructSignatures.length === 0) {
                return resolved.callSignatures[0];
              }
              if (kind === 1 && resolved.constructSignatures.length === 1 && resolved.callSignatures.length === 0) {
                return resolved.constructSignatures[0];
              }
            }
          }
          return void 0;
        }
        function instantiateSignatureInContextOf(signature, contextualSignature, inferenceContext, compareTypes) {
          var context = createInferenceContext(signature.typeParameters, signature, 0, compareTypes);
          var restType = getEffectiveRestType(contextualSignature);
          var mapper = inferenceContext && (restType && restType.flags & 262144 ? inferenceContext.nonFixingMapper : inferenceContext.mapper);
          var sourceSignature = mapper ? instantiateSignature(contextualSignature, mapper) : contextualSignature;
          applyToParameterTypes(sourceSignature, signature, function(source, target) {
            inferTypes(context.inferences, source, target);
          });
          if (!inferenceContext) {
            applyToReturnTypes(contextualSignature, signature, function(source, target) {
              inferTypes(context.inferences, source, target, 32);
            });
          }
          return getSignatureInstantiation(signature, getInferredTypes(context), ts2.isInJSFile(contextualSignature.declaration));
        }
        function inferJsxTypeArguments(node, signature, checkMode, context) {
          var paramType = getEffectiveFirstArgumentForJsxSignature(signature, node);
          var checkAttrType = checkExpressionWithContextualType(node.attributes, paramType, context, checkMode);
          inferTypes(context.inferences, checkAttrType, paramType);
          return getInferredTypes(context);
        }
        function inferTypeArguments(node, signature, args, checkMode, context) {
          if (ts2.isJsxOpeningLikeElement(node)) {
            return inferJsxTypeArguments(node, signature, checkMode, context);
          }
          if (node.kind !== 157) {
            var contextualType = getContextualType(node);
            if (contextualType) {
              var outerContext = getInferenceContext(node);
              var outerMapper = getMapperFromContext(cloneInferenceContext(outerContext, 1));
              var instantiatedType = instantiateType(contextualType, outerMapper);
              var contextualSignature = getSingleCallSignature(instantiatedType);
              var inferenceSourceType = contextualSignature && contextualSignature.typeParameters ? getOrCreateTypeFromSignature(getSignatureInstantiationWithoutFillingInTypeArguments(contextualSignature, contextualSignature.typeParameters)) : instantiatedType;
              var inferenceTargetType = getReturnTypeOfSignature(signature);
              inferTypes(context.inferences, inferenceSourceType, inferenceTargetType, 32);
              var returnContext = createInferenceContext(signature.typeParameters, signature, context.flags);
              var returnSourceType = instantiateType(contextualType, outerContext && outerContext.returnMapper);
              inferTypes(returnContext.inferences, returnSourceType, inferenceTargetType);
              context.returnMapper = ts2.some(returnContext.inferences, hasInferenceCandidates) ? getMapperFromContext(cloneInferredPartOfContext(returnContext)) : void 0;
            }
          }
          var thisType = getThisTypeOfSignature(signature);
          if (thisType) {
            var thisArgumentNode = getThisArgumentOfCall(node);
            var thisArgumentType = thisArgumentNode ? checkExpression(thisArgumentNode) : voidType;
            inferTypes(context.inferences, thisArgumentType, thisType);
          }
          var restType = getNonArrayRestType(signature);
          var argCount = restType ? Math.min(getParameterCount(signature) - 1, args.length) : args.length;
          for (var i = 0; i < argCount; i++) {
            var arg = args[i];
            if (arg.kind !== 215) {
              var paramType = getTypeAtPosition(signature, i);
              var argType = checkExpressionWithContextualType(arg, paramType, context, checkMode);
              inferTypes(context.inferences, argType, paramType);
            }
          }
          if (restType) {
            var spreadType = getSpreadArgumentType(args, argCount, args.length, restType, context);
            inferTypes(context.inferences, spreadType, restType);
          }
          return getInferredTypes(context);
        }
        function getArrayifiedType(type) {
          return type.flags & 1048576 ? mapType(type, getArrayifiedType) : type.flags & (1 | 63176704) || isMutableArrayOrTuple(type) ? type : isTupleType(type) ? createTupleType(getTypeArguments(type), type.target.minLength, type.target.hasRestElement, false, type.target.associatedNames) : createArrayType(getIndexedAccessType(type, numberType));
        }
        function getSpreadArgumentType(args, index, argCount, restType, context) {
          if (index >= argCount - 1) {
            var arg = args[argCount - 1];
            if (isSpreadArgument(arg)) {
              return arg.kind === 220 ? createArrayType(arg.type) : getArrayifiedType(checkExpressionWithContextualType(arg.expression, restType, context, 0));
            }
          }
          var types = [];
          var spreadIndex = -1;
          for (var i = index; i < argCount; i++) {
            var contextualType = getIndexedAccessType(restType, getLiteralType(i - index));
            var argType = checkExpressionWithContextualType(args[i], contextualType, context, 0);
            if (spreadIndex < 0 && isSpreadArgument(args[i])) {
              spreadIndex = i - index;
            }
            var hasPrimitiveContextualType = maybeTypeOfKind(contextualType, 131068 | 4194304);
            types.push(hasPrimitiveContextualType ? getRegularTypeOfLiteralType(argType) : getWidenedLiteralType(argType));
          }
          return spreadIndex < 0 ? createTupleType(types) : createTupleType(ts2.append(types.slice(0, spreadIndex), getUnionType(types.slice(spreadIndex))), spreadIndex, true);
        }
        function checkTypeArguments(signature, typeArgumentNodes, reportErrors, headMessage) {
          var isJavascript = ts2.isInJSFile(signature.declaration);
          var typeParameters = signature.typeParameters;
          var typeArgumentTypes = fillMissingTypeArguments(ts2.map(typeArgumentNodes, getTypeFromTypeNode), typeParameters, getMinTypeArgumentCount(typeParameters), isJavascript);
          var mapper;
          for (var i = 0; i < typeArgumentNodes.length; i++) {
            ts2.Debug.assert(typeParameters[i] !== void 0, "Should not call checkTypeArguments with too many type arguments");
            var constraint = getConstraintOfTypeParameter(typeParameters[i]);
            if (constraint) {
              var errorInfo = reportErrors && headMessage ? function() {
                return ts2.chainDiagnosticMessages(void 0, ts2.Diagnostics.Type_0_does_not_satisfy_the_constraint_1);
              } : void 0;
              var typeArgumentHeadMessage = headMessage || ts2.Diagnostics.Type_0_does_not_satisfy_the_constraint_1;
              if (!mapper) {
                mapper = createTypeMapper(typeParameters, typeArgumentTypes);
              }
              var typeArgument = typeArgumentTypes[i];
              if (!checkTypeAssignableTo(typeArgument, getTypeWithThisArgument(instantiateType(constraint, mapper), typeArgument), reportErrors ? typeArgumentNodes[i] : void 0, typeArgumentHeadMessage, errorInfo)) {
                return void 0;
              }
            }
          }
          return typeArgumentTypes;
        }
        function getJsxReferenceKind(node) {
          if (isJsxIntrinsicIdentifier(node.tagName)) {
            return 2;
          }
          var tagType = getApparentType(checkExpression(node.tagName));
          if (ts2.length(getSignaturesOfType(tagType, 1))) {
            return 0;
          }
          if (ts2.length(getSignaturesOfType(tagType, 0))) {
            return 1;
          }
          return 2;
        }
        function checkApplicableSignatureForJsxOpeningLikeElement(node, signature, relation, checkMode, reportErrors, containingMessageChain, errorOutputContainer) {
          var paramType = getEffectiveFirstArgumentForJsxSignature(signature, node);
          var attributesType = checkExpressionWithContextualType(node.attributes, paramType, void 0, checkMode);
          return checkTagNameDoesNotExpectTooManyArguments() && checkTypeRelatedToAndOptionallyElaborate(attributesType, paramType, relation, reportErrors ? node.tagName : void 0, node.attributes, void 0, containingMessageChain, errorOutputContainer);
          function checkTagNameDoesNotExpectTooManyArguments() {
            var _a;
            var tagType = ts2.isJsxOpeningElement(node) || ts2.isJsxSelfClosingElement(node) && !isJsxIntrinsicIdentifier(node.tagName) ? checkExpression(node.tagName) : void 0;
            if (!tagType) {
              return true;
            }
            var tagCallSignatures = getSignaturesOfType(tagType, 0);
            if (!ts2.length(tagCallSignatures)) {
              return true;
            }
            var factory = getJsxFactoryEntity(node);
            if (!factory) {
              return true;
            }
            var factorySymbol = resolveEntityName(factory, 111551, true, false, node);
            if (!factorySymbol) {
              return true;
            }
            var factoryType = getTypeOfSymbol(factorySymbol);
            var callSignatures = getSignaturesOfType(factoryType, 0);
            if (!ts2.length(callSignatures)) {
              return true;
            }
            var hasFirstParamSignatures = false;
            var maxParamCount = 0;
            for (var _i = 0, callSignatures_1 = callSignatures; _i < callSignatures_1.length; _i++) {
              var sig = callSignatures_1[_i];
              var firstparam = getTypeAtPosition(sig, 0);
              var signaturesOfParam = getSignaturesOfType(firstparam, 0);
              if (!ts2.length(signaturesOfParam))
                continue;
              for (var _b = 0, signaturesOfParam_1 = signaturesOfParam; _b < signaturesOfParam_1.length; _b++) {
                var paramSig = signaturesOfParam_1[_b];
                hasFirstParamSignatures = true;
                if (hasEffectiveRestParameter(paramSig)) {
                  return true;
                }
                var paramCount = getParameterCount(paramSig);
                if (paramCount > maxParamCount) {
                  maxParamCount = paramCount;
                }
              }
            }
            if (!hasFirstParamSignatures) {
              return true;
            }
            var absoluteMinArgCount = Infinity;
            for (var _c = 0, tagCallSignatures_1 = tagCallSignatures; _c < tagCallSignatures_1.length; _c++) {
              var tagSig = tagCallSignatures_1[_c];
              var tagRequiredArgCount = getMinArgumentCount(tagSig);
              if (tagRequiredArgCount < absoluteMinArgCount) {
                absoluteMinArgCount = tagRequiredArgCount;
              }
            }
            if (absoluteMinArgCount <= maxParamCount) {
              return true;
            }
            if (reportErrors) {
              var diag = ts2.createDiagnosticForNode(node.tagName, ts2.Diagnostics.Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3, ts2.entityNameToString(node.tagName), absoluteMinArgCount, ts2.entityNameToString(factory), maxParamCount);
              var tagNameDeclaration = (_a = getSymbolAtLocation(node.tagName)) === null || _a === void 0 ? void 0 : _a.valueDeclaration;
              if (tagNameDeclaration) {
                ts2.addRelatedInfo(diag, ts2.createDiagnosticForNode(tagNameDeclaration, ts2.Diagnostics._0_is_declared_here, ts2.entityNameToString(node.tagName)));
              }
              if (errorOutputContainer && errorOutputContainer.skipLogging) {
                (errorOutputContainer.errors || (errorOutputContainer.errors = [])).push(diag);
              }
              if (!errorOutputContainer.skipLogging) {
                diagnostics.add(diag);
              }
            }
            return false;
          }
        }
        function getSignatureApplicabilityError(node, args, signature, relation, checkMode, reportErrors, containingMessageChain) {
          var errorOutputContainer = { errors: void 0, skipLogging: true };
          if (ts2.isJsxOpeningLikeElement(node)) {
            if (!checkApplicableSignatureForJsxOpeningLikeElement(node, signature, relation, checkMode, reportErrors, containingMessageChain, errorOutputContainer)) {
              ts2.Debug.assert(!reportErrors || !!errorOutputContainer.errors, "jsx should have errors when reporting errors");
              return errorOutputContainer.errors || ts2.emptyArray;
            }
            return void 0;
          }
          var thisType = getThisTypeOfSignature(signature);
          if (thisType && thisType !== voidType && node.kind !== 197) {
            var thisArgumentNode = getThisArgumentOfCall(node);
            var thisArgumentType = void 0;
            if (thisArgumentNode) {
              thisArgumentType = checkExpression(thisArgumentNode);
              if (ts2.isOptionalChainRoot(thisArgumentNode.parent)) {
                thisArgumentType = getNonNullableType(thisArgumentType);
              } else if (ts2.isOptionalChain(thisArgumentNode.parent)) {
                thisArgumentType = removeOptionalTypeMarker(thisArgumentType);
              }
            } else {
              thisArgumentType = voidType;
            }
            var errorNode = reportErrors ? thisArgumentNode || node : void 0;
            var headMessage_1 = ts2.Diagnostics.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1;
            if (!checkTypeRelatedTo(thisArgumentType, thisType, relation, errorNode, headMessage_1, containingMessageChain, errorOutputContainer)) {
              ts2.Debug.assert(!reportErrors || !!errorOutputContainer.errors, "this parameter should have errors when reporting errors");
              return errorOutputContainer.errors || ts2.emptyArray;
            }
          }
          var headMessage = ts2.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1;
          var restType = getNonArrayRestType(signature);
          var argCount = restType ? Math.min(getParameterCount(signature) - 1, args.length) : args.length;
          for (var i = 0; i < argCount; i++) {
            var arg = args[i];
            if (arg.kind !== 215) {
              var paramType = getTypeAtPosition(signature, i);
              var argType = checkExpressionWithContextualType(arg, paramType, void 0, checkMode);
              var checkArgType = checkMode & 4 ? getRegularTypeOfObjectLiteral(argType) : argType;
              if (!checkTypeRelatedToAndOptionallyElaborate(checkArgType, paramType, relation, reportErrors ? arg : void 0, arg, headMessage, containingMessageChain, errorOutputContainer)) {
                ts2.Debug.assert(!reportErrors || !!errorOutputContainer.errors, "parameter should have errors when reporting errors");
                maybeAddMissingAwaitInfo(arg, checkArgType, paramType);
                return errorOutputContainer.errors || ts2.emptyArray;
              }
            }
          }
          if (restType) {
            var spreadType = getSpreadArgumentType(args, argCount, args.length, restType, void 0);
            var errorNode = reportErrors ? argCount < args.length ? args[argCount] : node : void 0;
            if (!checkTypeRelatedTo(spreadType, restType, relation, errorNode, headMessage, void 0, errorOutputContainer)) {
              ts2.Debug.assert(!reportErrors || !!errorOutputContainer.errors, "rest parameter should have errors when reporting errors");
              maybeAddMissingAwaitInfo(errorNode, spreadType, restType);
              return errorOutputContainer.errors || ts2.emptyArray;
            }
          }
          return void 0;
          function maybeAddMissingAwaitInfo(errorNode2, source, target) {
            if (errorNode2 && reportErrors && errorOutputContainer.errors && errorOutputContainer.errors.length) {
              if (getAwaitedTypeOfPromise(target)) {
                return;
              }
              var awaitedTypeOfSource = getAwaitedTypeOfPromise(source);
              if (awaitedTypeOfSource && isTypeRelatedTo(awaitedTypeOfSource, target, relation)) {
                ts2.addRelatedInfo(errorOutputContainer.errors[0], ts2.createDiagnosticForNode(errorNode2, ts2.Diagnostics.Did_you_forget_to_use_await));
              }
            }
          }
        }
        function getThisArgumentOfCall(node) {
          if (node.kind === 196) {
            var callee = ts2.skipOuterExpressions(node.expression);
            if (ts2.isAccessExpression(callee)) {
              return callee.expression;
            }
          }
        }
        function createSyntheticExpression(parent, type, isSpread) {
          var result = ts2.createNode(220, parent.pos, parent.end);
          result.parent = parent;
          result.type = type;
          result.isSpread = isSpread || false;
          return result;
        }
        function getEffectiveCallArguments(node) {
          if (node.kind === 198) {
            var template = node.template;
            var args_3 = [createSyntheticExpression(template, getGlobalTemplateStringsArrayType())];
            if (template.kind === 211) {
              ts2.forEach(template.templateSpans, function(span) {
                args_3.push(span.expression);
              });
            }
            return args_3;
          }
          if (node.kind === 157) {
            return getEffectiveDecoratorArguments(node);
          }
          if (ts2.isJsxOpeningLikeElement(node)) {
            return node.attributes.properties.length > 0 || ts2.isJsxOpeningElement(node) && node.parent.children.length > 0 ? [node.attributes] : ts2.emptyArray;
          }
          var args = node.arguments || ts2.emptyArray;
          var length = args.length;
          if (length && isSpreadArgument(args[length - 1]) && getSpreadArgumentIndex(args) === length - 1) {
            var spreadArgument_1 = args[length - 1];
            var type = flowLoopCount ? checkExpression(spreadArgument_1.expression) : checkExpressionCached(spreadArgument_1.expression);
            if (isTupleType(type)) {
              var typeArguments = getTypeArguments(type);
              var restIndex_2 = type.target.hasRestElement ? typeArguments.length - 1 : -1;
              var syntheticArgs = ts2.map(typeArguments, function(t, i) {
                return createSyntheticExpression(spreadArgument_1, t, i === restIndex_2);
              });
              return ts2.concatenate(args.slice(0, length - 1), syntheticArgs);
            }
          }
          return args;
        }
        function getEffectiveDecoratorArguments(node) {
          var parent = node.parent;
          var expr = node.expression;
          switch (parent.kind) {
            case 245:
            case 214:
              return [
                createSyntheticExpression(expr, getTypeOfSymbol(getSymbolOfNode(parent)))
              ];
            case 156:
              var func = parent.parent;
              return [
                createSyntheticExpression(expr, parent.parent.kind === 162 ? getTypeOfSymbol(getSymbolOfNode(func)) : errorType),
                createSyntheticExpression(expr, anyType),
                createSyntheticExpression(expr, numberType)
              ];
            case 159:
            case 161:
            case 163:
            case 164:
              var hasPropDesc = parent.kind !== 159 && languageVersion !== 0;
              return [
                createSyntheticExpression(expr, getParentTypeOfClassElement(parent)),
                createSyntheticExpression(expr, getClassElementPropertyKeyType(parent)),
                createSyntheticExpression(expr, hasPropDesc ? createTypedPropertyDescriptorType(getTypeOfNode(parent)) : anyType)
              ];
          }
          return ts2.Debug.fail();
        }
        function getDecoratorArgumentCount(node, signature) {
          switch (node.parent.kind) {
            case 245:
            case 214:
              return 1;
            case 159:
              return 2;
            case 161:
            case 163:
            case 164:
              return languageVersion === 0 || signature.parameters.length <= 2 ? 2 : 3;
            case 156:
              return 3;
            default:
              return ts2.Debug.fail();
          }
        }
        function getDiagnosticSpanForCallNode(node, doNotIncludeArguments) {
          var start;
          var length;
          var sourceFile = ts2.getSourceFileOfNode(node);
          if (ts2.isPropertyAccessExpression(node.expression)) {
            var nameSpan = ts2.getErrorSpanForNode(sourceFile, node.expression.name);
            start = nameSpan.start;
            length = doNotIncludeArguments ? nameSpan.length : node.end - start;
          } else {
            var expressionSpan = ts2.getErrorSpanForNode(sourceFile, node.expression);
            start = expressionSpan.start;
            length = doNotIncludeArguments ? expressionSpan.length : node.end - start;
          }
          return { start, length, sourceFile };
        }
        function getDiagnosticForCallNode(node, message, arg0, arg1, arg2, arg3) {
          if (ts2.isCallExpression(node)) {
            var _a = getDiagnosticSpanForCallNode(node), sourceFile = _a.sourceFile, start = _a.start, length_5 = _a.length;
            return ts2.createFileDiagnostic(sourceFile, start, length_5, message, arg0, arg1, arg2, arg3);
          } else {
            return ts2.createDiagnosticForNode(node, message, arg0, arg1, arg2, arg3);
          }
        }
        function getArgumentArityError(node, signatures, args) {
          var min = Number.POSITIVE_INFINITY;
          var max = Number.NEGATIVE_INFINITY;
          var belowArgCount = Number.NEGATIVE_INFINITY;
          var aboveArgCount = Number.POSITIVE_INFINITY;
          var argCount = args.length;
          var closestSignature;
          for (var _i = 0, signatures_8 = signatures; _i < signatures_8.length; _i++) {
            var sig = signatures_8[_i];
            var minCount = getMinArgumentCount(sig);
            var maxCount = getParameterCount(sig);
            if (minCount < argCount && minCount > belowArgCount)
              belowArgCount = minCount;
            if (argCount < maxCount && maxCount < aboveArgCount)
              aboveArgCount = maxCount;
            if (minCount < min) {
              min = minCount;
              closestSignature = sig;
            }
            max = Math.max(max, maxCount);
          }
          var hasRestParameter = ts2.some(signatures, hasEffectiveRestParameter);
          var paramRange = hasRestParameter ? min : min < max ? min + "-" + max : min;
          var hasSpreadArgument = getSpreadArgumentIndex(args) > -1;
          if (argCount <= max && hasSpreadArgument) {
            argCount--;
          }
          var spanArray;
          var related;
          var error2 = hasRestParameter || hasSpreadArgument ? hasRestParameter && hasSpreadArgument ? ts2.Diagnostics.Expected_at_least_0_arguments_but_got_1_or_more : hasRestParameter ? ts2.Diagnostics.Expected_at_least_0_arguments_but_got_1 : ts2.Diagnostics.Expected_0_arguments_but_got_1_or_more : ts2.Diagnostics.Expected_0_arguments_but_got_1;
          if (closestSignature && getMinArgumentCount(closestSignature) > argCount && closestSignature.declaration) {
            var paramDecl = closestSignature.declaration.parameters[closestSignature.thisParameter ? argCount + 1 : argCount];
            if (paramDecl) {
              related = ts2.createDiagnosticForNode(paramDecl, ts2.isBindingPattern(paramDecl.name) ? ts2.Diagnostics.An_argument_matching_this_binding_pattern_was_not_provided : ts2.Diagnostics.An_argument_for_0_was_not_provided, !paramDecl.name ? argCount : !ts2.isBindingPattern(paramDecl.name) ? ts2.idText(ts2.getFirstIdentifier(paramDecl.name)) : void 0);
            }
          }
          if (min < argCount && argCount < max) {
            return getDiagnosticForCallNode(node, ts2.Diagnostics.No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments, argCount, belowArgCount, aboveArgCount);
          }
          if (!hasSpreadArgument && argCount < min) {
            var diagnostic_1 = getDiagnosticForCallNode(node, error2, paramRange, argCount);
            return related ? ts2.addRelatedInfo(diagnostic_1, related) : diagnostic_1;
          }
          if (hasRestParameter || hasSpreadArgument) {
            spanArray = ts2.createNodeArray(args);
            if (hasSpreadArgument && argCount) {
              var nextArg = ts2.elementAt(args, getSpreadArgumentIndex(args) + 1) || void 0;
              spanArray = ts2.createNodeArray(args.slice(max > argCount && nextArg ? args.indexOf(nextArg) : Math.min(max, args.length - 1)));
            }
          } else {
            spanArray = ts2.createNodeArray(args.slice(max));
          }
          spanArray.pos = ts2.first(spanArray).pos;
          spanArray.end = ts2.last(spanArray).end;
          if (spanArray.end === spanArray.pos) {
            spanArray.end++;
          }
          var diagnostic = ts2.createDiagnosticForNodeArray(ts2.getSourceFileOfNode(node), spanArray, error2, paramRange, argCount);
          return related ? ts2.addRelatedInfo(diagnostic, related) : diagnostic;
        }
        function getTypeArgumentArityError(node, signatures, typeArguments) {
          var argCount = typeArguments.length;
          if (signatures.length === 1) {
            var sig = signatures[0];
            var min_1 = getMinTypeArgumentCount(sig.typeParameters);
            var max = ts2.length(sig.typeParameters);
            return ts2.createDiagnosticForNodeArray(ts2.getSourceFileOfNode(node), typeArguments, ts2.Diagnostics.Expected_0_type_arguments_but_got_1, min_1 < max ? min_1 + "-" + max : min_1, argCount);
          }
          var belowArgCount = -Infinity;
          var aboveArgCount = Infinity;
          for (var _i = 0, signatures_9 = signatures; _i < signatures_9.length; _i++) {
            var sig = signatures_9[_i];
            var min_2 = getMinTypeArgumentCount(sig.typeParameters);
            var max = ts2.length(sig.typeParameters);
            if (min_2 > argCount) {
              aboveArgCount = Math.min(aboveArgCount, min_2);
            } else if (max < argCount) {
              belowArgCount = Math.max(belowArgCount, max);
            }
          }
          if (belowArgCount !== -Infinity && aboveArgCount !== Infinity) {
            return ts2.createDiagnosticForNodeArray(ts2.getSourceFileOfNode(node), typeArguments, ts2.Diagnostics.No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments, argCount, belowArgCount, aboveArgCount);
          }
          return ts2.createDiagnosticForNodeArray(ts2.getSourceFileOfNode(node), typeArguments, ts2.Diagnostics.Expected_0_type_arguments_but_got_1, belowArgCount === -Infinity ? aboveArgCount : belowArgCount, argCount);
        }
        function resolveCall(node, signatures, candidatesOutArray, checkMode, callChainFlags, fallbackError) {
          var isTaggedTemplate = node.kind === 198;
          var isDecorator = node.kind === 157;
          var isJsxOpeningOrSelfClosingElement = ts2.isJsxOpeningLikeElement(node);
          var reportErrors = !candidatesOutArray;
          var typeArguments;
          if (!isDecorator) {
            typeArguments = node.typeArguments;
            if (isTaggedTemplate || isJsxOpeningOrSelfClosingElement || node.expression.kind !== 102) {
              ts2.forEach(typeArguments, checkSourceElement);
            }
          }
          var candidates = candidatesOutArray || [];
          reorderCandidates(signatures, candidates, callChainFlags);
          if (!candidates.length) {
            if (reportErrors) {
              diagnostics.add(getDiagnosticForCallNode(node, ts2.Diagnostics.Call_target_does_not_contain_any_signatures));
            }
            return resolveErrorCall(node);
          }
          var args = getEffectiveCallArguments(node);
          var isSingleNonGenericCandidate = candidates.length === 1 && !candidates[0].typeParameters;
          var argCheckMode = !isDecorator && !isSingleNonGenericCandidate && ts2.some(args, isContextSensitive) ? 4 : 0;
          var candidatesForArgumentError;
          var candidateForArgumentArityError;
          var candidateForTypeArgumentError;
          var result;
          var signatureHelpTrailingComma = !!(checkMode & 16) && node.kind === 196 && node.arguments.hasTrailingComma;
          if (candidates.length > 1) {
            result = chooseOverload(candidates, subtypeRelation, signatureHelpTrailingComma);
          }
          if (!result) {
            result = chooseOverload(candidates, assignableRelation, signatureHelpTrailingComma);
          }
          if (result) {
            return result;
          }
          if (reportErrors) {
            if (candidatesForArgumentError) {
              if (candidatesForArgumentError.length === 1 || candidatesForArgumentError.length > 3) {
                var last_2 = candidatesForArgumentError[candidatesForArgumentError.length - 1];
                var chain_1;
                if (candidatesForArgumentError.length > 3) {
                  chain_1 = ts2.chainDiagnosticMessages(chain_1, ts2.Diagnostics.The_last_overload_gave_the_following_error);
                  chain_1 = ts2.chainDiagnosticMessages(chain_1, ts2.Diagnostics.No_overload_matches_this_call);
                }
                var diags = getSignatureApplicabilityError(node, args, last_2, assignableRelation, 0, true, function() {
                  return chain_1;
                });
                if (diags) {
                  for (var _i = 0, diags_1 = diags; _i < diags_1.length; _i++) {
                    var d = diags_1[_i];
                    if (last_2.declaration && candidatesForArgumentError.length > 3) {
                      ts2.addRelatedInfo(d, ts2.createDiagnosticForNode(last_2.declaration, ts2.Diagnostics.The_last_overload_is_declared_here));
                    }
                    diagnostics.add(d);
                  }
                } else {
                  ts2.Debug.fail("No error for last overload signature");
                }
              } else {
                var allDiagnostics = [];
                var max = 0;
                var min_3 = Number.MAX_VALUE;
                var minIndex = 0;
                var i_1 = 0;
                var _loop_17 = function(c2) {
                  var chain_2 = function() {
                    return ts2.chainDiagnosticMessages(void 0, ts2.Diagnostics.Overload_0_of_1_2_gave_the_following_error, i_1 + 1, candidates.length, signatureToString(c2));
                  };
                  var diags_2 = getSignatureApplicabilityError(node, args, c2, assignableRelation, 0, true, chain_2);
                  if (diags_2) {
                    if (diags_2.length <= min_3) {
                      min_3 = diags_2.length;
                      minIndex = i_1;
                    }
                    max = Math.max(max, diags_2.length);
                    allDiagnostics.push(diags_2);
                  } else {
                    ts2.Debug.fail("No error for 3 or fewer overload signatures");
                  }
                  i_1++;
                };
                for (var _a = 0, candidatesForArgumentError_1 = candidatesForArgumentError; _a < candidatesForArgumentError_1.length; _a++) {
                  var c = candidatesForArgumentError_1[_a];
                  _loop_17(c);
                }
                var diags_3 = max > 1 ? allDiagnostics[minIndex] : ts2.flatten(allDiagnostics);
                ts2.Debug.assert(diags_3.length > 0, "No errors reported for 3 or fewer overload signatures");
                var chain = ts2.chainDiagnosticMessages(ts2.map(diags_3, function(d2) {
                  return typeof d2.messageText === "string" ? d2 : d2.messageText;
                }), ts2.Diagnostics.No_overload_matches_this_call);
                var related = ts2.flatMap(diags_3, function(d2) {
                  return d2.relatedInformation;
                });
                if (ts2.every(diags_3, function(d2) {
                  return d2.start === diags_3[0].start && d2.length === diags_3[0].length && d2.file === diags_3[0].file;
                })) {
                  var _b = diags_3[0], file = _b.file, start = _b.start, length_6 = _b.length;
                  diagnostics.add({ file, start, length: length_6, code: chain.code, category: chain.category, messageText: chain, relatedInformation: related });
                } else {
                  diagnostics.add(ts2.createDiagnosticForNodeFromMessageChain(node, chain, related));
                }
              }
            } else if (candidateForArgumentArityError) {
              diagnostics.add(getArgumentArityError(node, [candidateForArgumentArityError], args));
            } else if (candidateForTypeArgumentError) {
              checkTypeArguments(candidateForTypeArgumentError, node.typeArguments, true, fallbackError);
            } else {
              var signaturesWithCorrectTypeArgumentArity = ts2.filter(signatures, function(s) {
                return hasCorrectTypeArgumentArity(s, typeArguments);
              });
              if (signaturesWithCorrectTypeArgumentArity.length === 0) {
                diagnostics.add(getTypeArgumentArityError(node, signatures, typeArguments));
              } else if (!isDecorator) {
                diagnostics.add(getArgumentArityError(node, signaturesWithCorrectTypeArgumentArity, args));
              } else if (fallbackError) {
                diagnostics.add(getDiagnosticForCallNode(node, fallbackError));
              }
            }
          }
          return getCandidateForOverloadFailure(node, candidates, args, !!candidatesOutArray);
          function chooseOverload(candidates2, relation, signatureHelpTrailingComma2) {
            if (signatureHelpTrailingComma2 === void 0) {
              signatureHelpTrailingComma2 = false;
            }
            candidatesForArgumentError = void 0;
            candidateForArgumentArityError = void 0;
            candidateForTypeArgumentError = void 0;
            if (isSingleNonGenericCandidate) {
              var candidate = candidates2[0];
              if (ts2.some(typeArguments) || !hasCorrectArity(node, args, candidate, signatureHelpTrailingComma2)) {
                return void 0;
              }
              if (getSignatureApplicabilityError(node, args, candidate, relation, 0, false, void 0)) {
                candidatesForArgumentError = [candidate];
                return void 0;
              }
              return candidate;
            }
            for (var candidateIndex = 0; candidateIndex < candidates2.length; candidateIndex++) {
              var candidate = candidates2[candidateIndex];
              if (!hasCorrectTypeArgumentArity(candidate, typeArguments) || !hasCorrectArity(node, args, candidate, signatureHelpTrailingComma2)) {
                continue;
              }
              var checkCandidate = void 0;
              var inferenceContext = void 0;
              if (candidate.typeParameters) {
                var typeArgumentTypes = void 0;
                if (ts2.some(typeArguments)) {
                  typeArgumentTypes = checkTypeArguments(candidate, typeArguments, false);
                  if (!typeArgumentTypes) {
                    candidateForTypeArgumentError = candidate;
                    continue;
                  }
                } else {
                  inferenceContext = createInferenceContext(candidate.typeParameters, candidate, ts2.isInJSFile(node) ? 2 : 0);
                  typeArgumentTypes = inferTypeArguments(node, candidate, args, argCheckMode | 8, inferenceContext);
                  argCheckMode |= inferenceContext.flags & 4 ? 8 : 0;
                }
                checkCandidate = getSignatureInstantiation(candidate, typeArgumentTypes, ts2.isInJSFile(candidate.declaration), inferenceContext && inferenceContext.inferredTypeParameters);
                if (getNonArrayRestType(candidate) && !hasCorrectArity(node, args, checkCandidate, signatureHelpTrailingComma2)) {
                  candidateForArgumentArityError = checkCandidate;
                  continue;
                }
              } else {
                checkCandidate = candidate;
              }
              if (getSignatureApplicabilityError(node, args, checkCandidate, relation, argCheckMode, false, void 0)) {
                (candidatesForArgumentError || (candidatesForArgumentError = [])).push(checkCandidate);
                continue;
              }
              if (argCheckMode) {
                argCheckMode = 0;
                if (inferenceContext) {
                  var typeArgumentTypes = inferTypeArguments(node, candidate, args, argCheckMode, inferenceContext);
                  checkCandidate = getSignatureInstantiation(candidate, typeArgumentTypes, ts2.isInJSFile(candidate.declaration), inferenceContext && inferenceContext.inferredTypeParameters);
                  if (getNonArrayRestType(candidate) && !hasCorrectArity(node, args, checkCandidate, signatureHelpTrailingComma2)) {
                    candidateForArgumentArityError = checkCandidate;
                    continue;
                  }
                }
                if (getSignatureApplicabilityError(node, args, checkCandidate, relation, argCheckMode, false, void 0)) {
                  (candidatesForArgumentError || (candidatesForArgumentError = [])).push(checkCandidate);
                  continue;
                }
              }
              candidates2[candidateIndex] = checkCandidate;
              return checkCandidate;
            }
            return void 0;
          }
        }
        function getCandidateForOverloadFailure(node, candidates, args, hasCandidatesOutArray) {
          ts2.Debug.assert(candidates.length > 0);
          checkNodeDeferred(node);
          return hasCandidatesOutArray || candidates.length === 1 || candidates.some(function(c) {
            return !!c.typeParameters;
          }) ? pickLongestCandidateSignature(node, candidates, args) : createUnionOfSignaturesForOverloadFailure(candidates);
        }
        function createUnionOfSignaturesForOverloadFailure(candidates) {
          var thisParameters = ts2.mapDefined(candidates, function(c) {
            return c.thisParameter;
          });
          var thisParameter;
          if (thisParameters.length) {
            thisParameter = createCombinedSymbolFromTypes(thisParameters, thisParameters.map(getTypeOfParameter));
          }
          var _a = ts2.minAndMax(candidates, getNumNonRestParameters), minArgumentCount = _a.min, maxNonRestParam = _a.max;
          var parameters = [];
          var _loop_18 = function(i2) {
            var symbols = ts2.mapDefined(candidates, function(s) {
              return signatureHasRestParameter(s) ? i2 < s.parameters.length - 1 ? s.parameters[i2] : ts2.last(s.parameters) : i2 < s.parameters.length ? s.parameters[i2] : void 0;
            });
            ts2.Debug.assert(symbols.length !== 0);
            parameters.push(createCombinedSymbolFromTypes(symbols, ts2.mapDefined(candidates, function(candidate) {
              return tryGetTypeAtPosition(candidate, i2);
            })));
          };
          for (var i = 0; i < maxNonRestParam; i++) {
            _loop_18(i);
          }
          var restParameterSymbols = ts2.mapDefined(candidates, function(c) {
            return signatureHasRestParameter(c) ? ts2.last(c.parameters) : void 0;
          });
          var flags = 0;
          if (restParameterSymbols.length !== 0) {
            var type = createArrayType(getUnionType(ts2.mapDefined(candidates, tryGetRestTypeOfSignature), 2));
            parameters.push(createCombinedSymbolForOverloadFailure(restParameterSymbols, type));
            flags |= 1;
          }
          if (candidates.some(signatureHasLiteralTypes)) {
            flags |= 2;
          }
          return createSignature(candidates[0].declaration, void 0, thisParameter, parameters, getIntersectionType(candidates.map(getReturnTypeOfSignature)), void 0, minArgumentCount, flags);
        }
        function getNumNonRestParameters(signature) {
          var numParams = signature.parameters.length;
          return signatureHasRestParameter(signature) ? numParams - 1 : numParams;
        }
        function createCombinedSymbolFromTypes(sources, types) {
          return createCombinedSymbolForOverloadFailure(sources, getUnionType(types, 2));
        }
        function createCombinedSymbolForOverloadFailure(sources, type) {
          return createSymbolWithType(ts2.first(sources), type);
        }
        function pickLongestCandidateSignature(node, candidates, args) {
          var bestIndex = getLongestCandidateIndex(candidates, apparentArgumentCount === void 0 ? args.length : apparentArgumentCount);
          var candidate = candidates[bestIndex];
          var typeParameters = candidate.typeParameters;
          if (!typeParameters) {
            return candidate;
          }
          var typeArgumentNodes = callLikeExpressionMayHaveTypeArguments(node) ? node.typeArguments : void 0;
          var instantiated = typeArgumentNodes ? createSignatureInstantiation(candidate, getTypeArgumentsFromNodes(typeArgumentNodes, typeParameters, ts2.isInJSFile(node))) : inferSignatureInstantiationForOverloadFailure(node, typeParameters, candidate, args);
          candidates[bestIndex] = instantiated;
          return instantiated;
        }
        function getTypeArgumentsFromNodes(typeArgumentNodes, typeParameters, isJs) {
          var typeArguments = typeArgumentNodes.map(getTypeOfNode);
          while (typeArguments.length > typeParameters.length) {
            typeArguments.pop();
          }
          while (typeArguments.length < typeParameters.length) {
            typeArguments.push(getConstraintOfTypeParameter(typeParameters[typeArguments.length]) || getDefaultTypeArgumentType(isJs));
          }
          return typeArguments;
        }
        function inferSignatureInstantiationForOverloadFailure(node, typeParameters, candidate, args) {
          var inferenceContext = createInferenceContext(typeParameters, candidate, ts2.isInJSFile(node) ? 2 : 0);
          var typeArgumentTypes = inferTypeArguments(node, candidate, args, 4 | 8, inferenceContext);
          return createSignatureInstantiation(candidate, typeArgumentTypes);
        }
        function getLongestCandidateIndex(candidates, argsCount) {
          var maxParamsIndex = -1;
          var maxParams = -1;
          for (var i = 0; i < candidates.length; i++) {
            var candidate = candidates[i];
            var paramCount = getParameterCount(candidate);
            if (hasEffectiveRestParameter(candidate) || paramCount >= argsCount) {
              return i;
            }
            if (paramCount > maxParams) {
              maxParams = paramCount;
              maxParamsIndex = i;
            }
          }
          return maxParamsIndex;
        }
        function resolveCallExpression(node, candidatesOutArray, checkMode) {
          if (node.expression.kind === 102) {
            var superType = checkSuperExpression(node.expression);
            if (isTypeAny(superType)) {
              for (var _i = 0, _a = node.arguments; _i < _a.length; _i++) {
                var arg = _a[_i];
                checkExpression(arg);
              }
              return anySignature;
            }
            if (superType !== errorType) {
              var baseTypeNode = ts2.getEffectiveBaseTypeNode(ts2.getContainingClass(node));
              if (baseTypeNode) {
                var baseConstructors = getInstantiatedConstructorsForTypeArguments(superType, baseTypeNode.typeArguments, baseTypeNode);
                return resolveCall(node, baseConstructors, candidatesOutArray, checkMode, 0);
              }
            }
            return resolveUntypedCall(node);
          }
          var callChainFlags;
          var funcType = checkExpression(node.expression);
          if (ts2.isCallChain(node)) {
            var nonOptionalType = getOptionalExpressionType(funcType, node.expression);
            callChainFlags = nonOptionalType === funcType ? 0 : ts2.isOutermostOptionalChain(node) ? 8 : 4;
            funcType = nonOptionalType;
          } else {
            callChainFlags = 0;
          }
          funcType = checkNonNullTypeWithReporter(funcType, node.expression, reportCannotInvokePossiblyNullOrUndefinedError);
          if (funcType === silentNeverType) {
            return silentNeverSignature;
          }
          var apparentType = getApparentType(funcType);
          if (apparentType === errorType) {
            return resolveErrorCall(node);
          }
          var callSignatures = getSignaturesOfType(apparentType, 0);
          var numConstructSignatures = getSignaturesOfType(apparentType, 1).length;
          if (isUntypedFunctionCall(funcType, apparentType, callSignatures.length, numConstructSignatures)) {
            if (funcType !== errorType && node.typeArguments) {
              error(node, ts2.Diagnostics.Untyped_function_calls_may_not_accept_type_arguments);
            }
            return resolveUntypedCall(node);
          }
          if (!callSignatures.length) {
            if (numConstructSignatures) {
              error(node, ts2.Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new, typeToString(funcType));
            } else {
              var relatedInformation = void 0;
              if (node.arguments.length === 1) {
                var text = ts2.getSourceFileOfNode(node).text;
                if (ts2.isLineBreak(text.charCodeAt(ts2.skipTrivia(text, node.expression.end, true) - 1))) {
                  relatedInformation = ts2.createDiagnosticForNode(node.expression, ts2.Diagnostics.Are_you_missing_a_semicolon);
                }
              }
              invocationError(node.expression, apparentType, 0, relatedInformation);
            }
            return resolveErrorCall(node);
          }
          if (checkMode & 8 && !node.typeArguments && callSignatures.some(isGenericFunctionReturningFunction)) {
            skippedGenericFunction(node, checkMode);
            return resolvingSignature;
          }
          if (callSignatures.some(function(sig) {
            return ts2.isInJSFile(sig.declaration) && !!ts2.getJSDocClassTag(sig.declaration);
          })) {
            error(node, ts2.Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new, typeToString(funcType));
            return resolveErrorCall(node);
          }
          return resolveCall(node, callSignatures, candidatesOutArray, checkMode, callChainFlags);
        }
        function isGenericFunctionReturningFunction(signature) {
          return !!(signature.typeParameters && isFunctionType(getReturnTypeOfSignature(signature)));
        }
        function isUntypedFunctionCall(funcType, apparentFuncType, numCallSignatures, numConstructSignatures) {
          return isTypeAny(funcType) || isTypeAny(apparentFuncType) && !!(funcType.flags & 262144) || !numCallSignatures && !numConstructSignatures && !(apparentFuncType.flags & (1048576 | 131072)) && isTypeAssignableTo(funcType, globalFunctionType);
        }
        function resolveNewExpression(node, candidatesOutArray, checkMode) {
          if (node.arguments && languageVersion < 1) {
            var spreadIndex = getSpreadArgumentIndex(node.arguments);
            if (spreadIndex >= 0) {
              error(node.arguments[spreadIndex], ts2.Diagnostics.Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher);
            }
          }
          var expressionType = checkNonNullExpression(node.expression);
          if (expressionType === silentNeverType) {
            return silentNeverSignature;
          }
          expressionType = getApparentType(expressionType);
          if (expressionType === errorType) {
            return resolveErrorCall(node);
          }
          if (isTypeAny(expressionType)) {
            if (node.typeArguments) {
              error(node, ts2.Diagnostics.Untyped_function_calls_may_not_accept_type_arguments);
            }
            return resolveUntypedCall(node);
          }
          var constructSignatures = getSignaturesOfType(expressionType, 1);
          if (constructSignatures.length) {
            if (!isConstructorAccessible(node, constructSignatures[0])) {
              return resolveErrorCall(node);
            }
            var valueDecl = expressionType.symbol && ts2.getClassLikeDeclarationOfSymbol(expressionType.symbol);
            if (valueDecl && ts2.hasModifier(valueDecl, 128)) {
              error(node, ts2.Diagnostics.Cannot_create_an_instance_of_an_abstract_class);
              return resolveErrorCall(node);
            }
            return resolveCall(node, constructSignatures, candidatesOutArray, checkMode, 0);
          }
          var callSignatures = getSignaturesOfType(expressionType, 0);
          if (callSignatures.length) {
            var signature = resolveCall(node, callSignatures, candidatesOutArray, checkMode, 0);
            if (!noImplicitAny) {
              if (signature.declaration && !isJSConstructor(signature.declaration) && getReturnTypeOfSignature(signature) !== voidType) {
                error(node, ts2.Diagnostics.Only_a_void_function_can_be_called_with_the_new_keyword);
              }
              if (getThisTypeOfSignature(signature) === voidType) {
                error(node, ts2.Diagnostics.A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void);
              }
            }
            return signature;
          }
          invocationError(node.expression, expressionType, 1);
          return resolveErrorCall(node);
        }
        function typeHasProtectedAccessibleBase(target, type) {
          var baseTypes = getBaseTypes(type);
          if (!ts2.length(baseTypes)) {
            return false;
          }
          var firstBase = baseTypes[0];
          if (firstBase.flags & 2097152) {
            var types = firstBase.types;
            var mixinFlags = findMixins(types);
            var i = 0;
            for (var _i = 0, _a = firstBase.types; _i < _a.length; _i++) {
              var intersectionMember = _a[_i];
              if (!mixinFlags[i]) {
                if (ts2.getObjectFlags(intersectionMember) & (1 | 2)) {
                  if (intersectionMember.symbol === target) {
                    return true;
                  }
                  if (typeHasProtectedAccessibleBase(target, intersectionMember)) {
                    return true;
                  }
                }
              }
              i++;
            }
            return false;
          }
          if (firstBase.symbol === target) {
            return true;
          }
          return typeHasProtectedAccessibleBase(target, firstBase);
        }
        function isConstructorAccessible(node, signature) {
          if (!signature || !signature.declaration) {
            return true;
          }
          var declaration = signature.declaration;
          var modifiers = ts2.getSelectedModifierFlags(declaration, 24);
          if (!modifiers || declaration.kind !== 162) {
            return true;
          }
          var declaringClassDeclaration = ts2.getClassLikeDeclarationOfSymbol(declaration.parent.symbol);
          var declaringClass = getDeclaredTypeOfSymbol(declaration.parent.symbol);
          if (!isNodeWithinClass(node, declaringClassDeclaration)) {
            var containingClass = ts2.getContainingClass(node);
            if (containingClass && modifiers & 16) {
              var containingType = getTypeOfNode(containingClass);
              if (typeHasProtectedAccessibleBase(declaration.parent.symbol, containingType)) {
                return true;
              }
            }
            if (modifiers & 8) {
              error(node, ts2.Diagnostics.Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration, typeToString(declaringClass));
            }
            if (modifiers & 16) {
              error(node, ts2.Diagnostics.Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration, typeToString(declaringClass));
            }
            return false;
          }
          return true;
        }
        function invocationErrorDetails(apparentType, kind) {
          var errorInfo;
          var isCall = kind === 0;
          var awaitedType = getAwaitedType(apparentType);
          var maybeMissingAwait = awaitedType && getSignaturesOfType(awaitedType, kind).length > 0;
          if (apparentType.flags & 1048576) {
            var types = apparentType.types;
            var hasSignatures = false;
            for (var _i = 0, types_18 = types; _i < types_18.length; _i++) {
              var constituent = types_18[_i];
              var signatures = getSignaturesOfType(constituent, kind);
              if (signatures.length !== 0) {
                hasSignatures = true;
                if (errorInfo) {
                  break;
                }
              } else {
                if (!errorInfo) {
                  errorInfo = ts2.chainDiagnosticMessages(errorInfo, isCall ? ts2.Diagnostics.Type_0_has_no_call_signatures : ts2.Diagnostics.Type_0_has_no_construct_signatures, typeToString(constituent));
                  errorInfo = ts2.chainDiagnosticMessages(errorInfo, isCall ? ts2.Diagnostics.Not_all_constituents_of_type_0_are_callable : ts2.Diagnostics.Not_all_constituents_of_type_0_are_constructable, typeToString(apparentType));
                }
                if (hasSignatures) {
                  break;
                }
              }
            }
            if (!hasSignatures) {
              errorInfo = ts2.chainDiagnosticMessages(void 0, isCall ? ts2.Diagnostics.No_constituent_of_type_0_is_callable : ts2.Diagnostics.No_constituent_of_type_0_is_constructable, typeToString(apparentType));
            }
            if (!errorInfo) {
              errorInfo = ts2.chainDiagnosticMessages(errorInfo, isCall ? ts2.Diagnostics.Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_other : ts2.Diagnostics.Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_with_each_other, typeToString(apparentType));
            }
          } else {
            errorInfo = ts2.chainDiagnosticMessages(errorInfo, isCall ? ts2.Diagnostics.Type_0_has_no_call_signatures : ts2.Diagnostics.Type_0_has_no_construct_signatures, typeToString(apparentType));
          }
          return {
            messageChain: ts2.chainDiagnosticMessages(errorInfo, isCall ? ts2.Diagnostics.This_expression_is_not_callable : ts2.Diagnostics.This_expression_is_not_constructable),
            relatedMessage: maybeMissingAwait ? ts2.Diagnostics.Did_you_forget_to_use_await : void 0
          };
        }
        function invocationError(errorTarget, apparentType, kind, relatedInformation) {
          var _a = invocationErrorDetails(apparentType, kind), messageChain = _a.messageChain, relatedInfo = _a.relatedMessage;
          var diagnostic = ts2.createDiagnosticForNodeFromMessageChain(errorTarget, messageChain);
          if (relatedInfo) {
            ts2.addRelatedInfo(diagnostic, ts2.createDiagnosticForNode(errorTarget, relatedInfo));
          }
          if (ts2.isCallExpression(errorTarget.parent)) {
            var _b = getDiagnosticSpanForCallNode(errorTarget.parent, true), start = _b.start, length_7 = _b.length;
            diagnostic.start = start;
            diagnostic.length = length_7;
          }
          diagnostics.add(diagnostic);
          invocationErrorRecovery(apparentType, kind, relatedInformation ? ts2.addRelatedInfo(diagnostic, relatedInformation) : diagnostic);
        }
        function invocationErrorRecovery(apparentType, kind, diagnostic) {
          if (!apparentType.symbol) {
            return;
          }
          var importNode = getSymbolLinks(apparentType.symbol).originatingImport;
          if (importNode && !ts2.isImportCall(importNode)) {
            var sigs = getSignaturesOfType(getTypeOfSymbol(getSymbolLinks(apparentType.symbol).target), kind);
            if (!sigs || !sigs.length)
              return;
            ts2.addRelatedInfo(diagnostic, ts2.createDiagnosticForNode(importNode, ts2.Diagnostics.Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead));
          }
        }
        function resolveTaggedTemplateExpression(node, candidatesOutArray, checkMode) {
          var tagType = checkExpression(node.tag);
          var apparentType = getApparentType(tagType);
          if (apparentType === errorType) {
            return resolveErrorCall(node);
          }
          var callSignatures = getSignaturesOfType(apparentType, 0);
          var numConstructSignatures = getSignaturesOfType(apparentType, 1).length;
          if (isUntypedFunctionCall(tagType, apparentType, callSignatures.length, numConstructSignatures)) {
            return resolveUntypedCall(node);
          }
          if (!callSignatures.length) {
            invocationError(node.tag, apparentType, 0);
            return resolveErrorCall(node);
          }
          return resolveCall(node, callSignatures, candidatesOutArray, checkMode, 0);
        }
        function getDiagnosticHeadMessageForDecoratorResolution(node) {
          switch (node.parent.kind) {
            case 245:
            case 214:
              return ts2.Diagnostics.Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression;
            case 156:
              return ts2.Diagnostics.Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression;
            case 159:
              return ts2.Diagnostics.Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression;
            case 161:
            case 163:
            case 164:
              return ts2.Diagnostics.Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression;
            default:
              return ts2.Debug.fail();
          }
        }
        function resolveDecorator(node, candidatesOutArray, checkMode) {
          var funcType = checkExpression(node.expression);
          var apparentType = getApparentType(funcType);
          if (apparentType === errorType) {
            return resolveErrorCall(node);
          }
          var callSignatures = getSignaturesOfType(apparentType, 0);
          var numConstructSignatures = getSignaturesOfType(apparentType, 1).length;
          if (isUntypedFunctionCall(funcType, apparentType, callSignatures.length, numConstructSignatures)) {
            return resolveUntypedCall(node);
          }
          if (isPotentiallyUncalledDecorator(node, callSignatures)) {
            var nodeStr = ts2.getTextOfNode(node.expression, false);
            error(node, ts2.Diagnostics._0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0, nodeStr);
            return resolveErrorCall(node);
          }
          var headMessage = getDiagnosticHeadMessageForDecoratorResolution(node);
          if (!callSignatures.length) {
            var errorDetails = invocationErrorDetails(apparentType, 0);
            var messageChain = ts2.chainDiagnosticMessages(errorDetails.messageChain, headMessage);
            var diag = ts2.createDiagnosticForNodeFromMessageChain(node.expression, messageChain);
            if (errorDetails.relatedMessage) {
              ts2.addRelatedInfo(diag, ts2.createDiagnosticForNode(node.expression, errorDetails.relatedMessage));
            }
            diagnostics.add(diag);
            invocationErrorRecovery(apparentType, 0, diag);
            return resolveErrorCall(node);
          }
          return resolveCall(node, callSignatures, candidatesOutArray, checkMode, 0, headMessage);
        }
        function createSignatureForJSXIntrinsic(node, result) {
          var namespace = getJsxNamespaceAt(node);
          var exports2 = namespace && getExportsOfSymbol(namespace);
          var typeSymbol = exports2 && getSymbol(exports2, JsxNames.Element, 788968);
          var returnNode = typeSymbol && nodeBuilder.symbolToEntityName(typeSymbol, 788968, node);
          var declaration = ts2.createFunctionTypeNode(void 0, [ts2.createParameter(void 0, void 0, void 0, "props", void 0, nodeBuilder.typeToTypeNode(result, node))], returnNode ? ts2.createTypeReferenceNode(returnNode, void 0) : ts2.createKeywordTypeNode(125));
          var parameterSymbol = createSymbol(1, "props");
          parameterSymbol.type = result;
          return createSignature(declaration, void 0, void 0, [parameterSymbol], typeSymbol ? getDeclaredTypeOfSymbol(typeSymbol) : errorType, void 0, 1, 0);
        }
        function resolveJsxOpeningLikeElement(node, candidatesOutArray, checkMode) {
          if (isJsxIntrinsicIdentifier(node.tagName)) {
            var result = getIntrinsicAttributesTypeFromJsxOpeningLikeElement(node);
            var fakeSignature = createSignatureForJSXIntrinsic(node, result);
            checkTypeAssignableToAndOptionallyElaborate(checkExpressionWithContextualType(node.attributes, getEffectiveFirstArgumentForJsxSignature(fakeSignature, node), void 0, 0), result, node.tagName, node.attributes);
            return fakeSignature;
          }
          var exprTypes = checkExpression(node.tagName);
          var apparentType = getApparentType(exprTypes);
          if (apparentType === errorType) {
            return resolveErrorCall(node);
          }
          var signatures = getUninstantiatedJsxSignaturesOfType(exprTypes, node);
          if (isUntypedFunctionCall(exprTypes, apparentType, signatures.length, 0)) {
            return resolveUntypedCall(node);
          }
          if (signatures.length === 0) {
            error(node.tagName, ts2.Diagnostics.JSX_element_type_0_does_not_have_any_construct_or_call_signatures, ts2.getTextOfNode(node.tagName));
            return resolveErrorCall(node);
          }
          return resolveCall(node, signatures, candidatesOutArray, checkMode, 0);
        }
        function isPotentiallyUncalledDecorator(decorator, signatures) {
          return signatures.length && ts2.every(signatures, function(signature) {
            return signature.minArgumentCount === 0 && !signatureHasRestParameter(signature) && signature.parameters.length < getDecoratorArgumentCount(decorator, signature);
          });
        }
        function resolveSignature(node, candidatesOutArray, checkMode) {
          switch (node.kind) {
            case 196:
              return resolveCallExpression(node, candidatesOutArray, checkMode);
            case 197:
              return resolveNewExpression(node, candidatesOutArray, checkMode);
            case 198:
              return resolveTaggedTemplateExpression(node, candidatesOutArray, checkMode);
            case 157:
              return resolveDecorator(node, candidatesOutArray, checkMode);
            case 268:
            case 267:
              return resolveJsxOpeningLikeElement(node, candidatesOutArray, checkMode);
          }
          throw ts2.Debug.assertNever(node, "Branch in 'resolveSignature' should be unreachable.");
        }
        function getResolvedSignature(node, candidatesOutArray, checkMode) {
          var links = getNodeLinks(node);
          var cached = links.resolvedSignature;
          if (cached && cached !== resolvingSignature && !candidatesOutArray) {
            return cached;
          }
          links.resolvedSignature = resolvingSignature;
          var result = resolveSignature(node, candidatesOutArray, checkMode || 0);
          if (result !== resolvingSignature) {
            links.resolvedSignature = flowLoopStart === flowLoopCount ? result : cached;
          }
          return result;
        }
        function isJSConstructor(node) {
          if (!node || !ts2.isInJSFile(node)) {
            return false;
          }
          var func = ts2.isFunctionDeclaration(node) || ts2.isFunctionExpression(node) ? node : ts2.isVariableDeclaration(node) && node.initializer && ts2.isFunctionExpression(node.initializer) ? node.initializer : void 0;
          if (func) {
            if (ts2.getJSDocClassTag(node))
              return true;
            var symbol = getSymbolOfNode(func);
            return !!symbol && ts2.hasEntries(symbol.members);
          }
          return false;
        }
        function mergeJSSymbols(target, source) {
          if (source) {
            var links = getSymbolLinks(source);
            if (!links.inferredClassSymbol || !links.inferredClassSymbol.has("" + getSymbolId(target))) {
              var inferred = ts2.isTransientSymbol(target) ? target : cloneSymbol(target);
              inferred.exports = inferred.exports || ts2.createSymbolTable();
              inferred.members = inferred.members || ts2.createSymbolTable();
              inferred.flags |= source.flags & 32;
              if (ts2.hasEntries(source.exports)) {
                mergeSymbolTable(inferred.exports, source.exports);
              }
              if (ts2.hasEntries(source.members)) {
                mergeSymbolTable(inferred.members, source.members);
              }
              (links.inferredClassSymbol || (links.inferredClassSymbol = ts2.createMap())).set("" + getSymbolId(inferred), inferred);
              return inferred;
            }
            return links.inferredClassSymbol.get("" + getSymbolId(target));
          }
        }
        function getAssignedClassSymbol(decl) {
          var assignmentSymbol = decl && decl.parent && (ts2.isFunctionDeclaration(decl) && getSymbolOfNode(decl) || ts2.isBinaryExpression(decl.parent) && getSymbolOfNode(decl.parent.left) || ts2.isVariableDeclaration(decl.parent) && getSymbolOfNode(decl.parent));
          var prototype = assignmentSymbol && assignmentSymbol.exports && assignmentSymbol.exports.get("prototype");
          var init = prototype && prototype.valueDeclaration && getAssignedJSPrototype(prototype.valueDeclaration);
          return init ? getSymbolOfNode(init) : void 0;
        }
        function getAssignedJSPrototype(node) {
          if (!node.parent) {
            return false;
          }
          var parent = node.parent;
          while (parent && parent.kind === 194) {
            parent = parent.parent;
          }
          if (parent && ts2.isBinaryExpression(parent) && ts2.isPrototypeAccess(parent.left) && parent.operatorToken.kind === 62) {
            var right = ts2.getInitializerOfBinaryExpression(parent);
            return ts2.isObjectLiteralExpression(right) && right;
          }
        }
        function checkCallExpression(node, checkMode) {
          if (!checkGrammarTypeArguments(node, node.typeArguments))
            checkGrammarArguments(node.arguments);
          var signature = getResolvedSignature(node, void 0, checkMode);
          if (signature === resolvingSignature) {
            return nonInferrableType;
          }
          if (node.expression.kind === 102) {
            return voidType;
          }
          if (node.kind === 197) {
            var declaration = signature.declaration;
            if (declaration && declaration.kind !== 162 && declaration.kind !== 166 && declaration.kind !== 171 && !ts2.isJSDocConstructSignature(declaration) && !isJSConstructor(declaration)) {
              if (noImplicitAny) {
                error(node, ts2.Diagnostics.new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type);
              }
              return anyType;
            }
          }
          if (ts2.isInJSFile(node) && isCommonJsRequire(node)) {
            return resolveExternalModuleTypeByLiteral(node.arguments[0]);
          }
          var returnType = getReturnTypeOfSignature(signature);
          if (returnType.flags & 12288 && isSymbolOrSymbolForCall(node)) {
            return getESSymbolLikeTypeForNode(ts2.walkUpParenthesizedExpressions(node.parent));
          }
          if (node.kind === 196 && node.parent.kind === 226 && returnType.flags & 16384 && getTypePredicateOfSignature(signature)) {
            if (!ts2.isDottedName(node.expression)) {
              error(node.expression, ts2.Diagnostics.Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name);
            } else if (!getEffectsSignature(node)) {
              var diagnostic = error(node.expression, ts2.Diagnostics.Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation);
              getTypeOfDottedName(node.expression, diagnostic);
            }
          }
          if (ts2.isInJSFile(node)) {
            var decl = ts2.getDeclarationOfExpando(node);
            if (decl) {
              var jsSymbol = getSymbolOfNode(decl);
              if (jsSymbol && ts2.hasEntries(jsSymbol.exports)) {
                var jsAssignmentType = createAnonymousType(jsSymbol, jsSymbol.exports, ts2.emptyArray, ts2.emptyArray, void 0, void 0);
                jsAssignmentType.objectFlags |= 16384;
                return getIntersectionType([returnType, jsAssignmentType]);
              }
            }
          }
          return returnType;
        }
        function isSymbolOrSymbolForCall(node) {
          if (!ts2.isCallExpression(node))
            return false;
          var left = node.expression;
          if (ts2.isPropertyAccessExpression(left) && left.name.escapedText === "for") {
            left = left.expression;
          }
          if (!ts2.isIdentifier(left) || left.escapedText !== "Symbol") {
            return false;
          }
          var globalESSymbol = getGlobalESSymbolConstructorSymbol(false);
          if (!globalESSymbol) {
            return false;
          }
          return globalESSymbol === resolveName(left, "Symbol", 111551, void 0, void 0, false);
        }
        function checkImportCallExpression(node) {
          if (!checkGrammarArguments(node.arguments))
            checkGrammarImportCallExpression(node);
          if (node.arguments.length === 0) {
            return createPromiseReturnType(node, anyType);
          }
          var specifier = node.arguments[0];
          var specifierType = checkExpressionCached(specifier);
          for (var i = 1; i < node.arguments.length; ++i) {
            checkExpressionCached(node.arguments[i]);
          }
          if (specifierType.flags & 32768 || specifierType.flags & 65536 || !isTypeAssignableTo(specifierType, stringType)) {
            error(specifier, ts2.Diagnostics.Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0, typeToString(specifierType));
          }
          var moduleSymbol = resolveExternalModuleName(node, specifier);
          if (moduleSymbol) {
            var esModuleSymbol = resolveESModuleSymbol(moduleSymbol, specifier, true, false);
            if (esModuleSymbol) {
              return createPromiseReturnType(node, getTypeWithSyntheticDefaultImportType(getTypeOfSymbol(esModuleSymbol), esModuleSymbol, moduleSymbol));
            }
          }
          return createPromiseReturnType(node, anyType);
        }
        function getTypeWithSyntheticDefaultImportType(type, symbol, originalSymbol) {
          if (allowSyntheticDefaultImports && type && type !== errorType) {
            var synthType = type;
            if (!synthType.syntheticType) {
              var file = ts2.find(originalSymbol.declarations, ts2.isSourceFile);
              var hasSyntheticDefault = canHaveSyntheticDefault(file, originalSymbol, false);
              if (hasSyntheticDefault) {
                var memberTable = ts2.createSymbolTable();
                var newSymbol = createSymbol(2097152, "default");
                newSymbol.nameType = getLiteralType("default");
                newSymbol.target = resolveSymbol(symbol);
                memberTable.set("default", newSymbol);
                var anonymousSymbol = createSymbol(2048, "__type");
                var defaultContainingObject = createAnonymousType(anonymousSymbol, memberTable, ts2.emptyArray, ts2.emptyArray, void 0, void 0);
                anonymousSymbol.type = defaultContainingObject;
                synthType.syntheticType = isValidSpreadType(type) ? getSpreadType(type, defaultContainingObject, anonymousSymbol, 0, false) : defaultContainingObject;
              } else {
                synthType.syntheticType = type;
              }
            }
            return synthType.syntheticType;
          }
          return type;
        }
        function isCommonJsRequire(node) {
          if (!ts2.isRequireCall(node, true)) {
            return false;
          }
          if (!ts2.isIdentifier(node.expression))
            return ts2.Debug.fail();
          var resolvedRequire = resolveName(node.expression, node.expression.escapedText, 111551, void 0, void 0, true);
          if (resolvedRequire === requireSymbol) {
            return true;
          }
          if (resolvedRequire.flags & 2097152) {
            return false;
          }
          var targetDeclarationKind = resolvedRequire.flags & 16 ? 244 : resolvedRequire.flags & 3 ? 242 : 0;
          if (targetDeclarationKind !== 0) {
            var decl = ts2.getDeclarationOfKind(resolvedRequire, targetDeclarationKind);
            return !!decl && !!(decl.flags & 8388608);
          }
          return false;
        }
        function checkTaggedTemplateExpression(node) {
          if (!checkGrammarTaggedTemplateChain(node))
            checkGrammarTypeArguments(node, node.typeArguments);
          if (languageVersion < 2) {
            checkExternalEmitHelpers(node, 131072);
          }
          return getReturnTypeOfSignature(getResolvedSignature(node));
        }
        function checkAssertion(node) {
          return checkAssertionWorker(node, node.type, node.expression);
        }
        function isValidConstAssertionArgument(node) {
          switch (node.kind) {
            case 10:
            case 14:
            case 8:
            case 9:
            case 106:
            case 91:
            case 192:
            case 193:
              return true;
            case 200:
              return isValidConstAssertionArgument(node.expression);
            case 207:
              var op = node.operator;
              var arg = node.operand;
              return op === 40 && (arg.kind === 8 || arg.kind === 9) || op === 39 && arg.kind === 8;
            case 194:
            case 195:
              var expr = node.expression;
              if (ts2.isIdentifier(expr)) {
                var symbol = getSymbolAtLocation(expr);
                if (symbol && symbol.flags & 2097152) {
                  symbol = resolveAlias(symbol);
                }
                return !!(symbol && symbol.flags & 384 && getEnumKind(symbol) === 1);
              }
          }
          return false;
        }
        function checkAssertionWorker(errNode, type, expression, checkMode) {
          var exprType = checkExpression(expression, checkMode);
          if (ts2.isConstTypeReference(type)) {
            if (!isValidConstAssertionArgument(expression)) {
              error(expression, ts2.Diagnostics.A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array_or_object_literals);
            }
            return getRegularTypeOfLiteralType(exprType);
          }
          checkSourceElement(type);
          exprType = getRegularTypeOfObjectLiteral(getBaseTypeOfLiteralType(exprType));
          var targetType = getTypeFromTypeNode(type);
          if (produceDiagnostics && targetType !== errorType) {
            var widenedType = getWidenedType(exprType);
            if (!isTypeComparableTo(targetType, widenedType)) {
              checkTypeComparableTo(exprType, targetType, errNode, ts2.Diagnostics.Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first);
            }
          }
          return targetType;
        }
        function checkNonNullChain(node) {
          var leftType = checkExpression(node.expression);
          var nonOptionalType = getOptionalExpressionType(leftType, node.expression);
          return propagateOptionalTypeMarker(getNonNullableType(nonOptionalType), node, nonOptionalType !== leftType);
        }
        function checkNonNullAssertion(node) {
          return node.flags & 32 ? checkNonNullChain(node) : getNonNullableType(checkExpression(node.expression));
        }
        function checkMetaProperty(node) {
          checkGrammarMetaProperty(node);
          if (node.keywordToken === 99) {
            return checkNewTargetMetaProperty(node);
          }
          if (node.keywordToken === 96) {
            return checkImportMetaProperty(node);
          }
          return ts2.Debug.assertNever(node.keywordToken);
        }
        function checkNewTargetMetaProperty(node) {
          var container = ts2.getNewTargetContainer(node);
          if (!container) {
            error(node, ts2.Diagnostics.Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constructor, "new.target");
            return errorType;
          } else if (container.kind === 162) {
            var symbol = getSymbolOfNode(container.parent);
            return getTypeOfSymbol(symbol);
          } else {
            var symbol = getSymbolOfNode(container);
            return getTypeOfSymbol(symbol);
          }
        }
        function checkImportMetaProperty(node) {
          if (moduleKind !== ts2.ModuleKind.ESNext && moduleKind !== ts2.ModuleKind.System) {
            error(node, ts2.Diagnostics.The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_esnext_or_system);
          }
          var file = ts2.getSourceFileOfNode(node);
          ts2.Debug.assert(!!(file.flags & 2097152), "Containing file is missing import meta node flag.");
          ts2.Debug.assert(!!file.externalModuleIndicator, "Containing file should be a module.");
          return node.name.escapedText === "meta" ? getGlobalImportMetaType() : errorType;
        }
        function getTypeOfParameter(symbol) {
          var type = getTypeOfSymbol(symbol);
          if (strictNullChecks) {
            var declaration = symbol.valueDeclaration;
            if (declaration && ts2.hasInitializer(declaration)) {
              return getOptionalType(type);
            }
          }
          return type;
        }
        function getParameterNameAtPosition(signature, pos) {
          var paramCount = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
          if (pos < paramCount) {
            return signature.parameters[pos].escapedName;
          }
          var restParameter = signature.parameters[paramCount] || unknownSymbol;
          var restType = getTypeOfSymbol(restParameter);
          if (isTupleType(restType)) {
            var associatedNames = restType.target.associatedNames;
            var index = pos - paramCount;
            return associatedNames && associatedNames[index] || restParameter.escapedName + "_" + index;
          }
          return restParameter.escapedName;
        }
        function getTypeAtPosition(signature, pos) {
          return tryGetTypeAtPosition(signature, pos) || anyType;
        }
        function tryGetTypeAtPosition(signature, pos) {
          var paramCount = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
          if (pos < paramCount) {
            return getTypeOfParameter(signature.parameters[pos]);
          }
          if (signatureHasRestParameter(signature)) {
            var restType = getTypeOfSymbol(signature.parameters[paramCount]);
            var index = pos - paramCount;
            if (!isTupleType(restType) || restType.target.hasRestElement || index < getTypeArguments(restType).length) {
              return getIndexedAccessType(restType, getLiteralType(index));
            }
          }
          return void 0;
        }
        function getRestTypeAtPosition(source, pos) {
          var paramCount = getParameterCount(source);
          var restType = getEffectiveRestType(source);
          var nonRestCount = paramCount - (restType ? 1 : 0);
          if (restType && pos === nonRestCount) {
            return restType;
          }
          var types = [];
          var names = [];
          for (var i = pos; i < nonRestCount; i++) {
            types.push(getTypeAtPosition(source, i));
            names.push(getParameterNameAtPosition(source, i));
          }
          if (restType) {
            types.push(getIndexedAccessType(restType, numberType));
            names.push(getParameterNameAtPosition(source, nonRestCount));
          }
          var minArgumentCount = getMinArgumentCount(source);
          var minLength = minArgumentCount < pos ? 0 : minArgumentCount - pos;
          return createTupleType(types, minLength, !!restType, false, names);
        }
        function getParameterCount(signature) {
          var length = signature.parameters.length;
          if (signatureHasRestParameter(signature)) {
            var restType = getTypeOfSymbol(signature.parameters[length - 1]);
            if (isTupleType(restType)) {
              return length + getTypeArguments(restType).length - 1;
            }
          }
          return length;
        }
        function getMinArgumentCount(signature, strongArityForUntypedJS) {
          if (signatureHasRestParameter(signature)) {
            var restType = getTypeOfSymbol(signature.parameters[signature.parameters.length - 1]);
            if (isTupleType(restType)) {
              var minLength = restType.target.minLength;
              if (minLength > 0) {
                return signature.parameters.length - 1 + minLength;
              }
            }
          }
          if (!strongArityForUntypedJS && signature.flags & 16) {
            return 0;
          }
          return signature.minArgumentCount;
        }
        function hasEffectiveRestParameter(signature) {
          if (signatureHasRestParameter(signature)) {
            var restType = getTypeOfSymbol(signature.parameters[signature.parameters.length - 1]);
            return !isTupleType(restType) || restType.target.hasRestElement;
          }
          return false;
        }
        function getEffectiveRestType(signature) {
          if (signatureHasRestParameter(signature)) {
            var restType = getTypeOfSymbol(signature.parameters[signature.parameters.length - 1]);
            return isTupleType(restType) ? getRestArrayTypeOfTupleType(restType) : restType;
          }
          return void 0;
        }
        function getNonArrayRestType(signature) {
          var restType = getEffectiveRestType(signature);
          return restType && !isArrayType(restType) && !isTypeAny(restType) && (getReducedType(restType).flags & 131072) === 0 ? restType : void 0;
        }
        function getTypeOfFirstParameterOfSignature(signature) {
          return getTypeOfFirstParameterOfSignatureWithFallback(signature, neverType);
        }
        function getTypeOfFirstParameterOfSignatureWithFallback(signature, fallbackType) {
          return signature.parameters.length > 0 ? getTypeAtPosition(signature, 0) : fallbackType;
        }
        function inferFromAnnotatedParameters(signature, context, inferenceContext) {
          var len = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
          for (var i = 0; i < len; i++) {
            var declaration = signature.parameters[i].valueDeclaration;
            if (declaration.type) {
              var typeNode = ts2.getEffectiveTypeAnnotationNode(declaration);
              if (typeNode) {
                inferTypes(inferenceContext.inferences, getTypeFromTypeNode(typeNode), getTypeAtPosition(context, i));
              }
            }
          }
          var restType = getEffectiveRestType(context);
          if (restType && restType.flags & 262144) {
            var instantiatedContext = instantiateSignature(context, inferenceContext.nonFixingMapper);
            assignContextualParameterTypes(signature, instantiatedContext);
            var restPos = getParameterCount(context) - 1;
            inferTypes(inferenceContext.inferences, getRestTypeAtPosition(signature, restPos), restType);
          }
        }
        function assignContextualParameterTypes(signature, context) {
          signature.typeParameters = context.typeParameters;
          if (context.thisParameter) {
            var parameter = signature.thisParameter;
            if (!parameter || parameter.valueDeclaration && !parameter.valueDeclaration.type) {
              if (!parameter) {
                signature.thisParameter = createSymbolWithType(context.thisParameter, void 0);
              }
              assignParameterType(signature.thisParameter, getTypeOfSymbol(context.thisParameter));
            }
          }
          var len = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
          for (var i = 0; i < len; i++) {
            var parameter = signature.parameters[i];
            if (!ts2.getEffectiveTypeAnnotationNode(parameter.valueDeclaration)) {
              var contextualParameterType = tryGetTypeAtPosition(context, i);
              assignParameterType(parameter, contextualParameterType);
            }
          }
          if (signatureHasRestParameter(signature)) {
            var parameter = ts2.last(signature.parameters);
            if (ts2.isTransientSymbol(parameter) || !ts2.getEffectiveTypeAnnotationNode(parameter.valueDeclaration)) {
              var contextualParameterType = getRestTypeAtPosition(context, len);
              assignParameterType(parameter, contextualParameterType);
            }
          }
        }
        function assignNonContextualParameterTypes(signature) {
          if (signature.thisParameter) {
            assignParameterType(signature.thisParameter);
          }
          for (var _i = 0, _a = signature.parameters; _i < _a.length; _i++) {
            var parameter = _a[_i];
            assignParameterType(parameter);
          }
        }
        function assignParameterType(parameter, type) {
          var links = getSymbolLinks(parameter);
          if (!links.type) {
            var declaration = parameter.valueDeclaration;
            links.type = type || getWidenedTypeForVariableLikeDeclaration(declaration, true);
            if (declaration.name.kind !== 75) {
              if (links.type === unknownType) {
                links.type = getTypeFromBindingPattern(declaration.name);
              }
              assignBindingElementTypes(declaration.name);
            }
          }
        }
        function assignBindingElementTypes(pattern) {
          for (var _i = 0, _a = pattern.elements; _i < _a.length; _i++) {
            var element = _a[_i];
            if (!ts2.isOmittedExpression(element)) {
              if (element.name.kind === 75) {
                getSymbolLinks(getSymbolOfNode(element)).type = getTypeForBindingElement(element);
              } else {
                assignBindingElementTypes(element.name);
              }
            }
          }
        }
        function createPromiseType(promisedType) {
          var globalPromiseType = getGlobalPromiseType(true);
          if (globalPromiseType !== emptyGenericType) {
            promisedType = getAwaitedType(promisedType) || unknownType;
            return createTypeReference(globalPromiseType, [promisedType]);
          }
          return unknownType;
        }
        function createPromiseLikeType(promisedType) {
          var globalPromiseLikeType = getGlobalPromiseLikeType(true);
          if (globalPromiseLikeType !== emptyGenericType) {
            promisedType = getAwaitedType(promisedType) || unknownType;
            return createTypeReference(globalPromiseLikeType, [promisedType]);
          }
          return unknownType;
        }
        function createPromiseReturnType(func, promisedType) {
          var promiseType = createPromiseType(promisedType);
          if (promiseType === unknownType) {
            error(func, ts2.isImportCall(func) ? ts2.Diagnostics.A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option : ts2.Diagnostics.An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option);
            return errorType;
          } else if (!getGlobalPromiseConstructorSymbol(true)) {
            error(func, ts2.isImportCall(func) ? ts2.Diagnostics.A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option : ts2.Diagnostics.An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option);
          }
          return promiseType;
        }
        function getReturnTypeFromBody(func, checkMode) {
          if (!func.body) {
            return errorType;
          }
          var functionFlags = ts2.getFunctionFlags(func);
          var isAsync = (functionFlags & 2) !== 0;
          var isGenerator = (functionFlags & 1) !== 0;
          var returnType;
          var yieldType;
          var nextType;
          var fallbackReturnType = voidType;
          if (func.body.kind !== 223) {
            returnType = checkExpressionCached(func.body, checkMode && checkMode & ~8);
            if (isAsync) {
              returnType = checkAwaitedType(returnType, func, ts2.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
            }
          } else if (isGenerator) {
            var returnTypes = checkAndAggregateReturnExpressionTypes(func, checkMode);
            if (!returnTypes) {
              fallbackReturnType = neverType;
            } else if (returnTypes.length > 0) {
              returnType = getUnionType(returnTypes, 2);
            }
            var _a = checkAndAggregateYieldOperandTypes(func, checkMode), yieldTypes = _a.yieldTypes, nextTypes = _a.nextTypes;
            yieldType = ts2.some(yieldTypes) ? getUnionType(yieldTypes, 2) : void 0;
            nextType = ts2.some(nextTypes) ? getIntersectionType(nextTypes) : void 0;
          } else {
            var types = checkAndAggregateReturnExpressionTypes(func, checkMode);
            if (!types) {
              return functionFlags & 2 ? createPromiseReturnType(func, neverType) : neverType;
            }
            if (types.length === 0) {
              return functionFlags & 2 ? createPromiseReturnType(func, voidType) : voidType;
            }
            returnType = getUnionType(types, 2);
          }
          if (returnType || yieldType || nextType) {
            if (yieldType)
              reportErrorsFromWidening(func, yieldType, 3);
            if (returnType)
              reportErrorsFromWidening(func, returnType, 1);
            if (nextType)
              reportErrorsFromWidening(func, nextType, 2);
            if (returnType && isUnitType(returnType) || yieldType && isUnitType(yieldType) || nextType && isUnitType(nextType)) {
              var contextualSignature = getContextualSignatureForFunctionLikeDeclaration(func);
              var contextualType = !contextualSignature ? void 0 : contextualSignature === getSignatureFromDeclaration(func) ? isGenerator ? void 0 : returnType : instantiateContextualType(getReturnTypeOfSignature(contextualSignature), func);
              if (isGenerator) {
                yieldType = getWidenedLiteralLikeTypeForContextualIterationTypeIfNeeded(yieldType, contextualType, 0, isAsync);
                returnType = getWidenedLiteralLikeTypeForContextualIterationTypeIfNeeded(returnType, contextualType, 1, isAsync);
                nextType = getWidenedLiteralLikeTypeForContextualIterationTypeIfNeeded(nextType, contextualType, 2, isAsync);
              } else {
                returnType = getWidenedLiteralLikeTypeForContextualReturnTypeIfNeeded(returnType, contextualType, isAsync);
              }
            }
            if (yieldType)
              yieldType = getWidenedType(yieldType);
            if (returnType)
              returnType = getWidenedType(returnType);
            if (nextType)
              nextType = getWidenedType(nextType);
          }
          if (isGenerator) {
            return createGeneratorReturnType(yieldType || neverType, returnType || fallbackReturnType, nextType || getContextualIterationType(2, func) || unknownType, isAsync);
          } else {
            return isAsync ? createPromiseType(returnType || fallbackReturnType) : returnType || fallbackReturnType;
          }
        }
        function createGeneratorReturnType(yieldType, returnType, nextType, isAsyncGenerator) {
          var resolver = isAsyncGenerator ? asyncIterationTypesResolver : syncIterationTypesResolver;
          var globalGeneratorType = resolver.getGlobalGeneratorType(false);
          yieldType = resolver.resolveIterationType(yieldType, void 0) || unknownType;
          returnType = resolver.resolveIterationType(returnType, void 0) || unknownType;
          nextType = resolver.resolveIterationType(nextType, void 0) || unknownType;
          if (globalGeneratorType === emptyGenericType) {
            var globalType = resolver.getGlobalIterableIteratorType(false);
            var iterationTypes = globalType !== emptyGenericType ? getIterationTypesOfGlobalIterableType(globalType, resolver) : void 0;
            var iterableIteratorReturnType = iterationTypes ? iterationTypes.returnType : anyType;
            var iterableIteratorNextType = iterationTypes ? iterationTypes.nextType : undefinedType;
            if (isTypeAssignableTo(returnType, iterableIteratorReturnType) && isTypeAssignableTo(iterableIteratorNextType, nextType)) {
              if (globalType !== emptyGenericType) {
                return createTypeFromGenericGlobalType(globalType, [yieldType]);
              }
              resolver.getGlobalIterableIteratorType(true);
              return emptyObjectType;
            }
            resolver.getGlobalGeneratorType(true);
            return emptyObjectType;
          }
          return createTypeFromGenericGlobalType(globalGeneratorType, [yieldType, returnType, nextType]);
        }
        function checkAndAggregateYieldOperandTypes(func, checkMode) {
          var yieldTypes = [];
          var nextTypes = [];
          var isAsync = (ts2.getFunctionFlags(func) & 2) !== 0;
          ts2.forEachYieldExpression(func.body, function(yieldExpression) {
            var yieldExpressionType = yieldExpression.expression ? checkExpression(yieldExpression.expression, checkMode) : undefinedWideningType;
            ts2.pushIfUnique(yieldTypes, getYieldedTypeOfYieldExpression(yieldExpression, yieldExpressionType, anyType, isAsync));
            var nextType;
            if (yieldExpression.asteriskToken) {
              var iterationTypes = getIterationTypesOfIterable(yieldExpressionType, isAsync ? 19 : 17, yieldExpression.expression);
              nextType = iterationTypes && iterationTypes.nextType;
            } else {
              nextType = getContextualType(yieldExpression);
            }
            if (nextType)
              ts2.pushIfUnique(nextTypes, nextType);
          });
          return { yieldTypes, nextTypes };
        }
        function getYieldedTypeOfYieldExpression(node, expressionType, sentType, isAsync) {
          var errorNode = node.expression || node;
          var yieldedType = node.asteriskToken ? checkIteratedTypeOrElementType(isAsync ? 19 : 17, expressionType, sentType, errorNode) : expressionType;
          return !isAsync ? yieldedType : getAwaitedType(yieldedType, errorNode, node.asteriskToken ? ts2.Diagnostics.Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member : ts2.Diagnostics.Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
        }
        function getFactsFromTypeofSwitch(start, end, witnesses, hasDefault) {
          var facts = 0;
          if (hasDefault) {
            for (var i = end; i < witnesses.length; i++) {
              facts |= typeofNEFacts.get(witnesses[i]) || 32768;
            }
            for (var i = start; i < end; i++) {
              facts &= ~(typeofNEFacts.get(witnesses[i]) || 0);
            }
            for (var i = 0; i < start; i++) {
              facts |= typeofNEFacts.get(witnesses[i]) || 32768;
            }
          } else {
            for (var i = start; i < end; i++) {
              facts |= typeofEQFacts.get(witnesses[i]) || 128;
            }
            for (var i = 0; i < start; i++) {
              facts &= ~(typeofEQFacts.get(witnesses[i]) || 0);
            }
          }
          return facts;
        }
        function isExhaustiveSwitchStatement(node) {
          var links = getNodeLinks(node);
          return links.isExhaustive !== void 0 ? links.isExhaustive : links.isExhaustive = computeExhaustiveSwitchStatement(node);
        }
        function computeExhaustiveSwitchStatement(node) {
          if (node.expression.kind === 204) {
            var operandType = getTypeOfExpression(node.expression.expression);
            var witnesses = getSwitchClauseTypeOfWitnesses(node, false);
            var notEqualFacts_1 = getFactsFromTypeofSwitch(0, 0, witnesses, true);
            var type_3 = getBaseConstraintOfType(operandType) || operandType;
            return !!(filterType(type_3, function(t) {
              return (getTypeFacts(t) & notEqualFacts_1) === notEqualFacts_1;
            }).flags & 131072);
          }
          var type = getTypeOfExpression(node.expression);
          if (!isLiteralType(type)) {
            return false;
          }
          var switchTypes = getSwitchClauseTypes(node);
          if (!switchTypes.length || ts2.some(switchTypes, isNeitherUnitTypeNorNever)) {
            return false;
          }
          return eachTypeContainedIn(mapType(type, getRegularTypeOfLiteralType), switchTypes);
        }
        function functionHasImplicitReturn(func) {
          return func.endFlowNode && isReachableFlowNode(func.endFlowNode);
        }
        function checkAndAggregateReturnExpressionTypes(func, checkMode) {
          var functionFlags = ts2.getFunctionFlags(func);
          var aggregatedTypes = [];
          var hasReturnWithNoExpression = functionHasImplicitReturn(func);
          var hasReturnOfTypeNever = false;
          ts2.forEachReturnStatement(func.body, function(returnStatement) {
            var expr = returnStatement.expression;
            if (expr) {
              var type = checkExpressionCached(expr, checkMode && checkMode & ~8);
              if (functionFlags & 2) {
                type = checkAwaitedType(type, func, ts2.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
              }
              if (type.flags & 131072) {
                hasReturnOfTypeNever = true;
              }
              ts2.pushIfUnique(aggregatedTypes, type);
            } else {
              hasReturnWithNoExpression = true;
            }
          });
          if (aggregatedTypes.length === 0 && !hasReturnWithNoExpression && (hasReturnOfTypeNever || mayReturnNever(func))) {
            return void 0;
          }
          if (strictNullChecks && aggregatedTypes.length && hasReturnWithNoExpression && !(isJSConstructor(func) && aggregatedTypes.some(function(t) {
            return t.symbol === func.symbol;
          }))) {
            ts2.pushIfUnique(aggregatedTypes, undefinedType);
          }
          return aggregatedTypes;
        }
        function mayReturnNever(func) {
          switch (func.kind) {
            case 201:
            case 202:
              return true;
            case 161:
              return func.parent.kind === 193;
            default:
              return false;
          }
        }
        function checkAllCodePathsInNonVoidFunctionReturnOrThrow(func, returnType) {
          if (!produceDiagnostics) {
            return;
          }
          var functionFlags = ts2.getFunctionFlags(func);
          var type = returnType && unwrapReturnType(returnType, functionFlags);
          if (type && maybeTypeOfKind(type, 1 | 16384)) {
            return;
          }
          if (func.kind === 160 || ts2.nodeIsMissing(func.body) || func.body.kind !== 223 || !functionHasImplicitReturn(func)) {
            return;
          }
          var hasExplicitReturn = func.flags & 512;
          if (type && type.flags & 131072) {
            error(ts2.getEffectiveReturnTypeNode(func), ts2.Diagnostics.A_function_returning_never_cannot_have_a_reachable_end_point);
          } else if (type && !hasExplicitReturn) {
            error(ts2.getEffectiveReturnTypeNode(func), ts2.Diagnostics.A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value);
          } else if (type && strictNullChecks && !isTypeAssignableTo(undefinedType, type)) {
            error(ts2.getEffectiveReturnTypeNode(func) || func, ts2.Diagnostics.Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined);
          } else if (compilerOptions.noImplicitReturns) {
            if (!type) {
              if (!hasExplicitReturn) {
                return;
              }
              var inferredReturnType = getReturnTypeOfSignature(getSignatureFromDeclaration(func));
              if (isUnwrappedReturnTypeVoidOrAny(func, inferredReturnType)) {
                return;
              }
            }
            error(ts2.getEffectiveReturnTypeNode(func) || func, ts2.Diagnostics.Not_all_code_paths_return_a_value);
          }
        }
        function checkFunctionExpressionOrObjectLiteralMethod(node, checkMode) {
          ts2.Debug.assert(node.kind !== 161 || ts2.isObjectLiteralMethod(node));
          checkNodeDeferred(node);
          if (checkMode && checkMode & 4 && isContextSensitive(node)) {
            if (!ts2.getEffectiveReturnTypeNode(node) && !hasContextSensitiveParameters(node)) {
              var contextualSignature = getContextualSignature(node);
              if (contextualSignature && couldContainTypeVariables(getReturnTypeOfSignature(contextualSignature))) {
                var links = getNodeLinks(node);
                if (links.contextFreeType) {
                  return links.contextFreeType;
                }
                var returnType = getReturnTypeFromBody(node, checkMode);
                var returnOnlySignature = createSignature(void 0, void 0, void 0, ts2.emptyArray, returnType, void 0, 0, 0);
                var returnOnlyType = createAnonymousType(node.symbol, emptySymbols, [returnOnlySignature], ts2.emptyArray, void 0, void 0);
                returnOnlyType.objectFlags |= 2097152;
                return links.contextFreeType = returnOnlyType;
              }
            }
            return anyFunctionType;
          }
          var hasGrammarError = checkGrammarFunctionLikeDeclaration(node);
          if (!hasGrammarError && node.kind === 201) {
            checkGrammarForGenerator(node);
          }
          contextuallyCheckFunctionExpressionOrObjectLiteralMethod(node, checkMode);
          return getTypeOfSymbol(getSymbolOfNode(node));
        }
        function contextuallyCheckFunctionExpressionOrObjectLiteralMethod(node, checkMode) {
          var links = getNodeLinks(node);
          if (!(links.flags & 1024)) {
            var contextualSignature = getContextualSignature(node);
            if (!(links.flags & 1024)) {
              links.flags |= 1024;
              var signature = ts2.firstOrUndefined(getSignaturesOfType(getTypeOfSymbol(getSymbolOfNode(node)), 0));
              if (!signature) {
                return;
              }
              if (isContextSensitive(node)) {
                if (contextualSignature) {
                  var inferenceContext = getInferenceContext(node);
                  if (checkMode && checkMode & 2) {
                    inferFromAnnotatedParameters(signature, contextualSignature, inferenceContext);
                  }
                  var instantiatedContextualSignature = inferenceContext ? instantiateSignature(contextualSignature, inferenceContext.mapper) : contextualSignature;
                  assignContextualParameterTypes(signature, instantiatedContextualSignature);
                } else {
                  assignNonContextualParameterTypes(signature);
                }
              }
              if (contextualSignature && !getReturnTypeFromAnnotation(node) && !signature.resolvedReturnType) {
                var returnType = getReturnTypeFromBody(node, checkMode);
                if (!signature.resolvedReturnType) {
                  signature.resolvedReturnType = returnType;
                }
              }
              checkSignatureDeclaration(node);
            }
          }
        }
        function checkFunctionExpressionOrObjectLiteralMethodDeferred(node) {
          ts2.Debug.assert(node.kind !== 161 || ts2.isObjectLiteralMethod(node));
          var functionFlags = ts2.getFunctionFlags(node);
          var returnType = getReturnTypeFromAnnotation(node);
          checkAllCodePathsInNonVoidFunctionReturnOrThrow(node, returnType);
          if (node.body) {
            if (!ts2.getEffectiveReturnTypeNode(node)) {
              getReturnTypeOfSignature(getSignatureFromDeclaration(node));
            }
            if (node.body.kind === 223) {
              checkSourceElement(node.body);
            } else {
              var exprType = checkExpression(node.body);
              var returnOrPromisedType = returnType && unwrapReturnType(returnType, functionFlags);
              if (returnOrPromisedType) {
                if ((functionFlags & 3) === 2) {
                  var awaitedType = checkAwaitedType(exprType, node.body, ts2.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
                  checkTypeAssignableToAndOptionallyElaborate(awaitedType, returnOrPromisedType, node.body, node.body);
                } else {
                  checkTypeAssignableToAndOptionallyElaborate(exprType, returnOrPromisedType, node.body, node.body);
                }
              }
            }
          }
        }
        function checkArithmeticOperandType(operand, type, diagnostic, isAwaitValid) {
          if (isAwaitValid === void 0) {
            isAwaitValid = false;
          }
          if (!isTypeAssignableTo(type, numberOrBigIntType)) {
            var awaitedType = isAwaitValid && getAwaitedTypeOfPromise(type);
            errorAndMaybeSuggestAwait(operand, !!awaitedType && isTypeAssignableTo(awaitedType, numberOrBigIntType), diagnostic);
            return false;
          }
          return true;
        }
        function isReadonlyAssignmentDeclaration(d) {
          if (!ts2.isCallExpression(d)) {
            return false;
          }
          if (!ts2.isBindableObjectDefinePropertyCall(d)) {
            return false;
          }
          var objectLitType = checkExpressionCached(d.arguments[2]);
          var valueType = getTypeOfPropertyOfType(objectLitType, "value");
          if (valueType) {
            var writableProp = getPropertyOfType(objectLitType, "writable");
            var writableType = writableProp && getTypeOfSymbol(writableProp);
            if (!writableType || writableType === falseType || writableType === regularFalseType) {
              return true;
            }
            if (writableProp && writableProp.valueDeclaration && ts2.isPropertyAssignment(writableProp.valueDeclaration)) {
              var initializer = writableProp.valueDeclaration.initializer;
              var rawOriginalType = checkExpression(initializer);
              if (rawOriginalType === falseType || rawOriginalType === regularFalseType) {
                return true;
              }
            }
            return false;
          }
          var setProp = getPropertyOfType(objectLitType, "set");
          return !setProp;
        }
        function isReadonlySymbol(symbol) {
          return !!(ts2.getCheckFlags(symbol) & 8 || symbol.flags & 4 && ts2.getDeclarationModifierFlagsFromSymbol(symbol) & 64 || symbol.flags & 3 && getDeclarationNodeFlagsFromSymbol(symbol) & 2 || symbol.flags & 98304 && !(symbol.flags & 65536) || symbol.flags & 8 || ts2.some(symbol.declarations, isReadonlyAssignmentDeclaration));
        }
        function isAssignmentToReadonlyEntity(expr, symbol, assignmentKind) {
          var _a, _b;
          if (assignmentKind === 0) {
            return false;
          }
          if (isReadonlySymbol(symbol)) {
            if (symbol.flags & 4 && ts2.isAccessExpression(expr) && expr.expression.kind === 104) {
              var ctor = ts2.getContainingFunction(expr);
              if (!(ctor && ctor.kind === 162)) {
                return true;
              }
              if (symbol.valueDeclaration) {
                var isAssignmentDeclaration_1 = ts2.isBinaryExpression(symbol.valueDeclaration);
                var isLocalPropertyDeclaration = ctor.parent === symbol.valueDeclaration.parent;
                var isLocalParameterProperty = ctor === symbol.valueDeclaration.parent;
                var isLocalThisPropertyAssignment = isAssignmentDeclaration_1 && ((_a = symbol.parent) === null || _a === void 0 ? void 0 : _a.valueDeclaration) === ctor.parent;
                var isLocalThisPropertyAssignmentConstructorFunction = isAssignmentDeclaration_1 && ((_b = symbol.parent) === null || _b === void 0 ? void 0 : _b.valueDeclaration) === ctor;
                var isWriteableSymbol = isLocalPropertyDeclaration || isLocalParameterProperty || isLocalThisPropertyAssignment || isLocalThisPropertyAssignmentConstructorFunction;
                return !isWriteableSymbol;
              }
            }
            return true;
          }
          if (ts2.isAccessExpression(expr)) {
            var node = ts2.skipParentheses(expr.expression);
            if (node.kind === 75) {
              var symbol_2 = getNodeLinks(node).resolvedSymbol;
              if (symbol_2.flags & 2097152) {
                var declaration = getDeclarationOfAliasSymbol(symbol_2);
                return !!declaration && declaration.kind === 256;
              }
            }
          }
          return false;
        }
        function checkReferenceExpression(expr, invalidReferenceMessage, invalidOptionalChainMessage) {
          var node = ts2.skipOuterExpressions(expr, 6 | 1);
          if (node.kind !== 75 && !ts2.isAccessExpression(node)) {
            error(expr, invalidReferenceMessage);
            return false;
          }
          if (node.flags & 32) {
            error(expr, invalidOptionalChainMessage);
            return false;
          }
          return true;
        }
        function checkDeleteExpression(node) {
          checkExpression(node.expression);
          var expr = ts2.skipParentheses(node.expression);
          if (!ts2.isAccessExpression(expr)) {
            error(expr, ts2.Diagnostics.The_operand_of_a_delete_operator_must_be_a_property_reference);
            return booleanType;
          }
          if (expr.kind === 194 && ts2.isPrivateIdentifier(expr.name)) {
            error(expr, ts2.Diagnostics.The_operand_of_a_delete_operator_cannot_be_a_private_identifier);
          }
          var links = getNodeLinks(expr);
          var symbol = getExportSymbolOfValueSymbolIfExported(links.resolvedSymbol);
          if (symbol && isReadonlySymbol(symbol)) {
            error(expr, ts2.Diagnostics.The_operand_of_a_delete_operator_cannot_be_a_read_only_property);
          }
          return booleanType;
        }
        function checkTypeOfExpression(node) {
          checkExpression(node.expression);
          return typeofType;
        }
        function checkVoidExpression(node) {
          checkExpression(node.expression);
          return undefinedWideningType;
        }
        function isTopLevelAwait(node) {
          var container = ts2.getThisContainer(node, true);
          return ts2.isSourceFile(container);
        }
        function checkAwaitExpression(node) {
          if (produceDiagnostics) {
            if (!(node.flags & 32768)) {
              if (isTopLevelAwait(node)) {
                var sourceFile = ts2.getSourceFileOfNode(node);
                if (!hasParseDiagnostics(sourceFile)) {
                  var span = void 0;
                  if (!ts2.isEffectiveExternalModule(sourceFile, compilerOptions)) {
                    if (!span)
                      span = ts2.getSpanOfTokenAtPosition(sourceFile, node.pos);
                    var diagnostic = ts2.createFileDiagnostic(sourceFile, span.start, span.length, ts2.Diagnostics.await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module);
                    diagnostics.add(diagnostic);
                  }
                  if (moduleKind !== ts2.ModuleKind.ESNext && moduleKind !== ts2.ModuleKind.System || languageVersion < 4) {
                    span = ts2.getSpanOfTokenAtPosition(sourceFile, node.pos);
                    var diagnostic = ts2.createFileDiagnostic(sourceFile, span.start, span.length, ts2.Diagnostics.Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_esnext_or_system_and_the_target_option_is_set_to_es2017_or_higher);
                    diagnostics.add(diagnostic);
                  }
                }
              } else {
                var sourceFile = ts2.getSourceFileOfNode(node);
                if (!hasParseDiagnostics(sourceFile)) {
                  var span = ts2.getSpanOfTokenAtPosition(sourceFile, node.pos);
                  var diagnostic = ts2.createFileDiagnostic(sourceFile, span.start, span.length, ts2.Diagnostics.await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules);
                  var func = ts2.getContainingFunction(node);
                  if (func && func.kind !== 162 && (ts2.getFunctionFlags(func) & 2) === 0) {
                    var relatedInfo = ts2.createDiagnosticForNode(func, ts2.Diagnostics.Did_you_mean_to_mark_this_function_as_async);
                    ts2.addRelatedInfo(diagnostic, relatedInfo);
                  }
                  diagnostics.add(diagnostic);
                }
              }
            }
            if (isInParameterInitializerBeforeContainingFunction(node)) {
              error(node, ts2.Diagnostics.await_expressions_cannot_be_used_in_a_parameter_initializer);
            }
          }
          var operandType = checkExpression(node.expression);
          var awaitedType = checkAwaitedType(operandType, node, ts2.Diagnostics.Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
          if (awaitedType === operandType && awaitedType !== errorType && !(operandType.flags & 3)) {
            addErrorOrSuggestion(false, ts2.createDiagnosticForNode(node, ts2.Diagnostics.await_has_no_effect_on_the_type_of_this_expression));
          }
          return awaitedType;
        }
        function checkPrefixUnaryExpression(node) {
          var operandType = checkExpression(node.operand);
          if (operandType === silentNeverType) {
            return silentNeverType;
          }
          switch (node.operand.kind) {
            case 8:
              switch (node.operator) {
                case 40:
                  return getFreshTypeOfLiteralType(getLiteralType(-node.operand.text));
                case 39:
                  return getFreshTypeOfLiteralType(getLiteralType(+node.operand.text));
              }
              break;
            case 9:
              if (node.operator === 40) {
                return getFreshTypeOfLiteralType(getLiteralType({
                  negative: true,
                  base10Value: ts2.parsePseudoBigInt(node.operand.text)
                }));
              }
          }
          switch (node.operator) {
            case 39:
            case 40:
            case 54:
              checkNonNullType(operandType, node.operand);
              if (maybeTypeOfKind(operandType, 12288)) {
                error(node.operand, ts2.Diagnostics.The_0_operator_cannot_be_applied_to_type_symbol, ts2.tokenToString(node.operator));
              }
              if (node.operator === 39) {
                if (maybeTypeOfKind(operandType, 2112)) {
                  error(node.operand, ts2.Diagnostics.Operator_0_cannot_be_applied_to_type_1, ts2.tokenToString(node.operator), typeToString(getBaseTypeOfLiteralType(operandType)));
                }
                return numberType;
              }
              return getUnaryResultType(operandType);
            case 53:
              checkTruthinessExpression(node.operand);
              var facts = getTypeFacts(operandType) & (4194304 | 8388608);
              return facts === 4194304 ? falseType : facts === 8388608 ? trueType : booleanType;
            case 45:
            case 46:
              var ok = checkArithmeticOperandType(node.operand, checkNonNullType(operandType, node.operand), ts2.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type);
              if (ok) {
                checkReferenceExpression(node.operand, ts2.Diagnostics.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access, ts2.Diagnostics.The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access);
              }
              return getUnaryResultType(operandType);
          }
          return errorType;
        }
        function checkPostfixUnaryExpression(node) {
          var operandType = checkExpression(node.operand);
          if (operandType === silentNeverType) {
            return silentNeverType;
          }
          var ok = checkArithmeticOperandType(node.operand, checkNonNullType(operandType, node.operand), ts2.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type);
          if (ok) {
            checkReferenceExpression(node.operand, ts2.Diagnostics.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access, ts2.Diagnostics.The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access);
          }
          return getUnaryResultType(operandType);
        }
        function getUnaryResultType(operandType) {
          if (maybeTypeOfKind(operandType, 2112)) {
            return isTypeAssignableToKind(operandType, 3) || maybeTypeOfKind(operandType, 296) ? numberOrBigIntType : bigintType;
          }
          return numberType;
        }
        function maybeTypeOfKind(type, kind) {
          if (type.flags & kind) {
            return true;
          }
          if (type.flags & 3145728) {
            var types = type.types;
            for (var _i = 0, types_19 = types; _i < types_19.length; _i++) {
              var t = types_19[_i];
              if (maybeTypeOfKind(t, kind)) {
                return true;
              }
            }
          }
          return false;
        }
        function isTypeAssignableToKind(source, kind, strict) {
          if (source.flags & kind) {
            return true;
          }
          if (strict && source.flags & (3 | 16384 | 32768 | 65536)) {
            return false;
          }
          return !!(kind & 296) && isTypeAssignableTo(source, numberType) || !!(kind & 2112) && isTypeAssignableTo(source, bigintType) || !!(kind & 132) && isTypeAssignableTo(source, stringType) || !!(kind & 528) && isTypeAssignableTo(source, booleanType) || !!(kind & 16384) && isTypeAssignableTo(source, voidType) || !!(kind & 131072) && isTypeAssignableTo(source, neverType) || !!(kind & 65536) && isTypeAssignableTo(source, nullType) || !!(kind & 32768) && isTypeAssignableTo(source, undefinedType) || !!(kind & 4096) && isTypeAssignableTo(source, esSymbolType) || !!(kind & 67108864) && isTypeAssignableTo(source, nonPrimitiveType);
        }
        function allTypesAssignableToKind(source, kind, strict) {
          return source.flags & 1048576 ? ts2.every(source.types, function(subType) {
            return allTypesAssignableToKind(subType, kind, strict);
          }) : isTypeAssignableToKind(source, kind, strict);
        }
        function isConstEnumObjectType(type) {
          return !!(ts2.getObjectFlags(type) & 16) && !!type.symbol && isConstEnumSymbol(type.symbol);
        }
        function isConstEnumSymbol(symbol) {
          return (symbol.flags & 128) !== 0;
        }
        function checkInstanceOfExpression(left, right, leftType, rightType) {
          if (leftType === silentNeverType || rightType === silentNeverType) {
            return silentNeverType;
          }
          if (!isTypeAny(leftType) && allTypesAssignableToKind(leftType, 131068)) {
            error(left, ts2.Diagnostics.The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter);
          }
          if (!(isTypeAny(rightType) || typeHasCallOrConstructSignatures(rightType) || isTypeSubtypeOf(rightType, globalFunctionType))) {
            error(right, ts2.Diagnostics.The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_Function_interface_type);
          }
          return booleanType;
        }
        function checkInExpression(left, right, leftType, rightType) {
          if (leftType === silentNeverType || rightType === silentNeverType) {
            return silentNeverType;
          }
          leftType = checkNonNullType(leftType, left);
          rightType = checkNonNullType(rightType, right);
          if (!(isTypeComparableTo(leftType, stringType) || isTypeAssignableToKind(leftType, 296 | 12288))) {
            error(left, ts2.Diagnostics.The_left_hand_side_of_an_in_expression_must_be_of_type_any_string_number_or_symbol);
          }
          if (!allTypesAssignableToKind(rightType, 67108864 | 58982400)) {
            error(right, ts2.Diagnostics.The_right_hand_side_of_an_in_expression_must_be_of_type_any_an_object_type_or_a_type_parameter);
          }
          return booleanType;
        }
        function checkObjectLiteralAssignment(node, sourceType, rightIsThis) {
          var properties = node.properties;
          if (strictNullChecks && properties.length === 0) {
            return checkNonNullType(sourceType, node);
          }
          for (var i = 0; i < properties.length; i++) {
            checkObjectLiteralDestructuringPropertyAssignment(node, sourceType, i, properties, rightIsThis);
          }
          return sourceType;
        }
        function checkObjectLiteralDestructuringPropertyAssignment(node, objectLiteralType, propertyIndex, allProperties, rightIsThis) {
          if (rightIsThis === void 0) {
            rightIsThis = false;
          }
          var properties = node.properties;
          var property = properties[propertyIndex];
          if (property.kind === 281 || property.kind === 282) {
            var name = property.name;
            var exprType = getLiteralTypeFromPropertyName(name);
            if (isTypeUsableAsPropertyName(exprType)) {
              var text = getPropertyNameFromType(exprType);
              var prop = getPropertyOfType(objectLiteralType, text);
              if (prop) {
                markPropertyAsReferenced(prop, property, rightIsThis);
                checkPropertyAccessibility(property, false, objectLiteralType, prop);
              }
            }
            var elementType = getIndexedAccessType(objectLiteralType, exprType, name);
            var type = getFlowTypeOfDestructuring(property, elementType);
            return checkDestructuringAssignment(property.kind === 282 ? property : property.initializer, type);
          } else if (property.kind === 283) {
            if (propertyIndex < properties.length - 1) {
              error(property, ts2.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);
            } else {
              if (languageVersion < 99) {
                checkExternalEmitHelpers(property, 4);
              }
              var nonRestNames = [];
              if (allProperties) {
                for (var _i = 0, allProperties_1 = allProperties; _i < allProperties_1.length; _i++) {
                  var otherProperty = allProperties_1[_i];
                  if (!ts2.isSpreadAssignment(otherProperty)) {
                    nonRestNames.push(otherProperty.name);
                  }
                }
              }
              var type = getRestType(objectLiteralType, nonRestNames, objectLiteralType.symbol);
              checkGrammarForDisallowedTrailingComma(allProperties, ts2.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);
              return checkDestructuringAssignment(property.expression, type);
            }
          } else {
            error(property, ts2.Diagnostics.Property_assignment_expected);
          }
        }
        function checkArrayLiteralAssignment(node, sourceType, checkMode) {
          var elements = node.elements;
          if (languageVersion < 2 && compilerOptions.downlevelIteration) {
            checkExternalEmitHelpers(node, 512);
          }
          var elementType = checkIteratedTypeOrElementType(65, sourceType, undefinedType, node) || errorType;
          for (var i = 0; i < elements.length; i++) {
            checkArrayLiteralDestructuringElementAssignment(node, sourceType, i, elementType, checkMode);
          }
          return sourceType;
        }
        function checkArrayLiteralDestructuringElementAssignment(node, sourceType, elementIndex, elementType, checkMode) {
          var elements = node.elements;
          var element = elements[elementIndex];
          if (element.kind !== 215) {
            if (element.kind !== 213) {
              var indexType = getLiteralType(elementIndex);
              if (isArrayLikeType(sourceType)) {
                var accessFlags = hasDefaultValue(element) ? 8 : 0;
                var elementType_2 = getIndexedAccessTypeOrUndefined(sourceType, indexType, createSyntheticExpression(element, indexType), accessFlags) || errorType;
                var assignedType = hasDefaultValue(element) ? getTypeWithFacts(elementType_2, 524288) : elementType_2;
                var type = getFlowTypeOfDestructuring(element, assignedType);
                return checkDestructuringAssignment(element, type, checkMode);
              }
              return checkDestructuringAssignment(element, elementType, checkMode);
            }
            if (elementIndex < elements.length - 1) {
              error(element, ts2.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);
            } else {
              var restExpression = element.expression;
              if (restExpression.kind === 209 && restExpression.operatorToken.kind === 62) {
                error(restExpression.operatorToken, ts2.Diagnostics.A_rest_element_cannot_have_an_initializer);
              } else {
                checkGrammarForDisallowedTrailingComma(node.elements, ts2.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);
                var type = everyType(sourceType, isTupleType) ? mapType(sourceType, function(t) {
                  return sliceTupleType(t, elementIndex);
                }) : createArrayType(elementType);
                return checkDestructuringAssignment(restExpression, type, checkMode);
              }
            }
          }
          return void 0;
        }
        function checkDestructuringAssignment(exprOrAssignment, sourceType, checkMode, rightIsThis) {
          var target;
          if (exprOrAssignment.kind === 282) {
            var prop = exprOrAssignment;
            if (prop.objectAssignmentInitializer) {
              if (strictNullChecks && !(getFalsyFlags(checkExpression(prop.objectAssignmentInitializer)) & 32768)) {
                sourceType = getTypeWithFacts(sourceType, 524288);
              }
              checkBinaryLikeExpression(prop.name, prop.equalsToken, prop.objectAssignmentInitializer, checkMode);
            }
            target = exprOrAssignment.name;
          } else {
            target = exprOrAssignment;
          }
          if (target.kind === 209 && target.operatorToken.kind === 62) {
            checkBinaryExpression(target, checkMode);
            target = target.left;
          }
          if (target.kind === 193) {
            return checkObjectLiteralAssignment(target, sourceType, rightIsThis);
          }
          if (target.kind === 192) {
            return checkArrayLiteralAssignment(target, sourceType, checkMode);
          }
          return checkReferenceAssignment(target, sourceType, checkMode);
        }
        function checkReferenceAssignment(target, sourceType, checkMode) {
          var targetType = checkExpression(target, checkMode);
          var error2 = target.parent.kind === 283 ? ts2.Diagnostics.The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access : ts2.Diagnostics.The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access;
          var optionalError = target.parent.kind === 283 ? ts2.Diagnostics.The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access : ts2.Diagnostics.The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access;
          if (checkReferenceExpression(target, error2, optionalError)) {
            checkTypeAssignableToAndOptionallyElaborate(sourceType, targetType, target, target);
          }
          if (ts2.isPrivateIdentifierPropertyAccessExpression(target)) {
            checkExternalEmitHelpers(target.parent, 524288);
          }
          return sourceType;
        }
        function isSideEffectFree(node) {
          node = ts2.skipParentheses(node);
          switch (node.kind) {
            case 75:
            case 10:
            case 13:
            case 198:
            case 211:
            case 14:
            case 8:
            case 9:
            case 106:
            case 91:
            case 100:
            case 146:
            case 201:
            case 214:
            case 202:
            case 192:
            case 193:
            case 204:
            case 218:
            case 267:
            case 266:
              return true;
            case 210:
              return isSideEffectFree(node.whenTrue) && isSideEffectFree(node.whenFalse);
            case 209:
              if (ts2.isAssignmentOperator(node.operatorToken.kind)) {
                return false;
              }
              return isSideEffectFree(node.left) && isSideEffectFree(node.right);
            case 207:
            case 208:
              switch (node.operator) {
                case 53:
                case 39:
                case 40:
                case 54:
                  return true;
              }
              return false;
            case 205:
            case 199:
            case 217:
            default:
              return false;
          }
        }
        function isTypeEqualityComparableTo(source, target) {
          return (target.flags & 98304) !== 0 || isTypeComparableTo(source, target);
        }
        var CheckBinaryExpressionState;
        (function(CheckBinaryExpressionState2) {
          CheckBinaryExpressionState2[CheckBinaryExpressionState2["MaybeCheckLeft"] = 0] = "MaybeCheckLeft";
          CheckBinaryExpressionState2[CheckBinaryExpressionState2["CheckRight"] = 1] = "CheckRight";
          CheckBinaryExpressionState2[CheckBinaryExpressionState2["FinishCheck"] = 2] = "FinishCheck";
        })(CheckBinaryExpressionState || (CheckBinaryExpressionState = {}));
        function checkBinaryExpression(node, checkMode) {
          var workStacks = {
            expr: [node],
            state: [0],
            leftType: [void 0]
          };
          var stackIndex = 0;
          var lastResult;
          while (stackIndex >= 0) {
            node = workStacks.expr[stackIndex];
            switch (workStacks.state[stackIndex]) {
              case 0: {
                if (ts2.isInJSFile(node) && ts2.getAssignedExpandoInitializer(node)) {
                  finishInvocation(checkExpression(node.right, checkMode));
                  break;
                }
                checkGrammarNullishCoalesceWithLogicalExpression(node);
                var operator = node.operatorToken.kind;
                if (operator === 62 && (node.left.kind === 193 || node.left.kind === 192)) {
                  finishInvocation(checkDestructuringAssignment(node.left, checkExpression(node.right, checkMode), checkMode, node.right.kind === 104));
                  break;
                }
                advanceState(1);
                maybeCheckExpression(node.left);
                break;
              }
              case 1: {
                var leftType = lastResult;
                workStacks.leftType[stackIndex] = leftType;
                var operator = node.operatorToken.kind;
                if (operator === 55 || operator === 56 || operator === 60) {
                  checkTruthinessOfType(leftType, node.left);
                }
                advanceState(2);
                maybeCheckExpression(node.right);
                break;
              }
              case 2: {
                var leftType = workStacks.leftType[stackIndex];
                var rightType = lastResult;
                finishInvocation(checkBinaryLikeExpressionWorker(node.left, node.operatorToken, node.right, leftType, rightType, node));
                break;
              }
              default:
                return ts2.Debug.fail("Invalid state " + workStacks.state[stackIndex] + " for checkBinaryExpression");
            }
          }
          return lastResult;
          function finishInvocation(result) {
            lastResult = result;
            stackIndex--;
          }
          function advanceState(nextState) {
            workStacks.state[stackIndex] = nextState;
          }
          function maybeCheckExpression(node2) {
            if (ts2.isBinaryExpression(node2)) {
              stackIndex++;
              workStacks.expr[stackIndex] = node2;
              workStacks.state[stackIndex] = 0;
              workStacks.leftType[stackIndex] = void 0;
            } else {
              lastResult = checkExpression(node2, checkMode);
            }
          }
        }
        function checkGrammarNullishCoalesceWithLogicalExpression(node) {
          var left = node.left, operatorToken = node.operatorToken, right = node.right;
          if (operatorToken.kind === 60) {
            if (ts2.isBinaryExpression(left) && (left.operatorToken.kind === 56 || left.operatorToken.kind === 55)) {
              grammarErrorOnNode(left, ts2.Diagnostics._0_and_1_operations_cannot_be_mixed_without_parentheses, ts2.tokenToString(left.operatorToken.kind), ts2.tokenToString(operatorToken.kind));
            }
            if (ts2.isBinaryExpression(right) && (right.operatorToken.kind === 56 || right.operatorToken.kind === 55)) {
              grammarErrorOnNode(right, ts2.Diagnostics._0_and_1_operations_cannot_be_mixed_without_parentheses, ts2.tokenToString(right.operatorToken.kind), ts2.tokenToString(operatorToken.kind));
            }
          }
        }
        function checkBinaryLikeExpression(left, operatorToken, right, checkMode, errorNode) {
          var operator = operatorToken.kind;
          if (operator === 62 && (left.kind === 193 || left.kind === 192)) {
            return checkDestructuringAssignment(left, checkExpression(right, checkMode), checkMode, right.kind === 104);
          }
          var leftType;
          if (operator === 55 || operator === 56 || operator === 60) {
            leftType = checkTruthinessExpression(left, checkMode);
          } else {
            leftType = checkExpression(left, checkMode);
          }
          var rightType = checkExpression(right, checkMode);
          return checkBinaryLikeExpressionWorker(left, operatorToken, right, leftType, rightType, errorNode);
        }
        function checkBinaryLikeExpressionWorker(left, operatorToken, right, leftType, rightType, errorNode) {
          var operator = operatorToken.kind;
          switch (operator) {
            case 41:
            case 42:
            case 65:
            case 66:
            case 43:
            case 67:
            case 44:
            case 68:
            case 40:
            case 64:
            case 47:
            case 69:
            case 48:
            case 70:
            case 49:
            case 71:
            case 51:
            case 73:
            case 52:
            case 74:
            case 50:
            case 72:
              if (leftType === silentNeverType || rightType === silentNeverType) {
                return silentNeverType;
              }
              leftType = checkNonNullType(leftType, left);
              rightType = checkNonNullType(rightType, right);
              var suggestedOperator = void 0;
              if (leftType.flags & 528 && rightType.flags & 528 && (suggestedOperator = getSuggestedBooleanOperator(operatorToken.kind)) !== void 0) {
                error(errorNode || operatorToken, ts2.Diagnostics.The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead, ts2.tokenToString(operatorToken.kind), ts2.tokenToString(suggestedOperator));
                return numberType;
              } else {
                var leftOk = checkArithmeticOperandType(left, leftType, ts2.Diagnostics.The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type, true);
                var rightOk = checkArithmeticOperandType(right, rightType, ts2.Diagnostics.The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type, true);
                var resultType_1;
                if (isTypeAssignableToKind(leftType, 3) && isTypeAssignableToKind(rightType, 3) || !(maybeTypeOfKind(leftType, 2112) || maybeTypeOfKind(rightType, 2112))) {
                  resultType_1 = numberType;
                } else if (bothAreBigIntLike(leftType, rightType)) {
                  switch (operator) {
                    case 49:
                    case 71:
                      reportOperatorError();
                  }
                  resultType_1 = bigintType;
                } else {
                  reportOperatorError(bothAreBigIntLike);
                  resultType_1 = errorType;
                }
                if (leftOk && rightOk) {
                  checkAssignmentOperator(resultType_1);
                }
                return resultType_1;
              }
            case 39:
            case 63:
              if (leftType === silentNeverType || rightType === silentNeverType) {
                return silentNeverType;
              }
              if (!isTypeAssignableToKind(leftType, 132) && !isTypeAssignableToKind(rightType, 132)) {
                leftType = checkNonNullType(leftType, left);
                rightType = checkNonNullType(rightType, right);
              }
              var resultType = void 0;
              if (isTypeAssignableToKind(leftType, 296, true) && isTypeAssignableToKind(rightType, 296, true)) {
                resultType = numberType;
              } else if (isTypeAssignableToKind(leftType, 2112, true) && isTypeAssignableToKind(rightType, 2112, true)) {
                resultType = bigintType;
              } else if (isTypeAssignableToKind(leftType, 132, true) || isTypeAssignableToKind(rightType, 132, true)) {
                resultType = stringType;
              } else if (isTypeAny(leftType) || isTypeAny(rightType)) {
                resultType = leftType === errorType || rightType === errorType ? errorType : anyType;
              }
              if (resultType && !checkForDisallowedESSymbolOperand(operator)) {
                return resultType;
              }
              if (!resultType) {
                var closeEnoughKind_1 = 296 | 2112 | 132 | 3;
                reportOperatorError(function(left2, right2) {
                  return isTypeAssignableToKind(left2, closeEnoughKind_1) && isTypeAssignableToKind(right2, closeEnoughKind_1);
                });
                return anyType;
              }
              if (operator === 63) {
                checkAssignmentOperator(resultType);
              }
              return resultType;
            case 29:
            case 31:
            case 32:
            case 33:
              if (checkForDisallowedESSymbolOperand(operator)) {
                leftType = getBaseTypeOfLiteralType(checkNonNullType(leftType, left));
                rightType = getBaseTypeOfLiteralType(checkNonNullType(rightType, right));
                reportOperatorErrorUnless(function(left2, right2) {
                  return isTypeComparableTo(left2, right2) || isTypeComparableTo(right2, left2) || isTypeAssignableTo(left2, numberOrBigIntType) && isTypeAssignableTo(right2, numberOrBigIntType);
                });
              }
              return booleanType;
            case 34:
            case 35:
            case 36:
            case 37:
              reportOperatorErrorUnless(function(left2, right2) {
                return isTypeEqualityComparableTo(left2, right2) || isTypeEqualityComparableTo(right2, left2);
              });
              return booleanType;
            case 98:
              return checkInstanceOfExpression(left, right, leftType, rightType);
            case 97:
              return checkInExpression(left, right, leftType, rightType);
            case 55:
              return getTypeFacts(leftType) & 4194304 ? getUnionType([extractDefinitelyFalsyTypes(strictNullChecks ? leftType : getBaseTypeOfLiteralType(rightType)), rightType]) : leftType;
            case 56:
              return getTypeFacts(leftType) & 8388608 ? getUnionType([removeDefinitelyFalsyTypes(leftType), rightType], 2) : leftType;
            case 60:
              return getTypeFacts(leftType) & 262144 ? getUnionType([getNonNullableType(leftType), rightType], 2) : leftType;
            case 62:
              var declKind = ts2.isBinaryExpression(left.parent) ? ts2.getAssignmentDeclarationKind(left.parent) : 0;
              checkAssignmentDeclaration(declKind, rightType);
              if (isAssignmentDeclaration(declKind)) {
                if (!(rightType.flags & 524288) || declKind !== 2 && declKind !== 6 && !isEmptyObjectType(rightType) && !isFunctionObjectType(rightType) && !(ts2.getObjectFlags(rightType) & 1)) {
                  checkAssignmentOperator(rightType);
                }
                return leftType;
              } else {
                checkAssignmentOperator(rightType);
                return getRegularTypeOfObjectLiteral(rightType);
              }
            case 27:
              if (!compilerOptions.allowUnreachableCode && isSideEffectFree(left) && !isEvalNode(right)) {
                error(left, ts2.Diagnostics.Left_side_of_comma_operator_is_unused_and_has_no_side_effects);
              }
              return rightType;
            default:
              return ts2.Debug.fail();
          }
          function bothAreBigIntLike(left2, right2) {
            return isTypeAssignableToKind(left2, 2112) && isTypeAssignableToKind(right2, 2112);
          }
          function checkAssignmentDeclaration(kind, rightType2) {
            if (kind === 2) {
              for (var _i = 0, _a = getPropertiesOfObjectType(rightType2); _i < _a.length; _i++) {
                var prop = _a[_i];
                var propType = getTypeOfSymbol(prop);
                if (propType.symbol && propType.symbol.flags & 32) {
                  var name = prop.escapedName;
                  var symbol = resolveName(prop.valueDeclaration, name, 788968, void 0, name, false);
                  if (symbol && symbol.declarations.some(ts2.isJSDocTypedefTag)) {
                    addDuplicateDeclarationErrorsForSymbols(symbol, ts2.Diagnostics.Duplicate_identifier_0, ts2.unescapeLeadingUnderscores(name), prop);
                    addDuplicateDeclarationErrorsForSymbols(prop, ts2.Diagnostics.Duplicate_identifier_0, ts2.unescapeLeadingUnderscores(name), symbol);
                  }
                }
              }
            }
          }
          function isEvalNode(node) {
            return node.kind === 75 && node.escapedText === "eval";
          }
          function checkForDisallowedESSymbolOperand(operator2) {
            var offendingSymbolOperand = maybeTypeOfKind(leftType, 12288) ? left : maybeTypeOfKind(rightType, 12288) ? right : void 0;
            if (offendingSymbolOperand) {
              error(offendingSymbolOperand, ts2.Diagnostics.The_0_operator_cannot_be_applied_to_type_symbol, ts2.tokenToString(operator2));
              return false;
            }
            return true;
          }
          function getSuggestedBooleanOperator(operator2) {
            switch (operator2) {
              case 51:
              case 73:
                return 56;
              case 52:
              case 74:
                return 37;
              case 50:
              case 72:
                return 55;
              default:
                return void 0;
            }
          }
          function checkAssignmentOperator(valueType) {
            if (produceDiagnostics && ts2.isAssignmentOperator(operator)) {
              if (checkReferenceExpression(left, ts2.Diagnostics.The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access, ts2.Diagnostics.The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access) && (!ts2.isIdentifier(left) || ts2.unescapeLeadingUnderscores(left.escapedText) !== "exports")) {
                checkTypeAssignableToAndOptionallyElaborate(valueType, leftType, left, right);
              }
            }
          }
          function isAssignmentDeclaration(kind) {
            switch (kind) {
              case 2:
                return true;
              case 1:
              case 5:
              case 6:
              case 3:
              case 4:
                var symbol = getSymbolOfNode(left);
                var init = ts2.getAssignedExpandoInitializer(right);
                return init && ts2.isObjectLiteralExpression(init) && symbol && ts2.hasEntries(symbol.exports);
              default:
                return false;
            }
          }
          function reportOperatorErrorUnless(typesAreCompatible) {
            if (!typesAreCompatible(leftType, rightType)) {
              reportOperatorError(typesAreCompatible);
              return true;
            }
            return false;
          }
          function reportOperatorError(isRelated) {
            var _a;
            var wouldWorkWithAwait = false;
            var errNode = errorNode || operatorToken;
            if (isRelated) {
              var awaitedLeftType = getAwaitedType(leftType);
              var awaitedRightType = getAwaitedType(rightType);
              wouldWorkWithAwait = !(awaitedLeftType === leftType && awaitedRightType === rightType) && !!(awaitedLeftType && awaitedRightType) && isRelated(awaitedLeftType, awaitedRightType);
            }
            var effectiveLeft = leftType;
            var effectiveRight = rightType;
            if (!wouldWorkWithAwait && isRelated) {
              _a = getBaseTypesIfUnrelated(leftType, rightType, isRelated), effectiveLeft = _a[0], effectiveRight = _a[1];
            }
            var _b = getTypeNamesForErrorDisplay(effectiveLeft, effectiveRight), leftStr = _b[0], rightStr = _b[1];
            if (!tryGiveBetterPrimaryError(errNode, wouldWorkWithAwait, leftStr, rightStr)) {
              errorAndMaybeSuggestAwait(errNode, wouldWorkWithAwait, ts2.Diagnostics.Operator_0_cannot_be_applied_to_types_1_and_2, ts2.tokenToString(operatorToken.kind), leftStr, rightStr);
            }
          }
          function tryGiveBetterPrimaryError(errNode, maybeMissingAwait, leftStr, rightStr) {
            var typeName;
            switch (operatorToken.kind) {
              case 36:
              case 34:
                typeName = "false";
                break;
              case 37:
              case 35:
                typeName = "true";
            }
            if (typeName) {
              return errorAndMaybeSuggestAwait(errNode, maybeMissingAwait, ts2.Diagnostics.This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap, typeName, leftStr, rightStr);
            }
            return void 0;
          }
        }
        function getBaseTypesIfUnrelated(leftType, rightType, isRelated) {
          var effectiveLeft = leftType;
          var effectiveRight = rightType;
          var leftBase = getBaseTypeOfLiteralType(leftType);
          var rightBase = getBaseTypeOfLiteralType(rightType);
          if (!isRelated(leftBase, rightBase)) {
            effectiveLeft = leftBase;
            effectiveRight = rightBase;
          }
          return [effectiveLeft, effectiveRight];
        }
        function checkYieldExpression(node) {
          if (produceDiagnostics) {
            if (!(node.flags & 8192)) {
              grammarErrorOnFirstToken(node, ts2.Diagnostics.A_yield_expression_is_only_allowed_in_a_generator_body);
            }
            if (isInParameterInitializerBeforeContainingFunction(node)) {
              error(node, ts2.Diagnostics.yield_expressions_cannot_be_used_in_a_parameter_initializer);
            }
          }
          var func = ts2.getContainingFunction(node);
          if (!func)
            return anyType;
          var functionFlags = ts2.getFunctionFlags(func);
          if (!(functionFlags & 1)) {
            return anyType;
          }
          var isAsync = (functionFlags & 2) !== 0;
          if (node.asteriskToken) {
            if (isAsync && languageVersion < 99) {
              checkExternalEmitHelpers(node, 53248);
            }
            if (!isAsync && languageVersion < 2 && compilerOptions.downlevelIteration) {
              checkExternalEmitHelpers(node, 256);
            }
          }
          var returnType = getReturnTypeFromAnnotation(func);
          var iterationTypes = returnType && getIterationTypesOfGeneratorFunctionReturnType(returnType, isAsync);
          var signatureYieldType = iterationTypes && iterationTypes.yieldType || anyType;
          var signatureNextType = iterationTypes && iterationTypes.nextType || anyType;
          var resolvedSignatureNextType = isAsync ? getAwaitedType(signatureNextType) || anyType : signatureNextType;
          var yieldExpressionType = node.expression ? checkExpression(node.expression) : undefinedWideningType;
          var yieldedType = getYieldedTypeOfYieldExpression(node, yieldExpressionType, resolvedSignatureNextType, isAsync);
          if (returnType && yieldedType) {
            checkTypeAssignableToAndOptionallyElaborate(yieldedType, signatureYieldType, node.expression || node, node.expression);
          }
          if (node.asteriskToken) {
            var use = isAsync ? 19 : 17;
            return getIterationTypeOfIterable(use, 1, yieldExpressionType, node.expression) || anyType;
          } else if (returnType) {
            return getIterationTypeOfGeneratorFunctionReturnType(2, returnType, isAsync) || anyType;
          }
          return getContextualIterationType(2, func) || anyType;
        }
        function checkConditionalExpression(node, checkMode) {
          var type = checkTruthinessExpression(node.condition);
          checkTestingKnownTruthyCallableType(node.condition, node.whenTrue, type);
          var type1 = checkExpression(node.whenTrue, checkMode);
          var type2 = checkExpression(node.whenFalse, checkMode);
          return getUnionType([type1, type2], 2);
        }
        function checkTemplateExpression(node) {
          ts2.forEach(node.templateSpans, function(templateSpan) {
            if (maybeTypeOfKind(checkExpression(templateSpan.expression), 12288)) {
              error(templateSpan.expression, ts2.Diagnostics.Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_in_String);
            }
          });
          return stringType;
        }
        function getContextNode(node) {
          if (node.kind === 274 && !ts2.isJsxSelfClosingElement(node.parent)) {
            return node.parent.parent;
          }
          return node;
        }
        function checkExpressionWithContextualType(node, contextualType, inferenceContext, checkMode) {
          var context = getContextNode(node);
          var saveContextualType = context.contextualType;
          var saveInferenceContext = context.inferenceContext;
          try {
            context.contextualType = contextualType;
            context.inferenceContext = inferenceContext;
            var type = checkExpression(node, checkMode | 1 | (inferenceContext ? 2 : 0));
            var result = maybeTypeOfKind(type, 2944) && isLiteralOfContextualType(type, instantiateContextualType(contextualType, node)) ? getRegularTypeOfLiteralType(type) : type;
            return result;
          } finally {
            context.contextualType = saveContextualType;
            context.inferenceContext = saveInferenceContext;
          }
        }
        function checkExpressionCached(node, checkMode) {
          var links = getNodeLinks(node);
          if (!links.resolvedType) {
            if (checkMode && checkMode !== 0) {
              return checkExpression(node, checkMode);
            }
            var saveFlowLoopStart = flowLoopStart;
            var saveFlowTypeCache = flowTypeCache;
            flowLoopStart = flowLoopCount;
            flowTypeCache = void 0;
            links.resolvedType = checkExpression(node, checkMode);
            flowTypeCache = saveFlowTypeCache;
            flowLoopStart = saveFlowLoopStart;
          }
          return links.resolvedType;
        }
        function isTypeAssertion(node) {
          node = ts2.skipParentheses(node);
          return node.kind === 199 || node.kind === 217;
        }
        function checkDeclarationInitializer(declaration, contextualType) {
          var initializer = ts2.getEffectiveInitializer(declaration);
          var type = getQuickTypeOfExpression(initializer) || (contextualType ? checkExpressionWithContextualType(initializer, contextualType, void 0, 0) : checkExpressionCached(initializer));
          return ts2.isParameter(declaration) && declaration.name.kind === 190 && isTupleType(type) && !type.target.hasRestElement && getTypeReferenceArity(type) < declaration.name.elements.length ? padTupleType(type, declaration.name) : type;
        }
        function padTupleType(type, pattern) {
          var patternElements = pattern.elements;
          var arity = getTypeReferenceArity(type);
          var elementTypes = arity ? getTypeArguments(type).slice() : [];
          for (var i = arity; i < patternElements.length; i++) {
            var e = patternElements[i];
            if (i < patternElements.length - 1 || !(e.kind === 191 && e.dotDotDotToken)) {
              elementTypes.push(!ts2.isOmittedExpression(e) && hasDefaultValue(e) ? getTypeFromBindingElement(e, false, false) : anyType);
              if (!ts2.isOmittedExpression(e) && !hasDefaultValue(e)) {
                reportImplicitAny(e, anyType);
              }
            }
          }
          return createTupleType(elementTypes, type.target.minLength, false, type.target.readonly);
        }
        function widenTypeInferredFromInitializer(declaration, type) {
          var widened = ts2.getCombinedNodeFlags(declaration) & 2 || ts2.isDeclarationReadonly(declaration) ? type : getWidenedLiteralType(type);
          if (ts2.isInJSFile(declaration)) {
            if (widened.flags & 98304) {
              reportImplicitAny(declaration, anyType);
              return anyType;
            } else if (isEmptyArrayLiteralType(widened)) {
              reportImplicitAny(declaration, anyArrayType);
              return anyArrayType;
            }
          }
          return widened;
        }
        function isLiteralOfContextualType(candidateType, contextualType) {
          if (contextualType) {
            if (contextualType.flags & 3145728) {
              var types = contextualType.types;
              return ts2.some(types, function(t) {
                return isLiteralOfContextualType(candidateType, t);
              });
            }
            if (contextualType.flags & 58982400) {
              var constraint = getBaseConstraintOfType(contextualType) || unknownType;
              return maybeTypeOfKind(constraint, 4) && maybeTypeOfKind(candidateType, 128) || maybeTypeOfKind(constraint, 8) && maybeTypeOfKind(candidateType, 256) || maybeTypeOfKind(constraint, 64) && maybeTypeOfKind(candidateType, 2048) || maybeTypeOfKind(constraint, 4096) && maybeTypeOfKind(candidateType, 8192) || isLiteralOfContextualType(candidateType, constraint);
            }
            return !!(contextualType.flags & (128 | 4194304) && maybeTypeOfKind(candidateType, 128) || contextualType.flags & 256 && maybeTypeOfKind(candidateType, 256) || contextualType.flags & 2048 && maybeTypeOfKind(candidateType, 2048) || contextualType.flags & 512 && maybeTypeOfKind(candidateType, 512) || contextualType.flags & 8192 && maybeTypeOfKind(candidateType, 8192));
          }
          return false;
        }
        function isConstContext(node) {
          var parent = node.parent;
          return ts2.isAssertionExpression(parent) && ts2.isConstTypeReference(parent.type) || (ts2.isParenthesizedExpression(parent) || ts2.isArrayLiteralExpression(parent) || ts2.isSpreadElement(parent)) && isConstContext(parent) || (ts2.isPropertyAssignment(parent) || ts2.isShorthandPropertyAssignment(parent)) && isConstContext(parent.parent);
        }
        function checkExpressionForMutableLocation(node, checkMode, contextualType, forceTuple) {
          var type = checkExpression(node, checkMode, forceTuple);
          return isConstContext(node) ? getRegularTypeOfLiteralType(type) : isTypeAssertion(node) ? type : getWidenedLiteralLikeTypeForContextualType(type, instantiateContextualType(arguments.length === 2 ? getContextualType(node) : contextualType, node));
        }
        function checkPropertyAssignment(node, checkMode) {
          if (node.name.kind === 154) {
            checkComputedPropertyName(node.name);
          }
          return checkExpressionForMutableLocation(node.initializer, checkMode);
        }
        function checkObjectLiteralMethod(node, checkMode) {
          checkGrammarMethod(node);
          if (node.name.kind === 154) {
            checkComputedPropertyName(node.name);
          }
          var uninstantiatedType = checkFunctionExpressionOrObjectLiteralMethod(node, checkMode);
          return instantiateTypeWithSingleGenericCallSignature(node, uninstantiatedType, checkMode);
        }
        function instantiateTypeWithSingleGenericCallSignature(node, type, checkMode) {
          if (checkMode && checkMode & (2 | 8)) {
            var callSignature = getSingleSignature(type, 0, true);
            var constructSignature = getSingleSignature(type, 1, true);
            var signature = callSignature || constructSignature;
            if (signature && signature.typeParameters) {
              var contextualType = getApparentTypeOfContextualType(node, 2);
              if (contextualType) {
                var contextualSignature = getSingleSignature(getNonNullableType(contextualType), callSignature ? 0 : 1, false);
                if (contextualSignature && !contextualSignature.typeParameters) {
                  if (checkMode & 8) {
                    skippedGenericFunction(node, checkMode);
                    return anyFunctionType;
                  }
                  var context = getInferenceContext(node);
                  var returnType = context.signature && getReturnTypeOfSignature(context.signature);
                  var returnSignature = returnType && getSingleCallOrConstructSignature(returnType);
                  if (returnSignature && !returnSignature.typeParameters && !ts2.every(context.inferences, hasInferenceCandidates)) {
                    var uniqueTypeParameters = getUniqueTypeParameters(context, signature.typeParameters);
                    var instantiatedSignature = getSignatureInstantiationWithoutFillingInTypeArguments(signature, uniqueTypeParameters);
                    var inferences_3 = ts2.map(context.inferences, function(info) {
                      return createInferenceInfo(info.typeParameter);
                    });
                    applyToParameterTypes(instantiatedSignature, contextualSignature, function(source, target) {
                      inferTypes(inferences_3, source, target, 0, true);
                    });
                    if (ts2.some(inferences_3, hasInferenceCandidates)) {
                      applyToReturnTypes(instantiatedSignature, contextualSignature, function(source, target) {
                        inferTypes(inferences_3, source, target);
                      });
                      if (!hasOverlappingInferences(context.inferences, inferences_3)) {
                        mergeInferences(context.inferences, inferences_3);
                        context.inferredTypeParameters = ts2.concatenate(context.inferredTypeParameters, uniqueTypeParameters);
                        return getOrCreateTypeFromSignature(instantiatedSignature);
                      }
                    }
                  }
                  return getOrCreateTypeFromSignature(instantiateSignatureInContextOf(signature, contextualSignature, context));
                }
              }
            }
          }
          return type;
        }
        function skippedGenericFunction(node, checkMode) {
          if (checkMode & 2) {
            var context = getInferenceContext(node);
            context.flags |= 4;
          }
        }
        function hasInferenceCandidates(info) {
          return !!(info.candidates || info.contraCandidates);
        }
        function hasOverlappingInferences(a, b) {
          for (var i = 0; i < a.length; i++) {
            if (hasInferenceCandidates(a[i]) && hasInferenceCandidates(b[i])) {
              return true;
            }
          }
          return false;
        }
        function mergeInferences(target, source) {
          for (var i = 0; i < target.length; i++) {
            if (!hasInferenceCandidates(target[i]) && hasInferenceCandidates(source[i])) {
              target[i] = source[i];
            }
          }
        }
        function getUniqueTypeParameters(context, typeParameters) {
          var result = [];
          var oldTypeParameters;
          var newTypeParameters;
          for (var _i = 0, typeParameters_2 = typeParameters; _i < typeParameters_2.length; _i++) {
            var tp = typeParameters_2[_i];
            var name = tp.symbol.escapedName;
            if (hasTypeParameterByName(context.inferredTypeParameters, name) || hasTypeParameterByName(result, name)) {
              var newName = getUniqueTypeParameterName(ts2.concatenate(context.inferredTypeParameters, result), name);
              var symbol = createSymbol(262144, newName);
              var newTypeParameter = createTypeParameter(symbol);
              newTypeParameter.target = tp;
              oldTypeParameters = ts2.append(oldTypeParameters, tp);
              newTypeParameters = ts2.append(newTypeParameters, newTypeParameter);
              result.push(newTypeParameter);
            } else {
              result.push(tp);
            }
          }
          if (newTypeParameters) {
            var mapper = createTypeMapper(oldTypeParameters, newTypeParameters);
            for (var _a = 0, newTypeParameters_1 = newTypeParameters; _a < newTypeParameters_1.length; _a++) {
              var tp = newTypeParameters_1[_a];
              tp.mapper = mapper;
            }
          }
          return result;
        }
        function hasTypeParameterByName(typeParameters, name) {
          return ts2.some(typeParameters, function(tp) {
            return tp.symbol.escapedName === name;
          });
        }
        function getUniqueTypeParameterName(typeParameters, baseName) {
          var len = baseName.length;
          while (len > 1 && baseName.charCodeAt(len - 1) >= 48 && baseName.charCodeAt(len - 1) <= 57)
            len--;
          var s = baseName.slice(0, len);
          for (var index = 1; true; index++) {
            var augmentedName = s + index;
            if (!hasTypeParameterByName(typeParameters, augmentedName)) {
              return augmentedName;
            }
          }
        }
        function getReturnTypeOfSingleNonGenericCallSignature(funcType) {
          var signature = getSingleCallSignature(funcType);
          if (signature && !signature.typeParameters) {
            return getReturnTypeOfSignature(signature);
          }
        }
        function getReturnTypeOfSingleNonGenericSignatureOfCallChain(expr) {
          var funcType = checkExpression(expr.expression);
          var nonOptionalType = getOptionalExpressionType(funcType, expr.expression);
          var returnType = getReturnTypeOfSingleNonGenericCallSignature(funcType);
          return returnType && propagateOptionalTypeMarker(returnType, expr, nonOptionalType !== funcType);
        }
        function getTypeOfExpression(node) {
          var quickType = getQuickTypeOfExpression(node);
          if (quickType) {
            return quickType;
          }
          if (node.flags & 67108864 && flowTypeCache) {
            var cachedType = flowTypeCache[getNodeId(node)];
            if (cachedType) {
              return cachedType;
            }
          }
          var startInvocationCount = flowInvocationCount;
          var type = checkExpression(node);
          if (flowInvocationCount !== startInvocationCount) {
            var cache = flowTypeCache || (flowTypeCache = []);
            cache[getNodeId(node)] = type;
            node.flags |= 67108864;
          }
          return type;
        }
        function getQuickTypeOfExpression(node) {
          var expr = ts2.skipParentheses(node);
          if (ts2.isCallExpression(expr) && expr.expression.kind !== 102 && !ts2.isRequireCall(expr, true) && !isSymbolOrSymbolForCall(expr)) {
            var type = ts2.isCallChain(expr) ? getReturnTypeOfSingleNonGenericSignatureOfCallChain(expr) : getReturnTypeOfSingleNonGenericCallSignature(checkNonNullExpression(expr.expression));
            if (type) {
              return type;
            }
          } else if (ts2.isAssertionExpression(expr) && !ts2.isConstTypeReference(expr.type)) {
            return getTypeFromTypeNode(expr.type);
          } else if (node.kind === 8 || node.kind === 10 || node.kind === 106 || node.kind === 91) {
            return checkExpression(node);
          }
          return void 0;
        }
        function getContextFreeTypeOfExpression(node) {
          var links = getNodeLinks(node);
          if (links.contextFreeType) {
            return links.contextFreeType;
          }
          var saveContextualType = node.contextualType;
          node.contextualType = anyType;
          try {
            var type = links.contextFreeType = checkExpression(node, 4);
            return type;
          } finally {
            node.contextualType = saveContextualType;
          }
        }
        function checkExpression(node, checkMode, forceTuple) {
          var saveCurrentNode = currentNode;
          currentNode = node;
          instantiationCount = 0;
          var uninstantiatedType = checkExpressionWorker(node, checkMode, forceTuple);
          var type = instantiateTypeWithSingleGenericCallSignature(node, uninstantiatedType, checkMode);
          if (isConstEnumObjectType(type)) {
            checkConstEnumAccess(node, type);
          }
          currentNode = saveCurrentNode;
          return type;
        }
        function checkConstEnumAccess(node, type) {
          var ok = node.parent.kind === 194 && node.parent.expression === node || node.parent.kind === 195 && node.parent.expression === node || ((node.kind === 75 || node.kind === 153) && isInRightSideOfImportOrExportAssignment(node) || node.parent.kind === 172 && node.parent.exprName === node) || node.parent.kind === 263;
          if (!ok) {
            error(node, ts2.Diagnostics.const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment_or_type_query);
          }
          if (compilerOptions.isolatedModules) {
            ts2.Debug.assert(!!(type.symbol.flags & 128));
            var constEnumDeclaration = type.symbol.valueDeclaration;
            if (constEnumDeclaration.flags & 8388608) {
              error(node, ts2.Diagnostics.Cannot_access_ambient_const_enums_when_the_isolatedModules_flag_is_provided);
            }
          }
        }
        function checkParenthesizedExpression(node, checkMode) {
          var tag = ts2.isInJSFile(node) ? ts2.getJSDocTypeTag(node) : void 0;
          if (tag) {
            return checkAssertionWorker(tag, tag.typeExpression.type, node.expression, checkMode);
          }
          return checkExpression(node.expression, checkMode);
        }
        function checkExpressionWorker(node, checkMode, forceTuple) {
          var kind = node.kind;
          if (cancellationToken) {
            switch (kind) {
              case 214:
              case 201:
              case 202:
                cancellationToken.throwIfCancellationRequested();
            }
          }
          switch (kind) {
            case 75:
              return checkIdentifier(node);
            case 104:
              return checkThisExpression(node);
            case 102:
              return checkSuperExpression(node);
            case 100:
              return nullWideningType;
            case 14:
            case 10:
              return getFreshTypeOfLiteralType(getLiteralType(node.text));
            case 8:
              checkGrammarNumericLiteral(node);
              return getFreshTypeOfLiteralType(getLiteralType(+node.text));
            case 9:
              checkGrammarBigIntLiteral(node);
              return getFreshTypeOfLiteralType(getBigIntLiteralType(node));
            case 106:
              return trueType;
            case 91:
              return falseType;
            case 211:
              return checkTemplateExpression(node);
            case 13:
              return globalRegExpType;
            case 192:
              return checkArrayLiteral(node, checkMode, forceTuple);
            case 193:
              return checkObjectLiteral(node, checkMode);
            case 194:
              return checkPropertyAccessExpression(node);
            case 153:
              return checkQualifiedName(node);
            case 195:
              return checkIndexedAccess(node);
            case 196:
              if (node.expression.kind === 96) {
                return checkImportCallExpression(node);
              }
            case 197:
              return checkCallExpression(node, checkMode);
            case 198:
              return checkTaggedTemplateExpression(node);
            case 200:
              return checkParenthesizedExpression(node, checkMode);
            case 214:
              return checkClassExpression(node);
            case 201:
            case 202:
              return checkFunctionExpressionOrObjectLiteralMethod(node, checkMode);
            case 204:
              return checkTypeOfExpression(node);
            case 199:
            case 217:
              return checkAssertion(node);
            case 218:
              return checkNonNullAssertion(node);
            case 219:
              return checkMetaProperty(node);
            case 203:
              return checkDeleteExpression(node);
            case 205:
              return checkVoidExpression(node);
            case 206:
              return checkAwaitExpression(node);
            case 207:
              return checkPrefixUnaryExpression(node);
            case 208:
              return checkPostfixUnaryExpression(node);
            case 209:
              return checkBinaryExpression(node, checkMode);
            case 210:
              return checkConditionalExpression(node, checkMode);
            case 213:
              return checkSpreadExpression(node, checkMode);
            case 215:
              return undefinedWideningType;
            case 212:
              return checkYieldExpression(node);
            case 220:
              return node.type;
            case 276:
              return checkJsxExpression(node, checkMode);
            case 266:
              return checkJsxElement(node, checkMode);
            case 267:
              return checkJsxSelfClosingElement(node, checkMode);
            case 270:
              return checkJsxFragment(node);
            case 274:
              return checkJsxAttributes(node, checkMode);
            case 268:
              ts2.Debug.fail("Shouldn't ever directly check a JsxOpeningElement");
          }
          return errorType;
        }
        function checkTypeParameter(node) {
          if (node.expression) {
            grammarErrorOnFirstToken(node.expression, ts2.Diagnostics.Type_expected);
          }
          checkSourceElement(node.constraint);
          checkSourceElement(node.default);
          var typeParameter = getDeclaredTypeOfTypeParameter(getSymbolOfNode(node));
          getBaseConstraintOfType(typeParameter);
          if (!hasNonCircularTypeParameterDefault(typeParameter)) {
            error(node.default, ts2.Diagnostics.Type_parameter_0_has_a_circular_default, typeToString(typeParameter));
          }
          var constraintType = getConstraintOfTypeParameter(typeParameter);
          var defaultType = getDefaultFromTypeParameter(typeParameter);
          if (constraintType && defaultType) {
            checkTypeAssignableTo(defaultType, getTypeWithThisArgument(instantiateType(constraintType, makeUnaryTypeMapper(typeParameter, defaultType)), defaultType), node.default, ts2.Diagnostics.Type_0_does_not_satisfy_the_constraint_1);
          }
          if (produceDiagnostics) {
            checkTypeNameIsReserved(node.name, ts2.Diagnostics.Type_parameter_name_cannot_be_0);
          }
        }
        function checkParameter(node) {
          checkGrammarDecoratorsAndModifiers(node);
          checkVariableLikeDeclaration(node);
          var func = ts2.getContainingFunction(node);
          if (ts2.hasModifier(node, 92)) {
            if (!(func.kind === 162 && ts2.nodeIsPresent(func.body))) {
              error(node, ts2.Diagnostics.A_parameter_property_is_only_allowed_in_a_constructor_implementation);
            }
            if (func.kind === 162 && ts2.isIdentifier(node.name) && node.name.escapedText === "constructor") {
              error(node.name, ts2.Diagnostics.constructor_cannot_be_used_as_a_parameter_property_name);
            }
          }
          if (node.questionToken && ts2.isBindingPattern(node.name) && func.body) {
            error(node, ts2.Diagnostics.A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature);
          }
          if (node.name && ts2.isIdentifier(node.name) && (node.name.escapedText === "this" || node.name.escapedText === "new")) {
            if (func.parameters.indexOf(node) !== 0) {
              error(node, ts2.Diagnostics.A_0_parameter_must_be_the_first_parameter, node.name.escapedText);
            }
            if (func.kind === 162 || func.kind === 166 || func.kind === 171) {
              error(node, ts2.Diagnostics.A_constructor_cannot_have_a_this_parameter);
            }
            if (func.kind === 202) {
              error(node, ts2.Diagnostics.An_arrow_function_cannot_have_a_this_parameter);
            }
            if (func.kind === 163 || func.kind === 164) {
              error(node, ts2.Diagnostics.get_and_set_accessors_cannot_declare_this_parameters);
            }
          }
          if (node.dotDotDotToken && !ts2.isBindingPattern(node.name) && !isTypeAssignableTo(getReducedType(getTypeOfSymbol(node.symbol)), anyReadonlyArrayType)) {
            error(node, ts2.Diagnostics.A_rest_parameter_must_be_of_an_array_type);
          }
        }
        function checkTypePredicate(node) {
          var parent = getTypePredicateParent(node);
          if (!parent) {
            error(node, ts2.Diagnostics.A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods);
            return;
          }
          var signature = getSignatureFromDeclaration(parent);
          var typePredicate = getTypePredicateOfSignature(signature);
          if (!typePredicate) {
            return;
          }
          checkSourceElement(node.type);
          var parameterName = node.parameterName;
          if (typePredicate.kind === 0 || typePredicate.kind === 2) {
            getTypeFromThisTypeNode(parameterName);
          } else {
            if (typePredicate.parameterIndex >= 0) {
              if (signatureHasRestParameter(signature) && typePredicate.parameterIndex === signature.parameters.length - 1) {
                error(parameterName, ts2.Diagnostics.A_type_predicate_cannot_reference_a_rest_parameter);
              } else {
                if (typePredicate.type) {
                  var leadingError = function() {
                    return ts2.chainDiagnosticMessages(void 0, ts2.Diagnostics.A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type);
                  };
                  checkTypeAssignableTo(typePredicate.type, getTypeOfSymbol(signature.parameters[typePredicate.parameterIndex]), node.type, void 0, leadingError);
                }
              }
            } else if (parameterName) {
              var hasReportedError = false;
              for (var _i = 0, _a = parent.parameters; _i < _a.length; _i++) {
                var name = _a[_i].name;
                if (ts2.isBindingPattern(name) && checkIfTypePredicateVariableIsDeclaredInBindingPattern(name, parameterName, typePredicate.parameterName)) {
                  hasReportedError = true;
                  break;
                }
              }
              if (!hasReportedError) {
                error(node.parameterName, ts2.Diagnostics.Cannot_find_parameter_0, typePredicate.parameterName);
              }
            }
          }
        }
        function getTypePredicateParent(node) {
          switch (node.parent.kind) {
            case 202:
            case 165:
            case 244:
            case 201:
            case 170:
            case 161:
            case 160:
              var parent = node.parent;
              if (node === parent.type) {
                return parent;
              }
          }
        }
        function checkIfTypePredicateVariableIsDeclaredInBindingPattern(pattern, predicateVariableNode, predicateVariableName) {
          for (var _i = 0, _a = pattern.elements; _i < _a.length; _i++) {
            var element = _a[_i];
            if (ts2.isOmittedExpression(element)) {
              continue;
            }
            var name = element.name;
            if (name.kind === 75 && name.escapedText === predicateVariableName) {
              error(predicateVariableNode, ts2.Diagnostics.A_type_predicate_cannot_reference_element_0_in_a_binding_pattern, predicateVariableName);
              return true;
            } else if (name.kind === 190 || name.kind === 189) {
              if (checkIfTypePredicateVariableIsDeclaredInBindingPattern(name, predicateVariableNode, predicateVariableName)) {
                return true;
              }
            }
          }
        }
        function checkSignatureDeclaration(node) {
          if (node.kind === 167) {
            checkGrammarIndexSignature(node);
          } else if (node.kind === 170 || node.kind === 244 || node.kind === 171 || node.kind === 165 || node.kind === 162 || node.kind === 166) {
            checkGrammarFunctionLikeDeclaration(node);
          }
          var functionFlags = ts2.getFunctionFlags(node);
          if (!(functionFlags & 4)) {
            if ((functionFlags & 3) === 3 && languageVersion < 99) {
              checkExternalEmitHelpers(node, 12288);
            }
            if ((functionFlags & 3) === 2 && languageVersion < 4) {
              checkExternalEmitHelpers(node, 64);
            }
            if ((functionFlags & 3) !== 0 && languageVersion < 2) {
              checkExternalEmitHelpers(node, 128);
            }
          }
          checkTypeParameters(node.typeParameters);
          ts2.forEach(node.parameters, checkParameter);
          if (node.type) {
            checkSourceElement(node.type);
          }
          if (produceDiagnostics) {
            checkCollisionWithArgumentsInGeneratedCode(node);
            var returnTypeNode = ts2.getEffectiveReturnTypeNode(node);
            if (noImplicitAny && !returnTypeNode) {
              switch (node.kind) {
                case 166:
                  error(node, ts2.Diagnostics.Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);
                  break;
                case 165:
                  error(node, ts2.Diagnostics.Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);
                  break;
              }
            }
            if (returnTypeNode) {
              var functionFlags_1 = ts2.getFunctionFlags(node);
              if ((functionFlags_1 & (4 | 1)) === 1) {
                var returnType = getTypeFromTypeNode(returnTypeNode);
                if (returnType === voidType) {
                  error(returnTypeNode, ts2.Diagnostics.A_generator_cannot_have_a_void_type_annotation);
                } else {
                  var generatorYieldType = getIterationTypeOfGeneratorFunctionReturnType(0, returnType, (functionFlags_1 & 2) !== 0) || anyType;
                  var generatorReturnType = getIterationTypeOfGeneratorFunctionReturnType(1, returnType, (functionFlags_1 & 2) !== 0) || generatorYieldType;
                  var generatorNextType = getIterationTypeOfGeneratorFunctionReturnType(2, returnType, (functionFlags_1 & 2) !== 0) || unknownType;
                  var generatorInstantiation = createGeneratorReturnType(generatorYieldType, generatorReturnType, generatorNextType, !!(functionFlags_1 & 2));
                  checkTypeAssignableTo(generatorInstantiation, returnType, returnTypeNode);
                }
              } else if ((functionFlags_1 & 3) === 2) {
                checkAsyncFunctionReturnType(node, returnTypeNode);
              }
            }
            if (node.kind !== 167 && node.kind !== 300) {
              registerForUnusedIdentifiersCheck(node);
            }
          }
        }
        function checkClassForDuplicateDeclarations(node) {
          var instanceNames = ts2.createUnderscoreEscapedMap();
          var staticNames = ts2.createUnderscoreEscapedMap();
          var privateIdentifiers = ts2.createUnderscoreEscapedMap();
          for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
            var member = _a[_i];
            if (member.kind === 162) {
              for (var _b = 0, _c = member.parameters; _b < _c.length; _b++) {
                var param = _c[_b];
                if (ts2.isParameterPropertyDeclaration(param, member) && !ts2.isBindingPattern(param.name)) {
                  addName(instanceNames, param.name, param.name.escapedText, 3);
                }
              }
            } else {
              var isStatic = ts2.hasModifier(member, 32);
              var name = member.name;
              if (!name) {
                return;
              }
              var names = ts2.isPrivateIdentifier(name) ? privateIdentifiers : isStatic ? staticNames : instanceNames;
              var memberName = name && ts2.getPropertyNameForPropertyNameNode(name);
              if (memberName) {
                switch (member.kind) {
                  case 163:
                    addName(names, name, memberName, 1);
                    break;
                  case 164:
                    addName(names, name, memberName, 2);
                    break;
                  case 159:
                    addName(names, name, memberName, 3);
                    break;
                  case 161:
                    addName(names, name, memberName, 8);
                    break;
                }
              }
            }
          }
          function addName(names2, location, name2, meaning) {
            var prev = names2.get(name2);
            if (prev) {
              if (prev & 8) {
                if (meaning !== 8) {
                  error(location, ts2.Diagnostics.Duplicate_identifier_0, ts2.getTextOfNode(location));
                }
              } else if (prev & meaning) {
                error(location, ts2.Diagnostics.Duplicate_identifier_0, ts2.getTextOfNode(location));
              } else {
                names2.set(name2, prev | meaning);
              }
            } else {
              names2.set(name2, meaning);
            }
          }
        }
        function checkClassForStaticPropertyNameConflicts(node) {
          for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
            var member = _a[_i];
            var memberNameNode = member.name;
            var isStatic = ts2.hasModifier(member, 32);
            if (isStatic && memberNameNode) {
              var memberName = ts2.getPropertyNameForPropertyNameNode(memberNameNode);
              switch (memberName) {
                case "name":
                case "length":
                case "caller":
                case "arguments":
                case "prototype":
                  var message = ts2.Diagnostics.Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1;
                  var className = getNameOfSymbolAsWritten(getSymbolOfNode(node));
                  error(memberNameNode, message, memberName, className);
                  break;
              }
            }
          }
        }
        function checkObjectTypeForDuplicateDeclarations(node) {
          var names = ts2.createMap();
          for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
            var member = _a[_i];
            if (member.kind === 158) {
              var memberName = void 0;
              var name = member.name;
              switch (name.kind) {
                case 10:
                case 8:
                  memberName = name.text;
                  break;
                case 75:
                  memberName = ts2.idText(name);
                  break;
                default:
                  continue;
              }
              if (names.get(memberName)) {
                error(ts2.getNameOfDeclaration(member.symbol.valueDeclaration), ts2.Diagnostics.Duplicate_identifier_0, memberName);
                error(member.name, ts2.Diagnostics.Duplicate_identifier_0, memberName);
              } else {
                names.set(memberName, true);
              }
            }
          }
        }
        function checkTypeForDuplicateIndexSignatures(node) {
          if (node.kind === 246) {
            var nodeSymbol = getSymbolOfNode(node);
            if (nodeSymbol.declarations.length > 0 && nodeSymbol.declarations[0] !== node) {
              return;
            }
          }
          var indexSymbol = getIndexSymbol(getSymbolOfNode(node));
          if (indexSymbol) {
            var seenNumericIndexer = false;
            var seenStringIndexer = false;
            for (var _i = 0, _a = indexSymbol.declarations; _i < _a.length; _i++) {
              var decl = _a[_i];
              var declaration = decl;
              if (declaration.parameters.length === 1 && declaration.parameters[0].type) {
                switch (declaration.parameters[0].type.kind) {
                  case 143:
                    if (!seenStringIndexer) {
                      seenStringIndexer = true;
                    } else {
                      error(declaration, ts2.Diagnostics.Duplicate_string_index_signature);
                    }
                    break;
                  case 140:
                    if (!seenNumericIndexer) {
                      seenNumericIndexer = true;
                    } else {
                      error(declaration, ts2.Diagnostics.Duplicate_number_index_signature);
                    }
                    break;
                }
              }
            }
          }
        }
        function checkPropertyDeclaration(node) {
          if (!checkGrammarDecoratorsAndModifiers(node) && !checkGrammarProperty(node))
            checkGrammarComputedPropertyName(node.name);
          checkVariableLikeDeclaration(node);
          if (ts2.isPrivateIdentifier(node.name) && languageVersion < 99) {
            for (var lexicalScope = ts2.getEnclosingBlockScopeContainer(node); !!lexicalScope; lexicalScope = ts2.getEnclosingBlockScopeContainer(lexicalScope)) {
              getNodeLinks(lexicalScope).flags |= 67108864;
            }
          }
        }
        function checkPropertySignature(node) {
          if (ts2.isPrivateIdentifier(node.name)) {
            error(node, ts2.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
          }
          return checkPropertyDeclaration(node);
        }
        function checkMethodDeclaration(node) {
          if (!checkGrammarMethod(node))
            checkGrammarComputedPropertyName(node.name);
          if (ts2.isPrivateIdentifier(node.name)) {
            error(node, ts2.Diagnostics.A_method_cannot_be_named_with_a_private_identifier);
          }
          checkFunctionOrMethodDeclaration(node);
          if (ts2.hasModifier(node, 128) && node.kind === 161 && node.body) {
            error(node, ts2.Diagnostics.Method_0_cannot_have_an_implementation_because_it_is_marked_abstract, ts2.declarationNameToString(node.name));
          }
        }
        function checkConstructorDeclaration(node) {
          checkSignatureDeclaration(node);
          if (!checkGrammarConstructorTypeParameters(node))
            checkGrammarConstructorTypeAnnotation(node);
          checkSourceElement(node.body);
          var symbol = getSymbolOfNode(node);
          var firstDeclaration = ts2.getDeclarationOfKind(symbol, node.kind);
          if (node === firstDeclaration) {
            checkFunctionOrConstructorSymbol(symbol);
          }
          if (ts2.nodeIsMissing(node.body)) {
            return;
          }
          if (!produceDiagnostics) {
            return;
          }
          function isInstancePropertyWithInitializerOrPrivateIdentifierProperty(n) {
            if (ts2.isPrivateIdentifierPropertyDeclaration(n)) {
              return true;
            }
            return n.kind === 159 && !ts2.hasModifier(n, 32) && !!n.initializer;
          }
          var containingClassDecl = node.parent;
          if (ts2.getClassExtendsHeritageElement(containingClassDecl)) {
            captureLexicalThis(node.parent, containingClassDecl);
            var classExtendsNull = classDeclarationExtendsNull(containingClassDecl);
            var superCall = getSuperCallInConstructor(node);
            if (superCall) {
              if (classExtendsNull) {
                error(superCall, ts2.Diagnostics.A_constructor_cannot_contain_a_super_call_when_its_class_extends_null);
              }
              var superCallShouldBeFirst = (compilerOptions.target !== 99 || !compilerOptions.useDefineForClassFields) && (ts2.some(node.parent.members, isInstancePropertyWithInitializerOrPrivateIdentifierProperty) || ts2.some(node.parameters, function(p) {
                return ts2.hasModifier(p, 92);
              }));
              if (superCallShouldBeFirst) {
                var statements = node.body.statements;
                var superCallStatement = void 0;
                for (var _i = 0, statements_3 = statements; _i < statements_3.length; _i++) {
                  var statement = statements_3[_i];
                  if (statement.kind === 226 && ts2.isSuperCall(statement.expression)) {
                    superCallStatement = statement;
                    break;
                  }
                  if (!ts2.isPrologueDirective(statement)) {
                    break;
                  }
                }
                if (!superCallStatement) {
                  error(node, ts2.Diagnostics.A_super_call_must_be_the_first_statement_in_the_constructor_when_a_class_contains_initialized_properties_parameter_properties_or_private_identifiers);
                }
              }
            } else if (!classExtendsNull) {
              error(node, ts2.Diagnostics.Constructors_for_derived_classes_must_contain_a_super_call);
            }
          }
        }
        function checkAccessorDeclaration(node) {
          if (produceDiagnostics) {
            if (!checkGrammarFunctionLikeDeclaration(node) && !checkGrammarAccessor(node))
              checkGrammarComputedPropertyName(node.name);
            checkDecorators(node);
            checkSignatureDeclaration(node);
            if (node.kind === 163) {
              if (!(node.flags & 8388608) && ts2.nodeIsPresent(node.body) && node.flags & 256) {
                if (!(node.flags & 512)) {
                  error(node.name, ts2.Diagnostics.A_get_accessor_must_return_a_value);
                }
              }
            }
            if (node.name.kind === 154) {
              checkComputedPropertyName(node.name);
            }
            if (ts2.isPrivateIdentifier(node.name)) {
              error(node.name, ts2.Diagnostics.An_accessor_cannot_be_named_with_a_private_identifier);
            }
            if (!hasNonBindableDynamicName(node)) {
              var otherKind = node.kind === 163 ? 164 : 163;
              var otherAccessor = ts2.getDeclarationOfKind(getSymbolOfNode(node), otherKind);
              if (otherAccessor) {
                var nodeFlags = ts2.getModifierFlags(node);
                var otherFlags = ts2.getModifierFlags(otherAccessor);
                if ((nodeFlags & 28) !== (otherFlags & 28)) {
                  error(node.name, ts2.Diagnostics.Getter_and_setter_accessors_do_not_agree_in_visibility);
                }
                if ((nodeFlags & 128) !== (otherFlags & 128)) {
                  error(node.name, ts2.Diagnostics.Accessors_must_both_be_abstract_or_non_abstract);
                }
                checkAccessorDeclarationTypesIdentical(node, otherAccessor, getAnnotatedAccessorType, ts2.Diagnostics.get_and_set_accessor_must_have_the_same_type);
                checkAccessorDeclarationTypesIdentical(node, otherAccessor, getThisTypeOfDeclaration, ts2.Diagnostics.get_and_set_accessor_must_have_the_same_this_type);
              }
            }
            var returnType = getTypeOfAccessors(getSymbolOfNode(node));
            if (node.kind === 163) {
              checkAllCodePathsInNonVoidFunctionReturnOrThrow(node, returnType);
            }
          }
          checkSourceElement(node.body);
        }
        function checkAccessorDeclarationTypesIdentical(first, second, getAnnotatedType, message) {
          var firstType = getAnnotatedType(first);
          var secondType = getAnnotatedType(second);
          if (firstType && secondType && !isTypeIdenticalTo(firstType, secondType)) {
            error(first, message);
          }
        }
        function checkMissingDeclaration(node) {
          checkDecorators(node);
        }
        function getEffectiveTypeArguments(node, typeParameters) {
          return fillMissingTypeArguments(ts2.map(node.typeArguments, getTypeFromTypeNode), typeParameters, getMinTypeArgumentCount(typeParameters), ts2.isInJSFile(node));
        }
        function checkTypeArgumentConstraints(node, typeParameters) {
          var typeArguments;
          var mapper;
          var result = true;
          for (var i = 0; i < typeParameters.length; i++) {
            var constraint = getConstraintOfTypeParameter(typeParameters[i]);
            if (constraint) {
              if (!typeArguments) {
                typeArguments = getEffectiveTypeArguments(node, typeParameters);
                mapper = createTypeMapper(typeParameters, typeArguments);
              }
              result = result && checkTypeAssignableTo(typeArguments[i], instantiateType(constraint, mapper), node.typeArguments[i], ts2.Diagnostics.Type_0_does_not_satisfy_the_constraint_1);
            }
          }
          return result;
        }
        function getTypeParametersForTypeReference(node) {
          var type = getTypeFromTypeReference(node);
          if (type !== errorType) {
            var symbol = getNodeLinks(node).resolvedSymbol;
            if (symbol) {
              return symbol.flags & 524288 && getSymbolLinks(symbol).typeParameters || (ts2.getObjectFlags(type) & 4 ? type.target.localTypeParameters : void 0);
            }
          }
          return void 0;
        }
        function checkTypeReferenceNode(node) {
          checkGrammarTypeArguments(node, node.typeArguments);
          if (node.kind === 169 && node.typeName.jsdocDotPos !== void 0 && !ts2.isInJSFile(node) && !ts2.isInJSDoc(node)) {
            grammarErrorAtPos(node, node.typeName.jsdocDotPos, 1, ts2.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments);
          }
          ts2.forEach(node.typeArguments, checkSourceElement);
          var type = getTypeFromTypeReference(node);
          if (type !== errorType) {
            if (node.typeArguments && produceDiagnostics) {
              var typeParameters = getTypeParametersForTypeReference(node);
              if (typeParameters) {
                checkTypeArgumentConstraints(node, typeParameters);
              }
            }
            if (type.flags & 32 && getNodeLinks(node).resolvedSymbol.flags & 8) {
              error(node, ts2.Diagnostics.Enum_type_0_has_members_with_initializers_that_are_not_literals, typeToString(type));
            }
          }
        }
        function getTypeArgumentConstraint(node) {
          var typeReferenceNode = ts2.tryCast(node.parent, ts2.isTypeReferenceType);
          if (!typeReferenceNode)
            return void 0;
          var typeParameters = getTypeParametersForTypeReference(typeReferenceNode);
          var constraint = getConstraintOfTypeParameter(typeParameters[typeReferenceNode.typeArguments.indexOf(node)]);
          return constraint && instantiateType(constraint, createTypeMapper(typeParameters, getEffectiveTypeArguments(typeReferenceNode, typeParameters)));
        }
        function checkTypeQuery(node) {
          getTypeFromTypeQueryNode(node);
        }
        function checkTypeLiteral(node) {
          ts2.forEach(node.members, checkSourceElement);
          if (produceDiagnostics) {
            var type = getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node);
            checkIndexConstraints(type);
            checkTypeForDuplicateIndexSignatures(node);
            checkObjectTypeForDuplicateDeclarations(node);
          }
        }
        function checkArrayType(node) {
          checkSourceElement(node.elementType);
        }
        function checkTupleType(node) {
          var elementTypes = node.elementTypes;
          var seenOptionalElement = false;
          for (var i = 0; i < elementTypes.length; i++) {
            var e = elementTypes[i];
            if (e.kind === 177) {
              if (i !== elementTypes.length - 1) {
                grammarErrorOnNode(e, ts2.Diagnostics.A_rest_element_must_be_last_in_a_tuple_type);
                break;
              }
              if (!isArrayType(getTypeFromTypeNode(e.type))) {
                error(e, ts2.Diagnostics.A_rest_element_type_must_be_an_array_type);
              }
            } else if (e.kind === 176) {
              seenOptionalElement = true;
            } else if (seenOptionalElement) {
              grammarErrorOnNode(e, ts2.Diagnostics.A_required_element_cannot_follow_an_optional_element);
              break;
            }
          }
          ts2.forEach(node.elementTypes, checkSourceElement);
        }
        function checkUnionOrIntersectionType(node) {
          ts2.forEach(node.types, checkSourceElement);
        }
        function checkIndexedAccessIndexType(type, accessNode) {
          if (!(type.flags & 8388608)) {
            return type;
          }
          var objectType = type.objectType;
          var indexType = type.indexType;
          if (isTypeAssignableTo(indexType, getIndexType(objectType, false))) {
            if (accessNode.kind === 195 && ts2.isAssignmentTarget(accessNode) && ts2.getObjectFlags(objectType) & 32 && getMappedTypeModifiers(objectType) & 1) {
              error(accessNode, ts2.Diagnostics.Index_signature_in_type_0_only_permits_reading, typeToString(objectType));
            }
            return type;
          }
          var apparentObjectType = getApparentType(objectType);
          if (getIndexInfoOfType(apparentObjectType, 1) && isTypeAssignableToKind(indexType, 296)) {
            return type;
          }
          if (isGenericObjectType(objectType)) {
            var propertyName_1 = getPropertyNameFromIndex(indexType, accessNode);
            if (propertyName_1) {
              var propertySymbol = forEachType(apparentObjectType, function(t) {
                return getPropertyOfType(t, propertyName_1);
              });
              if (propertySymbol && ts2.getDeclarationModifierFlagsFromSymbol(propertySymbol) & 24) {
                error(accessNode, ts2.Diagnostics.Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter, ts2.unescapeLeadingUnderscores(propertyName_1));
                return errorType;
              }
            }
          }
          error(accessNode, ts2.Diagnostics.Type_0_cannot_be_used_to_index_type_1, typeToString(indexType), typeToString(objectType));
          return errorType;
        }
        function checkIndexedAccessType(node) {
          checkSourceElement(node.objectType);
          checkSourceElement(node.indexType);
          checkIndexedAccessIndexType(getTypeFromIndexedAccessTypeNode(node), node);
        }
        function checkMappedType(node) {
          checkSourceElement(node.typeParameter);
          checkSourceElement(node.type);
          if (!node.type) {
            reportImplicitAny(node, anyType);
          }
          var type = getTypeFromMappedTypeNode(node);
          var constraintType = getConstraintTypeFromMappedType(type);
          checkTypeAssignableTo(constraintType, keyofConstraintType, ts2.getEffectiveConstraintOfTypeParameter(node.typeParameter));
        }
        function checkThisType(node) {
          getTypeFromThisTypeNode(node);
        }
        function checkTypeOperator(node) {
          checkGrammarTypeOperatorNode(node);
          checkSourceElement(node.type);
        }
        function checkConditionalType(node) {
          ts2.forEachChild(node, checkSourceElement);
        }
        function checkInferType(node) {
          if (!ts2.findAncestor(node, function(n) {
            return n.parent && n.parent.kind === 180 && n.parent.extendsType === n;
          })) {
            grammarErrorOnNode(node, ts2.Diagnostics.infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type);
          }
          checkSourceElement(node.typeParameter);
          registerForUnusedIdentifiersCheck(node);
        }
        function checkImportType(node) {
          checkSourceElement(node.argument);
          getTypeFromTypeNode(node);
        }
        function isPrivateWithinAmbient(node) {
          return (ts2.hasModifier(node, 8) || ts2.isPrivateIdentifierPropertyDeclaration(node)) && !!(node.flags & 8388608);
        }
        function getEffectiveDeclarationFlags(n, flagsToCheck) {
          var flags = ts2.getCombinedModifierFlags(n);
          if (n.parent.kind !== 246 && n.parent.kind !== 245 && n.parent.kind !== 214 && n.flags & 8388608) {
            if (!(flags & 2) && !(ts2.isModuleBlock(n.parent) && ts2.isModuleDeclaration(n.parent.parent) && ts2.isGlobalScopeAugmentation(n.parent.parent))) {
              flags |= 1;
            }
            flags |= 2;
          }
          return flags & flagsToCheck;
        }
        function checkFunctionOrConstructorSymbol(symbol) {
          if (!produceDiagnostics) {
            return;
          }
          function getCanonicalOverload(overloads, implementation) {
            var implementationSharesContainerWithFirstOverload = implementation !== void 0 && implementation.parent === overloads[0].parent;
            return implementationSharesContainerWithFirstOverload ? implementation : overloads[0];
          }
          function checkFlagAgreementBetweenOverloads(overloads, implementation, flagsToCheck2, someOverloadFlags, allOverloadFlags) {
            var someButNotAllOverloadFlags = someOverloadFlags ^ allOverloadFlags;
            if (someButNotAllOverloadFlags !== 0) {
              var canonicalFlags_1 = getEffectiveDeclarationFlags(getCanonicalOverload(overloads, implementation), flagsToCheck2);
              ts2.forEach(overloads, function(o) {
                var deviation = getEffectiveDeclarationFlags(o, flagsToCheck2) ^ canonicalFlags_1;
                if (deviation & 1) {
                  error(ts2.getNameOfDeclaration(o), ts2.Diagnostics.Overload_signatures_must_all_be_exported_or_non_exported);
                } else if (deviation & 2) {
                  error(ts2.getNameOfDeclaration(o), ts2.Diagnostics.Overload_signatures_must_all_be_ambient_or_non_ambient);
                } else if (deviation & (8 | 16)) {
                  error(ts2.getNameOfDeclaration(o) || o, ts2.Diagnostics.Overload_signatures_must_all_be_public_private_or_protected);
                } else if (deviation & 128) {
                  error(ts2.getNameOfDeclaration(o), ts2.Diagnostics.Overload_signatures_must_all_be_abstract_or_non_abstract);
                }
              });
            }
          }
          function checkQuestionTokenAgreementBetweenOverloads(overloads, implementation, someHaveQuestionToken2, allHaveQuestionToken2) {
            if (someHaveQuestionToken2 !== allHaveQuestionToken2) {
              var canonicalHasQuestionToken_1 = ts2.hasQuestionToken(getCanonicalOverload(overloads, implementation));
              ts2.forEach(overloads, function(o) {
                var deviation = ts2.hasQuestionToken(o) !== canonicalHasQuestionToken_1;
                if (deviation) {
                  error(ts2.getNameOfDeclaration(o), ts2.Diagnostics.Overload_signatures_must_all_be_optional_or_required);
                }
              });
            }
          }
          var flagsToCheck = 1 | 2 | 8 | 16 | 128;
          var someNodeFlags = 0;
          var allNodeFlags = flagsToCheck;
          var someHaveQuestionToken = false;
          var allHaveQuestionToken = true;
          var hasOverloads = false;
          var bodyDeclaration;
          var lastSeenNonAmbientDeclaration;
          var previousDeclaration;
          var declarations = symbol.declarations;
          var isConstructor = (symbol.flags & 16384) !== 0;
          function reportImplementationExpectedError(node2) {
            if (node2.name && ts2.nodeIsMissing(node2.name)) {
              return;
            }
            var seen = false;
            var subsequentNode = ts2.forEachChild(node2.parent, function(c) {
              if (seen) {
                return c;
              } else {
                seen = c === node2;
              }
            });
            if (subsequentNode && subsequentNode.pos === node2.end) {
              if (subsequentNode.kind === node2.kind) {
                var errorNode_1 = subsequentNode.name || subsequentNode;
                var subsequentName = subsequentNode.name;
                if (node2.name && subsequentName && (ts2.isPrivateIdentifier(node2.name) && ts2.isPrivateIdentifier(subsequentName) && node2.name.escapedText === subsequentName.escapedText || ts2.isComputedPropertyName(node2.name) && ts2.isComputedPropertyName(subsequentName) || ts2.isPropertyNameLiteral(node2.name) && ts2.isPropertyNameLiteral(subsequentName) && ts2.getEscapedTextOfIdentifierOrLiteral(node2.name) === ts2.getEscapedTextOfIdentifierOrLiteral(subsequentName))) {
                  var reportError = (node2.kind === 161 || node2.kind === 160) && ts2.hasModifier(node2, 32) !== ts2.hasModifier(subsequentNode, 32);
                  if (reportError) {
                    var diagnostic = ts2.hasModifier(node2, 32) ? ts2.Diagnostics.Function_overload_must_be_static : ts2.Diagnostics.Function_overload_must_not_be_static;
                    error(errorNode_1, diagnostic);
                  }
                  return;
                }
                if (ts2.nodeIsPresent(subsequentNode.body)) {
                  error(errorNode_1, ts2.Diagnostics.Function_implementation_name_must_be_0, ts2.declarationNameToString(node2.name));
                  return;
                }
              }
            }
            var errorNode = node2.name || node2;
            if (isConstructor) {
              error(errorNode, ts2.Diagnostics.Constructor_implementation_is_missing);
            } else {
              if (ts2.hasModifier(node2, 128)) {
                error(errorNode, ts2.Diagnostics.All_declarations_of_an_abstract_method_must_be_consecutive);
              } else {
                error(errorNode, ts2.Diagnostics.Function_implementation_is_missing_or_not_immediately_following_the_declaration);
              }
            }
          }
          var duplicateFunctionDeclaration = false;
          var multipleConstructorImplementation = false;
          var hasNonAmbientClass = false;
          for (var _i = 0, declarations_4 = declarations; _i < declarations_4.length; _i++) {
            var current = declarations_4[_i];
            var node = current;
            var inAmbientContext = node.flags & 8388608;
            var inAmbientContextOrInterface = node.parent.kind === 246 || node.parent.kind === 173 || inAmbientContext;
            if (inAmbientContextOrInterface) {
              previousDeclaration = void 0;
            }
            if ((node.kind === 245 || node.kind === 214) && !inAmbientContext) {
              hasNonAmbientClass = true;
            }
            if (node.kind === 244 || node.kind === 161 || node.kind === 160 || node.kind === 162) {
              var currentNodeFlags = getEffectiveDeclarationFlags(node, flagsToCheck);
              someNodeFlags |= currentNodeFlags;
              allNodeFlags &= currentNodeFlags;
              someHaveQuestionToken = someHaveQuestionToken || ts2.hasQuestionToken(node);
              allHaveQuestionToken = allHaveQuestionToken && ts2.hasQuestionToken(node);
              if (ts2.nodeIsPresent(node.body) && bodyDeclaration) {
                if (isConstructor) {
                  multipleConstructorImplementation = true;
                } else {
                  duplicateFunctionDeclaration = true;
                }
              } else if (previousDeclaration && previousDeclaration.parent === node.parent && previousDeclaration.end !== node.pos) {
                reportImplementationExpectedError(previousDeclaration);
              }
              if (ts2.nodeIsPresent(node.body)) {
                if (!bodyDeclaration) {
                  bodyDeclaration = node;
                }
              } else {
                hasOverloads = true;
              }
              previousDeclaration = node;
              if (!inAmbientContextOrInterface) {
                lastSeenNonAmbientDeclaration = node;
              }
            }
          }
          if (multipleConstructorImplementation) {
            ts2.forEach(declarations, function(declaration) {
              error(declaration, ts2.Diagnostics.Multiple_constructor_implementations_are_not_allowed);
            });
          }
          if (duplicateFunctionDeclaration) {
            ts2.forEach(declarations, function(declaration) {
              error(ts2.getNameOfDeclaration(declaration), ts2.Diagnostics.Duplicate_function_implementation);
            });
          }
          if (hasNonAmbientClass && !isConstructor && symbol.flags & 16) {
            ts2.forEach(declarations, function(declaration) {
              addDuplicateDeclarationError(declaration, ts2.Diagnostics.Duplicate_identifier_0, ts2.symbolName(symbol), declarations);
            });
          }
          if (lastSeenNonAmbientDeclaration && !lastSeenNonAmbientDeclaration.body && !ts2.hasModifier(lastSeenNonAmbientDeclaration, 128) && !lastSeenNonAmbientDeclaration.questionToken) {
            reportImplementationExpectedError(lastSeenNonAmbientDeclaration);
          }
          if (hasOverloads) {
            checkFlagAgreementBetweenOverloads(declarations, bodyDeclaration, flagsToCheck, someNodeFlags, allNodeFlags);
            checkQuestionTokenAgreementBetweenOverloads(declarations, bodyDeclaration, someHaveQuestionToken, allHaveQuestionToken);
            if (bodyDeclaration) {
              var signatures = getSignaturesOfSymbol(symbol);
              var bodySignature = getSignatureFromDeclaration(bodyDeclaration);
              for (var _a = 0, signatures_10 = signatures; _a < signatures_10.length; _a++) {
                var signature = signatures_10[_a];
                if (!isImplementationCompatibleWithOverload(bodySignature, signature)) {
                  ts2.addRelatedInfo(error(signature.declaration, ts2.Diagnostics.This_overload_signature_is_not_compatible_with_its_implementation_signature), ts2.createDiagnosticForNode(bodyDeclaration, ts2.Diagnostics.The_implementation_signature_is_declared_here));
                  break;
                }
              }
            }
          }
        }
        function checkExportsOnMergedDeclarations(node) {
          if (!produceDiagnostics) {
            return;
          }
          var symbol = node.localSymbol;
          if (!symbol) {
            symbol = getSymbolOfNode(node);
            if (!symbol.exportSymbol) {
              return;
            }
          }
          if (ts2.getDeclarationOfKind(symbol, node.kind) !== node) {
            return;
          }
          var exportedDeclarationSpaces = 0;
          var nonExportedDeclarationSpaces = 0;
          var defaultExportedDeclarationSpaces = 0;
          for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
            var d = _a[_i];
            var declarationSpaces = getDeclarationSpaces(d);
            var effectiveDeclarationFlags = getEffectiveDeclarationFlags(d, 1 | 512);
            if (effectiveDeclarationFlags & 1) {
              if (effectiveDeclarationFlags & 512) {
                defaultExportedDeclarationSpaces |= declarationSpaces;
              } else {
                exportedDeclarationSpaces |= declarationSpaces;
              }
            } else {
              nonExportedDeclarationSpaces |= declarationSpaces;
            }
          }
          var nonDefaultExportedDeclarationSpaces = exportedDeclarationSpaces | nonExportedDeclarationSpaces;
          var commonDeclarationSpacesForExportsAndLocals = exportedDeclarationSpaces & nonExportedDeclarationSpaces;
          var commonDeclarationSpacesForDefaultAndNonDefault = defaultExportedDeclarationSpaces & nonDefaultExportedDeclarationSpaces;
          if (commonDeclarationSpacesForExportsAndLocals || commonDeclarationSpacesForDefaultAndNonDefault) {
            for (var _b = 0, _c = symbol.declarations; _b < _c.length; _b++) {
              var d = _c[_b];
              var declarationSpaces = getDeclarationSpaces(d);
              var name = ts2.getNameOfDeclaration(d);
              if (declarationSpaces & commonDeclarationSpacesForDefaultAndNonDefault) {
                error(name, ts2.Diagnostics.Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead, ts2.declarationNameToString(name));
              } else if (declarationSpaces & commonDeclarationSpacesForExportsAndLocals) {
                error(name, ts2.Diagnostics.Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local, ts2.declarationNameToString(name));
              }
            }
          }
          function getDeclarationSpaces(decl) {
            var d2 = decl;
            switch (d2.kind) {
              case 246:
              case 247:
              case 322:
              case 315:
              case 316:
                return 2;
              case 249:
                return ts2.isAmbientModule(d2) || ts2.getModuleInstanceState(d2) !== 0 ? 4 | 1 : 4;
              case 245:
              case 248:
              case 284:
                return 2 | 1;
              case 290:
                return 2 | 1 | 4;
              case 259:
                if (!ts2.isEntityNameExpression(d2.expression)) {
                  return 1;
                }
                d2 = d2.expression;
              case 253:
              case 256:
              case 255:
                var result_10 = 0;
                var target = resolveAlias(getSymbolOfNode(d2));
                ts2.forEach(target.declarations, function(d3) {
                  result_10 |= getDeclarationSpaces(d3);
                });
                return result_10;
              case 242:
              case 191:
              case 244:
              case 258:
              case 75:
                return 1;
              default:
                return ts2.Debug.failBadSyntaxKind(d2);
            }
          }
        }
        function getAwaitedTypeOfPromise(type, errorNode, diagnosticMessage, arg0) {
          var promisedType = getPromisedTypeOfPromise(type, errorNode);
          return promisedType && getAwaitedType(promisedType, errorNode, diagnosticMessage, arg0);
        }
        function getPromisedTypeOfPromise(type, errorNode) {
          if (isTypeAny(type)) {
            return void 0;
          }
          var typeAsPromise = type;
          if (typeAsPromise.promisedTypeOfPromise) {
            return typeAsPromise.promisedTypeOfPromise;
          }
          if (isReferenceToType(type, getGlobalPromiseType(false))) {
            return typeAsPromise.promisedTypeOfPromise = getTypeArguments(type)[0];
          }
          var thenFunction = getTypeOfPropertyOfType(type, "then");
          if (isTypeAny(thenFunction)) {
            return void 0;
          }
          var thenSignatures = thenFunction ? getSignaturesOfType(thenFunction, 0) : ts2.emptyArray;
          if (thenSignatures.length === 0) {
            if (errorNode) {
              error(errorNode, ts2.Diagnostics.A_promise_must_have_a_then_method);
            }
            return void 0;
          }
          var onfulfilledParameterType = getTypeWithFacts(getUnionType(ts2.map(thenSignatures, getTypeOfFirstParameterOfSignature)), 2097152);
          if (isTypeAny(onfulfilledParameterType)) {
            return void 0;
          }
          var onfulfilledParameterSignatures = getSignaturesOfType(onfulfilledParameterType, 0);
          if (onfulfilledParameterSignatures.length === 0) {
            if (errorNode) {
              error(errorNode, ts2.Diagnostics.The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback);
            }
            return void 0;
          }
          return typeAsPromise.promisedTypeOfPromise = getUnionType(ts2.map(onfulfilledParameterSignatures, getTypeOfFirstParameterOfSignature), 2);
        }
        function checkAwaitedType(type, errorNode, diagnosticMessage, arg0) {
          var awaitedType = getAwaitedType(type, errorNode, diagnosticMessage, arg0);
          return awaitedType || errorType;
        }
        function isThenableType(type) {
          var thenFunction = getTypeOfPropertyOfType(type, "then");
          return !!thenFunction && getSignaturesOfType(getTypeWithFacts(thenFunction, 2097152), 0).length > 0;
        }
        function getAwaitedType(type, errorNode, diagnosticMessage, arg0) {
          if (isTypeAny(type)) {
            return type;
          }
          var typeAsAwaitable = type;
          if (typeAsAwaitable.awaitedTypeOfType) {
            return typeAsAwaitable.awaitedTypeOfType;
          }
          return typeAsAwaitable.awaitedTypeOfType = mapType(type, errorNode ? function(constituentType) {
            return getAwaitedTypeWorker(constituentType, errorNode, diagnosticMessage, arg0);
          } : getAwaitedTypeWorker);
        }
        function getAwaitedTypeWorker(type, errorNode, diagnosticMessage, arg0) {
          var typeAsAwaitable = type;
          if (typeAsAwaitable.awaitedTypeOfType) {
            return typeAsAwaitable.awaitedTypeOfType;
          }
          var promisedType = getPromisedTypeOfPromise(type);
          if (promisedType) {
            if (type.id === promisedType.id || awaitedTypeStack.lastIndexOf(promisedType.id) >= 0) {
              if (errorNode) {
                error(errorNode, ts2.Diagnostics.Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method);
              }
              return void 0;
            }
            awaitedTypeStack.push(type.id);
            var awaitedType = getAwaitedType(promisedType, errorNode, diagnosticMessage, arg0);
            awaitedTypeStack.pop();
            if (!awaitedType) {
              return void 0;
            }
            return typeAsAwaitable.awaitedTypeOfType = awaitedType;
          }
          if (isThenableType(type)) {
            if (errorNode) {
              if (!diagnosticMessage)
                return ts2.Debug.fail();
              error(errorNode, diagnosticMessage, arg0);
            }
            return void 0;
          }
          return typeAsAwaitable.awaitedTypeOfType = type;
        }
        function checkAsyncFunctionReturnType(node, returnTypeNode) {
          var returnType = getTypeFromTypeNode(returnTypeNode);
          if (languageVersion >= 2) {
            if (returnType === errorType) {
              return;
            }
            var globalPromiseType = getGlobalPromiseType(true);
            if (globalPromiseType !== emptyGenericType && !isReferenceToType(returnType, globalPromiseType)) {
              error(returnTypeNode, ts2.Diagnostics.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type);
              return;
            }
          } else {
            markTypeNodeAsReferenced(returnTypeNode);
            if (returnType === errorType) {
              return;
            }
            var promiseConstructorName = ts2.getEntityNameFromTypeNode(returnTypeNode);
            if (promiseConstructorName === void 0) {
              error(returnTypeNode, ts2.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value, typeToString(returnType));
              return;
            }
            var promiseConstructorSymbol = resolveEntityName(promiseConstructorName, 111551, true);
            var promiseConstructorType = promiseConstructorSymbol ? getTypeOfSymbol(promiseConstructorSymbol) : errorType;
            if (promiseConstructorType === errorType) {
              if (promiseConstructorName.kind === 75 && promiseConstructorName.escapedText === "Promise" && getTargetType(returnType) === getGlobalPromiseType(false)) {
                error(returnTypeNode, ts2.Diagnostics.An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option);
              } else {
                error(returnTypeNode, ts2.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value, ts2.entityNameToString(promiseConstructorName));
              }
              return;
            }
            var globalPromiseConstructorLikeType = getGlobalPromiseConstructorLikeType(true);
            if (globalPromiseConstructorLikeType === emptyObjectType) {
              error(returnTypeNode, ts2.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value, ts2.entityNameToString(promiseConstructorName));
              return;
            }
            if (!checkTypeAssignableTo(promiseConstructorType, globalPromiseConstructorLikeType, returnTypeNode, ts2.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value)) {
              return;
            }
            var rootName = promiseConstructorName && ts2.getFirstIdentifier(promiseConstructorName);
            var collidingSymbol = getSymbol(node.locals, rootName.escapedText, 111551);
            if (collidingSymbol) {
              error(collidingSymbol.valueDeclaration, ts2.Diagnostics.Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions, ts2.idText(rootName), ts2.entityNameToString(promiseConstructorName));
              return;
            }
          }
          checkAwaitedType(returnType, node, ts2.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
        }
        function checkDecorator(node) {
          var signature = getResolvedSignature(node);
          var returnType = getReturnTypeOfSignature(signature);
          if (returnType.flags & 1) {
            return;
          }
          var expectedReturnType;
          var headMessage = getDiagnosticHeadMessageForDecoratorResolution(node);
          var errorInfo;
          switch (node.parent.kind) {
            case 245:
              var classSymbol = getSymbolOfNode(node.parent);
              var classConstructorType = getTypeOfSymbol(classSymbol);
              expectedReturnType = getUnionType([classConstructorType, voidType]);
              break;
            case 156:
              expectedReturnType = voidType;
              errorInfo = ts2.chainDiagnosticMessages(void 0, ts2.Diagnostics.The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any);
              break;
            case 159:
              expectedReturnType = voidType;
              errorInfo = ts2.chainDiagnosticMessages(void 0, ts2.Diagnostics.The_return_type_of_a_property_decorator_function_must_be_either_void_or_any);
              break;
            case 161:
            case 163:
            case 164:
              var methodType = getTypeOfNode(node.parent);
              var descriptorType = createTypedPropertyDescriptorType(methodType);
              expectedReturnType = getUnionType([descriptorType, voidType]);
              break;
            default:
              return ts2.Debug.fail();
          }
          checkTypeAssignableTo(returnType, expectedReturnType, node, headMessage, function() {
            return errorInfo;
          });
        }
        function markTypeNodeAsReferenced(node) {
          markEntityNameOrEntityExpressionAsReference(node && ts2.getEntityNameFromTypeNode(node));
        }
        function markEntityNameOrEntityExpressionAsReference(typeName) {
          if (!typeName)
            return;
          var rootName = ts2.getFirstIdentifier(typeName);
          var meaning = (typeName.kind === 75 ? 788968 : 1920) | 2097152;
          var rootSymbol = resolveName(rootName, rootName.escapedText, meaning, void 0, void 0, true);
          if (rootSymbol && rootSymbol.flags & 2097152 && symbolIsValue(rootSymbol) && !isConstEnumOrConstEnumOnlyModule(resolveAlias(rootSymbol)) && !getTypeOnlyAliasDeclaration(rootSymbol)) {
            markAliasSymbolAsReferenced(rootSymbol);
          }
        }
        function markDecoratorMedataDataTypeNodeAsReferenced(node) {
          var entityName = getEntityNameForDecoratorMetadata(node);
          if (entityName && ts2.isEntityName(entityName)) {
            markEntityNameOrEntityExpressionAsReference(entityName);
          }
        }
        function getEntityNameForDecoratorMetadata(node) {
          if (node) {
            switch (node.kind) {
              case 179:
              case 178:
                return getEntityNameForDecoratorMetadataFromTypeList(node.types);
              case 180:
                return getEntityNameForDecoratorMetadataFromTypeList([node.trueType, node.falseType]);
              case 182:
                return getEntityNameForDecoratorMetadata(node.type);
              case 169:
                return node.typeName;
            }
          }
        }
        function getEntityNameForDecoratorMetadataFromTypeList(types) {
          var commonEntityName;
          for (var _i = 0, types_20 = types; _i < types_20.length; _i++) {
            var typeNode = types_20[_i];
            while (typeNode.kind === 182) {
              typeNode = typeNode.type;
            }
            if (typeNode.kind === 137) {
              continue;
            }
            if (!strictNullChecks && (typeNode.kind === 100 || typeNode.kind === 146)) {
              continue;
            }
            var individualEntityName = getEntityNameForDecoratorMetadata(typeNode);
            if (!individualEntityName) {
              return void 0;
            }
            if (commonEntityName) {
              if (!ts2.isIdentifier(commonEntityName) || !ts2.isIdentifier(individualEntityName) || commonEntityName.escapedText !== individualEntityName.escapedText) {
                return void 0;
              }
            } else {
              commonEntityName = individualEntityName;
            }
          }
          return commonEntityName;
        }
        function getParameterTypeNodeForDecoratorCheck(node) {
          var typeNode = ts2.getEffectiveTypeAnnotationNode(node);
          return ts2.isRestParameter(node) ? ts2.getRestParameterElementType(typeNode) : typeNode;
        }
        function checkDecorators(node) {
          if (!node.decorators) {
            return;
          }
          if (!ts2.nodeCanBeDecorated(node, node.parent, node.parent.parent)) {
            return;
          }
          if (!compilerOptions.experimentalDecorators) {
            error(node, ts2.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning);
          }
          var firstDecorator = node.decorators[0];
          checkExternalEmitHelpers(firstDecorator, 8);
          if (node.kind === 156) {
            checkExternalEmitHelpers(firstDecorator, 32);
          }
          if (compilerOptions.emitDecoratorMetadata) {
            checkExternalEmitHelpers(firstDecorator, 16);
            switch (node.kind) {
              case 245:
                var constructor = ts2.getFirstConstructorWithBody(node);
                if (constructor) {
                  for (var _i = 0, _a = constructor.parameters; _i < _a.length; _i++) {
                    var parameter = _a[_i];
                    markDecoratorMedataDataTypeNodeAsReferenced(getParameterTypeNodeForDecoratorCheck(parameter));
                  }
                }
                break;
              case 163:
              case 164:
                var otherKind = node.kind === 163 ? 164 : 163;
                var otherAccessor = ts2.getDeclarationOfKind(getSymbolOfNode(node), otherKind);
                markDecoratorMedataDataTypeNodeAsReferenced(getAnnotatedAccessorTypeNode(node) || otherAccessor && getAnnotatedAccessorTypeNode(otherAccessor));
                break;
              case 161:
                for (var _b = 0, _c = node.parameters; _b < _c.length; _b++) {
                  var parameter = _c[_b];
                  markDecoratorMedataDataTypeNodeAsReferenced(getParameterTypeNodeForDecoratorCheck(parameter));
                }
                markDecoratorMedataDataTypeNodeAsReferenced(ts2.getEffectiveReturnTypeNode(node));
                break;
              case 159:
                markDecoratorMedataDataTypeNodeAsReferenced(ts2.getEffectiveTypeAnnotationNode(node));
                break;
              case 156:
                markDecoratorMedataDataTypeNodeAsReferenced(getParameterTypeNodeForDecoratorCheck(node));
                var containingSignature = node.parent;
                for (var _d = 0, _e = containingSignature.parameters; _d < _e.length; _d++) {
                  var parameter = _e[_d];
                  markDecoratorMedataDataTypeNodeAsReferenced(getParameterTypeNodeForDecoratorCheck(parameter));
                }
                break;
            }
          }
          ts2.forEach(node.decorators, checkDecorator);
        }
        function checkFunctionDeclaration(node) {
          if (produceDiagnostics) {
            checkFunctionOrMethodDeclaration(node);
            checkGrammarForGenerator(node);
            checkCollisionWithRequireExportsInGeneratedCode(node, node.name);
            checkCollisionWithGlobalPromiseInGeneratedCode(node, node.name);
          }
        }
        function checkJSDocTypeAliasTag(node) {
          if (!node.typeExpression) {
            error(node.name, ts2.Diagnostics.JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags);
          }
          if (node.name) {
            checkTypeNameIsReserved(node.name, ts2.Diagnostics.Type_alias_name_cannot_be_0);
          }
          checkSourceElement(node.typeExpression);
        }
        function checkJSDocTemplateTag(node) {
          checkSourceElement(node.constraint);
          for (var _i = 0, _a = node.typeParameters; _i < _a.length; _i++) {
            var tp = _a[_i];
            checkSourceElement(tp);
          }
        }
        function checkJSDocTypeTag(node) {
          checkSourceElement(node.typeExpression);
        }
        function checkJSDocParameterTag(node) {
          checkSourceElement(node.typeExpression);
          if (!ts2.getParameterSymbolFromJSDoc(node)) {
            var decl = ts2.getHostSignatureFromJSDoc(node);
            if (decl) {
              var i = ts2.getJSDocTags(decl).filter(ts2.isJSDocParameterTag).indexOf(node);
              if (i > -1 && i < decl.parameters.length && ts2.isBindingPattern(decl.parameters[i].name)) {
                return;
              }
              if (!containsArgumentsReference(decl)) {
                if (ts2.isQualifiedName(node.name)) {
                  error(node.name, ts2.Diagnostics.Qualified_name_0_is_not_allowed_without_a_leading_param_object_1, ts2.entityNameToString(node.name), ts2.entityNameToString(node.name.left));
                } else {
                  error(node.name, ts2.Diagnostics.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name, ts2.idText(node.name));
                }
              } else if (ts2.findLast(ts2.getJSDocTags(decl), ts2.isJSDocParameterTag) === node && node.typeExpression && node.typeExpression.type && !isArrayType(getTypeFromTypeNode(node.typeExpression.type))) {
                error(node.name, ts2.Diagnostics.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_had_an_array_type, ts2.idText(node.name.kind === 153 ? node.name.right : node.name));
              }
            }
          }
        }
        function checkJSDocPropertyTag(node) {
          checkSourceElement(node.typeExpression);
        }
        function checkJSDocFunctionType(node) {
          if (produceDiagnostics && !node.type && !ts2.isJSDocConstructSignature(node)) {
            reportImplicitAny(node, anyType);
          }
          checkSignatureDeclaration(node);
        }
        function checkJSDocImplementsTag(node) {
          var classLike = ts2.getEffectiveJSDocHost(node);
          if (!classLike || !ts2.isClassDeclaration(classLike) && !ts2.isClassExpression(classLike)) {
            error(classLike, ts2.Diagnostics.JSDoc_0_is_not_attached_to_a_class, ts2.idText(node.tagName));
          }
        }
        function checkJSDocAugmentsTag(node) {
          var classLike = ts2.getEffectiveJSDocHost(node);
          if (!classLike || !ts2.isClassDeclaration(classLike) && !ts2.isClassExpression(classLike)) {
            error(classLike, ts2.Diagnostics.JSDoc_0_is_not_attached_to_a_class, ts2.idText(node.tagName));
            return;
          }
          var augmentsTags = ts2.getJSDocTags(classLike).filter(ts2.isJSDocAugmentsTag);
          ts2.Debug.assert(augmentsTags.length > 0);
          if (augmentsTags.length > 1) {
            error(augmentsTags[1], ts2.Diagnostics.Class_declarations_cannot_have_more_than_one_augments_or_extends_tag);
          }
          var name = getIdentifierFromEntityNameExpression(node.class.expression);
          var extend = ts2.getClassExtendsHeritageElement(classLike);
          if (extend) {
            var className = getIdentifierFromEntityNameExpression(extend.expression);
            if (className && name.escapedText !== className.escapedText) {
              error(name, ts2.Diagnostics.JSDoc_0_1_does_not_match_the_extends_2_clause, ts2.idText(node.tagName), ts2.idText(name), ts2.idText(className));
            }
          }
        }
        function getIdentifierFromEntityNameExpression(node) {
          switch (node.kind) {
            case 75:
              return node;
            case 194:
              return node.name;
            default:
              return void 0;
          }
        }
        function checkFunctionOrMethodDeclaration(node) {
          checkDecorators(node);
          checkSignatureDeclaration(node);
          var functionFlags = ts2.getFunctionFlags(node);
          if (node.name && node.name.kind === 154) {
            checkComputedPropertyName(node.name);
          }
          if (!hasNonBindableDynamicName(node)) {
            var symbol = getSymbolOfNode(node);
            var localSymbol = node.localSymbol || symbol;
            var firstDeclaration = ts2.find(localSymbol.declarations, function(declaration) {
              return declaration.kind === node.kind && !(declaration.flags & 131072);
            });
            if (node === firstDeclaration) {
              checkFunctionOrConstructorSymbol(localSymbol);
            }
            if (symbol.parent) {
              if (ts2.getDeclarationOfKind(symbol, node.kind) === node) {
                checkFunctionOrConstructorSymbol(symbol);
              }
            }
          }
          var body = node.kind === 160 ? void 0 : node.body;
          checkSourceElement(body);
          checkAllCodePathsInNonVoidFunctionReturnOrThrow(node, getReturnTypeFromAnnotation(node));
          if (produceDiagnostics && !ts2.getEffectiveReturnTypeNode(node)) {
            if (ts2.nodeIsMissing(body) && !isPrivateWithinAmbient(node)) {
              reportImplicitAny(node, anyType);
            }
            if (functionFlags & 1 && ts2.nodeIsPresent(body)) {
              getReturnTypeOfSignature(getSignatureFromDeclaration(node));
            }
          }
          if (ts2.isInJSFile(node)) {
            var typeTag = ts2.getJSDocTypeTag(node);
            if (typeTag && typeTag.typeExpression && !getContextualCallSignature(getTypeFromTypeNode(typeTag.typeExpression), node)) {
              error(typeTag, ts2.Diagnostics.The_type_of_a_function_declaration_must_match_the_function_s_signature);
            }
          }
        }
        function registerForUnusedIdentifiersCheck(node) {
          if (produceDiagnostics) {
            var sourceFile = ts2.getSourceFileOfNode(node);
            var potentiallyUnusedIdentifiers = allPotentiallyUnusedIdentifiers.get(sourceFile.path);
            if (!potentiallyUnusedIdentifiers) {
              potentiallyUnusedIdentifiers = [];
              allPotentiallyUnusedIdentifiers.set(sourceFile.path, potentiallyUnusedIdentifiers);
            }
            potentiallyUnusedIdentifiers.push(node);
          }
        }
        function checkUnusedIdentifiers(potentiallyUnusedIdentifiers, addDiagnostic) {
          for (var _i = 0, potentiallyUnusedIdentifiers_1 = potentiallyUnusedIdentifiers; _i < potentiallyUnusedIdentifiers_1.length; _i++) {
            var node = potentiallyUnusedIdentifiers_1[_i];
            switch (node.kind) {
              case 245:
              case 214:
                checkUnusedClassMembers(node, addDiagnostic);
                checkUnusedTypeParameters(node, addDiagnostic);
                break;
              case 290:
              case 249:
              case 223:
              case 251:
              case 230:
              case 231:
              case 232:
                checkUnusedLocalsAndParameters(node, addDiagnostic);
                break;
              case 162:
              case 201:
              case 244:
              case 202:
              case 161:
              case 163:
              case 164:
                if (node.body) {
                  checkUnusedLocalsAndParameters(node, addDiagnostic);
                }
                checkUnusedTypeParameters(node, addDiagnostic);
                break;
              case 160:
              case 165:
              case 166:
              case 170:
              case 171:
              case 247:
              case 246:
                checkUnusedTypeParameters(node, addDiagnostic);
                break;
              case 181:
                checkUnusedInferTypeParameter(node, addDiagnostic);
                break;
              default:
                ts2.Debug.assertNever(node, "Node should not have been registered for unused identifiers check");
            }
          }
        }
        function errorUnusedLocal(declaration, name, addDiagnostic) {
          var node = ts2.getNameOfDeclaration(declaration) || declaration;
          var message = isTypeDeclaration(declaration) ? ts2.Diagnostics._0_is_declared_but_never_used : ts2.Diagnostics._0_is_declared_but_its_value_is_never_read;
          addDiagnostic(declaration, 0, ts2.createDiagnosticForNode(node, message, name));
        }
        function isIdentifierThatStartsWithUnderscore(node) {
          return ts2.isIdentifier(node) && ts2.idText(node).charCodeAt(0) === 95;
        }
        function checkUnusedClassMembers(node, addDiagnostic) {
          for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
            var member = _a[_i];
            switch (member.kind) {
              case 161:
              case 159:
              case 163:
              case 164:
                if (member.kind === 164 && member.symbol.flags & 32768) {
                  break;
                }
                var symbol = getSymbolOfNode(member);
                if (!symbol.isReferenced && (ts2.hasModifier(member, 8) || ts2.isNamedDeclaration(member) && ts2.isPrivateIdentifier(member.name)) && !(member.flags & 8388608)) {
                  addDiagnostic(member, 0, ts2.createDiagnosticForNode(member.name, ts2.Diagnostics._0_is_declared_but_its_value_is_never_read, symbolToString(symbol)));
                }
                break;
              case 162:
                for (var _b = 0, _c = member.parameters; _b < _c.length; _b++) {
                  var parameter = _c[_b];
                  if (!parameter.symbol.isReferenced && ts2.hasModifier(parameter, 8)) {
                    addDiagnostic(parameter, 0, ts2.createDiagnosticForNode(parameter.name, ts2.Diagnostics.Property_0_is_declared_but_its_value_is_never_read, ts2.symbolName(parameter.symbol)));
                  }
                }
                break;
              case 167:
              case 222:
                break;
              default:
                ts2.Debug.fail();
            }
          }
        }
        function checkUnusedInferTypeParameter(node, addDiagnostic) {
          var typeParameter = node.typeParameter;
          if (isTypeParameterUnused(typeParameter)) {
            addDiagnostic(node, 1, ts2.createDiagnosticForNode(node, ts2.Diagnostics._0_is_declared_but_its_value_is_never_read, ts2.idText(typeParameter.name)));
          }
        }
        function checkUnusedTypeParameters(node, addDiagnostic) {
          if (ts2.last(getSymbolOfNode(node).declarations) !== node)
            return;
          var typeParameters = ts2.getEffectiveTypeParameterDeclarations(node);
          var seenParentsWithEveryUnused = new ts2.NodeSet();
          for (var _i = 0, typeParameters_3 = typeParameters; _i < typeParameters_3.length; _i++) {
            var typeParameter = typeParameters_3[_i];
            if (!isTypeParameterUnused(typeParameter))
              continue;
            var name = ts2.idText(typeParameter.name);
            var parent = typeParameter.parent;
            if (parent.kind !== 181 && parent.typeParameters.every(isTypeParameterUnused)) {
              if (seenParentsWithEveryUnused.tryAdd(parent)) {
                var range = ts2.isJSDocTemplateTag(parent) ? ts2.rangeOfNode(parent) : ts2.rangeOfTypeParameters(parent.typeParameters);
                var only = parent.typeParameters.length === 1;
                var message = only ? ts2.Diagnostics._0_is_declared_but_its_value_is_never_read : ts2.Diagnostics.All_type_parameters_are_unused;
                var arg0 = only ? name : void 0;
                addDiagnostic(typeParameter, 1, ts2.createFileDiagnostic(ts2.getSourceFileOfNode(parent), range.pos, range.end - range.pos, message, arg0));
              }
            } else {
              addDiagnostic(typeParameter, 1, ts2.createDiagnosticForNode(typeParameter, ts2.Diagnostics._0_is_declared_but_its_value_is_never_read, name));
            }
          }
        }
        function isTypeParameterUnused(typeParameter) {
          return !(getMergedSymbol(typeParameter.symbol).isReferenced & 262144) && !isIdentifierThatStartsWithUnderscore(typeParameter.name);
        }
        function addToGroup(map, key, value, getKey) {
          var keyString = String(getKey(key));
          var group = map.get(keyString);
          if (group) {
            group[1].push(value);
          } else {
            map.set(keyString, [key, [value]]);
          }
        }
        function tryGetRootParameterDeclaration(node) {
          return ts2.tryCast(ts2.getRootDeclaration(node), ts2.isParameter);
        }
        function isValidUnusedLocalDeclaration(declaration) {
          if (ts2.isBindingElement(declaration) && isIdentifierThatStartsWithUnderscore(declaration.name)) {
            return !!ts2.findAncestor(declaration.parent, function(ancestor) {
              return ts2.isArrayBindingPattern(ancestor) || ts2.isVariableDeclaration(ancestor) || ts2.isVariableDeclarationList(ancestor) ? false : ts2.isForOfStatement(ancestor) ? true : "quit";
            });
          }
          return ts2.isAmbientModule(declaration) || (ts2.isVariableDeclaration(declaration) && ts2.isForInOrOfStatement(declaration.parent.parent) || isImportedDeclaration(declaration)) && isIdentifierThatStartsWithUnderscore(declaration.name);
        }
        function checkUnusedLocalsAndParameters(nodeWithLocals, addDiagnostic) {
          var unusedImports = ts2.createMap();
          var unusedDestructures = ts2.createMap();
          var unusedVariables = ts2.createMap();
          nodeWithLocals.locals.forEach(function(local) {
            if (local.flags & 262144 ? !(local.flags & 3 && !(local.isReferenced & 3)) : local.isReferenced || local.exportSymbol) {
              return;
            }
            for (var _i = 0, _a = local.declarations; _i < _a.length; _i++) {
              var declaration = _a[_i];
              if (isValidUnusedLocalDeclaration(declaration)) {
                continue;
              }
              if (isImportedDeclaration(declaration)) {
                addToGroup(unusedImports, importClauseFromImported(declaration), declaration, getNodeId);
              } else if (ts2.isBindingElement(declaration) && ts2.isObjectBindingPattern(declaration.parent)) {
                var lastElement = ts2.last(declaration.parent.elements);
                if (declaration === lastElement || !ts2.last(declaration.parent.elements).dotDotDotToken) {
                  addToGroup(unusedDestructures, declaration.parent, declaration, getNodeId);
                }
              } else if (ts2.isVariableDeclaration(declaration)) {
                addToGroup(unusedVariables, declaration.parent, declaration, getNodeId);
              } else {
                var parameter = local.valueDeclaration && tryGetRootParameterDeclaration(local.valueDeclaration);
                var name = local.valueDeclaration && ts2.getNameOfDeclaration(local.valueDeclaration);
                if (parameter && name) {
                  if (!ts2.isParameterPropertyDeclaration(parameter, parameter.parent) && !ts2.parameterIsThisKeyword(parameter) && !isIdentifierThatStartsWithUnderscore(name)) {
                    addDiagnostic(parameter, 1, ts2.createDiagnosticForNode(name, ts2.Diagnostics._0_is_declared_but_its_value_is_never_read, ts2.symbolName(local)));
                  }
                } else {
                  errorUnusedLocal(declaration, ts2.symbolName(local), addDiagnostic);
                }
              }
            }
          });
          unusedImports.forEach(function(_a) {
            var importClause = _a[0], unuseds = _a[1];
            var importDecl = importClause.parent;
            var nDeclarations = (importClause.name ? 1 : 0) + (importClause.namedBindings ? importClause.namedBindings.kind === 256 ? 1 : importClause.namedBindings.elements.length : 0);
            if (nDeclarations === unuseds.length) {
              addDiagnostic(importDecl, 0, unuseds.length === 1 ? ts2.createDiagnosticForNode(importDecl, ts2.Diagnostics._0_is_declared_but_its_value_is_never_read, ts2.idText(ts2.first(unuseds).name)) : ts2.createDiagnosticForNode(importDecl, ts2.Diagnostics.All_imports_in_import_declaration_are_unused));
            } else {
              for (var _i = 0, unuseds_1 = unuseds; _i < unuseds_1.length; _i++) {
                var unused = unuseds_1[_i];
                errorUnusedLocal(unused, ts2.idText(unused.name), addDiagnostic);
              }
            }
          });
          unusedDestructures.forEach(function(_a) {
            var bindingPattern = _a[0], bindingElements = _a[1];
            var kind = tryGetRootParameterDeclaration(bindingPattern.parent) ? 1 : 0;
            if (bindingPattern.elements.length === bindingElements.length) {
              if (bindingElements.length === 1 && bindingPattern.parent.kind === 242 && bindingPattern.parent.parent.kind === 243) {
                addToGroup(unusedVariables, bindingPattern.parent.parent, bindingPattern.parent, getNodeId);
              } else {
                addDiagnostic(bindingPattern, kind, bindingElements.length === 1 ? ts2.createDiagnosticForNode(bindingPattern, ts2.Diagnostics._0_is_declared_but_its_value_is_never_read, bindingNameText(ts2.first(bindingElements).name)) : ts2.createDiagnosticForNode(bindingPattern, ts2.Diagnostics.All_destructured_elements_are_unused));
              }
            } else {
              for (var _i = 0, bindingElements_1 = bindingElements; _i < bindingElements_1.length; _i++) {
                var e = bindingElements_1[_i];
                addDiagnostic(e, kind, ts2.createDiagnosticForNode(e, ts2.Diagnostics._0_is_declared_but_its_value_is_never_read, bindingNameText(e.name)));
              }
            }
          });
          unusedVariables.forEach(function(_a) {
            var declarationList = _a[0], declarations = _a[1];
            if (declarationList.declarations.length === declarations.length) {
              addDiagnostic(declarationList, 0, declarations.length === 1 ? ts2.createDiagnosticForNode(ts2.first(declarations).name, ts2.Diagnostics._0_is_declared_but_its_value_is_never_read, bindingNameText(ts2.first(declarations).name)) : ts2.createDiagnosticForNode(declarationList.parent.kind === 225 ? declarationList.parent : declarationList, ts2.Diagnostics.All_variables_are_unused));
            } else {
              for (var _i = 0, declarations_5 = declarations; _i < declarations_5.length; _i++) {
                var decl = declarations_5[_i];
                addDiagnostic(decl, 0, ts2.createDiagnosticForNode(decl, ts2.Diagnostics._0_is_declared_but_its_value_is_never_read, bindingNameText(decl.name)));
              }
            }
          });
        }
        function bindingNameText(name) {
          switch (name.kind) {
            case 75:
              return ts2.idText(name);
            case 190:
            case 189:
              return bindingNameText(ts2.cast(ts2.first(name.elements), ts2.isBindingElement).name);
            default:
              return ts2.Debug.assertNever(name);
          }
        }
        function isImportedDeclaration(node) {
          return node.kind === 255 || node.kind === 258 || node.kind === 256;
        }
        function importClauseFromImported(decl) {
          return decl.kind === 255 ? decl : decl.kind === 256 ? decl.parent : decl.parent.parent;
        }
        function checkBlock(node) {
          if (node.kind === 223) {
            checkGrammarStatementInAmbientContext(node);
          }
          if (ts2.isFunctionOrModuleBlock(node)) {
            var saveFlowAnalysisDisabled = flowAnalysisDisabled;
            ts2.forEach(node.statements, checkSourceElement);
            flowAnalysisDisabled = saveFlowAnalysisDisabled;
          } else {
            ts2.forEach(node.statements, checkSourceElement);
          }
          if (node.locals) {
            registerForUnusedIdentifiersCheck(node);
          }
        }
        function checkCollisionWithArgumentsInGeneratedCode(node) {
          if (languageVersion >= 2 || compilerOptions.noEmit || !ts2.hasRestParameter(node) || node.flags & 8388608 || ts2.nodeIsMissing(node.body)) {
            return;
          }
          ts2.forEach(node.parameters, function(p) {
            if (p.name && !ts2.isBindingPattern(p.name) && p.name.escapedText === argumentsSymbol.escapedName) {
              error(p, ts2.Diagnostics.Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters);
            }
          });
        }
        function needCollisionCheckForIdentifier(node, identifier, name) {
          if (!(identifier && identifier.escapedText === name)) {
            return false;
          }
          if (node.kind === 159 || node.kind === 158 || node.kind === 161 || node.kind === 160 || node.kind === 163 || node.kind === 164) {
            return false;
          }
          if (node.flags & 8388608) {
            return false;
          }
          var root = ts2.getRootDeclaration(node);
          if (root.kind === 156 && ts2.nodeIsMissing(root.parent.body)) {
            return false;
          }
          return true;
        }
        function checkIfThisIsCapturedInEnclosingScope(node) {
          ts2.findAncestor(node, function(current) {
            if (getNodeCheckFlags(current) & 4) {
              var isDeclaration_1 = node.kind !== 75;
              if (isDeclaration_1) {
                error(ts2.getNameOfDeclaration(node), ts2.Diagnostics.Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference);
              } else {
                error(node, ts2.Diagnostics.Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference);
              }
              return true;
            }
            return false;
          });
        }
        function checkIfNewTargetIsCapturedInEnclosingScope(node) {
          ts2.findAncestor(node, function(current) {
            if (getNodeCheckFlags(current) & 8) {
              var isDeclaration_2 = node.kind !== 75;
              if (isDeclaration_2) {
                error(ts2.getNameOfDeclaration(node), ts2.Diagnostics.Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_meta_property_reference);
              } else {
                error(node, ts2.Diagnostics.Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta_property_reference);
              }
              return true;
            }
            return false;
          });
        }
        function checkWeakMapCollision(node) {
          var enclosingBlockScope = ts2.getEnclosingBlockScopeContainer(node);
          if (getNodeCheckFlags(enclosingBlockScope) & 67108864) {
            error(node, ts2.Diagnostics.Compiler_reserves_name_0_when_emitting_private_identifier_downlevel, "WeakMap");
          }
        }
        function checkCollisionWithRequireExportsInGeneratedCode(node, name) {
          if (moduleKind >= ts2.ModuleKind.ES2015 || compilerOptions.noEmit) {
            return;
          }
          if (!needCollisionCheckForIdentifier(node, name, "require") && !needCollisionCheckForIdentifier(node, name, "exports")) {
            return;
          }
          if (ts2.isModuleDeclaration(node) && ts2.getModuleInstanceState(node) !== 1) {
            return;
          }
          var parent = getDeclarationContainer(node);
          if (parent.kind === 290 && ts2.isExternalOrCommonJsModule(parent)) {
            error(name, ts2.Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module, ts2.declarationNameToString(name), ts2.declarationNameToString(name));
          }
        }
        function checkCollisionWithGlobalPromiseInGeneratedCode(node, name) {
          if (languageVersion >= 4 || compilerOptions.noEmit || !needCollisionCheckForIdentifier(node, name, "Promise")) {
            return;
          }
          if (ts2.isModuleDeclaration(node) && ts2.getModuleInstanceState(node) !== 1) {
            return;
          }
          var parent = getDeclarationContainer(node);
          if (parent.kind === 290 && ts2.isExternalOrCommonJsModule(parent) && parent.flags & 2048) {
            error(name, ts2.Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions, ts2.declarationNameToString(name), ts2.declarationNameToString(name));
          }
        }
        function checkVarDeclaredNamesNotShadowed(node) {
          if ((ts2.getCombinedNodeFlags(node) & 3) !== 0 || ts2.isParameterDeclaration(node)) {
            return;
          }
          if (node.kind === 242 && !node.initializer) {
            return;
          }
          var symbol = getSymbolOfNode(node);
          if (symbol.flags & 1) {
            if (!ts2.isIdentifier(node.name))
              return ts2.Debug.fail();
            var localDeclarationSymbol = resolveName(node, node.name.escapedText, 3, void 0, void 0, false);
            if (localDeclarationSymbol && localDeclarationSymbol !== symbol && localDeclarationSymbol.flags & 2) {
              if (getDeclarationNodeFlagsFromSymbol(localDeclarationSymbol) & 3) {
                var varDeclList = ts2.getAncestor(localDeclarationSymbol.valueDeclaration, 243);
                var container = varDeclList.parent.kind === 225 && varDeclList.parent.parent ? varDeclList.parent.parent : void 0;
                var namesShareScope = container && (container.kind === 223 && ts2.isFunctionLike(container.parent) || container.kind === 250 || container.kind === 249 || container.kind === 290);
                if (!namesShareScope) {
                  var name = symbolToString(localDeclarationSymbol);
                  error(node, ts2.Diagnostics.Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1, name, name);
                }
              }
            }
          }
        }
        function convertAutoToAny(type) {
          return type === autoType ? anyType : type === autoArrayType ? anyArrayType : type;
        }
        function checkVariableLikeDeclaration(node) {
          checkDecorators(node);
          if (!ts2.isBindingElement(node)) {
            checkSourceElement(node.type);
          }
          if (!node.name) {
            return;
          }
          if (node.name.kind === 154) {
            checkComputedPropertyName(node.name);
            if (node.initializer) {
              checkExpressionCached(node.initializer);
            }
          }
          if (node.kind === 191) {
            if (node.parent.kind === 189 && languageVersion < 99) {
              checkExternalEmitHelpers(node, 4);
            }
            if (node.propertyName && node.propertyName.kind === 154) {
              checkComputedPropertyName(node.propertyName);
            }
            var parent = node.parent.parent;
            var parentType = getTypeForBindingElementParent(parent);
            var name = node.propertyName || node.name;
            if (parentType && !ts2.isBindingPattern(name)) {
              var exprType = getLiteralTypeFromPropertyName(name);
              if (isTypeUsableAsPropertyName(exprType)) {
                var nameText = getPropertyNameFromType(exprType);
                var property = getPropertyOfType(parentType, nameText);
                if (property) {
                  markPropertyAsReferenced(property, void 0, false);
                  checkPropertyAccessibility(parent, !!parent.initializer && parent.initializer.kind === 102, parentType, property);
                }
              }
            }
          }
          if (ts2.isBindingPattern(node.name)) {
            if (node.name.kind === 190 && languageVersion < 2 && compilerOptions.downlevelIteration) {
              checkExternalEmitHelpers(node, 512);
            }
            ts2.forEach(node.name.elements, checkSourceElement);
          }
          if (node.initializer && ts2.getRootDeclaration(node).kind === 156 && ts2.nodeIsMissing(ts2.getContainingFunction(node).body)) {
            error(node, ts2.Diagnostics.A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation);
            return;
          }
          if (ts2.isBindingPattern(node.name)) {
            var needCheckInitializer = node.initializer && node.parent.parent.kind !== 231;
            var needCheckWidenedType = node.name.elements.length === 0;
            if (needCheckInitializer || needCheckWidenedType) {
              var widenedType = getWidenedTypeForVariableLikeDeclaration(node);
              if (needCheckInitializer) {
                var initializerType = checkExpressionCached(node.initializer);
                if (strictNullChecks && needCheckWidenedType) {
                  checkNonNullNonVoidType(initializerType, node);
                } else {
                  checkTypeAssignableToAndOptionallyElaborate(initializerType, getWidenedTypeForVariableLikeDeclaration(node), node, node.initializer);
                }
              }
              if (needCheckWidenedType) {
                if (ts2.isArrayBindingPattern(node.name)) {
                  checkIteratedTypeOrElementType(65, widenedType, undefinedType, node);
                } else if (strictNullChecks) {
                  checkNonNullNonVoidType(widenedType, node);
                }
              }
            }
            return;
          }
          var symbol = getSymbolOfNode(node);
          var type = convertAutoToAny(getTypeOfSymbol(symbol));
          if (node === symbol.valueDeclaration) {
            var initializer = ts2.getEffectiveInitializer(node);
            if (initializer) {
              var isJSObjectLiteralInitializer = ts2.isInJSFile(node) && ts2.isObjectLiteralExpression(initializer) && (initializer.properties.length === 0 || ts2.isPrototypeAccess(node.name)) && ts2.hasEntries(symbol.exports);
              if (!isJSObjectLiteralInitializer && node.parent.parent.kind !== 231) {
                checkTypeAssignableToAndOptionallyElaborate(checkExpressionCached(initializer), type, node, initializer, void 0);
              }
            }
            if (symbol.declarations.length > 1) {
              if (ts2.some(symbol.declarations, function(d) {
                return d !== node && ts2.isVariableLike(d) && !areDeclarationFlagsIdentical(d, node);
              })) {
                error(node.name, ts2.Diagnostics.All_declarations_of_0_must_have_identical_modifiers, ts2.declarationNameToString(node.name));
              }
            }
          } else {
            var declarationType = convertAutoToAny(getWidenedTypeForVariableLikeDeclaration(node));
            if (type !== errorType && declarationType !== errorType && !isTypeIdenticalTo(type, declarationType) && !(symbol.flags & 67108864)) {
              errorNextVariableOrPropertyDeclarationMustHaveSameType(symbol.valueDeclaration, type, node, declarationType);
            }
            if (node.initializer) {
              checkTypeAssignableToAndOptionallyElaborate(checkExpressionCached(node.initializer), declarationType, node, node.initializer, void 0);
            }
            if (!areDeclarationFlagsIdentical(node, symbol.valueDeclaration)) {
              error(node.name, ts2.Diagnostics.All_declarations_of_0_must_have_identical_modifiers, ts2.declarationNameToString(node.name));
            }
          }
          if (node.kind !== 159 && node.kind !== 158) {
            checkExportsOnMergedDeclarations(node);
            if (node.kind === 242 || node.kind === 191) {
              checkVarDeclaredNamesNotShadowed(node);
            }
            checkCollisionWithRequireExportsInGeneratedCode(node, node.name);
            checkCollisionWithGlobalPromiseInGeneratedCode(node, node.name);
            if (!compilerOptions.noEmit && languageVersion < 99 && needCollisionCheckForIdentifier(node, node.name, "WeakMap")) {
              potentialWeakMapCollisions.push(node);
            }
          }
        }
        function errorNextVariableOrPropertyDeclarationMustHaveSameType(firstDeclaration, firstType, nextDeclaration, nextType) {
          var nextDeclarationName = ts2.getNameOfDeclaration(nextDeclaration);
          var message = nextDeclaration.kind === 159 || nextDeclaration.kind === 158 ? ts2.Diagnostics.Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_type_2 : ts2.Diagnostics.Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2;
          var declName = ts2.declarationNameToString(nextDeclarationName);
          var err = error(nextDeclarationName, message, declName, typeToString(firstType), typeToString(nextType));
          if (firstDeclaration) {
            ts2.addRelatedInfo(err, ts2.createDiagnosticForNode(firstDeclaration, ts2.Diagnostics._0_was_also_declared_here, declName));
          }
        }
        function areDeclarationFlagsIdentical(left, right) {
          if (left.kind === 156 && right.kind === 242 || left.kind === 242 && right.kind === 156) {
            return true;
          }
          if (ts2.hasQuestionToken(left) !== ts2.hasQuestionToken(right)) {
            return false;
          }
          var interestingFlags = 8 | 16 | 256 | 128 | 64 | 32;
          return ts2.getSelectedModifierFlags(left, interestingFlags) === ts2.getSelectedModifierFlags(right, interestingFlags);
        }
        function checkVariableDeclaration(node) {
          checkGrammarVariableDeclaration(node);
          return checkVariableLikeDeclaration(node);
        }
        function checkBindingElement(node) {
          checkGrammarBindingElement(node);
          return checkVariableLikeDeclaration(node);
        }
        function checkVariableStatement(node) {
          if (!checkGrammarDecoratorsAndModifiers(node) && !checkGrammarVariableDeclarationList(node.declarationList))
            checkGrammarForDisallowedLetOrConstStatement(node);
          ts2.forEach(node.declarationList.declarations, checkSourceElement);
        }
        function checkExpressionStatement(node) {
          checkGrammarStatementInAmbientContext(node);
          checkExpression(node.expression);
        }
        function checkIfStatement(node) {
          checkGrammarStatementInAmbientContext(node);
          var type = checkTruthinessExpression(node.expression);
          checkTestingKnownTruthyCallableType(node.expression, node.thenStatement, type);
          checkSourceElement(node.thenStatement);
          if (node.thenStatement.kind === 224) {
            error(node.thenStatement, ts2.Diagnostics.The_body_of_an_if_statement_cannot_be_the_empty_statement);
          }
          checkSourceElement(node.elseStatement);
        }
        function checkTestingKnownTruthyCallableType(condExpr, body, type) {
          if (!strictNullChecks) {
            return;
          }
          var testedNode = ts2.isIdentifier(condExpr) ? condExpr : ts2.isPropertyAccessExpression(condExpr) ? condExpr.name : void 0;
          if (!testedNode) {
            return;
          }
          var possiblyFalsy = getFalsyFlags(type);
          if (possiblyFalsy) {
            return;
          }
          var callSignatures = getSignaturesOfType(type, 0);
          if (callSignatures.length === 0) {
            return;
          }
          var testedFunctionSymbol = getSymbolAtLocation(testedNode);
          if (!testedFunctionSymbol) {
            return;
          }
          var functionIsUsedInBody = ts2.forEachChild(body, function check(childNode) {
            if (ts2.isIdentifier(childNode)) {
              var childSymbol = getSymbolAtLocation(childNode);
              if (childSymbol && childSymbol === testedFunctionSymbol) {
                if (ts2.isIdentifier(condExpr)) {
                  return true;
                }
                var testedExpression = testedNode.parent;
                var childExpression = childNode.parent;
                while (testedExpression && childExpression) {
                  if (ts2.isIdentifier(testedExpression) && ts2.isIdentifier(childExpression) || testedExpression.kind === 104 && childExpression.kind === 104) {
                    return getSymbolAtLocation(testedExpression) === getSymbolAtLocation(childExpression);
                  }
                  if (ts2.isPropertyAccessExpression(testedExpression) && ts2.isPropertyAccessExpression(childExpression)) {
                    if (getSymbolAtLocation(testedExpression.name) !== getSymbolAtLocation(childExpression.name)) {
                      return false;
                    }
                    childExpression = childExpression.expression;
                    testedExpression = testedExpression.expression;
                  } else {
                    return false;
                  }
                }
              }
            }
            return ts2.forEachChild(childNode, check);
          });
          if (!functionIsUsedInBody) {
            error(condExpr, ts2.Diagnostics.This_condition_will_always_return_true_since_the_function_is_always_defined_Did_you_mean_to_call_it_instead);
          }
        }
        function checkDoStatement(node) {
          checkGrammarStatementInAmbientContext(node);
          checkSourceElement(node.statement);
          checkTruthinessExpression(node.expression);
        }
        function checkWhileStatement(node) {
          checkGrammarStatementInAmbientContext(node);
          checkTruthinessExpression(node.expression);
          checkSourceElement(node.statement);
        }
        function checkTruthinessOfType(type, node) {
          if (type.flags & 16384) {
            error(node, ts2.Diagnostics.An_expression_of_type_void_cannot_be_tested_for_truthiness);
          }
          return type;
        }
        function checkTruthinessExpression(node, checkMode) {
          return checkTruthinessOfType(checkExpression(node, checkMode), node);
        }
        function checkForStatement(node) {
          if (!checkGrammarStatementInAmbientContext(node)) {
            if (node.initializer && node.initializer.kind === 243) {
              checkGrammarVariableDeclarationList(node.initializer);
            }
          }
          if (node.initializer) {
            if (node.initializer.kind === 243) {
              ts2.forEach(node.initializer.declarations, checkVariableDeclaration);
            } else {
              checkExpression(node.initializer);
            }
          }
          if (node.condition)
            checkTruthinessExpression(node.condition);
          if (node.incrementor)
            checkExpression(node.incrementor);
          checkSourceElement(node.statement);
          if (node.locals) {
            registerForUnusedIdentifiersCheck(node);
          }
        }
        function checkForOfStatement(node) {
          checkGrammarForInOrForOfStatement(node);
          if (node.awaitModifier) {
            var functionFlags = ts2.getFunctionFlags(ts2.getContainingFunction(node));
            if ((functionFlags & (4 | 2)) === 2 && languageVersion < 99) {
              checkExternalEmitHelpers(node, 32768);
            }
          } else if (compilerOptions.downlevelIteration && languageVersion < 2) {
            checkExternalEmitHelpers(node, 256);
          }
          if (node.initializer.kind === 243) {
            checkForInOrForOfVariableDeclaration(node);
          } else {
            var varExpr = node.initializer;
            var iteratedType = checkRightHandSideOfForOf(node);
            if (varExpr.kind === 192 || varExpr.kind === 193) {
              checkDestructuringAssignment(varExpr, iteratedType || errorType);
            } else {
              var leftType = checkExpression(varExpr);
              checkReferenceExpression(varExpr, ts2.Diagnostics.The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access, ts2.Diagnostics.The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access);
              if (iteratedType) {
                checkTypeAssignableToAndOptionallyElaborate(iteratedType, leftType, varExpr, node.expression);
              }
            }
          }
          checkSourceElement(node.statement);
          if (node.locals) {
            registerForUnusedIdentifiersCheck(node);
          }
        }
        function checkForInStatement(node) {
          checkGrammarForInOrForOfStatement(node);
          var rightType = getNonNullableTypeIfNeeded(checkExpression(node.expression));
          if (node.initializer.kind === 243) {
            var variable = node.initializer.declarations[0];
            if (variable && ts2.isBindingPattern(variable.name)) {
              error(variable.name, ts2.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern);
            }
            checkForInOrForOfVariableDeclaration(node);
          } else {
            var varExpr = node.initializer;
            var leftType = checkExpression(varExpr);
            if (varExpr.kind === 192 || varExpr.kind === 193) {
              error(varExpr, ts2.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern);
            } else if (!isTypeAssignableTo(getIndexTypeOrString(rightType), leftType)) {
              error(varExpr, ts2.Diagnostics.The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any);
            } else {
              checkReferenceExpression(varExpr, ts2.Diagnostics.The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access, ts2.Diagnostics.The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access);
            }
          }
          if (rightType === neverType || !isTypeAssignableToKind(rightType, 67108864 | 58982400)) {
            error(node.expression, ts2.Diagnostics.The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_here_has_type_0, typeToString(rightType));
          }
          checkSourceElement(node.statement);
          if (node.locals) {
            registerForUnusedIdentifiersCheck(node);
          }
        }
        function checkForInOrForOfVariableDeclaration(iterationStatement) {
          var variableDeclarationList = iterationStatement.initializer;
          if (variableDeclarationList.declarations.length >= 1) {
            var decl = variableDeclarationList.declarations[0];
            checkVariableDeclaration(decl);
          }
        }
        function checkRightHandSideOfForOf(statement) {
          var use = statement.awaitModifier ? 15 : 13;
          return checkIteratedTypeOrElementType(use, checkNonNullExpression(statement.expression), undefinedType, statement.expression);
        }
        function checkIteratedTypeOrElementType(use, inputType, sentType, errorNode) {
          if (isTypeAny(inputType)) {
            return inputType;
          }
          return getIteratedTypeOrElementType(use, inputType, sentType, errorNode, true) || anyType;
        }
        function getIteratedTypeOrElementType(use, inputType, sentType, errorNode, checkAssignability) {
          var allowAsyncIterables = (use & 2) !== 0;
          if (inputType === neverType) {
            reportTypeNotIterableError(errorNode, inputType, allowAsyncIterables);
            return void 0;
          }
          var uplevelIteration = languageVersion >= 2;
          var downlevelIteration = !uplevelIteration && compilerOptions.downlevelIteration;
          if (uplevelIteration || downlevelIteration || allowAsyncIterables) {
            var iterationTypes = getIterationTypesOfIterable(inputType, use, uplevelIteration ? errorNode : void 0);
            if (checkAssignability) {
              if (iterationTypes) {
                var diagnostic = use & 8 ? ts2.Diagnostics.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_send_0 : use & 32 ? ts2.Diagnostics.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_always_send_0 : use & 64 ? ts2.Diagnostics.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring_will_always_send_0 : use & 16 ? ts2.Diagnostics.Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_containing_generator_will_always_send_0 : void 0;
                if (diagnostic) {
                  checkTypeAssignableTo(sentType, iterationTypes.nextType, errorNode, diagnostic);
                }
              }
            }
            if (iterationTypes || uplevelIteration) {
              return iterationTypes && iterationTypes.yieldType;
            }
          }
          var arrayType = inputType;
          var reportedError = false;
          var hasStringConstituent = false;
          if (use & 4) {
            if (arrayType.flags & 1048576) {
              var arrayTypes = inputType.types;
              var filteredTypes = ts2.filter(arrayTypes, function(t) {
                return !(t.flags & 132);
              });
              if (filteredTypes !== arrayTypes) {
                arrayType = getUnionType(filteredTypes, 2);
              }
            } else if (arrayType.flags & 132) {
              arrayType = neverType;
            }
            hasStringConstituent = arrayType !== inputType;
            if (hasStringConstituent) {
              if (languageVersion < 1) {
                if (errorNode) {
                  error(errorNode, ts2.Diagnostics.Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher);
                  reportedError = true;
                }
              }
              if (arrayType.flags & 131072) {
                return stringType;
              }
            }
          }
          if (!isArrayLikeType(arrayType)) {
            if (errorNode && !reportedError) {
              var yieldType = getIterationTypeOfIterable(use, 0, inputType, void 0);
              var _a = !(use & 4) || hasStringConstituent ? downlevelIteration ? [ts2.Diagnostics.Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator, true] : yieldType ? [ts2.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_Use_compiler_option_downlevelIteration_to_allow_iterating_of_iterators, false] : [ts2.Diagnostics.Type_0_is_not_an_array_type, true] : downlevelIteration ? [ts2.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator, true] : yieldType ? [ts2.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_Use_compiler_option_downlevelIteration_to_allow_iterating_of_iterators, false] : [ts2.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type, true], defaultDiagnostic = _a[0], maybeMissingAwait = _a[1];
              errorAndMaybeSuggestAwait(errorNode, maybeMissingAwait && !!getAwaitedTypeOfPromise(arrayType), defaultDiagnostic, typeToString(arrayType));
            }
            return hasStringConstituent ? stringType : void 0;
          }
          var arrayElementType = getIndexTypeOfType(arrayType, 1);
          if (hasStringConstituent && arrayElementType) {
            if (arrayElementType.flags & 132) {
              return stringType;
            }
            return getUnionType([arrayElementType, stringType], 2);
          }
          return arrayElementType;
        }
        function getIterationTypeOfIterable(use, typeKind, inputType, errorNode) {
          if (isTypeAny(inputType)) {
            return void 0;
          }
          var iterationTypes = getIterationTypesOfIterable(inputType, use, errorNode);
          return iterationTypes && iterationTypes[getIterationTypesKeyFromIterationTypeKind(typeKind)];
        }
        function createIterationTypes(yieldType, returnType, nextType) {
          if (yieldType === void 0) {
            yieldType = neverType;
          }
          if (returnType === void 0) {
            returnType = neverType;
          }
          if (nextType === void 0) {
            nextType = unknownType;
          }
          if (yieldType.flags & 67359327 && returnType.flags & (1 | 131072 | 2 | 16384 | 32768) && nextType.flags & (1 | 131072 | 2 | 16384 | 32768)) {
            var id = getTypeListId([yieldType, returnType, nextType]);
            var iterationTypes = iterationTypesCache.get(id);
            if (!iterationTypes) {
              iterationTypes = { yieldType, returnType, nextType };
              iterationTypesCache.set(id, iterationTypes);
            }
            return iterationTypes;
          }
          return { yieldType, returnType, nextType };
        }
        function combineIterationTypes(array) {
          var yieldTypes;
          var returnTypes;
          var nextTypes;
          for (var _i = 0, array_10 = array; _i < array_10.length; _i++) {
            var iterationTypes = array_10[_i];
            if (iterationTypes === void 0 || iterationTypes === noIterationTypes) {
              continue;
            }
            if (iterationTypes === anyIterationTypes) {
              return anyIterationTypes;
            }
            yieldTypes = ts2.append(yieldTypes, iterationTypes.yieldType);
            returnTypes = ts2.append(returnTypes, iterationTypes.returnType);
            nextTypes = ts2.append(nextTypes, iterationTypes.nextType);
          }
          if (yieldTypes || returnTypes || nextTypes) {
            return createIterationTypes(yieldTypes && getUnionType(yieldTypes), returnTypes && getUnionType(returnTypes), nextTypes && getIntersectionType(nextTypes));
          }
          return noIterationTypes;
        }
        function getCachedIterationTypes(type, cacheKey) {
          return type[cacheKey];
        }
        function setCachedIterationTypes(type, cacheKey, cachedTypes) {
          return type[cacheKey] = cachedTypes;
        }
        function getIterationTypesOfIterable(type, use, errorNode) {
          if (isTypeAny(type)) {
            return anyIterationTypes;
          }
          if (!(type.flags & 1048576)) {
            var iterationTypes_1 = getIterationTypesOfIterableWorker(type, use, errorNode);
            if (iterationTypes_1 === noIterationTypes) {
              if (errorNode) {
                reportTypeNotIterableError(errorNode, type, !!(use & 2));
              }
              return void 0;
            }
            return iterationTypes_1;
          }
          var cacheKey = use & 2 ? "iterationTypesOfAsyncIterable" : "iterationTypesOfIterable";
          var cachedTypes = getCachedIterationTypes(type, cacheKey);
          if (cachedTypes)
            return cachedTypes === noIterationTypes ? void 0 : cachedTypes;
          var allIterationTypes;
          for (var _i = 0, _a = type.types; _i < _a.length; _i++) {
            var constituent = _a[_i];
            var iterationTypes_2 = getIterationTypesOfIterableWorker(constituent, use, errorNode);
            if (iterationTypes_2 === noIterationTypes) {
              if (errorNode) {
                reportTypeNotIterableError(errorNode, type, !!(use & 2));
                errorNode = void 0;
              }
            } else {
              allIterationTypes = ts2.append(allIterationTypes, iterationTypes_2);
            }
          }
          var iterationTypes = allIterationTypes ? combineIterationTypes(allIterationTypes) : noIterationTypes;
          setCachedIterationTypes(type, cacheKey, iterationTypes);
          return iterationTypes === noIterationTypes ? void 0 : iterationTypes;
        }
        function getAsyncFromSyncIterationTypes(iterationTypes, errorNode) {
          if (iterationTypes === noIterationTypes)
            return noIterationTypes;
          if (iterationTypes === anyIterationTypes)
            return anyIterationTypes;
          var yieldType = iterationTypes.yieldType, returnType = iterationTypes.returnType, nextType = iterationTypes.nextType;
          return createIterationTypes(getAwaitedType(yieldType, errorNode) || anyType, getAwaitedType(returnType, errorNode) || anyType, nextType);
        }
        function getIterationTypesOfIterableWorker(type, use, errorNode) {
          if (isTypeAny(type)) {
            return anyIterationTypes;
          }
          if (use & 2) {
            var iterationTypes = getIterationTypesOfIterableCached(type, asyncIterationTypesResolver) || getIterationTypesOfIterableFast(type, asyncIterationTypesResolver);
            if (iterationTypes) {
              return iterationTypes;
            }
          }
          if (use & 1) {
            var iterationTypes = getIterationTypesOfIterableCached(type, syncIterationTypesResolver) || getIterationTypesOfIterableFast(type, syncIterationTypesResolver);
            if (iterationTypes) {
              if (use & 2) {
                if (iterationTypes !== noIterationTypes) {
                  return setCachedIterationTypes(type, "iterationTypesOfAsyncIterable", getAsyncFromSyncIterationTypes(iterationTypes, errorNode));
                }
              } else {
                return iterationTypes;
              }
            }
          }
          if (use & 2) {
            var iterationTypes = getIterationTypesOfIterableSlow(type, asyncIterationTypesResolver, errorNode);
            if (iterationTypes !== noIterationTypes) {
              return iterationTypes;
            }
          }
          if (use & 1) {
            var iterationTypes = getIterationTypesOfIterableSlow(type, syncIterationTypesResolver, errorNode);
            if (iterationTypes !== noIterationTypes) {
              if (use & 2) {
                return setCachedIterationTypes(type, "iterationTypesOfAsyncIterable", iterationTypes ? getAsyncFromSyncIterationTypes(iterationTypes, errorNode) : noIterationTypes);
              } else {
                return iterationTypes;
              }
            }
          }
          return noIterationTypes;
        }
        function getIterationTypesOfIterableCached(type, resolver) {
          return getCachedIterationTypes(type, resolver.iterableCacheKey);
        }
        function getIterationTypesOfGlobalIterableType(globalType, resolver) {
          var globalIterationTypes = getIterationTypesOfIterableCached(globalType, resolver) || getIterationTypesOfIterableSlow(globalType, resolver, void 0);
          return globalIterationTypes === noIterationTypes ? defaultIterationTypes : globalIterationTypes;
        }
        function getIterationTypesOfIterableFast(type, resolver) {
          var globalType;
          if (isReferenceToType(type, globalType = resolver.getGlobalIterableType(false)) || isReferenceToType(type, globalType = resolver.getGlobalIterableIteratorType(false))) {
            var yieldType = getTypeArguments(type)[0];
            var _a = getIterationTypesOfGlobalIterableType(globalType, resolver), returnType = _a.returnType, nextType = _a.nextType;
            return setCachedIterationTypes(type, resolver.iterableCacheKey, createIterationTypes(yieldType, returnType, nextType));
          }
          if (isReferenceToType(type, resolver.getGlobalGeneratorType(false))) {
            var _b = getTypeArguments(type), yieldType = _b[0], returnType = _b[1], nextType = _b[2];
            return setCachedIterationTypes(type, resolver.iterableCacheKey, createIterationTypes(yieldType, returnType, nextType));
          }
        }
        function getIterationTypesOfIterableSlow(type, resolver, errorNode) {
          var _a;
          var method = getPropertyOfType(type, ts2.getPropertyNameForKnownSymbolName(resolver.iteratorSymbolName));
          var methodType = method && !(method.flags & 16777216) ? getTypeOfSymbol(method) : void 0;
          if (isTypeAny(methodType)) {
            return setCachedIterationTypes(type, resolver.iterableCacheKey, anyIterationTypes);
          }
          var signatures = methodType ? getSignaturesOfType(methodType, 0) : void 0;
          if (!ts2.some(signatures)) {
            return setCachedIterationTypes(type, resolver.iterableCacheKey, noIterationTypes);
          }
          var iteratorType = getUnionType(ts2.map(signatures, getReturnTypeOfSignature), 2);
          var iterationTypes = (_a = getIterationTypesOfIterator(iteratorType, resolver, errorNode)) !== null && _a !== void 0 ? _a : noIterationTypes;
          return setCachedIterationTypes(type, resolver.iterableCacheKey, iterationTypes);
        }
        function reportTypeNotIterableError(errorNode, type, allowAsyncIterables) {
          var message = allowAsyncIterables ? ts2.Diagnostics.Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator : ts2.Diagnostics.Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator;
          errorAndMaybeSuggestAwait(errorNode, !!getAwaitedTypeOfPromise(type), message, typeToString(type));
        }
        function getIterationTypesOfIterator(type, resolver, errorNode) {
          if (isTypeAny(type)) {
            return anyIterationTypes;
          }
          var iterationTypes = getIterationTypesOfIteratorCached(type, resolver) || getIterationTypesOfIteratorFast(type, resolver) || getIterationTypesOfIteratorSlow(type, resolver, errorNode);
          return iterationTypes === noIterationTypes ? void 0 : iterationTypes;
        }
        function getIterationTypesOfIteratorCached(type, resolver) {
          return getCachedIterationTypes(type, resolver.iteratorCacheKey);
        }
        function getIterationTypesOfIteratorFast(type, resolver) {
          var globalType = resolver.getGlobalIterableIteratorType(false);
          if (isReferenceToType(type, globalType)) {
            var yieldType = getTypeArguments(type)[0];
            var globalIterationTypes = getIterationTypesOfIteratorCached(globalType, resolver) || getIterationTypesOfIteratorSlow(globalType, resolver, void 0);
            var _a = globalIterationTypes === noIterationTypes ? defaultIterationTypes : globalIterationTypes, returnType = _a.returnType, nextType = _a.nextType;
            return setCachedIterationTypes(type, resolver.iteratorCacheKey, createIterationTypes(yieldType, returnType, nextType));
          }
          if (isReferenceToType(type, resolver.getGlobalIteratorType(false)) || isReferenceToType(type, resolver.getGlobalGeneratorType(false))) {
            var _b = getTypeArguments(type), yieldType = _b[0], returnType = _b[1], nextType = _b[2];
            return setCachedIterationTypes(type, resolver.iteratorCacheKey, createIterationTypes(yieldType, returnType, nextType));
          }
        }
        function isIteratorResult(type, kind) {
          var doneType = getTypeOfPropertyOfType(type, "done") || falseType;
          return isTypeAssignableTo(kind === 0 ? falseType : trueType, doneType);
        }
        function isYieldIteratorResult(type) {
          return isIteratorResult(type, 0);
        }
        function isReturnIteratorResult(type) {
          return isIteratorResult(type, 1);
        }
        function getIterationTypesOfIteratorResult(type) {
          if (isTypeAny(type)) {
            return anyIterationTypes;
          }
          var cachedTypes = getCachedIterationTypes(type, "iterationTypesOfIteratorResult");
          if (cachedTypes) {
            return cachedTypes;
          }
          if (isReferenceToType(type, getGlobalIteratorYieldResultType(false))) {
            var yieldType_1 = getTypeArguments(type)[0];
            return setCachedIterationTypes(type, "iterationTypesOfIteratorResult", createIterationTypes(yieldType_1, void 0, void 0));
          }
          if (isReferenceToType(type, getGlobalIteratorReturnResultType(false))) {
            var returnType_1 = getTypeArguments(type)[0];
            return setCachedIterationTypes(type, "iterationTypesOfIteratorResult", createIterationTypes(void 0, returnType_1, void 0));
          }
          var yieldIteratorResult = filterType(type, isYieldIteratorResult);
          var yieldType = yieldIteratorResult !== neverType ? getTypeOfPropertyOfType(yieldIteratorResult, "value") : void 0;
          var returnIteratorResult = filterType(type, isReturnIteratorResult);
          var returnType = returnIteratorResult !== neverType ? getTypeOfPropertyOfType(returnIteratorResult, "value") : void 0;
          if (!yieldType && !returnType) {
            return setCachedIterationTypes(type, "iterationTypesOfIteratorResult", noIterationTypes);
          }
          return setCachedIterationTypes(type, "iterationTypesOfIteratorResult", createIterationTypes(yieldType, returnType || voidType, void 0));
        }
        function getIterationTypesOfMethod(type, resolver, methodName, errorNode) {
          var method = getPropertyOfType(type, methodName);
          if (!method && methodName !== "next") {
            return void 0;
          }
          var methodType = method && !(methodName === "next" && method.flags & 16777216) ? methodName === "next" ? getTypeOfSymbol(method) : getTypeWithFacts(getTypeOfSymbol(method), 2097152) : void 0;
          if (isTypeAny(methodType)) {
            return methodName === "next" ? anyIterationTypes : anyIterationTypesExceptNext;
          }
          var methodSignatures = methodType ? getSignaturesOfType(methodType, 0) : ts2.emptyArray;
          if (methodSignatures.length === 0) {
            if (errorNode) {
              var diagnostic = methodName === "next" ? resolver.mustHaveANextMethodDiagnostic : resolver.mustBeAMethodDiagnostic;
              error(errorNode, diagnostic, methodName);
            }
            return methodName === "next" ? anyIterationTypes : void 0;
          }
          var methodParameterTypes;
          var methodReturnTypes;
          for (var _i = 0, methodSignatures_1 = methodSignatures; _i < methodSignatures_1.length; _i++) {
            var signature = methodSignatures_1[_i];
            if (methodName !== "throw" && ts2.some(signature.parameters)) {
              methodParameterTypes = ts2.append(methodParameterTypes, getTypeAtPosition(signature, 0));
            }
            methodReturnTypes = ts2.append(methodReturnTypes, getReturnTypeOfSignature(signature));
          }
          var returnTypes;
          var nextType;
          if (methodName !== "throw") {
            var methodParameterType = methodParameterTypes ? getUnionType(methodParameterTypes) : unknownType;
            if (methodName === "next") {
              nextType = methodParameterType;
            } else if (methodName === "return") {
              var resolvedMethodParameterType = resolver.resolveIterationType(methodParameterType, errorNode) || anyType;
              returnTypes = ts2.append(returnTypes, resolvedMethodParameterType);
            }
          }
          var yieldType;
          var methodReturnType = methodReturnTypes ? getUnionType(methodReturnTypes, 2) : neverType;
          var resolvedMethodReturnType = resolver.resolveIterationType(methodReturnType, errorNode) || anyType;
          var iterationTypes = getIterationTypesOfIteratorResult(resolvedMethodReturnType);
          if (iterationTypes === noIterationTypes) {
            if (errorNode) {
              error(errorNode, resolver.mustHaveAValueDiagnostic, methodName);
            }
            yieldType = anyType;
            returnTypes = ts2.append(returnTypes, anyType);
          } else {
            yieldType = iterationTypes.yieldType;
            returnTypes = ts2.append(returnTypes, iterationTypes.returnType);
          }
          return createIterationTypes(yieldType, getUnionType(returnTypes), nextType);
        }
        function getIterationTypesOfIteratorSlow(type, resolver, errorNode) {
          var iterationTypes = combineIterationTypes([
            getIterationTypesOfMethod(type, resolver, "next", errorNode),
            getIterationTypesOfMethod(type, resolver, "return", errorNode),
            getIterationTypesOfMethod(type, resolver, "throw", errorNode)
          ]);
          return setCachedIterationTypes(type, resolver.iteratorCacheKey, iterationTypes);
        }
        function getIterationTypeOfGeneratorFunctionReturnType(kind, returnType, isAsyncGenerator) {
          if (isTypeAny(returnType)) {
            return void 0;
          }
          var iterationTypes = getIterationTypesOfGeneratorFunctionReturnType(returnType, isAsyncGenerator);
          return iterationTypes && iterationTypes[getIterationTypesKeyFromIterationTypeKind(kind)];
        }
        function getIterationTypesOfGeneratorFunctionReturnType(type, isAsyncGenerator) {
          if (isTypeAny(type)) {
            return anyIterationTypes;
          }
          var use = isAsyncGenerator ? 2 : 1;
          var resolver = isAsyncGenerator ? asyncIterationTypesResolver : syncIterationTypesResolver;
          return getIterationTypesOfIterable(type, use, void 0) || getIterationTypesOfIterator(type, resolver, void 0);
        }
        function checkBreakOrContinueStatement(node) {
          if (!checkGrammarStatementInAmbientContext(node))
            checkGrammarBreakOrContinueStatement(node);
        }
        function unwrapReturnType(returnType, functionFlags) {
          var _a, _b;
          var isGenerator = !!(functionFlags & 1);
          var isAsync = !!(functionFlags & 2);
          return isGenerator ? (_a = getIterationTypeOfGeneratorFunctionReturnType(1, returnType, isAsync)) !== null && _a !== void 0 ? _a : errorType : isAsync ? (_b = getAwaitedType(returnType)) !== null && _b !== void 0 ? _b : errorType : returnType;
        }
        function isUnwrappedReturnTypeVoidOrAny(func, returnType) {
          var unwrappedReturnType = unwrapReturnType(returnType, ts2.getFunctionFlags(func));
          return !!unwrappedReturnType && maybeTypeOfKind(unwrappedReturnType, 16384 | 3);
        }
        function checkReturnStatement(node) {
          var _a;
          if (checkGrammarStatementInAmbientContext(node)) {
            return;
          }
          var func = ts2.getContainingFunction(node);
          if (!func) {
            grammarErrorOnFirstToken(node, ts2.Diagnostics.A_return_statement_can_only_be_used_within_a_function_body);
            return;
          }
          var signature = getSignatureFromDeclaration(func);
          var returnType = getReturnTypeOfSignature(signature);
          var functionFlags = ts2.getFunctionFlags(func);
          if (strictNullChecks || node.expression || returnType.flags & 131072) {
            var exprType = node.expression ? checkExpressionCached(node.expression) : undefinedType;
            if (func.kind === 164) {
              if (node.expression) {
                error(node, ts2.Diagnostics.Setters_cannot_return_a_value);
              }
            } else if (func.kind === 162) {
              if (node.expression && !checkTypeAssignableToAndOptionallyElaborate(exprType, returnType, node, node.expression)) {
                error(node, ts2.Diagnostics.Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class);
              }
            } else if (getReturnTypeFromAnnotation(func)) {
              var unwrappedReturnType = (_a = unwrapReturnType(returnType, functionFlags)) !== null && _a !== void 0 ? _a : returnType;
              var unwrappedExprType = functionFlags & 2 ? checkAwaitedType(exprType, node, ts2.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member) : exprType;
              if (unwrappedReturnType) {
                checkTypeAssignableToAndOptionallyElaborate(unwrappedExprType, unwrappedReturnType, node, node.expression);
              }
            }
          } else if (func.kind !== 162 && compilerOptions.noImplicitReturns && !isUnwrappedReturnTypeVoidOrAny(func, returnType)) {
            error(node, ts2.Diagnostics.Not_all_code_paths_return_a_value);
          }
        }
        function checkWithStatement(node) {
          if (!checkGrammarStatementInAmbientContext(node)) {
            if (node.flags & 32768) {
              grammarErrorOnFirstToken(node, ts2.Diagnostics.with_statements_are_not_allowed_in_an_async_function_block);
            }
          }
          checkExpression(node.expression);
          var sourceFile = ts2.getSourceFileOfNode(node);
          if (!hasParseDiagnostics(sourceFile)) {
            var start = ts2.getSpanOfTokenAtPosition(sourceFile, node.pos).start;
            var end = node.statement.pos;
            grammarErrorAtPos(sourceFile, start, end - start, ts2.Diagnostics.The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any);
          }
        }
        function checkSwitchStatement(node) {
          checkGrammarStatementInAmbientContext(node);
          var firstDefaultClause;
          var hasDuplicateDefaultClause = false;
          var expressionType = checkExpression(node.expression);
          var expressionIsLiteral = isLiteralType(expressionType);
          ts2.forEach(node.caseBlock.clauses, function(clause) {
            if (clause.kind === 278 && !hasDuplicateDefaultClause) {
              if (firstDefaultClause === void 0) {
                firstDefaultClause = clause;
              } else {
                grammarErrorOnNode(clause, ts2.Diagnostics.A_default_clause_cannot_appear_more_than_once_in_a_switch_statement);
                hasDuplicateDefaultClause = true;
              }
            }
            if (produceDiagnostics && clause.kind === 277) {
              var caseType = checkExpression(clause.expression);
              var caseIsLiteral = isLiteralType(caseType);
              var comparedExpressionType = expressionType;
              if (!caseIsLiteral || !expressionIsLiteral) {
                caseType = caseIsLiteral ? getBaseTypeOfLiteralType(caseType) : caseType;
                comparedExpressionType = getBaseTypeOfLiteralType(expressionType);
              }
              if (!isTypeEqualityComparableTo(comparedExpressionType, caseType)) {
                checkTypeComparableTo(caseType, comparedExpressionType, clause.expression, void 0);
              }
            }
            ts2.forEach(clause.statements, checkSourceElement);
            if (compilerOptions.noFallthroughCasesInSwitch && clause.fallthroughFlowNode && isReachableFlowNode(clause.fallthroughFlowNode)) {
              error(clause, ts2.Diagnostics.Fallthrough_case_in_switch);
            }
          });
          if (node.caseBlock.locals) {
            registerForUnusedIdentifiersCheck(node.caseBlock);
          }
        }
        function checkLabeledStatement(node) {
          if (!checkGrammarStatementInAmbientContext(node)) {
            ts2.findAncestor(node.parent, function(current) {
              if (ts2.isFunctionLike(current)) {
                return "quit";
              }
              if (current.kind === 238 && current.label.escapedText === node.label.escapedText) {
                grammarErrorOnNode(node.label, ts2.Diagnostics.Duplicate_label_0, ts2.getTextOfNode(node.label));
                return true;
              }
              return false;
            });
          }
          checkSourceElement(node.statement);
        }
        function checkThrowStatement(node) {
          if (!checkGrammarStatementInAmbientContext(node)) {
            if (node.expression === void 0) {
              grammarErrorAfterFirstToken(node, ts2.Diagnostics.Line_break_not_permitted_here);
            }
          }
          if (node.expression) {
            checkExpression(node.expression);
          }
        }
        function checkTryStatement(node) {
          checkGrammarStatementInAmbientContext(node);
          checkBlock(node.tryBlock);
          var catchClause = node.catchClause;
          if (catchClause) {
            if (catchClause.variableDeclaration) {
              if (catchClause.variableDeclaration.type) {
                grammarErrorOnFirstToken(catchClause.variableDeclaration.type, ts2.Diagnostics.Catch_clause_variable_cannot_have_a_type_annotation);
              } else if (catchClause.variableDeclaration.initializer) {
                grammarErrorOnFirstToken(catchClause.variableDeclaration.initializer, ts2.Diagnostics.Catch_clause_variable_cannot_have_an_initializer);
              } else {
                var blockLocals_1 = catchClause.block.locals;
                if (blockLocals_1) {
                  ts2.forEachKey(catchClause.locals, function(caughtName) {
                    var blockLocal = blockLocals_1.get(caughtName);
                    if (blockLocal && (blockLocal.flags & 2) !== 0) {
                      grammarErrorOnNode(blockLocal.valueDeclaration, ts2.Diagnostics.Cannot_redeclare_identifier_0_in_catch_clause, caughtName);
                    }
                  });
                }
              }
            }
            checkBlock(catchClause.block);
          }
          if (node.finallyBlock) {
            checkBlock(node.finallyBlock);
          }
        }
        function checkIndexConstraints(type) {
          var declaredNumberIndexer = getIndexDeclarationOfSymbol(type.symbol, 1);
          var declaredStringIndexer = getIndexDeclarationOfSymbol(type.symbol, 0);
          var stringIndexType = getIndexTypeOfType(type, 0);
          var numberIndexType = getIndexTypeOfType(type, 1);
          if (stringIndexType || numberIndexType) {
            ts2.forEach(getPropertiesOfObjectType(type), function(prop) {
              var propType2 = getTypeOfSymbol(prop);
              checkIndexConstraintForProperty(prop, propType2, type, declaredStringIndexer, stringIndexType, 0);
              checkIndexConstraintForProperty(prop, propType2, type, declaredNumberIndexer, numberIndexType, 1);
            });
            var classDeclaration = type.symbol.valueDeclaration;
            if (ts2.getObjectFlags(type) & 1 && ts2.isClassLike(classDeclaration)) {
              for (var _i = 0, _a = classDeclaration.members; _i < _a.length; _i++) {
                var member = _a[_i];
                if (!ts2.hasModifier(member, 32) && hasNonBindableDynamicName(member)) {
                  var symbol = getSymbolOfNode(member);
                  var propType = getTypeOfSymbol(symbol);
                  checkIndexConstraintForProperty(symbol, propType, type, declaredStringIndexer, stringIndexType, 0);
                  checkIndexConstraintForProperty(symbol, propType, type, declaredNumberIndexer, numberIndexType, 1);
                }
              }
            }
          }
          var errorNode;
          if (stringIndexType && numberIndexType) {
            errorNode = declaredNumberIndexer || declaredStringIndexer;
            if (!errorNode && ts2.getObjectFlags(type) & 2) {
              var someBaseTypeHasBothIndexers = ts2.forEach(getBaseTypes(type), function(base) {
                return getIndexTypeOfType(base, 0) && getIndexTypeOfType(base, 1);
              });
              errorNode = someBaseTypeHasBothIndexers ? void 0 : type.symbol.declarations[0];
            }
          }
          if (errorNode && !isTypeAssignableTo(numberIndexType, stringIndexType)) {
            error(errorNode, ts2.Diagnostics.Numeric_index_type_0_is_not_assignable_to_string_index_type_1, typeToString(numberIndexType), typeToString(stringIndexType));
          }
          function checkIndexConstraintForProperty(prop, propertyType, containingType, indexDeclaration, indexType, indexKind) {
            if (!indexType || ts2.isKnownSymbol(prop)) {
              return;
            }
            var propDeclaration = prop.valueDeclaration;
            var name = propDeclaration && ts2.getNameOfDeclaration(propDeclaration);
            if (name && ts2.isPrivateIdentifier(name)) {
              return;
            }
            if (indexKind === 1 && !(name ? isNumericName(name) : isNumericLiteralName(prop.escapedName))) {
              return;
            }
            var errorNode2;
            if (propDeclaration && name && (propDeclaration.kind === 209 || name.kind === 154 || prop.parent === containingType.symbol)) {
              errorNode2 = propDeclaration;
            } else if (indexDeclaration) {
              errorNode2 = indexDeclaration;
            } else if (ts2.getObjectFlags(containingType) & 2) {
              var someBaseClassHasBothPropertyAndIndexer = ts2.forEach(getBaseTypes(containingType), function(base) {
                return getPropertyOfObjectType(base, prop.escapedName) && getIndexTypeOfType(base, indexKind);
              });
              errorNode2 = someBaseClassHasBothPropertyAndIndexer ? void 0 : containingType.symbol.declarations[0];
            }
            if (errorNode2 && !isTypeAssignableTo(propertyType, indexType)) {
              var errorMessage = indexKind === 0 ? ts2.Diagnostics.Property_0_of_type_1_is_not_assignable_to_string_index_type_2 : ts2.Diagnostics.Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2;
              error(errorNode2, errorMessage, symbolToString(prop), typeToString(propertyType), typeToString(indexType));
            }
          }
        }
        function checkTypeNameIsReserved(name, message) {
          switch (name.escapedText) {
            case "any":
            case "unknown":
            case "number":
            case "bigint":
            case "boolean":
            case "string":
            case "symbol":
            case "void":
            case "object":
              error(name, message, name.escapedText);
          }
        }
        function checkClassNameCollisionWithObject(name) {
          if (languageVersion === 1 && name.escapedText === "Object" && moduleKind < ts2.ModuleKind.ES2015) {
            error(name, ts2.Diagnostics.Class_name_cannot_be_Object_when_targeting_ES5_with_module_0, ts2.ModuleKind[moduleKind]);
          }
        }
        function checkTypeParameters(typeParameterDeclarations) {
          if (typeParameterDeclarations) {
            var seenDefault = false;
            for (var i = 0; i < typeParameterDeclarations.length; i++) {
              var node = typeParameterDeclarations[i];
              checkTypeParameter(node);
              if (produceDiagnostics) {
                if (node.default) {
                  seenDefault = true;
                  checkTypeParametersNotReferenced(node.default, typeParameterDeclarations, i);
                } else if (seenDefault) {
                  error(node, ts2.Diagnostics.Required_type_parameters_may_not_follow_optional_type_parameters);
                }
                for (var j = 0; j < i; j++) {
                  if (typeParameterDeclarations[j].symbol === node.symbol) {
                    error(node.name, ts2.Diagnostics.Duplicate_identifier_0, ts2.declarationNameToString(node.name));
                  }
                }
              }
            }
          }
        }
        function checkTypeParametersNotReferenced(root, typeParameters, index) {
          visit(root);
          function visit(node) {
            if (node.kind === 169) {
              var type = getTypeFromTypeReference(node);
              if (type.flags & 262144) {
                for (var i = index; i < typeParameters.length; i++) {
                  if (type.symbol === getSymbolOfNode(typeParameters[i])) {
                    error(node, ts2.Diagnostics.Type_parameter_defaults_can_only_reference_previously_declared_type_parameters);
                  }
                }
              }
            }
            ts2.forEachChild(node, visit);
          }
        }
        function checkTypeParameterListsIdentical(symbol) {
          if (symbol.declarations.length === 1) {
            return;
          }
          var links = getSymbolLinks(symbol);
          if (!links.typeParametersChecked) {
            links.typeParametersChecked = true;
            var declarations = getClassOrInterfaceDeclarationsOfSymbol(symbol);
            if (declarations.length <= 1) {
              return;
            }
            var type = getDeclaredTypeOfSymbol(symbol);
            if (!areTypeParametersIdentical(declarations, type.localTypeParameters)) {
              var name = symbolToString(symbol);
              for (var _i = 0, declarations_6 = declarations; _i < declarations_6.length; _i++) {
                var declaration = declarations_6[_i];
                error(declaration.name, ts2.Diagnostics.All_declarations_of_0_must_have_identical_type_parameters, name);
              }
            }
          }
        }
        function areTypeParametersIdentical(declarations, targetParameters) {
          var maxTypeArgumentCount = ts2.length(targetParameters);
          var minTypeArgumentCount = getMinTypeArgumentCount(targetParameters);
          for (var _i = 0, declarations_7 = declarations; _i < declarations_7.length; _i++) {
            var declaration = declarations_7[_i];
            var sourceParameters = ts2.getEffectiveTypeParameterDeclarations(declaration);
            var numTypeParameters = sourceParameters.length;
            if (numTypeParameters < minTypeArgumentCount || numTypeParameters > maxTypeArgumentCount) {
              return false;
            }
            for (var i = 0; i < numTypeParameters; i++) {
              var source = sourceParameters[i];
              var target = targetParameters[i];
              if (source.name.escapedText !== target.symbol.escapedName) {
                return false;
              }
              var constraint = ts2.getEffectiveConstraintOfTypeParameter(source);
              var sourceConstraint = constraint && getTypeFromTypeNode(constraint);
              var targetConstraint = getConstraintOfTypeParameter(target);
              if (sourceConstraint && targetConstraint && !isTypeIdenticalTo(sourceConstraint, targetConstraint)) {
                return false;
              }
              var sourceDefault = source.default && getTypeFromTypeNode(source.default);
              var targetDefault = getDefaultFromTypeParameter(target);
              if (sourceDefault && targetDefault && !isTypeIdenticalTo(sourceDefault, targetDefault)) {
                return false;
              }
            }
          }
          return true;
        }
        function checkClassExpression(node) {
          checkClassLikeDeclaration(node);
          checkNodeDeferred(node);
          return getTypeOfSymbol(getSymbolOfNode(node));
        }
        function checkClassExpressionDeferred(node) {
          ts2.forEach(node.members, checkSourceElement);
          registerForUnusedIdentifiersCheck(node);
        }
        function checkClassDeclaration(node) {
          if (!node.name && !ts2.hasModifier(node, 512)) {
            grammarErrorOnFirstToken(node, ts2.Diagnostics.A_class_declaration_without_the_default_modifier_must_have_a_name);
          }
          checkClassLikeDeclaration(node);
          ts2.forEach(node.members, checkSourceElement);
          registerForUnusedIdentifiersCheck(node);
        }
        function checkClassLikeDeclaration(node) {
          checkGrammarClassLikeDeclaration(node);
          checkDecorators(node);
          if (node.name) {
            checkTypeNameIsReserved(node.name, ts2.Diagnostics.Class_name_cannot_be_0);
            checkCollisionWithRequireExportsInGeneratedCode(node, node.name);
            checkCollisionWithGlobalPromiseInGeneratedCode(node, node.name);
            if (!(node.flags & 8388608)) {
              checkClassNameCollisionWithObject(node.name);
            }
          }
          checkTypeParameters(ts2.getEffectiveTypeParameterDeclarations(node));
          checkExportsOnMergedDeclarations(node);
          var symbol = getSymbolOfNode(node);
          var type = getDeclaredTypeOfSymbol(symbol);
          var typeWithThis = getTypeWithThisArgument(type);
          var staticType = getTypeOfSymbol(symbol);
          checkTypeParameterListsIdentical(symbol);
          checkClassForDuplicateDeclarations(node);
          if (!(node.flags & 8388608)) {
            checkClassForStaticPropertyNameConflicts(node);
          }
          var baseTypeNode = ts2.getEffectiveBaseTypeNode(node);
          if (baseTypeNode) {
            ts2.forEach(baseTypeNode.typeArguments, checkSourceElement);
            if (languageVersion < 2) {
              checkExternalEmitHelpers(baseTypeNode.parent, 1);
            }
            var extendsNode = ts2.getClassExtendsHeritageElement(node);
            if (extendsNode && extendsNode !== baseTypeNode) {
              checkExpression(extendsNode.expression);
            }
            var baseTypes = getBaseTypes(type);
            if (baseTypes.length && produceDiagnostics) {
              var baseType_1 = baseTypes[0];
              var baseConstructorType = getBaseConstructorTypeOfClass(type);
              var staticBaseType = getApparentType(baseConstructorType);
              checkBaseTypeAccessibility(staticBaseType, baseTypeNode);
              checkSourceElement(baseTypeNode.expression);
              if (ts2.some(baseTypeNode.typeArguments)) {
                ts2.forEach(baseTypeNode.typeArguments, checkSourceElement);
                for (var _i = 0, _a = getConstructorsForTypeArguments(staticBaseType, baseTypeNode.typeArguments, baseTypeNode); _i < _a.length; _i++) {
                  var constructor = _a[_i];
                  if (!checkTypeArgumentConstraints(baseTypeNode, constructor.typeParameters)) {
                    break;
                  }
                }
              }
              var baseWithThis = getTypeWithThisArgument(baseType_1, type.thisType);
              if (!checkTypeAssignableTo(typeWithThis, baseWithThis, void 0)) {
                issueMemberSpecificError(node, typeWithThis, baseWithThis, ts2.Diagnostics.Class_0_incorrectly_extends_base_class_1);
              } else {
                checkTypeAssignableTo(staticType, getTypeWithoutSignatures(staticBaseType), node.name || node, ts2.Diagnostics.Class_static_side_0_incorrectly_extends_base_class_static_side_1);
              }
              if (baseConstructorType.flags & 8650752 && !isMixinConstructorType(staticType)) {
                error(node.name || node, ts2.Diagnostics.A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any);
              }
              if (!(staticBaseType.symbol && staticBaseType.symbol.flags & 32) && !(baseConstructorType.flags & 8650752)) {
                var constructors = getInstantiatedConstructorsForTypeArguments(staticBaseType, baseTypeNode.typeArguments, baseTypeNode);
                if (ts2.forEach(constructors, function(sig) {
                  return !isJSConstructor(sig.declaration) && !isTypeIdenticalTo(getReturnTypeOfSignature(sig), baseType_1);
                })) {
                  error(baseTypeNode.expression, ts2.Diagnostics.Base_constructors_must_all_have_the_same_return_type);
                }
              }
              checkKindsOfPropertyMemberOverrides(type, baseType_1);
            }
          }
          var implementedTypeNodes = ts2.getEffectiveImplementsTypeNodes(node);
          if (implementedTypeNodes) {
            for (var _b = 0, implementedTypeNodes_1 = implementedTypeNodes; _b < implementedTypeNodes_1.length; _b++) {
              var typeRefNode = implementedTypeNodes_1[_b];
              if (!ts2.isEntityNameExpression(typeRefNode.expression)) {
                error(typeRefNode.expression, ts2.Diagnostics.A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments);
              }
              checkTypeReferenceNode(typeRefNode);
              if (produceDiagnostics) {
                var t = getReducedType(getTypeFromTypeNode(typeRefNode));
                if (t !== errorType) {
                  if (isValidBaseType(t)) {
                    var genericDiag = t.symbol && t.symbol.flags & 32 ? ts2.Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass : ts2.Diagnostics.Class_0_incorrectly_implements_interface_1;
                    var baseWithThis = getTypeWithThisArgument(t, type.thisType);
                    if (!checkTypeAssignableTo(typeWithThis, baseWithThis, void 0)) {
                      issueMemberSpecificError(node, typeWithThis, baseWithThis, genericDiag);
                    }
                  } else {
                    error(typeRefNode, ts2.Diagnostics.A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_members);
                  }
                }
              }
            }
          }
          if (produceDiagnostics) {
            checkIndexConstraints(type);
            checkTypeForDuplicateIndexSignatures(node);
            checkPropertyInitialization(node);
          }
        }
        function issueMemberSpecificError(node, typeWithThis, baseWithThis, broadDiag) {
          var issuedMemberError = false;
          var _loop_19 = function(member2) {
            if (ts2.hasStaticModifier(member2)) {
              return "continue";
            }
            var declaredProp = member2.name && getSymbolAtLocation(member2.name) || getSymbolAtLocation(member2);
            if (declaredProp) {
              var prop = getPropertyOfType(typeWithThis, declaredProp.escapedName);
              var baseProp = getPropertyOfType(baseWithThis, declaredProp.escapedName);
              if (prop && baseProp) {
                var rootChain = function() {
                  return ts2.chainDiagnosticMessages(void 0, ts2.Diagnostics.Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2, symbolToString(declaredProp), typeToString(typeWithThis), typeToString(baseWithThis));
                };
                if (!checkTypeAssignableTo(getTypeOfSymbol(prop), getTypeOfSymbol(baseProp), member2.name || member2, void 0, rootChain)) {
                  issuedMemberError = true;
                }
              }
            }
          };
          for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
            var member = _a[_i];
            _loop_19(member);
          }
          if (!issuedMemberError) {
            checkTypeAssignableTo(typeWithThis, baseWithThis, node.name || node, broadDiag);
          }
        }
        function checkBaseTypeAccessibility(type, node) {
          var signatures = getSignaturesOfType(type, 1);
          if (signatures.length) {
            var declaration = signatures[0].declaration;
            if (declaration && ts2.hasModifier(declaration, 8)) {
              var typeClassDeclaration = ts2.getClassLikeDeclarationOfSymbol(type.symbol);
              if (!isNodeWithinClass(node, typeClassDeclaration)) {
                error(node, ts2.Diagnostics.Cannot_extend_a_class_0_Class_constructor_is_marked_as_private, getFullyQualifiedName(type.symbol));
              }
            }
          }
        }
        function getTargetSymbol(s) {
          return ts2.getCheckFlags(s) & 1 ? s.target : s;
        }
        function getClassOrInterfaceDeclarationsOfSymbol(symbol) {
          return ts2.filter(symbol.declarations, function(d) {
            return d.kind === 245 || d.kind === 246;
          });
        }
        function checkKindsOfPropertyMemberOverrides(type, baseType) {
          var baseProperties = getPropertiesOfType(baseType);
          basePropertyCheck:
            for (var _i = 0, baseProperties_1 = baseProperties; _i < baseProperties_1.length; _i++) {
              var baseProperty = baseProperties_1[_i];
              var base = getTargetSymbol(baseProperty);
              if (base.flags & 4194304) {
                continue;
              }
              var baseSymbol = getPropertyOfObjectType(type, base.escapedName);
              if (!baseSymbol) {
                continue;
              }
              var derived = getTargetSymbol(baseSymbol);
              var baseDeclarationFlags = ts2.getDeclarationModifierFlagsFromSymbol(base);
              ts2.Debug.assert(!!derived, "derived should point to something, even if it is the base class' declaration.");
              if (derived === base) {
                var derivedClassDecl = ts2.getClassLikeDeclarationOfSymbol(type.symbol);
                if (baseDeclarationFlags & 128 && (!derivedClassDecl || !ts2.hasModifier(derivedClassDecl, 128))) {
                  for (var _a = 0, _b = getBaseTypes(type); _a < _b.length; _a++) {
                    var otherBaseType = _b[_a];
                    if (otherBaseType === baseType)
                      continue;
                    var baseSymbol_1 = getPropertyOfObjectType(otherBaseType, base.escapedName);
                    var derivedElsewhere = baseSymbol_1 && getTargetSymbol(baseSymbol_1);
                    if (derivedElsewhere && derivedElsewhere !== base) {
                      continue basePropertyCheck;
                    }
                  }
                  if (derivedClassDecl.kind === 214) {
                    error(derivedClassDecl, ts2.Diagnostics.Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1, symbolToString(baseProperty), typeToString(baseType));
                  } else {
                    error(derivedClassDecl, ts2.Diagnostics.Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2, typeToString(type), symbolToString(baseProperty), typeToString(baseType));
                  }
                }
              } else {
                var derivedDeclarationFlags = ts2.getDeclarationModifierFlagsFromSymbol(derived);
                if (baseDeclarationFlags & 8 || derivedDeclarationFlags & 8) {
                  continue;
                }
                var errorMessage = void 0;
                var basePropertyFlags = base.flags & 98308;
                var derivedPropertyFlags = derived.flags & 98308;
                if (basePropertyFlags && derivedPropertyFlags) {
                  if (!compilerOptions.useDefineForClassFields || baseDeclarationFlags & 128 && !(base.valueDeclaration && ts2.isPropertyDeclaration(base.valueDeclaration) && base.valueDeclaration.initializer) || base.valueDeclaration && base.valueDeclaration.parent.kind === 246 || derived.valueDeclaration && ts2.isBinaryExpression(derived.valueDeclaration)) {
                    continue;
                  }
                  var overriddenInstanceProperty = basePropertyFlags !== 4 && derivedPropertyFlags === 4;
                  var overriddenInstanceAccessor = basePropertyFlags === 4 && derivedPropertyFlags !== 4;
                  if (overriddenInstanceProperty || overriddenInstanceAccessor) {
                    var errorMessage_1 = overriddenInstanceProperty ? ts2.Diagnostics._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property : ts2.Diagnostics._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor;
                    error(ts2.getNameOfDeclaration(derived.valueDeclaration) || derived.valueDeclaration, errorMessage_1, symbolToString(base), typeToString(baseType), typeToString(type));
                  } else {
                    var uninitialized = ts2.find(derived.declarations, function(d) {
                      return d.kind === 159 && !d.initializer;
                    });
                    if (uninitialized && !(derived.flags & 33554432) && !(baseDeclarationFlags & 128) && !(derivedDeclarationFlags & 128) && !derived.declarations.some(function(d) {
                      return !!(d.flags & 8388608);
                    })) {
                      var constructor = findConstructorDeclaration(ts2.getClassLikeDeclarationOfSymbol(type.symbol));
                      var propName = uninitialized.name;
                      if (uninitialized.exclamationToken || !constructor || !ts2.isIdentifier(propName) || !strictNullChecks || !isPropertyInitializedInConstructor(propName, type, constructor)) {
                        var errorMessage_2 = ts2.Diagnostics.Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration;
                        error(ts2.getNameOfDeclaration(derived.valueDeclaration) || derived.valueDeclaration, errorMessage_2, symbolToString(base), typeToString(baseType));
                      }
                    }
                  }
                  continue;
                } else if (isPrototypeProperty(base)) {
                  if (isPrototypeProperty(derived) || derived.flags & 4) {
                    continue;
                  } else {
                    ts2.Debug.assert(!!(derived.flags & 98304));
                    errorMessage = ts2.Diagnostics.Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor;
                  }
                } else if (base.flags & 98304) {
                  errorMessage = ts2.Diagnostics.Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function;
                } else {
                  errorMessage = ts2.Diagnostics.Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function;
                }
                error(ts2.getNameOfDeclaration(derived.valueDeclaration) || derived.valueDeclaration, errorMessage, typeToString(baseType), symbolToString(base), typeToString(type));
              }
            }
        }
        function getNonInterhitedProperties(type, baseTypes, properties) {
          if (!ts2.length(baseTypes)) {
            return properties;
          }
          var seen = ts2.createUnderscoreEscapedMap();
          ts2.forEach(properties, function(p) {
            seen.set(p.escapedName, p);
          });
          for (var _i = 0, baseTypes_2 = baseTypes; _i < baseTypes_2.length; _i++) {
            var base = baseTypes_2[_i];
            var properties_5 = getPropertiesOfType(getTypeWithThisArgument(base, type.thisType));
            for (var _a = 0, properties_4 = properties_5; _a < properties_4.length; _a++) {
              var prop = properties_4[_a];
              var existing = seen.get(prop.escapedName);
              if (existing && !isPropertyIdenticalTo(existing, prop)) {
                seen.delete(prop.escapedName);
              }
            }
          }
          return ts2.arrayFrom(seen.values());
        }
        function checkInheritedPropertiesAreIdentical(type, typeNode) {
          var baseTypes = getBaseTypes(type);
          if (baseTypes.length < 2) {
            return true;
          }
          var seen = ts2.createUnderscoreEscapedMap();
          ts2.forEach(resolveDeclaredMembers(type).declaredProperties, function(p) {
            seen.set(p.escapedName, { prop: p, containingType: type });
          });
          var ok = true;
          for (var _i = 0, baseTypes_3 = baseTypes; _i < baseTypes_3.length; _i++) {
            var base = baseTypes_3[_i];
            var properties = getPropertiesOfType(getTypeWithThisArgument(base, type.thisType));
            for (var _a = 0, properties_6 = properties; _a < properties_6.length; _a++) {
              var prop = properties_6[_a];
              var existing = seen.get(prop.escapedName);
              if (!existing) {
                seen.set(prop.escapedName, { prop, containingType: base });
              } else {
                var isInheritedProperty = existing.containingType !== type;
                if (isInheritedProperty && !isPropertyIdenticalTo(existing.prop, prop)) {
                  ok = false;
                  var typeName1 = typeToString(existing.containingType);
                  var typeName2 = typeToString(base);
                  var errorInfo = ts2.chainDiagnosticMessages(void 0, ts2.Diagnostics.Named_property_0_of_types_1_and_2_are_not_identical, symbolToString(prop), typeName1, typeName2);
                  errorInfo = ts2.chainDiagnosticMessages(errorInfo, ts2.Diagnostics.Interface_0_cannot_simultaneously_extend_types_1_and_2, typeToString(type), typeName1, typeName2);
                  diagnostics.add(ts2.createDiagnosticForNodeFromMessageChain(typeNode, errorInfo));
                }
              }
            }
          }
          return ok;
        }
        function checkPropertyInitialization(node) {
          if (!strictNullChecks || !strictPropertyInitialization || node.flags & 8388608) {
            return;
          }
          var constructor = findConstructorDeclaration(node);
          for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
            var member = _a[_i];
            if (ts2.getModifierFlags(member) & 2) {
              continue;
            }
            if (isInstancePropertyWithoutInitializer(member)) {
              var propName = member.name;
              if (ts2.isIdentifier(propName) || ts2.isPrivateIdentifier(propName)) {
                var type = getTypeOfSymbol(getSymbolOfNode(member));
                if (!(type.flags & 3 || getFalsyFlags(type) & 32768)) {
                  if (!constructor || !isPropertyInitializedInConstructor(propName, type, constructor)) {
                    error(member.name, ts2.Diagnostics.Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor, ts2.declarationNameToString(propName));
                  }
                }
              }
            }
          }
        }
        function isInstancePropertyWithoutInitializer(node) {
          return node.kind === 159 && !ts2.hasModifier(node, 32 | 128) && !node.exclamationToken && !node.initializer;
        }
        function isPropertyInitializedInConstructor(propName, propType, constructor) {
          var reference = ts2.createPropertyAccess(ts2.createThis(), propName);
          reference.expression.parent = reference;
          reference.parent = constructor;
          reference.flowNode = constructor.returnFlowNode;
          var flowType = getFlowTypeOfReference(reference, propType, getOptionalType(propType));
          return !(getFalsyFlags(flowType) & 32768);
        }
        function checkInterfaceDeclaration(node) {
          if (!checkGrammarDecoratorsAndModifiers(node))
            checkGrammarInterfaceDeclaration(node);
          checkTypeParameters(node.typeParameters);
          if (produceDiagnostics) {
            checkTypeNameIsReserved(node.name, ts2.Diagnostics.Interface_name_cannot_be_0);
            checkExportsOnMergedDeclarations(node);
            var symbol = getSymbolOfNode(node);
            checkTypeParameterListsIdentical(symbol);
            var firstInterfaceDecl = ts2.getDeclarationOfKind(symbol, 246);
            if (node === firstInterfaceDecl) {
              var type = getDeclaredTypeOfSymbol(symbol);
              var typeWithThis = getTypeWithThisArgument(type);
              if (checkInheritedPropertiesAreIdentical(type, node.name)) {
                for (var _i = 0, _a = getBaseTypes(type); _i < _a.length; _i++) {
                  var baseType = _a[_i];
                  checkTypeAssignableTo(typeWithThis, getTypeWithThisArgument(baseType, type.thisType), node.name, ts2.Diagnostics.Interface_0_incorrectly_extends_interface_1);
                }
                checkIndexConstraints(type);
              }
            }
            checkObjectTypeForDuplicateDeclarations(node);
          }
          ts2.forEach(ts2.getInterfaceBaseTypeNodes(node), function(heritageElement) {
            if (!ts2.isEntityNameExpression(heritageElement.expression)) {
              error(heritageElement.expression, ts2.Diagnostics.An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments);
            }
            checkTypeReferenceNode(heritageElement);
          });
          ts2.forEach(node.members, checkSourceElement);
          if (produceDiagnostics) {
            checkTypeForDuplicateIndexSignatures(node);
            registerForUnusedIdentifiersCheck(node);
          }
        }
        function checkTypeAliasDeclaration(node) {
          checkGrammarDecoratorsAndModifiers(node);
          checkTypeNameIsReserved(node.name, ts2.Diagnostics.Type_alias_name_cannot_be_0);
          checkExportsOnMergedDeclarations(node);
          checkTypeParameters(node.typeParameters);
          checkSourceElement(node.type);
          registerForUnusedIdentifiersCheck(node);
        }
        function computeEnumMemberValues(node) {
          var nodeLinks2 = getNodeLinks(node);
          if (!(nodeLinks2.flags & 16384)) {
            nodeLinks2.flags |= 16384;
            var autoValue = 0;
            for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
              var member = _a[_i];
              var value = computeMemberValue(member, autoValue);
              getNodeLinks(member).enumMemberValue = value;
              autoValue = typeof value === "number" ? value + 1 : void 0;
            }
          }
        }
        function computeMemberValue(member, autoValue) {
          if (ts2.isComputedNonLiteralName(member.name)) {
            error(member.name, ts2.Diagnostics.Computed_property_names_are_not_allowed_in_enums);
          } else {
            var text = ts2.getTextOfPropertyName(member.name);
            if (isNumericLiteralName(text) && !isInfinityOrNaNString(text)) {
              error(member.name, ts2.Diagnostics.An_enum_member_cannot_have_a_numeric_name);
            }
          }
          if (member.initializer) {
            return computeConstantValue(member);
          }
          if (member.parent.flags & 8388608 && !ts2.isEnumConst(member.parent) && getEnumKind(getSymbolOfNode(member.parent)) === 0) {
            return void 0;
          }
          if (autoValue !== void 0) {
            return autoValue;
          }
          error(member.name, ts2.Diagnostics.Enum_member_must_have_initializer);
          return void 0;
        }
        function computeConstantValue(member) {
          var enumKind = getEnumKind(getSymbolOfNode(member.parent));
          var isConstEnum = ts2.isEnumConst(member.parent);
          var initializer = member.initializer;
          var value = enumKind === 1 && !isLiteralEnumMember(member) ? void 0 : evaluate(initializer);
          if (value !== void 0) {
            if (isConstEnum && typeof value === "number" && !isFinite(value)) {
              error(initializer, isNaN(value) ? ts2.Diagnostics.const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN : ts2.Diagnostics.const_enum_member_initializer_was_evaluated_to_a_non_finite_value);
            }
          } else if (enumKind === 1) {
            error(initializer, ts2.Diagnostics.Computed_values_are_not_permitted_in_an_enum_with_string_valued_members);
            return 0;
          } else if (isConstEnum) {
            error(initializer, ts2.Diagnostics.const_enum_member_initializers_can_only_contain_literal_values_and_other_computed_enum_values);
          } else if (member.parent.flags & 8388608) {
            error(initializer, ts2.Diagnostics.In_ambient_enum_declarations_member_initializer_must_be_constant_expression);
          } else {
            var source = checkExpression(initializer);
            if (!isTypeAssignableToKind(source, 296)) {
              error(initializer, ts2.Diagnostics.Only_numeric_enums_can_have_computed_members_but_this_expression_has_type_0_If_you_do_not_need_exhaustiveness_checks_consider_using_an_object_literal_instead, typeToString(source));
            } else {
              checkTypeAssignableTo(source, getDeclaredTypeOfSymbol(getSymbolOfNode(member.parent)), initializer, void 0);
            }
          }
          return value;
          function evaluate(expr) {
            switch (expr.kind) {
              case 207:
                var value_2 = evaluate(expr.operand);
                if (typeof value_2 === "number") {
                  switch (expr.operator) {
                    case 39:
                      return value_2;
                    case 40:
                      return -value_2;
                    case 54:
                      return ~value_2;
                  }
                }
                break;
              case 209:
                var left = evaluate(expr.left);
                var right = evaluate(expr.right);
                if (typeof left === "number" && typeof right === "number") {
                  switch (expr.operatorToken.kind) {
                    case 51:
                      return left | right;
                    case 50:
                      return left & right;
                    case 48:
                      return left >> right;
                    case 49:
                      return left >>> right;
                    case 47:
                      return left << right;
                    case 52:
                      return left ^ right;
                    case 41:
                      return left * right;
                    case 43:
                      return left / right;
                    case 39:
                      return left + right;
                    case 40:
                      return left - right;
                    case 44:
                      return left % right;
                    case 42:
                      return Math.pow(left, right);
                  }
                } else if (typeof left === "string" && typeof right === "string" && expr.operatorToken.kind === 39) {
                  return left + right;
                }
                break;
              case 10:
              case 14:
                return expr.text;
              case 8:
                checkGrammarNumericLiteral(expr);
                return +expr.text;
              case 200:
                return evaluate(expr.expression);
              case 75:
                var identifier = expr;
                if (isInfinityOrNaNString(identifier.escapedText)) {
                  return +identifier.escapedText;
                }
                return ts2.nodeIsMissing(expr) ? 0 : evaluateEnumMember(expr, getSymbolOfNode(member.parent), identifier.escapedText);
              case 195:
              case 194:
                var ex = expr;
                if (isConstantMemberAccess(ex)) {
                  var type = getTypeOfExpression(ex.expression);
                  if (type.symbol && type.symbol.flags & 384) {
                    var name = void 0;
                    if (ex.kind === 194) {
                      name = ex.name.escapedText;
                    } else {
                      name = ts2.escapeLeadingUnderscores(ts2.cast(ex.argumentExpression, ts2.isLiteralExpression).text);
                    }
                    return evaluateEnumMember(expr, type.symbol, name);
                  }
                }
                break;
            }
            return void 0;
          }
          function evaluateEnumMember(expr, enumSymbol, name) {
            var memberSymbol = enumSymbol.exports.get(name);
            if (memberSymbol) {
              var declaration = memberSymbol.valueDeclaration;
              if (declaration !== member) {
                if (isBlockScopedNameDeclaredBeforeUse(declaration, member)) {
                  return getEnumMemberValue(declaration);
                }
                error(expr, ts2.Diagnostics.A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums);
                return 0;
              } else {
                error(expr, ts2.Diagnostics.Property_0_is_used_before_being_assigned, symbolToString(memberSymbol));
              }
            }
            return void 0;
          }
        }
        function isConstantMemberAccess(node) {
          return node.kind === 75 || node.kind === 194 && isConstantMemberAccess(node.expression) || node.kind === 195 && isConstantMemberAccess(node.expression) && ts2.isStringLiteralLike(node.argumentExpression);
        }
        function checkEnumDeclaration(node) {
          if (!produceDiagnostics) {
            return;
          }
          checkGrammarDecoratorsAndModifiers(node);
          checkTypeNameIsReserved(node.name, ts2.Diagnostics.Enum_name_cannot_be_0);
          checkCollisionWithRequireExportsInGeneratedCode(node, node.name);
          checkCollisionWithGlobalPromiseInGeneratedCode(node, node.name);
          checkExportsOnMergedDeclarations(node);
          node.members.forEach(checkEnumMember);
          computeEnumMemberValues(node);
          var enumSymbol = getSymbolOfNode(node);
          var firstDeclaration = ts2.getDeclarationOfKind(enumSymbol, node.kind);
          if (node === firstDeclaration) {
            if (enumSymbol.declarations.length > 1) {
              var enumIsConst_1 = ts2.isEnumConst(node);
              ts2.forEach(enumSymbol.declarations, function(decl) {
                if (ts2.isEnumDeclaration(decl) && ts2.isEnumConst(decl) !== enumIsConst_1) {
                  error(ts2.getNameOfDeclaration(decl), ts2.Diagnostics.Enum_declarations_must_all_be_const_or_non_const);
                }
              });
            }
            var seenEnumMissingInitialInitializer_1 = false;
            ts2.forEach(enumSymbol.declarations, function(declaration) {
              if (declaration.kind !== 248) {
                return false;
              }
              var enumDeclaration = declaration;
              if (!enumDeclaration.members.length) {
                return false;
              }
              var firstEnumMember = enumDeclaration.members[0];
              if (!firstEnumMember.initializer) {
                if (seenEnumMissingInitialInitializer_1) {
                  error(firstEnumMember.name, ts2.Diagnostics.In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element);
                } else {
                  seenEnumMissingInitialInitializer_1 = true;
                }
              }
            });
          }
        }
        function checkEnumMember(node) {
          if (ts2.isPrivateIdentifier(node.name)) {
            error(node, ts2.Diagnostics.An_enum_member_cannot_be_named_with_a_private_identifier);
          }
        }
        function getFirstNonAmbientClassOrFunctionDeclaration(symbol) {
          var declarations = symbol.declarations;
          for (var _i = 0, declarations_8 = declarations; _i < declarations_8.length; _i++) {
            var declaration = declarations_8[_i];
            if ((declaration.kind === 245 || declaration.kind === 244 && ts2.nodeIsPresent(declaration.body)) && !(declaration.flags & 8388608)) {
              return declaration;
            }
          }
          return void 0;
        }
        function inSameLexicalScope(node1, node2) {
          var container1 = ts2.getEnclosingBlockScopeContainer(node1);
          var container2 = ts2.getEnclosingBlockScopeContainer(node2);
          if (isGlobalSourceFile(container1)) {
            return isGlobalSourceFile(container2);
          } else if (isGlobalSourceFile(container2)) {
            return false;
          } else {
            return container1 === container2;
          }
        }
        function checkModuleDeclaration(node) {
          if (produceDiagnostics) {
            var isGlobalAugmentation = ts2.isGlobalScopeAugmentation(node);
            var inAmbientContext = node.flags & 8388608;
            if (isGlobalAugmentation && !inAmbientContext) {
              error(node.name, ts2.Diagnostics.Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context);
            }
            var isAmbientExternalModule = ts2.isAmbientModule(node);
            var contextErrorMessage = isAmbientExternalModule ? ts2.Diagnostics.An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file : ts2.Diagnostics.A_namespace_declaration_is_only_allowed_in_a_namespace_or_module;
            if (checkGrammarModuleElementContext(node, contextErrorMessage)) {
              return;
            }
            if (!checkGrammarDecoratorsAndModifiers(node)) {
              if (!inAmbientContext && node.name.kind === 10) {
                grammarErrorOnNode(node.name, ts2.Diagnostics.Only_ambient_modules_can_use_quoted_names);
              }
            }
            if (ts2.isIdentifier(node.name)) {
              checkCollisionWithRequireExportsInGeneratedCode(node, node.name);
              checkCollisionWithGlobalPromiseInGeneratedCode(node, node.name);
            }
            checkExportsOnMergedDeclarations(node);
            var symbol = getSymbolOfNode(node);
            if (symbol.flags & 512 && !inAmbientContext && symbol.declarations.length > 1 && isInstantiatedModule(node, !!compilerOptions.preserveConstEnums || !!compilerOptions.isolatedModules)) {
              var firstNonAmbientClassOrFunc = getFirstNonAmbientClassOrFunctionDeclaration(symbol);
              if (firstNonAmbientClassOrFunc) {
                if (ts2.getSourceFileOfNode(node) !== ts2.getSourceFileOfNode(firstNonAmbientClassOrFunc)) {
                  error(node.name, ts2.Diagnostics.A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged);
                } else if (node.pos < firstNonAmbientClassOrFunc.pos) {
                  error(node.name, ts2.Diagnostics.A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged);
                }
              }
              var mergedClass = ts2.getDeclarationOfKind(symbol, 245);
              if (mergedClass && inSameLexicalScope(node, mergedClass)) {
                getNodeLinks(node).flags |= 32768;
              }
            }
            if (isAmbientExternalModule) {
              if (ts2.isExternalModuleAugmentation(node)) {
                var checkBody = isGlobalAugmentation || getSymbolOfNode(node).flags & 33554432;
                if (checkBody && node.body) {
                  for (var _i = 0, _a = node.body.statements; _i < _a.length; _i++) {
                    var statement = _a[_i];
                    checkModuleAugmentationElement(statement, isGlobalAugmentation);
                  }
                }
              } else if (isGlobalSourceFile(node.parent)) {
                if (isGlobalAugmentation) {
                  error(node.name, ts2.Diagnostics.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations);
                } else if (ts2.isExternalModuleNameRelative(ts2.getTextOfIdentifierOrLiteral(node.name))) {
                  error(node.name, ts2.Diagnostics.Ambient_module_declaration_cannot_specify_relative_module_name);
                }
              } else {
                if (isGlobalAugmentation) {
                  error(node.name, ts2.Diagnostics.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations);
                } else {
                  error(node.name, ts2.Diagnostics.Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces);
                }
              }
            }
          }
          if (node.body) {
            checkSourceElement(node.body);
            if (!ts2.isGlobalScopeAugmentation(node)) {
              registerForUnusedIdentifiersCheck(node);
            }
          }
        }
        function checkModuleAugmentationElement(node, isGlobalAugmentation) {
          switch (node.kind) {
            case 225:
              for (var _i = 0, _a = node.declarationList.declarations; _i < _a.length; _i++) {
                var decl = _a[_i];
                checkModuleAugmentationElement(decl, isGlobalAugmentation);
              }
              break;
            case 259:
            case 260:
              grammarErrorOnFirstToken(node, ts2.Diagnostics.Exports_and_export_assignments_are_not_permitted_in_module_augmentations);
              break;
            case 253:
            case 254:
              grammarErrorOnFirstToken(node, ts2.Diagnostics.Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module);
              break;
            case 191:
            case 242:
              var name = node.name;
              if (ts2.isBindingPattern(name)) {
                for (var _b = 0, _c = name.elements; _b < _c.length; _b++) {
                  var el = _c[_b];
                  checkModuleAugmentationElement(el, isGlobalAugmentation);
                }
                break;
              }
            case 245:
            case 248:
            case 244:
            case 246:
            case 249:
            case 247:
              if (isGlobalAugmentation) {
                return;
              }
              var symbol = getSymbolOfNode(node);
              if (symbol) {
                var reportError = !(symbol.flags & 33554432);
                if (!reportError) {
                  reportError = !!symbol.parent && ts2.isExternalModuleAugmentation(symbol.parent.declarations[0]);
                }
              }
              break;
          }
        }
        function getFirstNonModuleExportsIdentifier(node) {
          switch (node.kind) {
            case 75:
              return node;
            case 153:
              do {
                node = node.left;
              } while (node.kind !== 75);
              return node;
            case 194:
              do {
                if (ts2.isModuleExportsAccessExpression(node.expression) && !ts2.isPrivateIdentifier(node.name)) {
                  return node.name;
                }
                node = node.expression;
              } while (node.kind !== 75);
              return node;
          }
        }
        function checkExternalImportOrExportDeclaration(node) {
          var moduleName = ts2.getExternalModuleName(node);
          if (!moduleName || ts2.nodeIsMissing(moduleName)) {
            return false;
          }
          if (!ts2.isStringLiteral(moduleName)) {
            error(moduleName, ts2.Diagnostics.String_literal_expected);
            return false;
          }
          var inAmbientExternalModule = node.parent.kind === 250 && ts2.isAmbientModule(node.parent.parent);
          if (node.parent.kind !== 290 && !inAmbientExternalModule) {
            error(moduleName, node.kind === 260 ? ts2.Diagnostics.Export_declarations_are_not_permitted_in_a_namespace : ts2.Diagnostics.Import_declarations_in_a_namespace_cannot_reference_a_module);
            return false;
          }
          if (inAmbientExternalModule && ts2.isExternalModuleNameRelative(moduleName.text)) {
            if (!isTopLevelInExternalModuleAugmentation(node)) {
              error(node, ts2.Diagnostics.Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name);
              return false;
            }
          }
          return true;
        }
        function checkAliasSymbol(node) {
          var symbol = getSymbolOfNode(node);
          var target = resolveAlias(symbol);
          var shouldSkipWithJSExpandoTargets = symbol.flags & 67108864;
          if (!shouldSkipWithJSExpandoTargets && target !== unknownSymbol) {
            symbol = getMergedSymbol(symbol.exportSymbol || symbol);
            var excludedMeanings = (symbol.flags & (111551 | 1048576) ? 111551 : 0) | (symbol.flags & 788968 ? 788968 : 0) | (symbol.flags & 1920 ? 1920 : 0);
            if (target.flags & excludedMeanings) {
              var message = node.kind === 263 ? ts2.Diagnostics.Export_declaration_conflicts_with_exported_declaration_of_0 : ts2.Diagnostics.Import_declaration_conflicts_with_local_declaration_of_0;
              error(node, message, symbolToString(symbol));
            }
            if (compilerOptions.isolatedModules && node.kind === 263 && !node.parent.parent.isTypeOnly && !(target.flags & 111551) && !(node.flags & 8388608)) {
              error(node, ts2.Diagnostics.Re_exporting_a_type_when_the_isolatedModules_flag_is_provided_requires_using_export_type);
            }
          }
        }
        function checkImportBinding(node) {
          checkCollisionWithRequireExportsInGeneratedCode(node, node.name);
          checkCollisionWithGlobalPromiseInGeneratedCode(node, node.name);
          checkAliasSymbol(node);
        }
        function checkImportDeclaration(node) {
          if (checkGrammarModuleElementContext(node, ts2.Diagnostics.An_import_declaration_can_only_be_used_in_a_namespace_or_module)) {
            return;
          }
          if (!checkGrammarDecoratorsAndModifiers(node) && ts2.hasModifiers(node)) {
            grammarErrorOnFirstToken(node, ts2.Diagnostics.An_import_declaration_cannot_have_modifiers);
          }
          if (checkExternalImportOrExportDeclaration(node)) {
            var importClause = node.importClause;
            if (importClause && !checkGrammarImportClause(importClause)) {
              if (importClause.name) {
                checkImportBinding(importClause);
              }
              if (importClause.namedBindings) {
                if (importClause.namedBindings.kind === 256) {
                  checkImportBinding(importClause.namedBindings);
                } else {
                  var moduleExisted = resolveExternalModuleName(node, node.moduleSpecifier);
                  if (moduleExisted) {
                    ts2.forEach(importClause.namedBindings.elements, checkImportBinding);
                  }
                }
              }
            }
          }
        }
        function checkImportEqualsDeclaration(node) {
          if (checkGrammarModuleElementContext(node, ts2.Diagnostics.An_import_declaration_can_only_be_used_in_a_namespace_or_module)) {
            return;
          }
          checkGrammarDecoratorsAndModifiers(node);
          if (ts2.isInternalModuleImportEqualsDeclaration(node) || checkExternalImportOrExportDeclaration(node)) {
            checkImportBinding(node);
            if (ts2.hasModifier(node, 1)) {
              markExportAsReferenced(node);
            }
            if (node.moduleReference.kind !== 265) {
              var target = resolveAlias(getSymbolOfNode(node));
              if (target !== unknownSymbol) {
                if (target.flags & 111551) {
                  var moduleName = ts2.getFirstIdentifier(node.moduleReference);
                  if (!(resolveEntityName(moduleName, 111551 | 1920).flags & 1920)) {
                    error(moduleName, ts2.Diagnostics.Module_0_is_hidden_by_a_local_declaration_with_the_same_name, ts2.declarationNameToString(moduleName));
                  }
                }
                if (target.flags & 788968) {
                  checkTypeNameIsReserved(node.name, ts2.Diagnostics.Import_name_cannot_be_0);
                }
              }
            } else {
              if (moduleKind >= ts2.ModuleKind.ES2015 && !(node.flags & 8388608)) {
                grammarErrorOnNode(node, ts2.Diagnostics.Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead);
              }
            }
          }
        }
        function checkExportDeclaration(node) {
          if (checkGrammarModuleElementContext(node, ts2.Diagnostics.An_export_declaration_can_only_be_used_in_a_module)) {
            return;
          }
          if (!checkGrammarDecoratorsAndModifiers(node) && ts2.hasModifiers(node)) {
            grammarErrorOnFirstToken(node, ts2.Diagnostics.An_export_declaration_cannot_have_modifiers);
          }
          if (node.moduleSpecifier && node.exportClause && ts2.isNamedExports(node.exportClause) && ts2.length(node.exportClause.elements) && languageVersion === 0) {
            checkExternalEmitHelpers(node, 1048576);
          }
          checkGrammarExportDeclaration(node);
          if (!node.moduleSpecifier || checkExternalImportOrExportDeclaration(node)) {
            if (node.exportClause && !ts2.isNamespaceExport(node.exportClause)) {
              ts2.forEach(node.exportClause.elements, checkExportSpecifier);
              var inAmbientExternalModule = node.parent.kind === 250 && ts2.isAmbientModule(node.parent.parent);
              var inAmbientNamespaceDeclaration = !inAmbientExternalModule && node.parent.kind === 250 && !node.moduleSpecifier && node.flags & 8388608;
              if (node.parent.kind !== 290 && !inAmbientExternalModule && !inAmbientNamespaceDeclaration) {
                error(node, ts2.Diagnostics.Export_declarations_are_not_permitted_in_a_namespace);
              }
            } else {
              var moduleSymbol = resolveExternalModuleName(node, node.moduleSpecifier);
              if (moduleSymbol && hasExportAssignmentSymbol(moduleSymbol)) {
                error(node.moduleSpecifier, ts2.Diagnostics.Module_0_uses_export_and_cannot_be_used_with_export_Asterisk, symbolToString(moduleSymbol));
              } else if (node.exportClause) {
                checkAliasSymbol(node.exportClause);
              }
              if (moduleKind !== ts2.ModuleKind.System && moduleKind < ts2.ModuleKind.ES2015) {
                checkExternalEmitHelpers(node, 65536);
              }
            }
          }
        }
        function checkGrammarExportDeclaration(node) {
          var _a;
          var isTypeOnlyExportStar = node.isTypeOnly && ((_a = node.exportClause) === null || _a === void 0 ? void 0 : _a.kind) !== 261;
          if (isTypeOnlyExportStar) {
            grammarErrorOnNode(node, ts2.Diagnostics.Only_named_exports_may_use_export_type);
          }
          return !isTypeOnlyExportStar;
        }
        function checkGrammarModuleElementContext(node, errorMessage) {
          var isInAppropriateContext = node.parent.kind === 290 || node.parent.kind === 250 || node.parent.kind === 249;
          if (!isInAppropriateContext) {
            grammarErrorOnFirstToken(node, errorMessage);
          }
          return !isInAppropriateContext;
        }
        function importClauseContainsReferencedImport(importClause) {
          return ts2.forEachImportClauseDeclaration(importClause, function(declaration) {
            return !!getSymbolOfNode(declaration).isReferenced;
          });
        }
        function importClauseContainsConstEnumUsedAsValue(importClause) {
          return ts2.forEachImportClauseDeclaration(importClause, function(declaration) {
            return !!getSymbolLinks(getSymbolOfNode(declaration)).constEnumReferenced;
          });
        }
        function checkImportsForTypeOnlyConversion(sourceFile) {
          for (var _i = 0, _a = sourceFile.statements; _i < _a.length; _i++) {
            var statement = _a[_i];
            if (ts2.isImportDeclaration(statement) && statement.importClause && !statement.importClause.isTypeOnly && importClauseContainsReferencedImport(statement.importClause) && !isReferencedAliasDeclaration(statement.importClause, true) && !importClauseContainsConstEnumUsedAsValue(statement.importClause)) {
              error(statement, ts2.Diagnostics.This_import_is_never_used_as_a_value_and_must_use_import_type_because_the_importsNotUsedAsValues_is_set_to_error);
            }
          }
        }
        function checkExportSpecifier(node) {
          checkAliasSymbol(node);
          if (ts2.getEmitDeclarations(compilerOptions)) {
            collectLinkedAliases(node.propertyName || node.name, true);
          }
          if (!node.parent.parent.moduleSpecifier) {
            var exportedName = node.propertyName || node.name;
            var symbol = resolveName(exportedName, exportedName.escapedText, 111551 | 788968 | 1920 | 2097152, void 0, void 0, true);
            if (symbol && (symbol === undefinedSymbol || symbol === globalThisSymbol || isGlobalSourceFile(getDeclarationContainer(symbol.declarations[0])))) {
              error(exportedName, ts2.Diagnostics.Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module, ts2.idText(exportedName));
            } else {
              markExportAsReferenced(node);
              var target = symbol && (symbol.flags & 2097152 ? resolveAlias(symbol) : symbol);
              if (!target || target === unknownSymbol || target.flags & 111551) {
                checkExpressionCached(node.propertyName || node.name);
              }
            }
          }
        }
        function checkExportAssignment(node) {
          if (checkGrammarModuleElementContext(node, ts2.Diagnostics.An_export_assignment_can_only_be_used_in_a_module)) {
            return;
          }
          var container = node.parent.kind === 290 ? node.parent : node.parent.parent;
          if (container.kind === 249 && !ts2.isAmbientModule(container)) {
            if (node.isExportEquals) {
              error(node, ts2.Diagnostics.An_export_assignment_cannot_be_used_in_a_namespace);
            } else {
              error(node, ts2.Diagnostics.A_default_export_can_only_be_used_in_an_ECMAScript_style_module);
            }
            return;
          }
          if (!checkGrammarDecoratorsAndModifiers(node) && ts2.hasModifiers(node)) {
            grammarErrorOnFirstToken(node, ts2.Diagnostics.An_export_assignment_cannot_have_modifiers);
          }
          if (node.expression.kind === 75) {
            var id = node.expression;
            var sym = resolveEntityName(id, 67108863, true, true, node);
            if (sym) {
              markAliasReferenced(sym, id);
              var target = sym.flags & 2097152 ? resolveAlias(sym) : sym;
              if (target === unknownSymbol || target.flags & 111551) {
                checkExpressionCached(node.expression);
              }
            }
            if (ts2.getEmitDeclarations(compilerOptions)) {
              collectLinkedAliases(node.expression, true);
            }
          } else {
            checkExpressionCached(node.expression);
          }
          checkExternalModuleExports(container);
          if (node.flags & 8388608 && !ts2.isEntityNameExpression(node.expression)) {
            grammarErrorOnNode(node.expression, ts2.Diagnostics.The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context);
          }
          if (node.isExportEquals && !(node.flags & 8388608)) {
            if (moduleKind >= ts2.ModuleKind.ES2015) {
              grammarErrorOnNode(node, ts2.Diagnostics.Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or_another_module_format_instead);
            } else if (moduleKind === ts2.ModuleKind.System) {
              grammarErrorOnNode(node, ts2.Diagnostics.Export_assignment_is_not_supported_when_module_flag_is_system);
            }
          }
        }
        function hasExportedMembers(moduleSymbol) {
          return ts2.forEachEntry(moduleSymbol.exports, function(_, id) {
            return id !== "export=";
          });
        }
        function checkExternalModuleExports(node) {
          var moduleSymbol = getSymbolOfNode(node);
          var links = getSymbolLinks(moduleSymbol);
          if (!links.exportsChecked) {
            var exportEqualsSymbol = moduleSymbol.exports.get("export=");
            if (exportEqualsSymbol && hasExportedMembers(moduleSymbol)) {
              var declaration = getDeclarationOfAliasSymbol(exportEqualsSymbol) || exportEqualsSymbol.valueDeclaration;
              if (!isTopLevelInExternalModuleAugmentation(declaration) && !ts2.isInJSFile(declaration)) {
                error(declaration, ts2.Diagnostics.An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements);
              }
            }
            var exports_2 = getExportsOfModule(moduleSymbol);
            if (exports_2) {
              exports_2.forEach(function(_a, id) {
                var declarations = _a.declarations, flags = _a.flags;
                if (id === "__export") {
                  return;
                }
                if (flags & (1920 | 64 | 384)) {
                  return;
                }
                var exportedDeclarationsCount = ts2.countWhere(declarations, isNotOverloadAndNotAccessor);
                if (flags & 524288 && exportedDeclarationsCount <= 2) {
                  return;
                }
                if (exportedDeclarationsCount > 1) {
                  for (var _i = 0, declarations_9 = declarations; _i < declarations_9.length; _i++) {
                    var declaration2 = declarations_9[_i];
                    if (isNotOverload(declaration2)) {
                      diagnostics.add(ts2.createDiagnosticForNode(declaration2, ts2.Diagnostics.Cannot_redeclare_exported_variable_0, ts2.unescapeLeadingUnderscores(id)));
                    }
                  }
                }
              });
            }
            links.exportsChecked = true;
          }
        }
        function checkSourceElement(node) {
          if (node) {
            var saveCurrentNode = currentNode;
            currentNode = node;
            instantiationCount = 0;
            checkSourceElementWorker(node);
            currentNode = saveCurrentNode;
          }
        }
        function checkSourceElementWorker(node) {
          if (ts2.isInJSFile(node)) {
            ts2.forEach(node.jsDoc, function(_a) {
              var tags = _a.tags;
              return ts2.forEach(tags, checkSourceElement);
            });
          }
          var kind = node.kind;
          if (cancellationToken) {
            switch (kind) {
              case 249:
              case 245:
              case 246:
              case 244:
                cancellationToken.throwIfCancellationRequested();
            }
          }
          if (kind >= 225 && kind <= 241 && node.flowNode && !isReachableFlowNode(node.flowNode)) {
            errorOrSuggestion(compilerOptions.allowUnreachableCode === false, node, ts2.Diagnostics.Unreachable_code_detected);
          }
          switch (kind) {
            case 155:
              return checkTypeParameter(node);
            case 156:
              return checkParameter(node);
            case 159:
              return checkPropertyDeclaration(node);
            case 158:
              return checkPropertySignature(node);
            case 170:
            case 171:
            case 165:
            case 166:
            case 167:
              return checkSignatureDeclaration(node);
            case 161:
            case 160:
              return checkMethodDeclaration(node);
            case 162:
              return checkConstructorDeclaration(node);
            case 163:
            case 164:
              return checkAccessorDeclaration(node);
            case 169:
              return checkTypeReferenceNode(node);
            case 168:
              return checkTypePredicate(node);
            case 172:
              return checkTypeQuery(node);
            case 173:
              return checkTypeLiteral(node);
            case 174:
              return checkArrayType(node);
            case 175:
              return checkTupleType(node);
            case 178:
            case 179:
              return checkUnionOrIntersectionType(node);
            case 182:
            case 176:
            case 177:
              return checkSourceElement(node.type);
            case 183:
              return checkThisType(node);
            case 184:
              return checkTypeOperator(node);
            case 180:
              return checkConditionalType(node);
            case 181:
              return checkInferType(node);
            case 188:
              return checkImportType(node);
            case 307:
              return checkJSDocAugmentsTag(node);
            case 308:
              return checkJSDocImplementsTag(node);
            case 322:
            case 315:
            case 316:
              return checkJSDocTypeAliasTag(node);
            case 321:
              return checkJSDocTemplateTag(node);
            case 320:
              return checkJSDocTypeTag(node);
            case 317:
              return checkJSDocParameterTag(node);
            case 323:
              return checkJSDocPropertyTag(node);
            case 300:
              checkJSDocFunctionType(node);
            case 298:
            case 297:
            case 295:
            case 296:
            case 304:
              checkJSDocTypeIsInJsFile(node);
              ts2.forEachChild(node, checkSourceElement);
              return;
            case 301:
              checkJSDocVariadicType(node);
              return;
            case 294:
              return checkSourceElement(node.type);
            case 185:
              return checkIndexedAccessType(node);
            case 186:
              return checkMappedType(node);
            case 244:
              return checkFunctionDeclaration(node);
            case 223:
            case 250:
              return checkBlock(node);
            case 225:
              return checkVariableStatement(node);
            case 226:
              return checkExpressionStatement(node);
            case 227:
              return checkIfStatement(node);
            case 228:
              return checkDoStatement(node);
            case 229:
              return checkWhileStatement(node);
            case 230:
              return checkForStatement(node);
            case 231:
              return checkForInStatement(node);
            case 232:
              return checkForOfStatement(node);
            case 233:
            case 234:
              return checkBreakOrContinueStatement(node);
            case 235:
              return checkReturnStatement(node);
            case 236:
              return checkWithStatement(node);
            case 237:
              return checkSwitchStatement(node);
            case 238:
              return checkLabeledStatement(node);
            case 239:
              return checkThrowStatement(node);
            case 240:
              return checkTryStatement(node);
            case 242:
              return checkVariableDeclaration(node);
            case 191:
              return checkBindingElement(node);
            case 245:
              return checkClassDeclaration(node);
            case 246:
              return checkInterfaceDeclaration(node);
            case 247:
              return checkTypeAliasDeclaration(node);
            case 248:
              return checkEnumDeclaration(node);
            case 249:
              return checkModuleDeclaration(node);
            case 254:
              return checkImportDeclaration(node);
            case 253:
              return checkImportEqualsDeclaration(node);
            case 260:
              return checkExportDeclaration(node);
            case 259:
              return checkExportAssignment(node);
            case 224:
            case 241:
              checkGrammarStatementInAmbientContext(node);
              return;
            case 264:
              return checkMissingDeclaration(node);
          }
        }
        function checkJSDocTypeIsInJsFile(node) {
          if (!ts2.isInJSFile(node)) {
            grammarErrorOnNode(node, ts2.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments);
          }
        }
        function checkJSDocVariadicType(node) {
          checkJSDocTypeIsInJsFile(node);
          checkSourceElement(node.type);
          var parent = node.parent;
          if (ts2.isParameter(parent) && ts2.isJSDocFunctionType(parent.parent)) {
            if (ts2.last(parent.parent.parameters) !== parent) {
              error(node, ts2.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);
            }
            return;
          }
          if (!ts2.isJSDocTypeExpression(parent)) {
            error(node, ts2.Diagnostics.JSDoc_may_only_appear_in_the_last_parameter_of_a_signature);
          }
          var paramTag = node.parent.parent;
          if (!ts2.isJSDocParameterTag(paramTag)) {
            error(node, ts2.Diagnostics.JSDoc_may_only_appear_in_the_last_parameter_of_a_signature);
            return;
          }
          var param = ts2.getParameterSymbolFromJSDoc(paramTag);
          if (!param) {
            return;
          }
          var host2 = ts2.getHostSignatureFromJSDoc(paramTag);
          if (!host2 || ts2.last(host2.parameters).symbol !== param) {
            error(node, ts2.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);
          }
        }
        function getTypeFromJSDocVariadicType(node) {
          var type = getTypeFromTypeNode(node.type);
          var parent = node.parent;
          var paramTag = node.parent.parent;
          if (ts2.isJSDocTypeExpression(node.parent) && ts2.isJSDocParameterTag(paramTag)) {
            var host_1 = ts2.getHostSignatureFromJSDoc(paramTag);
            if (host_1) {
              var lastParamDeclaration = ts2.lastOrUndefined(host_1.parameters);
              var symbol = ts2.getParameterSymbolFromJSDoc(paramTag);
              if (!lastParamDeclaration || symbol && lastParamDeclaration.symbol === symbol && ts2.isRestParameter(lastParamDeclaration)) {
                return createArrayType(type);
              }
            }
          }
          if (ts2.isParameter(parent) && ts2.isJSDocFunctionType(parent.parent)) {
            return createArrayType(type);
          }
          return addOptionality(type);
        }
        function checkNodeDeferred(node) {
          var enclosingFile = ts2.getSourceFileOfNode(node);
          var links = getNodeLinks(enclosingFile);
          if (!(links.flags & 1)) {
            links.deferredNodes = links.deferredNodes || ts2.createMap();
            var id = "" + getNodeId(node);
            links.deferredNodes.set(id, node);
          }
        }
        function checkDeferredNodes(context) {
          var links = getNodeLinks(context);
          if (links.deferredNodes) {
            links.deferredNodes.forEach(checkDeferredNode);
          }
        }
        function checkDeferredNode(node) {
          var saveCurrentNode = currentNode;
          currentNode = node;
          instantiationCount = 0;
          switch (node.kind) {
            case 196:
            case 197:
            case 198:
            case 157:
            case 268:
              resolveUntypedCall(node);
              break;
            case 201:
            case 202:
            case 161:
            case 160:
              checkFunctionExpressionOrObjectLiteralMethodDeferred(node);
              break;
            case 163:
            case 164:
              checkAccessorDeclaration(node);
              break;
            case 214:
              checkClassExpressionDeferred(node);
              break;
            case 267:
              checkJsxSelfClosingElementDeferred(node);
              break;
            case 266:
              checkJsxElementDeferred(node);
              break;
          }
          currentNode = saveCurrentNode;
        }
        function checkSourceFile(node) {
          ts2.performance.mark("beforeCheck");
          checkSourceFileWorker(node);
          ts2.performance.mark("afterCheck");
          ts2.performance.measure("Check", "beforeCheck", "afterCheck");
        }
        function unusedIsError(kind, isAmbient) {
          if (isAmbient) {
            return false;
          }
          switch (kind) {
            case 0:
              return !!compilerOptions.noUnusedLocals;
            case 1:
              return !!compilerOptions.noUnusedParameters;
            default:
              return ts2.Debug.assertNever(kind);
          }
        }
        function getPotentiallyUnusedIdentifiers(sourceFile) {
          return allPotentiallyUnusedIdentifiers.get(sourceFile.path) || ts2.emptyArray;
        }
        function checkSourceFileWorker(node) {
          var links = getNodeLinks(node);
          if (!(links.flags & 1)) {
            if (ts2.skipTypeChecking(node, compilerOptions, host)) {
              return;
            }
            checkGrammarSourceFile(node);
            ts2.clear(potentialThisCollisions);
            ts2.clear(potentialNewTargetCollisions);
            ts2.clear(potentialWeakMapCollisions);
            ts2.forEach(node.statements, checkSourceElement);
            checkSourceElement(node.endOfFileToken);
            checkDeferredNodes(node);
            if (ts2.isExternalOrCommonJsModule(node)) {
              registerForUnusedIdentifiersCheck(node);
            }
            if (!node.isDeclarationFile && (compilerOptions.noUnusedLocals || compilerOptions.noUnusedParameters)) {
              checkUnusedIdentifiers(getPotentiallyUnusedIdentifiers(node), function(containingNode, kind, diag) {
                if (!ts2.containsParseError(containingNode) && unusedIsError(kind, !!(containingNode.flags & 8388608))) {
                  diagnostics.add(diag);
                }
              });
            }
            if (compilerOptions.importsNotUsedAsValues === 2 && !node.isDeclarationFile && ts2.isExternalModule(node)) {
              checkImportsForTypeOnlyConversion(node);
            }
            if (ts2.isExternalOrCommonJsModule(node)) {
              checkExternalModuleExports(node);
            }
            if (potentialThisCollisions.length) {
              ts2.forEach(potentialThisCollisions, checkIfThisIsCapturedInEnclosingScope);
              ts2.clear(potentialThisCollisions);
            }
            if (potentialNewTargetCollisions.length) {
              ts2.forEach(potentialNewTargetCollisions, checkIfNewTargetIsCapturedInEnclosingScope);
              ts2.clear(potentialNewTargetCollisions);
            }
            if (potentialWeakMapCollisions.length) {
              ts2.forEach(potentialWeakMapCollisions, checkWeakMapCollision);
              ts2.clear(potentialWeakMapCollisions);
            }
            links.flags |= 1;
          }
        }
        function getDiagnostics(sourceFile, ct) {
          try {
            cancellationToken = ct;
            return getDiagnosticsWorker(sourceFile);
          } finally {
            cancellationToken = void 0;
          }
        }
        function getDiagnosticsWorker(sourceFile) {
          throwIfNonDiagnosticsProducing();
          if (sourceFile) {
            var previousGlobalDiagnostics = diagnostics.getGlobalDiagnostics();
            var previousGlobalDiagnosticsSize = previousGlobalDiagnostics.length;
            checkSourceFile(sourceFile);
            var semanticDiagnostics = diagnostics.getDiagnostics(sourceFile.fileName);
            var currentGlobalDiagnostics = diagnostics.getGlobalDiagnostics();
            if (currentGlobalDiagnostics !== previousGlobalDiagnostics) {
              var deferredGlobalDiagnostics = ts2.relativeComplement(previousGlobalDiagnostics, currentGlobalDiagnostics, ts2.compareDiagnostics);
              return ts2.concatenate(deferredGlobalDiagnostics, semanticDiagnostics);
            } else if (previousGlobalDiagnosticsSize === 0 && currentGlobalDiagnostics.length > 0) {
              return ts2.concatenate(currentGlobalDiagnostics, semanticDiagnostics);
            }
            return semanticDiagnostics;
          }
          ts2.forEach(host.getSourceFiles(), checkSourceFile);
          return diagnostics.getDiagnostics();
        }
        function getGlobalDiagnostics() {
          throwIfNonDiagnosticsProducing();
          return diagnostics.getGlobalDiagnostics();
        }
        function throwIfNonDiagnosticsProducing() {
          if (!produceDiagnostics) {
            throw new Error("Trying to get diagnostics from a type checker that does not produce them.");
          }
        }
        function getSymbolsInScope(location, meaning) {
          if (location.flags & 16777216) {
            return [];
          }
          var symbols = ts2.createSymbolTable();
          var isStatic = false;
          populateSymbols();
          symbols.delete("this");
          return symbolsToArray(symbols);
          function populateSymbols() {
            while (location) {
              if (location.locals && !isGlobalSourceFile(location)) {
                copySymbols(location.locals, meaning);
              }
              switch (location.kind) {
                case 290:
                  if (!ts2.isExternalOrCommonJsModule(location))
                    break;
                case 249:
                  copySymbols(getSymbolOfNode(location).exports, meaning & 2623475);
                  break;
                case 248:
                  copySymbols(getSymbolOfNode(location).exports, meaning & 8);
                  break;
                case 214:
                  var className = location.name;
                  if (className) {
                    copySymbol(location.symbol, meaning);
                  }
                case 245:
                case 246:
                  if (!isStatic) {
                    copySymbols(getMembersOfSymbol(getSymbolOfNode(location)), meaning & 788968);
                  }
                  break;
                case 201:
                  var funcName = location.name;
                  if (funcName) {
                    copySymbol(location.symbol, meaning);
                  }
                  break;
              }
              if (ts2.introducesArgumentsExoticObject(location)) {
                copySymbol(argumentsSymbol, meaning);
              }
              isStatic = ts2.hasModifier(location, 32);
              location = location.parent;
            }
            copySymbols(globals, meaning);
          }
          function copySymbol(symbol, meaning2) {
            if (ts2.getCombinedLocalAndExportSymbolFlags(symbol) & meaning2) {
              var id = symbol.escapedName;
              if (!symbols.has(id)) {
                symbols.set(id, symbol);
              }
            }
          }
          function copySymbols(source, meaning2) {
            if (meaning2) {
              source.forEach(function(symbol) {
                copySymbol(symbol, meaning2);
              });
            }
          }
        }
        function isTypeDeclarationName(name) {
          return name.kind === 75 && isTypeDeclaration(name.parent) && name.parent.name === name;
        }
        function isTypeDeclaration(node) {
          switch (node.kind) {
            case 155:
            case 245:
            case 246:
            case 247:
            case 248:
              return true;
            case 255:
              return node.isTypeOnly;
            case 258:
            case 263:
              return node.parent.parent.isTypeOnly;
            default:
              return false;
          }
        }
        function isTypeReferenceIdentifier(node) {
          while (node.parent.kind === 153) {
            node = node.parent;
          }
          return node.parent.kind === 169;
        }
        function isHeritageClauseElementIdentifier(node) {
          while (node.parent.kind === 194) {
            node = node.parent;
          }
          return node.parent.kind === 216;
        }
        function forEachEnclosingClass(node, callback) {
          var result;
          while (true) {
            node = ts2.getContainingClass(node);
            if (!node)
              break;
            if (result = callback(node))
              break;
          }
          return result;
        }
        function isNodeUsedDuringClassInitialization(node) {
          return !!ts2.findAncestor(node, function(element) {
            if (ts2.isConstructorDeclaration(element) && ts2.nodeIsPresent(element.body) || ts2.isPropertyDeclaration(element)) {
              return true;
            } else if (ts2.isClassLike(element) || ts2.isFunctionLikeDeclaration(element)) {
              return "quit";
            }
            return false;
          });
        }
        function isNodeWithinClass(node, classDeclaration) {
          return !!forEachEnclosingClass(node, function(n) {
            return n === classDeclaration;
          });
        }
        function getLeftSideOfImportEqualsOrExportAssignment(nodeOnRightSide) {
          while (nodeOnRightSide.parent.kind === 153) {
            nodeOnRightSide = nodeOnRightSide.parent;
          }
          if (nodeOnRightSide.parent.kind === 253) {
            return nodeOnRightSide.parent.moduleReference === nodeOnRightSide ? nodeOnRightSide.parent : void 0;
          }
          if (nodeOnRightSide.parent.kind === 259) {
            return nodeOnRightSide.parent.expression === nodeOnRightSide ? nodeOnRightSide.parent : void 0;
          }
          return void 0;
        }
        function isInRightSideOfImportOrExportAssignment(node) {
          return getLeftSideOfImportEqualsOrExportAssignment(node) !== void 0;
        }
        function getSpecialPropertyAssignmentSymbolFromEntityName(entityName) {
          var specialPropertyAssignmentKind = ts2.getAssignmentDeclarationKind(entityName.parent.parent);
          switch (specialPropertyAssignmentKind) {
            case 1:
            case 3:
              return getSymbolOfNode(entityName.parent);
            case 4:
            case 2:
            case 5:
              return getSymbolOfNode(entityName.parent.parent);
          }
        }
        function isImportTypeQualifierPart(node) {
          var parent = node.parent;
          while (ts2.isQualifiedName(parent)) {
            node = parent;
            parent = parent.parent;
          }
          if (parent && parent.kind === 188 && parent.qualifier === node) {
            return parent;
          }
          return void 0;
        }
        function getSymbolOfNameOrPropertyAccessExpression(name) {
          if (ts2.isDeclarationName(name)) {
            return getSymbolOfNode(name.parent);
          }
          if (ts2.isInJSFile(name) && name.parent.kind === 194 && name.parent === name.parent.parent.left) {
            if (!ts2.isPrivateIdentifier(name)) {
              var specialPropertyAssignmentSymbol = getSpecialPropertyAssignmentSymbolFromEntityName(name);
              if (specialPropertyAssignmentSymbol) {
                return specialPropertyAssignmentSymbol;
              }
            }
          }
          if (name.parent.kind === 259 && ts2.isEntityNameExpression(name)) {
            var success = resolveEntityName(name, 111551 | 788968 | 1920 | 2097152, true);
            if (success && success !== unknownSymbol) {
              return success;
            }
          } else if (!ts2.isPropertyAccessExpression(name) && !ts2.isPrivateIdentifier(name) && isInRightSideOfImportOrExportAssignment(name)) {
            var importEqualsDeclaration = ts2.getAncestor(name, 253);
            ts2.Debug.assert(importEqualsDeclaration !== void 0);
            return getSymbolOfPartOfRightHandSideOfImportEquals(name, true);
          }
          if (!ts2.isPropertyAccessExpression(name) && !ts2.isPrivateIdentifier(name)) {
            var possibleImportNode = isImportTypeQualifierPart(name);
            if (possibleImportNode) {
              getTypeFromTypeNode(possibleImportNode);
              var sym = getNodeLinks(name).resolvedSymbol;
              return sym === unknownSymbol ? void 0 : sym;
            }
          }
          while (ts2.isRightSideOfQualifiedNameOrPropertyAccess(name)) {
            name = name.parent;
          }
          if (isHeritageClauseElementIdentifier(name)) {
            var meaning = 0;
            if (name.parent.kind === 216) {
              meaning = 788968;
              if (ts2.isExpressionWithTypeArgumentsInClassExtendsClause(name.parent)) {
                meaning |= 111551;
              }
            } else {
              meaning = 1920;
            }
            meaning |= 2097152;
            var entityNameSymbol = ts2.isEntityNameExpression(name) ? resolveEntityName(name, meaning) : void 0;
            if (entityNameSymbol) {
              return entityNameSymbol;
            }
          }
          if (name.parent.kind === 317) {
            return ts2.getParameterSymbolFromJSDoc(name.parent);
          }
          if (name.parent.kind === 155 && name.parent.parent.kind === 321) {
            ts2.Debug.assert(!ts2.isInJSFile(name));
            var typeParameter = ts2.getTypeParameterFromJsDoc(name.parent);
            return typeParameter && typeParameter.symbol;
          }
          if (ts2.isExpressionNode(name)) {
            if (ts2.nodeIsMissing(name)) {
              return void 0;
            }
            if (name.kind === 75) {
              if (ts2.isJSXTagName(name) && isJsxIntrinsicIdentifier(name)) {
                var symbol = getIntrinsicTagSymbol(name.parent);
                return symbol === unknownSymbol ? void 0 : symbol;
              }
              return resolveEntityName(name, 111551, false, true);
            } else if (name.kind === 194 || name.kind === 153) {
              var links = getNodeLinks(name);
              if (links.resolvedSymbol) {
                return links.resolvedSymbol;
              }
              if (name.kind === 194) {
                checkPropertyAccessExpression(name);
              } else {
                checkQualifiedName(name);
              }
              return links.resolvedSymbol;
            }
          } else if (isTypeReferenceIdentifier(name)) {
            var meaning = name.parent.kind === 169 ? 788968 : 1920;
            return resolveEntityName(name, meaning, false, true);
          }
          if (name.parent.kind === 168) {
            return resolveEntityName(name, 1);
          }
          return void 0;
        }
        function getSymbolAtLocation(node, ignoreErrors) {
          if (node.kind === 290) {
            return ts2.isExternalModule(node) ? getMergedSymbol(node.symbol) : void 0;
          }
          var parent = node.parent;
          var grandParent = parent.parent;
          if (node.flags & 16777216) {
            return void 0;
          }
          if (isDeclarationNameOrImportPropertyName(node)) {
            var parentSymbol = getSymbolOfNode(parent);
            return ts2.isImportOrExportSpecifier(node.parent) && node.parent.propertyName === node ? getImmediateAliasedSymbol(parentSymbol) : parentSymbol;
          } else if (ts2.isLiteralComputedPropertyDeclarationName(node)) {
            return getSymbolOfNode(parent.parent);
          }
          if (node.kind === 75) {
            if (isInRightSideOfImportOrExportAssignment(node)) {
              return getSymbolOfNameOrPropertyAccessExpression(node);
            } else if (parent.kind === 191 && grandParent.kind === 189 && node === parent.propertyName) {
              var typeOfPattern = getTypeOfNode(grandParent);
              var propertyDeclaration = getPropertyOfType(typeOfPattern, node.escapedText);
              if (propertyDeclaration) {
                return propertyDeclaration;
              }
            }
          }
          switch (node.kind) {
            case 75:
            case 76:
            case 194:
            case 153:
              return getSymbolOfNameOrPropertyAccessExpression(node);
            case 104:
              var container = ts2.getThisContainer(node, false);
              if (ts2.isFunctionLike(container)) {
                var sig = getSignatureFromDeclaration(container);
                if (sig.thisParameter) {
                  return sig.thisParameter;
                }
              }
              if (ts2.isInExpressionContext(node)) {
                return checkExpression(node).symbol;
              }
            case 183:
              return getTypeFromThisTypeNode(node).symbol;
            case 102:
              return checkExpression(node).symbol;
            case 129:
              var constructorDeclaration = node.parent;
              if (constructorDeclaration && constructorDeclaration.kind === 162) {
                return constructorDeclaration.parent.symbol;
              }
              return void 0;
            case 10:
            case 14:
              if (ts2.isExternalModuleImportEqualsDeclaration(node.parent.parent) && ts2.getExternalModuleImportEqualsDeclarationExpression(node.parent.parent) === node || (node.parent.kind === 254 || node.parent.kind === 260) && node.parent.moduleSpecifier === node || (ts2.isInJSFile(node) && ts2.isRequireCall(node.parent, false) || ts2.isImportCall(node.parent)) || ts2.isLiteralTypeNode(node.parent) && ts2.isLiteralImportTypeNode(node.parent.parent) && node.parent.parent.argument === node.parent) {
                return resolveExternalModuleName(node, node, ignoreErrors);
              }
              if (ts2.isCallExpression(parent) && ts2.isBindableObjectDefinePropertyCall(parent) && parent.arguments[1] === node) {
                return getSymbolOfNode(parent);
              }
            case 8:
              var objectType = ts2.isElementAccessExpression(parent) ? parent.argumentExpression === node ? getTypeOfExpression(parent.expression) : void 0 : ts2.isLiteralTypeNode(parent) && ts2.isIndexedAccessTypeNode(grandParent) ? getTypeFromTypeNode(grandParent.objectType) : void 0;
              return objectType && getPropertyOfType(objectType, ts2.escapeLeadingUnderscores(node.text));
            case 84:
            case 94:
            case 38:
            case 80:
              return getSymbolOfNode(node.parent);
            case 188:
              return ts2.isLiteralImportTypeNode(node) ? getSymbolAtLocation(node.argument.literal, ignoreErrors) : void 0;
            case 89:
              return ts2.isExportAssignment(node.parent) ? ts2.Debug.checkDefined(node.parent.symbol) : void 0;
            default:
              return void 0;
          }
        }
        function getShorthandAssignmentValueSymbol(location) {
          if (location && location.kind === 282) {
            return resolveEntityName(location.name, 111551 | 2097152);
          }
          return void 0;
        }
        function getExportSpecifierLocalTargetSymbol(node) {
          return node.parent.parent.moduleSpecifier ? getExternalModuleMember(node.parent.parent, node) : resolveEntityName(node.propertyName || node.name, 111551 | 788968 | 1920 | 2097152);
        }
        function getTypeOfNode(node) {
          if (node.flags & 16777216) {
            return errorType;
          }
          var classDecl = ts2.tryGetClassImplementingOrExtendingExpressionWithTypeArguments(node);
          var classType = classDecl && getDeclaredTypeOfClassOrInterface(getSymbolOfNode(classDecl.class));
          if (ts2.isPartOfTypeNode(node)) {
            var typeFromTypeNode = getTypeFromTypeNode(node);
            return classType ? getTypeWithThisArgument(typeFromTypeNode, classType.thisType) : typeFromTypeNode;
          }
          if (ts2.isExpressionNode(node)) {
            return getRegularTypeOfExpression(node);
          }
          if (classType && !classDecl.isImplements) {
            var baseType = ts2.firstOrUndefined(getBaseTypes(classType));
            return baseType ? getTypeWithThisArgument(baseType, classType.thisType) : errorType;
          }
          if (isTypeDeclaration(node)) {
            var symbol = getSymbolOfNode(node);
            return getDeclaredTypeOfSymbol(symbol);
          }
          if (isTypeDeclarationName(node)) {
            var symbol = getSymbolAtLocation(node);
            return symbol ? getDeclaredTypeOfSymbol(symbol) : errorType;
          }
          if (ts2.isDeclaration(node)) {
            var symbol = getSymbolOfNode(node);
            return getTypeOfSymbol(symbol);
          }
          if (isDeclarationNameOrImportPropertyName(node)) {
            var symbol = getSymbolAtLocation(node);
            if (symbol) {
              return getTypeOfSymbol(symbol);
            }
            return errorType;
          }
          if (ts2.isBindingPattern(node)) {
            return getTypeForVariableLikeDeclaration(node.parent, true) || errorType;
          }
          if (isInRightSideOfImportOrExportAssignment(node)) {
            var symbol = getSymbolAtLocation(node);
            if (symbol) {
              var declaredType = getDeclaredTypeOfSymbol(symbol);
              return declaredType !== errorType ? declaredType : getTypeOfSymbol(symbol);
            }
          }
          return errorType;
        }
        function getTypeOfAssignmentPattern(expr) {
          ts2.Debug.assert(expr.kind === 193 || expr.kind === 192);
          if (expr.parent.kind === 232) {
            var iteratedType = checkRightHandSideOfForOf(expr.parent);
            return checkDestructuringAssignment(expr, iteratedType || errorType);
          }
          if (expr.parent.kind === 209) {
            var iteratedType = getTypeOfExpression(expr.parent.right);
            return checkDestructuringAssignment(expr, iteratedType || errorType);
          }
          if (expr.parent.kind === 281) {
            var node_4 = ts2.cast(expr.parent.parent, ts2.isObjectLiteralExpression);
            var typeOfParentObjectLiteral = getTypeOfAssignmentPattern(node_4) || errorType;
            var propertyIndex = ts2.indexOfNode(node_4.properties, expr.parent);
            return checkObjectLiteralDestructuringPropertyAssignment(node_4, typeOfParentObjectLiteral, propertyIndex);
          }
          var node = ts2.cast(expr.parent, ts2.isArrayLiteralExpression);
          var typeOfArrayLiteral = getTypeOfAssignmentPattern(node) || errorType;
          var elementType = checkIteratedTypeOrElementType(65, typeOfArrayLiteral, undefinedType, expr.parent) || errorType;
          return checkArrayLiteralDestructuringElementAssignment(node, typeOfArrayLiteral, node.elements.indexOf(expr), elementType);
        }
        function getPropertySymbolOfDestructuringAssignment(location) {
          var typeOfObjectLiteral = getTypeOfAssignmentPattern(ts2.cast(location.parent.parent, ts2.isAssignmentPattern));
          return typeOfObjectLiteral && getPropertyOfType(typeOfObjectLiteral, location.escapedText);
        }
        function getRegularTypeOfExpression(expr) {
          if (ts2.isRightSideOfQualifiedNameOrPropertyAccess(expr)) {
            expr = expr.parent;
          }
          return getRegularTypeOfLiteralType(getTypeOfExpression(expr));
        }
        function getParentTypeOfClassElement(node) {
          var classSymbol = getSymbolOfNode(node.parent);
          return ts2.hasModifier(node, 32) ? getTypeOfSymbol(classSymbol) : getDeclaredTypeOfSymbol(classSymbol);
        }
        function getClassElementPropertyKeyType(element) {
          var name = element.name;
          switch (name.kind) {
            case 75:
              return getLiteralType(ts2.idText(name));
            case 8:
            case 10:
              return getLiteralType(name.text);
            case 154:
              var nameType = checkComputedPropertyName(name);
              return isTypeAssignableToKind(nameType, 12288) ? nameType : stringType;
            default:
              return ts2.Debug.fail("Unsupported property name.");
          }
        }
        function getAugmentedPropertiesOfType(type) {
          type = getApparentType(type);
          var propsByName = ts2.createSymbolTable(getPropertiesOfType(type));
          var functionType = getSignaturesOfType(type, 0).length ? globalCallableFunctionType : getSignaturesOfType(type, 1).length ? globalNewableFunctionType : void 0;
          if (functionType) {
            ts2.forEach(getPropertiesOfType(functionType), function(p) {
              if (!propsByName.has(p.escapedName)) {
                propsByName.set(p.escapedName, p);
              }
            });
          }
          return getNamedMembers(propsByName);
        }
        function typeHasCallOrConstructSignatures(type) {
          return ts2.typeHasCallOrConstructSignatures(type, checker);
        }
        function getRootSymbols(symbol) {
          var roots = getImmediateRootSymbols(symbol);
          return roots ? ts2.flatMap(roots, getRootSymbols) : [symbol];
        }
        function getImmediateRootSymbols(symbol) {
          if (ts2.getCheckFlags(symbol) & 6) {
            return ts2.mapDefined(getSymbolLinks(symbol).containingType.types, function(type) {
              return getPropertyOfType(type, symbol.escapedName);
            });
          } else if (symbol.flags & 33554432) {
            var _a = symbol, leftSpread = _a.leftSpread, rightSpread = _a.rightSpread, syntheticOrigin = _a.syntheticOrigin;
            return leftSpread ? [leftSpread, rightSpread] : syntheticOrigin ? [syntheticOrigin] : ts2.singleElementArray(tryGetAliasTarget(symbol));
          }
          return void 0;
        }
        function tryGetAliasTarget(symbol) {
          var target;
          var next = symbol;
          while (next = getSymbolLinks(next).target) {
            target = next;
          }
          return target;
        }
        function isArgumentsLocalBinding(nodeIn) {
          if (!ts2.isGeneratedIdentifier(nodeIn)) {
            var node = ts2.getParseTreeNode(nodeIn, ts2.isIdentifier);
            if (node) {
              var isPropertyName_1 = node.parent.kind === 194 && node.parent.name === node;
              return !isPropertyName_1 && getReferencedValueSymbol(node) === argumentsSymbol;
            }
          }
          return false;
        }
        function moduleExportsSomeValue(moduleReferenceExpression) {
          var moduleSymbol = resolveExternalModuleName(moduleReferenceExpression.parent, moduleReferenceExpression);
          if (!moduleSymbol || ts2.isShorthandAmbientModuleSymbol(moduleSymbol)) {
            return true;
          }
          var hasExportAssignment = hasExportAssignmentSymbol(moduleSymbol);
          moduleSymbol = resolveExternalModuleSymbol(moduleSymbol);
          var symbolLinks2 = getSymbolLinks(moduleSymbol);
          if (symbolLinks2.exportsSomeValue === void 0) {
            symbolLinks2.exportsSomeValue = hasExportAssignment ? !!(moduleSymbol.flags & 111551) : ts2.forEachEntry(getExportsOfModule(moduleSymbol), isValue);
          }
          return symbolLinks2.exportsSomeValue;
          function isValue(s) {
            s = resolveSymbol(s);
            return s && !!(s.flags & 111551);
          }
        }
        function isNameOfModuleOrEnumDeclaration(node) {
          return ts2.isModuleOrEnumDeclaration(node.parent) && node === node.parent.name;
        }
        function getReferencedExportContainer(nodeIn, prefixLocals) {
          var node = ts2.getParseTreeNode(nodeIn, ts2.isIdentifier);
          if (node) {
            var symbol = getReferencedValueSymbol(node, isNameOfModuleOrEnumDeclaration(node));
            if (symbol) {
              if (symbol.flags & 1048576) {
                var exportSymbol = getMergedSymbol(symbol.exportSymbol);
                if (!prefixLocals && exportSymbol.flags & 944 && !(exportSymbol.flags & 3)) {
                  return void 0;
                }
                symbol = exportSymbol;
              }
              var parentSymbol_1 = getParentOfSymbol(symbol);
              if (parentSymbol_1) {
                if (parentSymbol_1.flags & 512 && parentSymbol_1.valueDeclaration.kind === 290) {
                  var symbolFile = parentSymbol_1.valueDeclaration;
                  var referenceFile = ts2.getSourceFileOfNode(node);
                  var symbolIsUmdExport = symbolFile !== referenceFile;
                  return symbolIsUmdExport ? void 0 : symbolFile;
                }
                return ts2.findAncestor(node.parent, function(n) {
                  return ts2.isModuleOrEnumDeclaration(n) && getSymbolOfNode(n) === parentSymbol_1;
                });
              }
            }
          }
        }
        function getReferencedImportDeclaration(nodeIn) {
          var node = ts2.getParseTreeNode(nodeIn, ts2.isIdentifier);
          if (node) {
            var symbol = getReferencedValueSymbol(node);
            if (isNonLocalAlias(symbol, 111551) && !getTypeOnlyAliasDeclaration(symbol)) {
              return getDeclarationOfAliasSymbol(symbol);
            }
          }
          return void 0;
        }
        function isSymbolOfDestructuredElementOfCatchBinding(symbol) {
          return ts2.isBindingElement(symbol.valueDeclaration) && ts2.walkUpBindingElementsAndPatterns(symbol.valueDeclaration).parent.kind === 280;
        }
        function isSymbolOfDeclarationWithCollidingName(symbol) {
          if (symbol.flags & 418 && !ts2.isSourceFile(symbol.valueDeclaration)) {
            var links = getSymbolLinks(symbol);
            if (links.isDeclarationWithCollidingName === void 0) {
              var container = ts2.getEnclosingBlockScopeContainer(symbol.valueDeclaration);
              if (ts2.isStatementWithLocals(container) || isSymbolOfDestructuredElementOfCatchBinding(symbol)) {
                var nodeLinks_1 = getNodeLinks(symbol.valueDeclaration);
                if (resolveName(container.parent, symbol.escapedName, 111551, void 0, void 0, false)) {
                  links.isDeclarationWithCollidingName = true;
                } else if (nodeLinks_1.flags & 262144) {
                  var isDeclaredInLoop = nodeLinks_1.flags & 524288;
                  var inLoopInitializer = ts2.isIterationStatement(container, false);
                  var inLoopBodyBlock = container.kind === 223 && ts2.isIterationStatement(container.parent, false);
                  links.isDeclarationWithCollidingName = !ts2.isBlockScopedContainerTopLevel(container) && (!isDeclaredInLoop || !inLoopInitializer && !inLoopBodyBlock);
                } else {
                  links.isDeclarationWithCollidingName = false;
                }
              }
            }
            return links.isDeclarationWithCollidingName;
          }
          return false;
        }
        function getReferencedDeclarationWithCollidingName(nodeIn) {
          if (!ts2.isGeneratedIdentifier(nodeIn)) {
            var node = ts2.getParseTreeNode(nodeIn, ts2.isIdentifier);
            if (node) {
              var symbol = getReferencedValueSymbol(node);
              if (symbol && isSymbolOfDeclarationWithCollidingName(symbol)) {
                return symbol.valueDeclaration;
              }
            }
          }
          return void 0;
        }
        function isDeclarationWithCollidingName(nodeIn) {
          var node = ts2.getParseTreeNode(nodeIn, ts2.isDeclaration);
          if (node) {
            var symbol = getSymbolOfNode(node);
            if (symbol) {
              return isSymbolOfDeclarationWithCollidingName(symbol);
            }
          }
          return false;
        }
        function isValueAliasDeclaration(node) {
          switch (node.kind) {
            case 253:
              return isAliasResolvedToValue(getSymbolOfNode(node) || unknownSymbol);
            case 255:
            case 256:
            case 258:
            case 263:
              var symbol = getSymbolOfNode(node) || unknownSymbol;
              return isAliasResolvedToValue(symbol) && !getTypeOnlyAliasDeclaration(symbol);
            case 260:
              var exportClause = node.exportClause;
              return !!exportClause && (ts2.isNamespaceExport(exportClause) || ts2.some(exportClause.elements, isValueAliasDeclaration));
            case 259:
              return node.expression && node.expression.kind === 75 ? isAliasResolvedToValue(getSymbolOfNode(node) || unknownSymbol) : true;
          }
          return false;
        }
        function isTopLevelValueImportEqualsWithEntityName(nodeIn) {
          var node = ts2.getParseTreeNode(nodeIn, ts2.isImportEqualsDeclaration);
          if (node === void 0 || node.parent.kind !== 290 || !ts2.isInternalModuleImportEqualsDeclaration(node)) {
            return false;
          }
          var isValue = isAliasResolvedToValue(getSymbolOfNode(node));
          return isValue && node.moduleReference && !ts2.nodeIsMissing(node.moduleReference);
        }
        function isAliasResolvedToValue(symbol) {
          var target = resolveAlias(symbol);
          if (target === unknownSymbol) {
            return true;
          }
          return !!(target.flags & 111551) && (compilerOptions.preserveConstEnums || !isConstEnumOrConstEnumOnlyModule(target));
        }
        function isConstEnumOrConstEnumOnlyModule(s) {
          return isConstEnumSymbol(s) || !!s.constEnumOnlyModule;
        }
        function isReferencedAliasDeclaration(node, checkChildren) {
          if (isAliasSymbolDeclaration(node)) {
            var symbol = getSymbolOfNode(node);
            if (symbol && getSymbolLinks(symbol).referenced) {
              return true;
            }
            var target = getSymbolLinks(symbol).target;
            if (target && ts2.getModifierFlags(node) & 1 && target.flags & 111551 && (compilerOptions.preserveConstEnums || !isConstEnumOrConstEnumOnlyModule(target))) {
              return true;
            }
          }
          if (checkChildren) {
            return !!ts2.forEachChild(node, function(node2) {
              return isReferencedAliasDeclaration(node2, checkChildren);
            });
          }
          return false;
        }
        function isImplementationOfOverload(node) {
          if (ts2.nodeIsPresent(node.body)) {
            if (ts2.isGetAccessor(node) || ts2.isSetAccessor(node))
              return false;
            var symbol = getSymbolOfNode(node);
            var signaturesOfSymbol = getSignaturesOfSymbol(symbol);
            return signaturesOfSymbol.length > 1 || signaturesOfSymbol.length === 1 && signaturesOfSymbol[0].declaration !== node;
          }
          return false;
        }
        function isRequiredInitializedParameter(parameter) {
          return !!strictNullChecks && !isOptionalParameter(parameter) && !ts2.isJSDocParameterTag(parameter) && !!parameter.initializer && !ts2.hasModifier(parameter, 92);
        }
        function isOptionalUninitializedParameterProperty(parameter) {
          return strictNullChecks && isOptionalParameter(parameter) && !parameter.initializer && ts2.hasModifier(parameter, 92);
        }
        function isExpandoFunctionDeclaration(node) {
          var declaration = ts2.getParseTreeNode(node, ts2.isFunctionDeclaration);
          if (!declaration) {
            return false;
          }
          var symbol = getSymbolOfNode(declaration);
          if (!symbol || !(symbol.flags & 16)) {
            return false;
          }
          return !!ts2.forEachEntry(getExportsOfSymbol(symbol), function(p) {
            return p.flags & 111551 && p.valueDeclaration && ts2.isPropertyAccessExpression(p.valueDeclaration);
          });
        }
        function getPropertiesOfContainerFunction(node) {
          var declaration = ts2.getParseTreeNode(node, ts2.isFunctionDeclaration);
          if (!declaration) {
            return ts2.emptyArray;
          }
          var symbol = getSymbolOfNode(declaration);
          return symbol && getPropertiesOfType(getTypeOfSymbol(symbol)) || ts2.emptyArray;
        }
        function getNodeCheckFlags(node) {
          return getNodeLinks(node).flags || 0;
        }
        function getEnumMemberValue(node) {
          computeEnumMemberValues(node.parent);
          return getNodeLinks(node).enumMemberValue;
        }
        function canHaveConstantValue(node) {
          switch (node.kind) {
            case 284:
            case 194:
            case 195:
              return true;
          }
          return false;
        }
        function getConstantValue(node) {
          if (node.kind === 284) {
            return getEnumMemberValue(node);
          }
          var symbol = getNodeLinks(node).resolvedSymbol;
          if (symbol && symbol.flags & 8) {
            var member = symbol.valueDeclaration;
            if (ts2.isEnumConst(member.parent)) {
              return getEnumMemberValue(member);
            }
          }
          return void 0;
        }
        function isFunctionType(type) {
          return !!(type.flags & 524288) && getSignaturesOfType(type, 0).length > 0;
        }
        function getTypeReferenceSerializationKind(typeNameIn, location) {
          var typeName = ts2.getParseTreeNode(typeNameIn, ts2.isEntityName);
          if (!typeName)
            return ts2.TypeReferenceSerializationKind.Unknown;
          if (location) {
            location = ts2.getParseTreeNode(location);
            if (!location)
              return ts2.TypeReferenceSerializationKind.Unknown;
          }
          var valueSymbol = resolveEntityName(typeName, 111551, true, false, location);
          var typeSymbol = resolveEntityName(typeName, 788968, true, false, location);
          if (valueSymbol && valueSymbol === typeSymbol) {
            var globalPromiseSymbol = getGlobalPromiseConstructorSymbol(false);
            if (globalPromiseSymbol && valueSymbol === globalPromiseSymbol) {
              return ts2.TypeReferenceSerializationKind.Promise;
            }
            var constructorType = getTypeOfSymbol(valueSymbol);
            if (constructorType && isConstructorType(constructorType)) {
              return ts2.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue;
            }
          }
          if (!typeSymbol) {
            return ts2.TypeReferenceSerializationKind.Unknown;
          }
          var type = getDeclaredTypeOfSymbol(typeSymbol);
          if (type === errorType) {
            return ts2.TypeReferenceSerializationKind.Unknown;
          } else if (type.flags & 3) {
            return ts2.TypeReferenceSerializationKind.ObjectType;
          } else if (isTypeAssignableToKind(type, 16384 | 98304 | 131072)) {
            return ts2.TypeReferenceSerializationKind.VoidNullableOrNeverType;
          } else if (isTypeAssignableToKind(type, 528)) {
            return ts2.TypeReferenceSerializationKind.BooleanType;
          } else if (isTypeAssignableToKind(type, 296)) {
            return ts2.TypeReferenceSerializationKind.NumberLikeType;
          } else if (isTypeAssignableToKind(type, 2112)) {
            return ts2.TypeReferenceSerializationKind.BigIntLikeType;
          } else if (isTypeAssignableToKind(type, 132)) {
            return ts2.TypeReferenceSerializationKind.StringLikeType;
          } else if (isTupleType(type)) {
            return ts2.TypeReferenceSerializationKind.ArrayLikeType;
          } else if (isTypeAssignableToKind(type, 12288)) {
            return ts2.TypeReferenceSerializationKind.ESSymbolType;
          } else if (isFunctionType(type)) {
            return ts2.TypeReferenceSerializationKind.TypeWithCallSignature;
          } else if (isArrayType(type)) {
            return ts2.TypeReferenceSerializationKind.ArrayLikeType;
          } else {
            return ts2.TypeReferenceSerializationKind.ObjectType;
          }
        }
        function createTypeOfDeclaration(declarationIn, enclosingDeclaration, flags, tracker, addUndefined) {
          var declaration = ts2.getParseTreeNode(declarationIn, ts2.isVariableLikeOrAccessor);
          if (!declaration) {
            return ts2.createToken(125);
          }
          var symbol = getSymbolOfNode(declaration);
          var type = symbol && !(symbol.flags & (2048 | 131072)) ? getWidenedLiteralType(getTypeOfSymbol(symbol)) : errorType;
          if (type.flags & 8192 && type.symbol === symbol) {
            flags |= 1048576;
          }
          if (addUndefined) {
            type = getOptionalType(type);
          }
          return nodeBuilder.typeToTypeNode(type, enclosingDeclaration, flags | 1024, tracker);
        }
        function createReturnTypeOfSignatureDeclaration(signatureDeclarationIn, enclosingDeclaration, flags, tracker) {
          var signatureDeclaration = ts2.getParseTreeNode(signatureDeclarationIn, ts2.isFunctionLike);
          if (!signatureDeclaration) {
            return ts2.createToken(125);
          }
          var signature = getSignatureFromDeclaration(signatureDeclaration);
          return nodeBuilder.typeToTypeNode(getReturnTypeOfSignature(signature), enclosingDeclaration, flags | 1024, tracker);
        }
        function createTypeOfExpression(exprIn, enclosingDeclaration, flags, tracker) {
          var expr = ts2.getParseTreeNode(exprIn, ts2.isExpression);
          if (!expr) {
            return ts2.createToken(125);
          }
          var type = getWidenedType(getRegularTypeOfExpression(expr));
          return nodeBuilder.typeToTypeNode(type, enclosingDeclaration, flags | 1024, tracker);
        }
        function hasGlobalName(name) {
          return globals.has(ts2.escapeLeadingUnderscores(name));
        }
        function getReferencedValueSymbol(reference, startInDeclarationContainer) {
          var resolvedSymbol = getNodeLinks(reference).resolvedSymbol;
          if (resolvedSymbol) {
            return resolvedSymbol;
          }
          var location = reference;
          if (startInDeclarationContainer) {
            var parent = reference.parent;
            if (ts2.isDeclaration(parent) && reference === parent.name) {
              location = getDeclarationContainer(parent);
            }
          }
          return resolveName(location, reference.escapedText, 111551 | 1048576 | 2097152, void 0, void 0, true);
        }
        function getReferencedValueDeclaration(referenceIn) {
          if (!ts2.isGeneratedIdentifier(referenceIn)) {
            var reference = ts2.getParseTreeNode(referenceIn, ts2.isIdentifier);
            if (reference) {
              var symbol = getReferencedValueSymbol(reference);
              if (symbol) {
                return getExportSymbolOfValueSymbolIfExported(symbol).valueDeclaration;
              }
            }
          }
          return void 0;
        }
        function isLiteralConstDeclaration(node) {
          if (ts2.isDeclarationReadonly(node) || ts2.isVariableDeclaration(node) && ts2.isVarConst(node)) {
            return isFreshLiteralType(getTypeOfSymbol(getSymbolOfNode(node)));
          }
          return false;
        }
        function literalTypeToNode(type, enclosing, tracker) {
          var enumResult = type.flags & 1024 ? nodeBuilder.symbolToExpression(type.symbol, 111551, enclosing, void 0, tracker) : type === trueType ? ts2.createTrue() : type === falseType && ts2.createFalse();
          return enumResult || ts2.createLiteral(type.value);
        }
        function createLiteralConstValue(node, tracker) {
          var type = getTypeOfSymbol(getSymbolOfNode(node));
          return literalTypeToNode(type, node, tracker);
        }
        function getJsxFactoryEntity(location) {
          return location ? (getJsxNamespace(location), ts2.getSourceFileOfNode(location).localJsxFactory || _jsxFactoryEntity) : _jsxFactoryEntity;
        }
        function createResolver() {
          var resolvedTypeReferenceDirectives = host.getResolvedTypeReferenceDirectives();
          var fileToDirective;
          if (resolvedTypeReferenceDirectives) {
            fileToDirective = ts2.createMap();
            resolvedTypeReferenceDirectives.forEach(function(resolvedDirective, key) {
              if (!resolvedDirective || !resolvedDirective.resolvedFileName) {
                return;
              }
              var file = host.getSourceFile(resolvedDirective.resolvedFileName);
              if (file) {
                addReferencedFilesToTypeDirective(file, key);
              }
            });
          }
          return {
            getReferencedExportContainer,
            getReferencedImportDeclaration,
            getReferencedDeclarationWithCollidingName,
            isDeclarationWithCollidingName,
            isValueAliasDeclaration: function(node) {
              node = ts2.getParseTreeNode(node);
              return node ? isValueAliasDeclaration(node) : true;
            },
            hasGlobalName,
            isReferencedAliasDeclaration: function(node, checkChildren) {
              node = ts2.getParseTreeNode(node);
              return node ? isReferencedAliasDeclaration(node, checkChildren) : true;
            },
            getNodeCheckFlags: function(node) {
              node = ts2.getParseTreeNode(node);
              return node ? getNodeCheckFlags(node) : 0;
            },
            isTopLevelValueImportEqualsWithEntityName,
            isDeclarationVisible,
            isImplementationOfOverload,
            isRequiredInitializedParameter,
            isOptionalUninitializedParameterProperty,
            isExpandoFunctionDeclaration,
            getPropertiesOfContainerFunction,
            createTypeOfDeclaration,
            createReturnTypeOfSignatureDeclaration,
            createTypeOfExpression,
            createLiteralConstValue,
            isSymbolAccessible,
            isEntityNameVisible,
            getConstantValue: function(nodeIn) {
              var node = ts2.getParseTreeNode(nodeIn, canHaveConstantValue);
              return node ? getConstantValue(node) : void 0;
            },
            collectLinkedAliases,
            getReferencedValueDeclaration,
            getTypeReferenceSerializationKind,
            isOptionalParameter,
            moduleExportsSomeValue,
            isArgumentsLocalBinding,
            getExternalModuleFileFromDeclaration,
            getTypeReferenceDirectivesForEntityName,
            getTypeReferenceDirectivesForSymbol,
            isLiteralConstDeclaration,
            isLateBound: function(nodeIn) {
              var node = ts2.getParseTreeNode(nodeIn, ts2.isDeclaration);
              var symbol = node && getSymbolOfNode(node);
              return !!(symbol && ts2.getCheckFlags(symbol) & 4096);
            },
            getJsxFactoryEntity,
            getAllAccessorDeclarations: function(accessor) {
              accessor = ts2.getParseTreeNode(accessor, ts2.isGetOrSetAccessorDeclaration);
              var otherKind = accessor.kind === 164 ? 163 : 164;
              var otherAccessor = ts2.getDeclarationOfKind(getSymbolOfNode(accessor), otherKind);
              var firstAccessor = otherAccessor && otherAccessor.pos < accessor.pos ? otherAccessor : accessor;
              var secondAccessor = otherAccessor && otherAccessor.pos < accessor.pos ? accessor : otherAccessor;
              var setAccessor = accessor.kind === 164 ? accessor : otherAccessor;
              var getAccessor = accessor.kind === 163 ? accessor : otherAccessor;
              return {
                firstAccessor,
                secondAccessor,
                setAccessor,
                getAccessor
              };
            },
            getSymbolOfExternalModuleSpecifier: function(moduleName) {
              return resolveExternalModuleNameWorker(moduleName, moduleName, void 0);
            },
            isBindingCapturedByNode: function(node, decl) {
              var parseNode = ts2.getParseTreeNode(node);
              var parseDecl = ts2.getParseTreeNode(decl);
              return !!parseNode && !!parseDecl && (ts2.isVariableDeclaration(parseDecl) || ts2.isBindingElement(parseDecl)) && isBindingCapturedByNode(parseNode, parseDecl);
            },
            getDeclarationStatementsForSourceFile: function(node, flags, tracker, bundled) {
              var n = ts2.getParseTreeNode(node);
              ts2.Debug.assert(n && n.kind === 290, "Non-sourcefile node passed into getDeclarationsForSourceFile");
              var sym = getSymbolOfNode(node);
              if (!sym) {
                return !node.locals ? [] : nodeBuilder.symbolTableToDeclarationStatements(node.locals, node, flags, tracker, bundled);
              }
              return !sym.exports ? [] : nodeBuilder.symbolTableToDeclarationStatements(sym.exports, node, flags, tracker, bundled);
            },
            isImportRequiredByAugmentation
          };
          function isImportRequiredByAugmentation(node) {
            var file = ts2.getSourceFileOfNode(node);
            if (!file.symbol)
              return false;
            var importTarget = getExternalModuleFileFromDeclaration(node);
            if (!importTarget)
              return false;
            if (importTarget === file)
              return false;
            var exports2 = getExportsOfModule(file.symbol);
            for (var _i = 0, _a = ts2.arrayFrom(exports2.values()); _i < _a.length; _i++) {
              var s = _a[_i];
              if (s.mergeId) {
                var merged = getMergedSymbol(s);
                for (var _b = 0, _c = merged.declarations; _b < _c.length; _b++) {
                  var d = _c[_b];
                  var declFile = ts2.getSourceFileOfNode(d);
                  if (declFile === importTarget) {
                    return true;
                  }
                }
              }
            }
            return false;
          }
          function isInHeritageClause(node) {
            return node.parent && node.parent.kind === 216 && node.parent.parent && node.parent.parent.kind === 279;
          }
          function getTypeReferenceDirectivesForEntityName(node) {
            if (!fileToDirective) {
              return void 0;
            }
            var meaning = 788968 | 1920;
            if (node.kind === 75 && isInTypeQuery(node) || node.kind === 194 && !isInHeritageClause(node)) {
              meaning = 111551 | 1048576;
            }
            var symbol = resolveEntityName(node, meaning, true);
            return symbol && symbol !== unknownSymbol ? getTypeReferenceDirectivesForSymbol(symbol, meaning) : void 0;
          }
          function getTypeReferenceDirectivesForSymbol(symbol, meaning) {
            if (!fileToDirective) {
              return void 0;
            }
            if (!isSymbolFromTypeDeclarationFile(symbol)) {
              return void 0;
            }
            var typeReferenceDirectives;
            for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
              var decl = _a[_i];
              if (decl.symbol && decl.symbol.flags & meaning) {
                var file = ts2.getSourceFileOfNode(decl);
                var typeReferenceDirective = fileToDirective.get(file.path);
                if (typeReferenceDirective) {
                  (typeReferenceDirectives || (typeReferenceDirectives = [])).push(typeReferenceDirective);
                } else {
                  return void 0;
                }
              }
            }
            return typeReferenceDirectives;
          }
          function isSymbolFromTypeDeclarationFile(symbol) {
            if (!symbol.declarations) {
              return false;
            }
            var current = symbol;
            while (true) {
              var parent = getParentOfSymbol(current);
              if (parent) {
                current = parent;
              } else {
                break;
              }
            }
            if (current.valueDeclaration && current.valueDeclaration.kind === 290 && current.flags & 512) {
              return false;
            }
            for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
              var decl = _a[_i];
              var file = ts2.getSourceFileOfNode(decl);
              if (fileToDirective.has(file.path)) {
                return true;
              }
            }
            return false;
          }
          function addReferencedFilesToTypeDirective(file, key) {
            if (fileToDirective.has(file.path))
              return;
            fileToDirective.set(file.path, key);
            for (var _i = 0, _a = file.referencedFiles; _i < _a.length; _i++) {
              var fileName = _a[_i].fileName;
              var resolvedFile = ts2.resolveTripleslashReference(fileName, file.originalFileName);
              var referencedFile = host.getSourceFile(resolvedFile);
              if (referencedFile) {
                addReferencedFilesToTypeDirective(referencedFile, key);
              }
            }
          }
        }
        function getExternalModuleFileFromDeclaration(declaration) {
          var specifier = declaration.kind === 249 ? ts2.tryCast(declaration.name, ts2.isStringLiteral) : ts2.getExternalModuleName(declaration);
          var moduleSymbol = resolveExternalModuleNameWorker(specifier, specifier, void 0);
          if (!moduleSymbol) {
            return void 0;
          }
          return ts2.getDeclarationOfKind(moduleSymbol, 290);
        }
        function initializeTypeChecker() {
          for (var _i = 0, _a = host.getSourceFiles(); _i < _a.length; _i++) {
            var file = _a[_i];
            ts2.bindSourceFile(file, compilerOptions);
          }
          amalgamatedDuplicates = ts2.createMap();
          var augmentations;
          for (var _b = 0, _c = host.getSourceFiles(); _b < _c.length; _b++) {
            var file = _c[_b];
            if (file.redirectInfo) {
              continue;
            }
            if (!ts2.isExternalOrCommonJsModule(file)) {
              var fileGlobalThisSymbol = file.locals.get("globalThis");
              if (fileGlobalThisSymbol) {
                for (var _d = 0, _e = fileGlobalThisSymbol.declarations; _d < _e.length; _d++) {
                  var declaration = _e[_d];
                  diagnostics.add(ts2.createDiagnosticForNode(declaration, ts2.Diagnostics.Declaration_name_conflicts_with_built_in_global_identifier_0, "globalThis"));
                }
              }
              mergeSymbolTable(globals, file.locals);
            }
            if (file.jsGlobalAugmentations) {
              mergeSymbolTable(globals, file.jsGlobalAugmentations);
            }
            if (file.patternAmbientModules && file.patternAmbientModules.length) {
              patternAmbientModules = ts2.concatenate(patternAmbientModules, file.patternAmbientModules);
            }
            if (file.moduleAugmentations.length) {
              (augmentations || (augmentations = [])).push(file.moduleAugmentations);
            }
            if (file.symbol && file.symbol.globalExports) {
              var source = file.symbol.globalExports;
              source.forEach(function(sourceSymbol, id) {
                if (!globals.has(id)) {
                  globals.set(id, sourceSymbol);
                }
              });
            }
          }
          if (augmentations) {
            for (var _f = 0, augmentations_1 = augmentations; _f < augmentations_1.length; _f++) {
              var list = augmentations_1[_f];
              for (var _g = 0, list_1 = list; _g < list_1.length; _g++) {
                var augmentation = list_1[_g];
                if (!ts2.isGlobalScopeAugmentation(augmentation.parent))
                  continue;
                mergeModuleAugmentation(augmentation);
              }
            }
          }
          addToSymbolTable(globals, builtinGlobals, ts2.Diagnostics.Declaration_name_conflicts_with_built_in_global_identifier_0);
          getSymbolLinks(undefinedSymbol).type = undefinedWideningType;
          getSymbolLinks(argumentsSymbol).type = getGlobalType("IArguments", 0, true);
          getSymbolLinks(unknownSymbol).type = errorType;
          getSymbolLinks(globalThisSymbol).type = createObjectType(16, globalThisSymbol);
          globalArrayType = getGlobalType("Array", 1, true);
          globalObjectType = getGlobalType("Object", 0, true);
          globalFunctionType = getGlobalType("Function", 0, true);
          globalCallableFunctionType = strictBindCallApply && getGlobalType("CallableFunction", 0, true) || globalFunctionType;
          globalNewableFunctionType = strictBindCallApply && getGlobalType("NewableFunction", 0, true) || globalFunctionType;
          globalStringType = getGlobalType("String", 0, true);
          globalNumberType = getGlobalType("Number", 0, true);
          globalBooleanType = getGlobalType("Boolean", 0, true);
          globalRegExpType = getGlobalType("RegExp", 0, true);
          anyArrayType = createArrayType(anyType);
          autoArrayType = createArrayType(autoType);
          if (autoArrayType === emptyObjectType) {
            autoArrayType = createAnonymousType(void 0, emptySymbols, ts2.emptyArray, ts2.emptyArray, void 0, void 0);
          }
          globalReadonlyArrayType = getGlobalTypeOrUndefined("ReadonlyArray", 1) || globalArrayType;
          anyReadonlyArrayType = globalReadonlyArrayType ? createTypeFromGenericGlobalType(globalReadonlyArrayType, [anyType]) : anyArrayType;
          globalThisType = getGlobalTypeOrUndefined("ThisType", 1);
          if (augmentations) {
            for (var _h = 0, augmentations_2 = augmentations; _h < augmentations_2.length; _h++) {
              var list = augmentations_2[_h];
              for (var _j = 0, list_2 = list; _j < list_2.length; _j++) {
                var augmentation = list_2[_j];
                if (ts2.isGlobalScopeAugmentation(augmentation.parent))
                  continue;
                mergeModuleAugmentation(augmentation);
              }
            }
          }
          amalgamatedDuplicates.forEach(function(_a2) {
            var firstFile = _a2.firstFile, secondFile = _a2.secondFile, conflictingSymbols = _a2.conflictingSymbols;
            if (conflictingSymbols.size < 8) {
              conflictingSymbols.forEach(function(_a3, symbolName) {
                var isBlockScoped = _a3.isBlockScoped, firstFileLocations = _a3.firstFileLocations, secondFileLocations = _a3.secondFileLocations;
                var message = isBlockScoped ? ts2.Diagnostics.Cannot_redeclare_block_scoped_variable_0 : ts2.Diagnostics.Duplicate_identifier_0;
                for (var _i2 = 0, firstFileLocations_1 = firstFileLocations; _i2 < firstFileLocations_1.length; _i2++) {
                  var node = firstFileLocations_1[_i2];
                  addDuplicateDeclarationError(node, message, symbolName, secondFileLocations);
                }
                for (var _b2 = 0, secondFileLocations_1 = secondFileLocations; _b2 < secondFileLocations_1.length; _b2++) {
                  var node = secondFileLocations_1[_b2];
                  addDuplicateDeclarationError(node, message, symbolName, firstFileLocations);
                }
              });
            } else {
              var list2 = ts2.arrayFrom(conflictingSymbols.keys()).join(", ");
              diagnostics.add(ts2.addRelatedInfo(ts2.createDiagnosticForNode(firstFile, ts2.Diagnostics.Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0, list2), ts2.createDiagnosticForNode(secondFile, ts2.Diagnostics.Conflicts_are_in_this_file)));
              diagnostics.add(ts2.addRelatedInfo(ts2.createDiagnosticForNode(secondFile, ts2.Diagnostics.Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0, list2), ts2.createDiagnosticForNode(firstFile, ts2.Diagnostics.Conflicts_are_in_this_file)));
            }
          });
          amalgamatedDuplicates = void 0;
        }
        function checkExternalEmitHelpers(location, helpers) {
          if ((requestedExternalEmitHelpers & helpers) !== helpers && compilerOptions.importHelpers) {
            var sourceFile = ts2.getSourceFileOfNode(location);
            if (ts2.isEffectiveExternalModule(sourceFile, compilerOptions) && !(location.flags & 8388608)) {
              var helpersModule = resolveHelpersModule(sourceFile, location);
              if (helpersModule !== unknownSymbol) {
                var uncheckedHelpers = helpers & ~requestedExternalEmitHelpers;
                for (var helper = 1; helper <= 1048576; helper <<= 1) {
                  if (uncheckedHelpers & helper) {
                    var name = getHelperName(helper);
                    var symbol = getSymbol(helpersModule.exports, ts2.escapeLeadingUnderscores(name), 111551);
                    if (!symbol) {
                      error(location, ts2.Diagnostics.This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_version_of_0, ts2.externalHelpersModuleNameText, name);
                    }
                  }
                }
              }
              requestedExternalEmitHelpers |= helpers;
            }
          }
        }
        function getHelperName(helper) {
          switch (helper) {
            case 1:
              return "__extends";
            case 2:
              return "__assign";
            case 4:
              return "__rest";
            case 8:
              return "__decorate";
            case 16:
              return "__metadata";
            case 32:
              return "__param";
            case 64:
              return "__awaiter";
            case 128:
              return "__generator";
            case 256:
              return "__values";
            case 512:
              return "__read";
            case 1024:
              return "__spread";
            case 2048:
              return "__spreadArrays";
            case 4096:
              return "__await";
            case 8192:
              return "__asyncGenerator";
            case 16384:
              return "__asyncDelegator";
            case 32768:
              return "__asyncValues";
            case 65536:
              return "__exportStar";
            case 131072:
              return "__makeTemplateObject";
            case 262144:
              return "__classPrivateFieldGet";
            case 524288:
              return "__classPrivateFieldSet";
            case 1048576:
              return "__createBinding";
            default:
              return ts2.Debug.fail("Unrecognized helper");
          }
        }
        function resolveHelpersModule(node, errorNode) {
          if (!externalHelpersModule) {
            externalHelpersModule = resolveExternalModule(node, ts2.externalHelpersModuleNameText, ts2.Diagnostics.This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found, errorNode) || unknownSymbol;
          }
          return externalHelpersModule;
        }
        function checkGrammarDecoratorsAndModifiers(node) {
          return checkGrammarDecorators(node) || checkGrammarModifiers(node);
        }
        function checkGrammarDecorators(node) {
          if (!node.decorators) {
            return false;
          }
          if (!ts2.nodeCanBeDecorated(node, node.parent, node.parent.parent)) {
            if (node.kind === 161 && !ts2.nodeIsPresent(node.body)) {
              return grammarErrorOnFirstToken(node, ts2.Diagnostics.A_decorator_can_only_decorate_a_method_implementation_not_an_overload);
            } else {
              return grammarErrorOnFirstToken(node, ts2.Diagnostics.Decorators_are_not_valid_here);
            }
          } else if (node.kind === 163 || node.kind === 164) {
            var accessors = ts2.getAllAccessorDeclarations(node.parent.members, node);
            if (accessors.firstAccessor.decorators && node === accessors.secondAccessor) {
              return grammarErrorOnFirstToken(node, ts2.Diagnostics.Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name);
            }
          }
          return false;
        }
        function checkGrammarModifiers(node) {
          var quickResult = reportObviousModifierErrors(node);
          if (quickResult !== void 0) {
            return quickResult;
          }
          var lastStatic, lastDeclare, lastAsync, lastReadonly;
          var flags = 0;
          for (var _i = 0, _a = node.modifiers; _i < _a.length; _i++) {
            var modifier = _a[_i];
            if (modifier.kind !== 138) {
              if (node.kind === 158 || node.kind === 160) {
                return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_cannot_appear_on_a_type_member, ts2.tokenToString(modifier.kind));
              }
              if (node.kind === 167) {
                return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_cannot_appear_on_an_index_signature, ts2.tokenToString(modifier.kind));
              }
            }
            switch (modifier.kind) {
              case 81:
                if (node.kind !== 248) {
                  return grammarErrorOnNode(node, ts2.Diagnostics.A_class_member_cannot_have_the_0_keyword, ts2.tokenToString(81));
                }
                break;
              case 119:
              case 118:
              case 117:
                var text = visibilityToString(ts2.modifierToFlag(modifier.kind));
                if (flags & 28) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics.Accessibility_modifier_already_seen);
                } else if (flags & 32) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_must_precede_1_modifier, text, "static");
                } else if (flags & 64) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_must_precede_1_modifier, text, "readonly");
                } else if (flags & 256) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_must_precede_1_modifier, text, "async");
                } else if (node.parent.kind === 250 || node.parent.kind === 290) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element, text);
                } else if (flags & 128) {
                  if (modifier.kind === 117) {
                    return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, text, "abstract");
                  } else {
                    return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_must_precede_1_modifier, text, "abstract");
                  }
                } else if (ts2.isPrivateIdentifierPropertyDeclaration(node)) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics.An_accessibility_modifier_cannot_be_used_with_a_private_identifier);
                }
                flags |= ts2.modifierToFlag(modifier.kind);
                break;
              case 120:
                if (flags & 32) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_already_seen, "static");
                } else if (flags & 64) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_must_precede_1_modifier, "static", "readonly");
                } else if (flags & 256) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_must_precede_1_modifier, "static", "async");
                } else if (node.parent.kind === 250 || node.parent.kind === 290) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element, "static");
                } else if (node.kind === 156) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "static");
                } else if (flags & 128) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "static", "abstract");
                } else if (ts2.isPrivateIdentifierPropertyDeclaration(node)) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_cannot_be_used_with_a_private_identifier, "static");
                }
                flags |= 32;
                lastStatic = modifier;
                break;
              case 138:
                if (flags & 64) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_already_seen, "readonly");
                } else if (node.kind !== 159 && node.kind !== 158 && node.kind !== 167 && node.kind !== 156) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics.readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature);
                }
                flags |= 64;
                lastReadonly = modifier;
                break;
              case 89:
                if (flags & 1) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_already_seen, "export");
                } else if (flags & 2) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_must_precede_1_modifier, "export", "declare");
                } else if (flags & 128) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_must_precede_1_modifier, "export", "abstract");
                } else if (flags & 256) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_must_precede_1_modifier, "export", "async");
                } else if (ts2.isClassLike(node.parent)) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_cannot_appear_on_a_class_element, "export");
                } else if (node.kind === 156) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "export");
                }
                flags |= 1;
                break;
              case 84:
                var container = node.parent.kind === 290 ? node.parent : node.parent.parent;
                if (container.kind === 249 && !ts2.isAmbientModule(container)) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics.A_default_export_can_only_be_used_in_an_ECMAScript_style_module);
                }
                flags |= 512;
                break;
              case 130:
                if (flags & 2) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_already_seen, "declare");
                } else if (flags & 256) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context, "async");
                } else if (ts2.isClassLike(node.parent) && !ts2.isPropertyDeclaration(node)) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_cannot_appear_on_a_class_element, "declare");
                } else if (node.kind === 156) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "declare");
                } else if (node.parent.flags & 8388608 && node.parent.kind === 250) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics.A_declare_modifier_cannot_be_used_in_an_already_ambient_context);
                } else if (ts2.isPrivateIdentifierPropertyDeclaration(node)) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_cannot_be_used_with_a_private_identifier, "declare");
                }
                flags |= 2;
                lastDeclare = modifier;
                break;
              case 122:
                if (flags & 128) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_already_seen, "abstract");
                }
                if (node.kind !== 245) {
                  if (node.kind !== 161 && node.kind !== 159 && node.kind !== 163 && node.kind !== 164) {
                    return grammarErrorOnNode(modifier, ts2.Diagnostics.abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration);
                  }
                  if (!(node.parent.kind === 245 && ts2.hasModifier(node.parent, 128))) {
                    return grammarErrorOnNode(modifier, ts2.Diagnostics.Abstract_methods_can_only_appear_within_an_abstract_class);
                  }
                  if (flags & 32) {
                    return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "static", "abstract");
                  }
                  if (flags & 8) {
                    return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "private", "abstract");
                  }
                }
                if (ts2.isNamedDeclaration(node) && node.name.kind === 76) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_cannot_be_used_with_a_private_identifier, "abstract");
                }
                flags |= 128;
                break;
              case 126:
                if (flags & 256) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_already_seen, "async");
                } else if (flags & 2 || node.parent.flags & 8388608) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context, "async");
                } else if (node.kind === 156) {
                  return grammarErrorOnNode(modifier, ts2.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "async");
                }
                flags |= 256;
                lastAsync = modifier;
                break;
            }
          }
          if (node.kind === 162) {
            if (flags & 32) {
              return grammarErrorOnNode(lastStatic, ts2.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "static");
            }
            if (flags & 128) {
              return grammarErrorOnNode(lastStatic, ts2.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "abstract");
            } else if (flags & 256) {
              return grammarErrorOnNode(lastAsync, ts2.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "async");
            } else if (flags & 64) {
              return grammarErrorOnNode(lastReadonly, ts2.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "readonly");
            }
            return false;
          } else if ((node.kind === 254 || node.kind === 253) && flags & 2) {
            return grammarErrorOnNode(lastDeclare, ts2.Diagnostics.A_0_modifier_cannot_be_used_with_an_import_declaration, "declare");
          } else if (node.kind === 156 && flags & 92 && ts2.isBindingPattern(node.name)) {
            return grammarErrorOnNode(node, ts2.Diagnostics.A_parameter_property_may_not_be_declared_using_a_binding_pattern);
          } else if (node.kind === 156 && flags & 92 && node.dotDotDotToken) {
            return grammarErrorOnNode(node, ts2.Diagnostics.A_parameter_property_cannot_be_declared_using_a_rest_parameter);
          }
          if (flags & 256) {
            return checkGrammarAsyncModifier(node, lastAsync);
          }
          return false;
        }
        function reportObviousModifierErrors(node) {
          return !node.modifiers ? false : shouldReportBadModifier(node) ? grammarErrorOnFirstToken(node, ts2.Diagnostics.Modifiers_cannot_appear_here) : void 0;
        }
        function shouldReportBadModifier(node) {
          switch (node.kind) {
            case 163:
            case 164:
            case 162:
            case 159:
            case 158:
            case 161:
            case 160:
            case 167:
            case 249:
            case 254:
            case 253:
            case 260:
            case 259:
            case 201:
            case 202:
            case 156:
              return false;
            default:
              if (node.parent.kind === 250 || node.parent.kind === 290) {
                return false;
              }
              switch (node.kind) {
                case 244:
                  return nodeHasAnyModifiersExcept(node, 126);
                case 245:
                  return nodeHasAnyModifiersExcept(node, 122);
                case 246:
                case 225:
                case 247:
                  return true;
                case 248:
                  return nodeHasAnyModifiersExcept(node, 81);
                default:
                  ts2.Debug.fail();
                  return false;
              }
          }
        }
        function nodeHasAnyModifiersExcept(node, allowedModifier) {
          return node.modifiers.length > 1 || node.modifiers[0].kind !== allowedModifier;
        }
        function checkGrammarAsyncModifier(node, asyncModifier) {
          switch (node.kind) {
            case 161:
            case 244:
            case 201:
            case 202:
              return false;
          }
          return grammarErrorOnNode(asyncModifier, ts2.Diagnostics._0_modifier_cannot_be_used_here, "async");
        }
        function checkGrammarForDisallowedTrailingComma(list, diag) {
          if (diag === void 0) {
            diag = ts2.Diagnostics.Trailing_comma_not_allowed;
          }
          if (list && list.hasTrailingComma) {
            return grammarErrorAtPos(list[0], list.end - ",".length, ",".length, diag);
          }
          return false;
        }
        function checkGrammarTypeParameterList(typeParameters, file) {
          if (typeParameters && typeParameters.length === 0) {
            var start = typeParameters.pos - "<".length;
            var end = ts2.skipTrivia(file.text, typeParameters.end) + ">".length;
            return grammarErrorAtPos(file, start, end - start, ts2.Diagnostics.Type_parameter_list_cannot_be_empty);
          }
          return false;
        }
        function checkGrammarParameterList(parameters) {
          var seenOptionalParameter = false;
          var parameterCount = parameters.length;
          for (var i = 0; i < parameterCount; i++) {
            var parameter = parameters[i];
            if (parameter.dotDotDotToken) {
              if (i !== parameterCount - 1) {
                return grammarErrorOnNode(parameter.dotDotDotToken, ts2.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);
              }
              if (!(parameter.flags & 8388608)) {
                checkGrammarForDisallowedTrailingComma(parameters, ts2.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);
              }
              if (parameter.questionToken) {
                return grammarErrorOnNode(parameter.questionToken, ts2.Diagnostics.A_rest_parameter_cannot_be_optional);
              }
              if (parameter.initializer) {
                return grammarErrorOnNode(parameter.name, ts2.Diagnostics.A_rest_parameter_cannot_have_an_initializer);
              }
            } else if (parameter.questionToken) {
              seenOptionalParameter = true;
              if (parameter.initializer) {
                return grammarErrorOnNode(parameter.name, ts2.Diagnostics.Parameter_cannot_have_question_mark_and_initializer);
              }
            } else if (seenOptionalParameter && !parameter.initializer) {
              return grammarErrorOnNode(parameter.name, ts2.Diagnostics.A_required_parameter_cannot_follow_an_optional_parameter);
            }
          }
        }
        function getNonSimpleParameters(parameters) {
          return ts2.filter(parameters, function(parameter) {
            return !!parameter.initializer || ts2.isBindingPattern(parameter.name) || ts2.isRestParameter(parameter);
          });
        }
        function checkGrammarForUseStrictSimpleParameterList(node) {
          if (languageVersion >= 3) {
            var useStrictDirective_1 = node.body && ts2.isBlock(node.body) && ts2.findUseStrictPrologue(node.body.statements);
            if (useStrictDirective_1) {
              var nonSimpleParameters = getNonSimpleParameters(node.parameters);
              if (ts2.length(nonSimpleParameters)) {
                ts2.forEach(nonSimpleParameters, function(parameter) {
                  ts2.addRelatedInfo(error(parameter, ts2.Diagnostics.This_parameter_is_not_allowed_with_use_strict_directive), ts2.createDiagnosticForNode(useStrictDirective_1, ts2.Diagnostics.use_strict_directive_used_here));
                });
                var diagnostics_1 = nonSimpleParameters.map(function(parameter, index) {
                  return index === 0 ? ts2.createDiagnosticForNode(parameter, ts2.Diagnostics.Non_simple_parameter_declared_here) : ts2.createDiagnosticForNode(parameter, ts2.Diagnostics.and_here);
                });
                ts2.addRelatedInfo.apply(void 0, __spreadArrays([error(useStrictDirective_1, ts2.Diagnostics.use_strict_directive_cannot_be_used_with_non_simple_parameter_list)], diagnostics_1));
                return true;
              }
            }
          }
          return false;
        }
        function checkGrammarFunctionLikeDeclaration(node) {
          var file = ts2.getSourceFileOfNode(node);
          return checkGrammarDecoratorsAndModifiers(node) || checkGrammarTypeParameterList(node.typeParameters, file) || checkGrammarParameterList(node.parameters) || checkGrammarArrowFunction(node, file) || ts2.isFunctionLikeDeclaration(node) && checkGrammarForUseStrictSimpleParameterList(node);
        }
        function checkGrammarClassLikeDeclaration(node) {
          var file = ts2.getSourceFileOfNode(node);
          return checkGrammarClassDeclarationHeritageClauses(node) || checkGrammarTypeParameterList(node.typeParameters, file);
        }
        function checkGrammarArrowFunction(node, file) {
          if (!ts2.isArrowFunction(node)) {
            return false;
          }
          var equalsGreaterThanToken = node.equalsGreaterThanToken;
          var startLine = ts2.getLineAndCharacterOfPosition(file, equalsGreaterThanToken.pos).line;
          var endLine = ts2.getLineAndCharacterOfPosition(file, equalsGreaterThanToken.end).line;
          return startLine !== endLine && grammarErrorOnNode(equalsGreaterThanToken, ts2.Diagnostics.Line_terminator_not_permitted_before_arrow);
        }
        function checkGrammarIndexSignatureParameters(node) {
          var parameter = node.parameters[0];
          if (node.parameters.length !== 1) {
            if (parameter) {
              return grammarErrorOnNode(parameter.name, ts2.Diagnostics.An_index_signature_must_have_exactly_one_parameter);
            } else {
              return grammarErrorOnNode(node, ts2.Diagnostics.An_index_signature_must_have_exactly_one_parameter);
            }
          }
          checkGrammarForDisallowedTrailingComma(node.parameters, ts2.Diagnostics.An_index_signature_cannot_have_a_trailing_comma);
          if (parameter.dotDotDotToken) {
            return grammarErrorOnNode(parameter.dotDotDotToken, ts2.Diagnostics.An_index_signature_cannot_have_a_rest_parameter);
          }
          if (ts2.hasModifiers(parameter)) {
            return grammarErrorOnNode(parameter.name, ts2.Diagnostics.An_index_signature_parameter_cannot_have_an_accessibility_modifier);
          }
          if (parameter.questionToken) {
            return grammarErrorOnNode(parameter.questionToken, ts2.Diagnostics.An_index_signature_parameter_cannot_have_a_question_mark);
          }
          if (parameter.initializer) {
            return grammarErrorOnNode(parameter.name, ts2.Diagnostics.An_index_signature_parameter_cannot_have_an_initializer);
          }
          if (!parameter.type) {
            return grammarErrorOnNode(parameter.name, ts2.Diagnostics.An_index_signature_parameter_must_have_a_type_annotation);
          }
          if (parameter.type.kind !== 143 && parameter.type.kind !== 140) {
            var type = getTypeFromTypeNode(parameter.type);
            if (type.flags & 4 || type.flags & 8) {
              return grammarErrorOnNode(parameter.name, ts2.Diagnostics.An_index_signature_parameter_type_cannot_be_a_type_alias_Consider_writing_0_Colon_1_Colon_2_instead, ts2.getTextOfNode(parameter.name), typeToString(type), typeToString(node.type ? getTypeFromTypeNode(node.type) : anyType));
            }
            if (type.flags & 1048576 && allTypesAssignableToKind(type, 384, true)) {
              return grammarErrorOnNode(parameter.name, ts2.Diagnostics.An_index_signature_parameter_type_cannot_be_a_union_type_Consider_using_a_mapped_object_type_instead);
            }
            return grammarErrorOnNode(parameter.name, ts2.Diagnostics.An_index_signature_parameter_type_must_be_either_string_or_number);
          }
          if (!node.type) {
            return grammarErrorOnNode(node, ts2.Diagnostics.An_index_signature_must_have_a_type_annotation);
          }
          return false;
        }
        function checkGrammarIndexSignature(node) {
          return checkGrammarDecoratorsAndModifiers(node) || checkGrammarIndexSignatureParameters(node);
        }
        function checkGrammarForAtLeastOneTypeArgument(node, typeArguments) {
          if (typeArguments && typeArguments.length === 0) {
            var sourceFile = ts2.getSourceFileOfNode(node);
            var start = typeArguments.pos - "<".length;
            var end = ts2.skipTrivia(sourceFile.text, typeArguments.end) + ">".length;
            return grammarErrorAtPos(sourceFile, start, end - start, ts2.Diagnostics.Type_argument_list_cannot_be_empty);
          }
          return false;
        }
        function checkGrammarTypeArguments(node, typeArguments) {
          return checkGrammarForDisallowedTrailingComma(typeArguments) || checkGrammarForAtLeastOneTypeArgument(node, typeArguments);
        }
        function checkGrammarTaggedTemplateChain(node) {
          if (node.questionDotToken || node.flags & 32) {
            return grammarErrorOnNode(node.template, ts2.Diagnostics.Tagged_template_expressions_are_not_permitted_in_an_optional_chain);
          }
          return false;
        }
        function checkGrammarForOmittedArgument(args) {
          if (args) {
            for (var _i = 0, args_4 = args; _i < args_4.length; _i++) {
              var arg = args_4[_i];
              if (arg.kind === 215) {
                return grammarErrorAtPos(arg, arg.pos, 0, ts2.Diagnostics.Argument_expression_expected);
              }
            }
          }
          return false;
        }
        function checkGrammarArguments(args) {
          return checkGrammarForOmittedArgument(args);
        }
        function checkGrammarHeritageClause(node) {
          var types = node.types;
          if (checkGrammarForDisallowedTrailingComma(types)) {
            return true;
          }
          if (types && types.length === 0) {
            var listType = ts2.tokenToString(node.token);
            return grammarErrorAtPos(node, types.pos, 0, ts2.Diagnostics._0_list_cannot_be_empty, listType);
          }
          return ts2.some(types, checkGrammarExpressionWithTypeArguments);
        }
        function checkGrammarExpressionWithTypeArguments(node) {
          return checkGrammarTypeArguments(node, node.typeArguments);
        }
        function checkGrammarClassDeclarationHeritageClauses(node) {
          var seenExtendsClause = false;
          var seenImplementsClause = false;
          if (!checkGrammarDecoratorsAndModifiers(node) && node.heritageClauses) {
            for (var _i = 0, _a = node.heritageClauses; _i < _a.length; _i++) {
              var heritageClause = _a[_i];
              if (heritageClause.token === 90) {
                if (seenExtendsClause) {
                  return grammarErrorOnFirstToken(heritageClause, ts2.Diagnostics.extends_clause_already_seen);
                }
                if (seenImplementsClause) {
                  return grammarErrorOnFirstToken(heritageClause, ts2.Diagnostics.extends_clause_must_precede_implements_clause);
                }
                if (heritageClause.types.length > 1) {
                  return grammarErrorOnFirstToken(heritageClause.types[1], ts2.Diagnostics.Classes_can_only_extend_a_single_class);
                }
                seenExtendsClause = true;
              } else {
                ts2.Debug.assert(heritageClause.token === 113);
                if (seenImplementsClause) {
                  return grammarErrorOnFirstToken(heritageClause, ts2.Diagnostics.implements_clause_already_seen);
                }
                seenImplementsClause = true;
              }
              checkGrammarHeritageClause(heritageClause);
            }
          }
        }
        function checkGrammarInterfaceDeclaration(node) {
          var seenExtendsClause = false;
          if (node.heritageClauses) {
            for (var _i = 0, _a = node.heritageClauses; _i < _a.length; _i++) {
              var heritageClause = _a[_i];
              if (heritageClause.token === 90) {
                if (seenExtendsClause) {
                  return grammarErrorOnFirstToken(heritageClause, ts2.Diagnostics.extends_clause_already_seen);
                }
                seenExtendsClause = true;
              } else {
                ts2.Debug.assert(heritageClause.token === 113);
                return grammarErrorOnFirstToken(heritageClause, ts2.Diagnostics.Interface_declaration_cannot_have_implements_clause);
              }
              checkGrammarHeritageClause(heritageClause);
            }
          }
          return false;
        }
        function checkGrammarComputedPropertyName(node) {
          if (node.kind !== 154) {
            return false;
          }
          var computedPropertyName = node;
          if (computedPropertyName.expression.kind === 209 && computedPropertyName.expression.operatorToken.kind === 27) {
            return grammarErrorOnNode(computedPropertyName.expression, ts2.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name);
          }
          return false;
        }
        function checkGrammarForGenerator(node) {
          if (node.asteriskToken) {
            ts2.Debug.assert(node.kind === 244 || node.kind === 201 || node.kind === 161);
            if (node.flags & 8388608) {
              return grammarErrorOnNode(node.asteriskToken, ts2.Diagnostics.Generators_are_not_allowed_in_an_ambient_context);
            }
            if (!node.body) {
              return grammarErrorOnNode(node.asteriskToken, ts2.Diagnostics.An_overload_signature_cannot_be_declared_as_a_generator);
            }
          }
        }
        function checkGrammarForInvalidQuestionMark(questionToken, message) {
          return !!questionToken && grammarErrorOnNode(questionToken, message);
        }
        function checkGrammarForInvalidExclamationToken(exclamationToken, message) {
          return !!exclamationToken && grammarErrorOnNode(exclamationToken, message);
        }
        function checkGrammarObjectLiteralExpression(node, inDestructuring) {
          var seen = ts2.createUnderscoreEscapedMap();
          for (var _i = 0, _a = node.properties; _i < _a.length; _i++) {
            var prop = _a[_i];
            if (prop.kind === 283) {
              if (inDestructuring) {
                var expression = ts2.skipParentheses(prop.expression);
                if (ts2.isArrayLiteralExpression(expression) || ts2.isObjectLiteralExpression(expression)) {
                  return grammarErrorOnNode(prop.expression, ts2.Diagnostics.A_rest_element_cannot_contain_a_binding_pattern);
                }
              }
              continue;
            }
            var name = prop.name;
            if (name.kind === 154) {
              checkGrammarComputedPropertyName(name);
            }
            if (prop.kind === 282 && !inDestructuring && prop.objectAssignmentInitializer) {
              return grammarErrorOnNode(prop.equalsToken, ts2.Diagnostics.can_only_be_used_in_an_object_literal_property_inside_a_destructuring_assignment);
            }
            if (name.kind === 76) {
              return grammarErrorOnNode(name, ts2.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
            }
            if (prop.modifiers) {
              for (var _b = 0, _c = prop.modifiers; _b < _c.length; _b++) {
                var mod = _c[_b];
                if (mod.kind !== 126 || prop.kind !== 161) {
                  grammarErrorOnNode(mod, ts2.Diagnostics._0_modifier_cannot_be_used_here, ts2.getTextOfNode(mod));
                }
              }
            }
            var currentKind = void 0;
            switch (prop.kind) {
              case 282:
                checkGrammarForInvalidExclamationToken(prop.exclamationToken, ts2.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context);
              case 281:
                checkGrammarForInvalidQuestionMark(prop.questionToken, ts2.Diagnostics.An_object_member_cannot_be_declared_optional);
                if (name.kind === 8) {
                  checkGrammarNumericLiteral(name);
                }
                currentKind = 4;
                break;
              case 161:
                currentKind = 8;
                break;
              case 163:
                currentKind = 1;
                break;
              case 164:
                currentKind = 2;
                break;
              default:
                throw ts2.Debug.assertNever(prop, "Unexpected syntax kind:" + prop.kind);
            }
            if (!inDestructuring) {
              var effectiveName = ts2.getPropertyNameForPropertyNameNode(name);
              if (effectiveName === void 0) {
                continue;
              }
              var existingKind = seen.get(effectiveName);
              if (!existingKind) {
                seen.set(effectiveName, currentKind);
              } else {
                if (currentKind & 12 && existingKind & 12) {
                  grammarErrorOnNode(name, ts2.Diagnostics.Duplicate_identifier_0, ts2.getTextOfNode(name));
                } else if (currentKind & 3 && existingKind & 3) {
                  if (existingKind !== 3 && currentKind !== existingKind) {
                    seen.set(effectiveName, currentKind | existingKind);
                  } else {
                    return grammarErrorOnNode(name, ts2.Diagnostics.An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name);
                  }
                } else {
                  return grammarErrorOnNode(name, ts2.Diagnostics.An_object_literal_cannot_have_property_and_accessor_with_the_same_name);
                }
              }
            }
          }
        }
        function checkGrammarJsxElement(node) {
          checkGrammarTypeArguments(node, node.typeArguments);
          var seen = ts2.createUnderscoreEscapedMap();
          for (var _i = 0, _a = node.attributes.properties; _i < _a.length; _i++) {
            var attr = _a[_i];
            if (attr.kind === 275) {
              continue;
            }
            var name = attr.name, initializer = attr.initializer;
            if (!seen.get(name.escapedText)) {
              seen.set(name.escapedText, true);
            } else {
              return grammarErrorOnNode(name, ts2.Diagnostics.JSX_elements_cannot_have_multiple_attributes_with_the_same_name);
            }
            if (initializer && initializer.kind === 276 && !initializer.expression) {
              return grammarErrorOnNode(initializer, ts2.Diagnostics.JSX_attributes_must_only_be_assigned_a_non_empty_expression);
            }
          }
        }
        function checkGrammarJsxExpression(node) {
          if (node.expression && ts2.isCommaSequence(node.expression)) {
            return grammarErrorOnNode(node.expression, ts2.Diagnostics.JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array);
          }
        }
        function checkGrammarForInOrForOfStatement(forInOrOfStatement) {
          if (checkGrammarStatementInAmbientContext(forInOrOfStatement)) {
            return true;
          }
          if (forInOrOfStatement.kind === 232 && forInOrOfStatement.awaitModifier) {
            if ((forInOrOfStatement.flags & 32768) === 0) {
              var sourceFile = ts2.getSourceFileOfNode(forInOrOfStatement);
              if (!hasParseDiagnostics(sourceFile)) {
                var diagnostic = ts2.createDiagnosticForNode(forInOrOfStatement.awaitModifier, ts2.Diagnostics.A_for_await_of_statement_is_only_allowed_within_an_async_function_or_async_generator);
                var func = ts2.getContainingFunction(forInOrOfStatement);
                if (func && func.kind !== 162) {
                  ts2.Debug.assert((ts2.getFunctionFlags(func) & 2) === 0, "Enclosing function should never be an async function.");
                  var relatedInfo = ts2.createDiagnosticForNode(func, ts2.Diagnostics.Did_you_mean_to_mark_this_function_as_async);
                  ts2.addRelatedInfo(diagnostic, relatedInfo);
                }
                diagnostics.add(diagnostic);
                return true;
              }
              return false;
            }
          }
          if (forInOrOfStatement.initializer.kind === 243) {
            var variableList = forInOrOfStatement.initializer;
            if (!checkGrammarVariableDeclarationList(variableList)) {
              var declarations = variableList.declarations;
              if (!declarations.length) {
                return false;
              }
              if (declarations.length > 1) {
                var diagnostic = forInOrOfStatement.kind === 231 ? ts2.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement : ts2.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement;
                return grammarErrorOnFirstToken(variableList.declarations[1], diagnostic);
              }
              var firstDeclaration = declarations[0];
              if (firstDeclaration.initializer) {
                var diagnostic = forInOrOfStatement.kind === 231 ? ts2.Diagnostics.The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer : ts2.Diagnostics.The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer;
                return grammarErrorOnNode(firstDeclaration.name, diagnostic);
              }
              if (firstDeclaration.type) {
                var diagnostic = forInOrOfStatement.kind === 231 ? ts2.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation : ts2.Diagnostics.The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation;
                return grammarErrorOnNode(firstDeclaration, diagnostic);
              }
            }
          }
          return false;
        }
        function checkGrammarAccessor(accessor) {
          if (!(accessor.flags & 8388608)) {
            if (languageVersion < 1) {
              return grammarErrorOnNode(accessor.name, ts2.Diagnostics.Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher);
            }
            if (accessor.body === void 0 && !ts2.hasModifier(accessor, 128)) {
              return grammarErrorAtPos(accessor, accessor.end - 1, ";".length, ts2.Diagnostics._0_expected, "{");
            }
          }
          if (accessor.body && ts2.hasModifier(accessor, 128)) {
            return grammarErrorOnNode(accessor, ts2.Diagnostics.An_abstract_accessor_cannot_have_an_implementation);
          }
          if (accessor.typeParameters) {
            return grammarErrorOnNode(accessor.name, ts2.Diagnostics.An_accessor_cannot_have_type_parameters);
          }
          if (!doesAccessorHaveCorrectParameterCount(accessor)) {
            return grammarErrorOnNode(accessor.name, accessor.kind === 163 ? ts2.Diagnostics.A_get_accessor_cannot_have_parameters : ts2.Diagnostics.A_set_accessor_must_have_exactly_one_parameter);
          }
          if (accessor.kind === 164) {
            if (accessor.type) {
              return grammarErrorOnNode(accessor.name, ts2.Diagnostics.A_set_accessor_cannot_have_a_return_type_annotation);
            }
            var parameter = ts2.Debug.checkDefined(ts2.getSetAccessorValueParameter(accessor), "Return value does not match parameter count assertion.");
            if (parameter.dotDotDotToken) {
              return grammarErrorOnNode(parameter.dotDotDotToken, ts2.Diagnostics.A_set_accessor_cannot_have_rest_parameter);
            }
            if (parameter.questionToken) {
              return grammarErrorOnNode(parameter.questionToken, ts2.Diagnostics.A_set_accessor_cannot_have_an_optional_parameter);
            }
            if (parameter.initializer) {
              return grammarErrorOnNode(accessor.name, ts2.Diagnostics.A_set_accessor_parameter_cannot_have_an_initializer);
            }
          }
          return false;
        }
        function doesAccessorHaveCorrectParameterCount(accessor) {
          return getAccessorThisParameter(accessor) || accessor.parameters.length === (accessor.kind === 163 ? 0 : 1);
        }
        function getAccessorThisParameter(accessor) {
          if (accessor.parameters.length === (accessor.kind === 163 ? 1 : 2)) {
            return ts2.getThisParameter(accessor);
          }
        }
        function checkGrammarTypeOperatorNode(node) {
          if (node.operator === 147) {
            if (node.type.kind !== 144) {
              return grammarErrorOnNode(node.type, ts2.Diagnostics._0_expected, ts2.tokenToString(144));
            }
            var parent = ts2.walkUpParenthesizedTypes(node.parent);
            switch (parent.kind) {
              case 242:
                var decl = parent;
                if (decl.name.kind !== 75) {
                  return grammarErrorOnNode(node, ts2.Diagnostics.unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name);
                }
                if (!ts2.isVariableDeclarationInVariableStatement(decl)) {
                  return grammarErrorOnNode(node, ts2.Diagnostics.unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement);
                }
                if (!(decl.parent.flags & 2)) {
                  return grammarErrorOnNode(parent.name, ts2.Diagnostics.A_variable_whose_type_is_a_unique_symbol_type_must_be_const);
                }
                break;
              case 159:
                if (!ts2.hasModifier(parent, 32) || !ts2.hasModifier(parent, 64)) {
                  return grammarErrorOnNode(parent.name, ts2.Diagnostics.A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly);
                }
                break;
              case 158:
                if (!ts2.hasModifier(parent, 64)) {
                  return grammarErrorOnNode(parent.name, ts2.Diagnostics.A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly);
                }
                break;
              default:
                return grammarErrorOnNode(node, ts2.Diagnostics.unique_symbol_types_are_not_allowed_here);
            }
          } else if (node.operator === 138) {
            if (node.type.kind !== 174 && node.type.kind !== 175) {
              return grammarErrorOnFirstToken(node, ts2.Diagnostics.readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types, ts2.tokenToString(144));
            }
          }
        }
        function checkGrammarForInvalidDynamicName(node, message) {
          if (isNonBindableDynamicName(node)) {
            return grammarErrorOnNode(node, message);
          }
        }
        function checkGrammarMethod(node) {
          if (checkGrammarFunctionLikeDeclaration(node)) {
            return true;
          }
          if (node.kind === 161) {
            if (node.parent.kind === 193) {
              if (node.modifiers && !(node.modifiers.length === 1 && ts2.first(node.modifiers).kind === 126)) {
                return grammarErrorOnFirstToken(node, ts2.Diagnostics.Modifiers_cannot_appear_here);
              } else if (checkGrammarForInvalidQuestionMark(node.questionToken, ts2.Diagnostics.An_object_member_cannot_be_declared_optional)) {
                return true;
              } else if (checkGrammarForInvalidExclamationToken(node.exclamationToken, ts2.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context)) {
                return true;
              } else if (node.body === void 0) {
                return grammarErrorAtPos(node, node.end - 1, ";".length, ts2.Diagnostics._0_expected, "{");
              }
            }
            if (checkGrammarForGenerator(node)) {
              return true;
            }
          }
          if (ts2.isClassLike(node.parent)) {
            if (node.flags & 8388608) {
              return checkGrammarForInvalidDynamicName(node.name, ts2.Diagnostics.A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
            } else if (node.kind === 161 && !node.body) {
              return checkGrammarForInvalidDynamicName(node.name, ts2.Diagnostics.A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
            }
          } else if (node.parent.kind === 246) {
            return checkGrammarForInvalidDynamicName(node.name, ts2.Diagnostics.A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
          } else if (node.parent.kind === 173) {
            return checkGrammarForInvalidDynamicName(node.name, ts2.Diagnostics.A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
          }
        }
        function checkGrammarBreakOrContinueStatement(node) {
          var current = node;
          while (current) {
            if (ts2.isFunctionLike(current)) {
              return grammarErrorOnNode(node, ts2.Diagnostics.Jump_target_cannot_cross_function_boundary);
            }
            switch (current.kind) {
              case 238:
                if (node.label && current.label.escapedText === node.label.escapedText) {
                  var isMisplacedContinueLabel = node.kind === 233 && !ts2.isIterationStatement(current.statement, true);
                  if (isMisplacedContinueLabel) {
                    return grammarErrorOnNode(node, ts2.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement);
                  }
                  return false;
                }
                break;
              case 237:
                if (node.kind === 234 && !node.label) {
                  return false;
                }
                break;
              default:
                if (ts2.isIterationStatement(current, false) && !node.label) {
                  return false;
                }
                break;
            }
            current = current.parent;
          }
          if (node.label) {
            var message = node.kind === 234 ? ts2.Diagnostics.A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement : ts2.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement;
            return grammarErrorOnNode(node, message);
          } else {
            var message = node.kind === 234 ? ts2.Diagnostics.A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement : ts2.Diagnostics.A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement;
            return grammarErrorOnNode(node, message);
          }
        }
        function checkGrammarBindingElement(node) {
          if (node.dotDotDotToken) {
            var elements = node.parent.elements;
            if (node !== ts2.last(elements)) {
              return grammarErrorOnNode(node, ts2.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);
            }
            checkGrammarForDisallowedTrailingComma(elements, ts2.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);
            if (node.propertyName) {
              return grammarErrorOnNode(node.name, ts2.Diagnostics.A_rest_element_cannot_have_a_property_name);
            }
            if (node.initializer) {
              return grammarErrorAtPos(node, node.initializer.pos - 1, 1, ts2.Diagnostics.A_rest_element_cannot_have_an_initializer);
            }
          }
        }
        function isStringOrNumberLiteralExpression(expr) {
          return ts2.isStringOrNumericLiteralLike(expr) || expr.kind === 207 && expr.operator === 40 && expr.operand.kind === 8;
        }
        function isBigIntLiteralExpression(expr) {
          return expr.kind === 9 || expr.kind === 207 && expr.operator === 40 && expr.operand.kind === 9;
        }
        function isSimpleLiteralEnumReference(expr) {
          if ((ts2.isPropertyAccessExpression(expr) || ts2.isElementAccessExpression(expr) && isStringOrNumberLiteralExpression(expr.argumentExpression)) && ts2.isEntityNameExpression(expr.expression)) {
            return !!(checkExpressionCached(expr).flags & 1024);
          }
        }
        function checkAmbientInitializer(node) {
          var initializer = node.initializer;
          if (initializer) {
            var isInvalidInitializer = !(isStringOrNumberLiteralExpression(initializer) || isSimpleLiteralEnumReference(initializer) || initializer.kind === 106 || initializer.kind === 91 || isBigIntLiteralExpression(initializer));
            var isConstOrReadonly = ts2.isDeclarationReadonly(node) || ts2.isVariableDeclaration(node) && ts2.isVarConst(node);
            if (isConstOrReadonly && !node.type) {
              if (isInvalidInitializer) {
                return grammarErrorOnNode(initializer, ts2.Diagnostics.A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_reference);
              }
            } else {
              return grammarErrorOnNode(initializer, ts2.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts);
            }
            if (!isConstOrReadonly || isInvalidInitializer) {
              return grammarErrorOnNode(initializer, ts2.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts);
            }
          }
        }
        function checkGrammarVariableDeclaration(node) {
          if (node.parent.parent.kind !== 231 && node.parent.parent.kind !== 232) {
            if (node.flags & 8388608) {
              checkAmbientInitializer(node);
            } else if (!node.initializer) {
              if (ts2.isBindingPattern(node.name) && !ts2.isBindingPattern(node.parent)) {
                return grammarErrorOnNode(node, ts2.Diagnostics.A_destructuring_declaration_must_have_an_initializer);
              }
              if (ts2.isVarConst(node)) {
                return grammarErrorOnNode(node, ts2.Diagnostics.const_declarations_must_be_initialized);
              }
            }
          }
          if (node.exclamationToken && (node.parent.parent.kind !== 225 || !node.type || node.initializer || node.flags & 8388608)) {
            return grammarErrorOnNode(node.exclamationToken, ts2.Diagnostics.Definite_assignment_assertions_can_only_be_used_along_with_a_type_annotation);
          }
          var moduleKind2 = ts2.getEmitModuleKind(compilerOptions);
          if (moduleKind2 < ts2.ModuleKind.ES2015 && moduleKind2 !== ts2.ModuleKind.System && !compilerOptions.noEmit && !(node.parent.parent.flags & 8388608) && ts2.hasModifier(node.parent.parent, 1)) {
            checkESModuleMarker(node.name);
          }
          var checkLetConstNames = ts2.isLet(node) || ts2.isVarConst(node);
          return checkLetConstNames && checkGrammarNameInLetOrConstDeclarations(node.name);
        }
        function checkESModuleMarker(name) {
          if (name.kind === 75) {
            if (ts2.idText(name) === "__esModule") {
              return grammarErrorOnNode(name, ts2.Diagnostics.Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules);
            }
          } else {
            var elements = name.elements;
            for (var _i = 0, elements_1 = elements; _i < elements_1.length; _i++) {
              var element = elements_1[_i];
              if (!ts2.isOmittedExpression(element)) {
                return checkESModuleMarker(element.name);
              }
            }
          }
          return false;
        }
        function checkGrammarNameInLetOrConstDeclarations(name) {
          if (name.kind === 75) {
            if (name.originalKeywordKind === 115) {
              return grammarErrorOnNode(name, ts2.Diagnostics.let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations);
            }
          } else {
            var elements = name.elements;
            for (var _i = 0, elements_2 = elements; _i < elements_2.length; _i++) {
              var element = elements_2[_i];
              if (!ts2.isOmittedExpression(element)) {
                checkGrammarNameInLetOrConstDeclarations(element.name);
              }
            }
          }
          return false;
        }
        function checkGrammarVariableDeclarationList(declarationList) {
          var declarations = declarationList.declarations;
          if (checkGrammarForDisallowedTrailingComma(declarationList.declarations)) {
            return true;
          }
          if (!declarationList.declarations.length) {
            return grammarErrorAtPos(declarationList, declarations.pos, declarations.end - declarations.pos, ts2.Diagnostics.Variable_declaration_list_cannot_be_empty);
          }
          return false;
        }
        function allowLetAndConstDeclarations(parent) {
          switch (parent.kind) {
            case 227:
            case 228:
            case 229:
            case 236:
            case 230:
            case 231:
            case 232:
              return false;
            case 238:
              return allowLetAndConstDeclarations(parent.parent);
          }
          return true;
        }
        function checkGrammarForDisallowedLetOrConstStatement(node) {
          if (!allowLetAndConstDeclarations(node.parent)) {
            if (ts2.isLet(node.declarationList)) {
              return grammarErrorOnNode(node, ts2.Diagnostics.let_declarations_can_only_be_declared_inside_a_block);
            } else if (ts2.isVarConst(node.declarationList)) {
              return grammarErrorOnNode(node, ts2.Diagnostics.const_declarations_can_only_be_declared_inside_a_block);
            }
          }
        }
        function checkGrammarMetaProperty(node) {
          var escapedText = node.name.escapedText;
          switch (node.keywordToken) {
            case 99:
              if (escapedText !== "target") {
                return grammarErrorOnNode(node.name, ts2.Diagnostics._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2, node.name.escapedText, ts2.tokenToString(node.keywordToken), "target");
              }
              break;
            case 96:
              if (escapedText !== "meta") {
                return grammarErrorOnNode(node.name, ts2.Diagnostics._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2, node.name.escapedText, ts2.tokenToString(node.keywordToken), "meta");
              }
              break;
          }
        }
        function hasParseDiagnostics(sourceFile) {
          return sourceFile.parseDiagnostics.length > 0;
        }
        function grammarErrorOnFirstToken(node, message, arg0, arg1, arg2) {
          var sourceFile = ts2.getSourceFileOfNode(node);
          if (!hasParseDiagnostics(sourceFile)) {
            var span = ts2.getSpanOfTokenAtPosition(sourceFile, node.pos);
            diagnostics.add(ts2.createFileDiagnostic(sourceFile, span.start, span.length, message, arg0, arg1, arg2));
            return true;
          }
          return false;
        }
        function grammarErrorAtPos(nodeForSourceFile, start, length, message, arg0, arg1, arg2) {
          var sourceFile = ts2.getSourceFileOfNode(nodeForSourceFile);
          if (!hasParseDiagnostics(sourceFile)) {
            diagnostics.add(ts2.createFileDiagnostic(sourceFile, start, length, message, arg0, arg1, arg2));
            return true;
          }
          return false;
        }
        function grammarErrorOnNode(node, message, arg0, arg1, arg2) {
          var sourceFile = ts2.getSourceFileOfNode(node);
          if (!hasParseDiagnostics(sourceFile)) {
            diagnostics.add(ts2.createDiagnosticForNode(node, message, arg0, arg1, arg2));
            return true;
          }
          return false;
        }
        function checkGrammarConstructorTypeParameters(node) {
          var jsdocTypeParameters = ts2.isInJSFile(node) ? ts2.getJSDocTypeParameterDeclarations(node) : void 0;
          var range = node.typeParameters || jsdocTypeParameters && ts2.firstOrUndefined(jsdocTypeParameters);
          if (range) {
            var pos = range.pos === range.end ? range.pos : ts2.skipTrivia(ts2.getSourceFileOfNode(node).text, range.pos);
            return grammarErrorAtPos(node, pos, range.end - pos, ts2.Diagnostics.Type_parameters_cannot_appear_on_a_constructor_declaration);
          }
        }
        function checkGrammarConstructorTypeAnnotation(node) {
          var type = ts2.getEffectiveReturnTypeNode(node);
          if (type) {
            return grammarErrorOnNode(type, ts2.Diagnostics.Type_annotation_cannot_appear_on_a_constructor_declaration);
          }
        }
        function checkGrammarProperty(node) {
          if (ts2.isClassLike(node.parent)) {
            if (ts2.isStringLiteral(node.name) && node.name.text === "constructor") {
              return grammarErrorOnNode(node.name, ts2.Diagnostics.Classes_may_not_have_a_field_named_constructor);
            }
            if (checkGrammarForInvalidDynamicName(node.name, ts2.Diagnostics.A_computed_property_name_in_a_class_property_declaration_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type)) {
              return true;
            }
            if (languageVersion < 2 && ts2.isPrivateIdentifier(node.name)) {
              return grammarErrorOnNode(node.name, ts2.Diagnostics.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);
            }
          } else if (node.parent.kind === 246) {
            if (checkGrammarForInvalidDynamicName(node.name, ts2.Diagnostics.A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type)) {
              return true;
            }
            if (node.initializer) {
              return grammarErrorOnNode(node.initializer, ts2.Diagnostics.An_interface_property_cannot_have_an_initializer);
            }
          } else if (node.parent.kind === 173) {
            if (checkGrammarForInvalidDynamicName(node.name, ts2.Diagnostics.A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type)) {
              return true;
            }
            if (node.initializer) {
              return grammarErrorOnNode(node.initializer, ts2.Diagnostics.A_type_literal_property_cannot_have_an_initializer);
            }
          }
          if (node.flags & 8388608) {
            checkAmbientInitializer(node);
          }
          if (ts2.isPropertyDeclaration(node) && node.exclamationToken && (!ts2.isClassLike(node.parent) || !node.type || node.initializer || node.flags & 8388608 || ts2.hasModifier(node, 32 | 128))) {
            return grammarErrorOnNode(node.exclamationToken, ts2.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context);
          }
        }
        function checkGrammarTopLevelElementForRequiredDeclareModifier(node) {
          if (node.kind === 246 || node.kind === 247 || node.kind === 254 || node.kind === 253 || node.kind === 260 || node.kind === 259 || node.kind === 252 || ts2.hasModifier(node, 2 | 1 | 512)) {
            return false;
          }
          return grammarErrorOnFirstToken(node, ts2.Diagnostics.Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier);
        }
        function checkGrammarTopLevelElementsForRequiredDeclareModifier(file) {
          for (var _i = 0, _a = file.statements; _i < _a.length; _i++) {
            var decl = _a[_i];
            if (ts2.isDeclaration(decl) || decl.kind === 225) {
              if (checkGrammarTopLevelElementForRequiredDeclareModifier(decl)) {
                return true;
              }
            }
          }
          return false;
        }
        function checkGrammarSourceFile(node) {
          return !!(node.flags & 8388608) && checkGrammarTopLevelElementsForRequiredDeclareModifier(node);
        }
        function checkGrammarStatementInAmbientContext(node) {
          if (node.flags & 8388608) {
            var links = getNodeLinks(node);
            if (!links.hasReportedStatementInAmbientContext && (ts2.isFunctionLike(node.parent) || ts2.isAccessor(node.parent))) {
              return getNodeLinks(node).hasReportedStatementInAmbientContext = grammarErrorOnFirstToken(node, ts2.Diagnostics.An_implementation_cannot_be_declared_in_ambient_contexts);
            }
            if (node.parent.kind === 223 || node.parent.kind === 250 || node.parent.kind === 290) {
              var links_2 = getNodeLinks(node.parent);
              if (!links_2.hasReportedStatementInAmbientContext) {
                return links_2.hasReportedStatementInAmbientContext = grammarErrorOnFirstToken(node, ts2.Diagnostics.Statements_are_not_allowed_in_ambient_contexts);
              }
            } else {
            }
          }
          return false;
        }
        function checkGrammarNumericLiteral(node) {
          if (node.numericLiteralFlags & 32) {
            var diagnosticMessage = void 0;
            if (languageVersion >= 1) {
              diagnosticMessage = ts2.Diagnostics.Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0;
            } else if (ts2.isChildOfNodeWithKind(node, 187)) {
              diagnosticMessage = ts2.Diagnostics.Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0;
            } else if (ts2.isChildOfNodeWithKind(node, 284)) {
              diagnosticMessage = ts2.Diagnostics.Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0;
            }
            if (diagnosticMessage) {
              var withMinus = ts2.isPrefixUnaryExpression(node.parent) && node.parent.operator === 40;
              var literal = (withMinus ? "-" : "") + "0o" + node.text;
              return grammarErrorOnNode(withMinus ? node.parent : node, diagnosticMessage, literal);
            }
          }
          checkNumericLiteralValueSize(node);
          return false;
        }
        function checkNumericLiteralValueSize(node) {
          if (node.numericLiteralFlags & 16 || node.text.length <= 15 || node.text.indexOf(".") !== -1) {
            return;
          }
          var apparentValue = +ts2.getTextOfNode(node);
          if (apparentValue <= Math.pow(2, 53) - 1 && apparentValue + 1 > apparentValue) {
            return;
          }
          addErrorOrSuggestion(false, ts2.createDiagnosticForNode(node, ts2.Diagnostics.Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers));
        }
        function checkGrammarBigIntLiteral(node) {
          var literalType = ts2.isLiteralTypeNode(node.parent) || ts2.isPrefixUnaryExpression(node.parent) && ts2.isLiteralTypeNode(node.parent.parent);
          if (!literalType) {
            if (languageVersion < 7) {
              if (grammarErrorOnNode(node, ts2.Diagnostics.BigInt_literals_are_not_available_when_targeting_lower_than_ES2020)) {
                return true;
              }
            }
          }
          return false;
        }
        function grammarErrorAfterFirstToken(node, message, arg0, arg1, arg2) {
          var sourceFile = ts2.getSourceFileOfNode(node);
          if (!hasParseDiagnostics(sourceFile)) {
            var span = ts2.getSpanOfTokenAtPosition(sourceFile, node.pos);
            diagnostics.add(ts2.createFileDiagnostic(sourceFile, ts2.textSpanEnd(span), 0, message, arg0, arg1, arg2));
            return true;
          }
          return false;
        }
        function getAmbientModules() {
          if (!ambientModulesCache) {
            ambientModulesCache = [];
            globals.forEach(function(global2, sym) {
              if (ambientModuleSymbolRegex.test(sym)) {
                ambientModulesCache.push(global2);
              }
            });
          }
          return ambientModulesCache;
        }
        function checkGrammarImportClause(node) {
          if (node.isTypeOnly && node.name && node.namedBindings) {
            return grammarErrorOnNode(node, ts2.Diagnostics.A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both);
          }
          return false;
        }
        function checkGrammarImportCallExpression(node) {
          if (moduleKind === ts2.ModuleKind.ES2015) {
            return grammarErrorOnNode(node, ts2.Diagnostics.Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_esnext_commonjs_amd_system_or_umd);
          }
          if (node.typeArguments) {
            return grammarErrorOnNode(node, ts2.Diagnostics.Dynamic_import_cannot_have_type_arguments);
          }
          var nodeArguments = node.arguments;
          if (nodeArguments.length !== 1) {
            return grammarErrorOnNode(node, ts2.Diagnostics.Dynamic_import_must_have_one_specifier_as_an_argument);
          }
          checkGrammarForDisallowedTrailingComma(nodeArguments);
          if (ts2.isSpreadElement(nodeArguments[0])) {
            return grammarErrorOnNode(nodeArguments[0], ts2.Diagnostics.Specifier_of_dynamic_import_cannot_be_spread_element);
          }
          return false;
        }
        function findMatchingTypeReferenceOrTypeAliasReference(source, unionTarget) {
          var sourceObjectFlags = ts2.getObjectFlags(source);
          if (sourceObjectFlags & (4 | 16) && unionTarget.flags & 1048576) {
            return ts2.find(unionTarget.types, function(target) {
              if (target.flags & 524288) {
                var overlapObjFlags = sourceObjectFlags & ts2.getObjectFlags(target);
                if (overlapObjFlags & 4) {
                  return source.target === target.target;
                }
                if (overlapObjFlags & 16) {
                  return !!source.aliasSymbol && source.aliasSymbol === target.aliasSymbol;
                }
              }
              return false;
            });
          }
        }
        function findBestTypeForObjectLiteral(source, unionTarget) {
          if (ts2.getObjectFlags(source) & 128 && forEachType(unionTarget, isArrayLikeType)) {
            return ts2.find(unionTarget.types, function(t) {
              return !isArrayLikeType(t);
            });
          }
        }
        function findBestTypeForInvokable(source, unionTarget) {
          var signatureKind = 0;
          var hasSignatures = getSignaturesOfType(source, signatureKind).length > 0 || (signatureKind = 1, getSignaturesOfType(source, signatureKind).length > 0);
          if (hasSignatures) {
            return ts2.find(unionTarget.types, function(t) {
              return getSignaturesOfType(t, signatureKind).length > 0;
            });
          }
        }
        function findMostOverlappyType(source, unionTarget) {
          var bestMatch;
          var matchingCount = 0;
          for (var _i = 0, _a = unionTarget.types; _i < _a.length; _i++) {
            var target = _a[_i];
            var overlap = getIntersectionType([getIndexType(source), getIndexType(target)]);
            if (overlap.flags & 4194304) {
              bestMatch = target;
              matchingCount = Infinity;
            } else if (overlap.flags & 1048576) {
              var len = ts2.length(ts2.filter(overlap.types, isUnitType));
              if (len >= matchingCount) {
                bestMatch = target;
                matchingCount = len;
              }
            } else if (isUnitType(overlap) && 1 >= matchingCount) {
              bestMatch = target;
              matchingCount = 1;
            }
          }
          return bestMatch;
        }
        function filterPrimitivesIfContainsNonPrimitive(type) {
          if (maybeTypeOfKind(type, 67108864)) {
            var result = filterType(type, function(t) {
              return !(t.flags & 131068);
            });
            if (!(result.flags & 131072)) {
              return result;
            }
          }
          return type;
        }
        function findMatchingDiscriminantType(source, target, isRelatedTo, skipPartial) {
          if (target.flags & 1048576 && source.flags & (2097152 | 524288)) {
            var sourceProperties = getPropertiesOfType(source);
            if (sourceProperties) {
              var sourcePropertiesFiltered = findDiscriminantProperties(sourceProperties, target);
              if (sourcePropertiesFiltered) {
                return discriminateTypeByDiscriminableItems(target, ts2.map(sourcePropertiesFiltered, function(p) {
                  return [function() {
                    return getTypeOfSymbol(p);
                  }, p.escapedName];
                }), isRelatedTo, void 0, skipPartial);
              }
            }
          }
          return void 0;
        }
      }
      ts2.createTypeChecker = createTypeChecker;
      function isNotAccessor(declaration) {
        return !ts2.isAccessor(declaration);
      }
      function isNotOverload(declaration) {
        return declaration.kind !== 244 && declaration.kind !== 161 || !!declaration.body;
      }
      function isDeclarationNameOrImportPropertyName(name) {
        switch (name.parent.kind) {
          case 258:
          case 263:
            return ts2.isIdentifier(name);
          default:
            return ts2.isDeclarationName(name);
        }
      }
      function isSomeImportDeclaration(decl) {
        switch (decl.kind) {
          case 255:
          case 253:
          case 256:
          case 258:
            return true;
          case 75:
            return decl.parent.kind === 258;
          default:
            return false;
        }
      }
      var JsxNames;
      (function(JsxNames2) {
        JsxNames2.JSX = "JSX";
        JsxNames2.IntrinsicElements = "IntrinsicElements";
        JsxNames2.ElementClass = "ElementClass";
        JsxNames2.ElementAttributesPropertyNameContainer = "ElementAttributesProperty";
        JsxNames2.ElementChildrenAttributeNameContainer = "ElementChildrenAttribute";
        JsxNames2.Element = "Element";
        JsxNames2.IntrinsicAttributes = "IntrinsicAttributes";
        JsxNames2.IntrinsicClassAttributes = "IntrinsicClassAttributes";
        JsxNames2.LibraryManagedAttributes = "LibraryManagedAttributes";
      })(JsxNames || (JsxNames = {}));
      function getIterationTypesKeyFromIterationTypeKind(typeKind) {
        switch (typeKind) {
          case 0:
            return "yieldType";
          case 1:
            return "returnType";
          case 2:
            return "nextType";
        }
      }
      function signatureHasRestParameter(s) {
        return !!(s.flags & 1);
      }
      ts2.signatureHasRestParameter = signatureHasRestParameter;
      function signatureHasLiteralTypes(s) {
        return !!(s.flags & 2);
      }
      ts2.signatureHasLiteralTypes = signatureHasLiteralTypes;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function createSynthesizedNode(kind) {
        var node = ts2.createNode(kind, -1, -1);
        node.flags |= 8;
        return node;
      }
      function updateNode(updated, original) {
        if (updated !== original) {
          setOriginalNode(updated, original);
          setTextRange(updated, original);
          ts2.aggregateTransformFlags(updated);
        }
        return updated;
      }
      ts2.updateNode = updateNode;
      function createNodeArray(elements, hasTrailingComma) {
        if (!elements || elements === ts2.emptyArray) {
          elements = [];
        } else if (ts2.isNodeArray(elements)) {
          return elements;
        }
        var array = elements;
        array.pos = -1;
        array.end = -1;
        array.hasTrailingComma = hasTrailingComma;
        return array;
      }
      ts2.createNodeArray = createNodeArray;
      function getSynthesizedClone(node) {
        if (node === void 0) {
          return node;
        }
        var clone = createSynthesizedNode(node.kind);
        clone.flags |= node.flags;
        setOriginalNode(clone, node);
        for (var key in node) {
          if (clone.hasOwnProperty(key) || !node.hasOwnProperty(key)) {
            continue;
          }
          clone[key] = node[key];
        }
        return clone;
      }
      ts2.getSynthesizedClone = getSynthesizedClone;
      function createLiteral(value, isSingleQuote) {
        if (typeof value === "number") {
          return createNumericLiteral(value + "");
        }
        if (typeof value === "object" && "base10Value" in value) {
          return createBigIntLiteral(ts2.pseudoBigIntToString(value) + "n");
        }
        if (typeof value === "boolean") {
          return value ? createTrue() : createFalse();
        }
        if (ts2.isString(value)) {
          var res = createStringLiteral(value);
          if (isSingleQuote)
            res.singleQuote = true;
          return res;
        }
        return createLiteralFromNode(value);
      }
      ts2.createLiteral = createLiteral;
      function createNumericLiteral(value, numericLiteralFlags) {
        if (numericLiteralFlags === void 0) {
          numericLiteralFlags = 0;
        }
        var node = createSynthesizedNode(8);
        node.text = value;
        node.numericLiteralFlags = numericLiteralFlags;
        return node;
      }
      ts2.createNumericLiteral = createNumericLiteral;
      function createBigIntLiteral(value) {
        var node = createSynthesizedNode(9);
        node.text = value;
        return node;
      }
      ts2.createBigIntLiteral = createBigIntLiteral;
      function createStringLiteral(text) {
        var node = createSynthesizedNode(10);
        node.text = text;
        return node;
      }
      ts2.createStringLiteral = createStringLiteral;
      function createRegularExpressionLiteral(text) {
        var node = createSynthesizedNode(13);
        node.text = text;
        return node;
      }
      ts2.createRegularExpressionLiteral = createRegularExpressionLiteral;
      function createLiteralFromNode(sourceNode) {
        var node = createStringLiteral(ts2.getTextOfIdentifierOrLiteral(sourceNode));
        node.textSourceNode = sourceNode;
        return node;
      }
      function createIdentifier(text, typeArguments) {
        var node = createSynthesizedNode(75);
        node.escapedText = ts2.escapeLeadingUnderscores(text);
        node.originalKeywordKind = text ? ts2.stringToToken(text) : 0;
        node.autoGenerateFlags = 0;
        node.autoGenerateId = 0;
        if (typeArguments) {
          node.typeArguments = createNodeArray(typeArguments);
        }
        return node;
      }
      ts2.createIdentifier = createIdentifier;
      function updateIdentifier(node, typeArguments) {
        return node.typeArguments !== typeArguments ? updateNode(createIdentifier(ts2.idText(node), typeArguments), node) : node;
      }
      ts2.updateIdentifier = updateIdentifier;
      var nextAutoGenerateId = 0;
      function createTempVariable(recordTempVariable, reservedInNestedScopes) {
        var name = createIdentifier("");
        name.autoGenerateFlags = 1;
        name.autoGenerateId = nextAutoGenerateId;
        nextAutoGenerateId++;
        if (recordTempVariable) {
          recordTempVariable(name);
        }
        if (reservedInNestedScopes) {
          name.autoGenerateFlags |= 8;
        }
        return name;
      }
      ts2.createTempVariable = createTempVariable;
      function createLoopVariable() {
        var name = createIdentifier("");
        name.autoGenerateFlags = 2;
        name.autoGenerateId = nextAutoGenerateId;
        nextAutoGenerateId++;
        return name;
      }
      ts2.createLoopVariable = createLoopVariable;
      function createUniqueName(text) {
        var name = createIdentifier(text);
        name.autoGenerateFlags = 3;
        name.autoGenerateId = nextAutoGenerateId;
        nextAutoGenerateId++;
        return name;
      }
      ts2.createUniqueName = createUniqueName;
      function createOptimisticUniqueName(text) {
        var name = createIdentifier(text);
        name.autoGenerateFlags = 3 | 16;
        name.autoGenerateId = nextAutoGenerateId;
        nextAutoGenerateId++;
        return name;
      }
      ts2.createOptimisticUniqueName = createOptimisticUniqueName;
      function createFileLevelUniqueName(text) {
        var name = createOptimisticUniqueName(text);
        name.autoGenerateFlags |= 32;
        return name;
      }
      ts2.createFileLevelUniqueName = createFileLevelUniqueName;
      function getGeneratedNameForNode(node, flags) {
        var name = createIdentifier(node && ts2.isIdentifier(node) ? ts2.idText(node) : "");
        name.autoGenerateFlags = 4 | flags;
        name.autoGenerateId = nextAutoGenerateId;
        name.original = node;
        nextAutoGenerateId++;
        return name;
      }
      ts2.getGeneratedNameForNode = getGeneratedNameForNode;
      function createPrivateIdentifier(text) {
        if (text[0] !== "#") {
          ts2.Debug.fail("First character of private identifier must be #: " + text);
        }
        var node = createSynthesizedNode(76);
        node.escapedText = ts2.escapeLeadingUnderscores(text);
        return node;
      }
      ts2.createPrivateIdentifier = createPrivateIdentifier;
      function createToken(token) {
        return createSynthesizedNode(token);
      }
      ts2.createToken = createToken;
      function createSuper() {
        return createSynthesizedNode(102);
      }
      ts2.createSuper = createSuper;
      function createThis() {
        return createSynthesizedNode(104);
      }
      ts2.createThis = createThis;
      function createNull() {
        return createSynthesizedNode(100);
      }
      ts2.createNull = createNull;
      function createTrue() {
        return createSynthesizedNode(106);
      }
      ts2.createTrue = createTrue;
      function createFalse() {
        return createSynthesizedNode(91);
      }
      ts2.createFalse = createFalse;
      function createModifier(kind) {
        return createToken(kind);
      }
      ts2.createModifier = createModifier;
      function createModifiersFromModifierFlags(flags) {
        var result = [];
        if (flags & 1) {
          result.push(createModifier(89));
        }
        if (flags & 2) {
          result.push(createModifier(130));
        }
        if (flags & 512) {
          result.push(createModifier(84));
        }
        if (flags & 2048) {
          result.push(createModifier(81));
        }
        if (flags & 4) {
          result.push(createModifier(119));
        }
        if (flags & 8) {
          result.push(createModifier(117));
        }
        if (flags & 16) {
          result.push(createModifier(118));
        }
        if (flags & 128) {
          result.push(createModifier(122));
        }
        if (flags & 32) {
          result.push(createModifier(120));
        }
        if (flags & 64) {
          result.push(createModifier(138));
        }
        if (flags & 256) {
          result.push(createModifier(126));
        }
        return result;
      }
      ts2.createModifiersFromModifierFlags = createModifiersFromModifierFlags;
      function createQualifiedName(left, right) {
        var node = createSynthesizedNode(153);
        node.left = left;
        node.right = asName(right);
        return node;
      }
      ts2.createQualifiedName = createQualifiedName;
      function updateQualifiedName(node, left, right) {
        return node.left !== left || node.right !== right ? updateNode(createQualifiedName(left, right), node) : node;
      }
      ts2.updateQualifiedName = updateQualifiedName;
      function parenthesizeForComputedName(expression) {
        return ts2.isCommaSequence(expression) ? createParen(expression) : expression;
      }
      function createComputedPropertyName(expression) {
        var node = createSynthesizedNode(154);
        node.expression = parenthesizeForComputedName(expression);
        return node;
      }
      ts2.createComputedPropertyName = createComputedPropertyName;
      function updateComputedPropertyName(node, expression) {
        return node.expression !== expression ? updateNode(createComputedPropertyName(expression), node) : node;
      }
      ts2.updateComputedPropertyName = updateComputedPropertyName;
      function createTypeParameterDeclaration(name, constraint, defaultType) {
        var node = createSynthesizedNode(155);
        node.name = asName(name);
        node.constraint = constraint;
        node.default = defaultType;
        return node;
      }
      ts2.createTypeParameterDeclaration = createTypeParameterDeclaration;
      function updateTypeParameterDeclaration(node, name, constraint, defaultType) {
        return node.name !== name || node.constraint !== constraint || node.default !== defaultType ? updateNode(createTypeParameterDeclaration(name, constraint, defaultType), node) : node;
      }
      ts2.updateTypeParameterDeclaration = updateTypeParameterDeclaration;
      function createParameter(decorators, modifiers, dotDotDotToken, name, questionToken, type, initializer) {
        var node = createSynthesizedNode(156);
        node.decorators = asNodeArray(decorators);
        node.modifiers = asNodeArray(modifiers);
        node.dotDotDotToken = dotDotDotToken;
        node.name = asName(name);
        node.questionToken = questionToken;
        node.type = type;
        node.initializer = initializer ? ts2.parenthesizeExpressionForList(initializer) : void 0;
        return node;
      }
      ts2.createParameter = createParameter;
      function updateParameter(node, decorators, modifiers, dotDotDotToken, name, questionToken, type, initializer) {
        return node.decorators !== decorators || node.modifiers !== modifiers || node.dotDotDotToken !== dotDotDotToken || node.name !== name || node.questionToken !== questionToken || node.type !== type || node.initializer !== initializer ? updateNode(createParameter(decorators, modifiers, dotDotDotToken, name, questionToken, type, initializer), node) : node;
      }
      ts2.updateParameter = updateParameter;
      function createDecorator(expression) {
        var node = createSynthesizedNode(157);
        node.expression = ts2.parenthesizeForAccess(expression);
        return node;
      }
      ts2.createDecorator = createDecorator;
      function updateDecorator(node, expression) {
        return node.expression !== expression ? updateNode(createDecorator(expression), node) : node;
      }
      ts2.updateDecorator = updateDecorator;
      function createPropertySignature(modifiers, name, questionToken, type, initializer) {
        var node = createSynthesizedNode(158);
        node.modifiers = asNodeArray(modifiers);
        node.name = asName(name);
        node.questionToken = questionToken;
        node.type = type;
        node.initializer = initializer;
        return node;
      }
      ts2.createPropertySignature = createPropertySignature;
      function updatePropertySignature(node, modifiers, name, questionToken, type, initializer) {
        return node.modifiers !== modifiers || node.name !== name || node.questionToken !== questionToken || node.type !== type || node.initializer !== initializer ? updateNode(createPropertySignature(modifiers, name, questionToken, type, initializer), node) : node;
      }
      ts2.updatePropertySignature = updatePropertySignature;
      function createProperty(decorators, modifiers, name, questionOrExclamationToken, type, initializer) {
        var node = createSynthesizedNode(159);
        node.decorators = asNodeArray(decorators);
        node.modifiers = asNodeArray(modifiers);
        node.name = asName(name);
        node.questionToken = questionOrExclamationToken !== void 0 && questionOrExclamationToken.kind === 57 ? questionOrExclamationToken : void 0;
        node.exclamationToken = questionOrExclamationToken !== void 0 && questionOrExclamationToken.kind === 53 ? questionOrExclamationToken : void 0;
        node.type = type;
        node.initializer = initializer;
        return node;
      }
      ts2.createProperty = createProperty;
      function updateProperty(node, decorators, modifiers, name, questionOrExclamationToken, type, initializer) {
        return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.questionToken !== (questionOrExclamationToken !== void 0 && questionOrExclamationToken.kind === 57 ? questionOrExclamationToken : void 0) || node.exclamationToken !== (questionOrExclamationToken !== void 0 && questionOrExclamationToken.kind === 53 ? questionOrExclamationToken : void 0) || node.type !== type || node.initializer !== initializer ? updateNode(createProperty(decorators, modifiers, name, questionOrExclamationToken, type, initializer), node) : node;
      }
      ts2.updateProperty = updateProperty;
      function createMethodSignature(typeParameters, parameters, type, name, questionToken) {
        var node = createSignatureDeclaration(160, typeParameters, parameters, type);
        node.name = asName(name);
        node.questionToken = questionToken;
        return node;
      }
      ts2.createMethodSignature = createMethodSignature;
      function updateMethodSignature(node, typeParameters, parameters, type, name, questionToken) {
        return node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type || node.name !== name || node.questionToken !== questionToken ? updateNode(createMethodSignature(typeParameters, parameters, type, name, questionToken), node) : node;
      }
      ts2.updateMethodSignature = updateMethodSignature;
      function createMethod(decorators, modifiers, asteriskToken, name, questionToken, typeParameters, parameters, type, body) {
        var node = createSynthesizedNode(161);
        node.decorators = asNodeArray(decorators);
        node.modifiers = asNodeArray(modifiers);
        node.asteriskToken = asteriskToken;
        node.name = asName(name);
        node.questionToken = questionToken;
        node.typeParameters = asNodeArray(typeParameters);
        node.parameters = createNodeArray(parameters);
        node.type = type;
        node.body = body;
        return node;
      }
      ts2.createMethod = createMethod;
      function createMethodCall(object, methodName, argumentsList) {
        return createCall(createPropertyAccess(object, asName(methodName)), void 0, argumentsList);
      }
      function createGlobalMethodCall(globalObjectName, methodName, argumentsList) {
        return createMethodCall(createIdentifier(globalObjectName), methodName, argumentsList);
      }
      function createObjectDefinePropertyCall(target, propertyName, attributes) {
        return createGlobalMethodCall("Object", "defineProperty", [target, asExpression(propertyName), attributes]);
      }
      ts2.createObjectDefinePropertyCall = createObjectDefinePropertyCall;
      function tryAddPropertyAssignment(properties, propertyName, expression) {
        if (expression) {
          properties.push(createPropertyAssignment(propertyName, expression));
          return true;
        }
        return false;
      }
      function createPropertyDescriptor(attributes, singleLine) {
        var properties = [];
        tryAddPropertyAssignment(properties, "enumerable", asExpression(attributes.enumerable));
        tryAddPropertyAssignment(properties, "configurable", asExpression(attributes.configurable));
        var isData = tryAddPropertyAssignment(properties, "writable", asExpression(attributes.writable));
        isData = tryAddPropertyAssignment(properties, "value", attributes.value) || isData;
        var isAccessor = tryAddPropertyAssignment(properties, "get", attributes.get);
        isAccessor = tryAddPropertyAssignment(properties, "set", attributes.set) || isAccessor;
        ts2.Debug.assert(!(isData && isAccessor), "A PropertyDescriptor may not be both an accessor descriptor and a data descriptor.");
        return createObjectLiteral(properties, !singleLine);
      }
      ts2.createPropertyDescriptor = createPropertyDescriptor;
      function updateMethod(node, decorators, modifiers, asteriskToken, name, questionToken, typeParameters, parameters, type, body) {
        return node.decorators !== decorators || node.modifiers !== modifiers || node.asteriskToken !== asteriskToken || node.name !== name || node.questionToken !== questionToken || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type || node.body !== body ? updateNode(createMethod(decorators, modifiers, asteriskToken, name, questionToken, typeParameters, parameters, type, body), node) : node;
      }
      ts2.updateMethod = updateMethod;
      function createConstructor(decorators, modifiers, parameters, body) {
        var node = createSynthesizedNode(162);
        node.decorators = asNodeArray(decorators);
        node.modifiers = asNodeArray(modifiers);
        node.typeParameters = void 0;
        node.parameters = createNodeArray(parameters);
        node.type = void 0;
        node.body = body;
        return node;
      }
      ts2.createConstructor = createConstructor;
      function updateConstructor(node, decorators, modifiers, parameters, body) {
        return node.decorators !== decorators || node.modifiers !== modifiers || node.parameters !== parameters || node.body !== body ? updateNode(createConstructor(decorators, modifiers, parameters, body), node) : node;
      }
      ts2.updateConstructor = updateConstructor;
      function createGetAccessor(decorators, modifiers, name, parameters, type, body) {
        var node = createSynthesizedNode(163);
        node.decorators = asNodeArray(decorators);
        node.modifiers = asNodeArray(modifiers);
        node.name = asName(name);
        node.typeParameters = void 0;
        node.parameters = createNodeArray(parameters);
        node.type = type;
        node.body = body;
        return node;
      }
      ts2.createGetAccessor = createGetAccessor;
      function updateGetAccessor(node, decorators, modifiers, name, parameters, type, body) {
        return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.parameters !== parameters || node.type !== type || node.body !== body ? updateNode(createGetAccessor(decorators, modifiers, name, parameters, type, body), node) : node;
      }
      ts2.updateGetAccessor = updateGetAccessor;
      function createSetAccessor(decorators, modifiers, name, parameters, body) {
        var node = createSynthesizedNode(164);
        node.decorators = asNodeArray(decorators);
        node.modifiers = asNodeArray(modifiers);
        node.name = asName(name);
        node.typeParameters = void 0;
        node.parameters = createNodeArray(parameters);
        node.body = body;
        return node;
      }
      ts2.createSetAccessor = createSetAccessor;
      function updateSetAccessor(node, decorators, modifiers, name, parameters, body) {
        return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.parameters !== parameters || node.body !== body ? updateNode(createSetAccessor(decorators, modifiers, name, parameters, body), node) : node;
      }
      ts2.updateSetAccessor = updateSetAccessor;
      function createCallSignature(typeParameters, parameters, type) {
        return createSignatureDeclaration(165, typeParameters, parameters, type);
      }
      ts2.createCallSignature = createCallSignature;
      function updateCallSignature(node, typeParameters, parameters, type) {
        return updateSignatureDeclaration(node, typeParameters, parameters, type);
      }
      ts2.updateCallSignature = updateCallSignature;
      function createConstructSignature(typeParameters, parameters, type) {
        return createSignatureDeclaration(166, typeParameters, parameters, type);
      }
      ts2.createConstructSignature = createConstructSignature;
      function updateConstructSignature(node, typeParameters, parameters, type) {
        return updateSignatureDeclaration(node, typeParameters, parameters, type);
      }
      ts2.updateConstructSignature = updateConstructSignature;
      function createIndexSignature(decorators, modifiers, parameters, type) {
        var node = createSynthesizedNode(167);
        node.decorators = asNodeArray(decorators);
        node.modifiers = asNodeArray(modifiers);
        node.parameters = createNodeArray(parameters);
        node.type = type;
        return node;
      }
      ts2.createIndexSignature = createIndexSignature;
      function updateIndexSignature(node, decorators, modifiers, parameters, type) {
        return node.parameters !== parameters || node.type !== type || node.decorators !== decorators || node.modifiers !== modifiers ? updateNode(createIndexSignature(decorators, modifiers, parameters, type), node) : node;
      }
      ts2.updateIndexSignature = updateIndexSignature;
      function createSignatureDeclaration(kind, typeParameters, parameters, type, typeArguments) {
        var node = createSynthesizedNode(kind);
        node.typeParameters = asNodeArray(typeParameters);
        node.parameters = asNodeArray(parameters);
        node.type = type;
        node.typeArguments = asNodeArray(typeArguments);
        return node;
      }
      ts2.createSignatureDeclaration = createSignatureDeclaration;
      function updateSignatureDeclaration(node, typeParameters, parameters, type) {
        return node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type ? updateNode(createSignatureDeclaration(node.kind, typeParameters, parameters, type), node) : node;
      }
      function createKeywordTypeNode(kind) {
        return createSynthesizedNode(kind);
      }
      ts2.createKeywordTypeNode = createKeywordTypeNode;
      function createTypePredicateNode(parameterName, type) {
        return createTypePredicateNodeWithModifier(void 0, parameterName, type);
      }
      ts2.createTypePredicateNode = createTypePredicateNode;
      function createTypePredicateNodeWithModifier(assertsModifier, parameterName, type) {
        var node = createSynthesizedNode(168);
        node.assertsModifier = assertsModifier;
        node.parameterName = asName(parameterName);
        node.type = type;
        return node;
      }
      ts2.createTypePredicateNodeWithModifier = createTypePredicateNodeWithModifier;
      function updateTypePredicateNode(node, parameterName, type) {
        return updateTypePredicateNodeWithModifier(node, node.assertsModifier, parameterName, type);
      }
      ts2.updateTypePredicateNode = updateTypePredicateNode;
      function updateTypePredicateNodeWithModifier(node, assertsModifier, parameterName, type) {
        return node.assertsModifier !== assertsModifier || node.parameterName !== parameterName || node.type !== type ? updateNode(createTypePredicateNodeWithModifier(assertsModifier, parameterName, type), node) : node;
      }
      ts2.updateTypePredicateNodeWithModifier = updateTypePredicateNodeWithModifier;
      function createTypeReferenceNode(typeName, typeArguments) {
        var node = createSynthesizedNode(169);
        node.typeName = asName(typeName);
        node.typeArguments = typeArguments && ts2.parenthesizeTypeParameters(typeArguments);
        return node;
      }
      ts2.createTypeReferenceNode = createTypeReferenceNode;
      function updateTypeReferenceNode(node, typeName, typeArguments) {
        return node.typeName !== typeName || node.typeArguments !== typeArguments ? updateNode(createTypeReferenceNode(typeName, typeArguments), node) : node;
      }
      ts2.updateTypeReferenceNode = updateTypeReferenceNode;
      function createFunctionTypeNode(typeParameters, parameters, type) {
        return createSignatureDeclaration(170, typeParameters, parameters, type);
      }
      ts2.createFunctionTypeNode = createFunctionTypeNode;
      function updateFunctionTypeNode(node, typeParameters, parameters, type) {
        return updateSignatureDeclaration(node, typeParameters, parameters, type);
      }
      ts2.updateFunctionTypeNode = updateFunctionTypeNode;
      function createConstructorTypeNode(typeParameters, parameters, type) {
        return createSignatureDeclaration(171, typeParameters, parameters, type);
      }
      ts2.createConstructorTypeNode = createConstructorTypeNode;
      function updateConstructorTypeNode(node, typeParameters, parameters, type) {
        return updateSignatureDeclaration(node, typeParameters, parameters, type);
      }
      ts2.updateConstructorTypeNode = updateConstructorTypeNode;
      function createTypeQueryNode(exprName) {
        var node = createSynthesizedNode(172);
        node.exprName = exprName;
        return node;
      }
      ts2.createTypeQueryNode = createTypeQueryNode;
      function updateTypeQueryNode(node, exprName) {
        return node.exprName !== exprName ? updateNode(createTypeQueryNode(exprName), node) : node;
      }
      ts2.updateTypeQueryNode = updateTypeQueryNode;
      function createTypeLiteralNode(members) {
        var node = createSynthesizedNode(173);
        node.members = createNodeArray(members);
        return node;
      }
      ts2.createTypeLiteralNode = createTypeLiteralNode;
      function updateTypeLiteralNode(node, members) {
        return node.members !== members ? updateNode(createTypeLiteralNode(members), node) : node;
      }
      ts2.updateTypeLiteralNode = updateTypeLiteralNode;
      function createArrayTypeNode(elementType) {
        var node = createSynthesizedNode(174);
        node.elementType = ts2.parenthesizeArrayTypeMember(elementType);
        return node;
      }
      ts2.createArrayTypeNode = createArrayTypeNode;
      function updateArrayTypeNode(node, elementType) {
        return node.elementType !== elementType ? updateNode(createArrayTypeNode(elementType), node) : node;
      }
      ts2.updateArrayTypeNode = updateArrayTypeNode;
      function createTupleTypeNode(elementTypes) {
        var node = createSynthesizedNode(175);
        node.elementTypes = createNodeArray(elementTypes);
        return node;
      }
      ts2.createTupleTypeNode = createTupleTypeNode;
      function updateTupleTypeNode(node, elementTypes) {
        return node.elementTypes !== elementTypes ? updateNode(createTupleTypeNode(elementTypes), node) : node;
      }
      ts2.updateTupleTypeNode = updateTupleTypeNode;
      function createOptionalTypeNode(type) {
        var node = createSynthesizedNode(176);
        node.type = ts2.parenthesizeArrayTypeMember(type);
        return node;
      }
      ts2.createOptionalTypeNode = createOptionalTypeNode;
      function updateOptionalTypeNode(node, type) {
        return node.type !== type ? updateNode(createOptionalTypeNode(type), node) : node;
      }
      ts2.updateOptionalTypeNode = updateOptionalTypeNode;
      function createRestTypeNode(type) {
        var node = createSynthesizedNode(177);
        node.type = type;
        return node;
      }
      ts2.createRestTypeNode = createRestTypeNode;
      function updateRestTypeNode(node, type) {
        return node.type !== type ? updateNode(createRestTypeNode(type), node) : node;
      }
      ts2.updateRestTypeNode = updateRestTypeNode;
      function createUnionTypeNode(types) {
        return createUnionOrIntersectionTypeNode(178, types);
      }
      ts2.createUnionTypeNode = createUnionTypeNode;
      function updateUnionTypeNode(node, types) {
        return updateUnionOrIntersectionTypeNode(node, types);
      }
      ts2.updateUnionTypeNode = updateUnionTypeNode;
      function createIntersectionTypeNode(types) {
        return createUnionOrIntersectionTypeNode(179, types);
      }
      ts2.createIntersectionTypeNode = createIntersectionTypeNode;
      function updateIntersectionTypeNode(node, types) {
        return updateUnionOrIntersectionTypeNode(node, types);
      }
      ts2.updateIntersectionTypeNode = updateIntersectionTypeNode;
      function createUnionOrIntersectionTypeNode(kind, types) {
        var node = createSynthesizedNode(kind);
        node.types = ts2.parenthesizeElementTypeMembers(types);
        return node;
      }
      ts2.createUnionOrIntersectionTypeNode = createUnionOrIntersectionTypeNode;
      function updateUnionOrIntersectionTypeNode(node, types) {
        return node.types !== types ? updateNode(createUnionOrIntersectionTypeNode(node.kind, types), node) : node;
      }
      function createConditionalTypeNode(checkType, extendsType, trueType, falseType) {
        var node = createSynthesizedNode(180);
        node.checkType = ts2.parenthesizeConditionalTypeMember(checkType);
        node.extendsType = ts2.parenthesizeConditionalTypeMember(extendsType);
        node.trueType = trueType;
        node.falseType = falseType;
        return node;
      }
      ts2.createConditionalTypeNode = createConditionalTypeNode;
      function updateConditionalTypeNode(node, checkType, extendsType, trueType, falseType) {
        return node.checkType !== checkType || node.extendsType !== extendsType || node.trueType !== trueType || node.falseType !== falseType ? updateNode(createConditionalTypeNode(checkType, extendsType, trueType, falseType), node) : node;
      }
      ts2.updateConditionalTypeNode = updateConditionalTypeNode;
      function createInferTypeNode(typeParameter) {
        var node = createSynthesizedNode(181);
        node.typeParameter = typeParameter;
        return node;
      }
      ts2.createInferTypeNode = createInferTypeNode;
      function updateInferTypeNode(node, typeParameter) {
        return node.typeParameter !== typeParameter ? updateNode(createInferTypeNode(typeParameter), node) : node;
      }
      ts2.updateInferTypeNode = updateInferTypeNode;
      function createImportTypeNode(argument, qualifier, typeArguments, isTypeOf) {
        var node = createSynthesizedNode(188);
        node.argument = argument;
        node.qualifier = qualifier;
        node.typeArguments = ts2.parenthesizeTypeParameters(typeArguments);
        node.isTypeOf = isTypeOf;
        return node;
      }
      ts2.createImportTypeNode = createImportTypeNode;
      function updateImportTypeNode(node, argument, qualifier, typeArguments, isTypeOf) {
        return node.argument !== argument || node.qualifier !== qualifier || node.typeArguments !== typeArguments || node.isTypeOf !== isTypeOf ? updateNode(createImportTypeNode(argument, qualifier, typeArguments, isTypeOf), node) : node;
      }
      ts2.updateImportTypeNode = updateImportTypeNode;
      function createParenthesizedType(type) {
        var node = createSynthesizedNode(182);
        node.type = type;
        return node;
      }
      ts2.createParenthesizedType = createParenthesizedType;
      function updateParenthesizedType(node, type) {
        return node.type !== type ? updateNode(createParenthesizedType(type), node) : node;
      }
      ts2.updateParenthesizedType = updateParenthesizedType;
      function createThisTypeNode() {
        return createSynthesizedNode(183);
      }
      ts2.createThisTypeNode = createThisTypeNode;
      function createTypeOperatorNode(operatorOrType, type) {
        var node = createSynthesizedNode(184);
        node.operator = typeof operatorOrType === "number" ? operatorOrType : 134;
        node.type = ts2.parenthesizeElementTypeMember(typeof operatorOrType === "number" ? type : operatorOrType);
        return node;
      }
      ts2.createTypeOperatorNode = createTypeOperatorNode;
      function updateTypeOperatorNode(node, type) {
        return node.type !== type ? updateNode(createTypeOperatorNode(node.operator, type), node) : node;
      }
      ts2.updateTypeOperatorNode = updateTypeOperatorNode;
      function createIndexedAccessTypeNode(objectType, indexType) {
        var node = createSynthesizedNode(185);
        node.objectType = ts2.parenthesizeElementTypeMember(objectType);
        node.indexType = indexType;
        return node;
      }
      ts2.createIndexedAccessTypeNode = createIndexedAccessTypeNode;
      function updateIndexedAccessTypeNode(node, objectType, indexType) {
        return node.objectType !== objectType || node.indexType !== indexType ? updateNode(createIndexedAccessTypeNode(objectType, indexType), node) : node;
      }
      ts2.updateIndexedAccessTypeNode = updateIndexedAccessTypeNode;
      function createMappedTypeNode(readonlyToken, typeParameter, questionToken, type) {
        var node = createSynthesizedNode(186);
        node.readonlyToken = readonlyToken;
        node.typeParameter = typeParameter;
        node.questionToken = questionToken;
        node.type = type;
        return node;
      }
      ts2.createMappedTypeNode = createMappedTypeNode;
      function updateMappedTypeNode(node, readonlyToken, typeParameter, questionToken, type) {
        return node.readonlyToken !== readonlyToken || node.typeParameter !== typeParameter || node.questionToken !== questionToken || node.type !== type ? updateNode(createMappedTypeNode(readonlyToken, typeParameter, questionToken, type), node) : node;
      }
      ts2.updateMappedTypeNode = updateMappedTypeNode;
      function createLiteralTypeNode(literal) {
        var node = createSynthesizedNode(187);
        node.literal = literal;
        return node;
      }
      ts2.createLiteralTypeNode = createLiteralTypeNode;
      function updateLiteralTypeNode(node, literal) {
        return node.literal !== literal ? updateNode(createLiteralTypeNode(literal), node) : node;
      }
      ts2.updateLiteralTypeNode = updateLiteralTypeNode;
      function createObjectBindingPattern(elements) {
        var node = createSynthesizedNode(189);
        node.elements = createNodeArray(elements);
        return node;
      }
      ts2.createObjectBindingPattern = createObjectBindingPattern;
      function updateObjectBindingPattern(node, elements) {
        return node.elements !== elements ? updateNode(createObjectBindingPattern(elements), node) : node;
      }
      ts2.updateObjectBindingPattern = updateObjectBindingPattern;
      function createArrayBindingPattern(elements) {
        var node = createSynthesizedNode(190);
        node.elements = createNodeArray(elements);
        return node;
      }
      ts2.createArrayBindingPattern = createArrayBindingPattern;
      function updateArrayBindingPattern(node, elements) {
        return node.elements !== elements ? updateNode(createArrayBindingPattern(elements), node) : node;
      }
      ts2.updateArrayBindingPattern = updateArrayBindingPattern;
      function createBindingElement(dotDotDotToken, propertyName, name, initializer) {
        var node = createSynthesizedNode(191);
        node.dotDotDotToken = dotDotDotToken;
        node.propertyName = asName(propertyName);
        node.name = asName(name);
        node.initializer = initializer;
        return node;
      }
      ts2.createBindingElement = createBindingElement;
      function updateBindingElement(node, dotDotDotToken, propertyName, name, initializer) {
        return node.propertyName !== propertyName || node.dotDotDotToken !== dotDotDotToken || node.name !== name || node.initializer !== initializer ? updateNode(createBindingElement(dotDotDotToken, propertyName, name, initializer), node) : node;
      }
      ts2.updateBindingElement = updateBindingElement;
      function createArrayLiteral(elements, multiLine) {
        var node = createSynthesizedNode(192);
        node.elements = ts2.parenthesizeListElements(createNodeArray(elements));
        if (multiLine)
          node.multiLine = true;
        return node;
      }
      ts2.createArrayLiteral = createArrayLiteral;
      function updateArrayLiteral(node, elements) {
        return node.elements !== elements ? updateNode(createArrayLiteral(elements, node.multiLine), node) : node;
      }
      ts2.updateArrayLiteral = updateArrayLiteral;
      function createObjectLiteral(properties, multiLine) {
        var node = createSynthesizedNode(193);
        node.properties = createNodeArray(properties);
        if (multiLine)
          node.multiLine = true;
        return node;
      }
      ts2.createObjectLiteral = createObjectLiteral;
      function updateObjectLiteral(node, properties) {
        return node.properties !== properties ? updateNode(createObjectLiteral(properties, node.multiLine), node) : node;
      }
      ts2.updateObjectLiteral = updateObjectLiteral;
      function createPropertyAccess(expression, name) {
        var node = createSynthesizedNode(194);
        node.expression = ts2.parenthesizeForAccess(expression);
        node.name = asName(name);
        setEmitFlags(node, 131072);
        return node;
      }
      ts2.createPropertyAccess = createPropertyAccess;
      function updatePropertyAccess(node, expression, name) {
        if (ts2.isPropertyAccessChain(node)) {
          return updatePropertyAccessChain(node, expression, node.questionDotToken, ts2.cast(name, ts2.isIdentifier));
        }
        return node.expression !== expression || node.name !== name ? updateNode(setEmitFlags(createPropertyAccess(expression, name), ts2.getEmitFlags(node)), node) : node;
      }
      ts2.updatePropertyAccess = updatePropertyAccess;
      function createPropertyAccessChain(expression, questionDotToken, name) {
        var node = createSynthesizedNode(194);
        node.flags |= 32;
        node.expression = ts2.parenthesizeForAccess(expression);
        node.questionDotToken = questionDotToken;
        node.name = asName(name);
        setEmitFlags(node, 131072);
        return node;
      }
      ts2.createPropertyAccessChain = createPropertyAccessChain;
      function updatePropertyAccessChain(node, expression, questionDotToken, name) {
        ts2.Debug.assert(!!(node.flags & 32), "Cannot update a PropertyAccessExpression using updatePropertyAccessChain. Use updatePropertyAccess instead.");
        return node.expression !== expression || node.questionDotToken !== questionDotToken || node.name !== name ? updateNode(setEmitFlags(createPropertyAccessChain(expression, questionDotToken, name), ts2.getEmitFlags(node)), node) : node;
      }
      ts2.updatePropertyAccessChain = updatePropertyAccessChain;
      function createElementAccess(expression, index) {
        var node = createSynthesizedNode(195);
        node.expression = ts2.parenthesizeForAccess(expression);
        node.argumentExpression = asExpression(index);
        return node;
      }
      ts2.createElementAccess = createElementAccess;
      function updateElementAccess(node, expression, argumentExpression) {
        if (ts2.isOptionalChain(node)) {
          return updateElementAccessChain(node, expression, node.questionDotToken, argumentExpression);
        }
        return node.expression !== expression || node.argumentExpression !== argumentExpression ? updateNode(createElementAccess(expression, argumentExpression), node) : node;
      }
      ts2.updateElementAccess = updateElementAccess;
      function createElementAccessChain(expression, questionDotToken, index) {
        var node = createSynthesizedNode(195);
        node.flags |= 32;
        node.expression = ts2.parenthesizeForAccess(expression);
        node.questionDotToken = questionDotToken;
        node.argumentExpression = asExpression(index);
        return node;
      }
      ts2.createElementAccessChain = createElementAccessChain;
      function updateElementAccessChain(node, expression, questionDotToken, argumentExpression) {
        ts2.Debug.assert(!!(node.flags & 32), "Cannot update an ElementAccessExpression using updateElementAccessChain. Use updateElementAccess instead.");
        return node.expression !== expression || node.questionDotToken !== questionDotToken || node.argumentExpression !== argumentExpression ? updateNode(createElementAccessChain(expression, questionDotToken, argumentExpression), node) : node;
      }
      ts2.updateElementAccessChain = updateElementAccessChain;
      function createCall(expression, typeArguments, argumentsArray) {
        var node = createSynthesizedNode(196);
        node.expression = ts2.parenthesizeForAccess(expression);
        node.typeArguments = asNodeArray(typeArguments);
        node.arguments = ts2.parenthesizeListElements(createNodeArray(argumentsArray));
        return node;
      }
      ts2.createCall = createCall;
      function updateCall(node, expression, typeArguments, argumentsArray) {
        if (ts2.isOptionalChain(node)) {
          return updateCallChain(node, expression, node.questionDotToken, typeArguments, argumentsArray);
        }
        return node.expression !== expression || node.typeArguments !== typeArguments || node.arguments !== argumentsArray ? updateNode(createCall(expression, typeArguments, argumentsArray), node) : node;
      }
      ts2.updateCall = updateCall;
      function createCallChain(expression, questionDotToken, typeArguments, argumentsArray) {
        var node = createSynthesizedNode(196);
        node.flags |= 32;
        node.expression = ts2.parenthesizeForAccess(expression);
        node.questionDotToken = questionDotToken;
        node.typeArguments = asNodeArray(typeArguments);
        node.arguments = ts2.parenthesizeListElements(createNodeArray(argumentsArray));
        return node;
      }
      ts2.createCallChain = createCallChain;
      function updateCallChain(node, expression, questionDotToken, typeArguments, argumentsArray) {
        ts2.Debug.assert(!!(node.flags & 32), "Cannot update a CallExpression using updateCallChain. Use updateCall instead.");
        return node.expression !== expression || node.questionDotToken !== questionDotToken || node.typeArguments !== typeArguments || node.arguments !== argumentsArray ? updateNode(createCallChain(expression, questionDotToken, typeArguments, argumentsArray), node) : node;
      }
      ts2.updateCallChain = updateCallChain;
      function createNew(expression, typeArguments, argumentsArray) {
        var node = createSynthesizedNode(197);
        node.expression = ts2.parenthesizeForNew(expression);
        node.typeArguments = asNodeArray(typeArguments);
        node.arguments = argumentsArray ? ts2.parenthesizeListElements(createNodeArray(argumentsArray)) : void 0;
        return node;
      }
      ts2.createNew = createNew;
      function updateNew(node, expression, typeArguments, argumentsArray) {
        return node.expression !== expression || node.typeArguments !== typeArguments || node.arguments !== argumentsArray ? updateNode(createNew(expression, typeArguments, argumentsArray), node) : node;
      }
      ts2.updateNew = updateNew;
      function createTaggedTemplate(tag, typeArgumentsOrTemplate, template) {
        var node = createSynthesizedNode(198);
        node.tag = ts2.parenthesizeForAccess(tag);
        if (template) {
          node.typeArguments = asNodeArray(typeArgumentsOrTemplate);
          node.template = template;
        } else {
          node.typeArguments = void 0;
          node.template = typeArgumentsOrTemplate;
        }
        return node;
      }
      ts2.createTaggedTemplate = createTaggedTemplate;
      function updateTaggedTemplate(node, tag, typeArgumentsOrTemplate, template) {
        return node.tag !== tag || (template ? node.typeArguments !== typeArgumentsOrTemplate || node.template !== template : node.typeArguments !== void 0 || node.template !== typeArgumentsOrTemplate) ? updateNode(createTaggedTemplate(tag, typeArgumentsOrTemplate, template), node) : node;
      }
      ts2.updateTaggedTemplate = updateTaggedTemplate;
      function createTypeAssertion(type, expression) {
        var node = createSynthesizedNode(199);
        node.type = type;
        node.expression = ts2.parenthesizePrefixOperand(expression);
        return node;
      }
      ts2.createTypeAssertion = createTypeAssertion;
      function updateTypeAssertion(node, type, expression) {
        return node.type !== type || node.expression !== expression ? updateNode(createTypeAssertion(type, expression), node) : node;
      }
      ts2.updateTypeAssertion = updateTypeAssertion;
      function createParen(expression) {
        var node = createSynthesizedNode(200);
        node.expression = expression;
        return node;
      }
      ts2.createParen = createParen;
      function updateParen(node, expression) {
        return node.expression !== expression ? updateNode(createParen(expression), node) : node;
      }
      ts2.updateParen = updateParen;
      function createFunctionExpression(modifiers, asteriskToken, name, typeParameters, parameters, type, body) {
        var node = createSynthesizedNode(201);
        node.modifiers = asNodeArray(modifiers);
        node.asteriskToken = asteriskToken;
        node.name = asName(name);
        node.typeParameters = asNodeArray(typeParameters);
        node.parameters = createNodeArray(parameters);
        node.type = type;
        node.body = body;
        return node;
      }
      ts2.createFunctionExpression = createFunctionExpression;
      function updateFunctionExpression(node, modifiers, asteriskToken, name, typeParameters, parameters, type, body) {
        return node.name !== name || node.modifiers !== modifiers || node.asteriskToken !== asteriskToken || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type || node.body !== body ? updateNode(createFunctionExpression(modifiers, asteriskToken, name, typeParameters, parameters, type, body), node) : node;
      }
      ts2.updateFunctionExpression = updateFunctionExpression;
      function createArrowFunction(modifiers, typeParameters, parameters, type, equalsGreaterThanToken, body) {
        var node = createSynthesizedNode(202);
        node.modifiers = asNodeArray(modifiers);
        node.typeParameters = asNodeArray(typeParameters);
        node.parameters = createNodeArray(parameters);
        node.type = type;
        node.equalsGreaterThanToken = equalsGreaterThanToken || createToken(38);
        node.body = ts2.parenthesizeConciseBody(body);
        return node;
      }
      ts2.createArrowFunction = createArrowFunction;
      function updateArrowFunction(node, modifiers, typeParameters, parameters, type, equalsGreaterThanToken, body) {
        return node.modifiers !== modifiers || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type || node.equalsGreaterThanToken !== equalsGreaterThanToken || node.body !== body ? updateNode(createArrowFunction(modifiers, typeParameters, parameters, type, equalsGreaterThanToken, body), node) : node;
      }
      ts2.updateArrowFunction = updateArrowFunction;
      function createDelete(expression) {
        var node = createSynthesizedNode(203);
        node.expression = ts2.parenthesizePrefixOperand(expression);
        return node;
      }
      ts2.createDelete = createDelete;
      function updateDelete(node, expression) {
        return node.expression !== expression ? updateNode(createDelete(expression), node) : node;
      }
      ts2.updateDelete = updateDelete;
      function createTypeOf(expression) {
        var node = createSynthesizedNode(204);
        node.expression = ts2.parenthesizePrefixOperand(expression);
        return node;
      }
      ts2.createTypeOf = createTypeOf;
      function updateTypeOf(node, expression) {
        return node.expression !== expression ? updateNode(createTypeOf(expression), node) : node;
      }
      ts2.updateTypeOf = updateTypeOf;
      function createVoid(expression) {
        var node = createSynthesizedNode(205);
        node.expression = ts2.parenthesizePrefixOperand(expression);
        return node;
      }
      ts2.createVoid = createVoid;
      function updateVoid(node, expression) {
        return node.expression !== expression ? updateNode(createVoid(expression), node) : node;
      }
      ts2.updateVoid = updateVoid;
      function createAwait(expression) {
        var node = createSynthesizedNode(206);
        node.expression = ts2.parenthesizePrefixOperand(expression);
        return node;
      }
      ts2.createAwait = createAwait;
      function updateAwait(node, expression) {
        return node.expression !== expression ? updateNode(createAwait(expression), node) : node;
      }
      ts2.updateAwait = updateAwait;
      function createPrefix(operator, operand) {
        var node = createSynthesizedNode(207);
        node.operator = operator;
        node.operand = ts2.parenthesizePrefixOperand(operand);
        return node;
      }
      ts2.createPrefix = createPrefix;
      function updatePrefix(node, operand) {
        return node.operand !== operand ? updateNode(createPrefix(node.operator, operand), node) : node;
      }
      ts2.updatePrefix = updatePrefix;
      function createPostfix(operand, operator) {
        var node = createSynthesizedNode(208);
        node.operand = ts2.parenthesizePostfixOperand(operand);
        node.operator = operator;
        return node;
      }
      ts2.createPostfix = createPostfix;
      function updatePostfix(node, operand) {
        return node.operand !== operand ? updateNode(createPostfix(operand, node.operator), node) : node;
      }
      ts2.updatePostfix = updatePostfix;
      function createBinary(left, operator, right) {
        var node = createSynthesizedNode(209);
        var operatorToken = asToken(operator);
        var operatorKind = operatorToken.kind;
        node.left = ts2.parenthesizeBinaryOperand(operatorKind, left, true, void 0);
        node.operatorToken = operatorToken;
        node.right = ts2.parenthesizeBinaryOperand(operatorKind, right, false, node.left);
        return node;
      }
      ts2.createBinary = createBinary;
      function updateBinary(node, left, right, operator) {
        return node.left !== left || node.right !== right ? updateNode(createBinary(left, operator || node.operatorToken, right), node) : node;
      }
      ts2.updateBinary = updateBinary;
      function createConditional(condition, questionTokenOrWhenTrue, whenTrueOrWhenFalse, colonToken, whenFalse) {
        var node = createSynthesizedNode(210);
        node.condition = ts2.parenthesizeForConditionalHead(condition);
        node.questionToken = whenFalse ? questionTokenOrWhenTrue : createToken(57);
        node.whenTrue = ts2.parenthesizeSubexpressionOfConditionalExpression(whenFalse ? whenTrueOrWhenFalse : questionTokenOrWhenTrue);
        node.colonToken = whenFalse ? colonToken : createToken(58);
        node.whenFalse = ts2.parenthesizeSubexpressionOfConditionalExpression(whenFalse ? whenFalse : whenTrueOrWhenFalse);
        return node;
      }
      ts2.createConditional = createConditional;
      function updateConditional(node, condition, questionToken, whenTrue, colonToken, whenFalse) {
        return node.condition !== condition || node.questionToken !== questionToken || node.whenTrue !== whenTrue || node.colonToken !== colonToken || node.whenFalse !== whenFalse ? updateNode(createConditional(condition, questionToken, whenTrue, colonToken, whenFalse), node) : node;
      }
      ts2.updateConditional = updateConditional;
      function createTemplateExpression(head, templateSpans) {
        var node = createSynthesizedNode(211);
        node.head = head;
        node.templateSpans = createNodeArray(templateSpans);
        return node;
      }
      ts2.createTemplateExpression = createTemplateExpression;
      function updateTemplateExpression(node, head, templateSpans) {
        return node.head !== head || node.templateSpans !== templateSpans ? updateNode(createTemplateExpression(head, templateSpans), node) : node;
      }
      ts2.updateTemplateExpression = updateTemplateExpression;
      var rawTextScanner;
      var invalidValueSentinel = {};
      function getCookedText(kind, rawText) {
        if (!rawTextScanner) {
          rawTextScanner = ts2.createScanner(99, false, 0);
        }
        switch (kind) {
          case 14:
            rawTextScanner.setText("`" + rawText + "`");
            break;
          case 15:
            rawTextScanner.setText("`" + rawText + "${");
            break;
          case 16:
            rawTextScanner.setText("}" + rawText + "${");
            break;
          case 17:
            rawTextScanner.setText("}" + rawText + "`");
            break;
        }
        var token = rawTextScanner.scan();
        if (token === 23) {
          token = rawTextScanner.reScanTemplateToken(false);
        }
        if (rawTextScanner.isUnterminated()) {
          rawTextScanner.setText(void 0);
          return invalidValueSentinel;
        }
        var tokenValue;
        switch (token) {
          case 14:
          case 15:
          case 16:
          case 17:
            tokenValue = rawTextScanner.getTokenValue();
            break;
        }
        if (rawTextScanner.scan() !== 1) {
          rawTextScanner.setText(void 0);
          return invalidValueSentinel;
        }
        rawTextScanner.setText(void 0);
        return tokenValue;
      }
      function createTemplateLiteralLikeNode(kind, text, rawText) {
        var node = createSynthesizedNode(kind);
        node.text = text;
        if (rawText === void 0 || text === rawText) {
          node.rawText = rawText;
        } else {
          var cooked = getCookedText(kind, rawText);
          if (typeof cooked === "object") {
            return ts2.Debug.fail("Invalid raw text");
          }
          ts2.Debug.assert(text === cooked, "Expected argument 'text' to be the normalized (i.e. 'cooked') version of argument 'rawText'.");
          node.rawText = rawText;
        }
        return node;
      }
      function createTemplateHead(text, rawText) {
        var node = createTemplateLiteralLikeNode(15, text, rawText);
        node.text = text;
        return node;
      }
      ts2.createTemplateHead = createTemplateHead;
      function createTemplateMiddle(text, rawText) {
        var node = createTemplateLiteralLikeNode(16, text, rawText);
        node.text = text;
        return node;
      }
      ts2.createTemplateMiddle = createTemplateMiddle;
      function createTemplateTail(text, rawText) {
        var node = createTemplateLiteralLikeNode(17, text, rawText);
        node.text = text;
        return node;
      }
      ts2.createTemplateTail = createTemplateTail;
      function createNoSubstitutionTemplateLiteral(text, rawText) {
        var node = createTemplateLiteralLikeNode(14, text, rawText);
        return node;
      }
      ts2.createNoSubstitutionTemplateLiteral = createNoSubstitutionTemplateLiteral;
      function createYield(asteriskTokenOrExpression, expression) {
        var asteriskToken = asteriskTokenOrExpression && asteriskTokenOrExpression.kind === 41 ? asteriskTokenOrExpression : void 0;
        expression = asteriskTokenOrExpression && asteriskTokenOrExpression.kind !== 41 ? asteriskTokenOrExpression : expression;
        var node = createSynthesizedNode(212);
        node.asteriskToken = asteriskToken;
        node.expression = expression && ts2.parenthesizeExpressionForList(expression);
        return node;
      }
      ts2.createYield = createYield;
      function updateYield(node, asteriskToken, expression) {
        return node.expression !== expression || node.asteriskToken !== asteriskToken ? updateNode(createYield(asteriskToken, expression), node) : node;
      }
      ts2.updateYield = updateYield;
      function createSpread(expression) {
        var node = createSynthesizedNode(213);
        node.expression = ts2.parenthesizeExpressionForList(expression);
        return node;
      }
      ts2.createSpread = createSpread;
      function updateSpread(node, expression) {
        return node.expression !== expression ? updateNode(createSpread(expression), node) : node;
      }
      ts2.updateSpread = updateSpread;
      function createClassExpression(modifiers, name, typeParameters, heritageClauses, members) {
        var node = createSynthesizedNode(214);
        node.decorators = void 0;
        node.modifiers = asNodeArray(modifiers);
        node.name = asName(name);
        node.typeParameters = asNodeArray(typeParameters);
        node.heritageClauses = asNodeArray(heritageClauses);
        node.members = createNodeArray(members);
        return node;
      }
      ts2.createClassExpression = createClassExpression;
      function updateClassExpression(node, modifiers, name, typeParameters, heritageClauses, members) {
        return node.modifiers !== modifiers || node.name !== name || node.typeParameters !== typeParameters || node.heritageClauses !== heritageClauses || node.members !== members ? updateNode(createClassExpression(modifiers, name, typeParameters, heritageClauses, members), node) : node;
      }
      ts2.updateClassExpression = updateClassExpression;
      function createOmittedExpression() {
        return createSynthesizedNode(215);
      }
      ts2.createOmittedExpression = createOmittedExpression;
      function createExpressionWithTypeArguments(typeArguments, expression) {
        var node = createSynthesizedNode(216);
        node.expression = ts2.parenthesizeForAccess(expression);
        node.typeArguments = asNodeArray(typeArguments);
        return node;
      }
      ts2.createExpressionWithTypeArguments = createExpressionWithTypeArguments;
      function updateExpressionWithTypeArguments(node, typeArguments, expression) {
        return node.typeArguments !== typeArguments || node.expression !== expression ? updateNode(createExpressionWithTypeArguments(typeArguments, expression), node) : node;
      }
      ts2.updateExpressionWithTypeArguments = updateExpressionWithTypeArguments;
      function createAsExpression(expression, type) {
        var node = createSynthesizedNode(217);
        node.expression = expression;
        node.type = type;
        return node;
      }
      ts2.createAsExpression = createAsExpression;
      function updateAsExpression(node, expression, type) {
        return node.expression !== expression || node.type !== type ? updateNode(createAsExpression(expression, type), node) : node;
      }
      ts2.updateAsExpression = updateAsExpression;
      function createNonNullExpression(expression) {
        var node = createSynthesizedNode(218);
        node.expression = ts2.parenthesizeForAccess(expression);
        return node;
      }
      ts2.createNonNullExpression = createNonNullExpression;
      function updateNonNullExpression(node, expression) {
        if (ts2.isNonNullChain(node)) {
          return updateNonNullChain(node, expression);
        }
        return node.expression !== expression ? updateNode(createNonNullExpression(expression), node) : node;
      }
      ts2.updateNonNullExpression = updateNonNullExpression;
      function createNonNullChain(expression) {
        var node = createSynthesizedNode(218);
        node.flags |= 32;
        node.expression = ts2.parenthesizeForAccess(expression);
        return node;
      }
      ts2.createNonNullChain = createNonNullChain;
      function updateNonNullChain(node, expression) {
        ts2.Debug.assert(!!(node.flags & 32), "Cannot update a NonNullExpression using updateNonNullChain. Use updateNonNullExpression instead.");
        return node.expression !== expression ? updateNode(createNonNullChain(expression), node) : node;
      }
      ts2.updateNonNullChain = updateNonNullChain;
      function createMetaProperty(keywordToken, name) {
        var node = createSynthesizedNode(219);
        node.keywordToken = keywordToken;
        node.name = name;
        return node;
      }
      ts2.createMetaProperty = createMetaProperty;
      function updateMetaProperty(node, name) {
        return node.name !== name ? updateNode(createMetaProperty(node.keywordToken, name), node) : node;
      }
      ts2.updateMetaProperty = updateMetaProperty;
      function createTemplateSpan(expression, literal) {
        var node = createSynthesizedNode(221);
        node.expression = expression;
        node.literal = literal;
        return node;
      }
      ts2.createTemplateSpan = createTemplateSpan;
      function updateTemplateSpan(node, expression, literal) {
        return node.expression !== expression || node.literal !== literal ? updateNode(createTemplateSpan(expression, literal), node) : node;
      }
      ts2.updateTemplateSpan = updateTemplateSpan;
      function createSemicolonClassElement() {
        return createSynthesizedNode(222);
      }
      ts2.createSemicolonClassElement = createSemicolonClassElement;
      function createBlock(statements, multiLine) {
        var block = createSynthesizedNode(223);
        block.statements = createNodeArray(statements);
        if (multiLine)
          block.multiLine = multiLine;
        return block;
      }
      ts2.createBlock = createBlock;
      function updateBlock(node, statements) {
        return node.statements !== statements ? updateNode(createBlock(statements, node.multiLine), node) : node;
      }
      ts2.updateBlock = updateBlock;
      function createVariableStatement(modifiers, declarationList) {
        var node = createSynthesizedNode(225);
        node.decorators = void 0;
        node.modifiers = asNodeArray(modifiers);
        node.declarationList = ts2.isArray(declarationList) ? createVariableDeclarationList(declarationList) : declarationList;
        return node;
      }
      ts2.createVariableStatement = createVariableStatement;
      function updateVariableStatement(node, modifiers, declarationList) {
        return node.modifiers !== modifiers || node.declarationList !== declarationList ? updateNode(createVariableStatement(modifiers, declarationList), node) : node;
      }
      ts2.updateVariableStatement = updateVariableStatement;
      function createEmptyStatement() {
        return createSynthesizedNode(224);
      }
      ts2.createEmptyStatement = createEmptyStatement;
      function createExpressionStatement(expression) {
        var node = createSynthesizedNode(226);
        node.expression = ts2.parenthesizeExpressionForExpressionStatement(expression);
        return node;
      }
      ts2.createExpressionStatement = createExpressionStatement;
      function updateExpressionStatement(node, expression) {
        return node.expression !== expression ? updateNode(createExpressionStatement(expression), node) : node;
      }
      ts2.updateExpressionStatement = updateExpressionStatement;
      ts2.createStatement = createExpressionStatement;
      ts2.updateStatement = updateExpressionStatement;
      function createIf(expression, thenStatement, elseStatement) {
        var node = createSynthesizedNode(227);
        node.expression = expression;
        node.thenStatement = asEmbeddedStatement(thenStatement);
        node.elseStatement = asEmbeddedStatement(elseStatement);
        return node;
      }
      ts2.createIf = createIf;
      function updateIf(node, expression, thenStatement, elseStatement) {
        return node.expression !== expression || node.thenStatement !== thenStatement || node.elseStatement !== elseStatement ? updateNode(createIf(expression, thenStatement, elseStatement), node) : node;
      }
      ts2.updateIf = updateIf;
      function createDo(statement, expression) {
        var node = createSynthesizedNode(228);
        node.statement = asEmbeddedStatement(statement);
        node.expression = expression;
        return node;
      }
      ts2.createDo = createDo;
      function updateDo(node, statement, expression) {
        return node.statement !== statement || node.expression !== expression ? updateNode(createDo(statement, expression), node) : node;
      }
      ts2.updateDo = updateDo;
      function createWhile(expression, statement) {
        var node = createSynthesizedNode(229);
        node.expression = expression;
        node.statement = asEmbeddedStatement(statement);
        return node;
      }
      ts2.createWhile = createWhile;
      function updateWhile(node, expression, statement) {
        return node.expression !== expression || node.statement !== statement ? updateNode(createWhile(expression, statement), node) : node;
      }
      ts2.updateWhile = updateWhile;
      function createFor(initializer, condition, incrementor, statement) {
        var node = createSynthesizedNode(230);
        node.initializer = initializer;
        node.condition = condition;
        node.incrementor = incrementor;
        node.statement = asEmbeddedStatement(statement);
        return node;
      }
      ts2.createFor = createFor;
      function updateFor(node, initializer, condition, incrementor, statement) {
        return node.initializer !== initializer || node.condition !== condition || node.incrementor !== incrementor || node.statement !== statement ? updateNode(createFor(initializer, condition, incrementor, statement), node) : node;
      }
      ts2.updateFor = updateFor;
      function createForIn(initializer, expression, statement) {
        var node = createSynthesizedNode(231);
        node.initializer = initializer;
        node.expression = expression;
        node.statement = asEmbeddedStatement(statement);
        return node;
      }
      ts2.createForIn = createForIn;
      function updateForIn(node, initializer, expression, statement) {
        return node.initializer !== initializer || node.expression !== expression || node.statement !== statement ? updateNode(createForIn(initializer, expression, statement), node) : node;
      }
      ts2.updateForIn = updateForIn;
      function createForOf(awaitModifier, initializer, expression, statement) {
        var node = createSynthesizedNode(232);
        node.awaitModifier = awaitModifier;
        node.initializer = initializer;
        node.expression = ts2.isCommaSequence(expression) ? createParen(expression) : expression;
        node.statement = asEmbeddedStatement(statement);
        return node;
      }
      ts2.createForOf = createForOf;
      function updateForOf(node, awaitModifier, initializer, expression, statement) {
        return node.awaitModifier !== awaitModifier || node.initializer !== initializer || node.expression !== expression || node.statement !== statement ? updateNode(createForOf(awaitModifier, initializer, expression, statement), node) : node;
      }
      ts2.updateForOf = updateForOf;
      function createContinue(label) {
        var node = createSynthesizedNode(233);
        node.label = asName(label);
        return node;
      }
      ts2.createContinue = createContinue;
      function updateContinue(node, label) {
        return node.label !== label ? updateNode(createContinue(label), node) : node;
      }
      ts2.updateContinue = updateContinue;
      function createBreak(label) {
        var node = createSynthesizedNode(234);
        node.label = asName(label);
        return node;
      }
      ts2.createBreak = createBreak;
      function updateBreak(node, label) {
        return node.label !== label ? updateNode(createBreak(label), node) : node;
      }
      ts2.updateBreak = updateBreak;
      function createReturn(expression) {
        var node = createSynthesizedNode(235);
        node.expression = expression;
        return node;
      }
      ts2.createReturn = createReturn;
      function updateReturn(node, expression) {
        return node.expression !== expression ? updateNode(createReturn(expression), node) : node;
      }
      ts2.updateReturn = updateReturn;
      function createWith(expression, statement) {
        var node = createSynthesizedNode(236);
        node.expression = expression;
        node.statement = asEmbeddedStatement(statement);
        return node;
      }
      ts2.createWith = createWith;
      function updateWith(node, expression, statement) {
        return node.expression !== expression || node.statement !== statement ? updateNode(createWith(expression, statement), node) : node;
      }
      ts2.updateWith = updateWith;
      function createSwitch(expression, caseBlock) {
        var node = createSynthesizedNode(237);
        node.expression = ts2.parenthesizeExpressionForList(expression);
        node.caseBlock = caseBlock;
        return node;
      }
      ts2.createSwitch = createSwitch;
      function updateSwitch(node, expression, caseBlock) {
        return node.expression !== expression || node.caseBlock !== caseBlock ? updateNode(createSwitch(expression, caseBlock), node) : node;
      }
      ts2.updateSwitch = updateSwitch;
      function createLabel(label, statement) {
        var node = createSynthesizedNode(238);
        node.label = asName(label);
        node.statement = asEmbeddedStatement(statement);
        return node;
      }
      ts2.createLabel = createLabel;
      function updateLabel(node, label, statement) {
        return node.label !== label || node.statement !== statement ? updateNode(createLabel(label, statement), node) : node;
      }
      ts2.updateLabel = updateLabel;
      function createThrow(expression) {
        var node = createSynthesizedNode(239);
        node.expression = expression;
        return node;
      }
      ts2.createThrow = createThrow;
      function updateThrow(node, expression) {
        return node.expression !== expression ? updateNode(createThrow(expression), node) : node;
      }
      ts2.updateThrow = updateThrow;
      function createTry(tryBlock, catchClause, finallyBlock) {
        var node = createSynthesizedNode(240);
        node.tryBlock = tryBlock;
        node.catchClause = catchClause;
        node.finallyBlock = finallyBlock;
        return node;
      }
      ts2.createTry = createTry;
      function updateTry(node, tryBlock, catchClause, finallyBlock) {
        return node.tryBlock !== tryBlock || node.catchClause !== catchClause || node.finallyBlock !== finallyBlock ? updateNode(createTry(tryBlock, catchClause, finallyBlock), node) : node;
      }
      ts2.updateTry = updateTry;
      function createDebuggerStatement() {
        return createSynthesizedNode(241);
      }
      ts2.createDebuggerStatement = createDebuggerStatement;
      function createVariableDeclaration(name, type, initializer) {
        var node = createSynthesizedNode(242);
        node.name = asName(name);
        node.type = type;
        node.initializer = initializer !== void 0 ? ts2.parenthesizeExpressionForList(initializer) : void 0;
        return node;
      }
      ts2.createVariableDeclaration = createVariableDeclaration;
      function updateVariableDeclaration(node, name, type, initializer) {
        return node.name !== name || node.type !== type || node.initializer !== initializer ? updateNode(createVariableDeclaration(name, type, initializer), node) : node;
      }
      ts2.updateVariableDeclaration = updateVariableDeclaration;
      function createTypeScriptVariableDeclaration(name, exclaimationToken, type, initializer) {
        var node = createSynthesizedNode(242);
        node.name = asName(name);
        node.type = type;
        node.initializer = initializer !== void 0 ? ts2.parenthesizeExpressionForList(initializer) : void 0;
        node.exclamationToken = exclaimationToken;
        return node;
      }
      ts2.createTypeScriptVariableDeclaration = createTypeScriptVariableDeclaration;
      function updateTypeScriptVariableDeclaration(node, name, exclaimationToken, type, initializer) {
        return node.name !== name || node.type !== type || node.initializer !== initializer || node.exclamationToken !== exclaimationToken ? updateNode(createTypeScriptVariableDeclaration(name, exclaimationToken, type, initializer), node) : node;
      }
      ts2.updateTypeScriptVariableDeclaration = updateTypeScriptVariableDeclaration;
      function createVariableDeclarationList(declarations, flags) {
        if (flags === void 0) {
          flags = 0;
        }
        var node = createSynthesizedNode(243);
        node.flags |= flags & 3;
        node.declarations = createNodeArray(declarations);
        return node;
      }
      ts2.createVariableDeclarationList = createVariableDeclarationList;
      function updateVariableDeclarationList(node, declarations) {
        return node.declarations !== declarations ? updateNode(createVariableDeclarationList(declarations, node.flags), node) : node;
      }
      ts2.updateVariableDeclarationList = updateVariableDeclarationList;
      function createFunctionDeclaration(decorators, modifiers, asteriskToken, name, typeParameters, parameters, type, body) {
        var node = createSynthesizedNode(244);
        node.decorators = asNodeArray(decorators);
        node.modifiers = asNodeArray(modifiers);
        node.asteriskToken = asteriskToken;
        node.name = asName(name);
        node.typeParameters = asNodeArray(typeParameters);
        node.parameters = createNodeArray(parameters);
        node.type = type;
        node.body = body;
        return node;
      }
      ts2.createFunctionDeclaration = createFunctionDeclaration;
      function updateFunctionDeclaration(node, decorators, modifiers, asteriskToken, name, typeParameters, parameters, type, body) {
        return node.decorators !== decorators || node.modifiers !== modifiers || node.asteriskToken !== asteriskToken || node.name !== name || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type || node.body !== body ? updateNode(createFunctionDeclaration(decorators, modifiers, asteriskToken, name, typeParameters, parameters, type, body), node) : node;
      }
      ts2.updateFunctionDeclaration = updateFunctionDeclaration;
      function updateFunctionLikeBody(declaration, body) {
        switch (declaration.kind) {
          case 244:
            return createFunctionDeclaration(declaration.decorators, declaration.modifiers, declaration.asteriskToken, declaration.name, declaration.typeParameters, declaration.parameters, declaration.type, body);
          case 161:
            return createMethod(declaration.decorators, declaration.modifiers, declaration.asteriskToken, declaration.name, declaration.questionToken, declaration.typeParameters, declaration.parameters, declaration.type, body);
          case 163:
            return createGetAccessor(declaration.decorators, declaration.modifiers, declaration.name, declaration.parameters, declaration.type, body);
          case 164:
            return createSetAccessor(declaration.decorators, declaration.modifiers, declaration.name, declaration.parameters, body);
          case 162:
            return createConstructor(declaration.decorators, declaration.modifiers, declaration.parameters, body);
          case 201:
            return createFunctionExpression(declaration.modifiers, declaration.asteriskToken, declaration.name, declaration.typeParameters, declaration.parameters, declaration.type, body);
          case 202:
            return createArrowFunction(declaration.modifiers, declaration.typeParameters, declaration.parameters, declaration.type, declaration.equalsGreaterThanToken, body);
        }
      }
      ts2.updateFunctionLikeBody = updateFunctionLikeBody;
      function createClassDeclaration(decorators, modifiers, name, typeParameters, heritageClauses, members) {
        var node = createSynthesizedNode(245);
        node.decorators = asNodeArray(decorators);
        node.modifiers = asNodeArray(modifiers);
        node.name = asName(name);
        node.typeParameters = asNodeArray(typeParameters);
        node.heritageClauses = asNodeArray(heritageClauses);
        node.members = createNodeArray(members);
        return node;
      }
      ts2.createClassDeclaration = createClassDeclaration;
      function updateClassDeclaration(node, decorators, modifiers, name, typeParameters, heritageClauses, members) {
        return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.typeParameters !== typeParameters || node.heritageClauses !== heritageClauses || node.members !== members ? updateNode(createClassDeclaration(decorators, modifiers, name, typeParameters, heritageClauses, members), node) : node;
      }
      ts2.updateClassDeclaration = updateClassDeclaration;
      function createInterfaceDeclaration(decorators, modifiers, name, typeParameters, heritageClauses, members) {
        var node = createSynthesizedNode(246);
        node.decorators = asNodeArray(decorators);
        node.modifiers = asNodeArray(modifiers);
        node.name = asName(name);
        node.typeParameters = asNodeArray(typeParameters);
        node.heritageClauses = asNodeArray(heritageClauses);
        node.members = createNodeArray(members);
        return node;
      }
      ts2.createInterfaceDeclaration = createInterfaceDeclaration;
      function updateInterfaceDeclaration(node, decorators, modifiers, name, typeParameters, heritageClauses, members) {
        return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.typeParameters !== typeParameters || node.heritageClauses !== heritageClauses || node.members !== members ? updateNode(createInterfaceDeclaration(decorators, modifiers, name, typeParameters, heritageClauses, members), node) : node;
      }
      ts2.updateInterfaceDeclaration = updateInterfaceDeclaration;
      function createTypeAliasDeclaration(decorators, modifiers, name, typeParameters, type) {
        var node = createSynthesizedNode(247);
        node.decorators = asNodeArray(decorators);
        node.modifiers = asNodeArray(modifiers);
        node.name = asName(name);
        node.typeParameters = asNodeArray(typeParameters);
        node.type = type;
        return node;
      }
      ts2.createTypeAliasDeclaration = createTypeAliasDeclaration;
      function updateTypeAliasDeclaration(node, decorators, modifiers, name, typeParameters, type) {
        return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.typeParameters !== typeParameters || node.type !== type ? updateNode(createTypeAliasDeclaration(decorators, modifiers, name, typeParameters, type), node) : node;
      }
      ts2.updateTypeAliasDeclaration = updateTypeAliasDeclaration;
      function createEnumDeclaration(decorators, modifiers, name, members) {
        var node = createSynthesizedNode(248);
        node.decorators = asNodeArray(decorators);
        node.modifiers = asNodeArray(modifiers);
        node.name = asName(name);
        node.members = createNodeArray(members);
        return node;
      }
      ts2.createEnumDeclaration = createEnumDeclaration;
      function updateEnumDeclaration(node, decorators, modifiers, name, members) {
        return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.members !== members ? updateNode(createEnumDeclaration(decorators, modifiers, name, members), node) : node;
      }
      ts2.updateEnumDeclaration = updateEnumDeclaration;
      function createModuleDeclaration(decorators, modifiers, name, body, flags) {
        if (flags === void 0) {
          flags = 0;
        }
        var node = createSynthesizedNode(249);
        node.flags |= flags & (16 | 4 | 1024);
        node.decorators = asNodeArray(decorators);
        node.modifiers = asNodeArray(modifiers);
        node.name = name;
        node.body = body;
        return node;
      }
      ts2.createModuleDeclaration = createModuleDeclaration;
      function updateModuleDeclaration(node, decorators, modifiers, name, body) {
        return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.body !== body ? updateNode(createModuleDeclaration(decorators, modifiers, name, body, node.flags), node) : node;
      }
      ts2.updateModuleDeclaration = updateModuleDeclaration;
      function createModuleBlock(statements) {
        var node = createSynthesizedNode(250);
        node.statements = createNodeArray(statements);
        return node;
      }
      ts2.createModuleBlock = createModuleBlock;
      function updateModuleBlock(node, statements) {
        return node.statements !== statements ? updateNode(createModuleBlock(statements), node) : node;
      }
      ts2.updateModuleBlock = updateModuleBlock;
      function createCaseBlock(clauses) {
        var node = createSynthesizedNode(251);
        node.clauses = createNodeArray(clauses);
        return node;
      }
      ts2.createCaseBlock = createCaseBlock;
      function updateCaseBlock(node, clauses) {
        return node.clauses !== clauses ? updateNode(createCaseBlock(clauses), node) : node;
      }
      ts2.updateCaseBlock = updateCaseBlock;
      function createNamespaceExportDeclaration(name) {
        var node = createSynthesizedNode(252);
        node.name = asName(name);
        return node;
      }
      ts2.createNamespaceExportDeclaration = createNamespaceExportDeclaration;
      function updateNamespaceExportDeclaration(node, name) {
        return node.name !== name ? updateNode(createNamespaceExportDeclaration(name), node) : node;
      }
      ts2.updateNamespaceExportDeclaration = updateNamespaceExportDeclaration;
      function createImportEqualsDeclaration(decorators, modifiers, name, moduleReference) {
        var node = createSynthesizedNode(253);
        node.decorators = asNodeArray(decorators);
        node.modifiers = asNodeArray(modifiers);
        node.name = asName(name);
        node.moduleReference = moduleReference;
        return node;
      }
      ts2.createImportEqualsDeclaration = createImportEqualsDeclaration;
      function updateImportEqualsDeclaration(node, decorators, modifiers, name, moduleReference) {
        return node.decorators !== decorators || node.modifiers !== modifiers || node.name !== name || node.moduleReference !== moduleReference ? updateNode(createImportEqualsDeclaration(decorators, modifiers, name, moduleReference), node) : node;
      }
      ts2.updateImportEqualsDeclaration = updateImportEqualsDeclaration;
      function createImportDeclaration(decorators, modifiers, importClause, moduleSpecifier) {
        var node = createSynthesizedNode(254);
        node.decorators = asNodeArray(decorators);
        node.modifiers = asNodeArray(modifiers);
        node.importClause = importClause;
        node.moduleSpecifier = moduleSpecifier;
        return node;
      }
      ts2.createImportDeclaration = createImportDeclaration;
      function updateImportDeclaration(node, decorators, modifiers, importClause, moduleSpecifier) {
        return node.decorators !== decorators || node.modifiers !== modifiers || node.importClause !== importClause || node.moduleSpecifier !== moduleSpecifier ? updateNode(createImportDeclaration(decorators, modifiers, importClause, moduleSpecifier), node) : node;
      }
      ts2.updateImportDeclaration = updateImportDeclaration;
      function createImportClause(name, namedBindings, isTypeOnly) {
        if (isTypeOnly === void 0) {
          isTypeOnly = false;
        }
        var node = createSynthesizedNode(255);
        node.name = name;
        node.namedBindings = namedBindings;
        node.isTypeOnly = isTypeOnly;
        return node;
      }
      ts2.createImportClause = createImportClause;
      function updateImportClause(node, name, namedBindings, isTypeOnly) {
        return node.name !== name || node.namedBindings !== namedBindings || node.isTypeOnly !== isTypeOnly ? updateNode(createImportClause(name, namedBindings, isTypeOnly), node) : node;
      }
      ts2.updateImportClause = updateImportClause;
      function createNamespaceImport(name) {
        var node = createSynthesizedNode(256);
        node.name = name;
        return node;
      }
      ts2.createNamespaceImport = createNamespaceImport;
      function createNamespaceExport(name) {
        var node = createSynthesizedNode(262);
        node.name = name;
        return node;
      }
      ts2.createNamespaceExport = createNamespaceExport;
      function updateNamespaceImport(node, name) {
        return node.name !== name ? updateNode(createNamespaceImport(name), node) : node;
      }
      ts2.updateNamespaceImport = updateNamespaceImport;
      function updateNamespaceExport(node, name) {
        return node.name !== name ? updateNode(createNamespaceExport(name), node) : node;
      }
      ts2.updateNamespaceExport = updateNamespaceExport;
      function createNamedImports(elements) {
        var node = createSynthesizedNode(257);
        node.elements = createNodeArray(elements);
        return node;
      }
      ts2.createNamedImports = createNamedImports;
      function updateNamedImports(node, elements) {
        return node.elements !== elements ? updateNode(createNamedImports(elements), node) : node;
      }
      ts2.updateNamedImports = updateNamedImports;
      function createImportSpecifier(propertyName, name) {
        var node = createSynthesizedNode(258);
        node.propertyName = propertyName;
        node.name = name;
        return node;
      }
      ts2.createImportSpecifier = createImportSpecifier;
      function updateImportSpecifier(node, propertyName, name) {
        return node.propertyName !== propertyName || node.name !== name ? updateNode(createImportSpecifier(propertyName, name), node) : node;
      }
      ts2.updateImportSpecifier = updateImportSpecifier;
      function createExportAssignment(decorators, modifiers, isExportEquals, expression) {
        var node = createSynthesizedNode(259);
        node.decorators = asNodeArray(decorators);
        node.modifiers = asNodeArray(modifiers);
        node.isExportEquals = isExportEquals;
        node.expression = isExportEquals ? ts2.parenthesizeBinaryOperand(62, expression, false, void 0) : ts2.parenthesizeDefaultExpression(expression);
        return node;
      }
      ts2.createExportAssignment = createExportAssignment;
      function updateExportAssignment(node, decorators, modifiers, expression) {
        return node.decorators !== decorators || node.modifiers !== modifiers || node.expression !== expression ? updateNode(createExportAssignment(decorators, modifiers, node.isExportEquals, expression), node) : node;
      }
      ts2.updateExportAssignment = updateExportAssignment;
      function createExportDeclaration(decorators, modifiers, exportClause, moduleSpecifier, isTypeOnly) {
        if (isTypeOnly === void 0) {
          isTypeOnly = false;
        }
        var node = createSynthesizedNode(260);
        node.decorators = asNodeArray(decorators);
        node.modifiers = asNodeArray(modifiers);
        node.isTypeOnly = isTypeOnly;
        node.exportClause = exportClause;
        node.moduleSpecifier = moduleSpecifier;
        return node;
      }
      ts2.createExportDeclaration = createExportDeclaration;
      function updateExportDeclaration(node, decorators, modifiers, exportClause, moduleSpecifier, isTypeOnly) {
        return node.decorators !== decorators || node.modifiers !== modifiers || node.isTypeOnly !== isTypeOnly || node.exportClause !== exportClause || node.moduleSpecifier !== moduleSpecifier ? updateNode(createExportDeclaration(decorators, modifiers, exportClause, moduleSpecifier, isTypeOnly), node) : node;
      }
      ts2.updateExportDeclaration = updateExportDeclaration;
      function createEmptyExports() {
        return createExportDeclaration(void 0, void 0, createNamedExports([]), void 0);
      }
      ts2.createEmptyExports = createEmptyExports;
      function createNamedExports(elements) {
        var node = createSynthesizedNode(261);
        node.elements = createNodeArray(elements);
        return node;
      }
      ts2.createNamedExports = createNamedExports;
      function updateNamedExports(node, elements) {
        return node.elements !== elements ? updateNode(createNamedExports(elements), node) : node;
      }
      ts2.updateNamedExports = updateNamedExports;
      function createExportSpecifier(propertyName, name) {
        var node = createSynthesizedNode(263);
        node.propertyName = asName(propertyName);
        node.name = asName(name);
        return node;
      }
      ts2.createExportSpecifier = createExportSpecifier;
      function updateExportSpecifier(node, propertyName, name) {
        return node.propertyName !== propertyName || node.name !== name ? updateNode(createExportSpecifier(propertyName, name), node) : node;
      }
      ts2.updateExportSpecifier = updateExportSpecifier;
      function createExternalModuleReference(expression) {
        var node = createSynthesizedNode(265);
        node.expression = expression;
        return node;
      }
      ts2.createExternalModuleReference = createExternalModuleReference;
      function updateExternalModuleReference(node, expression) {
        return node.expression !== expression ? updateNode(createExternalModuleReference(expression), node) : node;
      }
      ts2.updateExternalModuleReference = updateExternalModuleReference;
      function createJSDocTypeExpression(type) {
        var node = createSynthesizedNode(294);
        node.type = type;
        return node;
      }
      ts2.createJSDocTypeExpression = createJSDocTypeExpression;
      function createJSDocTypeTag(typeExpression, comment) {
        var tag = createJSDocTag(320, "type");
        tag.typeExpression = typeExpression;
        tag.comment = comment;
        return tag;
      }
      ts2.createJSDocTypeTag = createJSDocTypeTag;
      function createJSDocReturnTag(typeExpression, comment) {
        var tag = createJSDocTag(318, "returns");
        tag.typeExpression = typeExpression;
        tag.comment = comment;
        return tag;
      }
      ts2.createJSDocReturnTag = createJSDocReturnTag;
      function createJSDocThisTag(typeExpression) {
        var tag = createJSDocTag(319, "this");
        tag.typeExpression = typeExpression;
        return tag;
      }
      ts2.createJSDocThisTag = createJSDocThisTag;
      function createJSDocParamTag(name, isBracketed, typeExpression, comment) {
        var tag = createJSDocTag(317, "param");
        tag.typeExpression = typeExpression;
        tag.name = name;
        tag.isBracketed = isBracketed;
        tag.comment = comment;
        return tag;
      }
      ts2.createJSDocParamTag = createJSDocParamTag;
      function createJSDocClassTag() {
        return createJSDocTag(310, "class");
      }
      ts2.createJSDocClassTag = createJSDocClassTag;
      function createJSDocComment(comment, tags) {
        var node = createSynthesizedNode(303);
        node.comment = comment;
        node.tags = tags;
        return node;
      }
      ts2.createJSDocComment = createJSDocComment;
      function createJSDocTag(kind, tagName) {
        var node = createSynthesizedNode(kind);
        node.tagName = createIdentifier(tagName);
        return node;
      }
      function createJsxElement(openingElement, children, closingElement) {
        var node = createSynthesizedNode(266);
        node.openingElement = openingElement;
        node.children = createNodeArray(children);
        node.closingElement = closingElement;
        return node;
      }
      ts2.createJsxElement = createJsxElement;
      function updateJsxElement(node, openingElement, children, closingElement) {
        return node.openingElement !== openingElement || node.children !== children || node.closingElement !== closingElement ? updateNode(createJsxElement(openingElement, children, closingElement), node) : node;
      }
      ts2.updateJsxElement = updateJsxElement;
      function createJsxSelfClosingElement(tagName, typeArguments, attributes) {
        var node = createSynthesizedNode(267);
        node.tagName = tagName;
        node.typeArguments = asNodeArray(typeArguments);
        node.attributes = attributes;
        return node;
      }
      ts2.createJsxSelfClosingElement = createJsxSelfClosingElement;
      function updateJsxSelfClosingElement(node, tagName, typeArguments, attributes) {
        return node.tagName !== tagName || node.typeArguments !== typeArguments || node.attributes !== attributes ? updateNode(createJsxSelfClosingElement(tagName, typeArguments, attributes), node) : node;
      }
      ts2.updateJsxSelfClosingElement = updateJsxSelfClosingElement;
      function createJsxOpeningElement(tagName, typeArguments, attributes) {
        var node = createSynthesizedNode(268);
        node.tagName = tagName;
        node.typeArguments = asNodeArray(typeArguments);
        node.attributes = attributes;
        return node;
      }
      ts2.createJsxOpeningElement = createJsxOpeningElement;
      function updateJsxOpeningElement(node, tagName, typeArguments, attributes) {
        return node.tagName !== tagName || node.typeArguments !== typeArguments || node.attributes !== attributes ? updateNode(createJsxOpeningElement(tagName, typeArguments, attributes), node) : node;
      }
      ts2.updateJsxOpeningElement = updateJsxOpeningElement;
      function createJsxClosingElement(tagName) {
        var node = createSynthesizedNode(269);
        node.tagName = tagName;
        return node;
      }
      ts2.createJsxClosingElement = createJsxClosingElement;
      function updateJsxClosingElement(node, tagName) {
        return node.tagName !== tagName ? updateNode(createJsxClosingElement(tagName), node) : node;
      }
      ts2.updateJsxClosingElement = updateJsxClosingElement;
      function createJsxFragment(openingFragment, children, closingFragment) {
        var node = createSynthesizedNode(270);
        node.openingFragment = openingFragment;
        node.children = createNodeArray(children);
        node.closingFragment = closingFragment;
        return node;
      }
      ts2.createJsxFragment = createJsxFragment;
      function createJsxText(text, containsOnlyTriviaWhiteSpaces) {
        var node = createSynthesizedNode(11);
        node.text = text;
        node.containsOnlyTriviaWhiteSpaces = !!containsOnlyTriviaWhiteSpaces;
        return node;
      }
      ts2.createJsxText = createJsxText;
      function updateJsxText(node, text, containsOnlyTriviaWhiteSpaces) {
        return node.text !== text || node.containsOnlyTriviaWhiteSpaces !== containsOnlyTriviaWhiteSpaces ? updateNode(createJsxText(text, containsOnlyTriviaWhiteSpaces), node) : node;
      }
      ts2.updateJsxText = updateJsxText;
      function createJsxOpeningFragment() {
        return createSynthesizedNode(271);
      }
      ts2.createJsxOpeningFragment = createJsxOpeningFragment;
      function createJsxJsxClosingFragment() {
        return createSynthesizedNode(272);
      }
      ts2.createJsxJsxClosingFragment = createJsxJsxClosingFragment;
      function updateJsxFragment(node, openingFragment, children, closingFragment) {
        return node.openingFragment !== openingFragment || node.children !== children || node.closingFragment !== closingFragment ? updateNode(createJsxFragment(openingFragment, children, closingFragment), node) : node;
      }
      ts2.updateJsxFragment = updateJsxFragment;
      function createJsxAttribute(name, initializer) {
        var node = createSynthesizedNode(273);
        node.name = name;
        node.initializer = initializer;
        return node;
      }
      ts2.createJsxAttribute = createJsxAttribute;
      function updateJsxAttribute(node, name, initializer) {
        return node.name !== name || node.initializer !== initializer ? updateNode(createJsxAttribute(name, initializer), node) : node;
      }
      ts2.updateJsxAttribute = updateJsxAttribute;
      function createJsxAttributes(properties) {
        var node = createSynthesizedNode(274);
        node.properties = createNodeArray(properties);
        return node;
      }
      ts2.createJsxAttributes = createJsxAttributes;
      function updateJsxAttributes(node, properties) {
        return node.properties !== properties ? updateNode(createJsxAttributes(properties), node) : node;
      }
      ts2.updateJsxAttributes = updateJsxAttributes;
      function createJsxSpreadAttribute(expression) {
        var node = createSynthesizedNode(275);
        node.expression = expression;
        return node;
      }
      ts2.createJsxSpreadAttribute = createJsxSpreadAttribute;
      function updateJsxSpreadAttribute(node, expression) {
        return node.expression !== expression ? updateNode(createJsxSpreadAttribute(expression), node) : node;
      }
      ts2.updateJsxSpreadAttribute = updateJsxSpreadAttribute;
      function createJsxExpression(dotDotDotToken, expression) {
        var node = createSynthesizedNode(276);
        node.dotDotDotToken = dotDotDotToken;
        node.expression = expression;
        return node;
      }
      ts2.createJsxExpression = createJsxExpression;
      function updateJsxExpression(node, expression) {
        return node.expression !== expression ? updateNode(createJsxExpression(node.dotDotDotToken, expression), node) : node;
      }
      ts2.updateJsxExpression = updateJsxExpression;
      function createCaseClause(expression, statements) {
        var node = createSynthesizedNode(277);
        node.expression = ts2.parenthesizeExpressionForList(expression);
        node.statements = createNodeArray(statements);
        return node;
      }
      ts2.createCaseClause = createCaseClause;
      function updateCaseClause(node, expression, statements) {
        return node.expression !== expression || node.statements !== statements ? updateNode(createCaseClause(expression, statements), node) : node;
      }
      ts2.updateCaseClause = updateCaseClause;
      function createDefaultClause(statements) {
        var node = createSynthesizedNode(278);
        node.statements = createNodeArray(statements);
        return node;
      }
      ts2.createDefaultClause = createDefaultClause;
      function updateDefaultClause(node, statements) {
        return node.statements !== statements ? updateNode(createDefaultClause(statements), node) : node;
      }
      ts2.updateDefaultClause = updateDefaultClause;
      function createHeritageClause(token, types) {
        var node = createSynthesizedNode(279);
        node.token = token;
        node.types = createNodeArray(types);
        return node;
      }
      ts2.createHeritageClause = createHeritageClause;
      function updateHeritageClause(node, types) {
        return node.types !== types ? updateNode(createHeritageClause(node.token, types), node) : node;
      }
      ts2.updateHeritageClause = updateHeritageClause;
      function createCatchClause(variableDeclaration, block) {
        var node = createSynthesizedNode(280);
        node.variableDeclaration = ts2.isString(variableDeclaration) ? createVariableDeclaration(variableDeclaration) : variableDeclaration;
        node.block = block;
        return node;
      }
      ts2.createCatchClause = createCatchClause;
      function updateCatchClause(node, variableDeclaration, block) {
        return node.variableDeclaration !== variableDeclaration || node.block !== block ? updateNode(createCatchClause(variableDeclaration, block), node) : node;
      }
      ts2.updateCatchClause = updateCatchClause;
      function createPropertyAssignment(name, initializer) {
        var node = createSynthesizedNode(281);
        node.name = asName(name);
        node.questionToken = void 0;
        node.initializer = ts2.parenthesizeExpressionForList(initializer);
        return node;
      }
      ts2.createPropertyAssignment = createPropertyAssignment;
      function updatePropertyAssignment(node, name, initializer) {
        return node.name !== name || node.initializer !== initializer ? updateNode(createPropertyAssignment(name, initializer), node) : node;
      }
      ts2.updatePropertyAssignment = updatePropertyAssignment;
      function createShorthandPropertyAssignment(name, objectAssignmentInitializer) {
        var node = createSynthesizedNode(282);
        node.name = asName(name);
        node.objectAssignmentInitializer = objectAssignmentInitializer !== void 0 ? ts2.parenthesizeExpressionForList(objectAssignmentInitializer) : void 0;
        return node;
      }
      ts2.createShorthandPropertyAssignment = createShorthandPropertyAssignment;
      function updateShorthandPropertyAssignment(node, name, objectAssignmentInitializer) {
        return node.name !== name || node.objectAssignmentInitializer !== objectAssignmentInitializer ? updateNode(createShorthandPropertyAssignment(name, objectAssignmentInitializer), node) : node;
      }
      ts2.updateShorthandPropertyAssignment = updateShorthandPropertyAssignment;
      function createSpreadAssignment(expression) {
        var node = createSynthesizedNode(283);
        node.expression = ts2.parenthesizeExpressionForList(expression);
        return node;
      }
      ts2.createSpreadAssignment = createSpreadAssignment;
      function updateSpreadAssignment(node, expression) {
        return node.expression !== expression ? updateNode(createSpreadAssignment(expression), node) : node;
      }
      ts2.updateSpreadAssignment = updateSpreadAssignment;
      function createEnumMember(name, initializer) {
        var node = createSynthesizedNode(284);
        node.name = asName(name);
        node.initializer = initializer && ts2.parenthesizeExpressionForList(initializer);
        return node;
      }
      ts2.createEnumMember = createEnumMember;
      function updateEnumMember(node, name, initializer) {
        return node.name !== name || node.initializer !== initializer ? updateNode(createEnumMember(name, initializer), node) : node;
      }
      ts2.updateEnumMember = updateEnumMember;
      function updateSourceFileNode(node, statements, isDeclarationFile, referencedFiles, typeReferences, hasNoDefaultLib, libReferences) {
        if (node.statements !== statements || isDeclarationFile !== void 0 && node.isDeclarationFile !== isDeclarationFile || referencedFiles !== void 0 && node.referencedFiles !== referencedFiles || typeReferences !== void 0 && node.typeReferenceDirectives !== typeReferences || libReferences !== void 0 && node.libReferenceDirectives !== libReferences || hasNoDefaultLib !== void 0 && node.hasNoDefaultLib !== hasNoDefaultLib) {
          var updated = createSynthesizedNode(290);
          updated.flags |= node.flags;
          updated.statements = createNodeArray(statements);
          updated.endOfFileToken = node.endOfFileToken;
          updated.fileName = node.fileName;
          updated.path = node.path;
          updated.text = node.text;
          updated.isDeclarationFile = isDeclarationFile === void 0 ? node.isDeclarationFile : isDeclarationFile;
          updated.referencedFiles = referencedFiles === void 0 ? node.referencedFiles : referencedFiles;
          updated.typeReferenceDirectives = typeReferences === void 0 ? node.typeReferenceDirectives : typeReferences;
          updated.hasNoDefaultLib = hasNoDefaultLib === void 0 ? node.hasNoDefaultLib : hasNoDefaultLib;
          updated.libReferenceDirectives = libReferences === void 0 ? node.libReferenceDirectives : libReferences;
          if (node.amdDependencies !== void 0)
            updated.amdDependencies = node.amdDependencies;
          if (node.moduleName !== void 0)
            updated.moduleName = node.moduleName;
          if (node.languageVariant !== void 0)
            updated.languageVariant = node.languageVariant;
          if (node.renamedDependencies !== void 0)
            updated.renamedDependencies = node.renamedDependencies;
          if (node.languageVersion !== void 0)
            updated.languageVersion = node.languageVersion;
          if (node.scriptKind !== void 0)
            updated.scriptKind = node.scriptKind;
          if (node.externalModuleIndicator !== void 0)
            updated.externalModuleIndicator = node.externalModuleIndicator;
          if (node.commonJsModuleIndicator !== void 0)
            updated.commonJsModuleIndicator = node.commonJsModuleIndicator;
          if (node.identifiers !== void 0)
            updated.identifiers = node.identifiers;
          if (node.nodeCount !== void 0)
            updated.nodeCount = node.nodeCount;
          if (node.identifierCount !== void 0)
            updated.identifierCount = node.identifierCount;
          if (node.symbolCount !== void 0)
            updated.symbolCount = node.symbolCount;
          if (node.parseDiagnostics !== void 0)
            updated.parseDiagnostics = node.parseDiagnostics;
          if (node.bindDiagnostics !== void 0)
            updated.bindDiagnostics = node.bindDiagnostics;
          if (node.bindSuggestionDiagnostics !== void 0)
            updated.bindSuggestionDiagnostics = node.bindSuggestionDiagnostics;
          if (node.lineMap !== void 0)
            updated.lineMap = node.lineMap;
          if (node.classifiableNames !== void 0)
            updated.classifiableNames = node.classifiableNames;
          if (node.resolvedModules !== void 0)
            updated.resolvedModules = node.resolvedModules;
          if (node.resolvedTypeReferenceDirectiveNames !== void 0)
            updated.resolvedTypeReferenceDirectiveNames = node.resolvedTypeReferenceDirectiveNames;
          if (node.imports !== void 0)
            updated.imports = node.imports;
          if (node.moduleAugmentations !== void 0)
            updated.moduleAugmentations = node.moduleAugmentations;
          if (node.pragmas !== void 0)
            updated.pragmas = node.pragmas;
          if (node.localJsxFactory !== void 0)
            updated.localJsxFactory = node.localJsxFactory;
          if (node.localJsxNamespace !== void 0)
            updated.localJsxNamespace = node.localJsxNamespace;
          return updateNode(updated, node);
        }
        return node;
      }
      ts2.updateSourceFileNode = updateSourceFileNode;
      function getMutableClone(node) {
        var clone = getSynthesizedClone(node);
        clone.pos = node.pos;
        clone.end = node.end;
        clone.parent = node.parent;
        return clone;
      }
      ts2.getMutableClone = getMutableClone;
      function createNotEmittedStatement(original) {
        var node = createSynthesizedNode(325);
        node.original = original;
        setTextRange(node, original);
        return node;
      }
      ts2.createNotEmittedStatement = createNotEmittedStatement;
      function createEndOfDeclarationMarker(original) {
        var node = createSynthesizedNode(329);
        node.emitNode = {};
        node.original = original;
        return node;
      }
      ts2.createEndOfDeclarationMarker = createEndOfDeclarationMarker;
      function createMergeDeclarationMarker(original) {
        var node = createSynthesizedNode(328);
        node.emitNode = {};
        node.original = original;
        return node;
      }
      ts2.createMergeDeclarationMarker = createMergeDeclarationMarker;
      function createPartiallyEmittedExpression(expression, original) {
        var node = createSynthesizedNode(326);
        node.expression = expression;
        node.original = original;
        setTextRange(node, original);
        return node;
      }
      ts2.createPartiallyEmittedExpression = createPartiallyEmittedExpression;
      function updatePartiallyEmittedExpression(node, expression) {
        if (node.expression !== expression) {
          return updateNode(createPartiallyEmittedExpression(expression, node.original), node);
        }
        return node;
      }
      ts2.updatePartiallyEmittedExpression = updatePartiallyEmittedExpression;
      function flattenCommaElements(node) {
        if (ts2.nodeIsSynthesized(node) && !ts2.isParseTreeNode(node) && !node.original && !node.emitNode && !node.id) {
          if (node.kind === 327) {
            return node.elements;
          }
          if (ts2.isBinaryExpression(node) && node.operatorToken.kind === 27) {
            return [node.left, node.right];
          }
        }
        return node;
      }
      function createCommaList(elements) {
        var node = createSynthesizedNode(327);
        node.elements = createNodeArray(ts2.sameFlatMap(elements, flattenCommaElements));
        return node;
      }
      ts2.createCommaList = createCommaList;
      function updateCommaList(node, elements) {
        return node.elements !== elements ? updateNode(createCommaList(elements), node) : node;
      }
      ts2.updateCommaList = updateCommaList;
      function createSyntheticReferenceExpression(expression, thisArg) {
        var node = createSynthesizedNode(330);
        node.expression = expression;
        node.thisArg = thisArg;
        return node;
      }
      ts2.createSyntheticReferenceExpression = createSyntheticReferenceExpression;
      function updateSyntheticReferenceExpression(node, expression, thisArg) {
        return node.expression !== expression || node.thisArg !== thisArg ? updateNode(createSyntheticReferenceExpression(expression, thisArg), node) : node;
      }
      ts2.updateSyntheticReferenceExpression = updateSyntheticReferenceExpression;
      function createBundle(sourceFiles, prepends) {
        if (prepends === void 0) {
          prepends = ts2.emptyArray;
        }
        var node = ts2.createNode(291);
        node.prepends = prepends;
        node.sourceFiles = sourceFiles;
        return node;
      }
      ts2.createBundle = createBundle;
      var allUnscopedEmitHelpers;
      function getAllUnscopedEmitHelpers() {
        return allUnscopedEmitHelpers || (allUnscopedEmitHelpers = ts2.arrayToMap([
          ts2.valuesHelper,
          ts2.readHelper,
          ts2.spreadHelper,
          ts2.spreadArraysHelper,
          ts2.restHelper,
          ts2.decorateHelper,
          ts2.metadataHelper,
          ts2.paramHelper,
          ts2.awaiterHelper,
          ts2.assignHelper,
          ts2.awaitHelper,
          ts2.asyncGeneratorHelper,
          ts2.asyncDelegator,
          ts2.asyncValues,
          ts2.extendsHelper,
          ts2.templateObjectHelper,
          ts2.generatorHelper,
          ts2.importStarHelper,
          ts2.importDefaultHelper,
          ts2.classPrivateFieldGetHelper,
          ts2.classPrivateFieldSetHelper,
          ts2.createBindingHelper,
          ts2.setModuleDefaultHelper
        ], function(helper) {
          return helper.name;
        }));
      }
      function createUnparsedSource() {
        var node = ts2.createNode(292);
        node.prologues = ts2.emptyArray;
        node.referencedFiles = ts2.emptyArray;
        node.libReferenceDirectives = ts2.emptyArray;
        node.getLineAndCharacterOfPosition = function(pos) {
          return ts2.getLineAndCharacterOfPosition(node, pos);
        };
        return node;
      }
      function createUnparsedSourceFile(textOrInputFiles, mapPathOrType, mapTextOrStripInternal) {
        var node = createUnparsedSource();
        var stripInternal;
        var bundleFileInfo;
        if (!ts2.isString(textOrInputFiles)) {
          ts2.Debug.assert(mapPathOrType === "js" || mapPathOrType === "dts");
          node.fileName = (mapPathOrType === "js" ? textOrInputFiles.javascriptPath : textOrInputFiles.declarationPath) || "";
          node.sourceMapPath = mapPathOrType === "js" ? textOrInputFiles.javascriptMapPath : textOrInputFiles.declarationMapPath;
          Object.defineProperties(node, {
            text: { get: function() {
              return mapPathOrType === "js" ? textOrInputFiles.javascriptText : textOrInputFiles.declarationText;
            } },
            sourceMapText: { get: function() {
              return mapPathOrType === "js" ? textOrInputFiles.javascriptMapText : textOrInputFiles.declarationMapText;
            } }
          });
          if (textOrInputFiles.buildInfo && textOrInputFiles.buildInfo.bundle) {
            node.oldFileOfCurrentEmit = textOrInputFiles.oldFileOfCurrentEmit;
            ts2.Debug.assert(mapTextOrStripInternal === void 0 || typeof mapTextOrStripInternal === "boolean");
            stripInternal = mapTextOrStripInternal;
            bundleFileInfo = mapPathOrType === "js" ? textOrInputFiles.buildInfo.bundle.js : textOrInputFiles.buildInfo.bundle.dts;
            if (node.oldFileOfCurrentEmit) {
              parseOldFileOfCurrentEmit(node, ts2.Debug.checkDefined(bundleFileInfo));
              return node;
            }
          }
        } else {
          node.fileName = "";
          node.text = textOrInputFiles;
          node.sourceMapPath = mapPathOrType;
          node.sourceMapText = mapTextOrStripInternal;
        }
        ts2.Debug.assert(!node.oldFileOfCurrentEmit);
        parseUnparsedSourceFile(node, bundleFileInfo, stripInternal);
        return node;
      }
      ts2.createUnparsedSourceFile = createUnparsedSourceFile;
      function parseUnparsedSourceFile(node, bundleFileInfo, stripInternal) {
        var prologues;
        var helpers;
        var referencedFiles;
        var typeReferenceDirectives;
        var libReferenceDirectives;
        var texts;
        for (var _i = 0, _a = bundleFileInfo ? bundleFileInfo.sections : ts2.emptyArray; _i < _a.length; _i++) {
          var section = _a[_i];
          switch (section.kind) {
            case "prologue":
              (prologues || (prologues = [])).push(createUnparsedNode(section, node));
              break;
            case "emitHelpers":
              (helpers || (helpers = [])).push(getAllUnscopedEmitHelpers().get(section.data));
              break;
            case "no-default-lib":
              node.hasNoDefaultLib = true;
              break;
            case "reference":
              (referencedFiles || (referencedFiles = [])).push({ pos: -1, end: -1, fileName: section.data });
              break;
            case "type":
              (typeReferenceDirectives || (typeReferenceDirectives = [])).push(section.data);
              break;
            case "lib":
              (libReferenceDirectives || (libReferenceDirectives = [])).push({ pos: -1, end: -1, fileName: section.data });
              break;
            case "prepend":
              var prependNode = createUnparsedNode(section, node);
              var prependTexts = void 0;
              for (var _b = 0, _c = section.texts; _b < _c.length; _b++) {
                var text = _c[_b];
                if (!stripInternal || text.kind !== "internal") {
                  (prependTexts || (prependTexts = [])).push(createUnparsedNode(text, node));
                }
              }
              prependNode.texts = prependTexts || ts2.emptyArray;
              (texts || (texts = [])).push(prependNode);
              break;
            case "internal":
              if (stripInternal) {
                if (!texts)
                  texts = [];
                break;
              }
            case "text":
              (texts || (texts = [])).push(createUnparsedNode(section, node));
              break;
            default:
              ts2.Debug.assertNever(section);
          }
        }
        node.prologues = prologues || ts2.emptyArray;
        node.helpers = helpers;
        node.referencedFiles = referencedFiles || ts2.emptyArray;
        node.typeReferenceDirectives = typeReferenceDirectives;
        node.libReferenceDirectives = libReferenceDirectives || ts2.emptyArray;
        node.texts = texts || [createUnparsedNode({ kind: "text", pos: 0, end: node.text.length }, node)];
      }
      function parseOldFileOfCurrentEmit(node, bundleFileInfo) {
        ts2.Debug.assert(!!node.oldFileOfCurrentEmit);
        var texts;
        var syntheticReferences;
        for (var _i = 0, _a = bundleFileInfo.sections; _i < _a.length; _i++) {
          var section = _a[_i];
          switch (section.kind) {
            case "internal":
            case "text":
              (texts || (texts = [])).push(createUnparsedNode(section, node));
              break;
            case "no-default-lib":
            case "reference":
            case "type":
            case "lib":
              (syntheticReferences || (syntheticReferences = [])).push(createUnparsedSyntheticReference(section, node));
              break;
            case "prologue":
            case "emitHelpers":
            case "prepend":
              break;
            default:
              ts2.Debug.assertNever(section);
          }
        }
        node.texts = texts || ts2.emptyArray;
        node.helpers = ts2.map(bundleFileInfo.sources && bundleFileInfo.sources.helpers, function(name) {
          return getAllUnscopedEmitHelpers().get(name);
        });
        node.syntheticReferences = syntheticReferences;
        return node;
      }
      function mapBundleFileSectionKindToSyntaxKind(kind) {
        switch (kind) {
          case "prologue":
            return 285;
          case "prepend":
            return 286;
          case "internal":
            return 288;
          case "text":
            return 287;
          case "emitHelpers":
          case "no-default-lib":
          case "reference":
          case "type":
          case "lib":
            return ts2.Debug.fail("BundleFileSectionKind: " + kind + " not yet mapped to SyntaxKind");
          default:
            return ts2.Debug.assertNever(kind);
        }
      }
      function createUnparsedNode(section, parent) {
        var node = ts2.createNode(mapBundleFileSectionKindToSyntaxKind(section.kind), section.pos, section.end);
        node.parent = parent;
        node.data = section.data;
        return node;
      }
      function createUnparsedSyntheticReference(section, parent) {
        var node = ts2.createNode(289, section.pos, section.end);
        node.parent = parent;
        node.data = section.data;
        node.section = section;
        return node;
      }
      function createInputFiles(javascriptTextOrReadFileText, declarationTextOrJavascriptPath, javascriptMapPath, javascriptMapTextOrDeclarationPath, declarationMapPath, declarationMapTextOrBuildInfoPath, javascriptPath, declarationPath, buildInfoPath, buildInfo, oldFileOfCurrentEmit) {
        var node = ts2.createNode(293);
        if (!ts2.isString(javascriptTextOrReadFileText)) {
          var cache_1 = ts2.createMap();
          var textGetter_1 = function(path2) {
            if (path2 === void 0)
              return void 0;
            var value = cache_1.get(path2);
            if (value === void 0) {
              value = javascriptTextOrReadFileText(path2);
              cache_1.set(path2, value !== void 0 ? value : false);
            }
            return value !== false ? value : void 0;
          };
          var definedTextGetter_1 = function(path2) {
            var result = textGetter_1(path2);
            return result !== void 0 ? result : "/* Input file " + path2 + " was missing */\r\n";
          };
          var buildInfo_1;
          var getAndCacheBuildInfo_1 = function(getText) {
            if (buildInfo_1 === void 0) {
              var result = getText();
              buildInfo_1 = result !== void 0 ? ts2.getBuildInfo(result) : false;
            }
            return buildInfo_1 || void 0;
          };
          node.javascriptPath = declarationTextOrJavascriptPath;
          node.javascriptMapPath = javascriptMapPath;
          node.declarationPath = ts2.Debug.checkDefined(javascriptMapTextOrDeclarationPath);
          node.declarationMapPath = declarationMapPath;
          node.buildInfoPath = declarationMapTextOrBuildInfoPath;
          Object.defineProperties(node, {
            javascriptText: { get: function() {
              return definedTextGetter_1(declarationTextOrJavascriptPath);
            } },
            javascriptMapText: { get: function() {
              return textGetter_1(javascriptMapPath);
            } },
            declarationText: { get: function() {
              return definedTextGetter_1(ts2.Debug.checkDefined(javascriptMapTextOrDeclarationPath));
            } },
            declarationMapText: { get: function() {
              return textGetter_1(declarationMapPath);
            } },
            buildInfo: { get: function() {
              return getAndCacheBuildInfo_1(function() {
                return textGetter_1(declarationMapTextOrBuildInfoPath);
              });
            } }
          });
        } else {
          node.javascriptText = javascriptTextOrReadFileText;
          node.javascriptMapPath = javascriptMapPath;
          node.javascriptMapText = javascriptMapTextOrDeclarationPath;
          node.declarationText = declarationTextOrJavascriptPath;
          node.declarationMapPath = declarationMapPath;
          node.declarationMapText = declarationMapTextOrBuildInfoPath;
          node.javascriptPath = javascriptPath;
          node.declarationPath = declarationPath;
          node.buildInfoPath = buildInfoPath;
          node.buildInfo = buildInfo;
          node.oldFileOfCurrentEmit = oldFileOfCurrentEmit;
        }
        return node;
      }
      ts2.createInputFiles = createInputFiles;
      function updateBundle(node, sourceFiles, prepends) {
        if (prepends === void 0) {
          prepends = ts2.emptyArray;
        }
        if (node.sourceFiles !== sourceFiles || node.prepends !== prepends) {
          return createBundle(sourceFiles, prepends);
        }
        return node;
      }
      ts2.updateBundle = updateBundle;
      function createImmediatelyInvokedFunctionExpression(statements, param, paramValue) {
        return createCall(createFunctionExpression(void 0, void 0, void 0, void 0, param ? [param] : [], void 0, createBlock(statements, true)), void 0, paramValue ? [paramValue] : []);
      }
      ts2.createImmediatelyInvokedFunctionExpression = createImmediatelyInvokedFunctionExpression;
      function createImmediatelyInvokedArrowFunction(statements, param, paramValue) {
        return createCall(createArrowFunction(void 0, void 0, param ? [param] : [], void 0, void 0, createBlock(statements, true)), void 0, paramValue ? [paramValue] : []);
      }
      ts2.createImmediatelyInvokedArrowFunction = createImmediatelyInvokedArrowFunction;
      function createComma(left, right) {
        return createBinary(left, 27, right);
      }
      ts2.createComma = createComma;
      function createLessThan(left, right) {
        return createBinary(left, 29, right);
      }
      ts2.createLessThan = createLessThan;
      function createAssignment(left, right) {
        return createBinary(left, 62, right);
      }
      ts2.createAssignment = createAssignment;
      function createStrictEquality(left, right) {
        return createBinary(left, 36, right);
      }
      ts2.createStrictEquality = createStrictEquality;
      function createStrictInequality(left, right) {
        return createBinary(left, 37, right);
      }
      ts2.createStrictInequality = createStrictInequality;
      function createAdd(left, right) {
        return createBinary(left, 39, right);
      }
      ts2.createAdd = createAdd;
      function createSubtract(left, right) {
        return createBinary(left, 40, right);
      }
      ts2.createSubtract = createSubtract;
      function createPostfixIncrement(operand) {
        return createPostfix(operand, 45);
      }
      ts2.createPostfixIncrement = createPostfixIncrement;
      function createLogicalAnd(left, right) {
        return createBinary(left, 55, right);
      }
      ts2.createLogicalAnd = createLogicalAnd;
      function createLogicalOr(left, right) {
        return createBinary(left, 56, right);
      }
      ts2.createLogicalOr = createLogicalOr;
      function createNullishCoalesce(left, right) {
        return createBinary(left, 60, right);
      }
      ts2.createNullishCoalesce = createNullishCoalesce;
      function createLogicalNot(operand) {
        return createPrefix(53, operand);
      }
      ts2.createLogicalNot = createLogicalNot;
      function createVoidZero() {
        return createVoid(createLiteral(0));
      }
      ts2.createVoidZero = createVoidZero;
      function createExportDefault(expression) {
        return createExportAssignment(void 0, void 0, false, expression);
      }
      ts2.createExportDefault = createExportDefault;
      function createExternalModuleExport(exportName) {
        return createExportDeclaration(void 0, void 0, createNamedExports([createExportSpecifier(void 0, exportName)]));
      }
      ts2.createExternalModuleExport = createExternalModuleExport;
      function asName(name) {
        return ts2.isString(name) ? createIdentifier(name) : name;
      }
      function asExpression(value) {
        return typeof value === "string" ? createStringLiteral(value) : typeof value === "number" ? createNumericLiteral("" + value) : typeof value === "boolean" ? value ? createTrue() : createFalse() : value;
      }
      function asNodeArray(array) {
        return array ? createNodeArray(array) : void 0;
      }
      function asToken(value) {
        return typeof value === "number" ? createToken(value) : value;
      }
      function asEmbeddedStatement(statement) {
        return statement && ts2.isNotEmittedStatement(statement) ? setTextRange(setOriginalNode(createEmptyStatement(), statement), statement) : statement;
      }
      function disposeEmitNodes(sourceFile) {
        sourceFile = ts2.getSourceFileOfNode(ts2.getParseTreeNode(sourceFile));
        var emitNode = sourceFile && sourceFile.emitNode;
        var annotatedNodes = emitNode && emitNode.annotatedNodes;
        if (annotatedNodes) {
          for (var _i = 0, annotatedNodes_1 = annotatedNodes; _i < annotatedNodes_1.length; _i++) {
            var node = annotatedNodes_1[_i];
            node.emitNode = void 0;
          }
        }
      }
      ts2.disposeEmitNodes = disposeEmitNodes;
      function getOrCreateEmitNode(node) {
        if (!node.emitNode) {
          if (ts2.isParseTreeNode(node)) {
            if (node.kind === 290) {
              return node.emitNode = { annotatedNodes: [node] };
            }
            var sourceFile = ts2.getSourceFileOfNode(ts2.getParseTreeNode(ts2.getSourceFileOfNode(node)));
            getOrCreateEmitNode(sourceFile).annotatedNodes.push(node);
          }
          node.emitNode = {};
        }
        return node.emitNode;
      }
      ts2.getOrCreateEmitNode = getOrCreateEmitNode;
      function removeAllComments(node) {
        var emitNode = getOrCreateEmitNode(node);
        emitNode.flags |= 1536;
        emitNode.leadingComments = void 0;
        emitNode.trailingComments = void 0;
        return node;
      }
      ts2.removeAllComments = removeAllComments;
      function setTextRange(range, location) {
        if (location) {
          range.pos = location.pos;
          range.end = location.end;
        }
        return range;
      }
      ts2.setTextRange = setTextRange;
      function setEmitFlags(node, emitFlags) {
        getOrCreateEmitNode(node).flags = emitFlags;
        return node;
      }
      ts2.setEmitFlags = setEmitFlags;
      function addEmitFlags(node, emitFlags) {
        var emitNode = getOrCreateEmitNode(node);
        emitNode.flags = emitNode.flags | emitFlags;
        return node;
      }
      ts2.addEmitFlags = addEmitFlags;
      function getSourceMapRange(node) {
        var emitNode = node.emitNode;
        return emitNode && emitNode.sourceMapRange || node;
      }
      ts2.getSourceMapRange = getSourceMapRange;
      function setSourceMapRange(node, range) {
        getOrCreateEmitNode(node).sourceMapRange = range;
        return node;
      }
      ts2.setSourceMapRange = setSourceMapRange;
      var SourceMapSource;
      function createSourceMapSource(fileName, text, skipTrivia) {
        return new (SourceMapSource || (SourceMapSource = ts2.objectAllocator.getSourceMapSourceConstructor()))(fileName, text, skipTrivia);
      }
      ts2.createSourceMapSource = createSourceMapSource;
      function getTokenSourceMapRange(node, token) {
        var emitNode = node.emitNode;
        var tokenSourceMapRanges = emitNode && emitNode.tokenSourceMapRanges;
        return tokenSourceMapRanges && tokenSourceMapRanges[token];
      }
      ts2.getTokenSourceMapRange = getTokenSourceMapRange;
      function setTokenSourceMapRange(node, token, range) {
        var emitNode = getOrCreateEmitNode(node);
        var tokenSourceMapRanges = emitNode.tokenSourceMapRanges || (emitNode.tokenSourceMapRanges = []);
        tokenSourceMapRanges[token] = range;
        return node;
      }
      ts2.setTokenSourceMapRange = setTokenSourceMapRange;
      function getStartsOnNewLine(node) {
        var emitNode = node.emitNode;
        return emitNode && emitNode.startsOnNewLine;
      }
      ts2.getStartsOnNewLine = getStartsOnNewLine;
      function setStartsOnNewLine(node, newLine) {
        getOrCreateEmitNode(node).startsOnNewLine = newLine;
        return node;
      }
      ts2.setStartsOnNewLine = setStartsOnNewLine;
      function getCommentRange(node) {
        var emitNode = node.emitNode;
        return emitNode && emitNode.commentRange || node;
      }
      ts2.getCommentRange = getCommentRange;
      function setCommentRange(node, range) {
        getOrCreateEmitNode(node).commentRange = range;
        return node;
      }
      ts2.setCommentRange = setCommentRange;
      function getSyntheticLeadingComments(node) {
        var emitNode = node.emitNode;
        return emitNode && emitNode.leadingComments;
      }
      ts2.getSyntheticLeadingComments = getSyntheticLeadingComments;
      function setSyntheticLeadingComments(node, comments) {
        getOrCreateEmitNode(node).leadingComments = comments;
        return node;
      }
      ts2.setSyntheticLeadingComments = setSyntheticLeadingComments;
      function addSyntheticLeadingComment(node, kind, text, hasTrailingNewLine) {
        return setSyntheticLeadingComments(node, ts2.append(getSyntheticLeadingComments(node), { kind, pos: -1, end: -1, hasTrailingNewLine, text }));
      }
      ts2.addSyntheticLeadingComment = addSyntheticLeadingComment;
      function getSyntheticTrailingComments(node) {
        var emitNode = node.emitNode;
        return emitNode && emitNode.trailingComments;
      }
      ts2.getSyntheticTrailingComments = getSyntheticTrailingComments;
      function setSyntheticTrailingComments(node, comments) {
        getOrCreateEmitNode(node).trailingComments = comments;
        return node;
      }
      ts2.setSyntheticTrailingComments = setSyntheticTrailingComments;
      function addSyntheticTrailingComment(node, kind, text, hasTrailingNewLine) {
        return setSyntheticTrailingComments(node, ts2.append(getSyntheticTrailingComments(node), { kind, pos: -1, end: -1, hasTrailingNewLine, text }));
      }
      ts2.addSyntheticTrailingComment = addSyntheticTrailingComment;
      function moveSyntheticComments(node, original) {
        setSyntheticLeadingComments(node, getSyntheticLeadingComments(original));
        setSyntheticTrailingComments(node, getSyntheticTrailingComments(original));
        var emit = getOrCreateEmitNode(original);
        emit.leadingComments = void 0;
        emit.trailingComments = void 0;
        return node;
      }
      ts2.moveSyntheticComments = moveSyntheticComments;
      function ignoreSourceNewlines(node) {
        getOrCreateEmitNode(node).flags |= 134217728;
        return node;
      }
      ts2.ignoreSourceNewlines = ignoreSourceNewlines;
      function getConstantValue(node) {
        var emitNode = node.emitNode;
        return emitNode && emitNode.constantValue;
      }
      ts2.getConstantValue = getConstantValue;
      function setConstantValue(node, value) {
        var emitNode = getOrCreateEmitNode(node);
        emitNode.constantValue = value;
        return node;
      }
      ts2.setConstantValue = setConstantValue;
      function addEmitHelper(node, helper) {
        var emitNode = getOrCreateEmitNode(node);
        emitNode.helpers = ts2.append(emitNode.helpers, helper);
        return node;
      }
      ts2.addEmitHelper = addEmitHelper;
      function addEmitHelpers(node, helpers) {
        if (ts2.some(helpers)) {
          var emitNode = getOrCreateEmitNode(node);
          for (var _i = 0, helpers_1 = helpers; _i < helpers_1.length; _i++) {
            var helper = helpers_1[_i];
            emitNode.helpers = ts2.appendIfUnique(emitNode.helpers, helper);
          }
        }
        return node;
      }
      ts2.addEmitHelpers = addEmitHelpers;
      function removeEmitHelper(node, helper) {
        var emitNode = node.emitNode;
        if (emitNode) {
          var helpers = emitNode.helpers;
          if (helpers) {
            return ts2.orderedRemoveItem(helpers, helper);
          }
        }
        return false;
      }
      ts2.removeEmitHelper = removeEmitHelper;
      function getEmitHelpers(node) {
        var emitNode = node.emitNode;
        return emitNode && emitNode.helpers;
      }
      ts2.getEmitHelpers = getEmitHelpers;
      function moveEmitHelpers(source, target, predicate) {
        var sourceEmitNode = source.emitNode;
        var sourceEmitHelpers = sourceEmitNode && sourceEmitNode.helpers;
        if (!ts2.some(sourceEmitHelpers))
          return;
        var targetEmitNode = getOrCreateEmitNode(target);
        var helpersRemoved = 0;
        for (var i = 0; i < sourceEmitHelpers.length; i++) {
          var helper = sourceEmitHelpers[i];
          if (predicate(helper)) {
            helpersRemoved++;
            targetEmitNode.helpers = ts2.appendIfUnique(targetEmitNode.helpers, helper);
          } else if (helpersRemoved > 0) {
            sourceEmitHelpers[i - helpersRemoved] = helper;
          }
        }
        if (helpersRemoved > 0) {
          sourceEmitHelpers.length -= helpersRemoved;
        }
      }
      ts2.moveEmitHelpers = moveEmitHelpers;
      function compareEmitHelpers(x, y) {
        if (x === y)
          return 0;
        if (x.priority === y.priority)
          return 0;
        if (x.priority === void 0)
          return 1;
        if (y.priority === void 0)
          return -1;
        return ts2.compareValues(x.priority, y.priority);
      }
      ts2.compareEmitHelpers = compareEmitHelpers;
      function setOriginalNode(node, original) {
        node.original = original;
        if (original) {
          var emitNode = original.emitNode;
          if (emitNode)
            node.emitNode = mergeEmitNode(emitNode, node.emitNode);
        }
        return node;
      }
      ts2.setOriginalNode = setOriginalNode;
      function mergeEmitNode(sourceEmitNode, destEmitNode) {
        var flags = sourceEmitNode.flags, leadingComments = sourceEmitNode.leadingComments, trailingComments = sourceEmitNode.trailingComments, commentRange = sourceEmitNode.commentRange, sourceMapRange = sourceEmitNode.sourceMapRange, tokenSourceMapRanges = sourceEmitNode.tokenSourceMapRanges, constantValue = sourceEmitNode.constantValue, helpers = sourceEmitNode.helpers, startsOnNewLine = sourceEmitNode.startsOnNewLine;
        if (!destEmitNode)
          destEmitNode = {};
        if (leadingComments)
          destEmitNode.leadingComments = ts2.addRange(leadingComments.slice(), destEmitNode.leadingComments);
        if (trailingComments)
          destEmitNode.trailingComments = ts2.addRange(trailingComments.slice(), destEmitNode.trailingComments);
        if (flags)
          destEmitNode.flags = flags;
        if (commentRange)
          destEmitNode.commentRange = commentRange;
        if (sourceMapRange)
          destEmitNode.sourceMapRange = sourceMapRange;
        if (tokenSourceMapRanges)
          destEmitNode.tokenSourceMapRanges = mergeTokenSourceMapRanges(tokenSourceMapRanges, destEmitNode.tokenSourceMapRanges);
        if (constantValue !== void 0)
          destEmitNode.constantValue = constantValue;
        if (helpers)
          destEmitNode.helpers = ts2.addRange(destEmitNode.helpers, helpers);
        if (startsOnNewLine !== void 0)
          destEmitNode.startsOnNewLine = startsOnNewLine;
        return destEmitNode;
      }
      function mergeTokenSourceMapRanges(sourceRanges, destRanges) {
        if (!destRanges)
          destRanges = [];
        for (var key in sourceRanges) {
          destRanges[key] = sourceRanges[key];
        }
        return destRanges;
      }
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      ts2.nullTransformationContext = {
        enableEmitNotification: ts2.noop,
        enableSubstitution: ts2.noop,
        endLexicalEnvironment: ts2.returnUndefined,
        getCompilerOptions: function() {
          return {};
        },
        getEmitHost: ts2.notImplemented,
        getEmitResolver: ts2.notImplemented,
        setLexicalEnvironmentFlags: ts2.noop,
        getLexicalEnvironmentFlags: function() {
          return 0;
        },
        hoistFunctionDeclaration: ts2.noop,
        hoistVariableDeclaration: ts2.noop,
        addInitializationStatement: ts2.noop,
        isEmitNotificationEnabled: ts2.notImplemented,
        isSubstitutionEnabled: ts2.notImplemented,
        onEmitNode: ts2.noop,
        onSubstituteNode: ts2.notImplemented,
        readEmitHelpers: ts2.notImplemented,
        requestEmitHelper: ts2.noop,
        resumeLexicalEnvironment: ts2.noop,
        startLexicalEnvironment: ts2.noop,
        suspendLexicalEnvironment: ts2.noop,
        addDiagnostic: ts2.noop
      };
      function createTypeCheck(value, tag) {
        return tag === "undefined" ? ts2.createStrictEquality(value, ts2.createVoidZero()) : ts2.createStrictEquality(ts2.createTypeOf(value), ts2.createLiteral(tag));
      }
      ts2.createTypeCheck = createTypeCheck;
      function createMemberAccessForPropertyName(target, memberName, location) {
        if (ts2.isComputedPropertyName(memberName)) {
          return ts2.setTextRange(ts2.createElementAccess(target, memberName.expression), location);
        } else {
          var expression = ts2.setTextRange(ts2.isIdentifier(memberName) || ts2.isPrivateIdentifier(memberName) ? ts2.createPropertyAccess(target, memberName) : ts2.createElementAccess(target, memberName), memberName);
          ts2.getOrCreateEmitNode(expression).flags |= 64;
          return expression;
        }
      }
      ts2.createMemberAccessForPropertyName = createMemberAccessForPropertyName;
      function createFunctionCall(func, thisArg, argumentsList, location) {
        return ts2.setTextRange(ts2.createCall(ts2.createPropertyAccess(func, "call"), void 0, __spreadArrays([
          thisArg
        ], argumentsList)), location);
      }
      ts2.createFunctionCall = createFunctionCall;
      function createFunctionApply(func, thisArg, argumentsExpression, location) {
        return ts2.setTextRange(ts2.createCall(ts2.createPropertyAccess(func, "apply"), void 0, [
          thisArg,
          argumentsExpression
        ]), location);
      }
      ts2.createFunctionApply = createFunctionApply;
      function createArraySlice(array, start) {
        var argumentsList = [];
        if (start !== void 0) {
          argumentsList.push(typeof start === "number" ? ts2.createLiteral(start) : start);
        }
        return ts2.createCall(ts2.createPropertyAccess(array, "slice"), void 0, argumentsList);
      }
      ts2.createArraySlice = createArraySlice;
      function createArrayConcat(array, values) {
        return ts2.createCall(ts2.createPropertyAccess(array, "concat"), void 0, values);
      }
      ts2.createArrayConcat = createArrayConcat;
      function createMathPow(left, right, location) {
        return ts2.setTextRange(ts2.createCall(ts2.createPropertyAccess(ts2.createIdentifier("Math"), "pow"), void 0, [left, right]), location);
      }
      ts2.createMathPow = createMathPow;
      function createReactNamespace(reactNamespace, parent) {
        var react = ts2.createIdentifier(reactNamespace || "React");
        react.flags &= ~8;
        react.parent = ts2.getParseTreeNode(parent);
        return react;
      }
      function createJsxFactoryExpressionFromEntityName(jsxFactory, parent) {
        if (ts2.isQualifiedName(jsxFactory)) {
          var left = createJsxFactoryExpressionFromEntityName(jsxFactory.left, parent);
          var right = ts2.createIdentifier(ts2.idText(jsxFactory.right));
          right.escapedText = jsxFactory.right.escapedText;
          return ts2.createPropertyAccess(left, right);
        } else {
          return createReactNamespace(ts2.idText(jsxFactory), parent);
        }
      }
      function createJsxFactoryExpression(jsxFactoryEntity, reactNamespace, parent) {
        return jsxFactoryEntity ? createJsxFactoryExpressionFromEntityName(jsxFactoryEntity, parent) : ts2.createPropertyAccess(createReactNamespace(reactNamespace, parent), "createElement");
      }
      function createExpressionForJsxElement(jsxFactoryEntity, reactNamespace, tagName, props, children, parentElement, location) {
        var argumentsList = [tagName];
        if (props) {
          argumentsList.push(props);
        }
        if (children && children.length > 0) {
          if (!props) {
            argumentsList.push(ts2.createNull());
          }
          if (children.length > 1) {
            for (var _i = 0, children_2 = children; _i < children_2.length; _i++) {
              var child = children_2[_i];
              startOnNewLine(child);
              argumentsList.push(child);
            }
          } else {
            argumentsList.push(children[0]);
          }
        }
        return ts2.setTextRange(ts2.createCall(createJsxFactoryExpression(jsxFactoryEntity, reactNamespace, parentElement), void 0, argumentsList), location);
      }
      ts2.createExpressionForJsxElement = createExpressionForJsxElement;
      function createExpressionForJsxFragment(jsxFactoryEntity, reactNamespace, children, parentElement, location) {
        var tagName = ts2.createPropertyAccess(createReactNamespace(reactNamespace, parentElement), "Fragment");
        var argumentsList = [tagName];
        argumentsList.push(ts2.createNull());
        if (children && children.length > 0) {
          if (children.length > 1) {
            for (var _i = 0, children_3 = children; _i < children_3.length; _i++) {
              var child = children_3[_i];
              startOnNewLine(child);
              argumentsList.push(child);
            }
          } else {
            argumentsList.push(children[0]);
          }
        }
        return ts2.setTextRange(ts2.createCall(createJsxFactoryExpression(jsxFactoryEntity, reactNamespace, parentElement), void 0, argumentsList), location);
      }
      ts2.createExpressionForJsxFragment = createExpressionForJsxFragment;
      function getUnscopedHelperName(name) {
        return ts2.setEmitFlags(ts2.createIdentifier(name), 4096 | 2);
      }
      ts2.getUnscopedHelperName = getUnscopedHelperName;
      ts2.valuesHelper = {
        name: "typescript:values",
        importName: "__values",
        scoped: false,
        text: '\n            var __values = (this && this.__values) || function(o) {\n                var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;\n                if (m) return m.call(o);\n                if (o && typeof o.length === "number") return {\n                    next: function () {\n                        if (o && i >= o.length) o = void 0;\n                        return { value: o && o[i++], done: !o };\n                    }\n                };\n                throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");\n            };'
      };
      function createValuesHelper(context, expression, location) {
        context.requestEmitHelper(ts2.valuesHelper);
        return ts2.setTextRange(ts2.createCall(getUnscopedHelperName("__values"), void 0, [expression]), location);
      }
      ts2.createValuesHelper = createValuesHelper;
      ts2.readHelper = {
        name: "typescript:read",
        importName: "__read",
        scoped: false,
        text: '\n            var __read = (this && this.__read) || function (o, n) {\n                var m = typeof Symbol === "function" && o[Symbol.iterator];\n                if (!m) return o;\n                var i = m.call(o), r, ar = [], e;\n                try {\n                    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);\n                }\n                catch (error) { e = { error: error }; }\n                finally {\n                    try {\n                        if (r && !r.done && (m = i["return"])) m.call(i);\n                    }\n                    finally { if (e) throw e.error; }\n                }\n                return ar;\n            };'
      };
      function createReadHelper(context, iteratorRecord, count, location) {
        context.requestEmitHelper(ts2.readHelper);
        return ts2.setTextRange(ts2.createCall(getUnscopedHelperName("__read"), void 0, count !== void 0 ? [iteratorRecord, ts2.createLiteral(count)] : [iteratorRecord]), location);
      }
      ts2.createReadHelper = createReadHelper;
      ts2.spreadHelper = {
        name: "typescript:spread",
        importName: "__spread",
        scoped: false,
        dependencies: [ts2.readHelper],
        text: "\n            var __spread = (this && this.__spread) || function () {\n                for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));\n                return ar;\n            };"
      };
      function createSpreadHelper(context, argumentList, location) {
        context.requestEmitHelper(ts2.spreadHelper);
        return ts2.setTextRange(ts2.createCall(getUnscopedHelperName("__spread"), void 0, argumentList), location);
      }
      ts2.createSpreadHelper = createSpreadHelper;
      ts2.spreadArraysHelper = {
        name: "typescript:spreadArrays",
        importName: "__spreadArrays",
        scoped: false,
        text: "\n            var __spreadArrays = (this && this.__spreadArrays) || function () {\n                for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;\n                for (var r = Array(s), k = 0, i = 0; i < il; i++)\n                    for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)\n                        r[k] = a[j];\n                return r;\n            };"
      };
      function createSpreadArraysHelper(context, argumentList, location) {
        context.requestEmitHelper(ts2.spreadArraysHelper);
        return ts2.setTextRange(ts2.createCall(getUnscopedHelperName("__spreadArrays"), void 0, argumentList), location);
      }
      ts2.createSpreadArraysHelper = createSpreadArraysHelper;
      function createForOfBindingStatement(node, boundValue) {
        if (ts2.isVariableDeclarationList(node)) {
          var firstDeclaration = ts2.first(node.declarations);
          var updatedDeclaration = ts2.updateVariableDeclaration(firstDeclaration, firstDeclaration.name, void 0, boundValue);
          return ts2.setTextRange(ts2.createVariableStatement(void 0, ts2.updateVariableDeclarationList(node, [updatedDeclaration])), node);
        } else {
          var updatedExpression = ts2.setTextRange(ts2.createAssignment(node, boundValue), node);
          return ts2.setTextRange(ts2.createStatement(updatedExpression), node);
        }
      }
      ts2.createForOfBindingStatement = createForOfBindingStatement;
      function insertLeadingStatement(dest, source) {
        if (ts2.isBlock(dest)) {
          return ts2.updateBlock(dest, ts2.setTextRange(ts2.createNodeArray(__spreadArrays([source], dest.statements)), dest.statements));
        } else {
          return ts2.createBlock(ts2.createNodeArray([dest, source]), true);
        }
      }
      ts2.insertLeadingStatement = insertLeadingStatement;
      function restoreEnclosingLabel(node, outermostLabeledStatement, afterRestoreLabelCallback) {
        if (!outermostLabeledStatement) {
          return node;
        }
        var updated = ts2.updateLabel(outermostLabeledStatement, outermostLabeledStatement.label, outermostLabeledStatement.statement.kind === 238 ? restoreEnclosingLabel(node, outermostLabeledStatement.statement) : node);
        if (afterRestoreLabelCallback) {
          afterRestoreLabelCallback(outermostLabeledStatement);
        }
        return updated;
      }
      ts2.restoreEnclosingLabel = restoreEnclosingLabel;
      function shouldBeCapturedInTempVariable(node, cacheIdentifiers) {
        var target = ts2.skipParentheses(node);
        switch (target.kind) {
          case 75:
            return cacheIdentifiers;
          case 104:
          case 8:
          case 9:
          case 10:
            return false;
          case 192:
            var elements = target.elements;
            if (elements.length === 0) {
              return false;
            }
            return true;
          case 193:
            return target.properties.length > 0;
          default:
            return true;
        }
      }
      function createCallBinding(expression, recordTempVariable, languageVersion, cacheIdentifiers) {
        if (cacheIdentifiers === void 0) {
          cacheIdentifiers = false;
        }
        var callee = skipOuterExpressions(expression, 15);
        var thisArg;
        var target;
        if (ts2.isSuperProperty(callee)) {
          thisArg = ts2.createThis();
          target = callee;
        } else if (callee.kind === 102) {
          thisArg = ts2.createThis();
          target = languageVersion < 2 ? ts2.setTextRange(ts2.createIdentifier("_super"), callee) : callee;
        } else if (ts2.getEmitFlags(callee) & 4096) {
          thisArg = ts2.createVoidZero();
          target = parenthesizeForAccess(callee);
        } else {
          switch (callee.kind) {
            case 194: {
              if (shouldBeCapturedInTempVariable(callee.expression, cacheIdentifiers)) {
                thisArg = ts2.createTempVariable(recordTempVariable);
                target = ts2.createPropertyAccess(ts2.setTextRange(ts2.createAssignment(thisArg, callee.expression), callee.expression), callee.name);
                ts2.setTextRange(target, callee);
              } else {
                thisArg = callee.expression;
                target = callee;
              }
              break;
            }
            case 195: {
              if (shouldBeCapturedInTempVariable(callee.expression, cacheIdentifiers)) {
                thisArg = ts2.createTempVariable(recordTempVariable);
                target = ts2.createElementAccess(ts2.setTextRange(ts2.createAssignment(thisArg, callee.expression), callee.expression), callee.argumentExpression);
                ts2.setTextRange(target, callee);
              } else {
                thisArg = callee.expression;
                target = callee;
              }
              break;
            }
            default: {
              thisArg = ts2.createVoidZero();
              target = parenthesizeForAccess(expression);
              break;
            }
          }
        }
        return { target, thisArg };
      }
      ts2.createCallBinding = createCallBinding;
      function inlineExpressions(expressions) {
        return expressions.length > 10 ? ts2.createCommaList(expressions) : ts2.reduceLeft(expressions, ts2.createComma);
      }
      ts2.inlineExpressions = inlineExpressions;
      function createExpressionFromEntityName(node) {
        if (ts2.isQualifiedName(node)) {
          var left = createExpressionFromEntityName(node.left);
          var right = ts2.getMutableClone(node.right);
          return ts2.setTextRange(ts2.createPropertyAccess(left, right), node);
        } else {
          return ts2.getMutableClone(node);
        }
      }
      ts2.createExpressionFromEntityName = createExpressionFromEntityName;
      function createExpressionForPropertyName(memberName) {
        if (ts2.isIdentifier(memberName)) {
          return ts2.createLiteral(memberName);
        } else if (ts2.isComputedPropertyName(memberName)) {
          return ts2.getMutableClone(memberName.expression);
        } else {
          return ts2.getMutableClone(memberName);
        }
      }
      ts2.createExpressionForPropertyName = createExpressionForPropertyName;
      function createExpressionForObjectLiteralElementLike(node, property, receiver) {
        if (property.name && ts2.isPrivateIdentifier(property.name)) {
          ts2.Debug.failBadSyntaxKind(property.name, "Private identifiers are not allowed in object literals.");
        }
        switch (property.kind) {
          case 163:
          case 164:
            return createExpressionForAccessorDeclaration(node.properties, property, receiver, !!node.multiLine);
          case 281:
            return createExpressionForPropertyAssignment(property, receiver);
          case 282:
            return createExpressionForShorthandPropertyAssignment(property, receiver);
          case 161:
            return createExpressionForMethodDeclaration(property, receiver);
        }
      }
      ts2.createExpressionForObjectLiteralElementLike = createExpressionForObjectLiteralElementLike;
      function createExpressionForAccessorDeclaration(properties, property, receiver, multiLine) {
        var _a = ts2.getAllAccessorDeclarations(properties, property), firstAccessor = _a.firstAccessor, getAccessor = _a.getAccessor, setAccessor = _a.setAccessor;
        if (property === firstAccessor) {
          var properties_7 = [];
          if (getAccessor) {
            var getterFunction = ts2.createFunctionExpression(getAccessor.modifiers, void 0, void 0, void 0, getAccessor.parameters, void 0, getAccessor.body);
            ts2.setTextRange(getterFunction, getAccessor);
            ts2.setOriginalNode(getterFunction, getAccessor);
            var getter = ts2.createPropertyAssignment("get", getterFunction);
            properties_7.push(getter);
          }
          if (setAccessor) {
            var setterFunction = ts2.createFunctionExpression(setAccessor.modifiers, void 0, void 0, void 0, setAccessor.parameters, void 0, setAccessor.body);
            ts2.setTextRange(setterFunction, setAccessor);
            ts2.setOriginalNode(setterFunction, setAccessor);
            var setter = ts2.createPropertyAssignment("set", setterFunction);
            properties_7.push(setter);
          }
          properties_7.push(ts2.createPropertyAssignment("enumerable", getAccessor || setAccessor ? ts2.createFalse() : ts2.createTrue()));
          properties_7.push(ts2.createPropertyAssignment("configurable", ts2.createTrue()));
          var expression = ts2.setTextRange(ts2.createCall(ts2.createPropertyAccess(ts2.createIdentifier("Object"), "defineProperty"), void 0, [
            receiver,
            createExpressionForPropertyName(property.name),
            ts2.createObjectLiteral(properties_7, multiLine)
          ]), firstAccessor);
          return ts2.aggregateTransformFlags(expression);
        }
        return void 0;
      }
      function createExpressionForPropertyAssignment(property, receiver) {
        return ts2.aggregateTransformFlags(ts2.setOriginalNode(ts2.setTextRange(ts2.createAssignment(createMemberAccessForPropertyName(receiver, property.name, property.name), property.initializer), property), property));
      }
      function createExpressionForShorthandPropertyAssignment(property, receiver) {
        return ts2.aggregateTransformFlags(ts2.setOriginalNode(ts2.setTextRange(ts2.createAssignment(createMemberAccessForPropertyName(receiver, property.name, property.name), ts2.getSynthesizedClone(property.name)), property), property));
      }
      function createExpressionForMethodDeclaration(method, receiver) {
        return ts2.aggregateTransformFlags(ts2.setOriginalNode(ts2.setTextRange(ts2.createAssignment(createMemberAccessForPropertyName(receiver, method.name, method.name), ts2.setOriginalNode(ts2.setTextRange(ts2.createFunctionExpression(method.modifiers, method.asteriskToken, void 0, void 0, method.parameters, void 0, method.body), method), method)), method), method));
      }
      function getInternalName(node, allowComments, allowSourceMaps) {
        return getName(node, allowComments, allowSourceMaps, 16384 | 32768);
      }
      ts2.getInternalName = getInternalName;
      function isInternalName(node) {
        return (ts2.getEmitFlags(node) & 32768) !== 0;
      }
      ts2.isInternalName = isInternalName;
      function getLocalName(node, allowComments, allowSourceMaps) {
        return getName(node, allowComments, allowSourceMaps, 16384);
      }
      ts2.getLocalName = getLocalName;
      function isLocalName(node) {
        return (ts2.getEmitFlags(node) & 16384) !== 0;
      }
      ts2.isLocalName = isLocalName;
      function getExportName(node, allowComments, allowSourceMaps) {
        return getName(node, allowComments, allowSourceMaps, 8192);
      }
      ts2.getExportName = getExportName;
      function isExportName(node) {
        return (ts2.getEmitFlags(node) & 8192) !== 0;
      }
      ts2.isExportName = isExportName;
      function getDeclarationName(node, allowComments, allowSourceMaps) {
        return getName(node, allowComments, allowSourceMaps);
      }
      ts2.getDeclarationName = getDeclarationName;
      function getName(node, allowComments, allowSourceMaps, emitFlags) {
        if (emitFlags === void 0) {
          emitFlags = 0;
        }
        var nodeName = ts2.getNameOfDeclaration(node);
        if (nodeName && ts2.isIdentifier(nodeName) && !ts2.isGeneratedIdentifier(nodeName)) {
          var name = ts2.getMutableClone(nodeName);
          emitFlags |= ts2.getEmitFlags(nodeName);
          if (!allowSourceMaps)
            emitFlags |= 48;
          if (!allowComments)
            emitFlags |= 1536;
          if (emitFlags)
            ts2.setEmitFlags(name, emitFlags);
          return name;
        }
        return ts2.getGeneratedNameForNode(node);
      }
      function getExternalModuleOrNamespaceExportName(ns, node, allowComments, allowSourceMaps) {
        if (ns && ts2.hasModifier(node, 1)) {
          return getNamespaceMemberName(ns, getName(node), allowComments, allowSourceMaps);
        }
        return getExportName(node, allowComments, allowSourceMaps);
      }
      ts2.getExternalModuleOrNamespaceExportName = getExternalModuleOrNamespaceExportName;
      function getNamespaceMemberName(ns, name, allowComments, allowSourceMaps) {
        var qualifiedName = ts2.createPropertyAccess(ns, ts2.nodeIsSynthesized(name) ? name : ts2.getSynthesizedClone(name));
        ts2.setTextRange(qualifiedName, name);
        var emitFlags = 0;
        if (!allowSourceMaps)
          emitFlags |= 48;
        if (!allowComments)
          emitFlags |= 1536;
        if (emitFlags)
          ts2.setEmitFlags(qualifiedName, emitFlags);
        return qualifiedName;
      }
      ts2.getNamespaceMemberName = getNamespaceMemberName;
      function convertToFunctionBody(node, multiLine) {
        return ts2.isBlock(node) ? node : ts2.setTextRange(ts2.createBlock([ts2.setTextRange(ts2.createReturn(node), node)], multiLine), node);
      }
      ts2.convertToFunctionBody = convertToFunctionBody;
      function convertFunctionDeclarationToExpression(node) {
        if (!node.body)
          return ts2.Debug.fail();
        var updated = ts2.createFunctionExpression(node.modifiers, node.asteriskToken, node.name, node.typeParameters, node.parameters, node.type, node.body);
        ts2.setOriginalNode(updated, node);
        ts2.setTextRange(updated, node);
        if (ts2.getStartsOnNewLine(node)) {
          ts2.setStartsOnNewLine(updated, true);
        }
        ts2.aggregateTransformFlags(updated);
        return updated;
      }
      ts2.convertFunctionDeclarationToExpression = convertFunctionDeclarationToExpression;
      function isUseStrictPrologue(node) {
        return ts2.isStringLiteral(node.expression) && node.expression.text === "use strict";
      }
      function addPrologue(target, source, ensureUseStrict2, visitor) {
        var offset = addStandardPrologue(target, source, ensureUseStrict2);
        return addCustomPrologue(target, source, offset, visitor);
      }
      ts2.addPrologue = addPrologue;
      function addStandardPrologue(target, source, ensureUseStrict2) {
        ts2.Debug.assert(target.length === 0, "Prologue directives should be at the first statement in the target statements array");
        var foundUseStrict = false;
        var statementOffset = 0;
        var numStatements = source.length;
        while (statementOffset < numStatements) {
          var statement = source[statementOffset];
          if (ts2.isPrologueDirective(statement)) {
            if (isUseStrictPrologue(statement)) {
              foundUseStrict = true;
            }
            target.push(statement);
          } else {
            break;
          }
          statementOffset++;
        }
        if (ensureUseStrict2 && !foundUseStrict) {
          target.push(startOnNewLine(ts2.createStatement(ts2.createLiteral("use strict"))));
        }
        return statementOffset;
      }
      ts2.addStandardPrologue = addStandardPrologue;
      function addCustomPrologue(target, source, statementOffset, visitor, filter) {
        if (filter === void 0) {
          filter = ts2.returnTrue;
        }
        var numStatements = source.length;
        while (statementOffset !== void 0 && statementOffset < numStatements) {
          var statement = source[statementOffset];
          if (ts2.getEmitFlags(statement) & 1048576 && filter(statement)) {
            ts2.append(target, visitor ? ts2.visitNode(statement, visitor, ts2.isStatement) : statement);
          } else {
            break;
          }
          statementOffset++;
        }
        return statementOffset;
      }
      ts2.addCustomPrologue = addCustomPrologue;
      function findUseStrictPrologue(statements) {
        for (var _i = 0, statements_4 = statements; _i < statements_4.length; _i++) {
          var statement = statements_4[_i];
          if (ts2.isPrologueDirective(statement)) {
            if (isUseStrictPrologue(statement)) {
              return statement;
            }
          } else {
            break;
          }
        }
        return void 0;
      }
      ts2.findUseStrictPrologue = findUseStrictPrologue;
      function startsWithUseStrict(statements) {
        var firstStatement = ts2.firstOrUndefined(statements);
        return firstStatement !== void 0 && ts2.isPrologueDirective(firstStatement) && isUseStrictPrologue(firstStatement);
      }
      ts2.startsWithUseStrict = startsWithUseStrict;
      function ensureUseStrict(statements) {
        var foundUseStrict = findUseStrictPrologue(statements);
        if (!foundUseStrict) {
          return ts2.setTextRange(ts2.createNodeArray(__spreadArrays([
            startOnNewLine(ts2.createStatement(ts2.createLiteral("use strict")))
          ], statements)), statements);
        }
        return statements;
      }
      ts2.ensureUseStrict = ensureUseStrict;
      function parenthesizeBinaryOperand(binaryOperator, operand, isLeftSideOfBinary, leftOperand) {
        var skipped = ts2.skipPartiallyEmittedExpressions(operand);
        if (skipped.kind === 200) {
          return operand;
        }
        return binaryOperandNeedsParentheses(binaryOperator, operand, isLeftSideOfBinary, leftOperand) ? ts2.createParen(operand) : operand;
      }
      ts2.parenthesizeBinaryOperand = parenthesizeBinaryOperand;
      function binaryOperandNeedsParentheses(binaryOperator, operand, isLeftSideOfBinary, leftOperand) {
        var binaryOperatorPrecedence = ts2.getOperatorPrecedence(209, binaryOperator);
        var binaryOperatorAssociativity = ts2.getOperatorAssociativity(209, binaryOperator);
        var emittedOperand = ts2.skipPartiallyEmittedExpressions(operand);
        if (!isLeftSideOfBinary && operand.kind === 202 && binaryOperatorPrecedence > 3) {
          return true;
        }
        var operandPrecedence = ts2.getExpressionPrecedence(emittedOperand);
        switch (ts2.compareValues(operandPrecedence, binaryOperatorPrecedence)) {
          case -1:
            if (!isLeftSideOfBinary && binaryOperatorAssociativity === 1 && operand.kind === 212) {
              return false;
            }
            return true;
          case 1:
            return false;
          case 0:
            if (isLeftSideOfBinary) {
              return binaryOperatorAssociativity === 1;
            } else {
              if (ts2.isBinaryExpression(emittedOperand) && emittedOperand.operatorToken.kind === binaryOperator) {
                if (operatorHasAssociativeProperty(binaryOperator)) {
                  return false;
                }
                if (binaryOperator === 39) {
                  var leftKind = leftOperand ? getLiteralKindOfBinaryPlusOperand(leftOperand) : 0;
                  if (ts2.isLiteralKind(leftKind) && leftKind === getLiteralKindOfBinaryPlusOperand(emittedOperand)) {
                    return false;
                  }
                }
              }
              var operandAssociativity = ts2.getExpressionAssociativity(emittedOperand);
              return operandAssociativity === 0;
            }
        }
      }
      function operatorHasAssociativeProperty(binaryOperator) {
        return binaryOperator === 41 || binaryOperator === 51 || binaryOperator === 50 || binaryOperator === 52;
      }
      function getLiteralKindOfBinaryPlusOperand(node) {
        node = ts2.skipPartiallyEmittedExpressions(node);
        if (ts2.isLiteralKind(node.kind)) {
          return node.kind;
        }
        if (node.kind === 209 && node.operatorToken.kind === 39) {
          if (node.cachedLiteralKind !== void 0) {
            return node.cachedLiteralKind;
          }
          var leftKind = getLiteralKindOfBinaryPlusOperand(node.left);
          var literalKind = ts2.isLiteralKind(leftKind) && leftKind === getLiteralKindOfBinaryPlusOperand(node.right) ? leftKind : 0;
          node.cachedLiteralKind = literalKind;
          return literalKind;
        }
        return 0;
      }
      function parenthesizeForConditionalHead(condition) {
        var conditionalPrecedence = ts2.getOperatorPrecedence(210, 57);
        var emittedCondition = ts2.skipPartiallyEmittedExpressions(condition);
        var conditionPrecedence = ts2.getExpressionPrecedence(emittedCondition);
        if (ts2.compareValues(conditionPrecedence, conditionalPrecedence) !== 1) {
          return ts2.createParen(condition);
        }
        return condition;
      }
      ts2.parenthesizeForConditionalHead = parenthesizeForConditionalHead;
      function parenthesizeSubexpressionOfConditionalExpression(e) {
        var emittedExpression = ts2.skipPartiallyEmittedExpressions(e);
        return isCommaSequence(emittedExpression) ? ts2.createParen(e) : e;
      }
      ts2.parenthesizeSubexpressionOfConditionalExpression = parenthesizeSubexpressionOfConditionalExpression;
      function parenthesizeDefaultExpression(e) {
        var check = ts2.skipPartiallyEmittedExpressions(e);
        var needsParens = isCommaSequence(check);
        if (!needsParens) {
          switch (getLeftmostExpression(check, false).kind) {
            case 214:
            case 201:
              needsParens = true;
          }
        }
        return needsParens ? ts2.createParen(e) : e;
      }
      ts2.parenthesizeDefaultExpression = parenthesizeDefaultExpression;
      function parenthesizeForNew(expression) {
        var leftmostExpr = getLeftmostExpression(expression, true);
        switch (leftmostExpr.kind) {
          case 196:
            return ts2.createParen(expression);
          case 197:
            return !leftmostExpr.arguments ? ts2.createParen(expression) : expression;
        }
        return parenthesizeForAccess(expression);
      }
      ts2.parenthesizeForNew = parenthesizeForNew;
      function parenthesizeForAccess(expression) {
        var emittedExpression = ts2.skipPartiallyEmittedExpressions(expression);
        if (ts2.isLeftHandSideExpression(emittedExpression) && (emittedExpression.kind !== 197 || emittedExpression.arguments)) {
          return expression;
        }
        return ts2.setTextRange(ts2.createParen(expression), expression);
      }
      ts2.parenthesizeForAccess = parenthesizeForAccess;
      function parenthesizePostfixOperand(operand) {
        return ts2.isLeftHandSideExpression(operand) ? operand : ts2.setTextRange(ts2.createParen(operand), operand);
      }
      ts2.parenthesizePostfixOperand = parenthesizePostfixOperand;
      function parenthesizePrefixOperand(operand) {
        return ts2.isUnaryExpression(operand) ? operand : ts2.setTextRange(ts2.createParen(operand), operand);
      }
      ts2.parenthesizePrefixOperand = parenthesizePrefixOperand;
      function parenthesizeListElements(elements) {
        var result;
        for (var i = 0; i < elements.length; i++) {
          var element = parenthesizeExpressionForList(elements[i]);
          if (result !== void 0 || element !== elements[i]) {
            if (result === void 0) {
              result = elements.slice(0, i);
            }
            result.push(element);
          }
        }
        if (result !== void 0) {
          return ts2.setTextRange(ts2.createNodeArray(result, elements.hasTrailingComma), elements);
        }
        return elements;
      }
      ts2.parenthesizeListElements = parenthesizeListElements;
      function parenthesizeExpressionForList(expression) {
        var emittedExpression = ts2.skipPartiallyEmittedExpressions(expression);
        var expressionPrecedence = ts2.getExpressionPrecedence(emittedExpression);
        var commaPrecedence = ts2.getOperatorPrecedence(209, 27);
        return expressionPrecedence > commaPrecedence ? expression : ts2.setTextRange(ts2.createParen(expression), expression);
      }
      ts2.parenthesizeExpressionForList = parenthesizeExpressionForList;
      function parenthesizeExpressionForExpressionStatement(expression) {
        var emittedExpression = ts2.skipPartiallyEmittedExpressions(expression);
        if (ts2.isCallExpression(emittedExpression)) {
          var callee = emittedExpression.expression;
          var kind = ts2.skipPartiallyEmittedExpressions(callee).kind;
          if (kind === 201 || kind === 202) {
            var mutableCall = ts2.getMutableClone(emittedExpression);
            mutableCall.expression = ts2.setTextRange(ts2.createParen(callee), callee);
            return recreateOuterExpressions(expression, mutableCall, 8);
          }
        }
        var leftmostExpressionKind = getLeftmostExpression(emittedExpression, false).kind;
        if (leftmostExpressionKind === 193 || leftmostExpressionKind === 201) {
          return ts2.setTextRange(ts2.createParen(expression), expression);
        }
        return expression;
      }
      ts2.parenthesizeExpressionForExpressionStatement = parenthesizeExpressionForExpressionStatement;
      function parenthesizeConditionalTypeMember(member) {
        return member.kind === 180 ? ts2.createParenthesizedType(member) : member;
      }
      ts2.parenthesizeConditionalTypeMember = parenthesizeConditionalTypeMember;
      function parenthesizeElementTypeMember(member) {
        switch (member.kind) {
          case 178:
          case 179:
          case 170:
          case 171:
            return ts2.createParenthesizedType(member);
        }
        return parenthesizeConditionalTypeMember(member);
      }
      ts2.parenthesizeElementTypeMember = parenthesizeElementTypeMember;
      function parenthesizeArrayTypeMember(member) {
        switch (member.kind) {
          case 172:
          case 184:
          case 181:
            return ts2.createParenthesizedType(member);
        }
        return parenthesizeElementTypeMember(member);
      }
      ts2.parenthesizeArrayTypeMember = parenthesizeArrayTypeMember;
      function parenthesizeElementTypeMembers(members) {
        return ts2.createNodeArray(ts2.sameMap(members, parenthesizeElementTypeMember));
      }
      ts2.parenthesizeElementTypeMembers = parenthesizeElementTypeMembers;
      function parenthesizeTypeParameters(typeParameters) {
        if (ts2.some(typeParameters)) {
          var params = [];
          for (var i = 0; i < typeParameters.length; ++i) {
            var entry = typeParameters[i];
            params.push(i === 0 && ts2.isFunctionOrConstructorTypeNode(entry) && entry.typeParameters ? ts2.createParenthesizedType(entry) : entry);
          }
          return ts2.createNodeArray(params);
        }
      }
      ts2.parenthesizeTypeParameters = parenthesizeTypeParameters;
      function getLeftmostExpression(node, stopAtCallExpressions) {
        while (true) {
          switch (node.kind) {
            case 208:
              node = node.operand;
              continue;
            case 209:
              node = node.left;
              continue;
            case 210:
              node = node.condition;
              continue;
            case 198:
              node = node.tag;
              continue;
            case 196:
              if (stopAtCallExpressions) {
                return node;
              }
            case 217:
            case 195:
            case 194:
            case 218:
            case 326:
              node = node.expression;
              continue;
          }
          return node;
        }
      }
      ts2.getLeftmostExpression = getLeftmostExpression;
      function parenthesizeConciseBody(body) {
        if (!ts2.isBlock(body) && (isCommaSequence(body) || getLeftmostExpression(body, false).kind === 193)) {
          return ts2.setTextRange(ts2.createParen(body), body);
        }
        return body;
      }
      ts2.parenthesizeConciseBody = parenthesizeConciseBody;
      function isCommaSequence(node) {
        return node.kind === 209 && node.operatorToken.kind === 27 || node.kind === 327;
      }
      ts2.isCommaSequence = isCommaSequence;
      var OuterExpressionKinds;
      (function(OuterExpressionKinds2) {
        OuterExpressionKinds2[OuterExpressionKinds2["Parentheses"] = 1] = "Parentheses";
        OuterExpressionKinds2[OuterExpressionKinds2["TypeAssertions"] = 2] = "TypeAssertions";
        OuterExpressionKinds2[OuterExpressionKinds2["NonNullAssertions"] = 4] = "NonNullAssertions";
        OuterExpressionKinds2[OuterExpressionKinds2["PartiallyEmittedExpressions"] = 8] = "PartiallyEmittedExpressions";
        OuterExpressionKinds2[OuterExpressionKinds2["Assertions"] = 6] = "Assertions";
        OuterExpressionKinds2[OuterExpressionKinds2["All"] = 15] = "All";
      })(OuterExpressionKinds = ts2.OuterExpressionKinds || (ts2.OuterExpressionKinds = {}));
      function isOuterExpression(node, kinds) {
        if (kinds === void 0) {
          kinds = 15;
        }
        switch (node.kind) {
          case 200:
            return (kinds & 1) !== 0;
          case 199:
          case 217:
            return (kinds & 2) !== 0;
          case 218:
            return (kinds & 4) !== 0;
          case 326:
            return (kinds & 8) !== 0;
        }
        return false;
      }
      ts2.isOuterExpression = isOuterExpression;
      function skipOuterExpressions(node, kinds) {
        if (kinds === void 0) {
          kinds = 15;
        }
        while (isOuterExpression(node, kinds)) {
          node = node.expression;
        }
        return node;
      }
      ts2.skipOuterExpressions = skipOuterExpressions;
      function skipAssertions(node) {
        return skipOuterExpressions(node, 6);
      }
      ts2.skipAssertions = skipAssertions;
      function updateOuterExpression(outerExpression, expression) {
        switch (outerExpression.kind) {
          case 200:
            return ts2.updateParen(outerExpression, expression);
          case 199:
            return ts2.updateTypeAssertion(outerExpression, outerExpression.type, expression);
          case 217:
            return ts2.updateAsExpression(outerExpression, expression, outerExpression.type);
          case 218:
            return ts2.updateNonNullExpression(outerExpression, expression);
          case 326:
            return ts2.updatePartiallyEmittedExpression(outerExpression, expression);
        }
      }
      function isIgnorableParen(node) {
        return node.kind === 200 && ts2.nodeIsSynthesized(node) && ts2.nodeIsSynthesized(ts2.getSourceMapRange(node)) && ts2.nodeIsSynthesized(ts2.getCommentRange(node)) && !ts2.some(ts2.getSyntheticLeadingComments(node)) && !ts2.some(ts2.getSyntheticTrailingComments(node));
      }
      function recreateOuterExpressions(outerExpression, innerExpression, kinds) {
        if (kinds === void 0) {
          kinds = 15;
        }
        if (outerExpression && isOuterExpression(outerExpression, kinds) && !isIgnorableParen(outerExpression)) {
          return updateOuterExpression(outerExpression, recreateOuterExpressions(outerExpression.expression, innerExpression));
        }
        return innerExpression;
      }
      ts2.recreateOuterExpressions = recreateOuterExpressions;
      function startOnNewLine(node) {
        return ts2.setStartsOnNewLine(node, true);
      }
      ts2.startOnNewLine = startOnNewLine;
      function getExternalHelpersModuleName(node) {
        var parseNode = ts2.getOriginalNode(node, ts2.isSourceFile);
        var emitNode = parseNode && parseNode.emitNode;
        return emitNode && emitNode.externalHelpersModuleName;
      }
      ts2.getExternalHelpersModuleName = getExternalHelpersModuleName;
      function hasRecordedExternalHelpers(sourceFile) {
        var parseNode = ts2.getOriginalNode(sourceFile, ts2.isSourceFile);
        var emitNode = parseNode && parseNode.emitNode;
        return !!emitNode && (!!emitNode.externalHelpersModuleName || !!emitNode.externalHelpers);
      }
      ts2.hasRecordedExternalHelpers = hasRecordedExternalHelpers;
      function createExternalHelpersImportDeclarationIfNeeded(sourceFile, compilerOptions, hasExportStarsToExportValues, hasImportStar, hasImportDefault) {
        if (compilerOptions.importHelpers && ts2.isEffectiveExternalModule(sourceFile, compilerOptions)) {
          var namedBindings = void 0;
          var moduleKind = ts2.getEmitModuleKind(compilerOptions);
          if (moduleKind >= ts2.ModuleKind.ES2015 && moduleKind <= ts2.ModuleKind.ESNext) {
            var helpers = ts2.getEmitHelpers(sourceFile);
            if (helpers) {
              var helperNames = [];
              for (var _i = 0, helpers_2 = helpers; _i < helpers_2.length; _i++) {
                var helper = helpers_2[_i];
                if (!helper.scoped) {
                  var importName = helper.importName;
                  if (importName) {
                    ts2.pushIfUnique(helperNames, importName);
                  }
                }
              }
              if (ts2.some(helperNames)) {
                helperNames.sort(ts2.compareStringsCaseSensitive);
                namedBindings = ts2.createNamedImports(ts2.map(helperNames, function(name) {
                  return ts2.isFileLevelUniqueName(sourceFile, name) ? ts2.createImportSpecifier(void 0, ts2.createIdentifier(name)) : ts2.createImportSpecifier(ts2.createIdentifier(name), getUnscopedHelperName(name));
                }));
                var parseNode = ts2.getOriginalNode(sourceFile, ts2.isSourceFile);
                var emitNode = ts2.getOrCreateEmitNode(parseNode);
                emitNode.externalHelpers = true;
              }
            }
          } else {
            var externalHelpersModuleName = getOrCreateExternalHelpersModuleNameIfNeeded(sourceFile, compilerOptions, hasExportStarsToExportValues, hasImportStar || hasImportDefault);
            if (externalHelpersModuleName) {
              namedBindings = ts2.createNamespaceImport(externalHelpersModuleName);
            }
          }
          if (namedBindings) {
            var externalHelpersImportDeclaration = ts2.createImportDeclaration(void 0, void 0, ts2.createImportClause(void 0, namedBindings), ts2.createLiteral(ts2.externalHelpersModuleNameText));
            ts2.addEmitFlags(externalHelpersImportDeclaration, 67108864);
            return externalHelpersImportDeclaration;
          }
        }
      }
      ts2.createExternalHelpersImportDeclarationIfNeeded = createExternalHelpersImportDeclarationIfNeeded;
      function getOrCreateExternalHelpersModuleNameIfNeeded(node, compilerOptions, hasExportStarsToExportValues, hasImportStarOrImportDefault) {
        if (compilerOptions.importHelpers && ts2.isEffectiveExternalModule(node, compilerOptions)) {
          var externalHelpersModuleName = getExternalHelpersModuleName(node);
          if (externalHelpersModuleName) {
            return externalHelpersModuleName;
          }
          var moduleKind = ts2.getEmitModuleKind(compilerOptions);
          var create = (hasExportStarsToExportValues || compilerOptions.esModuleInterop && hasImportStarOrImportDefault) && moduleKind !== ts2.ModuleKind.System && moduleKind < ts2.ModuleKind.ES2015;
          if (!create) {
            var helpers = ts2.getEmitHelpers(node);
            if (helpers) {
              for (var _i = 0, helpers_3 = helpers; _i < helpers_3.length; _i++) {
                var helper = helpers_3[_i];
                if (!helper.scoped) {
                  create = true;
                  break;
                }
              }
            }
          }
          if (create) {
            var parseNode = ts2.getOriginalNode(node, ts2.isSourceFile);
            var emitNode = ts2.getOrCreateEmitNode(parseNode);
            return emitNode.externalHelpersModuleName || (emitNode.externalHelpersModuleName = ts2.createUniqueName(ts2.externalHelpersModuleNameText));
          }
        }
      }
      ts2.getOrCreateExternalHelpersModuleNameIfNeeded = getOrCreateExternalHelpersModuleNameIfNeeded;
      function getLocalNameForExternalImport(node, sourceFile) {
        var namespaceDeclaration = ts2.getNamespaceDeclarationNode(node);
        if (namespaceDeclaration && !ts2.isDefaultImport(node)) {
          var name = namespaceDeclaration.name;
          return ts2.isGeneratedIdentifier(name) ? name : ts2.createIdentifier(ts2.getSourceTextOfNodeFromSourceFile(sourceFile, name) || ts2.idText(name));
        }
        if (node.kind === 254 && node.importClause) {
          return ts2.getGeneratedNameForNode(node);
        }
        if (node.kind === 260 && node.moduleSpecifier) {
          return ts2.getGeneratedNameForNode(node);
        }
        return void 0;
      }
      ts2.getLocalNameForExternalImport = getLocalNameForExternalImport;
      function getExternalModuleNameLiteral(importNode, sourceFile, host, resolver, compilerOptions) {
        var moduleName = ts2.getExternalModuleName(importNode);
        if (moduleName.kind === 10) {
          return tryGetModuleNameFromDeclaration(importNode, host, resolver, compilerOptions) || tryRenameExternalModule(moduleName, sourceFile) || ts2.getSynthesizedClone(moduleName);
        }
        return void 0;
      }
      ts2.getExternalModuleNameLiteral = getExternalModuleNameLiteral;
      function tryRenameExternalModule(moduleName, sourceFile) {
        var rename = sourceFile.renamedDependencies && sourceFile.renamedDependencies.get(moduleName.text);
        return rename && ts2.createLiteral(rename);
      }
      function tryGetModuleNameFromFile(file, host, options) {
        if (!file) {
          return void 0;
        }
        if (file.moduleName) {
          return ts2.createLiteral(file.moduleName);
        }
        if (!file.isDeclarationFile && (options.out || options.outFile)) {
          return ts2.createLiteral(ts2.getExternalModuleNameFromPath(host, file.fileName));
        }
        return void 0;
      }
      ts2.tryGetModuleNameFromFile = tryGetModuleNameFromFile;
      function tryGetModuleNameFromDeclaration(declaration, host, resolver, compilerOptions) {
        return tryGetModuleNameFromFile(resolver.getExternalModuleFileFromDeclaration(declaration), host, compilerOptions);
      }
      function getInitializerOfBindingOrAssignmentElement(bindingElement) {
        if (ts2.isDeclarationBindingElement(bindingElement)) {
          return bindingElement.initializer;
        }
        if (ts2.isPropertyAssignment(bindingElement)) {
          var initializer = bindingElement.initializer;
          return ts2.isAssignmentExpression(initializer, true) ? initializer.right : void 0;
        }
        if (ts2.isShorthandPropertyAssignment(bindingElement)) {
          return bindingElement.objectAssignmentInitializer;
        }
        if (ts2.isAssignmentExpression(bindingElement, true)) {
          return bindingElement.right;
        }
        if (ts2.isSpreadElement(bindingElement)) {
          return getInitializerOfBindingOrAssignmentElement(bindingElement.expression);
        }
      }
      ts2.getInitializerOfBindingOrAssignmentElement = getInitializerOfBindingOrAssignmentElement;
      function getTargetOfBindingOrAssignmentElement(bindingElement) {
        if (ts2.isDeclarationBindingElement(bindingElement)) {
          return bindingElement.name;
        }
        if (ts2.isObjectLiteralElementLike(bindingElement)) {
          switch (bindingElement.kind) {
            case 281:
              return getTargetOfBindingOrAssignmentElement(bindingElement.initializer);
            case 282:
              return bindingElement.name;
            case 283:
              return getTargetOfBindingOrAssignmentElement(bindingElement.expression);
          }
          return void 0;
        }
        if (ts2.isAssignmentExpression(bindingElement, true)) {
          return getTargetOfBindingOrAssignmentElement(bindingElement.left);
        }
        if (ts2.isSpreadElement(bindingElement)) {
          return getTargetOfBindingOrAssignmentElement(bindingElement.expression);
        }
        return bindingElement;
      }
      ts2.getTargetOfBindingOrAssignmentElement = getTargetOfBindingOrAssignmentElement;
      function getRestIndicatorOfBindingOrAssignmentElement(bindingElement) {
        switch (bindingElement.kind) {
          case 156:
          case 191:
            return bindingElement.dotDotDotToken;
          case 213:
          case 283:
            return bindingElement;
        }
        return void 0;
      }
      ts2.getRestIndicatorOfBindingOrAssignmentElement = getRestIndicatorOfBindingOrAssignmentElement;
      function getPropertyNameOfBindingOrAssignmentElement(bindingElement) {
        var propertyName = tryGetPropertyNameOfBindingOrAssignmentElement(bindingElement);
        ts2.Debug.assert(!!propertyName || ts2.isSpreadAssignment(bindingElement), "Invalid property name for binding element.");
        return propertyName;
      }
      ts2.getPropertyNameOfBindingOrAssignmentElement = getPropertyNameOfBindingOrAssignmentElement;
      function tryGetPropertyNameOfBindingOrAssignmentElement(bindingElement) {
        switch (bindingElement.kind) {
          case 191:
            if (bindingElement.propertyName) {
              var propertyName = bindingElement.propertyName;
              if (ts2.isPrivateIdentifier(propertyName)) {
                return ts2.Debug.failBadSyntaxKind(propertyName);
              }
              return ts2.isComputedPropertyName(propertyName) && isStringOrNumericLiteral(propertyName.expression) ? propertyName.expression : propertyName;
            }
            break;
          case 281:
            if (bindingElement.name) {
              var propertyName = bindingElement.name;
              if (ts2.isPrivateIdentifier(propertyName)) {
                return ts2.Debug.failBadSyntaxKind(propertyName);
              }
              return ts2.isComputedPropertyName(propertyName) && isStringOrNumericLiteral(propertyName.expression) ? propertyName.expression : propertyName;
            }
            break;
          case 283:
            if (bindingElement.name && ts2.isPrivateIdentifier(bindingElement.name)) {
              return ts2.Debug.failBadSyntaxKind(bindingElement.name);
            }
            return bindingElement.name;
        }
        var target = getTargetOfBindingOrAssignmentElement(bindingElement);
        if (target && ts2.isPropertyName(target)) {
          return target;
        }
      }
      ts2.tryGetPropertyNameOfBindingOrAssignmentElement = tryGetPropertyNameOfBindingOrAssignmentElement;
      function isStringOrNumericLiteral(node) {
        var kind = node.kind;
        return kind === 10 || kind === 8;
      }
      function getElementsOfBindingOrAssignmentPattern(name) {
        switch (name.kind) {
          case 189:
          case 190:
          case 192:
            return name.elements;
          case 193:
            return name.properties;
        }
      }
      ts2.getElementsOfBindingOrAssignmentPattern = getElementsOfBindingOrAssignmentPattern;
      function convertToArrayAssignmentElement(element) {
        if (ts2.isBindingElement(element)) {
          if (element.dotDotDotToken) {
            ts2.Debug.assertNode(element.name, ts2.isIdentifier);
            return ts2.setOriginalNode(ts2.setTextRange(ts2.createSpread(element.name), element), element);
          }
          var expression = convertToAssignmentElementTarget(element.name);
          return element.initializer ? ts2.setOriginalNode(ts2.setTextRange(ts2.createAssignment(expression, element.initializer), element), element) : expression;
        }
        ts2.Debug.assertNode(element, ts2.isExpression);
        return element;
      }
      ts2.convertToArrayAssignmentElement = convertToArrayAssignmentElement;
      function convertToObjectAssignmentElement(element) {
        if (ts2.isBindingElement(element)) {
          if (element.dotDotDotToken) {
            ts2.Debug.assertNode(element.name, ts2.isIdentifier);
            return ts2.setOriginalNode(ts2.setTextRange(ts2.createSpreadAssignment(element.name), element), element);
          }
          if (element.propertyName) {
            var expression = convertToAssignmentElementTarget(element.name);
            return ts2.setOriginalNode(ts2.setTextRange(ts2.createPropertyAssignment(element.propertyName, element.initializer ? ts2.createAssignment(expression, element.initializer) : expression), element), element);
          }
          ts2.Debug.assertNode(element.name, ts2.isIdentifier);
          return ts2.setOriginalNode(ts2.setTextRange(ts2.createShorthandPropertyAssignment(element.name, element.initializer), element), element);
        }
        ts2.Debug.assertNode(element, ts2.isObjectLiteralElementLike);
        return element;
      }
      ts2.convertToObjectAssignmentElement = convertToObjectAssignmentElement;
      function convertToAssignmentPattern(node) {
        switch (node.kind) {
          case 190:
          case 192:
            return convertToArrayAssignmentPattern(node);
          case 189:
          case 193:
            return convertToObjectAssignmentPattern(node);
        }
      }
      ts2.convertToAssignmentPattern = convertToAssignmentPattern;
      function convertToObjectAssignmentPattern(node) {
        if (ts2.isObjectBindingPattern(node)) {
          return ts2.setOriginalNode(ts2.setTextRange(ts2.createObjectLiteral(ts2.map(node.elements, convertToObjectAssignmentElement)), node), node);
        }
        ts2.Debug.assertNode(node, ts2.isObjectLiteralExpression);
        return node;
      }
      ts2.convertToObjectAssignmentPattern = convertToObjectAssignmentPattern;
      function convertToArrayAssignmentPattern(node) {
        if (ts2.isArrayBindingPattern(node)) {
          return ts2.setOriginalNode(ts2.setTextRange(ts2.createArrayLiteral(ts2.map(node.elements, convertToArrayAssignmentElement)), node), node);
        }
        ts2.Debug.assertNode(node, ts2.isArrayLiteralExpression);
        return node;
      }
      ts2.convertToArrayAssignmentPattern = convertToArrayAssignmentPattern;
      function convertToAssignmentElementTarget(node) {
        if (ts2.isBindingPattern(node)) {
          return convertToAssignmentPattern(node);
        }
        ts2.Debug.assertNode(node, ts2.isExpression);
        return node;
      }
      ts2.convertToAssignmentElementTarget = convertToAssignmentElementTarget;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var isTypeNodeOrTypeParameterDeclaration = ts2.or(ts2.isTypeNode, ts2.isTypeParameterDeclaration);
      function visitNode(node, visitor, test, lift) {
        if (node === void 0 || visitor === void 0) {
          return node;
        }
        ts2.aggregateTransformFlags(node);
        var visited = visitor(node);
        if (visited === node) {
          return node;
        }
        var visitedNode;
        if (visited === void 0) {
          return void 0;
        } else if (ts2.isArray(visited)) {
          visitedNode = (lift || extractSingleNode)(visited);
        } else {
          visitedNode = visited;
        }
        ts2.Debug.assertNode(visitedNode, test);
        ts2.aggregateTransformFlags(visitedNode);
        return visitedNode;
      }
      ts2.visitNode = visitNode;
      function visitNodes(nodes, visitor, test, start, count) {
        if (nodes === void 0 || visitor === void 0) {
          return nodes;
        }
        var updated;
        var length = nodes.length;
        if (start === void 0 || start < 0) {
          start = 0;
        }
        if (count === void 0 || count > length - start) {
          count = length - start;
        }
        if (start > 0 || count < length) {
          updated = ts2.createNodeArray([], nodes.hasTrailingComma && start + count === length);
        }
        for (var i = 0; i < count; i++) {
          var node = nodes[i + start];
          ts2.aggregateTransformFlags(node);
          var visited = node !== void 0 ? visitor(node) : void 0;
          if (updated !== void 0 || visited === void 0 || visited !== node) {
            if (updated === void 0) {
              updated = ts2.createNodeArray(nodes.slice(0, i), nodes.hasTrailingComma);
              ts2.setTextRange(updated, nodes);
            }
            if (visited) {
              if (ts2.isArray(visited)) {
                for (var _i = 0, visited_1 = visited; _i < visited_1.length; _i++) {
                  var visitedNode = visited_1[_i];
                  ts2.Debug.assertNode(visitedNode, test);
                  ts2.aggregateTransformFlags(visitedNode);
                  updated.push(visitedNode);
                }
              } else {
                ts2.Debug.assertNode(visited, test);
                ts2.aggregateTransformFlags(visited);
                updated.push(visited);
              }
            }
          }
        }
        return updated || nodes;
      }
      ts2.visitNodes = visitNodes;
      function visitLexicalEnvironment(statements, visitor, context, start, ensureUseStrict) {
        context.startLexicalEnvironment();
        statements = visitNodes(statements, visitor, ts2.isStatement, start);
        if (ensureUseStrict)
          statements = ts2.ensureUseStrict(statements);
        return ts2.mergeLexicalEnvironment(statements, context.endLexicalEnvironment());
      }
      ts2.visitLexicalEnvironment = visitLexicalEnvironment;
      function visitParameterList(nodes, visitor, context, nodesVisitor) {
        if (nodesVisitor === void 0) {
          nodesVisitor = visitNodes;
        }
        var updated;
        context.startLexicalEnvironment();
        if (nodes) {
          context.setLexicalEnvironmentFlags(1, true);
          updated = nodesVisitor(nodes, visitor, ts2.isParameterDeclaration);
          if (context.getLexicalEnvironmentFlags() & 2 && ts2.getEmitScriptTarget(context.getCompilerOptions()) >= 2) {
            updated = addDefaultValueAssignmentsIfNeeded(updated, context);
          }
          context.setLexicalEnvironmentFlags(1, false);
        }
        context.suspendLexicalEnvironment();
        return updated;
      }
      ts2.visitParameterList = visitParameterList;
      function addDefaultValueAssignmentsIfNeeded(parameters, context) {
        var result;
        for (var i = 0; i < parameters.length; i++) {
          var parameter = parameters[i];
          var updated = addDefaultValueAssignmentIfNeeded(parameter, context);
          if (result || updated !== parameter) {
            if (!result)
              result = parameters.slice(0, i);
            result[i] = updated;
          }
        }
        if (result) {
          return ts2.setTextRange(ts2.createNodeArray(result, parameters.hasTrailingComma), parameters);
        }
        return parameters;
      }
      function addDefaultValueAssignmentIfNeeded(parameter, context) {
        return parameter.dotDotDotToken ? parameter : ts2.isBindingPattern(parameter.name) ? addDefaultValueAssignmentForBindingPattern(parameter, context) : parameter.initializer ? addDefaultValueAssignmentForInitializer(parameter, parameter.name, parameter.initializer, context) : parameter;
      }
      function addDefaultValueAssignmentForBindingPattern(parameter, context) {
        context.addInitializationStatement(ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([
          ts2.createVariableDeclaration(parameter.name, parameter.type, parameter.initializer ? ts2.createConditional(ts2.createStrictEquality(ts2.getGeneratedNameForNode(parameter), ts2.createVoidZero()), parameter.initializer, ts2.getGeneratedNameForNode(parameter)) : ts2.getGeneratedNameForNode(parameter))
        ])));
        return ts2.updateParameter(parameter, parameter.decorators, parameter.modifiers, parameter.dotDotDotToken, ts2.getGeneratedNameForNode(parameter), parameter.questionToken, parameter.type, void 0);
      }
      function addDefaultValueAssignmentForInitializer(parameter, name, initializer, context) {
        context.addInitializationStatement(ts2.createIf(ts2.createTypeCheck(ts2.getSynthesizedClone(name), "undefined"), ts2.setEmitFlags(ts2.setTextRange(ts2.createBlock([
          ts2.createExpressionStatement(ts2.setEmitFlags(ts2.setTextRange(ts2.createAssignment(ts2.setEmitFlags(ts2.getMutableClone(name), 48), ts2.setEmitFlags(initializer, 48 | ts2.getEmitFlags(initializer) | 1536)), parameter), 1536))
        ]), parameter), 1 | 32 | 384 | 1536)));
        return ts2.updateParameter(parameter, parameter.decorators, parameter.modifiers, parameter.dotDotDotToken, parameter.name, parameter.questionToken, parameter.type, void 0);
      }
      function visitFunctionBody(node, visitor, context) {
        context.resumeLexicalEnvironment();
        var updated = visitNode(node, visitor, ts2.isConciseBody);
        var declarations = context.endLexicalEnvironment();
        if (ts2.some(declarations)) {
          var block = ts2.convertToFunctionBody(updated);
          var statements = ts2.mergeLexicalEnvironment(block.statements, declarations);
          return ts2.updateBlock(block, statements);
        }
        return updated;
      }
      ts2.visitFunctionBody = visitFunctionBody;
      function visitEachChild(node, visitor, context, nodesVisitor, tokenVisitor) {
        if (nodesVisitor === void 0) {
          nodesVisitor = visitNodes;
        }
        if (node === void 0) {
          return void 0;
        }
        var kind = node.kind;
        if (kind > 0 && kind <= 152 || kind === 183) {
          return node;
        }
        switch (kind) {
          case 75:
            return ts2.updateIdentifier(node, nodesVisitor(node.typeArguments, visitor, isTypeNodeOrTypeParameterDeclaration));
          case 153:
            return ts2.updateQualifiedName(node, visitNode(node.left, visitor, ts2.isEntityName), visitNode(node.right, visitor, ts2.isIdentifier));
          case 154:
            return ts2.updateComputedPropertyName(node, visitNode(node.expression, visitor, ts2.isExpression));
          case 155:
            return ts2.updateTypeParameterDeclaration(node, visitNode(node.name, visitor, ts2.isIdentifier), visitNode(node.constraint, visitor, ts2.isTypeNode), visitNode(node.default, visitor, ts2.isTypeNode));
          case 156:
            return ts2.updateParameter(node, nodesVisitor(node.decorators, visitor, ts2.isDecorator), nodesVisitor(node.modifiers, visitor, ts2.isModifier), visitNode(node.dotDotDotToken, tokenVisitor, ts2.isToken), visitNode(node.name, visitor, ts2.isBindingName), visitNode(node.questionToken, tokenVisitor, ts2.isToken), visitNode(node.type, visitor, ts2.isTypeNode), visitNode(node.initializer, visitor, ts2.isExpression));
          case 157:
            return ts2.updateDecorator(node, visitNode(node.expression, visitor, ts2.isExpression));
          case 158:
            return ts2.updatePropertySignature(node, nodesVisitor(node.modifiers, visitor, ts2.isToken), visitNode(node.name, visitor, ts2.isPropertyName), visitNode(node.questionToken, tokenVisitor, ts2.isToken), visitNode(node.type, visitor, ts2.isTypeNode), visitNode(node.initializer, visitor, ts2.isExpression));
          case 159:
            return ts2.updateProperty(node, nodesVisitor(node.decorators, visitor, ts2.isDecorator), nodesVisitor(node.modifiers, visitor, ts2.isModifier), visitNode(node.name, visitor, ts2.isPropertyName), visitNode(node.questionToken || node.exclamationToken, tokenVisitor, ts2.isToken), visitNode(node.type, visitor, ts2.isTypeNode), visitNode(node.initializer, visitor, ts2.isExpression));
          case 160:
            return ts2.updateMethodSignature(node, nodesVisitor(node.typeParameters, visitor, ts2.isTypeParameterDeclaration), nodesVisitor(node.parameters, visitor, ts2.isParameterDeclaration), visitNode(node.type, visitor, ts2.isTypeNode), visitNode(node.name, visitor, ts2.isPropertyName), visitNode(node.questionToken, tokenVisitor, ts2.isToken));
          case 161:
            return ts2.updateMethod(node, nodesVisitor(node.decorators, visitor, ts2.isDecorator), nodesVisitor(node.modifiers, visitor, ts2.isModifier), visitNode(node.asteriskToken, tokenVisitor, ts2.isToken), visitNode(node.name, visitor, ts2.isPropertyName), visitNode(node.questionToken, tokenVisitor, ts2.isToken), nodesVisitor(node.typeParameters, visitor, ts2.isTypeParameterDeclaration), visitParameterList(node.parameters, visitor, context, nodesVisitor), visitNode(node.type, visitor, ts2.isTypeNode), visitFunctionBody(node.body, visitor, context));
          case 162:
            return ts2.updateConstructor(node, nodesVisitor(node.decorators, visitor, ts2.isDecorator), nodesVisitor(node.modifiers, visitor, ts2.isModifier), visitParameterList(node.parameters, visitor, context, nodesVisitor), visitFunctionBody(node.body, visitor, context));
          case 163:
            return ts2.updateGetAccessor(node, nodesVisitor(node.decorators, visitor, ts2.isDecorator), nodesVisitor(node.modifiers, visitor, ts2.isModifier), visitNode(node.name, visitor, ts2.isPropertyName), visitParameterList(node.parameters, visitor, context, nodesVisitor), visitNode(node.type, visitor, ts2.isTypeNode), visitFunctionBody(node.body, visitor, context));
          case 164:
            return ts2.updateSetAccessor(node, nodesVisitor(node.decorators, visitor, ts2.isDecorator), nodesVisitor(node.modifiers, visitor, ts2.isModifier), visitNode(node.name, visitor, ts2.isPropertyName), visitParameterList(node.parameters, visitor, context, nodesVisitor), visitFunctionBody(node.body, visitor, context));
          case 165:
            return ts2.updateCallSignature(node, nodesVisitor(node.typeParameters, visitor, ts2.isTypeParameterDeclaration), nodesVisitor(node.parameters, visitor, ts2.isParameterDeclaration), visitNode(node.type, visitor, ts2.isTypeNode));
          case 166:
            return ts2.updateConstructSignature(node, nodesVisitor(node.typeParameters, visitor, ts2.isTypeParameterDeclaration), nodesVisitor(node.parameters, visitor, ts2.isParameterDeclaration), visitNode(node.type, visitor, ts2.isTypeNode));
          case 167:
            return ts2.updateIndexSignature(node, nodesVisitor(node.decorators, visitor, ts2.isDecorator), nodesVisitor(node.modifiers, visitor, ts2.isModifier), nodesVisitor(node.parameters, visitor, ts2.isParameterDeclaration), visitNode(node.type, visitor, ts2.isTypeNode));
          case 168:
            return ts2.updateTypePredicateNodeWithModifier(node, visitNode(node.assertsModifier, visitor), visitNode(node.parameterName, visitor), visitNode(node.type, visitor, ts2.isTypeNode));
          case 169:
            return ts2.updateTypeReferenceNode(node, visitNode(node.typeName, visitor, ts2.isEntityName), nodesVisitor(node.typeArguments, visitor, ts2.isTypeNode));
          case 170:
            return ts2.updateFunctionTypeNode(node, nodesVisitor(node.typeParameters, visitor, ts2.isTypeParameterDeclaration), nodesVisitor(node.parameters, visitor, ts2.isParameterDeclaration), visitNode(node.type, visitor, ts2.isTypeNode));
          case 171:
            return ts2.updateConstructorTypeNode(node, nodesVisitor(node.typeParameters, visitor, ts2.isTypeParameterDeclaration), nodesVisitor(node.parameters, visitor, ts2.isParameterDeclaration), visitNode(node.type, visitor, ts2.isTypeNode));
          case 172:
            return ts2.updateTypeQueryNode(node, visitNode(node.exprName, visitor, ts2.isEntityName));
          case 173:
            return ts2.updateTypeLiteralNode(node, nodesVisitor(node.members, visitor, ts2.isTypeElement));
          case 174:
            return ts2.updateArrayTypeNode(node, visitNode(node.elementType, visitor, ts2.isTypeNode));
          case 175:
            return ts2.updateTupleTypeNode(node, nodesVisitor(node.elementTypes, visitor, ts2.isTypeNode));
          case 176:
            return ts2.updateOptionalTypeNode(node, visitNode(node.type, visitor, ts2.isTypeNode));
          case 177:
            return ts2.updateRestTypeNode(node, visitNode(node.type, visitor, ts2.isTypeNode));
          case 178:
            return ts2.updateUnionTypeNode(node, nodesVisitor(node.types, visitor, ts2.isTypeNode));
          case 179:
            return ts2.updateIntersectionTypeNode(node, nodesVisitor(node.types, visitor, ts2.isTypeNode));
          case 180:
            return ts2.updateConditionalTypeNode(node, visitNode(node.checkType, visitor, ts2.isTypeNode), visitNode(node.extendsType, visitor, ts2.isTypeNode), visitNode(node.trueType, visitor, ts2.isTypeNode), visitNode(node.falseType, visitor, ts2.isTypeNode));
          case 181:
            return ts2.updateInferTypeNode(node, visitNode(node.typeParameter, visitor, ts2.isTypeParameterDeclaration));
          case 188:
            return ts2.updateImportTypeNode(node, visitNode(node.argument, visitor, ts2.isTypeNode), visitNode(node.qualifier, visitor, ts2.isEntityName), visitNodes(node.typeArguments, visitor, ts2.isTypeNode), node.isTypeOf);
          case 182:
            return ts2.updateParenthesizedType(node, visitNode(node.type, visitor, ts2.isTypeNode));
          case 184:
            return ts2.updateTypeOperatorNode(node, visitNode(node.type, visitor, ts2.isTypeNode));
          case 185:
            return ts2.updateIndexedAccessTypeNode(node, visitNode(node.objectType, visitor, ts2.isTypeNode), visitNode(node.indexType, visitor, ts2.isTypeNode));
          case 186:
            return ts2.updateMappedTypeNode(node, visitNode(node.readonlyToken, tokenVisitor, ts2.isToken), visitNode(node.typeParameter, visitor, ts2.isTypeParameterDeclaration), visitNode(node.questionToken, tokenVisitor, ts2.isToken), visitNode(node.type, visitor, ts2.isTypeNode));
          case 187:
            return ts2.updateLiteralTypeNode(node, visitNode(node.literal, visitor, ts2.isExpression));
          case 189:
            return ts2.updateObjectBindingPattern(node, nodesVisitor(node.elements, visitor, ts2.isBindingElement));
          case 190:
            return ts2.updateArrayBindingPattern(node, nodesVisitor(node.elements, visitor, ts2.isArrayBindingElement));
          case 191:
            return ts2.updateBindingElement(node, visitNode(node.dotDotDotToken, tokenVisitor, ts2.isToken), visitNode(node.propertyName, visitor, ts2.isPropertyName), visitNode(node.name, visitor, ts2.isBindingName), visitNode(node.initializer, visitor, ts2.isExpression));
          case 192:
            return ts2.updateArrayLiteral(node, nodesVisitor(node.elements, visitor, ts2.isExpression));
          case 193:
            return ts2.updateObjectLiteral(node, nodesVisitor(node.properties, visitor, ts2.isObjectLiteralElementLike));
          case 194:
            if (node.flags & 32) {
              return ts2.updatePropertyAccessChain(node, visitNode(node.expression, visitor, ts2.isExpression), visitNode(node.questionDotToken, tokenVisitor, ts2.isToken), visitNode(node.name, visitor, ts2.isIdentifier));
            }
            return ts2.updatePropertyAccess(node, visitNode(node.expression, visitor, ts2.isExpression), visitNode(node.name, visitor, ts2.isIdentifierOrPrivateIdentifier));
          case 195:
            if (node.flags & 32) {
              return ts2.updateElementAccessChain(node, visitNode(node.expression, visitor, ts2.isExpression), visitNode(node.questionDotToken, tokenVisitor, ts2.isToken), visitNode(node.argumentExpression, visitor, ts2.isExpression));
            }
            return ts2.updateElementAccess(node, visitNode(node.expression, visitor, ts2.isExpression), visitNode(node.argumentExpression, visitor, ts2.isExpression));
          case 196:
            if (node.flags & 32) {
              return ts2.updateCallChain(node, visitNode(node.expression, visitor, ts2.isExpression), visitNode(node.questionDotToken, tokenVisitor, ts2.isToken), nodesVisitor(node.typeArguments, visitor, ts2.isTypeNode), nodesVisitor(node.arguments, visitor, ts2.isExpression));
            }
            return ts2.updateCall(node, visitNode(node.expression, visitor, ts2.isExpression), nodesVisitor(node.typeArguments, visitor, ts2.isTypeNode), nodesVisitor(node.arguments, visitor, ts2.isExpression));
          case 197:
            return ts2.updateNew(node, visitNode(node.expression, visitor, ts2.isExpression), nodesVisitor(node.typeArguments, visitor, ts2.isTypeNode), nodesVisitor(node.arguments, visitor, ts2.isExpression));
          case 198:
            return ts2.updateTaggedTemplate(node, visitNode(node.tag, visitor, ts2.isExpression), visitNodes(node.typeArguments, visitor, ts2.isExpression), visitNode(node.template, visitor, ts2.isTemplateLiteral));
          case 199:
            return ts2.updateTypeAssertion(node, visitNode(node.type, visitor, ts2.isTypeNode), visitNode(node.expression, visitor, ts2.isExpression));
          case 200:
            return ts2.updateParen(node, visitNode(node.expression, visitor, ts2.isExpression));
          case 201:
            return ts2.updateFunctionExpression(node, nodesVisitor(node.modifiers, visitor, ts2.isModifier), visitNode(node.asteriskToken, tokenVisitor, ts2.isToken), visitNode(node.name, visitor, ts2.isIdentifier), nodesVisitor(node.typeParameters, visitor, ts2.isTypeParameterDeclaration), visitParameterList(node.parameters, visitor, context, nodesVisitor), visitNode(node.type, visitor, ts2.isTypeNode), visitFunctionBody(node.body, visitor, context));
          case 202:
            return ts2.updateArrowFunction(node, nodesVisitor(node.modifiers, visitor, ts2.isModifier), nodesVisitor(node.typeParameters, visitor, ts2.isTypeParameterDeclaration), visitParameterList(node.parameters, visitor, context, nodesVisitor), visitNode(node.type, visitor, ts2.isTypeNode), visitNode(node.equalsGreaterThanToken, tokenVisitor, ts2.isToken), visitFunctionBody(node.body, visitor, context));
          case 203:
            return ts2.updateDelete(node, visitNode(node.expression, visitor, ts2.isExpression));
          case 204:
            return ts2.updateTypeOf(node, visitNode(node.expression, visitor, ts2.isExpression));
          case 205:
            return ts2.updateVoid(node, visitNode(node.expression, visitor, ts2.isExpression));
          case 206:
            return ts2.updateAwait(node, visitNode(node.expression, visitor, ts2.isExpression));
          case 207:
            return ts2.updatePrefix(node, visitNode(node.operand, visitor, ts2.isExpression));
          case 208:
            return ts2.updatePostfix(node, visitNode(node.operand, visitor, ts2.isExpression));
          case 209:
            return ts2.updateBinary(node, visitNode(node.left, visitor, ts2.isExpression), visitNode(node.right, visitor, ts2.isExpression), visitNode(node.operatorToken, tokenVisitor, ts2.isToken));
          case 210:
            return ts2.updateConditional(node, visitNode(node.condition, visitor, ts2.isExpression), visitNode(node.questionToken, tokenVisitor, ts2.isToken), visitNode(node.whenTrue, visitor, ts2.isExpression), visitNode(node.colonToken, tokenVisitor, ts2.isToken), visitNode(node.whenFalse, visitor, ts2.isExpression));
          case 211:
            return ts2.updateTemplateExpression(node, visitNode(node.head, visitor, ts2.isTemplateHead), nodesVisitor(node.templateSpans, visitor, ts2.isTemplateSpan));
          case 212:
            return ts2.updateYield(node, visitNode(node.asteriskToken, tokenVisitor, ts2.isToken), visitNode(node.expression, visitor, ts2.isExpression));
          case 213:
            return ts2.updateSpread(node, visitNode(node.expression, visitor, ts2.isExpression));
          case 214:
            return ts2.updateClassExpression(node, nodesVisitor(node.modifiers, visitor, ts2.isModifier), visitNode(node.name, visitor, ts2.isIdentifier), nodesVisitor(node.typeParameters, visitor, ts2.isTypeParameterDeclaration), nodesVisitor(node.heritageClauses, visitor, ts2.isHeritageClause), nodesVisitor(node.members, visitor, ts2.isClassElement));
          case 216:
            return ts2.updateExpressionWithTypeArguments(node, nodesVisitor(node.typeArguments, visitor, ts2.isTypeNode), visitNode(node.expression, visitor, ts2.isExpression));
          case 217:
            return ts2.updateAsExpression(node, visitNode(node.expression, visitor, ts2.isExpression), visitNode(node.type, visitor, ts2.isTypeNode));
          case 218:
            return ts2.updateNonNullExpression(node, visitNode(node.expression, visitor, ts2.isExpression));
          case 219:
            return ts2.updateMetaProperty(node, visitNode(node.name, visitor, ts2.isIdentifier));
          case 221:
            return ts2.updateTemplateSpan(node, visitNode(node.expression, visitor, ts2.isExpression), visitNode(node.literal, visitor, ts2.isTemplateMiddleOrTemplateTail));
          case 223:
            return ts2.updateBlock(node, nodesVisitor(node.statements, visitor, ts2.isStatement));
          case 225:
            return ts2.updateVariableStatement(node, nodesVisitor(node.modifiers, visitor, ts2.isModifier), visitNode(node.declarationList, visitor, ts2.isVariableDeclarationList));
          case 226:
            return ts2.updateExpressionStatement(node, visitNode(node.expression, visitor, ts2.isExpression));
          case 227:
            return ts2.updateIf(node, visitNode(node.expression, visitor, ts2.isExpression), visitNode(node.thenStatement, visitor, ts2.isStatement, ts2.liftToBlock), visitNode(node.elseStatement, visitor, ts2.isStatement, ts2.liftToBlock));
          case 228:
            return ts2.updateDo(node, visitNode(node.statement, visitor, ts2.isStatement, ts2.liftToBlock), visitNode(node.expression, visitor, ts2.isExpression));
          case 229:
            return ts2.updateWhile(node, visitNode(node.expression, visitor, ts2.isExpression), visitNode(node.statement, visitor, ts2.isStatement, ts2.liftToBlock));
          case 230:
            return ts2.updateFor(node, visitNode(node.initializer, visitor, ts2.isForInitializer), visitNode(node.condition, visitor, ts2.isExpression), visitNode(node.incrementor, visitor, ts2.isExpression), visitNode(node.statement, visitor, ts2.isStatement, ts2.liftToBlock));
          case 231:
            return ts2.updateForIn(node, visitNode(node.initializer, visitor, ts2.isForInitializer), visitNode(node.expression, visitor, ts2.isExpression), visitNode(node.statement, visitor, ts2.isStatement, ts2.liftToBlock));
          case 232:
            return ts2.updateForOf(node, visitNode(node.awaitModifier, tokenVisitor, ts2.isToken), visitNode(node.initializer, visitor, ts2.isForInitializer), visitNode(node.expression, visitor, ts2.isExpression), visitNode(node.statement, visitor, ts2.isStatement, ts2.liftToBlock));
          case 233:
            return ts2.updateContinue(node, visitNode(node.label, visitor, ts2.isIdentifier));
          case 234:
            return ts2.updateBreak(node, visitNode(node.label, visitor, ts2.isIdentifier));
          case 235:
            return ts2.updateReturn(node, visitNode(node.expression, visitor, ts2.isExpression));
          case 236:
            return ts2.updateWith(node, visitNode(node.expression, visitor, ts2.isExpression), visitNode(node.statement, visitor, ts2.isStatement, ts2.liftToBlock));
          case 237:
            return ts2.updateSwitch(node, visitNode(node.expression, visitor, ts2.isExpression), visitNode(node.caseBlock, visitor, ts2.isCaseBlock));
          case 238:
            return ts2.updateLabel(node, visitNode(node.label, visitor, ts2.isIdentifier), visitNode(node.statement, visitor, ts2.isStatement, ts2.liftToBlock));
          case 239:
            return ts2.updateThrow(node, visitNode(node.expression, visitor, ts2.isExpression));
          case 240:
            return ts2.updateTry(node, visitNode(node.tryBlock, visitor, ts2.isBlock), visitNode(node.catchClause, visitor, ts2.isCatchClause), visitNode(node.finallyBlock, visitor, ts2.isBlock));
          case 242:
            return ts2.updateTypeScriptVariableDeclaration(node, visitNode(node.name, visitor, ts2.isBindingName), visitNode(node.exclamationToken, tokenVisitor, ts2.isToken), visitNode(node.type, visitor, ts2.isTypeNode), visitNode(node.initializer, visitor, ts2.isExpression));
          case 243:
            return ts2.updateVariableDeclarationList(node, nodesVisitor(node.declarations, visitor, ts2.isVariableDeclaration));
          case 244:
            return ts2.updateFunctionDeclaration(node, nodesVisitor(node.decorators, visitor, ts2.isDecorator), nodesVisitor(node.modifiers, visitor, ts2.isModifier), visitNode(node.asteriskToken, tokenVisitor, ts2.isToken), visitNode(node.name, visitor, ts2.isIdentifier), nodesVisitor(node.typeParameters, visitor, ts2.isTypeParameterDeclaration), visitParameterList(node.parameters, visitor, context, nodesVisitor), visitNode(node.type, visitor, ts2.isTypeNode), visitFunctionBody(node.body, visitor, context));
          case 245:
            return ts2.updateClassDeclaration(node, nodesVisitor(node.decorators, visitor, ts2.isDecorator), nodesVisitor(node.modifiers, visitor, ts2.isModifier), visitNode(node.name, visitor, ts2.isIdentifier), nodesVisitor(node.typeParameters, visitor, ts2.isTypeParameterDeclaration), nodesVisitor(node.heritageClauses, visitor, ts2.isHeritageClause), nodesVisitor(node.members, visitor, ts2.isClassElement));
          case 246:
            return ts2.updateInterfaceDeclaration(node, nodesVisitor(node.decorators, visitor, ts2.isDecorator), nodesVisitor(node.modifiers, visitor, ts2.isModifier), visitNode(node.name, visitor, ts2.isIdentifier), nodesVisitor(node.typeParameters, visitor, ts2.isTypeParameterDeclaration), nodesVisitor(node.heritageClauses, visitor, ts2.isHeritageClause), nodesVisitor(node.members, visitor, ts2.isTypeElement));
          case 247:
            return ts2.updateTypeAliasDeclaration(node, nodesVisitor(node.decorators, visitor, ts2.isDecorator), nodesVisitor(node.modifiers, visitor, ts2.isModifier), visitNode(node.name, visitor, ts2.isIdentifier), nodesVisitor(node.typeParameters, visitor, ts2.isTypeParameterDeclaration), visitNode(node.type, visitor, ts2.isTypeNode));
          case 248:
            return ts2.updateEnumDeclaration(node, nodesVisitor(node.decorators, visitor, ts2.isDecorator), nodesVisitor(node.modifiers, visitor, ts2.isModifier), visitNode(node.name, visitor, ts2.isIdentifier), nodesVisitor(node.members, visitor, ts2.isEnumMember));
          case 249:
            return ts2.updateModuleDeclaration(node, nodesVisitor(node.decorators, visitor, ts2.isDecorator), nodesVisitor(node.modifiers, visitor, ts2.isModifier), visitNode(node.name, visitor, ts2.isIdentifier), visitNode(node.body, visitor, ts2.isModuleBody));
          case 250:
            return ts2.updateModuleBlock(node, nodesVisitor(node.statements, visitor, ts2.isStatement));
          case 251:
            return ts2.updateCaseBlock(node, nodesVisitor(node.clauses, visitor, ts2.isCaseOrDefaultClause));
          case 252:
            return ts2.updateNamespaceExportDeclaration(node, visitNode(node.name, visitor, ts2.isIdentifier));
          case 253:
            return ts2.updateImportEqualsDeclaration(node, nodesVisitor(node.decorators, visitor, ts2.isDecorator), nodesVisitor(node.modifiers, visitor, ts2.isModifier), visitNode(node.name, visitor, ts2.isIdentifier), visitNode(node.moduleReference, visitor, ts2.isModuleReference));
          case 254:
            return ts2.updateImportDeclaration(node, nodesVisitor(node.decorators, visitor, ts2.isDecorator), nodesVisitor(node.modifiers, visitor, ts2.isModifier), visitNode(node.importClause, visitor, ts2.isImportClause), visitNode(node.moduleSpecifier, visitor, ts2.isExpression));
          case 255:
            return ts2.updateImportClause(node, visitNode(node.name, visitor, ts2.isIdentifier), visitNode(node.namedBindings, visitor, ts2.isNamedImportBindings), node.isTypeOnly);
          case 256:
            return ts2.updateNamespaceImport(node, visitNode(node.name, visitor, ts2.isIdentifier));
          case 262:
            return ts2.updateNamespaceExport(node, visitNode(node.name, visitor, ts2.isIdentifier));
          case 257:
            return ts2.updateNamedImports(node, nodesVisitor(node.elements, visitor, ts2.isImportSpecifier));
          case 258:
            return ts2.updateImportSpecifier(node, visitNode(node.propertyName, visitor, ts2.isIdentifier), visitNode(node.name, visitor, ts2.isIdentifier));
          case 259:
            return ts2.updateExportAssignment(node, nodesVisitor(node.decorators, visitor, ts2.isDecorator), nodesVisitor(node.modifiers, visitor, ts2.isModifier), visitNode(node.expression, visitor, ts2.isExpression));
          case 260:
            return ts2.updateExportDeclaration(node, nodesVisitor(node.decorators, visitor, ts2.isDecorator), nodesVisitor(node.modifiers, visitor, ts2.isModifier), visitNode(node.exportClause, visitor, ts2.isNamedExportBindings), visitNode(node.moduleSpecifier, visitor, ts2.isExpression), node.isTypeOnly);
          case 261:
            return ts2.updateNamedExports(node, nodesVisitor(node.elements, visitor, ts2.isExportSpecifier));
          case 263:
            return ts2.updateExportSpecifier(node, visitNode(node.propertyName, visitor, ts2.isIdentifier), visitNode(node.name, visitor, ts2.isIdentifier));
          case 265:
            return ts2.updateExternalModuleReference(node, visitNode(node.expression, visitor, ts2.isExpression));
          case 266:
            return ts2.updateJsxElement(node, visitNode(node.openingElement, visitor, ts2.isJsxOpeningElement), nodesVisitor(node.children, visitor, ts2.isJsxChild), visitNode(node.closingElement, visitor, ts2.isJsxClosingElement));
          case 267:
            return ts2.updateJsxSelfClosingElement(node, visitNode(node.tagName, visitor, ts2.isJsxTagNameExpression), nodesVisitor(node.typeArguments, visitor, ts2.isTypeNode), visitNode(node.attributes, visitor, ts2.isJsxAttributes));
          case 268:
            return ts2.updateJsxOpeningElement(node, visitNode(node.tagName, visitor, ts2.isJsxTagNameExpression), nodesVisitor(node.typeArguments, visitor, ts2.isTypeNode), visitNode(node.attributes, visitor, ts2.isJsxAttributes));
          case 269:
            return ts2.updateJsxClosingElement(node, visitNode(node.tagName, visitor, ts2.isJsxTagNameExpression));
          case 270:
            return ts2.updateJsxFragment(node, visitNode(node.openingFragment, visitor, ts2.isJsxOpeningFragment), nodesVisitor(node.children, visitor, ts2.isJsxChild), visitNode(node.closingFragment, visitor, ts2.isJsxClosingFragment));
          case 273:
            return ts2.updateJsxAttribute(node, visitNode(node.name, visitor, ts2.isIdentifier), visitNode(node.initializer, visitor, ts2.isStringLiteralOrJsxExpression));
          case 274:
            return ts2.updateJsxAttributes(node, nodesVisitor(node.properties, visitor, ts2.isJsxAttributeLike));
          case 275:
            return ts2.updateJsxSpreadAttribute(node, visitNode(node.expression, visitor, ts2.isExpression));
          case 276:
            return ts2.updateJsxExpression(node, visitNode(node.expression, visitor, ts2.isExpression));
          case 277:
            return ts2.updateCaseClause(node, visitNode(node.expression, visitor, ts2.isExpression), nodesVisitor(node.statements, visitor, ts2.isStatement));
          case 278:
            return ts2.updateDefaultClause(node, nodesVisitor(node.statements, visitor, ts2.isStatement));
          case 279:
            return ts2.updateHeritageClause(node, nodesVisitor(node.types, visitor, ts2.isExpressionWithTypeArguments));
          case 280:
            return ts2.updateCatchClause(node, visitNode(node.variableDeclaration, visitor, ts2.isVariableDeclaration), visitNode(node.block, visitor, ts2.isBlock));
          case 281:
            return ts2.updatePropertyAssignment(node, visitNode(node.name, visitor, ts2.isPropertyName), visitNode(node.initializer, visitor, ts2.isExpression));
          case 282:
            return ts2.updateShorthandPropertyAssignment(node, visitNode(node.name, visitor, ts2.isIdentifier), visitNode(node.objectAssignmentInitializer, visitor, ts2.isExpression));
          case 283:
            return ts2.updateSpreadAssignment(node, visitNode(node.expression, visitor, ts2.isExpression));
          case 284:
            return ts2.updateEnumMember(node, visitNode(node.name, visitor, ts2.isPropertyName), visitNode(node.initializer, visitor, ts2.isExpression));
          case 290:
            return ts2.updateSourceFileNode(node, visitLexicalEnvironment(node.statements, visitor, context));
          case 326:
            return ts2.updatePartiallyEmittedExpression(node, visitNode(node.expression, visitor, ts2.isExpression));
          case 327:
            return ts2.updateCommaList(node, nodesVisitor(node.elements, visitor, ts2.isExpression));
          default:
            return node;
        }
      }
      ts2.visitEachChild = visitEachChild;
      function extractSingleNode(nodes) {
        ts2.Debug.assert(nodes.length <= 1, "Too many nodes written to output.");
        return ts2.singleOrUndefined(nodes);
      }
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function reduceNode(node, f, initial) {
        return node ? f(initial, node) : initial;
      }
      function reduceNodeArray(nodes, f, initial) {
        return nodes ? f(initial, nodes) : initial;
      }
      function reduceEachChild(node, initial, cbNode, cbNodeArray) {
        if (node === void 0) {
          return initial;
        }
        var reduceNodes = cbNodeArray ? reduceNodeArray : ts2.reduceLeft;
        var cbNodes = cbNodeArray || cbNode;
        var kind = node.kind;
        if (kind > 0 && kind <= 152) {
          return initial;
        }
        if (kind >= 168 && kind <= 187) {
          return initial;
        }
        var result = initial;
        switch (node.kind) {
          case 222:
          case 224:
          case 215:
          case 241:
          case 325:
            break;
          case 153:
            result = reduceNode(node.left, cbNode, result);
            result = reduceNode(node.right, cbNode, result);
            break;
          case 154:
            result = reduceNode(node.expression, cbNode, result);
            break;
          case 156:
            result = reduceNodes(node.decorators, cbNodes, result);
            result = reduceNodes(node.modifiers, cbNodes, result);
            result = reduceNode(node.name, cbNode, result);
            result = reduceNode(node.type, cbNode, result);
            result = reduceNode(node.initializer, cbNode, result);
            break;
          case 157:
            result = reduceNode(node.expression, cbNode, result);
            break;
          case 158:
            result = reduceNodes(node.modifiers, cbNodes, result);
            result = reduceNode(node.name, cbNode, result);
            result = reduceNode(node.questionToken, cbNode, result);
            result = reduceNode(node.type, cbNode, result);
            result = reduceNode(node.initializer, cbNode, result);
            break;
          case 159:
            result = reduceNodes(node.decorators, cbNodes, result);
            result = reduceNodes(node.modifiers, cbNodes, result);
            result = reduceNode(node.name, cbNode, result);
            result = reduceNode(node.type, cbNode, result);
            result = reduceNode(node.initializer, cbNode, result);
            break;
          case 161:
            result = reduceNodes(node.decorators, cbNodes, result);
            result = reduceNodes(node.modifiers, cbNodes, result);
            result = reduceNode(node.name, cbNode, result);
            result = reduceNodes(node.typeParameters, cbNodes, result);
            result = reduceNodes(node.parameters, cbNodes, result);
            result = reduceNode(node.type, cbNode, result);
            result = reduceNode(node.body, cbNode, result);
            break;
          case 162:
            result = reduceNodes(node.modifiers, cbNodes, result);
            result = reduceNodes(node.parameters, cbNodes, result);
            result = reduceNode(node.body, cbNode, result);
            break;
          case 163:
            result = reduceNodes(node.decorators, cbNodes, result);
            result = reduceNodes(node.modifiers, cbNodes, result);
            result = reduceNode(node.name, cbNode, result);
            result = reduceNodes(node.parameters, cbNodes, result);
            result = reduceNode(node.type, cbNode, result);
            result = reduceNode(node.body, cbNode, result);
            break;
          case 164:
            result = reduceNodes(node.decorators, cbNodes, result);
            result = reduceNodes(node.modifiers, cbNodes, result);
            result = reduceNode(node.name, cbNode, result);
            result = reduceNodes(node.parameters, cbNodes, result);
            result = reduceNode(node.body, cbNode, result);
            break;
          case 189:
          case 190:
            result = reduceNodes(node.elements, cbNodes, result);
            break;
          case 191:
            result = reduceNode(node.propertyName, cbNode, result);
            result = reduceNode(node.name, cbNode, result);
            result = reduceNode(node.initializer, cbNode, result);
            break;
          case 192:
            result = reduceNodes(node.elements, cbNodes, result);
            break;
          case 193:
            result = reduceNodes(node.properties, cbNodes, result);
            break;
          case 194:
            result = reduceNode(node.expression, cbNode, result);
            result = reduceNode(node.name, cbNode, result);
            break;
          case 195:
            result = reduceNode(node.expression, cbNode, result);
            result = reduceNode(node.argumentExpression, cbNode, result);
            break;
          case 196:
            result = reduceNode(node.expression, cbNode, result);
            result = reduceNodes(node.typeArguments, cbNodes, result);
            result = reduceNodes(node.arguments, cbNodes, result);
            break;
          case 197:
            result = reduceNode(node.expression, cbNode, result);
            result = reduceNodes(node.typeArguments, cbNodes, result);
            result = reduceNodes(node.arguments, cbNodes, result);
            break;
          case 198:
            result = reduceNode(node.tag, cbNode, result);
            result = reduceNodes(node.typeArguments, cbNodes, result);
            result = reduceNode(node.template, cbNode, result);
            break;
          case 199:
            result = reduceNode(node.type, cbNode, result);
            result = reduceNode(node.expression, cbNode, result);
            break;
          case 201:
            result = reduceNodes(node.modifiers, cbNodes, result);
            result = reduceNode(node.name, cbNode, result);
            result = reduceNodes(node.typeParameters, cbNodes, result);
            result = reduceNodes(node.parameters, cbNodes, result);
            result = reduceNode(node.type, cbNode, result);
            result = reduceNode(node.body, cbNode, result);
            break;
          case 202:
            result = reduceNodes(node.modifiers, cbNodes, result);
            result = reduceNodes(node.typeParameters, cbNodes, result);
            result = reduceNodes(node.parameters, cbNodes, result);
            result = reduceNode(node.type, cbNode, result);
            result = reduceNode(node.body, cbNode, result);
            break;
          case 200:
          case 203:
          case 204:
          case 205:
          case 206:
          case 212:
          case 213:
          case 218:
            result = reduceNode(node.expression, cbNode, result);
            break;
          case 207:
          case 208:
            result = reduceNode(node.operand, cbNode, result);
            break;
          case 209:
            result = reduceNode(node.left, cbNode, result);
            result = reduceNode(node.right, cbNode, result);
            break;
          case 210:
            result = reduceNode(node.condition, cbNode, result);
            result = reduceNode(node.whenTrue, cbNode, result);
            result = reduceNode(node.whenFalse, cbNode, result);
            break;
          case 211:
            result = reduceNode(node.head, cbNode, result);
            result = reduceNodes(node.templateSpans, cbNodes, result);
            break;
          case 214:
            result = reduceNodes(node.modifiers, cbNodes, result);
            result = reduceNode(node.name, cbNode, result);
            result = reduceNodes(node.typeParameters, cbNodes, result);
            result = reduceNodes(node.heritageClauses, cbNodes, result);
            result = reduceNodes(node.members, cbNodes, result);
            break;
          case 216:
            result = reduceNode(node.expression, cbNode, result);
            result = reduceNodes(node.typeArguments, cbNodes, result);
            break;
          case 217:
            result = reduceNode(node.expression, cbNode, result);
            result = reduceNode(node.type, cbNode, result);
            break;
          case 221:
            result = reduceNode(node.expression, cbNode, result);
            result = reduceNode(node.literal, cbNode, result);
            break;
          case 223:
            result = reduceNodes(node.statements, cbNodes, result);
            break;
          case 225:
            result = reduceNodes(node.modifiers, cbNodes, result);
            result = reduceNode(node.declarationList, cbNode, result);
            break;
          case 226:
            result = reduceNode(node.expression, cbNode, result);
            break;
          case 227:
            result = reduceNode(node.expression, cbNode, result);
            result = reduceNode(node.thenStatement, cbNode, result);
            result = reduceNode(node.elseStatement, cbNode, result);
            break;
          case 228:
            result = reduceNode(node.statement, cbNode, result);
            result = reduceNode(node.expression, cbNode, result);
            break;
          case 229:
          case 236:
            result = reduceNode(node.expression, cbNode, result);
            result = reduceNode(node.statement, cbNode, result);
            break;
          case 230:
            result = reduceNode(node.initializer, cbNode, result);
            result = reduceNode(node.condition, cbNode, result);
            result = reduceNode(node.incrementor, cbNode, result);
            result = reduceNode(node.statement, cbNode, result);
            break;
          case 231:
          case 232:
            result = reduceNode(node.initializer, cbNode, result);
            result = reduceNode(node.expression, cbNode, result);
            result = reduceNode(node.statement, cbNode, result);
            break;
          case 235:
          case 239:
            result = reduceNode(node.expression, cbNode, result);
            break;
          case 237:
            result = reduceNode(node.expression, cbNode, result);
            result = reduceNode(node.caseBlock, cbNode, result);
            break;
          case 238:
            result = reduceNode(node.label, cbNode, result);
            result = reduceNode(node.statement, cbNode, result);
            break;
          case 240:
            result = reduceNode(node.tryBlock, cbNode, result);
            result = reduceNode(node.catchClause, cbNode, result);
            result = reduceNode(node.finallyBlock, cbNode, result);
            break;
          case 242:
            result = reduceNode(node.name, cbNode, result);
            result = reduceNode(node.type, cbNode, result);
            result = reduceNode(node.initializer, cbNode, result);
            break;
          case 243:
            result = reduceNodes(node.declarations, cbNodes, result);
            break;
          case 244:
            result = reduceNodes(node.decorators, cbNodes, result);
            result = reduceNodes(node.modifiers, cbNodes, result);
            result = reduceNode(node.name, cbNode, result);
            result = reduceNodes(node.typeParameters, cbNodes, result);
            result = reduceNodes(node.parameters, cbNodes, result);
            result = reduceNode(node.type, cbNode, result);
            result = reduceNode(node.body, cbNode, result);
            break;
          case 245:
            result = reduceNodes(node.decorators, cbNodes, result);
            result = reduceNodes(node.modifiers, cbNodes, result);
            result = reduceNode(node.name, cbNode, result);
            result = reduceNodes(node.typeParameters, cbNodes, result);
            result = reduceNodes(node.heritageClauses, cbNodes, result);
            result = reduceNodes(node.members, cbNodes, result);
            break;
          case 248:
            result = reduceNodes(node.decorators, cbNodes, result);
            result = reduceNodes(node.modifiers, cbNodes, result);
            result = reduceNode(node.name, cbNode, result);
            result = reduceNodes(node.members, cbNodes, result);
            break;
          case 249:
            result = reduceNodes(node.decorators, cbNodes, result);
            result = reduceNodes(node.modifiers, cbNodes, result);
            result = reduceNode(node.name, cbNode, result);
            result = reduceNode(node.body, cbNode, result);
            break;
          case 250:
            result = reduceNodes(node.statements, cbNodes, result);
            break;
          case 251:
            result = reduceNodes(node.clauses, cbNodes, result);
            break;
          case 253:
            result = reduceNodes(node.decorators, cbNodes, result);
            result = reduceNodes(node.modifiers, cbNodes, result);
            result = reduceNode(node.name, cbNode, result);
            result = reduceNode(node.moduleReference, cbNode, result);
            break;
          case 254:
            result = reduceNodes(node.decorators, cbNodes, result);
            result = reduceNodes(node.modifiers, cbNodes, result);
            result = reduceNode(node.importClause, cbNode, result);
            result = reduceNode(node.moduleSpecifier, cbNode, result);
            break;
          case 255:
            result = reduceNode(node.name, cbNode, result);
            result = reduceNode(node.namedBindings, cbNode, result);
            break;
          case 256:
            result = reduceNode(node.name, cbNode, result);
            break;
          case 262:
            result = reduceNode(node.name, cbNode, result);
            break;
          case 257:
          case 261:
            result = reduceNodes(node.elements, cbNodes, result);
            break;
          case 258:
          case 263:
            result = reduceNode(node.propertyName, cbNode, result);
            result = reduceNode(node.name, cbNode, result);
            break;
          case 259:
            result = ts2.reduceLeft(node.decorators, cbNode, result);
            result = ts2.reduceLeft(node.modifiers, cbNode, result);
            result = reduceNode(node.expression, cbNode, result);
            break;
          case 260:
            result = ts2.reduceLeft(node.decorators, cbNode, result);
            result = ts2.reduceLeft(node.modifiers, cbNode, result);
            result = reduceNode(node.exportClause, cbNode, result);
            result = reduceNode(node.moduleSpecifier, cbNode, result);
            break;
          case 265:
            result = reduceNode(node.expression, cbNode, result);
            break;
          case 266:
            result = reduceNode(node.openingElement, cbNode, result);
            result = ts2.reduceLeft(node.children, cbNode, result);
            result = reduceNode(node.closingElement, cbNode, result);
            break;
          case 270:
            result = reduceNode(node.openingFragment, cbNode, result);
            result = ts2.reduceLeft(node.children, cbNode, result);
            result = reduceNode(node.closingFragment, cbNode, result);
            break;
          case 267:
          case 268:
            result = reduceNode(node.tagName, cbNode, result);
            result = reduceNodes(node.typeArguments, cbNode, result);
            result = reduceNode(node.attributes, cbNode, result);
            break;
          case 274:
            result = reduceNodes(node.properties, cbNodes, result);
            break;
          case 269:
            result = reduceNode(node.tagName, cbNode, result);
            break;
          case 273:
            result = reduceNode(node.name, cbNode, result);
            result = reduceNode(node.initializer, cbNode, result);
            break;
          case 275:
            result = reduceNode(node.expression, cbNode, result);
            break;
          case 276:
            result = reduceNode(node.expression, cbNode, result);
            break;
          case 277:
            result = reduceNode(node.expression, cbNode, result);
          case 278:
            result = reduceNodes(node.statements, cbNodes, result);
            break;
          case 279:
            result = reduceNodes(node.types, cbNodes, result);
            break;
          case 280:
            result = reduceNode(node.variableDeclaration, cbNode, result);
            result = reduceNode(node.block, cbNode, result);
            break;
          case 281:
            result = reduceNode(node.name, cbNode, result);
            result = reduceNode(node.initializer, cbNode, result);
            break;
          case 282:
            result = reduceNode(node.name, cbNode, result);
            result = reduceNode(node.objectAssignmentInitializer, cbNode, result);
            break;
          case 283:
            result = reduceNode(node.expression, cbNode, result);
            break;
          case 284:
            result = reduceNode(node.name, cbNode, result);
            result = reduceNode(node.initializer, cbNode, result);
            break;
          case 290:
            result = reduceNodes(node.statements, cbNodes, result);
            break;
          case 326:
            result = reduceNode(node.expression, cbNode, result);
            break;
          case 327:
            result = reduceNodes(node.elements, cbNodes, result);
            break;
          default:
            break;
        }
        return result;
      }
      ts2.reduceEachChild = reduceEachChild;
      function findSpanEnd(array, test, start) {
        var i = start;
        while (i < array.length && test(array[i])) {
          i++;
        }
        return i;
      }
      function mergeLexicalEnvironment(statements, declarations) {
        if (!ts2.some(declarations)) {
          return statements;
        }
        var leftStandardPrologueEnd = findSpanEnd(statements, ts2.isPrologueDirective, 0);
        var leftHoistedFunctionsEnd = findSpanEnd(statements, ts2.isHoistedFunction, leftStandardPrologueEnd);
        var leftHoistedVariablesEnd = findSpanEnd(statements, ts2.isHoistedVariableStatement, leftHoistedFunctionsEnd);
        var rightStandardPrologueEnd = findSpanEnd(declarations, ts2.isPrologueDirective, 0);
        var rightHoistedFunctionsEnd = findSpanEnd(declarations, ts2.isHoistedFunction, rightStandardPrologueEnd);
        var rightHoistedVariablesEnd = findSpanEnd(declarations, ts2.isHoistedVariableStatement, rightHoistedFunctionsEnd);
        var rightCustomPrologueEnd = findSpanEnd(declarations, ts2.isCustomPrologue, rightHoistedVariablesEnd);
        ts2.Debug.assert(rightCustomPrologueEnd === declarations.length, "Expected declarations to be valid standard or custom prologues");
        var left = ts2.isNodeArray(statements) ? statements.slice() : statements;
        if (rightCustomPrologueEnd > rightHoistedVariablesEnd) {
          left.splice.apply(left, __spreadArrays([leftHoistedVariablesEnd, 0], declarations.slice(rightHoistedVariablesEnd, rightCustomPrologueEnd)));
        }
        if (rightHoistedVariablesEnd > rightHoistedFunctionsEnd) {
          left.splice.apply(left, __spreadArrays([leftHoistedFunctionsEnd, 0], declarations.slice(rightHoistedFunctionsEnd, rightHoistedVariablesEnd)));
        }
        if (rightHoistedFunctionsEnd > rightStandardPrologueEnd) {
          left.splice.apply(left, __spreadArrays([leftStandardPrologueEnd, 0], declarations.slice(rightStandardPrologueEnd, rightHoistedFunctionsEnd)));
        }
        if (rightStandardPrologueEnd > 0) {
          if (leftStandardPrologueEnd === 0) {
            left.splice.apply(left, __spreadArrays([0, 0], declarations.slice(0, rightStandardPrologueEnd)));
          } else {
            var leftPrologues = ts2.createMap();
            for (var i = 0; i < leftStandardPrologueEnd; i++) {
              var leftPrologue = statements[i];
              leftPrologues.set(leftPrologue.expression.text, true);
            }
            for (var i = rightStandardPrologueEnd - 1; i >= 0; i--) {
              var rightPrologue = declarations[i];
              if (!leftPrologues.has(rightPrologue.expression.text)) {
                left.unshift(rightPrologue);
              }
            }
          }
        }
        if (ts2.isNodeArray(statements)) {
          return ts2.setTextRange(ts2.createNodeArray(left, statements.hasTrailingComma), statements);
        }
        return statements;
      }
      ts2.mergeLexicalEnvironment = mergeLexicalEnvironment;
      function liftToBlock(nodes) {
        ts2.Debug.assert(ts2.every(nodes, ts2.isStatement), "Cannot lift nodes to a Block.");
        return ts2.singleOrUndefined(nodes) || ts2.createBlock(nodes);
      }
      ts2.liftToBlock = liftToBlock;
      function aggregateTransformFlags(node) {
        aggregateTransformFlagsForNode(node);
        return node;
      }
      ts2.aggregateTransformFlags = aggregateTransformFlags;
      function aggregateTransformFlagsForNode(node) {
        if (node === void 0) {
          return 0;
        }
        if (node.transformFlags & 536870912) {
          return node.transformFlags & ~ts2.getTransformFlagsSubtreeExclusions(node.kind);
        }
        var subtreeFlags = aggregateTransformFlagsForSubtree(node);
        return ts2.computeTransformFlagsForNode(node, subtreeFlags);
      }
      function aggregateTransformFlagsForNodeArray(nodes) {
        if (nodes === void 0) {
          return 0;
        }
        var subtreeFlags = 0;
        var nodeArrayFlags = 0;
        for (var _i = 0, nodes_3 = nodes; _i < nodes_3.length; _i++) {
          var node = nodes_3[_i];
          subtreeFlags |= aggregateTransformFlagsForNode(node);
          nodeArrayFlags |= node.transformFlags & ~536870912;
        }
        nodes.transformFlags = nodeArrayFlags | 536870912;
        return subtreeFlags;
      }
      function aggregateTransformFlagsForSubtree(node) {
        if (ts2.hasModifier(node, 2) || ts2.isTypeNode(node) && node.kind !== 216) {
          return 0;
        }
        return reduceEachChild(node, 0, aggregateTransformFlagsForChildNode, aggregateTransformFlagsForChildNodes);
      }
      function aggregateTransformFlagsForChildNode(transformFlags, node) {
        return transformFlags | aggregateTransformFlagsForNode(node);
      }
      function aggregateTransformFlagsForChildNodes(transformFlags, nodes) {
        return transformFlags | aggregateTransformFlagsForNodeArray(nodes);
      }
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function createSourceMapGenerator(host, file, sourceRoot, sourcesDirectoryPath, generatorOptions) {
        var _a = generatorOptions.extendedDiagnostics ? ts2.performance.createTimer("Source Map", "beforeSourcemap", "afterSourcemap") : ts2.performance.nullTimer, enter = _a.enter, exit = _a.exit;
        var rawSources = [];
        var sources = [];
        var sourceToSourceIndexMap = ts2.createMap();
        var sourcesContent;
        var names = [];
        var nameToNameIndexMap;
        var mappings = "";
        var lastGeneratedLine = 0;
        var lastGeneratedCharacter = 0;
        var lastSourceIndex = 0;
        var lastSourceLine = 0;
        var lastSourceCharacter = 0;
        var lastNameIndex = 0;
        var hasLast = false;
        var pendingGeneratedLine = 0;
        var pendingGeneratedCharacter = 0;
        var pendingSourceIndex = 0;
        var pendingSourceLine = 0;
        var pendingSourceCharacter = 0;
        var pendingNameIndex = 0;
        var hasPending = false;
        var hasPendingSource = false;
        var hasPendingName = false;
        return {
          getSources: function() {
            return rawSources;
          },
          addSource,
          setSourceContent,
          addName,
          addMapping,
          appendSourceMap,
          toJSON,
          toString: function() {
            return JSON.stringify(toJSON());
          }
        };
        function addSource(fileName) {
          enter();
          var source = ts2.getRelativePathToDirectoryOrUrl(sourcesDirectoryPath, fileName, host.getCurrentDirectory(), host.getCanonicalFileName, true);
          var sourceIndex = sourceToSourceIndexMap.get(source);
          if (sourceIndex === void 0) {
            sourceIndex = sources.length;
            sources.push(source);
            rawSources.push(fileName);
            sourceToSourceIndexMap.set(source, sourceIndex);
          }
          exit();
          return sourceIndex;
        }
        function setSourceContent(sourceIndex, content) {
          enter();
          if (content !== null) {
            if (!sourcesContent)
              sourcesContent = [];
            while (sourcesContent.length < sourceIndex) {
              sourcesContent.push(null);
            }
            sourcesContent[sourceIndex] = content;
          }
          exit();
        }
        function addName(name) {
          enter();
          if (!nameToNameIndexMap)
            nameToNameIndexMap = ts2.createMap();
          var nameIndex = nameToNameIndexMap.get(name);
          if (nameIndex === void 0) {
            nameIndex = names.length;
            names.push(name);
            nameToNameIndexMap.set(name, nameIndex);
          }
          exit();
          return nameIndex;
        }
        function isNewGeneratedPosition(generatedLine, generatedCharacter) {
          return !hasPending || pendingGeneratedLine !== generatedLine || pendingGeneratedCharacter !== generatedCharacter;
        }
        function isBacktrackingSourcePosition(sourceIndex, sourceLine, sourceCharacter) {
          return sourceIndex !== void 0 && sourceLine !== void 0 && sourceCharacter !== void 0 && pendingSourceIndex === sourceIndex && (pendingSourceLine > sourceLine || pendingSourceLine === sourceLine && pendingSourceCharacter > sourceCharacter);
        }
        function addMapping(generatedLine, generatedCharacter, sourceIndex, sourceLine, sourceCharacter, nameIndex) {
          ts2.Debug.assert(generatedLine >= pendingGeneratedLine, "generatedLine cannot backtrack");
          ts2.Debug.assert(generatedCharacter >= 0, "generatedCharacter cannot be negative");
          ts2.Debug.assert(sourceIndex === void 0 || sourceIndex >= 0, "sourceIndex cannot be negative");
          ts2.Debug.assert(sourceLine === void 0 || sourceLine >= 0, "sourceLine cannot be negative");
          ts2.Debug.assert(sourceCharacter === void 0 || sourceCharacter >= 0, "sourceCharacter cannot be negative");
          enter();
          if (isNewGeneratedPosition(generatedLine, generatedCharacter) || isBacktrackingSourcePosition(sourceIndex, sourceLine, sourceCharacter)) {
            commitPendingMapping();
            pendingGeneratedLine = generatedLine;
            pendingGeneratedCharacter = generatedCharacter;
            hasPendingSource = false;
            hasPendingName = false;
            hasPending = true;
          }
          if (sourceIndex !== void 0 && sourceLine !== void 0 && sourceCharacter !== void 0) {
            pendingSourceIndex = sourceIndex;
            pendingSourceLine = sourceLine;
            pendingSourceCharacter = sourceCharacter;
            hasPendingSource = true;
            if (nameIndex !== void 0) {
              pendingNameIndex = nameIndex;
              hasPendingName = true;
            }
          }
          exit();
        }
        function appendSourceMap(generatedLine, generatedCharacter, map, sourceMapPath, start, end) {
          ts2.Debug.assert(generatedLine >= pendingGeneratedLine, "generatedLine cannot backtrack");
          ts2.Debug.assert(generatedCharacter >= 0, "generatedCharacter cannot be negative");
          enter();
          var sourceIndexToNewSourceIndexMap = [];
          var nameIndexToNewNameIndexMap;
          var mappingIterator = decodeMappings(map.mappings);
          for (var iterResult = mappingIterator.next(); !iterResult.done; iterResult = mappingIterator.next()) {
            var raw = iterResult.value;
            if (end && (raw.generatedLine > end.line || raw.generatedLine === end.line && raw.generatedCharacter > end.character)) {
              break;
            }
            if (start && (raw.generatedLine < start.line || start.line === raw.generatedLine && raw.generatedCharacter < start.character)) {
              continue;
            }
            var newSourceIndex = void 0;
            var newSourceLine = void 0;
            var newSourceCharacter = void 0;
            var newNameIndex = void 0;
            if (raw.sourceIndex !== void 0) {
              newSourceIndex = sourceIndexToNewSourceIndexMap[raw.sourceIndex];
              if (newSourceIndex === void 0) {
                var rawPath = map.sources[raw.sourceIndex];
                var relativePath = map.sourceRoot ? ts2.combinePaths(map.sourceRoot, rawPath) : rawPath;
                var combinedPath = ts2.combinePaths(ts2.getDirectoryPath(sourceMapPath), relativePath);
                sourceIndexToNewSourceIndexMap[raw.sourceIndex] = newSourceIndex = addSource(combinedPath);
                if (map.sourcesContent && typeof map.sourcesContent[raw.sourceIndex] === "string") {
                  setSourceContent(newSourceIndex, map.sourcesContent[raw.sourceIndex]);
                }
              }
              newSourceLine = raw.sourceLine;
              newSourceCharacter = raw.sourceCharacter;
              if (map.names && raw.nameIndex !== void 0) {
                if (!nameIndexToNewNameIndexMap)
                  nameIndexToNewNameIndexMap = [];
                newNameIndex = nameIndexToNewNameIndexMap[raw.nameIndex];
                if (newNameIndex === void 0) {
                  nameIndexToNewNameIndexMap[raw.nameIndex] = newNameIndex = addName(map.names[raw.nameIndex]);
                }
              }
            }
            var rawGeneratedLine = raw.generatedLine - (start ? start.line : 0);
            var newGeneratedLine = rawGeneratedLine + generatedLine;
            var rawGeneratedCharacter = start && start.line === raw.generatedLine ? raw.generatedCharacter - start.character : raw.generatedCharacter;
            var newGeneratedCharacter = rawGeneratedLine === 0 ? rawGeneratedCharacter + generatedCharacter : rawGeneratedCharacter;
            addMapping(newGeneratedLine, newGeneratedCharacter, newSourceIndex, newSourceLine, newSourceCharacter, newNameIndex);
          }
          exit();
        }
        function shouldCommitMapping() {
          return !hasLast || lastGeneratedLine !== pendingGeneratedLine || lastGeneratedCharacter !== pendingGeneratedCharacter || lastSourceIndex !== pendingSourceIndex || lastSourceLine !== pendingSourceLine || lastSourceCharacter !== pendingSourceCharacter || lastNameIndex !== pendingNameIndex;
        }
        function commitPendingMapping() {
          if (!hasPending || !shouldCommitMapping()) {
            return;
          }
          enter();
          if (lastGeneratedLine < pendingGeneratedLine) {
            do {
              mappings += ";";
              lastGeneratedLine++;
              lastGeneratedCharacter = 0;
            } while (lastGeneratedLine < pendingGeneratedLine);
          } else {
            ts2.Debug.assertEqual(lastGeneratedLine, pendingGeneratedLine, "generatedLine cannot backtrack");
            if (hasLast) {
              mappings += ",";
            }
          }
          mappings += base64VLQFormatEncode(pendingGeneratedCharacter - lastGeneratedCharacter);
          lastGeneratedCharacter = pendingGeneratedCharacter;
          if (hasPendingSource) {
            mappings += base64VLQFormatEncode(pendingSourceIndex - lastSourceIndex);
            lastSourceIndex = pendingSourceIndex;
            mappings += base64VLQFormatEncode(pendingSourceLine - lastSourceLine);
            lastSourceLine = pendingSourceLine;
            mappings += base64VLQFormatEncode(pendingSourceCharacter - lastSourceCharacter);
            lastSourceCharacter = pendingSourceCharacter;
            if (hasPendingName) {
              mappings += base64VLQFormatEncode(pendingNameIndex - lastNameIndex);
              lastNameIndex = pendingNameIndex;
            }
          }
          hasLast = true;
          exit();
        }
        function toJSON() {
          commitPendingMapping();
          return {
            version: 3,
            file,
            sourceRoot,
            sources,
            names,
            mappings,
            sourcesContent
          };
        }
      }
      ts2.createSourceMapGenerator = createSourceMapGenerator;
      var sourceMapCommentRegExp = /^\/\/[@#] source[M]appingURL=(.+)\s*$/;
      var whitespaceOrMapCommentRegExp = /^\s*(\/\/[@#] .*)?$/;
      function getLineInfo(text, lineStarts) {
        return {
          getLineCount: function() {
            return lineStarts.length;
          },
          getLineText: function(line) {
            return text.substring(lineStarts[line], lineStarts[line + 1]);
          }
        };
      }
      ts2.getLineInfo = getLineInfo;
      function tryGetSourceMappingURL(lineInfo) {
        for (var index = lineInfo.getLineCount() - 1; index >= 0; index--) {
          var line = lineInfo.getLineText(index);
          var comment = sourceMapCommentRegExp.exec(line);
          if (comment) {
            return comment[1];
          } else if (!line.match(whitespaceOrMapCommentRegExp)) {
            break;
          }
        }
      }
      ts2.tryGetSourceMappingURL = tryGetSourceMappingURL;
      function isStringOrNull(x) {
        return typeof x === "string" || x === null;
      }
      function isRawSourceMap(x) {
        return x !== null && typeof x === "object" && x.version === 3 && typeof x.file === "string" && typeof x.mappings === "string" && ts2.isArray(x.sources) && ts2.every(x.sources, ts2.isString) && (x.sourceRoot === void 0 || x.sourceRoot === null || typeof x.sourceRoot === "string") && (x.sourcesContent === void 0 || x.sourcesContent === null || ts2.isArray(x.sourcesContent) && ts2.every(x.sourcesContent, isStringOrNull)) && (x.names === void 0 || x.names === null || ts2.isArray(x.names) && ts2.every(x.names, ts2.isString));
      }
      ts2.isRawSourceMap = isRawSourceMap;
      function tryParseRawSourceMap(text) {
        try {
          var parsed = JSON.parse(text);
          if (isRawSourceMap(parsed)) {
            return parsed;
          }
        } catch (_a) {
        }
        return void 0;
      }
      ts2.tryParseRawSourceMap = tryParseRawSourceMap;
      function decodeMappings(mappings) {
        var done = false;
        var pos = 0;
        var generatedLine = 0;
        var generatedCharacter = 0;
        var sourceIndex = 0;
        var sourceLine = 0;
        var sourceCharacter = 0;
        var nameIndex = 0;
        var error;
        return {
          get pos() {
            return pos;
          },
          get error() {
            return error;
          },
          get state() {
            return captureMapping(true, true);
          },
          next: function() {
            while (!done && pos < mappings.length) {
              var ch = mappings.charCodeAt(pos);
              if (ch === 59) {
                generatedLine++;
                generatedCharacter = 0;
                pos++;
                continue;
              }
              if (ch === 44) {
                pos++;
                continue;
              }
              var hasSource = false;
              var hasName = false;
              generatedCharacter += base64VLQFormatDecode();
              if (hasReportedError())
                return stopIterating();
              if (generatedCharacter < 0)
                return setErrorAndStopIterating("Invalid generatedCharacter found");
              if (!isSourceMappingSegmentEnd()) {
                hasSource = true;
                sourceIndex += base64VLQFormatDecode();
                if (hasReportedError())
                  return stopIterating();
                if (sourceIndex < 0)
                  return setErrorAndStopIterating("Invalid sourceIndex found");
                if (isSourceMappingSegmentEnd())
                  return setErrorAndStopIterating("Unsupported Format: No entries after sourceIndex");
                sourceLine += base64VLQFormatDecode();
                if (hasReportedError())
                  return stopIterating();
                if (sourceLine < 0)
                  return setErrorAndStopIterating("Invalid sourceLine found");
                if (isSourceMappingSegmentEnd())
                  return setErrorAndStopIterating("Unsupported Format: No entries after sourceLine");
                sourceCharacter += base64VLQFormatDecode();
                if (hasReportedError())
                  return stopIterating();
                if (sourceCharacter < 0)
                  return setErrorAndStopIterating("Invalid sourceCharacter found");
                if (!isSourceMappingSegmentEnd()) {
                  hasName = true;
                  nameIndex += base64VLQFormatDecode();
                  if (hasReportedError())
                    return stopIterating();
                  if (nameIndex < 0)
                    return setErrorAndStopIterating("Invalid nameIndex found");
                  if (!isSourceMappingSegmentEnd())
                    return setErrorAndStopIterating("Unsupported Error Format: Entries after nameIndex");
                }
              }
              return { value: captureMapping(hasSource, hasName), done };
            }
            return stopIterating();
          }
        };
        function captureMapping(hasSource, hasName) {
          return {
            generatedLine,
            generatedCharacter,
            sourceIndex: hasSource ? sourceIndex : void 0,
            sourceLine: hasSource ? sourceLine : void 0,
            sourceCharacter: hasSource ? sourceCharacter : void 0,
            nameIndex: hasName ? nameIndex : void 0
          };
        }
        function stopIterating() {
          done = true;
          return { value: void 0, done: true };
        }
        function setError(message) {
          if (error === void 0) {
            error = message;
          }
        }
        function setErrorAndStopIterating(message) {
          setError(message);
          return stopIterating();
        }
        function hasReportedError() {
          return error !== void 0;
        }
        function isSourceMappingSegmentEnd() {
          return pos === mappings.length || mappings.charCodeAt(pos) === 44 || mappings.charCodeAt(pos) === 59;
        }
        function base64VLQFormatDecode() {
          var moreDigits = true;
          var shiftCount = 0;
          var value = 0;
          for (; moreDigits; pos++) {
            if (pos >= mappings.length)
              return setError("Error in decoding base64VLQFormatDecode, past the mapping string"), -1;
            var currentByte = base64FormatDecode(mappings.charCodeAt(pos));
            if (currentByte === -1)
              return setError("Invalid character in VLQ"), -1;
            moreDigits = (currentByte & 32) !== 0;
            value = value | (currentByte & 31) << shiftCount;
            shiftCount += 5;
          }
          if ((value & 1) === 0) {
            value = value >> 1;
          } else {
            value = value >> 1;
            value = -value;
          }
          return value;
        }
      }
      ts2.decodeMappings = decodeMappings;
      function sameMapping(left, right) {
        return left === right || left.generatedLine === right.generatedLine && left.generatedCharacter === right.generatedCharacter && left.sourceIndex === right.sourceIndex && left.sourceLine === right.sourceLine && left.sourceCharacter === right.sourceCharacter && left.nameIndex === right.nameIndex;
      }
      ts2.sameMapping = sameMapping;
      function isSourceMapping(mapping) {
        return mapping.sourceIndex !== void 0 && mapping.sourceLine !== void 0 && mapping.sourceCharacter !== void 0;
      }
      ts2.isSourceMapping = isSourceMapping;
      function base64FormatEncode(value) {
        return value >= 0 && value < 26 ? 65 + value : value >= 26 && value < 52 ? 97 + value - 26 : value >= 52 && value < 62 ? 48 + value - 52 : value === 62 ? 43 : value === 63 ? 47 : ts2.Debug.fail(value + ": not a base64 value");
      }
      function base64FormatDecode(ch) {
        return ch >= 65 && ch <= 90 ? ch - 65 : ch >= 97 && ch <= 122 ? ch - 97 + 26 : ch >= 48 && ch <= 57 ? ch - 48 + 52 : ch === 43 ? 62 : ch === 47 ? 63 : -1;
      }
      function base64VLQFormatEncode(inValue) {
        if (inValue < 0) {
          inValue = (-inValue << 1) + 1;
        } else {
          inValue = inValue << 1;
        }
        var encodedStr = "";
        do {
          var currentDigit = inValue & 31;
          inValue = inValue >> 5;
          if (inValue > 0) {
            currentDigit = currentDigit | 32;
          }
          encodedStr = encodedStr + String.fromCharCode(base64FormatEncode(currentDigit));
        } while (inValue > 0);
        return encodedStr;
      }
      function isSourceMappedPosition(value) {
        return value.sourceIndex !== void 0 && value.sourcePosition !== void 0;
      }
      function sameMappedPosition(left, right) {
        return left.generatedPosition === right.generatedPosition && left.sourceIndex === right.sourceIndex && left.sourcePosition === right.sourcePosition;
      }
      function compareSourcePositions(left, right) {
        ts2.Debug.assert(left.sourceIndex === right.sourceIndex);
        return ts2.compareValues(left.sourcePosition, right.sourcePosition);
      }
      function compareGeneratedPositions(left, right) {
        return ts2.compareValues(left.generatedPosition, right.generatedPosition);
      }
      function getSourcePositionOfMapping(value) {
        return value.sourcePosition;
      }
      function getGeneratedPositionOfMapping(value) {
        return value.generatedPosition;
      }
      function createDocumentPositionMapper(host, map, mapPath) {
        var mapDirectory = ts2.getDirectoryPath(mapPath);
        var sourceRoot = map.sourceRoot ? ts2.getNormalizedAbsolutePath(map.sourceRoot, mapDirectory) : mapDirectory;
        var generatedAbsoluteFilePath = ts2.getNormalizedAbsolutePath(map.file, mapDirectory);
        var generatedFile = host.getSourceFileLike(generatedAbsoluteFilePath);
        var sourceFileAbsolutePaths = map.sources.map(function(source) {
          return ts2.getNormalizedAbsolutePath(source, sourceRoot);
        });
        var sourceToSourceIndexMap = ts2.createMapFromEntries(sourceFileAbsolutePaths.map(function(source, i) {
          return [host.getCanonicalFileName(source), i];
        }));
        var decodedMappings;
        var generatedMappings;
        var sourceMappings;
        return {
          getSourcePosition,
          getGeneratedPosition
        };
        function processMapping(mapping) {
          var generatedPosition = generatedFile !== void 0 ? ts2.getPositionOfLineAndCharacter(generatedFile, mapping.generatedLine, mapping.generatedCharacter, true) : -1;
          var source;
          var sourcePosition;
          if (isSourceMapping(mapping)) {
            var sourceFile = host.getSourceFileLike(sourceFileAbsolutePaths[mapping.sourceIndex]);
            source = map.sources[mapping.sourceIndex];
            sourcePosition = sourceFile !== void 0 ? ts2.getPositionOfLineAndCharacter(sourceFile, mapping.sourceLine, mapping.sourceCharacter, true) : -1;
          }
          return {
            generatedPosition,
            source,
            sourceIndex: mapping.sourceIndex,
            sourcePosition,
            nameIndex: mapping.nameIndex
          };
        }
        function getDecodedMappings() {
          if (decodedMappings === void 0) {
            var decoder = decodeMappings(map.mappings);
            var mappings = ts2.arrayFrom(decoder, processMapping);
            if (decoder.error !== void 0) {
              if (host.log) {
                host.log("Encountered error while decoding sourcemap: " + decoder.error);
              }
              decodedMappings = ts2.emptyArray;
            } else {
              decodedMappings = mappings;
            }
          }
          return decodedMappings;
        }
        function getSourceMappings(sourceIndex) {
          if (sourceMappings === void 0) {
            var lists = [];
            for (var _i = 0, _a = getDecodedMappings(); _i < _a.length; _i++) {
              var mapping = _a[_i];
              if (!isSourceMappedPosition(mapping))
                continue;
              var list = lists[mapping.sourceIndex];
              if (!list)
                lists[mapping.sourceIndex] = list = [];
              list.push(mapping);
            }
            sourceMappings = lists.map(function(list2) {
              return ts2.sortAndDeduplicate(list2, compareSourcePositions, sameMappedPosition);
            });
          }
          return sourceMappings[sourceIndex];
        }
        function getGeneratedMappings() {
          if (generatedMappings === void 0) {
            var list = [];
            for (var _i = 0, _a = getDecodedMappings(); _i < _a.length; _i++) {
              var mapping = _a[_i];
              list.push(mapping);
            }
            generatedMappings = ts2.sortAndDeduplicate(list, compareGeneratedPositions, sameMappedPosition);
          }
          return generatedMappings;
        }
        function getGeneratedPosition(loc) {
          var sourceIndex = sourceToSourceIndexMap.get(host.getCanonicalFileName(loc.fileName));
          if (sourceIndex === void 0)
            return loc;
          var sourceMappings2 = getSourceMappings(sourceIndex);
          if (!ts2.some(sourceMappings2))
            return loc;
          var targetIndex = ts2.binarySearchKey(sourceMappings2, loc.pos, getSourcePositionOfMapping, ts2.compareValues);
          if (targetIndex < 0) {
            targetIndex = ~targetIndex;
          }
          var mapping = sourceMappings2[targetIndex];
          if (mapping === void 0 || mapping.sourceIndex !== sourceIndex) {
            return loc;
          }
          return { fileName: generatedAbsoluteFilePath, pos: mapping.generatedPosition };
        }
        function getSourcePosition(loc) {
          var generatedMappings2 = getGeneratedMappings();
          if (!ts2.some(generatedMappings2))
            return loc;
          var targetIndex = ts2.binarySearchKey(generatedMappings2, loc.pos, getGeneratedPositionOfMapping, ts2.compareValues);
          if (targetIndex < 0) {
            targetIndex = ~targetIndex;
          }
          var mapping = generatedMappings2[targetIndex];
          if (mapping === void 0 || !isSourceMappedPosition(mapping)) {
            return loc;
          }
          return { fileName: sourceFileAbsolutePaths[mapping.sourceIndex], pos: mapping.sourcePosition };
        }
      }
      ts2.createDocumentPositionMapper = createDocumentPositionMapper;
      ts2.identitySourceMapConsumer = {
        getSourcePosition: ts2.identity,
        getGeneratedPosition: ts2.identity
      };
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function getOriginalNodeId(node) {
        node = ts2.getOriginalNode(node);
        return node ? ts2.getNodeId(node) : 0;
      }
      ts2.getOriginalNodeId = getOriginalNodeId;
      function containsDefaultReference(node) {
        if (!node)
          return false;
        if (!ts2.isNamedImports(node))
          return false;
        return ts2.some(node.elements, isNamedDefaultReference);
      }
      function isNamedDefaultReference(e) {
        return e.propertyName !== void 0 && e.propertyName.escapedText === "default";
      }
      function chainBundle(transformSourceFile) {
        return transformSourceFileOrBundle;
        function transformSourceFileOrBundle(node) {
          return node.kind === 290 ? transformSourceFile(node) : transformBundle(node);
        }
        function transformBundle(node) {
          return ts2.createBundle(ts2.map(node.sourceFiles, transformSourceFile), node.prepends);
        }
      }
      ts2.chainBundle = chainBundle;
      function getExportNeedsImportStarHelper(node) {
        return !!ts2.getNamespaceDeclarationNode(node);
      }
      ts2.getExportNeedsImportStarHelper = getExportNeedsImportStarHelper;
      function getImportNeedsImportStarHelper(node) {
        if (!!ts2.getNamespaceDeclarationNode(node)) {
          return true;
        }
        var bindings = node.importClause && node.importClause.namedBindings;
        if (!bindings) {
          return false;
        }
        if (!ts2.isNamedImports(bindings))
          return false;
        var defaultRefCount = 0;
        for (var _i = 0, _a = bindings.elements; _i < _a.length; _i++) {
          var binding = _a[_i];
          if (isNamedDefaultReference(binding)) {
            defaultRefCount++;
          }
        }
        return defaultRefCount > 0 && defaultRefCount !== bindings.elements.length || !!(bindings.elements.length - defaultRefCount) && ts2.isDefaultImport(node);
      }
      ts2.getImportNeedsImportStarHelper = getImportNeedsImportStarHelper;
      function getImportNeedsImportDefaultHelper(node) {
        return !getImportNeedsImportStarHelper(node) && (ts2.isDefaultImport(node) || !!node.importClause && ts2.isNamedImports(node.importClause.namedBindings) && containsDefaultReference(node.importClause.namedBindings));
      }
      ts2.getImportNeedsImportDefaultHelper = getImportNeedsImportDefaultHelper;
      function collectExternalModuleInfo(sourceFile, resolver, compilerOptions) {
        var externalImports = [];
        var exportSpecifiers = ts2.createMultiMap();
        var exportedBindings = [];
        var uniqueExports = ts2.createMap();
        var exportedNames;
        var hasExportDefault = false;
        var exportEquals;
        var hasExportStarsToExportValues = false;
        var hasImportStar = false;
        var hasImportDefault = false;
        for (var _i = 0, _a = sourceFile.statements; _i < _a.length; _i++) {
          var node = _a[_i];
          switch (node.kind) {
            case 254:
              externalImports.push(node);
              if (!hasImportStar && getImportNeedsImportStarHelper(node)) {
                hasImportStar = true;
              }
              if (!hasImportDefault && getImportNeedsImportDefaultHelper(node)) {
                hasImportDefault = true;
              }
              break;
            case 253:
              if (node.moduleReference.kind === 265) {
                externalImports.push(node);
              }
              break;
            case 260:
              if (node.moduleSpecifier) {
                if (!node.exportClause) {
                  externalImports.push(node);
                  hasExportStarsToExportValues = true;
                } else {
                  externalImports.push(node);
                }
              } else {
                for (var _b = 0, _c = ts2.cast(node.exportClause, ts2.isNamedExports).elements; _b < _c.length; _b++) {
                  var specifier = _c[_b];
                  if (!uniqueExports.get(ts2.idText(specifier.name))) {
                    var name = specifier.propertyName || specifier.name;
                    exportSpecifiers.add(ts2.idText(name), specifier);
                    var decl = resolver.getReferencedImportDeclaration(name) || resolver.getReferencedValueDeclaration(name);
                    if (decl) {
                      multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(decl), specifier.name);
                    }
                    uniqueExports.set(ts2.idText(specifier.name), true);
                    exportedNames = ts2.append(exportedNames, specifier.name);
                  }
                }
              }
              break;
            case 259:
              if (node.isExportEquals && !exportEquals) {
                exportEquals = node;
              }
              break;
            case 225:
              if (ts2.hasModifier(node, 1)) {
                for (var _d = 0, _e = node.declarationList.declarations; _d < _e.length; _d++) {
                  var decl = _e[_d];
                  exportedNames = collectExportedVariableInfo(decl, uniqueExports, exportedNames);
                }
              }
              break;
            case 244:
              if (ts2.hasModifier(node, 1)) {
                if (ts2.hasModifier(node, 512)) {
                  if (!hasExportDefault) {
                    multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(node), ts2.getDeclarationName(node));
                    hasExportDefault = true;
                  }
                } else {
                  var name = node.name;
                  if (!uniqueExports.get(ts2.idText(name))) {
                    multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(node), name);
                    uniqueExports.set(ts2.idText(name), true);
                    exportedNames = ts2.append(exportedNames, name);
                  }
                }
              }
              break;
            case 245:
              if (ts2.hasModifier(node, 1)) {
                if (ts2.hasModifier(node, 512)) {
                  if (!hasExportDefault) {
                    multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(node), ts2.getDeclarationName(node));
                    hasExportDefault = true;
                  }
                } else {
                  var name = node.name;
                  if (name && !uniqueExports.get(ts2.idText(name))) {
                    multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(node), name);
                    uniqueExports.set(ts2.idText(name), true);
                    exportedNames = ts2.append(exportedNames, name);
                  }
                }
              }
              break;
          }
        }
        var externalHelpersImportDeclaration = ts2.createExternalHelpersImportDeclarationIfNeeded(sourceFile, compilerOptions, hasExportStarsToExportValues, hasImportStar, hasImportDefault);
        if (externalHelpersImportDeclaration) {
          externalImports.unshift(externalHelpersImportDeclaration);
        }
        return { externalImports, exportSpecifiers, exportEquals, hasExportStarsToExportValues, exportedBindings, exportedNames, externalHelpersImportDeclaration };
      }
      ts2.collectExternalModuleInfo = collectExternalModuleInfo;
      function collectExportedVariableInfo(decl, uniqueExports, exportedNames) {
        if (ts2.isBindingPattern(decl.name)) {
          for (var _i = 0, _a = decl.name.elements; _i < _a.length; _i++) {
            var element = _a[_i];
            if (!ts2.isOmittedExpression(element)) {
              exportedNames = collectExportedVariableInfo(element, uniqueExports, exportedNames);
            }
          }
        } else if (!ts2.isGeneratedIdentifier(decl.name)) {
          var text = ts2.idText(decl.name);
          if (!uniqueExports.get(text)) {
            uniqueExports.set(text, true);
            exportedNames = ts2.append(exportedNames, decl.name);
          }
        }
        return exportedNames;
      }
      function multiMapSparseArrayAdd(map, key, value) {
        var values = map[key];
        if (values) {
          values.push(value);
        } else {
          map[key] = values = [value];
        }
        return values;
      }
      function isSimpleCopiableExpression(expression) {
        return ts2.isStringLiteralLike(expression) || expression.kind === 8 || ts2.isKeyword(expression.kind) || ts2.isIdentifier(expression);
      }
      ts2.isSimpleCopiableExpression = isSimpleCopiableExpression;
      function isSimpleInlineableExpression(expression) {
        return !ts2.isIdentifier(expression) && isSimpleCopiableExpression(expression) || ts2.isWellKnownSymbolSyntactically(expression);
      }
      ts2.isSimpleInlineableExpression = isSimpleInlineableExpression;
      function isCompoundAssignment(kind) {
        return kind >= 63 && kind <= 74;
      }
      ts2.isCompoundAssignment = isCompoundAssignment;
      function getNonAssignmentOperatorForCompoundAssignment(kind) {
        switch (kind) {
          case 63:
            return 39;
          case 64:
            return 40;
          case 65:
            return 41;
          case 66:
            return 42;
          case 67:
            return 43;
          case 68:
            return 44;
          case 69:
            return 47;
          case 70:
            return 48;
          case 71:
            return 49;
          case 72:
            return 50;
          case 73:
            return 51;
          case 74:
            return 52;
        }
      }
      ts2.getNonAssignmentOperatorForCompoundAssignment = getNonAssignmentOperatorForCompoundAssignment;
      function addPrologueDirectivesAndInitialSuperCall(ctor, result, visitor) {
        if (ctor.body) {
          var statements = ctor.body.statements;
          var index = ts2.addPrologue(result, statements, false, visitor);
          if (index === statements.length) {
            return index;
          }
          var superIndex = ts2.findIndex(statements, function(s) {
            return ts2.isExpressionStatement(s) && ts2.isSuperCall(s.expression);
          }, index);
          if (superIndex > -1) {
            for (var i = index; i <= superIndex; i++) {
              result.push(ts2.visitNode(statements[i], visitor, ts2.isStatement));
            }
            return superIndex + 1;
          }
          return index;
        }
        return 0;
      }
      ts2.addPrologueDirectivesAndInitialSuperCall = addPrologueDirectivesAndInitialSuperCall;
      function helperString(input) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
          args[_i - 1] = arguments[_i];
        }
        return function(uniqueName) {
          var result = "";
          for (var i = 0; i < args.length; i++) {
            result += input[i];
            result += uniqueName(args[i]);
          }
          result += input[input.length - 1];
          return result;
        };
      }
      ts2.helperString = helperString;
      function getProperties(node, requireInitializer, isStatic) {
        return ts2.filter(node.members, function(m) {
          return isInitializedOrStaticProperty(m, requireInitializer, isStatic);
        });
      }
      ts2.getProperties = getProperties;
      function isInitializedOrStaticProperty(member, requireInitializer, isStatic) {
        return ts2.isPropertyDeclaration(member) && (!!member.initializer || !requireInitializer) && ts2.hasStaticModifier(member) === isStatic;
      }
      function isInitializedProperty(member) {
        return member.kind === 159 && member.initializer !== void 0;
      }
      ts2.isInitializedProperty = isInitializedProperty;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var FlattenLevel;
      (function(FlattenLevel2) {
        FlattenLevel2[FlattenLevel2["All"] = 0] = "All";
        FlattenLevel2[FlattenLevel2["ObjectRest"] = 1] = "ObjectRest";
      })(FlattenLevel = ts2.FlattenLevel || (ts2.FlattenLevel = {}));
      function flattenDestructuringAssignment(node, visitor, context, level, needsValue, createAssignmentCallback) {
        var location = node;
        var value;
        if (ts2.isDestructuringAssignment(node)) {
          value = node.right;
          while (ts2.isEmptyArrayLiteral(node.left) || ts2.isEmptyObjectLiteral(node.left)) {
            if (ts2.isDestructuringAssignment(value)) {
              location = node = value;
              value = node.right;
            } else {
              return ts2.visitNode(value, visitor, ts2.isExpression);
            }
          }
        }
        var expressions;
        var flattenContext = {
          context,
          level,
          downlevelIteration: !!context.getCompilerOptions().downlevelIteration,
          hoistTempVariables: true,
          emitExpression,
          emitBindingOrAssignment,
          createArrayBindingOrAssignmentPattern: makeArrayAssignmentPattern,
          createObjectBindingOrAssignmentPattern: makeObjectAssignmentPattern,
          createArrayBindingOrAssignmentElement: makeAssignmentElement,
          visitor
        };
        if (value) {
          value = ts2.visitNode(value, visitor, ts2.isExpression);
          if (ts2.isIdentifier(value) && bindingOrAssignmentElementAssignsToName(node, value.escapedText) || bindingOrAssignmentElementContainsNonLiteralComputedName(node)) {
            value = ensureIdentifier(flattenContext, value, false, location);
          } else if (needsValue) {
            value = ensureIdentifier(flattenContext, value, true, location);
          } else if (ts2.nodeIsSynthesized(node)) {
            location = value;
          }
        }
        flattenBindingOrAssignmentElement(flattenContext, node, value, location, ts2.isDestructuringAssignment(node));
        if (value && needsValue) {
          if (!ts2.some(expressions)) {
            return value;
          }
          expressions.push(value);
        }
        return ts2.aggregateTransformFlags(ts2.inlineExpressions(expressions)) || ts2.createOmittedExpression();
        function emitExpression(expression) {
          ts2.aggregateTransformFlags(expression);
          expressions = ts2.append(expressions, expression);
        }
        function emitBindingOrAssignment(target, value2, location2, original) {
          ts2.Debug.assertNode(target, createAssignmentCallback ? ts2.isIdentifier : ts2.isExpression);
          var expression = createAssignmentCallback ? createAssignmentCallback(target, value2, location2) : ts2.setTextRange(ts2.createAssignment(ts2.visitNode(target, visitor, ts2.isExpression), value2), location2);
          expression.original = original;
          emitExpression(expression);
        }
      }
      ts2.flattenDestructuringAssignment = flattenDestructuringAssignment;
      function bindingOrAssignmentElementAssignsToName(element, escapedName) {
        var target = ts2.getTargetOfBindingOrAssignmentElement(element);
        if (ts2.isBindingOrAssignmentPattern(target)) {
          return bindingOrAssignmentPatternAssignsToName(target, escapedName);
        } else if (ts2.isIdentifier(target)) {
          return target.escapedText === escapedName;
        }
        return false;
      }
      function bindingOrAssignmentPatternAssignsToName(pattern, escapedName) {
        var elements = ts2.getElementsOfBindingOrAssignmentPattern(pattern);
        for (var _i = 0, elements_3 = elements; _i < elements_3.length; _i++) {
          var element = elements_3[_i];
          if (bindingOrAssignmentElementAssignsToName(element, escapedName)) {
            return true;
          }
        }
        return false;
      }
      function bindingOrAssignmentElementContainsNonLiteralComputedName(element) {
        var propertyName = ts2.tryGetPropertyNameOfBindingOrAssignmentElement(element);
        if (propertyName && ts2.isComputedPropertyName(propertyName) && !ts2.isLiteralExpression(propertyName.expression)) {
          return true;
        }
        var target = ts2.getTargetOfBindingOrAssignmentElement(element);
        return !!target && ts2.isBindingOrAssignmentPattern(target) && bindingOrAssignmentPatternContainsNonLiteralComputedName(target);
      }
      function bindingOrAssignmentPatternContainsNonLiteralComputedName(pattern) {
        return !!ts2.forEach(ts2.getElementsOfBindingOrAssignmentPattern(pattern), bindingOrAssignmentElementContainsNonLiteralComputedName);
      }
      function flattenDestructuringBinding(node, visitor, context, level, rval, hoistTempVariables, skipInitializer) {
        if (hoistTempVariables === void 0) {
          hoistTempVariables = false;
        }
        var pendingExpressions;
        var pendingDeclarations = [];
        var declarations = [];
        var flattenContext = {
          context,
          level,
          downlevelIteration: !!context.getCompilerOptions().downlevelIteration,
          hoistTempVariables,
          emitExpression,
          emitBindingOrAssignment,
          createArrayBindingOrAssignmentPattern: makeArrayBindingPattern,
          createObjectBindingOrAssignmentPattern: makeObjectBindingPattern,
          createArrayBindingOrAssignmentElement: makeBindingElement,
          visitor
        };
        if (ts2.isVariableDeclaration(node)) {
          var initializer = ts2.getInitializerOfBindingOrAssignmentElement(node);
          if (initializer && (ts2.isIdentifier(initializer) && bindingOrAssignmentElementAssignsToName(node, initializer.escapedText) || bindingOrAssignmentElementContainsNonLiteralComputedName(node))) {
            initializer = ensureIdentifier(flattenContext, initializer, false, initializer);
            node = ts2.updateVariableDeclaration(node, node.name, node.type, initializer);
          }
        }
        flattenBindingOrAssignmentElement(flattenContext, node, rval, node, skipInitializer);
        if (pendingExpressions) {
          var temp = ts2.createTempVariable(void 0);
          if (hoistTempVariables) {
            var value = ts2.inlineExpressions(pendingExpressions);
            pendingExpressions = void 0;
            emitBindingOrAssignment(temp, value, void 0, void 0);
          } else {
            context.hoistVariableDeclaration(temp);
            var pendingDeclaration = ts2.last(pendingDeclarations);
            pendingDeclaration.pendingExpressions = ts2.append(pendingDeclaration.pendingExpressions, ts2.createAssignment(temp, pendingDeclaration.value));
            ts2.addRange(pendingDeclaration.pendingExpressions, pendingExpressions);
            pendingDeclaration.value = temp;
          }
        }
        for (var _i = 0, pendingDeclarations_1 = pendingDeclarations; _i < pendingDeclarations_1.length; _i++) {
          var _a = pendingDeclarations_1[_i], pendingExpressions_1 = _a.pendingExpressions, name = _a.name, value = _a.value, location = _a.location, original = _a.original;
          var variable = ts2.createVariableDeclaration(name, void 0, pendingExpressions_1 ? ts2.inlineExpressions(ts2.append(pendingExpressions_1, value)) : value);
          variable.original = original;
          ts2.setTextRange(variable, location);
          ts2.aggregateTransformFlags(variable);
          declarations.push(variable);
        }
        return declarations;
        function emitExpression(value2) {
          pendingExpressions = ts2.append(pendingExpressions, value2);
        }
        function emitBindingOrAssignment(target, value2, location2, original2) {
          ts2.Debug.assertNode(target, ts2.isBindingName);
          if (pendingExpressions) {
            value2 = ts2.inlineExpressions(ts2.append(pendingExpressions, value2));
            pendingExpressions = void 0;
          }
          pendingDeclarations.push({ pendingExpressions, name: target, value: value2, location: location2, original: original2 });
        }
      }
      ts2.flattenDestructuringBinding = flattenDestructuringBinding;
      function flattenBindingOrAssignmentElement(flattenContext, element, value, location, skipInitializer) {
        if (!skipInitializer) {
          var initializer = ts2.visitNode(ts2.getInitializerOfBindingOrAssignmentElement(element), flattenContext.visitor, ts2.isExpression);
          if (initializer) {
            value = value ? createDefaultValueCheck(flattenContext, value, initializer, location) : initializer;
          } else if (!value) {
            value = ts2.createVoidZero();
          }
        }
        var bindingTarget = ts2.getTargetOfBindingOrAssignmentElement(element);
        if (ts2.isObjectBindingOrAssignmentPattern(bindingTarget)) {
          flattenObjectBindingOrAssignmentPattern(flattenContext, element, bindingTarget, value, location);
        } else if (ts2.isArrayBindingOrAssignmentPattern(bindingTarget)) {
          flattenArrayBindingOrAssignmentPattern(flattenContext, element, bindingTarget, value, location);
        } else {
          flattenContext.emitBindingOrAssignment(bindingTarget, value, location, element);
        }
      }
      function flattenObjectBindingOrAssignmentPattern(flattenContext, parent, pattern, value, location) {
        var elements = ts2.getElementsOfBindingOrAssignmentPattern(pattern);
        var numElements = elements.length;
        if (numElements !== 1) {
          var reuseIdentifierExpressions = !ts2.isDeclarationBindingElement(parent) || numElements !== 0;
          value = ensureIdentifier(flattenContext, value, reuseIdentifierExpressions, location);
        }
        var bindingElements;
        var computedTempVariables;
        for (var i = 0; i < numElements; i++) {
          var element = elements[i];
          if (!ts2.getRestIndicatorOfBindingOrAssignmentElement(element)) {
            var propertyName = ts2.getPropertyNameOfBindingOrAssignmentElement(element);
            if (flattenContext.level >= 1 && !(element.transformFlags & (8192 | 16384)) && !(ts2.getTargetOfBindingOrAssignmentElement(element).transformFlags & (8192 | 16384)) && !ts2.isComputedPropertyName(propertyName)) {
              bindingElements = ts2.append(bindingElements, ts2.visitNode(element, flattenContext.visitor));
            } else {
              if (bindingElements) {
                flattenContext.emitBindingOrAssignment(flattenContext.createObjectBindingOrAssignmentPattern(bindingElements), value, location, pattern);
                bindingElements = void 0;
              }
              var rhsValue = createDestructuringPropertyAccess(flattenContext, value, propertyName);
              if (ts2.isComputedPropertyName(propertyName)) {
                computedTempVariables = ts2.append(computedTempVariables, rhsValue.argumentExpression);
              }
              flattenBindingOrAssignmentElement(flattenContext, element, rhsValue, element);
            }
          } else if (i === numElements - 1) {
            if (bindingElements) {
              flattenContext.emitBindingOrAssignment(flattenContext.createObjectBindingOrAssignmentPattern(bindingElements), value, location, pattern);
              bindingElements = void 0;
            }
            var rhsValue = createRestCall(flattenContext.context, value, elements, computedTempVariables, pattern);
            flattenBindingOrAssignmentElement(flattenContext, element, rhsValue, element);
          }
        }
        if (bindingElements) {
          flattenContext.emitBindingOrAssignment(flattenContext.createObjectBindingOrAssignmentPattern(bindingElements), value, location, pattern);
        }
      }
      function flattenArrayBindingOrAssignmentPattern(flattenContext, parent, pattern, value, location) {
        var elements = ts2.getElementsOfBindingOrAssignmentPattern(pattern);
        var numElements = elements.length;
        if (flattenContext.level < 1 && flattenContext.downlevelIteration) {
          value = ensureIdentifier(flattenContext, ts2.createReadHelper(flattenContext.context, value, numElements > 0 && ts2.getRestIndicatorOfBindingOrAssignmentElement(elements[numElements - 1]) ? void 0 : numElements, location), false, location);
        } else if (numElements !== 1 && (flattenContext.level < 1 || numElements === 0) || ts2.every(elements, ts2.isOmittedExpression)) {
          var reuseIdentifierExpressions = !ts2.isDeclarationBindingElement(parent) || numElements !== 0;
          value = ensureIdentifier(flattenContext, value, reuseIdentifierExpressions, location);
        }
        var bindingElements;
        var restContainingElements;
        for (var i = 0; i < numElements; i++) {
          var element = elements[i];
          if (flattenContext.level >= 1) {
            if (element.transformFlags & 16384) {
              var temp = ts2.createTempVariable(void 0);
              if (flattenContext.hoistTempVariables) {
                flattenContext.context.hoistVariableDeclaration(temp);
              }
              restContainingElements = ts2.append(restContainingElements, [temp, element]);
              bindingElements = ts2.append(bindingElements, flattenContext.createArrayBindingOrAssignmentElement(temp));
            } else {
              bindingElements = ts2.append(bindingElements, element);
            }
          } else if (ts2.isOmittedExpression(element)) {
            continue;
          } else if (!ts2.getRestIndicatorOfBindingOrAssignmentElement(element)) {
            var rhsValue = ts2.createElementAccess(value, i);
            flattenBindingOrAssignmentElement(flattenContext, element, rhsValue, element);
          } else if (i === numElements - 1) {
            var rhsValue = ts2.createArraySlice(value, i);
            flattenBindingOrAssignmentElement(flattenContext, element, rhsValue, element);
          }
        }
        if (bindingElements) {
          flattenContext.emitBindingOrAssignment(flattenContext.createArrayBindingOrAssignmentPattern(bindingElements), value, location, pattern);
        }
        if (restContainingElements) {
          for (var _i = 0, restContainingElements_1 = restContainingElements; _i < restContainingElements_1.length; _i++) {
            var _a = restContainingElements_1[_i], id = _a[0], element = _a[1];
            flattenBindingOrAssignmentElement(flattenContext, element, id, element);
          }
        }
      }
      function createDefaultValueCheck(flattenContext, value, defaultValue, location) {
        value = ensureIdentifier(flattenContext, value, true, location);
        return ts2.createConditional(ts2.createTypeCheck(value, "undefined"), defaultValue, value);
      }
      function createDestructuringPropertyAccess(flattenContext, value, propertyName) {
        if (ts2.isComputedPropertyName(propertyName)) {
          var argumentExpression = ensureIdentifier(flattenContext, ts2.visitNode(propertyName.expression, flattenContext.visitor), false, propertyName);
          return ts2.createElementAccess(value, argumentExpression);
        } else if (ts2.isStringOrNumericLiteralLike(propertyName)) {
          var argumentExpression = ts2.getSynthesizedClone(propertyName);
          argumentExpression.text = argumentExpression.text;
          return ts2.createElementAccess(value, argumentExpression);
        } else {
          var name = ts2.createIdentifier(ts2.idText(propertyName));
          return ts2.createPropertyAccess(value, name);
        }
      }
      function ensureIdentifier(flattenContext, value, reuseIdentifierExpressions, location) {
        if (ts2.isIdentifier(value) && reuseIdentifierExpressions) {
          return value;
        } else {
          var temp = ts2.createTempVariable(void 0);
          if (flattenContext.hoistTempVariables) {
            flattenContext.context.hoistVariableDeclaration(temp);
            flattenContext.emitExpression(ts2.setTextRange(ts2.createAssignment(temp, value), location));
          } else {
            flattenContext.emitBindingOrAssignment(temp, value, location, void 0);
          }
          return temp;
        }
      }
      function makeArrayBindingPattern(elements) {
        ts2.Debug.assertEachNode(elements, ts2.isArrayBindingElement);
        return ts2.createArrayBindingPattern(elements);
      }
      function makeArrayAssignmentPattern(elements) {
        return ts2.createArrayLiteral(ts2.map(elements, ts2.convertToArrayAssignmentElement));
      }
      function makeObjectBindingPattern(elements) {
        ts2.Debug.assertEachNode(elements, ts2.isBindingElement);
        return ts2.createObjectBindingPattern(elements);
      }
      function makeObjectAssignmentPattern(elements) {
        return ts2.createObjectLiteral(ts2.map(elements, ts2.convertToObjectAssignmentElement));
      }
      function makeBindingElement(name) {
        return ts2.createBindingElement(void 0, void 0, name);
      }
      function makeAssignmentElement(name) {
        return name;
      }
      ts2.restHelper = {
        name: "typescript:rest",
        importName: "__rest",
        scoped: false,
        text: '\n            var __rest = (this && this.__rest) || function (s, e) {\n                var t = {};\n                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)\n                    t[p] = s[p];\n                if (s != null && typeof Object.getOwnPropertySymbols === "function")\n                    for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {\n                        if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))\n                            t[p[i]] = s[p[i]];\n                    }\n                return t;\n            };'
      };
      function createRestCall(context, value, elements, computedTempVariables, location) {
        context.requestEmitHelper(ts2.restHelper);
        var propertyNames = [];
        var computedTempVariableOffset = 0;
        for (var i = 0; i < elements.length - 1; i++) {
          var propertyName = ts2.getPropertyNameOfBindingOrAssignmentElement(elements[i]);
          if (propertyName) {
            if (ts2.isComputedPropertyName(propertyName)) {
              var temp = computedTempVariables[computedTempVariableOffset];
              computedTempVariableOffset++;
              propertyNames.push(ts2.createConditional(ts2.createTypeCheck(temp, "symbol"), temp, ts2.createAdd(temp, ts2.createLiteral(""))));
            } else {
              propertyNames.push(ts2.createLiteral(propertyName));
            }
          }
        }
        return ts2.createCall(ts2.getUnscopedHelperName("__rest"), void 0, [
          value,
          ts2.setTextRange(ts2.createArrayLiteral(propertyNames), location)
        ]);
      }
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var ProcessLevel;
      (function(ProcessLevel2) {
        ProcessLevel2[ProcessLevel2["LiftRestriction"] = 0] = "LiftRestriction";
        ProcessLevel2[ProcessLevel2["All"] = 1] = "All";
      })(ProcessLevel = ts2.ProcessLevel || (ts2.ProcessLevel = {}));
      function processTaggedTemplateExpression(context, node, visitor, currentSourceFile, recordTaggedTemplateString, level) {
        var tag = ts2.visitNode(node.tag, visitor, ts2.isExpression);
        var templateArguments = [void 0];
        var cookedStrings = [];
        var rawStrings = [];
        var template = node.template;
        if (level === ProcessLevel.LiftRestriction && !ts2.hasInvalidEscape(template))
          return node;
        if (ts2.isNoSubstitutionTemplateLiteral(template)) {
          cookedStrings.push(createTemplateCooked(template));
          rawStrings.push(getRawLiteral(template, currentSourceFile));
        } else {
          cookedStrings.push(createTemplateCooked(template.head));
          rawStrings.push(getRawLiteral(template.head, currentSourceFile));
          for (var _i = 0, _a = template.templateSpans; _i < _a.length; _i++) {
            var templateSpan = _a[_i];
            cookedStrings.push(createTemplateCooked(templateSpan.literal));
            rawStrings.push(getRawLiteral(templateSpan.literal, currentSourceFile));
            templateArguments.push(ts2.visitNode(templateSpan.expression, visitor, ts2.isExpression));
          }
        }
        var helperCall = createTemplateObjectHelper(context, ts2.createArrayLiteral(cookedStrings), ts2.createArrayLiteral(rawStrings));
        if (ts2.isExternalModule(currentSourceFile)) {
          var tempVar = ts2.createUniqueName("templateObject");
          recordTaggedTemplateString(tempVar);
          templateArguments[0] = ts2.createLogicalOr(tempVar, ts2.createAssignment(tempVar, helperCall));
        } else {
          templateArguments[0] = helperCall;
        }
        return ts2.createCall(tag, void 0, templateArguments);
      }
      ts2.processTaggedTemplateExpression = processTaggedTemplateExpression;
      function createTemplateCooked(template) {
        return template.templateFlags ? ts2.createIdentifier("undefined") : ts2.createLiteral(template.text);
      }
      function getRawLiteral(node, currentSourceFile) {
        var text = node.rawText;
        if (text === void 0) {
          text = ts2.getSourceTextOfNodeFromSourceFile(currentSourceFile, node);
          var isLast = node.kind === 14 || node.kind === 17;
          text = text.substring(1, text.length - (isLast ? 1 : 2));
        }
        text = text.replace(/\r\n?/g, "\n");
        return ts2.setTextRange(ts2.createLiteral(text), node);
      }
      function createTemplateObjectHelper(context, cooked, raw) {
        context.requestEmitHelper(ts2.templateObjectHelper);
        return ts2.createCall(ts2.getUnscopedHelperName("__makeTemplateObject"), void 0, [
          cooked,
          raw
        ]);
      }
      ts2.templateObjectHelper = {
        name: "typescript:makeTemplateObject",
        importName: "__makeTemplateObject",
        scoped: false,
        priority: 0,
        text: '\n            var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {\n                if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }\n                return cooked;\n            };'
      };
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var USE_NEW_TYPE_METADATA_FORMAT = false;
      var TypeScriptSubstitutionFlags;
      (function(TypeScriptSubstitutionFlags2) {
        TypeScriptSubstitutionFlags2[TypeScriptSubstitutionFlags2["ClassAliases"] = 1] = "ClassAliases";
        TypeScriptSubstitutionFlags2[TypeScriptSubstitutionFlags2["NamespaceExports"] = 2] = "NamespaceExports";
        TypeScriptSubstitutionFlags2[TypeScriptSubstitutionFlags2["NonQualifiedEnumMembers"] = 8] = "NonQualifiedEnumMembers";
      })(TypeScriptSubstitutionFlags || (TypeScriptSubstitutionFlags = {}));
      var ClassFacts;
      (function(ClassFacts2) {
        ClassFacts2[ClassFacts2["None"] = 0] = "None";
        ClassFacts2[ClassFacts2["HasStaticInitializedProperties"] = 1] = "HasStaticInitializedProperties";
        ClassFacts2[ClassFacts2["HasConstructorDecorators"] = 2] = "HasConstructorDecorators";
        ClassFacts2[ClassFacts2["HasMemberDecorators"] = 4] = "HasMemberDecorators";
        ClassFacts2[ClassFacts2["IsExportOfNamespace"] = 8] = "IsExportOfNamespace";
        ClassFacts2[ClassFacts2["IsNamedExternalExport"] = 16] = "IsNamedExternalExport";
        ClassFacts2[ClassFacts2["IsDefaultExternalExport"] = 32] = "IsDefaultExternalExport";
        ClassFacts2[ClassFacts2["IsDerivedClass"] = 64] = "IsDerivedClass";
        ClassFacts2[ClassFacts2["UseImmediatelyInvokedFunctionExpression"] = 128] = "UseImmediatelyInvokedFunctionExpression";
        ClassFacts2[ClassFacts2["HasAnyDecorators"] = 6] = "HasAnyDecorators";
        ClassFacts2[ClassFacts2["NeedsName"] = 5] = "NeedsName";
        ClassFacts2[ClassFacts2["MayNeedImmediatelyInvokedFunctionExpression"] = 7] = "MayNeedImmediatelyInvokedFunctionExpression";
        ClassFacts2[ClassFacts2["IsExported"] = 56] = "IsExported";
      })(ClassFacts || (ClassFacts = {}));
      function transformTypeScript(context) {
        var startLexicalEnvironment = context.startLexicalEnvironment, resumeLexicalEnvironment = context.resumeLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var resolver = context.getEmitResolver();
        var compilerOptions = context.getCompilerOptions();
        var strictNullChecks = ts2.getStrictOptionValue(compilerOptions, "strictNullChecks");
        var languageVersion = ts2.getEmitScriptTarget(compilerOptions);
        var moduleKind = ts2.getEmitModuleKind(compilerOptions);
        var previousOnEmitNode = context.onEmitNode;
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onEmitNode = onEmitNode;
        context.onSubstituteNode = onSubstituteNode;
        context.enableSubstitution(194);
        context.enableSubstitution(195);
        var currentSourceFile;
        var currentNamespace;
        var currentNamespaceContainerName;
        var currentLexicalScope;
        var currentNameScope;
        var currentScopeFirstDeclarationsOfName;
        var currentClassHasParameterProperties;
        var enabledSubstitutions;
        var classAliases;
        var applicableSubstitutions;
        return transformSourceFileOrBundle;
        function transformSourceFileOrBundle(node) {
          if (node.kind === 291) {
            return transformBundle(node);
          }
          return transformSourceFile(node);
        }
        function transformBundle(node) {
          return ts2.createBundle(node.sourceFiles.map(transformSourceFile), ts2.mapDefined(node.prepends, function(prepend) {
            if (prepend.kind === 293) {
              return ts2.createUnparsedSourceFile(prepend, "js");
            }
            return prepend;
          }));
        }
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          currentSourceFile = node;
          var visited = saveStateAndInvoke(node, visitSourceFile);
          ts2.addEmitHelpers(visited, context.readEmitHelpers());
          currentSourceFile = void 0;
          return visited;
        }
        function saveStateAndInvoke(node, f) {
          var savedCurrentScope = currentLexicalScope;
          var savedCurrentNameScope = currentNameScope;
          var savedCurrentScopeFirstDeclarationsOfName = currentScopeFirstDeclarationsOfName;
          var savedCurrentClassHasParameterProperties = currentClassHasParameterProperties;
          onBeforeVisitNode(node);
          var visited = f(node);
          if (currentLexicalScope !== savedCurrentScope) {
            currentScopeFirstDeclarationsOfName = savedCurrentScopeFirstDeclarationsOfName;
          }
          currentLexicalScope = savedCurrentScope;
          currentNameScope = savedCurrentNameScope;
          currentClassHasParameterProperties = savedCurrentClassHasParameterProperties;
          return visited;
        }
        function onBeforeVisitNode(node) {
          switch (node.kind) {
            case 290:
            case 251:
            case 250:
            case 223:
              currentLexicalScope = node;
              currentNameScope = void 0;
              currentScopeFirstDeclarationsOfName = void 0;
              break;
            case 245:
            case 244:
              if (ts2.hasModifier(node, 2)) {
                break;
              }
              if (node.name) {
                recordEmittedDeclarationInScope(node);
              } else {
                ts2.Debug.assert(node.kind === 245 || ts2.hasModifier(node, 512));
              }
              if (ts2.isClassDeclaration(node)) {
                currentNameScope = node;
              }
              break;
          }
        }
        function visitor(node) {
          return saveStateAndInvoke(node, visitorWorker);
        }
        function visitorWorker(node) {
          if (node.transformFlags & 1) {
            return visitTypeScript(node);
          }
          return node;
        }
        function sourceElementVisitor(node) {
          return saveStateAndInvoke(node, sourceElementVisitorWorker);
        }
        function sourceElementVisitorWorker(node) {
          switch (node.kind) {
            case 254:
            case 253:
            case 259:
            case 260:
              return visitEllidableStatement(node);
            default:
              return visitorWorker(node);
          }
        }
        function visitEllidableStatement(node) {
          var parsed = ts2.getParseTreeNode(node);
          if (parsed !== node) {
            if (node.transformFlags & 1) {
              return ts2.visitEachChild(node, visitor, context);
            }
            return node;
          }
          switch (node.kind) {
            case 254:
              return visitImportDeclaration(node);
            case 253:
              return visitImportEqualsDeclaration(node);
            case 259:
              return visitExportAssignment(node);
            case 260:
              return visitExportDeclaration(node);
            default:
              ts2.Debug.fail("Unhandled ellided statement");
          }
        }
        function namespaceElementVisitor(node) {
          return saveStateAndInvoke(node, namespaceElementVisitorWorker);
        }
        function namespaceElementVisitorWorker(node) {
          if (node.kind === 260 || node.kind === 254 || node.kind === 255 || node.kind === 253 && node.moduleReference.kind === 265) {
            return void 0;
          } else if (node.transformFlags & 1 || ts2.hasModifier(node, 1)) {
            return visitTypeScript(node);
          }
          return node;
        }
        function classElementVisitor(node) {
          return saveStateAndInvoke(node, classElementVisitorWorker);
        }
        function classElementVisitorWorker(node) {
          switch (node.kind) {
            case 162:
              return visitConstructor(node);
            case 159:
              return visitPropertyDeclaration(node);
            case 167:
            case 163:
            case 164:
            case 161:
              return visitorWorker(node);
            case 222:
              return node;
            default:
              return ts2.Debug.failBadSyntaxKind(node);
          }
        }
        function modifierVisitor(node) {
          if (ts2.modifierToFlag(node.kind) & 2270) {
            return void 0;
          } else if (currentNamespace && node.kind === 89) {
            return void 0;
          }
          return node;
        }
        function visitTypeScript(node) {
          if (ts2.isStatement(node) && ts2.hasModifier(node, 2)) {
            return ts2.createNotEmittedStatement(node);
          }
          switch (node.kind) {
            case 89:
            case 84:
              return currentNamespace ? void 0 : node;
            case 119:
            case 117:
            case 118:
            case 122:
            case 81:
            case 130:
            case 138:
            case 174:
            case 175:
            case 176:
            case 177:
            case 173:
            case 168:
            case 155:
            case 125:
            case 148:
            case 128:
            case 143:
            case 140:
            case 137:
            case 110:
            case 144:
            case 171:
            case 170:
            case 172:
            case 169:
            case 178:
            case 179:
            case 180:
            case 182:
            case 183:
            case 184:
            case 185:
            case 186:
            case 187:
            case 167:
            case 157:
            case 247:
              return void 0;
            case 159:
              return visitPropertyDeclaration(node);
            case 252:
              return void 0;
            case 162:
              return visitConstructor(node);
            case 246:
              return ts2.createNotEmittedStatement(node);
            case 245:
              return visitClassDeclaration(node);
            case 214:
              return visitClassExpression(node);
            case 279:
              return visitHeritageClause(node);
            case 216:
              return visitExpressionWithTypeArguments(node);
            case 161:
              return visitMethodDeclaration(node);
            case 163:
              return visitGetAccessor(node);
            case 164:
              return visitSetAccessor(node);
            case 244:
              return visitFunctionDeclaration(node);
            case 201:
              return visitFunctionExpression(node);
            case 202:
              return visitArrowFunction(node);
            case 156:
              return visitParameter(node);
            case 200:
              return visitParenthesizedExpression(node);
            case 199:
            case 217:
              return visitAssertionExpression(node);
            case 196:
              return visitCallExpression(node);
            case 197:
              return visitNewExpression(node);
            case 198:
              return visitTaggedTemplateExpression(node);
            case 218:
              return visitNonNullExpression(node);
            case 248:
              return visitEnumDeclaration(node);
            case 225:
              return visitVariableStatement(node);
            case 242:
              return visitVariableDeclaration(node);
            case 249:
              return visitModuleDeclaration(node);
            case 253:
              return visitImportEqualsDeclaration(node);
            case 267:
              return visitJsxSelfClosingElement(node);
            case 268:
              return visitJsxJsxOpeningElement(node);
            default:
              return ts2.visitEachChild(node, visitor, context);
          }
        }
        function visitSourceFile(node) {
          var alwaysStrict = ts2.getStrictOptionValue(compilerOptions, "alwaysStrict") && !(ts2.isExternalModule(node) && moduleKind >= ts2.ModuleKind.ES2015) && !ts2.isJsonSourceFile(node);
          return ts2.updateSourceFileNode(node, ts2.visitLexicalEnvironment(node.statements, sourceElementVisitor, context, 0, alwaysStrict));
        }
        function shouldEmitDecorateCallForClass(node) {
          if (node.decorators && node.decorators.length > 0) {
            return true;
          }
          var constructor = ts2.getFirstConstructorWithBody(node);
          if (constructor) {
            return ts2.forEach(constructor.parameters, shouldEmitDecorateCallForParameter);
          }
          return false;
        }
        function shouldEmitDecorateCallForParameter(parameter) {
          return parameter.decorators !== void 0 && parameter.decorators.length > 0;
        }
        function getClassFacts(node, staticProperties) {
          var facts = 0;
          if (ts2.some(staticProperties))
            facts |= 1;
          var extendsClauseElement = ts2.getEffectiveBaseTypeNode(node);
          if (extendsClauseElement && ts2.skipOuterExpressions(extendsClauseElement.expression).kind !== 100)
            facts |= 64;
          if (shouldEmitDecorateCallForClass(node))
            facts |= 2;
          if (ts2.childIsDecorated(node))
            facts |= 4;
          if (isExportOfNamespace(node))
            facts |= 8;
          else if (isDefaultExternalModuleExport(node))
            facts |= 32;
          else if (isNamedExternalModuleExport(node))
            facts |= 16;
          if (languageVersion <= 1 && facts & 7)
            facts |= 128;
          return facts;
        }
        function hasTypeScriptClassSyntax(node) {
          return !!(node.transformFlags & 2048);
        }
        function isClassLikeDeclarationWithTypeScriptSyntax(node) {
          return ts2.some(node.decorators) || ts2.some(node.typeParameters) || ts2.some(node.heritageClauses, hasTypeScriptClassSyntax) || ts2.some(node.members, hasTypeScriptClassSyntax);
        }
        function visitClassDeclaration(node) {
          if (!isClassLikeDeclarationWithTypeScriptSyntax(node) && !(currentNamespace && ts2.hasModifier(node, 1))) {
            return ts2.visitEachChild(node, visitor, context);
          }
          var staticProperties = ts2.getProperties(node, true, true);
          var facts = getClassFacts(node, staticProperties);
          if (facts & 128) {
            context.startLexicalEnvironment();
          }
          var name = node.name || (facts & 5 ? ts2.getGeneratedNameForNode(node) : void 0);
          var classStatement = facts & 2 ? createClassDeclarationHeadWithDecorators(node, name) : createClassDeclarationHeadWithoutDecorators(node, name, facts);
          var statements = [classStatement];
          addClassElementDecorationStatements(statements, node, false);
          addClassElementDecorationStatements(statements, node, true);
          addConstructorDecorationStatement(statements, node);
          if (facts & 128) {
            var closingBraceLocation = ts2.createTokenRange(ts2.skipTrivia(currentSourceFile.text, node.members.end), 19);
            var localName = ts2.getInternalName(node);
            var outer = ts2.createPartiallyEmittedExpression(localName);
            outer.end = closingBraceLocation.end;
            ts2.setEmitFlags(outer, 1536);
            var statement = ts2.createReturn(outer);
            statement.pos = closingBraceLocation.pos;
            ts2.setEmitFlags(statement, 1536 | 384);
            statements.push(statement);
            ts2.insertStatementsAfterStandardPrologue(statements, context.endLexicalEnvironment());
            var iife = ts2.createImmediatelyInvokedArrowFunction(statements);
            ts2.setEmitFlags(iife, 33554432);
            var varStatement = ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([
              ts2.createVariableDeclaration(ts2.getLocalName(node, false, false), void 0, iife)
            ]));
            ts2.setOriginalNode(varStatement, node);
            ts2.setCommentRange(varStatement, node);
            ts2.setSourceMapRange(varStatement, ts2.moveRangePastDecorators(node));
            ts2.startOnNewLine(varStatement);
            statements = [varStatement];
          }
          if (facts & 8) {
            addExportMemberAssignment(statements, node);
          } else if (facts & 128 || facts & 2) {
            if (facts & 32) {
              statements.push(ts2.createExportDefault(ts2.getLocalName(node, false, true)));
            } else if (facts & 16) {
              statements.push(ts2.createExternalModuleExport(ts2.getLocalName(node, false, true)));
            }
          }
          if (statements.length > 1) {
            statements.push(ts2.createEndOfDeclarationMarker(node));
            ts2.setEmitFlags(classStatement, ts2.getEmitFlags(classStatement) | 4194304);
          }
          return ts2.singleOrMany(statements);
        }
        function createClassDeclarationHeadWithoutDecorators(node, name, facts) {
          var modifiers = !(facts & 128) ? ts2.visitNodes(node.modifiers, modifierVisitor, ts2.isModifier) : void 0;
          var classDeclaration = ts2.createClassDeclaration(void 0, modifiers, name, void 0, ts2.visitNodes(node.heritageClauses, visitor, ts2.isHeritageClause), transformClassMembers(node));
          var emitFlags = ts2.getEmitFlags(node);
          if (facts & 1) {
            emitFlags |= 32;
          }
          ts2.aggregateTransformFlags(classDeclaration);
          ts2.setTextRange(classDeclaration, node);
          ts2.setOriginalNode(classDeclaration, node);
          ts2.setEmitFlags(classDeclaration, emitFlags);
          return classDeclaration;
        }
        function createClassDeclarationHeadWithDecorators(node, name) {
          var location = ts2.moveRangePastDecorators(node);
          var classAlias = getClassAliasIfNeeded(node);
          var declName = ts2.getLocalName(node, false, true);
          var heritageClauses = ts2.visitNodes(node.heritageClauses, visitor, ts2.isHeritageClause);
          var members = transformClassMembers(node);
          var classExpression = ts2.createClassExpression(void 0, name, void 0, heritageClauses, members);
          ts2.aggregateTransformFlags(classExpression);
          ts2.setOriginalNode(classExpression, node);
          ts2.setTextRange(classExpression, location);
          var statement = ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([
            ts2.createVariableDeclaration(declName, void 0, classAlias ? ts2.createAssignment(classAlias, classExpression) : classExpression)
          ], 1));
          ts2.setOriginalNode(statement, node);
          ts2.setTextRange(statement, location);
          ts2.setCommentRange(statement, node);
          return statement;
        }
        function visitClassExpression(node) {
          if (!isClassLikeDeclarationWithTypeScriptSyntax(node)) {
            return ts2.visitEachChild(node, visitor, context);
          }
          var classExpression = ts2.createClassExpression(void 0, node.name, void 0, ts2.visitNodes(node.heritageClauses, visitor, ts2.isHeritageClause), transformClassMembers(node));
          ts2.aggregateTransformFlags(classExpression);
          ts2.setOriginalNode(classExpression, node);
          ts2.setTextRange(classExpression, node);
          return classExpression;
        }
        function transformClassMembers(node) {
          var members = [];
          var constructor = ts2.getFirstConstructorWithBody(node);
          var parametersWithPropertyAssignments = constructor && ts2.filter(constructor.parameters, function(p) {
            return ts2.isParameterPropertyDeclaration(p, constructor);
          });
          if (parametersWithPropertyAssignments) {
            for (var _i = 0, parametersWithPropertyAssignments_1 = parametersWithPropertyAssignments; _i < parametersWithPropertyAssignments_1.length; _i++) {
              var parameter = parametersWithPropertyAssignments_1[_i];
              if (ts2.isIdentifier(parameter.name)) {
                members.push(ts2.setOriginalNode(ts2.aggregateTransformFlags(ts2.createProperty(void 0, void 0, parameter.name, void 0, void 0, void 0)), parameter));
              }
            }
          }
          ts2.addRange(members, ts2.visitNodes(node.members, classElementVisitor, ts2.isClassElement));
          return ts2.setTextRange(ts2.createNodeArray(members), node.members);
        }
        function getDecoratedClassElements(node, isStatic) {
          return ts2.filter(node.members, isStatic ? function(m) {
            return isStaticDecoratedClassElement(m, node);
          } : function(m) {
            return isInstanceDecoratedClassElement(m, node);
          });
        }
        function isStaticDecoratedClassElement(member, parent) {
          return isDecoratedClassElement(member, true, parent);
        }
        function isInstanceDecoratedClassElement(member, parent) {
          return isDecoratedClassElement(member, false, parent);
        }
        function isDecoratedClassElement(member, isStatic, parent) {
          return ts2.nodeOrChildIsDecorated(member, parent) && isStatic === ts2.hasModifier(member, 32);
        }
        function getDecoratorsOfParameters(node) {
          var decorators;
          if (node) {
            var parameters = node.parameters;
            var firstParameterIsThis = parameters.length > 0 && ts2.parameterIsThisKeyword(parameters[0]);
            var firstParameterOffset = firstParameterIsThis ? 1 : 0;
            var numParameters = firstParameterIsThis ? parameters.length - 1 : parameters.length;
            for (var i = 0; i < numParameters; i++) {
              var parameter = parameters[i + firstParameterOffset];
              if (decorators || parameter.decorators) {
                if (!decorators) {
                  decorators = new Array(numParameters);
                }
                decorators[i] = parameter.decorators;
              }
            }
          }
          return decorators;
        }
        function getAllDecoratorsOfConstructor(node) {
          var decorators = node.decorators;
          var parameters = getDecoratorsOfParameters(ts2.getFirstConstructorWithBody(node));
          if (!decorators && !parameters) {
            return void 0;
          }
          return {
            decorators,
            parameters
          };
        }
        function getAllDecoratorsOfClassElement(node, member) {
          switch (member.kind) {
            case 163:
            case 164:
              return getAllDecoratorsOfAccessors(node, member);
            case 161:
              return getAllDecoratorsOfMethod(member);
            case 159:
              return getAllDecoratorsOfProperty(member);
            default:
              return void 0;
          }
        }
        function getAllDecoratorsOfAccessors(node, accessor) {
          if (!accessor.body) {
            return void 0;
          }
          var _a = ts2.getAllAccessorDeclarations(node.members, accessor), firstAccessor = _a.firstAccessor, secondAccessor = _a.secondAccessor, setAccessor = _a.setAccessor;
          var firstAccessorWithDecorators = firstAccessor.decorators ? firstAccessor : secondAccessor && secondAccessor.decorators ? secondAccessor : void 0;
          if (!firstAccessorWithDecorators || accessor !== firstAccessorWithDecorators) {
            return void 0;
          }
          var decorators = firstAccessorWithDecorators.decorators;
          var parameters = getDecoratorsOfParameters(setAccessor);
          if (!decorators && !parameters) {
            return void 0;
          }
          return { decorators, parameters };
        }
        function getAllDecoratorsOfMethod(method) {
          if (!method.body) {
            return void 0;
          }
          var decorators = method.decorators;
          var parameters = getDecoratorsOfParameters(method);
          if (!decorators && !parameters) {
            return void 0;
          }
          return { decorators, parameters };
        }
        function getAllDecoratorsOfProperty(property) {
          var decorators = property.decorators;
          if (!decorators) {
            return void 0;
          }
          return { decorators };
        }
        function transformAllDecoratorsOfDeclaration(node, container, allDecorators) {
          if (!allDecorators) {
            return void 0;
          }
          var decoratorExpressions = [];
          ts2.addRange(decoratorExpressions, ts2.map(allDecorators.decorators, transformDecorator));
          ts2.addRange(decoratorExpressions, ts2.flatMap(allDecorators.parameters, transformDecoratorsOfParameter));
          addTypeMetadata(node, container, decoratorExpressions);
          return decoratorExpressions;
        }
        function addClassElementDecorationStatements(statements, node, isStatic) {
          ts2.addRange(statements, ts2.map(generateClassElementDecorationExpressions(node, isStatic), expressionToStatement));
        }
        function generateClassElementDecorationExpressions(node, isStatic) {
          var members = getDecoratedClassElements(node, isStatic);
          var expressions;
          for (var _i = 0, members_6 = members; _i < members_6.length; _i++) {
            var member = members_6[_i];
            var expression = generateClassElementDecorationExpression(node, member);
            if (expression) {
              if (!expressions) {
                expressions = [expression];
              } else {
                expressions.push(expression);
              }
            }
          }
          return expressions;
        }
        function generateClassElementDecorationExpression(node, member) {
          var allDecorators = getAllDecoratorsOfClassElement(node, member);
          var decoratorExpressions = transformAllDecoratorsOfDeclaration(member, node, allDecorators);
          if (!decoratorExpressions) {
            return void 0;
          }
          var prefix = getClassMemberPrefix(node, member);
          var memberName = getExpressionForPropertyName(member, true);
          var descriptor = languageVersion > 0 ? member.kind === 159 ? ts2.createVoidZero() : ts2.createNull() : void 0;
          var helper = createDecorateHelper(context, decoratorExpressions, prefix, memberName, descriptor, ts2.moveRangePastDecorators(member));
          ts2.setEmitFlags(helper, 1536);
          return helper;
        }
        function addConstructorDecorationStatement(statements, node) {
          var expression = generateConstructorDecorationExpression(node);
          if (expression) {
            statements.push(ts2.setOriginalNode(ts2.createExpressionStatement(expression), node));
          }
        }
        function generateConstructorDecorationExpression(node) {
          var allDecorators = getAllDecoratorsOfConstructor(node);
          var decoratorExpressions = transformAllDecoratorsOfDeclaration(node, node, allDecorators);
          if (!decoratorExpressions) {
            return void 0;
          }
          var classAlias = classAliases && classAliases[ts2.getOriginalNodeId(node)];
          var localName = ts2.getLocalName(node, false, true);
          var decorate = createDecorateHelper(context, decoratorExpressions, localName);
          var expression = ts2.createAssignment(localName, classAlias ? ts2.createAssignment(classAlias, decorate) : decorate);
          ts2.setEmitFlags(expression, 1536);
          ts2.setSourceMapRange(expression, ts2.moveRangePastDecorators(node));
          return expression;
        }
        function transformDecorator(decorator) {
          return ts2.visitNode(decorator.expression, visitor, ts2.isExpression);
        }
        function transformDecoratorsOfParameter(decorators, parameterOffset) {
          var expressions;
          if (decorators) {
            expressions = [];
            for (var _i = 0, decorators_1 = decorators; _i < decorators_1.length; _i++) {
              var decorator = decorators_1[_i];
              var helper = createParamHelper(context, transformDecorator(decorator), parameterOffset, decorator.expression);
              ts2.setEmitFlags(helper, 1536);
              expressions.push(helper);
            }
          }
          return expressions;
        }
        function addTypeMetadata(node, container, decoratorExpressions) {
          if (USE_NEW_TYPE_METADATA_FORMAT) {
            addNewTypeMetadata(node, container, decoratorExpressions);
          } else {
            addOldTypeMetadata(node, container, decoratorExpressions);
          }
        }
        function addOldTypeMetadata(node, container, decoratorExpressions) {
          if (compilerOptions.emitDecoratorMetadata) {
            if (shouldAddTypeMetadata(node)) {
              decoratorExpressions.push(createMetadataHelper(context, "design:type", serializeTypeOfNode(node)));
            }
            if (shouldAddParamTypesMetadata(node)) {
              decoratorExpressions.push(createMetadataHelper(context, "design:paramtypes", serializeParameterTypesOfNode(node, container)));
            }
            if (shouldAddReturnTypeMetadata(node)) {
              decoratorExpressions.push(createMetadataHelper(context, "design:returntype", serializeReturnTypeOfNode(node)));
            }
          }
        }
        function addNewTypeMetadata(node, container, decoratorExpressions) {
          if (compilerOptions.emitDecoratorMetadata) {
            var properties = void 0;
            if (shouldAddTypeMetadata(node)) {
              (properties || (properties = [])).push(ts2.createPropertyAssignment("type", ts2.createArrowFunction(void 0, void 0, [], void 0, ts2.createToken(38), serializeTypeOfNode(node))));
            }
            if (shouldAddParamTypesMetadata(node)) {
              (properties || (properties = [])).push(ts2.createPropertyAssignment("paramTypes", ts2.createArrowFunction(void 0, void 0, [], void 0, ts2.createToken(38), serializeParameterTypesOfNode(node, container))));
            }
            if (shouldAddReturnTypeMetadata(node)) {
              (properties || (properties = [])).push(ts2.createPropertyAssignment("returnType", ts2.createArrowFunction(void 0, void 0, [], void 0, ts2.createToken(38), serializeReturnTypeOfNode(node))));
            }
            if (properties) {
              decoratorExpressions.push(createMetadataHelper(context, "design:typeinfo", ts2.createObjectLiteral(properties, true)));
            }
          }
        }
        function shouldAddTypeMetadata(node) {
          var kind = node.kind;
          return kind === 161 || kind === 163 || kind === 164 || kind === 159;
        }
        function shouldAddReturnTypeMetadata(node) {
          return node.kind === 161;
        }
        function shouldAddParamTypesMetadata(node) {
          switch (node.kind) {
            case 245:
            case 214:
              return ts2.getFirstConstructorWithBody(node) !== void 0;
            case 161:
            case 163:
            case 164:
              return true;
          }
          return false;
        }
        function getAccessorTypeNode(node) {
          var accessors = resolver.getAllAccessorDeclarations(node);
          return accessors.setAccessor && ts2.getSetAccessorTypeAnnotationNode(accessors.setAccessor) || accessors.getAccessor && ts2.getEffectiveReturnTypeNode(accessors.getAccessor);
        }
        function serializeTypeOfNode(node) {
          switch (node.kind) {
            case 159:
            case 156:
              return serializeTypeNode(node.type);
            case 164:
            case 163:
              return serializeTypeNode(getAccessorTypeNode(node));
            case 245:
            case 214:
            case 161:
              return ts2.createIdentifier("Function");
            default:
              return ts2.createVoidZero();
          }
        }
        function serializeParameterTypesOfNode(node, container) {
          var valueDeclaration = ts2.isClassLike(node) ? ts2.getFirstConstructorWithBody(node) : ts2.isFunctionLike(node) && ts2.nodeIsPresent(node.body) ? node : void 0;
          var expressions = [];
          if (valueDeclaration) {
            var parameters = getParametersOfDecoratedDeclaration(valueDeclaration, container);
            var numParameters = parameters.length;
            for (var i = 0; i < numParameters; i++) {
              var parameter = parameters[i];
              if (i === 0 && ts2.isIdentifier(parameter.name) && parameter.name.escapedText === "this") {
                continue;
              }
              if (parameter.dotDotDotToken) {
                expressions.push(serializeTypeNode(ts2.getRestParameterElementType(parameter.type)));
              } else {
                expressions.push(serializeTypeOfNode(parameter));
              }
            }
          }
          return ts2.createArrayLiteral(expressions);
        }
        function getParametersOfDecoratedDeclaration(node, container) {
          if (container && node.kind === 163) {
            var setAccessor = ts2.getAllAccessorDeclarations(container.members, node).setAccessor;
            if (setAccessor) {
              return setAccessor.parameters;
            }
          }
          return node.parameters;
        }
        function serializeReturnTypeOfNode(node) {
          if (ts2.isFunctionLike(node) && node.type) {
            return serializeTypeNode(node.type);
          } else if (ts2.isAsyncFunction(node)) {
            return ts2.createIdentifier("Promise");
          }
          return ts2.createVoidZero();
        }
        function serializeTypeNode(node) {
          if (node === void 0) {
            return ts2.createIdentifier("Object");
          }
          switch (node.kind) {
            case 110:
            case 146:
            case 100:
            case 137:
              return ts2.createVoidZero();
            case 182:
              return serializeTypeNode(node.type);
            case 170:
            case 171:
              return ts2.createIdentifier("Function");
            case 174:
            case 175:
              return ts2.createIdentifier("Array");
            case 168:
            case 128:
              return ts2.createIdentifier("Boolean");
            case 143:
              return ts2.createIdentifier("String");
            case 141:
              return ts2.createIdentifier("Object");
            case 187:
              switch (node.literal.kind) {
                case 10:
                  return ts2.createIdentifier("String");
                case 207:
                case 8:
                  return ts2.createIdentifier("Number");
                case 9:
                  return getGlobalBigIntNameWithFallback();
                case 106:
                case 91:
                  return ts2.createIdentifier("Boolean");
                default:
                  return ts2.Debug.failBadSyntaxKind(node.literal);
              }
            case 140:
              return ts2.createIdentifier("Number");
            case 151:
              return getGlobalBigIntNameWithFallback();
            case 144:
              return languageVersion < 2 ? getGlobalSymbolNameWithFallback() : ts2.createIdentifier("Symbol");
            case 169:
              return serializeTypeReferenceNode(node);
            case 179:
            case 178:
              return serializeTypeList(node.types);
            case 180:
              return serializeTypeList([node.trueType, node.falseType]);
            case 184:
              if (node.operator === 138) {
                return serializeTypeNode(node.type);
              }
              break;
            case 172:
            case 185:
            case 186:
            case 173:
            case 125:
            case 148:
            case 183:
            case 188:
              break;
            case 295:
            case 296:
            case 300:
            case 301:
            case 302:
              break;
            case 297:
            case 298:
            case 299:
              return serializeTypeNode(node.type);
            default:
              return ts2.Debug.failBadSyntaxKind(node);
          }
          return ts2.createIdentifier("Object");
        }
        function serializeTypeList(types) {
          var serializedUnion;
          for (var _i = 0, types_21 = types; _i < types_21.length; _i++) {
            var typeNode = types_21[_i];
            while (typeNode.kind === 182) {
              typeNode = typeNode.type;
            }
            if (typeNode.kind === 137) {
              continue;
            }
            if (!strictNullChecks && (typeNode.kind === 100 || typeNode.kind === 146)) {
              continue;
            }
            var serializedIndividual = serializeTypeNode(typeNode);
            if (ts2.isIdentifier(serializedIndividual) && serializedIndividual.escapedText === "Object") {
              return serializedIndividual;
            } else if (serializedUnion) {
              if (!ts2.isIdentifier(serializedUnion) || !ts2.isIdentifier(serializedIndividual) || serializedUnion.escapedText !== serializedIndividual.escapedText) {
                return ts2.createIdentifier("Object");
              }
            } else {
              serializedUnion = serializedIndividual;
            }
          }
          return serializedUnion || ts2.createVoidZero();
        }
        function serializeTypeReferenceNode(node) {
          var kind = resolver.getTypeReferenceSerializationKind(node.typeName, currentNameScope || currentLexicalScope);
          switch (kind) {
            case ts2.TypeReferenceSerializationKind.Unknown:
              if (ts2.findAncestor(node, function(n) {
                return n.parent && ts2.isConditionalTypeNode(n.parent) && (n.parent.trueType === n || n.parent.falseType === n);
              })) {
                return ts2.createIdentifier("Object");
              }
              var serialized = serializeEntityNameAsExpressionFallback(node.typeName);
              var temp = ts2.createTempVariable(hoistVariableDeclaration);
              return ts2.createConditional(ts2.createTypeCheck(ts2.createAssignment(temp, serialized), "function"), temp, ts2.createIdentifier("Object"));
            case ts2.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue:
              return serializeEntityNameAsExpression(node.typeName);
            case ts2.TypeReferenceSerializationKind.VoidNullableOrNeverType:
              return ts2.createVoidZero();
            case ts2.TypeReferenceSerializationKind.BigIntLikeType:
              return getGlobalBigIntNameWithFallback();
            case ts2.TypeReferenceSerializationKind.BooleanType:
              return ts2.createIdentifier("Boolean");
            case ts2.TypeReferenceSerializationKind.NumberLikeType:
              return ts2.createIdentifier("Number");
            case ts2.TypeReferenceSerializationKind.StringLikeType:
              return ts2.createIdentifier("String");
            case ts2.TypeReferenceSerializationKind.ArrayLikeType:
              return ts2.createIdentifier("Array");
            case ts2.TypeReferenceSerializationKind.ESSymbolType:
              return languageVersion < 2 ? getGlobalSymbolNameWithFallback() : ts2.createIdentifier("Symbol");
            case ts2.TypeReferenceSerializationKind.TypeWithCallSignature:
              return ts2.createIdentifier("Function");
            case ts2.TypeReferenceSerializationKind.Promise:
              return ts2.createIdentifier("Promise");
            case ts2.TypeReferenceSerializationKind.ObjectType:
              return ts2.createIdentifier("Object");
            default:
              return ts2.Debug.assertNever(kind);
          }
        }
        function createCheckedValue(left, right) {
          return ts2.createLogicalAnd(ts2.createStrictInequality(ts2.createTypeOf(left), ts2.createLiteral("undefined")), right);
        }
        function serializeEntityNameAsExpressionFallback(node) {
          if (node.kind === 75) {
            var copied = serializeEntityNameAsExpression(node);
            return createCheckedValue(copied, copied);
          }
          if (node.left.kind === 75) {
            return createCheckedValue(serializeEntityNameAsExpression(node.left), serializeEntityNameAsExpression(node));
          }
          var left = serializeEntityNameAsExpressionFallback(node.left);
          var temp = ts2.createTempVariable(hoistVariableDeclaration);
          return ts2.createLogicalAnd(ts2.createLogicalAnd(left.left, ts2.createStrictInequality(ts2.createAssignment(temp, left.right), ts2.createVoidZero())), ts2.createPropertyAccess(temp, node.right));
        }
        function serializeEntityNameAsExpression(node) {
          switch (node.kind) {
            case 75:
              var name = ts2.getMutableClone(node);
              name.flags &= ~8;
              name.original = void 0;
              name.parent = ts2.getParseTreeNode(currentLexicalScope);
              return name;
            case 153:
              return serializeQualifiedNameAsExpression(node);
          }
        }
        function serializeQualifiedNameAsExpression(node) {
          return ts2.createPropertyAccess(serializeEntityNameAsExpression(node.left), node.right);
        }
        function getGlobalSymbolNameWithFallback() {
          return ts2.createConditional(ts2.createTypeCheck(ts2.createIdentifier("Symbol"), "function"), ts2.createIdentifier("Symbol"), ts2.createIdentifier("Object"));
        }
        function getGlobalBigIntNameWithFallback() {
          return languageVersion < 99 ? ts2.createConditional(ts2.createTypeCheck(ts2.createIdentifier("BigInt"), "function"), ts2.createIdentifier("BigInt"), ts2.createIdentifier("Object")) : ts2.createIdentifier("BigInt");
        }
        function getExpressionForPropertyName(member, generateNameForComputedPropertyName) {
          var name = member.name;
          if (ts2.isPrivateIdentifier(name)) {
            return ts2.createIdentifier("");
          } else if (ts2.isComputedPropertyName(name)) {
            return generateNameForComputedPropertyName && !ts2.isSimpleInlineableExpression(name.expression) ? ts2.getGeneratedNameForNode(name) : name.expression;
          } else if (ts2.isIdentifier(name)) {
            return ts2.createLiteral(ts2.idText(name));
          } else {
            return ts2.getSynthesizedClone(name);
          }
        }
        function visitPropertyNameOfClassElement(member) {
          var name = member.name;
          if (ts2.isComputedPropertyName(name) && (!ts2.hasStaticModifier(member) && currentClassHasParameterProperties || ts2.some(member.decorators))) {
            var expression = ts2.visitNode(name.expression, visitor, ts2.isExpression);
            var innerExpression = ts2.skipPartiallyEmittedExpressions(expression);
            if (!ts2.isSimpleInlineableExpression(innerExpression)) {
              var generatedName = ts2.getGeneratedNameForNode(name);
              hoistVariableDeclaration(generatedName);
              return ts2.updateComputedPropertyName(name, ts2.createAssignment(generatedName, expression));
            }
          }
          return ts2.visitNode(name, visitor, ts2.isPropertyName);
        }
        function visitHeritageClause(node) {
          if (node.token === 113) {
            return void 0;
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitExpressionWithTypeArguments(node) {
          return ts2.updateExpressionWithTypeArguments(node, void 0, ts2.visitNode(node.expression, visitor, ts2.isLeftHandSideExpression));
        }
        function shouldEmitFunctionLikeDeclaration(node) {
          return !ts2.nodeIsMissing(node.body);
        }
        function visitPropertyDeclaration(node) {
          if (node.flags & 8388608) {
            return void 0;
          }
          var updated = ts2.updateProperty(node, void 0, ts2.visitNodes(node.modifiers, visitor, ts2.isModifier), visitPropertyNameOfClassElement(node), void 0, void 0, ts2.visitNode(node.initializer, visitor));
          if (updated !== node) {
            ts2.setCommentRange(updated, node);
            ts2.setSourceMapRange(updated, ts2.moveRangePastDecorators(node));
          }
          return updated;
        }
        function visitConstructor(node) {
          if (!shouldEmitFunctionLikeDeclaration(node)) {
            return void 0;
          }
          return ts2.updateConstructor(node, void 0, void 0, ts2.visitParameterList(node.parameters, visitor, context), transformConstructorBody(node.body, node));
        }
        function transformConstructorBody(body, constructor) {
          var parametersWithPropertyAssignments = constructor && ts2.filter(constructor.parameters, function(p) {
            return ts2.isParameterPropertyDeclaration(p, constructor);
          });
          if (!ts2.some(parametersWithPropertyAssignments)) {
            return ts2.visitFunctionBody(body, visitor, context);
          }
          var statements = [];
          var indexOfFirstStatement = 0;
          resumeLexicalEnvironment();
          indexOfFirstStatement = ts2.addPrologueDirectivesAndInitialSuperCall(constructor, statements, visitor);
          ts2.addRange(statements, ts2.map(parametersWithPropertyAssignments, transformParameterWithPropertyAssignment));
          ts2.addRange(statements, ts2.visitNodes(body.statements, visitor, ts2.isStatement, indexOfFirstStatement));
          statements = ts2.mergeLexicalEnvironment(statements, endLexicalEnvironment());
          var block = ts2.createBlock(ts2.setTextRange(ts2.createNodeArray(statements), body.statements), true);
          ts2.setTextRange(block, body);
          ts2.setOriginalNode(block, body);
          return block;
        }
        function transformParameterWithPropertyAssignment(node) {
          var name = node.name;
          if (!ts2.isIdentifier(name)) {
            return void 0;
          }
          var propertyName = ts2.getMutableClone(name);
          ts2.setEmitFlags(propertyName, 1536 | 48);
          var localName = ts2.getMutableClone(name);
          ts2.setEmitFlags(localName, 1536);
          return ts2.startOnNewLine(ts2.removeAllComments(ts2.setTextRange(ts2.setOriginalNode(ts2.createExpressionStatement(ts2.createAssignment(ts2.setTextRange(ts2.createPropertyAccess(ts2.createThis(), propertyName), node.name), localName)), node), ts2.moveRangePos(node, -1))));
        }
        function visitMethodDeclaration(node) {
          if (!shouldEmitFunctionLikeDeclaration(node)) {
            return void 0;
          }
          var updated = ts2.updateMethod(node, void 0, ts2.visitNodes(node.modifiers, modifierVisitor, ts2.isModifier), node.asteriskToken, visitPropertyNameOfClassElement(node), void 0, void 0, ts2.visitParameterList(node.parameters, visitor, context), void 0, ts2.visitFunctionBody(node.body, visitor, context));
          if (updated !== node) {
            ts2.setCommentRange(updated, node);
            ts2.setSourceMapRange(updated, ts2.moveRangePastDecorators(node));
          }
          return updated;
        }
        function shouldEmitAccessorDeclaration(node) {
          return !(ts2.nodeIsMissing(node.body) && ts2.hasModifier(node, 128));
        }
        function visitGetAccessor(node) {
          if (!shouldEmitAccessorDeclaration(node)) {
            return void 0;
          }
          var updated = ts2.updateGetAccessor(node, void 0, ts2.visitNodes(node.modifiers, modifierVisitor, ts2.isModifier), visitPropertyNameOfClassElement(node), ts2.visitParameterList(node.parameters, visitor, context), void 0, ts2.visitFunctionBody(node.body, visitor, context) || ts2.createBlock([]));
          if (updated !== node) {
            ts2.setCommentRange(updated, node);
            ts2.setSourceMapRange(updated, ts2.moveRangePastDecorators(node));
          }
          return updated;
        }
        function visitSetAccessor(node) {
          if (!shouldEmitAccessorDeclaration(node)) {
            return void 0;
          }
          var updated = ts2.updateSetAccessor(node, void 0, ts2.visitNodes(node.modifiers, modifierVisitor, ts2.isModifier), visitPropertyNameOfClassElement(node), ts2.visitParameterList(node.parameters, visitor, context), ts2.visitFunctionBody(node.body, visitor, context) || ts2.createBlock([]));
          if (updated !== node) {
            ts2.setCommentRange(updated, node);
            ts2.setSourceMapRange(updated, ts2.moveRangePastDecorators(node));
          }
          return updated;
        }
        function visitFunctionDeclaration(node) {
          if (!shouldEmitFunctionLikeDeclaration(node)) {
            return ts2.createNotEmittedStatement(node);
          }
          var updated = ts2.updateFunctionDeclaration(node, void 0, ts2.visitNodes(node.modifiers, modifierVisitor, ts2.isModifier), node.asteriskToken, node.name, void 0, ts2.visitParameterList(node.parameters, visitor, context), void 0, ts2.visitFunctionBody(node.body, visitor, context) || ts2.createBlock([]));
          if (isExportOfNamespace(node)) {
            var statements = [updated];
            addExportMemberAssignment(statements, node);
            return statements;
          }
          return updated;
        }
        function visitFunctionExpression(node) {
          if (!shouldEmitFunctionLikeDeclaration(node)) {
            return ts2.createOmittedExpression();
          }
          var updated = ts2.updateFunctionExpression(node, ts2.visitNodes(node.modifiers, modifierVisitor, ts2.isModifier), node.asteriskToken, node.name, void 0, ts2.visitParameterList(node.parameters, visitor, context), void 0, ts2.visitFunctionBody(node.body, visitor, context) || ts2.createBlock([]));
          return updated;
        }
        function visitArrowFunction(node) {
          var updated = ts2.updateArrowFunction(node, ts2.visitNodes(node.modifiers, modifierVisitor, ts2.isModifier), void 0, ts2.visitParameterList(node.parameters, visitor, context), void 0, node.equalsGreaterThanToken, ts2.visitFunctionBody(node.body, visitor, context));
          return updated;
        }
        function visitParameter(node) {
          if (ts2.parameterIsThisKeyword(node)) {
            return void 0;
          }
          var updated = ts2.updateParameter(node, void 0, void 0, node.dotDotDotToken, ts2.visitNode(node.name, visitor, ts2.isBindingName), void 0, void 0, ts2.visitNode(node.initializer, visitor, ts2.isExpression));
          if (updated !== node) {
            ts2.setCommentRange(updated, node);
            ts2.setTextRange(updated, ts2.moveRangePastModifiers(node));
            ts2.setSourceMapRange(updated, ts2.moveRangePastModifiers(node));
            ts2.setEmitFlags(updated.name, 32);
          }
          return updated;
        }
        function visitVariableStatement(node) {
          if (isExportOfNamespace(node)) {
            var variables = ts2.getInitializedVariables(node.declarationList);
            if (variables.length === 0) {
              return void 0;
            }
            return ts2.setTextRange(ts2.createExpressionStatement(ts2.inlineExpressions(ts2.map(variables, transformInitializedVariable))), node);
          } else {
            return ts2.visitEachChild(node, visitor, context);
          }
        }
        function transformInitializedVariable(node) {
          var name = node.name;
          if (ts2.isBindingPattern(name)) {
            return ts2.flattenDestructuringAssignment(node, visitor, context, 0, false, createNamespaceExportExpression);
          } else {
            return ts2.setTextRange(ts2.createAssignment(getNamespaceMemberNameWithSourceMapsAndWithoutComments(name), ts2.visitNode(node.initializer, visitor, ts2.isExpression)), node);
          }
        }
        function visitVariableDeclaration(node) {
          return ts2.updateTypeScriptVariableDeclaration(node, ts2.visitNode(node.name, visitor, ts2.isBindingName), void 0, void 0, ts2.visitNode(node.initializer, visitor, ts2.isExpression));
        }
        function visitParenthesizedExpression(node) {
          var innerExpression = ts2.skipOuterExpressions(node.expression, ~6);
          if (ts2.isAssertionExpression(innerExpression)) {
            var expression = ts2.visitNode(node.expression, visitor, ts2.isExpression);
            if (ts2.length(ts2.getLeadingCommentRangesOfNode(expression, currentSourceFile))) {
              return ts2.updateParen(node, expression);
            }
            return ts2.createPartiallyEmittedExpression(expression, node);
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitAssertionExpression(node) {
          var expression = ts2.visitNode(node.expression, visitor, ts2.isExpression);
          return ts2.createPartiallyEmittedExpression(expression, node);
        }
        function visitNonNullExpression(node) {
          var expression = ts2.visitNode(node.expression, visitor, ts2.isLeftHandSideExpression);
          return ts2.createPartiallyEmittedExpression(expression, node);
        }
        function visitCallExpression(node) {
          return ts2.updateCall(node, ts2.visitNode(node.expression, visitor, ts2.isExpression), void 0, ts2.visitNodes(node.arguments, visitor, ts2.isExpression));
        }
        function visitNewExpression(node) {
          return ts2.updateNew(node, ts2.visitNode(node.expression, visitor, ts2.isExpression), void 0, ts2.visitNodes(node.arguments, visitor, ts2.isExpression));
        }
        function visitTaggedTemplateExpression(node) {
          return ts2.updateTaggedTemplate(node, ts2.visitNode(node.tag, visitor, ts2.isExpression), void 0, ts2.visitNode(node.template, visitor, ts2.isExpression));
        }
        function visitJsxSelfClosingElement(node) {
          return ts2.updateJsxSelfClosingElement(node, ts2.visitNode(node.tagName, visitor, ts2.isJsxTagNameExpression), void 0, ts2.visitNode(node.attributes, visitor, ts2.isJsxAttributes));
        }
        function visitJsxJsxOpeningElement(node) {
          return ts2.updateJsxOpeningElement(node, ts2.visitNode(node.tagName, visitor, ts2.isJsxTagNameExpression), void 0, ts2.visitNode(node.attributes, visitor, ts2.isJsxAttributes));
        }
        function shouldEmitEnumDeclaration(node) {
          return !ts2.isEnumConst(node) || compilerOptions.preserveConstEnums || compilerOptions.isolatedModules;
        }
        function visitEnumDeclaration(node) {
          if (!shouldEmitEnumDeclaration(node)) {
            return ts2.createNotEmittedStatement(node);
          }
          var statements = [];
          var emitFlags = 2;
          var varAdded = addVarForEnumOrModuleDeclaration(statements, node);
          if (varAdded) {
            if (moduleKind !== ts2.ModuleKind.System || currentLexicalScope !== currentSourceFile) {
              emitFlags |= 512;
            }
          }
          var parameterName = getNamespaceParameterName(node);
          var containerName = getNamespaceContainerName(node);
          var exportName = ts2.hasModifier(node, 1) ? ts2.getExternalModuleOrNamespaceExportName(currentNamespaceContainerName, node, false, true) : ts2.getLocalName(node, false, true);
          var moduleArg = ts2.createLogicalOr(exportName, ts2.createAssignment(exportName, ts2.createObjectLiteral()));
          if (hasNamespaceQualifiedExportName(node)) {
            var localName = ts2.getLocalName(node, false, true);
            moduleArg = ts2.createAssignment(localName, moduleArg);
          }
          var enumStatement = ts2.createExpressionStatement(ts2.createCall(ts2.createFunctionExpression(void 0, void 0, void 0, void 0, [ts2.createParameter(void 0, void 0, void 0, parameterName)], void 0, transformEnumBody(node, containerName)), void 0, [moduleArg]));
          ts2.setOriginalNode(enumStatement, node);
          if (varAdded) {
            ts2.setSyntheticLeadingComments(enumStatement, void 0);
            ts2.setSyntheticTrailingComments(enumStatement, void 0);
          }
          ts2.setTextRange(enumStatement, node);
          ts2.addEmitFlags(enumStatement, emitFlags);
          statements.push(enumStatement);
          statements.push(ts2.createEndOfDeclarationMarker(node));
          return statements;
        }
        function transformEnumBody(node, localName) {
          var savedCurrentNamespaceLocalName = currentNamespaceContainerName;
          currentNamespaceContainerName = localName;
          var statements = [];
          startLexicalEnvironment();
          var members = ts2.map(node.members, transformEnumMember);
          ts2.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          ts2.addRange(statements, members);
          currentNamespaceContainerName = savedCurrentNamespaceLocalName;
          return ts2.createBlock(ts2.setTextRange(ts2.createNodeArray(statements), node.members), true);
        }
        function transformEnumMember(member) {
          var name = getExpressionForPropertyName(member, false);
          var valueExpression = transformEnumMemberDeclarationValue(member);
          var innerAssignment = ts2.createAssignment(ts2.createElementAccess(currentNamespaceContainerName, name), valueExpression);
          var outerAssignment = valueExpression.kind === 10 ? innerAssignment : ts2.createAssignment(ts2.createElementAccess(currentNamespaceContainerName, innerAssignment), name);
          return ts2.setTextRange(ts2.createExpressionStatement(ts2.setTextRange(outerAssignment, member)), member);
        }
        function transformEnumMemberDeclarationValue(member) {
          var value = resolver.getConstantValue(member);
          if (value !== void 0) {
            return ts2.createLiteral(value);
          } else {
            enableSubstitutionForNonQualifiedEnumMembers();
            if (member.initializer) {
              return ts2.visitNode(member.initializer, visitor, ts2.isExpression);
            } else {
              return ts2.createVoidZero();
            }
          }
        }
        function shouldEmitModuleDeclaration(nodeIn) {
          var node = ts2.getParseTreeNode(nodeIn, ts2.isModuleDeclaration);
          if (!node) {
            return true;
          }
          return ts2.isInstantiatedModule(node, !!compilerOptions.preserveConstEnums || !!compilerOptions.isolatedModules);
        }
        function hasNamespaceQualifiedExportName(node) {
          return isExportOfNamespace(node) || isExternalModuleExport(node) && moduleKind !== ts2.ModuleKind.ES2015 && moduleKind !== ts2.ModuleKind.ES2020 && moduleKind !== ts2.ModuleKind.ESNext && moduleKind !== ts2.ModuleKind.System;
        }
        function recordEmittedDeclarationInScope(node) {
          if (!currentScopeFirstDeclarationsOfName) {
            currentScopeFirstDeclarationsOfName = ts2.createUnderscoreEscapedMap();
          }
          var name = declaredNameInScope(node);
          if (!currentScopeFirstDeclarationsOfName.has(name)) {
            currentScopeFirstDeclarationsOfName.set(name, node);
          }
        }
        function isFirstEmittedDeclarationInScope(node) {
          if (currentScopeFirstDeclarationsOfName) {
            var name = declaredNameInScope(node);
            return currentScopeFirstDeclarationsOfName.get(name) === node;
          }
          return true;
        }
        function declaredNameInScope(node) {
          ts2.Debug.assertNode(node.name, ts2.isIdentifier);
          return node.name.escapedText;
        }
        function addVarForEnumOrModuleDeclaration(statements, node) {
          var statement = ts2.createVariableStatement(ts2.visitNodes(node.modifiers, modifierVisitor, ts2.isModifier), ts2.createVariableDeclarationList([
            ts2.createVariableDeclaration(ts2.getLocalName(node, false, true))
          ], currentLexicalScope.kind === 290 ? 0 : 1));
          ts2.setOriginalNode(statement, node);
          recordEmittedDeclarationInScope(node);
          if (isFirstEmittedDeclarationInScope(node)) {
            if (node.kind === 248) {
              ts2.setSourceMapRange(statement.declarationList, node);
            } else {
              ts2.setSourceMapRange(statement, node);
            }
            ts2.setCommentRange(statement, node);
            ts2.addEmitFlags(statement, 1024 | 4194304);
            statements.push(statement);
            return true;
          } else {
            var mergeMarker = ts2.createMergeDeclarationMarker(statement);
            ts2.setEmitFlags(mergeMarker, 1536 | 4194304);
            statements.push(mergeMarker);
            return false;
          }
        }
        function visitModuleDeclaration(node) {
          if (!shouldEmitModuleDeclaration(node)) {
            return ts2.createNotEmittedStatement(node);
          }
          ts2.Debug.assertNode(node.name, ts2.isIdentifier, "A TypeScript namespace should have an Identifier name.");
          enableSubstitutionForNamespaceExports();
          var statements = [];
          var emitFlags = 2;
          var varAdded = addVarForEnumOrModuleDeclaration(statements, node);
          if (varAdded) {
            if (moduleKind !== ts2.ModuleKind.System || currentLexicalScope !== currentSourceFile) {
              emitFlags |= 512;
            }
          }
          var parameterName = getNamespaceParameterName(node);
          var containerName = getNamespaceContainerName(node);
          var exportName = ts2.hasModifier(node, 1) ? ts2.getExternalModuleOrNamespaceExportName(currentNamespaceContainerName, node, false, true) : ts2.getLocalName(node, false, true);
          var moduleArg = ts2.createLogicalOr(exportName, ts2.createAssignment(exportName, ts2.createObjectLiteral()));
          if (hasNamespaceQualifiedExportName(node)) {
            var localName = ts2.getLocalName(node, false, true);
            moduleArg = ts2.createAssignment(localName, moduleArg);
          }
          var moduleStatement = ts2.createExpressionStatement(ts2.createCall(ts2.createFunctionExpression(void 0, void 0, void 0, void 0, [ts2.createParameter(void 0, void 0, void 0, parameterName)], void 0, transformModuleBody(node, containerName)), void 0, [moduleArg]));
          ts2.setOriginalNode(moduleStatement, node);
          if (varAdded) {
            ts2.setSyntheticLeadingComments(moduleStatement, void 0);
            ts2.setSyntheticTrailingComments(moduleStatement, void 0);
          }
          ts2.setTextRange(moduleStatement, node);
          ts2.addEmitFlags(moduleStatement, emitFlags);
          statements.push(moduleStatement);
          statements.push(ts2.createEndOfDeclarationMarker(node));
          return statements;
        }
        function transformModuleBody(node, namespaceLocalName) {
          var savedCurrentNamespaceContainerName = currentNamespaceContainerName;
          var savedCurrentNamespace = currentNamespace;
          var savedCurrentScopeFirstDeclarationsOfName = currentScopeFirstDeclarationsOfName;
          currentNamespaceContainerName = namespaceLocalName;
          currentNamespace = node;
          currentScopeFirstDeclarationsOfName = void 0;
          var statements = [];
          startLexicalEnvironment();
          var statementsLocation;
          var blockLocation;
          if (node.body) {
            if (node.body.kind === 250) {
              saveStateAndInvoke(node.body, function(body) {
                return ts2.addRange(statements, ts2.visitNodes(body.statements, namespaceElementVisitor, ts2.isStatement));
              });
              statementsLocation = node.body.statements;
              blockLocation = node.body;
            } else {
              var result = visitModuleDeclaration(node.body);
              if (result) {
                if (ts2.isArray(result)) {
                  ts2.addRange(statements, result);
                } else {
                  statements.push(result);
                }
              }
              var moduleBlock = getInnerMostModuleDeclarationFromDottedModule(node).body;
              statementsLocation = ts2.moveRangePos(moduleBlock.statements, -1);
            }
          }
          ts2.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          currentNamespaceContainerName = savedCurrentNamespaceContainerName;
          currentNamespace = savedCurrentNamespace;
          currentScopeFirstDeclarationsOfName = savedCurrentScopeFirstDeclarationsOfName;
          var block = ts2.createBlock(ts2.setTextRange(ts2.createNodeArray(statements), statementsLocation), true);
          ts2.setTextRange(block, blockLocation);
          if (!node.body || node.body.kind !== 250) {
            ts2.setEmitFlags(block, ts2.getEmitFlags(block) | 1536);
          }
          return block;
        }
        function getInnerMostModuleDeclarationFromDottedModule(moduleDeclaration) {
          if (moduleDeclaration.body.kind === 249) {
            var recursiveInnerModule = getInnerMostModuleDeclarationFromDottedModule(moduleDeclaration.body);
            return recursiveInnerModule || moduleDeclaration.body;
          }
        }
        function visitImportDeclaration(node) {
          if (!node.importClause) {
            return node;
          }
          if (node.importClause.isTypeOnly) {
            return void 0;
          }
          var importClause = ts2.visitNode(node.importClause, visitImportClause, ts2.isImportClause);
          return importClause || compilerOptions.importsNotUsedAsValues === 1 || compilerOptions.importsNotUsedAsValues === 2 ? ts2.updateImportDeclaration(node, void 0, void 0, importClause, node.moduleSpecifier) : void 0;
        }
        function visitImportClause(node) {
          if (node.isTypeOnly) {
            return void 0;
          }
          var name = resolver.isReferencedAliasDeclaration(node) ? node.name : void 0;
          var namedBindings = ts2.visitNode(node.namedBindings, visitNamedImportBindings, ts2.isNamedImportBindings);
          return name || namedBindings ? ts2.updateImportClause(node, name, namedBindings, false) : void 0;
        }
        function visitNamedImportBindings(node) {
          if (node.kind === 256) {
            return resolver.isReferencedAliasDeclaration(node) ? node : void 0;
          } else {
            var elements = ts2.visitNodes(node.elements, visitImportSpecifier, ts2.isImportSpecifier);
            return ts2.some(elements) ? ts2.updateNamedImports(node, elements) : void 0;
          }
        }
        function visitImportSpecifier(node) {
          return resolver.isReferencedAliasDeclaration(node) ? node : void 0;
        }
        function visitExportAssignment(node) {
          return resolver.isValueAliasDeclaration(node) ? ts2.visitEachChild(node, visitor, context) : void 0;
        }
        function visitExportDeclaration(node) {
          if (node.isTypeOnly) {
            return void 0;
          }
          if (!node.exportClause || ts2.isNamespaceExport(node.exportClause)) {
            return node;
          }
          if (!resolver.isValueAliasDeclaration(node)) {
            return void 0;
          }
          var exportClause = ts2.visitNode(node.exportClause, visitNamedExportBindings, ts2.isNamedExportBindings);
          return exportClause ? ts2.updateExportDeclaration(node, void 0, void 0, exportClause, node.moduleSpecifier, node.isTypeOnly) : void 0;
        }
        function visitNamedExports(node) {
          var elements = ts2.visitNodes(node.elements, visitExportSpecifier, ts2.isExportSpecifier);
          return ts2.some(elements) ? ts2.updateNamedExports(node, elements) : void 0;
        }
        function visitNamespaceExports(node) {
          return ts2.updateNamespaceExport(node, ts2.visitNode(node.name, visitor, ts2.isIdentifier));
        }
        function visitNamedExportBindings(node) {
          return ts2.isNamespaceExport(node) ? visitNamespaceExports(node) : visitNamedExports(node);
        }
        function visitExportSpecifier(node) {
          return resolver.isValueAliasDeclaration(node) ? node : void 0;
        }
        function shouldEmitImportEqualsDeclaration(node) {
          return resolver.isReferencedAliasDeclaration(node) || !ts2.isExternalModule(currentSourceFile) && resolver.isTopLevelValueImportEqualsWithEntityName(node);
        }
        function visitImportEqualsDeclaration(node) {
          if (ts2.isExternalModuleImportEqualsDeclaration(node)) {
            var isReferenced = resolver.isReferencedAliasDeclaration(node);
            if (!isReferenced && compilerOptions.importsNotUsedAsValues === 1) {
              return ts2.setOriginalNode(ts2.setTextRange(ts2.createImportDeclaration(void 0, void 0, void 0, node.moduleReference.expression), node), node);
            }
            return isReferenced ? ts2.visitEachChild(node, visitor, context) : void 0;
          }
          if (!shouldEmitImportEqualsDeclaration(node)) {
            return void 0;
          }
          var moduleReference = ts2.createExpressionFromEntityName(node.moduleReference);
          ts2.setEmitFlags(moduleReference, 1536 | 2048);
          if (isNamedExternalModuleExport(node) || !isExportOfNamespace(node)) {
            return ts2.setOriginalNode(ts2.setTextRange(ts2.createVariableStatement(ts2.visitNodes(node.modifiers, modifierVisitor, ts2.isModifier), ts2.createVariableDeclarationList([
              ts2.setOriginalNode(ts2.createVariableDeclaration(node.name, void 0, moduleReference), node)
            ])), node), node);
          } else {
            return ts2.setOriginalNode(createNamespaceExport(node.name, moduleReference, node), node);
          }
        }
        function isExportOfNamespace(node) {
          return currentNamespace !== void 0 && ts2.hasModifier(node, 1);
        }
        function isExternalModuleExport(node) {
          return currentNamespace === void 0 && ts2.hasModifier(node, 1);
        }
        function isNamedExternalModuleExport(node) {
          return isExternalModuleExport(node) && !ts2.hasModifier(node, 512);
        }
        function isDefaultExternalModuleExport(node) {
          return isExternalModuleExport(node) && ts2.hasModifier(node, 512);
        }
        function expressionToStatement(expression) {
          return ts2.createExpressionStatement(expression);
        }
        function addExportMemberAssignment(statements, node) {
          var expression = ts2.createAssignment(ts2.getExternalModuleOrNamespaceExportName(currentNamespaceContainerName, node, false, true), ts2.getLocalName(node));
          ts2.setSourceMapRange(expression, ts2.createRange(node.name ? node.name.pos : node.pos, node.end));
          var statement = ts2.createExpressionStatement(expression);
          ts2.setSourceMapRange(statement, ts2.createRange(-1, node.end));
          statements.push(statement);
        }
        function createNamespaceExport(exportName, exportValue, location) {
          return ts2.setTextRange(ts2.createExpressionStatement(ts2.createAssignment(ts2.getNamespaceMemberName(currentNamespaceContainerName, exportName, false, true), exportValue)), location);
        }
        function createNamespaceExportExpression(exportName, exportValue, location) {
          return ts2.setTextRange(ts2.createAssignment(getNamespaceMemberNameWithSourceMapsAndWithoutComments(exportName), exportValue), location);
        }
        function getNamespaceMemberNameWithSourceMapsAndWithoutComments(name) {
          return ts2.getNamespaceMemberName(currentNamespaceContainerName, name, false, true);
        }
        function getNamespaceParameterName(node) {
          var name = ts2.getGeneratedNameForNode(node);
          ts2.setSourceMapRange(name, node.name);
          return name;
        }
        function getNamespaceContainerName(node) {
          return ts2.getGeneratedNameForNode(node);
        }
        function getClassAliasIfNeeded(node) {
          if (resolver.getNodeCheckFlags(node) & 16777216) {
            enableSubstitutionForClassAliases();
            var classAlias = ts2.createUniqueName(node.name && !ts2.isGeneratedIdentifier(node.name) ? ts2.idText(node.name) : "default");
            classAliases[ts2.getOriginalNodeId(node)] = classAlias;
            hoistVariableDeclaration(classAlias);
            return classAlias;
          }
        }
        function getClassPrototype(node) {
          return ts2.createPropertyAccess(ts2.getDeclarationName(node), "prototype");
        }
        function getClassMemberPrefix(node, member) {
          return ts2.hasModifier(member, 32) ? ts2.getDeclarationName(node) : getClassPrototype(node);
        }
        function enableSubstitutionForNonQualifiedEnumMembers() {
          if ((enabledSubstitutions & 8) === 0) {
            enabledSubstitutions |= 8;
            context.enableSubstitution(75);
          }
        }
        function enableSubstitutionForClassAliases() {
          if ((enabledSubstitutions & 1) === 0) {
            enabledSubstitutions |= 1;
            context.enableSubstitution(75);
            classAliases = [];
          }
        }
        function enableSubstitutionForNamespaceExports() {
          if ((enabledSubstitutions & 2) === 0) {
            enabledSubstitutions |= 2;
            context.enableSubstitution(75);
            context.enableSubstitution(282);
            context.enableEmitNotification(249);
          }
        }
        function isTransformedModuleDeclaration(node) {
          return ts2.getOriginalNode(node).kind === 249;
        }
        function isTransformedEnumDeclaration(node) {
          return ts2.getOriginalNode(node).kind === 248;
        }
        function onEmitNode(hint, node, emitCallback) {
          var savedApplicableSubstitutions = applicableSubstitutions;
          var savedCurrentSourceFile = currentSourceFile;
          if (ts2.isSourceFile(node)) {
            currentSourceFile = node;
          }
          if (enabledSubstitutions & 2 && isTransformedModuleDeclaration(node)) {
            applicableSubstitutions |= 2;
          }
          if (enabledSubstitutions & 8 && isTransformedEnumDeclaration(node)) {
            applicableSubstitutions |= 8;
          }
          previousOnEmitNode(hint, node, emitCallback);
          applicableSubstitutions = savedApplicableSubstitutions;
          currentSourceFile = savedCurrentSourceFile;
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (hint === 1) {
            return substituteExpression(node);
          } else if (ts2.isShorthandPropertyAssignment(node)) {
            return substituteShorthandPropertyAssignment(node);
          }
          return node;
        }
        function substituteShorthandPropertyAssignment(node) {
          if (enabledSubstitutions & 2) {
            var name = node.name;
            var exportedName = trySubstituteNamespaceExportedName(name);
            if (exportedName) {
              if (node.objectAssignmentInitializer) {
                var initializer = ts2.createAssignment(exportedName, node.objectAssignmentInitializer);
                return ts2.setTextRange(ts2.createPropertyAssignment(name, initializer), node);
              }
              return ts2.setTextRange(ts2.createPropertyAssignment(name, exportedName), node);
            }
          }
          return node;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 75:
              return substituteExpressionIdentifier(node);
            case 194:
              return substitutePropertyAccessExpression(node);
            case 195:
              return substituteElementAccessExpression(node);
          }
          return node;
        }
        function substituteExpressionIdentifier(node) {
          return trySubstituteClassAlias(node) || trySubstituteNamespaceExportedName(node) || node;
        }
        function trySubstituteClassAlias(node) {
          if (enabledSubstitutions & 1) {
            if (resolver.getNodeCheckFlags(node) & 33554432) {
              var declaration = resolver.getReferencedValueDeclaration(node);
              if (declaration) {
                var classAlias = classAliases[declaration.id];
                if (classAlias) {
                  var clone_1 = ts2.getSynthesizedClone(classAlias);
                  ts2.setSourceMapRange(clone_1, node);
                  ts2.setCommentRange(clone_1, node);
                  return clone_1;
                }
              }
            }
          }
          return void 0;
        }
        function trySubstituteNamespaceExportedName(node) {
          if (enabledSubstitutions & applicableSubstitutions && !ts2.isGeneratedIdentifier(node) && !ts2.isLocalName(node)) {
            var container = resolver.getReferencedExportContainer(node, false);
            if (container && container.kind !== 290) {
              var substitute = applicableSubstitutions & 2 && container.kind === 249 || applicableSubstitutions & 8 && container.kind === 248;
              if (substitute) {
                return ts2.setTextRange(ts2.createPropertyAccess(ts2.getGeneratedNameForNode(container), node), node);
              }
            }
          }
          return void 0;
        }
        function substitutePropertyAccessExpression(node) {
          return substituteConstantValue(node);
        }
        function substituteElementAccessExpression(node) {
          return substituteConstantValue(node);
        }
        function substituteConstantValue(node) {
          var constantValue = tryGetConstEnumValue(node);
          if (constantValue !== void 0) {
            ts2.setConstantValue(node, constantValue);
            var substitute = ts2.createLiteral(constantValue);
            if (!compilerOptions.removeComments) {
              var originalNode = ts2.getOriginalNode(node, ts2.isAccessExpression);
              var propertyName = ts2.isPropertyAccessExpression(originalNode) ? ts2.declarationNameToString(originalNode.name) : ts2.getTextOfNode(originalNode.argumentExpression);
              ts2.addSyntheticTrailingComment(substitute, 3, " " + propertyName + " ");
            }
            return substitute;
          }
          return node;
        }
        function tryGetConstEnumValue(node) {
          if (compilerOptions.isolatedModules) {
            return void 0;
          }
          return ts2.isPropertyAccessExpression(node) || ts2.isElementAccessExpression(node) ? resolver.getConstantValue(node) : void 0;
        }
      }
      ts2.transformTypeScript = transformTypeScript;
      function createDecorateHelper(context, decoratorExpressions, target, memberName, descriptor, location) {
        var argumentsArray = [];
        argumentsArray.push(ts2.createArrayLiteral(decoratorExpressions, true));
        argumentsArray.push(target);
        if (memberName) {
          argumentsArray.push(memberName);
          if (descriptor) {
            argumentsArray.push(descriptor);
          }
        }
        context.requestEmitHelper(ts2.decorateHelper);
        return ts2.setTextRange(ts2.createCall(ts2.getUnscopedHelperName("__decorate"), void 0, argumentsArray), location);
      }
      ts2.decorateHelper = {
        name: "typescript:decorate",
        importName: "__decorate",
        scoped: false,
        priority: 2,
        text: '\n            var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {\n                var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;\n                if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);\n                else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;\n                return c > 3 && r && Object.defineProperty(target, key, r), r;\n            };'
      };
      function createMetadataHelper(context, metadataKey, metadataValue) {
        context.requestEmitHelper(ts2.metadataHelper);
        return ts2.createCall(ts2.getUnscopedHelperName("__metadata"), void 0, [
          ts2.createLiteral(metadataKey),
          metadataValue
        ]);
      }
      ts2.metadataHelper = {
        name: "typescript:metadata",
        importName: "__metadata",
        scoped: false,
        priority: 3,
        text: '\n            var __metadata = (this && this.__metadata) || function (k, v) {\n                if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);\n            };'
      };
      function createParamHelper(context, expression, parameterOffset, location) {
        context.requestEmitHelper(ts2.paramHelper);
        return ts2.setTextRange(ts2.createCall(ts2.getUnscopedHelperName("__param"), void 0, [
          ts2.createLiteral(parameterOffset),
          expression
        ]), location);
      }
      ts2.paramHelper = {
        name: "typescript:param",
        importName: "__param",
        scoped: false,
        priority: 4,
        text: "\n            var __param = (this && this.__param) || function (paramIndex, decorator) {\n                return function (target, key) { decorator(target, key, paramIndex); }\n            };"
      };
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var ClassPropertySubstitutionFlags;
      (function(ClassPropertySubstitutionFlags2) {
        ClassPropertySubstitutionFlags2[ClassPropertySubstitutionFlags2["ClassAliases"] = 1] = "ClassAliases";
      })(ClassPropertySubstitutionFlags || (ClassPropertySubstitutionFlags = {}));
      var PrivateIdentifierPlacement;
      (function(PrivateIdentifierPlacement2) {
        PrivateIdentifierPlacement2[PrivateIdentifierPlacement2["InstanceField"] = 0] = "InstanceField";
      })(PrivateIdentifierPlacement || (PrivateIdentifierPlacement = {}));
      function transformClassFields(context) {
        var hoistVariableDeclaration = context.hoistVariableDeclaration, endLexicalEnvironment = context.endLexicalEnvironment, resumeLexicalEnvironment = context.resumeLexicalEnvironment;
        var resolver = context.getEmitResolver();
        var compilerOptions = context.getCompilerOptions();
        var languageVersion = ts2.getEmitScriptTarget(compilerOptions);
        var shouldTransformPrivateFields = languageVersion < 99;
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onSubstituteNode = onSubstituteNode;
        var enabledSubstitutions;
        var classAliases;
        var pendingExpressions;
        var pendingStatements;
        var privateIdentifierEnvironmentStack = [];
        var currentPrivateIdentifierEnvironment;
        return ts2.chainBundle(transformSourceFile);
        function transformSourceFile(node) {
          var options = context.getCompilerOptions();
          if (node.isDeclarationFile || options.useDefineForClassFields && options.target === 99) {
            return node;
          }
          var visited = ts2.visitEachChild(node, visitor, context);
          ts2.addEmitHelpers(visited, context.readEmitHelpers());
          return visited;
        }
        function visitor(node) {
          if (!(node.transformFlags & 4194304))
            return node;
          switch (node.kind) {
            case 214:
            case 245:
              return visitClassLike(node);
            case 159:
              return visitPropertyDeclaration(node);
            case 225:
              return visitVariableStatement(node);
            case 154:
              return visitComputedPropertyName(node);
            case 194:
              return visitPropertyAccessExpression(node);
            case 207:
              return visitPrefixUnaryExpression(node);
            case 208:
              return visitPostfixUnaryExpression(node, false);
            case 196:
              return visitCallExpression(node);
            case 209:
              return visitBinaryExpression(node);
            case 76:
              return visitPrivateIdentifier(node);
            case 226:
              return visitExpressionStatement(node);
            case 230:
              return visitForStatement(node);
            case 198:
              return visitTaggedTemplateExpression(node);
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitorDestructuringTarget(node) {
          switch (node.kind) {
            case 193:
            case 192:
              return visitAssignmentPattern(node);
            default:
              return visitor(node);
          }
        }
        function visitPrivateIdentifier(node) {
          if (!shouldTransformPrivateFields) {
            return node;
          }
          return ts2.setOriginalNode(ts2.createIdentifier(""), node);
        }
        function classElementVisitor(node) {
          switch (node.kind) {
            case 162:
              return void 0;
            case 163:
            case 164:
            case 161:
              return ts2.visitEachChild(node, classElementVisitor, context);
            case 159:
              return visitPropertyDeclaration(node);
            case 154:
              return visitComputedPropertyName(node);
            case 222:
              return node;
            default:
              return visitor(node);
          }
        }
        function visitVariableStatement(node) {
          var savedPendingStatements = pendingStatements;
          pendingStatements = [];
          var visitedNode = ts2.visitEachChild(node, visitor, context);
          var statement = ts2.some(pendingStatements) ? __spreadArrays([visitedNode], pendingStatements) : visitedNode;
          pendingStatements = savedPendingStatements;
          return statement;
        }
        function visitComputedPropertyName(name) {
          var node = ts2.visitEachChild(name, visitor, context);
          if (ts2.some(pendingExpressions)) {
            var expressions = pendingExpressions;
            expressions.push(name.expression);
            pendingExpressions = [];
            node = ts2.updateComputedPropertyName(node, ts2.inlineExpressions(expressions));
          }
          return node;
        }
        function visitPropertyDeclaration(node) {
          ts2.Debug.assert(!ts2.some(node.decorators));
          if (!shouldTransformPrivateFields && ts2.isPrivateIdentifier(node.name)) {
            return ts2.updateProperty(node, void 0, ts2.visitNodes(node.modifiers, visitor, ts2.isModifier), node.name, void 0, void 0, void 0);
          }
          var expr = getPropertyNameExpressionIfNeeded(node.name, !!node.initializer || !!context.getCompilerOptions().useDefineForClassFields);
          if (expr && !ts2.isSimpleInlineableExpression(expr)) {
            (pendingExpressions || (pendingExpressions = [])).push(expr);
          }
          return void 0;
        }
        function createPrivateIdentifierAccess(info, receiver) {
          receiver = ts2.visitNode(receiver, visitor, ts2.isExpression);
          switch (info.placement) {
            case 0:
              return createClassPrivateFieldGetHelper(context, ts2.nodeIsSynthesized(receiver) ? receiver : ts2.getSynthesizedClone(receiver), info.weakMapName);
            default:
              return ts2.Debug.fail("Unexpected private identifier placement");
          }
        }
        function visitPropertyAccessExpression(node) {
          if (shouldTransformPrivateFields && ts2.isPrivateIdentifier(node.name)) {
            var privateIdentifierInfo = accessPrivateIdentifier(node.name);
            if (privateIdentifierInfo) {
              return ts2.setOriginalNode(createPrivateIdentifierAccess(privateIdentifierInfo, node.expression), node);
            }
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitPrefixUnaryExpression(node) {
          if (shouldTransformPrivateFields && ts2.isPrivateIdentifierPropertyAccessExpression(node.operand)) {
            var operator = node.operator === 45 ? 39 : node.operator === 46 ? 40 : void 0;
            var info = void 0;
            if (operator && (info = accessPrivateIdentifier(node.operand.name))) {
              var receiver = ts2.visitNode(node.operand.expression, visitor, ts2.isExpression);
              var _a = createCopiableReceiverExpr(receiver), readExpression = _a.readExpression, initializeExpression = _a.initializeExpression;
              var existingValue = ts2.createPrefix(39, createPrivateIdentifierAccess(info, readExpression));
              return ts2.setOriginalNode(createPrivateIdentifierAssignment(info, initializeExpression || readExpression, ts2.createBinary(existingValue, operator, ts2.createLiteral(1)), 62), node);
            }
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitPostfixUnaryExpression(node, valueIsDiscarded) {
          if (shouldTransformPrivateFields && ts2.isPrivateIdentifierPropertyAccessExpression(node.operand)) {
            var operator = node.operator === 45 ? 39 : node.operator === 46 ? 40 : void 0;
            var info = void 0;
            if (operator && (info = accessPrivateIdentifier(node.operand.name))) {
              var receiver = ts2.visitNode(node.operand.expression, visitor, ts2.isExpression);
              var _a = createCopiableReceiverExpr(receiver), readExpression = _a.readExpression, initializeExpression = _a.initializeExpression;
              var existingValue = ts2.createPrefix(39, createPrivateIdentifierAccess(info, readExpression));
              var returnValue = valueIsDiscarded ? void 0 : ts2.createTempVariable(hoistVariableDeclaration);
              return ts2.setOriginalNode(ts2.inlineExpressions(ts2.compact([
                createPrivateIdentifierAssignment(info, initializeExpression || readExpression, ts2.createBinary(returnValue ? ts2.createAssignment(returnValue, existingValue) : existingValue, operator, ts2.createLiteral(1)), 62),
                returnValue
              ])), node);
            }
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitForStatement(node) {
          if (node.incrementor && ts2.isPostfixUnaryExpression(node.incrementor)) {
            return ts2.updateFor(node, ts2.visitNode(node.initializer, visitor, ts2.isForInitializer), ts2.visitNode(node.condition, visitor, ts2.isExpression), visitPostfixUnaryExpression(node.incrementor, true), ts2.visitNode(node.statement, visitor, ts2.isStatement));
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitExpressionStatement(node) {
          if (ts2.isPostfixUnaryExpression(node.expression)) {
            return ts2.updateExpressionStatement(node, visitPostfixUnaryExpression(node.expression, true));
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function createCopiableReceiverExpr(receiver) {
          var clone = ts2.nodeIsSynthesized(receiver) ? receiver : ts2.getSynthesizedClone(receiver);
          if (ts2.isSimpleInlineableExpression(receiver)) {
            return { readExpression: clone, initializeExpression: void 0 };
          }
          var readExpression = ts2.createTempVariable(hoistVariableDeclaration);
          var initializeExpression = ts2.createAssignment(readExpression, clone);
          return { readExpression, initializeExpression };
        }
        function visitCallExpression(node) {
          if (shouldTransformPrivateFields && ts2.isPrivateIdentifierPropertyAccessExpression(node.expression)) {
            var _a = ts2.createCallBinding(node.expression, hoistVariableDeclaration, languageVersion), thisArg = _a.thisArg, target = _a.target;
            return ts2.updateCall(node, ts2.createPropertyAccess(ts2.visitNode(target, visitor), "call"), void 0, __spreadArrays([ts2.visitNode(thisArg, visitor, ts2.isExpression)], ts2.visitNodes(node.arguments, visitor, ts2.isExpression)));
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitTaggedTemplateExpression(node) {
          if (shouldTransformPrivateFields && ts2.isPrivateIdentifierPropertyAccessExpression(node.tag)) {
            var _a = ts2.createCallBinding(node.tag, hoistVariableDeclaration, languageVersion), thisArg = _a.thisArg, target = _a.target;
            return ts2.updateTaggedTemplate(node, ts2.createCall(ts2.createPropertyAccess(ts2.visitNode(target, visitor), "bind"), void 0, [ts2.visitNode(thisArg, visitor, ts2.isExpression)]), ts2.visitNode(node.template, visitor, ts2.isTemplateLiteral));
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitBinaryExpression(node) {
          if (shouldTransformPrivateFields) {
            if (ts2.isDestructuringAssignment(node)) {
              var savedPendingExpressions = pendingExpressions;
              pendingExpressions = void 0;
              node = ts2.updateBinary(node, ts2.visitNode(node.left, visitorDestructuringTarget), ts2.visitNode(node.right, visitor), node.operatorToken);
              var expr = ts2.some(pendingExpressions) ? ts2.inlineExpressions(ts2.compact(__spreadArrays(pendingExpressions, [node]))) : node;
              pendingExpressions = savedPendingExpressions;
              return expr;
            }
            if (ts2.isAssignmentExpression(node) && ts2.isPrivateIdentifierPropertyAccessExpression(node.left)) {
              var info = accessPrivateIdentifier(node.left.name);
              if (info) {
                return ts2.setOriginalNode(createPrivateIdentifierAssignment(info, node.left.expression, node.right, node.operatorToken.kind), node);
              }
            }
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function createPrivateIdentifierAssignment(info, receiver, right, operator) {
          switch (info.placement) {
            case 0: {
              return createPrivateIdentifierInstanceFieldAssignment(info, receiver, right, operator);
            }
            default:
              return ts2.Debug.fail("Unexpected private identifier placement");
          }
        }
        function createPrivateIdentifierInstanceFieldAssignment(info, receiver, right, operator) {
          receiver = ts2.visitNode(receiver, visitor, ts2.isExpression);
          right = ts2.visitNode(right, visitor, ts2.isExpression);
          if (ts2.isCompoundAssignment(operator)) {
            var _a = createCopiableReceiverExpr(receiver), readExpression = _a.readExpression, initializeExpression = _a.initializeExpression;
            return createClassPrivateFieldSetHelper(context, initializeExpression || readExpression, info.weakMapName, ts2.createBinary(createClassPrivateFieldGetHelper(context, readExpression, info.weakMapName), ts2.getNonAssignmentOperatorForCompoundAssignment(operator), right));
          } else {
            return createClassPrivateFieldSetHelper(context, receiver, info.weakMapName, right);
          }
        }
        function visitClassLike(node) {
          var savedPendingExpressions = pendingExpressions;
          pendingExpressions = void 0;
          if (shouldTransformPrivateFields) {
            startPrivateIdentifierEnvironment();
          }
          var result = ts2.isClassDeclaration(node) ? visitClassDeclaration(node) : visitClassExpression(node);
          if (shouldTransformPrivateFields) {
            endPrivateIdentifierEnvironment();
          }
          pendingExpressions = savedPendingExpressions;
          return result;
        }
        function doesClassElementNeedTransform(node) {
          return ts2.isPropertyDeclaration(node) || shouldTransformPrivateFields && node.name && ts2.isPrivateIdentifier(node.name);
        }
        function visitClassDeclaration(node) {
          if (!ts2.forEach(node.members, doesClassElementNeedTransform)) {
            return ts2.visitEachChild(node, visitor, context);
          }
          var extendsClauseElement = ts2.getEffectiveBaseTypeNode(node);
          var isDerivedClass = !!(extendsClauseElement && ts2.skipOuterExpressions(extendsClauseElement.expression).kind !== 100);
          var statements = [
            ts2.updateClassDeclaration(node, void 0, node.modifiers, node.name, void 0, ts2.visitNodes(node.heritageClauses, visitor, ts2.isHeritageClause), transformClassMembers(node, isDerivedClass))
          ];
          if (ts2.some(pendingExpressions)) {
            statements.push(ts2.createExpressionStatement(ts2.inlineExpressions(pendingExpressions)));
          }
          var staticProperties = ts2.getProperties(node, true, true);
          if (ts2.some(staticProperties)) {
            addPropertyStatements(statements, staticProperties, ts2.getInternalName(node));
          }
          return statements;
        }
        function visitClassExpression(node) {
          if (!ts2.forEach(node.members, doesClassElementNeedTransform)) {
            return ts2.visitEachChild(node, visitor, context);
          }
          var isDecoratedClassDeclaration = ts2.isClassDeclaration(ts2.getOriginalNode(node));
          var staticProperties = ts2.getProperties(node, true, true);
          var extendsClauseElement = ts2.getEffectiveBaseTypeNode(node);
          var isDerivedClass = !!(extendsClauseElement && ts2.skipOuterExpressions(extendsClauseElement.expression).kind !== 100);
          var classExpression = ts2.updateClassExpression(node, node.modifiers, node.name, void 0, ts2.visitNodes(node.heritageClauses, visitor, ts2.isHeritageClause), transformClassMembers(node, isDerivedClass));
          if (ts2.some(staticProperties) || ts2.some(pendingExpressions)) {
            if (isDecoratedClassDeclaration) {
              ts2.Debug.assertIsDefined(pendingStatements, "Decorated classes transformed by TypeScript are expected to be within a variable declaration.");
              if (pendingStatements && pendingExpressions && ts2.some(pendingExpressions)) {
                pendingStatements.push(ts2.createExpressionStatement(ts2.inlineExpressions(pendingExpressions)));
              }
              if (pendingStatements && ts2.some(staticProperties)) {
                addPropertyStatements(pendingStatements, staticProperties, ts2.getInternalName(node));
              }
              return classExpression;
            } else {
              var expressions = [];
              var isClassWithConstructorReference = resolver.getNodeCheckFlags(node) & 16777216;
              var temp = ts2.createTempVariable(hoistVariableDeclaration, !!isClassWithConstructorReference);
              if (isClassWithConstructorReference) {
                enableSubstitutionForClassAliases();
                var alias = ts2.getSynthesizedClone(temp);
                alias.autoGenerateFlags &= ~8;
                classAliases[ts2.getOriginalNodeId(node)] = alias;
              }
              ts2.setEmitFlags(classExpression, 65536 | ts2.getEmitFlags(classExpression));
              expressions.push(ts2.startOnNewLine(ts2.createAssignment(temp, classExpression)));
              ts2.addRange(expressions, ts2.map(pendingExpressions, ts2.startOnNewLine));
              ts2.addRange(expressions, generateInitializedPropertyExpressions(staticProperties, temp));
              expressions.push(ts2.startOnNewLine(temp));
              return ts2.inlineExpressions(expressions);
            }
          }
          return classExpression;
        }
        function transformClassMembers(node, isDerivedClass) {
          if (shouldTransformPrivateFields) {
            for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
              var member = _a[_i];
              if (ts2.isPrivateIdentifierPropertyDeclaration(member)) {
                addPrivateIdentifierToEnvironment(member.name);
              }
            }
          }
          var members = [];
          var constructor = transformConstructor(node, isDerivedClass);
          if (constructor) {
            members.push(constructor);
          }
          ts2.addRange(members, ts2.visitNodes(node.members, classElementVisitor, ts2.isClassElement));
          return ts2.setTextRange(ts2.createNodeArray(members), node.members);
        }
        function isPropertyDeclarationThatRequiresConstructorStatement(member) {
          if (!ts2.isPropertyDeclaration(member) || ts2.hasStaticModifier(member)) {
            return false;
          }
          if (context.getCompilerOptions().useDefineForClassFields) {
            return languageVersion < 99;
          }
          return ts2.isInitializedProperty(member) || shouldTransformPrivateFields && ts2.isPrivateIdentifierPropertyDeclaration(member);
        }
        function transformConstructor(node, isDerivedClass) {
          var constructor = ts2.visitNode(ts2.getFirstConstructorWithBody(node), visitor, ts2.isConstructorDeclaration);
          var properties = node.members.filter(isPropertyDeclarationThatRequiresConstructorStatement);
          if (!ts2.some(properties)) {
            return constructor;
          }
          var parameters = ts2.visitParameterList(constructor ? constructor.parameters : void 0, visitor, context);
          var body = transformConstructorBody(node, constructor, isDerivedClass);
          if (!body) {
            return void 0;
          }
          return ts2.startOnNewLine(ts2.setOriginalNode(ts2.setTextRange(ts2.createConstructor(void 0, void 0, parameters !== null && parameters !== void 0 ? parameters : [], body), constructor || node), constructor));
        }
        function transformConstructorBody(node, constructor, isDerivedClass) {
          var useDefineForClassFields = context.getCompilerOptions().useDefineForClassFields;
          var properties = ts2.getProperties(node, false, false);
          if (!useDefineForClassFields) {
            properties = ts2.filter(properties, function(property) {
              return !!property.initializer || ts2.isPrivateIdentifier(property.name);
            });
          }
          if (!constructor && !ts2.some(properties)) {
            return ts2.visitFunctionBody(void 0, visitor, context);
          }
          resumeLexicalEnvironment();
          var indexOfFirstStatement = 0;
          var statements = [];
          if (!constructor && isDerivedClass) {
            statements.push(ts2.createExpressionStatement(ts2.createCall(ts2.createSuper(), void 0, [ts2.createSpread(ts2.createIdentifier("arguments"))])));
          }
          if (constructor) {
            indexOfFirstStatement = ts2.addPrologueDirectivesAndInitialSuperCall(constructor, statements, visitor);
          }
          if (constructor === null || constructor === void 0 ? void 0 : constructor.body) {
            var afterParameterProperties = ts2.findIndex(constructor.body.statements, function(s) {
              return !ts2.isParameterPropertyDeclaration(ts2.getOriginalNode(s), constructor);
            }, indexOfFirstStatement);
            if (afterParameterProperties === -1) {
              afterParameterProperties = constructor.body.statements.length;
            }
            if (afterParameterProperties > indexOfFirstStatement) {
              if (!useDefineForClassFields) {
                ts2.addRange(statements, ts2.visitNodes(constructor.body.statements, visitor, ts2.isStatement, indexOfFirstStatement, afterParameterProperties - indexOfFirstStatement));
              }
              indexOfFirstStatement = afterParameterProperties;
            }
          }
          addPropertyStatements(statements, properties, ts2.createThis());
          if (constructor) {
            ts2.addRange(statements, ts2.visitNodes(constructor.body.statements, visitor, ts2.isStatement, indexOfFirstStatement));
          }
          statements = ts2.mergeLexicalEnvironment(statements, endLexicalEnvironment());
          return ts2.setTextRange(ts2.createBlock(ts2.setTextRange(ts2.createNodeArray(statements), constructor ? constructor.body.statements : node.members), true), constructor ? constructor.body : void 0);
        }
        function addPropertyStatements(statements, properties, receiver) {
          for (var _i = 0, properties_8 = properties; _i < properties_8.length; _i++) {
            var property = properties_8[_i];
            var expression = transformProperty(property, receiver);
            if (!expression) {
              continue;
            }
            var statement = ts2.createExpressionStatement(expression);
            ts2.setSourceMapRange(statement, ts2.moveRangePastModifiers(property));
            ts2.setCommentRange(statement, property);
            ts2.setOriginalNode(statement, property);
            statements.push(statement);
          }
        }
        function generateInitializedPropertyExpressions(properties, receiver) {
          var expressions = [];
          for (var _i = 0, properties_9 = properties; _i < properties_9.length; _i++) {
            var property = properties_9[_i];
            var expression = transformProperty(property, receiver);
            if (!expression) {
              continue;
            }
            ts2.startOnNewLine(expression);
            ts2.setSourceMapRange(expression, ts2.moveRangePastModifiers(property));
            ts2.setCommentRange(expression, property);
            ts2.setOriginalNode(expression, property);
            expressions.push(expression);
          }
          return expressions;
        }
        function transformProperty(property, receiver) {
          var emitAssignment = !context.getCompilerOptions().useDefineForClassFields;
          var propertyName = ts2.isComputedPropertyName(property.name) && !ts2.isSimpleInlineableExpression(property.name.expression) ? ts2.updateComputedPropertyName(property.name, ts2.getGeneratedNameForNode(property.name)) : property.name;
          if (shouldTransformPrivateFields && ts2.isPrivateIdentifier(propertyName)) {
            var privateIdentifierInfo = accessPrivateIdentifier(propertyName);
            if (privateIdentifierInfo) {
              switch (privateIdentifierInfo.placement) {
                case 0: {
                  return createPrivateInstanceFieldInitializer(receiver, ts2.visitNode(property.initializer, visitor, ts2.isExpression), privateIdentifierInfo.weakMapName);
                }
              }
            } else {
              ts2.Debug.fail("Undeclared private name for property declaration.");
            }
          }
          if (ts2.isPrivateIdentifier(propertyName) && !property.initializer) {
            return void 0;
          }
          if (ts2.isPrivateIdentifier(propertyName) && !property.initializer) {
            return void 0;
          }
          var propertyOriginalNode = ts2.getOriginalNode(property);
          var initializer = property.initializer || emitAssignment ? ts2.visitNode(property.initializer, visitor, ts2.isExpression) : ts2.isParameterPropertyDeclaration(propertyOriginalNode, propertyOriginalNode.parent) && ts2.isIdentifier(propertyName) ? propertyName : ts2.createVoidZero();
          if (emitAssignment || ts2.isPrivateIdentifier(propertyName)) {
            var memberAccess = ts2.createMemberAccessForPropertyName(receiver, propertyName, propertyName);
            return ts2.createAssignment(memberAccess, initializer);
          } else {
            var name = ts2.isComputedPropertyName(propertyName) ? propertyName.expression : ts2.isIdentifier(propertyName) ? ts2.createStringLiteral(ts2.unescapeLeadingUnderscores(propertyName.escapedText)) : propertyName;
            var descriptor = ts2.createPropertyDescriptor({ value: initializer, configurable: true, writable: true, enumerable: true });
            return ts2.createObjectDefinePropertyCall(receiver, name, descriptor);
          }
        }
        function enableSubstitutionForClassAliases() {
          if ((enabledSubstitutions & 1) === 0) {
            enabledSubstitutions |= 1;
            context.enableSubstitution(75);
            classAliases = [];
          }
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (hint === 1) {
            return substituteExpression(node);
          }
          return node;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 75:
              return substituteExpressionIdentifier(node);
          }
          return node;
        }
        function substituteExpressionIdentifier(node) {
          return trySubstituteClassAlias(node) || node;
        }
        function trySubstituteClassAlias(node) {
          if (enabledSubstitutions & 1) {
            if (resolver.getNodeCheckFlags(node) & 33554432) {
              var declaration = resolver.getReferencedValueDeclaration(node);
              if (declaration) {
                var classAlias = classAliases[declaration.id];
                if (classAlias) {
                  var clone_2 = ts2.getSynthesizedClone(classAlias);
                  ts2.setSourceMapRange(clone_2, node);
                  ts2.setCommentRange(clone_2, node);
                  return clone_2;
                }
              }
            }
          }
          return void 0;
        }
        function getPropertyNameExpressionIfNeeded(name, shouldHoist) {
          if (ts2.isComputedPropertyName(name)) {
            var expression = ts2.visitNode(name.expression, visitor, ts2.isExpression);
            var innerExpression = ts2.skipPartiallyEmittedExpressions(expression);
            var inlinable = ts2.isSimpleInlineableExpression(innerExpression);
            var alreadyTransformed = ts2.isAssignmentExpression(innerExpression) && ts2.isGeneratedIdentifier(innerExpression.left);
            if (!alreadyTransformed && !inlinable && shouldHoist) {
              var generatedName = ts2.getGeneratedNameForNode(name);
              hoistVariableDeclaration(generatedName);
              return ts2.createAssignment(generatedName, expression);
            }
            return inlinable || ts2.isIdentifier(innerExpression) ? void 0 : expression;
          }
        }
        function startPrivateIdentifierEnvironment() {
          privateIdentifierEnvironmentStack.push(currentPrivateIdentifierEnvironment);
          currentPrivateIdentifierEnvironment = void 0;
        }
        function endPrivateIdentifierEnvironment() {
          currentPrivateIdentifierEnvironment = privateIdentifierEnvironmentStack.pop();
        }
        function addPrivateIdentifierToEnvironment(name) {
          var text = ts2.getTextOfPropertyName(name);
          var weakMapName = ts2.createOptimisticUniqueName("_" + text.substring(1));
          weakMapName.autoGenerateFlags |= 8;
          hoistVariableDeclaration(weakMapName);
          (currentPrivateIdentifierEnvironment || (currentPrivateIdentifierEnvironment = ts2.createUnderscoreEscapedMap())).set(name.escapedText, { placement: 0, weakMapName });
          (pendingExpressions || (pendingExpressions = [])).push(ts2.createAssignment(weakMapName, ts2.createNew(ts2.createIdentifier("WeakMap"), void 0, [])));
        }
        function accessPrivateIdentifier(name) {
          if (currentPrivateIdentifierEnvironment) {
            var info = currentPrivateIdentifierEnvironment.get(name.escapedText);
            if (info) {
              return info;
            }
          }
          for (var i = privateIdentifierEnvironmentStack.length - 1; i >= 0; --i) {
            var env2 = privateIdentifierEnvironmentStack[i];
            if (!env2) {
              continue;
            }
            var info = env2.get(name.escapedText);
            if (info) {
              return info;
            }
          }
          return void 0;
        }
        function wrapPrivateIdentifierForDestructuringTarget(node) {
          var parameter = ts2.getGeneratedNameForNode(node);
          var info = accessPrivateIdentifier(node.name);
          if (!info) {
            return ts2.visitEachChild(node, visitor, context);
          }
          var receiver = node.expression;
          if (ts2.isThisProperty(node) || ts2.isSuperProperty(node) || !ts2.isSimpleCopiableExpression(node.expression)) {
            receiver = ts2.createTempVariable(hoistVariableDeclaration);
            receiver.autoGenerateFlags |= 8;
            (pendingExpressions || (pendingExpressions = [])).push(ts2.createBinary(receiver, 62, node.expression));
          }
          return ts2.createPropertyAccess(ts2.createParen(ts2.createObjectLiteral([
            ts2.createSetAccessor(void 0, void 0, "value", [ts2.createParameter(void 0, void 0, void 0, parameter, void 0, void 0, void 0)], ts2.createBlock([ts2.createExpressionStatement(createPrivateIdentifierAssignment(info, receiver, parameter, 62))]))
          ])), "value");
        }
        function visitArrayAssignmentTarget(node) {
          var target = ts2.getTargetOfBindingOrAssignmentElement(node);
          if (target && ts2.isPrivateIdentifierPropertyAccessExpression(target)) {
            var wrapped = wrapPrivateIdentifierForDestructuringTarget(target);
            if (ts2.isAssignmentExpression(node)) {
              return ts2.updateBinary(node, wrapped, ts2.visitNode(node.right, visitor, ts2.isExpression), node.operatorToken);
            } else if (ts2.isSpreadElement(node)) {
              return ts2.updateSpread(node, wrapped);
            } else {
              return wrapped;
            }
          }
          return ts2.visitNode(node, visitorDestructuringTarget);
        }
        function visitObjectAssignmentTarget(node) {
          if (ts2.isPropertyAssignment(node)) {
            var target = ts2.getTargetOfBindingOrAssignmentElement(node);
            if (target && ts2.isPrivateIdentifierPropertyAccessExpression(target)) {
              var initializer = ts2.getInitializerOfBindingOrAssignmentElement(node);
              var wrapped = wrapPrivateIdentifierForDestructuringTarget(target);
              return ts2.updatePropertyAssignment(node, ts2.visitNode(node.name, visitor), initializer ? ts2.createAssignment(wrapped, ts2.visitNode(initializer, visitor)) : wrapped);
            }
            return ts2.updatePropertyAssignment(node, ts2.visitNode(node.name, visitor), ts2.visitNode(node.initializer, visitorDestructuringTarget));
          }
          return ts2.visitNode(node, visitor);
        }
        function visitAssignmentPattern(node) {
          if (ts2.isArrayLiteralExpression(node)) {
            return ts2.updateArrayLiteral(node, ts2.visitNodes(node.elements, visitArrayAssignmentTarget, ts2.isExpression));
          } else {
            return ts2.updateObjectLiteral(node, ts2.visitNodes(node.properties, visitObjectAssignmentTarget, ts2.isObjectLiteralElementLike));
          }
        }
      }
      ts2.transformClassFields = transformClassFields;
      function createPrivateInstanceFieldInitializer(receiver, initializer, weakMapName) {
        return ts2.createCall(ts2.createPropertyAccess(weakMapName, "set"), void 0, [receiver, initializer || ts2.createVoidZero()]);
      }
      ts2.classPrivateFieldGetHelper = {
        name: "typescript:classPrivateFieldGet",
        scoped: false,
        text: '\n            var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, privateMap) {\n                if (!privateMap.has(receiver)) {\n                    throw new TypeError("attempted to get private field on non-instance");\n                }\n                return privateMap.get(receiver);\n            };'
      };
      function createClassPrivateFieldGetHelper(context, receiver, privateField) {
        context.requestEmitHelper(ts2.classPrivateFieldGetHelper);
        return ts2.createCall(ts2.getUnscopedHelperName("__classPrivateFieldGet"), void 0, [receiver, privateField]);
      }
      ts2.classPrivateFieldSetHelper = {
        name: "typescript:classPrivateFieldSet",
        scoped: false,
        text: '\n            var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, privateMap, value) {\n                if (!privateMap.has(receiver)) {\n                    throw new TypeError("attempted to set private field on non-instance");\n                }\n                privateMap.set(receiver, value);\n                return value;\n            };'
      };
      function createClassPrivateFieldSetHelper(context, receiver, privateField, value) {
        context.requestEmitHelper(ts2.classPrivateFieldSetHelper);
        return ts2.createCall(ts2.getUnscopedHelperName("__classPrivateFieldSet"), void 0, [receiver, privateField, value]);
      }
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var ES2017SubstitutionFlags;
      (function(ES2017SubstitutionFlags2) {
        ES2017SubstitutionFlags2[ES2017SubstitutionFlags2["AsyncMethodsWithSuper"] = 1] = "AsyncMethodsWithSuper";
      })(ES2017SubstitutionFlags || (ES2017SubstitutionFlags = {}));
      var ContextFlags;
      (function(ContextFlags2) {
        ContextFlags2[ContextFlags2["NonTopLevel"] = 1] = "NonTopLevel";
        ContextFlags2[ContextFlags2["HasLexicalThis"] = 2] = "HasLexicalThis";
      })(ContextFlags || (ContextFlags = {}));
      function transformES2017(context) {
        var resumeLexicalEnvironment = context.resumeLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var resolver = context.getEmitResolver();
        var compilerOptions = context.getCompilerOptions();
        var languageVersion = ts2.getEmitScriptTarget(compilerOptions);
        var enabledSubstitutions;
        var enclosingSuperContainerFlags = 0;
        var enclosingFunctionParameterNames;
        var capturedSuperProperties;
        var hasSuperElementAccess;
        var substitutedSuperAccessors = [];
        var contextFlags = 0;
        var previousOnEmitNode = context.onEmitNode;
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onEmitNode = onEmitNode;
        context.onSubstituteNode = onSubstituteNode;
        return ts2.chainBundle(transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          setContextFlag(1, false);
          setContextFlag(2, !ts2.isEffectiveStrictModeSourceFile(node, compilerOptions));
          var visited = ts2.visitEachChild(node, visitor, context);
          ts2.addEmitHelpers(visited, context.readEmitHelpers());
          return visited;
        }
        function setContextFlag(flag, val) {
          contextFlags = val ? contextFlags | flag : contextFlags & ~flag;
        }
        function inContext(flags) {
          return (contextFlags & flags) !== 0;
        }
        function inTopLevelContext() {
          return !inContext(1);
        }
        function inHasLexicalThisContext() {
          return inContext(2);
        }
        function doWithContext(flags, cb, value) {
          var contextFlagsToSet = flags & ~contextFlags;
          if (contextFlagsToSet) {
            setContextFlag(contextFlagsToSet, true);
            var result = cb(value);
            setContextFlag(contextFlagsToSet, false);
            return result;
          }
          return cb(value);
        }
        function visitDefault(node) {
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitor(node) {
          if ((node.transformFlags & 64) === 0) {
            return node;
          }
          switch (node.kind) {
            case 126:
              return void 0;
            case 206:
              return visitAwaitExpression(node);
            case 161:
              return doWithContext(1 | 2, visitMethodDeclaration, node);
            case 244:
              return doWithContext(1 | 2, visitFunctionDeclaration, node);
            case 201:
              return doWithContext(1 | 2, visitFunctionExpression, node);
            case 202:
              return doWithContext(1, visitArrowFunction, node);
            case 194:
              if (capturedSuperProperties && ts2.isPropertyAccessExpression(node) && node.expression.kind === 102) {
                capturedSuperProperties.set(node.name.escapedText, true);
              }
              return ts2.visitEachChild(node, visitor, context);
            case 195:
              if (capturedSuperProperties && node.expression.kind === 102) {
                hasSuperElementAccess = true;
              }
              return ts2.visitEachChild(node, visitor, context);
            case 163:
            case 164:
            case 162:
            case 245:
            case 214:
              return doWithContext(1 | 2, visitDefault, node);
            default:
              return ts2.visitEachChild(node, visitor, context);
          }
        }
        function asyncBodyVisitor(node) {
          if (ts2.isNodeWithPossibleHoistedDeclaration(node)) {
            switch (node.kind) {
              case 225:
                return visitVariableStatementInAsyncBody(node);
              case 230:
                return visitForStatementInAsyncBody(node);
              case 231:
                return visitForInStatementInAsyncBody(node);
              case 232:
                return visitForOfStatementInAsyncBody(node);
              case 280:
                return visitCatchClauseInAsyncBody(node);
              case 223:
              case 237:
              case 251:
              case 277:
              case 278:
              case 240:
              case 228:
              case 229:
              case 227:
              case 236:
              case 238:
                return ts2.visitEachChild(node, asyncBodyVisitor, context);
              default:
                return ts2.Debug.assertNever(node, "Unhandled node.");
            }
          }
          return visitor(node);
        }
        function visitCatchClauseInAsyncBody(node) {
          var catchClauseNames = ts2.createUnderscoreEscapedMap();
          recordDeclarationName(node.variableDeclaration, catchClauseNames);
          var catchClauseUnshadowedNames;
          catchClauseNames.forEach(function(_, escapedName) {
            if (enclosingFunctionParameterNames.has(escapedName)) {
              if (!catchClauseUnshadowedNames) {
                catchClauseUnshadowedNames = ts2.cloneMap(enclosingFunctionParameterNames);
              }
              catchClauseUnshadowedNames.delete(escapedName);
            }
          });
          if (catchClauseUnshadowedNames) {
            var savedEnclosingFunctionParameterNames = enclosingFunctionParameterNames;
            enclosingFunctionParameterNames = catchClauseUnshadowedNames;
            var result = ts2.visitEachChild(node, asyncBodyVisitor, context);
            enclosingFunctionParameterNames = savedEnclosingFunctionParameterNames;
            return result;
          } else {
            return ts2.visitEachChild(node, asyncBodyVisitor, context);
          }
        }
        function visitVariableStatementInAsyncBody(node) {
          if (isVariableDeclarationListWithCollidingName(node.declarationList)) {
            var expression = visitVariableDeclarationListWithCollidingNames(node.declarationList, false);
            return expression ? ts2.createExpressionStatement(expression) : void 0;
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitForInStatementInAsyncBody(node) {
          return ts2.updateForIn(node, isVariableDeclarationListWithCollidingName(node.initializer) ? visitVariableDeclarationListWithCollidingNames(node.initializer, true) : ts2.visitNode(node.initializer, visitor, ts2.isForInitializer), ts2.visitNode(node.expression, visitor, ts2.isExpression), ts2.visitNode(node.statement, asyncBodyVisitor, ts2.isStatement, ts2.liftToBlock));
        }
        function visitForOfStatementInAsyncBody(node) {
          return ts2.updateForOf(node, ts2.visitNode(node.awaitModifier, visitor, ts2.isToken), isVariableDeclarationListWithCollidingName(node.initializer) ? visitVariableDeclarationListWithCollidingNames(node.initializer, true) : ts2.visitNode(node.initializer, visitor, ts2.isForInitializer), ts2.visitNode(node.expression, visitor, ts2.isExpression), ts2.visitNode(node.statement, asyncBodyVisitor, ts2.isStatement, ts2.liftToBlock));
        }
        function visitForStatementInAsyncBody(node) {
          var initializer = node.initializer;
          return ts2.updateFor(node, isVariableDeclarationListWithCollidingName(initializer) ? visitVariableDeclarationListWithCollidingNames(initializer, false) : ts2.visitNode(node.initializer, visitor, ts2.isForInitializer), ts2.visitNode(node.condition, visitor, ts2.isExpression), ts2.visitNode(node.incrementor, visitor, ts2.isExpression), ts2.visitNode(node.statement, asyncBodyVisitor, ts2.isStatement, ts2.liftToBlock));
        }
        function visitAwaitExpression(node) {
          if (inTopLevelContext()) {
            return ts2.visitEachChild(node, visitor, context);
          }
          return ts2.setOriginalNode(ts2.setTextRange(ts2.createYield(void 0, ts2.visitNode(node.expression, visitor, ts2.isExpression)), node), node);
        }
        function visitMethodDeclaration(node) {
          return ts2.updateMethod(node, void 0, ts2.visitNodes(node.modifiers, visitor, ts2.isModifier), node.asteriskToken, node.name, void 0, void 0, ts2.visitParameterList(node.parameters, visitor, context), void 0, ts2.getFunctionFlags(node) & 2 ? transformAsyncFunctionBody(node) : ts2.visitFunctionBody(node.body, visitor, context));
        }
        function visitFunctionDeclaration(node) {
          return ts2.updateFunctionDeclaration(node, void 0, ts2.visitNodes(node.modifiers, visitor, ts2.isModifier), node.asteriskToken, node.name, void 0, ts2.visitParameterList(node.parameters, visitor, context), void 0, ts2.getFunctionFlags(node) & 2 ? transformAsyncFunctionBody(node) : ts2.visitFunctionBody(node.body, visitor, context));
        }
        function visitFunctionExpression(node) {
          return ts2.updateFunctionExpression(node, ts2.visitNodes(node.modifiers, visitor, ts2.isModifier), node.asteriskToken, node.name, void 0, ts2.visitParameterList(node.parameters, visitor, context), void 0, ts2.getFunctionFlags(node) & 2 ? transformAsyncFunctionBody(node) : ts2.visitFunctionBody(node.body, visitor, context));
        }
        function visitArrowFunction(node) {
          return ts2.updateArrowFunction(node, ts2.visitNodes(node.modifiers, visitor, ts2.isModifier), void 0, ts2.visitParameterList(node.parameters, visitor, context), void 0, node.equalsGreaterThanToken, ts2.getFunctionFlags(node) & 2 ? transformAsyncFunctionBody(node) : ts2.visitFunctionBody(node.body, visitor, context));
        }
        function recordDeclarationName(_a, names) {
          var name = _a.name;
          if (ts2.isIdentifier(name)) {
            names.set(name.escapedText, true);
          } else {
            for (var _i = 0, _b = name.elements; _i < _b.length; _i++) {
              var element = _b[_i];
              if (!ts2.isOmittedExpression(element)) {
                recordDeclarationName(element, names);
              }
            }
          }
        }
        function isVariableDeclarationListWithCollidingName(node) {
          return !!node && ts2.isVariableDeclarationList(node) && !(node.flags & 3) && node.declarations.some(collidesWithParameterName);
        }
        function visitVariableDeclarationListWithCollidingNames(node, hasReceiver) {
          hoistVariableDeclarationList(node);
          var variables = ts2.getInitializedVariables(node);
          if (variables.length === 0) {
            if (hasReceiver) {
              return ts2.visitNode(ts2.convertToAssignmentElementTarget(node.declarations[0].name), visitor, ts2.isExpression);
            }
            return void 0;
          }
          return ts2.inlineExpressions(ts2.map(variables, transformInitializedVariable));
        }
        function hoistVariableDeclarationList(node) {
          ts2.forEach(node.declarations, hoistVariable);
        }
        function hoistVariable(_a) {
          var name = _a.name;
          if (ts2.isIdentifier(name)) {
            hoistVariableDeclaration(name);
          } else {
            for (var _i = 0, _b = name.elements; _i < _b.length; _i++) {
              var element = _b[_i];
              if (!ts2.isOmittedExpression(element)) {
                hoistVariable(element);
              }
            }
          }
        }
        function transformInitializedVariable(node) {
          var converted = ts2.setSourceMapRange(ts2.createAssignment(ts2.convertToAssignmentElementTarget(node.name), node.initializer), node);
          return ts2.visitNode(converted, visitor, ts2.isExpression);
        }
        function collidesWithParameterName(_a) {
          var name = _a.name;
          if (ts2.isIdentifier(name)) {
            return enclosingFunctionParameterNames.has(name.escapedText);
          } else {
            for (var _i = 0, _b = name.elements; _i < _b.length; _i++) {
              var element = _b[_i];
              if (!ts2.isOmittedExpression(element) && collidesWithParameterName(element)) {
                return true;
              }
            }
          }
          return false;
        }
        function transformAsyncFunctionBody(node) {
          resumeLexicalEnvironment();
          var original = ts2.getOriginalNode(node, ts2.isFunctionLike);
          var nodeType = original.type;
          var promiseConstructor = languageVersion < 2 ? getPromiseConstructor(nodeType) : void 0;
          var isArrowFunction = node.kind === 202;
          var hasLexicalArguments = (resolver.getNodeCheckFlags(node) & 8192) !== 0;
          var savedEnclosingFunctionParameterNames = enclosingFunctionParameterNames;
          enclosingFunctionParameterNames = ts2.createUnderscoreEscapedMap();
          for (var _i = 0, _a = node.parameters; _i < _a.length; _i++) {
            var parameter = _a[_i];
            recordDeclarationName(parameter, enclosingFunctionParameterNames);
          }
          var savedCapturedSuperProperties = capturedSuperProperties;
          var savedHasSuperElementAccess = hasSuperElementAccess;
          if (!isArrowFunction) {
            capturedSuperProperties = ts2.createUnderscoreEscapedMap();
            hasSuperElementAccess = false;
          }
          var result;
          if (!isArrowFunction) {
            var statements = [];
            var statementOffset = ts2.addPrologue(statements, node.body.statements, false, visitor);
            statements.push(ts2.createReturn(createAwaiterHelper(context, inHasLexicalThisContext(), hasLexicalArguments, promiseConstructor, transformAsyncFunctionBodyWorker(node.body, statementOffset))));
            ts2.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
            var emitSuperHelpers = languageVersion >= 2 && resolver.getNodeCheckFlags(node) & (4096 | 2048);
            if (emitSuperHelpers) {
              enableSubstitutionForAsyncMethodsWithSuper();
              if (ts2.hasEntries(capturedSuperProperties)) {
                var variableStatement = createSuperAccessVariableStatement(resolver, node, capturedSuperProperties);
                substitutedSuperAccessors[ts2.getNodeId(variableStatement)] = true;
                ts2.insertStatementsAfterStandardPrologue(statements, [variableStatement]);
              }
            }
            var block = ts2.createBlock(statements, true);
            ts2.setTextRange(block, node.body);
            if (emitSuperHelpers && hasSuperElementAccess) {
              if (resolver.getNodeCheckFlags(node) & 4096) {
                ts2.addEmitHelper(block, ts2.advancedAsyncSuperHelper);
              } else if (resolver.getNodeCheckFlags(node) & 2048) {
                ts2.addEmitHelper(block, ts2.asyncSuperHelper);
              }
            }
            result = block;
          } else {
            var expression = createAwaiterHelper(context, inHasLexicalThisContext(), hasLexicalArguments, promiseConstructor, transformAsyncFunctionBodyWorker(node.body));
            var declarations = endLexicalEnvironment();
            if (ts2.some(declarations)) {
              var block = ts2.convertToFunctionBody(expression);
              result = ts2.updateBlock(block, ts2.setTextRange(ts2.createNodeArray(ts2.concatenate(declarations, block.statements)), block.statements));
            } else {
              result = expression;
            }
          }
          enclosingFunctionParameterNames = savedEnclosingFunctionParameterNames;
          if (!isArrowFunction) {
            capturedSuperProperties = savedCapturedSuperProperties;
            hasSuperElementAccess = savedHasSuperElementAccess;
          }
          return result;
        }
        function transformAsyncFunctionBodyWorker(body, start) {
          if (ts2.isBlock(body)) {
            return ts2.updateBlock(body, ts2.visitNodes(body.statements, asyncBodyVisitor, ts2.isStatement, start));
          } else {
            return ts2.convertToFunctionBody(ts2.visitNode(body, asyncBodyVisitor, ts2.isConciseBody));
          }
        }
        function getPromiseConstructor(type) {
          var typeName = type && ts2.getEntityNameFromTypeNode(type);
          if (typeName && ts2.isEntityName(typeName)) {
            var serializationKind = resolver.getTypeReferenceSerializationKind(typeName);
            if (serializationKind === ts2.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue || serializationKind === ts2.TypeReferenceSerializationKind.Unknown) {
              return typeName;
            }
          }
          return void 0;
        }
        function enableSubstitutionForAsyncMethodsWithSuper() {
          if ((enabledSubstitutions & 1) === 0) {
            enabledSubstitutions |= 1;
            context.enableSubstitution(196);
            context.enableSubstitution(194);
            context.enableSubstitution(195);
            context.enableEmitNotification(245);
            context.enableEmitNotification(161);
            context.enableEmitNotification(163);
            context.enableEmitNotification(164);
            context.enableEmitNotification(162);
            context.enableEmitNotification(225);
          }
        }
        function onEmitNode(hint, node, emitCallback) {
          if (enabledSubstitutions & 1 && isSuperContainer(node)) {
            var superContainerFlags = resolver.getNodeCheckFlags(node) & (2048 | 4096);
            if (superContainerFlags !== enclosingSuperContainerFlags) {
              var savedEnclosingSuperContainerFlags = enclosingSuperContainerFlags;
              enclosingSuperContainerFlags = superContainerFlags;
              previousOnEmitNode(hint, node, emitCallback);
              enclosingSuperContainerFlags = savedEnclosingSuperContainerFlags;
              return;
            }
          } else if (enabledSubstitutions && substitutedSuperAccessors[ts2.getNodeId(node)]) {
            var savedEnclosingSuperContainerFlags = enclosingSuperContainerFlags;
            enclosingSuperContainerFlags = 0;
            previousOnEmitNode(hint, node, emitCallback);
            enclosingSuperContainerFlags = savedEnclosingSuperContainerFlags;
            return;
          }
          previousOnEmitNode(hint, node, emitCallback);
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (hint === 1 && enclosingSuperContainerFlags) {
            return substituteExpression(node);
          }
          return node;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 194:
              return substitutePropertyAccessExpression(node);
            case 195:
              return substituteElementAccessExpression(node);
            case 196:
              return substituteCallExpression(node);
          }
          return node;
        }
        function substitutePropertyAccessExpression(node) {
          if (node.expression.kind === 102) {
            return ts2.setTextRange(ts2.createPropertyAccess(ts2.createFileLevelUniqueName("_super"), node.name), node);
          }
          return node;
        }
        function substituteElementAccessExpression(node) {
          if (node.expression.kind === 102) {
            return createSuperElementAccessInAsyncMethod(node.argumentExpression, node);
          }
          return node;
        }
        function substituteCallExpression(node) {
          var expression = node.expression;
          if (ts2.isSuperProperty(expression)) {
            var argumentExpression = ts2.isPropertyAccessExpression(expression) ? substitutePropertyAccessExpression(expression) : substituteElementAccessExpression(expression);
            return ts2.createCall(ts2.createPropertyAccess(argumentExpression, "call"), void 0, __spreadArrays([
              ts2.createThis()
            ], node.arguments));
          }
          return node;
        }
        function isSuperContainer(node) {
          var kind = node.kind;
          return kind === 245 || kind === 162 || kind === 161 || kind === 163 || kind === 164;
        }
        function createSuperElementAccessInAsyncMethod(argumentExpression, location) {
          if (enclosingSuperContainerFlags & 4096) {
            return ts2.setTextRange(ts2.createPropertyAccess(ts2.createCall(ts2.createFileLevelUniqueName("_superIndex"), void 0, [argumentExpression]), "value"), location);
          } else {
            return ts2.setTextRange(ts2.createCall(ts2.createFileLevelUniqueName("_superIndex"), void 0, [argumentExpression]), location);
          }
        }
      }
      ts2.transformES2017 = transformES2017;
      function createSuperAccessVariableStatement(resolver, node, names) {
        var hasBinding = (resolver.getNodeCheckFlags(node) & 4096) !== 0;
        var accessors = [];
        names.forEach(function(_, key) {
          var name = ts2.unescapeLeadingUnderscores(key);
          var getterAndSetter = [];
          getterAndSetter.push(ts2.createPropertyAssignment("get", ts2.createArrowFunction(void 0, void 0, [], void 0, void 0, ts2.setEmitFlags(ts2.createPropertyAccess(ts2.setEmitFlags(ts2.createSuper(), 4), name), 4))));
          if (hasBinding) {
            getterAndSetter.push(ts2.createPropertyAssignment("set", ts2.createArrowFunction(void 0, void 0, [
              ts2.createParameter(void 0, void 0, void 0, "v", void 0, void 0, void 0)
            ], void 0, void 0, ts2.createAssignment(ts2.setEmitFlags(ts2.createPropertyAccess(ts2.setEmitFlags(ts2.createSuper(), 4), name), 4), ts2.createIdentifier("v")))));
          }
          accessors.push(ts2.createPropertyAssignment(name, ts2.createObjectLiteral(getterAndSetter)));
        });
        return ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([
          ts2.createVariableDeclaration(ts2.createFileLevelUniqueName("_super"), void 0, ts2.createCall(ts2.createPropertyAccess(ts2.createIdentifier("Object"), "create"), void 0, [
            ts2.createNull(),
            ts2.createObjectLiteral(accessors, true)
          ]))
        ], 2));
      }
      ts2.createSuperAccessVariableStatement = createSuperAccessVariableStatement;
      ts2.awaiterHelper = {
        name: "typescript:awaiter",
        importName: "__awaiter",
        scoped: false,
        priority: 5,
        text: '\n            var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {\n                function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }\n                return new (P || (P = Promise))(function (resolve, reject) {\n                    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }\n                    function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }\n                    function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }\n                    step((generator = generator.apply(thisArg, _arguments || [])).next());\n                });\n            };'
      };
      function createAwaiterHelper(context, hasLexicalThis, hasLexicalArguments, promiseConstructor, body) {
        context.requestEmitHelper(ts2.awaiterHelper);
        var generatorFunc = ts2.createFunctionExpression(void 0, ts2.createToken(41), void 0, void 0, [], void 0, body);
        (generatorFunc.emitNode || (generatorFunc.emitNode = {})).flags |= 262144 | 524288;
        return ts2.createCall(ts2.getUnscopedHelperName("__awaiter"), void 0, [
          hasLexicalThis ? ts2.createThis() : ts2.createVoidZero(),
          hasLexicalArguments ? ts2.createIdentifier("arguments") : ts2.createVoidZero(),
          promiseConstructor ? ts2.createExpressionFromEntityName(promiseConstructor) : ts2.createVoidZero(),
          generatorFunc
        ]);
      }
      ts2.asyncSuperHelper = {
        name: "typescript:async-super",
        scoped: true,
        text: ts2.helperString(__makeTemplateObject(["\n            const ", " = name => super[name];"], ["\n            const ", " = name => super[name];"]), "_superIndex")
      };
      ts2.advancedAsyncSuperHelper = {
        name: "typescript:advanced-async-super",
        scoped: true,
        text: ts2.helperString(__makeTemplateObject(["\n            const ", " = (function (geti, seti) {\n                const cache = Object.create(null);\n                return name => cache[name] || (cache[name] = { get value() { return geti(name); }, set value(v) { seti(name, v); } });\n            })(name => super[name], (name, value) => super[name] = value);"], ["\n            const ", " = (function (geti, seti) {\n                const cache = Object.create(null);\n                return name => cache[name] || (cache[name] = { get value() { return geti(name); }, set value(v) { seti(name, v); } });\n            })(name => super[name], (name, value) => super[name] = value);"]), "_superIndex")
      };
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var ESNextSubstitutionFlags;
      (function(ESNextSubstitutionFlags2) {
        ESNextSubstitutionFlags2[ESNextSubstitutionFlags2["AsyncMethodsWithSuper"] = 1] = "AsyncMethodsWithSuper";
      })(ESNextSubstitutionFlags || (ESNextSubstitutionFlags = {}));
      var HierarchyFacts;
      (function(HierarchyFacts2) {
        HierarchyFacts2[HierarchyFacts2["None"] = 0] = "None";
        HierarchyFacts2[HierarchyFacts2["HasLexicalThis"] = 1] = "HasLexicalThis";
        HierarchyFacts2[HierarchyFacts2["IterationContainer"] = 2] = "IterationContainer";
        HierarchyFacts2[HierarchyFacts2["AncestorFactsMask"] = 3] = "AncestorFactsMask";
        HierarchyFacts2[HierarchyFacts2["SourceFileIncludes"] = 1] = "SourceFileIncludes";
        HierarchyFacts2[HierarchyFacts2["SourceFileExcludes"] = 2] = "SourceFileExcludes";
        HierarchyFacts2[HierarchyFacts2["StrictModeSourceFileIncludes"] = 0] = "StrictModeSourceFileIncludes";
        HierarchyFacts2[HierarchyFacts2["ClassOrFunctionIncludes"] = 1] = "ClassOrFunctionIncludes";
        HierarchyFacts2[HierarchyFacts2["ClassOrFunctionExcludes"] = 2] = "ClassOrFunctionExcludes";
        HierarchyFacts2[HierarchyFacts2["ArrowFunctionIncludes"] = 0] = "ArrowFunctionIncludes";
        HierarchyFacts2[HierarchyFacts2["ArrowFunctionExcludes"] = 2] = "ArrowFunctionExcludes";
        HierarchyFacts2[HierarchyFacts2["IterationStatementIncludes"] = 2] = "IterationStatementIncludes";
        HierarchyFacts2[HierarchyFacts2["IterationStatementExcludes"] = 0] = "IterationStatementExcludes";
      })(HierarchyFacts || (HierarchyFacts = {}));
      function transformES2018(context) {
        var resumeLexicalEnvironment = context.resumeLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var resolver = context.getEmitResolver();
        var compilerOptions = context.getCompilerOptions();
        var languageVersion = ts2.getEmitScriptTarget(compilerOptions);
        var previousOnEmitNode = context.onEmitNode;
        context.onEmitNode = onEmitNode;
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onSubstituteNode = onSubstituteNode;
        var exportedVariableStatement = false;
        var enabledSubstitutions;
        var enclosingFunctionFlags;
        var enclosingSuperContainerFlags = 0;
        var hierarchyFacts = 0;
        var currentSourceFile;
        var taggedTemplateStringDeclarations;
        var capturedSuperProperties;
        var hasSuperElementAccess;
        var substitutedSuperAccessors = [];
        return ts2.chainBundle(transformSourceFile);
        function affectsSubtree(excludeFacts, includeFacts) {
          return hierarchyFacts !== (hierarchyFacts & ~excludeFacts | includeFacts);
        }
        function enterSubtree(excludeFacts, includeFacts) {
          var ancestorFacts = hierarchyFacts;
          hierarchyFacts = (hierarchyFacts & ~excludeFacts | includeFacts) & 3;
          return ancestorFacts;
        }
        function exitSubtree(ancestorFacts) {
          hierarchyFacts = ancestorFacts;
        }
        function recordTaggedTemplateString(temp) {
          taggedTemplateStringDeclarations = ts2.append(taggedTemplateStringDeclarations, ts2.createVariableDeclaration(temp));
        }
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          currentSourceFile = node;
          var visited = visitSourceFile(node);
          ts2.addEmitHelpers(visited, context.readEmitHelpers());
          currentSourceFile = void 0;
          taggedTemplateStringDeclarations = void 0;
          return visited;
        }
        function visitor(node) {
          return visitorWorker(node, false);
        }
        function visitorNoDestructuringValue(node) {
          return visitorWorker(node, true);
        }
        function visitorNoAsyncModifier(node) {
          if (node.kind === 126) {
            return void 0;
          }
          return node;
        }
        function doWithHierarchyFacts(cb, value, excludeFacts, includeFacts) {
          if (affectsSubtree(excludeFacts, includeFacts)) {
            var ancestorFacts = enterSubtree(excludeFacts, includeFacts);
            var result = cb(value);
            exitSubtree(ancestorFacts);
            return result;
          }
          return cb(value);
        }
        function visitDefault(node) {
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitorWorker(node, noDestructuringValue) {
          if ((node.transformFlags & 32) === 0) {
            return node;
          }
          switch (node.kind) {
            case 206:
              return visitAwaitExpression(node);
            case 212:
              return visitYieldExpression(node);
            case 235:
              return visitReturnStatement(node);
            case 238:
              return visitLabeledStatement(node);
            case 193:
              return visitObjectLiteralExpression(node);
            case 209:
              return visitBinaryExpression(node, noDestructuringValue);
            case 280:
              return visitCatchClause(node);
            case 225:
              return visitVariableStatement(node);
            case 242:
              return visitVariableDeclaration(node);
            case 228:
            case 229:
            case 231:
              return doWithHierarchyFacts(visitDefault, node, 0, 2);
            case 232:
              return visitForOfStatement(node, void 0);
            case 230:
              return doWithHierarchyFacts(visitForStatement, node, 0, 2);
            case 205:
              return visitVoidExpression(node);
            case 162:
              return doWithHierarchyFacts(visitConstructorDeclaration, node, 2, 1);
            case 161:
              return doWithHierarchyFacts(visitMethodDeclaration, node, 2, 1);
            case 163:
              return doWithHierarchyFacts(visitGetAccessorDeclaration, node, 2, 1);
            case 164:
              return doWithHierarchyFacts(visitSetAccessorDeclaration, node, 2, 1);
            case 244:
              return doWithHierarchyFacts(visitFunctionDeclaration, node, 2, 1);
            case 201:
              return doWithHierarchyFacts(visitFunctionExpression, node, 2, 1);
            case 202:
              return doWithHierarchyFacts(visitArrowFunction, node, 2, 0);
            case 156:
              return visitParameter(node);
            case 226:
              return visitExpressionStatement(node);
            case 200:
              return visitParenthesizedExpression(node, noDestructuringValue);
            case 198:
              return visitTaggedTemplateExpression(node);
            case 194:
              if (capturedSuperProperties && ts2.isPropertyAccessExpression(node) && node.expression.kind === 102) {
                capturedSuperProperties.set(node.name.escapedText, true);
              }
              return ts2.visitEachChild(node, visitor, context);
            case 195:
              if (capturedSuperProperties && node.expression.kind === 102) {
                hasSuperElementAccess = true;
              }
              return ts2.visitEachChild(node, visitor, context);
            case 245:
            case 214:
              return doWithHierarchyFacts(visitDefault, node, 2, 1);
            default:
              return ts2.visitEachChild(node, visitor, context);
          }
        }
        function visitAwaitExpression(node) {
          if (enclosingFunctionFlags & 2 && enclosingFunctionFlags & 1) {
            return ts2.setOriginalNode(ts2.setTextRange(ts2.createYield(createAwaitHelper(context, ts2.visitNode(node.expression, visitor, ts2.isExpression))), node), node);
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitYieldExpression(node) {
          if (enclosingFunctionFlags & 2 && enclosingFunctionFlags & 1) {
            if (node.asteriskToken) {
              var expression = ts2.visitNode(node.expression, visitor, ts2.isExpression);
              return ts2.setOriginalNode(ts2.setTextRange(ts2.createYield(createAwaitHelper(context, ts2.updateYield(node, node.asteriskToken, createAsyncDelegatorHelper(context, createAsyncValuesHelper(context, expression, expression), expression)))), node), node);
            }
            return ts2.setOriginalNode(ts2.setTextRange(ts2.createYield(createDownlevelAwait(node.expression ? ts2.visitNode(node.expression, visitor, ts2.isExpression) : ts2.createVoidZero())), node), node);
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitReturnStatement(node) {
          if (enclosingFunctionFlags & 2 && enclosingFunctionFlags & 1) {
            return ts2.updateReturn(node, createDownlevelAwait(node.expression ? ts2.visitNode(node.expression, visitor, ts2.isExpression) : ts2.createVoidZero()));
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitLabeledStatement(node) {
          if (enclosingFunctionFlags & 2) {
            var statement = ts2.unwrapInnermostStatementOfLabel(node);
            if (statement.kind === 232 && statement.awaitModifier) {
              return visitForOfStatement(statement, node);
            }
            return ts2.restoreEnclosingLabel(ts2.visitNode(statement, visitor, ts2.isStatement, ts2.liftToBlock), node);
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function chunkObjectLiteralElements(elements) {
          var chunkObject;
          var objects = [];
          for (var _i = 0, elements_4 = elements; _i < elements_4.length; _i++) {
            var e = elements_4[_i];
            if (e.kind === 283) {
              if (chunkObject) {
                objects.push(ts2.createObjectLiteral(chunkObject));
                chunkObject = void 0;
              }
              var target = e.expression;
              objects.push(ts2.visitNode(target, visitor, ts2.isExpression));
            } else {
              chunkObject = ts2.append(chunkObject, e.kind === 281 ? ts2.createPropertyAssignment(e.name, ts2.visitNode(e.initializer, visitor, ts2.isExpression)) : ts2.visitNode(e, visitor, ts2.isObjectLiteralElementLike));
            }
          }
          if (chunkObject) {
            objects.push(ts2.createObjectLiteral(chunkObject));
          }
          return objects;
        }
        function visitObjectLiteralExpression(node) {
          if (node.transformFlags & 16384) {
            var objects = chunkObjectLiteralElements(node.properties);
            if (objects.length && objects[0].kind !== 193) {
              objects.unshift(ts2.createObjectLiteral());
            }
            var expression = objects[0];
            if (objects.length > 1) {
              for (var i = 1; i < objects.length; i++) {
                expression = createAssignHelper(context, [expression, objects[i]]);
              }
              return expression;
            } else {
              return createAssignHelper(context, objects);
            }
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitExpressionStatement(node) {
          return ts2.visitEachChild(node, visitorNoDestructuringValue, context);
        }
        function visitParenthesizedExpression(node, noDestructuringValue) {
          return ts2.visitEachChild(node, noDestructuringValue ? visitorNoDestructuringValue : visitor, context);
        }
        function visitSourceFile(node) {
          var ancestorFacts = enterSubtree(2, ts2.isEffectiveStrictModeSourceFile(node, compilerOptions) ? 0 : 1);
          exportedVariableStatement = false;
          var visited = ts2.visitEachChild(node, visitor, context);
          var statement = ts2.concatenate(visited.statements, taggedTemplateStringDeclarations && [
            ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList(taggedTemplateStringDeclarations))
          ]);
          var result = ts2.updateSourceFileNode(visited, ts2.setTextRange(ts2.createNodeArray(statement), node.statements));
          exitSubtree(ancestorFacts);
          return result;
        }
        function visitTaggedTemplateExpression(node) {
          return ts2.processTaggedTemplateExpression(context, node, visitor, currentSourceFile, recordTaggedTemplateString, ts2.ProcessLevel.LiftRestriction);
        }
        function visitBinaryExpression(node, noDestructuringValue) {
          if (ts2.isDestructuringAssignment(node) && node.left.transformFlags & 16384) {
            return ts2.flattenDestructuringAssignment(node, visitor, context, 1, !noDestructuringValue);
          } else if (node.operatorToken.kind === 27) {
            return ts2.updateBinary(node, ts2.visitNode(node.left, visitorNoDestructuringValue, ts2.isExpression), ts2.visitNode(node.right, noDestructuringValue ? visitorNoDestructuringValue : visitor, ts2.isExpression));
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitCatchClause(node) {
          if (node.variableDeclaration && ts2.isBindingPattern(node.variableDeclaration.name) && node.variableDeclaration.name.transformFlags & 16384) {
            var name = ts2.getGeneratedNameForNode(node.variableDeclaration.name);
            var updatedDecl = ts2.updateVariableDeclaration(node.variableDeclaration, node.variableDeclaration.name, void 0, name);
            var visitedBindings = ts2.flattenDestructuringBinding(updatedDecl, visitor, context, 1);
            var block = ts2.visitNode(node.block, visitor, ts2.isBlock);
            if (ts2.some(visitedBindings)) {
              block = ts2.updateBlock(block, __spreadArrays([
                ts2.createVariableStatement(void 0, visitedBindings)
              ], block.statements));
            }
            return ts2.updateCatchClause(node, ts2.updateVariableDeclaration(node.variableDeclaration, name, void 0, void 0), block);
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitVariableStatement(node) {
          if (ts2.hasModifier(node, 1)) {
            var savedExportedVariableStatement = exportedVariableStatement;
            exportedVariableStatement = true;
            var visited = ts2.visitEachChild(node, visitor, context);
            exportedVariableStatement = savedExportedVariableStatement;
            return visited;
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitVariableDeclaration(node) {
          if (exportedVariableStatement) {
            var savedExportedVariableStatement = exportedVariableStatement;
            exportedVariableStatement = false;
            var visited = visitVariableDeclarationWorker(node, true);
            exportedVariableStatement = savedExportedVariableStatement;
            return visited;
          }
          return visitVariableDeclarationWorker(node, false);
        }
        function visitVariableDeclarationWorker(node, exportedVariableStatement2) {
          if (ts2.isBindingPattern(node.name) && node.name.transformFlags & 16384) {
            return ts2.flattenDestructuringBinding(node, visitor, context, 1, void 0, exportedVariableStatement2);
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitForStatement(node) {
          return ts2.updateFor(node, ts2.visitNode(node.initializer, visitorNoDestructuringValue, ts2.isForInitializer), ts2.visitNode(node.condition, visitor, ts2.isExpression), ts2.visitNode(node.incrementor, visitor, ts2.isExpression), ts2.visitNode(node.statement, visitor, ts2.isStatement));
        }
        function visitVoidExpression(node) {
          return ts2.visitEachChild(node, visitorNoDestructuringValue, context);
        }
        function visitForOfStatement(node, outermostLabeledStatement) {
          var ancestorFacts = enterSubtree(0, 2);
          if (node.initializer.transformFlags & 16384) {
            node = transformForOfStatementWithObjectRest(node);
          }
          var result = node.awaitModifier ? transformForAwaitOfStatement(node, outermostLabeledStatement, ancestorFacts) : ts2.restoreEnclosingLabel(ts2.visitEachChild(node, visitor, context), outermostLabeledStatement);
          exitSubtree(ancestorFacts);
          return result;
        }
        function transformForOfStatementWithObjectRest(node) {
          var initializerWithoutParens = ts2.skipParentheses(node.initializer);
          if (ts2.isVariableDeclarationList(initializerWithoutParens) || ts2.isAssignmentPattern(initializerWithoutParens)) {
            var bodyLocation = void 0;
            var statementsLocation = void 0;
            var temp = ts2.createTempVariable(void 0);
            var statements = [ts2.createForOfBindingStatement(initializerWithoutParens, temp)];
            if (ts2.isBlock(node.statement)) {
              ts2.addRange(statements, node.statement.statements);
              bodyLocation = node.statement;
              statementsLocation = node.statement.statements;
            } else if (node.statement) {
              ts2.append(statements, node.statement);
              bodyLocation = node.statement;
              statementsLocation = node.statement;
            }
            return ts2.updateForOf(node, node.awaitModifier, ts2.setTextRange(ts2.createVariableDeclarationList([
              ts2.setTextRange(ts2.createVariableDeclaration(temp), node.initializer)
            ], 1), node.initializer), node.expression, ts2.setTextRange(ts2.createBlock(ts2.setTextRange(ts2.createNodeArray(statements), statementsLocation), true), bodyLocation));
          }
          return node;
        }
        function convertForOfStatementHead(node, boundValue) {
          var binding = ts2.createForOfBindingStatement(node.initializer, boundValue);
          var bodyLocation;
          var statementsLocation;
          var statements = [ts2.visitNode(binding, visitor, ts2.isStatement)];
          var statement = ts2.visitNode(node.statement, visitor, ts2.isStatement);
          if (ts2.isBlock(statement)) {
            ts2.addRange(statements, statement.statements);
            bodyLocation = statement;
            statementsLocation = statement.statements;
          } else {
            statements.push(statement);
          }
          return ts2.setEmitFlags(ts2.setTextRange(ts2.createBlock(ts2.setTextRange(ts2.createNodeArray(statements), statementsLocation), true), bodyLocation), 48 | 384);
        }
        function createDownlevelAwait(expression) {
          return enclosingFunctionFlags & 1 ? ts2.createYield(void 0, createAwaitHelper(context, expression)) : ts2.createAwait(expression);
        }
        function transformForAwaitOfStatement(node, outermostLabeledStatement, ancestorFacts) {
          var expression = ts2.visitNode(node.expression, visitor, ts2.isExpression);
          var iterator = ts2.isIdentifier(expression) ? ts2.getGeneratedNameForNode(expression) : ts2.createTempVariable(void 0);
          var result = ts2.isIdentifier(expression) ? ts2.getGeneratedNameForNode(iterator) : ts2.createTempVariable(void 0);
          var errorRecord = ts2.createUniqueName("e");
          var catchVariable = ts2.getGeneratedNameForNode(errorRecord);
          var returnMethod = ts2.createTempVariable(void 0);
          var callValues = createAsyncValuesHelper(context, expression, node.expression);
          var callNext = ts2.createCall(ts2.createPropertyAccess(iterator, "next"), void 0, []);
          var getDone = ts2.createPropertyAccess(result, "done");
          var getValue = ts2.createPropertyAccess(result, "value");
          var callReturn = ts2.createFunctionCall(returnMethod, iterator, []);
          hoistVariableDeclaration(errorRecord);
          hoistVariableDeclaration(returnMethod);
          var initializer = ancestorFacts & 2 ? ts2.inlineExpressions([ts2.createAssignment(errorRecord, ts2.createVoidZero()), callValues]) : callValues;
          var forStatement = ts2.setEmitFlags(ts2.setTextRange(ts2.createFor(ts2.setEmitFlags(ts2.setTextRange(ts2.createVariableDeclarationList([
            ts2.setTextRange(ts2.createVariableDeclaration(iterator, void 0, initializer), node.expression),
            ts2.createVariableDeclaration(result)
          ]), node.expression), 2097152), ts2.createComma(ts2.createAssignment(result, createDownlevelAwait(callNext)), ts2.createLogicalNot(getDone)), void 0, convertForOfStatementHead(node, getValue)), node), 256);
          return ts2.createTry(ts2.createBlock([
            ts2.restoreEnclosingLabel(forStatement, outermostLabeledStatement)
          ]), ts2.createCatchClause(ts2.createVariableDeclaration(catchVariable), ts2.setEmitFlags(ts2.createBlock([
            ts2.createExpressionStatement(ts2.createAssignment(errorRecord, ts2.createObjectLiteral([
              ts2.createPropertyAssignment("error", catchVariable)
            ])))
          ]), 1)), ts2.createBlock([
            ts2.createTry(ts2.createBlock([
              ts2.setEmitFlags(ts2.createIf(ts2.createLogicalAnd(ts2.createLogicalAnd(result, ts2.createLogicalNot(getDone)), ts2.createAssignment(returnMethod, ts2.createPropertyAccess(iterator, "return"))), ts2.createExpressionStatement(createDownlevelAwait(callReturn))), 1)
            ]), void 0, ts2.setEmitFlags(ts2.createBlock([
              ts2.setEmitFlags(ts2.createIf(errorRecord, ts2.createThrow(ts2.createPropertyAccess(errorRecord, "error"))), 1)
            ]), 1))
          ]));
        }
        function visitParameter(node) {
          if (node.transformFlags & 16384) {
            return ts2.updateParameter(node, void 0, void 0, node.dotDotDotToken, ts2.getGeneratedNameForNode(node), void 0, void 0, ts2.visitNode(node.initializer, visitor, ts2.isExpression));
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitConstructorDeclaration(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          enclosingFunctionFlags = 0;
          var updated = ts2.updateConstructor(node, void 0, node.modifiers, ts2.visitParameterList(node.parameters, visitor, context), transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          return updated;
        }
        function visitGetAccessorDeclaration(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          enclosingFunctionFlags = 0;
          var updated = ts2.updateGetAccessor(node, void 0, node.modifiers, ts2.visitNode(node.name, visitor, ts2.isPropertyName), ts2.visitParameterList(node.parameters, visitor, context), void 0, transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          return updated;
        }
        function visitSetAccessorDeclaration(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          enclosingFunctionFlags = 0;
          var updated = ts2.updateSetAccessor(node, void 0, node.modifiers, ts2.visitNode(node.name, visitor, ts2.isPropertyName), ts2.visitParameterList(node.parameters, visitor, context), transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          return updated;
        }
        function visitMethodDeclaration(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          enclosingFunctionFlags = ts2.getFunctionFlags(node);
          var updated = ts2.updateMethod(node, void 0, enclosingFunctionFlags & 1 ? ts2.visitNodes(node.modifiers, visitorNoAsyncModifier, ts2.isModifier) : node.modifiers, enclosingFunctionFlags & 2 ? void 0 : node.asteriskToken, ts2.visitNode(node.name, visitor, ts2.isPropertyName), ts2.visitNode(void 0, visitor, ts2.isToken), void 0, ts2.visitParameterList(node.parameters, visitor, context), void 0, enclosingFunctionFlags & 2 && enclosingFunctionFlags & 1 ? transformAsyncGeneratorFunctionBody(node) : transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          return updated;
        }
        function visitFunctionDeclaration(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          enclosingFunctionFlags = ts2.getFunctionFlags(node);
          var updated = ts2.updateFunctionDeclaration(node, void 0, enclosingFunctionFlags & 1 ? ts2.visitNodes(node.modifiers, visitorNoAsyncModifier, ts2.isModifier) : node.modifiers, enclosingFunctionFlags & 2 ? void 0 : node.asteriskToken, node.name, void 0, ts2.visitParameterList(node.parameters, visitor, context), void 0, enclosingFunctionFlags & 2 && enclosingFunctionFlags & 1 ? transformAsyncGeneratorFunctionBody(node) : transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          return updated;
        }
        function visitArrowFunction(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          enclosingFunctionFlags = ts2.getFunctionFlags(node);
          var updated = ts2.updateArrowFunction(node, node.modifiers, void 0, ts2.visitParameterList(node.parameters, visitor, context), void 0, node.equalsGreaterThanToken, transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          return updated;
        }
        function visitFunctionExpression(node) {
          var savedEnclosingFunctionFlags = enclosingFunctionFlags;
          enclosingFunctionFlags = ts2.getFunctionFlags(node);
          var updated = ts2.updateFunctionExpression(node, enclosingFunctionFlags & 1 ? ts2.visitNodes(node.modifiers, visitorNoAsyncModifier, ts2.isModifier) : node.modifiers, enclosingFunctionFlags & 2 ? void 0 : node.asteriskToken, node.name, void 0, ts2.visitParameterList(node.parameters, visitor, context), void 0, enclosingFunctionFlags & 2 && enclosingFunctionFlags & 1 ? transformAsyncGeneratorFunctionBody(node) : transformFunctionBody(node));
          enclosingFunctionFlags = savedEnclosingFunctionFlags;
          return updated;
        }
        function transformAsyncGeneratorFunctionBody(node) {
          resumeLexicalEnvironment();
          var statements = [];
          var statementOffset = ts2.addPrologue(statements, node.body.statements, false, visitor);
          appendObjectRestAssignmentsIfNeeded(statements, node);
          var savedCapturedSuperProperties = capturedSuperProperties;
          var savedHasSuperElementAccess = hasSuperElementAccess;
          capturedSuperProperties = ts2.createUnderscoreEscapedMap();
          hasSuperElementAccess = false;
          var returnStatement = ts2.createReturn(createAsyncGeneratorHelper(context, ts2.createFunctionExpression(void 0, ts2.createToken(41), node.name && ts2.getGeneratedNameForNode(node.name), void 0, [], void 0, ts2.updateBlock(node.body, ts2.visitLexicalEnvironment(node.body.statements, visitor, context, statementOffset))), !!(hierarchyFacts & 1)));
          var emitSuperHelpers = languageVersion >= 2 && resolver.getNodeCheckFlags(node) & (4096 | 2048);
          if (emitSuperHelpers) {
            enableSubstitutionForAsyncMethodsWithSuper();
            var variableStatement = ts2.createSuperAccessVariableStatement(resolver, node, capturedSuperProperties);
            substitutedSuperAccessors[ts2.getNodeId(variableStatement)] = true;
            ts2.insertStatementsAfterStandardPrologue(statements, [variableStatement]);
          }
          statements.push(returnStatement);
          ts2.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          var block = ts2.updateBlock(node.body, statements);
          if (emitSuperHelpers && hasSuperElementAccess) {
            if (resolver.getNodeCheckFlags(node) & 4096) {
              ts2.addEmitHelper(block, ts2.advancedAsyncSuperHelper);
            } else if (resolver.getNodeCheckFlags(node) & 2048) {
              ts2.addEmitHelper(block, ts2.asyncSuperHelper);
            }
          }
          capturedSuperProperties = savedCapturedSuperProperties;
          hasSuperElementAccess = savedHasSuperElementAccess;
          return block;
        }
        function transformFunctionBody(node) {
          resumeLexicalEnvironment();
          var statementOffset = 0;
          var statements = [];
          var body = ts2.visitNode(node.body, visitor, ts2.isConciseBody);
          if (ts2.isBlock(body)) {
            statementOffset = ts2.addPrologue(statements, body.statements, false, visitor);
          }
          ts2.addRange(statements, appendObjectRestAssignmentsIfNeeded(void 0, node));
          var leadingStatements = endLexicalEnvironment();
          if (statementOffset > 0 || ts2.some(statements) || ts2.some(leadingStatements)) {
            var block = ts2.convertToFunctionBody(body, true);
            ts2.insertStatementsAfterStandardPrologue(statements, leadingStatements);
            ts2.addRange(statements, block.statements.slice(statementOffset));
            return ts2.updateBlock(block, ts2.setTextRange(ts2.createNodeArray(statements), block.statements));
          }
          return body;
        }
        function appendObjectRestAssignmentsIfNeeded(statements, node) {
          for (var _i = 0, _a = node.parameters; _i < _a.length; _i++) {
            var parameter = _a[_i];
            if (parameter.transformFlags & 16384) {
              var temp = ts2.getGeneratedNameForNode(parameter);
              var declarations = ts2.flattenDestructuringBinding(parameter, visitor, context, 1, temp, false, true);
              if (ts2.some(declarations)) {
                var statement = ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList(declarations));
                ts2.setEmitFlags(statement, 1048576);
                statements = ts2.append(statements, statement);
              }
            }
          }
          return statements;
        }
        function enableSubstitutionForAsyncMethodsWithSuper() {
          if ((enabledSubstitutions & 1) === 0) {
            enabledSubstitutions |= 1;
            context.enableSubstitution(196);
            context.enableSubstitution(194);
            context.enableSubstitution(195);
            context.enableEmitNotification(245);
            context.enableEmitNotification(161);
            context.enableEmitNotification(163);
            context.enableEmitNotification(164);
            context.enableEmitNotification(162);
            context.enableEmitNotification(225);
          }
        }
        function onEmitNode(hint, node, emitCallback) {
          if (enabledSubstitutions & 1 && isSuperContainer(node)) {
            var superContainerFlags = resolver.getNodeCheckFlags(node) & (2048 | 4096);
            if (superContainerFlags !== enclosingSuperContainerFlags) {
              var savedEnclosingSuperContainerFlags = enclosingSuperContainerFlags;
              enclosingSuperContainerFlags = superContainerFlags;
              previousOnEmitNode(hint, node, emitCallback);
              enclosingSuperContainerFlags = savedEnclosingSuperContainerFlags;
              return;
            }
          } else if (enabledSubstitutions && substitutedSuperAccessors[ts2.getNodeId(node)]) {
            var savedEnclosingSuperContainerFlags = enclosingSuperContainerFlags;
            enclosingSuperContainerFlags = 0;
            previousOnEmitNode(hint, node, emitCallback);
            enclosingSuperContainerFlags = savedEnclosingSuperContainerFlags;
            return;
          }
          previousOnEmitNode(hint, node, emitCallback);
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (hint === 1 && enclosingSuperContainerFlags) {
            return substituteExpression(node);
          }
          return node;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 194:
              return substitutePropertyAccessExpression(node);
            case 195:
              return substituteElementAccessExpression(node);
            case 196:
              return substituteCallExpression(node);
          }
          return node;
        }
        function substitutePropertyAccessExpression(node) {
          if (node.expression.kind === 102) {
            return ts2.setTextRange(ts2.createPropertyAccess(ts2.createFileLevelUniqueName("_super"), node.name), node);
          }
          return node;
        }
        function substituteElementAccessExpression(node) {
          if (node.expression.kind === 102) {
            return createSuperElementAccessInAsyncMethod(node.argumentExpression, node);
          }
          return node;
        }
        function substituteCallExpression(node) {
          var expression = node.expression;
          if (ts2.isSuperProperty(expression)) {
            var argumentExpression = ts2.isPropertyAccessExpression(expression) ? substitutePropertyAccessExpression(expression) : substituteElementAccessExpression(expression);
            return ts2.createCall(ts2.createPropertyAccess(argumentExpression, "call"), void 0, __spreadArrays([
              ts2.createThis()
            ], node.arguments));
          }
          return node;
        }
        function isSuperContainer(node) {
          var kind = node.kind;
          return kind === 245 || kind === 162 || kind === 161 || kind === 163 || kind === 164;
        }
        function createSuperElementAccessInAsyncMethod(argumentExpression, location) {
          if (enclosingSuperContainerFlags & 4096) {
            return ts2.setTextRange(ts2.createPropertyAccess(ts2.createCall(ts2.createIdentifier("_superIndex"), void 0, [argumentExpression]), "value"), location);
          } else {
            return ts2.setTextRange(ts2.createCall(ts2.createIdentifier("_superIndex"), void 0, [argumentExpression]), location);
          }
        }
      }
      ts2.transformES2018 = transformES2018;
      ts2.assignHelper = {
        name: "typescript:assign",
        importName: "__assign",
        scoped: false,
        priority: 1,
        text: "\n            var __assign = (this && this.__assign) || function () {\n                __assign = Object.assign || function(t) {\n                    for (var s, i = 1, n = arguments.length; i < n; i++) {\n                        s = arguments[i];\n                        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))\n                            t[p] = s[p];\n                    }\n                    return t;\n                };\n                return __assign.apply(this, arguments);\n            };"
      };
      function createAssignHelper(context, attributesSegments) {
        if (context.getCompilerOptions().target >= 2) {
          return ts2.createCall(ts2.createPropertyAccess(ts2.createIdentifier("Object"), "assign"), void 0, attributesSegments);
        }
        context.requestEmitHelper(ts2.assignHelper);
        return ts2.createCall(ts2.getUnscopedHelperName("__assign"), void 0, attributesSegments);
      }
      ts2.createAssignHelper = createAssignHelper;
      ts2.awaitHelper = {
        name: "typescript:await",
        importName: "__await",
        scoped: false,
        text: "\n            var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }"
      };
      function createAwaitHelper(context, expression) {
        context.requestEmitHelper(ts2.awaitHelper);
        return ts2.createCall(ts2.getUnscopedHelperName("__await"), void 0, [expression]);
      }
      ts2.asyncGeneratorHelper = {
        name: "typescript:asyncGenerator",
        importName: "__asyncGenerator",
        scoped: false,
        dependencies: [ts2.awaitHelper],
        text: '\n            var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {\n                if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");\n                var g = generator.apply(thisArg, _arguments || []), i, q = [];\n                return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;\n                function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }\n                function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }\n                function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }\n                function fulfill(value) { resume("next", value); }\n                function reject(value) { resume("throw", value); }\n                function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }\n            };'
      };
      function createAsyncGeneratorHelper(context, generatorFunc, hasLexicalThis) {
        context.requestEmitHelper(ts2.asyncGeneratorHelper);
        (generatorFunc.emitNode || (generatorFunc.emitNode = {})).flags |= 262144 | 524288;
        return ts2.createCall(ts2.getUnscopedHelperName("__asyncGenerator"), void 0, [
          hasLexicalThis ? ts2.createThis() : ts2.createVoidZero(),
          ts2.createIdentifier("arguments"),
          generatorFunc
        ]);
      }
      ts2.asyncDelegator = {
        name: "typescript:asyncDelegator",
        importName: "__asyncDelegator",
        scoped: false,
        dependencies: [ts2.awaitHelper],
        text: '\n            var __asyncDelegator = (this && this.__asyncDelegator) || function (o) {\n                var i, p;\n                return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;\n                function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }\n            };'
      };
      function createAsyncDelegatorHelper(context, expression, location) {
        context.requestEmitHelper(ts2.asyncDelegator);
        return ts2.setTextRange(ts2.createCall(ts2.getUnscopedHelperName("__asyncDelegator"), void 0, [expression]), location);
      }
      ts2.asyncValues = {
        name: "typescript:asyncValues",
        importName: "__asyncValues",
        scoped: false,
        text: '\n            var __asyncValues = (this && this.__asyncValues) || function (o) {\n                if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");\n                var m = o[Symbol.asyncIterator], i;\n                return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);\n                function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }\n                function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }\n            };'
      };
      function createAsyncValuesHelper(context, expression, location) {
        context.requestEmitHelper(ts2.asyncValues);
        return ts2.setTextRange(ts2.createCall(ts2.getUnscopedHelperName("__asyncValues"), void 0, [expression]), location);
      }
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function transformES2019(context) {
        return ts2.chainBundle(transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitor(node) {
          if ((node.transformFlags & 16) === 0) {
            return node;
          }
          switch (node.kind) {
            case 280:
              return visitCatchClause(node);
            default:
              return ts2.visitEachChild(node, visitor, context);
          }
        }
        function visitCatchClause(node) {
          if (!node.variableDeclaration) {
            return ts2.updateCatchClause(node, ts2.createVariableDeclaration(ts2.createTempVariable(void 0)), ts2.visitNode(node.block, visitor, ts2.isBlock));
          }
          return ts2.visitEachChild(node, visitor, context);
        }
      }
      ts2.transformES2019 = transformES2019;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function transformES2020(context) {
        var hoistVariableDeclaration = context.hoistVariableDeclaration;
        return ts2.chainBundle(transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitor(node) {
          if ((node.transformFlags & 8) === 0) {
            return node;
          }
          switch (node.kind) {
            case 194:
            case 195:
            case 196:
              if (node.flags & 32) {
                var updated = visitOptionalExpression(node, false, false);
                ts2.Debug.assertNotNode(updated, ts2.isSyntheticReference);
                return updated;
              }
              return ts2.visitEachChild(node, visitor, context);
            case 209:
              if (node.operatorToken.kind === 60) {
                return transformNullishCoalescingExpression(node);
              }
              return ts2.visitEachChild(node, visitor, context);
            case 203:
              return visitDeleteExpression(node);
            default:
              return ts2.visitEachChild(node, visitor, context);
          }
        }
        function flattenChain(chain) {
          ts2.Debug.assertNotNode(chain, ts2.isNonNullChain);
          var links = [chain];
          while (!chain.questionDotToken && !ts2.isTaggedTemplateExpression(chain)) {
            chain = ts2.cast(ts2.skipPartiallyEmittedExpressions(chain.expression), ts2.isOptionalChain);
            ts2.Debug.assertNotNode(chain, ts2.isNonNullChain);
            links.unshift(chain);
          }
          return { expression: chain.expression, chain: links };
        }
        function visitNonOptionalParenthesizedExpression(node, captureThisArg, isDelete) {
          var expression = visitNonOptionalExpression(node.expression, captureThisArg, isDelete);
          if (ts2.isSyntheticReference(expression)) {
            return ts2.createSyntheticReferenceExpression(ts2.updateParen(node, expression.expression), expression.thisArg);
          }
          return ts2.updateParen(node, expression);
        }
        function visitNonOptionalPropertyOrElementAccessExpression(node, captureThisArg, isDelete) {
          if (ts2.isOptionalChain(node)) {
            return visitOptionalExpression(node, captureThisArg, isDelete);
          }
          var expression = ts2.visitNode(node.expression, visitor, ts2.isExpression);
          ts2.Debug.assertNotNode(expression, ts2.isSyntheticReference);
          var thisArg;
          if (captureThisArg) {
            if (shouldCaptureInTempVariable(expression)) {
              thisArg = ts2.createTempVariable(hoistVariableDeclaration);
              expression = ts2.createAssignment(thisArg, expression);
            } else {
              thisArg = expression;
            }
          }
          expression = node.kind === 194 ? ts2.updatePropertyAccess(node, expression, ts2.visitNode(node.name, visitor, ts2.isIdentifier)) : ts2.updateElementAccess(node, expression, ts2.visitNode(node.argumentExpression, visitor, ts2.isExpression));
          return thisArg ? ts2.createSyntheticReferenceExpression(expression, thisArg) : expression;
        }
        function visitNonOptionalCallExpression(node, captureThisArg) {
          if (ts2.isOptionalChain(node)) {
            return visitOptionalExpression(node, captureThisArg, false);
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitNonOptionalExpression(node, captureThisArg, isDelete) {
          switch (node.kind) {
            case 200:
              return visitNonOptionalParenthesizedExpression(node, captureThisArg, isDelete);
            case 194:
            case 195:
              return visitNonOptionalPropertyOrElementAccessExpression(node, captureThisArg, isDelete);
            case 196:
              return visitNonOptionalCallExpression(node, captureThisArg);
            default:
              return ts2.visitNode(node, visitor, ts2.isExpression);
          }
        }
        function visitOptionalExpression(node, captureThisArg, isDelete) {
          var _a = flattenChain(node), expression = _a.expression, chain = _a.chain;
          var left = visitNonOptionalExpression(expression, ts2.isCallChain(chain[0]), false);
          var leftThisArg = ts2.isSyntheticReference(left) ? left.thisArg : void 0;
          var leftExpression = ts2.isSyntheticReference(left) ? left.expression : left;
          var capturedLeft = leftExpression;
          if (shouldCaptureInTempVariable(leftExpression)) {
            capturedLeft = ts2.createTempVariable(hoistVariableDeclaration);
            leftExpression = ts2.createAssignment(capturedLeft, leftExpression);
          }
          var rightExpression = capturedLeft;
          var thisArg;
          for (var i = 0; i < chain.length; i++) {
            var segment = chain[i];
            switch (segment.kind) {
              case 194:
              case 195:
                if (i === chain.length - 1 && captureThisArg) {
                  if (shouldCaptureInTempVariable(rightExpression)) {
                    thisArg = ts2.createTempVariable(hoistVariableDeclaration);
                    rightExpression = ts2.createAssignment(thisArg, rightExpression);
                  } else {
                    thisArg = rightExpression;
                  }
                }
                rightExpression = segment.kind === 194 ? ts2.createPropertyAccess(rightExpression, ts2.visitNode(segment.name, visitor, ts2.isIdentifier)) : ts2.createElementAccess(rightExpression, ts2.visitNode(segment.argumentExpression, visitor, ts2.isExpression));
                break;
              case 196:
                if (i === 0 && leftThisArg) {
                  rightExpression = ts2.createFunctionCall(rightExpression, leftThisArg.kind === 102 ? ts2.createThis() : leftThisArg, ts2.visitNodes(segment.arguments, visitor, ts2.isExpression));
                } else {
                  rightExpression = ts2.createCall(rightExpression, void 0, ts2.visitNodes(segment.arguments, visitor, ts2.isExpression));
                }
                break;
            }
            ts2.setOriginalNode(rightExpression, segment);
          }
          var target = isDelete ? ts2.createConditional(createNotNullCondition(leftExpression, capturedLeft, true), ts2.createTrue(), ts2.createDelete(rightExpression)) : ts2.createConditional(createNotNullCondition(leftExpression, capturedLeft, true), ts2.createVoidZero(), rightExpression);
          return thisArg ? ts2.createSyntheticReferenceExpression(target, thisArg) : target;
        }
        function createNotNullCondition(left, right, invert) {
          return ts2.createBinary(ts2.createBinary(left, ts2.createToken(invert ? 36 : 37), ts2.createNull()), ts2.createToken(invert ? 56 : 55), ts2.createBinary(right, ts2.createToken(invert ? 36 : 37), ts2.createVoidZero()));
        }
        function transformNullishCoalescingExpression(node) {
          var left = ts2.visitNode(node.left, visitor, ts2.isExpression);
          var right = left;
          if (shouldCaptureInTempVariable(left)) {
            right = ts2.createTempVariable(hoistVariableDeclaration);
            left = ts2.createAssignment(right, left);
          }
          return ts2.createConditional(createNotNullCondition(left, right), right, ts2.visitNode(node.right, visitor, ts2.isExpression));
        }
        function shouldCaptureInTempVariable(expression) {
          return !ts2.isIdentifier(expression) && expression.kind !== 104 && expression.kind !== 102;
        }
        function visitDeleteExpression(node) {
          return ts2.isOptionalChain(ts2.skipParentheses(node.expression)) ? ts2.setOriginalNode(visitNonOptionalExpression(node.expression, false, true), node) : ts2.updateDelete(node, ts2.visitNode(node.expression, visitor, ts2.isExpression));
        }
      }
      ts2.transformES2020 = transformES2020;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function transformESNext(context) {
        return ts2.chainBundle(transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitor(node) {
          if ((node.transformFlags & 4) === 0) {
            return node;
          }
          switch (node.kind) {
            default:
              return ts2.visitEachChild(node, visitor, context);
          }
        }
      }
      ts2.transformESNext = transformESNext;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function transformJsx(context) {
        var compilerOptions = context.getCompilerOptions();
        var currentSourceFile;
        return ts2.chainBundle(transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          currentSourceFile = node;
          var visited = ts2.visitEachChild(node, visitor, context);
          ts2.addEmitHelpers(visited, context.readEmitHelpers());
          return visited;
        }
        function visitor(node) {
          if (node.transformFlags & 2) {
            return visitorWorker(node);
          } else {
            return node;
          }
        }
        function visitorWorker(node) {
          switch (node.kind) {
            case 266:
              return visitJsxElement(node, false);
            case 267:
              return visitJsxSelfClosingElement(node, false);
            case 270:
              return visitJsxFragment(node, false);
            case 276:
              return visitJsxExpression(node);
            default:
              return ts2.visitEachChild(node, visitor, context);
          }
        }
        function transformJsxChildToExpression(node) {
          switch (node.kind) {
            case 11:
              return visitJsxText(node);
            case 276:
              return visitJsxExpression(node);
            case 266:
              return visitJsxElement(node, true);
            case 267:
              return visitJsxSelfClosingElement(node, true);
            case 270:
              return visitJsxFragment(node, true);
            default:
              return ts2.Debug.failBadSyntaxKind(node);
          }
        }
        function visitJsxElement(node, isChild) {
          return visitJsxOpeningLikeElement(node.openingElement, node.children, isChild, node);
        }
        function visitJsxSelfClosingElement(node, isChild) {
          return visitJsxOpeningLikeElement(node, void 0, isChild, node);
        }
        function visitJsxFragment(node, isChild) {
          return visitJsxOpeningFragment(node.openingFragment, node.children, isChild, node);
        }
        function visitJsxOpeningLikeElement(node, children, isChild, location) {
          var tagName = getTagName(node);
          var objectProperties;
          var attrs = node.attributes.properties;
          if (attrs.length === 0) {
            objectProperties = ts2.createNull();
          } else {
            var segments = ts2.flatten(ts2.spanMap(attrs, ts2.isJsxSpreadAttribute, function(attrs2, isSpread) {
              return isSpread ? ts2.map(attrs2, transformJsxSpreadAttributeToExpression) : ts2.createObjectLiteral(ts2.map(attrs2, transformJsxAttributeToObjectLiteralElement));
            }));
            if (ts2.isJsxSpreadAttribute(attrs[0])) {
              segments.unshift(ts2.createObjectLiteral());
            }
            objectProperties = ts2.singleOrUndefined(segments);
            if (!objectProperties) {
              objectProperties = ts2.createAssignHelper(context, segments);
            }
          }
          var element = ts2.createExpressionForJsxElement(context.getEmitResolver().getJsxFactoryEntity(currentSourceFile), compilerOptions.reactNamespace, tagName, objectProperties, ts2.mapDefined(children, transformJsxChildToExpression), node, location);
          if (isChild) {
            ts2.startOnNewLine(element);
          }
          return element;
        }
        function visitJsxOpeningFragment(node, children, isChild, location) {
          var element = ts2.createExpressionForJsxFragment(context.getEmitResolver().getJsxFactoryEntity(currentSourceFile), compilerOptions.reactNamespace, ts2.mapDefined(children, transformJsxChildToExpression), node, location);
          if (isChild) {
            ts2.startOnNewLine(element);
          }
          return element;
        }
        function transformJsxSpreadAttributeToExpression(node) {
          return ts2.visitNode(node.expression, visitor, ts2.isExpression);
        }
        function transformJsxAttributeToObjectLiteralElement(node) {
          var name = getAttributeName(node);
          var expression = transformJsxAttributeInitializer(node.initializer);
          return ts2.createPropertyAssignment(name, expression);
        }
        function transformJsxAttributeInitializer(node) {
          if (node === void 0) {
            return ts2.createTrue();
          } else if (node.kind === 10) {
            var literal = ts2.createLiteral(tryDecodeEntities(node.text) || node.text);
            literal.singleQuote = node.singleQuote !== void 0 ? node.singleQuote : !ts2.isStringDoubleQuoted(node, currentSourceFile);
            return ts2.setTextRange(literal, node);
          } else if (node.kind === 276) {
            if (node.expression === void 0) {
              return ts2.createTrue();
            }
            return visitJsxExpression(node);
          } else {
            return ts2.Debug.failBadSyntaxKind(node);
          }
        }
        function visitJsxText(node) {
          var fixed = fixupWhitespaceAndDecodeEntities(node.text);
          return fixed === void 0 ? void 0 : ts2.createLiteral(fixed);
        }
        function fixupWhitespaceAndDecodeEntities(text) {
          var acc;
          var firstNonWhitespace = 0;
          var lastNonWhitespace = -1;
          for (var i = 0; i < text.length; i++) {
            var c = text.charCodeAt(i);
            if (ts2.isLineBreak(c)) {
              if (firstNonWhitespace !== -1 && lastNonWhitespace !== -1) {
                acc = addLineOfJsxText(acc, text.substr(firstNonWhitespace, lastNonWhitespace - firstNonWhitespace + 1));
              }
              firstNonWhitespace = -1;
            } else if (!ts2.isWhiteSpaceSingleLine(c)) {
              lastNonWhitespace = i;
              if (firstNonWhitespace === -1) {
                firstNonWhitespace = i;
              }
            }
          }
          return firstNonWhitespace !== -1 ? addLineOfJsxText(acc, text.substr(firstNonWhitespace)) : acc;
        }
        function addLineOfJsxText(acc, trimmedLine) {
          var decoded = decodeEntities(trimmedLine);
          return acc === void 0 ? decoded : acc + " " + decoded;
        }
        function decodeEntities(text) {
          return text.replace(/&((#((\d+)|x([\da-fA-F]+)))|(\w+));/g, function(match, _all, _number, _digits, decimal, hex, word) {
            if (decimal) {
              return ts2.utf16EncodeAsString(parseInt(decimal, 10));
            } else if (hex) {
              return ts2.utf16EncodeAsString(parseInt(hex, 16));
            } else {
              var ch = entities.get(word);
              return ch ? ts2.utf16EncodeAsString(ch) : match;
            }
          });
        }
        function tryDecodeEntities(text) {
          var decoded = decodeEntities(text);
          return decoded === text ? void 0 : decoded;
        }
        function getTagName(node) {
          if (node.kind === 266) {
            return getTagName(node.openingElement);
          } else {
            var name = node.tagName;
            if (ts2.isIdentifier(name) && ts2.isIntrinsicJsxName(name.escapedText)) {
              return ts2.createLiteral(ts2.idText(name));
            } else {
              return ts2.createExpressionFromEntityName(name);
            }
          }
        }
        function getAttributeName(node) {
          var name = node.name;
          var text = ts2.idText(name);
          if (/^[A-Za-z_]\w*$/.test(text)) {
            return name;
          } else {
            return ts2.createLiteral(text);
          }
        }
        function visitJsxExpression(node) {
          return ts2.visitNode(node.expression, visitor, ts2.isExpression);
        }
      }
      ts2.transformJsx = transformJsx;
      var entities = ts2.createMapFromTemplate({
        quot: 34,
        amp: 38,
        apos: 39,
        lt: 60,
        gt: 62,
        nbsp: 160,
        iexcl: 161,
        cent: 162,
        pound: 163,
        curren: 164,
        yen: 165,
        brvbar: 166,
        sect: 167,
        uml: 168,
        copy: 169,
        ordf: 170,
        laquo: 171,
        not: 172,
        shy: 173,
        reg: 174,
        macr: 175,
        deg: 176,
        plusmn: 177,
        sup2: 178,
        sup3: 179,
        acute: 180,
        micro: 181,
        para: 182,
        middot: 183,
        cedil: 184,
        sup1: 185,
        ordm: 186,
        raquo: 187,
        frac14: 188,
        frac12: 189,
        frac34: 190,
        iquest: 191,
        Agrave: 192,
        Aacute: 193,
        Acirc: 194,
        Atilde: 195,
        Auml: 196,
        Aring: 197,
        AElig: 198,
        Ccedil: 199,
        Egrave: 200,
        Eacute: 201,
        Ecirc: 202,
        Euml: 203,
        Igrave: 204,
        Iacute: 205,
        Icirc: 206,
        Iuml: 207,
        ETH: 208,
        Ntilde: 209,
        Ograve: 210,
        Oacute: 211,
        Ocirc: 212,
        Otilde: 213,
        Ouml: 214,
        times: 215,
        Oslash: 216,
        Ugrave: 217,
        Uacute: 218,
        Ucirc: 219,
        Uuml: 220,
        Yacute: 221,
        THORN: 222,
        szlig: 223,
        agrave: 224,
        aacute: 225,
        acirc: 226,
        atilde: 227,
        auml: 228,
        aring: 229,
        aelig: 230,
        ccedil: 231,
        egrave: 232,
        eacute: 233,
        ecirc: 234,
        euml: 235,
        igrave: 236,
        iacute: 237,
        icirc: 238,
        iuml: 239,
        eth: 240,
        ntilde: 241,
        ograve: 242,
        oacute: 243,
        ocirc: 244,
        otilde: 245,
        ouml: 246,
        divide: 247,
        oslash: 248,
        ugrave: 249,
        uacute: 250,
        ucirc: 251,
        uuml: 252,
        yacute: 253,
        thorn: 254,
        yuml: 255,
        OElig: 338,
        oelig: 339,
        Scaron: 352,
        scaron: 353,
        Yuml: 376,
        fnof: 402,
        circ: 710,
        tilde: 732,
        Alpha: 913,
        Beta: 914,
        Gamma: 915,
        Delta: 916,
        Epsilon: 917,
        Zeta: 918,
        Eta: 919,
        Theta: 920,
        Iota: 921,
        Kappa: 922,
        Lambda: 923,
        Mu: 924,
        Nu: 925,
        Xi: 926,
        Omicron: 927,
        Pi: 928,
        Rho: 929,
        Sigma: 931,
        Tau: 932,
        Upsilon: 933,
        Phi: 934,
        Chi: 935,
        Psi: 936,
        Omega: 937,
        alpha: 945,
        beta: 946,
        gamma: 947,
        delta: 948,
        epsilon: 949,
        zeta: 950,
        eta: 951,
        theta: 952,
        iota: 953,
        kappa: 954,
        lambda: 955,
        mu: 956,
        nu: 957,
        xi: 958,
        omicron: 959,
        pi: 960,
        rho: 961,
        sigmaf: 962,
        sigma: 963,
        tau: 964,
        upsilon: 965,
        phi: 966,
        chi: 967,
        psi: 968,
        omega: 969,
        thetasym: 977,
        upsih: 978,
        piv: 982,
        ensp: 8194,
        emsp: 8195,
        thinsp: 8201,
        zwnj: 8204,
        zwj: 8205,
        lrm: 8206,
        rlm: 8207,
        ndash: 8211,
        mdash: 8212,
        lsquo: 8216,
        rsquo: 8217,
        sbquo: 8218,
        ldquo: 8220,
        rdquo: 8221,
        bdquo: 8222,
        dagger: 8224,
        Dagger: 8225,
        bull: 8226,
        hellip: 8230,
        permil: 8240,
        prime: 8242,
        Prime: 8243,
        lsaquo: 8249,
        rsaquo: 8250,
        oline: 8254,
        frasl: 8260,
        euro: 8364,
        image: 8465,
        weierp: 8472,
        real: 8476,
        trade: 8482,
        alefsym: 8501,
        larr: 8592,
        uarr: 8593,
        rarr: 8594,
        darr: 8595,
        harr: 8596,
        crarr: 8629,
        lArr: 8656,
        uArr: 8657,
        rArr: 8658,
        dArr: 8659,
        hArr: 8660,
        forall: 8704,
        part: 8706,
        exist: 8707,
        empty: 8709,
        nabla: 8711,
        isin: 8712,
        notin: 8713,
        ni: 8715,
        prod: 8719,
        sum: 8721,
        minus: 8722,
        lowast: 8727,
        radic: 8730,
        prop: 8733,
        infin: 8734,
        ang: 8736,
        and: 8743,
        or: 8744,
        cap: 8745,
        cup: 8746,
        int: 8747,
        there4: 8756,
        sim: 8764,
        cong: 8773,
        asymp: 8776,
        ne: 8800,
        equiv: 8801,
        le: 8804,
        ge: 8805,
        sub: 8834,
        sup: 8835,
        nsub: 8836,
        sube: 8838,
        supe: 8839,
        oplus: 8853,
        otimes: 8855,
        perp: 8869,
        sdot: 8901,
        lceil: 8968,
        rceil: 8969,
        lfloor: 8970,
        rfloor: 8971,
        lang: 9001,
        rang: 9002,
        loz: 9674,
        spades: 9824,
        clubs: 9827,
        hearts: 9829,
        diams: 9830
      });
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function transformES2016(context) {
        var hoistVariableDeclaration = context.hoistVariableDeclaration;
        return ts2.chainBundle(transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitor(node) {
          if ((node.transformFlags & 128) === 0) {
            return node;
          }
          switch (node.kind) {
            case 209:
              return visitBinaryExpression(node);
            default:
              return ts2.visitEachChild(node, visitor, context);
          }
        }
        function visitBinaryExpression(node) {
          switch (node.operatorToken.kind) {
            case 66:
              return visitExponentiationAssignmentExpression(node);
            case 42:
              return visitExponentiationExpression(node);
            default:
              return ts2.visitEachChild(node, visitor, context);
          }
        }
        function visitExponentiationAssignmentExpression(node) {
          var target;
          var value;
          var left = ts2.visitNode(node.left, visitor, ts2.isExpression);
          var right = ts2.visitNode(node.right, visitor, ts2.isExpression);
          if (ts2.isElementAccessExpression(left)) {
            var expressionTemp = ts2.createTempVariable(hoistVariableDeclaration);
            var argumentExpressionTemp = ts2.createTempVariable(hoistVariableDeclaration);
            target = ts2.setTextRange(ts2.createElementAccess(ts2.setTextRange(ts2.createAssignment(expressionTemp, left.expression), left.expression), ts2.setTextRange(ts2.createAssignment(argumentExpressionTemp, left.argumentExpression), left.argumentExpression)), left);
            value = ts2.setTextRange(ts2.createElementAccess(expressionTemp, argumentExpressionTemp), left);
          } else if (ts2.isPropertyAccessExpression(left)) {
            var expressionTemp = ts2.createTempVariable(hoistVariableDeclaration);
            target = ts2.setTextRange(ts2.createPropertyAccess(ts2.setTextRange(ts2.createAssignment(expressionTemp, left.expression), left.expression), left.name), left);
            value = ts2.setTextRange(ts2.createPropertyAccess(expressionTemp, left.name), left);
          } else {
            target = left;
            value = left;
          }
          return ts2.setTextRange(ts2.createAssignment(target, ts2.createMathPow(value, right, node)), node);
        }
        function visitExponentiationExpression(node) {
          var left = ts2.visitNode(node.left, visitor, ts2.isExpression);
          var right = ts2.visitNode(node.right, visitor, ts2.isExpression);
          return ts2.createMathPow(left, right, node);
        }
      }
      ts2.transformES2016 = transformES2016;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var ES2015SubstitutionFlags;
      (function(ES2015SubstitutionFlags2) {
        ES2015SubstitutionFlags2[ES2015SubstitutionFlags2["CapturedThis"] = 1] = "CapturedThis";
        ES2015SubstitutionFlags2[ES2015SubstitutionFlags2["BlockScopedBindings"] = 2] = "BlockScopedBindings";
      })(ES2015SubstitutionFlags || (ES2015SubstitutionFlags = {}));
      var LoopOutParameterFlags;
      (function(LoopOutParameterFlags2) {
        LoopOutParameterFlags2[LoopOutParameterFlags2["Body"] = 1] = "Body";
        LoopOutParameterFlags2[LoopOutParameterFlags2["Initializer"] = 2] = "Initializer";
      })(LoopOutParameterFlags || (LoopOutParameterFlags = {}));
      var CopyDirection;
      (function(CopyDirection2) {
        CopyDirection2[CopyDirection2["ToOriginal"] = 0] = "ToOriginal";
        CopyDirection2[CopyDirection2["ToOutParameter"] = 1] = "ToOutParameter";
      })(CopyDirection || (CopyDirection = {}));
      var Jump;
      (function(Jump2) {
        Jump2[Jump2["Break"] = 2] = "Break";
        Jump2[Jump2["Continue"] = 4] = "Continue";
        Jump2[Jump2["Return"] = 8] = "Return";
      })(Jump || (Jump = {}));
      var HierarchyFacts;
      (function(HierarchyFacts2) {
        HierarchyFacts2[HierarchyFacts2["None"] = 0] = "None";
        HierarchyFacts2[HierarchyFacts2["Function"] = 1] = "Function";
        HierarchyFacts2[HierarchyFacts2["ArrowFunction"] = 2] = "ArrowFunction";
        HierarchyFacts2[HierarchyFacts2["AsyncFunctionBody"] = 4] = "AsyncFunctionBody";
        HierarchyFacts2[HierarchyFacts2["NonStaticClassElement"] = 8] = "NonStaticClassElement";
        HierarchyFacts2[HierarchyFacts2["CapturesThis"] = 16] = "CapturesThis";
        HierarchyFacts2[HierarchyFacts2["ExportedVariableStatement"] = 32] = "ExportedVariableStatement";
        HierarchyFacts2[HierarchyFacts2["TopLevel"] = 64] = "TopLevel";
        HierarchyFacts2[HierarchyFacts2["Block"] = 128] = "Block";
        HierarchyFacts2[HierarchyFacts2["IterationStatement"] = 256] = "IterationStatement";
        HierarchyFacts2[HierarchyFacts2["IterationStatementBlock"] = 512] = "IterationStatementBlock";
        HierarchyFacts2[HierarchyFacts2["IterationContainer"] = 1024] = "IterationContainer";
        HierarchyFacts2[HierarchyFacts2["ForStatement"] = 2048] = "ForStatement";
        HierarchyFacts2[HierarchyFacts2["ForInOrForOfStatement"] = 4096] = "ForInOrForOfStatement";
        HierarchyFacts2[HierarchyFacts2["ConstructorWithCapturedSuper"] = 8192] = "ConstructorWithCapturedSuper";
        HierarchyFacts2[HierarchyFacts2["AncestorFactsMask"] = 16383] = "AncestorFactsMask";
        HierarchyFacts2[HierarchyFacts2["BlockScopeIncludes"] = 0] = "BlockScopeIncludes";
        HierarchyFacts2[HierarchyFacts2["BlockScopeExcludes"] = 7104] = "BlockScopeExcludes";
        HierarchyFacts2[HierarchyFacts2["SourceFileIncludes"] = 64] = "SourceFileIncludes";
        HierarchyFacts2[HierarchyFacts2["SourceFileExcludes"] = 8064] = "SourceFileExcludes";
        HierarchyFacts2[HierarchyFacts2["FunctionIncludes"] = 65] = "FunctionIncludes";
        HierarchyFacts2[HierarchyFacts2["FunctionExcludes"] = 16286] = "FunctionExcludes";
        HierarchyFacts2[HierarchyFacts2["AsyncFunctionBodyIncludes"] = 69] = "AsyncFunctionBodyIncludes";
        HierarchyFacts2[HierarchyFacts2["AsyncFunctionBodyExcludes"] = 16278] = "AsyncFunctionBodyExcludes";
        HierarchyFacts2[HierarchyFacts2["ArrowFunctionIncludes"] = 66] = "ArrowFunctionIncludes";
        HierarchyFacts2[HierarchyFacts2["ArrowFunctionExcludes"] = 15232] = "ArrowFunctionExcludes";
        HierarchyFacts2[HierarchyFacts2["ConstructorIncludes"] = 73] = "ConstructorIncludes";
        HierarchyFacts2[HierarchyFacts2["ConstructorExcludes"] = 16278] = "ConstructorExcludes";
        HierarchyFacts2[HierarchyFacts2["DoOrWhileStatementIncludes"] = 1280] = "DoOrWhileStatementIncludes";
        HierarchyFacts2[HierarchyFacts2["DoOrWhileStatementExcludes"] = 0] = "DoOrWhileStatementExcludes";
        HierarchyFacts2[HierarchyFacts2["ForStatementIncludes"] = 3328] = "ForStatementIncludes";
        HierarchyFacts2[HierarchyFacts2["ForStatementExcludes"] = 5056] = "ForStatementExcludes";
        HierarchyFacts2[HierarchyFacts2["ForInOrForOfStatementIncludes"] = 5376] = "ForInOrForOfStatementIncludes";
        HierarchyFacts2[HierarchyFacts2["ForInOrForOfStatementExcludes"] = 3008] = "ForInOrForOfStatementExcludes";
        HierarchyFacts2[HierarchyFacts2["BlockIncludes"] = 128] = "BlockIncludes";
        HierarchyFacts2[HierarchyFacts2["BlockExcludes"] = 6976] = "BlockExcludes";
        HierarchyFacts2[HierarchyFacts2["IterationStatementBlockIncludes"] = 512] = "IterationStatementBlockIncludes";
        HierarchyFacts2[HierarchyFacts2["IterationStatementBlockExcludes"] = 7104] = "IterationStatementBlockExcludes";
        HierarchyFacts2[HierarchyFacts2["NewTarget"] = 16384] = "NewTarget";
        HierarchyFacts2[HierarchyFacts2["CapturedLexicalThis"] = 32768] = "CapturedLexicalThis";
        HierarchyFacts2[HierarchyFacts2["SubtreeFactsMask"] = -16384] = "SubtreeFactsMask";
        HierarchyFacts2[HierarchyFacts2["ArrowFunctionSubtreeExcludes"] = 0] = "ArrowFunctionSubtreeExcludes";
        HierarchyFacts2[HierarchyFacts2["FunctionSubtreeExcludes"] = 49152] = "FunctionSubtreeExcludes";
      })(HierarchyFacts || (HierarchyFacts = {}));
      function transformES2015(context) {
        var startLexicalEnvironment = context.startLexicalEnvironment, resumeLexicalEnvironment = context.resumeLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var compilerOptions = context.getCompilerOptions();
        var resolver = context.getEmitResolver();
        var previousOnSubstituteNode = context.onSubstituteNode;
        var previousOnEmitNode = context.onEmitNode;
        context.onEmitNode = onEmitNode;
        context.onSubstituteNode = onSubstituteNode;
        var currentSourceFile;
        var currentText;
        var hierarchyFacts;
        var taggedTemplateStringDeclarations;
        function recordTaggedTemplateString(temp) {
          taggedTemplateStringDeclarations = ts2.append(taggedTemplateStringDeclarations, ts2.createVariableDeclaration(temp));
        }
        var convertedLoopState;
        var enabledSubstitutions;
        return ts2.chainBundle(transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          currentSourceFile = node;
          currentText = node.text;
          var visited = visitSourceFile(node);
          ts2.addEmitHelpers(visited, context.readEmitHelpers());
          currentSourceFile = void 0;
          currentText = void 0;
          taggedTemplateStringDeclarations = void 0;
          hierarchyFacts = 0;
          return visited;
        }
        function enterSubtree(excludeFacts, includeFacts) {
          var ancestorFacts = hierarchyFacts;
          hierarchyFacts = (hierarchyFacts & ~excludeFacts | includeFacts) & 16383;
          return ancestorFacts;
        }
        function exitSubtree(ancestorFacts, excludeFacts, includeFacts) {
          hierarchyFacts = (hierarchyFacts & ~excludeFacts | includeFacts) & -16384 | ancestorFacts;
        }
        function isReturnVoidStatementInConstructorWithCapturedSuper(node) {
          return (hierarchyFacts & 8192) !== 0 && node.kind === 235 && !node.expression;
        }
        function shouldVisitNode(node) {
          return (node.transformFlags & 256) !== 0 || convertedLoopState !== void 0 || hierarchyFacts & 8192 && (ts2.isStatement(node) || node.kind === 223) || ts2.isIterationStatement(node, false) && shouldConvertIterationStatement(node) || (ts2.getEmitFlags(node) & 33554432) !== 0;
        }
        function visitor(node) {
          if (shouldVisitNode(node)) {
            return visitJavaScript(node);
          } else {
            return node;
          }
        }
        function callExpressionVisitor(node) {
          if (node.kind === 102) {
            return visitSuperKeyword(true);
          }
          return visitor(node);
        }
        function visitJavaScript(node) {
          switch (node.kind) {
            case 120:
              return void 0;
            case 245:
              return visitClassDeclaration(node);
            case 214:
              return visitClassExpression(node);
            case 156:
              return visitParameter(node);
            case 244:
              return visitFunctionDeclaration(node);
            case 202:
              return visitArrowFunction(node);
            case 201:
              return visitFunctionExpression(node);
            case 242:
              return visitVariableDeclaration(node);
            case 75:
              return visitIdentifier(node);
            case 243:
              return visitVariableDeclarationList(node);
            case 237:
              return visitSwitchStatement(node);
            case 251:
              return visitCaseBlock(node);
            case 223:
              return visitBlock(node, false);
            case 234:
            case 233:
              return visitBreakOrContinueStatement(node);
            case 238:
              return visitLabeledStatement(node);
            case 228:
            case 229:
              return visitDoOrWhileStatement(node, void 0);
            case 230:
              return visitForStatement(node, void 0);
            case 231:
              return visitForInStatement(node, void 0);
            case 232:
              return visitForOfStatement(node, void 0);
            case 226:
              return visitExpressionStatement(node);
            case 193:
              return visitObjectLiteralExpression(node);
            case 280:
              return visitCatchClause(node);
            case 282:
              return visitShorthandPropertyAssignment(node);
            case 154:
              return visitComputedPropertyName(node);
            case 192:
              return visitArrayLiteralExpression(node);
            case 196:
              return visitCallExpression(node);
            case 197:
              return visitNewExpression(node);
            case 200:
              return visitParenthesizedExpression(node, true);
            case 209:
              return visitBinaryExpression(node, true);
            case 14:
            case 15:
            case 16:
            case 17:
              return visitTemplateLiteral(node);
            case 10:
              return visitStringLiteral(node);
            case 8:
              return visitNumericLiteral(node);
            case 198:
              return visitTaggedTemplateExpression(node);
            case 211:
              return visitTemplateExpression(node);
            case 212:
              return visitYieldExpression(node);
            case 213:
              return visitSpreadElement(node);
            case 102:
              return visitSuperKeyword(false);
            case 104:
              return visitThisKeyword(node);
            case 219:
              return visitMetaProperty(node);
            case 161:
              return visitMethodDeclaration(node);
            case 163:
            case 164:
              return visitAccessorDeclaration(node);
            case 225:
              return visitVariableStatement(node);
            case 235:
              return visitReturnStatement(node);
            default:
              return ts2.visitEachChild(node, visitor, context);
          }
        }
        function visitSourceFile(node) {
          var ancestorFacts = enterSubtree(8064, 64);
          var prologue = [];
          var statements = [];
          startLexicalEnvironment();
          var statementOffset = ts2.addStandardPrologue(prologue, node.statements, false);
          statementOffset = ts2.addCustomPrologue(prologue, node.statements, statementOffset, visitor);
          ts2.addRange(statements, ts2.visitNodes(node.statements, visitor, ts2.isStatement, statementOffset));
          if (taggedTemplateStringDeclarations) {
            statements.push(ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList(taggedTemplateStringDeclarations)));
          }
          ts2.mergeLexicalEnvironment(prologue, endLexicalEnvironment());
          insertCaptureThisForNodeIfNeeded(prologue, node);
          exitSubtree(ancestorFacts, 0, 0);
          return ts2.updateSourceFileNode(node, ts2.setTextRange(ts2.createNodeArray(ts2.concatenate(prologue, statements)), node.statements));
        }
        function visitSwitchStatement(node) {
          if (convertedLoopState !== void 0) {
            var savedAllowedNonLabeledJumps = convertedLoopState.allowedNonLabeledJumps;
            convertedLoopState.allowedNonLabeledJumps |= 2;
            var result = ts2.visitEachChild(node, visitor, context);
            convertedLoopState.allowedNonLabeledJumps = savedAllowedNonLabeledJumps;
            return result;
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitCaseBlock(node) {
          var ancestorFacts = enterSubtree(7104, 0);
          var updated = ts2.visitEachChild(node, visitor, context);
          exitSubtree(ancestorFacts, 0, 0);
          return updated;
        }
        function returnCapturedThis(node) {
          return ts2.setOriginalNode(ts2.createReturn(ts2.createFileLevelUniqueName("_this")), node);
        }
        function visitReturnStatement(node) {
          if (convertedLoopState) {
            convertedLoopState.nonLocalJumps |= 8;
            if (isReturnVoidStatementInConstructorWithCapturedSuper(node)) {
              node = returnCapturedThis(node);
            }
            return ts2.createReturn(ts2.createObjectLiteral([
              ts2.createPropertyAssignment(ts2.createIdentifier("value"), node.expression ? ts2.visitNode(node.expression, visitor, ts2.isExpression) : ts2.createVoidZero())
            ]));
          } else if (isReturnVoidStatementInConstructorWithCapturedSuper(node)) {
            return returnCapturedThis(node);
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitThisKeyword(node) {
          if (hierarchyFacts & 2) {
            hierarchyFacts |= 32768;
          }
          if (convertedLoopState) {
            if (hierarchyFacts & 2) {
              convertedLoopState.containsLexicalThis = true;
              return node;
            }
            return convertedLoopState.thisName || (convertedLoopState.thisName = ts2.createUniqueName("this"));
          }
          return node;
        }
        function visitIdentifier(node) {
          if (!convertedLoopState) {
            return node;
          }
          if (ts2.isGeneratedIdentifier(node)) {
            return node;
          }
          if (node.escapedText !== "arguments" || !resolver.isArgumentsLocalBinding(node)) {
            return node;
          }
          return convertedLoopState.argumentsName || (convertedLoopState.argumentsName = ts2.createUniqueName("arguments"));
        }
        function visitBreakOrContinueStatement(node) {
          if (convertedLoopState) {
            var jump = node.kind === 234 ? 2 : 4;
            var canUseBreakOrContinue = node.label && convertedLoopState.labels && convertedLoopState.labels.get(ts2.idText(node.label)) || !node.label && convertedLoopState.allowedNonLabeledJumps & jump;
            if (!canUseBreakOrContinue) {
              var labelMarker = void 0;
              var label = node.label;
              if (!label) {
                if (node.kind === 234) {
                  convertedLoopState.nonLocalJumps |= 2;
                  labelMarker = "break";
                } else {
                  convertedLoopState.nonLocalJumps |= 4;
                  labelMarker = "continue";
                }
              } else {
                if (node.kind === 234) {
                  labelMarker = "break-" + label.escapedText;
                  setLabeledJump(convertedLoopState, true, ts2.idText(label), labelMarker);
                } else {
                  labelMarker = "continue-" + label.escapedText;
                  setLabeledJump(convertedLoopState, false, ts2.idText(label), labelMarker);
                }
              }
              var returnExpression = ts2.createLiteral(labelMarker);
              if (convertedLoopState.loopOutParameters.length) {
                var outParams = convertedLoopState.loopOutParameters;
                var expr = void 0;
                for (var i = 0; i < outParams.length; i++) {
                  var copyExpr = copyOutParameter(outParams[i], 1);
                  if (i === 0) {
                    expr = copyExpr;
                  } else {
                    expr = ts2.createBinary(expr, 27, copyExpr);
                  }
                }
                returnExpression = ts2.createBinary(expr, 27, returnExpression);
              }
              return ts2.createReturn(returnExpression);
            }
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitClassDeclaration(node) {
          var variable = ts2.createVariableDeclaration(ts2.getLocalName(node, true), void 0, transformClassLikeDeclarationToExpression(node));
          ts2.setOriginalNode(variable, node);
          var statements = [];
          var statement = ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([variable]));
          ts2.setOriginalNode(statement, node);
          ts2.setTextRange(statement, node);
          ts2.startOnNewLine(statement);
          statements.push(statement);
          if (ts2.hasModifier(node, 1)) {
            var exportStatement = ts2.hasModifier(node, 512) ? ts2.createExportDefault(ts2.getLocalName(node)) : ts2.createExternalModuleExport(ts2.getLocalName(node));
            ts2.setOriginalNode(exportStatement, statement);
            statements.push(exportStatement);
          }
          var emitFlags = ts2.getEmitFlags(node);
          if ((emitFlags & 4194304) === 0) {
            statements.push(ts2.createEndOfDeclarationMarker(node));
            ts2.setEmitFlags(statement, emitFlags | 4194304);
          }
          return ts2.singleOrMany(statements);
        }
        function visitClassExpression(node) {
          return transformClassLikeDeclarationToExpression(node);
        }
        function transformClassLikeDeclarationToExpression(node) {
          if (node.name) {
            enableSubstitutionsForBlockScopedBindings();
          }
          var extendsClauseElement = ts2.getClassExtendsHeritageElement(node);
          var classFunction = ts2.createFunctionExpression(void 0, void 0, void 0, void 0, extendsClauseElement ? [ts2.createParameter(void 0, void 0, void 0, ts2.createFileLevelUniqueName("_super"))] : [], void 0, transformClassBody(node, extendsClauseElement));
          ts2.setEmitFlags(classFunction, ts2.getEmitFlags(node) & 65536 | 524288);
          var inner = ts2.createPartiallyEmittedExpression(classFunction);
          inner.end = node.end;
          ts2.setEmitFlags(inner, 1536);
          var outer = ts2.createPartiallyEmittedExpression(inner);
          outer.end = ts2.skipTrivia(currentText, node.pos);
          ts2.setEmitFlags(outer, 1536);
          var result = ts2.createParen(ts2.createCall(outer, void 0, extendsClauseElement ? [ts2.visitNode(extendsClauseElement.expression, visitor, ts2.isExpression)] : []));
          ts2.addSyntheticLeadingComment(result, 3, "* @class ");
          return result;
        }
        function transformClassBody(node, extendsClauseElement) {
          var statements = [];
          startLexicalEnvironment();
          addExtendsHelperIfNeeded(statements, node, extendsClauseElement);
          addConstructor(statements, node, extendsClauseElement);
          addClassMembers(statements, node);
          var closingBraceLocation = ts2.createTokenRange(ts2.skipTrivia(currentText, node.members.end), 19);
          var localName = ts2.getInternalName(node);
          var outer = ts2.createPartiallyEmittedExpression(localName);
          outer.end = closingBraceLocation.end;
          ts2.setEmitFlags(outer, 1536);
          var statement = ts2.createReturn(outer);
          statement.pos = closingBraceLocation.pos;
          ts2.setEmitFlags(statement, 1536 | 384);
          statements.push(statement);
          ts2.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          var block = ts2.createBlock(ts2.setTextRange(ts2.createNodeArray(statements), node.members), true);
          ts2.setEmitFlags(block, 1536);
          return block;
        }
        function addExtendsHelperIfNeeded(statements, node, extendsClauseElement) {
          if (extendsClauseElement) {
            statements.push(ts2.setTextRange(ts2.createExpressionStatement(createExtendsHelper(context, ts2.getInternalName(node))), extendsClauseElement));
          }
        }
        function addConstructor(statements, node, extendsClauseElement) {
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var ancestorFacts = enterSubtree(16278, 73);
          var constructor = ts2.getFirstConstructorWithBody(node);
          var hasSynthesizedSuper = hasSynthesizedDefaultSuperCall(constructor, extendsClauseElement !== void 0);
          var constructorFunction = ts2.createFunctionDeclaration(void 0, void 0, void 0, ts2.getInternalName(node), void 0, transformConstructorParameters(constructor, hasSynthesizedSuper), void 0, transformConstructorBody(constructor, node, extendsClauseElement, hasSynthesizedSuper));
          ts2.setTextRange(constructorFunction, constructor || node);
          if (extendsClauseElement) {
            ts2.setEmitFlags(constructorFunction, 8);
          }
          statements.push(constructorFunction);
          exitSubtree(ancestorFacts, 49152, 0);
          convertedLoopState = savedConvertedLoopState;
        }
        function transformConstructorParameters(constructor, hasSynthesizedSuper) {
          return ts2.visitParameterList(constructor && !hasSynthesizedSuper ? constructor.parameters : void 0, visitor, context) || [];
        }
        function createDefaultConstructorBody(node, isDerivedClass) {
          var statements = [];
          resumeLexicalEnvironment();
          ts2.mergeLexicalEnvironment(statements, endLexicalEnvironment());
          if (isDerivedClass) {
            statements.push(ts2.createReturn(createDefaultSuperCallOrThis()));
          }
          var statementsArray = ts2.createNodeArray(statements);
          ts2.setTextRange(statementsArray, node.members);
          var block = ts2.createBlock(statementsArray, true);
          ts2.setTextRange(block, node);
          ts2.setEmitFlags(block, 1536);
          return block;
        }
        function transformConstructorBody(constructor, node, extendsClauseElement, hasSynthesizedSuper) {
          var isDerivedClass = !!extendsClauseElement && ts2.skipOuterExpressions(extendsClauseElement.expression).kind !== 100;
          if (!constructor)
            return createDefaultConstructorBody(node, isDerivedClass);
          var prologue = [];
          var statements = [];
          resumeLexicalEnvironment();
          var statementOffset = 0;
          if (!hasSynthesizedSuper)
            statementOffset = ts2.addStandardPrologue(prologue, constructor.body.statements, false);
          addDefaultValueAssignmentsIfNeeded(statements, constructor);
          addRestParameterIfNeeded(statements, constructor, hasSynthesizedSuper);
          if (!hasSynthesizedSuper)
            statementOffset = ts2.addCustomPrologue(statements, constructor.body.statements, statementOffset, visitor);
          var superCallExpression;
          if (hasSynthesizedSuper) {
            superCallExpression = createDefaultSuperCallOrThis();
          } else if (isDerivedClass && statementOffset < constructor.body.statements.length) {
            var firstStatement = constructor.body.statements[statementOffset];
            if (ts2.isExpressionStatement(firstStatement) && ts2.isSuperCall(firstStatement.expression)) {
              superCallExpression = visitImmediateSuperCallInBody(firstStatement.expression);
            }
          }
          if (superCallExpression) {
            hierarchyFacts |= 8192;
            statementOffset++;
          }
          ts2.addRange(statements, ts2.visitNodes(constructor.body.statements, visitor, ts2.isStatement, statementOffset));
          ts2.mergeLexicalEnvironment(prologue, endLexicalEnvironment());
          insertCaptureNewTargetIfNeeded(prologue, constructor, false);
          if (isDerivedClass) {
            if (superCallExpression && statementOffset === constructor.body.statements.length && !(constructor.body.transformFlags & 4096)) {
              var superCall = ts2.cast(ts2.cast(superCallExpression, ts2.isBinaryExpression).left, ts2.isCallExpression);
              var returnStatement = ts2.createReturn(superCallExpression);
              ts2.setCommentRange(returnStatement, ts2.getCommentRange(superCall));
              ts2.setEmitFlags(superCall, 1536);
              statements.push(returnStatement);
            } else {
              insertCaptureThisForNode(statements, constructor, superCallExpression || createActualThis());
              if (!isSufficientlyCoveredByReturnStatements(constructor.body)) {
                statements.push(ts2.createReturn(ts2.createFileLevelUniqueName("_this")));
              }
            }
          } else {
            insertCaptureThisForNodeIfNeeded(prologue, constructor);
          }
          var block = ts2.createBlock(ts2.setTextRange(ts2.createNodeArray(ts2.concatenate(prologue, statements)), constructor.body.statements), true);
          ts2.setTextRange(block, constructor.body);
          return block;
        }
        function isSufficientlyCoveredByReturnStatements(statement) {
          if (statement.kind === 235) {
            return true;
          } else if (statement.kind === 227) {
            var ifStatement = statement;
            if (ifStatement.elseStatement) {
              return isSufficientlyCoveredByReturnStatements(ifStatement.thenStatement) && isSufficientlyCoveredByReturnStatements(ifStatement.elseStatement);
            }
          } else if (statement.kind === 223) {
            var lastStatement = ts2.lastOrUndefined(statement.statements);
            if (lastStatement && isSufficientlyCoveredByReturnStatements(lastStatement)) {
              return true;
            }
          }
          return false;
        }
        function createActualThis() {
          return ts2.setEmitFlags(ts2.createThis(), 4);
        }
        function createDefaultSuperCallOrThis() {
          return ts2.createLogicalOr(ts2.createLogicalAnd(ts2.createStrictInequality(ts2.createFileLevelUniqueName("_super"), ts2.createNull()), ts2.createFunctionApply(ts2.createFileLevelUniqueName("_super"), createActualThis(), ts2.createIdentifier("arguments"))), createActualThis());
        }
        function visitParameter(node) {
          if (node.dotDotDotToken) {
            return void 0;
          } else if (ts2.isBindingPattern(node.name)) {
            return ts2.setOriginalNode(ts2.setTextRange(ts2.createParameter(void 0, void 0, void 0, ts2.getGeneratedNameForNode(node), void 0, void 0, void 0), node), node);
          } else if (node.initializer) {
            return ts2.setOriginalNode(ts2.setTextRange(ts2.createParameter(void 0, void 0, void 0, node.name, void 0, void 0, void 0), node), node);
          } else {
            return node;
          }
        }
        function hasDefaultValueOrBindingPattern(node) {
          return node.initializer !== void 0 || ts2.isBindingPattern(node.name);
        }
        function addDefaultValueAssignmentsIfNeeded(statements, node) {
          if (!ts2.some(node.parameters, hasDefaultValueOrBindingPattern)) {
            return false;
          }
          var added = false;
          for (var _i = 0, _a = node.parameters; _i < _a.length; _i++) {
            var parameter = _a[_i];
            var name = parameter.name, initializer = parameter.initializer, dotDotDotToken = parameter.dotDotDotToken;
            if (dotDotDotToken) {
              continue;
            }
            if (ts2.isBindingPattern(name)) {
              added = insertDefaultValueAssignmentForBindingPattern(statements, parameter, name, initializer) || added;
            } else if (initializer) {
              insertDefaultValueAssignmentForInitializer(statements, parameter, name, initializer);
              added = true;
            }
          }
          return added;
        }
        function insertDefaultValueAssignmentForBindingPattern(statements, parameter, name, initializer) {
          if (name.elements.length > 0) {
            ts2.insertStatementAfterCustomPrologue(statements, ts2.setEmitFlags(ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList(ts2.flattenDestructuringBinding(parameter, visitor, context, 0, ts2.getGeneratedNameForNode(parameter)))), 1048576));
            return true;
          } else if (initializer) {
            ts2.insertStatementAfterCustomPrologue(statements, ts2.setEmitFlags(ts2.createExpressionStatement(ts2.createAssignment(ts2.getGeneratedNameForNode(parameter), ts2.visitNode(initializer, visitor, ts2.isExpression))), 1048576));
            return true;
          }
          return false;
        }
        function insertDefaultValueAssignmentForInitializer(statements, parameter, name, initializer) {
          initializer = ts2.visitNode(initializer, visitor, ts2.isExpression);
          var statement = ts2.createIf(ts2.createTypeCheck(ts2.getSynthesizedClone(name), "undefined"), ts2.setEmitFlags(ts2.setTextRange(ts2.createBlock([
            ts2.createExpressionStatement(ts2.setEmitFlags(ts2.setTextRange(ts2.createAssignment(ts2.setEmitFlags(ts2.getMutableClone(name), 48), ts2.setEmitFlags(initializer, 48 | ts2.getEmitFlags(initializer) | 1536)), parameter), 1536))
          ]), parameter), 1 | 32 | 384 | 1536));
          ts2.startOnNewLine(statement);
          ts2.setTextRange(statement, parameter);
          ts2.setEmitFlags(statement, 384 | 32 | 1048576 | 1536);
          ts2.insertStatementAfterCustomPrologue(statements, statement);
        }
        function shouldAddRestParameter(node, inConstructorWithSynthesizedSuper) {
          return !!(node && node.dotDotDotToken && !inConstructorWithSynthesizedSuper);
        }
        function addRestParameterIfNeeded(statements, node, inConstructorWithSynthesizedSuper) {
          var prologueStatements = [];
          var parameter = ts2.lastOrUndefined(node.parameters);
          if (!shouldAddRestParameter(parameter, inConstructorWithSynthesizedSuper)) {
            return false;
          }
          var declarationName = parameter.name.kind === 75 ? ts2.getMutableClone(parameter.name) : ts2.createTempVariable(void 0);
          ts2.setEmitFlags(declarationName, 48);
          var expressionName = parameter.name.kind === 75 ? ts2.getSynthesizedClone(parameter.name) : declarationName;
          var restIndex = node.parameters.length - 1;
          var temp = ts2.createLoopVariable();
          prologueStatements.push(ts2.setEmitFlags(ts2.setTextRange(ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([
            ts2.createVariableDeclaration(declarationName, void 0, ts2.createArrayLiteral([]))
          ])), parameter), 1048576));
          var forStatement = ts2.createFor(ts2.setTextRange(ts2.createVariableDeclarationList([
            ts2.createVariableDeclaration(temp, void 0, ts2.createLiteral(restIndex))
          ]), parameter), ts2.setTextRange(ts2.createLessThan(temp, ts2.createPropertyAccess(ts2.createIdentifier("arguments"), "length")), parameter), ts2.setTextRange(ts2.createPostfixIncrement(temp), parameter), ts2.createBlock([
            ts2.startOnNewLine(ts2.setTextRange(ts2.createExpressionStatement(ts2.createAssignment(ts2.createElementAccess(expressionName, restIndex === 0 ? temp : ts2.createSubtract(temp, ts2.createLiteral(restIndex))), ts2.createElementAccess(ts2.createIdentifier("arguments"), temp))), parameter))
          ]));
          ts2.setEmitFlags(forStatement, 1048576);
          ts2.startOnNewLine(forStatement);
          prologueStatements.push(forStatement);
          if (parameter.name.kind !== 75) {
            prologueStatements.push(ts2.setEmitFlags(ts2.setTextRange(ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList(ts2.flattenDestructuringBinding(parameter, visitor, context, 0, expressionName))), parameter), 1048576));
          }
          ts2.insertStatementsAfterCustomPrologue(statements, prologueStatements);
          return true;
        }
        function insertCaptureThisForNodeIfNeeded(statements, node) {
          if (hierarchyFacts & 32768 && node.kind !== 202) {
            insertCaptureThisForNode(statements, node, ts2.createThis());
            return true;
          }
          return false;
        }
        function insertCaptureThisForNode(statements, node, initializer) {
          enableSubstitutionsForCapturedThis();
          var captureThisStatement = ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([
            ts2.createVariableDeclaration(ts2.createFileLevelUniqueName("_this"), void 0, initializer)
          ]));
          ts2.setEmitFlags(captureThisStatement, 1536 | 1048576);
          ts2.setSourceMapRange(captureThisStatement, node);
          ts2.insertStatementAfterCustomPrologue(statements, captureThisStatement);
        }
        function insertCaptureNewTargetIfNeeded(statements, node, copyOnWrite) {
          if (hierarchyFacts & 16384) {
            var newTarget = void 0;
            switch (node.kind) {
              case 202:
                return statements;
              case 161:
              case 163:
              case 164:
                newTarget = ts2.createVoidZero();
                break;
              case 162:
                newTarget = ts2.createPropertyAccess(ts2.setEmitFlags(ts2.createThis(), 4), "constructor");
                break;
              case 244:
              case 201:
                newTarget = ts2.createConditional(ts2.createLogicalAnd(ts2.setEmitFlags(ts2.createThis(), 4), ts2.createBinary(ts2.setEmitFlags(ts2.createThis(), 4), 98, ts2.getLocalName(node))), ts2.createPropertyAccess(ts2.setEmitFlags(ts2.createThis(), 4), "constructor"), ts2.createVoidZero());
                break;
              default:
                return ts2.Debug.failBadSyntaxKind(node);
            }
            var captureNewTargetStatement = ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([
              ts2.createVariableDeclaration(ts2.createFileLevelUniqueName("_newTarget"), void 0, newTarget)
            ]));
            ts2.setEmitFlags(captureNewTargetStatement, 1536 | 1048576);
            if (copyOnWrite) {
              statements = statements.slice();
            }
            ts2.insertStatementAfterCustomPrologue(statements, captureNewTargetStatement);
          }
          return statements;
        }
        function addClassMembers(statements, node) {
          for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
            var member = _a[_i];
            switch (member.kind) {
              case 222:
                statements.push(transformSemicolonClassElementToStatement(member));
                break;
              case 161:
                statements.push(transformClassMethodDeclarationToStatement(getClassMemberPrefix(node, member), member, node));
                break;
              case 163:
              case 164:
                var accessors = ts2.getAllAccessorDeclarations(node.members, member);
                if (member === accessors.firstAccessor) {
                  statements.push(transformAccessorsToStatement(getClassMemberPrefix(node, member), accessors, node));
                }
                break;
              case 162:
                break;
              default:
                ts2.Debug.failBadSyntaxKind(member, currentSourceFile && currentSourceFile.fileName);
                break;
            }
          }
        }
        function transformSemicolonClassElementToStatement(member) {
          return ts2.setTextRange(ts2.createEmptyStatement(), member);
        }
        function transformClassMethodDeclarationToStatement(receiver, member, container) {
          var commentRange = ts2.getCommentRange(member);
          var sourceMapRange = ts2.getSourceMapRange(member);
          var memberFunction = transformFunctionLikeToExpression(member, member, void 0, container);
          var propertyName = ts2.visitNode(member.name, visitor, ts2.isPropertyName);
          var e;
          if (!ts2.isPrivateIdentifier(propertyName) && context.getCompilerOptions().useDefineForClassFields) {
            var name = ts2.isComputedPropertyName(propertyName) ? propertyName.expression : ts2.isIdentifier(propertyName) ? ts2.createStringLiteral(ts2.unescapeLeadingUnderscores(propertyName.escapedText)) : propertyName;
            e = ts2.createObjectDefinePropertyCall(receiver, name, ts2.createPropertyDescriptor({ value: memberFunction, enumerable: false, writable: true, configurable: true }));
          } else {
            var memberName = ts2.createMemberAccessForPropertyName(receiver, propertyName, member.name);
            e = ts2.createAssignment(memberName, memberFunction);
          }
          ts2.setEmitFlags(memberFunction, 1536);
          ts2.setSourceMapRange(memberFunction, sourceMapRange);
          var statement = ts2.setTextRange(ts2.createExpressionStatement(e), member);
          ts2.setOriginalNode(statement, member);
          ts2.setCommentRange(statement, commentRange);
          ts2.setEmitFlags(statement, 48);
          return statement;
        }
        function transformAccessorsToStatement(receiver, accessors, container) {
          var statement = ts2.createExpressionStatement(transformAccessorsToExpression(receiver, accessors, container, false));
          ts2.setEmitFlags(statement, 1536);
          ts2.setSourceMapRange(statement, ts2.getSourceMapRange(accessors.firstAccessor));
          return statement;
        }
        function transformAccessorsToExpression(receiver, _a, container, startsOnNewLine) {
          var firstAccessor = _a.firstAccessor, getAccessor = _a.getAccessor, setAccessor = _a.setAccessor;
          var target = ts2.getMutableClone(receiver);
          ts2.setEmitFlags(target, 1536 | 32);
          ts2.setSourceMapRange(target, firstAccessor.name);
          var visitedAccessorName = ts2.visitNode(firstAccessor.name, visitor, ts2.isPropertyName);
          if (ts2.isPrivateIdentifier(visitedAccessorName)) {
            return ts2.Debug.failBadSyntaxKind(visitedAccessorName, "Encountered unhandled private identifier while transforming ES2015.");
          }
          var propertyName = ts2.createExpressionForPropertyName(visitedAccessorName);
          ts2.setEmitFlags(propertyName, 1536 | 16);
          ts2.setSourceMapRange(propertyName, firstAccessor.name);
          var properties = [];
          if (getAccessor) {
            var getterFunction = transformFunctionLikeToExpression(getAccessor, void 0, void 0, container);
            ts2.setSourceMapRange(getterFunction, ts2.getSourceMapRange(getAccessor));
            ts2.setEmitFlags(getterFunction, 512);
            var getter = ts2.createPropertyAssignment("get", getterFunction);
            ts2.setCommentRange(getter, ts2.getCommentRange(getAccessor));
            properties.push(getter);
          }
          if (setAccessor) {
            var setterFunction = transformFunctionLikeToExpression(setAccessor, void 0, void 0, container);
            ts2.setSourceMapRange(setterFunction, ts2.getSourceMapRange(setAccessor));
            ts2.setEmitFlags(setterFunction, 512);
            var setter = ts2.createPropertyAssignment("set", setterFunction);
            ts2.setCommentRange(setter, ts2.getCommentRange(setAccessor));
            properties.push(setter);
          }
          properties.push(ts2.createPropertyAssignment("enumerable", getAccessor || setAccessor ? ts2.createFalse() : ts2.createTrue()), ts2.createPropertyAssignment("configurable", ts2.createTrue()));
          var call = ts2.createCall(ts2.createPropertyAccess(ts2.createIdentifier("Object"), "defineProperty"), void 0, [
            target,
            propertyName,
            ts2.createObjectLiteral(properties, true)
          ]);
          if (startsOnNewLine) {
            ts2.startOnNewLine(call);
          }
          return call;
        }
        function visitArrowFunction(node) {
          if (node.transformFlags & 4096) {
            hierarchyFacts |= 32768;
          }
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var ancestorFacts = enterSubtree(15232, 66);
          var func = ts2.createFunctionExpression(void 0, void 0, void 0, void 0, ts2.visitParameterList(node.parameters, visitor, context), void 0, transformFunctionBody(node));
          ts2.setTextRange(func, node);
          ts2.setOriginalNode(func, node);
          ts2.setEmitFlags(func, 8);
          if (hierarchyFacts & 32768) {
            enableSubstitutionsForCapturedThis();
          }
          exitSubtree(ancestorFacts, 0, 0);
          convertedLoopState = savedConvertedLoopState;
          return func;
        }
        function visitFunctionExpression(node) {
          var ancestorFacts = ts2.getEmitFlags(node) & 262144 ? enterSubtree(16278, 69) : enterSubtree(16286, 65);
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var parameters = ts2.visitParameterList(node.parameters, visitor, context);
          var body = transformFunctionBody(node);
          var name = hierarchyFacts & 16384 ? ts2.getLocalName(node) : node.name;
          exitSubtree(ancestorFacts, 49152, 0);
          convertedLoopState = savedConvertedLoopState;
          return ts2.updateFunctionExpression(node, void 0, node.asteriskToken, name, void 0, parameters, void 0, body);
        }
        function visitFunctionDeclaration(node) {
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var ancestorFacts = enterSubtree(16286, 65);
          var parameters = ts2.visitParameterList(node.parameters, visitor, context);
          var body = transformFunctionBody(node);
          var name = hierarchyFacts & 16384 ? ts2.getLocalName(node) : node.name;
          exitSubtree(ancestorFacts, 49152, 0);
          convertedLoopState = savedConvertedLoopState;
          return ts2.updateFunctionDeclaration(node, void 0, ts2.visitNodes(node.modifiers, visitor, ts2.isModifier), node.asteriskToken, name, void 0, parameters, void 0, body);
        }
        function transformFunctionLikeToExpression(node, location, name, container) {
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var ancestorFacts = container && ts2.isClassLike(container) && !ts2.hasModifier(node, 32) ? enterSubtree(16286, 65 | 8) : enterSubtree(16286, 65);
          var parameters = ts2.visitParameterList(node.parameters, visitor, context);
          var body = transformFunctionBody(node);
          if (hierarchyFacts & 16384 && !name && (node.kind === 244 || node.kind === 201)) {
            name = ts2.getGeneratedNameForNode(node);
          }
          exitSubtree(ancestorFacts, 49152, 0);
          convertedLoopState = savedConvertedLoopState;
          return ts2.setOriginalNode(ts2.setTextRange(ts2.createFunctionExpression(void 0, node.asteriskToken, name, void 0, parameters, void 0, body), location), node);
        }
        function transformFunctionBody(node) {
          var multiLine = false;
          var singleLine = false;
          var statementsLocation;
          var closeBraceLocation;
          var prologue = [];
          var statements = [];
          var body = node.body;
          var statementOffset;
          resumeLexicalEnvironment();
          if (ts2.isBlock(body)) {
            statementOffset = ts2.addStandardPrologue(prologue, body.statements, false);
            statementOffset = ts2.addCustomPrologue(statements, body.statements, statementOffset, visitor, ts2.isHoistedFunction);
            statementOffset = ts2.addCustomPrologue(statements, body.statements, statementOffset, visitor, ts2.isHoistedVariableStatement);
          }
          multiLine = addDefaultValueAssignmentsIfNeeded(statements, node) || multiLine;
          multiLine = addRestParameterIfNeeded(statements, node, false) || multiLine;
          if (ts2.isBlock(body)) {
            statementOffset = ts2.addCustomPrologue(statements, body.statements, statementOffset, visitor);
            statementsLocation = body.statements;
            ts2.addRange(statements, ts2.visitNodes(body.statements, visitor, ts2.isStatement, statementOffset));
            if (!multiLine && body.multiLine) {
              multiLine = true;
            }
          } else {
            ts2.Debug.assert(node.kind === 202);
            statementsLocation = ts2.moveRangeEnd(body, -1);
            var equalsGreaterThanToken = node.equalsGreaterThanToken;
            if (!ts2.nodeIsSynthesized(equalsGreaterThanToken) && !ts2.nodeIsSynthesized(body)) {
              if (ts2.rangeEndIsOnSameLineAsRangeStart(equalsGreaterThanToken, body, currentSourceFile)) {
                singleLine = true;
              } else {
                multiLine = true;
              }
            }
            var expression = ts2.visitNode(body, visitor, ts2.isExpression);
            var returnStatement = ts2.createReturn(expression);
            ts2.setTextRange(returnStatement, body);
            ts2.moveSyntheticComments(returnStatement, body);
            ts2.setEmitFlags(returnStatement, 384 | 32 | 1024);
            statements.push(returnStatement);
            closeBraceLocation = body;
          }
          ts2.mergeLexicalEnvironment(prologue, endLexicalEnvironment());
          insertCaptureNewTargetIfNeeded(prologue, node, false);
          insertCaptureThisForNodeIfNeeded(prologue, node);
          if (ts2.some(prologue)) {
            multiLine = true;
          }
          statements.unshift.apply(statements, prologue);
          if (ts2.isBlock(body) && ts2.arrayIsEqualTo(statements, body.statements)) {
            return body;
          }
          var block = ts2.createBlock(ts2.setTextRange(ts2.createNodeArray(statements), statementsLocation), multiLine);
          ts2.setTextRange(block, node.body);
          if (!multiLine && singleLine) {
            ts2.setEmitFlags(block, 1);
          }
          if (closeBraceLocation) {
            ts2.setTokenSourceMapRange(block, 19, closeBraceLocation);
          }
          ts2.setOriginalNode(block, node.body);
          return block;
        }
        function visitBlock(node, isFunctionBody) {
          if (isFunctionBody) {
            return ts2.visitEachChild(node, visitor, context);
          }
          var ancestorFacts = hierarchyFacts & 256 ? enterSubtree(7104, 512) : enterSubtree(6976, 128);
          var updated = ts2.visitEachChild(node, visitor, context);
          exitSubtree(ancestorFacts, 0, 0);
          return updated;
        }
        function visitExpressionStatement(node) {
          switch (node.expression.kind) {
            case 200:
              return ts2.updateExpressionStatement(node, visitParenthesizedExpression(node.expression, false));
            case 209:
              return ts2.updateExpressionStatement(node, visitBinaryExpression(node.expression, false));
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitParenthesizedExpression(node, needsDestructuringValue) {
          if (!needsDestructuringValue) {
            switch (node.expression.kind) {
              case 200:
                return ts2.updateParen(node, visitParenthesizedExpression(node.expression, false));
              case 209:
                return ts2.updateParen(node, visitBinaryExpression(node.expression, false));
            }
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitBinaryExpression(node, needsDestructuringValue) {
          if (ts2.isDestructuringAssignment(node)) {
            return ts2.flattenDestructuringAssignment(node, visitor, context, 0, needsDestructuringValue);
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function isVariableStatementOfTypeScriptClassWrapper(node) {
          return node.declarationList.declarations.length === 1 && !!node.declarationList.declarations[0].initializer && !!(ts2.getEmitFlags(node.declarationList.declarations[0].initializer) & 33554432);
        }
        function visitVariableStatement(node) {
          var ancestorFacts = enterSubtree(0, ts2.hasModifier(node, 1) ? 32 : 0);
          var updated;
          if (convertedLoopState && (node.declarationList.flags & 3) === 0 && !isVariableStatementOfTypeScriptClassWrapper(node)) {
            var assignments = void 0;
            for (var _i = 0, _a = node.declarationList.declarations; _i < _a.length; _i++) {
              var decl = _a[_i];
              hoistVariableDeclarationDeclaredInConvertedLoop(convertedLoopState, decl);
              if (decl.initializer) {
                var assignment = void 0;
                if (ts2.isBindingPattern(decl.name)) {
                  assignment = ts2.flattenDestructuringAssignment(decl, visitor, context, 0);
                } else {
                  assignment = ts2.createBinary(decl.name, 62, ts2.visitNode(decl.initializer, visitor, ts2.isExpression));
                  ts2.setTextRange(assignment, decl);
                }
                assignments = ts2.append(assignments, assignment);
              }
            }
            if (assignments) {
              updated = ts2.setTextRange(ts2.createExpressionStatement(ts2.inlineExpressions(assignments)), node);
            } else {
              updated = void 0;
            }
          } else {
            updated = ts2.visitEachChild(node, visitor, context);
          }
          exitSubtree(ancestorFacts, 0, 0);
          return updated;
        }
        function visitVariableDeclarationList(node) {
          if (node.flags & 3 || node.transformFlags & 131072) {
            if (node.flags & 3) {
              enableSubstitutionsForBlockScopedBindings();
            }
            var declarations = ts2.flatMap(node.declarations, node.flags & 1 ? visitVariableDeclarationInLetDeclarationList : visitVariableDeclaration);
            var declarationList = ts2.createVariableDeclarationList(declarations);
            ts2.setOriginalNode(declarationList, node);
            ts2.setTextRange(declarationList, node);
            ts2.setCommentRange(declarationList, node);
            if (node.transformFlags & 131072 && (ts2.isBindingPattern(node.declarations[0].name) || ts2.isBindingPattern(ts2.last(node.declarations).name))) {
              ts2.setSourceMapRange(declarationList, getRangeUnion(declarations));
            }
            return declarationList;
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function getRangeUnion(declarations) {
          var pos = -1, end = -1;
          for (var _i = 0, declarations_10 = declarations; _i < declarations_10.length; _i++) {
            var node = declarations_10[_i];
            pos = pos === -1 ? node.pos : node.pos === -1 ? pos : Math.min(pos, node.pos);
            end = Math.max(end, node.end);
          }
          return ts2.createRange(pos, end);
        }
        function shouldEmitExplicitInitializerForLetDeclaration(node) {
          var flags = resolver.getNodeCheckFlags(node);
          var isCapturedInFunction = flags & 262144;
          var isDeclaredInLoop = flags & 524288;
          var emittedAsTopLevel = (hierarchyFacts & 64) !== 0 || isCapturedInFunction && isDeclaredInLoop && (hierarchyFacts & 512) !== 0;
          var emitExplicitInitializer = !emittedAsTopLevel && (hierarchyFacts & 4096) === 0 && (!resolver.isDeclarationWithCollidingName(node) || isDeclaredInLoop && !isCapturedInFunction && (hierarchyFacts & (2048 | 4096)) === 0);
          return emitExplicitInitializer;
        }
        function visitVariableDeclarationInLetDeclarationList(node) {
          var name = node.name;
          if (ts2.isBindingPattern(name)) {
            return visitVariableDeclaration(node);
          }
          if (!node.initializer && shouldEmitExplicitInitializerForLetDeclaration(node)) {
            var clone_3 = ts2.getMutableClone(node);
            clone_3.initializer = ts2.createVoidZero();
            return clone_3;
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitVariableDeclaration(node) {
          var ancestorFacts = enterSubtree(32, 0);
          var updated;
          if (ts2.isBindingPattern(node.name)) {
            updated = ts2.flattenDestructuringBinding(node, visitor, context, 0, void 0, (ancestorFacts & 32) !== 0);
          } else {
            updated = ts2.visitEachChild(node, visitor, context);
          }
          exitSubtree(ancestorFacts, 0, 0);
          return updated;
        }
        function recordLabel(node) {
          convertedLoopState.labels.set(ts2.idText(node.label), true);
        }
        function resetLabel(node) {
          convertedLoopState.labels.set(ts2.idText(node.label), false);
        }
        function visitLabeledStatement(node) {
          if (convertedLoopState && !convertedLoopState.labels) {
            convertedLoopState.labels = ts2.createMap();
          }
          var statement = ts2.unwrapInnermostStatementOfLabel(node, convertedLoopState && recordLabel);
          return ts2.isIterationStatement(statement, false) ? visitIterationStatement(statement, node) : ts2.restoreEnclosingLabel(ts2.visitNode(statement, visitor, ts2.isStatement, ts2.liftToBlock), node, convertedLoopState && resetLabel);
        }
        function visitIterationStatement(node, outermostLabeledStatement) {
          switch (node.kind) {
            case 228:
            case 229:
              return visitDoOrWhileStatement(node, outermostLabeledStatement);
            case 230:
              return visitForStatement(node, outermostLabeledStatement);
            case 231:
              return visitForInStatement(node, outermostLabeledStatement);
            case 232:
              return visitForOfStatement(node, outermostLabeledStatement);
          }
        }
        function visitIterationStatementWithFacts(excludeFacts, includeFacts, node, outermostLabeledStatement, convert) {
          var ancestorFacts = enterSubtree(excludeFacts, includeFacts);
          var updated = convertIterationStatementBodyIfNecessary(node, outermostLabeledStatement, ancestorFacts, convert);
          exitSubtree(ancestorFacts, 0, 0);
          return updated;
        }
        function visitDoOrWhileStatement(node, outermostLabeledStatement) {
          return visitIterationStatementWithFacts(0, 1280, node, outermostLabeledStatement);
        }
        function visitForStatement(node, outermostLabeledStatement) {
          return visitIterationStatementWithFacts(5056, 3328, node, outermostLabeledStatement);
        }
        function visitForInStatement(node, outermostLabeledStatement) {
          return visitIterationStatementWithFacts(3008, 5376, node, outermostLabeledStatement);
        }
        function visitForOfStatement(node, outermostLabeledStatement) {
          return visitIterationStatementWithFacts(3008, 5376, node, outermostLabeledStatement, compilerOptions.downlevelIteration ? convertForOfStatementForIterable : convertForOfStatementForArray);
        }
        function convertForOfStatementHead(node, boundValue, convertedLoopBodyStatements) {
          var statements = [];
          var initializer = node.initializer;
          if (ts2.isVariableDeclarationList(initializer)) {
            if (node.initializer.flags & 3) {
              enableSubstitutionsForBlockScopedBindings();
            }
            var firstOriginalDeclaration = ts2.firstOrUndefined(initializer.declarations);
            if (firstOriginalDeclaration && ts2.isBindingPattern(firstOriginalDeclaration.name)) {
              var declarations = ts2.flattenDestructuringBinding(firstOriginalDeclaration, visitor, context, 0, boundValue);
              var declarationList = ts2.setTextRange(ts2.createVariableDeclarationList(declarations), node.initializer);
              ts2.setOriginalNode(declarationList, node.initializer);
              ts2.setSourceMapRange(declarationList, ts2.createRange(declarations[0].pos, ts2.last(declarations).end));
              statements.push(ts2.createVariableStatement(void 0, declarationList));
            } else {
              statements.push(ts2.setTextRange(ts2.createVariableStatement(void 0, ts2.setOriginalNode(ts2.setTextRange(ts2.createVariableDeclarationList([
                ts2.createVariableDeclaration(firstOriginalDeclaration ? firstOriginalDeclaration.name : ts2.createTempVariable(void 0), void 0, boundValue)
              ]), ts2.moveRangePos(initializer, -1)), initializer)), ts2.moveRangeEnd(initializer, -1)));
            }
          } else {
            var assignment = ts2.createAssignment(initializer, boundValue);
            if (ts2.isDestructuringAssignment(assignment)) {
              ts2.aggregateTransformFlags(assignment);
              statements.push(ts2.createExpressionStatement(visitBinaryExpression(assignment, false)));
            } else {
              assignment.end = initializer.end;
              statements.push(ts2.setTextRange(ts2.createExpressionStatement(ts2.visitNode(assignment, visitor, ts2.isExpression)), ts2.moveRangeEnd(initializer, -1)));
            }
          }
          if (convertedLoopBodyStatements) {
            return createSyntheticBlockForConvertedStatements(ts2.addRange(statements, convertedLoopBodyStatements));
          } else {
            var statement = ts2.visitNode(node.statement, visitor, ts2.isStatement, ts2.liftToBlock);
            if (ts2.isBlock(statement)) {
              return ts2.updateBlock(statement, ts2.setTextRange(ts2.createNodeArray(ts2.concatenate(statements, statement.statements)), statement.statements));
            } else {
              statements.push(statement);
              return createSyntheticBlockForConvertedStatements(statements);
            }
          }
        }
        function createSyntheticBlockForConvertedStatements(statements) {
          return ts2.setEmitFlags(ts2.createBlock(ts2.createNodeArray(statements), true), 48 | 384);
        }
        function convertForOfStatementForArray(node, outermostLabeledStatement, convertedLoopBodyStatements) {
          var expression = ts2.visitNode(node.expression, visitor, ts2.isExpression);
          var counter = ts2.createLoopVariable();
          var rhsReference = ts2.isIdentifier(expression) ? ts2.getGeneratedNameForNode(expression) : ts2.createTempVariable(void 0);
          ts2.setEmitFlags(expression, 48 | ts2.getEmitFlags(expression));
          var forStatement = ts2.setTextRange(ts2.createFor(ts2.setEmitFlags(ts2.setTextRange(ts2.createVariableDeclarationList([
            ts2.setTextRange(ts2.createVariableDeclaration(counter, void 0, ts2.createLiteral(0)), ts2.moveRangePos(node.expression, -1)),
            ts2.setTextRange(ts2.createVariableDeclaration(rhsReference, void 0, expression), node.expression)
          ]), node.expression), 2097152), ts2.setTextRange(ts2.createLessThan(counter, ts2.createPropertyAccess(rhsReference, "length")), node.expression), ts2.setTextRange(ts2.createPostfixIncrement(counter), node.expression), convertForOfStatementHead(node, ts2.createElementAccess(rhsReference, counter), convertedLoopBodyStatements)), node);
          ts2.setEmitFlags(forStatement, 256);
          ts2.setTextRange(forStatement, node);
          return ts2.restoreEnclosingLabel(forStatement, outermostLabeledStatement, convertedLoopState && resetLabel);
        }
        function convertForOfStatementForIterable(node, outermostLabeledStatement, convertedLoopBodyStatements, ancestorFacts) {
          var expression = ts2.visitNode(node.expression, visitor, ts2.isExpression);
          var iterator = ts2.isIdentifier(expression) ? ts2.getGeneratedNameForNode(expression) : ts2.createTempVariable(void 0);
          var result = ts2.isIdentifier(expression) ? ts2.getGeneratedNameForNode(iterator) : ts2.createTempVariable(void 0);
          var errorRecord = ts2.createUniqueName("e");
          var catchVariable = ts2.getGeneratedNameForNode(errorRecord);
          var returnMethod = ts2.createTempVariable(void 0);
          var values = ts2.createValuesHelper(context, expression, node.expression);
          var next = ts2.createCall(ts2.createPropertyAccess(iterator, "next"), void 0, []);
          hoistVariableDeclaration(errorRecord);
          hoistVariableDeclaration(returnMethod);
          var initializer = ancestorFacts & 1024 ? ts2.inlineExpressions([ts2.createAssignment(errorRecord, ts2.createVoidZero()), values]) : values;
          var forStatement = ts2.setEmitFlags(ts2.setTextRange(ts2.createFor(ts2.setEmitFlags(ts2.setTextRange(ts2.createVariableDeclarationList([
            ts2.setTextRange(ts2.createVariableDeclaration(iterator, void 0, initializer), node.expression),
            ts2.createVariableDeclaration(result, void 0, next)
          ]), node.expression), 2097152), ts2.createLogicalNot(ts2.createPropertyAccess(result, "done")), ts2.createAssignment(result, next), convertForOfStatementHead(node, ts2.createPropertyAccess(result, "value"), convertedLoopBodyStatements)), node), 256);
          return ts2.createTry(ts2.createBlock([
            ts2.restoreEnclosingLabel(forStatement, outermostLabeledStatement, convertedLoopState && resetLabel)
          ]), ts2.createCatchClause(ts2.createVariableDeclaration(catchVariable), ts2.setEmitFlags(ts2.createBlock([
            ts2.createExpressionStatement(ts2.createAssignment(errorRecord, ts2.createObjectLiteral([
              ts2.createPropertyAssignment("error", catchVariable)
            ])))
          ]), 1)), ts2.createBlock([
            ts2.createTry(ts2.createBlock([
              ts2.setEmitFlags(ts2.createIf(ts2.createLogicalAnd(ts2.createLogicalAnd(result, ts2.createLogicalNot(ts2.createPropertyAccess(result, "done"))), ts2.createAssignment(returnMethod, ts2.createPropertyAccess(iterator, "return"))), ts2.createExpressionStatement(ts2.createFunctionCall(returnMethod, iterator, []))), 1)
            ]), void 0, ts2.setEmitFlags(ts2.createBlock([
              ts2.setEmitFlags(ts2.createIf(errorRecord, ts2.createThrow(ts2.createPropertyAccess(errorRecord, "error"))), 1)
            ]), 1))
          ]));
        }
        function visitObjectLiteralExpression(node) {
          var properties = node.properties;
          var numProperties = properties.length;
          var numInitialProperties = numProperties;
          var numInitialPropertiesWithoutYield = numProperties;
          for (var i = 0; i < numProperties; i++) {
            var property = properties[i];
            if (property.transformFlags & 262144 && hierarchyFacts & 4 && i < numInitialPropertiesWithoutYield) {
              numInitialPropertiesWithoutYield = i;
            }
            if (property.name.kind === 154) {
              numInitialProperties = i;
              break;
            }
          }
          if (numInitialProperties !== numProperties) {
            if (numInitialPropertiesWithoutYield < numInitialProperties) {
              numInitialProperties = numInitialPropertiesWithoutYield;
            }
            var temp = ts2.createTempVariable(hoistVariableDeclaration);
            var expressions = [];
            var assignment = ts2.createAssignment(temp, ts2.setEmitFlags(ts2.createObjectLiteral(ts2.visitNodes(properties, visitor, ts2.isObjectLiteralElementLike, 0, numInitialProperties), node.multiLine), 65536));
            if (node.multiLine) {
              ts2.startOnNewLine(assignment);
            }
            expressions.push(assignment);
            addObjectLiteralMembers(expressions, node, temp, numInitialProperties);
            expressions.push(node.multiLine ? ts2.startOnNewLine(ts2.getMutableClone(temp)) : temp);
            return ts2.inlineExpressions(expressions);
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function shouldConvertPartOfIterationStatement(node) {
          return (resolver.getNodeCheckFlags(node) & 131072) !== 0;
        }
        function shouldConvertInitializerOfForStatement(node) {
          return ts2.isForStatement(node) && !!node.initializer && shouldConvertPartOfIterationStatement(node.initializer);
        }
        function shouldConvertConditionOfForStatement(node) {
          return ts2.isForStatement(node) && !!node.condition && shouldConvertPartOfIterationStatement(node.condition);
        }
        function shouldConvertIncrementorOfForStatement(node) {
          return ts2.isForStatement(node) && !!node.incrementor && shouldConvertPartOfIterationStatement(node.incrementor);
        }
        function shouldConvertIterationStatement(node) {
          return shouldConvertBodyOfIterationStatement(node) || shouldConvertInitializerOfForStatement(node);
        }
        function shouldConvertBodyOfIterationStatement(node) {
          return (resolver.getNodeCheckFlags(node) & 65536) !== 0;
        }
        function hoistVariableDeclarationDeclaredInConvertedLoop(state, node) {
          if (!state.hoistedLocalVariables) {
            state.hoistedLocalVariables = [];
          }
          visit(node.name);
          function visit(node2) {
            if (node2.kind === 75) {
              state.hoistedLocalVariables.push(node2);
            } else {
              for (var _i = 0, _a = node2.elements; _i < _a.length; _i++) {
                var element = _a[_i];
                if (!ts2.isOmittedExpression(element)) {
                  visit(element.name);
                }
              }
            }
          }
        }
        function convertIterationStatementBodyIfNecessary(node, outermostLabeledStatement, ancestorFacts, convert) {
          if (!shouldConvertIterationStatement(node)) {
            var saveAllowedNonLabeledJumps = void 0;
            if (convertedLoopState) {
              saveAllowedNonLabeledJumps = convertedLoopState.allowedNonLabeledJumps;
              convertedLoopState.allowedNonLabeledJumps = 2 | 4;
            }
            var result = convert ? convert(node, outermostLabeledStatement, void 0, ancestorFacts) : ts2.restoreEnclosingLabel(ts2.visitEachChild(node, visitor, context), outermostLabeledStatement, convertedLoopState && resetLabel);
            if (convertedLoopState) {
              convertedLoopState.allowedNonLabeledJumps = saveAllowedNonLabeledJumps;
            }
            return result;
          }
          var currentState = createConvertedLoopState(node);
          var statements = [];
          var outerConvertedLoopState = convertedLoopState;
          convertedLoopState = currentState;
          var initializerFunction = shouldConvertInitializerOfForStatement(node) ? createFunctionForInitializerOfForStatement(node, currentState) : void 0;
          var bodyFunction = shouldConvertBodyOfIterationStatement(node) ? createFunctionForBodyOfIterationStatement(node, currentState, outerConvertedLoopState) : void 0;
          convertedLoopState = outerConvertedLoopState;
          if (initializerFunction)
            statements.push(initializerFunction.functionDeclaration);
          if (bodyFunction)
            statements.push(bodyFunction.functionDeclaration);
          addExtraDeclarationsForConvertedLoop(statements, currentState, outerConvertedLoopState);
          if (initializerFunction) {
            statements.push(generateCallToConvertedLoopInitializer(initializerFunction.functionName, initializerFunction.containsYield));
          }
          var loop;
          if (bodyFunction) {
            if (convert) {
              loop = convert(node, outermostLabeledStatement, bodyFunction.part, ancestorFacts);
            } else {
              var clone_4 = convertIterationStatementCore(node, initializerFunction, ts2.createBlock(bodyFunction.part, true));
              ts2.aggregateTransformFlags(clone_4);
              loop = ts2.restoreEnclosingLabel(clone_4, outermostLabeledStatement, convertedLoopState && resetLabel);
            }
          } else {
            var clone_5 = convertIterationStatementCore(node, initializerFunction, ts2.visitNode(node.statement, visitor, ts2.isStatement, ts2.liftToBlock));
            ts2.aggregateTransformFlags(clone_5);
            loop = ts2.restoreEnclosingLabel(clone_5, outermostLabeledStatement, convertedLoopState && resetLabel);
          }
          statements.push(loop);
          return statements;
        }
        function convertIterationStatementCore(node, initializerFunction, convertedLoopBody) {
          switch (node.kind) {
            case 230:
              return convertForStatement(node, initializerFunction, convertedLoopBody);
            case 231:
              return convertForInStatement(node, convertedLoopBody);
            case 232:
              return convertForOfStatement(node, convertedLoopBody);
            case 228:
              return convertDoStatement(node, convertedLoopBody);
            case 229:
              return convertWhileStatement(node, convertedLoopBody);
            default:
              return ts2.Debug.failBadSyntaxKind(node, "IterationStatement expected");
          }
        }
        function convertForStatement(node, initializerFunction, convertedLoopBody) {
          var shouldConvertCondition = node.condition && shouldConvertPartOfIterationStatement(node.condition);
          var shouldConvertIncrementor = shouldConvertCondition || node.incrementor && shouldConvertPartOfIterationStatement(node.incrementor);
          return ts2.updateFor(node, ts2.visitNode(initializerFunction ? initializerFunction.part : node.initializer, visitor, ts2.isForInitializer), ts2.visitNode(shouldConvertCondition ? void 0 : node.condition, visitor, ts2.isExpression), ts2.visitNode(shouldConvertIncrementor ? void 0 : node.incrementor, visitor, ts2.isExpression), convertedLoopBody);
        }
        function convertForOfStatement(node, convertedLoopBody) {
          return ts2.updateForOf(node, void 0, ts2.visitNode(node.initializer, visitor, ts2.isForInitializer), ts2.visitNode(node.expression, visitor, ts2.isExpression), convertedLoopBody);
        }
        function convertForInStatement(node, convertedLoopBody) {
          return ts2.updateForIn(node, ts2.visitNode(node.initializer, visitor, ts2.isForInitializer), ts2.visitNode(node.expression, visitor, ts2.isExpression), convertedLoopBody);
        }
        function convertDoStatement(node, convertedLoopBody) {
          return ts2.updateDo(node, convertedLoopBody, ts2.visitNode(node.expression, visitor, ts2.isExpression));
        }
        function convertWhileStatement(node, convertedLoopBody) {
          return ts2.updateWhile(node, ts2.visitNode(node.expression, visitor, ts2.isExpression), convertedLoopBody);
        }
        function createConvertedLoopState(node) {
          var loopInitializer;
          switch (node.kind) {
            case 230:
            case 231:
            case 232:
              var initializer = node.initializer;
              if (initializer && initializer.kind === 243) {
                loopInitializer = initializer;
              }
              break;
          }
          var loopParameters = [];
          var loopOutParameters = [];
          if (loopInitializer && ts2.getCombinedNodeFlags(loopInitializer) & 3) {
            var hasCapturedBindingsInForInitializer = shouldConvertInitializerOfForStatement(node);
            for (var _i = 0, _a = loopInitializer.declarations; _i < _a.length; _i++) {
              var decl = _a[_i];
              processLoopVariableDeclaration(node, decl, loopParameters, loopOutParameters, hasCapturedBindingsInForInitializer);
            }
          }
          var currentState = { loopParameters, loopOutParameters };
          if (convertedLoopState) {
            if (convertedLoopState.argumentsName) {
              currentState.argumentsName = convertedLoopState.argumentsName;
            }
            if (convertedLoopState.thisName) {
              currentState.thisName = convertedLoopState.thisName;
            }
            if (convertedLoopState.hoistedLocalVariables) {
              currentState.hoistedLocalVariables = convertedLoopState.hoistedLocalVariables;
            }
          }
          return currentState;
        }
        function addExtraDeclarationsForConvertedLoop(statements, state, outerState) {
          var extraVariableDeclarations;
          if (state.argumentsName) {
            if (outerState) {
              outerState.argumentsName = state.argumentsName;
            } else {
              (extraVariableDeclarations || (extraVariableDeclarations = [])).push(ts2.createVariableDeclaration(state.argumentsName, void 0, ts2.createIdentifier("arguments")));
            }
          }
          if (state.thisName) {
            if (outerState) {
              outerState.thisName = state.thisName;
            } else {
              (extraVariableDeclarations || (extraVariableDeclarations = [])).push(ts2.createVariableDeclaration(state.thisName, void 0, ts2.createIdentifier("this")));
            }
          }
          if (state.hoistedLocalVariables) {
            if (outerState) {
              outerState.hoistedLocalVariables = state.hoistedLocalVariables;
            } else {
              if (!extraVariableDeclarations) {
                extraVariableDeclarations = [];
              }
              for (var _i = 0, _a = state.hoistedLocalVariables; _i < _a.length; _i++) {
                var identifier = _a[_i];
                extraVariableDeclarations.push(ts2.createVariableDeclaration(identifier));
              }
            }
          }
          if (state.loopOutParameters.length) {
            if (!extraVariableDeclarations) {
              extraVariableDeclarations = [];
            }
            for (var _b = 0, _c = state.loopOutParameters; _b < _c.length; _b++) {
              var outParam = _c[_b];
              extraVariableDeclarations.push(ts2.createVariableDeclaration(outParam.outParamName));
            }
          }
          if (state.conditionVariable) {
            if (!extraVariableDeclarations) {
              extraVariableDeclarations = [];
            }
            extraVariableDeclarations.push(ts2.createVariableDeclaration(state.conditionVariable, void 0, ts2.createFalse()));
          }
          if (extraVariableDeclarations) {
            statements.push(ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList(extraVariableDeclarations)));
          }
        }
        function createOutVariable(p) {
          return ts2.createVariableDeclaration(p.originalName, void 0, p.outParamName);
        }
        function createFunctionForInitializerOfForStatement(node, currentState) {
          var functionName = ts2.createUniqueName("_loop_init");
          var containsYield = (node.initializer.transformFlags & 262144) !== 0;
          var emitFlags = 0;
          if (currentState.containsLexicalThis)
            emitFlags |= 8;
          if (containsYield && hierarchyFacts & 4)
            emitFlags |= 262144;
          var statements = [];
          statements.push(ts2.createVariableStatement(void 0, node.initializer));
          copyOutParameters(currentState.loopOutParameters, 2, 1, statements);
          var functionDeclaration = ts2.createVariableStatement(void 0, ts2.setEmitFlags(ts2.createVariableDeclarationList([
            ts2.createVariableDeclaration(functionName, void 0, ts2.setEmitFlags(ts2.createFunctionExpression(void 0, containsYield ? ts2.createToken(41) : void 0, void 0, void 0, void 0, void 0, ts2.visitNode(ts2.createBlock(statements, true), visitor, ts2.isBlock)), emitFlags))
          ]), 2097152));
          var part = ts2.createVariableDeclarationList(ts2.map(currentState.loopOutParameters, createOutVariable));
          return { functionName, containsYield, functionDeclaration, part };
        }
        function createFunctionForBodyOfIterationStatement(node, currentState, outerState) {
          var functionName = ts2.createUniqueName("_loop");
          startLexicalEnvironment();
          var statement = ts2.visitNode(node.statement, visitor, ts2.isStatement, ts2.liftToBlock);
          var lexicalEnvironment = endLexicalEnvironment();
          var statements = [];
          if (shouldConvertConditionOfForStatement(node) || shouldConvertIncrementorOfForStatement(node)) {
            currentState.conditionVariable = ts2.createUniqueName("inc");
            statements.push(ts2.createIf(currentState.conditionVariable, ts2.createStatement(ts2.visitNode(node.incrementor, visitor, ts2.isExpression)), ts2.createStatement(ts2.createAssignment(currentState.conditionVariable, ts2.createTrue()))));
            if (shouldConvertConditionOfForStatement(node)) {
              statements.push(ts2.createIf(ts2.createPrefix(53, ts2.visitNode(node.condition, visitor, ts2.isExpression)), ts2.visitNode(ts2.createBreak(), visitor, ts2.isStatement)));
            }
          }
          if (ts2.isBlock(statement)) {
            ts2.addRange(statements, statement.statements);
          } else {
            statements.push(statement);
          }
          copyOutParameters(currentState.loopOutParameters, 1, 1, statements);
          ts2.insertStatementsAfterStandardPrologue(statements, lexicalEnvironment);
          var loopBody = ts2.createBlock(statements, true);
          if (ts2.isBlock(statement))
            ts2.setOriginalNode(loopBody, statement);
          var containsYield = (node.statement.transformFlags & 262144) !== 0;
          var emitFlags = 0;
          if (currentState.containsLexicalThis)
            emitFlags |= 8;
          if (containsYield && (hierarchyFacts & 4) !== 0)
            emitFlags |= 262144;
          var functionDeclaration = ts2.createVariableStatement(void 0, ts2.setEmitFlags(ts2.createVariableDeclarationList([
            ts2.createVariableDeclaration(functionName, void 0, ts2.setEmitFlags(ts2.createFunctionExpression(void 0, containsYield ? ts2.createToken(41) : void 0, void 0, void 0, currentState.loopParameters, void 0, loopBody), emitFlags))
          ]), 2097152));
          var part = generateCallToConvertedLoop(functionName, currentState, outerState, containsYield);
          return { functionName, containsYield, functionDeclaration, part };
        }
        function copyOutParameter(outParam, copyDirection) {
          var source = copyDirection === 0 ? outParam.outParamName : outParam.originalName;
          var target = copyDirection === 0 ? outParam.originalName : outParam.outParamName;
          return ts2.createBinary(target, 62, source);
        }
        function copyOutParameters(outParams, partFlags, copyDirection, statements) {
          for (var _i = 0, outParams_1 = outParams; _i < outParams_1.length; _i++) {
            var outParam = outParams_1[_i];
            if (outParam.flags & partFlags) {
              statements.push(ts2.createExpressionStatement(copyOutParameter(outParam, copyDirection)));
            }
          }
        }
        function generateCallToConvertedLoopInitializer(initFunctionExpressionName, containsYield) {
          var call = ts2.createCall(initFunctionExpressionName, void 0, []);
          var callResult = containsYield ? ts2.createYield(ts2.createToken(41), ts2.setEmitFlags(call, 8388608)) : call;
          return ts2.createStatement(callResult);
        }
        function generateCallToConvertedLoop(loopFunctionExpressionName, state, outerState, containsYield) {
          var statements = [];
          var isSimpleLoop = !(state.nonLocalJumps & ~4) && !state.labeledNonLocalBreaks && !state.labeledNonLocalContinues;
          var call = ts2.createCall(loopFunctionExpressionName, void 0, ts2.map(state.loopParameters, function(p) {
            return p.name;
          }));
          var callResult = containsYield ? ts2.createYield(ts2.createToken(41), ts2.setEmitFlags(call, 8388608)) : call;
          if (isSimpleLoop) {
            statements.push(ts2.createExpressionStatement(callResult));
            copyOutParameters(state.loopOutParameters, 1, 0, statements);
          } else {
            var loopResultName = ts2.createUniqueName("state");
            var stateVariable = ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([ts2.createVariableDeclaration(loopResultName, void 0, callResult)]));
            statements.push(stateVariable);
            copyOutParameters(state.loopOutParameters, 1, 0, statements);
            if (state.nonLocalJumps & 8) {
              var returnStatement = void 0;
              if (outerState) {
                outerState.nonLocalJumps |= 8;
                returnStatement = ts2.createReturn(loopResultName);
              } else {
                returnStatement = ts2.createReturn(ts2.createPropertyAccess(loopResultName, "value"));
              }
              statements.push(ts2.createIf(ts2.createBinary(ts2.createTypeOf(loopResultName), 36, ts2.createLiteral("object")), returnStatement));
            }
            if (state.nonLocalJumps & 2) {
              statements.push(ts2.createIf(ts2.createBinary(loopResultName, 36, ts2.createLiteral("break")), ts2.createBreak()));
            }
            if (state.labeledNonLocalBreaks || state.labeledNonLocalContinues) {
              var caseClauses = [];
              processLabeledJumps(state.labeledNonLocalBreaks, true, loopResultName, outerState, caseClauses);
              processLabeledJumps(state.labeledNonLocalContinues, false, loopResultName, outerState, caseClauses);
              statements.push(ts2.createSwitch(loopResultName, ts2.createCaseBlock(caseClauses)));
            }
          }
          return statements;
        }
        function setLabeledJump(state, isBreak, labelText, labelMarker) {
          if (isBreak) {
            if (!state.labeledNonLocalBreaks) {
              state.labeledNonLocalBreaks = ts2.createMap();
            }
            state.labeledNonLocalBreaks.set(labelText, labelMarker);
          } else {
            if (!state.labeledNonLocalContinues) {
              state.labeledNonLocalContinues = ts2.createMap();
            }
            state.labeledNonLocalContinues.set(labelText, labelMarker);
          }
        }
        function processLabeledJumps(table, isBreak, loopResultName, outerLoop, caseClauses) {
          if (!table) {
            return;
          }
          table.forEach(function(labelMarker, labelText) {
            var statements = [];
            if (!outerLoop || outerLoop.labels && outerLoop.labels.get(labelText)) {
              var label = ts2.createIdentifier(labelText);
              statements.push(isBreak ? ts2.createBreak(label) : ts2.createContinue(label));
            } else {
              setLabeledJump(outerLoop, isBreak, labelText, labelMarker);
              statements.push(ts2.createReturn(loopResultName));
            }
            caseClauses.push(ts2.createCaseClause(ts2.createLiteral(labelMarker), statements));
          });
        }
        function processLoopVariableDeclaration(container, decl, loopParameters, loopOutParameters, hasCapturedBindingsInForInitializer) {
          var name = decl.name;
          if (ts2.isBindingPattern(name)) {
            for (var _i = 0, _a = name.elements; _i < _a.length; _i++) {
              var element = _a[_i];
              if (!ts2.isOmittedExpression(element)) {
                processLoopVariableDeclaration(container, element, loopParameters, loopOutParameters, hasCapturedBindingsInForInitializer);
              }
            }
          } else {
            loopParameters.push(ts2.createParameter(void 0, void 0, void 0, name));
            var checkFlags = resolver.getNodeCheckFlags(decl);
            if (checkFlags & 4194304 || hasCapturedBindingsInForInitializer) {
              var outParamName = ts2.createUniqueName("out_" + ts2.idText(name));
              var flags = 0;
              if (checkFlags & 4194304) {
                flags |= 1;
              }
              if (ts2.isForStatement(container) && container.initializer && resolver.isBindingCapturedByNode(container.initializer, decl)) {
                flags |= 2;
              }
              loopOutParameters.push({ flags, originalName: name, outParamName });
            }
          }
        }
        function addObjectLiteralMembers(expressions, node, receiver, start) {
          var properties = node.properties;
          var numProperties = properties.length;
          for (var i = start; i < numProperties; i++) {
            var property = properties[i];
            switch (property.kind) {
              case 163:
              case 164:
                var accessors = ts2.getAllAccessorDeclarations(node.properties, property);
                if (property === accessors.firstAccessor) {
                  expressions.push(transformAccessorsToExpression(receiver, accessors, node, !!node.multiLine));
                }
                break;
              case 161:
                expressions.push(transformObjectLiteralMethodDeclarationToExpression(property, receiver, node, node.multiLine));
                break;
              case 281:
                expressions.push(transformPropertyAssignmentToExpression(property, receiver, node.multiLine));
                break;
              case 282:
                expressions.push(transformShorthandPropertyAssignmentToExpression(property, receiver, node.multiLine));
                break;
              default:
                ts2.Debug.failBadSyntaxKind(node);
                break;
            }
          }
        }
        function transformPropertyAssignmentToExpression(property, receiver, startsOnNewLine) {
          var expression = ts2.createAssignment(ts2.createMemberAccessForPropertyName(receiver, ts2.visitNode(property.name, visitor, ts2.isPropertyName)), ts2.visitNode(property.initializer, visitor, ts2.isExpression));
          ts2.setTextRange(expression, property);
          if (startsOnNewLine) {
            ts2.startOnNewLine(expression);
          }
          return expression;
        }
        function transformShorthandPropertyAssignmentToExpression(property, receiver, startsOnNewLine) {
          var expression = ts2.createAssignment(ts2.createMemberAccessForPropertyName(receiver, ts2.visitNode(property.name, visitor, ts2.isPropertyName)), ts2.getSynthesizedClone(property.name));
          ts2.setTextRange(expression, property);
          if (startsOnNewLine) {
            ts2.startOnNewLine(expression);
          }
          return expression;
        }
        function transformObjectLiteralMethodDeclarationToExpression(method, receiver, container, startsOnNewLine) {
          var expression = ts2.createAssignment(ts2.createMemberAccessForPropertyName(receiver, ts2.visitNode(method.name, visitor, ts2.isPropertyName)), transformFunctionLikeToExpression(method, method, void 0, container));
          ts2.setTextRange(expression, method);
          if (startsOnNewLine) {
            ts2.startOnNewLine(expression);
          }
          return expression;
        }
        function visitCatchClause(node) {
          var ancestorFacts = enterSubtree(7104, 0);
          var updated;
          ts2.Debug.assert(!!node.variableDeclaration, "Catch clause variable should always be present when downleveling ES2015.");
          if (ts2.isBindingPattern(node.variableDeclaration.name)) {
            var temp = ts2.createTempVariable(void 0);
            var newVariableDeclaration = ts2.createVariableDeclaration(temp);
            ts2.setTextRange(newVariableDeclaration, node.variableDeclaration);
            var vars = ts2.flattenDestructuringBinding(node.variableDeclaration, visitor, context, 0, temp);
            var list = ts2.createVariableDeclarationList(vars);
            ts2.setTextRange(list, node.variableDeclaration);
            var destructure = ts2.createVariableStatement(void 0, list);
            updated = ts2.updateCatchClause(node, newVariableDeclaration, addStatementToStartOfBlock(node.block, destructure));
          } else {
            updated = ts2.visitEachChild(node, visitor, context);
          }
          exitSubtree(ancestorFacts, 0, 0);
          return updated;
        }
        function addStatementToStartOfBlock(block, statement) {
          var transformedStatements = ts2.visitNodes(block.statements, visitor, ts2.isStatement);
          return ts2.updateBlock(block, __spreadArrays([statement], transformedStatements));
        }
        function visitMethodDeclaration(node) {
          ts2.Debug.assert(!ts2.isComputedPropertyName(node.name));
          var functionExpression = transformFunctionLikeToExpression(node, ts2.moveRangePos(node, -1), void 0, void 0);
          ts2.setEmitFlags(functionExpression, 512 | ts2.getEmitFlags(functionExpression));
          return ts2.setTextRange(ts2.createPropertyAssignment(node.name, functionExpression), node);
        }
        function visitAccessorDeclaration(node) {
          ts2.Debug.assert(!ts2.isComputedPropertyName(node.name));
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var ancestorFacts = enterSubtree(16286, 65);
          var updated;
          var parameters = ts2.visitParameterList(node.parameters, visitor, context);
          var body = transformFunctionBody(node);
          if (node.kind === 163) {
            updated = ts2.updateGetAccessor(node, node.decorators, node.modifiers, node.name, parameters, node.type, body);
          } else {
            updated = ts2.updateSetAccessor(node, node.decorators, node.modifiers, node.name, parameters, body);
          }
          exitSubtree(ancestorFacts, 49152, 0);
          convertedLoopState = savedConvertedLoopState;
          return updated;
        }
        function visitShorthandPropertyAssignment(node) {
          return ts2.setTextRange(ts2.createPropertyAssignment(node.name, ts2.getSynthesizedClone(node.name)), node);
        }
        function visitComputedPropertyName(node) {
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitYieldExpression(node) {
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitArrayLiteralExpression(node) {
          if (ts2.some(node.elements, ts2.isSpreadElement)) {
            return transformAndSpreadElements(node.elements, true, !!node.multiLine, !!node.elements.hasTrailingComma);
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitCallExpression(node) {
          if (ts2.getEmitFlags(node) & 33554432) {
            return visitTypeScriptClassWrapper(node);
          }
          var expression = ts2.skipOuterExpressions(node.expression);
          if (expression.kind === 102 || ts2.isSuperProperty(expression) || ts2.some(node.arguments, ts2.isSpreadElement)) {
            return visitCallExpressionWithPotentialCapturedThisAssignment(node, true);
          }
          return ts2.updateCall(node, ts2.visitNode(node.expression, callExpressionVisitor, ts2.isExpression), void 0, ts2.visitNodes(node.arguments, visitor, ts2.isExpression));
        }
        function visitTypeScriptClassWrapper(node) {
          var body = ts2.cast(ts2.cast(ts2.skipOuterExpressions(node.expression), ts2.isArrowFunction).body, ts2.isBlock);
          var isVariableStatementWithInitializer = function(stmt) {
            return ts2.isVariableStatement(stmt) && !!ts2.first(stmt.declarationList.declarations).initializer;
          };
          var savedConvertedLoopState = convertedLoopState;
          convertedLoopState = void 0;
          var bodyStatements = ts2.visitNodes(body.statements, visitor, ts2.isStatement);
          convertedLoopState = savedConvertedLoopState;
          var classStatements = ts2.filter(bodyStatements, isVariableStatementWithInitializer);
          var remainingStatements = ts2.filter(bodyStatements, function(stmt) {
            return !isVariableStatementWithInitializer(stmt);
          });
          var varStatement = ts2.cast(ts2.first(classStatements), ts2.isVariableStatement);
          var variable = varStatement.declarationList.declarations[0];
          var initializer = ts2.skipOuterExpressions(variable.initializer);
          var aliasAssignment = ts2.tryCast(initializer, ts2.isAssignmentExpression);
          var call = ts2.cast(aliasAssignment ? ts2.skipOuterExpressions(aliasAssignment.right) : initializer, ts2.isCallExpression);
          var func = ts2.cast(ts2.skipOuterExpressions(call.expression), ts2.isFunctionExpression);
          var funcStatements = func.body.statements;
          var classBodyStart = 0;
          var classBodyEnd = -1;
          var statements = [];
          if (aliasAssignment) {
            var extendsCall = ts2.tryCast(funcStatements[classBodyStart], ts2.isExpressionStatement);
            if (extendsCall) {
              statements.push(extendsCall);
              classBodyStart++;
            }
            statements.push(funcStatements[classBodyStart]);
            classBodyStart++;
            statements.push(ts2.createExpressionStatement(ts2.createAssignment(aliasAssignment.left, ts2.cast(variable.name, ts2.isIdentifier))));
          }
          while (!ts2.isReturnStatement(ts2.elementAt(funcStatements, classBodyEnd))) {
            classBodyEnd--;
          }
          ts2.addRange(statements, funcStatements, classBodyStart, classBodyEnd);
          if (classBodyEnd < -1) {
            ts2.addRange(statements, funcStatements, classBodyEnd + 1);
          }
          ts2.addRange(statements, remainingStatements);
          ts2.addRange(statements, classStatements, 1);
          return ts2.recreateOuterExpressions(node.expression, ts2.recreateOuterExpressions(variable.initializer, ts2.recreateOuterExpressions(aliasAssignment && aliasAssignment.right, ts2.updateCall(call, ts2.recreateOuterExpressions(call.expression, ts2.updateFunctionExpression(func, void 0, void 0, void 0, void 0, func.parameters, void 0, ts2.updateBlock(func.body, statements))), void 0, call.arguments))));
        }
        function visitImmediateSuperCallInBody(node) {
          return visitCallExpressionWithPotentialCapturedThisAssignment(node, false);
        }
        function visitCallExpressionWithPotentialCapturedThisAssignment(node, assignToCapturedThis) {
          if (node.transformFlags & 8192 || node.expression.kind === 102 || ts2.isSuperProperty(ts2.skipOuterExpressions(node.expression))) {
            var _a = ts2.createCallBinding(node.expression, hoistVariableDeclaration), target = _a.target, thisArg = _a.thisArg;
            if (node.expression.kind === 102) {
              ts2.setEmitFlags(thisArg, 4);
            }
            var resultingCall = void 0;
            if (node.transformFlags & 8192) {
              resultingCall = ts2.createFunctionApply(ts2.visitNode(target, callExpressionVisitor, ts2.isExpression), node.expression.kind === 102 ? thisArg : ts2.visitNode(thisArg, visitor, ts2.isExpression), transformAndSpreadElements(node.arguments, false, false, false));
            } else {
              resultingCall = ts2.createFunctionCall(ts2.visitNode(target, callExpressionVisitor, ts2.isExpression), node.expression.kind === 102 ? thisArg : ts2.visitNode(thisArg, visitor, ts2.isExpression), ts2.visitNodes(node.arguments, visitor, ts2.isExpression), node);
            }
            if (node.expression.kind === 102) {
              var initializer = ts2.createLogicalOr(resultingCall, createActualThis());
              resultingCall = assignToCapturedThis ? ts2.createAssignment(ts2.createFileLevelUniqueName("_this"), initializer) : initializer;
            }
            return ts2.setOriginalNode(resultingCall, node);
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitNewExpression(node) {
          if (ts2.some(node.arguments, ts2.isSpreadElement)) {
            var _a = ts2.createCallBinding(ts2.createPropertyAccess(node.expression, "bind"), hoistVariableDeclaration), target = _a.target, thisArg = _a.thisArg;
            return ts2.createNew(ts2.createFunctionApply(ts2.visitNode(target, visitor, ts2.isExpression), thisArg, transformAndSpreadElements(ts2.createNodeArray(__spreadArrays([ts2.createVoidZero()], node.arguments)), false, false, false)), void 0, []);
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function transformAndSpreadElements(elements, needsUniqueCopy, multiLine, hasTrailingComma) {
          var numElements = elements.length;
          var segments = ts2.flatten(ts2.spanMap(elements, partitionSpread, function(partition, visitPartition, _start, end) {
            return visitPartition(partition, multiLine, hasTrailingComma && end === numElements);
          }));
          if (compilerOptions.downlevelIteration) {
            if (segments.length === 1) {
              var firstSegment = segments[0];
              if (isCallToHelper(firstSegment, "___spread")) {
                return segments[0];
              }
            }
            return ts2.createSpreadHelper(context, segments);
          } else {
            if (segments.length === 1) {
              var firstSegment = segments[0];
              if (!needsUniqueCopy || isPackedArrayLiteral(firstSegment) || isCallToHelper(firstSegment, "___spreadArrays")) {
                return segments[0];
              }
            }
            return ts2.createSpreadArraysHelper(context, segments);
          }
        }
        function isPackedElement(node) {
          return !ts2.isOmittedExpression(node);
        }
        function isPackedArrayLiteral(node) {
          return ts2.isArrayLiteralExpression(node) && ts2.every(node.elements, isPackedElement);
        }
        function isCallToHelper(firstSegment, helperName) {
          return ts2.isCallExpression(firstSegment) && ts2.isIdentifier(firstSegment.expression) && ts2.getEmitFlags(firstSegment.expression) & 4096 && firstSegment.expression.escapedText === helperName;
        }
        function partitionSpread(node) {
          return ts2.isSpreadElement(node) ? visitSpanOfSpreads : visitSpanOfNonSpreads;
        }
        function visitSpanOfSpreads(chunk) {
          return ts2.map(chunk, visitExpressionOfSpread);
        }
        function visitSpanOfNonSpreads(chunk, multiLine, hasTrailingComma) {
          return ts2.createArrayLiteral(ts2.visitNodes(ts2.createNodeArray(chunk, hasTrailingComma), visitor, ts2.isExpression), multiLine);
        }
        function visitSpreadElement(node) {
          return ts2.visitNode(node.expression, visitor, ts2.isExpression);
        }
        function visitExpressionOfSpread(node) {
          return ts2.visitNode(node.expression, visitor, ts2.isExpression);
        }
        function visitTemplateLiteral(node) {
          return ts2.setTextRange(ts2.createLiteral(node.text), node);
        }
        function visitStringLiteral(node) {
          if (node.hasExtendedUnicodeEscape) {
            return ts2.setTextRange(ts2.createLiteral(node.text), node);
          }
          return node;
        }
        function visitNumericLiteral(node) {
          if (node.numericLiteralFlags & 384) {
            return ts2.setTextRange(ts2.createNumericLiteral(node.text), node);
          }
          return node;
        }
        function visitTaggedTemplateExpression(node) {
          return ts2.processTaggedTemplateExpression(context, node, visitor, currentSourceFile, recordTaggedTemplateString, ts2.ProcessLevel.All);
        }
        function visitTemplateExpression(node) {
          var expressions = [];
          addTemplateHead(expressions, node);
          addTemplateSpans(expressions, node);
          var expression = ts2.reduceLeft(expressions, ts2.createAdd);
          if (ts2.nodeIsSynthesized(expression)) {
            expression.pos = node.pos;
            expression.end = node.end;
          }
          return expression;
        }
        function shouldAddTemplateHead(node) {
          ts2.Debug.assert(node.templateSpans.length !== 0);
          return node.head.text.length !== 0 || node.templateSpans[0].literal.text.length === 0;
        }
        function addTemplateHead(expressions, node) {
          if (!shouldAddTemplateHead(node)) {
            return;
          }
          expressions.push(ts2.createLiteral(node.head.text));
        }
        function addTemplateSpans(expressions, node) {
          for (var _i = 0, _a = node.templateSpans; _i < _a.length; _i++) {
            var span = _a[_i];
            expressions.push(ts2.visitNode(span.expression, visitor, ts2.isExpression));
            if (span.literal.text.length !== 0) {
              expressions.push(ts2.createLiteral(span.literal.text));
            }
          }
        }
        function visitSuperKeyword(isExpressionOfCall) {
          return hierarchyFacts & 8 && !isExpressionOfCall ? ts2.createPropertyAccess(ts2.createFileLevelUniqueName("_super"), "prototype") : ts2.createFileLevelUniqueName("_super");
        }
        function visitMetaProperty(node) {
          if (node.keywordToken === 99 && node.name.escapedText === "target") {
            hierarchyFacts |= 16384;
            return ts2.createFileLevelUniqueName("_newTarget");
          }
          return node;
        }
        function onEmitNode(hint, node, emitCallback) {
          if (enabledSubstitutions & 1 && ts2.isFunctionLike(node)) {
            var ancestorFacts = enterSubtree(16286, ts2.getEmitFlags(node) & 8 ? 65 | 16 : 65);
            previousOnEmitNode(hint, node, emitCallback);
            exitSubtree(ancestorFacts, 0, 0);
            return;
          }
          previousOnEmitNode(hint, node, emitCallback);
        }
        function enableSubstitutionsForBlockScopedBindings() {
          if ((enabledSubstitutions & 2) === 0) {
            enabledSubstitutions |= 2;
            context.enableSubstitution(75);
          }
        }
        function enableSubstitutionsForCapturedThis() {
          if ((enabledSubstitutions & 1) === 0) {
            enabledSubstitutions |= 1;
            context.enableSubstitution(104);
            context.enableEmitNotification(162);
            context.enableEmitNotification(161);
            context.enableEmitNotification(163);
            context.enableEmitNotification(164);
            context.enableEmitNotification(202);
            context.enableEmitNotification(201);
            context.enableEmitNotification(244);
          }
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (hint === 1) {
            return substituteExpression(node);
          }
          if (ts2.isIdentifier(node)) {
            return substituteIdentifier(node);
          }
          return node;
        }
        function substituteIdentifier(node) {
          if (enabledSubstitutions & 2 && !ts2.isInternalName(node)) {
            var original = ts2.getParseTreeNode(node, ts2.isIdentifier);
            if (original && isNameOfDeclarationWithCollidingName(original)) {
              return ts2.setTextRange(ts2.getGeneratedNameForNode(original), node);
            }
          }
          return node;
        }
        function isNameOfDeclarationWithCollidingName(node) {
          switch (node.parent.kind) {
            case 191:
            case 245:
            case 248:
            case 242:
              return node.parent.name === node && resolver.isDeclarationWithCollidingName(node.parent);
          }
          return false;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 75:
              return substituteExpressionIdentifier(node);
            case 104:
              return substituteThisKeyword(node);
          }
          return node;
        }
        function substituteExpressionIdentifier(node) {
          if (enabledSubstitutions & 2 && !ts2.isInternalName(node)) {
            var declaration = resolver.getReferencedDeclarationWithCollidingName(node);
            if (declaration && !(ts2.isClassLike(declaration) && isPartOfClassBody(declaration, node))) {
              return ts2.setTextRange(ts2.getGeneratedNameForNode(ts2.getNameOfDeclaration(declaration)), node);
            }
          }
          return node;
        }
        function isPartOfClassBody(declaration, node) {
          var currentNode = ts2.getParseTreeNode(node);
          if (!currentNode || currentNode === declaration || currentNode.end <= declaration.pos || currentNode.pos >= declaration.end) {
            return false;
          }
          var blockScope = ts2.getEnclosingBlockScopeContainer(declaration);
          while (currentNode) {
            if (currentNode === blockScope || currentNode === declaration) {
              return false;
            }
            if (ts2.isClassElement(currentNode) && currentNode.parent === declaration) {
              return true;
            }
            currentNode = currentNode.parent;
          }
          return false;
        }
        function substituteThisKeyword(node) {
          if (enabledSubstitutions & 1 && hierarchyFacts & 16) {
            return ts2.setTextRange(ts2.createFileLevelUniqueName("_this"), node);
          }
          return node;
        }
        function getClassMemberPrefix(node, member) {
          return ts2.hasModifier(member, 32) ? ts2.getInternalName(node) : ts2.createPropertyAccess(ts2.getInternalName(node), "prototype");
        }
        function hasSynthesizedDefaultSuperCall(constructor, hasExtendsClause) {
          if (!constructor || !hasExtendsClause) {
            return false;
          }
          if (ts2.some(constructor.parameters)) {
            return false;
          }
          var statement = ts2.firstOrUndefined(constructor.body.statements);
          if (!statement || !ts2.nodeIsSynthesized(statement) || statement.kind !== 226) {
            return false;
          }
          var statementExpression = statement.expression;
          if (!ts2.nodeIsSynthesized(statementExpression) || statementExpression.kind !== 196) {
            return false;
          }
          var callTarget = statementExpression.expression;
          if (!ts2.nodeIsSynthesized(callTarget) || callTarget.kind !== 102) {
            return false;
          }
          var callArgument = ts2.singleOrUndefined(statementExpression.arguments);
          if (!callArgument || !ts2.nodeIsSynthesized(callArgument) || callArgument.kind !== 213) {
            return false;
          }
          var expression = callArgument.expression;
          return ts2.isIdentifier(expression) && expression.escapedText === "arguments";
        }
      }
      ts2.transformES2015 = transformES2015;
      function createExtendsHelper(context, name) {
        context.requestEmitHelper(ts2.extendsHelper);
        return ts2.createCall(ts2.getUnscopedHelperName("__extends"), void 0, [
          name,
          ts2.createFileLevelUniqueName("_super")
        ]);
      }
      ts2.extendsHelper = {
        name: "typescript:extends",
        importName: "__extends",
        scoped: false,
        priority: 0,
        text: "\n            var __extends = (this && this.__extends) || (function () {\n                var extendStatics = function (d, b) {\n                    extendStatics = Object.setPrototypeOf ||\n                        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||\n                        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };\n                    return extendStatics(d, b);\n                };\n\n                return function (d, b) {\n                    extendStatics(d, b);\n                    function __() { this.constructor = d; }\n                    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());\n                };\n            })();"
      };
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function transformES5(context) {
        var compilerOptions = context.getCompilerOptions();
        var previousOnEmitNode;
        var noSubstitution;
        if (compilerOptions.jsx === 1 || compilerOptions.jsx === 3) {
          previousOnEmitNode = context.onEmitNode;
          context.onEmitNode = onEmitNode;
          context.enableEmitNotification(268);
          context.enableEmitNotification(269);
          context.enableEmitNotification(267);
          noSubstitution = [];
        }
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onSubstituteNode = onSubstituteNode;
        context.enableSubstitution(194);
        context.enableSubstitution(281);
        return ts2.chainBundle(transformSourceFile);
        function transformSourceFile(node) {
          return node;
        }
        function onEmitNode(hint, node, emitCallback) {
          switch (node.kind) {
            case 268:
            case 269:
            case 267:
              var tagName = node.tagName;
              noSubstitution[ts2.getOriginalNodeId(tagName)] = true;
              break;
          }
          previousOnEmitNode(hint, node, emitCallback);
        }
        function onSubstituteNode(hint, node) {
          if (node.id && noSubstitution && noSubstitution[node.id]) {
            return previousOnSubstituteNode(hint, node);
          }
          node = previousOnSubstituteNode(hint, node);
          if (ts2.isPropertyAccessExpression(node)) {
            return substitutePropertyAccessExpression(node);
          } else if (ts2.isPropertyAssignment(node)) {
            return substitutePropertyAssignment(node);
          }
          return node;
        }
        function substitutePropertyAccessExpression(node) {
          if (ts2.isPrivateIdentifier(node.name)) {
            return node;
          }
          var literalName = trySubstituteReservedName(node.name);
          if (literalName) {
            return ts2.setTextRange(ts2.createElementAccess(node.expression, literalName), node);
          }
          return node;
        }
        function substitutePropertyAssignment(node) {
          var literalName = ts2.isIdentifier(node.name) && trySubstituteReservedName(node.name);
          if (literalName) {
            return ts2.updatePropertyAssignment(node, literalName, node.initializer);
          }
          return node;
        }
        function trySubstituteReservedName(name) {
          var token = name.originalKeywordKind || (ts2.nodeIsSynthesized(name) ? ts2.stringToToken(ts2.idText(name)) : void 0);
          if (token !== void 0 && token >= 77 && token <= 112) {
            return ts2.setTextRange(ts2.createLiteral(name), name);
          }
          return void 0;
        }
      }
      ts2.transformES5 = transformES5;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var OpCode;
      (function(OpCode2) {
        OpCode2[OpCode2["Nop"] = 0] = "Nop";
        OpCode2[OpCode2["Statement"] = 1] = "Statement";
        OpCode2[OpCode2["Assign"] = 2] = "Assign";
        OpCode2[OpCode2["Break"] = 3] = "Break";
        OpCode2[OpCode2["BreakWhenTrue"] = 4] = "BreakWhenTrue";
        OpCode2[OpCode2["BreakWhenFalse"] = 5] = "BreakWhenFalse";
        OpCode2[OpCode2["Yield"] = 6] = "Yield";
        OpCode2[OpCode2["YieldStar"] = 7] = "YieldStar";
        OpCode2[OpCode2["Return"] = 8] = "Return";
        OpCode2[OpCode2["Throw"] = 9] = "Throw";
        OpCode2[OpCode2["Endfinally"] = 10] = "Endfinally";
      })(OpCode || (OpCode = {}));
      var BlockAction;
      (function(BlockAction2) {
        BlockAction2[BlockAction2["Open"] = 0] = "Open";
        BlockAction2[BlockAction2["Close"] = 1] = "Close";
      })(BlockAction || (BlockAction = {}));
      var CodeBlockKind;
      (function(CodeBlockKind2) {
        CodeBlockKind2[CodeBlockKind2["Exception"] = 0] = "Exception";
        CodeBlockKind2[CodeBlockKind2["With"] = 1] = "With";
        CodeBlockKind2[CodeBlockKind2["Switch"] = 2] = "Switch";
        CodeBlockKind2[CodeBlockKind2["Loop"] = 3] = "Loop";
        CodeBlockKind2[CodeBlockKind2["Labeled"] = 4] = "Labeled";
      })(CodeBlockKind || (CodeBlockKind = {}));
      var ExceptionBlockState;
      (function(ExceptionBlockState2) {
        ExceptionBlockState2[ExceptionBlockState2["Try"] = 0] = "Try";
        ExceptionBlockState2[ExceptionBlockState2["Catch"] = 1] = "Catch";
        ExceptionBlockState2[ExceptionBlockState2["Finally"] = 2] = "Finally";
        ExceptionBlockState2[ExceptionBlockState2["Done"] = 3] = "Done";
      })(ExceptionBlockState || (ExceptionBlockState = {}));
      var Instruction;
      (function(Instruction2) {
        Instruction2[Instruction2["Next"] = 0] = "Next";
        Instruction2[Instruction2["Throw"] = 1] = "Throw";
        Instruction2[Instruction2["Return"] = 2] = "Return";
        Instruction2[Instruction2["Break"] = 3] = "Break";
        Instruction2[Instruction2["Yield"] = 4] = "Yield";
        Instruction2[Instruction2["YieldStar"] = 5] = "YieldStar";
        Instruction2[Instruction2["Catch"] = 6] = "Catch";
        Instruction2[Instruction2["Endfinally"] = 7] = "Endfinally";
      })(Instruction || (Instruction = {}));
      function getInstructionName(instruction) {
        switch (instruction) {
          case 2:
            return "return";
          case 3:
            return "break";
          case 4:
            return "yield";
          case 5:
            return "yield*";
          case 7:
            return "endfinally";
          default:
            return void 0;
        }
      }
      function transformGenerators(context) {
        var resumeLexicalEnvironment = context.resumeLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistFunctionDeclaration = context.hoistFunctionDeclaration, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var compilerOptions = context.getCompilerOptions();
        var languageVersion = ts2.getEmitScriptTarget(compilerOptions);
        var resolver = context.getEmitResolver();
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onSubstituteNode = onSubstituteNode;
        var renamedCatchVariables;
        var renamedCatchVariableDeclarations;
        var inGeneratorFunctionBody;
        var inStatementContainingYield;
        var blocks;
        var blockOffsets;
        var blockActions;
        var blockStack;
        var labelOffsets;
        var labelExpressions;
        var nextLabelId = 1;
        var operations;
        var operationArguments;
        var operationLocations;
        var state;
        var blockIndex = 0;
        var labelNumber = 0;
        var labelNumbers;
        var lastOperationWasAbrupt;
        var lastOperationWasCompletion;
        var clauses;
        var statements;
        var exceptionBlockStack;
        var currentExceptionBlock;
        var withBlockStack;
        return ts2.chainBundle(transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile || (node.transformFlags & 512) === 0) {
            return node;
          }
          var visited = ts2.visitEachChild(node, visitor, context);
          ts2.addEmitHelpers(visited, context.readEmitHelpers());
          return visited;
        }
        function visitor(node) {
          var transformFlags = node.transformFlags;
          if (inStatementContainingYield) {
            return visitJavaScriptInStatementContainingYield(node);
          } else if (inGeneratorFunctionBody) {
            return visitJavaScriptInGeneratorFunctionBody(node);
          } else if (ts2.isFunctionLikeDeclaration(node) && node.asteriskToken) {
            return visitGenerator(node);
          } else if (transformFlags & 512) {
            return ts2.visitEachChild(node, visitor, context);
          } else {
            return node;
          }
        }
        function visitJavaScriptInStatementContainingYield(node) {
          switch (node.kind) {
            case 228:
              return visitDoStatement(node);
            case 229:
              return visitWhileStatement(node);
            case 237:
              return visitSwitchStatement(node);
            case 238:
              return visitLabeledStatement(node);
            default:
              return visitJavaScriptInGeneratorFunctionBody(node);
          }
        }
        function visitJavaScriptInGeneratorFunctionBody(node) {
          switch (node.kind) {
            case 244:
              return visitFunctionDeclaration(node);
            case 201:
              return visitFunctionExpression(node);
            case 163:
            case 164:
              return visitAccessorDeclaration(node);
            case 225:
              return visitVariableStatement(node);
            case 230:
              return visitForStatement(node);
            case 231:
              return visitForInStatement(node);
            case 234:
              return visitBreakStatement(node);
            case 233:
              return visitContinueStatement(node);
            case 235:
              return visitReturnStatement(node);
            default:
              if (node.transformFlags & 262144) {
                return visitJavaScriptContainingYield(node);
              } else if (node.transformFlags & (512 | 1048576)) {
                return ts2.visitEachChild(node, visitor, context);
              } else {
                return node;
              }
          }
        }
        function visitJavaScriptContainingYield(node) {
          switch (node.kind) {
            case 209:
              return visitBinaryExpression(node);
            case 210:
              return visitConditionalExpression(node);
            case 212:
              return visitYieldExpression(node);
            case 192:
              return visitArrayLiteralExpression(node);
            case 193:
              return visitObjectLiteralExpression(node);
            case 195:
              return visitElementAccessExpression(node);
            case 196:
              return visitCallExpression(node);
            case 197:
              return visitNewExpression(node);
            default:
              return ts2.visitEachChild(node, visitor, context);
          }
        }
        function visitGenerator(node) {
          switch (node.kind) {
            case 244:
              return visitFunctionDeclaration(node);
            case 201:
              return visitFunctionExpression(node);
            default:
              return ts2.Debug.failBadSyntaxKind(node);
          }
        }
        function visitFunctionDeclaration(node) {
          if (node.asteriskToken) {
            node = ts2.setOriginalNode(ts2.setTextRange(ts2.createFunctionDeclaration(void 0, node.modifiers, void 0, node.name, void 0, ts2.visitParameterList(node.parameters, visitor, context), void 0, transformGeneratorFunctionBody(node.body)), node), node);
          } else {
            var savedInGeneratorFunctionBody = inGeneratorFunctionBody;
            var savedInStatementContainingYield = inStatementContainingYield;
            inGeneratorFunctionBody = false;
            inStatementContainingYield = false;
            node = ts2.visitEachChild(node, visitor, context);
            inGeneratorFunctionBody = savedInGeneratorFunctionBody;
            inStatementContainingYield = savedInStatementContainingYield;
          }
          if (inGeneratorFunctionBody) {
            hoistFunctionDeclaration(node);
            return void 0;
          } else {
            return node;
          }
        }
        function visitFunctionExpression(node) {
          if (node.asteriskToken) {
            node = ts2.setOriginalNode(ts2.setTextRange(ts2.createFunctionExpression(void 0, void 0, node.name, void 0, ts2.visitParameterList(node.parameters, visitor, context), void 0, transformGeneratorFunctionBody(node.body)), node), node);
          } else {
            var savedInGeneratorFunctionBody = inGeneratorFunctionBody;
            var savedInStatementContainingYield = inStatementContainingYield;
            inGeneratorFunctionBody = false;
            inStatementContainingYield = false;
            node = ts2.visitEachChild(node, visitor, context);
            inGeneratorFunctionBody = savedInGeneratorFunctionBody;
            inStatementContainingYield = savedInStatementContainingYield;
          }
          return node;
        }
        function visitAccessorDeclaration(node) {
          var savedInGeneratorFunctionBody = inGeneratorFunctionBody;
          var savedInStatementContainingYield = inStatementContainingYield;
          inGeneratorFunctionBody = false;
          inStatementContainingYield = false;
          node = ts2.visitEachChild(node, visitor, context);
          inGeneratorFunctionBody = savedInGeneratorFunctionBody;
          inStatementContainingYield = savedInStatementContainingYield;
          return node;
        }
        function transformGeneratorFunctionBody(body) {
          var statements2 = [];
          var savedInGeneratorFunctionBody = inGeneratorFunctionBody;
          var savedInStatementContainingYield = inStatementContainingYield;
          var savedBlocks = blocks;
          var savedBlockOffsets = blockOffsets;
          var savedBlockActions = blockActions;
          var savedBlockStack = blockStack;
          var savedLabelOffsets = labelOffsets;
          var savedLabelExpressions = labelExpressions;
          var savedNextLabelId = nextLabelId;
          var savedOperations = operations;
          var savedOperationArguments = operationArguments;
          var savedOperationLocations = operationLocations;
          var savedState = state;
          inGeneratorFunctionBody = true;
          inStatementContainingYield = false;
          blocks = void 0;
          blockOffsets = void 0;
          blockActions = void 0;
          blockStack = void 0;
          labelOffsets = void 0;
          labelExpressions = void 0;
          nextLabelId = 1;
          operations = void 0;
          operationArguments = void 0;
          operationLocations = void 0;
          state = ts2.createTempVariable(void 0);
          resumeLexicalEnvironment();
          var statementOffset = ts2.addPrologue(statements2, body.statements, false, visitor);
          transformAndEmitStatements(body.statements, statementOffset);
          var buildResult = build();
          ts2.insertStatementsAfterStandardPrologue(statements2, endLexicalEnvironment());
          statements2.push(ts2.createReturn(buildResult));
          inGeneratorFunctionBody = savedInGeneratorFunctionBody;
          inStatementContainingYield = savedInStatementContainingYield;
          blocks = savedBlocks;
          blockOffsets = savedBlockOffsets;
          blockActions = savedBlockActions;
          blockStack = savedBlockStack;
          labelOffsets = savedLabelOffsets;
          labelExpressions = savedLabelExpressions;
          nextLabelId = savedNextLabelId;
          operations = savedOperations;
          operationArguments = savedOperationArguments;
          operationLocations = savedOperationLocations;
          state = savedState;
          return ts2.setTextRange(ts2.createBlock(statements2, body.multiLine), body);
        }
        function visitVariableStatement(node) {
          if (node.transformFlags & 262144) {
            transformAndEmitVariableDeclarationList(node.declarationList);
            return void 0;
          } else {
            if (ts2.getEmitFlags(node) & 1048576) {
              return node;
            }
            for (var _i = 0, _a = node.declarationList.declarations; _i < _a.length; _i++) {
              var variable = _a[_i];
              hoistVariableDeclaration(variable.name);
            }
            var variables = ts2.getInitializedVariables(node.declarationList);
            if (variables.length === 0) {
              return void 0;
            }
            return ts2.setSourceMapRange(ts2.createExpressionStatement(ts2.inlineExpressions(ts2.map(variables, transformInitializedVariable))), node);
          }
        }
        function visitBinaryExpression(node) {
          var assoc = ts2.getExpressionAssociativity(node);
          switch (assoc) {
            case 0:
              return visitLeftAssociativeBinaryExpression(node);
            case 1:
              return visitRightAssociativeBinaryExpression(node);
            default:
              return ts2.Debug.assertNever(assoc);
          }
        }
        function visitRightAssociativeBinaryExpression(node) {
          var left = node.left, right = node.right;
          if (containsYield(right)) {
            var target = void 0;
            switch (left.kind) {
              case 194:
                target = ts2.updatePropertyAccess(left, cacheExpression(ts2.visitNode(left.expression, visitor, ts2.isLeftHandSideExpression)), left.name);
                break;
              case 195:
                target = ts2.updateElementAccess(left, cacheExpression(ts2.visitNode(left.expression, visitor, ts2.isLeftHandSideExpression)), cacheExpression(ts2.visitNode(left.argumentExpression, visitor, ts2.isExpression)));
                break;
              default:
                target = ts2.visitNode(left, visitor, ts2.isExpression);
                break;
            }
            var operator = node.operatorToken.kind;
            if (ts2.isCompoundAssignment(operator)) {
              return ts2.setTextRange(ts2.createAssignment(target, ts2.setTextRange(ts2.createBinary(cacheExpression(target), ts2.getNonAssignmentOperatorForCompoundAssignment(operator), ts2.visitNode(right, visitor, ts2.isExpression)), node)), node);
            } else {
              return ts2.updateBinary(node, target, ts2.visitNode(right, visitor, ts2.isExpression));
            }
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitLeftAssociativeBinaryExpression(node) {
          if (containsYield(node.right)) {
            if (ts2.isLogicalOperator(node.operatorToken.kind)) {
              return visitLogicalBinaryExpression(node);
            } else if (node.operatorToken.kind === 27) {
              return visitCommaExpression(node);
            }
            var clone_6 = ts2.getMutableClone(node);
            clone_6.left = cacheExpression(ts2.visitNode(node.left, visitor, ts2.isExpression));
            clone_6.right = ts2.visitNode(node.right, visitor, ts2.isExpression);
            return clone_6;
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitLogicalBinaryExpression(node) {
          var resultLabel = defineLabel();
          var resultLocal = declareLocal();
          emitAssignment(resultLocal, ts2.visitNode(node.left, visitor, ts2.isExpression), node.left);
          if (node.operatorToken.kind === 55) {
            emitBreakWhenFalse(resultLabel, resultLocal, node.left);
          } else {
            emitBreakWhenTrue(resultLabel, resultLocal, node.left);
          }
          emitAssignment(resultLocal, ts2.visitNode(node.right, visitor, ts2.isExpression), node.right);
          markLabel(resultLabel);
          return resultLocal;
        }
        function visitCommaExpression(node) {
          var pendingExpressions = [];
          visit(node.left);
          visit(node.right);
          return ts2.inlineExpressions(pendingExpressions);
          function visit(node2) {
            if (ts2.isBinaryExpression(node2) && node2.operatorToken.kind === 27) {
              visit(node2.left);
              visit(node2.right);
            } else {
              if (containsYield(node2) && pendingExpressions.length > 0) {
                emitWorker(1, [ts2.createExpressionStatement(ts2.inlineExpressions(pendingExpressions))]);
                pendingExpressions = [];
              }
              pendingExpressions.push(ts2.visitNode(node2, visitor, ts2.isExpression));
            }
          }
        }
        function visitConditionalExpression(node) {
          if (containsYield(node.whenTrue) || containsYield(node.whenFalse)) {
            var whenFalseLabel = defineLabel();
            var resultLabel = defineLabel();
            var resultLocal = declareLocal();
            emitBreakWhenFalse(whenFalseLabel, ts2.visitNode(node.condition, visitor, ts2.isExpression), node.condition);
            emitAssignment(resultLocal, ts2.visitNode(node.whenTrue, visitor, ts2.isExpression), node.whenTrue);
            emitBreak(resultLabel);
            markLabel(whenFalseLabel);
            emitAssignment(resultLocal, ts2.visitNode(node.whenFalse, visitor, ts2.isExpression), node.whenFalse);
            markLabel(resultLabel);
            return resultLocal;
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitYieldExpression(node) {
          var resumeLabel = defineLabel();
          var expression = ts2.visitNode(node.expression, visitor, ts2.isExpression);
          if (node.asteriskToken) {
            var iterator = (ts2.getEmitFlags(node.expression) & 8388608) === 0 ? ts2.createValuesHelper(context, expression, node) : expression;
            emitYieldStar(iterator, node);
          } else {
            emitYield(expression, node);
          }
          markLabel(resumeLabel);
          return createGeneratorResume(node);
        }
        function visitArrayLiteralExpression(node) {
          return visitElements(node.elements, void 0, void 0, node.multiLine);
        }
        function visitElements(elements, leadingElement, location, multiLine) {
          var numInitialElements = countInitialNodesWithoutYield(elements);
          var temp;
          if (numInitialElements > 0) {
            temp = declareLocal();
            var initialElements = ts2.visitNodes(elements, visitor, ts2.isExpression, 0, numInitialElements);
            emitAssignment(temp, ts2.createArrayLiteral(leadingElement ? __spreadArrays([leadingElement], initialElements) : initialElements));
            leadingElement = void 0;
          }
          var expressions = ts2.reduceLeft(elements, reduceElement, [], numInitialElements);
          return temp ? ts2.createArrayConcat(temp, [ts2.createArrayLiteral(expressions, multiLine)]) : ts2.setTextRange(ts2.createArrayLiteral(leadingElement ? __spreadArrays([leadingElement], expressions) : expressions, multiLine), location);
          function reduceElement(expressions2, element) {
            if (containsYield(element) && expressions2.length > 0) {
              var hasAssignedTemp = temp !== void 0;
              if (!temp) {
                temp = declareLocal();
              }
              emitAssignment(temp, hasAssignedTemp ? ts2.createArrayConcat(temp, [ts2.createArrayLiteral(expressions2, multiLine)]) : ts2.createArrayLiteral(leadingElement ? __spreadArrays([leadingElement], expressions2) : expressions2, multiLine));
              leadingElement = void 0;
              expressions2 = [];
            }
            expressions2.push(ts2.visitNode(element, visitor, ts2.isExpression));
            return expressions2;
          }
        }
        function visitObjectLiteralExpression(node) {
          var properties = node.properties;
          var multiLine = node.multiLine;
          var numInitialProperties = countInitialNodesWithoutYield(properties);
          var temp = declareLocal();
          emitAssignment(temp, ts2.createObjectLiteral(ts2.visitNodes(properties, visitor, ts2.isObjectLiteralElementLike, 0, numInitialProperties), multiLine));
          var expressions = ts2.reduceLeft(properties, reduceProperty, [], numInitialProperties);
          expressions.push(multiLine ? ts2.startOnNewLine(ts2.getMutableClone(temp)) : temp);
          return ts2.inlineExpressions(expressions);
          function reduceProperty(expressions2, property) {
            if (containsYield(property) && expressions2.length > 0) {
              emitStatement(ts2.createExpressionStatement(ts2.inlineExpressions(expressions2)));
              expressions2 = [];
            }
            var expression = ts2.createExpressionForObjectLiteralElementLike(node, property, temp);
            var visited = ts2.visitNode(expression, visitor, ts2.isExpression);
            if (visited) {
              if (multiLine) {
                ts2.startOnNewLine(visited);
              }
              expressions2.push(visited);
            }
            return expressions2;
          }
        }
        function visitElementAccessExpression(node) {
          if (containsYield(node.argumentExpression)) {
            var clone_7 = ts2.getMutableClone(node);
            clone_7.expression = cacheExpression(ts2.visitNode(node.expression, visitor, ts2.isLeftHandSideExpression));
            clone_7.argumentExpression = ts2.visitNode(node.argumentExpression, visitor, ts2.isExpression);
            return clone_7;
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitCallExpression(node) {
          if (!ts2.isImportCall(node) && ts2.forEach(node.arguments, containsYield)) {
            var _a = ts2.createCallBinding(node.expression, hoistVariableDeclaration, languageVersion, true), target = _a.target, thisArg = _a.thisArg;
            return ts2.setOriginalNode(ts2.createFunctionApply(cacheExpression(ts2.visitNode(target, visitor, ts2.isLeftHandSideExpression)), thisArg, visitElements(node.arguments), node), node);
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function visitNewExpression(node) {
          if (ts2.forEach(node.arguments, containsYield)) {
            var _a = ts2.createCallBinding(ts2.createPropertyAccess(node.expression, "bind"), hoistVariableDeclaration), target = _a.target, thisArg = _a.thisArg;
            return ts2.setOriginalNode(ts2.setTextRange(ts2.createNew(ts2.createFunctionApply(cacheExpression(ts2.visitNode(target, visitor, ts2.isExpression)), thisArg, visitElements(node.arguments, ts2.createVoidZero())), void 0, []), node), node);
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function transformAndEmitStatements(statements2, start) {
          if (start === void 0) {
            start = 0;
          }
          var numStatements = statements2.length;
          for (var i = start; i < numStatements; i++) {
            transformAndEmitStatement(statements2[i]);
          }
        }
        function transformAndEmitEmbeddedStatement(node) {
          if (ts2.isBlock(node)) {
            transformAndEmitStatements(node.statements);
          } else {
            transformAndEmitStatement(node);
          }
        }
        function transformAndEmitStatement(node) {
          var savedInStatementContainingYield = inStatementContainingYield;
          if (!inStatementContainingYield) {
            inStatementContainingYield = containsYield(node);
          }
          transformAndEmitStatementWorker(node);
          inStatementContainingYield = savedInStatementContainingYield;
        }
        function transformAndEmitStatementWorker(node) {
          switch (node.kind) {
            case 223:
              return transformAndEmitBlock(node);
            case 226:
              return transformAndEmitExpressionStatement(node);
            case 227:
              return transformAndEmitIfStatement(node);
            case 228:
              return transformAndEmitDoStatement(node);
            case 229:
              return transformAndEmitWhileStatement(node);
            case 230:
              return transformAndEmitForStatement(node);
            case 231:
              return transformAndEmitForInStatement(node);
            case 233:
              return transformAndEmitContinueStatement(node);
            case 234:
              return transformAndEmitBreakStatement(node);
            case 235:
              return transformAndEmitReturnStatement(node);
            case 236:
              return transformAndEmitWithStatement(node);
            case 237:
              return transformAndEmitSwitchStatement(node);
            case 238:
              return transformAndEmitLabeledStatement(node);
            case 239:
              return transformAndEmitThrowStatement(node);
            case 240:
              return transformAndEmitTryStatement(node);
            default:
              return emitStatement(ts2.visitNode(node, visitor, ts2.isStatement));
          }
        }
        function transformAndEmitBlock(node) {
          if (containsYield(node)) {
            transformAndEmitStatements(node.statements);
          } else {
            emitStatement(ts2.visitNode(node, visitor, ts2.isStatement));
          }
        }
        function transformAndEmitExpressionStatement(node) {
          emitStatement(ts2.visitNode(node, visitor, ts2.isStatement));
        }
        function transformAndEmitVariableDeclarationList(node) {
          for (var _i = 0, _a = node.declarations; _i < _a.length; _i++) {
            var variable = _a[_i];
            var name = ts2.getSynthesizedClone(variable.name);
            ts2.setCommentRange(name, variable.name);
            hoistVariableDeclaration(name);
          }
          var variables = ts2.getInitializedVariables(node);
          var numVariables = variables.length;
          var variablesWritten = 0;
          var pendingExpressions = [];
          while (variablesWritten < numVariables) {
            for (var i = variablesWritten; i < numVariables; i++) {
              var variable = variables[i];
              if (containsYield(variable.initializer) && pendingExpressions.length > 0) {
                break;
              }
              pendingExpressions.push(transformInitializedVariable(variable));
            }
            if (pendingExpressions.length) {
              emitStatement(ts2.createExpressionStatement(ts2.inlineExpressions(pendingExpressions)));
              variablesWritten += pendingExpressions.length;
              pendingExpressions = [];
            }
          }
          return void 0;
        }
        function transformInitializedVariable(node) {
          return ts2.setSourceMapRange(ts2.createAssignment(ts2.setSourceMapRange(ts2.getSynthesizedClone(node.name), node.name), ts2.visitNode(node.initializer, visitor, ts2.isExpression)), node);
        }
        function transformAndEmitIfStatement(node) {
          if (containsYield(node)) {
            if (containsYield(node.thenStatement) || containsYield(node.elseStatement)) {
              var endLabel = defineLabel();
              var elseLabel = node.elseStatement ? defineLabel() : void 0;
              emitBreakWhenFalse(node.elseStatement ? elseLabel : endLabel, ts2.visitNode(node.expression, visitor, ts2.isExpression), node.expression);
              transformAndEmitEmbeddedStatement(node.thenStatement);
              if (node.elseStatement) {
                emitBreak(endLabel);
                markLabel(elseLabel);
                transformAndEmitEmbeddedStatement(node.elseStatement);
              }
              markLabel(endLabel);
            } else {
              emitStatement(ts2.visitNode(node, visitor, ts2.isStatement));
            }
          } else {
            emitStatement(ts2.visitNode(node, visitor, ts2.isStatement));
          }
        }
        function transformAndEmitDoStatement(node) {
          if (containsYield(node)) {
            var conditionLabel = defineLabel();
            var loopLabel = defineLabel();
            beginLoopBlock(conditionLabel);
            markLabel(loopLabel);
            transformAndEmitEmbeddedStatement(node.statement);
            markLabel(conditionLabel);
            emitBreakWhenTrue(loopLabel, ts2.visitNode(node.expression, visitor, ts2.isExpression));
            endLoopBlock();
          } else {
            emitStatement(ts2.visitNode(node, visitor, ts2.isStatement));
          }
        }
        function visitDoStatement(node) {
          if (inStatementContainingYield) {
            beginScriptLoopBlock();
            node = ts2.visitEachChild(node, visitor, context);
            endLoopBlock();
            return node;
          } else {
            return ts2.visitEachChild(node, visitor, context);
          }
        }
        function transformAndEmitWhileStatement(node) {
          if (containsYield(node)) {
            var loopLabel = defineLabel();
            var endLabel = beginLoopBlock(loopLabel);
            markLabel(loopLabel);
            emitBreakWhenFalse(endLabel, ts2.visitNode(node.expression, visitor, ts2.isExpression));
            transformAndEmitEmbeddedStatement(node.statement);
            emitBreak(loopLabel);
            endLoopBlock();
          } else {
            emitStatement(ts2.visitNode(node, visitor, ts2.isStatement));
          }
        }
        function visitWhileStatement(node) {
          if (inStatementContainingYield) {
            beginScriptLoopBlock();
            node = ts2.visitEachChild(node, visitor, context);
            endLoopBlock();
            return node;
          } else {
            return ts2.visitEachChild(node, visitor, context);
          }
        }
        function transformAndEmitForStatement(node) {
          if (containsYield(node)) {
            var conditionLabel = defineLabel();
            var incrementLabel = defineLabel();
            var endLabel = beginLoopBlock(incrementLabel);
            if (node.initializer) {
              var initializer = node.initializer;
              if (ts2.isVariableDeclarationList(initializer)) {
                transformAndEmitVariableDeclarationList(initializer);
              } else {
                emitStatement(ts2.setTextRange(ts2.createExpressionStatement(ts2.visitNode(initializer, visitor, ts2.isExpression)), initializer));
              }
            }
            markLabel(conditionLabel);
            if (node.condition) {
              emitBreakWhenFalse(endLabel, ts2.visitNode(node.condition, visitor, ts2.isExpression));
            }
            transformAndEmitEmbeddedStatement(node.statement);
            markLabel(incrementLabel);
            if (node.incrementor) {
              emitStatement(ts2.setTextRange(ts2.createExpressionStatement(ts2.visitNode(node.incrementor, visitor, ts2.isExpression)), node.incrementor));
            }
            emitBreak(conditionLabel);
            endLoopBlock();
          } else {
            emitStatement(ts2.visitNode(node, visitor, ts2.isStatement));
          }
        }
        function visitForStatement(node) {
          if (inStatementContainingYield) {
            beginScriptLoopBlock();
          }
          var initializer = node.initializer;
          if (initializer && ts2.isVariableDeclarationList(initializer)) {
            for (var _i = 0, _a = initializer.declarations; _i < _a.length; _i++) {
              var variable = _a[_i];
              hoistVariableDeclaration(variable.name);
            }
            var variables = ts2.getInitializedVariables(initializer);
            node = ts2.updateFor(node, variables.length > 0 ? ts2.inlineExpressions(ts2.map(variables, transformInitializedVariable)) : void 0, ts2.visitNode(node.condition, visitor, ts2.isExpression), ts2.visitNode(node.incrementor, visitor, ts2.isExpression), ts2.visitNode(node.statement, visitor, ts2.isStatement, ts2.liftToBlock));
          } else {
            node = ts2.visitEachChild(node, visitor, context);
          }
          if (inStatementContainingYield) {
            endLoopBlock();
          }
          return node;
        }
        function transformAndEmitForInStatement(node) {
          if (containsYield(node)) {
            var keysArray = declareLocal();
            var key = declareLocal();
            var keysIndex = ts2.createLoopVariable();
            var initializer = node.initializer;
            hoistVariableDeclaration(keysIndex);
            emitAssignment(keysArray, ts2.createArrayLiteral());
            emitStatement(ts2.createForIn(key, ts2.visitNode(node.expression, visitor, ts2.isExpression), ts2.createExpressionStatement(ts2.createCall(ts2.createPropertyAccess(keysArray, "push"), void 0, [key]))));
            emitAssignment(keysIndex, ts2.createLiteral(0));
            var conditionLabel = defineLabel();
            var incrementLabel = defineLabel();
            var endLabel = beginLoopBlock(incrementLabel);
            markLabel(conditionLabel);
            emitBreakWhenFalse(endLabel, ts2.createLessThan(keysIndex, ts2.createPropertyAccess(keysArray, "length")));
            var variable = void 0;
            if (ts2.isVariableDeclarationList(initializer)) {
              for (var _i = 0, _a = initializer.declarations; _i < _a.length; _i++) {
                var variable_1 = _a[_i];
                hoistVariableDeclaration(variable_1.name);
              }
              variable = ts2.getSynthesizedClone(initializer.declarations[0].name);
            } else {
              variable = ts2.visitNode(initializer, visitor, ts2.isExpression);
              ts2.Debug.assert(ts2.isLeftHandSideExpression(variable));
            }
            emitAssignment(variable, ts2.createElementAccess(keysArray, keysIndex));
            transformAndEmitEmbeddedStatement(node.statement);
            markLabel(incrementLabel);
            emitStatement(ts2.createExpressionStatement(ts2.createPostfixIncrement(keysIndex)));
            emitBreak(conditionLabel);
            endLoopBlock();
          } else {
            emitStatement(ts2.visitNode(node, visitor, ts2.isStatement));
          }
        }
        function visitForInStatement(node) {
          if (inStatementContainingYield) {
            beginScriptLoopBlock();
          }
          var initializer = node.initializer;
          if (ts2.isVariableDeclarationList(initializer)) {
            for (var _i = 0, _a = initializer.declarations; _i < _a.length; _i++) {
              var variable = _a[_i];
              hoistVariableDeclaration(variable.name);
            }
            node = ts2.updateForIn(node, initializer.declarations[0].name, ts2.visitNode(node.expression, visitor, ts2.isExpression), ts2.visitNode(node.statement, visitor, ts2.isStatement, ts2.liftToBlock));
          } else {
            node = ts2.visitEachChild(node, visitor, context);
          }
          if (inStatementContainingYield) {
            endLoopBlock();
          }
          return node;
        }
        function transformAndEmitContinueStatement(node) {
          var label = findContinueTarget(node.label ? ts2.idText(node.label) : void 0);
          if (label > 0) {
            emitBreak(label, node);
          } else {
            emitStatement(node);
          }
        }
        function visitContinueStatement(node) {
          if (inStatementContainingYield) {
            var label = findContinueTarget(node.label && ts2.idText(node.label));
            if (label > 0) {
              return createInlineBreak(label, node);
            }
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function transformAndEmitBreakStatement(node) {
          var label = findBreakTarget(node.label ? ts2.idText(node.label) : void 0);
          if (label > 0) {
            emitBreak(label, node);
          } else {
            emitStatement(node);
          }
        }
        function visitBreakStatement(node) {
          if (inStatementContainingYield) {
            var label = findBreakTarget(node.label && ts2.idText(node.label));
            if (label > 0) {
              return createInlineBreak(label, node);
            }
          }
          return ts2.visitEachChild(node, visitor, context);
        }
        function transformAndEmitReturnStatement(node) {
          emitReturn(ts2.visitNode(node.expression, visitor, ts2.isExpression), node);
        }
        function visitReturnStatement(node) {
          return createInlineReturn(ts2.visitNode(node.expression, visitor, ts2.isExpression), node);
        }
        function transformAndEmitWithStatement(node) {
          if (containsYield(node)) {
            beginWithBlock(cacheExpression(ts2.visitNode(node.expression, visitor, ts2.isExpression)));
            transformAndEmitEmbeddedStatement(node.statement);
            endWithBlock();
          } else {
            emitStatement(ts2.visitNode(node, visitor, ts2.isStatement));
          }
        }
        function transformAndEmitSwitchStatement(node) {
          if (containsYield(node.caseBlock)) {
            var caseBlock = node.caseBlock;
            var numClauses = caseBlock.clauses.length;
            var endLabel = beginSwitchBlock();
            var expression = cacheExpression(ts2.visitNode(node.expression, visitor, ts2.isExpression));
            var clauseLabels = [];
            var defaultClauseIndex = -1;
            for (var i = 0; i < numClauses; i++) {
              var clause = caseBlock.clauses[i];
              clauseLabels.push(defineLabel());
              if (clause.kind === 278 && defaultClauseIndex === -1) {
                defaultClauseIndex = i;
              }
            }
            var clausesWritten = 0;
            var pendingClauses = [];
            while (clausesWritten < numClauses) {
              var defaultClausesSkipped = 0;
              for (var i = clausesWritten; i < numClauses; i++) {
                var clause = caseBlock.clauses[i];
                if (clause.kind === 277) {
                  if (containsYield(clause.expression) && pendingClauses.length > 0) {
                    break;
                  }
                  pendingClauses.push(ts2.createCaseClause(ts2.visitNode(clause.expression, visitor, ts2.isExpression), [
                    createInlineBreak(clauseLabels[i], clause.expression)
                  ]));
                } else {
                  defaultClausesSkipped++;
                }
              }
              if (pendingClauses.length) {
                emitStatement(ts2.createSwitch(expression, ts2.createCaseBlock(pendingClauses)));
                clausesWritten += pendingClauses.length;
                pendingClauses = [];
              }
              if (defaultClausesSkipped > 0) {
                clausesWritten += defaultClausesSkipped;
                defaultClausesSkipped = 0;
              }
            }
            if (defaultClauseIndex >= 0) {
              emitBreak(clauseLabels[defaultClauseIndex]);
            } else {
              emitBreak(endLabel);
            }
            for (var i = 0; i < numClauses; i++) {
              markLabel(clauseLabels[i]);
              transformAndEmitStatements(caseBlock.clauses[i].statements);
            }
            endSwitchBlock();
          } else {
            emitStatement(ts2.visitNode(node, visitor, ts2.isStatement));
          }
        }
        function visitSwitchStatement(node) {
          if (inStatementContainingYield) {
            beginScriptSwitchBlock();
          }
          node = ts2.visitEachChild(node, visitor, context);
          if (inStatementContainingYield) {
            endSwitchBlock();
          }
          return node;
        }
        function transformAndEmitLabeledStatement(node) {
          if (containsYield(node)) {
            beginLabeledBlock(ts2.idText(node.label));
            transformAndEmitEmbeddedStatement(node.statement);
            endLabeledBlock();
          } else {
            emitStatement(ts2.visitNode(node, visitor, ts2.isStatement));
          }
        }
        function visitLabeledStatement(node) {
          if (inStatementContainingYield) {
            beginScriptLabeledBlock(ts2.idText(node.label));
          }
          node = ts2.visitEachChild(node, visitor, context);
          if (inStatementContainingYield) {
            endLabeledBlock();
          }
          return node;
        }
        function transformAndEmitThrowStatement(node) {
          emitThrow(ts2.visitNode(node.expression, visitor, ts2.isExpression), node);
        }
        function transformAndEmitTryStatement(node) {
          if (containsYield(node)) {
            beginExceptionBlock();
            transformAndEmitEmbeddedStatement(node.tryBlock);
            if (node.catchClause) {
              beginCatchBlock(node.catchClause.variableDeclaration);
              transformAndEmitEmbeddedStatement(node.catchClause.block);
            }
            if (node.finallyBlock) {
              beginFinallyBlock();
              transformAndEmitEmbeddedStatement(node.finallyBlock);
            }
            endExceptionBlock();
          } else {
            emitStatement(ts2.visitEachChild(node, visitor, context));
          }
        }
        function containsYield(node) {
          return !!node && (node.transformFlags & 262144) !== 0;
        }
        function countInitialNodesWithoutYield(nodes) {
          var numNodes = nodes.length;
          for (var i = 0; i < numNodes; i++) {
            if (containsYield(nodes[i])) {
              return i;
            }
          }
          return -1;
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (hint === 1) {
            return substituteExpression(node);
          }
          return node;
        }
        function substituteExpression(node) {
          if (ts2.isIdentifier(node)) {
            return substituteExpressionIdentifier(node);
          }
          return node;
        }
        function substituteExpressionIdentifier(node) {
          if (!ts2.isGeneratedIdentifier(node) && renamedCatchVariables && renamedCatchVariables.has(ts2.idText(node))) {
            var original = ts2.getOriginalNode(node);
            if (ts2.isIdentifier(original) && original.parent) {
              var declaration = resolver.getReferencedValueDeclaration(original);
              if (declaration) {
                var name = renamedCatchVariableDeclarations[ts2.getOriginalNodeId(declaration)];
                if (name) {
                  var clone_8 = ts2.getMutableClone(name);
                  ts2.setSourceMapRange(clone_8, node);
                  ts2.setCommentRange(clone_8, node);
                  return clone_8;
                }
              }
            }
          }
          return node;
        }
        function cacheExpression(node) {
          if (ts2.isGeneratedIdentifier(node) || ts2.getEmitFlags(node) & 4096) {
            return node;
          }
          var temp = ts2.createTempVariable(hoistVariableDeclaration);
          emitAssignment(temp, node, node);
          return temp;
        }
        function declareLocal(name) {
          var temp = name ? ts2.createUniqueName(name) : ts2.createTempVariable(void 0);
          hoistVariableDeclaration(temp);
          return temp;
        }
        function defineLabel() {
          if (!labelOffsets) {
            labelOffsets = [];
          }
          var label = nextLabelId;
          nextLabelId++;
          labelOffsets[label] = -1;
          return label;
        }
        function markLabel(label) {
          ts2.Debug.assert(labelOffsets !== void 0, "No labels were defined.");
          labelOffsets[label] = operations ? operations.length : 0;
        }
        function beginBlock(block) {
          if (!blocks) {
            blocks = [];
            blockActions = [];
            blockOffsets = [];
            blockStack = [];
          }
          var index = blockActions.length;
          blockActions[index] = 0;
          blockOffsets[index] = operations ? operations.length : 0;
          blocks[index] = block;
          blockStack.push(block);
          return index;
        }
        function endBlock() {
          var block = peekBlock();
          if (block === void 0)
            return ts2.Debug.fail("beginBlock was never called.");
          var index = blockActions.length;
          blockActions[index] = 1;
          blockOffsets[index] = operations ? operations.length : 0;
          blocks[index] = block;
          blockStack.pop();
          return block;
        }
        function peekBlock() {
          return ts2.lastOrUndefined(blockStack);
        }
        function peekBlockKind() {
          var block = peekBlock();
          return block && block.kind;
        }
        function beginWithBlock(expression) {
          var startLabel = defineLabel();
          var endLabel = defineLabel();
          markLabel(startLabel);
          beginBlock({
            kind: 1,
            expression,
            startLabel,
            endLabel
          });
        }
        function endWithBlock() {
          ts2.Debug.assert(peekBlockKind() === 1);
          var block = endBlock();
          markLabel(block.endLabel);
        }
        function beginExceptionBlock() {
          var startLabel = defineLabel();
          var endLabel = defineLabel();
          markLabel(startLabel);
          beginBlock({
            kind: 0,
            state: 0,
            startLabel,
            endLabel
          });
          emitNop();
          return endLabel;
        }
        function beginCatchBlock(variable) {
          ts2.Debug.assert(peekBlockKind() === 0);
          var name;
          if (ts2.isGeneratedIdentifier(variable.name)) {
            name = variable.name;
            hoistVariableDeclaration(variable.name);
          } else {
            var text = ts2.idText(variable.name);
            name = declareLocal(text);
            if (!renamedCatchVariables) {
              renamedCatchVariables = ts2.createMap();
              renamedCatchVariableDeclarations = [];
              context.enableSubstitution(75);
            }
            renamedCatchVariables.set(text, true);
            renamedCatchVariableDeclarations[ts2.getOriginalNodeId(variable)] = name;
          }
          var exception = peekBlock();
          ts2.Debug.assert(exception.state < 1);
          var endLabel = exception.endLabel;
          emitBreak(endLabel);
          var catchLabel = defineLabel();
          markLabel(catchLabel);
          exception.state = 1;
          exception.catchVariable = name;
          exception.catchLabel = catchLabel;
          emitAssignment(name, ts2.createCall(ts2.createPropertyAccess(state, "sent"), void 0, []));
          emitNop();
        }
        function beginFinallyBlock() {
          ts2.Debug.assert(peekBlockKind() === 0);
          var exception = peekBlock();
          ts2.Debug.assert(exception.state < 2);
          var endLabel = exception.endLabel;
          emitBreak(endLabel);
          var finallyLabel = defineLabel();
          markLabel(finallyLabel);
          exception.state = 2;
          exception.finallyLabel = finallyLabel;
        }
        function endExceptionBlock() {
          ts2.Debug.assert(peekBlockKind() === 0);
          var exception = endBlock();
          var state2 = exception.state;
          if (state2 < 2) {
            emitBreak(exception.endLabel);
          } else {
            emitEndfinally();
          }
          markLabel(exception.endLabel);
          emitNop();
          exception.state = 3;
        }
        function beginScriptLoopBlock() {
          beginBlock({
            kind: 3,
            isScript: true,
            breakLabel: -1,
            continueLabel: -1
          });
        }
        function beginLoopBlock(continueLabel) {
          var breakLabel = defineLabel();
          beginBlock({
            kind: 3,
            isScript: false,
            breakLabel,
            continueLabel
          });
          return breakLabel;
        }
        function endLoopBlock() {
          ts2.Debug.assert(peekBlockKind() === 3);
          var block = endBlock();
          var breakLabel = block.breakLabel;
          if (!block.isScript) {
            markLabel(breakLabel);
          }
        }
        function beginScriptSwitchBlock() {
          beginBlock({
            kind: 2,
            isScript: true,
            breakLabel: -1
          });
        }
        function beginSwitchBlock() {
          var breakLabel = defineLabel();
          beginBlock({
            kind: 2,
            isScript: false,
            breakLabel
          });
          return breakLabel;
        }
        function endSwitchBlock() {
          ts2.Debug.assert(peekBlockKind() === 2);
          var block = endBlock();
          var breakLabel = block.breakLabel;
          if (!block.isScript) {
            markLabel(breakLabel);
          }
        }
        function beginScriptLabeledBlock(labelText) {
          beginBlock({
            kind: 4,
            isScript: true,
            labelText,
            breakLabel: -1
          });
        }
        function beginLabeledBlock(labelText) {
          var breakLabel = defineLabel();
          beginBlock({
            kind: 4,
            isScript: false,
            labelText,
            breakLabel
          });
        }
        function endLabeledBlock() {
          ts2.Debug.assert(peekBlockKind() === 4);
          var block = endBlock();
          if (!block.isScript) {
            markLabel(block.breakLabel);
          }
        }
        function supportsUnlabeledBreak(block) {
          return block.kind === 2 || block.kind === 3;
        }
        function supportsLabeledBreakOrContinue(block) {
          return block.kind === 4;
        }
        function supportsUnlabeledContinue(block) {
          return block.kind === 3;
        }
        function hasImmediateContainingLabeledBlock(labelText, start) {
          for (var j = start; j >= 0; j--) {
            var containingBlock = blockStack[j];
            if (supportsLabeledBreakOrContinue(containingBlock)) {
              if (containingBlock.labelText === labelText) {
                return true;
              }
            } else {
              break;
            }
          }
          return false;
        }
        function findBreakTarget(labelText) {
          if (blockStack) {
            if (labelText) {
              for (var i = blockStack.length - 1; i >= 0; i--) {
                var block = blockStack[i];
                if (supportsLabeledBreakOrContinue(block) && block.labelText === labelText) {
                  return block.breakLabel;
                } else if (supportsUnlabeledBreak(block) && hasImmediateContainingLabeledBlock(labelText, i - 1)) {
                  return block.breakLabel;
                }
              }
            } else {
              for (var i = blockStack.length - 1; i >= 0; i--) {
                var block = blockStack[i];
                if (supportsUnlabeledBreak(block)) {
                  return block.breakLabel;
                }
              }
            }
          }
          return 0;
        }
        function findContinueTarget(labelText) {
          if (blockStack) {
            if (labelText) {
              for (var i = blockStack.length - 1; i >= 0; i--) {
                var block = blockStack[i];
                if (supportsUnlabeledContinue(block) && hasImmediateContainingLabeledBlock(labelText, i - 1)) {
                  return block.continueLabel;
                }
              }
            } else {
              for (var i = blockStack.length - 1; i >= 0; i--) {
                var block = blockStack[i];
                if (supportsUnlabeledContinue(block)) {
                  return block.continueLabel;
                }
              }
            }
          }
          return 0;
        }
        function createLabel(label) {
          if (label !== void 0 && label > 0) {
            if (labelExpressions === void 0) {
              labelExpressions = [];
            }
            var expression = ts2.createLiteral(-1);
            if (labelExpressions[label] === void 0) {
              labelExpressions[label] = [expression];
            } else {
              labelExpressions[label].push(expression);
            }
            return expression;
          }
          return ts2.createOmittedExpression();
        }
        function createInstruction(instruction) {
          var literal = ts2.createLiteral(instruction);
          ts2.addSyntheticTrailingComment(literal, 3, getInstructionName(instruction));
          return literal;
        }
        function createInlineBreak(label, location) {
          ts2.Debug.assertLessThan(0, label, "Invalid label");
          return ts2.setTextRange(ts2.createReturn(ts2.createArrayLiteral([
            createInstruction(3),
            createLabel(label)
          ])), location);
        }
        function createInlineReturn(expression, location) {
          return ts2.setTextRange(ts2.createReturn(ts2.createArrayLiteral(expression ? [createInstruction(2), expression] : [createInstruction(2)])), location);
        }
        function createGeneratorResume(location) {
          return ts2.setTextRange(ts2.createCall(ts2.createPropertyAccess(state, "sent"), void 0, []), location);
        }
        function emitNop() {
          emitWorker(0);
        }
        function emitStatement(node) {
          if (node) {
            emitWorker(1, [node]);
          } else {
            emitNop();
          }
        }
        function emitAssignment(left, right, location) {
          emitWorker(2, [left, right], location);
        }
        function emitBreak(label, location) {
          emitWorker(3, [label], location);
        }
        function emitBreakWhenTrue(label, condition, location) {
          emitWorker(4, [label, condition], location);
        }
        function emitBreakWhenFalse(label, condition, location) {
          emitWorker(5, [label, condition], location);
        }
        function emitYieldStar(expression, location) {
          emitWorker(7, [expression], location);
        }
        function emitYield(expression, location) {
          emitWorker(6, [expression], location);
        }
        function emitReturn(expression, location) {
          emitWorker(8, [expression], location);
        }
        function emitThrow(expression, location) {
          emitWorker(9, [expression], location);
        }
        function emitEndfinally() {
          emitWorker(10);
        }
        function emitWorker(code, args, location) {
          if (operations === void 0) {
            operations = [];
            operationArguments = [];
            operationLocations = [];
          }
          if (labelOffsets === void 0) {
            markLabel(defineLabel());
          }
          var operationIndex = operations.length;
          operations[operationIndex] = code;
          operationArguments[operationIndex] = args;
          operationLocations[operationIndex] = location;
        }
        function build() {
          blockIndex = 0;
          labelNumber = 0;
          labelNumbers = void 0;
          lastOperationWasAbrupt = false;
          lastOperationWasCompletion = false;
          clauses = void 0;
          statements = void 0;
          exceptionBlockStack = void 0;
          currentExceptionBlock = void 0;
          withBlockStack = void 0;
          var buildResult = buildStatements();
          return createGeneratorHelper(context, ts2.setEmitFlags(ts2.createFunctionExpression(void 0, void 0, void 0, void 0, [ts2.createParameter(void 0, void 0, void 0, state)], void 0, ts2.createBlock(buildResult, buildResult.length > 0)), 524288));
        }
        function buildStatements() {
          if (operations) {
            for (var operationIndex = 0; operationIndex < operations.length; operationIndex++) {
              writeOperation(operationIndex);
            }
            flushFinalLabel(operations.length);
          } else {
            flushFinalLabel(0);
          }
          if (clauses) {
            var labelExpression = ts2.createPropertyAccess(state, "label");
            var switchStatement = ts2.createSwitch(labelExpression, ts2.createCaseBlock(clauses));
            return [ts2.startOnNewLine(switchStatement)];
          }
          if (statements) {
            return statements;
          }
          return [];
        }
        function flushLabel() {
          if (!statements) {
            return;
          }
          appendLabel(!lastOperationWasAbrupt);
          lastOperationWasAbrupt = false;
          lastOperationWasCompletion = false;
          labelNumber++;
        }
        function flushFinalLabel(operationIndex) {
          if (isFinalLabelReachable(operationIndex)) {
            tryEnterLabel(operationIndex);
            withBlockStack = void 0;
            writeReturn(void 0, void 0);
          }
          if (statements && clauses) {
            appendLabel(false);
          }
          updateLabelExpressions();
        }
        function isFinalLabelReachable(operationIndex) {
          if (!lastOperationWasCompletion) {
            return true;
          }
          if (!labelOffsets || !labelExpressions) {
            return false;
          }
          for (var label = 0; label < labelOffsets.length; label++) {
            if (labelOffsets[label] === operationIndex && labelExpressions[label]) {
              return true;
            }
          }
          return false;
        }
        function appendLabel(markLabelEnd) {
          if (!clauses) {
            clauses = [];
          }
          if (statements) {
            if (withBlockStack) {
              for (var i = withBlockStack.length - 1; i >= 0; i--) {
                var withBlock = withBlockStack[i];
                statements = [ts2.createWith(withBlock.expression, ts2.createBlock(statements))];
              }
            }
            if (currentExceptionBlock) {
              var startLabel = currentExceptionBlock.startLabel, catchLabel = currentExceptionBlock.catchLabel, finallyLabel = currentExceptionBlock.finallyLabel, endLabel = currentExceptionBlock.endLabel;
              statements.unshift(ts2.createExpressionStatement(ts2.createCall(ts2.createPropertyAccess(ts2.createPropertyAccess(state, "trys"), "push"), void 0, [
                ts2.createArrayLiteral([
                  createLabel(startLabel),
                  createLabel(catchLabel),
                  createLabel(finallyLabel),
                  createLabel(endLabel)
                ])
              ])));
              currentExceptionBlock = void 0;
            }
            if (markLabelEnd) {
              statements.push(ts2.createExpressionStatement(ts2.createAssignment(ts2.createPropertyAccess(state, "label"), ts2.createLiteral(labelNumber + 1))));
            }
          }
          clauses.push(ts2.createCaseClause(ts2.createLiteral(labelNumber), statements || []));
          statements = void 0;
        }
        function tryEnterLabel(operationIndex) {
          if (!labelOffsets) {
            return;
          }
          for (var label = 0; label < labelOffsets.length; label++) {
            if (labelOffsets[label] === operationIndex) {
              flushLabel();
              if (labelNumbers === void 0) {
                labelNumbers = [];
              }
              if (labelNumbers[labelNumber] === void 0) {
                labelNumbers[labelNumber] = [label];
              } else {
                labelNumbers[labelNumber].push(label);
              }
            }
          }
        }
        function updateLabelExpressions() {
          if (labelExpressions !== void 0 && labelNumbers !== void 0) {
            for (var labelNumber_1 = 0; labelNumber_1 < labelNumbers.length; labelNumber_1++) {
              var labels = labelNumbers[labelNumber_1];
              if (labels !== void 0) {
                for (var _i = 0, labels_1 = labels; _i < labels_1.length; _i++) {
                  var label = labels_1[_i];
                  var expressions = labelExpressions[label];
                  if (expressions !== void 0) {
                    for (var _a = 0, expressions_1 = expressions; _a < expressions_1.length; _a++) {
                      var expression = expressions_1[_a];
                      expression.text = String(labelNumber_1);
                    }
                  }
                }
              }
            }
          }
        }
        function tryEnterOrLeaveBlock(operationIndex) {
          if (blocks) {
            for (; blockIndex < blockActions.length && blockOffsets[blockIndex] <= operationIndex; blockIndex++) {
              var block = blocks[blockIndex];
              var blockAction = blockActions[blockIndex];
              switch (block.kind) {
                case 0:
                  if (blockAction === 0) {
                    if (!exceptionBlockStack) {
                      exceptionBlockStack = [];
                    }
                    if (!statements) {
                      statements = [];
                    }
                    exceptionBlockStack.push(currentExceptionBlock);
                    currentExceptionBlock = block;
                  } else if (blockAction === 1) {
                    currentExceptionBlock = exceptionBlockStack.pop();
                  }
                  break;
                case 1:
                  if (blockAction === 0) {
                    if (!withBlockStack) {
                      withBlockStack = [];
                    }
                    withBlockStack.push(block);
                  } else if (blockAction === 1) {
                    withBlockStack.pop();
                  }
                  break;
              }
            }
          }
        }
        function writeOperation(operationIndex) {
          tryEnterLabel(operationIndex);
          tryEnterOrLeaveBlock(operationIndex);
          if (lastOperationWasAbrupt) {
            return;
          }
          lastOperationWasAbrupt = false;
          lastOperationWasCompletion = false;
          var opcode = operations[operationIndex];
          if (opcode === 0) {
            return;
          } else if (opcode === 10) {
            return writeEndfinally();
          }
          var args = operationArguments[operationIndex];
          if (opcode === 1) {
            return writeStatement(args[0]);
          }
          var location = operationLocations[operationIndex];
          switch (opcode) {
            case 2:
              return writeAssign(args[0], args[1], location);
            case 3:
              return writeBreak(args[0], location);
            case 4:
              return writeBreakWhenTrue(args[0], args[1], location);
            case 5:
              return writeBreakWhenFalse(args[0], args[1], location);
            case 6:
              return writeYield(args[0], location);
            case 7:
              return writeYieldStar(args[0], location);
            case 8:
              return writeReturn(args[0], location);
            case 9:
              return writeThrow(args[0], location);
          }
        }
        function writeStatement(statement) {
          if (statement) {
            if (!statements) {
              statements = [statement];
            } else {
              statements.push(statement);
            }
          }
        }
        function writeAssign(left, right, operationLocation) {
          writeStatement(ts2.setTextRange(ts2.createExpressionStatement(ts2.createAssignment(left, right)), operationLocation));
        }
        function writeThrow(expression, operationLocation) {
          lastOperationWasAbrupt = true;
          lastOperationWasCompletion = true;
          writeStatement(ts2.setTextRange(ts2.createThrow(expression), operationLocation));
        }
        function writeReturn(expression, operationLocation) {
          lastOperationWasAbrupt = true;
          lastOperationWasCompletion = true;
          writeStatement(ts2.setEmitFlags(ts2.setTextRange(ts2.createReturn(ts2.createArrayLiteral(expression ? [createInstruction(2), expression] : [createInstruction(2)])), operationLocation), 384));
        }
        function writeBreak(label, operationLocation) {
          lastOperationWasAbrupt = true;
          writeStatement(ts2.setEmitFlags(ts2.setTextRange(ts2.createReturn(ts2.createArrayLiteral([
            createInstruction(3),
            createLabel(label)
          ])), operationLocation), 384));
        }
        function writeBreakWhenTrue(label, condition, operationLocation) {
          writeStatement(ts2.setEmitFlags(ts2.createIf(condition, ts2.setEmitFlags(ts2.setTextRange(ts2.createReturn(ts2.createArrayLiteral([
            createInstruction(3),
            createLabel(label)
          ])), operationLocation), 384)), 1));
        }
        function writeBreakWhenFalse(label, condition, operationLocation) {
          writeStatement(ts2.setEmitFlags(ts2.createIf(ts2.createLogicalNot(condition), ts2.setEmitFlags(ts2.setTextRange(ts2.createReturn(ts2.createArrayLiteral([
            createInstruction(3),
            createLabel(label)
          ])), operationLocation), 384)), 1));
        }
        function writeYield(expression, operationLocation) {
          lastOperationWasAbrupt = true;
          writeStatement(ts2.setEmitFlags(ts2.setTextRange(ts2.createReturn(ts2.createArrayLiteral(expression ? [createInstruction(4), expression] : [createInstruction(4)])), operationLocation), 384));
        }
        function writeYieldStar(expression, operationLocation) {
          lastOperationWasAbrupt = true;
          writeStatement(ts2.setEmitFlags(ts2.setTextRange(ts2.createReturn(ts2.createArrayLiteral([
            createInstruction(5),
            expression
          ])), operationLocation), 384));
        }
        function writeEndfinally() {
          lastOperationWasAbrupt = true;
          writeStatement(ts2.createReturn(ts2.createArrayLiteral([
            createInstruction(7)
          ])));
        }
      }
      ts2.transformGenerators = transformGenerators;
      function createGeneratorHelper(context, body) {
        context.requestEmitHelper(ts2.generatorHelper);
        return ts2.createCall(ts2.getUnscopedHelperName("__generator"), void 0, [ts2.createThis(), body]);
      }
      ts2.generatorHelper = {
        name: "typescript:generator",
        importName: "__generator",
        scoped: false,
        priority: 6,
        text: '\n            var __generator = (this && this.__generator) || function (thisArg, body) {\n                var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;\n                return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;\n                function verb(n) { return function (v) { return step([n, v]); }; }\n                function step(op) {\n                    if (f) throw new TypeError("Generator is already executing.");\n                    while (_) try {\n                        if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;\n                        if (y = 0, t) op = [op[0] & 2, t.value];\n                        switch (op[0]) {\n                            case 0: case 1: t = op; break;\n                            case 4: _.label++; return { value: op[1], done: false };\n                            case 5: _.label++; y = op[1]; op = [0]; continue;\n                            case 7: op = _.ops.pop(); _.trys.pop(); continue;\n                            default:\n                                if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }\n                                if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }\n                                if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }\n                                if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }\n                                if (t[2]) _.ops.pop();\n                                _.trys.pop(); continue;\n                        }\n                        op = body.call(thisArg, _);\n                    } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }\n                    if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };\n                }\n            };'
      };
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function transformModule(context) {
        function getTransformModuleDelegate(moduleKind2) {
          switch (moduleKind2) {
            case ts2.ModuleKind.AMD:
              return transformAMDModule;
            case ts2.ModuleKind.UMD:
              return transformUMDModule;
            default:
              return transformCommonJSModule;
          }
        }
        var startLexicalEnvironment = context.startLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var compilerOptions = context.getCompilerOptions();
        var resolver = context.getEmitResolver();
        var host = context.getEmitHost();
        var languageVersion = ts2.getEmitScriptTarget(compilerOptions);
        var moduleKind = ts2.getEmitModuleKind(compilerOptions);
        var previousOnSubstituteNode = context.onSubstituteNode;
        var previousOnEmitNode = context.onEmitNode;
        context.onSubstituteNode = onSubstituteNode;
        context.onEmitNode = onEmitNode;
        context.enableSubstitution(75);
        context.enableSubstitution(209);
        context.enableSubstitution(207);
        context.enableSubstitution(208);
        context.enableSubstitution(282);
        context.enableEmitNotification(290);
        var moduleInfoMap = [];
        var deferredExports = [];
        var currentSourceFile;
        var currentModuleInfo;
        var noSubstitution;
        var needUMDDynamicImportHelper;
        return ts2.chainBundle(transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile || !(ts2.isEffectiveExternalModule(node, compilerOptions) || node.transformFlags & 2097152 || ts2.isJsonSourceFile(node) && ts2.hasJsonModuleEmitEnabled(compilerOptions) && (compilerOptions.out || compilerOptions.outFile))) {
            return node;
          }
          currentSourceFile = node;
          currentModuleInfo = ts2.collectExternalModuleInfo(node, resolver, compilerOptions);
          moduleInfoMap[ts2.getOriginalNodeId(node)] = currentModuleInfo;
          var transformModule2 = getTransformModuleDelegate(moduleKind);
          var updated = transformModule2(node);
          currentSourceFile = void 0;
          currentModuleInfo = void 0;
          needUMDDynamicImportHelper = false;
          return ts2.aggregateTransformFlags(updated);
        }
        function shouldEmitUnderscoreUnderscoreESModule() {
          if (!currentModuleInfo.exportEquals && ts2.isExternalModule(currentSourceFile)) {
            return true;
          }
          return false;
        }
        function transformCommonJSModule(node) {
          startLexicalEnvironment();
          var statements = [];
          var ensureUseStrict = ts2.getStrictOptionValue(compilerOptions, "alwaysStrict") || !compilerOptions.noImplicitUseStrict && ts2.isExternalModule(currentSourceFile);
          var statementOffset = ts2.addPrologue(statements, node.statements, ensureUseStrict && !ts2.isJsonSourceFile(node), sourceElementVisitor);
          if (shouldEmitUnderscoreUnderscoreESModule()) {
            ts2.append(statements, createUnderscoreUnderscoreESModule());
          }
          if (ts2.length(currentModuleInfo.exportedNames)) {
            ts2.append(statements, ts2.createExpressionStatement(ts2.reduceLeft(currentModuleInfo.exportedNames, function(prev, nextId) {
              return ts2.createAssignment(ts2.createPropertyAccess(ts2.createIdentifier("exports"), ts2.createIdentifier(ts2.idText(nextId))), prev);
            }, ts2.createVoidZero())));
          }
          ts2.append(statements, ts2.visitNode(currentModuleInfo.externalHelpersImportDeclaration, sourceElementVisitor, ts2.isStatement));
          ts2.addRange(statements, ts2.visitNodes(node.statements, sourceElementVisitor, ts2.isStatement, statementOffset));
          addExportEqualsIfNeeded(statements, false);
          ts2.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          var updated = ts2.updateSourceFileNode(node, ts2.setTextRange(ts2.createNodeArray(statements), node.statements));
          ts2.addEmitHelpers(updated, context.readEmitHelpers());
          return updated;
        }
        function transformAMDModule(node) {
          var define2 = ts2.createIdentifier("define");
          var moduleName = ts2.tryGetModuleNameFromFile(node, host, compilerOptions);
          var jsonSourceFile = ts2.isJsonSourceFile(node) && node;
          var _a = collectAsynchronousDependencies(node, true), aliasedModuleNames = _a.aliasedModuleNames, unaliasedModuleNames = _a.unaliasedModuleNames, importAliasNames = _a.importAliasNames;
          var updated = ts2.updateSourceFileNode(node, ts2.setTextRange(ts2.createNodeArray([
            ts2.createExpressionStatement(ts2.createCall(define2, void 0, __spreadArrays(moduleName ? [moduleName] : [], [
              ts2.createArrayLiteral(jsonSourceFile ? ts2.emptyArray : __spreadArrays([
                ts2.createLiteral("require"),
                ts2.createLiteral("exports")
              ], aliasedModuleNames, unaliasedModuleNames)),
              jsonSourceFile ? jsonSourceFile.statements.length ? jsonSourceFile.statements[0].expression : ts2.createObjectLiteral() : ts2.createFunctionExpression(void 0, void 0, void 0, void 0, __spreadArrays([
                ts2.createParameter(void 0, void 0, void 0, "require"),
                ts2.createParameter(void 0, void 0, void 0, "exports")
              ], importAliasNames), void 0, transformAsynchronousModuleBody(node))
            ])))
          ]), node.statements));
          ts2.addEmitHelpers(updated, context.readEmitHelpers());
          return updated;
        }
        function transformUMDModule(node) {
          var _a = collectAsynchronousDependencies(node, false), aliasedModuleNames = _a.aliasedModuleNames, unaliasedModuleNames = _a.unaliasedModuleNames, importAliasNames = _a.importAliasNames;
          var moduleName = ts2.tryGetModuleNameFromFile(node, host, compilerOptions);
          var umdHeader = ts2.createFunctionExpression(void 0, void 0, void 0, void 0, [ts2.createParameter(void 0, void 0, void 0, "factory")], void 0, ts2.setTextRange(ts2.createBlock([
            ts2.createIf(ts2.createLogicalAnd(ts2.createTypeCheck(ts2.createIdentifier("module"), "object"), ts2.createTypeCheck(ts2.createPropertyAccess(ts2.createIdentifier("module"), "exports"), "object")), ts2.createBlock([
              ts2.createVariableStatement(void 0, [
                ts2.createVariableDeclaration("v", void 0, ts2.createCall(ts2.createIdentifier("factory"), void 0, [
                  ts2.createIdentifier("require"),
                  ts2.createIdentifier("exports")
                ]))
              ]),
              ts2.setEmitFlags(ts2.createIf(ts2.createStrictInequality(ts2.createIdentifier("v"), ts2.createIdentifier("undefined")), ts2.createExpressionStatement(ts2.createAssignment(ts2.createPropertyAccess(ts2.createIdentifier("module"), "exports"), ts2.createIdentifier("v")))), 1)
            ]), ts2.createIf(ts2.createLogicalAnd(ts2.createTypeCheck(ts2.createIdentifier("define"), "function"), ts2.createPropertyAccess(ts2.createIdentifier("define"), "amd")), ts2.createBlock([
              ts2.createExpressionStatement(ts2.createCall(ts2.createIdentifier("define"), void 0, __spreadArrays(moduleName ? [moduleName] : [], [
                ts2.createArrayLiteral(__spreadArrays([
                  ts2.createLiteral("require"),
                  ts2.createLiteral("exports")
                ], aliasedModuleNames, unaliasedModuleNames)),
                ts2.createIdentifier("factory")
              ])))
            ])))
          ], true), void 0));
          var updated = ts2.updateSourceFileNode(node, ts2.setTextRange(ts2.createNodeArray([
            ts2.createExpressionStatement(ts2.createCall(umdHeader, void 0, [
              ts2.createFunctionExpression(void 0, void 0, void 0, void 0, __spreadArrays([
                ts2.createParameter(void 0, void 0, void 0, "require"),
                ts2.createParameter(void 0, void 0, void 0, "exports")
              ], importAliasNames), void 0, transformAsynchronousModuleBody(node))
            ]))
          ]), node.statements));
          ts2.addEmitHelpers(updated, context.readEmitHelpers());
          return updated;
        }
        function collectAsynchronousDependencies(node, includeNonAmdDependencies) {
          var aliasedModuleNames = [];
          var unaliasedModuleNames = [];
          var importAliasNames = [];
          for (var _i = 0, _a = node.amdDependencies; _i < _a.length; _i++) {
            var amdDependency = _a[_i];
            if (amdDependency.name) {
              aliasedModuleNames.push(ts2.createLiteral(amdDependency.path));
              importAliasNames.push(ts2.createParameter(void 0, void 0, void 0, amdDependency.name));
            } else {
              unaliasedModuleNames.push(ts2.createLiteral(amdDependency.path));
            }
          }
          for (var _b = 0, _c = currentModuleInfo.externalImports; _b < _c.length; _b++) {
            var importNode = _c[_b];
            var externalModuleName = ts2.getExternalModuleNameLiteral(importNode, currentSourceFile, host, resolver, compilerOptions);
            var importAliasName = ts2.getLocalNameForExternalImport(importNode, currentSourceFile);
            if (externalModuleName) {
              if (includeNonAmdDependencies && importAliasName) {
                ts2.setEmitFlags(importAliasName, 4);
                aliasedModuleNames.push(externalModuleName);
                importAliasNames.push(ts2.createParameter(void 0, void 0, void 0, importAliasName));
              } else {
                unaliasedModuleNames.push(externalModuleName);
              }
            }
          }
          return { aliasedModuleNames, unaliasedModuleNames, importAliasNames };
        }
        function getAMDImportExpressionForImport(node) {
          if (ts2.isImportEqualsDeclaration(node) || ts2.isExportDeclaration(node) || !ts2.getExternalModuleNameLiteral(node, currentSourceFile, host, resolver, compilerOptions)) {
            return void 0;
          }
          var name = ts2.getLocalNameForExternalImport(node, currentSourceFile);
          var expr = getHelperExpressionForImport(node, name);
          if (expr === name) {
            return void 0;
          }
          return ts2.createExpressionStatement(ts2.createAssignment(name, expr));
        }
        function transformAsynchronousModuleBody(node) {
          startLexicalEnvironment();
          var statements = [];
          var statementOffset = ts2.addPrologue(statements, node.statements, !compilerOptions.noImplicitUseStrict, sourceElementVisitor);
          if (shouldEmitUnderscoreUnderscoreESModule()) {
            ts2.append(statements, createUnderscoreUnderscoreESModule());
          }
          if (ts2.length(currentModuleInfo.exportedNames)) {
            ts2.append(statements, ts2.createExpressionStatement(ts2.reduceLeft(currentModuleInfo.exportedNames, function(prev, nextId) {
              return ts2.createAssignment(ts2.createPropertyAccess(ts2.createIdentifier("exports"), ts2.createIdentifier(ts2.idText(nextId))), prev);
            }, ts2.createVoidZero())));
          }
          ts2.append(statements, ts2.visitNode(currentModuleInfo.externalHelpersImportDeclaration, sourceElementVisitor, ts2.isStatement));
          if (moduleKind === ts2.ModuleKind.AMD) {
            ts2.addRange(statements, ts2.mapDefined(currentModuleInfo.externalImports, getAMDImportExpressionForImport));
          }
          ts2.addRange(statements, ts2.visitNodes(node.statements, sourceElementVisitor, ts2.isStatement, statementOffset));
          addExportEqualsIfNeeded(statements, true);
          ts2.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          var body = ts2.createBlock(statements, true);
          if (needUMDDynamicImportHelper) {
            ts2.addEmitHelper(body, dynamicImportUMDHelper);
          }
          return body;
        }
        function addExportEqualsIfNeeded(statements, emitAsReturn) {
          if (currentModuleInfo.exportEquals) {
            var expressionResult = ts2.visitNode(currentModuleInfo.exportEquals.expression, moduleExpressionElementVisitor);
            if (expressionResult) {
              if (emitAsReturn) {
                var statement = ts2.createReturn(expressionResult);
                ts2.setTextRange(statement, currentModuleInfo.exportEquals);
                ts2.setEmitFlags(statement, 384 | 1536);
                statements.push(statement);
              } else {
                var statement = ts2.createExpressionStatement(ts2.createAssignment(ts2.createPropertyAccess(ts2.createIdentifier("module"), "exports"), expressionResult));
                ts2.setTextRange(statement, currentModuleInfo.exportEquals);
                ts2.setEmitFlags(statement, 1536);
                statements.push(statement);
              }
            }
          }
        }
        function sourceElementVisitor(node) {
          switch (node.kind) {
            case 254:
              return visitImportDeclaration(node);
            case 253:
              return visitImportEqualsDeclaration(node);
            case 260:
              return visitExportDeclaration(node);
            case 259:
              return visitExportAssignment(node);
            case 225:
              return visitVariableStatement(node);
            case 244:
              return visitFunctionDeclaration(node);
            case 245:
              return visitClassDeclaration(node);
            case 328:
              return visitMergeDeclarationMarker(node);
            case 329:
              return visitEndOfDeclarationMarker(node);
            default:
              return ts2.visitEachChild(node, moduleExpressionElementVisitor, context);
          }
        }
        function moduleExpressionElementVisitor(node) {
          if (!(node.transformFlags & 2097152) && !(node.transformFlags & 1024)) {
            return node;
          }
          if (ts2.isImportCall(node)) {
            return visitImportCallExpression(node);
          } else if (ts2.isDestructuringAssignment(node)) {
            return visitDestructuringAssignment(node);
          } else {
            return ts2.visitEachChild(node, moduleExpressionElementVisitor, context);
          }
        }
        function destructuringNeedsFlattening(node) {
          if (ts2.isObjectLiteralExpression(node)) {
            for (var _i = 0, _a = node.properties; _i < _a.length; _i++) {
              var elem = _a[_i];
              switch (elem.kind) {
                case 281:
                  if (destructuringNeedsFlattening(elem.initializer)) {
                    return true;
                  }
                  break;
                case 282:
                  if (destructuringNeedsFlattening(elem.name)) {
                    return true;
                  }
                  break;
                case 283:
                  if (destructuringNeedsFlattening(elem.expression)) {
                    return true;
                  }
                  break;
                case 161:
                case 163:
                case 164:
                  return false;
                default:
                  ts2.Debug.assertNever(elem, "Unhandled object member kind");
              }
            }
          } else if (ts2.isArrayLiteralExpression(node)) {
            for (var _b = 0, _c = node.elements; _b < _c.length; _b++) {
              var elem = _c[_b];
              if (ts2.isSpreadElement(elem)) {
                if (destructuringNeedsFlattening(elem.expression)) {
                  return true;
                }
              } else if (destructuringNeedsFlattening(elem)) {
                return true;
              }
            }
          } else if (ts2.isIdentifier(node)) {
            return ts2.length(getExports(node)) > (ts2.isExportName(node) ? 1 : 0);
          }
          return false;
        }
        function visitDestructuringAssignment(node) {
          if (destructuringNeedsFlattening(node.left)) {
            return ts2.flattenDestructuringAssignment(node, moduleExpressionElementVisitor, context, 0, false, createAllExportExpressions);
          }
          return ts2.visitEachChild(node, moduleExpressionElementVisitor, context);
        }
        function visitImportCallExpression(node) {
          var argument = ts2.visitNode(ts2.firstOrUndefined(node.arguments), moduleExpressionElementVisitor);
          var containsLexicalThis = !!(node.transformFlags & 4096);
          switch (compilerOptions.module) {
            case ts2.ModuleKind.AMD:
              return createImportCallExpressionAMD(argument, containsLexicalThis);
            case ts2.ModuleKind.UMD:
              return createImportCallExpressionUMD(argument, containsLexicalThis);
            case ts2.ModuleKind.CommonJS:
            default:
              return createImportCallExpressionCommonJS(argument, containsLexicalThis);
          }
        }
        function createImportCallExpressionUMD(arg, containsLexicalThis) {
          needUMDDynamicImportHelper = true;
          if (ts2.isSimpleCopiableExpression(arg)) {
            var argClone = ts2.isGeneratedIdentifier(arg) ? arg : ts2.isStringLiteral(arg) ? ts2.createLiteral(arg) : ts2.setEmitFlags(ts2.setTextRange(ts2.getSynthesizedClone(arg), arg), 1536);
            return ts2.createConditional(ts2.createIdentifier("__syncRequire"), createImportCallExpressionCommonJS(arg, containsLexicalThis), createImportCallExpressionAMD(argClone, containsLexicalThis));
          } else {
            var temp = ts2.createTempVariable(hoistVariableDeclaration);
            return ts2.createComma(ts2.createAssignment(temp, arg), ts2.createConditional(ts2.createIdentifier("__syncRequire"), createImportCallExpressionCommonJS(temp, containsLexicalThis), createImportCallExpressionAMD(temp, containsLexicalThis)));
          }
        }
        function createImportCallExpressionAMD(arg, containsLexicalThis) {
          var resolve = ts2.createUniqueName("resolve");
          var reject = ts2.createUniqueName("reject");
          var parameters = [
            ts2.createParameter(void 0, void 0, void 0, resolve),
            ts2.createParameter(void 0, void 0, void 0, reject)
          ];
          var body = ts2.createBlock([
            ts2.createExpressionStatement(ts2.createCall(ts2.createIdentifier("require"), void 0, [ts2.createArrayLiteral([arg || ts2.createOmittedExpression()]), resolve, reject]))
          ]);
          var func;
          if (languageVersion >= 2) {
            func = ts2.createArrowFunction(void 0, void 0, parameters, void 0, void 0, body);
          } else {
            func = ts2.createFunctionExpression(void 0, void 0, void 0, void 0, parameters, void 0, body);
            if (containsLexicalThis) {
              ts2.setEmitFlags(func, 8);
            }
          }
          var promise = ts2.createNew(ts2.createIdentifier("Promise"), void 0, [func]);
          if (compilerOptions.esModuleInterop) {
            context.requestEmitHelper(ts2.importStarHelper);
            return ts2.createCall(ts2.createPropertyAccess(promise, ts2.createIdentifier("then")), void 0, [ts2.getUnscopedHelperName("__importStar")]);
          }
          return promise;
        }
        function createImportCallExpressionCommonJS(arg, containsLexicalThis) {
          var promiseResolveCall = ts2.createCall(ts2.createPropertyAccess(ts2.createIdentifier("Promise"), "resolve"), void 0, []);
          var requireCall = ts2.createCall(ts2.createIdentifier("require"), void 0, arg ? [arg] : []);
          if (compilerOptions.esModuleInterop) {
            context.requestEmitHelper(ts2.importStarHelper);
            requireCall = ts2.createCall(ts2.getUnscopedHelperName("__importStar"), void 0, [requireCall]);
          }
          var func;
          if (languageVersion >= 2) {
            func = ts2.createArrowFunction(void 0, void 0, [], void 0, void 0, requireCall);
          } else {
            func = ts2.createFunctionExpression(void 0, void 0, void 0, void 0, [], void 0, ts2.createBlock([ts2.createReturn(requireCall)]));
            if (containsLexicalThis) {
              ts2.setEmitFlags(func, 8);
            }
          }
          return ts2.createCall(ts2.createPropertyAccess(promiseResolveCall, "then"), void 0, [func]);
        }
        function getHelperExpressionForExport(node, innerExpr) {
          if (!compilerOptions.esModuleInterop || ts2.getEmitFlags(node) & 67108864) {
            return innerExpr;
          }
          if (ts2.getExportNeedsImportStarHelper(node)) {
            context.requestEmitHelper(ts2.importStarHelper);
            return ts2.createCall(ts2.getUnscopedHelperName("__importStar"), void 0, [innerExpr]);
          }
          return innerExpr;
        }
        function getHelperExpressionForImport(node, innerExpr) {
          if (!compilerOptions.esModuleInterop || ts2.getEmitFlags(node) & 67108864) {
            return innerExpr;
          }
          if (ts2.getImportNeedsImportStarHelper(node)) {
            context.requestEmitHelper(ts2.importStarHelper);
            return ts2.createCall(ts2.getUnscopedHelperName("__importStar"), void 0, [innerExpr]);
          }
          if (ts2.getImportNeedsImportDefaultHelper(node)) {
            context.requestEmitHelper(ts2.importDefaultHelper);
            return ts2.createCall(ts2.getUnscopedHelperName("__importDefault"), void 0, [innerExpr]);
          }
          return innerExpr;
        }
        function visitImportDeclaration(node) {
          var statements;
          var namespaceDeclaration = ts2.getNamespaceDeclarationNode(node);
          if (moduleKind !== ts2.ModuleKind.AMD) {
            if (!node.importClause) {
              return ts2.setOriginalNode(ts2.setTextRange(ts2.createExpressionStatement(createRequireCall(node)), node), node);
            } else {
              var variables = [];
              if (namespaceDeclaration && !ts2.isDefaultImport(node)) {
                variables.push(ts2.createVariableDeclaration(ts2.getSynthesizedClone(namespaceDeclaration.name), void 0, getHelperExpressionForImport(node, createRequireCall(node))));
              } else {
                variables.push(ts2.createVariableDeclaration(ts2.getGeneratedNameForNode(node), void 0, getHelperExpressionForImport(node, createRequireCall(node))));
                if (namespaceDeclaration && ts2.isDefaultImport(node)) {
                  variables.push(ts2.createVariableDeclaration(ts2.getSynthesizedClone(namespaceDeclaration.name), void 0, ts2.getGeneratedNameForNode(node)));
                }
              }
              statements = ts2.append(statements, ts2.setOriginalNode(ts2.setTextRange(ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList(variables, languageVersion >= 2 ? 2 : 0)), node), node));
            }
          } else if (namespaceDeclaration && ts2.isDefaultImport(node)) {
            statements = ts2.append(statements, ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([
              ts2.setOriginalNode(ts2.setTextRange(ts2.createVariableDeclaration(ts2.getSynthesizedClone(namespaceDeclaration.name), void 0, ts2.getGeneratedNameForNode(node)), node), node)
            ], languageVersion >= 2 ? 2 : 0)));
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts2.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfImportDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfImportDeclaration(statements, node);
          }
          return ts2.singleOrMany(statements);
        }
        function createRequireCall(importNode) {
          var moduleName = ts2.getExternalModuleNameLiteral(importNode, currentSourceFile, host, resolver, compilerOptions);
          var args = [];
          if (moduleName) {
            args.push(moduleName);
          }
          return ts2.createCall(ts2.createIdentifier("require"), void 0, args);
        }
        function visitImportEqualsDeclaration(node) {
          ts2.Debug.assert(ts2.isExternalModuleImportEqualsDeclaration(node), "import= for internal module references should be handled in an earlier transformer.");
          var statements;
          if (moduleKind !== ts2.ModuleKind.AMD) {
            if (ts2.hasModifier(node, 1)) {
              statements = ts2.append(statements, ts2.setOriginalNode(ts2.setTextRange(ts2.createExpressionStatement(createExportExpression(node.name, createRequireCall(node))), node), node));
            } else {
              statements = ts2.append(statements, ts2.setOriginalNode(ts2.setTextRange(ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([
                ts2.createVariableDeclaration(ts2.getSynthesizedClone(node.name), void 0, createRequireCall(node))
              ], languageVersion >= 2 ? 2 : 0)), node), node));
            }
          } else {
            if (ts2.hasModifier(node, 1)) {
              statements = ts2.append(statements, ts2.setOriginalNode(ts2.setTextRange(ts2.createExpressionStatement(createExportExpression(ts2.getExportName(node), ts2.getLocalName(node))), node), node));
            }
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts2.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfImportEqualsDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfImportEqualsDeclaration(statements, node);
          }
          return ts2.singleOrMany(statements);
        }
        function visitExportDeclaration(node) {
          if (!node.moduleSpecifier) {
            return void 0;
          }
          var generatedName = ts2.getGeneratedNameForNode(node);
          if (node.exportClause && ts2.isNamedExports(node.exportClause)) {
            var statements = [];
            if (moduleKind !== ts2.ModuleKind.AMD) {
              statements.push(ts2.setOriginalNode(ts2.setTextRange(ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([
                ts2.createVariableDeclaration(generatedName, void 0, createRequireCall(node))
              ])), node), node));
            }
            for (var _i = 0, _a = node.exportClause.elements; _i < _a.length; _i++) {
              var specifier = _a[_i];
              if (languageVersion === 0) {
                statements.push(ts2.setOriginalNode(ts2.setTextRange(ts2.createExpressionStatement(createCreateBindingHelper(context, generatedName, ts2.createLiteral(specifier.propertyName || specifier.name), specifier.propertyName ? ts2.createLiteral(specifier.name) : void 0)), specifier), specifier));
              } else {
                var exportedValue = ts2.createPropertyAccess(generatedName, specifier.propertyName || specifier.name);
                statements.push(ts2.setOriginalNode(ts2.setTextRange(ts2.createExpressionStatement(createExportExpression(ts2.getExportName(specifier), exportedValue, void 0, true)), specifier), specifier));
              }
            }
            return ts2.singleOrMany(statements);
          } else if (node.exportClause) {
            var statements = [];
            statements.push(ts2.setOriginalNode(ts2.setTextRange(ts2.createExpressionStatement(createExportExpression(ts2.getSynthesizedClone(node.exportClause.name), moduleKind !== ts2.ModuleKind.AMD ? getHelperExpressionForExport(node, createRequireCall(node)) : ts2.createIdentifier(ts2.idText(node.exportClause.name)))), node), node));
            return ts2.singleOrMany(statements);
          } else {
            return ts2.setOriginalNode(ts2.setTextRange(ts2.createExpressionStatement(createExportStarHelper(context, moduleKind !== ts2.ModuleKind.AMD ? createRequireCall(node) : generatedName)), node), node);
          }
        }
        function visitExportAssignment(node) {
          if (node.isExportEquals) {
            return void 0;
          }
          var statements;
          var original = node.original;
          if (original && hasAssociatedEndOfDeclarationMarker(original)) {
            var id = ts2.getOriginalNodeId(node);
            deferredExports[id] = appendExportStatement(deferredExports[id], ts2.createIdentifier("default"), ts2.visitNode(node.expression, moduleExpressionElementVisitor), node, true);
          } else {
            statements = appendExportStatement(statements, ts2.createIdentifier("default"), ts2.visitNode(node.expression, moduleExpressionElementVisitor), node, true);
          }
          return ts2.singleOrMany(statements);
        }
        function visitFunctionDeclaration(node) {
          var statements;
          if (ts2.hasModifier(node, 1)) {
            statements = ts2.append(statements, ts2.setOriginalNode(ts2.setTextRange(ts2.createFunctionDeclaration(void 0, ts2.visitNodes(node.modifiers, modifierVisitor, ts2.isModifier), node.asteriskToken, ts2.getDeclarationName(node, true, true), void 0, ts2.visitNodes(node.parameters, moduleExpressionElementVisitor), void 0, ts2.visitEachChild(node.body, moduleExpressionElementVisitor, context)), node), node));
          } else {
            statements = ts2.append(statements, ts2.visitEachChild(node, moduleExpressionElementVisitor, context));
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts2.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfHoistedDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfHoistedDeclaration(statements, node);
          }
          return ts2.singleOrMany(statements);
        }
        function visitClassDeclaration(node) {
          var statements;
          if (ts2.hasModifier(node, 1)) {
            statements = ts2.append(statements, ts2.setOriginalNode(ts2.setTextRange(ts2.createClassDeclaration(void 0, ts2.visitNodes(node.modifiers, modifierVisitor, ts2.isModifier), ts2.getDeclarationName(node, true, true), void 0, ts2.visitNodes(node.heritageClauses, moduleExpressionElementVisitor), ts2.visitNodes(node.members, moduleExpressionElementVisitor)), node), node));
          } else {
            statements = ts2.append(statements, ts2.visitEachChild(node, moduleExpressionElementVisitor, context));
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts2.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfHoistedDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfHoistedDeclaration(statements, node);
          }
          return ts2.singleOrMany(statements);
        }
        function visitVariableStatement(node) {
          var statements;
          var variables;
          var expressions;
          if (ts2.hasModifier(node, 1)) {
            var modifiers = void 0;
            for (var _i = 0, _a = node.declarationList.declarations; _i < _a.length; _i++) {
              var variable = _a[_i];
              if (ts2.isIdentifier(variable.name) && ts2.isLocalName(variable.name)) {
                if (!modifiers) {
                  modifiers = ts2.visitNodes(node.modifiers, modifierVisitor, ts2.isModifier);
                }
                variables = ts2.append(variables, variable);
              } else if (variable.initializer) {
                expressions = ts2.append(expressions, transformInitializedVariable(variable));
              }
            }
            if (variables) {
              statements = ts2.append(statements, ts2.updateVariableStatement(node, modifiers, ts2.updateVariableDeclarationList(node.declarationList, variables)));
            }
            if (expressions) {
              statements = ts2.append(statements, ts2.setOriginalNode(ts2.setTextRange(ts2.createExpressionStatement(ts2.inlineExpressions(expressions)), node), node));
            }
          } else {
            statements = ts2.append(statements, ts2.visitEachChild(node, moduleExpressionElementVisitor, context));
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts2.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfVariableStatement(deferredExports[id], node);
          } else {
            statements = appendExportsOfVariableStatement(statements, node);
          }
          return ts2.singleOrMany(statements);
        }
        function createAllExportExpressions(name, value, location) {
          var exportedNames = getExports(name);
          if (exportedNames) {
            var expression = ts2.isExportName(name) ? value : ts2.createAssignment(name, value);
            for (var _i = 0, exportedNames_1 = exportedNames; _i < exportedNames_1.length; _i++) {
              var exportName = exportedNames_1[_i];
              ts2.setEmitFlags(expression, 4);
              expression = createExportExpression(exportName, expression, location);
            }
            return expression;
          }
          return ts2.createAssignment(name, value);
        }
        function transformInitializedVariable(node) {
          if (ts2.isBindingPattern(node.name)) {
            return ts2.flattenDestructuringAssignment(ts2.visitNode(node, moduleExpressionElementVisitor), void 0, context, 0, false, createAllExportExpressions);
          } else {
            return ts2.createAssignment(ts2.setTextRange(ts2.createPropertyAccess(ts2.createIdentifier("exports"), node.name), node.name), node.initializer ? ts2.visitNode(node.initializer, moduleExpressionElementVisitor) : ts2.createVoidZero());
          }
        }
        function visitMergeDeclarationMarker(node) {
          if (hasAssociatedEndOfDeclarationMarker(node) && node.original.kind === 225) {
            var id = ts2.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfVariableStatement(deferredExports[id], node.original);
          }
          return node;
        }
        function hasAssociatedEndOfDeclarationMarker(node) {
          return (ts2.getEmitFlags(node) & 4194304) !== 0;
        }
        function visitEndOfDeclarationMarker(node) {
          var id = ts2.getOriginalNodeId(node);
          var statements = deferredExports[id];
          if (statements) {
            delete deferredExports[id];
            return ts2.append(statements, node);
          }
          return node;
        }
        function appendExportsOfImportDeclaration(statements, decl) {
          if (currentModuleInfo.exportEquals) {
            return statements;
          }
          var importClause = decl.importClause;
          if (!importClause) {
            return statements;
          }
          if (importClause.name) {
            statements = appendExportsOfDeclaration(statements, importClause);
          }
          var namedBindings = importClause.namedBindings;
          if (namedBindings) {
            switch (namedBindings.kind) {
              case 256:
                statements = appendExportsOfDeclaration(statements, namedBindings);
                break;
              case 257:
                for (var _i = 0, _a = namedBindings.elements; _i < _a.length; _i++) {
                  var importBinding = _a[_i];
                  statements = appendExportsOfDeclaration(statements, importBinding, true);
                }
                break;
            }
          }
          return statements;
        }
        function appendExportsOfImportEqualsDeclaration(statements, decl) {
          if (currentModuleInfo.exportEquals) {
            return statements;
          }
          return appendExportsOfDeclaration(statements, decl);
        }
        function appendExportsOfVariableStatement(statements, node) {
          if (currentModuleInfo.exportEquals) {
            return statements;
          }
          for (var _i = 0, _a = node.declarationList.declarations; _i < _a.length; _i++) {
            var decl = _a[_i];
            statements = appendExportsOfBindingElement(statements, decl);
          }
          return statements;
        }
        function appendExportsOfBindingElement(statements, decl) {
          if (currentModuleInfo.exportEquals) {
            return statements;
          }
          if (ts2.isBindingPattern(decl.name)) {
            for (var _i = 0, _a = decl.name.elements; _i < _a.length; _i++) {
              var element = _a[_i];
              if (!ts2.isOmittedExpression(element)) {
                statements = appendExportsOfBindingElement(statements, element);
              }
            }
          } else if (!ts2.isGeneratedIdentifier(decl.name)) {
            statements = appendExportsOfDeclaration(statements, decl);
          }
          return statements;
        }
        function appendExportsOfHoistedDeclaration(statements, decl) {
          if (currentModuleInfo.exportEquals) {
            return statements;
          }
          if (ts2.hasModifier(decl, 1)) {
            var exportName = ts2.hasModifier(decl, 512) ? ts2.createIdentifier("default") : ts2.getDeclarationName(decl);
            statements = appendExportStatement(statements, exportName, ts2.getLocalName(decl), decl);
          }
          if (decl.name) {
            statements = appendExportsOfDeclaration(statements, decl);
          }
          return statements;
        }
        function appendExportsOfDeclaration(statements, decl, liveBinding) {
          var name = ts2.getDeclarationName(decl);
          var exportSpecifiers = currentModuleInfo.exportSpecifiers.get(ts2.idText(name));
          if (exportSpecifiers) {
            for (var _i = 0, exportSpecifiers_1 = exportSpecifiers; _i < exportSpecifiers_1.length; _i++) {
              var exportSpecifier = exportSpecifiers_1[_i];
              statements = appendExportStatement(statements, exportSpecifier.name, name, exportSpecifier.name, void 0, liveBinding);
            }
          }
          return statements;
        }
        function appendExportStatement(statements, exportName, expression, location, allowComments, liveBinding) {
          statements = ts2.append(statements, createExportStatement(exportName, expression, location, allowComments, liveBinding));
          return statements;
        }
        function createUnderscoreUnderscoreESModule() {
          var statement;
          if (languageVersion === 0) {
            statement = ts2.createExpressionStatement(createExportExpression(ts2.createIdentifier("__esModule"), ts2.createLiteral(true)));
          } else {
            statement = ts2.createExpressionStatement(ts2.createCall(ts2.createPropertyAccess(ts2.createIdentifier("Object"), "defineProperty"), void 0, [
              ts2.createIdentifier("exports"),
              ts2.createLiteral("__esModule"),
              ts2.createObjectLiteral([
                ts2.createPropertyAssignment("value", ts2.createLiteral(true))
              ])
            ]));
          }
          ts2.setEmitFlags(statement, 1048576);
          return statement;
        }
        function createExportStatement(name, value, location, allowComments, liveBinding) {
          var statement = ts2.setTextRange(ts2.createExpressionStatement(createExportExpression(name, value, void 0, liveBinding)), location);
          ts2.startOnNewLine(statement);
          if (!allowComments) {
            ts2.setEmitFlags(statement, 1536);
          }
          return statement;
        }
        function createExportExpression(name, value, location, liveBinding) {
          return ts2.setTextRange(liveBinding && languageVersion !== 0 ? ts2.createCall(ts2.createPropertyAccess(ts2.createIdentifier("Object"), "defineProperty"), void 0, [
            ts2.createIdentifier("exports"),
            ts2.createLiteral(name),
            ts2.createObjectLiteral([
              ts2.createPropertyAssignment("enumerable", ts2.createLiteral(true)),
              ts2.createPropertyAssignment("get", ts2.createFunctionExpression(void 0, void 0, void 0, void 0, [], void 0, ts2.createBlock([ts2.createReturn(value)])))
            ])
          ]) : ts2.createAssignment(ts2.createPropertyAccess(ts2.createIdentifier("exports"), ts2.getSynthesizedClone(name)), value), location);
        }
        function modifierVisitor(node) {
          switch (node.kind) {
            case 89:
            case 84:
              return void 0;
          }
          return node;
        }
        function onEmitNode(hint, node, emitCallback) {
          if (node.kind === 290) {
            currentSourceFile = node;
            currentModuleInfo = moduleInfoMap[ts2.getOriginalNodeId(currentSourceFile)];
            noSubstitution = [];
            previousOnEmitNode(hint, node, emitCallback);
            currentSourceFile = void 0;
            currentModuleInfo = void 0;
            noSubstitution = void 0;
          } else {
            previousOnEmitNode(hint, node, emitCallback);
          }
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (node.id && noSubstitution[node.id]) {
            return node;
          }
          if (hint === 1) {
            return substituteExpression(node);
          } else if (ts2.isShorthandPropertyAssignment(node)) {
            return substituteShorthandPropertyAssignment(node);
          }
          return node;
        }
        function substituteShorthandPropertyAssignment(node) {
          var name = node.name;
          var exportedOrImportedName = substituteExpressionIdentifier(name);
          if (exportedOrImportedName !== name) {
            if (node.objectAssignmentInitializer) {
              var initializer = ts2.createAssignment(exportedOrImportedName, node.objectAssignmentInitializer);
              return ts2.setTextRange(ts2.createPropertyAssignment(name, initializer), node);
            }
            return ts2.setTextRange(ts2.createPropertyAssignment(name, exportedOrImportedName), node);
          }
          return node;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 75:
              return substituteExpressionIdentifier(node);
            case 209:
              return substituteBinaryExpression(node);
            case 208:
            case 207:
              return substituteUnaryExpression(node);
          }
          return node;
        }
        function substituteExpressionIdentifier(node) {
          if (ts2.getEmitFlags(node) & 4096) {
            var externalHelpersModuleName = ts2.getExternalHelpersModuleName(currentSourceFile);
            if (externalHelpersModuleName) {
              return ts2.createPropertyAccess(externalHelpersModuleName, node);
            }
            return node;
          }
          if (!ts2.isGeneratedIdentifier(node) && !ts2.isLocalName(node)) {
            var exportContainer = resolver.getReferencedExportContainer(node, ts2.isExportName(node));
            if (exportContainer && exportContainer.kind === 290) {
              return ts2.setTextRange(ts2.createPropertyAccess(ts2.createIdentifier("exports"), ts2.getSynthesizedClone(node)), node);
            }
            var importDeclaration = resolver.getReferencedImportDeclaration(node);
            if (importDeclaration) {
              if (ts2.isImportClause(importDeclaration)) {
                return ts2.setTextRange(ts2.createPropertyAccess(ts2.getGeneratedNameForNode(importDeclaration.parent), ts2.createIdentifier("default")), node);
              } else if (ts2.isImportSpecifier(importDeclaration)) {
                var name = importDeclaration.propertyName || importDeclaration.name;
                return ts2.setTextRange(ts2.createPropertyAccess(ts2.getGeneratedNameForNode(importDeclaration.parent.parent.parent), ts2.getSynthesizedClone(name)), node);
              }
            }
          }
          return node;
        }
        function substituteBinaryExpression(node) {
          if (ts2.isAssignmentOperator(node.operatorToken.kind) && ts2.isIdentifier(node.left) && !ts2.isGeneratedIdentifier(node.left) && !ts2.isLocalName(node.left) && !ts2.isDeclarationNameOfEnumOrNamespace(node.left)) {
            var exportedNames = getExports(node.left);
            if (exportedNames) {
              var expression = node;
              for (var _i = 0, exportedNames_2 = exportedNames; _i < exportedNames_2.length; _i++) {
                var exportName = exportedNames_2[_i];
                noSubstitution[ts2.getNodeId(expression)] = true;
                expression = createExportExpression(exportName, expression, node);
              }
              return expression;
            }
          }
          return node;
        }
        function substituteUnaryExpression(node) {
          if ((node.operator === 45 || node.operator === 46) && ts2.isIdentifier(node.operand) && !ts2.isGeneratedIdentifier(node.operand) && !ts2.isLocalName(node.operand) && !ts2.isDeclarationNameOfEnumOrNamespace(node.operand)) {
            var exportedNames = getExports(node.operand);
            if (exportedNames) {
              var expression = node.kind === 208 ? ts2.setTextRange(ts2.createBinary(node.operand, ts2.createToken(node.operator === 45 ? 63 : 64), ts2.createLiteral(1)), node) : node;
              for (var _i = 0, exportedNames_3 = exportedNames; _i < exportedNames_3.length; _i++) {
                var exportName = exportedNames_3[_i];
                noSubstitution[ts2.getNodeId(expression)] = true;
                expression = createExportExpression(exportName, expression);
              }
              return expression;
            }
          }
          return node;
        }
        function getExports(name) {
          if (!ts2.isGeneratedIdentifier(name)) {
            var valueDeclaration = resolver.getReferencedImportDeclaration(name) || resolver.getReferencedValueDeclaration(name);
            if (valueDeclaration) {
              return currentModuleInfo && currentModuleInfo.exportedBindings[ts2.getOriginalNodeId(valueDeclaration)];
            }
          }
        }
      }
      ts2.transformModule = transformModule;
      ts2.createBindingHelper = {
        name: "typescript:commonjscreatebinding",
        importName: "__createBinding",
        scoped: false,
        priority: 1,
        text: "\nvar __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {\n    if (k2 === undefined) k2 = k;\n    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });\n}) : (function(o, m, k, k2) {\n    if (k2 === undefined) k2 = k;\n    o[k2] = m[k];\n}));"
      };
      function createCreateBindingHelper(context, module3, inputName, outputName) {
        context.requestEmitHelper(ts2.createBindingHelper);
        return ts2.createCall(ts2.getUnscopedHelperName("__createBinding"), void 0, __spreadArrays([ts2.createIdentifier("exports"), module3, inputName], outputName ? [outputName] : []));
      }
      ts2.setModuleDefaultHelper = {
        name: "typescript:commonjscreatevalue",
        importName: "__setModuleDefault",
        scoped: false,
        priority: 1,
        text: '\nvar __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {\n    Object.defineProperty(o, "default", { enumerable: true, value: v });\n}) : function(o, v) {\n    o["default"] = v;\n});'
      };
      var exportStarHelper = {
        name: "typescript:export-star",
        importName: "__exportStar",
        scoped: false,
        dependencies: [ts2.createBindingHelper],
        priority: 2,
        text: '\n            var __exportStar = (this && this.__exportStar) || function(m, exports) {\n                for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) __createBinding(exports, m, p);\n            };'
      };
      function createExportStarHelper(context, module3) {
        context.requestEmitHelper(exportStarHelper);
        return ts2.createCall(ts2.getUnscopedHelperName("__exportStar"), void 0, [module3, ts2.createIdentifier("exports")]);
      }
      var dynamicImportUMDHelper = {
        name: "typescript:dynamicimport-sync-require",
        scoped: true,
        text: '\n            var __syncRequire = typeof module === "object" && typeof module.exports === "object";'
      };
      ts2.importStarHelper = {
        name: "typescript:commonjsimportstar",
        importName: "__importStar",
        scoped: false,
        dependencies: [ts2.createBindingHelper, ts2.setModuleDefaultHelper],
        priority: 2,
        text: '\nvar __importStar = (this && this.__importStar) || function (mod) {\n    if (mod && mod.__esModule) return mod;\n    var result = {};\n    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);\n    __setModuleDefault(result, mod);\n    return result;\n};'
      };
      ts2.importDefaultHelper = {
        name: "typescript:commonjsimportdefault",
        importName: "__importDefault",
        scoped: false,
        text: '\nvar __importDefault = (this && this.__importDefault) || function (mod) {\n    return (mod && mod.__esModule) ? mod : { "default": mod };\n};'
      };
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function transformSystemModule(context) {
        var startLexicalEnvironment = context.startLexicalEnvironment, endLexicalEnvironment = context.endLexicalEnvironment, hoistVariableDeclaration = context.hoistVariableDeclaration;
        var compilerOptions = context.getCompilerOptions();
        var resolver = context.getEmitResolver();
        var host = context.getEmitHost();
        var previousOnSubstituteNode = context.onSubstituteNode;
        var previousOnEmitNode = context.onEmitNode;
        context.onSubstituteNode = onSubstituteNode;
        context.onEmitNode = onEmitNode;
        context.enableSubstitution(75);
        context.enableSubstitution(282);
        context.enableSubstitution(209);
        context.enableSubstitution(207);
        context.enableSubstitution(208);
        context.enableSubstitution(219);
        context.enableEmitNotification(290);
        var moduleInfoMap = [];
        var deferredExports = [];
        var exportFunctionsMap = [];
        var noSubstitutionMap = [];
        var contextObjectMap = [];
        var currentSourceFile;
        var moduleInfo;
        var exportFunction;
        var contextObject;
        var hoistedStatements;
        var enclosingBlockScopedContainer;
        var noSubstitution;
        return ts2.chainBundle(transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile || !(ts2.isEffectiveExternalModule(node, compilerOptions) || node.transformFlags & 2097152)) {
            return node;
          }
          var id = ts2.getOriginalNodeId(node);
          currentSourceFile = node;
          enclosingBlockScopedContainer = node;
          moduleInfo = moduleInfoMap[id] = ts2.collectExternalModuleInfo(node, resolver, compilerOptions);
          exportFunction = ts2.createUniqueName("exports");
          exportFunctionsMap[id] = exportFunction;
          contextObject = contextObjectMap[id] = ts2.createUniqueName("context");
          var dependencyGroups = collectDependencyGroups(moduleInfo.externalImports);
          var moduleBodyBlock = createSystemModuleBody(node, dependencyGroups);
          var moduleBodyFunction = ts2.createFunctionExpression(void 0, void 0, void 0, void 0, [
            ts2.createParameter(void 0, void 0, void 0, exportFunction),
            ts2.createParameter(void 0, void 0, void 0, contextObject)
          ], void 0, moduleBodyBlock);
          var moduleName = ts2.tryGetModuleNameFromFile(node, host, compilerOptions);
          var dependencies = ts2.createArrayLiteral(ts2.map(dependencyGroups, function(dependencyGroup) {
            return dependencyGroup.name;
          }));
          var updated = ts2.setEmitFlags(ts2.updateSourceFileNode(node, ts2.setTextRange(ts2.createNodeArray([
            ts2.createExpressionStatement(ts2.createCall(ts2.createPropertyAccess(ts2.createIdentifier("System"), "register"), void 0, moduleName ? [moduleName, dependencies, moduleBodyFunction] : [dependencies, moduleBodyFunction]))
          ]), node.statements)), 1024);
          if (!(compilerOptions.outFile || compilerOptions.out)) {
            ts2.moveEmitHelpers(updated, moduleBodyBlock, function(helper) {
              return !helper.scoped;
            });
          }
          if (noSubstitution) {
            noSubstitutionMap[id] = noSubstitution;
            noSubstitution = void 0;
          }
          currentSourceFile = void 0;
          moduleInfo = void 0;
          exportFunction = void 0;
          contextObject = void 0;
          hoistedStatements = void 0;
          enclosingBlockScopedContainer = void 0;
          return ts2.aggregateTransformFlags(updated);
        }
        function collectDependencyGroups(externalImports) {
          var groupIndices = ts2.createMap();
          var dependencyGroups = [];
          for (var _i = 0, externalImports_1 = externalImports; _i < externalImports_1.length; _i++) {
            var externalImport = externalImports_1[_i];
            var externalModuleName = ts2.getExternalModuleNameLiteral(externalImport, currentSourceFile, host, resolver, compilerOptions);
            if (externalModuleName) {
              var text = externalModuleName.text;
              var groupIndex = groupIndices.get(text);
              if (groupIndex !== void 0) {
                dependencyGroups[groupIndex].externalImports.push(externalImport);
              } else {
                groupIndices.set(text, dependencyGroups.length);
                dependencyGroups.push({
                  name: externalModuleName,
                  externalImports: [externalImport]
                });
              }
            }
          }
          return dependencyGroups;
        }
        function createSystemModuleBody(node, dependencyGroups) {
          var statements = [];
          startLexicalEnvironment();
          var ensureUseStrict = ts2.getStrictOptionValue(compilerOptions, "alwaysStrict") || !compilerOptions.noImplicitUseStrict && ts2.isExternalModule(currentSourceFile);
          var statementOffset = ts2.addPrologue(statements, node.statements, ensureUseStrict, sourceElementVisitor);
          statements.push(ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([
            ts2.createVariableDeclaration("__moduleName", void 0, ts2.createLogicalAnd(contextObject, ts2.createPropertyAccess(contextObject, "id")))
          ])));
          ts2.visitNode(moduleInfo.externalHelpersImportDeclaration, sourceElementVisitor, ts2.isStatement);
          var executeStatements = ts2.visitNodes(node.statements, sourceElementVisitor, ts2.isStatement, statementOffset);
          ts2.addRange(statements, hoistedStatements);
          ts2.insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
          var exportStarFunction = addExportStarIfNeeded(statements);
          var modifiers = node.transformFlags & 524288 ? ts2.createModifiersFromModifierFlags(256) : void 0;
          var moduleObject = ts2.createObjectLiteral([
            ts2.createPropertyAssignment("setters", createSettersArray(exportStarFunction, dependencyGroups)),
            ts2.createPropertyAssignment("execute", ts2.createFunctionExpression(modifiers, void 0, void 0, void 0, [], void 0, ts2.createBlock(executeStatements, true)))
          ]);
          moduleObject.multiLine = true;
          statements.push(ts2.createReturn(moduleObject));
          return ts2.createBlock(statements, true);
        }
        function addExportStarIfNeeded(statements) {
          if (!moduleInfo.hasExportStarsToExportValues) {
            return;
          }
          if (!moduleInfo.exportedNames && moduleInfo.exportSpecifiers.size === 0) {
            var hasExportDeclarationWithExportClause = false;
            for (var _i = 0, _a = moduleInfo.externalImports; _i < _a.length; _i++) {
              var externalImport = _a[_i];
              if (externalImport.kind === 260 && externalImport.exportClause) {
                hasExportDeclarationWithExportClause = true;
                break;
              }
            }
            if (!hasExportDeclarationWithExportClause) {
              var exportStarFunction_1 = createExportStarFunction(void 0);
              statements.push(exportStarFunction_1);
              return exportStarFunction_1.name;
            }
          }
          var exportedNames = [];
          if (moduleInfo.exportedNames) {
            for (var _b = 0, _c = moduleInfo.exportedNames; _b < _c.length; _b++) {
              var exportedLocalName = _c[_b];
              if (exportedLocalName.escapedText === "default") {
                continue;
              }
              exportedNames.push(ts2.createPropertyAssignment(ts2.createLiteral(exportedLocalName), ts2.createTrue()));
            }
          }
          for (var _d = 0, _e = moduleInfo.externalImports; _d < _e.length; _d++) {
            var externalImport = _e[_d];
            if (externalImport.kind !== 260) {
              continue;
            }
            if (!externalImport.exportClause) {
              continue;
            }
            if (ts2.isNamedExports(externalImport.exportClause)) {
              for (var _f = 0, _g = externalImport.exportClause.elements; _f < _g.length; _f++) {
                var element = _g[_f];
                exportedNames.push(ts2.createPropertyAssignment(ts2.createLiteral(ts2.idText(element.name || element.propertyName)), ts2.createTrue()));
              }
            } else {
              exportedNames.push(ts2.createPropertyAssignment(ts2.createLiteral(ts2.idText(externalImport.exportClause.name)), ts2.createTrue()));
            }
          }
          var exportedNamesStorageRef = ts2.createUniqueName("exportedNames");
          statements.push(ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([
            ts2.createVariableDeclaration(exportedNamesStorageRef, void 0, ts2.createObjectLiteral(exportedNames, true))
          ])));
          var exportStarFunction = createExportStarFunction(exportedNamesStorageRef);
          statements.push(exportStarFunction);
          return exportStarFunction.name;
        }
        function createExportStarFunction(localNames) {
          var exportStarFunction = ts2.createUniqueName("exportStar");
          var m = ts2.createIdentifier("m");
          var n = ts2.createIdentifier("n");
          var exports2 = ts2.createIdentifier("exports");
          var condition = ts2.createStrictInequality(n, ts2.createLiteral("default"));
          if (localNames) {
            condition = ts2.createLogicalAnd(condition, ts2.createLogicalNot(ts2.createCall(ts2.createPropertyAccess(localNames, "hasOwnProperty"), void 0, [n])));
          }
          return ts2.createFunctionDeclaration(void 0, void 0, void 0, exportStarFunction, void 0, [ts2.createParameter(void 0, void 0, void 0, m)], void 0, ts2.createBlock([
            ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([
              ts2.createVariableDeclaration(exports2, void 0, ts2.createObjectLiteral([]))
            ])),
            ts2.createForIn(ts2.createVariableDeclarationList([
              ts2.createVariableDeclaration(n, void 0)
            ]), m, ts2.createBlock([
              ts2.setEmitFlags(ts2.createIf(condition, ts2.createExpressionStatement(ts2.createAssignment(ts2.createElementAccess(exports2, n), ts2.createElementAccess(m, n)))), 1)
            ])),
            ts2.createExpressionStatement(ts2.createCall(exportFunction, void 0, [exports2]))
          ], true));
        }
        function createSettersArray(exportStarFunction, dependencyGroups) {
          var setters = [];
          for (var _i = 0, dependencyGroups_1 = dependencyGroups; _i < dependencyGroups_1.length; _i++) {
            var group_2 = dependencyGroups_1[_i];
            var localName = ts2.forEach(group_2.externalImports, function(i) {
              return ts2.getLocalNameForExternalImport(i, currentSourceFile);
            });
            var parameterName = localName ? ts2.getGeneratedNameForNode(localName) : ts2.createUniqueName("");
            var statements = [];
            for (var _a = 0, _b = group_2.externalImports; _a < _b.length; _a++) {
              var entry = _b[_a];
              var importVariableName = ts2.getLocalNameForExternalImport(entry, currentSourceFile);
              switch (entry.kind) {
                case 254:
                  if (!entry.importClause) {
                    break;
                  }
                case 253:
                  ts2.Debug.assert(importVariableName !== void 0);
                  statements.push(ts2.createExpressionStatement(ts2.createAssignment(importVariableName, parameterName)));
                  break;
                case 260:
                  ts2.Debug.assert(importVariableName !== void 0);
                  if (entry.exportClause) {
                    if (ts2.isNamedExports(entry.exportClause)) {
                      var properties = [];
                      for (var _c = 0, _d = entry.exportClause.elements; _c < _d.length; _c++) {
                        var e = _d[_c];
                        properties.push(ts2.createPropertyAssignment(ts2.createLiteral(ts2.idText(e.name)), ts2.createElementAccess(parameterName, ts2.createLiteral(ts2.idText(e.propertyName || e.name)))));
                      }
                      statements.push(ts2.createExpressionStatement(ts2.createCall(exportFunction, void 0, [ts2.createObjectLiteral(properties, true)])));
                    } else {
                      statements.push(ts2.createExpressionStatement(ts2.createCall(exportFunction, void 0, [
                        ts2.createLiteral(ts2.idText(entry.exportClause.name)),
                        parameterName
                      ])));
                    }
                  } else {
                    statements.push(ts2.createExpressionStatement(ts2.createCall(exportStarFunction, void 0, [parameterName])));
                  }
                  break;
              }
            }
            setters.push(ts2.createFunctionExpression(void 0, void 0, void 0, void 0, [ts2.createParameter(void 0, void 0, void 0, parameterName)], void 0, ts2.createBlock(statements, true)));
          }
          return ts2.createArrayLiteral(setters, true);
        }
        function sourceElementVisitor(node) {
          switch (node.kind) {
            case 254:
              return visitImportDeclaration(node);
            case 253:
              return visitImportEqualsDeclaration(node);
            case 260:
              return visitExportDeclaration(node);
            case 259:
              return visitExportAssignment(node);
            default:
              return nestedElementVisitor(node);
          }
        }
        function visitImportDeclaration(node) {
          var statements;
          if (node.importClause) {
            hoistVariableDeclaration(ts2.getLocalNameForExternalImport(node, currentSourceFile));
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts2.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfImportDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfImportDeclaration(statements, node);
          }
          return ts2.singleOrMany(statements);
        }
        function visitExportDeclaration(node) {
          ts2.Debug.assertIsDefined(node);
          return void 0;
        }
        function visitImportEqualsDeclaration(node) {
          ts2.Debug.assert(ts2.isExternalModuleImportEqualsDeclaration(node), "import= for internal module references should be handled in an earlier transformer.");
          var statements;
          hoistVariableDeclaration(ts2.getLocalNameForExternalImport(node, currentSourceFile));
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts2.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfImportEqualsDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfImportEqualsDeclaration(statements, node);
          }
          return ts2.singleOrMany(statements);
        }
        function visitExportAssignment(node) {
          if (node.isExportEquals) {
            return void 0;
          }
          var expression = ts2.visitNode(node.expression, destructuringAndImportCallVisitor, ts2.isExpression);
          var original = node.original;
          if (original && hasAssociatedEndOfDeclarationMarker(original)) {
            var id = ts2.getOriginalNodeId(node);
            deferredExports[id] = appendExportStatement(deferredExports[id], ts2.createIdentifier("default"), expression, true);
          } else {
            return createExportStatement(ts2.createIdentifier("default"), expression, true);
          }
        }
        function visitFunctionDeclaration(node) {
          if (ts2.hasModifier(node, 1)) {
            hoistedStatements = ts2.append(hoistedStatements, ts2.updateFunctionDeclaration(node, node.decorators, ts2.visitNodes(node.modifiers, modifierVisitor, ts2.isModifier), node.asteriskToken, ts2.getDeclarationName(node, true, true), void 0, ts2.visitNodes(node.parameters, destructuringAndImportCallVisitor, ts2.isParameterDeclaration), void 0, ts2.visitNode(node.body, destructuringAndImportCallVisitor, ts2.isBlock)));
          } else {
            hoistedStatements = ts2.append(hoistedStatements, ts2.visitEachChild(node, destructuringAndImportCallVisitor, context));
          }
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts2.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfHoistedDeclaration(deferredExports[id], node);
          } else {
            hoistedStatements = appendExportsOfHoistedDeclaration(hoistedStatements, node);
          }
          return void 0;
        }
        function visitClassDeclaration(node) {
          var statements;
          var name = ts2.getLocalName(node);
          hoistVariableDeclaration(name);
          statements = ts2.append(statements, ts2.setTextRange(ts2.createExpressionStatement(ts2.createAssignment(name, ts2.setTextRange(ts2.createClassExpression(void 0, node.name, void 0, ts2.visitNodes(node.heritageClauses, destructuringAndImportCallVisitor, ts2.isHeritageClause), ts2.visitNodes(node.members, destructuringAndImportCallVisitor, ts2.isClassElement)), node))), node));
          if (hasAssociatedEndOfDeclarationMarker(node)) {
            var id = ts2.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfHoistedDeclaration(deferredExports[id], node);
          } else {
            statements = appendExportsOfHoistedDeclaration(statements, node);
          }
          return ts2.singleOrMany(statements);
        }
        function visitVariableStatement(node) {
          if (!shouldHoistVariableDeclarationList(node.declarationList)) {
            return ts2.visitNode(node, destructuringAndImportCallVisitor, ts2.isStatement);
          }
          var expressions;
          var isExportedDeclaration = ts2.hasModifier(node, 1);
          var isMarkedDeclaration = hasAssociatedEndOfDeclarationMarker(node);
          for (var _i = 0, _a = node.declarationList.declarations; _i < _a.length; _i++) {
            var variable = _a[_i];
            if (variable.initializer) {
              expressions = ts2.append(expressions, transformInitializedVariable(variable, isExportedDeclaration && !isMarkedDeclaration));
            } else {
              hoistBindingElement(variable);
            }
          }
          var statements;
          if (expressions) {
            statements = ts2.append(statements, ts2.setTextRange(ts2.createExpressionStatement(ts2.inlineExpressions(expressions)), node));
          }
          if (isMarkedDeclaration) {
            var id = ts2.getOriginalNodeId(node);
            deferredExports[id] = appendExportsOfVariableStatement(deferredExports[id], node, isExportedDeclaration);
          } else {
            statements = appendExportsOfVariableStatement(statements, node, false);
          }
          return ts2.singleOrMany(statements);
        }
        function hoistBindingElement(node) {
          if (ts2.isBindingPattern(node.name)) {
            for (var _i = 0, _a = node.name.elements; _i < _a.length; _i++) {
              var element = _a[_i];
              if (!ts2.isOmittedExpression(element)) {
                hoistBindingElement(element);
              }
            }
          } else {
            hoistVariableDeclaration(ts2.getSynthesizedClone(node.name));
          }
        }
        function shouldHoistVariableDeclarationList(node) {
          return (ts2.getEmitFlags(node) & 2097152) === 0 && (enclosingBlockScopedContainer.kind === 290 || (ts2.getOriginalNode(node).flags & 3) === 0);
        }
        function transformInitializedVariable(node, isExportedDeclaration) {
          var createAssignment = isExportedDeclaration ? createExportedVariableAssignment : createNonExportedVariableAssignment;
          return ts2.isBindingPattern(node.name) ? ts2.flattenDestructuringAssignment(node, destructuringAndImportCallVisitor, context, 0, false, createAssignment) : node.initializer ? createAssignment(node.name, ts2.visitNode(node.initializer, destructuringAndImportCallVisitor, ts2.isExpression)) : node.name;
        }
        function createExportedVariableAssignment(name, value, location) {
          return createVariableAssignment(name, value, location, true);
        }
        function createNonExportedVariableAssignment(name, value, location) {
          return createVariableAssignment(name, value, location, false);
        }
        function createVariableAssignment(name, value, location, isExportedDeclaration) {
          hoistVariableDeclaration(ts2.getSynthesizedClone(name));
          return isExportedDeclaration ? createExportExpression(name, preventSubstitution(ts2.setTextRange(ts2.createAssignment(name, value), location))) : preventSubstitution(ts2.setTextRange(ts2.createAssignment(name, value), location));
        }
        function visitMergeDeclarationMarker(node) {
          if (hasAssociatedEndOfDeclarationMarker(node) && node.original.kind === 225) {
            var id = ts2.getOriginalNodeId(node);
            var isExportedDeclaration = ts2.hasModifier(node.original, 1);
            deferredExports[id] = appendExportsOfVariableStatement(deferredExports[id], node.original, isExportedDeclaration);
          }
          return node;
        }
        function hasAssociatedEndOfDeclarationMarker(node) {
          return (ts2.getEmitFlags(node) & 4194304) !== 0;
        }
        function visitEndOfDeclarationMarker(node) {
          var id = ts2.getOriginalNodeId(node);
          var statements = deferredExports[id];
          if (statements) {
            delete deferredExports[id];
            return ts2.append(statements, node);
          } else {
            var original = ts2.getOriginalNode(node);
            if (ts2.isModuleOrEnumDeclaration(original)) {
              return ts2.append(appendExportsOfDeclaration(statements, original), node);
            }
          }
          return node;
        }
        function appendExportsOfImportDeclaration(statements, decl) {
          if (moduleInfo.exportEquals) {
            return statements;
          }
          var importClause = decl.importClause;
          if (!importClause) {
            return statements;
          }
          if (importClause.name) {
            statements = appendExportsOfDeclaration(statements, importClause);
          }
          var namedBindings = importClause.namedBindings;
          if (namedBindings) {
            switch (namedBindings.kind) {
              case 256:
                statements = appendExportsOfDeclaration(statements, namedBindings);
                break;
              case 257:
                for (var _i = 0, _a = namedBindings.elements; _i < _a.length; _i++) {
                  var importBinding = _a[_i];
                  statements = appendExportsOfDeclaration(statements, importBinding);
                }
                break;
            }
          }
          return statements;
        }
        function appendExportsOfImportEqualsDeclaration(statements, decl) {
          if (moduleInfo.exportEquals) {
            return statements;
          }
          return appendExportsOfDeclaration(statements, decl);
        }
        function appendExportsOfVariableStatement(statements, node, exportSelf) {
          if (moduleInfo.exportEquals) {
            return statements;
          }
          for (var _i = 0, _a = node.declarationList.declarations; _i < _a.length; _i++) {
            var decl = _a[_i];
            if (decl.initializer || exportSelf) {
              statements = appendExportsOfBindingElement(statements, decl, exportSelf);
            }
          }
          return statements;
        }
        function appendExportsOfBindingElement(statements, decl, exportSelf) {
          if (moduleInfo.exportEquals) {
            return statements;
          }
          if (ts2.isBindingPattern(decl.name)) {
            for (var _i = 0, _a = decl.name.elements; _i < _a.length; _i++) {
              var element = _a[_i];
              if (!ts2.isOmittedExpression(element)) {
                statements = appendExportsOfBindingElement(statements, element, exportSelf);
              }
            }
          } else if (!ts2.isGeneratedIdentifier(decl.name)) {
            var excludeName = void 0;
            if (exportSelf) {
              statements = appendExportStatement(statements, decl.name, ts2.getLocalName(decl));
              excludeName = ts2.idText(decl.name);
            }
            statements = appendExportsOfDeclaration(statements, decl, excludeName);
          }
          return statements;
        }
        function appendExportsOfHoistedDeclaration(statements, decl) {
          if (moduleInfo.exportEquals) {
            return statements;
          }
          var excludeName;
          if (ts2.hasModifier(decl, 1)) {
            var exportName = ts2.hasModifier(decl, 512) ? ts2.createLiteral("default") : decl.name;
            statements = appendExportStatement(statements, exportName, ts2.getLocalName(decl));
            excludeName = ts2.getTextOfIdentifierOrLiteral(exportName);
          }
          if (decl.name) {
            statements = appendExportsOfDeclaration(statements, decl, excludeName);
          }
          return statements;
        }
        function appendExportsOfDeclaration(statements, decl, excludeName) {
          if (moduleInfo.exportEquals) {
            return statements;
          }
          var name = ts2.getDeclarationName(decl);
          var exportSpecifiers = moduleInfo.exportSpecifiers.get(ts2.idText(name));
          if (exportSpecifiers) {
            for (var _i = 0, exportSpecifiers_2 = exportSpecifiers; _i < exportSpecifiers_2.length; _i++) {
              var exportSpecifier = exportSpecifiers_2[_i];
              if (exportSpecifier.name.escapedText !== excludeName) {
                statements = appendExportStatement(statements, exportSpecifier.name, name);
              }
            }
          }
          return statements;
        }
        function appendExportStatement(statements, exportName, expression, allowComments) {
          statements = ts2.append(statements, createExportStatement(exportName, expression, allowComments));
          return statements;
        }
        function createExportStatement(name, value, allowComments) {
          var statement = ts2.createExpressionStatement(createExportExpression(name, value));
          ts2.startOnNewLine(statement);
          if (!allowComments) {
            ts2.setEmitFlags(statement, 1536);
          }
          return statement;
        }
        function createExportExpression(name, value) {
          var exportName = ts2.isIdentifier(name) ? ts2.createLiteral(name) : name;
          ts2.setEmitFlags(value, ts2.getEmitFlags(value) | 1536);
          return ts2.setCommentRange(ts2.createCall(exportFunction, void 0, [exportName, value]), value);
        }
        function nestedElementVisitor(node) {
          switch (node.kind) {
            case 225:
              return visitVariableStatement(node);
            case 244:
              return visitFunctionDeclaration(node);
            case 245:
              return visitClassDeclaration(node);
            case 230:
              return visitForStatement(node);
            case 231:
              return visitForInStatement(node);
            case 232:
              return visitForOfStatement(node);
            case 228:
              return visitDoStatement(node);
            case 229:
              return visitWhileStatement(node);
            case 238:
              return visitLabeledStatement(node);
            case 236:
              return visitWithStatement(node);
            case 237:
              return visitSwitchStatement(node);
            case 251:
              return visitCaseBlock(node);
            case 277:
              return visitCaseClause(node);
            case 278:
              return visitDefaultClause(node);
            case 240:
              return visitTryStatement(node);
            case 280:
              return visitCatchClause(node);
            case 223:
              return visitBlock(node);
            case 328:
              return visitMergeDeclarationMarker(node);
            case 329:
              return visitEndOfDeclarationMarker(node);
            default:
              return destructuringAndImportCallVisitor(node);
          }
        }
        function visitForStatement(node) {
          var savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
          enclosingBlockScopedContainer = node;
          node = ts2.updateFor(node, node.initializer && visitForInitializer(node.initializer), ts2.visitNode(node.condition, destructuringAndImportCallVisitor, ts2.isExpression), ts2.visitNode(node.incrementor, destructuringAndImportCallVisitor, ts2.isExpression), ts2.visitNode(node.statement, nestedElementVisitor, ts2.isStatement));
          enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
          return node;
        }
        function visitForInStatement(node) {
          var savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
          enclosingBlockScopedContainer = node;
          node = ts2.updateForIn(node, visitForInitializer(node.initializer), ts2.visitNode(node.expression, destructuringAndImportCallVisitor, ts2.isExpression), ts2.visitNode(node.statement, nestedElementVisitor, ts2.isStatement, ts2.liftToBlock));
          enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
          return node;
        }
        function visitForOfStatement(node) {
          var savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
          enclosingBlockScopedContainer = node;
          node = ts2.updateForOf(node, node.awaitModifier, visitForInitializer(node.initializer), ts2.visitNode(node.expression, destructuringAndImportCallVisitor, ts2.isExpression), ts2.visitNode(node.statement, nestedElementVisitor, ts2.isStatement, ts2.liftToBlock));
          enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
          return node;
        }
        function shouldHoistForInitializer(node) {
          return ts2.isVariableDeclarationList(node) && shouldHoistVariableDeclarationList(node);
        }
        function visitForInitializer(node) {
          if (shouldHoistForInitializer(node)) {
            var expressions = void 0;
            for (var _i = 0, _a = node.declarations; _i < _a.length; _i++) {
              var variable = _a[_i];
              expressions = ts2.append(expressions, transformInitializedVariable(variable, false));
              if (!variable.initializer) {
                hoistBindingElement(variable);
              }
            }
            return expressions ? ts2.inlineExpressions(expressions) : ts2.createOmittedExpression();
          } else {
            return ts2.visitEachChild(node, nestedElementVisitor, context);
          }
        }
        function visitDoStatement(node) {
          return ts2.updateDo(node, ts2.visitNode(node.statement, nestedElementVisitor, ts2.isStatement, ts2.liftToBlock), ts2.visitNode(node.expression, destructuringAndImportCallVisitor, ts2.isExpression));
        }
        function visitWhileStatement(node) {
          return ts2.updateWhile(node, ts2.visitNode(node.expression, destructuringAndImportCallVisitor, ts2.isExpression), ts2.visitNode(node.statement, nestedElementVisitor, ts2.isStatement, ts2.liftToBlock));
        }
        function visitLabeledStatement(node) {
          return ts2.updateLabel(node, node.label, ts2.visitNode(node.statement, nestedElementVisitor, ts2.isStatement, ts2.liftToBlock));
        }
        function visitWithStatement(node) {
          return ts2.updateWith(node, ts2.visitNode(node.expression, destructuringAndImportCallVisitor, ts2.isExpression), ts2.visitNode(node.statement, nestedElementVisitor, ts2.isStatement, ts2.liftToBlock));
        }
        function visitSwitchStatement(node) {
          return ts2.updateSwitch(node, ts2.visitNode(node.expression, destructuringAndImportCallVisitor, ts2.isExpression), ts2.visitNode(node.caseBlock, nestedElementVisitor, ts2.isCaseBlock));
        }
        function visitCaseBlock(node) {
          var savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
          enclosingBlockScopedContainer = node;
          node = ts2.updateCaseBlock(node, ts2.visitNodes(node.clauses, nestedElementVisitor, ts2.isCaseOrDefaultClause));
          enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
          return node;
        }
        function visitCaseClause(node) {
          return ts2.updateCaseClause(node, ts2.visitNode(node.expression, destructuringAndImportCallVisitor, ts2.isExpression), ts2.visitNodes(node.statements, nestedElementVisitor, ts2.isStatement));
        }
        function visitDefaultClause(node) {
          return ts2.visitEachChild(node, nestedElementVisitor, context);
        }
        function visitTryStatement(node) {
          return ts2.visitEachChild(node, nestedElementVisitor, context);
        }
        function visitCatchClause(node) {
          var savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
          enclosingBlockScopedContainer = node;
          node = ts2.updateCatchClause(node, node.variableDeclaration, ts2.visitNode(node.block, nestedElementVisitor, ts2.isBlock));
          enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
          return node;
        }
        function visitBlock(node) {
          var savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
          enclosingBlockScopedContainer = node;
          node = ts2.visitEachChild(node, nestedElementVisitor, context);
          enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
          return node;
        }
        function destructuringAndImportCallVisitor(node) {
          if (ts2.isDestructuringAssignment(node)) {
            return visitDestructuringAssignment(node);
          } else if (ts2.isImportCall(node)) {
            return visitImportCallExpression(node);
          } else if (node.transformFlags & 1024 || node.transformFlags & 2097152) {
            return ts2.visitEachChild(node, destructuringAndImportCallVisitor, context);
          } else {
            return node;
          }
        }
        function visitImportCallExpression(node) {
          return ts2.createCall(ts2.createPropertyAccess(contextObject, ts2.createIdentifier("import")), void 0, ts2.some(node.arguments) ? [ts2.visitNode(node.arguments[0], destructuringAndImportCallVisitor)] : []);
        }
        function visitDestructuringAssignment(node) {
          if (hasExportedReferenceInDestructuringTarget(node.left)) {
            return ts2.flattenDestructuringAssignment(node, destructuringAndImportCallVisitor, context, 0, true);
          }
          return ts2.visitEachChild(node, destructuringAndImportCallVisitor, context);
        }
        function hasExportedReferenceInDestructuringTarget(node) {
          if (ts2.isAssignmentExpression(node, true)) {
            return hasExportedReferenceInDestructuringTarget(node.left);
          } else if (ts2.isSpreadElement(node)) {
            return hasExportedReferenceInDestructuringTarget(node.expression);
          } else if (ts2.isObjectLiteralExpression(node)) {
            return ts2.some(node.properties, hasExportedReferenceInDestructuringTarget);
          } else if (ts2.isArrayLiteralExpression(node)) {
            return ts2.some(node.elements, hasExportedReferenceInDestructuringTarget);
          } else if (ts2.isShorthandPropertyAssignment(node)) {
            return hasExportedReferenceInDestructuringTarget(node.name);
          } else if (ts2.isPropertyAssignment(node)) {
            return hasExportedReferenceInDestructuringTarget(node.initializer);
          } else if (ts2.isIdentifier(node)) {
            var container = resolver.getReferencedExportContainer(node);
            return container !== void 0 && container.kind === 290;
          } else {
            return false;
          }
        }
        function modifierVisitor(node) {
          switch (node.kind) {
            case 89:
            case 84:
              return void 0;
          }
          return node;
        }
        function onEmitNode(hint, node, emitCallback) {
          if (node.kind === 290) {
            var id = ts2.getOriginalNodeId(node);
            currentSourceFile = node;
            moduleInfo = moduleInfoMap[id];
            exportFunction = exportFunctionsMap[id];
            noSubstitution = noSubstitutionMap[id];
            contextObject = contextObjectMap[id];
            if (noSubstitution) {
              delete noSubstitutionMap[id];
            }
            previousOnEmitNode(hint, node, emitCallback);
            currentSourceFile = void 0;
            moduleInfo = void 0;
            exportFunction = void 0;
            contextObject = void 0;
            noSubstitution = void 0;
          } else {
            previousOnEmitNode(hint, node, emitCallback);
          }
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (isSubstitutionPrevented(node)) {
            return node;
          }
          if (hint === 1) {
            return substituteExpression(node);
          } else if (hint === 4) {
            return substituteUnspecified(node);
          }
          return node;
        }
        function substituteUnspecified(node) {
          switch (node.kind) {
            case 282:
              return substituteShorthandPropertyAssignment(node);
          }
          return node;
        }
        function substituteShorthandPropertyAssignment(node) {
          var name = node.name;
          if (!ts2.isGeneratedIdentifier(name) && !ts2.isLocalName(name)) {
            var importDeclaration = resolver.getReferencedImportDeclaration(name);
            if (importDeclaration) {
              if (ts2.isImportClause(importDeclaration)) {
                return ts2.setTextRange(ts2.createPropertyAssignment(ts2.getSynthesizedClone(name), ts2.createPropertyAccess(ts2.getGeneratedNameForNode(importDeclaration.parent), ts2.createIdentifier("default"))), node);
              } else if (ts2.isImportSpecifier(importDeclaration)) {
                return ts2.setTextRange(ts2.createPropertyAssignment(ts2.getSynthesizedClone(name), ts2.createPropertyAccess(ts2.getGeneratedNameForNode(importDeclaration.parent.parent.parent), ts2.getSynthesizedClone(importDeclaration.propertyName || importDeclaration.name))), node);
              }
            }
          }
          return node;
        }
        function substituteExpression(node) {
          switch (node.kind) {
            case 75:
              return substituteExpressionIdentifier(node);
            case 209:
              return substituteBinaryExpression(node);
            case 207:
            case 208:
              return substituteUnaryExpression(node);
            case 219:
              return substituteMetaProperty(node);
          }
          return node;
        }
        function substituteExpressionIdentifier(node) {
          if (ts2.getEmitFlags(node) & 4096) {
            var externalHelpersModuleName = ts2.getExternalHelpersModuleName(currentSourceFile);
            if (externalHelpersModuleName) {
              return ts2.createPropertyAccess(externalHelpersModuleName, node);
            }
            return node;
          }
          if (!ts2.isGeneratedIdentifier(node) && !ts2.isLocalName(node)) {
            var importDeclaration = resolver.getReferencedImportDeclaration(node);
            if (importDeclaration) {
              if (ts2.isImportClause(importDeclaration)) {
                return ts2.setTextRange(ts2.createPropertyAccess(ts2.getGeneratedNameForNode(importDeclaration.parent), ts2.createIdentifier("default")), node);
              } else if (ts2.isImportSpecifier(importDeclaration)) {
                return ts2.setTextRange(ts2.createPropertyAccess(ts2.getGeneratedNameForNode(importDeclaration.parent.parent.parent), ts2.getSynthesizedClone(importDeclaration.propertyName || importDeclaration.name)), node);
              }
            }
          }
          return node;
        }
        function substituteBinaryExpression(node) {
          if (ts2.isAssignmentOperator(node.operatorToken.kind) && ts2.isIdentifier(node.left) && !ts2.isGeneratedIdentifier(node.left) && !ts2.isLocalName(node.left) && !ts2.isDeclarationNameOfEnumOrNamespace(node.left)) {
            var exportedNames = getExports(node.left);
            if (exportedNames) {
              var expression = node;
              for (var _i = 0, exportedNames_4 = exportedNames; _i < exportedNames_4.length; _i++) {
                var exportName = exportedNames_4[_i];
                expression = createExportExpression(exportName, preventSubstitution(expression));
              }
              return expression;
            }
          }
          return node;
        }
        function substituteUnaryExpression(node) {
          if ((node.operator === 45 || node.operator === 46) && ts2.isIdentifier(node.operand) && !ts2.isGeneratedIdentifier(node.operand) && !ts2.isLocalName(node.operand) && !ts2.isDeclarationNameOfEnumOrNamespace(node.operand)) {
            var exportedNames = getExports(node.operand);
            if (exportedNames) {
              var expression = node.kind === 208 ? ts2.setTextRange(ts2.createPrefix(node.operator, node.operand), node) : node;
              for (var _i = 0, exportedNames_5 = exportedNames; _i < exportedNames_5.length; _i++) {
                var exportName = exportedNames_5[_i];
                expression = createExportExpression(exportName, preventSubstitution(expression));
              }
              if (node.kind === 208) {
                expression = node.operator === 45 ? ts2.createSubtract(preventSubstitution(expression), ts2.createLiteral(1)) : ts2.createAdd(preventSubstitution(expression), ts2.createLiteral(1));
              }
              return expression;
            }
          }
          return node;
        }
        function substituteMetaProperty(node) {
          if (ts2.isImportMeta(node)) {
            return ts2.createPropertyAccess(contextObject, ts2.createIdentifier("meta"));
          }
          return node;
        }
        function getExports(name) {
          var exportedNames;
          if (!ts2.isGeneratedIdentifier(name)) {
            var valueDeclaration = resolver.getReferencedImportDeclaration(name) || resolver.getReferencedValueDeclaration(name);
            if (valueDeclaration) {
              var exportContainer = resolver.getReferencedExportContainer(name, false);
              if (exportContainer && exportContainer.kind === 290) {
                exportedNames = ts2.append(exportedNames, ts2.getDeclarationName(valueDeclaration));
              }
              exportedNames = ts2.addRange(exportedNames, moduleInfo && moduleInfo.exportedBindings[ts2.getOriginalNodeId(valueDeclaration)]);
            }
          }
          return exportedNames;
        }
        function preventSubstitution(node) {
          if (noSubstitution === void 0)
            noSubstitution = [];
          noSubstitution[ts2.getNodeId(node)] = true;
          return node;
        }
        function isSubstitutionPrevented(node) {
          return noSubstitution && node.id && noSubstitution[node.id];
        }
      }
      ts2.transformSystemModule = transformSystemModule;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function transformECMAScriptModule(context) {
        var compilerOptions = context.getCompilerOptions();
        var previousOnEmitNode = context.onEmitNode;
        var previousOnSubstituteNode = context.onSubstituteNode;
        context.onEmitNode = onEmitNode;
        context.onSubstituteNode = onSubstituteNode;
        context.enableEmitNotification(290);
        context.enableSubstitution(75);
        var helperNameSubstitutions;
        return ts2.chainBundle(transformSourceFile);
        function transformSourceFile(node) {
          if (node.isDeclarationFile) {
            return node;
          }
          if (ts2.isExternalModule(node) || compilerOptions.isolatedModules) {
            var externalHelpersImportDeclaration = ts2.createExternalHelpersImportDeclarationIfNeeded(node, compilerOptions);
            if (externalHelpersImportDeclaration) {
              var statements = [];
              var statementOffset = ts2.addPrologue(statements, node.statements);
              ts2.append(statements, externalHelpersImportDeclaration);
              ts2.addRange(statements, ts2.visitNodes(node.statements, visitor, ts2.isStatement, statementOffset));
              return ts2.updateSourceFileNode(node, ts2.setTextRange(ts2.createNodeArray(statements), node.statements));
            } else {
              return ts2.visitEachChild(node, visitor, context);
            }
          }
          return node;
        }
        function visitor(node) {
          switch (node.kind) {
            case 253:
              return void 0;
            case 259:
              return visitExportAssignment(node);
            case 260:
              var exportDecl = node;
              return visitExportDeclaration(exportDecl);
          }
          return node;
        }
        function visitExportAssignment(node) {
          return node.isExportEquals ? void 0 : node;
        }
        function visitExportDeclaration(node) {
          if (compilerOptions.module !== void 0 && compilerOptions.module > ts2.ModuleKind.ES2015) {
            return node;
          }
          if (!node.exportClause || !ts2.isNamespaceExport(node.exportClause) || !node.moduleSpecifier) {
            return node;
          }
          var oldIdentifier = node.exportClause.name;
          var synthName = ts2.getGeneratedNameForNode(oldIdentifier);
          var importDecl = ts2.createImportDeclaration(void 0, void 0, ts2.createImportClause(void 0, ts2.createNamespaceImport(synthName)), node.moduleSpecifier);
          ts2.setOriginalNode(importDecl, node.exportClause);
          var exportDecl = ts2.createExportDeclaration(void 0, void 0, ts2.createNamedExports([ts2.createExportSpecifier(synthName, oldIdentifier)]));
          ts2.setOriginalNode(exportDecl, node);
          return [importDecl, exportDecl];
        }
        function onEmitNode(hint, node, emitCallback) {
          if (ts2.isSourceFile(node)) {
            if ((ts2.isExternalModule(node) || compilerOptions.isolatedModules) && compilerOptions.importHelpers) {
              helperNameSubstitutions = ts2.createMap();
            }
            previousOnEmitNode(hint, node, emitCallback);
            helperNameSubstitutions = void 0;
          } else {
            previousOnEmitNode(hint, node, emitCallback);
          }
        }
        function onSubstituteNode(hint, node) {
          node = previousOnSubstituteNode(hint, node);
          if (helperNameSubstitutions && ts2.isIdentifier(node) && ts2.getEmitFlags(node) & 4096) {
            return substituteHelperName(node);
          }
          return node;
        }
        function substituteHelperName(node) {
          var name = ts2.idText(node);
          var substitution = helperNameSubstitutions.get(name);
          if (!substitution) {
            helperNameSubstitutions.set(name, substitution = ts2.createFileLevelUniqueName(name));
          }
          return substitution;
        }
      }
      ts2.transformECMAScriptModule = transformECMAScriptModule;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function canProduceDiagnostics(node) {
        return ts2.isVariableDeclaration(node) || ts2.isPropertyDeclaration(node) || ts2.isPropertySignature(node) || ts2.isBindingElement(node) || ts2.isSetAccessor(node) || ts2.isGetAccessor(node) || ts2.isConstructSignatureDeclaration(node) || ts2.isCallSignatureDeclaration(node) || ts2.isMethodDeclaration(node) || ts2.isMethodSignature(node) || ts2.isFunctionDeclaration(node) || ts2.isParameter(node) || ts2.isTypeParameterDeclaration(node) || ts2.isExpressionWithTypeArguments(node) || ts2.isImportEqualsDeclaration(node) || ts2.isTypeAliasDeclaration(node) || ts2.isConstructorDeclaration(node) || ts2.isIndexSignatureDeclaration(node) || ts2.isPropertyAccessExpression(node);
      }
      ts2.canProduceDiagnostics = canProduceDiagnostics;
      function createGetSymbolAccessibilityDiagnosticForNodeName(node) {
        if (ts2.isSetAccessor(node) || ts2.isGetAccessor(node)) {
          return getAccessorNameVisibilityError;
        } else if (ts2.isMethodSignature(node) || ts2.isMethodDeclaration(node)) {
          return getMethodNameVisibilityError;
        } else {
          return createGetSymbolAccessibilityDiagnosticForNode(node);
        }
        function getAccessorNameVisibilityError(symbolAccessibilityResult) {
          var diagnosticMessage = getAccessorNameVisibilityDiagnosticMessage(symbolAccessibilityResult);
          return diagnosticMessage !== void 0 ? {
            diagnosticMessage,
            errorNode: node,
            typeName: node.name
          } : void 0;
        }
        function getAccessorNameVisibilityDiagnosticMessage(symbolAccessibilityResult) {
          if (ts2.hasModifier(node, 32)) {
            return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts2.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts2.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_private_name_1;
          } else if (node.parent.kind === 245) {
            return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts2.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts2.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_private_name_1;
          } else {
            return symbolAccessibilityResult.errorModuleName ? ts2.Diagnostics.Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Property_0_of_exported_interface_has_or_is_using_private_name_1;
          }
        }
        function getMethodNameVisibilityError(symbolAccessibilityResult) {
          var diagnosticMessage = getMethodNameVisibilityDiagnosticMessage(symbolAccessibilityResult);
          return diagnosticMessage !== void 0 ? {
            diagnosticMessage,
            errorNode: node,
            typeName: node.name
          } : void 0;
        }
        function getMethodNameVisibilityDiagnosticMessage(symbolAccessibilityResult) {
          if (ts2.hasModifier(node, 32)) {
            return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts2.Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts2.Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_private_name_1;
          } else if (node.parent.kind === 245) {
            return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts2.Diagnostics.Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts2.Diagnostics.Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Public_method_0_of_exported_class_has_or_is_using_private_name_1;
          } else {
            return symbolAccessibilityResult.errorModuleName ? ts2.Diagnostics.Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Method_0_of_exported_interface_has_or_is_using_private_name_1;
          }
        }
      }
      ts2.createGetSymbolAccessibilityDiagnosticForNodeName = createGetSymbolAccessibilityDiagnosticForNodeName;
      function createGetSymbolAccessibilityDiagnosticForNode(node) {
        if (ts2.isVariableDeclaration(node) || ts2.isPropertyDeclaration(node) || ts2.isPropertySignature(node) || ts2.isPropertyAccessExpression(node) || ts2.isBindingElement(node) || ts2.isConstructorDeclaration(node)) {
          return getVariableDeclarationTypeVisibilityError;
        } else if (ts2.isSetAccessor(node) || ts2.isGetAccessor(node)) {
          return getAccessorDeclarationTypeVisibilityError;
        } else if (ts2.isConstructSignatureDeclaration(node) || ts2.isCallSignatureDeclaration(node) || ts2.isMethodDeclaration(node) || ts2.isMethodSignature(node) || ts2.isFunctionDeclaration(node) || ts2.isIndexSignatureDeclaration(node)) {
          return getReturnTypeVisibilityError;
        } else if (ts2.isParameter(node)) {
          if (ts2.isParameterPropertyDeclaration(node, node.parent) && ts2.hasModifier(node.parent, 8)) {
            return getVariableDeclarationTypeVisibilityError;
          }
          return getParameterDeclarationTypeVisibilityError;
        } else if (ts2.isTypeParameterDeclaration(node)) {
          return getTypeParameterConstraintVisibilityError;
        } else if (ts2.isExpressionWithTypeArguments(node)) {
          return getHeritageClauseVisibilityError;
        } else if (ts2.isImportEqualsDeclaration(node)) {
          return getImportEntityNameVisibilityError;
        } else if (ts2.isTypeAliasDeclaration(node)) {
          return getTypeAliasDeclarationVisibilityError;
        } else {
          return ts2.Debug.assertNever(node, "Attempted to set a declaration diagnostic context for unhandled node kind: " + ts2.SyntaxKind[node.kind]);
        }
        function getVariableDeclarationTypeVisibilityDiagnosticMessage(symbolAccessibilityResult) {
          if (node.kind === 242 || node.kind === 191) {
            return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts2.Diagnostics.Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts2.Diagnostics.Exported_variable_0_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Exported_variable_0_has_or_is_using_private_name_1;
          } else if (node.kind === 159 || node.kind === 194 || node.kind === 158 || node.kind === 156 && ts2.hasModifier(node.parent, 8)) {
            if (ts2.hasModifier(node, 32)) {
              return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts2.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts2.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_private_name_1;
            } else if (node.parent.kind === 245 || node.kind === 156) {
              return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts2.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts2.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_private_name_1;
            } else {
              return symbolAccessibilityResult.errorModuleName ? ts2.Diagnostics.Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Property_0_of_exported_interface_has_or_is_using_private_name_1;
            }
          }
        }
        function getVariableDeclarationTypeVisibilityError(symbolAccessibilityResult) {
          var diagnosticMessage = getVariableDeclarationTypeVisibilityDiagnosticMessage(symbolAccessibilityResult);
          return diagnosticMessage !== void 0 ? {
            diagnosticMessage,
            errorNode: node,
            typeName: node.name
          } : void 0;
        }
        function getAccessorDeclarationTypeVisibilityError(symbolAccessibilityResult) {
          var diagnosticMessage;
          if (node.kind === 164) {
            if (ts2.hasModifier(node, 32)) {
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? ts2.Diagnostics.Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1;
            } else {
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? ts2.Diagnostics.Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1;
            }
          } else {
            if (ts2.hasModifier(node, 32)) {
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts2.Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts2.Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1;
            } else {
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts2.Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts2.Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1;
            }
          }
          return {
            diagnosticMessage,
            errorNode: node.name,
            typeName: node.name
          };
        }
        function getReturnTypeVisibilityError(symbolAccessibilityResult) {
          var diagnosticMessage;
          switch (node.kind) {
            case 166:
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? ts2.Diagnostics.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : ts2.Diagnostics.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0;
              break;
            case 165:
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? ts2.Diagnostics.Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : ts2.Diagnostics.Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0;
              break;
            case 167:
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? ts2.Diagnostics.Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : ts2.Diagnostics.Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0;
              break;
            case 161:
            case 160:
              if (ts2.hasModifier(node, 32)) {
                diagnosticMessage = symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts2.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named : ts2.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1 : ts2.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0;
              } else if (node.parent.kind === 245) {
                diagnosticMessage = symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts2.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named : ts2.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1 : ts2.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0;
              } else {
                diagnosticMessage = symbolAccessibilityResult.errorModuleName ? ts2.Diagnostics.Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : ts2.Diagnostics.Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0;
              }
              break;
            case 244:
              diagnosticMessage = symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts2.Diagnostics.Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named : ts2.Diagnostics.Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1 : ts2.Diagnostics.Return_type_of_exported_function_has_or_is_using_private_name_0;
              break;
            default:
              return ts2.Debug.fail("This is unknown kind for signature: " + node.kind);
          }
          return {
            diagnosticMessage,
            errorNode: node.name || node
          };
        }
        function getParameterDeclarationTypeVisibilityError(symbolAccessibilityResult) {
          var diagnosticMessage = getParameterDeclarationTypeVisibilityDiagnosticMessage(symbolAccessibilityResult);
          return diagnosticMessage !== void 0 ? {
            diagnosticMessage,
            errorNode: node,
            typeName: node.name
          } : void 0;
        }
        function getParameterDeclarationTypeVisibilityDiagnosticMessage(symbolAccessibilityResult) {
          switch (node.parent.kind) {
            case 162:
              return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts2.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts2.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1;
            case 166:
            case 171:
              return symbolAccessibilityResult.errorModuleName ? ts2.Diagnostics.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;
            case 165:
              return symbolAccessibilityResult.errorModuleName ? ts2.Diagnostics.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;
            case 167:
              return symbolAccessibilityResult.errorModuleName ? ts2.Diagnostics.Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1;
            case 161:
            case 160:
              if (ts2.hasModifier(node.parent, 32)) {
                return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts2.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts2.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1;
              } else if (node.parent.parent.kind === 245) {
                return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts2.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts2.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1;
              } else {
                return symbolAccessibilityResult.errorModuleName ? ts2.Diagnostics.Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;
              }
            case 244:
            case 170:
              return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts2.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts2.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_private_name_1;
            case 164:
            case 163:
              return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 ? ts2.Diagnostics.Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : ts2.Diagnostics.Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2 : ts2.Diagnostics.Parameter_0_of_accessor_has_or_is_using_private_name_1;
            default:
              return ts2.Debug.fail("Unknown parent for parameter: " + ts2.SyntaxKind[node.parent.kind]);
          }
        }
        function getTypeParameterConstraintVisibilityError() {
          var diagnosticMessage;
          switch (node.parent.kind) {
            case 245:
              diagnosticMessage = ts2.Diagnostics.Type_parameter_0_of_exported_class_has_or_is_using_private_name_1;
              break;
            case 246:
              diagnosticMessage = ts2.Diagnostics.Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1;
              break;
            case 186:
              diagnosticMessage = ts2.Diagnostics.Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1;
              break;
            case 171:
            case 166:
              diagnosticMessage = ts2.Diagnostics.Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;
              break;
            case 165:
              diagnosticMessage = ts2.Diagnostics.Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;
              break;
            case 161:
            case 160:
              if (ts2.hasModifier(node.parent, 32)) {
                diagnosticMessage = ts2.Diagnostics.Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1;
              } else if (node.parent.parent.kind === 245) {
                diagnosticMessage = ts2.Diagnostics.Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1;
              } else {
                diagnosticMessage = ts2.Diagnostics.Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;
              }
              break;
            case 170:
            case 244:
              diagnosticMessage = ts2.Diagnostics.Type_parameter_0_of_exported_function_has_or_is_using_private_name_1;
              break;
            case 247:
              diagnosticMessage = ts2.Diagnostics.Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1;
              break;
            default:
              return ts2.Debug.fail("This is unknown parent for type parameter: " + node.parent.kind);
          }
          return {
            diagnosticMessage,
            errorNode: node,
            typeName: node.name
          };
        }
        function getHeritageClauseVisibilityError() {
          var diagnosticMessage;
          if (node.parent.parent.kind === 245) {
            diagnosticMessage = ts2.isHeritageClause(node.parent) && node.parent.token === 113 ? ts2.Diagnostics.Implements_clause_of_exported_class_0_has_or_is_using_private_name_1 : ts2.Diagnostics.extends_clause_of_exported_class_0_has_or_is_using_private_name_1;
          } else {
            diagnosticMessage = ts2.Diagnostics.extends_clause_of_exported_interface_0_has_or_is_using_private_name_1;
          }
          return {
            diagnosticMessage,
            errorNode: node,
            typeName: ts2.getNameOfDeclaration(node.parent.parent)
          };
        }
        function getImportEntityNameVisibilityError() {
          return {
            diagnosticMessage: ts2.Diagnostics.Import_declaration_0_is_using_private_name_1,
            errorNode: node,
            typeName: node.name
          };
        }
        function getTypeAliasDeclarationVisibilityError() {
          return {
            diagnosticMessage: ts2.Diagnostics.Exported_type_alias_0_has_or_is_using_private_name_1,
            errorNode: node.type,
            typeName: node.name
          };
        }
      }
      ts2.createGetSymbolAccessibilityDiagnosticForNode = createGetSymbolAccessibilityDiagnosticForNode;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function getDeclarationDiagnostics(host, resolver, file) {
        if (file && ts2.isJsonSourceFile(file)) {
          return [];
        }
        var compilerOptions = host.getCompilerOptions();
        var result = ts2.transformNodes(resolver, host, compilerOptions, file ? [file] : ts2.filter(host.getSourceFiles(), ts2.isSourceFileNotJson), [transformDeclarations], false);
        return result.diagnostics;
      }
      ts2.getDeclarationDiagnostics = getDeclarationDiagnostics;
      function hasInternalAnnotation(range, currentSourceFile) {
        var comment = currentSourceFile.text.substring(range.pos, range.end);
        return ts2.stringContains(comment, "@internal");
      }
      function isInternalDeclaration(node, currentSourceFile) {
        var parseTreeNode = ts2.getParseTreeNode(node);
        if (parseTreeNode && parseTreeNode.kind === 156) {
          var paramIdx = parseTreeNode.parent.parameters.indexOf(parseTreeNode);
          var previousSibling = paramIdx > 0 ? parseTreeNode.parent.parameters[paramIdx - 1] : void 0;
          var text = currentSourceFile.text;
          var commentRanges = previousSibling ? ts2.concatenate(ts2.getTrailingCommentRanges(text, ts2.skipTrivia(text, previousSibling.end + 1, false, true)), ts2.getLeadingCommentRanges(text, node.pos)) : ts2.getTrailingCommentRanges(text, ts2.skipTrivia(text, node.pos, false, true));
          return commentRanges && commentRanges.length && hasInternalAnnotation(ts2.last(commentRanges), currentSourceFile);
        }
        var leadingCommentRanges = parseTreeNode && ts2.getLeadingCommentRangesOfNode(parseTreeNode, currentSourceFile);
        return !!ts2.forEach(leadingCommentRanges, function(range) {
          return hasInternalAnnotation(range, currentSourceFile);
        });
      }
      ts2.isInternalDeclaration = isInternalDeclaration;
      var declarationEmitNodeBuilderFlags = 1024 | 2048 | 4096 | 8 | 524288 | 4 | 1;
      function transformDeclarations(context) {
        var throwDiagnostic = function() {
          return ts2.Debug.fail("Diagnostic emitted without context");
        };
        var getSymbolAccessibilityDiagnostic = throwDiagnostic;
        var needsDeclare = true;
        var isBundledEmit = false;
        var resultHasExternalModuleIndicator = false;
        var needsScopeFixMarker = false;
        var resultHasScopeMarker = false;
        var enclosingDeclaration;
        var necessaryTypeReferences;
        var lateMarkedStatements;
        var lateStatementReplacementMap;
        var suppressNewDiagnosticContexts;
        var exportedModulesFromDeclarationEmit;
        var host = context.getEmitHost();
        var symbolTracker = {
          trackSymbol,
          reportInaccessibleThisError,
          reportInaccessibleUniqueSymbolError,
          reportCyclicStructureError,
          reportPrivateInBaseOfClassExpression,
          reportLikelyUnsafeImportRequiredError,
          moduleResolverHost: host,
          trackReferencedAmbientModule,
          trackExternalModuleSymbolOfImportTypeNode,
          reportNonlocalAugmentation
        };
        var errorNameNode;
        var currentSourceFile;
        var refs;
        var libs;
        var emittedImports;
        var resolver = context.getEmitResolver();
        var options = context.getCompilerOptions();
        var noResolve = options.noResolve, stripInternal = options.stripInternal;
        return transformRoot;
        function recordTypeReferenceDirectivesIfNecessary(typeReferenceDirectives) {
          if (!typeReferenceDirectives) {
            return;
          }
          necessaryTypeReferences = necessaryTypeReferences || ts2.createMap();
          for (var _i = 0, typeReferenceDirectives_2 = typeReferenceDirectives; _i < typeReferenceDirectives_2.length; _i++) {
            var ref = typeReferenceDirectives_2[_i];
            necessaryTypeReferences.set(ref, true);
          }
        }
        function trackReferencedAmbientModule(node, symbol) {
          var directives = resolver.getTypeReferenceDirectivesForSymbol(symbol, 67108863);
          if (ts2.length(directives)) {
            return recordTypeReferenceDirectivesIfNecessary(directives);
          }
          var container = ts2.getSourceFileOfNode(node);
          refs.set("" + ts2.getOriginalNodeId(container), container);
        }
        function handleSymbolAccessibilityError(symbolAccessibilityResult) {
          if (symbolAccessibilityResult.accessibility === 0) {
            if (symbolAccessibilityResult && symbolAccessibilityResult.aliasesToMakeVisible) {
              if (!lateMarkedStatements) {
                lateMarkedStatements = symbolAccessibilityResult.aliasesToMakeVisible;
              } else {
                for (var _i = 0, _a = symbolAccessibilityResult.aliasesToMakeVisible; _i < _a.length; _i++) {
                  var ref = _a[_i];
                  ts2.pushIfUnique(lateMarkedStatements, ref);
                }
              }
            }
          } else {
            var errorInfo = getSymbolAccessibilityDiagnostic(symbolAccessibilityResult);
            if (errorInfo) {
              if (errorInfo.typeName) {
                context.addDiagnostic(ts2.createDiagnosticForNode(symbolAccessibilityResult.errorNode || errorInfo.errorNode, errorInfo.diagnosticMessage, ts2.getTextOfNode(errorInfo.typeName), symbolAccessibilityResult.errorSymbolName, symbolAccessibilityResult.errorModuleName));
              } else {
                context.addDiagnostic(ts2.createDiagnosticForNode(symbolAccessibilityResult.errorNode || errorInfo.errorNode, errorInfo.diagnosticMessage, symbolAccessibilityResult.errorSymbolName, symbolAccessibilityResult.errorModuleName));
              }
            }
          }
        }
        function trackExternalModuleSymbolOfImportTypeNode(symbol) {
          if (!isBundledEmit) {
            (exportedModulesFromDeclarationEmit || (exportedModulesFromDeclarationEmit = [])).push(symbol);
          }
        }
        function trackSymbol(symbol, enclosingDeclaration2, meaning) {
          if (symbol.flags & 262144)
            return;
          handleSymbolAccessibilityError(resolver.isSymbolAccessible(symbol, enclosingDeclaration2, meaning, true));
          recordTypeReferenceDirectivesIfNecessary(resolver.getTypeReferenceDirectivesForSymbol(symbol, meaning));
        }
        function reportPrivateInBaseOfClassExpression(propertyName) {
          if (errorNameNode) {
            context.addDiagnostic(ts2.createDiagnosticForNode(errorNameNode, ts2.Diagnostics.Property_0_of_exported_class_expression_may_not_be_private_or_protected, propertyName));
          }
        }
        function reportInaccessibleUniqueSymbolError() {
          if (errorNameNode) {
            context.addDiagnostic(ts2.createDiagnosticForNode(errorNameNode, ts2.Diagnostics.The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary, ts2.declarationNameToString(errorNameNode), "unique symbol"));
          }
        }
        function reportCyclicStructureError() {
          if (errorNameNode) {
            context.addDiagnostic(ts2.createDiagnosticForNode(errorNameNode, ts2.Diagnostics.The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialized_A_type_annotation_is_necessary, ts2.declarationNameToString(errorNameNode)));
          }
        }
        function reportInaccessibleThisError() {
          if (errorNameNode) {
            context.addDiagnostic(ts2.createDiagnosticForNode(errorNameNode, ts2.Diagnostics.The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary, ts2.declarationNameToString(errorNameNode), "this"));
          }
        }
        function reportLikelyUnsafeImportRequiredError(specifier) {
          if (errorNameNode) {
            context.addDiagnostic(ts2.createDiagnosticForNode(errorNameNode, ts2.Diagnostics.The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_annotation_is_necessary, ts2.declarationNameToString(errorNameNode), specifier));
          }
        }
        function reportNonlocalAugmentation(containingFile, parentSymbol, symbol) {
          var primaryDeclaration = ts2.find(parentSymbol.declarations, function(d) {
            return ts2.getSourceFileOfNode(d) === containingFile;
          });
          var augmentingDeclarations = ts2.filter(symbol.declarations, function(d) {
            return ts2.getSourceFileOfNode(d) !== containingFile;
          });
          for (var _i = 0, augmentingDeclarations_1 = augmentingDeclarations; _i < augmentingDeclarations_1.length; _i++) {
            var augmentations = augmentingDeclarations_1[_i];
            context.addDiagnostic(ts2.addRelatedInfo(ts2.createDiagnosticForNode(augmentations, ts2.Diagnostics.Declaration_augments_declaration_in_another_file_This_cannot_be_serialized), ts2.createDiagnosticForNode(primaryDeclaration, ts2.Diagnostics.This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_file)));
          }
        }
        function transformDeclarationsForJS(sourceFile, bundled) {
          var oldDiag = getSymbolAccessibilityDiagnostic;
          getSymbolAccessibilityDiagnostic = function(s) {
            return {
              diagnosticMessage: s.errorModuleName ? ts2.Diagnostics.Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotation_may_unblock_declaration_emit : ts2.Diagnostics.Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_declaration_emit,
              errorNode: s.errorNode || sourceFile
            };
          };
          var result = resolver.getDeclarationStatementsForSourceFile(sourceFile, declarationEmitNodeBuilderFlags, symbolTracker, bundled);
          getSymbolAccessibilityDiagnostic = oldDiag;
          return result;
        }
        function transformRoot(node) {
          if (node.kind === 290 && node.isDeclarationFile) {
            return node;
          }
          if (node.kind === 291) {
            isBundledEmit = true;
            refs = ts2.createMap();
            libs = ts2.createMap();
            var hasNoDefaultLib_1 = false;
            var bundle = ts2.createBundle(ts2.map(node.sourceFiles, function(sourceFile) {
              if (sourceFile.isDeclarationFile)
                return void 0;
              hasNoDefaultLib_1 = hasNoDefaultLib_1 || sourceFile.hasNoDefaultLib;
              currentSourceFile = sourceFile;
              enclosingDeclaration = sourceFile;
              lateMarkedStatements = void 0;
              suppressNewDiagnosticContexts = false;
              lateStatementReplacementMap = ts2.createMap();
              getSymbolAccessibilityDiagnostic = throwDiagnostic;
              needsScopeFixMarker = false;
              resultHasScopeMarker = false;
              collectReferences(sourceFile, refs);
              collectLibs(sourceFile, libs);
              if (ts2.isExternalOrCommonJsModule(sourceFile) || ts2.isJsonSourceFile(sourceFile)) {
                resultHasExternalModuleIndicator = false;
                needsDeclare = false;
                var statements2 = ts2.isSourceFileJS(sourceFile) ? ts2.createNodeArray(transformDeclarationsForJS(sourceFile, true)) : ts2.visitNodes(sourceFile.statements, visitDeclarationStatements);
                var newFile = ts2.updateSourceFileNode(sourceFile, [ts2.createModuleDeclaration([], [ts2.createModifier(130)], ts2.createLiteral(ts2.getResolvedExternalModuleName(context.getEmitHost(), sourceFile)), ts2.createModuleBlock(ts2.setTextRange(ts2.createNodeArray(transformAndReplaceLatePaintedStatements(statements2)), sourceFile.statements)))], true, [], [], false, []);
                return newFile;
              }
              needsDeclare = true;
              var updated2 = ts2.isSourceFileJS(sourceFile) ? ts2.createNodeArray(transformDeclarationsForJS(sourceFile)) : ts2.visitNodes(sourceFile.statements, visitDeclarationStatements);
              return ts2.updateSourceFileNode(sourceFile, transformAndReplaceLatePaintedStatements(updated2), true, [], [], false, []);
            }), ts2.mapDefined(node.prepends, function(prepend) {
              if (prepend.kind === 293) {
                var sourceFile = ts2.createUnparsedSourceFile(prepend, "dts", stripInternal);
                hasNoDefaultLib_1 = hasNoDefaultLib_1 || !!sourceFile.hasNoDefaultLib;
                collectReferences(sourceFile, refs);
                recordTypeReferenceDirectivesIfNecessary(sourceFile.typeReferenceDirectives);
                collectLibs(sourceFile, libs);
                return sourceFile;
              }
              return prepend;
            }));
            bundle.syntheticFileReferences = [];
            bundle.syntheticTypeReferences = getFileReferencesForUsedTypeReferences();
            bundle.syntheticLibReferences = getLibReferences();
            bundle.hasNoDefaultLib = hasNoDefaultLib_1;
            var outputFilePath_1 = ts2.getDirectoryPath(ts2.normalizeSlashes(ts2.getOutputPathsFor(node, host, true).declarationFilePath));
            var referenceVisitor_1 = mapReferencesIntoArray(bundle.syntheticFileReferences, outputFilePath_1);
            refs.forEach(referenceVisitor_1);
            return bundle;
          }
          needsDeclare = true;
          needsScopeFixMarker = false;
          resultHasScopeMarker = false;
          enclosingDeclaration = node;
          currentSourceFile = node;
          getSymbolAccessibilityDiagnostic = throwDiagnostic;
          isBundledEmit = false;
          resultHasExternalModuleIndicator = false;
          suppressNewDiagnosticContexts = false;
          lateMarkedStatements = void 0;
          lateStatementReplacementMap = ts2.createMap();
          necessaryTypeReferences = void 0;
          refs = collectReferences(currentSourceFile, ts2.createMap());
          libs = collectLibs(currentSourceFile, ts2.createMap());
          var references = [];
          var outputFilePath = ts2.getDirectoryPath(ts2.normalizeSlashes(ts2.getOutputPathsFor(node, host, true).declarationFilePath));
          var referenceVisitor = mapReferencesIntoArray(references, outputFilePath);
          var combinedStatements;
          if (ts2.isSourceFileJS(currentSourceFile)) {
            combinedStatements = ts2.createNodeArray(transformDeclarationsForJS(node));
            refs.forEach(referenceVisitor);
            emittedImports = ts2.filter(combinedStatements, ts2.isAnyImportSyntax);
          } else {
            var statements = ts2.visitNodes(node.statements, visitDeclarationStatements);
            combinedStatements = ts2.setTextRange(ts2.createNodeArray(transformAndReplaceLatePaintedStatements(statements)), node.statements);
            refs.forEach(referenceVisitor);
            emittedImports = ts2.filter(combinedStatements, ts2.isAnyImportSyntax);
            if (ts2.isExternalModule(node) && (!resultHasExternalModuleIndicator || needsScopeFixMarker && !resultHasScopeMarker)) {
              combinedStatements = ts2.setTextRange(ts2.createNodeArray(__spreadArrays(combinedStatements, [ts2.createEmptyExports()])), combinedStatements);
            }
          }
          var updated = ts2.updateSourceFileNode(node, combinedStatements, true, references, getFileReferencesForUsedTypeReferences(), node.hasNoDefaultLib, getLibReferences());
          updated.exportedModulesFromDeclarationEmit = exportedModulesFromDeclarationEmit;
          return updated;
          function getLibReferences() {
            return ts2.map(ts2.arrayFrom(libs.keys()), function(lib) {
              return { fileName: lib, pos: -1, end: -1 };
            });
          }
          function getFileReferencesForUsedTypeReferences() {
            return necessaryTypeReferences ? ts2.mapDefined(ts2.arrayFrom(necessaryTypeReferences.keys()), getFileReferenceForTypeName) : [];
          }
          function getFileReferenceForTypeName(typeName) {
            if (emittedImports) {
              for (var _i = 0, emittedImports_1 = emittedImports; _i < emittedImports_1.length; _i++) {
                var importStatement = emittedImports_1[_i];
                if (ts2.isImportEqualsDeclaration(importStatement) && ts2.isExternalModuleReference(importStatement.moduleReference)) {
                  var expr = importStatement.moduleReference.expression;
                  if (ts2.isStringLiteralLike(expr) && expr.text === typeName) {
                    return void 0;
                  }
                } else if (ts2.isImportDeclaration(importStatement) && ts2.isStringLiteral(importStatement.moduleSpecifier) && importStatement.moduleSpecifier.text === typeName) {
                  return void 0;
                }
              }
            }
            return { fileName: typeName, pos: -1, end: -1 };
          }
          function mapReferencesIntoArray(references2, outputFilePath2) {
            return function(file) {
              var declFileName;
              if (file.isDeclarationFile) {
                declFileName = file.fileName;
              } else {
                if (isBundledEmit && ts2.contains(node.sourceFiles, file))
                  return;
                var paths = ts2.getOutputPathsFor(file, host, true);
                declFileName = paths.declarationFilePath || paths.jsFilePath || file.fileName;
              }
              if (declFileName) {
                var specifier = ts2.moduleSpecifiers.getModuleSpecifier(__assign(__assign({}, options), { baseUrl: options.baseUrl && ts2.toPath(options.baseUrl, host.getCurrentDirectory(), host.getCanonicalFileName) }), currentSourceFile, ts2.toPath(outputFilePath2, host.getCurrentDirectory(), host.getCanonicalFileName), ts2.toPath(declFileName, host.getCurrentDirectory(), host.getCanonicalFileName), host, void 0);
                if (!ts2.pathIsRelative(specifier)) {
                  recordTypeReferenceDirectivesIfNecessary([specifier]);
                  return;
                }
                var fileName = ts2.getRelativePathToDirectoryOrUrl(outputFilePath2, declFileName, host.getCurrentDirectory(), host.getCanonicalFileName, false);
                if (ts2.startsWith(fileName, "./") && ts2.hasExtension(fileName)) {
                  fileName = fileName.substring(2);
                }
                if (ts2.startsWith(fileName, "node_modules/") || ts2.pathContainsNodeModules(fileName)) {
                  return;
                }
                references2.push({ pos: -1, end: -1, fileName });
              }
            };
          }
        }
        function collectReferences(sourceFile, ret) {
          if (noResolve || !ts2.isUnparsedSource(sourceFile) && ts2.isSourceFileJS(sourceFile))
            return ret;
          ts2.forEach(sourceFile.referencedFiles, function(f) {
            var elem = host.getSourceFileFromReference(sourceFile, f);
            if (elem) {
              ret.set("" + ts2.getOriginalNodeId(elem), elem);
            }
          });
          return ret;
        }
        function collectLibs(sourceFile, ret) {
          ts2.forEach(sourceFile.libReferenceDirectives, function(ref) {
            var lib = host.getLibFileFromReference(ref);
            if (lib) {
              ret.set(ts2.toFileNameLowerCase(ref.fileName), true);
            }
          });
          return ret;
        }
        function filterBindingPatternInitializers(name) {
          if (name.kind === 75) {
            return name;
          } else {
            if (name.kind === 190) {
              return ts2.updateArrayBindingPattern(name, ts2.visitNodes(name.elements, visitBindingElement));
            } else {
              return ts2.updateObjectBindingPattern(name, ts2.visitNodes(name.elements, visitBindingElement));
            }
          }
          function visitBindingElement(elem) {
            if (elem.kind === 215) {
              return elem;
            }
            return ts2.updateBindingElement(elem, elem.dotDotDotToken, elem.propertyName, filterBindingPatternInitializers(elem.name), shouldPrintWithInitializer(elem) ? elem.initializer : void 0);
          }
        }
        function ensureParameter(p, modifierMask, type) {
          var oldDiag;
          if (!suppressNewDiagnosticContexts) {
            oldDiag = getSymbolAccessibilityDiagnostic;
            getSymbolAccessibilityDiagnostic = ts2.createGetSymbolAccessibilityDiagnosticForNode(p);
          }
          var newParam = ts2.updateParameter(p, void 0, maskModifiers(p, modifierMask), p.dotDotDotToken, filterBindingPatternInitializers(p.name), resolver.isOptionalParameter(p) ? p.questionToken || ts2.createToken(57) : void 0, ensureType(p, type || p.type, true), ensureNoInitializer(p));
          if (!suppressNewDiagnosticContexts) {
            getSymbolAccessibilityDiagnostic = oldDiag;
          }
          return newParam;
        }
        function shouldPrintWithInitializer(node) {
          return canHaveLiteralInitializer(node) && resolver.isLiteralConstDeclaration(ts2.getParseTreeNode(node));
        }
        function ensureNoInitializer(node) {
          if (shouldPrintWithInitializer(node)) {
            return resolver.createLiteralConstValue(ts2.getParseTreeNode(node), symbolTracker);
          }
          return void 0;
        }
        function ensureType(node, type, ignorePrivate) {
          if (!ignorePrivate && ts2.hasModifier(node, 8)) {
            return;
          }
          if (shouldPrintWithInitializer(node)) {
            return;
          }
          var shouldUseResolverType = node.kind === 156 && (resolver.isRequiredInitializedParameter(node) || resolver.isOptionalUninitializedParameterProperty(node));
          if (type && !shouldUseResolverType) {
            return ts2.visitNode(type, visitDeclarationSubtree);
          }
          if (!ts2.getParseTreeNode(node)) {
            return type ? ts2.visitNode(type, visitDeclarationSubtree) : ts2.createKeywordTypeNode(125);
          }
          if (node.kind === 164) {
            return ts2.createKeywordTypeNode(125);
          }
          errorNameNode = node.name;
          var oldDiag;
          if (!suppressNewDiagnosticContexts) {
            oldDiag = getSymbolAccessibilityDiagnostic;
            getSymbolAccessibilityDiagnostic = ts2.createGetSymbolAccessibilityDiagnosticForNode(node);
          }
          if (node.kind === 242 || node.kind === 191) {
            return cleanup(resolver.createTypeOfDeclaration(node, enclosingDeclaration, declarationEmitNodeBuilderFlags, symbolTracker));
          }
          if (node.kind === 156 || node.kind === 159 || node.kind === 158) {
            if (!node.initializer)
              return cleanup(resolver.createTypeOfDeclaration(node, enclosingDeclaration, declarationEmitNodeBuilderFlags, symbolTracker, shouldUseResolverType));
            return cleanup(resolver.createTypeOfDeclaration(node, enclosingDeclaration, declarationEmitNodeBuilderFlags, symbolTracker, shouldUseResolverType) || resolver.createTypeOfExpression(node.initializer, enclosingDeclaration, declarationEmitNodeBuilderFlags, symbolTracker));
          }
          return cleanup(resolver.createReturnTypeOfSignatureDeclaration(node, enclosingDeclaration, declarationEmitNodeBuilderFlags, symbolTracker));
          function cleanup(returnValue) {
            errorNameNode = void 0;
            if (!suppressNewDiagnosticContexts) {
              getSymbolAccessibilityDiagnostic = oldDiag;
            }
            return returnValue || ts2.createKeywordTypeNode(125);
          }
        }
        function isDeclarationAndNotVisible(node) {
          node = ts2.getParseTreeNode(node);
          switch (node.kind) {
            case 244:
            case 249:
            case 246:
            case 245:
            case 247:
            case 248:
              return !resolver.isDeclarationVisible(node);
            case 242:
              return !getBindingNameVisible(node);
            case 253:
            case 254:
            case 260:
            case 259:
              return false;
          }
          return false;
        }
        function getBindingNameVisible(elem) {
          if (ts2.isOmittedExpression(elem)) {
            return false;
          }
          if (ts2.isBindingPattern(elem.name)) {
            return ts2.some(elem.name.elements, getBindingNameVisible);
          } else {
            return resolver.isDeclarationVisible(elem);
          }
        }
        function updateParamsList(node, params, modifierMask) {
          if (ts2.hasModifier(node, 8)) {
            return void 0;
          }
          var newParams = ts2.map(params, function(p) {
            return ensureParameter(p, modifierMask);
          });
          if (!newParams) {
            return void 0;
          }
          return ts2.createNodeArray(newParams, params.hasTrailingComma);
        }
        function updateAccessorParamsList(input, isPrivate) {
          var newParams;
          if (!isPrivate) {
            var thisParameter = ts2.getThisParameter(input);
            if (thisParameter) {
              newParams = [ensureParameter(thisParameter)];
            }
          }
          if (ts2.isSetAccessorDeclaration(input)) {
            var newValueParameter = void 0;
            if (!isPrivate) {
              var valueParameter = ts2.getSetAccessorValueParameter(input);
              if (valueParameter) {
                var accessorType = getTypeAnnotationFromAllAccessorDeclarations(input, resolver.getAllAccessorDeclarations(input));
                newValueParameter = ensureParameter(valueParameter, void 0, accessorType);
              }
            }
            if (!newValueParameter) {
              newValueParameter = ts2.createParameter(void 0, void 0, void 0, "value");
            }
            newParams = ts2.append(newParams, newValueParameter);
          }
          return ts2.createNodeArray(newParams || ts2.emptyArray);
        }
        function ensureTypeParams(node, params) {
          return ts2.hasModifier(node, 8) ? void 0 : ts2.visitNodes(params, visitDeclarationSubtree);
        }
        function isEnclosingDeclaration(node) {
          return ts2.isSourceFile(node) || ts2.isTypeAliasDeclaration(node) || ts2.isModuleDeclaration(node) || ts2.isClassDeclaration(node) || ts2.isInterfaceDeclaration(node) || ts2.isFunctionLike(node) || ts2.isIndexSignatureDeclaration(node) || ts2.isMappedTypeNode(node);
        }
        function checkEntityNameVisibility(entityName, enclosingDeclaration2) {
          var visibilityResult = resolver.isEntityNameVisible(entityName, enclosingDeclaration2);
          handleSymbolAccessibilityError(visibilityResult);
          recordTypeReferenceDirectivesIfNecessary(resolver.getTypeReferenceDirectivesForEntityName(entityName));
        }
        function preserveJsDoc(updated, original) {
          if (ts2.hasJSDocNodes(updated) && ts2.hasJSDocNodes(original)) {
            updated.jsDoc = original.jsDoc;
          }
          return ts2.setCommentRange(updated, ts2.getCommentRange(original));
        }
        function rewriteModuleSpecifier(parent, input) {
          if (!input)
            return void 0;
          resultHasExternalModuleIndicator = resultHasExternalModuleIndicator || parent.kind !== 249 && parent.kind !== 188;
          if (ts2.isStringLiteralLike(input)) {
            if (isBundledEmit) {
              var newName = ts2.getExternalModuleNameFromDeclaration(context.getEmitHost(), resolver, parent);
              if (newName) {
                return ts2.createLiteral(newName);
              }
            } else {
              var symbol = resolver.getSymbolOfExternalModuleSpecifier(input);
              if (symbol) {
                (exportedModulesFromDeclarationEmit || (exportedModulesFromDeclarationEmit = [])).push(symbol);
              }
            }
          }
          return input;
        }
        function transformImportEqualsDeclaration(decl) {
          if (!resolver.isDeclarationVisible(decl))
            return;
          if (decl.moduleReference.kind === 265) {
            var specifier = ts2.getExternalModuleImportEqualsDeclarationExpression(decl);
            return ts2.updateImportEqualsDeclaration(decl, void 0, decl.modifiers, decl.name, ts2.updateExternalModuleReference(decl.moduleReference, rewriteModuleSpecifier(decl, specifier)));
          } else {
            var oldDiag = getSymbolAccessibilityDiagnostic;
            getSymbolAccessibilityDiagnostic = ts2.createGetSymbolAccessibilityDiagnosticForNode(decl);
            checkEntityNameVisibility(decl.moduleReference, enclosingDeclaration);
            getSymbolAccessibilityDiagnostic = oldDiag;
            return decl;
          }
        }
        function transformImportDeclaration(decl) {
          if (!decl.importClause) {
            return ts2.updateImportDeclaration(decl, void 0, decl.modifiers, decl.importClause, rewriteModuleSpecifier(decl, decl.moduleSpecifier));
          }
          var visibleDefaultBinding = decl.importClause && decl.importClause.name && resolver.isDeclarationVisible(decl.importClause) ? decl.importClause.name : void 0;
          if (!decl.importClause.namedBindings) {
            return visibleDefaultBinding && ts2.updateImportDeclaration(decl, void 0, decl.modifiers, ts2.updateImportClause(decl.importClause, visibleDefaultBinding, void 0, decl.importClause.isTypeOnly), rewriteModuleSpecifier(decl, decl.moduleSpecifier));
          }
          if (decl.importClause.namedBindings.kind === 256) {
            var namedBindings = resolver.isDeclarationVisible(decl.importClause.namedBindings) ? decl.importClause.namedBindings : void 0;
            return visibleDefaultBinding || namedBindings ? ts2.updateImportDeclaration(decl, void 0, decl.modifiers, ts2.updateImportClause(decl.importClause, visibleDefaultBinding, namedBindings, decl.importClause.isTypeOnly), rewriteModuleSpecifier(decl, decl.moduleSpecifier)) : void 0;
          }
          var bindingList = ts2.mapDefined(decl.importClause.namedBindings.elements, function(b) {
            return resolver.isDeclarationVisible(b) ? b : void 0;
          });
          if (bindingList && bindingList.length || visibleDefaultBinding) {
            return ts2.updateImportDeclaration(decl, void 0, decl.modifiers, ts2.updateImportClause(decl.importClause, visibleDefaultBinding, bindingList && bindingList.length ? ts2.updateNamedImports(decl.importClause.namedBindings, bindingList) : void 0, decl.importClause.isTypeOnly), rewriteModuleSpecifier(decl, decl.moduleSpecifier));
          }
          if (resolver.isImportRequiredByAugmentation(decl)) {
            return ts2.updateImportDeclaration(decl, void 0, decl.modifiers, void 0, rewriteModuleSpecifier(decl, decl.moduleSpecifier));
          }
        }
        function transformAndReplaceLatePaintedStatements(statements) {
          while (ts2.length(lateMarkedStatements)) {
            var i = lateMarkedStatements.shift();
            if (!ts2.isLateVisibilityPaintedStatement(i)) {
              return ts2.Debug.fail("Late replaced statement was found which is not handled by the declaration transformer!: " + (ts2.SyntaxKind ? ts2.SyntaxKind[i.kind] : i.kind));
            }
            var priorNeedsDeclare = needsDeclare;
            needsDeclare = i.parent && ts2.isSourceFile(i.parent) && !(ts2.isExternalModule(i.parent) && isBundledEmit);
            var result = transformTopLevelDeclaration(i);
            needsDeclare = priorNeedsDeclare;
            lateStatementReplacementMap.set("" + ts2.getOriginalNodeId(i), result);
          }
          return ts2.visitNodes(statements, visitLateVisibilityMarkedStatements);
          function visitLateVisibilityMarkedStatements(statement) {
            if (ts2.isLateVisibilityPaintedStatement(statement)) {
              var key = "" + ts2.getOriginalNodeId(statement);
              if (lateStatementReplacementMap.has(key)) {
                var result2 = lateStatementReplacementMap.get(key);
                lateStatementReplacementMap.delete(key);
                if (result2) {
                  if (ts2.isArray(result2) ? ts2.some(result2, ts2.needsScopeMarker) : ts2.needsScopeMarker(result2)) {
                    needsScopeFixMarker = true;
                  }
                  if (ts2.isSourceFile(statement.parent) && (ts2.isArray(result2) ? ts2.some(result2, ts2.isExternalModuleIndicator) : ts2.isExternalModuleIndicator(result2))) {
                    resultHasExternalModuleIndicator = true;
                  }
                }
                return result2;
              }
            }
            return statement;
          }
        }
        function visitDeclarationSubtree(input) {
          if (shouldStripInternal(input))
            return;
          if (ts2.isDeclaration(input)) {
            if (isDeclarationAndNotVisible(input))
              return;
            if (ts2.hasDynamicName(input) && !resolver.isLateBound(ts2.getParseTreeNode(input))) {
              return;
            }
          }
          if (ts2.isFunctionLike(input) && resolver.isImplementationOfOverload(input))
            return;
          if (ts2.isSemicolonClassElement(input))
            return;
          var previousEnclosingDeclaration;
          if (isEnclosingDeclaration(input)) {
            previousEnclosingDeclaration = enclosingDeclaration;
            enclosingDeclaration = input;
          }
          var oldDiag = getSymbolAccessibilityDiagnostic;
          var canProduceDiagnostic = ts2.canProduceDiagnostics(input);
          var oldWithinObjectLiteralType = suppressNewDiagnosticContexts;
          var shouldEnterSuppressNewDiagnosticsContextContext = (input.kind === 173 || input.kind === 186) && input.parent.kind !== 247;
          if (ts2.isMethodDeclaration(input) || ts2.isMethodSignature(input)) {
            if (ts2.hasModifier(input, 8)) {
              if (input.symbol && input.symbol.declarations && input.symbol.declarations[0] !== input)
                return;
              return cleanup(ts2.createProperty(void 0, ensureModifiers(input), input.name, void 0, void 0, void 0));
            }
          }
          if (canProduceDiagnostic && !suppressNewDiagnosticContexts) {
            getSymbolAccessibilityDiagnostic = ts2.createGetSymbolAccessibilityDiagnosticForNode(input);
          }
          if (ts2.isTypeQueryNode(input)) {
            checkEntityNameVisibility(input.exprName, enclosingDeclaration);
          }
          if (shouldEnterSuppressNewDiagnosticsContextContext) {
            suppressNewDiagnosticContexts = true;
          }
          if (isProcessedComponent(input)) {
            switch (input.kind) {
              case 216: {
                if (ts2.isEntityName(input.expression) || ts2.isEntityNameExpression(input.expression)) {
                  checkEntityNameVisibility(input.expression, enclosingDeclaration);
                }
                var node = ts2.visitEachChild(input, visitDeclarationSubtree, context);
                return cleanup(ts2.updateExpressionWithTypeArguments(node, ts2.parenthesizeTypeParameters(node.typeArguments), node.expression));
              }
              case 169: {
                checkEntityNameVisibility(input.typeName, enclosingDeclaration);
                var node = ts2.visitEachChild(input, visitDeclarationSubtree, context);
                return cleanup(ts2.updateTypeReferenceNode(node, node.typeName, ts2.parenthesizeTypeParameters(node.typeArguments)));
              }
              case 166:
                return cleanup(ts2.updateConstructSignature(input, ensureTypeParams(input, input.typeParameters), updateParamsList(input, input.parameters), ensureType(input, input.type)));
              case 162: {
                var ctor = ts2.createSignatureDeclaration(162, ensureTypeParams(input, input.typeParameters), updateParamsList(input, input.parameters, 0), void 0);
                ctor.modifiers = ts2.createNodeArray(ensureModifiers(input));
                return cleanup(ctor);
              }
              case 161: {
                if (ts2.isPrivateIdentifier(input.name)) {
                  return cleanup(void 0);
                }
                var sig = ts2.createSignatureDeclaration(160, ensureTypeParams(input, input.typeParameters), updateParamsList(input, input.parameters), ensureType(input, input.type));
                sig.name = input.name;
                sig.modifiers = ts2.createNodeArray(ensureModifiers(input));
                sig.questionToken = input.questionToken;
                return cleanup(sig);
              }
              case 163: {
                if (ts2.isPrivateIdentifier(input.name)) {
                  return cleanup(void 0);
                }
                var accessorType = getTypeAnnotationFromAllAccessorDeclarations(input, resolver.getAllAccessorDeclarations(input));
                return cleanup(ts2.updateGetAccessor(input, void 0, ensureModifiers(input), input.name, updateAccessorParamsList(input, ts2.hasModifier(input, 8)), ensureType(input, accessorType), void 0));
              }
              case 164: {
                if (ts2.isPrivateIdentifier(input.name)) {
                  return cleanup(void 0);
                }
                return cleanup(ts2.updateSetAccessor(input, void 0, ensureModifiers(input), input.name, updateAccessorParamsList(input, ts2.hasModifier(input, 8)), void 0));
              }
              case 159:
                if (ts2.isPrivateIdentifier(input.name)) {
                  return cleanup(void 0);
                }
                return cleanup(ts2.updateProperty(input, void 0, ensureModifiers(input), input.name, input.questionToken, ensureType(input, input.type), ensureNoInitializer(input)));
              case 158:
                if (ts2.isPrivateIdentifier(input.name)) {
                  return cleanup(void 0);
                }
                return cleanup(ts2.updatePropertySignature(input, ensureModifiers(input), input.name, input.questionToken, ensureType(input, input.type), ensureNoInitializer(input)));
              case 160: {
                if (ts2.isPrivateIdentifier(input.name)) {
                  return cleanup(void 0);
                }
                return cleanup(ts2.updateMethodSignature(input, ensureTypeParams(input, input.typeParameters), updateParamsList(input, input.parameters), ensureType(input, input.type), input.name, input.questionToken));
              }
              case 165: {
                return cleanup(ts2.updateCallSignature(input, ensureTypeParams(input, input.typeParameters), updateParamsList(input, input.parameters), ensureType(input, input.type)));
              }
              case 167: {
                return cleanup(ts2.updateIndexSignature(input, void 0, ensureModifiers(input), updateParamsList(input, input.parameters), ts2.visitNode(input.type, visitDeclarationSubtree) || ts2.createKeywordTypeNode(125)));
              }
              case 242: {
                if (ts2.isBindingPattern(input.name)) {
                  return recreateBindingPattern(input.name);
                }
                shouldEnterSuppressNewDiagnosticsContextContext = true;
                suppressNewDiagnosticContexts = true;
                return cleanup(ts2.updateTypeScriptVariableDeclaration(input, input.name, void 0, ensureType(input, input.type), ensureNoInitializer(input)));
              }
              case 155: {
                if (isPrivateMethodTypeParameter(input) && (input.default || input.constraint)) {
                  return cleanup(ts2.updateTypeParameterDeclaration(input, input.name, void 0, void 0));
                }
                return cleanup(ts2.visitEachChild(input, visitDeclarationSubtree, context));
              }
              case 180: {
                var checkType = ts2.visitNode(input.checkType, visitDeclarationSubtree);
                var extendsType = ts2.visitNode(input.extendsType, visitDeclarationSubtree);
                var oldEnclosingDecl = enclosingDeclaration;
                enclosingDeclaration = input.trueType;
                var trueType = ts2.visitNode(input.trueType, visitDeclarationSubtree);
                enclosingDeclaration = oldEnclosingDecl;
                var falseType = ts2.visitNode(input.falseType, visitDeclarationSubtree);
                return cleanup(ts2.updateConditionalTypeNode(input, checkType, extendsType, trueType, falseType));
              }
              case 170: {
                return cleanup(ts2.updateFunctionTypeNode(input, ts2.visitNodes(input.typeParameters, visitDeclarationSubtree), updateParamsList(input, input.parameters), ts2.visitNode(input.type, visitDeclarationSubtree)));
              }
              case 171: {
                return cleanup(ts2.updateConstructorTypeNode(input, ts2.visitNodes(input.typeParameters, visitDeclarationSubtree), updateParamsList(input, input.parameters), ts2.visitNode(input.type, visitDeclarationSubtree)));
              }
              case 188: {
                if (!ts2.isLiteralImportTypeNode(input))
                  return cleanup(input);
                return cleanup(ts2.updateImportTypeNode(input, ts2.updateLiteralTypeNode(input.argument, rewriteModuleSpecifier(input, input.argument.literal)), input.qualifier, ts2.visitNodes(input.typeArguments, visitDeclarationSubtree, ts2.isTypeNode), input.isTypeOf));
              }
              default:
                ts2.Debug.assertNever(input, "Attempted to process unhandled node kind: " + ts2.SyntaxKind[input.kind]);
            }
          }
          return cleanup(ts2.visitEachChild(input, visitDeclarationSubtree, context));
          function cleanup(returnValue) {
            if (returnValue && canProduceDiagnostic && ts2.hasDynamicName(input)) {
              checkName(input);
            }
            if (isEnclosingDeclaration(input)) {
              enclosingDeclaration = previousEnclosingDeclaration;
            }
            if (canProduceDiagnostic && !suppressNewDiagnosticContexts) {
              getSymbolAccessibilityDiagnostic = oldDiag;
            }
            if (shouldEnterSuppressNewDiagnosticsContextContext) {
              suppressNewDiagnosticContexts = oldWithinObjectLiteralType;
            }
            if (returnValue === input) {
              return returnValue;
            }
            return returnValue && ts2.setOriginalNode(preserveJsDoc(returnValue, input), input);
          }
        }
        function isPrivateMethodTypeParameter(node) {
          return node.parent.kind === 161 && ts2.hasModifier(node.parent, 8);
        }
        function visitDeclarationStatements(input) {
          if (!isPreservedDeclarationStatement(input)) {
            return;
          }
          if (shouldStripInternal(input))
            return;
          switch (input.kind) {
            case 260: {
              if (ts2.isSourceFile(input.parent)) {
                resultHasExternalModuleIndicator = true;
              }
              resultHasScopeMarker = true;
              return ts2.updateExportDeclaration(input, void 0, input.modifiers, input.exportClause, rewriteModuleSpecifier(input, input.moduleSpecifier), input.isTypeOnly);
            }
            case 259: {
              if (ts2.isSourceFile(input.parent)) {
                resultHasExternalModuleIndicator = true;
              }
              resultHasScopeMarker = true;
              if (input.expression.kind === 75) {
                return input;
              } else {
                var newId = ts2.createOptimisticUniqueName("_default");
                getSymbolAccessibilityDiagnostic = function() {
                  return {
                    diagnosticMessage: ts2.Diagnostics.Default_export_of_the_module_has_or_is_using_private_name_0,
                    errorNode: input
                  };
                };
                var varDecl = ts2.createVariableDeclaration(newId, resolver.createTypeOfExpression(input.expression, input, declarationEmitNodeBuilderFlags, symbolTracker), void 0);
                var statement = ts2.createVariableStatement(needsDeclare ? [ts2.createModifier(130)] : [], ts2.createVariableDeclarationList([varDecl], 2));
                return [statement, ts2.updateExportAssignment(input, input.decorators, input.modifiers, newId)];
              }
            }
          }
          var result = transformTopLevelDeclaration(input);
          lateStatementReplacementMap.set("" + ts2.getOriginalNodeId(input), result);
          return input;
        }
        function stripExportModifiers(statement) {
          if (ts2.isImportEqualsDeclaration(statement) || ts2.hasModifier(statement, 512)) {
            return statement;
          }
          var clone = ts2.getMutableClone(statement);
          var modifiers = ts2.createModifiersFromModifierFlags(ts2.getModifierFlags(statement) & (3071 ^ 1));
          clone.modifiers = modifiers.length ? ts2.createNodeArray(modifiers) : void 0;
          return clone;
        }
        function transformTopLevelDeclaration(input) {
          if (shouldStripInternal(input))
            return;
          switch (input.kind) {
            case 253: {
              return transformImportEqualsDeclaration(input);
            }
            case 254: {
              return transformImportDeclaration(input);
            }
          }
          if (ts2.isDeclaration(input) && isDeclarationAndNotVisible(input))
            return;
          if (ts2.isFunctionLike(input) && resolver.isImplementationOfOverload(input))
            return;
          var previousEnclosingDeclaration;
          if (isEnclosingDeclaration(input)) {
            previousEnclosingDeclaration = enclosingDeclaration;
            enclosingDeclaration = input;
          }
          var canProdiceDiagnostic = ts2.canProduceDiagnostics(input);
          var oldDiag = getSymbolAccessibilityDiagnostic;
          if (canProdiceDiagnostic) {
            getSymbolAccessibilityDiagnostic = ts2.createGetSymbolAccessibilityDiagnosticForNode(input);
          }
          var previousNeedsDeclare = needsDeclare;
          switch (input.kind) {
            case 247:
              return cleanup(ts2.updateTypeAliasDeclaration(input, void 0, ensureModifiers(input), input.name, ts2.visitNodes(input.typeParameters, visitDeclarationSubtree, ts2.isTypeParameterDeclaration), ts2.visitNode(input.type, visitDeclarationSubtree, ts2.isTypeNode)));
            case 246: {
              return cleanup(ts2.updateInterfaceDeclaration(input, void 0, ensureModifiers(input), input.name, ensureTypeParams(input, input.typeParameters), transformHeritageClauses(input.heritageClauses), ts2.visitNodes(input.members, visitDeclarationSubtree)));
            }
            case 244: {
              var clean = cleanup(ts2.updateFunctionDeclaration(input, void 0, ensureModifiers(input), void 0, input.name, ensureTypeParams(input, input.typeParameters), updateParamsList(input, input.parameters), ensureType(input, input.type), void 0));
              if (clean && resolver.isExpandoFunctionDeclaration(input)) {
                var props = resolver.getPropertiesOfContainerFunction(input);
                var fakespace_1 = ts2.createModuleDeclaration(void 0, void 0, clean.name || ts2.createIdentifier("_default"), ts2.createModuleBlock([]), 16);
                fakespace_1.flags ^= 8;
                fakespace_1.parent = enclosingDeclaration;
                fakespace_1.locals = ts2.createSymbolTable(props);
                fakespace_1.symbol = props[0].parent;
                var declarations = ts2.mapDefined(props, function(p) {
                  if (!ts2.isPropertyAccessExpression(p.valueDeclaration)) {
                    return void 0;
                  }
                  getSymbolAccessibilityDiagnostic = ts2.createGetSymbolAccessibilityDiagnosticForNode(p.valueDeclaration);
                  var type = resolver.createTypeOfDeclaration(p.valueDeclaration, fakespace_1, declarationEmitNodeBuilderFlags, symbolTracker);
                  getSymbolAccessibilityDiagnostic = oldDiag;
                  var varDecl2 = ts2.createVariableDeclaration(ts2.unescapeLeadingUnderscores(p.escapedName), type, void 0);
                  return ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([varDecl2]));
                });
                var namespaceDecl = ts2.createModuleDeclaration(void 0, ensureModifiers(input), input.name, ts2.createModuleBlock(declarations), 16);
                if (!ts2.hasModifier(clean, 512)) {
                  return [clean, namespaceDecl];
                }
                var modifiers = ts2.createModifiersFromModifierFlags(ts2.getModifierFlags(clean) & ~513 | 2);
                var cleanDeclaration = ts2.updateFunctionDeclaration(clean, void 0, modifiers, void 0, clean.name, clean.typeParameters, clean.parameters, clean.type, void 0);
                var namespaceDeclaration = ts2.updateModuleDeclaration(namespaceDecl, void 0, modifiers, namespaceDecl.name, namespaceDecl.body);
                var exportDefaultDeclaration = ts2.createExportAssignment(void 0, void 0, false, namespaceDecl.name);
                if (ts2.isSourceFile(input.parent)) {
                  resultHasExternalModuleIndicator = true;
                }
                resultHasScopeMarker = true;
                return [cleanDeclaration, namespaceDeclaration, exportDefaultDeclaration];
              } else {
                return clean;
              }
            }
            case 249: {
              needsDeclare = false;
              var inner = input.body;
              if (inner && inner.kind === 250) {
                var oldNeedsScopeFix = needsScopeFixMarker;
                var oldHasScopeFix = resultHasScopeMarker;
                resultHasScopeMarker = false;
                needsScopeFixMarker = false;
                var statements = ts2.visitNodes(inner.statements, visitDeclarationStatements);
                var lateStatements = transformAndReplaceLatePaintedStatements(statements);
                if (input.flags & 8388608) {
                  needsScopeFixMarker = false;
                }
                if (!ts2.isGlobalScopeAugmentation(input) && !hasScopeMarker(lateStatements) && !resultHasScopeMarker) {
                  if (needsScopeFixMarker) {
                    lateStatements = ts2.createNodeArray(__spreadArrays(lateStatements, [ts2.createEmptyExports()]));
                  } else {
                    lateStatements = ts2.visitNodes(lateStatements, stripExportModifiers);
                  }
                }
                var body = ts2.updateModuleBlock(inner, lateStatements);
                needsDeclare = previousNeedsDeclare;
                needsScopeFixMarker = oldNeedsScopeFix;
                resultHasScopeMarker = oldHasScopeFix;
                var mods = ensureModifiers(input);
                return cleanup(ts2.updateModuleDeclaration(input, void 0, mods, ts2.isExternalModuleAugmentation(input) ? rewriteModuleSpecifier(input, input.name) : input.name, body));
              } else {
                needsDeclare = previousNeedsDeclare;
                var mods = ensureModifiers(input);
                needsDeclare = false;
                ts2.visitNode(inner, visitDeclarationStatements);
                var id = "" + ts2.getOriginalNodeId(inner);
                var body = lateStatementReplacementMap.get(id);
                lateStatementReplacementMap.delete(id);
                return cleanup(ts2.updateModuleDeclaration(input, void 0, mods, input.name, body));
              }
            }
            case 245: {
              var modifiers = ts2.createNodeArray(ensureModifiers(input));
              var typeParameters = ensureTypeParams(input, input.typeParameters);
              var ctor = ts2.getFirstConstructorWithBody(input);
              var parameterProperties = void 0;
              if (ctor) {
                var oldDiag_1 = getSymbolAccessibilityDiagnostic;
                parameterProperties = ts2.compact(ts2.flatMap(ctor.parameters, function(param) {
                  if (!ts2.hasModifier(param, 92) || shouldStripInternal(param))
                    return;
                  getSymbolAccessibilityDiagnostic = ts2.createGetSymbolAccessibilityDiagnosticForNode(param);
                  if (param.name.kind === 75) {
                    return preserveJsDoc(ts2.createProperty(void 0, ensureModifiers(param), param.name, param.questionToken, ensureType(param, param.type), ensureNoInitializer(param)), param);
                  } else {
                    return walkBindingPattern(param.name);
                  }
                  function walkBindingPattern(pattern) {
                    var elems;
                    for (var _i = 0, _a = pattern.elements; _i < _a.length; _i++) {
                      var elem = _a[_i];
                      if (ts2.isOmittedExpression(elem))
                        continue;
                      if (ts2.isBindingPattern(elem.name)) {
                        elems = ts2.concatenate(elems, walkBindingPattern(elem.name));
                      }
                      elems = elems || [];
                      elems.push(ts2.createProperty(void 0, ensureModifiers(param), elem.name, void 0, ensureType(elem, void 0), void 0));
                    }
                    return elems;
                  }
                }));
                getSymbolAccessibilityDiagnostic = oldDiag_1;
              }
              var hasPrivateIdentifier = ts2.some(input.members, function(member) {
                return !!member.name && ts2.isPrivateIdentifier(member.name);
              });
              var privateIdentifier = hasPrivateIdentifier ? [
                ts2.createProperty(void 0, void 0, ts2.createPrivateIdentifier("#private"), void 0, void 0, void 0)
              ] : void 0;
              var memberNodes = ts2.concatenate(ts2.concatenate(privateIdentifier, parameterProperties), ts2.visitNodes(input.members, visitDeclarationSubtree));
              var members = ts2.createNodeArray(memberNodes);
              var extendsClause_1 = ts2.getEffectiveBaseTypeNode(input);
              if (extendsClause_1 && !ts2.isEntityNameExpression(extendsClause_1.expression) && extendsClause_1.expression.kind !== 100) {
                var oldId = input.name ? ts2.unescapeLeadingUnderscores(input.name.escapedText) : "default";
                var newId_1 = ts2.createOptimisticUniqueName(oldId + "_base");
                getSymbolAccessibilityDiagnostic = function() {
                  return {
                    diagnosticMessage: ts2.Diagnostics.extends_clause_of_exported_class_0_has_or_is_using_private_name_1,
                    errorNode: extendsClause_1,
                    typeName: input.name
                  };
                };
                var varDecl = ts2.createVariableDeclaration(newId_1, resolver.createTypeOfExpression(extendsClause_1.expression, input, declarationEmitNodeBuilderFlags, symbolTracker), void 0);
                var statement = ts2.createVariableStatement(needsDeclare ? [ts2.createModifier(130)] : [], ts2.createVariableDeclarationList([varDecl], 2));
                var heritageClauses = ts2.createNodeArray(ts2.map(input.heritageClauses, function(clause) {
                  if (clause.token === 90) {
                    var oldDiag_2 = getSymbolAccessibilityDiagnostic;
                    getSymbolAccessibilityDiagnostic = ts2.createGetSymbolAccessibilityDiagnosticForNode(clause.types[0]);
                    var newClause = ts2.updateHeritageClause(clause, ts2.map(clause.types, function(t) {
                      return ts2.updateExpressionWithTypeArguments(t, ts2.visitNodes(t.typeArguments, visitDeclarationSubtree), newId_1);
                    }));
                    getSymbolAccessibilityDiagnostic = oldDiag_2;
                    return newClause;
                  }
                  return ts2.updateHeritageClause(clause, ts2.visitNodes(ts2.createNodeArray(ts2.filter(clause.types, function(t) {
                    return ts2.isEntityNameExpression(t.expression) || t.expression.kind === 100;
                  })), visitDeclarationSubtree));
                }));
                return [statement, cleanup(ts2.updateClassDeclaration(input, void 0, modifiers, input.name, typeParameters, heritageClauses, members))];
              } else {
                var heritageClauses = transformHeritageClauses(input.heritageClauses);
                return cleanup(ts2.updateClassDeclaration(input, void 0, modifiers, input.name, typeParameters, heritageClauses, members));
              }
            }
            case 225: {
              return cleanup(transformVariableStatement(input));
            }
            case 248: {
              return cleanup(ts2.updateEnumDeclaration(input, void 0, ts2.createNodeArray(ensureModifiers(input)), input.name, ts2.createNodeArray(ts2.mapDefined(input.members, function(m) {
                if (shouldStripInternal(m))
                  return;
                var constValue = resolver.getConstantValue(m);
                return preserveJsDoc(ts2.updateEnumMember(m, m.name, constValue !== void 0 ? ts2.createLiteral(constValue) : void 0), m);
              }))));
            }
          }
          return ts2.Debug.assertNever(input, "Unhandled top-level node in declaration emit: " + ts2.SyntaxKind[input.kind]);
          function cleanup(node) {
            if (isEnclosingDeclaration(input)) {
              enclosingDeclaration = previousEnclosingDeclaration;
            }
            if (canProdiceDiagnostic) {
              getSymbolAccessibilityDiagnostic = oldDiag;
            }
            if (input.kind === 249) {
              needsDeclare = previousNeedsDeclare;
            }
            if (node === input) {
              return node;
            }
            return node && ts2.setOriginalNode(preserveJsDoc(node, input), input);
          }
        }
        function transformVariableStatement(input) {
          if (!ts2.forEach(input.declarationList.declarations, getBindingNameVisible))
            return;
          var nodes = ts2.visitNodes(input.declarationList.declarations, visitDeclarationSubtree);
          if (!ts2.length(nodes))
            return;
          return ts2.updateVariableStatement(input, ts2.createNodeArray(ensureModifiers(input)), ts2.updateVariableDeclarationList(input.declarationList, nodes));
        }
        function recreateBindingPattern(d) {
          return ts2.flatten(ts2.mapDefined(d.elements, function(e) {
            return recreateBindingElement(e);
          }));
        }
        function recreateBindingElement(e) {
          if (e.kind === 215) {
            return;
          }
          if (e.name) {
            if (!getBindingNameVisible(e))
              return;
            if (ts2.isBindingPattern(e.name)) {
              return recreateBindingPattern(e.name);
            } else {
              return ts2.createVariableDeclaration(e.name, ensureType(e, void 0), void 0);
            }
          }
        }
        function checkName(node) {
          var oldDiag;
          if (!suppressNewDiagnosticContexts) {
            oldDiag = getSymbolAccessibilityDiagnostic;
            getSymbolAccessibilityDiagnostic = ts2.createGetSymbolAccessibilityDiagnosticForNodeName(node);
          }
          errorNameNode = node.name;
          ts2.Debug.assert(resolver.isLateBound(ts2.getParseTreeNode(node)));
          var decl = node;
          var entityName = decl.name.expression;
          checkEntityNameVisibility(entityName, enclosingDeclaration);
          if (!suppressNewDiagnosticContexts) {
            getSymbolAccessibilityDiagnostic = oldDiag;
          }
          errorNameNode = void 0;
        }
        function shouldStripInternal(node) {
          return !!stripInternal && !!node && isInternalDeclaration(node, currentSourceFile);
        }
        function isScopeMarker(node) {
          return ts2.isExportAssignment(node) || ts2.isExportDeclaration(node);
        }
        function hasScopeMarker(statements) {
          return ts2.some(statements, isScopeMarker);
        }
        function ensureModifiers(node) {
          var currentFlags = ts2.getModifierFlags(node);
          var newFlags = ensureModifierFlags(node);
          if (currentFlags === newFlags) {
            return node.modifiers;
          }
          return ts2.createModifiersFromModifierFlags(newFlags);
        }
        function ensureModifierFlags(node) {
          var mask = 3071 ^ (4 | 256);
          var additions = needsDeclare && !isAlwaysType(node) ? 2 : 0;
          var parentIsFile = node.parent.kind === 290;
          if (!parentIsFile || isBundledEmit && parentIsFile && ts2.isExternalModule(node.parent)) {
            mask ^= 2;
            additions = 0;
          }
          return maskModifierFlags(node, mask, additions);
        }
        function getTypeAnnotationFromAllAccessorDeclarations(node, accessors) {
          var accessorType = getTypeAnnotationFromAccessor(node);
          if (!accessorType && node !== accessors.firstAccessor) {
            accessorType = getTypeAnnotationFromAccessor(accessors.firstAccessor);
            getSymbolAccessibilityDiagnostic = ts2.createGetSymbolAccessibilityDiagnosticForNode(accessors.firstAccessor);
          }
          if (!accessorType && accessors.secondAccessor && node !== accessors.secondAccessor) {
            accessorType = getTypeAnnotationFromAccessor(accessors.secondAccessor);
            getSymbolAccessibilityDiagnostic = ts2.createGetSymbolAccessibilityDiagnosticForNode(accessors.secondAccessor);
          }
          return accessorType;
        }
        function transformHeritageClauses(nodes) {
          return ts2.createNodeArray(ts2.filter(ts2.map(nodes, function(clause) {
            return ts2.updateHeritageClause(clause, ts2.visitNodes(ts2.createNodeArray(ts2.filter(clause.types, function(t) {
              return ts2.isEntityNameExpression(t.expression) || clause.token === 90 && t.expression.kind === 100;
            })), visitDeclarationSubtree));
          }), function(clause) {
            return clause.types && !!clause.types.length;
          }));
        }
      }
      ts2.transformDeclarations = transformDeclarations;
      function isAlwaysType(node) {
        if (node.kind === 246) {
          return true;
        }
        return false;
      }
      function maskModifiers(node, modifierMask, modifierAdditions) {
        return ts2.createModifiersFromModifierFlags(maskModifierFlags(node, modifierMask, modifierAdditions));
      }
      function maskModifierFlags(node, modifierMask, modifierAdditions) {
        if (modifierMask === void 0) {
          modifierMask = 3071 ^ 4;
        }
        if (modifierAdditions === void 0) {
          modifierAdditions = 0;
        }
        var flags = ts2.getModifierFlags(node) & modifierMask | modifierAdditions;
        if (flags & 512 && !(flags & 1)) {
          flags ^= 1;
        }
        if (flags & 512 && flags & 2) {
          flags ^= 2;
        }
        return flags;
      }
      function getTypeAnnotationFromAccessor(accessor) {
        if (accessor) {
          return accessor.kind === 163 ? accessor.type : accessor.parameters.length > 0 ? accessor.parameters[0].type : void 0;
        }
      }
      function canHaveLiteralInitializer(node) {
        switch (node.kind) {
          case 159:
          case 158:
            return !ts2.hasModifier(node, 8);
          case 156:
          case 242:
            return true;
        }
        return false;
      }
      function isPreservedDeclarationStatement(node) {
        switch (node.kind) {
          case 244:
          case 249:
          case 253:
          case 246:
          case 245:
          case 247:
          case 248:
          case 225:
          case 254:
          case 260:
          case 259:
            return true;
        }
        return false;
      }
      function isProcessedComponent(node) {
        switch (node.kind) {
          case 166:
          case 162:
          case 161:
          case 163:
          case 164:
          case 159:
          case 158:
          case 160:
          case 165:
          case 167:
          case 242:
          case 155:
          case 216:
          case 169:
          case 180:
          case 170:
          case 171:
          case 188:
            return true;
        }
        return false;
      }
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function getModuleTransformer(moduleKind) {
        switch (moduleKind) {
          case ts2.ModuleKind.ESNext:
          case ts2.ModuleKind.ES2020:
          case ts2.ModuleKind.ES2015:
            return ts2.transformECMAScriptModule;
          case ts2.ModuleKind.System:
            return ts2.transformSystemModule;
          default:
            return ts2.transformModule;
        }
      }
      var TransformationState;
      (function(TransformationState2) {
        TransformationState2[TransformationState2["Uninitialized"] = 0] = "Uninitialized";
        TransformationState2[TransformationState2["Initialized"] = 1] = "Initialized";
        TransformationState2[TransformationState2["Completed"] = 2] = "Completed";
        TransformationState2[TransformationState2["Disposed"] = 3] = "Disposed";
      })(TransformationState || (TransformationState = {}));
      var SyntaxKindFeatureFlags;
      (function(SyntaxKindFeatureFlags2) {
        SyntaxKindFeatureFlags2[SyntaxKindFeatureFlags2["Substitution"] = 1] = "Substitution";
        SyntaxKindFeatureFlags2[SyntaxKindFeatureFlags2["EmitNotifications"] = 2] = "EmitNotifications";
      })(SyntaxKindFeatureFlags || (SyntaxKindFeatureFlags = {}));
      ts2.noTransformers = { scriptTransformers: ts2.emptyArray, declarationTransformers: ts2.emptyArray };
      function getTransformers(compilerOptions, customTransformers, emitOnlyDtsFiles) {
        return {
          scriptTransformers: getScriptTransformers(compilerOptions, customTransformers, emitOnlyDtsFiles),
          declarationTransformers: getDeclarationTransformers(customTransformers)
        };
      }
      ts2.getTransformers = getTransformers;
      function getScriptTransformers(compilerOptions, customTransformers, emitOnlyDtsFiles) {
        if (emitOnlyDtsFiles)
          return ts2.emptyArray;
        var jsx = compilerOptions.jsx;
        var languageVersion = ts2.getEmitScriptTarget(compilerOptions);
        var moduleKind = ts2.getEmitModuleKind(compilerOptions);
        var transformers = [];
        ts2.addRange(transformers, customTransformers && ts2.map(customTransformers.before, wrapScriptTransformerFactory));
        transformers.push(ts2.transformTypeScript);
        transformers.push(ts2.transformClassFields);
        if (jsx === 2) {
          transformers.push(ts2.transformJsx);
        }
        if (languageVersion < 99) {
          transformers.push(ts2.transformESNext);
        }
        if (languageVersion < 7) {
          transformers.push(ts2.transformES2020);
        }
        if (languageVersion < 6) {
          transformers.push(ts2.transformES2019);
        }
        if (languageVersion < 5) {
          transformers.push(ts2.transformES2018);
        }
        if (languageVersion < 4) {
          transformers.push(ts2.transformES2017);
        }
        if (languageVersion < 3) {
          transformers.push(ts2.transformES2016);
        }
        if (languageVersion < 2) {
          transformers.push(ts2.transformES2015);
          transformers.push(ts2.transformGenerators);
        }
        transformers.push(getModuleTransformer(moduleKind));
        if (languageVersion < 1) {
          transformers.push(ts2.transformES5);
        }
        ts2.addRange(transformers, customTransformers && ts2.map(customTransformers.after, wrapScriptTransformerFactory));
        return transformers;
      }
      function getDeclarationTransformers(customTransformers) {
        var transformers = [];
        transformers.push(ts2.transformDeclarations);
        ts2.addRange(transformers, customTransformers && ts2.map(customTransformers.afterDeclarations, wrapDeclarationTransformerFactory));
        return transformers;
      }
      function wrapCustomTransformer(transformer) {
        return function(node) {
          return ts2.isBundle(node) ? transformer.transformBundle(node) : transformer.transformSourceFile(node);
        };
      }
      function wrapCustomTransformerFactory(transformer, handleDefault) {
        return function(context) {
          var customTransformer = transformer(context);
          return typeof customTransformer === "function" ? handleDefault(customTransformer) : wrapCustomTransformer(customTransformer);
        };
      }
      function wrapScriptTransformerFactory(transformer) {
        return wrapCustomTransformerFactory(transformer, ts2.chainBundle);
      }
      function wrapDeclarationTransformerFactory(transformer) {
        return wrapCustomTransformerFactory(transformer, ts2.identity);
      }
      function noEmitSubstitution(_hint, node) {
        return node;
      }
      ts2.noEmitSubstitution = noEmitSubstitution;
      function noEmitNotification(hint, node, callback) {
        callback(hint, node);
      }
      ts2.noEmitNotification = noEmitNotification;
      function transformNodes(resolver, host, options, nodes, transformers, allowDtsFiles) {
        var enabledSyntaxKindFeatures = new Array(331);
        var lexicalEnvironmentVariableDeclarations;
        var lexicalEnvironmentFunctionDeclarations;
        var lexicalEnvironmentStatements;
        var lexicalEnvironmentFlags = 0;
        var lexicalEnvironmentVariableDeclarationsStack = [];
        var lexicalEnvironmentFunctionDeclarationsStack = [];
        var lexicalEnvironmentStatementsStack = [];
        var lexicalEnvironmentFlagsStack = [];
        var lexicalEnvironmentStackOffset = 0;
        var lexicalEnvironmentSuspended = false;
        var emitHelpers;
        var onSubstituteNode = noEmitSubstitution;
        var onEmitNode = noEmitNotification;
        var state = 0;
        var diagnostics = [];
        var context = {
          getCompilerOptions: function() {
            return options;
          },
          getEmitResolver: function() {
            return resolver;
          },
          getEmitHost: function() {
            return host;
          },
          startLexicalEnvironment,
          suspendLexicalEnvironment,
          resumeLexicalEnvironment,
          endLexicalEnvironment,
          setLexicalEnvironmentFlags,
          getLexicalEnvironmentFlags,
          hoistVariableDeclaration,
          hoistFunctionDeclaration,
          addInitializationStatement,
          requestEmitHelper,
          readEmitHelpers,
          enableSubstitution,
          enableEmitNotification,
          isSubstitutionEnabled,
          isEmitNotificationEnabled,
          get onSubstituteNode() {
            return onSubstituteNode;
          },
          set onSubstituteNode(value) {
            ts2.Debug.assert(state < 1, "Cannot modify transformation hooks after initialization has completed.");
            ts2.Debug.assert(value !== void 0, "Value must not be 'undefined'");
            onSubstituteNode = value;
          },
          get onEmitNode() {
            return onEmitNode;
          },
          set onEmitNode(value) {
            ts2.Debug.assert(state < 1, "Cannot modify transformation hooks after initialization has completed.");
            ts2.Debug.assert(value !== void 0, "Value must not be 'undefined'");
            onEmitNode = value;
          },
          addDiagnostic: function(diag) {
            diagnostics.push(diag);
          }
        };
        for (var _i = 0, nodes_4 = nodes; _i < nodes_4.length; _i++) {
          var node = nodes_4[_i];
          ts2.disposeEmitNodes(ts2.getSourceFileOfNode(ts2.getParseTreeNode(node)));
        }
        ts2.performance.mark("beforeTransform");
        var transformersWithContext = transformers.map(function(t) {
          return t(context);
        });
        var transformation = function(node2) {
          for (var _i2 = 0, transformersWithContext_1 = transformersWithContext; _i2 < transformersWithContext_1.length; _i2++) {
            var transform = transformersWithContext_1[_i2];
            node2 = transform(node2);
          }
          return node2;
        };
        state = 1;
        var transformed = ts2.map(nodes, allowDtsFiles ? transformation : transformRoot);
        state = 2;
        ts2.performance.mark("afterTransform");
        ts2.performance.measure("transformTime", "beforeTransform", "afterTransform");
        return {
          transformed,
          substituteNode,
          emitNodeWithNotification,
          isEmitNotificationEnabled,
          dispose,
          diagnostics
        };
        function transformRoot(node2) {
          return node2 && (!ts2.isSourceFile(node2) || !node2.isDeclarationFile) ? transformation(node2) : node2;
        }
        function enableSubstitution(kind) {
          ts2.Debug.assert(state < 2, "Cannot modify the transformation context after transformation has completed.");
          enabledSyntaxKindFeatures[kind] |= 1;
        }
        function isSubstitutionEnabled(node2) {
          return (enabledSyntaxKindFeatures[node2.kind] & 1) !== 0 && (ts2.getEmitFlags(node2) & 4) === 0;
        }
        function substituteNode(hint, node2) {
          ts2.Debug.assert(state < 3, "Cannot substitute a node after the result is disposed.");
          return node2 && isSubstitutionEnabled(node2) && onSubstituteNode(hint, node2) || node2;
        }
        function enableEmitNotification(kind) {
          ts2.Debug.assert(state < 2, "Cannot modify the transformation context after transformation has completed.");
          enabledSyntaxKindFeatures[kind] |= 2;
        }
        function isEmitNotificationEnabled(node2) {
          return (enabledSyntaxKindFeatures[node2.kind] & 2) !== 0 || (ts2.getEmitFlags(node2) & 2) !== 0;
        }
        function emitNodeWithNotification(hint, node2, emitCallback) {
          ts2.Debug.assert(state < 3, "Cannot invoke TransformationResult callbacks after the result is disposed.");
          if (node2) {
            if (isEmitNotificationEnabled(node2)) {
              onEmitNode(hint, node2, emitCallback);
            } else {
              emitCallback(hint, node2);
            }
          }
        }
        function hoistVariableDeclaration(name) {
          ts2.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts2.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          var decl = ts2.setEmitFlags(ts2.createVariableDeclaration(name), 64);
          if (!lexicalEnvironmentVariableDeclarations) {
            lexicalEnvironmentVariableDeclarations = [decl];
          } else {
            lexicalEnvironmentVariableDeclarations.push(decl);
          }
          if (lexicalEnvironmentFlags & 1) {
            lexicalEnvironmentFlags |= 2;
          }
        }
        function hoistFunctionDeclaration(func) {
          ts2.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts2.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          ts2.setEmitFlags(func, 1048576);
          if (!lexicalEnvironmentFunctionDeclarations) {
            lexicalEnvironmentFunctionDeclarations = [func];
          } else {
            lexicalEnvironmentFunctionDeclarations.push(func);
          }
        }
        function addInitializationStatement(node2) {
          ts2.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts2.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          ts2.setEmitFlags(node2, 1048576);
          if (!lexicalEnvironmentStatements) {
            lexicalEnvironmentStatements = [node2];
          } else {
            lexicalEnvironmentStatements.push(node2);
          }
        }
        function startLexicalEnvironment() {
          ts2.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts2.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          ts2.Debug.assert(!lexicalEnvironmentSuspended, "Lexical environment is suspended.");
          lexicalEnvironmentVariableDeclarationsStack[lexicalEnvironmentStackOffset] = lexicalEnvironmentVariableDeclarations;
          lexicalEnvironmentFunctionDeclarationsStack[lexicalEnvironmentStackOffset] = lexicalEnvironmentFunctionDeclarations;
          lexicalEnvironmentStatementsStack[lexicalEnvironmentStackOffset] = lexicalEnvironmentStatements;
          lexicalEnvironmentFlagsStack[lexicalEnvironmentStackOffset] = lexicalEnvironmentFlags;
          lexicalEnvironmentStackOffset++;
          lexicalEnvironmentVariableDeclarations = void 0;
          lexicalEnvironmentFunctionDeclarations = void 0;
          lexicalEnvironmentStatements = void 0;
          lexicalEnvironmentFlags = 0;
        }
        function suspendLexicalEnvironment() {
          ts2.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts2.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          ts2.Debug.assert(!lexicalEnvironmentSuspended, "Lexical environment is already suspended.");
          lexicalEnvironmentSuspended = true;
        }
        function resumeLexicalEnvironment() {
          ts2.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts2.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          ts2.Debug.assert(lexicalEnvironmentSuspended, "Lexical environment is not suspended.");
          lexicalEnvironmentSuspended = false;
        }
        function endLexicalEnvironment() {
          ts2.Debug.assert(state > 0, "Cannot modify the lexical environment during initialization.");
          ts2.Debug.assert(state < 2, "Cannot modify the lexical environment after transformation has completed.");
          ts2.Debug.assert(!lexicalEnvironmentSuspended, "Lexical environment is suspended.");
          var statements;
          if (lexicalEnvironmentVariableDeclarations || lexicalEnvironmentFunctionDeclarations || lexicalEnvironmentStatements) {
            if (lexicalEnvironmentFunctionDeclarations) {
              statements = __spreadArrays(lexicalEnvironmentFunctionDeclarations);
            }
            if (lexicalEnvironmentVariableDeclarations) {
              var statement = ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList(lexicalEnvironmentVariableDeclarations));
              ts2.setEmitFlags(statement, 1048576);
              if (!statements) {
                statements = [statement];
              } else {
                statements.push(statement);
              }
            }
            if (lexicalEnvironmentStatements) {
              if (!statements) {
                statements = __spreadArrays(lexicalEnvironmentStatements);
              } else {
                statements = __spreadArrays(statements, lexicalEnvironmentStatements);
              }
            }
          }
          lexicalEnvironmentStackOffset--;
          lexicalEnvironmentVariableDeclarations = lexicalEnvironmentVariableDeclarationsStack[lexicalEnvironmentStackOffset];
          lexicalEnvironmentFunctionDeclarations = lexicalEnvironmentFunctionDeclarationsStack[lexicalEnvironmentStackOffset];
          lexicalEnvironmentStatements = lexicalEnvironmentStatementsStack[lexicalEnvironmentStackOffset];
          lexicalEnvironmentFlags = lexicalEnvironmentFlagsStack[lexicalEnvironmentStackOffset];
          if (lexicalEnvironmentStackOffset === 0) {
            lexicalEnvironmentVariableDeclarationsStack = [];
            lexicalEnvironmentFunctionDeclarationsStack = [];
            lexicalEnvironmentStatementsStack = [];
            lexicalEnvironmentFlagsStack = [];
          }
          return statements;
        }
        function setLexicalEnvironmentFlags(flags, value) {
          lexicalEnvironmentFlags = value ? lexicalEnvironmentFlags | flags : lexicalEnvironmentFlags & ~flags;
        }
        function getLexicalEnvironmentFlags() {
          return lexicalEnvironmentFlags;
        }
        function requestEmitHelper(helper) {
          ts2.Debug.assert(state > 0, "Cannot modify the transformation context during initialization.");
          ts2.Debug.assert(state < 2, "Cannot modify the transformation context after transformation has completed.");
          ts2.Debug.assert(!helper.scoped, "Cannot request a scoped emit helper.");
          if (helper.dependencies) {
            for (var _i2 = 0, _a = helper.dependencies; _i2 < _a.length; _i2++) {
              var h = _a[_i2];
              requestEmitHelper(h);
            }
          }
          emitHelpers = ts2.append(emitHelpers, helper);
        }
        function readEmitHelpers() {
          ts2.Debug.assert(state > 0, "Cannot modify the transformation context during initialization.");
          ts2.Debug.assert(state < 2, "Cannot modify the transformation context after transformation has completed.");
          var helpers = emitHelpers;
          emitHelpers = void 0;
          return helpers;
        }
        function dispose() {
          if (state < 3) {
            for (var _i2 = 0, nodes_5 = nodes; _i2 < nodes_5.length; _i2++) {
              var node2 = nodes_5[_i2];
              ts2.disposeEmitNodes(ts2.getSourceFileOfNode(ts2.getParseTreeNode(node2)));
            }
            lexicalEnvironmentVariableDeclarations = void 0;
            lexicalEnvironmentVariableDeclarationsStack = void 0;
            lexicalEnvironmentFunctionDeclarations = void 0;
            lexicalEnvironmentFunctionDeclarationsStack = void 0;
            onSubstituteNode = void 0;
            onEmitNode = void 0;
            emitHelpers = void 0;
            state = 3;
          }
        }
      }
      ts2.transformNodes = transformNodes;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var brackets = createBracketsMap();
      var syntheticParent = { pos: -1, end: -1 };
      function isBuildInfoFile(file) {
        return ts2.fileExtensionIs(file, ".tsbuildinfo");
      }
      ts2.isBuildInfoFile = isBuildInfoFile;
      function forEachEmittedFile(host, action, sourceFilesOrTargetSourceFile, forceDtsEmit, onlyBuildInfo, includeBuildInfo) {
        if (forceDtsEmit === void 0) {
          forceDtsEmit = false;
        }
        var sourceFiles = ts2.isArray(sourceFilesOrTargetSourceFile) ? sourceFilesOrTargetSourceFile : ts2.getSourceFilesToEmit(host, sourceFilesOrTargetSourceFile, forceDtsEmit);
        var options = host.getCompilerOptions();
        if (options.outFile || options.out) {
          var prepends = host.getPrependNodes();
          if (sourceFiles.length || prepends.length) {
            var bundle = ts2.createBundle(sourceFiles, prepends);
            var result = action(getOutputPathsFor(bundle, host, forceDtsEmit), bundle);
            if (result) {
              return result;
            }
          }
        } else {
          if (!onlyBuildInfo) {
            for (var _a = 0, sourceFiles_1 = sourceFiles; _a < sourceFiles_1.length; _a++) {
              var sourceFile = sourceFiles_1[_a];
              var result = action(getOutputPathsFor(sourceFile, host, forceDtsEmit), sourceFile);
              if (result) {
                return result;
              }
            }
          }
          if (includeBuildInfo) {
            var buildInfoPath = getTsBuildInfoEmitOutputFilePath(host.getCompilerOptions());
            if (buildInfoPath)
              return action({ buildInfoPath }, void 0);
          }
        }
      }
      ts2.forEachEmittedFile = forEachEmittedFile;
      function getTsBuildInfoEmitOutputFilePath(options) {
        var configFile = options.configFilePath;
        if (!ts2.isIncrementalCompilation(options))
          return void 0;
        if (options.tsBuildInfoFile)
          return options.tsBuildInfoFile;
        var outPath = options.outFile || options.out;
        var buildInfoExtensionLess;
        if (outPath) {
          buildInfoExtensionLess = ts2.removeFileExtension(outPath);
        } else {
          if (!configFile)
            return void 0;
          var configFileExtensionLess = ts2.removeFileExtension(configFile);
          buildInfoExtensionLess = options.outDir ? options.rootDir ? ts2.resolvePath(options.outDir, ts2.getRelativePathFromDirectory(options.rootDir, configFileExtensionLess, true)) : ts2.combinePaths(options.outDir, ts2.getBaseFileName(configFileExtensionLess)) : configFileExtensionLess;
        }
        return buildInfoExtensionLess + ".tsbuildinfo";
      }
      ts2.getTsBuildInfoEmitOutputFilePath = getTsBuildInfoEmitOutputFilePath;
      function getOutputPathsForBundle(options, forceDtsPaths) {
        var outPath = options.outFile || options.out;
        var jsFilePath = options.emitDeclarationOnly ? void 0 : outPath;
        var sourceMapFilePath = jsFilePath && getSourceMapFilePath(jsFilePath, options);
        var declarationFilePath = forceDtsPaths || ts2.getEmitDeclarations(options) ? ts2.removeFileExtension(outPath) + ".d.ts" : void 0;
        var declarationMapPath = declarationFilePath && ts2.getAreDeclarationMapsEnabled(options) ? declarationFilePath + ".map" : void 0;
        var buildInfoPath = getTsBuildInfoEmitOutputFilePath(options);
        return { jsFilePath, sourceMapFilePath, declarationFilePath, declarationMapPath, buildInfoPath };
      }
      ts2.getOutputPathsForBundle = getOutputPathsForBundle;
      function getOutputPathsFor(sourceFile, host, forceDtsPaths) {
        var options = host.getCompilerOptions();
        if (sourceFile.kind === 291) {
          return getOutputPathsForBundle(options, forceDtsPaths);
        } else {
          var ownOutputFilePath = ts2.getOwnEmitOutputFilePath(sourceFile.fileName, host, getOutputExtension(sourceFile, options));
          var isJsonFile = ts2.isJsonSourceFile(sourceFile);
          var isJsonEmittedToSameLocation = isJsonFile && ts2.comparePaths(sourceFile.fileName, ownOutputFilePath, host.getCurrentDirectory(), !host.useCaseSensitiveFileNames()) === 0;
          var jsFilePath = options.emitDeclarationOnly || isJsonEmittedToSameLocation ? void 0 : ownOutputFilePath;
          var sourceMapFilePath = !jsFilePath || ts2.isJsonSourceFile(sourceFile) ? void 0 : getSourceMapFilePath(jsFilePath, options);
          var declarationFilePath = forceDtsPaths || ts2.getEmitDeclarations(options) && !isJsonFile ? ts2.getDeclarationEmitOutputFilePath(sourceFile.fileName, host) : void 0;
          var declarationMapPath = declarationFilePath && ts2.getAreDeclarationMapsEnabled(options) ? declarationFilePath + ".map" : void 0;
          return { jsFilePath, sourceMapFilePath, declarationFilePath, declarationMapPath, buildInfoPath: void 0 };
        }
      }
      ts2.getOutputPathsFor = getOutputPathsFor;
      function getSourceMapFilePath(jsFilePath, options) {
        return options.sourceMap && !options.inlineSourceMap ? jsFilePath + ".map" : void 0;
      }
      function getOutputExtension(sourceFile, options) {
        if (ts2.isJsonSourceFile(sourceFile)) {
          return ".json";
        }
        if (options.jsx === 1) {
          if (ts2.isSourceFileJS(sourceFile)) {
            if (ts2.fileExtensionIs(sourceFile.fileName, ".jsx")) {
              return ".jsx";
            }
          } else if (sourceFile.languageVariant === 1) {
            return ".jsx";
          }
        }
        return ".js";
      }
      ts2.getOutputExtension = getOutputExtension;
      function rootDirOfOptions(configFile) {
        return configFile.options.rootDir || ts2.getDirectoryPath(ts2.Debug.checkDefined(configFile.options.configFilePath));
      }
      function getOutputPathWithoutChangingExt(inputFileName, configFile, ignoreCase, outputDir) {
        return outputDir ? ts2.resolvePath(outputDir, ts2.getRelativePathFromDirectory(rootDirOfOptions(configFile), inputFileName, ignoreCase)) : inputFileName;
      }
      function getOutputDeclarationFileName(inputFileName, configFile, ignoreCase) {
        ts2.Debug.assert(!ts2.fileExtensionIs(inputFileName, ".d.ts") && !ts2.fileExtensionIs(inputFileName, ".json"));
        return ts2.changeExtension(getOutputPathWithoutChangingExt(inputFileName, configFile, ignoreCase, configFile.options.declarationDir || configFile.options.outDir), ".d.ts");
      }
      ts2.getOutputDeclarationFileName = getOutputDeclarationFileName;
      function getOutputJSFileName(inputFileName, configFile, ignoreCase) {
        if (configFile.options.emitDeclarationOnly)
          return void 0;
        var isJsonFile = ts2.fileExtensionIs(inputFileName, ".json");
        var outputFileName = ts2.changeExtension(getOutputPathWithoutChangingExt(inputFileName, configFile, ignoreCase, configFile.options.outDir), isJsonFile ? ".json" : ts2.fileExtensionIs(inputFileName, ".tsx") && configFile.options.jsx === 1 ? ".jsx" : ".js");
        return !isJsonFile || ts2.comparePaths(inputFileName, outputFileName, ts2.Debug.checkDefined(configFile.options.configFilePath), ignoreCase) !== 0 ? outputFileName : void 0;
      }
      function createAddOutput() {
        var outputs;
        return { addOutput, getOutputs };
        function addOutput(path2) {
          if (path2) {
            (outputs || (outputs = [])).push(path2);
          }
        }
        function getOutputs() {
          return outputs || ts2.emptyArray;
        }
      }
      function getSingleOutputFileNames(configFile, addOutput) {
        var _a = getOutputPathsForBundle(configFile.options, false), jsFilePath = _a.jsFilePath, sourceMapFilePath = _a.sourceMapFilePath, declarationFilePath = _a.declarationFilePath, declarationMapPath = _a.declarationMapPath, buildInfoPath = _a.buildInfoPath;
        addOutput(jsFilePath);
        addOutput(sourceMapFilePath);
        addOutput(declarationFilePath);
        addOutput(declarationMapPath);
        addOutput(buildInfoPath);
      }
      function getOwnOutputFileNames(configFile, inputFileName, ignoreCase, addOutput) {
        if (ts2.fileExtensionIs(inputFileName, ".d.ts"))
          return;
        var js = getOutputJSFileName(inputFileName, configFile, ignoreCase);
        addOutput(js);
        if (ts2.fileExtensionIs(inputFileName, ".json"))
          return;
        if (js && configFile.options.sourceMap) {
          addOutput(js + ".map");
        }
        if (ts2.getEmitDeclarations(configFile.options)) {
          var dts = getOutputDeclarationFileName(inputFileName, configFile, ignoreCase);
          addOutput(dts);
          if (configFile.options.declarationMap) {
            addOutput(dts + ".map");
          }
        }
      }
      function getAllProjectOutputs(configFile, ignoreCase) {
        var _a = createAddOutput(), addOutput = _a.addOutput, getOutputs = _a.getOutputs;
        if (configFile.options.outFile || configFile.options.out) {
          getSingleOutputFileNames(configFile, addOutput);
        } else {
          for (var _b = 0, _c = configFile.fileNames; _b < _c.length; _b++) {
            var inputFileName = _c[_b];
            getOwnOutputFileNames(configFile, inputFileName, ignoreCase, addOutput);
          }
          addOutput(getTsBuildInfoEmitOutputFilePath(configFile.options));
        }
        return getOutputs();
      }
      ts2.getAllProjectOutputs = getAllProjectOutputs;
      function getOutputFileNames(commandLine, inputFileName, ignoreCase) {
        inputFileName = ts2.normalizePath(inputFileName);
        ts2.Debug.assert(ts2.contains(commandLine.fileNames, inputFileName), "Expected fileName to be present in command line");
        var _a = createAddOutput(), addOutput = _a.addOutput, getOutputs = _a.getOutputs;
        if (commandLine.options.outFile || commandLine.options.out) {
          getSingleOutputFileNames(commandLine, addOutput);
        } else {
          getOwnOutputFileNames(commandLine, inputFileName, ignoreCase, addOutput);
        }
        return getOutputs();
      }
      ts2.getOutputFileNames = getOutputFileNames;
      function getFirstProjectOutput(configFile, ignoreCase) {
        if (configFile.options.outFile || configFile.options.out) {
          var jsFilePath = getOutputPathsForBundle(configFile.options, false).jsFilePath;
          return ts2.Debug.checkDefined(jsFilePath, "project " + configFile.options.configFilePath + " expected to have at least one output");
        }
        for (var _a = 0, _b = configFile.fileNames; _a < _b.length; _a++) {
          var inputFileName = _b[_a];
          if (ts2.fileExtensionIs(inputFileName, ".d.ts"))
            continue;
          var jsFilePath = getOutputJSFileName(inputFileName, configFile, ignoreCase);
          if (jsFilePath)
            return jsFilePath;
          if (ts2.fileExtensionIs(inputFileName, ".json"))
            continue;
          if (ts2.getEmitDeclarations(configFile.options)) {
            return getOutputDeclarationFileName(inputFileName, configFile, ignoreCase);
          }
        }
        var buildInfoPath = getTsBuildInfoEmitOutputFilePath(configFile.options);
        if (buildInfoPath)
          return buildInfoPath;
        return ts2.Debug.fail("project " + configFile.options.configFilePath + " expected to have at least one output");
      }
      ts2.getFirstProjectOutput = getFirstProjectOutput;
      function emitFiles(resolver, host, targetSourceFile, _a, emitOnlyDtsFiles, onlyBuildInfo, forceDtsEmit) {
        var scriptTransformers = _a.scriptTransformers, declarationTransformers = _a.declarationTransformers;
        var compilerOptions = host.getCompilerOptions();
        var sourceMapDataList = compilerOptions.sourceMap || compilerOptions.inlineSourceMap || ts2.getAreDeclarationMapsEnabled(compilerOptions) ? [] : void 0;
        var emittedFilesList = compilerOptions.listEmittedFiles ? [] : void 0;
        var emitterDiagnostics = ts2.createDiagnosticCollection();
        var newLine = ts2.getNewLineCharacter(compilerOptions, function() {
          return host.getNewLine();
        });
        var writer = ts2.createTextWriter(newLine);
        var _b = ts2.performance.createTimer("printTime", "beforePrint", "afterPrint"), enter = _b.enter, exit = _b.exit;
        var bundleBuildInfo;
        var emitSkipped = false;
        var exportedModulesFromDeclarationEmit;
        enter();
        forEachEmittedFile(host, emitSourceFileOrBundle, ts2.getSourceFilesToEmit(host, targetSourceFile, forceDtsEmit), forceDtsEmit, onlyBuildInfo, !targetSourceFile);
        exit();
        return {
          emitSkipped,
          diagnostics: emitterDiagnostics.getDiagnostics(),
          emittedFiles: emittedFilesList,
          sourceMaps: sourceMapDataList,
          exportedModulesFromDeclarationEmit
        };
        function emitSourceFileOrBundle(_a2, sourceFileOrBundle) {
          var jsFilePath = _a2.jsFilePath, sourceMapFilePath = _a2.sourceMapFilePath, declarationFilePath = _a2.declarationFilePath, declarationMapPath = _a2.declarationMapPath, buildInfoPath = _a2.buildInfoPath;
          var buildInfoDirectory;
          if (buildInfoPath && sourceFileOrBundle && ts2.isBundle(sourceFileOrBundle)) {
            buildInfoDirectory = ts2.getDirectoryPath(ts2.getNormalizedAbsolutePath(buildInfoPath, host.getCurrentDirectory()));
            bundleBuildInfo = {
              commonSourceDirectory: relativeToBuildInfo(host.getCommonSourceDirectory()),
              sourceFiles: sourceFileOrBundle.sourceFiles.map(function(file) {
                return relativeToBuildInfo(ts2.getNormalizedAbsolutePath(file.fileName, host.getCurrentDirectory()));
              })
            };
          }
          emitJsFileOrBundle(sourceFileOrBundle, jsFilePath, sourceMapFilePath, relativeToBuildInfo);
          emitDeclarationFileOrBundle(sourceFileOrBundle, declarationFilePath, declarationMapPath, relativeToBuildInfo);
          emitBuildInfo(bundleBuildInfo, buildInfoPath);
          if (!emitSkipped && emittedFilesList) {
            if (!emitOnlyDtsFiles) {
              if (jsFilePath) {
                emittedFilesList.push(jsFilePath);
              }
              if (sourceMapFilePath) {
                emittedFilesList.push(sourceMapFilePath);
              }
              if (buildInfoPath) {
                emittedFilesList.push(buildInfoPath);
              }
            }
            if (declarationFilePath) {
              emittedFilesList.push(declarationFilePath);
            }
            if (declarationMapPath) {
              emittedFilesList.push(declarationMapPath);
            }
          }
          function relativeToBuildInfo(path2) {
            return ts2.ensurePathIsNonModuleName(ts2.getRelativePathFromDirectory(buildInfoDirectory, path2, host.getCanonicalFileName));
          }
        }
        function emitBuildInfo(bundle, buildInfoPath) {
          if (!buildInfoPath || targetSourceFile || emitSkipped)
            return;
          var program = host.getProgramBuildInfo();
          if (host.isEmitBlocked(buildInfoPath) || compilerOptions.noEmit) {
            emitSkipped = true;
            return;
          }
          var version = ts2.version;
          ts2.writeFile(host, emitterDiagnostics, buildInfoPath, getBuildInfoText({ bundle, program, version }), false);
        }
        function emitJsFileOrBundle(sourceFileOrBundle, jsFilePath, sourceMapFilePath, relativeToBuildInfo) {
          if (!sourceFileOrBundle || emitOnlyDtsFiles || !jsFilePath) {
            return;
          }
          if (jsFilePath && host.isEmitBlocked(jsFilePath) || compilerOptions.noEmit) {
            emitSkipped = true;
            return;
          }
          var transform = ts2.transformNodes(resolver, host, compilerOptions, [sourceFileOrBundle], scriptTransformers, false);
          var printerOptions = {
            removeComments: compilerOptions.removeComments,
            newLine: compilerOptions.newLine,
            noEmitHelpers: compilerOptions.noEmitHelpers,
            module: compilerOptions.module,
            target: compilerOptions.target,
            sourceMap: compilerOptions.sourceMap,
            inlineSourceMap: compilerOptions.inlineSourceMap,
            inlineSources: compilerOptions.inlineSources,
            extendedDiagnostics: compilerOptions.extendedDiagnostics,
            writeBundleFileInfo: !!bundleBuildInfo,
            relativeToBuildInfo
          };
          var printer = createPrinter(printerOptions, {
            hasGlobalName: resolver.hasGlobalName,
            onEmitNode: transform.emitNodeWithNotification,
            isEmitNotificationEnabled: transform.isEmitNotificationEnabled,
            substituteNode: transform.substituteNode
          });
          ts2.Debug.assert(transform.transformed.length === 1, "Should only see one output from the transform");
          printSourceFileOrBundle(jsFilePath, sourceMapFilePath, transform.transformed[0], printer, compilerOptions);
          transform.dispose();
          if (bundleBuildInfo)
            bundleBuildInfo.js = printer.bundleFileInfo;
        }
        function emitDeclarationFileOrBundle(sourceFileOrBundle, declarationFilePath, declarationMapPath, relativeToBuildInfo) {
          if (!sourceFileOrBundle)
            return;
          if (!declarationFilePath) {
            if (emitOnlyDtsFiles || compilerOptions.emitDeclarationOnly)
              emitSkipped = true;
            return;
          }
          var sourceFiles = ts2.isSourceFile(sourceFileOrBundle) ? [sourceFileOrBundle] : sourceFileOrBundle.sourceFiles;
          var filesForEmit = forceDtsEmit ? sourceFiles : ts2.filter(sourceFiles, ts2.isSourceFileNotJson);
          var inputListOrBundle = compilerOptions.outFile || compilerOptions.out ? [ts2.createBundle(filesForEmit, !ts2.isSourceFile(sourceFileOrBundle) ? sourceFileOrBundle.prepends : void 0)] : filesForEmit;
          if (emitOnlyDtsFiles && !ts2.getEmitDeclarations(compilerOptions)) {
            filesForEmit.forEach(collectLinkedAliases);
          }
          var declarationTransform = ts2.transformNodes(resolver, host, compilerOptions, inputListOrBundle, declarationTransformers, false);
          if (ts2.length(declarationTransform.diagnostics)) {
            for (var _a2 = 0, _b2 = declarationTransform.diagnostics; _a2 < _b2.length; _a2++) {
              var diagnostic = _b2[_a2];
              emitterDiagnostics.add(diagnostic);
            }
          }
          var printerOptions = {
            removeComments: compilerOptions.removeComments,
            newLine: compilerOptions.newLine,
            noEmitHelpers: true,
            module: compilerOptions.module,
            target: compilerOptions.target,
            sourceMap: compilerOptions.sourceMap,
            inlineSourceMap: compilerOptions.inlineSourceMap,
            extendedDiagnostics: compilerOptions.extendedDiagnostics,
            onlyPrintJsDocStyle: true,
            writeBundleFileInfo: !!bundleBuildInfo,
            recordInternalSection: !!bundleBuildInfo,
            relativeToBuildInfo
          };
          var declarationPrinter = createPrinter(printerOptions, {
            hasGlobalName: resolver.hasGlobalName,
            onEmitNode: declarationTransform.emitNodeWithNotification,
            isEmitNotificationEnabled: declarationTransform.isEmitNotificationEnabled,
            substituteNode: declarationTransform.substituteNode
          });
          var declBlocked = !!declarationTransform.diagnostics && !!declarationTransform.diagnostics.length || !!host.isEmitBlocked(declarationFilePath) || !!compilerOptions.noEmit;
          emitSkipped = emitSkipped || declBlocked;
          if (!declBlocked || forceDtsEmit) {
            ts2.Debug.assert(declarationTransform.transformed.length === 1, "Should only see one output from the decl transform");
            printSourceFileOrBundle(declarationFilePath, declarationMapPath, declarationTransform.transformed[0], declarationPrinter, {
              sourceMap: compilerOptions.declarationMap,
              sourceRoot: compilerOptions.sourceRoot,
              mapRoot: compilerOptions.mapRoot,
              extendedDiagnostics: compilerOptions.extendedDiagnostics
            });
            if (forceDtsEmit && declarationTransform.transformed[0].kind === 290) {
              var sourceFile = declarationTransform.transformed[0];
              exportedModulesFromDeclarationEmit = sourceFile.exportedModulesFromDeclarationEmit;
            }
          }
          declarationTransform.dispose();
          if (bundleBuildInfo)
            bundleBuildInfo.dts = declarationPrinter.bundleFileInfo;
        }
        function collectLinkedAliases(node) {
          if (ts2.isExportAssignment(node)) {
            if (node.expression.kind === 75) {
              resolver.collectLinkedAliases(node.expression, true);
            }
            return;
          } else if (ts2.isExportSpecifier(node)) {
            resolver.collectLinkedAliases(node.propertyName || node.name, true);
            return;
          }
          ts2.forEachChild(node, collectLinkedAliases);
        }
        function printSourceFileOrBundle(jsFilePath, sourceMapFilePath, sourceFileOrBundle, printer, mapOptions) {
          var bundle = sourceFileOrBundle.kind === 291 ? sourceFileOrBundle : void 0;
          var sourceFile = sourceFileOrBundle.kind === 290 ? sourceFileOrBundle : void 0;
          var sourceFiles = bundle ? bundle.sourceFiles : [sourceFile];
          var sourceMapGenerator;
          if (shouldEmitSourceMaps(mapOptions, sourceFileOrBundle)) {
            sourceMapGenerator = ts2.createSourceMapGenerator(host, ts2.getBaseFileName(ts2.normalizeSlashes(jsFilePath)), getSourceRoot(mapOptions), getSourceMapDirectory(mapOptions, jsFilePath, sourceFile), mapOptions);
          }
          if (bundle) {
            printer.writeBundle(bundle, writer, sourceMapGenerator);
          } else {
            printer.writeFile(sourceFile, writer, sourceMapGenerator);
          }
          if (sourceMapGenerator) {
            if (sourceMapDataList) {
              sourceMapDataList.push({
                inputSourceFileNames: sourceMapGenerator.getSources(),
                sourceMap: sourceMapGenerator.toJSON()
              });
            }
            var sourceMappingURL = getSourceMappingURL(mapOptions, sourceMapGenerator, jsFilePath, sourceMapFilePath, sourceFile);
            if (sourceMappingURL) {
              if (!writer.isAtStartOfLine())
                writer.rawWrite(newLine);
              writer.writeComment("//# sourceMappingURL=" + sourceMappingURL);
            }
            if (sourceMapFilePath) {
              var sourceMap = sourceMapGenerator.toString();
              ts2.writeFile(host, emitterDiagnostics, sourceMapFilePath, sourceMap, false, sourceFiles);
            }
          } else {
            writer.writeLine();
          }
          ts2.writeFile(host, emitterDiagnostics, jsFilePath, writer.getText(), !!compilerOptions.emitBOM, sourceFiles);
          writer.clear();
        }
        function shouldEmitSourceMaps(mapOptions, sourceFileOrBundle) {
          return (mapOptions.sourceMap || mapOptions.inlineSourceMap) && (sourceFileOrBundle.kind !== 290 || !ts2.fileExtensionIs(sourceFileOrBundle.fileName, ".json"));
        }
        function getSourceRoot(mapOptions) {
          var sourceRoot = ts2.normalizeSlashes(mapOptions.sourceRoot || "");
          return sourceRoot ? ts2.ensureTrailingDirectorySeparator(sourceRoot) : sourceRoot;
        }
        function getSourceMapDirectory(mapOptions, filePath, sourceFile) {
          if (mapOptions.sourceRoot)
            return host.getCommonSourceDirectory();
          if (mapOptions.mapRoot) {
            var sourceMapDir = ts2.normalizeSlashes(mapOptions.mapRoot);
            if (sourceFile) {
              sourceMapDir = ts2.getDirectoryPath(ts2.getSourceFilePathInNewDir(sourceFile.fileName, host, sourceMapDir));
            }
            if (ts2.getRootLength(sourceMapDir) === 0) {
              sourceMapDir = ts2.combinePaths(host.getCommonSourceDirectory(), sourceMapDir);
            }
            return sourceMapDir;
          }
          return ts2.getDirectoryPath(ts2.normalizePath(filePath));
        }
        function getSourceMappingURL(mapOptions, sourceMapGenerator, filePath, sourceMapFilePath, sourceFile) {
          if (mapOptions.inlineSourceMap) {
            var sourceMapText = sourceMapGenerator.toString();
            var base64SourceMapText = ts2.base64encode(ts2.sys, sourceMapText);
            return "data:application/json;base64," + base64SourceMapText;
          }
          var sourceMapFile = ts2.getBaseFileName(ts2.normalizeSlashes(ts2.Debug.checkDefined(sourceMapFilePath)));
          if (mapOptions.mapRoot) {
            var sourceMapDir = ts2.normalizeSlashes(mapOptions.mapRoot);
            if (sourceFile) {
              sourceMapDir = ts2.getDirectoryPath(ts2.getSourceFilePathInNewDir(sourceFile.fileName, host, sourceMapDir));
            }
            if (ts2.getRootLength(sourceMapDir) === 0) {
              sourceMapDir = ts2.combinePaths(host.getCommonSourceDirectory(), sourceMapDir);
              return ts2.getRelativePathToDirectoryOrUrl(ts2.getDirectoryPath(ts2.normalizePath(filePath)), ts2.combinePaths(sourceMapDir, sourceMapFile), host.getCurrentDirectory(), host.getCanonicalFileName, true);
            } else {
              return ts2.combinePaths(sourceMapDir, sourceMapFile);
            }
          }
          return sourceMapFile;
        }
      }
      ts2.emitFiles = emitFiles;
      function getBuildInfoText(buildInfo) {
        return JSON.stringify(buildInfo, void 0, 2);
      }
      ts2.getBuildInfoText = getBuildInfoText;
      function getBuildInfo(buildInfoText) {
        return JSON.parse(buildInfoText);
      }
      ts2.getBuildInfo = getBuildInfo;
      ts2.notImplementedResolver = {
        hasGlobalName: ts2.notImplemented,
        getReferencedExportContainer: ts2.notImplemented,
        getReferencedImportDeclaration: ts2.notImplemented,
        getReferencedDeclarationWithCollidingName: ts2.notImplemented,
        isDeclarationWithCollidingName: ts2.notImplemented,
        isValueAliasDeclaration: ts2.notImplemented,
        isReferencedAliasDeclaration: ts2.notImplemented,
        isTopLevelValueImportEqualsWithEntityName: ts2.notImplemented,
        getNodeCheckFlags: ts2.notImplemented,
        isDeclarationVisible: ts2.notImplemented,
        isLateBound: function(_node) {
          return false;
        },
        collectLinkedAliases: ts2.notImplemented,
        isImplementationOfOverload: ts2.notImplemented,
        isRequiredInitializedParameter: ts2.notImplemented,
        isOptionalUninitializedParameterProperty: ts2.notImplemented,
        isExpandoFunctionDeclaration: ts2.notImplemented,
        getPropertiesOfContainerFunction: ts2.notImplemented,
        createTypeOfDeclaration: ts2.notImplemented,
        createReturnTypeOfSignatureDeclaration: ts2.notImplemented,
        createTypeOfExpression: ts2.notImplemented,
        createLiteralConstValue: ts2.notImplemented,
        isSymbolAccessible: ts2.notImplemented,
        isEntityNameVisible: ts2.notImplemented,
        getConstantValue: ts2.notImplemented,
        getReferencedValueDeclaration: ts2.notImplemented,
        getTypeReferenceSerializationKind: ts2.notImplemented,
        isOptionalParameter: ts2.notImplemented,
        moduleExportsSomeValue: ts2.notImplemented,
        isArgumentsLocalBinding: ts2.notImplemented,
        getExternalModuleFileFromDeclaration: ts2.notImplemented,
        getTypeReferenceDirectivesForEntityName: ts2.notImplemented,
        getTypeReferenceDirectivesForSymbol: ts2.notImplemented,
        isLiteralConstDeclaration: ts2.notImplemented,
        getJsxFactoryEntity: ts2.notImplemented,
        getAllAccessorDeclarations: ts2.notImplemented,
        getSymbolOfExternalModuleSpecifier: ts2.notImplemented,
        isBindingCapturedByNode: ts2.notImplemented,
        getDeclarationStatementsForSourceFile: ts2.notImplemented,
        isImportRequiredByAugmentation: ts2.notImplemented
      };
      function createSourceFilesFromBundleBuildInfo(bundle, buildInfoDirectory, host) {
        var sourceFiles = bundle.sourceFiles.map(function(fileName) {
          var sourceFile = ts2.createNode(290, 0, 0);
          sourceFile.fileName = ts2.getRelativePathFromDirectory(host.getCurrentDirectory(), ts2.getNormalizedAbsolutePath(fileName, buildInfoDirectory), !host.useCaseSensitiveFileNames());
          sourceFile.text = "";
          sourceFile.statements = ts2.createNodeArray();
          return sourceFile;
        });
        var jsBundle = ts2.Debug.checkDefined(bundle.js);
        ts2.forEach(jsBundle.sources && jsBundle.sources.prologues, function(prologueInfo) {
          var sourceFile = sourceFiles[prologueInfo.file];
          sourceFile.text = prologueInfo.text;
          sourceFile.end = prologueInfo.text.length;
          sourceFile.statements = ts2.createNodeArray(prologueInfo.directives.map(function(directive) {
            var statement = ts2.createNode(226, directive.pos, directive.end);
            statement.expression = ts2.createNode(10, directive.expression.pos, directive.expression.end);
            statement.expression.text = directive.expression.text;
            return statement;
          }));
        });
        return sourceFiles;
      }
      function emitUsingBuildInfo(config, host, getCommandLine, customTransformers) {
        var _a = getOutputPathsForBundle(config.options, false), buildInfoPath = _a.buildInfoPath, jsFilePath = _a.jsFilePath, sourceMapFilePath = _a.sourceMapFilePath, declarationFilePath = _a.declarationFilePath, declarationMapPath = _a.declarationMapPath;
        var buildInfoText = host.readFile(ts2.Debug.checkDefined(buildInfoPath));
        if (!buildInfoText)
          return buildInfoPath;
        var jsFileText = host.readFile(ts2.Debug.checkDefined(jsFilePath));
        if (!jsFileText)
          return jsFilePath;
        var sourceMapText = sourceMapFilePath && host.readFile(sourceMapFilePath);
        if (sourceMapFilePath && !sourceMapText || config.options.inlineSourceMap)
          return sourceMapFilePath || "inline sourcemap decoding";
        var declarationText = declarationFilePath && host.readFile(declarationFilePath);
        if (declarationFilePath && !declarationText)
          return declarationFilePath;
        var declarationMapText = declarationMapPath && host.readFile(declarationMapPath);
        if (declarationMapPath && !declarationMapText || config.options.inlineSourceMap)
          return declarationMapPath || "inline sourcemap decoding";
        var buildInfo = getBuildInfo(buildInfoText);
        if (!buildInfo.bundle || !buildInfo.bundle.js || declarationText && !buildInfo.bundle.dts)
          return buildInfoPath;
        var buildInfoDirectory = ts2.getDirectoryPath(ts2.getNormalizedAbsolutePath(buildInfoPath, host.getCurrentDirectory()));
        var ownPrependInput = ts2.createInputFiles(jsFileText, declarationText, sourceMapFilePath, sourceMapText, declarationMapPath, declarationMapText, jsFilePath, declarationFilePath, buildInfoPath, buildInfo, true);
        var outputFiles = [];
        var prependNodes = ts2.createPrependNodes(config.projectReferences, getCommandLine, function(f) {
          return host.readFile(f);
        });
        var sourceFilesForJsEmit = createSourceFilesFromBundleBuildInfo(buildInfo.bundle, buildInfoDirectory, host);
        var emitHost = {
          getPrependNodes: ts2.memoize(function() {
            return __spreadArrays(prependNodes, [ownPrependInput]);
          }),
          getCanonicalFileName: host.getCanonicalFileName,
          getCommonSourceDirectory: function() {
            return ts2.getNormalizedAbsolutePath(buildInfo.bundle.commonSourceDirectory, buildInfoDirectory);
          },
          getCompilerOptions: function() {
            return config.options;
          },
          getCurrentDirectory: function() {
            return host.getCurrentDirectory();
          },
          getNewLine: function() {
            return host.getNewLine();
          },
          getSourceFile: ts2.returnUndefined,
          getSourceFileByPath: ts2.returnUndefined,
          getSourceFiles: function() {
            return sourceFilesForJsEmit;
          },
          getLibFileFromReference: ts2.notImplemented,
          isSourceFileFromExternalLibrary: ts2.returnFalse,
          getResolvedProjectReferenceToRedirect: ts2.returnUndefined,
          getProjectReferenceRedirect: ts2.returnUndefined,
          isSourceOfProjectReferenceRedirect: ts2.returnFalse,
          writeFile: function(name, text, writeByteOrderMark) {
            switch (name) {
              case jsFilePath:
                if (jsFileText === text)
                  return;
                break;
              case sourceMapFilePath:
                if (sourceMapText === text)
                  return;
                break;
              case buildInfoPath:
                var newBuildInfo = getBuildInfo(text);
                newBuildInfo.program = buildInfo.program;
                var _a2 = buildInfo.bundle, js = _a2.js, dts = _a2.dts, sourceFiles = _a2.sourceFiles;
                newBuildInfo.bundle.js.sources = js.sources;
                if (dts) {
                  newBuildInfo.bundle.dts.sources = dts.sources;
                }
                newBuildInfo.bundle.sourceFiles = sourceFiles;
                outputFiles.push({ name, text: getBuildInfoText(newBuildInfo), writeByteOrderMark });
                return;
              case declarationFilePath:
                if (declarationText === text)
                  return;
                break;
              case declarationMapPath:
                if (declarationMapText === text)
                  return;
                break;
              default:
                ts2.Debug.fail("Unexpected path: " + name);
            }
            outputFiles.push({ name, text, writeByteOrderMark });
          },
          isEmitBlocked: ts2.returnFalse,
          readFile: function(f) {
            return host.readFile(f);
          },
          fileExists: function(f) {
            return host.fileExists(f);
          },
          useCaseSensitiveFileNames: function() {
            return host.useCaseSensitiveFileNames();
          },
          getProgramBuildInfo: ts2.returnUndefined,
          getSourceFileFromReference: ts2.returnUndefined,
          redirectTargetsMap: ts2.createMultiMap()
        };
        emitFiles(ts2.notImplementedResolver, emitHost, void 0, ts2.getTransformers(config.options, customTransformers));
        return outputFiles;
      }
      ts2.emitUsingBuildInfo = emitUsingBuildInfo;
      var PipelinePhase;
      (function(PipelinePhase2) {
        PipelinePhase2[PipelinePhase2["Notification"] = 0] = "Notification";
        PipelinePhase2[PipelinePhase2["Substitution"] = 1] = "Substitution";
        PipelinePhase2[PipelinePhase2["Comments"] = 2] = "Comments";
        PipelinePhase2[PipelinePhase2["SourceMaps"] = 3] = "SourceMaps";
        PipelinePhase2[PipelinePhase2["Emit"] = 4] = "Emit";
      })(PipelinePhase || (PipelinePhase = {}));
      function createPrinter(printerOptions, handlers) {
        if (printerOptions === void 0) {
          printerOptions = {};
        }
        if (handlers === void 0) {
          handlers = {};
        }
        var hasGlobalName = handlers.hasGlobalName, _a = handlers.onEmitNode, onEmitNode = _a === void 0 ? ts2.noEmitNotification : _a, isEmitNotificationEnabled = handlers.isEmitNotificationEnabled, _b = handlers.substituteNode, substituteNode = _b === void 0 ? ts2.noEmitSubstitution : _b, onBeforeEmitNodeArray = handlers.onBeforeEmitNodeArray, onAfterEmitNodeArray = handlers.onAfterEmitNodeArray, onBeforeEmitToken = handlers.onBeforeEmitToken, onAfterEmitToken = handlers.onAfterEmitToken;
        var extendedDiagnostics = !!printerOptions.extendedDiagnostics;
        var newLine = ts2.getNewLineCharacter(printerOptions);
        var moduleKind = ts2.getEmitModuleKind(printerOptions);
        var bundledHelpers = ts2.createMap();
        var currentSourceFile;
        var nodeIdToGeneratedName;
        var autoGeneratedIdToGeneratedName;
        var generatedNames;
        var tempFlagsStack;
        var tempFlags;
        var reservedNamesStack;
        var reservedNames;
        var preserveSourceNewlines = printerOptions.preserveSourceNewlines;
        var writer;
        var ownWriter;
        var write = writeBase;
        var isOwnFileEmit;
        var bundleFileInfo = printerOptions.writeBundleFileInfo ? { sections: [] } : void 0;
        var relativeToBuildInfo = bundleFileInfo ? ts2.Debug.checkDefined(printerOptions.relativeToBuildInfo) : void 0;
        var recordInternalSection = printerOptions.recordInternalSection;
        var sourceFileTextPos = 0;
        var sourceFileTextKind = "text";
        var sourceMapsDisabled = true;
        var sourceMapGenerator;
        var sourceMapSource;
        var sourceMapSourceIndex = -1;
        var containerPos = -1;
        var containerEnd = -1;
        var declarationListContainerEnd = -1;
        var currentLineMap;
        var detachedCommentsInfo;
        var hasWrittenComment = false;
        var commentsDisabled = !!printerOptions.removeComments;
        var lastNode;
        var lastSubstitution;
        var _c = ts2.performance.createTimerIf(extendedDiagnostics, "commentTime", "beforeComment", "afterComment"), enterComment = _c.enter, exitComment = _c.exit;
        reset();
        return {
          printNode,
          printList,
          printFile,
          printBundle,
          writeNode,
          writeList,
          writeFile,
          writeBundle,
          bundleFileInfo
        };
        function printNode(hint, node, sourceFile) {
          switch (hint) {
            case 0:
              ts2.Debug.assert(ts2.isSourceFile(node), "Expected a SourceFile node.");
              break;
            case 2:
              ts2.Debug.assert(ts2.isIdentifier(node), "Expected an Identifier node.");
              break;
            case 1:
              ts2.Debug.assert(ts2.isExpression(node), "Expected an Expression node.");
              break;
          }
          switch (node.kind) {
            case 290:
              return printFile(node);
            case 291:
              return printBundle(node);
            case 292:
              return printUnparsedSource(node);
          }
          writeNode(hint, node, sourceFile, beginPrint());
          return endPrint();
        }
        function printList(format, nodes, sourceFile) {
          writeList(format, nodes, sourceFile, beginPrint());
          return endPrint();
        }
        function printBundle(bundle) {
          writeBundle(bundle, beginPrint(), void 0);
          return endPrint();
        }
        function printFile(sourceFile) {
          writeFile(sourceFile, beginPrint(), void 0);
          return endPrint();
        }
        function printUnparsedSource(unparsed) {
          writeUnparsedSource(unparsed, beginPrint());
          return endPrint();
        }
        function writeNode(hint, node, sourceFile, output) {
          var previousWriter = writer;
          setWriter(output, void 0);
          print(hint, node, sourceFile);
          reset();
          writer = previousWriter;
        }
        function writeList(format, nodes, sourceFile, output) {
          var previousWriter = writer;
          setWriter(output, void 0);
          if (sourceFile) {
            setSourceFile(sourceFile);
          }
          emitList(syntheticParent, nodes, format);
          reset();
          writer = previousWriter;
        }
        function getTextPosWithWriteLine() {
          return writer.getTextPosWithWriteLine ? writer.getTextPosWithWriteLine() : writer.getTextPos();
        }
        function updateOrPushBundleFileTextLike(pos, end, kind) {
          var last = ts2.lastOrUndefined(bundleFileInfo.sections);
          if (last && last.kind === kind) {
            last.end = end;
          } else {
            bundleFileInfo.sections.push({ pos, end, kind });
          }
        }
        function recordBundleFileInternalSectionStart(node) {
          if (recordInternalSection && bundleFileInfo && currentSourceFile && (ts2.isDeclaration(node) || ts2.isVariableStatement(node)) && ts2.isInternalDeclaration(node, currentSourceFile) && sourceFileTextKind !== "internal") {
            var prevSourceFileTextKind = sourceFileTextKind;
            recordBundleFileTextLikeSection(writer.getTextPos());
            sourceFileTextPos = getTextPosWithWriteLine();
            sourceFileTextKind = "internal";
            return prevSourceFileTextKind;
          }
          return void 0;
        }
        function recordBundleFileInternalSectionEnd(prevSourceFileTextKind) {
          if (prevSourceFileTextKind) {
            recordBundleFileTextLikeSection(writer.getTextPos());
            sourceFileTextPos = getTextPosWithWriteLine();
            sourceFileTextKind = prevSourceFileTextKind;
          }
        }
        function recordBundleFileTextLikeSection(end) {
          if (sourceFileTextPos < end) {
            updateOrPushBundleFileTextLike(sourceFileTextPos, end, sourceFileTextKind);
            return true;
          }
          return false;
        }
        function writeBundle(bundle, output, sourceMapGenerator2) {
          var _a2;
          isOwnFileEmit = false;
          var previousWriter = writer;
          setWriter(output, sourceMapGenerator2);
          emitShebangIfNeeded(bundle);
          emitPrologueDirectivesIfNeeded(bundle);
          emitHelpers(bundle);
          emitSyntheticTripleSlashReferencesIfNeeded(bundle);
          for (var _b2 = 0, _c2 = bundle.prepends; _b2 < _c2.length; _b2++) {
            var prepend = _c2[_b2];
            writeLine();
            var pos = writer.getTextPos();
            var savedSections = bundleFileInfo && bundleFileInfo.sections;
            if (savedSections)
              bundleFileInfo.sections = [];
            print(4, prepend, void 0);
            if (bundleFileInfo) {
              var newSections = bundleFileInfo.sections;
              bundleFileInfo.sections = savedSections;
              if (prepend.oldFileOfCurrentEmit)
                (_a2 = bundleFileInfo.sections).push.apply(_a2, newSections);
              else {
                newSections.forEach(function(section) {
                  return ts2.Debug.assert(ts2.isBundleFileTextLike(section));
                });
                bundleFileInfo.sections.push({
                  pos,
                  end: writer.getTextPos(),
                  kind: "prepend",
                  data: relativeToBuildInfo(prepend.fileName),
                  texts: newSections
                });
              }
            }
          }
          sourceFileTextPos = getTextPosWithWriteLine();
          for (var _d = 0, _e = bundle.sourceFiles; _d < _e.length; _d++) {
            var sourceFile = _e[_d];
            print(0, sourceFile, sourceFile);
          }
          if (bundleFileInfo && bundle.sourceFiles.length) {
            var end = writer.getTextPos();
            if (recordBundleFileTextLikeSection(end)) {
              var prologues = getPrologueDirectivesFromBundledSourceFiles(bundle);
              if (prologues) {
                if (!bundleFileInfo.sources)
                  bundleFileInfo.sources = {};
                bundleFileInfo.sources.prologues = prologues;
              }
              var helpers = getHelpersFromBundledSourceFiles(bundle);
              if (helpers) {
                if (!bundleFileInfo.sources)
                  bundleFileInfo.sources = {};
                bundleFileInfo.sources.helpers = helpers;
              }
            }
          }
          reset();
          writer = previousWriter;
        }
        function writeUnparsedSource(unparsed, output) {
          var previousWriter = writer;
          setWriter(output, void 0);
          print(4, unparsed, void 0);
          reset();
          writer = previousWriter;
        }
        function writeFile(sourceFile, output, sourceMapGenerator2) {
          isOwnFileEmit = true;
          var previousWriter = writer;
          setWriter(output, sourceMapGenerator2);
          emitShebangIfNeeded(sourceFile);
          emitPrologueDirectivesIfNeeded(sourceFile);
          print(0, sourceFile, sourceFile);
          reset();
          writer = previousWriter;
        }
        function beginPrint() {
          return ownWriter || (ownWriter = ts2.createTextWriter(newLine));
        }
        function endPrint() {
          var text = ownWriter.getText();
          ownWriter.clear();
          return text;
        }
        function print(hint, node, sourceFile) {
          if (sourceFile) {
            setSourceFile(sourceFile);
          }
          pipelineEmit(hint, node);
        }
        function setSourceFile(sourceFile) {
          currentSourceFile = sourceFile;
          currentLineMap = void 0;
          detachedCommentsInfo = void 0;
          if (sourceFile) {
            setSourceMapSource(sourceFile);
          }
        }
        function setWriter(_writer, _sourceMapGenerator) {
          if (_writer && printerOptions.omitTrailingSemicolon) {
            _writer = ts2.getTrailingSemicolonDeferringWriter(_writer);
          }
          writer = _writer;
          sourceMapGenerator = _sourceMapGenerator;
          sourceMapsDisabled = !writer || !sourceMapGenerator;
        }
        function reset() {
          nodeIdToGeneratedName = [];
          autoGeneratedIdToGeneratedName = [];
          generatedNames = ts2.createMap();
          tempFlagsStack = [];
          tempFlags = 0;
          reservedNamesStack = [];
          currentSourceFile = void 0;
          currentLineMap = void 0;
          detachedCommentsInfo = void 0;
          lastNode = void 0;
          lastSubstitution = void 0;
          setWriter(void 0, void 0);
        }
        function getCurrentLineMap() {
          return currentLineMap || (currentLineMap = ts2.getLineStarts(currentSourceFile));
        }
        function emit(node) {
          if (node === void 0)
            return;
          var prevSourceFileTextKind = recordBundleFileInternalSectionStart(node);
          var substitute = pipelineEmit(4, node);
          recordBundleFileInternalSectionEnd(prevSourceFileTextKind);
          return substitute;
        }
        function emitIdentifierName(node) {
          if (node === void 0)
            return;
          return pipelineEmit(2, node);
        }
        function emitExpression(node) {
          if (node === void 0)
            return;
          return pipelineEmit(1, node);
        }
        function emitJsxAttributeValue(node) {
          return pipelineEmit(ts2.isStringLiteral(node) ? 6 : 4, node);
        }
        function pipelineEmit(emitHint, node) {
          var savedLastNode = lastNode;
          var savedLastSubstitution = lastSubstitution;
          var savedPreserveSourceNewlines = preserveSourceNewlines;
          lastNode = node;
          lastSubstitution = void 0;
          if (preserveSourceNewlines && !!(ts2.getEmitFlags(node) & 134217728)) {
            preserveSourceNewlines = false;
          }
          var pipelinePhase = getPipelinePhase(0, emitHint, node);
          pipelinePhase(emitHint, node);
          ts2.Debug.assert(lastNode === node);
          var substitute = lastSubstitution;
          lastNode = savedLastNode;
          lastSubstitution = savedLastSubstitution;
          preserveSourceNewlines = savedPreserveSourceNewlines;
          return substitute || node;
        }
        function getPipelinePhase(phase, emitHint, node) {
          switch (phase) {
            case 0:
              if (onEmitNode !== ts2.noEmitNotification && (!isEmitNotificationEnabled || isEmitNotificationEnabled(node))) {
                return pipelineEmitWithNotification;
              }
            case 1:
              if (substituteNode !== ts2.noEmitSubstitution && (lastSubstitution = substituteNode(emitHint, node)) !== node) {
                return pipelineEmitWithSubstitution;
              }
            case 2:
              if (!commentsDisabled && node.kind !== 290) {
                return pipelineEmitWithComments;
              }
            case 3:
              if (!sourceMapsDisabled && node.kind !== 290 && !ts2.isInJsonFile(node)) {
                return pipelineEmitWithSourceMap;
              }
            case 4:
              return pipelineEmitWithHint;
            default:
              return ts2.Debug.assertNever(phase);
          }
        }
        function getNextPipelinePhase(currentPhase, emitHint, node) {
          return getPipelinePhase(currentPhase + 1, emitHint, node);
        }
        function pipelineEmitWithNotification(hint, node) {
          ts2.Debug.assert(lastNode === node);
          var pipelinePhase = getNextPipelinePhase(0, hint, node);
          onEmitNode(hint, node, pipelinePhase);
          ts2.Debug.assert(lastNode === node);
        }
        function pipelineEmitWithHint(hint, node) {
          ts2.Debug.assert(lastNode === node || lastSubstitution === node);
          if (hint === 0)
            return emitSourceFile(ts2.cast(node, ts2.isSourceFile));
          if (hint === 2)
            return emitIdentifier(ts2.cast(node, ts2.isIdentifier));
          if (hint === 6)
            return emitLiteral(ts2.cast(node, ts2.isStringLiteral), true);
          if (hint === 3)
            return emitMappedTypeParameter(ts2.cast(node, ts2.isTypeParameterDeclaration));
          if (hint === 5) {
            ts2.Debug.assertNode(node, ts2.isEmptyStatement);
            return emitEmptyStatement(true);
          }
          if (hint === 4) {
            if (ts2.isKeyword(node.kind))
              return writeTokenNode(node, writeKeyword);
            switch (node.kind) {
              case 15:
              case 16:
              case 17:
                return emitLiteral(node, false);
              case 292:
              case 286:
                return emitUnparsedSourceOrPrepend(node);
              case 285:
                return writeUnparsedNode(node);
              case 287:
              case 288:
                return emitUnparsedTextLike(node);
              case 289:
                return emitUnparsedSyntheticReference(node);
              case 75:
                return emitIdentifier(node);
              case 76:
                return emitPrivateIdentifier(node);
              case 153:
                return emitQualifiedName(node);
              case 154:
                return emitComputedPropertyName(node);
              case 155:
                return emitTypeParameter(node);
              case 156:
                return emitParameter(node);
              case 157:
                return emitDecorator(node);
              case 158:
                return emitPropertySignature(node);
              case 159:
                return emitPropertyDeclaration(node);
              case 160:
                return emitMethodSignature(node);
              case 161:
                return emitMethodDeclaration(node);
              case 162:
                return emitConstructor(node);
              case 163:
              case 164:
                return emitAccessorDeclaration(node);
              case 165:
                return emitCallSignature(node);
              case 166:
                return emitConstructSignature(node);
              case 167:
                return emitIndexSignature(node);
              case 168:
                return emitTypePredicate(node);
              case 169:
                return emitTypeReference(node);
              case 170:
                return emitFunctionType(node);
              case 300:
                return emitJSDocFunctionType(node);
              case 171:
                return emitConstructorType(node);
              case 172:
                return emitTypeQuery(node);
              case 173:
                return emitTypeLiteral(node);
              case 174:
                return emitArrayType(node);
              case 175:
                return emitTupleType(node);
              case 176:
                return emitOptionalType(node);
              case 178:
                return emitUnionType(node);
              case 179:
                return emitIntersectionType(node);
              case 180:
                return emitConditionalType(node);
              case 181:
                return emitInferType(node);
              case 182:
                return emitParenthesizedType(node);
              case 216:
                return emitExpressionWithTypeArguments(node);
              case 183:
                return emitThisType();
              case 184:
                return emitTypeOperator(node);
              case 185:
                return emitIndexedAccessType(node);
              case 186:
                return emitMappedType(node);
              case 187:
                return emitLiteralType(node);
              case 188:
                return emitImportTypeNode(node);
              case 295:
                writePunctuation("*");
                return;
              case 296:
                writePunctuation("?");
                return;
              case 297:
                return emitJSDocNullableType(node);
              case 298:
                return emitJSDocNonNullableType(node);
              case 299:
                return emitJSDocOptionalType(node);
              case 177:
              case 301:
                return emitRestOrJSDocVariadicType(node);
              case 189:
                return emitObjectBindingPattern(node);
              case 190:
                return emitArrayBindingPattern(node);
              case 191:
                return emitBindingElement(node);
              case 221:
                return emitTemplateSpan(node);
              case 222:
                return emitSemicolonClassElement();
              case 223:
                return emitBlock(node);
              case 225:
                return emitVariableStatement(node);
              case 224:
                return emitEmptyStatement(false);
              case 226:
                return emitExpressionStatement(node);
              case 227:
                return emitIfStatement(node);
              case 228:
                return emitDoStatement(node);
              case 229:
                return emitWhileStatement(node);
              case 230:
                return emitForStatement(node);
              case 231:
                return emitForInStatement(node);
              case 232:
                return emitForOfStatement(node);
              case 233:
                return emitContinueStatement(node);
              case 234:
                return emitBreakStatement(node);
              case 235:
                return emitReturnStatement(node);
              case 236:
                return emitWithStatement(node);
              case 237:
                return emitSwitchStatement(node);
              case 238:
                return emitLabeledStatement(node);
              case 239:
                return emitThrowStatement(node);
              case 240:
                return emitTryStatement(node);
              case 241:
                return emitDebuggerStatement(node);
              case 242:
                return emitVariableDeclaration(node);
              case 243:
                return emitVariableDeclarationList(node);
              case 244:
                return emitFunctionDeclaration(node);
              case 245:
                return emitClassDeclaration(node);
              case 246:
                return emitInterfaceDeclaration(node);
              case 247:
                return emitTypeAliasDeclaration(node);
              case 248:
                return emitEnumDeclaration(node);
              case 249:
                return emitModuleDeclaration(node);
              case 250:
                return emitModuleBlock(node);
              case 251:
                return emitCaseBlock(node);
              case 252:
                return emitNamespaceExportDeclaration(node);
              case 253:
                return emitImportEqualsDeclaration(node);
              case 254:
                return emitImportDeclaration(node);
              case 255:
                return emitImportClause(node);
              case 256:
                return emitNamespaceImport(node);
              case 262:
                return emitNamespaceExport(node);
              case 257:
                return emitNamedImports(node);
              case 258:
                return emitImportSpecifier(node);
              case 259:
                return emitExportAssignment(node);
              case 260:
                return emitExportDeclaration(node);
              case 261:
                return emitNamedExports(node);
              case 263:
                return emitExportSpecifier(node);
              case 264:
                return;
              case 265:
                return emitExternalModuleReference(node);
              case 11:
                return emitJsxText(node);
              case 268:
              case 271:
                return emitJsxOpeningElementOrFragment(node);
              case 269:
              case 272:
                return emitJsxClosingElementOrFragment(node);
              case 273:
                return emitJsxAttribute(node);
              case 274:
                return emitJsxAttributes(node);
              case 275:
                return emitJsxSpreadAttribute(node);
              case 276:
                return emitJsxExpression(node);
              case 277:
                return emitCaseClause(node);
              case 278:
                return emitDefaultClause(node);
              case 279:
                return emitHeritageClause(node);
              case 280:
                return emitCatchClause(node);
              case 281:
                return emitPropertyAssignment(node);
              case 282:
                return emitShorthandPropertyAssignment(node);
              case 283:
                return emitSpreadAssignment(node);
              case 284:
                return emitEnumMember(node);
              case 317:
              case 323:
                return emitJSDocPropertyLikeTag(node);
              case 318:
              case 320:
              case 319:
              case 316:
                return emitJSDocSimpleTypedTag(node);
              case 308:
              case 307:
                return emitJSDocHeritageTag(node);
              case 321:
                return emitJSDocTemplateTag(node);
              case 322:
                return emitJSDocTypedefTag(node);
              case 315:
                return emitJSDocCallbackTag(node);
              case 305:
                return emitJSDocSignature(node);
              case 304:
                return emitJSDocTypeLiteral(node);
              case 310:
              case 306:
                return emitJSDocSimpleTag(node);
              case 303:
                return emitJSDoc(node);
            }
            if (ts2.isExpression(node)) {
              hint = 1;
              if (substituteNode !== ts2.noEmitSubstitution) {
                lastSubstitution = node = substituteNode(hint, node);
              }
            } else if (ts2.isToken(node)) {
              return writeTokenNode(node, writePunctuation);
            }
          }
          if (hint === 1) {
            switch (node.kind) {
              case 8:
              case 9:
                return emitNumericOrBigIntLiteral(node);
              case 10:
              case 13:
              case 14:
                return emitLiteral(node, false);
              case 75:
                return emitIdentifier(node);
              case 91:
              case 100:
              case 102:
              case 106:
              case 104:
              case 96:
                writeTokenNode(node, writeKeyword);
                return;
              case 192:
                return emitArrayLiteralExpression(node);
              case 193:
                return emitObjectLiteralExpression(node);
              case 194:
                return emitPropertyAccessExpression(node);
              case 195:
                return emitElementAccessExpression(node);
              case 196:
                return emitCallExpression(node);
              case 197:
                return emitNewExpression(node);
              case 198:
                return emitTaggedTemplateExpression(node);
              case 199:
                return emitTypeAssertionExpression(node);
              case 200:
                return emitParenthesizedExpression(node);
              case 201:
                return emitFunctionExpression(node);
              case 202:
                return emitArrowFunction(node);
              case 203:
                return emitDeleteExpression(node);
              case 204:
                return emitTypeOfExpression(node);
              case 205:
                return emitVoidExpression(node);
              case 206:
                return emitAwaitExpression(node);
              case 207:
                return emitPrefixUnaryExpression(node);
              case 208:
                return emitPostfixUnaryExpression(node);
              case 209:
                return emitBinaryExpression(node);
              case 210:
                return emitConditionalExpression(node);
              case 211:
                return emitTemplateExpression(node);
              case 212:
                return emitYieldExpression(node);
              case 213:
                return emitSpreadExpression(node);
              case 214:
                return emitClassExpression(node);
              case 215:
                return;
              case 217:
                return emitAsExpression(node);
              case 218:
                return emitNonNullExpression(node);
              case 219:
                return emitMetaProperty(node);
              case 266:
                return emitJsxElement(node);
              case 267:
                return emitJsxSelfClosingElement(node);
              case 270:
                return emitJsxFragment(node);
              case 326:
                return emitPartiallyEmittedExpression(node);
              case 327:
                return emitCommaList(node);
            }
          }
        }
        function emitMappedTypeParameter(node) {
          emit(node.name);
          writeSpace();
          writeKeyword("in");
          writeSpace();
          emit(node.constraint);
        }
        function pipelineEmitWithSubstitution(hint, node) {
          ts2.Debug.assert(lastNode === node || lastSubstitution === node);
          var pipelinePhase = getNextPipelinePhase(1, hint, node);
          pipelinePhase(hint, lastSubstitution);
          ts2.Debug.assert(lastNode === node || lastSubstitution === node);
        }
        function getHelpersFromBundledSourceFiles(bundle) {
          var result;
          if (moduleKind === ts2.ModuleKind.None || printerOptions.noEmitHelpers) {
            return void 0;
          }
          var bundledHelpers2 = ts2.createMap();
          for (var _a2 = 0, _b2 = bundle.sourceFiles; _a2 < _b2.length; _a2++) {
            var sourceFile = _b2[_a2];
            var shouldSkip = ts2.getExternalHelpersModuleName(sourceFile) !== void 0;
            var helpers = getSortedEmitHelpers(sourceFile);
            if (!helpers)
              continue;
            for (var _c2 = 0, helpers_4 = helpers; _c2 < helpers_4.length; _c2++) {
              var helper = helpers_4[_c2];
              if (!helper.scoped && !shouldSkip && !bundledHelpers2.get(helper.name)) {
                bundledHelpers2.set(helper.name, true);
                (result || (result = [])).push(helper.name);
              }
            }
          }
          return result;
        }
        function emitHelpers(node) {
          var helpersEmitted = false;
          var bundle = node.kind === 291 ? node : void 0;
          if (bundle && moduleKind === ts2.ModuleKind.None) {
            return;
          }
          var numPrepends = bundle ? bundle.prepends.length : 0;
          var numNodes = bundle ? bundle.sourceFiles.length + numPrepends : 1;
          for (var i = 0; i < numNodes; i++) {
            var currentNode = bundle ? i < numPrepends ? bundle.prepends[i] : bundle.sourceFiles[i - numPrepends] : node;
            var sourceFile = ts2.isSourceFile(currentNode) ? currentNode : ts2.isUnparsedSource(currentNode) ? void 0 : currentSourceFile;
            var shouldSkip = printerOptions.noEmitHelpers || !!sourceFile && ts2.hasRecordedExternalHelpers(sourceFile);
            var shouldBundle = (ts2.isSourceFile(currentNode) || ts2.isUnparsedSource(currentNode)) && !isOwnFileEmit;
            var helpers = ts2.isUnparsedSource(currentNode) ? currentNode.helpers : getSortedEmitHelpers(currentNode);
            if (helpers) {
              for (var _a2 = 0, helpers_5 = helpers; _a2 < helpers_5.length; _a2++) {
                var helper = helpers_5[_a2];
                if (!helper.scoped) {
                  if (shouldSkip)
                    continue;
                  if (shouldBundle) {
                    if (bundledHelpers.get(helper.name)) {
                      continue;
                    }
                    bundledHelpers.set(helper.name, true);
                  }
                } else if (bundle) {
                  continue;
                }
                var pos = getTextPosWithWriteLine();
                if (typeof helper.text === "string") {
                  writeLines(helper.text);
                } else {
                  writeLines(helper.text(makeFileLevelOptimisticUniqueName));
                }
                if (bundleFileInfo)
                  bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "emitHelpers", data: helper.name });
                helpersEmitted = true;
              }
            }
          }
          return helpersEmitted;
        }
        function getSortedEmitHelpers(node) {
          var helpers = ts2.getEmitHelpers(node);
          return helpers && ts2.stableSort(helpers, ts2.compareEmitHelpers);
        }
        function emitNumericOrBigIntLiteral(node) {
          emitLiteral(node, false);
        }
        function emitLiteral(node, jsxAttributeEscape) {
          var text = getLiteralTextOfNode(node, printerOptions.neverAsciiEscape, jsxAttributeEscape);
          if ((printerOptions.sourceMap || printerOptions.inlineSourceMap) && (node.kind === 10 || ts2.isTemplateLiteralKind(node.kind))) {
            writeLiteral(text);
          } else {
            writeStringLiteral(text);
          }
        }
        function emitUnparsedSourceOrPrepend(unparsed) {
          for (var _a2 = 0, _b2 = unparsed.texts; _a2 < _b2.length; _a2++) {
            var text = _b2[_a2];
            writeLine();
            emit(text);
          }
        }
        function writeUnparsedNode(unparsed) {
          writer.rawWrite(unparsed.parent.text.substring(unparsed.pos, unparsed.end));
        }
        function emitUnparsedTextLike(unparsed) {
          var pos = getTextPosWithWriteLine();
          writeUnparsedNode(unparsed);
          if (bundleFileInfo) {
            updateOrPushBundleFileTextLike(pos, writer.getTextPos(), unparsed.kind === 287 ? "text" : "internal");
          }
        }
        function emitUnparsedSyntheticReference(unparsed) {
          var pos = getTextPosWithWriteLine();
          writeUnparsedNode(unparsed);
          if (bundleFileInfo) {
            var section = ts2.clone(unparsed.section);
            section.pos = pos;
            section.end = writer.getTextPos();
            bundleFileInfo.sections.push(section);
          }
        }
        function emitIdentifier(node) {
          var writeText = node.symbol ? writeSymbol : write;
          writeText(getTextOfNode(node, false), node.symbol);
          emitList(node, node.typeArguments, 53776);
        }
        function emitPrivateIdentifier(node) {
          var writeText = node.symbol ? writeSymbol : write;
          writeText(getTextOfNode(node, false), node.symbol);
        }
        function emitQualifiedName(node) {
          emitEntityName(node.left);
          writePunctuation(".");
          emit(node.right);
        }
        function emitEntityName(node) {
          if (node.kind === 75) {
            emitExpression(node);
          } else {
            emit(node);
          }
        }
        function emitComputedPropertyName(node) {
          writePunctuation("[");
          emitExpression(node.expression);
          writePunctuation("]");
        }
        function emitTypeParameter(node) {
          emit(node.name);
          if (node.constraint) {
            writeSpace();
            writeKeyword("extends");
            writeSpace();
            emit(node.constraint);
          }
          if (node.default) {
            writeSpace();
            writeOperator("=");
            writeSpace();
            emit(node.default);
          }
        }
        function emitParameter(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emit(node.dotDotDotToken);
          emitNodeWithWriter(node.name, writeParameter);
          emit(node.questionToken);
          if (node.parent && node.parent.kind === 300 && !node.name) {
            emit(node.type);
          } else {
            emitTypeAnnotation(node.type);
          }
          emitInitializer(node.initializer, node.type ? node.type.end : node.questionToken ? node.questionToken.end : node.name ? node.name.end : node.modifiers ? node.modifiers.end : node.decorators ? node.decorators.end : node.pos, node);
        }
        function emitDecorator(decorator) {
          writePunctuation("@");
          emitExpression(decorator.expression);
        }
        function emitPropertySignature(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emitNodeWithWriter(node.name, writeProperty);
          emit(node.questionToken);
          emitTypeAnnotation(node.type);
          writeTrailingSemicolon();
        }
        function emitPropertyDeclaration(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emit(node.name);
          emit(node.questionToken);
          emit(node.exclamationToken);
          emitTypeAnnotation(node.type);
          emitInitializer(node.initializer, node.type ? node.type.end : node.questionToken ? node.questionToken.end : node.name.end, node);
          writeTrailingSemicolon();
        }
        function emitMethodSignature(node) {
          pushNameGenerationScope(node);
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emit(node.name);
          emit(node.questionToken);
          emitTypeParameters(node, node.typeParameters);
          emitParameters(node, node.parameters);
          emitTypeAnnotation(node.type);
          writeTrailingSemicolon();
          popNameGenerationScope(node);
        }
        function emitMethodDeclaration(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emit(node.asteriskToken);
          emit(node.name);
          emit(node.questionToken);
          emitSignatureAndBody(node, emitSignatureHead);
        }
        function emitConstructor(node) {
          emitModifiers(node, node.modifiers);
          writeKeyword("constructor");
          emitSignatureAndBody(node, emitSignatureHead);
        }
        function emitAccessorDeclaration(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          writeKeyword(node.kind === 163 ? "get" : "set");
          writeSpace();
          emit(node.name);
          emitSignatureAndBody(node, emitSignatureHead);
        }
        function emitCallSignature(node) {
          pushNameGenerationScope(node);
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emitTypeParameters(node, node.typeParameters);
          emitParameters(node, node.parameters);
          emitTypeAnnotation(node.type);
          writeTrailingSemicolon();
          popNameGenerationScope(node);
        }
        function emitConstructSignature(node) {
          pushNameGenerationScope(node);
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          writeKeyword("new");
          writeSpace();
          emitTypeParameters(node, node.typeParameters);
          emitParameters(node, node.parameters);
          emitTypeAnnotation(node.type);
          writeTrailingSemicolon();
          popNameGenerationScope(node);
        }
        function emitIndexSignature(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emitParametersForIndexSignature(node, node.parameters);
          emitTypeAnnotation(node.type);
          writeTrailingSemicolon();
        }
        function emitSemicolonClassElement() {
          writeTrailingSemicolon();
        }
        function emitTypePredicate(node) {
          if (node.assertsModifier) {
            emit(node.assertsModifier);
            writeSpace();
          }
          emit(node.parameterName);
          if (node.type) {
            writeSpace();
            writeKeyword("is");
            writeSpace();
            emit(node.type);
          }
        }
        function emitTypeReference(node) {
          emit(node.typeName);
          emitTypeArguments(node, node.typeArguments);
        }
        function emitFunctionType(node) {
          pushNameGenerationScope(node);
          emitTypeParameters(node, node.typeParameters);
          emitParametersForArrow(node, node.parameters);
          writeSpace();
          writePunctuation("=>");
          writeSpace();
          emit(node.type);
          popNameGenerationScope(node);
        }
        function emitJSDocFunctionType(node) {
          writeKeyword("function");
          emitParameters(node, node.parameters);
          writePunctuation(":");
          emit(node.type);
        }
        function emitJSDocNullableType(node) {
          writePunctuation("?");
          emit(node.type);
        }
        function emitJSDocNonNullableType(node) {
          writePunctuation("!");
          emit(node.type);
        }
        function emitJSDocOptionalType(node) {
          emit(node.type);
          writePunctuation("=");
        }
        function emitConstructorType(node) {
          pushNameGenerationScope(node);
          writeKeyword("new");
          writeSpace();
          emitTypeParameters(node, node.typeParameters);
          emitParameters(node, node.parameters);
          writeSpace();
          writePunctuation("=>");
          writeSpace();
          emit(node.type);
          popNameGenerationScope(node);
        }
        function emitTypeQuery(node) {
          writeKeyword("typeof");
          writeSpace();
          emit(node.exprName);
        }
        function emitTypeLiteral(node) {
          writePunctuation("{");
          var flags = ts2.getEmitFlags(node) & 1 ? 768 : 32897;
          emitList(node, node.members, flags | 524288);
          writePunctuation("}");
        }
        function emitArrayType(node) {
          emit(node.elementType);
          writePunctuation("[");
          writePunctuation("]");
        }
        function emitRestOrJSDocVariadicType(node) {
          writePunctuation("...");
          emit(node.type);
        }
        function emitTupleType(node) {
          writePunctuation("[");
          emitList(node, node.elementTypes, 528);
          writePunctuation("]");
        }
        function emitOptionalType(node) {
          emit(node.type);
          writePunctuation("?");
        }
        function emitUnionType(node) {
          emitList(node, node.types, 516);
        }
        function emitIntersectionType(node) {
          emitList(node, node.types, 520);
        }
        function emitConditionalType(node) {
          emit(node.checkType);
          writeSpace();
          writeKeyword("extends");
          writeSpace();
          emit(node.extendsType);
          writeSpace();
          writePunctuation("?");
          writeSpace();
          emit(node.trueType);
          writeSpace();
          writePunctuation(":");
          writeSpace();
          emit(node.falseType);
        }
        function emitInferType(node) {
          writeKeyword("infer");
          writeSpace();
          emit(node.typeParameter);
        }
        function emitParenthesizedType(node) {
          writePunctuation("(");
          emit(node.type);
          writePunctuation(")");
        }
        function emitThisType() {
          writeKeyword("this");
        }
        function emitTypeOperator(node) {
          writeTokenText(node.operator, writeKeyword);
          writeSpace();
          emit(node.type);
        }
        function emitIndexedAccessType(node) {
          emit(node.objectType);
          writePunctuation("[");
          emit(node.indexType);
          writePunctuation("]");
        }
        function emitMappedType(node) {
          var emitFlags = ts2.getEmitFlags(node);
          writePunctuation("{");
          if (emitFlags & 1) {
            writeSpace();
          } else {
            writeLine();
            increaseIndent();
          }
          if (node.readonlyToken) {
            emit(node.readonlyToken);
            if (node.readonlyToken.kind !== 138) {
              writeKeyword("readonly");
            }
            writeSpace();
          }
          writePunctuation("[");
          pipelineEmit(3, node.typeParameter);
          writePunctuation("]");
          if (node.questionToken) {
            emit(node.questionToken);
            if (node.questionToken.kind !== 57) {
              writePunctuation("?");
            }
          }
          writePunctuation(":");
          writeSpace();
          emit(node.type);
          writeTrailingSemicolon();
          if (emitFlags & 1) {
            writeSpace();
          } else {
            writeLine();
            decreaseIndent();
          }
          writePunctuation("}");
        }
        function emitLiteralType(node) {
          emitExpression(node.literal);
        }
        function emitImportTypeNode(node) {
          if (node.isTypeOf) {
            writeKeyword("typeof");
            writeSpace();
          }
          writeKeyword("import");
          writePunctuation("(");
          emit(node.argument);
          writePunctuation(")");
          if (node.qualifier) {
            writePunctuation(".");
            emit(node.qualifier);
          }
          emitTypeArguments(node, node.typeArguments);
        }
        function emitObjectBindingPattern(node) {
          writePunctuation("{");
          emitList(node, node.elements, 525136);
          writePunctuation("}");
        }
        function emitArrayBindingPattern(node) {
          writePunctuation("[");
          emitList(node, node.elements, 524880);
          writePunctuation("]");
        }
        function emitBindingElement(node) {
          emit(node.dotDotDotToken);
          if (node.propertyName) {
            emit(node.propertyName);
            writePunctuation(":");
            writeSpace();
          }
          emit(node.name);
          emitInitializer(node.initializer, node.name.end, node);
        }
        function emitArrayLiteralExpression(node) {
          var elements = node.elements;
          var preferNewLine = node.multiLine ? 65536 : 0;
          emitExpressionList(node, elements, 8914 | preferNewLine);
        }
        function emitObjectLiteralExpression(node) {
          ts2.forEach(node.properties, generateMemberNames);
          var indentedFlag = ts2.getEmitFlags(node) & 65536;
          if (indentedFlag) {
            increaseIndent();
          }
          var preferNewLine = node.multiLine ? 65536 : 0;
          var allowTrailingComma = currentSourceFile.languageVersion >= 1 && !ts2.isJsonSourceFile(currentSourceFile) ? 64 : 0;
          emitList(node, node.properties, 526226 | allowTrailingComma | preferNewLine);
          if (indentedFlag) {
            decreaseIndent();
          }
        }
        function emitPropertyAccessExpression(node) {
          var expression = ts2.cast(emitExpression(node.expression), ts2.isExpression);
          var token = node.questionDotToken || ts2.createNode(24, node.expression.end, node.name.pos);
          var linesBeforeDot = getLinesBetweenNodes(node, node.expression, token);
          var linesAfterDot = getLinesBetweenNodes(node, token, node.name);
          writeLinesAndIndent(linesBeforeDot, false);
          var shouldEmitDotDot = token.kind !== 28 && mayNeedDotDotForPropertyAccess(expression) && !writer.hasTrailingComment() && !writer.hasTrailingWhitespace();
          if (shouldEmitDotDot) {
            writePunctuation(".");
          }
          if (node.questionDotToken) {
            emit(token);
          } else {
            emitTokenWithComment(token.kind, node.expression.end, writePunctuation, node);
          }
          writeLinesAndIndent(linesAfterDot, false);
          emit(node.name);
          decreaseIndentIf(linesBeforeDot, linesAfterDot);
        }
        function mayNeedDotDotForPropertyAccess(expression) {
          expression = ts2.skipPartiallyEmittedExpressions(expression);
          if (ts2.isNumericLiteral(expression)) {
            var text = getLiteralTextOfNode(expression, true, false);
            return !expression.numericLiteralFlags && !ts2.stringContains(text, ts2.tokenToString(24));
          } else if (ts2.isAccessExpression(expression)) {
            var constantValue = ts2.getConstantValue(expression);
            return typeof constantValue === "number" && isFinite(constantValue) && Math.floor(constantValue) === constantValue;
          }
        }
        function emitElementAccessExpression(node) {
          emitExpression(node.expression);
          emit(node.questionDotToken);
          emitTokenWithComment(22, node.expression.end, writePunctuation, node);
          emitExpression(node.argumentExpression);
          emitTokenWithComment(23, node.argumentExpression.end, writePunctuation, node);
        }
        function emitCallExpression(node) {
          emitExpression(node.expression);
          emit(node.questionDotToken);
          emitTypeArguments(node, node.typeArguments);
          emitExpressionList(node, node.arguments, 2576);
        }
        function emitNewExpression(node) {
          emitTokenWithComment(99, node.pos, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression);
          emitTypeArguments(node, node.typeArguments);
          emitExpressionList(node, node.arguments, 18960);
        }
        function emitTaggedTemplateExpression(node) {
          emitExpression(node.tag);
          emitTypeArguments(node, node.typeArguments);
          writeSpace();
          emitExpression(node.template);
        }
        function emitTypeAssertionExpression(node) {
          writePunctuation("<");
          emit(node.type);
          writePunctuation(">");
          emitExpression(node.expression);
        }
        function emitParenthesizedExpression(node) {
          var openParenPos = emitTokenWithComment(20, node.pos, writePunctuation, node);
          var indented = writeLineSeparatorsAndIndentBefore(node.expression, node);
          emitExpression(node.expression);
          writeLineSeparatorsAfter(node.expression, node);
          decreaseIndentIf(indented);
          emitTokenWithComment(21, node.expression ? node.expression.end : openParenPos, writePunctuation, node);
        }
        function emitFunctionExpression(node) {
          generateNameIfNeeded(node.name);
          emitFunctionDeclarationOrExpression(node);
        }
        function emitArrowFunction(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          emitSignatureAndBody(node, emitArrowFunctionHead);
        }
        function emitArrowFunctionHead(node) {
          emitTypeParameters(node, node.typeParameters);
          emitParametersForArrow(node, node.parameters);
          emitTypeAnnotation(node.type);
          writeSpace();
          emit(node.equalsGreaterThanToken);
        }
        function emitDeleteExpression(node) {
          emitTokenWithComment(85, node.pos, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression);
        }
        function emitTypeOfExpression(node) {
          emitTokenWithComment(108, node.pos, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression);
        }
        function emitVoidExpression(node) {
          emitTokenWithComment(110, node.pos, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression);
        }
        function emitAwaitExpression(node) {
          emitTokenWithComment(127, node.pos, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression);
        }
        function emitPrefixUnaryExpression(node) {
          writeTokenText(node.operator, writeOperator);
          if (shouldEmitWhitespaceBeforeOperand(node)) {
            writeSpace();
          }
          emitExpression(node.operand);
        }
        function shouldEmitWhitespaceBeforeOperand(node) {
          var operand = node.operand;
          return operand.kind === 207 && (node.operator === 39 && (operand.operator === 39 || operand.operator === 45) || node.operator === 40 && (operand.operator === 40 || operand.operator === 46));
        }
        function emitPostfixUnaryExpression(node) {
          emitExpression(node.operand);
          writeTokenText(node.operator, writeOperator);
        }
        var EmitBinaryExpressionState;
        (function(EmitBinaryExpressionState2) {
          EmitBinaryExpressionState2[EmitBinaryExpressionState2["EmitLeft"] = 0] = "EmitLeft";
          EmitBinaryExpressionState2[EmitBinaryExpressionState2["EmitRight"] = 1] = "EmitRight";
          EmitBinaryExpressionState2[EmitBinaryExpressionState2["FinishEmit"] = 2] = "FinishEmit";
        })(EmitBinaryExpressionState || (EmitBinaryExpressionState = {}));
        function emitBinaryExpression(node) {
          var nodeStack = [node];
          var stateStack = [0];
          var stackIndex = 0;
          while (stackIndex >= 0) {
            node = nodeStack[stackIndex];
            switch (stateStack[stackIndex]) {
              case 0: {
                maybePipelineEmitExpression(node.left);
                break;
              }
              case 1: {
                var isCommaOperator = node.operatorToken.kind !== 27;
                var linesBeforeOperator = getLinesBetweenNodes(node, node.left, node.operatorToken);
                var linesAfterOperator = getLinesBetweenNodes(node, node.operatorToken, node.right);
                writeLinesAndIndent(linesBeforeOperator, isCommaOperator);
                emitLeadingCommentsOfPosition(node.operatorToken.pos);
                writeTokenNode(node.operatorToken, node.operatorToken.kind === 97 ? writeKeyword : writeOperator);
                emitTrailingCommentsOfPosition(node.operatorToken.end, true);
                writeLinesAndIndent(linesAfterOperator, true);
                maybePipelineEmitExpression(node.right);
                break;
              }
              case 2: {
                var linesBeforeOperator = getLinesBetweenNodes(node, node.left, node.operatorToken);
                var linesAfterOperator = getLinesBetweenNodes(node, node.operatorToken, node.right);
                decreaseIndentIf(linesBeforeOperator, linesAfterOperator);
                stackIndex--;
                break;
              }
              default:
                return ts2.Debug.fail("Invalid state " + stateStack[stackIndex] + " for emitBinaryExpressionWorker");
            }
          }
          function maybePipelineEmitExpression(next) {
            stateStack[stackIndex]++;
            var savedLastNode = lastNode;
            var savedLastSubstitution = lastSubstitution;
            lastNode = next;
            lastSubstitution = void 0;
            var pipelinePhase = getPipelinePhase(0, 1, next);
            if (pipelinePhase === pipelineEmitWithHint && ts2.isBinaryExpression(next)) {
              stackIndex++;
              stateStack[stackIndex] = 0;
              nodeStack[stackIndex] = next;
            } else {
              pipelinePhase(1, next);
            }
            ts2.Debug.assert(lastNode === next);
            lastNode = savedLastNode;
            lastSubstitution = savedLastSubstitution;
          }
        }
        function emitConditionalExpression(node) {
          var linesBeforeQuestion = getLinesBetweenNodes(node, node.condition, node.questionToken);
          var linesAfterQuestion = getLinesBetweenNodes(node, node.questionToken, node.whenTrue);
          var linesBeforeColon = getLinesBetweenNodes(node, node.whenTrue, node.colonToken);
          var linesAfterColon = getLinesBetweenNodes(node, node.colonToken, node.whenFalse);
          emitExpression(node.condition);
          writeLinesAndIndent(linesBeforeQuestion, true);
          emit(node.questionToken);
          writeLinesAndIndent(linesAfterQuestion, true);
          emitExpression(node.whenTrue);
          decreaseIndentIf(linesBeforeQuestion, linesAfterQuestion);
          writeLinesAndIndent(linesBeforeColon, true);
          emit(node.colonToken);
          writeLinesAndIndent(linesAfterColon, true);
          emitExpression(node.whenFalse);
          decreaseIndentIf(linesBeforeColon, linesAfterColon);
        }
        function emitTemplateExpression(node) {
          emit(node.head);
          emitList(node, node.templateSpans, 262144);
        }
        function emitYieldExpression(node) {
          emitTokenWithComment(121, node.pos, writeKeyword, node);
          emit(node.asteriskToken);
          emitExpressionWithLeadingSpace(node.expression);
        }
        function emitSpreadExpression(node) {
          emitTokenWithComment(25, node.pos, writePunctuation, node);
          emitExpression(node.expression);
        }
        function emitClassExpression(node) {
          generateNameIfNeeded(node.name);
          emitClassDeclarationOrExpression(node);
        }
        function emitExpressionWithTypeArguments(node) {
          emitExpression(node.expression);
          emitTypeArguments(node, node.typeArguments);
        }
        function emitAsExpression(node) {
          emitExpression(node.expression);
          if (node.type) {
            writeSpace();
            writeKeyword("as");
            writeSpace();
            emit(node.type);
          }
        }
        function emitNonNullExpression(node) {
          emitExpression(node.expression);
          writeOperator("!");
        }
        function emitMetaProperty(node) {
          writeToken(node.keywordToken, node.pos, writePunctuation);
          writePunctuation(".");
          emit(node.name);
        }
        function emitTemplateSpan(node) {
          emitExpression(node.expression);
          emit(node.literal);
        }
        function emitBlock(node) {
          emitBlockStatements(node, !node.multiLine && isEmptyBlock(node));
        }
        function emitBlockStatements(node, forceSingleLine) {
          emitTokenWithComment(18, node.pos, writePunctuation, node);
          var format = forceSingleLine || ts2.getEmitFlags(node) & 1 ? 768 : 129;
          emitList(node, node.statements, format);
          emitTokenWithComment(19, node.statements.end, writePunctuation, node, !!(format & 1));
        }
        function emitVariableStatement(node) {
          emitModifiers(node, node.modifiers);
          emit(node.declarationList);
          writeTrailingSemicolon();
        }
        function emitEmptyStatement(isEmbeddedStatement) {
          if (isEmbeddedStatement) {
            writePunctuation(";");
          } else {
            writeTrailingSemicolon();
          }
        }
        function emitExpressionStatement(node) {
          emitExpression(node.expression);
          if (!ts2.isJsonSourceFile(currentSourceFile) || ts2.nodeIsSynthesized(node.expression)) {
            writeTrailingSemicolon();
          }
        }
        function emitIfStatement(node) {
          var openParenPos = emitTokenWithComment(95, node.pos, writeKeyword, node);
          writeSpace();
          emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitExpression(node.expression);
          emitTokenWithComment(21, node.expression.end, writePunctuation, node);
          emitEmbeddedStatement(node, node.thenStatement);
          if (node.elseStatement) {
            writeLineOrSpace(node);
            emitTokenWithComment(87, node.thenStatement.end, writeKeyword, node);
            if (node.elseStatement.kind === 227) {
              writeSpace();
              emit(node.elseStatement);
            } else {
              emitEmbeddedStatement(node, node.elseStatement);
            }
          }
        }
        function emitWhileClause(node, startPos) {
          var openParenPos = emitTokenWithComment(111, startPos, writeKeyword, node);
          writeSpace();
          emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitExpression(node.expression);
          emitTokenWithComment(21, node.expression.end, writePunctuation, node);
        }
        function emitDoStatement(node) {
          emitTokenWithComment(86, node.pos, writeKeyword, node);
          emitEmbeddedStatement(node, node.statement);
          if (ts2.isBlock(node.statement)) {
            writeSpace();
          } else {
            writeLineOrSpace(node);
          }
          emitWhileClause(node, node.statement.end);
          writeTrailingSemicolon();
        }
        function emitWhileStatement(node) {
          emitWhileClause(node, node.pos);
          emitEmbeddedStatement(node, node.statement);
        }
        function emitForStatement(node) {
          var openParenPos = emitTokenWithComment(93, node.pos, writeKeyword, node);
          writeSpace();
          var pos = emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitForBinding(node.initializer);
          pos = emitTokenWithComment(26, node.initializer ? node.initializer.end : pos, writePunctuation, node);
          emitExpressionWithLeadingSpace(node.condition);
          pos = emitTokenWithComment(26, node.condition ? node.condition.end : pos, writePunctuation, node);
          emitExpressionWithLeadingSpace(node.incrementor);
          emitTokenWithComment(21, node.incrementor ? node.incrementor.end : pos, writePunctuation, node);
          emitEmbeddedStatement(node, node.statement);
        }
        function emitForInStatement(node) {
          var openParenPos = emitTokenWithComment(93, node.pos, writeKeyword, node);
          writeSpace();
          emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitForBinding(node.initializer);
          writeSpace();
          emitTokenWithComment(97, node.initializer.end, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression);
          emitTokenWithComment(21, node.expression.end, writePunctuation, node);
          emitEmbeddedStatement(node, node.statement);
        }
        function emitForOfStatement(node) {
          var openParenPos = emitTokenWithComment(93, node.pos, writeKeyword, node);
          writeSpace();
          emitWithTrailingSpace(node.awaitModifier);
          emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitForBinding(node.initializer);
          writeSpace();
          emitTokenWithComment(152, node.initializer.end, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression);
          emitTokenWithComment(21, node.expression.end, writePunctuation, node);
          emitEmbeddedStatement(node, node.statement);
        }
        function emitForBinding(node) {
          if (node !== void 0) {
            if (node.kind === 243) {
              emit(node);
            } else {
              emitExpression(node);
            }
          }
        }
        function emitContinueStatement(node) {
          emitTokenWithComment(82, node.pos, writeKeyword, node);
          emitWithLeadingSpace(node.label);
          writeTrailingSemicolon();
        }
        function emitBreakStatement(node) {
          emitTokenWithComment(77, node.pos, writeKeyword, node);
          emitWithLeadingSpace(node.label);
          writeTrailingSemicolon();
        }
        function emitTokenWithComment(token, pos, writer2, contextNode, indentLeading) {
          var node = ts2.getParseTreeNode(contextNode);
          var isSimilarNode = node && node.kind === contextNode.kind;
          var startPos = pos;
          if (isSimilarNode && currentSourceFile) {
            pos = ts2.skipTrivia(currentSourceFile.text, pos);
          }
          if (emitLeadingCommentsOfPosition && isSimilarNode && contextNode.pos !== startPos) {
            var needsIndent = indentLeading && currentSourceFile && !ts2.positionsAreOnSameLine(startPos, pos, currentSourceFile);
            if (needsIndent) {
              increaseIndent();
            }
            emitLeadingCommentsOfPosition(startPos);
            if (needsIndent) {
              decreaseIndent();
            }
          }
          pos = writeTokenText(token, writer2, pos);
          if (emitTrailingCommentsOfPosition && isSimilarNode && contextNode.end !== pos) {
            emitTrailingCommentsOfPosition(pos, true);
          }
          return pos;
        }
        function emitReturnStatement(node) {
          emitTokenWithComment(101, node.pos, writeKeyword, node);
          emitExpressionWithLeadingSpace(node.expression);
          writeTrailingSemicolon();
        }
        function emitWithStatement(node) {
          var openParenPos = emitTokenWithComment(112, node.pos, writeKeyword, node);
          writeSpace();
          emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitExpression(node.expression);
          emitTokenWithComment(21, node.expression.end, writePunctuation, node);
          emitEmbeddedStatement(node, node.statement);
        }
        function emitSwitchStatement(node) {
          var openParenPos = emitTokenWithComment(103, node.pos, writeKeyword, node);
          writeSpace();
          emitTokenWithComment(20, openParenPos, writePunctuation, node);
          emitExpression(node.expression);
          emitTokenWithComment(21, node.expression.end, writePunctuation, node);
          writeSpace();
          emit(node.caseBlock);
        }
        function emitLabeledStatement(node) {
          emit(node.label);
          emitTokenWithComment(58, node.label.end, writePunctuation, node);
          writeSpace();
          emit(node.statement);
        }
        function emitThrowStatement(node) {
          emitTokenWithComment(105, node.pos, writeKeyword, node);
          emitExpressionWithLeadingSpace(node.expression);
          writeTrailingSemicolon();
        }
        function emitTryStatement(node) {
          emitTokenWithComment(107, node.pos, writeKeyword, node);
          writeSpace();
          emit(node.tryBlock);
          if (node.catchClause) {
            writeLineOrSpace(node);
            emit(node.catchClause);
          }
          if (node.finallyBlock) {
            writeLineOrSpace(node);
            emitTokenWithComment(92, (node.catchClause || node.tryBlock).end, writeKeyword, node);
            writeSpace();
            emit(node.finallyBlock);
          }
        }
        function emitDebuggerStatement(node) {
          writeToken(83, node.pos, writeKeyword);
          writeTrailingSemicolon();
        }
        function emitVariableDeclaration(node) {
          emit(node.name);
          emit(node.exclamationToken);
          emitTypeAnnotation(node.type);
          emitInitializer(node.initializer, node.type ? node.type.end : node.name.end, node);
        }
        function emitVariableDeclarationList(node) {
          writeKeyword(ts2.isLet(node) ? "let" : ts2.isVarConst(node) ? "const" : "var");
          writeSpace();
          emitList(node, node.declarations, 528);
        }
        function emitFunctionDeclaration(node) {
          emitFunctionDeclarationOrExpression(node);
        }
        function emitFunctionDeclarationOrExpression(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          writeKeyword("function");
          emit(node.asteriskToken);
          writeSpace();
          emitIdentifierName(node.name);
          emitSignatureAndBody(node, emitSignatureHead);
        }
        function emitBlockCallback(_hint, body) {
          emitBlockFunctionBody(body);
        }
        function emitSignatureAndBody(node, emitSignatureHead2) {
          var body = node.body;
          if (body) {
            if (ts2.isBlock(body)) {
              var indentedFlag = ts2.getEmitFlags(node) & 65536;
              if (indentedFlag) {
                increaseIndent();
              }
              pushNameGenerationScope(node);
              ts2.forEach(node.parameters, generateNames);
              generateNames(node.body);
              emitSignatureHead2(node);
              if (onEmitNode) {
                onEmitNode(4, body, emitBlockCallback);
              } else {
                emitBlockFunctionBody(body);
              }
              popNameGenerationScope(node);
              if (indentedFlag) {
                decreaseIndent();
              }
            } else {
              emitSignatureHead2(node);
              writeSpace();
              emitExpression(body);
            }
          } else {
            emitSignatureHead2(node);
            writeTrailingSemicolon();
          }
        }
        function emitSignatureHead(node) {
          emitTypeParameters(node, node.typeParameters);
          emitParameters(node, node.parameters);
          emitTypeAnnotation(node.type);
        }
        function shouldEmitBlockFunctionBodyOnSingleLine(body) {
          if (ts2.getEmitFlags(body) & 1) {
            return true;
          }
          if (body.multiLine) {
            return false;
          }
          if (!ts2.nodeIsSynthesized(body) && !ts2.rangeIsOnSingleLine(body, currentSourceFile)) {
            return false;
          }
          if (getLeadingLineTerminatorCount(body, body.statements, 2) || getClosingLineTerminatorCount(body, body.statements, 2)) {
            return false;
          }
          var previousStatement;
          for (var _a2 = 0, _b2 = body.statements; _a2 < _b2.length; _a2++) {
            var statement = _b2[_a2];
            if (getSeparatingLineTerminatorCount(previousStatement, statement, 2) > 0) {
              return false;
            }
            previousStatement = statement;
          }
          return true;
        }
        function emitBlockFunctionBody(body) {
          writeSpace();
          writePunctuation("{");
          increaseIndent();
          var emitBlockFunctionBody2 = shouldEmitBlockFunctionBodyOnSingleLine(body) ? emitBlockFunctionBodyOnSingleLine : emitBlockFunctionBodyWorker;
          if (emitBodyWithDetachedComments) {
            emitBodyWithDetachedComments(body, body.statements, emitBlockFunctionBody2);
          } else {
            emitBlockFunctionBody2(body);
          }
          decreaseIndent();
          writeToken(19, body.statements.end, writePunctuation, body);
        }
        function emitBlockFunctionBodyOnSingleLine(body) {
          emitBlockFunctionBodyWorker(body, true);
        }
        function emitBlockFunctionBodyWorker(body, emitBlockFunctionBodyOnSingleLine2) {
          var statementOffset = emitPrologueDirectives(body.statements);
          var pos = writer.getTextPos();
          emitHelpers(body);
          if (statementOffset === 0 && pos === writer.getTextPos() && emitBlockFunctionBodyOnSingleLine2) {
            decreaseIndent();
            emitList(body, body.statements, 768);
            increaseIndent();
          } else {
            emitList(body, body.statements, 1, statementOffset);
          }
        }
        function emitClassDeclaration(node) {
          emitClassDeclarationOrExpression(node);
        }
        function emitClassDeclarationOrExpression(node) {
          ts2.forEach(node.members, generateMemberNames);
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          writeKeyword("class");
          if (node.name) {
            writeSpace();
            emitIdentifierName(node.name);
          }
          var indentedFlag = ts2.getEmitFlags(node) & 65536;
          if (indentedFlag) {
            increaseIndent();
          }
          emitTypeParameters(node, node.typeParameters);
          emitList(node, node.heritageClauses, 0);
          writeSpace();
          writePunctuation("{");
          emitList(node, node.members, 129);
          writePunctuation("}");
          if (indentedFlag) {
            decreaseIndent();
          }
        }
        function emitInterfaceDeclaration(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          writeKeyword("interface");
          writeSpace();
          emit(node.name);
          emitTypeParameters(node, node.typeParameters);
          emitList(node, node.heritageClauses, 512);
          writeSpace();
          writePunctuation("{");
          emitList(node, node.members, 129);
          writePunctuation("}");
        }
        function emitTypeAliasDeclaration(node) {
          emitDecorators(node, node.decorators);
          emitModifiers(node, node.modifiers);
          writeKeyword("type");
          writeSpace();
          emit(node.name);
          emitTypeParameters(node, node.typeParameters);
          writeSpace();
          writePunctuation("=");
          writeSpace();
          emit(node.type);
          writeTrailingSemicolon();
        }
        function emitEnumDeclaration(node) {
          emitModifiers(node, node.modifiers);
          writeKeyword("enum");
          writeSpace();
          emit(node.name);
          writeSpace();
          writePunctuation("{");
          emitList(node, node.members, 145);
          writePunctuation("}");
        }
        function emitModuleDeclaration(node) {
          emitModifiers(node, node.modifiers);
          if (~node.flags & 1024) {
            writeKeyword(node.flags & 16 ? "namespace" : "module");
            writeSpace();
          }
          emit(node.name);
          var body = node.body;
          if (!body)
            return writeTrailingSemicolon();
          while (body.kind === 249) {
            writePunctuation(".");
            emit(body.name);
            body = body.body;
          }
          writeSpace();
          emit(body);
        }
        function emitModuleBlock(node) {
          pushNameGenerationScope(node);
          ts2.forEach(node.statements, generateNames);
          emitBlockStatements(node, isEmptyBlock(node));
          popNameGenerationScope(node);
        }
        function emitCaseBlock(node) {
          emitTokenWithComment(18, node.pos, writePunctuation, node);
          emitList(node, node.clauses, 129);
          emitTokenWithComment(19, node.clauses.end, writePunctuation, node, true);
        }
        function emitImportEqualsDeclaration(node) {
          emitModifiers(node, node.modifiers);
          emitTokenWithComment(96, node.modifiers ? node.modifiers.end : node.pos, writeKeyword, node);
          writeSpace();
          emit(node.name);
          writeSpace();
          emitTokenWithComment(62, node.name.end, writePunctuation, node);
          writeSpace();
          emitModuleReference(node.moduleReference);
          writeTrailingSemicolon();
        }
        function emitModuleReference(node) {
          if (node.kind === 75) {
            emitExpression(node);
          } else {
            emit(node);
          }
        }
        function emitImportDeclaration(node) {
          emitModifiers(node, node.modifiers);
          emitTokenWithComment(96, node.modifiers ? node.modifiers.end : node.pos, writeKeyword, node);
          writeSpace();
          if (node.importClause) {
            emit(node.importClause);
            writeSpace();
            emitTokenWithComment(149, node.importClause.end, writeKeyword, node);
            writeSpace();
          }
          emitExpression(node.moduleSpecifier);
          writeTrailingSemicolon();
        }
        function emitImportClause(node) {
          if (node.isTypeOnly) {
            emitTokenWithComment(145, node.pos, writeKeyword, node);
            writeSpace();
          }
          emit(node.name);
          if (node.name && node.namedBindings) {
            emitTokenWithComment(27, node.name.end, writePunctuation, node);
            writeSpace();
          }
          emit(node.namedBindings);
        }
        function emitNamespaceImport(node) {
          var asPos = emitTokenWithComment(41, node.pos, writePunctuation, node);
          writeSpace();
          emitTokenWithComment(123, asPos, writeKeyword, node);
          writeSpace();
          emit(node.name);
        }
        function emitNamedImports(node) {
          emitNamedImportsOrExports(node);
        }
        function emitImportSpecifier(node) {
          emitImportOrExportSpecifier(node);
        }
        function emitExportAssignment(node) {
          var nextPos = emitTokenWithComment(89, node.pos, writeKeyword, node);
          writeSpace();
          if (node.isExportEquals) {
            emitTokenWithComment(62, nextPos, writeOperator, node);
          } else {
            emitTokenWithComment(84, nextPos, writeKeyword, node);
          }
          writeSpace();
          emitExpression(node.expression);
          writeTrailingSemicolon();
        }
        function emitExportDeclaration(node) {
          var nextPos = emitTokenWithComment(89, node.pos, writeKeyword, node);
          writeSpace();
          if (node.isTypeOnly) {
            nextPos = emitTokenWithComment(145, nextPos, writeKeyword, node);
            writeSpace();
          }
          if (node.exportClause) {
            emit(node.exportClause);
          } else {
            nextPos = emitTokenWithComment(41, nextPos, writePunctuation, node);
          }
          if (node.moduleSpecifier) {
            writeSpace();
            var fromPos = node.exportClause ? node.exportClause.end : nextPos;
            emitTokenWithComment(149, fromPos, writeKeyword, node);
            writeSpace();
            emitExpression(node.moduleSpecifier);
          }
          writeTrailingSemicolon();
        }
        function emitNamespaceExportDeclaration(node) {
          var nextPos = emitTokenWithComment(89, node.pos, writeKeyword, node);
          writeSpace();
          nextPos = emitTokenWithComment(123, nextPos, writeKeyword, node);
          writeSpace();
          nextPos = emitTokenWithComment(136, nextPos, writeKeyword, node);
          writeSpace();
          emit(node.name);
          writeTrailingSemicolon();
        }
        function emitNamespaceExport(node) {
          var asPos = emitTokenWithComment(41, node.pos, writePunctuation, node);
          writeSpace();
          emitTokenWithComment(123, asPos, writeKeyword, node);
          writeSpace();
          emit(node.name);
        }
        function emitNamedExports(node) {
          emitNamedImportsOrExports(node);
        }
        function emitExportSpecifier(node) {
          emitImportOrExportSpecifier(node);
        }
        function emitNamedImportsOrExports(node) {
          writePunctuation("{");
          emitList(node, node.elements, 525136);
          writePunctuation("}");
        }
        function emitImportOrExportSpecifier(node) {
          if (node.propertyName) {
            emit(node.propertyName);
            writeSpace();
            emitTokenWithComment(123, node.propertyName.end, writeKeyword, node);
            writeSpace();
          }
          emit(node.name);
        }
        function emitExternalModuleReference(node) {
          writeKeyword("require");
          writePunctuation("(");
          emitExpression(node.expression);
          writePunctuation(")");
        }
        function emitJsxElement(node) {
          emit(node.openingElement);
          emitList(node, node.children, 262144);
          emit(node.closingElement);
        }
        function emitJsxSelfClosingElement(node) {
          writePunctuation("<");
          emitJsxTagName(node.tagName);
          emitTypeArguments(node, node.typeArguments);
          writeSpace();
          emit(node.attributes);
          writePunctuation("/>");
        }
        function emitJsxFragment(node) {
          emit(node.openingFragment);
          emitList(node, node.children, 262144);
          emit(node.closingFragment);
        }
        function emitJsxOpeningElementOrFragment(node) {
          writePunctuation("<");
          if (ts2.isJsxOpeningElement(node)) {
            var indented = writeLineSeparatorsAndIndentBefore(node.tagName, node);
            emitJsxTagName(node.tagName);
            emitTypeArguments(node, node.typeArguments);
            if (node.attributes.properties && node.attributes.properties.length > 0) {
              writeSpace();
            }
            emit(node.attributes);
            writeLineSeparatorsAfter(node.attributes, node);
            decreaseIndentIf(indented);
          }
          writePunctuation(">");
        }
        function emitJsxText(node) {
          writer.writeLiteral(node.text);
        }
        function emitJsxClosingElementOrFragment(node) {
          writePunctuation("</");
          if (ts2.isJsxClosingElement(node)) {
            emitJsxTagName(node.tagName);
          }
          writePunctuation(">");
        }
        function emitJsxAttributes(node) {
          emitList(node, node.properties, 262656);
        }
        function emitJsxAttribute(node) {
          emit(node.name);
          emitNodeWithPrefix("=", writePunctuation, node.initializer, emitJsxAttributeValue);
        }
        function emitJsxSpreadAttribute(node) {
          writePunctuation("{...");
          emitExpression(node.expression);
          writePunctuation("}");
        }
        function emitJsxExpression(node) {
          if (node.expression) {
            writePunctuation("{");
            emit(node.dotDotDotToken);
            emitExpression(node.expression);
            writePunctuation("}");
          }
        }
        function emitJsxTagName(node) {
          if (node.kind === 75) {
            emitExpression(node);
          } else {
            emit(node);
          }
        }
        function emitCaseClause(node) {
          emitTokenWithComment(78, node.pos, writeKeyword, node);
          writeSpace();
          emitExpression(node.expression);
          emitCaseOrDefaultClauseRest(node, node.statements, node.expression.end);
        }
        function emitDefaultClause(node) {
          var pos = emitTokenWithComment(84, node.pos, writeKeyword, node);
          emitCaseOrDefaultClauseRest(node, node.statements, pos);
        }
        function emitCaseOrDefaultClauseRest(parentNode, statements, colonPos) {
          var emitAsSingleStatement = statements.length === 1 && (ts2.nodeIsSynthesized(parentNode) || ts2.nodeIsSynthesized(statements[0]) || ts2.rangeStartPositionsAreOnSameLine(parentNode, statements[0], currentSourceFile));
          var format = 163969;
          if (emitAsSingleStatement) {
            writeToken(58, colonPos, writePunctuation, parentNode);
            writeSpace();
            format &= ~(1 | 128);
          } else {
            emitTokenWithComment(58, colonPos, writePunctuation, parentNode);
          }
          emitList(parentNode, statements, format);
        }
        function emitHeritageClause(node) {
          writeSpace();
          writeTokenText(node.token, writeKeyword);
          writeSpace();
          emitList(node, node.types, 528);
        }
        function emitCatchClause(node) {
          var openParenPos = emitTokenWithComment(79, node.pos, writeKeyword, node);
          writeSpace();
          if (node.variableDeclaration) {
            emitTokenWithComment(20, openParenPos, writePunctuation, node);
            emit(node.variableDeclaration);
            emitTokenWithComment(21, node.variableDeclaration.end, writePunctuation, node);
            writeSpace();
          }
          emit(node.block);
        }
        function emitPropertyAssignment(node) {
          emit(node.name);
          writePunctuation(":");
          writeSpace();
          var initializer = node.initializer;
          if (emitTrailingCommentsOfPosition && (ts2.getEmitFlags(initializer) & 512) === 0) {
            var commentRange = ts2.getCommentRange(initializer);
            emitTrailingCommentsOfPosition(commentRange.pos);
          }
          emitExpression(initializer);
        }
        function emitShorthandPropertyAssignment(node) {
          emit(node.name);
          if (node.objectAssignmentInitializer) {
            writeSpace();
            writePunctuation("=");
            writeSpace();
            emitExpression(node.objectAssignmentInitializer);
          }
        }
        function emitSpreadAssignment(node) {
          if (node.expression) {
            emitTokenWithComment(25, node.pos, writePunctuation, node);
            emitExpression(node.expression);
          }
        }
        function emitEnumMember(node) {
          emit(node.name);
          emitInitializer(node.initializer, node.name.end, node);
        }
        function emitJSDoc(node) {
          write("/**");
          if (node.comment) {
            var lines = node.comment.split(/\r\n?|\n/g);
            for (var _a2 = 0, lines_2 = lines; _a2 < lines_2.length; _a2++) {
              var line = lines_2[_a2];
              writeLine();
              writeSpace();
              writePunctuation("*");
              writeSpace();
              write(line);
            }
          }
          if (node.tags) {
            if (node.tags.length === 1 && node.tags[0].kind === 320 && !node.comment) {
              writeSpace();
              emit(node.tags[0]);
            } else {
              emitList(node, node.tags, 33);
            }
          }
          writeSpace();
          write("*/");
        }
        function emitJSDocSimpleTypedTag(tag) {
          emitJSDocTagName(tag.tagName);
          emitJSDocTypeExpression(tag.typeExpression);
          emitJSDocComment(tag.comment);
        }
        function emitJSDocHeritageTag(tag) {
          emitJSDocTagName(tag.tagName);
          writeSpace();
          writePunctuation("{");
          emit(tag.class);
          writePunctuation("}");
          emitJSDocComment(tag.comment);
        }
        function emitJSDocTemplateTag(tag) {
          emitJSDocTagName(tag.tagName);
          emitJSDocTypeExpression(tag.constraint);
          writeSpace();
          emitList(tag, tag.typeParameters, 528);
          emitJSDocComment(tag.comment);
        }
        function emitJSDocTypedefTag(tag) {
          emitJSDocTagName(tag.tagName);
          if (tag.typeExpression) {
            if (tag.typeExpression.kind === 294) {
              emitJSDocTypeExpression(tag.typeExpression);
            } else {
              writeSpace();
              writePunctuation("{");
              write("Object");
              if (tag.typeExpression.isArrayType) {
                writePunctuation("[");
                writePunctuation("]");
              }
              writePunctuation("}");
            }
          }
          if (tag.fullName) {
            writeSpace();
            emit(tag.fullName);
          }
          emitJSDocComment(tag.comment);
          if (tag.typeExpression && tag.typeExpression.kind === 304) {
            emitJSDocTypeLiteral(tag.typeExpression);
          }
        }
        function emitJSDocCallbackTag(tag) {
          emitJSDocTagName(tag.tagName);
          if (tag.name) {
            writeSpace();
            emit(tag.name);
          }
          emitJSDocComment(tag.comment);
          emitJSDocSignature(tag.typeExpression);
        }
        function emitJSDocSimpleTag(tag) {
          emitJSDocTagName(tag.tagName);
          emitJSDocComment(tag.comment);
        }
        function emitJSDocTypeLiteral(lit) {
          emitList(lit, ts2.createNodeArray(lit.jsDocPropertyTags), 33);
        }
        function emitJSDocSignature(sig) {
          if (sig.typeParameters) {
            emitList(sig, ts2.createNodeArray(sig.typeParameters), 33);
          }
          if (sig.parameters) {
            emitList(sig, ts2.createNodeArray(sig.parameters), 33);
          }
          if (sig.type) {
            writeLine();
            writeSpace();
            writePunctuation("*");
            writeSpace();
            emit(sig.type);
          }
        }
        function emitJSDocPropertyLikeTag(param) {
          emitJSDocTagName(param.tagName);
          emitJSDocTypeExpression(param.typeExpression);
          writeSpace();
          if (param.isBracketed) {
            writePunctuation("[");
          }
          emit(param.name);
          if (param.isBracketed) {
            writePunctuation("]");
          }
          emitJSDocComment(param.comment);
        }
        function emitJSDocTagName(tagName) {
          writePunctuation("@");
          emit(tagName);
        }
        function emitJSDocComment(comment) {
          if (comment) {
            writeSpace();
            write(comment);
          }
        }
        function emitJSDocTypeExpression(typeExpression) {
          if (typeExpression) {
            writeSpace();
            writePunctuation("{");
            emit(typeExpression.type);
            writePunctuation("}");
          }
        }
        function emitSourceFile(node) {
          writeLine();
          var statements = node.statements;
          if (emitBodyWithDetachedComments) {
            var shouldEmitDetachedComment = statements.length === 0 || !ts2.isPrologueDirective(statements[0]) || ts2.nodeIsSynthesized(statements[0]);
            if (shouldEmitDetachedComment) {
              emitBodyWithDetachedComments(node, statements, emitSourceFileWorker);
              return;
            }
          }
          emitSourceFileWorker(node);
        }
        function emitSyntheticTripleSlashReferencesIfNeeded(node) {
          emitTripleSlashDirectives(!!node.hasNoDefaultLib, node.syntheticFileReferences || [], node.syntheticTypeReferences || [], node.syntheticLibReferences || []);
          for (var _a2 = 0, _b2 = node.prepends; _a2 < _b2.length; _a2++) {
            var prepend = _b2[_a2];
            if (ts2.isUnparsedSource(prepend) && prepend.syntheticReferences) {
              for (var _c2 = 0, _d = prepend.syntheticReferences; _c2 < _d.length; _c2++) {
                var ref = _d[_c2];
                emit(ref);
                writeLine();
              }
            }
          }
        }
        function emitTripleSlashDirectivesIfNeeded(node) {
          if (node.isDeclarationFile)
            emitTripleSlashDirectives(node.hasNoDefaultLib, node.referencedFiles, node.typeReferenceDirectives, node.libReferenceDirectives);
        }
        function emitTripleSlashDirectives(hasNoDefaultLib, files, types, libs) {
          if (hasNoDefaultLib) {
            var pos = writer.getTextPos();
            writeComment('/// <reference no-default-lib="true"/>');
            if (bundleFileInfo)
              bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "no-default-lib" });
            writeLine();
          }
          if (currentSourceFile && currentSourceFile.moduleName) {
            writeComment('/// <amd-module name="' + currentSourceFile.moduleName + '" />');
            writeLine();
          }
          if (currentSourceFile && currentSourceFile.amdDependencies) {
            for (var _a2 = 0, _b2 = currentSourceFile.amdDependencies; _a2 < _b2.length; _a2++) {
              var dep = _b2[_a2];
              if (dep.name) {
                writeComment('/// <amd-dependency name="' + dep.name + '" path="' + dep.path + '" />');
              } else {
                writeComment('/// <amd-dependency path="' + dep.path + '" />');
              }
              writeLine();
            }
          }
          for (var _c2 = 0, files_1 = files; _c2 < files_1.length; _c2++) {
            var directive = files_1[_c2];
            var pos = writer.getTextPos();
            writeComment('/// <reference path="' + directive.fileName + '" />');
            if (bundleFileInfo)
              bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "reference", data: directive.fileName });
            writeLine();
          }
          for (var _d = 0, types_22 = types; _d < types_22.length; _d++) {
            var directive = types_22[_d];
            var pos = writer.getTextPos();
            writeComment('/// <reference types="' + directive.fileName + '" />');
            if (bundleFileInfo)
              bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "type", data: directive.fileName });
            writeLine();
          }
          for (var _e = 0, libs_1 = libs; _e < libs_1.length; _e++) {
            var directive = libs_1[_e];
            var pos = writer.getTextPos();
            writeComment('/// <reference lib="' + directive.fileName + '" />');
            if (bundleFileInfo)
              bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "lib", data: directive.fileName });
            writeLine();
          }
        }
        function emitSourceFileWorker(node) {
          var statements = node.statements;
          pushNameGenerationScope(node);
          ts2.forEach(node.statements, generateNames);
          emitHelpers(node);
          var index = ts2.findIndex(statements, function(statement) {
            return !ts2.isPrologueDirective(statement);
          });
          emitTripleSlashDirectivesIfNeeded(node);
          emitList(node, statements, 1, index === -1 ? statements.length : index);
          popNameGenerationScope(node);
        }
        function emitPartiallyEmittedExpression(node) {
          emitExpression(node.expression);
        }
        function emitCommaList(node) {
          emitExpressionList(node, node.elements, 528);
        }
        function emitPrologueDirectives(statements, sourceFile, seenPrologueDirectives, recordBundleFileSection) {
          var needsToSetSourceFile = !!sourceFile;
          for (var i = 0; i < statements.length; i++) {
            var statement = statements[i];
            if (ts2.isPrologueDirective(statement)) {
              var shouldEmitPrologueDirective = seenPrologueDirectives ? !seenPrologueDirectives.has(statement.expression.text) : true;
              if (shouldEmitPrologueDirective) {
                if (needsToSetSourceFile) {
                  needsToSetSourceFile = false;
                  setSourceFile(sourceFile);
                }
                writeLine();
                var pos = writer.getTextPos();
                emit(statement);
                if (recordBundleFileSection && bundleFileInfo)
                  bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "prologue", data: statement.expression.text });
                if (seenPrologueDirectives) {
                  seenPrologueDirectives.set(statement.expression.text, true);
                }
              }
            } else {
              return i;
            }
          }
          return statements.length;
        }
        function emitUnparsedPrologues(prologues, seenPrologueDirectives) {
          for (var _a2 = 0, prologues_1 = prologues; _a2 < prologues_1.length; _a2++) {
            var prologue = prologues_1[_a2];
            if (!seenPrologueDirectives.has(prologue.data)) {
              writeLine();
              var pos = writer.getTextPos();
              emit(prologue);
              if (bundleFileInfo)
                bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "prologue", data: prologue.data });
              if (seenPrologueDirectives) {
                seenPrologueDirectives.set(prologue.data, true);
              }
            }
          }
        }
        function emitPrologueDirectivesIfNeeded(sourceFileOrBundle) {
          if (ts2.isSourceFile(sourceFileOrBundle)) {
            emitPrologueDirectives(sourceFileOrBundle.statements, sourceFileOrBundle);
          } else {
            var seenPrologueDirectives = ts2.createMap();
            for (var _a2 = 0, _b2 = sourceFileOrBundle.prepends; _a2 < _b2.length; _a2++) {
              var prepend = _b2[_a2];
              emitUnparsedPrologues(prepend.prologues, seenPrologueDirectives);
            }
            for (var _c2 = 0, _d = sourceFileOrBundle.sourceFiles; _c2 < _d.length; _c2++) {
              var sourceFile = _d[_c2];
              emitPrologueDirectives(sourceFile.statements, sourceFile, seenPrologueDirectives, true);
            }
            setSourceFile(void 0);
          }
        }
        function getPrologueDirectivesFromBundledSourceFiles(bundle) {
          var seenPrologueDirectives = ts2.createMap();
          var prologues;
          for (var index = 0; index < bundle.sourceFiles.length; index++) {
            var sourceFile = bundle.sourceFiles[index];
            var directives = void 0;
            var end = 0;
            for (var _a2 = 0, _b2 = sourceFile.statements; _a2 < _b2.length; _a2++) {
              var statement = _b2[_a2];
              if (!ts2.isPrologueDirective(statement))
                break;
              if (seenPrologueDirectives.has(statement.expression.text))
                continue;
              seenPrologueDirectives.set(statement.expression.text, true);
              (directives || (directives = [])).push({
                pos: statement.pos,
                end: statement.end,
                expression: {
                  pos: statement.expression.pos,
                  end: statement.expression.end,
                  text: statement.expression.text
                }
              });
              end = end < statement.end ? statement.end : end;
            }
            if (directives)
              (prologues || (prologues = [])).push({ file: index, text: sourceFile.text.substring(0, end), directives });
          }
          return prologues;
        }
        function emitShebangIfNeeded(sourceFileOrBundle) {
          if (ts2.isSourceFile(sourceFileOrBundle) || ts2.isUnparsedSource(sourceFileOrBundle)) {
            var shebang = ts2.getShebang(sourceFileOrBundle.text);
            if (shebang) {
              writeComment(shebang);
              writeLine();
              return true;
            }
          } else {
            for (var _a2 = 0, _b2 = sourceFileOrBundle.prepends; _a2 < _b2.length; _a2++) {
              var prepend = _b2[_a2];
              ts2.Debug.assertNode(prepend, ts2.isUnparsedSource);
              if (emitShebangIfNeeded(prepend)) {
                return true;
              }
            }
            for (var _c2 = 0, _d = sourceFileOrBundle.sourceFiles; _c2 < _d.length; _c2++) {
              var sourceFile = _d[_c2];
              if (emitShebangIfNeeded(sourceFile)) {
                return true;
              }
            }
          }
        }
        function emitNodeWithWriter(node, writer2) {
          if (!node)
            return;
          var savedWrite = write;
          write = writer2;
          emit(node);
          write = savedWrite;
        }
        function emitModifiers(node, modifiers) {
          if (modifiers && modifiers.length) {
            emitList(node, modifiers, 262656);
            writeSpace();
          }
        }
        function emitTypeAnnotation(node) {
          if (node) {
            writePunctuation(":");
            writeSpace();
            emit(node);
          }
        }
        function emitInitializer(node, equalCommentStartPos, container) {
          if (node) {
            writeSpace();
            emitTokenWithComment(62, equalCommentStartPos, writeOperator, container);
            writeSpace();
            emitExpression(node);
          }
        }
        function emitNodeWithPrefix(prefix, prefixWriter, node, emit2) {
          if (node) {
            prefixWriter(prefix);
            emit2(node);
          }
        }
        function emitWithLeadingSpace(node) {
          if (node) {
            writeSpace();
            emit(node);
          }
        }
        function emitExpressionWithLeadingSpace(node) {
          if (node) {
            writeSpace();
            emitExpression(node);
          }
        }
        function emitWithTrailingSpace(node) {
          if (node) {
            emit(node);
            writeSpace();
          }
        }
        function emitEmbeddedStatement(parent, node) {
          if (ts2.isBlock(node) || ts2.getEmitFlags(parent) & 1) {
            writeSpace();
            emit(node);
          } else {
            writeLine();
            increaseIndent();
            if (ts2.isEmptyStatement(node)) {
              pipelineEmit(5, node);
            } else {
              emit(node);
            }
            decreaseIndent();
          }
        }
        function emitDecorators(parentNode, decorators) {
          emitList(parentNode, decorators, 2146305);
        }
        function emitTypeArguments(parentNode, typeArguments) {
          emitList(parentNode, typeArguments, 53776);
        }
        function emitTypeParameters(parentNode, typeParameters) {
          if (ts2.isFunctionLike(parentNode) && parentNode.typeArguments) {
            return emitTypeArguments(parentNode, parentNode.typeArguments);
          }
          emitList(parentNode, typeParameters, 53776);
        }
        function emitParameters(parentNode, parameters) {
          emitList(parentNode, parameters, 2576);
        }
        function canEmitSimpleArrowHead(parentNode, parameters) {
          var parameter = ts2.singleOrUndefined(parameters);
          return parameter && parameter.pos === parentNode.pos && ts2.isArrowFunction(parentNode) && !parentNode.type && !ts2.some(parentNode.decorators) && !ts2.some(parentNode.modifiers) && !ts2.some(parentNode.typeParameters) && !ts2.some(parameter.decorators) && !ts2.some(parameter.modifiers) && !parameter.dotDotDotToken && !parameter.questionToken && !parameter.type && !parameter.initializer && ts2.isIdentifier(parameter.name);
        }
        function emitParametersForArrow(parentNode, parameters) {
          if (canEmitSimpleArrowHead(parentNode, parameters)) {
            emitList(parentNode, parameters, 2576 & ~2048);
          } else {
            emitParameters(parentNode, parameters);
          }
        }
        function emitParametersForIndexSignature(parentNode, parameters) {
          emitList(parentNode, parameters, 8848);
        }
        function emitList(parentNode, children, format, start, count) {
          emitNodeList(emit, parentNode, children, format, start, count);
        }
        function emitExpressionList(parentNode, children, format, start, count) {
          emitNodeList(emitExpression, parentNode, children, format, start, count);
        }
        function writeDelimiter(format) {
          switch (format & 60) {
            case 0:
              break;
            case 16:
              writePunctuation(",");
              break;
            case 4:
              writeSpace();
              writePunctuation("|");
              break;
            case 32:
              writeSpace();
              writePunctuation("*");
              writeSpace();
              break;
            case 8:
              writeSpace();
              writePunctuation("&");
              break;
          }
        }
        function emitNodeList(emit2, parentNode, children, format, start, count) {
          if (start === void 0) {
            start = 0;
          }
          if (count === void 0) {
            count = children ? children.length - start : 0;
          }
          var isUndefined = children === void 0;
          if (isUndefined && format & 16384) {
            return;
          }
          var isEmpty = children === void 0 || start >= children.length || count === 0;
          if (isEmpty && format & 32768) {
            if (onBeforeEmitNodeArray) {
              onBeforeEmitNodeArray(children);
            }
            if (onAfterEmitNodeArray) {
              onAfterEmitNodeArray(children);
            }
            return;
          }
          if (format & 15360) {
            writePunctuation(getOpeningBracket(format));
            if (isEmpty && !isUndefined) {
              emitTrailingCommentsOfPosition(children.pos, true);
            }
          }
          if (onBeforeEmitNodeArray) {
            onBeforeEmitNodeArray(children);
          }
          if (isEmpty) {
            if (format & 1 && !(preserveSourceNewlines && ts2.rangeIsOnSingleLine(parentNode, currentSourceFile))) {
              writeLine();
            } else if (format & 256 && !(format & 524288)) {
              writeSpace();
            }
          } else {
            var mayEmitInterveningComments = (format & 262144) === 0;
            var shouldEmitInterveningComments = mayEmitInterveningComments;
            var leadingLineTerminatorCount = getLeadingLineTerminatorCount(parentNode, children, format);
            if (leadingLineTerminatorCount) {
              writeLine(leadingLineTerminatorCount);
              shouldEmitInterveningComments = false;
            } else if (format & 256) {
              writeSpace();
            }
            if (format & 128) {
              increaseIndent();
            }
            var previousSibling = void 0;
            var previousSourceFileTextKind = void 0;
            var shouldDecreaseIndentAfterEmit = false;
            for (var i = 0; i < count; i++) {
              var child = children[start + i];
              if (format & 32) {
                writeLine();
                writeDelimiter(format);
              } else if (previousSibling) {
                if (format & 60 && previousSibling.end !== parentNode.end) {
                  emitLeadingCommentsOfPosition(previousSibling.end);
                }
                writeDelimiter(format);
                recordBundleFileInternalSectionEnd(previousSourceFileTextKind);
                var separatingLineTerminatorCount = getSeparatingLineTerminatorCount(previousSibling, child, format);
                if (separatingLineTerminatorCount > 0) {
                  if ((format & (3 | 128)) === 0) {
                    increaseIndent();
                    shouldDecreaseIndentAfterEmit = true;
                  }
                  writeLine(separatingLineTerminatorCount);
                  shouldEmitInterveningComments = false;
                } else if (previousSibling && format & 512) {
                  writeSpace();
                }
              }
              previousSourceFileTextKind = recordBundleFileInternalSectionStart(child);
              if (shouldEmitInterveningComments) {
                if (emitTrailingCommentsOfPosition) {
                  var commentRange = ts2.getCommentRange(child);
                  emitTrailingCommentsOfPosition(commentRange.pos);
                }
              } else {
                shouldEmitInterveningComments = mayEmitInterveningComments;
              }
              emit2(child);
              if (shouldDecreaseIndentAfterEmit) {
                decreaseIndent();
                shouldDecreaseIndentAfterEmit = false;
              }
              previousSibling = child;
            }
            var hasTrailingComma = format & 64 && children.hasTrailingComma;
            if (format & 16 && hasTrailingComma) {
              writePunctuation(",");
            }
            if (previousSibling && format & 60 && previousSibling.end !== parentNode.end && !(ts2.getEmitFlags(previousSibling) & 1024)) {
              emitLeadingCommentsOfPosition(previousSibling.end);
            }
            if (format & 128) {
              decreaseIndent();
            }
            recordBundleFileInternalSectionEnd(previousSourceFileTextKind);
            var closingLineTerminatorCount = getClosingLineTerminatorCount(parentNode, children, format);
            if (closingLineTerminatorCount) {
              writeLine(closingLineTerminatorCount);
            } else if (format & (2097152 | 256)) {
              writeSpace();
            }
          }
          if (onAfterEmitNodeArray) {
            onAfterEmitNodeArray(children);
          }
          if (format & 15360) {
            if (isEmpty && !isUndefined) {
              emitLeadingCommentsOfPosition(children.end);
            }
            writePunctuation(getClosingBracket(format));
          }
        }
        function writeLiteral(s) {
          writer.writeLiteral(s);
        }
        function writeStringLiteral(s) {
          writer.writeStringLiteral(s);
        }
        function writeBase(s) {
          writer.write(s);
        }
        function writeSymbol(s, sym) {
          writer.writeSymbol(s, sym);
        }
        function writePunctuation(s) {
          writer.writePunctuation(s);
        }
        function writeTrailingSemicolon() {
          writer.writeTrailingSemicolon(";");
        }
        function writeKeyword(s) {
          writer.writeKeyword(s);
        }
        function writeOperator(s) {
          writer.writeOperator(s);
        }
        function writeParameter(s) {
          writer.writeParameter(s);
        }
        function writeComment(s) {
          writer.writeComment(s);
        }
        function writeSpace() {
          writer.writeSpace(" ");
        }
        function writeProperty(s) {
          writer.writeProperty(s);
        }
        function writeLine(count) {
          if (count === void 0) {
            count = 1;
          }
          for (var i = 0; i < count; i++) {
            writer.writeLine(i > 0);
          }
        }
        function increaseIndent() {
          writer.increaseIndent();
        }
        function decreaseIndent() {
          writer.decreaseIndent();
        }
        function writeToken(token, pos, writer2, contextNode) {
          return !sourceMapsDisabled ? emitTokenWithSourceMap(contextNode, token, writer2, pos, writeTokenText) : writeTokenText(token, writer2, pos);
        }
        function writeTokenNode(node, writer2) {
          if (onBeforeEmitToken) {
            onBeforeEmitToken(node);
          }
          writer2(ts2.tokenToString(node.kind));
          if (onAfterEmitToken) {
            onAfterEmitToken(node);
          }
        }
        function writeTokenText(token, writer2, pos) {
          var tokenString = ts2.tokenToString(token);
          writer2(tokenString);
          return pos < 0 ? pos : pos + tokenString.length;
        }
        function writeLineOrSpace(node) {
          if (ts2.getEmitFlags(node) & 1) {
            writeSpace();
          } else {
            writeLine();
          }
        }
        function writeLines(text) {
          var lines = text.split(/\r\n?|\n/g);
          var indentation = ts2.guessIndentation(lines);
          for (var _a2 = 0, lines_3 = lines; _a2 < lines_3.length; _a2++) {
            var lineText = lines_3[_a2];
            var line = indentation ? lineText.slice(indentation) : lineText;
            if (line.length) {
              writeLine();
              write(line);
            }
          }
        }
        function writeLinesAndIndent(lineCount, writeSpaceIfNotIndenting) {
          if (lineCount) {
            increaseIndent();
            writeLine(lineCount);
          } else if (writeSpaceIfNotIndenting) {
            writeSpace();
          }
        }
        function decreaseIndentIf(value1, value2) {
          if (value1) {
            decreaseIndent();
          }
          if (value2) {
            decreaseIndent();
          }
        }
        function getLeadingLineTerminatorCount(parentNode, children, format) {
          if (format & 2 || preserveSourceNewlines) {
            if (format & 65536) {
              return 1;
            }
            var firstChild_1 = children[0];
            if (firstChild_1 === void 0) {
              return ts2.rangeIsOnSingleLine(parentNode, currentSourceFile) ? 0 : 1;
            }
            if (firstChild_1.kind === 11) {
              return 0;
            }
            if (!ts2.positionIsSynthesized(parentNode.pos) && !ts2.nodeIsSynthesized(firstChild_1) && (!firstChild_1.parent || firstChild_1.parent === parentNode)) {
              if (preserveSourceNewlines) {
                return getEffectiveLines(function(includeComments) {
                  return ts2.getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter(firstChild_1.pos, parentNode.pos, currentSourceFile, includeComments);
                });
              }
              return ts2.rangeStartPositionsAreOnSameLine(parentNode, firstChild_1, currentSourceFile) ? 0 : 1;
            }
            if (synthesizedNodeStartsOnNewLine(firstChild_1, format)) {
              return 1;
            }
          }
          return format & 1 ? 1 : 0;
        }
        function getSeparatingLineTerminatorCount(previousNode, nextNode, format) {
          if (format & 2 || preserveSourceNewlines) {
            if (previousNode === void 0 || nextNode === void 0) {
              return 0;
            }
            if (nextNode.kind === 11) {
              return 0;
            } else if (!ts2.nodeIsSynthesized(previousNode) && !ts2.nodeIsSynthesized(nextNode) && previousNode.parent === nextNode.parent) {
              if (preserveSourceNewlines) {
                return getEffectiveLines(function(includeComments) {
                  return ts2.getLinesBetweenRangeEndAndRangeStart(previousNode, nextNode, currentSourceFile, includeComments);
                });
              }
              return ts2.rangeEndIsOnSameLineAsRangeStart(previousNode, nextNode, currentSourceFile) ? 0 : 1;
            } else if (synthesizedNodeStartsOnNewLine(previousNode, format) || synthesizedNodeStartsOnNewLine(nextNode, format)) {
              return 1;
            }
          } else if (ts2.getStartsOnNewLine(nextNode)) {
            return 1;
          }
          return format & 1 ? 1 : 0;
        }
        function getClosingLineTerminatorCount(parentNode, children, format) {
          if (format & 2 || preserveSourceNewlines) {
            if (format & 65536) {
              return 1;
            }
            var lastChild_1 = ts2.lastOrUndefined(children);
            if (lastChild_1 === void 0) {
              return ts2.rangeIsOnSingleLine(parentNode, currentSourceFile) ? 0 : 1;
            }
            if (!ts2.positionIsSynthesized(parentNode.pos) && !ts2.nodeIsSynthesized(lastChild_1) && (!lastChild_1.parent || lastChild_1.parent === parentNode)) {
              if (preserveSourceNewlines) {
                return getEffectiveLines(function(includeComments) {
                  return ts2.getLinesBetweenPositionAndNextNonWhitespaceCharacter(lastChild_1.end, parentNode.end, currentSourceFile, includeComments);
                });
              }
              return ts2.rangeEndPositionsAreOnSameLine(parentNode, lastChild_1, currentSourceFile) ? 0 : 1;
            }
            if (synthesizedNodeStartsOnNewLine(lastChild_1, format)) {
              return 1;
            }
          }
          if (format & 1 && !(format & 131072)) {
            return 1;
          }
          return 0;
        }
        function getEffectiveLines(getLineDifference) {
          ts2.Debug.assert(!!preserveSourceNewlines);
          var lines = getLineDifference(true);
          if (lines === 0) {
            return getLineDifference(false);
          }
          return lines;
        }
        function writeLineSeparatorsAndIndentBefore(node, parent) {
          var leadingNewlines = preserveSourceNewlines && getLeadingLineTerminatorCount(parent, [node], 0);
          if (leadingNewlines) {
            writeLinesAndIndent(leadingNewlines, false);
          }
          return !!leadingNewlines;
        }
        function writeLineSeparatorsAfter(node, parent) {
          var trailingNewlines = preserveSourceNewlines && getClosingLineTerminatorCount(parent, [node], 0);
          if (trailingNewlines) {
            writeLine(trailingNewlines);
          }
        }
        function synthesizedNodeStartsOnNewLine(node, format) {
          if (ts2.nodeIsSynthesized(node)) {
            var startsOnNewLine = ts2.getStartsOnNewLine(node);
            if (startsOnNewLine === void 0) {
              return (format & 65536) !== 0;
            }
            return startsOnNewLine;
          }
          return (format & 65536) !== 0;
        }
        function getLinesBetweenNodes(parent, node1, node2) {
          if (ts2.getEmitFlags(parent) & 131072) {
            return 0;
          }
          parent = skipSynthesizedParentheses(parent);
          node1 = skipSynthesizedParentheses(node1);
          node2 = skipSynthesizedParentheses(node2);
          if (ts2.getStartsOnNewLine(node2)) {
            return 1;
          }
          if (!ts2.nodeIsSynthesized(parent) && !ts2.nodeIsSynthesized(node1) && !ts2.nodeIsSynthesized(node2)) {
            if (preserveSourceNewlines) {
              return getEffectiveLines(function(includeComments) {
                return ts2.getLinesBetweenRangeEndAndRangeStart(node1, node2, currentSourceFile, includeComments);
              });
            }
            return ts2.rangeEndIsOnSameLineAsRangeStart(node1, node2, currentSourceFile) ? 0 : 1;
          }
          return 0;
        }
        function isEmptyBlock(block) {
          return block.statements.length === 0 && ts2.rangeEndIsOnSameLineAsRangeStart(block, block, currentSourceFile);
        }
        function skipSynthesizedParentheses(node) {
          while (node.kind === 200 && ts2.nodeIsSynthesized(node)) {
            node = node.expression;
          }
          return node;
        }
        function getTextOfNode(node, includeTrivia) {
          if (ts2.isGeneratedIdentifier(node)) {
            return generateName(node);
          } else if ((ts2.isIdentifier(node) || ts2.isPrivateIdentifier(node)) && (ts2.nodeIsSynthesized(node) || !node.parent || !currentSourceFile || node.parent && currentSourceFile && ts2.getSourceFileOfNode(node) !== ts2.getOriginalNode(currentSourceFile))) {
            return ts2.idText(node);
          } else if (node.kind === 10 && node.textSourceNode) {
            return getTextOfNode(node.textSourceNode, includeTrivia);
          } else if (ts2.isLiteralExpression(node) && (ts2.nodeIsSynthesized(node) || !node.parent)) {
            return node.text;
          }
          return ts2.getSourceTextOfNodeFromSourceFile(currentSourceFile, node, includeTrivia);
        }
        function getLiteralTextOfNode(node, neverAsciiEscape, jsxAttributeEscape) {
          if (node.kind === 10 && node.textSourceNode) {
            var textSourceNode = node.textSourceNode;
            if (ts2.isIdentifier(textSourceNode)) {
              return jsxAttributeEscape ? '"' + ts2.escapeJsxAttributeString(getTextOfNode(textSourceNode)) + '"' : neverAsciiEscape || ts2.getEmitFlags(node) & 16777216 ? '"' + ts2.escapeString(getTextOfNode(textSourceNode)) + '"' : '"' + ts2.escapeNonAsciiString(getTextOfNode(textSourceNode)) + '"';
            } else {
              return getLiteralTextOfNode(textSourceNode, neverAsciiEscape, jsxAttributeEscape);
            }
          }
          return ts2.getLiteralText(node, currentSourceFile, neverAsciiEscape, jsxAttributeEscape);
        }
        function pushNameGenerationScope(node) {
          if (node && ts2.getEmitFlags(node) & 524288) {
            return;
          }
          tempFlagsStack.push(tempFlags);
          tempFlags = 0;
          reservedNamesStack.push(reservedNames);
        }
        function popNameGenerationScope(node) {
          if (node && ts2.getEmitFlags(node) & 524288) {
            return;
          }
          tempFlags = tempFlagsStack.pop();
          reservedNames = reservedNamesStack.pop();
        }
        function reserveNameInNestedScopes(name) {
          if (!reservedNames || reservedNames === ts2.lastOrUndefined(reservedNamesStack)) {
            reservedNames = ts2.createMap();
          }
          reservedNames.set(name, true);
        }
        function generateNames(node) {
          if (!node)
            return;
          switch (node.kind) {
            case 223:
              ts2.forEach(node.statements, generateNames);
              break;
            case 238:
            case 236:
            case 228:
            case 229:
              generateNames(node.statement);
              break;
            case 227:
              generateNames(node.thenStatement);
              generateNames(node.elseStatement);
              break;
            case 230:
            case 232:
            case 231:
              generateNames(node.initializer);
              generateNames(node.statement);
              break;
            case 237:
              generateNames(node.caseBlock);
              break;
            case 251:
              ts2.forEach(node.clauses, generateNames);
              break;
            case 277:
            case 278:
              ts2.forEach(node.statements, generateNames);
              break;
            case 240:
              generateNames(node.tryBlock);
              generateNames(node.catchClause);
              generateNames(node.finallyBlock);
              break;
            case 280:
              generateNames(node.variableDeclaration);
              generateNames(node.block);
              break;
            case 225:
              generateNames(node.declarationList);
              break;
            case 243:
              ts2.forEach(node.declarations, generateNames);
              break;
            case 242:
            case 156:
            case 191:
            case 245:
              generateNameIfNeeded(node.name);
              break;
            case 244:
              generateNameIfNeeded(node.name);
              if (ts2.getEmitFlags(node) & 524288) {
                ts2.forEach(node.parameters, generateNames);
                generateNames(node.body);
              }
              break;
            case 189:
            case 190:
              ts2.forEach(node.elements, generateNames);
              break;
            case 254:
              generateNames(node.importClause);
              break;
            case 255:
              generateNameIfNeeded(node.name);
              generateNames(node.namedBindings);
              break;
            case 256:
              generateNameIfNeeded(node.name);
              break;
            case 262:
              generateNameIfNeeded(node.name);
              break;
            case 257:
              ts2.forEach(node.elements, generateNames);
              break;
            case 258:
              generateNameIfNeeded(node.propertyName || node.name);
              break;
          }
        }
        function generateMemberNames(node) {
          if (!node)
            return;
          switch (node.kind) {
            case 281:
            case 282:
            case 159:
            case 161:
            case 163:
            case 164:
              generateNameIfNeeded(node.name);
              break;
          }
        }
        function generateNameIfNeeded(name) {
          if (name) {
            if (ts2.isGeneratedIdentifier(name)) {
              generateName(name);
            } else if (ts2.isBindingPattern(name)) {
              generateNames(name);
            }
          }
        }
        function generateName(name) {
          if ((name.autoGenerateFlags & 7) === 4) {
            return generateNameCached(getNodeForGeneratedName(name), name.autoGenerateFlags);
          } else {
            var autoGenerateId = name.autoGenerateId;
            return autoGeneratedIdToGeneratedName[autoGenerateId] || (autoGeneratedIdToGeneratedName[autoGenerateId] = makeName(name));
          }
        }
        function generateNameCached(node, flags) {
          var nodeId = ts2.getNodeId(node);
          return nodeIdToGeneratedName[nodeId] || (nodeIdToGeneratedName[nodeId] = generateNameForNode(node, flags));
        }
        function isUniqueName(name) {
          return isFileLevelUniqueName(name) && !generatedNames.has(name) && !(reservedNames && reservedNames.has(name));
        }
        function isFileLevelUniqueName(name) {
          return currentSourceFile ? ts2.isFileLevelUniqueName(currentSourceFile, name, hasGlobalName) : true;
        }
        function isUniqueLocalName(name, container) {
          for (var node = container; ts2.isNodeDescendantOf(node, container); node = node.nextContainer) {
            if (node.locals) {
              var local = node.locals.get(ts2.escapeLeadingUnderscores(name));
              if (local && local.flags & (111551 | 1048576 | 2097152)) {
                return false;
              }
            }
          }
          return true;
        }
        function makeTempVariableName(flags, reservedInNestedScopes) {
          if (flags && !(tempFlags & flags)) {
            var name = flags === 268435456 ? "_i" : "_n";
            if (isUniqueName(name)) {
              tempFlags |= flags;
              if (reservedInNestedScopes) {
                reserveNameInNestedScopes(name);
              }
              return name;
            }
          }
          while (true) {
            var count = tempFlags & 268435455;
            tempFlags++;
            if (count !== 8 && count !== 13) {
              var name = count < 26 ? "_" + String.fromCharCode(97 + count) : "_" + (count - 26);
              if (isUniqueName(name)) {
                if (reservedInNestedScopes) {
                  reserveNameInNestedScopes(name);
                }
                return name;
              }
            }
          }
        }
        function makeUniqueName(baseName, checkFn, optimistic, scoped) {
          if (checkFn === void 0) {
            checkFn = isUniqueName;
          }
          if (optimistic) {
            if (checkFn(baseName)) {
              if (scoped) {
                reserveNameInNestedScopes(baseName);
              } else {
                generatedNames.set(baseName, true);
              }
              return baseName;
            }
          }
          if (baseName.charCodeAt(baseName.length - 1) !== 95) {
            baseName += "_";
          }
          var i = 1;
          while (true) {
            var generatedName = baseName + i;
            if (checkFn(generatedName)) {
              if (scoped) {
                reserveNameInNestedScopes(generatedName);
              } else {
                generatedNames.set(generatedName, true);
              }
              return generatedName;
            }
            i++;
          }
        }
        function makeFileLevelOptimisticUniqueName(name) {
          return makeUniqueName(name, isFileLevelUniqueName, true);
        }
        function generateNameForModuleOrEnum(node) {
          var name = getTextOfNode(node.name);
          return isUniqueLocalName(name, node) ? name : makeUniqueName(name);
        }
        function generateNameForImportOrExportDeclaration(node) {
          var expr = ts2.getExternalModuleName(node);
          var baseName = ts2.isStringLiteral(expr) ? ts2.makeIdentifierFromModuleName(expr.text) : "module";
          return makeUniqueName(baseName);
        }
        function generateNameForExportDefault() {
          return makeUniqueName("default");
        }
        function generateNameForClassExpression() {
          return makeUniqueName("class");
        }
        function generateNameForMethodOrAccessor(node) {
          if (ts2.isIdentifier(node.name)) {
            return generateNameCached(node.name);
          }
          return makeTempVariableName(0);
        }
        function generateNameForNode(node, flags) {
          switch (node.kind) {
            case 75:
              return makeUniqueName(getTextOfNode(node), isUniqueName, !!(flags & 16), !!(flags & 8));
            case 249:
            case 248:
              return generateNameForModuleOrEnum(node);
            case 254:
            case 260:
              return generateNameForImportOrExportDeclaration(node);
            case 244:
            case 245:
            case 259:
              return generateNameForExportDefault();
            case 214:
              return generateNameForClassExpression();
            case 161:
            case 163:
            case 164:
              return generateNameForMethodOrAccessor(node);
            case 154:
              return makeTempVariableName(0, true);
            default:
              return makeTempVariableName(0);
          }
        }
        function makeName(name) {
          switch (name.autoGenerateFlags & 7) {
            case 1:
              return makeTempVariableName(0, !!(name.autoGenerateFlags & 8));
            case 2:
              return makeTempVariableName(268435456, !!(name.autoGenerateFlags & 8));
            case 3:
              return makeUniqueName(ts2.idText(name), name.autoGenerateFlags & 32 ? isFileLevelUniqueName : isUniqueName, !!(name.autoGenerateFlags & 16), !!(name.autoGenerateFlags & 8));
          }
          return ts2.Debug.fail("Unsupported GeneratedIdentifierKind.");
        }
        function getNodeForGeneratedName(name) {
          var autoGenerateId = name.autoGenerateId;
          var node = name;
          var original = node.original;
          while (original) {
            node = original;
            if (ts2.isIdentifier(node) && !!(node.autoGenerateFlags & 4) && node.autoGenerateId !== autoGenerateId) {
              break;
            }
            original = node.original;
          }
          return node;
        }
        function pipelineEmitWithComments(hint, node) {
          ts2.Debug.assert(lastNode === node || lastSubstitution === node);
          enterComment();
          hasWrittenComment = false;
          var emitFlags = ts2.getEmitFlags(node);
          var _a2 = ts2.getCommentRange(node), pos = _a2.pos, end = _a2.end;
          var isEmittedNode = node.kind !== 325;
          var skipLeadingComments = pos < 0 || (emitFlags & 512) !== 0 || node.kind === 11;
          var skipTrailingComments = end < 0 || (emitFlags & 1024) !== 0 || node.kind === 11;
          var savedContainerPos = containerPos;
          var savedContainerEnd = containerEnd;
          var savedDeclarationListContainerEnd = declarationListContainerEnd;
          if ((pos > 0 || end > 0) && pos !== end) {
            if (!skipLeadingComments) {
              emitLeadingComments(pos, isEmittedNode);
            }
            if (!skipLeadingComments || pos >= 0 && (emitFlags & 512) !== 0) {
              containerPos = pos;
            }
            if (!skipTrailingComments || end >= 0 && (emitFlags & 1024) !== 0) {
              containerEnd = end;
              if (node.kind === 243) {
                declarationListContainerEnd = end;
              }
            }
          }
          ts2.forEach(ts2.getSyntheticLeadingComments(node), emitLeadingSynthesizedComment);
          exitComment();
          var pipelinePhase = getNextPipelinePhase(2, hint, node);
          if (emitFlags & 2048) {
            commentsDisabled = true;
            pipelinePhase(hint, node);
            commentsDisabled = false;
          } else {
            pipelinePhase(hint, node);
          }
          enterComment();
          ts2.forEach(ts2.getSyntheticTrailingComments(node), emitTrailingSynthesizedComment);
          if ((pos > 0 || end > 0) && pos !== end) {
            containerPos = savedContainerPos;
            containerEnd = savedContainerEnd;
            declarationListContainerEnd = savedDeclarationListContainerEnd;
            if (!skipTrailingComments && isEmittedNode) {
              emitTrailingComments(end);
            }
          }
          exitComment();
          ts2.Debug.assert(lastNode === node || lastSubstitution === node);
        }
        function emitLeadingSynthesizedComment(comment) {
          if (comment.kind === 2) {
            writer.writeLine();
          }
          writeSynthesizedComment(comment);
          if (comment.hasTrailingNewLine || comment.kind === 2) {
            writer.writeLine();
          } else {
            writer.writeSpace(" ");
          }
        }
        function emitTrailingSynthesizedComment(comment) {
          if (!writer.isAtStartOfLine()) {
            writer.writeSpace(" ");
          }
          writeSynthesizedComment(comment);
          if (comment.hasTrailingNewLine) {
            writer.writeLine();
          }
        }
        function writeSynthesizedComment(comment) {
          var text = formatSynthesizedComment(comment);
          var lineMap = comment.kind === 3 ? ts2.computeLineStarts(text) : void 0;
          ts2.writeCommentRange(text, lineMap, writer, 0, text.length, newLine);
        }
        function formatSynthesizedComment(comment) {
          return comment.kind === 3 ? "/*" + comment.text + "*/" : "//" + comment.text;
        }
        function emitBodyWithDetachedComments(node, detachedRange, emitCallback) {
          enterComment();
          var pos = detachedRange.pos, end = detachedRange.end;
          var emitFlags = ts2.getEmitFlags(node);
          var skipLeadingComments = pos < 0 || (emitFlags & 512) !== 0;
          var skipTrailingComments = commentsDisabled || end < 0 || (emitFlags & 1024) !== 0;
          if (!skipLeadingComments) {
            emitDetachedCommentsAndUpdateCommentsInfo(detachedRange);
          }
          exitComment();
          if (emitFlags & 2048 && !commentsDisabled) {
            commentsDisabled = true;
            emitCallback(node);
            commentsDisabled = false;
          } else {
            emitCallback(node);
          }
          enterComment();
          if (!skipTrailingComments) {
            emitLeadingComments(detachedRange.end, true);
            if (hasWrittenComment && !writer.isAtStartOfLine()) {
              writer.writeLine();
            }
          }
          exitComment();
        }
        function emitLeadingComments(pos, isEmittedNode) {
          hasWrittenComment = false;
          if (isEmittedNode) {
            forEachLeadingCommentToEmit(pos, emitLeadingComment);
          } else if (pos === 0) {
            forEachLeadingCommentToEmit(pos, emitTripleSlashLeadingComment);
          }
        }
        function emitTripleSlashLeadingComment(commentPos, commentEnd, kind, hasTrailingNewLine, rangePos) {
          if (isTripleSlashComment(commentPos, commentEnd)) {
            emitLeadingComment(commentPos, commentEnd, kind, hasTrailingNewLine, rangePos);
          }
        }
        function shouldWriteComment(text, pos) {
          if (printerOptions.onlyPrintJsDocStyle) {
            return ts2.isJSDocLikeText(text, pos) || ts2.isPinnedComment(text, pos);
          }
          return true;
        }
        function emitLeadingComment(commentPos, commentEnd, kind, hasTrailingNewLine, rangePos) {
          if (!shouldWriteComment(currentSourceFile.text, commentPos))
            return;
          if (!hasWrittenComment) {
            ts2.emitNewLineBeforeLeadingCommentOfPosition(getCurrentLineMap(), writer, rangePos, commentPos);
            hasWrittenComment = true;
          }
          emitPos(commentPos);
          ts2.writeCommentRange(currentSourceFile.text, getCurrentLineMap(), writer, commentPos, commentEnd, newLine);
          emitPos(commentEnd);
          if (hasTrailingNewLine) {
            writer.writeLine();
          } else if (kind === 3) {
            writer.writeSpace(" ");
          }
        }
        function emitLeadingCommentsOfPosition(pos) {
          if (commentsDisabled || pos === -1) {
            return;
          }
          emitLeadingComments(pos, true);
        }
        function emitTrailingComments(pos) {
          forEachTrailingCommentToEmit(pos, emitTrailingComment);
        }
        function emitTrailingComment(commentPos, commentEnd, _kind, hasTrailingNewLine) {
          if (!shouldWriteComment(currentSourceFile.text, commentPos))
            return;
          if (!writer.isAtStartOfLine()) {
            writer.writeSpace(" ");
          }
          emitPos(commentPos);
          ts2.writeCommentRange(currentSourceFile.text, getCurrentLineMap(), writer, commentPos, commentEnd, newLine);
          emitPos(commentEnd);
          if (hasTrailingNewLine) {
            writer.writeLine();
          }
        }
        function emitTrailingCommentsOfPosition(pos, prefixSpace) {
          if (commentsDisabled) {
            return;
          }
          enterComment();
          forEachTrailingCommentToEmit(pos, prefixSpace ? emitTrailingComment : emitTrailingCommentOfPosition);
          exitComment();
        }
        function emitTrailingCommentOfPosition(commentPos, commentEnd, _kind, hasTrailingNewLine) {
          emitPos(commentPos);
          ts2.writeCommentRange(currentSourceFile.text, getCurrentLineMap(), writer, commentPos, commentEnd, newLine);
          emitPos(commentEnd);
          if (hasTrailingNewLine) {
            writer.writeLine();
          } else {
            writer.writeSpace(" ");
          }
        }
        function forEachLeadingCommentToEmit(pos, cb) {
          if (currentSourceFile && (containerPos === -1 || pos !== containerPos)) {
            if (hasDetachedComments(pos)) {
              forEachLeadingCommentWithoutDetachedComments(cb);
            } else {
              ts2.forEachLeadingCommentRange(currentSourceFile.text, pos, cb, pos);
            }
          }
        }
        function forEachTrailingCommentToEmit(end, cb) {
          if (currentSourceFile && (containerEnd === -1 || end !== containerEnd && end !== declarationListContainerEnd)) {
            ts2.forEachTrailingCommentRange(currentSourceFile.text, end, cb);
          }
        }
        function hasDetachedComments(pos) {
          return detachedCommentsInfo !== void 0 && ts2.last(detachedCommentsInfo).nodePos === pos;
        }
        function forEachLeadingCommentWithoutDetachedComments(cb) {
          var pos = ts2.last(detachedCommentsInfo).detachedCommentEndPos;
          if (detachedCommentsInfo.length - 1) {
            detachedCommentsInfo.pop();
          } else {
            detachedCommentsInfo = void 0;
          }
          ts2.forEachLeadingCommentRange(currentSourceFile.text, pos, cb, pos);
        }
        function emitDetachedCommentsAndUpdateCommentsInfo(range) {
          var currentDetachedCommentInfo = ts2.emitDetachedComments(currentSourceFile.text, getCurrentLineMap(), writer, emitComment, range, newLine, commentsDisabled);
          if (currentDetachedCommentInfo) {
            if (detachedCommentsInfo) {
              detachedCommentsInfo.push(currentDetachedCommentInfo);
            } else {
              detachedCommentsInfo = [currentDetachedCommentInfo];
            }
          }
        }
        function emitComment(text, lineMap, writer2, commentPos, commentEnd, newLine2) {
          if (!shouldWriteComment(currentSourceFile.text, commentPos))
            return;
          emitPos(commentPos);
          ts2.writeCommentRange(text, lineMap, writer2, commentPos, commentEnd, newLine2);
          emitPos(commentEnd);
        }
        function isTripleSlashComment(commentPos, commentEnd) {
          return ts2.isRecognizedTripleSlashComment(currentSourceFile.text, commentPos, commentEnd);
        }
        function getParsedSourceMap(node) {
          if (node.parsedSourceMap === void 0 && node.sourceMapText !== void 0) {
            node.parsedSourceMap = ts2.tryParseRawSourceMap(node.sourceMapText) || false;
          }
          return node.parsedSourceMap || void 0;
        }
        function pipelineEmitWithSourceMap(hint, node) {
          ts2.Debug.assert(lastNode === node || lastSubstitution === node);
          var pipelinePhase = getNextPipelinePhase(3, hint, node);
          if (ts2.isUnparsedSource(node) || ts2.isUnparsedPrepend(node)) {
            pipelinePhase(hint, node);
          } else if (ts2.isUnparsedNode(node)) {
            var parsed = getParsedSourceMap(node.parent);
            if (parsed && sourceMapGenerator) {
              sourceMapGenerator.appendSourceMap(writer.getLine(), writer.getColumn(), parsed, node.parent.sourceMapPath, node.parent.getLineAndCharacterOfPosition(node.pos), node.parent.getLineAndCharacterOfPosition(node.end));
            }
            pipelinePhase(hint, node);
          } else {
            var _a2 = ts2.getSourceMapRange(node), pos = _a2.pos, end = _a2.end, _b2 = _a2.source, source = _b2 === void 0 ? sourceMapSource : _b2;
            var emitFlags = ts2.getEmitFlags(node);
            if (node.kind !== 325 && (emitFlags & 16) === 0 && pos >= 0) {
              emitSourcePos(source, skipSourceTrivia(source, pos));
            }
            if (emitFlags & 64) {
              sourceMapsDisabled = true;
              pipelinePhase(hint, node);
              sourceMapsDisabled = false;
            } else {
              pipelinePhase(hint, node);
            }
            if (node.kind !== 325 && (emitFlags & 32) === 0 && end >= 0) {
              emitSourcePos(source, end);
            }
          }
          ts2.Debug.assert(lastNode === node || lastSubstitution === node);
        }
        function skipSourceTrivia(source, pos) {
          return source.skipTrivia ? source.skipTrivia(pos) : ts2.skipTrivia(source.text, pos);
        }
        function emitPos(pos) {
          if (sourceMapsDisabled || ts2.positionIsSynthesized(pos) || isJsonSourceMapSource(sourceMapSource)) {
            return;
          }
          var _a2 = ts2.getLineAndCharacterOfPosition(sourceMapSource, pos), sourceLine = _a2.line, sourceCharacter = _a2.character;
          sourceMapGenerator.addMapping(writer.getLine(), writer.getColumn(), sourceMapSourceIndex, sourceLine, sourceCharacter, void 0);
        }
        function emitSourcePos(source, pos) {
          if (source !== sourceMapSource) {
            var savedSourceMapSource = sourceMapSource;
            setSourceMapSource(source);
            emitPos(pos);
            setSourceMapSource(savedSourceMapSource);
          } else {
            emitPos(pos);
          }
        }
        function emitTokenWithSourceMap(node, token, writer2, tokenPos, emitCallback) {
          if (sourceMapsDisabled || node && ts2.isInJsonFile(node)) {
            return emitCallback(token, writer2, tokenPos);
          }
          var emitNode = node && node.emitNode;
          var emitFlags = emitNode && emitNode.flags || 0;
          var range = emitNode && emitNode.tokenSourceMapRanges && emitNode.tokenSourceMapRanges[token];
          var source = range && range.source || sourceMapSource;
          tokenPos = skipSourceTrivia(source, range ? range.pos : tokenPos);
          if ((emitFlags & 128) === 0 && tokenPos >= 0) {
            emitSourcePos(source, tokenPos);
          }
          tokenPos = emitCallback(token, writer2, tokenPos);
          if (range)
            tokenPos = range.end;
          if ((emitFlags & 256) === 0 && tokenPos >= 0) {
            emitSourcePos(source, tokenPos);
          }
          return tokenPos;
        }
        function setSourceMapSource(source) {
          if (sourceMapsDisabled) {
            return;
          }
          sourceMapSource = source;
          if (isJsonSourceMapSource(source)) {
            return;
          }
          sourceMapSourceIndex = sourceMapGenerator.addSource(source.fileName);
          if (printerOptions.inlineSources) {
            sourceMapGenerator.setSourceContent(sourceMapSourceIndex, source.text);
          }
        }
        function isJsonSourceMapSource(sourceFile) {
          return ts2.fileExtensionIs(sourceFile.fileName, ".json");
        }
      }
      ts2.createPrinter = createPrinter;
      function createBracketsMap() {
        var brackets2 = [];
        brackets2[1024] = ["{", "}"];
        brackets2[2048] = ["(", ")"];
        brackets2[4096] = ["<", ">"];
        brackets2[8192] = ["[", "]"];
        return brackets2;
      }
      function getOpeningBracket(format) {
        return brackets[format & 15360][0];
      }
      function getClosingBracket(format) {
        return brackets[format & 15360][1];
      }
      var TempFlags;
      (function(TempFlags2) {
        TempFlags2[TempFlags2["Auto"] = 0] = "Auto";
        TempFlags2[TempFlags2["CountMask"] = 268435455] = "CountMask";
        TempFlags2[TempFlags2["_i"] = 268435456] = "_i";
      })(TempFlags || (TempFlags = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function createCachedDirectoryStructureHost(host, currentDirectory, useCaseSensitiveFileNames) {
        if (!host.getDirectories || !host.readDirectory) {
          return void 0;
        }
        var cachedReadDirectoryResult = ts2.createMap();
        var getCanonicalFileName = ts2.createGetCanonicalFileName(useCaseSensitiveFileNames);
        return {
          useCaseSensitiveFileNames,
          fileExists,
          readFile: function(path2, encoding) {
            return host.readFile(path2, encoding);
          },
          directoryExists: host.directoryExists && directoryExists,
          getDirectories,
          readDirectory,
          createDirectory: host.createDirectory && createDirectory,
          writeFile: host.writeFile && writeFile,
          addOrDeleteFileOrDirectory,
          addOrDeleteFile,
          clearCache,
          realpath: host.realpath && realpath
        };
        function toPath(fileName) {
          return ts2.toPath(fileName, currentDirectory, getCanonicalFileName);
        }
        function getCachedFileSystemEntries(rootDirPath) {
          return cachedReadDirectoryResult.get(ts2.ensureTrailingDirectorySeparator(rootDirPath));
        }
        function getCachedFileSystemEntriesForBaseDir(path2) {
          return getCachedFileSystemEntries(ts2.getDirectoryPath(path2));
        }
        function getBaseNameOfFileName(fileName) {
          return ts2.getBaseFileName(ts2.normalizePath(fileName));
        }
        function createCachedFileSystemEntries(rootDir, rootDirPath) {
          var resultFromHost = {
            files: ts2.map(host.readDirectory(rootDir, void 0, void 0, ["*.*"]), getBaseNameOfFileName) || [],
            directories: host.getDirectories(rootDir) || []
          };
          cachedReadDirectoryResult.set(ts2.ensureTrailingDirectorySeparator(rootDirPath), resultFromHost);
          return resultFromHost;
        }
        function tryReadDirectory(rootDir, rootDirPath) {
          rootDirPath = ts2.ensureTrailingDirectorySeparator(rootDirPath);
          var cachedResult = getCachedFileSystemEntries(rootDirPath);
          if (cachedResult) {
            return cachedResult;
          }
          try {
            return createCachedFileSystemEntries(rootDir, rootDirPath);
          } catch (_e) {
            ts2.Debug.assert(!cachedReadDirectoryResult.has(ts2.ensureTrailingDirectorySeparator(rootDirPath)));
            return void 0;
          }
        }
        function fileNameEqual(name1, name2) {
          return getCanonicalFileName(name1) === getCanonicalFileName(name2);
        }
        function hasEntry(entries, name) {
          return ts2.some(entries, function(file) {
            return fileNameEqual(file, name);
          });
        }
        function updateFileSystemEntry(entries, baseName, isValid) {
          if (hasEntry(entries, baseName)) {
            if (!isValid) {
              return ts2.filterMutate(entries, function(entry) {
                return !fileNameEqual(entry, baseName);
              });
            }
          } else if (isValid) {
            return entries.push(baseName);
          }
        }
        function writeFile(fileName, data, writeByteOrderMark) {
          var path2 = toPath(fileName);
          var result = getCachedFileSystemEntriesForBaseDir(path2);
          if (result) {
            updateFilesOfFileSystemEntry(result, getBaseNameOfFileName(fileName), true);
          }
          return host.writeFile(fileName, data, writeByteOrderMark);
        }
        function fileExists(fileName) {
          var path2 = toPath(fileName);
          var result = getCachedFileSystemEntriesForBaseDir(path2);
          return result && hasEntry(result.files, getBaseNameOfFileName(fileName)) || host.fileExists(fileName);
        }
        function directoryExists(dirPath) {
          var path2 = toPath(dirPath);
          return cachedReadDirectoryResult.has(ts2.ensureTrailingDirectorySeparator(path2)) || host.directoryExists(dirPath);
        }
        function createDirectory(dirPath) {
          var path2 = toPath(dirPath);
          var result = getCachedFileSystemEntriesForBaseDir(path2);
          var baseFileName = getBaseNameOfFileName(dirPath);
          if (result) {
            updateFileSystemEntry(result.directories, baseFileName, true);
          }
          host.createDirectory(dirPath);
        }
        function getDirectories(rootDir) {
          var rootDirPath = toPath(rootDir);
          var result = tryReadDirectory(rootDir, rootDirPath);
          if (result) {
            return result.directories.slice();
          }
          return host.getDirectories(rootDir);
        }
        function readDirectory(rootDir, extensions, excludes, includes, depth) {
          var rootDirPath = toPath(rootDir);
          var result = tryReadDirectory(rootDir, rootDirPath);
          if (result) {
            return ts2.matchFiles(rootDir, extensions, excludes, includes, useCaseSensitiveFileNames, currentDirectory, depth, getFileSystemEntries, realpath);
          }
          return host.readDirectory(rootDir, extensions, excludes, includes, depth);
          function getFileSystemEntries(dir) {
            var path2 = toPath(dir);
            if (path2 === rootDirPath) {
              return result;
            }
            return tryReadDirectory(dir, path2) || ts2.emptyFileSystemEntries;
          }
        }
        function realpath(s) {
          return host.realpath ? host.realpath(s) : s;
        }
        function addOrDeleteFileOrDirectory(fileOrDirectory, fileOrDirectoryPath) {
          var existingResult = getCachedFileSystemEntries(fileOrDirectoryPath);
          if (existingResult) {
            clearCache();
            return void 0;
          }
          var parentResult = getCachedFileSystemEntriesForBaseDir(fileOrDirectoryPath);
          if (!parentResult) {
            return void 0;
          }
          if (!host.directoryExists) {
            clearCache();
            return void 0;
          }
          var baseName = getBaseNameOfFileName(fileOrDirectory);
          var fsQueryResult = {
            fileExists: host.fileExists(fileOrDirectoryPath),
            directoryExists: host.directoryExists(fileOrDirectoryPath)
          };
          if (fsQueryResult.directoryExists || hasEntry(parentResult.directories, baseName)) {
            clearCache();
          } else {
            updateFilesOfFileSystemEntry(parentResult, baseName, fsQueryResult.fileExists);
          }
          return fsQueryResult;
        }
        function addOrDeleteFile(fileName, filePath, eventKind) {
          if (eventKind === ts2.FileWatcherEventKind.Changed) {
            return;
          }
          var parentResult = getCachedFileSystemEntriesForBaseDir(filePath);
          if (parentResult) {
            updateFilesOfFileSystemEntry(parentResult, getBaseNameOfFileName(fileName), eventKind === ts2.FileWatcherEventKind.Created);
          }
        }
        function updateFilesOfFileSystemEntry(parentResult, baseName, fileExists2) {
          updateFileSystemEntry(parentResult.files, baseName, fileExists2);
        }
        function clearCache() {
          cachedReadDirectoryResult.clear();
        }
      }
      ts2.createCachedDirectoryStructureHost = createCachedDirectoryStructureHost;
      var ConfigFileProgramReloadLevel;
      (function(ConfigFileProgramReloadLevel2) {
        ConfigFileProgramReloadLevel2[ConfigFileProgramReloadLevel2["None"] = 0] = "None";
        ConfigFileProgramReloadLevel2[ConfigFileProgramReloadLevel2["Partial"] = 1] = "Partial";
        ConfigFileProgramReloadLevel2[ConfigFileProgramReloadLevel2["Full"] = 2] = "Full";
      })(ConfigFileProgramReloadLevel = ts2.ConfigFileProgramReloadLevel || (ts2.ConfigFileProgramReloadLevel = {}));
      function updateMissingFilePathsWatch(program, missingFileWatches, createMissingFileWatch) {
        var missingFilePaths = program.getMissingFilePaths();
        var newMissingFilePathMap = ts2.arrayToSet(missingFilePaths);
        ts2.mutateMap(missingFileWatches, newMissingFilePathMap, {
          createNewValue: createMissingFileWatch,
          onDeleteValue: ts2.closeFileWatcher
        });
      }
      ts2.updateMissingFilePathsWatch = updateMissingFilePathsWatch;
      function updateWatchingWildcardDirectories(existingWatchedForWildcards, wildcardDirectories, watchDirectory2) {
        ts2.mutateMap(existingWatchedForWildcards, wildcardDirectories, {
          createNewValue: createWildcardDirectoryWatcher,
          onDeleteValue: closeFileWatcherOf,
          onExistingValue: updateWildcardDirectoryWatcher
        });
        function createWildcardDirectoryWatcher(directory, flags) {
          return {
            watcher: watchDirectory2(directory, flags),
            flags
          };
        }
        function updateWildcardDirectoryWatcher(existingWatcher, flags, directory) {
          if (existingWatcher.flags === flags) {
            return;
          }
          existingWatcher.watcher.close();
          existingWatchedForWildcards.set(directory, createWildcardDirectoryWatcher(directory, flags));
        }
      }
      ts2.updateWatchingWildcardDirectories = updateWatchingWildcardDirectories;
      function isEmittedFileOfProgram(program, file) {
        if (!program) {
          return false;
        }
        return program.isEmittedFile(file);
      }
      ts2.isEmittedFileOfProgram = isEmittedFileOfProgram;
      var WatchLogLevel;
      (function(WatchLogLevel2) {
        WatchLogLevel2[WatchLogLevel2["None"] = 0] = "None";
        WatchLogLevel2[WatchLogLevel2["TriggerOnly"] = 1] = "TriggerOnly";
        WatchLogLevel2[WatchLogLevel2["Verbose"] = 2] = "Verbose";
      })(WatchLogLevel = ts2.WatchLogLevel || (ts2.WatchLogLevel = {}));
      function getWatchFactory(watchLogLevel, log, getDetailWatchInfo) {
        return getWatchFactoryWith(watchLogLevel, log, getDetailWatchInfo, watchFile, watchDirectory);
      }
      ts2.getWatchFactory = getWatchFactory;
      function getWatchFactoryWith(watchLogLevel, log, getDetailWatchInfo, watchFile2, watchDirectory2) {
        var createFileWatcher = getCreateFileWatcher(watchLogLevel, watchFile2);
        var createFilePathWatcher = watchLogLevel === WatchLogLevel.None ? watchFilePath : createFileWatcher;
        var createDirectoryWatcher = getCreateFileWatcher(watchLogLevel, watchDirectory2);
        if (watchLogLevel === WatchLogLevel.Verbose && ts2.sysLog === ts2.noop) {
          ts2.setSysLog(function(s) {
            return log(s);
          });
        }
        return {
          watchFile: function(host, file, callback, pollingInterval, options, detailInfo1, detailInfo2) {
            return createFileWatcher(host, file, callback, pollingInterval, options, void 0, detailInfo1, detailInfo2, watchFile2, log, "FileWatcher", getDetailWatchInfo);
          },
          watchFilePath: function(host, file, callback, pollingInterval, options, path2, detailInfo1, detailInfo2) {
            return createFilePathWatcher(host, file, callback, pollingInterval, options, path2, detailInfo1, detailInfo2, watchFile2, log, "FileWatcher", getDetailWatchInfo);
          },
          watchDirectory: function(host, directory, callback, flags, options, detailInfo1, detailInfo2) {
            return createDirectoryWatcher(host, directory, callback, flags, options, void 0, detailInfo1, detailInfo2, watchDirectory2, log, "DirectoryWatcher", getDetailWatchInfo);
          }
        };
      }
      function watchFile(host, file, callback, pollingInterval, options) {
        return host.watchFile(file, callback, pollingInterval, options);
      }
      function watchFilePath(host, file, callback, pollingInterval, options, path2) {
        return watchFile(host, file, function(fileName, eventKind) {
          return callback(fileName, eventKind, path2);
        }, pollingInterval, options);
      }
      function watchDirectory(host, directory, callback, flags, options) {
        return host.watchDirectory(directory, callback, (flags & 1) !== 0, options);
      }
      function getCreateFileWatcher(watchLogLevel, addWatch) {
        switch (watchLogLevel) {
          case WatchLogLevel.None:
            return addWatch;
          case WatchLogLevel.TriggerOnly:
            return createFileWatcherWithTriggerLogging;
          case WatchLogLevel.Verbose:
            return addWatch === watchDirectory ? createDirectoryWatcherWithLogging : createFileWatcherWithLogging;
        }
      }
      function createFileWatcherWithLogging(host, file, cb, flags, options, passThrough, detailInfo1, detailInfo2, addWatch, log, watchCaption, getDetailWatchInfo) {
        log(watchCaption + ":: Added:: " + getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo));
        var watcher = createFileWatcherWithTriggerLogging(host, file, cb, flags, options, passThrough, detailInfo1, detailInfo2, addWatch, log, watchCaption, getDetailWatchInfo);
        return {
          close: function() {
            log(watchCaption + ":: Close:: " + getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo));
            watcher.close();
          }
        };
      }
      function createDirectoryWatcherWithLogging(host, file, cb, flags, options, passThrough, detailInfo1, detailInfo2, addWatch, log, watchCaption, getDetailWatchInfo) {
        var watchInfo = watchCaption + ":: Added:: " + getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo);
        log(watchInfo);
        var start = ts2.timestamp();
        var watcher = createFileWatcherWithTriggerLogging(host, file, cb, flags, options, passThrough, detailInfo1, detailInfo2, addWatch, log, watchCaption, getDetailWatchInfo);
        var elapsed = ts2.timestamp() - start;
        log("Elapsed:: " + elapsed + "ms " + watchInfo);
        return {
          close: function() {
            var watchInfo2 = watchCaption + ":: Close:: " + getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo);
            log(watchInfo2);
            var start2 = ts2.timestamp();
            watcher.close();
            var elapsed2 = ts2.timestamp() - start2;
            log("Elapsed:: " + elapsed2 + "ms " + watchInfo2);
          }
        };
      }
      function createFileWatcherWithTriggerLogging(host, file, cb, flags, options, passThrough, detailInfo1, detailInfo2, addWatch, log, watchCaption, getDetailWatchInfo) {
        return addWatch(host, file, function(fileName, cbOptional) {
          var triggerredInfo = watchCaption + ":: Triggered with " + fileName + " " + (cbOptional !== void 0 ? cbOptional : "") + ":: " + getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo);
          log(triggerredInfo);
          var start = ts2.timestamp();
          cb(fileName, cbOptional, passThrough);
          var elapsed = ts2.timestamp() - start;
          log("Elapsed:: " + elapsed + "ms " + triggerredInfo);
        }, flags, options);
      }
      function getFallbackOptions(options) {
        var fallbackPolling = options === null || options === void 0 ? void 0 : options.fallbackPolling;
        return {
          watchFile: fallbackPolling !== void 0 ? fallbackPolling : ts2.WatchFileKind.PriorityPollingInterval
        };
      }
      ts2.getFallbackOptions = getFallbackOptions;
      function getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo) {
        return "WatchInfo: " + file + " " + flags + " " + JSON.stringify(options) + " " + (getDetailWatchInfo ? getDetailWatchInfo(detailInfo1, detailInfo2) : detailInfo2 === void 0 ? detailInfo1 : detailInfo1 + " " + detailInfo2);
      }
      function closeFileWatcherOf(objWithWatcher) {
        objWithWatcher.watcher.close();
      }
      ts2.closeFileWatcherOf = closeFileWatcherOf;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function findConfigFile(searchPath, fileExists, configName) {
        if (configName === void 0) {
          configName = "tsconfig.json";
        }
        return ts2.forEachAncestorDirectory(searchPath, function(ancestor) {
          var fileName = ts2.combinePaths(ancestor, configName);
          return fileExists(fileName) ? fileName : void 0;
        });
      }
      ts2.findConfigFile = findConfigFile;
      function resolveTripleslashReference(moduleName, containingFile) {
        var basePath = ts2.getDirectoryPath(containingFile);
        var referencedFileName = ts2.isRootedDiskPath(moduleName) ? moduleName : ts2.combinePaths(basePath, moduleName);
        return ts2.normalizePath(referencedFileName);
      }
      ts2.resolveTripleslashReference = resolveTripleslashReference;
      function computeCommonSourceDirectoryOfFilenames(fileNames, currentDirectory, getCanonicalFileName) {
        var commonPathComponents;
        var failed = ts2.forEach(fileNames, function(sourceFile) {
          var sourcePathComponents = ts2.getNormalizedPathComponents(sourceFile, currentDirectory);
          sourcePathComponents.pop();
          if (!commonPathComponents) {
            commonPathComponents = sourcePathComponents;
            return;
          }
          var n = Math.min(commonPathComponents.length, sourcePathComponents.length);
          for (var i = 0; i < n; i++) {
            if (getCanonicalFileName(commonPathComponents[i]) !== getCanonicalFileName(sourcePathComponents[i])) {
              if (i === 0) {
                return true;
              }
              commonPathComponents.length = i;
              break;
            }
          }
          if (sourcePathComponents.length < commonPathComponents.length) {
            commonPathComponents.length = sourcePathComponents.length;
          }
        });
        if (failed) {
          return "";
        }
        if (!commonPathComponents) {
          return currentDirectory;
        }
        return ts2.getPathFromPathComponents(commonPathComponents);
      }
      ts2.computeCommonSourceDirectoryOfFilenames = computeCommonSourceDirectoryOfFilenames;
      function createCompilerHost(options, setParentNodes) {
        return createCompilerHostWorker(options, setParentNodes);
      }
      ts2.createCompilerHost = createCompilerHost;
      function createCompilerHostWorker(options, setParentNodes, system) {
        if (system === void 0) {
          system = ts2.sys;
        }
        var existingDirectories = ts2.createMap();
        var getCanonicalFileName = ts2.createGetCanonicalFileName(system.useCaseSensitiveFileNames);
        function getSourceFile(fileName, languageVersion, onError) {
          var text;
          try {
            ts2.performance.mark("beforeIORead");
            text = compilerHost.readFile(fileName);
            ts2.performance.mark("afterIORead");
            ts2.performance.measure("I/O Read", "beforeIORead", "afterIORead");
          } catch (e) {
            if (onError) {
              onError(e.message);
            }
            text = "";
          }
          return text !== void 0 ? ts2.createSourceFile(fileName, text, languageVersion, setParentNodes) : void 0;
        }
        function directoryExists(directoryPath) {
          if (existingDirectories.has(directoryPath)) {
            return true;
          }
          if ((compilerHost.directoryExists || system.directoryExists)(directoryPath)) {
            existingDirectories.set(directoryPath, true);
            return true;
          }
          return false;
        }
        function writeFile(fileName, data, writeByteOrderMark, onError) {
          try {
            ts2.performance.mark("beforeIOWrite");
            ts2.writeFileEnsuringDirectories(fileName, data, writeByteOrderMark, function(path2, data2, writeByteOrderMark2) {
              return writeFileWorker(path2, data2, writeByteOrderMark2);
            }, function(path2) {
              return (compilerHost.createDirectory || system.createDirectory)(path2);
            }, function(path2) {
              return directoryExists(path2);
            });
            ts2.performance.mark("afterIOWrite");
            ts2.performance.measure("I/O Write", "beforeIOWrite", "afterIOWrite");
          } catch (e) {
            if (onError) {
              onError(e.message);
            }
          }
        }
        var outputFingerprints;
        function writeFileWorker(fileName, data, writeByteOrderMark) {
          if (!ts2.isWatchSet(options) || !system.createHash || !system.getModifiedTime) {
            system.writeFile(fileName, data, writeByteOrderMark);
            return;
          }
          if (!outputFingerprints) {
            outputFingerprints = ts2.createMap();
          }
          var hash = system.createHash(data);
          var mtimeBefore = system.getModifiedTime(fileName);
          if (mtimeBefore) {
            var fingerprint = outputFingerprints.get(fileName);
            if (fingerprint && fingerprint.byteOrderMark === writeByteOrderMark && fingerprint.hash === hash && fingerprint.mtime.getTime() === mtimeBefore.getTime()) {
              return;
            }
          }
          system.writeFile(fileName, data, writeByteOrderMark);
          var mtimeAfter = system.getModifiedTime(fileName) || ts2.missingFileModifiedTime;
          outputFingerprints.set(fileName, {
            hash,
            byteOrderMark: writeByteOrderMark,
            mtime: mtimeAfter
          });
        }
        function getDefaultLibLocation() {
          return ts2.getDirectoryPath(ts2.normalizePath(system.getExecutingFilePath()));
        }
        var newLine = ts2.getNewLineCharacter(options, function() {
          return system.newLine;
        });
        var realpath = system.realpath && function(path2) {
          return system.realpath(path2);
        };
        var compilerHost = {
          getSourceFile,
          getDefaultLibLocation,
          getDefaultLibFileName: function(options2) {
            return ts2.combinePaths(getDefaultLibLocation(), ts2.getDefaultLibFileName(options2));
          },
          writeFile,
          getCurrentDirectory: ts2.memoize(function() {
            return system.getCurrentDirectory();
          }),
          useCaseSensitiveFileNames: function() {
            return system.useCaseSensitiveFileNames;
          },
          getCanonicalFileName,
          getNewLine: function() {
            return newLine;
          },
          fileExists: function(fileName) {
            return system.fileExists(fileName);
          },
          readFile: function(fileName) {
            return system.readFile(fileName);
          },
          trace: function(s) {
            return system.write(s + newLine);
          },
          directoryExists: function(directoryName) {
            return system.directoryExists(directoryName);
          },
          getEnvironmentVariable: function(name) {
            return system.getEnvironmentVariable ? system.getEnvironmentVariable(name) : "";
          },
          getDirectories: function(path2) {
            return system.getDirectories(path2);
          },
          realpath,
          readDirectory: function(path2, extensions, include, exclude, depth) {
            return system.readDirectory(path2, extensions, include, exclude, depth);
          },
          createDirectory: function(d) {
            return system.createDirectory(d);
          },
          createHash: ts2.maybeBind(system, system.createHash)
        };
        return compilerHost;
      }
      ts2.createCompilerHostWorker = createCompilerHostWorker;
      function changeCompilerHostLikeToUseCache(host, toPath, getSourceFile) {
        var originalReadFile = host.readFile;
        var originalFileExists = host.fileExists;
        var originalDirectoryExists = host.directoryExists;
        var originalCreateDirectory = host.createDirectory;
        var originalWriteFile = host.writeFile;
        var readFileCache = ts2.createMap();
        var fileExistsCache = ts2.createMap();
        var directoryExistsCache = ts2.createMap();
        var sourceFileCache = ts2.createMap();
        var readFileWithCache = function(fileName) {
          var key = toPath(fileName);
          var value = readFileCache.get(key);
          if (value !== void 0)
            return value !== false ? value : void 0;
          return setReadFileCache(key, fileName);
        };
        var setReadFileCache = function(key, fileName) {
          var newValue = originalReadFile.call(host, fileName);
          readFileCache.set(key, newValue !== void 0 ? newValue : false);
          return newValue;
        };
        host.readFile = function(fileName) {
          var key = toPath(fileName);
          var value = readFileCache.get(key);
          if (value !== void 0)
            return value !== false ? value : void 0;
          if (!ts2.fileExtensionIs(fileName, ".json") && !ts2.isBuildInfoFile(fileName)) {
            return originalReadFile.call(host, fileName);
          }
          return setReadFileCache(key, fileName);
        };
        var getSourceFileWithCache = getSourceFile ? function(fileName, languageVersion, onError, shouldCreateNewSourceFile) {
          var key = toPath(fileName);
          var value = sourceFileCache.get(key);
          if (value)
            return value;
          var sourceFile = getSourceFile(fileName, languageVersion, onError, shouldCreateNewSourceFile);
          if (sourceFile && (ts2.isDeclarationFileName(fileName) || ts2.fileExtensionIs(fileName, ".json"))) {
            sourceFileCache.set(key, sourceFile);
          }
          return sourceFile;
        } : void 0;
        host.fileExists = function(fileName) {
          var key = toPath(fileName);
          var value = fileExistsCache.get(key);
          if (value !== void 0)
            return value;
          var newValue = originalFileExists.call(host, fileName);
          fileExistsCache.set(key, !!newValue);
          return newValue;
        };
        if (originalWriteFile) {
          host.writeFile = function(fileName, data, writeByteOrderMark, onError, sourceFiles) {
            var key = toPath(fileName);
            fileExistsCache.delete(key);
            var value = readFileCache.get(key);
            if (value !== void 0 && value !== data) {
              readFileCache.delete(key);
              sourceFileCache.delete(key);
            } else if (getSourceFileWithCache) {
              var sourceFile = sourceFileCache.get(key);
              if (sourceFile && sourceFile.text !== data) {
                sourceFileCache.delete(key);
              }
            }
            originalWriteFile.call(host, fileName, data, writeByteOrderMark, onError, sourceFiles);
          };
        }
        if (originalDirectoryExists && originalCreateDirectory) {
          host.directoryExists = function(directory) {
            var key = toPath(directory);
            var value = directoryExistsCache.get(key);
            if (value !== void 0)
              return value;
            var newValue = originalDirectoryExists.call(host, directory);
            directoryExistsCache.set(key, !!newValue);
            return newValue;
          };
          host.createDirectory = function(directory) {
            var key = toPath(directory);
            directoryExistsCache.delete(key);
            originalCreateDirectory.call(host, directory);
          };
        }
        return {
          originalReadFile,
          originalFileExists,
          originalDirectoryExists,
          originalCreateDirectory,
          originalWriteFile,
          getSourceFileWithCache,
          readFileWithCache
        };
      }
      ts2.changeCompilerHostLikeToUseCache = changeCompilerHostLikeToUseCache;
      function getPreEmitDiagnostics(program, sourceFile, cancellationToken) {
        var diagnostics;
        diagnostics = ts2.addRange(diagnostics, program.getConfigFileParsingDiagnostics());
        diagnostics = ts2.addRange(diagnostics, program.getOptionsDiagnostics(cancellationToken));
        diagnostics = ts2.addRange(diagnostics, program.getSyntacticDiagnostics(sourceFile, cancellationToken));
        diagnostics = ts2.addRange(diagnostics, program.getGlobalDiagnostics(cancellationToken));
        diagnostics = ts2.addRange(diagnostics, program.getSemanticDiagnostics(sourceFile, cancellationToken));
        if (ts2.getEmitDeclarations(program.getCompilerOptions())) {
          diagnostics = ts2.addRange(diagnostics, program.getDeclarationDiagnostics(sourceFile, cancellationToken));
        }
        return ts2.sortAndDeduplicateDiagnostics(diagnostics || ts2.emptyArray);
      }
      ts2.getPreEmitDiagnostics = getPreEmitDiagnostics;
      function formatDiagnostics(diagnostics, host) {
        var output = "";
        for (var _i = 0, diagnostics_2 = diagnostics; _i < diagnostics_2.length; _i++) {
          var diagnostic = diagnostics_2[_i];
          output += formatDiagnostic(diagnostic, host);
        }
        return output;
      }
      ts2.formatDiagnostics = formatDiagnostics;
      function formatDiagnostic(diagnostic, host) {
        var errorMessage = ts2.diagnosticCategoryName(diagnostic) + " TS" + diagnostic.code + ": " + flattenDiagnosticMessageText(diagnostic.messageText, host.getNewLine()) + host.getNewLine();
        if (diagnostic.file) {
          var _a = ts2.getLineAndCharacterOfPosition(diagnostic.file, diagnostic.start), line = _a.line, character = _a.character;
          var fileName = diagnostic.file.fileName;
          var relativeFileName = ts2.convertToRelativePath(fileName, host.getCurrentDirectory(), function(fileName2) {
            return host.getCanonicalFileName(fileName2);
          });
          return relativeFileName + "(" + (line + 1) + "," + (character + 1) + "): " + errorMessage;
        }
        return errorMessage;
      }
      ts2.formatDiagnostic = formatDiagnostic;
      var ForegroundColorEscapeSequences;
      (function(ForegroundColorEscapeSequences2) {
        ForegroundColorEscapeSequences2["Grey"] = "[90m";
        ForegroundColorEscapeSequences2["Red"] = "[91m";
        ForegroundColorEscapeSequences2["Yellow"] = "[93m";
        ForegroundColorEscapeSequences2["Blue"] = "[94m";
        ForegroundColorEscapeSequences2["Cyan"] = "[96m";
      })(ForegroundColorEscapeSequences = ts2.ForegroundColorEscapeSequences || (ts2.ForegroundColorEscapeSequences = {}));
      var gutterStyleSequence = "[7m";
      var gutterSeparator = " ";
      var resetEscapeSequence = "[0m";
      var ellipsis = "...";
      var halfIndent = "  ";
      var indent = "    ";
      function getCategoryFormat(category) {
        switch (category) {
          case ts2.DiagnosticCategory.Error:
            return ForegroundColorEscapeSequences.Red;
          case ts2.DiagnosticCategory.Warning:
            return ForegroundColorEscapeSequences.Yellow;
          case ts2.DiagnosticCategory.Suggestion:
            return ts2.Debug.fail("Should never get an Info diagnostic on the command line.");
          case ts2.DiagnosticCategory.Message:
            return ForegroundColorEscapeSequences.Blue;
        }
      }
      function formatColorAndReset(text, formatStyle) {
        return formatStyle + text + resetEscapeSequence;
      }
      ts2.formatColorAndReset = formatColorAndReset;
      function formatCodeSpan(file, start, length, indent2, squiggleColor, host) {
        var _a = ts2.getLineAndCharacterOfPosition(file, start), firstLine = _a.line, firstLineChar = _a.character;
        var _b = ts2.getLineAndCharacterOfPosition(file, start + length), lastLine = _b.line, lastLineChar = _b.character;
        var lastLineInFile = ts2.getLineAndCharacterOfPosition(file, file.text.length).line;
        var hasMoreThanFiveLines = lastLine - firstLine >= 4;
        var gutterWidth = (lastLine + 1 + "").length;
        if (hasMoreThanFiveLines) {
          gutterWidth = Math.max(ellipsis.length, gutterWidth);
        }
        var context = "";
        for (var i = firstLine; i <= lastLine; i++) {
          context += host.getNewLine();
          if (hasMoreThanFiveLines && firstLine + 1 < i && i < lastLine - 1) {
            context += indent2 + formatColorAndReset(ts2.padLeft(ellipsis, gutterWidth), gutterStyleSequence) + gutterSeparator + host.getNewLine();
            i = lastLine - 1;
          }
          var lineStart = ts2.getPositionOfLineAndCharacter(file, i, 0);
          var lineEnd = i < lastLineInFile ? ts2.getPositionOfLineAndCharacter(file, i + 1, 0) : file.text.length;
          var lineContent = file.text.slice(lineStart, lineEnd);
          lineContent = lineContent.replace(/\s+$/g, "");
          lineContent = lineContent.replace("	", " ");
          context += indent2 + formatColorAndReset(ts2.padLeft(i + 1 + "", gutterWidth), gutterStyleSequence) + gutterSeparator;
          context += lineContent + host.getNewLine();
          context += indent2 + formatColorAndReset(ts2.padLeft("", gutterWidth), gutterStyleSequence) + gutterSeparator;
          context += squiggleColor;
          if (i === firstLine) {
            var lastCharForLine = i === lastLine ? lastLineChar : void 0;
            context += lineContent.slice(0, firstLineChar).replace(/\S/g, " ");
            context += lineContent.slice(firstLineChar, lastCharForLine).replace(/./g, "~");
          } else if (i === lastLine) {
            context += lineContent.slice(0, lastLineChar).replace(/./g, "~");
          } else {
            context += lineContent.replace(/./g, "~");
          }
          context += resetEscapeSequence;
        }
        return context;
      }
      function formatLocation(file, start, host, color) {
        if (color === void 0) {
          color = formatColorAndReset;
        }
        var _a = ts2.getLineAndCharacterOfPosition(file, start), firstLine = _a.line, firstLineChar = _a.character;
        var relativeFileName = host ? ts2.convertToRelativePath(file.fileName, host.getCurrentDirectory(), function(fileName) {
          return host.getCanonicalFileName(fileName);
        }) : file.fileName;
        var output = "";
        output += color(relativeFileName, ForegroundColorEscapeSequences.Cyan);
        output += ":";
        output += color("" + (firstLine + 1), ForegroundColorEscapeSequences.Yellow);
        output += ":";
        output += color("" + (firstLineChar + 1), ForegroundColorEscapeSequences.Yellow);
        return output;
      }
      ts2.formatLocation = formatLocation;
      function formatDiagnosticsWithColorAndContext(diagnostics, host) {
        var output = "";
        for (var _i = 0, diagnostics_3 = diagnostics; _i < diagnostics_3.length; _i++) {
          var diagnostic = diagnostics_3[_i];
          if (diagnostic.file) {
            var file = diagnostic.file, start = diagnostic.start;
            output += formatLocation(file, start, host);
            output += " - ";
          }
          output += formatColorAndReset(ts2.diagnosticCategoryName(diagnostic), getCategoryFormat(diagnostic.category));
          output += formatColorAndReset(" TS" + diagnostic.code + ": ", ForegroundColorEscapeSequences.Grey);
          output += flattenDiagnosticMessageText(diagnostic.messageText, host.getNewLine());
          if (diagnostic.file) {
            output += host.getNewLine();
            output += formatCodeSpan(diagnostic.file, diagnostic.start, diagnostic.length, "", getCategoryFormat(diagnostic.category), host);
            if (diagnostic.relatedInformation) {
              output += host.getNewLine();
              for (var _a = 0, _b = diagnostic.relatedInformation; _a < _b.length; _a++) {
                var _c = _b[_a], file = _c.file, start = _c.start, length_8 = _c.length, messageText = _c.messageText;
                if (file) {
                  output += host.getNewLine();
                  output += halfIndent + formatLocation(file, start, host);
                  output += formatCodeSpan(file, start, length_8, indent, ForegroundColorEscapeSequences.Cyan, host);
                }
                output += host.getNewLine();
                output += indent + flattenDiagnosticMessageText(messageText, host.getNewLine());
              }
            }
          }
          output += host.getNewLine();
        }
        return output;
      }
      ts2.formatDiagnosticsWithColorAndContext = formatDiagnosticsWithColorAndContext;
      function flattenDiagnosticMessageText(diag, newLine, indent2) {
        if (indent2 === void 0) {
          indent2 = 0;
        }
        if (ts2.isString(diag)) {
          return diag;
        } else if (diag === void 0) {
          return "";
        }
        var result = "";
        if (indent2) {
          result += newLine;
          for (var i = 0; i < indent2; i++) {
            result += "  ";
          }
        }
        result += diag.messageText;
        indent2++;
        if (diag.next) {
          for (var _i = 0, _a = diag.next; _i < _a.length; _i++) {
            var kid = _a[_i];
            result += flattenDiagnosticMessageText(kid, newLine, indent2);
          }
        }
        return result;
      }
      ts2.flattenDiagnosticMessageText = flattenDiagnosticMessageText;
      function loadWithLocalCache(names, containingFile, redirectedReference, loader) {
        if (names.length === 0) {
          return [];
        }
        var resolutions = [];
        var cache = ts2.createMap();
        for (var _i = 0, names_2 = names; _i < names_2.length; _i++) {
          var name = names_2[_i];
          var result = void 0;
          if (cache.has(name)) {
            result = cache.get(name);
          } else {
            cache.set(name, result = loader(name, containingFile, redirectedReference));
          }
          resolutions.push(result);
        }
        return resolutions;
      }
      ts2.loadWithLocalCache = loadWithLocalCache;
      ts2.inferredTypesContainingFile = "__inferred type names__.ts";
      function isProgramUptoDate(program, rootFileNames, newOptions, getSourceVersion, fileExists, hasInvalidatedResolution, hasChangedAutomaticTypeDirectiveNames, projectReferences) {
        if (!program || hasChangedAutomaticTypeDirectiveNames) {
          return false;
        }
        if (!ts2.arrayIsEqualTo(program.getRootFileNames(), rootFileNames)) {
          return false;
        }
        var seenResolvedRefs;
        if (!ts2.arrayIsEqualTo(program.getProjectReferences(), projectReferences, projectReferenceUptoDate)) {
          return false;
        }
        if (program.getSourceFiles().some(sourceFileNotUptoDate)) {
          return false;
        }
        if (program.getMissingFilePaths().some(fileExists)) {
          return false;
        }
        var currentOptions = program.getCompilerOptions();
        if (!ts2.compareDataObjects(currentOptions, newOptions)) {
          return false;
        }
        if (currentOptions.configFile && newOptions.configFile) {
          return currentOptions.configFile.text === newOptions.configFile.text;
        }
        return true;
        function sourceFileNotUptoDate(sourceFile) {
          return !sourceFileVersionUptoDate(sourceFile) || hasInvalidatedResolution(sourceFile.path);
        }
        function sourceFileVersionUptoDate(sourceFile) {
          return sourceFile.version === getSourceVersion(sourceFile.resolvedPath, sourceFile.fileName);
        }
        function projectReferenceUptoDate(oldRef, newRef, index) {
          if (!ts2.projectReferenceIsEqualTo(oldRef, newRef)) {
            return false;
          }
          return resolvedProjectReferenceUptoDate(program.getResolvedProjectReferences()[index], oldRef);
        }
        function resolvedProjectReferenceUptoDate(oldResolvedRef, oldRef) {
          if (oldResolvedRef) {
            if (ts2.contains(seenResolvedRefs, oldResolvedRef)) {
              return true;
            }
            if (!sourceFileVersionUptoDate(oldResolvedRef.sourceFile)) {
              return false;
            }
            (seenResolvedRefs || (seenResolvedRefs = [])).push(oldResolvedRef);
            return !ts2.forEach(oldResolvedRef.references, function(childResolvedRef, index) {
              return !resolvedProjectReferenceUptoDate(childResolvedRef, oldResolvedRef.commandLine.projectReferences[index]);
            });
          }
          return !fileExists(resolveProjectReferencePath(oldRef));
        }
      }
      ts2.isProgramUptoDate = isProgramUptoDate;
      function getConfigFileParsingDiagnostics(configFileParseResult) {
        return configFileParseResult.options.configFile ? __spreadArrays(configFileParseResult.options.configFile.parseDiagnostics, configFileParseResult.errors) : configFileParseResult.errors;
      }
      ts2.getConfigFileParsingDiagnostics = getConfigFileParsingDiagnostics;
      function shouldProgramCreateNewSourceFiles(program, newOptions) {
        if (!program)
          return false;
        var oldOptions = program.getCompilerOptions();
        return !!ts2.sourceFileAffectingCompilerOptions.some(function(option) {
          return !ts2.isJsonEqual(ts2.getCompilerOptionValue(oldOptions, option), ts2.getCompilerOptionValue(newOptions, option));
        });
      }
      function createCreateProgramOptions(rootNames, options, host, oldProgram, configFileParsingDiagnostics) {
        return {
          rootNames,
          options,
          host,
          oldProgram,
          configFileParsingDiagnostics
        };
      }
      function createProgram(rootNamesOrOptions, _options, _host, _oldProgram, _configFileParsingDiagnostics) {
        var _a;
        var createProgramOptions = ts2.isArray(rootNamesOrOptions) ? createCreateProgramOptions(rootNamesOrOptions, _options, _host, _oldProgram, _configFileParsingDiagnostics) : rootNamesOrOptions;
        var rootNames = createProgramOptions.rootNames, options = createProgramOptions.options, configFileParsingDiagnostics = createProgramOptions.configFileParsingDiagnostics, projectReferences = createProgramOptions.projectReferences;
        var oldProgram = createProgramOptions.oldProgram;
        var processingDefaultLibFiles;
        var processingOtherFiles;
        var files;
        var symlinks;
        var commonSourceDirectory;
        var diagnosticsProducingTypeChecker;
        var noDiagnosticsTypeChecker;
        var classifiableNames;
        var ambientModuleNameToUnmodifiedFileName = ts2.createMap();
        var refFileMap;
        var cachedBindAndCheckDiagnosticsForFile = {};
        var cachedDeclarationDiagnosticsForFile = {};
        var resolvedTypeReferenceDirectives = ts2.createMap();
        var fileProcessingDiagnostics = ts2.createDiagnosticCollection();
        var maxNodeModuleJsDepth = typeof options.maxNodeModuleJsDepth === "number" ? options.maxNodeModuleJsDepth : 0;
        var currentNodeModulesDepth = 0;
        var modulesWithElidedImports = ts2.createMap();
        var sourceFilesFoundSearchingNodeModules = ts2.createMap();
        ts2.performance.mark("beforeProgram");
        var host = createProgramOptions.host || createCompilerHost(options);
        var configParsingHost = parseConfigHostFromCompilerHostLike(host);
        var skipDefaultLib = options.noLib;
        var getDefaultLibraryFileName = ts2.memoize(function() {
          return host.getDefaultLibFileName(options);
        });
        var defaultLibraryPath = host.getDefaultLibLocation ? host.getDefaultLibLocation() : ts2.getDirectoryPath(getDefaultLibraryFileName());
        var programDiagnostics = ts2.createDiagnosticCollection();
        var currentDirectory = host.getCurrentDirectory();
        var supportedExtensions = ts2.getSupportedExtensions(options);
        var supportedExtensionsWithJsonIfResolveJsonModule = ts2.getSuppoertedExtensionsWithJsonIfResolveJsonModule(options, supportedExtensions);
        var hasEmitBlockingDiagnostics = ts2.createMap();
        var _compilerOptionsObjectLiteralSyntax;
        var moduleResolutionCache;
        var actualResolveModuleNamesWorker;
        var hasInvalidatedResolution = host.hasInvalidatedResolution || ts2.returnFalse;
        if (host.resolveModuleNames) {
          actualResolveModuleNamesWorker = function(moduleNames, containingFile, reusedNames, redirectedReference) {
            return host.resolveModuleNames(ts2.Debug.checkEachDefined(moduleNames), containingFile, reusedNames, redirectedReference, options).map(function(resolved) {
              if (!resolved || resolved.extension !== void 0) {
                return resolved;
              }
              var withExtension = ts2.clone(resolved);
              withExtension.extension = ts2.extensionFromPath(resolved.resolvedFileName);
              return withExtension;
            });
          };
        } else {
          moduleResolutionCache = ts2.createModuleResolutionCache(currentDirectory, function(x) {
            return host.getCanonicalFileName(x);
          }, options);
          var loader_1 = function(moduleName, containingFile, redirectedReference) {
            return ts2.resolveModuleName(moduleName, containingFile, options, host, moduleResolutionCache, redirectedReference).resolvedModule;
          };
          actualResolveModuleNamesWorker = function(moduleNames, containingFile, _reusedNames, redirectedReference) {
            return loadWithLocalCache(ts2.Debug.checkEachDefined(moduleNames), containingFile, redirectedReference, loader_1);
          };
        }
        var actualResolveTypeReferenceDirectiveNamesWorker;
        if (host.resolveTypeReferenceDirectives) {
          actualResolveTypeReferenceDirectiveNamesWorker = function(typeDirectiveNames, containingFile, redirectedReference) {
            return host.resolveTypeReferenceDirectives(ts2.Debug.checkEachDefined(typeDirectiveNames), containingFile, redirectedReference, options);
          };
        } else {
          var loader_2 = function(typesRef, containingFile, redirectedReference) {
            return ts2.resolveTypeReferenceDirective(typesRef, containingFile, options, host, redirectedReference).resolvedTypeReferenceDirective;
          };
          actualResolveTypeReferenceDirectiveNamesWorker = function(typeReferenceDirectiveNames, containingFile, redirectedReference) {
            return loadWithLocalCache(ts2.Debug.checkEachDefined(typeReferenceDirectiveNames), containingFile, redirectedReference, loader_2);
          };
        }
        var packageIdToSourceFile = ts2.createMap();
        var sourceFileToPackageName = ts2.createMap();
        var redirectTargetsMap = ts2.createMultiMap();
        var filesByName = ts2.createMap();
        var missingFilePaths;
        var filesByNameIgnoreCase = host.useCaseSensitiveFileNames() ? ts2.createMap() : void 0;
        var resolvedProjectReferences;
        var projectReferenceRedirects;
        var mapFromFileToProjectReferenceRedirects;
        var mapFromToProjectReferenceRedirectSource;
        var useSourceOfProjectReferenceRedirect = !!((_a = host.useSourceOfProjectReferenceRedirect) === null || _a === void 0 ? void 0 : _a.call(host)) && !options.disableSourceOfProjectReferenceRedirect;
        var _b = updateHostForUseSourceOfProjectReferenceRedirect({
          compilerHost: host,
          useSourceOfProjectReferenceRedirect,
          toPath,
          getResolvedProjectReferences,
          getSourceOfProjectReferenceRedirect,
          forEachResolvedProjectReference
        }), onProgramCreateComplete = _b.onProgramCreateComplete, fileExists = _b.fileExists;
        var shouldCreateNewSourceFile = shouldProgramCreateNewSourceFiles(oldProgram, options);
        var structuralIsReused;
        structuralIsReused = tryReuseStructureFromOldProgram();
        if (structuralIsReused !== 2) {
          processingDefaultLibFiles = [];
          processingOtherFiles = [];
          if (projectReferences) {
            if (!resolvedProjectReferences) {
              resolvedProjectReferences = projectReferences.map(parseProjectReferenceConfigFile);
            }
            if (rootNames.length) {
              for (var _i = 0, resolvedProjectReferences_1 = resolvedProjectReferences; _i < resolvedProjectReferences_1.length; _i++) {
                var parsedRef = resolvedProjectReferences_1[_i];
                if (!parsedRef)
                  continue;
                var out = parsedRef.commandLine.options.outFile || parsedRef.commandLine.options.out;
                if (useSourceOfProjectReferenceRedirect) {
                  if (out || ts2.getEmitModuleKind(parsedRef.commandLine.options) === ts2.ModuleKind.None) {
                    for (var _c = 0, _d = parsedRef.commandLine.fileNames; _c < _d.length; _c++) {
                      var fileName = _d[_c];
                      processSourceFile(fileName, false, false, void 0);
                    }
                  }
                } else {
                  if (out) {
                    processSourceFile(ts2.changeExtension(out, ".d.ts"), false, false, void 0);
                  } else if (ts2.getEmitModuleKind(parsedRef.commandLine.options) === ts2.ModuleKind.None) {
                    for (var _e = 0, _f = parsedRef.commandLine.fileNames; _e < _f.length; _e++) {
                      var fileName = _f[_e];
                      if (!ts2.fileExtensionIs(fileName, ".d.ts") && !ts2.fileExtensionIs(fileName, ".json")) {
                        processSourceFile(ts2.getOutputDeclarationFileName(fileName, parsedRef.commandLine, !host.useCaseSensitiveFileNames()), false, false, void 0);
                      }
                    }
                  }
                }
              }
            }
          }
          ts2.forEach(rootNames, function(name) {
            return processRootFile(name, false, false);
          });
          var typeReferences = rootNames.length ? ts2.getAutomaticTypeDirectiveNames(options, host) : ts2.emptyArray;
          if (typeReferences.length) {
            var containingDirectory = options.configFilePath ? ts2.getDirectoryPath(options.configFilePath) : host.getCurrentDirectory();
            var containingFilename = ts2.combinePaths(containingDirectory, ts2.inferredTypesContainingFile);
            var resolutions = resolveTypeReferenceDirectiveNamesWorker(typeReferences, containingFilename);
            for (var i = 0; i < typeReferences.length; i++) {
              processTypeReferenceDirective(typeReferences[i], resolutions[i]);
            }
          }
          if (rootNames.length && !skipDefaultLib) {
            var defaultLibraryFileName = getDefaultLibraryFileName();
            if (!options.lib && defaultLibraryFileName) {
              processRootFile(defaultLibraryFileName, true, false);
            } else {
              ts2.forEach(options.lib, function(libFileName) {
                processRootFile(ts2.combinePaths(defaultLibraryPath, libFileName), true, false);
              });
            }
          }
          missingFilePaths = ts2.arrayFrom(ts2.mapDefinedIterator(filesByName.entries(), function(_a2) {
            var path2 = _a2[0], file = _a2[1];
            return file === void 0 ? path2 : void 0;
          }));
          files = ts2.stableSort(processingDefaultLibFiles, compareDefaultLibFiles).concat(processingOtherFiles);
          processingDefaultLibFiles = void 0;
          processingOtherFiles = void 0;
        }
        ts2.Debug.assert(!!missingFilePaths);
        if (oldProgram && host.onReleaseOldSourceFile) {
          var oldSourceFiles = oldProgram.getSourceFiles();
          for (var _g = 0, oldSourceFiles_1 = oldSourceFiles; _g < oldSourceFiles_1.length; _g++) {
            var oldSourceFile = oldSourceFiles_1[_g];
            var newFile = getSourceFileByPath(oldSourceFile.resolvedPath);
            if (shouldCreateNewSourceFile || !newFile || oldSourceFile.resolvedPath === oldSourceFile.path && newFile.resolvedPath !== oldSourceFile.path) {
              host.onReleaseOldSourceFile(oldSourceFile, oldProgram.getCompilerOptions(), !!getSourceFileByPath(oldSourceFile.path));
            }
          }
          oldProgram.forEachResolvedProjectReference(function(resolvedProjectReference, resolvedProjectReferencePath) {
            if (resolvedProjectReference && !getResolvedProjectReferenceByPath(resolvedProjectReferencePath)) {
              host.onReleaseOldSourceFile(resolvedProjectReference.sourceFile, oldProgram.getCompilerOptions(), false);
            }
          });
        }
        oldProgram = void 0;
        var program = {
          getRootFileNames: function() {
            return rootNames;
          },
          getSourceFile,
          getSourceFileByPath,
          getSourceFiles: function() {
            return files;
          },
          getMissingFilePaths: function() {
            return missingFilePaths;
          },
          getRefFileMap: function() {
            return refFileMap;
          },
          getFilesByNameMap: function() {
            return filesByName;
          },
          getCompilerOptions: function() {
            return options;
          },
          getSyntacticDiagnostics,
          getOptionsDiagnostics,
          getGlobalDiagnostics,
          getSemanticDiagnostics,
          getSuggestionDiagnostics,
          getDeclarationDiagnostics,
          getBindAndCheckDiagnostics,
          getProgramDiagnostics,
          getTypeChecker,
          getClassifiableNames,
          getDiagnosticsProducingTypeChecker,
          getCommonSourceDirectory,
          emit,
          getCurrentDirectory: function() {
            return currentDirectory;
          },
          getNodeCount: function() {
            return getDiagnosticsProducingTypeChecker().getNodeCount();
          },
          getIdentifierCount: function() {
            return getDiagnosticsProducingTypeChecker().getIdentifierCount();
          },
          getSymbolCount: function() {
            return getDiagnosticsProducingTypeChecker().getSymbolCount();
          },
          getTypeCount: function() {
            return getDiagnosticsProducingTypeChecker().getTypeCount();
          },
          getInstantiationCount: function() {
            return getDiagnosticsProducingTypeChecker().getInstantiationCount();
          },
          getRelationCacheSizes: function() {
            return getDiagnosticsProducingTypeChecker().getRelationCacheSizes();
          },
          getFileProcessingDiagnostics: function() {
            return fileProcessingDiagnostics;
          },
          getResolvedTypeReferenceDirectives: function() {
            return resolvedTypeReferenceDirectives;
          },
          isSourceFileFromExternalLibrary,
          isSourceFileDefaultLibrary,
          dropDiagnosticsProducingTypeChecker,
          getSourceFileFromReference,
          getLibFileFromReference,
          sourceFileToPackageName,
          redirectTargetsMap,
          isEmittedFile,
          getConfigFileParsingDiagnostics: getConfigFileParsingDiagnostics2,
          getResolvedModuleWithFailedLookupLocationsFromCache,
          getProjectReferences,
          getResolvedProjectReferences,
          getProjectReferenceRedirect,
          getResolvedProjectReferenceToRedirect,
          getResolvedProjectReferenceByPath,
          forEachResolvedProjectReference,
          isSourceOfProjectReferenceRedirect,
          emitBuildInfo,
          fileExists,
          getProbableSymlinks,
          useCaseSensitiveFileNames: function() {
            return host.useCaseSensitiveFileNames();
          }
        };
        onProgramCreateComplete();
        verifyCompilerOptions();
        ts2.performance.mark("afterProgram");
        ts2.performance.measure("Program", "beforeProgram", "afterProgram");
        return program;
        function resolveModuleNamesWorker(moduleNames, containingFile, reusedNames, redirectedReference) {
          ts2.performance.mark("beforeResolveModule");
          var result = actualResolveModuleNamesWorker(moduleNames, containingFile, reusedNames, redirectedReference);
          ts2.performance.mark("afterResolveModule");
          ts2.performance.measure("ResolveModule", "beforeResolveModule", "afterResolveModule");
          return result;
        }
        function resolveTypeReferenceDirectiveNamesWorker(typeDirectiveNames, containingFile, redirectedReference) {
          ts2.performance.mark("beforeResolveTypeReference");
          var result = actualResolveTypeReferenceDirectiveNamesWorker(typeDirectiveNames, containingFile, redirectedReference);
          ts2.performance.mark("afterResolveTypeReference");
          ts2.performance.measure("ResolveTypeReference", "beforeResolveTypeReference", "afterResolveTypeReference");
          return result;
        }
        function compareDefaultLibFiles(a, b) {
          return ts2.compareValues(getDefaultLibFilePriority(a), getDefaultLibFilePriority(b));
        }
        function getDefaultLibFilePriority(a) {
          if (ts2.containsPath(defaultLibraryPath, a.fileName, false)) {
            var basename = ts2.getBaseFileName(a.fileName);
            if (basename === "lib.d.ts" || basename === "lib.es6.d.ts")
              return 0;
            var name = ts2.removeSuffix(ts2.removePrefix(basename, "lib."), ".d.ts");
            var index = ts2.libs.indexOf(name);
            if (index !== -1)
              return index + 1;
          }
          return ts2.libs.length + 2;
        }
        function getResolvedModuleWithFailedLookupLocationsFromCache(moduleName, containingFile) {
          return moduleResolutionCache && ts2.resolveModuleNameFromCache(moduleName, containingFile, moduleResolutionCache);
        }
        function toPath(fileName2) {
          return ts2.toPath(fileName2, currentDirectory, getCanonicalFileName);
        }
        function getCommonSourceDirectory() {
          if (commonSourceDirectory === void 0) {
            var emittedFiles = ts2.filter(files, function(file) {
              return ts2.sourceFileMayBeEmitted(file, program);
            });
            if (options.rootDir && checkSourceFilesBelongToPath(emittedFiles, options.rootDir)) {
              commonSourceDirectory = ts2.getNormalizedAbsolutePath(options.rootDir, currentDirectory);
            } else if (options.composite && options.configFilePath) {
              commonSourceDirectory = ts2.getDirectoryPath(ts2.normalizeSlashes(options.configFilePath));
              checkSourceFilesBelongToPath(emittedFiles, commonSourceDirectory);
            } else {
              commonSourceDirectory = computeCommonSourceDirectory(emittedFiles);
            }
            if (commonSourceDirectory && commonSourceDirectory[commonSourceDirectory.length - 1] !== ts2.directorySeparator) {
              commonSourceDirectory += ts2.directorySeparator;
            }
          }
          return commonSourceDirectory;
        }
        function getClassifiableNames() {
          if (!classifiableNames) {
            getTypeChecker();
            classifiableNames = ts2.createUnderscoreEscapedMap();
            for (var _i2 = 0, files_2 = files; _i2 < files_2.length; _i2++) {
              var sourceFile = files_2[_i2];
              ts2.copyEntries(sourceFile.classifiableNames, classifiableNames);
            }
          }
          return classifiableNames;
        }
        function resolveModuleNamesReusingOldState(moduleNames, containingFile, file) {
          if (structuralIsReused === 0 && !file.ambientModuleNames.length) {
            return resolveModuleNamesWorker(moduleNames, containingFile, void 0, getResolvedProjectReferenceToRedirect(file.originalFileName));
          }
          var oldSourceFile2 = oldProgram && oldProgram.getSourceFile(containingFile);
          if (oldSourceFile2 !== file && file.resolvedModules) {
            var result_11 = [];
            for (var _i2 = 0, moduleNames_1 = moduleNames; _i2 < moduleNames_1.length; _i2++) {
              var moduleName = moduleNames_1[_i2];
              var resolvedModule = file.resolvedModules.get(moduleName);
              result_11.push(resolvedModule);
            }
            return result_11;
          }
          var unknownModuleNames;
          var result;
          var reusedNames;
          var predictedToResolveToAmbientModuleMarker = {};
          for (var i2 = 0; i2 < moduleNames.length; i2++) {
            var moduleName = moduleNames[i2];
            if (file === oldSourceFile2 && !hasInvalidatedResolution(oldSourceFile2.path)) {
              var oldResolvedModule = oldSourceFile2 && oldSourceFile2.resolvedModules.get(moduleName);
              if (oldResolvedModule) {
                if (ts2.isTraceEnabled(options, host)) {
                  ts2.trace(host, ts2.Diagnostics.Reusing_resolution_of_module_0_to_file_1_from_old_program, moduleName, containingFile);
                }
                (result || (result = new Array(moduleNames.length)))[i2] = oldResolvedModule;
                (reusedNames || (reusedNames = [])).push(moduleName);
                continue;
              }
            }
            var resolvesToAmbientModuleInNonModifiedFile = false;
            if (ts2.contains(file.ambientModuleNames, moduleName)) {
              resolvesToAmbientModuleInNonModifiedFile = true;
              if (ts2.isTraceEnabled(options, host)) {
                ts2.trace(host, ts2.Diagnostics.Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1, moduleName, containingFile);
              }
            } else {
              resolvesToAmbientModuleInNonModifiedFile = moduleNameResolvesToAmbientModuleInNonModifiedFile(moduleName);
            }
            if (resolvesToAmbientModuleInNonModifiedFile) {
              (result || (result = new Array(moduleNames.length)))[i2] = predictedToResolveToAmbientModuleMarker;
            } else {
              (unknownModuleNames || (unknownModuleNames = [])).push(moduleName);
            }
          }
          var resolutions2 = unknownModuleNames && unknownModuleNames.length ? resolveModuleNamesWorker(unknownModuleNames, containingFile, reusedNames, getResolvedProjectReferenceToRedirect(file.originalFileName)) : ts2.emptyArray;
          if (!result) {
            ts2.Debug.assert(resolutions2.length === moduleNames.length);
            return resolutions2;
          }
          var j = 0;
          for (var i2 = 0; i2 < result.length; i2++) {
            if (result[i2]) {
              if (result[i2] === predictedToResolveToAmbientModuleMarker) {
                result[i2] = void 0;
              }
            } else {
              result[i2] = resolutions2[j];
              j++;
            }
          }
          ts2.Debug.assert(j === resolutions2.length);
          return result;
          function moduleNameResolvesToAmbientModuleInNonModifiedFile(moduleName2) {
            var resolutionToFile = ts2.getResolvedModule(oldSourceFile2, moduleName2);
            var resolvedFile = resolutionToFile && oldProgram.getSourceFile(resolutionToFile.resolvedFileName);
            if (resolutionToFile && resolvedFile) {
              return false;
            }
            var unmodifiedFile = ambientModuleNameToUnmodifiedFileName.get(moduleName2);
            if (!unmodifiedFile) {
              return false;
            }
            if (ts2.isTraceEnabled(options, host)) {
              ts2.trace(host, ts2.Diagnostics.Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified, moduleName2, unmodifiedFile);
            }
            return true;
          }
        }
        function canReuseProjectReferences() {
          return !forEachProjectReference(oldProgram.getProjectReferences(), oldProgram.getResolvedProjectReferences(), function(oldResolvedRef, index, parent) {
            var newRef = (parent ? parent.commandLine.projectReferences : projectReferences)[index];
            var newResolvedRef = parseProjectReferenceConfigFile(newRef);
            if (oldResolvedRef) {
              return !newResolvedRef || newResolvedRef.sourceFile !== oldResolvedRef.sourceFile;
            } else {
              return newResolvedRef !== void 0;
            }
          }, function(oldProjectReferences, parent) {
            var newReferences = parent ? getResolvedProjectReferenceByPath(parent.sourceFile.path).commandLine.projectReferences : projectReferences;
            return !ts2.arrayIsEqualTo(oldProjectReferences, newReferences, ts2.projectReferenceIsEqualTo);
          });
        }
        function tryReuseStructureFromOldProgram() {
          if (!oldProgram) {
            return 0;
          }
          var oldOptions = oldProgram.getCompilerOptions();
          if (ts2.changesAffectModuleResolution(oldOptions, options)) {
            return oldProgram.structureIsReused = 0;
          }
          ts2.Debug.assert(!(oldProgram.structureIsReused & (2 | 1)));
          var oldRootNames = oldProgram.getRootFileNames();
          if (!ts2.arrayIsEqualTo(oldRootNames, rootNames)) {
            return oldProgram.structureIsReused = 0;
          }
          if (!ts2.arrayIsEqualTo(options.types, oldOptions.types)) {
            return oldProgram.structureIsReused = 0;
          }
          if (!canReuseProjectReferences()) {
            return oldProgram.structureIsReused = 0;
          }
          if (projectReferences) {
            resolvedProjectReferences = projectReferences.map(parseProjectReferenceConfigFile);
          }
          var newSourceFiles = [];
          var modifiedSourceFiles = [];
          oldProgram.structureIsReused = 2;
          if (oldProgram.getMissingFilePaths().some(function(missingFilePath) {
            return host.fileExists(missingFilePath);
          })) {
            return oldProgram.structureIsReused = 0;
          }
          var oldSourceFiles2 = oldProgram.getSourceFiles();
          var SeenPackageName;
          (function(SeenPackageName2) {
            SeenPackageName2[SeenPackageName2["Exists"] = 0] = "Exists";
            SeenPackageName2[SeenPackageName2["Modified"] = 1] = "Modified";
          })(SeenPackageName || (SeenPackageName = {}));
          var seenPackageNames = ts2.createMap();
          for (var _i2 = 0, oldSourceFiles_2 = oldSourceFiles2; _i2 < oldSourceFiles_2.length; _i2++) {
            var oldSourceFile2 = oldSourceFiles_2[_i2];
            var newSourceFile = host.getSourceFileByPath ? host.getSourceFileByPath(oldSourceFile2.fileName, oldSourceFile2.resolvedPath, options.target, void 0, shouldCreateNewSourceFile) : host.getSourceFile(oldSourceFile2.fileName, options.target, void 0, shouldCreateNewSourceFile);
            if (!newSourceFile) {
              return oldProgram.structureIsReused = 0;
            }
            ts2.Debug.assert(!newSourceFile.redirectInfo, "Host should not return a redirect source file from `getSourceFile`");
            var fileChanged = void 0;
            if (oldSourceFile2.redirectInfo) {
              if (newSourceFile !== oldSourceFile2.redirectInfo.unredirected) {
                return oldProgram.structureIsReused = 0;
              }
              fileChanged = false;
              newSourceFile = oldSourceFile2;
            } else if (oldProgram.redirectTargetsMap.has(oldSourceFile2.path)) {
              if (newSourceFile !== oldSourceFile2) {
                return oldProgram.structureIsReused = 0;
              }
              fileChanged = false;
            } else {
              fileChanged = newSourceFile !== oldSourceFile2;
            }
            newSourceFile.path = oldSourceFile2.path;
            newSourceFile.originalFileName = oldSourceFile2.originalFileName;
            newSourceFile.resolvedPath = oldSourceFile2.resolvedPath;
            newSourceFile.fileName = oldSourceFile2.fileName;
            var packageName = oldProgram.sourceFileToPackageName.get(oldSourceFile2.path);
            if (packageName !== void 0) {
              var prevKind = seenPackageNames.get(packageName);
              var newKind = fileChanged ? 1 : 0;
              if (prevKind !== void 0 && newKind === 1 || prevKind === 1) {
                return oldProgram.structureIsReused = 0;
              }
              seenPackageNames.set(packageName, newKind);
            }
            if (fileChanged) {
              if (!ts2.arrayIsEqualTo(oldSourceFile2.libReferenceDirectives, newSourceFile.libReferenceDirectives, fileReferenceIsEqualTo)) {
                return oldProgram.structureIsReused = 0;
              }
              if (oldSourceFile2.hasNoDefaultLib !== newSourceFile.hasNoDefaultLib) {
                oldProgram.structureIsReused = 1;
              }
              if (!ts2.arrayIsEqualTo(oldSourceFile2.referencedFiles, newSourceFile.referencedFiles, fileReferenceIsEqualTo)) {
                oldProgram.structureIsReused = 1;
              }
              collectExternalModuleReferences(newSourceFile);
              if (!ts2.arrayIsEqualTo(oldSourceFile2.imports, newSourceFile.imports, moduleNameIsEqualTo)) {
                oldProgram.structureIsReused = 1;
              }
              if (!ts2.arrayIsEqualTo(oldSourceFile2.moduleAugmentations, newSourceFile.moduleAugmentations, moduleNameIsEqualTo)) {
                oldProgram.structureIsReused = 1;
              }
              if ((oldSourceFile2.flags & 3145728) !== (newSourceFile.flags & 3145728)) {
                oldProgram.structureIsReused = 1;
              }
              if (!ts2.arrayIsEqualTo(oldSourceFile2.typeReferenceDirectives, newSourceFile.typeReferenceDirectives, fileReferenceIsEqualTo)) {
                oldProgram.structureIsReused = 1;
              }
              modifiedSourceFiles.push({ oldFile: oldSourceFile2, newFile: newSourceFile });
            } else if (hasInvalidatedResolution(oldSourceFile2.path)) {
              oldProgram.structureIsReused = 1;
              modifiedSourceFiles.push({ oldFile: oldSourceFile2, newFile: newSourceFile });
            }
            newSourceFiles.push(newSourceFile);
          }
          if (oldProgram.structureIsReused !== 2) {
            return oldProgram.structureIsReused;
          }
          var modifiedFiles = modifiedSourceFiles.map(function(f) {
            return f.oldFile;
          });
          for (var _a2 = 0, oldSourceFiles_3 = oldSourceFiles2; _a2 < oldSourceFiles_3.length; _a2++) {
            var oldFile = oldSourceFiles_3[_a2];
            if (!ts2.contains(modifiedFiles, oldFile)) {
              for (var _b2 = 0, _c2 = oldFile.ambientModuleNames; _b2 < _c2.length; _b2++) {
                var moduleName = _c2[_b2];
                ambientModuleNameToUnmodifiedFileName.set(moduleName, oldFile.fileName);
              }
            }
          }
          for (var _d2 = 0, modifiedSourceFiles_1 = modifiedSourceFiles; _d2 < modifiedSourceFiles_1.length; _d2++) {
            var _e2 = modifiedSourceFiles_1[_d2], oldSourceFile2 = _e2.oldFile, newSourceFile = _e2.newFile;
            var newSourceFilePath = ts2.getNormalizedAbsolutePath(newSourceFile.originalFileName, currentDirectory);
            var moduleNames = getModuleNames(newSourceFile);
            var resolutions2 = resolveModuleNamesReusingOldState(moduleNames, newSourceFilePath, newSourceFile);
            var resolutionsChanged = ts2.hasChangesInResolutions(moduleNames, resolutions2, oldSourceFile2.resolvedModules, ts2.moduleResolutionIsEqualTo);
            if (resolutionsChanged) {
              oldProgram.structureIsReused = 1;
              newSourceFile.resolvedModules = ts2.zipToMap(moduleNames, resolutions2);
            } else {
              newSourceFile.resolvedModules = oldSourceFile2.resolvedModules;
            }
            if (resolveTypeReferenceDirectiveNamesWorker) {
              var typesReferenceDirectives = ts2.map(newSourceFile.typeReferenceDirectives, function(ref) {
                return ts2.toFileNameLowerCase(ref.fileName);
              });
              var resolutions_1 = resolveTypeReferenceDirectiveNamesWorker(typesReferenceDirectives, newSourceFilePath, getResolvedProjectReferenceToRedirect(newSourceFile.originalFileName));
              var resolutionsChanged_1 = ts2.hasChangesInResolutions(typesReferenceDirectives, resolutions_1, oldSourceFile2.resolvedTypeReferenceDirectiveNames, ts2.typeDirectiveIsEqualTo);
              if (resolutionsChanged_1) {
                oldProgram.structureIsReused = 1;
                newSourceFile.resolvedTypeReferenceDirectiveNames = ts2.zipToMap(typesReferenceDirectives, resolutions_1);
              } else {
                newSourceFile.resolvedTypeReferenceDirectiveNames = oldSourceFile2.resolvedTypeReferenceDirectiveNames;
              }
            }
          }
          if (oldProgram.structureIsReused !== 2) {
            return oldProgram.structureIsReused;
          }
          if (host.hasChangedAutomaticTypeDirectiveNames) {
            return oldProgram.structureIsReused = 1;
          }
          missingFilePaths = oldProgram.getMissingFilePaths();
          refFileMap = oldProgram.getRefFileMap();
          ts2.Debug.assert(newSourceFiles.length === oldProgram.getSourceFiles().length);
          for (var _f2 = 0, newSourceFiles_1 = newSourceFiles; _f2 < newSourceFiles_1.length; _f2++) {
            var newSourceFile = newSourceFiles_1[_f2];
            filesByName.set(newSourceFile.path, newSourceFile);
          }
          var oldFilesByNameMap = oldProgram.getFilesByNameMap();
          oldFilesByNameMap.forEach(function(oldFile2, path2) {
            if (!oldFile2) {
              filesByName.set(path2, oldFile2);
              return;
            }
            if (oldFile2.path === path2) {
              if (oldProgram.isSourceFileFromExternalLibrary(oldFile2)) {
                sourceFilesFoundSearchingNodeModules.set(oldFile2.path, true);
              }
              return;
            }
            filesByName.set(path2, filesByName.get(oldFile2.path));
          });
          files = newSourceFiles;
          fileProcessingDiagnostics = oldProgram.getFileProcessingDiagnostics();
          for (var _g2 = 0, modifiedSourceFiles_2 = modifiedSourceFiles; _g2 < modifiedSourceFiles_2.length; _g2++) {
            var modifiedFile = modifiedSourceFiles_2[_g2];
            fileProcessingDiagnostics.reattachFileDiagnostics(modifiedFile.newFile);
          }
          resolvedTypeReferenceDirectives = oldProgram.getResolvedTypeReferenceDirectives();
          sourceFileToPackageName = oldProgram.sourceFileToPackageName;
          redirectTargetsMap = oldProgram.redirectTargetsMap;
          return oldProgram.structureIsReused = 2;
        }
        function getEmitHost(writeFileCallback) {
          return {
            getPrependNodes,
            getCanonicalFileName,
            getCommonSourceDirectory: program.getCommonSourceDirectory,
            getCompilerOptions: program.getCompilerOptions,
            getCurrentDirectory: function() {
              return currentDirectory;
            },
            getNewLine: function() {
              return host.getNewLine();
            },
            getSourceFile: program.getSourceFile,
            getSourceFileByPath: program.getSourceFileByPath,
            getSourceFiles: program.getSourceFiles,
            getLibFileFromReference: program.getLibFileFromReference,
            isSourceFileFromExternalLibrary,
            getResolvedProjectReferenceToRedirect,
            getProjectReferenceRedirect,
            isSourceOfProjectReferenceRedirect,
            getProbableSymlinks,
            writeFile: writeFileCallback || function(fileName2, data, writeByteOrderMark, onError, sourceFiles) {
              return host.writeFile(fileName2, data, writeByteOrderMark, onError, sourceFiles);
            },
            isEmitBlocked,
            readFile: function(f) {
              return host.readFile(f);
            },
            fileExists: function(f) {
              var path2 = toPath(f);
              if (getSourceFileByPath(path2))
                return true;
              if (ts2.contains(missingFilePaths, path2))
                return false;
              return host.fileExists(f);
            },
            useCaseSensitiveFileNames: function() {
              return host.useCaseSensitiveFileNames();
            },
            getProgramBuildInfo: function() {
              return program.getProgramBuildInfo && program.getProgramBuildInfo();
            },
            getSourceFileFromReference: function(file, ref) {
              return program.getSourceFileFromReference(file, ref);
            },
            redirectTargetsMap
          };
        }
        function emitBuildInfo(writeFileCallback) {
          ts2.Debug.assert(!options.out && !options.outFile);
          ts2.performance.mark("beforeEmit");
          var emitResult = ts2.emitFiles(ts2.notImplementedResolver, getEmitHost(writeFileCallback), void 0, ts2.noTransformers, false, true);
          ts2.performance.mark("afterEmit");
          ts2.performance.measure("Emit", "beforeEmit", "afterEmit");
          return emitResult;
        }
        function getResolvedProjectReferences() {
          return resolvedProjectReferences;
        }
        function getProjectReferences() {
          return projectReferences;
        }
        function getPrependNodes() {
          return createPrependNodes(projectReferences, function(_ref, index) {
            return resolvedProjectReferences[index].commandLine;
          }, function(fileName2) {
            var path2 = toPath(fileName2);
            var sourceFile = getSourceFileByPath(path2);
            return sourceFile ? sourceFile.text : filesByName.has(path2) ? void 0 : host.readFile(path2);
          });
        }
        function isSourceFileFromExternalLibrary(file) {
          return !!sourceFilesFoundSearchingNodeModules.get(file.path);
        }
        function isSourceFileDefaultLibrary(file) {
          if (file.hasNoDefaultLib) {
            return true;
          }
          if (!options.noLib) {
            return false;
          }
          var equalityComparer = host.useCaseSensitiveFileNames() ? ts2.equateStringsCaseSensitive : ts2.equateStringsCaseInsensitive;
          if (!options.lib) {
            return equalityComparer(file.fileName, getDefaultLibraryFileName());
          } else {
            return ts2.some(options.lib, function(libFileName) {
              return equalityComparer(file.fileName, ts2.combinePaths(defaultLibraryPath, libFileName));
            });
          }
        }
        function getDiagnosticsProducingTypeChecker() {
          return diagnosticsProducingTypeChecker || (diagnosticsProducingTypeChecker = ts2.createTypeChecker(program, true));
        }
        function dropDiagnosticsProducingTypeChecker() {
          diagnosticsProducingTypeChecker = void 0;
        }
        function getTypeChecker() {
          return noDiagnosticsTypeChecker || (noDiagnosticsTypeChecker = ts2.createTypeChecker(program, false));
        }
        function emit(sourceFile, writeFileCallback, cancellationToken, emitOnlyDtsFiles, transformers, forceDtsEmit) {
          return runWithCancellationToken(function() {
            return emitWorker(program, sourceFile, writeFileCallback, cancellationToken, emitOnlyDtsFiles, transformers, forceDtsEmit);
          });
        }
        function isEmitBlocked(emitFileName) {
          return hasEmitBlockingDiagnostics.has(toPath(emitFileName));
        }
        function emitWorker(program2, sourceFile, writeFileCallback, cancellationToken, emitOnlyDtsFiles, customTransformers, forceDtsEmit) {
          if (!forceDtsEmit) {
            var result = handleNoEmitOptions(program2, sourceFile, cancellationToken);
            if (result)
              return result;
          }
          var emitResolver = getDiagnosticsProducingTypeChecker().getEmitResolver(options.outFile || options.out ? void 0 : sourceFile, cancellationToken);
          ts2.performance.mark("beforeEmit");
          var emitResult = ts2.emitFiles(emitResolver, getEmitHost(writeFileCallback), sourceFile, ts2.getTransformers(options, customTransformers, emitOnlyDtsFiles), emitOnlyDtsFiles, false, forceDtsEmit);
          ts2.performance.mark("afterEmit");
          ts2.performance.measure("Emit", "beforeEmit", "afterEmit");
          return emitResult;
        }
        function getSourceFile(fileName2) {
          return getSourceFileByPath(toPath(fileName2));
        }
        function getSourceFileByPath(path2) {
          return filesByName.get(path2) || void 0;
        }
        function getDiagnosticsHelper(sourceFile, getDiagnostics, cancellationToken) {
          if (sourceFile) {
            return getDiagnostics(sourceFile, cancellationToken);
          }
          return ts2.sortAndDeduplicateDiagnostics(ts2.flatMap(program.getSourceFiles(), function(sourceFile2) {
            if (cancellationToken) {
              cancellationToken.throwIfCancellationRequested();
            }
            return getDiagnostics(sourceFile2, cancellationToken);
          }));
        }
        function getSyntacticDiagnostics(sourceFile, cancellationToken) {
          return getDiagnosticsHelper(sourceFile, getSyntacticDiagnosticsForFile, cancellationToken);
        }
        function getSemanticDiagnostics(sourceFile, cancellationToken) {
          return getDiagnosticsHelper(sourceFile, getSemanticDiagnosticsForFile, cancellationToken);
        }
        function getBindAndCheckDiagnostics(sourceFile, cancellationToken) {
          return getBindAndCheckDiagnosticsForFile(sourceFile, cancellationToken);
        }
        function getProgramDiagnostics(sourceFile) {
          if (ts2.skipTypeChecking(sourceFile, options, program)) {
            return ts2.emptyArray;
          }
          var fileProcessingDiagnosticsInFile = fileProcessingDiagnostics.getDiagnostics(sourceFile.fileName);
          var programDiagnosticsInFile = programDiagnostics.getDiagnostics(sourceFile.fileName);
          return getMergedProgramDiagnostics(sourceFile, fileProcessingDiagnosticsInFile, programDiagnosticsInFile);
        }
        function getMergedProgramDiagnostics(sourceFile) {
          var _a2;
          var allDiagnostics = [];
          for (var _i2 = 1; _i2 < arguments.length; _i2++) {
            allDiagnostics[_i2 - 1] = arguments[_i2];
          }
          var flatDiagnostics = ts2.flatten(allDiagnostics);
          if (!((_a2 = sourceFile.commentDirectives) === null || _a2 === void 0 ? void 0 : _a2.length)) {
            return flatDiagnostics;
          }
          return getDiagnosticsWithPrecedingDirectives(sourceFile, sourceFile.commentDirectives, flatDiagnostics).diagnostics;
        }
        function getDeclarationDiagnostics(sourceFile, cancellationToken) {
          var options2 = program.getCompilerOptions();
          if (!sourceFile || options2.out || options2.outFile) {
            return getDeclarationDiagnosticsWorker(sourceFile, cancellationToken);
          } else {
            return getDiagnosticsHelper(sourceFile, getDeclarationDiagnosticsForFile, cancellationToken);
          }
        }
        function getSyntacticDiagnosticsForFile(sourceFile) {
          if (ts2.isSourceFileJS(sourceFile)) {
            if (!sourceFile.additionalSyntacticDiagnostics) {
              sourceFile.additionalSyntacticDiagnostics = getJSSyntacticDiagnosticsForFile(sourceFile);
            }
            return ts2.concatenate(sourceFile.additionalSyntacticDiagnostics, sourceFile.parseDiagnostics);
          }
          return sourceFile.parseDiagnostics;
        }
        function runWithCancellationToken(func) {
          try {
            return func();
          } catch (e) {
            if (e instanceof ts2.OperationCanceledException) {
              noDiagnosticsTypeChecker = void 0;
              diagnosticsProducingTypeChecker = void 0;
            }
            throw e;
          }
        }
        function getSemanticDiagnosticsForFile(sourceFile, cancellationToken) {
          return ts2.concatenate(getBindAndCheckDiagnosticsForFile(sourceFile, cancellationToken), getProgramDiagnostics(sourceFile));
        }
        function getBindAndCheckDiagnosticsForFile(sourceFile, cancellationToken) {
          return getAndCacheDiagnostics(sourceFile, cancellationToken, cachedBindAndCheckDiagnosticsForFile, getBindAndCheckDiagnosticsForFileNoCache);
        }
        function getBindAndCheckDiagnosticsForFileNoCache(sourceFile, cancellationToken) {
          return runWithCancellationToken(function() {
            if (ts2.skipTypeChecking(sourceFile, options, program)) {
              return ts2.emptyArray;
            }
            var typeChecker = getDiagnosticsProducingTypeChecker();
            ts2.Debug.assert(!!sourceFile.bindDiagnostics);
            var isCheckJs = ts2.isCheckJsEnabledForFile(sourceFile, options);
            var isTsNoCheck = !!sourceFile.checkJsDirective && sourceFile.checkJsDirective.enabled === false;
            var includeBindAndCheckDiagnostics = !isTsNoCheck && (sourceFile.scriptKind === 3 || sourceFile.scriptKind === 4 || sourceFile.scriptKind === 5 || isCheckJs || sourceFile.scriptKind === 7);
            var bindDiagnostics = includeBindAndCheckDiagnostics ? sourceFile.bindDiagnostics : ts2.emptyArray;
            var checkDiagnostics = includeBindAndCheckDiagnostics ? typeChecker.getDiagnostics(sourceFile, cancellationToken) : ts2.emptyArray;
            return getMergedBindAndCheckDiagnostics(sourceFile, bindDiagnostics, checkDiagnostics, isCheckJs ? sourceFile.jsDocDiagnostics : void 0);
          });
        }
        function getMergedBindAndCheckDiagnostics(sourceFile) {
          var _a2;
          var allDiagnostics = [];
          for (var _i2 = 1; _i2 < arguments.length; _i2++) {
            allDiagnostics[_i2 - 1] = arguments[_i2];
          }
          var flatDiagnostics = ts2.flatten(allDiagnostics);
          if (!((_a2 = sourceFile.commentDirectives) === null || _a2 === void 0 ? void 0 : _a2.length)) {
            return flatDiagnostics;
          }
          var _b2 = getDiagnosticsWithPrecedingDirectives(sourceFile, sourceFile.commentDirectives, flatDiagnostics), diagnostics = _b2.diagnostics, directives = _b2.directives;
          for (var _c2 = 0, _d2 = directives.getUnusedExpectations(); _c2 < _d2.length; _c2++) {
            var errorExpectation = _d2[_c2];
            diagnostics.push(ts2.createDiagnosticForRange(sourceFile, errorExpectation.range, ts2.Diagnostics.Unused_ts_expect_error_directive));
          }
          return diagnostics;
        }
        function getDiagnosticsWithPrecedingDirectives(sourceFile, commentDirectives, flatDiagnostics) {
          var directives = ts2.createCommentDirectivesMap(sourceFile, commentDirectives);
          var diagnostics = flatDiagnostics.filter(function(diagnostic) {
            return markPrecedingCommentDirectiveLine(diagnostic, directives) === -1;
          });
          return { diagnostics, directives };
        }
        function getSuggestionDiagnostics(sourceFile, cancellationToken) {
          return runWithCancellationToken(function() {
            return getDiagnosticsProducingTypeChecker().getSuggestionDiagnostics(sourceFile, cancellationToken);
          });
        }
        function markPrecedingCommentDirectiveLine(diagnostic, directives) {
          var file = diagnostic.file, start = diagnostic.start;
          if (!file) {
            return -1;
          }
          var lineStarts = ts2.getLineStarts(file);
          var line = ts2.computeLineAndCharacterOfPosition(lineStarts, start).line - 1;
          while (line >= 0) {
            if (directives.markUsed(line)) {
              return line;
            }
            var lineText = file.text.slice(lineStarts[line], lineStarts[line + 1]).trim();
            if (lineText !== "" && !/^(\s*)\/\/(.*)$/.test(lineText)) {
              return -1;
            }
            line--;
          }
          return -1;
        }
        function getJSSyntacticDiagnosticsForFile(sourceFile) {
          return runWithCancellationToken(function() {
            var diagnostics = [];
            walk(sourceFile, sourceFile);
            ts2.forEachChildRecursively(sourceFile, walk, walkArray);
            return diagnostics;
            function walk(node, parent) {
              switch (parent.kind) {
                case 156:
                case 159:
                case 161:
                  if (parent.questionToken === node) {
                    diagnostics.push(createDiagnosticForNode(node, ts2.Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, "?"));
                    return "skip";
                  }
                case 160:
                case 162:
                case 163:
                case 164:
                case 201:
                case 244:
                case 202:
                case 242:
                  if (parent.type === node) {
                    diagnostics.push(createDiagnosticForNode(node, ts2.Diagnostics.Type_annotations_can_only_be_used_in_TypeScript_files));
                    return "skip";
                  }
              }
              switch (node.kind) {
                case 255:
                  if (node.isTypeOnly) {
                    diagnostics.push(createDiagnosticForNode(node.parent, ts2.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, "import type"));
                    return "skip";
                  }
                  break;
                case 260:
                  if (node.isTypeOnly) {
                    diagnostics.push(createDiagnosticForNode(node, ts2.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, "export type"));
                    return "skip";
                  }
                  break;
                case 253:
                  diagnostics.push(createDiagnosticForNode(node, ts2.Diagnostics.import_can_only_be_used_in_TypeScript_files));
                  return "skip";
                case 259:
                  if (node.isExportEquals) {
                    diagnostics.push(createDiagnosticForNode(node, ts2.Diagnostics.export_can_only_be_used_in_TypeScript_files));
                    return "skip";
                  }
                  break;
                case 279:
                  var heritageClause = node;
                  if (heritageClause.token === 113) {
                    diagnostics.push(createDiagnosticForNode(node, ts2.Diagnostics.implements_clauses_can_only_be_used_in_TypeScript_files));
                    return "skip";
                  }
                  break;
                case 246:
                  var interfaceKeyword = ts2.tokenToString(114);
                  ts2.Debug.assertIsDefined(interfaceKeyword);
                  diagnostics.push(createDiagnosticForNode(node, ts2.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, interfaceKeyword));
                  return "skip";
                case 249:
                  var moduleKeyword = node.flags & 16 ? ts2.tokenToString(136) : ts2.tokenToString(135);
                  ts2.Debug.assertIsDefined(moduleKeyword);
                  diagnostics.push(createDiagnosticForNode(node, ts2.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, moduleKeyword));
                  return "skip";
                case 247:
                  diagnostics.push(createDiagnosticForNode(node, ts2.Diagnostics.Type_aliases_can_only_be_used_in_TypeScript_files));
                  return "skip";
                case 248:
                  var enumKeyword = ts2.Debug.checkDefined(ts2.tokenToString(88));
                  diagnostics.push(createDiagnosticForNode(node, ts2.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, enumKeyword));
                  return "skip";
                case 218:
                  diagnostics.push(createDiagnosticForNode(node, ts2.Diagnostics.Non_null_assertions_can_only_be_used_in_TypeScript_files));
                  return "skip";
                case 217:
                  diagnostics.push(createDiagnosticForNode(node.type, ts2.Diagnostics.Type_assertion_expressions_can_only_be_used_in_TypeScript_files));
                  return "skip";
                case 199:
                  ts2.Debug.fail();
              }
            }
            function walkArray(nodes, parent) {
              if (parent.decorators === nodes && !options.experimentalDecorators) {
                diagnostics.push(createDiagnosticForNode(parent, ts2.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning));
              }
              switch (parent.kind) {
                case 245:
                case 214:
                case 161:
                case 162:
                case 163:
                case 164:
                case 201:
                case 244:
                case 202:
                  if (nodes === parent.typeParameters) {
                    diagnostics.push(createDiagnosticForNodeArray(nodes, ts2.Diagnostics.Type_parameter_declarations_can_only_be_used_in_TypeScript_files));
                    return "skip";
                  }
                case 225:
                  if (nodes === parent.modifiers) {
                    checkModifiers(parent.modifiers, parent.kind === 225);
                    return "skip";
                  }
                  break;
                case 159:
                  if (nodes === parent.modifiers) {
                    for (var _i2 = 0, _a2 = nodes; _i2 < _a2.length; _i2++) {
                      var modifier = _a2[_i2];
                      if (modifier.kind !== 120) {
                        diagnostics.push(createDiagnosticForNode(modifier, ts2.Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, ts2.tokenToString(modifier.kind)));
                      }
                    }
                    return "skip";
                  }
                  break;
                case 156:
                  if (nodes === parent.modifiers) {
                    diagnostics.push(createDiagnosticForNodeArray(nodes, ts2.Diagnostics.Parameter_modifiers_can_only_be_used_in_TypeScript_files));
                    return "skip";
                  }
                  break;
                case 196:
                case 197:
                case 216:
                case 267:
                case 268:
                case 198:
                  if (nodes === parent.typeArguments) {
                    diagnostics.push(createDiagnosticForNodeArray(nodes, ts2.Diagnostics.Type_arguments_can_only_be_used_in_TypeScript_files));
                    return "skip";
                  }
                  break;
              }
            }
            function checkModifiers(modifiers, isConstValid) {
              for (var _i2 = 0, modifiers_1 = modifiers; _i2 < modifiers_1.length; _i2++) {
                var modifier = modifiers_1[_i2];
                switch (modifier.kind) {
                  case 81:
                    if (isConstValid) {
                      continue;
                    }
                  case 119:
                  case 117:
                  case 118:
                  case 138:
                  case 130:
                  case 122:
                    diagnostics.push(createDiagnosticForNode(modifier, ts2.Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, ts2.tokenToString(modifier.kind)));
                    break;
                  case 120:
                  case 89:
                  case 84:
                }
              }
            }
            function createDiagnosticForNodeArray(nodes, message, arg0, arg1, arg2) {
              var start = nodes.pos;
              return ts2.createFileDiagnostic(sourceFile, start, nodes.end - start, message, arg0, arg1, arg2);
            }
            function createDiagnosticForNode(node, message, arg0, arg1, arg2) {
              return ts2.createDiagnosticForNodeInSourceFile(sourceFile, node, message, arg0, arg1, arg2);
            }
          });
        }
        function getDeclarationDiagnosticsWorker(sourceFile, cancellationToken) {
          return getAndCacheDiagnostics(sourceFile, cancellationToken, cachedDeclarationDiagnosticsForFile, getDeclarationDiagnosticsForFileNoCache);
        }
        function getDeclarationDiagnosticsForFileNoCache(sourceFile, cancellationToken) {
          return runWithCancellationToken(function() {
            var resolver = getDiagnosticsProducingTypeChecker().getEmitResolver(sourceFile, cancellationToken);
            return ts2.getDeclarationDiagnostics(getEmitHost(ts2.noop), resolver, sourceFile) || ts2.emptyArray;
          });
        }
        function getAndCacheDiagnostics(sourceFile, cancellationToken, cache, getDiagnostics) {
          var cachedResult = sourceFile ? cache.perFile && cache.perFile.get(sourceFile.path) : cache.allDiagnostics;
          if (cachedResult) {
            return cachedResult;
          }
          var result = getDiagnostics(sourceFile, cancellationToken);
          if (sourceFile) {
            if (!cache.perFile) {
              cache.perFile = ts2.createMap();
            }
            cache.perFile.set(sourceFile.path, result);
          } else {
            cache.allDiagnostics = result;
          }
          return result;
        }
        function getDeclarationDiagnosticsForFile(sourceFile, cancellationToken) {
          return sourceFile.isDeclarationFile ? [] : getDeclarationDiagnosticsWorker(sourceFile, cancellationToken);
        }
        function getOptionsDiagnostics() {
          return ts2.sortAndDeduplicateDiagnostics(ts2.concatenate(fileProcessingDiagnostics.getGlobalDiagnostics(), ts2.concatenate(programDiagnostics.getGlobalDiagnostics(), getOptionsDiagnosticsOfConfigFile())));
        }
        function getOptionsDiagnosticsOfConfigFile() {
          if (!options.configFile) {
            return ts2.emptyArray;
          }
          var diagnostics = programDiagnostics.getDiagnostics(options.configFile.fileName);
          forEachResolvedProjectReference(function(resolvedRef) {
            if (resolvedRef) {
              diagnostics = ts2.concatenate(diagnostics, programDiagnostics.getDiagnostics(resolvedRef.sourceFile.fileName));
            }
          });
          return diagnostics;
        }
        function getGlobalDiagnostics() {
          return rootNames.length ? ts2.sortAndDeduplicateDiagnostics(getDiagnosticsProducingTypeChecker().getGlobalDiagnostics().slice()) : ts2.emptyArray;
        }
        function getConfigFileParsingDiagnostics2() {
          return configFileParsingDiagnostics || ts2.emptyArray;
        }
        function processRootFile(fileName2, isDefaultLib, ignoreNoDefaultLib) {
          processSourceFile(ts2.normalizePath(fileName2), isDefaultLib, ignoreNoDefaultLib, void 0);
        }
        function fileReferenceIsEqualTo(a, b) {
          return a.fileName === b.fileName;
        }
        function moduleNameIsEqualTo(a, b) {
          return a.kind === 75 ? b.kind === 75 && a.escapedText === b.escapedText : b.kind === 10 && a.text === b.text;
        }
        function collectExternalModuleReferences(file) {
          if (file.imports) {
            return;
          }
          var isJavaScriptFile = ts2.isSourceFileJS(file);
          var isExternalModuleFile = ts2.isExternalModule(file);
          var imports;
          var moduleAugmentations;
          var ambientModules;
          if (options.importHelpers && (options.isolatedModules || isExternalModuleFile) && !file.isDeclarationFile) {
            var externalHelpersModuleReference = ts2.createLiteral(ts2.externalHelpersModuleNameText);
            var importDecl = ts2.createImportDeclaration(void 0, void 0, void 0, externalHelpersModuleReference);
            ts2.addEmitFlags(importDecl, 67108864);
            externalHelpersModuleReference.parent = importDecl;
            importDecl.parent = file;
            imports = [externalHelpersModuleReference];
          }
          for (var _i2 = 0, _a2 = file.statements; _i2 < _a2.length; _i2++) {
            var node = _a2[_i2];
            collectModuleReferences(node, false);
          }
          if (file.flags & 1048576 || isJavaScriptFile) {
            collectDynamicImportOrRequireCalls(file);
          }
          file.imports = imports || ts2.emptyArray;
          file.moduleAugmentations = moduleAugmentations || ts2.emptyArray;
          file.ambientModuleNames = ambientModules || ts2.emptyArray;
          return;
          function collectModuleReferences(node2, inAmbientModule) {
            if (ts2.isAnyImportOrReExport(node2)) {
              var moduleNameExpr = ts2.getExternalModuleName(node2);
              if (moduleNameExpr && ts2.isStringLiteral(moduleNameExpr) && moduleNameExpr.text && (!inAmbientModule || !ts2.isExternalModuleNameRelative(moduleNameExpr.text))) {
                imports = ts2.append(imports, moduleNameExpr);
              }
            } else if (ts2.isModuleDeclaration(node2)) {
              if (ts2.isAmbientModule(node2) && (inAmbientModule || ts2.hasModifier(node2, 2) || file.isDeclarationFile)) {
                var nameText = ts2.getTextOfIdentifierOrLiteral(node2.name);
                if (isExternalModuleFile || inAmbientModule && !ts2.isExternalModuleNameRelative(nameText)) {
                  (moduleAugmentations || (moduleAugmentations = [])).push(node2.name);
                } else if (!inAmbientModule) {
                  if (file.isDeclarationFile) {
                    (ambientModules || (ambientModules = [])).push(nameText);
                  }
                  var body = node2.body;
                  if (body) {
                    for (var _i3 = 0, _a3 = body.statements; _i3 < _a3.length; _i3++) {
                      var statement = _a3[_i3];
                      collectModuleReferences(statement, true);
                    }
                  }
                }
              }
            }
          }
          function collectDynamicImportOrRequireCalls(file2) {
            var r = /import|require/g;
            while (r.exec(file2.text) !== null) {
              var node2 = getNodeAtPosition(file2, r.lastIndex);
              if (ts2.isRequireCall(node2, true)) {
                imports = ts2.append(imports, node2.arguments[0]);
              } else if (ts2.isImportCall(node2) && node2.arguments.length === 1 && ts2.isStringLiteralLike(node2.arguments[0])) {
                imports = ts2.append(imports, node2.arguments[0]);
              } else if (ts2.isLiteralImportTypeNode(node2)) {
                imports = ts2.append(imports, node2.argument.literal);
              }
            }
          }
          function getNodeAtPosition(sourceFile, position) {
            var current = sourceFile;
            var getContainingChild = function(child2) {
              if (child2.pos <= position && (position < child2.end || position === child2.end && child2.kind === 1)) {
                return child2;
              }
            };
            while (true) {
              var child = isJavaScriptFile && ts2.hasJSDocNodes(current) && ts2.forEach(current.jsDoc, getContainingChild) || ts2.forEachChild(current, getContainingChild);
              if (!child) {
                return current;
              }
              current = child;
            }
          }
        }
        function getLibFileFromReference(ref) {
          var libName = ts2.toFileNameLowerCase(ref.fileName);
          var libFileName = ts2.libMap.get(libName);
          if (libFileName) {
            return getSourceFile(ts2.combinePaths(defaultLibraryPath, libFileName));
          }
        }
        function getSourceFileFromReference(referencingFile, ref) {
          return getSourceFileFromReferenceWorker(resolveTripleslashReference(ref.fileName, referencingFile.fileName), function(fileName2) {
            return filesByName.get(toPath(fileName2)) || void 0;
          });
        }
        function getSourceFileFromReferenceWorker(fileName2, getSourceFile2, fail, refFile) {
          if (ts2.hasExtension(fileName2)) {
            var canonicalFileName_1 = host.getCanonicalFileName(fileName2);
            if (!options.allowNonTsExtensions && !ts2.forEach(supportedExtensionsWithJsonIfResolveJsonModule, function(extension) {
              return ts2.fileExtensionIs(canonicalFileName_1, extension);
            })) {
              if (fail) {
                if (ts2.hasJSFileExtension(canonicalFileName_1)) {
                  fail(ts2.Diagnostics.File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option, fileName2);
                } else {
                  fail(ts2.Diagnostics.File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1, fileName2, "'" + supportedExtensions.join("', '") + "'");
                }
              }
              return void 0;
            }
            var sourceFile = getSourceFile2(fileName2);
            if (fail) {
              if (!sourceFile) {
                var redirect = getProjectReferenceRedirect(fileName2);
                if (redirect) {
                  fail(ts2.Diagnostics.Output_file_0_has_not_been_built_from_source_file_1, redirect, fileName2);
                } else {
                  fail(ts2.Diagnostics.File_0_not_found, fileName2);
                }
              } else if (refFile && canonicalFileName_1 === host.getCanonicalFileName(refFile.fileName)) {
                fail(ts2.Diagnostics.A_file_cannot_have_a_reference_to_itself);
              }
            }
            return sourceFile;
          } else {
            var sourceFileNoExtension = options.allowNonTsExtensions && getSourceFile2(fileName2);
            if (sourceFileNoExtension)
              return sourceFileNoExtension;
            if (fail && options.allowNonTsExtensions) {
              fail(ts2.Diagnostics.File_0_not_found, fileName2);
              return void 0;
            }
            var sourceFileWithAddedExtension = ts2.forEach(supportedExtensions, function(extension) {
              return getSourceFile2(fileName2 + extension);
            });
            if (fail && !sourceFileWithAddedExtension)
              fail(ts2.Diagnostics.Could_not_resolve_the_path_0_with_the_extensions_Colon_1, fileName2, "'" + supportedExtensions.join("', '") + "'");
            return sourceFileWithAddedExtension;
          }
        }
        function processSourceFile(fileName2, isDefaultLib, ignoreNoDefaultLib, packageId, refFile) {
          getSourceFileFromReferenceWorker(fileName2, function(fileName3) {
            return findSourceFile(fileName3, toPath(fileName3), isDefaultLib, ignoreNoDefaultLib, refFile, packageId);
          }, function(diagnostic) {
            var args = [];
            for (var _i2 = 1; _i2 < arguments.length; _i2++) {
              args[_i2 - 1] = arguments[_i2];
            }
            return fileProcessingDiagnostics.add(createRefFileDiagnostic.apply(void 0, __spreadArrays([refFile, diagnostic], args)));
          }, refFile && refFile.file);
        }
        function reportFileNamesDifferOnlyInCasingError(fileName2, existingFile, refFile) {
          var refs = !refFile ? refFileMap && refFileMap.get(existingFile.path) : void 0;
          var refToReportErrorOn = refs && ts2.find(refs, function(ref) {
            return ref.referencedFileName === existingFile.fileName;
          });
          fileProcessingDiagnostics.add(refToReportErrorOn ? createFileDiagnosticAtReference(refToReportErrorOn, ts2.Diagnostics.Already_included_file_name_0_differs_from_file_name_1_only_in_casing, existingFile.fileName, fileName2) : createRefFileDiagnostic(refFile, ts2.Diagnostics.File_name_0_differs_from_already_included_file_name_1_only_in_casing, fileName2, existingFile.fileName));
        }
        function createRedirectSourceFile(redirectTarget, unredirected, fileName2, path2, resolvedPath, originalFileName) {
          var redirect = Object.create(redirectTarget);
          redirect.fileName = fileName2;
          redirect.path = path2;
          redirect.resolvedPath = resolvedPath;
          redirect.originalFileName = originalFileName;
          redirect.redirectInfo = { redirectTarget, unredirected };
          sourceFilesFoundSearchingNodeModules.set(path2, currentNodeModulesDepth > 0);
          Object.defineProperties(redirect, {
            id: {
              get: function() {
                return this.redirectInfo.redirectTarget.id;
              },
              set: function(value) {
                this.redirectInfo.redirectTarget.id = value;
              }
            },
            symbol: {
              get: function() {
                return this.redirectInfo.redirectTarget.symbol;
              },
              set: function(value) {
                this.redirectInfo.redirectTarget.symbol = value;
              }
            }
          });
          return redirect;
        }
        function findSourceFile(fileName2, path2, isDefaultLib, ignoreNoDefaultLib, refFile, packageId) {
          if (useSourceOfProjectReferenceRedirect) {
            var source = getSourceOfProjectReferenceRedirect(fileName2);
            if (!source && host.realpath && options.preserveSymlinks && ts2.isDeclarationFileName(fileName2) && ts2.stringContains(fileName2, ts2.nodeModulesPathPart)) {
              var realPath = host.realpath(fileName2);
              if (realPath !== fileName2)
                source = getSourceOfProjectReferenceRedirect(realPath);
            }
            if (source) {
              var file_1 = ts2.isString(source) ? findSourceFile(source, toPath(source), isDefaultLib, ignoreNoDefaultLib, refFile, packageId) : void 0;
              if (file_1)
                addFileToFilesByName(file_1, path2, void 0);
              return file_1;
            }
          }
          var originalFileName = fileName2;
          if (filesByName.has(path2)) {
            var file_2 = filesByName.get(path2);
            addFileToRefFileMap(fileName2, file_2 || void 0, refFile);
            if (file_2 && options.forceConsistentCasingInFileNames) {
              var checkedName = file_2.fileName;
              var isRedirect = toPath(checkedName) !== toPath(fileName2);
              if (isRedirect) {
                fileName2 = getProjectReferenceRedirect(fileName2) || fileName2;
              }
              var checkedAbsolutePath = ts2.getNormalizedAbsolutePathWithoutRoot(checkedName, currentDirectory);
              var inputAbsolutePath = ts2.getNormalizedAbsolutePathWithoutRoot(fileName2, currentDirectory);
              if (checkedAbsolutePath !== inputAbsolutePath) {
                reportFileNamesDifferOnlyInCasingError(fileName2, file_2, refFile);
              }
            }
            if (file_2 && sourceFilesFoundSearchingNodeModules.get(file_2.path) && currentNodeModulesDepth === 0) {
              sourceFilesFoundSearchingNodeModules.set(file_2.path, false);
              if (!options.noResolve) {
                processReferencedFiles(file_2, isDefaultLib);
                processTypeReferenceDirectives(file_2);
              }
              if (!options.noLib) {
                processLibReferenceDirectives(file_2);
              }
              modulesWithElidedImports.set(file_2.path, false);
              processImportedModules(file_2);
            } else if (file_2 && modulesWithElidedImports.get(file_2.path)) {
              if (currentNodeModulesDepth < maxNodeModuleJsDepth) {
                modulesWithElidedImports.set(file_2.path, false);
                processImportedModules(file_2);
              }
            }
            return file_2 || void 0;
          }
          var redirectedPath;
          if (refFile && !useSourceOfProjectReferenceRedirect) {
            var redirectProject = getProjectReferenceRedirectProject(fileName2);
            if (redirectProject) {
              if (redirectProject.commandLine.options.outFile || redirectProject.commandLine.options.out) {
                return void 0;
              }
              var redirect = getProjectReferenceOutputName(redirectProject, fileName2);
              fileName2 = redirect;
              redirectedPath = toPath(redirect);
            }
          }
          var file = host.getSourceFile(fileName2, options.target, function(hostErrorMessage) {
            return fileProcessingDiagnostics.add(createRefFileDiagnostic(refFile, ts2.Diagnostics.Cannot_read_file_0_Colon_1, fileName2, hostErrorMessage));
          }, shouldCreateNewSourceFile);
          if (packageId) {
            var packageIdKey = ts2.packageIdToString(packageId);
            var fileFromPackageId = packageIdToSourceFile.get(packageIdKey);
            if (fileFromPackageId) {
              var dupFile = createRedirectSourceFile(fileFromPackageId, file, fileName2, path2, toPath(fileName2), originalFileName);
              redirectTargetsMap.add(fileFromPackageId.path, fileName2);
              addFileToFilesByName(dupFile, path2, redirectedPath);
              sourceFileToPackageName.set(path2, packageId.name);
              processingOtherFiles.push(dupFile);
              return dupFile;
            } else if (file) {
              packageIdToSourceFile.set(packageIdKey, file);
              sourceFileToPackageName.set(path2, packageId.name);
            }
          }
          addFileToFilesByName(file, path2, redirectedPath);
          if (file) {
            sourceFilesFoundSearchingNodeModules.set(path2, currentNodeModulesDepth > 0);
            file.fileName = fileName2;
            file.path = path2;
            file.resolvedPath = toPath(fileName2);
            file.originalFileName = originalFileName;
            addFileToRefFileMap(fileName2, file, refFile);
            if (host.useCaseSensitiveFileNames()) {
              var pathLowerCase = ts2.toFileNameLowerCase(path2);
              var existingFile = filesByNameIgnoreCase.get(pathLowerCase);
              if (existingFile) {
                reportFileNamesDifferOnlyInCasingError(fileName2, existingFile, refFile);
              } else {
                filesByNameIgnoreCase.set(pathLowerCase, file);
              }
            }
            skipDefaultLib = skipDefaultLib || file.hasNoDefaultLib && !ignoreNoDefaultLib;
            if (!options.noResolve) {
              processReferencedFiles(file, isDefaultLib);
              processTypeReferenceDirectives(file);
            }
            if (!options.noLib) {
              processLibReferenceDirectives(file);
            }
            processImportedModules(file);
            if (isDefaultLib) {
              processingDefaultLibFiles.push(file);
            } else {
              processingOtherFiles.push(file);
            }
          }
          return file;
        }
        function addFileToRefFileMap(referencedFileName, file, refFile) {
          if (refFile && file) {
            (refFileMap || (refFileMap = ts2.createMultiMap())).add(file.path, {
              referencedFileName,
              kind: refFile.kind,
              index: refFile.index,
              file: refFile.file.path
            });
          }
        }
        function addFileToFilesByName(file, path2, redirectedPath) {
          if (redirectedPath) {
            filesByName.set(redirectedPath, file);
            filesByName.set(path2, file || false);
          } else {
            filesByName.set(path2, file);
          }
        }
        function getProjectReferenceRedirect(fileName2) {
          var referencedProject = getProjectReferenceRedirectProject(fileName2);
          return referencedProject && getProjectReferenceOutputName(referencedProject, fileName2);
        }
        function getProjectReferenceRedirectProject(fileName2) {
          if (!resolvedProjectReferences || !resolvedProjectReferences.length || ts2.fileExtensionIs(fileName2, ".d.ts") || ts2.fileExtensionIs(fileName2, ".json")) {
            return void 0;
          }
          return getResolvedProjectReferenceToRedirect(fileName2);
        }
        function getProjectReferenceOutputName(referencedProject, fileName2) {
          var out2 = referencedProject.commandLine.options.outFile || referencedProject.commandLine.options.out;
          return out2 ? ts2.changeExtension(out2, ".d.ts") : ts2.getOutputDeclarationFileName(fileName2, referencedProject.commandLine, !host.useCaseSensitiveFileNames());
        }
        function getResolvedProjectReferenceToRedirect(fileName2) {
          if (mapFromFileToProjectReferenceRedirects === void 0) {
            mapFromFileToProjectReferenceRedirects = ts2.createMap();
            forEachResolvedProjectReference(function(referencedProject, referenceProjectPath) {
              if (referencedProject && toPath(options.configFilePath) !== referenceProjectPath) {
                referencedProject.commandLine.fileNames.forEach(function(f) {
                  return mapFromFileToProjectReferenceRedirects.set(toPath(f), referenceProjectPath);
                });
              }
            });
          }
          var referencedProjectPath = mapFromFileToProjectReferenceRedirects.get(toPath(fileName2));
          return referencedProjectPath && getResolvedProjectReferenceByPath(referencedProjectPath);
        }
        function forEachResolvedProjectReference(cb) {
          return forEachProjectReference(projectReferences, resolvedProjectReferences, function(resolvedRef, index, parent) {
            var ref = (parent ? parent.commandLine.projectReferences : projectReferences)[index];
            var resolvedRefPath = toPath(resolveProjectReferencePath(ref));
            return cb(resolvedRef, resolvedRefPath);
          });
        }
        function getSourceOfProjectReferenceRedirect(file) {
          if (!ts2.isDeclarationFileName(file))
            return void 0;
          if (mapFromToProjectReferenceRedirectSource === void 0) {
            mapFromToProjectReferenceRedirectSource = ts2.createMap();
            forEachResolvedProjectReference(function(resolvedRef) {
              if (resolvedRef) {
                var out2 = resolvedRef.commandLine.options.outFile || resolvedRef.commandLine.options.out;
                if (out2) {
                  var outputDts = ts2.changeExtension(out2, ".d.ts");
                  mapFromToProjectReferenceRedirectSource.set(toPath(outputDts), true);
                } else {
                  ts2.forEach(resolvedRef.commandLine.fileNames, function(fileName2) {
                    if (!ts2.fileExtensionIs(fileName2, ".d.ts") && !ts2.fileExtensionIs(fileName2, ".json")) {
                      var outputDts2 = ts2.getOutputDeclarationFileName(fileName2, resolvedRef.commandLine, host.useCaseSensitiveFileNames());
                      mapFromToProjectReferenceRedirectSource.set(toPath(outputDts2), fileName2);
                    }
                  });
                }
              }
            });
          }
          return mapFromToProjectReferenceRedirectSource.get(toPath(file));
        }
        function isSourceOfProjectReferenceRedirect(fileName2) {
          return useSourceOfProjectReferenceRedirect && !!getResolvedProjectReferenceToRedirect(fileName2);
        }
        function forEachProjectReference(projectReferences2, resolvedProjectReferences2, cbResolvedRef, cbRef) {
          var seenResolvedRefs;
          return worker(projectReferences2, resolvedProjectReferences2, void 0, cbResolvedRef, cbRef);
          function worker(projectReferences3, resolvedProjectReferences3, parent, cbResolvedRef2, cbRef2) {
            if (cbRef2) {
              var result = cbRef2(projectReferences3, parent);
              if (result) {
                return result;
              }
            }
            return ts2.forEach(resolvedProjectReferences3, function(resolvedRef, index) {
              if (ts2.contains(seenResolvedRefs, resolvedRef)) {
                return void 0;
              }
              var result2 = cbResolvedRef2(resolvedRef, index, parent);
              if (result2) {
                return result2;
              }
              if (!resolvedRef)
                return void 0;
              (seenResolvedRefs || (seenResolvedRefs = [])).push(resolvedRef);
              return worker(resolvedRef.commandLine.projectReferences, resolvedRef.references, resolvedRef, cbResolvedRef2, cbRef2);
            });
          }
        }
        function getResolvedProjectReferenceByPath(projectReferencePath) {
          if (!projectReferenceRedirects) {
            return void 0;
          }
          return projectReferenceRedirects.get(projectReferencePath) || void 0;
        }
        function processReferencedFiles(file, isDefaultLib) {
          ts2.forEach(file.referencedFiles, function(ref, index) {
            var referencedFileName = resolveTripleslashReference(ref.fileName, file.originalFileName);
            processSourceFile(referencedFileName, isDefaultLib, false, void 0, {
              kind: ts2.RefFileKind.ReferenceFile,
              index,
              file,
              pos: ref.pos,
              end: ref.end
            });
          });
        }
        function processTypeReferenceDirectives(file) {
          var typeDirectives = ts2.map(file.typeReferenceDirectives, function(ref2) {
            return ts2.toFileNameLowerCase(ref2.fileName);
          });
          if (!typeDirectives) {
            return;
          }
          var resolutions2 = resolveTypeReferenceDirectiveNamesWorker(typeDirectives, file.originalFileName, getResolvedProjectReferenceToRedirect(file.originalFileName));
          for (var i2 = 0; i2 < typeDirectives.length; i2++) {
            var ref = file.typeReferenceDirectives[i2];
            var resolvedTypeReferenceDirective = resolutions2[i2];
            var fileName2 = ts2.toFileNameLowerCase(ref.fileName);
            ts2.setResolvedTypeReferenceDirective(file, fileName2, resolvedTypeReferenceDirective);
            processTypeReferenceDirective(fileName2, resolvedTypeReferenceDirective, {
              kind: ts2.RefFileKind.TypeReferenceDirective,
              index: i2,
              file,
              pos: ref.pos,
              end: ref.end
            });
          }
        }
        function processTypeReferenceDirective(typeReferenceDirective, resolvedTypeReferenceDirective, refFile) {
          var previousResolution = resolvedTypeReferenceDirectives.get(typeReferenceDirective);
          if (previousResolution && previousResolution.primary) {
            return;
          }
          var saveResolution = true;
          if (resolvedTypeReferenceDirective) {
            if (resolvedTypeReferenceDirective.isExternalLibraryImport)
              currentNodeModulesDepth++;
            if (resolvedTypeReferenceDirective.primary) {
              processSourceFile(resolvedTypeReferenceDirective.resolvedFileName, false, false, resolvedTypeReferenceDirective.packageId, refFile);
            } else {
              if (previousResolution) {
                if (resolvedTypeReferenceDirective.resolvedFileName !== previousResolution.resolvedFileName) {
                  var otherFileText = host.readFile(resolvedTypeReferenceDirective.resolvedFileName);
                  var existingFile_1 = getSourceFile(previousResolution.resolvedFileName);
                  if (otherFileText !== existingFile_1.text) {
                    var refs = !refFile ? refFileMap && refFileMap.get(existingFile_1.path) : void 0;
                    var refToReportErrorOn = refs && ts2.find(refs, function(ref) {
                      return ref.referencedFileName === existingFile_1.fileName;
                    });
                    fileProcessingDiagnostics.add(refToReportErrorOn ? createFileDiagnosticAtReference(refToReportErrorOn, ts2.Diagnostics.Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_library_to_resolve_the_conflict, typeReferenceDirective, resolvedTypeReferenceDirective.resolvedFileName, previousResolution.resolvedFileName) : createRefFileDiagnostic(refFile, ts2.Diagnostics.Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_library_to_resolve_the_conflict, typeReferenceDirective, resolvedTypeReferenceDirective.resolvedFileName, previousResolution.resolvedFileName));
                  }
                }
                saveResolution = false;
              } else {
                processSourceFile(resolvedTypeReferenceDirective.resolvedFileName, false, false, resolvedTypeReferenceDirective.packageId, refFile);
              }
            }
            if (resolvedTypeReferenceDirective.isExternalLibraryImport)
              currentNodeModulesDepth--;
          } else {
            fileProcessingDiagnostics.add(createRefFileDiagnostic(refFile, ts2.Diagnostics.Cannot_find_type_definition_file_for_0, typeReferenceDirective));
          }
          if (saveResolution) {
            resolvedTypeReferenceDirectives.set(typeReferenceDirective, resolvedTypeReferenceDirective);
          }
        }
        function processLibReferenceDirectives(file) {
          ts2.forEach(file.libReferenceDirectives, function(libReference) {
            var libName = ts2.toFileNameLowerCase(libReference.fileName);
            var libFileName = ts2.libMap.get(libName);
            if (libFileName) {
              processRootFile(ts2.combinePaths(defaultLibraryPath, libFileName), true, true);
            } else {
              var unqualifiedLibName = ts2.removeSuffix(ts2.removePrefix(libName, "lib."), ".d.ts");
              var suggestion = ts2.getSpellingSuggestion(unqualifiedLibName, ts2.libs, ts2.identity);
              var message = suggestion ? ts2.Diagnostics.Cannot_find_lib_definition_for_0_Did_you_mean_1 : ts2.Diagnostics.Cannot_find_lib_definition_for_0;
              fileProcessingDiagnostics.add(ts2.createFileDiagnostic(file, libReference.pos, libReference.end - libReference.pos, message, libName, suggestion));
            }
          });
        }
        function createRefFileDiagnostic(refFile, message) {
          var args = [];
          for (var _i2 = 2; _i2 < arguments.length; _i2++) {
            args[_i2 - 2] = arguments[_i2];
          }
          if (!refFile) {
            return ts2.createCompilerDiagnostic.apply(void 0, __spreadArrays([message], args));
          } else {
            return ts2.createFileDiagnostic.apply(void 0, __spreadArrays([refFile.file, refFile.pos, refFile.end - refFile.pos, message], args));
          }
        }
        function getCanonicalFileName(fileName2) {
          return host.getCanonicalFileName(fileName2);
        }
        function processImportedModules(file) {
          collectExternalModuleReferences(file);
          if (file.imports.length || file.moduleAugmentations.length) {
            var moduleNames = getModuleNames(file);
            var resolutions2 = resolveModuleNamesReusingOldState(moduleNames, ts2.getNormalizedAbsolutePath(file.originalFileName, currentDirectory), file);
            ts2.Debug.assert(resolutions2.length === moduleNames.length);
            for (var i2 = 0; i2 < moduleNames.length; i2++) {
              var resolution = resolutions2[i2];
              ts2.setResolvedModule(file, moduleNames[i2], resolution);
              if (!resolution) {
                continue;
              }
              var isFromNodeModulesSearch = resolution.isExternalLibraryImport;
              var isJsFile = !ts2.resolutionExtensionIsTSOrJson(resolution.extension);
              var isJsFileFromNodeModules = isFromNodeModulesSearch && isJsFile;
              var resolvedFileName = resolution.resolvedFileName;
              if (isFromNodeModulesSearch) {
                currentNodeModulesDepth++;
              }
              var elideImport = isJsFileFromNodeModules && currentNodeModulesDepth > maxNodeModuleJsDepth;
              var shouldAddFile = resolvedFileName && !getResolutionDiagnostic(options, resolution) && !options.noResolve && i2 < file.imports.length && !elideImport && !(isJsFile && !options.allowJs) && (ts2.isInJSFile(file.imports[i2]) || !(file.imports[i2].flags & 4194304));
              if (elideImport) {
                modulesWithElidedImports.set(file.path, true);
              } else if (shouldAddFile) {
                var path2 = toPath(resolvedFileName);
                var pos = ts2.skipTrivia(file.text, file.imports[i2].pos);
                findSourceFile(resolvedFileName, path2, false, false, {
                  kind: ts2.RefFileKind.Import,
                  index: i2,
                  file,
                  pos,
                  end: file.imports[i2].end
                }, resolution.packageId);
              }
              if (isFromNodeModulesSearch) {
                currentNodeModulesDepth--;
              }
            }
          } else {
            file.resolvedModules = void 0;
          }
        }
        function computeCommonSourceDirectory(sourceFiles) {
          var fileNames = ts2.mapDefined(sourceFiles, function(file) {
            return file.isDeclarationFile ? void 0 : file.fileName;
          });
          return computeCommonSourceDirectoryOfFilenames(fileNames, currentDirectory, getCanonicalFileName);
        }
        function checkSourceFilesBelongToPath(sourceFiles, rootDirectory) {
          var allFilesBelongToPath = true;
          var absoluteRootDirectoryPath = host.getCanonicalFileName(ts2.getNormalizedAbsolutePath(rootDirectory, currentDirectory));
          var rootPaths;
          for (var _i2 = 0, sourceFiles_2 = sourceFiles; _i2 < sourceFiles_2.length; _i2++) {
            var sourceFile = sourceFiles_2[_i2];
            if (!sourceFile.isDeclarationFile) {
              var absoluteSourceFilePath = host.getCanonicalFileName(ts2.getNormalizedAbsolutePath(sourceFile.fileName, currentDirectory));
              if (absoluteSourceFilePath.indexOf(absoluteRootDirectoryPath) !== 0) {
                if (!rootPaths)
                  rootPaths = ts2.arrayToSet(rootNames, toPath);
                addProgramDiagnosticAtRefPath(sourceFile, rootPaths, ts2.Diagnostics.File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files, sourceFile.fileName, rootDirectory);
                allFilesBelongToPath = false;
              }
            }
          }
          return allFilesBelongToPath;
        }
        function parseProjectReferenceConfigFile(ref) {
          if (!projectReferenceRedirects) {
            projectReferenceRedirects = ts2.createMap();
          }
          var refPath = resolveProjectReferencePath(ref);
          var sourceFilePath = toPath(refPath);
          var fromCache = projectReferenceRedirects.get(sourceFilePath);
          if (fromCache !== void 0) {
            return fromCache || void 0;
          }
          var commandLine;
          var sourceFile;
          if (host.getParsedCommandLine) {
            commandLine = host.getParsedCommandLine(refPath);
            if (!commandLine) {
              addFileToFilesByName(void 0, sourceFilePath, void 0);
              projectReferenceRedirects.set(sourceFilePath, false);
              return void 0;
            }
            sourceFile = ts2.Debug.checkDefined(commandLine.options.configFile);
            ts2.Debug.assert(!sourceFile.path || sourceFile.path === sourceFilePath);
            addFileToFilesByName(sourceFile, sourceFilePath, void 0);
          } else {
            var basePath = ts2.getNormalizedAbsolutePath(ts2.getDirectoryPath(refPath), host.getCurrentDirectory());
            sourceFile = host.getSourceFile(refPath, 100);
            addFileToFilesByName(sourceFile, sourceFilePath, void 0);
            if (sourceFile === void 0) {
              projectReferenceRedirects.set(sourceFilePath, false);
              return void 0;
            }
            commandLine = ts2.parseJsonSourceFileConfigFileContent(sourceFile, configParsingHost, basePath, void 0, refPath);
          }
          sourceFile.fileName = refPath;
          sourceFile.path = sourceFilePath;
          sourceFile.resolvedPath = sourceFilePath;
          sourceFile.originalFileName = refPath;
          var resolvedRef = { commandLine, sourceFile };
          projectReferenceRedirects.set(sourceFilePath, resolvedRef);
          if (commandLine.projectReferences) {
            resolvedRef.references = commandLine.projectReferences.map(parseProjectReferenceConfigFile);
          }
          return resolvedRef;
        }
        function verifyCompilerOptions() {
          if (options.strictPropertyInitialization && !ts2.getStrictOptionValue(options, "strictNullChecks")) {
            createDiagnosticForOptionName(ts2.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "strictPropertyInitialization", "strictNullChecks");
          }
          if (options.isolatedModules) {
            if (options.out) {
              createDiagnosticForOptionName(ts2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "out", "isolatedModules");
            }
            if (options.outFile) {
              createDiagnosticForOptionName(ts2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "outFile", "isolatedModules");
            }
          }
          if (options.inlineSourceMap) {
            if (options.sourceMap) {
              createDiagnosticForOptionName(ts2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "sourceMap", "inlineSourceMap");
            }
            if (options.mapRoot) {
              createDiagnosticForOptionName(ts2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "mapRoot", "inlineSourceMap");
            }
          }
          if (options.paths && options.baseUrl === void 0) {
            createDiagnosticForOptionName(ts2.Diagnostics.Option_paths_cannot_be_used_without_specifying_baseUrl_option, "paths");
          }
          if (options.composite) {
            if (options.declaration === false) {
              createDiagnosticForOptionName(ts2.Diagnostics.Composite_projects_may_not_disable_declaration_emit, "declaration");
            }
            if (options.incremental === false) {
              createDiagnosticForOptionName(ts2.Diagnostics.Composite_projects_may_not_disable_incremental_compilation, "declaration");
            }
          }
          if (options.tsBuildInfoFile) {
            if (!ts2.isIncrementalCompilation(options)) {
              createDiagnosticForOptionName(ts2.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "tsBuildInfoFile", "incremental", "composite");
            }
          } else if (options.incremental && !options.outFile && !options.out && !options.configFilePath) {
            programDiagnostics.add(ts2.createCompilerDiagnostic(ts2.Diagnostics.Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBuildInfoFile_is_specified));
          }
          if (!options.listFilesOnly && options.noEmit && ts2.isIncrementalCompilation(options)) {
            createDiagnosticForOptionName(ts2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "noEmit", options.incremental ? "incremental" : "composite");
          }
          verifyProjectReferences();
          if (options.composite) {
            var rootPaths = ts2.arrayToSet(rootNames, toPath);
            for (var _i2 = 0, files_3 = files; _i2 < files_3.length; _i2++) {
              var file = files_3[_i2];
              if (ts2.sourceFileMayBeEmitted(file, program) && !rootPaths.has(file.path)) {
                addProgramDiagnosticAtRefPath(file, rootPaths, ts2.Diagnostics.File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_include_pattern, file.fileName, options.configFilePath || "");
              }
            }
          }
          if (options.paths) {
            for (var key in options.paths) {
              if (!ts2.hasProperty(options.paths, key)) {
                continue;
              }
              if (!ts2.hasZeroOrOneAsteriskCharacter(key)) {
                createDiagnosticForOptionPaths(true, key, ts2.Diagnostics.Pattern_0_can_have_at_most_one_Asterisk_character, key);
              }
              if (ts2.isArray(options.paths[key])) {
                var len = options.paths[key].length;
                if (len === 0) {
                  createDiagnosticForOptionPaths(false, key, ts2.Diagnostics.Substitutions_for_pattern_0_shouldn_t_be_an_empty_array, key);
                }
                for (var i2 = 0; i2 < len; i2++) {
                  var subst = options.paths[key][i2];
                  var typeOfSubst = typeof subst;
                  if (typeOfSubst === "string") {
                    if (!ts2.hasZeroOrOneAsteriskCharacter(subst)) {
                      createDiagnosticForOptionPathKeyValue(key, i2, ts2.Diagnostics.Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character, subst, key);
                    }
                  } else {
                    createDiagnosticForOptionPathKeyValue(key, i2, ts2.Diagnostics.Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2, subst, key, typeOfSubst);
                  }
                }
              } else {
                createDiagnosticForOptionPaths(false, key, ts2.Diagnostics.Substitutions_for_pattern_0_should_be_an_array, key);
              }
            }
          }
          if (!options.sourceMap && !options.inlineSourceMap) {
            if (options.inlineSources) {
              createDiagnosticForOptionName(ts2.Diagnostics.Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided, "inlineSources");
            }
            if (options.sourceRoot) {
              createDiagnosticForOptionName(ts2.Diagnostics.Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided, "sourceRoot");
            }
          }
          if (options.out && options.outFile) {
            createDiagnosticForOptionName(ts2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "out", "outFile");
          }
          if (options.mapRoot && !(options.sourceMap || options.declarationMap)) {
            createDiagnosticForOptionName(ts2.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "mapRoot", "sourceMap", "declarationMap");
          }
          if (options.declarationDir) {
            if (!ts2.getEmitDeclarations(options)) {
              createDiagnosticForOptionName(ts2.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "declarationDir", "declaration", "composite");
            }
            if (options.out || options.outFile) {
              createDiagnosticForOptionName(ts2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "declarationDir", options.out ? "out" : "outFile");
            }
          }
          if (options.declarationMap && !ts2.getEmitDeclarations(options)) {
            createDiagnosticForOptionName(ts2.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "declarationMap", "declaration", "composite");
          }
          if (options.lib && options.noLib) {
            createDiagnosticForOptionName(ts2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "lib", "noLib");
          }
          if (options.noImplicitUseStrict && ts2.getStrictOptionValue(options, "alwaysStrict")) {
            createDiagnosticForOptionName(ts2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "noImplicitUseStrict", "alwaysStrict");
          }
          var languageVersion = options.target || 0;
          var outFile = options.outFile || options.out;
          var firstNonAmbientExternalModuleSourceFile = ts2.find(files, function(f) {
            return ts2.isExternalModule(f) && !f.isDeclarationFile;
          });
          if (options.isolatedModules) {
            if (options.module === ts2.ModuleKind.None && languageVersion < 2) {
              createDiagnosticForOptionName(ts2.Diagnostics.Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher, "isolatedModules", "target");
            }
            var firstNonExternalModuleSourceFile = ts2.find(files, function(f) {
              return !ts2.isExternalModule(f) && !ts2.isSourceFileJS(f) && !f.isDeclarationFile && f.scriptKind !== 6;
            });
            if (firstNonExternalModuleSourceFile) {
              var span = ts2.getErrorSpanForNode(firstNonExternalModuleSourceFile, firstNonExternalModuleSourceFile);
              programDiagnostics.add(ts2.createFileDiagnostic(firstNonExternalModuleSourceFile, span.start, span.length, ts2.Diagnostics.All_files_must_be_modules_when_the_isolatedModules_flag_is_provided));
            }
          } else if (firstNonAmbientExternalModuleSourceFile && languageVersion < 2 && options.module === ts2.ModuleKind.None) {
            var span = ts2.getErrorSpanForNode(firstNonAmbientExternalModuleSourceFile, firstNonAmbientExternalModuleSourceFile.externalModuleIndicator);
            programDiagnostics.add(ts2.createFileDiagnostic(firstNonAmbientExternalModuleSourceFile, span.start, span.length, ts2.Diagnostics.Cannot_use_imports_exports_or_module_augmentations_when_module_is_none));
          }
          if (outFile && !options.emitDeclarationOnly) {
            if (options.module && !(options.module === ts2.ModuleKind.AMD || options.module === ts2.ModuleKind.System)) {
              createDiagnosticForOptionName(ts2.Diagnostics.Only_amd_and_system_modules_are_supported_alongside_0, options.out ? "out" : "outFile", "module");
            } else if (options.module === void 0 && firstNonAmbientExternalModuleSourceFile) {
              var span = ts2.getErrorSpanForNode(firstNonAmbientExternalModuleSourceFile, firstNonAmbientExternalModuleSourceFile.externalModuleIndicator);
              programDiagnostics.add(ts2.createFileDiagnostic(firstNonAmbientExternalModuleSourceFile, span.start, span.length, ts2.Diagnostics.Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system, options.out ? "out" : "outFile"));
            }
          }
          if (options.resolveJsonModule) {
            if (ts2.getEmitModuleResolutionKind(options) !== ts2.ModuleResolutionKind.NodeJs) {
              createDiagnosticForOptionName(ts2.Diagnostics.Option_resolveJsonModule_cannot_be_specified_without_node_module_resolution_strategy, "resolveJsonModule");
            } else if (!ts2.hasJsonModuleEmitEnabled(options)) {
              createDiagnosticForOptionName(ts2.Diagnostics.Option_resolveJsonModule_can_only_be_specified_when_module_code_generation_is_commonjs_amd_es2015_or_esNext, "resolveJsonModule", "module");
            }
          }
          if (options.outDir || options.sourceRoot || options.mapRoot) {
            var dir = getCommonSourceDirectory();
            if (options.outDir && dir === "" && files.some(function(file2) {
              return ts2.getRootLength(file2.fileName) > 1;
            })) {
              createDiagnosticForOptionName(ts2.Diagnostics.Cannot_find_the_common_subdirectory_path_for_the_input_files, "outDir");
            }
          }
          if (options.useDefineForClassFields && languageVersion === 0) {
            createDiagnosticForOptionName(ts2.Diagnostics.Option_0_cannot_be_specified_when_option_target_is_ES3, "useDefineForClassFields");
          }
          if (options.checkJs && !options.allowJs) {
            programDiagnostics.add(ts2.createCompilerDiagnostic(ts2.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "checkJs", "allowJs"));
          }
          if (options.emitDeclarationOnly) {
            if (!ts2.getEmitDeclarations(options)) {
              createDiagnosticForOptionName(ts2.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "emitDeclarationOnly", "declaration", "composite");
            }
            if (options.noEmit) {
              createDiagnosticForOptionName(ts2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "emitDeclarationOnly", "noEmit");
            }
          }
          if (options.emitDecoratorMetadata && !options.experimentalDecorators) {
            createDiagnosticForOptionName(ts2.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "emitDecoratorMetadata", "experimentalDecorators");
          }
          if (options.jsxFactory) {
            if (options.reactNamespace) {
              createDiagnosticForOptionName(ts2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "reactNamespace", "jsxFactory");
            }
            if (!ts2.parseIsolatedEntityName(options.jsxFactory, languageVersion)) {
              createOptionValueDiagnostic("jsxFactory", ts2.Diagnostics.Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name, options.jsxFactory);
            }
          } else if (options.reactNamespace && !ts2.isIdentifierText(options.reactNamespace, languageVersion)) {
            createOptionValueDiagnostic("reactNamespace", ts2.Diagnostics.Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier, options.reactNamespace);
          }
          if (!options.noEmit && !options.suppressOutputPathCheck) {
            var emitHost = getEmitHost();
            var emitFilesSeen_1 = ts2.createMap();
            ts2.forEachEmittedFile(emitHost, function(emitFileNames) {
              if (!options.emitDeclarationOnly) {
                verifyEmitFilePath(emitFileNames.jsFilePath, emitFilesSeen_1);
              }
              verifyEmitFilePath(emitFileNames.declarationFilePath, emitFilesSeen_1);
            });
          }
          function verifyEmitFilePath(emitFileName, emitFilesSeen) {
            if (emitFileName) {
              var emitFilePath = toPath(emitFileName);
              if (filesByName.has(emitFilePath)) {
                var chain = void 0;
                if (!options.configFilePath) {
                  chain = ts2.chainDiagnosticMessages(void 0, ts2.Diagnostics.Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript_files_Learn_more_at_https_Colon_Slash_Slashaka_ms_Slashtsconfig);
                }
                chain = ts2.chainDiagnosticMessages(chain, ts2.Diagnostics.Cannot_write_file_0_because_it_would_overwrite_input_file, emitFileName);
                blockEmittingOfFile(emitFileName, ts2.createCompilerDiagnosticFromMessageChain(chain));
              }
              var emitFileKey = !host.useCaseSensitiveFileNames() ? ts2.toFileNameLowerCase(emitFilePath) : emitFilePath;
              if (emitFilesSeen.has(emitFileKey)) {
                blockEmittingOfFile(emitFileName, ts2.createCompilerDiagnostic(ts2.Diagnostics.Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files, emitFileName));
              } else {
                emitFilesSeen.set(emitFileKey, true);
              }
            }
          }
        }
        function createFileDiagnosticAtReference(refPathToReportErrorOn, message) {
          var _a2, _b2;
          var args = [];
          for (var _i2 = 2; _i2 < arguments.length; _i2++) {
            args[_i2 - 2] = arguments[_i2];
          }
          var refFile = ts2.Debug.checkDefined(getSourceFileByPath(refPathToReportErrorOn.file));
          var kind = refPathToReportErrorOn.kind, index = refPathToReportErrorOn.index;
          var pos, end;
          switch (kind) {
            case ts2.RefFileKind.Import:
              pos = ts2.skipTrivia(refFile.text, refFile.imports[index].pos);
              end = refFile.imports[index].end;
              break;
            case ts2.RefFileKind.ReferenceFile:
              _a2 = refFile.referencedFiles[index], pos = _a2.pos, end = _a2.end;
              break;
            case ts2.RefFileKind.TypeReferenceDirective:
              _b2 = refFile.typeReferenceDirectives[index], pos = _b2.pos, end = _b2.end;
              break;
            default:
              return ts2.Debug.assertNever(kind);
          }
          return ts2.createFileDiagnostic.apply(void 0, __spreadArrays([refFile, pos, end - pos, message], args));
        }
        function addProgramDiagnosticAtRefPath(file, rootPaths, message) {
          var args = [];
          for (var _i2 = 3; _i2 < arguments.length; _i2++) {
            args[_i2 - 3] = arguments[_i2];
          }
          var refPaths = refFileMap && refFileMap.get(file.path);
          var refPathToReportErrorOn = ts2.forEach(refPaths, function(refPath) {
            return rootPaths.has(refPath.file) ? refPath : void 0;
          }) || ts2.elementAt(refPaths, 0);
          programDiagnostics.add(refPathToReportErrorOn ? createFileDiagnosticAtReference.apply(void 0, __spreadArrays([refPathToReportErrorOn, message], args)) : ts2.createCompilerDiagnostic.apply(void 0, __spreadArrays([message], args)));
        }
        function verifyProjectReferences() {
          var buildInfoPath = !options.noEmit && !options.suppressOutputPathCheck ? ts2.getTsBuildInfoEmitOutputFilePath(options) : void 0;
          forEachProjectReference(projectReferences, resolvedProjectReferences, function(resolvedRef, index, parent) {
            var ref = (parent ? parent.commandLine.projectReferences : projectReferences)[index];
            var parentFile = parent && parent.sourceFile;
            if (!resolvedRef) {
              createDiagnosticForReference(parentFile, index, ts2.Diagnostics.File_0_not_found, ref.path);
              return;
            }
            var options2 = resolvedRef.commandLine.options;
            if (!options2.composite) {
              var inputs = parent ? parent.commandLine.fileNames : rootNames;
              if (inputs.length) {
                createDiagnosticForReference(parentFile, index, ts2.Diagnostics.Referenced_project_0_must_have_setting_composite_Colon_true, ref.path);
              }
            }
            if (ref.prepend) {
              var out2 = options2.outFile || options2.out;
              if (out2) {
                if (!host.fileExists(out2)) {
                  createDiagnosticForReference(parentFile, index, ts2.Diagnostics.Output_file_0_from_project_1_does_not_exist, out2, ref.path);
                }
              } else {
                createDiagnosticForReference(parentFile, index, ts2.Diagnostics.Cannot_prepend_project_0_because_it_does_not_have_outFile_set, ref.path);
              }
            }
            if (!parent && buildInfoPath && buildInfoPath === ts2.getTsBuildInfoEmitOutputFilePath(options2)) {
              createDiagnosticForReference(parentFile, index, ts2.Diagnostics.Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1, buildInfoPath, ref.path);
              hasEmitBlockingDiagnostics.set(toPath(buildInfoPath), true);
            }
          });
        }
        function createDiagnosticForOptionPathKeyValue(key, valueIndex, message, arg0, arg1, arg2) {
          var needCompilerDiagnostic = true;
          var pathsSyntax = getOptionPathsSyntax();
          for (var _i2 = 0, pathsSyntax_1 = pathsSyntax; _i2 < pathsSyntax_1.length; _i2++) {
            var pathProp = pathsSyntax_1[_i2];
            if (ts2.isObjectLiteralExpression(pathProp.initializer)) {
              for (var _a2 = 0, _b2 = ts2.getPropertyAssignment(pathProp.initializer, key); _a2 < _b2.length; _a2++) {
                var keyProps = _b2[_a2];
                var initializer = keyProps.initializer;
                if (ts2.isArrayLiteralExpression(initializer) && initializer.elements.length > valueIndex) {
                  programDiagnostics.add(ts2.createDiagnosticForNodeInSourceFile(options.configFile, initializer.elements[valueIndex], message, arg0, arg1, arg2));
                  needCompilerDiagnostic = false;
                }
              }
            }
          }
          if (needCompilerDiagnostic) {
            programDiagnostics.add(ts2.createCompilerDiagnostic(message, arg0, arg1, arg2));
          }
        }
        function createDiagnosticForOptionPaths(onKey, key, message, arg0) {
          var needCompilerDiagnostic = true;
          var pathsSyntax = getOptionPathsSyntax();
          for (var _i2 = 0, pathsSyntax_2 = pathsSyntax; _i2 < pathsSyntax_2.length; _i2++) {
            var pathProp = pathsSyntax_2[_i2];
            if (ts2.isObjectLiteralExpression(pathProp.initializer) && createOptionDiagnosticInObjectLiteralSyntax(pathProp.initializer, onKey, key, void 0, message, arg0)) {
              needCompilerDiagnostic = false;
            }
          }
          if (needCompilerDiagnostic) {
            programDiagnostics.add(ts2.createCompilerDiagnostic(message, arg0));
          }
        }
        function getOptionsSyntaxByName(name) {
          var compilerOptionsObjectLiteralSyntax = getCompilerOptionsObjectLiteralSyntax();
          if (compilerOptionsObjectLiteralSyntax) {
            return ts2.getPropertyAssignment(compilerOptionsObjectLiteralSyntax, name);
          }
          return void 0;
        }
        function getOptionPathsSyntax() {
          return getOptionsSyntaxByName("paths") || ts2.emptyArray;
        }
        function createDiagnosticForOptionName(message, option1, option2, option3) {
          createDiagnosticForOption(true, option1, option2, message, option1, option2, option3);
        }
        function createOptionValueDiagnostic(option1, message, arg0) {
          createDiagnosticForOption(false, option1, void 0, message, arg0);
        }
        function createDiagnosticForReference(sourceFile, index, message, arg0, arg1) {
          var referencesSyntax = ts2.firstDefined(ts2.getTsConfigPropArray(sourceFile || options.configFile, "references"), function(property) {
            return ts2.isArrayLiteralExpression(property.initializer) ? property.initializer : void 0;
          });
          if (referencesSyntax && referencesSyntax.elements.length > index) {
            programDiagnostics.add(ts2.createDiagnosticForNodeInSourceFile(sourceFile || options.configFile, referencesSyntax.elements[index], message, arg0, arg1));
          } else {
            programDiagnostics.add(ts2.createCompilerDiagnostic(message, arg0, arg1));
          }
        }
        function createDiagnosticForOption(onKey, option1, option2, message, arg0, arg1, arg2) {
          var compilerOptionsObjectLiteralSyntax = getCompilerOptionsObjectLiteralSyntax();
          var needCompilerDiagnostic = !compilerOptionsObjectLiteralSyntax || !createOptionDiagnosticInObjectLiteralSyntax(compilerOptionsObjectLiteralSyntax, onKey, option1, option2, message, arg0, arg1, arg2);
          if (needCompilerDiagnostic) {
            programDiagnostics.add(ts2.createCompilerDiagnostic(message, arg0, arg1, arg2));
          }
        }
        function getCompilerOptionsObjectLiteralSyntax() {
          if (_compilerOptionsObjectLiteralSyntax === void 0) {
            _compilerOptionsObjectLiteralSyntax = null;
            var jsonObjectLiteral = ts2.getTsConfigObjectLiteralExpression(options.configFile);
            if (jsonObjectLiteral) {
              for (var _i2 = 0, _a2 = ts2.getPropertyAssignment(jsonObjectLiteral, "compilerOptions"); _i2 < _a2.length; _i2++) {
                var prop = _a2[_i2];
                if (ts2.isObjectLiteralExpression(prop.initializer)) {
                  _compilerOptionsObjectLiteralSyntax = prop.initializer;
                  break;
                }
              }
            }
          }
          return _compilerOptionsObjectLiteralSyntax;
        }
        function createOptionDiagnosticInObjectLiteralSyntax(objectLiteral, onKey, key1, key2, message, arg0, arg1, arg2) {
          var props = ts2.getPropertyAssignment(objectLiteral, key1, key2);
          for (var _i2 = 0, props_3 = props; _i2 < props_3.length; _i2++) {
            var prop = props_3[_i2];
            programDiagnostics.add(ts2.createDiagnosticForNodeInSourceFile(options.configFile, onKey ? prop.name : prop.initializer, message, arg0, arg1, arg2));
          }
          return !!props.length;
        }
        function blockEmittingOfFile(emitFileName, diag) {
          hasEmitBlockingDiagnostics.set(toPath(emitFileName), true);
          programDiagnostics.add(diag);
        }
        function isEmittedFile(file) {
          if (options.noEmit) {
            return false;
          }
          var filePath = toPath(file);
          if (getSourceFileByPath(filePath)) {
            return false;
          }
          var out2 = options.outFile || options.out;
          if (out2) {
            return isSameFile(filePath, out2) || isSameFile(filePath, ts2.removeFileExtension(out2) + ".d.ts");
          }
          if (options.declarationDir && ts2.containsPath(options.declarationDir, filePath, currentDirectory, !host.useCaseSensitiveFileNames())) {
            return true;
          }
          if (options.outDir) {
            return ts2.containsPath(options.outDir, filePath, currentDirectory, !host.useCaseSensitiveFileNames());
          }
          if (ts2.fileExtensionIsOneOf(filePath, ts2.supportedJSExtensions) || ts2.fileExtensionIs(filePath, ".d.ts")) {
            var filePathWithoutExtension = ts2.removeFileExtension(filePath);
            return !!getSourceFileByPath(filePathWithoutExtension + ".ts") || !!getSourceFileByPath(filePathWithoutExtension + ".tsx");
          }
          return false;
        }
        function isSameFile(file1, file2) {
          return ts2.comparePaths(file1, file2, currentDirectory, !host.useCaseSensitiveFileNames()) === 0;
        }
        function getProbableSymlinks() {
          if (host.getSymlinks) {
            return host.getSymlinks();
          }
          return symlinks || (symlinks = ts2.discoverProbableSymlinks(files, getCanonicalFileName, host.getCurrentDirectory()));
        }
      }
      ts2.createProgram = createProgram;
      function updateHostForUseSourceOfProjectReferenceRedirect(host) {
        var mapOfDeclarationDirectories;
        var symlinkedDirectories;
        var symlinkedFiles;
        var originalFileExists = host.compilerHost.fileExists;
        var originalDirectoryExists = host.compilerHost.directoryExists;
        var originalGetDirectories = host.compilerHost.getDirectories;
        var originalRealpath = host.compilerHost.realpath;
        if (!host.useSourceOfProjectReferenceRedirect)
          return { onProgramCreateComplete: ts2.noop, fileExists };
        host.compilerHost.fileExists = fileExists;
        if (originalDirectoryExists) {
          host.compilerHost.directoryExists = function(path2) {
            if (originalDirectoryExists.call(host.compilerHost, path2)) {
              handleDirectoryCouldBeSymlink(path2);
              return true;
            }
            if (!host.getResolvedProjectReferences())
              return false;
            if (!mapOfDeclarationDirectories) {
              mapOfDeclarationDirectories = ts2.createMap();
              host.forEachResolvedProjectReference(function(ref) {
                if (!ref)
                  return;
                var out = ref.commandLine.options.outFile || ref.commandLine.options.out;
                if (out) {
                  mapOfDeclarationDirectories.set(ts2.getDirectoryPath(host.toPath(out)), true);
                } else {
                  var declarationDir = ref.commandLine.options.declarationDir || ref.commandLine.options.outDir;
                  if (declarationDir) {
                    mapOfDeclarationDirectories.set(host.toPath(declarationDir), true);
                  }
                }
              });
            }
            return fileOrDirectoryExistsUsingSource(path2, false);
          };
        }
        if (originalGetDirectories) {
          host.compilerHost.getDirectories = function(path2) {
            return !host.getResolvedProjectReferences() || originalDirectoryExists && originalDirectoryExists.call(host.compilerHost, path2) ? originalGetDirectories.call(host.compilerHost, path2) : [];
          };
        }
        if (originalRealpath) {
          host.compilerHost.realpath = function(s) {
            return (symlinkedFiles === null || symlinkedFiles === void 0 ? void 0 : symlinkedFiles.get(host.toPath(s))) || originalRealpath.call(host.compilerHost, s);
          };
        }
        return { onProgramCreateComplete, fileExists };
        function onProgramCreateComplete() {
          host.compilerHost.fileExists = originalFileExists;
          host.compilerHost.directoryExists = originalDirectoryExists;
          host.compilerHost.getDirectories = originalGetDirectories;
        }
        function fileExists(file) {
          if (originalFileExists.call(host.compilerHost, file))
            return true;
          if (!host.getResolvedProjectReferences())
            return false;
          if (!ts2.isDeclarationFileName(file))
            return false;
          return fileOrDirectoryExistsUsingSource(file, true);
        }
        function fileExistsIfProjectReferenceDts(file) {
          var source = host.getSourceOfProjectReferenceRedirect(file);
          return source !== void 0 ? ts2.isString(source) ? originalFileExists.call(host.compilerHost, source) : true : void 0;
        }
        function directoryExistsIfProjectReferenceDeclDir(dir) {
          var dirPath = host.toPath(dir);
          var dirPathWithTrailingDirectorySeparator = "" + dirPath + ts2.directorySeparator;
          return ts2.forEachKey(mapOfDeclarationDirectories, function(declDirPath) {
            return dirPath === declDirPath || ts2.startsWith(declDirPath, dirPathWithTrailingDirectorySeparator) || ts2.startsWith(dirPath, declDirPath + "/");
          });
        }
        function handleDirectoryCouldBeSymlink(directory) {
          if (!host.getResolvedProjectReferences())
            return;
          if (!originalRealpath || !ts2.stringContains(directory, ts2.nodeModulesPathPart))
            return;
          if (!symlinkedDirectories)
            symlinkedDirectories = ts2.createMap();
          var directoryPath = ts2.ensureTrailingDirectorySeparator(host.toPath(directory));
          if (symlinkedDirectories.has(directoryPath))
            return;
          var real = ts2.normalizePath(originalRealpath.call(host.compilerHost, directory));
          var realPath;
          if (real === directory || (realPath = ts2.ensureTrailingDirectorySeparator(host.toPath(real))) === directoryPath) {
            symlinkedDirectories.set(directoryPath, false);
            return;
          }
          symlinkedDirectories.set(directoryPath, {
            real: ts2.ensureTrailingDirectorySeparator(real),
            realPath
          });
        }
        function fileOrDirectoryExistsUsingSource(fileOrDirectory, isFile) {
          var fileOrDirectoryExistsUsingSource2 = isFile ? function(file) {
            return fileExistsIfProjectReferenceDts(file);
          } : function(dir) {
            return directoryExistsIfProjectReferenceDeclDir(dir);
          };
          var result = fileOrDirectoryExistsUsingSource2(fileOrDirectory);
          if (result !== void 0)
            return result;
          if (!symlinkedDirectories)
            return false;
          var fileOrDirectoryPath = host.toPath(fileOrDirectory);
          if (!ts2.stringContains(fileOrDirectoryPath, ts2.nodeModulesPathPart))
            return false;
          if (isFile && symlinkedFiles && symlinkedFiles.has(fileOrDirectoryPath))
            return true;
          return ts2.firstDefinedIterator(symlinkedDirectories.entries(), function(_a) {
            var directoryPath = _a[0], symlinkedDirectory = _a[1];
            if (!symlinkedDirectory || !ts2.startsWith(fileOrDirectoryPath, directoryPath))
              return void 0;
            var result2 = fileOrDirectoryExistsUsingSource2(fileOrDirectoryPath.replace(directoryPath, symlinkedDirectory.realPath));
            if (isFile && result2) {
              if (!symlinkedFiles)
                symlinkedFiles = ts2.createMap();
              var absolutePath = ts2.getNormalizedAbsolutePath(fileOrDirectory, host.compilerHost.getCurrentDirectory());
              symlinkedFiles.set(fileOrDirectoryPath, "" + symlinkedDirectory.real + absolutePath.replace(new RegExp(directoryPath, "i"), ""));
            }
            return result2;
          }) || false;
        }
      }
      function handleNoEmitOptions(program, sourceFile, cancellationToken) {
        var options = program.getCompilerOptions();
        if (options.noEmit) {
          return { diagnostics: ts2.emptyArray, sourceMaps: void 0, emittedFiles: void 0, emitSkipped: true };
        }
        if (!options.noEmitOnError)
          return void 0;
        var diagnostics = __spreadArrays(program.getOptionsDiagnostics(cancellationToken), program.getSyntacticDiagnostics(sourceFile, cancellationToken), program.getGlobalDiagnostics(cancellationToken), program.getSemanticDiagnostics(sourceFile, cancellationToken));
        if (diagnostics.length === 0 && ts2.getEmitDeclarations(program.getCompilerOptions())) {
          diagnostics = program.getDeclarationDiagnostics(void 0, cancellationToken);
        }
        return diagnostics.length > 0 ? { diagnostics, sourceMaps: void 0, emittedFiles: void 0, emitSkipped: true } : void 0;
      }
      ts2.handleNoEmitOptions = handleNoEmitOptions;
      function parseConfigHostFromCompilerHostLike(host, directoryStructureHost) {
        if (directoryStructureHost === void 0) {
          directoryStructureHost = host;
        }
        return {
          fileExists: function(f) {
            return directoryStructureHost.fileExists(f);
          },
          readDirectory: function(root, extensions, excludes, includes, depth) {
            ts2.Debug.assertIsDefined(directoryStructureHost.readDirectory, "'CompilerHost.readDirectory' must be implemented to correctly process 'projectReferences'");
            return directoryStructureHost.readDirectory(root, extensions, excludes, includes, depth);
          },
          readFile: function(f) {
            return directoryStructureHost.readFile(f);
          },
          useCaseSensitiveFileNames: host.useCaseSensitiveFileNames(),
          getCurrentDirectory: function() {
            return host.getCurrentDirectory();
          },
          onUnRecoverableConfigFileDiagnostic: host.onUnRecoverableConfigFileDiagnostic || ts2.returnUndefined,
          trace: host.trace ? function(s) {
            return host.trace(s);
          } : void 0
        };
      }
      ts2.parseConfigHostFromCompilerHostLike = parseConfigHostFromCompilerHostLike;
      function createPrependNodes(projectReferences, getCommandLine, readFile) {
        if (!projectReferences)
          return ts2.emptyArray;
        var nodes;
        for (var i = 0; i < projectReferences.length; i++) {
          var ref = projectReferences[i];
          var resolvedRefOpts = getCommandLine(ref, i);
          if (ref.prepend && resolvedRefOpts && resolvedRefOpts.options) {
            var out = resolvedRefOpts.options.outFile || resolvedRefOpts.options.out;
            if (!out)
              continue;
            var _a = ts2.getOutputPathsForBundle(resolvedRefOpts.options, true), jsFilePath = _a.jsFilePath, sourceMapFilePath = _a.sourceMapFilePath, declarationFilePath = _a.declarationFilePath, declarationMapPath = _a.declarationMapPath, buildInfoPath = _a.buildInfoPath;
            var node = ts2.createInputFiles(readFile, jsFilePath, sourceMapFilePath, declarationFilePath, declarationMapPath, buildInfoPath);
            (nodes || (nodes = [])).push(node);
          }
        }
        return nodes || ts2.emptyArray;
      }
      ts2.createPrependNodes = createPrependNodes;
      function resolveProjectReferencePath(hostOrRef, ref) {
        var passedInRef = ref ? ref : hostOrRef;
        return ts2.resolveConfigFileProjectName(passedInRef.path);
      }
      ts2.resolveProjectReferencePath = resolveProjectReferencePath;
      function getResolutionDiagnostic(options, _a) {
        var extension = _a.extension;
        switch (extension) {
          case ".ts":
          case ".d.ts":
            return void 0;
          case ".tsx":
            return needJsx();
          case ".jsx":
            return needJsx() || needAllowJs();
          case ".js":
            return needAllowJs();
          case ".json":
            return needResolveJsonModule();
        }
        function needJsx() {
          return options.jsx ? void 0 : ts2.Diagnostics.Module_0_was_resolved_to_1_but_jsx_is_not_set;
        }
        function needAllowJs() {
          return options.allowJs || !ts2.getStrictOptionValue(options, "noImplicitAny") ? void 0 : ts2.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type;
        }
        function needResolveJsonModule() {
          return options.resolveJsonModule ? void 0 : ts2.Diagnostics.Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used;
        }
      }
      ts2.getResolutionDiagnostic = getResolutionDiagnostic;
      function getModuleNames(_a) {
        var imports = _a.imports, moduleAugmentations = _a.moduleAugmentations;
        var res = imports.map(function(i) {
          return i.text;
        });
        for (var _i = 0, moduleAugmentations_1 = moduleAugmentations; _i < moduleAugmentations_1.length; _i++) {
          var aug = moduleAugmentations_1[_i];
          if (aug.kind === 10) {
            res.push(aug.text);
          }
        }
        return res;
      }
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function getFileEmitOutput(program, sourceFile, emitOnlyDtsFiles, cancellationToken, customTransformers, forceDtsEmit) {
        var outputFiles = [];
        var _a = program.emit(sourceFile, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers, forceDtsEmit), emitSkipped = _a.emitSkipped, diagnostics = _a.diagnostics, exportedModulesFromDeclarationEmit = _a.exportedModulesFromDeclarationEmit;
        return { outputFiles, emitSkipped, diagnostics, exportedModulesFromDeclarationEmit };
        function writeFile(fileName, text, writeByteOrderMark) {
          outputFiles.push({ name: fileName, writeByteOrderMark, text });
        }
      }
      ts2.getFileEmitOutput = getFileEmitOutput;
      var BuilderState;
      (function(BuilderState2) {
        function getReferencedFileFromImportedModuleSymbol(symbol) {
          if (symbol.declarations && symbol.declarations[0]) {
            var declarationSourceFile = ts2.getSourceFileOfNode(symbol.declarations[0]);
            return declarationSourceFile && declarationSourceFile.resolvedPath;
          }
        }
        function getReferencedFileFromImportLiteral(checker, importName) {
          var symbol = checker.getSymbolAtLocation(importName);
          return symbol && getReferencedFileFromImportedModuleSymbol(symbol);
        }
        function getReferencedFileFromFileName(program, fileName, sourceFileDirectory, getCanonicalFileName) {
          return ts2.toPath(program.getProjectReferenceRedirect(fileName) || fileName, sourceFileDirectory, getCanonicalFileName);
        }
        function getReferencedFiles(program, sourceFile, getCanonicalFileName) {
          var referencedFiles;
          if (sourceFile.imports && sourceFile.imports.length > 0) {
            var checker = program.getTypeChecker();
            for (var _i = 0, _a = sourceFile.imports; _i < _a.length; _i++) {
              var importName = _a[_i];
              var declarationSourceFilePath = getReferencedFileFromImportLiteral(checker, importName);
              if (declarationSourceFilePath) {
                addReferencedFile(declarationSourceFilePath);
              }
            }
          }
          var sourceFileDirectory = ts2.getDirectoryPath(sourceFile.resolvedPath);
          if (sourceFile.referencedFiles && sourceFile.referencedFiles.length > 0) {
            for (var _b = 0, _c = sourceFile.referencedFiles; _b < _c.length; _b++) {
              var referencedFile = _c[_b];
              var referencedPath = getReferencedFileFromFileName(program, referencedFile.fileName, sourceFileDirectory, getCanonicalFileName);
              addReferencedFile(referencedPath);
            }
          }
          if (sourceFile.resolvedTypeReferenceDirectiveNames) {
            sourceFile.resolvedTypeReferenceDirectiveNames.forEach(function(resolvedTypeReferenceDirective) {
              if (!resolvedTypeReferenceDirective) {
                return;
              }
              var fileName = resolvedTypeReferenceDirective.resolvedFileName;
              var typeFilePath = getReferencedFileFromFileName(program, fileName, sourceFileDirectory, getCanonicalFileName);
              addReferencedFile(typeFilePath);
            });
          }
          if (sourceFile.moduleAugmentations.length) {
            var checker = program.getTypeChecker();
            for (var _d = 0, _e = sourceFile.moduleAugmentations; _d < _e.length; _d++) {
              var moduleName = _e[_d];
              if (!ts2.isStringLiteral(moduleName)) {
                continue;
              }
              var symbol = checker.getSymbolAtLocation(moduleName);
              if (!symbol) {
                continue;
              }
              addReferenceFromAmbientModule(symbol);
            }
          }
          for (var _f = 0, _g = program.getTypeChecker().getAmbientModules(); _f < _g.length; _f++) {
            var ambientModule = _g[_f];
            if (ambientModule.declarations.length > 1) {
              addReferenceFromAmbientModule(ambientModule);
            }
          }
          return referencedFiles;
          function addReferenceFromAmbientModule(symbol2) {
            for (var _i2 = 0, _a2 = symbol2.declarations; _i2 < _a2.length; _i2++) {
              var declaration = _a2[_i2];
              var declarationSourceFile = ts2.getSourceFileOfNode(declaration);
              if (declarationSourceFile && declarationSourceFile !== sourceFile) {
                addReferencedFile(declarationSourceFile.resolvedPath);
              }
            }
          }
          function addReferencedFile(referencedPath2) {
            if (!referencedFiles) {
              referencedFiles = ts2.createMap();
            }
            referencedFiles.set(referencedPath2, true);
          }
        }
        function canReuseOldState(newReferencedMap, oldState) {
          return oldState && !oldState.referencedMap === !newReferencedMap;
        }
        BuilderState2.canReuseOldState = canReuseOldState;
        function create(newProgram, getCanonicalFileName, oldState) {
          var fileInfos = ts2.createMap();
          var referencedMap = newProgram.getCompilerOptions().module !== ts2.ModuleKind.None ? ts2.createMap() : void 0;
          var exportedModulesMap = referencedMap ? ts2.createMap() : void 0;
          var hasCalledUpdateShapeSignature = ts2.createMap();
          var useOldState = canReuseOldState(referencedMap, oldState);
          for (var _i = 0, _a = newProgram.getSourceFiles(); _i < _a.length; _i++) {
            var sourceFile = _a[_i];
            var version_1 = ts2.Debug.checkDefined(sourceFile.version, "Program intended to be used with Builder should have source files with versions set");
            var oldInfo = useOldState ? oldState.fileInfos.get(sourceFile.resolvedPath) : void 0;
            if (referencedMap) {
              var newReferences = getReferencedFiles(newProgram, sourceFile, getCanonicalFileName);
              if (newReferences) {
                referencedMap.set(sourceFile.resolvedPath, newReferences);
              }
              if (useOldState) {
                var exportedModules = oldState.exportedModulesMap.get(sourceFile.resolvedPath);
                if (exportedModules) {
                  exportedModulesMap.set(sourceFile.resolvedPath, exportedModules);
                }
              }
            }
            fileInfos.set(sourceFile.resolvedPath, { version: version_1, signature: oldInfo && oldInfo.signature, affectsGlobalScope: isFileAffectingGlobalScope(sourceFile) });
          }
          return {
            fileInfos,
            referencedMap,
            exportedModulesMap,
            hasCalledUpdateShapeSignature
          };
        }
        BuilderState2.create = create;
        function releaseCache(state) {
          state.allFilesExcludingDefaultLibraryFile = void 0;
          state.allFileNames = void 0;
        }
        BuilderState2.releaseCache = releaseCache;
        function clone(state) {
          var fileInfos = ts2.createMap();
          state.fileInfos.forEach(function(value, key) {
            fileInfos.set(key, __assign({}, value));
          });
          return {
            fileInfos,
            referencedMap: cloneMapOrUndefined(state.referencedMap),
            exportedModulesMap: cloneMapOrUndefined(state.exportedModulesMap),
            hasCalledUpdateShapeSignature: ts2.cloneMap(state.hasCalledUpdateShapeSignature)
          };
        }
        BuilderState2.clone = clone;
        function getFilesAffectedBy(state, programOfThisState, path2, cancellationToken, computeHash, cacheToUpdateSignature, exportedModulesMapCache) {
          var signatureCache = cacheToUpdateSignature || ts2.createMap();
          var sourceFile = programOfThisState.getSourceFileByPath(path2);
          if (!sourceFile) {
            return ts2.emptyArray;
          }
          if (!updateShapeSignature(state, programOfThisState, sourceFile, signatureCache, cancellationToken, computeHash, exportedModulesMapCache)) {
            return [sourceFile];
          }
          var result = (state.referencedMap ? getFilesAffectedByUpdatedShapeWhenModuleEmit : getFilesAffectedByUpdatedShapeWhenNonModuleEmit)(state, programOfThisState, sourceFile, signatureCache, cancellationToken, computeHash, exportedModulesMapCache);
          if (!cacheToUpdateSignature) {
            updateSignaturesFromCache(state, signatureCache);
          }
          return result;
        }
        BuilderState2.getFilesAffectedBy = getFilesAffectedBy;
        function updateSignaturesFromCache(state, signatureCache) {
          signatureCache.forEach(function(signature, path2) {
            return updateSignatureOfFile(state, signature, path2);
          });
        }
        BuilderState2.updateSignaturesFromCache = updateSignaturesFromCache;
        function updateSignatureOfFile(state, signature, path2) {
          state.fileInfos.get(path2).signature = signature;
          state.hasCalledUpdateShapeSignature.set(path2, true);
        }
        BuilderState2.updateSignatureOfFile = updateSignatureOfFile;
        function updateShapeSignature(state, programOfThisState, sourceFile, cacheToUpdateSignature, cancellationToken, computeHash, exportedModulesMapCache) {
          ts2.Debug.assert(!!sourceFile);
          ts2.Debug.assert(!exportedModulesMapCache || !!state.exportedModulesMap, "Compute visible to outside map only if visibleToOutsideReferencedMap present in the state");
          if (state.hasCalledUpdateShapeSignature.has(sourceFile.resolvedPath) || cacheToUpdateSignature.has(sourceFile.resolvedPath)) {
            return false;
          }
          var info = state.fileInfos.get(sourceFile.resolvedPath);
          if (!info)
            return ts2.Debug.fail();
          var prevSignature = info.signature;
          var latestSignature;
          if (sourceFile.isDeclarationFile) {
            latestSignature = sourceFile.version;
            if (exportedModulesMapCache && latestSignature !== prevSignature) {
              var references = state.referencedMap ? state.referencedMap.get(sourceFile.resolvedPath) : void 0;
              exportedModulesMapCache.set(sourceFile.resolvedPath, references || false);
            }
          } else {
            var emitOutput_1 = getFileEmitOutput(programOfThisState, sourceFile, true, cancellationToken, void 0, true);
            var firstDts_1 = emitOutput_1.outputFiles && programOfThisState.getCompilerOptions().declarationMap ? emitOutput_1.outputFiles.length > 1 ? emitOutput_1.outputFiles[1] : void 0 : emitOutput_1.outputFiles.length > 0 ? emitOutput_1.outputFiles[0] : void 0;
            if (firstDts_1) {
              ts2.Debug.assert(ts2.fileExtensionIs(firstDts_1.name, ".d.ts"), "File extension for signature expected to be dts", function() {
                return "Found: " + ts2.getAnyExtensionFromPath(firstDts_1.name) + " for " + firstDts_1.name + ":: All output files: " + JSON.stringify(emitOutput_1.outputFiles.map(function(f) {
                  return f.name;
                }));
              });
              latestSignature = computeHash(firstDts_1.text);
              if (exportedModulesMapCache && latestSignature !== prevSignature) {
                updateExportedModules(sourceFile, emitOutput_1.exportedModulesFromDeclarationEmit, exportedModulesMapCache);
              }
            } else {
              latestSignature = prevSignature;
            }
          }
          cacheToUpdateSignature.set(sourceFile.resolvedPath, latestSignature);
          return !prevSignature || latestSignature !== prevSignature;
        }
        BuilderState2.updateShapeSignature = updateShapeSignature;
        function updateExportedModules(sourceFile, exportedModulesFromDeclarationEmit, exportedModulesMapCache) {
          if (!exportedModulesFromDeclarationEmit) {
            exportedModulesMapCache.set(sourceFile.resolvedPath, false);
            return;
          }
          var exportedModules;
          exportedModulesFromDeclarationEmit.forEach(function(symbol) {
            return addExportedModule(getReferencedFileFromImportedModuleSymbol(symbol));
          });
          exportedModulesMapCache.set(sourceFile.resolvedPath, exportedModules || false);
          function addExportedModule(exportedModulePath) {
            if (exportedModulePath) {
              if (!exportedModules) {
                exportedModules = ts2.createMap();
              }
              exportedModules.set(exportedModulePath, true);
            }
          }
        }
        function updateExportedFilesMapFromCache(state, exportedModulesMapCache) {
          if (exportedModulesMapCache) {
            ts2.Debug.assert(!!state.exportedModulesMap);
            exportedModulesMapCache.forEach(function(exportedModules, path2) {
              if (exportedModules) {
                state.exportedModulesMap.set(path2, exportedModules);
              } else {
                state.exportedModulesMap.delete(path2);
              }
            });
          }
        }
        BuilderState2.updateExportedFilesMapFromCache = updateExportedFilesMapFromCache;
        function getAllDependencies(state, programOfThisState, sourceFile) {
          var compilerOptions = programOfThisState.getCompilerOptions();
          if (compilerOptions.outFile || compilerOptions.out) {
            return getAllFileNames(state, programOfThisState);
          }
          if (!state.referencedMap || isFileAffectingGlobalScope(sourceFile)) {
            return getAllFileNames(state, programOfThisState);
          }
          var seenMap = ts2.createMap();
          var queue = [sourceFile.resolvedPath];
          while (queue.length) {
            var path2 = queue.pop();
            if (!seenMap.has(path2)) {
              seenMap.set(path2, true);
              var references = state.referencedMap.get(path2);
              if (references) {
                var iterator = references.keys();
                for (var iterResult = iterator.next(); !iterResult.done; iterResult = iterator.next()) {
                  queue.push(iterResult.value);
                }
              }
            }
          }
          return ts2.arrayFrom(ts2.mapDefinedIterator(seenMap.keys(), function(path3) {
            var file = programOfThisState.getSourceFileByPath(path3);
            return file ? file.fileName : path3;
          }));
        }
        BuilderState2.getAllDependencies = getAllDependencies;
        function getAllFileNames(state, programOfThisState) {
          if (!state.allFileNames) {
            var sourceFiles = programOfThisState.getSourceFiles();
            state.allFileNames = sourceFiles === ts2.emptyArray ? ts2.emptyArray : sourceFiles.map(function(file) {
              return file.fileName;
            });
          }
          return state.allFileNames;
        }
        function getReferencedByPaths(state, referencedFilePath) {
          return ts2.arrayFrom(ts2.mapDefinedIterator(state.referencedMap.entries(), function(_a) {
            var filePath = _a[0], referencesInFile = _a[1];
            return referencesInFile.has(referencedFilePath) ? filePath : void 0;
          }));
        }
        BuilderState2.getReferencedByPaths = getReferencedByPaths;
        function containsOnlyAmbientModules(sourceFile) {
          for (var _i = 0, _a = sourceFile.statements; _i < _a.length; _i++) {
            var statement = _a[_i];
            if (!ts2.isModuleWithStringLiteralName(statement)) {
              return false;
            }
          }
          return true;
        }
        function containsGlobalScopeAugmentation(sourceFile) {
          return ts2.some(sourceFile.moduleAugmentations, function(augmentation) {
            return ts2.isGlobalScopeAugmentation(augmentation.parent);
          });
        }
        function isFileAffectingGlobalScope(sourceFile) {
          return containsGlobalScopeAugmentation(sourceFile) || !ts2.isExternalModule(sourceFile) && !containsOnlyAmbientModules(sourceFile);
        }
        function getAllFilesExcludingDefaultLibraryFile(state, programOfThisState, firstSourceFile) {
          if (state.allFilesExcludingDefaultLibraryFile) {
            return state.allFilesExcludingDefaultLibraryFile;
          }
          var result;
          if (firstSourceFile)
            addSourceFile(firstSourceFile);
          for (var _i = 0, _a = programOfThisState.getSourceFiles(); _i < _a.length; _i++) {
            var sourceFile = _a[_i];
            if (sourceFile !== firstSourceFile) {
              addSourceFile(sourceFile);
            }
          }
          state.allFilesExcludingDefaultLibraryFile = result || ts2.emptyArray;
          return state.allFilesExcludingDefaultLibraryFile;
          function addSourceFile(sourceFile2) {
            if (!programOfThisState.isSourceFileDefaultLibrary(sourceFile2)) {
              (result || (result = [])).push(sourceFile2);
            }
          }
        }
        BuilderState2.getAllFilesExcludingDefaultLibraryFile = getAllFilesExcludingDefaultLibraryFile;
        function getFilesAffectedByUpdatedShapeWhenNonModuleEmit(state, programOfThisState, sourceFileWithUpdatedShape) {
          var compilerOptions = programOfThisState.getCompilerOptions();
          if (compilerOptions && (compilerOptions.out || compilerOptions.outFile)) {
            return [sourceFileWithUpdatedShape];
          }
          return getAllFilesExcludingDefaultLibraryFile(state, programOfThisState, sourceFileWithUpdatedShape);
        }
        function getFilesAffectedByUpdatedShapeWhenModuleEmit(state, programOfThisState, sourceFileWithUpdatedShape, cacheToUpdateSignature, cancellationToken, computeHash, exportedModulesMapCache) {
          if (isFileAffectingGlobalScope(sourceFileWithUpdatedShape)) {
            return getAllFilesExcludingDefaultLibraryFile(state, programOfThisState, sourceFileWithUpdatedShape);
          }
          var compilerOptions = programOfThisState.getCompilerOptions();
          if (compilerOptions && (compilerOptions.isolatedModules || compilerOptions.out || compilerOptions.outFile)) {
            return [sourceFileWithUpdatedShape];
          }
          var seenFileNamesMap = ts2.createMap();
          seenFileNamesMap.set(sourceFileWithUpdatedShape.resolvedPath, sourceFileWithUpdatedShape);
          var queue = getReferencedByPaths(state, sourceFileWithUpdatedShape.resolvedPath);
          while (queue.length > 0) {
            var currentPath = queue.pop();
            if (!seenFileNamesMap.has(currentPath)) {
              var currentSourceFile = programOfThisState.getSourceFileByPath(currentPath);
              seenFileNamesMap.set(currentPath, currentSourceFile);
              if (currentSourceFile && updateShapeSignature(state, programOfThisState, currentSourceFile, cacheToUpdateSignature, cancellationToken, computeHash, exportedModulesMapCache)) {
                queue.push.apply(queue, getReferencedByPaths(state, currentSourceFile.resolvedPath));
              }
            }
          }
          return ts2.arrayFrom(ts2.mapDefinedIterator(seenFileNamesMap.values(), function(value) {
            return value;
          }));
        }
      })(BuilderState = ts2.BuilderState || (ts2.BuilderState = {}));
      function cloneMapOrUndefined(map) {
        return map ? ts2.cloneMap(map) : void 0;
      }
      ts2.cloneMapOrUndefined = cloneMapOrUndefined;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var BuilderFileEmit;
      (function(BuilderFileEmit2) {
        BuilderFileEmit2[BuilderFileEmit2["DtsOnly"] = 0] = "DtsOnly";
        BuilderFileEmit2[BuilderFileEmit2["Full"] = 1] = "Full";
      })(BuilderFileEmit = ts2.BuilderFileEmit || (ts2.BuilderFileEmit = {}));
      function hasSameKeys(map1, map2) {
        return map1 === map2 || map1 !== void 0 && map2 !== void 0 && map1.size === map2.size && !ts2.forEachKey(map1, function(key) {
          return !map2.has(key);
        });
      }
      function createBuilderProgramState(newProgram, getCanonicalFileName, oldState) {
        var state = ts2.BuilderState.create(newProgram, getCanonicalFileName, oldState);
        state.program = newProgram;
        var compilerOptions = newProgram.getCompilerOptions();
        state.compilerOptions = compilerOptions;
        if (!compilerOptions.outFile && !compilerOptions.out) {
          state.semanticDiagnosticsPerFile = ts2.createMap();
        }
        state.changedFilesSet = ts2.createMap();
        var useOldState = ts2.BuilderState.canReuseOldState(state.referencedMap, oldState);
        var oldCompilerOptions = useOldState ? oldState.compilerOptions : void 0;
        var canCopySemanticDiagnostics = useOldState && oldState.semanticDiagnosticsPerFile && !!state.semanticDiagnosticsPerFile && !ts2.compilerOptionsAffectSemanticDiagnostics(compilerOptions, oldCompilerOptions);
        if (useOldState) {
          if (!oldState.currentChangedFilePath) {
            var affectedSignatures = oldState.currentAffectedFilesSignatures;
            ts2.Debug.assert(!oldState.affectedFiles && (!affectedSignatures || !affectedSignatures.size), "Cannot reuse if only few affected files of currentChangedFile were iterated");
          }
          var changedFilesSet = oldState.changedFilesSet;
          if (canCopySemanticDiagnostics) {
            ts2.Debug.assert(!changedFilesSet || !ts2.forEachKey(changedFilesSet, function(path2) {
              return oldState.semanticDiagnosticsPerFile.has(path2);
            }), "Semantic diagnostics shouldnt be available for changed files");
          }
          if (changedFilesSet) {
            ts2.copyEntries(changedFilesSet, state.changedFilesSet);
          }
          if (!compilerOptions.outFile && !compilerOptions.out && oldState.affectedFilesPendingEmit) {
            state.affectedFilesPendingEmit = oldState.affectedFilesPendingEmit.slice();
            state.affectedFilesPendingEmitKind = ts2.cloneMapOrUndefined(oldState.affectedFilesPendingEmitKind);
            state.affectedFilesPendingEmitIndex = oldState.affectedFilesPendingEmitIndex;
            state.seenAffectedFiles = ts2.createMap();
          }
        }
        var referencedMap = state.referencedMap;
        var oldReferencedMap = useOldState ? oldState.referencedMap : void 0;
        var copyDeclarationFileDiagnostics = canCopySemanticDiagnostics && !compilerOptions.skipLibCheck === !oldCompilerOptions.skipLibCheck;
        var copyLibFileDiagnostics = copyDeclarationFileDiagnostics && !compilerOptions.skipDefaultLibCheck === !oldCompilerOptions.skipDefaultLibCheck;
        state.fileInfos.forEach(function(info, sourceFilePath) {
          var oldInfo;
          var newReferences;
          if (!useOldState || !(oldInfo = oldState.fileInfos.get(sourceFilePath)) || oldInfo.version !== info.version || !hasSameKeys(newReferences = referencedMap && referencedMap.get(sourceFilePath), oldReferencedMap && oldReferencedMap.get(sourceFilePath)) || newReferences && ts2.forEachKey(newReferences, function(path2) {
            return !state.fileInfos.has(path2) && oldState.fileInfos.has(path2);
          })) {
            state.changedFilesSet.set(sourceFilePath, true);
          } else if (canCopySemanticDiagnostics) {
            var sourceFile = newProgram.getSourceFileByPath(sourceFilePath);
            if (sourceFile.isDeclarationFile && !copyDeclarationFileDiagnostics) {
              return;
            }
            if (sourceFile.hasNoDefaultLib && !copyLibFileDiagnostics) {
              return;
            }
            var diagnostics = oldState.semanticDiagnosticsPerFile.get(sourceFilePath);
            if (diagnostics) {
              state.semanticDiagnosticsPerFile.set(sourceFilePath, oldState.hasReusableDiagnostic ? convertToDiagnostics(diagnostics, newProgram, getCanonicalFileName) : diagnostics);
              if (!state.semanticDiagnosticsFromOldState) {
                state.semanticDiagnosticsFromOldState = ts2.createMap();
              }
              state.semanticDiagnosticsFromOldState.set(sourceFilePath, true);
            }
          }
        });
        if (useOldState && ts2.forEachEntry(oldState.fileInfos, function(info, sourceFilePath) {
          return info.affectsGlobalScope && !state.fileInfos.has(sourceFilePath);
        })) {
          ts2.BuilderState.getAllFilesExcludingDefaultLibraryFile(state, newProgram, void 0).forEach(function(file) {
            return state.changedFilesSet.set(file.resolvedPath, true);
          });
        } else if (oldCompilerOptions && ts2.compilerOptionsAffectEmit(compilerOptions, oldCompilerOptions)) {
          newProgram.getSourceFiles().forEach(function(f) {
            return addToAffectedFilesPendingEmit(state, f.resolvedPath, 1);
          });
          ts2.Debug.assert(!state.seenAffectedFiles || !state.seenAffectedFiles.size);
          state.seenAffectedFiles = state.seenAffectedFiles || ts2.createMap();
        }
        state.emittedBuildInfo = !state.changedFilesSet.size && !state.affectedFilesPendingEmit;
        return state;
      }
      function convertToDiagnostics(diagnostics, newProgram, getCanonicalFileName) {
        if (!diagnostics.length)
          return ts2.emptyArray;
        var buildInfoDirectory = ts2.getDirectoryPath(ts2.getNormalizedAbsolutePath(ts2.getTsBuildInfoEmitOutputFilePath(newProgram.getCompilerOptions()), newProgram.getCurrentDirectory()));
        return diagnostics.map(function(diagnostic) {
          var result = convertToDiagnosticRelatedInformation(diagnostic, newProgram, toPath);
          result.reportsUnnecessary = diagnostic.reportsUnnecessary;
          result.source = diagnostic.source;
          var relatedInformation = diagnostic.relatedInformation;
          result.relatedInformation = relatedInformation ? relatedInformation.length ? relatedInformation.map(function(r) {
            return convertToDiagnosticRelatedInformation(r, newProgram, toPath);
          }) : ts2.emptyArray : void 0;
          return result;
        });
        function toPath(path2) {
          return ts2.toPath(path2, buildInfoDirectory, getCanonicalFileName);
        }
      }
      function convertToDiagnosticRelatedInformation(diagnostic, newProgram, toPath) {
        var file = diagnostic.file;
        return __assign(__assign({}, diagnostic), { file: file ? newProgram.getSourceFileByPath(toPath(file)) : void 0 });
      }
      function releaseCache(state) {
        ts2.BuilderState.releaseCache(state);
        state.program = void 0;
      }
      function cloneBuilderProgramState(state) {
        var newState = ts2.BuilderState.clone(state);
        newState.semanticDiagnosticsPerFile = ts2.cloneMapOrUndefined(state.semanticDiagnosticsPerFile);
        newState.changedFilesSet = ts2.cloneMap(state.changedFilesSet);
        newState.affectedFiles = state.affectedFiles;
        newState.affectedFilesIndex = state.affectedFilesIndex;
        newState.currentChangedFilePath = state.currentChangedFilePath;
        newState.currentAffectedFilesSignatures = ts2.cloneMapOrUndefined(state.currentAffectedFilesSignatures);
        newState.currentAffectedFilesExportedModulesMap = ts2.cloneMapOrUndefined(state.currentAffectedFilesExportedModulesMap);
        newState.seenAffectedFiles = ts2.cloneMapOrUndefined(state.seenAffectedFiles);
        newState.cleanedDiagnosticsOfLibFiles = state.cleanedDiagnosticsOfLibFiles;
        newState.semanticDiagnosticsFromOldState = ts2.cloneMapOrUndefined(state.semanticDiagnosticsFromOldState);
        newState.program = state.program;
        newState.compilerOptions = state.compilerOptions;
        newState.affectedFilesPendingEmit = state.affectedFilesPendingEmit && state.affectedFilesPendingEmit.slice();
        newState.affectedFilesPendingEmitKind = ts2.cloneMapOrUndefined(state.affectedFilesPendingEmitKind);
        newState.affectedFilesPendingEmitIndex = state.affectedFilesPendingEmitIndex;
        newState.seenEmittedFiles = ts2.cloneMapOrUndefined(state.seenEmittedFiles);
        newState.programEmitComplete = state.programEmitComplete;
        return newState;
      }
      function assertSourceFileOkWithoutNextAffectedCall(state, sourceFile) {
        ts2.Debug.assert(!sourceFile || !state.affectedFiles || state.affectedFiles[state.affectedFilesIndex - 1] !== sourceFile || !state.semanticDiagnosticsPerFile.has(sourceFile.resolvedPath));
      }
      function getNextAffectedFile(state, cancellationToken, computeHash) {
        while (true) {
          var affectedFiles = state.affectedFiles;
          if (affectedFiles) {
            var seenAffectedFiles = state.seenAffectedFiles;
            var affectedFilesIndex = state.affectedFilesIndex;
            while (affectedFilesIndex < affectedFiles.length) {
              var affectedFile = affectedFiles[affectedFilesIndex];
              if (!seenAffectedFiles.has(affectedFile.resolvedPath)) {
                state.affectedFilesIndex = affectedFilesIndex;
                handleDtsMayChangeOfAffectedFile(state, affectedFile, cancellationToken, computeHash);
                return affectedFile;
              }
              affectedFilesIndex++;
            }
            state.changedFilesSet.delete(state.currentChangedFilePath);
            state.currentChangedFilePath = void 0;
            ts2.BuilderState.updateSignaturesFromCache(state, state.currentAffectedFilesSignatures);
            state.currentAffectedFilesSignatures.clear();
            ts2.BuilderState.updateExportedFilesMapFromCache(state, state.currentAffectedFilesExportedModulesMap);
            state.affectedFiles = void 0;
          }
          var nextKey = state.changedFilesSet.keys().next();
          if (nextKey.done) {
            return void 0;
          }
          var program = ts2.Debug.checkDefined(state.program);
          var compilerOptions = program.getCompilerOptions();
          if (compilerOptions.outFile || compilerOptions.out) {
            ts2.Debug.assert(!state.semanticDiagnosticsPerFile);
            return program;
          }
          state.currentAffectedFilesSignatures = state.currentAffectedFilesSignatures || ts2.createMap();
          if (state.exportedModulesMap) {
            state.currentAffectedFilesExportedModulesMap = state.currentAffectedFilesExportedModulesMap || ts2.createMap();
          }
          state.affectedFiles = ts2.BuilderState.getFilesAffectedBy(state, program, nextKey.value, cancellationToken, computeHash, state.currentAffectedFilesSignatures, state.currentAffectedFilesExportedModulesMap);
          state.currentChangedFilePath = nextKey.value;
          state.affectedFilesIndex = 0;
          state.seenAffectedFiles = state.seenAffectedFiles || ts2.createMap();
        }
      }
      function getNextAffectedFilePendingEmit(state) {
        var affectedFilesPendingEmit = state.affectedFilesPendingEmit;
        if (affectedFilesPendingEmit) {
          var seenEmittedFiles = state.seenEmittedFiles || (state.seenEmittedFiles = ts2.createMap());
          for (var i = state.affectedFilesPendingEmitIndex; i < affectedFilesPendingEmit.length; i++) {
            var affectedFile = ts2.Debug.checkDefined(state.program).getSourceFileByPath(affectedFilesPendingEmit[i]);
            if (affectedFile) {
              var seenKind = seenEmittedFiles.get(affectedFile.resolvedPath);
              var emitKind = ts2.Debug.checkDefined(ts2.Debug.checkDefined(state.affectedFilesPendingEmitKind).get(affectedFile.resolvedPath));
              if (seenKind === void 0 || seenKind < emitKind) {
                state.affectedFilesPendingEmitIndex = i;
                return { affectedFile, emitKind };
              }
            }
          }
          state.affectedFilesPendingEmit = void 0;
          state.affectedFilesPendingEmitKind = void 0;
          state.affectedFilesPendingEmitIndex = void 0;
        }
        return void 0;
      }
      function handleDtsMayChangeOfAffectedFile(state, affectedFile, cancellationToken, computeHash) {
        removeSemanticDiagnosticsOf(state, affectedFile.resolvedPath);
        if (state.allFilesExcludingDefaultLibraryFile === state.affectedFiles) {
          if (!state.cleanedDiagnosticsOfLibFiles) {
            state.cleanedDiagnosticsOfLibFiles = true;
            var program_1 = ts2.Debug.checkDefined(state.program);
            var options_2 = program_1.getCompilerOptions();
            ts2.forEach(program_1.getSourceFiles(), function(f) {
              return program_1.isSourceFileDefaultLibrary(f) && !ts2.skipTypeChecking(f, options_2, program_1) && removeSemanticDiagnosticsOf(state, f.resolvedPath);
            });
          }
          return;
        }
        if (!state.compilerOptions.assumeChangesOnlyAffectDirectDependencies) {
          forEachReferencingModulesOfExportOfAffectedFile(state, affectedFile, function(state2, path2) {
            return handleDtsMayChangeOf(state2, path2, cancellationToken, computeHash);
          });
        }
      }
      function handleDtsMayChangeOf(state, path2, cancellationToken, computeHash) {
        removeSemanticDiagnosticsOf(state, path2);
        if (!state.changedFilesSet.has(path2)) {
          var program = ts2.Debug.checkDefined(state.program);
          var sourceFile = program.getSourceFileByPath(path2);
          if (sourceFile) {
            ts2.BuilderState.updateShapeSignature(state, program, sourceFile, ts2.Debug.checkDefined(state.currentAffectedFilesSignatures), cancellationToken, computeHash, state.currentAffectedFilesExportedModulesMap);
            if (ts2.getEmitDeclarations(state.compilerOptions)) {
              addToAffectedFilesPendingEmit(state, path2, 0);
            }
          }
        }
        return false;
      }
      function removeSemanticDiagnosticsOf(state, path2) {
        if (!state.semanticDiagnosticsFromOldState) {
          return true;
        }
        state.semanticDiagnosticsFromOldState.delete(path2);
        state.semanticDiagnosticsPerFile.delete(path2);
        return !state.semanticDiagnosticsFromOldState.size;
      }
      function isChangedSignagure(state, path2) {
        var newSignature = ts2.Debug.checkDefined(state.currentAffectedFilesSignatures).get(path2);
        var oldSignagure = ts2.Debug.checkDefined(state.fileInfos.get(path2)).signature;
        return newSignature !== oldSignagure;
      }
      function forEachReferencingModulesOfExportOfAffectedFile(state, affectedFile, fn) {
        if (!state.exportedModulesMap || !state.changedFilesSet.has(affectedFile.resolvedPath)) {
          return;
        }
        if (!isChangedSignagure(state, affectedFile.resolvedPath))
          return;
        if (state.compilerOptions.isolatedModules) {
          var seenFileNamesMap = ts2.createMap();
          seenFileNamesMap.set(affectedFile.resolvedPath, true);
          var queue = ts2.BuilderState.getReferencedByPaths(state, affectedFile.resolvedPath);
          while (queue.length > 0) {
            var currentPath = queue.pop();
            if (!seenFileNamesMap.has(currentPath)) {
              seenFileNamesMap.set(currentPath, true);
              var result = fn(state, currentPath);
              if (result && isChangedSignagure(state, currentPath)) {
                var currentSourceFile = ts2.Debug.checkDefined(state.program).getSourceFileByPath(currentPath);
                queue.push.apply(queue, ts2.BuilderState.getReferencedByPaths(state, currentSourceFile.resolvedPath));
              }
            }
          }
        }
        ts2.Debug.assert(!!state.currentAffectedFilesExportedModulesMap);
        var seenFileAndExportsOfFile = ts2.createMap();
        if (ts2.forEachEntry(state.currentAffectedFilesExportedModulesMap, function(exportedModules, exportedFromPath) {
          return exportedModules && exportedModules.has(affectedFile.resolvedPath) && forEachFilesReferencingPath(state, exportedFromPath, seenFileAndExportsOfFile, fn);
        })) {
          return;
        }
        ts2.forEachEntry(state.exportedModulesMap, function(exportedModules, exportedFromPath) {
          return !state.currentAffectedFilesExportedModulesMap.has(exportedFromPath) && exportedModules.has(affectedFile.resolvedPath) && forEachFilesReferencingPath(state, exportedFromPath, seenFileAndExportsOfFile, fn);
        });
      }
      function forEachFilesReferencingPath(state, referencedPath, seenFileAndExportsOfFile, fn) {
        return ts2.forEachEntry(state.referencedMap, function(referencesInFile, filePath) {
          return referencesInFile.has(referencedPath) && forEachFileAndExportsOfFile(state, filePath, seenFileAndExportsOfFile, fn);
        });
      }
      function forEachFileAndExportsOfFile(state, filePath, seenFileAndExportsOfFile, fn) {
        if (!ts2.addToSeen(seenFileAndExportsOfFile, filePath)) {
          return false;
        }
        if (fn(state, filePath)) {
          return true;
        }
        ts2.Debug.assert(!!state.currentAffectedFilesExportedModulesMap);
        if (ts2.forEachEntry(state.currentAffectedFilesExportedModulesMap, function(exportedModules, exportedFromPath) {
          return exportedModules && exportedModules.has(filePath) && forEachFileAndExportsOfFile(state, exportedFromPath, seenFileAndExportsOfFile, fn);
        })) {
          return true;
        }
        if (ts2.forEachEntry(state.exportedModulesMap, function(exportedModules, exportedFromPath) {
          return !state.currentAffectedFilesExportedModulesMap.has(exportedFromPath) && exportedModules.has(filePath) && forEachFileAndExportsOfFile(state, exportedFromPath, seenFileAndExportsOfFile, fn);
        })) {
          return true;
        }
        return !!ts2.forEachEntry(state.referencedMap, function(referencesInFile, referencingFilePath) {
          return referencesInFile.has(filePath) && !seenFileAndExportsOfFile.has(referencingFilePath) && fn(state, referencingFilePath);
        });
      }
      function doneWithAffectedFile(state, affected, emitKind, isPendingEmit, isBuildInfoEmit) {
        if (isBuildInfoEmit) {
          state.emittedBuildInfo = true;
        } else if (affected === state.program) {
          state.changedFilesSet.clear();
          state.programEmitComplete = true;
        } else {
          state.seenAffectedFiles.set(affected.resolvedPath, true);
          if (emitKind !== void 0) {
            (state.seenEmittedFiles || (state.seenEmittedFiles = ts2.createMap())).set(affected.resolvedPath, emitKind);
          }
          if (isPendingEmit) {
            state.affectedFilesPendingEmitIndex++;
          } else {
            state.affectedFilesIndex++;
          }
        }
      }
      function toAffectedFileResult(state, result, affected) {
        doneWithAffectedFile(state, affected);
        return { result, affected };
      }
      function toAffectedFileEmitResult(state, result, affected, emitKind, isPendingEmit, isBuildInfoEmit) {
        doneWithAffectedFile(state, affected, emitKind, isPendingEmit, isBuildInfoEmit);
        return { result, affected };
      }
      function getSemanticDiagnosticsOfFile(state, sourceFile, cancellationToken) {
        return ts2.concatenate(getBinderAndCheckerDiagnosticsOfFile(state, sourceFile, cancellationToken), ts2.Debug.checkDefined(state.program).getProgramDiagnostics(sourceFile));
      }
      function getBinderAndCheckerDiagnosticsOfFile(state, sourceFile, cancellationToken) {
        var path2 = sourceFile.resolvedPath;
        if (state.semanticDiagnosticsPerFile) {
          var cachedDiagnostics = state.semanticDiagnosticsPerFile.get(path2);
          if (cachedDiagnostics) {
            return cachedDiagnostics;
          }
        }
        var diagnostics = ts2.Debug.checkDefined(state.program).getBindAndCheckDiagnostics(sourceFile, cancellationToken);
        if (state.semanticDiagnosticsPerFile) {
          state.semanticDiagnosticsPerFile.set(path2, diagnostics);
        }
        return diagnostics;
      }
      function getProgramBuildInfo(state, getCanonicalFileName) {
        if (state.compilerOptions.outFile || state.compilerOptions.out)
          return void 0;
        var currentDirectory = ts2.Debug.checkDefined(state.program).getCurrentDirectory();
        var buildInfoDirectory = ts2.getDirectoryPath(ts2.getNormalizedAbsolutePath(ts2.getTsBuildInfoEmitOutputFilePath(state.compilerOptions), currentDirectory));
        var fileInfos = {};
        state.fileInfos.forEach(function(value2, key2) {
          var signature = state.currentAffectedFilesSignatures && state.currentAffectedFilesSignatures.get(key2);
          fileInfos[relativeToBuildInfo(key2)] = signature === void 0 ? value2 : { version: value2.version, signature, affectsGlobalScope: value2.affectsGlobalScope };
        });
        var result = {
          fileInfos,
          options: convertToReusableCompilerOptions(state.compilerOptions, relativeToBuildInfoEnsuringAbsolutePath)
        };
        if (state.referencedMap) {
          var referencedMap = {};
          for (var _i = 0, _a = ts2.arrayFrom(state.referencedMap.keys()).sort(ts2.compareStringsCaseSensitive); _i < _a.length; _i++) {
            var key = _a[_i];
            referencedMap[relativeToBuildInfo(key)] = ts2.arrayFrom(state.referencedMap.get(key).keys(), relativeToBuildInfo).sort(ts2.compareStringsCaseSensitive);
          }
          result.referencedMap = referencedMap;
        }
        if (state.exportedModulesMap) {
          var exportedModulesMap = {};
          for (var _b = 0, _c = ts2.arrayFrom(state.exportedModulesMap.keys()).sort(ts2.compareStringsCaseSensitive); _b < _c.length; _b++) {
            var key = _c[_b];
            var newValue = state.currentAffectedFilesExportedModulesMap && state.currentAffectedFilesExportedModulesMap.get(key);
            if (newValue === void 0)
              exportedModulesMap[relativeToBuildInfo(key)] = ts2.arrayFrom(state.exportedModulesMap.get(key).keys(), relativeToBuildInfo).sort(ts2.compareStringsCaseSensitive);
            else if (newValue)
              exportedModulesMap[relativeToBuildInfo(key)] = ts2.arrayFrom(newValue.keys(), relativeToBuildInfo).sort(ts2.compareStringsCaseSensitive);
          }
          result.exportedModulesMap = exportedModulesMap;
        }
        if (state.semanticDiagnosticsPerFile) {
          var semanticDiagnosticsPerFile = [];
          for (var _d = 0, _e = ts2.arrayFrom(state.semanticDiagnosticsPerFile.keys()).sort(ts2.compareStringsCaseSensitive); _d < _e.length; _d++) {
            var key = _e[_d];
            var value = state.semanticDiagnosticsPerFile.get(key);
            semanticDiagnosticsPerFile.push(value.length ? [
              relativeToBuildInfo(key),
              state.hasReusableDiagnostic ? value : convertToReusableDiagnostics(value, relativeToBuildInfo)
            ] : relativeToBuildInfo(key));
          }
          result.semanticDiagnosticsPerFile = semanticDiagnosticsPerFile;
        }
        return result;
        function relativeToBuildInfoEnsuringAbsolutePath(path2) {
          return relativeToBuildInfo(ts2.getNormalizedAbsolutePath(path2, currentDirectory));
        }
        function relativeToBuildInfo(path2) {
          return ts2.ensurePathIsNonModuleName(ts2.getRelativePathFromDirectory(buildInfoDirectory, path2, getCanonicalFileName));
        }
      }
      function convertToReusableCompilerOptions(options, relativeToBuildInfo) {
        var result = {};
        var optionsNameMap = ts2.getOptionsNameMap().optionsNameMap;
        for (var name in options) {
          if (ts2.hasProperty(options, name)) {
            result[name] = convertToReusableCompilerOptionValue(optionsNameMap.get(name.toLowerCase()), options[name], relativeToBuildInfo);
          }
        }
        if (result.configFilePath) {
          result.configFilePath = relativeToBuildInfo(result.configFilePath);
        }
        return result;
      }
      function convertToReusableCompilerOptionValue(option, value, relativeToBuildInfo) {
        if (option) {
          if (option.type === "list") {
            var values = value;
            if (option.element.isFilePath && values.length) {
              return values.map(relativeToBuildInfo);
            }
          } else if (option.isFilePath) {
            return relativeToBuildInfo(value);
          }
        }
        return value;
      }
      function convertToReusableDiagnostics(diagnostics, relativeToBuildInfo) {
        ts2.Debug.assert(!!diagnostics.length);
        return diagnostics.map(function(diagnostic) {
          var result = convertToReusableDiagnosticRelatedInformation(diagnostic, relativeToBuildInfo);
          result.reportsUnnecessary = diagnostic.reportsUnnecessary;
          result.source = diagnostic.source;
          var relatedInformation = diagnostic.relatedInformation;
          result.relatedInformation = relatedInformation ? relatedInformation.length ? relatedInformation.map(function(r) {
            return convertToReusableDiagnosticRelatedInformation(r, relativeToBuildInfo);
          }) : ts2.emptyArray : void 0;
          return result;
        });
      }
      function convertToReusableDiagnosticRelatedInformation(diagnostic, relativeToBuildInfo) {
        var file = diagnostic.file;
        return __assign(__assign({}, diagnostic), { file: file ? relativeToBuildInfo(file.resolvedPath) : void 0 });
      }
      var BuilderProgramKind;
      (function(BuilderProgramKind2) {
        BuilderProgramKind2[BuilderProgramKind2["SemanticDiagnosticsBuilderProgram"] = 0] = "SemanticDiagnosticsBuilderProgram";
        BuilderProgramKind2[BuilderProgramKind2["EmitAndSemanticDiagnosticsBuilderProgram"] = 1] = "EmitAndSemanticDiagnosticsBuilderProgram";
      })(BuilderProgramKind = ts2.BuilderProgramKind || (ts2.BuilderProgramKind = {}));
      function getBuilderCreationParameters(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences) {
        var host;
        var newProgram;
        var oldProgram;
        if (newProgramOrRootNames === void 0) {
          ts2.Debug.assert(hostOrOptions === void 0);
          host = oldProgramOrHost;
          oldProgram = configFileParsingDiagnosticsOrOldProgram;
          ts2.Debug.assert(!!oldProgram);
          newProgram = oldProgram.getProgram();
        } else if (ts2.isArray(newProgramOrRootNames)) {
          oldProgram = configFileParsingDiagnosticsOrOldProgram;
          newProgram = ts2.createProgram({
            rootNames: newProgramOrRootNames,
            options: hostOrOptions,
            host: oldProgramOrHost,
            oldProgram: oldProgram && oldProgram.getProgramOrUndefined(),
            configFileParsingDiagnostics,
            projectReferences
          });
          host = oldProgramOrHost;
        } else {
          newProgram = newProgramOrRootNames;
          host = hostOrOptions;
          oldProgram = oldProgramOrHost;
          configFileParsingDiagnostics = configFileParsingDiagnosticsOrOldProgram;
        }
        return { host, newProgram, oldProgram, configFileParsingDiagnostics: configFileParsingDiagnostics || ts2.emptyArray };
      }
      ts2.getBuilderCreationParameters = getBuilderCreationParameters;
      function createBuilderProgram(kind, _a) {
        var newProgram = _a.newProgram, host = _a.host, oldProgram = _a.oldProgram, configFileParsingDiagnostics = _a.configFileParsingDiagnostics;
        var oldState = oldProgram && oldProgram.getState();
        if (oldState && newProgram === oldState.program && configFileParsingDiagnostics === newProgram.getConfigFileParsingDiagnostics()) {
          newProgram = void 0;
          oldState = void 0;
          return oldProgram;
        }
        var getCanonicalFileName = ts2.createGetCanonicalFileName(host.useCaseSensitiveFileNames());
        var computeHash = host.createHash || ts2.generateDjb2Hash;
        var state = createBuilderProgramState(newProgram, getCanonicalFileName, oldState);
        var backupState;
        newProgram.getProgramBuildInfo = function() {
          return getProgramBuildInfo(state, getCanonicalFileName);
        };
        newProgram = void 0;
        oldProgram = void 0;
        oldState = void 0;
        var builderProgram = createRedirectedBuilderProgram(state, configFileParsingDiagnostics);
        builderProgram.getState = function() {
          return state;
        };
        builderProgram.backupState = function() {
          ts2.Debug.assert(backupState === void 0);
          backupState = cloneBuilderProgramState(state);
        };
        builderProgram.restoreState = function() {
          state = ts2.Debug.checkDefined(backupState);
          backupState = void 0;
        };
        builderProgram.getAllDependencies = function(sourceFile) {
          return ts2.BuilderState.getAllDependencies(state, ts2.Debug.checkDefined(state.program), sourceFile);
        };
        builderProgram.getSemanticDiagnostics = getSemanticDiagnostics;
        builderProgram.emit = emit;
        builderProgram.releaseProgram = function() {
          releaseCache(state);
          backupState = void 0;
        };
        if (kind === BuilderProgramKind.SemanticDiagnosticsBuilderProgram) {
          builderProgram.getSemanticDiagnosticsOfNextAffectedFile = getSemanticDiagnosticsOfNextAffectedFile;
        } else if (kind === BuilderProgramKind.EmitAndSemanticDiagnosticsBuilderProgram) {
          builderProgram.getSemanticDiagnosticsOfNextAffectedFile = getSemanticDiagnosticsOfNextAffectedFile;
          builderProgram.emitNextAffectedFile = emitNextAffectedFile;
        } else {
          ts2.notImplemented();
        }
        return builderProgram;
        function emitNextAffectedFile(writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers) {
          var affected = getNextAffectedFile(state, cancellationToken, computeHash);
          var emitKind = 1;
          var isPendingEmitFile = false;
          if (!affected) {
            if (!state.compilerOptions.out && !state.compilerOptions.outFile) {
              var pendingAffectedFile = getNextAffectedFilePendingEmit(state);
              if (!pendingAffectedFile) {
                if (state.emittedBuildInfo) {
                  return void 0;
                }
                var affected_1 = ts2.Debug.checkDefined(state.program);
                return toAffectedFileEmitResult(state, affected_1.emitBuildInfo(writeFile || ts2.maybeBind(host, host.writeFile), cancellationToken), affected_1, 1, false, true);
              }
              affected = pendingAffectedFile.affectedFile, emitKind = pendingAffectedFile.emitKind;
              isPendingEmitFile = true;
            } else {
              var program = ts2.Debug.checkDefined(state.program);
              if (state.programEmitComplete)
                return void 0;
              affected = program;
            }
          }
          return toAffectedFileEmitResult(state, ts2.Debug.checkDefined(state.program).emit(affected === state.program ? void 0 : affected, writeFile || ts2.maybeBind(host, host.writeFile), cancellationToken, emitOnlyDtsFiles || emitKind === 0, customTransformers), affected, emitKind, isPendingEmitFile);
        }
        function emit(targetSourceFile, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers) {
          if (kind === BuilderProgramKind.EmitAndSemanticDiagnosticsBuilderProgram) {
            assertSourceFileOkWithoutNextAffectedCall(state, targetSourceFile);
            var result = ts2.handleNoEmitOptions(builderProgram, targetSourceFile, cancellationToken);
            if (result)
              return result;
            if (!targetSourceFile) {
              var sourceMaps = [];
              var emitSkipped = false;
              var diagnostics = void 0;
              var emittedFiles = [];
              var affectedEmitResult = void 0;
              while (affectedEmitResult = emitNextAffectedFile(writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers)) {
                emitSkipped = emitSkipped || affectedEmitResult.result.emitSkipped;
                diagnostics = ts2.addRange(diagnostics, affectedEmitResult.result.diagnostics);
                emittedFiles = ts2.addRange(emittedFiles, affectedEmitResult.result.emittedFiles);
                sourceMaps = ts2.addRange(sourceMaps, affectedEmitResult.result.sourceMaps);
              }
              return {
                emitSkipped,
                diagnostics: diagnostics || ts2.emptyArray,
                emittedFiles,
                sourceMaps
              };
            }
          }
          return ts2.Debug.checkDefined(state.program).emit(targetSourceFile, writeFile || ts2.maybeBind(host, host.writeFile), cancellationToken, emitOnlyDtsFiles, customTransformers);
        }
        function getSemanticDiagnosticsOfNextAffectedFile(cancellationToken, ignoreSourceFile) {
          while (true) {
            var affected = getNextAffectedFile(state, cancellationToken, computeHash);
            if (!affected) {
              return void 0;
            } else if (affected === state.program) {
              return toAffectedFileResult(state, state.program.getSemanticDiagnostics(void 0, cancellationToken), affected);
            }
            if (kind === BuilderProgramKind.EmitAndSemanticDiagnosticsBuilderProgram) {
              addToAffectedFilesPendingEmit(state, affected.resolvedPath, 1);
            }
            if (ignoreSourceFile && ignoreSourceFile(affected)) {
              doneWithAffectedFile(state, affected);
              continue;
            }
            return toAffectedFileResult(state, getSemanticDiagnosticsOfFile(state, affected, cancellationToken), affected);
          }
        }
        function getSemanticDiagnostics(sourceFile, cancellationToken) {
          assertSourceFileOkWithoutNextAffectedCall(state, sourceFile);
          var compilerOptions = ts2.Debug.checkDefined(state.program).getCompilerOptions();
          if (compilerOptions.outFile || compilerOptions.out) {
            ts2.Debug.assert(!state.semanticDiagnosticsPerFile);
            return ts2.Debug.checkDefined(state.program).getSemanticDiagnostics(sourceFile, cancellationToken);
          }
          if (sourceFile) {
            return getSemanticDiagnosticsOfFile(state, sourceFile, cancellationToken);
          }
          while (getSemanticDiagnosticsOfNextAffectedFile(cancellationToken)) {
          }
          var diagnostics;
          for (var _i = 0, _a2 = ts2.Debug.checkDefined(state.program).getSourceFiles(); _i < _a2.length; _i++) {
            var sourceFile_1 = _a2[_i];
            diagnostics = ts2.addRange(diagnostics, getSemanticDiagnosticsOfFile(state, sourceFile_1, cancellationToken));
          }
          return diagnostics || ts2.emptyArray;
        }
      }
      ts2.createBuilderProgram = createBuilderProgram;
      function addToAffectedFilesPendingEmit(state, affectedFilePendingEmit, kind) {
        if (!state.affectedFilesPendingEmit)
          state.affectedFilesPendingEmit = [];
        if (!state.affectedFilesPendingEmitKind)
          state.affectedFilesPendingEmitKind = ts2.createMap();
        var existingKind = state.affectedFilesPendingEmitKind.get(affectedFilePendingEmit);
        state.affectedFilesPendingEmit.push(affectedFilePendingEmit);
        state.affectedFilesPendingEmitKind.set(affectedFilePendingEmit, existingKind || kind);
        if (state.affectedFilesPendingEmitIndex === void 0) {
          state.affectedFilesPendingEmitIndex = 0;
        }
      }
      function getMapOfReferencedSet(mapLike, toPath) {
        if (!mapLike)
          return void 0;
        var map = ts2.createMap();
        for (var key in mapLike) {
          if (ts2.hasProperty(mapLike, key)) {
            map.set(toPath(key), ts2.arrayToSet(mapLike[key], toPath));
          }
        }
        return map;
      }
      function createBuildProgramUsingProgramBuildInfo(program, buildInfoPath, host) {
        var buildInfoDirectory = ts2.getDirectoryPath(ts2.getNormalizedAbsolutePath(buildInfoPath, host.getCurrentDirectory()));
        var getCanonicalFileName = ts2.createGetCanonicalFileName(host.useCaseSensitiveFileNames());
        var fileInfos = ts2.createMap();
        for (var key in program.fileInfos) {
          if (ts2.hasProperty(program.fileInfos, key)) {
            fileInfos.set(toPath(key), program.fileInfos[key]);
          }
        }
        var state = {
          fileInfos,
          compilerOptions: ts2.convertToOptionsWithAbsolutePaths(program.options, toAbsolutePath),
          referencedMap: getMapOfReferencedSet(program.referencedMap, toPath),
          exportedModulesMap: getMapOfReferencedSet(program.exportedModulesMap, toPath),
          semanticDiagnosticsPerFile: program.semanticDiagnosticsPerFile && ts2.arrayToMap(program.semanticDiagnosticsPerFile, function(value) {
            return toPath(ts2.isString(value) ? value : value[0]);
          }, function(value) {
            return ts2.isString(value) ? ts2.emptyArray : value[1];
          }),
          hasReusableDiagnostic: true
        };
        return {
          getState: function() {
            return state;
          },
          backupState: ts2.noop,
          restoreState: ts2.noop,
          getProgram: ts2.notImplemented,
          getProgramOrUndefined: ts2.returnUndefined,
          releaseProgram: ts2.noop,
          getCompilerOptions: function() {
            return state.compilerOptions;
          },
          getSourceFile: ts2.notImplemented,
          getSourceFiles: ts2.notImplemented,
          getOptionsDiagnostics: ts2.notImplemented,
          getGlobalDiagnostics: ts2.notImplemented,
          getConfigFileParsingDiagnostics: ts2.notImplemented,
          getSyntacticDiagnostics: ts2.notImplemented,
          getDeclarationDiagnostics: ts2.notImplemented,
          getSemanticDiagnostics: ts2.notImplemented,
          emit: ts2.notImplemented,
          getAllDependencies: ts2.notImplemented,
          getCurrentDirectory: ts2.notImplemented,
          emitNextAffectedFile: ts2.notImplemented,
          getSemanticDiagnosticsOfNextAffectedFile: ts2.notImplemented,
          close: ts2.noop
        };
        function toPath(path2) {
          return ts2.toPath(path2, buildInfoDirectory, getCanonicalFileName);
        }
        function toAbsolutePath(path2) {
          return ts2.getNormalizedAbsolutePath(path2, buildInfoDirectory);
        }
      }
      ts2.createBuildProgramUsingProgramBuildInfo = createBuildProgramUsingProgramBuildInfo;
      function createRedirectedBuilderProgram(state, configFileParsingDiagnostics) {
        return {
          getState: ts2.notImplemented,
          backupState: ts2.noop,
          restoreState: ts2.noop,
          getProgram,
          getProgramOrUndefined: function() {
            return state.program;
          },
          releaseProgram: function() {
            return state.program = void 0;
          },
          getCompilerOptions: function() {
            return state.compilerOptions;
          },
          getSourceFile: function(fileName) {
            return getProgram().getSourceFile(fileName);
          },
          getSourceFiles: function() {
            return getProgram().getSourceFiles();
          },
          getOptionsDiagnostics: function(cancellationToken) {
            return getProgram().getOptionsDiagnostics(cancellationToken);
          },
          getGlobalDiagnostics: function(cancellationToken) {
            return getProgram().getGlobalDiagnostics(cancellationToken);
          },
          getConfigFileParsingDiagnostics: function() {
            return configFileParsingDiagnostics;
          },
          getSyntacticDiagnostics: function(sourceFile, cancellationToken) {
            return getProgram().getSyntacticDiagnostics(sourceFile, cancellationToken);
          },
          getDeclarationDiagnostics: function(sourceFile, cancellationToken) {
            return getProgram().getDeclarationDiagnostics(sourceFile, cancellationToken);
          },
          getSemanticDiagnostics: function(sourceFile, cancellationToken) {
            return getProgram().getSemanticDiagnostics(sourceFile, cancellationToken);
          },
          emit: function(sourceFile, writeFile, cancellationToken, emitOnlyDts, customTransformers) {
            return getProgram().emit(sourceFile, writeFile, cancellationToken, emitOnlyDts, customTransformers);
          },
          getAllDependencies: ts2.notImplemented,
          getCurrentDirectory: function() {
            return getProgram().getCurrentDirectory();
          },
          close: ts2.noop
        };
        function getProgram() {
          return ts2.Debug.checkDefined(state.program);
        }
      }
      ts2.createRedirectedBuilderProgram = createRedirectedBuilderProgram;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function createSemanticDiagnosticsBuilderProgram(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences) {
        return ts2.createBuilderProgram(ts2.BuilderProgramKind.SemanticDiagnosticsBuilderProgram, ts2.getBuilderCreationParameters(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences));
      }
      ts2.createSemanticDiagnosticsBuilderProgram = createSemanticDiagnosticsBuilderProgram;
      function createEmitAndSemanticDiagnosticsBuilderProgram(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences) {
        return ts2.createBuilderProgram(ts2.BuilderProgramKind.EmitAndSemanticDiagnosticsBuilderProgram, ts2.getBuilderCreationParameters(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences));
      }
      ts2.createEmitAndSemanticDiagnosticsBuilderProgram = createEmitAndSemanticDiagnosticsBuilderProgram;
      function createAbstractBuilder(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences) {
        var _a = ts2.getBuilderCreationParameters(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences), newProgram = _a.newProgram, newConfigFileParsingDiagnostics = _a.configFileParsingDiagnostics;
        return ts2.createRedirectedBuilderProgram({ program: newProgram, compilerOptions: newProgram.getCompilerOptions() }, newConfigFileParsingDiagnostics);
      }
      ts2.createAbstractBuilder = createAbstractBuilder;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function removeIgnoredPath(path2) {
        if (ts2.endsWith(path2, "/node_modules/.staging")) {
          return ts2.removeSuffix(path2, "/.staging");
        }
        return ts2.some(ts2.ignoredPaths, function(searchPath) {
          return ts2.stringContains(path2, searchPath);
        }) ? void 0 : path2;
      }
      ts2.removeIgnoredPath = removeIgnoredPath;
      function canWatchDirectory(dirPath) {
        var rootLength = ts2.getRootLength(dirPath);
        if (dirPath.length === rootLength) {
          return false;
        }
        var nextDirectorySeparator = dirPath.indexOf(ts2.directorySeparator, rootLength);
        if (nextDirectorySeparator === -1) {
          return false;
        }
        var pathPartForUserCheck = dirPath.substring(rootLength, nextDirectorySeparator + 1);
        var isNonDirectorySeparatorRoot = rootLength > 1 || dirPath.charCodeAt(0) !== 47;
        if (isNonDirectorySeparatorRoot && dirPath.search(/[a-zA-Z]:/) !== 0 && pathPartForUserCheck.search(/[a-zA-z]\$\//) === 0) {
          nextDirectorySeparator = dirPath.indexOf(ts2.directorySeparator, nextDirectorySeparator + 1);
          if (nextDirectorySeparator === -1) {
            return false;
          }
          pathPartForUserCheck = dirPath.substring(rootLength + pathPartForUserCheck.length, nextDirectorySeparator + 1);
        }
        if (isNonDirectorySeparatorRoot && pathPartForUserCheck.search(/users\//i) !== 0) {
          return true;
        }
        for (var searchIndex = nextDirectorySeparator + 1, searchLevels = 2; searchLevels > 0; searchLevels--) {
          searchIndex = dirPath.indexOf(ts2.directorySeparator, searchIndex) + 1;
          if (searchIndex === 0) {
            return false;
          }
        }
        return true;
      }
      ts2.canWatchDirectory = canWatchDirectory;
      function createResolutionCache(resolutionHost, rootDirForResolution, logChangesWhenResolvingModule) {
        var filesWithChangedSetOfUnresolvedImports;
        var filesWithInvalidatedResolutions;
        var filesWithInvalidatedNonRelativeUnresolvedImports;
        var nonRelativeExternalModuleResolutions = ts2.createMultiMap();
        var resolutionsWithFailedLookups = [];
        var resolvedFileToResolution = ts2.createMultiMap();
        var getCurrentDirectory = ts2.memoize(function() {
          return resolutionHost.getCurrentDirectory();
        });
        var cachedDirectoryStructureHost = resolutionHost.getCachedDirectoryStructureHost();
        var resolvedModuleNames = ts2.createMap();
        var perDirectoryResolvedModuleNames = ts2.createCacheWithRedirects();
        var nonRelativeModuleNameCache = ts2.createCacheWithRedirects();
        var moduleResolutionCache = ts2.createModuleResolutionCacheWithMaps(perDirectoryResolvedModuleNames, nonRelativeModuleNameCache, getCurrentDirectory(), resolutionHost.getCanonicalFileName);
        var resolvedTypeReferenceDirectives = ts2.createMap();
        var perDirectoryResolvedTypeReferenceDirectives = ts2.createCacheWithRedirects();
        var failedLookupDefaultExtensions = [".ts", ".tsx", ".js", ".jsx", ".json"];
        var customFailedLookupPaths = ts2.createMap();
        var directoryWatchesOfFailedLookups = ts2.createMap();
        var rootDir = rootDirForResolution && ts2.removeTrailingDirectorySeparator(ts2.getNormalizedAbsolutePath(rootDirForResolution, getCurrentDirectory()));
        var rootPath = rootDir && resolutionHost.toPath(rootDir);
        var rootSplitLength = rootPath !== void 0 ? rootPath.split(ts2.directorySeparator).length : 0;
        var typeRootsWatches = ts2.createMap();
        return {
          startRecordingFilesWithChangedResolutions,
          finishRecordingFilesWithChangedResolutions,
          startCachingPerDirectoryResolution: clearPerDirectoryResolutions,
          finishCachingPerDirectoryResolution,
          resolveModuleNames,
          getResolvedModuleWithFailedLookupLocationsFromCache,
          resolveTypeReferenceDirectives,
          removeResolutionsFromProjectReferenceRedirects,
          removeResolutionsOfFile,
          invalidateResolutionOfFile,
          setFilesWithInvalidatedNonRelativeUnresolvedImports,
          createHasInvalidatedResolution,
          updateTypeRootsWatch,
          closeTypeRootsWatch,
          clear
        };
        function getResolvedModule(resolution) {
          return resolution.resolvedModule;
        }
        function getResolvedTypeReferenceDirective(resolution) {
          return resolution.resolvedTypeReferenceDirective;
        }
        function isInDirectoryPath(dir, file) {
          if (dir === void 0 || file.length <= dir.length) {
            return false;
          }
          return ts2.startsWith(file, dir) && file[dir.length] === ts2.directorySeparator;
        }
        function clear() {
          ts2.clearMap(directoryWatchesOfFailedLookups, ts2.closeFileWatcherOf);
          customFailedLookupPaths.clear();
          nonRelativeExternalModuleResolutions.clear();
          closeTypeRootsWatch();
          resolvedModuleNames.clear();
          resolvedTypeReferenceDirectives.clear();
          resolvedFileToResolution.clear();
          resolutionsWithFailedLookups.length = 0;
          clearPerDirectoryResolutions();
        }
        function startRecordingFilesWithChangedResolutions() {
          filesWithChangedSetOfUnresolvedImports = [];
        }
        function finishRecordingFilesWithChangedResolutions() {
          var collected = filesWithChangedSetOfUnresolvedImports;
          filesWithChangedSetOfUnresolvedImports = void 0;
          return collected;
        }
        function isFileWithInvalidatedNonRelativeUnresolvedImports(path2) {
          if (!filesWithInvalidatedNonRelativeUnresolvedImports) {
            return false;
          }
          var value = filesWithInvalidatedNonRelativeUnresolvedImports.get(path2);
          return !!value && !!value.length;
        }
        function createHasInvalidatedResolution(forceAllFilesAsInvalidated) {
          if (forceAllFilesAsInvalidated) {
            filesWithInvalidatedResolutions = void 0;
            return ts2.returnTrue;
          }
          var collected = filesWithInvalidatedResolutions;
          filesWithInvalidatedResolutions = void 0;
          return function(path2) {
            return !!collected && collected.has(path2) || isFileWithInvalidatedNonRelativeUnresolvedImports(path2);
          };
        }
        function clearPerDirectoryResolutions() {
          perDirectoryResolvedModuleNames.clear();
          nonRelativeModuleNameCache.clear();
          perDirectoryResolvedTypeReferenceDirectives.clear();
          nonRelativeExternalModuleResolutions.forEach(watchFailedLookupLocationOfNonRelativeModuleResolutions);
          nonRelativeExternalModuleResolutions.clear();
        }
        function finishCachingPerDirectoryResolution() {
          filesWithInvalidatedNonRelativeUnresolvedImports = void 0;
          clearPerDirectoryResolutions();
          directoryWatchesOfFailedLookups.forEach(function(watcher, path2) {
            if (watcher.refCount === 0) {
              directoryWatchesOfFailedLookups.delete(path2);
              watcher.watcher.close();
            }
          });
        }
        function resolveModuleName(moduleName, containingFile, compilerOptions, host, redirectedReference) {
          var _a;
          var primaryResult = ts2.resolveModuleName(moduleName, containingFile, compilerOptions, host, moduleResolutionCache, redirectedReference);
          if (!resolutionHost.getGlobalCache) {
            return primaryResult;
          }
          var globalCache = resolutionHost.getGlobalCache();
          if (globalCache !== void 0 && !ts2.isExternalModuleNameRelative(moduleName) && !(primaryResult.resolvedModule && ts2.extensionIsTS(primaryResult.resolvedModule.extension))) {
            var _b = ts2.loadModuleFromGlobalCache(ts2.Debug.checkDefined(resolutionHost.globalCacheResolutionModuleName)(moduleName), resolutionHost.projectName, compilerOptions, host, globalCache), resolvedModule = _b.resolvedModule, failedLookupLocations = _b.failedLookupLocations;
            if (resolvedModule) {
              primaryResult.resolvedModule = resolvedModule;
              (_a = primaryResult.failedLookupLocations).push.apply(_a, failedLookupLocations);
              return primaryResult;
            }
          }
          return primaryResult;
        }
        function resolveNamesWithLocalCache(_a) {
          var _b;
          var names = _a.names, containingFile = _a.containingFile, redirectedReference = _a.redirectedReference, cache = _a.cache, perDirectoryCacheWithRedirects = _a.perDirectoryCacheWithRedirects, loader = _a.loader, getResolutionWithResolvedFileName = _a.getResolutionWithResolvedFileName, shouldRetryResolution = _a.shouldRetryResolution, reusedNames = _a.reusedNames, logChanges = _a.logChanges;
          var path2 = resolutionHost.toPath(containingFile);
          var resolutionsInFile = cache.get(path2) || cache.set(path2, ts2.createMap()).get(path2);
          var dirPath = ts2.getDirectoryPath(path2);
          var perDirectoryCache = perDirectoryCacheWithRedirects.getOrCreateMapOfCacheRedirects(redirectedReference);
          var perDirectoryResolution = perDirectoryCache.get(dirPath);
          if (!perDirectoryResolution) {
            perDirectoryResolution = ts2.createMap();
            perDirectoryCache.set(dirPath, perDirectoryResolution);
          }
          var resolvedModules = [];
          var compilerOptions = resolutionHost.getCompilationSettings();
          var hasInvalidatedNonRelativeUnresolvedImport = logChanges && isFileWithInvalidatedNonRelativeUnresolvedImports(path2);
          var program = resolutionHost.getCurrentProgram();
          var oldRedirect = program && program.getResolvedProjectReferenceToRedirect(containingFile);
          var unmatchedRedirects = oldRedirect ? !redirectedReference || redirectedReference.sourceFile.path !== oldRedirect.sourceFile.path : !!redirectedReference;
          var seenNamesInFile = ts2.createMap();
          for (var _i = 0, names_3 = names; _i < names_3.length; _i++) {
            var name = names_3[_i];
            var resolution = resolutionsInFile.get(name);
            if (!seenNamesInFile.has(name) && unmatchedRedirects || !resolution || resolution.isInvalidated || hasInvalidatedNonRelativeUnresolvedImport && !ts2.isExternalModuleNameRelative(name) && shouldRetryResolution(resolution)) {
              var existingResolution = resolution;
              var resolutionInDirectory = perDirectoryResolution.get(name);
              if (resolutionInDirectory) {
                resolution = resolutionInDirectory;
              } else {
                resolution = loader(name, containingFile, compilerOptions, ((_b = resolutionHost.getCompilerHost) === null || _b === void 0 ? void 0 : _b.call(resolutionHost)) || resolutionHost, redirectedReference);
                perDirectoryResolution.set(name, resolution);
              }
              resolutionsInFile.set(name, resolution);
              watchFailedLookupLocationsOfExternalModuleResolutions(name, resolution, path2, getResolutionWithResolvedFileName);
              if (existingResolution) {
                stopWatchFailedLookupLocationOfResolution(existingResolution, path2, getResolutionWithResolvedFileName);
              }
              if (logChanges && filesWithChangedSetOfUnresolvedImports && !resolutionIsEqualTo(existingResolution, resolution)) {
                filesWithChangedSetOfUnresolvedImports.push(path2);
                logChanges = false;
              }
            }
            ts2.Debug.assert(resolution !== void 0 && !resolution.isInvalidated);
            seenNamesInFile.set(name, true);
            resolvedModules.push(getResolutionWithResolvedFileName(resolution));
          }
          resolutionsInFile.forEach(function(resolution2, name2) {
            if (!seenNamesInFile.has(name2) && !ts2.contains(reusedNames, name2)) {
              stopWatchFailedLookupLocationOfResolution(resolution2, path2, getResolutionWithResolvedFileName);
              resolutionsInFile.delete(name2);
            }
          });
          return resolvedModules;
          function resolutionIsEqualTo(oldResolution, newResolution) {
            if (oldResolution === newResolution) {
              return true;
            }
            if (!oldResolution || !newResolution) {
              return false;
            }
            var oldResult = getResolutionWithResolvedFileName(oldResolution);
            var newResult = getResolutionWithResolvedFileName(newResolution);
            if (oldResult === newResult) {
              return true;
            }
            if (!oldResult || !newResult) {
              return false;
            }
            return oldResult.resolvedFileName === newResult.resolvedFileName;
          }
        }
        function resolveTypeReferenceDirectives(typeDirectiveNames, containingFile, redirectedReference) {
          return resolveNamesWithLocalCache({
            names: typeDirectiveNames,
            containingFile,
            redirectedReference,
            cache: resolvedTypeReferenceDirectives,
            perDirectoryCacheWithRedirects: perDirectoryResolvedTypeReferenceDirectives,
            loader: ts2.resolveTypeReferenceDirective,
            getResolutionWithResolvedFileName: getResolvedTypeReferenceDirective,
            shouldRetryResolution: function(resolution) {
              return resolution.resolvedTypeReferenceDirective === void 0;
            }
          });
        }
        function resolveModuleNames(moduleNames, containingFile, reusedNames, redirectedReference) {
          return resolveNamesWithLocalCache({
            names: moduleNames,
            containingFile,
            redirectedReference,
            cache: resolvedModuleNames,
            perDirectoryCacheWithRedirects: perDirectoryResolvedModuleNames,
            loader: resolveModuleName,
            getResolutionWithResolvedFileName: getResolvedModule,
            shouldRetryResolution: function(resolution) {
              return !resolution.resolvedModule || !ts2.resolutionExtensionIsTSOrJson(resolution.resolvedModule.extension);
            },
            reusedNames,
            logChanges: logChangesWhenResolvingModule
          });
        }
        function getResolvedModuleWithFailedLookupLocationsFromCache(moduleName, containingFile) {
          var cache = resolvedModuleNames.get(resolutionHost.toPath(containingFile));
          return cache && cache.get(moduleName);
        }
        function isNodeModulesAtTypesDirectory(dirPath) {
          return ts2.endsWith(dirPath, "/node_modules/@types");
        }
        function getDirectoryToWatchFailedLookupLocation(failedLookupLocation, failedLookupLocationPath) {
          if (isInDirectoryPath(rootPath, failedLookupLocationPath)) {
            failedLookupLocation = ts2.isRootedDiskPath(failedLookupLocation) ? ts2.normalizePath(failedLookupLocation) : ts2.getNormalizedAbsolutePath(failedLookupLocation, getCurrentDirectory());
            var failedLookupPathSplit = failedLookupLocationPath.split(ts2.directorySeparator);
            var failedLookupSplit = failedLookupLocation.split(ts2.directorySeparator);
            ts2.Debug.assert(failedLookupSplit.length === failedLookupPathSplit.length, "FailedLookup: " + failedLookupLocation + " failedLookupLocationPath: " + failedLookupLocationPath);
            if (failedLookupPathSplit.length > rootSplitLength + 1) {
              return {
                dir: failedLookupSplit.slice(0, rootSplitLength + 1).join(ts2.directorySeparator),
                dirPath: failedLookupPathSplit.slice(0, rootSplitLength + 1).join(ts2.directorySeparator)
              };
            } else {
              return {
                dir: rootDir,
                dirPath: rootPath,
                nonRecursive: false
              };
            }
          }
          return getDirectoryToWatchFromFailedLookupLocationDirectory(ts2.getDirectoryPath(ts2.getNormalizedAbsolutePath(failedLookupLocation, getCurrentDirectory())), ts2.getDirectoryPath(failedLookupLocationPath));
        }
        function getDirectoryToWatchFromFailedLookupLocationDirectory(dir, dirPath) {
          while (ts2.pathContainsNodeModules(dirPath)) {
            dir = ts2.getDirectoryPath(dir);
            dirPath = ts2.getDirectoryPath(dirPath);
          }
          if (ts2.isNodeModulesDirectory(dirPath)) {
            return canWatchDirectory(ts2.getDirectoryPath(dirPath)) ? { dir, dirPath } : void 0;
          }
          var nonRecursive = true;
          var subDirectoryPath, subDirectory;
          if (rootPath !== void 0) {
            while (!isInDirectoryPath(dirPath, rootPath)) {
              var parentPath = ts2.getDirectoryPath(dirPath);
              if (parentPath === dirPath) {
                break;
              }
              nonRecursive = false;
              subDirectoryPath = dirPath;
              subDirectory = dir;
              dirPath = parentPath;
              dir = ts2.getDirectoryPath(dir);
            }
          }
          return canWatchDirectory(dirPath) ? { dir: subDirectory || dir, dirPath: subDirectoryPath || dirPath, nonRecursive } : void 0;
        }
        function isPathWithDefaultFailedLookupExtension(path2) {
          return ts2.fileExtensionIsOneOf(path2, failedLookupDefaultExtensions);
        }
        function watchFailedLookupLocationsOfExternalModuleResolutions(name, resolution, filePath, getResolutionWithResolvedFileName) {
          if (resolution.refCount) {
            resolution.refCount++;
            ts2.Debug.assertDefined(resolution.files);
          } else {
            resolution.refCount = 1;
            ts2.Debug.assert(resolution.files === void 0);
            if (ts2.isExternalModuleNameRelative(name)) {
              watchFailedLookupLocationOfResolution(resolution);
            } else {
              nonRelativeExternalModuleResolutions.add(name, resolution);
            }
            var resolved = getResolutionWithResolvedFileName(resolution);
            if (resolved && resolved.resolvedFileName) {
              resolvedFileToResolution.add(resolutionHost.toPath(resolved.resolvedFileName), resolution);
            }
          }
          (resolution.files || (resolution.files = [])).push(filePath);
        }
        function watchFailedLookupLocationOfResolution(resolution) {
          ts2.Debug.assert(!!resolution.refCount);
          var failedLookupLocations = resolution.failedLookupLocations;
          if (!failedLookupLocations.length)
            return;
          resolutionsWithFailedLookups.push(resolution);
          var setAtRoot = false;
          for (var _i = 0, failedLookupLocations_1 = failedLookupLocations; _i < failedLookupLocations_1.length; _i++) {
            var failedLookupLocation = failedLookupLocations_1[_i];
            var failedLookupLocationPath = resolutionHost.toPath(failedLookupLocation);
            var toWatch = getDirectoryToWatchFailedLookupLocation(failedLookupLocation, failedLookupLocationPath);
            if (toWatch) {
              var dir = toWatch.dir, dirPath = toWatch.dirPath, nonRecursive = toWatch.nonRecursive;
              if (!isPathWithDefaultFailedLookupExtension(failedLookupLocationPath)) {
                var refCount = customFailedLookupPaths.get(failedLookupLocationPath) || 0;
                customFailedLookupPaths.set(failedLookupLocationPath, refCount + 1);
              }
              if (dirPath === rootPath) {
                ts2.Debug.assert(!nonRecursive);
                setAtRoot = true;
              } else {
                setDirectoryWatcher(dir, dirPath, nonRecursive);
              }
            }
          }
          if (setAtRoot) {
            setDirectoryWatcher(rootDir, rootPath, true);
          }
        }
        function watchFailedLookupLocationOfNonRelativeModuleResolutions(resolutions, name) {
          var program = resolutionHost.getCurrentProgram();
          if (!program || !program.getTypeChecker().tryFindAmbientModuleWithoutAugmentations(name)) {
            resolutions.forEach(watchFailedLookupLocationOfResolution);
          }
        }
        function setDirectoryWatcher(dir, dirPath, nonRecursive) {
          var dirWatcher = directoryWatchesOfFailedLookups.get(dirPath);
          if (dirWatcher) {
            ts2.Debug.assert(!!nonRecursive === !!dirWatcher.nonRecursive);
            dirWatcher.refCount++;
          } else {
            directoryWatchesOfFailedLookups.set(dirPath, { watcher: createDirectoryWatcher(dir, dirPath, nonRecursive), refCount: 1, nonRecursive });
          }
        }
        function stopWatchFailedLookupLocationOfResolution(resolution, filePath, getResolutionWithResolvedFileName) {
          ts2.unorderedRemoveItem(ts2.Debug.assertDefined(resolution.files), filePath);
          resolution.refCount--;
          if (resolution.refCount) {
            return;
          }
          var resolved = getResolutionWithResolvedFileName(resolution);
          if (resolved && resolved.resolvedFileName) {
            resolvedFileToResolution.remove(resolutionHost.toPath(resolved.resolvedFileName), resolution);
          }
          if (!ts2.unorderedRemoveItem(resolutionsWithFailedLookups, resolution)) {
            return;
          }
          var failedLookupLocations = resolution.failedLookupLocations;
          var removeAtRoot = false;
          for (var _i = 0, failedLookupLocations_2 = failedLookupLocations; _i < failedLookupLocations_2.length; _i++) {
            var failedLookupLocation = failedLookupLocations_2[_i];
            var failedLookupLocationPath = resolutionHost.toPath(failedLookupLocation);
            var toWatch = getDirectoryToWatchFailedLookupLocation(failedLookupLocation, failedLookupLocationPath);
            if (toWatch) {
              var dirPath = toWatch.dirPath;
              var refCount = customFailedLookupPaths.get(failedLookupLocationPath);
              if (refCount) {
                if (refCount === 1) {
                  customFailedLookupPaths.delete(failedLookupLocationPath);
                } else {
                  ts2.Debug.assert(refCount > 1);
                  customFailedLookupPaths.set(failedLookupLocationPath, refCount - 1);
                }
              }
              if (dirPath === rootPath) {
                removeAtRoot = true;
              } else {
                removeDirectoryWatcher(dirPath);
              }
            }
          }
          if (removeAtRoot) {
            removeDirectoryWatcher(rootPath);
          }
        }
        function removeDirectoryWatcher(dirPath) {
          var dirWatcher = directoryWatchesOfFailedLookups.get(dirPath);
          dirWatcher.refCount--;
        }
        function createDirectoryWatcher(directory, dirPath, nonRecursive) {
          return resolutionHost.watchDirectoryOfFailedLookupLocation(directory, function(fileOrDirectory) {
            var fileOrDirectoryPath = resolutionHost.toPath(fileOrDirectory);
            if (cachedDirectoryStructureHost) {
              cachedDirectoryStructureHost.addOrDeleteFileOrDirectory(fileOrDirectory, fileOrDirectoryPath);
            }
            if (invalidateResolutionOfFailedLookupLocation(fileOrDirectoryPath, dirPath === fileOrDirectoryPath)) {
              resolutionHost.onInvalidatedResolution();
            }
          }, nonRecursive ? 0 : 1);
        }
        function removeResolutionsOfFileFromCache(cache, filePath, getResolutionWithResolvedFileName) {
          var resolutions = cache.get(filePath);
          if (resolutions) {
            resolutions.forEach(function(resolution) {
              return stopWatchFailedLookupLocationOfResolution(resolution, filePath, getResolutionWithResolvedFileName);
            });
            cache.delete(filePath);
          }
        }
        function removeResolutionsFromProjectReferenceRedirects(filePath) {
          if (!ts2.fileExtensionIs(filePath, ".json")) {
            return;
          }
          var program = resolutionHost.getCurrentProgram();
          if (!program) {
            return;
          }
          var resolvedProjectReference = program.getResolvedProjectReferenceByPath(filePath);
          if (!resolvedProjectReference) {
            return;
          }
          resolvedProjectReference.commandLine.fileNames.forEach(function(f) {
            return removeResolutionsOfFile(resolutionHost.toPath(f));
          });
        }
        function removeResolutionsOfFile(filePath) {
          removeResolutionsOfFileFromCache(resolvedModuleNames, filePath, getResolvedModule);
          removeResolutionsOfFileFromCache(resolvedTypeReferenceDirectives, filePath, getResolvedTypeReferenceDirective);
        }
        function invalidateResolution(resolution) {
          resolution.isInvalidated = true;
          var changedInAutoTypeReferenced = false;
          for (var _i = 0, _a = ts2.Debug.assertDefined(resolution.files); _i < _a.length; _i++) {
            var containingFilePath = _a[_i];
            (filesWithInvalidatedResolutions || (filesWithInvalidatedResolutions = ts2.createMap())).set(containingFilePath, true);
            changedInAutoTypeReferenced = changedInAutoTypeReferenced || containingFilePath.endsWith(ts2.inferredTypesContainingFile);
          }
          if (changedInAutoTypeReferenced) {
            resolutionHost.onChangedAutomaticTypeDirectiveNames();
          }
        }
        function invalidateResolutionOfFile(filePath) {
          removeResolutionsOfFile(filePath);
          ts2.forEach(resolvedFileToResolution.get(filePath), invalidateResolution);
        }
        function setFilesWithInvalidatedNonRelativeUnresolvedImports(filesMap) {
          ts2.Debug.assert(filesWithInvalidatedNonRelativeUnresolvedImports === filesMap || filesWithInvalidatedNonRelativeUnresolvedImports === void 0);
          filesWithInvalidatedNonRelativeUnresolvedImports = filesMap;
        }
        function invalidateResolutionOfFailedLookupLocation(fileOrDirectoryPath, isCreatingWatchedDirectory) {
          var isChangedFailedLookupLocation;
          if (isCreatingWatchedDirectory) {
            isChangedFailedLookupLocation = function(location) {
              return isInDirectoryPath(fileOrDirectoryPath, resolutionHost.toPath(location));
            };
          } else {
            var updatedPath = removeIgnoredPath(fileOrDirectoryPath);
            if (!updatedPath)
              return false;
            fileOrDirectoryPath = updatedPath;
            if (resolutionHost.fileIsOpen(fileOrDirectoryPath)) {
              return false;
            }
            var dirOfFileOrDirectory = ts2.getDirectoryPath(fileOrDirectoryPath);
            if (isNodeModulesAtTypesDirectory(fileOrDirectoryPath) || ts2.isNodeModulesDirectory(fileOrDirectoryPath) || isNodeModulesAtTypesDirectory(dirOfFileOrDirectory) || ts2.isNodeModulesDirectory(dirOfFileOrDirectory)) {
              isChangedFailedLookupLocation = function(location) {
                var locationPath = resolutionHost.toPath(location);
                return locationPath === fileOrDirectoryPath || ts2.startsWith(resolutionHost.toPath(location), fileOrDirectoryPath);
              };
            } else {
              if (!isPathWithDefaultFailedLookupExtension(fileOrDirectoryPath) && !customFailedLookupPaths.has(fileOrDirectoryPath)) {
                return false;
              }
              if (ts2.isEmittedFileOfProgram(resolutionHost.getCurrentProgram(), fileOrDirectoryPath)) {
                return false;
              }
              isChangedFailedLookupLocation = function(location) {
                return resolutionHost.toPath(location) === fileOrDirectoryPath;
              };
            }
          }
          var invalidated = false;
          for (var _i = 0, resolutionsWithFailedLookups_1 = resolutionsWithFailedLookups; _i < resolutionsWithFailedLookups_1.length; _i++) {
            var resolution = resolutionsWithFailedLookups_1[_i];
            if (resolution.failedLookupLocations.some(isChangedFailedLookupLocation)) {
              invalidateResolution(resolution);
              invalidated = true;
            }
          }
          return invalidated;
        }
        function closeTypeRootsWatch() {
          ts2.clearMap(typeRootsWatches, ts2.closeFileWatcher);
        }
        function getDirectoryToWatchFailedLookupLocationFromTypeRoot(typeRoot, typeRootPath) {
          if (isInDirectoryPath(rootPath, typeRootPath)) {
            return rootPath;
          }
          var toWatch = getDirectoryToWatchFromFailedLookupLocationDirectory(typeRoot, typeRootPath);
          return toWatch && directoryWatchesOfFailedLookups.has(toWatch.dirPath) ? toWatch.dirPath : void 0;
        }
        function createTypeRootsWatch(typeRootPath, typeRoot) {
          return resolutionHost.watchTypeRootsDirectory(typeRoot, function(fileOrDirectory) {
            var fileOrDirectoryPath = resolutionHost.toPath(fileOrDirectory);
            if (cachedDirectoryStructureHost) {
              cachedDirectoryStructureHost.addOrDeleteFileOrDirectory(fileOrDirectory, fileOrDirectoryPath);
            }
            resolutionHost.onChangedAutomaticTypeDirectiveNames();
            var dirPath = getDirectoryToWatchFailedLookupLocationFromTypeRoot(typeRoot, typeRootPath);
            if (dirPath && invalidateResolutionOfFailedLookupLocation(fileOrDirectoryPath, dirPath === fileOrDirectoryPath)) {
              resolutionHost.onInvalidatedResolution();
            }
          }, 1);
        }
        function updateTypeRootsWatch() {
          var options = resolutionHost.getCompilationSettings();
          if (options.types) {
            closeTypeRootsWatch();
            return;
          }
          var typeRoots = ts2.getEffectiveTypeRoots(options, { directoryExists: directoryExistsForTypeRootWatch, getCurrentDirectory });
          if (typeRoots) {
            ts2.mutateMap(typeRootsWatches, ts2.arrayToMap(typeRoots, function(tr) {
              return resolutionHost.toPath(tr);
            }), {
              createNewValue: createTypeRootsWatch,
              onDeleteValue: ts2.closeFileWatcher
            });
          } else {
            closeTypeRootsWatch();
          }
        }
        function directoryExistsForTypeRootWatch(nodeTypesDirectory) {
          var dir = ts2.getDirectoryPath(ts2.getDirectoryPath(nodeTypesDirectory));
          var dirPath = resolutionHost.toPath(dir);
          return dirPath === rootPath || canWatchDirectory(dirPath);
        }
      }
      ts2.createResolutionCache = createResolutionCache;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var moduleSpecifiers;
      (function(moduleSpecifiers2) {
        var RelativePreference;
        (function(RelativePreference2) {
          RelativePreference2[RelativePreference2["Relative"] = 0] = "Relative";
          RelativePreference2[RelativePreference2["NonRelative"] = 1] = "NonRelative";
          RelativePreference2[RelativePreference2["Auto"] = 2] = "Auto";
        })(RelativePreference || (RelativePreference = {}));
        var Ending;
        (function(Ending2) {
          Ending2[Ending2["Minimal"] = 0] = "Minimal";
          Ending2[Ending2["Index"] = 1] = "Index";
          Ending2[Ending2["JsExtension"] = 2] = "JsExtension";
        })(Ending || (Ending = {}));
        function getPreferences(_a, compilerOptions, importingSourceFile) {
          var importModuleSpecifierPreference = _a.importModuleSpecifierPreference, importModuleSpecifierEnding = _a.importModuleSpecifierEnding;
          return {
            relativePreference: importModuleSpecifierPreference === "relative" ? 0 : importModuleSpecifierPreference === "non-relative" ? 1 : 2,
            ending: getEnding()
          };
          function getEnding() {
            switch (importModuleSpecifierEnding) {
              case "minimal":
                return 0;
              case "index":
                return 1;
              case "js":
                return 2;
              default:
                return usesJsExtensionOnImports(importingSourceFile) ? 2 : ts2.getEmitModuleResolutionKind(compilerOptions) !== ts2.ModuleResolutionKind.NodeJs ? 1 : 0;
            }
          }
        }
        function getPreferencesForUpdate(compilerOptions, oldImportSpecifier) {
          return {
            relativePreference: ts2.isExternalModuleNameRelative(oldImportSpecifier) ? 0 : 1,
            ending: ts2.hasJSFileExtension(oldImportSpecifier) ? 2 : ts2.getEmitModuleResolutionKind(compilerOptions) !== ts2.ModuleResolutionKind.NodeJs || ts2.endsWith(oldImportSpecifier, "index") ? 1 : 0
          };
        }
        function updateModuleSpecifier(compilerOptions, importingSourceFileName, toFileName, host, oldImportSpecifier) {
          var res = getModuleSpecifierWorker(compilerOptions, importingSourceFileName, toFileName, host, getPreferencesForUpdate(compilerOptions, oldImportSpecifier));
          if (res === oldImportSpecifier)
            return void 0;
          return res;
        }
        moduleSpecifiers2.updateModuleSpecifier = updateModuleSpecifier;
        function getModuleSpecifier(compilerOptions, importingSourceFile, importingSourceFileName, toFileName, host, preferences) {
          if (preferences === void 0) {
            preferences = {};
          }
          return getModuleSpecifierWorker(compilerOptions, importingSourceFileName, toFileName, host, getPreferences(preferences, compilerOptions, importingSourceFile));
        }
        moduleSpecifiers2.getModuleSpecifier = getModuleSpecifier;
        function getNodeModulesPackageName(compilerOptions, importingSourceFileName, nodeModulesFileName, host) {
          var info = getInfo(importingSourceFileName, host);
          var modulePaths = getAllModulePaths(importingSourceFileName, nodeModulesFileName, host);
          return ts2.firstDefined(modulePaths, function(moduleFileName) {
            return tryGetModuleNameAsNodeModule(moduleFileName, info, host, compilerOptions, true);
          });
        }
        moduleSpecifiers2.getNodeModulesPackageName = getNodeModulesPackageName;
        function getModuleSpecifierWorker(compilerOptions, importingSourceFileName, toFileName, host, preferences) {
          var info = getInfo(importingSourceFileName, host);
          var modulePaths = getAllModulePaths(importingSourceFileName, toFileName, host);
          return ts2.firstDefined(modulePaths, function(moduleFileName) {
            return tryGetModuleNameAsNodeModule(moduleFileName, info, host, compilerOptions);
          }) || getLocalModuleSpecifier(toFileName, info, compilerOptions, preferences);
        }
        function getModuleSpecifiers(moduleSymbol, compilerOptions, importingSourceFile, host, userPreferences) {
          var ambient = tryGetModuleNameFromAmbientModule(moduleSymbol);
          if (ambient)
            return [ambient];
          var info = getInfo(importingSourceFile.path, host);
          var moduleSourceFile = ts2.getSourceFileOfNode(moduleSymbol.valueDeclaration || ts2.getNonAugmentationDeclaration(moduleSymbol));
          var modulePaths = getAllModulePaths(importingSourceFile.path, moduleSourceFile.originalFileName, host);
          var preferences = getPreferences(userPreferences, compilerOptions, importingSourceFile);
          var global2 = ts2.mapDefined(modulePaths, function(moduleFileName) {
            return tryGetModuleNameAsNodeModule(moduleFileName, info, host, compilerOptions);
          });
          return global2.length ? global2 : modulePaths.map(function(moduleFileName) {
            return getLocalModuleSpecifier(moduleFileName, info, compilerOptions, preferences);
          });
        }
        moduleSpecifiers2.getModuleSpecifiers = getModuleSpecifiers;
        function getInfo(importingSourceFileName, host) {
          var getCanonicalFileName = ts2.createGetCanonicalFileName(host.useCaseSensitiveFileNames ? host.useCaseSensitiveFileNames() : true);
          var sourceDirectory = ts2.getDirectoryPath(importingSourceFileName);
          return { getCanonicalFileName, sourceDirectory };
        }
        function getLocalModuleSpecifier(moduleFileName, _a, compilerOptions, _b) {
          var getCanonicalFileName = _a.getCanonicalFileName, sourceDirectory = _a.sourceDirectory;
          var ending = _b.ending, relativePreference = _b.relativePreference;
          var baseUrl = compilerOptions.baseUrl, paths = compilerOptions.paths, rootDirs = compilerOptions.rootDirs;
          var relativePath = rootDirs && tryGetModuleNameFromRootDirs(rootDirs, moduleFileName, sourceDirectory, getCanonicalFileName, ending, compilerOptions) || removeExtensionAndIndexPostFix(ts2.ensurePathIsNonModuleName(ts2.getRelativePathFromDirectory(sourceDirectory, moduleFileName, getCanonicalFileName)), ending, compilerOptions);
          if (!baseUrl || relativePreference === 0) {
            return relativePath;
          }
          var relativeToBaseUrl = getRelativePathIfInDirectory(moduleFileName, baseUrl, getCanonicalFileName);
          if (!relativeToBaseUrl) {
            return relativePath;
          }
          var importRelativeToBaseUrl = removeExtensionAndIndexPostFix(relativeToBaseUrl, ending, compilerOptions);
          var fromPaths = paths && tryGetModuleNameFromPaths(ts2.removeFileExtension(relativeToBaseUrl), importRelativeToBaseUrl, paths);
          var nonRelative = fromPaths === void 0 ? importRelativeToBaseUrl : fromPaths;
          if (relativePreference === 1) {
            return nonRelative;
          }
          if (relativePreference !== 2)
            ts2.Debug.assertNever(relativePreference);
          return isPathRelativeToParent(nonRelative) || countPathComponents(relativePath) < countPathComponents(nonRelative) ? relativePath : nonRelative;
        }
        function countPathComponents(path2) {
          var count = 0;
          for (var i = ts2.startsWith(path2, "./") ? 2 : 0; i < path2.length; i++) {
            if (path2.charCodeAt(i) === 47)
              count++;
          }
          return count;
        }
        moduleSpecifiers2.countPathComponents = countPathComponents;
        function usesJsExtensionOnImports(_a) {
          var imports = _a.imports;
          return ts2.firstDefined(imports, function(_a2) {
            var text = _a2.text;
            return ts2.pathIsRelative(text) ? ts2.hasJSFileExtension(text) : void 0;
          }) || false;
        }
        function numberOfDirectorySeparators(str) {
          var match = str.match(/\//g);
          return match ? match.length : 0;
        }
        function comparePathsByNumberOfDirectorySeparators(a, b) {
          return ts2.compareValues(numberOfDirectorySeparators(a), numberOfDirectorySeparators(b));
        }
        function forEachFileNameOfModule(importingFileName, importedFileName, host, preferSymlinks, cb) {
          var getCanonicalFileName = ts2.hostGetCanonicalFileName(host);
          var cwd = host.getCurrentDirectory();
          var referenceRedirect = host.isSourceOfProjectReferenceRedirect(importedFileName) ? host.getProjectReferenceRedirect(importedFileName) : void 0;
          var redirects = host.redirectTargetsMap.get(ts2.toPath(importedFileName, cwd, getCanonicalFileName)) || ts2.emptyArray;
          var importedFileNames = __spreadArrays(referenceRedirect ? [referenceRedirect] : ts2.emptyArray, [importedFileName], redirects);
          var targets = importedFileNames.map(function(f) {
            return ts2.getNormalizedAbsolutePath(f, cwd);
          });
          if (!preferSymlinks) {
            var result_12 = ts2.forEach(targets, cb);
            if (result_12)
              return result_12;
          }
          var links = host.getProbableSymlinks ? host.getProbableSymlinks(host.getSourceFiles()) : ts2.discoverProbableSymlinks(host.getSourceFiles(), getCanonicalFileName, cwd);
          var compareStrings = !host.useCaseSensitiveFileNames || host.useCaseSensitiveFileNames() ? ts2.compareStringsCaseSensitive : ts2.compareStringsCaseInsensitive;
          var result = ts2.forEachEntry(links, function(resolved, path2) {
            if (ts2.startsWithDirectory(importingFileName, resolved, getCanonicalFileName)) {
              return void 0;
            }
            var target = ts2.find(targets, function(t) {
              return compareStrings(t.slice(0, resolved.length + 1), resolved + "/") === 0;
            });
            if (target === void 0)
              return void 0;
            var relative = ts2.getRelativePathFromDirectory(resolved, target, getCanonicalFileName);
            var option = ts2.resolvePath(path2, relative);
            if (!host.fileExists || host.fileExists(option)) {
              var result_13 = cb(option);
              if (result_13)
                return result_13;
            }
          });
          return result || (preferSymlinks ? ts2.forEach(targets, cb) : void 0);
        }
        moduleSpecifiers2.forEachFileNameOfModule = forEachFileNameOfModule;
        function getAllModulePaths(importingFileName, importedFileName, host) {
          var cwd = host.getCurrentDirectory();
          var getCanonicalFileName = ts2.hostGetCanonicalFileName(host);
          var allFileNames = ts2.createMap();
          var importedFileFromNodeModules = false;
          forEachFileNameOfModule(importingFileName, importedFileName, host, true, function(path2) {
            allFileNames.set(path2, getCanonicalFileName(path2));
            importedFileFromNodeModules = importedFileFromNodeModules || ts2.pathContainsNodeModules(path2);
          });
          var sortedPaths = [];
          var _loop_20 = function(directory2) {
            var directoryStart = ts2.ensureTrailingDirectorySeparator(directory2);
            var pathsInDirectory;
            allFileNames.forEach(function(canonicalFileName, fileName) {
              if (ts2.startsWith(canonicalFileName, directoryStart)) {
                if (!importedFileFromNodeModules || ts2.pathContainsNodeModules(fileName)) {
                  (pathsInDirectory || (pathsInDirectory = [])).push(fileName);
                }
                allFileNames.delete(fileName);
              }
            });
            if (pathsInDirectory) {
              if (pathsInDirectory.length > 1) {
                pathsInDirectory.sort(comparePathsByNumberOfDirectorySeparators);
              }
              sortedPaths.push.apply(sortedPaths, pathsInDirectory);
            }
            var newDirectory = ts2.getDirectoryPath(directory2);
            if (newDirectory === directory2)
              return out_directory_1 = directory2, "break";
            directory2 = newDirectory;
            out_directory_1 = directory2;
          };
          var out_directory_1;
          for (var directory = ts2.getDirectoryPath(ts2.toPath(importingFileName, cwd, getCanonicalFileName)); allFileNames.size !== 0; ) {
            var state_8 = _loop_20(directory);
            directory = out_directory_1;
            if (state_8 === "break")
              break;
          }
          if (allFileNames.size) {
            var remainingPaths = ts2.arrayFrom(allFileNames.values());
            if (remainingPaths.length > 1)
              remainingPaths.sort(comparePathsByNumberOfDirectorySeparators);
            sortedPaths.push.apply(sortedPaths, remainingPaths);
          }
          return sortedPaths;
        }
        function tryGetModuleNameFromAmbientModule(moduleSymbol) {
          var decl = ts2.find(moduleSymbol.declarations, function(d) {
            return ts2.isNonGlobalAmbientModule(d) && (!ts2.isExternalModuleAugmentation(d) || !ts2.isExternalModuleNameRelative(ts2.getTextOfIdentifierOrLiteral(d.name)));
          });
          if (decl) {
            return decl.name.text;
          }
        }
        function tryGetModuleNameFromPaths(relativeToBaseUrlWithIndex, relativeToBaseUrl, paths) {
          for (var key in paths) {
            for (var _i = 0, _a = paths[key]; _i < _a.length; _i++) {
              var patternText_1 = _a[_i];
              var pattern = ts2.removeFileExtension(ts2.normalizePath(patternText_1));
              var indexOfStar = pattern.indexOf("*");
              if (indexOfStar !== -1) {
                var prefix = pattern.substr(0, indexOfStar);
                var suffix = pattern.substr(indexOfStar + 1);
                if (relativeToBaseUrl.length >= prefix.length + suffix.length && ts2.startsWith(relativeToBaseUrl, prefix) && ts2.endsWith(relativeToBaseUrl, suffix) || !suffix && relativeToBaseUrl === ts2.removeTrailingDirectorySeparator(prefix)) {
                  var matchedStar = relativeToBaseUrl.substr(prefix.length, relativeToBaseUrl.length - suffix.length);
                  return key.replace("*", matchedStar);
                }
              } else if (pattern === relativeToBaseUrl || pattern === relativeToBaseUrlWithIndex) {
                return key;
              }
            }
          }
        }
        function tryGetModuleNameFromRootDirs(rootDirs, moduleFileName, sourceDirectory, getCanonicalFileName, ending, compilerOptions) {
          var normalizedTargetPath = getPathRelativeToRootDirs(moduleFileName, rootDirs, getCanonicalFileName);
          if (normalizedTargetPath === void 0) {
            return void 0;
          }
          var normalizedSourcePath = getPathRelativeToRootDirs(sourceDirectory, rootDirs, getCanonicalFileName);
          var relativePath = normalizedSourcePath !== void 0 ? ts2.ensurePathIsNonModuleName(ts2.getRelativePathFromDirectory(normalizedSourcePath, normalizedTargetPath, getCanonicalFileName)) : normalizedTargetPath;
          return ts2.getEmitModuleResolutionKind(compilerOptions) === ts2.ModuleResolutionKind.NodeJs ? removeExtensionAndIndexPostFix(relativePath, ending, compilerOptions) : ts2.removeFileExtension(relativePath);
        }
        function tryGetModuleNameAsNodeModule(moduleFileName, _a, host, options, packageNameOnly) {
          var getCanonicalFileName = _a.getCanonicalFileName, sourceDirectory = _a.sourceDirectory;
          if (!host.fileExists || !host.readFile) {
            return void 0;
          }
          var parts = getNodeModulePathParts(moduleFileName);
          if (!parts) {
            return void 0;
          }
          var moduleSpecifier = moduleFileName;
          if (!packageNameOnly) {
            var packageRootIndex = parts.packageRootIndex;
            var moduleFileNameForExtensionless = void 0;
            while (true) {
              var _b = tryDirectoryWithPackageJson(packageRootIndex), moduleFileToTry = _b.moduleFileToTry, packageRootPath = _b.packageRootPath;
              if (packageRootPath) {
                moduleSpecifier = packageRootPath;
                break;
              }
              if (!moduleFileNameForExtensionless)
                moduleFileNameForExtensionless = moduleFileToTry;
              packageRootIndex = moduleFileName.indexOf(ts2.directorySeparator, packageRootIndex + 1);
              if (packageRootIndex === -1) {
                moduleSpecifier = getExtensionlessFileName(moduleFileNameForExtensionless);
                break;
              }
            }
          }
          var globalTypingsCacheLocation = host.getGlobalTypingsCacheLocation && host.getGlobalTypingsCacheLocation();
          var pathToTopLevelNodeModules = getCanonicalFileName(moduleSpecifier.substring(0, parts.topLevelNodeModulesIndex));
          if (!(ts2.startsWith(sourceDirectory, pathToTopLevelNodeModules) || globalTypingsCacheLocation && ts2.startsWith(getCanonicalFileName(globalTypingsCacheLocation), pathToTopLevelNodeModules))) {
            return void 0;
          }
          var nodeModulesDirectoryName = moduleSpecifier.substring(parts.topLevelPackageNameIndex + 1);
          var packageName = ts2.getPackageNameFromTypesPackageName(nodeModulesDirectoryName);
          return ts2.getEmitModuleResolutionKind(options) !== ts2.ModuleResolutionKind.NodeJs && packageName === nodeModulesDirectoryName ? void 0 : packageName;
          function tryDirectoryWithPackageJson(packageRootIndex2) {
            var packageRootPath2 = moduleFileName.substring(0, packageRootIndex2);
            var packageJsonPath = ts2.combinePaths(packageRootPath2, "package.json");
            var moduleFileToTry2 = moduleFileName;
            if (host.fileExists(packageJsonPath)) {
              var packageJsonContent = JSON.parse(host.readFile(packageJsonPath));
              var versionPaths = packageJsonContent.typesVersions ? ts2.getPackageJsonTypesVersionsPaths(packageJsonContent.typesVersions) : void 0;
              if (versionPaths) {
                var subModuleName = moduleFileName.slice(packageRootPath2.length + 1);
                var fromPaths = tryGetModuleNameFromPaths(ts2.removeFileExtension(subModuleName), removeExtensionAndIndexPostFix(subModuleName, 0, options), versionPaths.paths);
                if (fromPaths !== void 0) {
                  moduleFileToTry2 = ts2.combinePaths(packageRootPath2, fromPaths);
                }
              }
              var mainFileRelative = packageJsonContent.typings || packageJsonContent.types || packageJsonContent.main;
              if (ts2.isString(mainFileRelative)) {
                var mainExportFile = ts2.toPath(mainFileRelative, packageRootPath2, getCanonicalFileName);
                if (ts2.removeFileExtension(mainExportFile) === ts2.removeFileExtension(getCanonicalFileName(moduleFileToTry2))) {
                  return { packageRootPath: packageRootPath2, moduleFileToTry: moduleFileToTry2 };
                }
              }
            }
            return { moduleFileToTry: moduleFileToTry2 };
          }
          function getExtensionlessFileName(path2) {
            var fullModulePathWithoutExtension = ts2.removeFileExtension(path2);
            if (getCanonicalFileName(fullModulePathWithoutExtension.substring(parts.fileNameIndex)) === "/index" && !tryGetAnyFileFromPath(host, fullModulePathWithoutExtension.substring(0, parts.fileNameIndex))) {
              return fullModulePathWithoutExtension.substring(0, parts.fileNameIndex);
            }
            return fullModulePathWithoutExtension;
          }
        }
        function tryGetAnyFileFromPath(host, path2) {
          if (!host.fileExists)
            return;
          var extensions = ts2.getSupportedExtensions({ allowJs: true }, [{ extension: "node", isMixedContent: false }, { extension: "json", isMixedContent: false, scriptKind: 6 }]);
          for (var _i = 0, extensions_3 = extensions; _i < extensions_3.length; _i++) {
            var e = extensions_3[_i];
            var fullPath = path2 + e;
            if (host.fileExists(fullPath)) {
              return fullPath;
            }
          }
        }
        function getNodeModulePathParts(fullPath) {
          var topLevelNodeModulesIndex = 0;
          var topLevelPackageNameIndex = 0;
          var packageRootIndex = 0;
          var fileNameIndex = 0;
          var States;
          (function(States2) {
            States2[States2["BeforeNodeModules"] = 0] = "BeforeNodeModules";
            States2[States2["NodeModules"] = 1] = "NodeModules";
            States2[States2["Scope"] = 2] = "Scope";
            States2[States2["PackageContent"] = 3] = "PackageContent";
          })(States || (States = {}));
          var partStart = 0;
          var partEnd = 0;
          var state = 0;
          while (partEnd >= 0) {
            partStart = partEnd;
            partEnd = fullPath.indexOf("/", partStart + 1);
            switch (state) {
              case 0:
                if (fullPath.indexOf(ts2.nodeModulesPathPart, partStart) === partStart) {
                  topLevelNodeModulesIndex = partStart;
                  topLevelPackageNameIndex = partEnd;
                  state = 1;
                }
                break;
              case 1:
              case 2:
                if (state === 1 && fullPath.charAt(partStart + 1) === "@") {
                  state = 2;
                } else {
                  packageRootIndex = partEnd;
                  state = 3;
                }
                break;
              case 3:
                if (fullPath.indexOf(ts2.nodeModulesPathPart, partStart) === partStart) {
                  state = 1;
                } else {
                  state = 3;
                }
                break;
            }
          }
          fileNameIndex = partStart;
          return state > 1 ? { topLevelNodeModulesIndex, topLevelPackageNameIndex, packageRootIndex, fileNameIndex } : void 0;
        }
        function getPathRelativeToRootDirs(path2, rootDirs, getCanonicalFileName) {
          return ts2.firstDefined(rootDirs, function(rootDir) {
            var relativePath = getRelativePathIfInDirectory(path2, rootDir, getCanonicalFileName);
            return isPathRelativeToParent(relativePath) ? void 0 : relativePath;
          });
        }
        function removeExtensionAndIndexPostFix(fileName, ending, options) {
          if (ts2.fileExtensionIs(fileName, ".json"))
            return fileName;
          var noExtension = ts2.removeFileExtension(fileName);
          switch (ending) {
            case 0:
              return ts2.removeSuffix(noExtension, "/index");
            case 1:
              return noExtension;
            case 2:
              return noExtension + getJSExtensionForFile(fileName, options);
            default:
              return ts2.Debug.assertNever(ending);
          }
        }
        function getJSExtensionForFile(fileName, options) {
          var ext = ts2.extensionFromPath(fileName);
          switch (ext) {
            case ".ts":
            case ".d.ts":
              return ".js";
            case ".tsx":
              return options.jsx === 1 ? ".jsx" : ".js";
            case ".js":
            case ".jsx":
            case ".json":
              return ext;
            case ".tsbuildinfo":
              return ts2.Debug.fail("Extension .tsbuildinfo is unsupported:: FileName:: " + fileName);
            default:
              return ts2.Debug.assertNever(ext);
          }
        }
        function getRelativePathIfInDirectory(path2, directoryPath, getCanonicalFileName) {
          var relativePath = ts2.getRelativePathToDirectoryOrUrl(directoryPath, path2, directoryPath, getCanonicalFileName, false);
          return ts2.isRootedDiskPath(relativePath) ? void 0 : relativePath;
        }
        function isPathRelativeToParent(path2) {
          return ts2.startsWith(path2, "..");
        }
      })(moduleSpecifiers = ts2.moduleSpecifiers || (ts2.moduleSpecifiers = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var sysFormatDiagnosticsHost = ts2.sys ? {
        getCurrentDirectory: function() {
          return ts2.sys.getCurrentDirectory();
        },
        getNewLine: function() {
          return ts2.sys.newLine;
        },
        getCanonicalFileName: ts2.createGetCanonicalFileName(ts2.sys.useCaseSensitiveFileNames)
      } : void 0;
      function createDiagnosticReporter(system, pretty) {
        var host = system === ts2.sys ? sysFormatDiagnosticsHost : {
          getCurrentDirectory: function() {
            return system.getCurrentDirectory();
          },
          getNewLine: function() {
            return system.newLine;
          },
          getCanonicalFileName: ts2.createGetCanonicalFileName(system.useCaseSensitiveFileNames)
        };
        if (!pretty) {
          return function(diagnostic) {
            return system.write(ts2.formatDiagnostic(diagnostic, host));
          };
        }
        var diagnostics = new Array(1);
        return function(diagnostic) {
          diagnostics[0] = diagnostic;
          system.write(ts2.formatDiagnosticsWithColorAndContext(diagnostics, host) + host.getNewLine());
          diagnostics[0] = void 0;
        };
      }
      ts2.createDiagnosticReporter = createDiagnosticReporter;
      function clearScreenIfNotWatchingForFileChanges(system, diagnostic, options) {
        if (system.clearScreen && !options.preserveWatchOutput && !options.extendedDiagnostics && !options.diagnostics && ts2.contains(ts2.screenStartingMessageCodes, diagnostic.code)) {
          system.clearScreen();
          return true;
        }
        return false;
      }
      ts2.screenStartingMessageCodes = [
        ts2.Diagnostics.Starting_compilation_in_watch_mode.code,
        ts2.Diagnostics.File_change_detected_Starting_incremental_compilation.code
      ];
      function getPlainDiagnosticFollowingNewLines(diagnostic, newLine) {
        return ts2.contains(ts2.screenStartingMessageCodes, diagnostic.code) ? newLine + newLine : newLine;
      }
      function getLocaleTimeString(system) {
        return !system.now ? new Date().toLocaleTimeString() : system.now().toLocaleTimeString("en-US", { timeZone: "UTC" });
      }
      ts2.getLocaleTimeString = getLocaleTimeString;
      function createWatchStatusReporter(system, pretty) {
        return pretty ? function(diagnostic, newLine, options) {
          clearScreenIfNotWatchingForFileChanges(system, diagnostic, options);
          var output = "[" + ts2.formatColorAndReset(getLocaleTimeString(system), ts2.ForegroundColorEscapeSequences.Grey) + "] ";
          output += "" + ts2.flattenDiagnosticMessageText(diagnostic.messageText, system.newLine) + (newLine + newLine);
          system.write(output);
        } : function(diagnostic, newLine, options) {
          var output = "";
          if (!clearScreenIfNotWatchingForFileChanges(system, diagnostic, options)) {
            output += newLine;
          }
          output += getLocaleTimeString(system) + " - ";
          output += "" + ts2.flattenDiagnosticMessageText(diagnostic.messageText, system.newLine) + getPlainDiagnosticFollowingNewLines(diagnostic, newLine);
          system.write(output);
        };
      }
      ts2.createWatchStatusReporter = createWatchStatusReporter;
      function parseConfigFileWithSystem(configFileName, optionsToExtend, watchOptionsToExtend, system, reportDiagnostic) {
        var host = system;
        host.onUnRecoverableConfigFileDiagnostic = function(diagnostic) {
          return reportUnrecoverableDiagnostic(system, reportDiagnostic, diagnostic);
        };
        var result = ts2.getParsedCommandLineOfConfigFile(configFileName, optionsToExtend, host, void 0, watchOptionsToExtend);
        host.onUnRecoverableConfigFileDiagnostic = void 0;
        return result;
      }
      ts2.parseConfigFileWithSystem = parseConfigFileWithSystem;
      function getErrorCountForSummary(diagnostics) {
        return ts2.countWhere(diagnostics, function(diagnostic) {
          return diagnostic.category === ts2.DiagnosticCategory.Error;
        });
      }
      ts2.getErrorCountForSummary = getErrorCountForSummary;
      function getWatchErrorSummaryDiagnosticMessage(errorCount) {
        return errorCount === 1 ? ts2.Diagnostics.Found_1_error_Watching_for_file_changes : ts2.Diagnostics.Found_0_errors_Watching_for_file_changes;
      }
      ts2.getWatchErrorSummaryDiagnosticMessage = getWatchErrorSummaryDiagnosticMessage;
      function getErrorSummaryText(errorCount, newLine) {
        if (errorCount === 0)
          return "";
        var d = ts2.createCompilerDiagnostic(errorCount === 1 ? ts2.Diagnostics.Found_1_error : ts2.Diagnostics.Found_0_errors, errorCount);
        return "" + newLine + ts2.flattenDiagnosticMessageText(d.messageText, newLine) + newLine + newLine;
      }
      ts2.getErrorSummaryText = getErrorSummaryText;
      function listFiles(program, writeFileName) {
        if (program.getCompilerOptions().listFiles || program.getCompilerOptions().listFilesOnly) {
          ts2.forEach(program.getSourceFiles(), function(file) {
            writeFileName(file.fileName);
          });
        }
      }
      ts2.listFiles = listFiles;
      function emitFilesAndReportErrors(program, reportDiagnostic, writeFileName, reportSummary, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers) {
        var isListFilesOnly = !!program.getCompilerOptions().listFilesOnly;
        var allDiagnostics = program.getConfigFileParsingDiagnostics().slice();
        var configFileParsingDiagnosticsLength = allDiagnostics.length;
        ts2.addRange(allDiagnostics, program.getSyntacticDiagnostics(void 0, cancellationToken));
        if (allDiagnostics.length === configFileParsingDiagnosticsLength) {
          ts2.addRange(allDiagnostics, program.getOptionsDiagnostics(cancellationToken));
          if (!isListFilesOnly) {
            ts2.addRange(allDiagnostics, program.getGlobalDiagnostics(cancellationToken));
            if (allDiagnostics.length === configFileParsingDiagnosticsLength) {
              ts2.addRange(allDiagnostics, program.getSemanticDiagnostics(void 0, cancellationToken));
            }
          }
        }
        var emitResult = isListFilesOnly ? { emitSkipped: true, diagnostics: ts2.emptyArray } : program.emit(void 0, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers);
        var emittedFiles = emitResult.emittedFiles, emitDiagnostics = emitResult.diagnostics;
        ts2.addRange(allDiagnostics, emitDiagnostics);
        var diagnostics = ts2.sortAndDeduplicateDiagnostics(allDiagnostics);
        diagnostics.forEach(reportDiagnostic);
        if (writeFileName) {
          var currentDir_1 = program.getCurrentDirectory();
          ts2.forEach(emittedFiles, function(file) {
            var filepath = ts2.getNormalizedAbsolutePath(file, currentDir_1);
            writeFileName("TSFILE: " + filepath);
          });
          listFiles(program, writeFileName);
        }
        if (reportSummary) {
          reportSummary(getErrorCountForSummary(diagnostics));
        }
        return {
          emitResult,
          diagnostics
        };
      }
      ts2.emitFilesAndReportErrors = emitFilesAndReportErrors;
      function emitFilesAndReportErrorsAndGetExitStatus(program, reportDiagnostic, writeFileName, reportSummary, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers) {
        var _a = emitFilesAndReportErrors(program, reportDiagnostic, writeFileName, reportSummary, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers), emitResult = _a.emitResult, diagnostics = _a.diagnostics;
        if (emitResult.emitSkipped && diagnostics.length > 0) {
          return ts2.ExitStatus.DiagnosticsPresent_OutputsSkipped;
        } else if (diagnostics.length > 0) {
          return ts2.ExitStatus.DiagnosticsPresent_OutputsGenerated;
        }
        return ts2.ExitStatus.Success;
      }
      ts2.emitFilesAndReportErrorsAndGetExitStatus = emitFilesAndReportErrorsAndGetExitStatus;
      ts2.noopFileWatcher = { close: ts2.noop };
      function createWatchHost(system, reportWatchStatus) {
        if (system === void 0) {
          system = ts2.sys;
        }
        var onWatchStatusChange = reportWatchStatus || createWatchStatusReporter(system);
        return {
          onWatchStatusChange,
          watchFile: ts2.maybeBind(system, system.watchFile) || function() {
            return ts2.noopFileWatcher;
          },
          watchDirectory: ts2.maybeBind(system, system.watchDirectory) || function() {
            return ts2.noopFileWatcher;
          },
          setTimeout: ts2.maybeBind(system, system.setTimeout) || ts2.noop,
          clearTimeout: ts2.maybeBind(system, system.clearTimeout) || ts2.noop
        };
      }
      ts2.createWatchHost = createWatchHost;
      ts2.WatchType = {
        ConfigFile: "Config file",
        SourceFile: "Source file",
        MissingFile: "Missing file",
        WildcardDirectory: "Wild card directory",
        FailedLookupLocations: "Failed Lookup Locations",
        TypeRoots: "Type roots"
      };
      function createWatchFactory(host, options) {
        var watchLogLevel = host.trace ? options.extendedDiagnostics ? ts2.WatchLogLevel.Verbose : options.diagnostics ? ts2.WatchLogLevel.TriggerOnly : ts2.WatchLogLevel.None : ts2.WatchLogLevel.None;
        var writeLog = watchLogLevel !== ts2.WatchLogLevel.None ? function(s) {
          return host.trace(s);
        } : ts2.noop;
        var result = ts2.getWatchFactory(watchLogLevel, writeLog);
        result.writeLog = writeLog;
        return result;
      }
      ts2.createWatchFactory = createWatchFactory;
      function createCompilerHostFromProgramHost(host, getCompilerOptions, directoryStructureHost) {
        if (directoryStructureHost === void 0) {
          directoryStructureHost = host;
        }
        var useCaseSensitiveFileNames = host.useCaseSensitiveFileNames();
        var hostGetNewLine = ts2.memoize(function() {
          return host.getNewLine();
        });
        return {
          getSourceFile: function(fileName, languageVersion, onError) {
            var text;
            try {
              ts2.performance.mark("beforeIORead");
              text = host.readFile(fileName, getCompilerOptions().charset);
              ts2.performance.mark("afterIORead");
              ts2.performance.measure("I/O Read", "beforeIORead", "afterIORead");
            } catch (e) {
              if (onError) {
                onError(e.message);
              }
              text = "";
            }
            return text !== void 0 ? ts2.createSourceFile(fileName, text, languageVersion) : void 0;
          },
          getDefaultLibLocation: ts2.maybeBind(host, host.getDefaultLibLocation),
          getDefaultLibFileName: function(options) {
            return host.getDefaultLibFileName(options);
          },
          writeFile,
          getCurrentDirectory: ts2.memoize(function() {
            return host.getCurrentDirectory();
          }),
          useCaseSensitiveFileNames: function() {
            return useCaseSensitiveFileNames;
          },
          getCanonicalFileName: ts2.createGetCanonicalFileName(useCaseSensitiveFileNames),
          getNewLine: function() {
            return ts2.getNewLineCharacter(getCompilerOptions(), hostGetNewLine);
          },
          fileExists: function(f) {
            return host.fileExists(f);
          },
          readFile: function(f) {
            return host.readFile(f);
          },
          trace: ts2.maybeBind(host, host.trace),
          directoryExists: ts2.maybeBind(directoryStructureHost, directoryStructureHost.directoryExists),
          getDirectories: ts2.maybeBind(directoryStructureHost, directoryStructureHost.getDirectories),
          realpath: ts2.maybeBind(host, host.realpath),
          getEnvironmentVariable: ts2.maybeBind(host, host.getEnvironmentVariable) || function() {
            return "";
          },
          createHash: ts2.maybeBind(host, host.createHash),
          readDirectory: ts2.maybeBind(host, host.readDirectory)
        };
        function writeFile(fileName, text, writeByteOrderMark, onError) {
          try {
            ts2.performance.mark("beforeIOWrite");
            ts2.writeFileEnsuringDirectories(fileName, text, writeByteOrderMark, function(path2, data, writeByteOrderMark2) {
              return host.writeFile(path2, data, writeByteOrderMark2);
            }, function(path2) {
              return host.createDirectory(path2);
            }, function(path2) {
              return host.directoryExists(path2);
            });
            ts2.performance.mark("afterIOWrite");
            ts2.performance.measure("I/O Write", "beforeIOWrite", "afterIOWrite");
          } catch (e) {
            if (onError) {
              onError(e.message);
            }
          }
        }
      }
      ts2.createCompilerHostFromProgramHost = createCompilerHostFromProgramHost;
      function setGetSourceFileAsHashVersioned(compilerHost, host) {
        var originalGetSourceFile = compilerHost.getSourceFile;
        var computeHash = host.createHash || ts2.generateDjb2Hash;
        compilerHost.getSourceFile = function() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          var result = originalGetSourceFile.call.apply(originalGetSourceFile, __spreadArrays([compilerHost], args));
          if (result) {
            result.version = computeHash.call(host, result.text);
          }
          return result;
        };
      }
      ts2.setGetSourceFileAsHashVersioned = setGetSourceFileAsHashVersioned;
      function createProgramHost(system, createProgram) {
        var getDefaultLibLocation = ts2.memoize(function() {
          return ts2.getDirectoryPath(ts2.normalizePath(system.getExecutingFilePath()));
        });
        return {
          useCaseSensitiveFileNames: function() {
            return system.useCaseSensitiveFileNames;
          },
          getNewLine: function() {
            return system.newLine;
          },
          getCurrentDirectory: ts2.memoize(function() {
            return system.getCurrentDirectory();
          }),
          getDefaultLibLocation,
          getDefaultLibFileName: function(options) {
            return ts2.combinePaths(getDefaultLibLocation(), ts2.getDefaultLibFileName(options));
          },
          fileExists: function(path2) {
            return system.fileExists(path2);
          },
          readFile: function(path2, encoding) {
            return system.readFile(path2, encoding);
          },
          directoryExists: function(path2) {
            return system.directoryExists(path2);
          },
          getDirectories: function(path2) {
            return system.getDirectories(path2);
          },
          readDirectory: function(path2, extensions, exclude, include, depth) {
            return system.readDirectory(path2, extensions, exclude, include, depth);
          },
          realpath: ts2.maybeBind(system, system.realpath),
          getEnvironmentVariable: ts2.maybeBind(system, system.getEnvironmentVariable),
          trace: function(s) {
            return system.write(s + system.newLine);
          },
          createDirectory: function(path2) {
            return system.createDirectory(path2);
          },
          writeFile: function(path2, data, writeByteOrderMark) {
            return system.writeFile(path2, data, writeByteOrderMark);
          },
          createHash: ts2.maybeBind(system, system.createHash),
          createProgram: createProgram || ts2.createEmitAndSemanticDiagnosticsBuilderProgram
        };
      }
      ts2.createProgramHost = createProgramHost;
      function createWatchCompilerHost(system, createProgram, reportDiagnostic, reportWatchStatus) {
        if (system === void 0) {
          system = ts2.sys;
        }
        var writeFileName = function(s) {
          return system.write(s + system.newLine);
        };
        var result = createProgramHost(system, createProgram);
        ts2.copyProperties(result, createWatchHost(system, reportWatchStatus));
        result.afterProgramCreate = function(builderProgram) {
          var compilerOptions = builderProgram.getCompilerOptions();
          var newLine = ts2.getNewLineCharacter(compilerOptions, function() {
            return system.newLine;
          });
          emitFilesAndReportErrors(builderProgram, reportDiagnostic, writeFileName, function(errorCount) {
            return result.onWatchStatusChange(ts2.createCompilerDiagnostic(getWatchErrorSummaryDiagnosticMessage(errorCount), errorCount), newLine, compilerOptions, errorCount);
          });
        };
        return result;
      }
      function reportUnrecoverableDiagnostic(system, reportDiagnostic, diagnostic) {
        reportDiagnostic(diagnostic);
        system.exit(ts2.ExitStatus.DiagnosticsPresent_OutputsSkipped);
      }
      function createWatchCompilerHostOfConfigFile(_a) {
        var configFileName = _a.configFileName, optionsToExtend = _a.optionsToExtend, watchOptionsToExtend = _a.watchOptionsToExtend, extraFileExtensions = _a.extraFileExtensions, system = _a.system, createProgram = _a.createProgram, reportDiagnostic = _a.reportDiagnostic, reportWatchStatus = _a.reportWatchStatus;
        var diagnosticReporter = reportDiagnostic || createDiagnosticReporter(system);
        var host = createWatchCompilerHost(system, createProgram, diagnosticReporter, reportWatchStatus);
        host.onUnRecoverableConfigFileDiagnostic = function(diagnostic) {
          return reportUnrecoverableDiagnostic(system, diagnosticReporter, diagnostic);
        };
        host.configFileName = configFileName;
        host.optionsToExtend = optionsToExtend;
        host.watchOptionsToExtend = watchOptionsToExtend;
        host.extraFileExtensions = extraFileExtensions;
        return host;
      }
      ts2.createWatchCompilerHostOfConfigFile = createWatchCompilerHostOfConfigFile;
      function createWatchCompilerHostOfFilesAndCompilerOptions(_a) {
        var rootFiles = _a.rootFiles, options = _a.options, watchOptions = _a.watchOptions, projectReferences = _a.projectReferences, system = _a.system, createProgram = _a.createProgram, reportDiagnostic = _a.reportDiagnostic, reportWatchStatus = _a.reportWatchStatus;
        var host = createWatchCompilerHost(system, createProgram, reportDiagnostic || createDiagnosticReporter(system), reportWatchStatus);
        host.rootFiles = rootFiles;
        host.options = options;
        host.watchOptions = watchOptions;
        host.projectReferences = projectReferences;
        return host;
      }
      ts2.createWatchCompilerHostOfFilesAndCompilerOptions = createWatchCompilerHostOfFilesAndCompilerOptions;
      function performIncrementalCompilation(input) {
        var system = input.system || ts2.sys;
        var host = input.host || (input.host = ts2.createIncrementalCompilerHost(input.options, system));
        var builderProgram = ts2.createIncrementalProgram(input);
        var exitStatus = emitFilesAndReportErrorsAndGetExitStatus(builderProgram, input.reportDiagnostic || createDiagnosticReporter(system), function(s) {
          return host.trace && host.trace(s);
        }, input.reportErrorSummary || input.options.pretty ? function(errorCount) {
          return system.write(getErrorSummaryText(errorCount, system.newLine));
        } : void 0);
        if (input.afterProgramEmitAndDiagnostics)
          input.afterProgramEmitAndDiagnostics(builderProgram);
        return exitStatus;
      }
      ts2.performIncrementalCompilation = performIncrementalCompilation;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function readBuilderProgram(compilerOptions, host) {
        if (compilerOptions.out || compilerOptions.outFile)
          return void 0;
        var buildInfoPath = ts2.getTsBuildInfoEmitOutputFilePath(compilerOptions);
        if (!buildInfoPath)
          return void 0;
        var content = host.readFile(buildInfoPath);
        if (!content)
          return void 0;
        var buildInfo = ts2.getBuildInfo(content);
        if (buildInfo.version !== ts2.version)
          return void 0;
        if (!buildInfo.program)
          return void 0;
        return ts2.createBuildProgramUsingProgramBuildInfo(buildInfo.program, buildInfoPath, host);
      }
      ts2.readBuilderProgram = readBuilderProgram;
      function createIncrementalCompilerHost(options, system) {
        if (system === void 0) {
          system = ts2.sys;
        }
        var host = ts2.createCompilerHostWorker(options, void 0, system);
        host.createHash = ts2.maybeBind(system, system.createHash);
        ts2.setGetSourceFileAsHashVersioned(host, system);
        ts2.changeCompilerHostLikeToUseCache(host, function(fileName) {
          return ts2.toPath(fileName, host.getCurrentDirectory(), host.getCanonicalFileName);
        });
        return host;
      }
      ts2.createIncrementalCompilerHost = createIncrementalCompilerHost;
      function createIncrementalProgram(_a) {
        var rootNames = _a.rootNames, options = _a.options, configFileParsingDiagnostics = _a.configFileParsingDiagnostics, projectReferences = _a.projectReferences, host = _a.host, createProgram = _a.createProgram;
        host = host || createIncrementalCompilerHost(options);
        createProgram = createProgram || ts2.createEmitAndSemanticDiagnosticsBuilderProgram;
        var oldProgram = readBuilderProgram(options, host);
        return createProgram(rootNames, options, host, oldProgram, configFileParsingDiagnostics, projectReferences);
      }
      ts2.createIncrementalProgram = createIncrementalProgram;
      function createWatchCompilerHost(rootFilesOrConfigFileName, options, system, createProgram, reportDiagnostic, reportWatchStatus, projectReferencesOrWatchOptionsToExtend, watchOptionsOrExtraFileExtensions) {
        if (ts2.isArray(rootFilesOrConfigFileName)) {
          return ts2.createWatchCompilerHostOfFilesAndCompilerOptions({
            rootFiles: rootFilesOrConfigFileName,
            options,
            watchOptions: watchOptionsOrExtraFileExtensions,
            projectReferences: projectReferencesOrWatchOptionsToExtend,
            system,
            createProgram,
            reportDiagnostic,
            reportWatchStatus
          });
        } else {
          return ts2.createWatchCompilerHostOfConfigFile({
            configFileName: rootFilesOrConfigFileName,
            optionsToExtend: options,
            watchOptionsToExtend: projectReferencesOrWatchOptionsToExtend,
            extraFileExtensions: watchOptionsOrExtraFileExtensions,
            system,
            createProgram,
            reportDiagnostic,
            reportWatchStatus
          });
        }
      }
      ts2.createWatchCompilerHost = createWatchCompilerHost;
      function createWatchProgram(host) {
        var builderProgram;
        var reloadLevel;
        var missingFilesMap;
        var watchedWildcardDirectories;
        var timerToUpdateProgram;
        var sourceFilesCache = ts2.createMap();
        var missingFilePathsRequestedForRelease;
        var hasChangedCompilerOptions = false;
        var hasChangedAutomaticTypeDirectiveNames = false;
        var useCaseSensitiveFileNames = host.useCaseSensitiveFileNames();
        var currentDirectory = host.getCurrentDirectory();
        var configFileName = host.configFileName, _a = host.optionsToExtend, optionsToExtendForConfigFile = _a === void 0 ? {} : _a, watchOptionsToExtend = host.watchOptionsToExtend, extraFileExtensions = host.extraFileExtensions, createProgram = host.createProgram;
        var rootFileNames = host.rootFiles, compilerOptions = host.options, watchOptions = host.watchOptions, projectReferences = host.projectReferences;
        var configFileSpecs;
        var configFileParsingDiagnostics;
        var canConfigFileJsonReportNoInputFiles = false;
        var hasChangedConfigFileParsingErrors = false;
        var cachedDirectoryStructureHost = configFileName === void 0 ? void 0 : ts2.createCachedDirectoryStructureHost(host, currentDirectory, useCaseSensitiveFileNames);
        var directoryStructureHost = cachedDirectoryStructureHost || host;
        var parseConfigFileHost = ts2.parseConfigHostFromCompilerHostLike(host, directoryStructureHost);
        var newLine = updateNewLine();
        if (configFileName && host.configFileParsingResult) {
          setConfigFileParsingResult(host.configFileParsingResult);
          newLine = updateNewLine();
        }
        reportWatchDiagnostic(ts2.Diagnostics.Starting_compilation_in_watch_mode);
        if (configFileName && !host.configFileParsingResult) {
          newLine = ts2.getNewLineCharacter(optionsToExtendForConfigFile, function() {
            return host.getNewLine();
          });
          ts2.Debug.assert(!rootFileNames);
          parseConfigFile();
          newLine = updateNewLine();
        }
        var _b = ts2.createWatchFactory(host, compilerOptions), watchFile = _b.watchFile, watchFilePath = _b.watchFilePath, watchDirectory = _b.watchDirectory, writeLog = _b.writeLog;
        var getCanonicalFileName = ts2.createGetCanonicalFileName(useCaseSensitiveFileNames);
        writeLog("Current directory: " + currentDirectory + " CaseSensitiveFileNames: " + useCaseSensitiveFileNames);
        var configFileWatcher;
        if (configFileName) {
          configFileWatcher = watchFile(host, configFileName, scheduleProgramReload, ts2.PollingInterval.High, watchOptions, ts2.WatchType.ConfigFile);
        }
        var compilerHost = ts2.createCompilerHostFromProgramHost(host, function() {
          return compilerOptions;
        }, directoryStructureHost);
        ts2.setGetSourceFileAsHashVersioned(compilerHost, host);
        var getNewSourceFile = compilerHost.getSourceFile;
        compilerHost.getSourceFile = function(fileName) {
          var args = [];
          for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
          }
          return getVersionedSourceFileByPath.apply(void 0, __spreadArrays([fileName, toPath(fileName)], args));
        };
        compilerHost.getSourceFileByPath = getVersionedSourceFileByPath;
        compilerHost.getNewLine = function() {
          return newLine;
        };
        compilerHost.fileExists = fileExists;
        compilerHost.onReleaseOldSourceFile = onReleaseOldSourceFile;
        compilerHost.toPath = toPath;
        compilerHost.getCompilationSettings = function() {
          return compilerOptions;
        };
        compilerHost.useSourceOfProjectReferenceRedirect = ts2.maybeBind(host, host.useSourceOfProjectReferenceRedirect);
        compilerHost.watchDirectoryOfFailedLookupLocation = function(dir, cb, flags) {
          return watchDirectory(host, dir, cb, flags, watchOptions, ts2.WatchType.FailedLookupLocations);
        };
        compilerHost.watchTypeRootsDirectory = function(dir, cb, flags) {
          return watchDirectory(host, dir, cb, flags, watchOptions, ts2.WatchType.TypeRoots);
        };
        compilerHost.getCachedDirectoryStructureHost = function() {
          return cachedDirectoryStructureHost;
        };
        compilerHost.onInvalidatedResolution = scheduleProgramUpdate;
        compilerHost.onChangedAutomaticTypeDirectiveNames = function() {
          hasChangedAutomaticTypeDirectiveNames = true;
          scheduleProgramUpdate();
        };
        compilerHost.fileIsOpen = ts2.returnFalse;
        compilerHost.getCurrentProgram = getCurrentProgram;
        compilerHost.writeLog = writeLog;
        var resolutionCache = ts2.createResolutionCache(compilerHost, configFileName ? ts2.getDirectoryPath(ts2.getNormalizedAbsolutePath(configFileName, currentDirectory)) : currentDirectory, false);
        compilerHost.resolveModuleNames = host.resolveModuleNames ? function() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          return host.resolveModuleNames.apply(host, args);
        } : function(moduleNames, containingFile, reusedNames, redirectedReference) {
          return resolutionCache.resolveModuleNames(moduleNames, containingFile, reusedNames, redirectedReference);
        };
        compilerHost.resolveTypeReferenceDirectives = host.resolveTypeReferenceDirectives ? function() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          return host.resolveTypeReferenceDirectives.apply(host, args);
        } : function(typeDirectiveNames, containingFile, redirectedReference) {
          return resolutionCache.resolveTypeReferenceDirectives(typeDirectiveNames, containingFile, redirectedReference);
        };
        var userProvidedResolution = !!host.resolveModuleNames || !!host.resolveTypeReferenceDirectives;
        builderProgram = readBuilderProgram(compilerOptions, compilerHost);
        synchronizeProgram();
        watchConfigFileWildCardDirectories();
        return configFileName ? { getCurrentProgram: getCurrentBuilderProgram, getProgram: updateProgram, close } : { getCurrentProgram: getCurrentBuilderProgram, getProgram: updateProgram, updateRootFileNames, close };
        function close() {
          resolutionCache.clear();
          ts2.clearMap(sourceFilesCache, function(value) {
            if (value && value.fileWatcher) {
              value.fileWatcher.close();
              value.fileWatcher = void 0;
            }
          });
          if (configFileWatcher) {
            configFileWatcher.close();
            configFileWatcher = void 0;
          }
          if (watchedWildcardDirectories) {
            ts2.clearMap(watchedWildcardDirectories, ts2.closeFileWatcherOf);
            watchedWildcardDirectories = void 0;
          }
          if (missingFilesMap) {
            ts2.clearMap(missingFilesMap, ts2.closeFileWatcher);
            missingFilesMap = void 0;
          }
        }
        function getCurrentBuilderProgram() {
          return builderProgram;
        }
        function getCurrentProgram() {
          return builderProgram && builderProgram.getProgramOrUndefined();
        }
        function synchronizeProgram() {
          writeLog("Synchronizing program");
          var program = getCurrentBuilderProgram();
          if (hasChangedCompilerOptions) {
            newLine = updateNewLine();
            if (program && ts2.changesAffectModuleResolution(program.getCompilerOptions(), compilerOptions)) {
              resolutionCache.clear();
            }
          }
          var hasInvalidatedResolution = resolutionCache.createHasInvalidatedResolution(userProvidedResolution);
          if (ts2.isProgramUptoDate(getCurrentProgram(), rootFileNames, compilerOptions, getSourceVersion, fileExists, hasInvalidatedResolution, hasChangedAutomaticTypeDirectiveNames, projectReferences)) {
            if (hasChangedConfigFileParsingErrors) {
              builderProgram = createProgram(void 0, void 0, compilerHost, builderProgram, configFileParsingDiagnostics, projectReferences);
              hasChangedConfigFileParsingErrors = false;
            }
          } else {
            createNewProgram(hasInvalidatedResolution);
          }
          if (host.afterProgramCreate && program !== builderProgram) {
            host.afterProgramCreate(builderProgram);
          }
          return builderProgram;
        }
        function createNewProgram(hasInvalidatedResolution) {
          writeLog("CreatingProgramWith::");
          writeLog("  roots: " + JSON.stringify(rootFileNames));
          writeLog("  options: " + JSON.stringify(compilerOptions));
          var needsUpdateInTypeRootWatch = hasChangedCompilerOptions || !getCurrentProgram();
          hasChangedCompilerOptions = false;
          hasChangedConfigFileParsingErrors = false;
          resolutionCache.startCachingPerDirectoryResolution();
          compilerHost.hasInvalidatedResolution = hasInvalidatedResolution;
          compilerHost.hasChangedAutomaticTypeDirectiveNames = hasChangedAutomaticTypeDirectiveNames;
          hasChangedAutomaticTypeDirectiveNames = false;
          builderProgram = createProgram(rootFileNames, compilerOptions, compilerHost, builderProgram, configFileParsingDiagnostics, projectReferences);
          resolutionCache.finishCachingPerDirectoryResolution();
          ts2.updateMissingFilePathsWatch(builderProgram.getProgram(), missingFilesMap || (missingFilesMap = ts2.createMap()), watchMissingFilePath);
          if (needsUpdateInTypeRootWatch) {
            resolutionCache.updateTypeRootsWatch();
          }
          if (missingFilePathsRequestedForRelease) {
            for (var _i = 0, missingFilePathsRequestedForRelease_1 = missingFilePathsRequestedForRelease; _i < missingFilePathsRequestedForRelease_1.length; _i++) {
              var missingFilePath = missingFilePathsRequestedForRelease_1[_i];
              if (!missingFilesMap.has(missingFilePath)) {
                sourceFilesCache.delete(missingFilePath);
              }
            }
            missingFilePathsRequestedForRelease = void 0;
          }
        }
        function updateRootFileNames(files) {
          ts2.Debug.assert(!configFileName, "Cannot update root file names with config file watch mode");
          rootFileNames = files;
          scheduleProgramUpdate();
        }
        function updateNewLine() {
          return ts2.getNewLineCharacter(compilerOptions || optionsToExtendForConfigFile, function() {
            return host.getNewLine();
          });
        }
        function toPath(fileName) {
          return ts2.toPath(fileName, currentDirectory, getCanonicalFileName);
        }
        function isFileMissingOnHost(hostSourceFile) {
          return typeof hostSourceFile === "boolean";
        }
        function isFilePresenceUnknownOnHost(hostSourceFile) {
          return typeof hostSourceFile.version === "boolean";
        }
        function fileExists(fileName) {
          var path2 = toPath(fileName);
          if (isFileMissingOnHost(sourceFilesCache.get(path2))) {
            return false;
          }
          return directoryStructureHost.fileExists(fileName);
        }
        function getVersionedSourceFileByPath(fileName, path2, languageVersion, onError, shouldCreateNewSourceFile) {
          var hostSourceFile = sourceFilesCache.get(path2);
          if (isFileMissingOnHost(hostSourceFile)) {
            return void 0;
          }
          if (hostSourceFile === void 0 || shouldCreateNewSourceFile || isFilePresenceUnknownOnHost(hostSourceFile)) {
            var sourceFile = getNewSourceFile(fileName, languageVersion, onError);
            if (hostSourceFile) {
              if (sourceFile) {
                hostSourceFile.sourceFile = sourceFile;
                hostSourceFile.version = sourceFile.version;
                if (!hostSourceFile.fileWatcher) {
                  hostSourceFile.fileWatcher = watchFilePath(host, fileName, onSourceFileChange, ts2.PollingInterval.Low, watchOptions, path2, ts2.WatchType.SourceFile);
                }
              } else {
                if (hostSourceFile.fileWatcher) {
                  hostSourceFile.fileWatcher.close();
                }
                sourceFilesCache.set(path2, false);
              }
            } else {
              if (sourceFile) {
                var fileWatcher = watchFilePath(host, fileName, onSourceFileChange, ts2.PollingInterval.Low, watchOptions, path2, ts2.WatchType.SourceFile);
                sourceFilesCache.set(path2, { sourceFile, version: sourceFile.version, fileWatcher });
              } else {
                sourceFilesCache.set(path2, false);
              }
            }
            return sourceFile;
          }
          return hostSourceFile.sourceFile;
        }
        function nextSourceFileVersion(path2) {
          var hostSourceFile = sourceFilesCache.get(path2);
          if (hostSourceFile !== void 0) {
            if (isFileMissingOnHost(hostSourceFile)) {
              sourceFilesCache.set(path2, { version: false });
            } else {
              hostSourceFile.version = false;
            }
          }
        }
        function getSourceVersion(path2) {
          var hostSourceFile = sourceFilesCache.get(path2);
          return !hostSourceFile || !hostSourceFile.version ? void 0 : hostSourceFile.version;
        }
        function onReleaseOldSourceFile(oldSourceFile, _oldOptions, hasSourceFileByPath) {
          var hostSourceFileInfo = sourceFilesCache.get(oldSourceFile.resolvedPath);
          if (hostSourceFileInfo !== void 0) {
            if (isFileMissingOnHost(hostSourceFileInfo)) {
              (missingFilePathsRequestedForRelease || (missingFilePathsRequestedForRelease = [])).push(oldSourceFile.path);
            } else if (hostSourceFileInfo.sourceFile === oldSourceFile) {
              if (hostSourceFileInfo.fileWatcher) {
                hostSourceFileInfo.fileWatcher.close();
              }
              sourceFilesCache.delete(oldSourceFile.resolvedPath);
              if (!hasSourceFileByPath) {
                resolutionCache.removeResolutionsOfFile(oldSourceFile.path);
              }
            }
          }
        }
        function reportWatchDiagnostic(message) {
          if (host.onWatchStatusChange) {
            host.onWatchStatusChange(ts2.createCompilerDiagnostic(message), newLine, compilerOptions || optionsToExtendForConfigFile);
          }
        }
        function scheduleProgramUpdate() {
          if (!host.setTimeout || !host.clearTimeout) {
            return;
          }
          if (timerToUpdateProgram) {
            host.clearTimeout(timerToUpdateProgram);
          }
          writeLog("Scheduling update");
          timerToUpdateProgram = host.setTimeout(updateProgramWithWatchStatus, 250);
        }
        function scheduleProgramReload() {
          ts2.Debug.assert(!!configFileName);
          reloadLevel = ts2.ConfigFileProgramReloadLevel.Full;
          scheduleProgramUpdate();
        }
        function updateProgramWithWatchStatus() {
          timerToUpdateProgram = void 0;
          reportWatchDiagnostic(ts2.Diagnostics.File_change_detected_Starting_incremental_compilation);
          updateProgram();
        }
        function updateProgram() {
          switch (reloadLevel) {
            case ts2.ConfigFileProgramReloadLevel.Partial:
              ts2.perfLogger.logStartUpdateProgram("PartialConfigReload");
              reloadFileNamesFromConfigFile();
              break;
            case ts2.ConfigFileProgramReloadLevel.Full:
              ts2.perfLogger.logStartUpdateProgram("FullConfigReload");
              reloadConfigFile();
              break;
            default:
              ts2.perfLogger.logStartUpdateProgram("SynchronizeProgram");
              synchronizeProgram();
              break;
          }
          ts2.perfLogger.logStopUpdateProgram("Done");
          return getCurrentBuilderProgram();
        }
        function reloadFileNamesFromConfigFile() {
          writeLog("Reloading new file names and options");
          var result = ts2.getFileNamesFromConfigSpecs(configFileSpecs, ts2.getNormalizedAbsolutePath(ts2.getDirectoryPath(configFileName), currentDirectory), compilerOptions, parseConfigFileHost);
          if (ts2.updateErrorForNoInputFiles(result, ts2.getNormalizedAbsolutePath(configFileName, currentDirectory), configFileSpecs, configFileParsingDiagnostics, canConfigFileJsonReportNoInputFiles)) {
            hasChangedConfigFileParsingErrors = true;
          }
          rootFileNames = result.fileNames;
          synchronizeProgram();
        }
        function reloadConfigFile() {
          writeLog("Reloading config file: " + configFileName);
          reloadLevel = ts2.ConfigFileProgramReloadLevel.None;
          if (cachedDirectoryStructureHost) {
            cachedDirectoryStructureHost.clearCache();
          }
          parseConfigFile();
          hasChangedCompilerOptions = true;
          synchronizeProgram();
          watchConfigFileWildCardDirectories();
        }
        function parseConfigFile() {
          setConfigFileParsingResult(ts2.getParsedCommandLineOfConfigFile(configFileName, optionsToExtendForConfigFile, parseConfigFileHost, void 0, watchOptionsToExtend, extraFileExtensions));
        }
        function setConfigFileParsingResult(configFileParseResult) {
          rootFileNames = configFileParseResult.fileNames;
          compilerOptions = configFileParseResult.options;
          watchOptions = configFileParseResult.watchOptions;
          configFileSpecs = configFileParseResult.configFileSpecs;
          projectReferences = configFileParseResult.projectReferences;
          configFileParsingDiagnostics = ts2.getConfigFileParsingDiagnostics(configFileParseResult).slice();
          canConfigFileJsonReportNoInputFiles = ts2.canJsonReportNoInutFiles(configFileParseResult.raw);
          hasChangedConfigFileParsingErrors = true;
        }
        function onSourceFileChange(fileName, eventKind, path2) {
          updateCachedSystemWithFile(fileName, path2, eventKind);
          if (eventKind === ts2.FileWatcherEventKind.Deleted && sourceFilesCache.has(path2)) {
            resolutionCache.invalidateResolutionOfFile(path2);
          }
          resolutionCache.removeResolutionsFromProjectReferenceRedirects(path2);
          nextSourceFileVersion(path2);
          scheduleProgramUpdate();
        }
        function updateCachedSystemWithFile(fileName, path2, eventKind) {
          if (cachedDirectoryStructureHost) {
            cachedDirectoryStructureHost.addOrDeleteFile(fileName, path2, eventKind);
          }
        }
        function watchMissingFilePath(missingFilePath) {
          return watchFilePath(host, missingFilePath, onMissingFileChange, ts2.PollingInterval.Medium, watchOptions, missingFilePath, ts2.WatchType.MissingFile);
        }
        function onMissingFileChange(fileName, eventKind, missingFilePath) {
          updateCachedSystemWithFile(fileName, missingFilePath, eventKind);
          if (eventKind === ts2.FileWatcherEventKind.Created && missingFilesMap.has(missingFilePath)) {
            missingFilesMap.get(missingFilePath).close();
            missingFilesMap.delete(missingFilePath);
            nextSourceFileVersion(missingFilePath);
            scheduleProgramUpdate();
          }
        }
        function watchConfigFileWildCardDirectories() {
          if (configFileSpecs) {
            ts2.updateWatchingWildcardDirectories(watchedWildcardDirectories || (watchedWildcardDirectories = ts2.createMap()), ts2.createMapFromTemplate(configFileSpecs.wildcardDirectories), watchWildcardDirectory);
          } else if (watchedWildcardDirectories) {
            ts2.clearMap(watchedWildcardDirectories, ts2.closeFileWatcherOf);
          }
        }
        function watchWildcardDirectory(directory, flags) {
          return watchDirectory(host, directory, function(fileOrDirectory) {
            ts2.Debug.assert(!!configFileName);
            var fileOrDirectoryPath = toPath(fileOrDirectory);
            if (cachedDirectoryStructureHost) {
              cachedDirectoryStructureHost.addOrDeleteFileOrDirectory(fileOrDirectory, fileOrDirectoryPath);
            }
            nextSourceFileVersion(fileOrDirectoryPath);
            fileOrDirectoryPath = ts2.removeIgnoredPath(fileOrDirectoryPath);
            if (!fileOrDirectoryPath)
              return;
            if (fileOrDirectoryPath !== directory && ts2.hasExtension(fileOrDirectoryPath) && !ts2.isSupportedSourceFileName(fileOrDirectory, compilerOptions)) {
              writeLog("Project: " + configFileName + " Detected file add/remove of non supported extension: " + fileOrDirectory);
              return;
            }
            if (reloadLevel !== ts2.ConfigFileProgramReloadLevel.Full) {
              reloadLevel = ts2.ConfigFileProgramReloadLevel.Partial;
              scheduleProgramUpdate();
            }
          }, flags, watchOptions, ts2.WatchType.WildcardDirectory);
        }
      }
      ts2.createWatchProgram = createWatchProgram;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var UpToDateStatusType;
      (function(UpToDateStatusType2) {
        UpToDateStatusType2[UpToDateStatusType2["Unbuildable"] = 0] = "Unbuildable";
        UpToDateStatusType2[UpToDateStatusType2["UpToDate"] = 1] = "UpToDate";
        UpToDateStatusType2[UpToDateStatusType2["UpToDateWithUpstreamTypes"] = 2] = "UpToDateWithUpstreamTypes";
        UpToDateStatusType2[UpToDateStatusType2["OutOfDateWithPrepend"] = 3] = "OutOfDateWithPrepend";
        UpToDateStatusType2[UpToDateStatusType2["OutputMissing"] = 4] = "OutputMissing";
        UpToDateStatusType2[UpToDateStatusType2["OutOfDateWithSelf"] = 5] = "OutOfDateWithSelf";
        UpToDateStatusType2[UpToDateStatusType2["OutOfDateWithUpstream"] = 6] = "OutOfDateWithUpstream";
        UpToDateStatusType2[UpToDateStatusType2["UpstreamOutOfDate"] = 7] = "UpstreamOutOfDate";
        UpToDateStatusType2[UpToDateStatusType2["UpstreamBlocked"] = 8] = "UpstreamBlocked";
        UpToDateStatusType2[UpToDateStatusType2["ComputingUpstream"] = 9] = "ComputingUpstream";
        UpToDateStatusType2[UpToDateStatusType2["TsVersionOutputOfDate"] = 10] = "TsVersionOutputOfDate";
        UpToDateStatusType2[UpToDateStatusType2["ContainerOnly"] = 11] = "ContainerOnly";
      })(UpToDateStatusType = ts2.UpToDateStatusType || (ts2.UpToDateStatusType = {}));
      function resolveConfigFileProjectName(project) {
        if (ts2.fileExtensionIs(project, ".json")) {
          return project;
        }
        return ts2.combinePaths(project, "tsconfig.json");
      }
      ts2.resolveConfigFileProjectName = resolveConfigFileProjectName;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var minimumDate = new Date(-864e13);
      var maximumDate = new Date(864e13);
      var BuildResultFlags;
      (function(BuildResultFlags2) {
        BuildResultFlags2[BuildResultFlags2["None"] = 0] = "None";
        BuildResultFlags2[BuildResultFlags2["Success"] = 1] = "Success";
        BuildResultFlags2[BuildResultFlags2["DeclarationOutputUnchanged"] = 2] = "DeclarationOutputUnchanged";
        BuildResultFlags2[BuildResultFlags2["ConfigFileErrors"] = 4] = "ConfigFileErrors";
        BuildResultFlags2[BuildResultFlags2["SyntaxErrors"] = 8] = "SyntaxErrors";
        BuildResultFlags2[BuildResultFlags2["TypeErrors"] = 16] = "TypeErrors";
        BuildResultFlags2[BuildResultFlags2["DeclarationEmitErrors"] = 32] = "DeclarationEmitErrors";
        BuildResultFlags2[BuildResultFlags2["EmitErrors"] = 64] = "EmitErrors";
        BuildResultFlags2[BuildResultFlags2["AnyErrors"] = 124] = "AnyErrors";
      })(BuildResultFlags || (BuildResultFlags = {}));
      function createConfigFileMap() {
        return ts2.createMap();
      }
      function getOrCreateValueFromConfigFileMap(configFileMap, resolved, createT) {
        var existingValue = configFileMap.get(resolved);
        var newValue;
        if (!existingValue) {
          newValue = createT();
          configFileMap.set(resolved, newValue);
        }
        return existingValue || newValue;
      }
      function getOrCreateValueMapFromConfigFileMap(configFileMap, resolved) {
        return getOrCreateValueFromConfigFileMap(configFileMap, resolved, ts2.createMap);
      }
      function newer(date1, date2) {
        return date2 > date1 ? date2 : date1;
      }
      function isDeclarationFile(fileName) {
        return ts2.fileExtensionIs(fileName, ".d.ts");
      }
      function isCircularBuildOrder(buildOrder) {
        return !!buildOrder && !!buildOrder.buildOrder;
      }
      ts2.isCircularBuildOrder = isCircularBuildOrder;
      function getBuildOrderFromAnyBuildOrder(anyBuildOrder) {
        return isCircularBuildOrder(anyBuildOrder) ? anyBuildOrder.buildOrder : anyBuildOrder;
      }
      ts2.getBuildOrderFromAnyBuildOrder = getBuildOrderFromAnyBuildOrder;
      function createBuilderStatusReporter(system, pretty) {
        return function(diagnostic) {
          var output = pretty ? "[" + ts2.formatColorAndReset(ts2.getLocaleTimeString(system), ts2.ForegroundColorEscapeSequences.Grey) + "] " : ts2.getLocaleTimeString(system) + " - ";
          output += "" + ts2.flattenDiagnosticMessageText(diagnostic.messageText, system.newLine) + (system.newLine + system.newLine);
          system.write(output);
        };
      }
      ts2.createBuilderStatusReporter = createBuilderStatusReporter;
      function createSolutionBuilderHostBase(system, createProgram, reportDiagnostic, reportSolutionBuilderStatus) {
        var host = ts2.createProgramHost(system, createProgram);
        host.getModifiedTime = system.getModifiedTime ? function(path2) {
          return system.getModifiedTime(path2);
        } : ts2.returnUndefined;
        host.setModifiedTime = system.setModifiedTime ? function(path2, date) {
          return system.setModifiedTime(path2, date);
        } : ts2.noop;
        host.deleteFile = system.deleteFile ? function(path2) {
          return system.deleteFile(path2);
        } : ts2.noop;
        host.reportDiagnostic = reportDiagnostic || ts2.createDiagnosticReporter(system);
        host.reportSolutionBuilderStatus = reportSolutionBuilderStatus || createBuilderStatusReporter(system);
        host.now = ts2.maybeBind(system, system.now);
        return host;
      }
      function createSolutionBuilderHost(system, createProgram, reportDiagnostic, reportSolutionBuilderStatus, reportErrorSummary2) {
        if (system === void 0) {
          system = ts2.sys;
        }
        var host = createSolutionBuilderHostBase(system, createProgram, reportDiagnostic, reportSolutionBuilderStatus);
        host.reportErrorSummary = reportErrorSummary2;
        return host;
      }
      ts2.createSolutionBuilderHost = createSolutionBuilderHost;
      function createSolutionBuilderWithWatchHost(system, createProgram, reportDiagnostic, reportSolutionBuilderStatus, reportWatchStatus2) {
        if (system === void 0) {
          system = ts2.sys;
        }
        var host = createSolutionBuilderHostBase(system, createProgram, reportDiagnostic, reportSolutionBuilderStatus);
        var watchHost = ts2.createWatchHost(system, reportWatchStatus2);
        ts2.copyProperties(host, watchHost);
        return host;
      }
      ts2.createSolutionBuilderWithWatchHost = createSolutionBuilderWithWatchHost;
      function getCompilerOptionsOfBuildOptions(buildOptions) {
        var result = {};
        ts2.commonOptionsWithBuild.forEach(function(option) {
          if (ts2.hasProperty(buildOptions, option.name))
            result[option.name] = buildOptions[option.name];
        });
        return result;
      }
      function createSolutionBuilder(host, rootNames, defaultOptions) {
        return createSolutionBuilderWorker(false, host, rootNames, defaultOptions);
      }
      ts2.createSolutionBuilder = createSolutionBuilder;
      function createSolutionBuilderWithWatch(host, rootNames, defaultOptions, baseWatchOptions) {
        return createSolutionBuilderWorker(true, host, rootNames, defaultOptions, baseWatchOptions);
      }
      ts2.createSolutionBuilderWithWatch = createSolutionBuilderWithWatch;
      function createSolutionBuilderState(watch, hostOrHostWithWatch, rootNames, options, baseWatchOptions) {
        var host = hostOrHostWithWatch;
        var hostWithWatch = hostOrHostWithWatch;
        var currentDirectory = host.getCurrentDirectory();
        var getCanonicalFileName = ts2.createGetCanonicalFileName(host.useCaseSensitiveFileNames());
        var baseCompilerOptions = getCompilerOptionsOfBuildOptions(options);
        var compilerHost = ts2.createCompilerHostFromProgramHost(host, function() {
          return state.projectCompilerOptions;
        });
        ts2.setGetSourceFileAsHashVersioned(compilerHost, host);
        compilerHost.getParsedCommandLine = function(fileName) {
          return parseConfigFile(state, fileName, toResolvedConfigFilePath(state, fileName));
        };
        compilerHost.resolveModuleNames = ts2.maybeBind(host, host.resolveModuleNames);
        compilerHost.resolveTypeReferenceDirectives = ts2.maybeBind(host, host.resolveTypeReferenceDirectives);
        var moduleResolutionCache = !compilerHost.resolveModuleNames ? ts2.createModuleResolutionCache(currentDirectory, getCanonicalFileName) : void 0;
        if (!compilerHost.resolveModuleNames) {
          var loader_3 = function(moduleName, containingFile, redirectedReference) {
            return ts2.resolveModuleName(moduleName, containingFile, state.projectCompilerOptions, compilerHost, moduleResolutionCache, redirectedReference).resolvedModule;
          };
          compilerHost.resolveModuleNames = function(moduleNames, containingFile, _reusedNames, redirectedReference) {
            return ts2.loadWithLocalCache(ts2.Debug.checkEachDefined(moduleNames), containingFile, redirectedReference, loader_3);
          };
        }
        var _a = ts2.createWatchFactory(hostWithWatch, options), watchFile = _a.watchFile, watchFilePath = _a.watchFilePath, watchDirectory = _a.watchDirectory, writeLog = _a.writeLog;
        var state = {
          host,
          hostWithWatch,
          currentDirectory,
          getCanonicalFileName,
          parseConfigFileHost: ts2.parseConfigHostFromCompilerHostLike(host),
          writeFileName: host.trace ? function(s) {
            return host.trace(s);
          } : void 0,
          options,
          baseCompilerOptions,
          rootNames,
          baseWatchOptions,
          resolvedConfigFilePaths: ts2.createMap(),
          configFileCache: createConfigFileMap(),
          projectStatus: createConfigFileMap(),
          buildInfoChecked: createConfigFileMap(),
          extendedConfigCache: ts2.createMap(),
          builderPrograms: createConfigFileMap(),
          diagnostics: createConfigFileMap(),
          projectPendingBuild: createConfigFileMap(),
          projectErrorsReported: createConfigFileMap(),
          compilerHost,
          moduleResolutionCache,
          buildOrder: void 0,
          readFileWithCache: function(f) {
            return host.readFile(f);
          },
          projectCompilerOptions: baseCompilerOptions,
          cache: void 0,
          allProjectBuildPending: true,
          needsSummary: true,
          watchAllProjectsPending: watch,
          currentInvalidatedProject: void 0,
          watch,
          allWatchedWildcardDirectories: createConfigFileMap(),
          allWatchedInputFiles: createConfigFileMap(),
          allWatchedConfigFiles: createConfigFileMap(),
          timerToBuildInvalidatedProject: void 0,
          reportFileChangeDetected: false,
          watchFile,
          watchFilePath,
          watchDirectory,
          writeLog
        };
        return state;
      }
      function toPath(state, fileName) {
        return ts2.toPath(fileName, state.currentDirectory, state.getCanonicalFileName);
      }
      function toResolvedConfigFilePath(state, fileName) {
        var resolvedConfigFilePaths = state.resolvedConfigFilePaths;
        var path2 = resolvedConfigFilePaths.get(fileName);
        if (path2 !== void 0)
          return path2;
        var resolvedPath = toPath(state, fileName);
        resolvedConfigFilePaths.set(fileName, resolvedPath);
        return resolvedPath;
      }
      function isParsedCommandLine(entry) {
        return !!entry.options;
      }
      function parseConfigFile(state, configFileName, configFilePath) {
        var configFileCache = state.configFileCache;
        var value = configFileCache.get(configFilePath);
        if (value) {
          return isParsedCommandLine(value) ? value : void 0;
        }
        var diagnostic;
        var parseConfigFileHost = state.parseConfigFileHost, baseCompilerOptions = state.baseCompilerOptions, baseWatchOptions = state.baseWatchOptions, extendedConfigCache = state.extendedConfigCache, host = state.host;
        var parsed;
        if (host.getParsedCommandLine) {
          parsed = host.getParsedCommandLine(configFileName);
          if (!parsed)
            diagnostic = ts2.createCompilerDiagnostic(ts2.Diagnostics.File_0_not_found, configFileName);
        } else {
          parseConfigFileHost.onUnRecoverableConfigFileDiagnostic = function(d) {
            return diagnostic = d;
          };
          parsed = ts2.getParsedCommandLineOfConfigFile(configFileName, baseCompilerOptions, parseConfigFileHost, extendedConfigCache, baseWatchOptions);
          parseConfigFileHost.onUnRecoverableConfigFileDiagnostic = ts2.noop;
        }
        configFileCache.set(configFilePath, parsed || diagnostic);
        return parsed;
      }
      function resolveProjectName(state, name) {
        return ts2.resolveConfigFileProjectName(ts2.resolvePath(state.currentDirectory, name));
      }
      function createBuildOrder(state, roots) {
        var temporaryMarks = ts2.createMap();
        var permanentMarks = ts2.createMap();
        var circularityReportStack = [];
        var buildOrder;
        var circularDiagnostics;
        for (var _i = 0, roots_1 = roots; _i < roots_1.length; _i++) {
          var root = roots_1[_i];
          visit(root);
        }
        return circularDiagnostics ? { buildOrder: buildOrder || ts2.emptyArray, circularDiagnostics } : buildOrder || ts2.emptyArray;
        function visit(configFileName, inCircularContext) {
          var projPath = toResolvedConfigFilePath(state, configFileName);
          if (permanentMarks.has(projPath))
            return;
          if (temporaryMarks.has(projPath)) {
            if (!inCircularContext) {
              (circularDiagnostics || (circularDiagnostics = [])).push(ts2.createCompilerDiagnostic(ts2.Diagnostics.Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0, circularityReportStack.join("\r\n")));
            }
            return;
          }
          temporaryMarks.set(projPath, true);
          circularityReportStack.push(configFileName);
          var parsed = parseConfigFile(state, configFileName, projPath);
          if (parsed && parsed.projectReferences) {
            for (var _i2 = 0, _a = parsed.projectReferences; _i2 < _a.length; _i2++) {
              var ref = _a[_i2];
              var resolvedRefPath = resolveProjectName(state, ref.path);
              visit(resolvedRefPath, inCircularContext || ref.circular);
            }
          }
          circularityReportStack.pop();
          permanentMarks.set(projPath, true);
          (buildOrder || (buildOrder = [])).push(configFileName);
        }
      }
      function getBuildOrder(state) {
        return state.buildOrder || createStateBuildOrder(state);
      }
      function createStateBuildOrder(state) {
        var buildOrder = createBuildOrder(state, state.rootNames.map(function(f) {
          return resolveProjectName(state, f);
        }));
        state.resolvedConfigFilePaths.clear();
        var currentProjects = ts2.arrayToSet(getBuildOrderFromAnyBuildOrder(buildOrder), function(resolved) {
          return toResolvedConfigFilePath(state, resolved);
        });
        var noopOnDelete = { onDeleteValue: ts2.noop };
        ts2.mutateMapSkippingNewValues(state.configFileCache, currentProjects, noopOnDelete);
        ts2.mutateMapSkippingNewValues(state.projectStatus, currentProjects, noopOnDelete);
        ts2.mutateMapSkippingNewValues(state.buildInfoChecked, currentProjects, noopOnDelete);
        ts2.mutateMapSkippingNewValues(state.builderPrograms, currentProjects, noopOnDelete);
        ts2.mutateMapSkippingNewValues(state.diagnostics, currentProjects, noopOnDelete);
        ts2.mutateMapSkippingNewValues(state.projectPendingBuild, currentProjects, noopOnDelete);
        ts2.mutateMapSkippingNewValues(state.projectErrorsReported, currentProjects, noopOnDelete);
        if (state.watch) {
          ts2.mutateMapSkippingNewValues(state.allWatchedConfigFiles, currentProjects, { onDeleteValue: ts2.closeFileWatcher });
          ts2.mutateMapSkippingNewValues(state.allWatchedWildcardDirectories, currentProjects, { onDeleteValue: function(existingMap) {
            return existingMap.forEach(ts2.closeFileWatcherOf);
          } });
          ts2.mutateMapSkippingNewValues(state.allWatchedInputFiles, currentProjects, { onDeleteValue: function(existingMap) {
            return existingMap.forEach(ts2.closeFileWatcher);
          } });
        }
        return state.buildOrder = buildOrder;
      }
      function getBuildOrderFor(state, project, onlyReferences) {
        var resolvedProject = project && resolveProjectName(state, project);
        var buildOrderFromState = getBuildOrder(state);
        if (isCircularBuildOrder(buildOrderFromState))
          return buildOrderFromState;
        if (resolvedProject) {
          var projectPath_1 = toResolvedConfigFilePath(state, resolvedProject);
          var projectIndex = ts2.findIndex(buildOrderFromState, function(configFileName) {
            return toResolvedConfigFilePath(state, configFileName) === projectPath_1;
          });
          if (projectIndex === -1)
            return void 0;
        }
        var buildOrder = resolvedProject ? createBuildOrder(state, [resolvedProject]) : buildOrderFromState;
        ts2.Debug.assert(!isCircularBuildOrder(buildOrder));
        ts2.Debug.assert(!onlyReferences || resolvedProject !== void 0);
        ts2.Debug.assert(!onlyReferences || buildOrder[buildOrder.length - 1] === resolvedProject);
        return onlyReferences ? buildOrder.slice(0, buildOrder.length - 1) : buildOrder;
      }
      function enableCache(state) {
        if (state.cache) {
          disableCache(state);
        }
        var compilerHost = state.compilerHost, host = state.host;
        var originalReadFileWithCache = state.readFileWithCache;
        var originalGetSourceFile = compilerHost.getSourceFile;
        var _a = ts2.changeCompilerHostLikeToUseCache(host, function(fileName) {
          return toPath(state, fileName);
        }, function() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
          return originalGetSourceFile.call.apply(originalGetSourceFile, __spreadArrays([compilerHost], args));
        }), originalReadFile = _a.originalReadFile, originalFileExists = _a.originalFileExists, originalDirectoryExists = _a.originalDirectoryExists, originalCreateDirectory = _a.originalCreateDirectory, originalWriteFile = _a.originalWriteFile, getSourceFileWithCache = _a.getSourceFileWithCache, readFileWithCache = _a.readFileWithCache;
        state.readFileWithCache = readFileWithCache;
        compilerHost.getSourceFile = getSourceFileWithCache;
        state.cache = {
          originalReadFile,
          originalFileExists,
          originalDirectoryExists,
          originalCreateDirectory,
          originalWriteFile,
          originalReadFileWithCache,
          originalGetSourceFile
        };
      }
      function disableCache(state) {
        if (!state.cache)
          return;
        var cache = state.cache, host = state.host, compilerHost = state.compilerHost, extendedConfigCache = state.extendedConfigCache, moduleResolutionCache = state.moduleResolutionCache;
        host.readFile = cache.originalReadFile;
        host.fileExists = cache.originalFileExists;
        host.directoryExists = cache.originalDirectoryExists;
        host.createDirectory = cache.originalCreateDirectory;
        host.writeFile = cache.originalWriteFile;
        compilerHost.getSourceFile = cache.originalGetSourceFile;
        state.readFileWithCache = cache.originalReadFileWithCache;
        extendedConfigCache.clear();
        if (moduleResolutionCache) {
          moduleResolutionCache.directoryToModuleNameMap.clear();
          moduleResolutionCache.moduleNameToDirectoryMap.clear();
        }
        state.cache = void 0;
      }
      function clearProjectStatus(state, resolved) {
        state.projectStatus.delete(resolved);
        state.diagnostics.delete(resolved);
      }
      function addProjToQueue(_a, proj, reloadLevel) {
        var projectPendingBuild = _a.projectPendingBuild;
        var value = projectPendingBuild.get(proj);
        if (value === void 0) {
          projectPendingBuild.set(proj, reloadLevel);
        } else if (value < reloadLevel) {
          projectPendingBuild.set(proj, reloadLevel);
        }
      }
      function setupInitialBuild(state, cancellationToken) {
        if (!state.allProjectBuildPending)
          return;
        state.allProjectBuildPending = false;
        if (state.options.watch) {
          reportWatchStatus(state, ts2.Diagnostics.Starting_compilation_in_watch_mode);
        }
        enableCache(state);
        var buildOrder = getBuildOrderFromAnyBuildOrder(getBuildOrder(state));
        buildOrder.forEach(function(configFileName) {
          return state.projectPendingBuild.set(toResolvedConfigFilePath(state, configFileName), ts2.ConfigFileProgramReloadLevel.None);
        });
        if (cancellationToken) {
          cancellationToken.throwIfCancellationRequested();
        }
      }
      var InvalidatedProjectKind;
      (function(InvalidatedProjectKind2) {
        InvalidatedProjectKind2[InvalidatedProjectKind2["Build"] = 0] = "Build";
        InvalidatedProjectKind2[InvalidatedProjectKind2["UpdateBundle"] = 1] = "UpdateBundle";
        InvalidatedProjectKind2[InvalidatedProjectKind2["UpdateOutputFileStamps"] = 2] = "UpdateOutputFileStamps";
      })(InvalidatedProjectKind = ts2.InvalidatedProjectKind || (ts2.InvalidatedProjectKind = {}));
      function doneInvalidatedProject(state, projectPath) {
        state.projectPendingBuild.delete(projectPath);
        state.currentInvalidatedProject = void 0;
        return state.diagnostics.has(projectPath) ? ts2.ExitStatus.DiagnosticsPresent_OutputsSkipped : ts2.ExitStatus.Success;
      }
      function createUpdateOutputFileStampsProject(state, project, projectPath, config, buildOrder) {
        var updateOutputFileStampsPending = true;
        return {
          kind: InvalidatedProjectKind.UpdateOutputFileStamps,
          project,
          projectPath,
          buildOrder,
          getCompilerOptions: function() {
            return config.options;
          },
          getCurrentDirectory: function() {
            return state.currentDirectory;
          },
          updateOutputFileStatmps: function() {
            updateOutputTimestamps(state, config, projectPath);
            updateOutputFileStampsPending = false;
          },
          done: function() {
            if (updateOutputFileStampsPending) {
              updateOutputTimestamps(state, config, projectPath);
            }
            return doneInvalidatedProject(state, projectPath);
          }
        };
      }
      function createBuildOrUpdateInvalidedProject(kind, state, project, projectPath, projectIndex, config, buildOrder) {
        var Step;
        (function(Step2) {
          Step2[Step2["CreateProgram"] = 0] = "CreateProgram";
          Step2[Step2["SyntaxDiagnostics"] = 1] = "SyntaxDiagnostics";
          Step2[Step2["SemanticDiagnostics"] = 2] = "SemanticDiagnostics";
          Step2[Step2["Emit"] = 3] = "Emit";
          Step2[Step2["EmitBundle"] = 4] = "EmitBundle";
          Step2[Step2["BuildInvalidatedProjectOfBundle"] = 5] = "BuildInvalidatedProjectOfBundle";
          Step2[Step2["QueueReferencingProjects"] = 6] = "QueueReferencingProjects";
          Step2[Step2["Done"] = 7] = "Done";
        })(Step || (Step = {}));
        var step = kind === InvalidatedProjectKind.Build ? Step.CreateProgram : Step.EmitBundle;
        var program;
        var buildResult;
        var invalidatedProjectOfBundle;
        return kind === InvalidatedProjectKind.Build ? {
          kind,
          project,
          projectPath,
          buildOrder,
          getCompilerOptions: function() {
            return config.options;
          },
          getCurrentDirectory: function() {
            return state.currentDirectory;
          },
          getBuilderProgram: function() {
            return withProgramOrUndefined(ts2.identity);
          },
          getProgram: function() {
            return withProgramOrUndefined(function(program2) {
              return program2.getProgramOrUndefined();
            });
          },
          getSourceFile: function(fileName) {
            return withProgramOrUndefined(function(program2) {
              return program2.getSourceFile(fileName);
            });
          },
          getSourceFiles: function() {
            return withProgramOrEmptyArray(function(program2) {
              return program2.getSourceFiles();
            });
          },
          getOptionsDiagnostics: function(cancellationToken) {
            return withProgramOrEmptyArray(function(program2) {
              return program2.getOptionsDiagnostics(cancellationToken);
            });
          },
          getGlobalDiagnostics: function(cancellationToken) {
            return withProgramOrEmptyArray(function(program2) {
              return program2.getGlobalDiagnostics(cancellationToken);
            });
          },
          getConfigFileParsingDiagnostics: function() {
            return withProgramOrEmptyArray(function(program2) {
              return program2.getConfigFileParsingDiagnostics();
            });
          },
          getSyntacticDiagnostics: function(sourceFile, cancellationToken) {
            return withProgramOrEmptyArray(function(program2) {
              return program2.getSyntacticDiagnostics(sourceFile, cancellationToken);
            });
          },
          getAllDependencies: function(sourceFile) {
            return withProgramOrEmptyArray(function(program2) {
              return program2.getAllDependencies(sourceFile);
            });
          },
          getSemanticDiagnostics: function(sourceFile, cancellationToken) {
            return withProgramOrEmptyArray(function(program2) {
              return program2.getSemanticDiagnostics(sourceFile, cancellationToken);
            });
          },
          getSemanticDiagnosticsOfNextAffectedFile: function(cancellationToken, ignoreSourceFile) {
            return withProgramOrUndefined(function(program2) {
              return program2.getSemanticDiagnosticsOfNextAffectedFile && program2.getSemanticDiagnosticsOfNextAffectedFile(cancellationToken, ignoreSourceFile);
            });
          },
          emit: function(targetSourceFile, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers) {
            if (targetSourceFile || emitOnlyDtsFiles) {
              return withProgramOrUndefined(function(program2) {
                return program2.emit(targetSourceFile, writeFile, cancellationToken, emitOnlyDtsFiles, customTransformers);
              });
            }
            executeSteps(Step.SemanticDiagnostics, cancellationToken);
            if (step !== Step.Emit)
              return void 0;
            return emit(writeFile, cancellationToken, customTransformers);
          },
          done
        } : {
          kind,
          project,
          projectPath,
          buildOrder,
          getCompilerOptions: function() {
            return config.options;
          },
          getCurrentDirectory: function() {
            return state.currentDirectory;
          },
          emit: function(writeFile, customTransformers) {
            if (step !== Step.EmitBundle)
              return invalidatedProjectOfBundle;
            return emitBundle(writeFile, customTransformers);
          },
          done
        };
        function done(cancellationToken, writeFile, customTransformers) {
          executeSteps(Step.Done, cancellationToken, writeFile, customTransformers);
          return doneInvalidatedProject(state, projectPath);
        }
        function withProgramOrUndefined(action) {
          executeSteps(Step.CreateProgram);
          return program && action(program);
        }
        function withProgramOrEmptyArray(action) {
          return withProgramOrUndefined(action) || ts2.emptyArray;
        }
        function createProgram() {
          ts2.Debug.assert(program === void 0);
          if (state.options.dry) {
            reportStatus(state, ts2.Diagnostics.A_non_dry_build_would_build_project_0, project);
            buildResult = BuildResultFlags.Success;
            step = Step.QueueReferencingProjects;
            return;
          }
          if (state.options.verbose)
            reportStatus(state, ts2.Diagnostics.Building_project_0, project);
          if (config.fileNames.length === 0) {
            reportAndStoreErrors(state, projectPath, ts2.getConfigFileParsingDiagnostics(config));
            buildResult = BuildResultFlags.None;
            step = Step.QueueReferencingProjects;
            return;
          }
          var host = state.host, compilerHost = state.compilerHost;
          state.projectCompilerOptions = config.options;
          updateModuleResolutionCache(state, project, config);
          program = host.createProgram(config.fileNames, config.options, compilerHost, getOldProgram(state, projectPath, config), ts2.getConfigFileParsingDiagnostics(config), config.projectReferences);
          step++;
        }
        function handleDiagnostics(diagnostics, errorFlags, errorType) {
          if (diagnostics.length) {
            buildResult = buildErrors(state, projectPath, program, config, diagnostics, errorFlags, errorType);
            step = Step.QueueReferencingProjects;
          } else {
            step++;
          }
        }
        function getSyntaxDiagnostics(cancellationToken) {
          ts2.Debug.assertIsDefined(program);
          handleDiagnostics(__spreadArrays(program.getConfigFileParsingDiagnostics(), program.getOptionsDiagnostics(cancellationToken), program.getGlobalDiagnostics(cancellationToken), program.getSyntacticDiagnostics(void 0, cancellationToken)), BuildResultFlags.SyntaxErrors, "Syntactic");
        }
        function getSemanticDiagnostics(cancellationToken) {
          handleDiagnostics(ts2.Debug.checkDefined(program).getSemanticDiagnostics(void 0, cancellationToken), BuildResultFlags.TypeErrors, "Semantic");
        }
        function emit(writeFileCallback, cancellationToken, customTransformers) {
          ts2.Debug.assertIsDefined(program);
          ts2.Debug.assert(step === Step.Emit);
          program.backupState();
          var declDiagnostics;
          var reportDeclarationDiagnostics = function(d) {
            return (declDiagnostics || (declDiagnostics = [])).push(d);
          };
          var outputFiles = [];
          var emitResult = ts2.emitFilesAndReportErrors(program, reportDeclarationDiagnostics, void 0, void 0, function(name, text, writeByteOrderMark) {
            return outputFiles.push({ name, text, writeByteOrderMark });
          }, cancellationToken, false, customTransformers).emitResult;
          if (declDiagnostics) {
            program.restoreState();
            buildResult = buildErrors(state, projectPath, program, config, declDiagnostics, BuildResultFlags.DeclarationEmitErrors, "Declaration file");
            step = Step.QueueReferencingProjects;
            return {
              emitSkipped: true,
              diagnostics: emitResult.diagnostics
            };
          }
          var host = state.host, compilerHost = state.compilerHost;
          var resultFlags = BuildResultFlags.DeclarationOutputUnchanged;
          var newestDeclarationFileContentChangedTime = minimumDate;
          var anyDtsChanged = false;
          var emitterDiagnostics = ts2.createDiagnosticCollection();
          var emittedOutputs = ts2.createMap();
          outputFiles.forEach(function(_a) {
            var name = _a.name, text = _a.text, writeByteOrderMark = _a.writeByteOrderMark;
            var priorChangeTime;
            if (!anyDtsChanged && isDeclarationFile(name)) {
              if (host.fileExists(name) && state.readFileWithCache(name) === text) {
                priorChangeTime = host.getModifiedTime(name);
              } else {
                resultFlags &= ~BuildResultFlags.DeclarationOutputUnchanged;
                anyDtsChanged = true;
              }
            }
            emittedOutputs.set(toPath(state, name), name);
            ts2.writeFile(writeFileCallback ? { writeFile: writeFileCallback } : compilerHost, emitterDiagnostics, name, text, writeByteOrderMark);
            if (priorChangeTime !== void 0) {
              newestDeclarationFileContentChangedTime = newer(priorChangeTime, newestDeclarationFileContentChangedTime);
            }
          });
          finishEmit(emitterDiagnostics, emittedOutputs, newestDeclarationFileContentChangedTime, anyDtsChanged, outputFiles.length ? outputFiles[0].name : ts2.getFirstProjectOutput(config, !host.useCaseSensitiveFileNames()), resultFlags);
          return emitResult;
        }
        function finishEmit(emitterDiagnostics, emittedOutputs, priorNewestUpdateTime, newestDeclarationFileContentChangedTimeIsMaximumDate, oldestOutputFileName, resultFlags) {
          var emitDiagnostics = emitterDiagnostics.getDiagnostics();
          if (emitDiagnostics.length) {
            buildResult = buildErrors(state, projectPath, program, config, emitDiagnostics, BuildResultFlags.EmitErrors, "Emit");
            step = Step.QueueReferencingProjects;
            return emitDiagnostics;
          }
          if (state.writeFileName) {
            emittedOutputs.forEach(function(name) {
              return listEmittedFile(state, config, name);
            });
            if (program)
              ts2.listFiles(program, state.writeFileName);
          }
          var newestDeclarationFileContentChangedTime = updateOutputTimestampsWorker(state, config, priorNewestUpdateTime, ts2.Diagnostics.Updating_unchanged_output_timestamps_of_project_0, emittedOutputs);
          state.diagnostics.delete(projectPath);
          state.projectStatus.set(projectPath, {
            type: ts2.UpToDateStatusType.UpToDate,
            newestDeclarationFileContentChangedTime: newestDeclarationFileContentChangedTimeIsMaximumDate ? maximumDate : newestDeclarationFileContentChangedTime,
            oldestOutputFileName
          });
          afterProgramDone(state, projectPath, program, config);
          state.projectCompilerOptions = state.baseCompilerOptions;
          step = Step.QueueReferencingProjects;
          buildResult = resultFlags;
          return emitDiagnostics;
        }
        function emitBundle(writeFileCallback, customTransformers) {
          ts2.Debug.assert(kind === InvalidatedProjectKind.UpdateBundle);
          if (state.options.dry) {
            reportStatus(state, ts2.Diagnostics.A_non_dry_build_would_update_output_of_project_0, project);
            buildResult = BuildResultFlags.Success;
            step = Step.QueueReferencingProjects;
            return void 0;
          }
          if (state.options.verbose)
            reportStatus(state, ts2.Diagnostics.Updating_output_of_project_0, project);
          var compilerHost = state.compilerHost;
          state.projectCompilerOptions = config.options;
          var outputFiles = ts2.emitUsingBuildInfo(config, compilerHost, function(ref) {
            var refName = resolveProjectName(state, ref.path);
            return parseConfigFile(state, refName, toResolvedConfigFilePath(state, refName));
          }, customTransformers);
          if (ts2.isString(outputFiles)) {
            reportStatus(state, ts2.Diagnostics.Cannot_update_output_of_project_0_because_there_was_error_reading_file_1, project, relName(state, outputFiles));
            step = Step.BuildInvalidatedProjectOfBundle;
            return invalidatedProjectOfBundle = createBuildOrUpdateInvalidedProject(InvalidatedProjectKind.Build, state, project, projectPath, projectIndex, config, buildOrder);
          }
          ts2.Debug.assert(!!outputFiles.length);
          var emitterDiagnostics = ts2.createDiagnosticCollection();
          var emittedOutputs = ts2.createMap();
          outputFiles.forEach(function(_a) {
            var name = _a.name, text = _a.text, writeByteOrderMark = _a.writeByteOrderMark;
            emittedOutputs.set(toPath(state, name), name);
            ts2.writeFile(writeFileCallback ? { writeFile: writeFileCallback } : compilerHost, emitterDiagnostics, name, text, writeByteOrderMark);
          });
          var emitDiagnostics = finishEmit(emitterDiagnostics, emittedOutputs, minimumDate, false, outputFiles[0].name, BuildResultFlags.DeclarationOutputUnchanged);
          return { emitSkipped: false, diagnostics: emitDiagnostics };
        }
        function executeSteps(till, cancellationToken, writeFile, customTransformers) {
          while (step <= till && step < Step.Done) {
            var currentStep = step;
            switch (step) {
              case Step.CreateProgram:
                createProgram();
                break;
              case Step.SyntaxDiagnostics:
                getSyntaxDiagnostics(cancellationToken);
                break;
              case Step.SemanticDiagnostics:
                getSemanticDiagnostics(cancellationToken);
                break;
              case Step.Emit:
                emit(writeFile, cancellationToken, customTransformers);
                break;
              case Step.EmitBundle:
                emitBundle(writeFile, customTransformers);
                break;
              case Step.BuildInvalidatedProjectOfBundle:
                ts2.Debug.checkDefined(invalidatedProjectOfBundle).done(cancellationToken);
                step = Step.Done;
                break;
              case Step.QueueReferencingProjects:
                queueReferencingProjects(state, project, projectPath, projectIndex, config, buildOrder, ts2.Debug.checkDefined(buildResult));
                step++;
                break;
              case Step.Done:
              default:
                ts2.assertType(step);
            }
            ts2.Debug.assert(step > currentStep);
          }
        }
      }
      function needsBuild(_a, status, config) {
        var options = _a.options;
        if (status.type !== ts2.UpToDateStatusType.OutOfDateWithPrepend || options.force)
          return true;
        return config.fileNames.length === 0 || !!ts2.getConfigFileParsingDiagnostics(config).length || !ts2.isIncrementalCompilation(config.options);
      }
      function getNextInvalidatedProject(state, buildOrder, reportQueue) {
        if (!state.projectPendingBuild.size)
          return void 0;
        if (isCircularBuildOrder(buildOrder))
          return void 0;
        if (state.currentInvalidatedProject) {
          return ts2.arrayIsEqualTo(state.currentInvalidatedProject.buildOrder, buildOrder) ? state.currentInvalidatedProject : void 0;
        }
        var options = state.options, projectPendingBuild = state.projectPendingBuild;
        for (var projectIndex = 0; projectIndex < buildOrder.length; projectIndex++) {
          var project = buildOrder[projectIndex];
          var projectPath = toResolvedConfigFilePath(state, project);
          var reloadLevel = state.projectPendingBuild.get(projectPath);
          if (reloadLevel === void 0)
            continue;
          if (reportQueue) {
            reportQueue = false;
            reportBuildQueue(state, buildOrder);
          }
          var config = parseConfigFile(state, project, projectPath);
          if (!config) {
            reportParseConfigFileDiagnostic(state, projectPath);
            projectPendingBuild.delete(projectPath);
            continue;
          }
          if (reloadLevel === ts2.ConfigFileProgramReloadLevel.Full) {
            watchConfigFile(state, project, projectPath, config);
            watchWildCardDirectories(state, project, projectPath, config);
            watchInputFiles(state, project, projectPath, config);
          } else if (reloadLevel === ts2.ConfigFileProgramReloadLevel.Partial) {
            var result = ts2.getFileNamesFromConfigSpecs(config.configFileSpecs, ts2.getDirectoryPath(project), config.options, state.parseConfigFileHost);
            ts2.updateErrorForNoInputFiles(result, project, config.configFileSpecs, config.errors, ts2.canJsonReportNoInutFiles(config.raw));
            config.fileNames = result.fileNames;
            watchInputFiles(state, project, projectPath, config);
          }
          var status = getUpToDateStatus(state, config, projectPath);
          verboseReportProjectStatus(state, project, status);
          if (!options.force) {
            if (status.type === ts2.UpToDateStatusType.UpToDate) {
              reportAndStoreErrors(state, projectPath, ts2.getConfigFileParsingDiagnostics(config));
              projectPendingBuild.delete(projectPath);
              if (options.dry) {
                reportStatus(state, ts2.Diagnostics.Project_0_is_up_to_date, project);
              }
              continue;
            }
            if (status.type === ts2.UpToDateStatusType.UpToDateWithUpstreamTypes) {
              reportAndStoreErrors(state, projectPath, ts2.getConfigFileParsingDiagnostics(config));
              return createUpdateOutputFileStampsProject(state, project, projectPath, config, buildOrder);
            }
          }
          if (status.type === ts2.UpToDateStatusType.UpstreamBlocked) {
            reportAndStoreErrors(state, projectPath, ts2.getConfigFileParsingDiagnostics(config));
            projectPendingBuild.delete(projectPath);
            if (options.verbose) {
              reportStatus(state, status.upstreamProjectBlocked ? ts2.Diagnostics.Skipping_build_of_project_0_because_its_dependency_1_was_not_built : ts2.Diagnostics.Skipping_build_of_project_0_because_its_dependency_1_has_errors, project, status.upstreamProjectName);
            }
            continue;
          }
          if (status.type === ts2.UpToDateStatusType.ContainerOnly) {
            reportAndStoreErrors(state, projectPath, ts2.getConfigFileParsingDiagnostics(config));
            projectPendingBuild.delete(projectPath);
            continue;
          }
          return createBuildOrUpdateInvalidedProject(needsBuild(state, status, config) ? InvalidatedProjectKind.Build : InvalidatedProjectKind.UpdateBundle, state, project, projectPath, projectIndex, config, buildOrder);
        }
        return void 0;
      }
      function listEmittedFile(_a, proj, file) {
        var writeFileName = _a.writeFileName;
        if (writeFileName && proj.options.listEmittedFiles) {
          writeFileName("TSFILE: " + file);
        }
      }
      function getOldProgram(_a, proj, parsed) {
        var options = _a.options, builderPrograms = _a.builderPrograms, compilerHost = _a.compilerHost;
        if (options.force)
          return void 0;
        var value = builderPrograms.get(proj);
        if (value)
          return value;
        return ts2.readBuilderProgram(parsed.options, compilerHost);
      }
      function afterProgramDone(_a, proj, program, config) {
        var host = _a.host, watch = _a.watch, builderPrograms = _a.builderPrograms;
        if (program) {
          if (host.afterProgramEmitAndDiagnostics) {
            host.afterProgramEmitAndDiagnostics(program);
          }
          if (watch) {
            program.releaseProgram();
            builderPrograms.set(proj, program);
          }
        } else if (host.afterEmitBundle) {
          host.afterEmitBundle(config);
        }
      }
      function buildErrors(state, resolvedPath, program, config, diagnostics, errorFlags, errorType) {
        reportAndStoreErrors(state, resolvedPath, diagnostics);
        if (program && state.writeFileName)
          ts2.listFiles(program, state.writeFileName);
        state.projectStatus.set(resolvedPath, { type: ts2.UpToDateStatusType.Unbuildable, reason: errorType + " errors" });
        afterProgramDone(state, resolvedPath, program, config);
        state.projectCompilerOptions = state.baseCompilerOptions;
        return errorFlags;
      }
      function updateModuleResolutionCache(state, proj, config) {
        if (!state.moduleResolutionCache)
          return;
        var moduleResolutionCache = state.moduleResolutionCache;
        var projPath = toPath(state, proj);
        if (moduleResolutionCache.directoryToModuleNameMap.redirectsMap.size === 0) {
          ts2.Debug.assert(moduleResolutionCache.moduleNameToDirectoryMap.redirectsMap.size === 0);
          moduleResolutionCache.directoryToModuleNameMap.redirectsMap.set(projPath, moduleResolutionCache.directoryToModuleNameMap.ownMap);
          moduleResolutionCache.moduleNameToDirectoryMap.redirectsMap.set(projPath, moduleResolutionCache.moduleNameToDirectoryMap.ownMap);
        } else {
          ts2.Debug.assert(moduleResolutionCache.moduleNameToDirectoryMap.redirectsMap.size > 0);
          var ref = {
            sourceFile: config.options.configFile,
            commandLine: config
          };
          moduleResolutionCache.directoryToModuleNameMap.setOwnMap(moduleResolutionCache.directoryToModuleNameMap.getOrCreateMapOfCacheRedirects(ref));
          moduleResolutionCache.moduleNameToDirectoryMap.setOwnMap(moduleResolutionCache.moduleNameToDirectoryMap.getOrCreateMapOfCacheRedirects(ref));
        }
        moduleResolutionCache.directoryToModuleNameMap.setOwnOptions(config.options);
        moduleResolutionCache.moduleNameToDirectoryMap.setOwnOptions(config.options);
      }
      function checkConfigFileUpToDateStatus(state, configFile, oldestOutputFileTime, oldestOutputFileName) {
        var tsconfigTime = state.host.getModifiedTime(configFile) || ts2.missingFileModifiedTime;
        if (oldestOutputFileTime < tsconfigTime) {
          return {
            type: ts2.UpToDateStatusType.OutOfDateWithSelf,
            outOfDateOutputFileName: oldestOutputFileName,
            newerInputFileName: configFile
          };
        }
      }
      function getUpToDateStatusWorker(state, project, resolvedPath) {
        var newestInputFileName = void 0;
        var newestInputFileTime = minimumDate;
        var host = state.host;
        for (var _i = 0, _a = project.fileNames; _i < _a.length; _i++) {
          var inputFile = _a[_i];
          if (!host.fileExists(inputFile)) {
            return {
              type: ts2.UpToDateStatusType.Unbuildable,
              reason: inputFile + " does not exist"
            };
          }
          var inputTime = host.getModifiedTime(inputFile) || ts2.missingFileModifiedTime;
          if (inputTime > newestInputFileTime) {
            newestInputFileName = inputFile;
            newestInputFileTime = inputTime;
          }
        }
        if (!project.fileNames.length && !ts2.canJsonReportNoInutFiles(project.raw)) {
          return {
            type: ts2.UpToDateStatusType.ContainerOnly
          };
        }
        var outputs = ts2.getAllProjectOutputs(project, !host.useCaseSensitiveFileNames());
        var oldestOutputFileName = "(none)";
        var oldestOutputFileTime = maximumDate;
        var newestOutputFileName = "(none)";
        var newestOutputFileTime = minimumDate;
        var missingOutputFileName;
        var newestDeclarationFileContentChangedTime = minimumDate;
        var isOutOfDateWithInputs = false;
        for (var _b = 0, outputs_1 = outputs; _b < outputs_1.length; _b++) {
          var output = outputs_1[_b];
          if (!host.fileExists(output)) {
            missingOutputFileName = output;
            break;
          }
          var outputTime = host.getModifiedTime(output) || ts2.missingFileModifiedTime;
          if (outputTime < oldestOutputFileTime) {
            oldestOutputFileTime = outputTime;
            oldestOutputFileName = output;
          }
          if (outputTime < newestInputFileTime) {
            isOutOfDateWithInputs = true;
            break;
          }
          if (outputTime > newestOutputFileTime) {
            newestOutputFileTime = outputTime;
            newestOutputFileName = output;
          }
          if (isDeclarationFile(output)) {
            var outputModifiedTime = host.getModifiedTime(output) || ts2.missingFileModifiedTime;
            newestDeclarationFileContentChangedTime = newer(newestDeclarationFileContentChangedTime, outputModifiedTime);
          }
        }
        var pseudoUpToDate = false;
        var usesPrepend = false;
        var upstreamChangedProject;
        if (project.projectReferences) {
          state.projectStatus.set(resolvedPath, { type: ts2.UpToDateStatusType.ComputingUpstream });
          for (var _c = 0, _d = project.projectReferences; _c < _d.length; _c++) {
            var ref = _d[_c];
            usesPrepend = usesPrepend || !!ref.prepend;
            var resolvedRef = ts2.resolveProjectReferencePath(ref);
            var resolvedRefPath = toResolvedConfigFilePath(state, resolvedRef);
            var refStatus = getUpToDateStatus(state, parseConfigFile(state, resolvedRef, resolvedRefPath), resolvedRefPath);
            if (refStatus.type === ts2.UpToDateStatusType.ComputingUpstream || refStatus.type === ts2.UpToDateStatusType.ContainerOnly) {
              continue;
            }
            if (refStatus.type === ts2.UpToDateStatusType.Unbuildable || refStatus.type === ts2.UpToDateStatusType.UpstreamBlocked) {
              return {
                type: ts2.UpToDateStatusType.UpstreamBlocked,
                upstreamProjectName: ref.path,
                upstreamProjectBlocked: refStatus.type === ts2.UpToDateStatusType.UpstreamBlocked
              };
            }
            if (refStatus.type !== ts2.UpToDateStatusType.UpToDate) {
              return {
                type: ts2.UpToDateStatusType.UpstreamOutOfDate,
                upstreamProjectName: ref.path
              };
            }
            if (!missingOutputFileName) {
              if (refStatus.newestInputFileTime && refStatus.newestInputFileTime <= oldestOutputFileTime) {
                continue;
              }
              if (refStatus.newestDeclarationFileContentChangedTime && refStatus.newestDeclarationFileContentChangedTime <= oldestOutputFileTime) {
                pseudoUpToDate = true;
                upstreamChangedProject = ref.path;
                continue;
              }
              ts2.Debug.assert(oldestOutputFileName !== void 0, "Should have an oldest output filename here");
              return {
                type: ts2.UpToDateStatusType.OutOfDateWithUpstream,
                outOfDateOutputFileName: oldestOutputFileName,
                newerProjectName: ref.path
              };
            }
          }
        }
        if (missingOutputFileName !== void 0) {
          return {
            type: ts2.UpToDateStatusType.OutputMissing,
            missingOutputFileName
          };
        }
        if (isOutOfDateWithInputs) {
          return {
            type: ts2.UpToDateStatusType.OutOfDateWithSelf,
            outOfDateOutputFileName: oldestOutputFileName,
            newerInputFileName: newestInputFileName
          };
        } else {
          var configStatus = checkConfigFileUpToDateStatus(state, project.options.configFilePath, oldestOutputFileTime, oldestOutputFileName);
          if (configStatus)
            return configStatus;
          var extendedConfigStatus = ts2.forEach(project.options.configFile.extendedSourceFiles || ts2.emptyArray, function(configFile) {
            return checkConfigFileUpToDateStatus(state, configFile, oldestOutputFileTime, oldestOutputFileName);
          });
          if (extendedConfigStatus)
            return extendedConfigStatus;
        }
        if (!state.buildInfoChecked.has(resolvedPath)) {
          state.buildInfoChecked.set(resolvedPath, true);
          var buildInfoPath = ts2.getTsBuildInfoEmitOutputFilePath(project.options);
          if (buildInfoPath) {
            var value = state.readFileWithCache(buildInfoPath);
            var buildInfo = value && ts2.getBuildInfo(value);
            if (buildInfo && (buildInfo.bundle || buildInfo.program) && buildInfo.version !== ts2.version) {
              return {
                type: ts2.UpToDateStatusType.TsVersionOutputOfDate,
                version: buildInfo.version
              };
            }
          }
        }
        if (usesPrepend && pseudoUpToDate) {
          return {
            type: ts2.UpToDateStatusType.OutOfDateWithPrepend,
            outOfDateOutputFileName: oldestOutputFileName,
            newerProjectName: upstreamChangedProject
          };
        }
        return {
          type: pseudoUpToDate ? ts2.UpToDateStatusType.UpToDateWithUpstreamTypes : ts2.UpToDateStatusType.UpToDate,
          newestDeclarationFileContentChangedTime,
          newestInputFileTime,
          newestOutputFileTime,
          newestInputFileName,
          newestOutputFileName,
          oldestOutputFileName
        };
      }
      function getUpToDateStatus(state, project, resolvedPath) {
        if (project === void 0) {
          return { type: ts2.UpToDateStatusType.Unbuildable, reason: "File deleted mid-build" };
        }
        var prior = state.projectStatus.get(resolvedPath);
        if (prior !== void 0) {
          return prior;
        }
        var actual = getUpToDateStatusWorker(state, project, resolvedPath);
        state.projectStatus.set(resolvedPath, actual);
        return actual;
      }
      function updateOutputTimestampsWorker(state, proj, priorNewestUpdateTime, verboseMessage, skipOutputs) {
        var host = state.host;
        var outputs = ts2.getAllProjectOutputs(proj, !host.useCaseSensitiveFileNames());
        if (!skipOutputs || outputs.length !== skipOutputs.size) {
          var reportVerbose = !!state.options.verbose;
          var now = host.now ? host.now() : new Date();
          for (var _i = 0, outputs_2 = outputs; _i < outputs_2.length; _i++) {
            var file = outputs_2[_i];
            if (skipOutputs && skipOutputs.has(toPath(state, file))) {
              continue;
            }
            if (reportVerbose) {
              reportVerbose = false;
              reportStatus(state, verboseMessage, proj.options.configFilePath);
            }
            if (isDeclarationFile(file)) {
              priorNewestUpdateTime = newer(priorNewestUpdateTime, host.getModifiedTime(file) || ts2.missingFileModifiedTime);
            }
            host.setModifiedTime(file, now);
          }
        }
        return priorNewestUpdateTime;
      }
      function updateOutputTimestamps(state, proj, resolvedPath) {
        if (state.options.dry) {
          return reportStatus(state, ts2.Diagnostics.A_non_dry_build_would_update_timestamps_for_output_of_project_0, proj.options.configFilePath);
        }
        var priorNewestUpdateTime = updateOutputTimestampsWorker(state, proj, minimumDate, ts2.Diagnostics.Updating_output_timestamps_of_project_0);
        state.projectStatus.set(resolvedPath, {
          type: ts2.UpToDateStatusType.UpToDate,
          newestDeclarationFileContentChangedTime: priorNewestUpdateTime,
          oldestOutputFileName: ts2.getFirstProjectOutput(proj, !state.host.useCaseSensitiveFileNames())
        });
      }
      function queueReferencingProjects(state, project, projectPath, projectIndex, config, buildOrder, buildResult) {
        if (buildResult & BuildResultFlags.AnyErrors)
          return;
        if (!config.options.composite)
          return;
        for (var index = projectIndex + 1; index < buildOrder.length; index++) {
          var nextProject = buildOrder[index];
          var nextProjectPath = toResolvedConfigFilePath(state, nextProject);
          if (state.projectPendingBuild.has(nextProjectPath))
            continue;
          var nextProjectConfig = parseConfigFile(state, nextProject, nextProjectPath);
          if (!nextProjectConfig || !nextProjectConfig.projectReferences)
            continue;
          for (var _i = 0, _a = nextProjectConfig.projectReferences; _i < _a.length; _i++) {
            var ref = _a[_i];
            var resolvedRefPath = resolveProjectName(state, ref.path);
            if (toResolvedConfigFilePath(state, resolvedRefPath) !== projectPath)
              continue;
            var status = state.projectStatus.get(nextProjectPath);
            if (status) {
              switch (status.type) {
                case ts2.UpToDateStatusType.UpToDate:
                  if (buildResult & BuildResultFlags.DeclarationOutputUnchanged) {
                    if (ref.prepend) {
                      state.projectStatus.set(nextProjectPath, {
                        type: ts2.UpToDateStatusType.OutOfDateWithPrepend,
                        outOfDateOutputFileName: status.oldestOutputFileName,
                        newerProjectName: project
                      });
                    } else {
                      status.type = ts2.UpToDateStatusType.UpToDateWithUpstreamTypes;
                    }
                    break;
                  }
                case ts2.UpToDateStatusType.UpToDateWithUpstreamTypes:
                case ts2.UpToDateStatusType.OutOfDateWithPrepend:
                  if (!(buildResult & BuildResultFlags.DeclarationOutputUnchanged)) {
                    state.projectStatus.set(nextProjectPath, {
                      type: ts2.UpToDateStatusType.OutOfDateWithUpstream,
                      outOfDateOutputFileName: status.type === ts2.UpToDateStatusType.OutOfDateWithPrepend ? status.outOfDateOutputFileName : status.oldestOutputFileName,
                      newerProjectName: project
                    });
                  }
                  break;
                case ts2.UpToDateStatusType.UpstreamBlocked:
                  if (toResolvedConfigFilePath(state, resolveProjectName(state, status.upstreamProjectName)) === projectPath) {
                    clearProjectStatus(state, nextProjectPath);
                  }
                  break;
              }
            }
            addProjToQueue(state, nextProjectPath, ts2.ConfigFileProgramReloadLevel.None);
            break;
          }
        }
      }
      function build(state, project, cancellationToken, onlyReferences) {
        var buildOrder = getBuildOrderFor(state, project, onlyReferences);
        if (!buildOrder)
          return ts2.ExitStatus.InvalidProject_OutputsSkipped;
        setupInitialBuild(state, cancellationToken);
        var reportQueue = true;
        var successfulProjects = 0;
        while (true) {
          var invalidatedProject = getNextInvalidatedProject(state, buildOrder, reportQueue);
          if (!invalidatedProject)
            break;
          reportQueue = false;
          invalidatedProject.done(cancellationToken);
          if (!state.diagnostics.has(invalidatedProject.projectPath))
            successfulProjects++;
        }
        disableCache(state);
        reportErrorSummary(state, buildOrder);
        startWatching(state, buildOrder);
        return isCircularBuildOrder(buildOrder) ? ts2.ExitStatus.ProjectReferenceCycle_OutputsSkipped : !buildOrder.some(function(p) {
          return state.diagnostics.has(toResolvedConfigFilePath(state, p));
        }) ? ts2.ExitStatus.Success : successfulProjects ? ts2.ExitStatus.DiagnosticsPresent_OutputsGenerated : ts2.ExitStatus.DiagnosticsPresent_OutputsSkipped;
      }
      function clean(state, project, onlyReferences) {
        var buildOrder = getBuildOrderFor(state, project, onlyReferences);
        if (!buildOrder)
          return ts2.ExitStatus.InvalidProject_OutputsSkipped;
        if (isCircularBuildOrder(buildOrder)) {
          reportErrors(state, buildOrder.circularDiagnostics);
          return ts2.ExitStatus.ProjectReferenceCycle_OutputsSkipped;
        }
        var options = state.options, host = state.host;
        var filesToDelete = options.dry ? [] : void 0;
        for (var _i = 0, buildOrder_1 = buildOrder; _i < buildOrder_1.length; _i++) {
          var proj = buildOrder_1[_i];
          var resolvedPath = toResolvedConfigFilePath(state, proj);
          var parsed = parseConfigFile(state, proj, resolvedPath);
          if (parsed === void 0) {
            reportParseConfigFileDiagnostic(state, resolvedPath);
            continue;
          }
          var outputs = ts2.getAllProjectOutputs(parsed, !host.useCaseSensitiveFileNames());
          for (var _a = 0, outputs_3 = outputs; _a < outputs_3.length; _a++) {
            var output = outputs_3[_a];
            if (host.fileExists(output)) {
              if (filesToDelete) {
                filesToDelete.push(output);
              } else {
                host.deleteFile(output);
                invalidateProject(state, resolvedPath, ts2.ConfigFileProgramReloadLevel.None);
              }
            }
          }
        }
        if (filesToDelete) {
          reportStatus(state, ts2.Diagnostics.A_non_dry_build_would_delete_the_following_files_Colon_0, filesToDelete.map(function(f) {
            return "\r\n * " + f;
          }).join(""));
        }
        return ts2.ExitStatus.Success;
      }
      function invalidateProject(state, resolved, reloadLevel) {
        if (state.host.getParsedCommandLine && reloadLevel === ts2.ConfigFileProgramReloadLevel.Partial) {
          reloadLevel = ts2.ConfigFileProgramReloadLevel.Full;
        }
        if (reloadLevel === ts2.ConfigFileProgramReloadLevel.Full) {
          state.configFileCache.delete(resolved);
          state.buildOrder = void 0;
        }
        state.needsSummary = true;
        clearProjectStatus(state, resolved);
        addProjToQueue(state, resolved, reloadLevel);
        enableCache(state);
      }
      function invalidateProjectAndScheduleBuilds(state, resolvedPath, reloadLevel) {
        state.reportFileChangeDetected = true;
        invalidateProject(state, resolvedPath, reloadLevel);
        scheduleBuildInvalidatedProject(state);
      }
      function scheduleBuildInvalidatedProject(state) {
        var hostWithWatch = state.hostWithWatch;
        if (!hostWithWatch.setTimeout || !hostWithWatch.clearTimeout) {
          return;
        }
        if (state.timerToBuildInvalidatedProject) {
          hostWithWatch.clearTimeout(state.timerToBuildInvalidatedProject);
        }
        state.timerToBuildInvalidatedProject = hostWithWatch.setTimeout(buildNextInvalidatedProject, 250, state);
      }
      function buildNextInvalidatedProject(state) {
        state.timerToBuildInvalidatedProject = void 0;
        if (state.reportFileChangeDetected) {
          state.reportFileChangeDetected = false;
          state.projectErrorsReported.clear();
          reportWatchStatus(state, ts2.Diagnostics.File_change_detected_Starting_incremental_compilation);
        }
        var buildOrder = getBuildOrder(state);
        var invalidatedProject = getNextInvalidatedProject(state, buildOrder, false);
        if (invalidatedProject) {
          invalidatedProject.done();
          if (state.projectPendingBuild.size) {
            if (state.watch && !state.timerToBuildInvalidatedProject) {
              scheduleBuildInvalidatedProject(state);
            }
            return;
          }
        }
        disableCache(state);
        reportErrorSummary(state, buildOrder);
      }
      function watchConfigFile(state, resolved, resolvedPath, parsed) {
        if (!state.watch || state.allWatchedConfigFiles.has(resolvedPath))
          return;
        state.allWatchedConfigFiles.set(resolvedPath, state.watchFile(state.hostWithWatch, resolved, function() {
          invalidateProjectAndScheduleBuilds(state, resolvedPath, ts2.ConfigFileProgramReloadLevel.Full);
        }, ts2.PollingInterval.High, parsed === null || parsed === void 0 ? void 0 : parsed.watchOptions, ts2.WatchType.ConfigFile, resolved));
      }
      function isSameFile(state, file1, file2) {
        return ts2.comparePaths(file1, file2, state.currentDirectory, !state.host.useCaseSensitiveFileNames()) === 0;
      }
      function isOutputFile(state, fileName, configFile) {
        if (configFile.options.noEmit)
          return false;
        if (!ts2.fileExtensionIs(fileName, ".d.ts") && (ts2.fileExtensionIs(fileName, ".ts") || ts2.fileExtensionIs(fileName, ".tsx"))) {
          return false;
        }
        var out = configFile.options.outFile || configFile.options.out;
        if (out && (isSameFile(state, fileName, out) || isSameFile(state, fileName, ts2.removeFileExtension(out) + ".d.ts"))) {
          return true;
        }
        if (configFile.options.declarationDir && ts2.containsPath(configFile.options.declarationDir, fileName, state.currentDirectory, !state.host.useCaseSensitiveFileNames())) {
          return true;
        }
        if (configFile.options.outDir && ts2.containsPath(configFile.options.outDir, fileName, state.currentDirectory, !state.host.useCaseSensitiveFileNames())) {
          return true;
        }
        return !ts2.forEach(configFile.fileNames, function(inputFile) {
          return isSameFile(state, fileName, inputFile);
        });
      }
      function watchWildCardDirectories(state, resolved, resolvedPath, parsed) {
        if (!state.watch)
          return;
        ts2.updateWatchingWildcardDirectories(getOrCreateValueMapFromConfigFileMap(state.allWatchedWildcardDirectories, resolvedPath), ts2.createMapFromTemplate(parsed.configFileSpecs.wildcardDirectories), function(dir, flags) {
          return state.watchDirectory(state.hostWithWatch, dir, function(fileOrDirectory) {
            var fileOrDirectoryPath = toPath(state, fileOrDirectory);
            if (fileOrDirectoryPath !== toPath(state, dir) && ts2.hasExtension(fileOrDirectoryPath) && !ts2.isSupportedSourceFileName(fileOrDirectory, parsed.options)) {
              state.writeLog("Project: " + resolved + " Detected file add/remove of non supported extension: " + fileOrDirectory);
              return;
            }
            if (isOutputFile(state, fileOrDirectory, parsed)) {
              state.writeLog(fileOrDirectory + " is output file");
              return;
            }
            invalidateProjectAndScheduleBuilds(state, resolvedPath, ts2.ConfigFileProgramReloadLevel.Partial);
          }, flags, parsed === null || parsed === void 0 ? void 0 : parsed.watchOptions, ts2.WatchType.WildcardDirectory, resolved);
        });
      }
      function watchInputFiles(state, resolved, resolvedPath, parsed) {
        if (!state.watch)
          return;
        ts2.mutateMap(getOrCreateValueMapFromConfigFileMap(state.allWatchedInputFiles, resolvedPath), ts2.arrayToMap(parsed.fileNames, function(fileName) {
          return toPath(state, fileName);
        }), {
          createNewValue: function(path2, input) {
            return state.watchFilePath(state.hostWithWatch, input, function() {
              return invalidateProjectAndScheduleBuilds(state, resolvedPath, ts2.ConfigFileProgramReloadLevel.None);
            }, ts2.PollingInterval.Low, parsed === null || parsed === void 0 ? void 0 : parsed.watchOptions, path2, ts2.WatchType.SourceFile, resolved);
          },
          onDeleteValue: ts2.closeFileWatcher
        });
      }
      function startWatching(state, buildOrder) {
        if (!state.watchAllProjectsPending)
          return;
        state.watchAllProjectsPending = false;
        for (var _i = 0, _a = getBuildOrderFromAnyBuildOrder(buildOrder); _i < _a.length; _i++) {
          var resolved = _a[_i];
          var resolvedPath = toResolvedConfigFilePath(state, resolved);
          var cfg = parseConfigFile(state, resolved, resolvedPath);
          watchConfigFile(state, resolved, resolvedPath, cfg);
          if (cfg) {
            watchWildCardDirectories(state, resolved, resolvedPath, cfg);
            watchInputFiles(state, resolved, resolvedPath, cfg);
          }
        }
      }
      function stopWatching(state) {
        ts2.clearMap(state.allWatchedConfigFiles, ts2.closeFileWatcher);
        ts2.clearMap(state.allWatchedWildcardDirectories, function(watchedWildcardDirectories) {
          return ts2.clearMap(watchedWildcardDirectories, ts2.closeFileWatcherOf);
        });
        ts2.clearMap(state.allWatchedInputFiles, function(watchedWildcardDirectories) {
          return ts2.clearMap(watchedWildcardDirectories, ts2.closeFileWatcher);
        });
      }
      function createSolutionBuilderWorker(watch, hostOrHostWithWatch, rootNames, options, baseWatchOptions) {
        var state = createSolutionBuilderState(watch, hostOrHostWithWatch, rootNames, options, baseWatchOptions);
        return {
          build: function(project, cancellationToken) {
            return build(state, project, cancellationToken);
          },
          clean: function(project) {
            return clean(state, project);
          },
          buildReferences: function(project, cancellationToken) {
            return build(state, project, cancellationToken, true);
          },
          cleanReferences: function(project) {
            return clean(state, project, true);
          },
          getNextInvalidatedProject: function(cancellationToken) {
            setupInitialBuild(state, cancellationToken);
            return getNextInvalidatedProject(state, getBuildOrder(state), false);
          },
          getBuildOrder: function() {
            return getBuildOrder(state);
          },
          getUpToDateStatusOfProject: function(project) {
            var configFileName = resolveProjectName(state, project);
            var configFilePath = toResolvedConfigFilePath(state, configFileName);
            return getUpToDateStatus(state, parseConfigFile(state, configFileName, configFilePath), configFilePath);
          },
          invalidateProject: function(configFilePath, reloadLevel) {
            return invalidateProject(state, configFilePath, reloadLevel || ts2.ConfigFileProgramReloadLevel.None);
          },
          buildNextInvalidatedProject: function() {
            return buildNextInvalidatedProject(state);
          },
          getAllParsedConfigs: function() {
            return ts2.arrayFrom(ts2.mapDefinedIterator(state.configFileCache.values(), function(config) {
              return isParsedCommandLine(config) ? config : void 0;
            }));
          },
          close: function() {
            return stopWatching(state);
          }
        };
      }
      function relName(state, path2) {
        return ts2.convertToRelativePath(path2, state.currentDirectory, function(f) {
          return state.getCanonicalFileName(f);
        });
      }
      function reportStatus(state, message) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
          args[_i - 2] = arguments[_i];
        }
        state.host.reportSolutionBuilderStatus(ts2.createCompilerDiagnostic.apply(void 0, __spreadArrays([message], args)));
      }
      function reportWatchStatus(state, message) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
          args[_i - 2] = arguments[_i];
        }
        if (state.hostWithWatch.onWatchStatusChange) {
          state.hostWithWatch.onWatchStatusChange(ts2.createCompilerDiagnostic.apply(void 0, __spreadArrays([message], args)), state.host.getNewLine(), state.baseCompilerOptions);
        }
      }
      function reportErrors(_a, errors) {
        var host = _a.host;
        errors.forEach(function(err) {
          return host.reportDiagnostic(err);
        });
      }
      function reportAndStoreErrors(state, proj, errors) {
        reportErrors(state, errors);
        state.projectErrorsReported.set(proj, true);
        if (errors.length) {
          state.diagnostics.set(proj, errors);
        }
      }
      function reportParseConfigFileDiagnostic(state, proj) {
        reportAndStoreErrors(state, proj, [state.configFileCache.get(proj)]);
      }
      function reportErrorSummary(state, buildOrder) {
        if (!state.needsSummary)
          return;
        state.needsSummary = false;
        var canReportSummary = state.watch || !!state.host.reportErrorSummary;
        var diagnostics = state.diagnostics;
        var totalErrors = 0;
        if (isCircularBuildOrder(buildOrder)) {
          reportBuildQueue(state, buildOrder.buildOrder);
          reportErrors(state, buildOrder.circularDiagnostics);
          if (canReportSummary)
            totalErrors += ts2.getErrorCountForSummary(buildOrder.circularDiagnostics);
        } else {
          buildOrder.forEach(function(project) {
            var projectPath = toResolvedConfigFilePath(state, project);
            if (!state.projectErrorsReported.has(projectPath)) {
              reportErrors(state, diagnostics.get(projectPath) || ts2.emptyArray);
            }
          });
          if (canReportSummary)
            diagnostics.forEach(function(singleProjectErrors) {
              return totalErrors += ts2.getErrorCountForSummary(singleProjectErrors);
            });
        }
        if (state.watch) {
          reportWatchStatus(state, ts2.getWatchErrorSummaryDiagnosticMessage(totalErrors), totalErrors);
        } else if (state.host.reportErrorSummary) {
          state.host.reportErrorSummary(totalErrors);
        }
      }
      function reportBuildQueue(state, buildQueue) {
        if (state.options.verbose) {
          reportStatus(state, ts2.Diagnostics.Projects_in_this_build_Colon_0, buildQueue.map(function(s) {
            return "\r\n    * " + relName(state, s);
          }).join(""));
        }
      }
      function reportUpToDateStatus(state, configFileName, status) {
        switch (status.type) {
          case ts2.UpToDateStatusType.OutOfDateWithSelf:
            return reportStatus(state, ts2.Diagnostics.Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2, relName(state, configFileName), relName(state, status.outOfDateOutputFileName), relName(state, status.newerInputFileName));
          case ts2.UpToDateStatusType.OutOfDateWithUpstream:
            return reportStatus(state, ts2.Diagnostics.Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2, relName(state, configFileName), relName(state, status.outOfDateOutputFileName), relName(state, status.newerProjectName));
          case ts2.UpToDateStatusType.OutputMissing:
            return reportStatus(state, ts2.Diagnostics.Project_0_is_out_of_date_because_output_file_1_does_not_exist, relName(state, configFileName), relName(state, status.missingOutputFileName));
          case ts2.UpToDateStatusType.UpToDate:
            if (status.newestInputFileTime !== void 0) {
              return reportStatus(state, ts2.Diagnostics.Project_0_is_up_to_date_because_newest_input_1_is_older_than_oldest_output_2, relName(state, configFileName), relName(state, status.newestInputFileName || ""), relName(state, status.oldestOutputFileName || ""));
            }
            break;
          case ts2.UpToDateStatusType.OutOfDateWithPrepend:
            return reportStatus(state, ts2.Diagnostics.Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed, relName(state, configFileName), relName(state, status.newerProjectName));
          case ts2.UpToDateStatusType.UpToDateWithUpstreamTypes:
            return reportStatus(state, ts2.Diagnostics.Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies, relName(state, configFileName));
          case ts2.UpToDateStatusType.UpstreamOutOfDate:
            return reportStatus(state, ts2.Diagnostics.Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date, relName(state, configFileName), relName(state, status.upstreamProjectName));
          case ts2.UpToDateStatusType.UpstreamBlocked:
            return reportStatus(state, status.upstreamProjectBlocked ? ts2.Diagnostics.Project_0_can_t_be_built_because_its_dependency_1_was_not_built : ts2.Diagnostics.Project_0_can_t_be_built_because_its_dependency_1_has_errors, relName(state, configFileName), relName(state, status.upstreamProjectName));
          case ts2.UpToDateStatusType.Unbuildable:
            return reportStatus(state, ts2.Diagnostics.Failed_to_parse_file_0_Colon_1, relName(state, configFileName), status.reason);
          case ts2.UpToDateStatusType.TsVersionOutputOfDate:
            return reportStatus(state, ts2.Diagnostics.Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_current_version_2, relName(state, configFileName), status.version, ts2.version);
          case ts2.UpToDateStatusType.ContainerOnly:
          case ts2.UpToDateStatusType.ComputingUpstream:
            break;
          default:
            ts2.assertType(status);
        }
      }
      function verboseReportProjectStatus(state, configFileName, status) {
        if (state.options.verbose) {
          reportUpToDateStatus(state, configFileName, status);
        }
      }
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var server;
      (function(server2) {
        server2.ActionSet = "action::set";
        server2.ActionInvalidate = "action::invalidate";
        server2.ActionPackageInstalled = "action::packageInstalled";
        server2.EventTypesRegistry = "event::typesRegistry";
        server2.EventBeginInstallTypes = "event::beginInstallTypes";
        server2.EventEndInstallTypes = "event::endInstallTypes";
        server2.EventInitializationFailed = "event::initializationFailed";
        var Arguments;
        (function(Arguments2) {
          Arguments2.GlobalCacheLocation = "--globalTypingsCacheLocation";
          Arguments2.LogFile = "--logFile";
          Arguments2.EnableTelemetry = "--enableTelemetry";
          Arguments2.TypingSafeListLocation = "--typingSafeListLocation";
          Arguments2.TypesMapLocation = "--typesMapLocation";
          Arguments2.NpmLocation = "--npmLocation";
          Arguments2.ValidateDefaultNpmLocation = "--validateDefaultNpmLocation";
        })(Arguments = server2.Arguments || (server2.Arguments = {}));
        function hasArgument(argumentName) {
          return ts2.sys.args.indexOf(argumentName) >= 0;
        }
        server2.hasArgument = hasArgument;
        function findArgument(argumentName) {
          var index = ts2.sys.args.indexOf(argumentName);
          return index >= 0 && index < ts2.sys.args.length - 1 ? ts2.sys.args[index + 1] : void 0;
        }
        server2.findArgument = findArgument;
        function nowString() {
          var d = new Date();
          return d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds() + "." + d.getMilliseconds();
        }
        server2.nowString = nowString;
      })(server = ts2.server || (ts2.server = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var JsTyping;
      (function(JsTyping2) {
        function isTypingUpToDate(cachedTyping, availableTypingVersions) {
          var availableVersion = new ts2.Version(ts2.getProperty(availableTypingVersions, "ts" + ts2.versionMajorMinor) || ts2.getProperty(availableTypingVersions, "latest"));
          return availableVersion.compareTo(cachedTyping.version) <= 0;
        }
        JsTyping2.isTypingUpToDate = isTypingUpToDate;
        JsTyping2.nodeCoreModuleList = [
          "assert",
          "async_hooks",
          "buffer",
          "child_process",
          "cluster",
          "console",
          "constants",
          "crypto",
          "dgram",
          "dns",
          "domain",
          "events",
          "fs",
          "http",
          "https",
          "http2",
          "inspector",
          "net",
          "os",
          "path",
          "perf_hooks",
          "process",
          "punycode",
          "querystring",
          "readline",
          "repl",
          "stream",
          "string_decoder",
          "timers",
          "tls",
          "tty",
          "url",
          "util",
          "v8",
          "vm",
          "zlib"
        ];
        JsTyping2.nodeCoreModules = ts2.arrayToSet(JsTyping2.nodeCoreModuleList);
        function nonRelativeModuleNameForTypingCache(moduleName) {
          return JsTyping2.nodeCoreModules.has(moduleName) ? "node" : moduleName;
        }
        JsTyping2.nonRelativeModuleNameForTypingCache = nonRelativeModuleNameForTypingCache;
        function loadSafeList(host, safeListPath) {
          var result = ts2.readConfigFile(safeListPath, function(path2) {
            return host.readFile(path2);
          });
          return ts2.createMapFromTemplate(result.config);
        }
        JsTyping2.loadSafeList = loadSafeList;
        function loadTypesMap(host, typesMapPath) {
          var result = ts2.readConfigFile(typesMapPath, function(path2) {
            return host.readFile(path2);
          });
          if (result.config) {
            return ts2.createMapFromTemplate(result.config.simpleMap);
          }
          return void 0;
        }
        JsTyping2.loadTypesMap = loadTypesMap;
        function discoverTypings(host, log, fileNames, projectRootPath, safeList, packageNameToTypingLocation, typeAcquisition, unresolvedImports, typesRegistry) {
          if (!typeAcquisition || !typeAcquisition.enable) {
            return { cachedTypingPaths: [], newTypingNames: [], filesToWatch: [] };
          }
          var inferredTypings = ts2.createMap();
          fileNames = ts2.mapDefined(fileNames, function(fileName) {
            var path2 = ts2.normalizePath(fileName);
            if (ts2.hasJSFileExtension(path2)) {
              return path2;
            }
          });
          var filesToWatch = [];
          if (typeAcquisition.include)
            addInferredTypings(typeAcquisition.include, "Explicitly included types");
          var exclude = typeAcquisition.exclude || [];
          var possibleSearchDirs = ts2.arrayToSet(fileNames, ts2.getDirectoryPath);
          possibleSearchDirs.set(projectRootPath, true);
          possibleSearchDirs.forEach(function(_true, searchDir) {
            var packageJsonPath = ts2.combinePaths(searchDir, "package.json");
            getTypingNamesFromJson(packageJsonPath, filesToWatch);
            var bowerJsonPath = ts2.combinePaths(searchDir, "bower.json");
            getTypingNamesFromJson(bowerJsonPath, filesToWatch);
            var bowerComponentsPath = ts2.combinePaths(searchDir, "bower_components");
            getTypingNamesFromPackagesFolder(bowerComponentsPath, filesToWatch);
            var nodeModulesPath = ts2.combinePaths(searchDir, "node_modules");
            getTypingNamesFromPackagesFolder(nodeModulesPath, filesToWatch);
          });
          getTypingNamesFromSourceFileNames(fileNames);
          if (unresolvedImports) {
            var module_1 = ts2.deduplicate(unresolvedImports.map(nonRelativeModuleNameForTypingCache), ts2.equateStringsCaseSensitive, ts2.compareStringsCaseSensitive);
            addInferredTypings(module_1, "Inferred typings from unresolved imports");
          }
          packageNameToTypingLocation.forEach(function(typing, name) {
            var registryEntry = typesRegistry.get(name);
            if (inferredTypings.has(name) && inferredTypings.get(name) === void 0 && registryEntry !== void 0 && isTypingUpToDate(typing, registryEntry)) {
              inferredTypings.set(name, typing.typingLocation);
            }
          });
          for (var _i = 0, exclude_1 = exclude; _i < exclude_1.length; _i++) {
            var excludeTypingName = exclude_1[_i];
            var didDelete = inferredTypings.delete(excludeTypingName);
            if (didDelete && log)
              log("Typing for " + excludeTypingName + " is in exclude list, will be ignored.");
          }
          var newTypingNames = [];
          var cachedTypingPaths = [];
          inferredTypings.forEach(function(inferred, typing) {
            if (inferred !== void 0) {
              cachedTypingPaths.push(inferred);
            } else {
              newTypingNames.push(typing);
            }
          });
          var result = { cachedTypingPaths, newTypingNames, filesToWatch };
          if (log)
            log("Result: " + JSON.stringify(result));
          return result;
          function addInferredTyping(typingName) {
            if (!inferredTypings.has(typingName)) {
              inferredTypings.set(typingName, void 0);
            }
          }
          function addInferredTypings(typingNames, message) {
            if (log)
              log(message + ": " + JSON.stringify(typingNames));
            ts2.forEach(typingNames, addInferredTyping);
          }
          function getTypingNamesFromJson(jsonPath, filesToWatch2) {
            if (!host.fileExists(jsonPath)) {
              return;
            }
            filesToWatch2.push(jsonPath);
            var jsonConfig = ts2.readConfigFile(jsonPath, function(path2) {
              return host.readFile(path2);
            }).config;
            var jsonTypingNames = ts2.flatMap([jsonConfig.dependencies, jsonConfig.devDependencies, jsonConfig.optionalDependencies, jsonConfig.peerDependencies], ts2.getOwnKeys);
            addInferredTypings(jsonTypingNames, "Typing names in '" + jsonPath + "' dependencies");
          }
          function getTypingNamesFromSourceFileNames(fileNames2) {
            var fromFileNames = ts2.mapDefined(fileNames2, function(j) {
              if (!ts2.hasJSFileExtension(j))
                return void 0;
              var inferredTypingName = ts2.removeFileExtension(ts2.getBaseFileName(j.toLowerCase()));
              var cleanedTypingName = ts2.removeMinAndVersionNumbers(inferredTypingName);
              return safeList.get(cleanedTypingName);
            });
            if (fromFileNames.length) {
              addInferredTypings(fromFileNames, "Inferred typings from file names");
            }
            var hasJsxFile = ts2.some(fileNames2, function(f) {
              return ts2.fileExtensionIs(f, ".jsx");
            });
            if (hasJsxFile) {
              if (log)
                log("Inferred 'react' typings due to presence of '.jsx' extension");
              addInferredTyping("react");
            }
          }
          function getTypingNamesFromPackagesFolder(packagesFolderPath, filesToWatch2) {
            filesToWatch2.push(packagesFolderPath);
            if (!host.directoryExists(packagesFolderPath)) {
              return;
            }
            var fileNames2 = host.readDirectory(packagesFolderPath, [".json"], void 0, void 0, 2);
            if (log)
              log("Searching for typing names in " + packagesFolderPath + "; all files: " + JSON.stringify(fileNames2));
            var packageNames = [];
            for (var _i2 = 0, fileNames_1 = fileNames2; _i2 < fileNames_1.length; _i2++) {
              var fileName = fileNames_1[_i2];
              var normalizedFileName = ts2.normalizePath(fileName);
              var baseFileName = ts2.getBaseFileName(normalizedFileName);
              if (baseFileName !== "package.json" && baseFileName !== "bower.json") {
                continue;
              }
              var result_1 = ts2.readConfigFile(normalizedFileName, function(path2) {
                return host.readFile(path2);
              });
              var packageJson = result_1.config;
              if (baseFileName === "package.json" && packageJson._requiredBy && ts2.filter(packageJson._requiredBy, function(r) {
                return r[0] === "#" || r === "/";
              }).length === 0) {
                continue;
              }
              if (!packageJson.name) {
                continue;
              }
              var ownTypes = packageJson.types || packageJson.typings;
              if (ownTypes) {
                var absolutePath = ts2.getNormalizedAbsolutePath(ownTypes, ts2.getDirectoryPath(normalizedFileName));
                if (log)
                  log("    Package '" + packageJson.name + "' provides its own types.");
                inferredTypings.set(packageJson.name, absolutePath);
              } else {
                packageNames.push(packageJson.name);
              }
            }
            addInferredTypings(packageNames, "    Found package names");
          }
        }
        JsTyping2.discoverTypings = discoverTypings;
        var NameValidationResult;
        (function(NameValidationResult2) {
          NameValidationResult2[NameValidationResult2["Ok"] = 0] = "Ok";
          NameValidationResult2[NameValidationResult2["EmptyName"] = 1] = "EmptyName";
          NameValidationResult2[NameValidationResult2["NameTooLong"] = 2] = "NameTooLong";
          NameValidationResult2[NameValidationResult2["NameStartsWithDot"] = 3] = "NameStartsWithDot";
          NameValidationResult2[NameValidationResult2["NameStartsWithUnderscore"] = 4] = "NameStartsWithUnderscore";
          NameValidationResult2[NameValidationResult2["NameContainsNonURISafeCharacters"] = 5] = "NameContainsNonURISafeCharacters";
        })(NameValidationResult = JsTyping2.NameValidationResult || (JsTyping2.NameValidationResult = {}));
        var maxPackageNameLength = 214;
        function validatePackageName(packageName) {
          return validatePackageNameWorker(packageName, true);
        }
        JsTyping2.validatePackageName = validatePackageName;
        function validatePackageNameWorker(packageName, supportScopedPackage) {
          if (!packageName) {
            return 1;
          }
          if (packageName.length > maxPackageNameLength) {
            return 2;
          }
          if (packageName.charCodeAt(0) === 46) {
            return 3;
          }
          if (packageName.charCodeAt(0) === 95) {
            return 4;
          }
          if (supportScopedPackage) {
            var matches = /^@([^/]+)\/([^/]+)$/.exec(packageName);
            if (matches) {
              var scopeResult = validatePackageNameWorker(matches[1], false);
              if (scopeResult !== 0) {
                return { name: matches[1], isScopeName: true, result: scopeResult };
              }
              var packageResult = validatePackageNameWorker(matches[2], false);
              if (packageResult !== 0) {
                return { name: matches[2], isScopeName: false, result: packageResult };
              }
              return 0;
            }
          }
          if (encodeURIComponent(packageName) !== packageName) {
            return 5;
          }
          return 0;
        }
        function renderPackageNameValidationFailure(result, typing) {
          return typeof result === "object" ? renderPackageNameValidationFailureWorker(typing, result.result, result.name, result.isScopeName) : renderPackageNameValidationFailureWorker(typing, result, typing, false);
        }
        JsTyping2.renderPackageNameValidationFailure = renderPackageNameValidationFailure;
        function renderPackageNameValidationFailureWorker(typing, result, name, isScopeName) {
          var kind = isScopeName ? "Scope" : "Package";
          switch (result) {
            case 1:
              return "'" + typing + "':: " + kind + " name '" + name + "' cannot be empty";
            case 2:
              return "'" + typing + "':: " + kind + " name '" + name + "' should be less than " + maxPackageNameLength + " characters";
            case 3:
              return "'" + typing + "':: " + kind + " name '" + name + "' cannot start with '.'";
            case 4:
              return "'" + typing + "':: " + kind + " name '" + name + "' cannot start with '_'";
            case 5:
              return "'" + typing + "':: " + kind + " name '" + name + "' contains non URI safe characters";
            case 0:
              return ts2.Debug.fail();
            default:
              throw ts2.Debug.assertNever(result);
          }
        }
      })(JsTyping = ts2.JsTyping || (ts2.JsTyping = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var ScriptSnapshot;
      (function(ScriptSnapshot2) {
        var StringScriptSnapshot = function() {
          function StringScriptSnapshot2(text) {
            this.text = text;
          }
          StringScriptSnapshot2.prototype.getText = function(start, end) {
            return start === 0 && end === this.text.length ? this.text : this.text.substring(start, end);
          };
          StringScriptSnapshot2.prototype.getLength = function() {
            return this.text.length;
          };
          StringScriptSnapshot2.prototype.getChangeRange = function() {
            return void 0;
          };
          return StringScriptSnapshot2;
        }();
        function fromString(text) {
          return new StringScriptSnapshot(text);
        }
        ScriptSnapshot2.fromString = fromString;
      })(ScriptSnapshot = ts2.ScriptSnapshot || (ts2.ScriptSnapshot = {}));
      var PackageJsonDependencyGroup;
      (function(PackageJsonDependencyGroup2) {
        PackageJsonDependencyGroup2[PackageJsonDependencyGroup2["Dependencies"] = 1] = "Dependencies";
        PackageJsonDependencyGroup2[PackageJsonDependencyGroup2["DevDependencies"] = 2] = "DevDependencies";
        PackageJsonDependencyGroup2[PackageJsonDependencyGroup2["PeerDependencies"] = 4] = "PeerDependencies";
        PackageJsonDependencyGroup2[PackageJsonDependencyGroup2["OptionalDependencies"] = 8] = "OptionalDependencies";
        PackageJsonDependencyGroup2[PackageJsonDependencyGroup2["All"] = 15] = "All";
      })(PackageJsonDependencyGroup = ts2.PackageJsonDependencyGroup || (ts2.PackageJsonDependencyGroup = {}));
      ts2.emptyOptions = {};
      var HighlightSpanKind;
      (function(HighlightSpanKind2) {
        HighlightSpanKind2["none"] = "none";
        HighlightSpanKind2["definition"] = "definition";
        HighlightSpanKind2["reference"] = "reference";
        HighlightSpanKind2["writtenReference"] = "writtenReference";
      })(HighlightSpanKind = ts2.HighlightSpanKind || (ts2.HighlightSpanKind = {}));
      var IndentStyle;
      (function(IndentStyle2) {
        IndentStyle2[IndentStyle2["None"] = 0] = "None";
        IndentStyle2[IndentStyle2["Block"] = 1] = "Block";
        IndentStyle2[IndentStyle2["Smart"] = 2] = "Smart";
      })(IndentStyle = ts2.IndentStyle || (ts2.IndentStyle = {}));
      var SemicolonPreference;
      (function(SemicolonPreference2) {
        SemicolonPreference2["Ignore"] = "ignore";
        SemicolonPreference2["Insert"] = "insert";
        SemicolonPreference2["Remove"] = "remove";
      })(SemicolonPreference = ts2.SemicolonPreference || (ts2.SemicolonPreference = {}));
      function getDefaultFormatCodeSettings(newLineCharacter) {
        return {
          indentSize: 4,
          tabSize: 4,
          newLineCharacter: newLineCharacter || "\n",
          convertTabsToSpaces: true,
          indentStyle: IndentStyle.Smart,
          insertSpaceAfterConstructor: false,
          insertSpaceAfterCommaDelimiter: true,
          insertSpaceAfterSemicolonInForStatements: true,
          insertSpaceBeforeAndAfterBinaryOperators: true,
          insertSpaceAfterKeywordsInControlFlowStatements: true,
          insertSpaceAfterFunctionKeywordForAnonymousFunctions: false,
          insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis: false,
          insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets: false,
          insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces: true,
          insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces: false,
          insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces: false,
          insertSpaceBeforeFunctionParenthesis: false,
          placeOpenBraceOnNewLineForFunctions: false,
          placeOpenBraceOnNewLineForControlBlocks: false,
          semicolons: SemicolonPreference.Ignore,
          trimTrailingWhitespace: true
        };
      }
      ts2.getDefaultFormatCodeSettings = getDefaultFormatCodeSettings;
      ts2.testFormatSettings = getDefaultFormatCodeSettings("\n");
      var SymbolDisplayPartKind;
      (function(SymbolDisplayPartKind2) {
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["aliasName"] = 0] = "aliasName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["className"] = 1] = "className";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["enumName"] = 2] = "enumName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["fieldName"] = 3] = "fieldName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["interfaceName"] = 4] = "interfaceName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["keyword"] = 5] = "keyword";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["lineBreak"] = 6] = "lineBreak";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["numericLiteral"] = 7] = "numericLiteral";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["stringLiteral"] = 8] = "stringLiteral";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["localName"] = 9] = "localName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["methodName"] = 10] = "methodName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["moduleName"] = 11] = "moduleName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["operator"] = 12] = "operator";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["parameterName"] = 13] = "parameterName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["propertyName"] = 14] = "propertyName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["punctuation"] = 15] = "punctuation";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["space"] = 16] = "space";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["text"] = 17] = "text";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["typeParameterName"] = 18] = "typeParameterName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["enumMemberName"] = 19] = "enumMemberName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["functionName"] = 20] = "functionName";
        SymbolDisplayPartKind2[SymbolDisplayPartKind2["regularExpressionLiteral"] = 21] = "regularExpressionLiteral";
      })(SymbolDisplayPartKind = ts2.SymbolDisplayPartKind || (ts2.SymbolDisplayPartKind = {}));
      var OutliningSpanKind;
      (function(OutliningSpanKind2) {
        OutliningSpanKind2["Comment"] = "comment";
        OutliningSpanKind2["Region"] = "region";
        OutliningSpanKind2["Code"] = "code";
        OutliningSpanKind2["Imports"] = "imports";
      })(OutliningSpanKind = ts2.OutliningSpanKind || (ts2.OutliningSpanKind = {}));
      var OutputFileType;
      (function(OutputFileType2) {
        OutputFileType2[OutputFileType2["JavaScript"] = 0] = "JavaScript";
        OutputFileType2[OutputFileType2["SourceMap"] = 1] = "SourceMap";
        OutputFileType2[OutputFileType2["Declaration"] = 2] = "Declaration";
      })(OutputFileType = ts2.OutputFileType || (ts2.OutputFileType = {}));
      var EndOfLineState;
      (function(EndOfLineState2) {
        EndOfLineState2[EndOfLineState2["None"] = 0] = "None";
        EndOfLineState2[EndOfLineState2["InMultiLineCommentTrivia"] = 1] = "InMultiLineCommentTrivia";
        EndOfLineState2[EndOfLineState2["InSingleQuoteStringLiteral"] = 2] = "InSingleQuoteStringLiteral";
        EndOfLineState2[EndOfLineState2["InDoubleQuoteStringLiteral"] = 3] = "InDoubleQuoteStringLiteral";
        EndOfLineState2[EndOfLineState2["InTemplateHeadOrNoSubstitutionTemplate"] = 4] = "InTemplateHeadOrNoSubstitutionTemplate";
        EndOfLineState2[EndOfLineState2["InTemplateMiddleOrTail"] = 5] = "InTemplateMiddleOrTail";
        EndOfLineState2[EndOfLineState2["InTemplateSubstitutionPosition"] = 6] = "InTemplateSubstitutionPosition";
      })(EndOfLineState = ts2.EndOfLineState || (ts2.EndOfLineState = {}));
      var TokenClass;
      (function(TokenClass2) {
        TokenClass2[TokenClass2["Punctuation"] = 0] = "Punctuation";
        TokenClass2[TokenClass2["Keyword"] = 1] = "Keyword";
        TokenClass2[TokenClass2["Operator"] = 2] = "Operator";
        TokenClass2[TokenClass2["Comment"] = 3] = "Comment";
        TokenClass2[TokenClass2["Whitespace"] = 4] = "Whitespace";
        TokenClass2[TokenClass2["Identifier"] = 5] = "Identifier";
        TokenClass2[TokenClass2["NumberLiteral"] = 6] = "NumberLiteral";
        TokenClass2[TokenClass2["BigIntLiteral"] = 7] = "BigIntLiteral";
        TokenClass2[TokenClass2["StringLiteral"] = 8] = "StringLiteral";
        TokenClass2[TokenClass2["RegExpLiteral"] = 9] = "RegExpLiteral";
      })(TokenClass = ts2.TokenClass || (ts2.TokenClass = {}));
      var ScriptElementKind;
      (function(ScriptElementKind2) {
        ScriptElementKind2["unknown"] = "";
        ScriptElementKind2["warning"] = "warning";
        ScriptElementKind2["keyword"] = "keyword";
        ScriptElementKind2["scriptElement"] = "script";
        ScriptElementKind2["moduleElement"] = "module";
        ScriptElementKind2["classElement"] = "class";
        ScriptElementKind2["localClassElement"] = "local class";
        ScriptElementKind2["interfaceElement"] = "interface";
        ScriptElementKind2["typeElement"] = "type";
        ScriptElementKind2["enumElement"] = "enum";
        ScriptElementKind2["enumMemberElement"] = "enum member";
        ScriptElementKind2["variableElement"] = "var";
        ScriptElementKind2["localVariableElement"] = "local var";
        ScriptElementKind2["functionElement"] = "function";
        ScriptElementKind2["localFunctionElement"] = "local function";
        ScriptElementKind2["memberFunctionElement"] = "method";
        ScriptElementKind2["memberGetAccessorElement"] = "getter";
        ScriptElementKind2["memberSetAccessorElement"] = "setter";
        ScriptElementKind2["memberVariableElement"] = "property";
        ScriptElementKind2["constructorImplementationElement"] = "constructor";
        ScriptElementKind2["callSignatureElement"] = "call";
        ScriptElementKind2["indexSignatureElement"] = "index";
        ScriptElementKind2["constructSignatureElement"] = "construct";
        ScriptElementKind2["parameterElement"] = "parameter";
        ScriptElementKind2["typeParameterElement"] = "type parameter";
        ScriptElementKind2["primitiveType"] = "primitive type";
        ScriptElementKind2["label"] = "label";
        ScriptElementKind2["alias"] = "alias";
        ScriptElementKind2["constElement"] = "const";
        ScriptElementKind2["letElement"] = "let";
        ScriptElementKind2["directory"] = "directory";
        ScriptElementKind2["externalModuleName"] = "external module name";
        ScriptElementKind2["jsxAttribute"] = "JSX attribute";
        ScriptElementKind2["string"] = "string";
      })(ScriptElementKind = ts2.ScriptElementKind || (ts2.ScriptElementKind = {}));
      var ScriptElementKindModifier;
      (function(ScriptElementKindModifier2) {
        ScriptElementKindModifier2["none"] = "";
        ScriptElementKindModifier2["publicMemberModifier"] = "public";
        ScriptElementKindModifier2["privateMemberModifier"] = "private";
        ScriptElementKindModifier2["protectedMemberModifier"] = "protected";
        ScriptElementKindModifier2["exportedModifier"] = "export";
        ScriptElementKindModifier2["ambientModifier"] = "declare";
        ScriptElementKindModifier2["staticModifier"] = "static";
        ScriptElementKindModifier2["abstractModifier"] = "abstract";
        ScriptElementKindModifier2["optionalModifier"] = "optional";
        ScriptElementKindModifier2["dtsModifier"] = ".d.ts";
        ScriptElementKindModifier2["tsModifier"] = ".ts";
        ScriptElementKindModifier2["tsxModifier"] = ".tsx";
        ScriptElementKindModifier2["jsModifier"] = ".js";
        ScriptElementKindModifier2["jsxModifier"] = ".jsx";
        ScriptElementKindModifier2["jsonModifier"] = ".json";
      })(ScriptElementKindModifier = ts2.ScriptElementKindModifier || (ts2.ScriptElementKindModifier = {}));
      var ClassificationTypeNames;
      (function(ClassificationTypeNames2) {
        ClassificationTypeNames2["comment"] = "comment";
        ClassificationTypeNames2["identifier"] = "identifier";
        ClassificationTypeNames2["keyword"] = "keyword";
        ClassificationTypeNames2["numericLiteral"] = "number";
        ClassificationTypeNames2["bigintLiteral"] = "bigint";
        ClassificationTypeNames2["operator"] = "operator";
        ClassificationTypeNames2["stringLiteral"] = "string";
        ClassificationTypeNames2["whiteSpace"] = "whitespace";
        ClassificationTypeNames2["text"] = "text";
        ClassificationTypeNames2["punctuation"] = "punctuation";
        ClassificationTypeNames2["className"] = "class name";
        ClassificationTypeNames2["enumName"] = "enum name";
        ClassificationTypeNames2["interfaceName"] = "interface name";
        ClassificationTypeNames2["moduleName"] = "module name";
        ClassificationTypeNames2["typeParameterName"] = "type parameter name";
        ClassificationTypeNames2["typeAliasName"] = "type alias name";
        ClassificationTypeNames2["parameterName"] = "parameter name";
        ClassificationTypeNames2["docCommentTagName"] = "doc comment tag name";
        ClassificationTypeNames2["jsxOpenTagName"] = "jsx open tag name";
        ClassificationTypeNames2["jsxCloseTagName"] = "jsx close tag name";
        ClassificationTypeNames2["jsxSelfClosingTagName"] = "jsx self closing tag name";
        ClassificationTypeNames2["jsxAttribute"] = "jsx attribute";
        ClassificationTypeNames2["jsxText"] = "jsx text";
        ClassificationTypeNames2["jsxAttributeStringLiteralValue"] = "jsx attribute string literal value";
      })(ClassificationTypeNames = ts2.ClassificationTypeNames || (ts2.ClassificationTypeNames = {}));
      var ClassificationType;
      (function(ClassificationType2) {
        ClassificationType2[ClassificationType2["comment"] = 1] = "comment";
        ClassificationType2[ClassificationType2["identifier"] = 2] = "identifier";
        ClassificationType2[ClassificationType2["keyword"] = 3] = "keyword";
        ClassificationType2[ClassificationType2["numericLiteral"] = 4] = "numericLiteral";
        ClassificationType2[ClassificationType2["operator"] = 5] = "operator";
        ClassificationType2[ClassificationType2["stringLiteral"] = 6] = "stringLiteral";
        ClassificationType2[ClassificationType2["regularExpressionLiteral"] = 7] = "regularExpressionLiteral";
        ClassificationType2[ClassificationType2["whiteSpace"] = 8] = "whiteSpace";
        ClassificationType2[ClassificationType2["text"] = 9] = "text";
        ClassificationType2[ClassificationType2["punctuation"] = 10] = "punctuation";
        ClassificationType2[ClassificationType2["className"] = 11] = "className";
        ClassificationType2[ClassificationType2["enumName"] = 12] = "enumName";
        ClassificationType2[ClassificationType2["interfaceName"] = 13] = "interfaceName";
        ClassificationType2[ClassificationType2["moduleName"] = 14] = "moduleName";
        ClassificationType2[ClassificationType2["typeParameterName"] = 15] = "typeParameterName";
        ClassificationType2[ClassificationType2["typeAliasName"] = 16] = "typeAliasName";
        ClassificationType2[ClassificationType2["parameterName"] = 17] = "parameterName";
        ClassificationType2[ClassificationType2["docCommentTagName"] = 18] = "docCommentTagName";
        ClassificationType2[ClassificationType2["jsxOpenTagName"] = 19] = "jsxOpenTagName";
        ClassificationType2[ClassificationType2["jsxCloseTagName"] = 20] = "jsxCloseTagName";
        ClassificationType2[ClassificationType2["jsxSelfClosingTagName"] = 21] = "jsxSelfClosingTagName";
        ClassificationType2[ClassificationType2["jsxAttribute"] = 22] = "jsxAttribute";
        ClassificationType2[ClassificationType2["jsxText"] = 23] = "jsxText";
        ClassificationType2[ClassificationType2["jsxAttributeStringLiteralValue"] = 24] = "jsxAttributeStringLiteralValue";
        ClassificationType2[ClassificationType2["bigintLiteral"] = 25] = "bigintLiteral";
      })(ClassificationType = ts2.ClassificationType || (ts2.ClassificationType = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      ts2.scanner = ts2.createScanner(99, true);
      var SemanticMeaning;
      (function(SemanticMeaning2) {
        SemanticMeaning2[SemanticMeaning2["None"] = 0] = "None";
        SemanticMeaning2[SemanticMeaning2["Value"] = 1] = "Value";
        SemanticMeaning2[SemanticMeaning2["Type"] = 2] = "Type";
        SemanticMeaning2[SemanticMeaning2["Namespace"] = 4] = "Namespace";
        SemanticMeaning2[SemanticMeaning2["All"] = 7] = "All";
      })(SemanticMeaning = ts2.SemanticMeaning || (ts2.SemanticMeaning = {}));
      function getMeaningFromDeclaration(node) {
        switch (node.kind) {
          case 242:
            return ts2.isInJSFile(node) && ts2.getJSDocEnumTag(node) ? 7 : 1;
          case 156:
          case 191:
          case 159:
          case 158:
          case 281:
          case 282:
          case 161:
          case 160:
          case 162:
          case 163:
          case 164:
          case 244:
          case 201:
          case 202:
          case 280:
          case 273:
            return 1;
          case 155:
          case 246:
          case 247:
          case 173:
            return 2;
          case 322:
            return node.name === void 0 ? 1 | 2 : 2;
          case 284:
          case 245:
            return 1 | 2;
          case 249:
            if (ts2.isAmbientModule(node)) {
              return 4 | 1;
            } else if (ts2.getModuleInstanceState(node) === 1) {
              return 4 | 1;
            } else {
              return 4;
            }
          case 248:
          case 257:
          case 258:
          case 253:
          case 254:
          case 259:
          case 260:
            return 7;
          case 290:
            return 4 | 1;
        }
        return 7;
      }
      ts2.getMeaningFromDeclaration = getMeaningFromDeclaration;
      function getMeaningFromLocation(node) {
        node = getAdjustedReferenceLocation(node);
        if (node.kind === 290) {
          return 1;
        } else if (node.parent.kind === 259 || node.parent.kind === 265 || node.parent.kind === 258 || node.parent.kind === 255 || ts2.isImportEqualsDeclaration(node.parent) && node === node.parent.name) {
          return 7;
        } else if (isInRightSideOfInternalImportEqualsDeclaration(node)) {
          return getMeaningFromRightHandSideOfImportEquals(node);
        } else if (ts2.isDeclarationName(node)) {
          return getMeaningFromDeclaration(node.parent);
        } else if (isTypeReference(node)) {
          return 2;
        } else if (isNamespaceReference(node)) {
          return 4;
        } else if (ts2.isTypeParameterDeclaration(node.parent)) {
          ts2.Debug.assert(ts2.isJSDocTemplateTag(node.parent.parent));
          return 2;
        } else if (ts2.isLiteralTypeNode(node.parent)) {
          return 2 | 1;
        } else {
          return 1;
        }
      }
      ts2.getMeaningFromLocation = getMeaningFromLocation;
      function getMeaningFromRightHandSideOfImportEquals(node) {
        var name = node.kind === 153 ? node : ts2.isQualifiedName(node.parent) && node.parent.right === node ? node.parent : void 0;
        return name && name.parent.kind === 253 ? 7 : 4;
      }
      function isInRightSideOfInternalImportEqualsDeclaration(node) {
        while (node.parent.kind === 153) {
          node = node.parent;
        }
        return ts2.isInternalModuleImportEqualsDeclaration(node.parent) && node.parent.moduleReference === node;
      }
      ts2.isInRightSideOfInternalImportEqualsDeclaration = isInRightSideOfInternalImportEqualsDeclaration;
      function isNamespaceReference(node) {
        return isQualifiedNameNamespaceReference(node) || isPropertyAccessNamespaceReference(node);
      }
      function isQualifiedNameNamespaceReference(node) {
        var root = node;
        var isLastClause = true;
        if (root.parent.kind === 153) {
          while (root.parent && root.parent.kind === 153) {
            root = root.parent;
          }
          isLastClause = root.right === node;
        }
        return root.parent.kind === 169 && !isLastClause;
      }
      function isPropertyAccessNamespaceReference(node) {
        var root = node;
        var isLastClause = true;
        if (root.parent.kind === 194) {
          while (root.parent && root.parent.kind === 194) {
            root = root.parent;
          }
          isLastClause = root.name === node;
        }
        if (!isLastClause && root.parent.kind === 216 && root.parent.parent.kind === 279) {
          var decl = root.parent.parent.parent;
          return decl.kind === 245 && root.parent.parent.token === 113 || decl.kind === 246 && root.parent.parent.token === 90;
        }
        return false;
      }
      function isTypeReference(node) {
        if (ts2.isRightSideOfQualifiedNameOrPropertyAccess(node)) {
          node = node.parent;
        }
        switch (node.kind) {
          case 104:
            return !ts2.isExpressionNode(node);
          case 183:
            return true;
        }
        switch (node.parent.kind) {
          case 169:
            return true;
          case 188:
            return !node.parent.isTypeOf;
          case 216:
            return !ts2.isExpressionWithTypeArgumentsInClassExtendsClause(node.parent);
        }
        return false;
      }
      function isCallExpressionTarget(node, includeElementAccess, skipPastOuterExpressions) {
        if (includeElementAccess === void 0) {
          includeElementAccess = false;
        }
        if (skipPastOuterExpressions === void 0) {
          skipPastOuterExpressions = false;
        }
        return isCalleeWorker(node, ts2.isCallExpression, selectExpressionOfCallOrNewExpressionOrDecorator, includeElementAccess, skipPastOuterExpressions);
      }
      ts2.isCallExpressionTarget = isCallExpressionTarget;
      function isNewExpressionTarget(node, includeElementAccess, skipPastOuterExpressions) {
        if (includeElementAccess === void 0) {
          includeElementAccess = false;
        }
        if (skipPastOuterExpressions === void 0) {
          skipPastOuterExpressions = false;
        }
        return isCalleeWorker(node, ts2.isNewExpression, selectExpressionOfCallOrNewExpressionOrDecorator, includeElementAccess, skipPastOuterExpressions);
      }
      ts2.isNewExpressionTarget = isNewExpressionTarget;
      function isCallOrNewExpressionTarget(node, includeElementAccess, skipPastOuterExpressions) {
        if (includeElementAccess === void 0) {
          includeElementAccess = false;
        }
        if (skipPastOuterExpressions === void 0) {
          skipPastOuterExpressions = false;
        }
        return isCalleeWorker(node, ts2.isCallOrNewExpression, selectExpressionOfCallOrNewExpressionOrDecorator, includeElementAccess, skipPastOuterExpressions);
      }
      ts2.isCallOrNewExpressionTarget = isCallOrNewExpressionTarget;
      function isTaggedTemplateTag(node, includeElementAccess, skipPastOuterExpressions) {
        if (includeElementAccess === void 0) {
          includeElementAccess = false;
        }
        if (skipPastOuterExpressions === void 0) {
          skipPastOuterExpressions = false;
        }
        return isCalleeWorker(node, ts2.isTaggedTemplateExpression, selectTagOfTaggedTemplateExpression, includeElementAccess, skipPastOuterExpressions);
      }
      ts2.isTaggedTemplateTag = isTaggedTemplateTag;
      function isDecoratorTarget(node, includeElementAccess, skipPastOuterExpressions) {
        if (includeElementAccess === void 0) {
          includeElementAccess = false;
        }
        if (skipPastOuterExpressions === void 0) {
          skipPastOuterExpressions = false;
        }
        return isCalleeWorker(node, ts2.isDecorator, selectExpressionOfCallOrNewExpressionOrDecorator, includeElementAccess, skipPastOuterExpressions);
      }
      ts2.isDecoratorTarget = isDecoratorTarget;
      function isJsxOpeningLikeElementTagName(node, includeElementAccess, skipPastOuterExpressions) {
        if (includeElementAccess === void 0) {
          includeElementAccess = false;
        }
        if (skipPastOuterExpressions === void 0) {
          skipPastOuterExpressions = false;
        }
        return isCalleeWorker(node, ts2.isJsxOpeningLikeElement, selectTagNameOfJsxOpeningLikeElement, includeElementAccess, skipPastOuterExpressions);
      }
      ts2.isJsxOpeningLikeElementTagName = isJsxOpeningLikeElementTagName;
      function selectExpressionOfCallOrNewExpressionOrDecorator(node) {
        return node.expression;
      }
      function selectTagOfTaggedTemplateExpression(node) {
        return node.tag;
      }
      function selectTagNameOfJsxOpeningLikeElement(node) {
        return node.tagName;
      }
      function isCalleeWorker(node, pred, calleeSelector, includeElementAccess, skipPastOuterExpressions) {
        var target = includeElementAccess ? climbPastPropertyOrElementAccess(node) : climbPastPropertyAccess(node);
        if (skipPastOuterExpressions) {
          target = ts2.skipOuterExpressions(target);
        }
        return !!target && !!target.parent && pred(target.parent) && calleeSelector(target.parent) === target;
      }
      function climbPastPropertyAccess(node) {
        return isRightSideOfPropertyAccess(node) ? node.parent : node;
      }
      ts2.climbPastPropertyAccess = climbPastPropertyAccess;
      function climbPastPropertyOrElementAccess(node) {
        return isRightSideOfPropertyAccess(node) || isArgumentExpressionOfElementAccess(node) ? node.parent : node;
      }
      ts2.climbPastPropertyOrElementAccess = climbPastPropertyOrElementAccess;
      function getTargetLabel(referenceNode, labelName) {
        while (referenceNode) {
          if (referenceNode.kind === 238 && referenceNode.label.escapedText === labelName) {
            return referenceNode.label;
          }
          referenceNode = referenceNode.parent;
        }
        return void 0;
      }
      ts2.getTargetLabel = getTargetLabel;
      function hasPropertyAccessExpressionWithName(node, funcName) {
        if (!ts2.isPropertyAccessExpression(node.expression)) {
          return false;
        }
        return node.expression.name.text === funcName;
      }
      ts2.hasPropertyAccessExpressionWithName = hasPropertyAccessExpressionWithName;
      function isJumpStatementTarget(node) {
        var _a;
        return ts2.isIdentifier(node) && ((_a = ts2.tryCast(node.parent, ts2.isBreakOrContinueStatement)) === null || _a === void 0 ? void 0 : _a.label) === node;
      }
      ts2.isJumpStatementTarget = isJumpStatementTarget;
      function isLabelOfLabeledStatement(node) {
        var _a;
        return ts2.isIdentifier(node) && ((_a = ts2.tryCast(node.parent, ts2.isLabeledStatement)) === null || _a === void 0 ? void 0 : _a.label) === node;
      }
      ts2.isLabelOfLabeledStatement = isLabelOfLabeledStatement;
      function isLabelName(node) {
        return isLabelOfLabeledStatement(node) || isJumpStatementTarget(node);
      }
      ts2.isLabelName = isLabelName;
      function isTagName(node) {
        var _a;
        return ((_a = ts2.tryCast(node.parent, ts2.isJSDocTag)) === null || _a === void 0 ? void 0 : _a.tagName) === node;
      }
      ts2.isTagName = isTagName;
      function isRightSideOfQualifiedName(node) {
        var _a;
        return ((_a = ts2.tryCast(node.parent, ts2.isQualifiedName)) === null || _a === void 0 ? void 0 : _a.right) === node;
      }
      ts2.isRightSideOfQualifiedName = isRightSideOfQualifiedName;
      function isRightSideOfPropertyAccess(node) {
        var _a;
        return ((_a = ts2.tryCast(node.parent, ts2.isPropertyAccessExpression)) === null || _a === void 0 ? void 0 : _a.name) === node;
      }
      ts2.isRightSideOfPropertyAccess = isRightSideOfPropertyAccess;
      function isArgumentExpressionOfElementAccess(node) {
        var _a;
        return ((_a = ts2.tryCast(node.parent, ts2.isElementAccessExpression)) === null || _a === void 0 ? void 0 : _a.argumentExpression) === node;
      }
      ts2.isArgumentExpressionOfElementAccess = isArgumentExpressionOfElementAccess;
      function isNameOfModuleDeclaration(node) {
        var _a;
        return ((_a = ts2.tryCast(node.parent, ts2.isModuleDeclaration)) === null || _a === void 0 ? void 0 : _a.name) === node;
      }
      ts2.isNameOfModuleDeclaration = isNameOfModuleDeclaration;
      function isNameOfFunctionDeclaration(node) {
        var _a;
        return ts2.isIdentifier(node) && ((_a = ts2.tryCast(node.parent, ts2.isFunctionLike)) === null || _a === void 0 ? void 0 : _a.name) === node;
      }
      ts2.isNameOfFunctionDeclaration = isNameOfFunctionDeclaration;
      function isLiteralNameOfPropertyDeclarationOrIndexAccess(node) {
        switch (node.parent.kind) {
          case 159:
          case 158:
          case 281:
          case 284:
          case 161:
          case 160:
          case 163:
          case 164:
          case 249:
            return ts2.getNameOfDeclaration(node.parent) === node;
          case 195:
            return node.parent.argumentExpression === node;
          case 154:
            return true;
          case 187:
            return node.parent.parent.kind === 185;
          default:
            return false;
        }
      }
      ts2.isLiteralNameOfPropertyDeclarationOrIndexAccess = isLiteralNameOfPropertyDeclarationOrIndexAccess;
      function isExpressionOfExternalModuleImportEqualsDeclaration(node) {
        return ts2.isExternalModuleImportEqualsDeclaration(node.parent.parent) && ts2.getExternalModuleImportEqualsDeclarationExpression(node.parent.parent) === node;
      }
      ts2.isExpressionOfExternalModuleImportEqualsDeclaration = isExpressionOfExternalModuleImportEqualsDeclaration;
      function getContainerNode(node) {
        if (ts2.isJSDocTypeAlias(node)) {
          node = node.parent.parent;
        }
        while (true) {
          node = node.parent;
          if (!node) {
            return void 0;
          }
          switch (node.kind) {
            case 290:
            case 161:
            case 160:
            case 244:
            case 201:
            case 163:
            case 164:
            case 245:
            case 246:
            case 248:
            case 249:
              return node;
          }
        }
      }
      ts2.getContainerNode = getContainerNode;
      function getNodeKind(node) {
        switch (node.kind) {
          case 290:
            return ts2.isExternalModule(node) ? "module" : "script";
          case 249:
            return "module";
          case 245:
          case 214:
            return "class";
          case 246:
            return "interface";
          case 247:
          case 315:
          case 322:
            return "type";
          case 248:
            return "enum";
          case 242:
            return getKindOfVariableDeclaration(node);
          case 191:
            return getKindOfVariableDeclaration(ts2.getRootDeclaration(node));
          case 202:
          case 244:
          case 201:
            return "function";
          case 163:
            return "getter";
          case 164:
            return "setter";
          case 161:
          case 160:
            return "method";
          case 281:
            var initializer = node.initializer;
            return ts2.isFunctionLike(initializer) ? "method" : "property";
          case 159:
          case 158:
          case 282:
          case 283:
            return "property";
          case 167:
            return "index";
          case 166:
            return "construct";
          case 165:
            return "call";
          case 162:
            return "constructor";
          case 155:
            return "type parameter";
          case 284:
            return "enum member";
          case 156:
            return ts2.hasModifier(node, 92) ? "property" : "parameter";
          case 253:
          case 258:
          case 263:
          case 256:
          case 262:
            return "alias";
          case 209:
            var kind = ts2.getAssignmentDeclarationKind(node);
            var right = node.right;
            switch (kind) {
              case 7:
              case 8:
              case 9:
              case 0:
                return "";
              case 1:
              case 2:
                var rightKind = getNodeKind(right);
                return rightKind === "" ? "const" : rightKind;
              case 3:
                return ts2.isFunctionExpression(right) ? "method" : "property";
              case 4:
                return "property";
              case 5:
                return ts2.isFunctionExpression(right) ? "method" : "property";
              case 6:
                return "local class";
              default: {
                ts2.assertType(kind);
                return "";
              }
            }
          case 75:
            return ts2.isImportClause(node.parent) ? "alias" : "";
          case 259:
            var scriptKind = getNodeKind(node.expression);
            return scriptKind === "" ? "const" : scriptKind;
          default:
            return "";
        }
        function getKindOfVariableDeclaration(v) {
          return ts2.isVarConst(v) ? "const" : ts2.isLet(v) ? "let" : "var";
        }
      }
      ts2.getNodeKind = getNodeKind;
      function isThis(node) {
        switch (node.kind) {
          case 104:
            return true;
          case 75:
            return ts2.identifierIsThisKeyword(node) && node.parent.kind === 156;
          default:
            return false;
        }
      }
      ts2.isThis = isThis;
      var tripleSlashDirectivePrefixRegex = /^\/\/\/\s*</;
      function getLineStartPositionForPosition(position, sourceFile) {
        var lineStarts = ts2.getLineStarts(sourceFile);
        var line = sourceFile.getLineAndCharacterOfPosition(position).line;
        return lineStarts[line];
      }
      ts2.getLineStartPositionForPosition = getLineStartPositionForPosition;
      function rangeContainsRange(r1, r2) {
        return startEndContainsRange(r1.pos, r1.end, r2);
      }
      ts2.rangeContainsRange = rangeContainsRange;
      function rangeContainsRangeExclusive(r1, r2) {
        return rangeContainsPositionExclusive(r1, r2.pos) && rangeContainsPositionExclusive(r1, r2.end);
      }
      ts2.rangeContainsRangeExclusive = rangeContainsRangeExclusive;
      function rangeContainsPosition(r, pos) {
        return r.pos <= pos && pos <= r.end;
      }
      ts2.rangeContainsPosition = rangeContainsPosition;
      function rangeContainsPositionExclusive(r, pos) {
        return r.pos < pos && pos < r.end;
      }
      ts2.rangeContainsPositionExclusive = rangeContainsPositionExclusive;
      function startEndContainsRange(start, end, range) {
        return start <= range.pos && end >= range.end;
      }
      ts2.startEndContainsRange = startEndContainsRange;
      function rangeContainsStartEnd(range, start, end) {
        return range.pos <= start && range.end >= end;
      }
      ts2.rangeContainsStartEnd = rangeContainsStartEnd;
      function rangeOverlapsWithStartEnd(r1, start, end) {
        return startEndOverlapsWithStartEnd(r1.pos, r1.end, start, end);
      }
      ts2.rangeOverlapsWithStartEnd = rangeOverlapsWithStartEnd;
      function nodeOverlapsWithStartEnd(node, sourceFile, start, end) {
        return startEndOverlapsWithStartEnd(node.getStart(sourceFile), node.end, start, end);
      }
      ts2.nodeOverlapsWithStartEnd = nodeOverlapsWithStartEnd;
      function startEndOverlapsWithStartEnd(start1, end1, start2, end2) {
        var start = Math.max(start1, start2);
        var end = Math.min(end1, end2);
        return start < end;
      }
      ts2.startEndOverlapsWithStartEnd = startEndOverlapsWithStartEnd;
      function positionBelongsToNode(candidate, position, sourceFile) {
        ts2.Debug.assert(candidate.pos <= position);
        return position < candidate.end || !isCompletedNode(candidate, sourceFile);
      }
      ts2.positionBelongsToNode = positionBelongsToNode;
      function isCompletedNode(n, sourceFile) {
        if (n === void 0 || ts2.nodeIsMissing(n)) {
          return false;
        }
        switch (n.kind) {
          case 245:
          case 246:
          case 248:
          case 193:
          case 189:
          case 173:
          case 223:
          case 250:
          case 251:
          case 257:
          case 261:
            return nodeEndsWith(n, 19, sourceFile);
          case 280:
            return isCompletedNode(n.block, sourceFile);
          case 197:
            if (!n.arguments) {
              return true;
            }
          case 196:
          case 200:
          case 182:
            return nodeEndsWith(n, 21, sourceFile);
          case 170:
          case 171:
            return isCompletedNode(n.type, sourceFile);
          case 162:
          case 163:
          case 164:
          case 244:
          case 201:
          case 161:
          case 160:
          case 166:
          case 165:
          case 202:
            if (n.body) {
              return isCompletedNode(n.body, sourceFile);
            }
            if (n.type) {
              return isCompletedNode(n.type, sourceFile);
            }
            return hasChildOfKind(n, 21, sourceFile);
          case 249:
            return !!n.body && isCompletedNode(n.body, sourceFile);
          case 227:
            if (n.elseStatement) {
              return isCompletedNode(n.elseStatement, sourceFile);
            }
            return isCompletedNode(n.thenStatement, sourceFile);
          case 226:
            return isCompletedNode(n.expression, sourceFile) || hasChildOfKind(n, 26, sourceFile);
          case 192:
          case 190:
          case 195:
          case 154:
          case 175:
            return nodeEndsWith(n, 23, sourceFile);
          case 167:
            if (n.type) {
              return isCompletedNode(n.type, sourceFile);
            }
            return hasChildOfKind(n, 23, sourceFile);
          case 277:
          case 278:
            return false;
          case 230:
          case 231:
          case 232:
          case 229:
            return isCompletedNode(n.statement, sourceFile);
          case 228:
            return hasChildOfKind(n, 111, sourceFile) ? nodeEndsWith(n, 21, sourceFile) : isCompletedNode(n.statement, sourceFile);
          case 172:
            return isCompletedNode(n.exprName, sourceFile);
          case 204:
          case 203:
          case 205:
          case 212:
          case 213:
            var unaryWordExpression = n;
            return isCompletedNode(unaryWordExpression.expression, sourceFile);
          case 198:
            return isCompletedNode(n.template, sourceFile);
          case 211:
            var lastSpan = ts2.lastOrUndefined(n.templateSpans);
            return isCompletedNode(lastSpan, sourceFile);
          case 221:
            return ts2.nodeIsPresent(n.literal);
          case 260:
          case 254:
            return ts2.nodeIsPresent(n.moduleSpecifier);
          case 207:
            return isCompletedNode(n.operand, sourceFile);
          case 209:
            return isCompletedNode(n.right, sourceFile);
          case 210:
            return isCompletedNode(n.whenFalse, sourceFile);
          default:
            return true;
        }
      }
      function nodeEndsWith(n, expectedLastToken, sourceFile) {
        var children = n.getChildren(sourceFile);
        if (children.length) {
          var lastChild = ts2.last(children);
          if (lastChild.kind === expectedLastToken) {
            return true;
          } else if (lastChild.kind === 26 && children.length !== 1) {
            return children[children.length - 2].kind === expectedLastToken;
          }
        }
        return false;
      }
      function findListItemInfo(node) {
        var list = findContainingList(node);
        if (!list) {
          return void 0;
        }
        var children = list.getChildren();
        var listItemIndex = ts2.indexOfNode(children, node);
        return {
          listItemIndex,
          list
        };
      }
      ts2.findListItemInfo = findListItemInfo;
      function hasChildOfKind(n, kind, sourceFile) {
        return !!findChildOfKind(n, kind, sourceFile);
      }
      ts2.hasChildOfKind = hasChildOfKind;
      function findChildOfKind(n, kind, sourceFile) {
        return ts2.find(n.getChildren(sourceFile), function(c) {
          return c.kind === kind;
        });
      }
      ts2.findChildOfKind = findChildOfKind;
      function findContainingList(node) {
        var syntaxList = ts2.find(node.parent.getChildren(), function(c) {
          return ts2.isSyntaxList(c) && rangeContainsRange(c, node);
        });
        ts2.Debug.assert(!syntaxList || ts2.contains(syntaxList.getChildren(), node));
        return syntaxList;
      }
      ts2.findContainingList = findContainingList;
      function isDefaultModifier(node) {
        return node.kind === 84;
      }
      function isClassKeyword(node) {
        return node.kind === 80;
      }
      function isFunctionKeyword(node) {
        return node.kind === 94;
      }
      function getAdjustedLocationForClass(node) {
        if (ts2.isNamedDeclaration(node)) {
          return node.name;
        }
        if (ts2.isClassDeclaration(node)) {
          var defaultModifier = ts2.find(node.modifiers, isDefaultModifier);
          if (defaultModifier)
            return defaultModifier;
        }
        if (ts2.isClassExpression(node)) {
          var classKeyword = ts2.find(node.getChildren(), isClassKeyword);
          if (classKeyword)
            return classKeyword;
        }
      }
      function getAdjustedLocationForFunction(node) {
        if (ts2.isNamedDeclaration(node)) {
          return node.name;
        }
        if (ts2.isFunctionDeclaration(node)) {
          var defaultModifier = ts2.find(node.modifiers, isDefaultModifier);
          if (defaultModifier)
            return defaultModifier;
        }
        if (ts2.isFunctionExpression(node)) {
          var functionKeyword = ts2.find(node.getChildren(), isFunctionKeyword);
          if (functionKeyword)
            return functionKeyword;
        }
      }
      function getAdjustedLocationForDeclaration(node, forRename) {
        if (!forRename) {
          switch (node.kind) {
            case 245:
            case 214:
              return getAdjustedLocationForClass(node);
            case 244:
            case 201:
              return getAdjustedLocationForFunction(node);
          }
        }
        if (ts2.isNamedDeclaration(node)) {
          return node.name;
        }
      }
      function getAdjustedLocationForImportDeclaration(node, forRename) {
        if (node.importClause) {
          if (node.importClause.name && node.importClause.namedBindings) {
            return;
          }
          if (node.importClause.name) {
            return node.importClause.name;
          }
          if (node.importClause.namedBindings) {
            if (ts2.isNamedImports(node.importClause.namedBindings)) {
              var onlyBinding = ts2.singleOrUndefined(node.importClause.namedBindings.elements);
              if (!onlyBinding) {
                return;
              }
              return onlyBinding.name;
            } else if (ts2.isNamespaceImport(node.importClause.namedBindings)) {
              return node.importClause.namedBindings.name;
            }
          }
        }
        if (!forRename) {
          return node.moduleSpecifier;
        }
      }
      function getAdjustedLocationForExportDeclaration(node, forRename) {
        if (node.exportClause) {
          if (ts2.isNamedExports(node.exportClause)) {
            var onlyBinding = ts2.singleOrUndefined(node.exportClause.elements);
            if (!onlyBinding) {
              return;
            }
            return node.exportClause.elements[0].name;
          } else if (ts2.isNamespaceExport(node.exportClause)) {
            return node.exportClause.name;
          }
        }
        if (!forRename) {
          return node.moduleSpecifier;
        }
      }
      function getAdjustedLocationForHeritageClause(node) {
        if (node.types.length === 1) {
          return node.types[0].expression;
        }
      }
      function getAdjustedLocation(node, forRename) {
        var parent = node.parent;
        if (ts2.isModifier(node) && (forRename || node.kind !== 84) ? ts2.contains(parent.modifiers, node) : node.kind === 80 ? ts2.isClassDeclaration(parent) || ts2.isClassExpression(node) : node.kind === 94 ? ts2.isFunctionDeclaration(parent) || ts2.isFunctionExpression(node) : node.kind === 114 ? ts2.isInterfaceDeclaration(parent) : node.kind === 88 ? ts2.isEnumDeclaration(parent) : node.kind === 145 ? ts2.isTypeAliasDeclaration(parent) : node.kind === 136 || node.kind === 135 ? ts2.isModuleDeclaration(parent) : node.kind === 96 ? ts2.isImportEqualsDeclaration(parent) : node.kind === 131 ? ts2.isGetAccessorDeclaration(parent) : node.kind === 142 && ts2.isSetAccessorDeclaration(parent)) {
          var location = getAdjustedLocationForDeclaration(parent, forRename);
          if (location) {
            return location;
          }
        }
        if ((node.kind === 109 || node.kind === 81 || node.kind === 115) && ts2.isVariableDeclarationList(parent) && parent.declarations.length === 1) {
          var decl = parent.declarations[0];
          if (ts2.isIdentifier(decl.name)) {
            return decl.name;
          }
        }
        if (node.kind === 145) {
          if (ts2.isImportClause(parent) && parent.isTypeOnly) {
            var location = getAdjustedLocationForImportDeclaration(parent.parent, forRename);
            if (location) {
              return location;
            }
          }
          if (ts2.isExportDeclaration(parent) && parent.isTypeOnly) {
            var location = getAdjustedLocationForExportDeclaration(parent, forRename);
            if (location) {
              return location;
            }
          }
        }
        if (node.kind === 123) {
          if (ts2.isImportSpecifier(parent) && parent.propertyName || ts2.isExportSpecifier(parent) && parent.propertyName || ts2.isNamespaceImport(parent) || ts2.isNamespaceExport(parent)) {
            return parent.name;
          }
          if (ts2.isExportDeclaration(parent) && parent.exportClause && ts2.isNamespaceExport(parent.exportClause)) {
            return parent.exportClause.name;
          }
        }
        if (node.kind === 96 && ts2.isImportDeclaration(parent)) {
          var location = getAdjustedLocationForImportDeclaration(parent, forRename);
          if (location) {
            return location;
          }
        }
        if (node.kind === 89) {
          if (ts2.isExportDeclaration(parent)) {
            var location = getAdjustedLocationForExportDeclaration(parent, forRename);
            if (location) {
              return location;
            }
          }
          if (ts2.isExportAssignment(parent)) {
            return ts2.skipOuterExpressions(parent.expression);
          }
        }
        if (node.kind === 139 && ts2.isExternalModuleReference(parent)) {
          return parent.expression;
        }
        if (node.kind === 149 && (ts2.isImportDeclaration(parent) || ts2.isExportDeclaration(parent)) && parent.moduleSpecifier) {
          return parent.moduleSpecifier;
        }
        if ((node.kind === 90 || node.kind === 113) && ts2.isHeritageClause(parent) && parent.token === node.kind) {
          var location = getAdjustedLocationForHeritageClause(parent);
          if (location) {
            return location;
          }
        }
        if (node.kind === 90) {
          if (ts2.isTypeParameterDeclaration(parent) && parent.constraint && ts2.isTypeReferenceNode(parent.constraint)) {
            return parent.constraint.typeName;
          }
          if (ts2.isConditionalTypeNode(parent) && ts2.isTypeReferenceNode(parent.extendsType)) {
            return parent.extendsType.typeName;
          }
        }
        if (node.kind === 132 && ts2.isInferTypeNode(parent)) {
          return parent.typeParameter.name;
        }
        if (node.kind === 97 && ts2.isTypeParameterDeclaration(parent) && ts2.isMappedTypeNode(parent.parent)) {
          return parent.name;
        }
        if (node.kind === 134 && ts2.isTypeOperatorNode(parent) && parent.operator === 134 && ts2.isTypeReferenceNode(parent.type)) {
          return parent.type.typeName;
        }
        if (node.kind === 138 && ts2.isTypeOperatorNode(parent) && parent.operator === 138 && ts2.isArrayTypeNode(parent.type) && ts2.isTypeReferenceNode(parent.type.elementType)) {
          return parent.type.elementType.typeName;
        }
        if (!forRename) {
          if (node.kind === 99 && ts2.isNewExpression(parent) || node.kind === 110 && ts2.isVoidExpression(parent) || node.kind === 108 && ts2.isTypeOfExpression(parent) || node.kind === 127 && ts2.isAwaitExpression(parent) || node.kind === 121 && ts2.isYieldExpression(parent) || node.kind === 85 && ts2.isDeleteExpression(parent)) {
            if (parent.expression) {
              return ts2.skipOuterExpressions(parent.expression);
            }
          }
          if ((node.kind === 97 || node.kind === 98) && ts2.isBinaryExpression(parent) && parent.operatorToken === node) {
            return ts2.skipOuterExpressions(parent.right);
          }
          if (node.kind === 123 && ts2.isAsExpression(parent) && ts2.isTypeReferenceNode(parent.type)) {
            return parent.type.typeName;
          }
          if (node.kind === 97 && ts2.isForInStatement(parent) || node.kind === 152 && ts2.isForOfStatement(parent)) {
            return ts2.skipOuterExpressions(parent.expression);
          }
        }
        return node;
      }
      function getAdjustedReferenceLocation(node) {
        return getAdjustedLocation(node, false);
      }
      ts2.getAdjustedReferenceLocation = getAdjustedReferenceLocation;
      function getAdjustedRenameLocation(node) {
        return getAdjustedLocation(node, true);
      }
      ts2.getAdjustedRenameLocation = getAdjustedRenameLocation;
      function getTouchingPropertyName(sourceFile, position) {
        return getTouchingToken(sourceFile, position, function(n) {
          return ts2.isPropertyNameLiteral(n) || ts2.isKeyword(n.kind) || ts2.isPrivateIdentifier(n);
        });
      }
      ts2.getTouchingPropertyName = getTouchingPropertyName;
      function getTouchingToken(sourceFile, position, includePrecedingTokenAtEndPosition) {
        return getTokenAtPositionWorker(sourceFile, position, false, includePrecedingTokenAtEndPosition, false);
      }
      ts2.getTouchingToken = getTouchingToken;
      function getTokenAtPosition(sourceFile, position) {
        return getTokenAtPositionWorker(sourceFile, position, true, void 0, false);
      }
      ts2.getTokenAtPosition = getTokenAtPosition;
      function getTokenAtPositionWorker(sourceFile, position, allowPositionInLeadingTrivia, includePrecedingTokenAtEndPosition, includeEndPosition) {
        var current = sourceFile;
        outer:
          while (true) {
            for (var _i = 0, _a = current.getChildren(sourceFile); _i < _a.length; _i++) {
              var child = _a[_i];
              var start = allowPositionInLeadingTrivia ? child.getFullStart() : child.getStart(sourceFile, true);
              if (start > position) {
                break;
              }
              var end = child.getEnd();
              if (position < end || position === end && (child.kind === 1 || includeEndPosition)) {
                current = child;
                continue outer;
              } else if (includePrecedingTokenAtEndPosition && end === position) {
                var previousToken = findPrecedingToken(position, sourceFile, child);
                if (previousToken && includePrecedingTokenAtEndPosition(previousToken)) {
                  return previousToken;
                }
              }
            }
            return current;
          }
      }
      function findTokenOnLeftOfPosition(file, position) {
        var tokenAtPosition = getTokenAtPosition(file, position);
        if (ts2.isToken(tokenAtPosition) && position > tokenAtPosition.getStart(file) && position < tokenAtPosition.getEnd()) {
          return tokenAtPosition;
        }
        return findPrecedingToken(position, file);
      }
      ts2.findTokenOnLeftOfPosition = findTokenOnLeftOfPosition;
      function findNextToken(previousToken, parent, sourceFile) {
        return find(parent);
        function find(n) {
          if (ts2.isToken(n) && n.pos === previousToken.end) {
            return n;
          }
          return ts2.firstDefined(n.getChildren(sourceFile), function(child) {
            var shouldDiveInChildNode = child.pos <= previousToken.pos && child.end > previousToken.end || child.pos === previousToken.end;
            return shouldDiveInChildNode && nodeHasTokens(child, sourceFile) ? find(child) : void 0;
          });
        }
      }
      ts2.findNextToken = findNextToken;
      function findPrecedingToken(position, sourceFile, startNode, excludeJsdoc) {
        var result = find(startNode || sourceFile);
        ts2.Debug.assert(!(result && isWhiteSpaceOnlyJsxText(result)));
        return result;
        function find(n) {
          if (isNonWhitespaceToken(n) && n.kind !== 1) {
            return n;
          }
          var children = n.getChildren(sourceFile);
          for (var i = 0; i < children.length; i++) {
            var child = children[i];
            if (position < child.end) {
              var start = child.getStart(sourceFile, !excludeJsdoc);
              var lookInPreviousChild = start >= position || !nodeHasTokens(child, sourceFile) || isWhiteSpaceOnlyJsxText(child);
              if (lookInPreviousChild) {
                var candidate_1 = findRightmostChildNodeWithTokens(children, i, sourceFile);
                return candidate_1 && findRightmostToken(candidate_1, sourceFile);
              } else {
                return find(child);
              }
            }
          }
          ts2.Debug.assert(startNode !== void 0 || n.kind === 290 || n.kind === 1 || ts2.isJSDocCommentContainingNode(n));
          var candidate = findRightmostChildNodeWithTokens(children, children.length, sourceFile);
          return candidate && findRightmostToken(candidate, sourceFile);
        }
      }
      ts2.findPrecedingToken = findPrecedingToken;
      function isNonWhitespaceToken(n) {
        return ts2.isToken(n) && !isWhiteSpaceOnlyJsxText(n);
      }
      function findRightmostToken(n, sourceFile) {
        if (isNonWhitespaceToken(n)) {
          return n;
        }
        var children = n.getChildren(sourceFile);
        var candidate = findRightmostChildNodeWithTokens(children, children.length, sourceFile);
        return candidate && findRightmostToken(candidate, sourceFile);
      }
      function findRightmostChildNodeWithTokens(children, exclusiveStartPosition, sourceFile) {
        for (var i = exclusiveStartPosition - 1; i >= 0; i--) {
          var child = children[i];
          if (isWhiteSpaceOnlyJsxText(child)) {
            ts2.Debug.assert(i > 0, "`JsxText` tokens should not be the first child of `JsxElement | JsxSelfClosingElement`");
          } else if (nodeHasTokens(children[i], sourceFile)) {
            return children[i];
          }
        }
      }
      function isInString(sourceFile, position, previousToken) {
        if (previousToken === void 0) {
          previousToken = findPrecedingToken(position, sourceFile);
        }
        if (previousToken && ts2.isStringTextContainingNode(previousToken)) {
          var start = previousToken.getStart(sourceFile);
          var end = previousToken.getEnd();
          if (start < position && position < end) {
            return true;
          }
          if (position === end) {
            return !!previousToken.isUnterminated;
          }
        }
        return false;
      }
      ts2.isInString = isInString;
      function isInsideJsxElementOrAttribute(sourceFile, position) {
        var token = getTokenAtPosition(sourceFile, position);
        if (!token) {
          return false;
        }
        if (token.kind === 11) {
          return true;
        }
        if (token.kind === 29 && token.parent.kind === 11) {
          return true;
        }
        if (token.kind === 29 && token.parent.kind === 276) {
          return true;
        }
        if (token && token.kind === 19 && token.parent.kind === 276) {
          return true;
        }
        if (token.kind === 29 && token.parent.kind === 269) {
          return true;
        }
        return false;
      }
      ts2.isInsideJsxElementOrAttribute = isInsideJsxElementOrAttribute;
      function isWhiteSpaceOnlyJsxText(node) {
        return ts2.isJsxText(node) && node.containsOnlyTriviaWhiteSpaces;
      }
      function isInTemplateString(sourceFile, position) {
        var token = getTokenAtPosition(sourceFile, position);
        return ts2.isTemplateLiteralKind(token.kind) && position > token.getStart(sourceFile);
      }
      ts2.isInTemplateString = isInTemplateString;
      function isInJSXText(sourceFile, position) {
        var token = getTokenAtPosition(sourceFile, position);
        if (ts2.isJsxText(token)) {
          return true;
        }
        if (token.kind === 18 && ts2.isJsxExpression(token.parent) && ts2.isJsxElement(token.parent.parent)) {
          return true;
        }
        if (token.kind === 29 && ts2.isJsxOpeningLikeElement(token.parent) && ts2.isJsxElement(token.parent.parent)) {
          return true;
        }
        return false;
      }
      ts2.isInJSXText = isInJSXText;
      function findPrecedingMatchingToken(token, matchingTokenKind, sourceFile) {
        var tokenKind = token.kind;
        var remainingMatchingTokens = 0;
        while (true) {
          var preceding = findPrecedingToken(token.getFullStart(), sourceFile);
          if (!preceding) {
            return void 0;
          }
          token = preceding;
          if (token.kind === matchingTokenKind) {
            if (remainingMatchingTokens === 0) {
              return token;
            }
            remainingMatchingTokens--;
          } else if (token.kind === tokenKind) {
            remainingMatchingTokens++;
          }
        }
      }
      ts2.findPrecedingMatchingToken = findPrecedingMatchingToken;
      function removeOptionality(type, isOptionalExpression, isOptionalChain) {
        return isOptionalExpression ? type.getNonNullableType() : isOptionalChain ? type.getNonOptionalType() : type;
      }
      ts2.removeOptionality = removeOptionality;
      function isPossiblyTypeArgumentPosition(token, sourceFile, checker) {
        var info = getPossibleTypeArgumentsInfo(token, sourceFile);
        return info !== void 0 && (ts2.isPartOfTypeNode(info.called) || getPossibleGenericSignatures(info.called, info.nTypeArguments, checker).length !== 0 || isPossiblyTypeArgumentPosition(info.called, sourceFile, checker));
      }
      ts2.isPossiblyTypeArgumentPosition = isPossiblyTypeArgumentPosition;
      function getPossibleGenericSignatures(called, typeArgumentCount, checker) {
        var type = checker.getTypeAtLocation(called);
        if (ts2.isOptionalChain(called.parent)) {
          type = removeOptionality(type, ts2.isOptionalChainRoot(called.parent), true);
        }
        var signatures = ts2.isNewExpression(called.parent) ? type.getConstructSignatures() : type.getCallSignatures();
        return signatures.filter(function(candidate) {
          return !!candidate.typeParameters && candidate.typeParameters.length >= typeArgumentCount;
        });
      }
      ts2.getPossibleGenericSignatures = getPossibleGenericSignatures;
      function getPossibleTypeArgumentsInfo(tokenIn, sourceFile) {
        var token = tokenIn;
        var remainingLessThanTokens = 0;
        var nTypeArguments = 0;
        while (token) {
          switch (token.kind) {
            case 29:
              token = findPrecedingToken(token.getFullStart(), sourceFile);
              if (token && token.kind === 28) {
                token = findPrecedingToken(token.getFullStart(), sourceFile);
              }
              if (!token || !ts2.isIdentifier(token))
                return void 0;
              if (!remainingLessThanTokens) {
                return ts2.isDeclarationName(token) ? void 0 : { called: token, nTypeArguments };
              }
              remainingLessThanTokens--;
              break;
            case 49:
              remainingLessThanTokens = 3;
              break;
            case 48:
              remainingLessThanTokens = 2;
              break;
            case 31:
              remainingLessThanTokens++;
              break;
            case 19:
              token = findPrecedingMatchingToken(token, 18, sourceFile);
              if (!token)
                return void 0;
              break;
            case 21:
              token = findPrecedingMatchingToken(token, 20, sourceFile);
              if (!token)
                return void 0;
              break;
            case 23:
              token = findPrecedingMatchingToken(token, 22, sourceFile);
              if (!token)
                return void 0;
              break;
            case 27:
              nTypeArguments++;
              break;
            case 38:
            case 75:
            case 10:
            case 8:
            case 9:
            case 106:
            case 91:
            case 108:
            case 90:
            case 134:
            case 24:
            case 51:
            case 57:
            case 58:
              break;
            default:
              if (ts2.isTypeNode(token)) {
                break;
              }
              return void 0;
          }
          token = findPrecedingToken(token.getFullStart(), sourceFile);
        }
        return void 0;
      }
      ts2.getPossibleTypeArgumentsInfo = getPossibleTypeArgumentsInfo;
      function isInComment(sourceFile, position, tokenAtPosition) {
        return ts2.formatting.getRangeOfEnclosingComment(sourceFile, position, void 0, tokenAtPosition);
      }
      ts2.isInComment = isInComment;
      function hasDocComment(sourceFile, position) {
        var token = getTokenAtPosition(sourceFile, position);
        return !!ts2.findAncestor(token, ts2.isJSDoc);
      }
      ts2.hasDocComment = hasDocComment;
      function nodeHasTokens(n, sourceFile) {
        return n.kind === 1 ? !!n.jsDoc : n.getWidth(sourceFile) !== 0;
      }
      function getNodeModifiers(node) {
        var flags = ts2.isDeclaration(node) ? ts2.getCombinedModifierFlags(node) : 0;
        var result = [];
        if (flags & 8)
          result.push("private");
        if (flags & 16)
          result.push("protected");
        if (flags & 4)
          result.push("public");
        if (flags & 32)
          result.push("static");
        if (flags & 128)
          result.push("abstract");
        if (flags & 1)
          result.push("export");
        if (node.flags & 8388608)
          result.push("declare");
        if (node.kind === 259)
          result.push("export");
        return result.length > 0 ? result.join(",") : "";
      }
      ts2.getNodeModifiers = getNodeModifiers;
      function getTypeArgumentOrTypeParameterList(node) {
        if (node.kind === 169 || node.kind === 196) {
          return node.typeArguments;
        }
        if (ts2.isFunctionLike(node) || node.kind === 245 || node.kind === 246) {
          return node.typeParameters;
        }
        return void 0;
      }
      ts2.getTypeArgumentOrTypeParameterList = getTypeArgumentOrTypeParameterList;
      function isComment(kind) {
        return kind === 2 || kind === 3;
      }
      ts2.isComment = isComment;
      function isStringOrRegularExpressionOrTemplateLiteral(kind) {
        if (kind === 10 || kind === 13 || ts2.isTemplateLiteralKind(kind)) {
          return true;
        }
        return false;
      }
      ts2.isStringOrRegularExpressionOrTemplateLiteral = isStringOrRegularExpressionOrTemplateLiteral;
      function isPunctuation(kind) {
        return 18 <= kind && kind <= 74;
      }
      ts2.isPunctuation = isPunctuation;
      function isInsideTemplateLiteral(node, position, sourceFile) {
        return ts2.isTemplateLiteralKind(node.kind) && (node.getStart(sourceFile) < position && position < node.end) || !!node.isUnterminated && position === node.end;
      }
      ts2.isInsideTemplateLiteral = isInsideTemplateLiteral;
      function isAccessibilityModifier(kind) {
        switch (kind) {
          case 119:
          case 117:
          case 118:
            return true;
        }
        return false;
      }
      ts2.isAccessibilityModifier = isAccessibilityModifier;
      function cloneCompilerOptions(options) {
        var result = ts2.clone(options);
        ts2.setConfigFileInOptions(result, options && options.configFile);
        return result;
      }
      ts2.cloneCompilerOptions = cloneCompilerOptions;
      function isArrayLiteralOrObjectLiteralDestructuringPattern(node) {
        if (node.kind === 192 || node.kind === 193) {
          if (node.parent.kind === 209 && node.parent.left === node && node.parent.operatorToken.kind === 62) {
            return true;
          }
          if (node.parent.kind === 232 && node.parent.initializer === node) {
            return true;
          }
          if (isArrayLiteralOrObjectLiteralDestructuringPattern(node.parent.kind === 281 ? node.parent.parent : node.parent)) {
            return true;
          }
        }
        return false;
      }
      ts2.isArrayLiteralOrObjectLiteralDestructuringPattern = isArrayLiteralOrObjectLiteralDestructuringPattern;
      function isInReferenceComment(sourceFile, position) {
        return isInReferenceCommentWorker(sourceFile, position, true);
      }
      ts2.isInReferenceComment = isInReferenceComment;
      function isInNonReferenceComment(sourceFile, position) {
        return isInReferenceCommentWorker(sourceFile, position, false);
      }
      ts2.isInNonReferenceComment = isInNonReferenceComment;
      function isInReferenceCommentWorker(sourceFile, position, shouldBeReference) {
        var range = isInComment(sourceFile, position, void 0);
        return !!range && shouldBeReference === tripleSlashDirectivePrefixRegex.test(sourceFile.text.substring(range.pos, range.end));
      }
      function getReplacementSpanForContextToken(contextToken) {
        if (!contextToken)
          return void 0;
        switch (contextToken.kind) {
          case 10:
          case 14:
            return createTextSpanFromStringLiteralLikeContent(contextToken);
          default:
            return createTextSpanFromNode(contextToken);
        }
      }
      ts2.getReplacementSpanForContextToken = getReplacementSpanForContextToken;
      function createTextSpanFromNode(node, sourceFile, endNode) {
        return ts2.createTextSpanFromBounds(node.getStart(sourceFile), (endNode || node).getEnd());
      }
      ts2.createTextSpanFromNode = createTextSpanFromNode;
      function createTextSpanFromStringLiteralLikeContent(node) {
        if (node.isUnterminated)
          return void 0;
        return ts2.createTextSpanFromBounds(node.getStart() + 1, node.getEnd() - 1);
      }
      ts2.createTextSpanFromStringLiteralLikeContent = createTextSpanFromStringLiteralLikeContent;
      function createTextRangeFromNode(node, sourceFile) {
        return ts2.createRange(node.getStart(sourceFile), node.end);
      }
      ts2.createTextRangeFromNode = createTextRangeFromNode;
      function createTextSpanFromRange(range) {
        return ts2.createTextSpanFromBounds(range.pos, range.end);
      }
      ts2.createTextSpanFromRange = createTextSpanFromRange;
      function createTextRangeFromSpan(span) {
        return ts2.createRange(span.start, span.start + span.length);
      }
      ts2.createTextRangeFromSpan = createTextRangeFromSpan;
      function createTextChangeFromStartLength(start, length, newText) {
        return createTextChange(ts2.createTextSpan(start, length), newText);
      }
      ts2.createTextChangeFromStartLength = createTextChangeFromStartLength;
      function createTextChange(span, newText) {
        return { span, newText };
      }
      ts2.createTextChange = createTextChange;
      ts2.typeKeywords = [
        125,
        124,
        151,
        128,
        91,
        134,
        137,
        100,
        140,
        141,
        138,
        143,
        144,
        106,
        110,
        146,
        147,
        148
      ];
      function isTypeKeyword(kind) {
        return ts2.contains(ts2.typeKeywords, kind);
      }
      ts2.isTypeKeyword = isTypeKeyword;
      function isTypeKeywordToken(node) {
        return node.kind === 145;
      }
      ts2.isTypeKeywordToken = isTypeKeywordToken;
      function isExternalModuleSymbol(moduleSymbol) {
        return !!(moduleSymbol.flags & 1536) && moduleSymbol.name.charCodeAt(0) === 34;
      }
      ts2.isExternalModuleSymbol = isExternalModuleSymbol;
      function nodeSeenTracker() {
        var seen = [];
        return function(node) {
          var id = ts2.getNodeId(node);
          return !seen[id] && (seen[id] = true);
        };
      }
      ts2.nodeSeenTracker = nodeSeenTracker;
      function getSnapshotText(snap) {
        return snap.getText(0, snap.getLength());
      }
      ts2.getSnapshotText = getSnapshotText;
      function repeatString(str, count) {
        var result = "";
        for (var i = 0; i < count; i++) {
          result += str;
        }
        return result;
      }
      ts2.repeatString = repeatString;
      function skipConstraint(type) {
        return type.isTypeParameter() ? type.getConstraint() || type : type;
      }
      ts2.skipConstraint = skipConstraint;
      function getNameFromPropertyName(name) {
        return name.kind === 154 ? ts2.isStringOrNumericLiteralLike(name.expression) ? name.expression.text : void 0 : ts2.isPrivateIdentifier(name) ? ts2.idText(name) : ts2.getTextOfIdentifierOrLiteral(name);
      }
      ts2.getNameFromPropertyName = getNameFromPropertyName;
      function programContainsModules(program) {
        return program.getSourceFiles().some(function(s) {
          return !s.isDeclarationFile && !program.isSourceFileFromExternalLibrary(s) && !!(s.externalModuleIndicator || s.commonJsModuleIndicator);
        });
      }
      ts2.programContainsModules = programContainsModules;
      function programContainsEs6Modules(program) {
        return program.getSourceFiles().some(function(s) {
          return !s.isDeclarationFile && !program.isSourceFileFromExternalLibrary(s) && !!s.externalModuleIndicator;
        });
      }
      ts2.programContainsEs6Modules = programContainsEs6Modules;
      function compilerOptionsIndicateEs6Modules(compilerOptions) {
        return !!compilerOptions.module || compilerOptions.target >= 2 || !!compilerOptions.noEmit;
      }
      ts2.compilerOptionsIndicateEs6Modules = compilerOptionsIndicateEs6Modules;
      function createModuleSpecifierResolutionHost(program, host) {
        return {
          fileExists: function(fileName) {
            return program.fileExists(fileName);
          },
          getCurrentDirectory: function() {
            return host.getCurrentDirectory();
          },
          readFile: ts2.maybeBind(host, host.readFile),
          useCaseSensitiveFileNames: ts2.maybeBind(host, host.useCaseSensitiveFileNames),
          getProbableSymlinks: ts2.maybeBind(host, host.getProbableSymlinks) || function() {
            return program.getProbableSymlinks();
          },
          getGlobalTypingsCacheLocation: ts2.maybeBind(host, host.getGlobalTypingsCacheLocation),
          getSourceFiles: function() {
            return program.getSourceFiles();
          },
          redirectTargetsMap: program.redirectTargetsMap,
          getProjectReferenceRedirect: function(fileName) {
            return program.getProjectReferenceRedirect(fileName);
          },
          isSourceOfProjectReferenceRedirect: function(fileName) {
            return program.isSourceOfProjectReferenceRedirect(fileName);
          }
        };
      }
      ts2.createModuleSpecifierResolutionHost = createModuleSpecifierResolutionHost;
      function getModuleSpecifierResolverHost(program, host) {
        return __assign(__assign({}, createModuleSpecifierResolutionHost(program, host)), { getCommonSourceDirectory: function() {
          return program.getCommonSourceDirectory();
        } });
      }
      ts2.getModuleSpecifierResolverHost = getModuleSpecifierResolverHost;
      function makeImportIfNecessary(defaultImport, namedImports, moduleSpecifier, quotePreference) {
        return defaultImport || namedImports && namedImports.length ? makeImport(defaultImport, namedImports, moduleSpecifier, quotePreference) : void 0;
      }
      ts2.makeImportIfNecessary = makeImportIfNecessary;
      function makeImport(defaultImport, namedImports, moduleSpecifier, quotePreference, isTypeOnly) {
        return ts2.createImportDeclaration(void 0, void 0, defaultImport || namedImports ? ts2.createImportClause(defaultImport, namedImports && namedImports.length ? ts2.createNamedImports(namedImports) : void 0, isTypeOnly) : void 0, typeof moduleSpecifier === "string" ? makeStringLiteral(moduleSpecifier, quotePreference) : moduleSpecifier);
      }
      ts2.makeImport = makeImport;
      function makeStringLiteral(text, quotePreference) {
        return ts2.createLiteral(text, quotePreference === 0);
      }
      ts2.makeStringLiteral = makeStringLiteral;
      var QuotePreference;
      (function(QuotePreference2) {
        QuotePreference2[QuotePreference2["Single"] = 0] = "Single";
        QuotePreference2[QuotePreference2["Double"] = 1] = "Double";
      })(QuotePreference = ts2.QuotePreference || (ts2.QuotePreference = {}));
      function quotePreferenceFromString(str, sourceFile) {
        return ts2.isStringDoubleQuoted(str, sourceFile) ? 1 : 0;
      }
      ts2.quotePreferenceFromString = quotePreferenceFromString;
      function getQuotePreference(sourceFile, preferences) {
        if (preferences.quotePreference && preferences.quotePreference !== "auto") {
          return preferences.quotePreference === "single" ? 0 : 1;
        } else {
          var firstModuleSpecifier = sourceFile.imports && ts2.find(sourceFile.imports, ts2.isStringLiteral);
          return firstModuleSpecifier ? quotePreferenceFromString(firstModuleSpecifier, sourceFile) : 1;
        }
      }
      ts2.getQuotePreference = getQuotePreference;
      function getQuoteFromPreference(qp) {
        switch (qp) {
          case 0:
            return "'";
          case 1:
            return '"';
          default:
            return ts2.Debug.assertNever(qp);
        }
      }
      ts2.getQuoteFromPreference = getQuoteFromPreference;
      function symbolNameNoDefault(symbol) {
        var escaped = symbolEscapedNameNoDefault(symbol);
        return escaped === void 0 ? void 0 : ts2.unescapeLeadingUnderscores(escaped);
      }
      ts2.symbolNameNoDefault = symbolNameNoDefault;
      function symbolEscapedNameNoDefault(symbol) {
        if (symbol.escapedName !== "default") {
          return symbol.escapedName;
        }
        return ts2.firstDefined(symbol.declarations, function(decl) {
          var name = ts2.getNameOfDeclaration(decl);
          return name && name.kind === 75 ? name.escapedText : void 0;
        });
      }
      ts2.symbolEscapedNameNoDefault = symbolEscapedNameNoDefault;
      function isObjectBindingElementWithoutPropertyName(bindingElement) {
        return ts2.isBindingElement(bindingElement) && ts2.isObjectBindingPattern(bindingElement.parent) && ts2.isIdentifier(bindingElement.name) && !bindingElement.propertyName;
      }
      ts2.isObjectBindingElementWithoutPropertyName = isObjectBindingElementWithoutPropertyName;
      function getPropertySymbolFromBindingElement(checker, bindingElement) {
        var typeOfPattern = checker.getTypeAtLocation(bindingElement.parent);
        return typeOfPattern && checker.getPropertyOfType(typeOfPattern, bindingElement.name.text);
      }
      ts2.getPropertySymbolFromBindingElement = getPropertySymbolFromBindingElement;
      function getPropertySymbolsFromBaseTypes(symbol, propertyName, checker, cb) {
        var seen = ts2.createMap();
        return recur(symbol);
        function recur(symbol2) {
          if (!(symbol2.flags & (32 | 64)) || !ts2.addToSeen(seen, ts2.getSymbolId(symbol2)))
            return;
          return ts2.firstDefined(symbol2.declarations, function(declaration) {
            return ts2.firstDefined(ts2.getAllSuperTypeNodes(declaration), function(typeReference) {
              var type = checker.getTypeAtLocation(typeReference);
              var propertySymbol = type && type.symbol && checker.getPropertyOfType(type, propertyName);
              return type && propertySymbol && (ts2.firstDefined(checker.getRootSymbols(propertySymbol), cb) || recur(type.symbol));
            });
          });
        }
      }
      ts2.getPropertySymbolsFromBaseTypes = getPropertySymbolsFromBaseTypes;
      function isMemberSymbolInBaseType(memberSymbol, checker) {
        return getPropertySymbolsFromBaseTypes(memberSymbol.parent, memberSymbol.name, checker, function(_) {
          return true;
        }) || false;
      }
      ts2.isMemberSymbolInBaseType = isMemberSymbolInBaseType;
      function getParentNodeInSpan(node, file, span) {
        if (!node)
          return void 0;
        while (node.parent) {
          if (ts2.isSourceFile(node.parent) || !spanContainsNode(span, node.parent, file)) {
            return node;
          }
          node = node.parent;
        }
      }
      ts2.getParentNodeInSpan = getParentNodeInSpan;
      function spanContainsNode(span, node, file) {
        return ts2.textSpanContainsPosition(span, node.getStart(file)) && node.getEnd() <= ts2.textSpanEnd(span);
      }
      function findModifier(node, kind) {
        return node.modifiers && ts2.find(node.modifiers, function(m) {
          return m.kind === kind;
        });
      }
      ts2.findModifier = findModifier;
      function insertImports(changes, sourceFile, imports, blankLineBetween) {
        var decl = ts2.isArray(imports) ? imports[0] : imports;
        var importKindPredicate = decl.kind === 225 ? ts2.isRequireVariableDeclarationStatement : ts2.isAnyImportSyntax;
        var lastImportDeclaration = ts2.findLast(sourceFile.statements, function(statement) {
          return importKindPredicate(statement);
        });
        if (lastImportDeclaration) {
          if (ts2.isArray(imports)) {
            changes.insertNodesAfter(sourceFile, lastImportDeclaration, imports);
          } else {
            changes.insertNodeAfter(sourceFile, lastImportDeclaration, imports);
          }
        } else if (ts2.isArray(imports)) {
          changes.insertNodesAtTopOfFile(sourceFile, imports, blankLineBetween);
        } else {
          changes.insertNodeAtTopOfFile(sourceFile, imports, blankLineBetween);
        }
      }
      ts2.insertImports = insertImports;
      function getTypeKeywordOfTypeOnlyImport(importClause, sourceFile) {
        ts2.Debug.assert(importClause.isTypeOnly);
        return ts2.cast(importClause.getChildAt(0, sourceFile), isTypeKeywordToken);
      }
      ts2.getTypeKeywordOfTypeOnlyImport = getTypeKeywordOfTypeOnlyImport;
      function textSpansEqual(a, b) {
        return !!a && !!b && a.start === b.start && a.length === b.length;
      }
      ts2.textSpansEqual = textSpansEqual;
      function documentSpansEqual(a, b) {
        return a.fileName === b.fileName && textSpansEqual(a.textSpan, b.textSpan);
      }
      ts2.documentSpansEqual = documentSpansEqual;
      function forEachUnique(array, callback) {
        if (array) {
          for (var i = 0; i < array.length; i++) {
            if (array.indexOf(array[i]) === i) {
              var result = callback(array[i], i);
              if (result) {
                return result;
              }
            }
          }
        }
        return void 0;
      }
      ts2.forEachUnique = forEachUnique;
      function isFirstDeclarationOfSymbolParameter(symbol) {
        return symbol.declarations && symbol.declarations.length > 0 && symbol.declarations[0].kind === 156;
      }
      ts2.isFirstDeclarationOfSymbolParameter = isFirstDeclarationOfSymbolParameter;
      var displayPartWriter = getDisplayPartWriter();
      function getDisplayPartWriter() {
        var absoluteMaximumLength = ts2.defaultMaximumTruncationLength * 10;
        var displayParts;
        var lineStart;
        var indent;
        var length;
        resetWriter();
        var unknownWrite = function(text) {
          return writeKind(text, ts2.SymbolDisplayPartKind.text);
        };
        return {
          displayParts: function() {
            var finalText = displayParts.length && displayParts[displayParts.length - 1].text;
            if (length > absoluteMaximumLength && finalText && finalText !== "...") {
              if (!ts2.isWhiteSpaceLike(finalText.charCodeAt(finalText.length - 1))) {
                displayParts.push(displayPart(" ", ts2.SymbolDisplayPartKind.space));
              }
              displayParts.push(displayPart("...", ts2.SymbolDisplayPartKind.punctuation));
            }
            return displayParts;
          },
          writeKeyword: function(text) {
            return writeKind(text, ts2.SymbolDisplayPartKind.keyword);
          },
          writeOperator: function(text) {
            return writeKind(text, ts2.SymbolDisplayPartKind.operator);
          },
          writePunctuation: function(text) {
            return writeKind(text, ts2.SymbolDisplayPartKind.punctuation);
          },
          writeTrailingSemicolon: function(text) {
            return writeKind(text, ts2.SymbolDisplayPartKind.punctuation);
          },
          writeSpace: function(text) {
            return writeKind(text, ts2.SymbolDisplayPartKind.space);
          },
          writeStringLiteral: function(text) {
            return writeKind(text, ts2.SymbolDisplayPartKind.stringLiteral);
          },
          writeParameter: function(text) {
            return writeKind(text, ts2.SymbolDisplayPartKind.parameterName);
          },
          writeProperty: function(text) {
            return writeKind(text, ts2.SymbolDisplayPartKind.propertyName);
          },
          writeLiteral: function(text) {
            return writeKind(text, ts2.SymbolDisplayPartKind.stringLiteral);
          },
          writeSymbol,
          writeLine,
          write: unknownWrite,
          writeComment: unknownWrite,
          getText: function() {
            return "";
          },
          getTextPos: function() {
            return 0;
          },
          getColumn: function() {
            return 0;
          },
          getLine: function() {
            return 0;
          },
          isAtStartOfLine: function() {
            return false;
          },
          hasTrailingWhitespace: function() {
            return false;
          },
          hasTrailingComment: function() {
            return false;
          },
          rawWrite: ts2.notImplemented,
          getIndent: function() {
            return indent;
          },
          increaseIndent: function() {
            indent++;
          },
          decreaseIndent: function() {
            indent--;
          },
          clear: resetWriter,
          trackSymbol: ts2.noop,
          reportInaccessibleThisError: ts2.noop,
          reportInaccessibleUniqueSymbolError: ts2.noop,
          reportPrivateInBaseOfClassExpression: ts2.noop
        };
        function writeIndent() {
          if (length > absoluteMaximumLength)
            return;
          if (lineStart) {
            var indentString = ts2.getIndentString(indent);
            if (indentString) {
              length += indentString.length;
              displayParts.push(displayPart(indentString, ts2.SymbolDisplayPartKind.space));
            }
            lineStart = false;
          }
        }
        function writeKind(text, kind) {
          if (length > absoluteMaximumLength)
            return;
          writeIndent();
          length += text.length;
          displayParts.push(displayPart(text, kind));
        }
        function writeSymbol(text, symbol) {
          if (length > absoluteMaximumLength)
            return;
          writeIndent();
          length += text.length;
          displayParts.push(symbolPart(text, symbol));
        }
        function writeLine() {
          if (length > absoluteMaximumLength)
            return;
          length += 1;
          displayParts.push(lineBreakPart());
          lineStart = true;
        }
        function resetWriter() {
          displayParts = [];
          lineStart = true;
          indent = 0;
          length = 0;
        }
      }
      function symbolPart(text, symbol) {
        return displayPart(text, displayPartKind(symbol));
        function displayPartKind(symbol2) {
          var flags = symbol2.flags;
          if (flags & 3) {
            return isFirstDeclarationOfSymbolParameter(symbol2) ? ts2.SymbolDisplayPartKind.parameterName : ts2.SymbolDisplayPartKind.localName;
          } else if (flags & 4) {
            return ts2.SymbolDisplayPartKind.propertyName;
          } else if (flags & 32768) {
            return ts2.SymbolDisplayPartKind.propertyName;
          } else if (flags & 65536) {
            return ts2.SymbolDisplayPartKind.propertyName;
          } else if (flags & 8) {
            return ts2.SymbolDisplayPartKind.enumMemberName;
          } else if (flags & 16) {
            return ts2.SymbolDisplayPartKind.functionName;
          } else if (flags & 32) {
            return ts2.SymbolDisplayPartKind.className;
          } else if (flags & 64) {
            return ts2.SymbolDisplayPartKind.interfaceName;
          } else if (flags & 384) {
            return ts2.SymbolDisplayPartKind.enumName;
          } else if (flags & 1536) {
            return ts2.SymbolDisplayPartKind.moduleName;
          } else if (flags & 8192) {
            return ts2.SymbolDisplayPartKind.methodName;
          } else if (flags & 262144) {
            return ts2.SymbolDisplayPartKind.typeParameterName;
          } else if (flags & 524288) {
            return ts2.SymbolDisplayPartKind.aliasName;
          } else if (flags & 2097152) {
            return ts2.SymbolDisplayPartKind.aliasName;
          }
          return ts2.SymbolDisplayPartKind.text;
        }
      }
      ts2.symbolPart = symbolPart;
      function displayPart(text, kind) {
        return { text, kind: ts2.SymbolDisplayPartKind[kind] };
      }
      ts2.displayPart = displayPart;
      function spacePart() {
        return displayPart(" ", ts2.SymbolDisplayPartKind.space);
      }
      ts2.spacePart = spacePart;
      function keywordPart(kind) {
        return displayPart(ts2.tokenToString(kind), ts2.SymbolDisplayPartKind.keyword);
      }
      ts2.keywordPart = keywordPart;
      function punctuationPart(kind) {
        return displayPart(ts2.tokenToString(kind), ts2.SymbolDisplayPartKind.punctuation);
      }
      ts2.punctuationPart = punctuationPart;
      function operatorPart(kind) {
        return displayPart(ts2.tokenToString(kind), ts2.SymbolDisplayPartKind.operator);
      }
      ts2.operatorPart = operatorPart;
      function textOrKeywordPart(text) {
        var kind = ts2.stringToToken(text);
        return kind === void 0 ? textPart(text) : keywordPart(kind);
      }
      ts2.textOrKeywordPart = textOrKeywordPart;
      function textPart(text) {
        return displayPart(text, ts2.SymbolDisplayPartKind.text);
      }
      ts2.textPart = textPart;
      var carriageReturnLineFeed = "\r\n";
      function getNewLineOrDefaultFromHost(host, formatSettings) {
        var _a;
        return (formatSettings === null || formatSettings === void 0 ? void 0 : formatSettings.newLineCharacter) || ((_a = host.getNewLine) === null || _a === void 0 ? void 0 : _a.call(host)) || carriageReturnLineFeed;
      }
      ts2.getNewLineOrDefaultFromHost = getNewLineOrDefaultFromHost;
      function lineBreakPart() {
        return displayPart("\n", ts2.SymbolDisplayPartKind.lineBreak);
      }
      ts2.lineBreakPart = lineBreakPart;
      function mapToDisplayParts(writeDisplayParts) {
        try {
          writeDisplayParts(displayPartWriter);
          return displayPartWriter.displayParts();
        } finally {
          displayPartWriter.clear();
        }
      }
      ts2.mapToDisplayParts = mapToDisplayParts;
      function typeToDisplayParts(typechecker, type, enclosingDeclaration, flags) {
        if (flags === void 0) {
          flags = 0;
        }
        return mapToDisplayParts(function(writer) {
          typechecker.writeType(type, enclosingDeclaration, flags | 1024 | 16384, writer);
        });
      }
      ts2.typeToDisplayParts = typeToDisplayParts;
      function symbolToDisplayParts(typeChecker, symbol, enclosingDeclaration, meaning, flags) {
        if (flags === void 0) {
          flags = 0;
        }
        return mapToDisplayParts(function(writer) {
          typeChecker.writeSymbol(symbol, enclosingDeclaration, meaning, flags | 8, writer);
        });
      }
      ts2.symbolToDisplayParts = symbolToDisplayParts;
      function signatureToDisplayParts(typechecker, signature, enclosingDeclaration, flags) {
        if (flags === void 0) {
          flags = 0;
        }
        flags |= 16384 | 1024 | 32 | 8192;
        return mapToDisplayParts(function(writer) {
          typechecker.writeSignature(signature, enclosingDeclaration, flags, void 0, writer);
        });
      }
      ts2.signatureToDisplayParts = signatureToDisplayParts;
      function isImportOrExportSpecifierName(location) {
        return !!location.parent && ts2.isImportOrExportSpecifier(location.parent) && location.parent.propertyName === location;
      }
      ts2.isImportOrExportSpecifierName = isImportOrExportSpecifierName;
      function scriptKindIs(fileName, host) {
        var scriptKinds = [];
        for (var _i = 2; _i < arguments.length; _i++) {
          scriptKinds[_i - 2] = arguments[_i];
        }
        var scriptKind = getScriptKind(fileName, host);
        return ts2.some(scriptKinds, function(k) {
          return k === scriptKind;
        });
      }
      ts2.scriptKindIs = scriptKindIs;
      function getScriptKind(fileName, host) {
        return ts2.ensureScriptKind(fileName, host && host.getScriptKind && host.getScriptKind(fileName));
      }
      ts2.getScriptKind = getScriptKind;
      function getSymbolTarget(symbol, checker) {
        var next = symbol;
        while (isAliasSymbol(next) || isTransientSymbol(next) && next.target) {
          if (isTransientSymbol(next) && next.target) {
            next = next.target;
          } else {
            next = ts2.skipAlias(next, checker);
          }
        }
        return next;
      }
      ts2.getSymbolTarget = getSymbolTarget;
      function isTransientSymbol(symbol) {
        return (symbol.flags & 33554432) !== 0;
      }
      function isAliasSymbol(symbol) {
        return (symbol.flags & 2097152) !== 0;
      }
      function getUniqueSymbolId(symbol, checker) {
        return ts2.getSymbolId(ts2.skipAlias(symbol, checker));
      }
      ts2.getUniqueSymbolId = getUniqueSymbolId;
      function getFirstNonSpaceCharacterPosition(text, position) {
        while (ts2.isWhiteSpaceLike(text.charCodeAt(position))) {
          position += 1;
        }
        return position;
      }
      ts2.getFirstNonSpaceCharacterPosition = getFirstNonSpaceCharacterPosition;
      function getPrecedingNonSpaceCharacterPosition(text, position) {
        while (position > -1 && ts2.isWhiteSpaceSingleLine(text.charCodeAt(position))) {
          position -= 1;
        }
        return position + 1;
      }
      ts2.getPrecedingNonSpaceCharacterPosition = getPrecedingNonSpaceCharacterPosition;
      function getSynthesizedDeepClone(node, includeTrivia) {
        if (includeTrivia === void 0) {
          includeTrivia = true;
        }
        var clone = node && getSynthesizedDeepCloneWorker(node);
        if (clone && !includeTrivia)
          suppressLeadingAndTrailingTrivia(clone);
        return clone;
      }
      ts2.getSynthesizedDeepClone = getSynthesizedDeepClone;
      function getSynthesizedDeepCloneWithRenames(node, includeTrivia, renameMap, checker, callback) {
        if (includeTrivia === void 0) {
          includeTrivia = true;
        }
        var clone;
        if (renameMap && checker && ts2.isBindingElement(node) && ts2.isIdentifier(node.name) && ts2.isObjectBindingPattern(node.parent)) {
          var symbol = checker.getSymbolAtLocation(node.name);
          var renameInfo = symbol && renameMap.get(String(ts2.getSymbolId(symbol)));
          if (renameInfo && renameInfo.text !== (node.name || node.propertyName).getText()) {
            clone = ts2.setOriginalNode(ts2.createBindingElement(node.dotDotDotToken, node.propertyName || node.name, renameInfo, node.initializer), node);
          }
        } else if (renameMap && checker && ts2.isIdentifier(node)) {
          var symbol = checker.getSymbolAtLocation(node);
          var renameInfo = symbol && renameMap.get(String(ts2.getSymbolId(symbol)));
          if (renameInfo) {
            clone = ts2.setOriginalNode(ts2.createIdentifier(renameInfo.text), node);
          }
        }
        if (!clone) {
          clone = getSynthesizedDeepCloneWorker(node, renameMap, checker, callback);
        }
        if (clone && !includeTrivia)
          suppressLeadingAndTrailingTrivia(clone);
        if (callback && clone)
          callback(node, clone);
        return clone;
      }
      ts2.getSynthesizedDeepCloneWithRenames = getSynthesizedDeepCloneWithRenames;
      function getSynthesizedDeepCloneWorker(node, renameMap, checker, callback) {
        var visited = renameMap || checker || callback ? ts2.visitEachChild(node, wrapper, ts2.nullTransformationContext) : ts2.visitEachChild(node, getSynthesizedDeepClone, ts2.nullTransformationContext);
        if (visited === node) {
          var clone_1 = ts2.getSynthesizedClone(node);
          if (ts2.isStringLiteral(clone_1)) {
            clone_1.textSourceNode = node;
          } else if (ts2.isNumericLiteral(clone_1)) {
            clone_1.numericLiteralFlags = node.numericLiteralFlags;
          }
          return ts2.setTextRange(clone_1, node);
        }
        visited.parent = void 0;
        return visited;
        function wrapper(node2) {
          return getSynthesizedDeepCloneWithRenames(node2, true, renameMap, checker, callback);
        }
      }
      function getSynthesizedDeepClones(nodes, includeTrivia) {
        if (includeTrivia === void 0) {
          includeTrivia = true;
        }
        return nodes && ts2.createNodeArray(nodes.map(function(n) {
          return getSynthesizedDeepClone(n, includeTrivia);
        }), nodes.hasTrailingComma);
      }
      ts2.getSynthesizedDeepClones = getSynthesizedDeepClones;
      function suppressLeadingAndTrailingTrivia(node) {
        suppressLeadingTrivia(node);
        suppressTrailingTrivia(node);
      }
      ts2.suppressLeadingAndTrailingTrivia = suppressLeadingAndTrailingTrivia;
      function suppressLeadingTrivia(node) {
        addEmitFlagsRecursively(node, 512, getFirstChild);
      }
      ts2.suppressLeadingTrivia = suppressLeadingTrivia;
      function suppressTrailingTrivia(node) {
        addEmitFlagsRecursively(node, 1024, ts2.getLastChild);
      }
      ts2.suppressTrailingTrivia = suppressTrailingTrivia;
      function copyComments(sourceNode, targetNode) {
        var sourceFile = sourceNode.getSourceFile();
        var text = sourceFile.text;
        if (hasLeadingLineBreak(sourceNode, text)) {
          copyLeadingComments(sourceNode, targetNode, sourceFile);
        } else {
          copyTrailingAsLeadingComments(sourceNode, targetNode, sourceFile);
        }
        copyTrailingComments(sourceNode, targetNode, sourceFile);
      }
      ts2.copyComments = copyComments;
      function hasLeadingLineBreak(node, text) {
        var start = node.getFullStart();
        var end = node.getStart();
        for (var i = start; i < end; i++) {
          if (text.charCodeAt(i) === 10)
            return true;
        }
        return false;
      }
      function addEmitFlagsRecursively(node, flag, getChild) {
        ts2.addEmitFlags(node, flag);
        var child = getChild(node);
        if (child)
          addEmitFlagsRecursively(child, flag, getChild);
      }
      function getFirstChild(node) {
        return node.forEachChild(function(child) {
          return child;
        });
      }
      function getUniqueName(baseName, sourceFile) {
        var nameText = baseName;
        for (var i = 1; !ts2.isFileLevelUniqueName(sourceFile, nameText); i++) {
          nameText = baseName + "_" + i;
        }
        return nameText;
      }
      ts2.getUniqueName = getUniqueName;
      function getRenameLocation(edits, renameFilename, name, preferLastLocation) {
        var delta = 0;
        var lastPos = -1;
        for (var _i = 0, edits_1 = edits; _i < edits_1.length; _i++) {
          var _a = edits_1[_i], fileName = _a.fileName, textChanges_2 = _a.textChanges;
          ts2.Debug.assert(fileName === renameFilename);
          for (var _b = 0, textChanges_1 = textChanges_2; _b < textChanges_1.length; _b++) {
            var change = textChanges_1[_b];
            var span = change.span, newText = change.newText;
            var index = indexInTextChange(newText, name);
            if (index !== -1) {
              lastPos = span.start + delta + index;
              if (!preferLastLocation) {
                return lastPos;
              }
            }
            delta += newText.length - span.length;
          }
        }
        ts2.Debug.assert(preferLastLocation);
        ts2.Debug.assert(lastPos >= 0);
        return lastPos;
      }
      ts2.getRenameLocation = getRenameLocation;
      function copyLeadingComments(sourceNode, targetNode, sourceFile, commentKind, hasTrailingNewLine) {
        ts2.forEachLeadingCommentRange(sourceFile.text, sourceNode.pos, getAddCommentsFunction(targetNode, sourceFile, commentKind, hasTrailingNewLine, ts2.addSyntheticLeadingComment));
      }
      ts2.copyLeadingComments = copyLeadingComments;
      function copyTrailingComments(sourceNode, targetNode, sourceFile, commentKind, hasTrailingNewLine) {
        ts2.forEachTrailingCommentRange(sourceFile.text, sourceNode.end, getAddCommentsFunction(targetNode, sourceFile, commentKind, hasTrailingNewLine, ts2.addSyntheticTrailingComment));
      }
      ts2.copyTrailingComments = copyTrailingComments;
      function copyTrailingAsLeadingComments(sourceNode, targetNode, sourceFile, commentKind, hasTrailingNewLine) {
        ts2.forEachTrailingCommentRange(sourceFile.text, sourceNode.pos, getAddCommentsFunction(targetNode, sourceFile, commentKind, hasTrailingNewLine, ts2.addSyntheticLeadingComment));
      }
      ts2.copyTrailingAsLeadingComments = copyTrailingAsLeadingComments;
      function getAddCommentsFunction(targetNode, sourceFile, commentKind, hasTrailingNewLine, cb) {
        return function(pos, end, kind, htnl) {
          if (kind === 3) {
            pos += 2;
            end -= 2;
          } else {
            pos += 2;
          }
          cb(targetNode, commentKind || kind, sourceFile.text.slice(pos, end), hasTrailingNewLine !== void 0 ? hasTrailingNewLine : htnl);
        };
      }
      function indexInTextChange(change, name) {
        if (ts2.startsWith(change, name))
          return 0;
        var idx = change.indexOf(" " + name);
        if (idx === -1)
          idx = change.indexOf("." + name);
        if (idx === -1)
          idx = change.indexOf('"' + name);
        return idx === -1 ? -1 : idx + 1;
      }
      function needsParentheses(expression) {
        return ts2.isBinaryExpression(expression) && expression.operatorToken.kind === 27 || ts2.isObjectLiteralExpression(expression);
      }
      ts2.needsParentheses = needsParentheses;
      function getContextualTypeFromParent(node, checker) {
        var parent = node.parent;
        switch (parent.kind) {
          case 197:
            return checker.getContextualType(parent);
          case 209: {
            var _a = parent, left = _a.left, operatorToken = _a.operatorToken, right = _a.right;
            return isEqualityOperatorKind(operatorToken.kind) ? checker.getTypeAtLocation(node === right ? left : right) : checker.getContextualType(node);
          }
          case 277:
            return parent.expression === node ? getSwitchedType(parent, checker) : void 0;
          default:
            return checker.getContextualType(node);
        }
      }
      ts2.getContextualTypeFromParent = getContextualTypeFromParent;
      function quote(text, preferences) {
        var quotePreference = preferences.quotePreference || "auto";
        var quoted = JSON.stringify(text);
        switch (quotePreference) {
          case "auto":
          case "double":
            return quoted;
          case "single":
            return "'" + ts2.stripQuotes(quoted).replace("'", "\\'").replace('\\"', '"') + "'";
          default:
            return ts2.Debug.assertNever(quotePreference);
        }
      }
      ts2.quote = quote;
      function isEqualityOperatorKind(kind) {
        switch (kind) {
          case 36:
          case 34:
          case 37:
          case 35:
            return true;
          default:
            return false;
        }
      }
      ts2.isEqualityOperatorKind = isEqualityOperatorKind;
      function isStringLiteralOrTemplate(node) {
        switch (node.kind) {
          case 10:
          case 14:
          case 211:
          case 198:
            return true;
          default:
            return false;
        }
      }
      ts2.isStringLiteralOrTemplate = isStringLiteralOrTemplate;
      function hasIndexSignature(type) {
        return !!type.getStringIndexType() || !!type.getNumberIndexType();
      }
      ts2.hasIndexSignature = hasIndexSignature;
      function getSwitchedType(caseClause, checker) {
        return checker.getTypeAtLocation(caseClause.parent.parent.expression);
      }
      ts2.getSwitchedType = getSwitchedType;
      ts2.ANONYMOUS = "anonymous function";
      function getTypeNodeIfAccessible(type, enclosingScope, program, host) {
        var checker = program.getTypeChecker();
        var typeIsAccessible = true;
        var notAccessible = function() {
          typeIsAccessible = false;
        };
        var res = checker.typeToTypeNode(type, enclosingScope, void 0, {
          trackSymbol: function(symbol, declaration, meaning) {
            typeIsAccessible = typeIsAccessible && checker.isSymbolAccessible(symbol, declaration, meaning, false).accessibility === 0;
          },
          reportInaccessibleThisError: notAccessible,
          reportPrivateInBaseOfClassExpression: notAccessible,
          reportInaccessibleUniqueSymbolError: notAccessible,
          moduleResolverHost: getModuleSpecifierResolverHost(program, host)
        });
        return typeIsAccessible ? res : void 0;
      }
      ts2.getTypeNodeIfAccessible = getTypeNodeIfAccessible;
      function syntaxRequiresTrailingCommaOrSemicolonOrASI(kind) {
        return kind === 165 || kind === 166 || kind === 167 || kind === 158 || kind === 160;
      }
      ts2.syntaxRequiresTrailingCommaOrSemicolonOrASI = syntaxRequiresTrailingCommaOrSemicolonOrASI;
      function syntaxRequiresTrailingFunctionBlockOrSemicolonOrASI(kind) {
        return kind === 244 || kind === 162 || kind === 161 || kind === 163 || kind === 164;
      }
      ts2.syntaxRequiresTrailingFunctionBlockOrSemicolonOrASI = syntaxRequiresTrailingFunctionBlockOrSemicolonOrASI;
      function syntaxRequiresTrailingModuleBlockOrSemicolonOrASI(kind) {
        return kind === 249;
      }
      ts2.syntaxRequiresTrailingModuleBlockOrSemicolonOrASI = syntaxRequiresTrailingModuleBlockOrSemicolonOrASI;
      function syntaxRequiresTrailingSemicolonOrASI(kind) {
        return kind === 225 || kind === 226 || kind === 228 || kind === 233 || kind === 234 || kind === 235 || kind === 239 || kind === 241 || kind === 159 || kind === 247 || kind === 254 || kind === 253 || kind === 260 || kind === 252 || kind === 259;
      }
      ts2.syntaxRequiresTrailingSemicolonOrASI = syntaxRequiresTrailingSemicolonOrASI;
      ts2.syntaxMayBeASICandidate = ts2.or(syntaxRequiresTrailingCommaOrSemicolonOrASI, syntaxRequiresTrailingFunctionBlockOrSemicolonOrASI, syntaxRequiresTrailingModuleBlockOrSemicolonOrASI, syntaxRequiresTrailingSemicolonOrASI);
      function nodeIsASICandidate(node, sourceFile) {
        var lastToken = node.getLastToken(sourceFile);
        if (lastToken && lastToken.kind === 26) {
          return false;
        }
        if (syntaxRequiresTrailingCommaOrSemicolonOrASI(node.kind)) {
          if (lastToken && lastToken.kind === 27) {
            return false;
          }
        } else if (syntaxRequiresTrailingModuleBlockOrSemicolonOrASI(node.kind)) {
          var lastChild = ts2.last(node.getChildren(sourceFile));
          if (lastChild && ts2.isModuleBlock(lastChild)) {
            return false;
          }
        } else if (syntaxRequiresTrailingFunctionBlockOrSemicolonOrASI(node.kind)) {
          var lastChild = ts2.last(node.getChildren(sourceFile));
          if (lastChild && ts2.isFunctionBlock(lastChild)) {
            return false;
          }
        } else if (!syntaxRequiresTrailingSemicolonOrASI(node.kind)) {
          return false;
        }
        if (node.kind === 228) {
          return true;
        }
        var topNode = ts2.findAncestor(node, function(ancestor) {
          return !ancestor.parent;
        });
        var nextToken = findNextToken(node, topNode, sourceFile);
        if (!nextToken || nextToken.kind === 19) {
          return true;
        }
        var startLine = sourceFile.getLineAndCharacterOfPosition(node.getEnd()).line;
        var endLine = sourceFile.getLineAndCharacterOfPosition(nextToken.getStart(sourceFile)).line;
        return startLine !== endLine;
      }
      function positionIsASICandidate(pos, context, sourceFile) {
        var contextAncestor = ts2.findAncestor(context, function(ancestor) {
          if (ancestor.end !== pos) {
            return "quit";
          }
          return ts2.syntaxMayBeASICandidate(ancestor.kind);
        });
        return !!contextAncestor && nodeIsASICandidate(contextAncestor, sourceFile);
      }
      ts2.positionIsASICandidate = positionIsASICandidate;
      function probablyUsesSemicolons(sourceFile) {
        var withSemicolon = 0;
        var withoutSemicolon = 0;
        var nStatementsToObserve = 5;
        ts2.forEachChild(sourceFile, function visit(node) {
          if (syntaxRequiresTrailingSemicolonOrASI(node.kind)) {
            var lastToken = node.getLastToken(sourceFile);
            if (lastToken && lastToken.kind === 26) {
              withSemicolon++;
            } else {
              withoutSemicolon++;
            }
          }
          if (withSemicolon + withoutSemicolon >= nStatementsToObserve) {
            return true;
          }
          return ts2.forEachChild(node, visit);
        });
        if (withSemicolon === 0 && withoutSemicolon <= 1) {
          return true;
        }
        return withSemicolon / withoutSemicolon > 1 / nStatementsToObserve;
      }
      ts2.probablyUsesSemicolons = probablyUsesSemicolons;
      function tryGetDirectories(host, directoryName) {
        return tryIOAndConsumeErrors(host, host.getDirectories, directoryName) || [];
      }
      ts2.tryGetDirectories = tryGetDirectories;
      function tryReadDirectory(host, path2, extensions, exclude, include) {
        return tryIOAndConsumeErrors(host, host.readDirectory, path2, extensions, exclude, include) || ts2.emptyArray;
      }
      ts2.tryReadDirectory = tryReadDirectory;
      function tryFileExists(host, path2) {
        return tryIOAndConsumeErrors(host, host.fileExists, path2);
      }
      ts2.tryFileExists = tryFileExists;
      function tryDirectoryExists(host, path2) {
        return tryAndIgnoreErrors(function() {
          return ts2.directoryProbablyExists(path2, host);
        }) || false;
      }
      ts2.tryDirectoryExists = tryDirectoryExists;
      function tryAndIgnoreErrors(cb) {
        try {
          return cb();
        } catch (_a) {
          return void 0;
        }
      }
      ts2.tryAndIgnoreErrors = tryAndIgnoreErrors;
      function tryIOAndConsumeErrors(host, toApply) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
          args[_i - 2] = arguments[_i];
        }
        return tryAndIgnoreErrors(function() {
          return toApply && toApply.apply(host, args);
        });
      }
      ts2.tryIOAndConsumeErrors = tryIOAndConsumeErrors;
      function findPackageJsons(startDirectory, host, stopDirectory) {
        var paths = [];
        ts2.forEachAncestorDirectory(startDirectory, function(ancestor) {
          if (ancestor === stopDirectory) {
            return true;
          }
          var currentConfigPath = ts2.combinePaths(ancestor, "package.json");
          if (tryFileExists(host, currentConfigPath)) {
            paths.push(currentConfigPath);
          }
        });
        return paths;
      }
      ts2.findPackageJsons = findPackageJsons;
      function findPackageJson(directory, host) {
        var packageJson;
        ts2.forEachAncestorDirectory(directory, function(ancestor) {
          if (ancestor === "node_modules")
            return true;
          packageJson = ts2.findConfigFile(ancestor, function(f) {
            return tryFileExists(host, f);
          }, "package.json");
          if (packageJson) {
            return true;
          }
        });
        return packageJson;
      }
      ts2.findPackageJson = findPackageJson;
      function getPackageJsonsVisibleToFile(fileName, host) {
        if (!host.fileExists) {
          return [];
        }
        var packageJsons = [];
        ts2.forEachAncestorDirectory(ts2.getDirectoryPath(fileName), function(ancestor) {
          var packageJsonFileName = ts2.combinePaths(ancestor, "package.json");
          if (host.fileExists(packageJsonFileName)) {
            var info = createPackageJsonInfo(packageJsonFileName, host);
            if (info) {
              packageJsons.push(info);
            }
          }
        });
        return packageJsons;
      }
      ts2.getPackageJsonsVisibleToFile = getPackageJsonsVisibleToFile;
      function createPackageJsonInfo(fileName, host) {
        if (!host.readFile) {
          return void 0;
        }
        var dependencyKeys = ["dependencies", "devDependencies", "optionalDependencies", "peerDependencies"];
        var stringContent = host.readFile(fileName);
        if (!stringContent)
          return void 0;
        var content = tryParseJson(stringContent);
        if (!content)
          return false;
        var info = {};
        for (var _i = 0, dependencyKeys_1 = dependencyKeys; _i < dependencyKeys_1.length; _i++) {
          var key = dependencyKeys_1[_i];
          var dependencies = content[key];
          if (!dependencies) {
            continue;
          }
          var dependencyMap = ts2.createMap();
          for (var packageName in dependencies) {
            dependencyMap.set(packageName, dependencies[packageName]);
          }
          info[key] = dependencyMap;
        }
        var dependencyGroups = [
          [1, info.dependencies],
          [2, info.devDependencies],
          [8, info.optionalDependencies],
          [4, info.peerDependencies]
        ];
        return __assign(__assign({}, info), {
          fileName,
          get,
          has: function(dependencyName, inGroups) {
            return !!get(dependencyName, inGroups);
          }
        });
        function get(dependencyName, inGroups) {
          if (inGroups === void 0) {
            inGroups = 15;
          }
          for (var _i2 = 0, dependencyGroups_1 = dependencyGroups; _i2 < dependencyGroups_1.length; _i2++) {
            var _a = dependencyGroups_1[_i2], group_1 = _a[0], deps = _a[1];
            if (deps && inGroups & group_1) {
              var dep = deps.get(dependencyName);
              if (dep !== void 0) {
                return dep;
              }
            }
          }
        }
      }
      ts2.createPackageJsonInfo = createPackageJsonInfo;
      function tryParseJson(text) {
        try {
          return JSON.parse(text);
        } catch (_a) {
          return void 0;
        }
      }
      function consumesNodeCoreModules(sourceFile) {
        return ts2.some(sourceFile.imports, function(_a) {
          var text = _a.text;
          return ts2.JsTyping.nodeCoreModules.has(text);
        });
      }
      ts2.consumesNodeCoreModules = consumesNodeCoreModules;
      function isInsideNodeModules(fileOrDirectory) {
        return ts2.contains(ts2.getPathComponents(fileOrDirectory), "node_modules");
      }
      ts2.isInsideNodeModules = isInsideNodeModules;
      function isDiagnosticWithLocation(diagnostic) {
        return diagnostic.file !== void 0 && diagnostic.start !== void 0 && diagnostic.length !== void 0;
      }
      ts2.isDiagnosticWithLocation = isDiagnosticWithLocation;
      function findDiagnosticForNode(node, sortedFileDiagnostics) {
        var span = createTextSpanFromNode(node);
        var index = ts2.binarySearchKey(sortedFileDiagnostics, span, ts2.identity, ts2.compareTextSpans);
        if (index >= 0) {
          var diagnostic = sortedFileDiagnostics[index];
          ts2.Debug.assertEqual(diagnostic.file, node.getSourceFile(), "Diagnostics proided to 'findDiagnosticForNode' must be from a single SourceFile");
          return ts2.cast(diagnostic, isDiagnosticWithLocation);
        }
      }
      ts2.findDiagnosticForNode = findDiagnosticForNode;
      function getDiagnosticsWithinSpan(span, sortedFileDiagnostics) {
        var _a;
        var index = ts2.binarySearchKey(sortedFileDiagnostics, span.start, function(diag) {
          return diag.start;
        }, ts2.compareValues);
        if (index < 0) {
          index = ~index;
        }
        while (((_a = sortedFileDiagnostics[index - 1]) === null || _a === void 0 ? void 0 : _a.start) === span.start) {
          index--;
        }
        var result = [];
        var end = ts2.textSpanEnd(span);
        while (true) {
          var diagnostic = ts2.tryCast(sortedFileDiagnostics[index], isDiagnosticWithLocation);
          if (!diagnostic || diagnostic.start > end) {
            break;
          }
          if (ts2.textSpanContainsTextSpan(span, diagnostic)) {
            result.push(diagnostic);
          }
          index++;
        }
        return result;
      }
      ts2.getDiagnosticsWithinSpan = getDiagnosticsWithinSpan;
      function getRefactorContextSpan(_a) {
        var startPosition = _a.startPosition, endPosition = _a.endPosition;
        return ts2.createTextSpanFromBounds(startPosition, endPosition === void 0 ? startPosition : endPosition);
      }
      ts2.getRefactorContextSpan = getRefactorContextSpan;
      function mapOneOrMany(valueOrArray, f, resultSelector) {
        if (resultSelector === void 0) {
          resultSelector = ts2.identity;
        }
        return valueOrArray ? ts2.isArray(valueOrArray) ? resultSelector(ts2.map(valueOrArray, f)) : f(valueOrArray, 0) : void 0;
      }
      ts2.mapOneOrMany = mapOneOrMany;
      function firstOrOnly(valueOrArray) {
        return ts2.isArray(valueOrArray) ? ts2.first(valueOrArray) : valueOrArray;
      }
      ts2.firstOrOnly = firstOrOnly;
      function getNameForExportedSymbol(symbol, scriptTarget) {
        if (symbol.escapedName === "export=" || symbol.escapedName === "default") {
          return ts2.firstDefined(symbol.declarations, function(d) {
            return ts2.isExportAssignment(d) && ts2.isIdentifier(d.expression) ? d.expression.text : void 0;
          }) || ts2.codefix.moduleSymbolToValidIdentifier(ts2.Debug.checkDefined(symbol.parent), scriptTarget);
        }
        return symbol.name;
      }
      ts2.getNameForExportedSymbol = getNameForExportedSymbol;
      function stringContainsAt(haystack, needle, startIndex) {
        var needleLength = needle.length;
        if (needleLength + startIndex > haystack.length) {
          return false;
        }
        for (var i = 0; i < needleLength; i++) {
          if (needle.charCodeAt(i) !== haystack.charCodeAt(i + startIndex))
            return false;
        }
        return true;
      }
      ts2.stringContainsAt = stringContainsAt;
      function startsWithUnderscore(name) {
        return name.charCodeAt(0) === 95;
      }
      ts2.startsWithUnderscore = startsWithUnderscore;
      function isGlobalDeclaration(declaration) {
        return !isNonGlobalDeclaration(declaration);
      }
      ts2.isGlobalDeclaration = isGlobalDeclaration;
      function isNonGlobalDeclaration(declaration) {
        var sourceFile = declaration.getSourceFile();
        if (!sourceFile.externalModuleIndicator && !sourceFile.commonJsModuleIndicator) {
          return false;
        }
        return ts2.isInJSFile(declaration) || !ts2.findAncestor(declaration, ts2.isGlobalScopeAugmentation);
      }
      ts2.isNonGlobalDeclaration = isNonGlobalDeclaration;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function createClassifier() {
        var scanner = ts2.createScanner(99, false);
        function getClassificationsForLine(text, lexState, syntacticClassifierAbsent) {
          return convertClassificationsToResult(getEncodedLexicalClassifications(text, lexState, syntacticClassifierAbsent), text);
        }
        function getEncodedLexicalClassifications(text, lexState, syntacticClassifierAbsent) {
          var token = 0;
          var lastNonTriviaToken = 0;
          var templateStack = [];
          var _a = getPrefixFromLexState(lexState), prefix = _a.prefix, pushTemplate = _a.pushTemplate;
          text = prefix + text;
          var offset = prefix.length;
          if (pushTemplate) {
            templateStack.push(15);
          }
          scanner.setText(text);
          var endOfLineState = 0;
          var spans = [];
          var angleBracketStack = 0;
          do {
            token = scanner.scan();
            if (!ts2.isTrivia(token)) {
              handleToken();
              lastNonTriviaToken = token;
            }
            var end = scanner.getTextPos();
            pushEncodedClassification(scanner.getTokenPos(), end, offset, classFromKind(token), spans);
            if (end >= text.length) {
              var end_1 = getNewEndOfLineState(scanner, token, ts2.lastOrUndefined(templateStack));
              if (end_1 !== void 0) {
                endOfLineState = end_1;
              }
            }
          } while (token !== 1);
          function handleToken() {
            switch (token) {
              case 43:
              case 67:
                if (!noRegexTable[lastNonTriviaToken] && scanner.reScanSlashToken() === 13) {
                  token = 13;
                }
                break;
              case 29:
                if (lastNonTriviaToken === 75) {
                  angleBracketStack++;
                }
                break;
              case 31:
                if (angleBracketStack > 0) {
                  angleBracketStack--;
                }
                break;
              case 125:
              case 143:
              case 140:
              case 128:
              case 144:
                if (angleBracketStack > 0 && !syntacticClassifierAbsent) {
                  token = 75;
                }
                break;
              case 15:
                templateStack.push(token);
                break;
              case 18:
                if (templateStack.length > 0) {
                  templateStack.push(token);
                }
                break;
              case 19:
                if (templateStack.length > 0) {
                  var lastTemplateStackToken = ts2.lastOrUndefined(templateStack);
                  if (lastTemplateStackToken === 15) {
                    token = scanner.reScanTemplateToken(false);
                    if (token === 17) {
                      templateStack.pop();
                    } else {
                      ts2.Debug.assertEqual(token, 16, "Should have been a template middle.");
                    }
                  } else {
                    ts2.Debug.assertEqual(lastTemplateStackToken, 18, "Should have been an open brace");
                    templateStack.pop();
                  }
                }
                break;
              default:
                if (!ts2.isKeyword(token)) {
                  break;
                }
                if (lastNonTriviaToken === 24) {
                  token = 75;
                } else if (ts2.isKeyword(lastNonTriviaToken) && ts2.isKeyword(token) && !canFollow(lastNonTriviaToken, token)) {
                  token = 75;
                }
            }
          }
          return { endOfLineState, spans };
        }
        return { getClassificationsForLine, getEncodedLexicalClassifications };
      }
      ts2.createClassifier = createClassifier;
      var noRegexTable = ts2.arrayToNumericMap([
        75,
        10,
        8,
        9,
        13,
        104,
        45,
        46,
        21,
        23,
        19,
        106,
        91
      ], function(token) {
        return token;
      }, function() {
        return true;
      });
      function getNewEndOfLineState(scanner, token, lastOnTemplateStack) {
        switch (token) {
          case 10: {
            if (!scanner.isUnterminated())
              return void 0;
            var tokenText = scanner.getTokenText();
            var lastCharIndex = tokenText.length - 1;
            var numBackslashes = 0;
            while (tokenText.charCodeAt(lastCharIndex - numBackslashes) === 92) {
              numBackslashes++;
            }
            if ((numBackslashes & 1) === 0)
              return void 0;
            return tokenText.charCodeAt(0) === 34 ? 3 : 2;
          }
          case 3:
            return scanner.isUnterminated() ? 1 : void 0;
          default:
            if (ts2.isTemplateLiteralKind(token)) {
              if (!scanner.isUnterminated()) {
                return void 0;
              }
              switch (token) {
                case 17:
                  return 5;
                case 14:
                  return 4;
                default:
                  return ts2.Debug.fail("Only 'NoSubstitutionTemplateLiteral's and 'TemplateTail's can be unterminated; got SyntaxKind #" + token);
              }
            }
            return lastOnTemplateStack === 15 ? 6 : void 0;
        }
      }
      function pushEncodedClassification(start, end, offset, classification, result) {
        if (classification === 8) {
          return;
        }
        if (start === 0 && offset > 0) {
          start += offset;
        }
        var length = end - start;
        if (length > 0) {
          result.push(start - offset, length, classification);
        }
      }
      function convertClassificationsToResult(classifications, text) {
        var entries = [];
        var dense = classifications.spans;
        var lastEnd = 0;
        for (var i = 0; i < dense.length; i += 3) {
          var start = dense[i];
          var length_1 = dense[i + 1];
          var type = dense[i + 2];
          if (lastEnd >= 0) {
            var whitespaceLength_1 = start - lastEnd;
            if (whitespaceLength_1 > 0) {
              entries.push({ length: whitespaceLength_1, classification: ts2.TokenClass.Whitespace });
            }
          }
          entries.push({ length: length_1, classification: convertClassification(type) });
          lastEnd = start + length_1;
        }
        var whitespaceLength = text.length - lastEnd;
        if (whitespaceLength > 0) {
          entries.push({ length: whitespaceLength, classification: ts2.TokenClass.Whitespace });
        }
        return { entries, finalLexState: classifications.endOfLineState };
      }
      function convertClassification(type) {
        switch (type) {
          case 1:
            return ts2.TokenClass.Comment;
          case 3:
            return ts2.TokenClass.Keyword;
          case 4:
            return ts2.TokenClass.NumberLiteral;
          case 25:
            return ts2.TokenClass.BigIntLiteral;
          case 5:
            return ts2.TokenClass.Operator;
          case 6:
            return ts2.TokenClass.StringLiteral;
          case 8:
            return ts2.TokenClass.Whitespace;
          case 10:
            return ts2.TokenClass.Punctuation;
          case 2:
          case 11:
          case 12:
          case 13:
          case 14:
          case 15:
          case 16:
          case 9:
          case 17:
            return ts2.TokenClass.Identifier;
          default:
            return void 0;
        }
      }
      function canFollow(keyword1, keyword2) {
        if (!ts2.isAccessibilityModifier(keyword1)) {
          return true;
        }
        switch (keyword2) {
          case 131:
          case 142:
          case 129:
          case 120:
            return true;
          default:
            return false;
        }
      }
      function getPrefixFromLexState(lexState) {
        switch (lexState) {
          case 3:
            return { prefix: '"\\\n' };
          case 2:
            return { prefix: "'\\\n" };
          case 1:
            return { prefix: "/*\n" };
          case 4:
            return { prefix: "`\n" };
          case 5:
            return { prefix: "}\n", pushTemplate: true };
          case 6:
            return { prefix: "", pushTemplate: true };
          case 0:
            return { prefix: "" };
          default:
            return ts2.Debug.assertNever(lexState);
        }
      }
      function isBinaryExpressionOperatorToken(token) {
        switch (token) {
          case 41:
          case 43:
          case 44:
          case 39:
          case 40:
          case 47:
          case 48:
          case 49:
          case 29:
          case 31:
          case 32:
          case 33:
          case 98:
          case 97:
          case 123:
          case 34:
          case 35:
          case 36:
          case 37:
          case 50:
          case 52:
          case 51:
          case 55:
          case 56:
          case 73:
          case 72:
          case 74:
          case 69:
          case 70:
          case 71:
          case 63:
          case 64:
          case 65:
          case 67:
          case 68:
          case 62:
          case 27:
          case 60:
            return true;
          default:
            return false;
        }
      }
      function isPrefixUnaryExpressionOperatorToken(token) {
        switch (token) {
          case 39:
          case 40:
          case 54:
          case 53:
          case 45:
          case 46:
            return true;
          default:
            return false;
        }
      }
      function classFromKind(token) {
        if (ts2.isKeyword(token)) {
          return 3;
        } else if (isBinaryExpressionOperatorToken(token) || isPrefixUnaryExpressionOperatorToken(token)) {
          return 5;
        } else if (token >= 18 && token <= 74) {
          return 10;
        }
        switch (token) {
          case 8:
            return 4;
          case 9:
            return 25;
          case 10:
            return 6;
          case 13:
            return 7;
          case 7:
          case 3:
          case 2:
            return 1;
          case 5:
          case 4:
            return 8;
          case 75:
          default:
            if (ts2.isTemplateLiteralKind(token)) {
              return 6;
            }
            return 2;
        }
      }
      function getSemanticClassifications(typeChecker, cancellationToken, sourceFile, classifiableNames, span) {
        return convertClassificationsToSpans(getEncodedSemanticClassifications(typeChecker, cancellationToken, sourceFile, classifiableNames, span));
      }
      ts2.getSemanticClassifications = getSemanticClassifications;
      function checkForClassificationCancellation(cancellationToken, kind) {
        switch (kind) {
          case 249:
          case 245:
          case 246:
          case 244:
            cancellationToken.throwIfCancellationRequested();
        }
      }
      function getEncodedSemanticClassifications(typeChecker, cancellationToken, sourceFile, classifiableNames, span) {
        var spans = [];
        sourceFile.forEachChild(function cb(node) {
          if (!node || !ts2.textSpanIntersectsWith(span, node.pos, node.getFullWidth())) {
            return;
          }
          checkForClassificationCancellation(cancellationToken, node.kind);
          if (ts2.isIdentifier(node) && !ts2.nodeIsMissing(node) && classifiableNames.has(node.escapedText)) {
            var symbol = typeChecker.getSymbolAtLocation(node);
            var type = symbol && classifySymbol(symbol, ts2.getMeaningFromLocation(node), typeChecker);
            if (type) {
              pushClassification(node.getStart(sourceFile), node.getEnd(), type);
            }
          }
          node.forEachChild(cb);
        });
        return { spans, endOfLineState: 0 };
        function pushClassification(start, end, type) {
          var length = end - start;
          ts2.Debug.assert(length > 0, "Classification had non-positive length of " + length);
          spans.push(start);
          spans.push(length);
          spans.push(type);
        }
      }
      ts2.getEncodedSemanticClassifications = getEncodedSemanticClassifications;
      function classifySymbol(symbol, meaningAtPosition, checker) {
        var flags = symbol.getFlags();
        if ((flags & 2885600) === 0) {
          return void 0;
        } else if (flags & 32) {
          return 11;
        } else if (flags & 384) {
          return 12;
        } else if (flags & 524288) {
          return 16;
        } else if (flags & 1536) {
          return meaningAtPosition & 4 || meaningAtPosition & 1 && hasValueSideModule(symbol) ? 14 : void 0;
        } else if (flags & 2097152) {
          return classifySymbol(checker.getAliasedSymbol(symbol), meaningAtPosition, checker);
        } else if (meaningAtPosition & 2) {
          return flags & 64 ? 13 : flags & 262144 ? 15 : void 0;
        } else {
          return void 0;
        }
      }
      function hasValueSideModule(symbol) {
        return ts2.some(symbol.declarations, function(declaration) {
          return ts2.isModuleDeclaration(declaration) && ts2.getModuleInstanceState(declaration) === 1;
        });
      }
      function getClassificationTypeName(type) {
        switch (type) {
          case 1:
            return "comment";
          case 2:
            return "identifier";
          case 3:
            return "keyword";
          case 4:
            return "number";
          case 25:
            return "bigint";
          case 5:
            return "operator";
          case 6:
            return "string";
          case 8:
            return "whitespace";
          case 9:
            return "text";
          case 10:
            return "punctuation";
          case 11:
            return "class name";
          case 12:
            return "enum name";
          case 13:
            return "interface name";
          case 14:
            return "module name";
          case 15:
            return "type parameter name";
          case 16:
            return "type alias name";
          case 17:
            return "parameter name";
          case 18:
            return "doc comment tag name";
          case 19:
            return "jsx open tag name";
          case 20:
            return "jsx close tag name";
          case 21:
            return "jsx self closing tag name";
          case 22:
            return "jsx attribute";
          case 23:
            return "jsx text";
          case 24:
            return "jsx attribute string literal value";
          default:
            return void 0;
        }
      }
      function convertClassificationsToSpans(classifications) {
        ts2.Debug.assert(classifications.spans.length % 3 === 0);
        var dense = classifications.spans;
        var result = [];
        for (var i = 0; i < dense.length; i += 3) {
          result.push({
            textSpan: ts2.createTextSpan(dense[i], dense[i + 1]),
            classificationType: getClassificationTypeName(dense[i + 2])
          });
        }
        return result;
      }
      function getSyntacticClassifications(cancellationToken, sourceFile, span) {
        return convertClassificationsToSpans(getEncodedSyntacticClassifications(cancellationToken, sourceFile, span));
      }
      ts2.getSyntacticClassifications = getSyntacticClassifications;
      function getEncodedSyntacticClassifications(cancellationToken, sourceFile, span) {
        var spanStart = span.start;
        var spanLength = span.length;
        var triviaScanner = ts2.createScanner(99, false, sourceFile.languageVariant, sourceFile.text);
        var mergeConflictScanner = ts2.createScanner(99, false, sourceFile.languageVariant, sourceFile.text);
        var result = [];
        processElement(sourceFile);
        return { spans: result, endOfLineState: 0 };
        function pushClassification(start, length, type) {
          result.push(start);
          result.push(length);
          result.push(type);
        }
        function classifyLeadingTriviaAndGetTokenStart(token) {
          triviaScanner.setTextPos(token.pos);
          while (true) {
            var start = triviaScanner.getTextPos();
            if (!ts2.couldStartTrivia(sourceFile.text, start)) {
              return start;
            }
            var kind = triviaScanner.scan();
            var end = triviaScanner.getTextPos();
            var width = end - start;
            if (!ts2.isTrivia(kind)) {
              return start;
            }
            switch (kind) {
              case 4:
              case 5:
                continue;
              case 2:
              case 3:
                classifyComment(token, kind, start, width);
                triviaScanner.setTextPos(end);
                continue;
              case 7:
                var text = sourceFile.text;
                var ch = text.charCodeAt(start);
                if (ch === 60 || ch === 62) {
                  pushClassification(start, width, 1);
                  continue;
                }
                ts2.Debug.assert(ch === 124 || ch === 61);
                classifyDisabledMergeCode(text, start, end);
                break;
              case 6:
                break;
              default:
                ts2.Debug.assertNever(kind);
            }
          }
        }
        function classifyComment(token, kind, start, width) {
          if (kind === 3) {
            var docCommentAndDiagnostics = ts2.parseIsolatedJSDocComment(sourceFile.text, start, width);
            if (docCommentAndDiagnostics && docCommentAndDiagnostics.jsDoc) {
              docCommentAndDiagnostics.jsDoc.parent = token;
              classifyJSDocComment(docCommentAndDiagnostics.jsDoc);
              return;
            }
          } else if (kind === 2) {
            if (tryClassifyTripleSlashComment(start, width)) {
              return;
            }
          }
          pushCommentRange(start, width);
        }
        function pushCommentRange(start, width) {
          pushClassification(start, width, 1);
        }
        function classifyJSDocComment(docComment) {
          var pos = docComment.pos;
          if (docComment.tags) {
            for (var _i = 0, _a = docComment.tags; _i < _a.length; _i++) {
              var tag = _a[_i];
              if (tag.pos !== pos) {
                pushCommentRange(pos, tag.pos - pos);
              }
              pushClassification(tag.pos, 1, 10);
              pushClassification(tag.tagName.pos, tag.tagName.end - tag.tagName.pos, 18);
              pos = tag.tagName.end;
              switch (tag.kind) {
                case 317:
                  processJSDocParameterTag(tag);
                  break;
                case 321:
                  processJSDocTemplateTag(tag);
                  pos = tag.end;
                  break;
                case 320:
                  processElement(tag.typeExpression);
                  pos = tag.end;
                  break;
                case 318:
                  processElement(tag.typeExpression);
                  pos = tag.end;
                  break;
              }
            }
          }
          if (pos !== docComment.end) {
            pushCommentRange(pos, docComment.end - pos);
          }
          return;
          function processJSDocParameterTag(tag2) {
            if (tag2.isNameFirst) {
              pushCommentRange(pos, tag2.name.pos - pos);
              pushClassification(tag2.name.pos, tag2.name.end - tag2.name.pos, 17);
              pos = tag2.name.end;
            }
            if (tag2.typeExpression) {
              pushCommentRange(pos, tag2.typeExpression.pos - pos);
              processElement(tag2.typeExpression);
              pos = tag2.typeExpression.end;
            }
            if (!tag2.isNameFirst) {
              pushCommentRange(pos, tag2.name.pos - pos);
              pushClassification(tag2.name.pos, tag2.name.end - tag2.name.pos, 17);
              pos = tag2.name.end;
            }
          }
        }
        function tryClassifyTripleSlashComment(start, width) {
          var tripleSlashXMLCommentRegEx = /^(\/\/\/\s*)(<)(?:(\S+)((?:[^/]|\/[^>])*)(\/>)?)?/im;
          var attributeRegex = /(\S+)(\s*)(=)(\s*)('[^']+'|"[^"]+")/img;
          var text = sourceFile.text.substr(start, width);
          var match = tripleSlashXMLCommentRegEx.exec(text);
          if (!match) {
            return false;
          }
          if (!match[3] || !(match[3] in ts2.commentPragmas)) {
            return false;
          }
          var pos = start;
          pushCommentRange(pos, match[1].length);
          pos += match[1].length;
          pushClassification(pos, match[2].length, 10);
          pos += match[2].length;
          pushClassification(pos, match[3].length, 21);
          pos += match[3].length;
          var attrText = match[4];
          var attrPos = pos;
          while (true) {
            var attrMatch = attributeRegex.exec(attrText);
            if (!attrMatch) {
              break;
            }
            var newAttrPos = pos + attrMatch.index;
            if (newAttrPos > attrPos) {
              pushCommentRange(attrPos, newAttrPos - attrPos);
              attrPos = newAttrPos;
            }
            pushClassification(attrPos, attrMatch[1].length, 22);
            attrPos += attrMatch[1].length;
            if (attrMatch[2].length) {
              pushCommentRange(attrPos, attrMatch[2].length);
              attrPos += attrMatch[2].length;
            }
            pushClassification(attrPos, attrMatch[3].length, 5);
            attrPos += attrMatch[3].length;
            if (attrMatch[4].length) {
              pushCommentRange(attrPos, attrMatch[4].length);
              attrPos += attrMatch[4].length;
            }
            pushClassification(attrPos, attrMatch[5].length, 24);
            attrPos += attrMatch[5].length;
          }
          pos += match[4].length;
          if (pos > attrPos) {
            pushCommentRange(attrPos, pos - attrPos);
          }
          if (match[5]) {
            pushClassification(pos, match[5].length, 10);
            pos += match[5].length;
          }
          var end = start + width;
          if (pos < end) {
            pushCommentRange(pos, end - pos);
          }
          return true;
        }
        function processJSDocTemplateTag(tag) {
          for (var _i = 0, _a = tag.getChildren(); _i < _a.length; _i++) {
            var child = _a[_i];
            processElement(child);
          }
        }
        function classifyDisabledMergeCode(text, start, end) {
          var i;
          for (i = start; i < end; i++) {
            if (ts2.isLineBreak(text.charCodeAt(i))) {
              break;
            }
          }
          pushClassification(start, i - start, 1);
          mergeConflictScanner.setTextPos(i);
          while (mergeConflictScanner.getTextPos() < end) {
            classifyDisabledCodeToken();
          }
        }
        function classifyDisabledCodeToken() {
          var start = mergeConflictScanner.getTextPos();
          var tokenKind = mergeConflictScanner.scan();
          var end = mergeConflictScanner.getTextPos();
          var type = classifyTokenType(tokenKind);
          if (type) {
            pushClassification(start, end - start, type);
          }
        }
        function tryClassifyNode(node) {
          if (ts2.isJSDoc(node)) {
            return true;
          }
          if (ts2.nodeIsMissing(node)) {
            return true;
          }
          var classifiedElementName = tryClassifyJsxElementName(node);
          if (!ts2.isToken(node) && node.kind !== 11 && classifiedElementName === void 0) {
            return false;
          }
          var tokenStart = node.kind === 11 ? node.pos : classifyLeadingTriviaAndGetTokenStart(node);
          var tokenWidth = node.end - tokenStart;
          ts2.Debug.assert(tokenWidth >= 0);
          if (tokenWidth > 0) {
            var type = classifiedElementName || classifyTokenType(node.kind, node);
            if (type) {
              pushClassification(tokenStart, tokenWidth, type);
            }
          }
          return true;
        }
        function tryClassifyJsxElementName(token) {
          switch (token.parent && token.parent.kind) {
            case 268:
              if (token.parent.tagName === token) {
                return 19;
              }
              break;
            case 269:
              if (token.parent.tagName === token) {
                return 20;
              }
              break;
            case 267:
              if (token.parent.tagName === token) {
                return 21;
              }
              break;
            case 273:
              if (token.parent.name === token) {
                return 22;
              }
              break;
          }
          return void 0;
        }
        function classifyTokenType(tokenKind, token) {
          if (ts2.isKeyword(tokenKind)) {
            return 3;
          }
          if (tokenKind === 29 || tokenKind === 31) {
            if (token && ts2.getTypeArgumentOrTypeParameterList(token.parent)) {
              return 10;
            }
          }
          if (ts2.isPunctuation(tokenKind)) {
            if (token) {
              var parent = token.parent;
              if (tokenKind === 62) {
                if (parent.kind === 242 || parent.kind === 159 || parent.kind === 156 || parent.kind === 273) {
                  return 5;
                }
              }
              if (parent.kind === 209 || parent.kind === 207 || parent.kind === 208 || parent.kind === 210) {
                return 5;
              }
            }
            return 10;
          } else if (tokenKind === 8) {
            return 4;
          } else if (tokenKind === 9) {
            return 25;
          } else if (tokenKind === 10) {
            return token && token.parent.kind === 273 ? 24 : 6;
          } else if (tokenKind === 13) {
            return 6;
          } else if (ts2.isTemplateLiteralKind(tokenKind)) {
            return 6;
          } else if (tokenKind === 11) {
            return 23;
          } else if (tokenKind === 75) {
            if (token) {
              switch (token.parent.kind) {
                case 245:
                  if (token.parent.name === token) {
                    return 11;
                  }
                  return;
                case 155:
                  if (token.parent.name === token) {
                    return 15;
                  }
                  return;
                case 246:
                  if (token.parent.name === token) {
                    return 13;
                  }
                  return;
                case 248:
                  if (token.parent.name === token) {
                    return 12;
                  }
                  return;
                case 249:
                  if (token.parent.name === token) {
                    return 14;
                  }
                  return;
                case 156:
                  if (token.parent.name === token) {
                    return ts2.isThisIdentifier(token) ? 3 : 17;
                  }
                  return;
              }
            }
            return 2;
          }
        }
        function processElement(element) {
          if (!element) {
            return;
          }
          if (ts2.decodedTextSpanIntersectsWith(spanStart, spanLength, element.pos, element.getFullWidth())) {
            checkForClassificationCancellation(cancellationToken, element.kind);
            for (var _i = 0, _a = element.getChildren(sourceFile); _i < _a.length; _i++) {
              var child = _a[_i];
              if (!tryClassifyNode(child)) {
                processElement(child);
              }
            }
          }
        }
      }
      ts2.getEncodedSyntacticClassifications = getEncodedSyntacticClassifications;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var Completions;
      (function(Completions2) {
        var StringCompletions;
        (function(StringCompletions2) {
          function getStringLiteralCompletions(sourceFile, position, contextToken, checker, options, host, log, preferences) {
            if (ts2.isInReferenceComment(sourceFile, position)) {
              var entries = getTripleSlashReferenceCompletion(sourceFile, position, options, host);
              return entries && convertPathCompletions(entries);
            }
            if (ts2.isInString(sourceFile, position, contextToken)) {
              if (!contextToken || !ts2.isStringLiteralLike(contextToken))
                return void 0;
              var entries = getStringLiteralCompletionEntries(sourceFile, contextToken, position, checker, options, host);
              return convertStringLiteralCompletions(entries, contextToken, sourceFile, checker, log, preferences);
            }
          }
          StringCompletions2.getStringLiteralCompletions = getStringLiteralCompletions;
          function convertStringLiteralCompletions(completion, contextToken, sourceFile, checker, log, preferences) {
            if (completion === void 0) {
              return void 0;
            }
            switch (completion.kind) {
              case 0:
                return convertPathCompletions(completion.paths);
              case 1: {
                var entries = [];
                Completions2.getCompletionEntriesFromSymbols(completion.symbols, entries, contextToken, sourceFile, sourceFile, checker, 99, log, 4, preferences);
                return { isGlobalCompletion: false, isMemberCompletion: true, isNewIdentifierLocation: completion.hasIndexSignature, entries };
              }
              case 2: {
                var entries = completion.types.map(function(type) {
                  return {
                    name: type.value,
                    kindModifiers: "",
                    kind: "string",
                    sortText: "0",
                    replacementSpan: ts2.getReplacementSpanForContextToken(contextToken)
                  };
                });
                return { isGlobalCompletion: false, isMemberCompletion: false, isNewIdentifierLocation: completion.isNewIdentifier, entries };
              }
              default:
                return ts2.Debug.assertNever(completion);
            }
          }
          function getStringLiteralCompletionDetails(name, sourceFile, position, contextToken, checker, options, host, cancellationToken) {
            if (!contextToken || !ts2.isStringLiteralLike(contextToken))
              return void 0;
            var completions = getStringLiteralCompletionEntries(sourceFile, contextToken, position, checker, options, host);
            return completions && stringLiteralCompletionDetails(name, contextToken, completions, sourceFile, checker, cancellationToken);
          }
          StringCompletions2.getStringLiteralCompletionDetails = getStringLiteralCompletionDetails;
          function stringLiteralCompletionDetails(name, location, completion, sourceFile, checker, cancellationToken) {
            switch (completion.kind) {
              case 0: {
                var match = ts2.find(completion.paths, function(p) {
                  return p.name === name;
                });
                return match && Completions2.createCompletionDetails(name, kindModifiersFromExtension(match.extension), match.kind, [ts2.textPart(name)]);
              }
              case 1: {
                var match = ts2.find(completion.symbols, function(s) {
                  return s.name === name;
                });
                return match && Completions2.createCompletionDetailsForSymbol(match, checker, sourceFile, location, cancellationToken);
              }
              case 2:
                return ts2.find(completion.types, function(t) {
                  return t.value === name;
                }) ? Completions2.createCompletionDetails(name, "", "type", [ts2.textPart(name)]) : void 0;
              default:
                return ts2.Debug.assertNever(completion);
            }
          }
          function convertPathCompletions(pathCompletions) {
            var isGlobalCompletion = false;
            var isNewIdentifierLocation = true;
            var entries = pathCompletions.map(function(_a) {
              var name = _a.name, kind = _a.kind, span = _a.span, extension = _a.extension;
              return { name, kind, kindModifiers: kindModifiersFromExtension(extension), sortText: Completions2.SortText.LocationPriority, replacementSpan: span };
            });
            return { isGlobalCompletion, isMemberCompletion: false, isNewIdentifierLocation, entries };
          }
          function kindModifiersFromExtension(extension) {
            switch (extension) {
              case ".d.ts":
                return ".d.ts";
              case ".js":
                return ".js";
              case ".json":
                return ".json";
              case ".jsx":
                return ".jsx";
              case ".ts":
                return ".ts";
              case ".tsx":
                return ".tsx";
              case ".tsbuildinfo":
                return ts2.Debug.fail("Extension .tsbuildinfo is unsupported.");
              case void 0:
                return "";
              default:
                return ts2.Debug.assertNever(extension);
            }
          }
          var StringLiteralCompletionKind;
          (function(StringLiteralCompletionKind2) {
            StringLiteralCompletionKind2[StringLiteralCompletionKind2["Paths"] = 0] = "Paths";
            StringLiteralCompletionKind2[StringLiteralCompletionKind2["Properties"] = 1] = "Properties";
            StringLiteralCompletionKind2[StringLiteralCompletionKind2["Types"] = 2] = "Types";
          })(StringLiteralCompletionKind || (StringLiteralCompletionKind = {}));
          function getStringLiteralCompletionEntries(sourceFile, node, position, typeChecker, compilerOptions, host) {
            var parent = node.parent;
            switch (parent.kind) {
              case 187:
                switch (parent.parent.kind) {
                  case 169:
                    return { kind: 2, types: getStringLiteralTypes(typeChecker.getTypeArgumentConstraint(parent)), isNewIdentifier: false };
                  case 185:
                    return stringLiteralCompletionsFromProperties(typeChecker.getTypeFromTypeNode(parent.parent.objectType));
                  case 188:
                    return { kind: 0, paths: getStringLiteralCompletionsFromModuleNames(sourceFile, node, compilerOptions, host, typeChecker) };
                  case 178: {
                    if (!ts2.isTypeReferenceNode(parent.parent.parent))
                      return void 0;
                    var alreadyUsedTypes_1 = getAlreadyUsedTypesInStringLiteralUnion(parent.parent, parent);
                    var types = getStringLiteralTypes(typeChecker.getTypeArgumentConstraint(parent.parent)).filter(function(t) {
                      return !ts2.contains(alreadyUsedTypes_1, t.value);
                    });
                    return { kind: 2, types, isNewIdentifier: false };
                  }
                  default:
                    return void 0;
                }
              case 281:
                if (ts2.isObjectLiteralExpression(parent.parent) && parent.name === node) {
                  return stringLiteralCompletionsFromProperties(typeChecker.getContextualType(parent.parent));
                }
                return fromContextualType();
              case 195: {
                var _a = parent, expression = _a.expression, argumentExpression = _a.argumentExpression;
                if (node === argumentExpression) {
                  return stringLiteralCompletionsFromProperties(typeChecker.getTypeAtLocation(expression));
                }
                return void 0;
              }
              case 196:
              case 197:
                if (!ts2.isRequireCall(parent, false) && !ts2.isImportCall(parent)) {
                  var argumentInfo = ts2.SignatureHelp.getArgumentInfoForCompletions(node, position, sourceFile);
                  return argumentInfo ? getStringLiteralCompletionsFromSignature(argumentInfo, typeChecker) : fromContextualType();
                }
              case 254:
              case 260:
              case 265:
                return { kind: 0, paths: getStringLiteralCompletionsFromModuleNames(sourceFile, node, compilerOptions, host, typeChecker) };
              default:
                return fromContextualType();
            }
            function fromContextualType() {
              return { kind: 2, types: getStringLiteralTypes(ts2.getContextualTypeFromParent(node, typeChecker)), isNewIdentifier: false };
            }
          }
          function getAlreadyUsedTypesInStringLiteralUnion(union, current) {
            return ts2.mapDefined(union.types, function(type) {
              return type !== current && ts2.isLiteralTypeNode(type) && ts2.isStringLiteral(type.literal) ? type.literal.text : void 0;
            });
          }
          function getStringLiteralCompletionsFromSignature(argumentInfo, checker) {
            var isNewIdentifier = false;
            var uniques = ts2.createMap();
            var candidates = [];
            checker.getResolvedSignature(argumentInfo.invocation, candidates, argumentInfo.argumentCount);
            var types = ts2.flatMap(candidates, function(candidate) {
              if (!ts2.signatureHasRestParameter(candidate) && argumentInfo.argumentCount > candidate.parameters.length)
                return;
              var type = checker.getParameterType(candidate, argumentInfo.argumentIndex);
              isNewIdentifier = isNewIdentifier || !!(type.flags & 4);
              return getStringLiteralTypes(type, uniques);
            });
            return { kind: 2, types, isNewIdentifier };
          }
          function stringLiteralCompletionsFromProperties(type) {
            return type && {
              kind: 1,
              symbols: type.getApparentProperties().filter(function(prop) {
                return !ts2.isPrivateIdentifierPropertyDeclaration(ts2.isTransientSymbol(prop) && prop.syntheticOrigin ? prop.syntheticOrigin.valueDeclaration : prop.valueDeclaration);
              }),
              hasIndexSignature: ts2.hasIndexSignature(type)
            };
          }
          function getStringLiteralTypes(type, uniques) {
            if (uniques === void 0) {
              uniques = ts2.createMap();
            }
            if (!type)
              return ts2.emptyArray;
            type = ts2.skipConstraint(type);
            return type.isUnion() ? ts2.flatMap(type.types, function(t) {
              return getStringLiteralTypes(t, uniques);
            }) : type.isStringLiteral() && !(type.flags & 1024) && ts2.addToSeen(uniques, type.value) ? [type] : ts2.emptyArray;
          }
          function nameAndKind(name, kind, extension) {
            return { name, kind, extension };
          }
          function directoryResult(name) {
            return nameAndKind(name, "directory", void 0);
          }
          function addReplacementSpans(text, textStart, names) {
            var span = getDirectoryFragmentTextSpan(text, textStart);
            return names.map(function(_a) {
              var name = _a.name, kind = _a.kind, extension = _a.extension;
              return { name, kind, extension, span };
            });
          }
          function getStringLiteralCompletionsFromModuleNames(sourceFile, node, compilerOptions, host, typeChecker) {
            return addReplacementSpans(node.text, node.getStart(sourceFile) + 1, getStringLiteralCompletionsFromModuleNamesWorker(sourceFile, node, compilerOptions, host, typeChecker));
          }
          function getStringLiteralCompletionsFromModuleNamesWorker(sourceFile, node, compilerOptions, host, typeChecker) {
            var literalValue = ts2.normalizeSlashes(node.text);
            var scriptPath = sourceFile.path;
            var scriptDirectory = ts2.getDirectoryPath(scriptPath);
            return isPathRelativeToScript(literalValue) || !compilerOptions.baseUrl && (ts2.isRootedDiskPath(literalValue) || ts2.isUrl(literalValue)) ? getCompletionEntriesForRelativeModules(literalValue, scriptDirectory, compilerOptions, host, scriptPath) : getCompletionEntriesForNonRelativeModules(literalValue, scriptDirectory, compilerOptions, host, typeChecker);
          }
          function getExtensionOptions(compilerOptions, includeExtensions) {
            if (includeExtensions === void 0) {
              includeExtensions = false;
            }
            return { extensions: getSupportedExtensionsForModuleResolution(compilerOptions), includeExtensions };
          }
          function getCompletionEntriesForRelativeModules(literalValue, scriptDirectory, compilerOptions, host, scriptPath) {
            var extensionOptions = getExtensionOptions(compilerOptions);
            if (compilerOptions.rootDirs) {
              return getCompletionEntriesForDirectoryFragmentWithRootDirs(compilerOptions.rootDirs, literalValue, scriptDirectory, extensionOptions, compilerOptions, host, scriptPath);
            } else {
              return getCompletionEntriesForDirectoryFragment(literalValue, scriptDirectory, extensionOptions, host, scriptPath);
            }
          }
          function getSupportedExtensionsForModuleResolution(compilerOptions) {
            var extensions = ts2.getSupportedExtensions(compilerOptions);
            return compilerOptions.resolveJsonModule && ts2.getEmitModuleResolutionKind(compilerOptions) === ts2.ModuleResolutionKind.NodeJs ? extensions.concat(".json") : extensions;
          }
          function getBaseDirectoriesFromRootDirs(rootDirs, basePath, scriptDirectory, ignoreCase) {
            rootDirs = rootDirs.map(function(rootDirectory) {
              return ts2.normalizePath(ts2.isRootedDiskPath(rootDirectory) ? rootDirectory : ts2.combinePaths(basePath, rootDirectory));
            });
            var relativeDirectory = ts2.firstDefined(rootDirs, function(rootDirectory) {
              return ts2.containsPath(rootDirectory, scriptDirectory, basePath, ignoreCase) ? scriptDirectory.substr(rootDirectory.length) : void 0;
            });
            return ts2.deduplicate(__spreadArrays(rootDirs.map(function(rootDirectory) {
              return ts2.combinePaths(rootDirectory, relativeDirectory);
            }), [scriptDirectory]), ts2.equateStringsCaseSensitive, ts2.compareStringsCaseSensitive);
          }
          function getCompletionEntriesForDirectoryFragmentWithRootDirs(rootDirs, fragment, scriptDirectory, extensionOptions, compilerOptions, host, exclude) {
            var basePath = compilerOptions.project || host.getCurrentDirectory();
            var ignoreCase = !(host.useCaseSensitiveFileNames && host.useCaseSensitiveFileNames());
            var baseDirectories = getBaseDirectoriesFromRootDirs(rootDirs, basePath, scriptDirectory, ignoreCase);
            return ts2.flatMap(baseDirectories, function(baseDirectory) {
              return getCompletionEntriesForDirectoryFragment(fragment, baseDirectory, extensionOptions, host, exclude);
            });
          }
          function getCompletionEntriesForDirectoryFragment(fragment, scriptPath, _a, host, exclude, result) {
            var extensions = _a.extensions, includeExtensions = _a.includeExtensions;
            if (result === void 0) {
              result = [];
            }
            if (fragment === void 0) {
              fragment = "";
            }
            fragment = ts2.normalizeSlashes(fragment);
            if (!ts2.hasTrailingDirectorySeparator(fragment)) {
              fragment = ts2.getDirectoryPath(fragment);
            }
            if (fragment === "") {
              fragment = "." + ts2.directorySeparator;
            }
            fragment = ts2.ensureTrailingDirectorySeparator(fragment);
            var absolutePath = ts2.resolvePath(scriptPath, fragment);
            var baseDirectory = ts2.hasTrailingDirectorySeparator(absolutePath) ? absolutePath : ts2.getDirectoryPath(absolutePath);
            var ignoreCase = !(host.useCaseSensitiveFileNames && host.useCaseSensitiveFileNames());
            if (!ts2.tryDirectoryExists(host, baseDirectory))
              return result;
            var files = ts2.tryReadDirectory(host, baseDirectory, extensions, void 0, ["./*"]);
            if (files) {
              var foundFiles = ts2.createMap();
              for (var _i = 0, files_1 = files; _i < files_1.length; _i++) {
                var filePath = files_1[_i];
                filePath = ts2.normalizePath(filePath);
                if (exclude && ts2.comparePaths(filePath, exclude, scriptPath, ignoreCase) === 0) {
                  continue;
                }
                var foundFileName = includeExtensions || ts2.fileExtensionIs(filePath, ".json") ? ts2.getBaseFileName(filePath) : ts2.removeFileExtension(ts2.getBaseFileName(filePath));
                foundFiles.set(foundFileName, ts2.tryGetExtensionFromPath(filePath));
              }
              foundFiles.forEach(function(ext, foundFile) {
                result.push(nameAndKind(foundFile, "script", ext));
              });
            }
            var directories = ts2.tryGetDirectories(host, baseDirectory);
            if (directories) {
              for (var _b = 0, directories_1 = directories; _b < directories_1.length; _b++) {
                var directory = directories_1[_b];
                var directoryName = ts2.getBaseFileName(ts2.normalizePath(directory));
                if (directoryName !== "@types") {
                  result.push(directoryResult(directoryName));
                }
              }
            }
            var packageJsonPath = ts2.findPackageJson(baseDirectory, host);
            if (packageJsonPath) {
              var packageJson = ts2.readJson(packageJsonPath, host);
              var typesVersions = packageJson.typesVersions;
              if (typeof typesVersions === "object") {
                var versionResult = ts2.getPackageJsonTypesVersionsPaths(typesVersions);
                var versionPaths = versionResult && versionResult.paths;
                var rest = absolutePath.slice(ts2.ensureTrailingDirectorySeparator(baseDirectory).length);
                if (versionPaths) {
                  addCompletionEntriesFromPaths(result, rest, baseDirectory, extensions, versionPaths, host);
                }
              }
            }
            return result;
          }
          function addCompletionEntriesFromPaths(result, fragment, baseDirectory, fileExtensions, paths, host) {
            for (var path2 in paths) {
              if (!ts2.hasProperty(paths, path2))
                continue;
              var patterns = paths[path2];
              if (patterns) {
                var _loop_1 = function(name2, kind2, extension2) {
                  if (!result.some(function(entry) {
                    return entry.name === name2;
                  })) {
                    result.push(nameAndKind(name2, kind2, extension2));
                  }
                };
                for (var _i = 0, _a = getCompletionsForPathMapping(path2, patterns, fragment, baseDirectory, fileExtensions, host); _i < _a.length; _i++) {
                  var _b = _a[_i], name = _b.name, kind = _b.kind, extension = _b.extension;
                  _loop_1(name, kind, extension);
                }
              }
            }
          }
          function getCompletionEntriesForNonRelativeModules(fragment, scriptPath, compilerOptions, host, typeChecker) {
            var baseUrl = compilerOptions.baseUrl, paths = compilerOptions.paths;
            var result = [];
            var extensionOptions = getExtensionOptions(compilerOptions);
            if (baseUrl) {
              var projectDir = compilerOptions.project || host.getCurrentDirectory();
              var absolute = ts2.normalizePath(ts2.combinePaths(projectDir, baseUrl));
              getCompletionEntriesForDirectoryFragment(fragment, absolute, extensionOptions, host, void 0, result);
              if (paths) {
                addCompletionEntriesFromPaths(result, fragment, absolute, extensionOptions.extensions, paths, host);
              }
            }
            var fragmentDirectory = getFragmentDirectory(fragment);
            for (var _i = 0, _a = getAmbientModuleCompletions(fragment, fragmentDirectory, typeChecker); _i < _a.length; _i++) {
              var ambientName = _a[_i];
              result.push(nameAndKind(ambientName, "external module name", void 0));
            }
            getCompletionEntriesFromTypings(host, compilerOptions, scriptPath, fragmentDirectory, extensionOptions, result);
            if (ts2.getEmitModuleResolutionKind(compilerOptions) === ts2.ModuleResolutionKind.NodeJs) {
              var foundGlobal = false;
              if (fragmentDirectory === void 0) {
                var _loop_2 = function(moduleName2) {
                  if (!result.some(function(entry) {
                    return entry.name === moduleName2;
                  })) {
                    foundGlobal = true;
                    result.push(nameAndKind(moduleName2, "external module name", void 0));
                  }
                };
                for (var _b = 0, _c = enumerateNodeModulesVisibleToScript(host, scriptPath); _b < _c.length; _b++) {
                  var moduleName = _c[_b];
                  _loop_2(moduleName);
                }
              }
              if (!foundGlobal) {
                ts2.forEachAncestorDirectory(scriptPath, function(ancestor) {
                  var nodeModules = ts2.combinePaths(ancestor, "node_modules");
                  if (ts2.tryDirectoryExists(host, nodeModules)) {
                    getCompletionEntriesForDirectoryFragment(fragment, nodeModules, extensionOptions, host, void 0, result);
                  }
                });
              }
            }
            return result;
          }
          function getFragmentDirectory(fragment) {
            return containsSlash(fragment) ? ts2.hasTrailingDirectorySeparator(fragment) ? fragment : ts2.getDirectoryPath(fragment) : void 0;
          }
          function getCompletionsForPathMapping(path2, patterns, fragment, baseUrl, fileExtensions, host) {
            if (!ts2.endsWith(path2, "*")) {
              return !ts2.stringContains(path2, "*") ? justPathMappingName(path2) : ts2.emptyArray;
            }
            var pathPrefix = path2.slice(0, path2.length - 1);
            var remainingFragment = ts2.tryRemovePrefix(fragment, pathPrefix);
            return remainingFragment === void 0 ? justPathMappingName(pathPrefix) : ts2.flatMap(patterns, function(pattern) {
              return getModulesForPathsPattern(remainingFragment, baseUrl, pattern, fileExtensions, host);
            });
            function justPathMappingName(name) {
              return ts2.startsWith(name, fragment) ? [directoryResult(name)] : ts2.emptyArray;
            }
          }
          function getModulesForPathsPattern(fragment, baseUrl, pattern, fileExtensions, host) {
            if (!host.readDirectory) {
              return void 0;
            }
            var parsed = ts2.hasZeroOrOneAsteriskCharacter(pattern) ? ts2.tryParsePattern(pattern) : void 0;
            if (!parsed) {
              return void 0;
            }
            var normalizedPrefix = ts2.resolvePath(parsed.prefix);
            var normalizedPrefixDirectory = ts2.hasTrailingDirectorySeparator(parsed.prefix) ? normalizedPrefix : ts2.getDirectoryPath(normalizedPrefix);
            var normalizedPrefixBase = ts2.hasTrailingDirectorySeparator(parsed.prefix) ? "" : ts2.getBaseFileName(normalizedPrefix);
            var fragmentHasPath = containsSlash(fragment);
            var fragmentDirectory = fragmentHasPath ? ts2.hasTrailingDirectorySeparator(fragment) ? fragment : ts2.getDirectoryPath(fragment) : void 0;
            var expandedPrefixDirectory = fragmentHasPath ? ts2.combinePaths(normalizedPrefixDirectory, normalizedPrefixBase + fragmentDirectory) : normalizedPrefixDirectory;
            var normalizedSuffix = ts2.normalizePath(parsed.suffix);
            var baseDirectory = ts2.normalizePath(ts2.combinePaths(baseUrl, expandedPrefixDirectory));
            var completePrefix = fragmentHasPath ? baseDirectory : ts2.ensureTrailingDirectorySeparator(baseDirectory) + normalizedPrefixBase;
            var includeGlob = normalizedSuffix ? "**/*" : "./*";
            var matches = ts2.mapDefined(ts2.tryReadDirectory(host, baseDirectory, fileExtensions, void 0, [includeGlob]), function(match) {
              var extension = ts2.tryGetExtensionFromPath(match);
              var name = trimPrefixAndSuffix(match);
              return name === void 0 ? void 0 : nameAndKind(ts2.removeFileExtension(name), "script", extension);
            });
            var directories = ts2.mapDefined(ts2.tryGetDirectories(host, baseDirectory).map(function(d) {
              return ts2.combinePaths(baseDirectory, d);
            }), function(dir) {
              var name = trimPrefixAndSuffix(dir);
              return name === void 0 ? void 0 : directoryResult(name);
            });
            return __spreadArrays(matches, directories);
            function trimPrefixAndSuffix(path2) {
              var inner = withoutStartAndEnd(ts2.normalizePath(path2), completePrefix, normalizedSuffix);
              return inner === void 0 ? void 0 : removeLeadingDirectorySeparator(inner);
            }
          }
          function withoutStartAndEnd(s, start, end) {
            return ts2.startsWith(s, start) && ts2.endsWith(s, end) ? s.slice(start.length, s.length - end.length) : void 0;
          }
          function removeLeadingDirectorySeparator(path2) {
            return path2[0] === ts2.directorySeparator ? path2.slice(1) : path2;
          }
          function getAmbientModuleCompletions(fragment, fragmentDirectory, checker) {
            var ambientModules = checker.getAmbientModules().map(function(sym) {
              return ts2.stripQuotes(sym.name);
            });
            var nonRelativeModuleNames = ambientModules.filter(function(moduleName) {
              return ts2.startsWith(moduleName, fragment);
            });
            if (fragmentDirectory !== void 0) {
              var moduleNameWithSeparator_1 = ts2.ensureTrailingDirectorySeparator(fragmentDirectory);
              return nonRelativeModuleNames.map(function(nonRelativeModuleName) {
                return ts2.removePrefix(nonRelativeModuleName, moduleNameWithSeparator_1);
              });
            }
            return nonRelativeModuleNames;
          }
          function getTripleSlashReferenceCompletion(sourceFile, position, compilerOptions, host) {
            var token = ts2.getTokenAtPosition(sourceFile, position);
            var commentRanges = ts2.getLeadingCommentRanges(sourceFile.text, token.pos);
            var range = commentRanges && ts2.find(commentRanges, function(commentRange) {
              return position >= commentRange.pos && position <= commentRange.end;
            });
            if (!range) {
              return void 0;
            }
            var text = sourceFile.text.slice(range.pos, position);
            var match = tripleSlashDirectiveFragmentRegex.exec(text);
            if (!match) {
              return void 0;
            }
            var prefix = match[1], kind = match[2], toComplete = match[3];
            var scriptPath = ts2.getDirectoryPath(sourceFile.path);
            var names = kind === "path" ? getCompletionEntriesForDirectoryFragment(toComplete, scriptPath, getExtensionOptions(compilerOptions, true), host, sourceFile.path) : kind === "types" ? getCompletionEntriesFromTypings(host, compilerOptions, scriptPath, getFragmentDirectory(toComplete), getExtensionOptions(compilerOptions)) : ts2.Debug.fail();
            return addReplacementSpans(toComplete, range.pos + prefix.length, names);
          }
          function getCompletionEntriesFromTypings(host, options, scriptPath, fragmentDirectory, extensionOptions, result) {
            if (result === void 0) {
              result = [];
            }
            var seen = ts2.createMap();
            var typeRoots = ts2.tryAndIgnoreErrors(function() {
              return ts2.getEffectiveTypeRoots(options, host);
            }) || ts2.emptyArray;
            for (var _i = 0, typeRoots_1 = typeRoots; _i < typeRoots_1.length; _i++) {
              var root = typeRoots_1[_i];
              getCompletionEntriesFromDirectories(root);
            }
            for (var _a = 0, _b = ts2.findPackageJsons(scriptPath, host); _a < _b.length; _a++) {
              var packageJson = _b[_a];
              var typesDir = ts2.combinePaths(ts2.getDirectoryPath(packageJson), "node_modules/@types");
              getCompletionEntriesFromDirectories(typesDir);
            }
            return result;
            function getCompletionEntriesFromDirectories(directory) {
              if (!ts2.tryDirectoryExists(host, directory))
                return;
              for (var _i2 = 0, _a2 = ts2.tryGetDirectories(host, directory); _i2 < _a2.length; _i2++) {
                var typeDirectoryName = _a2[_i2];
                var packageName = ts2.unmangleScopedPackageName(typeDirectoryName);
                if (options.types && !ts2.contains(options.types, packageName))
                  continue;
                if (fragmentDirectory === void 0) {
                  if (!seen.has(packageName)) {
                    result.push(nameAndKind(packageName, "external module name", void 0));
                    seen.set(packageName, true);
                  }
                } else {
                  var baseDirectory = ts2.combinePaths(directory, typeDirectoryName);
                  var remainingFragment = ts2.tryRemoveDirectoryPrefix(fragmentDirectory, packageName, ts2.hostGetCanonicalFileName(host));
                  if (remainingFragment !== void 0) {
                    getCompletionEntriesForDirectoryFragment(remainingFragment, baseDirectory, extensionOptions, host, void 0, result);
                  }
                }
              }
            }
          }
          function enumerateNodeModulesVisibleToScript(host, scriptPath) {
            if (!host.readFile || !host.fileExists)
              return ts2.emptyArray;
            var result = [];
            for (var _i = 0, _a = ts2.findPackageJsons(scriptPath, host); _i < _a.length; _i++) {
              var packageJson = _a[_i];
              var contents = ts2.readJson(packageJson, host);
              for (var _b = 0, nodeModulesDependencyKeys_1 = nodeModulesDependencyKeys; _b < nodeModulesDependencyKeys_1.length; _b++) {
                var key = nodeModulesDependencyKeys_1[_b];
                var dependencies = contents[key];
                if (!dependencies)
                  continue;
                for (var dep in dependencies) {
                  if (dependencies.hasOwnProperty(dep) && !ts2.startsWith(dep, "@types/")) {
                    result.push(dep);
                  }
                }
              }
            }
            return result;
          }
          function getDirectoryFragmentTextSpan(text, textStart) {
            var index = Math.max(text.lastIndexOf(ts2.directorySeparator), text.lastIndexOf("\\"));
            var offset = index !== -1 ? index + 1 : 0;
            var length = text.length - offset;
            return length === 0 || ts2.isIdentifierText(text.substr(offset, length), 99) ? void 0 : ts2.createTextSpan(textStart + offset, length);
          }
          function isPathRelativeToScript(path2) {
            if (path2 && path2.length >= 2 && path2.charCodeAt(0) === 46) {
              var slashIndex = path2.length >= 3 && path2.charCodeAt(1) === 46 ? 2 : 1;
              var slashCharCode = path2.charCodeAt(slashIndex);
              return slashCharCode === 47 || slashCharCode === 92;
            }
            return false;
          }
          var tripleSlashDirectiveFragmentRegex = /^(\/\/\/\s*<reference\s+(path|types)\s*=\s*(?:'|"))([^\3"]*)$/;
          var nodeModulesDependencyKeys = ["dependencies", "devDependencies", "peerDependencies", "optionalDependencies"];
          function containsSlash(fragment) {
            return ts2.stringContains(fragment, ts2.directorySeparator);
          }
        })(StringCompletions = Completions2.StringCompletions || (Completions2.StringCompletions = {}));
      })(Completions = ts2.Completions || (ts2.Completions = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var Completions;
      (function(Completions2) {
        var SortText;
        (function(SortText2) {
          SortText2["LocationPriority"] = "0";
          SortText2["OptionalMember"] = "1";
          SortText2["MemberDeclaredBySpreadAssignment"] = "2";
          SortText2["SuggestedClassMembers"] = "3";
          SortText2["GlobalsOrKeywords"] = "4";
          SortText2["AutoImportSuggestions"] = "5";
          SortText2["JavascriptIdentifiers"] = "6";
        })(SortText = Completions2.SortText || (Completions2.SortText = {}));
        var CompletionSource;
        (function(CompletionSource2) {
          CompletionSource2["ThisProperty"] = "ThisProperty/";
        })(CompletionSource = Completions2.CompletionSource || (Completions2.CompletionSource = {}));
        var SymbolOriginInfoKind;
        (function(SymbolOriginInfoKind2) {
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["ThisType"] = 1] = "ThisType";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["SymbolMember"] = 2] = "SymbolMember";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["Export"] = 4] = "Export";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["Promise"] = 8] = "Promise";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["Nullable"] = 16] = "Nullable";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["SymbolMemberNoExport"] = 2] = "SymbolMemberNoExport";
          SymbolOriginInfoKind2[SymbolOriginInfoKind2["SymbolMemberExport"] = 6] = "SymbolMemberExport";
        })(SymbolOriginInfoKind || (SymbolOriginInfoKind = {}));
        function originIsThisType(origin) {
          return !!(origin.kind & 1);
        }
        function originIsSymbolMember(origin) {
          return !!(origin.kind & 2);
        }
        function originIsExport(origin) {
          return !!(origin && origin.kind & 4);
        }
        function originIsPromise(origin) {
          return !!(origin.kind & 8);
        }
        function originIsNullableMember(origin) {
          return !!(origin.kind & 16);
        }
        var KeywordCompletionFilters;
        (function(KeywordCompletionFilters2) {
          KeywordCompletionFilters2[KeywordCompletionFilters2["None"] = 0] = "None";
          KeywordCompletionFilters2[KeywordCompletionFilters2["All"] = 1] = "All";
          KeywordCompletionFilters2[KeywordCompletionFilters2["ClassElementKeywords"] = 2] = "ClassElementKeywords";
          KeywordCompletionFilters2[KeywordCompletionFilters2["InterfaceElementKeywords"] = 3] = "InterfaceElementKeywords";
          KeywordCompletionFilters2[KeywordCompletionFilters2["ConstructorParameterKeywords"] = 4] = "ConstructorParameterKeywords";
          KeywordCompletionFilters2[KeywordCompletionFilters2["FunctionLikeBodyKeywords"] = 5] = "FunctionLikeBodyKeywords";
          KeywordCompletionFilters2[KeywordCompletionFilters2["TypeAssertionKeywords"] = 6] = "TypeAssertionKeywords";
          KeywordCompletionFilters2[KeywordCompletionFilters2["TypeKeywords"] = 7] = "TypeKeywords";
          KeywordCompletionFilters2[KeywordCompletionFilters2["Last"] = 7] = "Last";
        })(KeywordCompletionFilters || (KeywordCompletionFilters = {}));
        var GlobalsSearch;
        (function(GlobalsSearch2) {
          GlobalsSearch2[GlobalsSearch2["Continue"] = 0] = "Continue";
          GlobalsSearch2[GlobalsSearch2["Success"] = 1] = "Success";
          GlobalsSearch2[GlobalsSearch2["Fail"] = 2] = "Fail";
        })(GlobalsSearch || (GlobalsSearch = {}));
        function createImportSuggestionsForFileCache() {
          var cache;
          var projectVersion;
          var fileName;
          return {
            isEmpty: function() {
              return !cache;
            },
            clear: function() {
              cache = void 0;
              fileName = void 0;
              projectVersion = void 0;
            },
            set: function(file, suggestions, version) {
              cache = suggestions;
              fileName = file;
              if (version) {
                projectVersion = version;
              }
            },
            get: function(file, checker, version) {
              if (file !== fileName) {
                return void 0;
              }
              if (version) {
                return projectVersion === version ? cache : void 0;
              }
              ts2.forEach(cache, function(suggestion) {
                var _a, _b, _c;
                if ((_a = suggestion.symbol.declarations) === null || _a === void 0 ? void 0 : _a.length) {
                  suggestion.symbol = checker.getMergedSymbol(suggestion.origin.isDefaultExport ? (_b = suggestion.symbol.declarations[0].localSymbol) !== null && _b !== void 0 ? _b : suggestion.symbol.declarations[0].symbol : suggestion.symbol.declarations[0].symbol);
                }
                if ((_c = suggestion.origin.moduleSymbol.declarations) === null || _c === void 0 ? void 0 : _c.length) {
                  suggestion.origin.moduleSymbol = checker.getMergedSymbol(suggestion.origin.moduleSymbol.declarations[0].symbol);
                }
              });
              return cache;
            }
          };
        }
        Completions2.createImportSuggestionsForFileCache = createImportSuggestionsForFileCache;
        function getCompletionsAtPosition(host, program, log, sourceFile, position, preferences, triggerCharacter) {
          var typeChecker = program.getTypeChecker();
          var compilerOptions = program.getCompilerOptions();
          var contextToken = ts2.findPrecedingToken(position, sourceFile);
          if (triggerCharacter && !ts2.isInString(sourceFile, position, contextToken) && !isValidTrigger(sourceFile, triggerCharacter, contextToken, position)) {
            return void 0;
          }
          var stringCompletions = Completions2.StringCompletions.getStringLiteralCompletions(sourceFile, position, contextToken, typeChecker, compilerOptions, host, log, preferences);
          if (stringCompletions) {
            return stringCompletions;
          }
          if (contextToken && ts2.isBreakOrContinueStatement(contextToken.parent) && (contextToken.kind === 77 || contextToken.kind === 82 || contextToken.kind === 75)) {
            return getLabelCompletionAtPosition(contextToken.parent);
          }
          var completionData = getCompletionData(program, log, sourceFile, isUncheckedFile(sourceFile, compilerOptions), position, preferences, void 0, host);
          if (!completionData) {
            return void 0;
          }
          switch (completionData.kind) {
            case 0:
              return completionInfoFromData(sourceFile, typeChecker, compilerOptions, log, completionData, preferences);
            case 1:
              return jsdocCompletionInfo(ts2.JsDoc.getJSDocTagNameCompletions());
            case 2:
              return jsdocCompletionInfo(ts2.JsDoc.getJSDocTagCompletions());
            case 3:
              return jsdocCompletionInfo(ts2.JsDoc.getJSDocParameterNameCompletions(completionData.tag));
            default:
              return ts2.Debug.assertNever(completionData);
          }
        }
        Completions2.getCompletionsAtPosition = getCompletionsAtPosition;
        function jsdocCompletionInfo(entries) {
          return { isGlobalCompletion: false, isMemberCompletion: false, isNewIdentifierLocation: false, entries };
        }
        function completionInfoFromData(sourceFile, typeChecker, compilerOptions, log, completionData, preferences) {
          var symbols = completionData.symbols, completionKind = completionData.completionKind, isInSnippetScope = completionData.isInSnippetScope, isNewIdentifierLocation = completionData.isNewIdentifierLocation, location = completionData.location, propertyAccessToConvert = completionData.propertyAccessToConvert, keywordFilters = completionData.keywordFilters, literals = completionData.literals, symbolToOriginInfoMap = completionData.symbolToOriginInfoMap, recommendedCompletion = completionData.recommendedCompletion, isJsxInitializer = completionData.isJsxInitializer, insideJsDocTagTypeExpression = completionData.insideJsDocTagTypeExpression, symbolToSortTextMap = completionData.symbolToSortTextMap;
          if (location && location.parent && ts2.isJsxClosingElement(location.parent)) {
            var tagName = location.parent.parent.openingElement.tagName;
            var hasClosingAngleBracket = !!ts2.findChildOfKind(location.parent, 31, sourceFile);
            var entry = {
              name: tagName.getFullText(sourceFile) + (hasClosingAngleBracket ? "" : ">"),
              kind: "class",
              kindModifiers: void 0,
              sortText: SortText.LocationPriority
            };
            return { isGlobalCompletion: false, isMemberCompletion: true, isNewIdentifierLocation: false, entries: [entry] };
          }
          var entries = [];
          if (isUncheckedFile(sourceFile, compilerOptions)) {
            var uniqueNames = getCompletionEntriesFromSymbols(symbols, entries, void 0, location, sourceFile, typeChecker, compilerOptions.target, log, completionKind, preferences, propertyAccessToConvert, completionData.isJsxIdentifierExpected, isJsxInitializer, recommendedCompletion, symbolToOriginInfoMap, symbolToSortTextMap);
            getJSCompletionEntries(sourceFile, location.pos, uniqueNames, compilerOptions.target, entries);
          } else {
            if (!isNewIdentifierLocation && (!symbols || symbols.length === 0) && keywordFilters === 0) {
              return void 0;
            }
            getCompletionEntriesFromSymbols(symbols, entries, void 0, location, sourceFile, typeChecker, compilerOptions.target, log, completionKind, preferences, propertyAccessToConvert, completionData.isJsxIdentifierExpected, isJsxInitializer, recommendedCompletion, symbolToOriginInfoMap, symbolToSortTextMap);
          }
          if (keywordFilters !== 0) {
            var entryNames = ts2.arrayToSet(entries, function(e) {
              return e.name;
            });
            for (var _i = 0, _a = getKeywordCompletions(keywordFilters, !insideJsDocTagTypeExpression && ts2.isSourceFileJS(sourceFile)); _i < _a.length; _i++) {
              var keywordEntry = _a[_i];
              if (!entryNames.has(keywordEntry.name)) {
                entries.push(keywordEntry);
              }
            }
          }
          for (var _b = 0, literals_1 = literals; _b < literals_1.length; _b++) {
            var literal = literals_1[_b];
            entries.push(createCompletionEntryForLiteral(literal, preferences));
          }
          return { isGlobalCompletion: isInSnippetScope, isMemberCompletion: isMemberCompletionKind(completionKind), isNewIdentifierLocation, entries };
        }
        function isUncheckedFile(sourceFile, compilerOptions) {
          return ts2.isSourceFileJS(sourceFile) && !ts2.isCheckJsEnabledForFile(sourceFile, compilerOptions);
        }
        function isMemberCompletionKind(kind) {
          switch (kind) {
            case 0:
            case 3:
            case 2:
              return true;
            default:
              return false;
          }
        }
        function getJSCompletionEntries(sourceFile, position, uniqueNames, target, entries) {
          ts2.getNameTable(sourceFile).forEach(function(pos, name) {
            if (pos === position) {
              return;
            }
            var realName = ts2.unescapeLeadingUnderscores(name);
            if (!uniqueNames.has(realName) && ts2.isIdentifierText(realName, target)) {
              uniqueNames.add(realName);
              entries.push({
                name: realName,
                kind: "warning",
                kindModifiers: "",
                sortText: SortText.JavascriptIdentifiers,
                isFromUncheckedFile: true
              });
            }
          });
        }
        function completionNameForLiteral(literal, preferences) {
          return typeof literal === "object" ? ts2.pseudoBigIntToString(literal) + "n" : ts2.isString(literal) ? ts2.quote(literal, preferences) : JSON.stringify(literal);
        }
        function createCompletionEntryForLiteral(literal, preferences) {
          return { name: completionNameForLiteral(literal, preferences), kind: "string", kindModifiers: "", sortText: SortText.LocationPriority };
        }
        function createCompletionEntry(symbol, sortText, contextToken, location, sourceFile, typeChecker, name, needsConvertPropertyAccess, origin, recommendedCompletion, propertyAccessToConvert, isJsxInitializer, preferences) {
          var insertText;
          var replacementSpan = ts2.getReplacementSpanForContextToken(contextToken);
          var insertQuestionDot = origin && originIsNullableMember(origin);
          var useBraces = origin && originIsSymbolMember(origin) || needsConvertPropertyAccess;
          if (origin && originIsThisType(origin)) {
            insertText = needsConvertPropertyAccess ? "this" + (insertQuestionDot ? "?." : "") + "[" + quotePropertyName(name, preferences) + "]" : "this" + (insertQuestionDot ? "?." : ".") + name;
          } else if ((useBraces || insertQuestionDot) && propertyAccessToConvert) {
            insertText = useBraces ? needsConvertPropertyAccess ? "[" + quotePropertyName(name, preferences) + "]" : "[" + name + "]" : name;
            if (insertQuestionDot || propertyAccessToConvert.questionDotToken) {
              insertText = "?." + insertText;
            }
            var dot = ts2.findChildOfKind(propertyAccessToConvert, 24, sourceFile) || ts2.findChildOfKind(propertyAccessToConvert, 28, sourceFile);
            if (!dot) {
              return void 0;
            }
            var end = ts2.startsWith(name, propertyAccessToConvert.name.text) ? propertyAccessToConvert.name.end : dot.end;
            replacementSpan = ts2.createTextSpanFromBounds(dot.getStart(sourceFile), end);
          }
          if (isJsxInitializer) {
            if (insertText === void 0)
              insertText = name;
            insertText = "{" + insertText + "}";
            if (typeof isJsxInitializer !== "boolean") {
              replacementSpan = ts2.createTextSpanFromNode(isJsxInitializer, sourceFile);
            }
          }
          if (origin && originIsPromise(origin) && propertyAccessToConvert) {
            if (insertText === void 0)
              insertText = name;
            var precedingToken = ts2.findPrecedingToken(propertyAccessToConvert.pos, sourceFile);
            var awaitText = "";
            if (precedingToken && ts2.positionIsASICandidate(precedingToken.end, precedingToken.parent, sourceFile)) {
              awaitText = ";";
            }
            awaitText += "(await " + propertyAccessToConvert.expression.getText() + ")";
            insertText = needsConvertPropertyAccess ? "" + awaitText + insertText : "" + awaitText + (insertQuestionDot ? "?." : ".") + insertText;
            replacementSpan = ts2.createTextSpanFromBounds(propertyAccessToConvert.getStart(sourceFile), propertyAccessToConvert.end);
          }
          if (insertText !== void 0 && !preferences.includeCompletionsWithInsertText) {
            return void 0;
          }
          return {
            name,
            kind: ts2.SymbolDisplay.getSymbolKind(typeChecker, symbol, location),
            kindModifiers: ts2.SymbolDisplay.getSymbolModifiers(symbol),
            sortText,
            source: getSourceFromOrigin(origin),
            hasAction: origin && originIsExport(origin) || void 0,
            isRecommended: isRecommendedCompletionMatch(symbol, recommendedCompletion, typeChecker) || void 0,
            insertText,
            replacementSpan
          };
        }
        function quotePropertyName(name, preferences) {
          if (/^\d+$/.test(name)) {
            return name;
          }
          return ts2.quote(name, preferences);
        }
        function isRecommendedCompletionMatch(localSymbol, recommendedCompletion, checker) {
          return localSymbol === recommendedCompletion || !!(localSymbol.flags & 1048576) && checker.getExportSymbolOfSymbol(localSymbol) === recommendedCompletion;
        }
        function getSourceFromOrigin(origin) {
          if (originIsExport(origin)) {
            return ts2.stripQuotes(origin.moduleSymbol.name);
          }
          if ((origin === null || origin === void 0 ? void 0 : origin.kind) === 1) {
            return CompletionSource.ThisProperty;
          }
        }
        function getCompletionEntriesFromSymbols(symbols, entries, contextToken, location, sourceFile, typeChecker, target, log, kind, preferences, propertyAccessToConvert, jsxIdentifierExpected, isJsxInitializer, recommendedCompletion, symbolToOriginInfoMap, symbolToSortTextMap) {
          var start = ts2.timestamp();
          var uniques = ts2.createMap();
          for (var _i = 0, symbols_1 = symbols; _i < symbols_1.length; _i++) {
            var symbol = symbols_1[_i];
            var origin = symbolToOriginInfoMap ? symbolToOriginInfoMap[ts2.getSymbolId(symbol)] : void 0;
            var info = getCompletionEntryDisplayNameForSymbol(symbol, target, origin, kind, !!jsxIdentifierExpected);
            if (!info) {
              continue;
            }
            var name = info.name, needsConvertPropertyAccess = info.needsConvertPropertyAccess;
            if (uniques.get(name)) {
              continue;
            }
            var entry = createCompletionEntry(symbol, symbolToSortTextMap && symbolToSortTextMap[ts2.getSymbolId(symbol)] || SortText.LocationPriority, contextToken, location, sourceFile, typeChecker, name, needsConvertPropertyAccess, origin, recommendedCompletion, propertyAccessToConvert, isJsxInitializer, preferences);
            if (!entry) {
              continue;
            }
            var shouldShadowLaterSymbols = !origin && !(symbol.parent === void 0 && !ts2.some(symbol.declarations, function(d) {
              return d.getSourceFile() === location.getSourceFile();
            }));
            uniques.set(name, shouldShadowLaterSymbols);
            entries.push(entry);
          }
          log("getCompletionsAtPosition: getCompletionEntriesFromSymbols: " + (ts2.timestamp() - start));
          return {
            has: function(name2) {
              return uniques.has(name2);
            },
            add: function(name2) {
              return uniques.set(name2, true);
            }
          };
        }
        Completions2.getCompletionEntriesFromSymbols = getCompletionEntriesFromSymbols;
        function getLabelCompletionAtPosition(node) {
          var entries = getLabelStatementCompletions(node);
          if (entries.length) {
            return { isGlobalCompletion: false, isMemberCompletion: false, isNewIdentifierLocation: false, entries };
          }
        }
        function getLabelStatementCompletions(node) {
          var entries = [];
          var uniques = ts2.createMap();
          var current = node;
          while (current) {
            if (ts2.isFunctionLike(current)) {
              break;
            }
            if (ts2.isLabeledStatement(current)) {
              var name = current.label.text;
              if (!uniques.has(name)) {
                uniques.set(name, true);
                entries.push({
                  name,
                  kindModifiers: "",
                  kind: "label",
                  sortText: SortText.LocationPriority
                });
              }
            }
            current = current.parent;
          }
          return entries;
        }
        function getSymbolCompletionFromEntryId(program, log, sourceFile, position, entryId, host, preferences) {
          var compilerOptions = program.getCompilerOptions();
          var completionData = getCompletionData(program, log, sourceFile, isUncheckedFile(sourceFile, compilerOptions), position, { includeCompletionsForModuleExports: true, includeCompletionsWithInsertText: true }, entryId, host);
          if (!completionData) {
            return { type: "none" };
          }
          if (completionData.kind !== 0) {
            return { type: "request", request: completionData };
          }
          var symbols = completionData.symbols, literals = completionData.literals, location = completionData.location, completionKind = completionData.completionKind, symbolToOriginInfoMap = completionData.symbolToOriginInfoMap, previousToken = completionData.previousToken, isJsxInitializer = completionData.isJsxInitializer, isTypeOnlyLocation = completionData.isTypeOnlyLocation;
          var literal = ts2.find(literals, function(l) {
            return completionNameForLiteral(l, preferences) === entryId.name;
          });
          if (literal !== void 0)
            return { type: "literal", literal };
          return ts2.firstDefined(symbols, function(symbol) {
            var origin = symbolToOriginInfoMap[ts2.getSymbolId(symbol)];
            var info = getCompletionEntryDisplayNameForSymbol(symbol, compilerOptions.target, origin, completionKind, completionData.isJsxIdentifierExpected);
            return info && info.name === entryId.name && getSourceFromOrigin(origin) === entryId.source ? { type: "symbol", symbol, location, symbolToOriginInfoMap, previousToken, isJsxInitializer, isTypeOnlyLocation } : void 0;
          }) || { type: "none" };
        }
        function getCompletionEntryDetails(program, log, sourceFile, position, entryId, host, formatContext, preferences, cancellationToken) {
          var typeChecker = program.getTypeChecker();
          var compilerOptions = program.getCompilerOptions();
          var name = entryId.name;
          var contextToken = ts2.findPrecedingToken(position, sourceFile);
          if (ts2.isInString(sourceFile, position, contextToken)) {
            return Completions2.StringCompletions.getStringLiteralCompletionDetails(name, sourceFile, position, contextToken, typeChecker, compilerOptions, host, cancellationToken);
          }
          var symbolCompletion = getSymbolCompletionFromEntryId(program, log, sourceFile, position, entryId, host, preferences);
          switch (symbolCompletion.type) {
            case "request": {
              var request = symbolCompletion.request;
              switch (request.kind) {
                case 1:
                  return ts2.JsDoc.getJSDocTagNameCompletionDetails(name);
                case 2:
                  return ts2.JsDoc.getJSDocTagCompletionDetails(name);
                case 3:
                  return ts2.JsDoc.getJSDocParameterNameCompletionDetails(name);
                default:
                  return ts2.Debug.assertNever(request);
              }
            }
            case "symbol": {
              var symbol = symbolCompletion.symbol, location = symbolCompletion.location, symbolToOriginInfoMap = symbolCompletion.symbolToOriginInfoMap, previousToken = symbolCompletion.previousToken;
              var _a = getCompletionEntryCodeActionsAndSourceDisplay(symbolToOriginInfoMap, symbol, program, typeChecker, host, compilerOptions, sourceFile, position, previousToken, formatContext, preferences), codeActions = _a.codeActions, sourceDisplay = _a.sourceDisplay;
              return createCompletionDetailsForSymbol(symbol, typeChecker, sourceFile, location, cancellationToken, codeActions, sourceDisplay);
            }
            case "literal": {
              var literal = symbolCompletion.literal;
              return createSimpleDetails(completionNameForLiteral(literal, preferences), "string", typeof literal === "string" ? ts2.SymbolDisplayPartKind.stringLiteral : ts2.SymbolDisplayPartKind.numericLiteral);
            }
            case "none":
              return allKeywordsCompletions().some(function(c) {
                return c.name === name;
              }) ? createSimpleDetails(name, "keyword", ts2.SymbolDisplayPartKind.keyword) : void 0;
            default:
              ts2.Debug.assertNever(symbolCompletion);
          }
        }
        Completions2.getCompletionEntryDetails = getCompletionEntryDetails;
        function createSimpleDetails(name, kind, kind2) {
          return createCompletionDetails(name, "", kind, [ts2.displayPart(name, kind2)]);
        }
        function createCompletionDetailsForSymbol(symbol, checker, sourceFile, location, cancellationToken, codeActions, sourceDisplay) {
          var _a = checker.runWithCancellationToken(cancellationToken, function(checker2) {
            return ts2.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(checker2, symbol, sourceFile, location, location, 7);
          }), displayParts = _a.displayParts, documentation = _a.documentation, symbolKind = _a.symbolKind, tags = _a.tags;
          return createCompletionDetails(symbol.name, ts2.SymbolDisplay.getSymbolModifiers(symbol), symbolKind, displayParts, documentation, tags, codeActions, sourceDisplay);
        }
        Completions2.createCompletionDetailsForSymbol = createCompletionDetailsForSymbol;
        function createCompletionDetails(name, kindModifiers, kind, displayParts, documentation, tags, codeActions, source) {
          return { name, kindModifiers, kind, displayParts, documentation, tags, codeActions, source };
        }
        Completions2.createCompletionDetails = createCompletionDetails;
        function getCompletionEntryCodeActionsAndSourceDisplay(symbolToOriginInfoMap, symbol, program, checker, host, compilerOptions, sourceFile, position, previousToken, formatContext, preferences) {
          var symbolOriginInfo = symbolToOriginInfoMap[ts2.getSymbolId(symbol)];
          if (!symbolOriginInfo || !originIsExport(symbolOriginInfo)) {
            return { codeActions: void 0, sourceDisplay: void 0 };
          }
          var moduleSymbol = symbolOriginInfo.moduleSymbol;
          var exportedSymbol = checker.getMergedSymbol(ts2.skipAlias(symbol.exportSymbol || symbol, checker));
          var _a = ts2.codefix.getImportCompletionAction(exportedSymbol, moduleSymbol, sourceFile, ts2.getNameForExportedSymbol(symbol, compilerOptions.target), host, program, formatContext, previousToken && ts2.isIdentifier(previousToken) ? previousToken.getStart(sourceFile) : position, preferences), moduleSpecifier = _a.moduleSpecifier, codeAction = _a.codeAction;
          return { sourceDisplay: [ts2.textPart(moduleSpecifier)], codeActions: [codeAction] };
        }
        function getCompletionEntrySymbol(program, log, sourceFile, position, entryId, host, preferences) {
          var completion = getSymbolCompletionFromEntryId(program, log, sourceFile, position, entryId, host, preferences);
          return completion.type === "symbol" ? completion.symbol : void 0;
        }
        Completions2.getCompletionEntrySymbol = getCompletionEntrySymbol;
        var CompletionDataKind;
        (function(CompletionDataKind2) {
          CompletionDataKind2[CompletionDataKind2["Data"] = 0] = "Data";
          CompletionDataKind2[CompletionDataKind2["JsDocTagName"] = 1] = "JsDocTagName";
          CompletionDataKind2[CompletionDataKind2["JsDocTag"] = 2] = "JsDocTag";
          CompletionDataKind2[CompletionDataKind2["JsDocParameterName"] = 3] = "JsDocParameterName";
        })(CompletionDataKind || (CompletionDataKind = {}));
        var CompletionKind;
        (function(CompletionKind2) {
          CompletionKind2[CompletionKind2["ObjectPropertyDeclaration"] = 0] = "ObjectPropertyDeclaration";
          CompletionKind2[CompletionKind2["Global"] = 1] = "Global";
          CompletionKind2[CompletionKind2["PropertyAccess"] = 2] = "PropertyAccess";
          CompletionKind2[CompletionKind2["MemberLike"] = 3] = "MemberLike";
          CompletionKind2[CompletionKind2["String"] = 4] = "String";
          CompletionKind2[CompletionKind2["None"] = 5] = "None";
        })(CompletionKind = Completions2.CompletionKind || (Completions2.CompletionKind = {}));
        function getRecommendedCompletion(previousToken, contextualType, checker) {
          return ts2.firstDefined(contextualType && (contextualType.isUnion() ? contextualType.types : [contextualType]), function(type) {
            var symbol = type && type.symbol;
            return symbol && (symbol.flags & (8 | 384 | 32) && !ts2.isAbstractConstructorSymbol(symbol)) ? getFirstSymbolInChain(symbol, previousToken, checker) : void 0;
          });
        }
        function getContextualType(previousToken, position, sourceFile, checker) {
          var parent = previousToken.parent;
          switch (previousToken.kind) {
            case 75:
              return ts2.getContextualTypeFromParent(previousToken, checker);
            case 62:
              switch (parent.kind) {
                case 242:
                  return checker.getContextualType(parent.initializer);
                case 209:
                  return checker.getTypeAtLocation(parent.left);
                case 273:
                  return checker.getContextualTypeForJsxAttribute(parent);
                default:
                  return void 0;
              }
            case 99:
              return checker.getContextualType(parent);
            case 78:
              return ts2.getSwitchedType(ts2.cast(parent, ts2.isCaseClause), checker);
            case 18:
              return ts2.isJsxExpression(parent) && parent.parent.kind !== 266 ? checker.getContextualTypeForJsxAttribute(parent.parent) : void 0;
            default:
              var argInfo = ts2.SignatureHelp.getArgumentInfoForCompletions(previousToken, position, sourceFile);
              return argInfo ? checker.getContextualTypeForArgumentAtIndex(argInfo.invocation, argInfo.argumentIndex + (previousToken.kind === 27 ? 1 : 0)) : ts2.isEqualityOperatorKind(previousToken.kind) && ts2.isBinaryExpression(parent) && ts2.isEqualityOperatorKind(parent.operatorToken.kind) ? checker.getTypeAtLocation(parent.left) : checker.getContextualType(previousToken);
          }
        }
        function getFirstSymbolInChain(symbol, enclosingDeclaration, checker) {
          var chain = checker.getAccessibleSymbolChain(symbol, enclosingDeclaration, 67108863, false);
          if (chain)
            return ts2.first(chain);
          return symbol.parent && (isModuleSymbol(symbol.parent) ? symbol : getFirstSymbolInChain(symbol.parent, enclosingDeclaration, checker));
        }
        function isModuleSymbol(symbol) {
          return symbol.declarations.some(function(d) {
            return d.kind === 290;
          });
        }
        function getCompletionData(program, log, sourceFile, isUncheckedFile2, position, preferences, detailsEntryId, host) {
          var typeChecker = program.getTypeChecker();
          var start = ts2.timestamp();
          var currentToken = ts2.getTokenAtPosition(sourceFile, position);
          log("getCompletionData: Get current token: " + (ts2.timestamp() - start));
          start = ts2.timestamp();
          var insideComment = ts2.isInComment(sourceFile, position, currentToken);
          log("getCompletionData: Is inside comment: " + (ts2.timestamp() - start));
          var insideJsDocTagTypeExpression = false;
          var isInSnippetScope = false;
          if (insideComment) {
            if (ts2.hasDocComment(sourceFile, position)) {
              if (sourceFile.text.charCodeAt(position - 1) === 64) {
                return { kind: 1 };
              } else {
                var lineStart = ts2.getLineStartPositionForPosition(position, sourceFile);
                if (!sourceFile.text.substring(lineStart, position).match(/[^\*|\s|(/\*\*)]/)) {
                  return { kind: 2 };
                }
              }
            }
            var tag = getJsDocTagAtPosition(currentToken, position);
            if (tag) {
              if (tag.tagName.pos <= position && position <= tag.tagName.end) {
                return { kind: 1 };
              }
              if (isTagWithTypeExpression(tag) && tag.typeExpression && tag.typeExpression.kind === 294) {
                currentToken = ts2.getTokenAtPosition(sourceFile, position);
                if (!currentToken || !ts2.isDeclarationName(currentToken) && (currentToken.parent.kind !== 323 || currentToken.parent.name !== currentToken)) {
                  insideJsDocTagTypeExpression = isCurrentlyEditingNode(tag.typeExpression);
                }
              }
              if (!insideJsDocTagTypeExpression && ts2.isJSDocParameterTag(tag) && (ts2.nodeIsMissing(tag.name) || tag.name.pos <= position && position <= tag.name.end)) {
                return { kind: 3, tag };
              }
            }
            if (!insideJsDocTagTypeExpression) {
              log("Returning an empty list because completion was inside a regular comment or plain text part of a JsDoc comment.");
              return void 0;
            }
          }
          start = ts2.timestamp();
          var previousToken = ts2.findPrecedingToken(position, sourceFile, void 0);
          log("getCompletionData: Get previous token 1: " + (ts2.timestamp() - start));
          var contextToken = previousToken;
          if (contextToken && position <= contextToken.end && (ts2.isIdentifierOrPrivateIdentifier(contextToken) || ts2.isKeyword(contextToken.kind))) {
            var start_1 = ts2.timestamp();
            contextToken = ts2.findPrecedingToken(contextToken.getFullStart(), sourceFile, void 0);
            log("getCompletionData: Get previous token 2: " + (ts2.timestamp() - start_1));
          }
          var node = currentToken;
          var propertyAccessToConvert;
          var isRightOfDot = false;
          var isRightOfQuestionDot = false;
          var isRightOfOpenTag = false;
          var isStartingCloseTag = false;
          var isJsxInitializer = false;
          var isJsxIdentifierExpected = false;
          var location = ts2.getTouchingPropertyName(sourceFile, position);
          if (contextToken) {
            if (isCompletionListBlocker(contextToken)) {
              log("Returning an empty list because completion was requested in an invalid position.");
              return void 0;
            }
            var parent = contextToken.parent;
            if (contextToken.kind === 24 || contextToken.kind === 28) {
              isRightOfDot = contextToken.kind === 24;
              isRightOfQuestionDot = contextToken.kind === 28;
              switch (parent.kind) {
                case 194:
                  propertyAccessToConvert = parent;
                  node = propertyAccessToConvert.expression;
                  if (node.end === contextToken.pos && ts2.isCallExpression(node) && node.getChildCount(sourceFile) && ts2.last(node.getChildren(sourceFile)).kind !== 21) {
                    return void 0;
                  }
                  break;
                case 153:
                  node = parent.left;
                  break;
                case 249:
                  node = parent.name;
                  break;
                case 188:
                case 219:
                  node = parent;
                  break;
                default:
                  return void 0;
              }
            } else if (sourceFile.languageVariant === 1) {
              if (parent && parent.kind === 194) {
                contextToken = parent;
                parent = parent.parent;
              }
              if (currentToken.parent === location) {
                switch (currentToken.kind) {
                  case 31:
                    if (currentToken.parent.kind === 266 || currentToken.parent.kind === 268) {
                      location = currentToken;
                    }
                    break;
                  case 43:
                    if (currentToken.parent.kind === 267) {
                      location = currentToken;
                    }
                    break;
                }
              }
              switch (parent.kind) {
                case 269:
                  if (contextToken.kind === 43) {
                    isStartingCloseTag = true;
                    location = contextToken;
                  }
                  break;
                case 209:
                  if (!binaryExpressionMayBeOpenTag(parent)) {
                    break;
                  }
                case 267:
                case 266:
                case 268:
                  isJsxIdentifierExpected = true;
                  if (contextToken.kind === 29) {
                    isRightOfOpenTag = true;
                    location = contextToken;
                  }
                  break;
                case 273:
                  switch (previousToken.kind) {
                    case 62:
                      isJsxInitializer = true;
                      break;
                    case 75:
                      isJsxIdentifierExpected = true;
                      if (parent !== previousToken.parent && !parent.initializer && ts2.findChildOfKind(parent, 62, sourceFile)) {
                        isJsxInitializer = previousToken;
                      }
                  }
                  break;
              }
            }
          }
          var semanticStart = ts2.timestamp();
          var completionKind = 5;
          var isNewIdentifierLocation = false;
          var keywordFilters = 0;
          var symbols = [];
          var symbolToOriginInfoMap = [];
          var symbolToSortTextMap = [];
          var importSuggestionsCache = host.getImportSuggestionsCache && host.getImportSuggestionsCache();
          var isTypeOnly = isTypeOnlyCompletion();
          if (isRightOfDot || isRightOfQuestionDot) {
            getTypeScriptMemberSymbols();
          } else if (isRightOfOpenTag) {
            var tagSymbols = typeChecker.getJsxIntrinsicTagNamesAt(location);
            ts2.Debug.assertEachIsDefined(tagSymbols, "getJsxIntrinsicTagNames() should all be defined");
            tryGetGlobalSymbols();
            symbols = tagSymbols.concat(symbols);
            completionKind = 3;
            keywordFilters = 0;
          } else if (isStartingCloseTag) {
            var tagName = contextToken.parent.parent.openingElement.tagName;
            var tagSymbol = typeChecker.getSymbolAtLocation(tagName);
            if (tagSymbol) {
              symbols = [tagSymbol];
            }
            completionKind = 3;
            keywordFilters = 0;
          } else {
            if (!tryGetGlobalSymbols()) {
              return void 0;
            }
          }
          log("getCompletionData: Semantic work: " + (ts2.timestamp() - semanticStart));
          var contextualType = previousToken && getContextualType(previousToken, position, sourceFile, typeChecker);
          var literals = ts2.mapDefined(contextualType && (contextualType.isUnion() ? contextualType.types : [contextualType]), function(t) {
            return t.isLiteral() ? t.value : void 0;
          });
          var recommendedCompletion = previousToken && contextualType && getRecommendedCompletion(previousToken, contextualType, typeChecker);
          return {
            kind: 0,
            symbols,
            completionKind,
            isInSnippetScope,
            propertyAccessToConvert,
            isNewIdentifierLocation,
            location,
            keywordFilters,
            literals,
            symbolToOriginInfoMap,
            recommendedCompletion,
            previousToken,
            isJsxInitializer,
            insideJsDocTagTypeExpression,
            symbolToSortTextMap,
            isTypeOnlyLocation: isTypeOnly,
            isJsxIdentifierExpected
          };
          function isTagWithTypeExpression(tag2) {
            switch (tag2.kind) {
              case 317:
              case 323:
              case 318:
              case 320:
              case 322:
                return true;
              default:
                return false;
            }
          }
          function getTypeScriptMemberSymbols() {
            completionKind = 2;
            var isImportType = ts2.isLiteralImportTypeNode(node);
            var isTypeLocation = insideJsDocTagTypeExpression || isImportType && !node.isTypeOf || ts2.isPartOfTypeNode(node.parent) || ts2.isPossiblyTypeArgumentPosition(contextToken, sourceFile, typeChecker);
            var isRhsOfImportDeclaration = ts2.isInRightSideOfInternalImportEqualsDeclaration(node);
            if (ts2.isEntityName(node) || isImportType) {
              var isNamespaceName = ts2.isModuleDeclaration(node.parent);
              if (isNamespaceName)
                isNewIdentifierLocation = true;
              var symbol = typeChecker.getSymbolAtLocation(node);
              if (symbol) {
                symbol = ts2.skipAlias(symbol, typeChecker);
                if (symbol.flags & (1536 | 384)) {
                  var exportedSymbols = typeChecker.getExportsOfModule(symbol);
                  ts2.Debug.assertEachIsDefined(exportedSymbols, "getExportsOfModule() should all be defined");
                  var isValidValueAccess_1 = function(symbol2) {
                    return typeChecker.isValidPropertyAccess(isImportType ? node : node.parent, symbol2.name);
                  };
                  var isValidTypeAccess_1 = function(symbol2) {
                    return symbolCanBeReferencedAtTypeLocation(symbol2);
                  };
                  var isValidAccess = isNamespaceName ? function(symbol2) {
                    return !!(symbol2.flags & 1920) && !symbol2.declarations.every(function(d) {
                      return d.parent === node.parent;
                    });
                  } : isRhsOfImportDeclaration ? function(symbol2) {
                    return isValidTypeAccess_1(symbol2) || isValidValueAccess_1(symbol2);
                  } : isTypeLocation ? isValidTypeAccess_1 : isValidValueAccess_1;
                  for (var _i = 0, exportedSymbols_1 = exportedSymbols; _i < exportedSymbols_1.length; _i++) {
                    var exportedSymbol = exportedSymbols_1[_i];
                    if (isValidAccess(exportedSymbol)) {
                      symbols.push(exportedSymbol);
                    }
                  }
                  if (!isTypeLocation && symbol.declarations && symbol.declarations.some(function(d) {
                    return d.kind !== 290 && d.kind !== 249 && d.kind !== 248;
                  })) {
                    var type = typeChecker.getTypeOfSymbolAtLocation(symbol, node).getNonOptionalType();
                    var insertQuestionDot = false;
                    if (type.isNullableType()) {
                      var canCorrectToQuestionDot = isRightOfDot && !isRightOfQuestionDot && preferences.includeAutomaticOptionalChainCompletions !== false;
                      if (canCorrectToQuestionDot || isRightOfQuestionDot) {
                        type = type.getNonNullableType();
                        if (canCorrectToQuestionDot) {
                          insertQuestionDot = true;
                        }
                      }
                    }
                    addTypeProperties(type, !!(node.flags & 32768), insertQuestionDot);
                  }
                  return;
                }
              }
            }
            if (ts2.isMetaProperty(node) && (node.keywordToken === 99 || node.keywordToken === 96) && contextToken === node.getChildAt(1)) {
              var completion = node.keywordToken === 99 ? "target" : "meta";
              symbols.push(typeChecker.createSymbol(4, ts2.escapeLeadingUnderscores(completion)));
              return;
            }
            if (!isTypeLocation) {
              var type = typeChecker.getTypeAtLocation(node).getNonOptionalType();
              var insertQuestionDot = false;
              if (type.isNullableType()) {
                var canCorrectToQuestionDot = isRightOfDot && !isRightOfQuestionDot && preferences.includeAutomaticOptionalChainCompletions !== false;
                if (canCorrectToQuestionDot || isRightOfQuestionDot) {
                  type = type.getNonNullableType();
                  if (canCorrectToQuestionDot) {
                    insertQuestionDot = true;
                  }
                }
              }
              addTypeProperties(type, !!(node.flags & 32768), insertQuestionDot);
            }
          }
          function addTypeProperties(type, insertAwait, insertQuestionDot) {
            isNewIdentifierLocation = !!type.getStringIndexType();
            if (isRightOfQuestionDot && ts2.some(type.getCallSignatures())) {
              isNewIdentifierLocation = true;
            }
            var propertyAccess = node.kind === 188 ? node : node.parent;
            if (isUncheckedFile2) {
              symbols.push.apply(symbols, getPropertiesForCompletion(type, typeChecker));
            } else {
              for (var _i = 0, _a = type.getApparentProperties(); _i < _a.length; _i++) {
                var symbol = _a[_i];
                if (typeChecker.isValidPropertyAccessForCompletions(propertyAccess, type, symbol)) {
                  addPropertySymbol(symbol, false, insertQuestionDot);
                }
              }
            }
            if (insertAwait && preferences.includeCompletionsWithInsertText) {
              var promiseType = typeChecker.getPromisedTypeOfPromise(type);
              if (promiseType) {
                for (var _b = 0, _c = promiseType.getApparentProperties(); _b < _c.length; _b++) {
                  var symbol = _c[_b];
                  if (typeChecker.isValidPropertyAccessForCompletions(propertyAccess, promiseType, symbol)) {
                    addPropertySymbol(symbol, true, insertQuestionDot);
                  }
                }
              }
            }
          }
          function addPropertySymbol(symbol, insertAwait, insertQuestionDot) {
            var computedPropertyName = ts2.firstDefined(symbol.declarations, function(decl) {
              return ts2.tryCast(ts2.getNameOfDeclaration(decl), ts2.isComputedPropertyName);
            });
            if (computedPropertyName) {
              var leftMostName = getLeftMostName(computedPropertyName.expression);
              var nameSymbol = leftMostName && typeChecker.getSymbolAtLocation(leftMostName);
              var firstAccessibleSymbol = nameSymbol && getFirstSymbolInChain(nameSymbol, contextToken, typeChecker);
              if (firstAccessibleSymbol && !symbolToOriginInfoMap[ts2.getSymbolId(firstAccessibleSymbol)]) {
                symbols.push(firstAccessibleSymbol);
                var moduleSymbol = firstAccessibleSymbol.parent;
                symbolToOriginInfoMap[ts2.getSymbolId(firstAccessibleSymbol)] = !moduleSymbol || !ts2.isExternalModuleSymbol(moduleSymbol) ? { kind: getNullableSymbolOriginInfoKind(2) } : { kind: getNullableSymbolOriginInfoKind(6), moduleSymbol, isDefaultExport: false };
              } else if (preferences.includeCompletionsWithInsertText) {
                addSymbolOriginInfo(symbol);
                symbols.push(symbol);
              }
            } else {
              addSymbolOriginInfo(symbol);
              symbols.push(symbol);
            }
            function addSymbolOriginInfo(symbol2) {
              if (preferences.includeCompletionsWithInsertText) {
                if (insertAwait && !symbolToOriginInfoMap[ts2.getSymbolId(symbol2)]) {
                  symbolToOriginInfoMap[ts2.getSymbolId(symbol2)] = { kind: getNullableSymbolOriginInfoKind(8) };
                } else if (insertQuestionDot) {
                  symbolToOriginInfoMap[ts2.getSymbolId(symbol2)] = { kind: 16 };
                }
              }
            }
            function getNullableSymbolOriginInfoKind(kind) {
              return insertQuestionDot ? kind | 16 : kind;
            }
          }
          function getLeftMostName(e) {
            return ts2.isIdentifier(e) ? e : ts2.isPropertyAccessExpression(e) ? getLeftMostName(e.expression) : void 0;
          }
          function tryGetGlobalSymbols() {
            var result = tryGetObjectLikeCompletionSymbols() || tryGetImportOrExportClauseCompletionSymbols() || tryGetLocalNamedExportCompletionSymbols() || tryGetConstructorCompletion() || tryGetClassLikeCompletionSymbols() || tryGetJsxCompletionSymbols() || (getGlobalCompletions(), 1);
            return result === 1;
          }
          function tryGetConstructorCompletion() {
            if (!tryGetConstructorLikeCompletionContainer(contextToken))
              return 0;
            completionKind = 5;
            isNewIdentifierLocation = true;
            keywordFilters = 4;
            return 1;
          }
          function tryGetJsxCompletionSymbols() {
            var jsxContainer = tryGetContainingJsxElement(contextToken);
            var attrsType = jsxContainer && typeChecker.getContextualType(jsxContainer.attributes);
            if (!attrsType)
              return 0;
            var completionsType = jsxContainer && typeChecker.getContextualType(jsxContainer.attributes, 4);
            symbols = filterJsxAttributes(getPropertiesForObjectExpression(attrsType, completionsType, jsxContainer.attributes, typeChecker), jsxContainer.attributes.properties);
            setSortTextToOptionalMember();
            completionKind = 3;
            isNewIdentifierLocation = false;
            return 1;
          }
          function getGlobalCompletions() {
            keywordFilters = tryGetFunctionLikeBodyCompletionContainer(contextToken) ? 5 : 1;
            completionKind = 1;
            isNewIdentifierLocation = isNewIdentifierDefinitionLocation(contextToken);
            if (previousToken !== contextToken) {
              ts2.Debug.assert(!!previousToken, "Expected 'contextToken' to be defined when different from 'previousToken'.");
            }
            var adjustedPosition = previousToken !== contextToken ? previousToken.getStart() : position;
            var scopeNode = getScopeNode(contextToken, adjustedPosition, sourceFile) || sourceFile;
            isInSnippetScope = isSnippetScope(scopeNode);
            var symbolMeanings = (isTypeOnly ? 0 : 111551) | 788968 | 1920 | 2097152;
            symbols = typeChecker.getSymbolsInScope(scopeNode, symbolMeanings);
            ts2.Debug.assertEachIsDefined(symbols, "getSymbolsInScope() should all be defined");
            for (var _i = 0, symbols_2 = symbols; _i < symbols_2.length; _i++) {
              var symbol = symbols_2[_i];
              if (!typeChecker.isArgumentsSymbol(symbol) && !ts2.some(symbol.declarations, function(d) {
                return d.getSourceFile() === sourceFile;
              })) {
                symbolToSortTextMap[ts2.getSymbolId(symbol)] = SortText.GlobalsOrKeywords;
              }
            }
            if (preferences.includeCompletionsWithInsertText && scopeNode.kind !== 290) {
              var thisType = typeChecker.tryGetThisTypeAt(scopeNode, false);
              if (thisType && !isProbablyGlobalType(thisType, sourceFile, typeChecker)) {
                for (var _a = 0, _b = getPropertiesForCompletion(thisType, typeChecker); _a < _b.length; _a++) {
                  var symbol = _b[_a];
                  symbolToOriginInfoMap[ts2.getSymbolId(symbol)] = { kind: 1 };
                  symbols.push(symbol);
                  symbolToSortTextMap[ts2.getSymbolId(symbol)] = SortText.SuggestedClassMembers;
                }
              }
            }
            if (shouldOfferImportCompletions()) {
              var lowerCaseTokenText_1 = previousToken && ts2.isIdentifier(previousToken) ? previousToken.text.toLowerCase() : "";
              var autoImportSuggestions = getSymbolsFromOtherSourceFileExports(program.getCompilerOptions().target, host);
              if (!detailsEntryId && importSuggestionsCache) {
                importSuggestionsCache.set(sourceFile.fileName, autoImportSuggestions, host.getProjectVersion && host.getProjectVersion());
              }
              autoImportSuggestions.forEach(function(_a2) {
                var symbol2 = _a2.symbol, symbolName = _a2.symbolName, skipFilter = _a2.skipFilter, origin = _a2.origin;
                if (detailsEntryId) {
                  if (detailsEntryId.source && ts2.stripQuotes(origin.moduleSymbol.name) !== detailsEntryId.source) {
                    return;
                  }
                } else if (!skipFilter && !stringContainsCharactersInOrder(symbolName.toLowerCase(), lowerCaseTokenText_1)) {
                  return;
                }
                var symbolId = ts2.getSymbolId(symbol2);
                symbols.push(symbol2);
                symbolToOriginInfoMap[symbolId] = origin;
                symbolToSortTextMap[symbolId] = SortText.AutoImportSuggestions;
              });
            }
            filterGlobalCompletion(symbols);
          }
          function shouldOfferImportCompletions() {
            if (!preferences.includeCompletionsForModuleExports)
              return false;
            if (sourceFile.externalModuleIndicator || sourceFile.commonJsModuleIndicator)
              return true;
            if (ts2.compilerOptionsIndicateEs6Modules(program.getCompilerOptions()))
              return true;
            return ts2.programContainsModules(program);
          }
          function isSnippetScope(scopeNode) {
            switch (scopeNode.kind) {
              case 290:
              case 211:
              case 276:
              case 223:
                return true;
              default:
                return ts2.isStatement(scopeNode);
            }
          }
          function filterGlobalCompletion(symbols2) {
            var isTypeOnly2 = isTypeOnlyCompletion();
            if (isTypeOnly2) {
              keywordFilters = isTypeAssertion() ? 6 : 7;
            }
            ts2.filterMutate(symbols2, function(symbol) {
              if (!ts2.isSourceFile(location)) {
                if (ts2.isExportAssignment(location.parent)) {
                  return true;
                }
                symbol = ts2.skipAlias(symbol, typeChecker);
                if (ts2.isInRightSideOfInternalImportEqualsDeclaration(location)) {
                  return !!(symbol.flags & 1920);
                }
                if (isTypeOnly2) {
                  return symbolCanBeReferencedAtTypeLocation(symbol);
                }
              }
              return !!(ts2.getCombinedLocalAndExportSymbolFlags(symbol) & 111551);
            });
          }
          function isTypeAssertion() {
            return ts2.isAssertionExpression(contextToken.parent);
          }
          function isTypeOnlyCompletion() {
            return insideJsDocTagTypeExpression || !isContextTokenValueLocation(contextToken) && (ts2.isPossiblyTypeArgumentPosition(contextToken, sourceFile, typeChecker) || ts2.isPartOfTypeNode(location) || isContextTokenTypeLocation(contextToken));
          }
          function isContextTokenValueLocation(contextToken2) {
            return contextToken2 && contextToken2.kind === 108 && (contextToken2.parent.kind === 172 || ts2.isTypeOfExpression(contextToken2.parent));
          }
          function isContextTokenTypeLocation(contextToken2) {
            if (contextToken2) {
              var parentKind = contextToken2.parent.kind;
              switch (contextToken2.kind) {
                case 58:
                  return parentKind === 159 || parentKind === 158 || parentKind === 156 || parentKind === 242 || ts2.isFunctionLikeKind(parentKind);
                case 62:
                  return parentKind === 247;
                case 123:
                  return parentKind === 217;
                case 29:
                  return parentKind === 169 || parentKind === 199;
                case 90:
                  return parentKind === 155;
              }
            }
            return false;
          }
          function symbolCanBeReferencedAtTypeLocation(symbol, seenModules) {
            if (seenModules === void 0) {
              seenModules = ts2.createMap();
            }
            var sym = ts2.skipAlias(symbol.exportSymbol || symbol, typeChecker);
            return !!(sym.flags & 788968) || !!(sym.flags & 1536) && ts2.addToSeen(seenModules, ts2.getSymbolId(sym)) && typeChecker.getExportsOfModule(sym).some(function(e) {
              return symbolCanBeReferencedAtTypeLocation(e, seenModules);
            });
          }
          function getSymbolsFromOtherSourceFileExports(target, host2) {
            var cached = importSuggestionsCache && importSuggestionsCache.get(sourceFile.fileName, typeChecker, detailsEntryId && host2.getProjectVersion ? host2.getProjectVersion() : void 0);
            if (cached) {
              log("getSymbolsFromOtherSourceFileExports: Using cached list");
              return cached;
            }
            var startTime = ts2.timestamp();
            log("getSymbolsFromOtherSourceFileExports: Recomputing list" + (detailsEntryId ? " for details entry" : ""));
            var seenResolvedModules = ts2.createMap();
            var seenExports = ts2.createMap();
            var aliasesToAlreadyIncludedSymbols = ts2.createMap();
            var aliasesToReturnIfOriginalsAreMissing = ts2.createMap();
            var results = [];
            var resultSymbolIds = ts2.createMap();
            ts2.codefix.forEachExternalModuleToImportFrom(program, host2, sourceFile, !detailsEntryId, function(moduleSymbol) {
              if (detailsEntryId && detailsEntryId.source && ts2.stripQuotes(moduleSymbol.name) !== detailsEntryId.source) {
                return;
              }
              var resolvedModuleSymbol = typeChecker.resolveExternalModuleSymbol(moduleSymbol);
              if (!ts2.addToSeen(seenResolvedModules, ts2.getSymbolId(resolvedModuleSymbol))) {
                return;
              }
              if (resolvedModuleSymbol !== moduleSymbol && ts2.every(resolvedModuleSymbol.declarations, ts2.isNonGlobalDeclaration)) {
                pushSymbol(resolvedModuleSymbol, moduleSymbol, true);
              }
              for (var _i = 0, _a = typeChecker.getExportsAndPropertiesOfModule(moduleSymbol); _i < _a.length; _i++) {
                var symbol = _a[_i];
                var symbolId = ts2.getSymbolId(symbol).toString();
                if (!ts2.addToSeen(seenExports, symbolId)) {
                  continue;
                }
                if (ts2.some(symbol.declarations, function(d) {
                  return ts2.isExportSpecifier(d) && !!d.propertyName && ts2.isIdentifierANonContextualKeyword(d.name);
                })) {
                  continue;
                }
                var isExportStarFromReExport = typeChecker.getMergedSymbol(symbol.parent) !== resolvedModuleSymbol;
                if (isExportStarFromReExport || ts2.some(symbol.declarations, function(d) {
                  return ts2.isExportSpecifier(d) && !d.propertyName && !!d.parent.parent.moduleSpecifier;
                })) {
                  var nearestExportSymbol = isExportStarFromReExport ? symbol : getNearestExportSymbol(symbol);
                  if (!nearestExportSymbol)
                    continue;
                  var nearestExportSymbolId = ts2.getSymbolId(nearestExportSymbol).toString();
                  var symbolHasBeenSeen = resultSymbolIds.has(nearestExportSymbolId) || aliasesToAlreadyIncludedSymbols.has(nearestExportSymbolId);
                  if (!symbolHasBeenSeen) {
                    aliasesToReturnIfOriginalsAreMissing.set(nearestExportSymbolId, { alias: symbol, moduleSymbol });
                    aliasesToAlreadyIncludedSymbols.set(symbolId, true);
                  } else {
                    ts2.addToSeen(aliasesToAlreadyIncludedSymbols, symbolId);
                  }
                } else {
                  aliasesToReturnIfOriginalsAreMissing.delete(symbolId);
                  pushSymbol(symbol, moduleSymbol);
                }
              }
            });
            aliasesToReturnIfOriginalsAreMissing.forEach(function(_a) {
              var alias = _a.alias, moduleSymbol = _a.moduleSymbol;
              return pushSymbol(alias, moduleSymbol);
            });
            log("getSymbolsFromOtherSourceFileExports: " + (ts2.timestamp() - startTime));
            return results;
            function pushSymbol(symbol, moduleSymbol, skipFilter) {
              if (skipFilter === void 0) {
                skipFilter = false;
              }
              var isDefaultExport = symbol.escapedName === "default";
              if (isDefaultExport) {
                symbol = ts2.getLocalSymbolForExportDefault(symbol) || symbol;
              }
              if (typeChecker.isUndefinedSymbol(symbol)) {
                return;
              }
              ts2.addToSeen(resultSymbolIds, ts2.getSymbolId(symbol));
              var origin = { kind: 4, moduleSymbol, isDefaultExport };
              results.push({
                symbol,
                symbolName: ts2.getNameForExportedSymbol(symbol, target),
                origin,
                skipFilter
              });
            }
          }
          function getNearestExportSymbol(fromSymbol) {
            return findAlias(typeChecker, fromSymbol, function(alias) {
              return ts2.some(alias.declarations, function(d) {
                return ts2.isExportSpecifier(d) || !!d.localSymbol;
              });
            });
          }
          function stringContainsCharactersInOrder(str, characters) {
            if (characters.length === 0) {
              return true;
            }
            var characterIndex = 0;
            for (var strIndex = 0; strIndex < str.length; strIndex++) {
              if (str.charCodeAt(strIndex) === characters.charCodeAt(characterIndex)) {
                characterIndex++;
                if (characterIndex === characters.length) {
                  return true;
                }
              }
            }
            return false;
          }
          function getScopeNode(initialToken, position2, sourceFile2) {
            var scope = initialToken;
            while (scope && !ts2.positionBelongsToNode(scope, position2, sourceFile2)) {
              scope = scope.parent;
            }
            return scope;
          }
          function isCompletionListBlocker(contextToken2) {
            var start2 = ts2.timestamp();
            var result = isInStringOrRegularExpressionOrTemplateLiteral(contextToken2) || isSolelyIdentifierDefinitionLocation(contextToken2) || isDotOfNumericLiteral(contextToken2) || isInJsxText(contextToken2);
            log("getCompletionsAtPosition: isCompletionListBlocker: " + (ts2.timestamp() - start2));
            return result;
          }
          function isInJsxText(contextToken2) {
            if (contextToken2.kind === 11) {
              return true;
            }
            if (contextToken2.kind === 31 && contextToken2.parent) {
              if (contextToken2.parent.kind === 268) {
                return location.parent.kind !== 268;
              }
              if (contextToken2.parent.kind === 269 || contextToken2.parent.kind === 267) {
                return !!contextToken2.parent.parent && contextToken2.parent.parent.kind === 266;
              }
            }
            return false;
          }
          function isNewIdentifierDefinitionLocation(previousToken2) {
            if (previousToken2) {
              var containingNodeKind = previousToken2.parent.kind;
              switch (keywordForNode(previousToken2)) {
                case 27:
                  return containingNodeKind === 196 || containingNodeKind === 162 || containingNodeKind === 197 || containingNodeKind === 192 || containingNodeKind === 209 || containingNodeKind === 170;
                case 20:
                  return containingNodeKind === 196 || containingNodeKind === 162 || containingNodeKind === 197 || containingNodeKind === 200 || containingNodeKind === 182;
                case 22:
                  return containingNodeKind === 192 || containingNodeKind === 167 || containingNodeKind === 154;
                case 135:
                case 136:
                  return true;
                case 24:
                  return containingNodeKind === 249;
                case 18:
                  return containingNodeKind === 245;
                case 62:
                  return containingNodeKind === 242 || containingNodeKind === 209;
                case 15:
                  return containingNodeKind === 211;
                case 16:
                  return containingNodeKind === 221;
                case 119:
                case 117:
                case 118:
                  return containingNodeKind === 159;
              }
            }
            return false;
          }
          function isInStringOrRegularExpressionOrTemplateLiteral(contextToken2) {
            return (ts2.isRegularExpressionLiteral(contextToken2) || ts2.isStringTextContainingNode(contextToken2)) && (ts2.rangeContainsPositionExclusive(ts2.createTextRangeFromSpan(ts2.createTextSpanFromNode(contextToken2)), position) || position === contextToken2.end && (!!contextToken2.isUnterminated || ts2.isRegularExpressionLiteral(contextToken2)));
          }
          function tryGetObjectLikeCompletionSymbols() {
            var objectLikeContainer = tryGetObjectLikeCompletionContainer(contextToken);
            if (!objectLikeContainer)
              return 0;
            completionKind = 0;
            var typeMembers;
            var existingMembers;
            if (objectLikeContainer.kind === 193) {
              var instantiatedType = typeChecker.getContextualType(objectLikeContainer);
              var completionsType = instantiatedType && typeChecker.getContextualType(objectLikeContainer, 4);
              if (!instantiatedType || !completionsType)
                return 2;
              isNewIdentifierLocation = ts2.hasIndexSignature(instantiatedType || completionsType);
              typeMembers = getPropertiesForObjectExpression(instantiatedType, completionsType, objectLikeContainer, typeChecker);
              existingMembers = objectLikeContainer.properties;
            } else {
              ts2.Debug.assert(objectLikeContainer.kind === 189);
              isNewIdentifierLocation = false;
              var rootDeclaration = ts2.getRootDeclaration(objectLikeContainer.parent);
              if (!ts2.isVariableLike(rootDeclaration))
                return ts2.Debug.fail("Root declaration is not variable-like.");
              var canGetType = ts2.hasInitializer(rootDeclaration) || ts2.hasType(rootDeclaration) || rootDeclaration.parent.parent.kind === 232;
              if (!canGetType && rootDeclaration.kind === 156) {
                if (ts2.isExpression(rootDeclaration.parent)) {
                  canGetType = !!typeChecker.getContextualType(rootDeclaration.parent);
                } else if (rootDeclaration.parent.kind === 161 || rootDeclaration.parent.kind === 164) {
                  canGetType = ts2.isExpression(rootDeclaration.parent.parent) && !!typeChecker.getContextualType(rootDeclaration.parent.parent);
                }
              }
              if (canGetType) {
                var typeForObject_1 = typeChecker.getTypeAtLocation(objectLikeContainer);
                if (!typeForObject_1)
                  return 2;
                var containerClass_1 = ts2.getContainingClass(objectLikeContainer);
                typeMembers = typeChecker.getPropertiesOfType(typeForObject_1).filter(function(symbol) {
                  return !(ts2.getDeclarationModifierFlagsFromSymbol(symbol) & 24) || containerClass_1 && ts2.contains(typeForObject_1.symbol.declarations, containerClass_1);
                });
                existingMembers = objectLikeContainer.elements;
              }
            }
            if (typeMembers && typeMembers.length > 0) {
              symbols = filterObjectMembersList(typeMembers, ts2.Debug.checkDefined(existingMembers));
            }
            setSortTextToOptionalMember();
            return 1;
          }
          function tryGetImportOrExportClauseCompletionSymbols() {
            var namedImportsOrExports = contextToken && (contextToken.kind === 18 || contextToken.kind === 27) ? ts2.tryCast(contextToken.parent, ts2.isNamedImportsOrExports) : void 0;
            if (!namedImportsOrExports)
              return 0;
            var moduleSpecifier = (namedImportsOrExports.kind === 257 ? namedImportsOrExports.parent.parent : namedImportsOrExports.parent).moduleSpecifier;
            if (!moduleSpecifier)
              return namedImportsOrExports.kind === 257 ? 2 : 0;
            var moduleSpecifierSymbol = typeChecker.getSymbolAtLocation(moduleSpecifier);
            if (!moduleSpecifierSymbol)
              return 2;
            completionKind = 3;
            isNewIdentifierLocation = false;
            var exports2 = typeChecker.getExportsAndPropertiesOfModule(moduleSpecifierSymbol);
            var existing = ts2.arrayToSet(namedImportsOrExports.elements, function(n) {
              return isCurrentlyEditingNode(n) ? void 0 : (n.propertyName || n.name).escapedText;
            });
            symbols = exports2.filter(function(e) {
              return e.escapedName !== "default" && !existing.get(e.escapedName);
            });
            return 1;
          }
          function tryGetLocalNamedExportCompletionSymbols() {
            var _a;
            var namedExports = contextToken && (contextToken.kind === 18 || contextToken.kind === 27) ? ts2.tryCast(contextToken.parent, ts2.isNamedExports) : void 0;
            if (!namedExports) {
              return 0;
            }
            var localsContainer = ts2.findAncestor(namedExports, ts2.or(ts2.isSourceFile, ts2.isModuleDeclaration));
            completionKind = 5;
            isNewIdentifierLocation = false;
            (_a = localsContainer.locals) === null || _a === void 0 ? void 0 : _a.forEach(function(symbol, name) {
              var _a2, _b;
              symbols.push(symbol);
              if ((_b = (_a2 = localsContainer.symbol) === null || _a2 === void 0 ? void 0 : _a2.exports) === null || _b === void 0 ? void 0 : _b.has(name)) {
                symbolToSortTextMap[ts2.getSymbolId(symbol)] = SortText.OptionalMember;
              }
            });
            return 1;
          }
          function tryGetClassLikeCompletionSymbols() {
            var decl = tryGetObjectTypeDeclarationCompletionContainer(sourceFile, contextToken, location, position);
            if (!decl)
              return 0;
            completionKind = 3;
            isNewIdentifierLocation = true;
            keywordFilters = contextToken.kind === 41 ? 0 : ts2.isClassLike(decl) ? 2 : 3;
            if (!ts2.isClassLike(decl))
              return 1;
            var classElement = contextToken.kind === 26 ? contextToken.parent.parent : contextToken.parent;
            var classElementModifierFlags = ts2.isClassElement(classElement) ? ts2.getModifierFlags(classElement) : 0;
            if (contextToken.kind === 75 && !isCurrentlyEditingNode(contextToken)) {
              switch (contextToken.getText()) {
                case "private":
                  classElementModifierFlags = classElementModifierFlags | 8;
                  break;
                case "static":
                  classElementModifierFlags = classElementModifierFlags | 32;
                  break;
              }
            }
            if (!(classElementModifierFlags & 8)) {
              var baseSymbols = ts2.flatMap(ts2.getAllSuperTypeNodes(decl), function(baseTypeNode) {
                var type = typeChecker.getTypeAtLocation(baseTypeNode);
                return type && typeChecker.getPropertiesOfType(classElementModifierFlags & 32 ? typeChecker.getTypeOfSymbolAtLocation(type.symbol, decl) : type);
              });
              symbols = filterClassMembersList(baseSymbols, decl.members, classElementModifierFlags);
            }
            return 1;
          }
          function tryGetObjectLikeCompletionContainer(contextToken2) {
            if (contextToken2) {
              var parent2 = contextToken2.parent;
              switch (contextToken2.kind) {
                case 18:
                case 27:
                  if (ts2.isObjectLiteralExpression(parent2) || ts2.isObjectBindingPattern(parent2)) {
                    return parent2;
                  }
                  break;
                case 41:
                  return ts2.isMethodDeclaration(parent2) ? ts2.tryCast(parent2.parent, ts2.isObjectLiteralExpression) : void 0;
                case 75:
                  return contextToken2.text === "async" && ts2.isShorthandPropertyAssignment(contextToken2.parent) ? contextToken2.parent.parent : void 0;
              }
            }
            return void 0;
          }
          function isConstructorParameterCompletion(node2) {
            return !!node2.parent && ts2.isParameter(node2.parent) && ts2.isConstructorDeclaration(node2.parent.parent) && (ts2.isParameterPropertyModifier(node2.kind) || ts2.isDeclarationName(node2));
          }
          function tryGetConstructorLikeCompletionContainer(contextToken2) {
            if (contextToken2) {
              var parent2 = contextToken2.parent;
              switch (contextToken2.kind) {
                case 20:
                case 27:
                  return ts2.isConstructorDeclaration(contextToken2.parent) ? contextToken2.parent : void 0;
                default:
                  if (isConstructorParameterCompletion(contextToken2)) {
                    return parent2.parent;
                  }
              }
            }
            return void 0;
          }
          function tryGetFunctionLikeBodyCompletionContainer(contextToken2) {
            if (contextToken2) {
              var prev_1;
              var container = ts2.findAncestor(contextToken2.parent, function(node2) {
                if (ts2.isClassLike(node2)) {
                  return "quit";
                }
                if (ts2.isFunctionLikeDeclaration(node2) && prev_1 === node2.body) {
                  return true;
                }
                prev_1 = node2;
                return false;
              });
              return container && container;
            }
          }
          function tryGetContainingJsxElement(contextToken2) {
            if (contextToken2) {
              var parent2 = contextToken2.parent;
              switch (contextToken2.kind) {
                case 31:
                case 30:
                case 43:
                case 75:
                case 194:
                case 274:
                case 273:
                case 275:
                  if (parent2 && (parent2.kind === 267 || parent2.kind === 268)) {
                    if (contextToken2.kind === 31) {
                      var precedingToken = ts2.findPrecedingToken(contextToken2.pos, sourceFile, void 0);
                      if (!parent2.typeArguments || precedingToken && precedingToken.kind === 43)
                        break;
                    }
                    return parent2;
                  } else if (parent2.kind === 273) {
                    return parent2.parent.parent;
                  }
                  break;
                case 10:
                  if (parent2 && (parent2.kind === 273 || parent2.kind === 275)) {
                    return parent2.parent.parent;
                  }
                  break;
                case 19:
                  if (parent2 && parent2.kind === 276 && parent2.parent && parent2.parent.kind === 273) {
                    return parent2.parent.parent.parent;
                  }
                  if (parent2 && parent2.kind === 275) {
                    return parent2.parent.parent;
                  }
                  break;
              }
            }
            return void 0;
          }
          function isSolelyIdentifierDefinitionLocation(contextToken2) {
            var parent2 = contextToken2.parent;
            var containingNodeKind = parent2.kind;
            switch (contextToken2.kind) {
              case 27:
                return containingNodeKind === 242 || isVariableDeclarationListButNotTypeArgument(contextToken2) || containingNodeKind === 225 || containingNodeKind === 248 || isFunctionLikeButNotConstructor(containingNodeKind) || containingNodeKind === 246 || containingNodeKind === 190 || containingNodeKind === 247 || ts2.isClassLike(parent2) && !!parent2.typeParameters && parent2.typeParameters.end >= contextToken2.pos;
              case 24:
                return containingNodeKind === 190;
              case 58:
                return containingNodeKind === 191;
              case 22:
                return containingNodeKind === 190;
              case 20:
                return containingNodeKind === 280 || isFunctionLikeButNotConstructor(containingNodeKind);
              case 18:
                return containingNodeKind === 248;
              case 29:
                return containingNodeKind === 245 || containingNodeKind === 214 || containingNodeKind === 246 || containingNodeKind === 247 || ts2.isFunctionLikeKind(containingNodeKind);
              case 120:
                return containingNodeKind === 159 && !ts2.isClassLike(parent2.parent);
              case 25:
                return containingNodeKind === 156 || !!parent2.parent && parent2.parent.kind === 190;
              case 119:
              case 117:
              case 118:
                return containingNodeKind === 156 && !ts2.isConstructorDeclaration(parent2.parent);
              case 123:
                return containingNodeKind === 258 || containingNodeKind === 263 || containingNodeKind === 256;
              case 131:
              case 142:
                return !isFromObjectTypeDeclaration(contextToken2);
              case 80:
              case 88:
              case 114:
              case 94:
              case 109:
              case 96:
              case 115:
              case 81:
              case 145:
                return true;
              case 41:
                return ts2.isFunctionLike(contextToken2.parent) && !ts2.isMethodDeclaration(contextToken2.parent);
            }
            if (isClassMemberCompletionKeyword(keywordForNode(contextToken2)) && isFromObjectTypeDeclaration(contextToken2)) {
              return false;
            }
            if (isConstructorParameterCompletion(contextToken2)) {
              if (!ts2.isIdentifier(contextToken2) || ts2.isParameterPropertyModifier(keywordForNode(contextToken2)) || isCurrentlyEditingNode(contextToken2)) {
                return false;
              }
            }
            switch (keywordForNode(contextToken2)) {
              case 122:
              case 80:
              case 81:
              case 130:
              case 88:
              case 94:
              case 114:
              case 115:
              case 117:
              case 118:
              case 119:
              case 120:
              case 109:
                return true;
              case 126:
                return ts2.isPropertyDeclaration(contextToken2.parent);
            }
            return ts2.isDeclarationName(contextToken2) && !ts2.isJsxAttribute(contextToken2.parent) && !(ts2.isClassLike(contextToken2.parent) && (contextToken2 !== previousToken || position > previousToken.end));
          }
          function isFunctionLikeButNotConstructor(kind) {
            return ts2.isFunctionLikeKind(kind) && kind !== 162;
          }
          function isDotOfNumericLiteral(contextToken2) {
            if (contextToken2.kind === 8) {
              var text = contextToken2.getFullText();
              return text.charAt(text.length - 1) === ".";
            }
            return false;
          }
          function isVariableDeclarationListButNotTypeArgument(node2) {
            return node2.parent.kind === 243 && !ts2.isPossiblyTypeArgumentPosition(node2, sourceFile, typeChecker);
          }
          function filterObjectMembersList(contextualMemberSymbols, existingMembers) {
            if (existingMembers.length === 0) {
              return contextualMemberSymbols;
            }
            var membersDeclaredBySpreadAssignment = ts2.createMap();
            var existingMemberNames = ts2.createUnderscoreEscapedMap();
            for (var _i = 0, existingMembers_1 = existingMembers; _i < existingMembers_1.length; _i++) {
              var m = existingMembers_1[_i];
              if (m.kind !== 281 && m.kind !== 282 && m.kind !== 191 && m.kind !== 161 && m.kind !== 163 && m.kind !== 164 && m.kind !== 283) {
                continue;
              }
              if (isCurrentlyEditingNode(m)) {
                continue;
              }
              var existingName = void 0;
              if (ts2.isSpreadAssignment(m)) {
                setMembersDeclaredBySpreadAssignment(m, membersDeclaredBySpreadAssignment);
              } else if (ts2.isBindingElement(m) && m.propertyName) {
                if (m.propertyName.kind === 75) {
                  existingName = m.propertyName.escapedText;
                }
              } else {
                var name = ts2.getNameOfDeclaration(m);
                existingName = name && ts2.isPropertyNameLiteral(name) ? ts2.getEscapedTextOfIdentifierOrLiteral(name) : void 0;
              }
              existingMemberNames.set(existingName, true);
            }
            var filteredSymbols = contextualMemberSymbols.filter(function(m2) {
              return !existingMemberNames.get(m2.escapedName);
            });
            setSortTextToMemberDeclaredBySpreadAssignment(membersDeclaredBySpreadAssignment, filteredSymbols);
            return filteredSymbols;
          }
          function setMembersDeclaredBySpreadAssignment(declaration, membersDeclaredBySpreadAssignment) {
            var expression = declaration.expression;
            var symbol = typeChecker.getSymbolAtLocation(expression);
            var type = symbol && typeChecker.getTypeOfSymbolAtLocation(symbol, expression);
            var properties = type && type.properties;
            if (properties) {
              properties.forEach(function(property) {
                membersDeclaredBySpreadAssignment.set(property.name, true);
              });
            }
          }
          function setSortTextToOptionalMember() {
            symbols.forEach(function(m) {
              if (m.flags & 16777216) {
                symbolToSortTextMap[ts2.getSymbolId(m)] = symbolToSortTextMap[ts2.getSymbolId(m)] || SortText.OptionalMember;
              }
            });
          }
          function setSortTextToMemberDeclaredBySpreadAssignment(membersDeclaredBySpreadAssignment, contextualMemberSymbols) {
            if (membersDeclaredBySpreadAssignment.size === 0) {
              return;
            }
            for (var _i = 0, contextualMemberSymbols_1 = contextualMemberSymbols; _i < contextualMemberSymbols_1.length; _i++) {
              var contextualMemberSymbol = contextualMemberSymbols_1[_i];
              if (membersDeclaredBySpreadAssignment.has(contextualMemberSymbol.name)) {
                symbolToSortTextMap[ts2.getSymbolId(contextualMemberSymbol)] = SortText.MemberDeclaredBySpreadAssignment;
              }
            }
          }
          function filterClassMembersList(baseSymbols, existingMembers, currentClassElementModifierFlags) {
            var existingMemberNames = ts2.createUnderscoreEscapedMap();
            for (var _i = 0, existingMembers_2 = existingMembers; _i < existingMembers_2.length; _i++) {
              var m = existingMembers_2[_i];
              if (m.kind !== 159 && m.kind !== 161 && m.kind !== 163 && m.kind !== 164) {
                continue;
              }
              if (isCurrentlyEditingNode(m)) {
                continue;
              }
              if (ts2.hasModifier(m, 8)) {
                continue;
              }
              if (ts2.hasModifier(m, 32) !== !!(currentClassElementModifierFlags & 32)) {
                continue;
              }
              var existingName = ts2.getPropertyNameForPropertyNameNode(m.name);
              if (existingName) {
                existingMemberNames.set(existingName, true);
              }
            }
            return baseSymbols.filter(function(propertySymbol) {
              return !existingMemberNames.has(propertySymbol.escapedName) && !!propertySymbol.declarations && !(ts2.getDeclarationModifierFlagsFromSymbol(propertySymbol) & 8) && !ts2.isPrivateIdentifierPropertyDeclaration(propertySymbol.valueDeclaration);
            });
          }
          function filterJsxAttributes(symbols2, attributes) {
            var seenNames = ts2.createUnderscoreEscapedMap();
            var membersDeclaredBySpreadAssignment = ts2.createMap();
            for (var _i = 0, attributes_1 = attributes; _i < attributes_1.length; _i++) {
              var attr = attributes_1[_i];
              if (isCurrentlyEditingNode(attr)) {
                continue;
              }
              if (attr.kind === 273) {
                seenNames.set(attr.name.escapedText, true);
              } else if (ts2.isJsxSpreadAttribute(attr)) {
                setMembersDeclaredBySpreadAssignment(attr, membersDeclaredBySpreadAssignment);
              }
            }
            var filteredSymbols = symbols2.filter(function(a) {
              return !seenNames.get(a.escapedName);
            });
            setSortTextToMemberDeclaredBySpreadAssignment(membersDeclaredBySpreadAssignment, filteredSymbols);
            return filteredSymbols;
          }
          function isCurrentlyEditingNode(node2) {
            return node2.getStart(sourceFile) <= position && position <= node2.getEnd();
          }
        }
        function getCompletionEntryDisplayNameForSymbol(symbol, target, origin, kind, jsxIdentifierExpected) {
          var name = originIsExport(origin) ? ts2.getNameForExportedSymbol(symbol, target) : symbol.name;
          if (name === void 0 || symbol.flags & 1536 && ts2.isSingleOrDoubleQuote(name.charCodeAt(0)) || ts2.isKnownSymbol(symbol)) {
            return void 0;
          }
          var validNameResult = { name, needsConvertPropertyAccess: false };
          if (ts2.isIdentifierText(name, target, jsxIdentifierExpected ? 1 : 0) || symbol.valueDeclaration && ts2.isPrivateIdentifierPropertyDeclaration(symbol.valueDeclaration)) {
            return validNameResult;
          }
          switch (kind) {
            case 3:
              return void 0;
            case 0:
              return { name: JSON.stringify(name), needsConvertPropertyAccess: false };
            case 2:
            case 1:
              return name.charCodeAt(0) === 32 ? void 0 : { name, needsConvertPropertyAccess: true };
            case 5:
            case 4:
              return validNameResult;
            default:
              ts2.Debug.assertNever(kind);
          }
        }
        var _keywordCompletions = [];
        var allKeywordsCompletions = ts2.memoize(function() {
          var res = [];
          for (var i = 77; i <= 152; i++) {
            res.push({
              name: ts2.tokenToString(i),
              kind: "keyword",
              kindModifiers: "",
              sortText: SortText.GlobalsOrKeywords
            });
          }
          return res;
        });
        function getKeywordCompletions(keywordFilter, filterOutTsOnlyKeywords) {
          if (!filterOutTsOnlyKeywords)
            return getTypescriptKeywordCompletions(keywordFilter);
          var index = keywordFilter + 7 + 1;
          return _keywordCompletions[index] || (_keywordCompletions[index] = getTypescriptKeywordCompletions(keywordFilter).filter(function(entry) {
            return !isTypeScriptOnlyKeyword(ts2.stringToToken(entry.name));
          }));
        }
        function getTypescriptKeywordCompletions(keywordFilter) {
          return _keywordCompletions[keywordFilter] || (_keywordCompletions[keywordFilter] = allKeywordsCompletions().filter(function(entry) {
            var kind = ts2.stringToToken(entry.name);
            switch (keywordFilter) {
              case 0:
                return false;
              case 1:
                return isFunctionLikeBodyKeyword(kind) || kind === 130 || kind === 135 || kind === 145 || kind === 136 || kind === 123 || ts2.isTypeKeyword(kind) && kind !== 146;
              case 5:
                return isFunctionLikeBodyKeyword(kind);
              case 2:
                return isClassMemberCompletionKeyword(kind);
              case 3:
                return isInterfaceOrTypeLiteralCompletionKeyword(kind);
              case 4:
                return ts2.isParameterPropertyModifier(kind);
              case 6:
                return ts2.isTypeKeyword(kind) || kind === 81;
              case 7:
                return ts2.isTypeKeyword(kind);
              default:
                return ts2.Debug.assertNever(keywordFilter);
            }
          }));
        }
        function isTypeScriptOnlyKeyword(kind) {
          switch (kind) {
            case 122:
            case 125:
            case 151:
            case 128:
            case 130:
            case 88:
            case 150:
            case 113:
            case 132:
            case 114:
            case 133:
            case 134:
            case 135:
            case 136:
            case 137:
            case 140:
            case 141:
            case 117:
            case 118:
            case 119:
            case 138:
            case 143:
            case 144:
            case 145:
            case 147:
            case 148:
              return true;
            default:
              return false;
          }
        }
        function isInterfaceOrTypeLiteralCompletionKeyword(kind) {
          return kind === 138;
        }
        function isClassMemberCompletionKeyword(kind) {
          switch (kind) {
            case 122:
            case 129:
            case 131:
            case 142:
            case 126:
            case 130:
              return true;
            default:
              return ts2.isClassMemberModifier(kind);
          }
        }
        function isFunctionLikeBodyKeyword(kind) {
          return kind === 126 || kind === 127 || !ts2.isContextualKeyword(kind) && !isClassMemberCompletionKeyword(kind);
        }
        function keywordForNode(node) {
          return ts2.isIdentifier(node) ? node.originalKeywordKind || 0 : node.kind;
        }
        function getJsDocTagAtPosition(node, position) {
          var jsdoc = ts2.findAncestor(node, ts2.isJSDoc);
          return jsdoc && jsdoc.tags && (ts2.rangeContainsPosition(jsdoc, position) ? ts2.findLast(jsdoc.tags, function(tag) {
            return tag.pos < position;
          }) : void 0);
        }
        function getPropertiesForObjectExpression(contextualType, completionsType, obj, checker) {
          var hasCompletionsType = completionsType && completionsType !== contextualType;
          var type = hasCompletionsType && !(completionsType.flags & 3) ? checker.getUnionType([contextualType, completionsType]) : contextualType;
          var properties = type.isUnion() ? checker.getAllPossiblePropertiesOfTypes(type.types.filter(function(memberType) {
            return !(memberType.flags & 131068 || checker.isArrayLikeType(memberType) || ts2.typeHasCallOrConstructSignatures(memberType, checker) || checker.isTypeInvalidDueToUnionDiscriminant(memberType, obj));
          })) : type.getApparentProperties();
          return hasCompletionsType ? properties.filter(hasDeclarationOtherThanSelf) : properties;
          function hasDeclarationOtherThanSelf(member) {
            return ts2.some(member.declarations, function(decl) {
              return decl.parent !== obj;
            });
          }
        }
        function getPropertiesForCompletion(type, checker) {
          return type.isUnion() ? ts2.Debug.checkEachDefined(checker.getAllPossiblePropertiesOfTypes(type.types), "getAllPossiblePropertiesOfTypes() should all be defined") : ts2.Debug.checkEachDefined(type.getApparentProperties(), "getApparentProperties() should all be defined");
        }
        function tryGetObjectTypeDeclarationCompletionContainer(sourceFile, contextToken, location, position) {
          switch (location.kind) {
            case 324:
              return ts2.tryCast(location.parent, ts2.isObjectTypeDeclaration);
            case 1:
              var cls = ts2.tryCast(ts2.lastOrUndefined(ts2.cast(location.parent, ts2.isSourceFile).statements), ts2.isObjectTypeDeclaration);
              if (cls && !ts2.findChildOfKind(cls, 19, sourceFile)) {
                return cls;
              }
              break;
            case 75: {
              if (ts2.isPropertyDeclaration(location.parent) && location.parent.initializer === location) {
                return void 0;
              }
              if (isFromObjectTypeDeclaration(location)) {
                return ts2.findAncestor(location, ts2.isObjectTypeDeclaration);
              }
            }
          }
          if (!contextToken)
            return void 0;
          switch (contextToken.kind) {
            case 62:
              return void 0;
            case 26:
            case 19:
              return isFromObjectTypeDeclaration(location) && location.parent.name === location ? location.parent.parent : ts2.tryCast(location, ts2.isObjectTypeDeclaration);
            case 18:
            case 27:
              return ts2.tryCast(contextToken.parent, ts2.isObjectTypeDeclaration);
            default:
              if (!isFromObjectTypeDeclaration(contextToken)) {
                if (ts2.getLineAndCharacterOfPosition(sourceFile, contextToken.getEnd()).line !== ts2.getLineAndCharacterOfPosition(sourceFile, position).line && ts2.isObjectTypeDeclaration(location)) {
                  return location;
                }
                return void 0;
              }
              var isValidKeyword = ts2.isClassLike(contextToken.parent.parent) ? isClassMemberCompletionKeyword : isInterfaceOrTypeLiteralCompletionKeyword;
              return isValidKeyword(contextToken.kind) || contextToken.kind === 41 || ts2.isIdentifier(contextToken) && isValidKeyword(ts2.stringToToken(contextToken.text)) ? contextToken.parent.parent : void 0;
          }
        }
        function isFromObjectTypeDeclaration(node) {
          return node.parent && ts2.isClassOrTypeElement(node.parent) && ts2.isObjectTypeDeclaration(node.parent.parent);
        }
        function isValidTrigger(sourceFile, triggerCharacter, contextToken, position) {
          switch (triggerCharacter) {
            case ".":
            case "@":
              return true;
            case '"':
            case "'":
            case "`":
              return !!contextToken && ts2.isStringLiteralOrTemplate(contextToken) && position === contextToken.getStart(sourceFile) + 1;
            case "#":
              return !!contextToken && ts2.isPrivateIdentifier(contextToken) && !!ts2.getContainingClass(contextToken);
            case "<":
              return !!contextToken && contextToken.kind === 29 && (!ts2.isBinaryExpression(contextToken.parent) || binaryExpressionMayBeOpenTag(contextToken.parent));
            case "/":
              return !!contextToken && (ts2.isStringLiteralLike(contextToken) ? !!ts2.tryGetImportFromModuleSpecifier(contextToken) : contextToken.kind === 43 && ts2.isJsxClosingElement(contextToken.parent));
            default:
              return ts2.Debug.assertNever(triggerCharacter);
          }
        }
        function binaryExpressionMayBeOpenTag(_a) {
          var left = _a.left;
          return ts2.nodeIsMissing(left);
        }
        function findAlias(typeChecker, symbol, predicate) {
          var currentAlias = symbol;
          while (currentAlias.flags & 2097152 && (currentAlias = typeChecker.getImmediateAliasedSymbol(currentAlias))) {
            if (predicate(currentAlias)) {
              return currentAlias;
            }
          }
        }
        function isProbablyGlobalType(type, sourceFile, checker) {
          var selfSymbol = checker.resolveName("self", void 0, 111551, false);
          if (selfSymbol && checker.getTypeOfSymbolAtLocation(selfSymbol, sourceFile) === type) {
            return true;
          }
          var globalSymbol = checker.resolveName("global", void 0, 111551, false);
          if (globalSymbol && checker.getTypeOfSymbolAtLocation(globalSymbol, sourceFile) === type) {
            return true;
          }
          var globalThisSymbol = checker.resolveName("globalThis", void 0, 111551, false);
          if (globalThisSymbol && checker.getTypeOfSymbolAtLocation(globalThisSymbol, sourceFile) === type) {
            return true;
          }
          return false;
        }
      })(Completions = ts2.Completions || (ts2.Completions = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var DocumentHighlights;
      (function(DocumentHighlights2) {
        function getDocumentHighlights(program, cancellationToken, sourceFile, position, sourceFilesToSearch) {
          var node = ts2.getTouchingPropertyName(sourceFile, position);
          if (node.parent && (ts2.isJsxOpeningElement(node.parent) && node.parent.tagName === node || ts2.isJsxClosingElement(node.parent))) {
            var _a = node.parent.parent, openingElement = _a.openingElement, closingElement = _a.closingElement;
            var highlightSpans = [openingElement, closingElement].map(function(_a2) {
              var tagName = _a2.tagName;
              return getHighlightSpanForNode(tagName, sourceFile);
            });
            return [{ fileName: sourceFile.fileName, highlightSpans }];
          }
          return getSemanticDocumentHighlights(position, node, program, cancellationToken, sourceFilesToSearch) || getSyntacticDocumentHighlights(node, sourceFile);
        }
        DocumentHighlights2.getDocumentHighlights = getDocumentHighlights;
        function getHighlightSpanForNode(node, sourceFile) {
          return {
            fileName: sourceFile.fileName,
            textSpan: ts2.createTextSpanFromNode(node, sourceFile),
            kind: "none"
          };
        }
        function getSemanticDocumentHighlights(position, node, program, cancellationToken, sourceFilesToSearch) {
          var sourceFilesSet = ts2.arrayToSet(sourceFilesToSearch, function(f) {
            return f.fileName;
          });
          var referenceEntries = ts2.FindAllReferences.getReferenceEntriesForNode(position, node, program, sourceFilesToSearch, cancellationToken, void 0, sourceFilesSet);
          if (!referenceEntries)
            return void 0;
          var map = ts2.arrayToMultiMap(referenceEntries.map(ts2.FindAllReferences.toHighlightSpan), function(e) {
            return e.fileName;
          }, function(e) {
            return e.span;
          });
          return ts2.arrayFrom(map.entries(), function(_a) {
            var fileName = _a[0], highlightSpans = _a[1];
            if (!sourceFilesSet.has(fileName)) {
              ts2.Debug.assert(program.redirectTargetsMap.has(fileName));
              var redirectTarget_1 = program.getSourceFile(fileName);
              var redirect = ts2.find(sourceFilesToSearch, function(f) {
                return !!f.redirectInfo && f.redirectInfo.redirectTarget === redirectTarget_1;
              });
              fileName = redirect.fileName;
              ts2.Debug.assert(sourceFilesSet.has(fileName));
            }
            return { fileName, highlightSpans };
          });
        }
        function getSyntacticDocumentHighlights(node, sourceFile) {
          var highlightSpans = getHighlightSpans(node, sourceFile);
          return highlightSpans && [{ fileName: sourceFile.fileName, highlightSpans }];
        }
        function getHighlightSpans(node, sourceFile) {
          switch (node.kind) {
            case 95:
            case 87:
              return ts2.isIfStatement(node.parent) ? getIfElseOccurrences(node.parent, sourceFile) : void 0;
            case 101:
              return useParent(node.parent, ts2.isReturnStatement, getReturnOccurrences);
            case 105:
              return useParent(node.parent, ts2.isThrowStatement, getThrowOccurrences);
            case 107:
            case 79:
            case 92:
              var tryStatement = node.kind === 79 ? node.parent.parent : node.parent;
              return useParent(tryStatement, ts2.isTryStatement, getTryCatchFinallyOccurrences);
            case 103:
              return useParent(node.parent, ts2.isSwitchStatement, getSwitchCaseDefaultOccurrences);
            case 78:
            case 84: {
              if (ts2.isDefaultClause(node.parent) || ts2.isCaseClause(node.parent)) {
                return useParent(node.parent.parent.parent, ts2.isSwitchStatement, getSwitchCaseDefaultOccurrences);
              }
              return void 0;
            }
            case 77:
            case 82:
              return useParent(node.parent, ts2.isBreakOrContinueStatement, getBreakOrContinueStatementOccurrences);
            case 93:
            case 111:
            case 86:
              return useParent(node.parent, function(n) {
                return ts2.isIterationStatement(n, true);
              }, getLoopBreakContinueOccurrences);
            case 129:
              return getFromAllDeclarations(ts2.isConstructorDeclaration, [129]);
            case 131:
            case 142:
              return getFromAllDeclarations(ts2.isAccessor, [131, 142]);
            case 127:
              return useParent(node.parent, ts2.isAwaitExpression, getAsyncAndAwaitOccurrences);
            case 126:
              return highlightSpans(getAsyncAndAwaitOccurrences(node));
            case 121:
              return highlightSpans(getYieldOccurrences(node));
            default:
              return ts2.isModifierKind(node.kind) && (ts2.isDeclaration(node.parent) || ts2.isVariableStatement(node.parent)) ? highlightSpans(getModifierOccurrences(node.kind, node.parent)) : void 0;
          }
          function getFromAllDeclarations(nodeTest, keywords) {
            return useParent(node.parent, nodeTest, function(decl) {
              return ts2.mapDefined(decl.symbol.declarations, function(d) {
                return nodeTest(d) ? ts2.find(d.getChildren(sourceFile), function(c) {
                  return ts2.contains(keywords, c.kind);
                }) : void 0;
              });
            });
          }
          function useParent(node2, nodeTest, getNodes) {
            return nodeTest(node2) ? highlightSpans(getNodes(node2, sourceFile)) : void 0;
          }
          function highlightSpans(nodes) {
            return nodes && nodes.map(function(node2) {
              return getHighlightSpanForNode(node2, sourceFile);
            });
          }
        }
        function aggregateOwnedThrowStatements(node) {
          if (ts2.isThrowStatement(node)) {
            return [node];
          } else if (ts2.isTryStatement(node)) {
            return ts2.concatenate(node.catchClause ? aggregateOwnedThrowStatements(node.catchClause) : node.tryBlock && aggregateOwnedThrowStatements(node.tryBlock), node.finallyBlock && aggregateOwnedThrowStatements(node.finallyBlock));
          }
          return ts2.isFunctionLike(node) ? void 0 : flatMapChildren(node, aggregateOwnedThrowStatements);
        }
        function getThrowStatementOwner(throwStatement) {
          var child = throwStatement;
          while (child.parent) {
            var parent = child.parent;
            if (ts2.isFunctionBlock(parent) || parent.kind === 290) {
              return parent;
            }
            if (ts2.isTryStatement(parent) && parent.tryBlock === child && parent.catchClause) {
              return child;
            }
            child = parent;
          }
          return void 0;
        }
        function aggregateAllBreakAndContinueStatements(node) {
          return ts2.isBreakOrContinueStatement(node) ? [node] : ts2.isFunctionLike(node) ? void 0 : flatMapChildren(node, aggregateAllBreakAndContinueStatements);
        }
        function flatMapChildren(node, cb) {
          var result = [];
          node.forEachChild(function(child) {
            var value = cb(child);
            if (value !== void 0) {
              result.push.apply(result, ts2.toArray(value));
            }
          });
          return result;
        }
        function ownsBreakOrContinueStatement(owner, statement) {
          var actualOwner = getBreakOrContinueOwner(statement);
          return !!actualOwner && actualOwner === owner;
        }
        function getBreakOrContinueOwner(statement) {
          return ts2.findAncestor(statement, function(node) {
            switch (node.kind) {
              case 237:
                if (statement.kind === 233) {
                  return false;
                }
              case 230:
              case 231:
              case 232:
              case 229:
              case 228:
                return !statement.label || isLabeledBy(node, statement.label.escapedText);
              default:
                return ts2.isFunctionLike(node) && "quit";
            }
          });
        }
        function getModifierOccurrences(modifier, declaration) {
          return ts2.mapDefined(getNodesToSearchForModifier(declaration, ts2.modifierToFlag(modifier)), function(node) {
            return ts2.findModifier(node, modifier);
          });
        }
        function getNodesToSearchForModifier(declaration, modifierFlag) {
          var container = declaration.parent;
          switch (container.kind) {
            case 250:
            case 290:
            case 223:
            case 277:
            case 278:
              if (modifierFlag & 128 && ts2.isClassDeclaration(declaration)) {
                return __spreadArrays(declaration.members, [declaration]);
              } else {
                return container.statements;
              }
            case 162:
            case 161:
            case 244:
              return __spreadArrays(container.parameters, ts2.isClassLike(container.parent) ? container.parent.members : []);
            case 245:
            case 214:
            case 246:
            case 173:
              var nodes = container.members;
              if (modifierFlag & (28 | 64)) {
                var constructor = ts2.find(container.members, ts2.isConstructorDeclaration);
                if (constructor) {
                  return __spreadArrays(nodes, constructor.parameters);
                }
              } else if (modifierFlag & 128) {
                return __spreadArrays(nodes, [container]);
              }
              return nodes;
            default:
              ts2.Debug.assertNever(container, "Invalid container kind.");
          }
        }
        function pushKeywordIf(keywordList, token) {
          var expected = [];
          for (var _i = 2; _i < arguments.length; _i++) {
            expected[_i - 2] = arguments[_i];
          }
          if (token && ts2.contains(expected, token.kind)) {
            keywordList.push(token);
            return true;
          }
          return false;
        }
        function getLoopBreakContinueOccurrences(loopNode) {
          var keywords = [];
          if (pushKeywordIf(keywords, loopNode.getFirstToken(), 93, 111, 86)) {
            if (loopNode.kind === 228) {
              var loopTokens = loopNode.getChildren();
              for (var i = loopTokens.length - 1; i >= 0; i--) {
                if (pushKeywordIf(keywords, loopTokens[i], 111)) {
                  break;
                }
              }
            }
          }
          ts2.forEach(aggregateAllBreakAndContinueStatements(loopNode.statement), function(statement) {
            if (ownsBreakOrContinueStatement(loopNode, statement)) {
              pushKeywordIf(keywords, statement.getFirstToken(), 77, 82);
            }
          });
          return keywords;
        }
        function getBreakOrContinueStatementOccurrences(breakOrContinueStatement) {
          var owner = getBreakOrContinueOwner(breakOrContinueStatement);
          if (owner) {
            switch (owner.kind) {
              case 230:
              case 231:
              case 232:
              case 228:
              case 229:
                return getLoopBreakContinueOccurrences(owner);
              case 237:
                return getSwitchCaseDefaultOccurrences(owner);
            }
          }
          return void 0;
        }
        function getSwitchCaseDefaultOccurrences(switchStatement) {
          var keywords = [];
          pushKeywordIf(keywords, switchStatement.getFirstToken(), 103);
          ts2.forEach(switchStatement.caseBlock.clauses, function(clause) {
            pushKeywordIf(keywords, clause.getFirstToken(), 78, 84);
            ts2.forEach(aggregateAllBreakAndContinueStatements(clause), function(statement) {
              if (ownsBreakOrContinueStatement(switchStatement, statement)) {
                pushKeywordIf(keywords, statement.getFirstToken(), 77);
              }
            });
          });
          return keywords;
        }
        function getTryCatchFinallyOccurrences(tryStatement, sourceFile) {
          var keywords = [];
          pushKeywordIf(keywords, tryStatement.getFirstToken(), 107);
          if (tryStatement.catchClause) {
            pushKeywordIf(keywords, tryStatement.catchClause.getFirstToken(), 79);
          }
          if (tryStatement.finallyBlock) {
            var finallyKeyword = ts2.findChildOfKind(tryStatement, 92, sourceFile);
            pushKeywordIf(keywords, finallyKeyword, 92);
          }
          return keywords;
        }
        function getThrowOccurrences(throwStatement, sourceFile) {
          var owner = getThrowStatementOwner(throwStatement);
          if (!owner) {
            return void 0;
          }
          var keywords = [];
          ts2.forEach(aggregateOwnedThrowStatements(owner), function(throwStatement2) {
            keywords.push(ts2.findChildOfKind(throwStatement2, 105, sourceFile));
          });
          if (ts2.isFunctionBlock(owner)) {
            ts2.forEachReturnStatement(owner, function(returnStatement) {
              keywords.push(ts2.findChildOfKind(returnStatement, 101, sourceFile));
            });
          }
          return keywords;
        }
        function getReturnOccurrences(returnStatement, sourceFile) {
          var func = ts2.getContainingFunction(returnStatement);
          if (!func) {
            return void 0;
          }
          var keywords = [];
          ts2.forEachReturnStatement(ts2.cast(func.body, ts2.isBlock), function(returnStatement2) {
            keywords.push(ts2.findChildOfKind(returnStatement2, 101, sourceFile));
          });
          ts2.forEach(aggregateOwnedThrowStatements(func.body), function(throwStatement) {
            keywords.push(ts2.findChildOfKind(throwStatement, 105, sourceFile));
          });
          return keywords;
        }
        function getAsyncAndAwaitOccurrences(node) {
          var func = ts2.getContainingFunction(node);
          if (!func) {
            return void 0;
          }
          var keywords = [];
          if (func.modifiers) {
            func.modifiers.forEach(function(modifier) {
              pushKeywordIf(keywords, modifier, 126);
            });
          }
          ts2.forEachChild(func, function(child) {
            traverseWithoutCrossingFunction(child, function(node2) {
              if (ts2.isAwaitExpression(node2)) {
                pushKeywordIf(keywords, node2.getFirstToken(), 127);
              }
            });
          });
          return keywords;
        }
        function getYieldOccurrences(node) {
          var func = ts2.getContainingFunction(node);
          if (!func) {
            return void 0;
          }
          var keywords = [];
          ts2.forEachChild(func, function(child) {
            traverseWithoutCrossingFunction(child, function(node2) {
              if (ts2.isYieldExpression(node2)) {
                pushKeywordIf(keywords, node2.getFirstToken(), 121);
              }
            });
          });
          return keywords;
        }
        function traverseWithoutCrossingFunction(node, cb) {
          cb(node);
          if (!ts2.isFunctionLike(node) && !ts2.isClassLike(node) && !ts2.isInterfaceDeclaration(node) && !ts2.isModuleDeclaration(node) && !ts2.isTypeAliasDeclaration(node) && !ts2.isTypeNode(node)) {
            ts2.forEachChild(node, function(child) {
              return traverseWithoutCrossingFunction(child, cb);
            });
          }
        }
        function getIfElseOccurrences(ifStatement, sourceFile) {
          var keywords = getIfElseKeywords(ifStatement, sourceFile);
          var result = [];
          for (var i = 0; i < keywords.length; i++) {
            if (keywords[i].kind === 87 && i < keywords.length - 1) {
              var elseKeyword = keywords[i];
              var ifKeyword = keywords[i + 1];
              var shouldCombineElseAndIf = true;
              for (var j = ifKeyword.getStart(sourceFile) - 1; j >= elseKeyword.end; j--) {
                if (!ts2.isWhiteSpaceSingleLine(sourceFile.text.charCodeAt(j))) {
                  shouldCombineElseAndIf = false;
                  break;
                }
              }
              if (shouldCombineElseAndIf) {
                result.push({
                  fileName: sourceFile.fileName,
                  textSpan: ts2.createTextSpanFromBounds(elseKeyword.getStart(), ifKeyword.end),
                  kind: "reference"
                });
                i++;
                continue;
              }
            }
            result.push(getHighlightSpanForNode(keywords[i], sourceFile));
          }
          return result;
        }
        function getIfElseKeywords(ifStatement, sourceFile) {
          var keywords = [];
          while (ts2.isIfStatement(ifStatement.parent) && ifStatement.parent.elseStatement === ifStatement) {
            ifStatement = ifStatement.parent;
          }
          while (true) {
            var children = ifStatement.getChildren(sourceFile);
            pushKeywordIf(keywords, children[0], 95);
            for (var i = children.length - 1; i >= 0; i--) {
              if (pushKeywordIf(keywords, children[i], 87)) {
                break;
              }
            }
            if (!ifStatement.elseStatement || !ts2.isIfStatement(ifStatement.elseStatement)) {
              break;
            }
            ifStatement = ifStatement.elseStatement;
          }
          return keywords;
        }
        function isLabeledBy(node, labelName) {
          return !!ts2.findAncestor(node.parent, function(owner) {
            return !ts2.isLabeledStatement(owner) ? "quit" : owner.label.escapedText === labelName;
          });
        }
      })(DocumentHighlights = ts2.DocumentHighlights || (ts2.DocumentHighlights = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function createDocumentRegistry(useCaseSensitiveFileNames, currentDirectory) {
        return createDocumentRegistryInternal(useCaseSensitiveFileNames, currentDirectory);
      }
      ts2.createDocumentRegistry = createDocumentRegistry;
      function createDocumentRegistryInternal(useCaseSensitiveFileNames, currentDirectory, externalCache) {
        if (currentDirectory === void 0) {
          currentDirectory = "";
        }
        var buckets = ts2.createMap();
        var getCanonicalFileName = ts2.createGetCanonicalFileName(!!useCaseSensitiveFileNames);
        function reportStats() {
          var bucketInfoArray = ts2.arrayFrom(buckets.keys()).filter(function(name) {
            return name && name.charAt(0) === "_";
          }).map(function(name) {
            var entries = buckets.get(name);
            var sourceFiles = [];
            entries.forEach(function(entry, name2) {
              sourceFiles.push({
                name: name2,
                refCount: entry.languageServiceRefCount
              });
            });
            sourceFiles.sort(function(x, y) {
              return y.refCount - x.refCount;
            });
            return {
              bucket: name,
              sourceFiles
            };
          });
          return JSON.stringify(bucketInfoArray, void 0, 2);
        }
        function acquireDocument(fileName, compilationSettings, scriptSnapshot, version, scriptKind) {
          var path2 = ts2.toPath(fileName, currentDirectory, getCanonicalFileName);
          var key = getKeyForCompilationSettings(compilationSettings);
          return acquireDocumentWithKey(fileName, path2, compilationSettings, key, scriptSnapshot, version, scriptKind);
        }
        function acquireDocumentWithKey(fileName, path2, compilationSettings, key, scriptSnapshot, version, scriptKind) {
          return acquireOrUpdateDocument(fileName, path2, compilationSettings, key, scriptSnapshot, version, true, scriptKind);
        }
        function updateDocument(fileName, compilationSettings, scriptSnapshot, version, scriptKind) {
          var path2 = ts2.toPath(fileName, currentDirectory, getCanonicalFileName);
          var key = getKeyForCompilationSettings(compilationSettings);
          return updateDocumentWithKey(fileName, path2, compilationSettings, key, scriptSnapshot, version, scriptKind);
        }
        function updateDocumentWithKey(fileName, path2, compilationSettings, key, scriptSnapshot, version, scriptKind) {
          return acquireOrUpdateDocument(fileName, path2, compilationSettings, key, scriptSnapshot, version, false, scriptKind);
        }
        function acquireOrUpdateDocument(fileName, path2, compilationSettings, key, scriptSnapshot, version, acquiring, scriptKind) {
          var bucket = ts2.getOrUpdate(buckets, key, ts2.createMap);
          var entry = bucket.get(path2);
          var scriptTarget = scriptKind === 6 ? 100 : compilationSettings.target || 1;
          if (!entry && externalCache) {
            var sourceFile = externalCache.getDocument(key, path2);
            if (sourceFile) {
              ts2.Debug.assert(acquiring);
              entry = {
                sourceFile,
                languageServiceRefCount: 0
              };
              bucket.set(path2, entry);
            }
          }
          if (!entry) {
            var sourceFile = ts2.createLanguageServiceSourceFile(fileName, scriptSnapshot, scriptTarget, version, false, scriptKind);
            if (externalCache) {
              externalCache.setDocument(key, path2, sourceFile);
            }
            entry = {
              sourceFile,
              languageServiceRefCount: 1
            };
            bucket.set(path2, entry);
          } else {
            if (entry.sourceFile.version !== version) {
              entry.sourceFile = ts2.updateLanguageServiceSourceFile(entry.sourceFile, scriptSnapshot, version, scriptSnapshot.getChangeRange(entry.sourceFile.scriptSnapshot));
              if (externalCache) {
                externalCache.setDocument(key, path2, entry.sourceFile);
              }
            }
            if (acquiring) {
              entry.languageServiceRefCount++;
            }
          }
          ts2.Debug.assert(entry.languageServiceRefCount !== 0);
          return entry.sourceFile;
        }
        function releaseDocument(fileName, compilationSettings) {
          var path2 = ts2.toPath(fileName, currentDirectory, getCanonicalFileName);
          var key = getKeyForCompilationSettings(compilationSettings);
          return releaseDocumentWithKey(path2, key);
        }
        function releaseDocumentWithKey(path2, key) {
          var bucket = ts2.Debug.checkDefined(buckets.get(key));
          var entry = bucket.get(path2);
          entry.languageServiceRefCount--;
          ts2.Debug.assert(entry.languageServiceRefCount >= 0);
          if (entry.languageServiceRefCount === 0) {
            bucket.delete(path2);
          }
        }
        function getLanguageServiceRefCounts(path2) {
          return ts2.arrayFrom(buckets.entries(), function(_a) {
            var key = _a[0], bucket = _a[1];
            var entry = bucket.get(path2);
            return [key, entry && entry.languageServiceRefCount];
          });
        }
        return {
          acquireDocument,
          acquireDocumentWithKey,
          updateDocument,
          updateDocumentWithKey,
          releaseDocument,
          releaseDocumentWithKey,
          getLanguageServiceRefCounts,
          reportStats,
          getKeyForCompilationSettings
        };
      }
      ts2.createDocumentRegistryInternal = createDocumentRegistryInternal;
      function getKeyForCompilationSettings(settings) {
        return ts2.sourceFileAffectingCompilerOptions.map(function(option) {
          return ts2.getCompilerOptionValue(settings, option);
        }).join("|");
      }
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var FindAllReferences;
      (function(FindAllReferences2) {
        function createImportTracker(sourceFiles, sourceFilesSet, checker, cancellationToken) {
          var allDirectImports = getDirectImportsMap(sourceFiles, checker, cancellationToken);
          return function(exportSymbol, exportInfo, isForRename) {
            var _a = getImportersForExport(sourceFiles, sourceFilesSet, allDirectImports, exportInfo, checker, cancellationToken), directImports = _a.directImports, indirectUsers = _a.indirectUsers;
            return __assign({ indirectUsers }, getSearchesFromDirectImports(directImports, exportSymbol, exportInfo.exportKind, checker, isForRename));
          };
        }
        FindAllReferences2.createImportTracker = createImportTracker;
        var ExportKind;
        (function(ExportKind2) {
          ExportKind2[ExportKind2["Named"] = 0] = "Named";
          ExportKind2[ExportKind2["Default"] = 1] = "Default";
          ExportKind2[ExportKind2["ExportEquals"] = 2] = "ExportEquals";
        })(ExportKind = FindAllReferences2.ExportKind || (FindAllReferences2.ExportKind = {}));
        var ImportExport;
        (function(ImportExport2) {
          ImportExport2[ImportExport2["Import"] = 0] = "Import";
          ImportExport2[ImportExport2["Export"] = 1] = "Export";
        })(ImportExport = FindAllReferences2.ImportExport || (FindAllReferences2.ImportExport = {}));
        function getImportersForExport(sourceFiles, sourceFilesSet, allDirectImports, _a, checker, cancellationToken) {
          var exportingModuleSymbol = _a.exportingModuleSymbol, exportKind = _a.exportKind;
          var markSeenDirectImport = ts2.nodeSeenTracker();
          var markSeenIndirectUser = ts2.nodeSeenTracker();
          var directImports = [];
          var isAvailableThroughGlobal = !!exportingModuleSymbol.globalExports;
          var indirectUserDeclarations = isAvailableThroughGlobal ? void 0 : [];
          handleDirectImports(exportingModuleSymbol);
          return { directImports, indirectUsers: getIndirectUsers() };
          function getIndirectUsers() {
            if (isAvailableThroughGlobal) {
              return sourceFiles;
            }
            for (var _i = 0, _a2 = exportingModuleSymbol.declarations; _i < _a2.length; _i++) {
              var decl = _a2[_i];
              if (ts2.isExternalModuleAugmentation(decl) && sourceFilesSet.has(decl.getSourceFile().fileName)) {
                addIndirectUser(decl);
              }
            }
            return indirectUserDeclarations.map(ts2.getSourceFileOfNode);
          }
          function handleDirectImports(exportingModuleSymbol2) {
            var theseDirectImports = getDirectImports(exportingModuleSymbol2);
            if (theseDirectImports) {
              for (var _i = 0, theseDirectImports_1 = theseDirectImports; _i < theseDirectImports_1.length; _i++) {
                var direct = theseDirectImports_1[_i];
                if (!markSeenDirectImport(direct)) {
                  continue;
                }
                if (cancellationToken)
                  cancellationToken.throwIfCancellationRequested();
                switch (direct.kind) {
                  case 196:
                    if (!isAvailableThroughGlobal) {
                      var parent = direct.parent;
                      if (exportKind === 2 && parent.kind === 242) {
                        var name = parent.name;
                        if (name.kind === 75) {
                          directImports.push(name);
                          break;
                        }
                      }
                      addIndirectUser(direct.getSourceFile());
                    }
                    break;
                  case 75:
                    break;
                  case 253:
                    handleNamespaceImport(direct, direct.name, ts2.hasModifier(direct, 1), false);
                    break;
                  case 254:
                    directImports.push(direct);
                    var namedBindings = direct.importClause && direct.importClause.namedBindings;
                    if (namedBindings && namedBindings.kind === 256) {
                      handleNamespaceImport(direct, namedBindings.name, false, true);
                    } else if (!isAvailableThroughGlobal && ts2.isDefaultImport(direct)) {
                      addIndirectUser(getSourceFileLikeForImportDeclaration(direct));
                    }
                    break;
                  case 260:
                    if (!direct.exportClause) {
                      handleDirectImports(getContainingModuleSymbol(direct, checker));
                    } else {
                      directImports.push(direct);
                    }
                    break;
                  case 188:
                    directImports.push(direct);
                    break;
                  default:
                    ts2.Debug.failBadSyntaxKind(direct, "Unexpected import kind.");
                }
              }
            }
          }
          function handleNamespaceImport(importDeclaration, name, isReExport, alreadyAddedDirect) {
            if (exportKind === 2) {
              if (!alreadyAddedDirect)
                directImports.push(importDeclaration);
            } else if (!isAvailableThroughGlobal) {
              var sourceFileLike = getSourceFileLikeForImportDeclaration(importDeclaration);
              ts2.Debug.assert(sourceFileLike.kind === 290 || sourceFileLike.kind === 249);
              if (isReExport || findNamespaceReExports(sourceFileLike, name, checker)) {
                addIndirectUsers(sourceFileLike);
              } else {
                addIndirectUser(sourceFileLike);
              }
            }
          }
          function addIndirectUser(sourceFileLike) {
            ts2.Debug.assert(!isAvailableThroughGlobal);
            var isNew = markSeenIndirectUser(sourceFileLike);
            if (isNew) {
              indirectUserDeclarations.push(sourceFileLike);
            }
            return isNew;
          }
          function addIndirectUsers(sourceFileLike) {
            if (!addIndirectUser(sourceFileLike)) {
              return;
            }
            var moduleSymbol = checker.getMergedSymbol(sourceFileLike.symbol);
            ts2.Debug.assert(!!(moduleSymbol.flags & 1536));
            var directImports2 = getDirectImports(moduleSymbol);
            if (directImports2) {
              for (var _i = 0, directImports_1 = directImports2; _i < directImports_1.length; _i++) {
                var directImport = directImports_1[_i];
                if (!ts2.isImportTypeNode(directImport)) {
                  addIndirectUsers(getSourceFileLikeForImportDeclaration(directImport));
                }
              }
            }
          }
          function getDirectImports(moduleSymbol) {
            return allDirectImports.get(ts2.getSymbolId(moduleSymbol).toString());
          }
        }
        function getSearchesFromDirectImports(directImports, exportSymbol, exportKind, checker, isForRename) {
          var importSearches = [];
          var singleReferences = [];
          function addSearch(location, symbol) {
            importSearches.push([location, symbol]);
          }
          if (directImports) {
            for (var _i = 0, directImports_2 = directImports; _i < directImports_2.length; _i++) {
              var decl = directImports_2[_i];
              handleImport(decl);
            }
          }
          return { importSearches, singleReferences };
          function handleImport(decl2) {
            if (decl2.kind === 253) {
              if (isExternalModuleImportEquals(decl2)) {
                handleNamespaceImportLike(decl2.name);
              }
              return;
            }
            if (decl2.kind === 75) {
              handleNamespaceImportLike(decl2);
              return;
            }
            if (decl2.kind === 188) {
              if (decl2.qualifier) {
                var firstIdentifier = ts2.getFirstIdentifier(decl2.qualifier);
                if (firstIdentifier.escapedText === ts2.symbolName(exportSymbol)) {
                  singleReferences.push(firstIdentifier);
                }
              } else if (exportKind === 2) {
                singleReferences.push(decl2.argument.literal);
              }
              return;
            }
            if (decl2.moduleSpecifier.kind !== 10) {
              return;
            }
            if (decl2.kind === 260) {
              if (decl2.exportClause && ts2.isNamedExports(decl2.exportClause)) {
                searchForNamedImport(decl2.exportClause);
              }
              return;
            }
            var _a = decl2.importClause || { name: void 0, namedBindings: void 0 }, name = _a.name, namedBindings = _a.namedBindings;
            if (namedBindings) {
              switch (namedBindings.kind) {
                case 256:
                  handleNamespaceImportLike(namedBindings.name);
                  break;
                case 257:
                  if (exportKind === 0 || exportKind === 1) {
                    searchForNamedImport(namedBindings);
                  }
                  break;
                default:
                  ts2.Debug.assertNever(namedBindings);
              }
            }
            if (name && (exportKind === 1 || exportKind === 2) && (!isForRename || name.escapedText === ts2.symbolEscapedNameNoDefault(exportSymbol))) {
              var defaultImportAlias = checker.getSymbolAtLocation(name);
              addSearch(name, defaultImportAlias);
            }
          }
          function handleNamespaceImportLike(importName) {
            if (exportKind === 2 && (!isForRename || isNameMatch(importName.escapedText))) {
              addSearch(importName, checker.getSymbolAtLocation(importName));
            }
          }
          function searchForNamedImport(namedBindings) {
            if (!namedBindings) {
              return;
            }
            for (var _i2 = 0, _a = namedBindings.elements; _i2 < _a.length; _i2++) {
              var element = _a[_i2];
              var name = element.name, propertyName = element.propertyName;
              if (!isNameMatch((propertyName || name).escapedText)) {
                continue;
              }
              if (propertyName) {
                singleReferences.push(propertyName);
                if (!isForRename || name.escapedText === exportSymbol.escapedName) {
                  addSearch(name, checker.getSymbolAtLocation(name));
                }
              } else {
                var localSymbol = element.kind === 263 && element.propertyName ? checker.getExportSpecifierLocalTargetSymbol(element) : checker.getSymbolAtLocation(name);
                addSearch(name, localSymbol);
              }
            }
          }
          function isNameMatch(name) {
            return name === exportSymbol.escapedName || exportKind !== 0 && name === "default";
          }
        }
        function findNamespaceReExports(sourceFileLike, name, checker) {
          var namespaceImportSymbol = checker.getSymbolAtLocation(name);
          return !!forEachPossibleImportOrExportStatement(sourceFileLike, function(statement) {
            if (!ts2.isExportDeclaration(statement))
              return;
            var exportClause = statement.exportClause, moduleSpecifier = statement.moduleSpecifier;
            return !moduleSpecifier && exportClause && ts2.isNamedExports(exportClause) && exportClause.elements.some(function(element) {
              return checker.getExportSpecifierLocalTargetSymbol(element) === namespaceImportSymbol;
            });
          });
        }
        function findModuleReferences(program, sourceFiles, searchModuleSymbol) {
          var refs = [];
          var checker = program.getTypeChecker();
          for (var _i = 0, sourceFiles_1 = sourceFiles; _i < sourceFiles_1.length; _i++) {
            var referencingFile = sourceFiles_1[_i];
            var searchSourceFile = searchModuleSymbol.valueDeclaration;
            if (searchSourceFile.kind === 290) {
              for (var _a = 0, _b = referencingFile.referencedFiles; _a < _b.length; _a++) {
                var ref = _b[_a];
                if (program.getSourceFileFromReference(referencingFile, ref) === searchSourceFile) {
                  refs.push({ kind: "reference", referencingFile, ref });
                }
              }
              for (var _c = 0, _d = referencingFile.typeReferenceDirectives; _c < _d.length; _c++) {
                var ref = _d[_c];
                var referenced = program.getResolvedTypeReferenceDirectives().get(ref.fileName);
                if (referenced !== void 0 && referenced.resolvedFileName === searchSourceFile.fileName) {
                  refs.push({ kind: "reference", referencingFile, ref });
                }
              }
            }
            forEachImport(referencingFile, function(_importDecl, moduleSpecifier) {
              var moduleSymbol = checker.getSymbolAtLocation(moduleSpecifier);
              if (moduleSymbol === searchModuleSymbol) {
                refs.push({ kind: "import", literal: moduleSpecifier });
              }
            });
          }
          return refs;
        }
        FindAllReferences2.findModuleReferences = findModuleReferences;
        function getDirectImportsMap(sourceFiles, checker, cancellationToken) {
          var map = ts2.createMap();
          for (var _i = 0, sourceFiles_2 = sourceFiles; _i < sourceFiles_2.length; _i++) {
            var sourceFile = sourceFiles_2[_i];
            if (cancellationToken)
              cancellationToken.throwIfCancellationRequested();
            forEachImport(sourceFile, function(importDecl, moduleSpecifier) {
              var moduleSymbol = checker.getSymbolAtLocation(moduleSpecifier);
              if (moduleSymbol) {
                var id = ts2.getSymbolId(moduleSymbol).toString();
                var imports = map.get(id);
                if (!imports) {
                  map.set(id, imports = []);
                }
                imports.push(importDecl);
              }
            });
          }
          return map;
        }
        function forEachPossibleImportOrExportStatement(sourceFileLike, action) {
          return ts2.forEach(sourceFileLike.kind === 290 ? sourceFileLike.statements : sourceFileLike.body.statements, function(statement) {
            return action(statement) || isAmbientModuleDeclaration(statement) && ts2.forEach(statement.body && statement.body.statements, action);
          });
        }
        function forEachImport(sourceFile, action) {
          if (sourceFile.externalModuleIndicator || sourceFile.imports !== void 0) {
            for (var _i = 0, _a = sourceFile.imports; _i < _a.length; _i++) {
              var i = _a[_i];
              action(ts2.importFromModuleSpecifier(i), i);
            }
          } else {
            forEachPossibleImportOrExportStatement(sourceFile, function(statement) {
              switch (statement.kind) {
                case 260:
                case 254: {
                  var decl = statement;
                  if (decl.moduleSpecifier && ts2.isStringLiteral(decl.moduleSpecifier)) {
                    action(decl, decl.moduleSpecifier);
                  }
                  break;
                }
                case 253: {
                  var decl = statement;
                  if (isExternalModuleImportEquals(decl)) {
                    action(decl, decl.moduleReference.expression);
                  }
                  break;
                }
              }
            });
          }
        }
        function getImportOrExportSymbol(node, symbol, checker, comingFromExport) {
          return comingFromExport ? getExport() : getExport() || getImport();
          function getExport() {
            var parent = node.parent;
            var grandParent = parent.parent;
            if (symbol.exportSymbol) {
              if (parent.kind === 194) {
                return symbol.declarations.some(function(d) {
                  return d === parent;
                }) && ts2.isBinaryExpression(grandParent) ? getSpecialPropertyExport(grandParent, false) : void 0;
              } else {
                return exportInfo(symbol.exportSymbol, getExportKindForDeclaration(parent));
              }
            } else {
              var exportNode = getExportNode(parent, node);
              if (exportNode && ts2.hasModifier(exportNode, 1)) {
                if (ts2.isImportEqualsDeclaration(exportNode) && exportNode.moduleReference === node) {
                  if (comingFromExport) {
                    return void 0;
                  }
                  var lhsSymbol = checker.getSymbolAtLocation(exportNode.name);
                  return { kind: 0, symbol: lhsSymbol };
                } else {
                  return exportInfo(symbol, getExportKindForDeclaration(exportNode));
                }
              } else if (ts2.isExportAssignment(parent)) {
                return getExportAssignmentExport(parent);
              } else if (ts2.isExportAssignment(grandParent)) {
                return getExportAssignmentExport(grandParent);
              } else if (ts2.isBinaryExpression(parent)) {
                return getSpecialPropertyExport(parent, true);
              } else if (ts2.isBinaryExpression(grandParent)) {
                return getSpecialPropertyExport(grandParent, true);
              } else if (ts2.isJSDocTypedefTag(parent)) {
                return exportInfo(symbol, 0);
              }
            }
            function getExportAssignmentExport(ex) {
              var exportingModuleSymbol = ts2.Debug.checkDefined(ex.symbol.parent, "Expected export symbol to have a parent");
              var exportKind = ex.isExportEquals ? 2 : 1;
              return { kind: 1, symbol, exportInfo: { exportingModuleSymbol, exportKind } };
            }
            function getSpecialPropertyExport(node2, useLhsSymbol) {
              var kind;
              switch (ts2.getAssignmentDeclarationKind(node2)) {
                case 1:
                  kind = 0;
                  break;
                case 2:
                  kind = 2;
                  break;
                default:
                  return void 0;
              }
              var sym = useLhsSymbol ? checker.getSymbolAtLocation(ts2.getNameOfAccessExpression(ts2.cast(node2.left, ts2.isAccessExpression))) : symbol;
              return sym && exportInfo(sym, kind);
            }
          }
          function getImport() {
            var isImport = isNodeImport(node);
            if (!isImport)
              return void 0;
            var importedSymbol = checker.getImmediateAliasedSymbol(symbol);
            if (!importedSymbol)
              return void 0;
            importedSymbol = skipExportSpecifierSymbol(importedSymbol, checker);
            if (importedSymbol.escapedName === "export=") {
              importedSymbol = getExportEqualsLocalSymbol(importedSymbol, checker);
            }
            var importedName = ts2.symbolEscapedNameNoDefault(importedSymbol);
            if (importedName === void 0 || importedName === "default" || importedName === symbol.escapedName) {
              return { kind: 0, symbol: importedSymbol };
            }
          }
          function exportInfo(symbol2, kind) {
            var exportInfo2 = getExportInfo(symbol2, kind, checker);
            return exportInfo2 && { kind: 1, symbol: symbol2, exportInfo: exportInfo2 };
          }
          function getExportKindForDeclaration(node2) {
            return ts2.hasModifier(node2, 512) ? 1 : 0;
          }
        }
        FindAllReferences2.getImportOrExportSymbol = getImportOrExportSymbol;
        function getExportEqualsLocalSymbol(importedSymbol, checker) {
          if (importedSymbol.flags & 2097152) {
            return ts2.Debug.checkDefined(checker.getImmediateAliasedSymbol(importedSymbol));
          }
          var decl = importedSymbol.valueDeclaration;
          if (ts2.isExportAssignment(decl)) {
            return ts2.Debug.checkDefined(decl.expression.symbol);
          } else if (ts2.isBinaryExpression(decl)) {
            return ts2.Debug.checkDefined(decl.right.symbol);
          } else if (ts2.isSourceFile(decl)) {
            return ts2.Debug.checkDefined(decl.symbol);
          }
          return ts2.Debug.fail();
        }
        function getExportNode(parent, node) {
          var declaration = ts2.isVariableDeclaration(parent) ? parent : ts2.isBindingElement(parent) ? ts2.walkUpBindingElementsAndPatterns(parent) : void 0;
          if (declaration) {
            return parent.name !== node ? void 0 : ts2.isCatchClause(declaration.parent) ? void 0 : ts2.isVariableStatement(declaration.parent.parent) ? declaration.parent.parent : void 0;
          } else {
            return parent;
          }
        }
        function isNodeImport(node) {
          var parent = node.parent;
          switch (parent.kind) {
            case 253:
              return parent.name === node && isExternalModuleImportEquals(parent);
            case 258:
              return !parent.propertyName;
            case 255:
            case 256:
              ts2.Debug.assert(parent.name === node);
              return true;
            default:
              return false;
          }
        }
        function getExportInfo(exportSymbol, exportKind, checker) {
          var moduleSymbol = exportSymbol.parent;
          if (!moduleSymbol)
            return void 0;
          var exportingModuleSymbol = checker.getMergedSymbol(moduleSymbol);
          return ts2.isExternalModuleSymbol(exportingModuleSymbol) ? { exportingModuleSymbol, exportKind } : void 0;
        }
        FindAllReferences2.getExportInfo = getExportInfo;
        function skipExportSpecifierSymbol(symbol, checker) {
          if (symbol.declarations) {
            for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
              var declaration = _a[_i];
              if (ts2.isExportSpecifier(declaration) && !declaration.propertyName && !declaration.parent.parent.moduleSpecifier) {
                return checker.getExportSpecifierLocalTargetSymbol(declaration);
              }
            }
          }
          return symbol;
        }
        function getContainingModuleSymbol(importer, checker) {
          return checker.getMergedSymbol(getSourceFileLikeForImportDeclaration(importer).symbol);
        }
        function getSourceFileLikeForImportDeclaration(node) {
          if (node.kind === 196) {
            return node.getSourceFile();
          }
          var parent = node.parent;
          if (parent.kind === 290) {
            return parent;
          }
          ts2.Debug.assert(parent.kind === 250);
          return ts2.cast(parent.parent, isAmbientModuleDeclaration);
        }
        function isAmbientModuleDeclaration(node) {
          return node.kind === 249 && node.name.kind === 10;
        }
        function isExternalModuleImportEquals(eq) {
          return eq.moduleReference.kind === 265 && eq.moduleReference.expression.kind === 10;
        }
      })(FindAllReferences = ts2.FindAllReferences || (ts2.FindAllReferences = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var FindAllReferences;
      (function(FindAllReferences2) {
        var DefinitionKind;
        (function(DefinitionKind2) {
          DefinitionKind2[DefinitionKind2["Symbol"] = 0] = "Symbol";
          DefinitionKind2[DefinitionKind2["Label"] = 1] = "Label";
          DefinitionKind2[DefinitionKind2["Keyword"] = 2] = "Keyword";
          DefinitionKind2[DefinitionKind2["This"] = 3] = "This";
          DefinitionKind2[DefinitionKind2["String"] = 4] = "String";
        })(DefinitionKind = FindAllReferences2.DefinitionKind || (FindAllReferences2.DefinitionKind = {}));
        var EntryKind;
        (function(EntryKind2) {
          EntryKind2[EntryKind2["Span"] = 0] = "Span";
          EntryKind2[EntryKind2["Node"] = 1] = "Node";
          EntryKind2[EntryKind2["StringLiteral"] = 2] = "StringLiteral";
          EntryKind2[EntryKind2["SearchedLocalFoundProperty"] = 3] = "SearchedLocalFoundProperty";
          EntryKind2[EntryKind2["SearchedPropertyFoundLocal"] = 4] = "SearchedPropertyFoundLocal";
        })(EntryKind = FindAllReferences2.EntryKind || (FindAllReferences2.EntryKind = {}));
        function nodeEntry(node, kind) {
          if (kind === void 0) {
            kind = 1;
          }
          return {
            kind,
            node: node.name || node,
            context: getContextNodeForNodeEntry(node)
          };
        }
        FindAllReferences2.nodeEntry = nodeEntry;
        function isContextWithStartAndEndNode(node) {
          return node && node.kind === void 0;
        }
        FindAllReferences2.isContextWithStartAndEndNode = isContextWithStartAndEndNode;
        function getContextNodeForNodeEntry(node) {
          if (ts2.isDeclaration(node)) {
            return getContextNode(node);
          }
          if (!node.parent)
            return void 0;
          if (!ts2.isDeclaration(node.parent) && !ts2.isExportAssignment(node.parent)) {
            if (ts2.isInJSFile(node)) {
              var binaryExpression = ts2.isBinaryExpression(node.parent) ? node.parent : ts2.isAccessExpression(node.parent) && ts2.isBinaryExpression(node.parent.parent) && node.parent.parent.left === node.parent ? node.parent.parent : void 0;
              if (binaryExpression && ts2.getAssignmentDeclarationKind(binaryExpression) !== 0) {
                return getContextNode(binaryExpression);
              }
            }
            if (ts2.isJsxOpeningElement(node.parent) || ts2.isJsxClosingElement(node.parent)) {
              return node.parent.parent;
            } else if (ts2.isJsxSelfClosingElement(node.parent) || ts2.isLabeledStatement(node.parent) || ts2.isBreakOrContinueStatement(node.parent)) {
              return node.parent;
            } else if (ts2.isStringLiteralLike(node)) {
              var validImport = ts2.tryGetImportFromModuleSpecifier(node);
              if (validImport) {
                var declOrStatement = ts2.findAncestor(validImport, function(node2) {
                  return ts2.isDeclaration(node2) || ts2.isStatement(node2) || ts2.isJSDocTag(node2);
                });
                return ts2.isDeclaration(declOrStatement) ? getContextNode(declOrStatement) : declOrStatement;
              }
            }
            var propertyName = ts2.findAncestor(node, ts2.isComputedPropertyName);
            return propertyName ? getContextNode(propertyName.parent) : void 0;
          }
          if (node.parent.name === node || ts2.isConstructorDeclaration(node.parent) || ts2.isExportAssignment(node.parent) || (ts2.isImportOrExportSpecifier(node.parent) || ts2.isBindingElement(node.parent)) && node.parent.propertyName === node || node.kind === 84 && ts2.hasModifier(node.parent, 513)) {
            return getContextNode(node.parent);
          }
          return void 0;
        }
        function getContextNode(node) {
          if (!node)
            return void 0;
          switch (node.kind) {
            case 242:
              return !ts2.isVariableDeclarationList(node.parent) || node.parent.declarations.length !== 1 ? node : ts2.isVariableStatement(node.parent.parent) ? node.parent.parent : ts2.isForInOrOfStatement(node.parent.parent) ? getContextNode(node.parent.parent) : node.parent;
            case 191:
              return getContextNode(node.parent.parent);
            case 258:
              return node.parent.parent.parent;
            case 263:
            case 256:
              return node.parent.parent;
            case 255:
              return node.parent;
            case 209:
              return ts2.isExpressionStatement(node.parent) ? node.parent : node;
            case 232:
            case 231:
              return {
                start: node.initializer,
                end: node.expression
              };
            case 281:
            case 282:
              return ts2.isArrayLiteralOrObjectLiteralDestructuringPattern(node.parent) ? getContextNode(ts2.findAncestor(node.parent, function(node2) {
                return ts2.isBinaryExpression(node2) || ts2.isForInOrOfStatement(node2);
              })) : node;
            default:
              return node;
          }
        }
        FindAllReferences2.getContextNode = getContextNode;
        function toContextSpan(textSpan, sourceFile, context) {
          if (!context)
            return void 0;
          var contextSpan = isContextWithStartAndEndNode(context) ? getTextSpan(context.start, sourceFile, context.end) : getTextSpan(context, sourceFile);
          return contextSpan.start !== textSpan.start || contextSpan.length !== textSpan.length ? { contextSpan } : void 0;
        }
        FindAllReferences2.toContextSpan = toContextSpan;
        var FindReferencesUse;
        (function(FindReferencesUse2) {
          FindReferencesUse2[FindReferencesUse2["Other"] = 0] = "Other";
          FindReferencesUse2[FindReferencesUse2["References"] = 1] = "References";
          FindReferencesUse2[FindReferencesUse2["Rename"] = 2] = "Rename";
        })(FindReferencesUse = FindAllReferences2.FindReferencesUse || (FindAllReferences2.FindReferencesUse = {}));
        function findReferencedSymbols(program, cancellationToken, sourceFiles, sourceFile, position) {
          var node = ts2.getTouchingPropertyName(sourceFile, position);
          var referencedSymbols = Core.getReferencedSymbolsForNode(position, node, program, sourceFiles, cancellationToken, { use: 1 });
          var checker = program.getTypeChecker();
          return !referencedSymbols || !referencedSymbols.length ? void 0 : ts2.mapDefined(referencedSymbols, function(_a) {
            var definition = _a.definition, references = _a.references;
            return definition && {
              definition: checker.runWithCancellationToken(cancellationToken, function(checker2) {
                return definitionToReferencedSymbolDefinitionInfo(definition, checker2, node);
              }),
              references: references.map(toReferenceEntry)
            };
          });
        }
        FindAllReferences2.findReferencedSymbols = findReferencedSymbols;
        function getImplementationsAtPosition(program, cancellationToken, sourceFiles, sourceFile, position) {
          var node = ts2.getTouchingPropertyName(sourceFile, position);
          var referenceEntries;
          var entries = getImplementationReferenceEntries(program, cancellationToken, sourceFiles, node, position);
          if (node.parent.kind === 194 || node.parent.kind === 191 || node.parent.kind === 195 || node.kind === 102) {
            referenceEntries = entries && __spreadArrays(entries);
          } else {
            var queue = entries && __spreadArrays(entries);
            var seenNodes = ts2.createMap();
            while (queue && queue.length) {
              var entry = queue.shift();
              if (!ts2.addToSeen(seenNodes, ts2.getNodeId(entry.node))) {
                continue;
              }
              referenceEntries = ts2.append(referenceEntries, entry);
              var entries_1 = getImplementationReferenceEntries(program, cancellationToken, sourceFiles, entry.node, entry.node.pos);
              if (entries_1) {
                queue.push.apply(queue, entries_1);
              }
            }
          }
          var checker = program.getTypeChecker();
          return ts2.map(referenceEntries, function(entry2) {
            return toImplementationLocation(entry2, checker);
          });
        }
        FindAllReferences2.getImplementationsAtPosition = getImplementationsAtPosition;
        function getImplementationReferenceEntries(program, cancellationToken, sourceFiles, node, position) {
          if (node.kind === 290) {
            return void 0;
          }
          var checker = program.getTypeChecker();
          if (node.parent.kind === 282) {
            var result_1 = [];
            Core.getReferenceEntriesForShorthandPropertyAssignment(node, checker, function(node2) {
              return result_1.push(nodeEntry(node2));
            });
            return result_1;
          } else if (node.kind === 102 || ts2.isSuperProperty(node.parent)) {
            var symbol = checker.getSymbolAtLocation(node);
            return symbol.valueDeclaration && [nodeEntry(symbol.valueDeclaration)];
          } else {
            return getReferenceEntriesForNode(position, node, program, sourceFiles, cancellationToken, { implementations: true, use: 1 });
          }
        }
        function findReferenceOrRenameEntries(program, cancellationToken, sourceFiles, node, position, options, convertEntry) {
          return ts2.map(flattenEntries(Core.getReferencedSymbolsForNode(position, node, program, sourceFiles, cancellationToken, options)), function(entry) {
            return convertEntry(entry, node, program.getTypeChecker());
          });
        }
        FindAllReferences2.findReferenceOrRenameEntries = findReferenceOrRenameEntries;
        function getReferenceEntriesForNode(position, node, program, sourceFiles, cancellationToken, options, sourceFilesSet) {
          if (options === void 0) {
            options = {};
          }
          if (sourceFilesSet === void 0) {
            sourceFilesSet = ts2.arrayToSet(sourceFiles, function(f) {
              return f.fileName;
            });
          }
          return flattenEntries(Core.getReferencedSymbolsForNode(position, node, program, sourceFiles, cancellationToken, options, sourceFilesSet));
        }
        FindAllReferences2.getReferenceEntriesForNode = getReferenceEntriesForNode;
        function flattenEntries(referenceSymbols) {
          return referenceSymbols && ts2.flatMap(referenceSymbols, function(r) {
            return r.references;
          });
        }
        function definitionToReferencedSymbolDefinitionInfo(def, checker, originalNode) {
          var info = function() {
            switch (def.type) {
              case 0: {
                var symbol = def.symbol;
                var _a = getDefinitionKindAndDisplayParts(symbol, checker, originalNode), displayParts_1 = _a.displayParts, kind_1 = _a.kind;
                var name_1 = displayParts_1.map(function(p) {
                  return p.text;
                }).join("");
                var declaration = symbol.declarations ? ts2.first(symbol.declarations) : void 0;
                return {
                  node: declaration ? ts2.getNameOfDeclaration(declaration) || declaration : originalNode,
                  name: name_1,
                  kind: kind_1,
                  displayParts: displayParts_1,
                  context: getContextNode(declaration)
                };
              }
              case 1: {
                var node_1 = def.node;
                return { node: node_1, name: node_1.text, kind: "label", displayParts: [ts2.displayPart(node_1.text, ts2.SymbolDisplayPartKind.text)] };
              }
              case 2: {
                var node_2 = def.node;
                var name_2 = ts2.tokenToString(node_2.kind);
                return { node: node_2, name: name_2, kind: "keyword", displayParts: [{ text: name_2, kind: "keyword" }] };
              }
              case 3: {
                var node_3 = def.node;
                var symbol = checker.getSymbolAtLocation(node_3);
                var displayParts_2 = symbol && ts2.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(checker, symbol, node_3.getSourceFile(), ts2.getContainerNode(node_3), node_3).displayParts || [ts2.textPart("this")];
                return { node: node_3, name: "this", kind: "var", displayParts: displayParts_2 };
              }
              case 4: {
                var node_4 = def.node;
                return { node: node_4, name: node_4.text, kind: "var", displayParts: [ts2.displayPart(ts2.getTextOfNode(node_4), ts2.SymbolDisplayPartKind.stringLiteral)] };
              }
              default:
                return ts2.Debug.assertNever(def);
            }
          }();
          var node = info.node, name = info.name, kind = info.kind, displayParts = info.displayParts, context = info.context;
          var sourceFile = node.getSourceFile();
          var textSpan = getTextSpan(ts2.isComputedPropertyName(node) ? node.expression : node, sourceFile);
          return __assign({
            containerKind: "",
            containerName: "",
            fileName: sourceFile.fileName,
            kind,
            name,
            textSpan,
            displayParts
          }, toContextSpan(textSpan, sourceFile, context));
        }
        function getDefinitionKindAndDisplayParts(symbol, checker, node) {
          var meaning = Core.getIntersectingMeaningFromDeclarations(node, symbol);
          var enclosingDeclaration = symbol.declarations && ts2.firstOrUndefined(symbol.declarations) || node;
          var _a = ts2.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(checker, symbol, enclosingDeclaration.getSourceFile(), enclosingDeclaration, enclosingDeclaration, meaning), displayParts = _a.displayParts, symbolKind = _a.symbolKind;
          return { displayParts, kind: symbolKind };
        }
        function toRenameLocation(entry, originalNode, checker, providePrefixAndSuffixText) {
          return __assign(__assign({}, entryToDocumentSpan(entry)), providePrefixAndSuffixText && getPrefixAndSuffixText(entry, originalNode, checker));
        }
        FindAllReferences2.toRenameLocation = toRenameLocation;
        function toReferenceEntry(entry) {
          var documentSpan = entryToDocumentSpan(entry);
          if (entry.kind === 0) {
            return __assign(__assign({}, documentSpan), { isWriteAccess: false, isDefinition: false });
          }
          var kind = entry.kind, node = entry.node;
          return __assign(__assign({}, documentSpan), { isWriteAccess: isWriteAccessForReference(node), isDefinition: isDefinitionForReference(node), isInString: kind === 2 ? true : void 0 });
        }
        FindAllReferences2.toReferenceEntry = toReferenceEntry;
        function entryToDocumentSpan(entry) {
          if (entry.kind === 0) {
            return { textSpan: entry.textSpan, fileName: entry.fileName };
          } else {
            var sourceFile = entry.node.getSourceFile();
            var textSpan = getTextSpan(entry.node, sourceFile);
            return __assign({ textSpan, fileName: sourceFile.fileName }, toContextSpan(textSpan, sourceFile, entry.context));
          }
        }
        function getPrefixAndSuffixText(entry, originalNode, checker) {
          if (entry.kind !== 0 && ts2.isIdentifier(originalNode)) {
            var node = entry.node, kind = entry.kind;
            var name = originalNode.text;
            var isShorthandAssignment = ts2.isShorthandPropertyAssignment(node.parent);
            if (isShorthandAssignment || ts2.isObjectBindingElementWithoutPropertyName(node.parent) && node.parent.name === node) {
              var prefixColon = { prefixText: name + ": " };
              var suffixColon = { suffixText: ": " + name };
              return kind === 3 ? prefixColon : kind === 4 ? suffixColon : isShorthandAssignment ? suffixColon : prefixColon;
            } else if (ts2.isImportSpecifier(entry.node.parent) && !entry.node.parent.propertyName) {
              var originalSymbol = ts2.isExportSpecifier(originalNode.parent) ? checker.getExportSpecifierLocalTargetSymbol(originalNode.parent) : checker.getSymbolAtLocation(originalNode);
              return ts2.contains(originalSymbol.declarations, entry.node.parent) ? { prefixText: name + " as " } : ts2.emptyOptions;
            } else if (ts2.isExportSpecifier(entry.node.parent) && !entry.node.parent.propertyName) {
              return originalNode === entry.node || checker.getSymbolAtLocation(originalNode) === checker.getSymbolAtLocation(entry.node) ? { prefixText: name + " as " } : { suffixText: " as " + name };
            }
          }
          return ts2.emptyOptions;
        }
        function toImplementationLocation(entry, checker) {
          var documentSpan = entryToDocumentSpan(entry);
          if (entry.kind !== 0) {
            var node = entry.node;
            return __assign(__assign({}, documentSpan), implementationKindDisplayParts(node, checker));
          } else {
            return __assign(__assign({}, documentSpan), { kind: "", displayParts: [] });
          }
        }
        function implementationKindDisplayParts(node, checker) {
          var symbol = checker.getSymbolAtLocation(ts2.isDeclaration(node) && node.name ? node.name : node);
          if (symbol) {
            return getDefinitionKindAndDisplayParts(symbol, checker, node);
          } else if (node.kind === 193) {
            return {
              kind: "interface",
              displayParts: [ts2.punctuationPart(20), ts2.textPart("object literal"), ts2.punctuationPart(21)]
            };
          } else if (node.kind === 214) {
            return {
              kind: "local class",
              displayParts: [ts2.punctuationPart(20), ts2.textPart("anonymous local class"), ts2.punctuationPart(21)]
            };
          } else {
            return { kind: ts2.getNodeKind(node), displayParts: [] };
          }
        }
        function toHighlightSpan(entry) {
          var documentSpan = entryToDocumentSpan(entry);
          if (entry.kind === 0) {
            return {
              fileName: documentSpan.fileName,
              span: {
                textSpan: documentSpan.textSpan,
                kind: "reference"
              }
            };
          }
          var writeAccess = isWriteAccessForReference(entry.node);
          var span = __assign({ textSpan: documentSpan.textSpan, kind: writeAccess ? "writtenReference" : "reference", isInString: entry.kind === 2 ? true : void 0 }, documentSpan.contextSpan && { contextSpan: documentSpan.contextSpan });
          return { fileName: documentSpan.fileName, span };
        }
        FindAllReferences2.toHighlightSpan = toHighlightSpan;
        function getTextSpan(node, sourceFile, endNode) {
          var start = node.getStart(sourceFile);
          var end = (endNode || node).getEnd();
          if (ts2.isStringLiteralLike(node)) {
            ts2.Debug.assert(endNode === void 0);
            start += 1;
            end -= 1;
          }
          return ts2.createTextSpanFromBounds(start, end);
        }
        function getTextSpanOfEntry(entry) {
          return entry.kind === 0 ? entry.textSpan : getTextSpan(entry.node, entry.node.getSourceFile());
        }
        FindAllReferences2.getTextSpanOfEntry = getTextSpanOfEntry;
        function isWriteAccessForReference(node) {
          var decl = ts2.getDeclarationFromName(node);
          return !!decl && declarationIsWriteAccess(decl) || node.kind === 84 || ts2.isWriteAccess(node);
        }
        function isDefinitionForReference(node) {
          return node.kind === 84 || !!ts2.getDeclarationFromName(node) || ts2.isLiteralComputedPropertyDeclarationName(node) || node.kind === 129 && ts2.isConstructorDeclaration(node.parent);
        }
        function declarationIsWriteAccess(decl) {
          if (!!(decl.flags & 8388608))
            return true;
          switch (decl.kind) {
            case 209:
            case 191:
            case 245:
            case 214:
            case 84:
            case 248:
            case 284:
            case 263:
            case 255:
            case 253:
            case 258:
            case 246:
            case 315:
            case 322:
            case 273:
            case 249:
            case 252:
            case 256:
            case 262:
            case 156:
            case 282:
            case 247:
            case 155:
              return true;
            case 281:
              return !ts2.isArrayLiteralOrObjectLiteralDestructuringPattern(decl.parent);
            case 244:
            case 201:
            case 162:
            case 161:
            case 163:
            case 164:
              return !!decl.body;
            case 242:
            case 159:
              return !!decl.initializer || ts2.isCatchClause(decl.parent);
            case 160:
            case 158:
            case 323:
            case 317:
              return false;
            default:
              return ts2.Debug.failBadSyntaxKind(decl);
          }
        }
        var Core;
        (function(Core2) {
          function getReferencedSymbolsForNode(position, node, program, sourceFiles, cancellationToken, options, sourceFilesSet) {
            if (options === void 0) {
              options = {};
            }
            if (sourceFilesSet === void 0) {
              sourceFilesSet = ts2.arrayToSet(sourceFiles, function(f) {
                return f.fileName;
              });
            }
            if (options.use === 1) {
              node = ts2.getAdjustedReferenceLocation(node);
            } else if (options.use === 2) {
              node = ts2.getAdjustedRenameLocation(node);
            }
            if (ts2.isSourceFile(node)) {
              var reference = ts2.GoToDefinition.getReferenceAtPosition(node, position, program);
              var moduleSymbol = reference && program.getTypeChecker().getMergedSymbol(reference.file.symbol);
              return moduleSymbol && getReferencedSymbolsForModule(program, moduleSymbol, false, sourceFiles, sourceFilesSet);
            }
            if (!options.implementations) {
              var special = getReferencedSymbolsSpecial(node, sourceFiles, cancellationToken);
              if (special) {
                return special;
              }
            }
            var checker = program.getTypeChecker();
            var symbol = checker.getSymbolAtLocation(node);
            if (!symbol) {
              return !options.implementations && ts2.isStringLiteral(node) ? getReferencesForStringLiteral(node, sourceFiles, cancellationToken) : void 0;
            }
            if (symbol.escapedName === "export=") {
              return getReferencedSymbolsForModule(program, symbol.parent, false, sourceFiles, sourceFilesSet);
            }
            var moduleReferences = getReferencedSymbolsForModuleIfDeclaredBySourceFile(symbol, program, sourceFiles, cancellationToken, options, sourceFilesSet);
            if (moduleReferences && !(symbol.flags & 33554432)) {
              return moduleReferences;
            }
            var aliasedSymbol = getMergedAliasedSymbolOfNamespaceExportDeclaration(node, symbol, checker);
            var moduleReferencesOfExportTarget = aliasedSymbol && getReferencedSymbolsForModuleIfDeclaredBySourceFile(aliasedSymbol, program, sourceFiles, cancellationToken, options, sourceFilesSet);
            var references = getReferencedSymbolsForSymbol(symbol, node, sourceFiles, sourceFilesSet, checker, cancellationToken, options);
            return mergeReferences(program, moduleReferences, references, moduleReferencesOfExportTarget);
          }
          Core2.getReferencedSymbolsForNode = getReferencedSymbolsForNode;
          function getMergedAliasedSymbolOfNamespaceExportDeclaration(node, symbol, checker) {
            if (node.parent && ts2.isNamespaceExportDeclaration(node.parent)) {
              var aliasedSymbol = checker.getAliasedSymbol(symbol);
              var targetSymbol = checker.getMergedSymbol(aliasedSymbol);
              if (aliasedSymbol !== targetSymbol) {
                return targetSymbol;
              }
            }
            return void 0;
          }
          function getReferencedSymbolsForModuleIfDeclaredBySourceFile(symbol, program, sourceFiles, cancellationToken, options, sourceFilesSet) {
            var moduleSourceFile = symbol.flags & 1536 && symbol.declarations && ts2.find(symbol.declarations, ts2.isSourceFile);
            if (!moduleSourceFile)
              return void 0;
            var exportEquals = symbol.exports.get("export=");
            var moduleReferences = getReferencedSymbolsForModule(program, symbol, !!exportEquals, sourceFiles, sourceFilesSet);
            if (!exportEquals || !sourceFilesSet.has(moduleSourceFile.fileName))
              return moduleReferences;
            var checker = program.getTypeChecker();
            symbol = ts2.skipAlias(exportEquals, checker);
            return mergeReferences(program, moduleReferences, getReferencedSymbolsForSymbol(symbol, void 0, sourceFiles, sourceFilesSet, checker, cancellationToken, options));
          }
          function mergeReferences(program) {
            var referencesToMerge = [];
            for (var _i = 1; _i < arguments.length; _i++) {
              referencesToMerge[_i - 1] = arguments[_i];
            }
            var result;
            for (var _a = 0, referencesToMerge_1 = referencesToMerge; _a < referencesToMerge_1.length; _a++) {
              var references = referencesToMerge_1[_a];
              if (!references || !references.length)
                continue;
              if (!result) {
                result = references;
                continue;
              }
              var _loop_3 = function(entry2) {
                if (!entry2.definition || entry2.definition.type !== 0) {
                  result.push(entry2);
                  return "continue";
                }
                var symbol = entry2.definition.symbol;
                var refIndex = ts2.findIndex(result, function(ref) {
                  return !!ref.definition && ref.definition.type === 0 && ref.definition.symbol === symbol;
                });
                if (refIndex === -1) {
                  result.push(entry2);
                  return "continue";
                }
                var reference = result[refIndex];
                result[refIndex] = {
                  definition: reference.definition,
                  references: reference.references.concat(entry2.references).sort(function(entry1, entry22) {
                    var entry1File = getSourceFileIndexOfEntry(program, entry1);
                    var entry2File = getSourceFileIndexOfEntry(program, entry22);
                    if (entry1File !== entry2File) {
                      return ts2.compareValues(entry1File, entry2File);
                    }
                    var entry1Span = getTextSpanOfEntry(entry1);
                    var entry2Span = getTextSpanOfEntry(entry22);
                    return entry1Span.start !== entry2Span.start ? ts2.compareValues(entry1Span.start, entry2Span.start) : ts2.compareValues(entry1Span.length, entry2Span.length);
                  })
                };
              };
              for (var _b = 0, references_1 = references; _b < references_1.length; _b++) {
                var entry = references_1[_b];
                _loop_3(entry);
              }
            }
            return result;
          }
          function getSourceFileIndexOfEntry(program, entry) {
            var sourceFile = entry.kind === 0 ? program.getSourceFile(entry.fileName) : entry.node.getSourceFile();
            return program.getSourceFiles().indexOf(sourceFile);
          }
          function getReferencedSymbolsForModule(program, symbol, excludeImportTypeOfExportEquals, sourceFiles, sourceFilesSet) {
            ts2.Debug.assert(!!symbol.valueDeclaration);
            var references = ts2.mapDefined(FindAllReferences2.findModuleReferences(program, sourceFiles, symbol), function(reference) {
              if (reference.kind === "import") {
                var parent = reference.literal.parent;
                if (ts2.isLiteralTypeNode(parent)) {
                  var importType = ts2.cast(parent.parent, ts2.isImportTypeNode);
                  if (excludeImportTypeOfExportEquals && !importType.qualifier) {
                    return void 0;
                  }
                }
                return nodeEntry(reference.literal);
              } else {
                return {
                  kind: 0,
                  fileName: reference.referencingFile.fileName,
                  textSpan: ts2.createTextSpanFromRange(reference.ref)
                };
              }
            });
            if (symbol.declarations) {
              for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
                var decl = _a[_i];
                switch (decl.kind) {
                  case 290:
                    break;
                  case 249:
                    if (sourceFilesSet.has(decl.getSourceFile().fileName)) {
                      references.push(nodeEntry(decl.name));
                    }
                    break;
                  default:
                    ts2.Debug.assert(!!(symbol.flags & 33554432), "Expected a module symbol to be declared by a SourceFile or ModuleDeclaration.");
                }
              }
            }
            var exported = symbol.exports.get("export=");
            if (exported) {
              for (var _b = 0, _c = exported.declarations; _b < _c.length; _b++) {
                var decl = _c[_b];
                var sourceFile = decl.getSourceFile();
                if (sourceFilesSet.has(sourceFile.fileName)) {
                  var node = ts2.isBinaryExpression(decl) && ts2.isPropertyAccessExpression(decl.left) ? decl.left.expression : ts2.isExportAssignment(decl) ? ts2.Debug.checkDefined(ts2.findChildOfKind(decl, 89, sourceFile)) : ts2.getNameOfDeclaration(decl) || decl;
                  references.push(nodeEntry(node));
                }
              }
            }
            return references.length ? [{ definition: { type: 0, symbol }, references }] : ts2.emptyArray;
          }
          function isReadonlyTypeOperator(node) {
            return node.kind === 138 && ts2.isTypeOperatorNode(node.parent) && node.parent.operator === 138;
          }
          function getReferencedSymbolsSpecial(node, sourceFiles, cancellationToken) {
            if (ts2.isTypeKeyword(node.kind)) {
              if (node.kind === 110 && ts2.isVoidExpression(node.parent)) {
                return void 0;
              }
              if (node.kind === 138 && !isReadonlyTypeOperator(node)) {
                return void 0;
              }
              return getAllReferencesForKeyword(sourceFiles, node.kind, cancellationToken, node.kind === 138 ? isReadonlyTypeOperator : void 0);
            }
            if (ts2.isJumpStatementTarget(node)) {
              var labelDefinition = ts2.getTargetLabel(node.parent, node.text);
              return labelDefinition && getLabelReferencesInNode(labelDefinition.parent, labelDefinition);
            } else if (ts2.isLabelOfLabeledStatement(node)) {
              return getLabelReferencesInNode(node.parent, node);
            }
            if (ts2.isThis(node)) {
              return getReferencesForThisKeyword(node, sourceFiles, cancellationToken);
            }
            if (node.kind === 102) {
              return getReferencesForSuperKeyword(node);
            }
            return void 0;
          }
          function getReferencedSymbolsForSymbol(originalSymbol, node, sourceFiles, sourceFilesSet, checker, cancellationToken, options) {
            var symbol = node && skipPastExportOrImportSpecifierOrUnion(originalSymbol, node, checker, !isForRenameWithPrefixAndSuffixText(options)) || originalSymbol;
            var searchMeaning = node ? getIntersectingMeaningFromDeclarations(node, symbol) : 7;
            var result = [];
            var state = new State(sourceFiles, sourceFilesSet, node ? getSpecialSearchKind(node) : 0, checker, cancellationToken, searchMeaning, options, result);
            var exportSpecifier = !isForRenameWithPrefixAndSuffixText(options) ? void 0 : ts2.find(symbol.declarations, ts2.isExportSpecifier);
            if (exportSpecifier) {
              getReferencesAtExportSpecifier(exportSpecifier.name, symbol, exportSpecifier, state.createSearch(node, originalSymbol, void 0), state, true, true);
            } else if (node && node.kind === 84) {
              addReference(node, symbol, state);
              searchForImportsOfExport(node, symbol, { exportingModuleSymbol: ts2.Debug.checkDefined(symbol.parent, "Expected export symbol to have a parent"), exportKind: 1 }, state);
            } else {
              var search = state.createSearch(node, symbol, void 0, { allSearchSymbols: node ? populateSearchSymbolSet(symbol, node, checker, options.use === 2, !!options.providePrefixAndSuffixTextForRename, !!options.implementations) : [symbol] });
              getReferencesInContainerOrFiles(symbol, state, search);
            }
            return result;
          }
          function getReferencesInContainerOrFiles(symbol, state, search) {
            var scope = getSymbolScope(symbol);
            if (scope) {
              getReferencesInContainer(scope, scope.getSourceFile(), search, state, !(ts2.isSourceFile(scope) && !ts2.contains(state.sourceFiles, scope)));
            } else {
              for (var _i = 0, _a = state.sourceFiles; _i < _a.length; _i++) {
                var sourceFile = _a[_i];
                state.cancellationToken.throwIfCancellationRequested();
                searchForName(sourceFile, search, state);
              }
            }
          }
          function getSpecialSearchKind(node) {
            switch (node.kind) {
              case 129:
                return 1;
              case 75:
                if (ts2.isClassLike(node.parent)) {
                  ts2.Debug.assert(node.parent.name === node);
                  return 2;
                }
              default:
                return 0;
            }
          }
          function skipPastExportOrImportSpecifierOrUnion(symbol, node, checker, useLocalSymbolForExportSpecifier) {
            var parent = node.parent;
            if (ts2.isExportSpecifier(parent) && useLocalSymbolForExportSpecifier) {
              return getLocalSymbolForExportSpecifier(node, symbol, parent, checker);
            }
            return ts2.firstDefined(symbol.declarations, function(decl) {
              if (!decl.parent) {
                if (symbol.flags & 33554432)
                  return void 0;
                ts2.Debug.fail("Unexpected symbol at " + ts2.Debug.formatSyntaxKind(node.kind) + ": " + ts2.Debug.formatSymbol(symbol));
              }
              return ts2.isTypeLiteralNode(decl.parent) && ts2.isUnionTypeNode(decl.parent.parent) ? checker.getPropertyOfType(checker.getTypeFromTypeNode(decl.parent.parent), symbol.name) : void 0;
            });
          }
          var SpecialSearchKind;
          (function(SpecialSearchKind2) {
            SpecialSearchKind2[SpecialSearchKind2["None"] = 0] = "None";
            SpecialSearchKind2[SpecialSearchKind2["Constructor"] = 1] = "Constructor";
            SpecialSearchKind2[SpecialSearchKind2["Class"] = 2] = "Class";
          })(SpecialSearchKind || (SpecialSearchKind = {}));
          function getNonModuleSymbolOfMergedModuleSymbol(symbol) {
            if (!(symbol.flags & (1536 | 33554432)))
              return void 0;
            var decl = symbol.declarations && ts2.find(symbol.declarations, function(d) {
              return !ts2.isSourceFile(d) && !ts2.isModuleDeclaration(d);
            });
            return decl && decl.symbol;
          }
          var State = function() {
            function State2(sourceFiles, sourceFilesSet, specialSearchKind, checker, cancellationToken, searchMeaning, options, result) {
              this.sourceFiles = sourceFiles;
              this.sourceFilesSet = sourceFilesSet;
              this.specialSearchKind = specialSearchKind;
              this.checker = checker;
              this.cancellationToken = cancellationToken;
              this.searchMeaning = searchMeaning;
              this.options = options;
              this.result = result;
              this.inheritsFromCache = ts2.createMap();
              this.markSeenContainingTypeReference = ts2.nodeSeenTracker();
              this.markSeenReExportRHS = ts2.nodeSeenTracker();
              this.symbolIdToReferences = [];
              this.sourceFileToSeenSymbols = [];
            }
            State2.prototype.includesSourceFile = function(sourceFile) {
              return this.sourceFilesSet.has(sourceFile.fileName);
            };
            State2.prototype.getImportSearches = function(exportSymbol, exportInfo) {
              if (!this.importTracker)
                this.importTracker = FindAllReferences2.createImportTracker(this.sourceFiles, this.sourceFilesSet, this.checker, this.cancellationToken);
              return this.importTracker(exportSymbol, exportInfo, this.options.use === 2);
            };
            State2.prototype.createSearch = function(location, symbol, comingFrom, searchOptions) {
              if (searchOptions === void 0) {
                searchOptions = {};
              }
              var _a = searchOptions.text, text = _a === void 0 ? ts2.stripQuotes(ts2.symbolName(ts2.getLocalSymbolForExportDefault(symbol) || getNonModuleSymbolOfMergedModuleSymbol(symbol) || symbol)) : _a, _b = searchOptions.allSearchSymbols, allSearchSymbols = _b === void 0 ? [symbol] : _b;
              var escapedText = ts2.escapeLeadingUnderscores(text);
              var parents = this.options.implementations && location ? getParentSymbolsOfPropertyAccess(location, symbol, this.checker) : void 0;
              return { symbol, comingFrom, text, escapedText, parents, allSearchSymbols, includes: function(sym) {
                return ts2.contains(allSearchSymbols, sym);
              } };
            };
            State2.prototype.referenceAdder = function(searchSymbol) {
              var symbolId = ts2.getSymbolId(searchSymbol);
              var references = this.symbolIdToReferences[symbolId];
              if (!references) {
                references = this.symbolIdToReferences[symbolId] = [];
                this.result.push({ definition: { type: 0, symbol: searchSymbol }, references });
              }
              return function(node, kind) {
                return references.push(nodeEntry(node, kind));
              };
            };
            State2.prototype.addStringOrCommentReference = function(fileName, textSpan) {
              this.result.push({
                definition: void 0,
                references: [{ kind: 0, fileName, textSpan }]
              });
            };
            State2.prototype.markSearchedSymbols = function(sourceFile, symbols) {
              var sourceId = ts2.getNodeId(sourceFile);
              var seenSymbols = this.sourceFileToSeenSymbols[sourceId] || (this.sourceFileToSeenSymbols[sourceId] = ts2.createMap());
              var anyNewSymbols = false;
              for (var _i = 0, symbols_3 = symbols; _i < symbols_3.length; _i++) {
                var sym = symbols_3[_i];
                anyNewSymbols = ts2.addToSeen(seenSymbols, ts2.getSymbolId(sym)) || anyNewSymbols;
              }
              return anyNewSymbols;
            };
            return State2;
          }();
          function searchForImportsOfExport(exportLocation, exportSymbol, exportInfo, state) {
            var _a = state.getImportSearches(exportSymbol, exportInfo), importSearches = _a.importSearches, singleReferences = _a.singleReferences, indirectUsers = _a.indirectUsers;
            if (singleReferences.length) {
              var addRef = state.referenceAdder(exportSymbol);
              for (var _i = 0, singleReferences_1 = singleReferences; _i < singleReferences_1.length; _i++) {
                var singleRef = singleReferences_1[_i];
                if (shouldAddSingleReference(singleRef, state))
                  addRef(singleRef);
              }
            }
            for (var _b = 0, importSearches_1 = importSearches; _b < importSearches_1.length; _b++) {
              var _c = importSearches_1[_b], importLocation = _c[0], importSymbol = _c[1];
              getReferencesInSourceFile(importLocation.getSourceFile(), state.createSearch(importLocation, importSymbol, 1), state);
            }
            if (indirectUsers.length) {
              var indirectSearch = void 0;
              switch (exportInfo.exportKind) {
                case 0:
                  indirectSearch = state.createSearch(exportLocation, exportSymbol, 1);
                  break;
                case 1:
                  indirectSearch = state.options.use === 2 ? void 0 : state.createSearch(exportLocation, exportSymbol, 1, { text: "default" });
                  break;
                case 2:
                  break;
              }
              if (indirectSearch) {
                for (var _d = 0, indirectUsers_1 = indirectUsers; _d < indirectUsers_1.length; _d++) {
                  var indirectUser = indirectUsers_1[_d];
                  searchForName(indirectUser, indirectSearch, state);
                }
              }
            }
          }
          function eachExportReference(sourceFiles, checker, cancellationToken, exportSymbol, exportingModuleSymbol, exportName, isDefaultExport, cb) {
            var importTracker = FindAllReferences2.createImportTracker(sourceFiles, ts2.arrayToSet(sourceFiles, function(f) {
              return f.fileName;
            }), checker, cancellationToken);
            var _a = importTracker(exportSymbol, { exportKind: isDefaultExport ? 1 : 0, exportingModuleSymbol }, false), importSearches = _a.importSearches, indirectUsers = _a.indirectUsers;
            for (var _i = 0, importSearches_2 = importSearches; _i < importSearches_2.length; _i++) {
              var importLocation = importSearches_2[_i][0];
              cb(importLocation);
            }
            for (var _b = 0, indirectUsers_2 = indirectUsers; _b < indirectUsers_2.length; _b++) {
              var indirectUser = indirectUsers_2[_b];
              for (var _c = 0, _d = getPossibleSymbolReferenceNodes(indirectUser, isDefaultExport ? "default" : exportName); _c < _d.length; _c++) {
                var node = _d[_c];
                if (ts2.isIdentifier(node) && !ts2.isImportOrExportSpecifier(node.parent) && checker.getSymbolAtLocation(node) === exportSymbol) {
                  cb(node);
                }
              }
            }
          }
          Core2.eachExportReference = eachExportReference;
          function shouldAddSingleReference(singleRef, state) {
            if (!hasMatchingMeaning(singleRef, state))
              return false;
            if (state.options.use !== 2)
              return true;
            if (!ts2.isIdentifier(singleRef))
              return false;
            return !(ts2.isImportOrExportSpecifier(singleRef.parent) && singleRef.escapedText === "default");
          }
          function searchForImportedSymbol(symbol, state) {
            if (!symbol.declarations)
              return;
            for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
              var declaration = _a[_i];
              var exportingFile = declaration.getSourceFile();
              getReferencesInSourceFile(exportingFile, state.createSearch(declaration, symbol, 0), state, state.includesSourceFile(exportingFile));
            }
          }
          function searchForName(sourceFile, search, state) {
            if (ts2.getNameTable(sourceFile).get(search.escapedText) !== void 0) {
              getReferencesInSourceFile(sourceFile, search, state);
            }
          }
          function getPropertySymbolOfDestructuringAssignment(location, checker) {
            return ts2.isArrayLiteralOrObjectLiteralDestructuringPattern(location.parent.parent) ? checker.getPropertySymbolOfDestructuringAssignment(location) : void 0;
          }
          function getSymbolScope(symbol) {
            var declarations = symbol.declarations, flags = symbol.flags, parent = symbol.parent, valueDeclaration = symbol.valueDeclaration;
            if (valueDeclaration && (valueDeclaration.kind === 201 || valueDeclaration.kind === 214)) {
              return valueDeclaration;
            }
            if (!declarations) {
              return void 0;
            }
            if (flags & (4 | 8192)) {
              var privateDeclaration = ts2.find(declarations, function(d) {
                return ts2.hasModifier(d, 8) || ts2.isPrivateIdentifierPropertyDeclaration(d);
              });
              if (privateDeclaration) {
                return ts2.getAncestor(privateDeclaration, 245);
              }
              return void 0;
            }
            if (declarations.some(ts2.isObjectBindingElementWithoutPropertyName)) {
              return void 0;
            }
            var exposedByParent = parent && !(symbol.flags & 262144);
            if (exposedByParent && !(ts2.isExternalModuleSymbol(parent) && !parent.globalExports)) {
              return void 0;
            }
            var scope;
            for (var _i = 0, declarations_1 = declarations; _i < declarations_1.length; _i++) {
              var declaration = declarations_1[_i];
              var container = ts2.getContainerNode(declaration);
              if (scope && scope !== container) {
                return void 0;
              }
              if (!container || container.kind === 290 && !ts2.isExternalOrCommonJsModule(container)) {
                return void 0;
              }
              scope = container;
            }
            return exposedByParent ? scope.getSourceFile() : scope;
          }
          function isSymbolReferencedInFile(definition, checker, sourceFile, searchContainer) {
            if (searchContainer === void 0) {
              searchContainer = sourceFile;
            }
            return eachSymbolReferenceInFile(definition, checker, sourceFile, function() {
              return true;
            }, searchContainer) || false;
          }
          Core2.isSymbolReferencedInFile = isSymbolReferencedInFile;
          function eachSymbolReferenceInFile(definition, checker, sourceFile, cb, searchContainer) {
            if (searchContainer === void 0) {
              searchContainer = sourceFile;
            }
            var symbol = ts2.isParameterPropertyDeclaration(definition.parent, definition.parent.parent) ? ts2.first(checker.getSymbolsOfParameterPropertyDeclaration(definition.parent, definition.text)) : checker.getSymbolAtLocation(definition);
            if (!symbol)
              return void 0;
            for (var _i = 0, _a = getPossibleSymbolReferenceNodes(sourceFile, symbol.name, searchContainer); _i < _a.length; _i++) {
              var token = _a[_i];
              if (!ts2.isIdentifier(token) || token === definition || token.escapedText !== definition.escapedText)
                continue;
              var referenceSymbol = checker.getSymbolAtLocation(token);
              if (referenceSymbol === symbol || checker.getShorthandAssignmentValueSymbol(token.parent) === symbol || ts2.isExportSpecifier(token.parent) && getLocalSymbolForExportSpecifier(token, referenceSymbol, token.parent, checker) === symbol) {
                var res = cb(token);
                if (res)
                  return res;
              }
            }
          }
          Core2.eachSymbolReferenceInFile = eachSymbolReferenceInFile;
          function eachSignatureCall(signature, sourceFiles, checker, cb) {
            if (!signature.name || !ts2.isIdentifier(signature.name))
              return;
            var symbol = ts2.Debug.checkDefined(checker.getSymbolAtLocation(signature.name));
            for (var _i = 0, sourceFiles_3 = sourceFiles; _i < sourceFiles_3.length; _i++) {
              var sourceFile = sourceFiles_3[_i];
              for (var _a = 0, _b = getPossibleSymbolReferenceNodes(sourceFile, symbol.name); _a < _b.length; _a++) {
                var name = _b[_a];
                if (!ts2.isIdentifier(name) || name === signature.name || name.escapedText !== signature.name.escapedText)
                  continue;
                var called = ts2.climbPastPropertyAccess(name);
                var call = called.parent;
                if (!ts2.isCallExpression(call) || call.expression !== called)
                  continue;
                var referenceSymbol = checker.getSymbolAtLocation(name);
                if (referenceSymbol && checker.getRootSymbols(referenceSymbol).some(function(s) {
                  return s === symbol;
                })) {
                  cb(call);
                }
              }
            }
          }
          Core2.eachSignatureCall = eachSignatureCall;
          function getPossibleSymbolReferenceNodes(sourceFile, symbolName, container) {
            if (container === void 0) {
              container = sourceFile;
            }
            return getPossibleSymbolReferencePositions(sourceFile, symbolName, container).map(function(pos) {
              return ts2.getTouchingPropertyName(sourceFile, pos);
            });
          }
          function getPossibleSymbolReferencePositions(sourceFile, symbolName, container) {
            if (container === void 0) {
              container = sourceFile;
            }
            var positions = [];
            if (!symbolName || !symbolName.length) {
              return positions;
            }
            var text = sourceFile.text;
            var sourceLength = text.length;
            var symbolNameLength = symbolName.length;
            var position = text.indexOf(symbolName, container.pos);
            while (position >= 0) {
              if (position > container.end)
                break;
              var endPosition = position + symbolNameLength;
              if ((position === 0 || !ts2.isIdentifierPart(text.charCodeAt(position - 1), 99)) && (endPosition === sourceLength || !ts2.isIdentifierPart(text.charCodeAt(endPosition), 99))) {
                positions.push(position);
              }
              position = text.indexOf(symbolName, position + symbolNameLength + 1);
            }
            return positions;
          }
          function getLabelReferencesInNode(container, targetLabel) {
            var sourceFile = container.getSourceFile();
            var labelName = targetLabel.text;
            var references = ts2.mapDefined(getPossibleSymbolReferenceNodes(sourceFile, labelName, container), function(node) {
              return node === targetLabel || ts2.isJumpStatementTarget(node) && ts2.getTargetLabel(node, labelName) === targetLabel ? nodeEntry(node) : void 0;
            });
            return [{ definition: { type: 1, node: targetLabel }, references }];
          }
          function isValidReferencePosition(node, searchSymbolName) {
            switch (node.kind) {
              case 76:
              case 75:
                return node.text.length === searchSymbolName.length;
              case 14:
              case 10: {
                var str = node;
                return (ts2.isLiteralNameOfPropertyDeclarationOrIndexAccess(str) || ts2.isNameOfModuleDeclaration(node) || ts2.isExpressionOfExternalModuleImportEqualsDeclaration(node) || ts2.isCallExpression(node.parent) && ts2.isBindableObjectDefinePropertyCall(node.parent) && node.parent.arguments[1] === node) && str.text.length === searchSymbolName.length;
              }
              case 8:
                return ts2.isLiteralNameOfPropertyDeclarationOrIndexAccess(node) && node.text.length === searchSymbolName.length;
              case 84:
                return "default".length === searchSymbolName.length;
              default:
                return false;
            }
          }
          function getAllReferencesForKeyword(sourceFiles, keywordKind, cancellationToken, filter) {
            var references = ts2.flatMap(sourceFiles, function(sourceFile) {
              cancellationToken.throwIfCancellationRequested();
              return ts2.mapDefined(getPossibleSymbolReferenceNodes(sourceFile, ts2.tokenToString(keywordKind), sourceFile), function(referenceLocation) {
                if (referenceLocation.kind === keywordKind && (!filter || filter(referenceLocation))) {
                  return nodeEntry(referenceLocation);
                }
              });
            });
            return references.length ? [{ definition: { type: 2, node: references[0].node }, references }] : void 0;
          }
          function getReferencesInSourceFile(sourceFile, search, state, addReferencesHere) {
            if (addReferencesHere === void 0) {
              addReferencesHere = true;
            }
            state.cancellationToken.throwIfCancellationRequested();
            return getReferencesInContainer(sourceFile, sourceFile, search, state, addReferencesHere);
          }
          function getReferencesInContainer(container, sourceFile, search, state, addReferencesHere) {
            if (!state.markSearchedSymbols(sourceFile, search.allSearchSymbols)) {
              return;
            }
            for (var _i = 0, _a = getPossibleSymbolReferencePositions(sourceFile, search.text, container); _i < _a.length; _i++) {
              var position = _a[_i];
              getReferencesAtLocation(sourceFile, position, search, state, addReferencesHere);
            }
          }
          function hasMatchingMeaning(referenceLocation, state) {
            return !!(ts2.getMeaningFromLocation(referenceLocation) & state.searchMeaning);
          }
          function getReferencesAtLocation(sourceFile, position, search, state, addReferencesHere) {
            var referenceLocation = ts2.getTouchingPropertyName(sourceFile, position);
            if (!isValidReferencePosition(referenceLocation, search.text)) {
              if (!state.options.implementations && (state.options.findInStrings && ts2.isInString(sourceFile, position) || state.options.findInComments && ts2.isInNonReferenceComment(sourceFile, position))) {
                state.addStringOrCommentReference(sourceFile.fileName, ts2.createTextSpan(position, search.text.length));
              }
              return;
            }
            if (!hasMatchingMeaning(referenceLocation, state))
              return;
            var referenceSymbol = state.checker.getSymbolAtLocation(referenceLocation);
            if (!referenceSymbol) {
              return;
            }
            var parent = referenceLocation.parent;
            if (ts2.isImportSpecifier(parent) && parent.propertyName === referenceLocation) {
              return;
            }
            if (ts2.isExportSpecifier(parent)) {
              ts2.Debug.assert(referenceLocation.kind === 75);
              getReferencesAtExportSpecifier(referenceLocation, referenceSymbol, parent, search, state, addReferencesHere);
              return;
            }
            var relatedSymbol = getRelatedSymbol(search, referenceSymbol, referenceLocation, state);
            if (!relatedSymbol) {
              getReferenceForShorthandProperty(referenceSymbol, search, state);
              return;
            }
            switch (state.specialSearchKind) {
              case 0:
                if (addReferencesHere)
                  addReference(referenceLocation, relatedSymbol, state);
                break;
              case 1:
                addConstructorReferences(referenceLocation, sourceFile, search, state);
                break;
              case 2:
                addClassStaticThisReferences(referenceLocation, search, state);
                break;
              default:
                ts2.Debug.assertNever(state.specialSearchKind);
            }
            getImportOrExportReferences(referenceLocation, referenceSymbol, search, state);
          }
          function getReferencesAtExportSpecifier(referenceLocation, referenceSymbol, exportSpecifier, search, state, addReferencesHere, alwaysGetReferences) {
            ts2.Debug.assert(!alwaysGetReferences || !!state.options.providePrefixAndSuffixTextForRename, "If alwaysGetReferences is true, then prefix/suffix text must be enabled");
            var parent = exportSpecifier.parent, propertyName = exportSpecifier.propertyName, name = exportSpecifier.name;
            var exportDeclaration = parent.parent;
            var localSymbol = getLocalSymbolForExportSpecifier(referenceLocation, referenceSymbol, exportSpecifier, state.checker);
            if (!alwaysGetReferences && !search.includes(localSymbol)) {
              return;
            }
            if (!propertyName) {
              if (!(state.options.use === 2 && name.escapedText === "default")) {
                addRef();
              }
            } else if (referenceLocation === propertyName) {
              if (!exportDeclaration.moduleSpecifier) {
                addRef();
              }
              if (addReferencesHere && state.options.use !== 2 && state.markSeenReExportRHS(name)) {
                addReference(name, ts2.Debug.checkDefined(exportSpecifier.symbol), state);
              }
            } else {
              if (state.markSeenReExportRHS(referenceLocation)) {
                addRef();
              }
            }
            if (!isForRenameWithPrefixAndSuffixText(state.options) || alwaysGetReferences) {
              var isDefaultExport = referenceLocation.originalKeywordKind === 84 || exportSpecifier.name.originalKeywordKind === 84;
              var exportKind = isDefaultExport ? 1 : 0;
              var exportSymbol = ts2.Debug.checkDefined(exportSpecifier.symbol);
              var exportInfo = FindAllReferences2.getExportInfo(exportSymbol, exportKind, state.checker);
              if (exportInfo) {
                searchForImportsOfExport(referenceLocation, exportSymbol, exportInfo, state);
              }
            }
            if (search.comingFrom !== 1 && exportDeclaration.moduleSpecifier && !propertyName && !isForRenameWithPrefixAndSuffixText(state.options)) {
              var imported = state.checker.getExportSpecifierLocalTargetSymbol(exportSpecifier);
              if (imported)
                searchForImportedSymbol(imported, state);
            }
            function addRef() {
              if (addReferencesHere)
                addReference(referenceLocation, localSymbol, state);
            }
          }
          function getLocalSymbolForExportSpecifier(referenceLocation, referenceSymbol, exportSpecifier, checker) {
            return isExportSpecifierAlias(referenceLocation, exportSpecifier) && checker.getExportSpecifierLocalTargetSymbol(exportSpecifier) || referenceSymbol;
          }
          function isExportSpecifierAlias(referenceLocation, exportSpecifier) {
            var parent = exportSpecifier.parent, propertyName = exportSpecifier.propertyName, name = exportSpecifier.name;
            ts2.Debug.assert(propertyName === referenceLocation || name === referenceLocation);
            if (propertyName) {
              return propertyName === referenceLocation;
            } else {
              return !parent.parent.moduleSpecifier;
            }
          }
          function getImportOrExportReferences(referenceLocation, referenceSymbol, search, state) {
            var importOrExport = FindAllReferences2.getImportOrExportSymbol(referenceLocation, referenceSymbol, state.checker, search.comingFrom === 1);
            if (!importOrExport)
              return;
            var symbol = importOrExport.symbol;
            if (importOrExport.kind === 0) {
              if (!isForRenameWithPrefixAndSuffixText(state.options)) {
                searchForImportedSymbol(symbol, state);
              }
            } else {
              searchForImportsOfExport(referenceLocation, symbol, importOrExport.exportInfo, state);
            }
          }
          function getReferenceForShorthandProperty(_a, search, state) {
            var flags = _a.flags, valueDeclaration = _a.valueDeclaration;
            var shorthandValueSymbol = state.checker.getShorthandAssignmentValueSymbol(valueDeclaration);
            var name = valueDeclaration && ts2.getNameOfDeclaration(valueDeclaration);
            if (!(flags & 33554432) && name && search.includes(shorthandValueSymbol)) {
              addReference(name, shorthandValueSymbol, state);
            }
          }
          function addReference(referenceLocation, relatedSymbol, state) {
            var _a = "kind" in relatedSymbol ? relatedSymbol : { kind: void 0, symbol: relatedSymbol }, kind = _a.kind, symbol = _a.symbol;
            var addRef = state.referenceAdder(symbol);
            if (state.options.implementations) {
              addImplementationReferences(referenceLocation, addRef, state);
            } else {
              addRef(referenceLocation, kind);
            }
          }
          function addConstructorReferences(referenceLocation, sourceFile, search, state) {
            if (ts2.isNewExpressionTarget(referenceLocation)) {
              addReference(referenceLocation, search.symbol, state);
            }
            var pusher = function() {
              return state.referenceAdder(search.symbol);
            };
            if (ts2.isClassLike(referenceLocation.parent)) {
              ts2.Debug.assert(referenceLocation.kind === 84 || referenceLocation.parent.name === referenceLocation);
              findOwnConstructorReferences(search.symbol, sourceFile, pusher());
            } else {
              var classExtending = tryGetClassByExtendingIdentifier(referenceLocation);
              if (classExtending) {
                findSuperConstructorAccesses(classExtending, pusher());
                findInheritedConstructorReferences(classExtending, state);
              }
            }
          }
          function addClassStaticThisReferences(referenceLocation, search, state) {
            addReference(referenceLocation, search.symbol, state);
            var classLike = referenceLocation.parent;
            if (state.options.use === 2 || !ts2.isClassLike(classLike))
              return;
            ts2.Debug.assert(classLike.name === referenceLocation);
            var addRef = state.referenceAdder(search.symbol);
            for (var _i = 0, _a = classLike.members; _i < _a.length; _i++) {
              var member = _a[_i];
              if (!(ts2.isMethodOrAccessor(member) && ts2.hasModifier(member, 32))) {
                continue;
              }
              if (member.body) {
                member.body.forEachChild(function cb(node) {
                  if (node.kind === 104) {
                    addRef(node);
                  } else if (!ts2.isFunctionLike(node) && !ts2.isClassLike(node)) {
                    node.forEachChild(cb);
                  }
                });
              }
            }
          }
          function findOwnConstructorReferences(classSymbol, sourceFile, addNode) {
            var constructorSymbol = getClassConstructorSymbol(classSymbol);
            if (constructorSymbol && constructorSymbol.declarations) {
              for (var _i = 0, _a = constructorSymbol.declarations; _i < _a.length; _i++) {
                var decl = _a[_i];
                var ctrKeyword = ts2.findChildOfKind(decl, 129, sourceFile);
                ts2.Debug.assert(decl.kind === 162 && !!ctrKeyword);
                addNode(ctrKeyword);
              }
            }
            if (classSymbol.exports) {
              classSymbol.exports.forEach(function(member) {
                var decl2 = member.valueDeclaration;
                if (decl2 && decl2.kind === 161) {
                  var body = decl2.body;
                  if (body) {
                    forEachDescendantOfKind(body, 104, function(thisKeyword) {
                      if (ts2.isNewExpressionTarget(thisKeyword)) {
                        addNode(thisKeyword);
                      }
                    });
                  }
                }
              });
            }
          }
          function getClassConstructorSymbol(classSymbol) {
            return classSymbol.members && classSymbol.members.get("__constructor");
          }
          function findSuperConstructorAccesses(classDeclaration, addNode) {
            var constructor = getClassConstructorSymbol(classDeclaration.symbol);
            if (!(constructor && constructor.declarations)) {
              return;
            }
            for (var _i = 0, _a = constructor.declarations; _i < _a.length; _i++) {
              var decl = _a[_i];
              ts2.Debug.assert(decl.kind === 162);
              var body = decl.body;
              if (body) {
                forEachDescendantOfKind(body, 102, function(node) {
                  if (ts2.isCallExpressionTarget(node)) {
                    addNode(node);
                  }
                });
              }
            }
          }
          function hasOwnConstructor(classDeclaration) {
            return !!getClassConstructorSymbol(classDeclaration.symbol);
          }
          function findInheritedConstructorReferences(classDeclaration, state) {
            if (hasOwnConstructor(classDeclaration))
              return;
            var classSymbol = classDeclaration.symbol;
            var search = state.createSearch(void 0, classSymbol, void 0);
            getReferencesInContainerOrFiles(classSymbol, state, search);
          }
          function addImplementationReferences(refNode, addReference2, state) {
            if (ts2.isDeclarationName(refNode) && isImplementation(refNode.parent)) {
              addReference2(refNode);
              return;
            }
            if (refNode.kind !== 75) {
              return;
            }
            if (refNode.parent.kind === 282) {
              getReferenceEntriesForShorthandPropertyAssignment(refNode, state.checker, addReference2);
            }
            var containingClass = getContainingClassIfInHeritageClause(refNode);
            if (containingClass) {
              addReference2(containingClass);
              return;
            }
            var typeNode = ts2.findAncestor(refNode, function(a) {
              return !ts2.isQualifiedName(a.parent) && !ts2.isTypeNode(a.parent) && !ts2.isTypeElement(a.parent);
            });
            var typeHavingNode = typeNode.parent;
            if (ts2.hasType(typeHavingNode) && typeHavingNode.type === typeNode && state.markSeenContainingTypeReference(typeHavingNode)) {
              if (ts2.hasInitializer(typeHavingNode)) {
                addIfImplementation(typeHavingNode.initializer);
              } else if (ts2.isFunctionLike(typeHavingNode) && typeHavingNode.body) {
                var body = typeHavingNode.body;
                if (body.kind === 223) {
                  ts2.forEachReturnStatement(body, function(returnStatement) {
                    if (returnStatement.expression)
                      addIfImplementation(returnStatement.expression);
                  });
                } else {
                  addIfImplementation(body);
                }
              } else if (ts2.isAssertionExpression(typeHavingNode)) {
                addIfImplementation(typeHavingNode.expression);
              }
            }
            function addIfImplementation(e) {
              if (isImplementationExpression(e))
                addReference2(e);
            }
          }
          function getContainingClassIfInHeritageClause(node) {
            return ts2.isIdentifier(node) || ts2.isPropertyAccessExpression(node) ? getContainingClassIfInHeritageClause(node.parent) : ts2.isExpressionWithTypeArguments(node) ? ts2.tryCast(node.parent.parent, ts2.isClassLike) : void 0;
          }
          function isImplementationExpression(node) {
            switch (node.kind) {
              case 200:
                return isImplementationExpression(node.expression);
              case 202:
              case 201:
              case 193:
              case 214:
              case 192:
                return true;
              default:
                return false;
            }
          }
          function explicitlyInheritsFrom(symbol, parent, cachedResults, checker) {
            if (symbol === parent) {
              return true;
            }
            var key = ts2.getSymbolId(symbol) + "," + ts2.getSymbolId(parent);
            var cached = cachedResults.get(key);
            if (cached !== void 0) {
              return cached;
            }
            cachedResults.set(key, false);
            var inherits = !!symbol.declarations && symbol.declarations.some(function(declaration) {
              return ts2.getAllSuperTypeNodes(declaration).some(function(typeReference) {
                var type = checker.getTypeAtLocation(typeReference);
                return !!type && !!type.symbol && explicitlyInheritsFrom(type.symbol, parent, cachedResults, checker);
              });
            });
            cachedResults.set(key, inherits);
            return inherits;
          }
          function getReferencesForSuperKeyword(superKeyword) {
            var searchSpaceNode = ts2.getSuperContainer(superKeyword, false);
            if (!searchSpaceNode) {
              return void 0;
            }
            var staticFlag = 32;
            switch (searchSpaceNode.kind) {
              case 159:
              case 158:
              case 161:
              case 160:
              case 162:
              case 163:
              case 164:
                staticFlag &= ts2.getModifierFlags(searchSpaceNode);
                searchSpaceNode = searchSpaceNode.parent;
                break;
              default:
                return void 0;
            }
            var sourceFile = searchSpaceNode.getSourceFile();
            var references = ts2.mapDefined(getPossibleSymbolReferenceNodes(sourceFile, "super", searchSpaceNode), function(node) {
              if (node.kind !== 102) {
                return;
              }
              var container = ts2.getSuperContainer(node, false);
              return container && (32 & ts2.getModifierFlags(container)) === staticFlag && container.parent.symbol === searchSpaceNode.symbol ? nodeEntry(node) : void 0;
            });
            return [{ definition: { type: 0, symbol: searchSpaceNode.symbol }, references }];
          }
          function isParameterName(node) {
            return node.kind === 75 && node.parent.kind === 156 && node.parent.name === node;
          }
          function getReferencesForThisKeyword(thisOrSuperKeyword, sourceFiles, cancellationToken) {
            var searchSpaceNode = ts2.getThisContainer(thisOrSuperKeyword, false);
            var staticFlag = 32;
            switch (searchSpaceNode.kind) {
              case 161:
              case 160:
                if (ts2.isObjectLiteralMethod(searchSpaceNode)) {
                  break;
                }
              case 159:
              case 158:
              case 162:
              case 163:
              case 164:
                staticFlag &= ts2.getModifierFlags(searchSpaceNode);
                searchSpaceNode = searchSpaceNode.parent;
                break;
              case 290:
                if (ts2.isExternalModule(searchSpaceNode) || isParameterName(thisOrSuperKeyword)) {
                  return void 0;
                }
              case 244:
              case 201:
                break;
              default:
                return void 0;
            }
            var references = ts2.flatMap(searchSpaceNode.kind === 290 ? sourceFiles : [searchSpaceNode.getSourceFile()], function(sourceFile) {
              cancellationToken.throwIfCancellationRequested();
              return getPossibleSymbolReferenceNodes(sourceFile, "this", ts2.isSourceFile(searchSpaceNode) ? sourceFile : searchSpaceNode).filter(function(node) {
                if (!ts2.isThis(node)) {
                  return false;
                }
                var container = ts2.getThisContainer(node, false);
                switch (searchSpaceNode.kind) {
                  case 201:
                  case 244:
                    return searchSpaceNode.symbol === container.symbol;
                  case 161:
                  case 160:
                    return ts2.isObjectLiteralMethod(searchSpaceNode) && searchSpaceNode.symbol === container.symbol;
                  case 214:
                  case 245:
                    return container.parent && searchSpaceNode.symbol === container.parent.symbol && (ts2.getModifierFlags(container) & 32) === staticFlag;
                  case 290:
                    return container.kind === 290 && !ts2.isExternalModule(container) && !isParameterName(node);
                }
              });
            }).map(function(n) {
              return nodeEntry(n);
            });
            var thisParameter = ts2.firstDefined(references, function(r) {
              return ts2.isParameter(r.node.parent) ? r.node : void 0;
            });
            return [{
              definition: { type: 3, node: thisParameter || thisOrSuperKeyword },
              references
            }];
          }
          function getReferencesForStringLiteral(node, sourceFiles, cancellationToken) {
            var references = ts2.flatMap(sourceFiles, function(sourceFile) {
              cancellationToken.throwIfCancellationRequested();
              return ts2.mapDefined(getPossibleSymbolReferenceNodes(sourceFile, node.text), function(ref) {
                return ts2.isStringLiteral(ref) && ref.text === node.text ? nodeEntry(ref, 2) : void 0;
              });
            });
            return [{
              definition: { type: 4, node },
              references
            }];
          }
          function populateSearchSymbolSet(symbol, location, checker, isForRename, providePrefixAndSuffixText, implementations) {
            var result = [];
            forEachRelatedSymbol(symbol, location, checker, isForRename, !(isForRename && providePrefixAndSuffixText), function(sym, root, base) {
              result.push(base || root || sym);
            }, function() {
              return !implementations;
            });
            return result;
          }
          function forEachRelatedSymbol(symbol, location, checker, isForRenamePopulateSearchSymbolSet, onlyIncludeBindingElementAtReferenceLocation, cbSymbol, allowBaseTypes) {
            var containingObjectLiteralElement = ts2.getContainingObjectLiteralElement(location);
            if (containingObjectLiteralElement) {
              var shorthandValueSymbol = checker.getShorthandAssignmentValueSymbol(location.parent);
              if (shorthandValueSymbol && isForRenamePopulateSearchSymbolSet) {
                return cbSymbol(shorthandValueSymbol, void 0, void 0, 3);
              }
              var contextualType = checker.getContextualType(containingObjectLiteralElement.parent);
              var res_1 = contextualType && ts2.firstDefined(ts2.getPropertySymbolsFromContextualType(containingObjectLiteralElement, checker, contextualType, true), function(sym) {
                return fromRoot(sym, 4);
              });
              if (res_1)
                return res_1;
              var propertySymbol = getPropertySymbolOfDestructuringAssignment(location, checker);
              var res1 = propertySymbol && cbSymbol(propertySymbol, void 0, void 0, 4);
              if (res1)
                return res1;
              var res2 = shorthandValueSymbol && cbSymbol(shorthandValueSymbol, void 0, void 0, 3);
              if (res2)
                return res2;
            }
            var aliasedSymbol = getMergedAliasedSymbolOfNamespaceExportDeclaration(location, symbol, checker);
            if (aliasedSymbol) {
              var res_2 = cbSymbol(aliasedSymbol, void 0, void 0, 1);
              if (res_2)
                return res_2;
            }
            var res = fromRoot(symbol);
            if (res)
              return res;
            if (symbol.valueDeclaration && ts2.isParameterPropertyDeclaration(symbol.valueDeclaration, symbol.valueDeclaration.parent)) {
              var paramProps = checker.getSymbolsOfParameterPropertyDeclaration(ts2.cast(symbol.valueDeclaration, ts2.isParameter), symbol.name);
              ts2.Debug.assert(paramProps.length === 2 && !!(paramProps[0].flags & 1) && !!(paramProps[1].flags & 4));
              return fromRoot(symbol.flags & 1 ? paramProps[1] : paramProps[0]);
            }
            var exportSpecifier = ts2.getDeclarationOfKind(symbol, 263);
            if (!isForRenamePopulateSearchSymbolSet || exportSpecifier && !exportSpecifier.propertyName) {
              var localSymbol = exportSpecifier && checker.getExportSpecifierLocalTargetSymbol(exportSpecifier);
              if (localSymbol) {
                var res_3 = cbSymbol(localSymbol, void 0, void 0, 1);
                if (res_3)
                  return res_3;
              }
            }
            if (!isForRenamePopulateSearchSymbolSet) {
              var bindingElementPropertySymbol = void 0;
              if (onlyIncludeBindingElementAtReferenceLocation) {
                bindingElementPropertySymbol = ts2.isObjectBindingElementWithoutPropertyName(location.parent) ? ts2.getPropertySymbolFromBindingElement(checker, location.parent) : void 0;
              } else {
                bindingElementPropertySymbol = getPropertySymbolOfObjectBindingPatternWithoutPropertyName(symbol, checker);
              }
              return bindingElementPropertySymbol && fromRoot(bindingElementPropertySymbol, 4);
            }
            ts2.Debug.assert(isForRenamePopulateSearchSymbolSet);
            var includeOriginalSymbolOfBindingElement = onlyIncludeBindingElementAtReferenceLocation;
            if (includeOriginalSymbolOfBindingElement) {
              var bindingElementPropertySymbol = getPropertySymbolOfObjectBindingPatternWithoutPropertyName(symbol, checker);
              return bindingElementPropertySymbol && fromRoot(bindingElementPropertySymbol, 4);
            }
            function fromRoot(sym, kind) {
              return ts2.firstDefined(checker.getRootSymbols(sym), function(rootSymbol) {
                return cbSymbol(sym, rootSymbol, void 0, kind) || (rootSymbol.parent && rootSymbol.parent.flags & (32 | 64) && allowBaseTypes(rootSymbol) ? ts2.getPropertySymbolsFromBaseTypes(rootSymbol.parent, rootSymbol.name, checker, function(base) {
                  return cbSymbol(sym, rootSymbol, base, kind);
                }) : void 0);
              });
            }
            function getPropertySymbolOfObjectBindingPatternWithoutPropertyName(symbol2, checker2) {
              var bindingElement = ts2.getDeclarationOfKind(symbol2, 191);
              if (bindingElement && ts2.isObjectBindingElementWithoutPropertyName(bindingElement)) {
                return ts2.getPropertySymbolFromBindingElement(checker2, bindingElement);
              }
            }
          }
          function getRelatedSymbol(search, referenceSymbol, referenceLocation, state) {
            var checker = state.checker;
            return forEachRelatedSymbol(referenceSymbol, referenceLocation, checker, false, state.options.use !== 2 || !!state.options.providePrefixAndSuffixTextForRename, function(sym, rootSymbol, baseSymbol, kind) {
              return search.includes(baseSymbol || rootSymbol || sym) ? { symbol: rootSymbol && !(ts2.getCheckFlags(sym) & 6) ? rootSymbol : sym, kind } : void 0;
            }, function(rootSymbol) {
              return !(search.parents && !search.parents.some(function(parent) {
                return explicitlyInheritsFrom(rootSymbol.parent, parent, state.inheritsFromCache, checker);
              }));
            });
          }
          function getIntersectingMeaningFromDeclarations(node, symbol) {
            var meaning = ts2.getMeaningFromLocation(node);
            var declarations = symbol.declarations;
            if (declarations) {
              var lastIterationMeaning = void 0;
              do {
                lastIterationMeaning = meaning;
                for (var _i = 0, declarations_2 = declarations; _i < declarations_2.length; _i++) {
                  var declaration = declarations_2[_i];
                  var declarationMeaning = ts2.getMeaningFromDeclaration(declaration);
                  if (declarationMeaning & meaning) {
                    meaning |= declarationMeaning;
                  }
                }
              } while (meaning !== lastIterationMeaning);
            }
            return meaning;
          }
          Core2.getIntersectingMeaningFromDeclarations = getIntersectingMeaningFromDeclarations;
          function isImplementation(node) {
            return !!(node.flags & 8388608) ? !(ts2.isInterfaceDeclaration(node) || ts2.isTypeAliasDeclaration(node)) : ts2.isVariableLike(node) ? ts2.hasInitializer(node) : ts2.isFunctionLikeDeclaration(node) ? !!node.body : ts2.isClassLike(node) || ts2.isModuleOrEnumDeclaration(node);
          }
          function getReferenceEntriesForShorthandPropertyAssignment(node, checker, addReference2) {
            var refSymbol = checker.getSymbolAtLocation(node);
            var shorthandSymbol = checker.getShorthandAssignmentValueSymbol(refSymbol.valueDeclaration);
            if (shorthandSymbol) {
              for (var _i = 0, _a = shorthandSymbol.getDeclarations(); _i < _a.length; _i++) {
                var declaration = _a[_i];
                if (ts2.getMeaningFromDeclaration(declaration) & 1) {
                  addReference2(declaration);
                }
              }
            }
          }
          Core2.getReferenceEntriesForShorthandPropertyAssignment = getReferenceEntriesForShorthandPropertyAssignment;
          function forEachDescendantOfKind(node, kind, action) {
            ts2.forEachChild(node, function(child) {
              if (child.kind === kind) {
                action(child);
              }
              forEachDescendantOfKind(child, kind, action);
            });
          }
          function tryGetClassByExtendingIdentifier(node) {
            return ts2.tryGetClassExtendingExpressionWithTypeArguments(ts2.climbPastPropertyAccess(node).parent);
          }
          function getParentSymbolsOfPropertyAccess(location, symbol, checker) {
            var propertyAccessExpression = ts2.isRightSideOfPropertyAccess(location) ? location.parent : void 0;
            var lhsType = propertyAccessExpression && checker.getTypeAtLocation(propertyAccessExpression.expression);
            var res = ts2.mapDefined(lhsType && (lhsType.isUnionOrIntersection() ? lhsType.types : lhsType.symbol === symbol.parent ? void 0 : [lhsType]), function(t) {
              return t.symbol && t.symbol.flags & (32 | 64) ? t.symbol : void 0;
            });
            return res.length === 0 ? void 0 : res;
          }
          function isForRenameWithPrefixAndSuffixText(options) {
            return options.use === 2 && options.providePrefixAndSuffixTextForRename;
          }
        })(Core = FindAllReferences2.Core || (FindAllReferences2.Core = {}));
      })(FindAllReferences = ts2.FindAllReferences || (ts2.FindAllReferences = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var CallHierarchy;
      (function(CallHierarchy2) {
        function isNamedExpression(node) {
          return (ts2.isFunctionExpression(node) || ts2.isClassExpression(node)) && ts2.isNamedDeclaration(node);
        }
        function isConstNamedExpression(node) {
          return (ts2.isFunctionExpression(node) || ts2.isArrowFunction(node) || ts2.isClassExpression(node)) && ts2.isVariableDeclaration(node.parent) && node === node.parent.initializer && ts2.isIdentifier(node.parent.name) && !!(ts2.getCombinedNodeFlags(node.parent) & 2);
        }
        function isPossibleCallHierarchyDeclaration(node) {
          return ts2.isSourceFile(node) || ts2.isModuleDeclaration(node) || ts2.isFunctionDeclaration(node) || ts2.isFunctionExpression(node) || ts2.isClassDeclaration(node) || ts2.isClassExpression(node) || ts2.isMethodDeclaration(node) || ts2.isMethodSignature(node) || ts2.isGetAccessorDeclaration(node) || ts2.isSetAccessorDeclaration(node);
        }
        function isValidCallHierarchyDeclaration(node) {
          return ts2.isSourceFile(node) || ts2.isModuleDeclaration(node) && ts2.isIdentifier(node.name) || ts2.isFunctionDeclaration(node) || ts2.isClassDeclaration(node) || ts2.isMethodDeclaration(node) || ts2.isMethodSignature(node) || ts2.isGetAccessorDeclaration(node) || ts2.isSetAccessorDeclaration(node) || isNamedExpression(node) || isConstNamedExpression(node);
        }
        function getCallHierarchyDeclarationReferenceNode(node) {
          if (ts2.isSourceFile(node))
            return node;
          if (ts2.isNamedDeclaration(node))
            return node.name;
          if (isConstNamedExpression(node))
            return node.parent.name;
          return ts2.Debug.checkDefined(node.modifiers && ts2.find(node.modifiers, isDefaultModifier));
        }
        function isDefaultModifier(node) {
          return node.kind === 84;
        }
        function getSymbolOfCallHierarchyDeclaration(typeChecker, node) {
          var location = getCallHierarchyDeclarationReferenceNode(node);
          return location && typeChecker.getSymbolAtLocation(location);
        }
        function getCallHierarchyItemName(program, node) {
          if (ts2.isSourceFile(node)) {
            return { text: node.fileName, pos: 0, end: 0 };
          }
          if ((ts2.isFunctionDeclaration(node) || ts2.isClassDeclaration(node)) && !ts2.isNamedDeclaration(node)) {
            var defaultModifier = node.modifiers && ts2.find(node.modifiers, isDefaultModifier);
            if (defaultModifier) {
              return { text: "default", pos: defaultModifier.getStart(), end: defaultModifier.getEnd() };
            }
          }
          var declName = isConstNamedExpression(node) ? node.parent.name : ts2.Debug.checkDefined(ts2.getNameOfDeclaration(node), "Expected call hierarchy item to have a name");
          var text = ts2.isIdentifier(declName) ? ts2.idText(declName) : ts2.isStringOrNumericLiteralLike(declName) ? declName.text : ts2.isComputedPropertyName(declName) ? ts2.isStringOrNumericLiteralLike(declName.expression) ? declName.expression.text : void 0 : void 0;
          if (text === void 0) {
            var typeChecker = program.getTypeChecker();
            var symbol = typeChecker.getSymbolAtLocation(declName);
            if (symbol) {
              text = typeChecker.symbolToString(symbol, node);
            }
          }
          if (text === void 0) {
            var printer_1 = ts2.createPrinter({ removeComments: true, omitTrailingSemicolon: true });
            text = ts2.usingSingleLineStringWriter(function(writer) {
              return printer_1.writeNode(4, node, node.getSourceFile(), writer);
            });
          }
          return { text, pos: declName.getStart(), end: declName.getEnd() };
        }
        function findImplementation(typeChecker, node) {
          if (node.body) {
            return node;
          }
          if (ts2.isConstructorDeclaration(node)) {
            return ts2.getFirstConstructorWithBody(node.parent);
          }
          if (ts2.isFunctionDeclaration(node) || ts2.isMethodDeclaration(node)) {
            var symbol = getSymbolOfCallHierarchyDeclaration(typeChecker, node);
            if (symbol && symbol.valueDeclaration && ts2.isFunctionLikeDeclaration(symbol.valueDeclaration) && symbol.valueDeclaration.body) {
              return symbol.valueDeclaration;
            }
            return void 0;
          }
          return node;
        }
        function findAllInitialDeclarations(typeChecker, node) {
          var symbol = getSymbolOfCallHierarchyDeclaration(typeChecker, node);
          var declarations;
          if (symbol && symbol.declarations) {
            var indices = ts2.indicesOf(symbol.declarations);
            var keys_1 = ts2.map(symbol.declarations, function(decl2) {
              return { file: decl2.getSourceFile().fileName, pos: decl2.pos };
            });
            indices.sort(function(a, b) {
              return ts2.compareStringsCaseSensitive(keys_1[a].file, keys_1[b].file) || keys_1[a].pos - keys_1[b].pos;
            });
            var sortedDeclarations = ts2.map(indices, function(i) {
              return symbol.declarations[i];
            });
            var lastDecl = void 0;
            for (var _i = 0, sortedDeclarations_1 = sortedDeclarations; _i < sortedDeclarations_1.length; _i++) {
              var decl = sortedDeclarations_1[_i];
              if (isValidCallHierarchyDeclaration(decl)) {
                if (!lastDecl || lastDecl.parent !== decl.parent || lastDecl.end !== decl.pos) {
                  declarations = ts2.append(declarations, decl);
                }
                lastDecl = decl;
              }
            }
          }
          return declarations;
        }
        function findImplementationOrAllInitialDeclarations(typeChecker, node) {
          var _a, _b, _c;
          if (ts2.isFunctionLikeDeclaration(node)) {
            return (_b = (_a = findImplementation(typeChecker, node)) !== null && _a !== void 0 ? _a : findAllInitialDeclarations(typeChecker, node)) !== null && _b !== void 0 ? _b : node;
          }
          return (_c = findAllInitialDeclarations(typeChecker, node)) !== null && _c !== void 0 ? _c : node;
        }
        function resolveCallHierarchyDeclaration(program, location) {
          var typeChecker = program.getTypeChecker();
          var followingSymbol = false;
          while (true) {
            if (isValidCallHierarchyDeclaration(location)) {
              return findImplementationOrAllInitialDeclarations(typeChecker, location);
            }
            if (isPossibleCallHierarchyDeclaration(location)) {
              var ancestor = ts2.findAncestor(location, isValidCallHierarchyDeclaration);
              return ancestor && findImplementationOrAllInitialDeclarations(typeChecker, ancestor);
            }
            if (ts2.isDeclarationName(location)) {
              if (isValidCallHierarchyDeclaration(location.parent)) {
                return findImplementationOrAllInitialDeclarations(typeChecker, location.parent);
              }
              if (isPossibleCallHierarchyDeclaration(location.parent)) {
                var ancestor = ts2.findAncestor(location.parent, isValidCallHierarchyDeclaration);
                return ancestor && findImplementationOrAllInitialDeclarations(typeChecker, ancestor);
              }
              if (ts2.isVariableDeclaration(location.parent) && location.parent.initializer && isConstNamedExpression(location.parent.initializer)) {
                return location.parent.initializer;
              }
              return void 0;
            }
            if (ts2.isConstructorDeclaration(location)) {
              if (isValidCallHierarchyDeclaration(location.parent)) {
                return location.parent;
              }
              return void 0;
            }
            if (!followingSymbol) {
              var symbol = typeChecker.getSymbolAtLocation(location);
              if (symbol) {
                if (symbol.flags & 2097152) {
                  symbol = typeChecker.getAliasedSymbol(symbol);
                }
                if (symbol.valueDeclaration) {
                  followingSymbol = true;
                  location = symbol.valueDeclaration;
                  continue;
                }
              }
            }
            return void 0;
          }
        }
        CallHierarchy2.resolveCallHierarchyDeclaration = resolveCallHierarchyDeclaration;
        function createCallHierarchyItem(program, node) {
          var sourceFile = node.getSourceFile();
          var name = getCallHierarchyItemName(program, node);
          var kind = ts2.getNodeKind(node);
          var span = ts2.createTextSpanFromBounds(ts2.skipTrivia(sourceFile.text, node.getFullStart(), false, true), node.getEnd());
          var selectionSpan = ts2.createTextSpanFromBounds(name.pos, name.end);
          return { file: sourceFile.fileName, kind, name: name.text, span, selectionSpan };
        }
        CallHierarchy2.createCallHierarchyItem = createCallHierarchyItem;
        function isDefined(x) {
          return x !== void 0;
        }
        function convertEntryToCallSite(entry) {
          if (entry.kind === 1) {
            var node = entry.node;
            if (ts2.isCallOrNewExpressionTarget(node, true, true) || ts2.isTaggedTemplateTag(node, true, true) || ts2.isDecoratorTarget(node, true, true) || ts2.isJsxOpeningLikeElementTagName(node, true, true) || ts2.isRightSideOfPropertyAccess(node) || ts2.isArgumentExpressionOfElementAccess(node)) {
              var sourceFile = node.getSourceFile();
              var ancestor = ts2.findAncestor(node, isValidCallHierarchyDeclaration) || sourceFile;
              return { declaration: ancestor, range: ts2.createTextRangeFromNode(node, sourceFile) };
            }
          }
        }
        function getCallSiteGroupKey(entry) {
          return "" + ts2.getNodeId(entry.declaration);
        }
        function createCallHierarchyIncomingCall(from, fromSpans) {
          return { from, fromSpans };
        }
        function convertCallSiteGroupToIncomingCall(program, entries) {
          return createCallHierarchyIncomingCall(createCallHierarchyItem(program, entries[0].declaration), ts2.map(entries, function(entry) {
            return ts2.createTextSpanFromRange(entry.range);
          }));
        }
        function getIncomingCalls(program, declaration, cancellationToken) {
          if (ts2.isSourceFile(declaration) || ts2.isModuleDeclaration(declaration)) {
            return [];
          }
          var location = getCallHierarchyDeclarationReferenceNode(declaration);
          var calls = ts2.filter(ts2.FindAllReferences.findReferenceOrRenameEntries(program, cancellationToken, program.getSourceFiles(), location, 0, { use: 1 }, convertEntryToCallSite), isDefined);
          return calls ? ts2.group(calls, getCallSiteGroupKey, function(entries) {
            return convertCallSiteGroupToIncomingCall(program, entries);
          }) : [];
        }
        CallHierarchy2.getIncomingCalls = getIncomingCalls;
        function createCallSiteCollector(program, callSites) {
          function recordCallSite(node) {
            var target = ts2.isTaggedTemplateExpression(node) ? node.tag : ts2.isJsxOpeningLikeElement(node) ? node.tagName : ts2.isAccessExpression(node) ? node : node.expression;
            var declaration = resolveCallHierarchyDeclaration(program, target);
            if (declaration) {
              var range = ts2.createTextRangeFromNode(target, node.getSourceFile());
              if (ts2.isArray(declaration)) {
                for (var _i = 0, declaration_1 = declaration; _i < declaration_1.length; _i++) {
                  var decl = declaration_1[_i];
                  callSites.push({ declaration: decl, range });
                }
              } else {
                callSites.push({ declaration, range });
              }
            }
          }
          function collect(node) {
            if (!node)
              return;
            if (node.flags & 8388608) {
              return;
            }
            if (isValidCallHierarchyDeclaration(node)) {
              if (ts2.isClassLike(node)) {
                for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
                  var member = _a[_i];
                  if (member.name && ts2.isComputedPropertyName(member.name)) {
                    collect(member.name.expression);
                  }
                }
              }
              return;
            }
            switch (node.kind) {
              case 75:
              case 253:
              case 254:
              case 260:
              case 246:
              case 247:
                return;
              case 199:
              case 217:
                collect(node.expression);
                return;
              case 242:
              case 156:
                collect(node.name);
                collect(node.initializer);
                return;
              case 196:
                recordCallSite(node);
                collect(node.expression);
                ts2.forEach(node.arguments, collect);
                return;
              case 197:
                recordCallSite(node);
                collect(node.expression);
                ts2.forEach(node.arguments, collect);
                return;
              case 198:
                recordCallSite(node);
                collect(node.tag);
                collect(node.template);
                return;
              case 268:
              case 267:
                recordCallSite(node);
                collect(node.tagName);
                collect(node.attributes);
                return;
              case 157:
                recordCallSite(node);
                collect(node.expression);
                return;
              case 194:
              case 195:
                recordCallSite(node);
                ts2.forEachChild(node, collect);
                break;
            }
            if (ts2.isPartOfTypeNode(node)) {
              return;
            }
            ts2.forEachChild(node, collect);
          }
          return collect;
        }
        function collectCallSitesOfSourceFile(node, collect) {
          ts2.forEach(node.statements, collect);
        }
        function collectCallSitesOfModuleDeclaration(node, collect) {
          if (!ts2.hasModifier(node, 2) && node.body && ts2.isModuleBlock(node.body)) {
            ts2.forEach(node.body.statements, collect);
          }
        }
        function collectCallSitesOfFunctionLikeDeclaration(typeChecker, node, collect) {
          var implementation = findImplementation(typeChecker, node);
          if (implementation) {
            ts2.forEach(implementation.parameters, collect);
            collect(implementation.body);
          }
        }
        function collectCallSitesOfClassLikeDeclaration(node, collect) {
          ts2.forEach(node.decorators, collect);
          var heritage = ts2.getClassExtendsHeritageElement(node);
          if (heritage) {
            collect(heritage.expression);
          }
          for (var _i = 0, _a = node.members; _i < _a.length; _i++) {
            var member = _a[_i];
            ts2.forEach(member.decorators, collect);
            if (ts2.isPropertyDeclaration(member)) {
              collect(member.initializer);
            } else if (ts2.isConstructorDeclaration(member) && member.body) {
              ts2.forEach(member.parameters, collect);
              collect(member.body);
            }
          }
        }
        function collectCallSites(program, node) {
          var callSites = [];
          var collect = createCallSiteCollector(program, callSites);
          switch (node.kind) {
            case 290:
              collectCallSitesOfSourceFile(node, collect);
              break;
            case 249:
              collectCallSitesOfModuleDeclaration(node, collect);
              break;
            case 244:
            case 201:
            case 202:
            case 161:
            case 163:
            case 164:
              collectCallSitesOfFunctionLikeDeclaration(program.getTypeChecker(), node, collect);
              break;
            case 245:
            case 214:
              collectCallSitesOfClassLikeDeclaration(node, collect);
              break;
            default:
              ts2.Debug.assertNever(node);
          }
          return callSites;
        }
        function createCallHierarchyOutgoingCall(to, fromSpans) {
          return { to, fromSpans };
        }
        function convertCallSiteGroupToOutgoingCall(program, entries) {
          return createCallHierarchyOutgoingCall(createCallHierarchyItem(program, entries[0].declaration), ts2.map(entries, function(entry) {
            return ts2.createTextSpanFromRange(entry.range);
          }));
        }
        function getOutgoingCalls(program, declaration) {
          if (declaration.flags & 8388608 || ts2.isMethodSignature(declaration)) {
            return [];
          }
          return ts2.group(collectCallSites(program, declaration), getCallSiteGroupKey, function(entries) {
            return convertCallSiteGroupToOutgoingCall(program, entries);
          });
        }
        CallHierarchy2.getOutgoingCalls = getOutgoingCalls;
      })(CallHierarchy = ts2.CallHierarchy || (ts2.CallHierarchy = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function getEditsForFileRename(program, oldFileOrDirPath, newFileOrDirPath, host, formatContext, preferences, sourceMapper) {
        var useCaseSensitiveFileNames = ts2.hostUsesCaseSensitiveFileNames(host);
        var getCanonicalFileName = ts2.createGetCanonicalFileName(useCaseSensitiveFileNames);
        var oldToNew = getPathUpdater(oldFileOrDirPath, newFileOrDirPath, getCanonicalFileName, sourceMapper);
        var newToOld = getPathUpdater(newFileOrDirPath, oldFileOrDirPath, getCanonicalFileName, sourceMapper);
        return ts2.textChanges.ChangeTracker.with({ host, formatContext, preferences }, function(changeTracker) {
          updateTsconfigFiles(program, changeTracker, oldToNew, oldFileOrDirPath, newFileOrDirPath, host.getCurrentDirectory(), useCaseSensitiveFileNames);
          updateImports(program, changeTracker, oldToNew, newToOld, host, getCanonicalFileName);
        });
      }
      ts2.getEditsForFileRename = getEditsForFileRename;
      function getPathUpdater(oldFileOrDirPath, newFileOrDirPath, getCanonicalFileName, sourceMapper) {
        var canonicalOldPath = getCanonicalFileName(oldFileOrDirPath);
        return function(path2) {
          var originalPath = sourceMapper && sourceMapper.tryGetSourcePosition({ fileName: path2, pos: 0 });
          var updatedPath = getUpdatedPath(originalPath ? originalPath.fileName : path2);
          return originalPath ? updatedPath === void 0 ? void 0 : makeCorrespondingRelativeChange(originalPath.fileName, updatedPath, path2, getCanonicalFileName) : updatedPath;
        };
        function getUpdatedPath(pathToUpdate) {
          if (getCanonicalFileName(pathToUpdate) === canonicalOldPath)
            return newFileOrDirPath;
          var suffix = ts2.tryRemoveDirectoryPrefix(pathToUpdate, canonicalOldPath, getCanonicalFileName);
          return suffix === void 0 ? void 0 : newFileOrDirPath + "/" + suffix;
        }
      }
      ts2.getPathUpdater = getPathUpdater;
      function makeCorrespondingRelativeChange(a0, b0, a1, getCanonicalFileName) {
        var rel = ts2.getRelativePathFromFile(a0, b0, getCanonicalFileName);
        return combinePathsSafe(ts2.getDirectoryPath(a1), rel);
      }
      function updateTsconfigFiles(program, changeTracker, oldToNew, oldFileOrDirPath, newFileOrDirPath, currentDirectory, useCaseSensitiveFileNames) {
        var configFile = program.getCompilerOptions().configFile;
        if (!configFile)
          return;
        var configDir = ts2.getDirectoryPath(configFile.fileName);
        var jsonObjectLiteral = ts2.getTsConfigObjectLiteralExpression(configFile);
        if (!jsonObjectLiteral)
          return;
        forEachProperty(jsonObjectLiteral, function(property, propertyName) {
          switch (propertyName) {
            case "files":
            case "include":
            case "exclude": {
              var foundExactMatch = updatePaths(property);
              if (!foundExactMatch && propertyName === "include" && ts2.isArrayLiteralExpression(property.initializer)) {
                var includes = ts2.mapDefined(property.initializer.elements, function(e) {
                  return ts2.isStringLiteral(e) ? e.text : void 0;
                });
                var matchers = ts2.getFileMatcherPatterns(configDir, [], includes, useCaseSensitiveFileNames, currentDirectory);
                if (ts2.getRegexFromPattern(ts2.Debug.checkDefined(matchers.includeFilePattern), useCaseSensitiveFileNames).test(oldFileOrDirPath) && !ts2.getRegexFromPattern(ts2.Debug.checkDefined(matchers.includeFilePattern), useCaseSensitiveFileNames).test(newFileOrDirPath)) {
                  changeTracker.insertNodeAfter(configFile, ts2.last(property.initializer.elements), ts2.createStringLiteral(relativePath(newFileOrDirPath)));
                }
              }
              break;
            }
            case "compilerOptions":
              forEachProperty(property.initializer, function(property2, propertyName2) {
                var option = ts2.getOptionFromName(propertyName2);
                if (option && (option.isFilePath || option.type === "list" && option.element.isFilePath)) {
                  updatePaths(property2);
                } else if (propertyName2 === "paths") {
                  forEachProperty(property2.initializer, function(pathsProperty) {
                    if (!ts2.isArrayLiteralExpression(pathsProperty.initializer))
                      return;
                    for (var _i = 0, _a = pathsProperty.initializer.elements; _i < _a.length; _i++) {
                      var e = _a[_i];
                      tryUpdateString(e);
                    }
                  });
                }
              });
              break;
          }
        });
        function updatePaths(property) {
          var elements = ts2.isArrayLiteralExpression(property.initializer) ? property.initializer.elements : [property.initializer];
          var foundExactMatch = false;
          for (var _i = 0, elements_1 = elements; _i < elements_1.length; _i++) {
            var element = elements_1[_i];
            foundExactMatch = tryUpdateString(element) || foundExactMatch;
          }
          return foundExactMatch;
        }
        function tryUpdateString(element) {
          if (!ts2.isStringLiteral(element))
            return false;
          var elementFileName = combinePathsSafe(configDir, element.text);
          var updated = oldToNew(elementFileName);
          if (updated !== void 0) {
            changeTracker.replaceRangeWithText(configFile, createStringRange(element, configFile), relativePath(updated));
            return true;
          }
          return false;
        }
        function relativePath(path2) {
          return ts2.getRelativePathFromDirectory(configDir, path2, !useCaseSensitiveFileNames);
        }
      }
      function updateImports(program, changeTracker, oldToNew, newToOld, host, getCanonicalFileName) {
        var allFiles = program.getSourceFiles();
        var _loop_4 = function(sourceFile2) {
          var newFromOld = oldToNew(sourceFile2.path);
          var newImportFromPath = newFromOld !== void 0 ? newFromOld : sourceFile2.path;
          var newImportFromDirectory = ts2.getDirectoryPath(newImportFromPath);
          var oldFromNew = newToOld(sourceFile2.fileName);
          var oldImportFromPath = oldFromNew || sourceFile2.fileName;
          var oldImportFromDirectory = ts2.getDirectoryPath(oldImportFromPath);
          var importingSourceFileMoved = newFromOld !== void 0 || oldFromNew !== void 0;
          updateImportsWorker(sourceFile2, changeTracker, function(referenceText) {
            if (!ts2.pathIsRelative(referenceText))
              return void 0;
            var oldAbsolute = combinePathsSafe(oldImportFromDirectory, referenceText);
            var newAbsolute = oldToNew(oldAbsolute);
            return newAbsolute === void 0 ? void 0 : ts2.ensurePathIsNonModuleName(ts2.getRelativePathFromDirectory(newImportFromDirectory, newAbsolute, getCanonicalFileName));
          }, function(importLiteral) {
            var importedModuleSymbol = program.getTypeChecker().getSymbolAtLocation(importLiteral);
            if (importedModuleSymbol && importedModuleSymbol.declarations.some(function(d) {
              return ts2.isAmbientModule(d);
            }))
              return void 0;
            var toImport = oldFromNew !== void 0 ? getSourceFileToImportFromResolved(ts2.resolveModuleName(importLiteral.text, oldImportFromPath, program.getCompilerOptions(), host), oldToNew, allFiles) : getSourceFileToImport(importedModuleSymbol, importLiteral, sourceFile2, program, host, oldToNew);
            return toImport !== void 0 && (toImport.updated || importingSourceFileMoved && ts2.pathIsRelative(importLiteral.text)) ? ts2.moduleSpecifiers.updateModuleSpecifier(program.getCompilerOptions(), newImportFromPath, toImport.newFileName, ts2.createModuleSpecifierResolutionHost(program, host), importLiteral.text) : void 0;
          });
        };
        for (var _i = 0, allFiles_1 = allFiles; _i < allFiles_1.length; _i++) {
          var sourceFile = allFiles_1[_i];
          _loop_4(sourceFile);
        }
      }
      function combineNormal(pathA, pathB) {
        return ts2.normalizePath(ts2.combinePaths(pathA, pathB));
      }
      function combinePathsSafe(pathA, pathB) {
        return ts2.ensurePathIsNonModuleName(combineNormal(pathA, pathB));
      }
      function getSourceFileToImport(importedModuleSymbol, importLiteral, importingSourceFile, program, host, oldToNew) {
        if (importedModuleSymbol) {
          var oldFileName = ts2.find(importedModuleSymbol.declarations, ts2.isSourceFile).fileName;
          var newFileName = oldToNew(oldFileName);
          return newFileName === void 0 ? { newFileName: oldFileName, updated: false } : { newFileName, updated: true };
        } else {
          var resolved = host.resolveModuleNames ? host.getResolvedModuleWithFailedLookupLocationsFromCache && host.getResolvedModuleWithFailedLookupLocationsFromCache(importLiteral.text, importingSourceFile.fileName) : program.getResolvedModuleWithFailedLookupLocationsFromCache(importLiteral.text, importingSourceFile.fileName);
          return getSourceFileToImportFromResolved(resolved, oldToNew, program.getSourceFiles());
        }
      }
      function getSourceFileToImportFromResolved(resolved, oldToNew, sourceFiles) {
        if (!resolved)
          return void 0;
        if (resolved.resolvedModule) {
          var result_2 = tryChange(resolved.resolvedModule.resolvedFileName);
          if (result_2)
            return result_2;
        }
        var result = ts2.forEach(resolved.failedLookupLocations, tryChangeWithIgnoringPackageJsonExisting) || ts2.forEach(resolved.failedLookupLocations, tryChangeWithIgnoringPackageJson);
        if (result)
          return result;
        return resolved.resolvedModule && { newFileName: resolved.resolvedModule.resolvedFileName, updated: false };
        function tryChangeWithIgnoringPackageJsonExisting(oldFileName) {
          var newFileName = oldToNew(oldFileName);
          return newFileName && ts2.find(sourceFiles, function(src) {
            return src.fileName === newFileName;
          }) ? tryChangeWithIgnoringPackageJson(oldFileName) : void 0;
        }
        function tryChangeWithIgnoringPackageJson(oldFileName) {
          return !ts2.endsWith(oldFileName, "/package.json") ? tryChange(oldFileName) : void 0;
        }
        function tryChange(oldFileName) {
          var newFileName = oldToNew(oldFileName);
          return newFileName && { newFileName, updated: true };
        }
      }
      function updateImportsWorker(sourceFile, changeTracker, updateRef, updateImport) {
        for (var _i = 0, _a = sourceFile.referencedFiles || ts2.emptyArray; _i < _a.length; _i++) {
          var ref = _a[_i];
          var updated = updateRef(ref.fileName);
          if (updated !== void 0 && updated !== sourceFile.text.slice(ref.pos, ref.end))
            changeTracker.replaceRangeWithText(sourceFile, ref, updated);
        }
        for (var _b = 0, _c = sourceFile.imports; _b < _c.length; _b++) {
          var importStringLiteral = _c[_b];
          var updated = updateImport(importStringLiteral);
          if (updated !== void 0 && updated !== importStringLiteral.text)
            changeTracker.replaceRangeWithText(sourceFile, createStringRange(importStringLiteral, sourceFile), updated);
        }
      }
      function createStringRange(node, sourceFile) {
        return ts2.createRange(node.getStart(sourceFile) + 1, node.end - 1);
      }
      function forEachProperty(objectLiteral, cb) {
        if (!ts2.isObjectLiteralExpression(objectLiteral))
          return;
        for (var _i = 0, _a = objectLiteral.properties; _i < _a.length; _i++) {
          var property = _a[_i];
          if (ts2.isPropertyAssignment(property) && ts2.isStringLiteral(property.name)) {
            cb(property, property.name.text);
          }
        }
      }
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var GoToDefinition;
      (function(GoToDefinition2) {
        function getDefinitionAtPosition(program, sourceFile, position) {
          var reference = getReferenceAtPosition(sourceFile, position, program);
          if (reference) {
            return [getDefinitionInfoForFileReference(reference.fileName, reference.file.fileName)];
          }
          var node = ts2.getTouchingPropertyName(sourceFile, position);
          if (node === sourceFile) {
            return void 0;
          }
          var parent = node.parent;
          var typeChecker = program.getTypeChecker();
          if (ts2.isJumpStatementTarget(node)) {
            var label = ts2.getTargetLabel(node.parent, node.text);
            return label ? [createDefinitionInfoFromName(typeChecker, label, "label", node.text, void 0)] : void 0;
          }
          var symbol = getSymbol(node, typeChecker);
          if (!symbol) {
            return getDefinitionInfoForIndexSignatures(node, typeChecker);
          }
          var calledDeclaration = tryGetSignatureDeclaration(typeChecker, node);
          if (calledDeclaration && !(ts2.isJsxOpeningLikeElement(node.parent) && isConstructorLike(calledDeclaration))) {
            var sigInfo = createDefinitionFromSignatureDeclaration(typeChecker, calledDeclaration);
            if (typeChecker.getRootSymbols(symbol).some(function(s) {
              return symbolMatchesSignature(s, calledDeclaration);
            }) || symbol.declarations && symbol.declarations.some(function(d) {
              return ts2.isVariableDeclaration(d) && !!d.initializer && ts2.isRequireCall(d.initializer, false);
            })) {
              return [sigInfo];
            } else {
              var defs = getDefinitionFromSymbol(typeChecker, symbol, node, calledDeclaration) || ts2.emptyArray;
              return node.kind === 102 ? __spreadArrays([sigInfo], defs) : __spreadArrays(defs, [sigInfo]);
            }
          }
          if (node.parent.kind === 282) {
            var shorthandSymbol_1 = typeChecker.getShorthandAssignmentValueSymbol(symbol.valueDeclaration);
            return shorthandSymbol_1 ? shorthandSymbol_1.declarations.map(function(decl) {
              return createDefinitionInfo(decl, typeChecker, shorthandSymbol_1, node);
            }) : [];
          }
          if (ts2.isPropertyName(node) && ts2.isBindingElement(parent) && ts2.isObjectBindingPattern(parent.parent) && node === (parent.propertyName || parent.name)) {
            var name_3 = ts2.getNameFromPropertyName(node);
            var type = typeChecker.getTypeAtLocation(parent.parent);
            return name_3 === void 0 ? ts2.emptyArray : ts2.flatMap(type.isUnion() ? type.types : [type], function(t) {
              var prop = t.getProperty(name_3);
              return prop && getDefinitionFromSymbol(typeChecker, prop, node);
            });
          }
          var element = ts2.getContainingObjectLiteralElement(node);
          if (element) {
            var contextualType = element && typeChecker.getContextualType(element.parent);
            if (contextualType) {
              return ts2.flatMap(ts2.getPropertySymbolsFromContextualType(element, typeChecker, contextualType, false), function(propertySymbol) {
                return getDefinitionFromSymbol(typeChecker, propertySymbol, node);
              });
            }
          }
          return getDefinitionFromSymbol(typeChecker, symbol, node);
        }
        GoToDefinition2.getDefinitionAtPosition = getDefinitionAtPosition;
        function symbolMatchesSignature(s, calledDeclaration) {
          return s === calledDeclaration.symbol || s === calledDeclaration.symbol.parent || !ts2.isCallLikeExpression(calledDeclaration.parent) && s === calledDeclaration.parent.symbol;
        }
        function getReferenceAtPosition(sourceFile, position, program) {
          var referencePath = findReferenceInPosition(sourceFile.referencedFiles, position);
          if (referencePath) {
            var file = program.getSourceFileFromReference(sourceFile, referencePath);
            return file && { fileName: referencePath.fileName, file };
          }
          var typeReferenceDirective = findReferenceInPosition(sourceFile.typeReferenceDirectives, position);
          if (typeReferenceDirective) {
            var reference = program.getResolvedTypeReferenceDirectives().get(typeReferenceDirective.fileName);
            var file = reference && program.getSourceFile(reference.resolvedFileName);
            return file && { fileName: typeReferenceDirective.fileName, file };
          }
          var libReferenceDirective = findReferenceInPosition(sourceFile.libReferenceDirectives, position);
          if (libReferenceDirective) {
            var file = program.getLibFileFromReference(libReferenceDirective);
            return file && { fileName: libReferenceDirective.fileName, file };
          }
          return void 0;
        }
        GoToDefinition2.getReferenceAtPosition = getReferenceAtPosition;
        function getTypeDefinitionAtPosition(typeChecker, sourceFile, position) {
          var node = ts2.getTouchingPropertyName(sourceFile, position);
          if (node === sourceFile) {
            return void 0;
          }
          var symbol = typeChecker.getSymbolAtLocation(node);
          if (!symbol)
            return void 0;
          var typeAtLocation = typeChecker.getTypeOfSymbolAtLocation(symbol, node);
          var returnType = tryGetReturnTypeOfFunction(symbol, typeAtLocation, typeChecker);
          var fromReturnType = returnType && definitionFromType(returnType, typeChecker, node);
          return fromReturnType && fromReturnType.length !== 0 ? fromReturnType : definitionFromType(typeAtLocation, typeChecker, node);
        }
        GoToDefinition2.getTypeDefinitionAtPosition = getTypeDefinitionAtPosition;
        function definitionFromType(type, checker, node) {
          return ts2.flatMap(type.isUnion() && !(type.flags & 32) ? type.types : [type], function(t) {
            return t.symbol && getDefinitionFromSymbol(checker, t.symbol, node);
          });
        }
        function tryGetReturnTypeOfFunction(symbol, type, checker) {
          if (type.symbol === symbol || symbol.valueDeclaration && type.symbol && ts2.isVariableDeclaration(symbol.valueDeclaration) && symbol.valueDeclaration.initializer === type.symbol.valueDeclaration) {
            var sigs = type.getCallSignatures();
            if (sigs.length === 1)
              return checker.getReturnTypeOfSignature(ts2.first(sigs));
          }
          return void 0;
        }
        function getDefinitionAndBoundSpan(program, sourceFile, position) {
          var definitions = getDefinitionAtPosition(program, sourceFile, position);
          if (!definitions || definitions.length === 0) {
            return void 0;
          }
          var comment = findReferenceInPosition(sourceFile.referencedFiles, position) || findReferenceInPosition(sourceFile.typeReferenceDirectives, position) || findReferenceInPosition(sourceFile.libReferenceDirectives, position);
          if (comment) {
            return { definitions, textSpan: ts2.createTextSpanFromRange(comment) };
          }
          var node = ts2.getTouchingPropertyName(sourceFile, position);
          var textSpan = ts2.createTextSpan(node.getStart(), node.getWidth());
          return { definitions, textSpan };
        }
        GoToDefinition2.getDefinitionAndBoundSpan = getDefinitionAndBoundSpan;
        function getDefinitionInfoForIndexSignatures(node, checker) {
          if (!ts2.isPropertyAccessExpression(node.parent) || node.parent.name !== node)
            return;
          var type = checker.getTypeAtLocation(node.parent.expression);
          return ts2.mapDefined(type.isUnionOrIntersection() ? type.types : [type], function(nonUnionType) {
            var info = checker.getIndexInfoOfType(nonUnionType, 0);
            return info && info.declaration && createDefinitionFromSignatureDeclaration(checker, info.declaration);
          });
        }
        function getSymbol(node, checker) {
          var symbol = checker.getSymbolAtLocation(node);
          if (symbol && symbol.flags & 2097152 && shouldSkipAlias(node, symbol.declarations[0])) {
            var aliased = checker.getAliasedSymbol(symbol);
            if (aliased.declarations) {
              return aliased;
            }
          }
          if (symbol && ts2.isInJSFile(node)) {
            var requireCall = ts2.forEach(symbol.declarations, function(d) {
              return ts2.isVariableDeclaration(d) && !!d.initializer && ts2.isRequireCall(d.initializer, true) ? d.initializer : void 0;
            });
            if (requireCall) {
              var moduleSymbol = checker.getSymbolAtLocation(requireCall.arguments[0]);
              if (moduleSymbol) {
                return checker.resolveExternalModuleSymbol(moduleSymbol);
              }
            }
          }
          return symbol;
        }
        function shouldSkipAlias(node, declaration) {
          if (node.kind !== 75) {
            return false;
          }
          if (node.parent === declaration) {
            return true;
          }
          switch (declaration.kind) {
            case 255:
            case 253:
              return true;
            case 258:
              return declaration.parent.kind === 257;
            default:
              return false;
          }
        }
        function getDefinitionFromSymbol(typeChecker, symbol, node, declarationNode) {
          var filteredDeclarations = ts2.filter(symbol.declarations, function(d) {
            return d !== declarationNode && (!ts2.isAssignmentDeclaration(d) || d === symbol.valueDeclaration);
          }) || void 0;
          return getConstructSignatureDefinition() || getCallSignatureDefinition() || ts2.map(filteredDeclarations, function(declaration) {
            return createDefinitionInfo(declaration, typeChecker, symbol, node);
          });
          function getConstructSignatureDefinition() {
            if (symbol.flags & 32 && !(symbol.flags & (16 | 3)) && (ts2.isNewExpressionTarget(node) || node.kind === 129)) {
              var cls = ts2.find(filteredDeclarations, ts2.isClassLike) || ts2.Debug.fail("Expected declaration to have at least one class-like declaration");
              return getSignatureDefinition(cls.members, true);
            }
          }
          function getCallSignatureDefinition() {
            return ts2.isCallOrNewExpressionTarget(node) || ts2.isNameOfFunctionDeclaration(node) ? getSignatureDefinition(filteredDeclarations, false) : void 0;
          }
          function getSignatureDefinition(signatureDeclarations, selectConstructors) {
            if (!signatureDeclarations) {
              return void 0;
            }
            var declarations = signatureDeclarations.filter(selectConstructors ? ts2.isConstructorDeclaration : ts2.isFunctionLike);
            var declarationsWithBody = declarations.filter(function(d) {
              return !!d.body;
            });
            return declarations.length ? declarationsWithBody.length !== 0 ? declarationsWithBody.map(function(x) {
              return createDefinitionInfo(x, typeChecker, symbol, node);
            }) : [createDefinitionInfo(ts2.last(declarations), typeChecker, symbol, node)] : void 0;
          }
        }
        function createDefinitionInfo(declaration, checker, symbol, node) {
          var symbolName = checker.symbolToString(symbol);
          var symbolKind = ts2.SymbolDisplay.getSymbolKind(checker, symbol, node);
          var containerName = symbol.parent ? checker.symbolToString(symbol.parent, node) : "";
          return createDefinitionInfoFromName(checker, declaration, symbolKind, symbolName, containerName);
        }
        function createDefinitionInfoFromName(checker, declaration, symbolKind, symbolName, containerName) {
          var name = ts2.getNameOfDeclaration(declaration) || declaration;
          var sourceFile = name.getSourceFile();
          var textSpan = ts2.createTextSpanFromNode(name, sourceFile);
          return __assign(__assign({
            fileName: sourceFile.fileName,
            textSpan,
            kind: symbolKind,
            name: symbolName,
            containerKind: void 0,
            containerName
          }, ts2.FindAllReferences.toContextSpan(textSpan, sourceFile, ts2.FindAllReferences.getContextNode(declaration))), { isLocal: !checker.isDeclarationVisible(declaration) });
        }
        function createDefinitionFromSignatureDeclaration(typeChecker, decl) {
          return createDefinitionInfo(decl, typeChecker, decl.symbol, decl);
        }
        function findReferenceInPosition(refs, pos) {
          return ts2.find(refs, function(ref) {
            return ts2.textRangeContainsPositionInclusive(ref, pos);
          });
        }
        GoToDefinition2.findReferenceInPosition = findReferenceInPosition;
        function getDefinitionInfoForFileReference(name, targetFileName) {
          return {
            fileName: targetFileName,
            textSpan: ts2.createTextSpanFromBounds(0, 0),
            kind: "script",
            name,
            containerName: void 0,
            containerKind: void 0
          };
        }
        function getAncestorCallLikeExpression(node) {
          var target = climbPastManyPropertyAccesses(node);
          var callLike = target.parent;
          return callLike && ts2.isCallLikeExpression(callLike) && ts2.getInvokedExpression(callLike) === target ? callLike : void 0;
        }
        function climbPastManyPropertyAccesses(node) {
          return ts2.isRightSideOfPropertyAccess(node) ? climbPastManyPropertyAccesses(node.parent) : node;
        }
        function tryGetSignatureDeclaration(typeChecker, node) {
          var callLike = getAncestorCallLikeExpression(node);
          var signature = callLike && typeChecker.getResolvedSignature(callLike);
          return ts2.tryCast(signature && signature.declaration, function(d) {
            return ts2.isFunctionLike(d) && !ts2.isFunctionTypeNode(d);
          });
        }
        function isConstructorLike(node) {
          switch (node.kind) {
            case 162:
            case 171:
            case 166:
              return true;
            default:
              return false;
          }
        }
      })(GoToDefinition = ts2.GoToDefinition || (ts2.GoToDefinition = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var JsDoc;
      (function(JsDoc2) {
        var jsDocTagNames = [
          "abstract",
          "access",
          "alias",
          "argument",
          "async",
          "augments",
          "author",
          "borrows",
          "callback",
          "class",
          "classdesc",
          "constant",
          "constructor",
          "constructs",
          "copyright",
          "default",
          "deprecated",
          "description",
          "emits",
          "enum",
          "event",
          "example",
          "exports",
          "extends",
          "external",
          "field",
          "file",
          "fileoverview",
          "fires",
          "function",
          "generator",
          "global",
          "hideconstructor",
          "host",
          "ignore",
          "implements",
          "inheritdoc",
          "inner",
          "instance",
          "interface",
          "kind",
          "lends",
          "license",
          "listens",
          "member",
          "memberof",
          "method",
          "mixes",
          "module",
          "name",
          "namespace",
          "override",
          "package",
          "param",
          "private",
          "property",
          "protected",
          "public",
          "readonly",
          "requires",
          "returns",
          "see",
          "since",
          "static",
          "summary",
          "template",
          "this",
          "throws",
          "todo",
          "tutorial",
          "type",
          "typedef",
          "var",
          "variation",
          "version",
          "virtual",
          "yields"
        ];
        var jsDocTagNameCompletionEntries;
        var jsDocTagCompletionEntries;
        function getJsDocCommentsFromDeclarations(declarations) {
          var documentationComment = [];
          ts2.forEachUnique(declarations, function(declaration) {
            for (var _i = 0, _a = getCommentHavingNodes(declaration); _i < _a.length; _i++) {
              var comment = _a[_i].comment;
              if (comment === void 0)
                continue;
              if (documentationComment.length) {
                documentationComment.push(ts2.lineBreakPart());
              }
              documentationComment.push(ts2.textPart(comment));
            }
          });
          return documentationComment;
        }
        JsDoc2.getJsDocCommentsFromDeclarations = getJsDocCommentsFromDeclarations;
        function getCommentHavingNodes(declaration) {
          switch (declaration.kind) {
            case 317:
            case 323:
              return [declaration];
            case 315:
            case 322:
              return [declaration, declaration.parent];
            default:
              return ts2.getJSDocCommentsAndTags(declaration);
          }
        }
        function getJsDocTagsFromDeclarations(declarations) {
          var tags = [];
          ts2.forEachUnique(declarations, function(declaration) {
            for (var _i = 0, _a = ts2.getJSDocTags(declaration); _i < _a.length; _i++) {
              var tag = _a[_i];
              tags.push({ name: tag.tagName.text, text: getCommentText(tag) });
            }
          });
          return tags;
        }
        JsDoc2.getJsDocTagsFromDeclarations = getJsDocTagsFromDeclarations;
        function getCommentText(tag) {
          var comment = tag.comment;
          switch (tag.kind) {
            case 308:
              return withNode(tag.class);
            case 307:
              return withNode(tag.class);
            case 321:
              return withList(tag.typeParameters);
            case 320:
              return withNode(tag.typeExpression);
            case 322:
            case 315:
            case 323:
            case 317:
              var name = tag.name;
              return name ? withNode(name) : comment;
            default:
              return comment;
          }
          function withNode(node) {
            return addComment(node.getText());
          }
          function withList(list) {
            return addComment(list.map(function(x) {
              return x.getText();
            }).join(", "));
          }
          function addComment(s) {
            return comment === void 0 ? s : s + " " + comment;
          }
        }
        function getJSDocTagNameCompletions() {
          return jsDocTagNameCompletionEntries || (jsDocTagNameCompletionEntries = ts2.map(jsDocTagNames, function(tagName) {
            return {
              name: tagName,
              kind: "keyword",
              kindModifiers: "",
              sortText: "0"
            };
          }));
        }
        JsDoc2.getJSDocTagNameCompletions = getJSDocTagNameCompletions;
        JsDoc2.getJSDocTagNameCompletionDetails = getJSDocTagCompletionDetails;
        function getJSDocTagCompletions() {
          return jsDocTagCompletionEntries || (jsDocTagCompletionEntries = ts2.map(jsDocTagNames, function(tagName) {
            return {
              name: "@" + tagName,
              kind: "keyword",
              kindModifiers: "",
              sortText: "0"
            };
          }));
        }
        JsDoc2.getJSDocTagCompletions = getJSDocTagCompletions;
        function getJSDocTagCompletionDetails(name) {
          return {
            name,
            kind: "",
            kindModifiers: "",
            displayParts: [ts2.textPart(name)],
            documentation: ts2.emptyArray,
            tags: void 0,
            codeActions: void 0
          };
        }
        JsDoc2.getJSDocTagCompletionDetails = getJSDocTagCompletionDetails;
        function getJSDocParameterNameCompletions(tag) {
          if (!ts2.isIdentifier(tag.name)) {
            return ts2.emptyArray;
          }
          var nameThusFar = tag.name.text;
          var jsdoc = tag.parent;
          var fn = jsdoc.parent;
          if (!ts2.isFunctionLike(fn))
            return [];
          return ts2.mapDefined(fn.parameters, function(param) {
            if (!ts2.isIdentifier(param.name))
              return void 0;
            var name = param.name.text;
            if (jsdoc.tags.some(function(t) {
              return t !== tag && ts2.isJSDocParameterTag(t) && ts2.isIdentifier(t.name) && t.name.escapedText === name;
            }) || nameThusFar !== void 0 && !ts2.startsWith(name, nameThusFar)) {
              return void 0;
            }
            return { name, kind: "parameter", kindModifiers: "", sortText: "0" };
          });
        }
        JsDoc2.getJSDocParameterNameCompletions = getJSDocParameterNameCompletions;
        function getJSDocParameterNameCompletionDetails(name) {
          return {
            name,
            kind: "parameter",
            kindModifiers: "",
            displayParts: [ts2.textPart(name)],
            documentation: ts2.emptyArray,
            tags: void 0,
            codeActions: void 0
          };
        }
        JsDoc2.getJSDocParameterNameCompletionDetails = getJSDocParameterNameCompletionDetails;
        function getDocCommentTemplateAtPosition(newLine, sourceFile, position) {
          var tokenAtPos = ts2.getTokenAtPosition(sourceFile, position);
          var existingDocComment = ts2.findAncestor(tokenAtPos, ts2.isJSDoc);
          if (existingDocComment && (existingDocComment.comment !== void 0 || ts2.length(existingDocComment.tags))) {
            return void 0;
          }
          var tokenStart = tokenAtPos.getStart(sourceFile);
          if (!existingDocComment && tokenStart < position) {
            return void 0;
          }
          var commentOwnerInfo = getCommentOwnerInfo(tokenAtPos);
          if (!commentOwnerInfo) {
            return void 0;
          }
          var commentOwner = commentOwnerInfo.commentOwner, parameters = commentOwnerInfo.parameters;
          if (commentOwner.getStart(sourceFile) < position) {
            return void 0;
          }
          if (!parameters || parameters.length === 0) {
            var singleLineResult = "/** */";
            return { newText: singleLineResult, caretOffset: 3 };
          }
          var indentationStr = getIndentationStringAtPosition(sourceFile, position);
          var preamble = "/**" + newLine + indentationStr + " * ";
          var result = preamble + newLine + parameterDocComments(parameters, ts2.hasJSFileExtension(sourceFile.fileName), indentationStr, newLine) + indentationStr + " */" + (tokenStart === position ? newLine + indentationStr : "");
          return { newText: result, caretOffset: preamble.length };
        }
        JsDoc2.getDocCommentTemplateAtPosition = getDocCommentTemplateAtPosition;
        function getIndentationStringAtPosition(sourceFile, position) {
          var text = sourceFile.text;
          var lineStart = ts2.getLineStartPositionForPosition(position, sourceFile);
          var pos = lineStart;
          for (; pos <= position && ts2.isWhiteSpaceSingleLine(text.charCodeAt(pos)); pos++)
            ;
          return text.slice(lineStart, pos);
        }
        function parameterDocComments(parameters, isJavaScriptFile, indentationStr, newLine) {
          return parameters.map(function(_a, i) {
            var name = _a.name, dotDotDotToken = _a.dotDotDotToken;
            var paramName = name.kind === 75 ? name.text : "param" + i;
            var type = isJavaScriptFile ? dotDotDotToken ? "{...any} " : "{any} " : "";
            return indentationStr + " * @param " + type + paramName + newLine;
          }).join("");
        }
        function getCommentOwnerInfo(tokenAtPos) {
          return ts2.forEachAncestor(tokenAtPos, getCommentOwnerInfoWorker);
        }
        function getCommentOwnerInfoWorker(commentOwner) {
          switch (commentOwner.kind) {
            case 244:
            case 201:
            case 161:
            case 162:
            case 160:
              var parameters = commentOwner.parameters;
              return { commentOwner, parameters };
            case 281:
              return getCommentOwnerInfoWorker(commentOwner.initializer);
            case 245:
            case 246:
            case 158:
            case 248:
            case 284:
            case 247:
              return { commentOwner };
            case 225: {
              var varStatement = commentOwner;
              var varDeclarations = varStatement.declarationList.declarations;
              var parameters_1 = varDeclarations.length === 1 && varDeclarations[0].initializer ? getParametersFromRightHandSideOfAssignment(varDeclarations[0].initializer) : void 0;
              return { commentOwner, parameters: parameters_1 };
            }
            case 290:
              return "quit";
            case 249:
              return commentOwner.parent.kind === 249 ? void 0 : { commentOwner };
            case 226:
              return getCommentOwnerInfoWorker(commentOwner.expression);
            case 209: {
              var be = commentOwner;
              if (ts2.getAssignmentDeclarationKind(be) === 0) {
                return "quit";
              }
              var parameters_2 = ts2.isFunctionLike(be.right) ? be.right.parameters : ts2.emptyArray;
              return { commentOwner, parameters: parameters_2 };
            }
            case 159:
              var init = commentOwner.initializer;
              if (init && (ts2.isFunctionExpression(init) || ts2.isArrowFunction(init))) {
                return { commentOwner, parameters: init.parameters };
              }
          }
        }
        function getParametersFromRightHandSideOfAssignment(rightHandSide) {
          while (rightHandSide.kind === 200) {
            rightHandSide = rightHandSide.expression;
          }
          switch (rightHandSide.kind) {
            case 201:
            case 202:
              return rightHandSide.parameters;
            case 214: {
              var ctr = ts2.find(rightHandSide.members, ts2.isConstructorDeclaration);
              return ctr ? ctr.parameters : ts2.emptyArray;
            }
          }
          return ts2.emptyArray;
        }
      })(JsDoc = ts2.JsDoc || (ts2.JsDoc = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var NavigateTo;
      (function(NavigateTo2) {
        function getNavigateToItems(sourceFiles, checker, cancellationToken, searchValue, maxResultCount, excludeDtsFiles) {
          var patternMatcher = ts2.createPatternMatcher(searchValue);
          if (!patternMatcher)
            return ts2.emptyArray;
          var rawItems = [];
          var _loop_5 = function(sourceFile2) {
            cancellationToken.throwIfCancellationRequested();
            if (excludeDtsFiles && sourceFile2.isDeclarationFile) {
              return "continue";
            }
            sourceFile2.getNamedDeclarations().forEach(function(declarations, name) {
              getItemsFromNamedDeclaration(patternMatcher, name, declarations, checker, sourceFile2.fileName, rawItems);
            });
          };
          for (var _i = 0, sourceFiles_4 = sourceFiles; _i < sourceFiles_4.length; _i++) {
            var sourceFile = sourceFiles_4[_i];
            _loop_5(sourceFile);
          }
          rawItems.sort(compareNavigateToItems);
          return (maxResultCount === void 0 ? rawItems : rawItems.slice(0, maxResultCount)).map(createNavigateToItem);
        }
        NavigateTo2.getNavigateToItems = getNavigateToItems;
        function getItemsFromNamedDeclaration(patternMatcher, name, declarations, checker, fileName, rawItems) {
          var match = patternMatcher.getMatchForLastSegmentOfPattern(name);
          if (!match) {
            return;
          }
          for (var _i = 0, declarations_3 = declarations; _i < declarations_3.length; _i++) {
            var declaration = declarations_3[_i];
            if (!shouldKeepItem(declaration, checker))
              continue;
            if (patternMatcher.patternContainsDots) {
              var fullMatch = patternMatcher.getFullMatch(getContainers(declaration), name);
              if (fullMatch) {
                rawItems.push({ name, fileName, matchKind: fullMatch.kind, isCaseSensitive: fullMatch.isCaseSensitive, declaration });
              }
            } else {
              rawItems.push({ name, fileName, matchKind: match.kind, isCaseSensitive: match.isCaseSensitive, declaration });
            }
          }
        }
        function shouldKeepItem(declaration, checker) {
          switch (declaration.kind) {
            case 255:
            case 258:
            case 253:
              var importer = checker.getSymbolAtLocation(declaration.name);
              var imported = checker.getAliasedSymbol(importer);
              return importer.escapedName !== imported.escapedName;
            default:
              return true;
          }
        }
        function tryAddSingleDeclarationName(declaration, containers) {
          var name = ts2.getNameOfDeclaration(declaration);
          return !!name && (pushLiteral(name, containers) || name.kind === 154 && tryAddComputedPropertyName(name.expression, containers));
        }
        function tryAddComputedPropertyName(expression, containers) {
          return pushLiteral(expression, containers) || ts2.isPropertyAccessExpression(expression) && (containers.push(expression.name.text), true) && tryAddComputedPropertyName(expression.expression, containers);
        }
        function pushLiteral(node, containers) {
          return ts2.isPropertyNameLiteral(node) && (containers.push(ts2.getTextOfIdentifierOrLiteral(node)), true);
        }
        function getContainers(declaration) {
          var containers = [];
          var name = ts2.getNameOfDeclaration(declaration);
          if (name && name.kind === 154 && !tryAddComputedPropertyName(name.expression, containers)) {
            return ts2.emptyArray;
          }
          containers.shift();
          var container = ts2.getContainerNode(declaration);
          while (container) {
            if (!tryAddSingleDeclarationName(container, containers)) {
              return ts2.emptyArray;
            }
            container = ts2.getContainerNode(container);
          }
          return containers.reverse();
        }
        function compareNavigateToItems(i1, i2) {
          return ts2.compareValues(i1.matchKind, i2.matchKind) || ts2.compareStringsCaseSensitiveUI(i1.name, i2.name);
        }
        function createNavigateToItem(rawItem) {
          var declaration = rawItem.declaration;
          var container = ts2.getContainerNode(declaration);
          var containerName = container && ts2.getNameOfDeclaration(container);
          return {
            name: rawItem.name,
            kind: ts2.getNodeKind(declaration),
            kindModifiers: ts2.getNodeModifiers(declaration),
            matchKind: ts2.PatternMatchKind[rawItem.matchKind],
            isCaseSensitive: rawItem.isCaseSensitive,
            fileName: rawItem.fileName,
            textSpan: ts2.createTextSpanFromNode(declaration),
            containerName: containerName ? containerName.text : "",
            containerKind: containerName ? ts2.getNodeKind(container) : ""
          };
        }
      })(NavigateTo = ts2.NavigateTo || (ts2.NavigateTo = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var NavigationBar;
      (function(NavigationBar2) {
        var _a;
        var whiteSpaceRegex = /\s+/g;
        var maxLength = 150;
        var curCancellationToken;
        var curSourceFile;
        var parentsStack = [];
        var parent;
        var trackedEs5ClassesStack = [];
        var trackedEs5Classes;
        var emptyChildItemArray = [];
        function getNavigationBarItems(sourceFile, cancellationToken) {
          curCancellationToken = cancellationToken;
          curSourceFile = sourceFile;
          try {
            return ts2.map(primaryNavBarMenuItems(rootNavigationBarNode(sourceFile)), convertToPrimaryNavBarMenuItem);
          } finally {
            reset();
          }
        }
        NavigationBar2.getNavigationBarItems = getNavigationBarItems;
        function getNavigationTree(sourceFile, cancellationToken) {
          curCancellationToken = cancellationToken;
          curSourceFile = sourceFile;
          try {
            return convertToTree(rootNavigationBarNode(sourceFile));
          } finally {
            reset();
          }
        }
        NavigationBar2.getNavigationTree = getNavigationTree;
        function reset() {
          curSourceFile = void 0;
          curCancellationToken = void 0;
          parentsStack = [];
          parent = void 0;
          emptyChildItemArray = [];
        }
        function nodeText(node) {
          return cleanText(node.getText(curSourceFile));
        }
        function navigationBarNodeKind(n) {
          return n.node.kind;
        }
        function pushChild(parent2, child) {
          if (parent2.children) {
            parent2.children.push(child);
          } else {
            parent2.children = [child];
          }
        }
        function rootNavigationBarNode(sourceFile) {
          ts2.Debug.assert(!parentsStack.length);
          var root = { node: sourceFile, name: void 0, additionalNodes: void 0, parent: void 0, children: void 0, indent: 0 };
          parent = root;
          for (var _i = 0, _a2 = sourceFile.statements; _i < _a2.length; _i++) {
            var statement = _a2[_i];
            addChildrenRecursively(statement);
          }
          endNode();
          ts2.Debug.assert(!parent && !parentsStack.length);
          return root;
        }
        function addLeafNode(node, name) {
          pushChild(parent, emptyNavigationBarNode(node, name));
        }
        function emptyNavigationBarNode(node, name) {
          return {
            node,
            name: name || (ts2.isDeclaration(node) || ts2.isExpression(node) ? ts2.getNameOfDeclaration(node) : void 0),
            additionalNodes: void 0,
            parent,
            children: void 0,
            indent: parent.indent + 1
          };
        }
        function addTrackedEs5Class(name) {
          if (!trackedEs5Classes) {
            trackedEs5Classes = ts2.createMap();
          }
          trackedEs5Classes.set(name, true);
        }
        function endNestedNodes(depth) {
          for (var i = 0; i < depth; i++)
            endNode();
        }
        function startNestedNodes(targetNode, entityName) {
          var names = [];
          while (!ts2.isPropertyNameLiteral(entityName)) {
            var name = ts2.getNameOrArgument(entityName);
            var nameText = ts2.getElementOrPropertyAccessName(entityName);
            entityName = entityName.expression;
            if (nameText === "prototype" || ts2.isPrivateIdentifier(name))
              continue;
            names.push(name);
          }
          names.push(entityName);
          for (var i = names.length - 1; i > 0; i--) {
            var name = names[i];
            startNode(targetNode, name);
          }
          return [names.length - 1, names[0]];
        }
        function startNode(node, name) {
          var navNode = emptyNavigationBarNode(node, name);
          pushChild(parent, navNode);
          parentsStack.push(parent);
          trackedEs5ClassesStack.push(trackedEs5Classes);
          parent = navNode;
        }
        function endNode() {
          if (parent.children) {
            mergeChildren(parent.children, parent);
            sortChildren(parent.children);
          }
          parent = parentsStack.pop();
          trackedEs5Classes = trackedEs5ClassesStack.pop();
        }
        function addNodeWithRecursiveChild(node, child, name) {
          startNode(node, name);
          addChildrenRecursively(child);
          endNode();
        }
        function addChildrenRecursively(node) {
          var _a2;
          curCancellationToken.throwIfCancellationRequested();
          if (!node || ts2.isToken(node)) {
            return;
          }
          switch (node.kind) {
            case 162:
              var ctr = node;
              addNodeWithRecursiveChild(ctr, ctr.body);
              for (var _i = 0, _b = ctr.parameters; _i < _b.length; _i++) {
                var param = _b[_i];
                if (ts2.isParameterPropertyDeclaration(param, ctr)) {
                  addLeafNode(param);
                }
              }
              break;
            case 161:
            case 163:
            case 164:
            case 160:
              if (!ts2.hasDynamicName(node)) {
                addNodeWithRecursiveChild(node, node.body);
              }
              break;
            case 159:
            case 158:
              if (!ts2.hasDynamicName(node)) {
                addLeafNode(node);
              }
              break;
            case 255:
              var importClause = node;
              if (importClause.name) {
                addLeafNode(importClause.name);
              }
              var namedBindings = importClause.namedBindings;
              if (namedBindings) {
                if (namedBindings.kind === 256) {
                  addLeafNode(namedBindings);
                } else {
                  for (var _c = 0, _d = namedBindings.elements; _c < _d.length; _c++) {
                    var element = _d[_c];
                    addLeafNode(element);
                  }
                }
              }
              break;
            case 282:
              addNodeWithRecursiveChild(node, node.name);
              break;
            case 283:
              var expression = node.expression;
              ts2.isIdentifier(expression) ? addLeafNode(node, expression) : addLeafNode(node);
              break;
            case 191:
            case 281:
            case 242:
              var _e = node, name = _e.name, initializer = _e.initializer;
              if (ts2.isBindingPattern(name)) {
                addChildrenRecursively(name);
              } else if (initializer && isFunctionOrClassExpression(initializer)) {
                startNode(node);
                ts2.forEachChild(initializer, addChildrenRecursively);
                endNode();
              } else {
                addNodeWithRecursiveChild(node, initializer);
              }
              break;
            case 244:
              var nameNode = node.name;
              if (nameNode && ts2.isIdentifier(nameNode)) {
                addTrackedEs5Class(nameNode.text);
              }
              addNodeWithRecursiveChild(node, node.body);
              break;
            case 202:
            case 201:
              addNodeWithRecursiveChild(node, node.body);
              break;
            case 248:
              startNode(node);
              for (var _f = 0, _g = node.members; _f < _g.length; _f++) {
                var member = _g[_f];
                if (!isComputedProperty(member)) {
                  addLeafNode(member);
                }
              }
              endNode();
              break;
            case 245:
            case 214:
            case 246:
              startNode(node);
              for (var _h = 0, _j = node.members; _h < _j.length; _h++) {
                var member = _j[_h];
                addChildrenRecursively(member);
              }
              endNode();
              break;
            case 249:
              addNodeWithRecursiveChild(node, getInteriorModule(node).body);
              break;
            case 259:
            case 263:
            case 253:
            case 167:
            case 165:
            case 166:
            case 247:
              addLeafNode(node);
              break;
            case 196:
            case 209: {
              var special = ts2.getAssignmentDeclarationKind(node);
              switch (special) {
                case 1:
                case 2:
                  addNodeWithRecursiveChild(node, node.right);
                  return;
                case 6:
                case 3: {
                  var binaryExpression = node;
                  var assignmentTarget = binaryExpression.left;
                  var prototypeAccess = special === 3 ? assignmentTarget.expression : assignmentTarget;
                  var depth = 0;
                  var className = void 0;
                  if (ts2.isIdentifier(prototypeAccess.expression)) {
                    addTrackedEs5Class(prototypeAccess.expression.text);
                    className = prototypeAccess.expression;
                  } else {
                    _a2 = startNestedNodes(binaryExpression, prototypeAccess.expression), depth = _a2[0], className = _a2[1];
                  }
                  if (special === 6) {
                    if (ts2.isObjectLiteralExpression(binaryExpression.right)) {
                      if (binaryExpression.right.properties.length > 0) {
                        startNode(binaryExpression, className);
                        ts2.forEachChild(binaryExpression.right, addChildrenRecursively);
                        endNode();
                      }
                    }
                  } else if (ts2.isFunctionExpression(binaryExpression.right) || ts2.isArrowFunction(binaryExpression.right)) {
                    addNodeWithRecursiveChild(node, binaryExpression.right, className);
                  } else {
                    startNode(binaryExpression, className);
                    addNodeWithRecursiveChild(node, binaryExpression.right, assignmentTarget.name);
                    endNode();
                  }
                  endNestedNodes(depth);
                  return;
                }
                case 7:
                case 9: {
                  var defineCall = node;
                  var className = special === 7 ? defineCall.arguments[0] : defineCall.arguments[0].expression;
                  var memberName = defineCall.arguments[1];
                  var _k = startNestedNodes(node, className), depth = _k[0], classNameIdentifier = _k[1];
                  startNode(node, classNameIdentifier);
                  startNode(node, ts2.setTextRange(ts2.createIdentifier(memberName.text), memberName));
                  addChildrenRecursively(node.arguments[2]);
                  endNode();
                  endNode();
                  endNestedNodes(depth);
                  return;
                }
                case 5: {
                  var binaryExpression = node;
                  var assignmentTarget = binaryExpression.left;
                  var targetFunction = assignmentTarget.expression;
                  if (ts2.isIdentifier(targetFunction) && ts2.getElementOrPropertyAccessName(assignmentTarget) !== "prototype" && trackedEs5Classes && trackedEs5Classes.has(targetFunction.text)) {
                    if (ts2.isFunctionExpression(binaryExpression.right) || ts2.isArrowFunction(binaryExpression.right)) {
                      addNodeWithRecursiveChild(node, binaryExpression.right, targetFunction);
                    } else if (ts2.isBindableStaticAccessExpression(assignmentTarget)) {
                      startNode(binaryExpression, targetFunction);
                      addNodeWithRecursiveChild(binaryExpression.left, binaryExpression.right, ts2.getNameOrArgument(assignmentTarget));
                      endNode();
                    }
                    return;
                  }
                  break;
                }
                case 4:
                case 0:
                case 8:
                  break;
                default:
                  ts2.Debug.assertNever(special);
              }
            }
            default:
              if (ts2.hasJSDocNodes(node)) {
                ts2.forEach(node.jsDoc, function(jsDoc) {
                  ts2.forEach(jsDoc.tags, function(tag) {
                    if (ts2.isJSDocTypeAlias(tag)) {
                      addLeafNode(tag);
                    }
                  });
                });
              }
              ts2.forEachChild(node, addChildrenRecursively);
          }
        }
        function mergeChildren(children, node) {
          var nameToItems = ts2.createMap();
          ts2.filterMutate(children, function(child, index) {
            var declName = child.name || ts2.getNameOfDeclaration(child.node);
            var name = declName && nodeText(declName);
            if (!name) {
              return true;
            }
            var itemsWithSameName = nameToItems.get(name);
            if (!itemsWithSameName) {
              nameToItems.set(name, child);
              return true;
            }
            if (itemsWithSameName instanceof Array) {
              for (var _i = 0, itemsWithSameName_1 = itemsWithSameName; _i < itemsWithSameName_1.length; _i++) {
                var itemWithSameName = itemsWithSameName_1[_i];
                if (tryMerge(itemWithSameName, child, index, node)) {
                  return false;
                }
              }
              itemsWithSameName.push(child);
              return true;
            } else {
              var itemWithSameName = itemsWithSameName;
              if (tryMerge(itemWithSameName, child, index, node)) {
                return false;
              }
              nameToItems.set(name, [itemWithSameName, child]);
              return true;
            }
          });
        }
        var isEs5ClassMember = (_a = {}, _a[5] = true, _a[3] = true, _a[7] = true, _a[9] = true, _a[0] = false, _a[1] = false, _a[2] = false, _a[8] = false, _a[6] = true, _a[4] = false, _a);
        function tryMergeEs5Class(a, b, bIndex, parent2) {
          function isPossibleConstructor(node) {
            return ts2.isFunctionExpression(node) || ts2.isFunctionDeclaration(node) || ts2.isVariableDeclaration(node);
          }
          var bAssignmentDeclarationKind = ts2.isBinaryExpression(b.node) || ts2.isCallExpression(b.node) ? ts2.getAssignmentDeclarationKind(b.node) : 0;
          var aAssignmentDeclarationKind = ts2.isBinaryExpression(a.node) || ts2.isCallExpression(a.node) ? ts2.getAssignmentDeclarationKind(a.node) : 0;
          if (isEs5ClassMember[bAssignmentDeclarationKind] && isEs5ClassMember[aAssignmentDeclarationKind] || isPossibleConstructor(a.node) && isEs5ClassMember[bAssignmentDeclarationKind] || isPossibleConstructor(b.node) && isEs5ClassMember[aAssignmentDeclarationKind] || ts2.isClassDeclaration(a.node) && isEs5ClassMember[bAssignmentDeclarationKind] || ts2.isClassDeclaration(b.node) && isEs5ClassMember[aAssignmentDeclarationKind] || ts2.isClassDeclaration(a.node) && isPossibleConstructor(b.node) || ts2.isClassDeclaration(b.node) && isPossibleConstructor(a.node)) {
            var lastANode = a.additionalNodes && ts2.lastOrUndefined(a.additionalNodes) || a.node;
            if (!ts2.isClassDeclaration(a.node) && !ts2.isClassDeclaration(b.node) || isPossibleConstructor(a.node) || isPossibleConstructor(b.node)) {
              var ctorFunction = isPossibleConstructor(a.node) ? a.node : isPossibleConstructor(b.node) ? b.node : void 0;
              if (ctorFunction !== void 0) {
                var ctorNode = ts2.setTextRange(ts2.createConstructor(void 0, void 0, [], void 0), ctorFunction);
                var ctor = emptyNavigationBarNode(ctorNode);
                ctor.indent = a.indent + 1;
                ctor.children = a.node === ctorFunction ? a.children : b.children;
                a.children = a.node === ctorFunction ? ts2.concatenate([ctor], b.children || [b]) : ts2.concatenate(a.children || [a], [ctor]);
              } else {
                if (a.children || b.children) {
                  a.children = ts2.concatenate(a.children || [a], b.children || [b]);
                  if (a.children) {
                    mergeChildren(a.children, a);
                    sortChildren(a.children);
                  }
                }
              }
              lastANode = a.node = ts2.setTextRange(ts2.createClassDeclaration(void 0, void 0, a.name || ts2.createIdentifier("__class__"), void 0, void 0, []), a.node);
            } else {
              a.children = ts2.concatenate(a.children, b.children);
              if (a.children) {
                mergeChildren(a.children, a);
              }
            }
            var bNode = b.node;
            if (parent2.children[bIndex - 1].node.end === lastANode.end) {
              ts2.setTextRange(lastANode, { pos: lastANode.pos, end: bNode.end });
            } else {
              if (!a.additionalNodes)
                a.additionalNodes = [];
              a.additionalNodes.push(ts2.setTextRange(ts2.createClassDeclaration(void 0, void 0, a.name || ts2.createIdentifier("__class__"), void 0, void 0, []), b.node));
            }
            return true;
          }
          return bAssignmentDeclarationKind === 0 ? false : true;
        }
        function tryMerge(a, b, bIndex, parent2) {
          if (tryMergeEs5Class(a, b, bIndex, parent2)) {
            return true;
          }
          if (shouldReallyMerge(a.node, b.node, parent2)) {
            merge(a, b);
            return true;
          }
          return false;
        }
        function shouldReallyMerge(a, b, parent2) {
          if (a.kind !== b.kind || a.parent !== b.parent && !(isOwnChild(a, parent2) && isOwnChild(b, parent2))) {
            return false;
          }
          switch (a.kind) {
            case 159:
            case 161:
            case 163:
            case 164:
              return ts2.hasModifier(a, 32) === ts2.hasModifier(b, 32);
            case 249:
              return areSameModule(a, b);
            default:
              return true;
          }
        }
        function isOwnChild(n, parent2) {
          var par = ts2.isModuleBlock(n.parent) ? n.parent.parent : n.parent;
          return par === parent2.node || ts2.contains(parent2.additionalNodes, par);
        }
        function areSameModule(a, b) {
          return a.body.kind === b.body.kind && (a.body.kind !== 249 || areSameModule(a.body, b.body));
        }
        function merge(target, source) {
          var _a2;
          target.additionalNodes = target.additionalNodes || [];
          target.additionalNodes.push(source.node);
          if (source.additionalNodes) {
            (_a2 = target.additionalNodes).push.apply(_a2, source.additionalNodes);
          }
          target.children = ts2.concatenate(target.children, source.children);
          if (target.children) {
            mergeChildren(target.children, target);
            sortChildren(target.children);
          }
        }
        function sortChildren(children) {
          children.sort(compareChildren);
        }
        function compareChildren(child1, child2) {
          return ts2.compareStringsCaseSensitiveUI(tryGetName(child1.node), tryGetName(child2.node)) || ts2.compareValues(navigationBarNodeKind(child1), navigationBarNodeKind(child2));
        }
        function tryGetName(node) {
          if (node.kind === 249) {
            return getModuleName(node);
          }
          var declName = ts2.getNameOfDeclaration(node);
          if (declName && ts2.isPropertyName(declName)) {
            var propertyName = ts2.getPropertyNameForPropertyNameNode(declName);
            return propertyName && ts2.unescapeLeadingUnderscores(propertyName);
          }
          switch (node.kind) {
            case 201:
            case 202:
            case 214:
              return getFunctionOrClassName(node);
            default:
              return void 0;
          }
        }
        function getItemName(node, name) {
          if (node.kind === 249) {
            return cleanText(getModuleName(node));
          }
          if (name) {
            var text = ts2.isIdentifier(name) ? name.text : ts2.isElementAccessExpression(name) ? "[" + nodeText(name.argumentExpression) + "]" : nodeText(name);
            if (text.length > 0) {
              return cleanText(text);
            }
          }
          switch (node.kind) {
            case 290:
              var sourceFile = node;
              return ts2.isExternalModule(sourceFile) ? '"' + ts2.escapeString(ts2.getBaseFileName(ts2.removeFileExtension(ts2.normalizePath(sourceFile.fileName)))) + '"' : "<global>";
            case 259:
              return ts2.isExportAssignment(node) && node.isExportEquals ? "export=" : "default";
            case 202:
            case 244:
            case 201:
            case 245:
            case 214:
              if (ts2.getModifierFlags(node) & 512) {
                return "default";
              }
              return getFunctionOrClassName(node);
            case 162:
              return "constructor";
            case 166:
              return "new()";
            case 165:
              return "()";
            case 167:
              return "[]";
            default:
              return "<unknown>";
          }
        }
        function primaryNavBarMenuItems(root) {
          var primaryNavBarMenuItems2 = [];
          function recur(item) {
            if (shouldAppearInPrimaryNavBarMenu(item)) {
              primaryNavBarMenuItems2.push(item);
              if (item.children) {
                for (var _i = 0, _a2 = item.children; _i < _a2.length; _i++) {
                  var child = _a2[_i];
                  recur(child);
                }
              }
            }
          }
          recur(root);
          return primaryNavBarMenuItems2;
          function shouldAppearInPrimaryNavBarMenu(item) {
            if (item.children) {
              return true;
            }
            switch (navigationBarNodeKind(item)) {
              case 245:
              case 214:
              case 248:
              case 246:
              case 249:
              case 290:
              case 247:
              case 322:
              case 315:
                return true;
              case 202:
              case 244:
              case 201:
                return isTopLevelFunctionDeclaration(item);
              default:
                return false;
            }
            function isTopLevelFunctionDeclaration(item2) {
              if (!item2.node.body) {
                return false;
              }
              switch (navigationBarNodeKind(item2.parent)) {
                case 250:
                case 290:
                case 161:
                case 162:
                  return true;
                default:
                  return false;
              }
            }
          }
        }
        function convertToTree(n) {
          return {
            text: getItemName(n.node, n.name),
            kind: ts2.getNodeKind(n.node),
            kindModifiers: getModifiers(n.node),
            spans: getSpans(n),
            nameSpan: n.name && getNodeSpan(n.name),
            childItems: ts2.map(n.children, convertToTree)
          };
        }
        function convertToPrimaryNavBarMenuItem(n) {
          return {
            text: getItemName(n.node, n.name),
            kind: ts2.getNodeKind(n.node),
            kindModifiers: getModifiers(n.node),
            spans: getSpans(n),
            childItems: ts2.map(n.children, convertToSecondaryNavBarMenuItem) || emptyChildItemArray,
            indent: n.indent,
            bolded: false,
            grayed: false
          };
          function convertToSecondaryNavBarMenuItem(n2) {
            return {
              text: getItemName(n2.node, n2.name),
              kind: ts2.getNodeKind(n2.node),
              kindModifiers: ts2.getNodeModifiers(n2.node),
              spans: getSpans(n2),
              childItems: emptyChildItemArray,
              indent: 0,
              bolded: false,
              grayed: false
            };
          }
        }
        function getSpans(n) {
          var spans = [getNodeSpan(n.node)];
          if (n.additionalNodes) {
            for (var _i = 0, _a2 = n.additionalNodes; _i < _a2.length; _i++) {
              var node = _a2[_i];
              spans.push(getNodeSpan(node));
            }
          }
          return spans;
        }
        function getModuleName(moduleDeclaration) {
          if (ts2.isAmbientModule(moduleDeclaration)) {
            return ts2.getTextOfNode(moduleDeclaration.name);
          }
          var result = [];
          result.push(ts2.getTextOfIdentifierOrLiteral(moduleDeclaration.name));
          while (moduleDeclaration.body && moduleDeclaration.body.kind === 249) {
            moduleDeclaration = moduleDeclaration.body;
            result.push(ts2.getTextOfIdentifierOrLiteral(moduleDeclaration.name));
          }
          return result.join(".");
        }
        function getInteriorModule(decl) {
          return decl.body && ts2.isModuleDeclaration(decl.body) ? getInteriorModule(decl.body) : decl;
        }
        function isComputedProperty(member) {
          return !member.name || member.name.kind === 154;
        }
        function getNodeSpan(node) {
          return node.kind === 290 ? ts2.createTextSpanFromRange(node) : ts2.createTextSpanFromNode(node, curSourceFile);
        }
        function getModifiers(node) {
          if (node.parent && node.parent.kind === 242) {
            node = node.parent;
          }
          return ts2.getNodeModifiers(node);
        }
        function getFunctionOrClassName(node) {
          var parent2 = node.parent;
          if (node.name && ts2.getFullWidth(node.name) > 0) {
            return cleanText(ts2.declarationNameToString(node.name));
          } else if (ts2.isVariableDeclaration(parent2)) {
            return cleanText(ts2.declarationNameToString(parent2.name));
          } else if (ts2.isBinaryExpression(parent2) && parent2.operatorToken.kind === 62) {
            return nodeText(parent2.left).replace(whiteSpaceRegex, "");
          } else if (ts2.isPropertyAssignment(parent2)) {
            return nodeText(parent2.name);
          } else if (ts2.getModifierFlags(node) & 512) {
            return "default";
          } else if (ts2.isClassLike(node)) {
            return "<class>";
          } else if (ts2.isCallExpression(parent2)) {
            var name = getCalledExpressionName(parent2.expression);
            if (name !== void 0) {
              name = cleanText(name);
              if (name.length > maxLength) {
                return name + " callback";
              }
              var args = cleanText(ts2.mapDefined(parent2.arguments, function(a) {
                return ts2.isStringLiteralLike(a) ? a.getText(curSourceFile) : void 0;
              }).join(", "));
              return name + "(" + args + ") callback";
            }
          }
          return "<function>";
        }
        function getCalledExpressionName(expr) {
          if (ts2.isIdentifier(expr)) {
            return expr.text;
          } else if (ts2.isPropertyAccessExpression(expr)) {
            var left = getCalledExpressionName(expr.expression);
            var right = expr.name.text;
            return left === void 0 ? right : left + "." + right;
          } else {
            return void 0;
          }
        }
        function isFunctionOrClassExpression(node) {
          switch (node.kind) {
            case 202:
            case 201:
            case 214:
              return true;
            default:
              return false;
          }
        }
        function cleanText(text) {
          text = text.length > maxLength ? text.substring(0, maxLength) + "..." : text;
          return text.replace(/\\?(\r?\n|\r|\u2028|\u2029)/g, "");
        }
      })(NavigationBar = ts2.NavigationBar || (ts2.NavigationBar = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var OrganizeImports;
      (function(OrganizeImports2) {
        function organizeImports(sourceFile, formatContext, host, program, preferences) {
          var changeTracker = ts2.textChanges.ChangeTracker.fromContext({ host, formatContext, preferences });
          var coalesceAndOrganizeImports = function(importGroup) {
            return coalesceImports(removeUnusedImports(importGroup, sourceFile, program));
          };
          var topLevelImportDecls = sourceFile.statements.filter(ts2.isImportDeclaration);
          organizeImportsWorker(topLevelImportDecls, coalesceAndOrganizeImports);
          var topLevelExportDecls = sourceFile.statements.filter(ts2.isExportDeclaration);
          organizeImportsWorker(topLevelExportDecls, coalesceExports);
          for (var _i = 0, _a = sourceFile.statements.filter(ts2.isAmbientModule); _i < _a.length; _i++) {
            var ambientModule = _a[_i];
            if (!ambientModule.body) {
              continue;
            }
            var ambientModuleImportDecls = ambientModule.body.statements.filter(ts2.isImportDeclaration);
            organizeImportsWorker(ambientModuleImportDecls, coalesceAndOrganizeImports);
            var ambientModuleExportDecls = ambientModule.body.statements.filter(ts2.isExportDeclaration);
            organizeImportsWorker(ambientModuleExportDecls, coalesceExports);
          }
          return changeTracker.getChanges();
          function organizeImportsWorker(oldImportDecls, coalesce) {
            if (ts2.length(oldImportDecls) === 0) {
              return;
            }
            ts2.suppressLeadingTrivia(oldImportDecls[0]);
            var oldImportGroups = ts2.group(oldImportDecls, function(importDecl) {
              return getExternalModuleName(importDecl.moduleSpecifier);
            });
            var sortedImportGroups = ts2.stableSort(oldImportGroups, function(group1, group2) {
              return compareModuleSpecifiers(group1[0].moduleSpecifier, group2[0].moduleSpecifier);
            });
            var newImportDecls = ts2.flatMap(sortedImportGroups, function(importGroup) {
              return getExternalModuleName(importGroup[0].moduleSpecifier) ? coalesce(importGroup) : importGroup;
            });
            if (newImportDecls.length === 0) {
              changeTracker.delete(sourceFile, oldImportDecls[0]);
            } else {
              changeTracker.replaceNodeWithNodes(sourceFile, oldImportDecls[0], newImportDecls, {
                leadingTriviaOption: ts2.textChanges.LeadingTriviaOption.Exclude,
                trailingTriviaOption: ts2.textChanges.TrailingTriviaOption.Include,
                suffix: ts2.getNewLineOrDefaultFromHost(host, formatContext.options)
              });
            }
            for (var i = 1; i < oldImportDecls.length; i++) {
              changeTracker.deleteNode(sourceFile, oldImportDecls[i]);
            }
          }
        }
        OrganizeImports2.organizeImports = organizeImports;
        function removeUnusedImports(oldImports, sourceFile, program) {
          var typeChecker = program.getTypeChecker();
          var jsxNamespace = typeChecker.getJsxNamespace(sourceFile);
          var jsxElementsPresent = !!(sourceFile.transformFlags & 2);
          var usedImports = [];
          for (var _i = 0, oldImports_1 = oldImports; _i < oldImports_1.length; _i++) {
            var importDecl = oldImports_1[_i];
            var importClause = importDecl.importClause, moduleSpecifier = importDecl.moduleSpecifier;
            if (!importClause) {
              usedImports.push(importDecl);
              continue;
            }
            var name = importClause.name, namedBindings = importClause.namedBindings;
            if (name && !isDeclarationUsed(name)) {
              name = void 0;
            }
            if (namedBindings) {
              if (ts2.isNamespaceImport(namedBindings)) {
                if (!isDeclarationUsed(namedBindings.name)) {
                  namedBindings = void 0;
                }
              } else {
                var newElements = namedBindings.elements.filter(function(e) {
                  return isDeclarationUsed(e.name);
                });
                if (newElements.length < namedBindings.elements.length) {
                  namedBindings = newElements.length ? ts2.updateNamedImports(namedBindings, newElements) : void 0;
                }
              }
            }
            if (name || namedBindings) {
              usedImports.push(updateImportDeclarationAndClause(importDecl, name, namedBindings));
            } else if (hasModuleDeclarationMatchingSpecifier(sourceFile, moduleSpecifier)) {
              if (sourceFile.isDeclarationFile) {
                usedImports.push(ts2.createImportDeclaration(importDecl.decorators, importDecl.modifiers, void 0, moduleSpecifier));
              } else {
                usedImports.push(importDecl);
              }
            }
          }
          return usedImports;
          function isDeclarationUsed(identifier) {
            return jsxElementsPresent && identifier.text === jsxNamespace || ts2.FindAllReferences.Core.isSymbolReferencedInFile(identifier, typeChecker, sourceFile);
          }
        }
        function hasModuleDeclarationMatchingSpecifier(sourceFile, moduleSpecifier) {
          var moduleSpecifierText = ts2.isStringLiteral(moduleSpecifier) && moduleSpecifier.text;
          return ts2.isString(moduleSpecifierText) && ts2.some(sourceFile.moduleAugmentations, function(moduleName) {
            return ts2.isStringLiteral(moduleName) && moduleName.text === moduleSpecifierText;
          });
        }
        function getExternalModuleName(specifier) {
          return specifier !== void 0 && ts2.isStringLiteralLike(specifier) ? specifier.text : void 0;
        }
        function coalesceImports(importGroup) {
          var _a;
          if (importGroup.length === 0) {
            return importGroup;
          }
          var _b = getCategorizedImports(importGroup), importWithoutClause = _b.importWithoutClause, typeOnlyImports = _b.typeOnlyImports, regularImports = _b.regularImports;
          var coalescedImports = [];
          if (importWithoutClause) {
            coalescedImports.push(importWithoutClause);
          }
          for (var _i = 0, _c = [regularImports, typeOnlyImports]; _i < _c.length; _i++) {
            var group_2 = _c[_i];
            var isTypeOnly = group_2 === typeOnlyImports;
            var defaultImports = group_2.defaultImports, namespaceImports = group_2.namespaceImports, namedImports = group_2.namedImports;
            if (!isTypeOnly && defaultImports.length === 1 && namespaceImports.length === 1 && namedImports.length === 0) {
              var defaultImport = defaultImports[0];
              coalescedImports.push(updateImportDeclarationAndClause(defaultImport, defaultImport.importClause.name, namespaceImports[0].importClause.namedBindings));
              continue;
            }
            var sortedNamespaceImports = ts2.stableSort(namespaceImports, function(i1, i2) {
              return compareIdentifiers(i1.importClause.namedBindings.name, i2.importClause.namedBindings.name);
            });
            for (var _d = 0, sortedNamespaceImports_1 = sortedNamespaceImports; _d < sortedNamespaceImports_1.length; _d++) {
              var namespaceImport = sortedNamespaceImports_1[_d];
              coalescedImports.push(updateImportDeclarationAndClause(namespaceImport, void 0, namespaceImport.importClause.namedBindings));
            }
            if (defaultImports.length === 0 && namedImports.length === 0) {
              continue;
            }
            var newDefaultImport = void 0;
            var newImportSpecifiers = [];
            if (defaultImports.length === 1) {
              newDefaultImport = defaultImports[0].importClause.name;
            } else {
              for (var _e = 0, defaultImports_1 = defaultImports; _e < defaultImports_1.length; _e++) {
                var defaultImport = defaultImports_1[_e];
                newImportSpecifiers.push(ts2.createImportSpecifier(ts2.createIdentifier("default"), defaultImport.importClause.name));
              }
            }
            newImportSpecifiers.push.apply(newImportSpecifiers, ts2.flatMap(namedImports, function(i) {
              return i.importClause.namedBindings.elements;
            }));
            var sortedImportSpecifiers = sortSpecifiers(newImportSpecifiers);
            var importDecl = defaultImports.length > 0 ? defaultImports[0] : namedImports[0];
            var newNamedImports = sortedImportSpecifiers.length === 0 ? newDefaultImport ? void 0 : ts2.createNamedImports(ts2.emptyArray) : namedImports.length === 0 ? ts2.createNamedImports(sortedImportSpecifiers) : ts2.updateNamedImports(namedImports[0].importClause.namedBindings, sortedImportSpecifiers);
            if (isTypeOnly && newDefaultImport && newNamedImports) {
              coalescedImports.push(updateImportDeclarationAndClause(importDecl, newDefaultImport, void 0));
              coalescedImports.push(updateImportDeclarationAndClause((_a = namedImports[0]) !== null && _a !== void 0 ? _a : importDecl, void 0, newNamedImports));
            } else {
              coalescedImports.push(updateImportDeclarationAndClause(importDecl, newDefaultImport, newNamedImports));
            }
          }
          return coalescedImports;
        }
        OrganizeImports2.coalesceImports = coalesceImports;
        function getCategorizedImports(importGroup) {
          var importWithoutClause;
          var typeOnlyImports = { defaultImports: [], namespaceImports: [], namedImports: [] };
          var regularImports = { defaultImports: [], namespaceImports: [], namedImports: [] };
          for (var _i = 0, importGroup_1 = importGroup; _i < importGroup_1.length; _i++) {
            var importDeclaration = importGroup_1[_i];
            if (importDeclaration.importClause === void 0) {
              importWithoutClause = importWithoutClause || importDeclaration;
              continue;
            }
            var group_3 = importDeclaration.importClause.isTypeOnly ? typeOnlyImports : regularImports;
            var _a = importDeclaration.importClause, name = _a.name, namedBindings = _a.namedBindings;
            if (name) {
              group_3.defaultImports.push(importDeclaration);
            }
            if (namedBindings) {
              if (ts2.isNamespaceImport(namedBindings)) {
                group_3.namespaceImports.push(importDeclaration);
              } else {
                group_3.namedImports.push(importDeclaration);
              }
            }
          }
          return {
            importWithoutClause,
            typeOnlyImports,
            regularImports
          };
        }
        function coalesceExports(exportGroup) {
          if (exportGroup.length === 0) {
            return exportGroup;
          }
          var _a = getCategorizedExports(exportGroup), exportWithoutClause = _a.exportWithoutClause, namedExports = _a.namedExports, typeOnlyExports = _a.typeOnlyExports;
          var coalescedExports = [];
          if (exportWithoutClause) {
            coalescedExports.push(exportWithoutClause);
          }
          for (var _i = 0, _b = [namedExports, typeOnlyExports]; _i < _b.length; _i++) {
            var exportGroup_1 = _b[_i];
            if (exportGroup_1.length === 0) {
              continue;
            }
            var newExportSpecifiers = [];
            newExportSpecifiers.push.apply(newExportSpecifiers, ts2.flatMap(exportGroup_1, function(i) {
              return i.exportClause && ts2.isNamedExports(i.exportClause) ? i.exportClause.elements : ts2.emptyArray;
            }));
            var sortedExportSpecifiers = sortSpecifiers(newExportSpecifiers);
            var exportDecl = exportGroup_1[0];
            coalescedExports.push(ts2.updateExportDeclaration(exportDecl, exportDecl.decorators, exportDecl.modifiers, exportDecl.exportClause && (ts2.isNamedExports(exportDecl.exportClause) ? ts2.updateNamedExports(exportDecl.exportClause, sortedExportSpecifiers) : ts2.updateNamespaceExport(exportDecl.exportClause, exportDecl.exportClause.name)), exportDecl.moduleSpecifier, exportDecl.isTypeOnly));
          }
          return coalescedExports;
          function getCategorizedExports(exportGroup2) {
            var exportWithoutClause2;
            var namedExports2 = [];
            var typeOnlyExports2 = [];
            for (var _i2 = 0, exportGroup_2 = exportGroup2; _i2 < exportGroup_2.length; _i2++) {
              var exportDeclaration = exportGroup_2[_i2];
              if (exportDeclaration.exportClause === void 0) {
                exportWithoutClause2 = exportWithoutClause2 || exportDeclaration;
              } else if (exportDeclaration.isTypeOnly) {
                typeOnlyExports2.push(exportDeclaration);
              } else {
                namedExports2.push(exportDeclaration);
              }
            }
            return {
              exportWithoutClause: exportWithoutClause2,
              namedExports: namedExports2,
              typeOnlyExports: typeOnlyExports2
            };
          }
        }
        OrganizeImports2.coalesceExports = coalesceExports;
        function updateImportDeclarationAndClause(importDeclaration, name, namedBindings) {
          return ts2.updateImportDeclaration(importDeclaration, importDeclaration.decorators, importDeclaration.modifiers, ts2.updateImportClause(importDeclaration.importClause, name, namedBindings, importDeclaration.importClause.isTypeOnly), importDeclaration.moduleSpecifier);
        }
        function sortSpecifiers(specifiers) {
          return ts2.stableSort(specifiers, function(s1, s2) {
            return compareIdentifiers(s1.propertyName || s1.name, s2.propertyName || s2.name) || compareIdentifiers(s1.name, s2.name);
          });
        }
        function compareModuleSpecifiers(m1, m2) {
          var name1 = getExternalModuleName(m1);
          var name2 = getExternalModuleName(m2);
          return ts2.compareBooleans(name1 === void 0, name2 === void 0) || ts2.compareBooleans(ts2.isExternalModuleNameRelative(name1), ts2.isExternalModuleNameRelative(name2)) || ts2.compareStringsCaseInsensitive(name1, name2);
        }
        OrganizeImports2.compareModuleSpecifiers = compareModuleSpecifiers;
        function compareIdentifiers(s1, s2) {
          return ts2.compareStringsCaseInsensitive(s1.text, s2.text);
        }
      })(OrganizeImports = ts2.OrganizeImports || (ts2.OrganizeImports = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var OutliningElementsCollector;
      (function(OutliningElementsCollector2) {
        function collectElements(sourceFile, cancellationToken) {
          var res = [];
          addNodeOutliningSpans(sourceFile, cancellationToken, res);
          addRegionOutliningSpans(sourceFile, res);
          return res.sort(function(span1, span2) {
            return span1.textSpan.start - span2.textSpan.start;
          });
        }
        OutliningElementsCollector2.collectElements = collectElements;
        function addNodeOutliningSpans(sourceFile, cancellationToken, out) {
          var depthRemaining = 40;
          var current = 0;
          var statements = __spreadArrays(sourceFile.statements, [sourceFile.endOfFileToken]);
          var n = statements.length;
          while (current < n) {
            while (current < n && !ts2.isAnyImportSyntax(statements[current])) {
              visitNonImportNode(statements[current]);
              current++;
            }
            if (current === n)
              break;
            var firstImport = current;
            while (current < n && ts2.isAnyImportSyntax(statements[current])) {
              addOutliningForLeadingCommentsForNode(statements[current], sourceFile, cancellationToken, out);
              current++;
            }
            var lastImport = current - 1;
            if (lastImport !== firstImport) {
              out.push(createOutliningSpanFromBounds(ts2.findChildOfKind(statements[firstImport], 96, sourceFile).getStart(sourceFile), statements[lastImport].getEnd(), "imports"));
            }
          }
          function visitNonImportNode(n2) {
            var _a;
            if (depthRemaining === 0)
              return;
            cancellationToken.throwIfCancellationRequested();
            if (ts2.isDeclaration(n2) || n2.kind === 1) {
              addOutliningForLeadingCommentsForNode(n2, sourceFile, cancellationToken, out);
            }
            if (isFunctionExpressionAssignedToVariable(n2)) {
              addOutliningForLeadingCommentsForNode(n2.parent.parent.parent, sourceFile, cancellationToken, out);
            }
            var span = getOutliningSpanForNode(n2, sourceFile);
            if (span)
              out.push(span);
            depthRemaining--;
            if (ts2.isCallExpression(n2)) {
              depthRemaining++;
              visitNonImportNode(n2.expression);
              depthRemaining--;
              n2.arguments.forEach(visitNonImportNode);
              (_a = n2.typeArguments) === null || _a === void 0 ? void 0 : _a.forEach(visitNonImportNode);
            } else if (ts2.isIfStatement(n2) && n2.elseStatement && ts2.isIfStatement(n2.elseStatement)) {
              visitNonImportNode(n2.expression);
              visitNonImportNode(n2.thenStatement);
              depthRemaining++;
              visitNonImportNode(n2.elseStatement);
              depthRemaining--;
            } else {
              n2.forEachChild(visitNonImportNode);
            }
            depthRemaining++;
          }
          function isFunctionExpressionAssignedToVariable(n2) {
            if (!ts2.isFunctionExpression(n2) && !ts2.isArrowFunction(n2)) {
              return false;
            }
            var ancestor = ts2.findAncestor(n2, ts2.isVariableStatement);
            return !!ancestor && ts2.getSingleInitializerOfVariableStatementOrPropertyDeclaration(ancestor) === n2;
          }
        }
        function addRegionOutliningSpans(sourceFile, out) {
          var regions = [];
          var lineStarts = sourceFile.getLineStarts();
          for (var _i = 0, lineStarts_1 = lineStarts; _i < lineStarts_1.length; _i++) {
            var currentLineStart = lineStarts_1[_i];
            var lineEnd = sourceFile.getLineEndOfPosition(currentLineStart);
            var lineText = sourceFile.text.substring(currentLineStart, lineEnd);
            var result = isRegionDelimiter(lineText);
            if (!result || ts2.isInComment(sourceFile, currentLineStart)) {
              continue;
            }
            if (!result[1]) {
              var span = ts2.createTextSpanFromBounds(sourceFile.text.indexOf("//", currentLineStart), lineEnd);
              regions.push(createOutliningSpan(span, "region", span, false, result[2] || "#region"));
            } else {
              var region = regions.pop();
              if (region) {
                region.textSpan.length = lineEnd - region.textSpan.start;
                region.hintSpan.length = lineEnd - region.textSpan.start;
                out.push(region);
              }
            }
          }
        }
        var regionDelimiterRegExp = /^\s*\/\/\s*#(end)?region(?:\s+(.*))?(?:\r)?$/;
        function isRegionDelimiter(lineText) {
          return regionDelimiterRegExp.exec(lineText);
        }
        function addOutliningForLeadingCommentsForNode(n, sourceFile, cancellationToken, out) {
          var comments = ts2.getLeadingCommentRangesOfNode(n, sourceFile);
          if (!comments)
            return;
          var firstSingleLineCommentStart = -1;
          var lastSingleLineCommentEnd = -1;
          var singleLineCommentCount = 0;
          var sourceText = sourceFile.getFullText();
          for (var _i = 0, comments_1 = comments; _i < comments_1.length; _i++) {
            var _a = comments_1[_i], kind = _a.kind, pos = _a.pos, end = _a.end;
            cancellationToken.throwIfCancellationRequested();
            switch (kind) {
              case 2:
                var commentText = sourceText.slice(pos, end);
                if (isRegionDelimiter(commentText)) {
                  combineAndAddMultipleSingleLineComments();
                  singleLineCommentCount = 0;
                  break;
                }
                if (singleLineCommentCount === 0) {
                  firstSingleLineCommentStart = pos;
                }
                lastSingleLineCommentEnd = end;
                singleLineCommentCount++;
                break;
              case 3:
                combineAndAddMultipleSingleLineComments();
                out.push(createOutliningSpanFromBounds(pos, end, "comment"));
                singleLineCommentCount = 0;
                break;
              default:
                ts2.Debug.assertNever(kind);
            }
          }
          combineAndAddMultipleSingleLineComments();
          function combineAndAddMultipleSingleLineComments() {
            if (singleLineCommentCount > 1) {
              out.push(createOutliningSpanFromBounds(firstSingleLineCommentStart, lastSingleLineCommentEnd, "comment"));
            }
          }
        }
        function createOutliningSpanFromBounds(pos, end, kind) {
          return createOutliningSpan(ts2.createTextSpanFromBounds(pos, end), kind);
        }
        function getOutliningSpanForNode(n, sourceFile) {
          switch (n.kind) {
            case 223:
              if (ts2.isFunctionLike(n.parent)) {
                return functionSpan(n.parent, n, sourceFile);
              }
              switch (n.parent.kind) {
                case 228:
                case 231:
                case 232:
                case 230:
                case 227:
                case 229:
                case 236:
                case 280:
                  return spanForNode(n.parent);
                case 240:
                  var tryStatement = n.parent;
                  if (tryStatement.tryBlock === n) {
                    return spanForNode(n.parent);
                  } else if (tryStatement.finallyBlock === n) {
                    var node = ts2.findChildOfKind(tryStatement, 92, sourceFile);
                    if (node)
                      return spanForNode(node);
                  }
                default:
                  return createOutliningSpan(ts2.createTextSpanFromNode(n, sourceFile), "code");
              }
            case 250:
              return spanForNode(n.parent);
            case 245:
            case 214:
            case 246:
            case 248:
            case 251:
            case 173:
              return spanForNode(n);
            case 277:
            case 278:
              return spanForNodeArray(n.statements);
            case 193:
              return spanForObjectOrArrayLiteral(n);
            case 192:
              return spanForObjectOrArrayLiteral(n, 22);
            case 266:
              return spanForJSXElement(n);
            case 270:
              return spanForJSXFragment(n);
            case 267:
            case 268:
              return spanForJSXAttributes(n.attributes);
            case 211:
            case 14:
              return spanForTemplateLiteral(n);
          }
          function spanForJSXElement(node2) {
            var textSpan = ts2.createTextSpanFromBounds(node2.openingElement.getStart(sourceFile), node2.closingElement.getEnd());
            var tagName = node2.openingElement.tagName.getText(sourceFile);
            var bannerText = "<" + tagName + ">...</" + tagName + ">";
            return createOutliningSpan(textSpan, "code", textSpan, false, bannerText);
          }
          function spanForJSXFragment(node2) {
            var textSpan = ts2.createTextSpanFromBounds(node2.openingFragment.getStart(sourceFile), node2.closingFragment.getEnd());
            var bannerText = "<>...</>";
            return createOutliningSpan(textSpan, "code", textSpan, false, bannerText);
          }
          function spanForJSXAttributes(node2) {
            if (node2.properties.length === 0) {
              return void 0;
            }
            return createOutliningSpanFromBounds(node2.getStart(sourceFile), node2.getEnd(), "code");
          }
          function spanForTemplateLiteral(node2) {
            if (node2.kind === 14 && node2.text.length === 0) {
              return void 0;
            }
            return createOutliningSpanFromBounds(node2.getStart(sourceFile), node2.getEnd(), "code");
          }
          function spanForObjectOrArrayLiteral(node2, open) {
            if (open === void 0) {
              open = 18;
            }
            return spanForNode(node2, false, !ts2.isArrayLiteralExpression(node2.parent) && !ts2.isCallExpression(node2.parent), open);
          }
          function spanForNode(hintSpanNode, autoCollapse, useFullStart, open, close) {
            if (autoCollapse === void 0) {
              autoCollapse = false;
            }
            if (useFullStart === void 0) {
              useFullStart = true;
            }
            if (open === void 0) {
              open = 18;
            }
            if (close === void 0) {
              close = open === 18 ? 19 : 23;
            }
            var openToken = ts2.findChildOfKind(n, open, sourceFile);
            var closeToken = ts2.findChildOfKind(n, close, sourceFile);
            return openToken && closeToken && spanBetweenTokens(openToken, closeToken, hintSpanNode, sourceFile, autoCollapse, useFullStart);
          }
          function spanForNodeArray(nodeArray) {
            return nodeArray.length ? createOutliningSpan(ts2.createTextSpanFromRange(nodeArray), "code") : void 0;
          }
        }
        function functionSpan(node, body, sourceFile) {
          var openToken = ts2.isNodeArrayMultiLine(node.parameters, sourceFile) ? ts2.findChildOfKind(node, 20, sourceFile) : ts2.findChildOfKind(body, 18, sourceFile);
          var closeToken = ts2.findChildOfKind(body, 19, sourceFile);
          return openToken && closeToken && spanBetweenTokens(openToken, closeToken, node, sourceFile, node.kind !== 202);
        }
        function spanBetweenTokens(openToken, closeToken, hintSpanNode, sourceFile, autoCollapse, useFullStart) {
          if (autoCollapse === void 0) {
            autoCollapse = false;
          }
          if (useFullStart === void 0) {
            useFullStart = true;
          }
          var textSpan = ts2.createTextSpanFromBounds(useFullStart ? openToken.getFullStart() : openToken.getStart(sourceFile), closeToken.getEnd());
          return createOutliningSpan(textSpan, "code", ts2.createTextSpanFromNode(hintSpanNode, sourceFile), autoCollapse);
        }
        function createOutliningSpan(textSpan, kind, hintSpan, autoCollapse, bannerText) {
          if (hintSpan === void 0) {
            hintSpan = textSpan;
          }
          if (autoCollapse === void 0) {
            autoCollapse = false;
          }
          if (bannerText === void 0) {
            bannerText = "...";
          }
          return { textSpan, kind, hintSpan, bannerText, autoCollapse };
        }
      })(OutliningElementsCollector = ts2.OutliningElementsCollector || (ts2.OutliningElementsCollector = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var PatternMatchKind;
      (function(PatternMatchKind2) {
        PatternMatchKind2[PatternMatchKind2["exact"] = 0] = "exact";
        PatternMatchKind2[PatternMatchKind2["prefix"] = 1] = "prefix";
        PatternMatchKind2[PatternMatchKind2["substring"] = 2] = "substring";
        PatternMatchKind2[PatternMatchKind2["camelCase"] = 3] = "camelCase";
      })(PatternMatchKind = ts2.PatternMatchKind || (ts2.PatternMatchKind = {}));
      function createPatternMatch(kind, isCaseSensitive) {
        return {
          kind,
          isCaseSensitive
        };
      }
      function createPatternMatcher(pattern) {
        var stringToWordSpans = ts2.createMap();
        var dotSeparatedSegments = pattern.trim().split(".").map(function(p) {
          return createSegment(p.trim());
        });
        if (dotSeparatedSegments.some(function(segment) {
          return !segment.subWordTextChunks.length;
        }))
          return void 0;
        return {
          getFullMatch: function(containers, candidate) {
            return getFullMatch(containers, candidate, dotSeparatedSegments, stringToWordSpans);
          },
          getMatchForLastSegmentOfPattern: function(candidate) {
            return matchSegment(candidate, ts2.last(dotSeparatedSegments), stringToWordSpans);
          },
          patternContainsDots: dotSeparatedSegments.length > 1
        };
      }
      ts2.createPatternMatcher = createPatternMatcher;
      function getFullMatch(candidateContainers, candidate, dotSeparatedSegments, stringToWordSpans) {
        var candidateMatch = matchSegment(candidate, ts2.last(dotSeparatedSegments), stringToWordSpans);
        if (!candidateMatch) {
          return void 0;
        }
        if (dotSeparatedSegments.length - 1 > candidateContainers.length) {
          return void 0;
        }
        var bestMatch;
        for (var i = dotSeparatedSegments.length - 2, j = candidateContainers.length - 1; i >= 0; i -= 1, j -= 1) {
          bestMatch = betterMatch(bestMatch, matchSegment(candidateContainers[j], dotSeparatedSegments[i], stringToWordSpans));
        }
        return bestMatch;
      }
      function getWordSpans(word, stringToWordSpans) {
        var spans = stringToWordSpans.get(word);
        if (!spans) {
          stringToWordSpans.set(word, spans = breakIntoWordSpans(word));
        }
        return spans;
      }
      function matchTextChunk(candidate, chunk, stringToWordSpans) {
        var index = indexOfIgnoringCase(candidate, chunk.textLowerCase);
        if (index === 0) {
          return createPatternMatch(chunk.text.length === candidate.length ? PatternMatchKind.exact : PatternMatchKind.prefix, ts2.startsWith(candidate, chunk.text));
        }
        if (chunk.isLowerCase) {
          if (index === -1)
            return void 0;
          var wordSpans = getWordSpans(candidate, stringToWordSpans);
          for (var _i = 0, wordSpans_1 = wordSpans; _i < wordSpans_1.length; _i++) {
            var span = wordSpans_1[_i];
            if (partStartsWith(candidate, span, chunk.text, true)) {
              return createPatternMatch(PatternMatchKind.substring, partStartsWith(candidate, span, chunk.text, false));
            }
          }
          if (chunk.text.length < candidate.length && isUpperCaseLetter(candidate.charCodeAt(index))) {
            return createPatternMatch(PatternMatchKind.substring, false);
          }
        } else {
          if (candidate.indexOf(chunk.text) > 0) {
            return createPatternMatch(PatternMatchKind.substring, true);
          }
          if (chunk.characterSpans.length > 0) {
            var candidateParts = getWordSpans(candidate, stringToWordSpans);
            var isCaseSensitive = tryCamelCaseMatch(candidate, candidateParts, chunk, false) ? true : tryCamelCaseMatch(candidate, candidateParts, chunk, true) ? false : void 0;
            if (isCaseSensitive !== void 0) {
              return createPatternMatch(PatternMatchKind.camelCase, isCaseSensitive);
            }
          }
        }
      }
      function matchSegment(candidate, segment, stringToWordSpans) {
        if (every(segment.totalTextChunk.text, function(ch) {
          return ch !== 32 && ch !== 42;
        })) {
          var match = matchTextChunk(candidate, segment.totalTextChunk, stringToWordSpans);
          if (match)
            return match;
        }
        var subWordTextChunks = segment.subWordTextChunks;
        var bestMatch;
        for (var _i = 0, subWordTextChunks_1 = subWordTextChunks; _i < subWordTextChunks_1.length; _i++) {
          var subWordTextChunk = subWordTextChunks_1[_i];
          bestMatch = betterMatch(bestMatch, matchTextChunk(candidate, subWordTextChunk, stringToWordSpans));
        }
        return bestMatch;
      }
      function betterMatch(a, b) {
        return ts2.min(a, b, compareMatches);
      }
      function compareMatches(a, b) {
        return a === void 0 ? 1 : b === void 0 ? -1 : ts2.compareValues(a.kind, b.kind) || ts2.compareBooleans(!a.isCaseSensitive, !b.isCaseSensitive);
      }
      function partStartsWith(candidate, candidateSpan, pattern, ignoreCase, patternSpan) {
        if (patternSpan === void 0) {
          patternSpan = { start: 0, length: pattern.length };
        }
        return patternSpan.length <= candidateSpan.length && everyInRange(0, patternSpan.length, function(i) {
          return equalChars(pattern.charCodeAt(patternSpan.start + i), candidate.charCodeAt(candidateSpan.start + i), ignoreCase);
        });
      }
      function equalChars(ch1, ch2, ignoreCase) {
        return ignoreCase ? toLowerCase(ch1) === toLowerCase(ch2) : ch1 === ch2;
      }
      function tryCamelCaseMatch(candidate, candidateParts, chunk, ignoreCase) {
        var chunkCharacterSpans = chunk.characterSpans;
        var currentCandidate = 0;
        var currentChunkSpan = 0;
        var firstMatch;
        var contiguous;
        while (true) {
          if (currentChunkSpan === chunkCharacterSpans.length) {
            return true;
          } else if (currentCandidate === candidateParts.length) {
            return false;
          }
          var candidatePart = candidateParts[currentCandidate];
          var gotOneMatchThisCandidate = false;
          for (; currentChunkSpan < chunkCharacterSpans.length; currentChunkSpan++) {
            var chunkCharacterSpan = chunkCharacterSpans[currentChunkSpan];
            if (gotOneMatchThisCandidate) {
              if (!isUpperCaseLetter(chunk.text.charCodeAt(chunkCharacterSpans[currentChunkSpan - 1].start)) || !isUpperCaseLetter(chunk.text.charCodeAt(chunkCharacterSpans[currentChunkSpan].start))) {
                break;
              }
            }
            if (!partStartsWith(candidate, candidatePart, chunk.text, ignoreCase, chunkCharacterSpan)) {
              break;
            }
            gotOneMatchThisCandidate = true;
            firstMatch = firstMatch === void 0 ? currentCandidate : firstMatch;
            contiguous = contiguous === void 0 ? true : contiguous;
            candidatePart = ts2.createTextSpan(candidatePart.start + chunkCharacterSpan.length, candidatePart.length - chunkCharacterSpan.length);
          }
          if (!gotOneMatchThisCandidate && contiguous !== void 0) {
            contiguous = false;
          }
          currentCandidate++;
        }
      }
      function createSegment(text) {
        return {
          totalTextChunk: createTextChunk(text),
          subWordTextChunks: breakPatternIntoTextChunks(text)
        };
      }
      function isUpperCaseLetter(ch) {
        if (ch >= 65 && ch <= 90) {
          return true;
        }
        if (ch < 127 || !ts2.isUnicodeIdentifierStart(ch, 99)) {
          return false;
        }
        var str = String.fromCharCode(ch);
        return str === str.toUpperCase();
      }
      function isLowerCaseLetter(ch) {
        if (ch >= 97 && ch <= 122) {
          return true;
        }
        if (ch < 127 || !ts2.isUnicodeIdentifierStart(ch, 99)) {
          return false;
        }
        var str = String.fromCharCode(ch);
        return str === str.toLowerCase();
      }
      function indexOfIgnoringCase(str, value) {
        var n = str.length - value.length;
        var _loop_6 = function(start2) {
          if (every(value, function(valueChar, i) {
            return toLowerCase(str.charCodeAt(i + start2)) === valueChar;
          })) {
            return { value: start2 };
          }
        };
        for (var start = 0; start <= n; start++) {
          var state_1 = _loop_6(start);
          if (typeof state_1 === "object")
            return state_1.value;
        }
        return -1;
      }
      function toLowerCase(ch) {
        if (ch >= 65 && ch <= 90) {
          return 97 + (ch - 65);
        }
        if (ch < 127) {
          return ch;
        }
        return String.fromCharCode(ch).toLowerCase().charCodeAt(0);
      }
      function isDigit(ch) {
        return ch >= 48 && ch <= 57;
      }
      function isWordChar(ch) {
        return isUpperCaseLetter(ch) || isLowerCaseLetter(ch) || isDigit(ch) || ch === 95 || ch === 36;
      }
      function breakPatternIntoTextChunks(pattern) {
        var result = [];
        var wordStart = 0;
        var wordLength = 0;
        for (var i = 0; i < pattern.length; i++) {
          var ch = pattern.charCodeAt(i);
          if (isWordChar(ch)) {
            if (wordLength === 0) {
              wordStart = i;
            }
            wordLength++;
          } else {
            if (wordLength > 0) {
              result.push(createTextChunk(pattern.substr(wordStart, wordLength)));
              wordLength = 0;
            }
          }
        }
        if (wordLength > 0) {
          result.push(createTextChunk(pattern.substr(wordStart, wordLength)));
        }
        return result;
      }
      function createTextChunk(text) {
        var textLowerCase = text.toLowerCase();
        return {
          text,
          textLowerCase,
          isLowerCase: text === textLowerCase,
          characterSpans: breakIntoCharacterSpans(text)
        };
      }
      function breakIntoCharacterSpans(identifier) {
        return breakIntoSpans(identifier, false);
      }
      ts2.breakIntoCharacterSpans = breakIntoCharacterSpans;
      function breakIntoWordSpans(identifier) {
        return breakIntoSpans(identifier, true);
      }
      ts2.breakIntoWordSpans = breakIntoWordSpans;
      function breakIntoSpans(identifier, word) {
        var result = [];
        var wordStart = 0;
        for (var i = 1; i < identifier.length; i++) {
          var lastIsDigit = isDigit(identifier.charCodeAt(i - 1));
          var currentIsDigit = isDigit(identifier.charCodeAt(i));
          var hasTransitionFromLowerToUpper = transitionFromLowerToUpper(identifier, word, i);
          var hasTransitionFromUpperToLower = word && transitionFromUpperToLower(identifier, i, wordStart);
          if (charIsPunctuation(identifier.charCodeAt(i - 1)) || charIsPunctuation(identifier.charCodeAt(i)) || lastIsDigit !== currentIsDigit || hasTransitionFromLowerToUpper || hasTransitionFromUpperToLower) {
            if (!isAllPunctuation(identifier, wordStart, i)) {
              result.push(ts2.createTextSpan(wordStart, i - wordStart));
            }
            wordStart = i;
          }
        }
        if (!isAllPunctuation(identifier, wordStart, identifier.length)) {
          result.push(ts2.createTextSpan(wordStart, identifier.length - wordStart));
        }
        return result;
      }
      function charIsPunctuation(ch) {
        switch (ch) {
          case 33:
          case 34:
          case 35:
          case 37:
          case 38:
          case 39:
          case 40:
          case 41:
          case 42:
          case 44:
          case 45:
          case 46:
          case 47:
          case 58:
          case 59:
          case 63:
          case 64:
          case 91:
          case 92:
          case 93:
          case 95:
          case 123:
          case 125:
            return true;
        }
        return false;
      }
      function isAllPunctuation(identifier, start, end) {
        return every(identifier, function(ch) {
          return charIsPunctuation(ch) && ch !== 95;
        }, start, end);
      }
      function transitionFromUpperToLower(identifier, index, wordStart) {
        return index !== wordStart && index + 1 < identifier.length && isUpperCaseLetter(identifier.charCodeAt(index)) && isLowerCaseLetter(identifier.charCodeAt(index + 1)) && every(identifier, isUpperCaseLetter, wordStart, index);
      }
      function transitionFromLowerToUpper(identifier, word, index) {
        var lastIsUpper = isUpperCaseLetter(identifier.charCodeAt(index - 1));
        var currentIsUpper = isUpperCaseLetter(identifier.charCodeAt(index));
        return currentIsUpper && (!word || !lastIsUpper);
      }
      function everyInRange(start, end, pred) {
        for (var i = start; i < end; i++) {
          if (!pred(i)) {
            return false;
          }
        }
        return true;
      }
      function every(s, pred, start, end) {
        if (start === void 0) {
          start = 0;
        }
        if (end === void 0) {
          end = s.length;
        }
        return everyInRange(start, end, function(i) {
          return pred(s.charCodeAt(i), i);
        });
      }
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function preProcessFile(sourceText, readImportFiles, detectJavaScriptImports) {
        if (readImportFiles === void 0) {
          readImportFiles = true;
        }
        if (detectJavaScriptImports === void 0) {
          detectJavaScriptImports = false;
        }
        var pragmaContext = {
          languageVersion: 1,
          pragmas: void 0,
          checkJsDirective: void 0,
          referencedFiles: [],
          typeReferenceDirectives: [],
          libReferenceDirectives: [],
          amdDependencies: [],
          hasNoDefaultLib: void 0,
          moduleName: void 0
        };
        var importedFiles = [];
        var ambientExternalModules;
        var lastToken;
        var currentToken;
        var braceNesting = 0;
        var externalModule = false;
        function nextToken() {
          lastToken = currentToken;
          currentToken = ts2.scanner.scan();
          if (currentToken === 18) {
            braceNesting++;
          } else if (currentToken === 19) {
            braceNesting--;
          }
          return currentToken;
        }
        function getFileReference() {
          var fileName = ts2.scanner.getTokenValue();
          var pos = ts2.scanner.getTokenPos();
          return { fileName, pos, end: pos + fileName.length };
        }
        function recordAmbientExternalModule() {
          if (!ambientExternalModules) {
            ambientExternalModules = [];
          }
          ambientExternalModules.push({ ref: getFileReference(), depth: braceNesting });
        }
        function recordModuleName() {
          importedFiles.push(getFileReference());
          markAsExternalModuleIfTopLevel();
        }
        function markAsExternalModuleIfTopLevel() {
          if (braceNesting === 0) {
            externalModule = true;
          }
        }
        function tryConsumeDeclare() {
          var token = ts2.scanner.getToken();
          if (token === 130) {
            token = nextToken();
            if (token === 135) {
              token = nextToken();
              if (token === 10) {
                recordAmbientExternalModule();
              }
            }
            return true;
          }
          return false;
        }
        function tryConsumeImport() {
          if (lastToken === 24) {
            return false;
          }
          var token = ts2.scanner.getToken();
          if (token === 96) {
            token = nextToken();
            if (token === 20) {
              token = nextToken();
              if (token === 10 || token === 14) {
                recordModuleName();
                return true;
              }
            } else if (token === 10) {
              recordModuleName();
              return true;
            } else {
              if (token === 145) {
                var skipTypeKeyword = ts2.scanner.lookAhead(function() {
                  var token2 = ts2.scanner.scan();
                  return token2 !== 149 && (token2 === 41 || token2 === 18 || token2 === 75 || ts2.isKeyword(token2));
                });
                if (skipTypeKeyword) {
                  token = nextToken();
                }
              }
              if (token === 75 || ts2.isKeyword(token)) {
                token = nextToken();
                if (token === 149) {
                  token = nextToken();
                  if (token === 10) {
                    recordModuleName();
                    return true;
                  }
                } else if (token === 62) {
                  if (tryConsumeRequireCall(true)) {
                    return true;
                  }
                } else if (token === 27) {
                  token = nextToken();
                } else {
                  return true;
                }
              }
              if (token === 18) {
                token = nextToken();
                while (token !== 19 && token !== 1) {
                  token = nextToken();
                }
                if (token === 19) {
                  token = nextToken();
                  if (token === 149) {
                    token = nextToken();
                    if (token === 10) {
                      recordModuleName();
                    }
                  }
                }
              } else if (token === 41) {
                token = nextToken();
                if (token === 123) {
                  token = nextToken();
                  if (token === 75 || ts2.isKeyword(token)) {
                    token = nextToken();
                    if (token === 149) {
                      token = nextToken();
                      if (token === 10) {
                        recordModuleName();
                      }
                    }
                  }
                }
              }
            }
            return true;
          }
          return false;
        }
        function tryConsumeExport() {
          var token = ts2.scanner.getToken();
          if (token === 89) {
            markAsExternalModuleIfTopLevel();
            token = nextToken();
            if (token === 145) {
              var skipTypeKeyword = ts2.scanner.lookAhead(function() {
                var token2 = ts2.scanner.scan();
                return token2 === 41 || token2 === 18;
              });
              if (skipTypeKeyword) {
                token = nextToken();
              }
            }
            if (token === 18) {
              token = nextToken();
              while (token !== 19 && token !== 1) {
                token = nextToken();
              }
              if (token === 19) {
                token = nextToken();
                if (token === 149) {
                  token = nextToken();
                  if (token === 10) {
                    recordModuleName();
                  }
                }
              }
            } else if (token === 41) {
              token = nextToken();
              if (token === 149) {
                token = nextToken();
                if (token === 10) {
                  recordModuleName();
                }
              }
            } else if (token === 96) {
              token = nextToken();
              if (token === 145) {
                var skipTypeKeyword = ts2.scanner.lookAhead(function() {
                  var token2 = ts2.scanner.scan();
                  return token2 === 75 || ts2.isKeyword(token2);
                });
                if (skipTypeKeyword) {
                  token = nextToken();
                }
              }
              if (token === 75 || ts2.isKeyword(token)) {
                token = nextToken();
                if (token === 62) {
                  if (tryConsumeRequireCall(true)) {
                    return true;
                  }
                }
              }
            }
            return true;
          }
          return false;
        }
        function tryConsumeRequireCall(skipCurrentToken, allowTemplateLiterals) {
          if (allowTemplateLiterals === void 0) {
            allowTemplateLiterals = false;
          }
          var token = skipCurrentToken ? nextToken() : ts2.scanner.getToken();
          if (token === 139) {
            token = nextToken();
            if (token === 20) {
              token = nextToken();
              if (token === 10 || allowTemplateLiterals && token === 14) {
                recordModuleName();
              }
            }
            return true;
          }
          return false;
        }
        function tryConsumeDefine() {
          var token = ts2.scanner.getToken();
          if (token === 75 && ts2.scanner.getTokenValue() === "define") {
            token = nextToken();
            if (token !== 20) {
              return true;
            }
            token = nextToken();
            if (token === 10 || token === 14) {
              token = nextToken();
              if (token === 27) {
                token = nextToken();
              } else {
                return true;
              }
            }
            if (token !== 22) {
              return true;
            }
            token = nextToken();
            while (token !== 23 && token !== 1) {
              if (token === 10 || token === 14) {
                recordModuleName();
              }
              token = nextToken();
            }
            return true;
          }
          return false;
        }
        function processImports() {
          ts2.scanner.setText(sourceText);
          nextToken();
          while (true) {
            if (ts2.scanner.getToken() === 1) {
              break;
            }
            if (tryConsumeDeclare() || tryConsumeImport() || tryConsumeExport() || detectJavaScriptImports && (tryConsumeRequireCall(false, true) || tryConsumeDefine())) {
              continue;
            } else {
              nextToken();
            }
          }
          ts2.scanner.setText(void 0);
        }
        if (readImportFiles) {
          processImports();
        }
        ts2.processCommentPragmas(pragmaContext, sourceText);
        ts2.processPragmasIntoFields(pragmaContext, ts2.noop);
        if (externalModule) {
          if (ambientExternalModules) {
            for (var _i = 0, ambientExternalModules_1 = ambientExternalModules; _i < ambientExternalModules_1.length; _i++) {
              var decl = ambientExternalModules_1[_i];
              importedFiles.push(decl.ref);
            }
          }
          return { referencedFiles: pragmaContext.referencedFiles, typeReferenceDirectives: pragmaContext.typeReferenceDirectives, libReferenceDirectives: pragmaContext.libReferenceDirectives, importedFiles, isLibFile: !!pragmaContext.hasNoDefaultLib, ambientExternalModules: void 0 };
        } else {
          var ambientModuleNames = void 0;
          if (ambientExternalModules) {
            for (var _a = 0, ambientExternalModules_2 = ambientExternalModules; _a < ambientExternalModules_2.length; _a++) {
              var decl = ambientExternalModules_2[_a];
              if (decl.depth === 0) {
                if (!ambientModuleNames) {
                  ambientModuleNames = [];
                }
                ambientModuleNames.push(decl.ref.fileName);
              } else {
                importedFiles.push(decl.ref);
              }
            }
          }
          return { referencedFiles: pragmaContext.referencedFiles, typeReferenceDirectives: pragmaContext.typeReferenceDirectives, libReferenceDirectives: pragmaContext.libReferenceDirectives, importedFiles, isLibFile: !!pragmaContext.hasNoDefaultLib, ambientExternalModules: ambientModuleNames };
        }
      }
      ts2.preProcessFile = preProcessFile;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var Rename;
      (function(Rename2) {
        function getRenameInfo(program, sourceFile, position, options) {
          var node = ts2.getAdjustedRenameLocation(ts2.getTouchingPropertyName(sourceFile, position));
          if (nodeIsEligibleForRename(node)) {
            var renameInfo = getRenameInfoForNode(node, program.getTypeChecker(), sourceFile, function(declaration) {
              return program.isSourceFileDefaultLibrary(declaration.getSourceFile());
            }, options);
            if (renameInfo) {
              return renameInfo;
            }
          }
          return getRenameInfoError(ts2.Diagnostics.You_cannot_rename_this_element);
        }
        Rename2.getRenameInfo = getRenameInfo;
        function getRenameInfoForNode(node, typeChecker, sourceFile, isDefinedInLibraryFile, options) {
          var symbol = typeChecker.getSymbolAtLocation(node);
          if (!symbol)
            return;
          var declarations = symbol.declarations;
          if (!declarations || declarations.length === 0)
            return;
          if (declarations.some(isDefinedInLibraryFile)) {
            return getRenameInfoError(ts2.Diagnostics.You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library);
          }
          if (ts2.isIdentifier(node) && node.originalKeywordKind === 84 && symbol.parent && symbol.parent.flags & 1536) {
            return void 0;
          }
          if (ts2.isStringLiteralLike(node) && ts2.tryGetImportFromModuleSpecifier(node)) {
            return options && options.allowRenameOfImportPath ? getRenameInfoForModule(node, sourceFile, symbol) : void 0;
          }
          var kind = ts2.SymbolDisplay.getSymbolKind(typeChecker, symbol, node);
          var specifierName = ts2.isImportOrExportSpecifierName(node) || ts2.isStringOrNumericLiteralLike(node) && node.parent.kind === 154 ? ts2.stripQuotes(ts2.getTextOfIdentifierOrLiteral(node)) : void 0;
          var displayName = specifierName || typeChecker.symbolToString(symbol);
          var fullDisplayName = specifierName || typeChecker.getFullyQualifiedName(symbol);
          return getRenameInfoSuccess(displayName, fullDisplayName, kind, ts2.SymbolDisplay.getSymbolModifiers(symbol), node, sourceFile);
        }
        function getRenameInfoForModule(node, sourceFile, moduleSymbol) {
          if (!ts2.isExternalModuleNameRelative(node.text)) {
            return getRenameInfoError(ts2.Diagnostics.You_cannot_rename_a_module_via_a_global_import);
          }
          var moduleSourceFile = ts2.find(moduleSymbol.declarations, ts2.isSourceFile);
          if (!moduleSourceFile)
            return void 0;
          var withoutIndex = ts2.endsWith(node.text, "/index") || ts2.endsWith(node.text, "/index.js") ? void 0 : ts2.tryRemoveSuffix(ts2.removeFileExtension(moduleSourceFile.fileName), "/index");
          var name = withoutIndex === void 0 ? moduleSourceFile.fileName : withoutIndex;
          var kind = withoutIndex === void 0 ? "module" : "directory";
          var indexAfterLastSlash = node.text.lastIndexOf("/") + 1;
          var triggerSpan = ts2.createTextSpan(node.getStart(sourceFile) + 1 + indexAfterLastSlash, node.text.length - indexAfterLastSlash);
          return {
            canRename: true,
            fileToRename: name,
            kind,
            displayName: name,
            fullDisplayName: name,
            kindModifiers: "",
            triggerSpan
          };
        }
        function getRenameInfoSuccess(displayName, fullDisplayName, kind, kindModifiers, node, sourceFile) {
          return {
            canRename: true,
            fileToRename: void 0,
            kind,
            displayName,
            fullDisplayName,
            kindModifiers,
            triggerSpan: createTriggerSpanForNode(node, sourceFile)
          };
        }
        function getRenameInfoError(diagnostic) {
          return { canRename: false, localizedErrorMessage: ts2.getLocaleSpecificMessage(diagnostic) };
        }
        function createTriggerSpanForNode(node, sourceFile) {
          var start = node.getStart(sourceFile);
          var width = node.getWidth(sourceFile);
          if (ts2.isStringLiteralLike(node)) {
            start += 1;
            width -= 2;
          }
          return ts2.createTextSpan(start, width);
        }
        function nodeIsEligibleForRename(node) {
          switch (node.kind) {
            case 75:
            case 76:
            case 10:
            case 14:
            case 104:
              return true;
            case 8:
              return ts2.isLiteralNameOfPropertyDeclarationOrIndexAccess(node);
            default:
              return false;
          }
        }
      })(Rename = ts2.Rename || (ts2.Rename = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var SmartSelectionRange;
      (function(SmartSelectionRange2) {
        function getSmartSelectionRange(pos, sourceFile) {
          var selectionRange = {
            textSpan: ts2.createTextSpanFromBounds(sourceFile.getFullStart(), sourceFile.getEnd())
          };
          var parentNode = sourceFile;
          outer:
            while (true) {
              var children = getSelectionChildren(parentNode);
              if (!children.length)
                break;
              for (var i = 0; i < children.length; i++) {
                var prevNode = children[i - 1];
                var node = children[i];
                var nextNode = children[i + 1];
                if (node.getStart(sourceFile) > pos) {
                  break outer;
                }
                if (positionShouldSnapToNode(sourceFile, pos, node)) {
                  if (ts2.isBlock(node) || ts2.isTemplateSpan(node) || ts2.isTemplateHead(node) || ts2.isTemplateTail(node) || prevNode && ts2.isTemplateHead(prevNode) || ts2.isVariableDeclarationList(node) && ts2.isVariableStatement(parentNode) || ts2.isSyntaxList(node) && ts2.isVariableDeclarationList(parentNode) || ts2.isVariableDeclaration(node) && ts2.isSyntaxList(parentNode) && children.length === 1) {
                    parentNode = node;
                    break;
                  }
                  if (ts2.isTemplateSpan(parentNode) && nextNode && ts2.isTemplateMiddleOrTemplateTail(nextNode)) {
                    var start_2 = node.getFullStart() - "${".length;
                    var end_2 = nextNode.getStart() + "}".length;
                    pushSelectionRange(start_2, end_2);
                  }
                  var isBetweenMultiLineBookends = ts2.isSyntaxList(node) && isListOpener(prevNode) && isListCloser(nextNode) && !ts2.positionsAreOnSameLine(prevNode.getStart(), nextNode.getStart(), sourceFile);
                  var jsDocCommentStart = ts2.hasJSDocNodes(node) && node.jsDoc[0].getStart();
                  var start = isBetweenMultiLineBookends ? prevNode.getEnd() : node.getStart();
                  var end = isBetweenMultiLineBookends ? nextNode.getStart() : node.getEnd();
                  if (ts2.isNumber(jsDocCommentStart)) {
                    pushSelectionRange(jsDocCommentStart, end);
                  }
                  pushSelectionRange(start, end);
                  if (ts2.isStringLiteral(node) || ts2.isTemplateLiteral(node)) {
                    pushSelectionRange(start + 1, end - 1);
                  }
                  parentNode = node;
                  break;
                }
                if (i === children.length - 1) {
                  break outer;
                }
              }
            }
          return selectionRange;
          function pushSelectionRange(start2, end2) {
            if (start2 !== end2) {
              var textSpan = ts2.createTextSpanFromBounds(start2, end2);
              if (!selectionRange || !ts2.textSpansEqual(textSpan, selectionRange.textSpan) && ts2.textSpanIntersectsWithPosition(textSpan, pos)) {
                selectionRange = __assign({ textSpan }, selectionRange && { parent: selectionRange });
              }
            }
          }
        }
        SmartSelectionRange2.getSmartSelectionRange = getSmartSelectionRange;
        function positionShouldSnapToNode(sourceFile, pos, node) {
          ts2.Debug.assert(node.pos <= pos);
          if (pos < node.end) {
            return true;
          }
          var nodeEnd = node.getEnd();
          if (nodeEnd === pos) {
            return ts2.getTouchingPropertyName(sourceFile, pos).pos < node.end;
          }
          return false;
        }
        var isImport = ts2.or(ts2.isImportDeclaration, ts2.isImportEqualsDeclaration);
        function getSelectionChildren(node) {
          if (ts2.isSourceFile(node)) {
            return groupChildren(node.getChildAt(0).getChildren(), isImport);
          }
          if (ts2.isMappedTypeNode(node)) {
            var _a = node.getChildren(), openBraceToken = _a[0], children = _a.slice(1);
            var closeBraceToken = ts2.Debug.checkDefined(children.pop());
            ts2.Debug.assertEqual(openBraceToken.kind, 18);
            ts2.Debug.assertEqual(closeBraceToken.kind, 19);
            var groupedWithPlusMinusTokens = groupChildren(children, function(child) {
              return child === node.readonlyToken || child.kind === 138 || child === node.questionToken || child.kind === 57;
            });
            var groupedWithBrackets = groupChildren(groupedWithPlusMinusTokens, function(_a2) {
              var kind = _a2.kind;
              return kind === 22 || kind === 155 || kind === 23;
            });
            return [
              openBraceToken,
              createSyntaxList(splitChildren(groupedWithBrackets, function(_a2) {
                var kind = _a2.kind;
                return kind === 58;
              })),
              closeBraceToken
            ];
          }
          if (ts2.isPropertySignature(node)) {
            var children = groupChildren(node.getChildren(), function(child) {
              return child === node.name || ts2.contains(node.modifiers, child);
            });
            return splitChildren(children, function(_a2) {
              var kind = _a2.kind;
              return kind === 58;
            });
          }
          if (ts2.isParameter(node)) {
            var groupedDotDotDotAndName_1 = groupChildren(node.getChildren(), function(child) {
              return child === node.dotDotDotToken || child === node.name;
            });
            var groupedWithQuestionToken = groupChildren(groupedDotDotDotAndName_1, function(child) {
              return child === groupedDotDotDotAndName_1[0] || child === node.questionToken;
            });
            return splitChildren(groupedWithQuestionToken, function(_a2) {
              var kind = _a2.kind;
              return kind === 62;
            });
          }
          if (ts2.isBindingElement(node)) {
            return splitChildren(node.getChildren(), function(_a2) {
              var kind = _a2.kind;
              return kind === 62;
            });
          }
          return node.getChildren();
        }
        function groupChildren(children, groupOn) {
          var result = [];
          var group;
          for (var _i = 0, children_1 = children; _i < children_1.length; _i++) {
            var child = children_1[_i];
            if (groupOn(child)) {
              group = group || [];
              group.push(child);
            } else {
              if (group) {
                result.push(createSyntaxList(group));
                group = void 0;
              }
              result.push(child);
            }
          }
          if (group) {
            result.push(createSyntaxList(group));
          }
          return result;
        }
        function splitChildren(children, pivotOn, separateTrailingSemicolon) {
          if (separateTrailingSemicolon === void 0) {
            separateTrailingSemicolon = true;
          }
          if (children.length < 2) {
            return children;
          }
          var splitTokenIndex = ts2.findIndex(children, pivotOn);
          if (splitTokenIndex === -1) {
            return children;
          }
          var leftChildren = children.slice(0, splitTokenIndex);
          var splitToken = children[splitTokenIndex];
          var lastToken = ts2.last(children);
          var separateLastToken = separateTrailingSemicolon && lastToken.kind === 26;
          var rightChildren = children.slice(splitTokenIndex + 1, separateLastToken ? children.length - 1 : void 0);
          var result = ts2.compact([
            leftChildren.length ? createSyntaxList(leftChildren) : void 0,
            splitToken,
            rightChildren.length ? createSyntaxList(rightChildren) : void 0
          ]);
          return separateLastToken ? result.concat(lastToken) : result;
        }
        function createSyntaxList(children) {
          ts2.Debug.assertGreaterThanOrEqual(children.length, 1);
          var syntaxList = ts2.createNode(324, children[0].pos, ts2.last(children).end);
          syntaxList._children = children;
          return syntaxList;
        }
        function isListOpener(token) {
          var kind = token && token.kind;
          return kind === 18 || kind === 22 || kind === 20 || kind === 268;
        }
        function isListCloser(token) {
          var kind = token && token.kind;
          return kind === 19 || kind === 23 || kind === 21 || kind === 269;
        }
      })(SmartSelectionRange = ts2.SmartSelectionRange || (ts2.SmartSelectionRange = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var SignatureHelp;
      (function(SignatureHelp2) {
        var InvocationKind;
        (function(InvocationKind2) {
          InvocationKind2[InvocationKind2["Call"] = 0] = "Call";
          InvocationKind2[InvocationKind2["TypeArgs"] = 1] = "TypeArgs";
          InvocationKind2[InvocationKind2["Contextual"] = 2] = "Contextual";
        })(InvocationKind || (InvocationKind = {}));
        function getSignatureHelpItems(program, sourceFile, position, triggerReason, cancellationToken) {
          var typeChecker = program.getTypeChecker();
          var startingToken = ts2.findTokenOnLeftOfPosition(sourceFile, position);
          if (!startingToken) {
            return void 0;
          }
          var onlyUseSyntacticOwners = !!triggerReason && triggerReason.kind === "characterTyped";
          if (onlyUseSyntacticOwners && (ts2.isInString(sourceFile, position, startingToken) || ts2.isInComment(sourceFile, position))) {
            return void 0;
          }
          var isManuallyInvoked = !!triggerReason && triggerReason.kind === "invoked";
          var argumentInfo = getContainingArgumentInfo(startingToken, position, sourceFile, typeChecker, isManuallyInvoked);
          if (!argumentInfo)
            return void 0;
          cancellationToken.throwIfCancellationRequested();
          var candidateInfo = getCandidateOrTypeInfo(argumentInfo, typeChecker, sourceFile, startingToken, onlyUseSyntacticOwners);
          cancellationToken.throwIfCancellationRequested();
          if (!candidateInfo) {
            return ts2.isSourceFileJS(sourceFile) ? createJSSignatureHelpItems(argumentInfo, program, cancellationToken) : void 0;
          }
          return typeChecker.runWithCancellationToken(cancellationToken, function(typeChecker2) {
            return candidateInfo.kind === 0 ? createSignatureHelpItems(candidateInfo.candidates, candidateInfo.resolvedSignature, argumentInfo, sourceFile, typeChecker2) : createTypeHelpItems(candidateInfo.symbol, argumentInfo, sourceFile, typeChecker2);
          });
        }
        SignatureHelp2.getSignatureHelpItems = getSignatureHelpItems;
        var CandidateOrTypeKind;
        (function(CandidateOrTypeKind2) {
          CandidateOrTypeKind2[CandidateOrTypeKind2["Candidate"] = 0] = "Candidate";
          CandidateOrTypeKind2[CandidateOrTypeKind2["Type"] = 1] = "Type";
        })(CandidateOrTypeKind || (CandidateOrTypeKind = {}));
        function getCandidateOrTypeInfo(_a, checker, sourceFile, startingToken, onlyUseSyntacticOwners) {
          var invocation = _a.invocation, argumentCount = _a.argumentCount;
          switch (invocation.kind) {
            case 0: {
              if (onlyUseSyntacticOwners && !isSyntacticOwner(startingToken, invocation.node, sourceFile)) {
                return void 0;
              }
              var candidates = [];
              var resolvedSignature = checker.getResolvedSignatureForSignatureHelp(invocation.node, candidates, argumentCount);
              return candidates.length === 0 ? void 0 : { kind: 0, candidates, resolvedSignature };
            }
            case 1: {
              var called = invocation.called;
              if (onlyUseSyntacticOwners && !containsPrecedingToken(startingToken, sourceFile, ts2.isIdentifier(called) ? called.parent : called)) {
                return void 0;
              }
              var candidates = ts2.getPossibleGenericSignatures(called, argumentCount, checker);
              if (candidates.length !== 0)
                return { kind: 0, candidates, resolvedSignature: ts2.first(candidates) };
              var symbol = checker.getSymbolAtLocation(called);
              return symbol && { kind: 1, symbol };
            }
            case 2:
              return { kind: 0, candidates: [invocation.signature], resolvedSignature: invocation.signature };
            default:
              return ts2.Debug.assertNever(invocation);
          }
        }
        function isSyntacticOwner(startingToken, node, sourceFile) {
          if (!ts2.isCallOrNewExpression(node))
            return false;
          var invocationChildren = node.getChildren(sourceFile);
          switch (startingToken.kind) {
            case 20:
              return ts2.contains(invocationChildren, startingToken);
            case 27: {
              var containingList = ts2.findContainingList(startingToken);
              return !!containingList && ts2.contains(invocationChildren, containingList);
            }
            case 29:
              return containsPrecedingToken(startingToken, sourceFile, node.expression);
            default:
              return false;
          }
        }
        function createJSSignatureHelpItems(argumentInfo, program, cancellationToken) {
          if (argumentInfo.invocation.kind === 2)
            return void 0;
          var expression = getExpressionFromInvocation(argumentInfo.invocation);
          var name = ts2.isIdentifier(expression) ? expression.text : ts2.isPropertyAccessExpression(expression) ? expression.name.text : void 0;
          var typeChecker = program.getTypeChecker();
          return name === void 0 ? void 0 : ts2.firstDefined(program.getSourceFiles(), function(sourceFile) {
            return ts2.firstDefined(sourceFile.getNamedDeclarations().get(name), function(declaration) {
              var type = declaration.symbol && typeChecker.getTypeOfSymbolAtLocation(declaration.symbol, declaration);
              var callSignatures = type && type.getCallSignatures();
              if (callSignatures && callSignatures.length) {
                return typeChecker.runWithCancellationToken(cancellationToken, function(typeChecker2) {
                  return createSignatureHelpItems(callSignatures, callSignatures[0], argumentInfo, sourceFile, typeChecker2);
                });
              }
            });
          });
        }
        function containsPrecedingToken(startingToken, sourceFile, container) {
          var pos = startingToken.getFullStart();
          var currentParent = startingToken.parent;
          while (currentParent) {
            var precedingToken = ts2.findPrecedingToken(pos, sourceFile, currentParent, true);
            if (precedingToken) {
              return ts2.rangeContainsRange(container, precedingToken);
            }
            currentParent = currentParent.parent;
          }
          return ts2.Debug.fail("Could not find preceding token");
        }
        function getArgumentInfoForCompletions(node, position, sourceFile) {
          var info = getImmediatelyContainingArgumentInfo(node, position, sourceFile);
          return !info || info.isTypeParameterList || info.invocation.kind !== 0 ? void 0 : { invocation: info.invocation.node, argumentCount: info.argumentCount, argumentIndex: info.argumentIndex };
        }
        SignatureHelp2.getArgumentInfoForCompletions = getArgumentInfoForCompletions;
        function getArgumentOrParameterListInfo(node, sourceFile) {
          var info = getArgumentOrParameterListAndIndex(node, sourceFile);
          if (!info)
            return void 0;
          var list = info.list, argumentIndex = info.argumentIndex;
          var argumentCount = getArgumentCount(list);
          if (argumentIndex !== 0) {
            ts2.Debug.assertLessThan(argumentIndex, argumentCount);
          }
          var argumentsSpan = getApplicableSpanForArguments(list, sourceFile);
          return { list, argumentIndex, argumentCount, argumentsSpan };
        }
        function getArgumentOrParameterListAndIndex(node, sourceFile) {
          if (node.kind === 29 || node.kind === 20) {
            return { list: getChildListThatStartsWithOpenerToken(node.parent, node, sourceFile), argumentIndex: 0 };
          } else {
            var list = ts2.findContainingList(node);
            return list && { list, argumentIndex: getArgumentIndex(list, node) };
          }
        }
        function getImmediatelyContainingArgumentInfo(node, position, sourceFile) {
          var parent = node.parent;
          if (ts2.isCallOrNewExpression(parent)) {
            var invocation = parent;
            var info = getArgumentOrParameterListInfo(node, sourceFile);
            if (!info)
              return void 0;
            var list = info.list, argumentIndex = info.argumentIndex, argumentCount = info.argumentCount, argumentsSpan = info.argumentsSpan;
            var isTypeParameterList = !!parent.typeArguments && parent.typeArguments.pos === list.pos;
            return { isTypeParameterList, invocation: { kind: 0, node: invocation }, argumentsSpan, argumentIndex, argumentCount };
          } else if (ts2.isNoSubstitutionTemplateLiteral(node) && ts2.isTaggedTemplateExpression(parent)) {
            if (ts2.isInsideTemplateLiteral(node, position, sourceFile)) {
              return getArgumentListInfoForTemplate(parent, 0, sourceFile);
            }
            return void 0;
          } else if (ts2.isTemplateHead(node) && parent.parent.kind === 198) {
            var templateExpression = parent;
            var tagExpression = templateExpression.parent;
            ts2.Debug.assert(templateExpression.kind === 211);
            var argumentIndex = ts2.isInsideTemplateLiteral(node, position, sourceFile) ? 0 : 1;
            return getArgumentListInfoForTemplate(tagExpression, argumentIndex, sourceFile);
          } else if (ts2.isTemplateSpan(parent) && ts2.isTaggedTemplateExpression(parent.parent.parent)) {
            var templateSpan = parent;
            var tagExpression = parent.parent.parent;
            if (ts2.isTemplateTail(node) && !ts2.isInsideTemplateLiteral(node, position, sourceFile)) {
              return void 0;
            }
            var spanIndex = templateSpan.parent.templateSpans.indexOf(templateSpan);
            var argumentIndex = getArgumentIndexForTemplatePiece(spanIndex, node, position, sourceFile);
            return getArgumentListInfoForTemplate(tagExpression, argumentIndex, sourceFile);
          } else if (ts2.isJsxOpeningLikeElement(parent)) {
            var attributeSpanStart = parent.attributes.pos;
            var attributeSpanEnd = ts2.skipTrivia(sourceFile.text, parent.attributes.end, false);
            return {
              isTypeParameterList: false,
              invocation: { kind: 0, node: parent },
              argumentsSpan: ts2.createTextSpan(attributeSpanStart, attributeSpanEnd - attributeSpanStart),
              argumentIndex: 0,
              argumentCount: 1
            };
          } else {
            var typeArgInfo = ts2.getPossibleTypeArgumentsInfo(node, sourceFile);
            if (typeArgInfo) {
              var called = typeArgInfo.called, nTypeArguments = typeArgInfo.nTypeArguments;
              var invocation = { kind: 1, called };
              var argumentsSpan = ts2.createTextSpanFromBounds(called.getStart(sourceFile), node.end);
              return { isTypeParameterList: true, invocation, argumentsSpan, argumentIndex: nTypeArguments, argumentCount: nTypeArguments + 1 };
            }
            return void 0;
          }
        }
        function getImmediatelyContainingArgumentOrContextualParameterInfo(node, position, sourceFile, checker) {
          return tryGetParameterInfo(node, position, sourceFile, checker) || getImmediatelyContainingArgumentInfo(node, position, sourceFile);
        }
        function getHighestBinary(b) {
          return ts2.isBinaryExpression(b.parent) ? getHighestBinary(b.parent) : b;
        }
        function countBinaryExpressionParameters(b) {
          return ts2.isBinaryExpression(b.left) ? countBinaryExpressionParameters(b.left) + 1 : 2;
        }
        function tryGetParameterInfo(startingToken, _position, sourceFile, checker) {
          var info = getContextualSignatureLocationInfo(startingToken, sourceFile, checker);
          if (!info)
            return void 0;
          var contextualType = info.contextualType, argumentIndex = info.argumentIndex, argumentCount = info.argumentCount, argumentsSpan = info.argumentsSpan;
          var signatures = contextualType.getCallSignatures();
          if (signatures.length !== 1)
            return void 0;
          var invocation = { kind: 2, signature: ts2.first(signatures), node: startingToken, symbol: chooseBetterSymbol(contextualType.symbol) };
          return { isTypeParameterList: false, invocation, argumentsSpan, argumentIndex, argumentCount };
        }
        function getContextualSignatureLocationInfo(startingToken, sourceFile, checker) {
          if (startingToken.kind !== 20 && startingToken.kind !== 27)
            return void 0;
          var parent = startingToken.parent;
          switch (parent.kind) {
            case 200:
            case 161:
            case 201:
            case 202:
              var info = getArgumentOrParameterListInfo(startingToken, sourceFile);
              if (!info)
                return void 0;
              var argumentIndex = info.argumentIndex, argumentCount = info.argumentCount, argumentsSpan = info.argumentsSpan;
              var contextualType = ts2.isMethodDeclaration(parent) ? checker.getContextualTypeForObjectLiteralElement(parent) : checker.getContextualType(parent);
              return contextualType && { contextualType, argumentIndex, argumentCount, argumentsSpan };
            case 209: {
              var highestBinary = getHighestBinary(parent);
              var contextualType_1 = checker.getContextualType(highestBinary);
              var argumentIndex_1 = startingToken.kind === 20 ? 0 : countBinaryExpressionParameters(parent) - 1;
              var argumentCount_1 = countBinaryExpressionParameters(highestBinary);
              return contextualType_1 && { contextualType: contextualType_1, argumentIndex: argumentIndex_1, argumentCount: argumentCount_1, argumentsSpan: ts2.createTextSpanFromNode(parent) };
            }
            default:
              return void 0;
          }
        }
        function chooseBetterSymbol(s) {
          return s.name === "__type" ? ts2.firstDefined(s.declarations, function(d) {
            return ts2.isFunctionTypeNode(d) ? d.parent.symbol : void 0;
          }) || s : s;
        }
        function getArgumentIndex(argumentsList, node) {
          var argumentIndex = 0;
          for (var _i = 0, _a = argumentsList.getChildren(); _i < _a.length; _i++) {
            var child = _a[_i];
            if (child === node) {
              break;
            }
            if (child.kind !== 27) {
              argumentIndex++;
            }
          }
          return argumentIndex;
        }
        function getArgumentCount(argumentsList) {
          var listChildren = argumentsList.getChildren();
          var argumentCount = ts2.countWhere(listChildren, function(arg) {
            return arg.kind !== 27;
          });
          if (listChildren.length > 0 && ts2.last(listChildren).kind === 27) {
            argumentCount++;
          }
          return argumentCount;
        }
        function getArgumentIndexForTemplatePiece(spanIndex, node, position, sourceFile) {
          ts2.Debug.assert(position >= node.getStart(), "Assumed 'position' could not occur before node.");
          if (ts2.isTemplateLiteralToken(node)) {
            if (ts2.isInsideTemplateLiteral(node, position, sourceFile)) {
              return 0;
            }
            return spanIndex + 2;
          }
          return spanIndex + 1;
        }
        function getArgumentListInfoForTemplate(tagExpression, argumentIndex, sourceFile) {
          var argumentCount = ts2.isNoSubstitutionTemplateLiteral(tagExpression.template) ? 1 : tagExpression.template.templateSpans.length + 1;
          if (argumentIndex !== 0) {
            ts2.Debug.assertLessThan(argumentIndex, argumentCount);
          }
          return {
            isTypeParameterList: false,
            invocation: { kind: 0, node: tagExpression },
            argumentsSpan: getApplicableSpanForTaggedTemplate(tagExpression, sourceFile),
            argumentIndex,
            argumentCount
          };
        }
        function getApplicableSpanForArguments(argumentsList, sourceFile) {
          var applicableSpanStart = argumentsList.getFullStart();
          var applicableSpanEnd = ts2.skipTrivia(sourceFile.text, argumentsList.getEnd(), false);
          return ts2.createTextSpan(applicableSpanStart, applicableSpanEnd - applicableSpanStart);
        }
        function getApplicableSpanForTaggedTemplate(taggedTemplate, sourceFile) {
          var template = taggedTemplate.template;
          var applicableSpanStart = template.getStart();
          var applicableSpanEnd = template.getEnd();
          if (template.kind === 211) {
            var lastSpan = ts2.last(template.templateSpans);
            if (lastSpan.literal.getFullWidth() === 0) {
              applicableSpanEnd = ts2.skipTrivia(sourceFile.text, applicableSpanEnd, false);
            }
          }
          return ts2.createTextSpan(applicableSpanStart, applicableSpanEnd - applicableSpanStart);
        }
        function getContainingArgumentInfo(node, position, sourceFile, checker, isManuallyInvoked) {
          var _loop_7 = function(n2) {
            ts2.Debug.assert(ts2.rangeContainsRange(n2.parent, n2), "Not a subspan", function() {
              return "Child: " + ts2.Debug.formatSyntaxKind(n2.kind) + ", parent: " + ts2.Debug.formatSyntaxKind(n2.parent.kind);
            });
            var argumentInfo = getImmediatelyContainingArgumentOrContextualParameterInfo(n2, position, sourceFile, checker);
            if (argumentInfo) {
              return { value: argumentInfo };
            }
          };
          for (var n = node; !ts2.isSourceFile(n) && (isManuallyInvoked || !ts2.isBlock(n)); n = n.parent) {
            var state_2 = _loop_7(n);
            if (typeof state_2 === "object")
              return state_2.value;
          }
          return void 0;
        }
        function getChildListThatStartsWithOpenerToken(parent, openerToken, sourceFile) {
          var children = parent.getChildren(sourceFile);
          var indexOfOpenerToken = children.indexOf(openerToken);
          ts2.Debug.assert(indexOfOpenerToken >= 0 && children.length > indexOfOpenerToken + 1);
          return children[indexOfOpenerToken + 1];
        }
        function getExpressionFromInvocation(invocation) {
          return invocation.kind === 0 ? ts2.getInvokedExpression(invocation.node) : invocation.called;
        }
        function getEnclosingDeclarationFromInvocation(invocation) {
          return invocation.kind === 0 ? invocation.node : invocation.kind === 1 ? invocation.called : invocation.node;
        }
        var signatureHelpNodeBuilderFlags = 8192 | 70221824 | 16384;
        function createSignatureHelpItems(candidates, resolvedSignature, _a, sourceFile, typeChecker) {
          var isTypeParameterList = _a.isTypeParameterList, argumentCount = _a.argumentCount, applicableSpan = _a.argumentsSpan, invocation = _a.invocation, argumentIndex = _a.argumentIndex;
          var enclosingDeclaration = getEnclosingDeclarationFromInvocation(invocation);
          var callTargetSymbol = invocation.kind === 2 ? invocation.symbol : typeChecker.getSymbolAtLocation(getExpressionFromInvocation(invocation));
          var callTargetDisplayParts = callTargetSymbol ? ts2.symbolToDisplayParts(typeChecker, callTargetSymbol, void 0, void 0) : ts2.emptyArray;
          var items = candidates.map(function(candidateSignature) {
            return getSignatureHelpItem(candidateSignature, callTargetDisplayParts, isTypeParameterList, typeChecker, enclosingDeclaration, sourceFile);
          });
          if (argumentIndex !== 0) {
            ts2.Debug.assertLessThan(argumentIndex, argumentCount);
          }
          var selectedItemIndex = candidates.indexOf(resolvedSignature);
          ts2.Debug.assert(selectedItemIndex !== -1);
          return { items, applicableSpan, selectedItemIndex, argumentIndex, argumentCount };
        }
        function createTypeHelpItems(symbol, _a, sourceFile, checker) {
          var argumentCount = _a.argumentCount, applicableSpan = _a.argumentsSpan, invocation = _a.invocation, argumentIndex = _a.argumentIndex;
          var typeParameters = checker.getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
          if (!typeParameters)
            return void 0;
          var items = [getTypeHelpItem(symbol, typeParameters, checker, getEnclosingDeclarationFromInvocation(invocation), sourceFile)];
          return { items, applicableSpan, selectedItemIndex: 0, argumentIndex, argumentCount };
        }
        function getTypeHelpItem(symbol, typeParameters, checker, enclosingDeclaration, sourceFile) {
          var typeSymbolDisplay = ts2.symbolToDisplayParts(checker, symbol);
          var printer = ts2.createPrinter({ removeComments: true });
          var parameters = typeParameters.map(function(t) {
            return createSignatureHelpParameterForTypeParameter(t, checker, enclosingDeclaration, sourceFile, printer);
          });
          var documentation = symbol.getDocumentationComment(checker);
          var tags = symbol.getJsDocTags();
          var prefixDisplayParts = __spreadArrays(typeSymbolDisplay, [ts2.punctuationPart(29)]);
          return { isVariadic: false, prefixDisplayParts, suffixDisplayParts: [ts2.punctuationPart(31)], separatorDisplayParts, parameters, documentation, tags };
        }
        var separatorDisplayParts = [ts2.punctuationPart(27), ts2.spacePart()];
        function getSignatureHelpItem(candidateSignature, callTargetDisplayParts, isTypeParameterList, checker, enclosingDeclaration, sourceFile) {
          var _a = (isTypeParameterList ? itemInfoForTypeParameters : itemInfoForParameters)(candidateSignature, checker, enclosingDeclaration, sourceFile), isVariadic = _a.isVariadic, parameters = _a.parameters, prefix = _a.prefix, suffix = _a.suffix;
          var prefixDisplayParts = __spreadArrays(callTargetDisplayParts, prefix);
          var suffixDisplayParts = __spreadArrays(suffix, returnTypeToDisplayParts(candidateSignature, enclosingDeclaration, checker));
          var documentation = candidateSignature.getDocumentationComment(checker);
          var tags = candidateSignature.getJsDocTags();
          return { isVariadic, prefixDisplayParts, suffixDisplayParts, separatorDisplayParts, parameters, documentation, tags };
        }
        function returnTypeToDisplayParts(candidateSignature, enclosingDeclaration, checker) {
          return ts2.mapToDisplayParts(function(writer) {
            writer.writePunctuation(":");
            writer.writeSpace(" ");
            var predicate = checker.getTypePredicateOfSignature(candidateSignature);
            if (predicate) {
              checker.writeTypePredicate(predicate, enclosingDeclaration, void 0, writer);
            } else {
              checker.writeType(checker.getReturnTypeOfSignature(candidateSignature), enclosingDeclaration, void 0, writer);
            }
          });
        }
        function itemInfoForTypeParameters(candidateSignature, checker, enclosingDeclaration, sourceFile) {
          var typeParameters = (candidateSignature.target || candidateSignature).typeParameters;
          var printer = ts2.createPrinter({ removeComments: true });
          var parameters = (typeParameters || ts2.emptyArray).map(function(t) {
            return createSignatureHelpParameterForTypeParameter(t, checker, enclosingDeclaration, sourceFile, printer);
          });
          var parameterParts = ts2.mapToDisplayParts(function(writer) {
            var thisParameter = candidateSignature.thisParameter ? [checker.symbolToParameterDeclaration(candidateSignature.thisParameter, enclosingDeclaration, signatureHelpNodeBuilderFlags)] : [];
            var params = ts2.createNodeArray(__spreadArrays(thisParameter, checker.getExpandedParameters(candidateSignature).map(function(param) {
              return checker.symbolToParameterDeclaration(param, enclosingDeclaration, signatureHelpNodeBuilderFlags);
            })));
            printer.writeList(2576, params, sourceFile, writer);
          });
          return { isVariadic: false, parameters, prefix: [ts2.punctuationPart(29)], suffix: __spreadArrays([ts2.punctuationPart(31)], parameterParts) };
        }
        function itemInfoForParameters(candidateSignature, checker, enclosingDeclaration, sourceFile) {
          var isVariadic = checker.hasEffectiveRestParameter(candidateSignature);
          var printer = ts2.createPrinter({ removeComments: true });
          var typeParameterParts = ts2.mapToDisplayParts(function(writer) {
            if (candidateSignature.typeParameters && candidateSignature.typeParameters.length) {
              var args = ts2.createNodeArray(candidateSignature.typeParameters.map(function(p) {
                return checker.typeParameterToDeclaration(p, enclosingDeclaration, signatureHelpNodeBuilderFlags);
              }));
              printer.writeList(53776, args, sourceFile, writer);
            }
          });
          var parameters = checker.getExpandedParameters(candidateSignature).map(function(p) {
            return createSignatureHelpParameterForParameter(p, checker, enclosingDeclaration, sourceFile, printer);
          });
          return { isVariadic, parameters, prefix: __spreadArrays(typeParameterParts, [ts2.punctuationPart(20)]), suffix: [ts2.punctuationPart(21)] };
        }
        function createSignatureHelpParameterForParameter(parameter, checker, enclosingDeclaration, sourceFile, printer) {
          var displayParts = ts2.mapToDisplayParts(function(writer) {
            var param = checker.symbolToParameterDeclaration(parameter, enclosingDeclaration, signatureHelpNodeBuilderFlags);
            printer.writeNode(4, param, sourceFile, writer);
          });
          var isOptional = checker.isOptionalParameter(parameter.valueDeclaration);
          return { name: parameter.name, documentation: parameter.getDocumentationComment(checker), displayParts, isOptional };
        }
        function createSignatureHelpParameterForTypeParameter(typeParameter, checker, enclosingDeclaration, sourceFile, printer) {
          var displayParts = ts2.mapToDisplayParts(function(writer) {
            var param = checker.typeParameterToDeclaration(typeParameter, enclosingDeclaration, signatureHelpNodeBuilderFlags);
            printer.writeNode(4, param, sourceFile, writer);
          });
          return { name: typeParameter.symbol.name, documentation: typeParameter.symbol.getDocumentationComment(checker), displayParts, isOptional: false };
        }
      })(SignatureHelp = ts2.SignatureHelp || (ts2.SignatureHelp = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var base64UrlRegExp = /^data:(?:application\/json(?:;charset=[uU][tT][fF]-8);base64,([A-Za-z0-9+\/=]+)$)?/;
      function getSourceMapper(host) {
        var getCanonicalFileName = ts2.createGetCanonicalFileName(host.useCaseSensitiveFileNames());
        var currentDirectory = host.getCurrentDirectory();
        var sourceFileLike = ts2.createMap();
        var documentPositionMappers = ts2.createMap();
        return { tryGetSourcePosition, tryGetGeneratedPosition, toLineColumnOffset, clearCache };
        function toPath(fileName) {
          return ts2.toPath(fileName, currentDirectory, getCanonicalFileName);
        }
        function getDocumentPositionMapper2(generatedFileName, sourceFileName) {
          var path2 = toPath(generatedFileName);
          var value = documentPositionMappers.get(path2);
          if (value)
            return value;
          var mapper;
          if (host.getDocumentPositionMapper) {
            mapper = host.getDocumentPositionMapper(generatedFileName, sourceFileName);
          } else if (host.readFile) {
            var file = getSourceFileLike(generatedFileName);
            mapper = file && ts2.getDocumentPositionMapper({ getSourceFileLike, getCanonicalFileName, log: function(s) {
              return host.log(s);
            } }, generatedFileName, ts2.getLineInfo(file.text, ts2.getLineStarts(file)), function(f) {
              return !host.fileExists || host.fileExists(f) ? host.readFile(f) : void 0;
            });
          }
          documentPositionMappers.set(path2, mapper || ts2.identitySourceMapConsumer);
          return mapper || ts2.identitySourceMapConsumer;
        }
        function tryGetSourcePosition(info) {
          if (!ts2.isDeclarationFileName(info.fileName))
            return void 0;
          var file = getSourceFile(info.fileName);
          if (!file)
            return void 0;
          var newLoc = getDocumentPositionMapper2(info.fileName).getSourcePosition(info);
          return !newLoc || newLoc === info ? void 0 : tryGetSourcePosition(newLoc) || newLoc;
        }
        function tryGetGeneratedPosition(info) {
          if (ts2.isDeclarationFileName(info.fileName))
            return void 0;
          var sourceFile = getSourceFile(info.fileName);
          if (!sourceFile)
            return void 0;
          var program = host.getProgram();
          if (program.isSourceOfProjectReferenceRedirect(sourceFile.fileName)) {
            return void 0;
          }
          var options = program.getCompilerOptions();
          var outPath = options.outFile || options.out;
          var declarationPath = outPath ? ts2.removeFileExtension(outPath) + ".d.ts" : ts2.getDeclarationEmitOutputFilePathWorker(info.fileName, program.getCompilerOptions(), currentDirectory, program.getCommonSourceDirectory(), getCanonicalFileName);
          if (declarationPath === void 0)
            return void 0;
          var newLoc = getDocumentPositionMapper2(declarationPath, info.fileName).getGeneratedPosition(info);
          return newLoc === info ? void 0 : newLoc;
        }
        function getSourceFile(fileName) {
          var program = host.getProgram();
          if (!program)
            return void 0;
          var path2 = toPath(fileName);
          var file = program.getSourceFileByPath(path2);
          return file && file.resolvedPath === path2 ? file : void 0;
        }
        function getOrCreateSourceFileLike(fileName) {
          var path2 = toPath(fileName);
          var fileFromCache = sourceFileLike.get(path2);
          if (fileFromCache !== void 0)
            return fileFromCache ? fileFromCache : void 0;
          if (!host.readFile || host.fileExists && !host.fileExists(path2)) {
            sourceFileLike.set(path2, false);
            return void 0;
          }
          var text = host.readFile(path2);
          var file = text ? createSourceFileLike(text) : false;
          sourceFileLike.set(path2, file);
          return file ? file : void 0;
        }
        function getSourceFileLike(fileName) {
          return !host.getSourceFileLike ? getSourceFile(fileName) || getOrCreateSourceFileLike(fileName) : host.getSourceFileLike(fileName);
        }
        function toLineColumnOffset(fileName, position) {
          var file = getSourceFileLike(fileName);
          return file.getLineAndCharacterOfPosition(position);
        }
        function clearCache() {
          sourceFileLike.clear();
          documentPositionMappers.clear();
        }
      }
      ts2.getSourceMapper = getSourceMapper;
      function getDocumentPositionMapper(host, generatedFileName, generatedFileLineInfo, readMapFile) {
        var mapFileName = ts2.tryGetSourceMappingURL(generatedFileLineInfo);
        if (mapFileName) {
          var match = base64UrlRegExp.exec(mapFileName);
          if (match) {
            if (match[1]) {
              var base64Object = match[1];
              return convertDocumentToSourceMapper(host, ts2.base64decode(ts2.sys, base64Object), generatedFileName);
            }
            mapFileName = void 0;
          }
        }
        var possibleMapLocations = [];
        if (mapFileName) {
          possibleMapLocations.push(mapFileName);
        }
        possibleMapLocations.push(generatedFileName + ".map");
        var originalMapFileName = mapFileName && ts2.getNormalizedAbsolutePath(mapFileName, ts2.getDirectoryPath(generatedFileName));
        for (var _i = 0, possibleMapLocations_1 = possibleMapLocations; _i < possibleMapLocations_1.length; _i++) {
          var location = possibleMapLocations_1[_i];
          var mapFileName_1 = ts2.getNormalizedAbsolutePath(location, ts2.getDirectoryPath(generatedFileName));
          var mapFileContents = readMapFile(mapFileName_1, originalMapFileName);
          if (ts2.isString(mapFileContents)) {
            return convertDocumentToSourceMapper(host, mapFileContents, mapFileName_1);
          }
          if (mapFileContents !== void 0) {
            return mapFileContents || void 0;
          }
        }
        return void 0;
      }
      ts2.getDocumentPositionMapper = getDocumentPositionMapper;
      function convertDocumentToSourceMapper(host, contents, mapFileName) {
        var map = ts2.tryParseRawSourceMap(contents);
        if (!map || !map.sources || !map.file || !map.mappings) {
          return void 0;
        }
        if (map.sourcesContent && map.sourcesContent.some(ts2.isString))
          return void 0;
        return ts2.createDocumentPositionMapper(host, map, mapFileName);
      }
      function createSourceFileLike(text, lineMap) {
        return {
          text,
          lineMap,
          getLineAndCharacterOfPosition: function(pos) {
            return ts2.computeLineAndCharacterOfPosition(ts2.getLineStarts(this), pos);
          }
        };
      }
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var visitedNestedConvertibleFunctions = ts2.createMap();
      function computeSuggestionDiagnostics(sourceFile, program, cancellationToken) {
        program.getSemanticDiagnostics(sourceFile, cancellationToken);
        var diags = [];
        var checker = program.getTypeChecker();
        if (sourceFile.commonJsModuleIndicator && (ts2.programContainsEs6Modules(program) || ts2.compilerOptionsIndicateEs6Modules(program.getCompilerOptions())) && containsTopLevelCommonjs(sourceFile)) {
          diags.push(ts2.createDiagnosticForNode(getErrorNodeFromCommonJsIndicator(sourceFile.commonJsModuleIndicator), ts2.Diagnostics.File_is_a_CommonJS_module_it_may_be_converted_to_an_ES6_module));
        }
        var isJsFile = ts2.isSourceFileJS(sourceFile);
        visitedNestedConvertibleFunctions.clear();
        check(sourceFile);
        if (ts2.getAllowSyntheticDefaultImports(program.getCompilerOptions())) {
          for (var _i = 0, _a = sourceFile.imports; _i < _a.length; _i++) {
            var moduleSpecifier = _a[_i];
            var importNode = ts2.importFromModuleSpecifier(moduleSpecifier);
            var name = importNameForConvertToDefaultImport(importNode);
            if (!name)
              continue;
            var module_1 = ts2.getResolvedModule(sourceFile, moduleSpecifier.text);
            var resolvedFile = module_1 && program.getSourceFile(module_1.resolvedFileName);
            if (resolvedFile && resolvedFile.externalModuleIndicator && ts2.isExportAssignment(resolvedFile.externalModuleIndicator) && resolvedFile.externalModuleIndicator.isExportEquals) {
              diags.push(ts2.createDiagnosticForNode(name, ts2.Diagnostics.Import_may_be_converted_to_a_default_import));
            }
          }
        }
        ts2.addRange(diags, sourceFile.bindSuggestionDiagnostics);
        ts2.addRange(diags, program.getSuggestionDiagnostics(sourceFile, cancellationToken));
        return diags.sort(function(d1, d2) {
          return d1.start - d2.start;
        });
        function check(node) {
          if (isJsFile) {
            if (canBeConvertedToClass(node)) {
              diags.push(ts2.createDiagnosticForNode(ts2.isVariableDeclaration(node.parent) ? node.parent.name : node, ts2.Diagnostics.This_constructor_function_may_be_converted_to_a_class_declaration));
            }
          } else {
            if (ts2.isVariableStatement(node) && node.parent === sourceFile && node.declarationList.flags & 2 && node.declarationList.declarations.length === 1) {
              var init = node.declarationList.declarations[0].initializer;
              if (init && ts2.isRequireCall(init, true)) {
                diags.push(ts2.createDiagnosticForNode(init, ts2.Diagnostics.require_call_may_be_converted_to_an_import));
              }
            }
            if (ts2.codefix.parameterShouldGetTypeFromJSDoc(node)) {
              diags.push(ts2.createDiagnosticForNode(node.name || node, ts2.Diagnostics.JSDoc_types_may_be_moved_to_TypeScript_types));
            }
          }
          if (ts2.isFunctionLikeDeclaration(node)) {
            addConvertToAsyncFunctionDiagnostics(node, checker, diags);
          }
          node.forEachChild(check);
        }
      }
      ts2.computeSuggestionDiagnostics = computeSuggestionDiagnostics;
      function containsTopLevelCommonjs(sourceFile) {
        return sourceFile.statements.some(function(statement) {
          switch (statement.kind) {
            case 225:
              return statement.declarationList.declarations.some(function(decl) {
                return !!decl.initializer && ts2.isRequireCall(propertyAccessLeftHandSide(decl.initializer), true);
              });
            case 226: {
              var expression = statement.expression;
              if (!ts2.isBinaryExpression(expression))
                return ts2.isRequireCall(expression, true);
              var kind = ts2.getAssignmentDeclarationKind(expression);
              return kind === 1 || kind === 2;
            }
            default:
              return false;
          }
        });
      }
      function propertyAccessLeftHandSide(node) {
        return ts2.isPropertyAccessExpression(node) ? propertyAccessLeftHandSide(node.expression) : node;
      }
      function importNameForConvertToDefaultImport(node) {
        switch (node.kind) {
          case 254:
            var importClause = node.importClause, moduleSpecifier = node.moduleSpecifier;
            return importClause && !importClause.name && importClause.namedBindings && importClause.namedBindings.kind === 256 && ts2.isStringLiteral(moduleSpecifier) ? importClause.namedBindings.name : void 0;
          case 253:
            return node.name;
          default:
            return void 0;
        }
      }
      function addConvertToAsyncFunctionDiagnostics(node, checker, diags) {
        if (isConvertibleFunction(node, checker) && !visitedNestedConvertibleFunctions.has(getKeyFromNode(node))) {
          diags.push(ts2.createDiagnosticForNode(!node.name && ts2.isVariableDeclaration(node.parent) && ts2.isIdentifier(node.parent.name) ? node.parent.name : node, ts2.Diagnostics.This_may_be_converted_to_an_async_function));
        }
      }
      function isConvertibleFunction(node, checker) {
        return !ts2.isAsyncFunction(node) && node.body && ts2.isBlock(node.body) && hasReturnStatementWithPromiseHandler(node.body) && returnsPromise(node, checker);
      }
      function returnsPromise(node, checker) {
        var functionType = checker.getTypeAtLocation(node);
        var callSignatures = checker.getSignaturesOfType(functionType, 0);
        var returnType = callSignatures.length ? checker.getReturnTypeOfSignature(callSignatures[0]) : void 0;
        return !!returnType && !!checker.getPromisedTypeOfPromise(returnType);
      }
      function getErrorNodeFromCommonJsIndicator(commonJsModuleIndicator) {
        return ts2.isBinaryExpression(commonJsModuleIndicator) ? commonJsModuleIndicator.left : commonJsModuleIndicator;
      }
      function hasReturnStatementWithPromiseHandler(body) {
        return !!ts2.forEachReturnStatement(body, isReturnStatementWithFixablePromiseHandler);
      }
      function isReturnStatementWithFixablePromiseHandler(node) {
        return ts2.isReturnStatement(node) && !!node.expression && isFixablePromiseHandler(node.expression);
      }
      ts2.isReturnStatementWithFixablePromiseHandler = isReturnStatementWithFixablePromiseHandler;
      function isFixablePromiseHandler(node) {
        if (!isPromiseHandler(node) || !node.arguments.every(isFixablePromiseArgument)) {
          return false;
        }
        var currentNode = node.expression;
        while (isPromiseHandler(currentNode) || ts2.isPropertyAccessExpression(currentNode)) {
          if (ts2.isCallExpression(currentNode) && !currentNode.arguments.every(isFixablePromiseArgument)) {
            return false;
          }
          currentNode = currentNode.expression;
        }
        return true;
      }
      ts2.isFixablePromiseHandler = isFixablePromiseHandler;
      function isPromiseHandler(node) {
        return ts2.isCallExpression(node) && (ts2.hasPropertyAccessExpressionWithName(node, "then") && hasSupportedNumberOfArguments(node) || ts2.hasPropertyAccessExpressionWithName(node, "catch"));
      }
      function hasSupportedNumberOfArguments(node) {
        if (node.arguments.length > 2)
          return false;
        if (node.arguments.length < 2)
          return true;
        return ts2.some(node.arguments, function(arg) {
          return arg.kind === 100 || ts2.isIdentifier(arg) && arg.text === "undefined";
        });
      }
      function isFixablePromiseArgument(arg) {
        switch (arg.kind) {
          case 244:
          case 201:
          case 202:
            visitedNestedConvertibleFunctions.set(getKeyFromNode(arg), true);
          case 100:
          case 75:
            return true;
          default:
            return false;
        }
      }
      function getKeyFromNode(exp) {
        return exp.pos.toString() + ":" + exp.end.toString();
      }
      function canBeConvertedToClass(node) {
        var _a, _b, _c, _d;
        if (node.kind === 201) {
          if (ts2.isVariableDeclaration(node.parent) && ((_a = node.symbol.members) === null || _a === void 0 ? void 0 : _a.size)) {
            return true;
          }
          var decl = ts2.getDeclarationOfExpando(node);
          var symbol = decl === null || decl === void 0 ? void 0 : decl.symbol;
          return !!(symbol && (((_b = symbol.exports) === null || _b === void 0 ? void 0 : _b.size) || ((_c = symbol.members) === null || _c === void 0 ? void 0 : _c.size)));
        }
        if (node.kind === 244) {
          return !!((_d = node.symbol.members) === null || _d === void 0 ? void 0 : _d.size);
        }
        return false;
      }
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var SymbolDisplay;
      (function(SymbolDisplay2) {
        var symbolDisplayNodeBuilderFlags = 8192 | 70221824 | 16384;
        function getSymbolKind(typeChecker, symbol, location) {
          var result = getSymbolKindOfConstructorPropertyMethodAccessorFunctionOrVar(typeChecker, symbol, location);
          if (result !== "") {
            return result;
          }
          var flags = ts2.getCombinedLocalAndExportSymbolFlags(symbol);
          if (flags & 32) {
            return ts2.getDeclarationOfKind(symbol, 214) ? "local class" : "class";
          }
          if (flags & 384)
            return "enum";
          if (flags & 524288)
            return "type";
          if (flags & 64)
            return "interface";
          if (flags & 262144)
            return "type parameter";
          if (flags & 8)
            return "enum member";
          if (flags & 2097152)
            return "alias";
          if (flags & 1536)
            return "module";
          return result;
        }
        SymbolDisplay2.getSymbolKind = getSymbolKind;
        function getSymbolKindOfConstructorPropertyMethodAccessorFunctionOrVar(typeChecker, symbol, location) {
          var roots = typeChecker.getRootSymbols(symbol);
          if (roots.length === 1 && ts2.first(roots).flags & 8192 && typeChecker.getTypeOfSymbolAtLocation(symbol, location).getNonNullableType().getCallSignatures().length !== 0) {
            return "method";
          }
          if (typeChecker.isUndefinedSymbol(symbol)) {
            return "var";
          }
          if (typeChecker.isArgumentsSymbol(symbol)) {
            return "local var";
          }
          if (location.kind === 104 && ts2.isExpression(location)) {
            return "parameter";
          }
          var flags = ts2.getCombinedLocalAndExportSymbolFlags(symbol);
          if (flags & 3) {
            if (ts2.isFirstDeclarationOfSymbolParameter(symbol)) {
              return "parameter";
            } else if (symbol.valueDeclaration && ts2.isVarConst(symbol.valueDeclaration)) {
              return "const";
            } else if (ts2.forEach(symbol.declarations, ts2.isLet)) {
              return "let";
            }
            return isLocalVariableOrFunction(symbol) ? "local var" : "var";
          }
          if (flags & 16)
            return isLocalVariableOrFunction(symbol) ? "local function" : "function";
          if (flags & 32768)
            return "getter";
          if (flags & 65536)
            return "setter";
          if (flags & 8192)
            return "method";
          if (flags & 16384)
            return "constructor";
          if (flags & 4) {
            if (flags & 33554432 && symbol.checkFlags & 6) {
              var unionPropertyKind = ts2.forEach(typeChecker.getRootSymbols(symbol), function(rootSymbol) {
                var rootSymbolFlags = rootSymbol.getFlags();
                if (rootSymbolFlags & (98308 | 3)) {
                  return "property";
                }
                ts2.Debug.assert(!!(rootSymbolFlags & (8192 | 16)));
              });
              if (!unionPropertyKind) {
                var typeOfUnionProperty = typeChecker.getTypeOfSymbolAtLocation(symbol, location);
                if (typeOfUnionProperty.getCallSignatures().length) {
                  return "method";
                }
                return "property";
              }
              return unionPropertyKind;
            }
            switch (location.parent && location.parent.kind) {
              case 268:
              case 266:
              case 267:
                return location.kind === 75 ? "property" : "JSX attribute";
              case 273:
                return "JSX attribute";
              default:
                return "property";
            }
          }
          return "";
        }
        function getSymbolModifiers(symbol) {
          var nodeModifiers = symbol && symbol.declarations && symbol.declarations.length > 0 ? ts2.getNodeModifiers(symbol.declarations[0]) : "";
          var symbolModifiers = symbol && symbol.flags & 16777216 ? "optional" : "";
          return nodeModifiers && symbolModifiers ? nodeModifiers + "," + symbolModifiers : nodeModifiers || symbolModifiers;
        }
        SymbolDisplay2.getSymbolModifiers = getSymbolModifiers;
        function getSymbolDisplayPartsDocumentationAndSymbolKind(typeChecker, symbol, sourceFile, enclosingDeclaration, location, semanticMeaning, alias) {
          if (semanticMeaning === void 0) {
            semanticMeaning = ts2.getMeaningFromLocation(location);
          }
          var displayParts = [];
          var documentation = [];
          var tags = [];
          var symbolFlags = ts2.getCombinedLocalAndExportSymbolFlags(symbol);
          var symbolKind = semanticMeaning & 1 ? getSymbolKindOfConstructorPropertyMethodAccessorFunctionOrVar(typeChecker, symbol, location) : "";
          var hasAddedSymbolInfo = false;
          var isThisExpression = location.kind === 104 && ts2.isInExpressionContext(location);
          var type;
          var printer;
          var documentationFromAlias;
          var tagsFromAlias;
          var hasMultipleSignatures = false;
          if (location.kind === 104 && !isThisExpression) {
            return { displayParts: [ts2.keywordPart(104)], documentation: [], symbolKind: "primitive type", tags: void 0 };
          }
          if (symbolKind !== "" || symbolFlags & 32 || symbolFlags & 2097152) {
            if (symbolKind === "getter" || symbolKind === "setter") {
              symbolKind = "property";
            }
            var signature = void 0;
            type = isThisExpression ? typeChecker.getTypeAtLocation(location) : typeChecker.getTypeOfSymbolAtLocation(symbol.exportSymbol || symbol, location);
            if (location.parent && location.parent.kind === 194) {
              var right = location.parent.name;
              if (right === location || right && right.getFullWidth() === 0) {
                location = location.parent;
              }
            }
            var callExpressionLike = void 0;
            if (ts2.isCallOrNewExpression(location)) {
              callExpressionLike = location;
            } else if (ts2.isCallExpressionTarget(location) || ts2.isNewExpressionTarget(location)) {
              callExpressionLike = location.parent;
            } else if (location.parent && ts2.isJsxOpeningLikeElement(location.parent) && ts2.isFunctionLike(symbol.valueDeclaration)) {
              callExpressionLike = location.parent;
            }
            if (callExpressionLike) {
              signature = typeChecker.getResolvedSignature(callExpressionLike);
              var useConstructSignatures = callExpressionLike.kind === 197 || ts2.isCallExpression(callExpressionLike) && callExpressionLike.expression.kind === 102;
              var allSignatures = useConstructSignatures ? type.getConstructSignatures() : type.getCallSignatures();
              if (!ts2.contains(allSignatures, signature.target) && !ts2.contains(allSignatures, signature)) {
                signature = allSignatures.length ? allSignatures[0] : void 0;
              }
              if (signature) {
                if (useConstructSignatures && symbolFlags & 32) {
                  symbolKind = "constructor";
                  addPrefixForAnyFunctionOrVar(type.symbol, symbolKind);
                } else if (symbolFlags & 2097152) {
                  symbolKind = "alias";
                  pushSymbolKind(symbolKind);
                  displayParts.push(ts2.spacePart());
                  if (useConstructSignatures) {
                    displayParts.push(ts2.keywordPart(99));
                    displayParts.push(ts2.spacePart());
                  }
                  addFullSymbolName(symbol);
                } else {
                  addPrefixForAnyFunctionOrVar(symbol, symbolKind);
                }
                switch (symbolKind) {
                  case "JSX attribute":
                  case "property":
                  case "var":
                  case "const":
                  case "let":
                  case "parameter":
                  case "local var":
                    displayParts.push(ts2.punctuationPart(58));
                    displayParts.push(ts2.spacePart());
                    if (!(ts2.getObjectFlags(type) & 16) && type.symbol) {
                      ts2.addRange(displayParts, ts2.symbolToDisplayParts(typeChecker, type.symbol, enclosingDeclaration, void 0, 4 | 1));
                      displayParts.push(ts2.lineBreakPart());
                    }
                    if (useConstructSignatures) {
                      displayParts.push(ts2.keywordPart(99));
                      displayParts.push(ts2.spacePart());
                    }
                    addSignatureDisplayParts(signature, allSignatures, 262144);
                    break;
                  default:
                    addSignatureDisplayParts(signature, allSignatures);
                }
                hasAddedSymbolInfo = true;
                hasMultipleSignatures = allSignatures.length > 1;
              }
            } else if (ts2.isNameOfFunctionDeclaration(location) && !(symbolFlags & 98304) || location.kind === 129 && location.parent.kind === 162) {
              var functionDeclaration_1 = location.parent;
              var locationIsSymbolDeclaration = symbol.declarations && ts2.find(symbol.declarations, function(declaration2) {
                return declaration2 === (location.kind === 129 ? functionDeclaration_1.parent : functionDeclaration_1);
              });
              if (locationIsSymbolDeclaration) {
                var allSignatures = functionDeclaration_1.kind === 162 ? type.getNonNullableType().getConstructSignatures() : type.getNonNullableType().getCallSignatures();
                if (!typeChecker.isImplementationOfOverload(functionDeclaration_1)) {
                  signature = typeChecker.getSignatureFromDeclaration(functionDeclaration_1);
                } else {
                  signature = allSignatures[0];
                }
                if (functionDeclaration_1.kind === 162) {
                  symbolKind = "constructor";
                  addPrefixForAnyFunctionOrVar(type.symbol, symbolKind);
                } else {
                  addPrefixForAnyFunctionOrVar(functionDeclaration_1.kind === 165 && !(type.symbol.flags & 2048 || type.symbol.flags & 4096) ? type.symbol : symbol, symbolKind);
                }
                addSignatureDisplayParts(signature, allSignatures);
                hasAddedSymbolInfo = true;
                hasMultipleSignatures = allSignatures.length > 1;
              }
            }
          }
          if (symbolFlags & 32 && !hasAddedSymbolInfo && !isThisExpression) {
            addAliasPrefixIfNecessary();
            if (ts2.getDeclarationOfKind(symbol, 214)) {
              pushSymbolKind("local class");
            } else {
              displayParts.push(ts2.keywordPart(80));
            }
            displayParts.push(ts2.spacePart());
            addFullSymbolName(symbol);
            writeTypeParametersOfSymbol(symbol, sourceFile);
          }
          if (symbolFlags & 64 && semanticMeaning & 2) {
            prefixNextMeaning();
            displayParts.push(ts2.keywordPart(114));
            displayParts.push(ts2.spacePart());
            addFullSymbolName(symbol);
            writeTypeParametersOfSymbol(symbol, sourceFile);
          }
          if (symbolFlags & 524288 && semanticMeaning & 2) {
            prefixNextMeaning();
            displayParts.push(ts2.keywordPart(145));
            displayParts.push(ts2.spacePart());
            addFullSymbolName(symbol);
            writeTypeParametersOfSymbol(symbol, sourceFile);
            displayParts.push(ts2.spacePart());
            displayParts.push(ts2.operatorPart(62));
            displayParts.push(ts2.spacePart());
            ts2.addRange(displayParts, ts2.typeToDisplayParts(typeChecker, typeChecker.getDeclaredTypeOfSymbol(symbol), enclosingDeclaration, 8388608));
          }
          if (symbolFlags & 384) {
            prefixNextMeaning();
            if (ts2.some(symbol.declarations, function(d) {
              return ts2.isEnumDeclaration(d) && ts2.isEnumConst(d);
            })) {
              displayParts.push(ts2.keywordPart(81));
              displayParts.push(ts2.spacePart());
            }
            displayParts.push(ts2.keywordPart(88));
            displayParts.push(ts2.spacePart());
            addFullSymbolName(symbol);
          }
          if (symbolFlags & 1536 && !isThisExpression) {
            prefixNextMeaning();
            var declaration = ts2.getDeclarationOfKind(symbol, 249);
            var isNamespace = declaration && declaration.name && declaration.name.kind === 75;
            displayParts.push(ts2.keywordPart(isNamespace ? 136 : 135));
            displayParts.push(ts2.spacePart());
            addFullSymbolName(symbol);
          }
          if (symbolFlags & 262144 && semanticMeaning & 2) {
            prefixNextMeaning();
            displayParts.push(ts2.punctuationPart(20));
            displayParts.push(ts2.textPart("type parameter"));
            displayParts.push(ts2.punctuationPart(21));
            displayParts.push(ts2.spacePart());
            addFullSymbolName(symbol);
            if (symbol.parent) {
              addInPrefix();
              addFullSymbolName(symbol.parent, enclosingDeclaration);
              writeTypeParametersOfSymbol(symbol.parent, enclosingDeclaration);
            } else {
              var decl = ts2.getDeclarationOfKind(symbol, 155);
              if (decl === void 0)
                return ts2.Debug.fail();
              var declaration = decl.parent;
              if (declaration) {
                if (ts2.isFunctionLikeKind(declaration.kind)) {
                  addInPrefix();
                  var signature = typeChecker.getSignatureFromDeclaration(declaration);
                  if (declaration.kind === 166) {
                    displayParts.push(ts2.keywordPart(99));
                    displayParts.push(ts2.spacePart());
                  } else if (declaration.kind !== 165 && declaration.name) {
                    addFullSymbolName(declaration.symbol);
                  }
                  ts2.addRange(displayParts, ts2.signatureToDisplayParts(typeChecker, signature, sourceFile, 32));
                } else if (declaration.kind === 247) {
                  addInPrefix();
                  displayParts.push(ts2.keywordPart(145));
                  displayParts.push(ts2.spacePart());
                  addFullSymbolName(declaration.symbol);
                  writeTypeParametersOfSymbol(declaration.symbol, sourceFile);
                }
              }
            }
          }
          if (symbolFlags & 8) {
            symbolKind = "enum member";
            addPrefixForAnyFunctionOrVar(symbol, "enum member");
            var declaration = symbol.declarations[0];
            if (declaration.kind === 284) {
              var constantValue = typeChecker.getConstantValue(declaration);
              if (constantValue !== void 0) {
                displayParts.push(ts2.spacePart());
                displayParts.push(ts2.operatorPart(62));
                displayParts.push(ts2.spacePart());
                displayParts.push(ts2.displayPart(ts2.getTextOfConstantValue(constantValue), typeof constantValue === "number" ? ts2.SymbolDisplayPartKind.numericLiteral : ts2.SymbolDisplayPartKind.stringLiteral));
              }
            }
          }
          if (symbolFlags & 2097152) {
            prefixNextMeaning();
            if (!hasAddedSymbolInfo) {
              var resolvedSymbol = typeChecker.getAliasedSymbol(symbol);
              if (resolvedSymbol !== symbol && resolvedSymbol.declarations && resolvedSymbol.declarations.length > 0) {
                var resolvedNode = resolvedSymbol.declarations[0];
                var declarationName = ts2.getNameOfDeclaration(resolvedNode);
                if (declarationName) {
                  var isExternalModuleDeclaration = ts2.isModuleWithStringLiteralName(resolvedNode) && ts2.hasModifier(resolvedNode, 2);
                  var shouldUseAliasName = symbol.name !== "default" && !isExternalModuleDeclaration;
                  var resolvedInfo = getSymbolDisplayPartsDocumentationAndSymbolKind(typeChecker, resolvedSymbol, ts2.getSourceFileOfNode(resolvedNode), resolvedNode, declarationName, semanticMeaning, shouldUseAliasName ? symbol : resolvedSymbol);
                  displayParts.push.apply(displayParts, resolvedInfo.displayParts);
                  displayParts.push(ts2.lineBreakPart());
                  documentationFromAlias = resolvedInfo.documentation;
                  tagsFromAlias = resolvedInfo.tags;
                }
              }
            }
            switch (symbol.declarations[0].kind) {
              case 252:
                displayParts.push(ts2.keywordPart(89));
                displayParts.push(ts2.spacePart());
                displayParts.push(ts2.keywordPart(136));
                break;
              case 259:
                displayParts.push(ts2.keywordPart(89));
                displayParts.push(ts2.spacePart());
                displayParts.push(ts2.keywordPart(symbol.declarations[0].isExportEquals ? 62 : 84));
                break;
              case 263:
                displayParts.push(ts2.keywordPart(89));
                break;
              default:
                displayParts.push(ts2.keywordPart(96));
            }
            displayParts.push(ts2.spacePart());
            addFullSymbolName(symbol);
            ts2.forEach(symbol.declarations, function(declaration2) {
              if (declaration2.kind === 253) {
                var importEqualsDeclaration = declaration2;
                if (ts2.isExternalModuleImportEqualsDeclaration(importEqualsDeclaration)) {
                  displayParts.push(ts2.spacePart());
                  displayParts.push(ts2.operatorPart(62));
                  displayParts.push(ts2.spacePart());
                  displayParts.push(ts2.keywordPart(139));
                  displayParts.push(ts2.punctuationPart(20));
                  displayParts.push(ts2.displayPart(ts2.getTextOfNode(ts2.getExternalModuleImportEqualsDeclarationExpression(importEqualsDeclaration)), ts2.SymbolDisplayPartKind.stringLiteral));
                  displayParts.push(ts2.punctuationPart(21));
                } else {
                  var internalAliasSymbol = typeChecker.getSymbolAtLocation(importEqualsDeclaration.moduleReference);
                  if (internalAliasSymbol) {
                    displayParts.push(ts2.spacePart());
                    displayParts.push(ts2.operatorPart(62));
                    displayParts.push(ts2.spacePart());
                    addFullSymbolName(internalAliasSymbol, enclosingDeclaration);
                  }
                }
                return true;
              }
            });
          }
          if (!hasAddedSymbolInfo) {
            if (symbolKind !== "") {
              if (type) {
                if (isThisExpression) {
                  prefixNextMeaning();
                  displayParts.push(ts2.keywordPart(104));
                } else {
                  addPrefixForAnyFunctionOrVar(symbol, symbolKind);
                }
                if (symbolKind === "property" || symbolKind === "JSX attribute" || symbolFlags & 3 || symbolKind === "local var" || isThisExpression) {
                  displayParts.push(ts2.punctuationPart(58));
                  displayParts.push(ts2.spacePart());
                  if (type.symbol && type.symbol.flags & 262144) {
                    var typeParameterParts = ts2.mapToDisplayParts(function(writer) {
                      var param = typeChecker.typeParameterToDeclaration(type, enclosingDeclaration, symbolDisplayNodeBuilderFlags);
                      getPrinter().writeNode(4, param, ts2.getSourceFileOfNode(ts2.getParseTreeNode(enclosingDeclaration)), writer);
                    });
                    ts2.addRange(displayParts, typeParameterParts);
                  } else {
                    ts2.addRange(displayParts, ts2.typeToDisplayParts(typeChecker, type, enclosingDeclaration));
                  }
                } else if (symbolFlags & 16 || symbolFlags & 8192 || symbolFlags & 16384 || symbolFlags & 131072 || symbolFlags & 98304 || symbolKind === "method") {
                  var allSignatures = type.getNonNullableType().getCallSignatures();
                  if (allSignatures.length) {
                    addSignatureDisplayParts(allSignatures[0], allSignatures);
                    hasMultipleSignatures = allSignatures.length > 1;
                  }
                }
              }
            } else {
              symbolKind = getSymbolKind(typeChecker, symbol, location);
            }
          }
          if (documentation.length === 0 && !hasMultipleSignatures) {
            documentation = symbol.getDocumentationComment(typeChecker);
          }
          if (documentation.length === 0 && symbolFlags & 4) {
            if (symbol.parent && ts2.forEach(symbol.parent.declarations, function(declaration2) {
              return declaration2.kind === 290;
            })) {
              for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
                var declaration = _a[_i];
                if (!declaration.parent || declaration.parent.kind !== 209) {
                  continue;
                }
                var rhsSymbol = typeChecker.getSymbolAtLocation(declaration.parent.right);
                if (!rhsSymbol) {
                  continue;
                }
                documentation = rhsSymbol.getDocumentationComment(typeChecker);
                tags = rhsSymbol.getJsDocTags();
                if (documentation.length > 0) {
                  break;
                }
              }
            }
          }
          if (tags.length === 0 && !hasMultipleSignatures) {
            tags = symbol.getJsDocTags();
          }
          if (documentation.length === 0 && documentationFromAlias) {
            documentation = documentationFromAlias;
          }
          if (tags.length === 0 && tagsFromAlias) {
            tags = tagsFromAlias;
          }
          return { displayParts, documentation, symbolKind, tags: tags.length === 0 ? void 0 : tags };
          function getPrinter() {
            if (!printer) {
              printer = ts2.createPrinter({ removeComments: true });
            }
            return printer;
          }
          function prefixNextMeaning() {
            if (displayParts.length) {
              displayParts.push(ts2.lineBreakPart());
            }
            addAliasPrefixIfNecessary();
          }
          function addAliasPrefixIfNecessary() {
            if (alias) {
              pushSymbolKind("alias");
              displayParts.push(ts2.spacePart());
            }
          }
          function addInPrefix() {
            displayParts.push(ts2.spacePart());
            displayParts.push(ts2.keywordPart(97));
            displayParts.push(ts2.spacePart());
          }
          function addFullSymbolName(symbolToDisplay, enclosingDeclaration2) {
            if (alias && symbolToDisplay === symbol) {
              symbolToDisplay = alias;
            }
            var fullSymbolDisplayParts = ts2.symbolToDisplayParts(typeChecker, symbolToDisplay, enclosingDeclaration2 || sourceFile, void 0, 1 | 2 | 4);
            ts2.addRange(displayParts, fullSymbolDisplayParts);
            if (symbol.flags & 16777216) {
              displayParts.push(ts2.punctuationPart(57));
            }
          }
          function addPrefixForAnyFunctionOrVar(symbol2, symbolKind2) {
            prefixNextMeaning();
            if (symbolKind2) {
              pushSymbolKind(symbolKind2);
              if (symbol2 && !ts2.some(symbol2.declarations, function(d) {
                return ts2.isArrowFunction(d) || (ts2.isFunctionExpression(d) || ts2.isClassExpression(d)) && !d.name;
              })) {
                displayParts.push(ts2.spacePart());
                addFullSymbolName(symbol2);
              }
            }
          }
          function pushSymbolKind(symbolKind2) {
            switch (symbolKind2) {
              case "var":
              case "function":
              case "let":
              case "const":
              case "constructor":
                displayParts.push(ts2.textOrKeywordPart(symbolKind2));
                return;
              default:
                displayParts.push(ts2.punctuationPart(20));
                displayParts.push(ts2.textOrKeywordPart(symbolKind2));
                displayParts.push(ts2.punctuationPart(21));
                return;
            }
          }
          function addSignatureDisplayParts(signature2, allSignatures2, flags) {
            if (flags === void 0) {
              flags = 0;
            }
            ts2.addRange(displayParts, ts2.signatureToDisplayParts(typeChecker, signature2, enclosingDeclaration, flags | 32));
            if (allSignatures2.length > 1) {
              displayParts.push(ts2.spacePart());
              displayParts.push(ts2.punctuationPart(20));
              displayParts.push(ts2.operatorPart(39));
              displayParts.push(ts2.displayPart((allSignatures2.length - 1).toString(), ts2.SymbolDisplayPartKind.numericLiteral));
              displayParts.push(ts2.spacePart());
              displayParts.push(ts2.textPart(allSignatures2.length === 2 ? "overload" : "overloads"));
              displayParts.push(ts2.punctuationPart(21));
            }
            documentation = signature2.getDocumentationComment(typeChecker);
            tags = signature2.getJsDocTags();
            if (allSignatures2.length > 1 && documentation.length === 0 && tags.length === 0) {
              documentation = allSignatures2[0].getDocumentationComment(typeChecker);
              tags = allSignatures2[0].getJsDocTags();
            }
          }
          function writeTypeParametersOfSymbol(symbol2, enclosingDeclaration2) {
            var typeParameterParts2 = ts2.mapToDisplayParts(function(writer) {
              var params = typeChecker.symbolToTypeParameterDeclarations(symbol2, enclosingDeclaration2, symbolDisplayNodeBuilderFlags);
              getPrinter().writeList(53776, params, ts2.getSourceFileOfNode(ts2.getParseTreeNode(enclosingDeclaration2)), writer);
            });
            ts2.addRange(displayParts, typeParameterParts2);
          }
        }
        SymbolDisplay2.getSymbolDisplayPartsDocumentationAndSymbolKind = getSymbolDisplayPartsDocumentationAndSymbolKind;
        function isLocalVariableOrFunction(symbol) {
          if (symbol.parent) {
            return false;
          }
          return ts2.forEach(symbol.declarations, function(declaration) {
            if (declaration.kind === 201) {
              return true;
            }
            if (declaration.kind !== 242 && declaration.kind !== 244) {
              return false;
            }
            for (var parent = declaration.parent; !ts2.isFunctionBlock(parent); parent = parent.parent) {
              if (parent.kind === 290 || parent.kind === 250) {
                return false;
              }
            }
            return true;
          });
        }
      })(SymbolDisplay = ts2.SymbolDisplay || (ts2.SymbolDisplay = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function transpileModule(input, transpileOptions) {
        var diagnostics = [];
        var options = transpileOptions.compilerOptions ? fixupCompilerOptions(transpileOptions.compilerOptions, diagnostics) : {};
        var defaultOptions = ts2.getDefaultCompilerOptions();
        for (var key in defaultOptions) {
          if (ts2.hasProperty(defaultOptions, key) && options[key] === void 0) {
            options[key] = defaultOptions[key];
          }
        }
        for (var _i = 0, transpileOptionValueCompilerOptions_1 = ts2.transpileOptionValueCompilerOptions; _i < transpileOptionValueCompilerOptions_1.length; _i++) {
          var option = transpileOptionValueCompilerOptions_1[_i];
          options[option.name] = option.transpileOptionValue;
        }
        options.suppressOutputPathCheck = true;
        options.allowNonTsExtensions = true;
        var inputFileName = transpileOptions.fileName || (transpileOptions.compilerOptions && transpileOptions.compilerOptions.jsx ? "module.tsx" : "module.ts");
        var sourceFile = ts2.createSourceFile(inputFileName, input, options.target);
        if (transpileOptions.moduleName) {
          sourceFile.moduleName = transpileOptions.moduleName;
        }
        if (transpileOptions.renamedDependencies) {
          sourceFile.renamedDependencies = ts2.createMapFromTemplate(transpileOptions.renamedDependencies);
        }
        var newLine = ts2.getNewLineCharacter(options);
        var outputText;
        var sourceMapText;
        var compilerHost = {
          getSourceFile: function(fileName) {
            return fileName === ts2.normalizePath(inputFileName) ? sourceFile : void 0;
          },
          writeFile: function(name, text) {
            if (ts2.fileExtensionIs(name, ".map")) {
              ts2.Debug.assertEqual(sourceMapText, void 0, "Unexpected multiple source map outputs, file:", name);
              sourceMapText = text;
            } else {
              ts2.Debug.assertEqual(outputText, void 0, "Unexpected multiple outputs, file:", name);
              outputText = text;
            }
          },
          getDefaultLibFileName: function() {
            return "lib.d.ts";
          },
          useCaseSensitiveFileNames: function() {
            return false;
          },
          getCanonicalFileName: function(fileName) {
            return fileName;
          },
          getCurrentDirectory: function() {
            return "";
          },
          getNewLine: function() {
            return newLine;
          },
          fileExists: function(fileName) {
            return fileName === inputFileName;
          },
          readFile: function() {
            return "";
          },
          directoryExists: function() {
            return true;
          },
          getDirectories: function() {
            return [];
          }
        };
        var program = ts2.createProgram([inputFileName], options, compilerHost);
        if (transpileOptions.reportDiagnostics) {
          ts2.addRange(diagnostics, program.getSyntacticDiagnostics(sourceFile));
          ts2.addRange(diagnostics, program.getOptionsDiagnostics());
        }
        program.emit(void 0, void 0, void 0, void 0, transpileOptions.transformers);
        if (outputText === void 0)
          return ts2.Debug.fail("Output generation failed");
        return { outputText, diagnostics, sourceMapText };
      }
      ts2.transpileModule = transpileModule;
      function transpile(input, compilerOptions, fileName, diagnostics, moduleName) {
        var output = transpileModule(input, { compilerOptions, fileName, reportDiagnostics: !!diagnostics, moduleName });
        ts2.addRange(diagnostics, output.diagnostics);
        return output.outputText;
      }
      ts2.transpile = transpile;
      var commandLineOptionsStringToEnum;
      function fixupCompilerOptions(options, diagnostics) {
        commandLineOptionsStringToEnum = commandLineOptionsStringToEnum || ts2.filter(ts2.optionDeclarations, function(o) {
          return typeof o.type === "object" && !ts2.forEachEntry(o.type, function(v) {
            return typeof v !== "number";
          });
        });
        options = ts2.cloneCompilerOptions(options);
        var _loop_8 = function(opt2) {
          if (!ts2.hasProperty(options, opt2.name)) {
            return "continue";
          }
          var value = options[opt2.name];
          if (ts2.isString(value)) {
            options[opt2.name] = ts2.parseCustomTypeOption(opt2, value, diagnostics);
          } else {
            if (!ts2.forEachEntry(opt2.type, function(v) {
              return v === value;
            })) {
              diagnostics.push(ts2.createCompilerDiagnosticForInvalidCustomType(opt2));
            }
          }
        };
        for (var _i = 0, commandLineOptionsStringToEnum_1 = commandLineOptionsStringToEnum; _i < commandLineOptionsStringToEnum_1.length; _i++) {
          var opt = commandLineOptionsStringToEnum_1[_i];
          _loop_8(opt);
        }
        return options;
      }
      ts2.fixupCompilerOptions = fixupCompilerOptions;
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var formatting;
      (function(formatting2) {
        var FormattingRequestKind;
        (function(FormattingRequestKind2) {
          FormattingRequestKind2[FormattingRequestKind2["FormatDocument"] = 0] = "FormatDocument";
          FormattingRequestKind2[FormattingRequestKind2["FormatSelection"] = 1] = "FormatSelection";
          FormattingRequestKind2[FormattingRequestKind2["FormatOnEnter"] = 2] = "FormatOnEnter";
          FormattingRequestKind2[FormattingRequestKind2["FormatOnSemicolon"] = 3] = "FormatOnSemicolon";
          FormattingRequestKind2[FormattingRequestKind2["FormatOnOpeningCurlyBrace"] = 4] = "FormatOnOpeningCurlyBrace";
          FormattingRequestKind2[FormattingRequestKind2["FormatOnClosingCurlyBrace"] = 5] = "FormatOnClosingCurlyBrace";
        })(FormattingRequestKind = formatting2.FormattingRequestKind || (formatting2.FormattingRequestKind = {}));
        var FormattingContext = function() {
          function FormattingContext2(sourceFile, formattingRequestKind, options) {
            this.sourceFile = sourceFile;
            this.formattingRequestKind = formattingRequestKind;
            this.options = options;
          }
          FormattingContext2.prototype.updateContext = function(currentRange, currentTokenParent, nextRange, nextTokenParent, commonParent) {
            this.currentTokenSpan = ts2.Debug.checkDefined(currentRange);
            this.currentTokenParent = ts2.Debug.checkDefined(currentTokenParent);
            this.nextTokenSpan = ts2.Debug.checkDefined(nextRange);
            this.nextTokenParent = ts2.Debug.checkDefined(nextTokenParent);
            this.contextNode = ts2.Debug.checkDefined(commonParent);
            this.contextNodeAllOnSameLine = void 0;
            this.nextNodeAllOnSameLine = void 0;
            this.tokensAreOnSameLine = void 0;
            this.contextNodeBlockIsOnOneLine = void 0;
            this.nextNodeBlockIsOnOneLine = void 0;
          };
          FormattingContext2.prototype.ContextNodeAllOnSameLine = function() {
            if (this.contextNodeAllOnSameLine === void 0) {
              this.contextNodeAllOnSameLine = this.NodeIsOnOneLine(this.contextNode);
            }
            return this.contextNodeAllOnSameLine;
          };
          FormattingContext2.prototype.NextNodeAllOnSameLine = function() {
            if (this.nextNodeAllOnSameLine === void 0) {
              this.nextNodeAllOnSameLine = this.NodeIsOnOneLine(this.nextTokenParent);
            }
            return this.nextNodeAllOnSameLine;
          };
          FormattingContext2.prototype.TokensAreOnSameLine = function() {
            if (this.tokensAreOnSameLine === void 0) {
              var startLine = this.sourceFile.getLineAndCharacterOfPosition(this.currentTokenSpan.pos).line;
              var endLine = this.sourceFile.getLineAndCharacterOfPosition(this.nextTokenSpan.pos).line;
              this.tokensAreOnSameLine = startLine === endLine;
            }
            return this.tokensAreOnSameLine;
          };
          FormattingContext2.prototype.ContextNodeBlockIsOnOneLine = function() {
            if (this.contextNodeBlockIsOnOneLine === void 0) {
              this.contextNodeBlockIsOnOneLine = this.BlockIsOnOneLine(this.contextNode);
            }
            return this.contextNodeBlockIsOnOneLine;
          };
          FormattingContext2.prototype.NextNodeBlockIsOnOneLine = function() {
            if (this.nextNodeBlockIsOnOneLine === void 0) {
              this.nextNodeBlockIsOnOneLine = this.BlockIsOnOneLine(this.nextTokenParent);
            }
            return this.nextNodeBlockIsOnOneLine;
          };
          FormattingContext2.prototype.NodeIsOnOneLine = function(node) {
            var startLine = this.sourceFile.getLineAndCharacterOfPosition(node.getStart(this.sourceFile)).line;
            var endLine = this.sourceFile.getLineAndCharacterOfPosition(node.getEnd()).line;
            return startLine === endLine;
          };
          FormattingContext2.prototype.BlockIsOnOneLine = function(node) {
            var openBrace = ts2.findChildOfKind(node, 18, this.sourceFile);
            var closeBrace = ts2.findChildOfKind(node, 19, this.sourceFile);
            if (openBrace && closeBrace) {
              var startLine = this.sourceFile.getLineAndCharacterOfPosition(openBrace.getEnd()).line;
              var endLine = this.sourceFile.getLineAndCharacterOfPosition(closeBrace.getStart(this.sourceFile)).line;
              return startLine === endLine;
            }
            return false;
          };
          return FormattingContext2;
        }();
        formatting2.FormattingContext = FormattingContext;
      })(formatting = ts2.formatting || (ts2.formatting = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var formatting;
      (function(formatting2) {
        var standardScanner = ts2.createScanner(99, false, 0);
        var jsxScanner = ts2.createScanner(99, false, 1);
        var ScanAction;
        (function(ScanAction2) {
          ScanAction2[ScanAction2["Scan"] = 0] = "Scan";
          ScanAction2[ScanAction2["RescanGreaterThanToken"] = 1] = "RescanGreaterThanToken";
          ScanAction2[ScanAction2["RescanSlashToken"] = 2] = "RescanSlashToken";
          ScanAction2[ScanAction2["RescanTemplateToken"] = 3] = "RescanTemplateToken";
          ScanAction2[ScanAction2["RescanJsxIdentifier"] = 4] = "RescanJsxIdentifier";
          ScanAction2[ScanAction2["RescanJsxText"] = 5] = "RescanJsxText";
          ScanAction2[ScanAction2["RescanJsxAttributeValue"] = 6] = "RescanJsxAttributeValue";
        })(ScanAction || (ScanAction = {}));
        function getFormattingScanner(text, languageVariant, startPos, endPos, cb) {
          var scanner = languageVariant === 1 ? jsxScanner : standardScanner;
          scanner.setText(text);
          scanner.setTextPos(startPos);
          var wasNewLine = true;
          var leadingTrivia;
          var trailingTrivia;
          var savedPos;
          var lastScanAction;
          var lastTokenInfo;
          var res = cb({
            advance,
            readTokenInfo,
            readEOFTokenRange,
            isOnToken,
            isOnEOF,
            getCurrentLeadingTrivia: function() {
              return leadingTrivia;
            },
            lastTrailingTriviaWasNewLine: function() {
              return wasNewLine;
            },
            skipToEndOf
          });
          lastTokenInfo = void 0;
          scanner.setText(void 0);
          return res;
          function advance() {
            lastTokenInfo = void 0;
            var isStarted = scanner.getStartPos() !== startPos;
            if (isStarted) {
              wasNewLine = !!trailingTrivia && ts2.last(trailingTrivia).kind === 4;
            } else {
              scanner.scan();
            }
            leadingTrivia = void 0;
            trailingTrivia = void 0;
            var pos = scanner.getStartPos();
            while (pos < endPos) {
              var t = scanner.getToken();
              if (!ts2.isTrivia(t)) {
                break;
              }
              scanner.scan();
              var item = {
                pos,
                end: scanner.getStartPos(),
                kind: t
              };
              pos = scanner.getStartPos();
              leadingTrivia = ts2.append(leadingTrivia, item);
            }
            savedPos = scanner.getStartPos();
          }
          function shouldRescanGreaterThanToken(node) {
            switch (node.kind) {
              case 33:
              case 70:
              case 71:
              case 49:
              case 48:
                return true;
            }
            return false;
          }
          function shouldRescanJsxIdentifier(node) {
            if (node.parent) {
              switch (node.parent.kind) {
                case 273:
                case 268:
                case 269:
                case 267:
                  return ts2.isKeyword(node.kind) || node.kind === 75;
              }
            }
            return false;
          }
          function shouldRescanJsxText(node) {
            var isJSXText = ts2.isJsxText(node);
            if (isJSXText) {
              var containingElement = ts2.findAncestor(node.parent, function(p) {
                return ts2.isJsxElement(p);
              });
              if (!containingElement)
                return false;
              return !ts2.isParenthesizedExpression(containingElement.parent);
            }
            return false;
          }
          function shouldRescanSlashToken(container) {
            return container.kind === 13;
          }
          function shouldRescanTemplateToken(container) {
            return container.kind === 16 || container.kind === 17;
          }
          function shouldRescanJsxAttributeValue(node) {
            return node.parent && ts2.isJsxAttribute(node.parent) && node.parent.initializer === node;
          }
          function startsWithSlashToken(t) {
            return t === 43 || t === 67;
          }
          function readTokenInfo(n) {
            ts2.Debug.assert(isOnToken());
            var expectedScanAction = shouldRescanGreaterThanToken(n) ? 1 : shouldRescanSlashToken(n) ? 2 : shouldRescanTemplateToken(n) ? 3 : shouldRescanJsxIdentifier(n) ? 4 : shouldRescanJsxText(n) ? 5 : shouldRescanJsxAttributeValue(n) ? 6 : 0;
            if (lastTokenInfo && expectedScanAction === lastScanAction) {
              return fixTokenKind(lastTokenInfo, n);
            }
            if (scanner.getStartPos() !== savedPos) {
              ts2.Debug.assert(lastTokenInfo !== void 0);
              scanner.setTextPos(savedPos);
              scanner.scan();
            }
            var currentToken = getNextToken(n, expectedScanAction);
            var token = formatting2.createTextRangeWithKind(scanner.getStartPos(), scanner.getTextPos(), currentToken);
            if (trailingTrivia) {
              trailingTrivia = void 0;
            }
            while (scanner.getStartPos() < endPos) {
              currentToken = scanner.scan();
              if (!ts2.isTrivia(currentToken)) {
                break;
              }
              var trivia = formatting2.createTextRangeWithKind(scanner.getStartPos(), scanner.getTextPos(), currentToken);
              if (!trailingTrivia) {
                trailingTrivia = [];
              }
              trailingTrivia.push(trivia);
              if (currentToken === 4) {
                scanner.scan();
                break;
              }
            }
            lastTokenInfo = { leadingTrivia, trailingTrivia, token };
            return fixTokenKind(lastTokenInfo, n);
          }
          function getNextToken(n, expectedScanAction) {
            var token = scanner.getToken();
            lastScanAction = 0;
            switch (expectedScanAction) {
              case 1:
                if (token === 31) {
                  lastScanAction = 1;
                  var newToken = scanner.reScanGreaterToken();
                  ts2.Debug.assert(n.kind === newToken);
                  return newToken;
                }
                break;
              case 2:
                if (startsWithSlashToken(token)) {
                  lastScanAction = 2;
                  var newToken = scanner.reScanSlashToken();
                  ts2.Debug.assert(n.kind === newToken);
                  return newToken;
                }
                break;
              case 3:
                if (token === 19) {
                  lastScanAction = 3;
                  return scanner.reScanTemplateToken(false);
                }
                break;
              case 4:
                lastScanAction = 4;
                return scanner.scanJsxIdentifier();
              case 5:
                lastScanAction = 5;
                return scanner.reScanJsxToken();
              case 6:
                lastScanAction = 6;
                return scanner.reScanJsxAttributeValue();
              case 0:
                break;
              default:
                ts2.Debug.assertNever(expectedScanAction);
            }
            return token;
          }
          function readEOFTokenRange() {
            ts2.Debug.assert(isOnEOF());
            return formatting2.createTextRangeWithKind(scanner.getStartPos(), scanner.getTextPos(), 1);
          }
          function isOnToken() {
            var current = lastTokenInfo ? lastTokenInfo.token.kind : scanner.getToken();
            var startPos2 = lastTokenInfo ? lastTokenInfo.token.pos : scanner.getStartPos();
            return startPos2 < endPos && current !== 1 && !ts2.isTrivia(current);
          }
          function isOnEOF() {
            var current = lastTokenInfo ? lastTokenInfo.token.kind : scanner.getToken();
            return current === 1;
          }
          function fixTokenKind(tokenInfo, container) {
            if (ts2.isToken(container) && tokenInfo.token.kind !== container.kind) {
              tokenInfo.token.kind = container.kind;
            }
            return tokenInfo;
          }
          function skipToEndOf(node) {
            scanner.setTextPos(node.end);
            savedPos = scanner.getStartPos();
            lastScanAction = void 0;
            lastTokenInfo = void 0;
            wasNewLine = false;
            leadingTrivia = void 0;
            trailingTrivia = void 0;
          }
        }
        formatting2.getFormattingScanner = getFormattingScanner;
      })(formatting = ts2.formatting || (ts2.formatting = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var formatting;
      (function(formatting2) {
        formatting2.anyContext = ts2.emptyArray;
        var RuleAction;
        (function(RuleAction2) {
          RuleAction2[RuleAction2["StopProcessingSpaceActions"] = 1] = "StopProcessingSpaceActions";
          RuleAction2[RuleAction2["StopProcessingTokenActions"] = 2] = "StopProcessingTokenActions";
          RuleAction2[RuleAction2["InsertSpace"] = 4] = "InsertSpace";
          RuleAction2[RuleAction2["InsertNewLine"] = 8] = "InsertNewLine";
          RuleAction2[RuleAction2["DeleteSpace"] = 16] = "DeleteSpace";
          RuleAction2[RuleAction2["DeleteToken"] = 32] = "DeleteToken";
          RuleAction2[RuleAction2["InsertTrailingSemicolon"] = 64] = "InsertTrailingSemicolon";
          RuleAction2[RuleAction2["StopAction"] = 3] = "StopAction";
          RuleAction2[RuleAction2["ModifySpaceAction"] = 28] = "ModifySpaceAction";
          RuleAction2[RuleAction2["ModifyTokenAction"] = 96] = "ModifyTokenAction";
        })(RuleAction = formatting2.RuleAction || (formatting2.RuleAction = {}));
        var RuleFlags;
        (function(RuleFlags2) {
          RuleFlags2[RuleFlags2["None"] = 0] = "None";
          RuleFlags2[RuleFlags2["CanDeleteNewLines"] = 1] = "CanDeleteNewLines";
        })(RuleFlags = formatting2.RuleFlags || (formatting2.RuleFlags = {}));
      })(formatting = ts2.formatting || (ts2.formatting = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var formatting;
      (function(formatting2) {
        function getAllRules() {
          var allTokens = [];
          for (var token = 0; token <= 152; token++) {
            if (token !== 1) {
              allTokens.push(token);
            }
          }
          function anyTokenExcept() {
            var tokens = [];
            for (var _i = 0; _i < arguments.length; _i++) {
              tokens[_i] = arguments[_i];
            }
            return { tokens: allTokens.filter(function(t) {
              return !tokens.some(function(t2) {
                return t2 === t;
              });
            }), isSpecific: false };
          }
          var anyToken = { tokens: allTokens, isSpecific: false };
          var anyTokenIncludingMultilineComments = tokenRangeFrom(__spreadArrays(allTokens, [3]));
          var anyTokenIncludingEOF = tokenRangeFrom(__spreadArrays(allTokens, [1]));
          var keywords = tokenRangeFromRange(77, 152);
          var binaryOperators = tokenRangeFromRange(29, 74);
          var binaryKeywordOperators = [97, 98, 152, 123, 133];
          var unaryPrefixOperators = [45, 46, 54, 53];
          var unaryPrefixExpressions = [
            8,
            9,
            75,
            20,
            22,
            18,
            104,
            99
          ];
          var unaryPreincrementExpressions = [75, 20, 104, 99];
          var unaryPostincrementExpressions = [75, 21, 23, 99];
          var unaryPredecrementExpressions = [75, 20, 104, 99];
          var unaryPostdecrementExpressions = [75, 21, 23, 99];
          var comments = [2, 3];
          var typeNames = __spreadArrays([75], ts2.typeKeywords);
          var functionOpenBraceLeftTokenRange = anyTokenIncludingMultilineComments;
          var typeScriptOpenBraceLeftTokenRange = tokenRangeFrom([75, 3, 80, 89, 96]);
          var controlOpenBraceLeftTokenRange = tokenRangeFrom([21, 3, 86, 107, 92, 87]);
          var highPriorityCommonRules = [
            rule("IgnoreBeforeComment", anyToken, comments, formatting2.anyContext, 1),
            rule("IgnoreAfterLineComment", 2, anyToken, formatting2.anyContext, 1),
            rule("NotSpaceBeforeColon", anyToken, 58, [isNonJsxSameLineTokenContext, isNotBinaryOpContext, isNotTypeAnnotationContext], 16),
            rule("SpaceAfterColon", 58, anyToken, [isNonJsxSameLineTokenContext, isNotBinaryOpContext], 4),
            rule("NoSpaceBeforeQuestionMark", anyToken, 57, [isNonJsxSameLineTokenContext, isNotBinaryOpContext], 16),
            rule("SpaceAfterQuestionMarkInConditionalOperator", 57, anyToken, [isNonJsxSameLineTokenContext, isConditionalOperatorContext], 4),
            rule("NoSpaceAfterQuestionMark", 57, anyToken, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeDot", anyToken, [24, 28], [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterDot", [24, 28], anyToken, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBetweenImportParenInImportType", 96, 20, [isNonJsxSameLineTokenContext, isImportTypeContext], 16),
            rule("NoSpaceAfterUnaryPrefixOperator", unaryPrefixOperators, unaryPrefixExpressions, [isNonJsxSameLineTokenContext, isNotBinaryOpContext], 16),
            rule("NoSpaceAfterUnaryPreincrementOperator", 45, unaryPreincrementExpressions, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterUnaryPredecrementOperator", 46, unaryPredecrementExpressions, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeUnaryPostincrementOperator", unaryPostincrementExpressions, 45, [isNonJsxSameLineTokenContext, isNotStatementConditionContext], 16),
            rule("NoSpaceBeforeUnaryPostdecrementOperator", unaryPostdecrementExpressions, 46, [isNonJsxSameLineTokenContext, isNotStatementConditionContext], 16),
            rule("SpaceAfterPostincrementWhenFollowedByAdd", 45, 39, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterAddWhenFollowedByUnaryPlus", 39, 39, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterAddWhenFollowedByPreincrement", 39, 45, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterPostdecrementWhenFollowedBySubtract", 46, 40, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterSubtractWhenFollowedByUnaryMinus", 40, 40, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterSubtractWhenFollowedByPredecrement", 40, 46, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("NoSpaceAfterCloseBrace", 19, [27, 26], [isNonJsxSameLineTokenContext], 16),
            rule("NewLineBeforeCloseBraceInBlockContext", anyTokenIncludingMultilineComments, 19, [isMultilineBlockContext], 8),
            rule("SpaceAfterCloseBrace", 19, anyTokenExcept(21), [isNonJsxSameLineTokenContext, isAfterCodeBlockContext], 4),
            rule("SpaceBetweenCloseBraceAndElse", 19, 87, [isNonJsxSameLineTokenContext], 4),
            rule("SpaceBetweenCloseBraceAndWhile", 19, 111, [isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceBetweenEmptyBraceBrackets", 18, 19, [isNonJsxSameLineTokenContext, isObjectContext], 16),
            rule("SpaceAfterConditionalClosingParen", 21, 22, [isControlDeclContext], 4),
            rule("NoSpaceBetweenFunctionKeywordAndStar", 94, 41, [isFunctionDeclarationOrFunctionExpressionContext], 16),
            rule("SpaceAfterStarInGeneratorDeclaration", 41, 75, [isFunctionDeclarationOrFunctionExpressionContext], 4),
            rule("SpaceAfterFunctionInFuncDecl", 94, anyToken, [isFunctionDeclContext], 4),
            rule("NewLineAfterOpenBraceInBlockContext", 18, anyToken, [isMultilineBlockContext], 8),
            rule("SpaceAfterGetSetInMember", [131, 142], 75, [isFunctionDeclContext], 4),
            rule("NoSpaceBetweenYieldKeywordAndStar", 121, 41, [isNonJsxSameLineTokenContext, isYieldOrYieldStarWithOperand], 16),
            rule("SpaceBetweenYieldOrYieldStarAndOperand", [121, 41], anyToken, [isNonJsxSameLineTokenContext, isYieldOrYieldStarWithOperand], 4),
            rule("NoSpaceBetweenReturnAndSemicolon", 101, 26, [isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterCertainKeywords", [109, 105, 99, 85, 101, 108, 127], anyToken, [isNonJsxSameLineTokenContext], 4),
            rule("SpaceAfterLetConstInVariableDeclaration", [115, 81], anyToken, [isNonJsxSameLineTokenContext, isStartOfVariableDeclarationList], 4),
            rule("NoSpaceBeforeOpenParenInFuncCall", anyToken, 20, [isNonJsxSameLineTokenContext, isFunctionCallOrNewContext, isPreviousTokenNotComma], 16),
            rule("SpaceBeforeBinaryKeywordOperator", anyToken, binaryKeywordOperators, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterBinaryKeywordOperator", binaryKeywordOperators, anyToken, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterVoidOperator", 110, anyToken, [isNonJsxSameLineTokenContext, isVoidOpContext], 4),
            rule("SpaceBetweenAsyncAndOpenParen", 126, 20, [isArrowFunctionContext, isNonJsxSameLineTokenContext], 4),
            rule("SpaceBetweenAsyncAndFunctionKeyword", 126, [94, 75], [isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceBetweenTagAndTemplateString", [75, 21], [14, 15], [isNonJsxSameLineTokenContext], 16),
            rule("SpaceBeforeJsxAttribute", anyToken, 75, [isNextTokenParentJsxAttribute, isNonJsxSameLineTokenContext], 4),
            rule("SpaceBeforeSlashInJsxOpeningElement", anyToken, 43, [isJsxSelfClosingElementContext, isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceBeforeGreaterThanTokenInJsxOpeningElement", 43, 31, [isJsxSelfClosingElementContext, isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeEqualInJsxAttribute", anyToken, 62, [isJsxAttributeContext, isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterEqualInJsxAttribute", 62, anyToken, [isJsxAttributeContext, isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterModuleImport", [135, 139], 20, [isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterCertainTypeScriptKeywords", [
              122,
              80,
              130,
              84,
              88,
              89,
              90,
              131,
              113,
              96,
              114,
              135,
              136,
              117,
              119,
              118,
              138,
              142,
              120,
              145,
              149,
              134,
              132
            ], anyToken, [isNonJsxSameLineTokenContext], 4),
            rule("SpaceBeforeCertainTypeScriptKeywords", anyToken, [90, 113, 149], [isNonJsxSameLineTokenContext], 4),
            rule("SpaceAfterModuleName", 10, 18, [isModuleDeclContext], 4),
            rule("SpaceBeforeArrow", anyToken, 38, [isNonJsxSameLineTokenContext], 4),
            rule("SpaceAfterArrow", 38, anyToken, [isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceAfterEllipsis", 25, 75, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterOptionalParameters", 57, [21, 27], [isNonJsxSameLineTokenContext, isNotBinaryOpContext], 16),
            rule("NoSpaceBetweenEmptyInterfaceBraceBrackets", 18, 19, [isNonJsxSameLineTokenContext, isObjectTypeContext], 16),
            rule("NoSpaceBeforeOpenAngularBracket", typeNames, 29, [isNonJsxSameLineTokenContext, isTypeArgumentOrParameterOrAssertionContext], 16),
            rule("NoSpaceBetweenCloseParenAndAngularBracket", 21, 29, [isNonJsxSameLineTokenContext, isTypeArgumentOrParameterOrAssertionContext], 16),
            rule("NoSpaceAfterOpenAngularBracket", 29, anyToken, [isNonJsxSameLineTokenContext, isTypeArgumentOrParameterOrAssertionContext], 16),
            rule("NoSpaceBeforeCloseAngularBracket", anyToken, 31, [isNonJsxSameLineTokenContext, isTypeArgumentOrParameterOrAssertionContext], 16),
            rule("NoSpaceAfterCloseAngularBracket", 31, [20, 22, 31, 27], [isNonJsxSameLineTokenContext, isTypeArgumentOrParameterOrAssertionContext, isNotFunctionDeclContext], 16),
            rule("SpaceBeforeAt", [21, 75], 59, [isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceAfterAt", 59, anyToken, [isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterDecorator", anyToken, [
              122,
              75,
              89,
              84,
              80,
              120,
              119,
              117,
              118,
              131,
              142,
              22,
              41
            ], [isEndOfDecoratorContextOnSameLine], 4),
            rule("NoSpaceBeforeNonNullAssertionOperator", anyToken, 53, [isNonJsxSameLineTokenContext, isNonNullAssertionContext], 16),
            rule("NoSpaceAfterNewKeywordOnConstructorSignature", 99, 20, [isNonJsxSameLineTokenContext, isConstructorSignatureContext], 16),
            rule("SpaceLessThanAndNonJSXTypeAnnotation", 29, 29, [isNonJsxSameLineTokenContext], 4)
          ];
          var userConfigurableRules = [
            rule("SpaceAfterConstructor", 129, 20, [isOptionEnabled("insertSpaceAfterConstructor"), isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceAfterConstructor", 129, 20, [isOptionDisabledOrUndefined("insertSpaceAfterConstructor"), isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterComma", 27, anyToken, [isOptionEnabled("insertSpaceAfterCommaDelimiter"), isNonJsxSameLineTokenContext, isNonJsxElementOrFragmentContext, isNextTokenNotCloseBracket, isNextTokenNotCloseParen], 4),
            rule("NoSpaceAfterComma", 27, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterCommaDelimiter"), isNonJsxSameLineTokenContext, isNonJsxElementOrFragmentContext], 16),
            rule("SpaceAfterAnonymousFunctionKeyword", [94, 41], 20, [isOptionEnabled("insertSpaceAfterFunctionKeywordForAnonymousFunctions"), isFunctionDeclContext], 4),
            rule("NoSpaceAfterAnonymousFunctionKeyword", [94, 41], 20, [isOptionDisabledOrUndefined("insertSpaceAfterFunctionKeywordForAnonymousFunctions"), isFunctionDeclContext], 16),
            rule("SpaceAfterKeywordInControl", keywords, 20, [isOptionEnabled("insertSpaceAfterKeywordsInControlFlowStatements"), isControlDeclContext], 4),
            rule("NoSpaceAfterKeywordInControl", keywords, 20, [isOptionDisabledOrUndefined("insertSpaceAfterKeywordsInControlFlowStatements"), isControlDeclContext], 16),
            rule("SpaceAfterOpenParen", 20, anyToken, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), isNonJsxSameLineTokenContext], 4),
            rule("SpaceBeforeCloseParen", anyToken, 21, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), isNonJsxSameLineTokenContext], 4),
            rule("SpaceBetweenOpenParens", 20, 20, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceBetweenParens", 20, 21, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterOpenParen", 20, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeCloseParen", anyToken, 21, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterOpenBracket", 22, anyToken, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), isNonJsxSameLineTokenContext], 4),
            rule("SpaceBeforeCloseBracket", anyToken, 23, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceBetweenBrackets", 22, 23, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterOpenBracket", 22, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeCloseBracket", anyToken, 23, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterOpenBrace", 18, anyToken, [isOptionEnabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), isBraceWrappedContext], 4),
            rule("SpaceBeforeCloseBrace", anyToken, 19, [isOptionEnabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), isBraceWrappedContext], 4),
            rule("NoSpaceBetweenEmptyBraceBrackets", 18, 19, [isNonJsxSameLineTokenContext, isObjectContext], 16),
            rule("NoSpaceAfterOpenBrace", 18, anyToken, [isOptionDisabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeCloseBrace", anyToken, 19, [isOptionDisabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), isNonJsxSameLineTokenContext], 16),
            rule("SpaceBetweenEmptyBraceBrackets", 18, 19, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingEmptyBraces")], 4),
            rule("NoSpaceBetweenEmptyBraceBrackets", 18, 19, [isOptionDisabled("insertSpaceAfterOpeningAndBeforeClosingEmptyBraces"), isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterTemplateHeadAndMiddle", [15, 16], anyToken, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), isNonJsxSameLineTokenContext], 4),
            rule("SpaceBeforeTemplateMiddleAndTail", anyToken, [16, 17], [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), isNonJsxSameLineTokenContext], 4),
            rule("NoSpaceAfterTemplateHeadAndMiddle", [15, 16], anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeTemplateMiddleAndTail", anyToken, [16, 17], [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), isNonJsxSameLineTokenContext], 16),
            rule("SpaceAfterOpenBraceInJsxExpression", 18, anyToken, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), isNonJsxSameLineTokenContext, isJsxExpressionContext], 4),
            rule("SpaceBeforeCloseBraceInJsxExpression", anyToken, 19, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), isNonJsxSameLineTokenContext, isJsxExpressionContext], 4),
            rule("NoSpaceAfterOpenBraceInJsxExpression", 18, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), isNonJsxSameLineTokenContext, isJsxExpressionContext], 16),
            rule("NoSpaceBeforeCloseBraceInJsxExpression", anyToken, 19, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), isNonJsxSameLineTokenContext, isJsxExpressionContext], 16),
            rule("SpaceAfterSemicolonInFor", 26, anyToken, [isOptionEnabled("insertSpaceAfterSemicolonInForStatements"), isNonJsxSameLineTokenContext, isForContext], 4),
            rule("NoSpaceAfterSemicolonInFor", 26, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterSemicolonInForStatements"), isNonJsxSameLineTokenContext, isForContext], 16),
            rule("SpaceBeforeBinaryOperator", anyToken, binaryOperators, [isOptionEnabled("insertSpaceBeforeAndAfterBinaryOperators"), isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("SpaceAfterBinaryOperator", binaryOperators, anyToken, [isOptionEnabled("insertSpaceBeforeAndAfterBinaryOperators"), isNonJsxSameLineTokenContext, isBinaryOpContext], 4),
            rule("NoSpaceBeforeBinaryOperator", anyToken, binaryOperators, [isOptionDisabledOrUndefined("insertSpaceBeforeAndAfterBinaryOperators"), isNonJsxSameLineTokenContext, isBinaryOpContext], 16),
            rule("NoSpaceAfterBinaryOperator", binaryOperators, anyToken, [isOptionDisabledOrUndefined("insertSpaceBeforeAndAfterBinaryOperators"), isNonJsxSameLineTokenContext, isBinaryOpContext], 16),
            rule("SpaceBeforeOpenParenInFuncDecl", anyToken, 20, [isOptionEnabled("insertSpaceBeforeFunctionParenthesis"), isNonJsxSameLineTokenContext, isFunctionDeclContext], 4),
            rule("NoSpaceBeforeOpenParenInFuncDecl", anyToken, 20, [isOptionDisabledOrUndefined("insertSpaceBeforeFunctionParenthesis"), isNonJsxSameLineTokenContext, isFunctionDeclContext], 16),
            rule("NewLineBeforeOpenBraceInControl", controlOpenBraceLeftTokenRange, 18, [isOptionEnabled("placeOpenBraceOnNewLineForControlBlocks"), isControlDeclContext, isBeforeMultilineBlockContext], 8, 1),
            rule("NewLineBeforeOpenBraceInFunction", functionOpenBraceLeftTokenRange, 18, [isOptionEnabled("placeOpenBraceOnNewLineForFunctions"), isFunctionDeclContext, isBeforeMultilineBlockContext], 8, 1),
            rule("NewLineBeforeOpenBraceInTypeScriptDeclWithBlock", typeScriptOpenBraceLeftTokenRange, 18, [isOptionEnabled("placeOpenBraceOnNewLineForFunctions"), isTypeScriptDeclWithBlockContext, isBeforeMultilineBlockContext], 8, 1),
            rule("SpaceAfterTypeAssertion", 31, anyToken, [isOptionEnabled("insertSpaceAfterTypeAssertion"), isNonJsxSameLineTokenContext, isTypeAssertionContext], 4),
            rule("NoSpaceAfterTypeAssertion", 31, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterTypeAssertion"), isNonJsxSameLineTokenContext, isTypeAssertionContext], 16),
            rule("SpaceBeforeTypeAnnotation", anyToken, 58, [isOptionEnabled("insertSpaceBeforeTypeAnnotation"), isNonJsxSameLineTokenContext, isTypeAnnotationContext], 4),
            rule("NoSpaceBeforeTypeAnnotation", anyToken, 58, [isOptionDisabledOrUndefined("insertSpaceBeforeTypeAnnotation"), isNonJsxSameLineTokenContext, isTypeAnnotationContext], 16),
            rule("NoOptionalSemicolon", 26, anyTokenIncludingEOF, [optionEquals("semicolons", ts2.SemicolonPreference.Remove), isSemicolonDeletionContext], 32),
            rule("OptionalSemicolon", anyToken, anyTokenIncludingEOF, [optionEquals("semicolons", ts2.SemicolonPreference.Insert), isSemicolonInsertionContext], 64)
          ];
          var lowPriorityCommonRules = [
            rule("NoSpaceBeforeSemicolon", anyToken, 26, [isNonJsxSameLineTokenContext], 16),
            rule("SpaceBeforeOpenBraceInControl", controlOpenBraceLeftTokenRange, 18, [isOptionDisabledOrUndefinedOrTokensOnSameLine("placeOpenBraceOnNewLineForControlBlocks"), isControlDeclContext, isNotFormatOnEnter, isSameLineTokenOrBeforeBlockContext], 4, 1),
            rule("SpaceBeforeOpenBraceInFunction", functionOpenBraceLeftTokenRange, 18, [isOptionDisabledOrUndefinedOrTokensOnSameLine("placeOpenBraceOnNewLineForFunctions"), isFunctionDeclContext, isBeforeBlockContext, isNotFormatOnEnter, isSameLineTokenOrBeforeBlockContext], 4, 1),
            rule("SpaceBeforeOpenBraceInTypeScriptDeclWithBlock", typeScriptOpenBraceLeftTokenRange, 18, [isOptionDisabledOrUndefinedOrTokensOnSameLine("placeOpenBraceOnNewLineForFunctions"), isTypeScriptDeclWithBlockContext, isNotFormatOnEnter, isSameLineTokenOrBeforeBlockContext], 4, 1),
            rule("NoSpaceBeforeComma", anyToken, 27, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceBeforeOpenBracket", anyTokenExcept(126, 78), 22, [isNonJsxSameLineTokenContext], 16),
            rule("NoSpaceAfterCloseBracket", 23, anyToken, [isNonJsxSameLineTokenContext, isNotBeforeBlockInFunctionDeclarationContext], 16),
            rule("SpaceAfterSemicolon", 26, anyToken, [isNonJsxSameLineTokenContext], 4),
            rule("SpaceBetweenForAndAwaitKeyword", 93, 127, [isNonJsxSameLineTokenContext], 4),
            rule("SpaceBetweenStatements", [21, 86, 87, 78], anyToken, [isNonJsxSameLineTokenContext, isNonJsxElementOrFragmentContext, isNotForContext], 4),
            rule("SpaceAfterTryFinally", [107, 92], 18, [isNonJsxSameLineTokenContext], 4)
          ];
          return __spreadArrays(highPriorityCommonRules, userConfigurableRules, lowPriorityCommonRules);
        }
        formatting2.getAllRules = getAllRules;
        function rule(debugName, left, right, context, action, flags) {
          if (flags === void 0) {
            flags = 0;
          }
          return { leftTokenRange: toTokenRange(left), rightTokenRange: toTokenRange(right), rule: { debugName, context, action, flags } };
        }
        function tokenRangeFrom(tokens) {
          return { tokens, isSpecific: true };
        }
        function toTokenRange(arg) {
          return typeof arg === "number" ? tokenRangeFrom([arg]) : ts2.isArray(arg) ? tokenRangeFrom(arg) : arg;
        }
        function tokenRangeFromRange(from, to, except) {
          if (except === void 0) {
            except = [];
          }
          var tokens = [];
          for (var token = from; token <= to; token++) {
            if (!ts2.contains(except, token)) {
              tokens.push(token);
            }
          }
          return tokenRangeFrom(tokens);
        }
        function optionEquals(optionName, optionValue) {
          return function(context) {
            return context.options && context.options[optionName] === optionValue;
          };
        }
        function isOptionEnabled(optionName) {
          return function(context) {
            return context.options && context.options.hasOwnProperty(optionName) && !!context.options[optionName];
          };
        }
        function isOptionDisabled(optionName) {
          return function(context) {
            return context.options && context.options.hasOwnProperty(optionName) && !context.options[optionName];
          };
        }
        function isOptionDisabledOrUndefined(optionName) {
          return function(context) {
            return !context.options || !context.options.hasOwnProperty(optionName) || !context.options[optionName];
          };
        }
        function isOptionDisabledOrUndefinedOrTokensOnSameLine(optionName) {
          return function(context) {
            return !context.options || !context.options.hasOwnProperty(optionName) || !context.options[optionName] || context.TokensAreOnSameLine();
          };
        }
        function isOptionEnabledOrUndefined(optionName) {
          return function(context) {
            return !context.options || !context.options.hasOwnProperty(optionName) || !!context.options[optionName];
          };
        }
        function isForContext(context) {
          return context.contextNode.kind === 230;
        }
        function isNotForContext(context) {
          return !isForContext(context);
        }
        function isBinaryOpContext(context) {
          switch (context.contextNode.kind) {
            case 209:
              return context.contextNode.operatorToken.kind !== 27;
            case 210:
            case 180:
            case 217:
            case 263:
            case 258:
            case 168:
            case 178:
            case 179:
              return true;
            case 191:
            case 247:
            case 253:
            case 242:
            case 156:
            case 284:
            case 159:
            case 158:
              return context.currentTokenSpan.kind === 62 || context.nextTokenSpan.kind === 62;
            case 231:
            case 155:
              return context.currentTokenSpan.kind === 97 || context.nextTokenSpan.kind === 97 || context.currentTokenSpan.kind === 62 || context.nextTokenSpan.kind === 62;
            case 232:
              return context.currentTokenSpan.kind === 152 || context.nextTokenSpan.kind === 152;
          }
          return false;
        }
        function isNotBinaryOpContext(context) {
          return !isBinaryOpContext(context);
        }
        function isNotTypeAnnotationContext(context) {
          return !isTypeAnnotationContext(context);
        }
        function isTypeAnnotationContext(context) {
          var contextKind = context.contextNode.kind;
          return contextKind === 159 || contextKind === 158 || contextKind === 156 || contextKind === 242 || ts2.isFunctionLikeKind(contextKind);
        }
        function isConditionalOperatorContext(context) {
          return context.contextNode.kind === 210 || context.contextNode.kind === 180;
        }
        function isSameLineTokenOrBeforeBlockContext(context) {
          return context.TokensAreOnSameLine() || isBeforeBlockContext(context);
        }
        function isBraceWrappedContext(context) {
          return context.contextNode.kind === 189 || context.contextNode.kind === 186 || isSingleLineBlockContext(context);
        }
        function isBeforeMultilineBlockContext(context) {
          return isBeforeBlockContext(context) && !(context.NextNodeAllOnSameLine() || context.NextNodeBlockIsOnOneLine());
        }
        function isMultilineBlockContext(context) {
          return isBlockContext(context) && !(context.ContextNodeAllOnSameLine() || context.ContextNodeBlockIsOnOneLine());
        }
        function isSingleLineBlockContext(context) {
          return isBlockContext(context) && (context.ContextNodeAllOnSameLine() || context.ContextNodeBlockIsOnOneLine());
        }
        function isBlockContext(context) {
          return nodeIsBlockContext(context.contextNode);
        }
        function isBeforeBlockContext(context) {
          return nodeIsBlockContext(context.nextTokenParent);
        }
        function nodeIsBlockContext(node) {
          if (nodeIsTypeScriptDeclWithBlockContext(node)) {
            return true;
          }
          switch (node.kind) {
            case 223:
            case 251:
            case 193:
            case 250:
              return true;
          }
          return false;
        }
        function isFunctionDeclContext(context) {
          switch (context.contextNode.kind) {
            case 244:
            case 161:
            case 160:
            case 163:
            case 164:
            case 165:
            case 201:
            case 162:
            case 202:
            case 246:
              return true;
          }
          return false;
        }
        function isNotFunctionDeclContext(context) {
          return !isFunctionDeclContext(context);
        }
        function isFunctionDeclarationOrFunctionExpressionContext(context) {
          return context.contextNode.kind === 244 || context.contextNode.kind === 201;
        }
        function isTypeScriptDeclWithBlockContext(context) {
          return nodeIsTypeScriptDeclWithBlockContext(context.contextNode);
        }
        function nodeIsTypeScriptDeclWithBlockContext(node) {
          switch (node.kind) {
            case 245:
            case 214:
            case 246:
            case 248:
            case 173:
            case 249:
            case 260:
            case 261:
            case 254:
            case 257:
              return true;
          }
          return false;
        }
        function isAfterCodeBlockContext(context) {
          switch (context.currentTokenParent.kind) {
            case 245:
            case 249:
            case 248:
            case 280:
            case 250:
            case 237:
              return true;
            case 223: {
              var blockParent = context.currentTokenParent.parent;
              if (!blockParent || blockParent.kind !== 202 && blockParent.kind !== 201) {
                return true;
              }
            }
          }
          return false;
        }
        function isControlDeclContext(context) {
          switch (context.contextNode.kind) {
            case 227:
            case 237:
            case 230:
            case 231:
            case 232:
            case 229:
            case 240:
            case 228:
            case 236:
            case 280:
              return true;
            default:
              return false;
          }
        }
        function isObjectContext(context) {
          return context.contextNode.kind === 193;
        }
        function isFunctionCallContext(context) {
          return context.contextNode.kind === 196;
        }
        function isNewContext(context) {
          return context.contextNode.kind === 197;
        }
        function isFunctionCallOrNewContext(context) {
          return isFunctionCallContext(context) || isNewContext(context);
        }
        function isPreviousTokenNotComma(context) {
          return context.currentTokenSpan.kind !== 27;
        }
        function isNextTokenNotCloseBracket(context) {
          return context.nextTokenSpan.kind !== 23;
        }
        function isNextTokenNotCloseParen(context) {
          return context.nextTokenSpan.kind !== 21;
        }
        function isArrowFunctionContext(context) {
          return context.contextNode.kind === 202;
        }
        function isImportTypeContext(context) {
          return context.contextNode.kind === 188;
        }
        function isNonJsxSameLineTokenContext(context) {
          return context.TokensAreOnSameLine() && context.contextNode.kind !== 11;
        }
        function isNonJsxElementOrFragmentContext(context) {
          return context.contextNode.kind !== 266 && context.contextNode.kind !== 270;
        }
        function isJsxExpressionContext(context) {
          return context.contextNode.kind === 276 || context.contextNode.kind === 275;
        }
        function isNextTokenParentJsxAttribute(context) {
          return context.nextTokenParent.kind === 273;
        }
        function isJsxAttributeContext(context) {
          return context.contextNode.kind === 273;
        }
        function isJsxSelfClosingElementContext(context) {
          return context.contextNode.kind === 267;
        }
        function isNotBeforeBlockInFunctionDeclarationContext(context) {
          return !isFunctionDeclContext(context) && !isBeforeBlockContext(context);
        }
        function isEndOfDecoratorContextOnSameLine(context) {
          return context.TokensAreOnSameLine() && !!context.contextNode.decorators && nodeIsInDecoratorContext(context.currentTokenParent) && !nodeIsInDecoratorContext(context.nextTokenParent);
        }
        function nodeIsInDecoratorContext(node) {
          while (ts2.isExpressionNode(node)) {
            node = node.parent;
          }
          return node.kind === 157;
        }
        function isStartOfVariableDeclarationList(context) {
          return context.currentTokenParent.kind === 243 && context.currentTokenParent.getStart(context.sourceFile) === context.currentTokenSpan.pos;
        }
        function isNotFormatOnEnter(context) {
          return context.formattingRequestKind !== 2;
        }
        function isModuleDeclContext(context) {
          return context.contextNode.kind === 249;
        }
        function isObjectTypeContext(context) {
          return context.contextNode.kind === 173;
        }
        function isConstructorSignatureContext(context) {
          return context.contextNode.kind === 166;
        }
        function isTypeArgumentOrParameterOrAssertion(token, parent) {
          if (token.kind !== 29 && token.kind !== 31) {
            return false;
          }
          switch (parent.kind) {
            case 169:
            case 199:
            case 247:
            case 245:
            case 214:
            case 246:
            case 244:
            case 201:
            case 202:
            case 161:
            case 160:
            case 165:
            case 166:
            case 196:
            case 197:
            case 216:
              return true;
            default:
              return false;
          }
        }
        function isTypeArgumentOrParameterOrAssertionContext(context) {
          return isTypeArgumentOrParameterOrAssertion(context.currentTokenSpan, context.currentTokenParent) || isTypeArgumentOrParameterOrAssertion(context.nextTokenSpan, context.nextTokenParent);
        }
        function isTypeAssertionContext(context) {
          return context.contextNode.kind === 199;
        }
        function isVoidOpContext(context) {
          return context.currentTokenSpan.kind === 110 && context.currentTokenParent.kind === 205;
        }
        function isYieldOrYieldStarWithOperand(context) {
          return context.contextNode.kind === 212 && context.contextNode.expression !== void 0;
        }
        function isNonNullAssertionContext(context) {
          return context.contextNode.kind === 218;
        }
        function isNotStatementConditionContext(context) {
          return !isStatementConditionContext(context);
        }
        function isStatementConditionContext(context) {
          switch (context.contextNode.kind) {
            case 227:
            case 230:
            case 231:
            case 232:
            case 228:
            case 229:
              return true;
            default:
              return false;
          }
        }
        function isSemicolonDeletionContext(context) {
          var nextTokenKind = context.nextTokenSpan.kind;
          var nextTokenStart = context.nextTokenSpan.pos;
          if (ts2.isTrivia(nextTokenKind)) {
            var nextRealToken = context.nextTokenParent === context.currentTokenParent ? ts2.findNextToken(context.currentTokenParent, ts2.findAncestor(context.currentTokenParent, function(a) {
              return !a.parent;
            }), context.sourceFile) : context.nextTokenParent.getFirstToken(context.sourceFile);
            if (!nextRealToken) {
              return true;
            }
            nextTokenKind = nextRealToken.kind;
            nextTokenStart = nextRealToken.getStart(context.sourceFile);
          }
          var startLine = context.sourceFile.getLineAndCharacterOfPosition(context.currentTokenSpan.pos).line;
          var endLine = context.sourceFile.getLineAndCharacterOfPosition(nextTokenStart).line;
          if (startLine === endLine) {
            return nextTokenKind === 19 || nextTokenKind === 1;
          }
          if (nextTokenKind === 222 || nextTokenKind === 26) {
            return false;
          }
          if (context.contextNode.kind === 246 || context.contextNode.kind === 247) {
            return !ts2.isPropertySignature(context.currentTokenParent) || !!context.currentTokenParent.type || nextTokenKind !== 20;
          }
          if (ts2.isPropertyDeclaration(context.currentTokenParent)) {
            return !context.currentTokenParent.initializer;
          }
          return context.currentTokenParent.kind !== 230 && context.currentTokenParent.kind !== 224 && context.currentTokenParent.kind !== 222 && nextTokenKind !== 22 && nextTokenKind !== 20 && nextTokenKind !== 39 && nextTokenKind !== 40 && nextTokenKind !== 43 && nextTokenKind !== 13 && nextTokenKind !== 27 && nextTokenKind !== 211 && nextTokenKind !== 15 && nextTokenKind !== 14 && nextTokenKind !== 24;
        }
        function isSemicolonInsertionContext(context) {
          return ts2.positionIsASICandidate(context.currentTokenSpan.end, context.currentTokenParent, context.sourceFile);
        }
      })(formatting = ts2.formatting || (ts2.formatting = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var formatting;
      (function(formatting2) {
        function getFormatContext(options, host) {
          return { options, getRules: getRulesMap(), host };
        }
        formatting2.getFormatContext = getFormatContext;
        var rulesMapCache;
        function getRulesMap() {
          if (rulesMapCache === void 0) {
            rulesMapCache = createRulesMap(formatting2.getAllRules());
          }
          return rulesMapCache;
        }
        function getRuleActionExclusion(ruleAction) {
          var mask2 = 0;
          if (ruleAction & 1) {
            mask2 |= 28;
          }
          if (ruleAction & 2) {
            mask2 |= 96;
          }
          if (ruleAction & 28) {
            mask2 |= 28;
          }
          if (ruleAction & 96) {
            mask2 |= 96;
          }
          return mask2;
        }
        function createRulesMap(rules) {
          var map = buildMap(rules);
          return function(context) {
            var bucket = map[getRuleBucketIndex(context.currentTokenSpan.kind, context.nextTokenSpan.kind)];
            if (bucket) {
              var rules_1 = [];
              var ruleActionMask = 0;
              for (var _i = 0, bucket_1 = bucket; _i < bucket_1.length; _i++) {
                var rule = bucket_1[_i];
                var acceptRuleActions = ~getRuleActionExclusion(ruleActionMask);
                if (rule.action & acceptRuleActions && ts2.every(rule.context, function(c) {
                  return c(context);
                })) {
                  rules_1.push(rule);
                  ruleActionMask |= rule.action;
                }
              }
              if (rules_1.length) {
                return rules_1;
              }
            }
          };
        }
        function buildMap(rules) {
          var map = new Array(mapRowLength * mapRowLength);
          var rulesBucketConstructionStateList = new Array(map.length);
          for (var _i = 0, rules_2 = rules; _i < rules_2.length; _i++) {
            var rule = rules_2[_i];
            var specificRule = rule.leftTokenRange.isSpecific && rule.rightTokenRange.isSpecific;
            for (var _a = 0, _b = rule.leftTokenRange.tokens; _a < _b.length; _a++) {
              var left = _b[_a];
              for (var _c = 0, _d = rule.rightTokenRange.tokens; _c < _d.length; _c++) {
                var right = _d[_c];
                var index = getRuleBucketIndex(left, right);
                var rulesBucket = map[index];
                if (rulesBucket === void 0) {
                  rulesBucket = map[index] = [];
                }
                addRule(rulesBucket, rule.rule, specificRule, rulesBucketConstructionStateList, index);
              }
            }
          }
          return map;
        }
        function getRuleBucketIndex(row, column) {
          ts2.Debug.assert(row <= 152 && column <= 152, "Must compute formatting context from tokens");
          return row * mapRowLength + column;
        }
        var maskBitSize = 5;
        var mask = 31;
        var mapRowLength = 152 + 1;
        var RulesPosition;
        (function(RulesPosition2) {
          RulesPosition2[RulesPosition2["StopRulesSpecific"] = 0] = "StopRulesSpecific";
          RulesPosition2[RulesPosition2["StopRulesAny"] = maskBitSize * 1] = "StopRulesAny";
          RulesPosition2[RulesPosition2["ContextRulesSpecific"] = maskBitSize * 2] = "ContextRulesSpecific";
          RulesPosition2[RulesPosition2["ContextRulesAny"] = maskBitSize * 3] = "ContextRulesAny";
          RulesPosition2[RulesPosition2["NoContextRulesSpecific"] = maskBitSize * 4] = "NoContextRulesSpecific";
          RulesPosition2[RulesPosition2["NoContextRulesAny"] = maskBitSize * 5] = "NoContextRulesAny";
        })(RulesPosition || (RulesPosition = {}));
        function addRule(rules, rule, specificTokens, constructionState, rulesBucketIndex) {
          var position = rule.action & 3 ? specificTokens ? RulesPosition.StopRulesSpecific : RulesPosition.StopRulesAny : rule.context !== formatting2.anyContext ? specificTokens ? RulesPosition.ContextRulesSpecific : RulesPosition.ContextRulesAny : specificTokens ? RulesPosition.NoContextRulesSpecific : RulesPosition.NoContextRulesAny;
          var state = constructionState[rulesBucketIndex] || 0;
          rules.splice(getInsertionIndex(state, position), 0, rule);
          constructionState[rulesBucketIndex] = increaseInsertionIndex(state, position);
        }
        function getInsertionIndex(indexBitmap, maskPosition) {
          var index = 0;
          for (var pos = 0; pos <= maskPosition; pos += maskBitSize) {
            index += indexBitmap & mask;
            indexBitmap >>= maskBitSize;
          }
          return index;
        }
        function increaseInsertionIndex(indexBitmap, maskPosition) {
          var value = (indexBitmap >> maskPosition & mask) + 1;
          ts2.Debug.assert((value & mask) === value, "Adding more rules into the sub-bucket than allowed. Maximum allowed is 32 rules.");
          return indexBitmap & ~(mask << maskPosition) | value << maskPosition;
        }
      })(formatting = ts2.formatting || (ts2.formatting = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var formatting;
      (function(formatting2) {
        function createTextRangeWithKind(pos, end, kind) {
          var textRangeWithKind = { pos, end, kind };
          if (ts2.Debug.isDebugging) {
            Object.defineProperty(textRangeWithKind, "__debugKind", {
              get: function() {
                return ts2.Debug.formatSyntaxKind(kind);
              }
            });
          }
          return textRangeWithKind;
        }
        formatting2.createTextRangeWithKind = createTextRangeWithKind;
        var Constants;
        (function(Constants2) {
          Constants2[Constants2["Unknown"] = -1] = "Unknown";
        })(Constants || (Constants = {}));
        function formatOnEnter(position, sourceFile, formatContext) {
          var line = sourceFile.getLineAndCharacterOfPosition(position).line;
          if (line === 0) {
            return [];
          }
          var endOfFormatSpan = ts2.getEndLinePosition(line, sourceFile);
          while (ts2.isWhiteSpaceSingleLine(sourceFile.text.charCodeAt(endOfFormatSpan))) {
            endOfFormatSpan--;
          }
          if (ts2.isLineBreak(sourceFile.text.charCodeAt(endOfFormatSpan))) {
            endOfFormatSpan--;
          }
          var span = {
            pos: ts2.getStartPositionOfLine(line - 1, sourceFile),
            end: endOfFormatSpan + 1
          };
          return formatSpan(span, sourceFile, formatContext, 2);
        }
        formatting2.formatOnEnter = formatOnEnter;
        function formatOnSemicolon(position, sourceFile, formatContext) {
          var semicolon = findImmediatelyPrecedingTokenOfKind(position, 26, sourceFile);
          return formatNodeLines(findOutermostNodeWithinListLevel(semicolon), sourceFile, formatContext, 3);
        }
        formatting2.formatOnSemicolon = formatOnSemicolon;
        function formatOnOpeningCurly(position, sourceFile, formatContext) {
          var openingCurly = findImmediatelyPrecedingTokenOfKind(position, 18, sourceFile);
          if (!openingCurly) {
            return [];
          }
          var curlyBraceRange = openingCurly.parent;
          var outermostNode = findOutermostNodeWithinListLevel(curlyBraceRange);
          var textRange = {
            pos: ts2.getLineStartPositionForPosition(outermostNode.getStart(sourceFile), sourceFile),
            end: position
          };
          return formatSpan(textRange, sourceFile, formatContext, 4);
        }
        formatting2.formatOnOpeningCurly = formatOnOpeningCurly;
        function formatOnClosingCurly(position, sourceFile, formatContext) {
          var precedingToken = findImmediatelyPrecedingTokenOfKind(position, 19, sourceFile);
          return formatNodeLines(findOutermostNodeWithinListLevel(precedingToken), sourceFile, formatContext, 5);
        }
        formatting2.formatOnClosingCurly = formatOnClosingCurly;
        function formatDocument(sourceFile, formatContext) {
          var span = {
            pos: 0,
            end: sourceFile.text.length
          };
          return formatSpan(span, sourceFile, formatContext, 0);
        }
        formatting2.formatDocument = formatDocument;
        function formatSelection(start, end, sourceFile, formatContext) {
          var span = {
            pos: ts2.getLineStartPositionForPosition(start, sourceFile),
            end
          };
          return formatSpan(span, sourceFile, formatContext, 1);
        }
        formatting2.formatSelection = formatSelection;
        function findImmediatelyPrecedingTokenOfKind(end, expectedTokenKind, sourceFile) {
          var precedingToken = ts2.findPrecedingToken(end, sourceFile);
          return precedingToken && precedingToken.kind === expectedTokenKind && end === precedingToken.getEnd() ? precedingToken : void 0;
        }
        function findOutermostNodeWithinListLevel(node) {
          var current = node;
          while (current && current.parent && current.parent.end === node.end && !isListElement(current.parent, current)) {
            current = current.parent;
          }
          return current;
        }
        function isListElement(parent, node) {
          switch (parent.kind) {
            case 245:
            case 246:
              return ts2.rangeContainsRange(parent.members, node);
            case 249:
              var body = parent.body;
              return !!body && body.kind === 250 && ts2.rangeContainsRange(body.statements, node);
            case 290:
            case 223:
            case 250:
              return ts2.rangeContainsRange(parent.statements, node);
            case 280:
              return ts2.rangeContainsRange(parent.block.statements, node);
          }
          return false;
        }
        function findEnclosingNode(range, sourceFile) {
          return find(sourceFile);
          function find(n) {
            var candidate = ts2.forEachChild(n, function(c) {
              return ts2.startEndContainsRange(c.getStart(sourceFile), c.end, range) && c;
            });
            if (candidate) {
              var result = find(candidate);
              if (result) {
                return result;
              }
            }
            return n;
          }
        }
        function prepareRangeContainsErrorFunction(errors, originalRange) {
          if (!errors.length) {
            return rangeHasNoErrors;
          }
          var sorted = errors.filter(function(d) {
            return ts2.rangeOverlapsWithStartEnd(originalRange, d.start, d.start + d.length);
          }).sort(function(e1, e2) {
            return e1.start - e2.start;
          });
          if (!sorted.length) {
            return rangeHasNoErrors;
          }
          var index = 0;
          return function(r) {
            while (true) {
              if (index >= sorted.length) {
                return false;
              }
              var error = sorted[index];
              if (r.end <= error.start) {
                return false;
              }
              if (ts2.startEndOverlapsWithStartEnd(r.pos, r.end, error.start, error.start + error.length)) {
                return true;
              }
              index++;
            }
          };
          function rangeHasNoErrors() {
            return false;
          }
        }
        function getScanStartPosition(enclosingNode, originalRange, sourceFile) {
          var start = enclosingNode.getStart(sourceFile);
          if (start === originalRange.pos && enclosingNode.end === originalRange.end) {
            return start;
          }
          var precedingToken = ts2.findPrecedingToken(originalRange.pos, sourceFile);
          if (!precedingToken) {
            return enclosingNode.pos;
          }
          if (precedingToken.end >= originalRange.pos) {
            return enclosingNode.pos;
          }
          return precedingToken.end;
        }
        function getOwnOrInheritedDelta(n, options, sourceFile) {
          var previousLine = -1;
          var child;
          while (n) {
            var line = sourceFile.getLineAndCharacterOfPosition(n.getStart(sourceFile)).line;
            if (previousLine !== -1 && line !== previousLine) {
              break;
            }
            if (formatting2.SmartIndenter.shouldIndentChildNode(options, n, child, sourceFile)) {
              return options.indentSize;
            }
            previousLine = line;
            child = n;
            n = n.parent;
          }
          return 0;
        }
        function formatNodeGivenIndentation(node, sourceFileLike, languageVariant, initialIndentation, delta, formatContext) {
          var range = { pos: 0, end: sourceFileLike.text.length };
          return formatting2.getFormattingScanner(sourceFileLike.text, languageVariant, range.pos, range.end, function(scanner) {
            return formatSpanWorker(range, node, initialIndentation, delta, scanner, formatContext, 1, function(_) {
              return false;
            }, sourceFileLike);
          });
        }
        formatting2.formatNodeGivenIndentation = formatNodeGivenIndentation;
        function formatNodeLines(node, sourceFile, formatContext, requestKind) {
          if (!node) {
            return [];
          }
          var span = {
            pos: ts2.getLineStartPositionForPosition(node.getStart(sourceFile), sourceFile),
            end: node.end
          };
          return formatSpan(span, sourceFile, formatContext, requestKind);
        }
        function formatSpan(originalRange, sourceFile, formatContext, requestKind) {
          var enclosingNode = findEnclosingNode(originalRange, sourceFile);
          return formatting2.getFormattingScanner(sourceFile.text, sourceFile.languageVariant, getScanStartPosition(enclosingNode, originalRange, sourceFile), originalRange.end, function(scanner) {
            return formatSpanWorker(originalRange, enclosingNode, formatting2.SmartIndenter.getIndentationForNode(enclosingNode, originalRange, sourceFile, formatContext.options), getOwnOrInheritedDelta(enclosingNode, formatContext.options, sourceFile), scanner, formatContext, requestKind, prepareRangeContainsErrorFunction(sourceFile.parseDiagnostics, originalRange), sourceFile);
          });
        }
        function formatSpanWorker(originalRange, enclosingNode, initialIndentation, delta, formattingScanner, _a, requestKind, rangeContainsError, sourceFile) {
          var options = _a.options, getRules = _a.getRules, host = _a.host;
          var formattingContext = new formatting2.FormattingContext(sourceFile, requestKind, options);
          var previousRange;
          var previousParent;
          var previousRangeStartLine;
          var lastIndentedLine;
          var indentationOnLastIndentedLine = -1;
          var edits = [];
          formattingScanner.advance();
          if (formattingScanner.isOnToken()) {
            var startLine = sourceFile.getLineAndCharacterOfPosition(enclosingNode.getStart(sourceFile)).line;
            var undecoratedStartLine = startLine;
            if (enclosingNode.decorators) {
              undecoratedStartLine = sourceFile.getLineAndCharacterOfPosition(ts2.getNonDecoratorTokenPosOfNode(enclosingNode, sourceFile)).line;
            }
            processNode(enclosingNode, enclosingNode, startLine, undecoratedStartLine, initialIndentation, delta);
          }
          if (!formattingScanner.isOnToken()) {
            var leadingTrivia = formattingScanner.getCurrentLeadingTrivia();
            if (leadingTrivia) {
              indentTriviaItems(leadingTrivia, initialIndentation, false, function(item) {
                return processRange(item, sourceFile.getLineAndCharacterOfPosition(item.pos), enclosingNode, enclosingNode, void 0);
              });
              if (options.trimTrailingWhitespace !== false) {
                trimTrailingWhitespacesForRemainingRange();
              }
            }
          }
          return edits;
          function tryComputeIndentationForListItem(startPos, endPos, parentStartLine, range, inheritedIndentation) {
            if (ts2.rangeOverlapsWithStartEnd(range, startPos, endPos) || ts2.rangeContainsStartEnd(range, startPos, endPos)) {
              if (inheritedIndentation !== -1) {
                return inheritedIndentation;
              }
            } else {
              var startLine2 = sourceFile.getLineAndCharacterOfPosition(startPos).line;
              var startLinePosition = ts2.getLineStartPositionForPosition(startPos, sourceFile);
              var column = formatting2.SmartIndenter.findFirstNonWhitespaceColumn(startLinePosition, startPos, sourceFile, options);
              if (startLine2 !== parentStartLine || startPos === column) {
                var baseIndentSize = formatting2.SmartIndenter.getBaseIndentation(options);
                return baseIndentSize > column ? baseIndentSize : column;
              }
            }
            return -1;
          }
          function computeIndentation(node, startLine2, inheritedIndentation, parent, parentDynamicIndentation, effectiveParentStartLine) {
            var delta2 = formatting2.SmartIndenter.shouldIndentChildNode(options, node) ? options.indentSize : 0;
            if (effectiveParentStartLine === startLine2) {
              return {
                indentation: startLine2 === lastIndentedLine ? indentationOnLastIndentedLine : parentDynamicIndentation.getIndentation(),
                delta: Math.min(options.indentSize, parentDynamicIndentation.getDelta(node) + delta2)
              };
            } else if (inheritedIndentation === -1) {
              if (node.kind === 20 && startLine2 === lastIndentedLine) {
                return { indentation: indentationOnLastIndentedLine, delta: parentDynamicIndentation.getDelta(node) };
              } else if (formatting2.SmartIndenter.childStartsOnTheSameLineWithElseInIfStatement(parent, node, startLine2, sourceFile)) {
                return { indentation: parentDynamicIndentation.getIndentation(), delta: delta2 };
              } else if (formatting2.SmartIndenter.argumentStartsOnSameLineAsPreviousArgument(parent, node, startLine2, sourceFile)) {
                return { indentation: parentDynamicIndentation.getIndentation(), delta: delta2 };
              } else {
                return { indentation: parentDynamicIndentation.getIndentation() + parentDynamicIndentation.getDelta(node), delta: delta2 };
              }
            } else {
              return { indentation: inheritedIndentation, delta: delta2 };
            }
          }
          function getFirstNonDecoratorTokenOfNode(node) {
            if (node.modifiers && node.modifiers.length) {
              return node.modifiers[0].kind;
            }
            switch (node.kind) {
              case 245:
                return 80;
              case 246:
                return 114;
              case 244:
                return 94;
              case 248:
                return 248;
              case 163:
                return 131;
              case 164:
                return 142;
              case 161:
                if (node.asteriskToken) {
                  return 41;
                }
              case 159:
              case 156:
                var name = ts2.getNameOfDeclaration(node);
                if (name) {
                  return name.kind;
                }
            }
          }
          function getDynamicIndentation(node, nodeStartLine, indentation, delta2) {
            return {
              getIndentationForComment: function(kind, tokenIndentation, container) {
                switch (kind) {
                  case 19:
                  case 23:
                  case 21:
                    return indentation + getDelta(container);
                }
                return tokenIndentation !== -1 ? tokenIndentation : indentation;
              },
              getIndentationForToken: function(line, kind, container, suppressDelta) {
                return !suppressDelta && shouldAddDelta(line, kind, container) ? indentation + getDelta(container) : indentation;
              },
              getIndentation: function() {
                return indentation;
              },
              getDelta,
              recomputeIndentation: function(lineAdded, parent) {
                if (formatting2.SmartIndenter.shouldIndentChildNode(options, parent, node, sourceFile)) {
                  indentation += lineAdded ? options.indentSize : -options.indentSize;
                  delta2 = formatting2.SmartIndenter.shouldIndentChildNode(options, node) ? options.indentSize : 0;
                }
              }
            };
            function shouldAddDelta(line, kind, container) {
              switch (kind) {
                case 18:
                case 19:
                case 21:
                case 87:
                case 111:
                case 59:
                  return false;
                case 43:
                case 31:
                  switch (container.kind) {
                    case 268:
                    case 269:
                    case 267:
                      return false;
                  }
                  break;
                case 22:
                case 23:
                  if (container.kind !== 186) {
                    return false;
                  }
                  break;
              }
              return nodeStartLine !== line && !(node.decorators && kind === getFirstNonDecoratorTokenOfNode(node));
            }
            function getDelta(child) {
              return formatting2.SmartIndenter.nodeWillIndentChild(options, node, child, sourceFile, true) ? delta2 : 0;
            }
          }
          function processNode(node, contextNode, nodeStartLine, undecoratedNodeStartLine, indentation, delta2) {
            if (!ts2.rangeOverlapsWithStartEnd(originalRange, node.getStart(sourceFile), node.getEnd())) {
              return;
            }
            var nodeDynamicIndentation = getDynamicIndentation(node, nodeStartLine, indentation, delta2);
            var childContextNode = contextNode;
            ts2.forEachChild(node, function(child) {
              processChildNode(child, -1, node, nodeDynamicIndentation, nodeStartLine, undecoratedNodeStartLine, false);
            }, function(nodes) {
              processChildNodes(nodes, node, nodeStartLine, nodeDynamicIndentation);
            });
            while (formattingScanner.isOnToken()) {
              var tokenInfo = formattingScanner.readTokenInfo(node);
              if (tokenInfo.token.end > node.end) {
                break;
              }
              if (node.kind === 11) {
                formattingScanner.advance();
                continue;
              }
              consumeTokenAndAdvanceScanner(tokenInfo, node, nodeDynamicIndentation, node);
            }
            if (!node.parent && formattingScanner.isOnEOF()) {
              var token = formattingScanner.readEOFTokenRange();
              if (token.end <= node.end && previousRange) {
                processPair(token, sourceFile.getLineAndCharacterOfPosition(token.pos).line, node, previousRange, previousRangeStartLine, previousParent, contextNode, nodeDynamicIndentation);
              }
            }
            function processChildNode(child, inheritedIndentation, parent, parentDynamicIndentation, parentStartLine, undecoratedParentStartLine, isListItem, isFirstListItem) {
              var childStartPos = child.getStart(sourceFile);
              var childStartLine = sourceFile.getLineAndCharacterOfPosition(childStartPos).line;
              var undecoratedChildStartLine = childStartLine;
              if (child.decorators) {
                undecoratedChildStartLine = sourceFile.getLineAndCharacterOfPosition(ts2.getNonDecoratorTokenPosOfNode(child, sourceFile)).line;
              }
              var childIndentationAmount = -1;
              if (isListItem && ts2.rangeContainsRange(originalRange, parent)) {
                childIndentationAmount = tryComputeIndentationForListItem(childStartPos, child.end, parentStartLine, originalRange, inheritedIndentation);
                if (childIndentationAmount !== -1) {
                  inheritedIndentation = childIndentationAmount;
                }
              }
              if (!ts2.rangeOverlapsWithStartEnd(originalRange, child.pos, child.end)) {
                if (child.end < originalRange.pos) {
                  formattingScanner.skipToEndOf(child);
                }
                return inheritedIndentation;
              }
              if (child.getFullWidth() === 0) {
                return inheritedIndentation;
              }
              while (formattingScanner.isOnToken()) {
                var tokenInfo2 = formattingScanner.readTokenInfo(node);
                if (tokenInfo2.token.end > childStartPos) {
                  break;
                }
                consumeTokenAndAdvanceScanner(tokenInfo2, node, parentDynamicIndentation, node);
              }
              if (!formattingScanner.isOnToken()) {
                return inheritedIndentation;
              }
              if (ts2.isToken(child) && child.kind !== 11) {
                var tokenInfo2 = formattingScanner.readTokenInfo(child);
                ts2.Debug.assert(tokenInfo2.token.end === child.end, "Token end is child end");
                consumeTokenAndAdvanceScanner(tokenInfo2, node, parentDynamicIndentation, child);
                return inheritedIndentation;
              }
              var effectiveParentStartLine = child.kind === 157 ? childStartLine : undecoratedParentStartLine;
              var childIndentation = computeIndentation(child, childStartLine, childIndentationAmount, node, parentDynamicIndentation, effectiveParentStartLine);
              processNode(child, childContextNode, childStartLine, undecoratedChildStartLine, childIndentation.indentation, childIndentation.delta);
              if (child.kind === 11) {
                var range = { pos: child.getStart(), end: child.getEnd() };
                if (range.pos !== range.end) {
                  var siblings = parent.getChildren(sourceFile);
                  var currentIndex = ts2.findIndex(siblings, function(arg) {
                    return arg.pos === child.pos;
                  });
                  var previousNode = siblings[currentIndex - 1];
                  if (previousNode) {
                    if (sourceFile.getLineAndCharacterOfPosition(range.end).line !== sourceFile.getLineAndCharacterOfPosition(previousNode.end).line) {
                      var firstLineIsIndented = sourceFile.getLineAndCharacterOfPosition(range.pos).line === sourceFile.getLineAndCharacterOfPosition(previousNode.end).line;
                      indentMultilineCommentOrJsxText(range, childIndentation.indentation, firstLineIsIndented, false, true);
                    }
                  }
                }
              }
              childContextNode = node;
              if (isFirstListItem && parent.kind === 192 && inheritedIndentation === -1) {
                inheritedIndentation = childIndentation.indentation;
              }
              return inheritedIndentation;
            }
            function processChildNodes(nodes, parent, parentStartLine, parentDynamicIndentation) {
              ts2.Debug.assert(ts2.isNodeArray(nodes));
              var listStartToken = getOpenTokenForList(parent, nodes);
              var listDynamicIndentation = parentDynamicIndentation;
              var startLine2 = parentStartLine;
              if (listStartToken !== 0) {
                while (formattingScanner.isOnToken()) {
                  var tokenInfo2 = formattingScanner.readTokenInfo(parent);
                  if (tokenInfo2.token.end > nodes.pos) {
                    break;
                  } else if (tokenInfo2.token.kind === listStartToken) {
                    startLine2 = sourceFile.getLineAndCharacterOfPosition(tokenInfo2.token.pos).line;
                    consumeTokenAndAdvanceScanner(tokenInfo2, parent, parentDynamicIndentation, parent);
                    var indentationOnListStartToken = void 0;
                    if (indentationOnLastIndentedLine !== -1) {
                      indentationOnListStartToken = indentationOnLastIndentedLine;
                    } else {
                      var startLinePosition = ts2.getLineStartPositionForPosition(tokenInfo2.token.pos, sourceFile);
                      indentationOnListStartToken = formatting2.SmartIndenter.findFirstNonWhitespaceColumn(startLinePosition, tokenInfo2.token.pos, sourceFile, options);
                    }
                    listDynamicIndentation = getDynamicIndentation(parent, parentStartLine, indentationOnListStartToken, options.indentSize);
                  } else {
                    consumeTokenAndAdvanceScanner(tokenInfo2, parent, parentDynamicIndentation, parent);
                  }
                }
              }
              var inheritedIndentation = -1;
              for (var i = 0; i < nodes.length; i++) {
                var child = nodes[i];
                inheritedIndentation = processChildNode(child, inheritedIndentation, node, listDynamicIndentation, startLine2, startLine2, true, i === 0);
              }
              var listEndToken = getCloseTokenForOpenToken(listStartToken);
              if (listEndToken !== 0 && formattingScanner.isOnToken()) {
                var tokenInfo2 = formattingScanner.readTokenInfo(parent);
                if (tokenInfo2.token.kind === 27 && ts2.isCallLikeExpression(parent)) {
                  var commaTokenLine = sourceFile.getLineAndCharacterOfPosition(tokenInfo2.token.pos).line;
                  if (startLine2 !== commaTokenLine) {
                    formattingScanner.advance();
                    tokenInfo2 = formattingScanner.isOnToken() ? formattingScanner.readTokenInfo(parent) : void 0;
                  }
                }
                if (tokenInfo2 && tokenInfo2.token.kind === listEndToken && ts2.rangeContainsRange(parent, tokenInfo2.token)) {
                  consumeTokenAndAdvanceScanner(tokenInfo2, parent, listDynamicIndentation, parent, true);
                }
              }
            }
            function consumeTokenAndAdvanceScanner(currentTokenInfo, parent, dynamicIndentation, container, isListEndToken) {
              ts2.Debug.assert(ts2.rangeContainsRange(parent, currentTokenInfo.token));
              var lastTriviaWasNewLine = formattingScanner.lastTrailingTriviaWasNewLine();
              var indentToken = false;
              if (currentTokenInfo.leadingTrivia) {
                processTrivia(currentTokenInfo.leadingTrivia, parent, childContextNode, dynamicIndentation);
              }
              var lineAction = 0;
              var isTokenInRange = ts2.rangeContainsRange(originalRange, currentTokenInfo.token);
              var tokenStart = sourceFile.getLineAndCharacterOfPosition(currentTokenInfo.token.pos);
              if (isTokenInRange) {
                var rangeHasError = rangeContainsError(currentTokenInfo.token);
                var savePreviousRange = previousRange;
                lineAction = processRange(currentTokenInfo.token, tokenStart, parent, childContextNode, dynamicIndentation);
                if (!rangeHasError) {
                  if (lineAction === 0) {
                    var prevEndLine = savePreviousRange && sourceFile.getLineAndCharacterOfPosition(savePreviousRange.end).line;
                    indentToken = lastTriviaWasNewLine && tokenStart.line !== prevEndLine;
                  } else {
                    indentToken = lineAction === 1;
                  }
                }
              }
              if (currentTokenInfo.trailingTrivia) {
                processTrivia(currentTokenInfo.trailingTrivia, parent, childContextNode, dynamicIndentation);
              }
              if (indentToken) {
                var tokenIndentation = isTokenInRange && !rangeContainsError(currentTokenInfo.token) ? dynamicIndentation.getIndentationForToken(tokenStart.line, currentTokenInfo.token.kind, container, !!isListEndToken) : -1;
                var indentNextTokenOrTrivia = true;
                if (currentTokenInfo.leadingTrivia) {
                  var commentIndentation_1 = dynamicIndentation.getIndentationForComment(currentTokenInfo.token.kind, tokenIndentation, container);
                  indentNextTokenOrTrivia = indentTriviaItems(currentTokenInfo.leadingTrivia, commentIndentation_1, indentNextTokenOrTrivia, function(item) {
                    return insertIndentation(item.pos, commentIndentation_1, false);
                  });
                }
                if (tokenIndentation !== -1 && indentNextTokenOrTrivia) {
                  insertIndentation(currentTokenInfo.token.pos, tokenIndentation, lineAction === 1);
                  lastIndentedLine = tokenStart.line;
                  indentationOnLastIndentedLine = tokenIndentation;
                }
              }
              formattingScanner.advance();
              childContextNode = parent;
            }
          }
          function indentTriviaItems(trivia, commentIndentation, indentNextTokenOrTrivia, indentSingleLine) {
            for (var _i = 0, trivia_1 = trivia; _i < trivia_1.length; _i++) {
              var triviaItem = trivia_1[_i];
              var triviaInRange = ts2.rangeContainsRange(originalRange, triviaItem);
              switch (triviaItem.kind) {
                case 3:
                  if (triviaInRange) {
                    indentMultilineCommentOrJsxText(triviaItem, commentIndentation, !indentNextTokenOrTrivia);
                  }
                  indentNextTokenOrTrivia = false;
                  break;
                case 2:
                  if (indentNextTokenOrTrivia && triviaInRange) {
                    indentSingleLine(triviaItem);
                  }
                  indentNextTokenOrTrivia = false;
                  break;
                case 4:
                  indentNextTokenOrTrivia = true;
                  break;
              }
            }
            return indentNextTokenOrTrivia;
          }
          function processTrivia(trivia, parent, contextNode, dynamicIndentation) {
            for (var _i = 0, trivia_2 = trivia; _i < trivia_2.length; _i++) {
              var triviaItem = trivia_2[_i];
              if (ts2.isComment(triviaItem.kind) && ts2.rangeContainsRange(originalRange, triviaItem)) {
                var triviaItemStart = sourceFile.getLineAndCharacterOfPosition(triviaItem.pos);
                processRange(triviaItem, triviaItemStart, parent, contextNode, dynamicIndentation);
              }
            }
          }
          function processRange(range, rangeStart, parent, contextNode, dynamicIndentation) {
            var rangeHasError = rangeContainsError(range);
            var lineAction = 0;
            if (!rangeHasError) {
              if (!previousRange) {
                var originalStart = sourceFile.getLineAndCharacterOfPosition(originalRange.pos);
                trimTrailingWhitespacesForLines(originalStart.line, rangeStart.line);
              } else {
                lineAction = processPair(range, rangeStart.line, parent, previousRange, previousRangeStartLine, previousParent, contextNode, dynamicIndentation);
              }
            }
            previousRange = range;
            previousParent = parent;
            previousRangeStartLine = rangeStart.line;
            return lineAction;
          }
          function processPair(currentItem, currentStartLine, currentParent, previousItem, previousStartLine, previousParent2, contextNode, dynamicIndentation) {
            formattingContext.updateContext(previousItem, previousParent2, currentItem, currentParent, contextNode);
            var rules = getRules(formattingContext);
            var trimTrailingWhitespaces = formattingContext.options.trimTrailingWhitespace !== false;
            var lineAction = 0;
            if (rules) {
              ts2.forEachRight(rules, function(rule) {
                lineAction = applyRuleEdits(rule, previousItem, previousStartLine, currentItem, currentStartLine);
                switch (lineAction) {
                  case 2:
                    if (currentParent.getStart(sourceFile) === currentItem.pos) {
                      dynamicIndentation.recomputeIndentation(false, contextNode);
                    }
                    break;
                  case 1:
                    if (currentParent.getStart(sourceFile) === currentItem.pos) {
                      dynamicIndentation.recomputeIndentation(true, contextNode);
                    }
                    break;
                  default:
                    ts2.Debug.assert(lineAction === 0);
                }
                trimTrailingWhitespaces = trimTrailingWhitespaces && !(rule.action & 16) && rule.flags !== 1;
              });
            } else {
              trimTrailingWhitespaces = trimTrailingWhitespaces && currentItem.kind !== 1;
            }
            if (currentStartLine !== previousStartLine && trimTrailingWhitespaces) {
              trimTrailingWhitespacesForLines(previousStartLine, currentStartLine, previousItem);
            }
            return lineAction;
          }
          function insertIndentation(pos, indentation, lineAdded) {
            var indentationString = getIndentationString(indentation, options);
            if (lineAdded) {
              recordReplace(pos, 0, indentationString);
            } else {
              var tokenStart = sourceFile.getLineAndCharacterOfPosition(pos);
              var startLinePosition = ts2.getStartPositionOfLine(tokenStart.line, sourceFile);
              if (indentation !== characterToColumn(startLinePosition, tokenStart.character) || indentationIsDifferent(indentationString, startLinePosition)) {
                recordReplace(startLinePosition, tokenStart.character, indentationString);
              }
            }
          }
          function characterToColumn(startLinePosition, characterInLine) {
            var column = 0;
            for (var i = 0; i < characterInLine; i++) {
              if (sourceFile.text.charCodeAt(startLinePosition + i) === 9) {
                column += options.tabSize - column % options.tabSize;
              } else {
                column++;
              }
            }
            return column;
          }
          function indentationIsDifferent(indentationString, startLinePosition) {
            return indentationString !== sourceFile.text.substr(startLinePosition, indentationString.length);
          }
          function indentMultilineCommentOrJsxText(commentRange, indentation, firstLineIsIndented, indentFinalLine, jsxTextStyleIndent) {
            if (indentFinalLine === void 0) {
              indentFinalLine = true;
            }
            var startLine2 = sourceFile.getLineAndCharacterOfPosition(commentRange.pos).line;
            var endLine = sourceFile.getLineAndCharacterOfPosition(commentRange.end).line;
            if (startLine2 === endLine) {
              if (!firstLineIsIndented) {
                insertIndentation(commentRange.pos, indentation, false);
              }
              return;
            }
            var parts = [];
            var startPos = commentRange.pos;
            for (var line = startLine2; line < endLine; line++) {
              var endOfLine = ts2.getEndLinePosition(line, sourceFile);
              parts.push({ pos: startPos, end: endOfLine });
              startPos = ts2.getStartPositionOfLine(line + 1, sourceFile);
            }
            if (indentFinalLine) {
              parts.push({ pos: startPos, end: commentRange.end });
            }
            if (parts.length === 0)
              return;
            var startLinePos = ts2.getStartPositionOfLine(startLine2, sourceFile);
            var nonWhitespaceColumnInFirstPart = formatting2.SmartIndenter.findFirstNonWhitespaceCharacterAndColumn(startLinePos, parts[0].pos, sourceFile, options);
            if (indentation === nonWhitespaceColumnInFirstPart.column && !jsxTextStyleIndent) {
              return;
            }
            var startIndex = 0;
            if (firstLineIsIndented) {
              startIndex = 1;
              startLine2++;
            }
            var delta2 = indentation - nonWhitespaceColumnInFirstPart.column;
            for (var i = startIndex; i < parts.length; i++, startLine2++) {
              var startLinePos_1 = ts2.getStartPositionOfLine(startLine2, sourceFile);
              var nonWhitespaceCharacterAndColumn = i === 0 ? nonWhitespaceColumnInFirstPart : formatting2.SmartIndenter.findFirstNonWhitespaceCharacterAndColumn(parts[i].pos, parts[i].end, sourceFile, options);
              if (jsxTextStyleIndent) {
                if (ts2.isLineBreak(sourceFile.text.charCodeAt(ts2.getStartPositionOfLine(startLine2, sourceFile))))
                  continue;
                delta2 = indentation - nonWhitespaceCharacterAndColumn.column;
              }
              var newIndentation = nonWhitespaceCharacterAndColumn.column + delta2;
              if (newIndentation > 0) {
                var indentationString = getIndentationString(newIndentation, options);
                recordReplace(startLinePos_1, nonWhitespaceCharacterAndColumn.character, indentationString);
              } else {
                recordDelete(startLinePos_1, nonWhitespaceCharacterAndColumn.character);
              }
            }
          }
          function trimTrailingWhitespacesForLines(line1, line2, range) {
            for (var line = line1; line < line2; line++) {
              var lineStartPosition = ts2.getStartPositionOfLine(line, sourceFile);
              var lineEndPosition = ts2.getEndLinePosition(line, sourceFile);
              if (range && (ts2.isComment(range.kind) || ts2.isStringOrRegularExpressionOrTemplateLiteral(range.kind)) && range.pos <= lineEndPosition && range.end > lineEndPosition) {
                continue;
              }
              var whitespaceStart = getTrailingWhitespaceStartPosition(lineStartPosition, lineEndPosition);
              if (whitespaceStart !== -1) {
                ts2.Debug.assert(whitespaceStart === lineStartPosition || !ts2.isWhiteSpaceSingleLine(sourceFile.text.charCodeAt(whitespaceStart - 1)));
                recordDelete(whitespaceStart, lineEndPosition + 1 - whitespaceStart);
              }
            }
          }
          function getTrailingWhitespaceStartPosition(start, end) {
            var pos = end;
            while (pos >= start && ts2.isWhiteSpaceSingleLine(sourceFile.text.charCodeAt(pos))) {
              pos--;
            }
            if (pos !== end) {
              return pos + 1;
            }
            return -1;
          }
          function trimTrailingWhitespacesForRemainingRange() {
            var startPosition = previousRange ? previousRange.end : originalRange.pos;
            var startLine2 = sourceFile.getLineAndCharacterOfPosition(startPosition).line;
            var endLine = sourceFile.getLineAndCharacterOfPosition(originalRange.end).line;
            trimTrailingWhitespacesForLines(startLine2, endLine + 1, previousRange);
          }
          function recordDelete(start, len) {
            if (len) {
              edits.push(ts2.createTextChangeFromStartLength(start, len, ""));
            }
          }
          function recordReplace(start, len, newText) {
            if (len || newText) {
              edits.push(ts2.createTextChangeFromStartLength(start, len, newText));
            }
          }
          function recordInsert(start, text) {
            if (text) {
              edits.push(ts2.createTextChangeFromStartLength(start, 0, text));
            }
          }
          function applyRuleEdits(rule, previousRange2, previousStartLine, currentRange, currentStartLine) {
            var onLaterLine = currentStartLine !== previousStartLine;
            switch (rule.action) {
              case 1:
                return 0;
              case 16:
                if (previousRange2.end !== currentRange.pos) {
                  recordDelete(previousRange2.end, currentRange.pos - previousRange2.end);
                  return onLaterLine ? 2 : 0;
                }
                break;
              case 32:
                recordDelete(previousRange2.pos, previousRange2.end - previousRange2.pos);
                break;
              case 8:
                if (rule.flags !== 1 && previousStartLine !== currentStartLine) {
                  return 0;
                }
                var lineDelta = currentStartLine - previousStartLine;
                if (lineDelta !== 1) {
                  recordReplace(previousRange2.end, currentRange.pos - previousRange2.end, ts2.getNewLineOrDefaultFromHost(host, options));
                  return onLaterLine ? 0 : 1;
                }
                break;
              case 4:
                if (rule.flags !== 1 && previousStartLine !== currentStartLine) {
                  return 0;
                }
                var posDelta = currentRange.pos - previousRange2.end;
                if (posDelta !== 1 || sourceFile.text.charCodeAt(previousRange2.end) !== 32) {
                  recordReplace(previousRange2.end, currentRange.pos - previousRange2.end, " ");
                  return onLaterLine ? 2 : 0;
                }
                break;
              case 64:
                recordInsert(previousRange2.end, ";");
            }
            return 0;
          }
        }
        var LineAction;
        (function(LineAction2) {
          LineAction2[LineAction2["None"] = 0] = "None";
          LineAction2[LineAction2["LineAdded"] = 1] = "LineAdded";
          LineAction2[LineAction2["LineRemoved"] = 2] = "LineRemoved";
        })(LineAction || (LineAction = {}));
        function getRangeOfEnclosingComment(sourceFile, position, precedingToken, tokenAtPosition) {
          if (tokenAtPosition === void 0) {
            tokenAtPosition = ts2.getTokenAtPosition(sourceFile, position);
          }
          var jsdoc = ts2.findAncestor(tokenAtPosition, ts2.isJSDoc);
          if (jsdoc)
            tokenAtPosition = jsdoc.parent;
          var tokenStart = tokenAtPosition.getStart(sourceFile);
          if (tokenStart <= position && position < tokenAtPosition.getEnd()) {
            return void 0;
          }
          precedingToken = precedingToken === null ? void 0 : precedingToken === void 0 ? ts2.findPrecedingToken(position, sourceFile) : precedingToken;
          var trailingRangesOfPreviousToken = precedingToken && ts2.getTrailingCommentRanges(sourceFile.text, precedingToken.end);
          var leadingCommentRangesOfNextToken = ts2.getLeadingCommentRangesOfNode(tokenAtPosition, sourceFile);
          var commentRanges = ts2.concatenate(trailingRangesOfPreviousToken, leadingCommentRangesOfNextToken);
          return commentRanges && ts2.find(commentRanges, function(range) {
            return ts2.rangeContainsPositionExclusive(range, position) || position === range.end && (range.kind === 2 || position === sourceFile.getFullWidth());
          });
        }
        formatting2.getRangeOfEnclosingComment = getRangeOfEnclosingComment;
        function getOpenTokenForList(node, list) {
          switch (node.kind) {
            case 162:
            case 244:
            case 201:
            case 161:
            case 160:
            case 202:
              if (node.typeParameters === list) {
                return 29;
              } else if (node.parameters === list) {
                return 20;
              }
              break;
            case 196:
            case 197:
              if (node.typeArguments === list) {
                return 29;
              } else if (node.arguments === list) {
                return 20;
              }
              break;
            case 169:
              if (node.typeArguments === list) {
                return 29;
              }
              break;
            case 173:
              return 18;
          }
          return 0;
        }
        function getCloseTokenForOpenToken(kind) {
          switch (kind) {
            case 20:
              return 21;
            case 29:
              return 31;
            case 18:
              return 19;
          }
          return 0;
        }
        var internedSizes;
        var internedTabsIndentation;
        var internedSpacesIndentation;
        function getIndentationString(indentation, options) {
          var resetInternedStrings = !internedSizes || (internedSizes.tabSize !== options.tabSize || internedSizes.indentSize !== options.indentSize);
          if (resetInternedStrings) {
            internedSizes = { tabSize: options.tabSize, indentSize: options.indentSize };
            internedTabsIndentation = internedSpacesIndentation = void 0;
          }
          if (!options.convertTabsToSpaces) {
            var tabs = Math.floor(indentation / options.tabSize);
            var spaces = indentation - tabs * options.tabSize;
            var tabString = void 0;
            if (!internedTabsIndentation) {
              internedTabsIndentation = [];
            }
            if (internedTabsIndentation[tabs] === void 0) {
              internedTabsIndentation[tabs] = tabString = ts2.repeatString("	", tabs);
            } else {
              tabString = internedTabsIndentation[tabs];
            }
            return spaces ? tabString + ts2.repeatString(" ", spaces) : tabString;
          } else {
            var spacesString = void 0;
            var quotient = Math.floor(indentation / options.indentSize);
            var remainder = indentation % options.indentSize;
            if (!internedSpacesIndentation) {
              internedSpacesIndentation = [];
            }
            if (internedSpacesIndentation[quotient] === void 0) {
              spacesString = ts2.repeatString(" ", options.indentSize * quotient);
              internedSpacesIndentation[quotient] = spacesString;
            } else {
              spacesString = internedSpacesIndentation[quotient];
            }
            return remainder ? spacesString + ts2.repeatString(" ", remainder) : spacesString;
          }
        }
        formatting2.getIndentationString = getIndentationString;
      })(formatting = ts2.formatting || (ts2.formatting = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var formatting;
      (function(formatting2) {
        var SmartIndenter;
        (function(SmartIndenter2) {
          var Value;
          (function(Value2) {
            Value2[Value2["Unknown"] = -1] = "Unknown";
          })(Value || (Value = {}));
          function getIndentation(position, sourceFile, options, assumeNewLineBeforeCloseBrace) {
            if (assumeNewLineBeforeCloseBrace === void 0) {
              assumeNewLineBeforeCloseBrace = false;
            }
            if (position > sourceFile.text.length) {
              return getBaseIndentation(options);
            }
            if (options.indentStyle === ts2.IndentStyle.None) {
              return 0;
            }
            var precedingToken = ts2.findPrecedingToken(position, sourceFile, void 0, true);
            var enclosingCommentRange = formatting2.getRangeOfEnclosingComment(sourceFile, position, precedingToken || null);
            if (enclosingCommentRange && enclosingCommentRange.kind === 3) {
              return getCommentIndent(sourceFile, position, options, enclosingCommentRange);
            }
            if (!precedingToken) {
              return getBaseIndentation(options);
            }
            var precedingTokenIsLiteral = ts2.isStringOrRegularExpressionOrTemplateLiteral(precedingToken.kind);
            if (precedingTokenIsLiteral && precedingToken.getStart(sourceFile) <= position && position < precedingToken.end) {
              return 0;
            }
            var lineAtPosition = sourceFile.getLineAndCharacterOfPosition(position).line;
            if (options.indentStyle === ts2.IndentStyle.Block) {
              return getBlockIndent(sourceFile, position, options);
            }
            if (precedingToken.kind === 27 && precedingToken.parent.kind !== 209) {
              var actualIndentation = getActualIndentationForListItemBeforeComma(precedingToken, sourceFile, options);
              if (actualIndentation !== -1) {
                return actualIndentation;
              }
            }
            var containerList = getListByPosition(position, precedingToken.parent, sourceFile);
            if (containerList && !ts2.rangeContainsRange(containerList, precedingToken)) {
              return getActualIndentationForListStartLine(containerList, sourceFile, options) + options.indentSize;
            }
            return getSmartIndent(sourceFile, position, precedingToken, lineAtPosition, assumeNewLineBeforeCloseBrace, options);
          }
          SmartIndenter2.getIndentation = getIndentation;
          function getCommentIndent(sourceFile, position, options, enclosingCommentRange) {
            var previousLine = ts2.getLineAndCharacterOfPosition(sourceFile, position).line - 1;
            var commentStartLine = ts2.getLineAndCharacterOfPosition(sourceFile, enclosingCommentRange.pos).line;
            ts2.Debug.assert(commentStartLine >= 0);
            if (previousLine <= commentStartLine) {
              return findFirstNonWhitespaceColumn(ts2.getStartPositionOfLine(commentStartLine, sourceFile), position, sourceFile, options);
            }
            var startPositionOfLine = ts2.getStartPositionOfLine(previousLine, sourceFile);
            var _a = findFirstNonWhitespaceCharacterAndColumn(startPositionOfLine, position, sourceFile, options), column = _a.column, character = _a.character;
            if (column === 0) {
              return column;
            }
            var firstNonWhitespaceCharacterCode = sourceFile.text.charCodeAt(startPositionOfLine + character);
            return firstNonWhitespaceCharacterCode === 42 ? column - 1 : column;
          }
          function getBlockIndent(sourceFile, position, options) {
            var current = position;
            while (current > 0) {
              var char = sourceFile.text.charCodeAt(current);
              if (!ts2.isWhiteSpaceLike(char)) {
                break;
              }
              current--;
            }
            var lineStart = ts2.getLineStartPositionForPosition(current, sourceFile);
            return findFirstNonWhitespaceColumn(lineStart, current, sourceFile, options);
          }
          function getSmartIndent(sourceFile, position, precedingToken, lineAtPosition, assumeNewLineBeforeCloseBrace, options) {
            var previous;
            var current = precedingToken;
            while (current) {
              if (ts2.positionBelongsToNode(current, position, sourceFile) && shouldIndentChildNode(options, current, previous, sourceFile, true)) {
                var currentStart = getStartLineAndCharacterForNode(current, sourceFile);
                var nextTokenKind = nextTokenIsCurlyBraceOnSameLineAsCursor(precedingToken, current, lineAtPosition, sourceFile);
                var indentationDelta = nextTokenKind !== 0 ? assumeNewLineBeforeCloseBrace && nextTokenKind === 2 ? options.indentSize : 0 : lineAtPosition !== currentStart.line ? options.indentSize : 0;
                return getIndentationForNodeWorker(current, currentStart, void 0, indentationDelta, sourceFile, true, options);
              }
              var actualIndentation = getActualIndentationForListItem(current, sourceFile, options, true);
              if (actualIndentation !== -1) {
                return actualIndentation;
              }
              previous = current;
              current = current.parent;
            }
            return getBaseIndentation(options);
          }
          function getIndentationForNode(n, ignoreActualIndentationRange, sourceFile, options) {
            var start = sourceFile.getLineAndCharacterOfPosition(n.getStart(sourceFile));
            return getIndentationForNodeWorker(n, start, ignoreActualIndentationRange, 0, sourceFile, false, options);
          }
          SmartIndenter2.getIndentationForNode = getIndentationForNode;
          function getBaseIndentation(options) {
            return options.baseIndentSize || 0;
          }
          SmartIndenter2.getBaseIndentation = getBaseIndentation;
          function getIndentationForNodeWorker(current, currentStart, ignoreActualIndentationRange, indentationDelta, sourceFile, isNextChild, options) {
            var parent = current.parent;
            while (parent) {
              var useActualIndentation = true;
              if (ignoreActualIndentationRange) {
                var start = current.getStart(sourceFile);
                useActualIndentation = start < ignoreActualIndentationRange.pos || start > ignoreActualIndentationRange.end;
              }
              var containingListOrParentStart = getContainingListOrParentStart(parent, current, sourceFile);
              var parentAndChildShareLine = containingListOrParentStart.line === currentStart.line || childStartsOnTheSameLineWithElseInIfStatement(parent, current, currentStart.line, sourceFile);
              if (useActualIndentation) {
                var actualIndentation = getActualIndentationForListItem(current, sourceFile, options, !parentAndChildShareLine);
                if (actualIndentation !== -1) {
                  return actualIndentation + indentationDelta;
                }
                actualIndentation = getActualIndentationForNode(current, parent, currentStart, parentAndChildShareLine, sourceFile, options);
                if (actualIndentation !== -1) {
                  return actualIndentation + indentationDelta;
                }
              }
              if (shouldIndentChildNode(options, parent, current, sourceFile, isNextChild) && !parentAndChildShareLine) {
                indentationDelta += options.indentSize;
              }
              var useTrueStart = isArgumentAndStartLineOverlapsExpressionBeingCalled(parent, current, currentStart.line, sourceFile);
              current = parent;
              parent = current.parent;
              currentStart = useTrueStart ? sourceFile.getLineAndCharacterOfPosition(current.getStart(sourceFile)) : containingListOrParentStart;
            }
            return indentationDelta + getBaseIndentation(options);
          }
          function getContainingListOrParentStart(parent, child, sourceFile) {
            var containingList = getContainingList(child, sourceFile);
            var startPos = containingList ? containingList.pos : parent.getStart(sourceFile);
            return sourceFile.getLineAndCharacterOfPosition(startPos);
          }
          function getActualIndentationForListItemBeforeComma(commaToken, sourceFile, options) {
            var commaItemInfo = ts2.findListItemInfo(commaToken);
            if (commaItemInfo && commaItemInfo.listItemIndex > 0) {
              return deriveActualIndentationFromList(commaItemInfo.list.getChildren(), commaItemInfo.listItemIndex - 1, sourceFile, options);
            } else {
              return -1;
            }
          }
          function getActualIndentationForNode(current, parent, currentLineAndChar, parentAndChildShareLine, sourceFile, options) {
            var useActualIndentation = (ts2.isDeclaration(current) || ts2.isStatementButNotDeclaration(current)) && (parent.kind === 290 || !parentAndChildShareLine);
            if (!useActualIndentation) {
              return -1;
            }
            return findColumnForFirstNonWhitespaceCharacterInLine(currentLineAndChar, sourceFile, options);
          }
          var NextTokenKind;
          (function(NextTokenKind2) {
            NextTokenKind2[NextTokenKind2["Unknown"] = 0] = "Unknown";
            NextTokenKind2[NextTokenKind2["OpenBrace"] = 1] = "OpenBrace";
            NextTokenKind2[NextTokenKind2["CloseBrace"] = 2] = "CloseBrace";
          })(NextTokenKind || (NextTokenKind = {}));
          function nextTokenIsCurlyBraceOnSameLineAsCursor(precedingToken, current, lineAtPosition, sourceFile) {
            var nextToken = ts2.findNextToken(precedingToken, current, sourceFile);
            if (!nextToken) {
              return 0;
            }
            if (nextToken.kind === 18) {
              return 1;
            } else if (nextToken.kind === 19) {
              var nextTokenStartLine = getStartLineAndCharacterForNode(nextToken, sourceFile).line;
              return lineAtPosition === nextTokenStartLine ? 2 : 0;
            }
            return 0;
          }
          function getStartLineAndCharacterForNode(n, sourceFile) {
            return sourceFile.getLineAndCharacterOfPosition(n.getStart(sourceFile));
          }
          function isArgumentAndStartLineOverlapsExpressionBeingCalled(parent, child, childStartLine, sourceFile) {
            if (!(ts2.isCallExpression(parent) && ts2.contains(parent.arguments, child))) {
              return false;
            }
            var expressionOfCallExpressionEnd = parent.expression.getEnd();
            var expressionOfCallExpressionEndLine = ts2.getLineAndCharacterOfPosition(sourceFile, expressionOfCallExpressionEnd).line;
            return expressionOfCallExpressionEndLine === childStartLine;
          }
          SmartIndenter2.isArgumentAndStartLineOverlapsExpressionBeingCalled = isArgumentAndStartLineOverlapsExpressionBeingCalled;
          function childStartsOnTheSameLineWithElseInIfStatement(parent, child, childStartLine, sourceFile) {
            if (parent.kind === 227 && parent.elseStatement === child) {
              var elseKeyword = ts2.findChildOfKind(parent, 87, sourceFile);
              ts2.Debug.assert(elseKeyword !== void 0);
              var elseKeywordStartLine = getStartLineAndCharacterForNode(elseKeyword, sourceFile).line;
              return elseKeywordStartLine === childStartLine;
            }
            return false;
          }
          SmartIndenter2.childStartsOnTheSameLineWithElseInIfStatement = childStartsOnTheSameLineWithElseInIfStatement;
          function argumentStartsOnSameLineAsPreviousArgument(parent, child, childStartLine, sourceFile) {
            if (ts2.isCallOrNewExpression(parent)) {
              if (!parent.arguments)
                return false;
              var currentNode = ts2.find(parent.arguments, function(arg) {
                return arg.pos === child.pos;
              });
              if (!currentNode)
                return false;
              var currentIndex = parent.arguments.indexOf(currentNode);
              if (currentIndex === 0)
                return false;
              var previousNode = parent.arguments[currentIndex - 1];
              var lineOfPreviousNode = ts2.getLineAndCharacterOfPosition(sourceFile, previousNode.getEnd()).line;
              if (childStartLine === lineOfPreviousNode) {
                return true;
              }
            }
            return false;
          }
          SmartIndenter2.argumentStartsOnSameLineAsPreviousArgument = argumentStartsOnSameLineAsPreviousArgument;
          function getContainingList(node, sourceFile) {
            return node.parent && getListByRange(node.getStart(sourceFile), node.getEnd(), node.parent, sourceFile);
          }
          SmartIndenter2.getContainingList = getContainingList;
          function getListByPosition(pos, node, sourceFile) {
            return node && getListByRange(pos, pos, node, sourceFile);
          }
          function getListByRange(start, end, node, sourceFile) {
            switch (node.kind) {
              case 169:
                return getList(node.typeArguments);
              case 193:
                return getList(node.properties);
              case 192:
                return getList(node.elements);
              case 173:
                return getList(node.members);
              case 244:
              case 201:
              case 202:
              case 161:
              case 160:
              case 165:
              case 162:
              case 171:
              case 166:
                return getList(node.typeParameters) || getList(node.parameters);
              case 245:
              case 214:
              case 246:
              case 247:
              case 321:
                return getList(node.typeParameters);
              case 197:
              case 196:
                return getList(node.typeArguments) || getList(node.arguments);
              case 243:
                return getList(node.declarations);
              case 257:
              case 261:
                return getList(node.elements);
              case 189:
              case 190:
                return getList(node.elements);
            }
            function getList(list) {
              return list && ts2.rangeContainsStartEnd(getVisualListRange(node, list, sourceFile), start, end) ? list : void 0;
            }
          }
          function getVisualListRange(node, list, sourceFile) {
            var children = node.getChildren(sourceFile);
            for (var i = 1; i < children.length - 1; i++) {
              if (children[i].pos === list.pos && children[i].end === list.end) {
                return { pos: children[i - 1].end, end: children[i + 1].getStart(sourceFile) };
              }
            }
            return list;
          }
          function getActualIndentationForListStartLine(list, sourceFile, options) {
            if (!list) {
              return -1;
            }
            return findColumnForFirstNonWhitespaceCharacterInLine(sourceFile.getLineAndCharacterOfPosition(list.pos), sourceFile, options);
          }
          function getActualIndentationForListItem(node, sourceFile, options, listIndentsChild) {
            if (node.parent && node.parent.kind === 243) {
              return -1;
            }
            var containingList = getContainingList(node, sourceFile);
            if (containingList) {
              var index = containingList.indexOf(node);
              if (index !== -1) {
                var result = deriveActualIndentationFromList(containingList, index, sourceFile, options);
                if (result !== -1) {
                  return result;
                }
              }
              return getActualIndentationForListStartLine(containingList, sourceFile, options) + (listIndentsChild ? options.indentSize : 0);
            }
            return -1;
          }
          function deriveActualIndentationFromList(list, index, sourceFile, options) {
            ts2.Debug.assert(index >= 0 && index < list.length);
            var node = list[index];
            var lineAndCharacter = getStartLineAndCharacterForNode(node, sourceFile);
            for (var i = index - 1; i >= 0; i--) {
              if (list[i].kind === 27) {
                continue;
              }
              var prevEndLine = sourceFile.getLineAndCharacterOfPosition(list[i].end).line;
              if (prevEndLine !== lineAndCharacter.line) {
                return findColumnForFirstNonWhitespaceCharacterInLine(lineAndCharacter, sourceFile, options);
              }
              lineAndCharacter = getStartLineAndCharacterForNode(list[i], sourceFile);
            }
            return -1;
          }
          function findColumnForFirstNonWhitespaceCharacterInLine(lineAndCharacter, sourceFile, options) {
            var lineStart = sourceFile.getPositionOfLineAndCharacter(lineAndCharacter.line, 0);
            return findFirstNonWhitespaceColumn(lineStart, lineStart + lineAndCharacter.character, sourceFile, options);
          }
          function findFirstNonWhitespaceCharacterAndColumn(startPos, endPos, sourceFile, options) {
            var character = 0;
            var column = 0;
            for (var pos = startPos; pos < endPos; pos++) {
              var ch = sourceFile.text.charCodeAt(pos);
              if (!ts2.isWhiteSpaceSingleLine(ch)) {
                break;
              }
              if (ch === 9) {
                column += options.tabSize + column % options.tabSize;
              } else {
                column++;
              }
              character++;
            }
            return { column, character };
          }
          SmartIndenter2.findFirstNonWhitespaceCharacterAndColumn = findFirstNonWhitespaceCharacterAndColumn;
          function findFirstNonWhitespaceColumn(startPos, endPos, sourceFile, options) {
            return findFirstNonWhitespaceCharacterAndColumn(startPos, endPos, sourceFile, options).column;
          }
          SmartIndenter2.findFirstNonWhitespaceColumn = findFirstNonWhitespaceColumn;
          function nodeWillIndentChild(settings, parent, child, sourceFile, indentByDefault) {
            var childKind = child ? child.kind : 0;
            switch (parent.kind) {
              case 226:
              case 245:
              case 214:
              case 246:
              case 248:
              case 247:
              case 192:
              case 223:
              case 250:
              case 193:
              case 173:
              case 186:
              case 175:
              case 251:
              case 278:
              case 277:
              case 200:
              case 194:
              case 196:
              case 197:
              case 225:
              case 259:
              case 235:
              case 210:
              case 190:
              case 189:
              case 268:
              case 271:
              case 267:
              case 276:
              case 160:
              case 165:
              case 166:
              case 156:
              case 170:
              case 171:
              case 182:
              case 198:
              case 206:
              case 261:
              case 257:
              case 263:
              case 258:
              case 159:
                return true;
              case 242:
              case 281:
              case 209:
                if (!settings.indentMultiLineObjectLiteralBeginningOnBlankLine && sourceFile && childKind === 193) {
                  return rangeIsOnOneLine(sourceFile, child);
                }
                if (parent.kind !== 209) {
                  return true;
                }
                break;
              case 228:
              case 229:
              case 231:
              case 232:
              case 230:
              case 227:
              case 244:
              case 201:
              case 161:
              case 202:
              case 162:
              case 163:
              case 164:
                return childKind !== 223;
              case 260:
                return childKind !== 261;
              case 254:
                return childKind !== 255 || !!child.namedBindings && child.namedBindings.kind !== 257;
              case 266:
                return childKind !== 269;
              case 270:
                return childKind !== 272;
              case 179:
              case 178:
                if (childKind === 173) {
                  return false;
                }
            }
            return indentByDefault;
          }
          SmartIndenter2.nodeWillIndentChild = nodeWillIndentChild;
          function isControlFlowEndingStatement(kind, parent) {
            switch (kind) {
              case 235:
              case 239:
              case 233:
              case 234:
                return parent.kind !== 223;
              default:
                return false;
            }
          }
          function shouldIndentChildNode(settings, parent, child, sourceFile, isNextChild) {
            if (isNextChild === void 0) {
              isNextChild = false;
            }
            return nodeWillIndentChild(settings, parent, child, sourceFile, false) && !(isNextChild && child && isControlFlowEndingStatement(child.kind, parent));
          }
          SmartIndenter2.shouldIndentChildNode = shouldIndentChildNode;
          function rangeIsOnOneLine(sourceFile, range) {
            var rangeStart = ts2.skipTrivia(sourceFile.text, range.pos);
            var startLine = sourceFile.getLineAndCharacterOfPosition(rangeStart).line;
            var endLine = sourceFile.getLineAndCharacterOfPosition(range.end).line;
            return startLine === endLine;
          }
        })(SmartIndenter = formatting2.SmartIndenter || (formatting2.SmartIndenter = {}));
      })(formatting = ts2.formatting || (ts2.formatting = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var textChanges;
      (function(textChanges_3) {
        function getPos(n) {
          var result = n.__pos;
          ts2.Debug.assert(typeof result === "number");
          return result;
        }
        function setPos(n, pos) {
          ts2.Debug.assert(typeof pos === "number");
          n.__pos = pos;
        }
        function getEnd(n) {
          var result = n.__end;
          ts2.Debug.assert(typeof result === "number");
          return result;
        }
        function setEnd(n, end) {
          ts2.Debug.assert(typeof end === "number");
          n.__end = end;
        }
        var LeadingTriviaOption;
        (function(LeadingTriviaOption2) {
          LeadingTriviaOption2[LeadingTriviaOption2["Exclude"] = 0] = "Exclude";
          LeadingTriviaOption2[LeadingTriviaOption2["IncludeAll"] = 1] = "IncludeAll";
          LeadingTriviaOption2[LeadingTriviaOption2["JSDoc"] = 2] = "JSDoc";
          LeadingTriviaOption2[LeadingTriviaOption2["StartLine"] = 3] = "StartLine";
        })(LeadingTriviaOption = textChanges_3.LeadingTriviaOption || (textChanges_3.LeadingTriviaOption = {}));
        var TrailingTriviaOption;
        (function(TrailingTriviaOption2) {
          TrailingTriviaOption2[TrailingTriviaOption2["Exclude"] = 0] = "Exclude";
          TrailingTriviaOption2[TrailingTriviaOption2["Include"] = 1] = "Include";
        })(TrailingTriviaOption = textChanges_3.TrailingTriviaOption || (textChanges_3.TrailingTriviaOption = {}));
        function skipWhitespacesAndLineBreaks(text, start) {
          return ts2.skipTrivia(text, start, false, true);
        }
        function hasCommentsBeforeLineBreak(text, start) {
          var i = start;
          while (i < text.length) {
            var ch = text.charCodeAt(i);
            if (ts2.isWhiteSpaceSingleLine(ch)) {
              i++;
              continue;
            }
            return ch === 47;
          }
          return false;
        }
        var useNonAdjustedPositions = {
          leadingTriviaOption: LeadingTriviaOption.Exclude,
          trailingTriviaOption: TrailingTriviaOption.Exclude
        };
        var ChangeKind;
        (function(ChangeKind2) {
          ChangeKind2[ChangeKind2["Remove"] = 0] = "Remove";
          ChangeKind2[ChangeKind2["ReplaceWithSingleNode"] = 1] = "ReplaceWithSingleNode";
          ChangeKind2[ChangeKind2["ReplaceWithMultipleNodes"] = 2] = "ReplaceWithMultipleNodes";
          ChangeKind2[ChangeKind2["Text"] = 3] = "Text";
        })(ChangeKind || (ChangeKind = {}));
        function getAdjustedRange(sourceFile, startNode, endNode, options) {
          return { pos: getAdjustedStartPosition(sourceFile, startNode, options), end: getAdjustedEndPosition(sourceFile, endNode, options) };
        }
        function getAdjustedStartPosition(sourceFile, node, options) {
          var leadingTriviaOption = options.leadingTriviaOption;
          if (leadingTriviaOption === LeadingTriviaOption.Exclude) {
            return node.getStart(sourceFile);
          }
          if (leadingTriviaOption === LeadingTriviaOption.StartLine) {
            return ts2.getLineStartPositionForPosition(node.getStart(sourceFile), sourceFile);
          }
          if (leadingTriviaOption === LeadingTriviaOption.JSDoc) {
            var JSDocComments = ts2.getJSDocCommentRanges(node, sourceFile.text);
            if (JSDocComments === null || JSDocComments === void 0 ? void 0 : JSDocComments.length) {
              return ts2.getLineStartPositionForPosition(JSDocComments[0].pos, sourceFile);
            }
          }
          var fullStart = node.getFullStart();
          var start = node.getStart(sourceFile);
          if (fullStart === start) {
            return start;
          }
          var fullStartLine = ts2.getLineStartPositionForPosition(fullStart, sourceFile);
          var startLine = ts2.getLineStartPositionForPosition(start, sourceFile);
          if (startLine === fullStartLine) {
            return leadingTriviaOption === LeadingTriviaOption.IncludeAll ? fullStart : start;
          }
          var nextLineStart = fullStart > 0 ? 1 : 0;
          var adjustedStartPosition = ts2.getStartPositionOfLine(ts2.getLineOfLocalPosition(sourceFile, fullStartLine) + nextLineStart, sourceFile);
          adjustedStartPosition = skipWhitespacesAndLineBreaks(sourceFile.text, adjustedStartPosition);
          return ts2.getStartPositionOfLine(ts2.getLineOfLocalPosition(sourceFile, adjustedStartPosition), sourceFile);
        }
        function getAdjustedEndPosition(sourceFile, node, options) {
          var end = node.end;
          var trailingTriviaOption = options.trailingTriviaOption;
          if (trailingTriviaOption === TrailingTriviaOption.Exclude || ts2.isExpression(node) && trailingTriviaOption !== TrailingTriviaOption.Include) {
            return end;
          }
          var newEnd = ts2.skipTrivia(sourceFile.text, end, true);
          return newEnd !== end && (trailingTriviaOption === TrailingTriviaOption.Include || ts2.isLineBreak(sourceFile.text.charCodeAt(newEnd - 1))) ? newEnd : end;
        }
        function isSeparator(node, candidate) {
          return !!candidate && !!node.parent && (candidate.kind === 27 || candidate.kind === 26 && node.parent.kind === 193);
        }
        function spaces(count) {
          var s = "";
          for (var i = 0; i < count; i++) {
            s += " ";
          }
          return s;
        }
        function isThisTypeAnnotatable(containingFunction) {
          return ts2.isFunctionExpression(containingFunction) || ts2.isFunctionDeclaration(containingFunction);
        }
        textChanges_3.isThisTypeAnnotatable = isThisTypeAnnotatable;
        var ChangeTracker = function() {
          function ChangeTracker2(newLineCharacter, formatContext) {
            this.newLineCharacter = newLineCharacter;
            this.formatContext = formatContext;
            this.changes = [];
            this.newFiles = [];
            this.classesWithNodesInsertedAtStart = ts2.createMap();
            this.deletedNodes = [];
          }
          ChangeTracker2.fromContext = function(context) {
            return new ChangeTracker2(ts2.getNewLineOrDefaultFromHost(context.host, context.formatContext.options), context.formatContext);
          };
          ChangeTracker2.with = function(context, cb) {
            var tracker = ChangeTracker2.fromContext(context);
            cb(tracker);
            return tracker.getChanges();
          };
          ChangeTracker2.prototype.pushRaw = function(sourceFile, change) {
            ts2.Debug.assertEqual(sourceFile.fileName, change.fileName);
            for (var _i = 0, _a = change.textChanges; _i < _a.length; _i++) {
              var c = _a[_i];
              this.changes.push({
                kind: ChangeKind.Text,
                sourceFile,
                text: c.newText,
                range: ts2.createTextRangeFromSpan(c.span)
              });
            }
          };
          ChangeTracker2.prototype.deleteRange = function(sourceFile, range) {
            this.changes.push({ kind: ChangeKind.Remove, sourceFile, range });
          };
          ChangeTracker2.prototype.delete = function(sourceFile, node) {
            this.deletedNodes.push({ sourceFile, node });
          };
          ChangeTracker2.prototype.deleteNode = function(sourceFile, node, options) {
            if (options === void 0) {
              options = { leadingTriviaOption: LeadingTriviaOption.IncludeAll };
            }
            this.deleteRange(sourceFile, getAdjustedRange(sourceFile, node, node, options));
          };
          ChangeTracker2.prototype.deleteModifier = function(sourceFile, modifier) {
            this.deleteRange(sourceFile, { pos: modifier.getStart(sourceFile), end: ts2.skipTrivia(sourceFile.text, modifier.end, true) });
          };
          ChangeTracker2.prototype.deleteNodeRange = function(sourceFile, startNode, endNode, options) {
            if (options === void 0) {
              options = { leadingTriviaOption: LeadingTriviaOption.IncludeAll };
            }
            var startPosition = getAdjustedStartPosition(sourceFile, startNode, options);
            var endPosition = getAdjustedEndPosition(sourceFile, endNode, options);
            this.deleteRange(sourceFile, { pos: startPosition, end: endPosition });
          };
          ChangeTracker2.prototype.deleteNodeRangeExcludingEnd = function(sourceFile, startNode, afterEndNode, options) {
            if (options === void 0) {
              options = { leadingTriviaOption: LeadingTriviaOption.IncludeAll };
            }
            var startPosition = getAdjustedStartPosition(sourceFile, startNode, options);
            var endPosition = afterEndNode === void 0 ? sourceFile.text.length : getAdjustedStartPosition(sourceFile, afterEndNode, options);
            this.deleteRange(sourceFile, { pos: startPosition, end: endPosition });
          };
          ChangeTracker2.prototype.replaceRange = function(sourceFile, range, newNode, options) {
            if (options === void 0) {
              options = {};
            }
            this.changes.push({ kind: ChangeKind.ReplaceWithSingleNode, sourceFile, range, options, node: newNode });
          };
          ChangeTracker2.prototype.replaceNode = function(sourceFile, oldNode, newNode, options) {
            if (options === void 0) {
              options = useNonAdjustedPositions;
            }
            this.replaceRange(sourceFile, getAdjustedRange(sourceFile, oldNode, oldNode, options), newNode, options);
          };
          ChangeTracker2.prototype.replaceNodeRange = function(sourceFile, startNode, endNode, newNode, options) {
            if (options === void 0) {
              options = useNonAdjustedPositions;
            }
            this.replaceRange(sourceFile, getAdjustedRange(sourceFile, startNode, endNode, options), newNode, options);
          };
          ChangeTracker2.prototype.replaceRangeWithNodes = function(sourceFile, range, newNodes, options) {
            if (options === void 0) {
              options = {};
            }
            this.changes.push({ kind: ChangeKind.ReplaceWithMultipleNodes, sourceFile, range, options, nodes: newNodes });
          };
          ChangeTracker2.prototype.replaceNodeWithNodes = function(sourceFile, oldNode, newNodes, options) {
            if (options === void 0) {
              options = useNonAdjustedPositions;
            }
            this.replaceRangeWithNodes(sourceFile, getAdjustedRange(sourceFile, oldNode, oldNode, options), newNodes, options);
          };
          ChangeTracker2.prototype.replaceNodeWithText = function(sourceFile, oldNode, text) {
            this.replaceRangeWithText(sourceFile, getAdjustedRange(sourceFile, oldNode, oldNode, useNonAdjustedPositions), text);
          };
          ChangeTracker2.prototype.replaceNodeRangeWithNodes = function(sourceFile, startNode, endNode, newNodes, options) {
            if (options === void 0) {
              options = useNonAdjustedPositions;
            }
            this.replaceRangeWithNodes(sourceFile, getAdjustedRange(sourceFile, startNode, endNode, options), newNodes, options);
          };
          ChangeTracker2.prototype.nextCommaToken = function(sourceFile, node) {
            var next = ts2.findNextToken(node, node.parent, sourceFile);
            return next && next.kind === 27 ? next : void 0;
          };
          ChangeTracker2.prototype.replacePropertyAssignment = function(sourceFile, oldNode, newNode) {
            var suffix = this.nextCommaToken(sourceFile, oldNode) ? "" : "," + this.newLineCharacter;
            this.replaceNode(sourceFile, oldNode, newNode, { suffix });
          };
          ChangeTracker2.prototype.insertNodeAt = function(sourceFile, pos, newNode, options) {
            if (options === void 0) {
              options = {};
            }
            this.replaceRange(sourceFile, ts2.createRange(pos), newNode, options);
          };
          ChangeTracker2.prototype.insertNodesAt = function(sourceFile, pos, newNodes, options) {
            if (options === void 0) {
              options = {};
            }
            this.replaceRangeWithNodes(sourceFile, ts2.createRange(pos), newNodes, options);
          };
          ChangeTracker2.prototype.insertNodeAtTopOfFile = function(sourceFile, newNode, blankLineBetween) {
            this.insertAtTopOfFile(sourceFile, newNode, blankLineBetween);
          };
          ChangeTracker2.prototype.insertNodesAtTopOfFile = function(sourceFile, newNodes, blankLineBetween) {
            this.insertAtTopOfFile(sourceFile, newNodes, blankLineBetween);
          };
          ChangeTracker2.prototype.insertAtTopOfFile = function(sourceFile, insert, blankLineBetween) {
            var pos = getInsertionPositionAtSourceFileTop(sourceFile);
            var options = {
              prefix: pos === 0 ? void 0 : this.newLineCharacter,
              suffix: (ts2.isLineBreak(sourceFile.text.charCodeAt(pos)) ? "" : this.newLineCharacter) + (blankLineBetween ? this.newLineCharacter : "")
            };
            if (ts2.isArray(insert)) {
              this.insertNodesAt(sourceFile, pos, insert, options);
            } else {
              this.insertNodeAt(sourceFile, pos, insert, options);
            }
          };
          ChangeTracker2.prototype.insertFirstParameter = function(sourceFile, parameters, newParam) {
            var p0 = ts2.firstOrUndefined(parameters);
            if (p0) {
              this.insertNodeBefore(sourceFile, p0, newParam);
            } else {
              this.insertNodeAt(sourceFile, parameters.pos, newParam);
            }
          };
          ChangeTracker2.prototype.insertNodeBefore = function(sourceFile, before, newNode, blankLineBetween) {
            if (blankLineBetween === void 0) {
              blankLineBetween = false;
            }
            this.insertNodeAt(sourceFile, getAdjustedStartPosition(sourceFile, before, {}), newNode, this.getOptionsForInsertNodeBefore(before, newNode, blankLineBetween));
          };
          ChangeTracker2.prototype.insertModifierBefore = function(sourceFile, modifier, before) {
            var pos = before.getStart(sourceFile);
            this.insertNodeAt(sourceFile, pos, ts2.createToken(modifier), { suffix: " " });
          };
          ChangeTracker2.prototype.insertLastModifierBefore = function(sourceFile, modifier, before) {
            if (!before.modifiers) {
              this.insertModifierBefore(sourceFile, modifier, before);
              return;
            }
            var pos = before.modifiers.end;
            this.insertNodeAt(sourceFile, pos, ts2.createToken(modifier), { prefix: " " });
          };
          ChangeTracker2.prototype.insertCommentBeforeLine = function(sourceFile, lineNumber, position, commentText) {
            var lineStartPosition = ts2.getStartPositionOfLine(lineNumber, sourceFile);
            var startPosition = ts2.getFirstNonSpaceCharacterPosition(sourceFile.text, lineStartPosition);
            var insertAtLineStart = isValidLocationToAddComment(sourceFile, startPosition);
            var token = ts2.getTouchingToken(sourceFile, insertAtLineStart ? startPosition : position);
            var indent = sourceFile.text.slice(lineStartPosition, startPosition);
            var text = (insertAtLineStart ? "" : this.newLineCharacter) + "//" + commentText + this.newLineCharacter + indent;
            this.insertText(sourceFile, token.getStart(sourceFile), text);
          };
          ChangeTracker2.prototype.insertJsdocCommentBefore = function(sourceFile, node, tag) {
            var fnStart = node.getStart(sourceFile);
            if (node.jsDoc) {
              for (var _i = 0, _a = node.jsDoc; _i < _a.length; _i++) {
                var jsdoc = _a[_i];
                this.deleteRange(sourceFile, {
                  pos: ts2.getLineStartPositionForPosition(jsdoc.getStart(sourceFile), sourceFile),
                  end: getAdjustedEndPosition(sourceFile, jsdoc, {})
                });
              }
            }
            var startPosition = ts2.getPrecedingNonSpaceCharacterPosition(sourceFile.text, fnStart - 1);
            var indent = sourceFile.text.slice(startPosition, fnStart);
            this.insertNodeAt(sourceFile, fnStart, tag, { preserveLeadingWhitespace: false, suffix: this.newLineCharacter + indent });
          };
          ChangeTracker2.prototype.replaceRangeWithText = function(sourceFile, range, text) {
            this.changes.push({ kind: ChangeKind.Text, sourceFile, range, text });
          };
          ChangeTracker2.prototype.insertText = function(sourceFile, pos, text) {
            this.replaceRangeWithText(sourceFile, ts2.createRange(pos), text);
          };
          ChangeTracker2.prototype.tryInsertTypeAnnotation = function(sourceFile, node, type) {
            var _a;
            var endNode;
            if (ts2.isFunctionLike(node)) {
              endNode = ts2.findChildOfKind(node, 21, sourceFile);
              if (!endNode) {
                if (!ts2.isArrowFunction(node))
                  return false;
                endNode = ts2.first(node.parameters);
              }
            } else {
              endNode = (_a = node.kind === 242 ? node.exclamationToken : node.questionToken) !== null && _a !== void 0 ? _a : node.name;
            }
            this.insertNodeAt(sourceFile, endNode.end, type, { prefix: ": " });
            return true;
          };
          ChangeTracker2.prototype.tryInsertThisTypeAnnotation = function(sourceFile, node, type) {
            var start = ts2.findChildOfKind(node, 20, sourceFile).getStart(sourceFile) + 1;
            var suffix = node.parameters.length ? ", " : "";
            this.insertNodeAt(sourceFile, start, type, { prefix: "this: ", suffix });
          };
          ChangeTracker2.prototype.insertTypeParameters = function(sourceFile, node, typeParameters) {
            var start = (ts2.findChildOfKind(node, 20, sourceFile) || ts2.first(node.parameters)).getStart(sourceFile);
            this.insertNodesAt(sourceFile, start, typeParameters, { prefix: "<", suffix: ">" });
          };
          ChangeTracker2.prototype.getOptionsForInsertNodeBefore = function(before, inserted, doubleNewlines) {
            if (ts2.isStatement(before) || ts2.isClassElement(before)) {
              return { suffix: doubleNewlines ? this.newLineCharacter + this.newLineCharacter : this.newLineCharacter };
            } else if (ts2.isVariableDeclaration(before)) {
              return { suffix: ", " };
            } else if (ts2.isParameter(before)) {
              return ts2.isParameter(inserted) ? { suffix: ", " } : {};
            } else if (ts2.isStringLiteral(before) && ts2.isImportDeclaration(before.parent) || ts2.isNamedImports(before)) {
              return { suffix: ", " };
            }
            return ts2.Debug.failBadSyntaxKind(before);
          };
          ChangeTracker2.prototype.insertNodeAtConstructorStart = function(sourceFile, ctr, newStatement) {
            var firstStatement = ts2.firstOrUndefined(ctr.body.statements);
            if (!firstStatement || !ctr.body.multiLine) {
              this.replaceConstructorBody(sourceFile, ctr, __spreadArrays([newStatement], ctr.body.statements));
            } else {
              this.insertNodeBefore(sourceFile, firstStatement, newStatement);
            }
          };
          ChangeTracker2.prototype.insertNodeAtConstructorEnd = function(sourceFile, ctr, newStatement) {
            var lastStatement = ts2.lastOrUndefined(ctr.body.statements);
            if (!lastStatement || !ctr.body.multiLine) {
              this.replaceConstructorBody(sourceFile, ctr, __spreadArrays(ctr.body.statements, [newStatement]));
            } else {
              this.insertNodeAfter(sourceFile, lastStatement, newStatement);
            }
          };
          ChangeTracker2.prototype.replaceConstructorBody = function(sourceFile, ctr, statements) {
            this.replaceNode(sourceFile, ctr.body, ts2.createBlock(statements, true));
          };
          ChangeTracker2.prototype.insertNodeAtEndOfScope = function(sourceFile, scope, newNode) {
            var pos = getAdjustedStartPosition(sourceFile, scope.getLastToken(), {});
            this.insertNodeAt(sourceFile, pos, newNode, {
              prefix: ts2.isLineBreak(sourceFile.text.charCodeAt(scope.getLastToken().pos)) ? this.newLineCharacter : this.newLineCharacter + this.newLineCharacter,
              suffix: this.newLineCharacter
            });
          };
          ChangeTracker2.prototype.insertNodeAtClassStart = function(sourceFile, cls, newElement) {
            this.insertNodeAtStartWorker(sourceFile, cls, newElement);
          };
          ChangeTracker2.prototype.insertNodeAtObjectStart = function(sourceFile, obj, newElement) {
            this.insertNodeAtStartWorker(sourceFile, obj, newElement);
          };
          ChangeTracker2.prototype.insertNodeAtStartWorker = function(sourceFile, cls, newElement) {
            var _a;
            var indentation = (_a = this.guessIndentationFromExistingMembers(sourceFile, cls)) !== null && _a !== void 0 ? _a : this.computeIndentationForNewMember(sourceFile, cls);
            this.insertNodeAt(sourceFile, getMembersOrProperties(cls).pos, newElement, this.getInsertNodeAtStartInsertOptions(sourceFile, cls, indentation));
          };
          ChangeTracker2.prototype.guessIndentationFromExistingMembers = function(sourceFile, cls) {
            var indentation;
            var lastRange = cls;
            for (var _i = 0, _a = getMembersOrProperties(cls); _i < _a.length; _i++) {
              var member = _a[_i];
              if (ts2.rangeStartPositionsAreOnSameLine(lastRange, member, sourceFile)) {
                return void 0;
              }
              var memberStart = member.getStart(sourceFile);
              var memberIndentation = ts2.formatting.SmartIndenter.findFirstNonWhitespaceColumn(ts2.getLineStartPositionForPosition(memberStart, sourceFile), memberStart, sourceFile, this.formatContext.options);
              if (indentation === void 0) {
                indentation = memberIndentation;
              } else if (memberIndentation !== indentation) {
                return void 0;
              }
              lastRange = member;
            }
            return indentation;
          };
          ChangeTracker2.prototype.computeIndentationForNewMember = function(sourceFile, cls) {
            var _a;
            var clsStart = cls.getStart(sourceFile);
            return ts2.formatting.SmartIndenter.findFirstNonWhitespaceColumn(ts2.getLineStartPositionForPosition(clsStart, sourceFile), clsStart, sourceFile, this.formatContext.options) + ((_a = this.formatContext.options.indentSize) !== null && _a !== void 0 ? _a : 4);
          };
          ChangeTracker2.prototype.getInsertNodeAtStartInsertOptions = function(sourceFile, cls, indentation) {
            var members = getMembersOrProperties(cls);
            var isEmpty = members.length === 0;
            var isFirstInsertion = ts2.addToSeen(this.classesWithNodesInsertedAtStart, ts2.getNodeId(cls), { node: cls, sourceFile });
            var insertTrailingComma = ts2.isObjectLiteralExpression(cls) && (!ts2.isJsonSourceFile(sourceFile) || !isEmpty);
            var insertLeadingComma = ts2.isObjectLiteralExpression(cls) && ts2.isJsonSourceFile(sourceFile) && isEmpty && !isFirstInsertion;
            return {
              indentation,
              prefix: (insertLeadingComma ? "," : "") + this.newLineCharacter,
              suffix: insertTrailingComma ? "," : ""
            };
          };
          ChangeTracker2.prototype.insertNodeAfterComma = function(sourceFile, after, newNode) {
            var endPosition = this.insertNodeAfterWorker(sourceFile, this.nextCommaToken(sourceFile, after) || after, newNode);
            this.insertNodeAt(sourceFile, endPosition, newNode, this.getInsertNodeAfterOptions(sourceFile, after));
          };
          ChangeTracker2.prototype.insertNodeAfter = function(sourceFile, after, newNode) {
            var endPosition = this.insertNodeAfterWorker(sourceFile, after, newNode);
            this.insertNodeAt(sourceFile, endPosition, newNode, this.getInsertNodeAfterOptions(sourceFile, after));
          };
          ChangeTracker2.prototype.insertNodeAtEndOfList = function(sourceFile, list, newNode) {
            this.insertNodeAt(sourceFile, list.end, newNode, { prefix: ", " });
          };
          ChangeTracker2.prototype.insertNodesAfter = function(sourceFile, after, newNodes) {
            var endPosition = this.insertNodeAfterWorker(sourceFile, after, ts2.first(newNodes));
            this.insertNodesAt(sourceFile, endPosition, newNodes, this.getInsertNodeAfterOptions(sourceFile, after));
          };
          ChangeTracker2.prototype.insertNodeAfterWorker = function(sourceFile, after, newNode) {
            if (needSemicolonBetween(after, newNode)) {
              if (sourceFile.text.charCodeAt(after.end - 1) !== 59) {
                this.replaceRange(sourceFile, ts2.createRange(after.end), ts2.createToken(26));
              }
            }
            var endPosition = getAdjustedEndPosition(sourceFile, after, {});
            return endPosition;
          };
          ChangeTracker2.prototype.getInsertNodeAfterOptions = function(sourceFile, after) {
            var options = this.getInsertNodeAfterOptionsWorker(after);
            return __assign(__assign({}, options), { prefix: after.end === sourceFile.end && ts2.isStatement(after) ? options.prefix ? "\n" + options.prefix : "\n" : options.prefix });
          };
          ChangeTracker2.prototype.getInsertNodeAfterOptionsWorker = function(node) {
            switch (node.kind) {
              case 245:
              case 249:
                return { prefix: this.newLineCharacter, suffix: this.newLineCharacter };
              case 242:
              case 10:
              case 75:
                return { prefix: ", " };
              case 281:
                return { suffix: "," + this.newLineCharacter };
              case 89:
                return { prefix: " " };
              case 156:
                return {};
              default:
                ts2.Debug.assert(ts2.isStatement(node) || ts2.isClassOrTypeElement(node));
                return { suffix: this.newLineCharacter };
            }
          };
          ChangeTracker2.prototype.insertName = function(sourceFile, node, name) {
            ts2.Debug.assert(!node.name);
            if (node.kind === 202) {
              var arrow = ts2.findChildOfKind(node, 38, sourceFile);
              var lparen = ts2.findChildOfKind(node, 20, sourceFile);
              if (lparen) {
                this.insertNodesAt(sourceFile, lparen.getStart(sourceFile), [ts2.createToken(94), ts2.createIdentifier(name)], { joiner: " " });
                deleteNode(this, sourceFile, arrow);
              } else {
                this.insertText(sourceFile, ts2.first(node.parameters).getStart(sourceFile), "function " + name + "(");
                this.replaceRange(sourceFile, arrow, ts2.createToken(21));
              }
              if (node.body.kind !== 223) {
                this.insertNodesAt(sourceFile, node.body.getStart(sourceFile), [ts2.createToken(18), ts2.createToken(101)], { joiner: " ", suffix: " " });
                this.insertNodesAt(sourceFile, node.body.end, [ts2.createToken(26), ts2.createToken(19)], { joiner: " " });
              }
            } else {
              var pos = ts2.findChildOfKind(node, node.kind === 201 ? 94 : 80, sourceFile).end;
              this.insertNodeAt(sourceFile, pos, ts2.createIdentifier(name), { prefix: " " });
            }
          };
          ChangeTracker2.prototype.insertExportModifier = function(sourceFile, node) {
            this.insertText(sourceFile, node.getStart(sourceFile), "export ");
          };
          ChangeTracker2.prototype.insertNodeInListAfter = function(sourceFile, after, newNode, containingList) {
            if (containingList === void 0) {
              containingList = ts2.formatting.SmartIndenter.getContainingList(after, sourceFile);
            }
            if (!containingList) {
              ts2.Debug.fail("node is not a list element");
              return;
            }
            var index = ts2.indexOfNode(containingList, after);
            if (index < 0) {
              return;
            }
            var end = after.getEnd();
            if (index !== containingList.length - 1) {
              var nextToken = ts2.getTokenAtPosition(sourceFile, after.end);
              if (nextToken && isSeparator(after, nextToken)) {
                var lineAndCharOfNextElement = ts2.getLineAndCharacterOfPosition(sourceFile, skipWhitespacesAndLineBreaks(sourceFile.text, containingList[index + 1].getFullStart()));
                var lineAndCharOfNextToken = ts2.getLineAndCharacterOfPosition(sourceFile, nextToken.end);
                var prefix = void 0;
                var startPos = void 0;
                if (lineAndCharOfNextToken.line === lineAndCharOfNextElement.line) {
                  startPos = nextToken.end;
                  prefix = spaces(lineAndCharOfNextElement.character - lineAndCharOfNextToken.character);
                } else {
                  startPos = ts2.getStartPositionOfLine(lineAndCharOfNextElement.line, sourceFile);
                }
                var suffix = "" + ts2.tokenToString(nextToken.kind) + sourceFile.text.substring(nextToken.end, containingList[index + 1].getStart(sourceFile));
                this.replaceRange(sourceFile, ts2.createRange(startPos, containingList[index + 1].getStart(sourceFile)), newNode, { prefix, suffix });
              }
            } else {
              var afterStart = after.getStart(sourceFile);
              var afterStartLinePosition = ts2.getLineStartPositionForPosition(afterStart, sourceFile);
              var separator = void 0;
              var multilineList = false;
              if (containingList.length === 1) {
                separator = 27;
              } else {
                var tokenBeforeInsertPosition = ts2.findPrecedingToken(after.pos, sourceFile);
                separator = isSeparator(after, tokenBeforeInsertPosition) ? tokenBeforeInsertPosition.kind : 27;
                var afterMinusOneStartLinePosition = ts2.getLineStartPositionForPosition(containingList[index - 1].getStart(sourceFile), sourceFile);
                multilineList = afterMinusOneStartLinePosition !== afterStartLinePosition;
              }
              if (hasCommentsBeforeLineBreak(sourceFile.text, after.end)) {
                multilineList = true;
              }
              if (multilineList) {
                this.replaceRange(sourceFile, ts2.createRange(end), ts2.createToken(separator));
                var indentation = ts2.formatting.SmartIndenter.findFirstNonWhitespaceColumn(afterStartLinePosition, afterStart, sourceFile, this.formatContext.options);
                var insertPos = ts2.skipTrivia(sourceFile.text, end, true, false);
                if (insertPos !== end && ts2.isLineBreak(sourceFile.text.charCodeAt(insertPos - 1))) {
                  insertPos--;
                }
                this.replaceRange(sourceFile, ts2.createRange(insertPos), newNode, { indentation, prefix: this.newLineCharacter });
              } else {
                this.replaceRange(sourceFile, ts2.createRange(end), newNode, { prefix: ts2.tokenToString(separator) + " " });
              }
            }
          };
          ChangeTracker2.prototype.parenthesizeExpression = function(sourceFile, expression) {
            this.replaceRange(sourceFile, ts2.rangeOfNode(expression), ts2.createParen(expression));
          };
          ChangeTracker2.prototype.finishClassesWithNodesInsertedAtStart = function() {
            var _this = this;
            this.classesWithNodesInsertedAtStart.forEach(function(_a) {
              var node = _a.node, sourceFile = _a.sourceFile;
              var _b = getClassOrObjectBraceEnds(node, sourceFile), openBraceEnd = _b[0], closeBraceEnd = _b[1];
              if (openBraceEnd !== void 0 && closeBraceEnd !== void 0) {
                var isEmpty = getMembersOrProperties(node).length === 0;
                var isSingleLine = ts2.positionsAreOnSameLine(openBraceEnd, closeBraceEnd, sourceFile);
                if (isEmpty && isSingleLine && openBraceEnd !== closeBraceEnd - 1) {
                  _this.deleteRange(sourceFile, ts2.createRange(openBraceEnd, closeBraceEnd - 1));
                }
                if (isSingleLine) {
                  _this.insertText(sourceFile, closeBraceEnd - 1, _this.newLineCharacter);
                }
              }
            });
          };
          ChangeTracker2.prototype.finishDeleteDeclarations = function() {
            var _this = this;
            var deletedNodesInLists = new ts2.NodeSet();
            var _loop_9 = function(sourceFile2, node2) {
              if (!this_1.deletedNodes.some(function(d) {
                return d.sourceFile === sourceFile2 && ts2.rangeContainsRangeExclusive(d.node, node2);
              })) {
                if (ts2.isArray(node2)) {
                  this_1.deleteRange(sourceFile2, ts2.rangeOfTypeParameters(node2));
                } else {
                  deleteDeclaration.deleteDeclaration(this_1, deletedNodesInLists, sourceFile2, node2);
                }
              }
            };
            var this_1 = this;
            for (var _i = 0, _a = this.deletedNodes; _i < _a.length; _i++) {
              var _b = _a[_i], sourceFile = _b.sourceFile, node = _b.node;
              _loop_9(sourceFile, node);
            }
            deletedNodesInLists.forEach(function(node2) {
              var sourceFile2 = node2.getSourceFile();
              var list = ts2.formatting.SmartIndenter.getContainingList(node2, sourceFile2);
              if (node2 !== ts2.last(list))
                return;
              var lastNonDeletedIndex = ts2.findLastIndex(list, function(n) {
                return !deletedNodesInLists.has(n);
              }, list.length - 2);
              if (lastNonDeletedIndex !== -1) {
                _this.deleteRange(sourceFile2, { pos: list[lastNonDeletedIndex].end, end: startPositionToDeleteNodeInList(sourceFile2, list[lastNonDeletedIndex + 1]) });
              }
            });
          };
          ChangeTracker2.prototype.getChanges = function(validate) {
            this.finishDeleteDeclarations();
            this.finishClassesWithNodesInsertedAtStart();
            var changes = changesToText.getTextChangesFromChanges(this.changes, this.newLineCharacter, this.formatContext, validate);
            for (var _i = 0, _a = this.newFiles; _i < _a.length; _i++) {
              var _b = _a[_i], oldFile = _b.oldFile, fileName = _b.fileName, statements = _b.statements;
              changes.push(changesToText.newFileChanges(oldFile, fileName, statements, this.newLineCharacter, this.formatContext));
            }
            return changes;
          };
          ChangeTracker2.prototype.createNewFile = function(oldFile, fileName, statements) {
            this.newFiles.push({ oldFile, fileName, statements });
          };
          return ChangeTracker2;
        }();
        textChanges_3.ChangeTracker = ChangeTracker;
        function startPositionToDeleteNodeInList(sourceFile, node) {
          return ts2.skipTrivia(sourceFile.text, getAdjustedStartPosition(sourceFile, node, { leadingTriviaOption: LeadingTriviaOption.IncludeAll }), false, true);
        }
        function getClassOrObjectBraceEnds(cls, sourceFile) {
          var open = ts2.findChildOfKind(cls, 18, sourceFile);
          var close = ts2.findChildOfKind(cls, 19, sourceFile);
          return [open === null || open === void 0 ? void 0 : open.end, close === null || close === void 0 ? void 0 : close.end];
        }
        function getMembersOrProperties(cls) {
          return ts2.isObjectLiteralExpression(cls) ? cls.properties : cls.members;
        }
        function getNewFileText(statements, scriptKind, newLineCharacter, formatContext) {
          return changesToText.newFileChangesWorker(void 0, scriptKind, statements, newLineCharacter, formatContext);
        }
        textChanges_3.getNewFileText = getNewFileText;
        var changesToText;
        (function(changesToText2) {
          function getTextChangesFromChanges(changes, newLineCharacter, formatContext, validate) {
            return ts2.mapDefined(ts2.group(changes, function(c) {
              return c.sourceFile.path;
            }), function(changesInFile) {
              var sourceFile = changesInFile[0].sourceFile;
              var normalized = ts2.stableSort(changesInFile, function(a, b) {
                return a.range.pos - b.range.pos || a.range.end - b.range.end;
              });
              var _loop_10 = function(i2) {
                ts2.Debug.assert(normalized[i2].range.end <= normalized[i2 + 1].range.pos, "Changes overlap", function() {
                  return JSON.stringify(normalized[i2].range) + " and " + JSON.stringify(normalized[i2 + 1].range);
                });
              };
              for (var i = 0; i < normalized.length - 1; i++) {
                _loop_10(i);
              }
              var textChanges2 = ts2.mapDefined(normalized, function(c) {
                var span = ts2.createTextSpanFromRange(c.range);
                var newText = computeNewText(c, sourceFile, newLineCharacter, formatContext, validate);
                if (span.length === newText.length && ts2.stringContainsAt(sourceFile.text, newText, span.start)) {
                  return void 0;
                }
                return ts2.createTextChange(span, newText);
              });
              return textChanges2.length > 0 ? { fileName: sourceFile.fileName, textChanges: textChanges2 } : void 0;
            });
          }
          changesToText2.getTextChangesFromChanges = getTextChangesFromChanges;
          function newFileChanges(oldFile, fileName, statements, newLineCharacter, formatContext) {
            var text = newFileChangesWorker(oldFile, ts2.getScriptKindFromFileName(fileName), statements, newLineCharacter, formatContext);
            return { fileName, textChanges: [ts2.createTextChange(ts2.createTextSpan(0, 0), text)], isNewFile: true };
          }
          changesToText2.newFileChanges = newFileChanges;
          function newFileChangesWorker(oldFile, scriptKind, statements, newLineCharacter, formatContext) {
            var nonFormattedText = statements.map(function(s) {
              return getNonformattedText(s, oldFile, newLineCharacter).text;
            }).join(newLineCharacter);
            var sourceFile = ts2.createSourceFile("any file name", nonFormattedText, 99, true, scriptKind);
            var changes = ts2.formatting.formatDocument(sourceFile, formatContext);
            return applyChanges(nonFormattedText, changes) + newLineCharacter;
          }
          changesToText2.newFileChangesWorker = newFileChangesWorker;
          function computeNewText(change, sourceFile, newLineCharacter, formatContext, validate) {
            if (change.kind === ChangeKind.Remove) {
              return "";
            }
            if (change.kind === ChangeKind.Text) {
              return change.text;
            }
            var _a = change.options, options = _a === void 0 ? {} : _a, pos = change.range.pos;
            var format = function(n) {
              return getFormattedTextOfNode(n, sourceFile, pos, options, newLineCharacter, formatContext, validate);
            };
            var text = change.kind === ChangeKind.ReplaceWithMultipleNodes ? change.nodes.map(function(n) {
              return ts2.removeSuffix(format(n), newLineCharacter);
            }).join(change.options.joiner || newLineCharacter) : format(change.node);
            var noIndent = options.preserveLeadingWhitespace || options.indentation !== void 0 || ts2.getLineStartPositionForPosition(pos, sourceFile) === pos ? text : text.replace(/^\s+/, "");
            return (options.prefix || "") + noIndent + (!options.suffix || ts2.endsWith(noIndent, options.suffix) ? "" : options.suffix);
          }
          function getFormatCodeSettingsForWriting(_a, sourceFile) {
            var options = _a.options;
            var shouldAutoDetectSemicolonPreference = !options.semicolons || options.semicolons === ts2.SemicolonPreference.Ignore;
            var shouldRemoveSemicolons = options.semicolons === ts2.SemicolonPreference.Remove || shouldAutoDetectSemicolonPreference && !ts2.probablyUsesSemicolons(sourceFile);
            return __assign(__assign({}, options), { semicolons: shouldRemoveSemicolons ? ts2.SemicolonPreference.Remove : ts2.SemicolonPreference.Ignore });
          }
          function getFormattedTextOfNode(nodeIn, sourceFile, pos, _a, newLineCharacter, formatContext, validate) {
            var indentation = _a.indentation, prefix = _a.prefix, delta = _a.delta;
            var _b = getNonformattedText(nodeIn, sourceFile, newLineCharacter), node = _b.node, text = _b.text;
            if (validate)
              validate(node, text);
            var formatOptions = getFormatCodeSettingsForWriting(formatContext, sourceFile);
            var initialIndentation = indentation !== void 0 ? indentation : ts2.formatting.SmartIndenter.getIndentation(pos, sourceFile, formatOptions, prefix === newLineCharacter || ts2.getLineStartPositionForPosition(pos, sourceFile) === pos);
            if (delta === void 0) {
              delta = ts2.formatting.SmartIndenter.shouldIndentChildNode(formatOptions, nodeIn) ? formatOptions.indentSize || 0 : 0;
            }
            var file = { text, getLineAndCharacterOfPosition: function(pos2) {
              return ts2.getLineAndCharacterOfPosition(this, pos2);
            } };
            var changes = ts2.formatting.formatNodeGivenIndentation(node, file, sourceFile.languageVariant, initialIndentation, delta, __assign(__assign({}, formatContext), { options: formatOptions }));
            return applyChanges(text, changes);
          }
          function getNonformattedText(node, sourceFile, newLineCharacter) {
            var writer = createWriter(newLineCharacter);
            var newLine = newLineCharacter === "\n" ? 1 : 0;
            ts2.createPrinter({ newLine, neverAsciiEscape: true, preserveSourceNewlines: true }, writer).writeNode(4, node, sourceFile, writer);
            return { text: writer.getText(), node: assignPositionsToNode(node) };
          }
          changesToText2.getNonformattedText = getNonformattedText;
        })(changesToText || (changesToText = {}));
        function applyChanges(text, changes) {
          for (var i = changes.length - 1; i >= 0; i--) {
            var _a = changes[i], span = _a.span, newText = _a.newText;
            text = "" + text.substring(0, span.start) + newText + text.substring(ts2.textSpanEnd(span));
          }
          return text;
        }
        textChanges_3.applyChanges = applyChanges;
        function isTrivia(s) {
          return ts2.skipTrivia(s, 0) === s.length;
        }
        function assignPositionsToNode(node) {
          var visited = ts2.visitEachChild(node, assignPositionsToNode, ts2.nullTransformationContext, assignPositionsToNodeArray, assignPositionsToNode);
          var newNode = ts2.nodeIsSynthesized(visited) ? visited : Object.create(visited);
          newNode.pos = getPos(node);
          newNode.end = getEnd(node);
          return newNode;
        }
        function assignPositionsToNodeArray(nodes, visitor, test, start, count) {
          var visited = ts2.visitNodes(nodes, visitor, test, start, count);
          if (!visited) {
            return visited;
          }
          var nodeArray = visited === nodes ? ts2.createNodeArray(visited.slice(0)) : visited;
          nodeArray.pos = getPos(nodes);
          nodeArray.end = getEnd(nodes);
          return nodeArray;
        }
        function createWriter(newLine) {
          var lastNonTriviaPosition = 0;
          var writer = ts2.createTextWriter(newLine);
          var onEmitNode = function(hint, node, printCallback) {
            if (node) {
              setPos(node, lastNonTriviaPosition);
            }
            printCallback(hint, node);
            if (node) {
              setEnd(node, lastNonTriviaPosition);
            }
          };
          var onBeforeEmitNodeArray = function(nodes) {
            if (nodes) {
              setPos(nodes, lastNonTriviaPosition);
            }
          };
          var onAfterEmitNodeArray = function(nodes) {
            if (nodes) {
              setEnd(nodes, lastNonTriviaPosition);
            }
          };
          var onBeforeEmitToken = function(node) {
            if (node) {
              setPos(node, lastNonTriviaPosition);
            }
          };
          var onAfterEmitToken = function(node) {
            if (node) {
              setEnd(node, lastNonTriviaPosition);
            }
          };
          function setLastNonTriviaPosition(s, force) {
            if (force || !isTrivia(s)) {
              lastNonTriviaPosition = writer.getTextPos();
              var i = 0;
              while (ts2.isWhiteSpaceLike(s.charCodeAt(s.length - i - 1))) {
                i++;
              }
              lastNonTriviaPosition -= i;
            }
          }
          function write(s) {
            writer.write(s);
            setLastNonTriviaPosition(s, false);
          }
          function writeComment(s) {
            writer.writeComment(s);
          }
          function writeKeyword(s) {
            writer.writeKeyword(s);
            setLastNonTriviaPosition(s, false);
          }
          function writeOperator(s) {
            writer.writeOperator(s);
            setLastNonTriviaPosition(s, false);
          }
          function writePunctuation(s) {
            writer.writePunctuation(s);
            setLastNonTriviaPosition(s, false);
          }
          function writeTrailingSemicolon(s) {
            writer.writeTrailingSemicolon(s);
            setLastNonTriviaPosition(s, false);
          }
          function writeParameter(s) {
            writer.writeParameter(s);
            setLastNonTriviaPosition(s, false);
          }
          function writeProperty(s) {
            writer.writeProperty(s);
            setLastNonTriviaPosition(s, false);
          }
          function writeSpace(s) {
            writer.writeSpace(s);
            setLastNonTriviaPosition(s, false);
          }
          function writeStringLiteral(s) {
            writer.writeStringLiteral(s);
            setLastNonTriviaPosition(s, false);
          }
          function writeSymbol(s, sym) {
            writer.writeSymbol(s, sym);
            setLastNonTriviaPosition(s, false);
          }
          function writeLine(force) {
            writer.writeLine(force);
          }
          function increaseIndent() {
            writer.increaseIndent();
          }
          function decreaseIndent() {
            writer.decreaseIndent();
          }
          function getText() {
            return writer.getText();
          }
          function rawWrite(s) {
            writer.rawWrite(s);
            setLastNonTriviaPosition(s, false);
          }
          function writeLiteral(s) {
            writer.writeLiteral(s);
            setLastNonTriviaPosition(s, true);
          }
          function getTextPos() {
            return writer.getTextPos();
          }
          function getLine() {
            return writer.getLine();
          }
          function getColumn() {
            return writer.getColumn();
          }
          function getIndent() {
            return writer.getIndent();
          }
          function isAtStartOfLine() {
            return writer.isAtStartOfLine();
          }
          function clear() {
            writer.clear();
            lastNonTriviaPosition = 0;
          }
          return {
            onEmitNode,
            onBeforeEmitNodeArray,
            onAfterEmitNodeArray,
            onBeforeEmitToken,
            onAfterEmitToken,
            write,
            writeComment,
            writeKeyword,
            writeOperator,
            writePunctuation,
            writeTrailingSemicolon,
            writeParameter,
            writeProperty,
            writeSpace,
            writeStringLiteral,
            writeSymbol,
            writeLine,
            increaseIndent,
            decreaseIndent,
            getText,
            rawWrite,
            writeLiteral,
            getTextPos,
            getLine,
            getColumn,
            getIndent,
            isAtStartOfLine,
            hasTrailingComment: function() {
              return writer.hasTrailingComment();
            },
            hasTrailingWhitespace: function() {
              return writer.hasTrailingWhitespace();
            },
            clear
          };
        }
        function getInsertionPositionAtSourceFileTop(sourceFile) {
          var lastPrologue;
          for (var _i = 0, _a = sourceFile.statements; _i < _a.length; _i++) {
            var node = _a[_i];
            if (ts2.isPrologueDirective(node)) {
              lastPrologue = node;
            } else {
              break;
            }
          }
          var position = 0;
          var text = sourceFile.text;
          if (lastPrologue) {
            position = lastPrologue.end;
            advancePastLineBreak();
            return position;
          }
          var shebang = ts2.getShebang(text);
          if (shebang !== void 0) {
            position = shebang.length;
            advancePastLineBreak();
          }
          var ranges = ts2.getLeadingCommentRanges(text, position);
          if (!ranges)
            return position;
          var lastComment;
          var firstNodeLine;
          for (var _b = 0, ranges_1 = ranges; _b < ranges_1.length; _b++) {
            var range = ranges_1[_b];
            if (range.kind === 3) {
              if (ts2.isPinnedComment(text, range.pos)) {
                lastComment = { range, pinnedOrTripleSlash: true };
                continue;
              }
            } else if (ts2.isRecognizedTripleSlashComment(text, range.pos, range.end)) {
              lastComment = { range, pinnedOrTripleSlash: true };
              continue;
            }
            if (lastComment) {
              if (lastComment.pinnedOrTripleSlash)
                break;
              var commentLine = sourceFile.getLineAndCharacterOfPosition(range.pos).line;
              var lastCommentEndLine = sourceFile.getLineAndCharacterOfPosition(lastComment.range.end).line;
              if (commentLine >= lastCommentEndLine + 2)
                break;
            }
            if (sourceFile.statements.length) {
              if (firstNodeLine === void 0)
                firstNodeLine = sourceFile.getLineAndCharacterOfPosition(sourceFile.statements[0].getStart()).line;
              var commentEndLine = sourceFile.getLineAndCharacterOfPosition(range.end).line;
              if (firstNodeLine < commentEndLine + 2)
                break;
            }
            lastComment = { range, pinnedOrTripleSlash: false };
          }
          if (lastComment) {
            position = lastComment.range.end;
            advancePastLineBreak();
          }
          return position;
          function advancePastLineBreak() {
            if (position < text.length) {
              var charCode = text.charCodeAt(position);
              if (ts2.isLineBreak(charCode)) {
                position++;
                if (position < text.length && charCode === 13 && text.charCodeAt(position) === 10) {
                  position++;
                }
              }
            }
          }
        }
        function isValidLocationToAddComment(sourceFile, position) {
          return !ts2.isInComment(sourceFile, position) && !ts2.isInString(sourceFile, position) && !ts2.isInTemplateString(sourceFile, position) && !ts2.isInJSXText(sourceFile, position);
        }
        textChanges_3.isValidLocationToAddComment = isValidLocationToAddComment;
        function needSemicolonBetween(a, b) {
          return (ts2.isPropertySignature(a) || ts2.isPropertyDeclaration(a)) && ts2.isClassOrTypeElement(b) && b.name.kind === 154 || ts2.isStatementButNotDeclaration(a) && ts2.isStatementButNotDeclaration(b);
        }
        var deleteDeclaration;
        (function(deleteDeclaration_1) {
          function deleteDeclaration2(changes, deletedNodesInLists, sourceFile, node) {
            switch (node.kind) {
              case 156: {
                var oldFunction = node.parent;
                if (ts2.isArrowFunction(oldFunction) && oldFunction.parameters.length === 1 && !ts2.findChildOfKind(oldFunction, 20, sourceFile)) {
                  changes.replaceNodeWithText(sourceFile, node, "()");
                } else {
                  deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
                }
                break;
              }
              case 254:
              case 253:
                var isFirstImport = sourceFile.imports.length && node === ts2.first(sourceFile.imports).parent || node === ts2.find(sourceFile.statements, ts2.isAnyImportSyntax);
                deleteNode(changes, sourceFile, node, { leadingTriviaOption: isFirstImport ? LeadingTriviaOption.Exclude : ts2.hasJSDocNodes(node) ? LeadingTriviaOption.JSDoc : LeadingTriviaOption.StartLine });
                break;
              case 191:
                var pattern = node.parent;
                var preserveComma = pattern.kind === 190 && node !== ts2.last(pattern.elements);
                if (preserveComma) {
                  deleteNode(changes, sourceFile, node);
                } else {
                  deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
                }
                break;
              case 242:
                deleteVariableDeclaration(changes, deletedNodesInLists, sourceFile, node);
                break;
              case 155:
                deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
                break;
              case 258:
                var namedImports = node.parent;
                if (namedImports.elements.length === 1) {
                  deleteImportBinding(changes, sourceFile, namedImports);
                } else {
                  deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
                }
                break;
              case 256:
                deleteImportBinding(changes, sourceFile, node);
                break;
              case 26:
                deleteNode(changes, sourceFile, node, { trailingTriviaOption: TrailingTriviaOption.Exclude });
                break;
              case 94:
                deleteNode(changes, sourceFile, node, { leadingTriviaOption: LeadingTriviaOption.Exclude });
                break;
              case 245:
              case 244:
                deleteNode(changes, sourceFile, node, { leadingTriviaOption: ts2.hasJSDocNodes(node) ? LeadingTriviaOption.JSDoc : LeadingTriviaOption.StartLine });
                break;
              default:
                if (ts2.isImportClause(node.parent) && node.parent.name === node) {
                  deleteDefaultImport(changes, sourceFile, node.parent);
                } else if (ts2.isCallExpression(node.parent) && ts2.contains(node.parent.arguments, node)) {
                  deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
                } else {
                  deleteNode(changes, sourceFile, node);
                }
            }
          }
          deleteDeclaration_1.deleteDeclaration = deleteDeclaration2;
          function deleteDefaultImport(changes, sourceFile, importClause) {
            if (!importClause.namedBindings) {
              deleteNode(changes, sourceFile, importClause.parent);
            } else {
              var start = importClause.name.getStart(sourceFile);
              var nextToken = ts2.getTokenAtPosition(sourceFile, importClause.name.end);
              if (nextToken && nextToken.kind === 27) {
                var end = ts2.skipTrivia(sourceFile.text, nextToken.end, false, true);
                changes.deleteRange(sourceFile, { pos: start, end });
              } else {
                deleteNode(changes, sourceFile, importClause.name);
              }
            }
          }
          function deleteImportBinding(changes, sourceFile, node) {
            if (node.parent.name) {
              var previousToken = ts2.Debug.checkDefined(ts2.getTokenAtPosition(sourceFile, node.pos - 1));
              changes.deleteRange(sourceFile, { pos: previousToken.getStart(sourceFile), end: node.end });
            } else {
              var importDecl = ts2.getAncestor(node, 254);
              deleteNode(changes, sourceFile, importDecl);
            }
          }
          function deleteVariableDeclaration(changes, deletedNodesInLists, sourceFile, node) {
            var parent = node.parent;
            if (parent.kind === 280) {
              changes.deleteNodeRange(sourceFile, ts2.findChildOfKind(parent, 20, sourceFile), ts2.findChildOfKind(parent, 21, sourceFile));
              return;
            }
            if (parent.declarations.length !== 1) {
              deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
              return;
            }
            var gp = parent.parent;
            switch (gp.kind) {
              case 232:
              case 231:
                changes.replaceNode(sourceFile, node, ts2.createObjectLiteral());
                break;
              case 230:
                deleteNode(changes, sourceFile, parent);
                break;
              case 225:
                deleteNode(changes, sourceFile, gp, { leadingTriviaOption: ts2.hasJSDocNodes(gp) ? LeadingTriviaOption.JSDoc : LeadingTriviaOption.StartLine });
                break;
              default:
                ts2.Debug.assertNever(gp);
            }
          }
        })(deleteDeclaration || (deleteDeclaration = {}));
        function deleteNode(changes, sourceFile, node, options) {
          if (options === void 0) {
            options = { leadingTriviaOption: LeadingTriviaOption.IncludeAll };
          }
          var startPosition = getAdjustedStartPosition(sourceFile, node, options);
          var endPosition = getAdjustedEndPosition(sourceFile, node, options);
          changes.deleteRange(sourceFile, { pos: startPosition, end: endPosition });
        }
        textChanges_3.deleteNode = deleteNode;
        function deleteNodeInList(changes, deletedNodesInLists, sourceFile, node) {
          var containingList = ts2.Debug.checkDefined(ts2.formatting.SmartIndenter.getContainingList(node, sourceFile));
          var index = ts2.indexOfNode(containingList, node);
          ts2.Debug.assert(index !== -1);
          if (containingList.length === 1) {
            deleteNode(changes, sourceFile, node);
            return;
          }
          ts2.Debug.assert(!deletedNodesInLists.has(node), "Deleting a node twice");
          deletedNodesInLists.add(node);
          changes.deleteRange(sourceFile, {
            pos: startPositionToDeleteNodeInList(sourceFile, node),
            end: index === containingList.length - 1 ? getAdjustedEndPosition(sourceFile, node, {}) : startPositionToDeleteNodeInList(sourceFile, containingList[index + 1])
          });
        }
      })(textChanges = ts2.textChanges || (ts2.textChanges = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var errorCodeToFixes = ts2.createMultiMap();
        var fixIdToRegistration = ts2.createMap();
        function diagnosticToString(diag) {
          return ts2.isArray(diag) ? ts2.formatStringFromArgs(ts2.getLocaleSpecificMessage(diag[0]), diag.slice(1)) : ts2.getLocaleSpecificMessage(diag);
        }
        function createCodeFixActionWithoutFixAll(fixName, changes, description) {
          return createCodeFixActionWorker(fixName, diagnosticToString(description), changes, void 0, void 0);
        }
        codefix2.createCodeFixActionWithoutFixAll = createCodeFixActionWithoutFixAll;
        function createCodeFixAction(fixName, changes, description, fixId, fixAllDescription, command) {
          return createCodeFixActionWorker(fixName, diagnosticToString(description), changes, fixId, diagnosticToString(fixAllDescription), command);
        }
        codefix2.createCodeFixAction = createCodeFixAction;
        function createCodeFixActionWorker(fixName, description, changes, fixId, fixAllDescription, command) {
          return { fixName, description, changes, fixId, fixAllDescription, commands: command ? [command] : void 0 };
        }
        function registerCodeFix(reg) {
          for (var _i = 0, _a = reg.errorCodes; _i < _a.length; _i++) {
            var error = _a[_i];
            errorCodeToFixes.add(String(error), reg);
          }
          if (reg.fixIds) {
            for (var _b = 0, _c = reg.fixIds; _b < _c.length; _b++) {
              var fixId = _c[_b];
              ts2.Debug.assert(!fixIdToRegistration.has(fixId));
              fixIdToRegistration.set(fixId, reg);
            }
          }
        }
        codefix2.registerCodeFix = registerCodeFix;
        function getSupportedErrorCodes() {
          return ts2.arrayFrom(errorCodeToFixes.keys());
        }
        codefix2.getSupportedErrorCodes = getSupportedErrorCodes;
        function removeFixIdIfFixAllUnavailable(registration, diagnostics) {
          var errorCodes = registration.errorCodes;
          var maybeFixableDiagnostics = 0;
          for (var _i = 0, diagnostics_1 = diagnostics; _i < diagnostics_1.length; _i++) {
            var diag = diagnostics_1[_i];
            if (ts2.contains(errorCodes, diag.code))
              maybeFixableDiagnostics++;
            if (maybeFixableDiagnostics > 1)
              break;
          }
          var fixAllUnavailable = maybeFixableDiagnostics < 2;
          return function(_a) {
            var fixId = _a.fixId, fixAllDescription = _a.fixAllDescription, action = __rest(_a, ["fixId", "fixAllDescription"]);
            return fixAllUnavailable ? action : __assign(__assign({}, action), { fixId, fixAllDescription });
          };
        }
        function getFixes(context) {
          var diagnostics = getDiagnostics(context);
          var registrations = errorCodeToFixes.get(String(context.errorCode));
          return ts2.flatMap(registrations, function(f) {
            return ts2.map(f.getCodeActions(context), removeFixIdIfFixAllUnavailable(f, diagnostics));
          });
        }
        codefix2.getFixes = getFixes;
        function getAllFixes(context) {
          return fixIdToRegistration.get(ts2.cast(context.fixId, ts2.isString)).getAllCodeActions(context);
        }
        codefix2.getAllFixes = getAllFixes;
        function createCombinedCodeActions(changes, commands) {
          return { changes, commands };
        }
        codefix2.createCombinedCodeActions = createCombinedCodeActions;
        function createFileTextChanges(fileName, textChanges) {
          return { fileName, textChanges };
        }
        codefix2.createFileTextChanges = createFileTextChanges;
        function codeFixAll(context, errorCodes, use) {
          var commands = [];
          var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
            return eachDiagnostic(context, errorCodes, function(diag) {
              return use(t, diag, commands);
            });
          });
          return createCombinedCodeActions(changes, commands.length === 0 ? void 0 : commands);
        }
        codefix2.codeFixAll = codeFixAll;
        function eachDiagnostic(context, errorCodes, cb) {
          for (var _i = 0, _a = getDiagnostics(context); _i < _a.length; _i++) {
            var diag = _a[_i];
            if (ts2.contains(errorCodes, diag.code)) {
              cb(diag);
            }
          }
        }
        codefix2.eachDiagnostic = eachDiagnostic;
        function getDiagnostics(_a) {
          var program = _a.program, sourceFile = _a.sourceFile, cancellationToken = _a.cancellationToken;
          return __spreadArrays(program.getSemanticDiagnostics(sourceFile, cancellationToken), program.getSyntacticDiagnostics(sourceFile, cancellationToken), ts2.computeSuggestionDiagnostics(sourceFile, program, cancellationToken));
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var refactor;
      (function(refactor_1) {
        var refactors = ts2.createMap();
        function registerRefactor(name, refactor2) {
          refactors.set(name, refactor2);
        }
        refactor_1.registerRefactor = registerRefactor;
        function getApplicableRefactors(context) {
          return ts2.arrayFrom(ts2.flatMapIterator(refactors.values(), function(refactor2) {
            return context.cancellationToken && context.cancellationToken.isCancellationRequested() ? void 0 : refactor2.getAvailableActions(context);
          }));
        }
        refactor_1.getApplicableRefactors = getApplicableRefactors;
        function getEditsForRefactor(context, refactorName, actionName) {
          var refactor2 = refactors.get(refactorName);
          return refactor2 && refactor2.getEditsForAction(context, actionName);
        }
        refactor_1.getEditsForRefactor = getEditsForRefactor;
      })(refactor = ts2.refactor || (ts2.refactor = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "addConvertToUnknownForNonOverlappingTypes";
        var errorCodes = [ts2.Diagnostics.Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return makeChange(t, context.sourceFile, context.span.start);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Add_unknown_conversion_for_non_overlapping_types, fixId, ts2.Diagnostics.Add_unknown_to_all_conversions_of_non_overlapping_types)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag.start);
            });
          }
        });
        function makeChange(changeTracker, sourceFile, pos) {
          var token = ts2.getTokenAtPosition(sourceFile, pos);
          var assertion = ts2.Debug.checkDefined(ts2.findAncestor(token, function(n) {
            return ts2.isAsExpression(n) || ts2.isTypeAssertion(n);
          }), "Expected to find an assertion expression");
          var replacement = ts2.isAsExpression(assertion) ? ts2.createAsExpression(assertion.expression, ts2.createKeywordTypeNode(148)) : ts2.createTypeAssertion(ts2.createKeywordTypeNode(148), assertion.expression);
          changeTracker.replaceNode(sourceFile, assertion.expression, replacement);
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        codefix2.registerCodeFix({
          errorCodes: [ts2.Diagnostics.await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module.code],
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var changes = ts2.textChanges.ChangeTracker.with(context, function(changes2) {
              var exportDeclaration = ts2.createExportDeclaration(void 0, void 0, ts2.createNamedExports([]), void 0, false);
              changes2.insertNodeAtEndOfScope(sourceFile, sourceFile, exportDeclaration);
            });
            return [codefix2.createCodeFixActionWithoutFixAll("addEmptyExportDeclaration", changes, ts2.Diagnostics.Add_export_to_make_this_file_into_a_module)];
          }
        });
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "addMissingAsync";
        var errorCodes = [
          ts2.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,
          ts2.Diagnostics.Type_0_is_not_assignable_to_type_1.code,
          ts2.Diagnostics.Type_0_is_not_comparable_to_type_1.code
        ];
        codefix2.registerCodeFix({
          fixIds: [fixId],
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, errorCode = context.errorCode, cancellationToken = context.cancellationToken, program = context.program, span = context.span;
            var diagnostic = ts2.find(program.getDiagnosticsProducingTypeChecker().getDiagnostics(sourceFile, cancellationToken), getIsMatchingAsyncError(span, errorCode));
            var directSpan = diagnostic && diagnostic.relatedInformation && ts2.find(diagnostic.relatedInformation, function(r) {
              return r.code === ts2.Diagnostics.Did_you_mean_to_mark_this_function_as_async.code;
            });
            var decl = getFixableErrorSpanDeclaration(sourceFile, directSpan);
            if (!decl) {
              return;
            }
            var trackChanges = function(cb) {
              return ts2.textChanges.ChangeTracker.with(context, cb);
            };
            return [getFix(context, decl, trackChanges)];
          },
          getAllCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var fixedDeclarations = ts2.createMap();
            return codefix2.codeFixAll(context, errorCodes, function(t, diagnostic) {
              var span = diagnostic.relatedInformation && ts2.find(diagnostic.relatedInformation, function(r) {
                return r.code === ts2.Diagnostics.Did_you_mean_to_mark_this_function_as_async.code;
              });
              var decl = getFixableErrorSpanDeclaration(sourceFile, span);
              if (!decl) {
                return;
              }
              var trackChanges = function(cb) {
                return cb(t), [];
              };
              return getFix(context, decl, trackChanges, fixedDeclarations);
            });
          }
        });
        function getFix(context, decl, trackChanges, fixedDeclarations) {
          var changes = trackChanges(function(t) {
            return makeChange(t, context.sourceFile, decl, fixedDeclarations);
          });
          return codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Add_async_modifier_to_containing_function, fixId, ts2.Diagnostics.Add_all_missing_async_modifiers);
        }
        function makeChange(changeTracker, sourceFile, insertionSite, fixedDeclarations) {
          if (fixedDeclarations) {
            if (fixedDeclarations.has(ts2.getNodeId(insertionSite).toString())) {
              return;
            }
          }
          fixedDeclarations === null || fixedDeclarations === void 0 ? void 0 : fixedDeclarations.set(ts2.getNodeId(insertionSite).toString(), true);
          var cloneWithModifier = ts2.getSynthesizedDeepClone(insertionSite, true);
          cloneWithModifier.modifiers = ts2.createNodeArray(ts2.createModifiersFromModifierFlags(ts2.getModifierFlags(insertionSite) | 256));
          cloneWithModifier.modifierFlagsCache = 0;
          changeTracker.replaceNode(sourceFile, insertionSite, cloneWithModifier);
        }
        function getFixableErrorSpanDeclaration(sourceFile, span) {
          if (!span)
            return void 0;
          var token = ts2.getTokenAtPosition(sourceFile, span.start);
          var decl = ts2.findAncestor(token, function(node) {
            if (node.getStart(sourceFile) < span.start || node.getEnd() > ts2.textSpanEnd(span)) {
              return "quit";
            }
            return (ts2.isArrowFunction(node) || ts2.isMethodDeclaration(node) || ts2.isFunctionExpression(node) || ts2.isFunctionDeclaration(node)) && ts2.textSpansEqual(span, ts2.createTextSpanFromNode(node, sourceFile));
          });
          return decl;
        }
        function getIsMatchingAsyncError(span, errorCode) {
          return function(_a) {
            var start = _a.start, length = _a.length, relatedInformation = _a.relatedInformation, code = _a.code;
            return ts2.isNumber(start) && ts2.isNumber(length) && ts2.textSpansEqual({ start, length }, span) && code === errorCode && !!relatedInformation && ts2.some(relatedInformation, function(related) {
              return related.code === ts2.Diagnostics.Did_you_mean_to_mark_this_function_as_async.code;
            });
          };
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "addMissingAwait";
        var propertyAccessCode = ts2.Diagnostics.Property_0_does_not_exist_on_type_1.code;
        var callableConstructableErrorCodes = [
          ts2.Diagnostics.This_expression_is_not_callable.code,
          ts2.Diagnostics.This_expression_is_not_constructable.code
        ];
        var errorCodes = __spreadArrays([
          ts2.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type.code,
          ts2.Diagnostics.The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type.code,
          ts2.Diagnostics.The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type.code,
          ts2.Diagnostics.Operator_0_cannot_be_applied_to_type_1.code,
          ts2.Diagnostics.Operator_0_cannot_be_applied_to_types_1_and_2.code,
          ts2.Diagnostics.This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap.code,
          ts2.Diagnostics.Type_0_is_not_an_array_type.code,
          ts2.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type.code,
          ts2.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_Use_compiler_option_downlevelIteration_to_allow_iterating_of_iterators.code,
          ts2.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator.code,
          ts2.Diagnostics.Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator.code,
          ts2.Diagnostics.Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator.code,
          ts2.Diagnostics.Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator.code,
          ts2.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,
          propertyAccessCode
        ], callableConstructableErrorCodes);
        codefix2.registerCodeFix({
          fixIds: [fixId],
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, errorCode = context.errorCode, span = context.span, cancellationToken = context.cancellationToken, program = context.program;
            var expression = getFixableErrorSpanExpression(sourceFile, errorCode, span, cancellationToken, program);
            if (!expression) {
              return;
            }
            var checker = context.program.getTypeChecker();
            var trackChanges = function(cb) {
              return ts2.textChanges.ChangeTracker.with(context, cb);
            };
            return ts2.compact([
              getDeclarationSiteFix(context, expression, errorCode, checker, trackChanges),
              getUseSiteFix(context, expression, errorCode, checker, trackChanges)
            ]);
          },
          getAllCodeActions: function(context) {
            var sourceFile = context.sourceFile, program = context.program, cancellationToken = context.cancellationToken;
            var checker = context.program.getTypeChecker();
            var fixedDeclarations = ts2.createMap();
            return codefix2.codeFixAll(context, errorCodes, function(t, diagnostic) {
              var expression = getFixableErrorSpanExpression(sourceFile, diagnostic.code, diagnostic, cancellationToken, program);
              if (!expression) {
                return;
              }
              var trackChanges = function(cb) {
                return cb(t), [];
              };
              return getDeclarationSiteFix(context, expression, diagnostic.code, checker, trackChanges, fixedDeclarations) || getUseSiteFix(context, expression, diagnostic.code, checker, trackChanges, fixedDeclarations);
            });
          }
        });
        function getDeclarationSiteFix(context, expression, errorCode, checker, trackChanges, fixedDeclarations) {
          var sourceFile = context.sourceFile, program = context.program, cancellationToken = context.cancellationToken;
          var awaitableInitializers = findAwaitableInitializers(expression, sourceFile, cancellationToken, program, checker);
          if (awaitableInitializers) {
            var initializerChanges = trackChanges(function(t) {
              ts2.forEach(awaitableInitializers.initializers, function(_a) {
                var expression2 = _a.expression;
                return makeChange(t, errorCode, sourceFile, checker, expression2, fixedDeclarations);
              });
              if (fixedDeclarations && awaitableInitializers.needsSecondPassForFixAll) {
                makeChange(t, errorCode, sourceFile, checker, expression, fixedDeclarations);
              }
            });
            return codefix2.createCodeFixActionWithoutFixAll("addMissingAwaitToInitializer", initializerChanges, awaitableInitializers.initializers.length === 1 ? [ts2.Diagnostics.Add_await_to_initializer_for_0, awaitableInitializers.initializers[0].declarationSymbol.name] : ts2.Diagnostics.Add_await_to_initializers);
          }
        }
        function getUseSiteFix(context, expression, errorCode, checker, trackChanges, fixedDeclarations) {
          var changes = trackChanges(function(t) {
            return makeChange(t, errorCode, context.sourceFile, checker, expression, fixedDeclarations);
          });
          return codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Add_await, fixId, ts2.Diagnostics.Fix_all_expressions_possibly_missing_await);
        }
        function isMissingAwaitError(sourceFile, errorCode, span, cancellationToken, program) {
          var checker = program.getDiagnosticsProducingTypeChecker();
          var diagnostics = checker.getDiagnostics(sourceFile, cancellationToken);
          return ts2.some(diagnostics, function(_a) {
            var start = _a.start, length = _a.length, relatedInformation = _a.relatedInformation, code = _a.code;
            return ts2.isNumber(start) && ts2.isNumber(length) && ts2.textSpansEqual({ start, length }, span) && code === errorCode && !!relatedInformation && ts2.some(relatedInformation, function(related) {
              return related.code === ts2.Diagnostics.Did_you_forget_to_use_await.code;
            });
          });
        }
        function getFixableErrorSpanExpression(sourceFile, errorCode, span, cancellationToken, program) {
          var token = ts2.getTokenAtPosition(sourceFile, span.start);
          var expression = ts2.findAncestor(token, function(node) {
            if (node.getStart(sourceFile) < span.start || node.getEnd() > ts2.textSpanEnd(span)) {
              return "quit";
            }
            return ts2.isExpression(node) && ts2.textSpansEqual(span, ts2.createTextSpanFromNode(node, sourceFile));
          });
          return expression && isMissingAwaitError(sourceFile, errorCode, span, cancellationToken, program) && isInsideAwaitableBody(expression) ? expression : void 0;
        }
        function findAwaitableInitializers(expression, sourceFile, cancellationToken, program, checker) {
          var identifiers = getIdentifiersFromErrorSpanExpression(expression, checker);
          if (!identifiers) {
            return;
          }
          var isCompleteFix = identifiers.isCompleteFix;
          var initializers;
          var _loop_11 = function(identifier2) {
            var symbol = checker.getSymbolAtLocation(identifier2);
            if (!symbol) {
              return "continue";
            }
            var declaration = ts2.tryCast(symbol.valueDeclaration, ts2.isVariableDeclaration);
            var variableName = declaration && ts2.tryCast(declaration.name, ts2.isIdentifier);
            var variableStatement = ts2.getAncestor(declaration, 225);
            if (!declaration || !variableStatement || declaration.type || !declaration.initializer || variableStatement.getSourceFile() !== sourceFile || ts2.hasModifier(variableStatement, 1) || !variableName || !isInsideAwaitableBody(declaration.initializer)) {
              isCompleteFix = false;
              return "continue";
            }
            var diagnostics = program.getSemanticDiagnostics(sourceFile, cancellationToken);
            var isUsedElsewhere = ts2.FindAllReferences.Core.eachSymbolReferenceInFile(variableName, checker, sourceFile, function(reference) {
              return identifier2 !== reference && !symbolReferenceIsAlsoMissingAwait(reference, diagnostics, sourceFile, checker);
            });
            if (isUsedElsewhere) {
              isCompleteFix = false;
              return "continue";
            }
            (initializers || (initializers = [])).push({
              expression: declaration.initializer,
              declarationSymbol: symbol
            });
          };
          for (var _i = 0, _a = identifiers.identifiers; _i < _a.length; _i++) {
            var identifier = _a[_i];
            _loop_11(identifier);
          }
          return initializers && {
            initializers,
            needsSecondPassForFixAll: !isCompleteFix
          };
        }
        function getIdentifiersFromErrorSpanExpression(expression, checker) {
          if (ts2.isPropertyAccessExpression(expression.parent) && ts2.isIdentifier(expression.parent.expression)) {
            return { identifiers: [expression.parent.expression], isCompleteFix: true };
          }
          if (ts2.isIdentifier(expression)) {
            return { identifiers: [expression], isCompleteFix: true };
          }
          if (ts2.isBinaryExpression(expression)) {
            var sides = void 0;
            var isCompleteFix = true;
            for (var _i = 0, _a = [expression.left, expression.right]; _i < _a.length; _i++) {
              var side = _a[_i];
              var type = checker.getTypeAtLocation(side);
              if (checker.getPromisedTypeOfPromise(type)) {
                if (!ts2.isIdentifier(side)) {
                  isCompleteFix = false;
                  continue;
                }
                (sides || (sides = [])).push(side);
              }
            }
            return sides && { identifiers: sides, isCompleteFix };
          }
        }
        function symbolReferenceIsAlsoMissingAwait(reference, diagnostics, sourceFile, checker) {
          var errorNode = ts2.isPropertyAccessExpression(reference.parent) ? reference.parent.name : ts2.isBinaryExpression(reference.parent) ? reference.parent : reference;
          var diagnostic = ts2.find(diagnostics, function(diagnostic2) {
            return diagnostic2.start === errorNode.getStart(sourceFile) && diagnostic2.start + diagnostic2.length === errorNode.getEnd();
          });
          return diagnostic && ts2.contains(errorCodes, diagnostic.code) || checker.getTypeAtLocation(errorNode).flags & 1;
        }
        function isInsideAwaitableBody(node) {
          return node.kind & 32768 || !!ts2.findAncestor(node, function(ancestor) {
            return ancestor.parent && ts2.isArrowFunction(ancestor.parent) && ancestor.parent.body === ancestor || ts2.isBlock(ancestor) && (ancestor.parent.kind === 244 || ancestor.parent.kind === 201 || ancestor.parent.kind === 202 || ancestor.parent.kind === 161);
          });
        }
        function makeChange(changeTracker, errorCode, sourceFile, checker, insertionSite, fixedDeclarations) {
          if (ts2.isBinaryExpression(insertionSite)) {
            for (var _i = 0, _a = [insertionSite.left, insertionSite.right]; _i < _a.length; _i++) {
              var side = _a[_i];
              if (fixedDeclarations && ts2.isIdentifier(side)) {
                var symbol = checker.getSymbolAtLocation(side);
                if (symbol && fixedDeclarations.has(ts2.getSymbolId(symbol).toString())) {
                  continue;
                }
              }
              var type = checker.getTypeAtLocation(side);
              var newNode = checker.getPromisedTypeOfPromise(type) ? ts2.createAwait(side) : side;
              changeTracker.replaceNode(sourceFile, side, newNode);
            }
          } else if (errorCode === propertyAccessCode && ts2.isPropertyAccessExpression(insertionSite.parent)) {
            if (fixedDeclarations && ts2.isIdentifier(insertionSite.parent.expression)) {
              var symbol = checker.getSymbolAtLocation(insertionSite.parent.expression);
              if (symbol && fixedDeclarations.has(ts2.getSymbolId(symbol).toString())) {
                return;
              }
            }
            changeTracker.replaceNode(sourceFile, insertionSite.parent.expression, ts2.createParen(ts2.createAwait(insertionSite.parent.expression)));
            insertLeadingSemicolonIfNeeded(changeTracker, insertionSite.parent.expression, sourceFile);
          } else if (ts2.contains(callableConstructableErrorCodes, errorCode) && ts2.isCallOrNewExpression(insertionSite.parent)) {
            if (fixedDeclarations && ts2.isIdentifier(insertionSite)) {
              var symbol = checker.getSymbolAtLocation(insertionSite);
              if (symbol && fixedDeclarations.has(ts2.getSymbolId(symbol).toString())) {
                return;
              }
            }
            changeTracker.replaceNode(sourceFile, insertionSite, ts2.createParen(ts2.createAwait(insertionSite)));
            insertLeadingSemicolonIfNeeded(changeTracker, insertionSite, sourceFile);
          } else {
            if (fixedDeclarations && ts2.isVariableDeclaration(insertionSite.parent) && ts2.isIdentifier(insertionSite.parent.name)) {
              var symbol = checker.getSymbolAtLocation(insertionSite.parent.name);
              if (symbol && !ts2.addToSeen(fixedDeclarations, ts2.getSymbolId(symbol))) {
                return;
              }
            }
            changeTracker.replaceNode(sourceFile, insertionSite, ts2.createAwait(insertionSite));
          }
        }
        function insertLeadingSemicolonIfNeeded(changeTracker, beforeNode, sourceFile) {
          var precedingToken = ts2.findPrecedingToken(beforeNode.pos, sourceFile);
          if (precedingToken && ts2.positionIsASICandidate(precedingToken.end, precedingToken.parent, sourceFile)) {
            changeTracker.insertText(sourceFile, beforeNode.getStart(sourceFile), ";");
          }
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "addMissingConst";
        var errorCodes = [
          ts2.Diagnostics.Cannot_find_name_0.code,
          ts2.Diagnostics.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return makeChange(t, context.sourceFile, context.span.start, context.program);
            });
            if (changes.length > 0) {
              return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Add_const_to_unresolved_variable, fixId, ts2.Diagnostics.Add_const_to_all_unresolved_variables)];
            }
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var fixedNodes = new ts2.NodeSet();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag.start, context.program, fixedNodes);
            });
          }
        });
        function makeChange(changeTracker, sourceFile, pos, program, fixedNodes) {
          var token = ts2.getTokenAtPosition(sourceFile, pos);
          var forInitializer = ts2.findAncestor(token, function(node) {
            return ts2.isForInOrOfStatement(node.parent) ? node.parent.initializer === node : isPossiblyPartOfDestructuring(node) ? false : "quit";
          });
          if (forInitializer)
            return applyChange(changeTracker, forInitializer, sourceFile, fixedNodes);
          var parent = token.parent;
          if (ts2.isBinaryExpression(parent) && parent.operatorToken.kind === 62 && ts2.isExpressionStatement(parent.parent)) {
            return applyChange(changeTracker, token, sourceFile, fixedNodes);
          }
          if (ts2.isArrayLiteralExpression(parent)) {
            var checker_1 = program.getTypeChecker();
            if (!ts2.every(parent.elements, function(element) {
              return arrayElementCouldBeVariableDeclaration(element, checker_1);
            })) {
              return;
            }
            return applyChange(changeTracker, parent, sourceFile, fixedNodes);
          }
          var commaExpression = ts2.findAncestor(token, function(node) {
            return ts2.isExpressionStatement(node.parent) ? true : isPossiblyPartOfCommaSeperatedInitializer(node) ? false : "quit";
          });
          if (commaExpression) {
            var checker = program.getTypeChecker();
            if (!expressionCouldBeVariableDeclaration(commaExpression, checker)) {
              return;
            }
            return applyChange(changeTracker, commaExpression, sourceFile, fixedNodes);
          }
        }
        function applyChange(changeTracker, initializer, sourceFile, fixedNodes) {
          if (!fixedNodes || fixedNodes.tryAdd(initializer)) {
            changeTracker.insertModifierBefore(sourceFile, 81, initializer);
          }
        }
        function isPossiblyPartOfDestructuring(node) {
          switch (node.kind) {
            case 75:
            case 192:
            case 193:
            case 281:
            case 282:
              return true;
            default:
              return false;
          }
        }
        function arrayElementCouldBeVariableDeclaration(expression, checker) {
          var identifier = ts2.isIdentifier(expression) ? expression : ts2.isAssignmentExpression(expression, true) && ts2.isIdentifier(expression.left) ? expression.left : void 0;
          return !!identifier && !checker.getSymbolAtLocation(identifier);
        }
        function isPossiblyPartOfCommaSeperatedInitializer(node) {
          switch (node.kind) {
            case 75:
            case 209:
            case 27:
              return true;
            default:
              return false;
          }
        }
        function expressionCouldBeVariableDeclaration(expression, checker) {
          if (!ts2.isBinaryExpression(expression)) {
            return false;
          }
          if (expression.operatorToken.kind === 27) {
            return ts2.every([expression.left, expression.right], function(expression2) {
              return expressionCouldBeVariableDeclaration(expression2, checker);
            });
          }
          return expression.operatorToken.kind === 62 && ts2.isIdentifier(expression.left) && !checker.getSymbolAtLocation(expression.left);
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "addMissingDeclareProperty";
        var errorCodes = [
          ts2.Diagnostics.Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return makeChange(t, context.sourceFile, context.span.start);
            });
            if (changes.length > 0) {
              return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Prefix_with_declare, fixId, ts2.Diagnostics.Prefix_all_incorrect_property_declarations_with_declare)];
            }
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var fixedNodes = new ts2.NodeSet();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag.start, fixedNodes);
            });
          }
        });
        function makeChange(changeTracker, sourceFile, pos, fixedNodes) {
          var token = ts2.getTokenAtPosition(sourceFile, pos);
          if (!ts2.isIdentifier(token)) {
            return;
          }
          var declaration = token.parent;
          if (declaration.kind === 159 && (!fixedNodes || fixedNodes.tryAdd(declaration))) {
            changeTracker.insertModifierBefore(sourceFile, 130, declaration);
          }
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "addMissingInvocationForDecorator";
        var errorCodes = [ts2.Diagnostics._0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return makeChange(t, context.sourceFile, context.span.start);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Call_decorator_expression, fixId, ts2.Diagnostics.Add_to_all_uncalled_decorators)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag.start);
            });
          }
        });
        function makeChange(changeTracker, sourceFile, pos) {
          var token = ts2.getTokenAtPosition(sourceFile, pos);
          var decorator = ts2.findAncestor(token, ts2.isDecorator);
          ts2.Debug.assert(!!decorator, "Expected position to be owned by a decorator.");
          var replacement = ts2.createCall(decorator.expression, void 0, void 0);
          changeTracker.replaceNode(sourceFile, decorator.expression, replacement);
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "addNameToNamelessParameter";
        var errorCodes = [ts2.Diagnostics.Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return makeChange(t, context.sourceFile, context.span.start);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Add_parameter_name, fixId, ts2.Diagnostics.Add_names_to_all_parameters_without_names)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag.start);
            });
          }
        });
        function makeChange(changeTracker, sourceFile, pos) {
          var token = ts2.getTokenAtPosition(sourceFile, pos);
          if (!ts2.isIdentifier(token)) {
            return ts2.Debug.fail("add-name-to-nameless-parameter operates on identifiers, but got a " + ts2.Debug.formatSyntaxKind(token.kind));
          }
          var param = token.parent;
          if (!ts2.isParameter(param)) {
            return ts2.Debug.fail("Tried to add a parameter name to a non-parameter: " + ts2.Debug.formatSyntaxKind(token.kind));
          }
          var i = param.parent.parameters.indexOf(param);
          ts2.Debug.assert(!param.type, "Tried to add a parameter name to a parameter that already had one.");
          ts2.Debug.assert(i > -1, "Parameter not found in parent parameter list.");
          var replacement = ts2.createParameter(void 0, param.modifiers, param.dotDotDotToken, "arg" + i, param.questionToken, ts2.createTypeReferenceNode(token, void 0), param.initializer);
          changeTracker.replaceNode(sourceFile, token, replacement);
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "annotateWithTypeFromJSDoc";
        var errorCodes = [ts2.Diagnostics.JSDoc_types_may_be_moved_to_TypeScript_types.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var decl = getDeclaration(context.sourceFile, context.span.start);
            if (!decl)
              return;
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, context.sourceFile, decl);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Annotate_with_type_from_JSDoc, fixId, ts2.Diagnostics.Annotate_everything_with_types_from_JSDoc)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var decl = getDeclaration(diag.file, diag.start);
              if (decl)
                doChange(changes, diag.file, decl);
            });
          }
        });
        function getDeclaration(file, pos) {
          var name = ts2.getTokenAtPosition(file, pos);
          return ts2.tryCast(ts2.isParameter(name.parent) ? name.parent.parent : name.parent, parameterShouldGetTypeFromJSDoc);
        }
        function parameterShouldGetTypeFromJSDoc(node) {
          return isDeclarationWithType(node) && hasUsableJSDoc(node);
        }
        codefix2.parameterShouldGetTypeFromJSDoc = parameterShouldGetTypeFromJSDoc;
        function hasUsableJSDoc(decl) {
          return ts2.isFunctionLikeDeclaration(decl) ? decl.parameters.some(hasUsableJSDoc) || !decl.type && !!ts2.getJSDocReturnType(decl) : !decl.type && !!ts2.getJSDocType(decl);
        }
        function doChange(changes, sourceFile, decl) {
          if (ts2.isFunctionLikeDeclaration(decl) && (ts2.getJSDocReturnType(decl) || decl.parameters.some(function(p) {
            return !!ts2.getJSDocType(p);
          }))) {
            if (!decl.typeParameters) {
              var typeParameters = ts2.getJSDocTypeParameterDeclarations(decl);
              if (typeParameters.length)
                changes.insertTypeParameters(sourceFile, decl, typeParameters);
            }
            var needParens = ts2.isArrowFunction(decl) && !ts2.findChildOfKind(decl, 20, sourceFile);
            if (needParens)
              changes.insertNodeBefore(sourceFile, ts2.first(decl.parameters), ts2.createToken(20));
            for (var _i = 0, _a = decl.parameters; _i < _a.length; _i++) {
              var param = _a[_i];
              if (!param.type) {
                var paramType = ts2.getJSDocType(param);
                if (paramType)
                  changes.tryInsertTypeAnnotation(sourceFile, param, transformJSDocType(paramType));
              }
            }
            if (needParens)
              changes.insertNodeAfter(sourceFile, ts2.last(decl.parameters), ts2.createToken(21));
            if (!decl.type) {
              var returnType = ts2.getJSDocReturnType(decl);
              if (returnType)
                changes.tryInsertTypeAnnotation(sourceFile, decl, transformJSDocType(returnType));
            }
          } else {
            var jsdocType = ts2.Debug.checkDefined(ts2.getJSDocType(decl), "A JSDocType for this declaration should exist");
            ts2.Debug.assert(!decl.type, "The JSDocType decl should have a type");
            changes.tryInsertTypeAnnotation(sourceFile, decl, transformJSDocType(jsdocType));
          }
        }
        function isDeclarationWithType(node) {
          return ts2.isFunctionLikeDeclaration(node) || node.kind === 242 || node.kind === 158 || node.kind === 159;
        }
        function transformJSDocType(node) {
          switch (node.kind) {
            case 295:
            case 296:
              return ts2.createTypeReferenceNode("any", ts2.emptyArray);
            case 299:
              return transformJSDocOptionalType(node);
            case 298:
              return transformJSDocType(node.type);
            case 297:
              return transformJSDocNullableType(node);
            case 301:
              return transformJSDocVariadicType(node);
            case 300:
              return transformJSDocFunctionType(node);
            case 169:
              return transformJSDocTypeReference(node);
            default:
              var visited = ts2.visitEachChild(node, transformJSDocType, void 0);
              ts2.setEmitFlags(visited, 1);
              return visited;
          }
        }
        function transformJSDocOptionalType(node) {
          return ts2.createUnionTypeNode([ts2.visitNode(node.type, transformJSDocType), ts2.createTypeReferenceNode("undefined", ts2.emptyArray)]);
        }
        function transformJSDocNullableType(node) {
          return ts2.createUnionTypeNode([ts2.visitNode(node.type, transformJSDocType), ts2.createTypeReferenceNode("null", ts2.emptyArray)]);
        }
        function transformJSDocVariadicType(node) {
          return ts2.createArrayTypeNode(ts2.visitNode(node.type, transformJSDocType));
        }
        function transformJSDocFunctionType(node) {
          return ts2.createFunctionTypeNode(ts2.emptyArray, node.parameters.map(transformJSDocParameter), node.type);
        }
        function transformJSDocParameter(node) {
          var index = node.parent.parameters.indexOf(node);
          var isRest = node.type.kind === 301 && index === node.parent.parameters.length - 1;
          var name = node.name || (isRest ? "rest" : "arg" + index);
          var dotdotdot = isRest ? ts2.createToken(25) : node.dotDotDotToken;
          return ts2.createParameter(node.decorators, node.modifiers, dotdotdot, name, node.questionToken, ts2.visitNode(node.type, transformJSDocType), node.initializer);
        }
        function transformJSDocTypeReference(node) {
          var name = node.typeName;
          var args = node.typeArguments;
          if (ts2.isIdentifier(node.typeName)) {
            if (ts2.isJSDocIndexSignature(node)) {
              return transformJSDocIndexSignature(node);
            }
            var text = node.typeName.text;
            switch (node.typeName.text) {
              case "String":
              case "Boolean":
              case "Object":
              case "Number":
                text = text.toLowerCase();
                break;
              case "array":
              case "date":
              case "promise":
                text = text[0].toUpperCase() + text.slice(1);
                break;
            }
            name = ts2.createIdentifier(text);
            if ((text === "Array" || text === "Promise") && !node.typeArguments) {
              args = ts2.createNodeArray([ts2.createTypeReferenceNode("any", ts2.emptyArray)]);
            } else {
              args = ts2.visitNodes(node.typeArguments, transformJSDocType);
            }
          }
          return ts2.createTypeReferenceNode(name, args);
        }
        function transformJSDocIndexSignature(node) {
          var index = ts2.createParameter(void 0, void 0, void 0, node.typeArguments[0].kind === 140 ? "n" : "s", void 0, ts2.createTypeReferenceNode(node.typeArguments[0].kind === 140 ? "number" : "string", []), void 0);
          var indexSignature = ts2.createTypeLiteralNode([ts2.createIndexSignature(void 0, void 0, [index], node.typeArguments[1])]);
          ts2.setEmitFlags(indexSignature, 1);
          return indexSignature;
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "convertFunctionToEs6Class";
        var errorCodes = [ts2.Diagnostics.This_constructor_function_may_be_converted_to_a_class_declaration.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, context.sourceFile, context.span.start, context.program.getTypeChecker());
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Convert_function_to_an_ES2015_class, fixId, ts2.Diagnostics.Convert_all_constructor_functions_to_classes)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, err) {
              return doChange(changes, err.file, err.start, context.program.getTypeChecker());
            });
          }
        });
        function doChange(changes, sourceFile, position, checker) {
          var ctorSymbol = checker.getSymbolAtLocation(ts2.getTokenAtPosition(sourceFile, position));
          if (!ctorSymbol || !(ctorSymbol.flags & (16 | 3))) {
            return void 0;
          }
          var ctorDeclaration = ctorSymbol.valueDeclaration;
          var precedingNode;
          var newClassDeclaration;
          switch (ctorDeclaration.kind) {
            case 244:
              precedingNode = ctorDeclaration;
              changes.delete(sourceFile, ctorDeclaration);
              newClassDeclaration = createClassFromFunctionDeclaration(ctorDeclaration);
              break;
            case 242:
              precedingNode = ctorDeclaration.parent.parent;
              newClassDeclaration = createClassFromVariableDeclaration(ctorDeclaration);
              if (ctorDeclaration.parent.declarations.length === 1) {
                ts2.copyLeadingComments(precedingNode, newClassDeclaration, sourceFile);
                changes.delete(sourceFile, precedingNode);
              } else {
                changes.delete(sourceFile, ctorDeclaration);
              }
              break;
          }
          if (!newClassDeclaration) {
            return void 0;
          }
          if (ts2.hasJSDocNodes(ctorDeclaration)) {
            ts2.copyLeadingComments(ctorDeclaration, newClassDeclaration, sourceFile);
          }
          changes.insertNodeAfter(sourceFile, precedingNode, newClassDeclaration);
          function createClassElementsFromSymbol(symbol) {
            var memberElements = [];
            if (symbol.members) {
              symbol.members.forEach(function(member) {
                var memberElement = createClassElement(member, void 0);
                if (memberElement) {
                  memberElements.push(memberElement);
                }
              });
            }
            if (symbol.exports) {
              symbol.exports.forEach(function(member) {
                var memberElement = createClassElement(member, [ts2.createToken(120)]);
                if (memberElement) {
                  memberElements.push(memberElement);
                }
              });
            }
            return memberElements;
            function shouldConvertDeclaration(_target, source) {
              return ts2.isFunctionLike(source);
            }
            function createClassElement(symbol2, modifiers) {
              if (!(symbol2.flags & 8192)) {
                return;
              }
              var memberDeclaration = symbol2.valueDeclaration;
              var assignmentBinaryExpression = memberDeclaration.parent;
              if (!shouldConvertDeclaration(memberDeclaration, assignmentBinaryExpression.right)) {
                return;
              }
              var nodeToDelete = assignmentBinaryExpression.parent && assignmentBinaryExpression.parent.kind === 226 ? assignmentBinaryExpression.parent : assignmentBinaryExpression;
              changes.delete(sourceFile, nodeToDelete);
              if (!assignmentBinaryExpression.right) {
                return ts2.createProperty([], modifiers, symbol2.name, void 0, void 0, void 0);
              }
              switch (assignmentBinaryExpression.right.kind) {
                case 201: {
                  var functionExpression = assignmentBinaryExpression.right;
                  var fullModifiers = ts2.concatenate(modifiers, getModifierKindFromSource(functionExpression, 126));
                  var method = ts2.createMethod(void 0, fullModifiers, void 0, memberDeclaration.name, void 0, void 0, functionExpression.parameters, void 0, functionExpression.body);
                  ts2.copyLeadingComments(assignmentBinaryExpression, method, sourceFile);
                  return method;
                }
                case 202: {
                  var arrowFunction = assignmentBinaryExpression.right;
                  var arrowFunctionBody = arrowFunction.body;
                  var bodyBlock = void 0;
                  if (arrowFunctionBody.kind === 223) {
                    bodyBlock = arrowFunctionBody;
                  } else {
                    bodyBlock = ts2.createBlock([ts2.createReturn(arrowFunctionBody)]);
                  }
                  var fullModifiers = ts2.concatenate(modifiers, getModifierKindFromSource(arrowFunction, 126));
                  var method = ts2.createMethod(void 0, fullModifiers, void 0, memberDeclaration.name, void 0, void 0, arrowFunction.parameters, void 0, bodyBlock);
                  ts2.copyLeadingComments(assignmentBinaryExpression, method, sourceFile);
                  return method;
                }
                default: {
                  if (ts2.isSourceFileJS(sourceFile)) {
                    return;
                  }
                  var prop = ts2.createProperty(void 0, modifiers, memberDeclaration.name, void 0, void 0, assignmentBinaryExpression.right);
                  ts2.copyLeadingComments(assignmentBinaryExpression.parent, prop, sourceFile);
                  return prop;
                }
              }
            }
          }
          function createClassFromVariableDeclaration(node) {
            var initializer = node.initializer;
            if (!initializer || initializer.kind !== 201) {
              return void 0;
            }
            if (node.name.kind !== 75) {
              return void 0;
            }
            var memberElements = createClassElementsFromSymbol(node.symbol);
            if (initializer.body) {
              memberElements.unshift(ts2.createConstructor(void 0, void 0, initializer.parameters, initializer.body));
            }
            var modifiers = getModifierKindFromSource(precedingNode, 89);
            var cls = ts2.createClassDeclaration(void 0, modifiers, node.name, void 0, void 0, memberElements);
            return cls;
          }
          function createClassFromFunctionDeclaration(node) {
            var memberElements = createClassElementsFromSymbol(ctorSymbol);
            if (node.body) {
              memberElements.unshift(ts2.createConstructor(void 0, void 0, node.parameters, node.body));
            }
            var modifiers = getModifierKindFromSource(node, 89);
            var cls = ts2.createClassDeclaration(void 0, modifiers, node.name, void 0, void 0, memberElements);
            return cls;
          }
        }
        function getModifierKindFromSource(source, kind) {
          return ts2.filter(source.modifiers, function(modifier) {
            return modifier.kind === kind;
          });
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "convertToAsyncFunction";
        var errorCodes = [ts2.Diagnostics.This_may_be_converted_to_an_async_function.code];
        var codeActionSucceeded = true;
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            codeActionSucceeded = true;
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return convertToAsyncFunction(t, context.sourceFile, context.span.start, context.program.getTypeChecker(), context);
            });
            return codeActionSucceeded ? [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Convert_to_async_function, fixId, ts2.Diagnostics.Convert_all_to_async_functions)] : [];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, err) {
              return convertToAsyncFunction(changes, err.file, err.start, context.program.getTypeChecker(), context);
            });
          }
        });
        var SynthBindingNameKind;
        (function(SynthBindingNameKind2) {
          SynthBindingNameKind2[SynthBindingNameKind2["Identifier"] = 0] = "Identifier";
          SynthBindingNameKind2[SynthBindingNameKind2["BindingPattern"] = 1] = "BindingPattern";
        })(SynthBindingNameKind || (SynthBindingNameKind = {}));
        function convertToAsyncFunction(changes, sourceFile, position, checker, context) {
          var tokenAtPosition = ts2.getTokenAtPosition(sourceFile, position);
          var functionToConvert;
          if (ts2.isIdentifier(tokenAtPosition) && ts2.isVariableDeclaration(tokenAtPosition.parent) && tokenAtPosition.parent.initializer && ts2.isFunctionLikeDeclaration(tokenAtPosition.parent.initializer)) {
            functionToConvert = tokenAtPosition.parent.initializer;
          } else {
            functionToConvert = ts2.tryCast(ts2.getContainingFunction(ts2.getTokenAtPosition(sourceFile, position)), ts2.isFunctionLikeDeclaration);
          }
          if (!functionToConvert) {
            return;
          }
          var synthNamesMap = ts2.createMap();
          var isInJavascript = ts2.isInJSFile(functionToConvert);
          var setOfExpressionsToReturn = getAllPromiseExpressionsToReturn(functionToConvert, checker);
          var functionToConvertRenamed = renameCollidingVarNames(functionToConvert, checker, synthNamesMap, context.sourceFile);
          var returnStatements = functionToConvertRenamed.body && ts2.isBlock(functionToConvertRenamed.body) ? getReturnStatementsWithPromiseHandlers(functionToConvertRenamed.body) : ts2.emptyArray;
          var transformer = { checker, synthNamesMap, setOfExpressionsToReturn, isInJSFile: isInJavascript };
          if (!returnStatements.length) {
            return;
          }
          changes.insertLastModifierBefore(sourceFile, 126, functionToConvert);
          var _loop_12 = function(returnStatement2) {
            ts2.forEachChild(returnStatement2, function visit(node) {
              if (ts2.isCallExpression(node)) {
                var newNodes = transformExpression(node, transformer);
                changes.replaceNodeWithNodes(sourceFile, returnStatement2, newNodes);
              } else if (!ts2.isFunctionLike(node)) {
                ts2.forEachChild(node, visit);
              }
            });
          };
          for (var _i = 0, returnStatements_1 = returnStatements; _i < returnStatements_1.length; _i++) {
            var returnStatement = returnStatements_1[_i];
            _loop_12(returnStatement);
          }
        }
        function getReturnStatementsWithPromiseHandlers(body) {
          var res = [];
          ts2.forEachReturnStatement(body, function(ret) {
            if (ts2.isReturnStatementWithFixablePromiseHandler(ret))
              res.push(ret);
          });
          return res;
        }
        function getAllPromiseExpressionsToReturn(func, checker) {
          if (!func.body) {
            return ts2.createMap();
          }
          var setOfExpressionsToReturn = ts2.createMap();
          ts2.forEachChild(func.body, function visit(node) {
            if (isPromiseReturningCallExpression(node, checker, "then")) {
              setOfExpressionsToReturn.set(ts2.getNodeId(node).toString(), true);
              ts2.forEach(node.arguments, visit);
            } else if (isPromiseReturningCallExpression(node, checker, "catch")) {
              setOfExpressionsToReturn.set(ts2.getNodeId(node).toString(), true);
              ts2.forEachChild(node, visit);
            } else if (isPromiseTypedExpression(node, checker)) {
              setOfExpressionsToReturn.set(ts2.getNodeId(node).toString(), true);
            } else {
              ts2.forEachChild(node, visit);
            }
          });
          return setOfExpressionsToReturn;
        }
        function isPromiseReturningCallExpression(node, checker, name) {
          if (!ts2.isCallExpression(node))
            return false;
          var isExpressionOfName = ts2.hasPropertyAccessExpressionWithName(node, name);
          var nodeType = isExpressionOfName && checker.getTypeAtLocation(node);
          return !!(nodeType && checker.getPromisedTypeOfPromise(nodeType));
        }
        function isPromiseTypedExpression(node, checker) {
          if (!ts2.isExpression(node))
            return false;
          return !!checker.getPromisedTypeOfPromise(checker.getTypeAtLocation(node));
        }
        function declaredInFile(symbol, sourceFile) {
          return symbol.valueDeclaration && symbol.valueDeclaration.getSourceFile() === sourceFile;
        }
        function renameCollidingVarNames(nodeToRename, checker, synthNamesMap, sourceFile) {
          var identsToRenameMap = ts2.createMap();
          var collidingSymbolMap = ts2.createMultiMap();
          ts2.forEachChild(nodeToRename, function visit(node) {
            if (!ts2.isIdentifier(node)) {
              ts2.forEachChild(node, visit);
              return;
            }
            var symbol = checker.getSymbolAtLocation(node);
            var isDefinedInFile = symbol && declaredInFile(symbol, sourceFile);
            if (symbol && isDefinedInFile) {
              var type = checker.getTypeAtLocation(node);
              var lastCallSignature = getLastCallSignature(type, checker);
              var symbolIdString = ts2.getSymbolId(symbol).toString();
              if (lastCallSignature && !ts2.isFunctionLikeDeclaration(node.parent) && !synthNamesMap.has(symbolIdString)) {
                var firstParameter = ts2.firstOrUndefined(lastCallSignature.parameters);
                var ident = firstParameter && ts2.isParameter(firstParameter.valueDeclaration) && ts2.tryCast(firstParameter.valueDeclaration.name, ts2.isIdentifier) || ts2.createOptimisticUniqueName("result");
                var synthName = getNewNameIfConflict(ident, collidingSymbolMap);
                synthNamesMap.set(symbolIdString, synthName);
                collidingSymbolMap.add(ident.text, symbol);
              } else if (node.parent && (ts2.isParameter(node.parent) || ts2.isVariableDeclaration(node.parent) || ts2.isBindingElement(node.parent))) {
                var originalName = node.text;
                var collidingSymbols = collidingSymbolMap.get(originalName);
                if (collidingSymbols && collidingSymbols.some(function(prevSymbol) {
                  return prevSymbol !== symbol;
                })) {
                  var newName = getNewNameIfConflict(node, collidingSymbolMap);
                  identsToRenameMap.set(symbolIdString, newName.identifier);
                  synthNamesMap.set(symbolIdString, newName);
                  collidingSymbolMap.add(originalName, symbol);
                } else {
                  var identifier = ts2.getSynthesizedDeepClone(node);
                  synthNamesMap.set(symbolIdString, createSynthIdentifier(identifier));
                  collidingSymbolMap.add(originalName, symbol);
                }
              }
            }
          });
          return ts2.getSynthesizedDeepCloneWithRenames(nodeToRename, true, identsToRenameMap, checker);
        }
        function getNewNameIfConflict(name, originalNames) {
          var numVarsSameName = (originalNames.get(name.text) || ts2.emptyArray).length;
          var identifier = numVarsSameName === 0 ? name : ts2.createIdentifier(name.text + "_" + numVarsSameName);
          return createSynthIdentifier(identifier);
        }
        function silentFail() {
          codeActionSucceeded = false;
          return ts2.emptyArray;
        }
        function transformExpression(node, transformer, prevArgName) {
          if (isPromiseReturningCallExpression(node, transformer.checker, "then")) {
            if (node.arguments.length === 0)
              return silentFail();
            return transformThen(node, transformer, prevArgName);
          }
          if (isPromiseReturningCallExpression(node, transformer.checker, "catch")) {
            if (node.arguments.length === 0)
              return silentFail();
            return transformCatch(node, transformer, prevArgName);
          }
          if (ts2.isPropertyAccessExpression(node)) {
            return transformExpression(node.expression, transformer, prevArgName);
          }
          var nodeType = transformer.checker.getTypeAtLocation(node);
          if (nodeType && transformer.checker.getPromisedTypeOfPromise(nodeType)) {
            ts2.Debug.assertNode(node.original.parent, ts2.isPropertyAccessExpression);
            return transformPromiseExpressionOfPropertyAccess(node, transformer, prevArgName);
          }
          return silentFail();
        }
        function transformCatch(node, transformer, prevArgName) {
          var func = node.arguments[0];
          var argName = getArgBindingName(func, transformer);
          var possibleNameForVarDecl;
          if (prevArgName && !shouldReturn(node, transformer)) {
            if (isSynthIdentifier(prevArgName)) {
              possibleNameForVarDecl = prevArgName;
              transformer.synthNamesMap.forEach(function(val, key) {
                if (val.identifier.text === prevArgName.identifier.text) {
                  var newSynthName = createUniqueSynthName(prevArgName);
                  transformer.synthNamesMap.set(key, newSynthName);
                }
              });
            } else {
              possibleNameForVarDecl = createSynthIdentifier(ts2.createOptimisticUniqueName("result"), prevArgName.types);
            }
            possibleNameForVarDecl.hasBeenDeclared = true;
          }
          var tryBlock = ts2.createBlock(transformExpression(node.expression, transformer, possibleNameForVarDecl));
          var transformationBody = getTransformationBody(func, possibleNameForVarDecl, argName, node, transformer);
          var catchArg = argName ? isSynthIdentifier(argName) ? argName.identifier.text : argName.bindingPattern : "e";
          var catchVariableDeclaration = ts2.createVariableDeclaration(catchArg);
          var catchClause = ts2.createCatchClause(catchVariableDeclaration, ts2.createBlock(transformationBody));
          var varDeclList;
          var varDeclIdentifier;
          if (possibleNameForVarDecl && !shouldReturn(node, transformer)) {
            varDeclIdentifier = ts2.getSynthesizedDeepClone(possibleNameForVarDecl.identifier);
            var typeArray = possibleNameForVarDecl.types;
            var unionType = transformer.checker.getUnionType(typeArray, 2);
            var unionTypeNode = transformer.isInJSFile ? void 0 : transformer.checker.typeToTypeNode(unionType, void 0, void 0);
            var varDecl = [ts2.createVariableDeclaration(varDeclIdentifier, unionTypeNode)];
            varDeclList = ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList(varDecl, 1));
          }
          var tryStatement = ts2.createTry(tryBlock, catchClause, void 0);
          var destructuredResult = prevArgName && varDeclIdentifier && isSynthBindingPattern(prevArgName) && ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([ts2.createVariableDeclaration(ts2.getSynthesizedDeepCloneWithRenames(prevArgName.bindingPattern), void 0, varDeclIdentifier)], 2));
          return ts2.compact([varDeclList, tryStatement, destructuredResult]);
        }
        function createUniqueSynthName(prevArgName) {
          var renamedPrevArg = ts2.createOptimisticUniqueName(prevArgName.identifier.text);
          return createSynthIdentifier(renamedPrevArg);
        }
        function transformThen(node, transformer, prevArgName) {
          var _a = node.arguments, onFulfilled = _a[0], onRejected = _a[1];
          var onFulfilledArgumentName = getArgBindingName(onFulfilled, transformer);
          var transformationBody = getTransformationBody(onFulfilled, prevArgName, onFulfilledArgumentName, node, transformer);
          if (onRejected) {
            var onRejectedArgumentName = getArgBindingName(onRejected, transformer);
            var tryBlock = ts2.createBlock(transformExpression(node.expression, transformer, onFulfilledArgumentName).concat(transformationBody));
            var transformationBody2 = getTransformationBody(onRejected, prevArgName, onRejectedArgumentName, node, transformer);
            var catchArg = onRejectedArgumentName ? isSynthIdentifier(onRejectedArgumentName) ? onRejectedArgumentName.identifier.text : onRejectedArgumentName.bindingPattern : "e";
            var catchVariableDeclaration = ts2.createVariableDeclaration(catchArg);
            var catchClause = ts2.createCatchClause(catchVariableDeclaration, ts2.createBlock(transformationBody2));
            return [ts2.createTry(tryBlock, catchClause, void 0)];
          }
          return transformExpression(node.expression, transformer, onFulfilledArgumentName).concat(transformationBody);
        }
        function transformPromiseExpressionOfPropertyAccess(node, transformer, prevArgName) {
          if (shouldReturn(node, transformer)) {
            return [ts2.createReturn(ts2.getSynthesizedDeepClone(node))];
          }
          return createVariableOrAssignmentOrExpressionStatement(prevArgName, ts2.createAwait(node), void 0);
        }
        function createVariableOrAssignmentOrExpressionStatement(variableName, rightHandSide, typeAnnotation) {
          if (!variableName || isEmptyBindingName(variableName)) {
            return [ts2.createExpressionStatement(rightHandSide)];
          }
          if (isSynthIdentifier(variableName) && variableName.hasBeenDeclared) {
            return [ts2.createExpressionStatement(ts2.createAssignment(ts2.getSynthesizedDeepClone(variableName.identifier), rightHandSide))];
          }
          return [
            ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([
              ts2.createVariableDeclaration(ts2.getSynthesizedDeepClone(getNode(variableName)), typeAnnotation, rightHandSide)
            ], 2))
          ];
        }
        function maybeAnnotateAndReturn(expressionToReturn, typeAnnotation) {
          if (typeAnnotation && expressionToReturn) {
            var name = ts2.createOptimisticUniqueName("result");
            return __spreadArrays(createVariableOrAssignmentOrExpressionStatement(createSynthIdentifier(name), expressionToReturn, typeAnnotation), [
              ts2.createReturn(name)
            ]);
          }
          return [ts2.createReturn(expressionToReturn)];
        }
        function getTransformationBody(func, prevArgName, argName, parent, transformer) {
          var _a, _b, _c, _d;
          switch (func.kind) {
            case 100:
              break;
            case 75:
              if (!argName) {
                break;
              }
              var synthCall = ts2.createCall(ts2.getSynthesizedDeepClone(func), void 0, isSynthIdentifier(argName) ? [argName.identifier] : []);
              if (shouldReturn(parent, transformer)) {
                return maybeAnnotateAndReturn(synthCall, (_a = parent.typeArguments) === null || _a === void 0 ? void 0 : _a[0]);
              }
              var type = transformer.checker.getTypeAtLocation(func);
              var callSignatures = transformer.checker.getSignaturesOfType(type, 0);
              if (!callSignatures.length) {
                return silentFail();
              }
              var returnType = callSignatures[0].getReturnType();
              var varDeclOrAssignment = createVariableOrAssignmentOrExpressionStatement(prevArgName, ts2.createAwait(synthCall), (_b = parent.typeArguments) === null || _b === void 0 ? void 0 : _b[0]);
              if (prevArgName) {
                prevArgName.types.push(returnType);
              }
              return varDeclOrAssignment;
            case 201:
            case 202: {
              var funcBody = func.body;
              if (ts2.isBlock(funcBody)) {
                var refactoredStmts = [];
                var seenReturnStatement = false;
                for (var _i = 0, _e = funcBody.statements; _i < _e.length; _i++) {
                  var statement = _e[_i];
                  if (ts2.isReturnStatement(statement)) {
                    seenReturnStatement = true;
                    if (ts2.isReturnStatementWithFixablePromiseHandler(statement)) {
                      refactoredStmts = refactoredStmts.concat(getInnerTransformationBody(transformer, [statement], prevArgName));
                    } else {
                      refactoredStmts.push.apply(refactoredStmts, maybeAnnotateAndReturn(statement.expression, (_c = parent.typeArguments) === null || _c === void 0 ? void 0 : _c[0]));
                    }
                  } else {
                    refactoredStmts.push(statement);
                  }
                }
                return shouldReturn(parent, transformer) ? refactoredStmts.map(function(s) {
                  return ts2.getSynthesizedDeepClone(s);
                }) : removeReturns(refactoredStmts, prevArgName, transformer, seenReturnStatement);
              } else {
                var innerRetStmts = ts2.isFixablePromiseHandler(funcBody) ? [ts2.createReturn(funcBody)] : ts2.emptyArray;
                var innerCbBody = getInnerTransformationBody(transformer, innerRetStmts, prevArgName);
                if (innerCbBody.length > 0) {
                  return innerCbBody;
                }
                var type_1 = transformer.checker.getTypeAtLocation(func);
                var returnType_1 = getLastCallSignature(type_1, transformer.checker).getReturnType();
                var rightHandSide = ts2.getSynthesizedDeepClone(funcBody);
                var possiblyAwaitedRightHandSide = !!transformer.checker.getPromisedTypeOfPromise(returnType_1) ? ts2.createAwait(rightHandSide) : rightHandSide;
                if (!shouldReturn(parent, transformer)) {
                  var transformedStatement = createVariableOrAssignmentOrExpressionStatement(prevArgName, possiblyAwaitedRightHandSide, void 0);
                  if (prevArgName) {
                    prevArgName.types.push(returnType_1);
                  }
                  return transformedStatement;
                } else {
                  return maybeAnnotateAndReturn(possiblyAwaitedRightHandSide, (_d = parent.typeArguments) === null || _d === void 0 ? void 0 : _d[0]);
                }
              }
            }
            default:
              return silentFail();
          }
          return ts2.emptyArray;
        }
        function getLastCallSignature(type, checker) {
          var callSignatures = checker.getSignaturesOfType(type, 0);
          return ts2.lastOrUndefined(callSignatures);
        }
        function removeReturns(stmts, prevArgName, transformer, seenReturnStatement) {
          var ret = [];
          for (var _i = 0, stmts_1 = stmts; _i < stmts_1.length; _i++) {
            var stmt = stmts_1[_i];
            if (ts2.isReturnStatement(stmt)) {
              if (stmt.expression) {
                var possiblyAwaitedExpression = isPromiseTypedExpression(stmt.expression, transformer.checker) ? ts2.createAwait(stmt.expression) : stmt.expression;
                if (prevArgName === void 0) {
                  ret.push(ts2.createExpressionStatement(possiblyAwaitedExpression));
                } else {
                  ret.push(ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([ts2.createVariableDeclaration(getNode(prevArgName), void 0, possiblyAwaitedExpression)], 2)));
                }
              }
            } else {
              ret.push(ts2.getSynthesizedDeepClone(stmt));
            }
          }
          if (!seenReturnStatement && prevArgName !== void 0) {
            ret.push(ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([ts2.createVariableDeclaration(getNode(prevArgName), void 0, ts2.createIdentifier("undefined"))], 2)));
          }
          return ret;
        }
        function getInnerTransformationBody(transformer, innerRetStmts, prevArgName) {
          var innerCbBody = [];
          for (var _i = 0, innerRetStmts_1 = innerRetStmts; _i < innerRetStmts_1.length; _i++) {
            var stmt = innerRetStmts_1[_i];
            ts2.forEachChild(stmt, function visit(node) {
              if (ts2.isCallExpression(node)) {
                var temp = transformExpression(node, transformer, prevArgName);
                innerCbBody = innerCbBody.concat(temp);
                if (innerCbBody.length > 0) {
                  return;
                }
              } else if (!ts2.isFunctionLike(node)) {
                ts2.forEachChild(node, visit);
              }
            });
          }
          return innerCbBody;
        }
        function getArgBindingName(funcNode, transformer) {
          var types = [];
          var name;
          if (ts2.isFunctionLikeDeclaration(funcNode)) {
            if (funcNode.parameters.length > 0) {
              var param = funcNode.parameters[0].name;
              name = getMappedBindingNameOrDefault(param);
            }
          } else if (ts2.isIdentifier(funcNode)) {
            name = getMapEntryOrDefault(funcNode);
          }
          if (!name || "identifier" in name && name.identifier.text === "undefined") {
            return void 0;
          }
          return name;
          function getMappedBindingNameOrDefault(bindingName) {
            if (ts2.isIdentifier(bindingName))
              return getMapEntryOrDefault(bindingName);
            var elements = ts2.flatMap(bindingName.elements, function(element) {
              if (ts2.isOmittedExpression(element))
                return [];
              return [getMappedBindingNameOrDefault(element.name)];
            });
            return createSynthBindingPattern(bindingName, elements);
          }
          function getMapEntryOrDefault(identifier) {
            var originalNode = getOriginalNode(identifier);
            var symbol = getSymbol(originalNode);
            if (!symbol) {
              return createSynthIdentifier(identifier, types);
            }
            var mapEntry = transformer.synthNamesMap.get(ts2.getSymbolId(symbol).toString());
            return mapEntry || createSynthIdentifier(identifier, types);
          }
          function getSymbol(node) {
            return node.symbol ? node.symbol : transformer.checker.getSymbolAtLocation(node);
          }
          function getOriginalNode(node) {
            return node.original ? node.original : node;
          }
        }
        function isEmptyBindingName(bindingName) {
          if (!bindingName) {
            return true;
          }
          if (isSynthIdentifier(bindingName)) {
            return !bindingName.identifier.text;
          }
          return ts2.every(bindingName.elements, isEmptyBindingName);
        }
        function getNode(bindingName) {
          return isSynthIdentifier(bindingName) ? bindingName.identifier : bindingName.bindingPattern;
        }
        function createSynthIdentifier(identifier, types) {
          if (types === void 0) {
            types = [];
          }
          return { kind: 0, identifier, types, hasBeenDeclared: false };
        }
        function createSynthBindingPattern(bindingPattern, elements, types) {
          if (elements === void 0) {
            elements = ts2.emptyArray;
          }
          if (types === void 0) {
            types = [];
          }
          return { kind: 1, bindingPattern, elements, types };
        }
        function isSynthIdentifier(bindingName) {
          return bindingName.kind === 0;
        }
        function isSynthBindingPattern(bindingName) {
          return bindingName.kind === 1;
        }
        function shouldReturn(expression, transformer) {
          return !!expression.original && transformer.setOfExpressionsToReturn.has(ts2.getNodeId(expression.original).toString());
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        codefix2.registerCodeFix({
          errorCodes: [ts2.Diagnostics.File_is_a_CommonJS_module_it_may_be_converted_to_an_ES6_module.code],
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, program = context.program, preferences = context.preferences;
            var changes = ts2.textChanges.ChangeTracker.with(context, function(changes2) {
              var moduleExportsChangedToDefault = convertFileToEs6Module(sourceFile, program.getTypeChecker(), changes2, program.getCompilerOptions().target, ts2.getQuotePreference(sourceFile, preferences));
              if (moduleExportsChangedToDefault) {
                for (var _i = 0, _a = program.getSourceFiles(); _i < _a.length; _i++) {
                  var importingFile = _a[_i];
                  fixImportOfModuleExports(importingFile, sourceFile, changes2, ts2.getQuotePreference(importingFile, preferences));
                }
              }
            });
            return [codefix2.createCodeFixActionWithoutFixAll("convertToEs6Module", changes, ts2.Diagnostics.Convert_to_ES6_module)];
          }
        });
        function fixImportOfModuleExports(importingFile, exportingFile, changes, quotePreference) {
          for (var _i = 0, _a = importingFile.imports; _i < _a.length; _i++) {
            var moduleSpecifier = _a[_i];
            var imported = ts2.getResolvedModule(importingFile, moduleSpecifier.text);
            if (!imported || imported.resolvedFileName !== exportingFile.fileName) {
              continue;
            }
            var importNode = ts2.importFromModuleSpecifier(moduleSpecifier);
            switch (importNode.kind) {
              case 253:
                changes.replaceNode(importingFile, importNode, ts2.makeImport(importNode.name, void 0, moduleSpecifier, quotePreference));
                break;
              case 196:
                if (ts2.isRequireCall(importNode, false)) {
                  changes.replaceNode(importingFile, importNode, ts2.createPropertyAccess(ts2.getSynthesizedDeepClone(importNode), "default"));
                }
                break;
            }
          }
        }
        function convertFileToEs6Module(sourceFile, checker, changes, target, quotePreference) {
          var identifiers = { original: collectFreeIdentifiers(sourceFile), additional: ts2.createMap() };
          var exports2 = collectExportRenames(sourceFile, checker, identifiers);
          convertExportsAccesses(sourceFile, exports2, changes);
          var moduleExportsChangedToDefault = false;
          for (var _i = 0, _a = sourceFile.statements; _i < _a.length; _i++) {
            var statement = _a[_i];
            var moduleExportsChanged = convertStatement(sourceFile, statement, checker, changes, identifiers, target, exports2, quotePreference);
            moduleExportsChangedToDefault = moduleExportsChangedToDefault || moduleExportsChanged;
          }
          return moduleExportsChangedToDefault;
        }
        function collectExportRenames(sourceFile, checker, identifiers) {
          var res = ts2.createMap();
          forEachExportReference(sourceFile, function(node) {
            var _a = node.name, text = _a.text, originalKeywordKind = _a.originalKeywordKind;
            if (!res.has(text) && (originalKeywordKind !== void 0 && ts2.isNonContextualKeyword(originalKeywordKind) || checker.resolveName(text, node, 111551, true))) {
              res.set(text, makeUniqueName("_" + text, identifiers));
            }
          });
          return res;
        }
        function convertExportsAccesses(sourceFile, exports2, changes) {
          forEachExportReference(sourceFile, function(node, isAssignmentLhs) {
            if (isAssignmentLhs) {
              return;
            }
            var text = node.name.text;
            changes.replaceNode(sourceFile, node, ts2.createIdentifier(exports2.get(text) || text));
          });
        }
        function forEachExportReference(sourceFile, cb) {
          sourceFile.forEachChild(function recur(node) {
            if (ts2.isPropertyAccessExpression(node) && ts2.isExportsOrModuleExportsOrAlias(sourceFile, node.expression) && ts2.isIdentifier(node.name)) {
              var parent = node.parent;
              cb(node, ts2.isBinaryExpression(parent) && parent.left === node && parent.operatorToken.kind === 62);
            }
            node.forEachChild(recur);
          });
        }
        function convertStatement(sourceFile, statement, checker, changes, identifiers, target, exports2, quotePreference) {
          switch (statement.kind) {
            case 225:
              convertVariableStatement(sourceFile, statement, changes, checker, identifiers, target, quotePreference);
              return false;
            case 226: {
              var expression = statement.expression;
              switch (expression.kind) {
                case 196: {
                  if (ts2.isRequireCall(expression, true)) {
                    changes.replaceNode(sourceFile, statement, ts2.makeImport(void 0, void 0, expression.arguments[0], quotePreference));
                  }
                  return false;
                }
                case 209: {
                  var operatorToken = expression.operatorToken;
                  return operatorToken.kind === 62 && convertAssignment(sourceFile, checker, expression, changes, exports2);
                }
              }
            }
            default:
              return false;
          }
        }
        function convertVariableStatement(sourceFile, statement, changes, checker, identifiers, target, quotePreference) {
          var declarationList = statement.declarationList;
          var foundImport = false;
          var newNodes = ts2.flatMap(declarationList.declarations, function(decl) {
            var name = decl.name, initializer = decl.initializer;
            if (initializer) {
              if (ts2.isExportsOrModuleExportsOrAlias(sourceFile, initializer)) {
                foundImport = true;
                return [];
              } else if (ts2.isRequireCall(initializer, true)) {
                foundImport = true;
                return convertSingleImport(sourceFile, name, initializer.arguments[0], changes, checker, identifiers, target, quotePreference);
              } else if (ts2.isPropertyAccessExpression(initializer) && ts2.isRequireCall(initializer.expression, true)) {
                foundImport = true;
                return convertPropertyAccessImport(name, initializer.name.text, initializer.expression.arguments[0], identifiers, quotePreference);
              }
            }
            return ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([decl], declarationList.flags));
          });
          if (foundImport) {
            changes.replaceNodeWithNodes(sourceFile, statement, newNodes);
          }
        }
        function convertPropertyAccessImport(name, propertyName, moduleSpecifier, identifiers, quotePreference) {
          switch (name.kind) {
            case 189:
            case 190: {
              var tmp = makeUniqueName(propertyName, identifiers);
              return [
                makeSingleImport(tmp, propertyName, moduleSpecifier, quotePreference),
                makeConst(void 0, name, ts2.createIdentifier(tmp))
              ];
            }
            case 75:
              return [makeSingleImport(name.text, propertyName, moduleSpecifier, quotePreference)];
            default:
              return ts2.Debug.assertNever(name, "Convert to ES6 module got invalid syntax form " + name.kind);
          }
        }
        function convertAssignment(sourceFile, checker, assignment, changes, exports2) {
          var left = assignment.left, right = assignment.right;
          if (!ts2.isPropertyAccessExpression(left)) {
            return false;
          }
          if (ts2.isExportsOrModuleExportsOrAlias(sourceFile, left)) {
            if (ts2.isExportsOrModuleExportsOrAlias(sourceFile, right)) {
              changes.delete(sourceFile, assignment.parent);
            } else {
              var replacement = ts2.isObjectLiteralExpression(right) ? tryChangeModuleExportsObject(right) : ts2.isRequireCall(right, true) ? convertReExportAll(right.arguments[0], checker) : void 0;
              if (replacement) {
                changes.replaceNodeWithNodes(sourceFile, assignment.parent, replacement[0]);
                return replacement[1];
              } else {
                changes.replaceRangeWithText(sourceFile, ts2.createRange(left.getStart(sourceFile), right.pos), "export default");
                return true;
              }
            }
          } else if (ts2.isExportsOrModuleExportsOrAlias(sourceFile, left.expression)) {
            convertNamedExport(sourceFile, assignment, changes, exports2);
          }
          return false;
        }
        function tryChangeModuleExportsObject(object) {
          var statements = ts2.mapAllOrFail(object.properties, function(prop) {
            switch (prop.kind) {
              case 163:
              case 164:
              case 282:
              case 283:
                return void 0;
              case 281:
                return !ts2.isIdentifier(prop.name) ? void 0 : convertExportsDotXEquals_replaceNode(prop.name.text, prop.initializer);
              case 161:
                return !ts2.isIdentifier(prop.name) ? void 0 : functionExpressionToDeclaration(prop.name.text, [ts2.createToken(89)], prop);
              default:
                ts2.Debug.assertNever(prop, "Convert to ES6 got invalid prop kind " + prop.kind);
            }
          });
          return statements && [statements, false];
        }
        function convertNamedExport(sourceFile, assignment, changes, exports2) {
          var text = assignment.left.name.text;
          var rename = exports2.get(text);
          if (rename !== void 0) {
            var newNodes = [
              makeConst(void 0, rename, assignment.right),
              makeExportDeclaration([ts2.createExportSpecifier(rename, text)])
            ];
            changes.replaceNodeWithNodes(sourceFile, assignment.parent, newNodes);
          } else {
            convertExportsPropertyAssignment(assignment, sourceFile, changes);
          }
        }
        function convertReExportAll(reExported, checker) {
          var moduleSpecifier = reExported.text;
          var moduleSymbol = checker.getSymbolAtLocation(reExported);
          var exports2 = moduleSymbol ? moduleSymbol.exports : ts2.emptyUnderscoreEscapedMap;
          return exports2.has("export=") ? [[reExportDefault(moduleSpecifier)], true] : !exports2.has("default") ? [[reExportStar(moduleSpecifier)], false] : exports2.size > 1 ? [[reExportStar(moduleSpecifier), reExportDefault(moduleSpecifier)], true] : [[reExportDefault(moduleSpecifier)], true];
        }
        function reExportStar(moduleSpecifier) {
          return makeExportDeclaration(void 0, moduleSpecifier);
        }
        function reExportDefault(moduleSpecifier) {
          return makeExportDeclaration([ts2.createExportSpecifier(void 0, "default")], moduleSpecifier);
        }
        function convertExportsPropertyAssignment(_a, sourceFile, changes) {
          var left = _a.left, right = _a.right, parent = _a.parent;
          var name = left.name.text;
          if ((ts2.isFunctionExpression(right) || ts2.isArrowFunction(right) || ts2.isClassExpression(right)) && (!right.name || right.name.text === name)) {
            changes.replaceRange(sourceFile, { pos: left.getStart(sourceFile), end: right.getStart(sourceFile) }, ts2.createToken(89), { suffix: " " });
            if (!right.name)
              changes.insertName(sourceFile, right, name);
            var semi = ts2.findChildOfKind(parent, 26, sourceFile);
            if (semi)
              changes.delete(sourceFile, semi);
          } else {
            changes.replaceNodeRangeWithNodes(sourceFile, left.expression, ts2.findChildOfKind(left, 24, sourceFile), [ts2.createToken(89), ts2.createToken(81)], { joiner: " ", suffix: " " });
          }
        }
        function convertExportsDotXEquals_replaceNode(name, exported) {
          var modifiers = [ts2.createToken(89)];
          switch (exported.kind) {
            case 201: {
              var expressionName = exported.name;
              if (expressionName && expressionName.text !== name) {
                return exportConst();
              }
            }
            case 202:
              return functionExpressionToDeclaration(name, modifiers, exported);
            case 214:
              return classExpressionToDeclaration(name, modifiers, exported);
            default:
              return exportConst();
          }
          function exportConst() {
            return makeConst(modifiers, ts2.createIdentifier(name), exported);
          }
        }
        function convertSingleImport(file, name, moduleSpecifier, changes, checker, identifiers, target, quotePreference) {
          switch (name.kind) {
            case 189: {
              var importSpecifiers = ts2.mapAllOrFail(name.elements, function(e) {
                return e.dotDotDotToken || e.initializer || e.propertyName && !ts2.isIdentifier(e.propertyName) || !ts2.isIdentifier(e.name) ? void 0 : makeImportSpecifier(e.propertyName && e.propertyName.text, e.name.text);
              });
              if (importSpecifiers) {
                return [ts2.makeImport(void 0, importSpecifiers, moduleSpecifier, quotePreference)];
              }
            }
            case 190: {
              var tmp = makeUniqueName(codefix2.moduleSpecifierToValidIdentifier(moduleSpecifier.text, target), identifiers);
              return [
                ts2.makeImport(ts2.createIdentifier(tmp), void 0, moduleSpecifier, quotePreference),
                makeConst(void 0, ts2.getSynthesizedDeepClone(name), ts2.createIdentifier(tmp))
              ];
            }
            case 75:
              return convertSingleIdentifierImport(file, name, moduleSpecifier, changes, checker, identifiers, quotePreference);
            default:
              return ts2.Debug.assertNever(name, "Convert to ES6 module got invalid name kind " + name.kind);
          }
        }
        function convertSingleIdentifierImport(file, name, moduleSpecifier, changes, checker, identifiers, quotePreference) {
          var nameSymbol = checker.getSymbolAtLocation(name);
          var namedBindingsNames = ts2.createMap();
          var needDefaultImport = false;
          for (var _i = 0, _a = identifiers.original.get(name.text); _i < _a.length; _i++) {
            var use = _a[_i];
            if (checker.getSymbolAtLocation(use) !== nameSymbol || use === name) {
              continue;
            }
            var parent = use.parent;
            if (ts2.isPropertyAccessExpression(parent)) {
              var expression = parent.expression, propertyName = parent.name.text;
              ts2.Debug.assert(expression === use, "Didn't expect expression === use");
              var idName = namedBindingsNames.get(propertyName);
              if (idName === void 0) {
                idName = makeUniqueName(propertyName, identifiers);
                namedBindingsNames.set(propertyName, idName);
              }
              changes.replaceNode(file, parent, ts2.createIdentifier(idName));
            } else {
              needDefaultImport = true;
            }
          }
          var namedBindings = namedBindingsNames.size === 0 ? void 0 : ts2.arrayFrom(ts2.mapIterator(namedBindingsNames.entries(), function(_a2) {
            var propertyName2 = _a2[0], idName2 = _a2[1];
            return ts2.createImportSpecifier(propertyName2 === idName2 ? void 0 : ts2.createIdentifier(propertyName2), ts2.createIdentifier(idName2));
          }));
          if (!namedBindings) {
            needDefaultImport = true;
          }
          return [ts2.makeImport(needDefaultImport ? ts2.getSynthesizedDeepClone(name) : void 0, namedBindings, moduleSpecifier, quotePreference)];
        }
        function makeUniqueName(name, identifiers) {
          while (identifiers.original.has(name) || identifiers.additional.has(name)) {
            name = "_" + name;
          }
          identifiers.additional.set(name, true);
          return name;
        }
        function collectFreeIdentifiers(file) {
          var map = ts2.createMultiMap();
          forEachFreeIdentifier(file, function(id) {
            return map.add(id.text, id);
          });
          return map;
        }
        function forEachFreeIdentifier(node, cb) {
          if (ts2.isIdentifier(node) && isFreeIdentifier(node))
            cb(node);
          node.forEachChild(function(child) {
            return forEachFreeIdentifier(child, cb);
          });
        }
        function isFreeIdentifier(node) {
          var parent = node.parent;
          switch (parent.kind) {
            case 194:
              return parent.name !== node;
            case 191:
              return parent.propertyName !== node;
            case 258:
              return parent.propertyName !== node;
            default:
              return true;
          }
        }
        function functionExpressionToDeclaration(name, additionalModifiers, fn) {
          return ts2.createFunctionDeclaration(ts2.getSynthesizedDeepClones(fn.decorators), ts2.concatenate(additionalModifiers, ts2.getSynthesizedDeepClones(fn.modifiers)), ts2.getSynthesizedDeepClone(fn.asteriskToken), name, ts2.getSynthesizedDeepClones(fn.typeParameters), ts2.getSynthesizedDeepClones(fn.parameters), ts2.getSynthesizedDeepClone(fn.type), ts2.convertToFunctionBody(ts2.getSynthesizedDeepClone(fn.body)));
        }
        function classExpressionToDeclaration(name, additionalModifiers, cls) {
          return ts2.createClassDeclaration(ts2.getSynthesizedDeepClones(cls.decorators), ts2.concatenate(additionalModifiers, ts2.getSynthesizedDeepClones(cls.modifiers)), name, ts2.getSynthesizedDeepClones(cls.typeParameters), ts2.getSynthesizedDeepClones(cls.heritageClauses), ts2.getSynthesizedDeepClones(cls.members));
        }
        function makeSingleImport(localName, propertyName, moduleSpecifier, quotePreference) {
          return propertyName === "default" ? ts2.makeImport(ts2.createIdentifier(localName), void 0, moduleSpecifier, quotePreference) : ts2.makeImport(void 0, [makeImportSpecifier(propertyName, localName)], moduleSpecifier, quotePreference);
        }
        function makeImportSpecifier(propertyName, name) {
          return ts2.createImportSpecifier(propertyName !== void 0 && propertyName !== name ? ts2.createIdentifier(propertyName) : void 0, ts2.createIdentifier(name));
        }
        function makeConst(modifiers, name, init) {
          return ts2.createVariableStatement(modifiers, ts2.createVariableDeclarationList([ts2.createVariableDeclaration(name, void 0, init)], 2));
        }
        function makeExportDeclaration(exportSpecifiers, moduleSpecifier) {
          return ts2.createExportDeclaration(void 0, void 0, exportSpecifiers && ts2.createNamedExports(exportSpecifiers), moduleSpecifier === void 0 ? void 0 : ts2.createLiteral(moduleSpecifier));
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "correctQualifiedNameToIndexedAccessType";
        var errorCodes = [ts2.Diagnostics.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var qualifiedName = getQualifiedName(context.sourceFile, context.span.start);
            if (!qualifiedName)
              return void 0;
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, context.sourceFile, qualifiedName);
            });
            var newText = qualifiedName.left.text + '["' + qualifiedName.right.text + '"]';
            return [codefix2.createCodeFixAction(fixId, changes, [ts2.Diagnostics.Rewrite_as_the_indexed_access_type_0, newText], fixId, ts2.Diagnostics.Rewrite_all_as_indexed_access_types)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var q = getQualifiedName(diag.file, diag.start);
              if (q) {
                doChange(changes, diag.file, q);
              }
            });
          }
        });
        function getQualifiedName(sourceFile, pos) {
          var qualifiedName = ts2.findAncestor(ts2.getTokenAtPosition(sourceFile, pos), ts2.isQualifiedName);
          ts2.Debug.assert(!!qualifiedName, "Expected position to be owned by a qualified name.");
          return ts2.isIdentifier(qualifiedName.left) ? qualifiedName : void 0;
        }
        function doChange(changeTracker, sourceFile, qualifiedName) {
          var rightText = qualifiedName.right.text;
          var replacement = ts2.createIndexedAccessTypeNode(ts2.createTypeReferenceNode(qualifiedName.left, void 0), ts2.createLiteralTypeNode(ts2.createLiteral(rightText)));
          changeTracker.replaceNode(sourceFile, qualifiedName, replacement);
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var errorCodes = [ts2.Diagnostics.Re_exporting_a_type_when_the_isolatedModules_flag_is_provided_requires_using_export_type.code];
        var fixId = "convertToTypeOnlyExport";
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return fixSingleExportDeclaration(t, getExportSpecifierForDiagnosticSpan(context.span, context.sourceFile), context);
            });
            if (changes.length) {
              return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Convert_to_type_only_export, fixId, ts2.Diagnostics.Convert_all_re_exported_types_to_type_only_exports)];
            }
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var fixedExportDeclarations = ts2.createMap();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var exportSpecifier = getExportSpecifierForDiagnosticSpan(diag, context.sourceFile);
              if (exportSpecifier && !ts2.addToSeen(fixedExportDeclarations, ts2.getNodeId(exportSpecifier.parent.parent))) {
                fixSingleExportDeclaration(changes, exportSpecifier, context);
              }
            });
          }
        });
        function getExportSpecifierForDiagnosticSpan(span, sourceFile) {
          return ts2.tryCast(ts2.getTokenAtPosition(sourceFile, span.start).parent, ts2.isExportSpecifier);
        }
        function fixSingleExportDeclaration(changes, exportSpecifier, context) {
          if (!exportSpecifier) {
            return;
          }
          var exportClause = exportSpecifier.parent;
          var exportDeclaration = exportClause.parent;
          var typeExportSpecifiers = getTypeExportSpecifiers(exportSpecifier, context);
          if (typeExportSpecifiers.length === exportClause.elements.length) {
            changes.replaceNode(context.sourceFile, exportDeclaration, ts2.updateExportDeclaration(exportDeclaration, exportDeclaration.decorators, exportDeclaration.modifiers, exportClause, exportDeclaration.moduleSpecifier, true));
          } else {
            var valueExportDeclaration = ts2.updateExportDeclaration(exportDeclaration, exportDeclaration.decorators, exportDeclaration.modifiers, ts2.updateNamedExports(exportClause, ts2.filter(exportClause.elements, function(e) {
              return !ts2.contains(typeExportSpecifiers, e);
            })), exportDeclaration.moduleSpecifier, false);
            var typeExportDeclaration = ts2.createExportDeclaration(void 0, void 0, ts2.createNamedExports(typeExportSpecifiers), exportDeclaration.moduleSpecifier, true);
            changes.replaceNode(context.sourceFile, exportDeclaration, valueExportDeclaration);
            changes.insertNodeAfter(context.sourceFile, exportDeclaration, typeExportDeclaration);
          }
        }
        function getTypeExportSpecifiers(originExportSpecifier, context) {
          var exportClause = originExportSpecifier.parent;
          if (exportClause.elements.length === 1) {
            return exportClause.elements;
          }
          var diagnostics = ts2.getDiagnosticsWithinSpan(ts2.createTextSpanFromNode(exportClause), context.program.getSemanticDiagnostics(context.sourceFile, context.cancellationToken));
          return ts2.filter(exportClause.elements, function(element) {
            var _a;
            return element === originExportSpecifier || ((_a = ts2.findDiagnosticForNode(element, diagnostics)) === null || _a === void 0 ? void 0 : _a.code) === errorCodes[0];
          });
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var errorCodes = [ts2.Diagnostics.This_import_is_never_used_as_a_value_and_must_use_import_type_because_the_importsNotUsedAsValues_is_set_to_error.code];
        var fixId = "convertToTypeOnlyImport";
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              var importDeclaration = getImportDeclarationForDiagnosticSpan(context.span, context.sourceFile);
              fixSingleImportDeclaration(t, importDeclaration, context);
            });
            if (changes.length) {
              return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Convert_to_type_only_import, fixId, ts2.Diagnostics.Convert_all_imports_not_used_as_a_value_to_type_only_imports)];
            }
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var importDeclaration = getImportDeclarationForDiagnosticSpan(diag, context.sourceFile);
              fixSingleImportDeclaration(changes, importDeclaration, context);
            });
          }
        });
        function getImportDeclarationForDiagnosticSpan(span, sourceFile) {
          return ts2.tryCast(ts2.getTokenAtPosition(sourceFile, span.start).parent, ts2.isImportDeclaration);
        }
        function fixSingleImportDeclaration(changes, importDeclaration, context) {
          if (!(importDeclaration === null || importDeclaration === void 0 ? void 0 : importDeclaration.importClause)) {
            return;
          }
          var importClause = importDeclaration.importClause;
          changes.insertText(context.sourceFile, importDeclaration.getStart() + "import".length, " type");
          if (importClause.name && importClause.namedBindings) {
            changes.deleteNodeRangeExcludingEnd(context.sourceFile, importClause.name, importDeclaration.importClause.namedBindings);
            changes.insertNodeBefore(context.sourceFile, importDeclaration, ts2.updateImportDeclaration(importDeclaration, void 0, void 0, ts2.createImportClause(importClause.name, void 0, true), importDeclaration.moduleSpecifier));
          }
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var errorCodes = [
          ts2.Diagnostics.Class_0_incorrectly_implements_interface_1.code,
          ts2.Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass.code
        ];
        var fixId = "fixClassIncorrectlyImplementsInterface";
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var classDeclaration = getClass(sourceFile, span.start);
            return ts2.mapDefined(ts2.getEffectiveImplementsTypeNodes(classDeclaration), function(implementedTypeNode) {
              var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
                return addMissingDeclarations(context, implementedTypeNode, sourceFile, classDeclaration, t, context.preferences);
              });
              return changes.length === 0 ? void 0 : codefix2.createCodeFixAction(fixId, changes, [ts2.Diagnostics.Implement_interface_0, implementedTypeNode.getText(sourceFile)], fixId, ts2.Diagnostics.Implement_all_unimplemented_interfaces);
            });
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var seenClassDeclarations = ts2.createMap();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var classDeclaration = getClass(diag.file, diag.start);
              if (ts2.addToSeen(seenClassDeclarations, ts2.getNodeId(classDeclaration))) {
                for (var _i = 0, _a = ts2.getEffectiveImplementsTypeNodes(classDeclaration); _i < _a.length; _i++) {
                  var implementedTypeNode = _a[_i];
                  addMissingDeclarations(context, implementedTypeNode, diag.file, classDeclaration, changes, context.preferences);
                }
              }
            });
          }
        });
        function getClass(sourceFile, pos) {
          return ts2.Debug.checkDefined(ts2.getContainingClass(ts2.getTokenAtPosition(sourceFile, pos)), "There should be a containing class");
        }
        function symbolPointsToNonPrivateMember(symbol) {
          return !symbol.valueDeclaration || !(ts2.getModifierFlags(symbol.valueDeclaration) & 8);
        }
        function addMissingDeclarations(context, implementedTypeNode, sourceFile, classDeclaration, changeTracker, preferences) {
          var checker = context.program.getTypeChecker();
          var maybeHeritageClauseSymbol = getHeritageClauseSymbolTable(classDeclaration, checker);
          var implementedType = checker.getTypeAtLocation(implementedTypeNode);
          var implementedTypeSymbols = checker.getPropertiesOfType(implementedType);
          var nonPrivateAndNotExistedInHeritageClauseMembers = implementedTypeSymbols.filter(ts2.and(symbolPointsToNonPrivateMember, function(symbol) {
            return !maybeHeritageClauseSymbol.has(symbol.escapedName);
          }));
          var classType = checker.getTypeAtLocation(classDeclaration);
          var constructor = ts2.find(classDeclaration.members, function(m) {
            return ts2.isConstructorDeclaration(m);
          });
          if (!classType.getNumberIndexType()) {
            createMissingIndexSignatureDeclaration(implementedType, 1);
          }
          if (!classType.getStringIndexType()) {
            createMissingIndexSignatureDeclaration(implementedType, 0);
          }
          var importAdder = codefix2.createImportAdder(sourceFile, context.program, preferences, context.host);
          codefix2.createMissingMemberNodes(classDeclaration, nonPrivateAndNotExistedInHeritageClauseMembers, context, preferences, importAdder, function(member) {
            return insertInterfaceMemberNode(sourceFile, classDeclaration, member);
          });
          importAdder.writeFixes(changeTracker);
          function createMissingIndexSignatureDeclaration(type, kind) {
            var indexInfoOfKind = checker.getIndexInfoOfType(type, kind);
            if (indexInfoOfKind) {
              insertInterfaceMemberNode(sourceFile, classDeclaration, checker.indexInfoToIndexSignatureDeclaration(indexInfoOfKind, kind, classDeclaration, void 0, codefix2.getNoopSymbolTrackerWithResolver(context)));
            }
          }
          function insertInterfaceMemberNode(sourceFile2, cls, newElement) {
            if (constructor) {
              changeTracker.insertNodeAfter(sourceFile2, constructor, newElement);
            } else {
              changeTracker.insertNodeAtClassStart(sourceFile2, cls, newElement);
            }
          }
        }
        function getHeritageClauseSymbolTable(classDeclaration, checker) {
          var heritageClauseNode = ts2.getEffectiveBaseTypeNode(classDeclaration);
          if (!heritageClauseNode)
            return ts2.createSymbolTable();
          var heritageClauseType = checker.getTypeAtLocation(heritageClauseNode);
          var heritageClauseTypeSymbols = checker.getPropertiesOfType(heritageClauseType);
          return ts2.createSymbolTable(heritageClauseTypeSymbols.filter(symbolPointsToNonPrivateMember));
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        codefix2.importFixName = "import";
        var importFixId = "fixMissingImport";
        var errorCodes = [
          ts2.Diagnostics.Cannot_find_name_0.code,
          ts2.Diagnostics.Cannot_find_name_0_Did_you_mean_1.code,
          ts2.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,
          ts2.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code,
          ts2.Diagnostics.Cannot_find_namespace_0.code,
          ts2.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead.code,
          ts2.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var errorCode = context.errorCode, preferences = context.preferences, sourceFile = context.sourceFile, span = context.span;
            var info = getFixesInfo(context, errorCode, span.start);
            if (!info)
              return void 0;
            var fixes = info.fixes, symbolName = info.symbolName;
            var quotePreference = ts2.getQuotePreference(sourceFile, preferences);
            return fixes.map(function(fix) {
              return codeActionForFix(context, sourceFile, symbolName, fix, quotePreference);
            });
          },
          fixIds: [importFixId],
          getAllCodeActions: function(context) {
            var sourceFile = context.sourceFile, program = context.program, preferences = context.preferences, host = context.host;
            var importAdder = createImportAdder(sourceFile, program, preferences, host);
            codefix2.eachDiagnostic(context, errorCodes, function(diag) {
              return importAdder.addImportFromDiagnostic(diag, context);
            });
            return codefix2.createCombinedCodeActions(ts2.textChanges.ChangeTracker.with(context, importAdder.writeFixes));
          }
        });
        function createImportAdder(sourceFile, program, preferences, host) {
          var compilerOptions = program.getCompilerOptions();
          var addToNamespace = [];
          var importType = [];
          var addToExisting = ts2.createMap();
          var newImports = ts2.createMap();
          return { addImportFromDiagnostic, addImportFromExportedSymbol, writeFixes };
          function addImportFromDiagnostic(diagnostic, context) {
            var info = getFixesInfo(context, diagnostic.code, diagnostic.start);
            if (!info || !info.fixes.length)
              return;
            addImport(info);
          }
          function addImportFromExportedSymbol(exportedSymbol, usageIsTypeOnly) {
            var moduleSymbol = ts2.Debug.checkDefined(exportedSymbol.parent);
            var symbolName = ts2.getNameForExportedSymbol(exportedSymbol, ts2.getEmitScriptTarget(compilerOptions));
            var checker = program.getTypeChecker();
            var symbol = checker.getMergedSymbol(ts2.skipAlias(exportedSymbol, checker));
            var exportInfos = getAllReExportingModules(sourceFile, symbol, moduleSymbol, symbolName, sourceFile, compilerOptions, checker, program.getSourceFiles());
            var preferTypeOnlyImport = !!usageIsTypeOnly && compilerOptions.importsNotUsedAsValues === 2;
            var useRequire = shouldUseRequire(sourceFile, compilerOptions);
            var fix = getImportFixForSymbol(sourceFile, exportInfos, moduleSymbol, symbolName, program, void 0, preferTypeOnlyImport, useRequire, host, preferences);
            addImport({ fixes: [fix], symbolName });
          }
          function addImport(info) {
            var fixes = info.fixes, symbolName = info.symbolName;
            var fix = ts2.first(fixes);
            switch (fix.kind) {
              case 0:
                addToNamespace.push(fix);
                break;
              case 1:
                importType.push(fix);
                break;
              case 2: {
                var importClauseOrBindingPattern = fix.importClauseOrBindingPattern, importKind = fix.importKind, canUseTypeOnlyImport = fix.canUseTypeOnlyImport;
                var key = String(ts2.getNodeId(importClauseOrBindingPattern));
                var entry = addToExisting.get(key);
                if (!entry) {
                  addToExisting.set(key, entry = { importClauseOrBindingPattern, defaultImport: void 0, namedImports: [], canUseTypeOnlyImport });
                }
                if (importKind === 0) {
                  ts2.pushIfUnique(entry.namedImports, symbolName);
                } else {
                  ts2.Debug.assert(entry.defaultImport === void 0 || entry.defaultImport === symbolName, "(Add to Existing) Default import should be missing or match symbolName");
                  entry.defaultImport = symbolName;
                }
                break;
              }
              case 3: {
                var moduleSpecifier = fix.moduleSpecifier, importKind = fix.importKind, useRequire = fix.useRequire, typeOnly = fix.typeOnly;
                var entry = newImports.get(moduleSpecifier);
                if (!entry) {
                  newImports.set(moduleSpecifier, entry = { namedImports: [], namespaceLikeImport: void 0, typeOnly, useRequire });
                } else {
                  entry.typeOnly = entry.typeOnly && typeOnly;
                }
                switch (importKind) {
                  case 1:
                    ts2.Debug.assert(entry.defaultImport === void 0 || entry.defaultImport === symbolName, "(Add new) Default import should be missing or match symbolName");
                    entry.defaultImport = symbolName;
                    break;
                  case 0:
                    ts2.pushIfUnique(entry.namedImports || (entry.namedImports = []), symbolName);
                    break;
                  case 3:
                  case 2:
                    ts2.Debug.assert(entry.namespaceLikeImport === void 0 || entry.namespaceLikeImport.name === symbolName, "Namespacelike import shoudl be missing or match symbolName");
                    entry.namespaceLikeImport = { importKind, name: symbolName };
                    break;
                }
                break;
              }
              default:
                ts2.Debug.assertNever(fix, "fix wasn't never - got kind " + fix.kind);
            }
          }
          function writeFixes(changeTracker) {
            var quotePreference = ts2.getQuotePreference(sourceFile, preferences);
            for (var _i = 0, addToNamespace_1 = addToNamespace; _i < addToNamespace_1.length; _i++) {
              var fix = addToNamespace_1[_i];
              addNamespaceQualifier(changeTracker, sourceFile, fix);
            }
            for (var _a = 0, importType_1 = importType; _a < importType_1.length; _a++) {
              var fix = importType_1[_a];
              addImportType(changeTracker, sourceFile, fix, quotePreference);
            }
            addToExisting.forEach(function(_a2) {
              var importClauseOrBindingPattern = _a2.importClauseOrBindingPattern, defaultImport = _a2.defaultImport, namedImports = _a2.namedImports, canUseTypeOnlyImport = _a2.canUseTypeOnlyImport;
              doAddExistingFix(changeTracker, sourceFile, importClauseOrBindingPattern, defaultImport, namedImports, canUseTypeOnlyImport);
            });
            var newDeclarations;
            newImports.forEach(function(_a2, moduleSpecifier) {
              var useRequire = _a2.useRequire, imports = __rest(_a2, ["useRequire"]);
              var getDeclarations = useRequire ? getNewRequires : getNewImports;
              newDeclarations = ts2.combine(newDeclarations, getDeclarations(moduleSpecifier, quotePreference, imports));
            });
            if (newDeclarations) {
              ts2.insertImports(changeTracker, sourceFile, newDeclarations, true);
            }
          }
        }
        codefix2.createImportAdder = createImportAdder;
        var ImportFixKind;
        (function(ImportFixKind2) {
          ImportFixKind2[ImportFixKind2["UseNamespace"] = 0] = "UseNamespace";
          ImportFixKind2[ImportFixKind2["ImportType"] = 1] = "ImportType";
          ImportFixKind2[ImportFixKind2["AddToExisting"] = 2] = "AddToExisting";
          ImportFixKind2[ImportFixKind2["AddNew"] = 3] = "AddNew";
        })(ImportFixKind || (ImportFixKind = {}));
        var ImportKind;
        (function(ImportKind2) {
          ImportKind2[ImportKind2["Named"] = 0] = "Named";
          ImportKind2[ImportKind2["Default"] = 1] = "Default";
          ImportKind2[ImportKind2["Namespace"] = 2] = "Namespace";
          ImportKind2[ImportKind2["CommonJS"] = 3] = "CommonJS";
        })(ImportKind || (ImportKind = {}));
        function getImportCompletionAction(exportedSymbol, moduleSymbol, sourceFile, symbolName, host, program, formatContext, position, preferences) {
          var compilerOptions = program.getCompilerOptions();
          var exportInfos = getAllReExportingModules(sourceFile, exportedSymbol, moduleSymbol, symbolName, sourceFile, compilerOptions, program.getTypeChecker(), program.getSourceFiles());
          var useRequire = shouldUseRequire(sourceFile, compilerOptions);
          var preferTypeOnlyImport = compilerOptions.importsNotUsedAsValues === 2 && !ts2.isSourceFileJS(sourceFile) && ts2.isValidTypeOnlyAliasUseSite(ts2.getTokenAtPosition(sourceFile, position));
          var moduleSpecifier = ts2.first(getNewImportInfos(program, sourceFile, position, preferTypeOnlyImport, useRequire, exportInfos, host, preferences)).moduleSpecifier;
          var fix = getImportFixForSymbol(sourceFile, exportInfos, moduleSymbol, symbolName, program, position, preferTypeOnlyImport, useRequire, host, preferences);
          return { moduleSpecifier, codeAction: codeFixActionToCodeAction(codeActionForFix({ host, formatContext, preferences }, sourceFile, symbolName, fix, ts2.getQuotePreference(sourceFile, preferences))) };
        }
        codefix2.getImportCompletionAction = getImportCompletionAction;
        function getImportFixForSymbol(sourceFile, exportInfos, moduleSymbol, symbolName, program, position, preferTypeOnlyImport, useRequire, host, preferences) {
          ts2.Debug.assert(exportInfos.some(function(info) {
            return info.moduleSymbol === moduleSymbol;
          }), "Some exportInfo should match the specified moduleSymbol");
          return ts2.first(getFixForImport(exportInfos, symbolName, position, preferTypeOnlyImport, useRequire, program, sourceFile, host, preferences));
        }
        function codeFixActionToCodeAction(_a) {
          var description = _a.description, changes = _a.changes, commands = _a.commands;
          return { description, changes, commands };
        }
        function getAllReExportingModules(importingFile, exportedSymbol, exportingModuleSymbol, symbolName, sourceFile, compilerOptions, checker, allSourceFiles) {
          var result = [];
          forEachExternalModule(checker, allSourceFiles, function(moduleSymbol, moduleFile) {
            if (moduleFile && moduleSymbol !== exportingModuleSymbol && ts2.startsWith(sourceFile.fileName, ts2.getDirectoryPath(moduleFile.fileName))) {
              return;
            }
            var defaultInfo = getDefaultLikeExportInfo(importingFile, moduleSymbol, checker, compilerOptions);
            if (defaultInfo && defaultInfo.name === symbolName && ts2.skipAlias(defaultInfo.symbol, checker) === exportedSymbol) {
              result.push({ moduleSymbol, importKind: defaultInfo.kind, exportedSymbolIsTypeOnly: isTypeOnlySymbol(defaultInfo.symbol, checker) });
            }
            for (var _i = 0, _a = checker.getExportsAndPropertiesOfModule(moduleSymbol); _i < _a.length; _i++) {
              var exported = _a[_i];
              if (exported.name === symbolName && ts2.skipAlias(exported, checker) === exportedSymbol) {
                result.push({ moduleSymbol, importKind: 0, exportedSymbolIsTypeOnly: isTypeOnlySymbol(exported, checker) });
              }
            }
          });
          return result;
        }
        function isTypeOnlySymbol(s, checker) {
          return !(ts2.skipAlias(s, checker).flags & 111551);
        }
        function isTypeOnlyPosition(sourceFile, position) {
          return ts2.isValidTypeOnlyAliasUseSite(ts2.getTokenAtPosition(sourceFile, position));
        }
        function getFixForImport(exportInfos, symbolName, position, preferTypeOnlyImport, useRequire, program, sourceFile, host, preferences) {
          var checker = program.getTypeChecker();
          var existingImports = ts2.flatMap(exportInfos, function(info) {
            return getExistingImportDeclarations(info, checker, sourceFile);
          });
          var useNamespace = position === void 0 ? void 0 : tryUseExistingNamespaceImport(existingImports, symbolName, position, checker);
          var addToExisting = tryAddToExistingImport(existingImports, position !== void 0 && isTypeOnlyPosition(sourceFile, position));
          var addImport = addToExisting ? [addToExisting] : getFixesForAddImport(exportInfos, existingImports, program, sourceFile, position, preferTypeOnlyImport, useRequire, host, preferences);
          return __spreadArrays(useNamespace ? [useNamespace] : ts2.emptyArray, addImport);
        }
        function tryUseExistingNamespaceImport(existingImports, symbolName, position, checker) {
          return ts2.firstDefined(existingImports, function(_a) {
            var declaration = _a.declaration;
            var namespacePrefix = getNamespaceLikeImportText(declaration);
            if (namespacePrefix) {
              var moduleSymbol = getTargetModuleFromNamespaceLikeImport(declaration, checker);
              if (moduleSymbol && moduleSymbol.exports.has(ts2.escapeLeadingUnderscores(symbolName))) {
                return { kind: 0, namespacePrefix, position };
              }
            }
          });
        }
        function getTargetModuleFromNamespaceLikeImport(declaration, checker) {
          var _a;
          switch (declaration.kind) {
            case 242:
              return checker.resolveExternalModuleName(declaration.initializer.arguments[0]);
            case 253:
              return checker.getAliasedSymbol(declaration.symbol);
            case 254:
              var namespaceImport = ts2.tryCast((_a = declaration.importClause) === null || _a === void 0 ? void 0 : _a.namedBindings, ts2.isNamespaceImport);
              return namespaceImport && checker.getAliasedSymbol(namespaceImport.symbol);
            default:
              return ts2.Debug.assertNever(declaration);
          }
        }
        function getNamespaceLikeImportText(declaration) {
          var _a, _b, _c;
          switch (declaration.kind) {
            case 242:
              return (_a = ts2.tryCast(declaration.name, ts2.isIdentifier)) === null || _a === void 0 ? void 0 : _a.text;
            case 253:
              return declaration.name.text;
            case 254:
              return (_c = ts2.tryCast((_b = declaration.importClause) === null || _b === void 0 ? void 0 : _b.namedBindings, ts2.isNamespaceImport)) === null || _c === void 0 ? void 0 : _c.name.text;
            default:
              return ts2.Debug.assertNever(declaration);
          }
        }
        function tryAddToExistingImport(existingImports, canUseTypeOnlyImport) {
          return ts2.firstDefined(existingImports, function(_a) {
            var declaration = _a.declaration, importKind = _a.importKind;
            if (declaration.kind === 253)
              return void 0;
            if (declaration.kind === 242) {
              return (importKind === 0 || importKind === 1) && declaration.name.kind === 189 ? { kind: 2, importClauseOrBindingPattern: declaration.name, importKind, moduleSpecifier: declaration.initializer.arguments[0].text, canUseTypeOnlyImport: false } : void 0;
            }
            var importClause = declaration.importClause;
            if (!importClause)
              return void 0;
            var name = importClause.name, namedBindings = importClause.namedBindings;
            return importKind === 1 && !name || importKind === 0 && (!namedBindings || namedBindings.kind === 257) ? { kind: 2, importClauseOrBindingPattern: importClause, importKind, moduleSpecifier: declaration.moduleSpecifier.getText(), canUseTypeOnlyImport } : void 0;
          });
        }
        function getExistingImportDeclarations(_a, checker, sourceFile) {
          var moduleSymbol = _a.moduleSymbol, importKind = _a.importKind, exportedSymbolIsTypeOnly = _a.exportedSymbolIsTypeOnly;
          return exportedSymbolIsTypeOnly && ts2.isSourceFileJS(sourceFile) ? ts2.emptyArray : ts2.mapDefined(sourceFile.imports, function(moduleSpecifier) {
            var i = ts2.importFromModuleSpecifier(moduleSpecifier);
            if (ts2.isRequireVariableDeclaration(i.parent, true)) {
              return checker.resolveExternalModuleName(moduleSpecifier) === moduleSymbol ? { declaration: i.parent, importKind } : void 0;
            }
            if (i.kind === 254 || i.kind === 253) {
              return checker.getSymbolAtLocation(moduleSpecifier) === moduleSymbol ? { declaration: i, importKind } : void 0;
            }
          });
        }
        function shouldUseRequire(sourceFile, compilerOptions) {
          return ts2.isSourceFileJS(sourceFile) && !sourceFile.externalModuleIndicator && (!!sourceFile.commonJsModuleIndicator || ts2.getEmitModuleKind(compilerOptions) < ts2.ModuleKind.ES2015);
        }
        function getNewImportInfos(program, sourceFile, position, preferTypeOnlyImport, useRequire, moduleSymbols, host, preferences) {
          var isJs = ts2.isSourceFileJS(sourceFile);
          var compilerOptions = program.getCompilerOptions();
          var allowsImportingSpecifier = createAutoImportFilter(sourceFile, program, host).allowsImportingSpecifier;
          var choicesForEachExportingModule = ts2.flatMap(moduleSymbols, function(_a) {
            var moduleSymbol = _a.moduleSymbol, importKind = _a.importKind, exportedSymbolIsTypeOnly = _a.exportedSymbolIsTypeOnly;
            return ts2.moduleSpecifiers.getModuleSpecifiers(moduleSymbol, compilerOptions, sourceFile, ts2.createModuleSpecifierResolutionHost(program, host), preferences).map(function(moduleSpecifier) {
              return exportedSymbolIsTypeOnly && isJs ? { kind: 1, moduleSpecifier, position: ts2.Debug.checkDefined(position, "position should be defined") } : { kind: 3, moduleSpecifier, importKind, useRequire, typeOnly: preferTypeOnlyImport };
            });
          });
          return ts2.sort(choicesForEachExportingModule, function(a, b) {
            var allowsImportingA = allowsImportingSpecifier(a.moduleSpecifier);
            var allowsImportingB = allowsImportingSpecifier(b.moduleSpecifier);
            if (allowsImportingA && !allowsImportingB) {
              return -1;
            }
            if (allowsImportingB && !allowsImportingA) {
              return 1;
            }
            return a.moduleSpecifier.length - b.moduleSpecifier.length;
          });
        }
        function getFixesForAddImport(exportInfos, existingImports, program, sourceFile, position, preferTypeOnlyImport, useRequire, host, preferences) {
          var existingDeclaration = ts2.firstDefined(existingImports, function(info) {
            return newImportInfoFromExistingSpecifier(info, preferTypeOnlyImport, useRequire);
          });
          return existingDeclaration ? [existingDeclaration] : getNewImportInfos(program, sourceFile, position, preferTypeOnlyImport, useRequire, exportInfos, host, preferences);
        }
        function newImportInfoFromExistingSpecifier(_a, preferTypeOnlyImport, useRequire) {
          var declaration = _a.declaration, importKind = _a.importKind;
          var moduleSpecifier = declaration.kind === 254 ? declaration.moduleSpecifier : declaration.kind === 242 ? declaration.initializer.arguments[0] : declaration.moduleReference.kind === 265 ? declaration.moduleReference.expression : void 0;
          return moduleSpecifier && ts2.isStringLiteral(moduleSpecifier) ? { kind: 3, moduleSpecifier: moduleSpecifier.text, importKind, typeOnly: preferTypeOnlyImport, useRequire } : void 0;
        }
        function getFixesInfo(context, errorCode, pos) {
          var symbolToken = ts2.getTokenAtPosition(context.sourceFile, pos);
          var info = errorCode === ts2.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead.code ? getFixesInfoForUMDImport(context, symbolToken) : ts2.isIdentifier(symbolToken) ? getFixesInfoForNonUMDImport(context, symbolToken) : void 0;
          return info && __assign(__assign({}, info), { fixes: ts2.sort(info.fixes, function(a, b) {
            return a.kind - b.kind;
          }) });
        }
        function getFixesInfoForUMDImport(_a, token) {
          var sourceFile = _a.sourceFile, program = _a.program, host = _a.host, preferences = _a.preferences;
          var checker = program.getTypeChecker();
          var umdSymbol = getUmdSymbol(token, checker);
          if (!umdSymbol)
            return void 0;
          var symbol = checker.getAliasedSymbol(umdSymbol);
          var symbolName = umdSymbol.name;
          var exportInfos = [{ moduleSymbol: symbol, importKind: getUmdImportKind(sourceFile, program.getCompilerOptions()), exportedSymbolIsTypeOnly: false }];
          var useRequire = shouldUseRequire(sourceFile, program.getCompilerOptions());
          var fixes = getFixForImport(exportInfos, symbolName, ts2.isIdentifier(token) ? token.getStart(sourceFile) : void 0, false, useRequire, program, sourceFile, host, preferences);
          return { fixes, symbolName };
        }
        function getUmdSymbol(token, checker) {
          var umdSymbol = ts2.isIdentifier(token) ? checker.getSymbolAtLocation(token) : void 0;
          if (ts2.isUMDExportSymbol(umdSymbol))
            return umdSymbol;
          var parent = token.parent;
          return ts2.isJsxOpeningLikeElement(parent) && parent.tagName === token || ts2.isJsxOpeningFragment(parent) ? ts2.tryCast(checker.resolveName(checker.getJsxNamespace(parent), ts2.isJsxOpeningLikeElement(parent) ? token : parent, 111551, false), ts2.isUMDExportSymbol) : void 0;
        }
        function getUmdImportKind(importingFile, compilerOptions) {
          if (ts2.getAllowSyntheticDefaultImports(compilerOptions)) {
            return 1;
          }
          var moduleKind = ts2.getEmitModuleKind(compilerOptions);
          switch (moduleKind) {
            case ts2.ModuleKind.AMD:
            case ts2.ModuleKind.CommonJS:
            case ts2.ModuleKind.UMD:
              if (ts2.isInJSFile(importingFile)) {
                return ts2.isExternalModule(importingFile) ? 2 : 3;
              }
              return 3;
            case ts2.ModuleKind.System:
            case ts2.ModuleKind.ES2015:
            case ts2.ModuleKind.ES2020:
            case ts2.ModuleKind.ESNext:
            case ts2.ModuleKind.None:
              return 2;
            default:
              return ts2.Debug.assertNever(moduleKind, "Unexpected moduleKind " + moduleKind);
          }
        }
        function getFixesInfoForNonUMDImport(_a, symbolToken) {
          var sourceFile = _a.sourceFile, program = _a.program, cancellationToken = _a.cancellationToken, host = _a.host, preferences = _a.preferences;
          var checker = program.getTypeChecker();
          var symbolName = ts2.isJsxOpeningLikeElement(symbolToken.parent) && symbolToken.parent.tagName === symbolToken && (ts2.isIntrinsicJsxName(symbolToken.text) || checker.resolveName(symbolToken.text, symbolToken, 67108863, false)) ? checker.getJsxNamespace(sourceFile) : symbolToken.text;
          ts2.Debug.assert(symbolName !== "default", "'default' isn't a legal identifier and couldn't occur here");
          var compilerOptions = program.getCompilerOptions();
          var preferTypeOnlyImport = compilerOptions.importsNotUsedAsValues === 2 && ts2.isValidTypeOnlyAliasUseSite(symbolToken);
          var useRequire = shouldUseRequire(sourceFile, compilerOptions);
          var exportInfos = getExportInfos(symbolName, ts2.getMeaningFromLocation(symbolToken), cancellationToken, sourceFile, checker, program, host);
          var fixes = ts2.arrayFrom(ts2.flatMapIterator(exportInfos.entries(), function(_a2) {
            var _ = _a2[0], exportInfos2 = _a2[1];
            return getFixForImport(exportInfos2, symbolName, symbolToken.getStart(sourceFile), preferTypeOnlyImport, useRequire, program, sourceFile, host, preferences);
          }));
          return { fixes, symbolName };
        }
        function getExportInfos(symbolName, currentTokenMeaning, cancellationToken, sourceFile, checker, program, host) {
          var originalSymbolToExportInfos = ts2.createMultiMap();
          function addSymbol(moduleSymbol, exportedSymbol, importKind) {
            originalSymbolToExportInfos.add(ts2.getUniqueSymbolId(exportedSymbol, checker).toString(), { moduleSymbol, importKind, exportedSymbolIsTypeOnly: isTypeOnlySymbol(exportedSymbol, checker) });
          }
          forEachExternalModuleToImportFrom(program, host, sourceFile, true, function(moduleSymbol) {
            cancellationToken.throwIfCancellationRequested();
            var defaultInfo = getDefaultLikeExportInfo(sourceFile, moduleSymbol, checker, program.getCompilerOptions());
            if (defaultInfo && defaultInfo.name === symbolName && symbolHasMeaning(defaultInfo.symbolForMeaning, currentTokenMeaning)) {
              addSymbol(moduleSymbol, defaultInfo.symbol, defaultInfo.kind);
            }
            var exportSymbolWithIdenticalName = checker.tryGetMemberInModuleExportsAndProperties(symbolName, moduleSymbol);
            if (exportSymbolWithIdenticalName && symbolHasMeaning(exportSymbolWithIdenticalName, currentTokenMeaning)) {
              addSymbol(moduleSymbol, exportSymbolWithIdenticalName, 0);
            }
          });
          return originalSymbolToExportInfos;
        }
        function getDefaultLikeExportInfo(importingFile, moduleSymbol, checker, compilerOptions) {
          var exported = getDefaultLikeExportWorker(importingFile, moduleSymbol, checker, compilerOptions);
          if (!exported)
            return void 0;
          var symbol = exported.symbol, kind = exported.kind;
          var info = getDefaultExportInfoWorker(symbol, moduleSymbol, checker, compilerOptions);
          return info && __assign({ symbol, kind }, info);
        }
        function getDefaultLikeExportWorker(importingFile, moduleSymbol, checker, compilerOptions) {
          var defaultExport = checker.tryGetMemberInModuleExports("default", moduleSymbol);
          if (defaultExport)
            return { symbol: defaultExport, kind: 1 };
          var exportEquals = checker.resolveExternalModuleSymbol(moduleSymbol);
          return exportEquals === moduleSymbol ? void 0 : { symbol: exportEquals, kind: getExportEqualsImportKind(importingFile, compilerOptions) };
        }
        function getExportEqualsImportKind(importingFile, compilerOptions) {
          var allowSyntheticDefaults = ts2.getAllowSyntheticDefaultImports(compilerOptions);
          if (ts2.getEmitModuleKind(compilerOptions) >= ts2.ModuleKind.ES2015) {
            return allowSyntheticDefaults ? 1 : 2;
          }
          if (ts2.isInJSFile(importingFile)) {
            return ts2.isExternalModule(importingFile) ? 1 : 3;
          }
          for (var _i = 0, _a = importingFile.statements; _i < _a.length; _i++) {
            var statement = _a[_i];
            if (ts2.isImportEqualsDeclaration(statement)) {
              return 3;
            }
          }
          return allowSyntheticDefaults ? 1 : 3;
        }
        function getDefaultExportInfoWorker(defaultExport, moduleSymbol, checker, compilerOptions) {
          var localSymbol = ts2.getLocalSymbolForExportDefault(defaultExport);
          if (localSymbol)
            return { symbolForMeaning: localSymbol, name: localSymbol.name };
          var name = getNameForExportDefault(defaultExport);
          if (name !== void 0)
            return { symbolForMeaning: defaultExport, name };
          if (defaultExport.flags & 2097152) {
            var aliased = checker.getImmediateAliasedSymbol(defaultExport);
            return aliased && getDefaultExportInfoWorker(aliased, ts2.Debug.checkDefined(aliased.parent, "Alias targets of default exports must have a parent"), checker, compilerOptions);
          }
          if (defaultExport.escapedName !== "default" && defaultExport.escapedName !== "export=") {
            return { symbolForMeaning: defaultExport, name: defaultExport.getName() };
          }
          return { symbolForMeaning: defaultExport, name: moduleSymbolToValidIdentifier(moduleSymbol, compilerOptions.target) };
        }
        function getNameForExportDefault(symbol) {
          return symbol.declarations && ts2.firstDefined(symbol.declarations, function(declaration) {
            if (ts2.isExportAssignment(declaration)) {
              if (ts2.isIdentifier(declaration.expression)) {
                return declaration.expression.text;
              }
            } else if (ts2.isExportSpecifier(declaration)) {
              ts2.Debug.assert(declaration.name.text === "default", "Expected the specifier to be a default export");
              return declaration.propertyName && declaration.propertyName.text;
            }
          });
        }
        function codeActionForFix(context, sourceFile, symbolName, fix, quotePreference) {
          var diag;
          var changes = ts2.textChanges.ChangeTracker.with(context, function(tracker) {
            diag = codeActionForFixWorker(tracker, sourceFile, symbolName, fix, quotePreference);
          });
          return codefix2.createCodeFixAction(codefix2.importFixName, changes, diag, importFixId, ts2.Diagnostics.Add_all_missing_imports);
        }
        function codeActionForFixWorker(changes, sourceFile, symbolName, fix, quotePreference) {
          switch (fix.kind) {
            case 0:
              addNamespaceQualifier(changes, sourceFile, fix);
              return [ts2.Diagnostics.Change_0_to_1, symbolName, fix.namespacePrefix + "." + symbolName];
            case 1:
              addImportType(changes, sourceFile, fix, quotePreference);
              return [ts2.Diagnostics.Change_0_to_1, symbolName, getImportTypePrefix(fix.moduleSpecifier, quotePreference) + symbolName];
            case 2: {
              var importClauseOrBindingPattern = fix.importClauseOrBindingPattern, importKind = fix.importKind, canUseTypeOnlyImport = fix.canUseTypeOnlyImport, moduleSpecifier = fix.moduleSpecifier;
              doAddExistingFix(changes, sourceFile, importClauseOrBindingPattern, importKind === 1 ? symbolName : void 0, importKind === 0 ? [symbolName] : ts2.emptyArray, canUseTypeOnlyImport);
              var moduleSpecifierWithoutQuotes = ts2.stripQuotes(moduleSpecifier);
              return [importKind === 1 ? ts2.Diagnostics.Add_default_import_0_to_existing_import_declaration_from_1 : ts2.Diagnostics.Add_0_to_existing_import_declaration_from_1, symbolName, moduleSpecifierWithoutQuotes];
            }
            case 3: {
              var importKind = fix.importKind, moduleSpecifier = fix.moduleSpecifier, typeOnly = fix.typeOnly, useRequire = fix.useRequire;
              var getDeclarations = useRequire ? getNewRequires : getNewImports;
              var importsCollection = importKind === 1 ? { defaultImport: symbolName, typeOnly } : importKind === 0 ? { namedImports: [symbolName], typeOnly } : { namespaceLikeImport: { importKind, name: symbolName }, typeOnly };
              ts2.insertImports(changes, sourceFile, getDeclarations(moduleSpecifier, quotePreference, importsCollection), true);
              return [importKind === 1 ? ts2.Diagnostics.Import_default_0_from_module_1 : ts2.Diagnostics.Import_0_from_module_1, symbolName, moduleSpecifier];
            }
            default:
              return ts2.Debug.assertNever(fix, "Unexpected fix kind " + fix.kind);
          }
        }
        function doAddExistingFix(changes, sourceFile, clause, defaultImport, namedImports, canUseTypeOnlyImport) {
          if (clause.kind === 189) {
            if (defaultImport) {
              addElementToBindingPattern(clause, defaultImport, "default");
            }
            for (var _i = 0, namedImports_1 = namedImports; _i < namedImports_1.length; _i++) {
              var specifier = namedImports_1[_i];
              addElementToBindingPattern(clause, specifier, void 0);
            }
            return;
          }
          var convertTypeOnlyToRegular = !canUseTypeOnlyImport && clause.isTypeOnly;
          if (defaultImport) {
            ts2.Debug.assert(!clause.name, "Cannot add a default import to an import clause that already has one");
            changes.insertNodeAt(sourceFile, clause.getStart(sourceFile), ts2.createIdentifier(defaultImport), { suffix: ", " });
          }
          if (namedImports.length) {
            var specifiers = namedImports.map(function(name) {
              return ts2.createImportSpecifier(void 0, ts2.createIdentifier(name));
            });
            if (clause.namedBindings && ts2.cast(clause.namedBindings, ts2.isNamedImports).elements.length) {
              for (var _a = 0, specifiers_1 = specifiers; _a < specifiers_1.length; _a++) {
                var spec = specifiers_1[_a];
                changes.insertNodeInListAfter(sourceFile, ts2.last(ts2.cast(clause.namedBindings, ts2.isNamedImports).elements), spec);
              }
            } else {
              if (specifiers.length) {
                var namedImports_2 = ts2.createNamedImports(specifiers);
                if (clause.namedBindings) {
                  changes.replaceNode(sourceFile, clause.namedBindings, namedImports_2);
                } else {
                  changes.insertNodeAfter(sourceFile, ts2.Debug.checkDefined(clause.name, "Import clause must have either named imports or a default import"), namedImports_2);
                }
              }
            }
          }
          if (convertTypeOnlyToRegular) {
            changes.delete(sourceFile, ts2.getTypeKeywordOfTypeOnlyImport(clause, sourceFile));
          }
          function addElementToBindingPattern(bindingPattern, name, propertyName) {
            var element = ts2.createBindingElement(void 0, propertyName, name);
            if (bindingPattern.elements.length) {
              changes.insertNodeInListAfter(sourceFile, ts2.last(bindingPattern.elements), element);
            } else {
              changes.replaceNode(sourceFile, bindingPattern, ts2.createObjectBindingPattern([element]));
            }
          }
        }
        function addNamespaceQualifier(changes, sourceFile, _a) {
          var namespacePrefix = _a.namespacePrefix, position = _a.position;
          changes.insertText(sourceFile, position, namespacePrefix + ".");
        }
        function addImportType(changes, sourceFile, _a, quotePreference) {
          var moduleSpecifier = _a.moduleSpecifier, position = _a.position;
          changes.insertText(sourceFile, position, getImportTypePrefix(moduleSpecifier, quotePreference));
        }
        function getImportTypePrefix(moduleSpecifier, quotePreference) {
          var quote = ts2.getQuoteFromPreference(quotePreference);
          return "import(" + quote + moduleSpecifier + quote + ").";
        }
        function getNewImports(moduleSpecifier, quotePreference, imports) {
          var _a, _b;
          var quotedModuleSpecifier = ts2.makeStringLiteral(moduleSpecifier, quotePreference);
          var statements;
          if (imports.defaultImport !== void 0 || ((_a = imports.namedImports) === null || _a === void 0 ? void 0 : _a.length)) {
            statements = ts2.combine(statements, ts2.makeImport(imports.defaultImport === void 0 ? void 0 : ts2.createIdentifier(imports.defaultImport), (_b = imports.namedImports) === null || _b === void 0 ? void 0 : _b.map(function(n) {
              return ts2.createImportSpecifier(void 0, ts2.createIdentifier(n));
            }), moduleSpecifier, quotePreference, imports.typeOnly));
          }
          var namespaceLikeImport = imports.namespaceLikeImport, typeOnly = imports.typeOnly;
          if (namespaceLikeImport) {
            var declaration = namespaceLikeImport.importKind === 3 ? ts2.createImportEqualsDeclaration(void 0, void 0, ts2.createIdentifier(namespaceLikeImport.name), ts2.createExternalModuleReference(quotedModuleSpecifier)) : ts2.createImportDeclaration(void 0, void 0, ts2.createImportClause(void 0, ts2.createNamespaceImport(ts2.createIdentifier(namespaceLikeImport.name)), typeOnly), quotedModuleSpecifier);
            statements = ts2.combine(statements, declaration);
          }
          return ts2.Debug.checkDefined(statements);
        }
        function getNewRequires(moduleSpecifier, quotePreference, imports) {
          var _a, _b;
          var quotedModuleSpecifier = ts2.makeStringLiteral(moduleSpecifier, quotePreference);
          var statements;
          if (imports.defaultImport || ((_a = imports.namedImports) === null || _a === void 0 ? void 0 : _a.length)) {
            var bindingElements = ((_b = imports.namedImports) === null || _b === void 0 ? void 0 : _b.map(function(name) {
              return ts2.createBindingElement(void 0, void 0, name);
            })) || [];
            if (imports.defaultImport) {
              bindingElements.unshift(ts2.createBindingElement(void 0, "default", imports.defaultImport));
            }
            var declaration = createConstEqualsRequireDeclaration(ts2.createObjectBindingPattern(bindingElements), quotedModuleSpecifier);
            statements = ts2.combine(statements, declaration);
          }
          if (imports.namespaceLikeImport) {
            var declaration = createConstEqualsRequireDeclaration(imports.namespaceLikeImport.name, quotedModuleSpecifier);
            statements = ts2.combine(statements, declaration);
          }
          return ts2.Debug.checkDefined(statements);
        }
        function createConstEqualsRequireDeclaration(name, quotedModuleSpecifier) {
          return ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([
            ts2.createVariableDeclaration(typeof name === "string" ? ts2.createIdentifier(name) : name, void 0, ts2.createCall(ts2.createIdentifier("require"), void 0, [quotedModuleSpecifier]))
          ], 2));
        }
        function symbolHasMeaning(_a, meaning) {
          var declarations = _a.declarations;
          return ts2.some(declarations, function(decl) {
            return !!(ts2.getMeaningFromDeclaration(decl) & meaning);
          });
        }
        function forEachExternalModuleToImportFrom(program, host, from, filterByPackageJson, cb) {
          var filteredCount = 0;
          var moduleSpecifierResolutionHost = ts2.createModuleSpecifierResolutionHost(program, host);
          var packageJson = filterByPackageJson && createAutoImportFilter(from, program, host, moduleSpecifierResolutionHost);
          forEachExternalModule(program.getTypeChecker(), program.getSourceFiles(), function(module3, sourceFile) {
            if (sourceFile === void 0) {
              if (!packageJson || packageJson.allowsImportingAmbientModule(module3)) {
                cb(module3);
              } else if (packageJson) {
                filteredCount++;
              }
            } else if (sourceFile && sourceFile !== from && isImportableFile(program, from, sourceFile, moduleSpecifierResolutionHost)) {
              if (!packageJson || packageJson.allowsImportingSourceFile(sourceFile)) {
                cb(module3);
              } else if (packageJson) {
                filteredCount++;
              }
            }
          });
          if (host.log) {
            host.log("forEachExternalModuleToImportFrom: filtered out " + filteredCount + " modules by package.json contents");
          }
        }
        codefix2.forEachExternalModuleToImportFrom = forEachExternalModuleToImportFrom;
        function forEachExternalModule(checker, allSourceFiles, cb) {
          for (var _i = 0, _a = checker.getAmbientModules(); _i < _a.length; _i++) {
            var ambient = _a[_i];
            cb(ambient, void 0);
          }
          for (var _b = 0, allSourceFiles_1 = allSourceFiles; _b < allSourceFiles_1.length; _b++) {
            var sourceFile = allSourceFiles_1[_b];
            if (ts2.isExternalOrCommonJsModule(sourceFile)) {
              cb(checker.getMergedSymbol(sourceFile.symbol), sourceFile);
            }
          }
        }
        function isImportableFile(program, from, to, moduleSpecifierResolutionHost) {
          var _a;
          var getCanonicalFileName = ts2.hostGetCanonicalFileName(moduleSpecifierResolutionHost);
          var globalTypingsCache = (_a = moduleSpecifierResolutionHost.getGlobalTypingsCacheLocation) === null || _a === void 0 ? void 0 : _a.call(moduleSpecifierResolutionHost);
          return !!ts2.moduleSpecifiers.forEachFileNameOfModule(from.fileName, to.fileName, moduleSpecifierResolutionHost, false, function(toPath) {
            var toFile = program.getSourceFile(toPath);
            return (toFile === to || !toFile) && isImportablePath(from.fileName, toPath, getCanonicalFileName, globalTypingsCache);
          });
        }
        function isImportablePath(fromPath, toPath, getCanonicalFileName, globalCachePath) {
          var toNodeModules = ts2.forEachAncestorDirectory(toPath, function(ancestor) {
            return ts2.getBaseFileName(ancestor) === "node_modules" ? ancestor : void 0;
          });
          var toNodeModulesParent = toNodeModules && ts2.getDirectoryPath(getCanonicalFileName(toNodeModules));
          return toNodeModulesParent === void 0 || ts2.startsWith(getCanonicalFileName(fromPath), toNodeModulesParent) || !!globalCachePath && ts2.startsWith(getCanonicalFileName(globalCachePath), toNodeModulesParent);
        }
        function moduleSymbolToValidIdentifier(moduleSymbol, target) {
          return moduleSpecifierToValidIdentifier(ts2.removeFileExtension(ts2.stripQuotes(moduleSymbol.name)), target);
        }
        codefix2.moduleSymbolToValidIdentifier = moduleSymbolToValidIdentifier;
        function moduleSpecifierToValidIdentifier(moduleSpecifier, target) {
          var baseName = ts2.getBaseFileName(ts2.removeSuffix(moduleSpecifier, "/index"));
          var res = "";
          var lastCharWasValid = true;
          var firstCharCode = baseName.charCodeAt(0);
          if (ts2.isIdentifierStart(firstCharCode, target)) {
            res += String.fromCharCode(firstCharCode);
          } else {
            lastCharWasValid = false;
          }
          for (var i = 1; i < baseName.length; i++) {
            var ch = baseName.charCodeAt(i);
            var isValid = ts2.isIdentifierPart(ch, target);
            if (isValid) {
              var char = String.fromCharCode(ch);
              if (!lastCharWasValid) {
                char = char.toUpperCase();
              }
              res += char;
            }
            lastCharWasValid = isValid;
          }
          return !ts2.isStringANonContextualKeyword(res) ? res || "_" : "_" + res;
        }
        codefix2.moduleSpecifierToValidIdentifier = moduleSpecifierToValidIdentifier;
        function createAutoImportFilter(fromFile, program, host, moduleSpecifierResolutionHost) {
          if (moduleSpecifierResolutionHost === void 0) {
            moduleSpecifierResolutionHost = ts2.createModuleSpecifierResolutionHost(program, host);
          }
          var packageJsons = host.getPackageJsonsVisibleToFile && host.getPackageJsonsVisibleToFile(fromFile.fileName) || ts2.getPackageJsonsVisibleToFile(fromFile.fileName, host);
          var dependencyGroups = 1 | 2 | 8;
          var usesNodeCoreModules;
          return { allowsImportingAmbientModule, allowsImportingSourceFile, allowsImportingSpecifier, moduleSpecifierResolutionHost };
          function moduleSpecifierIsCoveredByPackageJson(specifier) {
            var packageName = getNodeModuleRootSpecifier(specifier);
            for (var _i = 0, packageJsons_1 = packageJsons; _i < packageJsons_1.length; _i++) {
              var packageJson = packageJsons_1[_i];
              if (packageJson.has(packageName, dependencyGroups) || packageJson.has(ts2.getTypesPackageName(packageName), dependencyGroups)) {
                return true;
              }
            }
            return false;
          }
          function allowsImportingAmbientModule(moduleSymbol) {
            if (!packageJsons.length) {
              return true;
            }
            var declaringSourceFile = moduleSymbol.valueDeclaration.getSourceFile();
            var declaringNodeModuleName = getNodeModulesPackageNameFromFileName(declaringSourceFile.fileName);
            if (typeof declaringNodeModuleName === "undefined") {
              return true;
            }
            var declaredModuleSpecifier = ts2.stripQuotes(moduleSymbol.getName());
            if (isAllowedCoreNodeModulesImport(declaredModuleSpecifier)) {
              return true;
            }
            return moduleSpecifierIsCoveredByPackageJson(declaringNodeModuleName) || moduleSpecifierIsCoveredByPackageJson(declaredModuleSpecifier);
          }
          function allowsImportingSourceFile(sourceFile) {
            if (!packageJsons.length) {
              return true;
            }
            var moduleSpecifier = getNodeModulesPackageNameFromFileName(sourceFile.fileName);
            if (!moduleSpecifier) {
              return true;
            }
            return moduleSpecifierIsCoveredByPackageJson(moduleSpecifier);
          }
          function allowsImportingSpecifier(moduleSpecifier) {
            if (!packageJsons.length || isAllowedCoreNodeModulesImport(moduleSpecifier)) {
              return true;
            }
            if (ts2.pathIsRelative(moduleSpecifier) || ts2.isRootedDiskPath(moduleSpecifier)) {
              return true;
            }
            return moduleSpecifierIsCoveredByPackageJson(moduleSpecifier);
          }
          function isAllowedCoreNodeModulesImport(moduleSpecifier) {
            if (ts2.isSourceFileJS(fromFile) && ts2.JsTyping.nodeCoreModules.has(moduleSpecifier)) {
              if (usesNodeCoreModules === void 0) {
                usesNodeCoreModules = ts2.consumesNodeCoreModules(fromFile);
              }
              if (usesNodeCoreModules) {
                return true;
              }
            }
            return false;
          }
          function getNodeModulesPackageNameFromFileName(importedFileName) {
            if (!ts2.stringContains(importedFileName, "node_modules")) {
              return void 0;
            }
            var specifier = ts2.moduleSpecifiers.getNodeModulesPackageName(host.getCompilationSettings(), fromFile.path, importedFileName, moduleSpecifierResolutionHost);
            if (!specifier) {
              return void 0;
            }
            if (!ts2.pathIsRelative(specifier) && !ts2.isRootedDiskPath(specifier)) {
              return getNodeModuleRootSpecifier(specifier);
            }
          }
          function getNodeModuleRootSpecifier(fullSpecifier) {
            var components = ts2.getPathComponents(ts2.getPackageNameFromTypesPackageName(fullSpecifier)).slice(1);
            if (ts2.startsWith(components[0], "@")) {
              return components[0] + "/" + components[1];
            }
            return components[0];
          }
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixImplicitThis";
        var errorCodes = [ts2.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, program = context.program, span = context.span;
            var diagnostic;
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              diagnostic = doChange(t, sourceFile, span.start, program.getTypeChecker());
            });
            return diagnostic ? [codefix2.createCodeFixAction(fixId, changes, diagnostic, fixId, ts2.Diagnostics.Fix_all_implicit_this_errors)] : ts2.emptyArray;
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              doChange(changes, diag.file, diag.start, context.program.getTypeChecker());
            });
          }
        });
        function doChange(changes, sourceFile, pos, checker) {
          var token = ts2.getTokenAtPosition(sourceFile, pos);
          ts2.Debug.assert(token.kind === 104);
          var fn = ts2.getThisContainer(token, false);
          if (!ts2.isFunctionDeclaration(fn) && !ts2.isFunctionExpression(fn))
            return void 0;
          if (!ts2.isSourceFile(ts2.getThisContainer(fn, false))) {
            var fnKeyword = ts2.Debug.assertDefined(ts2.findChildOfKind(fn, 94, sourceFile));
            var name = fn.name;
            var body = ts2.Debug.assertDefined(fn.body);
            if (ts2.isFunctionExpression(fn)) {
              if (name && ts2.FindAllReferences.Core.isSymbolReferencedInFile(name, checker, sourceFile, body)) {
                return void 0;
              }
              changes.delete(sourceFile, fnKeyword);
              if (name) {
                changes.delete(sourceFile, name);
              }
              changes.insertText(sourceFile, body.pos, " =>");
              return [ts2.Diagnostics.Convert_function_expression_0_to_arrow_function, name ? name.text : ts2.ANONYMOUS];
            } else {
              changes.replaceNode(sourceFile, fnKeyword, ts2.createToken(81));
              changes.insertText(sourceFile, name.end, " = ");
              changes.insertText(sourceFile, body.pos, " =>");
              return [ts2.Diagnostics.Convert_function_declaration_0_to_arrow_function, name.text];
            }
          } else if (ts2.isSourceFileJS(sourceFile) && ts2.isPropertyAccessExpression(token.parent) && ts2.isAssignmentExpression(token.parent.parent)) {
            codefix2.addJSDocTags(changes, sourceFile, fn, [ts2.createJSDocClassTag()]);
            return ts2.Diagnostics.Add_class_tag;
          }
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixSpelling";
        var errorCodes = [
          ts2.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2.code,
          ts2.Diagnostics.Cannot_find_name_0_Did_you_mean_1.code,
          ts2.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,
          ts2.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code,
          ts2.Diagnostics.Module_0_has_no_exported_member_1_Did_you_mean_2.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var info = getInfo(sourceFile, context.span.start, context);
            if (!info)
              return void 0;
            var node = info.node, suggestedSymbol = info.suggestedSymbol;
            var target = context.host.getCompilationSettings().target;
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, node, suggestedSymbol, target);
            });
            return [codefix2.createCodeFixAction("spelling", changes, [ts2.Diagnostics.Change_spelling_to_0, ts2.symbolName(suggestedSymbol)], fixId, ts2.Diagnostics.Fix_all_detected_spelling_errors)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, diag.start, context);
              var target = context.host.getCompilationSettings().target;
              if (info)
                doChange(changes, context.sourceFile, info.node, info.suggestedSymbol, target);
            });
          }
        });
        function getInfo(sourceFile, pos, context) {
          var node = ts2.getTokenAtPosition(sourceFile, pos);
          var parent = node.parent;
          var checker = context.program.getTypeChecker();
          var suggestedSymbol;
          if (ts2.isPropertyAccessExpression(parent) && parent.name === node) {
            ts2.Debug.assert(ts2.isIdentifierOrPrivateIdentifier(node), "Expected an identifier for spelling (property access)");
            var containingType = checker.getTypeAtLocation(parent.expression);
            if (parent.flags & 32) {
              containingType = checker.getNonNullableType(containingType);
            }
            suggestedSymbol = checker.getSuggestedSymbolForNonexistentProperty(node, containingType);
          } else if (ts2.isImportSpecifier(parent) && parent.name === node) {
            ts2.Debug.assertNode(node, ts2.isIdentifier, "Expected an identifier for spelling (import)");
            var importDeclaration = ts2.findAncestor(node, ts2.isImportDeclaration);
            var resolvedSourceFile = getResolvedSourceFileFromImportDeclaration(sourceFile, context, importDeclaration);
            if (resolvedSourceFile && resolvedSourceFile.symbol) {
              suggestedSymbol = checker.getSuggestedSymbolForNonexistentModule(node, resolvedSourceFile.symbol);
            }
          } else {
            var meaning = ts2.getMeaningFromLocation(node);
            var name = ts2.getTextOfNode(node);
            ts2.Debug.assert(name !== void 0, "name should be defined");
            suggestedSymbol = checker.getSuggestedSymbolForNonexistentSymbol(node, name, convertSemanticMeaningToSymbolFlags(meaning));
          }
          return suggestedSymbol === void 0 ? void 0 : { node, suggestedSymbol };
        }
        function doChange(changes, sourceFile, node, suggestedSymbol, target) {
          var suggestion = ts2.symbolName(suggestedSymbol);
          if (!ts2.isIdentifierText(suggestion, target) && ts2.isPropertyAccessExpression(node.parent)) {
            var valDecl = suggestedSymbol.valueDeclaration;
            if (ts2.isNamedDeclaration(valDecl) && ts2.isPrivateIdentifier(valDecl.name)) {
              changes.replaceNode(sourceFile, node, ts2.createIdentifier(suggestion));
            } else {
              changes.replaceNode(sourceFile, node.parent, ts2.createElementAccess(node.parent.expression, ts2.createLiteral(suggestion)));
            }
          } else {
            changes.replaceNode(sourceFile, node, ts2.createIdentifier(suggestion));
          }
        }
        function convertSemanticMeaningToSymbolFlags(meaning) {
          var flags = 0;
          if (meaning & 4) {
            flags |= 1920;
          }
          if (meaning & 2) {
            flags |= 788968;
          }
          if (meaning & 1) {
            flags |= 111551;
          }
          return flags;
        }
        function getResolvedSourceFileFromImportDeclaration(sourceFile, context, importDeclaration) {
          if (!importDeclaration || !ts2.isStringLiteralLike(importDeclaration.moduleSpecifier))
            return void 0;
          var resolvedModule = ts2.getResolvedModule(sourceFile, importDeclaration.moduleSpecifier.text);
          if (!resolvedModule)
            return void 0;
          return context.program.getSourceFile(resolvedModule.resolvedFileName);
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "returnValueCorrect";
        var fixIdAddReturnStatement = "fixAddReturnStatement";
        var fixIdRemoveBlockBodyBrace = "fixRemoveBlockBodyBrace";
        var fixIdWrapTheBlockWithParen = "fixWrapTheBlockWithParen";
        var errorCodes = [
          ts2.Diagnostics.A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value.code,
          ts2.Diagnostics.Type_0_is_not_assignable_to_type_1.code,
          ts2.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code
        ];
        var ProblemKind;
        (function(ProblemKind2) {
          ProblemKind2[ProblemKind2["MissingReturnStatement"] = 0] = "MissingReturnStatement";
          ProblemKind2[ProblemKind2["MissingParentheses"] = 1] = "MissingParentheses";
        })(ProblemKind || (ProblemKind = {}));
        codefix2.registerCodeFix({
          errorCodes,
          fixIds: [fixIdAddReturnStatement, fixIdRemoveBlockBodyBrace, fixIdWrapTheBlockWithParen],
          getCodeActions: function(context) {
            var program = context.program, sourceFile = context.sourceFile, start = context.span.start, errorCode = context.errorCode;
            var info = getInfo(program.getTypeChecker(), sourceFile, start, errorCode);
            if (!info)
              return void 0;
            if (info.kind === ProblemKind.MissingReturnStatement) {
              return ts2.append([getActionForfixAddReturnStatement(context, info.expression, info.statement)], ts2.isArrowFunction(info.declaration) ? getActionForfixRemoveBlockBodyBrace(context, info.declaration, info.expression, info.commentSource) : void 0);
            } else {
              return [getActionForfixWrapTheBlockWithParen(context, info.declaration, info.expression)];
            }
          },
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(context.program.getTypeChecker(), diag.file, diag.start, diag.code);
              if (!info)
                return void 0;
              switch (context.fixId) {
                case fixIdAddReturnStatement:
                  addReturnStatement(changes, diag.file, info.expression, info.statement);
                  break;
                case fixIdRemoveBlockBodyBrace:
                  if (!ts2.isArrowFunction(info.declaration))
                    return void 0;
                  removeBlockBodyBrace(changes, diag.file, info.declaration, info.expression, info.commentSource, false);
                  break;
                case fixIdWrapTheBlockWithParen:
                  if (!ts2.isArrowFunction(info.declaration))
                    return void 0;
                  wrapBlockWithParen(changes, diag.file, info.declaration, info.expression);
                  break;
                default:
                  ts2.Debug.fail(JSON.stringify(context.fixId));
              }
            });
          }
        });
        function getFixInfo(checker, declaration, expectType, isFunctionType) {
          if (!declaration.body || !ts2.isBlock(declaration.body) || ts2.length(declaration.body.statements) !== 1)
            return void 0;
          var firstStatement = ts2.first(declaration.body.statements);
          if (ts2.isExpressionStatement(firstStatement) && checkFixedAssignableTo(checker, declaration, firstStatement.expression, expectType, isFunctionType)) {
            return {
              declaration,
              kind: ProblemKind.MissingReturnStatement,
              expression: firstStatement.expression,
              statement: firstStatement,
              commentSource: firstStatement.expression
            };
          } else if (ts2.isLabeledStatement(firstStatement) && ts2.isExpressionStatement(firstStatement.statement)) {
            var node = ts2.createObjectLiteral([ts2.createPropertyAssignment(firstStatement.label, firstStatement.statement.expression)]);
            if (checkFixedAssignableTo(checker, declaration, node, expectType, isFunctionType)) {
              return ts2.isArrowFunction(declaration) ? {
                declaration,
                kind: ProblemKind.MissingParentheses,
                expression: node,
                statement: firstStatement,
                commentSource: firstStatement.statement.expression
              } : {
                declaration,
                kind: ProblemKind.MissingReturnStatement,
                expression: node,
                statement: firstStatement,
                commentSource: firstStatement.statement.expression
              };
            }
          } else if (ts2.isBlock(firstStatement) && ts2.length(firstStatement.statements) === 1) {
            var firstBlockStatement = ts2.first(firstStatement.statements);
            if (ts2.isLabeledStatement(firstBlockStatement) && ts2.isExpressionStatement(firstBlockStatement.statement)) {
              var node = ts2.createObjectLiteral([ts2.createPropertyAssignment(firstBlockStatement.label, firstBlockStatement.statement.expression)]);
              if (checkFixedAssignableTo(checker, declaration, node, expectType, isFunctionType)) {
                return {
                  declaration,
                  kind: ProblemKind.MissingReturnStatement,
                  expression: node,
                  statement: firstStatement,
                  commentSource: firstBlockStatement
                };
              }
            }
          }
          return void 0;
        }
        function checkFixedAssignableTo(checker, declaration, expr, type, isFunctionType) {
          return checker.isTypeAssignableTo(checker.getTypeAtLocation(isFunctionType ? ts2.updateFunctionLikeBody(declaration, ts2.createBlock([ts2.createReturn(expr)])) : expr), type);
        }
        function getInfo(checker, sourceFile, position, errorCode) {
          var node = ts2.getTokenAtPosition(sourceFile, position);
          if (!node.parent)
            return void 0;
          var declaration = ts2.findAncestor(node.parent, ts2.isFunctionLikeDeclaration);
          switch (errorCode) {
            case ts2.Diagnostics.A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value.code:
              if (!declaration || !declaration.body || !declaration.type || !ts2.rangeContainsRange(declaration.type, node))
                return void 0;
              return getFixInfo(checker, declaration, checker.getTypeFromTypeNode(declaration.type), false);
            case ts2.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code:
              if (!declaration || !ts2.isCallExpression(declaration.parent) || !declaration.body)
                return void 0;
              var pos = declaration.parent.arguments.indexOf(declaration);
              var type = checker.getContextualTypeForArgumentAtIndex(declaration.parent, pos);
              if (!type)
                return void 0;
              return getFixInfo(checker, declaration, type, true);
            case ts2.Diagnostics.Type_0_is_not_assignable_to_type_1.code:
              if (!ts2.isDeclarationName(node) || !ts2.isVariableLike(node.parent) && !ts2.isJsxAttribute(node.parent))
                return void 0;
              var initializer = getVariableLikeInitializer(node.parent);
              if (!initializer || !ts2.isFunctionLikeDeclaration(initializer) || !initializer.body)
                return void 0;
              return getFixInfo(checker, initializer, checker.getTypeAtLocation(node.parent), true);
          }
          return void 0;
        }
        function getVariableLikeInitializer(declaration) {
          switch (declaration.kind) {
            case 242:
            case 156:
            case 191:
            case 159:
            case 281:
              return declaration.initializer;
            case 273:
              return declaration.initializer && (ts2.isJsxExpression(declaration.initializer) ? declaration.initializer.expression : void 0);
            case 282:
            case 158:
            case 284:
            case 323:
            case 317:
              return void 0;
          }
        }
        function addReturnStatement(changes, sourceFile, expression, statement) {
          ts2.suppressLeadingAndTrailingTrivia(expression);
          var probablyNeedSemi = ts2.probablyUsesSemicolons(sourceFile);
          changes.replaceNode(sourceFile, statement, ts2.createReturn(expression), {
            leadingTriviaOption: ts2.textChanges.LeadingTriviaOption.Exclude,
            trailingTriviaOption: ts2.textChanges.TrailingTriviaOption.Exclude,
            suffix: probablyNeedSemi ? ";" : void 0
          });
        }
        function removeBlockBodyBrace(changes, sourceFile, declaration, expression, commentSource, withParen) {
          var newBody = withParen || ts2.needsParentheses(expression) ? ts2.createParen(expression) : expression;
          ts2.suppressLeadingAndTrailingTrivia(commentSource);
          ts2.copyComments(commentSource, newBody);
          changes.replaceNode(sourceFile, declaration.body, newBody);
        }
        function wrapBlockWithParen(changes, sourceFile, declaration, expression) {
          changes.replaceNode(sourceFile, declaration.body, ts2.createParen(expression));
        }
        function getActionForfixAddReturnStatement(context, expression, statement) {
          var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
            return addReturnStatement(t, context.sourceFile, expression, statement);
          });
          return codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Add_a_return_statement, fixIdAddReturnStatement, ts2.Diagnostics.Add_all_missing_return_statement);
        }
        function getActionForfixRemoveBlockBodyBrace(context, declaration, expression, commentSource) {
          var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
            return removeBlockBodyBrace(t, context.sourceFile, declaration, expression, commentSource, false);
          });
          return codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Remove_block_body_braces, fixIdRemoveBlockBodyBrace, ts2.Diagnostics.Remove_all_incorrect_body_block_braces);
        }
        function getActionForfixWrapTheBlockWithParen(context, declaration, expression) {
          var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
            return wrapBlockWithParen(t, context.sourceFile, declaration, expression);
          });
          return codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal, fixIdWrapTheBlockWithParen, ts2.Diagnostics.Wrap_all_object_literal_with_parentheses);
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixName = "addMissingMember";
        var errorCodes = [
          ts2.Diagnostics.Property_0_does_not_exist_on_type_1.code,
          ts2.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2.code,
          ts2.Diagnostics.Property_0_is_missing_in_type_1_but_required_in_type_2.code,
          ts2.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2.code,
          ts2.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more.code
        ];
        var fixId = "addMissingMember";
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var info = getInfo(context.sourceFile, context.span.start, context.program.getTypeChecker(), context.program);
            if (!info)
              return void 0;
            if (info.kind === 0) {
              var token_1 = info.token, parentDeclaration_1 = info.parentDeclaration;
              var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
                return addEnumMemberDeclaration(t, context.program.getTypeChecker(), token_1, parentDeclaration_1);
              });
              return [codefix2.createCodeFixAction(fixName, changes, [ts2.Diagnostics.Add_missing_enum_member_0, token_1.text], fixId, ts2.Diagnostics.Add_all_missing_members)];
            }
            var parentDeclaration = info.parentDeclaration, declSourceFile = info.declSourceFile, inJs = info.inJs, makeStatic = info.makeStatic, token = info.token, call = info.call;
            var methodCodeAction = call && getActionForMethodDeclaration(context, declSourceFile, parentDeclaration, token, call, makeStatic, inJs);
            var addMember = inJs && !ts2.isInterfaceDeclaration(parentDeclaration) ? ts2.singleElementArray(getActionsForAddMissingMemberInJavascriptFile(context, declSourceFile, parentDeclaration, token, makeStatic)) : getActionsForAddMissingMemberInTypeScriptFile(context, declSourceFile, parentDeclaration, token, makeStatic);
            return ts2.concatenate(ts2.singleElementArray(methodCodeAction), addMember);
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var program = context.program;
            var checker = program.getTypeChecker();
            var seen = ts2.createMap();
            var typeDeclToMembers = new ts2.NodeMap();
            return codefix2.createCombinedCodeActions(ts2.textChanges.ChangeTracker.with(context, function(changes) {
              codefix2.eachDiagnostic(context, errorCodes, function(diag) {
                var info = getInfo(diag.file, diag.start, checker, context.program);
                if (!info || !ts2.addToSeen(seen, ts2.getNodeId(info.parentDeclaration) + "#" + info.token.text)) {
                  return;
                }
                if (info.kind === 0) {
                  var token = info.token, parentDeclaration = info.parentDeclaration;
                  addEnumMemberDeclaration(changes, checker, token, parentDeclaration);
                } else {
                  var parentDeclaration = info.parentDeclaration, token_2 = info.token;
                  var infos = typeDeclToMembers.getOrUpdate(parentDeclaration, function() {
                    return [];
                  });
                  if (!infos.some(function(i) {
                    return i.token.text === token_2.text;
                  }))
                    infos.push(info);
                }
              });
              typeDeclToMembers.forEach(function(infos, classDeclaration) {
                var supers = getAllSupers(classDeclaration, checker);
                var _loop_13 = function(info2) {
                  if (supers.some(function(superClassOrInterface) {
                    var superInfos = typeDeclToMembers.get(superClassOrInterface);
                    return !!superInfos && superInfos.some(function(_a) {
                      var token2 = _a.token;
                      return token2.text === info2.token.text;
                    });
                  }))
                    return "continue";
                  var parentDeclaration = info2.parentDeclaration, declSourceFile = info2.declSourceFile, inJs = info2.inJs, makeStatic = info2.makeStatic, token = info2.token, call = info2.call;
                  if (call && !ts2.isPrivateIdentifier(token)) {
                    addMethodDeclaration(context, changes, declSourceFile, parentDeclaration, token, call, makeStatic, inJs);
                  } else {
                    if (inJs && !ts2.isInterfaceDeclaration(parentDeclaration)) {
                      addMissingMemberInJs(changes, declSourceFile, parentDeclaration, token, makeStatic);
                    } else {
                      var typeNode = getTypeNode(program.getTypeChecker(), parentDeclaration, token);
                      addPropertyDeclaration(changes, declSourceFile, parentDeclaration, token.text, typeNode, makeStatic ? 32 : 0);
                    }
                  }
                };
                for (var _i = 0, infos_1 = infos; _i < infos_1.length; _i++) {
                  var info = infos_1[_i];
                  _loop_13(info);
                }
              });
            }));
          }
        });
        function getAllSupers(decl, checker) {
          var res = [];
          while (decl) {
            var superElement = ts2.getClassExtendsHeritageElement(decl);
            var superSymbol = superElement && checker.getSymbolAtLocation(superElement.expression);
            var superDecl = superSymbol && ts2.find(superSymbol.declarations, ts2.isClassLike);
            if (superDecl) {
              res.push(superDecl);
            }
            decl = superDecl;
          }
          return res;
        }
        var InfoKind;
        (function(InfoKind2) {
          InfoKind2[InfoKind2["Enum"] = 0] = "Enum";
          InfoKind2[InfoKind2["ClassOrInterface"] = 1] = "ClassOrInterface";
        })(InfoKind || (InfoKind = {}));
        function getInfo(tokenSourceFile, tokenPos, checker, program) {
          var token = ts2.getTokenAtPosition(tokenSourceFile, tokenPos);
          if (!ts2.isIdentifier(token) && !ts2.isPrivateIdentifier(token)) {
            return void 0;
          }
          var parent = token.parent;
          if (!ts2.isPropertyAccessExpression(parent))
            return void 0;
          var leftExpressionType = ts2.skipConstraint(checker.getTypeAtLocation(parent.expression));
          var symbol = leftExpressionType.symbol;
          if (!symbol || !symbol.declarations)
            return void 0;
          var classDeclaration = ts2.find(symbol.declarations, ts2.isClassLike);
          if (!classDeclaration && ts2.isPrivateIdentifier(token)) {
            return void 0;
          }
          var classOrInterface = classDeclaration || ts2.find(symbol.declarations, ts2.isInterfaceDeclaration);
          if (classOrInterface && !program.isSourceFileFromExternalLibrary(classOrInterface.getSourceFile())) {
            var makeStatic = (leftExpressionType.target || leftExpressionType) !== checker.getDeclaredTypeOfSymbol(symbol);
            if (makeStatic && (ts2.isPrivateIdentifier(token) || ts2.isInterfaceDeclaration(classOrInterface))) {
              return void 0;
            }
            var declSourceFile = classOrInterface.getSourceFile();
            var inJs = ts2.isSourceFileJS(declSourceFile);
            var call = ts2.tryCast(parent.parent, ts2.isCallExpression);
            return { kind: 1, token, parentDeclaration: classOrInterface, makeStatic, declSourceFile, inJs, call };
          }
          var enumDeclaration = ts2.find(symbol.declarations, ts2.isEnumDeclaration);
          if (enumDeclaration && !ts2.isPrivateIdentifier(token) && !program.isSourceFileFromExternalLibrary(enumDeclaration.getSourceFile())) {
            return { kind: 0, token, parentDeclaration: enumDeclaration };
          }
          return void 0;
        }
        function getActionsForAddMissingMemberInJavascriptFile(context, declSourceFile, classDeclaration, token, makeStatic) {
          var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
            return addMissingMemberInJs(t, declSourceFile, classDeclaration, token, makeStatic);
          });
          if (changes.length === 0) {
            return void 0;
          }
          var diagnostic = makeStatic ? ts2.Diagnostics.Initialize_static_property_0 : ts2.isPrivateIdentifier(token) ? ts2.Diagnostics.Declare_a_private_field_named_0 : ts2.Diagnostics.Initialize_property_0_in_the_constructor;
          return codefix2.createCodeFixAction(fixName, changes, [diagnostic, token.text], fixId, ts2.Diagnostics.Add_all_missing_members);
        }
        function addMissingMemberInJs(changeTracker, declSourceFile, classDeclaration, token, makeStatic) {
          var tokenName = token.text;
          if (makeStatic) {
            if (classDeclaration.kind === 214) {
              return;
            }
            var className = classDeclaration.name.getText();
            var staticInitialization = initializePropertyToUndefined(ts2.createIdentifier(className), tokenName);
            changeTracker.insertNodeAfter(declSourceFile, classDeclaration, staticInitialization);
          } else if (ts2.isPrivateIdentifier(token)) {
            var property = ts2.createProperty(void 0, void 0, tokenName, void 0, void 0, void 0);
            var lastProp = getNodeToInsertPropertyAfter(classDeclaration);
            if (lastProp) {
              changeTracker.insertNodeAfter(declSourceFile, lastProp, property);
            } else {
              changeTracker.insertNodeAtClassStart(declSourceFile, classDeclaration, property);
            }
          } else {
            var classConstructor = ts2.getFirstConstructorWithBody(classDeclaration);
            if (!classConstructor) {
              return;
            }
            var propertyInitialization = initializePropertyToUndefined(ts2.createThis(), tokenName);
            changeTracker.insertNodeAtConstructorEnd(declSourceFile, classConstructor, propertyInitialization);
          }
        }
        function initializePropertyToUndefined(obj, propertyName) {
          return ts2.createStatement(ts2.createAssignment(ts2.createPropertyAccess(obj, propertyName), ts2.createIdentifier("undefined")));
        }
        function getActionsForAddMissingMemberInTypeScriptFile(context, declSourceFile, classDeclaration, token, makeStatic) {
          var typeNode = getTypeNode(context.program.getTypeChecker(), classDeclaration, token);
          var actions = [createAddPropertyDeclarationAction(context, declSourceFile, classDeclaration, token.text, typeNode, makeStatic ? 32 : 0)];
          if (makeStatic || ts2.isPrivateIdentifier(token)) {
            return actions;
          }
          if (ts2.startsWithUnderscore(token.text)) {
            actions.unshift(createAddPropertyDeclarationAction(context, declSourceFile, classDeclaration, token.text, typeNode, 8));
          }
          actions.push(createAddIndexSignatureAction(context, declSourceFile, classDeclaration, token.text, typeNode));
          return actions;
        }
        function getTypeNode(checker, classDeclaration, token) {
          var typeNode;
          if (token.parent.parent.kind === 209) {
            var binaryExpression = token.parent.parent;
            var otherExpression = token.parent === binaryExpression.left ? binaryExpression.right : binaryExpression.left;
            var widenedType = checker.getWidenedType(checker.getBaseTypeOfLiteralType(checker.getTypeAtLocation(otherExpression)));
            typeNode = checker.typeToTypeNode(widenedType, classDeclaration, void 0);
          } else {
            var contextualType = checker.getContextualType(token.parent);
            typeNode = contextualType ? checker.typeToTypeNode(contextualType, void 0, void 0) : void 0;
          }
          return typeNode || ts2.createKeywordTypeNode(125);
        }
        function createAddPropertyDeclarationAction(context, declSourceFile, classDeclaration, tokenName, typeNode, modifierFlags) {
          var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
            return addPropertyDeclaration(t, declSourceFile, classDeclaration, tokenName, typeNode, modifierFlags);
          });
          if (modifierFlags & 8) {
            return codefix2.createCodeFixActionWithoutFixAll(fixName, changes, [ts2.Diagnostics.Declare_private_property_0, tokenName]);
          }
          return codefix2.createCodeFixAction(fixName, changes, [modifierFlags & 32 ? ts2.Diagnostics.Declare_static_property_0 : ts2.Diagnostics.Declare_property_0, tokenName], fixId, ts2.Diagnostics.Add_all_missing_members);
        }
        function addPropertyDeclaration(changeTracker, declSourceFile, classDeclaration, tokenName, typeNode, modifierFlags) {
          var property = ts2.createProperty(void 0, modifierFlags ? ts2.createNodeArray(ts2.createModifiersFromModifierFlags(modifierFlags)) : void 0, tokenName, void 0, typeNode, void 0);
          var lastProp = getNodeToInsertPropertyAfter(classDeclaration);
          if (lastProp) {
            changeTracker.insertNodeAfter(declSourceFile, lastProp, property);
          } else {
            changeTracker.insertNodeAtClassStart(declSourceFile, classDeclaration, property);
          }
        }
        function getNodeToInsertPropertyAfter(cls) {
          var res;
          for (var _i = 0, _a = cls.members; _i < _a.length; _i++) {
            var member = _a[_i];
            if (!ts2.isPropertyDeclaration(member))
              break;
            res = member;
          }
          return res;
        }
        function createAddIndexSignatureAction(context, declSourceFile, classDeclaration, tokenName, typeNode) {
          var stringTypeNode = ts2.createKeywordTypeNode(143);
          var indexingParameter = ts2.createParameter(void 0, void 0, void 0, "x", void 0, stringTypeNode, void 0);
          var indexSignature = ts2.createIndexSignature(void 0, void 0, [indexingParameter], typeNode);
          var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
            return t.insertNodeAtClassStart(declSourceFile, classDeclaration, indexSignature);
          });
          return codefix2.createCodeFixActionWithoutFixAll(fixName, changes, [ts2.Diagnostics.Add_index_signature_for_property_0, tokenName]);
        }
        function getActionForMethodDeclaration(context, declSourceFile, classDeclaration, token, callExpression, makeStatic, inJs) {
          if (ts2.isPrivateIdentifier(token)) {
            return void 0;
          }
          var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
            return addMethodDeclaration(context, t, declSourceFile, classDeclaration, token, callExpression, makeStatic, inJs);
          });
          return codefix2.createCodeFixAction(fixName, changes, [makeStatic ? ts2.Diagnostics.Declare_static_method_0 : ts2.Diagnostics.Declare_method_0, token.text], fixId, ts2.Diagnostics.Add_all_missing_members);
        }
        function addMethodDeclaration(context, changeTracker, declSourceFile, typeDecl, token, callExpression, makeStatic, inJs) {
          var importAdder = codefix2.createImportAdder(declSourceFile, context.program, context.preferences, context.host);
          var methodDeclaration = codefix2.createMethodFromCallExpression(context, callExpression, token.text, inJs, makeStatic, typeDecl, importAdder);
          var containingMethodDeclaration = ts2.getAncestor(callExpression, 161);
          if (containingMethodDeclaration && containingMethodDeclaration.parent === typeDecl) {
            changeTracker.insertNodeAfter(declSourceFile, containingMethodDeclaration, methodDeclaration);
          } else {
            changeTracker.insertNodeAtClassStart(declSourceFile, typeDecl, methodDeclaration);
          }
          importAdder.writeFixes(changeTracker);
        }
        function addEnumMemberDeclaration(changes, checker, token, enumDeclaration) {
          var hasStringInitializer = ts2.some(enumDeclaration.members, function(member) {
            var type = checker.getTypeAtLocation(member);
            return !!(type && type.flags & 132);
          });
          var enumMember = ts2.createEnumMember(token, hasStringInitializer ? ts2.createStringLiteral(token.text) : void 0);
          changes.replaceNode(enumDeclaration.getSourceFile(), enumDeclaration, ts2.updateEnumDeclaration(enumDeclaration, enumDeclaration.decorators, enumDeclaration.modifiers, enumDeclaration.name, ts2.concatenate(enumDeclaration.members, ts2.singleElementArray(enumMember))), {
            leadingTriviaOption: ts2.textChanges.LeadingTriviaOption.IncludeAll,
            trailingTriviaOption: ts2.textChanges.TrailingTriviaOption.Exclude
          });
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "addMissingNewOperator";
        var errorCodes = [ts2.Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return addMissingNewOperator(t, sourceFile, span);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Add_missing_new_operator_to_call, fixId, ts2.Diagnostics.Add_missing_new_operator_to_all_calls)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return addMissingNewOperator(changes, context.sourceFile, diag);
            });
          }
        });
        function addMissingNewOperator(changes, sourceFile, span) {
          var call = ts2.cast(findAncestorMatchingSpan(sourceFile, span), ts2.isCallExpression);
          var newExpression = ts2.createNew(call.expression, call.typeArguments, call.arguments);
          changes.replaceNode(sourceFile, call, newExpression);
        }
        function findAncestorMatchingSpan(sourceFile, span) {
          var token = ts2.getTokenAtPosition(sourceFile, span.start);
          var end = ts2.textSpanEnd(span);
          while (token.end < end) {
            token = token.parent;
          }
          return token;
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixName = "fixCannotFindModule";
        var fixIdInstallTypesPackage = "installTypesPackage";
        var errorCodeCannotFindModule = ts2.Diagnostics.Cannot_find_module_0_or_its_corresponding_type_declarations.code;
        var errorCodes = [
          errorCodeCannotFindModule,
          ts2.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var host = context.host, sourceFile = context.sourceFile, start = context.span.start;
            var packageName = tryGetImportedPackageName(sourceFile, start);
            if (packageName === void 0)
              return void 0;
            var typesPackageName = getTypesPackageNameToInstall(packageName, host, context.errorCode);
            return typesPackageName === void 0 ? [] : [codefix2.createCodeFixAction(fixName, [], [ts2.Diagnostics.Install_0, typesPackageName], fixIdInstallTypesPackage, ts2.Diagnostics.Install_all_missing_types_packages, getInstallCommand(sourceFile.fileName, typesPackageName))];
          },
          fixIds: [fixIdInstallTypesPackage],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(_changes, diag, commands) {
              var packageName = tryGetImportedPackageName(diag.file, diag.start);
              if (packageName === void 0)
                return void 0;
              switch (context.fixId) {
                case fixIdInstallTypesPackage: {
                  var pkg = getTypesPackageNameToInstall(packageName, context.host, diag.code);
                  if (pkg) {
                    commands.push(getInstallCommand(diag.file.fileName, pkg));
                  }
                  break;
                }
                default:
                  ts2.Debug.fail("Bad fixId: " + context.fixId);
              }
            });
          }
        });
        function getInstallCommand(fileName, packageName) {
          return { type: "install package", file: fileName, packageName };
        }
        function tryGetImportedPackageName(sourceFile, pos) {
          var moduleName = ts2.cast(ts2.getTokenAtPosition(sourceFile, pos), ts2.isStringLiteral).text;
          var packageName = ts2.parsePackageName(moduleName).packageName;
          return ts2.isExternalModuleNameRelative(packageName) ? void 0 : packageName;
        }
        function getTypesPackageNameToInstall(packageName, host, diagCode) {
          return diagCode === errorCodeCannotFindModule ? ts2.JsTyping.nodeCoreModules.has(packageName) ? "@types/node" : void 0 : host.isKnownTypesPackageName(packageName) ? ts2.getTypesPackageName(packageName) : void 0;
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var errorCodes = [
          ts2.Diagnostics.Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2.code,
          ts2.Diagnostics.Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1.code
        ];
        var fixId = "fixClassDoesntImplementInheritedAbstractMember";
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return addMissingMembers(getClass(sourceFile, span.start), sourceFile, context, t, context.preferences);
            });
            return changes.length === 0 ? void 0 : [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Implement_inherited_abstract_class, fixId, ts2.Diagnostics.Implement_all_inherited_abstract_classes)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var seenClassDeclarations = ts2.createMap();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var classDeclaration = getClass(diag.file, diag.start);
              if (ts2.addToSeen(seenClassDeclarations, ts2.getNodeId(classDeclaration))) {
                addMissingMembers(classDeclaration, context.sourceFile, context, changes, context.preferences);
              }
            });
          }
        });
        function getClass(sourceFile, pos) {
          var token = ts2.getTokenAtPosition(sourceFile, pos);
          return ts2.cast(token.parent, ts2.isClassLike);
        }
        function addMissingMembers(classDeclaration, sourceFile, context, changeTracker, preferences) {
          var extendsNode = ts2.getEffectiveBaseTypeNode(classDeclaration);
          var checker = context.program.getTypeChecker();
          var instantiatedExtendsType = checker.getTypeAtLocation(extendsNode);
          var abstractAndNonPrivateExtendsSymbols = checker.getPropertiesOfType(instantiatedExtendsType).filter(symbolPointsToNonPrivateAndAbstractMember);
          var importAdder = codefix2.createImportAdder(sourceFile, context.program, preferences, context.host);
          codefix2.createMissingMemberNodes(classDeclaration, abstractAndNonPrivateExtendsSymbols, context, preferences, importAdder, function(member) {
            return changeTracker.insertNodeAtClassStart(sourceFile, classDeclaration, member);
          });
          importAdder.writeFixes(changeTracker);
        }
        function symbolPointsToNonPrivateAndAbstractMember(symbol) {
          var flags = ts2.getModifierFlags(ts2.first(symbol.getDeclarations()));
          return !(flags & 8) && !!(flags & 128);
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "classSuperMustPrecedeThisAccess";
        var errorCodes = [ts2.Diagnostics.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var nodes = getNodes(sourceFile, span.start);
            if (!nodes)
              return void 0;
            var constructor = nodes.constructor, superCall = nodes.superCall;
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, constructor, superCall);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Make_super_call_the_first_statement_in_the_constructor, fixId, ts2.Diagnostics.Make_all_super_calls_the_first_statement_in_their_constructor)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var seenClasses = ts2.createMap();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var nodes = getNodes(diag.file, diag.start);
              if (!nodes)
                return;
              var constructor = nodes.constructor, superCall = nodes.superCall;
              if (ts2.addToSeen(seenClasses, ts2.getNodeId(constructor.parent))) {
                doChange(changes, sourceFile, constructor, superCall);
              }
            });
          }
        });
        function doChange(changes, sourceFile, constructor, superCall) {
          changes.insertNodeAtConstructorStart(sourceFile, constructor, superCall);
          changes.delete(sourceFile, superCall);
        }
        function getNodes(sourceFile, pos) {
          var token = ts2.getTokenAtPosition(sourceFile, pos);
          if (token.kind !== 104)
            return void 0;
          var constructor = ts2.getContainingFunction(token);
          var superCall = findSuperCall(constructor.body);
          return superCall && !superCall.expression.arguments.some(function(arg) {
            return ts2.isPropertyAccessExpression(arg) && arg.expression === token;
          }) ? { constructor, superCall } : void 0;
        }
        function findSuperCall(n) {
          return ts2.isExpressionStatement(n) && ts2.isSuperCall(n.expression) ? n : ts2.isFunctionLike(n) ? void 0 : ts2.forEachChild(n, findSuperCall);
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "constructorForDerivedNeedSuperCall";
        var errorCodes = [ts2.Diagnostics.Constructors_for_derived_classes_must_contain_a_super_call.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var ctr = getNode(sourceFile, span.start);
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, ctr);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Add_missing_super_call, fixId, ts2.Diagnostics.Add_all_missing_super_calls)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return doChange(changes, context.sourceFile, getNode(diag.file, diag.start));
            });
          }
        });
        function getNode(sourceFile, pos) {
          var token = ts2.getTokenAtPosition(sourceFile, pos);
          ts2.Debug.assert(ts2.isConstructorDeclaration(token.parent), "token should be at the constructor declaration");
          return token.parent;
        }
        function doChange(changes, sourceFile, ctr) {
          var superCall = ts2.createStatement(ts2.createCall(ts2.createSuper(), void 0, ts2.emptyArray));
          changes.insertNodeAtConstructorStart(sourceFile, ctr, superCall);
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "enableExperimentalDecorators";
        var errorCodes = [
          ts2.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var configFile = context.program.getCompilerOptions().configFile;
            if (configFile === void 0) {
              return void 0;
            }
            var changes = ts2.textChanges.ChangeTracker.with(context, function(changeTracker) {
              return doChange(changeTracker, configFile);
            });
            return [codefix2.createCodeFixActionWithoutFixAll(fixId, changes, ts2.Diagnostics.Enable_the_experimentalDecorators_option_in_your_configuration_file)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes) {
              var configFile = context.program.getCompilerOptions().configFile;
              if (configFile === void 0) {
                return void 0;
              }
              doChange(changes, configFile);
            });
          }
        });
        function doChange(changeTracker, configFile) {
          codefix2.setJsonCompilerOptionValue(changeTracker, configFile, "experimentalDecorators", ts2.createTrue());
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixID = "fixEnableJsxFlag";
        var errorCodes = [ts2.Diagnostics.Cannot_use_JSX_unless_the_jsx_flag_is_provided.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var configFile = context.program.getCompilerOptions().configFile;
            if (configFile === void 0) {
              return void 0;
            }
            var changes = ts2.textChanges.ChangeTracker.with(context, function(changeTracker) {
              return doChange(changeTracker, configFile);
            });
            return [
              codefix2.createCodeFixActionWithoutFixAll(fixID, changes, ts2.Diagnostics.Enable_the_jsx_flag_in_your_configuration_file)
            ];
          },
          fixIds: [fixID],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes) {
              var configFile = context.program.getCompilerOptions().configFile;
              if (configFile === void 0) {
                return void 0;
              }
              doChange(changes, configFile);
            });
          }
        });
        function doChange(changeTracker, configFile) {
          codefix2.setJsonCompilerOptionValue(changeTracker, configFile, "jsx", ts2.createStringLiteral("react"));
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        codefix2.registerCodeFix({
          errorCodes: [ts2.Diagnostics.Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_esnext_or_system_and_the_target_option_is_set_to_es2017_or_higher.code],
          getCodeActions: function(context) {
            var compilerOptions = context.program.getCompilerOptions();
            var configFile = compilerOptions.configFile;
            if (configFile === void 0) {
              return void 0;
            }
            var codeFixes = [];
            var moduleKind = ts2.getEmitModuleKind(compilerOptions);
            var moduleOutOfRange = moduleKind >= ts2.ModuleKind.ES2015 && moduleKind < ts2.ModuleKind.ESNext;
            if (moduleOutOfRange) {
              var changes = ts2.textChanges.ChangeTracker.with(context, function(changes2) {
                codefix2.setJsonCompilerOptionValue(changes2, configFile, "module", ts2.createStringLiteral("esnext"));
              });
              codeFixes.push(codefix2.createCodeFixActionWithoutFixAll("fixModuleOption", changes, [ts2.Diagnostics.Set_the_module_option_in_your_configuration_file_to_0, "esnext"]));
            }
            var target = ts2.getEmitScriptTarget(compilerOptions);
            var targetOutOfRange = target < 4 || target > 99;
            if (targetOutOfRange) {
              var changes = ts2.textChanges.ChangeTracker.with(context, function(tracker) {
                var configObject = ts2.getTsConfigObjectLiteralExpression(configFile);
                if (!configObject)
                  return;
                var options = [["target", ts2.createStringLiteral("es2017")]];
                if (moduleKind === ts2.ModuleKind.CommonJS) {
                  options.push(["module", ts2.createStringLiteral("commonjs")]);
                }
                codefix2.setJsonCompilerOptionValues(tracker, configFile, options);
              });
              codeFixes.push(codefix2.createCodeFixActionWithoutFixAll("fixTargetOption", changes, [ts2.Diagnostics.Set_the_target_option_in_your_configuration_file_to_0, "es2017"]));
            }
            return codeFixes.length ? codeFixes : void 0;
          }
        });
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "extendsInterfaceBecomesImplements";
        var errorCodes = [ts2.Diagnostics.Cannot_extend_an_interface_0_Did_you_mean_implements.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var nodes = getNodes(sourceFile, context.span.start);
            if (!nodes)
              return void 0;
            var extendsToken = nodes.extendsToken, heritageClauses = nodes.heritageClauses;
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChanges(t, sourceFile, extendsToken, heritageClauses);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Change_extends_to_implements, fixId, ts2.Diagnostics.Change_all_extended_interfaces_to_implements)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var nodes = getNodes(diag.file, diag.start);
              if (nodes)
                doChanges(changes, diag.file, nodes.extendsToken, nodes.heritageClauses);
            });
          }
        });
        function getNodes(sourceFile, pos) {
          var token = ts2.getTokenAtPosition(sourceFile, pos);
          var heritageClauses = ts2.getContainingClass(token).heritageClauses;
          var extendsToken = heritageClauses[0].getFirstToken();
          return extendsToken.kind === 90 ? { extendsToken, heritageClauses } : void 0;
        }
        function doChanges(changes, sourceFile, extendsToken, heritageClauses) {
          changes.replaceNode(sourceFile, extendsToken, ts2.createToken(113));
          if (heritageClauses.length === 2 && heritageClauses[0].token === 90 && heritageClauses[1].token === 113) {
            var implementsToken = heritageClauses[1].getFirstToken();
            var implementsFullStart = implementsToken.getFullStart();
            changes.replaceRange(sourceFile, { pos: implementsFullStart, end: implementsFullStart }, ts2.createToken(27));
            var text = sourceFile.text;
            var end = implementsToken.end;
            while (end < text.length && ts2.isWhiteSpaceSingleLine(text.charCodeAt(end))) {
              end++;
            }
            changes.deleteRange(sourceFile, { pos: implementsToken.getStart(), end });
          }
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "forgottenThisPropertyAccess";
        var didYouMeanStaticMemberCode = ts2.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code;
        var errorCodes = [
          ts2.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,
          ts2.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies.code,
          didYouMeanStaticMemberCode
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var info = getInfo(sourceFile, context.span.start, context.errorCode);
            if (!info) {
              return void 0;
            }
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, info);
            });
            return [codefix2.createCodeFixAction(fixId, changes, [ts2.Diagnostics.Add_0_to_unresolved_variable, info.className || "this"], fixId, ts2.Diagnostics.Add_qualifier_to_all_unresolved_variables_matching_a_member_name)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, diag.start, diag.code);
              if (info)
                doChange(changes, context.sourceFile, info);
            });
          }
        });
        function getInfo(sourceFile, pos, diagCode) {
          var node = ts2.getTokenAtPosition(sourceFile, pos);
          if (ts2.isIdentifier(node)) {
            return { node, className: diagCode === didYouMeanStaticMemberCode ? ts2.getContainingClass(node).name.text : void 0 };
          }
        }
        function doChange(changes, sourceFile, _a) {
          var node = _a.node, className = _a.className;
          ts2.suppressLeadingAndTrailingTrivia(node);
          changes.replaceNode(sourceFile, node, ts2.createPropertyAccess(className ? ts2.createIdentifier(className) : ts2.createThis(), node));
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixIdExpression = "fixInvalidJsxCharacters_expression";
        var fixIdHtmlEntity = "fixInvalidJsxCharacters_htmlEntity";
        var errorCodes = [
          ts2.Diagnostics.Unexpected_token_Did_you_mean_or_gt.code,
          ts2.Diagnostics.Unexpected_token_Did_you_mean_or_rbrace.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          fixIds: [fixIdExpression, fixIdHtmlEntity],
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, preferences = context.preferences, span = context.span;
            var changeToExpression = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, preferences, sourceFile, span.start, false);
            });
            var changeToHtmlEntity = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, preferences, sourceFile, span.start, true);
            });
            return [
              codefix2.createCodeFixAction(fixIdExpression, changeToExpression, ts2.Diagnostics.Wrap_invalid_character_in_an_expression_container, fixIdExpression, ts2.Diagnostics.Wrap_all_invalid_characters_in_an_expression_container),
              codefix2.createCodeFixAction(fixIdHtmlEntity, changeToHtmlEntity, ts2.Diagnostics.Convert_invalid_character_to_its_html_entity_code, fixIdHtmlEntity, ts2.Diagnostics.Convert_all_invalid_characters_to_HTML_entity_code)
            ];
          },
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diagnostic) {
              return doChange(changes, context.preferences, diagnostic.file, diagnostic.start, context.fixId === fixIdHtmlEntity);
            });
          }
        });
        var htmlEntity = {
          ">": "&gt;",
          "}": "&rbrace;"
        };
        function isValidCharacter(character) {
          return ts2.hasProperty(htmlEntity, character);
        }
        function doChange(changes, preferences, sourceFile, start, useHtmlEntity) {
          var character = sourceFile.getText()[start];
          if (!isValidCharacter(character)) {
            return;
          }
          var replacement = useHtmlEntity ? htmlEntity[character] : "{" + ts2.quote(character, preferences) + "}";
          changes.replaceRangeWithText(sourceFile, { pos: start, end: start + 1 }, replacement);
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixName = "unusedIdentifier";
        var fixIdPrefix = "unusedIdentifier_prefix";
        var fixIdDelete = "unusedIdentifier_delete";
        var fixIdInfer = "unusedIdentifier_infer";
        var errorCodes = [
          ts2.Diagnostics._0_is_declared_but_its_value_is_never_read.code,
          ts2.Diagnostics._0_is_declared_but_never_used.code,
          ts2.Diagnostics.Property_0_is_declared_but_its_value_is_never_read.code,
          ts2.Diagnostics.All_imports_in_import_declaration_are_unused.code,
          ts2.Diagnostics.All_destructured_elements_are_unused.code,
          ts2.Diagnostics.All_variables_are_unused.code,
          ts2.Diagnostics.All_type_parameters_are_unused.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var errorCode = context.errorCode, sourceFile = context.sourceFile, program = context.program;
            var checker = program.getTypeChecker();
            var sourceFiles = program.getSourceFiles();
            var token = ts2.getTokenAtPosition(sourceFile, context.span.start);
            if (ts2.isJSDocTemplateTag(token)) {
              return [createDeleteFix(ts2.textChanges.ChangeTracker.with(context, function(t) {
                return t.delete(sourceFile, token);
              }), ts2.Diagnostics.Remove_template_tag)];
            }
            if (token.kind === 29) {
              var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
                return deleteTypeParameters(t, sourceFile, token);
              });
              return [createDeleteFix(changes, ts2.Diagnostics.Remove_type_parameters)];
            }
            var importDecl = tryGetFullImport(token);
            if (importDecl) {
              var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
                return t.delete(sourceFile, importDecl);
              });
              return [createDeleteFix(changes, [ts2.Diagnostics.Remove_import_from_0, ts2.showModuleSpecifier(importDecl)])];
            }
            var delDestructure = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return tryDeleteFullDestructure(token, t, sourceFile, checker, sourceFiles, false);
            });
            if (delDestructure.length) {
              return [createDeleteFix(delDestructure, ts2.Diagnostics.Remove_destructuring)];
            }
            var delVar = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return tryDeleteFullVariableStatement(sourceFile, token, t);
            });
            if (delVar.length) {
              return [createDeleteFix(delVar, ts2.Diagnostics.Remove_variable_statement)];
            }
            var result = [];
            if (token.kind === 132) {
              var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
                return changeInferToUnknown(t, sourceFile, token);
              });
              var name = ts2.cast(token.parent, ts2.isInferTypeNode).typeParameter.name.text;
              result.push(codefix2.createCodeFixAction(fixName, changes, [ts2.Diagnostics.Replace_infer_0_with_unknown, name], fixIdInfer, ts2.Diagnostics.Replace_all_unused_infer_with_unknown));
            } else {
              var deletion = ts2.textChanges.ChangeTracker.with(context, function(t) {
                return tryDeleteDeclaration(sourceFile, token, t, checker, sourceFiles, false);
              });
              if (deletion.length) {
                var name = ts2.isComputedPropertyName(token.parent) ? token.parent : token;
                result.push(createDeleteFix(deletion, [ts2.Diagnostics.Remove_unused_declaration_for_Colon_0, name.getText(sourceFile)]));
              }
            }
            var prefix = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return tryPrefixDeclaration(t, errorCode, sourceFile, token);
            });
            if (prefix.length) {
              result.push(codefix2.createCodeFixAction(fixName, prefix, [ts2.Diagnostics.Prefix_0_with_an_underscore, token.getText(sourceFile)], fixIdPrefix, ts2.Diagnostics.Prefix_all_unused_declarations_with_where_possible));
            }
            return result;
          },
          fixIds: [fixIdPrefix, fixIdDelete, fixIdInfer],
          getAllCodeActions: function(context) {
            var sourceFile = context.sourceFile, program = context.program;
            var checker = program.getTypeChecker();
            var sourceFiles = program.getSourceFiles();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var token = ts2.getTokenAtPosition(sourceFile, diag.start);
              switch (context.fixId) {
                case fixIdPrefix:
                  tryPrefixDeclaration(changes, diag.code, sourceFile, token);
                  break;
                case fixIdDelete: {
                  if (token.kind === 132)
                    break;
                  var importDecl = tryGetFullImport(token);
                  if (importDecl) {
                    changes.delete(sourceFile, importDecl);
                  } else if (ts2.isJSDocTemplateTag(token)) {
                    changes.delete(sourceFile, token);
                  } else if (token.kind === 29) {
                    deleteTypeParameters(changes, sourceFile, token);
                  } else if (!tryDeleteFullDestructure(token, changes, sourceFile, checker, sourceFiles, true) && !tryDeleteFullVariableStatement(sourceFile, token, changes)) {
                    tryDeleteDeclaration(sourceFile, token, changes, checker, sourceFiles, true);
                  }
                  break;
                }
                case fixIdInfer:
                  if (token.kind === 132) {
                    changeInferToUnknown(changes, sourceFile, token);
                  }
                  break;
                default:
                  ts2.Debug.fail(JSON.stringify(context.fixId));
              }
            });
          }
        });
        function changeInferToUnknown(changes, sourceFile, token) {
          changes.replaceNode(sourceFile, token.parent, ts2.createKeywordTypeNode(148));
        }
        function createDeleteFix(changes, diag) {
          return codefix2.createCodeFixAction(fixName, changes, diag, fixIdDelete, ts2.Diagnostics.Delete_all_unused_declarations);
        }
        function deleteTypeParameters(changes, sourceFile, token) {
          changes.delete(sourceFile, ts2.Debug.checkDefined(ts2.cast(token.parent, ts2.isDeclarationWithTypeParameterChildren).typeParameters, "The type parameter to delete should exist"));
        }
        function tryGetFullImport(token) {
          return token.kind === 96 ? ts2.tryCast(token.parent, ts2.isImportDeclaration) : void 0;
        }
        function tryDeleteFullDestructure(token, changes, sourceFile, checker, sourceFiles, isFixAll) {
          if (token.kind !== 18 || !ts2.isObjectBindingPattern(token.parent))
            return false;
          var decl = token.parent.parent;
          if (decl.kind === 156) {
            tryDeleteParameter(changes, sourceFile, decl, checker, sourceFiles, isFixAll);
          } else {
            changes.delete(sourceFile, decl);
          }
          return true;
        }
        function tryDeleteFullVariableStatement(sourceFile, token, changes) {
          var declarationList = ts2.tryCast(token.parent, ts2.isVariableDeclarationList);
          if (declarationList && declarationList.getChildren(sourceFile)[0] === token) {
            changes.delete(sourceFile, declarationList.parent.kind === 225 ? declarationList.parent : declarationList);
            return true;
          }
          return false;
        }
        function tryPrefixDeclaration(changes, errorCode, sourceFile, token) {
          if (errorCode === ts2.Diagnostics.Property_0_is_declared_but_its_value_is_never_read.code)
            return;
          if (token.kind === 132) {
            token = ts2.cast(token.parent, ts2.isInferTypeNode).typeParameter.name;
          }
          if (ts2.isIdentifier(token) && canPrefix(token)) {
            changes.replaceNode(sourceFile, token, ts2.createIdentifier("_" + token.text));
            if (ts2.isParameter(token.parent)) {
              ts2.getJSDocParameterTags(token.parent).forEach(function(tag) {
                if (ts2.isIdentifier(tag.name)) {
                  changes.replaceNode(sourceFile, tag.name, ts2.createIdentifier("_" + tag.name.text));
                }
              });
            }
          }
        }
        function canPrefix(token) {
          switch (token.parent.kind) {
            case 156:
            case 155:
              return true;
            case 242: {
              var varDecl = token.parent;
              switch (varDecl.parent.parent.kind) {
                case 232:
                case 231:
                  return true;
              }
            }
          }
          return false;
        }
        function tryDeleteDeclaration(sourceFile, token, changes, checker, sourceFiles, isFixAll) {
          tryDeleteDeclarationWorker(token, changes, sourceFile, checker, sourceFiles, isFixAll);
          if (ts2.isIdentifier(token))
            deleteAssignments(changes, sourceFile, token, checker);
        }
        function deleteAssignments(changes, sourceFile, token, checker) {
          ts2.FindAllReferences.Core.eachSymbolReferenceInFile(token, checker, sourceFile, function(ref) {
            if (ts2.isPropertyAccessExpression(ref.parent) && ref.parent.name === ref)
              ref = ref.parent;
            if (ts2.isBinaryExpression(ref.parent) && ts2.isExpressionStatement(ref.parent.parent) && ref.parent.left === ref) {
              changes.delete(sourceFile, ref.parent.parent);
            }
          });
        }
        function tryDeleteDeclarationWorker(token, changes, sourceFile, checker, sourceFiles, isFixAll) {
          var parent = token.parent;
          if (ts2.isParameter(parent)) {
            tryDeleteParameter(changes, sourceFile, parent, checker, sourceFiles, isFixAll);
          } else {
            changes.delete(sourceFile, ts2.isImportClause(parent) ? token : ts2.isComputedPropertyName(parent) ? parent.parent : parent);
          }
        }
        function tryDeleteParameter(changes, sourceFile, p, checker, sourceFiles, isFixAll) {
          if (mayDeleteParameter(p, checker, isFixAll)) {
            if (p.modifiers && p.modifiers.length > 0 && (!ts2.isIdentifier(p.name) || ts2.FindAllReferences.Core.isSymbolReferencedInFile(p.name, checker, sourceFile))) {
              p.modifiers.forEach(function(modifier) {
                changes.deleteModifier(sourceFile, modifier);
              });
            } else {
              changes.delete(sourceFile, p);
              deleteUnusedArguments(changes, sourceFile, p, sourceFiles, checker);
            }
          }
        }
        function mayDeleteParameter(p, checker, isFixAll) {
          var parent = p.parent;
          switch (parent.kind) {
            case 161:
              var symbol = checker.getSymbolAtLocation(parent.name);
              if (ts2.isMemberSymbolInBaseType(symbol, checker))
                return false;
            case 162:
            case 244:
              return true;
            case 201:
            case 202: {
              var parameters = parent.parameters;
              var index = parameters.indexOf(p);
              ts2.Debug.assert(index !== -1, "The parameter should already be in the list");
              return isFixAll ? parameters.slice(index + 1).every(function(p2) {
                return p2.name.kind === 75 && !p2.symbol.isReferenced;
              }) : index === parameters.length - 1;
            }
            case 164:
              return false;
            default:
              return ts2.Debug.failBadSyntaxKind(parent);
          }
        }
        function deleteUnusedArguments(changes, sourceFile, deletedParameter, sourceFiles, checker) {
          ts2.FindAllReferences.Core.eachSignatureCall(deletedParameter.parent, sourceFiles, checker, function(call) {
            var index = deletedParameter.parent.parameters.indexOf(deletedParameter);
            if (call.arguments.length > index) {
              changes.delete(sourceFile, call.arguments[index]);
            }
          });
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixUnreachableCode";
        var errorCodes = [ts2.Diagnostics.Unreachable_code_detected.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, context.sourceFile, context.span.start, context.span.length, context.errorCode);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Remove_unreachable_code, fixId, ts2.Diagnostics.Remove_all_unreachable_code)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return doChange(changes, diag.file, diag.start, diag.length, diag.code);
            });
          }
        });
        function doChange(changes, sourceFile, start, length, errorCode) {
          var token = ts2.getTokenAtPosition(sourceFile, start);
          var statement = ts2.findAncestor(token, ts2.isStatement);
          if (statement.getStart(sourceFile) !== token.getStart(sourceFile)) {
            var logData = JSON.stringify({
              statementKind: ts2.Debug.formatSyntaxKind(statement.kind),
              tokenKind: ts2.Debug.formatSyntaxKind(token.kind),
              errorCode,
              start,
              length
            });
            ts2.Debug.fail("Token and statement should start at the same point. " + logData);
          }
          var container = (ts2.isBlock(statement.parent) ? statement.parent : statement).parent;
          if (!ts2.isBlock(statement.parent) || statement === ts2.first(statement.parent.statements)) {
            switch (container.kind) {
              case 227:
                if (container.elseStatement) {
                  if (ts2.isBlock(statement.parent)) {
                    break;
                  } else {
                    changes.replaceNode(sourceFile, statement, ts2.createBlock(ts2.emptyArray));
                  }
                  return;
                }
              case 229:
              case 230:
                changes.delete(sourceFile, container);
                return;
            }
          }
          if (ts2.isBlock(statement.parent)) {
            var end_3 = start + length;
            var lastStatement = ts2.Debug.checkDefined(lastWhere(ts2.sliceAfter(statement.parent.statements, statement), function(s) {
              return s.pos < end_3;
            }), "Some statement should be last");
            changes.deleteNodeRange(sourceFile, statement, lastStatement);
          } else {
            changes.delete(sourceFile, statement);
          }
        }
        function lastWhere(a, pred) {
          var last;
          for (var _i = 0, a_1 = a; _i < a_1.length; _i++) {
            var value = a_1[_i];
            if (!pred(value))
              break;
            last = value;
          }
          return last;
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixUnusedLabel";
        var errorCodes = [ts2.Diagnostics.Unused_label.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, context.sourceFile, context.span.start);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Remove_unused_label, fixId, ts2.Diagnostics.Remove_all_unused_labels)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return doChange(changes, diag.file, diag.start);
            });
          }
        });
        function doChange(changes, sourceFile, start) {
          var token = ts2.getTokenAtPosition(sourceFile, start);
          var labeledStatement = ts2.cast(token.parent, ts2.isLabeledStatement);
          var pos = token.getStart(sourceFile);
          var statementPos = labeledStatement.statement.getStart(sourceFile);
          var end = ts2.positionsAreOnSameLine(pos, statementPos, sourceFile) ? statementPos : ts2.skipTrivia(sourceFile.text, ts2.findChildOfKind(labeledStatement, 58, sourceFile).end, true);
          changes.deleteRange(sourceFile, { pos, end });
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixIdPlain = "fixJSDocTypes_plain";
        var fixIdNullable = "fixJSDocTypes_nullable";
        var errorCodes = [ts2.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var checker = context.program.getTypeChecker();
            var info = getInfo(sourceFile, context.span.start, checker);
            if (!info)
              return void 0;
            var typeNode = info.typeNode, type = info.type;
            var original = typeNode.getText(sourceFile);
            var actions = [fix(type, fixIdPlain, ts2.Diagnostics.Change_all_jsdoc_style_types_to_TypeScript)];
            if (typeNode.kind === 297) {
              actions.push(fix(checker.getNullableType(type, 32768), fixIdNullable, ts2.Diagnostics.Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types));
            }
            return actions;
            function fix(type2, fixId, fixAllDescription) {
              var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
                return doChange(t, sourceFile, typeNode, type2, checker);
              });
              return codefix2.createCodeFixAction("jdocTypes", changes, [ts2.Diagnostics.Change_0_to_1, original, checker.typeToString(type2)], fixId, fixAllDescription);
            }
          },
          fixIds: [fixIdPlain, fixIdNullable],
          getAllCodeActions: function(context) {
            var fixId = context.fixId, program = context.program, sourceFile = context.sourceFile;
            var checker = program.getTypeChecker();
            return codefix2.codeFixAll(context, errorCodes, function(changes, err) {
              var info = getInfo(err.file, err.start, checker);
              if (!info)
                return;
              var typeNode = info.typeNode, type = info.type;
              var fixedType = typeNode.kind === 297 && fixId === fixIdNullable ? checker.getNullableType(type, 32768) : type;
              doChange(changes, sourceFile, typeNode, fixedType, checker);
            });
          }
        });
        function doChange(changes, sourceFile, oldTypeNode, newType, checker) {
          changes.replaceNode(sourceFile, oldTypeNode, checker.typeToTypeNode(newType, oldTypeNode, void 0));
        }
        function getInfo(sourceFile, pos, checker) {
          var decl = ts2.findAncestor(ts2.getTokenAtPosition(sourceFile, pos), isTypeContainer);
          var typeNode = decl && decl.type;
          return typeNode && { typeNode, type: checker.getTypeFromTypeNode(typeNode) };
        }
        function isTypeContainer(node) {
          switch (node.kind) {
            case 217:
            case 165:
            case 166:
            case 244:
            case 163:
            case 167:
            case 186:
            case 161:
            case 160:
            case 156:
            case 159:
            case 158:
            case 164:
            case 247:
            case 199:
            case 242:
              return true;
            default:
              return false;
          }
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixMissingCallParentheses";
        var errorCodes = [
          ts2.Diagnostics.This_condition_will_always_return_true_since_the_function_is_always_defined_Did_you_mean_to_call_it_instead.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          fixIds: [fixId],
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var callName = getCallName(sourceFile, span.start);
            if (!callName)
              return;
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, context.sourceFile, callName);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Add_missing_call_parentheses, fixId, ts2.Diagnostics.Add_all_missing_call_parentheses)];
          },
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var callName = getCallName(diag.file, diag.start);
              if (callName)
                doChange(changes, diag.file, callName);
            });
          }
        });
        function doChange(changes, sourceFile, name) {
          changes.replaceNodeWithText(sourceFile, name, name.text + "()");
        }
        function getCallName(sourceFile, start) {
          var token = ts2.getTokenAtPosition(sourceFile, start);
          if (ts2.isPropertyAccessExpression(token.parent)) {
            var current = token.parent;
            while (ts2.isPropertyAccessExpression(current.parent)) {
              current = current.parent;
            }
            return current.name;
          }
          if (ts2.isIdentifier(token)) {
            return token;
          }
          return void 0;
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixAwaitInSyncFunction";
        var errorCodes = [
          ts2.Diagnostics.await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code,
          ts2.Diagnostics.A_for_await_of_statement_is_only_allowed_within_an_async_function_or_async_generator.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var nodes = getNodes(sourceFile, span.start);
            if (!nodes)
              return void 0;
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, nodes);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Add_async_modifier_to_containing_function, fixId, ts2.Diagnostics.Add_all_missing_async_modifiers)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var seen = ts2.createMap();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var nodes = getNodes(diag.file, diag.start);
              if (!nodes || !ts2.addToSeen(seen, ts2.getNodeId(nodes.insertBefore)))
                return;
              doChange(changes, context.sourceFile, nodes);
            });
          }
        });
        function getReturnType(expr) {
          if (expr.type) {
            return expr.type;
          }
          if (ts2.isVariableDeclaration(expr.parent) && expr.parent.type && ts2.isFunctionTypeNode(expr.parent.type)) {
            return expr.parent.type.type;
          }
        }
        function getNodes(sourceFile, start) {
          var token = ts2.getTokenAtPosition(sourceFile, start);
          var containingFunction = ts2.getContainingFunction(token);
          if (!containingFunction) {
            return;
          }
          var insertBefore;
          switch (containingFunction.kind) {
            case 161:
              insertBefore = containingFunction.name;
              break;
            case 244:
            case 201:
              insertBefore = ts2.findChildOfKind(containingFunction, 94, sourceFile);
              break;
            case 202:
              insertBefore = ts2.findChildOfKind(containingFunction, 20, sourceFile) || ts2.first(containingFunction.parameters);
              break;
            default:
              return;
          }
          return insertBefore && {
            insertBefore,
            returnType: getReturnType(containingFunction)
          };
        }
        function doChange(changes, sourceFile, _a) {
          var insertBefore = _a.insertBefore, returnType = _a.returnType;
          if (returnType) {
            var entityName = ts2.getEntityNameFromTypeNode(returnType);
            if (!entityName || entityName.kind !== 75 || entityName.text !== "Promise") {
              changes.replaceNode(sourceFile, returnType, ts2.createTypeReferenceNode("Promise", ts2.createNodeArray([returnType])));
            }
          }
          changes.insertModifierBefore(sourceFile, 126, insertBefore);
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "inferFromUsage";
        var errorCodes = [
          ts2.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code,
          ts2.Diagnostics.Variable_0_implicitly_has_an_1_type.code,
          ts2.Diagnostics.Parameter_0_implicitly_has_an_1_type.code,
          ts2.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code,
          ts2.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code,
          ts2.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code,
          ts2.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code,
          ts2.Diagnostics.Member_0_implicitly_has_an_1_type.code,
          ts2.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage.code,
          ts2.Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code,
          ts2.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code,
          ts2.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code,
          ts2.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage.code,
          ts2.Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage.code,
          ts2.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage.code,
          ts2.Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code,
          ts2.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, program = context.program, start = context.span.start, errorCode = context.errorCode, cancellationToken = context.cancellationToken, host = context.host, preferences = context.preferences;
            var token = ts2.getTokenAtPosition(sourceFile, start);
            var declaration;
            var changes = ts2.textChanges.ChangeTracker.with(context, function(changes2) {
              declaration = doChange(changes2, sourceFile, token, errorCode, program, cancellationToken, ts2.returnTrue, host, preferences);
            });
            var name = declaration && ts2.getNameOfDeclaration(declaration);
            return !name || changes.length === 0 ? void 0 : [codefix2.createCodeFixAction(fixId, changes, [getDiagnostic(errorCode, token), name.getText(sourceFile)], fixId, ts2.Diagnostics.Infer_all_types_from_usage)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var sourceFile = context.sourceFile, program = context.program, cancellationToken = context.cancellationToken, host = context.host, preferences = context.preferences;
            var markSeen = ts2.nodeSeenTracker();
            return codefix2.codeFixAll(context, errorCodes, function(changes, err) {
              doChange(changes, sourceFile, ts2.getTokenAtPosition(err.file, err.start), err.code, program, cancellationToken, markSeen, host, preferences);
            });
          }
        });
        function getDiagnostic(errorCode, token) {
          switch (errorCode) {
            case ts2.Diagnostics.Parameter_0_implicitly_has_an_1_type.code:
            case ts2.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts2.isSetAccessorDeclaration(ts2.getContainingFunction(token)) ? ts2.Diagnostics.Infer_type_of_0_from_usage : ts2.Diagnostics.Infer_parameter_types_from_usage;
            case ts2.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code:
            case ts2.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts2.Diagnostics.Infer_parameter_types_from_usage;
            case ts2.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code:
              return ts2.Diagnostics.Infer_this_type_of_0_from_usage;
            default:
              return ts2.Diagnostics.Infer_type_of_0_from_usage;
          }
        }
        function mapSuggestionDiagnostic(errorCode) {
          switch (errorCode) {
            case ts2.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage.code:
              return ts2.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code;
            case ts2.Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts2.Diagnostics.Variable_0_implicitly_has_an_1_type.code;
            case ts2.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts2.Diagnostics.Parameter_0_implicitly_has_an_1_type.code;
            case ts2.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts2.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code;
            case ts2.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage.code:
              return ts2.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code;
            case ts2.Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts2.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code;
            case ts2.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage.code:
              return ts2.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code;
            case ts2.Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
              return ts2.Diagnostics.Member_0_implicitly_has_an_1_type.code;
          }
          return errorCode;
        }
        function doChange(changes, sourceFile, token, errorCode, program, cancellationToken, markSeen, host, preferences) {
          if (!ts2.isParameterPropertyModifier(token.kind) && token.kind !== 75 && token.kind !== 25 && token.kind !== 104) {
            return void 0;
          }
          var parent = token.parent;
          var importAdder = codefix2.createImportAdder(sourceFile, program, preferences, host);
          errorCode = mapSuggestionDiagnostic(errorCode);
          switch (errorCode) {
            case ts2.Diagnostics.Member_0_implicitly_has_an_1_type.code:
            case ts2.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code:
              if (ts2.isVariableDeclaration(parent) && markSeen(parent) || ts2.isPropertyDeclaration(parent) || ts2.isPropertySignature(parent)) {
                annotateVariableDeclaration(changes, importAdder, sourceFile, parent, program, host, cancellationToken);
                importAdder.writeFixes(changes);
                return parent;
              }
              if (ts2.isPropertyAccessExpression(parent)) {
                var type = inferTypeForVariableFromUsage(parent.name, program, cancellationToken);
                var typeNode = ts2.getTypeNodeIfAccessible(type, parent, program, host);
                if (typeNode) {
                  var typeTag = ts2.createJSDocTypeTag(ts2.createJSDocTypeExpression(typeNode), "");
                  addJSDocTags(changes, sourceFile, ts2.cast(parent.parent.parent, ts2.isExpressionStatement), [typeTag]);
                }
                importAdder.writeFixes(changes);
                return parent;
              }
              return void 0;
            case ts2.Diagnostics.Variable_0_implicitly_has_an_1_type.code: {
              var symbol = program.getTypeChecker().getSymbolAtLocation(token);
              if (symbol && symbol.valueDeclaration && ts2.isVariableDeclaration(symbol.valueDeclaration) && markSeen(symbol.valueDeclaration)) {
                annotateVariableDeclaration(changes, importAdder, sourceFile, symbol.valueDeclaration, program, host, cancellationToken);
                importAdder.writeFixes(changes);
                return symbol.valueDeclaration;
              }
              return void 0;
            }
          }
          var containingFunction = ts2.getContainingFunction(token);
          if (containingFunction === void 0) {
            return void 0;
          }
          var declaration;
          switch (errorCode) {
            case ts2.Diagnostics.Parameter_0_implicitly_has_an_1_type.code:
              if (ts2.isSetAccessorDeclaration(containingFunction)) {
                annotateSetAccessor(changes, importAdder, sourceFile, containingFunction, program, host, cancellationToken);
                declaration = containingFunction;
                break;
              }
            case ts2.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code:
              if (markSeen(containingFunction)) {
                var param = ts2.cast(parent, ts2.isParameter);
                annotateParameters(changes, importAdder, sourceFile, param, containingFunction, program, host, cancellationToken);
                declaration = param;
              }
              break;
            case ts2.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code:
            case ts2.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code:
              if (ts2.isGetAccessorDeclaration(containingFunction) && ts2.isIdentifier(containingFunction.name)) {
                annotate(changes, importAdder, sourceFile, containingFunction, inferTypeForVariableFromUsage(containingFunction.name, program, cancellationToken), program, host);
                declaration = containingFunction;
              }
              break;
            case ts2.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code:
              if (ts2.isSetAccessorDeclaration(containingFunction)) {
                annotateSetAccessor(changes, importAdder, sourceFile, containingFunction, program, host, cancellationToken);
                declaration = containingFunction;
              }
              break;
            case ts2.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code:
              if (ts2.textChanges.isThisTypeAnnotatable(containingFunction) && markSeen(containingFunction)) {
                annotateThis(changes, sourceFile, containingFunction, program, host, cancellationToken);
                declaration = containingFunction;
              }
              break;
            default:
              return ts2.Debug.fail(String(errorCode));
          }
          importAdder.writeFixes(changes);
          return declaration;
        }
        function annotateVariableDeclaration(changes, importAdder, sourceFile, declaration, program, host, cancellationToken) {
          if (ts2.isIdentifier(declaration.name)) {
            annotate(changes, importAdder, sourceFile, declaration, inferTypeForVariableFromUsage(declaration.name, program, cancellationToken), program, host);
          }
        }
        function annotateParameters(changes, importAdder, sourceFile, parameterDeclaration, containingFunction, program, host, cancellationToken) {
          if (!ts2.isIdentifier(parameterDeclaration.name)) {
            return;
          }
          var parameterInferences = inferTypeForParametersFromUsage(containingFunction, sourceFile, program, cancellationToken);
          ts2.Debug.assert(containingFunction.parameters.length === parameterInferences.length, "Parameter count and inference count should match");
          if (ts2.isInJSFile(containingFunction)) {
            annotateJSDocParameters(changes, sourceFile, parameterInferences, program, host);
          } else {
            var needParens = ts2.isArrowFunction(containingFunction) && !ts2.findChildOfKind(containingFunction, 20, sourceFile);
            if (needParens)
              changes.insertNodeBefore(sourceFile, ts2.first(containingFunction.parameters), ts2.createToken(20));
            for (var _i = 0, parameterInferences_1 = parameterInferences; _i < parameterInferences_1.length; _i++) {
              var _a = parameterInferences_1[_i], declaration = _a.declaration, type = _a.type;
              if (declaration && !declaration.type && !declaration.initializer) {
                annotate(changes, importAdder, sourceFile, declaration, type, program, host);
              }
            }
            if (needParens)
              changes.insertNodeAfter(sourceFile, ts2.last(containingFunction.parameters), ts2.createToken(21));
          }
        }
        function annotateThis(changes, sourceFile, containingFunction, program, host, cancellationToken) {
          var references = getFunctionReferences(containingFunction, sourceFile, program, cancellationToken);
          if (!references || !references.length) {
            return;
          }
          var thisInference = inferTypeFromReferences(program, references, cancellationToken).thisParameter();
          var typeNode = ts2.getTypeNodeIfAccessible(thisInference, containingFunction, program, host);
          if (!typeNode) {
            return;
          }
          if (ts2.isInJSFile(containingFunction)) {
            annotateJSDocThis(changes, sourceFile, containingFunction, typeNode);
          } else {
            changes.tryInsertThisTypeAnnotation(sourceFile, containingFunction, typeNode);
          }
        }
        function annotateJSDocThis(changes, sourceFile, containingFunction, typeNode) {
          addJSDocTags(changes, sourceFile, containingFunction, [
            ts2.createJSDocThisTag(ts2.createJSDocTypeExpression(typeNode))
          ]);
        }
        function annotateSetAccessor(changes, importAdder, sourceFile, setAccessorDeclaration, program, host, cancellationToken) {
          var param = ts2.firstOrUndefined(setAccessorDeclaration.parameters);
          if (param && ts2.isIdentifier(setAccessorDeclaration.name) && ts2.isIdentifier(param.name)) {
            var type = inferTypeForVariableFromUsage(setAccessorDeclaration.name, program, cancellationToken);
            if (type === program.getTypeChecker().getAnyType()) {
              type = inferTypeForVariableFromUsage(param.name, program, cancellationToken);
            }
            if (ts2.isInJSFile(setAccessorDeclaration)) {
              annotateJSDocParameters(changes, sourceFile, [{ declaration: param, type }], program, host);
            } else {
              annotate(changes, importAdder, sourceFile, param, type, program, host);
            }
          }
        }
        function annotate(changes, importAdder, sourceFile, declaration, type, program, host) {
          var typeNode = ts2.getTypeNodeIfAccessible(type, declaration, program, host);
          if (typeNode) {
            if (ts2.isInJSFile(sourceFile) && declaration.kind !== 158) {
              var parent = ts2.isVariableDeclaration(declaration) ? ts2.tryCast(declaration.parent.parent, ts2.isVariableStatement) : declaration;
              if (!parent) {
                return;
              }
              var typeExpression = ts2.createJSDocTypeExpression(typeNode);
              var typeTag = ts2.isGetAccessorDeclaration(declaration) ? ts2.createJSDocReturnTag(typeExpression, "") : ts2.createJSDocTypeTag(typeExpression, "");
              addJSDocTags(changes, sourceFile, parent, [typeTag]);
            } else if (!tryReplaceImportTypeNodeWithAutoImport(typeNode, declaration, type, sourceFile, changes, importAdder, ts2.getEmitScriptTarget(program.getCompilerOptions()))) {
              changes.tryInsertTypeAnnotation(sourceFile, declaration, typeNode);
            }
          }
        }
        function tryReplaceImportTypeNodeWithAutoImport(typeNode, declaration, type, sourceFile, changes, importAdder, scriptTarget) {
          var importableReference = codefix2.tryGetAutoImportableReferenceFromImportTypeNode(typeNode, type, scriptTarget);
          if (importableReference && changes.tryInsertTypeAnnotation(sourceFile, declaration, importableReference.typeReference)) {
            ts2.forEach(importableReference.symbols, function(s) {
              return importAdder.addImportFromExportedSymbol(s, true);
            });
            return true;
          }
          return false;
        }
        function annotateJSDocParameters(changes, sourceFile, parameterInferences, program, host) {
          var signature = parameterInferences.length && parameterInferences[0].declaration.parent;
          if (!signature) {
            return;
          }
          var paramTags = ts2.mapDefined(parameterInferences, function(inference) {
            var param = inference.declaration;
            if (param.initializer || ts2.getJSDocType(param) || !ts2.isIdentifier(param.name))
              return;
            var typeNode = inference.type && ts2.getTypeNodeIfAccessible(inference.type, param, program, host);
            var name = ts2.getSynthesizedClone(param.name);
            ts2.setEmitFlags(name, 1536 | 2048);
            return typeNode && ts2.createJSDocParamTag(name, !!inference.isOptional, ts2.createJSDocTypeExpression(typeNode), "");
          });
          addJSDocTags(changes, sourceFile, signature, paramTags);
        }
        function addJSDocTags(changes, sourceFile, parent, newTags) {
          var comments = ts2.mapDefined(parent.jsDoc, function(j) {
            return j.comment;
          });
          var oldTags = ts2.flatMapToMutable(parent.jsDoc, function(j) {
            return j.tags;
          });
          var unmergedNewTags = newTags.filter(function(newTag) {
            return !oldTags || !oldTags.some(function(tag2, i) {
              var merged = tryMergeJsdocTags(tag2, newTag);
              if (merged)
                oldTags[i] = merged;
              return !!merged;
            });
          });
          var tag = ts2.createJSDocComment(comments.join("\n"), ts2.createNodeArray(__spreadArrays(oldTags || ts2.emptyArray, unmergedNewTags)));
          var jsDocNode = parent.kind === 202 ? getJsDocNodeForArrowFunction(parent) : parent;
          jsDocNode.jsDoc = parent.jsDoc;
          jsDocNode.jsDocCache = parent.jsDocCache;
          changes.insertJsdocCommentBefore(sourceFile, jsDocNode, tag);
        }
        codefix2.addJSDocTags = addJSDocTags;
        function getJsDocNodeForArrowFunction(signature) {
          if (signature.parent.kind === 159) {
            return signature.parent;
          }
          return signature.parent.parent;
        }
        function tryMergeJsdocTags(oldTag, newTag) {
          if (oldTag.kind !== newTag.kind) {
            return void 0;
          }
          switch (oldTag.kind) {
            case 317: {
              var oldParam = oldTag;
              var newParam = newTag;
              return ts2.isIdentifier(oldParam.name) && ts2.isIdentifier(newParam.name) && oldParam.name.escapedText === newParam.name.escapedText ? ts2.createJSDocParamTag(newParam.name, newParam.isBracketed, newParam.typeExpression, oldParam.comment) : void 0;
            }
            case 318:
              return ts2.createJSDocReturnTag(newTag.typeExpression, oldTag.comment);
          }
        }
        function getReferences(token, program, cancellationToken) {
          return ts2.mapDefined(ts2.FindAllReferences.getReferenceEntriesForNode(-1, token, program, program.getSourceFiles(), cancellationToken), function(entry) {
            return entry.kind !== 0 ? ts2.tryCast(entry.node, ts2.isIdentifier) : void 0;
          });
        }
        function inferTypeForVariableFromUsage(token, program, cancellationToken) {
          var references = getReferences(token, program, cancellationToken);
          return inferTypeFromReferences(program, references, cancellationToken).single();
        }
        function inferTypeForParametersFromUsage(func, sourceFile, program, cancellationToken) {
          var references = getFunctionReferences(func, sourceFile, program, cancellationToken);
          return references && inferTypeFromReferences(program, references, cancellationToken).parameters(func) || func.parameters.map(function(p) {
            return {
              declaration: p,
              type: ts2.isIdentifier(p.name) ? inferTypeForVariableFromUsage(p.name, program, cancellationToken) : program.getTypeChecker().getAnyType()
            };
          });
        }
        function getFunctionReferences(containingFunction, sourceFile, program, cancellationToken) {
          var searchToken;
          switch (containingFunction.kind) {
            case 162:
              searchToken = ts2.findChildOfKind(containingFunction, 129, sourceFile);
              break;
            case 202:
            case 201:
              var parent = containingFunction.parent;
              searchToken = ts2.isVariableDeclaration(parent) && ts2.isIdentifier(parent.name) ? parent.name : containingFunction.name;
              break;
            case 244:
            case 161:
              searchToken = containingFunction.name;
              break;
          }
          if (!searchToken) {
            return void 0;
          }
          return getReferences(searchToken, program, cancellationToken);
        }
        function inferTypeFromReferences(program, references, cancellationToken) {
          var checker = program.getTypeChecker();
          var builtinConstructors = {
            string: function() {
              return checker.getStringType();
            },
            number: function() {
              return checker.getNumberType();
            },
            Array: function(t) {
              return checker.createArrayType(t);
            },
            Promise: function(t) {
              return checker.createPromiseType(t);
            }
          };
          var builtins = [
            checker.getStringType(),
            checker.getNumberType(),
            checker.createArrayType(checker.getAnyType()),
            checker.createPromiseType(checker.getAnyType())
          ];
          return {
            single,
            parameters,
            thisParameter
          };
          function createEmptyUsage() {
            return {
              isNumber: void 0,
              isString: void 0,
              isNumberOrString: void 0,
              candidateTypes: void 0,
              properties: void 0,
              calls: void 0,
              constructs: void 0,
              numberIndex: void 0,
              stringIndex: void 0,
              candidateThisTypes: void 0,
              inferredTypes: void 0
            };
          }
          function combineUsages(usages) {
            var combinedProperties = ts2.createUnderscoreEscapedMap();
            for (var _i = 0, usages_1 = usages; _i < usages_1.length; _i++) {
              var u = usages_1[_i];
              if (u.properties) {
                u.properties.forEach(function(p, name) {
                  if (!combinedProperties.has(name)) {
                    combinedProperties.set(name, []);
                  }
                  combinedProperties.get(name).push(p);
                });
              }
            }
            var properties = ts2.createUnderscoreEscapedMap();
            combinedProperties.forEach(function(ps, name) {
              properties.set(name, combineUsages(ps));
            });
            return {
              isNumber: usages.some(function(u2) {
                return u2.isNumber;
              }),
              isString: usages.some(function(u2) {
                return u2.isString;
              }),
              isNumberOrString: usages.some(function(u2) {
                return u2.isNumberOrString;
              }),
              candidateTypes: ts2.flatMap(usages, function(u2) {
                return u2.candidateTypes;
              }),
              properties,
              calls: ts2.flatMap(usages, function(u2) {
                return u2.calls;
              }),
              constructs: ts2.flatMap(usages, function(u2) {
                return u2.constructs;
              }),
              numberIndex: ts2.forEach(usages, function(u2) {
                return u2.numberIndex;
              }),
              stringIndex: ts2.forEach(usages, function(u2) {
                return u2.stringIndex;
              }),
              candidateThisTypes: ts2.flatMap(usages, function(u2) {
                return u2.candidateThisTypes;
              }),
              inferredTypes: void 0
            };
          }
          function single() {
            return combineTypes(inferTypesFromReferencesSingle(references));
          }
          function parameters(declaration) {
            if (references.length === 0 || !declaration.parameters) {
              return void 0;
            }
            var usage = createEmptyUsage();
            for (var _i = 0, references_2 = references; _i < references_2.length; _i++) {
              var reference = references_2[_i];
              cancellationToken.throwIfCancellationRequested();
              calculateUsageOfNode(reference, usage);
            }
            var calls = __spreadArrays(usage.constructs || [], usage.calls || []);
            return declaration.parameters.map(function(parameter, parameterIndex) {
              var types = [];
              var isRest = ts2.isRestParameter(parameter);
              var isOptional = false;
              for (var _i2 = 0, calls_1 = calls; _i2 < calls_1.length; _i2++) {
                var call = calls_1[_i2];
                if (call.argumentTypes.length <= parameterIndex) {
                  isOptional = ts2.isInJSFile(declaration);
                  types.push(checker.getUndefinedType());
                } else if (isRest) {
                  for (var i = parameterIndex; i < call.argumentTypes.length; i++) {
                    types.push(checker.getBaseTypeOfLiteralType(call.argumentTypes[i]));
                  }
                } else {
                  types.push(checker.getBaseTypeOfLiteralType(call.argumentTypes[parameterIndex]));
                }
              }
              if (ts2.isIdentifier(parameter.name)) {
                var inferred = inferTypesFromReferencesSingle(getReferences(parameter.name, program, cancellationToken));
                types.push.apply(types, isRest ? ts2.mapDefined(inferred, checker.getElementTypeOfArrayType) : inferred);
              }
              var type = combineTypes(types);
              return {
                type: isRest ? checker.createArrayType(type) : type,
                isOptional: isOptional && !isRest,
                declaration: parameter
              };
            });
          }
          function thisParameter() {
            var usage = createEmptyUsage();
            for (var _i = 0, references_3 = references; _i < references_3.length; _i++) {
              var reference = references_3[_i];
              cancellationToken.throwIfCancellationRequested();
              calculateUsageOfNode(reference, usage);
            }
            return combineTypes(usage.candidateThisTypes || ts2.emptyArray);
          }
          function inferTypesFromReferencesSingle(references2) {
            var usage = createEmptyUsage();
            for (var _i = 0, references_4 = references2; _i < references_4.length; _i++) {
              var reference = references_4[_i];
              cancellationToken.throwIfCancellationRequested();
              calculateUsageOfNode(reference, usage);
            }
            return inferTypes(usage);
          }
          function calculateUsageOfNode(node, usage) {
            while (ts2.isRightSideOfQualifiedNameOrPropertyAccess(node)) {
              node = node.parent;
            }
            switch (node.parent.kind) {
              case 226:
                inferTypeFromExpressionStatement(node, usage);
                break;
              case 208:
                usage.isNumber = true;
                break;
              case 207:
                inferTypeFromPrefixUnaryExpression(node.parent, usage);
                break;
              case 209:
                inferTypeFromBinaryExpression(node, node.parent, usage);
                break;
              case 277:
              case 278:
                inferTypeFromSwitchStatementLabel(node.parent, usage);
                break;
              case 196:
              case 197:
                if (node.parent.expression === node) {
                  inferTypeFromCallExpression(node.parent, usage);
                } else {
                  inferTypeFromContextualType(node, usage);
                }
                break;
              case 194:
                inferTypeFromPropertyAccessExpression(node.parent, usage);
                break;
              case 195:
                inferTypeFromPropertyElementExpression(node.parent, node, usage);
                break;
              case 281:
              case 282:
                inferTypeFromPropertyAssignment(node.parent, usage);
                break;
              case 159:
                inferTypeFromPropertyDeclaration(node.parent, usage);
                break;
              case 242: {
                var _a = node.parent, name = _a.name, initializer = _a.initializer;
                if (node === name) {
                  if (initializer) {
                    addCandidateType(usage, checker.getTypeAtLocation(initializer));
                  }
                  break;
                }
              }
              default:
                return inferTypeFromContextualType(node, usage);
            }
          }
          function inferTypeFromContextualType(node, usage) {
            if (ts2.isExpressionNode(node)) {
              addCandidateType(usage, checker.getContextualType(node));
            }
          }
          function inferTypeFromExpressionStatement(node, usage) {
            addCandidateType(usage, ts2.isCallExpression(node) ? checker.getVoidType() : checker.getAnyType());
          }
          function inferTypeFromPrefixUnaryExpression(node, usage) {
            switch (node.operator) {
              case 45:
              case 46:
              case 40:
              case 54:
                usage.isNumber = true;
                break;
              case 39:
                usage.isNumberOrString = true;
                break;
            }
          }
          function inferTypeFromBinaryExpression(node, parent, usage) {
            switch (parent.operatorToken.kind) {
              case 42:
              case 41:
              case 43:
              case 44:
              case 47:
              case 48:
              case 49:
              case 50:
              case 51:
              case 52:
              case 64:
              case 66:
              case 65:
              case 67:
              case 68:
              case 72:
              case 73:
              case 74:
              case 69:
              case 71:
              case 70:
              case 40:
              case 29:
              case 32:
              case 31:
              case 33:
                var operandType = checker.getTypeAtLocation(parent.left === node ? parent.right : parent.left);
                if (operandType.flags & 1056) {
                  addCandidateType(usage, operandType);
                } else {
                  usage.isNumber = true;
                }
                break;
              case 63:
              case 39:
                var otherOperandType = checker.getTypeAtLocation(parent.left === node ? parent.right : parent.left);
                if (otherOperandType.flags & 1056) {
                  addCandidateType(usage, otherOperandType);
                } else if (otherOperandType.flags & 296) {
                  usage.isNumber = true;
                } else if (otherOperandType.flags & 132) {
                  usage.isString = true;
                } else if (otherOperandType.flags & 1) {
                } else {
                  usage.isNumberOrString = true;
                }
                break;
              case 62:
              case 34:
              case 36:
              case 37:
              case 35:
                addCandidateType(usage, checker.getTypeAtLocation(parent.left === node ? parent.right : parent.left));
                break;
              case 97:
                if (node === parent.left) {
                  usage.isString = true;
                }
                break;
              case 56:
              case 60:
                if (node === parent.left && (node.parent.parent.kind === 242 || ts2.isAssignmentExpression(node.parent.parent, true))) {
                  addCandidateType(usage, checker.getTypeAtLocation(parent.right));
                }
                break;
              case 55:
              case 27:
              case 98:
                break;
            }
          }
          function inferTypeFromSwitchStatementLabel(parent, usage) {
            addCandidateType(usage, checker.getTypeAtLocation(parent.parent.parent.expression));
          }
          function inferTypeFromCallExpression(parent, usage) {
            var call = {
              argumentTypes: [],
              return_: createEmptyUsage()
            };
            if (parent.arguments) {
              for (var _i = 0, _a = parent.arguments; _i < _a.length; _i++) {
                var argument = _a[_i];
                call.argumentTypes.push(checker.getTypeAtLocation(argument));
              }
            }
            calculateUsageOfNode(parent, call.return_);
            if (parent.kind === 196) {
              (usage.calls || (usage.calls = [])).push(call);
            } else {
              (usage.constructs || (usage.constructs = [])).push(call);
            }
          }
          function inferTypeFromPropertyAccessExpression(parent, usage) {
            var name = ts2.escapeLeadingUnderscores(parent.name.text);
            if (!usage.properties) {
              usage.properties = ts2.createUnderscoreEscapedMap();
            }
            var propertyUsage = usage.properties.get(name) || createEmptyUsage();
            calculateUsageOfNode(parent, propertyUsage);
            usage.properties.set(name, propertyUsage);
          }
          function inferTypeFromPropertyElementExpression(parent, node, usage) {
            if (node === parent.argumentExpression) {
              usage.isNumberOrString = true;
              return;
            } else {
              var indexType = checker.getTypeAtLocation(parent.argumentExpression);
              var indexUsage = createEmptyUsage();
              calculateUsageOfNode(parent, indexUsage);
              if (indexType.flags & 296) {
                usage.numberIndex = indexUsage;
              } else {
                usage.stringIndex = indexUsage;
              }
            }
          }
          function inferTypeFromPropertyAssignment(assignment, usage) {
            var nodeWithRealType = ts2.isVariableDeclaration(assignment.parent.parent) ? assignment.parent.parent : assignment.parent;
            addCandidateThisType(usage, checker.getTypeAtLocation(nodeWithRealType));
          }
          function inferTypeFromPropertyDeclaration(declaration, usage) {
            addCandidateThisType(usage, checker.getTypeAtLocation(declaration.parent));
          }
          function removeLowPriorityInferences(inferences, priorities) {
            var toRemove = [];
            for (var _i = 0, inferences_1 = inferences; _i < inferences_1.length; _i++) {
              var i = inferences_1[_i];
              for (var _a = 0, priorities_1 = priorities; _a < priorities_1.length; _a++) {
                var _b = priorities_1[_a], high = _b.high, low = _b.low;
                if (high(i)) {
                  ts2.Debug.assert(!low(i), "Priority can't have both low and high");
                  toRemove.push(low);
                }
              }
            }
            return inferences.filter(function(i2) {
              return toRemove.every(function(f) {
                return !f(i2);
              });
            });
          }
          function combineFromUsage(usage) {
            return combineTypes(inferTypes(usage));
          }
          function combineTypes(inferences) {
            if (!inferences.length)
              return checker.getAnyType();
            var stringNumber = checker.getUnionType([checker.getStringType(), checker.getNumberType()]);
            var priorities = [
              {
                high: function(t) {
                  return t === checker.getStringType() || t === checker.getNumberType();
                },
                low: function(t) {
                  return t === stringNumber;
                }
              },
              {
                high: function(t) {
                  return !(t.flags & (1 | 16384));
                },
                low: function(t) {
                  return !!(t.flags & (1 | 16384));
                }
              },
              {
                high: function(t) {
                  return !(t.flags & (98304 | 1 | 16384)) && !(ts2.getObjectFlags(t) & 16);
                },
                low: function(t) {
                  return !!(ts2.getObjectFlags(t) & 16);
                }
              }
            ];
            var good = removeLowPriorityInferences(inferences, priorities);
            var anons = good.filter(function(i) {
              return ts2.getObjectFlags(i) & 16;
            });
            if (anons.length) {
              good = good.filter(function(i) {
                return !(ts2.getObjectFlags(i) & 16);
              });
              good.push(combineAnonymousTypes(anons));
            }
            return checker.getWidenedType(checker.getUnionType(good.map(checker.getBaseTypeOfLiteralType), 2));
          }
          function combineAnonymousTypes(anons) {
            if (anons.length === 1) {
              return anons[0];
            }
            var calls = [];
            var constructs = [];
            var stringIndices = [];
            var numberIndices = [];
            var stringIndexReadonly = false;
            var numberIndexReadonly = false;
            var props = ts2.createMultiMap();
            for (var _i = 0, anons_1 = anons; _i < anons_1.length; _i++) {
              var anon = anons_1[_i];
              for (var _a = 0, _b = checker.getPropertiesOfType(anon); _a < _b.length; _a++) {
                var p = _b[_a];
                props.add(p.name, checker.getTypeOfSymbolAtLocation(p, p.valueDeclaration));
              }
              calls.push.apply(calls, checker.getSignaturesOfType(anon, 0));
              constructs.push.apply(constructs, checker.getSignaturesOfType(anon, 1));
              if (anon.stringIndexInfo) {
                stringIndices.push(anon.stringIndexInfo.type);
                stringIndexReadonly = stringIndexReadonly || anon.stringIndexInfo.isReadonly;
              }
              if (anon.numberIndexInfo) {
                numberIndices.push(anon.numberIndexInfo.type);
                numberIndexReadonly = numberIndexReadonly || anon.numberIndexInfo.isReadonly;
              }
            }
            var members = ts2.mapEntries(props, function(name, types) {
              var isOptional = types.length < anons.length ? 16777216 : 0;
              var s = checker.createSymbol(4 | isOptional, name);
              s.type = checker.getUnionType(types);
              return [name, s];
            });
            return checker.createAnonymousType(anons[0].symbol, members, calls, constructs, stringIndices.length ? checker.createIndexInfo(checker.getUnionType(stringIndices), stringIndexReadonly) : void 0, numberIndices.length ? checker.createIndexInfo(checker.getUnionType(numberIndices), numberIndexReadonly) : void 0);
          }
          function inferTypes(usage) {
            var _a, _b, _c;
            var types = [];
            if (usage.isNumber) {
              types.push(checker.getNumberType());
            }
            if (usage.isString) {
              types.push(checker.getStringType());
            }
            if (usage.isNumberOrString) {
              types.push(checker.getUnionType([checker.getStringType(), checker.getNumberType()]));
            }
            if (usage.numberIndex) {
              types.push(checker.createArrayType(combineFromUsage(usage.numberIndex)));
            }
            if (((_a = usage.properties) === null || _a === void 0 ? void 0 : _a.size) || ((_b = usage.calls) === null || _b === void 0 ? void 0 : _b.length) || ((_c = usage.constructs) === null || _c === void 0 ? void 0 : _c.length) || usage.stringIndex) {
              types.push(inferStructuralType(usage));
            }
            types.push.apply(types, (usage.candidateTypes || []).map(function(t) {
              return checker.getBaseTypeOfLiteralType(t);
            }));
            types.push.apply(types, inferNamedTypesFromProperties(usage));
            return types;
          }
          function inferStructuralType(usage) {
            var members = ts2.createUnderscoreEscapedMap();
            if (usage.properties) {
              usage.properties.forEach(function(u, name) {
                var symbol = checker.createSymbol(4, name);
                symbol.type = combineFromUsage(u);
                members.set(name, symbol);
              });
            }
            var callSignatures = usage.calls ? [getSignatureFromCalls(usage.calls)] : [];
            var constructSignatures = usage.constructs ? [getSignatureFromCalls(usage.constructs)] : [];
            var stringIndexInfo = usage.stringIndex && checker.createIndexInfo(combineFromUsage(usage.stringIndex), false);
            return checker.createAnonymousType(void 0, members, callSignatures, constructSignatures, stringIndexInfo, void 0);
          }
          function inferNamedTypesFromProperties(usage) {
            if (!usage.properties || !usage.properties.size)
              return [];
            var types = builtins.filter(function(t) {
              return allPropertiesAreAssignableToUsage(t, usage);
            });
            if (0 < types.length && types.length < 3) {
              return types.map(function(t) {
                return inferInstantiationFromUsage(t, usage);
              });
            }
            return [];
          }
          function allPropertiesAreAssignableToUsage(type, usage) {
            if (!usage.properties)
              return false;
            return !ts2.forEachEntry(usage.properties, function(propUsage, name) {
              var source = checker.getTypeOfPropertyOfType(type, name);
              if (!source) {
                return true;
              }
              if (propUsage.calls) {
                var sigs = checker.getSignaturesOfType(source, 0);
                return !sigs.length || !checker.isTypeAssignableTo(source, getFunctionFromCalls(propUsage.calls));
              } else {
                return !checker.isTypeAssignableTo(source, combineFromUsage(propUsage));
              }
            });
          }
          function inferInstantiationFromUsage(type, usage) {
            if (!(ts2.getObjectFlags(type) & 4) || !usage.properties) {
              return type;
            }
            var generic = type.target;
            var singleTypeParameter = ts2.singleOrUndefined(generic.typeParameters);
            if (!singleTypeParameter)
              return type;
            var types = [];
            usage.properties.forEach(function(propUsage, name) {
              var genericPropertyType = checker.getTypeOfPropertyOfType(generic, name);
              ts2.Debug.assert(!!genericPropertyType, "generic should have all the properties of its reference.");
              types.push.apply(types, inferTypeParameters(genericPropertyType, combineFromUsage(propUsage), singleTypeParameter));
            });
            return builtinConstructors[type.symbol.escapedName](combineTypes(types));
          }
          function inferTypeParameters(genericType, usageType, typeParameter) {
            if (genericType === typeParameter) {
              return [usageType];
            } else if (genericType.flags & 3145728) {
              return ts2.flatMap(genericType.types, function(t) {
                return inferTypeParameters(t, usageType, typeParameter);
              });
            } else if (ts2.getObjectFlags(genericType) & 4 && ts2.getObjectFlags(usageType) & 4) {
              var genericArgs = checker.getTypeArguments(genericType);
              var usageArgs = checker.getTypeArguments(usageType);
              var types = [];
              if (genericArgs && usageArgs) {
                for (var i = 0; i < genericArgs.length; i++) {
                  if (usageArgs[i]) {
                    types.push.apply(types, inferTypeParameters(genericArgs[i], usageArgs[i], typeParameter));
                  }
                }
              }
              return types;
            }
            var genericSigs = checker.getSignaturesOfType(genericType, 0);
            var usageSigs = checker.getSignaturesOfType(usageType, 0);
            if (genericSigs.length === 1 && usageSigs.length === 1) {
              return inferFromSignatures(genericSigs[0], usageSigs[0], typeParameter);
            }
            return [];
          }
          function inferFromSignatures(genericSig, usageSig, typeParameter) {
            var types = [];
            for (var i = 0; i < genericSig.parameters.length; i++) {
              var genericParam = genericSig.parameters[i];
              var usageParam = usageSig.parameters[i];
              var isRest = genericSig.declaration && ts2.isRestParameter(genericSig.declaration.parameters[i]);
              if (!usageParam) {
                break;
              }
              var genericParamType = checker.getTypeOfSymbolAtLocation(genericParam, genericParam.valueDeclaration);
              var elementType = isRest && checker.getElementTypeOfArrayType(genericParamType);
              if (elementType) {
                genericParamType = elementType;
              }
              var targetType = usageParam.type || checker.getTypeOfSymbolAtLocation(usageParam, usageParam.valueDeclaration);
              types.push.apply(types, inferTypeParameters(genericParamType, targetType, typeParameter));
            }
            var genericReturn = checker.getReturnTypeOfSignature(genericSig);
            var usageReturn = checker.getReturnTypeOfSignature(usageSig);
            types.push.apply(types, inferTypeParameters(genericReturn, usageReturn, typeParameter));
            return types;
          }
          function getFunctionFromCalls(calls) {
            return checker.createAnonymousType(void 0, ts2.createSymbolTable(), [getSignatureFromCalls(calls)], ts2.emptyArray, void 0, void 0);
          }
          function getSignatureFromCalls(calls) {
            var parameters2 = [];
            var length = Math.max.apply(Math, calls.map(function(c) {
              return c.argumentTypes.length;
            }));
            var _loop_14 = function(i2) {
              var symbol = checker.createSymbol(1, ts2.escapeLeadingUnderscores("arg" + i2));
              symbol.type = combineTypes(calls.map(function(call) {
                return call.argumentTypes[i2] || checker.getUndefinedType();
              }));
              if (calls.some(function(call) {
                return call.argumentTypes[i2] === void 0;
              })) {
                symbol.flags |= 16777216;
              }
              parameters2.push(symbol);
            };
            for (var i = 0; i < length; i++) {
              _loop_14(i);
            }
            var returnType = combineFromUsage(combineUsages(calls.map(function(call) {
              return call.return_;
            })));
            return checker.createSignature(void 0, void 0, void 0, parameters2, returnType, void 0, length, 0);
          }
          function addCandidateType(usage, type) {
            if (type && !(type.flags & 1) && !(type.flags & 131072)) {
              (usage.candidateTypes || (usage.candidateTypes = [])).push(type);
            }
          }
          function addCandidateThisType(usage, type) {
            if (type && !(type.flags & 1) && !(type.flags & 131072)) {
              (usage.candidateThisTypes || (usage.candidateThisTypes = [])).push(type);
            }
          }
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixName = "disableJsDiagnostics";
        var fixId = "disableJsDiagnostics";
        var errorCodes = ts2.mapDefined(Object.keys(ts2.Diagnostics), function(key) {
          var diag = ts2.Diagnostics[key];
          return diag.category === ts2.DiagnosticCategory.Error ? diag.code : void 0;
        });
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, program = context.program, span = context.span, host = context.host, formatContext = context.formatContext;
            if (!ts2.isInJSFile(sourceFile) || !ts2.isCheckJsEnabledForFile(sourceFile, program.getCompilerOptions())) {
              return void 0;
            }
            var newLineCharacter = sourceFile.checkJsDirective ? "" : ts2.getNewLineOrDefaultFromHost(host, formatContext.options);
            var fixes = [
              codefix2.createCodeFixActionWithoutFixAll(fixName, [codefix2.createFileTextChanges(sourceFile.fileName, [
                ts2.createTextChange(sourceFile.checkJsDirective ? ts2.createTextSpanFromBounds(sourceFile.checkJsDirective.pos, sourceFile.checkJsDirective.end) : ts2.createTextSpan(0, 0), "// @ts-nocheck" + newLineCharacter)
              ])], ts2.Diagnostics.Disable_checking_for_this_file)
            ];
            if (ts2.textChanges.isValidLocationToAddComment(sourceFile, span.start)) {
              fixes.unshift(codefix2.createCodeFixAction(fixName, ts2.textChanges.ChangeTracker.with(context, function(t) {
                return makeChange(t, sourceFile, span.start);
              }), ts2.Diagnostics.Ignore_this_error_message, fixId, ts2.Diagnostics.Add_ts_ignore_to_all_error_messages));
            }
            return fixes;
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            var seenLines = ts2.createMap();
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              if (ts2.textChanges.isValidLocationToAddComment(diag.file, diag.start)) {
                makeChange(changes, diag.file, diag.start, seenLines);
              }
            });
          }
        });
        function makeChange(changes, sourceFile, position, seenLines) {
          var lineNumber = ts2.getLineAndCharacterOfPosition(sourceFile, position).line;
          if (!seenLines || ts2.addToSeen(seenLines, lineNumber)) {
            changes.insertCommentBeforeLine(sourceFile, lineNumber, position, " @ts-ignore");
          }
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        function createMissingMemberNodes(classDeclaration, possiblyMissingSymbols, context, preferences, importAdder, addClassElement) {
          var classMembers = classDeclaration.symbol.members;
          for (var _i = 0, possiblyMissingSymbols_1 = possiblyMissingSymbols; _i < possiblyMissingSymbols_1.length; _i++) {
            var symbol = possiblyMissingSymbols_1[_i];
            if (!classMembers.has(symbol.escapedName)) {
              addNewNodeForMemberSymbol(symbol, classDeclaration, context, preferences, importAdder, addClassElement);
            }
          }
        }
        codefix2.createMissingMemberNodes = createMissingMemberNodes;
        function getNoopSymbolTrackerWithResolver(context) {
          return {
            trackSymbol: ts2.noop,
            moduleResolverHost: ts2.getModuleSpecifierResolverHost(context.program, context.host)
          };
        }
        codefix2.getNoopSymbolTrackerWithResolver = getNoopSymbolTrackerWithResolver;
        function addNewNodeForMemberSymbol(symbol, enclosingDeclaration, context, preferences, importAdder, addClassElement) {
          var declarations = symbol.getDeclarations();
          if (!(declarations && declarations.length)) {
            return void 0;
          }
          var checker = context.program.getTypeChecker();
          var scriptTarget = ts2.getEmitScriptTarget(context.program.getCompilerOptions());
          var declaration = declarations[0];
          var name = ts2.getSynthesizedDeepClone(ts2.getNameOfDeclaration(declaration), false);
          var visibilityModifier = createVisibilityModifier(ts2.getModifierFlags(declaration));
          var modifiers = visibilityModifier ? ts2.createNodeArray([visibilityModifier]) : void 0;
          var type = checker.getWidenedType(checker.getTypeOfSymbolAtLocation(symbol, enclosingDeclaration));
          var optional = !!(symbol.flags & 16777216);
          var ambient = !!(enclosingDeclaration.flags & 8388608);
          switch (declaration.kind) {
            case 158:
            case 159:
              var flags = preferences.quotePreference === "single" ? 268435456 : void 0;
              var typeNode = checker.typeToTypeNode(type, enclosingDeclaration, flags, getNoopSymbolTrackerWithResolver(context));
              if (importAdder) {
                var importableReference = tryGetAutoImportableReferenceFromImportTypeNode(typeNode, type, scriptTarget);
                if (importableReference) {
                  typeNode = importableReference.typeReference;
                  importSymbols(importAdder, importableReference.symbols);
                }
              }
              addClassElement(ts2.createProperty(void 0, modifiers, name, optional ? ts2.createToken(57) : void 0, typeNode, void 0));
              break;
            case 163:
            case 164: {
              var typeNode_1 = checker.typeToTypeNode(type, enclosingDeclaration, void 0, getNoopSymbolTrackerWithResolver(context));
              var allAccessors = ts2.getAllAccessorDeclarations(declarations, declaration);
              var orderedAccessors = allAccessors.secondAccessor ? [allAccessors.firstAccessor, allAccessors.secondAccessor] : [allAccessors.firstAccessor];
              if (importAdder) {
                var importableReference = tryGetAutoImportableReferenceFromImportTypeNode(typeNode_1, type, scriptTarget);
                if (importableReference) {
                  typeNode_1 = importableReference.typeReference;
                  importSymbols(importAdder, importableReference.symbols);
                }
              }
              for (var _i = 0, orderedAccessors_1 = orderedAccessors; _i < orderedAccessors_1.length; _i++) {
                var accessor = orderedAccessors_1[_i];
                if (ts2.isGetAccessorDeclaration(accessor)) {
                  addClassElement(ts2.createGetAccessor(void 0, modifiers, name, ts2.emptyArray, typeNode_1, ambient ? void 0 : createStubbedMethodBody(preferences)));
                } else {
                  ts2.Debug.assertNode(accessor, ts2.isSetAccessorDeclaration, "The counterpart to a getter should be a setter");
                  var parameter = ts2.getSetAccessorValueParameter(accessor);
                  var parameterName = parameter && ts2.isIdentifier(parameter.name) ? ts2.idText(parameter.name) : void 0;
                  addClassElement(ts2.createSetAccessor(void 0, modifiers, name, createDummyParameters(1, [parameterName], [typeNode_1], 1, false), ambient ? void 0 : createStubbedMethodBody(preferences)));
                }
              }
              break;
            }
            case 160:
            case 161:
              var signatures = checker.getSignaturesOfType(type, 0);
              if (!ts2.some(signatures)) {
                break;
              }
              if (declarations.length === 1) {
                ts2.Debug.assert(signatures.length === 1, "One declaration implies one signature");
                var signature = signatures[0];
                outputMethod(signature, modifiers, name, ambient ? void 0 : createStubbedMethodBody(preferences));
                break;
              }
              for (var _a = 0, signatures_1 = signatures; _a < signatures_1.length; _a++) {
                var signature = signatures_1[_a];
                outputMethod(signature, ts2.getSynthesizedDeepClones(modifiers, false), ts2.getSynthesizedDeepClone(name, false));
              }
              if (!ambient) {
                if (declarations.length > signatures.length) {
                  var signature = checker.getSignatureFromDeclaration(declarations[declarations.length - 1]);
                  outputMethod(signature, modifiers, name, createStubbedMethodBody(preferences));
                } else {
                  ts2.Debug.assert(declarations.length === signatures.length, "Declarations and signatures should match count");
                  addClassElement(createMethodImplementingSignatures(signatures, name, optional, modifiers, preferences));
                }
              }
              break;
          }
          function outputMethod(signature2, modifiers2, name2, body) {
            var method = signatureToMethodDeclaration(context, signature2, enclosingDeclaration, modifiers2, name2, optional, body, importAdder);
            if (method)
              addClassElement(method);
          }
        }
        function signatureToMethodDeclaration(context, signature, enclosingDeclaration, modifiers, name, optional, body, importAdder) {
          var program = context.program;
          var checker = program.getTypeChecker();
          var scriptTarget = ts2.getEmitScriptTarget(program.getCompilerOptions());
          var signatureDeclaration = checker.signatureToSignatureDeclaration(signature, 161, enclosingDeclaration, 1 | 256, getNoopSymbolTrackerWithResolver(context));
          if (!signatureDeclaration) {
            return void 0;
          }
          if (importAdder) {
            if (signatureDeclaration.typeParameters) {
              ts2.forEach(signatureDeclaration.typeParameters, function(typeParameterDecl, i) {
                var typeParameter = signature.typeParameters[i];
                if (typeParameterDecl.constraint) {
                  var importableReference2 = tryGetAutoImportableReferenceFromImportTypeNode(typeParameterDecl.constraint, typeParameter.constraint, scriptTarget);
                  if (importableReference2) {
                    typeParameterDecl.constraint = importableReference2.typeReference;
                    importSymbols(importAdder, importableReference2.symbols);
                  }
                }
                if (typeParameterDecl.default) {
                  var importableReference2 = tryGetAutoImportableReferenceFromImportTypeNode(typeParameterDecl.default, typeParameter.default, scriptTarget);
                  if (importableReference2) {
                    typeParameterDecl.default = importableReference2.typeReference;
                    importSymbols(importAdder, importableReference2.symbols);
                  }
                }
              });
            }
            ts2.forEach(signatureDeclaration.parameters, function(parameterDecl, i) {
              var parameter = signature.parameters[i];
              var importableReference2 = tryGetAutoImportableReferenceFromImportTypeNode(parameterDecl.type, checker.getTypeAtLocation(parameter.valueDeclaration), scriptTarget);
              if (importableReference2) {
                parameterDecl.type = importableReference2.typeReference;
                importSymbols(importAdder, importableReference2.symbols);
              }
            });
            if (signatureDeclaration.type) {
              var importableReference = tryGetAutoImportableReferenceFromImportTypeNode(signatureDeclaration.type, signature.resolvedReturnType, scriptTarget);
              if (importableReference) {
                signatureDeclaration.type = importableReference.typeReference;
                importSymbols(importAdder, importableReference.symbols);
              }
            }
          }
          signatureDeclaration.decorators = void 0;
          signatureDeclaration.modifiers = modifiers;
          signatureDeclaration.name = name;
          signatureDeclaration.questionToken = optional ? ts2.createToken(57) : void 0;
          signatureDeclaration.body = body;
          return signatureDeclaration;
        }
        function createMethodFromCallExpression(context, call, methodName, inJs, makeStatic, contextNode, importAdder) {
          var body = !ts2.isInterfaceDeclaration(contextNode);
          var typeArguments = call.typeArguments, args = call.arguments, parent = call.parent;
          var scriptTarget = ts2.getEmitScriptTarget(context.program.getCompilerOptions());
          var checker = context.program.getTypeChecker();
          var tracker = getNoopSymbolTrackerWithResolver(context);
          var types = ts2.map(args, function(arg) {
            return typeToAutoImportableTypeNode(checker, importAdder, checker.getBaseTypeOfLiteralType(checker.getTypeAtLocation(arg)), contextNode, scriptTarget, void 0, tracker);
          });
          var names = ts2.map(args, function(arg) {
            return ts2.isIdentifier(arg) ? arg.text : ts2.isPropertyAccessExpression(arg) && ts2.isIdentifier(arg.name) ? arg.name.text : void 0;
          });
          var contextualType = checker.getContextualType(call);
          var returnType = inJs || !contextualType ? void 0 : checker.typeToTypeNode(contextualType, contextNode, void 0, tracker);
          return ts2.createMethod(void 0, makeStatic ? [ts2.createToken(120)] : void 0, ts2.isYieldExpression(parent) ? ts2.createToken(41) : void 0, methodName, void 0, inJs ? void 0 : ts2.map(typeArguments, function(_, i) {
            return ts2.createTypeParameterDeclaration(84 + typeArguments.length - 1 <= 90 ? String.fromCharCode(84 + i) : "T" + i);
          }), createDummyParameters(args.length, names, types, void 0, inJs), returnType, body ? createStubbedMethodBody(context.preferences) : void 0);
        }
        codefix2.createMethodFromCallExpression = createMethodFromCallExpression;
        function typeToAutoImportableTypeNode(checker, importAdder, type, contextNode, scriptTarget, flags, tracker) {
          var typeNode = checker.typeToTypeNode(type, contextNode, flags, tracker);
          if (typeNode && ts2.isImportTypeNode(typeNode)) {
            var importableReference = tryGetAutoImportableReferenceFromImportTypeNode(typeNode, type, scriptTarget);
            if (importableReference) {
              importSymbols(importAdder, importableReference.symbols);
              return importableReference.typeReference;
            }
          }
          return typeNode;
        }
        codefix2.typeToAutoImportableTypeNode = typeToAutoImportableTypeNode;
        function createDummyParameters(argCount, names, types, minArgumentCount, inJs) {
          var parameters = [];
          for (var i = 0; i < argCount; i++) {
            var newParameter = ts2.createParameter(void 0, void 0, void 0, names && names[i] || "arg" + i, minArgumentCount !== void 0 && i >= minArgumentCount ? ts2.createToken(57) : void 0, inJs ? void 0 : types && types[i] || ts2.createKeywordTypeNode(125), void 0);
            parameters.push(newParameter);
          }
          return parameters;
        }
        function createMethodImplementingSignatures(signatures, name, optional, modifiers, preferences) {
          var maxArgsSignature = signatures[0];
          var minArgumentCount = signatures[0].minArgumentCount;
          var someSigHasRestParameter = false;
          for (var _i = 0, signatures_2 = signatures; _i < signatures_2.length; _i++) {
            var sig = signatures_2[_i];
            minArgumentCount = Math.min(sig.minArgumentCount, minArgumentCount);
            if (ts2.signatureHasRestParameter(sig)) {
              someSigHasRestParameter = true;
            }
            if (sig.parameters.length >= maxArgsSignature.parameters.length && (!ts2.signatureHasRestParameter(sig) || ts2.signatureHasRestParameter(maxArgsSignature))) {
              maxArgsSignature = sig;
            }
          }
          var maxNonRestArgs = maxArgsSignature.parameters.length - (ts2.signatureHasRestParameter(maxArgsSignature) ? 1 : 0);
          var maxArgsParameterSymbolNames = maxArgsSignature.parameters.map(function(symbol) {
            return symbol.name;
          });
          var parameters = createDummyParameters(maxNonRestArgs, maxArgsParameterSymbolNames, void 0, minArgumentCount, false);
          if (someSigHasRestParameter) {
            var anyArrayType = ts2.createArrayTypeNode(ts2.createKeywordTypeNode(125));
            var restParameter = ts2.createParameter(void 0, void 0, ts2.createToken(25), maxArgsParameterSymbolNames[maxNonRestArgs] || "rest", maxNonRestArgs >= minArgumentCount ? ts2.createToken(57) : void 0, anyArrayType, void 0);
            parameters.push(restParameter);
          }
          return createStubbedMethod(modifiers, name, optional, void 0, parameters, void 0, preferences);
        }
        function createStubbedMethod(modifiers, name, optional, typeParameters, parameters, returnType, preferences) {
          return ts2.createMethod(void 0, modifiers, void 0, name, optional ? ts2.createToken(57) : void 0, typeParameters, parameters, returnType, createStubbedMethodBody(preferences));
        }
        function createStubbedMethodBody(preferences) {
          return ts2.createBlock([ts2.createThrow(ts2.createNew(ts2.createIdentifier("Error"), void 0, [ts2.createLiteral("Method not implemented.", preferences.quotePreference === "single")]))], true);
        }
        function createVisibilityModifier(flags) {
          if (flags & 4) {
            return ts2.createToken(119);
          } else if (flags & 16) {
            return ts2.createToken(118);
          }
          return void 0;
        }
        function setJsonCompilerOptionValues(changeTracker, configFile, options) {
          var tsconfigObjectLiteral = ts2.getTsConfigObjectLiteralExpression(configFile);
          if (!tsconfigObjectLiteral)
            return void 0;
          var compilerOptionsProperty = findJsonProperty(tsconfigObjectLiteral, "compilerOptions");
          if (compilerOptionsProperty === void 0) {
            changeTracker.insertNodeAtObjectStart(configFile, tsconfigObjectLiteral, createJsonPropertyAssignment("compilerOptions", ts2.createObjectLiteral(options.map(function(_a2) {
              var optionName2 = _a2[0], optionValue2 = _a2[1];
              return createJsonPropertyAssignment(optionName2, optionValue2);
            }), true)));
            return;
          }
          var compilerOptions = compilerOptionsProperty.initializer;
          if (!ts2.isObjectLiteralExpression(compilerOptions)) {
            return;
          }
          for (var _i = 0, options_1 = options; _i < options_1.length; _i++) {
            var _a = options_1[_i], optionName = _a[0], optionValue = _a[1];
            var optionProperty = findJsonProperty(compilerOptions, optionName);
            if (optionProperty === void 0) {
              changeTracker.insertNodeAtObjectStart(configFile, compilerOptions, createJsonPropertyAssignment(optionName, optionValue));
            } else {
              changeTracker.replaceNode(configFile, optionProperty.initializer, optionValue);
            }
          }
        }
        codefix2.setJsonCompilerOptionValues = setJsonCompilerOptionValues;
        function setJsonCompilerOptionValue(changeTracker, configFile, optionName, optionValue) {
          setJsonCompilerOptionValues(changeTracker, configFile, [[optionName, optionValue]]);
        }
        codefix2.setJsonCompilerOptionValue = setJsonCompilerOptionValue;
        function createJsonPropertyAssignment(name, initializer) {
          return ts2.createPropertyAssignment(ts2.createStringLiteral(name), initializer);
        }
        codefix2.createJsonPropertyAssignment = createJsonPropertyAssignment;
        function findJsonProperty(obj, name) {
          return ts2.find(obj.properties, function(p) {
            return ts2.isPropertyAssignment(p) && !!p.name && ts2.isStringLiteral(p.name) && p.name.text === name;
          });
        }
        codefix2.findJsonProperty = findJsonProperty;
        function tryGetAutoImportableReferenceFromImportTypeNode(importTypeNode, type, scriptTarget) {
          if (importTypeNode && ts2.isLiteralImportTypeNode(importTypeNode) && importTypeNode.qualifier && (!type || type.symbol)) {
            var firstIdentifier = ts2.getFirstIdentifier(importTypeNode.qualifier);
            var name = ts2.getNameForExportedSymbol(firstIdentifier.symbol, scriptTarget);
            var qualifier = name !== firstIdentifier.text ? replaceFirstIdentifierOfEntityName(importTypeNode.qualifier, ts2.createIdentifier(name)) : importTypeNode.qualifier;
            var symbols_4 = [firstIdentifier.symbol];
            var typeArguments_1 = [];
            if (importTypeNode.typeArguments) {
              importTypeNode.typeArguments.forEach(function(arg) {
                var ref = tryGetAutoImportableReferenceFromImportTypeNode(arg, type, scriptTarget);
                if (ref) {
                  symbols_4.push.apply(symbols_4, ref.symbols);
                  typeArguments_1.push(ref.typeReference);
                } else {
                  typeArguments_1.push(arg);
                }
              });
            }
            return {
              symbols: symbols_4,
              typeReference: ts2.createTypeReferenceNode(qualifier, typeArguments_1)
            };
          }
        }
        codefix2.tryGetAutoImportableReferenceFromImportTypeNode = tryGetAutoImportableReferenceFromImportTypeNode;
        function replaceFirstIdentifierOfEntityName(name, newIdentifier) {
          if (name.kind === 75) {
            return newIdentifier;
          }
          return ts2.createQualifiedName(replaceFirstIdentifierOfEntityName(name.left, newIdentifier), name.right);
        }
        function importSymbols(importAdder, symbols) {
          symbols.forEach(function(s) {
            return importAdder.addImportFromExportedSymbol(s, true);
          });
        }
        codefix2.importSymbols = importSymbols;
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixName = "invalidImportSyntax";
        function getCodeFixesForImportDeclaration(context, node) {
          var sourceFile = ts2.getSourceFileOfNode(node);
          var namespace = ts2.getNamespaceDeclarationNode(node);
          var opts = context.program.getCompilerOptions();
          var variations = [];
          variations.push(createAction(context, sourceFile, node, ts2.makeImport(namespace.name, void 0, node.moduleSpecifier, ts2.getQuotePreference(sourceFile, context.preferences))));
          if (ts2.getEmitModuleKind(opts) === ts2.ModuleKind.CommonJS) {
            variations.push(createAction(context, sourceFile, node, ts2.createImportEqualsDeclaration(void 0, void 0, namespace.name, ts2.createExternalModuleReference(node.moduleSpecifier))));
          }
          return variations;
        }
        function createAction(context, sourceFile, node, replacement) {
          var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
            return t.replaceNode(sourceFile, node, replacement);
          });
          return codefix2.createCodeFixActionWithoutFixAll(fixName, changes, [ts2.Diagnostics.Replace_import_with_0, changes[0].textChanges[0].newText]);
        }
        codefix2.registerCodeFix({
          errorCodes: [
            ts2.Diagnostics.This_expression_is_not_callable.code,
            ts2.Diagnostics.This_expression_is_not_constructable.code
          ],
          getCodeActions: getActionsForUsageOfInvalidImport
        });
        function getActionsForUsageOfInvalidImport(context) {
          var sourceFile = context.sourceFile;
          var targetKind = ts2.Diagnostics.This_expression_is_not_callable.code === context.errorCode ? 196 : 197;
          var node = ts2.findAncestor(ts2.getTokenAtPosition(sourceFile, context.span.start), function(a) {
            return a.kind === targetKind;
          });
          if (!node) {
            return [];
          }
          var expr = node.expression;
          return getImportCodeFixesForExpression(context, expr);
        }
        codefix2.registerCodeFix({
          errorCodes: [
            ts2.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,
            ts2.Diagnostics.Type_0_does_not_satisfy_the_constraint_1.code,
            ts2.Diagnostics.Type_0_is_not_assignable_to_type_1.code,
            ts2.Diagnostics.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated.code,
            ts2.Diagnostics.Type_predicate_0_is_not_assignable_to_1.code,
            ts2.Diagnostics.Property_0_of_type_1_is_not_assignable_to_string_index_type_2.code,
            ts2.Diagnostics.Property_0_of_type_1_is_not_assignable_to_numeric_index_type_2.code,
            ts2.Diagnostics.Numeric_index_type_0_is_not_assignable_to_string_index_type_1.code,
            ts2.Diagnostics.Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2.code,
            ts2.Diagnostics.Property_0_in_type_1_is_not_assignable_to_type_2.code,
            ts2.Diagnostics.Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property.code,
            ts2.Diagnostics.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1.code
          ],
          getCodeActions: getActionsForInvalidImportLocation
        });
        function getActionsForInvalidImportLocation(context) {
          var sourceFile = context.sourceFile;
          var node = ts2.findAncestor(ts2.getTokenAtPosition(sourceFile, context.span.start), function(a) {
            return a.getStart() === context.span.start && a.getEnd() === context.span.start + context.span.length;
          });
          if (!node) {
            return [];
          }
          return getImportCodeFixesForExpression(context, node);
        }
        function getImportCodeFixesForExpression(context, expr) {
          var type = context.program.getTypeChecker().getTypeAtLocation(expr);
          if (!(type.symbol && type.symbol.originatingImport)) {
            return [];
          }
          var fixes = [];
          var relatedImport = type.symbol.originatingImport;
          if (!ts2.isImportCall(relatedImport)) {
            ts2.addRange(fixes, getCodeFixesForImportDeclaration(context, relatedImport));
          }
          if (ts2.isExpression(expr) && !(ts2.isNamedDeclaration(expr.parent) && expr.parent.name === expr)) {
            var sourceFile_1 = context.sourceFile;
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return t.replaceNode(sourceFile_1, expr, ts2.createPropertyAccess(expr, "default"), {});
            });
            fixes.push(codefix2.createCodeFixActionWithoutFixAll(fixName, changes, ts2.Diagnostics.Use_synthetic_default_member));
          }
          return fixes;
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixName = "strictClassInitialization";
        var fixIdAddDefiniteAssignmentAssertions = "addMissingPropertyDefiniteAssignmentAssertions";
        var fixIdAddUndefinedType = "addMissingPropertyUndefinedType";
        var fixIdAddInitializer = "addMissingPropertyInitializer";
        var errorCodes = [ts2.Diagnostics.Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var propertyDeclaration = getPropertyDeclaration(context.sourceFile, context.span.start);
            if (!propertyDeclaration)
              return;
            var result = [
              getActionForAddMissingUndefinedType(context, propertyDeclaration),
              getActionForAddMissingDefiniteAssignmentAssertion(context, propertyDeclaration)
            ];
            ts2.append(result, getActionForAddMissingInitializer(context, propertyDeclaration));
            return result;
          },
          fixIds: [fixIdAddDefiniteAssignmentAssertions, fixIdAddUndefinedType, fixIdAddInitializer],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var propertyDeclaration = getPropertyDeclaration(diag.file, diag.start);
              if (!propertyDeclaration)
                return;
              switch (context.fixId) {
                case fixIdAddDefiniteAssignmentAssertions:
                  addDefiniteAssignmentAssertion(changes, diag.file, propertyDeclaration);
                  break;
                case fixIdAddUndefinedType:
                  addUndefinedType(changes, diag.file, propertyDeclaration);
                  break;
                case fixIdAddInitializer:
                  var checker = context.program.getTypeChecker();
                  var initializer = getInitializer(checker, propertyDeclaration);
                  if (!initializer)
                    return;
                  addInitializer(changes, diag.file, propertyDeclaration, initializer);
                  break;
                default:
                  ts2.Debug.fail(JSON.stringify(context.fixId));
              }
            });
          }
        });
        function getPropertyDeclaration(sourceFile, pos) {
          var token = ts2.getTokenAtPosition(sourceFile, pos);
          return ts2.isIdentifier(token) ? ts2.cast(token.parent, ts2.isPropertyDeclaration) : void 0;
        }
        function getActionForAddMissingDefiniteAssignmentAssertion(context, propertyDeclaration) {
          var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
            return addDefiniteAssignmentAssertion(t, context.sourceFile, propertyDeclaration);
          });
          return codefix2.createCodeFixAction(fixName, changes, [ts2.Diagnostics.Add_definite_assignment_assertion_to_property_0, propertyDeclaration.getText()], fixIdAddDefiniteAssignmentAssertions, ts2.Diagnostics.Add_definite_assignment_assertions_to_all_uninitialized_properties);
        }
        function addDefiniteAssignmentAssertion(changeTracker, propertyDeclarationSourceFile, propertyDeclaration) {
          var property = ts2.updateProperty(propertyDeclaration, propertyDeclaration.decorators, propertyDeclaration.modifiers, propertyDeclaration.name, ts2.createToken(53), propertyDeclaration.type, propertyDeclaration.initializer);
          changeTracker.replaceNode(propertyDeclarationSourceFile, propertyDeclaration, property);
        }
        function getActionForAddMissingUndefinedType(context, propertyDeclaration) {
          var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
            return addUndefinedType(t, context.sourceFile, propertyDeclaration);
          });
          return codefix2.createCodeFixAction(fixName, changes, [ts2.Diagnostics.Add_undefined_type_to_property_0, propertyDeclaration.name.getText()], fixIdAddUndefinedType, ts2.Diagnostics.Add_undefined_type_to_all_uninitialized_properties);
        }
        function addUndefinedType(changeTracker, propertyDeclarationSourceFile, propertyDeclaration) {
          var undefinedTypeNode = ts2.createKeywordTypeNode(146);
          var type = propertyDeclaration.type;
          var types = ts2.isUnionTypeNode(type) ? type.types.concat(undefinedTypeNode) : [type, undefinedTypeNode];
          changeTracker.replaceNode(propertyDeclarationSourceFile, type, ts2.createUnionTypeNode(types));
        }
        function getActionForAddMissingInitializer(context, propertyDeclaration) {
          var checker = context.program.getTypeChecker();
          var initializer = getInitializer(checker, propertyDeclaration);
          if (!initializer)
            return void 0;
          var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
            return addInitializer(t, context.sourceFile, propertyDeclaration, initializer);
          });
          return codefix2.createCodeFixAction(fixName, changes, [ts2.Diagnostics.Add_initializer_to_property_0, propertyDeclaration.name.getText()], fixIdAddInitializer, ts2.Diagnostics.Add_initializers_to_all_uninitialized_properties);
        }
        function addInitializer(changeTracker, propertyDeclarationSourceFile, propertyDeclaration, initializer) {
          var property = ts2.updateProperty(propertyDeclaration, propertyDeclaration.decorators, propertyDeclaration.modifiers, propertyDeclaration.name, propertyDeclaration.questionToken, propertyDeclaration.type, initializer);
          changeTracker.replaceNode(propertyDeclarationSourceFile, propertyDeclaration, property);
        }
        function getInitializer(checker, propertyDeclaration) {
          return getDefaultValueFromType(checker, checker.getTypeFromTypeNode(propertyDeclaration.type));
        }
        function getDefaultValueFromType(checker, type) {
          if (type.flags & 512) {
            return type === checker.getFalseType() || type === checker.getFalseType(true) ? ts2.createFalse() : ts2.createTrue();
          } else if (type.isLiteral()) {
            return ts2.createLiteral(type.value);
          } else if (type.isUnion()) {
            return ts2.firstDefined(type.types, function(t) {
              return getDefaultValueFromType(checker, t);
            });
          } else if (type.isClass()) {
            var classDeclaration = ts2.getClassLikeDeclarationOfSymbol(type.symbol);
            if (!classDeclaration || ts2.hasModifier(classDeclaration, 128))
              return void 0;
            var constructorDeclaration = ts2.getFirstConstructorWithBody(classDeclaration);
            if (constructorDeclaration && constructorDeclaration.parameters.length)
              return void 0;
            return ts2.createNew(ts2.createIdentifier(type.symbol.name), void 0, void 0);
          } else if (checker.isArrayLikeType(type)) {
            return ts2.createArrayLiteral();
          }
          return void 0;
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "requireInTs";
        var errorCodes = [ts2.Diagnostics.require_call_may_be_converted_to_an_import.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, context.sourceFile, context.span.start, context.program);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Convert_require_to_import, fixId, ts2.Diagnostics.Convert_all_require_to_import)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return doChange(changes, diag.file, diag.start, context.program);
            });
          }
        });
        function doChange(changes, sourceFile, pos, program) {
          var _a = getInfo(sourceFile, pos), statement = _a.statement, name = _a.name, required = _a.required;
          changes.replaceNode(sourceFile, statement, ts2.getAllowSyntheticDefaultImports(program.getCompilerOptions()) ? ts2.createImportDeclaration(void 0, void 0, ts2.createImportClause(name, void 0), required) : ts2.createImportEqualsDeclaration(void 0, void 0, name, ts2.createExternalModuleReference(required)));
        }
        function getInfo(sourceFile, pos) {
          var parent = ts2.getTokenAtPosition(sourceFile, pos).parent;
          if (!ts2.isRequireCall(parent, true))
            throw ts2.Debug.failBadSyntaxKind(parent);
          var decl = ts2.cast(parent.parent, ts2.isVariableDeclaration);
          return { statement: ts2.cast(decl.parent.parent, ts2.isVariableStatement), name: ts2.cast(decl.name, ts2.isIdentifier), required: parent.arguments[0] };
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "useDefaultImport";
        var errorCodes = [ts2.Diagnostics.Import_may_be_converted_to_a_default_import.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, start = context.span.start;
            var info = getInfo(sourceFile, start);
            if (!info)
              return void 0;
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, info, context.preferences);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Convert_to_default_import, fixId, ts2.Diagnostics.Convert_all_to_default_imports)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, diag.start);
              if (info)
                doChange(changes, diag.file, info, context.preferences);
            });
          }
        });
        function getInfo(sourceFile, pos) {
          var name = ts2.getTokenAtPosition(sourceFile, pos);
          if (!ts2.isIdentifier(name))
            return void 0;
          var parent = name.parent;
          if (ts2.isImportEqualsDeclaration(parent) && ts2.isExternalModuleReference(parent.moduleReference)) {
            return { importNode: parent, name, moduleSpecifier: parent.moduleReference.expression };
          } else if (ts2.isNamespaceImport(parent)) {
            var importNode = parent.parent.parent;
            return { importNode, name, moduleSpecifier: importNode.moduleSpecifier };
          }
        }
        function doChange(changes, sourceFile, info, preferences) {
          changes.replaceNode(sourceFile, info.importNode, ts2.makeImport(info.name, void 0, info.moduleSpecifier, ts2.getQuotePreference(sourceFile, preferences)));
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "useBigintLiteral";
        var errorCodes = [
          ts2.Diagnostics.Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return makeChange(t, context.sourceFile, context.span);
            });
            if (changes.length > 0) {
              return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Convert_to_a_bigint_numeric_literal, fixId, ts2.Diagnostics.Convert_all_to_bigint_numeric_literals)];
            }
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag);
            });
          }
        });
        function makeChange(changeTracker, sourceFile, span) {
          var numericLiteral = ts2.tryCast(ts2.getTokenAtPosition(sourceFile, span.start), ts2.isNumericLiteral);
          if (!numericLiteral) {
            return;
          }
          var newText = numericLiteral.getText(sourceFile) + "n";
          changeTracker.replaceNode(sourceFile, numericLiteral, ts2.createBigIntLiteral(newText));
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixIdAddMissingTypeof = "fixAddModuleReferTypeMissingTypeof";
        var fixId = fixIdAddMissingTypeof;
        var errorCodes = [ts2.Diagnostics.Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var importType = getImportTypeNode(sourceFile, span.start);
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, importType);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Add_missing_typeof, fixId, ts2.Diagnostics.Add_missing_typeof)];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return doChange(changes, context.sourceFile, getImportTypeNode(diag.file, diag.start));
            });
          }
        });
        function getImportTypeNode(sourceFile, pos) {
          var token = ts2.getTokenAtPosition(sourceFile, pos);
          ts2.Debug.assert(token.kind === 96, "This token should be an ImportKeyword");
          ts2.Debug.assert(token.parent.kind === 188, "Token parent should be an ImportType");
          return token.parent;
        }
        function doChange(changes, sourceFile, importType) {
          var newTypeNode = ts2.updateImportTypeNode(importType, importType.argument, importType.qualifier, importType.typeArguments, true);
          changes.replaceNode(sourceFile, importType, newTypeNode);
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixIdAddMissingTypeof = "fixConvertToMappedObjectType";
        var fixId = fixIdAddMissingTypeof;
        var errorCodes = [ts2.Diagnostics.An_index_signature_parameter_type_cannot_be_a_union_type_Consider_using_a_mapped_object_type_instead.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span;
            var info = getInfo(sourceFile, span.start);
            if (!info)
              return void 0;
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, info);
            });
            var name = ts2.idText(info.container.name);
            return [codefix2.createCodeFixAction(fixId, changes, [ts2.Diagnostics.Convert_0_to_mapped_object_type, name], fixId, [ts2.Diagnostics.Convert_0_to_mapped_object_type, name])];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, diag.start);
              if (info)
                doChange(changes, diag.file, info);
            });
          }
        });
        function getInfo(sourceFile, pos) {
          var token = ts2.getTokenAtPosition(sourceFile, pos);
          var indexSignature = ts2.cast(token.parent.parent, ts2.isIndexSignatureDeclaration);
          if (ts2.isClassDeclaration(indexSignature.parent))
            return void 0;
          var container = ts2.isInterfaceDeclaration(indexSignature.parent) ? indexSignature.parent : ts2.cast(indexSignature.parent.parent, ts2.isTypeAliasDeclaration);
          return { indexSignature, container };
        }
        function createTypeAliasFromInterface(declaration, type) {
          return ts2.createTypeAliasDeclaration(declaration.decorators, declaration.modifiers, declaration.name, declaration.typeParameters, type);
        }
        function doChange(changes, sourceFile, _a) {
          var indexSignature = _a.indexSignature, container = _a.container;
          var members = ts2.isInterfaceDeclaration(container) ? container.members : container.type.members;
          var otherMembers = members.filter(function(member) {
            return !ts2.isIndexSignatureDeclaration(member);
          });
          var parameter = ts2.first(indexSignature.parameters);
          var mappedTypeParameter = ts2.createTypeParameterDeclaration(ts2.cast(parameter.name, ts2.isIdentifier), parameter.type);
          var mappedIntersectionType = ts2.createMappedTypeNode(ts2.hasReadonlyModifier(indexSignature) ? ts2.createModifier(138) : void 0, mappedTypeParameter, indexSignature.questionToken, indexSignature.type);
          var intersectionType = ts2.createIntersectionTypeNode(__spreadArrays(ts2.getAllSuperTypeNodes(container), [
            mappedIntersectionType
          ], otherMembers.length ? [ts2.createTypeLiteralNode(otherMembers)] : ts2.emptyArray));
          changes.replaceNode(sourceFile, container, createTypeAliasFromInterface(container, intersectionType));
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "removeUnnecessaryAwait";
        var errorCodes = [
          ts2.Diagnostics.await_has_no_effect_on_the_type_of_this_expression.code
        ];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return makeChange(t, context.sourceFile, context.span);
            });
            if (changes.length > 0) {
              return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Remove_unnecessary_await, fixId, ts2.Diagnostics.Remove_all_unnecessary_uses_of_await)];
            }
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              return makeChange(changes, diag.file, diag);
            });
          }
        });
        function makeChange(changeTracker, sourceFile, span) {
          var awaitKeyword = ts2.tryCast(ts2.getTokenAtPosition(sourceFile, span.start), function(node) {
            return node.kind === 127;
          });
          var awaitExpression = awaitKeyword && ts2.tryCast(awaitKeyword.parent, ts2.isAwaitExpression);
          if (!awaitExpression) {
            return;
          }
          var expressionToReplace = awaitExpression;
          var hasSurroundingParens = ts2.isParenthesizedExpression(awaitExpression.parent);
          if (hasSurroundingParens) {
            var leftMostExpression = ts2.getLeftmostExpression(awaitExpression.expression, false);
            if (ts2.isIdentifier(leftMostExpression)) {
              var precedingToken = ts2.findPrecedingToken(awaitExpression.parent.pos, sourceFile);
              if (precedingToken && precedingToken.kind !== 99) {
                expressionToReplace = awaitExpression.parent;
              }
            }
          }
          changeTracker.replaceNode(sourceFile, expressionToReplace, awaitExpression.expression);
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var errorCodes = [ts2.Diagnostics.A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both.code];
        var fixId = "splitTypeOnlyImport";
        codefix2.registerCodeFix({
          errorCodes,
          fixIds: [fixId],
          getCodeActions: function(context) {
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return splitTypeOnlyImport(t, getImportDeclaration(context.sourceFile, context.span), context);
            });
            if (changes.length) {
              return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Split_into_two_separate_import_declarations, fixId, ts2.Diagnostics.Split_all_invalid_type_only_imports)];
            }
          },
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, error) {
              splitTypeOnlyImport(changes, getImportDeclaration(context.sourceFile, error), context);
            });
          }
        });
        function getImportDeclaration(sourceFile, span) {
          return ts2.findAncestor(ts2.getTokenAtPosition(sourceFile, span.start), ts2.isImportDeclaration);
        }
        function splitTypeOnlyImport(changes, importDeclaration, context) {
          if (!importDeclaration) {
            return;
          }
          var importClause = ts2.Debug.checkDefined(importDeclaration.importClause);
          changes.replaceNode(context.sourceFile, importDeclaration, ts2.updateImportDeclaration(importDeclaration, importDeclaration.decorators, importDeclaration.modifiers, ts2.updateImportClause(importClause, importClause.name, void 0, importClause.isTypeOnly), importDeclaration.moduleSpecifier));
          changes.insertNodeAfter(context.sourceFile, importDeclaration, ts2.createImportDeclaration(void 0, void 0, ts2.updateImportClause(importClause, void 0, importClause.namedBindings, importClause.isTypeOnly), importDeclaration.moduleSpecifier));
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixConvertConstToLet";
        var errorCodes = [ts2.Diagnostics.Cannot_assign_to_0_because_it_is_a_constant.code];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile, span = context.span, program = context.program;
            var variableStatement = getVariableStatement(sourceFile, span.start, program);
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, variableStatement);
            });
            return [codefix2.createCodeFixAction(fixId, changes, ts2.Diagnostics.Convert_const_to_let, fixId, ts2.Diagnostics.Convert_const_to_let)];
          },
          fixIds: [fixId]
        });
        function getVariableStatement(sourceFile, pos, program) {
          var token = ts2.getTokenAtPosition(sourceFile, pos);
          var checker = program.getTypeChecker();
          var symbol = checker.getSymbolAtLocation(token);
          if (symbol) {
            return symbol.valueDeclaration.parent.parent;
          }
        }
        function doChange(changes, sourceFile, variableStatement) {
          if (!variableStatement) {
            return;
          }
          var start = variableStatement.getStart();
          changes.replaceRangeWithText(sourceFile, { pos: start, end: start + 5 }, "let");
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var codefix;
      (function(codefix2) {
        var fixId = "fixExpectedComma";
        var expectedErrorCode = ts2.Diagnostics._0_expected.code;
        var errorCodes = [expectedErrorCode];
        codefix2.registerCodeFix({
          errorCodes,
          getCodeActions: function(context) {
            var sourceFile = context.sourceFile;
            var info = getInfo(sourceFile, context.span.start, context.errorCode);
            if (!info) {
              return void 0;
            }
            var changes = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(t, sourceFile, info);
            });
            return [codefix2.createCodeFixAction(fixId, changes, [ts2.Diagnostics.Change_0_to_1, ";", ","], fixId, [ts2.Diagnostics.Change_0_to_1, ";", ","])];
          },
          fixIds: [fixId],
          getAllCodeActions: function(context) {
            return codefix2.codeFixAll(context, errorCodes, function(changes, diag) {
              var info = getInfo(diag.file, diag.start, diag.code);
              if (info)
                doChange(changes, context.sourceFile, info);
            });
          }
        });
        function getInfo(sourceFile, pos, _) {
          var node = ts2.getTokenAtPosition(sourceFile, pos);
          return node.kind === 26 && node.parent && (ts2.isObjectLiteralExpression(node.parent) || ts2.isArrayLiteralExpression(node.parent)) ? { node } : void 0;
        }
        function doChange(changes, sourceFile, _a) {
          var node = _a.node;
          var newNode = ts2.createNode(27);
          changes.replaceNode(sourceFile, node, newNode);
        }
      })(codefix = ts2.codefix || (ts2.codefix = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var refactor;
      (function(refactor2) {
        var refactorName = "Convert export";
        var actionNameDefaultToNamed = "Convert default export to named export";
        var actionNameNamedToDefault = "Convert named export to default export";
        refactor2.registerRefactor(refactorName, {
          getAvailableActions: function(context) {
            var info = getInfo(context);
            if (!info)
              return ts2.emptyArray;
            var description = info.wasDefault ? ts2.Diagnostics.Convert_default_export_to_named_export.message : ts2.Diagnostics.Convert_named_export_to_default_export.message;
            var actionName = info.wasDefault ? actionNameDefaultToNamed : actionNameNamedToDefault;
            return [{ name: refactorName, description, actions: [{ name: actionName, description }] }];
          },
          getEditsForAction: function(context, actionName) {
            ts2.Debug.assert(actionName === actionNameDefaultToNamed || actionName === actionNameNamedToDefault, "Unexpected action name");
            var edits = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(context.file, context.program, ts2.Debug.checkDefined(getInfo(context), "context must have info"), t, context.cancellationToken);
            });
            return { edits, renameFilename: void 0, renameLocation: void 0 };
          }
        });
        function getInfo(context) {
          var file = context.file;
          var span = ts2.getRefactorContextSpan(context);
          var token = ts2.getTokenAtPosition(file, span.start);
          var exportNode = ts2.getParentNodeInSpan(token, file, span);
          if (!exportNode || !ts2.isSourceFile(exportNode.parent) && !(ts2.isModuleBlock(exportNode.parent) && ts2.isAmbientModule(exportNode.parent.parent))) {
            return void 0;
          }
          var exportingModuleSymbol = ts2.isSourceFile(exportNode.parent) ? exportNode.parent.symbol : exportNode.parent.parent.symbol;
          var flags = ts2.getModifierFlags(exportNode);
          var wasDefault = !!(flags & 512);
          if (!(flags & 1) || !wasDefault && exportingModuleSymbol.exports.has("default")) {
            return void 0;
          }
          switch (exportNode.kind) {
            case 244:
            case 245:
            case 246:
            case 248:
            case 247:
            case 249: {
              var node = exportNode;
              return node.name && ts2.isIdentifier(node.name) ? { exportNode: node, exportName: node.name, wasDefault, exportingModuleSymbol } : void 0;
            }
            case 225: {
              var vs = exportNode;
              if (!(vs.declarationList.flags & 2) || vs.declarationList.declarations.length !== 1) {
                return void 0;
              }
              var decl = ts2.first(vs.declarationList.declarations);
              if (!decl.initializer)
                return void 0;
              ts2.Debug.assert(!wasDefault, "Can't have a default flag here");
              return ts2.isIdentifier(decl.name) ? { exportNode: vs, exportName: decl.name, wasDefault, exportingModuleSymbol } : void 0;
            }
            default:
              return void 0;
          }
        }
        function doChange(exportingSourceFile, program, info, changes, cancellationToken) {
          changeExport(exportingSourceFile, info, changes, program.getTypeChecker());
          changeImports(program, info, changes, cancellationToken);
        }
        function changeExport(exportingSourceFile, _a, changes, checker) {
          var wasDefault = _a.wasDefault, exportNode = _a.exportNode, exportName = _a.exportName;
          if (wasDefault) {
            changes.delete(exportingSourceFile, ts2.Debug.checkDefined(ts2.findModifier(exportNode, 84), "Should find a default keyword in modifier list"));
          } else {
            var exportKeyword = ts2.Debug.checkDefined(ts2.findModifier(exportNode, 89), "Should find an export keyword in modifier list");
            switch (exportNode.kind) {
              case 244:
              case 245:
              case 246:
                changes.insertNodeAfter(exportingSourceFile, exportKeyword, ts2.createToken(84));
                break;
              case 225:
                if (!ts2.FindAllReferences.Core.isSymbolReferencedInFile(exportName, checker, exportingSourceFile)) {
                  changes.replaceNode(exportingSourceFile, exportNode, ts2.createExportDefault(ts2.Debug.checkDefined(ts2.first(exportNode.declarationList.declarations).initializer, "Initializer was previously known to be present")));
                  break;
                }
              case 248:
              case 247:
              case 249:
                changes.deleteModifier(exportingSourceFile, exportKeyword);
                changes.insertNodeAfter(exportingSourceFile, exportNode, ts2.createExportDefault(ts2.createIdentifier(exportName.text)));
                break;
              default:
                ts2.Debug.assertNever(exportNode, "Unexpected exportNode kind " + exportNode.kind);
            }
          }
        }
        function changeImports(program, _a, changes, cancellationToken) {
          var wasDefault = _a.wasDefault, exportName = _a.exportName, exportingModuleSymbol = _a.exportingModuleSymbol;
          var checker = program.getTypeChecker();
          var exportSymbol = ts2.Debug.checkDefined(checker.getSymbolAtLocation(exportName), "Export name should resolve to a symbol");
          ts2.FindAllReferences.Core.eachExportReference(program.getSourceFiles(), checker, cancellationToken, exportSymbol, exportingModuleSymbol, exportName.text, wasDefault, function(ref) {
            var importingSourceFile = ref.getSourceFile();
            if (wasDefault) {
              changeDefaultToNamedImport(importingSourceFile, ref, changes, exportName.text);
            } else {
              changeNamedToDefaultImport(importingSourceFile, ref, changes);
            }
          });
        }
        function changeDefaultToNamedImport(importingSourceFile, ref, changes, exportName) {
          var parent = ref.parent;
          switch (parent.kind) {
            case 194:
              changes.replaceNode(importingSourceFile, ref, ts2.createIdentifier(exportName));
              break;
            case 258:
            case 263: {
              var spec = parent;
              changes.replaceNode(importingSourceFile, spec, makeImportSpecifier(exportName, spec.name.text));
              break;
            }
            case 255: {
              var clause = parent;
              ts2.Debug.assert(clause.name === ref, "Import clause name should match provided ref");
              var spec = makeImportSpecifier(exportName, ref.text);
              var namedBindings = clause.namedBindings;
              if (!namedBindings) {
                changes.replaceNode(importingSourceFile, ref, ts2.createNamedImports([spec]));
              } else if (namedBindings.kind === 256) {
                changes.deleteRange(importingSourceFile, { pos: ref.getStart(importingSourceFile), end: namedBindings.getStart(importingSourceFile) });
                var quotePreference = ts2.isStringLiteral(clause.parent.moduleSpecifier) ? ts2.quotePreferenceFromString(clause.parent.moduleSpecifier, importingSourceFile) : 1;
                var newImport = ts2.makeImport(void 0, [makeImportSpecifier(exportName, ref.text)], clause.parent.moduleSpecifier, quotePreference);
                changes.insertNodeAfter(importingSourceFile, clause.parent, newImport);
              } else {
                changes.delete(importingSourceFile, ref);
                changes.insertNodeAtEndOfList(importingSourceFile, namedBindings.elements, spec);
              }
              break;
            }
            default:
              ts2.Debug.failBadSyntaxKind(parent);
          }
        }
        function changeNamedToDefaultImport(importingSourceFile, ref, changes) {
          var parent = ref.parent;
          switch (parent.kind) {
            case 194:
              changes.replaceNode(importingSourceFile, ref, ts2.createIdentifier("default"));
              break;
            case 258: {
              var defaultImport = ts2.createIdentifier(parent.name.text);
              if (parent.parent.elements.length === 1) {
                changes.replaceNode(importingSourceFile, parent.parent, defaultImport);
              } else {
                changes.delete(importingSourceFile, parent);
                changes.insertNodeBefore(importingSourceFile, parent.parent, defaultImport);
              }
              break;
            }
            case 263: {
              changes.replaceNode(importingSourceFile, parent, makeExportSpecifier("default", parent.name.text));
              break;
            }
            default:
              ts2.Debug.assertNever(parent, "Unexpected parent kind " + parent.kind);
          }
        }
        function makeImportSpecifier(propertyName, name) {
          return ts2.createImportSpecifier(propertyName === name ? void 0 : ts2.createIdentifier(propertyName), ts2.createIdentifier(name));
        }
        function makeExportSpecifier(propertyName, name) {
          return ts2.createExportSpecifier(propertyName === name ? void 0 : ts2.createIdentifier(propertyName), ts2.createIdentifier(name));
        }
      })(refactor = ts2.refactor || (ts2.refactor = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var refactor;
      (function(refactor2) {
        var refactorName = "Convert import";
        var actionNameNamespaceToNamed = "Convert namespace import to named imports";
        var actionNameNamedToNamespace = "Convert named imports to namespace import";
        refactor2.registerRefactor(refactorName, {
          getAvailableActions: function(context) {
            var i = getImportToConvert(context);
            if (!i)
              return ts2.emptyArray;
            var description = i.kind === 256 ? ts2.Diagnostics.Convert_namespace_import_to_named_imports.message : ts2.Diagnostics.Convert_named_imports_to_namespace_import.message;
            var actionName = i.kind === 256 ? actionNameNamespaceToNamed : actionNameNamedToNamespace;
            return [{ name: refactorName, description, actions: [{ name: actionName, description }] }];
          },
          getEditsForAction: function(context, actionName) {
            ts2.Debug.assert(actionName === actionNameNamespaceToNamed || actionName === actionNameNamedToNamespace, "Unexpected action name");
            var edits = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(context.file, context.program, t, ts2.Debug.checkDefined(getImportToConvert(context), "Context must provide an import to convert"));
            });
            return { edits, renameFilename: void 0, renameLocation: void 0 };
          }
        });
        function getImportToConvert(context) {
          var file = context.file;
          var span = ts2.getRefactorContextSpan(context);
          var token = ts2.getTokenAtPosition(file, span.start);
          var importDecl = ts2.getParentNodeInSpan(token, file, span);
          if (!importDecl || !ts2.isImportDeclaration(importDecl))
            return void 0;
          var importClause = importDecl.importClause;
          return importClause && importClause.namedBindings;
        }
        function doChange(sourceFile, program, changes, toConvert) {
          var checker = program.getTypeChecker();
          if (toConvert.kind === 256) {
            doChangeNamespaceToNamed(sourceFile, checker, changes, toConvert, ts2.getAllowSyntheticDefaultImports(program.getCompilerOptions()));
          } else {
            doChangeNamedToNamespace(sourceFile, checker, changes, toConvert);
          }
        }
        function doChangeNamespaceToNamed(sourceFile, checker, changes, toConvert, allowSyntheticDefaultImports) {
          var usedAsNamespaceOrDefault = false;
          var nodesToReplace = [];
          var conflictingNames = ts2.createMap();
          ts2.FindAllReferences.Core.eachSymbolReferenceInFile(toConvert.name, checker, sourceFile, function(id) {
            if (!ts2.isPropertyAccessExpression(id.parent)) {
              usedAsNamespaceOrDefault = true;
            } else {
              var parent = ts2.cast(id.parent, ts2.isPropertyAccessExpression);
              var exportName2 = parent.name.text;
              if (checker.resolveName(exportName2, id, 67108863, true)) {
                conflictingNames.set(exportName2, true);
              }
              ts2.Debug.assert(parent.expression === id, "Parent expression should match id");
              nodesToReplace.push(parent);
            }
          });
          var exportNameToImportName = ts2.createMap();
          for (var _i = 0, nodesToReplace_1 = nodesToReplace; _i < nodesToReplace_1.length; _i++) {
            var propertyAccess = nodesToReplace_1[_i];
            var exportName = propertyAccess.name.text;
            var importName = exportNameToImportName.get(exportName);
            if (importName === void 0) {
              exportNameToImportName.set(exportName, importName = conflictingNames.has(exportName) ? ts2.getUniqueName(exportName, sourceFile) : exportName);
            }
            changes.replaceNode(sourceFile, propertyAccess, ts2.createIdentifier(importName));
          }
          var importSpecifiers = [];
          exportNameToImportName.forEach(function(name, propertyName) {
            importSpecifiers.push(ts2.createImportSpecifier(name === propertyName ? void 0 : ts2.createIdentifier(propertyName), ts2.createIdentifier(name)));
          });
          var importDecl = toConvert.parent.parent;
          if (usedAsNamespaceOrDefault && !allowSyntheticDefaultImports) {
            changes.insertNodeAfter(sourceFile, importDecl, updateImport(importDecl, void 0, importSpecifiers));
          } else {
            changes.replaceNode(sourceFile, importDecl, updateImport(importDecl, usedAsNamespaceOrDefault ? ts2.createIdentifier(toConvert.name.text) : void 0, importSpecifiers));
          }
        }
        function doChangeNamedToNamespace(sourceFile, checker, changes, toConvert) {
          var importDecl = toConvert.parent.parent;
          var moduleSpecifier = importDecl.moduleSpecifier;
          var preferredName = moduleSpecifier && ts2.isStringLiteral(moduleSpecifier) ? ts2.codefix.moduleSpecifierToValidIdentifier(moduleSpecifier.text, 99) : "module";
          var namespaceNameConflicts = toConvert.elements.some(function(element2) {
            return ts2.FindAllReferences.Core.eachSymbolReferenceInFile(element2.name, checker, sourceFile, function(id) {
              return !!checker.resolveName(preferredName, id, 67108863, true);
            }) || false;
          });
          var namespaceImportName = namespaceNameConflicts ? ts2.getUniqueName(preferredName, sourceFile) : preferredName;
          var neededNamedImports = [];
          var _loop_15 = function(element2) {
            var propertyName = (element2.propertyName || element2.name).text;
            ts2.FindAllReferences.Core.eachSymbolReferenceInFile(element2.name, checker, sourceFile, function(id) {
              var access = ts2.createPropertyAccess(ts2.createIdentifier(namespaceImportName), propertyName);
              if (ts2.isShorthandPropertyAssignment(id.parent)) {
                changes.replaceNode(sourceFile, id.parent, ts2.createPropertyAssignment(id.text, access));
              } else if (ts2.isExportSpecifier(id.parent) && !id.parent.propertyName) {
                if (!neededNamedImports.some(function(n) {
                  return n.name === element2.name;
                })) {
                  neededNamedImports.push(ts2.createImportSpecifier(element2.propertyName && ts2.createIdentifier(element2.propertyName.text), ts2.createIdentifier(element2.name.text)));
                }
              } else {
                changes.replaceNode(sourceFile, id, access);
              }
            });
          };
          for (var _i = 0, _a = toConvert.elements; _i < _a.length; _i++) {
            var element = _a[_i];
            _loop_15(element);
          }
          changes.replaceNode(sourceFile, toConvert, ts2.createNamespaceImport(ts2.createIdentifier(namespaceImportName)));
          if (neededNamedImports.length) {
            changes.insertNodeAfter(sourceFile, toConvert.parent.parent, updateImport(importDecl, void 0, neededNamedImports));
          }
        }
        function updateImport(old, defaultImportName, elements) {
          return ts2.createImportDeclaration(void 0, void 0, ts2.createImportClause(defaultImportName, elements && elements.length ? ts2.createNamedImports(elements) : void 0), old.moduleSpecifier);
        }
      })(refactor = ts2.refactor || (ts2.refactor = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var refactor;
      (function(refactor2) {
        var extractSymbol;
        (function(extractSymbol2) {
          var refactorName = "Extract Symbol";
          refactor2.registerRefactor(refactorName, { getAvailableActions, getEditsForAction });
          function getAvailableActions(context) {
            var rangeToExtract = getRangeToExtract(context.file, ts2.getRefactorContextSpan(context));
            var targetRange = rangeToExtract.targetRange;
            if (targetRange === void 0) {
              return ts2.emptyArray;
            }
            var extractions = getPossibleExtractions(targetRange, context);
            if (extractions === void 0) {
              return ts2.emptyArray;
            }
            var functionActions = [];
            var usedFunctionNames = ts2.createMap();
            var constantActions = [];
            var usedConstantNames = ts2.createMap();
            var i = 0;
            for (var _i = 0, extractions_1 = extractions; _i < extractions_1.length; _i++) {
              var _a = extractions_1[_i], functionExtraction = _a.functionExtraction, constantExtraction = _a.constantExtraction;
              if (functionExtraction.errors.length === 0) {
                var description = functionExtraction.description;
                if (!usedFunctionNames.has(description)) {
                  usedFunctionNames.set(description, true);
                  functionActions.push({
                    description,
                    name: "function_scope_" + i
                  });
                }
              }
              if (constantExtraction.errors.length === 0) {
                var description = constantExtraction.description;
                if (!usedConstantNames.has(description)) {
                  usedConstantNames.set(description, true);
                  constantActions.push({
                    description,
                    name: "constant_scope_" + i
                  });
                }
              }
              i++;
            }
            var infos = [];
            if (constantActions.length) {
              infos.push({
                name: refactorName,
                description: ts2.getLocaleSpecificMessage(ts2.Diagnostics.Extract_constant),
                actions: constantActions
              });
            }
            if (functionActions.length) {
              infos.push({
                name: refactorName,
                description: ts2.getLocaleSpecificMessage(ts2.Diagnostics.Extract_function),
                actions: functionActions
              });
            }
            return infos.length ? infos : ts2.emptyArray;
          }
          extractSymbol2.getAvailableActions = getAvailableActions;
          function getEditsForAction(context, actionName) {
            var rangeToExtract = getRangeToExtract(context.file, ts2.getRefactorContextSpan(context));
            var targetRange = rangeToExtract.targetRange;
            var parsedFunctionIndexMatch = /^function_scope_(\d+)$/.exec(actionName);
            if (parsedFunctionIndexMatch) {
              var index = +parsedFunctionIndexMatch[1];
              ts2.Debug.assert(isFinite(index), "Expected to parse a finite number from the function scope index");
              return getFunctionExtractionAtIndex(targetRange, context, index);
            }
            var parsedConstantIndexMatch = /^constant_scope_(\d+)$/.exec(actionName);
            if (parsedConstantIndexMatch) {
              var index = +parsedConstantIndexMatch[1];
              ts2.Debug.assert(isFinite(index), "Expected to parse a finite number from the constant scope index");
              return getConstantExtractionAtIndex(targetRange, context, index);
            }
            ts2.Debug.fail("Unrecognized action name");
          }
          extractSymbol2.getEditsForAction = getEditsForAction;
          var Messages;
          (function(Messages2) {
            function createMessage(message) {
              return { message, code: 0, category: ts2.DiagnosticCategory.Message, key: message };
            }
            Messages2.cannotExtractRange = createMessage("Cannot extract range.");
            Messages2.cannotExtractImport = createMessage("Cannot extract import statement.");
            Messages2.cannotExtractSuper = createMessage("Cannot extract super call.");
            Messages2.cannotExtractJSDoc = createMessage("Cannot extract JSDoc.");
            Messages2.cannotExtractEmpty = createMessage("Cannot extract empty range.");
            Messages2.expressionExpected = createMessage("expression expected.");
            Messages2.uselessConstantType = createMessage("No reason to extract constant of type.");
            Messages2.statementOrExpressionExpected = createMessage("Statement or expression expected.");
            Messages2.cannotExtractRangeContainingConditionalBreakOrContinueStatements = createMessage("Cannot extract range containing conditional break or continue statements.");
            Messages2.cannotExtractRangeContainingConditionalReturnStatement = createMessage("Cannot extract range containing conditional return statement.");
            Messages2.cannotExtractRangeContainingLabeledBreakOrContinueStatementWithTargetOutsideOfTheRange = createMessage("Cannot extract range containing labeled break or continue with target outside of the range.");
            Messages2.cannotExtractRangeThatContainsWritesToReferencesLocatedOutsideOfTheTargetRangeInGenerators = createMessage("Cannot extract range containing writes to references located outside of the target range in generators.");
            Messages2.typeWillNotBeVisibleInTheNewScope = createMessage("Type will not visible in the new scope.");
            Messages2.functionWillNotBeVisibleInTheNewScope = createMessage("Function will not visible in the new scope.");
            Messages2.cannotExtractIdentifier = createMessage("Select more than a single identifier.");
            Messages2.cannotExtractExportedEntity = createMessage("Cannot extract exported declaration");
            Messages2.cannotWriteInExpression = createMessage("Cannot write back side-effects when extracting an expression");
            Messages2.cannotExtractReadonlyPropertyInitializerOutsideConstructor = createMessage("Cannot move initialization of read-only class property outside of the constructor");
            Messages2.cannotExtractAmbientBlock = createMessage("Cannot extract code from ambient contexts");
            Messages2.cannotAccessVariablesFromNestedScopes = createMessage("Cannot access variables from nested scopes");
            Messages2.cannotExtractToOtherFunctionLike = createMessage("Cannot extract method to a function-like scope that is not a function");
            Messages2.cannotExtractToJSClass = createMessage("Cannot extract constant to a class scope in JS");
            Messages2.cannotExtractToExpressionArrowFunction = createMessage("Cannot extract constant to an arrow function without a block");
          })(Messages = extractSymbol2.Messages || (extractSymbol2.Messages = {}));
          var RangeFacts;
          (function(RangeFacts2) {
            RangeFacts2[RangeFacts2["None"] = 0] = "None";
            RangeFacts2[RangeFacts2["HasReturn"] = 1] = "HasReturn";
            RangeFacts2[RangeFacts2["IsGenerator"] = 2] = "IsGenerator";
            RangeFacts2[RangeFacts2["IsAsyncFunction"] = 4] = "IsAsyncFunction";
            RangeFacts2[RangeFacts2["UsesThis"] = 8] = "UsesThis";
            RangeFacts2[RangeFacts2["InStaticRegion"] = 16] = "InStaticRegion";
          })(RangeFacts || (RangeFacts = {}));
          function getRangeToExtract(sourceFile, span) {
            var length = span.length;
            if (length === 0) {
              return { errors: [ts2.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractEmpty)] };
            }
            var start = ts2.getParentNodeInSpan(ts2.getTokenAtPosition(sourceFile, span.start), sourceFile, span);
            var end = ts2.getParentNodeInSpan(ts2.findTokenOnLeftOfPosition(sourceFile, ts2.textSpanEnd(span)), sourceFile, span);
            var declarations = [];
            var rangeFacts = RangeFacts.None;
            if (!start || !end) {
              return { errors: [ts2.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractRange)] };
            }
            if (start.parent !== end.parent) {
              return { errors: [ts2.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractRange)] };
            }
            if (start !== end) {
              if (!isBlockLike(start.parent)) {
                return { errors: [ts2.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractRange)] };
              }
              var statements = [];
              var start2 = start;
              for (var _i = 0, _a = start2.parent.statements; _i < _a.length; _i++) {
                var statement = _a[_i];
                if (statement === start || statements.length) {
                  var errors_1 = checkNode(statement);
                  if (errors_1) {
                    return { errors: errors_1 };
                  }
                  statements.push(statement);
                }
                if (statement === end) {
                  break;
                }
              }
              if (!statements.length) {
                return { errors: [ts2.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractRange)] };
              }
              return { targetRange: { range: statements, facts: rangeFacts, declarations } };
            }
            if (ts2.isJSDoc(start)) {
              return { errors: [ts2.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractJSDoc)] };
            }
            if (ts2.isReturnStatement(start) && !start.expression) {
              return { errors: [ts2.createFileDiagnostic(sourceFile, span.start, length, Messages.cannotExtractRange)] };
            }
            var node = refineNode(start);
            var errors = checkRootNode(node) || checkNode(node);
            if (errors) {
              return { errors };
            }
            return { targetRange: { range: getStatementOrExpressionRange(node), facts: rangeFacts, declarations } };
            function refineNode(node2) {
              if (ts2.isReturnStatement(node2)) {
                if (node2.expression) {
                  return node2.expression;
                }
              } else if (ts2.isVariableStatement(node2)) {
                var numInitializers = 0;
                var lastInitializer = void 0;
                for (var _i2 = 0, _a2 = node2.declarationList.declarations; _i2 < _a2.length; _i2++) {
                  var declaration = _a2[_i2];
                  if (declaration.initializer) {
                    numInitializers++;
                    lastInitializer = declaration.initializer;
                  }
                }
                if (numInitializers === 1) {
                  return lastInitializer;
                }
              } else if (ts2.isVariableDeclaration(node2)) {
                if (node2.initializer) {
                  return node2.initializer;
                }
              }
              return node2;
            }
            function checkRootNode(node2) {
              if (ts2.isIdentifier(ts2.isExpressionStatement(node2) ? node2.expression : node2)) {
                return [ts2.createDiagnosticForNode(node2, Messages.cannotExtractIdentifier)];
              }
              return void 0;
            }
            function checkForStaticContext(nodeToCheck, containingClass) {
              var current = nodeToCheck;
              while (current !== containingClass) {
                if (current.kind === 159) {
                  if (ts2.hasModifier(current, 32)) {
                    rangeFacts |= RangeFacts.InStaticRegion;
                  }
                  break;
                } else if (current.kind === 156) {
                  var ctorOrMethod = ts2.getContainingFunction(current);
                  if (ctorOrMethod.kind === 162) {
                    rangeFacts |= RangeFacts.InStaticRegion;
                  }
                  break;
                } else if (current.kind === 161) {
                  if (ts2.hasModifier(current, 32)) {
                    rangeFacts |= RangeFacts.InStaticRegion;
                  }
                }
                current = current.parent;
              }
            }
            function checkNode(nodeToCheck) {
              var PermittedJumps;
              (function(PermittedJumps2) {
                PermittedJumps2[PermittedJumps2["None"] = 0] = "None";
                PermittedJumps2[PermittedJumps2["Break"] = 1] = "Break";
                PermittedJumps2[PermittedJumps2["Continue"] = 2] = "Continue";
                PermittedJumps2[PermittedJumps2["Return"] = 4] = "Return";
              })(PermittedJumps || (PermittedJumps = {}));
              ts2.Debug.assert(nodeToCheck.pos <= nodeToCheck.end, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809 (1)");
              ts2.Debug.assert(!ts2.positionIsSynthesized(nodeToCheck.pos), "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809 (2)");
              if (!ts2.isStatement(nodeToCheck) && !(ts2.isExpressionNode(nodeToCheck) && isExtractableExpression(nodeToCheck))) {
                return [ts2.createDiagnosticForNode(nodeToCheck, Messages.statementOrExpressionExpected)];
              }
              if (nodeToCheck.flags & 8388608) {
                return [ts2.createDiagnosticForNode(nodeToCheck, Messages.cannotExtractAmbientBlock)];
              }
              var containingClass = ts2.getContainingClass(nodeToCheck);
              if (containingClass) {
                checkForStaticContext(nodeToCheck, containingClass);
              }
              var errors2;
              var permittedJumps = 4;
              var seenLabels;
              visit(nodeToCheck);
              return errors2;
              function visit(node2) {
                if (errors2) {
                  return true;
                }
                if (ts2.isDeclaration(node2)) {
                  var declaringNode = node2.kind === 242 ? node2.parent.parent : node2;
                  if (ts2.hasModifier(declaringNode, 1)) {
                    (errors2 || (errors2 = [])).push(ts2.createDiagnosticForNode(node2, Messages.cannotExtractExportedEntity));
                    return true;
                  }
                  declarations.push(node2.symbol);
                }
                switch (node2.kind) {
                  case 254:
                    (errors2 || (errors2 = [])).push(ts2.createDiagnosticForNode(node2, Messages.cannotExtractImport));
                    return true;
                  case 102:
                    if (node2.parent.kind === 196) {
                      var containingClass_1 = ts2.getContainingClass(node2);
                      if (containingClass_1.pos < span.start || containingClass_1.end >= span.start + span.length) {
                        (errors2 || (errors2 = [])).push(ts2.createDiagnosticForNode(node2, Messages.cannotExtractSuper));
                        return true;
                      }
                    } else {
                      rangeFacts |= RangeFacts.UsesThis;
                    }
                    break;
                }
                if (ts2.isFunctionLikeDeclaration(node2) || ts2.isClassLike(node2)) {
                  switch (node2.kind) {
                    case 244:
                    case 245:
                      if (ts2.isSourceFile(node2.parent) && node2.parent.externalModuleIndicator === void 0) {
                        (errors2 || (errors2 = [])).push(ts2.createDiagnosticForNode(node2, Messages.functionWillNotBeVisibleInTheNewScope));
                      }
                      break;
                  }
                  return false;
                }
                var savedPermittedJumps = permittedJumps;
                switch (node2.kind) {
                  case 227:
                    permittedJumps = 0;
                    break;
                  case 240:
                    permittedJumps = 0;
                    break;
                  case 223:
                    if (node2.parent && node2.parent.kind === 240 && node2.parent.finallyBlock === node2) {
                      permittedJumps = 4;
                    }
                    break;
                  case 278:
                  case 277:
                    permittedJumps |= 1;
                    break;
                  default:
                    if (ts2.isIterationStatement(node2, false)) {
                      permittedJumps |= 1 | 2;
                    }
                    break;
                }
                switch (node2.kind) {
                  case 183:
                  case 104:
                    rangeFacts |= RangeFacts.UsesThis;
                    break;
                  case 238: {
                    var label = node2.label;
                    (seenLabels || (seenLabels = [])).push(label.escapedText);
                    ts2.forEachChild(node2, visit);
                    seenLabels.pop();
                    break;
                  }
                  case 234:
                  case 233: {
                    var label = node2.label;
                    if (label) {
                      if (!ts2.contains(seenLabels, label.escapedText)) {
                        (errors2 || (errors2 = [])).push(ts2.createDiagnosticForNode(node2, Messages.cannotExtractRangeContainingLabeledBreakOrContinueStatementWithTargetOutsideOfTheRange));
                      }
                    } else {
                      if (!(permittedJumps & (node2.kind === 234 ? 1 : 2))) {
                        (errors2 || (errors2 = [])).push(ts2.createDiagnosticForNode(node2, Messages.cannotExtractRangeContainingConditionalBreakOrContinueStatements));
                      }
                    }
                    break;
                  }
                  case 206:
                    rangeFacts |= RangeFacts.IsAsyncFunction;
                    break;
                  case 212:
                    rangeFacts |= RangeFacts.IsGenerator;
                    break;
                  case 235:
                    if (permittedJumps & 4) {
                      rangeFacts |= RangeFacts.HasReturn;
                    } else {
                      (errors2 || (errors2 = [])).push(ts2.createDiagnosticForNode(node2, Messages.cannotExtractRangeContainingConditionalReturnStatement));
                    }
                    break;
                  default:
                    ts2.forEachChild(node2, visit);
                    break;
                }
                permittedJumps = savedPermittedJumps;
              }
            }
          }
          extractSymbol2.getRangeToExtract = getRangeToExtract;
          function getStatementOrExpressionRange(node) {
            if (ts2.isStatement(node)) {
              return [node];
            } else if (ts2.isExpressionNode(node)) {
              return ts2.isExpressionStatement(node.parent) ? [node.parent] : node;
            }
            return void 0;
          }
          function isScope(node) {
            return ts2.isFunctionLikeDeclaration(node) || ts2.isSourceFile(node) || ts2.isModuleBlock(node) || ts2.isClassLike(node);
          }
          function collectEnclosingScopes(range) {
            var current = isReadonlyArray(range.range) ? ts2.first(range.range) : range.range;
            if (range.facts & RangeFacts.UsesThis) {
              var containingClass = ts2.getContainingClass(current);
              if (containingClass) {
                var containingFunction = ts2.findAncestor(current, ts2.isFunctionLikeDeclaration);
                return containingFunction ? [containingFunction, containingClass] : [containingClass];
              }
            }
            var scopes = [];
            while (true) {
              current = current.parent;
              if (current.kind === 156) {
                current = ts2.findAncestor(current, function(parent) {
                  return ts2.isFunctionLikeDeclaration(parent);
                }).parent;
              }
              if (isScope(current)) {
                scopes.push(current);
                if (current.kind === 290) {
                  return scopes;
                }
              }
            }
          }
          function getFunctionExtractionAtIndex(targetRange, context, requestedChangesIndex) {
            var _a = getPossibleExtractionsWorker(targetRange, context), scopes = _a.scopes, _b = _a.readsAndWrites, target = _b.target, usagesPerScope = _b.usagesPerScope, functionErrorsPerScope = _b.functionErrorsPerScope, exposedVariableDeclarations = _b.exposedVariableDeclarations;
            ts2.Debug.assert(!functionErrorsPerScope[requestedChangesIndex].length, "The extraction went missing? How?");
            context.cancellationToken.throwIfCancellationRequested();
            return extractFunctionInScope(target, scopes[requestedChangesIndex], usagesPerScope[requestedChangesIndex], exposedVariableDeclarations, targetRange, context);
          }
          function getConstantExtractionAtIndex(targetRange, context, requestedChangesIndex) {
            var _a = getPossibleExtractionsWorker(targetRange, context), scopes = _a.scopes, _b = _a.readsAndWrites, target = _b.target, usagesPerScope = _b.usagesPerScope, constantErrorsPerScope = _b.constantErrorsPerScope, exposedVariableDeclarations = _b.exposedVariableDeclarations;
            ts2.Debug.assert(!constantErrorsPerScope[requestedChangesIndex].length, "The extraction went missing? How?");
            ts2.Debug.assert(exposedVariableDeclarations.length === 0, "Extract constant accepted a range containing a variable declaration?");
            context.cancellationToken.throwIfCancellationRequested();
            var expression = ts2.isExpression(target) ? target : target.statements[0].expression;
            return extractConstantInScope(expression, scopes[requestedChangesIndex], usagesPerScope[requestedChangesIndex], targetRange.facts, context);
          }
          function getPossibleExtractions(targetRange, context) {
            var _a = getPossibleExtractionsWorker(targetRange, context), scopes = _a.scopes, _b = _a.readsAndWrites, functionErrorsPerScope = _b.functionErrorsPerScope, constantErrorsPerScope = _b.constantErrorsPerScope;
            var extractions = scopes.map(function(scope, i) {
              var functionDescriptionPart = getDescriptionForFunctionInScope(scope);
              var constantDescriptionPart = getDescriptionForConstantInScope(scope);
              var scopeDescription = ts2.isFunctionLikeDeclaration(scope) ? getDescriptionForFunctionLikeDeclaration(scope) : ts2.isClassLike(scope) ? getDescriptionForClassLikeDeclaration(scope) : getDescriptionForModuleLikeDeclaration(scope);
              var functionDescription;
              var constantDescription;
              if (scopeDescription === 1) {
                functionDescription = ts2.formatStringFromArgs(ts2.getLocaleSpecificMessage(ts2.Diagnostics.Extract_to_0_in_1_scope), [functionDescriptionPart, "global"]);
                constantDescription = ts2.formatStringFromArgs(ts2.getLocaleSpecificMessage(ts2.Diagnostics.Extract_to_0_in_1_scope), [constantDescriptionPart, "global"]);
              } else if (scopeDescription === 0) {
                functionDescription = ts2.formatStringFromArgs(ts2.getLocaleSpecificMessage(ts2.Diagnostics.Extract_to_0_in_1_scope), [functionDescriptionPart, "module"]);
                constantDescription = ts2.formatStringFromArgs(ts2.getLocaleSpecificMessage(ts2.Diagnostics.Extract_to_0_in_1_scope), [constantDescriptionPart, "module"]);
              } else {
                functionDescription = ts2.formatStringFromArgs(ts2.getLocaleSpecificMessage(ts2.Diagnostics.Extract_to_0_in_1), [functionDescriptionPart, scopeDescription]);
                constantDescription = ts2.formatStringFromArgs(ts2.getLocaleSpecificMessage(ts2.Diagnostics.Extract_to_0_in_1), [constantDescriptionPart, scopeDescription]);
              }
              if (i === 0 && !ts2.isClassLike(scope)) {
                constantDescription = ts2.formatStringFromArgs(ts2.getLocaleSpecificMessage(ts2.Diagnostics.Extract_to_0_in_enclosing_scope), [constantDescriptionPart]);
              }
              return {
                functionExtraction: {
                  description: functionDescription,
                  errors: functionErrorsPerScope[i]
                },
                constantExtraction: {
                  description: constantDescription,
                  errors: constantErrorsPerScope[i]
                }
              };
            });
            return extractions;
          }
          function getPossibleExtractionsWorker(targetRange, context) {
            var sourceFile = context.file;
            var scopes = collectEnclosingScopes(targetRange);
            var enclosingTextRange = getEnclosingTextRange(targetRange, sourceFile);
            var readsAndWrites = collectReadsAndWrites(targetRange, scopes, enclosingTextRange, sourceFile, context.program.getTypeChecker(), context.cancellationToken);
            return { scopes, readsAndWrites };
          }
          function getDescriptionForFunctionInScope(scope) {
            return ts2.isFunctionLikeDeclaration(scope) ? "inner function" : ts2.isClassLike(scope) ? "method" : "function";
          }
          function getDescriptionForConstantInScope(scope) {
            return ts2.isClassLike(scope) ? "readonly field" : "constant";
          }
          function getDescriptionForFunctionLikeDeclaration(scope) {
            switch (scope.kind) {
              case 162:
                return "constructor";
              case 201:
              case 244:
                return scope.name ? "function '" + scope.name.text + "'" : ts2.ANONYMOUS;
              case 202:
                return "arrow function";
              case 161:
                return "method '" + scope.name.getText() + "'";
              case 163:
                return "'get " + scope.name.getText() + "'";
              case 164:
                return "'set " + scope.name.getText() + "'";
              default:
                throw ts2.Debug.assertNever(scope, "Unexpected scope kind " + scope.kind);
            }
          }
          function getDescriptionForClassLikeDeclaration(scope) {
            return scope.kind === 245 ? scope.name ? "class '" + scope.name.text + "'" : "anonymous class declaration" : scope.name ? "class expression '" + scope.name.text + "'" : "anonymous class expression";
          }
          function getDescriptionForModuleLikeDeclaration(scope) {
            return scope.kind === 250 ? "namespace '" + scope.parent.name.getText() + "'" : scope.externalModuleIndicator ? 0 : 1;
          }
          var SpecialScope;
          (function(SpecialScope2) {
            SpecialScope2[SpecialScope2["Module"] = 0] = "Module";
            SpecialScope2[SpecialScope2["Global"] = 1] = "Global";
          })(SpecialScope || (SpecialScope = {}));
          function extractFunctionInScope(node, scope, _a, exposedVariableDeclarations, range, context) {
            var usagesInScope = _a.usages, typeParameterUsages = _a.typeParameterUsages, substitutions = _a.substitutions;
            var checker = context.program.getTypeChecker();
            var scriptTarget = ts2.getEmitScriptTarget(context.program.getCompilerOptions());
            var importAdder = ts2.codefix.createImportAdder(context.file, context.program, context.preferences, context.host);
            var file = scope.getSourceFile();
            var functionNameText = ts2.getUniqueName(ts2.isClassLike(scope) ? "newMethod" : "newFunction", file);
            var isJS = ts2.isInJSFile(scope);
            var functionName = ts2.createIdentifier(functionNameText);
            var returnType;
            var parameters = [];
            var callArguments = [];
            var writes;
            usagesInScope.forEach(function(usage, name) {
              var typeNode;
              if (!isJS) {
                var type = checker.getTypeOfSymbolAtLocation(usage.symbol, usage.node);
                type = checker.getBaseTypeOfLiteralType(type);
                typeNode = ts2.codefix.typeToAutoImportableTypeNode(checker, importAdder, type, scope, scriptTarget, 1);
              }
              var paramDecl = ts2.createParameter(void 0, void 0, void 0, name, void 0, typeNode);
              parameters.push(paramDecl);
              if (usage.usage === 2) {
                (writes || (writes = [])).push(usage);
              }
              callArguments.push(ts2.createIdentifier(name));
            });
            var typeParametersAndDeclarations = ts2.arrayFrom(typeParameterUsages.values()).map(function(type) {
              return { type, declaration: getFirstDeclaration(type) };
            });
            var sortedTypeParametersAndDeclarations = typeParametersAndDeclarations.sort(compareTypesByDeclarationOrder);
            var typeParameters = sortedTypeParametersAndDeclarations.length === 0 ? void 0 : sortedTypeParametersAndDeclarations.map(function(t) {
              return t.declaration;
            });
            var callTypeArguments = typeParameters !== void 0 ? typeParameters.map(function(decl) {
              return ts2.createTypeReferenceNode(decl.name, void 0);
            }) : void 0;
            if (ts2.isExpression(node) && !isJS) {
              var contextualType = checker.getContextualType(node);
              returnType = checker.typeToTypeNode(contextualType, scope, 1);
            }
            var _b = transformFunctionBody(node, exposedVariableDeclarations, writes, substitutions, !!(range.facts & RangeFacts.HasReturn)), body = _b.body, returnValueProperty = _b.returnValueProperty;
            ts2.suppressLeadingAndTrailingTrivia(body);
            var newFunction;
            if (ts2.isClassLike(scope)) {
              var modifiers = isJS ? [] : [ts2.createToken(117)];
              if (range.facts & RangeFacts.InStaticRegion) {
                modifiers.push(ts2.createToken(120));
              }
              if (range.facts & RangeFacts.IsAsyncFunction) {
                modifiers.push(ts2.createToken(126));
              }
              newFunction = ts2.createMethod(void 0, modifiers.length ? modifiers : void 0, range.facts & RangeFacts.IsGenerator ? ts2.createToken(41) : void 0, functionName, void 0, typeParameters, parameters, returnType, body);
            } else {
              newFunction = ts2.createFunctionDeclaration(void 0, range.facts & RangeFacts.IsAsyncFunction ? [ts2.createToken(126)] : void 0, range.facts & RangeFacts.IsGenerator ? ts2.createToken(41) : void 0, functionName, typeParameters, parameters, returnType, body);
            }
            var changeTracker = ts2.textChanges.ChangeTracker.fromContext(context);
            var minInsertionPos = (isReadonlyArray(range.range) ? ts2.last(range.range) : range.range).end;
            var nodeToInsertBefore = getNodeToInsertFunctionBefore(minInsertionPos, scope);
            if (nodeToInsertBefore) {
              changeTracker.insertNodeBefore(context.file, nodeToInsertBefore, newFunction, true);
            } else {
              changeTracker.insertNodeAtEndOfScope(context.file, scope, newFunction);
            }
            importAdder.writeFixes(changeTracker);
            var newNodes = [];
            var called = getCalledExpression(scope, range, functionNameText);
            var call = ts2.createCall(called, callTypeArguments, callArguments);
            if (range.facts & RangeFacts.IsGenerator) {
              call = ts2.createYield(ts2.createToken(41), call);
            }
            if (range.facts & RangeFacts.IsAsyncFunction) {
              call = ts2.createAwait(call);
            }
            if (exposedVariableDeclarations.length && !writes) {
              ts2.Debug.assert(!returnValueProperty, "Expected no returnValueProperty");
              ts2.Debug.assert(!(range.facts & RangeFacts.HasReturn), "Expected RangeFacts.HasReturn flag to be unset");
              if (exposedVariableDeclarations.length === 1) {
                var variableDeclaration = exposedVariableDeclarations[0];
                newNodes.push(ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([ts2.createVariableDeclaration(ts2.getSynthesizedDeepClone(variableDeclaration.name), ts2.getSynthesizedDeepClone(variableDeclaration.type), call)], variableDeclaration.parent.flags)));
              } else {
                var bindingElements = [];
                var typeElements = [];
                var commonNodeFlags = exposedVariableDeclarations[0].parent.flags;
                var sawExplicitType = false;
                for (var _i = 0, exposedVariableDeclarations_1 = exposedVariableDeclarations; _i < exposedVariableDeclarations_1.length; _i++) {
                  var variableDeclaration = exposedVariableDeclarations_1[_i];
                  bindingElements.push(ts2.createBindingElement(void 0, void 0, ts2.getSynthesizedDeepClone(variableDeclaration.name)));
                  var variableType = checker.typeToTypeNode(checker.getBaseTypeOfLiteralType(checker.getTypeAtLocation(variableDeclaration)), scope, 1);
                  typeElements.push(ts2.createPropertySignature(void 0, variableDeclaration.symbol.name, void 0, variableType, void 0));
                  sawExplicitType = sawExplicitType || variableDeclaration.type !== void 0;
                  commonNodeFlags = commonNodeFlags & variableDeclaration.parent.flags;
                }
                var typeLiteral = sawExplicitType ? ts2.createTypeLiteralNode(typeElements) : void 0;
                if (typeLiteral) {
                  ts2.setEmitFlags(typeLiteral, 1);
                }
                newNodes.push(ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([ts2.createVariableDeclaration(ts2.createObjectBindingPattern(bindingElements), typeLiteral, call)], commonNodeFlags)));
              }
            } else if (exposedVariableDeclarations.length || writes) {
              if (exposedVariableDeclarations.length) {
                for (var _c = 0, exposedVariableDeclarations_2 = exposedVariableDeclarations; _c < exposedVariableDeclarations_2.length; _c++) {
                  var variableDeclaration = exposedVariableDeclarations_2[_c];
                  var flags = variableDeclaration.parent.flags;
                  if (flags & 2) {
                    flags = flags & ~2 | 1;
                  }
                  newNodes.push(ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([ts2.createVariableDeclaration(variableDeclaration.symbol.name, getTypeDeepCloneUnionUndefined(variableDeclaration.type))], flags)));
                }
              }
              if (returnValueProperty) {
                newNodes.push(ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([ts2.createVariableDeclaration(returnValueProperty, getTypeDeepCloneUnionUndefined(returnType))], 1)));
              }
              var assignments = getPropertyAssignmentsForWritesAndVariableDeclarations(exposedVariableDeclarations, writes);
              if (returnValueProperty) {
                assignments.unshift(ts2.createShorthandPropertyAssignment(returnValueProperty));
              }
              if (assignments.length === 1) {
                ts2.Debug.assert(!returnValueProperty, "Shouldn't have returnValueProperty here");
                newNodes.push(ts2.createStatement(ts2.createAssignment(assignments[0].name, call)));
                if (range.facts & RangeFacts.HasReturn) {
                  newNodes.push(ts2.createReturn());
                }
              } else {
                newNodes.push(ts2.createStatement(ts2.createAssignment(ts2.createObjectLiteral(assignments), call)));
                if (returnValueProperty) {
                  newNodes.push(ts2.createReturn(ts2.createIdentifier(returnValueProperty)));
                }
              }
            } else {
              if (range.facts & RangeFacts.HasReturn) {
                newNodes.push(ts2.createReturn(call));
              } else if (isReadonlyArray(range.range)) {
                newNodes.push(ts2.createStatement(call));
              } else {
                newNodes.push(call);
              }
            }
            if (isReadonlyArray(range.range)) {
              changeTracker.replaceNodeRangeWithNodes(context.file, ts2.first(range.range), ts2.last(range.range), newNodes);
            } else {
              changeTracker.replaceNodeWithNodes(context.file, range.range, newNodes);
            }
            var edits = changeTracker.getChanges();
            var renameRange = isReadonlyArray(range.range) ? ts2.first(range.range) : range.range;
            var renameFilename = renameRange.getSourceFile().fileName;
            var renameLocation = ts2.getRenameLocation(edits, renameFilename, functionNameText, false);
            return { renameFilename, renameLocation, edits };
            function getTypeDeepCloneUnionUndefined(typeNode) {
              if (typeNode === void 0) {
                return void 0;
              }
              var clone = ts2.getSynthesizedDeepClone(typeNode);
              var withoutParens = clone;
              while (ts2.isParenthesizedTypeNode(withoutParens)) {
                withoutParens = withoutParens.type;
              }
              return ts2.isUnionTypeNode(withoutParens) && ts2.find(withoutParens.types, function(t) {
                return t.kind === 146;
              }) ? clone : ts2.createUnionTypeNode([clone, ts2.createKeywordTypeNode(146)]);
            }
          }
          function extractConstantInScope(node, scope, _a, rangeFacts, context) {
            var _b;
            var substitutions = _a.substitutions;
            var checker = context.program.getTypeChecker();
            var file = scope.getSourceFile();
            var localNameText = ts2.getUniqueName(ts2.isClassLike(scope) ? "newProperty" : "newLocal", file);
            var isJS = ts2.isInJSFile(scope);
            var variableType = isJS || !checker.isContextSensitive(node) ? void 0 : checker.typeToTypeNode(checker.getContextualType(node), scope, 1);
            var initializer = transformConstantInitializer(node, substitutions);
            _b = transformFunctionInitializerAndType(variableType, initializer), variableType = _b.variableType, initializer = _b.initializer;
            ts2.suppressLeadingAndTrailingTrivia(initializer);
            var changeTracker = ts2.textChanges.ChangeTracker.fromContext(context);
            if (ts2.isClassLike(scope)) {
              ts2.Debug.assert(!isJS, "Cannot extract to a JS class");
              var modifiers = [];
              modifiers.push(ts2.createToken(117));
              if (rangeFacts & RangeFacts.InStaticRegion) {
                modifiers.push(ts2.createToken(120));
              }
              modifiers.push(ts2.createToken(138));
              var newVariable = ts2.createProperty(void 0, modifiers, localNameText, void 0, variableType, initializer);
              var localReference = ts2.createPropertyAccess(rangeFacts & RangeFacts.InStaticRegion ? ts2.createIdentifier(scope.name.getText()) : ts2.createThis(), ts2.createIdentifier(localNameText));
              var maxInsertionPos = node.pos;
              var nodeToInsertBefore = getNodeToInsertPropertyBefore(maxInsertionPos, scope);
              changeTracker.insertNodeBefore(context.file, nodeToInsertBefore, newVariable, true);
              changeTracker.replaceNode(context.file, node, localReference);
            } else {
              var newVariableDeclaration = ts2.createVariableDeclaration(localNameText, variableType, initializer);
              var oldVariableDeclaration = getContainingVariableDeclarationIfInList(node, scope);
              if (oldVariableDeclaration) {
                changeTracker.insertNodeBefore(context.file, oldVariableDeclaration, newVariableDeclaration);
                var localReference = ts2.createIdentifier(localNameText);
                changeTracker.replaceNode(context.file, node, localReference);
              } else if (node.parent.kind === 226 && scope === ts2.findAncestor(node, isScope)) {
                var newVariableStatement = ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([newVariableDeclaration], 2));
                changeTracker.replaceNode(context.file, node.parent, newVariableStatement);
              } else {
                var newVariableStatement = ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([newVariableDeclaration], 2));
                var nodeToInsertBefore = getNodeToInsertConstantBefore(node, scope);
                if (nodeToInsertBefore.pos === 0) {
                  changeTracker.insertNodeAtTopOfFile(context.file, newVariableStatement, false);
                } else {
                  changeTracker.insertNodeBefore(context.file, nodeToInsertBefore, newVariableStatement, false);
                }
                if (node.parent.kind === 226) {
                  changeTracker.delete(context.file, node.parent);
                } else {
                  var localReference = ts2.createIdentifier(localNameText);
                  changeTracker.replaceNode(context.file, node, localReference);
                }
              }
            }
            var edits = changeTracker.getChanges();
            var renameFilename = node.getSourceFile().fileName;
            var renameLocation = ts2.getRenameLocation(edits, renameFilename, localNameText, true);
            return { renameFilename, renameLocation, edits };
            function transformFunctionInitializerAndType(variableType2, initializer2) {
              if (variableType2 === void 0)
                return { variableType: variableType2, initializer: initializer2 };
              if (!ts2.isFunctionExpression(initializer2) && !ts2.isArrowFunction(initializer2) || !!initializer2.typeParameters)
                return { variableType: variableType2, initializer: initializer2 };
              var functionType = checker.getTypeAtLocation(node);
              var functionSignature = ts2.singleOrUndefined(checker.getSignaturesOfType(functionType, 0));
              if (!functionSignature)
                return { variableType: variableType2, initializer: initializer2 };
              if (!!functionSignature.getTypeParameters())
                return { variableType: variableType2, initializer: initializer2 };
              var parameters = [];
              var hasAny = false;
              for (var _i = 0, _a2 = initializer2.parameters; _i < _a2.length; _i++) {
                var p = _a2[_i];
                if (p.type) {
                  parameters.push(p);
                } else {
                  var paramType = checker.getTypeAtLocation(p);
                  if (paramType === checker.getAnyType())
                    hasAny = true;
                  parameters.push(ts2.updateParameter(p, p.decorators, p.modifiers, p.dotDotDotToken, p.name, p.questionToken, p.type || checker.typeToTypeNode(paramType, scope, 1), p.initializer));
                }
              }
              if (hasAny)
                return { variableType: variableType2, initializer: initializer2 };
              variableType2 = void 0;
              if (ts2.isArrowFunction(initializer2)) {
                initializer2 = ts2.updateArrowFunction(initializer2, node.modifiers, initializer2.typeParameters, parameters, initializer2.type || checker.typeToTypeNode(functionSignature.getReturnType(), scope, 1), initializer2.equalsGreaterThanToken, initializer2.body);
              } else {
                if (functionSignature && !!functionSignature.thisParameter) {
                  var firstParameter = ts2.firstOrUndefined(parameters);
                  if (!firstParameter || ts2.isIdentifier(firstParameter.name) && firstParameter.name.escapedText !== "this") {
                    var thisType = checker.getTypeOfSymbolAtLocation(functionSignature.thisParameter, node);
                    parameters.splice(0, 0, ts2.createParameter(void 0, void 0, void 0, "this", void 0, checker.typeToTypeNode(thisType, scope, 1)));
                  }
                }
                initializer2 = ts2.updateFunctionExpression(initializer2, node.modifiers, initializer2.asteriskToken, initializer2.name, initializer2.typeParameters, parameters, initializer2.type || checker.typeToTypeNode(functionSignature.getReturnType(), scope, 1), initializer2.body);
              }
              return { variableType: variableType2, initializer: initializer2 };
            }
          }
          function getContainingVariableDeclarationIfInList(node, scope) {
            var prevNode;
            while (node !== void 0 && node !== scope) {
              if (ts2.isVariableDeclaration(node) && node.initializer === prevNode && ts2.isVariableDeclarationList(node.parent) && node.parent.declarations.length > 1) {
                return node;
              }
              prevNode = node;
              node = node.parent;
            }
          }
          function getFirstDeclaration(type) {
            var firstDeclaration;
            var symbol = type.symbol;
            if (symbol && symbol.declarations) {
              for (var _i = 0, _a = symbol.declarations; _i < _a.length; _i++) {
                var declaration = _a[_i];
                if (firstDeclaration === void 0 || declaration.pos < firstDeclaration.pos) {
                  firstDeclaration = declaration;
                }
              }
            }
            return firstDeclaration;
          }
          function compareTypesByDeclarationOrder(_a, _b) {
            var type1 = _a.type, declaration1 = _a.declaration;
            var type2 = _b.type, declaration2 = _b.declaration;
            return ts2.compareProperties(declaration1, declaration2, "pos", ts2.compareValues) || ts2.compareStringsCaseSensitive(type1.symbol ? type1.symbol.getName() : "", type2.symbol ? type2.symbol.getName() : "") || ts2.compareValues(type1.id, type2.id);
          }
          function getCalledExpression(scope, range, functionNameText) {
            var functionReference = ts2.createIdentifier(functionNameText);
            if (ts2.isClassLike(scope)) {
              var lhs = range.facts & RangeFacts.InStaticRegion ? ts2.createIdentifier(scope.name.text) : ts2.createThis();
              return ts2.createPropertyAccess(lhs, functionReference);
            } else {
              return functionReference;
            }
          }
          function transformFunctionBody(body, exposedVariableDeclarations, writes, substitutions, hasReturn) {
            var hasWritesOrVariableDeclarations = writes !== void 0 || exposedVariableDeclarations.length > 0;
            if (ts2.isBlock(body) && !hasWritesOrVariableDeclarations && substitutions.size === 0) {
              return { body: ts2.createBlock(body.statements, true), returnValueProperty: void 0 };
            }
            var returnValueProperty;
            var ignoreReturns = false;
            var statements = ts2.createNodeArray(ts2.isBlock(body) ? body.statements.slice(0) : [ts2.isStatement(body) ? body : ts2.createReturn(body)]);
            if (hasWritesOrVariableDeclarations || substitutions.size) {
              var rewrittenStatements = ts2.visitNodes(statements, visitor).slice();
              if (hasWritesOrVariableDeclarations && !hasReturn && ts2.isStatement(body)) {
                var assignments = getPropertyAssignmentsForWritesAndVariableDeclarations(exposedVariableDeclarations, writes);
                if (assignments.length === 1) {
                  rewrittenStatements.push(ts2.createReturn(assignments[0].name));
                } else {
                  rewrittenStatements.push(ts2.createReturn(ts2.createObjectLiteral(assignments)));
                }
              }
              return { body: ts2.createBlock(rewrittenStatements, true), returnValueProperty };
            } else {
              return { body: ts2.createBlock(statements, true), returnValueProperty: void 0 };
            }
            function visitor(node) {
              if (!ignoreReturns && node.kind === 235 && hasWritesOrVariableDeclarations) {
                var assignments2 = getPropertyAssignmentsForWritesAndVariableDeclarations(exposedVariableDeclarations, writes);
                if (node.expression) {
                  if (!returnValueProperty) {
                    returnValueProperty = "__return";
                  }
                  assignments2.unshift(ts2.createPropertyAssignment(returnValueProperty, ts2.visitNode(node.expression, visitor)));
                }
                if (assignments2.length === 1) {
                  return ts2.createReturn(assignments2[0].name);
                } else {
                  return ts2.createReturn(ts2.createObjectLiteral(assignments2));
                }
              } else {
                var oldIgnoreReturns = ignoreReturns;
                ignoreReturns = ignoreReturns || ts2.isFunctionLikeDeclaration(node) || ts2.isClassLike(node);
                var substitution = substitutions.get(ts2.getNodeId(node).toString());
                var result = substitution ? ts2.getSynthesizedDeepClone(substitution) : ts2.visitEachChild(node, visitor, ts2.nullTransformationContext);
                ignoreReturns = oldIgnoreReturns;
                return result;
              }
            }
          }
          function transformConstantInitializer(initializer, substitutions) {
            return substitutions.size ? visitor(initializer) : initializer;
            function visitor(node) {
              var substitution = substitutions.get(ts2.getNodeId(node).toString());
              return substitution ? ts2.getSynthesizedDeepClone(substitution) : ts2.visitEachChild(node, visitor, ts2.nullTransformationContext);
            }
          }
          function getStatementsOrClassElements(scope) {
            if (ts2.isFunctionLikeDeclaration(scope)) {
              var body = scope.body;
              if (ts2.isBlock(body)) {
                return body.statements;
              }
            } else if (ts2.isModuleBlock(scope) || ts2.isSourceFile(scope)) {
              return scope.statements;
            } else if (ts2.isClassLike(scope)) {
              return scope.members;
            } else {
              ts2.assertType(scope);
            }
            return ts2.emptyArray;
          }
          function getNodeToInsertFunctionBefore(minPos, scope) {
            return ts2.find(getStatementsOrClassElements(scope), function(child) {
              return child.pos >= minPos && ts2.isFunctionLikeDeclaration(child) && !ts2.isConstructorDeclaration(child);
            });
          }
          function getNodeToInsertPropertyBefore(maxPos, scope) {
            var members = scope.members;
            ts2.Debug.assert(members.length > 0, "Found no members");
            var prevMember;
            var allProperties = true;
            for (var _i = 0, members_1 = members; _i < members_1.length; _i++) {
              var member = members_1[_i];
              if (member.pos > maxPos) {
                return prevMember || members[0];
              }
              if (allProperties && !ts2.isPropertyDeclaration(member)) {
                if (prevMember !== void 0) {
                  return member;
                }
                allProperties = false;
              }
              prevMember = member;
            }
            if (prevMember === void 0)
              return ts2.Debug.fail();
            return prevMember;
          }
          function getNodeToInsertConstantBefore(node, scope) {
            ts2.Debug.assert(!ts2.isClassLike(scope));
            var prevScope;
            for (var curr = node; curr !== scope; curr = curr.parent) {
              if (isScope(curr)) {
                prevScope = curr;
              }
            }
            for (var curr = (prevScope || node).parent; ; curr = curr.parent) {
              if (isBlockLike(curr)) {
                var prevStatement = void 0;
                for (var _i = 0, _a = curr.statements; _i < _a.length; _i++) {
                  var statement = _a[_i];
                  if (statement.pos > node.pos) {
                    break;
                  }
                  prevStatement = statement;
                }
                if (!prevStatement && ts2.isCaseClause(curr)) {
                  ts2.Debug.assert(ts2.isSwitchStatement(curr.parent.parent), "Grandparent isn't a switch statement");
                  return curr.parent.parent;
                }
                return ts2.Debug.checkDefined(prevStatement, "prevStatement failed to get set");
              }
              ts2.Debug.assert(curr !== scope, "Didn't encounter a block-like before encountering scope");
            }
          }
          function getPropertyAssignmentsForWritesAndVariableDeclarations(exposedVariableDeclarations, writes) {
            var variableAssignments = ts2.map(exposedVariableDeclarations, function(v) {
              return ts2.createShorthandPropertyAssignment(v.symbol.name);
            });
            var writeAssignments = ts2.map(writes, function(w) {
              return ts2.createShorthandPropertyAssignment(w.symbol.name);
            });
            return variableAssignments === void 0 ? writeAssignments : writeAssignments === void 0 ? variableAssignments : variableAssignments.concat(writeAssignments);
          }
          function isReadonlyArray(v) {
            return ts2.isArray(v);
          }
          function getEnclosingTextRange(targetRange, sourceFile) {
            return isReadonlyArray(targetRange.range) ? { pos: ts2.first(targetRange.range).getStart(sourceFile), end: ts2.last(targetRange.range).getEnd() } : targetRange.range;
          }
          var Usage;
          (function(Usage2) {
            Usage2[Usage2["Read"] = 1] = "Read";
            Usage2[Usage2["Write"] = 2] = "Write";
          })(Usage || (Usage = {}));
          function collectReadsAndWrites(targetRange, scopes, enclosingTextRange, sourceFile, checker, cancellationToken) {
            var allTypeParameterUsages = ts2.createMap();
            var usagesPerScope = [];
            var substitutionsPerScope = [];
            var functionErrorsPerScope = [];
            var constantErrorsPerScope = [];
            var visibleDeclarationsInExtractedRange = [];
            var exposedVariableSymbolSet = ts2.createMap();
            var exposedVariableDeclarations = [];
            var firstExposedNonVariableDeclaration;
            var expression = !isReadonlyArray(targetRange.range) ? targetRange.range : targetRange.range.length === 1 && ts2.isExpressionStatement(targetRange.range[0]) ? targetRange.range[0].expression : void 0;
            var expressionDiagnostic;
            if (expression === void 0) {
              var statements = targetRange.range;
              var start = ts2.first(statements).getStart();
              var end = ts2.last(statements).end;
              expressionDiagnostic = ts2.createFileDiagnostic(sourceFile, start, end - start, Messages.expressionExpected);
            } else if (checker.getTypeAtLocation(expression).flags & (16384 | 131072)) {
              expressionDiagnostic = ts2.createDiagnosticForNode(expression, Messages.uselessConstantType);
            }
            for (var _i = 0, scopes_1 = scopes; _i < scopes_1.length; _i++) {
              var scope = scopes_1[_i];
              usagesPerScope.push({ usages: ts2.createMap(), typeParameterUsages: ts2.createMap(), substitutions: ts2.createMap() });
              substitutionsPerScope.push(ts2.createMap());
              functionErrorsPerScope.push(ts2.isFunctionLikeDeclaration(scope) && scope.kind !== 244 ? [ts2.createDiagnosticForNode(scope, Messages.cannotExtractToOtherFunctionLike)] : []);
              var constantErrors = [];
              if (expressionDiagnostic) {
                constantErrors.push(expressionDiagnostic);
              }
              if (ts2.isClassLike(scope) && ts2.isInJSFile(scope)) {
                constantErrors.push(ts2.createDiagnosticForNode(scope, Messages.cannotExtractToJSClass));
              }
              if (ts2.isArrowFunction(scope) && !ts2.isBlock(scope.body)) {
                constantErrors.push(ts2.createDiagnosticForNode(scope, Messages.cannotExtractToExpressionArrowFunction));
              }
              constantErrorsPerScope.push(constantErrors);
            }
            var seenUsages = ts2.createMap();
            var target = isReadonlyArray(targetRange.range) ? ts2.createBlock(targetRange.range) : targetRange.range;
            var unmodifiedNode = isReadonlyArray(targetRange.range) ? ts2.first(targetRange.range) : targetRange.range;
            var inGenericContext = isInGenericContext(unmodifiedNode);
            collectUsages(target);
            if (inGenericContext && !isReadonlyArray(targetRange.range)) {
              var contextualType = checker.getContextualType(targetRange.range);
              recordTypeParameterUsages(contextualType);
            }
            if (allTypeParameterUsages.size > 0) {
              var seenTypeParameterUsages = ts2.createMap();
              var i_1 = 0;
              for (var curr = unmodifiedNode; curr !== void 0 && i_1 < scopes.length; curr = curr.parent) {
                if (curr === scopes[i_1]) {
                  seenTypeParameterUsages.forEach(function(typeParameter2, id) {
                    usagesPerScope[i_1].typeParameterUsages.set(id, typeParameter2);
                  });
                  i_1++;
                }
                if (ts2.isDeclarationWithTypeParameters(curr)) {
                  for (var _a = 0, _b = ts2.getEffectiveTypeParameterDeclarations(curr); _a < _b.length; _a++) {
                    var typeParameterDecl = _b[_a];
                    var typeParameter = checker.getTypeAtLocation(typeParameterDecl);
                    if (allTypeParameterUsages.has(typeParameter.id.toString())) {
                      seenTypeParameterUsages.set(typeParameter.id.toString(), typeParameter);
                    }
                  }
                }
              }
              ts2.Debug.assert(i_1 === scopes.length, "Should have iterated all scopes");
            }
            if (visibleDeclarationsInExtractedRange.length) {
              var containingLexicalScopeOfExtraction = ts2.isBlockScope(scopes[0], scopes[0].parent) ? scopes[0] : ts2.getEnclosingBlockScopeContainer(scopes[0]);
              ts2.forEachChild(containingLexicalScopeOfExtraction, checkForUsedDeclarations);
            }
            var _loop_16 = function(i2) {
              var scopeUsages = usagesPerScope[i2];
              if (i2 > 0 && (scopeUsages.usages.size > 0 || scopeUsages.typeParameterUsages.size > 0)) {
                var errorNode = isReadonlyArray(targetRange.range) ? targetRange.range[0] : targetRange.range;
                constantErrorsPerScope[i2].push(ts2.createDiagnosticForNode(errorNode, Messages.cannotAccessVariablesFromNestedScopes));
              }
              var hasWrite = false;
              var readonlyClassPropertyWrite;
              usagesPerScope[i2].usages.forEach(function(value) {
                if (value.usage === 2) {
                  hasWrite = true;
                  if (value.symbol.flags & 106500 && value.symbol.valueDeclaration && ts2.hasModifier(value.symbol.valueDeclaration, 64)) {
                    readonlyClassPropertyWrite = value.symbol.valueDeclaration;
                  }
                }
              });
              ts2.Debug.assert(isReadonlyArray(targetRange.range) || exposedVariableDeclarations.length === 0, "No variable declarations expected if something was extracted");
              if (hasWrite && !isReadonlyArray(targetRange.range)) {
                var diag = ts2.createDiagnosticForNode(targetRange.range, Messages.cannotWriteInExpression);
                functionErrorsPerScope[i2].push(diag);
                constantErrorsPerScope[i2].push(diag);
              } else if (readonlyClassPropertyWrite && i2 > 0) {
                var diag = ts2.createDiagnosticForNode(readonlyClassPropertyWrite, Messages.cannotExtractReadonlyPropertyInitializerOutsideConstructor);
                functionErrorsPerScope[i2].push(diag);
                constantErrorsPerScope[i2].push(diag);
              } else if (firstExposedNonVariableDeclaration) {
                var diag = ts2.createDiagnosticForNode(firstExposedNonVariableDeclaration, Messages.cannotExtractExportedEntity);
                functionErrorsPerScope[i2].push(diag);
                constantErrorsPerScope[i2].push(diag);
              }
            };
            for (var i = 0; i < scopes.length; i++) {
              _loop_16(i);
            }
            return { target, usagesPerScope, functionErrorsPerScope, constantErrorsPerScope, exposedVariableDeclarations };
            function isInGenericContext(node) {
              return !!ts2.findAncestor(node, function(n) {
                return ts2.isDeclarationWithTypeParameters(n) && ts2.getEffectiveTypeParameterDeclarations(n).length !== 0;
              });
            }
            function recordTypeParameterUsages(type) {
              var symbolWalker = checker.getSymbolWalker(function() {
                return cancellationToken.throwIfCancellationRequested(), true;
              });
              var visitedTypes = symbolWalker.walkType(type).visitedTypes;
              for (var _i2 = 0, visitedTypes_1 = visitedTypes; _i2 < visitedTypes_1.length; _i2++) {
                var visitedType = visitedTypes_1[_i2];
                if (visitedType.isTypeParameter()) {
                  allTypeParameterUsages.set(visitedType.id.toString(), visitedType);
                }
              }
            }
            function collectUsages(node, valueUsage) {
              if (valueUsage === void 0) {
                valueUsage = 1;
              }
              if (inGenericContext) {
                var type = checker.getTypeAtLocation(node);
                recordTypeParameterUsages(type);
              }
              if (ts2.isDeclaration(node) && node.symbol) {
                visibleDeclarationsInExtractedRange.push(node);
              }
              if (ts2.isAssignmentExpression(node)) {
                collectUsages(node.left, 2);
                collectUsages(node.right);
              } else if (ts2.isUnaryExpressionWithWrite(node)) {
                collectUsages(node.operand, 2);
              } else if (ts2.isPropertyAccessExpression(node) || ts2.isElementAccessExpression(node)) {
                ts2.forEachChild(node, collectUsages);
              } else if (ts2.isIdentifier(node)) {
                if (!node.parent) {
                  return;
                }
                if (ts2.isQualifiedName(node.parent) && node !== node.parent.left) {
                  return;
                }
                if (ts2.isPropertyAccessExpression(node.parent) && node !== node.parent.expression) {
                  return;
                }
                recordUsage(node, valueUsage, ts2.isPartOfTypeNode(node));
              } else {
                ts2.forEachChild(node, collectUsages);
              }
            }
            function recordUsage(n, usage, isTypeNode) {
              var symbolId = recordUsagebySymbol(n, usage, isTypeNode);
              if (symbolId) {
                for (var i2 = 0; i2 < scopes.length; i2++) {
                  var substitution = substitutionsPerScope[i2].get(symbolId);
                  if (substitution) {
                    usagesPerScope[i2].substitutions.set(ts2.getNodeId(n).toString(), substitution);
                  }
                }
              }
            }
            function recordUsagebySymbol(identifier, usage, isTypeName) {
              var symbol = getSymbolReferencedByIdentifier(identifier);
              if (!symbol) {
                return void 0;
              }
              var symbolId = ts2.getSymbolId(symbol).toString();
              var lastUsage = seenUsages.get(symbolId);
              if (lastUsage && lastUsage >= usage) {
                return symbolId;
              }
              seenUsages.set(symbolId, usage);
              if (lastUsage) {
                for (var _i2 = 0, usagesPerScope_1 = usagesPerScope; _i2 < usagesPerScope_1.length; _i2++) {
                  var perScope = usagesPerScope_1[_i2];
                  var prevEntry = perScope.usages.get(identifier.text);
                  if (prevEntry) {
                    perScope.usages.set(identifier.text, { usage, symbol, node: identifier });
                  }
                }
                return symbolId;
              }
              var decls = symbol.getDeclarations();
              var declInFile = decls && ts2.find(decls, function(d) {
                return d.getSourceFile() === sourceFile;
              });
              if (!declInFile) {
                return void 0;
              }
              if (ts2.rangeContainsStartEnd(enclosingTextRange, declInFile.getStart(), declInFile.end)) {
                return void 0;
              }
              if (targetRange.facts & RangeFacts.IsGenerator && usage === 2) {
                var diag = ts2.createDiagnosticForNode(identifier, Messages.cannotExtractRangeThatContainsWritesToReferencesLocatedOutsideOfTheTargetRangeInGenerators);
                for (var _a2 = 0, functionErrorsPerScope_1 = functionErrorsPerScope; _a2 < functionErrorsPerScope_1.length; _a2++) {
                  var errors = functionErrorsPerScope_1[_a2];
                  errors.push(diag);
                }
                for (var _b2 = 0, constantErrorsPerScope_1 = constantErrorsPerScope; _b2 < constantErrorsPerScope_1.length; _b2++) {
                  var errors = constantErrorsPerScope_1[_b2];
                  errors.push(diag);
                }
              }
              for (var i2 = 0; i2 < scopes.length; i2++) {
                var scope2 = scopes[i2];
                var resolvedSymbol = checker.resolveName(symbol.name, scope2, symbol.flags, false);
                if (resolvedSymbol === symbol) {
                  continue;
                }
                if (!substitutionsPerScope[i2].has(symbolId)) {
                  var substitution = tryReplaceWithQualifiedNameOrPropertyAccess(symbol.exportSymbol || symbol, scope2, isTypeName);
                  if (substitution) {
                    substitutionsPerScope[i2].set(symbolId, substitution);
                  } else if (isTypeName) {
                    if (!(symbol.flags & 262144)) {
                      var diag = ts2.createDiagnosticForNode(identifier, Messages.typeWillNotBeVisibleInTheNewScope);
                      functionErrorsPerScope[i2].push(diag);
                      constantErrorsPerScope[i2].push(diag);
                    }
                  } else {
                    usagesPerScope[i2].usages.set(identifier.text, { usage, symbol, node: identifier });
                  }
                }
              }
              return symbolId;
            }
            function checkForUsedDeclarations(node) {
              if (node === targetRange.range || isReadonlyArray(targetRange.range) && targetRange.range.indexOf(node) >= 0) {
                return;
              }
              var sym = ts2.isIdentifier(node) ? getSymbolReferencedByIdentifier(node) : checker.getSymbolAtLocation(node);
              if (sym) {
                var decl = ts2.find(visibleDeclarationsInExtractedRange, function(d) {
                  return d.symbol === sym;
                });
                if (decl) {
                  if (ts2.isVariableDeclaration(decl)) {
                    var idString = decl.symbol.id.toString();
                    if (!exposedVariableSymbolSet.has(idString)) {
                      exposedVariableDeclarations.push(decl);
                      exposedVariableSymbolSet.set(idString, true);
                    }
                  } else {
                    firstExposedNonVariableDeclaration = firstExposedNonVariableDeclaration || decl;
                  }
                }
              }
              ts2.forEachChild(node, checkForUsedDeclarations);
            }
            function getSymbolReferencedByIdentifier(identifier) {
              return identifier.parent && ts2.isShorthandPropertyAssignment(identifier.parent) && identifier.parent.name === identifier ? checker.getShorthandAssignmentValueSymbol(identifier.parent) : checker.getSymbolAtLocation(identifier);
            }
            function tryReplaceWithQualifiedNameOrPropertyAccess(symbol, scopeDecl, isTypeNode) {
              if (!symbol) {
                return void 0;
              }
              var decls = symbol.getDeclarations();
              if (decls && decls.some(function(d) {
                return d.parent === scopeDecl;
              })) {
                return ts2.createIdentifier(symbol.name);
              }
              var prefix = tryReplaceWithQualifiedNameOrPropertyAccess(symbol.parent, scopeDecl, isTypeNode);
              if (prefix === void 0) {
                return void 0;
              }
              return isTypeNode ? ts2.createQualifiedName(prefix, ts2.createIdentifier(symbol.name)) : ts2.createPropertyAccess(prefix, symbol.name);
            }
          }
          function isExtractableExpression(node) {
            var parent = node.parent;
            switch (parent.kind) {
              case 284:
                return false;
            }
            switch (node.kind) {
              case 10:
                return parent.kind !== 254 && parent.kind !== 258;
              case 213:
              case 189:
              case 191:
                return false;
              case 75:
                return parent.kind !== 191 && parent.kind !== 258 && parent.kind !== 263;
            }
            return true;
          }
          function isBlockLike(node) {
            switch (node.kind) {
              case 223:
              case 290:
              case 250:
              case 277:
                return true;
              default:
                return false;
            }
          }
        })(extractSymbol = refactor2.extractSymbol || (refactor2.extractSymbol = {}));
      })(refactor = ts2.refactor || (ts2.refactor = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var refactor;
      (function(refactor2) {
        var refactorName = "Extract type";
        var extractToTypeAlias = "Extract to type alias";
        var extractToInterface = "Extract to interface";
        var extractToTypeDef = "Extract to typedef";
        refactor2.registerRefactor(refactorName, {
          getAvailableActions: function(context) {
            var info = getRangeToExtract(context);
            if (!info)
              return ts2.emptyArray;
            return [{
              name: refactorName,
              description: ts2.getLocaleSpecificMessage(ts2.Diagnostics.Extract_type),
              actions: info.isJS ? [{
                name: extractToTypeDef,
                description: ts2.getLocaleSpecificMessage(ts2.Diagnostics.Extract_to_typedef)
              }] : ts2.append([{
                name: extractToTypeAlias,
                description: ts2.getLocaleSpecificMessage(ts2.Diagnostics.Extract_to_type_alias)
              }], info.typeElements && {
                name: extractToInterface,
                description: ts2.getLocaleSpecificMessage(ts2.Diagnostics.Extract_to_interface)
              })
            }];
          },
          getEditsForAction: function(context, actionName) {
            var file = context.file;
            var info = ts2.Debug.checkDefined(getRangeToExtract(context), "Expected to find a range to extract");
            var name = ts2.getUniqueName("NewType", file);
            var edits = ts2.textChanges.ChangeTracker.with(context, function(changes) {
              switch (actionName) {
                case extractToTypeAlias:
                  ts2.Debug.assert(!info.isJS, "Invalid actionName/JS combo");
                  return doTypeAliasChange(changes, file, name, info);
                case extractToTypeDef:
                  ts2.Debug.assert(info.isJS, "Invalid actionName/JS combo");
                  return doTypedefChange(changes, file, name, info);
                case extractToInterface:
                  ts2.Debug.assert(!info.isJS && !!info.typeElements, "Invalid actionName/JS combo");
                  return doInterfaceChange(changes, file, name, info);
                default:
                  ts2.Debug.fail("Unexpected action name");
              }
            });
            var renameFilename = file.fileName;
            var renameLocation = ts2.getRenameLocation(edits, renameFilename, name, false);
            return { edits, renameFilename, renameLocation };
          }
        });
        function getRangeToExtract(context) {
          var file = context.file, startPosition = context.startPosition;
          var isJS = ts2.isSourceFileJS(file);
          var current = ts2.getTokenAtPosition(file, startPosition);
          var range = ts2.createTextRangeFromSpan(ts2.getRefactorContextSpan(context));
          var selection = ts2.findAncestor(current, function(node) {
            return node.parent && rangeContainsSkipTrivia(range, node, file) && !rangeContainsSkipTrivia(range, node.parent, file);
          });
          if (!selection || !ts2.isTypeNode(selection))
            return void 0;
          var checker = context.program.getTypeChecker();
          var firstStatement = ts2.Debug.checkDefined(ts2.findAncestor(selection, ts2.isStatement), "Should find a statement");
          var typeParameters = collectTypeParameters(checker, selection, firstStatement, file);
          if (!typeParameters)
            return void 0;
          var typeElements = flattenTypeLiteralNodeReference(checker, selection);
          return { isJS, selection, firstStatement, typeParameters, typeElements };
        }
        function flattenTypeLiteralNodeReference(checker, node) {
          if (!node)
            return void 0;
          if (ts2.isIntersectionTypeNode(node)) {
            var result = [];
            var seen_1 = ts2.createMap();
            for (var _i = 0, _a = node.types; _i < _a.length; _i++) {
              var type = _a[_i];
              var flattenedTypeMembers = flattenTypeLiteralNodeReference(checker, type);
              if (!flattenedTypeMembers || !flattenedTypeMembers.every(function(type2) {
                return type2.name && ts2.addToSeen(seen_1, ts2.getNameFromPropertyName(type2.name));
              })) {
                return void 0;
              }
              ts2.addRange(result, flattenedTypeMembers);
            }
            return result;
          } else if (ts2.isParenthesizedTypeNode(node)) {
            return flattenTypeLiteralNodeReference(checker, node.type);
          } else if (ts2.isTypeLiteralNode(node)) {
            return node.members;
          }
          return void 0;
        }
        function rangeContainsSkipTrivia(r1, node, file) {
          return ts2.rangeContainsStartEnd(r1, ts2.skipTrivia(file.text, node.pos), node.end);
        }
        function collectTypeParameters(checker, selection, statement, file) {
          var result = [];
          return visitor(selection) ? void 0 : result;
          function visitor(node) {
            if (ts2.isTypeReferenceNode(node)) {
              if (ts2.isIdentifier(node.typeName)) {
                var symbol = checker.resolveName(node.typeName.text, node.typeName, 262144, true);
                if (symbol) {
                  var declaration = ts2.cast(ts2.first(symbol.declarations), ts2.isTypeParameterDeclaration);
                  if (rangeContainsSkipTrivia(statement, declaration, file) && !rangeContainsSkipTrivia(selection, declaration, file)) {
                    result.push(declaration);
                  }
                }
              }
            } else if (ts2.isInferTypeNode(node)) {
              var conditionalTypeNode = ts2.findAncestor(node, function(n) {
                return ts2.isConditionalTypeNode(n) && rangeContainsSkipTrivia(n.extendsType, node, file);
              });
              if (!conditionalTypeNode || !rangeContainsSkipTrivia(selection, conditionalTypeNode, file)) {
                return true;
              }
            } else if (ts2.isTypePredicateNode(node) || ts2.isThisTypeNode(node)) {
              var functionLikeNode = ts2.findAncestor(node.parent, ts2.isFunctionLike);
              if (functionLikeNode && functionLikeNode.type && rangeContainsSkipTrivia(functionLikeNode.type, node, file) && !rangeContainsSkipTrivia(selection, functionLikeNode, file)) {
                return true;
              }
            } else if (ts2.isTypeQueryNode(node)) {
              if (ts2.isIdentifier(node.exprName)) {
                var symbol = checker.resolveName(node.exprName.text, node.exprName, 111551, false);
                if (symbol && rangeContainsSkipTrivia(statement, symbol.valueDeclaration, file) && !rangeContainsSkipTrivia(selection, symbol.valueDeclaration, file)) {
                  return true;
                }
              } else {
                if (ts2.isThisIdentifier(node.exprName.left) && !rangeContainsSkipTrivia(selection, node.parent, file)) {
                  return true;
                }
              }
            }
            return ts2.forEachChild(node, visitor);
          }
        }
        function doTypeAliasChange(changes, file, name, info) {
          var firstStatement = info.firstStatement, selection = info.selection, typeParameters = info.typeParameters;
          var newTypeNode = ts2.createTypeAliasDeclaration(void 0, void 0, name, typeParameters.map(function(id) {
            return ts2.updateTypeParameterDeclaration(id, id.name, id.constraint, void 0);
          }), selection);
          changes.insertNodeBefore(file, firstStatement, ts2.ignoreSourceNewlines(newTypeNode), true);
          changes.replaceNode(file, selection, ts2.createTypeReferenceNode(name, typeParameters.map(function(id) {
            return ts2.createTypeReferenceNode(id.name, void 0);
          })));
        }
        function doInterfaceChange(changes, file, name, info) {
          var firstStatement = info.firstStatement, selection = info.selection, typeParameters = info.typeParameters, typeElements = info.typeElements;
          var newTypeNode = ts2.createInterfaceDeclaration(void 0, void 0, name, typeParameters, void 0, typeElements);
          changes.insertNodeBefore(file, firstStatement, ts2.ignoreSourceNewlines(newTypeNode), true);
          changes.replaceNode(file, selection, ts2.createTypeReferenceNode(name, typeParameters.map(function(id) {
            return ts2.createTypeReferenceNode(id.name, void 0);
          })));
        }
        function doTypedefChange(changes, file, name, info) {
          var firstStatement = info.firstStatement, selection = info.selection, typeParameters = info.typeParameters;
          var node = ts2.createNode(322);
          node.tagName = ts2.createIdentifier("typedef");
          node.fullName = ts2.createIdentifier(name);
          node.name = node.fullName;
          node.typeExpression = ts2.createJSDocTypeExpression(selection);
          var templates = [];
          ts2.forEach(typeParameters, function(typeParameter) {
            var constraint = ts2.getEffectiveConstraintOfTypeParameter(typeParameter);
            var template = ts2.createNode(321);
            template.tagName = ts2.createIdentifier("template");
            template.constraint = constraint && ts2.cast(constraint, ts2.isJSDocTypeExpression);
            var parameter = ts2.createNode(155);
            parameter.name = typeParameter.name;
            template.typeParameters = ts2.createNodeArray([parameter]);
            templates.push(template);
          });
          changes.insertNodeBefore(file, firstStatement, ts2.createJSDocComment(void 0, ts2.createNodeArray(ts2.concatenate(templates, [node]))), true);
          changes.replaceNode(file, selection, ts2.createTypeReferenceNode(name, typeParameters.map(function(id) {
            return ts2.createTypeReferenceNode(id.name, void 0);
          })));
        }
      })(refactor = ts2.refactor || (ts2.refactor = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var refactor;
      (function(refactor2) {
        var generateGetAccessorAndSetAccessor;
        (function(generateGetAccessorAndSetAccessor2) {
          var actionName = "Generate 'get' and 'set' accessors";
          var actionDescription = ts2.Diagnostics.Generate_get_and_set_accessors.message;
          refactor2.registerRefactor(actionName, { getEditsForAction, getAvailableActions });
          function getAvailableActions(context) {
            if (!getConvertibleFieldAtPosition(context))
              return ts2.emptyArray;
            return [{
              name: actionName,
              description: actionDescription,
              actions: [
                {
                  name: actionName,
                  description: actionDescription
                }
              ]
            }];
          }
          function getEditsForAction(context, _actionName) {
            var file = context.file;
            var fieldInfo = getConvertibleFieldAtPosition(context);
            if (!fieldInfo)
              return void 0;
            var isJS = ts2.isSourceFileJS(file);
            var changeTracker = ts2.textChanges.ChangeTracker.fromContext(context);
            var isStatic = fieldInfo.isStatic, isReadonly = fieldInfo.isReadonly, fieldName = fieldInfo.fieldName, accessorName = fieldInfo.accessorName, originalName = fieldInfo.originalName, type = fieldInfo.type, container = fieldInfo.container, declaration = fieldInfo.declaration, renameAccessor = fieldInfo.renameAccessor;
            ts2.suppressLeadingAndTrailingTrivia(fieldName);
            ts2.suppressLeadingAndTrailingTrivia(accessorName);
            ts2.suppressLeadingAndTrailingTrivia(declaration);
            ts2.suppressLeadingAndTrailingTrivia(container);
            var isInClassLike = ts2.isClassLike(container);
            var modifierFlags = ts2.getModifierFlags(declaration) & ~64;
            var accessorModifiers = isInClassLike ? !modifierFlags || modifierFlags & 8 ? getModifiers(isJS, isStatic, 119) : ts2.createNodeArray(ts2.createModifiersFromModifierFlags(modifierFlags)) : void 0;
            var fieldModifiers = isInClassLike ? getModifiers(isJS, isStatic, 117) : void 0;
            updateFieldDeclaration(changeTracker, file, declaration, fieldName, fieldModifiers);
            var getAccessor = generateGetAccessor(fieldName, accessorName, type, accessorModifiers, isStatic, container);
            ts2.suppressLeadingAndTrailingTrivia(getAccessor);
            insertAccessor(changeTracker, file, getAccessor, declaration, container);
            if (isReadonly) {
              var constructor = ts2.getFirstConstructorWithBody(container);
              if (constructor) {
                updateReadonlyPropertyInitializerStatementConstructor(changeTracker, file, constructor, fieldName.text, originalName);
              }
            } else {
              var setAccessor = generateSetAccessor(fieldName, accessorName, type, accessorModifiers, isStatic, container);
              ts2.suppressLeadingAndTrailingTrivia(setAccessor);
              insertAccessor(changeTracker, file, setAccessor, declaration, container);
            }
            var edits = changeTracker.getChanges();
            var renameFilename = file.fileName;
            var nameNeedRename = renameAccessor ? accessorName : fieldName;
            var renameLocationOffset = ts2.isIdentifier(nameNeedRename) ? 0 : -1;
            var renameLocation = renameLocationOffset + ts2.getRenameLocation(edits, renameFilename, nameNeedRename.text, ts2.isParameter(declaration));
            return { renameFilename, renameLocation, edits };
          }
          function isConvertibleName(name) {
            return ts2.isIdentifier(name) || ts2.isStringLiteral(name);
          }
          function isAcceptedDeclaration(node) {
            return ts2.isParameterPropertyDeclaration(node, node.parent) || ts2.isPropertyDeclaration(node) || ts2.isPropertyAssignment(node);
          }
          function createPropertyName(name, originalName) {
            return ts2.isIdentifier(originalName) ? ts2.createIdentifier(name) : ts2.createLiteral(name);
          }
          function createAccessorAccessExpression(fieldName, isStatic, container) {
            var leftHead = isStatic ? container.name : ts2.createThis();
            return ts2.isIdentifier(fieldName) ? ts2.createPropertyAccess(leftHead, fieldName) : ts2.createElementAccess(leftHead, ts2.createLiteral(fieldName));
          }
          function getModifiers(isJS, isStatic, accessModifier) {
            var modifiers = ts2.append(!isJS ? [ts2.createToken(accessModifier)] : void 0, isStatic ? ts2.createToken(120) : void 0);
            return modifiers && ts2.createNodeArray(modifiers);
          }
          function getConvertibleFieldAtPosition(context) {
            var file = context.file, startPosition = context.startPosition, endPosition = context.endPosition;
            var node = ts2.getTokenAtPosition(file, startPosition);
            var declaration = ts2.findAncestor(node.parent, isAcceptedDeclaration);
            var meaning = 28 | 32 | 64;
            if (!declaration || !ts2.nodeOverlapsWithStartEnd(declaration.name, file, startPosition, endPosition) || !isConvertibleName(declaration.name) || (ts2.getModifierFlags(declaration) | meaning) !== meaning)
              return void 0;
            var name = declaration.name.text;
            var startWithUnderscore = ts2.startsWithUnderscore(name);
            var fieldName = createPropertyName(startWithUnderscore ? name : ts2.getUniqueName("_" + name, file), declaration.name);
            var accessorName = createPropertyName(startWithUnderscore ? ts2.getUniqueName(name.substring(1), file) : name, declaration.name);
            return {
              isStatic: ts2.hasStaticModifier(declaration),
              isReadonly: ts2.hasReadonlyModifier(declaration),
              type: ts2.getTypeAnnotationNode(declaration),
              container: declaration.kind === 156 ? declaration.parent.parent : declaration.parent,
              originalName: declaration.name.text,
              declaration,
              fieldName,
              accessorName,
              renameAccessor: startWithUnderscore
            };
          }
          function generateGetAccessor(fieldName, accessorName, type, modifiers, isStatic, container) {
            return ts2.createGetAccessor(void 0, modifiers, accessorName, void 0, type, ts2.createBlock([
              ts2.createReturn(createAccessorAccessExpression(fieldName, isStatic, container))
            ], true));
          }
          function generateSetAccessor(fieldName, accessorName, type, modifiers, isStatic, container) {
            return ts2.createSetAccessor(void 0, modifiers, accessorName, [ts2.createParameter(void 0, void 0, void 0, ts2.createIdentifier("value"), void 0, type)], ts2.createBlock([
              ts2.createStatement(ts2.createAssignment(createAccessorAccessExpression(fieldName, isStatic, container), ts2.createIdentifier("value")))
            ], true));
          }
          function updatePropertyDeclaration(changeTracker, file, declaration, fieldName, modifiers) {
            var property = ts2.updateProperty(declaration, declaration.decorators, modifiers, fieldName, declaration.questionToken || declaration.exclamationToken, declaration.type, declaration.initializer);
            changeTracker.replaceNode(file, declaration, property);
          }
          function updatePropertyAssignmentDeclaration(changeTracker, file, declaration, fieldName) {
            var assignment = ts2.updatePropertyAssignment(declaration, fieldName, declaration.initializer);
            changeTracker.replacePropertyAssignment(file, declaration, assignment);
          }
          function updateFieldDeclaration(changeTracker, file, declaration, fieldName, modifiers) {
            if (ts2.isPropertyDeclaration(declaration)) {
              updatePropertyDeclaration(changeTracker, file, declaration, fieldName, modifiers);
            } else if (ts2.isPropertyAssignment(declaration)) {
              updatePropertyAssignmentDeclaration(changeTracker, file, declaration, fieldName);
            } else {
              changeTracker.replaceNode(file, declaration, ts2.updateParameter(declaration, declaration.decorators, modifiers, declaration.dotDotDotToken, ts2.cast(fieldName, ts2.isIdentifier), declaration.questionToken, declaration.type, declaration.initializer));
            }
          }
          function insertAccessor(changeTracker, file, accessor, declaration, container) {
            ts2.isParameterPropertyDeclaration(declaration, declaration.parent) ? changeTracker.insertNodeAtClassStart(file, container, accessor) : ts2.isPropertyAssignment(declaration) ? changeTracker.insertNodeAfterComma(file, declaration, accessor) : changeTracker.insertNodeAfter(file, declaration, accessor);
          }
          function updateReadonlyPropertyInitializerStatementConstructor(changeTracker, file, constructor, fieldName, originalName) {
            if (!constructor.body)
              return;
            constructor.body.forEachChild(function recur(node) {
              if (ts2.isElementAccessExpression(node) && node.expression.kind === 104 && ts2.isStringLiteral(node.argumentExpression) && node.argumentExpression.text === originalName && ts2.isWriteAccess(node)) {
                changeTracker.replaceNode(file, node.argumentExpression, ts2.createStringLiteral(fieldName));
              }
              if (ts2.isPropertyAccessExpression(node) && node.expression.kind === 104 && node.name.text === originalName && ts2.isWriteAccess(node)) {
                changeTracker.replaceNode(file, node.name, ts2.createIdentifier(fieldName));
              }
              if (!ts2.isFunctionLike(node) && !ts2.isClassLike(node)) {
                node.forEachChild(recur);
              }
            });
          }
        })(generateGetAccessorAndSetAccessor = refactor2.generateGetAccessorAndSetAccessor || (refactor2.generateGetAccessorAndSetAccessor = {}));
      })(refactor = ts2.refactor || (ts2.refactor = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var refactor;
      (function(refactor2) {
        var refactorName = "Move to a new file";
        refactor2.registerRefactor(refactorName, {
          getAvailableActions: function(context) {
            if (!context.preferences.allowTextChangesInNewFiles || getStatementsToMove(context) === void 0)
              return ts2.emptyArray;
            var description = ts2.getLocaleSpecificMessage(ts2.Diagnostics.Move_to_a_new_file);
            return [{ name: refactorName, description, actions: [{ name: refactorName, description }] }];
          },
          getEditsForAction: function(context, actionName) {
            ts2.Debug.assert(actionName === refactorName, "Wrong refactor invoked");
            var statements = ts2.Debug.checkDefined(getStatementsToMove(context));
            var edits = ts2.textChanges.ChangeTracker.with(context, function(t) {
              return doChange(context.file, context.program, statements, t, context.host, context.preferences);
            });
            return { edits, renameFilename: void 0, renameLocation: void 0 };
          }
        });
        function getRangeToMove(context) {
          var file = context.file;
          var range = ts2.createTextRangeFromSpan(ts2.getRefactorContextSpan(context));
          var statements = file.statements;
          var startNodeIndex = ts2.findIndex(statements, function(s) {
            return s.end > range.pos;
          });
          if (startNodeIndex === -1)
            return void 0;
          var startStatement = statements[startNodeIndex];
          if (ts2.isNamedDeclaration(startStatement) && startStatement.name && ts2.rangeContainsRange(startStatement.name, range)) {
            return { toMove: [statements[startNodeIndex]], afterLast: statements[startNodeIndex + 1] };
          }
          if (range.pos > startStatement.getStart(file))
            return void 0;
          var afterEndNodeIndex = ts2.findIndex(statements, function(s) {
            return s.end > range.end;
          }, startNodeIndex);
          if (afterEndNodeIndex !== -1 && (afterEndNodeIndex === 0 || statements[afterEndNodeIndex].getStart(file) < range.end))
            return void 0;
          return {
            toMove: statements.slice(startNodeIndex, afterEndNodeIndex === -1 ? statements.length : afterEndNodeIndex),
            afterLast: afterEndNodeIndex === -1 ? void 0 : statements[afterEndNodeIndex]
          };
        }
        function doChange(oldFile, program, toMove, changes, host, preferences) {
          var checker = program.getTypeChecker();
          var usage = getUsageInfo(oldFile, toMove.all, checker);
          var currentDirectory = ts2.getDirectoryPath(oldFile.fileName);
          var extension = ts2.extensionFromPath(oldFile.fileName);
          var newModuleName = makeUniqueModuleName(getNewModuleName(usage.movedSymbols), extension, currentDirectory, host);
          var newFileNameWithExtension = newModuleName + extension;
          changes.createNewFile(oldFile, ts2.combinePaths(currentDirectory, newFileNameWithExtension), getNewStatementsAndRemoveFromOldFile(oldFile, usage, changes, toMove, program, newModuleName, preferences));
          addNewFileToTsconfig(program, changes, oldFile.fileName, newFileNameWithExtension, ts2.hostGetCanonicalFileName(host));
        }
        function getStatementsToMove(context) {
          var rangeToMove = getRangeToMove(context);
          if (rangeToMove === void 0)
            return void 0;
          var all = [];
          var ranges = [];
          var toMove = rangeToMove.toMove, afterLast = rangeToMove.afterLast;
          ts2.getRangesWhere(toMove, function(s) {
            return !isPureImport(s);
          }, function(start, afterEndIndex) {
            for (var i = start; i < afterEndIndex; i++)
              all.push(toMove[i]);
            ranges.push({ first: toMove[start], afterLast });
          });
          return all.length === 0 ? void 0 : { all, ranges };
        }
        function isPureImport(node) {
          switch (node.kind) {
            case 254:
              return true;
            case 253:
              return !ts2.hasModifier(node, 1);
            case 225:
              return node.declarationList.declarations.every(function(d) {
                return !!d.initializer && ts2.isRequireCall(d.initializer, true);
              });
            default:
              return false;
          }
        }
        function addNewFileToTsconfig(program, changes, oldFileName, newFileNameWithExtension, getCanonicalFileName) {
          var cfg = program.getCompilerOptions().configFile;
          if (!cfg)
            return;
          var newFileAbsolutePath = ts2.normalizePath(ts2.combinePaths(oldFileName, "..", newFileNameWithExtension));
          var newFilePath = ts2.getRelativePathFromFile(cfg.fileName, newFileAbsolutePath, getCanonicalFileName);
          var cfgObject = cfg.statements[0] && ts2.tryCast(cfg.statements[0].expression, ts2.isObjectLiteralExpression);
          var filesProp = cfgObject && ts2.find(cfgObject.properties, function(prop) {
            return ts2.isPropertyAssignment(prop) && ts2.isStringLiteral(prop.name) && prop.name.text === "files";
          });
          if (filesProp && ts2.isArrayLiteralExpression(filesProp.initializer)) {
            changes.insertNodeInListAfter(cfg, ts2.last(filesProp.initializer.elements), ts2.createLiteral(newFilePath), filesProp.initializer.elements);
          }
        }
        function getNewStatementsAndRemoveFromOldFile(oldFile, usage, changes, toMove, program, newModuleName, preferences) {
          var checker = program.getTypeChecker();
          if (!oldFile.externalModuleIndicator && !oldFile.commonJsModuleIndicator) {
            deleteMovedStatements(oldFile, toMove.ranges, changes);
            return toMove.all;
          }
          var useEs6ModuleSyntax = !!oldFile.externalModuleIndicator;
          var quotePreference = ts2.getQuotePreference(oldFile, preferences);
          var importsFromNewFile = createOldFileImportsFromNewFile(usage.oldFileImportsFromNewFile, newModuleName, useEs6ModuleSyntax, quotePreference);
          if (importsFromNewFile) {
            ts2.insertImports(changes, oldFile, importsFromNewFile, true);
          }
          deleteUnusedOldImports(oldFile, toMove.all, changes, usage.unusedImportsFromOldFile, checker);
          deleteMovedStatements(oldFile, toMove.ranges, changes);
          updateImportsInOtherFiles(changes, program, oldFile, usage.movedSymbols, newModuleName);
          return __spreadArrays(getNewFileImportsAndAddExportInOldFile(oldFile, usage.oldImportsNeededByNewFile, usage.newFileImportsFromOldFile, changes, checker, useEs6ModuleSyntax, quotePreference), addExports(oldFile, toMove.all, usage.oldFileImportsFromNewFile, useEs6ModuleSyntax));
        }
        function deleteMovedStatements(sourceFile, moved, changes) {
          for (var _i = 0, moved_1 = moved; _i < moved_1.length; _i++) {
            var _a = moved_1[_i], first_1 = _a.first, afterLast = _a.afterLast;
            changes.deleteNodeRangeExcludingEnd(sourceFile, first_1, afterLast);
          }
        }
        function deleteUnusedOldImports(oldFile, toMove, changes, toDelete, checker) {
          for (var _i = 0, _a = oldFile.statements; _i < _a.length; _i++) {
            var statement = _a[_i];
            if (ts2.contains(toMove, statement))
              continue;
            forEachImportInStatement(statement, function(i) {
              return deleteUnusedImports(oldFile, i, changes, function(name) {
                return toDelete.has(checker.getSymbolAtLocation(name));
              });
            });
          }
        }
        function updateImportsInOtherFiles(changes, program, oldFile, movedSymbols, newModuleName) {
          var checker = program.getTypeChecker();
          var _loop_17 = function(sourceFile2) {
            if (sourceFile2 === oldFile)
              return "continue";
            var _loop_18 = function(statement2) {
              forEachImportInStatement(statement2, function(importNode) {
                if (checker.getSymbolAtLocation(moduleSpecifierFromImport(importNode)) !== oldFile.symbol)
                  return;
                var shouldMove = function(name) {
                  var symbol = ts2.isBindingElement(name.parent) ? ts2.getPropertySymbolFromBindingElement(checker, name.parent) : ts2.skipAlias(checker.getSymbolAtLocation(name), checker);
                  return !!symbol && movedSymbols.has(symbol);
                };
                deleteUnusedImports(sourceFile2, importNode, changes, shouldMove);
                var newModuleSpecifier = ts2.combinePaths(ts2.getDirectoryPath(moduleSpecifierFromImport(importNode).text), newModuleName);
                var newImportDeclaration = filterImport(importNode, ts2.createLiteral(newModuleSpecifier), shouldMove);
                if (newImportDeclaration)
                  changes.insertNodeAfter(sourceFile2, statement2, newImportDeclaration);
                var ns = getNamespaceLikeImport(importNode);
                if (ns)
                  updateNamespaceLikeImport(changes, sourceFile2, checker, movedSymbols, newModuleName, newModuleSpecifier, ns, importNode);
              });
            };
            for (var _i2 = 0, _a2 = sourceFile2.statements; _i2 < _a2.length; _i2++) {
              var statement = _a2[_i2];
              _loop_18(statement);
            }
          };
          for (var _i = 0, _a = program.getSourceFiles(); _i < _a.length; _i++) {
            var sourceFile = _a[_i];
            _loop_17(sourceFile);
          }
        }
        function getNamespaceLikeImport(node) {
          switch (node.kind) {
            case 254:
              return node.importClause && node.importClause.namedBindings && node.importClause.namedBindings.kind === 256 ? node.importClause.namedBindings.name : void 0;
            case 253:
              return node.name;
            case 242:
              return ts2.tryCast(node.name, ts2.isIdentifier);
            default:
              return ts2.Debug.assertNever(node, "Unexpected node kind " + node.kind);
          }
        }
        function updateNamespaceLikeImport(changes, sourceFile, checker, movedSymbols, newModuleName, newModuleSpecifier, oldImportId, oldImportNode) {
          var preferredNewNamespaceName = ts2.codefix.moduleSpecifierToValidIdentifier(newModuleName, 99);
          var needUniqueName = false;
          var toChange = [];
          ts2.FindAllReferences.Core.eachSymbolReferenceInFile(oldImportId, checker, sourceFile, function(ref2) {
            if (!ts2.isPropertyAccessExpression(ref2.parent))
              return;
            needUniqueName = needUniqueName || !!checker.resolveName(preferredNewNamespaceName, ref2, 67108863, true);
            if (movedSymbols.has(checker.getSymbolAtLocation(ref2.parent.name))) {
              toChange.push(ref2);
            }
          });
          if (toChange.length) {
            var newNamespaceName = needUniqueName ? ts2.getUniqueName(preferredNewNamespaceName, sourceFile) : preferredNewNamespaceName;
            for (var _i = 0, toChange_1 = toChange; _i < toChange_1.length; _i++) {
              var ref = toChange_1[_i];
              changes.replaceNode(sourceFile, ref, ts2.createIdentifier(newNamespaceName));
            }
            changes.insertNodeAfter(sourceFile, oldImportNode, updateNamespaceLikeImportNode(oldImportNode, newModuleName, newModuleSpecifier));
          }
        }
        function updateNamespaceLikeImportNode(node, newNamespaceName, newModuleSpecifier) {
          var newNamespaceId = ts2.createIdentifier(newNamespaceName);
          var newModuleString = ts2.createLiteral(newModuleSpecifier);
          switch (node.kind) {
            case 254:
              return ts2.createImportDeclaration(void 0, void 0, ts2.createImportClause(void 0, ts2.createNamespaceImport(newNamespaceId)), newModuleString);
            case 253:
              return ts2.createImportEqualsDeclaration(void 0, void 0, newNamespaceId, ts2.createExternalModuleReference(newModuleString));
            case 242:
              return ts2.createVariableDeclaration(newNamespaceId, void 0, createRequireCall(newModuleString));
            default:
              return ts2.Debug.assertNever(node, "Unexpected node kind " + node.kind);
          }
        }
        function moduleSpecifierFromImport(i) {
          return i.kind === 254 ? i.moduleSpecifier : i.kind === 253 ? i.moduleReference.expression : i.initializer.arguments[0];
        }
        function forEachImportInStatement(statement, cb) {
          if (ts2.isImportDeclaration(statement)) {
            if (ts2.isStringLiteral(statement.moduleSpecifier))
              cb(statement);
          } else if (ts2.isImportEqualsDeclaration(statement)) {
            if (ts2.isExternalModuleReference(statement.moduleReference) && ts2.isStringLiteralLike(statement.moduleReference.expression)) {
              cb(statement);
            }
          } else if (ts2.isVariableStatement(statement)) {
            for (var _i = 0, _a = statement.declarationList.declarations; _i < _a.length; _i++) {
              var decl = _a[_i];
              if (decl.initializer && ts2.isRequireCall(decl.initializer, true)) {
                cb(decl);
              }
            }
          }
        }
        function createOldFileImportsFromNewFile(newFileNeedExport, newFileNameWithExtension, useEs6Imports, quotePreference) {
          var defaultImport;
          var imports = [];
          newFileNeedExport.forEach(function(symbol) {
            if (symbol.escapedName === "default") {
              defaultImport = ts2.createIdentifier(ts2.symbolNameNoDefault(symbol));
            } else {
              imports.push(symbol.name);
            }
          });
          return makeImportOrRequire(defaultImport, imports, newFileNameWithExtension, useEs6Imports, quotePreference);
        }
        function makeImportOrRequire(defaultImport, imports, path2, useEs6Imports, quotePreference) {
          path2 = ts2.ensurePathIsNonModuleName(path2);
          if (useEs6Imports) {
            var specifiers = imports.map(function(i) {
              return ts2.createImportSpecifier(void 0, ts2.createIdentifier(i));
            });
            return ts2.makeImportIfNecessary(defaultImport, specifiers, path2, quotePreference);
          } else {
            ts2.Debug.assert(!defaultImport, "No default import should exist");
            var bindingElements = imports.map(function(i) {
              return ts2.createBindingElement(void 0, void 0, i);
            });
            return bindingElements.length ? makeVariableStatement(ts2.createObjectBindingPattern(bindingElements), void 0, createRequireCall(ts2.createLiteral(path2))) : void 0;
          }
        }
        function makeVariableStatement(name, type, initializer, flags) {
          if (flags === void 0) {
            flags = 2;
          }
          return ts2.createVariableStatement(void 0, ts2.createVariableDeclarationList([ts2.createVariableDeclaration(name, type, initializer)], flags));
        }
        function createRequireCall(moduleSpecifier) {
          return ts2.createCall(ts2.createIdentifier("require"), void 0, [moduleSpecifier]);
        }
        function addExports(sourceFile, toMove, needExport, useEs6Exports) {
          return ts2.flatMap(toMove, function(statement) {
            if (isTopLevelDeclarationStatement(statement) && !isExported(sourceFile, statement, useEs6Exports) && forEachTopLevelDeclaration(statement, function(d) {
              return needExport.has(ts2.Debug.checkDefined(d.symbol));
            })) {
              var exports2 = addExport(statement, useEs6Exports);
              if (exports2)
                return exports2;
            }
            return statement;
          });
        }
        function deleteUnusedImports(sourceFile, importDecl, changes, isUnused) {
          switch (importDecl.kind) {
            case 254:
              deleteUnusedImportsInDeclaration(sourceFile, importDecl, changes, isUnused);
              break;
            case 253:
              if (isUnused(importDecl.name)) {
                changes.delete(sourceFile, importDecl);
              }
              break;
            case 242:
              deleteUnusedImportsInVariableDeclaration(sourceFile, importDecl, changes, isUnused);
              break;
            default:
              ts2.Debug.assertNever(importDecl, "Unexpected import decl kind " + importDecl.kind);
          }
        }
        function deleteUnusedImportsInDeclaration(sourceFile, importDecl, changes, isUnused) {
          if (!importDecl.importClause)
            return;
          var _a = importDecl.importClause, name = _a.name, namedBindings = _a.namedBindings;
          var defaultUnused = !name || isUnused(name);
          var namedBindingsUnused = !namedBindings || (namedBindings.kind === 256 ? isUnused(namedBindings.name) : namedBindings.elements.length !== 0 && namedBindings.elements.every(function(e) {
            return isUnused(e.name);
          }));
          if (defaultUnused && namedBindingsUnused) {
            changes.delete(sourceFile, importDecl);
          } else {
            if (name && defaultUnused) {
              changes.delete(sourceFile, name);
            }
            if (namedBindings) {
              if (namedBindingsUnused) {
                changes.replaceNode(sourceFile, importDecl.importClause, ts2.updateImportClause(importDecl.importClause, name, void 0, importDecl.importClause.isTypeOnly));
              } else if (namedBindings.kind === 257) {
                for (var _i = 0, _b = namedBindings.elements; _i < _b.length; _i++) {
                  var element = _b[_i];
                  if (isUnused(element.name))
                    changes.delete(sourceFile, element);
                }
              }
            }
          }
        }
        function deleteUnusedImportsInVariableDeclaration(sourceFile, varDecl, changes, isUnused) {
          var name = varDecl.name;
          switch (name.kind) {
            case 75:
              if (isUnused(name)) {
                changes.delete(sourceFile, name);
              }
              break;
            case 190:
              break;
            case 189:
              if (name.elements.every(function(e) {
                return ts2.isIdentifier(e.name) && isUnused(e.name);
              })) {
                changes.delete(sourceFile, ts2.isVariableDeclarationList(varDecl.parent) && varDecl.parent.declarations.length === 1 ? varDecl.parent.parent : varDecl);
              } else {
                for (var _i = 0, _a = name.elements; _i < _a.length; _i++) {
                  var element = _a[_i];
                  if (ts2.isIdentifier(element.name) && isUnused(element.name)) {
                    changes.delete(sourceFile, element.name);
                  }
                }
              }
              break;
          }
        }
        function getNewFileImportsAndAddExportInOldFile(oldFile, importsToCopy, newFileImportsFromOldFile, changes, checker, useEs6ModuleSyntax, quotePreference) {
          var copiedOldImports = [];
          for (var _i = 0, _a = oldFile.statements; _i < _a.length; _i++) {
            var oldStatement = _a[_i];
            forEachImportInStatement(oldStatement, function(i) {
              ts2.append(copiedOldImports, filterImport(i, moduleSpecifierFromImport(i), function(name) {
                return importsToCopy.has(checker.getSymbolAtLocation(name));
              }));
            });
          }
          var oldFileDefault;
          var oldFileNamedImports = [];
          var markSeenTop = ts2.nodeSeenTracker();
          newFileImportsFromOldFile.forEach(function(symbol) {
            for (var _i2 = 0, _a2 = symbol.declarations; _i2 < _a2.length; _i2++) {
              var decl = _a2[_i2];
              if (!isTopLevelDeclaration(decl))
                continue;
              var name = nameOfTopLevelDeclaration(decl);
              if (!name)
                continue;
              var top = getTopLevelDeclarationStatement(decl);
              if (markSeenTop(top)) {
                addExportToChanges(oldFile, top, changes, useEs6ModuleSyntax);
              }
              if (ts2.hasModifier(decl, 512)) {
                oldFileDefault = name;
              } else {
                oldFileNamedImports.push(name.text);
              }
            }
          });
          ts2.append(copiedOldImports, makeImportOrRequire(oldFileDefault, oldFileNamedImports, ts2.removeFileExtension(ts2.getBaseFileName(oldFile.fileName)), useEs6ModuleSyntax, quotePreference));
          return copiedOldImports;
        }
        function makeUniqueModuleName(moduleName, extension, inDirectory, host) {
          var newModuleName = moduleName;
          for (var i = 1; ; i++) {
            var name = ts2.combinePaths(inDirectory, newModuleName + extension);
            if (!host.fileExists(name))
              return newModuleName;
            newModuleName = moduleName + "." + i;
          }
        }
        function getNewModuleName(movedSymbols) {
          return movedSymbols.forEachEntry(ts2.symbolNameNoDefault) || "newFile";
        }
        function getUsageInfo(oldFile, toMove, checker) {
          var movedSymbols = new SymbolSet();
          var oldImportsNeededByNewFile = new SymbolSet();
          var newFileImportsFromOldFile = new SymbolSet();
          var containsJsx = ts2.find(toMove, function(statement2) {
            return !!(statement2.transformFlags & 2);
          });
          var jsxNamespaceSymbol = getJsxNamespaceSymbol(containsJsx);
          if (jsxNamespaceSymbol) {
            oldImportsNeededByNewFile.add(jsxNamespaceSymbol);
          }
          for (var _i = 0, toMove_1 = toMove; _i < toMove_1.length; _i++) {
            var statement = toMove_1[_i];
            forEachTopLevelDeclaration(statement, function(decl) {
              movedSymbols.add(ts2.Debug.checkDefined(ts2.isExpressionStatement(decl) ? checker.getSymbolAtLocation(decl.expression.left) : decl.symbol, "Need a symbol here"));
            });
          }
          for (var _a = 0, toMove_2 = toMove; _a < toMove_2.length; _a++) {
            var statement = toMove_2[_a];
            forEachReference(statement, checker, function(symbol) {
              if (!symbol.declarations)
                return;
              for (var _i2 = 0, _a2 = symbol.declarations; _i2 < _a2.length; _i2++) {
                var decl = _a2[_i2];
                if (isInImport(decl)) {
                  oldImportsNeededByNewFile.add(symbol);
                } else if (isTopLevelDeclaration(decl) && sourceFileOfTopLevelDeclaration(decl) === oldFile && !movedSymbols.has(symbol)) {
                  newFileImportsFromOldFile.add(symbol);
                }
              }
            });
          }
          var unusedImportsFromOldFile = oldImportsNeededByNewFile.clone();
          var oldFileImportsFromNewFile = new SymbolSet();
          for (var _b = 0, _c = oldFile.statements; _b < _c.length; _b++) {
            var statement = _c[_b];
            if (ts2.contains(toMove, statement))
              continue;
            if (jsxNamespaceSymbol && !!(statement.transformFlags & 2)) {
              unusedImportsFromOldFile.delete(jsxNamespaceSymbol);
            }
            forEachReference(statement, checker, function(symbol) {
              if (movedSymbols.has(symbol))
                oldFileImportsFromNewFile.add(symbol);
              unusedImportsFromOldFile.delete(symbol);
            });
          }
          return { movedSymbols, newFileImportsFromOldFile, oldFileImportsFromNewFile, oldImportsNeededByNewFile, unusedImportsFromOldFile };
          function getJsxNamespaceSymbol(containsJsx2) {
            if (containsJsx2 === void 0) {
              return void 0;
            }
            var jsxNamespace = checker.getJsxNamespace(containsJsx2);
            var jsxNamespaceSymbol2 = checker.resolveName(jsxNamespace, containsJsx2, 1920, true);
            return !!jsxNamespaceSymbol2 && ts2.some(jsxNamespaceSymbol2.declarations, isInImport) ? jsxNamespaceSymbol2 : void 0;
          }
        }
        function isInImport(decl) {
          switch (decl.kind) {
            case 253:
            case 258:
            case 255:
            case 256:
              return true;
            case 242:
              return isVariableDeclarationInImport(decl);
            case 191:
              return ts2.isVariableDeclaration(decl.parent.parent) && isVariableDeclarationInImport(decl.parent.parent);
            default:
              return false;
          }
        }
        function isVariableDeclarationInImport(decl) {
          return ts2.isSourceFile(decl.parent.parent.parent) && !!decl.initializer && ts2.isRequireCall(decl.initializer, true);
        }
        function filterImport(i, moduleSpecifier, keep) {
          switch (i.kind) {
            case 254: {
              var clause = i.importClause;
              if (!clause)
                return void 0;
              var defaultImport = clause.name && keep(clause.name) ? clause.name : void 0;
              var namedBindings = clause.namedBindings && filterNamedBindings(clause.namedBindings, keep);
              return defaultImport || namedBindings ? ts2.createImportDeclaration(void 0, void 0, ts2.createImportClause(defaultImport, namedBindings), moduleSpecifier) : void 0;
            }
            case 253:
              return keep(i.name) ? i : void 0;
            case 242: {
              var name = filterBindingName(i.name, keep);
              return name ? makeVariableStatement(name, i.type, createRequireCall(moduleSpecifier), i.parent.flags) : void 0;
            }
            default:
              return ts2.Debug.assertNever(i, "Unexpected import kind " + i.kind);
          }
        }
        function filterNamedBindings(namedBindings, keep) {
          if (namedBindings.kind === 256) {
            return keep(namedBindings.name) ? namedBindings : void 0;
          } else {
            var newElements = namedBindings.elements.filter(function(e) {
              return keep(e.name);
            });
            return newElements.length ? ts2.createNamedImports(newElements) : void 0;
          }
        }
        function filterBindingName(name, keep) {
          switch (name.kind) {
            case 75:
              return keep(name) ? name : void 0;
            case 190:
              return name;
            case 189: {
              var newElements = name.elements.filter(function(prop) {
                return prop.propertyName || !ts2.isIdentifier(prop.name) || keep(prop.name);
              });
              return newElements.length ? ts2.createObjectBindingPattern(newElements) : void 0;
            }
          }
        }
        function forEachReference(node, checker, onReference) {
          node.forEachChild(function cb(node2) {
            if (ts2.isIdentifier(node2) && !ts2.isDeclarationName(node2)) {
              var sym = checker.getSymbolAtLocation(node2);
              if (sym)
                onReference(sym);
            } else {
              node2.forEachChild(cb);
            }
          });
        }
        var SymbolSet = function() {
          function SymbolSet2() {
            this.map = ts2.createMap();
          }
          SymbolSet2.prototype.add = function(symbol) {
            this.map.set(String(ts2.getSymbolId(symbol)), symbol);
          };
          SymbolSet2.prototype.has = function(symbol) {
            return this.map.has(String(ts2.getSymbolId(symbol)));
          };
          SymbolSet2.prototype.delete = function(symbol) {
            this.map.delete(String(ts2.getSymbolId(symbol)));
          };
          SymbolSet2.prototype.forEach = function(cb) {
            this.map.forEach(cb);
          };
          SymbolSet2.prototype.forEachEntry = function(cb) {
            return ts2.forEachEntry(this.map, cb);
          };
          SymbolSet2.prototype.clone = function() {
            var clone = new SymbolSet2();
            ts2.copyEntries(this.map, clone.map);
            return clone;
          };
          return SymbolSet2;
        }();
        function isTopLevelDeclaration(node) {
          return isNonVariableTopLevelDeclaration(node) && ts2.isSourceFile(node.parent) || ts2.isVariableDeclaration(node) && ts2.isSourceFile(node.parent.parent.parent);
        }
        function sourceFileOfTopLevelDeclaration(node) {
          return ts2.isVariableDeclaration(node) ? node.parent.parent.parent : node.parent;
        }
        function isTopLevelDeclarationStatement(node) {
          ts2.Debug.assert(ts2.isSourceFile(node.parent), "Node parent should be a SourceFile");
          return isNonVariableTopLevelDeclaration(node) || ts2.isVariableStatement(node);
        }
        function isNonVariableTopLevelDeclaration(node) {
          switch (node.kind) {
            case 244:
            case 245:
            case 249:
            case 248:
            case 247:
            case 246:
            case 253:
              return true;
            default:
              return false;
          }
        }
        function forEachTopLevelDeclaration(statement, cb) {
          switch (statement.kind) {
            case 244:
            case 245:
            case 249:
            case 248:
            case 247:
            case 246:
            case 253:
              return cb(statement);
            case 225:
              return ts2.firstDefined(statement.declarationList.declarations, function(decl) {
                return forEachTopLevelDeclarationInBindingName(decl.name, cb);
              });
            case 226: {
              var expression = statement.expression;
              return ts2.isBinaryExpression(expression) && ts2.getAssignmentDeclarationKind(expression) === 1 ? cb(statement) : void 0;
            }
          }
        }
        function forEachTopLevelDeclarationInBindingName(name, cb) {
          switch (name.kind) {
            case 75:
              return cb(ts2.cast(name.parent, function(x) {
                return ts2.isVariableDeclaration(x) || ts2.isBindingElement(x);
              }));
            case 190:
            case 189:
              return ts2.firstDefined(name.elements, function(em) {
                return ts2.isOmittedExpression(em) ? void 0 : forEachTopLevelDeclarationInBindingName(em.name, cb);
              });
            default:
              return ts2.Debug.assertNever(name, "Unexpected name kind " + name.kind);
          }
        }
        function nameOfTopLevelDeclaration(d) {
          return ts2.isExpressionStatement(d) ? ts2.tryCast(d.expression.left.name, ts2.isIdentifier) : ts2.tryCast(d.name, ts2.isIdentifier);
        }
        function getTopLevelDeclarationStatement(d) {
          switch (d.kind) {
            case 242:
              return d.parent.parent;
            case 191:
              return getTopLevelDeclarationStatement(ts2.cast(d.parent.parent, function(p) {
                return ts2.isVariableDeclaration(p) || ts2.isBindingElement(p);
              }));
            default:
              return d;
          }
        }
        function addExportToChanges(sourceFile, decl, changes, useEs6Exports) {
          if (isExported(sourceFile, decl, useEs6Exports))
            return;
          if (useEs6Exports) {
            if (!ts2.isExpressionStatement(decl))
              changes.insertExportModifier(sourceFile, decl);
          } else {
            var names = getNamesToExportInCommonJS(decl);
            if (names.length !== 0)
              changes.insertNodesAfter(sourceFile, decl, names.map(createExportAssignment));
          }
        }
        function isExported(sourceFile, decl, useEs6Exports) {
          if (useEs6Exports) {
            return !ts2.isExpressionStatement(decl) && ts2.hasModifier(decl, 1);
          } else {
            return getNamesToExportInCommonJS(decl).some(function(name) {
              return sourceFile.symbol.exports.has(ts2.escapeLeadingUnderscores(name));
            });
          }
        }
        function addExport(decl, useEs6Exports) {
          return useEs6Exports ? [addEs6Export(decl)] : addCommonjsExport(decl);
        }
        function addEs6Export(d) {
          var modifiers = ts2.concatenate([ts2.createModifier(89)], d.modifiers);
          switch (d.kind) {
            case 244:
              return ts2.updateFunctionDeclaration(d, d.decorators, modifiers, d.asteriskToken, d.name, d.typeParameters, d.parameters, d.type, d.body);
            case 245:
              return ts2.updateClassDeclaration(d, d.decorators, modifiers, d.name, d.typeParameters, d.heritageClauses, d.members);
            case 225:
              return ts2.updateVariableStatement(d, modifiers, d.declarationList);
            case 249:
              return ts2.updateModuleDeclaration(d, d.decorators, modifiers, d.name, d.body);
            case 248:
              return ts2.updateEnumDeclaration(d, d.decorators, modifiers, d.name, d.members);
            case 247:
              return ts2.updateTypeAliasDeclaration(d, d.decorators, modifiers, d.name, d.typeParameters, d.type);
            case 246:
              return ts2.updateInterfaceDeclaration(d, d.decorators, modifiers, d.name, d.typeParameters, d.heritageClauses, d.members);
            case 253:
              return ts2.updateImportEqualsDeclaration(d, d.decorators, modifiers, d.name, d.moduleReference);
            case 226:
              return ts2.Debug.fail();
            default:
              return ts2.Debug.assertNever(d, "Unexpected declaration kind " + d.kind);
          }
        }
        function addCommonjsExport(decl) {
          return __spreadArrays([decl], getNamesToExportInCommonJS(decl).map(createExportAssignment));
        }
        function getNamesToExportInCommonJS(decl) {
          switch (decl.kind) {
            case 244:
            case 245:
              return [decl.name.text];
            case 225:
              return ts2.mapDefined(decl.declarationList.declarations, function(d) {
                return ts2.isIdentifier(d.name) ? d.name.text : void 0;
              });
            case 249:
            case 248:
            case 247:
            case 246:
            case 253:
              return ts2.emptyArray;
            case 226:
              return ts2.Debug.fail("Can't export an ExpressionStatement");
            default:
              return ts2.Debug.assertNever(decl, "Unexpected decl kind " + decl.kind);
          }
        }
        function createExportAssignment(name) {
          return ts2.createExpressionStatement(ts2.createBinary(ts2.createPropertyAccess(ts2.createIdentifier("exports"), ts2.createIdentifier(name)), 62, ts2.createIdentifier(name)));
        }
      })(refactor = ts2.refactor || (ts2.refactor = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var refactor;
      (function(refactor2) {
        var addOrRemoveBracesToArrowFunction;
        (function(addOrRemoveBracesToArrowFunction2) {
          var refactorName = "Add or remove braces in an arrow function";
          var refactorDescription = ts2.Diagnostics.Add_or_remove_braces_in_an_arrow_function.message;
          var addBracesActionName = "Add braces to arrow function";
          var removeBracesActionName = "Remove braces from arrow function";
          var addBracesActionDescription = ts2.Diagnostics.Add_braces_to_arrow_function.message;
          var removeBracesActionDescription = ts2.Diagnostics.Remove_braces_from_arrow_function.message;
          refactor2.registerRefactor(refactorName, { getEditsForAction, getAvailableActions });
          function getAvailableActions(context) {
            var file = context.file, startPosition = context.startPosition;
            var info = getConvertibleArrowFunctionAtPosition(file, startPosition);
            if (!info)
              return ts2.emptyArray;
            return [{
              name: refactorName,
              description: refactorDescription,
              actions: [
                info.addBraces ? {
                  name: addBracesActionName,
                  description: addBracesActionDescription
                } : {
                  name: removeBracesActionName,
                  description: removeBracesActionDescription
                }
              ]
            }];
          }
          function getEditsForAction(context, actionName) {
            var file = context.file, startPosition = context.startPosition;
            var info = getConvertibleArrowFunctionAtPosition(file, startPosition);
            if (!info)
              return void 0;
            var expression = info.expression, returnStatement = info.returnStatement, func = info.func;
            var body;
            if (actionName === addBracesActionName) {
              var returnStatement_1 = ts2.createReturn(expression);
              body = ts2.createBlock([returnStatement_1], true);
              ts2.suppressLeadingAndTrailingTrivia(body);
              ts2.copyLeadingComments(expression, returnStatement_1, file, 3, true);
            } else if (actionName === removeBracesActionName && returnStatement) {
              var actualExpression = expression || ts2.createVoidZero();
              body = ts2.needsParentheses(actualExpression) ? ts2.createParen(actualExpression) : actualExpression;
              ts2.suppressLeadingAndTrailingTrivia(body);
              ts2.copyTrailingAsLeadingComments(returnStatement, body, file, 3, false);
              ts2.copyLeadingComments(returnStatement, body, file, 3, false);
              ts2.copyTrailingComments(returnStatement, body, file, 3, false);
            } else {
              ts2.Debug.fail("invalid action");
            }
            var edits = ts2.textChanges.ChangeTracker.with(context, function(t) {
              t.replaceNode(file, func.body, body);
            });
            return { renameFilename: void 0, renameLocation: void 0, edits };
          }
          function getConvertibleArrowFunctionAtPosition(file, startPosition) {
            var node = ts2.getTokenAtPosition(file, startPosition);
            var func = ts2.getContainingFunction(node);
            if (!func || !ts2.isArrowFunction(func) || (!ts2.rangeContainsRange(func, node) || ts2.rangeContainsRange(func.body, node)))
              return void 0;
            if (ts2.isExpression(func.body)) {
              return {
                func,
                addBraces: true,
                expression: func.body
              };
            } else if (func.body.statements.length === 1) {
              var firstStatement = ts2.first(func.body.statements);
              if (ts2.isReturnStatement(firstStatement)) {
                return {
                  func,
                  addBraces: false,
                  expression: firstStatement.expression,
                  returnStatement: firstStatement
                };
              }
            }
            return void 0;
          }
        })(addOrRemoveBracesToArrowFunction = refactor2.addOrRemoveBracesToArrowFunction || (refactor2.addOrRemoveBracesToArrowFunction = {}));
      })(refactor = ts2.refactor || (ts2.refactor = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var refactor;
      (function(refactor2) {
        var convertParamsToDestructuredObject;
        (function(convertParamsToDestructuredObject2) {
          var refactorName = "Convert parameters to destructured object";
          var minimumParameterLength = 2;
          refactor2.registerRefactor(refactorName, { getEditsForAction, getAvailableActions });
          function getAvailableActions(context) {
            var file = context.file, startPosition = context.startPosition;
            var isJSFile = ts2.isSourceFileJS(file);
            if (isJSFile)
              return ts2.emptyArray;
            var functionDeclaration = getFunctionDeclarationAtPosition(file, startPosition, context.program.getTypeChecker());
            if (!functionDeclaration)
              return ts2.emptyArray;
            var description = ts2.getLocaleSpecificMessage(ts2.Diagnostics.Convert_parameters_to_destructured_object);
            return [{
              name: refactorName,
              description,
              actions: [{
                name: refactorName,
                description
              }]
            }];
          }
          function getEditsForAction(context, actionName) {
            ts2.Debug.assert(actionName === refactorName, "Unexpected action name");
            var file = context.file, startPosition = context.startPosition, program = context.program, cancellationToken = context.cancellationToken, host = context.host;
            var functionDeclaration = getFunctionDeclarationAtPosition(file, startPosition, program.getTypeChecker());
            if (!functionDeclaration || !cancellationToken)
              return void 0;
            var groupedReferences = getGroupedReferences(functionDeclaration, program, cancellationToken);
            if (groupedReferences.valid) {
              var edits = ts2.textChanges.ChangeTracker.with(context, function(t) {
                return doChange(file, program, host, t, functionDeclaration, groupedReferences);
              });
              return { renameFilename: void 0, renameLocation: void 0, edits };
            }
            return { edits: [] };
          }
          function doChange(sourceFile, program, host, changes, functionDeclaration, groupedReferences) {
            var newParamDeclaration = ts2.map(createNewParameters(functionDeclaration, program, host), function(param) {
              return ts2.getSynthesizedDeepClone(param);
            });
            changes.replaceNodeRangeWithNodes(sourceFile, ts2.first(functionDeclaration.parameters), ts2.last(functionDeclaration.parameters), newParamDeclaration, {
              joiner: ", ",
              indentation: 0,
              leadingTriviaOption: ts2.textChanges.LeadingTriviaOption.IncludeAll,
              trailingTriviaOption: ts2.textChanges.TrailingTriviaOption.Include
            });
            var functionCalls = ts2.sortAndDeduplicate(groupedReferences.functionCalls, function(a, b) {
              return ts2.compareValues(a.pos, b.pos);
            });
            for (var _i = 0, functionCalls_1 = functionCalls; _i < functionCalls_1.length; _i++) {
              var call = functionCalls_1[_i];
              if (call.arguments && call.arguments.length) {
                var newArgument = ts2.getSynthesizedDeepClone(createNewArgument(functionDeclaration, call.arguments), true);
                changes.replaceNodeRange(ts2.getSourceFileOfNode(call), ts2.first(call.arguments), ts2.last(call.arguments), newArgument, { leadingTriviaOption: ts2.textChanges.LeadingTriviaOption.IncludeAll, trailingTriviaOption: ts2.textChanges.TrailingTriviaOption.Include });
              }
            }
          }
          function getGroupedReferences(functionDeclaration, program, cancellationToken) {
            var functionNames = getFunctionNames(functionDeclaration);
            var classNames = ts2.isConstructorDeclaration(functionDeclaration) ? getClassNames(functionDeclaration) : [];
            var names = ts2.deduplicate(__spreadArrays(functionNames, classNames), ts2.equateValues);
            var checker = program.getTypeChecker();
            var references = ts2.flatMap(names, function(name) {
              return ts2.FindAllReferences.getReferenceEntriesForNode(-1, name, program, program.getSourceFiles(), cancellationToken);
            });
            var groupedReferences = groupReferences(references);
            if (!ts2.every(groupedReferences.declarations, function(decl) {
              return ts2.contains(names, decl);
            })) {
              groupedReferences.valid = false;
            }
            return groupedReferences;
            function groupReferences(referenceEntries) {
              var classReferences = { accessExpressions: [], typeUsages: [] };
              var groupedReferences2 = { functionCalls: [], declarations: [], classReferences, valid: true };
              var functionSymbols = ts2.map(functionNames, getSymbolTargetAtLocation);
              var classSymbols = ts2.map(classNames, getSymbolTargetAtLocation);
              var isConstructor = ts2.isConstructorDeclaration(functionDeclaration);
              for (var _i = 0, referenceEntries_1 = referenceEntries; _i < referenceEntries_1.length; _i++) {
                var entry = referenceEntries_1[_i];
                if (entry.kind !== 1) {
                  groupedReferences2.valid = false;
                  continue;
                }
                if (ts2.contains(functionSymbols, getSymbolTargetAtLocation(entry.node)) || ts2.isNewExpressionTarget(entry.node)) {
                  var importOrExportReference = entryToImportOrExport(entry);
                  if (importOrExportReference) {
                    continue;
                  }
                  var decl = entryToDeclaration(entry);
                  if (decl) {
                    groupedReferences2.declarations.push(decl);
                    continue;
                  }
                  var call = entryToFunctionCall(entry);
                  if (call) {
                    groupedReferences2.functionCalls.push(call);
                    continue;
                  }
                }
                if (isConstructor && ts2.contains(classSymbols, getSymbolTargetAtLocation(entry.node))) {
                  var importOrExportReference = entryToImportOrExport(entry);
                  if (importOrExportReference) {
                    continue;
                  }
                  var decl = entryToDeclaration(entry);
                  if (decl) {
                    groupedReferences2.declarations.push(decl);
                    continue;
                  }
                  var accessExpression = entryToAccessExpression(entry);
                  if (accessExpression) {
                    classReferences.accessExpressions.push(accessExpression);
                    continue;
                  }
                  if (ts2.isClassDeclaration(functionDeclaration.parent)) {
                    var type = entryToType(entry);
                    if (type) {
                      classReferences.typeUsages.push(type);
                      continue;
                    }
                  }
                }
                groupedReferences2.valid = false;
              }
              return groupedReferences2;
            }
            function getSymbolTargetAtLocation(node) {
              var symbol = checker.getSymbolAtLocation(node);
              return symbol && ts2.getSymbolTarget(symbol, checker);
            }
          }
          function entryToImportOrExport(entry) {
            var node = entry.node;
            if (ts2.isImportSpecifier(node.parent) || ts2.isImportClause(node.parent) || ts2.isImportEqualsDeclaration(node.parent) || ts2.isNamespaceImport(node.parent)) {
              return node;
            }
            if (ts2.isExportSpecifier(node.parent) || ts2.isExportAssignment(node.parent)) {
              return node;
            }
            return void 0;
          }
          function entryToDeclaration(entry) {
            if (ts2.isDeclaration(entry.node.parent)) {
              return entry.node;
            }
            return void 0;
          }
          function entryToFunctionCall(entry) {
            if (entry.node.parent) {
              var functionReference = entry.node;
              var parent = functionReference.parent;
              switch (parent.kind) {
                case 196:
                case 197:
                  var callOrNewExpression = ts2.tryCast(parent, ts2.isCallOrNewExpression);
                  if (callOrNewExpression && callOrNewExpression.expression === functionReference) {
                    return callOrNewExpression;
                  }
                  break;
                case 194:
                  var propertyAccessExpression = ts2.tryCast(parent, ts2.isPropertyAccessExpression);
                  if (propertyAccessExpression && propertyAccessExpression.parent && propertyAccessExpression.name === functionReference) {
                    var callOrNewExpression_1 = ts2.tryCast(propertyAccessExpression.parent, ts2.isCallOrNewExpression);
                    if (callOrNewExpression_1 && callOrNewExpression_1.expression === propertyAccessExpression) {
                      return callOrNewExpression_1;
                    }
                  }
                  break;
                case 195:
                  var elementAccessExpression = ts2.tryCast(parent, ts2.isElementAccessExpression);
                  if (elementAccessExpression && elementAccessExpression.parent && elementAccessExpression.argumentExpression === functionReference) {
                    var callOrNewExpression_2 = ts2.tryCast(elementAccessExpression.parent, ts2.isCallOrNewExpression);
                    if (callOrNewExpression_2 && callOrNewExpression_2.expression === elementAccessExpression) {
                      return callOrNewExpression_2;
                    }
                  }
                  break;
              }
            }
            return void 0;
          }
          function entryToAccessExpression(entry) {
            if (entry.node.parent) {
              var reference = entry.node;
              var parent = reference.parent;
              switch (parent.kind) {
                case 194:
                  var propertyAccessExpression = ts2.tryCast(parent, ts2.isPropertyAccessExpression);
                  if (propertyAccessExpression && propertyAccessExpression.expression === reference) {
                    return propertyAccessExpression;
                  }
                  break;
                case 195:
                  var elementAccessExpression = ts2.tryCast(parent, ts2.isElementAccessExpression);
                  if (elementAccessExpression && elementAccessExpression.expression === reference) {
                    return elementAccessExpression;
                  }
                  break;
              }
            }
            return void 0;
          }
          function entryToType(entry) {
            var reference = entry.node;
            if (ts2.getMeaningFromLocation(reference) === 2 || ts2.isExpressionWithTypeArgumentsInClassExtendsClause(reference.parent)) {
              return reference;
            }
            return void 0;
          }
          function getFunctionDeclarationAtPosition(file, startPosition, checker) {
            var node = ts2.getTouchingToken(file, startPosition);
            var functionDeclaration = ts2.getContainingFunctionDeclaration(node);
            if (isTopLevelJSDoc(node))
              return void 0;
            if (functionDeclaration && isValidFunctionDeclaration(functionDeclaration, checker) && ts2.rangeContainsRange(functionDeclaration, node) && !(functionDeclaration.body && ts2.rangeContainsRange(functionDeclaration.body, node)))
              return functionDeclaration;
            return void 0;
          }
          function isTopLevelJSDoc(node) {
            var containingJSDoc = ts2.findAncestor(node, ts2.isJSDocNode);
            if (containingJSDoc) {
              var containingNonJSDoc = ts2.findAncestor(containingJSDoc, function(n) {
                return !ts2.isJSDocNode(n);
              });
              return !!containingNonJSDoc && ts2.isFunctionLikeDeclaration(containingNonJSDoc);
            }
            return false;
          }
          function isValidFunctionDeclaration(functionDeclaration, checker) {
            if (!isValidParameterNodeArray(functionDeclaration.parameters, checker))
              return false;
            switch (functionDeclaration.kind) {
              case 244:
                return hasNameOrDefault(functionDeclaration) && isSingleImplementation(functionDeclaration, checker);
              case 161:
                return isSingleImplementation(functionDeclaration, checker);
              case 162:
                if (ts2.isClassDeclaration(functionDeclaration.parent)) {
                  return hasNameOrDefault(functionDeclaration.parent) && isSingleImplementation(functionDeclaration, checker);
                } else {
                  return isValidVariableDeclaration(functionDeclaration.parent.parent) && isSingleImplementation(functionDeclaration, checker);
                }
              case 201:
              case 202:
                return isValidVariableDeclaration(functionDeclaration.parent);
            }
            return false;
          }
          function isSingleImplementation(functionDeclaration, checker) {
            return !!functionDeclaration.body && !checker.isImplementationOfOverload(functionDeclaration);
          }
          function hasNameOrDefault(functionOrClassDeclaration) {
            if (!functionOrClassDeclaration.name) {
              var defaultKeyword = ts2.findModifier(functionOrClassDeclaration, 84);
              return !!defaultKeyword;
            }
            return true;
          }
          function isValidParameterNodeArray(parameters, checker) {
            return getRefactorableParametersLength(parameters) >= minimumParameterLength && ts2.every(parameters, function(paramDecl) {
              return isValidParameterDeclaration(paramDecl, checker);
            });
          }
          function isValidParameterDeclaration(parameterDeclaration, checker) {
            if (ts2.isRestParameter(parameterDeclaration)) {
              var type = checker.getTypeAtLocation(parameterDeclaration);
              if (!checker.isArrayType(type) && !checker.isTupleType(type))
                return false;
            }
            return !parameterDeclaration.modifiers && !parameterDeclaration.decorators && ts2.isIdentifier(parameterDeclaration.name);
          }
          function isValidVariableDeclaration(node) {
            return ts2.isVariableDeclaration(node) && ts2.isVarConst(node) && ts2.isIdentifier(node.name) && !node.type;
          }
          function hasThisParameter(parameters) {
            return parameters.length > 0 && ts2.isThis(parameters[0].name);
          }
          function getRefactorableParametersLength(parameters) {
            if (hasThisParameter(parameters)) {
              return parameters.length - 1;
            }
            return parameters.length;
          }
          function getRefactorableParameters(parameters) {
            if (hasThisParameter(parameters)) {
              parameters = ts2.createNodeArray(parameters.slice(1), parameters.hasTrailingComma);
            }
            return parameters;
          }
          function createPropertyOrShorthandAssignment(name, initializer) {
            if (ts2.isIdentifier(initializer) && ts2.getTextOfIdentifierOrLiteral(initializer) === name) {
              return ts2.createShorthandPropertyAssignment(name);
            }
            return ts2.createPropertyAssignment(name, initializer);
          }
          function createNewArgument(functionDeclaration, functionArguments) {
            var parameters = getRefactorableParameters(functionDeclaration.parameters);
            var hasRestParameter = ts2.isRestParameter(ts2.last(parameters));
            var nonRestArguments = hasRestParameter ? functionArguments.slice(0, parameters.length - 1) : functionArguments;
            var properties = ts2.map(nonRestArguments, function(arg, i) {
              var parameterName = getParameterName(parameters[i]);
              var property = createPropertyOrShorthandAssignment(parameterName, arg);
              ts2.suppressLeadingAndTrailingTrivia(property.name);
              if (ts2.isPropertyAssignment(property))
                ts2.suppressLeadingAndTrailingTrivia(property.initializer);
              ts2.copyComments(arg, property);
              return property;
            });
            if (hasRestParameter && functionArguments.length >= parameters.length) {
              var restArguments = functionArguments.slice(parameters.length - 1);
              var restProperty = ts2.createPropertyAssignment(getParameterName(ts2.last(parameters)), ts2.createArrayLiteral(restArguments));
              properties.push(restProperty);
            }
            var objectLiteral = ts2.createObjectLiteral(properties, false);
            return objectLiteral;
          }
          function createNewParameters(functionDeclaration, program, host) {
            var checker = program.getTypeChecker();
            var refactorableParameters = getRefactorableParameters(functionDeclaration.parameters);
            var bindingElements = ts2.map(refactorableParameters, createBindingElementFromParameterDeclaration);
            var objectParameterName = ts2.createObjectBindingPattern(bindingElements);
            var objectParameterType = createParameterTypeNode(refactorableParameters);
            var objectInitializer;
            if (ts2.every(refactorableParameters, isOptionalParameter)) {
              objectInitializer = ts2.createObjectLiteral();
            }
            var objectParameter = ts2.createParameter(void 0, void 0, void 0, objectParameterName, void 0, objectParameterType, objectInitializer);
            if (hasThisParameter(functionDeclaration.parameters)) {
              var thisParameter = functionDeclaration.parameters[0];
              var newThisParameter = ts2.createParameter(void 0, void 0, void 0, thisParameter.name, void 0, thisParameter.type);
              ts2.suppressLeadingAndTrailingTrivia(newThisParameter.name);
              ts2.copyComments(thisParameter.name, newThisParameter.name);
              if (thisParameter.type) {
                ts2.suppressLeadingAndTrailingTrivia(newThisParameter.type);
                ts2.copyComments(thisParameter.type, newThisParameter.type);
              }
              return ts2.createNodeArray([newThisParameter, objectParameter]);
            }
            return ts2.createNodeArray([objectParameter]);
            function createBindingElementFromParameterDeclaration(parameterDeclaration) {
              var element = ts2.createBindingElement(void 0, void 0, getParameterName(parameterDeclaration), ts2.isRestParameter(parameterDeclaration) && isOptionalParameter(parameterDeclaration) ? ts2.createArrayLiteral() : parameterDeclaration.initializer);
              ts2.suppressLeadingAndTrailingTrivia(element);
              if (parameterDeclaration.initializer && element.initializer) {
                ts2.copyComments(parameterDeclaration.initializer, element.initializer);
              }
              return element;
            }
            function createParameterTypeNode(parameters) {
              var members = ts2.map(parameters, createPropertySignatureFromParameterDeclaration);
              var typeNode = ts2.addEmitFlags(ts2.createTypeLiteralNode(members), 1);
              return typeNode;
            }
            function createPropertySignatureFromParameterDeclaration(parameterDeclaration) {
              var parameterType = parameterDeclaration.type;
              if (!parameterType && (parameterDeclaration.initializer || ts2.isRestParameter(parameterDeclaration))) {
                parameterType = getTypeNode(parameterDeclaration);
              }
              var propertySignature = ts2.createPropertySignature(void 0, getParameterName(parameterDeclaration), isOptionalParameter(parameterDeclaration) ? ts2.createToken(57) : parameterDeclaration.questionToken, parameterType, void 0);
              ts2.suppressLeadingAndTrailingTrivia(propertySignature);
              ts2.copyComments(parameterDeclaration.name, propertySignature.name);
              if (parameterDeclaration.type && propertySignature.type) {
                ts2.copyComments(parameterDeclaration.type, propertySignature.type);
              }
              return propertySignature;
            }
            function getTypeNode(node) {
              var type = checker.getTypeAtLocation(node);
              return ts2.getTypeNodeIfAccessible(type, node, program, host);
            }
            function isOptionalParameter(parameterDeclaration) {
              if (ts2.isRestParameter(parameterDeclaration)) {
                var type = checker.getTypeAtLocation(parameterDeclaration);
                return !checker.isTupleType(type);
              }
              return checker.isOptionalParameter(parameterDeclaration);
            }
          }
          function getParameterName(paramDeclaration) {
            return ts2.getTextOfIdentifierOrLiteral(paramDeclaration.name);
          }
          function getClassNames(constructorDeclaration) {
            switch (constructorDeclaration.parent.kind) {
              case 245:
                var classDeclaration = constructorDeclaration.parent;
                if (classDeclaration.name)
                  return [classDeclaration.name];
                var defaultModifier = ts2.Debug.checkDefined(ts2.findModifier(classDeclaration, 84), "Nameless class declaration should be a default export");
                return [defaultModifier];
              case 214:
                var classExpression = constructorDeclaration.parent;
                var variableDeclaration = constructorDeclaration.parent.parent;
                var className = classExpression.name;
                if (className)
                  return [className, variableDeclaration.name];
                return [variableDeclaration.name];
            }
          }
          function getFunctionNames(functionDeclaration) {
            switch (functionDeclaration.kind) {
              case 244:
                if (functionDeclaration.name)
                  return [functionDeclaration.name];
                var defaultModifier = ts2.Debug.checkDefined(ts2.findModifier(functionDeclaration, 84), "Nameless function declaration should be a default export");
                return [defaultModifier];
              case 161:
                return [functionDeclaration.name];
              case 162:
                var ctrKeyword = ts2.Debug.checkDefined(ts2.findChildOfKind(functionDeclaration, 129, functionDeclaration.getSourceFile()), "Constructor declaration should have constructor keyword");
                if (functionDeclaration.parent.kind === 214) {
                  var variableDeclaration = functionDeclaration.parent.parent;
                  return [variableDeclaration.name, ctrKeyword];
                }
                return [ctrKeyword];
              case 202:
                return [functionDeclaration.parent.name];
              case 201:
                if (functionDeclaration.name)
                  return [functionDeclaration.name, functionDeclaration.parent.name];
                return [functionDeclaration.parent.name];
              default:
                return ts2.Debug.assertNever(functionDeclaration, "Unexpected function declaration kind " + functionDeclaration.kind);
            }
          }
        })(convertParamsToDestructuredObject = refactor2.convertParamsToDestructuredObject || (refactor2.convertParamsToDestructuredObject = {}));
      })(refactor = ts2.refactor || (ts2.refactor = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var refactor;
      (function(refactor2) {
        var convertStringOrTemplateLiteral;
        (function(convertStringOrTemplateLiteral2) {
          var refactorName = "Convert to template string";
          var refactorDescription = ts2.getLocaleSpecificMessage(ts2.Diagnostics.Convert_to_template_string);
          refactor2.registerRefactor(refactorName, { getEditsForAction, getAvailableActions });
          function getAvailableActions(context) {
            var file = context.file, startPosition = context.startPosition;
            var node = getNodeOrParentOfParentheses(file, startPosition);
            var maybeBinary = getParentBinaryExpression(node);
            var refactorInfo = { name: refactorName, description: refactorDescription, actions: [] };
            if (ts2.isBinaryExpression(maybeBinary) && isStringConcatenationValid(maybeBinary)) {
              refactorInfo.actions.push({ name: refactorName, description: refactorDescription });
              return [refactorInfo];
            }
            return ts2.emptyArray;
          }
          function getNodeOrParentOfParentheses(file, startPosition) {
            var node = ts2.getTokenAtPosition(file, startPosition);
            var nestedBinary = getParentBinaryExpression(node);
            var isNonStringBinary = !isStringConcatenationValid(nestedBinary);
            if (isNonStringBinary && ts2.isParenthesizedExpression(nestedBinary.parent) && ts2.isBinaryExpression(nestedBinary.parent.parent)) {
              return nestedBinary.parent.parent;
            }
            return node;
          }
          function getEditsForAction(context, actionName) {
            var file = context.file, startPosition = context.startPosition;
            var node = getNodeOrParentOfParentheses(file, startPosition);
            switch (actionName) {
              case refactorDescription:
                return { edits: getEditsForToTemplateLiteral(context, node) };
              default:
                return ts2.Debug.fail("invalid action");
            }
          }
          function getEditsForToTemplateLiteral(context, node) {
            var maybeBinary = getParentBinaryExpression(node);
            var file = context.file;
            var templateLiteral = nodesToTemplate(treeToArray(maybeBinary), file);
            var trailingCommentRanges = ts2.getTrailingCommentRanges(file.text, maybeBinary.end);
            if (trailingCommentRanges) {
              var lastComment = trailingCommentRanges[trailingCommentRanges.length - 1];
              var trailingRange_1 = { pos: trailingCommentRanges[0].pos, end: lastComment.end };
              return ts2.textChanges.ChangeTracker.with(context, function(t) {
                t.deleteRange(file, trailingRange_1);
                t.replaceNode(file, maybeBinary, templateLiteral);
              });
            } else {
              return ts2.textChanges.ChangeTracker.with(context, function(t) {
                return t.replaceNode(file, maybeBinary, templateLiteral);
              });
            }
          }
          function isNotEqualsOperator(node) {
            return node.operatorToken.kind !== 62;
          }
          function getParentBinaryExpression(expr) {
            while (ts2.isBinaryExpression(expr.parent) && isNotEqualsOperator(expr.parent)) {
              expr = expr.parent;
            }
            return expr;
          }
          function isStringConcatenationValid(node) {
            var _a = treeToArray(node), containsString = _a.containsString, areOperatorsValid = _a.areOperatorsValid;
            return containsString && areOperatorsValid;
          }
          function treeToArray(current) {
            if (ts2.isBinaryExpression(current)) {
              var _a = treeToArray(current.left), nodes = _a.nodes, operators = _a.operators, leftHasString = _a.containsString, leftOperatorValid = _a.areOperatorsValid;
              if (!leftHasString && !ts2.isStringLiteral(current.right)) {
                return { nodes: [current], operators: [], containsString: false, areOperatorsValid: true };
              }
              var currentOperatorValid = current.operatorToken.kind === 39;
              var areOperatorsValid = leftOperatorValid && currentOperatorValid;
              nodes.push(current.right);
              operators.push(current.operatorToken);
              return { nodes, operators, containsString: true, areOperatorsValid };
            }
            return { nodes: [current], operators: [], containsString: ts2.isStringLiteral(current), areOperatorsValid: true };
          }
          var copyTrailingOperatorComments = function(operators, file) {
            return function(index, targetNode) {
              if (index < operators.length) {
                ts2.copyTrailingComments(operators[index], targetNode, file, 3, false);
              }
            };
          };
          var copyCommentFromMultiNode = function(nodes, file, copyOperatorComments) {
            return function(indexes, targetNode) {
              while (indexes.length > 0) {
                var index = indexes.shift();
                ts2.copyTrailingComments(nodes[index], targetNode, file, 3, false);
                copyOperatorComments(index, targetNode);
              }
            };
          };
          function concatConsecutiveString(index, nodes) {
            var text = "";
            var indexes = [];
            while (index < nodes.length && ts2.isStringLiteral(nodes[index])) {
              var stringNode = nodes[index];
              text = text + stringNode.text;
              indexes.push(index);
              index++;
            }
            return [index, text, indexes];
          }
          function nodesToTemplate(_a, file) {
            var nodes = _a.nodes, operators = _a.operators;
            var copyOperatorComments = copyTrailingOperatorComments(operators, file);
            var copyCommentFromStringLiterals = copyCommentFromMultiNode(nodes, file, copyOperatorComments);
            var _b = concatConsecutiveString(0, nodes), begin = _b[0], headText = _b[1], headIndexes = _b[2];
            if (begin === nodes.length) {
              var noSubstitutionTemplateLiteral = ts2.createNoSubstitutionTemplateLiteral(headText);
              copyCommentFromStringLiterals(headIndexes, noSubstitutionTemplateLiteral);
              return noSubstitutionTemplateLiteral;
            }
            var templateSpans = [];
            var templateHead = ts2.createTemplateHead(headText);
            copyCommentFromStringLiterals(headIndexes, templateHead);
            for (var i = begin; i < nodes.length; i++) {
              var currentNode = getExpressionFromParenthesesOrExpression(nodes[i]);
              copyOperatorComments(i, currentNode);
              var _c = concatConsecutiveString(i + 1, nodes), newIndex = _c[0], subsequentText = _c[1], stringIndexes = _c[2];
              i = newIndex - 1;
              var templatePart = i === nodes.length - 1 ? ts2.createTemplateTail(subsequentText) : ts2.createTemplateMiddle(subsequentText);
              copyCommentFromStringLiterals(stringIndexes, templatePart);
              templateSpans.push(ts2.createTemplateSpan(currentNode, templatePart));
            }
            return ts2.createTemplateExpression(templateHead, templateSpans);
          }
          function copyCommentsWhenParenthesized(node) {
            var file = node.getSourceFile();
            ts2.copyTrailingComments(node, node.expression, file, 3, false);
            ts2.copyTrailingAsLeadingComments(node.expression, node.expression, file, 3, false);
          }
          function getExpressionFromParenthesesOrExpression(node) {
            if (ts2.isParenthesizedExpression(node)) {
              copyCommentsWhenParenthesized(node);
              node = node.expression;
            }
            return node;
          }
        })(convertStringOrTemplateLiteral = refactor2.convertStringOrTemplateLiteral || (refactor2.convertStringOrTemplateLiteral = {}));
      })(refactor = ts2.refactor || (ts2.refactor = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      ts2.servicesVersion = "0.8";
      function createNode(kind, pos, end, parent) {
        var node = ts2.isNodeKind(kind) ? new NodeObject(kind, pos, end) : kind === 75 ? new IdentifierObject(75, pos, end) : kind === 76 ? new PrivateIdentifierObject(76, pos, end) : new TokenObject(kind, pos, end);
        node.parent = parent;
        node.flags = parent.flags & 25358336;
        return node;
      }
      var NodeObject = function() {
        function NodeObject2(kind, pos, end) {
          this.pos = pos;
          this.end = end;
          this.flags = 0;
          this.modifierFlagsCache = 0;
          this.transformFlags = 0;
          this.parent = void 0;
          this.kind = kind;
        }
        NodeObject2.prototype.assertHasRealPosition = function(message) {
          ts2.Debug.assert(!ts2.positionIsSynthesized(this.pos) && !ts2.positionIsSynthesized(this.end), message || "Node must have a real position for this operation");
        };
        NodeObject2.prototype.getSourceFile = function() {
          return ts2.getSourceFileOfNode(this);
        };
        NodeObject2.prototype.getStart = function(sourceFile, includeJsDocComment) {
          this.assertHasRealPosition();
          return ts2.getTokenPosOfNode(this, sourceFile, includeJsDocComment);
        };
        NodeObject2.prototype.getFullStart = function() {
          this.assertHasRealPosition();
          return this.pos;
        };
        NodeObject2.prototype.getEnd = function() {
          this.assertHasRealPosition();
          return this.end;
        };
        NodeObject2.prototype.getWidth = function(sourceFile) {
          this.assertHasRealPosition();
          return this.getEnd() - this.getStart(sourceFile);
        };
        NodeObject2.prototype.getFullWidth = function() {
          this.assertHasRealPosition();
          return this.end - this.pos;
        };
        NodeObject2.prototype.getLeadingTriviaWidth = function(sourceFile) {
          this.assertHasRealPosition();
          return this.getStart(sourceFile) - this.pos;
        };
        NodeObject2.prototype.getFullText = function(sourceFile) {
          this.assertHasRealPosition();
          return (sourceFile || this.getSourceFile()).text.substring(this.pos, this.end);
        };
        NodeObject2.prototype.getText = function(sourceFile) {
          this.assertHasRealPosition();
          if (!sourceFile) {
            sourceFile = this.getSourceFile();
          }
          return sourceFile.text.substring(this.getStart(sourceFile), this.getEnd());
        };
        NodeObject2.prototype.getChildCount = function(sourceFile) {
          return this.getChildren(sourceFile).length;
        };
        NodeObject2.prototype.getChildAt = function(index, sourceFile) {
          return this.getChildren(sourceFile)[index];
        };
        NodeObject2.prototype.getChildren = function(sourceFile) {
          this.assertHasRealPosition("Node without a real position cannot be scanned and thus has no token nodes - use forEachChild and collect the result if that's fine");
          return this._children || (this._children = createChildren(this, sourceFile));
        };
        NodeObject2.prototype.getFirstToken = function(sourceFile) {
          this.assertHasRealPosition();
          var children = this.getChildren(sourceFile);
          if (!children.length) {
            return void 0;
          }
          var child = ts2.find(children, function(kid) {
            return kid.kind < 294 || kid.kind > 323;
          });
          return child.kind < 153 ? child : child.getFirstToken(sourceFile);
        };
        NodeObject2.prototype.getLastToken = function(sourceFile) {
          this.assertHasRealPosition();
          var children = this.getChildren(sourceFile);
          var child = ts2.lastOrUndefined(children);
          if (!child) {
            return void 0;
          }
          return child.kind < 153 ? child : child.getLastToken(sourceFile);
        };
        NodeObject2.prototype.forEachChild = function(cbNode, cbNodeArray) {
          return ts2.forEachChild(this, cbNode, cbNodeArray);
        };
        return NodeObject2;
      }();
      function createChildren(node, sourceFile) {
        if (!ts2.isNodeKind(node.kind)) {
          return ts2.emptyArray;
        }
        var children = [];
        if (ts2.isJSDocCommentContainingNode(node)) {
          node.forEachChild(function(child) {
            children.push(child);
          });
          return children;
        }
        ts2.scanner.setText((sourceFile || node.getSourceFile()).text);
        var pos = node.pos;
        var processNode = function(child) {
          addSyntheticNodes(children, pos, child.pos, node);
          children.push(child);
          pos = child.end;
        };
        var processNodes = function(nodes) {
          addSyntheticNodes(children, pos, nodes.pos, node);
          children.push(createSyntaxList(nodes, node));
          pos = nodes.end;
        };
        ts2.forEach(node.jsDoc, processNode);
        pos = node.pos;
        node.forEachChild(processNode, processNodes);
        addSyntheticNodes(children, pos, node.end, node);
        ts2.scanner.setText(void 0);
        return children;
      }
      function addSyntheticNodes(nodes, pos, end, parent) {
        ts2.scanner.setTextPos(pos);
        while (pos < end) {
          var token = ts2.scanner.scan();
          var textPos = ts2.scanner.getTextPos();
          if (textPos <= end) {
            if (token === 75) {
              ts2.Debug.fail("Did not expect " + ts2.Debug.formatSyntaxKind(parent.kind) + " to have an Identifier in its trivia");
            }
            nodes.push(createNode(token, pos, textPos, parent));
          }
          pos = textPos;
          if (token === 1) {
            break;
          }
        }
      }
      function createSyntaxList(nodes, parent) {
        var list = createNode(324, nodes.pos, nodes.end, parent);
        list._children = [];
        var pos = nodes.pos;
        for (var _i = 0, nodes_1 = nodes; _i < nodes_1.length; _i++) {
          var node = nodes_1[_i];
          addSyntheticNodes(list._children, pos, node.pos, parent);
          list._children.push(node);
          pos = node.end;
        }
        addSyntheticNodes(list._children, pos, nodes.end, parent);
        return list;
      }
      var TokenOrIdentifierObject = function() {
        function TokenOrIdentifierObject2(pos, end) {
          this.pos = pos;
          this.end = end;
          this.flags = 0;
          this.modifierFlagsCache = 0;
          this.transformFlags = 0;
          this.parent = void 0;
        }
        TokenOrIdentifierObject2.prototype.getSourceFile = function() {
          return ts2.getSourceFileOfNode(this);
        };
        TokenOrIdentifierObject2.prototype.getStart = function(sourceFile, includeJsDocComment) {
          return ts2.getTokenPosOfNode(this, sourceFile, includeJsDocComment);
        };
        TokenOrIdentifierObject2.prototype.getFullStart = function() {
          return this.pos;
        };
        TokenOrIdentifierObject2.prototype.getEnd = function() {
          return this.end;
        };
        TokenOrIdentifierObject2.prototype.getWidth = function(sourceFile) {
          return this.getEnd() - this.getStart(sourceFile);
        };
        TokenOrIdentifierObject2.prototype.getFullWidth = function() {
          return this.end - this.pos;
        };
        TokenOrIdentifierObject2.prototype.getLeadingTriviaWidth = function(sourceFile) {
          return this.getStart(sourceFile) - this.pos;
        };
        TokenOrIdentifierObject2.prototype.getFullText = function(sourceFile) {
          return (sourceFile || this.getSourceFile()).text.substring(this.pos, this.end);
        };
        TokenOrIdentifierObject2.prototype.getText = function(sourceFile) {
          if (!sourceFile) {
            sourceFile = this.getSourceFile();
          }
          return sourceFile.text.substring(this.getStart(sourceFile), this.getEnd());
        };
        TokenOrIdentifierObject2.prototype.getChildCount = function() {
          return 0;
        };
        TokenOrIdentifierObject2.prototype.getChildAt = function() {
          return void 0;
        };
        TokenOrIdentifierObject2.prototype.getChildren = function() {
          return this.kind === 1 ? this.jsDoc || ts2.emptyArray : ts2.emptyArray;
        };
        TokenOrIdentifierObject2.prototype.getFirstToken = function() {
          return void 0;
        };
        TokenOrIdentifierObject2.prototype.getLastToken = function() {
          return void 0;
        };
        TokenOrIdentifierObject2.prototype.forEachChild = function() {
          return void 0;
        };
        return TokenOrIdentifierObject2;
      }();
      var SymbolObject = function() {
        function SymbolObject2(flags, name) {
          this.flags = flags;
          this.escapedName = name;
        }
        SymbolObject2.prototype.getFlags = function() {
          return this.flags;
        };
        Object.defineProperty(SymbolObject2.prototype, "name", {
          get: function() {
            return ts2.symbolName(this);
          },
          enumerable: false,
          configurable: true
        });
        SymbolObject2.prototype.getEscapedName = function() {
          return this.escapedName;
        };
        SymbolObject2.prototype.getName = function() {
          return this.name;
        };
        SymbolObject2.prototype.getDeclarations = function() {
          return this.declarations;
        };
        SymbolObject2.prototype.getDocumentationComment = function(checker) {
          if (!this.documentationComment) {
            this.documentationComment = ts2.emptyArray;
            this.documentationComment = getDocumentationComment(this.declarations, checker);
          }
          return this.documentationComment;
        };
        SymbolObject2.prototype.getJsDocTags = function() {
          if (this.tags === void 0) {
            this.tags = ts2.JsDoc.getJsDocTagsFromDeclarations(this.declarations);
          }
          return this.tags;
        };
        return SymbolObject2;
      }();
      var TokenObject = function(_super) {
        __extends(TokenObject2, _super);
        function TokenObject2(kind, pos, end) {
          var _this = _super.call(this, pos, end) || this;
          _this.kind = kind;
          return _this;
        }
        return TokenObject2;
      }(TokenOrIdentifierObject);
      var IdentifierObject = function(_super) {
        __extends(IdentifierObject2, _super);
        function IdentifierObject2(_kind, pos, end) {
          var _this = _super.call(this, pos, end) || this;
          _this.kind = 75;
          return _this;
        }
        Object.defineProperty(IdentifierObject2.prototype, "text", {
          get: function() {
            return ts2.idText(this);
          },
          enumerable: false,
          configurable: true
        });
        return IdentifierObject2;
      }(TokenOrIdentifierObject);
      IdentifierObject.prototype.kind = 75;
      var PrivateIdentifierObject = function(_super) {
        __extends(PrivateIdentifierObject2, _super);
        function PrivateIdentifierObject2(_kind, pos, end) {
          return _super.call(this, pos, end) || this;
        }
        Object.defineProperty(PrivateIdentifierObject2.prototype, "text", {
          get: function() {
            return ts2.idText(this);
          },
          enumerable: false,
          configurable: true
        });
        return PrivateIdentifierObject2;
      }(TokenOrIdentifierObject);
      PrivateIdentifierObject.prototype.kind = 76;
      var TypeObject = function() {
        function TypeObject2(checker, flags) {
          this.checker = checker;
          this.flags = flags;
        }
        TypeObject2.prototype.getFlags = function() {
          return this.flags;
        };
        TypeObject2.prototype.getSymbol = function() {
          return this.symbol;
        };
        TypeObject2.prototype.getProperties = function() {
          return this.checker.getPropertiesOfType(this);
        };
        TypeObject2.prototype.getProperty = function(propertyName) {
          return this.checker.getPropertyOfType(this, propertyName);
        };
        TypeObject2.prototype.getApparentProperties = function() {
          return this.checker.getAugmentedPropertiesOfType(this);
        };
        TypeObject2.prototype.getCallSignatures = function() {
          return this.checker.getSignaturesOfType(this, 0);
        };
        TypeObject2.prototype.getConstructSignatures = function() {
          return this.checker.getSignaturesOfType(this, 1);
        };
        TypeObject2.prototype.getStringIndexType = function() {
          return this.checker.getIndexTypeOfType(this, 0);
        };
        TypeObject2.prototype.getNumberIndexType = function() {
          return this.checker.getIndexTypeOfType(this, 1);
        };
        TypeObject2.prototype.getBaseTypes = function() {
          return this.isClassOrInterface() ? this.checker.getBaseTypes(this) : void 0;
        };
        TypeObject2.prototype.isNullableType = function() {
          return this.checker.isNullableType(this);
        };
        TypeObject2.prototype.getNonNullableType = function() {
          return this.checker.getNonNullableType(this);
        };
        TypeObject2.prototype.getNonOptionalType = function() {
          return this.checker.getNonOptionalType(this);
        };
        TypeObject2.prototype.getConstraint = function() {
          return this.checker.getBaseConstraintOfType(this);
        };
        TypeObject2.prototype.getDefault = function() {
          return this.checker.getDefaultFromTypeParameter(this);
        };
        TypeObject2.prototype.isUnion = function() {
          return !!(this.flags & 1048576);
        };
        TypeObject2.prototype.isIntersection = function() {
          return !!(this.flags & 2097152);
        };
        TypeObject2.prototype.isUnionOrIntersection = function() {
          return !!(this.flags & 3145728);
        };
        TypeObject2.prototype.isLiteral = function() {
          return !!(this.flags & 384);
        };
        TypeObject2.prototype.isStringLiteral = function() {
          return !!(this.flags & 128);
        };
        TypeObject2.prototype.isNumberLiteral = function() {
          return !!(this.flags & 256);
        };
        TypeObject2.prototype.isTypeParameter = function() {
          return !!(this.flags & 262144);
        };
        TypeObject2.prototype.isClassOrInterface = function() {
          return !!(ts2.getObjectFlags(this) & 3);
        };
        TypeObject2.prototype.isClass = function() {
          return !!(ts2.getObjectFlags(this) & 1);
        };
        Object.defineProperty(TypeObject2.prototype, "typeArguments", {
          get: function() {
            if (ts2.getObjectFlags(this) & 4) {
              return this.checker.getTypeArguments(this);
            }
            return void 0;
          },
          enumerable: false,
          configurable: true
        });
        return TypeObject2;
      }();
      var SignatureObject = function() {
        function SignatureObject2(checker, flags) {
          this.checker = checker;
          this.flags = flags;
        }
        SignatureObject2.prototype.getDeclaration = function() {
          return this.declaration;
        };
        SignatureObject2.prototype.getTypeParameters = function() {
          return this.typeParameters;
        };
        SignatureObject2.prototype.getParameters = function() {
          return this.parameters;
        };
        SignatureObject2.prototype.getReturnType = function() {
          return this.checker.getReturnTypeOfSignature(this);
        };
        SignatureObject2.prototype.getDocumentationComment = function() {
          return this.documentationComment || (this.documentationComment = getDocumentationComment(ts2.singleElementArray(this.declaration), this.checker));
        };
        SignatureObject2.prototype.getJsDocTags = function() {
          if (this.jsDocTags === void 0) {
            this.jsDocTags = this.declaration ? ts2.JsDoc.getJsDocTagsFromDeclarations([this.declaration]) : [];
          }
          return this.jsDocTags;
        };
        return SignatureObject2;
      }();
      function hasJSDocInheritDocTag(node) {
        return ts2.getJSDocTags(node).some(function(tag) {
          return tag.tagName.text === "inheritDoc";
        });
      }
      function getDocumentationComment(declarations, checker) {
        if (!declarations)
          return ts2.emptyArray;
        var doc = ts2.JsDoc.getJsDocCommentsFromDeclarations(declarations);
        if (doc.length === 0 || declarations.some(hasJSDocInheritDocTag)) {
          ts2.forEachUnique(declarations, function(declaration) {
            var inheritedDocs = findInheritedJSDocComments(declaration, declaration.symbol.name, checker);
            if (inheritedDocs)
              doc = doc.length === 0 ? inheritedDocs.slice() : inheritedDocs.concat(ts2.lineBreakPart(), doc);
          });
        }
        return doc;
      }
      function findInheritedJSDocComments(declaration, propertyName, typeChecker) {
        return ts2.firstDefined(declaration.parent ? ts2.getAllSuperTypeNodes(declaration.parent) : ts2.emptyArray, function(superTypeNode) {
          var superType = typeChecker.getTypeAtLocation(superTypeNode);
          var baseProperty = superType && typeChecker.getPropertyOfType(superType, propertyName);
          var inheritedDocs = baseProperty && baseProperty.getDocumentationComment(typeChecker);
          return inheritedDocs && inheritedDocs.length ? inheritedDocs : void 0;
        });
      }
      var SourceFileObject = function(_super) {
        __extends(SourceFileObject2, _super);
        function SourceFileObject2(kind, pos, end) {
          var _this = _super.call(this, kind, pos, end) || this;
          _this.kind = 290;
          return _this;
        }
        SourceFileObject2.prototype.update = function(newText, textChangeRange) {
          return ts2.updateSourceFile(this, newText, textChangeRange);
        };
        SourceFileObject2.prototype.getLineAndCharacterOfPosition = function(position) {
          return ts2.getLineAndCharacterOfPosition(this, position);
        };
        SourceFileObject2.prototype.getLineStarts = function() {
          return ts2.getLineStarts(this);
        };
        SourceFileObject2.prototype.getPositionOfLineAndCharacter = function(line, character, allowEdits) {
          return ts2.computePositionOfLineAndCharacter(ts2.getLineStarts(this), line, character, this.text, allowEdits);
        };
        SourceFileObject2.prototype.getLineEndOfPosition = function(pos) {
          var line = this.getLineAndCharacterOfPosition(pos).line;
          var lineStarts = this.getLineStarts();
          var lastCharPos;
          if (line + 1 >= lineStarts.length) {
            lastCharPos = this.getEnd();
          }
          if (!lastCharPos) {
            lastCharPos = lineStarts[line + 1] - 1;
          }
          var fullText = this.getFullText();
          return fullText[lastCharPos] === "\n" && fullText[lastCharPos - 1] === "\r" ? lastCharPos - 1 : lastCharPos;
        };
        SourceFileObject2.prototype.getNamedDeclarations = function() {
          if (!this.namedDeclarations) {
            this.namedDeclarations = this.computeNamedDeclarations();
          }
          return this.namedDeclarations;
        };
        SourceFileObject2.prototype.computeNamedDeclarations = function() {
          var result = ts2.createMultiMap();
          this.forEachChild(visit);
          return result;
          function addDeclaration(declaration) {
            var name = getDeclarationName(declaration);
            if (name) {
              result.add(name, declaration);
            }
          }
          function getDeclarations(name) {
            var declarations = result.get(name);
            if (!declarations) {
              result.set(name, declarations = []);
            }
            return declarations;
          }
          function getDeclarationName(declaration) {
            var name = ts2.getNonAssignedNameOfDeclaration(declaration);
            return name && (ts2.isComputedPropertyName(name) && ts2.isPropertyAccessExpression(name.expression) ? name.expression.name.text : ts2.isPropertyName(name) ? ts2.getNameFromPropertyName(name) : void 0);
          }
          function visit(node) {
            switch (node.kind) {
              case 244:
              case 201:
              case 161:
              case 160:
                var functionDeclaration = node;
                var declarationName = getDeclarationName(functionDeclaration);
                if (declarationName) {
                  var declarations = getDeclarations(declarationName);
                  var lastDeclaration = ts2.lastOrUndefined(declarations);
                  if (lastDeclaration && functionDeclaration.parent === lastDeclaration.parent && functionDeclaration.symbol === lastDeclaration.symbol) {
                    if (functionDeclaration.body && !lastDeclaration.body) {
                      declarations[declarations.length - 1] = functionDeclaration;
                    }
                  } else {
                    declarations.push(functionDeclaration);
                  }
                }
                ts2.forEachChild(node, visit);
                break;
              case 245:
              case 214:
              case 246:
              case 247:
              case 248:
              case 249:
              case 253:
              case 263:
              case 258:
              case 255:
              case 256:
              case 163:
              case 164:
              case 173:
                addDeclaration(node);
                ts2.forEachChild(node, visit);
                break;
              case 156:
                if (!ts2.hasModifier(node, 92)) {
                  break;
                }
              case 242:
              case 191: {
                var decl = node;
                if (ts2.isBindingPattern(decl.name)) {
                  ts2.forEachChild(decl.name, visit);
                  break;
                }
                if (decl.initializer) {
                  visit(decl.initializer);
                }
              }
              case 284:
              case 159:
              case 158:
                addDeclaration(node);
                break;
              case 260:
                var exportDeclaration = node;
                if (exportDeclaration.exportClause) {
                  if (ts2.isNamedExports(exportDeclaration.exportClause)) {
                    ts2.forEach(exportDeclaration.exportClause.elements, visit);
                  } else {
                    visit(exportDeclaration.exportClause.name);
                  }
                }
                break;
              case 254:
                var importClause = node.importClause;
                if (importClause) {
                  if (importClause.name) {
                    addDeclaration(importClause.name);
                  }
                  if (importClause.namedBindings) {
                    if (importClause.namedBindings.kind === 256) {
                      addDeclaration(importClause.namedBindings);
                    } else {
                      ts2.forEach(importClause.namedBindings.elements, visit);
                    }
                  }
                }
                break;
              case 209:
                if (ts2.getAssignmentDeclarationKind(node) !== 0) {
                  addDeclaration(node);
                }
              default:
                ts2.forEachChild(node, visit);
            }
          }
        };
        return SourceFileObject2;
      }(NodeObject);
      var SourceMapSourceObject = function() {
        function SourceMapSourceObject2(fileName, text, skipTrivia) {
          this.fileName = fileName;
          this.text = text;
          this.skipTrivia = skipTrivia;
        }
        SourceMapSourceObject2.prototype.getLineAndCharacterOfPosition = function(pos) {
          return ts2.getLineAndCharacterOfPosition(this, pos);
        };
        return SourceMapSourceObject2;
      }();
      function getServicesObjectAllocator() {
        return {
          getNodeConstructor: function() {
            return NodeObject;
          },
          getTokenConstructor: function() {
            return TokenObject;
          },
          getIdentifierConstructor: function() {
            return IdentifierObject;
          },
          getPrivateIdentifierConstructor: function() {
            return PrivateIdentifierObject;
          },
          getSourceFileConstructor: function() {
            return SourceFileObject;
          },
          getSymbolConstructor: function() {
            return SymbolObject;
          },
          getTypeConstructor: function() {
            return TypeObject;
          },
          getSignatureConstructor: function() {
            return SignatureObject;
          },
          getSourceMapSourceConstructor: function() {
            return SourceMapSourceObject;
          }
        };
      }
      function toEditorSettings(optionsAsMap) {
        var allPropertiesAreCamelCased = true;
        for (var key in optionsAsMap) {
          if (ts2.hasProperty(optionsAsMap, key) && !isCamelCase(key)) {
            allPropertiesAreCamelCased = false;
            break;
          }
        }
        if (allPropertiesAreCamelCased) {
          return optionsAsMap;
        }
        var settings = {};
        for (var key in optionsAsMap) {
          if (ts2.hasProperty(optionsAsMap, key)) {
            var newKey = isCamelCase(key) ? key : key.charAt(0).toLowerCase() + key.substr(1);
            settings[newKey] = optionsAsMap[key];
          }
        }
        return settings;
      }
      ts2.toEditorSettings = toEditorSettings;
      function isCamelCase(s) {
        return !s.length || s.charAt(0) === s.charAt(0).toLowerCase();
      }
      function displayPartsToString(displayParts) {
        if (displayParts) {
          return ts2.map(displayParts, function(displayPart) {
            return displayPart.text;
          }).join("");
        }
        return "";
      }
      ts2.displayPartsToString = displayPartsToString;
      function getDefaultCompilerOptions() {
        return {
          target: 1,
          jsx: 1
        };
      }
      ts2.getDefaultCompilerOptions = getDefaultCompilerOptions;
      function getSupportedCodeFixes() {
        return ts2.codefix.getSupportedErrorCodes();
      }
      ts2.getSupportedCodeFixes = getSupportedCodeFixes;
      var HostCache = function() {
        function HostCache2(host, getCanonicalFileName) {
          this.host = host;
          this.currentDirectory = host.getCurrentDirectory();
          this.fileNameToEntry = ts2.createMap();
          var rootFileNames = host.getScriptFileNames();
          for (var _i = 0, rootFileNames_1 = rootFileNames; _i < rootFileNames_1.length; _i++) {
            var fileName = rootFileNames_1[_i];
            this.createEntry(fileName, ts2.toPath(fileName, this.currentDirectory, getCanonicalFileName));
          }
          this._compilationSettings = host.getCompilationSettings() || getDefaultCompilerOptions();
        }
        HostCache2.prototype.compilationSettings = function() {
          return this._compilationSettings;
        };
        HostCache2.prototype.getProjectReferences = function() {
          return this.host.getProjectReferences && this.host.getProjectReferences();
        };
        HostCache2.prototype.createEntry = function(fileName, path2) {
          var entry;
          var scriptSnapshot = this.host.getScriptSnapshot(fileName);
          if (scriptSnapshot) {
            entry = {
              hostFileName: fileName,
              version: this.host.getScriptVersion(fileName),
              scriptSnapshot,
              scriptKind: ts2.getScriptKind(fileName, this.host)
            };
          } else {
            entry = fileName;
          }
          this.fileNameToEntry.set(path2, entry);
          return entry;
        };
        HostCache2.prototype.getEntryByPath = function(path2) {
          return this.fileNameToEntry.get(path2);
        };
        HostCache2.prototype.getHostFileInformation = function(path2) {
          var entry = this.fileNameToEntry.get(path2);
          return !ts2.isString(entry) ? entry : void 0;
        };
        HostCache2.prototype.getOrCreateEntryByPath = function(fileName, path2) {
          var info = this.getEntryByPath(path2) || this.createEntry(fileName, path2);
          return ts2.isString(info) ? void 0 : info;
        };
        HostCache2.prototype.getRootFileNames = function() {
          var names = [];
          this.fileNameToEntry.forEach(function(entry) {
            if (ts2.isString(entry)) {
              names.push(entry);
            } else {
              names.push(entry.hostFileName);
            }
          });
          return names;
        };
        HostCache2.prototype.getScriptSnapshot = function(path2) {
          var file = this.getHostFileInformation(path2);
          return file && file.scriptSnapshot;
        };
        return HostCache2;
      }();
      var SyntaxTreeCache = function() {
        function SyntaxTreeCache2(host) {
          this.host = host;
        }
        SyntaxTreeCache2.prototype.getCurrentSourceFile = function(fileName) {
          var scriptSnapshot = this.host.getScriptSnapshot(fileName);
          if (!scriptSnapshot) {
            throw new Error("Could not find file: '" + fileName + "'.");
          }
          var scriptKind = ts2.getScriptKind(fileName, this.host);
          var version = this.host.getScriptVersion(fileName);
          var sourceFile;
          if (this.currentFileName !== fileName) {
            sourceFile = createLanguageServiceSourceFile(fileName, scriptSnapshot, 99, version, true, scriptKind);
          } else if (this.currentFileVersion !== version) {
            var editRange = scriptSnapshot.getChangeRange(this.currentFileScriptSnapshot);
            sourceFile = updateLanguageServiceSourceFile(this.currentSourceFile, scriptSnapshot, version, editRange);
          }
          if (sourceFile) {
            this.currentFileVersion = version;
            this.currentFileName = fileName;
            this.currentFileScriptSnapshot = scriptSnapshot;
            this.currentSourceFile = sourceFile;
          }
          return this.currentSourceFile;
        };
        return SyntaxTreeCache2;
      }();
      function setSourceFileFields(sourceFile, scriptSnapshot, version) {
        sourceFile.version = version;
        sourceFile.scriptSnapshot = scriptSnapshot;
      }
      function createLanguageServiceSourceFile(fileName, scriptSnapshot, scriptTarget, version, setNodeParents, scriptKind) {
        var sourceFile = ts2.createSourceFile(fileName, ts2.getSnapshotText(scriptSnapshot), scriptTarget, setNodeParents, scriptKind);
        setSourceFileFields(sourceFile, scriptSnapshot, version);
        return sourceFile;
      }
      ts2.createLanguageServiceSourceFile = createLanguageServiceSourceFile;
      function updateLanguageServiceSourceFile(sourceFile, scriptSnapshot, version, textChangeRange, aggressiveChecks) {
        if (textChangeRange) {
          if (version !== sourceFile.version) {
            var newText = void 0;
            var prefix = textChangeRange.span.start !== 0 ? sourceFile.text.substr(0, textChangeRange.span.start) : "";
            var suffix = ts2.textSpanEnd(textChangeRange.span) !== sourceFile.text.length ? sourceFile.text.substr(ts2.textSpanEnd(textChangeRange.span)) : "";
            if (textChangeRange.newLength === 0) {
              newText = prefix && suffix ? prefix + suffix : prefix || suffix;
            } else {
              var changedText = scriptSnapshot.getText(textChangeRange.span.start, textChangeRange.span.start + textChangeRange.newLength);
              newText = prefix && suffix ? prefix + changedText + suffix : prefix ? prefix + changedText : changedText + suffix;
            }
            var newSourceFile = ts2.updateSourceFile(sourceFile, newText, textChangeRange, aggressiveChecks);
            setSourceFileFields(newSourceFile, scriptSnapshot, version);
            newSourceFile.nameTable = void 0;
            if (sourceFile !== newSourceFile && sourceFile.scriptSnapshot) {
              if (sourceFile.scriptSnapshot.dispose) {
                sourceFile.scriptSnapshot.dispose();
              }
              sourceFile.scriptSnapshot = void 0;
            }
            return newSourceFile;
          }
        }
        return createLanguageServiceSourceFile(sourceFile.fileName, scriptSnapshot, sourceFile.languageVersion, version, true, sourceFile.scriptKind);
      }
      ts2.updateLanguageServiceSourceFile = updateLanguageServiceSourceFile;
      var CancellationTokenObject = function() {
        function CancellationTokenObject2(cancellationToken) {
          this.cancellationToken = cancellationToken;
        }
        CancellationTokenObject2.prototype.isCancellationRequested = function() {
          return !!this.cancellationToken && this.cancellationToken.isCancellationRequested();
        };
        CancellationTokenObject2.prototype.throwIfCancellationRequested = function() {
          if (this.isCancellationRequested()) {
            throw new ts2.OperationCanceledException();
          }
        };
        return CancellationTokenObject2;
      }();
      var ThrottledCancellationToken = function() {
        function ThrottledCancellationToken2(hostCancellationToken, throttleWaitMilliseconds) {
          if (throttleWaitMilliseconds === void 0) {
            throttleWaitMilliseconds = 20;
          }
          this.hostCancellationToken = hostCancellationToken;
          this.throttleWaitMilliseconds = throttleWaitMilliseconds;
          this.lastCancellationCheckTime = 0;
        }
        ThrottledCancellationToken2.prototype.isCancellationRequested = function() {
          var time = ts2.timestamp();
          var duration = Math.abs(time - this.lastCancellationCheckTime);
          if (duration >= this.throttleWaitMilliseconds) {
            this.lastCancellationCheckTime = time;
            return this.hostCancellationToken.isCancellationRequested();
          }
          return false;
        };
        ThrottledCancellationToken2.prototype.throwIfCancellationRequested = function() {
          if (this.isCancellationRequested()) {
            throw new ts2.OperationCanceledException();
          }
        };
        return ThrottledCancellationToken2;
      }();
      ts2.ThrottledCancellationToken = ThrottledCancellationToken;
      function createLanguageService(host, documentRegistry, syntaxOnly) {
        var _a;
        if (documentRegistry === void 0) {
          documentRegistry = ts2.createDocumentRegistry(host.useCaseSensitiveFileNames && host.useCaseSensitiveFileNames(), host.getCurrentDirectory());
        }
        if (syntaxOnly === void 0) {
          syntaxOnly = false;
        }
        var syntaxTreeCache = new SyntaxTreeCache(host);
        var program;
        var lastProjectVersion;
        var lastTypesRootVersion = 0;
        var cancellationToken = new CancellationTokenObject(host.getCancellationToken && host.getCancellationToken());
        var currentDirectory = host.getCurrentDirectory();
        if (!ts2.localizedDiagnosticMessages && host.getLocalizedDiagnosticMessages) {
          ts2.setLocalizedDiagnosticMessages(host.getLocalizedDiagnosticMessages());
        }
        function log(message) {
          if (host.log) {
            host.log(message);
          }
        }
        var useCaseSensitiveFileNames = ts2.hostUsesCaseSensitiveFileNames(host);
        var getCanonicalFileName = ts2.createGetCanonicalFileName(useCaseSensitiveFileNames);
        var sourceMapper = ts2.getSourceMapper({
          useCaseSensitiveFileNames: function() {
            return useCaseSensitiveFileNames;
          },
          getCurrentDirectory: function() {
            return currentDirectory;
          },
          getProgram,
          fileExists: ts2.maybeBind(host, host.fileExists),
          readFile: ts2.maybeBind(host, host.readFile),
          getDocumentPositionMapper: ts2.maybeBind(host, host.getDocumentPositionMapper),
          getSourceFileLike: ts2.maybeBind(host, host.getSourceFileLike),
          log
        });
        function getValidSourceFile(fileName) {
          var sourceFile = program.getSourceFile(fileName);
          if (!sourceFile) {
            var error = new Error("Could not find source file: '" + fileName + "'.");
            error.ProgramFiles = program.getSourceFiles().map(function(f) {
              return f.fileName;
            });
            throw error;
          }
          return sourceFile;
        }
        function synchronizeHostData() {
          var _a2;
          ts2.Debug.assert(!syntaxOnly);
          if (host.getProjectVersion) {
            var hostProjectVersion = host.getProjectVersion();
            if (hostProjectVersion) {
              if (lastProjectVersion === hostProjectVersion && !host.hasChangedAutomaticTypeDirectiveNames) {
                return;
              }
              lastProjectVersion = hostProjectVersion;
            }
          }
          var typeRootsVersion = host.getTypeRootsVersion ? host.getTypeRootsVersion() : 0;
          if (lastTypesRootVersion !== typeRootsVersion) {
            log("TypeRoots version has changed; provide new program");
            program = void 0;
            lastTypesRootVersion = typeRootsVersion;
          }
          var hostCache = new HostCache(host, getCanonicalFileName);
          var rootFileNames = hostCache.getRootFileNames();
          var hasInvalidatedResolution = host.hasInvalidatedResolution || ts2.returnFalse;
          var projectReferences = hostCache.getProjectReferences();
          if (ts2.isProgramUptoDate(program, rootFileNames, hostCache.compilationSettings(), function(_path, fileName) {
            return host.getScriptVersion(fileName);
          }, fileExists, hasInvalidatedResolution, !!host.hasChangedAutomaticTypeDirectiveNames, projectReferences)) {
            return;
          }
          var newSettings = hostCache.compilationSettings();
          var compilerHost = {
            getSourceFile: getOrCreateSourceFile,
            getSourceFileByPath: getOrCreateSourceFileByPath,
            getCancellationToken: function() {
              return cancellationToken;
            },
            getCanonicalFileName,
            useCaseSensitiveFileNames: function() {
              return useCaseSensitiveFileNames;
            },
            getNewLine: function() {
              return ts2.getNewLineCharacter(newSettings, function() {
                return ts2.getNewLineOrDefaultFromHost(host);
              });
            },
            getDefaultLibFileName: function(options2) {
              return host.getDefaultLibFileName(options2);
            },
            writeFile: ts2.noop,
            getCurrentDirectory: function() {
              return currentDirectory;
            },
            fileExists,
            readFile,
            realpath: host.realpath && function(path2) {
              return host.realpath(path2);
            },
            directoryExists: function(directoryName) {
              return ts2.directoryProbablyExists(directoryName, host);
            },
            getDirectories: function(path2) {
              return host.getDirectories ? host.getDirectories(path2) : [];
            },
            readDirectory: function(path2, extensions, exclude, include, depth) {
              ts2.Debug.checkDefined(host.readDirectory, "'LanguageServiceHost.readDirectory' must be implemented to correctly process 'projectReferences'");
              return host.readDirectory(path2, extensions, exclude, include, depth);
            },
            onReleaseOldSourceFile,
            hasInvalidatedResolution,
            hasChangedAutomaticTypeDirectiveNames: host.hasChangedAutomaticTypeDirectiveNames
          };
          if (host.trace) {
            compilerHost.trace = function(message) {
              return host.trace(message);
            };
          }
          if (host.resolveModuleNames) {
            compilerHost.resolveModuleNames = function() {
              var args = [];
              for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
              }
              return host.resolveModuleNames.apply(host, args);
            };
          }
          if (host.resolveTypeReferenceDirectives) {
            compilerHost.resolveTypeReferenceDirectives = function() {
              var args = [];
              for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
              }
              return host.resolveTypeReferenceDirectives.apply(host, args);
            };
          }
          if (host.useSourceOfProjectReferenceRedirect) {
            compilerHost.useSourceOfProjectReferenceRedirect = function() {
              return host.useSourceOfProjectReferenceRedirect();
            };
          }
          (_a2 = host.setCompilerHost) === null || _a2 === void 0 ? void 0 : _a2.call(host, compilerHost);
          var documentRegistryBucketKey = documentRegistry.getKeyForCompilationSettings(newSettings);
          var options = {
            rootNames: rootFileNames,
            options: newSettings,
            host: compilerHost,
            oldProgram: program,
            projectReferences
          };
          program = ts2.createProgram(options);
          hostCache = void 0;
          sourceMapper.clearCache();
          program.getTypeChecker();
          return;
          function fileExists(fileName) {
            var path2 = ts2.toPath(fileName, currentDirectory, getCanonicalFileName);
            var entry = hostCache && hostCache.getEntryByPath(path2);
            return entry ? !ts2.isString(entry) : !!host.fileExists && host.fileExists(fileName);
          }
          function readFile(fileName) {
            var path2 = ts2.toPath(fileName, currentDirectory, getCanonicalFileName);
            var entry = hostCache && hostCache.getEntryByPath(path2);
            if (entry) {
              return ts2.isString(entry) ? void 0 : ts2.getSnapshotText(entry.scriptSnapshot);
            }
            return host.readFile && host.readFile(fileName);
          }
          function onReleaseOldSourceFile(oldSourceFile, oldOptions) {
            var oldSettingsKey = documentRegistry.getKeyForCompilationSettings(oldOptions);
            documentRegistry.releaseDocumentWithKey(oldSourceFile.resolvedPath, oldSettingsKey);
          }
          function getOrCreateSourceFile(fileName, languageVersion, onError, shouldCreateNewSourceFile) {
            return getOrCreateSourceFileByPath(fileName, ts2.toPath(fileName, currentDirectory, getCanonicalFileName), languageVersion, onError, shouldCreateNewSourceFile);
          }
          function getOrCreateSourceFileByPath(fileName, path2, _languageVersion, _onError, shouldCreateNewSourceFile) {
            ts2.Debug.assert(hostCache !== void 0, "getOrCreateSourceFileByPath called after typical CompilerHost lifetime, check the callstack something with a reference to an old host.");
            var hostFileInformation = hostCache && hostCache.getOrCreateEntryByPath(fileName, path2);
            if (!hostFileInformation) {
              return void 0;
            }
            if (!shouldCreateNewSourceFile) {
              var oldSourceFile = program && program.getSourceFileByPath(path2);
              if (oldSourceFile) {
                ts2.Debug.assertEqual(hostFileInformation.scriptKind, oldSourceFile.scriptKind, "Registered script kind should match new script kind.");
                return documentRegistry.updateDocumentWithKey(fileName, path2, newSettings, documentRegistryBucketKey, hostFileInformation.scriptSnapshot, hostFileInformation.version, hostFileInformation.scriptKind);
              }
            }
            return documentRegistry.acquireDocumentWithKey(fileName, path2, newSettings, documentRegistryBucketKey, hostFileInformation.scriptSnapshot, hostFileInformation.version, hostFileInformation.scriptKind);
          }
        }
        function getProgram() {
          if (syntaxOnly) {
            ts2.Debug.assert(program === void 0);
            return void 0;
          }
          synchronizeHostData();
          return program;
        }
        function cleanupSemanticCache() {
          program = void 0;
        }
        function dispose() {
          if (program) {
            var key_1 = documentRegistry.getKeyForCompilationSettings(program.getCompilerOptions());
            ts2.forEach(program.getSourceFiles(), function(f) {
              return documentRegistry.releaseDocumentWithKey(f.resolvedPath, key_1);
            });
            program = void 0;
          }
          host = void 0;
        }
        function getSyntacticDiagnostics(fileName) {
          synchronizeHostData();
          return program.getSyntacticDiagnostics(getValidSourceFile(fileName), cancellationToken).slice();
        }
        function getSemanticDiagnostics(fileName) {
          synchronizeHostData();
          var targetSourceFile = getValidSourceFile(fileName);
          var semanticDiagnostics = program.getSemanticDiagnostics(targetSourceFile, cancellationToken);
          if (!ts2.getEmitDeclarations(program.getCompilerOptions())) {
            return semanticDiagnostics.slice();
          }
          var declarationDiagnostics = program.getDeclarationDiagnostics(targetSourceFile, cancellationToken);
          return __spreadArrays(semanticDiagnostics, declarationDiagnostics);
        }
        function getSuggestionDiagnostics(fileName) {
          synchronizeHostData();
          return ts2.computeSuggestionDiagnostics(getValidSourceFile(fileName), program, cancellationToken);
        }
        function getCompilerOptionsDiagnostics() {
          synchronizeHostData();
          return __spreadArrays(program.getOptionsDiagnostics(cancellationToken), program.getGlobalDiagnostics(cancellationToken));
        }
        function getCompletionsAtPosition(fileName, position, options) {
          if (options === void 0) {
            options = ts2.emptyOptions;
          }
          var fullPreferences = __assign(__assign({}, ts2.identity(options)), { includeCompletionsForModuleExports: options.includeCompletionsForModuleExports || options.includeExternalModuleExports, includeCompletionsWithInsertText: options.includeCompletionsWithInsertText || options.includeInsertTextCompletions });
          synchronizeHostData();
          return ts2.Completions.getCompletionsAtPosition(host, program, log, getValidSourceFile(fileName), position, fullPreferences, options.triggerCharacter);
        }
        function getCompletionEntryDetails(fileName, position, name, formattingOptions, source, preferences) {
          if (preferences === void 0) {
            preferences = ts2.emptyOptions;
          }
          synchronizeHostData();
          return ts2.Completions.getCompletionEntryDetails(program, log, getValidSourceFile(fileName), position, { name, source }, host, formattingOptions && ts2.formatting.getFormatContext(formattingOptions, host), preferences, cancellationToken);
        }
        function getCompletionEntrySymbol(fileName, position, name, source, preferences) {
          if (preferences === void 0) {
            preferences = ts2.emptyOptions;
          }
          synchronizeHostData();
          return ts2.Completions.getCompletionEntrySymbol(program, log, getValidSourceFile(fileName), position, { name, source }, host, preferences);
        }
        function getQuickInfoAtPosition(fileName, position) {
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName);
          var node = ts2.getTouchingPropertyName(sourceFile, position);
          if (node === sourceFile) {
            return void 0;
          }
          var typeChecker = program.getTypeChecker();
          var nodeForQuickInfo = getNodeForQuickInfo(node);
          var symbol = getSymbolAtLocationForQuickInfo(nodeForQuickInfo, typeChecker);
          if (!symbol || typeChecker.isUnknownSymbol(symbol)) {
            var type_2 = shouldGetType(sourceFile, nodeForQuickInfo, position) ? typeChecker.getTypeAtLocation(nodeForQuickInfo) : void 0;
            return type_2 && {
              kind: "",
              kindModifiers: "",
              textSpan: ts2.createTextSpanFromNode(nodeForQuickInfo, sourceFile),
              displayParts: typeChecker.runWithCancellationToken(cancellationToken, function(typeChecker2) {
                return ts2.typeToDisplayParts(typeChecker2, type_2, ts2.getContainerNode(nodeForQuickInfo));
              }),
              documentation: type_2.symbol ? type_2.symbol.getDocumentationComment(typeChecker) : void 0,
              tags: type_2.symbol ? type_2.symbol.getJsDocTags() : void 0
            };
          }
          var _a2 = typeChecker.runWithCancellationToken(cancellationToken, function(typeChecker2) {
            return ts2.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(typeChecker2, symbol, sourceFile, ts2.getContainerNode(nodeForQuickInfo), nodeForQuickInfo);
          }), symbolKind = _a2.symbolKind, displayParts = _a2.displayParts, documentation = _a2.documentation, tags = _a2.tags;
          return {
            kind: symbolKind,
            kindModifiers: ts2.SymbolDisplay.getSymbolModifiers(symbol),
            textSpan: ts2.createTextSpanFromNode(nodeForQuickInfo, sourceFile),
            displayParts,
            documentation,
            tags
          };
        }
        function getNodeForQuickInfo(node) {
          if (ts2.isNewExpression(node.parent) && node.pos === node.parent.pos) {
            return node.parent.expression;
          }
          return node;
        }
        function shouldGetType(sourceFile, node, position) {
          switch (node.kind) {
            case 75:
              return !ts2.isLabelName(node) && !ts2.isTagName(node);
            case 194:
            case 153:
              return !ts2.isInComment(sourceFile, position);
            case 104:
            case 183:
            case 102:
              return true;
            default:
              return false;
          }
        }
        function getDefinitionAtPosition(fileName, position) {
          synchronizeHostData();
          return ts2.GoToDefinition.getDefinitionAtPosition(program, getValidSourceFile(fileName), position);
        }
        function getDefinitionAndBoundSpan(fileName, position) {
          synchronizeHostData();
          return ts2.GoToDefinition.getDefinitionAndBoundSpan(program, getValidSourceFile(fileName), position);
        }
        function getTypeDefinitionAtPosition(fileName, position) {
          synchronizeHostData();
          return ts2.GoToDefinition.getTypeDefinitionAtPosition(program.getTypeChecker(), getValidSourceFile(fileName), position);
        }
        function getImplementationAtPosition(fileName, position) {
          synchronizeHostData();
          return ts2.FindAllReferences.getImplementationsAtPosition(program, cancellationToken, program.getSourceFiles(), getValidSourceFile(fileName), position);
        }
        function getOccurrencesAtPosition(fileName, position) {
          return ts2.flatMap(getDocumentHighlights(fileName, position, [fileName]), function(entry) {
            return entry.highlightSpans.map(function(highlightSpan) {
              return __assign(__assign({ fileName: entry.fileName, textSpan: highlightSpan.textSpan, isWriteAccess: highlightSpan.kind === "writtenReference", isDefinition: false }, highlightSpan.isInString && { isInString: true }), highlightSpan.contextSpan && { contextSpan: highlightSpan.contextSpan });
            });
          });
        }
        function getDocumentHighlights(fileName, position, filesToSearch) {
          var normalizedFileName = ts2.normalizePath(fileName);
          ts2.Debug.assert(filesToSearch.some(function(f) {
            return ts2.normalizePath(f) === normalizedFileName;
          }));
          synchronizeHostData();
          var sourceFilesToSearch = ts2.mapDefined(filesToSearch, function(fileName2) {
            return program.getSourceFile(fileName2);
          });
          var sourceFile = getValidSourceFile(fileName);
          return ts2.DocumentHighlights.getDocumentHighlights(program, cancellationToken, sourceFile, position, sourceFilesToSearch);
        }
        function findRenameLocations(fileName, position, findInStrings, findInComments, providePrefixAndSuffixTextForRename) {
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName);
          var node = ts2.getAdjustedRenameLocation(ts2.getTouchingPropertyName(sourceFile, position));
          if (ts2.isIdentifier(node) && (ts2.isJsxOpeningElement(node.parent) || ts2.isJsxClosingElement(node.parent)) && ts2.isIntrinsicJsxName(node.escapedText)) {
            var _a2 = node.parent.parent, openingElement = _a2.openingElement, closingElement = _a2.closingElement;
            return [openingElement, closingElement].map(function(node2) {
              var textSpan = ts2.createTextSpanFromNode(node2.tagName, sourceFile);
              return __assign({ fileName: sourceFile.fileName, textSpan }, ts2.FindAllReferences.toContextSpan(textSpan, sourceFile, node2.parent));
            });
          } else {
            return getReferencesWorker(node, position, { findInStrings, findInComments, providePrefixAndSuffixTextForRename, use: 2 }, function(entry, originalNode, checker) {
              return ts2.FindAllReferences.toRenameLocation(entry, originalNode, checker, providePrefixAndSuffixTextForRename || false);
            });
          }
        }
        function getReferencesAtPosition(fileName, position) {
          synchronizeHostData();
          return getReferencesWorker(ts2.getTouchingPropertyName(getValidSourceFile(fileName), position), position, { use: 1 }, ts2.FindAllReferences.toReferenceEntry);
        }
        function getReferencesWorker(node, position, options, cb) {
          synchronizeHostData();
          var sourceFiles = options && options.use === 2 ? program.getSourceFiles().filter(function(sourceFile) {
            return !program.isSourceFileDefaultLibrary(sourceFile);
          }) : program.getSourceFiles();
          return ts2.FindAllReferences.findReferenceOrRenameEntries(program, cancellationToken, sourceFiles, node, position, options, cb);
        }
        function findReferences(fileName, position) {
          synchronizeHostData();
          return ts2.FindAllReferences.findReferencedSymbols(program, cancellationToken, program.getSourceFiles(), getValidSourceFile(fileName), position);
        }
        function getNavigateToItems(searchValue, maxResultCount, fileName, excludeDtsFiles) {
          if (excludeDtsFiles === void 0) {
            excludeDtsFiles = false;
          }
          synchronizeHostData();
          var sourceFiles = fileName ? [getValidSourceFile(fileName)] : program.getSourceFiles();
          return ts2.NavigateTo.getNavigateToItems(sourceFiles, program.getTypeChecker(), cancellationToken, searchValue, maxResultCount, excludeDtsFiles);
        }
        function getEmitOutput(fileName, emitOnlyDtsFiles, forceDtsEmit) {
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName);
          var customTransformers = host.getCustomTransformers && host.getCustomTransformers();
          return ts2.getFileEmitOutput(program, sourceFile, !!emitOnlyDtsFiles, cancellationToken, customTransformers, forceDtsEmit);
        }
        function getSignatureHelpItems(fileName, position, _a2) {
          var triggerReason = (_a2 === void 0 ? ts2.emptyOptions : _a2).triggerReason;
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName);
          return ts2.SignatureHelp.getSignatureHelpItems(program, sourceFile, position, triggerReason, cancellationToken);
        }
        function getNonBoundSourceFile(fileName) {
          return syntaxTreeCache.getCurrentSourceFile(fileName);
        }
        function getNameOrDottedNameSpan(fileName, startPos, _endPos) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          var node = ts2.getTouchingPropertyName(sourceFile, startPos);
          if (node === sourceFile) {
            return void 0;
          }
          switch (node.kind) {
            case 194:
            case 153:
            case 10:
            case 91:
            case 106:
            case 100:
            case 102:
            case 104:
            case 183:
            case 75:
              break;
            default:
              return void 0;
          }
          var nodeForStartPos = node;
          while (true) {
            if (ts2.isRightSideOfPropertyAccess(nodeForStartPos) || ts2.isRightSideOfQualifiedName(nodeForStartPos)) {
              nodeForStartPos = nodeForStartPos.parent;
            } else if (ts2.isNameOfModuleDeclaration(nodeForStartPos)) {
              if (nodeForStartPos.parent.parent.kind === 249 && nodeForStartPos.parent.parent.body === nodeForStartPos.parent) {
                nodeForStartPos = nodeForStartPos.parent.parent.name;
              } else {
                break;
              }
            } else {
              break;
            }
          }
          return ts2.createTextSpanFromBounds(nodeForStartPos.getStart(), node.getEnd());
        }
        function getBreakpointStatementAtPosition(fileName, position) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          return ts2.BreakpointResolver.spanInSourceFileAtLocation(sourceFile, position);
        }
        function getNavigationBarItems(fileName) {
          return ts2.NavigationBar.getNavigationBarItems(syntaxTreeCache.getCurrentSourceFile(fileName), cancellationToken);
        }
        function getNavigationTree(fileName) {
          return ts2.NavigationBar.getNavigationTree(syntaxTreeCache.getCurrentSourceFile(fileName), cancellationToken);
        }
        function isTsOrTsxFile(fileName) {
          var kind = ts2.getScriptKind(fileName, host);
          return kind === 3 || kind === 4;
        }
        function getSemanticClassifications(fileName, span) {
          if (!isTsOrTsxFile(fileName)) {
            return [];
          }
          synchronizeHostData();
          return ts2.getSemanticClassifications(program.getTypeChecker(), cancellationToken, getValidSourceFile(fileName), program.getClassifiableNames(), span);
        }
        function getEncodedSemanticClassifications(fileName, span) {
          if (!isTsOrTsxFile(fileName)) {
            return { spans: [], endOfLineState: 0 };
          }
          synchronizeHostData();
          return ts2.getEncodedSemanticClassifications(program.getTypeChecker(), cancellationToken, getValidSourceFile(fileName), program.getClassifiableNames(), span);
        }
        function getSyntacticClassifications(fileName, span) {
          return ts2.getSyntacticClassifications(cancellationToken, syntaxTreeCache.getCurrentSourceFile(fileName), span);
        }
        function getEncodedSyntacticClassifications(fileName, span) {
          return ts2.getEncodedSyntacticClassifications(cancellationToken, syntaxTreeCache.getCurrentSourceFile(fileName), span);
        }
        function getOutliningSpans(fileName) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          return ts2.OutliningElementsCollector.collectElements(sourceFile, cancellationToken);
        }
        var braceMatching = ts2.createMapFromTemplate((_a = {}, _a[18] = 19, _a[20] = 21, _a[22] = 23, _a[31] = 29, _a));
        braceMatching.forEach(function(value, key) {
          return braceMatching.set(value.toString(), Number(key));
        });
        function getBraceMatchingAtPosition(fileName, position) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          var token = ts2.getTouchingToken(sourceFile, position);
          var matchKind = token.getStart(sourceFile) === position ? braceMatching.get(token.kind.toString()) : void 0;
          var match = matchKind && ts2.findChildOfKind(token.parent, matchKind, sourceFile);
          return match ? [ts2.createTextSpanFromNode(token, sourceFile), ts2.createTextSpanFromNode(match, sourceFile)].sort(function(a, b) {
            return a.start - b.start;
          }) : ts2.emptyArray;
        }
        function getIndentationAtPosition(fileName, position, editorOptions) {
          var start = ts2.timestamp();
          var settings = toEditorSettings(editorOptions);
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          log("getIndentationAtPosition: getCurrentSourceFile: " + (ts2.timestamp() - start));
          start = ts2.timestamp();
          var result = ts2.formatting.SmartIndenter.getIndentation(position, sourceFile, settings);
          log("getIndentationAtPosition: computeIndentation  : " + (ts2.timestamp() - start));
          return result;
        }
        function getFormattingEditsForRange(fileName, start, end, options) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          return ts2.formatting.formatSelection(start, end, sourceFile, ts2.formatting.getFormatContext(toEditorSettings(options), host));
        }
        function getFormattingEditsForDocument(fileName, options) {
          return ts2.formatting.formatDocument(syntaxTreeCache.getCurrentSourceFile(fileName), ts2.formatting.getFormatContext(toEditorSettings(options), host));
        }
        function getFormattingEditsAfterKeystroke(fileName, position, key, options) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          var formatContext = ts2.formatting.getFormatContext(toEditorSettings(options), host);
          if (!ts2.isInComment(sourceFile, position)) {
            switch (key) {
              case "{":
                return ts2.formatting.formatOnOpeningCurly(position, sourceFile, formatContext);
              case "}":
                return ts2.formatting.formatOnClosingCurly(position, sourceFile, formatContext);
              case ";":
                return ts2.formatting.formatOnSemicolon(position, sourceFile, formatContext);
              case "\n":
                return ts2.formatting.formatOnEnter(position, sourceFile, formatContext);
            }
          }
          return [];
        }
        function getCodeFixesAtPosition(fileName, start, end, errorCodes, formatOptions, preferences) {
          if (preferences === void 0) {
            preferences = ts2.emptyOptions;
          }
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName);
          var span = ts2.createTextSpanFromBounds(start, end);
          var formatContext = ts2.formatting.getFormatContext(formatOptions, host);
          return ts2.flatMap(ts2.deduplicate(errorCodes, ts2.equateValues, ts2.compareValues), function(errorCode) {
            cancellationToken.throwIfCancellationRequested();
            return ts2.codefix.getFixes({ errorCode, sourceFile, span, program, host, cancellationToken, formatContext, preferences });
          });
        }
        function getCombinedCodeFix(scope, fixId, formatOptions, preferences) {
          if (preferences === void 0) {
            preferences = ts2.emptyOptions;
          }
          synchronizeHostData();
          ts2.Debug.assert(scope.type === "file");
          var sourceFile = getValidSourceFile(scope.fileName);
          var formatContext = ts2.formatting.getFormatContext(formatOptions, host);
          return ts2.codefix.getAllFixes({ fixId, sourceFile, program, host, cancellationToken, formatContext, preferences });
        }
        function organizeImports(scope, formatOptions, preferences) {
          if (preferences === void 0) {
            preferences = ts2.emptyOptions;
          }
          synchronizeHostData();
          ts2.Debug.assert(scope.type === "file");
          var sourceFile = getValidSourceFile(scope.fileName);
          var formatContext = ts2.formatting.getFormatContext(formatOptions, host);
          return ts2.OrganizeImports.organizeImports(sourceFile, formatContext, host, program, preferences);
        }
        function getEditsForFileRename(oldFilePath, newFilePath, formatOptions, preferences) {
          if (preferences === void 0) {
            preferences = ts2.emptyOptions;
          }
          return ts2.getEditsForFileRename(getProgram(), oldFilePath, newFilePath, host, ts2.formatting.getFormatContext(formatOptions, host), preferences, sourceMapper);
        }
        function applyCodeActionCommand(fileName, actionOrFormatSettingsOrUndefined) {
          var action = typeof fileName === "string" ? actionOrFormatSettingsOrUndefined : fileName;
          return ts2.isArray(action) ? Promise.all(action.map(function(a) {
            return applySingleCodeActionCommand(a);
          })) : applySingleCodeActionCommand(action);
        }
        function applySingleCodeActionCommand(action) {
          var getPath = function(path2) {
            return ts2.toPath(path2, currentDirectory, getCanonicalFileName);
          };
          ts2.Debug.assertEqual(action.type, "install package");
          return host.installPackage ? host.installPackage({ fileName: getPath(action.file), packageName: action.packageName }) : Promise.reject("Host does not implement `installPackage`");
        }
        function getDocCommentTemplateAtPosition(fileName, position) {
          return ts2.JsDoc.getDocCommentTemplateAtPosition(ts2.getNewLineOrDefaultFromHost(host), syntaxTreeCache.getCurrentSourceFile(fileName), position);
        }
        function isValidBraceCompletionAtPosition(fileName, position, openingBrace) {
          if (openingBrace === 60) {
            return false;
          }
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          if (ts2.isInString(sourceFile, position)) {
            return false;
          }
          if (ts2.isInsideJsxElementOrAttribute(sourceFile, position)) {
            return openingBrace === 123;
          }
          if (ts2.isInTemplateString(sourceFile, position)) {
            return false;
          }
          switch (openingBrace) {
            case 39:
            case 34:
            case 96:
              return !ts2.isInComment(sourceFile, position);
          }
          return true;
        }
        function getJsxClosingTagAtPosition(fileName, position) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          var token = ts2.findPrecedingToken(position, sourceFile);
          if (!token)
            return void 0;
          var element = token.kind === 31 && ts2.isJsxOpeningElement(token.parent) ? token.parent.parent : ts2.isJsxText(token) ? token.parent : void 0;
          if (element && isUnclosedTag(element)) {
            return { newText: "</" + element.openingElement.tagName.getText(sourceFile) + ">" };
          }
        }
        function isUnclosedTag(_a2) {
          var openingElement = _a2.openingElement, closingElement = _a2.closingElement, parent = _a2.parent;
          return !ts2.tagNamesAreEquivalent(openingElement.tagName, closingElement.tagName) || ts2.isJsxElement(parent) && ts2.tagNamesAreEquivalent(openingElement.tagName, parent.openingElement.tagName) && isUnclosedTag(parent);
        }
        function getSpanOfEnclosingComment(fileName, position, onlyMultiLine) {
          var sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
          var range = ts2.formatting.getRangeOfEnclosingComment(sourceFile, position);
          return range && (!onlyMultiLine || range.kind === 3) ? ts2.createTextSpanFromRange(range) : void 0;
        }
        function getTodoComments(fileName, descriptors) {
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName);
          cancellationToken.throwIfCancellationRequested();
          var fileContents = sourceFile.text;
          var result = [];
          if (descriptors.length > 0 && !isNodeModulesFile(sourceFile.fileName)) {
            var regExp = getTodoCommentsRegExp();
            var matchArray = void 0;
            while (matchArray = regExp.exec(fileContents)) {
              cancellationToken.throwIfCancellationRequested();
              var firstDescriptorCaptureIndex = 3;
              ts2.Debug.assert(matchArray.length === descriptors.length + firstDescriptorCaptureIndex);
              var preamble = matchArray[1];
              var matchPosition = matchArray.index + preamble.length;
              if (!ts2.isInComment(sourceFile, matchPosition)) {
                continue;
              }
              var descriptor = void 0;
              for (var i = 0; i < descriptors.length; i++) {
                if (matchArray[i + firstDescriptorCaptureIndex]) {
                  descriptor = descriptors[i];
                }
              }
              if (descriptor === void 0)
                return ts2.Debug.fail();
              if (isLetterOrDigit(fileContents.charCodeAt(matchPosition + descriptor.text.length))) {
                continue;
              }
              var message = matchArray[2];
              result.push({ descriptor, message, position: matchPosition });
            }
          }
          return result;
          function escapeRegExp(str) {
            return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
          }
          function getTodoCommentsRegExp() {
            var singleLineCommentStart = /(?:\/\/+\s*)/.source;
            var multiLineCommentStart = /(?:\/\*+\s*)/.source;
            var anyNumberOfSpacesAndAsterisksAtStartOfLine = /(?:^(?:\s|\*)*)/.source;
            var preamble2 = "(" + anyNumberOfSpacesAndAsterisksAtStartOfLine + "|" + singleLineCommentStart + "|" + multiLineCommentStart + ")";
            var literals = "(?:" + ts2.map(descriptors, function(d) {
              return "(" + escapeRegExp(d.text) + ")";
            }).join("|") + ")";
            var endOfLineOrEndOfComment = /(?:$|\*\/)/.source;
            var messageRemainder = /(?:.*?)/.source;
            var messagePortion = "(" + literals + messageRemainder + ")";
            var regExpString = preamble2 + messagePortion + endOfLineOrEndOfComment;
            return new RegExp(regExpString, "gim");
          }
          function isLetterOrDigit(char) {
            return char >= 97 && char <= 122 || char >= 65 && char <= 90 || char >= 48 && char <= 57;
          }
          function isNodeModulesFile(path2) {
            return ts2.stringContains(path2, "/node_modules/");
          }
        }
        function getRenameInfo(fileName, position, options) {
          synchronizeHostData();
          return ts2.Rename.getRenameInfo(program, getValidSourceFile(fileName), position, options);
        }
        function getRefactorContext(file, positionOrRange, preferences, formatOptions) {
          var _a2 = typeof positionOrRange === "number" ? [positionOrRange, void 0] : [positionOrRange.pos, positionOrRange.end], startPosition = _a2[0], endPosition = _a2[1];
          return {
            file,
            startPosition,
            endPosition,
            program: getProgram(),
            host,
            formatContext: ts2.formatting.getFormatContext(formatOptions, host),
            cancellationToken,
            preferences
          };
        }
        function getSmartSelectionRange(fileName, position) {
          return ts2.SmartSelectionRange.getSmartSelectionRange(position, syntaxTreeCache.getCurrentSourceFile(fileName));
        }
        function getApplicableRefactors(fileName, positionOrRange, preferences) {
          if (preferences === void 0) {
            preferences = ts2.emptyOptions;
          }
          synchronizeHostData();
          var file = getValidSourceFile(fileName);
          return ts2.refactor.getApplicableRefactors(getRefactorContext(file, positionOrRange, preferences));
        }
        function getEditsForRefactor(fileName, formatOptions, positionOrRange, refactorName, actionName, preferences) {
          if (preferences === void 0) {
            preferences = ts2.emptyOptions;
          }
          synchronizeHostData();
          var file = getValidSourceFile(fileName);
          return ts2.refactor.getEditsForRefactor(getRefactorContext(file, positionOrRange, preferences, formatOptions), refactorName, actionName);
        }
        function prepareCallHierarchy(fileName, position) {
          synchronizeHostData();
          var declarations = ts2.CallHierarchy.resolveCallHierarchyDeclaration(program, ts2.getTouchingPropertyName(getValidSourceFile(fileName), position));
          return declarations && ts2.mapOneOrMany(declarations, function(declaration) {
            return ts2.CallHierarchy.createCallHierarchyItem(program, declaration);
          });
        }
        function provideCallHierarchyIncomingCalls(fileName, position) {
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName);
          var declaration = ts2.firstOrOnly(ts2.CallHierarchy.resolveCallHierarchyDeclaration(program, position === 0 ? sourceFile : ts2.getTouchingPropertyName(sourceFile, position)));
          return declaration ? ts2.CallHierarchy.getIncomingCalls(program, declaration, cancellationToken) : [];
        }
        function provideCallHierarchyOutgoingCalls(fileName, position) {
          synchronizeHostData();
          var sourceFile = getValidSourceFile(fileName);
          var declaration = ts2.firstOrOnly(ts2.CallHierarchy.resolveCallHierarchyDeclaration(program, position === 0 ? sourceFile : ts2.getTouchingPropertyName(sourceFile, position)));
          return declaration ? ts2.CallHierarchy.getOutgoingCalls(program, declaration) : [];
        }
        return {
          dispose,
          cleanupSemanticCache,
          getSyntacticDiagnostics,
          getSemanticDiagnostics,
          getSuggestionDiagnostics,
          getCompilerOptionsDiagnostics,
          getSyntacticClassifications,
          getSemanticClassifications,
          getEncodedSyntacticClassifications,
          getEncodedSemanticClassifications,
          getCompletionsAtPosition,
          getCompletionEntryDetails,
          getCompletionEntrySymbol,
          getSignatureHelpItems,
          getQuickInfoAtPosition,
          getDefinitionAtPosition,
          getDefinitionAndBoundSpan,
          getImplementationAtPosition,
          getTypeDefinitionAtPosition,
          getReferencesAtPosition,
          findReferences,
          getOccurrencesAtPosition,
          getDocumentHighlights,
          getNameOrDottedNameSpan,
          getBreakpointStatementAtPosition,
          getNavigateToItems,
          getRenameInfo,
          getSmartSelectionRange,
          findRenameLocations,
          getNavigationBarItems,
          getNavigationTree,
          getOutliningSpans,
          getTodoComments,
          getBraceMatchingAtPosition,
          getIndentationAtPosition,
          getFormattingEditsForRange,
          getFormattingEditsForDocument,
          getFormattingEditsAfterKeystroke,
          getDocCommentTemplateAtPosition,
          isValidBraceCompletionAtPosition,
          getJsxClosingTagAtPosition,
          getSpanOfEnclosingComment,
          getCodeFixesAtPosition,
          getCombinedCodeFix,
          applyCodeActionCommand,
          organizeImports,
          getEditsForFileRename,
          getEmitOutput,
          getNonBoundSourceFile,
          getProgram,
          getApplicableRefactors,
          getEditsForRefactor,
          toLineColumnOffset: sourceMapper.toLineColumnOffset,
          getSourceMapper: function() {
            return sourceMapper;
          },
          clearSourceMapperCache: function() {
            return sourceMapper.clearCache();
          },
          prepareCallHierarchy,
          provideCallHierarchyIncomingCalls,
          provideCallHierarchyOutgoingCalls
        };
      }
      ts2.createLanguageService = createLanguageService;
      function getNameTable(sourceFile) {
        if (!sourceFile.nameTable) {
          initializeNameTable(sourceFile);
        }
        return sourceFile.nameTable;
      }
      ts2.getNameTable = getNameTable;
      function initializeNameTable(sourceFile) {
        var nameTable = sourceFile.nameTable = ts2.createUnderscoreEscapedMap();
        sourceFile.forEachChild(function walk(node) {
          if (ts2.isIdentifier(node) && !ts2.isTagName(node) && node.escapedText || ts2.isStringOrNumericLiteralLike(node) && literalIsName(node)) {
            var text = ts2.getEscapedTextOfIdentifierOrLiteral(node);
            nameTable.set(text, nameTable.get(text) === void 0 ? node.pos : -1);
          } else if (ts2.isPrivateIdentifier(node)) {
            var text = node.escapedText;
            nameTable.set(text, nameTable.get(text) === void 0 ? node.pos : -1);
          }
          ts2.forEachChild(node, walk);
          if (ts2.hasJSDocNodes(node)) {
            for (var _i = 0, _a = node.jsDoc; _i < _a.length; _i++) {
              var jsDoc = _a[_i];
              ts2.forEachChild(jsDoc, walk);
            }
          }
        });
      }
      function literalIsName(node) {
        return ts2.isDeclarationName(node) || node.parent.kind === 265 || isArgumentOfElementAccessExpression(node) || ts2.isLiteralComputedPropertyDeclarationName(node);
      }
      function getContainingObjectLiteralElement(node) {
        var element = getContainingObjectLiteralElementWorker(node);
        return element && (ts2.isObjectLiteralExpression(element.parent) || ts2.isJsxAttributes(element.parent)) ? element : void 0;
      }
      ts2.getContainingObjectLiteralElement = getContainingObjectLiteralElement;
      function getContainingObjectLiteralElementWorker(node) {
        switch (node.kind) {
          case 10:
          case 14:
          case 8:
            if (node.parent.kind === 154) {
              return ts2.isObjectLiteralElement(node.parent.parent) ? node.parent.parent : void 0;
            }
          case 75:
            return ts2.isObjectLiteralElement(node.parent) && (node.parent.parent.kind === 193 || node.parent.parent.kind === 274) && node.parent.name === node ? node.parent : void 0;
        }
        return void 0;
      }
      function getSymbolAtLocationForQuickInfo(node, checker) {
        var object = getContainingObjectLiteralElement(node);
        if (object) {
          var contextualType = checker.getContextualType(object.parent);
          var properties = contextualType && getPropertySymbolsFromContextualType(object, checker, contextualType, false);
          if (properties && properties.length === 1) {
            return ts2.first(properties);
          }
        }
        return checker.getSymbolAtLocation(node);
      }
      function getPropertySymbolsFromContextualType(node, checker, contextualType, unionSymbolOk) {
        var name = ts2.getNameFromPropertyName(node.name);
        if (!name)
          return ts2.emptyArray;
        if (!contextualType.isUnion()) {
          var symbol = contextualType.getProperty(name);
          return symbol ? [symbol] : ts2.emptyArray;
        }
        var discriminatedPropertySymbols = ts2.mapDefined(contextualType.types, function(t) {
          return ts2.isObjectLiteralExpression(node.parent) && checker.isTypeInvalidDueToUnionDiscriminant(t, node.parent) ? void 0 : t.getProperty(name);
        });
        if (unionSymbolOk && (discriminatedPropertySymbols.length === 0 || discriminatedPropertySymbols.length === contextualType.types.length)) {
          var symbol = contextualType.getProperty(name);
          if (symbol)
            return [symbol];
        }
        if (discriminatedPropertySymbols.length === 0) {
          return ts2.mapDefined(contextualType.types, function(t) {
            return t.getProperty(name);
          });
        }
        return discriminatedPropertySymbols;
      }
      ts2.getPropertySymbolsFromContextualType = getPropertySymbolsFromContextualType;
      function isArgumentOfElementAccessExpression(node) {
        return node && node.parent && node.parent.kind === 195 && node.parent.argumentExpression === node;
      }
      function getDefaultLibFilePath(options) {
        if (typeof __dirname !== "undefined") {
          return __dirname + ts2.directorySeparator + ts2.getDefaultLibFileName(options);
        }
        throw new Error("getDefaultLibFilePath is only supported when consumed as a node module. ");
      }
      ts2.getDefaultLibFilePath = getDefaultLibFilePath;
      ts2.setObjectAllocator(getServicesObjectAllocator());
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      var BreakpointResolver;
      (function(BreakpointResolver2) {
        function spanInSourceFileAtLocation(sourceFile, position) {
          if (sourceFile.isDeclarationFile) {
            return void 0;
          }
          var tokenAtLocation = ts2.getTokenAtPosition(sourceFile, position);
          var lineOfPosition = sourceFile.getLineAndCharacterOfPosition(position).line;
          if (sourceFile.getLineAndCharacterOfPosition(tokenAtLocation.getStart(sourceFile)).line > lineOfPosition) {
            var preceding = ts2.findPrecedingToken(tokenAtLocation.pos, sourceFile);
            if (!preceding || sourceFile.getLineAndCharacterOfPosition(preceding.getEnd()).line !== lineOfPosition) {
              return void 0;
            }
            tokenAtLocation = preceding;
          }
          if (tokenAtLocation.flags & 8388608) {
            return void 0;
          }
          return spanInNode(tokenAtLocation);
          function textSpan(startNode, endNode) {
            var start = startNode.decorators ? ts2.skipTrivia(sourceFile.text, startNode.decorators.end) : startNode.getStart(sourceFile);
            return ts2.createTextSpanFromBounds(start, (endNode || startNode).getEnd());
          }
          function textSpanEndingAtNextToken(startNode, previousTokenToFindNextEndToken) {
            return textSpan(startNode, ts2.findNextToken(previousTokenToFindNextEndToken, previousTokenToFindNextEndToken.parent, sourceFile));
          }
          function spanInNodeIfStartsOnSameLine(node, otherwiseOnNode) {
            if (node && lineOfPosition === sourceFile.getLineAndCharacterOfPosition(node.getStart(sourceFile)).line) {
              return spanInNode(node);
            }
            return spanInNode(otherwiseOnNode);
          }
          function spanInNodeArray(nodeArray) {
            return ts2.createTextSpanFromBounds(ts2.skipTrivia(sourceFile.text, nodeArray.pos), nodeArray.end);
          }
          function spanInPreviousNode(node) {
            return spanInNode(ts2.findPrecedingToken(node.pos, sourceFile));
          }
          function spanInNextNode(node) {
            return spanInNode(ts2.findNextToken(node, node.parent, sourceFile));
          }
          function spanInNode(node) {
            if (node) {
              var parent = node.parent;
              switch (node.kind) {
                case 225:
                  return spanInVariableDeclaration(node.declarationList.declarations[0]);
                case 242:
                case 159:
                case 158:
                  return spanInVariableDeclaration(node);
                case 156:
                  return spanInParameterDeclaration(node);
                case 244:
                case 161:
                case 160:
                case 163:
                case 164:
                case 162:
                case 201:
                case 202:
                  return spanInFunctionDeclaration(node);
                case 223:
                  if (ts2.isFunctionBlock(node)) {
                    return spanInFunctionBlock(node);
                  }
                case 250:
                  return spanInBlock(node);
                case 280:
                  return spanInBlock(node.block);
                case 226:
                  return textSpan(node.expression);
                case 235:
                  return textSpan(node.getChildAt(0), node.expression);
                case 229:
                  return textSpanEndingAtNextToken(node, node.expression);
                case 228:
                  return spanInNode(node.statement);
                case 241:
                  return textSpan(node.getChildAt(0));
                case 227:
                  return textSpanEndingAtNextToken(node, node.expression);
                case 238:
                  return spanInNode(node.statement);
                case 234:
                case 233:
                  return textSpan(node.getChildAt(0), node.label);
                case 230:
                  return spanInForStatement(node);
                case 231:
                  return textSpanEndingAtNextToken(node, node.expression);
                case 232:
                  return spanInInitializerOfForLike(node);
                case 237:
                  return textSpanEndingAtNextToken(node, node.expression);
                case 277:
                case 278:
                  return spanInNode(node.statements[0]);
                case 240:
                  return spanInBlock(node.tryBlock);
                case 239:
                  return textSpan(node, node.expression);
                case 259:
                  return textSpan(node, node.expression);
                case 253:
                  return textSpan(node, node.moduleReference);
                case 254:
                  return textSpan(node, node.moduleSpecifier);
                case 260:
                  return textSpan(node, node.moduleSpecifier);
                case 249:
                  if (ts2.getModuleInstanceState(node) !== 1) {
                    return void 0;
                  }
                case 245:
                case 248:
                case 284:
                case 191:
                  return textSpan(node);
                case 236:
                  return spanInNode(node.statement);
                case 157:
                  return spanInNodeArray(parent.decorators);
                case 189:
                case 190:
                  return spanInBindingPattern(node);
                case 246:
                case 247:
                  return void 0;
                case 26:
                case 1:
                  return spanInNodeIfStartsOnSameLine(ts2.findPrecedingToken(node.pos, sourceFile));
                case 27:
                  return spanInPreviousNode(node);
                case 18:
                  return spanInOpenBraceToken(node);
                case 19:
                  return spanInCloseBraceToken(node);
                case 23:
                  return spanInCloseBracketToken(node);
                case 20:
                  return spanInOpenParenToken(node);
                case 21:
                  return spanInCloseParenToken(node);
                case 58:
                  return spanInColonToken(node);
                case 31:
                case 29:
                  return spanInGreaterThanOrLessThanToken(node);
                case 111:
                  return spanInWhileKeyword(node);
                case 87:
                case 79:
                case 92:
                  return spanInNextNode(node);
                case 152:
                  return spanInOfKeyword(node);
                default:
                  if (ts2.isArrayLiteralOrObjectLiteralDestructuringPattern(node)) {
                    return spanInArrayLiteralOrObjectLiteralDestructuringPattern(node);
                  }
                  if ((node.kind === 75 || node.kind === 213 || node.kind === 281 || node.kind === 282) && ts2.isArrayLiteralOrObjectLiteralDestructuringPattern(parent)) {
                    return textSpan(node);
                  }
                  if (node.kind === 209) {
                    var _a = node, left = _a.left, operatorToken = _a.operatorToken;
                    if (ts2.isArrayLiteralOrObjectLiteralDestructuringPattern(left)) {
                      return spanInArrayLiteralOrObjectLiteralDestructuringPattern(left);
                    }
                    if (operatorToken.kind === 62 && ts2.isArrayLiteralOrObjectLiteralDestructuringPattern(node.parent)) {
                      return textSpan(node);
                    }
                    if (operatorToken.kind === 27) {
                      return spanInNode(left);
                    }
                  }
                  if (ts2.isExpressionNode(node)) {
                    switch (parent.kind) {
                      case 228:
                        return spanInPreviousNode(node);
                      case 157:
                        return spanInNode(node.parent);
                      case 230:
                      case 232:
                        return textSpan(node);
                      case 209:
                        if (node.parent.operatorToken.kind === 27) {
                          return textSpan(node);
                        }
                        break;
                      case 202:
                        if (node.parent.body === node) {
                          return textSpan(node);
                        }
                        break;
                    }
                  }
                  switch (node.parent.kind) {
                    case 281:
                      if (node.parent.name === node && !ts2.isArrayLiteralOrObjectLiteralDestructuringPattern(node.parent.parent)) {
                        return spanInNode(node.parent.initializer);
                      }
                      break;
                    case 199:
                      if (node.parent.type === node) {
                        return spanInNextNode(node.parent.type);
                      }
                      break;
                    case 242:
                    case 156: {
                      var _b = node.parent, initializer = _b.initializer, type = _b.type;
                      if (initializer === node || type === node || ts2.isAssignmentOperator(node.kind)) {
                        return spanInPreviousNode(node);
                      }
                      break;
                    }
                    case 209: {
                      var left = node.parent.left;
                      if (ts2.isArrayLiteralOrObjectLiteralDestructuringPattern(left) && node !== left) {
                        return spanInPreviousNode(node);
                      }
                      break;
                    }
                    default:
                      if (ts2.isFunctionLike(node.parent) && node.parent.type === node) {
                        return spanInPreviousNode(node);
                      }
                  }
                  return spanInNode(node.parent);
              }
            }
            function textSpanFromVariableDeclaration(variableDeclaration) {
              if (ts2.isVariableDeclarationList(variableDeclaration.parent) && variableDeclaration.parent.declarations[0] === variableDeclaration) {
                return textSpan(ts2.findPrecedingToken(variableDeclaration.pos, sourceFile, variableDeclaration.parent), variableDeclaration);
              } else {
                return textSpan(variableDeclaration);
              }
            }
            function spanInVariableDeclaration(variableDeclaration) {
              if (variableDeclaration.parent.parent.kind === 231) {
                return spanInNode(variableDeclaration.parent.parent);
              }
              var parent2 = variableDeclaration.parent;
              if (ts2.isBindingPattern(variableDeclaration.name)) {
                return spanInBindingPattern(variableDeclaration.name);
              }
              if (variableDeclaration.initializer || ts2.hasModifier(variableDeclaration, 1) || parent2.parent.kind === 232) {
                return textSpanFromVariableDeclaration(variableDeclaration);
              }
              if (ts2.isVariableDeclarationList(variableDeclaration.parent) && variableDeclaration.parent.declarations[0] !== variableDeclaration) {
                return spanInNode(ts2.findPrecedingToken(variableDeclaration.pos, sourceFile, variableDeclaration.parent));
              }
            }
            function canHaveSpanInParameterDeclaration(parameter) {
              return !!parameter.initializer || parameter.dotDotDotToken !== void 0 || ts2.hasModifier(parameter, 4 | 8);
            }
            function spanInParameterDeclaration(parameter) {
              if (ts2.isBindingPattern(parameter.name)) {
                return spanInBindingPattern(parameter.name);
              } else if (canHaveSpanInParameterDeclaration(parameter)) {
                return textSpan(parameter);
              } else {
                var functionDeclaration = parameter.parent;
                var indexOfParameter = functionDeclaration.parameters.indexOf(parameter);
                ts2.Debug.assert(indexOfParameter !== -1);
                if (indexOfParameter !== 0) {
                  return spanInParameterDeclaration(functionDeclaration.parameters[indexOfParameter - 1]);
                } else {
                  return spanInNode(functionDeclaration.body);
                }
              }
            }
            function canFunctionHaveSpanInWholeDeclaration(functionDeclaration) {
              return ts2.hasModifier(functionDeclaration, 1) || functionDeclaration.parent.kind === 245 && functionDeclaration.kind !== 162;
            }
            function spanInFunctionDeclaration(functionDeclaration) {
              if (!functionDeclaration.body) {
                return void 0;
              }
              if (canFunctionHaveSpanInWholeDeclaration(functionDeclaration)) {
                return textSpan(functionDeclaration);
              }
              return spanInNode(functionDeclaration.body);
            }
            function spanInFunctionBlock(block) {
              var nodeForSpanInBlock = block.statements.length ? block.statements[0] : block.getLastToken();
              if (canFunctionHaveSpanInWholeDeclaration(block.parent)) {
                return spanInNodeIfStartsOnSameLine(block.parent, nodeForSpanInBlock);
              }
              return spanInNode(nodeForSpanInBlock);
            }
            function spanInBlock(block) {
              switch (block.parent.kind) {
                case 249:
                  if (ts2.getModuleInstanceState(block.parent) !== 1) {
                    return void 0;
                  }
                case 229:
                case 227:
                case 231:
                  return spanInNodeIfStartsOnSameLine(block.parent, block.statements[0]);
                case 230:
                case 232:
                  return spanInNodeIfStartsOnSameLine(ts2.findPrecedingToken(block.pos, sourceFile, block.parent), block.statements[0]);
              }
              return spanInNode(block.statements[0]);
            }
            function spanInInitializerOfForLike(forLikeStatement) {
              if (forLikeStatement.initializer.kind === 243) {
                var variableDeclarationList = forLikeStatement.initializer;
                if (variableDeclarationList.declarations.length > 0) {
                  return spanInNode(variableDeclarationList.declarations[0]);
                }
              } else {
                return spanInNode(forLikeStatement.initializer);
              }
            }
            function spanInForStatement(forStatement) {
              if (forStatement.initializer) {
                return spanInInitializerOfForLike(forStatement);
              }
              if (forStatement.condition) {
                return textSpan(forStatement.condition);
              }
              if (forStatement.incrementor) {
                return textSpan(forStatement.incrementor);
              }
            }
            function spanInBindingPattern(bindingPattern) {
              var firstBindingElement = ts2.forEach(bindingPattern.elements, function(element) {
                return element.kind !== 215 ? element : void 0;
              });
              if (firstBindingElement) {
                return spanInNode(firstBindingElement);
              }
              if (bindingPattern.parent.kind === 191) {
                return textSpan(bindingPattern.parent);
              }
              return textSpanFromVariableDeclaration(bindingPattern.parent);
            }
            function spanInArrayLiteralOrObjectLiteralDestructuringPattern(node2) {
              ts2.Debug.assert(node2.kind !== 190 && node2.kind !== 189);
              var elements = node2.kind === 192 ? node2.elements : node2.properties;
              var firstBindingElement = ts2.forEach(elements, function(element) {
                return element.kind !== 215 ? element : void 0;
              });
              if (firstBindingElement) {
                return spanInNode(firstBindingElement);
              }
              return textSpan(node2.parent.kind === 209 ? node2.parent : node2);
            }
            function spanInOpenBraceToken(node2) {
              switch (node2.parent.kind) {
                case 248:
                  var enumDeclaration = node2.parent;
                  return spanInNodeIfStartsOnSameLine(ts2.findPrecedingToken(node2.pos, sourceFile, node2.parent), enumDeclaration.members.length ? enumDeclaration.members[0] : enumDeclaration.getLastToken(sourceFile));
                case 245:
                  var classDeclaration = node2.parent;
                  return spanInNodeIfStartsOnSameLine(ts2.findPrecedingToken(node2.pos, sourceFile, node2.parent), classDeclaration.members.length ? classDeclaration.members[0] : classDeclaration.getLastToken(sourceFile));
                case 251:
                  return spanInNodeIfStartsOnSameLine(node2.parent.parent, node2.parent.clauses[0]);
              }
              return spanInNode(node2.parent);
            }
            function spanInCloseBraceToken(node2) {
              switch (node2.parent.kind) {
                case 250:
                  if (ts2.getModuleInstanceState(node2.parent.parent) !== 1) {
                    return void 0;
                  }
                case 248:
                case 245:
                  return textSpan(node2);
                case 223:
                  if (ts2.isFunctionBlock(node2.parent)) {
                    return textSpan(node2);
                  }
                case 280:
                  return spanInNode(ts2.lastOrUndefined(node2.parent.statements));
                case 251:
                  var caseBlock = node2.parent;
                  var lastClause = ts2.lastOrUndefined(caseBlock.clauses);
                  if (lastClause) {
                    return spanInNode(ts2.lastOrUndefined(lastClause.statements));
                  }
                  return void 0;
                case 189:
                  var bindingPattern = node2.parent;
                  return spanInNode(ts2.lastOrUndefined(bindingPattern.elements) || bindingPattern);
                default:
                  if (ts2.isArrayLiteralOrObjectLiteralDestructuringPattern(node2.parent)) {
                    var objectLiteral = node2.parent;
                    return textSpan(ts2.lastOrUndefined(objectLiteral.properties) || objectLiteral);
                  }
                  return spanInNode(node2.parent);
              }
            }
            function spanInCloseBracketToken(node2) {
              switch (node2.parent.kind) {
                case 190:
                  var bindingPattern = node2.parent;
                  return textSpan(ts2.lastOrUndefined(bindingPattern.elements) || bindingPattern);
                default:
                  if (ts2.isArrayLiteralOrObjectLiteralDestructuringPattern(node2.parent)) {
                    var arrayLiteral = node2.parent;
                    return textSpan(ts2.lastOrUndefined(arrayLiteral.elements) || arrayLiteral);
                  }
                  return spanInNode(node2.parent);
              }
            }
            function spanInOpenParenToken(node2) {
              if (node2.parent.kind === 228 || node2.parent.kind === 196 || node2.parent.kind === 197) {
                return spanInPreviousNode(node2);
              }
              if (node2.parent.kind === 200) {
                return spanInNextNode(node2);
              }
              return spanInNode(node2.parent);
            }
            function spanInCloseParenToken(node2) {
              switch (node2.parent.kind) {
                case 201:
                case 244:
                case 202:
                case 161:
                case 160:
                case 163:
                case 164:
                case 162:
                case 229:
                case 228:
                case 230:
                case 232:
                case 196:
                case 197:
                case 200:
                  return spanInPreviousNode(node2);
                default:
                  return spanInNode(node2.parent);
              }
            }
            function spanInColonToken(node2) {
              if (ts2.isFunctionLike(node2.parent) || node2.parent.kind === 281 || node2.parent.kind === 156) {
                return spanInPreviousNode(node2);
              }
              return spanInNode(node2.parent);
            }
            function spanInGreaterThanOrLessThanToken(node2) {
              if (node2.parent.kind === 199) {
                return spanInNextNode(node2);
              }
              return spanInNode(node2.parent);
            }
            function spanInWhileKeyword(node2) {
              if (node2.parent.kind === 228) {
                return textSpanEndingAtNextToken(node2, node2.parent.expression);
              }
              return spanInNode(node2.parent);
            }
            function spanInOfKeyword(node2) {
              if (node2.parent.kind === 232) {
                return spanInNextNode(node2);
              }
              return spanInNode(node2.parent);
            }
          }
        }
        BreakpointResolver2.spanInSourceFileAtLocation = spanInSourceFileAtLocation;
      })(BreakpointResolver = ts2.BreakpointResolver || (ts2.BreakpointResolver = {}));
    })(ts || (ts = {}));
    var ts;
    (function(ts2) {
      function transform(source, transformers, compilerOptions) {
        var diagnostics = [];
        compilerOptions = ts2.fixupCompilerOptions(compilerOptions, diagnostics);
        var nodes = ts2.isArray(source) ? source : [source];
        var result = ts2.transformNodes(void 0, void 0, compilerOptions, nodes, transformers, true);
        result.diagnostics = ts2.concatenate(result.diagnostics, diagnostics);
        return result;
      }
      ts2.transform = transform;
    })(ts || (ts = {}));
    var debugObjectHost = function() {
      return this;
    }();
    var ts;
    (function(ts2) {
      function logInternalError(logger, err) {
        if (logger) {
          logger.log("*INTERNAL ERROR* - Exception in typescript services: " + err.message);
        }
      }
      var ScriptSnapshotShimAdapter = function() {
        function ScriptSnapshotShimAdapter2(scriptSnapshotShim) {
          this.scriptSnapshotShim = scriptSnapshotShim;
        }
        ScriptSnapshotShimAdapter2.prototype.getText = function(start, end) {
          return this.scriptSnapshotShim.getText(start, end);
        };
        ScriptSnapshotShimAdapter2.prototype.getLength = function() {
          return this.scriptSnapshotShim.getLength();
        };
        ScriptSnapshotShimAdapter2.prototype.getChangeRange = function(oldSnapshot) {
          var oldSnapshotShim = oldSnapshot;
          var encoded = this.scriptSnapshotShim.getChangeRange(oldSnapshotShim.scriptSnapshotShim);
          if (encoded === null) {
            return null;
          }
          var decoded = JSON.parse(encoded);
          return ts2.createTextChangeRange(ts2.createTextSpan(decoded.span.start, decoded.span.length), decoded.newLength);
        };
        ScriptSnapshotShimAdapter2.prototype.dispose = function() {
          if ("dispose" in this.scriptSnapshotShim) {
            this.scriptSnapshotShim.dispose();
          }
        };
        return ScriptSnapshotShimAdapter2;
      }();
      var LanguageServiceShimHostAdapter = function() {
        function LanguageServiceShimHostAdapter2(shimHost) {
          var _this = this;
          this.shimHost = shimHost;
          this.loggingEnabled = false;
          this.tracingEnabled = false;
          if ("getModuleResolutionsForFile" in this.shimHost) {
            this.resolveModuleNames = function(moduleNames, containingFile) {
              var resolutionsInFile = JSON.parse(_this.shimHost.getModuleResolutionsForFile(containingFile));
              return ts2.map(moduleNames, function(name) {
                var result = ts2.getProperty(resolutionsInFile, name);
                return result ? { resolvedFileName: result, extension: ts2.extensionFromPath(result), isExternalLibraryImport: false } : void 0;
              });
            };
          }
          if ("directoryExists" in this.shimHost) {
            this.directoryExists = function(directoryName) {
              return _this.shimHost.directoryExists(directoryName);
            };
          }
          if ("getTypeReferenceDirectiveResolutionsForFile" in this.shimHost) {
            this.resolveTypeReferenceDirectives = function(typeDirectiveNames, containingFile) {
              var typeDirectivesForFile = JSON.parse(_this.shimHost.getTypeReferenceDirectiveResolutionsForFile(containingFile));
              return ts2.map(typeDirectiveNames, function(name) {
                return ts2.getProperty(typeDirectivesForFile, name);
              });
            };
          }
        }
        LanguageServiceShimHostAdapter2.prototype.log = function(s) {
          if (this.loggingEnabled) {
            this.shimHost.log(s);
          }
        };
        LanguageServiceShimHostAdapter2.prototype.trace = function(s) {
          if (this.tracingEnabled) {
            this.shimHost.trace(s);
          }
        };
        LanguageServiceShimHostAdapter2.prototype.error = function(s) {
          this.shimHost.error(s);
        };
        LanguageServiceShimHostAdapter2.prototype.getProjectVersion = function() {
          if (!this.shimHost.getProjectVersion) {
            return void 0;
          }
          return this.shimHost.getProjectVersion();
        };
        LanguageServiceShimHostAdapter2.prototype.getTypeRootsVersion = function() {
          if (!this.shimHost.getTypeRootsVersion) {
            return 0;
          }
          return this.shimHost.getTypeRootsVersion();
        };
        LanguageServiceShimHostAdapter2.prototype.useCaseSensitiveFileNames = function() {
          return this.shimHost.useCaseSensitiveFileNames ? this.shimHost.useCaseSensitiveFileNames() : false;
        };
        LanguageServiceShimHostAdapter2.prototype.getCompilationSettings = function() {
          var settingsJson = this.shimHost.getCompilationSettings();
          if (settingsJson === null || settingsJson === "") {
            throw Error("LanguageServiceShimHostAdapter.getCompilationSettings: empty compilationSettings");
          }
          var compilerOptions = JSON.parse(settingsJson);
          compilerOptions.allowNonTsExtensions = true;
          return compilerOptions;
        };
        LanguageServiceShimHostAdapter2.prototype.getScriptFileNames = function() {
          var encoded = this.shimHost.getScriptFileNames();
          return JSON.parse(encoded);
        };
        LanguageServiceShimHostAdapter2.prototype.getScriptSnapshot = function(fileName) {
          var scriptSnapshot = this.shimHost.getScriptSnapshot(fileName);
          return scriptSnapshot && new ScriptSnapshotShimAdapter(scriptSnapshot);
        };
        LanguageServiceShimHostAdapter2.prototype.getScriptKind = function(fileName) {
          if ("getScriptKind" in this.shimHost) {
            return this.shimHost.getScriptKind(fileName);
          } else {
            return 0;
          }
        };
        LanguageServiceShimHostAdapter2.prototype.getScriptVersion = function(fileName) {
          return this.shimHost.getScriptVersion(fileName);
        };
        LanguageServiceShimHostAdapter2.prototype.getLocalizedDiagnosticMessages = function() {
          var diagnosticMessagesJson = this.shimHost.getLocalizedDiagnosticMessages();
          if (diagnosticMessagesJson === null || diagnosticMessagesJson === "") {
            return null;
          }
          try {
            return JSON.parse(diagnosticMessagesJson);
          } catch (e) {
            this.log(e.description || "diagnosticMessages.generated.json has invalid JSON format");
            return null;
          }
        };
        LanguageServiceShimHostAdapter2.prototype.getCancellationToken = function() {
          var hostCancellationToken = this.shimHost.getCancellationToken();
          return new ts2.ThrottledCancellationToken(hostCancellationToken);
        };
        LanguageServiceShimHostAdapter2.prototype.getCurrentDirectory = function() {
          return this.shimHost.getCurrentDirectory();
        };
        LanguageServiceShimHostAdapter2.prototype.getDirectories = function(path2) {
          return JSON.parse(this.shimHost.getDirectories(path2));
        };
        LanguageServiceShimHostAdapter2.prototype.getDefaultLibFileName = function(options) {
          return this.shimHost.getDefaultLibFileName(JSON.stringify(options));
        };
        LanguageServiceShimHostAdapter2.prototype.readDirectory = function(path2, extensions, exclude, include, depth) {
          var pattern = ts2.getFileMatcherPatterns(path2, exclude, include, this.shimHost.useCaseSensitiveFileNames(), this.shimHost.getCurrentDirectory());
          return JSON.parse(this.shimHost.readDirectory(path2, JSON.stringify(extensions), JSON.stringify(pattern.basePaths), pattern.excludePattern, pattern.includeFilePattern, pattern.includeDirectoryPattern, depth));
        };
        LanguageServiceShimHostAdapter2.prototype.readFile = function(path2, encoding) {
          return this.shimHost.readFile(path2, encoding);
        };
        LanguageServiceShimHostAdapter2.prototype.fileExists = function(path2) {
          return this.shimHost.fileExists(path2);
        };
        return LanguageServiceShimHostAdapter2;
      }();
      ts2.LanguageServiceShimHostAdapter = LanguageServiceShimHostAdapter;
      var CoreServicesShimHostAdapter = function() {
        function CoreServicesShimHostAdapter2(shimHost) {
          var _this = this;
          this.shimHost = shimHost;
          this.useCaseSensitiveFileNames = this.shimHost.useCaseSensitiveFileNames ? this.shimHost.useCaseSensitiveFileNames() : false;
          if ("directoryExists" in this.shimHost) {
            this.directoryExists = function(directoryName) {
              return _this.shimHost.directoryExists(directoryName);
            };
          } else {
            this.directoryExists = void 0;
          }
          if ("realpath" in this.shimHost) {
            this.realpath = function(path2) {
              return _this.shimHost.realpath(path2);
            };
          } else {
            this.realpath = void 0;
          }
        }
        CoreServicesShimHostAdapter2.prototype.readDirectory = function(rootDir, extensions, exclude, include, depth) {
          var pattern = ts2.getFileMatcherPatterns(rootDir, exclude, include, this.shimHost.useCaseSensitiveFileNames(), this.shimHost.getCurrentDirectory());
          return JSON.parse(this.shimHost.readDirectory(rootDir, JSON.stringify(extensions), JSON.stringify(pattern.basePaths), pattern.excludePattern, pattern.includeFilePattern, pattern.includeDirectoryPattern, depth));
        };
        CoreServicesShimHostAdapter2.prototype.fileExists = function(fileName) {
          return this.shimHost.fileExists(fileName);
        };
        CoreServicesShimHostAdapter2.prototype.readFile = function(fileName) {
          return this.shimHost.readFile(fileName);
        };
        CoreServicesShimHostAdapter2.prototype.getDirectories = function(path2) {
          return JSON.parse(this.shimHost.getDirectories(path2));
        };
        return CoreServicesShimHostAdapter2;
      }();
      ts2.CoreServicesShimHostAdapter = CoreServicesShimHostAdapter;
      function simpleForwardCall(logger, actionDescription, action, logPerformance) {
        var start;
        if (logPerformance) {
          logger.log(actionDescription);
          start = ts2.timestamp();
        }
        var result = action();
        if (logPerformance) {
          var end = ts2.timestamp();
          logger.log(actionDescription + " completed in " + (end - start) + " msec");
          if (ts2.isString(result)) {
            var str = result;
            if (str.length > 128) {
              str = str.substring(0, 128) + "...";
            }
            logger.log("  result.length=" + str.length + ", result='" + JSON.stringify(str) + "'");
          }
        }
        return result;
      }
      function forwardJSONCall(logger, actionDescription, action, logPerformance) {
        return forwardCall(logger, actionDescription, true, action, logPerformance);
      }
      function forwardCall(logger, actionDescription, returnJson, action, logPerformance) {
        try {
          var result = simpleForwardCall(logger, actionDescription, action, logPerformance);
          return returnJson ? JSON.stringify({ result }) : result;
        } catch (err) {
          if (err instanceof ts2.OperationCanceledException) {
            return JSON.stringify({ canceled: true });
          }
          logInternalError(logger, err);
          err.description = actionDescription;
          return JSON.stringify({ error: err });
        }
      }
      var ShimBase = function() {
        function ShimBase2(factory) {
          this.factory = factory;
          factory.registerShim(this);
        }
        ShimBase2.prototype.dispose = function(_dummy) {
          this.factory.unregisterShim(this);
        };
        return ShimBase2;
      }();
      function realizeDiagnostics(diagnostics, newLine) {
        return diagnostics.map(function(d) {
          return realizeDiagnostic(d, newLine);
        });
      }
      ts2.realizeDiagnostics = realizeDiagnostics;
      function realizeDiagnostic(diagnostic, newLine) {
        return {
          message: ts2.flattenDiagnosticMessageText(diagnostic.messageText, newLine),
          start: diagnostic.start,
          length: diagnostic.length,
          category: ts2.diagnosticCategoryName(diagnostic),
          code: diagnostic.code,
          reportsUnnecessary: diagnostic.reportsUnnecessary
        };
      }
      var LanguageServiceShimObject = function(_super) {
        __extends(LanguageServiceShimObject2, _super);
        function LanguageServiceShimObject2(factory, host, languageService) {
          var _this = _super.call(this, factory) || this;
          _this.host = host;
          _this.languageService = languageService;
          _this.logPerformance = false;
          _this.logger = _this.host;
          return _this;
        }
        LanguageServiceShimObject2.prototype.forwardJSONCall = function(actionDescription, action) {
          return forwardJSONCall(this.logger, actionDescription, action, this.logPerformance);
        };
        LanguageServiceShimObject2.prototype.dispose = function(dummy) {
          this.logger.log("dispose()");
          this.languageService.dispose();
          this.languageService = null;
          if (debugObjectHost && debugObjectHost.CollectGarbage) {
            debugObjectHost.CollectGarbage();
            this.logger.log("CollectGarbage()");
          }
          this.logger = null;
          _super.prototype.dispose.call(this, dummy);
        };
        LanguageServiceShimObject2.prototype.refresh = function(throwOnError) {
          this.forwardJSONCall("refresh(" + throwOnError + ")", function() {
            return null;
          });
        };
        LanguageServiceShimObject2.prototype.cleanupSemanticCache = function() {
          var _this = this;
          this.forwardJSONCall("cleanupSemanticCache()", function() {
            _this.languageService.cleanupSemanticCache();
            return null;
          });
        };
        LanguageServiceShimObject2.prototype.realizeDiagnostics = function(diagnostics) {
          var newLine = ts2.getNewLineOrDefaultFromHost(this.host);
          return realizeDiagnostics(diagnostics, newLine);
        };
        LanguageServiceShimObject2.prototype.getSyntacticClassifications = function(fileName, start, length) {
          var _this = this;
          return this.forwardJSONCall("getSyntacticClassifications('" + fileName + "', " + start + ", " + length + ")", function() {
            return _this.languageService.getSyntacticClassifications(fileName, ts2.createTextSpan(start, length));
          });
        };
        LanguageServiceShimObject2.prototype.getSemanticClassifications = function(fileName, start, length) {
          var _this = this;
          return this.forwardJSONCall("getSemanticClassifications('" + fileName + "', " + start + ", " + length + ")", function() {
            return _this.languageService.getSemanticClassifications(fileName, ts2.createTextSpan(start, length));
          });
        };
        LanguageServiceShimObject2.prototype.getEncodedSyntacticClassifications = function(fileName, start, length) {
          var _this = this;
          return this.forwardJSONCall("getEncodedSyntacticClassifications('" + fileName + "', " + start + ", " + length + ")", function() {
            return convertClassifications(_this.languageService.getEncodedSyntacticClassifications(fileName, ts2.createTextSpan(start, length)));
          });
        };
        LanguageServiceShimObject2.prototype.getEncodedSemanticClassifications = function(fileName, start, length) {
          var _this = this;
          return this.forwardJSONCall("getEncodedSemanticClassifications('" + fileName + "', " + start + ", " + length + ")", function() {
            return convertClassifications(_this.languageService.getEncodedSemanticClassifications(fileName, ts2.createTextSpan(start, length)));
          });
        };
        LanguageServiceShimObject2.prototype.getSyntacticDiagnostics = function(fileName) {
          var _this = this;
          return this.forwardJSONCall("getSyntacticDiagnostics('" + fileName + "')", function() {
            var diagnostics = _this.languageService.getSyntacticDiagnostics(fileName);
            return _this.realizeDiagnostics(diagnostics);
          });
        };
        LanguageServiceShimObject2.prototype.getSemanticDiagnostics = function(fileName) {
          var _this = this;
          return this.forwardJSONCall("getSemanticDiagnostics('" + fileName + "')", function() {
            var diagnostics = _this.languageService.getSemanticDiagnostics(fileName);
            return _this.realizeDiagnostics(diagnostics);
          });
        };
        LanguageServiceShimObject2.prototype.getSuggestionDiagnostics = function(fileName) {
          var _this = this;
          return this.forwardJSONCall("getSuggestionDiagnostics('" + fileName + "')", function() {
            return _this.realizeDiagnostics(_this.languageService.getSuggestionDiagnostics(fileName));
          });
        };
        LanguageServiceShimObject2.prototype.getCompilerOptionsDiagnostics = function() {
          var _this = this;
          return this.forwardJSONCall("getCompilerOptionsDiagnostics()", function() {
            var diagnostics = _this.languageService.getCompilerOptionsDiagnostics();
            return _this.realizeDiagnostics(diagnostics);
          });
        };
        LanguageServiceShimObject2.prototype.getQuickInfoAtPosition = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getQuickInfoAtPosition('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getQuickInfoAtPosition(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.getNameOrDottedNameSpan = function(fileName, startPos, endPos) {
          var _this = this;
          return this.forwardJSONCall("getNameOrDottedNameSpan('" + fileName + "', " + startPos + ", " + endPos + ")", function() {
            return _this.languageService.getNameOrDottedNameSpan(fileName, startPos, endPos);
          });
        };
        LanguageServiceShimObject2.prototype.getBreakpointStatementAtPosition = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getBreakpointStatementAtPosition('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getBreakpointStatementAtPosition(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.getSignatureHelpItems = function(fileName, position, options) {
          var _this = this;
          return this.forwardJSONCall("getSignatureHelpItems('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getSignatureHelpItems(fileName, position, options);
          });
        };
        LanguageServiceShimObject2.prototype.getDefinitionAtPosition = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getDefinitionAtPosition('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getDefinitionAtPosition(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.getDefinitionAndBoundSpan = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getDefinitionAndBoundSpan('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getDefinitionAndBoundSpan(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.getTypeDefinitionAtPosition = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getTypeDefinitionAtPosition('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getTypeDefinitionAtPosition(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.getImplementationAtPosition = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getImplementationAtPosition('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getImplementationAtPosition(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.getRenameInfo = function(fileName, position, options) {
          var _this = this;
          return this.forwardJSONCall("getRenameInfo('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getRenameInfo(fileName, position, options);
          });
        };
        LanguageServiceShimObject2.prototype.getSmartSelectionRange = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getSmartSelectionRange('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getSmartSelectionRange(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.findRenameLocations = function(fileName, position, findInStrings, findInComments, providePrefixAndSuffixTextForRename) {
          var _this = this;
          return this.forwardJSONCall("findRenameLocations('" + fileName + "', " + position + ", " + findInStrings + ", " + findInComments + ", " + providePrefixAndSuffixTextForRename + ")", function() {
            return _this.languageService.findRenameLocations(fileName, position, findInStrings, findInComments, providePrefixAndSuffixTextForRename);
          });
        };
        LanguageServiceShimObject2.prototype.getBraceMatchingAtPosition = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getBraceMatchingAtPosition('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getBraceMatchingAtPosition(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.isValidBraceCompletionAtPosition = function(fileName, position, openingBrace) {
          var _this = this;
          return this.forwardJSONCall("isValidBraceCompletionAtPosition('" + fileName + "', " + position + ", " + openingBrace + ")", function() {
            return _this.languageService.isValidBraceCompletionAtPosition(fileName, position, openingBrace);
          });
        };
        LanguageServiceShimObject2.prototype.getSpanOfEnclosingComment = function(fileName, position, onlyMultiLine) {
          var _this = this;
          return this.forwardJSONCall("getSpanOfEnclosingComment('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getSpanOfEnclosingComment(fileName, position, onlyMultiLine);
          });
        };
        LanguageServiceShimObject2.prototype.getIndentationAtPosition = function(fileName, position, options) {
          var _this = this;
          return this.forwardJSONCall("getIndentationAtPosition('" + fileName + "', " + position + ")", function() {
            var localOptions = JSON.parse(options);
            return _this.languageService.getIndentationAtPosition(fileName, position, localOptions);
          });
        };
        LanguageServiceShimObject2.prototype.getReferencesAtPosition = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getReferencesAtPosition('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getReferencesAtPosition(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.findReferences = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("findReferences('" + fileName + "', " + position + ")", function() {
            return _this.languageService.findReferences(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.getOccurrencesAtPosition = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getOccurrencesAtPosition('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getOccurrencesAtPosition(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.getDocumentHighlights = function(fileName, position, filesToSearch) {
          var _this = this;
          return this.forwardJSONCall("getDocumentHighlights('" + fileName + "', " + position + ")", function() {
            var results = _this.languageService.getDocumentHighlights(fileName, position, JSON.parse(filesToSearch));
            var normalizedName = ts2.toFileNameLowerCase(ts2.normalizeSlashes(fileName));
            return ts2.filter(results, function(r) {
              return ts2.toFileNameLowerCase(ts2.normalizeSlashes(r.fileName)) === normalizedName;
            });
          });
        };
        LanguageServiceShimObject2.prototype.getCompletionsAtPosition = function(fileName, position, preferences) {
          var _this = this;
          return this.forwardJSONCall("getCompletionsAtPosition('" + fileName + "', " + position + ", " + preferences + ")", function() {
            return _this.languageService.getCompletionsAtPosition(fileName, position, preferences);
          });
        };
        LanguageServiceShimObject2.prototype.getCompletionEntryDetails = function(fileName, position, entryName, formatOptions, source, preferences) {
          var _this = this;
          return this.forwardJSONCall("getCompletionEntryDetails('" + fileName + "', " + position + ", '" + entryName + "')", function() {
            var localOptions = formatOptions === void 0 ? void 0 : JSON.parse(formatOptions);
            return _this.languageService.getCompletionEntryDetails(fileName, position, entryName, localOptions, source, preferences);
          });
        };
        LanguageServiceShimObject2.prototype.getFormattingEditsForRange = function(fileName, start, end, options) {
          var _this = this;
          return this.forwardJSONCall("getFormattingEditsForRange('" + fileName + "', " + start + ", " + end + ")", function() {
            var localOptions = JSON.parse(options);
            return _this.languageService.getFormattingEditsForRange(fileName, start, end, localOptions);
          });
        };
        LanguageServiceShimObject2.prototype.getFormattingEditsForDocument = function(fileName, options) {
          var _this = this;
          return this.forwardJSONCall("getFormattingEditsForDocument('" + fileName + "')", function() {
            var localOptions = JSON.parse(options);
            return _this.languageService.getFormattingEditsForDocument(fileName, localOptions);
          });
        };
        LanguageServiceShimObject2.prototype.getFormattingEditsAfterKeystroke = function(fileName, position, key, options) {
          var _this = this;
          return this.forwardJSONCall("getFormattingEditsAfterKeystroke('" + fileName + "', " + position + ", '" + key + "')", function() {
            var localOptions = JSON.parse(options);
            return _this.languageService.getFormattingEditsAfterKeystroke(fileName, position, key, localOptions);
          });
        };
        LanguageServiceShimObject2.prototype.getDocCommentTemplateAtPosition = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("getDocCommentTemplateAtPosition('" + fileName + "', " + position + ")", function() {
            return _this.languageService.getDocCommentTemplateAtPosition(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.getNavigateToItems = function(searchValue, maxResultCount, fileName) {
          var _this = this;
          return this.forwardJSONCall("getNavigateToItems('" + searchValue + "', " + maxResultCount + ", " + fileName + ")", function() {
            return _this.languageService.getNavigateToItems(searchValue, maxResultCount, fileName);
          });
        };
        LanguageServiceShimObject2.prototype.getNavigationBarItems = function(fileName) {
          var _this = this;
          return this.forwardJSONCall("getNavigationBarItems('" + fileName + "')", function() {
            return _this.languageService.getNavigationBarItems(fileName);
          });
        };
        LanguageServiceShimObject2.prototype.getNavigationTree = function(fileName) {
          var _this = this;
          return this.forwardJSONCall("getNavigationTree('" + fileName + "')", function() {
            return _this.languageService.getNavigationTree(fileName);
          });
        };
        LanguageServiceShimObject2.prototype.getOutliningSpans = function(fileName) {
          var _this = this;
          return this.forwardJSONCall("getOutliningSpans('" + fileName + "')", function() {
            return _this.languageService.getOutliningSpans(fileName);
          });
        };
        LanguageServiceShimObject2.prototype.getTodoComments = function(fileName, descriptors) {
          var _this = this;
          return this.forwardJSONCall("getTodoComments('" + fileName + "')", function() {
            return _this.languageService.getTodoComments(fileName, JSON.parse(descriptors));
          });
        };
        LanguageServiceShimObject2.prototype.prepareCallHierarchy = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("prepareCallHierarchy('" + fileName + "', " + position + ")", function() {
            return _this.languageService.prepareCallHierarchy(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.provideCallHierarchyIncomingCalls = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("provideCallHierarchyIncomingCalls('" + fileName + "', " + position + ")", function() {
            return _this.languageService.provideCallHierarchyIncomingCalls(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.provideCallHierarchyOutgoingCalls = function(fileName, position) {
          var _this = this;
          return this.forwardJSONCall("provideCallHierarchyOutgoingCalls('" + fileName + "', " + position + ")", function() {
            return _this.languageService.provideCallHierarchyOutgoingCalls(fileName, position);
          });
        };
        LanguageServiceShimObject2.prototype.getEmitOutput = function(fileName) {
          var _this = this;
          return this.forwardJSONCall("getEmitOutput('" + fileName + "')", function() {
            var _a = _this.languageService.getEmitOutput(fileName), diagnostics = _a.diagnostics, rest = __rest(_a, ["diagnostics"]);
            return __assign(__assign({}, rest), { diagnostics: _this.realizeDiagnostics(diagnostics) });
          });
        };
        LanguageServiceShimObject2.prototype.getEmitOutputObject = function(fileName) {
          var _this = this;
          return forwardCall(this.logger, "getEmitOutput('" + fileName + "')", false, function() {
            return _this.languageService.getEmitOutput(fileName);
          }, this.logPerformance);
        };
        return LanguageServiceShimObject2;
      }(ShimBase);
      function convertClassifications(classifications) {
        return { spans: classifications.spans.join(","), endOfLineState: classifications.endOfLineState };
      }
      var ClassifierShimObject = function(_super) {
        __extends(ClassifierShimObject2, _super);
        function ClassifierShimObject2(factory, logger) {
          var _this = _super.call(this, factory) || this;
          _this.logger = logger;
          _this.logPerformance = false;
          _this.classifier = ts2.createClassifier();
          return _this;
        }
        ClassifierShimObject2.prototype.getEncodedLexicalClassifications = function(text, lexState, syntacticClassifierAbsent) {
          var _this = this;
          if (syntacticClassifierAbsent === void 0) {
            syntacticClassifierAbsent = false;
          }
          return forwardJSONCall(this.logger, "getEncodedLexicalClassifications", function() {
            return convertClassifications(_this.classifier.getEncodedLexicalClassifications(text, lexState, syntacticClassifierAbsent));
          }, this.logPerformance);
        };
        ClassifierShimObject2.prototype.getClassificationsForLine = function(text, lexState, classifyKeywordsInGenerics) {
          if (classifyKeywordsInGenerics === void 0) {
            classifyKeywordsInGenerics = false;
          }
          var classification = this.classifier.getClassificationsForLine(text, lexState, classifyKeywordsInGenerics);
          var result = "";
          for (var _i = 0, _a = classification.entries; _i < _a.length; _i++) {
            var item = _a[_i];
            result += item.length + "\n";
            result += item.classification + "\n";
          }
          result += classification.finalLexState;
          return result;
        };
        return ClassifierShimObject2;
      }(ShimBase);
      var CoreServicesShimObject = function(_super) {
        __extends(CoreServicesShimObject2, _super);
        function CoreServicesShimObject2(factory, logger, host) {
          var _this = _super.call(this, factory) || this;
          _this.logger = logger;
          _this.host = host;
          _this.logPerformance = false;
          return _this;
        }
        CoreServicesShimObject2.prototype.forwardJSONCall = function(actionDescription, action) {
          return forwardJSONCall(this.logger, actionDescription, action, this.logPerformance);
        };
        CoreServicesShimObject2.prototype.resolveModuleName = function(fileName, moduleName, compilerOptionsJson) {
          var _this = this;
          return this.forwardJSONCall("resolveModuleName('" + fileName + "')", function() {
            var compilerOptions = JSON.parse(compilerOptionsJson);
            var result = ts2.resolveModuleName(moduleName, ts2.normalizeSlashes(fileName), compilerOptions, _this.host);
            var resolvedFileName = result.resolvedModule ? result.resolvedModule.resolvedFileName : void 0;
            if (result.resolvedModule && result.resolvedModule.extension !== ".ts" && result.resolvedModule.extension !== ".tsx" && result.resolvedModule.extension !== ".d.ts") {
              resolvedFileName = void 0;
            }
            return {
              resolvedFileName,
              failedLookupLocations: result.failedLookupLocations
            };
          });
        };
        CoreServicesShimObject2.prototype.resolveTypeReferenceDirective = function(fileName, typeReferenceDirective, compilerOptionsJson) {
          var _this = this;
          return this.forwardJSONCall("resolveTypeReferenceDirective(" + fileName + ")", function() {
            var compilerOptions = JSON.parse(compilerOptionsJson);
            var result = ts2.resolveTypeReferenceDirective(typeReferenceDirective, ts2.normalizeSlashes(fileName), compilerOptions, _this.host);
            return {
              resolvedFileName: result.resolvedTypeReferenceDirective ? result.resolvedTypeReferenceDirective.resolvedFileName : void 0,
              primary: result.resolvedTypeReferenceDirective ? result.resolvedTypeReferenceDirective.primary : true,
              failedLookupLocations: result.failedLookupLocations
            };
          });
        };
        CoreServicesShimObject2.prototype.getPreProcessedFileInfo = function(fileName, sourceTextSnapshot) {
          var _this = this;
          return this.forwardJSONCall("getPreProcessedFileInfo('" + fileName + "')", function() {
            var result = ts2.preProcessFile(ts2.getSnapshotText(sourceTextSnapshot), true, true);
            return {
              referencedFiles: _this.convertFileReferences(result.referencedFiles),
              importedFiles: _this.convertFileReferences(result.importedFiles),
              ambientExternalModules: result.ambientExternalModules,
              isLibFile: result.isLibFile,
              typeReferenceDirectives: _this.convertFileReferences(result.typeReferenceDirectives),
              libReferenceDirectives: _this.convertFileReferences(result.libReferenceDirectives)
            };
          });
        };
        CoreServicesShimObject2.prototype.getAutomaticTypeDirectiveNames = function(compilerOptionsJson) {
          var _this = this;
          return this.forwardJSONCall("getAutomaticTypeDirectiveNames('" + compilerOptionsJson + "')", function() {
            var compilerOptions = JSON.parse(compilerOptionsJson);
            return ts2.getAutomaticTypeDirectiveNames(compilerOptions, _this.host);
          });
        };
        CoreServicesShimObject2.prototype.convertFileReferences = function(refs) {
          if (!refs) {
            return void 0;
          }
          var result = [];
          for (var _i = 0, refs_1 = refs; _i < refs_1.length; _i++) {
            var ref = refs_1[_i];
            result.push({
              path: ts2.normalizeSlashes(ref.fileName),
              position: ref.pos,
              length: ref.end - ref.pos
            });
          }
          return result;
        };
        CoreServicesShimObject2.prototype.getTSConfigFileInfo = function(fileName, sourceTextSnapshot) {
          var _this = this;
          return this.forwardJSONCall("getTSConfigFileInfo('" + fileName + "')", function() {
            var result = ts2.parseJsonText(fileName, ts2.getSnapshotText(sourceTextSnapshot));
            var normalizedFileName = ts2.normalizeSlashes(fileName);
            var configFile = ts2.parseJsonSourceFileConfigFileContent(result, _this.host, ts2.getDirectoryPath(normalizedFileName), {}, normalizedFileName);
            return {
              options: configFile.options,
              typeAcquisition: configFile.typeAcquisition,
              files: configFile.fileNames,
              raw: configFile.raw,
              errors: realizeDiagnostics(__spreadArrays(result.parseDiagnostics, configFile.errors), "\r\n")
            };
          });
        };
        CoreServicesShimObject2.prototype.getDefaultCompilationSettings = function() {
          return this.forwardJSONCall("getDefaultCompilationSettings()", function() {
            return ts2.getDefaultCompilerOptions();
          });
        };
        CoreServicesShimObject2.prototype.discoverTypings = function(discoverTypingsJson) {
          var _this = this;
          var getCanonicalFileName = ts2.createGetCanonicalFileName(false);
          return this.forwardJSONCall("discoverTypings()", function() {
            var info = JSON.parse(discoverTypingsJson);
            if (_this.safeList === void 0) {
              _this.safeList = ts2.JsTyping.loadSafeList(_this.host, ts2.toPath(info.safeListPath, info.safeListPath, getCanonicalFileName));
            }
            return ts2.JsTyping.discoverTypings(_this.host, function(msg) {
              return _this.logger.log(msg);
            }, info.fileNames, ts2.toPath(info.projectRootPath, info.projectRootPath, getCanonicalFileName), _this.safeList, info.packageNameToTypingLocation, info.typeAcquisition, info.unresolvedImports, info.typesRegistry);
          });
        };
        return CoreServicesShimObject2;
      }(ShimBase);
      var TypeScriptServicesFactory = function() {
        function TypeScriptServicesFactory2() {
          this._shims = [];
        }
        TypeScriptServicesFactory2.prototype.getServicesVersion = function() {
          return ts2.servicesVersion;
        };
        TypeScriptServicesFactory2.prototype.createLanguageServiceShim = function(host) {
          try {
            if (this.documentRegistry === void 0) {
              this.documentRegistry = ts2.createDocumentRegistry(host.useCaseSensitiveFileNames && host.useCaseSensitiveFileNames(), host.getCurrentDirectory());
            }
            var hostAdapter = new LanguageServiceShimHostAdapter(host);
            var languageService = ts2.createLanguageService(hostAdapter, this.documentRegistry, false);
            return new LanguageServiceShimObject(this, host, languageService);
          } catch (err) {
            logInternalError(host, err);
            throw err;
          }
        };
        TypeScriptServicesFactory2.prototype.createClassifierShim = function(logger) {
          try {
            return new ClassifierShimObject(this, logger);
          } catch (err) {
            logInternalError(logger, err);
            throw err;
          }
        };
        TypeScriptServicesFactory2.prototype.createCoreServicesShim = function(host) {
          try {
            var adapter = new CoreServicesShimHostAdapter(host);
            return new CoreServicesShimObject(this, host, adapter);
          } catch (err) {
            logInternalError(host, err);
            throw err;
          }
        };
        TypeScriptServicesFactory2.prototype.close = function() {
          ts2.clear(this._shims);
          this.documentRegistry = void 0;
        };
        TypeScriptServicesFactory2.prototype.registerShim = function(shim) {
          this._shims.push(shim);
        };
        TypeScriptServicesFactory2.prototype.unregisterShim = function(shim) {
          for (var i = 0; i < this._shims.length; i++) {
            if (this._shims[i] === shim) {
              delete this._shims[i];
              return;
            }
          }
          throw new Error("Invalid operation");
        };
        return TypeScriptServicesFactory2;
      }();
      ts2.TypeScriptServicesFactory = TypeScriptServicesFactory;
    })(ts || (ts = {}));
    (function() {
      if (typeof globalThis === "object")
        return;
      try {
        Object.defineProperty(Object.prototype, "__magic__", {
          get: function() {
            return this;
          },
          configurable: true
        });
        __magic__.globalThis = __magic__;
        if (typeof globalThis === "undefined") {
          window.globalThis = window;
        }
        delete Object.prototype.__magic__;
      } catch (error) {
        window.globalThis = window;
      }
    })();
    if (typeof process === "undefined" || process.browser) {
      globalThis.TypeScript = globalThis.TypeScript || {};
      globalThis.TypeScript.Services = globalThis.TypeScript.Services || {};
      globalThis.TypeScript.Services.TypeScriptServicesFactory = ts.TypeScriptServicesFactory;
      globalThis.toolsVersion = ts.versionMajorMinor;
    }
    if (typeof module2 !== "undefined" && module2.exports) {
      module2.exports = ts;
    }
  }
});

// node_modules/jsii-rosetta/lib/jsii/jsii-utils.js
var require_jsii_utils = __commonJS({
  "node_modules/jsii-rosetta/lib/jsii/jsii-utils.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.structPropertyAcceptsUndefined = exports.propertiesOfStruct = exports.hasAnyFlag = exports.hasAllFlags = exports.isStructType = exports.isStructInterface = void 0;
    var ts = require_typescript();
    var types_1 = require_types();
    function isStructInterface(name) {
      return !/^I[A-Z]/.test(name);
    }
    exports.isStructInterface = isStructInterface;
    function isStructType(type) {
      return type.isClassOrInterface() && hasAllFlags(type.objectFlags, ts.ObjectFlags.Interface) && isStructInterface(type.symbol.name);
    }
    exports.isStructType = isStructType;
    function hasAllFlags(flags, test) {
      return test !== 0 && (flags & test) === test;
    }
    exports.hasAllFlags = hasAllFlags;
    function hasAnyFlag(flags, test) {
      return test !== 0 && (flags & test) !== 0;
    }
    exports.hasAnyFlag = hasAnyFlag;
    function propertiesOfStruct(type, context) {
      return type.isClassOrInterface() ? type.getProperties().map((s) => {
        let propType;
        let questionMark = false;
        const propSymbol = type.getProperty(s.name);
        const symbolDecl = propSymbol.valueDeclaration;
        if (ts.isPropertyDeclaration(symbolDecl) || ts.isPropertySignature(symbolDecl)) {
          questionMark = symbolDecl.questionToken !== void 0;
          propType = symbolDecl.type && context.typeOfType(symbolDecl.type);
        }
        return {
          name: s.name,
          type: propType,
          questionMark
        };
      }) : [];
    }
    exports.propertiesOfStruct = propertiesOfStruct;
    function structPropertyAcceptsUndefined(prop) {
      return prop.questionMark || !!prop.type && types_1.typeContainsUndefined(prop.type);
    }
    exports.structPropertyAcceptsUndefined = structPropertyAcceptsUndefined;
  }
});

// node_modules/jsii-rosetta/lib/typescript/types.js
var require_types = __commonJS({
  "node_modules/jsii-rosetta/lib/typescript/types.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.renderFlags = exports.isStaticReadonlyAccess = exports.isEnumAccess = exports.isNumber = exports.typeOfExpression = exports.arrayElementType = exports.inferMapElementType = exports.mapElementType = exports.renderTypeFlags = exports.typeContainsUndefined = exports.parameterAcceptsUndefined = exports.renderType = exports.builtInTypeName = exports.firstTypeInUnion = void 0;
    var ts = require_typescript();
    var jsii_utils_1 = require_jsii_utils();
    function firstTypeInUnion(typeChecker, type) {
      type = typeChecker.getNonNullableType(type);
      if (!type.isUnion()) {
        return type;
      }
      return type.types[0];
    }
    exports.firstTypeInUnion = firstTypeInUnion;
    function builtInTypeName(type) {
      const map = {
        [ts.TypeFlags.Any]: "any",
        [ts.TypeFlags.Unknown]: "any",
        [ts.TypeFlags.Boolean]: "boolean",
        [ts.TypeFlags.Number]: "number",
        [ts.TypeFlags.String]: "string",
        [ts.TypeFlags.StringLiteral]: "string",
        [ts.TypeFlags.NumberLiteral]: "number",
        [ts.TypeFlags.BooleanLiteral]: "boolean"
      };
      return map[type.flags];
    }
    exports.builtInTypeName = builtInTypeName;
    function renderType(type) {
      if (type.isClassOrInterface()) {
        return type.symbol.name;
      }
      if (type.isLiteral()) {
        return `${type.value}`;
      }
      return renderTypeFlags(type);
    }
    exports.renderType = renderType;
    function parameterAcceptsUndefined(param, type) {
      if (param.initializer !== void 0) {
        return true;
      }
      if (param.questionToken !== void 0) {
        return true;
      }
      if (type) {
        return typeContainsUndefined(type);
      }
      return false;
    }
    exports.parameterAcceptsUndefined = parameterAcceptsUndefined;
    function typeContainsUndefined(type) {
      if (type.getFlags() & ts.TypeFlags.Undefined) {
        return true;
      }
      if (type.isUnion()) {
        return type.types.some(typeContainsUndefined);
      }
      return false;
    }
    exports.typeContainsUndefined = typeContainsUndefined;
    function renderTypeFlags(type) {
      return renderFlags(type.flags, ts.TypeFlags);
    }
    exports.renderTypeFlags = renderTypeFlags;
    function mapElementType(type, typeChecker) {
      if (jsii_utils_1.hasAnyFlag(type.flags, ts.TypeFlags.Object) && type.symbol) {
        if (type.symbol.name === "__type") {
          return { result: "map", elementType: type.getStringIndexType() };
        }
        if (type.symbol.name === "__object") {
          const initializerTypes = type.getProperties().map((p) => {
            const expression = p.valueDeclaration;
            return typeOfObjectLiteralProperty(typeChecker, expression);
          });
          return {
            result: "map",
            elementType: typeIfSame([...initializerTypes, type.getStringIndexType()].filter(isDefined))
          };
        }
      }
      return { result: "nonMap" };
    }
    exports.mapElementType = mapElementType;
    function inferMapElementType(elements, typeChecker) {
      const types = elements.map((e) => typeOfObjectLiteralProperty(typeChecker, e)).filter(isDefined);
      return types.every((t) => isSameType(types[0], t)) ? types[0] : void 0;
    }
    exports.inferMapElementType = inferMapElementType;
    function typeOfObjectLiteralProperty(typeChecker, el) {
      if (ts.isPropertyAssignment(el)) {
        return typeOfExpression(typeChecker, el.initializer);
      }
      if (ts.isShorthandPropertyAssignment(el)) {
        return typeOfExpression(typeChecker, el.name);
      }
      return void 0;
    }
    function isSameType(a, b) {
      var _a, _b;
      return a.flags === b.flags && ((_a = a.symbol) === null || _a === void 0 ? void 0 : _a.name) === ((_b = b.symbol) === null || _b === void 0 ? void 0 : _b.name);
    }
    function typeIfSame(types) {
      const ttypes = types.filter(isDefined);
      if (types.length === 0) {
        return void 0;
      }
      return ttypes.every((t) => isSameType(ttypes[0], t)) ? ttypes[0] : void 0;
    }
    function arrayElementType(type) {
      if (type.symbol && type.symbol.name === "Array") {
        const tr = type;
        return tr.aliasTypeArguments && tr.aliasTypeArguments[0];
      }
      return void 0;
    }
    exports.arrayElementType = arrayElementType;
    function typeOfExpression(typeChecker, node) {
      var _a;
      return (_a = typeChecker.getContextualType(node)) !== null && _a !== void 0 ? _a : typeChecker.getTypeAtLocation(node);
    }
    exports.typeOfExpression = typeOfExpression;
    function isDefined(x) {
      return x !== void 0;
    }
    function isNumber(x) {
      return typeof x === "number";
    }
    exports.isNumber = isNumber;
    function isEnumAccess(typeChecker, access) {
      const symbol = typeChecker.getSymbolAtLocation(access.expression);
      return symbol ? jsii_utils_1.hasAnyFlag(symbol.flags, ts.SymbolFlags.Enum) : false;
    }
    exports.isEnumAccess = isEnumAccess;
    function isStaticReadonlyAccess(typeChecker, access) {
      const symbol = typeChecker.getSymbolAtLocation(access);
      const decl = symbol === null || symbol === void 0 ? void 0 : symbol.getDeclarations();
      if (decl && decl[0] && ts.isPropertyDeclaration(decl[0])) {
        const flags = ts.getCombinedModifierFlags(decl[0]);
        return jsii_utils_1.hasAllFlags(flags, ts.ModifierFlags.Readonly | ts.ModifierFlags.Static);
      }
      return false;
    }
    exports.isStaticReadonlyAccess = isStaticReadonlyAccess;
    function renderFlags(flags, flagObject) {
      if (flags === void 0) {
        return "";
      }
      return Object.values(flagObject).filter(isNumber).filter((f) => jsii_utils_1.hasAllFlags(flags, f)).map((f) => flagObject[f]).join(",");
    }
    exports.renderFlags = renderFlags;
  }
});

// node_modules/jsii-rosetta/lib/jsii/jsii-types.js
var require_jsii_types = __commonJS({
  "node_modules/jsii-rosetta/lib/jsii/jsii-types.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.determineJsiiType = void 0;
    var types_1 = require_types();
    function determineJsiiType(typeChecker, type) {
      if (type.intrinsicName === "error") {
        return { kind: "unknown" };
      }
      type = type.getNonNullableType();
      if (type.isUnion() || type.isIntersection()) {
        return { kind: "error", message: "Type unions or intersections are not supported in examples" };
      }
      const mapValuesType = types_1.mapElementType(type, typeChecker);
      if (mapValuesType.result === "map") {
        return {
          kind: "map",
          elementType: mapValuesType.elementType ? determineJsiiType(typeChecker, mapValuesType.elementType) : { kind: "builtIn", builtIn: "any" }
        };
      }
      if (type.aliasSymbol) {
        return { kind: "namedType", name: type.aliasSymbol.name };
      }
      if (type.symbol) {
        return { kind: "namedType", name: type.symbol.name };
      }
      const typeScriptBuiltInType = types_1.builtInTypeName(type);
      if (!typeScriptBuiltInType) {
        return { kind: "unknown" };
      }
      return { kind: "builtIn", builtIn: typeScriptBuiltInType };
    }
    exports.determineJsiiType = determineJsiiType;
  }
});

// node_modules/jsii-rosetta/lib/jsii/packages.js
var require_packages = __commonJS({
  "node_modules/jsii-rosetta/lib/jsii/packages.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.jsiiTargetParam = exports.resolvePackage = void 0;
    function resolvePackage(packageName) {
      try {
        const resolved = require.resolve(`${packageName}/package.json`, {
          paths: [process.cwd()]
        });
        return require(resolved);
      } catch {
        return void 0;
      }
    }
    exports.resolvePackage = resolvePackage;
    function jsiiTargetParam(packageName, field) {
      const pkgJson = resolvePackage(packageName);
      const path2 = ["jsii", "targets", ...field.split(".")];
      let r = pkgJson;
      while (path2.length > 0 && typeof r === "object" && r !== null) {
        r = r[path2.splice(0, 1)[0]];
      }
      return r;
    }
    exports.jsiiTargetParam = jsiiTargetParam;
  }
});

// node_modules/jsii-rosetta/lib/o-tree.js
var require_o_tree = __commonJS({
  "node_modules/jsii-rosetta/lib/o-tree.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.spanContains = exports.spanInside = exports.renderTree = exports.OTreeSink = exports.UnknownSyntax = exports.NO_SYNTAX = exports.OTree = void 0;
    var OTree = class {
      constructor(prefix, children, options = {}) {
        this.options = options;
        this.prefix = OTree.simplify(prefix);
        this.children = OTree.simplify(children !== null && children !== void 0 ? children : []);
        this.attachComment = !!options.canBreakLine;
      }
      static simplify(xs) {
        return xs.filter(notUndefined).filter(notEmpty);
      }
      setSpan(start, end) {
        this.span = { start, end };
      }
      write(sink) {
        var _a, _b;
        if (!sink.tagOnce(this.options.renderOnce)) {
          return;
        }
        const meVisible = sink.renderingForSpan(this.span);
        for (const x of this.prefix) {
          sink.write(x);
        }
        const popIndent = sink.requestIndentChange(meVisible ? (_a = this.options.indent) !== null && _a !== void 0 ? _a : 0 : 0);
        let mark = sink.mark();
        for (const child of (_b = this.children) !== null && _b !== void 0 ? _b : []) {
          if (this.options.separator && mark.wroteNonWhitespaceSinceMark) {
            sink.write(this.options.separator);
          }
          mark = sink.mark();
          sink.write(child);
        }
        popIndent();
        if (this.options.suffix) {
          sink.renderingForSpan(this.span);
          sink.write(this.options.suffix);
        }
      }
      get isEmpty() {
        return this.prefix.length + this.children.length === 0;
      }
      toString() {
        return `<INCORRECTLY STRINGIFIED ${this.prefix.toString()}>`;
      }
    };
    exports.OTree = OTree;
    exports.NO_SYNTAX = new OTree([]);
    var UnknownSyntax = class extends OTree {
    };
    exports.UnknownSyntax = UnknownSyntax;
    var OTreeSink = class {
      constructor(options = {}) {
        this.options = options;
        this.indentLevels = [0];
        this.fragments = new Array();
        this.singletonsRendered = new Set();
        this.pendingIndentChange = 0;
        this.rendering = true;
      }
      tagOnce(key) {
        if (key === void 0) {
          return true;
        }
        if (this.singletonsRendered.has(key)) {
          return false;
        }
        this.singletonsRendered.add(key);
        return true;
      }
      mark() {
        const self2 = this;
        const markIndex = this.fragments.length;
        return {
          get wroteNonWhitespaceSinceMark() {
            return self2.fragments.slice(markIndex).some((s) => /[^\s]/.exec(s) != null);
          }
        };
      }
      write(text) {
        if (text instanceof OTree) {
          text.write(this);
        } else {
          if (!this.rendering) {
            return;
          }
          if (containsNewline(text)) {
            this.applyPendingIndentChange();
          }
          this.append(text.replace(/\n/g, `
${" ".repeat(this.currentIndent)}`));
        }
      }
      renderingForSpan(span) {
        if (span && this.options.visibleSpans) {
          this.rendering = this.options.visibleSpans.some((v) => spanInside(span, v));
        }
        return this.rendering;
      }
      requestIndentChange(x) {
        if (x === 0) {
          return () => void 0;
        }
        this.pendingIndentChange = x;
        const currentIndentState = this.indentLevels.length;
        return () => {
          this.indentLevels.splice(currentIndentState);
          this.pendingIndentChange = 0;
        };
      }
      toString() {
        return this.fragments.join("").replace(/[ \t]+$/gm, "").replace(/^\n+/, "").replace(/\n+$/, "");
      }
      append(x) {
        this.fragments.push(x);
      }
      applyPendingIndentChange() {
        if (this.pendingIndentChange !== 0) {
          this.indentLevels.push(this.currentIndent + this.pendingIndentChange);
          this.pendingIndentChange = 0;
        }
      }
      get currentIndent() {
        return this.indentLevels[this.indentLevels.length - 1];
      }
    };
    exports.OTreeSink = OTreeSink;
    function notUndefined(x) {
      return x !== void 0;
    }
    function notEmpty(x) {
      return x instanceof OTree ? !x.isEmpty : x !== "";
    }
    function renderTree(tree, options) {
      const sink = new OTreeSink(options);
      tree.write(sink);
      return sink.toString();
    }
    exports.renderTree = renderTree;
    function containsNewline(x) {
      return x.includes("\n");
    }
    function spanInside(a, b) {
      return b.start <= a.start && a.end <= b.end;
    }
    exports.spanInside = spanInside;
    function spanContains(a, position) {
      return a.start <= position && position < a.end;
    }
    exports.spanContains = spanContains;
  }
});

// node_modules/jsii-rosetta/lib/typescript/ast-utils.js
var require_ast_utils = __commonJS({
  "node_modules/jsii-rosetta/lib/typescript/ast-utils.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.privatePropertyNames = exports.findSuperCall = exports.isReadOnly = exports.visibility = exports.quoteStringLiteral = exports.extractVoidExpression = exports.voidExpressionString = exports.extractShowingVoidExpression = exports.extractMaskingVoidExpression = exports.scanText = exports.commentRangeFromTextRange = exports.extractComments = exports.repeatNewlines = exports.countNakedNewlines = exports.matchAst = exports.DONE = exports.allOfType = exports.anyNode = exports.nodeOfType = exports.nodeChildren = exports.stringFromLiteral = exports.stripCommentMarkers = exports.calculateMarkedSpans = exports.calculateVisibleSpans = void 0;
    var ts = require_typescript();
    function calculateVisibleSpans(source) {
      return calculateMarkedSpans(source).filter((s) => s.visible);
    }
    exports.calculateVisibleSpans = calculateVisibleSpans;
    function calculateMarkedSpans(source) {
      const regEx = /[/]{3}[ \t]*(!(?:show|hide))[ \t]*$/gm;
      const ret = new Array();
      let match;
      let spanStart;
      let visible = true;
      while ((match = regEx.exec(source)) != null) {
        const directiveStart = match.index;
        const directive = match[1].trim();
        if (["!hide", "!show"].includes(directive)) {
          const isShow = directive === "!show";
          if (spanStart === void 0) {
            ret.push({ start: 0, end: directiveStart, visible: !isShow });
          } else {
            ret.push({ start: spanStart, end: directiveStart, visible });
          }
          visible = isShow;
          spanStart = match.index + match[0].length;
        }
      }
      ret.push({ start: spanStart !== null && spanStart !== void 0 ? spanStart : 0, end: source.length, visible });
      return ret.filter((s) => s.start !== s.end);
    }
    exports.calculateMarkedSpans = calculateMarkedSpans;
    function stripCommentMarkers(comment, multiline) {
      if (multiline) {
        return comment.substring(2, comment.length - 2).replace(/^[ \t]+/g, "").replace(/[ \t]+$/g, "").replace(/^[ \t]*\*[ \t]?/gm, "");
      }
      return comment.replace(/^[/]{2}[ \t]?/gm, "");
    }
    exports.stripCommentMarkers = stripCommentMarkers;
    function stringFromLiteral(expr) {
      if (ts.isStringLiteral(expr)) {
        return expr.text;
      }
      return "???";
    }
    exports.stringFromLiteral = stringFromLiteral;
    function nodeChildren(node) {
      const ret = new Array();
      node.forEachChild((n) => {
        ret.push(n);
      });
      return ret;
    }
    exports.nodeChildren = nodeChildren;
    function nodeOfType(syntaxKindOrCaptureName, nodeTypeOrChildren, children) {
      var _a;
      const capturing = typeof syntaxKindOrCaptureName === "string";
      const realNext = (_a = capturing ? children : nodeTypeOrChildren) !== null && _a !== void 0 ? _a : exports.DONE;
      const realCapture = capturing ? syntaxKindOrCaptureName : void 0;
      const realSyntaxKind = capturing ? nodeTypeOrChildren : syntaxKindOrCaptureName;
      return (nodes) => {
        for (const node of nodes !== null && nodes !== void 0 ? nodes : []) {
          if (node.kind === realSyntaxKind) {
            const ret = realNext(nodeChildren(node));
            if (!ret) {
              continue;
            }
            if (realCapture) {
              return Object.assign(ret, {
                [realCapture]: node
              });
            }
            return ret;
          }
        }
        return void 0;
      };
    }
    exports.nodeOfType = nodeOfType;
    function anyNode(children) {
      const realNext = children !== null && children !== void 0 ? children : exports.DONE;
      return (nodes) => {
        for (const node of nodes !== null && nodes !== void 0 ? nodes : []) {
          const m = realNext(nodeChildren(node));
          if (m) {
            return m;
          }
        }
        return void 0;
      };
    }
    exports.anyNode = anyNode;
    function allOfType(s, name, children) {
      const realNext = children !== null && children !== void 0 ? children : exports.DONE;
      return (nodes) => {
        let ret;
        for (const node of nodes !== null && nodes !== void 0 ? nodes : []) {
          if (node.kind === s) {
            if (realNext(nodeChildren(node))) {
              if (!ret) {
                ret = { [name]: new Array() };
              }
              ret[name].push(node);
            }
          }
        }
        return ret;
      };
    }
    exports.allOfType = allOfType;
    exports.DONE = () => ({});
    function matchAst(node, matcher, cb) {
      const matched = matcher([node]);
      if (cb) {
        if (matched) {
          cb(matched);
        }
        return !!matched;
      }
      return matched;
    }
    exports.matchAst = matchAst;
    function countNakedNewlines(str) {
      let ret = 0;
      scanText(str, 0, str.length).filter((s) => s.type === "other" || s.type === "blockcomment").forEach((s) => {
        if (s.type === "other") {
          for (let i = s.pos; i < s.end; i++) {
            if (str[i] === "\n") {
              ret++;
            }
          }
        } else {
          if (s.hasTrailingNewLine) {
            ret--;
          }
        }
      });
      return ret;
    }
    exports.countNakedNewlines = countNakedNewlines;
    function repeatNewlines(str) {
      return "\n".repeat(Math.min(2, countNakedNewlines(str)));
    }
    exports.repeatNewlines = repeatNewlines;
    var WHITESPACE = [" ", "	", "\r", "\n"];
    function extractComments(text, start) {
      return scanText(text, start).filter((s) => s.type === "blockcomment" || s.type === "linecomment").map(commentRangeFromTextRange);
    }
    exports.extractComments = extractComments;
    function commentRangeFromTextRange(rng) {
      return {
        kind: rng.type === "blockcomment" ? ts.SyntaxKind.MultiLineCommentTrivia : ts.SyntaxKind.SingleLineCommentTrivia,
        pos: rng.pos,
        end: rng.end,
        hasTrailingNewLine: rng.type !== "blockcomment" && rng.hasTrailingNewLine
      };
    }
    exports.commentRangeFromTextRange = commentRangeFromTextRange;
    function scanText(text, start, end) {
      const ret = [];
      let pos = start;
      const stopAtCode = end === void 0;
      if (end === void 0) {
        end = text.length;
      }
      while (pos < end) {
        const ch = text[pos];
        if (WHITESPACE.includes(ch)) {
          pos++;
          continue;
        }
        if (ch === "/" && text[pos + 1] === "/") {
          accumulateTextBlock();
          scanSinglelineComment();
          continue;
        }
        if (ch === "/" && text[pos + 1] === "*") {
          accumulateTextBlock();
          scanMultilineComment();
          continue;
        }
        if (stopAtCode) {
          break;
        }
        pos++;
      }
      accumulateTextBlock();
      return ret;
      function scanMultilineComment() {
        const endOfComment = findNext("*/", pos + 2);
        ret.push({
          type: "blockcomment",
          hasTrailingNewLine: ["\n", "\r"].includes(text[endOfComment + 2]),
          pos,
          end: endOfComment + 2
        });
        pos = endOfComment + 2;
        start = pos;
      }
      function scanSinglelineComment() {
        const nl = Math.min(findNext("\r", pos + 2), findNext("\n", pos + 2));
        if (text[pos + 2] === "/") {
          ret.push({
            type: "directive",
            hasTrailingNewLine: true,
            pos: pos + 1,
            end: nl
          });
        } else {
          ret.push({
            type: "linecomment",
            hasTrailingNewLine: true,
            pos,
            end: nl
          });
        }
        pos = nl + 1;
        start = pos;
      }
      function accumulateTextBlock() {
        if (pos - start > 0) {
          ret.push({
            type: "other",
            hasTrailingNewLine: false,
            pos: start,
            end: pos
          });
          start = pos;
        }
      }
      function findNext(sub, startPos) {
        const f = text.indexOf(sub, startPos);
        if (f === -1) {
          return text.length;
        }
        return f;
      }
    }
    exports.scanText = scanText;
    var VOID_SHOW_KEYWORD = "show";
    function extractMaskingVoidExpression(node) {
      const expr = extractVoidExpression(node);
      if (!expr) {
        return void 0;
      }
      if (ts.isStringLiteral(expr.expression) && expr.expression.text === VOID_SHOW_KEYWORD) {
        return void 0;
      }
      return expr;
    }
    exports.extractMaskingVoidExpression = extractMaskingVoidExpression;
    function extractShowingVoidExpression(node) {
      const expr = extractVoidExpression(node);
      if (!expr) {
        return void 0;
      }
      if (ts.isStringLiteral(expr.expression) && expr.expression.text === VOID_SHOW_KEYWORD) {
        return expr;
      }
      return void 0;
    }
    exports.extractShowingVoidExpression = extractShowingVoidExpression;
    function voidExpressionString(node) {
      if (ts.isStringLiteral(node.expression)) {
        return node.expression.text;
      }
      return void 0;
    }
    exports.voidExpressionString = voidExpressionString;
    function extractVoidExpression(node) {
      if (ts.isVoidExpression(node)) {
        return node;
      }
      if (ts.isExpressionStatement(node)) {
        return extractVoidExpression(node.expression);
      }
      if (ts.isParenthesizedExpression(node)) {
        return extractVoidExpression(node.expression);
      }
      if (ts.isBinaryExpression(node) && node.operatorToken.kind === ts.SyntaxKind.CommaToken) {
        return extractVoidExpression(node.left);
      }
      return void 0;
    }
    exports.extractVoidExpression = extractVoidExpression;
    function quoteStringLiteral(x) {
      return x.replace(/\\/g, "\\\\").replace(/"/g, '\\"');
    }
    exports.quoteStringLiteral = quoteStringLiteral;
    function visibility(x) {
      const flags = ts.getCombinedModifierFlags(x);
      if (flags & ts.ModifierFlags.Private) {
        return "private";
      }
      if (flags & ts.ModifierFlags.Protected) {
        return "protected";
      }
      return "public";
    }
    exports.visibility = visibility;
    function isReadOnly(x) {
      const flags = ts.getCombinedModifierFlags(x);
      return (flags & ts.ModifierFlags.Readonly) !== 0;
    }
    exports.isReadOnly = isReadOnly;
    function findSuperCall(node, renderer) {
      if (node === void 0) {
        return void 0;
      }
      if (ts.isCallExpression(node)) {
        if (renderer.textOf(node.expression) === "super") {
          return node;
        }
      }
      if (ts.isExpressionStatement(node)) {
        return findSuperCall(node.expression, renderer);
      }
      if (ts.isBlock(node)) {
        for (const statement of node.statements) {
          if (ts.isExpressionStatement(statement)) {
            const s = findSuperCall(statement.expression, renderer);
            if (s) {
              return s;
            }
          }
        }
      }
      return void 0;
    }
    exports.findSuperCall = findSuperCall;
    function privatePropertyNames(members, renderer) {
      const props = members.filter((m) => ts.isPropertyDeclaration(m));
      return props.filter((m) => visibility(m) === "private").map((m) => renderer.textOf(m.name));
    }
    exports.privatePropertyNames = privatePropertyNames;
  }
});

// node_modules/jsii-rosetta/lib/typescript/imports.js
var require_imports = __commonJS({
  "node_modules/jsii-rosetta/lib/typescript/imports.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.analyzeImportDeclaration = exports.analyzeImportEquals = void 0;
    var ts = require_typescript();
    var ast_utils_1 = require_ast_utils();
    function analyzeImportEquals(node, context) {
      let moduleName = "???";
      ast_utils_1.matchAst(node.moduleReference, ast_utils_1.nodeOfType("ref", ts.SyntaxKind.ExternalModuleReference), (bindings) => {
        moduleName = ast_utils_1.stringFromLiteral(bindings.ref.expression);
      });
      return {
        node,
        packageName: moduleName,
        imports: { import: "full", alias: context.textOf(node.name) }
      };
    }
    exports.analyzeImportEquals = analyzeImportEquals;
    function analyzeImportDeclaration(node, context) {
      const packageName = ast_utils_1.stringFromLiteral(node.moduleSpecifier);
      const starBindings = ast_utils_1.matchAst(node, ast_utils_1.nodeOfType(ts.SyntaxKind.ImportDeclaration, ast_utils_1.nodeOfType(ts.SyntaxKind.ImportClause, ast_utils_1.nodeOfType("namespace", ts.SyntaxKind.NamespaceImport))));
      if (starBindings) {
        return {
          node,
          packageName,
          imports: {
            import: "full",
            alias: context.textOf(starBindings.namespace.name)
          }
        };
      }
      const namedBindings = ast_utils_1.matchAst(node, ast_utils_1.nodeOfType(ts.SyntaxKind.ImportDeclaration, ast_utils_1.nodeOfType(ts.SyntaxKind.ImportClause, ast_utils_1.nodeOfType(ts.SyntaxKind.NamedImports, ast_utils_1.allOfType(ts.SyntaxKind.ImportSpecifier, "specifiers")))));
      const elements = [];
      if (namedBindings) {
        elements.push(...namedBindings.specifiers.map((spec) => spec.propertyName ? {
          sourceName: context.textOf(spec.propertyName),
          alias: spec.name ? context.textOf(spec.name) : "???"
        } : {
          sourceName: spec.name ? context.textOf(spec.name) : "???"
        }));
      }
      return {
        node,
        packageName,
        imports: { import: "selective", elements }
      };
    }
    exports.analyzeImportDeclaration = analyzeImportDeclaration;
  }
});

// node_modules/jsii-rosetta/lib/renderer.js
var require_renderer = __commonJS({
  "node_modules/jsii-rosetta/lib/renderer.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.nimpl = exports.AstRenderer = void 0;
    var ts = require_typescript();
    var o_tree_1 = require_o_tree();
    var ast_utils_1 = require_ast_utils();
    var imports_1 = require_imports();
    var types_1 = require_types();
    var AstRenderer = class {
      constructor(sourceFile, typeChecker, handler2, options = {}) {
        this.sourceFile = sourceFile;
        this.typeChecker = typeChecker;
        this.handler = handler2;
        this.options = options;
        this.diagnostics = new Array();
        this.currentContext = handler2.defaultContext;
      }
      updateContext(contextUpdate) {
        const newContext = this.handler.mergeContext(this.currentContext, contextUpdate);
        return Object.assign(Object.create(this), {
          currentContext: newContext
        });
      }
      convert(node) {
        if (node === void 0) {
          return o_tree_1.NO_SYNTAX;
        }
        const transformed = this.dispatch(node);
        transformed.setSpan(node.getStart(this.sourceFile), node.getEnd());
        if (!transformed.attachComment) {
          return transformed;
        }
        const withTrivia = this.attachLeadingTrivia(node, transformed);
        withTrivia.setSpan(node.getStart(this.sourceFile), node.getEnd());
        return withTrivia;
      }
      convertAll(nodes) {
        return filterVisible(nodes).map(this.convert.bind(this));
      }
      convertWithModifier(nodes, makeContext) {
        const vis = assignVisibility(nodes);
        const result = new Array();
        for (const [idx, { node, visible, maskingVoid }] of vis.entries()) {
          const renderedNode = visible ? node : maskingVoid;
          if (renderedNode) {
            const context = makeContext(this, renderedNode, idx);
            result.push(context.convert(renderedNode));
          }
        }
        return result;
      }
      convertLastDifferently(nodes, lastContext) {
        const lastConverter = this.updateContext(lastContext);
        const convert = this.convert.bind(this);
        const lastConvert = lastConverter.convert.bind(lastConverter);
        const ret = [];
        const vis = assignVisibility(nodes);
        for (let i = 0; i < vis.length; i++) {
          const whichConvert = i === vis.length - 1 ? lastConvert : convert;
          const node = vis[i].visible ? vis[i].node : vis[i].maskingVoid;
          if (node) {
            ret.push(whichConvert(node));
          }
        }
        return ret;
      }
      getPosition(node) {
        return {
          start: node.getStart(this.sourceFile),
          end: node.getEnd()
        };
      }
      textOf(node) {
        return node.getText(this.sourceFile);
      }
      textAt(pos, end) {
        return this.sourceFile.text.substring(pos, end);
      }
      inferredTypeOfExpression(node) {
        const type = this.typeChecker.getContextualType(node);
        return type ? this.typeChecker.getNonNullableType(type) : void 0;
      }
      typeOfExpression(node) {
        return types_1.typeOfExpression(this.typeChecker, node);
      }
      typeOfType(node) {
        return this.typeChecker.getTypeFromTypeNode(node);
      }
      typeToString(type) {
        return this.typeChecker.typeToString(type);
      }
      report(node, messageText, category = ts.DiagnosticCategory.Error) {
        this.diagnostics.push({
          category,
          code: 0,
          source: "rosetta",
          messageText,
          file: this.sourceFile,
          start: node.getStart(this.sourceFile),
          length: node.getWidth(this.sourceFile)
        });
      }
      reportUnsupported(node, language) {
        const nodeKind = ts.SyntaxKind[node.kind];
        if (language) {
          this.report(node, `This TypeScript feature (${nodeKind}) is not supported in examples because we cannot translate it to ${language}. Please rewrite this example.`);
        } else {
          this.report(node, `This TypeScript feature (${nodeKind}) is not supported in examples. Please rewrite this example.`);
        }
      }
      mirrorNewlineBefore(viz, suffix = "", otherwise = "") {
        if (viz === void 0) {
          return suffix;
        }
        const leadingRanges = ast_utils_1.scanText(this.sourceFile.text, viz.getFullStart(), viz.getStart(this.sourceFile));
        const newlines = [];
        for (const range of leadingRanges) {
          if (range.type === "other") {
            newlines.push(ast_utils_1.repeatNewlines(this.sourceFile.text.substring(range.pos, range.end)));
          }
        }
        return (newlines.join("").length > 0 ? "\n" : otherwise) + suffix;
      }
      dispatch(tree) {
        if (ts.isEmptyStatement(tree)) {
          return o_tree_1.NO_SYNTAX;
        }
        const visitor = this.handler;
        if (ts.isSourceFile(tree)) {
          return visitor.sourceFile(tree, this);
        }
        if (ts.isImportEqualsDeclaration(tree)) {
          return visitor.importStatement(imports_1.analyzeImportEquals(tree, this), this);
        }
        if (ts.isImportDeclaration(tree)) {
          return visitor.importStatement(imports_1.analyzeImportDeclaration(tree, this), this);
        }
        if (ts.isStringLiteral(tree) || ts.isNoSubstitutionTemplateLiteral(tree)) {
          return visitor.stringLiteral(tree, this);
        }
        if (ts.isFunctionDeclaration(tree)) {
          return visitor.functionDeclaration(tree, this);
        }
        if (ts.isIdentifier(tree)) {
          return visitor.identifier(tree, this);
        }
        if (ts.isBlock(tree)) {
          return visitor.block(tree, this);
        }
        if (ts.isParameter(tree)) {
          return visitor.parameterDeclaration(tree, this);
        }
        if (ts.isReturnStatement(tree)) {
          return visitor.returnStatement(tree, this);
        }
        if (ts.isBinaryExpression(tree)) {
          return visitor.binaryExpression(tree, this);
        }
        if (ts.isIfStatement(tree)) {
          return visitor.ifStatement(tree, this);
        }
        if (ts.isPropertyAccessExpression(tree)) {
          return visitor.propertyAccessExpression(tree, this);
        }
        if (ts.isCallExpression(tree)) {
          return visitor.callExpression(tree, this);
        }
        if (ts.isExpressionStatement(tree)) {
          return visitor.expressionStatement(tree, this);
        }
        if (ts.isToken(tree)) {
          return visitor.token(tree, this);
        }
        if (ts.isObjectLiteralExpression(tree)) {
          return visitor.objectLiteralExpression(tree, this);
        }
        if (ts.isNewExpression(tree)) {
          return visitor.newExpression(tree, this);
        }
        if (ts.isPropertyAssignment(tree)) {
          return visitor.propertyAssignment(tree, this);
        }
        if (ts.isVariableStatement(tree)) {
          return visitor.variableStatement(tree, this);
        }
        if (ts.isVariableDeclarationList(tree)) {
          return visitor.variableDeclarationList(tree, this);
        }
        if (ts.isVariableDeclaration(tree)) {
          return visitor.variableDeclaration(tree, this);
        }
        if (ts.isJSDoc(tree)) {
          return visitor.jsDoc(tree, this);
        }
        if (ts.isArrayLiteralExpression(tree)) {
          return visitor.arrayLiteralExpression(tree, this);
        }
        if (ts.isShorthandPropertyAssignment(tree)) {
          return visitor.shorthandPropertyAssignment(tree, this);
        }
        if (ts.isForOfStatement(tree)) {
          return visitor.forOfStatement(tree, this);
        }
        if (ts.isClassDeclaration(tree)) {
          return visitor.classDeclaration(tree, this);
        }
        if (ts.isConstructorDeclaration(tree)) {
          return visitor.constructorDeclaration(tree, this);
        }
        if (ts.isPropertyDeclaration(tree)) {
          return visitor.propertyDeclaration(tree, this);
        }
        if (ts.isComputedPropertyName(tree)) {
          return visitor.computedPropertyName(tree.expression, this);
        }
        if (ts.isMethodDeclaration(tree)) {
          return visitor.methodDeclaration(tree, this);
        }
        if (ts.isInterfaceDeclaration(tree)) {
          return visitor.interfaceDeclaration(tree, this);
        }
        if (ts.isPropertySignature(tree)) {
          return visitor.propertySignature(tree, this);
        }
        if (ts.isMethodSignature(tree)) {
          return visitor.methodSignature(tree, this);
        }
        if (ts.isAsExpression(tree)) {
          return visitor.asExpression(tree, this);
        }
        if (ts.isPrefixUnaryExpression(tree)) {
          return visitor.prefixUnaryExpression(tree, this);
        }
        if (ts.isSpreadAssignment(tree)) {
          if (this.textOf(tree) === "...") {
            return visitor.ellipsis(tree, this);
          }
          return visitor.spreadAssignment(tree, this);
        }
        if (ts.isSpreadElement(tree)) {
          if (this.textOf(tree) === "...") {
            return visitor.ellipsis(tree, this);
          }
          return visitor.spreadElement(tree, this);
        }
        if (ts.isTemplateExpression(tree)) {
          return visitor.templateExpression(tree, this);
        }
        if (ts.isNonNullExpression(tree)) {
          return visitor.nonNullExpression(tree, this);
        }
        if (ts.isParenthesizedExpression(tree)) {
          return visitor.parenthesizedExpression(tree, this);
        }
        if (ts.isVoidExpression(tree)) {
          return visitor.maskingVoidExpression(tree, this);
        }
        this.reportUnsupported(tree, void 0);
        if (this.options.bestEffort !== false) {
          return new o_tree_1.OTree([this.textOf(tree)]);
        }
        const nodeKind = ts.SyntaxKind[tree.kind];
        return new o_tree_1.UnknownSyntax([`<${nodeKind} ${this.textOf(tree)}>`], ["\n", ...ast_utils_1.nodeChildren(tree).map(this.convert.bind(this))], {
          indent: 2
        });
      }
      attachLeadingTrivia(node, transformed) {
        const leadingRanges = ast_utils_1.scanText(this.sourceFile.text, node.getFullStart(), node.getStart(this.sourceFile));
        const precede = [];
        for (const range of leadingRanges) {
          let trivia = void 0;
          switch (range.type) {
            case "other":
              trivia = new o_tree_1.OTree([ast_utils_1.repeatNewlines(this.sourceFile.text.substring(range.pos, range.end))], [], {
                renderOnce: `ws-${range.pos}`
              });
              break;
            case "linecomment":
            case "blockcomment":
              trivia = this.handler.commentRange(commentSyntaxFromCommentRange(ast_utils_1.commentRangeFromTextRange(range), this), this);
              break;
            case "directive":
              break;
          }
          if (trivia != null) {
            trivia.setSpan(range.pos, range.end);
            precede.push(trivia);
          }
        }
        if (precede.length > 0 && !transformed.isEmpty) {
          return new o_tree_1.OTree([...precede, transformed], [], { canBreakLine: true });
        }
        return transformed;
      }
    };
    exports.AstRenderer = AstRenderer;
    function nimpl(node, context, options = {}) {
      const children = ast_utils_1.nodeChildren(node).map((c) => context.convert(c));
      let syntaxKind = ts.SyntaxKind[node.kind];
      if (syntaxKind === "FirstPunctuation") {
        syntaxKind = "OpenBraceToken";
      }
      const parts = [`(${syntaxKind}`];
      if (options.additionalInfo) {
        parts.push(`{${options.additionalInfo}}`);
      }
      parts.push(context.textOf(node));
      return new o_tree_1.UnknownSyntax([parts.join(" ")], children.length > 0 ? ["\n", ...children] : [], {
        indent: 2,
        suffix: ")",
        separator: "\n",
        canBreakLine: true
      });
    }
    exports.nimpl = nimpl;
    function filterVisible(nodes) {
      return assignVisibility(nodes).map((c) => c.visible ? c.node : c.maskingVoid).filter(notUndefined);
    }
    function assignVisibility(nodes) {
      const ret = [];
      let visible = true;
      for (const node of nodes) {
        const maskingVoid = ast_utils_1.extractMaskingVoidExpression(node);
        if (visible && maskingVoid) {
          visible = false;
        }
        ret.push({ node, maskingVoid, visible });
        if (!visible) {
          const showing = ast_utils_1.extractShowingVoidExpression(node);
          if (showing) {
            visible = true;
          }
        }
      }
      return ret;
    }
    function notUndefined(x) {
      return x !== void 0;
    }
    function commentSyntaxFromCommentRange(rng, renderer) {
      return {
        hasTrailingNewLine: rng.hasTrailingNewLine,
        kind: rng.kind,
        pos: rng.pos,
        text: renderer.textAt(rng.pos, rng.end)
      };
    }
  }
});

// node_modules/jsii-rosetta/lib/util.js
var require_util3 = __commonJS({
  "node_modules/jsii-rosetta/lib/util.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.setExtend = exports.partition = exports.flat = exports.divideEvenly = exports.isErrorDiagnostic = exports.annotateStrictDiagnostic = exports.StrictBrand = exports.printDiagnostic = exports.printDiagnostics = exports.startsWithUppercase = void 0;
    var ts = require_typescript();
    function startsWithUppercase(x) {
      return /^[A-Z]/.exec(x) != null;
    }
    exports.startsWithUppercase = startsWithUppercase;
    function printDiagnostics(diags, stream) {
      for (const diag of diags) {
        printDiagnostic(diag, stream);
      }
    }
    exports.printDiagnostics = printDiagnostics;
    function printDiagnostic(diag, stream) {
      const host = {
        getCurrentDirectory() {
          return ".";
        },
        getCanonicalFileName(fileName) {
          return fileName;
        },
        getNewLine() {
          return "\n";
        }
      };
      const message = ts.formatDiagnosticsWithColorAndContext([diag], host);
      stream.write(message);
    }
    exports.printDiagnostic = printDiagnostic;
    exports.StrictBrand = "jsii.strict";
    function annotateStrictDiagnostic(diag) {
      Object.defineProperty(diag, exports.StrictBrand, {
        configurable: false,
        enumerable: true,
        value: true,
        writable: false
      });
    }
    exports.annotateStrictDiagnostic = annotateStrictDiagnostic;
    function isErrorDiagnostic(diag, { onlyStrict }) {
      return diag.category === ts.DiagnosticCategory.Error && (!onlyStrict || !!diag[exports.StrictBrand]);
    }
    exports.isErrorDiagnostic = isErrorDiagnostic;
    function divideEvenly(groups, xs) {
      const chunkSize = Math.ceil(xs.length / groups);
      const ret = [];
      for (let i = 0; i < groups; i++) {
        ret.push(xs.slice(i * chunkSize, (i + 1) * chunkSize));
      }
      return ret;
    }
    exports.divideEvenly = divideEvenly;
    function flat(xs) {
      return Array.prototype.concat.apply([], xs);
    }
    exports.flat = flat;
    function partition(xs, pred) {
      const truthy = new Array();
      const falsy = new Array();
      for (const x of xs) {
        if (pred(x)) {
          truthy.push(x);
        } else {
          falsy.push(x);
        }
      }
      return [truthy, falsy];
    }
    exports.partition = partition;
    function setExtend(xs, els) {
      for (const el of els) {
        xs.add(el);
      }
    }
    exports.setExtend = setExtend;
  }
});

// node_modules/jsii-rosetta/lib/languages/default.js
var require_default = __commonJS({
  "node_modules/jsii-rosetta/lib/languages/default.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.DefaultVisitor = void 0;
    var ts = require_typescript();
    var jsii_utils_1 = require_jsii_utils();
    var o_tree_1 = require_o_tree();
    var renderer_1 = require_renderer();
    var ast_utils_1 = require_ast_utils();
    var DefaultVisitor = class {
      commentRange(comment, _context) {
        return new o_tree_1.OTree([comment.text, comment.hasTrailingNewLine ? "\n" : ""]);
      }
      sourceFile(node, context) {
        return new o_tree_1.OTree(context.convertAll(node.statements));
      }
      jsDoc(_node, _context) {
        return new o_tree_1.OTree([]);
      }
      importStatement(node, context) {
        return this.notImplemented(node.node, context);
      }
      functionDeclaration(node, children) {
        return this.notImplemented(node, children);
      }
      stringLiteral(node, _renderer) {
        return new o_tree_1.OTree([JSON.stringify(node.text)]);
      }
      identifier(node, _children) {
        return new o_tree_1.OTree([node.text]);
      }
      block(node, children) {
        return new o_tree_1.OTree(["{"], ["\n", ...children.convertAll(node.statements)], {
          indent: 4,
          suffix: "}"
        });
      }
      parameterDeclaration(node, children) {
        return this.notImplemented(node, children);
      }
      returnStatement(node, children) {
        return new o_tree_1.OTree(["return ", children.convert(node.expression)]);
      }
      binaryExpression(node, context) {
        const operatorToken = this.translateBinaryOperator(context.textOf(node.operatorToken));
        return new o_tree_1.OTree([context.convert(node.left), " ", operatorToken, " ", context.convert(node.right)]);
      }
      prefixUnaryExpression(node, context) {
        return new o_tree_1.OTree([this.translateUnaryOperator(node.operator), context.convert(node.operand)]);
      }
      translateUnaryOperator(operator) {
        return UNARY_OPS[operator];
      }
      translateBinaryOperator(operator) {
        if (operator === "===") {
          return "==";
        }
        return operator;
      }
      ifStatement(node, context) {
        return this.notImplemented(node, context);
      }
      propertyAccessExpression(node, context) {
        return new o_tree_1.OTree([context.convert(node.expression), ".", context.convert(node.name)]);
      }
      callExpression(node, context) {
        const functionText = context.textOf(node.expression);
        if (functionText === "console.log" || functionText === "console.error") {
          return this.printStatement(node.arguments, context);
        }
        if (functionText === "super") {
          return this.superCallExpression(node, context);
        }
        return this.regularCallExpression(node, context);
      }
      regularCallExpression(node, context) {
        return new o_tree_1.OTree([context.convert(node.expression), "(", this.argumentList(node.arguments, context), ")"]);
      }
      superCallExpression(node, context) {
        return this.regularCallExpression(node, context);
      }
      printStatement(args, context) {
        return new o_tree_1.OTree(["<PRINT>", "(", this.argumentList(args, context), ")"]);
      }
      expressionStatement(node, context) {
        return new o_tree_1.OTree([context.convert(node.expression)], [], {
          canBreakLine: true
        });
      }
      token(node, context) {
        return new o_tree_1.OTree([context.textOf(node)]);
      }
      objectLiteralExpression(node, context) {
        const type = context.inferredTypeOfExpression(node);
        let isUnknownType = !type;
        if (type && jsii_utils_1.hasAllFlags(type.flags, ts.TypeFlags.Any)) {
          const call = findEnclosingCallExpression(node);
          const signature = call ? context.typeChecker.getResolvedSignature(call) : void 0;
          if (!(signature === null || signature === void 0 ? void 0 : signature.declaration)) {
            isUnknownType = true;
          }
        }
        const isKnownStruct = type && jsii_utils_1.isStructType(type);
        if (isUnknownType) {
          return this.unknownTypeObjectLiteralExpression(node, context);
        }
        if (isKnownStruct) {
          return this.knownStructObjectLiteralExpression(node, type, context);
        }
        return this.keyValueObjectLiteralExpression(node, context);
      }
      unknownTypeObjectLiteralExpression(node, context) {
        return this.notImplemented(node, context);
      }
      knownStructObjectLiteralExpression(node, _structType, context) {
        return this.notImplemented(node, context);
      }
      keyValueObjectLiteralExpression(node, context) {
        return this.notImplemented(node, context);
      }
      newExpression(node, context) {
        return new o_tree_1.OTree(["new ", context.convert(node.expression), "(", this.argumentList(node.arguments, context), ")"], [], { canBreakLine: true });
      }
      propertyAssignment(node, context) {
        return this.notImplemented(node, context);
      }
      variableStatement(node, context) {
        return new o_tree_1.OTree([context.convert(node.declarationList)], [], {
          canBreakLine: true
        });
      }
      variableDeclarationList(node, context) {
        return new o_tree_1.OTree([], context.convertAll(node.declarations));
      }
      variableDeclaration(node, context) {
        return this.notImplemented(node, context);
      }
      arrayLiteralExpression(node, context) {
        return new o_tree_1.OTree(["["], context.convertAll(node.elements), {
          separator: ", ",
          suffix: "]"
        });
      }
      shorthandPropertyAssignment(node, context) {
        return this.notImplemented(node, context);
      }
      forOfStatement(node, context) {
        return this.notImplemented(node, context);
      }
      classDeclaration(node, context) {
        return this.notImplemented(node, context);
      }
      constructorDeclaration(node, context) {
        return this.notImplemented(node, context);
      }
      propertyDeclaration(node, context) {
        return this.notImplemented(node, context);
      }
      computedPropertyName(node, context) {
        return context.convert(node);
      }
      methodDeclaration(node, context) {
        return this.notImplemented(node, context);
      }
      interfaceDeclaration(node, context) {
        if (jsii_utils_1.isStructInterface(context.textOf(node.name))) {
          return this.structInterfaceDeclaration(node, context);
        }
        return this.regularInterfaceDeclaration(node, context);
      }
      structInterfaceDeclaration(node, context) {
        return this.notImplemented(node, context);
      }
      regularInterfaceDeclaration(node, context) {
        return this.notImplemented(node, context);
      }
      propertySignature(node, context) {
        return this.notImplemented(node, context);
      }
      methodSignature(node, context) {
        return this.notImplemented(node, context);
      }
      asExpression(node, context) {
        return this.notImplemented(node, context);
      }
      spreadElement(node, context) {
        return this.notImplemented(node, context);
      }
      spreadAssignment(node, context) {
        return this.notImplemented(node, context);
      }
      ellipsis(_node, _context) {
        return new o_tree_1.OTree(["..."]);
      }
      templateExpression(node, context) {
        return this.notImplemented(node, context);
      }
      nonNullExpression(node, context) {
        return context.convert(node.expression);
      }
      parenthesizedExpression(node, context) {
        return new o_tree_1.OTree(["(", context.convert(node.expression), ")"]);
      }
      maskingVoidExpression(node, context) {
        const arg = ast_utils_1.voidExpressionString(node);
        if (arg === "block") {
          return this.commentRange({
            pos: context.getPosition(node).start,
            text: "\n// ...",
            kind: ts.SyntaxKind.SingleLineCommentTrivia,
            hasTrailingNewLine: false
          }, context);
        }
        if (arg === "...") {
          return new o_tree_1.OTree(["..."]);
        }
        return o_tree_1.NO_SYNTAX;
      }
      argumentList(args, context) {
        return new o_tree_1.OTree([], args ? context.convertAll(args) : [], {
          separator: ", "
        });
      }
      notImplemented(node, context) {
        context.reportUnsupported(node, this.language);
        return renderer_1.nimpl(node, context);
      }
    };
    exports.DefaultVisitor = DefaultVisitor;
    var UNARY_OPS = {
      [ts.SyntaxKind.PlusPlusToken]: "++",
      [ts.SyntaxKind.MinusMinusToken]: "--",
      [ts.SyntaxKind.PlusToken]: "+",
      [ts.SyntaxKind.MinusToken]: "-",
      [ts.SyntaxKind.TildeToken]: "~",
      [ts.SyntaxKind.ExclamationToken]: "!"
    };
    function findEnclosingCallExpression(node) {
      while (node) {
        if (ts.isCallLikeExpression(node)) {
          return node;
        }
        node = node.parent;
      }
      return void 0;
    }
  }
});

// node_modules/jsii-rosetta/lib/languages/target-language.js
var require_target_language = __commonJS({
  "node_modules/jsii-rosetta/lib/languages/target-language.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.TargetLanguage = void 0;
    var TargetLanguage;
    (function(TargetLanguage2) {
      TargetLanguage2["PYTHON"] = "python";
      TargetLanguage2["CSHARP"] = "csharp";
      TargetLanguage2["JAVA"] = "java";
    })(TargetLanguage = exports.TargetLanguage || (exports.TargetLanguage = {}));
  }
});

// node_modules/jsii-rosetta/lib/languages/csharp.js
var require_csharp = __commonJS({
  "node_modules/jsii-rosetta/lib/languages/csharp.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.CSharpVisitor = void 0;
    var ts = require_typescript();
    var jsii_types_1 = require_jsii_types();
    var packages_1 = require_packages();
    var o_tree_1 = require_o_tree();
    var renderer_1 = require_renderer();
    var ast_utils_1 = require_ast_utils();
    var types_1 = require_types();
    var util_1 = require_util3();
    var default_1 = require_default();
    var target_language_1 = require_target_language();
    var CSharpVisitor = class extends default_1.DefaultVisitor {
      constructor() {
        super(...arguments);
        this.language = target_language_1.TargetLanguage.CSHARP;
        this.defaultContext = {
          propertyOrMethod: false,
          inStructInterface: false,
          inRegularInterface: false,
          inKeyValueList: false,
          stringAsIdentifier: false,
          identifierAsString: false,
          preferObjectLiteralAsStruct: true,
          privatePropertyNames: []
        };
        this.importedModuleAliases = new Set();
        this.importedModuleSymbols = new Set();
      }
      mergeContext(old, update) {
        return Object.assign({}, old, update);
      }
      identifier(node, renderer) {
        let text = node.text;
        if (renderer.currentContext.identifierAsString) {
          return new o_tree_1.OTree([JSON.stringify(text)]);
        }
        if (renderer.currentContext.propertyOrMethod && !renderer.currentContext.privatePropertyNames.includes(text)) {
          text = ucFirst(text);
        }
        return new o_tree_1.OTree([text]);
      }
      importStatement(importStatement, context) {
        const namespace = this.lookupModuleNamespace(importStatement.packageName);
        if (importStatement.imports.import === "full") {
          this.importedModuleAliases.add(importStatement.imports.alias);
          return new o_tree_1.OTree([`using ${namespace};`], [], { canBreakLine: true });
        }
        if (importStatement.imports.import === "selective") {
          const statements = [];
          const [withoutAlias, withAlias] = util_1.partition(importStatement.imports.elements, (im) => im.alias === void 0);
          if (withoutAlias) {
            statements.push(`using ${namespace};`);
            util_1.setExtend(this.importedModuleSymbols, withoutAlias.map((w) => w.sourceName));
          }
          for (const aliasedImport of withAlias) {
            statements.push(`using ${ucFirst(aliasedImport.alias)} = ${namespace}.${ucFirst(aliasedImport.sourceName)};`);
            this.importedModuleSymbols.add(aliasedImport.alias);
          }
          return new o_tree_1.OTree([], statements, { canBreakLine: true, separator: "\n" });
        }
        return renderer_1.nimpl(importStatement.node, context);
      }
      functionDeclaration(node, renderer) {
        return this.functionLike(node, renderer);
      }
      constructorDeclaration(node, renderer) {
        return this.functionLike(node, renderer, { isConstructor: true });
      }
      methodDeclaration(node, renderer) {
        return this.functionLike(node, renderer);
      }
      methodSignature(node, renderer) {
        return new o_tree_1.OTree([
          this.renderTypeNode(node.type, false, renderer),
          " ",
          renderer.updateContext({ propertyOrMethod: true }).convert(node.name),
          "(",
          new o_tree_1.OTree([], renderer.convertAll(node.parameters), {
            separator: ", "
          }),
          ");"
        ], [], { canBreakLine: true });
      }
      functionLike(node, renderer, opts = {}) {
        var _a;
        const methodName = opts.isConstructor ? (_a = renderer.currentContext.currentClassName) !== null && _a !== void 0 ? _a : "MyClass" : renderer.updateContext({ propertyOrMethod: true }).convert(node.name);
        const returnType = opts.isConstructor ? "" : this.renderTypeNode(node.type, false, renderer);
        const baseConstructorCall = new Array();
        if (opts.isConstructor) {
          const superCall = ast_utils_1.findSuperCall(node.body, renderer);
          if (superCall) {
            baseConstructorCall.push(": base(", this.argumentList(superCall.arguments, renderer), ") ");
          }
        }
        const ret = new o_tree_1.OTree([
          ast_utils_1.visibility(node),
          " ",
          returnType,
          returnType ? " " : "",
          methodName,
          "(",
          new o_tree_1.OTree([], renderer.convertAll(node.parameters), {
            separator: ", "
          }),
          ") ",
          ...baseConstructorCall
        ], [renderer.convert(node.body)], {
          canBreakLine: true
        });
        return ret;
      }
      propertyDeclaration(node, renderer) {
        const vis = ast_utils_1.visibility(node);
        const propertyOrMethod = vis !== "private";
        if (vis === "private" || node.initializer) {
          return new o_tree_1.OTree([
            vis,
            ast_utils_1.isReadOnly(node) ? " readonly" : "",
            " ",
            this.renderTypeNode(node.type, node.questionToken !== void 0, renderer),
            " ",
            renderer.updateContext({ propertyOrMethod }).convert(node.name),
            ...node.initializer ? [" = ", renderer.convert(node.initializer)] : [],
            ";"
          ], [], { canBreakLine: true });
        }
        return new o_tree_1.OTree([
          vis,
          " ",
          this.renderTypeNode(node.type, node.questionToken !== void 0, renderer),
          " ",
          renderer.updateContext({ propertyOrMethod }).convert(node.name),
          " ",
          ast_utils_1.isReadOnly(node) ? "{ get; }" : "{ get; set; }"
        ], [], { canBreakLine: true });
      }
      printStatement(args, renderer) {
        const renderedArgs = args.length === 1 ? renderer.convertAll(args) : [
          '$"',
          new o_tree_1.OTree([], args.map((a) => new o_tree_1.OTree(["{", renderer.convert(a), "}"])), { separator: " " }),
          '"'
        ];
        return new o_tree_1.OTree(["Console.WriteLine(", ...renderedArgs, ")"]);
      }
      superCallExpression(_node, _renderer) {
        return o_tree_1.NO_SYNTAX;
      }
      stringLiteral(node, renderer) {
        if (renderer.currentContext.stringAsIdentifier) {
          return this.identifier(node, renderer);
        }
        if (node.text.includes("\n")) {
          return new o_tree_1.OTree(['@"', node.text.replace(/"/g, '""'), '"']);
        }
        return new o_tree_1.OTree([JSON.stringify(node.text)]);
      }
      expressionStatement(node, renderer) {
        const inner = renderer.convert(node.expression);
        if (inner.isEmpty) {
          return inner;
        }
        return new o_tree_1.OTree([inner, ";"], [], { canBreakLine: true });
      }
      propertyAccessExpression(node, renderer) {
        const lhs = renderer.textOf(node.expression);
        const objectExpression = lhs === "this" || this.importedModuleAliases.has(lhs) ? [] : [renderer.updateContext({ propertyOrMethod: false }).convert(node.expression), "."];
        return new o_tree_1.OTree([...objectExpression, renderer.updateContext({ propertyOrMethod: true }).convert(node.name)]);
      }
      parameterDeclaration(node, renderer) {
        return new o_tree_1.OTree([
          this.renderTypeNode(node.type, node.questionToken !== void 0, renderer),
          " ",
          renderer.convert(node.name),
          ...types_1.parameterAcceptsUndefined(node, node.type && renderer.typeOfType(node.type)) ? ["=", node.initializer ? renderer.convert(node.initializer) : "null"] : []
        ]);
      }
      propertySignature(node, renderer) {
        const canSet = renderer.currentContext.inStructInterface || !ast_utils_1.isReadOnly(node);
        return new o_tree_1.OTree([
          !renderer.currentContext.inRegularInterface ? `${ast_utils_1.visibility(node)} ` : o_tree_1.NO_SYNTAX,
          this.renderTypeNode(node.type, node.questionToken !== void 0, renderer),
          " ",
          renderer.updateContext({ propertyOrMethod: true }).convert(node.name),
          " ",
          canSet ? "{ get; set; }" : "{ get; }"
        ], [], { canBreakLine: true });
      }
      regularCallExpression(node, renderer) {
        return new o_tree_1.OTree([
          renderer.updateContext({ propertyOrMethod: true }).convert(node.expression),
          "(",
          this.argumentList(node.arguments, renderer),
          ")"
        ]);
      }
      classDeclaration(node, renderer) {
        return new o_tree_1.OTree(["class ", renderer.convert(node.name), ...this.classHeritage(node, renderer), "\n{"], renderer.updateContext({
          privatePropertyNames: ast_utils_1.privatePropertyNames(node.members, renderer)
        }).convertAll(node.members), {
          indent: 4,
          canBreakLine: true,
          suffix: "\n}"
        });
      }
      structInterfaceDeclaration(node, renderer) {
        return new o_tree_1.OTree(["class ", renderer.convert(node.name), ...this.classHeritage(node, renderer), "\n{"], renderer.updateContext({ inStructInterface: true }).convertAll(node.members), {
          indent: 4,
          canBreakLine: true,
          suffix: "\n}"
        });
      }
      regularInterfaceDeclaration(node, renderer) {
        return new o_tree_1.OTree(["interface ", renderer.convert(node.name), ...this.classHeritage(node, renderer), "\n{"], renderer.updateContext({ inRegularInterface: true }).convertAll(node.members), {
          indent: 4,
          canBreakLine: true,
          suffix: "\n}"
        });
      }
      block(node, children) {
        return new o_tree_1.OTree(["\n{"], [...children.convertAll(node.statements)], {
          indent: 4,
          suffix: "\n}"
        });
      }
      unknownTypeObjectLiteralExpression(node, renderer) {
        if (renderer.currentContext.preferObjectLiteralAsStruct) {
          return new o_tree_1.OTree(["new Struct { "], renderer.convertAll(node.properties), {
            suffix: renderer.mirrorNewlineBefore(node.properties[0], "}", " "),
            separator: ", ",
            indent: 4
          });
        }
        return this.keyValueObjectLiteralExpression(node, renderer);
      }
      knownStructObjectLiteralExpression(node, structType, renderer) {
        return new o_tree_1.OTree(["new ", structType.symbol.name, " { "], renderer.convertAll(node.properties), {
          suffix: renderer.mirrorNewlineBefore(node.properties[0], "}", " "),
          separator: ", ",
          indent: 4
        });
      }
      keyValueObjectLiteralExpression(node, renderer) {
        const valueType = types_1.inferMapElementType(node.properties, renderer.typeChecker);
        return new o_tree_1.OTree(["new Dictionary<string, ", this.renderType(node, valueType, false, "object", renderer), "> { "], renderer.updateContext({ inKeyValueList: true }).convertAll(node.properties), {
          suffix: renderer.mirrorNewlineBefore(node.properties[0], "}", " "),
          separator: ", ",
          indent: 4
        });
      }
      shorthandPropertyAssignment(node, renderer) {
        return this.renderPropertyAssignment(node.name, node.name, renderer);
      }
      propertyAssignment(node, renderer) {
        return this.renderPropertyAssignment(node.name, node.initializer, renderer);
      }
      renderPropertyAssignment(key, value, renderer) {
        if (renderer.currentContext.inKeyValueList) {
          return new o_tree_1.OTree([
            "{ ",
            renderer.updateContext({
              propertyOrMethod: false,
              identifierAsString: !ts.isComputedPropertyName(key)
            }).convert(key),
            ", ",
            renderer.updateContext({ inKeyValueList: false }).convert(value),
            " }"
          ], [], { canBreakLine: true });
        }
        return new o_tree_1.OTree([
          renderer.updateContext({ propertyOrMethod: true, stringAsIdentifier: true }).convert(key),
          " = ",
          renderer.convert(value)
        ], [], { canBreakLine: true });
      }
      arrayLiteralExpression(node, renderer) {
        return new o_tree_1.OTree(["new [] { "], renderer.convertAll(node.elements), {
          separator: ", ",
          suffix: " }",
          indent: 4
        });
      }
      ifStatement(node, renderer) {
        const ifStmt = new o_tree_1.OTree(["if (", renderer.convert(node.expression), ") "], [renderer.convert(node.thenStatement)], { canBreakLine: true });
        const elseStmt = node.elseStatement ? new o_tree_1.OTree(["else "], [renderer.convert(node.elseStatement)], {
          canBreakLine: true
        }) : void 0;
        return elseStmt ? new o_tree_1.OTree([], [ifStmt, elseStmt], {
          separator: "\n",
          canBreakLine: true
        }) : ifStmt;
      }
      forOfStatement(node, renderer) {
        let variableName = "???";
        ast_utils_1.matchAst(node.initializer, ast_utils_1.nodeOfType(ts.SyntaxKind.VariableDeclarationList, ast_utils_1.nodeOfType("var", ts.SyntaxKind.VariableDeclaration)), (bindings) => {
          variableName = renderer.textOf(bindings.var.name);
        });
        return new o_tree_1.OTree(["for (var ", variableName, " in ", renderer.convert(node.expression), ") "], [renderer.convert(node.statement)], { canBreakLine: true });
      }
      asExpression(node, context) {
        return new o_tree_1.OTree(["(", this.renderTypeNode(node.type, false, context), ")", context.convert(node.expression)]);
      }
      variableDeclaration(node, renderer) {
        let fallback = "var";
        if (node.type) {
          fallback = node.type.getText();
        }
        const type = node.type && renderer.typeOfType(node.type) || node.initializer && renderer.typeOfExpression(node.initializer);
        let renderedType = this.renderType(node, type, false, fallback, renderer);
        if (renderedType === "object") {
          renderedType = "var";
        }
        if (!node.initializer) {
          return new o_tree_1.OTree([renderedType, " ", renderer.convert(node.name), ";"], []);
        }
        return new o_tree_1.OTree([
          renderedType,
          " ",
          renderer.convert(node.name),
          " = ",
          renderer.updateContext({ preferObjectLiteralAsStruct: false }).convert(node.initializer),
          ";"
        ], [], { canBreakLine: true });
      }
      templateExpression(node, context) {
        var _a;
        const isMultiLine = !!((_a = node.head.rawText) === null || _a === void 0 ? void 0 : _a.includes("\n")) || node.templateSpans.some((span) => {
          var _a2;
          return (_a2 = span.literal.rawText) === null || _a2 === void 0 ? void 0 : _a2.includes("\n");
        });
        const parts = new Array();
        if (node.head.rawText) {
          parts.push(isMultiLine ? node.head.rawText.replace(/"/g, '""') : ast_utils_1.quoteStringLiteral(node.head.rawText));
        }
        for (const span of node.templateSpans) {
          parts.push(`{${context.textOf(span.expression)}}`);
          if (span.literal.rawText) {
            parts.push(isMultiLine ? span.literal.rawText.replace(/"/g, '""') : ast_utils_1.quoteStringLiteral(span.literal.rawText));
          }
        }
        return new o_tree_1.OTree([isMultiLine ? '$@"' : '$"', ...parts, '"']);
      }
      argumentList(args, renderer) {
        return new o_tree_1.OTree([], args ? renderer.updateContext({ preferObjectLiteralAsStruct: true }).convertAll(args) : [], {
          separator: ", "
        });
      }
      lookupModuleNamespace(ref) {
        const resolvedNamespace = packages_1.jsiiTargetParam(ref, "dotnet.namespace");
        return resolvedNamespace || ref.split(/[^a-zA-Z0-9]+/g).filter((s) => s !== "").map(ucFirst).join(".");
      }
      renderTypeNode(typeNode, questionMark, renderer) {
        if (!typeNode) {
          return "void";
        }
        return this.renderType(typeNode, renderer.typeOfType(typeNode), questionMark, renderer.textOf(typeNode), renderer);
      }
      renderType(typeNode, type, questionMark, fallback, renderer) {
        if (type === void 0) {
          return fallback;
        }
        const renderedType = doRender(jsii_types_1.determineJsiiType(renderer.typeChecker, type));
        const suffix = questionMark || types_1.typeContainsUndefined(type) ? "?" : "";
        return renderedType + suffix;
        function doRender(jsiiType) {
          switch (jsiiType.kind) {
            case "unknown":
              return fallback;
            case "error":
              renderer.report(typeNode, jsiiType.message);
              return fallback;
            case "map":
              return `IDictionary<string, ${doRender(jsiiType.elementType)}>`;
            case "list":
              return `${doRender(jsiiType.elementType)}[]`;
            case "namedType":
              return jsiiType.name;
            case "builtIn":
              switch (jsiiType.builtIn) {
                case "boolean":
                  return "boolean";
                case "number":
                  return "int";
                case "string":
                  return "string";
                case "any":
                  return "object";
              }
          }
        }
      }
      classHeritage(node, renderer) {
        var _a;
        const heritage = util_1.flat(Array.from((_a = node.heritageClauses) !== null && _a !== void 0 ? _a : []).map((h) => Array.from(h.types))).map((t) => renderer.convert(t.expression));
        return heritage.length > 0 ? [" : ", new o_tree_1.OTree([], heritage, { separator: ", " })] : [];
      }
    };
    exports.CSharpVisitor = CSharpVisitor;
    function ucFirst(x) {
      return x.substr(0, 1).toUpperCase() + x.substr(1);
    }
  }
});

// node_modules/jsii-rosetta/lib/languages/java.js
var require_java = __commonJS({
  "node_modules/jsii-rosetta/lib/languages/java.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.JavaVisitor = void 0;
    var ts = require_typescript();
    var jsii_types_1 = require_jsii_types();
    var jsii_utils_1 = require_jsii_utils();
    var packages_1 = require_packages();
    var target_language_1 = require_target_language();
    var o_tree_1 = require_o_tree();
    var ast_utils_1 = require_ast_utils();
    var types_1 = require_types();
    var default_1 = require_default();
    var JavaVisitor = class extends default_1.DefaultVisitor {
      constructor() {
        super(...arguments);
        this.language = target_language_1.TargetLanguage.JAVA;
        this.defaultContext = {};
      }
      mergeContext(old, update) {
        return Object.assign({}, old, update);
      }
      importStatement(importStatement) {
        const namespace = this.lookupModuleNamespace(importStatement.packageName);
        if (importStatement.imports.import === "full") {
          return new o_tree_1.OTree([`import ${namespace}.*;`], [], { canBreakLine: true });
        }
        return new o_tree_1.OTree([], importStatement.imports.elements.map((importEl) => `import ${namespace}.${importEl.sourceName};`), { canBreakLine: true, separator: "\n" });
      }
      classDeclaration(node, renderer) {
        return this.renderClassDeclaration(node, renderer);
      }
      structInterfaceDeclaration(node, renderer) {
        return this.renderClassDeclaration(node, renderer);
      }
      regularInterfaceDeclaration(node, renderer) {
        return new o_tree_1.OTree([
          "public ",
          "interface ",
          renderer.convert(node.name),
          ...this.typeHeritage(node, renderer.updateContext({ ignorePropertyPrefix: true })),
          " {"
        ], renderer.updateContext({
          insideTypeDeclaration: { typeName: node.name, isInterface: true }
        }).convertAll(node.members), {
          indent: 4,
          canBreakLine: true,
          suffix: "\n}"
        });
      }
      propertySignature(node, renderer) {
        var _a;
        const propertyType = this.renderTypeNode(node.type, renderer, "Object");
        const propertyName = renderer.convert(node.name);
        const isClass = !((_a = renderer.currentContext.insideTypeDeclaration) === null || _a === void 0 ? void 0 : _a.isInterface);
        const blockSep = isClass ? " " : ";";
        const field = isClass ? new o_tree_1.OTree([], ["private ", propertyType, " ", propertyName, ";"], {
          canBreakLine: true
        }) : o_tree_1.NO_SYNTAX;
        const getter = new o_tree_1.OTree([], [
          isClass ? "public " : o_tree_1.NO_SYNTAX,
          propertyType,
          " ",
          `get${capitalize(renderer.textOf(node.name))}()${blockSep}`,
          isClass ? this.renderBlock([new o_tree_1.OTree(["\n"], ["return this.", propertyName, ";"])]) : o_tree_1.NO_SYNTAX
        ], {
          canBreakLine: true
        });
        const hasSetter = isClass || !ast_utils_1.isReadOnly(node);
        const setter = hasSetter ? new o_tree_1.OTree([], [
          isClass ? "public " : o_tree_1.NO_SYNTAX,
          renderer.convert(renderer.currentContext.insideTypeDeclaration.typeName),
          " ",
          propertyName,
          "(",
          propertyType,
          " ",
          propertyName,
          `)${blockSep}`,
          isClass ? this.renderBlock([
            new o_tree_1.OTree(["\n"], ["this.", propertyName, " = ", propertyName, ";"]),
            new o_tree_1.OTree(["\n"], ["return this;"])
          ]) : o_tree_1.NO_SYNTAX
        ], {
          canBreakLine: true
        }) : o_tree_1.NO_SYNTAX;
        return new o_tree_1.OTree([], [field, getter, setter], {
          canBreakLine: true,
          separator: "\n"
        });
      }
      propertyDeclaration(node, renderer) {
        const vis = ast_utils_1.visibility(node);
        return new o_tree_1.OTree([
          vis,
          ast_utils_1.isReadOnly(node) ? " final" : "",
          " ",
          this.renderTypeNode(node.type, renderer, "Object"),
          " ",
          renderer.convert(node.name),
          ";"
        ], [], {
          canBreakLine: true
        });
      }
      constructorDeclaration(node, renderer) {
        return this.renderProcedure(node, renderer, renderer.currentContext.insideTypeDeclaration.typeName, void 0);
      }
      methodDeclaration(node, renderer) {
        return this.renderProcedure(node, renderer, node.name, this.renderTypeNode(node.type, renderer, "void"));
      }
      functionDeclaration(node, renderer) {
        return this.renderProcedure(node, renderer, node.name, this.renderTypeNode(node.type, renderer, "void"));
      }
      methodSignature(node, renderer) {
        return new o_tree_1.OTree([
          this.renderTypeNode(node.type, renderer, "void"),
          " ",
          renderer.convert(node.name),
          "(",
          new o_tree_1.OTree([], renderer.convertAll(node.parameters), {
            separator: ", "
          }),
          ");"
        ], [], { canBreakLine: true });
      }
      parameterDeclaration(node, renderer) {
        return new o_tree_1.OTree([this.renderTypeNode(node.type, renderer), " ", renderer.convert(node.name)]);
      }
      block(node, renderer) {
        return this.renderBlock(renderer.convertAll(node.statements));
      }
      variableDeclaration(node, renderer) {
        let fallback = "Object";
        if (node.type) {
          fallback = node.type.getText();
        }
        const type = node.type && renderer.typeOfType(node.type) || node.initializer && renderer.typeOfExpression(node.initializer);
        const renderedType = type ? this.renderType(node, type, renderer, fallback) : fallback;
        if (!node.initializer) {
          return new o_tree_1.OTree([renderedType, " ", renderer.convert(node.name), ";"], []);
        }
        return new o_tree_1.OTree([
          renderedType,
          " ",
          renderer.convert(node.name),
          ...node.initializer ? [" = ", renderer.convert(node.initializer)] : [],
          ";"
        ], [], {
          canBreakLine: true
        });
      }
      expressionStatement(node, renderer) {
        const inner = renderer.convert(node.expression);
        return inner.isEmpty ? inner : new o_tree_1.OTree([inner, ";"], [], { canBreakLine: true });
      }
      ifStatement(node, renderer) {
        const ifStmt = new o_tree_1.OTree(["if (", renderer.convert(node.expression), ") "], [renderer.convert(node.thenStatement)], {
          canBreakLine: true
        });
        const elseStmt = node.elseStatement ? new o_tree_1.OTree(["else "], [renderer.convert(node.elseStatement)], {
          canBreakLine: true
        }) : void 0;
        return elseStmt ? new o_tree_1.OTree([], [ifStmt, elseStmt], {
          separator: " ",
          canBreakLine: true
        }) : ifStmt;
      }
      forOfStatement(node, renderer) {
        let variableName = "???";
        ast_utils_1.matchAst(node.initializer, ast_utils_1.nodeOfType(ts.SyntaxKind.VariableDeclarationList, ast_utils_1.nodeOfType("var", ts.SyntaxKind.VariableDeclaration)), (bindings) => {
          variableName = renderer.textOf(bindings.var.name);
        });
        return new o_tree_1.OTree(["for (Object ", variableName, " : ", renderer.convert(node.expression), ") "], [renderer.convert(node.statement)], {
          canBreakLine: true
        });
      }
      printStatement(args, renderer) {
        return new o_tree_1.OTree([
          "System.out.println(",
          args.length === 1 ? renderer.convert(args[0]) : new o_tree_1.OTree([], renderer.convertAll(args), { separator: " + " }),
          ")"
        ]);
      }
      templateExpression(node, renderer) {
        let template = "";
        const parameters = new Array();
        if (node.head.rawText) {
          template += node.head.rawText;
        }
        for (const span of node.templateSpans) {
          template += "%s";
          parameters.push(renderer.updateContext({
            convertPropertyToGetter: true,
            identifierAsString: false
          }).convert(span.expression));
          if (span.literal.rawText) {
            template += span.literal.rawText;
          }
        }
        if (parameters.length === 0) {
          return new o_tree_1.OTree([JSON.stringify(ast_utils_1.quoteStringLiteral(template))]);
        }
        return new o_tree_1.OTree([
          "String.format(",
          `"${ast_utils_1.quoteStringLiteral(template).replace(/\n/g, "%n")}"`,
          ...parameters.reduce((list, element) => list.concat(", ", element), new Array()),
          ")"
        ]);
      }
      asExpression(node, renderer) {
        return new o_tree_1.OTree(["(", this.renderTypeNode(node.type, renderer, "Object"), ")", renderer.convert(node.expression)]);
      }
      arrayLiteralExpression(node, renderer) {
        return new o_tree_1.OTree(["List.of("], renderer.convertAll(node.elements), {
          separator: ", ",
          suffix: ")",
          indent: 4
        });
      }
      regularCallExpression(node, renderer) {
        return new o_tree_1.OTree([
          renderer.updateContext({ convertPropertyToGetter: false }).convert(node.expression),
          "(",
          this.argumentList(node.arguments, renderer),
          ")"
        ]);
      }
      newExpression(node, renderer) {
        const argsLength = node.arguments ? node.arguments.length : 0;
        const lastArg = argsLength > 0 ? node.arguments[argsLength - 1] : void 0;
        const lastArgIsObjectLiteral = lastArg && ts.isObjectLiteralExpression(lastArg);
        const lastArgType = lastArg && renderer.inferredTypeOfExpression(lastArg);
        const renderBuilderInsteadOfNew = lastArgIsObjectLiteral && (!lastArgType || !jsii_utils_1.isStructType(lastArgType));
        return new o_tree_1.OTree([], [
          renderBuilderInsteadOfNew ? void 0 : "new ",
          renderer.updateContext({
            ignorePropertyPrefix: true,
            convertPropertyToGetter: false
          }).convert(node.expression),
          renderBuilderInsteadOfNew ? ".Builder.create" : void 0,
          "(",
          this.argumentList(renderBuilderInsteadOfNew ? node.arguments.slice(0, argsLength - 1) : node.arguments, renderer),
          ")",
          renderBuilderInsteadOfNew ? renderer.updateContext({ inNewExprWithObjectLiteralAsLastArg: true }).convert(lastArg) : void 0
        ], {
          canBreakLine: true
        });
      }
      unknownTypeObjectLiteralExpression(node, renderer) {
        return renderer.currentContext.inNewExprWithObjectLiteralAsLastArg ? this.renderObjectLiteralAsBuilder(node, renderer) : this.keyValueObjectLiteralExpression(node, renderer);
      }
      keyValueObjectLiteralExpression(node, renderer) {
        return new o_tree_1.OTree(["Map.of("], renderer.updateContext({ inKeyValueList: true }).convertAll(node.properties), {
          suffix: ")",
          separator: ", ",
          indent: 8
        });
      }
      knownStructObjectLiteralExpression(node, structType, renderer) {
        return new o_tree_1.OTree(["new ", structType.symbol.name, "()"], [...renderer.convertAll(node.properties)], {
          indent: 8
        });
      }
      propertyAssignment(node, renderer) {
        return renderer.currentContext.inKeyValueList ? this.singlePropertyInJavaScriptObjectLiteralToJavaMap(node.name, node.initializer, renderer) : this.singlePropertyInJavaScriptObjectLiteralToFluentSetters(node.name, node.initializer, renderer);
      }
      shorthandPropertyAssignment(node, renderer) {
        return renderer.currentContext.inKeyValueList ? this.singlePropertyInJavaScriptObjectLiteralToJavaMap(node.name, node.name, renderer) : this.singlePropertyInJavaScriptObjectLiteralToFluentSetters(node.name, node.name, renderer);
      }
      propertyAccessExpression(node, renderer) {
        const rightHandSide = renderer.convert(node.name);
        let parts;
        if (renderer.currentContext.ignorePropertyPrefix) {
          parts = [rightHandSide];
        } else {
          const leftHandSide = renderer.textOf(node.expression);
          if (leftHandSide === "this") {
            parts = ["this", ".", rightHandSide];
          } else {
            let convertToGetter = renderer.currentContext.convertPropertyToGetter !== false;
            if (types_1.isEnumAccess(renderer.typeChecker, node)) {
              convertToGetter = false;
            }
            if (types_1.isStaticReadonlyAccess(renderer.typeChecker, node)) {
              convertToGetter = false;
            }
            const renderedRightHandSide = convertToGetter ? `get${capitalize(node.name.text)}()` : rightHandSide;
            parts = [stripTrailingBang(leftHandSide), ".", renderedRightHandSide];
          }
        }
        return new o_tree_1.OTree(parts);
      }
      stringLiteral(node, renderer) {
        if (renderer.currentContext.stringLiteralAsIdentifier) {
          return this.identifier(node, renderer);
        }
        return new o_tree_1.OTree([JSON.stringify(node.text).replace(/\n/g, "\\n")]);
      }
      identifier(node, renderer) {
        const nodeText = node.text;
        return new o_tree_1.OTree([renderer.currentContext.identifierAsString ? JSON.stringify(nodeText) : nodeText]);
      }
      renderObjectLiteralAsBuilder(node, renderer) {
        return new o_tree_1.OTree([], [
          ...renderer.convertAll(node.properties),
          new o_tree_1.OTree([renderer.mirrorNewlineBefore(node.properties[0])], [".build()"])
        ], {
          indent: 8
        });
      }
      singlePropertyInJavaScriptObjectLiteralToJavaMap(name, initializer, renderer) {
        return new o_tree_1.OTree([], [
          renderer.updateContext({
            identifierAsString: !ts.isComputedPropertyName(name)
          }).convert(name),
          ", ",
          renderer.updateContext({ inKeyValueList: false }).convert(initializer)
        ], {
          canBreakLine: true
        });
      }
      singlePropertyInJavaScriptObjectLiteralToFluentSetters(name, initializer, renderer) {
        return new o_tree_1.OTree([], [
          ".",
          renderer.updateContext({ stringLiteralAsIdentifier: true }).convert(name),
          "(",
          renderer.updateContext({ inNewExprWithObjectLiteralAsLastArg: false }).convert(initializer),
          ")"
        ], {
          canBreakLine: true
        });
      }
      lookupModuleNamespace(packageName) {
        const resolvedNamespace = packages_1.jsiiTargetParam(packageName, "java.package");
        return resolvedNamespace || packageName.split(/[^a-zA-Z0-9]+/g).filter((s) => s !== "").join(".");
      }
      renderClassDeclaration(node, renderer) {
        return new o_tree_1.OTree([
          "public ",
          "class ",
          renderer.convert(node.name),
          ...this.typeHeritage(node, renderer.updateContext({ ignorePropertyPrefix: true })),
          " {"
        ], renderer.updateContext({ insideTypeDeclaration: { typeName: node.name } }).convertAll(node.members), {
          indent: 4,
          canBreakLine: true,
          suffix: "\n}"
        });
      }
      typeHeritage(node, renderer) {
        return [
          ...this.extractSuperTypes(node, renderer, ts.SyntaxKind.ExtendsKeyword, "extends"),
          ...this.extractSuperTypes(node, renderer, ts.SyntaxKind.ImplementsKeyword, "implements")
        ];
      }
      extractSuperTypes(node, renderer, heritageKeyword, outputKeyword) {
        var _a;
        const heritageClause = ((_a = node.heritageClauses) !== null && _a !== void 0 ? _a : []).find((hc) => hc.token === heritageKeyword);
        const superTypes = heritageClause ? heritageClause.types.map((t) => renderer.convert(t.expression)) : [];
        return superTypes.length > 0 ? [` ${outputKeyword} `, new o_tree_1.OTree([], superTypes, { separator: ", " })] : [];
      }
      renderTypeNode(typeNode, renderer, fallback) {
        fallback = fallback !== null && fallback !== void 0 ? fallback : typeNode ? lastElement(renderer.textOf(typeNode).split(".")) : "Object";
        if (!typeNode) {
          return fallback;
        }
        return this.renderType(typeNode, renderer.typeOfType(typeNode), renderer, fallback);
      }
      renderType(owningNode, type, renderer, fallback) {
        return doRender(jsii_types_1.determineJsiiType(renderer.typeChecker, type), false);
        function doRender(jsiiType, requiresReferenceType) {
          switch (jsiiType.kind) {
            case "unknown":
              return fallback;
            case "error":
              renderer.report(owningNode, jsiiType.message);
              return fallback;
            case "map":
              return `Map<String, ${doRender(jsiiType.elementType, true)}>`;
            case "list":
              return `${doRender(jsiiType.elementType, true)}[]`;
            case "namedType":
              return jsiiType.name;
            case "builtIn":
              switch (jsiiType.builtIn) {
                case "boolean":
                  return requiresReferenceType ? "Boolean" : "boolean";
                case "number":
                  return "Number";
                case "string":
                  return "String";
                case "any":
                  return "Object";
                default:
                  return jsiiType.builtIn;
              }
          }
        }
      }
      renderProcedure(node, renderer, methodOrConstructorName, returnType) {
        const overloads = new Array();
        for (let i = 0; i < node.parameters.length; i++) {
          const param = node.parameters[i];
          if (!!param.questionToken || !!param.initializer) {
            const parametersUpToIth = node.parameters.slice(0, i);
            const callExpr = ts.isConstructorDeclaration(node) ? "this" : renderer.convert(methodOrConstructorName);
            overloads.push(this.renderOverload(returnType, renderer, methodOrConstructorName, parametersUpToIth, this.renderBlock([
              new o_tree_1.OTree(["\n", callExpr, "("], [
                ...parametersUpToIth.map((param2) => renderer.convert(param2.name)),
                param.initializer ? renderer.convert(param.initializer) : "null"
              ], {
                separator: ", ",
                suffix: ");"
              })
            ])));
          }
        }
        overloads.push(this.renderOverload(returnType, renderer, methodOrConstructorName, node.parameters, renderer.convert(node.body)));
        return new o_tree_1.OTree([], overloads, {
          canBreakLine: true,
          separator: "\n\n"
        });
      }
      renderOverload(returnType, renderer, methodOrConstructorName, parameters, body) {
        return new o_tree_1.OTree([
          "public ",
          returnType ? `${returnType} ` : void 0,
          renderer.convert(methodOrConstructorName),
          "(",
          new o_tree_1.OTree([], renderer.convertAll(parameters), { separator: ", " }),
          ") "
        ], [body], {
          canBreakLine: true
        });
      }
      renderBlock(blockContents) {
        return new o_tree_1.OTree(["{"], blockContents, {
          indent: 4,
          suffix: "\n}"
        });
      }
    };
    exports.JavaVisitor = JavaVisitor;
    function stripTrailingBang(str) {
      return str.replace(/!+$/, "");
    }
    function capitalize(str) {
      return str.charAt(0).toUpperCase() + str.slice(1);
    }
    function lastElement(strings) {
      return strings[strings.length - 1];
    }
  }
});

// node_modules/jsii-rosetta/lib/languages/python.js
var require_python = __commonJS({
  "node_modules/jsii-rosetta/lib/languages/python.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.PythonVisitor = void 0;
    var ts = require_typescript();
    var jsii_types_1 = require_jsii_types();
    var jsii_utils_1 = require_jsii_utils();
    var packages_1 = require_packages();
    var target_language_1 = require_target_language();
    var o_tree_1 = require_o_tree();
    var renderer_1 = require_renderer();
    var ast_utils_1 = require_ast_utils();
    var types_1 = require_types();
    var util_1 = require_util3();
    var default_1 = require_default();
    var PythonVisitor = class extends default_1.DefaultVisitor {
      constructor(options = {}) {
        super();
        this.options = options;
        this.language = target_language_1.TargetLanguage.PYTHON;
        this.defaultContext = {};
      }
      mergeContext(old, update) {
        return Object.assign({}, old, update);
      }
      commentRange(comment, _context) {
        const commentText = ast_utils_1.stripCommentMarkers(comment.text, comment.kind === ts.SyntaxKind.MultiLineCommentTrivia);
        const hashLines = commentText.split("\n").map((l) => `# ${l}`).join("\n");
        const needsAdditionalTrailer = comment.hasTrailingNewLine;
        return new o_tree_1.OTree([hashLines, needsAdditionalTrailer ? "\n" : ""], [], {
          renderOnce: `comment-${comment.pos}`
        });
      }
      sourceFile(node, context) {
        const rendered = super.sourceFile(node, context);
        if (this.options.disclaimer) {
          return new o_tree_1.OTree([`# ${this.options.disclaimer}
`, rendered]);
        }
        return rendered;
      }
      importStatement(node, context) {
        const moduleName = this.convertModuleReference(node.packageName);
        if (node.imports.import === "full") {
          return new o_tree_1.OTree([`import ${moduleName} as ${mangleIdentifier(node.imports.alias)}`], [], {
            canBreakLine: true
          });
        }
        if (node.imports.import === "selective") {
          const imports = node.imports.elements.map((im) => im.alias ? `${mangleIdentifier(im.sourceName)} as ${mangleIdentifier(im.alias)}` : mangleIdentifier(im.sourceName));
          return new o_tree_1.OTree([`from ${moduleName} import ${imports.join(", ")}`], [], {
            canBreakLine: true
          });
        }
        return renderer_1.nimpl(node.node, context);
      }
      token(node, context) {
        const text = context.textOf(node);
        const mapped = TOKEN_REWRITES[text];
        if (mapped) {
          return new o_tree_1.OTree([mapped]);
        }
        return super.token(node, context);
      }
      identifier(node, context) {
        const originalIdentifier = node.text;
        const explodedParameter = context.currentContext.explodedParameter;
        if (context.currentContext.tailPositionArgument && explodedParameter && explodedParameter.type && explodedParameter.variableName === originalIdentifier) {
          return new o_tree_1.OTree([], jsii_utils_1.propertiesOfStruct(explodedParameter.type, context).map((prop) => new o_tree_1.OTree([prop.name, "=", prop.name])), { separator: ", " });
        }
        return new o_tree_1.OTree([mangleIdentifier(originalIdentifier)]);
      }
      functionDeclaration(node, context) {
        return this.functionLike(node, context);
      }
      constructorDeclaration(node, context) {
        return this.functionLike(node, context, { isConstructor: true });
      }
      methodDeclaration(node, context) {
        return this.functionLike(node, context);
      }
      expressionStatement(node, context) {
        const text = context.textOf(node);
        if (text === "true") {
          return new o_tree_1.OTree(["True"]);
        }
        if (text === "false") {
          return new o_tree_1.OTree(["False"]);
        }
        return super.expressionStatement(node, context);
      }
      functionLike(node, context, opts = {}) {
        const methodName = opts.isConstructor ? "__init__" : o_tree_1.renderTree(context.convert(node.name));
        const [paramDecls, explodedParameter] = this.convertFunctionCallParameters(node.parameters, context);
        const ret = new o_tree_1.OTree([
          "def ",
          methodName,
          "(",
          new o_tree_1.OTree([], [context.currentContext.inClass ? "self" : void 0, ...paramDecls], {
            separator: ", "
          }),
          "): "
        ], [context.updateContext({ explodedParameter, currentMethodName: methodName }).convert(node.body)], {
          canBreakLine: true
        });
        return ret;
      }
      block(node, context) {
        if (node.statements.length === 0) {
          return new o_tree_1.OTree([], ["\npass"], { indent: 4, canBreakLine: true });
        }
        return new o_tree_1.OTree([], context.convertAll(node.statements), {
          separator: "",
          indent: 4,
          canBreakLine: true
        });
      }
      regularCallExpression(node, context) {
        var _a;
        let expressionText = context.convert(node.expression);
        if (ast_utils_1.matchAst(node.expression, ast_utils_1.nodeOfType(ts.SyntaxKind.SuperKeyword)) && context.currentContext.currentMethodName) {
          expressionText = `super().${context.currentContext.currentMethodName}`;
        }
        const signature = context.typeChecker.getResolvedSignature(node);
        return new o_tree_1.OTree([
          expressionText,
          "(",
          this.convertFunctionCallArguments(node.arguments, context, (_a = signature === null || signature === void 0 ? void 0 : signature.parameters) === null || _a === void 0 ? void 0 : _a.map((p) => p.valueDeclaration)),
          ")"
        ], [], { canBreakLine: true });
      }
      propertyAccessExpression(node, context) {
        const fullText = context.textOf(node);
        if (fullText in BUILTIN_FUNCTIONS) {
          return new o_tree_1.OTree([BUILTIN_FUNCTIONS[fullText]]);
        }
        const explodedParameter = context.currentContext.explodedParameter;
        if (explodedParameter && context.textOf(node.expression) === explodedParameter.variableName) {
          return context.convert(node.name);
        }
        return super.propertyAccessExpression(node, context);
      }
      parameterDeclaration(node, context) {
        const type = node.type && context.typeOfType(node.type);
        if (context.currentContext.tailPositionParameter && type && jsii_utils_1.isStructType(type)) {
          if (context.currentContext.returnExplodedParameter) {
            context.currentContext.returnExplodedParameter.value = {
              variableName: context.textOf(node.name),
              type
            };
          }
          return new o_tree_1.OTree([], ["*", ...jsii_utils_1.propertiesOfStruct(type, context).map(renderStructProperty)], { separator: ", " });
        }
        const suffix = types_1.parameterAcceptsUndefined(node, type) ? "=None" : "";
        return new o_tree_1.OTree([context.convert(node.name), suffix]);
        function renderStructProperty(prop) {
          const sfx = jsii_utils_1.structPropertyAcceptsUndefined(prop) ? "=None" : "";
          return prop.name + sfx;
        }
      }
      ifStatement(node, context) {
        const ifStmt = new o_tree_1.OTree(["if ", context.convert(node.expression), ": "], [context.convert(node.thenStatement)], {
          canBreakLine: true
        });
        const elseStmt = node.elseStatement ? new o_tree_1.OTree(["else: "], [context.convert(node.elseStatement)], {
          canBreakLine: true
        }) : void 0;
        return elseStmt ? new o_tree_1.OTree([], [ifStmt, elseStmt], {
          separator: "\n",
          canBreakLine: true
        }) : ifStmt;
      }
      unknownTypeObjectLiteralExpression(node, context) {
        const downContext = context.updateContext({
          tailPositionArgument: false,
          variadicArgument: false
        });
        if (context.currentContext.tailPositionArgument && !context.currentContext.variadicArgument) {
          return this.renderObjectLiteralExpression("", "", true, node, downContext);
        }
        return this.renderObjectLiteralExpression("{", "}", false, node, downContext);
      }
      knownStructObjectLiteralExpression(node, structType, context) {
        if (context.currentContext.tailPositionArgument) {
          return this.renderObjectLiteralExpression("", "", true, node, context);
        }
        return this.renderObjectLiteralExpression(`${structType.symbol.name}(`, ")", true, node, context);
      }
      keyValueObjectLiteralExpression(node, context) {
        return this.renderObjectLiteralExpression("{", "}", false, node, context);
      }
      translateUnaryOperator(operator) {
        if (operator === ts.SyntaxKind.ExclamationToken) {
          return "not ";
        }
        return super.translateUnaryOperator(operator);
      }
      renderObjectLiteralExpression(prefix, suffix, renderObjectLiteralAsKeywords, node, context) {
        return new o_tree_1.OTree([prefix], context.updateContext({ renderObjectLiteralAsKeywords }).convertAll(node.properties), {
          suffix: context.mirrorNewlineBefore(node.properties[0], suffix),
          separator: ", ",
          indent: 4
        });
      }
      arrayLiteralExpression(node, context) {
        return new o_tree_1.OTree(["["], context.convertAll(node.elements), {
          suffix: context.mirrorNewlineBefore(node.elements[0], "]"),
          separator: ", ",
          indent: 4
        });
      }
      propertyAssignment(node, context) {
        const mid = context.currentContext.renderObjectLiteralAsKeywords ? "=" : ": ";
        let name = context.convert(node.name);
        ast_utils_1.matchAst(node.name, ast_utils_1.nodeOfType("stringLiteral", ts.SyntaxKind.StringLiteral), (captured) => {
          name = new o_tree_1.OTree([mangleIdentifier(captured.stringLiteral.text)]);
        });
        if (!context.currentContext.renderObjectLiteralAsKeywords && !ts.isComputedPropertyName(node.name)) {
          name = new o_tree_1.OTree(['"', name, '"']);
        }
        return new o_tree_1.OTree([name, mid, context.updateContext({ tailPositionArgument: false }).convert(node.initializer)], [], { canBreakLine: true });
      }
      shorthandPropertyAssignment(node, context) {
        let before = '"';
        let mid = '": ';
        if (context.currentContext.renderObjectLiteralAsKeywords) {
          before = "";
          mid = "=";
        }
        return new o_tree_1.OTree([before, context.convert(node.name), mid, context.convert(node.name)], [], { canBreakLine: true });
      }
      newExpression(node, context) {
        return new o_tree_1.OTree([context.convert(node.expression), "(", this.convertFunctionCallArguments(node.arguments, context), ")"], [], { canBreakLine: true });
      }
      variableDeclaration(node, context) {
        let fallback = "object";
        if (node.type) {
          fallback = node.type.getText();
        }
        if (!node.initializer) {
          const type = node.type && context.typeOfType(node.type) || node.initializer && context.typeOfExpression(node.initializer);
          const renderedType = type ? this.renderType(node, type, context, fallback) : fallback;
          return new o_tree_1.OTree(["# ", context.convert(node.name), " is of type ", renderedType], []);
        }
        return new o_tree_1.OTree([context.convert(node.name), " = ", context.convert(node.initializer)], [], {
          canBreakLine: true
        });
      }
      thisKeyword() {
        return new o_tree_1.OTree(["self"]);
      }
      forOfStatement(node, context) {
        let variableName = "???";
        ast_utils_1.matchAst(node.initializer, ast_utils_1.nodeOfType(ts.SyntaxKind.VariableDeclarationList, ast_utils_1.nodeOfType("var", ts.SyntaxKind.VariableDeclaration)), (bindings) => {
          variableName = mangleIdentifier(context.textOf(bindings.var.name));
        });
        return new o_tree_1.OTree(["for ", variableName, " in ", context.convert(node.expression), ": "], [context.convert(node.statement)], { canBreakLine: true });
      }
      classDeclaration(node, context) {
        var _a;
        const heritage = util_1.flat(Array.from((_a = node.heritageClauses) !== null && _a !== void 0 ? _a : []).map((h) => Array.from(h.types))).map((t) => context.convert(t.expression));
        const hasHeritage = heritage.length > 0;
        const members = context.updateContext({ inClass: true }).convertAll(node.members);
        if (members.length === 0) {
          members.push(new o_tree_1.OTree(["\npass"], []));
        }
        const ret = new o_tree_1.OTree([
          "class ",
          node.name ? context.textOf(node.name) : "???",
          hasHeritage ? "(" : "",
          ...heritage,
          hasHeritage ? ")" : "",
          ": "
        ], members, {
          indent: 4,
          canBreakLine: true
        });
        return ret;
      }
      printStatement(args, context) {
        return new o_tree_1.OTree(["print", "(", new o_tree_1.OTree([], context.convertAll(args), { separator: ", " }), ")"]);
      }
      propertyDeclaration(_node, _context) {
        return new o_tree_1.OTree([]);
      }
      interfaceDeclaration(_node, _context) {
        return o_tree_1.NO_SYNTAX;
      }
      propertySignature(_node, _context) {
        return o_tree_1.NO_SYNTAX;
      }
      methodSignature(_node, _context) {
        return o_tree_1.NO_SYNTAX;
      }
      asExpression(node, context) {
        return context.convert(node.expression);
      }
      stringLiteral(node, _context) {
        const rawText = node.text;
        if (rawText.includes("\n")) {
          return new o_tree_1.OTree([
            '"""',
            rawText.replace(/\\/g, "\\\\").replace(/"""/g, '\\"""'),
            '"""'
          ]);
        }
        return new o_tree_1.OTree([JSON.stringify(rawText)]);
      }
      templateExpression(node, context) {
        const parts = new Array();
        if (node.head.rawText) {
          parts.push(ast_utils_1.quoteStringLiteral(node.head.rawText));
        }
        for (const span of node.templateSpans) {
          parts.push(`{${context.textOf(span.expression)}}`);
          if (span.literal.rawText) {
            parts.push(ast_utils_1.quoteStringLiteral(span.literal.rawText));
          }
        }
        const quote = parts.some((part) => part.includes("\n")) ? '"""' : '"';
        return new o_tree_1.OTree([`f${quote}`, ...parts, quote]);
      }
      maskingVoidExpression(node, _context) {
        const arg = ast_utils_1.voidExpressionString(node);
        if (arg === "block") {
          return new o_tree_1.OTree(["# ..."], [], { canBreakLine: true });
        }
        if (arg === "...") {
          return new o_tree_1.OTree(["..."]);
        }
        return o_tree_1.NO_SYNTAX;
      }
      convertModuleReference(ref) {
        const resolvedPackage = packages_1.jsiiTargetParam(ref, "python.module");
        return resolvedPackage || ref.replace(/^@/, "").replace(/\//g, ".").replace(/-/g, "_");
      }
      convertFunctionCallParameters(params, context) {
        if (!params || params.length === 0) {
          return [[], void 0];
        }
        const returnExplodedParameter = {};
        const converted = params.length > 0 ? [
          ...context.convertAll(params.slice(0, params.length - 1)),
          context.updateContext({
            tailPositionParameter: true,
            returnExplodedParameter
          }).convert(last(params))
        ] : [];
        return [converted, returnExplodedParameter.value];
      }
      convertFunctionCallArguments(args, context, parameterDeclarations) {
        if (!args) {
          return o_tree_1.NO_SYNTAX;
        }
        const converted = context.convertWithModifier(args, (ctx, _arg, index) => {
          const decl = parameterDeclarations === null || parameterDeclarations === void 0 ? void 0 : parameterDeclarations[Math.min(index, parameterDeclarations.length - 1)];
          const variadicArgument = (decl === null || decl === void 0 ? void 0 : decl.dotDotDotToken) != null;
          const tailPositionArgument = index >= args.length - 1;
          return ctx.updateContext({ variadicArgument, tailPositionArgument });
        });
        return new o_tree_1.OTree([], converted, { separator: ", ", indent: 4 });
      }
      renderType(owningNode, type, renderer, fallback) {
        return doRender(jsii_types_1.determineJsiiType(renderer.typeChecker, type));
        function doRender(jsiiType) {
          switch (jsiiType.kind) {
            case "unknown":
              return fallback;
            case "error":
              renderer.report(owningNode, jsiiType.message);
              return fallback;
            case "map":
              return `dictionary of string to ${doRender(jsiiType.elementType)}`;
            case "list":
              return `list of ${doRender(jsiiType.elementType)}`;
            case "namedType":
              return jsiiType.name;
            case "builtIn":
              switch (jsiiType.builtIn) {
                case "boolean":
                  return "boolean";
                case "number":
                  return "number";
                case "string":
                  return "string";
                case "any":
                  return "object";
                default:
                  return jsiiType.builtIn;
              }
          }
        }
      }
    };
    exports.PythonVisitor = PythonVisitor;
    function mangleIdentifier(originalIdentifier) {
      if (util_1.startsWithUppercase(originalIdentifier)) {
        return originalIdentifier;
      }
      const cased = originalIdentifier.replace(/[^A-Z][A-Z]/g, (m) => `${m[0].substr(0, 1)}_${m.substr(1).toLowerCase()}`);
      return IDENTIFIER_KEYWORDS.includes(cased) ? `${cased}_` : cased;
    }
    var BUILTIN_FUNCTIONS = {
      "console.log": "print",
      "console.error": "sys.stderr.write",
      "Math.random": "random.random"
    };
    var TOKEN_REWRITES = {
      this: "self",
      true: "True",
      false: "False"
    };
    var IDENTIFIER_KEYWORDS = ["lambda"];
    function last(xs) {
      return xs[xs.length - 1];
    }
  }
});

// node_modules/jsii-rosetta/lib/languages/index.js
var require_languages = __commonJS({
  "node_modules/jsii-rosetta/lib/languages/index.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.TARGET_LANGUAGES = exports.TargetLanguage = void 0;
    var csharp_1 = require_csharp();
    var java_1 = require_java();
    var python_1 = require_python();
    var target_language_1 = require_target_language();
    Object.defineProperty(exports, "TargetLanguage", { enumerable: true, get: function() {
      return target_language_1.TargetLanguage;
    } });
    exports.TARGET_LANGUAGES = {
      python: () => new python_1.PythonVisitor(),
      csharp: () => new csharp_1.CSharpVisitor(),
      java: () => new java_1.JavaVisitor()
    };
  }
});

// node_modules/jsii-rosetta/lib/logging.js
var require_logging = __commonJS({
  "node_modules/jsii-rosetta/lib/logging.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.debug = exports.info = exports.warn = exports.configure = exports.level = exports.LEVEL_VERBOSE = exports.LEVEL_INFO = exports.Level = void 0;
    var util = require("util");
    var Level;
    (function(Level2) {
      Level2[Level2["WARN"] = -1] = "WARN";
      Level2[Level2["QUIET"] = 0] = "QUIET";
      Level2[Level2["INFO"] = 1] = "INFO";
      Level2[Level2["VERBOSE"] = 2] = "VERBOSE";
    })(Level = exports.Level || (exports.Level = {}));
    exports.LEVEL_INFO = Level.INFO;
    exports.LEVEL_VERBOSE = Level.VERBOSE;
    exports.level = Level.QUIET;
    function configure({ level: newLevel }) {
      exports.level = newLevel;
    }
    exports.configure = configure;
    function warn(fmt, ...args) {
      log(Level.WARN, fmt, ...args);
    }
    exports.warn = warn;
    function info(fmt, ...args) {
      log(Level.INFO, fmt, ...args);
    }
    exports.info = info;
    function debug(fmt, ...args) {
      log(Level.VERBOSE, fmt, ...args);
    }
    exports.debug = debug;
    function log(messageLevel, fmt, ...args) {
      if (exports.level >= messageLevel) {
        const levelName = Level[messageLevel];
        process.stderr.write(`[jsii-rosetta] [${levelName}] ${util.format(fmt, ...args)}
`);
      }
    }
  }
});

// node_modules/jsii-rosetta/lib/snippet.js
var require_snippet = __commonJS({
  "node_modules/jsii-rosetta/lib/snippet.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.SnippetParameters = exports.parseKeyValueList = exports.completeSource = exports.updateParameters = exports.typeScriptSnippetFromSource = void 0;
    function typeScriptSnippetFromSource(typeScriptSource, where, strict, parameters = {}) {
      const [source, sourceParameters] = parametersFromSourceDirectives(typeScriptSource);
      return {
        visibleSource: source.trimRight(),
        where,
        parameters: Object.assign({}, parameters, sourceParameters),
        strict
      };
    }
    exports.typeScriptSnippetFromSource = typeScriptSnippetFromSource;
    function updateParameters(snippet, params) {
      var _a;
      return __spreadProps(__spreadValues({}, snippet), {
        parameters: Object.assign(Object.create(null), (_a = snippet.parameters) !== null && _a !== void 0 ? _a : {}, params)
      });
    }
    exports.updateParameters = updateParameters;
    function completeSource(snippet) {
      var _a;
      return (_a = snippet.completeSource) !== null && _a !== void 0 ? _a : snippet.visibleSource;
    }
    exports.completeSource = completeSource;
    function parametersFromSourceDirectives(source) {
      const [firstLine, ...rest] = source.split("\n");
      const m = /[/]{3}(.*)$/.exec(firstLine);
      if (m) {
        const paramClauses = m[1].trim().split(" ").map((s) => s.trim()).filter((s) => s !== "");
        return [rest.join("\n"), parseKeyValueList(paramClauses)];
      }
      return [source, {}];
    }
    function parseKeyValueList(parameters) {
      const ret = {};
      for (const param of parameters) {
        const parts = param.split("=", 2);
        if (parts.length === 2) {
          ret[parts[0]] = parts[1];
        } else {
          ret[parts[0]] = "";
        }
      }
      return ret;
    }
    exports.parseKeyValueList = parseKeyValueList;
    var SnippetParameters;
    (function(SnippetParameters2) {
      SnippetParameters2["FIXTURE"] = "fixture";
      SnippetParameters2["NO_FIXTURE"] = "nofixture";
      SnippetParameters2["LITERATE_SOURCE"] = "lit";
      SnippetParameters2["$PROJECT_DIRECTORY"] = "$directory";
      SnippetParameters2["$COMPILATION_DIRECTORY"] = "$compilation";
    })(SnippetParameters = exports.SnippetParameters || (exports.SnippetParameters = {}));
  }
});

// node_modules/jsii-rosetta/lib/tablets/key.js
var require_key = __commonJS({
  "node_modules/jsii-rosetta/lib/tablets/key.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.snippetKey = void 0;
    var crypto = require("crypto");
    function snippetKey(snippet) {
      const h = crypto.createHash("sha256");
      h.update(snippet.visibleSource);
      return h.digest("hex");
    }
    exports.snippetKey = snippetKey;
  }
});

// node_modules/jsii-rosetta/node_modules/universalify/index.js
var require_universalify2 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/universalify/index.js"(exports) {
    "use strict";
    exports.fromCallback = function(fn) {
      return Object.defineProperty(function(...args) {
        if (typeof args[args.length - 1] === "function")
          fn.apply(this, args);
        else {
          return new Promise((resolve, reject) => {
            fn.call(this, ...args, (err, res) => err != null ? reject(err) : resolve(res));
          });
        }
      }, "name", { value: fn.name });
    };
    exports.fromPromise = function(fn) {
      return Object.defineProperty(function(...args) {
        const cb = args[args.length - 1];
        if (typeof cb !== "function")
          return fn.apply(this, args);
        else
          fn.apply(this, args.slice(0, -1)).then((r) => cb(null, r), cb);
      }, "name", { value: fn.name });
    };
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/fs/index.js
var require_fs3 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/fs/index.js"(exports) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var fs2 = require_graceful_fs();
    var api = [
      "access",
      "appendFile",
      "chmod",
      "chown",
      "close",
      "copyFile",
      "fchmod",
      "fchown",
      "fdatasync",
      "fstat",
      "fsync",
      "ftruncate",
      "futimes",
      "lchmod",
      "lchown",
      "link",
      "lstat",
      "mkdir",
      "mkdtemp",
      "open",
      "opendir",
      "readdir",
      "readFile",
      "readlink",
      "realpath",
      "rename",
      "rm",
      "rmdir",
      "stat",
      "symlink",
      "truncate",
      "unlink",
      "utimes",
      "writeFile"
    ].filter((key) => {
      return typeof fs2[key] === "function";
    });
    Object.keys(fs2).forEach((key) => {
      if (key === "promises") {
        return;
      }
      exports[key] = fs2[key];
    });
    api.forEach((method) => {
      exports[method] = u(fs2[method]);
    });
    exports.exists = function(filename, callback) {
      if (typeof callback === "function") {
        return fs2.exists(filename, callback);
      }
      return new Promise((resolve) => {
        return fs2.exists(filename, resolve);
      });
    };
    exports.read = function(fd, buffer, offset, length, position, callback) {
      if (typeof callback === "function") {
        return fs2.read(fd, buffer, offset, length, position, callback);
      }
      return new Promise((resolve, reject) => {
        fs2.read(fd, buffer, offset, length, position, (err, bytesRead, buffer2) => {
          if (err)
            return reject(err);
          resolve({ bytesRead, buffer: buffer2 });
        });
      });
    };
    exports.write = function(fd, buffer, ...args) {
      if (typeof args[args.length - 1] === "function") {
        return fs2.write(fd, buffer, ...args);
      }
      return new Promise((resolve, reject) => {
        fs2.write(fd, buffer, ...args, (err, bytesWritten, buffer2) => {
          if (err)
            return reject(err);
          resolve({ bytesWritten, buffer: buffer2 });
        });
      });
    };
    if (typeof fs2.writev === "function") {
      exports.writev = function(fd, buffers, ...args) {
        if (typeof args[args.length - 1] === "function") {
          return fs2.writev(fd, buffers, ...args);
        }
        return new Promise((resolve, reject) => {
          fs2.writev(fd, buffers, ...args, (err, bytesWritten, buffers2) => {
            if (err)
              return reject(err);
            resolve({ bytesWritten, buffers: buffers2 });
          });
        });
      };
    }
    if (typeof fs2.realpath.native === "function") {
      exports.realpath.native = u(fs2.realpath.native);
    }
  }
});

// node_modules/at-least-node/index.js
var require_at_least_node = __commonJS({
  "node_modules/at-least-node/index.js"(exports, module2) {
    module2.exports = (r) => {
      const n = process.versions.node.split(".").map((x) => parseInt(x, 10));
      r = r.split(".").map((x) => parseInt(x, 10));
      return n[0] > r[0] || n[0] === r[0] && (n[1] > r[1] || n[1] === r[1] && n[2] >= r[2]);
    };
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/mkdirs/make-dir.js
var require_make_dir2 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/mkdirs/make-dir.js"(exports, module2) {
    "use strict";
    var fs2 = require_fs3();
    var path2 = require("path");
    var atLeastNode = require_at_least_node();
    var useNativeRecursiveOption = atLeastNode("10.12.0");
    var checkPath = (pth) => {
      if (process.platform === "win32") {
        const pathHasInvalidWinCharacters = /[<>:"|?*]/.test(pth.replace(path2.parse(pth).root, ""));
        if (pathHasInvalidWinCharacters) {
          const error = new Error(`Path contains invalid characters: ${pth}`);
          error.code = "EINVAL";
          throw error;
        }
      }
    };
    var processOptions = (options) => {
      const defaults = { mode: 511 };
      if (typeof options === "number")
        options = { mode: options };
      return __spreadValues(__spreadValues({}, defaults), options);
    };
    var permissionError = (pth) => {
      const error = new Error(`operation not permitted, mkdir '${pth}'`);
      error.code = "EPERM";
      error.errno = -4048;
      error.path = pth;
      error.syscall = "mkdir";
      return error;
    };
    module2.exports.makeDir = async (input, options) => {
      checkPath(input);
      options = processOptions(options);
      if (useNativeRecursiveOption) {
        const pth = path2.resolve(input);
        return fs2.mkdir(pth, {
          mode: options.mode,
          recursive: true
        });
      }
      const make = async (pth) => {
        try {
          await fs2.mkdir(pth, options.mode);
        } catch (error) {
          if (error.code === "EPERM") {
            throw error;
          }
          if (error.code === "ENOENT") {
            if (path2.dirname(pth) === pth) {
              throw permissionError(pth);
            }
            if (error.message.includes("null bytes")) {
              throw error;
            }
            await make(path2.dirname(pth));
            return make(pth);
          }
          try {
            const stats = await fs2.stat(pth);
            if (!stats.isDirectory()) {
              throw new Error("The path is not a directory");
            }
          } catch {
            throw error;
          }
        }
      };
      return make(path2.resolve(input));
    };
    module2.exports.makeDirSync = (input, options) => {
      checkPath(input);
      options = processOptions(options);
      if (useNativeRecursiveOption) {
        const pth = path2.resolve(input);
        return fs2.mkdirSync(pth, {
          mode: options.mode,
          recursive: true
        });
      }
      const make = (pth) => {
        try {
          fs2.mkdirSync(pth, options.mode);
        } catch (error) {
          if (error.code === "EPERM") {
            throw error;
          }
          if (error.code === "ENOENT") {
            if (path2.dirname(pth) === pth) {
              throw permissionError(pth);
            }
            if (error.message.includes("null bytes")) {
              throw error;
            }
            make(path2.dirname(pth));
            return make(pth);
          }
          try {
            if (!fs2.statSync(pth).isDirectory()) {
              throw new Error("The path is not a directory");
            }
          } catch {
            throw error;
          }
        }
      };
      return make(path2.resolve(input));
    };
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/mkdirs/index.js
var require_mkdirs2 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/mkdirs/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromPromise;
    var { makeDir: _makeDir, makeDirSync } = require_make_dir2();
    var makeDir = u(_makeDir);
    module2.exports = {
      mkdirs: makeDir,
      mkdirsSync: makeDirSync,
      mkdirp: makeDir,
      mkdirpSync: makeDirSync,
      ensureDir: makeDir,
      ensureDirSync: makeDirSync
    };
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/util/utimes.js
var require_utimes2 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/util/utimes.js"(exports, module2) {
    "use strict";
    var fs2 = require_graceful_fs();
    function utimesMillis(path2, atime, mtime, callback) {
      fs2.open(path2, "r+", (err, fd) => {
        if (err)
          return callback(err);
        fs2.futimes(fd, atime, mtime, (futimesErr) => {
          fs2.close(fd, (closeErr) => {
            if (callback)
              callback(futimesErr || closeErr);
          });
        });
      });
    }
    function utimesMillisSync(path2, atime, mtime) {
      const fd = fs2.openSync(path2, "r+");
      fs2.futimesSync(fd, atime, mtime);
      return fs2.closeSync(fd);
    }
    module2.exports = {
      utimesMillis,
      utimesMillisSync
    };
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/util/stat.js
var require_stat2 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/util/stat.js"(exports, module2) {
    "use strict";
    var fs2 = require_fs3();
    var path2 = require("path");
    var util = require("util");
    var atLeastNode = require_at_least_node();
    var nodeSupportsBigInt = atLeastNode("10.5.0");
    var stat = (file) => nodeSupportsBigInt ? fs2.stat(file, { bigint: true }) : fs2.stat(file);
    var statSync = (file) => nodeSupportsBigInt ? fs2.statSync(file, { bigint: true }) : fs2.statSync(file);
    function getStats(src, dest) {
      return Promise.all([
        stat(src),
        stat(dest).catch((err) => {
          if (err.code === "ENOENT")
            return null;
          throw err;
        })
      ]).then(([srcStat, destStat]) => ({ srcStat, destStat }));
    }
    function getStatsSync(src, dest) {
      let destStat;
      const srcStat = statSync(src);
      try {
        destStat = statSync(dest);
      } catch (err) {
        if (err.code === "ENOENT")
          return { srcStat, destStat: null };
        throw err;
      }
      return { srcStat, destStat };
    }
    function checkPaths(src, dest, funcName, cb) {
      util.callbackify(getStats)(src, dest, (err, stats) => {
        if (err)
          return cb(err);
        const { srcStat, destStat } = stats;
        if (destStat && areIdentical(srcStat, destStat)) {
          return cb(new Error("Source and destination must not be the same."));
        }
        if (srcStat.isDirectory() && isSrcSubdir(src, dest)) {
          return cb(new Error(errMsg(src, dest, funcName)));
        }
        return cb(null, { srcStat, destStat });
      });
    }
    function checkPathsSync(src, dest, funcName) {
      const { srcStat, destStat } = getStatsSync(src, dest);
      if (destStat && areIdentical(srcStat, destStat)) {
        throw new Error("Source and destination must not be the same.");
      }
      if (srcStat.isDirectory() && isSrcSubdir(src, dest)) {
        throw new Error(errMsg(src, dest, funcName));
      }
      return { srcStat, destStat };
    }
    function checkParentPaths(src, srcStat, dest, funcName, cb) {
      const srcParent = path2.resolve(path2.dirname(src));
      const destParent = path2.resolve(path2.dirname(dest));
      if (destParent === srcParent || destParent === path2.parse(destParent).root)
        return cb();
      const callback = (err, destStat) => {
        if (err) {
          if (err.code === "ENOENT")
            return cb();
          return cb(err);
        }
        if (areIdentical(srcStat, destStat)) {
          return cb(new Error(errMsg(src, dest, funcName)));
        }
        return checkParentPaths(src, srcStat, destParent, funcName, cb);
      };
      if (nodeSupportsBigInt)
        fs2.stat(destParent, { bigint: true }, callback);
      else
        fs2.stat(destParent, callback);
    }
    function checkParentPathsSync(src, srcStat, dest, funcName) {
      const srcParent = path2.resolve(path2.dirname(src));
      const destParent = path2.resolve(path2.dirname(dest));
      if (destParent === srcParent || destParent === path2.parse(destParent).root)
        return;
      let destStat;
      try {
        destStat = statSync(destParent);
      } catch (err) {
        if (err.code === "ENOENT")
          return;
        throw err;
      }
      if (areIdentical(srcStat, destStat)) {
        throw new Error(errMsg(src, dest, funcName));
      }
      return checkParentPathsSync(src, srcStat, destParent, funcName);
    }
    function areIdentical(srcStat, destStat) {
      if (destStat.ino && destStat.dev && destStat.ino === srcStat.ino && destStat.dev === srcStat.dev) {
        if (nodeSupportsBigInt || destStat.ino < Number.MAX_SAFE_INTEGER) {
          return true;
        }
        if (destStat.size === srcStat.size && destStat.mode === srcStat.mode && destStat.nlink === srcStat.nlink && destStat.atimeMs === srcStat.atimeMs && destStat.mtimeMs === srcStat.mtimeMs && destStat.ctimeMs === srcStat.ctimeMs && destStat.birthtimeMs === srcStat.birthtimeMs) {
          return true;
        }
      }
      return false;
    }
    function isSrcSubdir(src, dest) {
      const srcArr = path2.resolve(src).split(path2.sep).filter((i) => i);
      const destArr = path2.resolve(dest).split(path2.sep).filter((i) => i);
      return srcArr.reduce((acc, cur, i) => acc && destArr[i] === cur, true);
    }
    function errMsg(src, dest, funcName) {
      return `Cannot ${funcName} '${src}' to a subdirectory of itself, '${dest}'.`;
    }
    module2.exports = {
      checkPaths,
      checkPathsSync,
      checkParentPaths,
      checkParentPathsSync,
      isSrcSubdir
    };
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/copy-sync/copy-sync.js
var require_copy_sync3 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/copy-sync/copy-sync.js"(exports, module2) {
    "use strict";
    var fs2 = require_graceful_fs();
    var path2 = require("path");
    var mkdirsSync = require_mkdirs2().mkdirsSync;
    var utimesMillisSync = require_utimes2().utimesMillisSync;
    var stat = require_stat2();
    function copySync(src, dest, opts) {
      if (typeof opts === "function") {
        opts = { filter: opts };
      }
      opts = opts || {};
      opts.clobber = "clobber" in opts ? !!opts.clobber : true;
      opts.overwrite = "overwrite" in opts ? !!opts.overwrite : opts.clobber;
      if (opts.preserveTimestamps && process.arch === "ia32") {
        console.warn(`fs-extra: Using the preserveTimestamps option in 32-bit node is not recommended;

    see https://github.com/jprichardson/node-fs-extra/issues/269`);
      }
      const { srcStat, destStat } = stat.checkPathsSync(src, dest, "copy");
      stat.checkParentPathsSync(src, srcStat, dest, "copy");
      return handleFilterAndCopy(destStat, src, dest, opts);
    }
    function handleFilterAndCopy(destStat, src, dest, opts) {
      if (opts.filter && !opts.filter(src, dest))
        return;
      const destParent = path2.dirname(dest);
      if (!fs2.existsSync(destParent))
        mkdirsSync(destParent);
      return startCopy(destStat, src, dest, opts);
    }
    function startCopy(destStat, src, dest, opts) {
      if (opts.filter && !opts.filter(src, dest))
        return;
      return getStats(destStat, src, dest, opts);
    }
    function getStats(destStat, src, dest, opts) {
      const statSync = opts.dereference ? fs2.statSync : fs2.lstatSync;
      const srcStat = statSync(src);
      if (srcStat.isDirectory())
        return onDir(srcStat, destStat, src, dest, opts);
      else if (srcStat.isFile() || srcStat.isCharacterDevice() || srcStat.isBlockDevice())
        return onFile(srcStat, destStat, src, dest, opts);
      else if (srcStat.isSymbolicLink())
        return onLink(destStat, src, dest, opts);
    }
    function onFile(srcStat, destStat, src, dest, opts) {
      if (!destStat)
        return copyFile(srcStat, src, dest, opts);
      return mayCopyFile(srcStat, src, dest, opts);
    }
    function mayCopyFile(srcStat, src, dest, opts) {
      if (opts.overwrite) {
        fs2.unlinkSync(dest);
        return copyFile(srcStat, src, dest, opts);
      } else if (opts.errorOnExist) {
        throw new Error(`'${dest}' already exists`);
      }
    }
    function copyFile(srcStat, src, dest, opts) {
      fs2.copyFileSync(src, dest);
      if (opts.preserveTimestamps)
        handleTimestamps(srcStat.mode, src, dest);
      return setDestMode(dest, srcStat.mode);
    }
    function handleTimestamps(srcMode, src, dest) {
      if (fileIsNotWritable(srcMode))
        makeFileWritable(dest, srcMode);
      return setDestTimestamps(src, dest);
    }
    function fileIsNotWritable(srcMode) {
      return (srcMode & 128) === 0;
    }
    function makeFileWritable(dest, srcMode) {
      return setDestMode(dest, srcMode | 128);
    }
    function setDestMode(dest, srcMode) {
      return fs2.chmodSync(dest, srcMode);
    }
    function setDestTimestamps(src, dest) {
      const updatedSrcStat = fs2.statSync(src);
      return utimesMillisSync(dest, updatedSrcStat.atime, updatedSrcStat.mtime);
    }
    function onDir(srcStat, destStat, src, dest, opts) {
      if (!destStat)
        return mkDirAndCopy(srcStat.mode, src, dest, opts);
      if (destStat && !destStat.isDirectory()) {
        throw new Error(`Cannot overwrite non-directory '${dest}' with directory '${src}'.`);
      }
      return copyDir(src, dest, opts);
    }
    function mkDirAndCopy(srcMode, src, dest, opts) {
      fs2.mkdirSync(dest);
      copyDir(src, dest, opts);
      return setDestMode(dest, srcMode);
    }
    function copyDir(src, dest, opts) {
      fs2.readdirSync(src).forEach((item) => copyDirItem(item, src, dest, opts));
    }
    function copyDirItem(item, src, dest, opts) {
      const srcItem = path2.join(src, item);
      const destItem = path2.join(dest, item);
      const { destStat } = stat.checkPathsSync(srcItem, destItem, "copy");
      return startCopy(destStat, srcItem, destItem, opts);
    }
    function onLink(destStat, src, dest, opts) {
      let resolvedSrc = fs2.readlinkSync(src);
      if (opts.dereference) {
        resolvedSrc = path2.resolve(process.cwd(), resolvedSrc);
      }
      if (!destStat) {
        return fs2.symlinkSync(resolvedSrc, dest);
      } else {
        let resolvedDest;
        try {
          resolvedDest = fs2.readlinkSync(dest);
        } catch (err) {
          if (err.code === "EINVAL" || err.code === "UNKNOWN")
            return fs2.symlinkSync(resolvedSrc, dest);
          throw err;
        }
        if (opts.dereference) {
          resolvedDest = path2.resolve(process.cwd(), resolvedDest);
        }
        if (stat.isSrcSubdir(resolvedSrc, resolvedDest)) {
          throw new Error(`Cannot copy '${resolvedSrc}' to a subdirectory of itself, '${resolvedDest}'.`);
        }
        if (fs2.statSync(dest).isDirectory() && stat.isSrcSubdir(resolvedDest, resolvedSrc)) {
          throw new Error(`Cannot overwrite '${resolvedDest}' with '${resolvedSrc}'.`);
        }
        return copyLink(resolvedSrc, dest);
      }
    }
    function copyLink(resolvedSrc, dest) {
      fs2.unlinkSync(dest);
      return fs2.symlinkSync(resolvedSrc, dest);
    }
    module2.exports = copySync;
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/copy-sync/index.js
var require_copy_sync4 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/copy-sync/index.js"(exports, module2) {
    "use strict";
    module2.exports = {
      copySync: require_copy_sync3()
    };
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/path-exists/index.js
var require_path_exists2 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/path-exists/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromPromise;
    var fs2 = require_fs3();
    function pathExists(path2) {
      return fs2.access(path2).then(() => true).catch(() => false);
    }
    module2.exports = {
      pathExists: u(pathExists),
      pathExistsSync: fs2.existsSync
    };
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/copy/copy.js
var require_copy3 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/copy/copy.js"(exports, module2) {
    "use strict";
    var fs2 = require_graceful_fs();
    var path2 = require("path");
    var mkdirs = require_mkdirs2().mkdirs;
    var pathExists = require_path_exists2().pathExists;
    var utimesMillis = require_utimes2().utimesMillis;
    var stat = require_stat2();
    function copy(src, dest, opts, cb) {
      if (typeof opts === "function" && !cb) {
        cb = opts;
        opts = {};
      } else if (typeof opts === "function") {
        opts = { filter: opts };
      }
      cb = cb || function() {
      };
      opts = opts || {};
      opts.clobber = "clobber" in opts ? !!opts.clobber : true;
      opts.overwrite = "overwrite" in opts ? !!opts.overwrite : opts.clobber;
      if (opts.preserveTimestamps && process.arch === "ia32") {
        console.warn(`fs-extra: Using the preserveTimestamps option in 32-bit node is not recommended;

    see https://github.com/jprichardson/node-fs-extra/issues/269`);
      }
      stat.checkPaths(src, dest, "copy", (err, stats) => {
        if (err)
          return cb(err);
        const { srcStat, destStat } = stats;
        stat.checkParentPaths(src, srcStat, dest, "copy", (err2) => {
          if (err2)
            return cb(err2);
          if (opts.filter)
            return handleFilter(checkParentDir, destStat, src, dest, opts, cb);
          return checkParentDir(destStat, src, dest, opts, cb);
        });
      });
    }
    function checkParentDir(destStat, src, dest, opts, cb) {
      const destParent = path2.dirname(dest);
      pathExists(destParent, (err, dirExists) => {
        if (err)
          return cb(err);
        if (dirExists)
          return startCopy(destStat, src, dest, opts, cb);
        mkdirs(destParent, (err2) => {
          if (err2)
            return cb(err2);
          return startCopy(destStat, src, dest, opts, cb);
        });
      });
    }
    function handleFilter(onInclude, destStat, src, dest, opts, cb) {
      Promise.resolve(opts.filter(src, dest)).then((include) => {
        if (include)
          return onInclude(destStat, src, dest, opts, cb);
        return cb();
      }, (error) => cb(error));
    }
    function startCopy(destStat, src, dest, opts, cb) {
      if (opts.filter)
        return handleFilter(getStats, destStat, src, dest, opts, cb);
      return getStats(destStat, src, dest, opts, cb);
    }
    function getStats(destStat, src, dest, opts, cb) {
      const stat2 = opts.dereference ? fs2.stat : fs2.lstat;
      stat2(src, (err, srcStat) => {
        if (err)
          return cb(err);
        if (srcStat.isDirectory())
          return onDir(srcStat, destStat, src, dest, opts, cb);
        else if (srcStat.isFile() || srcStat.isCharacterDevice() || srcStat.isBlockDevice())
          return onFile(srcStat, destStat, src, dest, opts, cb);
        else if (srcStat.isSymbolicLink())
          return onLink(destStat, src, dest, opts, cb);
      });
    }
    function onFile(srcStat, destStat, src, dest, opts, cb) {
      if (!destStat)
        return copyFile(srcStat, src, dest, opts, cb);
      return mayCopyFile(srcStat, src, dest, opts, cb);
    }
    function mayCopyFile(srcStat, src, dest, opts, cb) {
      if (opts.overwrite) {
        fs2.unlink(dest, (err) => {
          if (err)
            return cb(err);
          return copyFile(srcStat, src, dest, opts, cb);
        });
      } else if (opts.errorOnExist) {
        return cb(new Error(`'${dest}' already exists`));
      } else
        return cb();
    }
    function copyFile(srcStat, src, dest, opts, cb) {
      fs2.copyFile(src, dest, (err) => {
        if (err)
          return cb(err);
        if (opts.preserveTimestamps)
          return handleTimestampsAndMode(srcStat.mode, src, dest, cb);
        return setDestMode(dest, srcStat.mode, cb);
      });
    }
    function handleTimestampsAndMode(srcMode, src, dest, cb) {
      if (fileIsNotWritable(srcMode)) {
        return makeFileWritable(dest, srcMode, (err) => {
          if (err)
            return cb(err);
          return setDestTimestampsAndMode(srcMode, src, dest, cb);
        });
      }
      return setDestTimestampsAndMode(srcMode, src, dest, cb);
    }
    function fileIsNotWritable(srcMode) {
      return (srcMode & 128) === 0;
    }
    function makeFileWritable(dest, srcMode, cb) {
      return setDestMode(dest, srcMode | 128, cb);
    }
    function setDestTimestampsAndMode(srcMode, src, dest, cb) {
      setDestTimestamps(src, dest, (err) => {
        if (err)
          return cb(err);
        return setDestMode(dest, srcMode, cb);
      });
    }
    function setDestMode(dest, srcMode, cb) {
      return fs2.chmod(dest, srcMode, cb);
    }
    function setDestTimestamps(src, dest, cb) {
      fs2.stat(src, (err, updatedSrcStat) => {
        if (err)
          return cb(err);
        return utimesMillis(dest, updatedSrcStat.atime, updatedSrcStat.mtime, cb);
      });
    }
    function onDir(srcStat, destStat, src, dest, opts, cb) {
      if (!destStat)
        return mkDirAndCopy(srcStat.mode, src, dest, opts, cb);
      if (destStat && !destStat.isDirectory()) {
        return cb(new Error(`Cannot overwrite non-directory '${dest}' with directory '${src}'.`));
      }
      return copyDir(src, dest, opts, cb);
    }
    function mkDirAndCopy(srcMode, src, dest, opts, cb) {
      fs2.mkdir(dest, (err) => {
        if (err)
          return cb(err);
        copyDir(src, dest, opts, (err2) => {
          if (err2)
            return cb(err2);
          return setDestMode(dest, srcMode, cb);
        });
      });
    }
    function copyDir(src, dest, opts, cb) {
      fs2.readdir(src, (err, items) => {
        if (err)
          return cb(err);
        return copyDirItems(items, src, dest, opts, cb);
      });
    }
    function copyDirItems(items, src, dest, opts, cb) {
      const item = items.pop();
      if (!item)
        return cb();
      return copyDirItem(items, item, src, dest, opts, cb);
    }
    function copyDirItem(items, item, src, dest, opts, cb) {
      const srcItem = path2.join(src, item);
      const destItem = path2.join(dest, item);
      stat.checkPaths(srcItem, destItem, "copy", (err, stats) => {
        if (err)
          return cb(err);
        const { destStat } = stats;
        startCopy(destStat, srcItem, destItem, opts, (err2) => {
          if (err2)
            return cb(err2);
          return copyDirItems(items, src, dest, opts, cb);
        });
      });
    }
    function onLink(destStat, src, dest, opts, cb) {
      fs2.readlink(src, (err, resolvedSrc) => {
        if (err)
          return cb(err);
        if (opts.dereference) {
          resolvedSrc = path2.resolve(process.cwd(), resolvedSrc);
        }
        if (!destStat) {
          return fs2.symlink(resolvedSrc, dest, cb);
        } else {
          fs2.readlink(dest, (err2, resolvedDest) => {
            if (err2) {
              if (err2.code === "EINVAL" || err2.code === "UNKNOWN")
                return fs2.symlink(resolvedSrc, dest, cb);
              return cb(err2);
            }
            if (opts.dereference) {
              resolvedDest = path2.resolve(process.cwd(), resolvedDest);
            }
            if (stat.isSrcSubdir(resolvedSrc, resolvedDest)) {
              return cb(new Error(`Cannot copy '${resolvedSrc}' to a subdirectory of itself, '${resolvedDest}'.`));
            }
            if (destStat.isDirectory() && stat.isSrcSubdir(resolvedDest, resolvedSrc)) {
              return cb(new Error(`Cannot overwrite '${resolvedDest}' with '${resolvedSrc}'.`));
            }
            return copyLink(resolvedSrc, dest, cb);
          });
        }
      });
    }
    function copyLink(resolvedSrc, dest, cb) {
      fs2.unlink(dest, (err) => {
        if (err)
          return cb(err);
        return fs2.symlink(resolvedSrc, dest, cb);
      });
    }
    module2.exports = copy;
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/copy/index.js
var require_copy4 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/copy/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    module2.exports = {
      copy: u(require_copy3())
    };
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/remove/rimraf.js
var require_rimraf2 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/remove/rimraf.js"(exports, module2) {
    "use strict";
    var fs2 = require_graceful_fs();
    var path2 = require("path");
    var assert = require("assert");
    var isWindows = process.platform === "win32";
    function defaults(options) {
      const methods = [
        "unlink",
        "chmod",
        "stat",
        "lstat",
        "rmdir",
        "readdir"
      ];
      methods.forEach((m) => {
        options[m] = options[m] || fs2[m];
        m = m + "Sync";
        options[m] = options[m] || fs2[m];
      });
      options.maxBusyTries = options.maxBusyTries || 3;
    }
    function rimraf(p, options, cb) {
      let busyTries = 0;
      if (typeof options === "function") {
        cb = options;
        options = {};
      }
      assert(p, "rimraf: missing path");
      assert.strictEqual(typeof p, "string", "rimraf: path should be a string");
      assert.strictEqual(typeof cb, "function", "rimraf: callback function required");
      assert(options, "rimraf: invalid options argument provided");
      assert.strictEqual(typeof options, "object", "rimraf: options should be object");
      defaults(options);
      rimraf_(p, options, function CB(er) {
        if (er) {
          if ((er.code === "EBUSY" || er.code === "ENOTEMPTY" || er.code === "EPERM") && busyTries < options.maxBusyTries) {
            busyTries++;
            const time = busyTries * 100;
            return setTimeout(() => rimraf_(p, options, CB), time);
          }
          if (er.code === "ENOENT")
            er = null;
        }
        cb(er);
      });
    }
    function rimraf_(p, options, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.lstat(p, (er, st) => {
        if (er && er.code === "ENOENT") {
          return cb(null);
        }
        if (er && er.code === "EPERM" && isWindows) {
          return fixWinEPERM(p, options, er, cb);
        }
        if (st && st.isDirectory()) {
          return rmdir(p, options, er, cb);
        }
        options.unlink(p, (er2) => {
          if (er2) {
            if (er2.code === "ENOENT") {
              return cb(null);
            }
            if (er2.code === "EPERM") {
              return isWindows ? fixWinEPERM(p, options, er2, cb) : rmdir(p, options, er2, cb);
            }
            if (er2.code === "EISDIR") {
              return rmdir(p, options, er2, cb);
            }
          }
          return cb(er2);
        });
      });
    }
    function fixWinEPERM(p, options, er, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.chmod(p, 438, (er2) => {
        if (er2) {
          cb(er2.code === "ENOENT" ? null : er);
        } else {
          options.stat(p, (er3, stats) => {
            if (er3) {
              cb(er3.code === "ENOENT" ? null : er);
            } else if (stats.isDirectory()) {
              rmdir(p, options, er, cb);
            } else {
              options.unlink(p, cb);
            }
          });
        }
      });
    }
    function fixWinEPERMSync(p, options, er) {
      let stats;
      assert(p);
      assert(options);
      try {
        options.chmodSync(p, 438);
      } catch (er2) {
        if (er2.code === "ENOENT") {
          return;
        } else {
          throw er;
        }
      }
      try {
        stats = options.statSync(p);
      } catch (er3) {
        if (er3.code === "ENOENT") {
          return;
        } else {
          throw er;
        }
      }
      if (stats.isDirectory()) {
        rmdirSync(p, options, er);
      } else {
        options.unlinkSync(p);
      }
    }
    function rmdir(p, options, originalEr, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.rmdir(p, (er) => {
        if (er && (er.code === "ENOTEMPTY" || er.code === "EEXIST" || er.code === "EPERM")) {
          rmkids(p, options, cb);
        } else if (er && er.code === "ENOTDIR") {
          cb(originalEr);
        } else {
          cb(er);
        }
      });
    }
    function rmkids(p, options, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.readdir(p, (er, files) => {
        if (er)
          return cb(er);
        let n = files.length;
        let errState;
        if (n === 0)
          return options.rmdir(p, cb);
        files.forEach((f) => {
          rimraf(path2.join(p, f), options, (er2) => {
            if (errState) {
              return;
            }
            if (er2)
              return cb(errState = er2);
            if (--n === 0) {
              options.rmdir(p, cb);
            }
          });
        });
      });
    }
    function rimrafSync(p, options) {
      let st;
      options = options || {};
      defaults(options);
      assert(p, "rimraf: missing path");
      assert.strictEqual(typeof p, "string", "rimraf: path should be a string");
      assert(options, "rimraf: missing options");
      assert.strictEqual(typeof options, "object", "rimraf: options should be object");
      try {
        st = options.lstatSync(p);
      } catch (er) {
        if (er.code === "ENOENT") {
          return;
        }
        if (er.code === "EPERM" && isWindows) {
          fixWinEPERMSync(p, options, er);
        }
      }
      try {
        if (st && st.isDirectory()) {
          rmdirSync(p, options, null);
        } else {
          options.unlinkSync(p);
        }
      } catch (er) {
        if (er.code === "ENOENT") {
          return;
        } else if (er.code === "EPERM") {
          return isWindows ? fixWinEPERMSync(p, options, er) : rmdirSync(p, options, er);
        } else if (er.code !== "EISDIR") {
          throw er;
        }
        rmdirSync(p, options, er);
      }
    }
    function rmdirSync(p, options, originalEr) {
      assert(p);
      assert(options);
      try {
        options.rmdirSync(p);
      } catch (er) {
        if (er.code === "ENOTDIR") {
          throw originalEr;
        } else if (er.code === "ENOTEMPTY" || er.code === "EEXIST" || er.code === "EPERM") {
          rmkidsSync(p, options);
        } else if (er.code !== "ENOENT") {
          throw er;
        }
      }
    }
    function rmkidsSync(p, options) {
      assert(p);
      assert(options);
      options.readdirSync(p).forEach((f) => rimrafSync(path2.join(p, f), options));
      if (isWindows) {
        const startTime = Date.now();
        do {
          try {
            const ret = options.rmdirSync(p, options);
            return ret;
          } catch {
          }
        } while (Date.now() - startTime < 500);
      } else {
        const ret = options.rmdirSync(p, options);
        return ret;
      }
    }
    module2.exports = rimraf;
    rimraf.sync = rimrafSync;
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/remove/index.js
var require_remove2 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/remove/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var rimraf = require_rimraf2();
    module2.exports = {
      remove: u(rimraf),
      removeSync: rimraf.sync
    };
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/empty/index.js
var require_empty2 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/empty/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var fs2 = require_graceful_fs();
    var path2 = require("path");
    var mkdir = require_mkdirs2();
    var remove2 = require_remove2();
    var emptyDir = u(function emptyDir2(dir, callback) {
      callback = callback || function() {
      };
      fs2.readdir(dir, (err, items) => {
        if (err)
          return mkdir.mkdirs(dir, callback);
        items = items.map((item) => path2.join(dir, item));
        deleteItem();
        function deleteItem() {
          const item = items.pop();
          if (!item)
            return callback();
          remove2.remove(item, (err2) => {
            if (err2)
              return callback(err2);
            deleteItem();
          });
        }
      });
    });
    function emptyDirSync(dir) {
      let items;
      try {
        items = fs2.readdirSync(dir);
      } catch {
        return mkdir.mkdirsSync(dir);
      }
      items.forEach((item) => {
        item = path2.join(dir, item);
        remove2.removeSync(item);
      });
    }
    module2.exports = {
      emptyDirSync,
      emptydirSync: emptyDirSync,
      emptyDir,
      emptydir: emptyDir
    };
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/ensure/file.js
var require_file2 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/ensure/file.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var path2 = require("path");
    var fs2 = require_graceful_fs();
    var mkdir = require_mkdirs2();
    function createFile(file, callback) {
      function makeFile() {
        fs2.writeFile(file, "", (err) => {
          if (err)
            return callback(err);
          callback();
        });
      }
      fs2.stat(file, (err, stats) => {
        if (!err && stats.isFile())
          return callback();
        const dir = path2.dirname(file);
        fs2.stat(dir, (err2, stats2) => {
          if (err2) {
            if (err2.code === "ENOENT") {
              return mkdir.mkdirs(dir, (err3) => {
                if (err3)
                  return callback(err3);
                makeFile();
              });
            }
            return callback(err2);
          }
          if (stats2.isDirectory())
            makeFile();
          else {
            fs2.readdir(dir, (err3) => {
              if (err3)
                return callback(err3);
            });
          }
        });
      });
    }
    function createFileSync(file) {
      let stats;
      try {
        stats = fs2.statSync(file);
      } catch {
      }
      if (stats && stats.isFile())
        return;
      const dir = path2.dirname(file);
      try {
        if (!fs2.statSync(dir).isDirectory()) {
          fs2.readdirSync(dir);
        }
      } catch (err) {
        if (err && err.code === "ENOENT")
          mkdir.mkdirsSync(dir);
        else
          throw err;
      }
      fs2.writeFileSync(file, "");
    }
    module2.exports = {
      createFile: u(createFile),
      createFileSync
    };
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/ensure/link.js
var require_link2 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/ensure/link.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var path2 = require("path");
    var fs2 = require_graceful_fs();
    var mkdir = require_mkdirs2();
    var pathExists = require_path_exists2().pathExists;
    function createLink(srcpath, dstpath, callback) {
      function makeLink(srcpath2, dstpath2) {
        fs2.link(srcpath2, dstpath2, (err) => {
          if (err)
            return callback(err);
          callback(null);
        });
      }
      pathExists(dstpath, (err, destinationExists) => {
        if (err)
          return callback(err);
        if (destinationExists)
          return callback(null);
        fs2.lstat(srcpath, (err2) => {
          if (err2) {
            err2.message = err2.message.replace("lstat", "ensureLink");
            return callback(err2);
          }
          const dir = path2.dirname(dstpath);
          pathExists(dir, (err3, dirExists) => {
            if (err3)
              return callback(err3);
            if (dirExists)
              return makeLink(srcpath, dstpath);
            mkdir.mkdirs(dir, (err4) => {
              if (err4)
                return callback(err4);
              makeLink(srcpath, dstpath);
            });
          });
        });
      });
    }
    function createLinkSync(srcpath, dstpath) {
      const destinationExists = fs2.existsSync(dstpath);
      if (destinationExists)
        return void 0;
      try {
        fs2.lstatSync(srcpath);
      } catch (err) {
        err.message = err.message.replace("lstat", "ensureLink");
        throw err;
      }
      const dir = path2.dirname(dstpath);
      const dirExists = fs2.existsSync(dir);
      if (dirExists)
        return fs2.linkSync(srcpath, dstpath);
      mkdir.mkdirsSync(dir);
      return fs2.linkSync(srcpath, dstpath);
    }
    module2.exports = {
      createLink: u(createLink),
      createLinkSync
    };
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/ensure/symlink-paths.js
var require_symlink_paths2 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/ensure/symlink-paths.js"(exports, module2) {
    "use strict";
    var path2 = require("path");
    var fs2 = require_graceful_fs();
    var pathExists = require_path_exists2().pathExists;
    function symlinkPaths(srcpath, dstpath, callback) {
      if (path2.isAbsolute(srcpath)) {
        return fs2.lstat(srcpath, (err) => {
          if (err) {
            err.message = err.message.replace("lstat", "ensureSymlink");
            return callback(err);
          }
          return callback(null, {
            toCwd: srcpath,
            toDst: srcpath
          });
        });
      } else {
        const dstdir = path2.dirname(dstpath);
        const relativeToDst = path2.join(dstdir, srcpath);
        return pathExists(relativeToDst, (err, exists) => {
          if (err)
            return callback(err);
          if (exists) {
            return callback(null, {
              toCwd: relativeToDst,
              toDst: srcpath
            });
          } else {
            return fs2.lstat(srcpath, (err2) => {
              if (err2) {
                err2.message = err2.message.replace("lstat", "ensureSymlink");
                return callback(err2);
              }
              return callback(null, {
                toCwd: srcpath,
                toDst: path2.relative(dstdir, srcpath)
              });
            });
          }
        });
      }
    }
    function symlinkPathsSync(srcpath, dstpath) {
      let exists;
      if (path2.isAbsolute(srcpath)) {
        exists = fs2.existsSync(srcpath);
        if (!exists)
          throw new Error("absolute srcpath does not exist");
        return {
          toCwd: srcpath,
          toDst: srcpath
        };
      } else {
        const dstdir = path2.dirname(dstpath);
        const relativeToDst = path2.join(dstdir, srcpath);
        exists = fs2.existsSync(relativeToDst);
        if (exists) {
          return {
            toCwd: relativeToDst,
            toDst: srcpath
          };
        } else {
          exists = fs2.existsSync(srcpath);
          if (!exists)
            throw new Error("relative srcpath does not exist");
          return {
            toCwd: srcpath,
            toDst: path2.relative(dstdir, srcpath)
          };
        }
      }
    }
    module2.exports = {
      symlinkPaths,
      symlinkPathsSync
    };
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/ensure/symlink-type.js
var require_symlink_type2 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/ensure/symlink-type.js"(exports, module2) {
    "use strict";
    var fs2 = require_graceful_fs();
    function symlinkType(srcpath, type, callback) {
      callback = typeof type === "function" ? type : callback;
      type = typeof type === "function" ? false : type;
      if (type)
        return callback(null, type);
      fs2.lstat(srcpath, (err, stats) => {
        if (err)
          return callback(null, "file");
        type = stats && stats.isDirectory() ? "dir" : "file";
        callback(null, type);
      });
    }
    function symlinkTypeSync(srcpath, type) {
      let stats;
      if (type)
        return type;
      try {
        stats = fs2.lstatSync(srcpath);
      } catch {
        return "file";
      }
      return stats && stats.isDirectory() ? "dir" : "file";
    }
    module2.exports = {
      symlinkType,
      symlinkTypeSync
    };
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/ensure/symlink.js
var require_symlink2 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/ensure/symlink.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var path2 = require("path");
    var fs2 = require_graceful_fs();
    var _mkdirs = require_mkdirs2();
    var mkdirs = _mkdirs.mkdirs;
    var mkdirsSync = _mkdirs.mkdirsSync;
    var _symlinkPaths = require_symlink_paths2();
    var symlinkPaths = _symlinkPaths.symlinkPaths;
    var symlinkPathsSync = _symlinkPaths.symlinkPathsSync;
    var _symlinkType = require_symlink_type2();
    var symlinkType = _symlinkType.symlinkType;
    var symlinkTypeSync = _symlinkType.symlinkTypeSync;
    var pathExists = require_path_exists2().pathExists;
    function createSymlink(srcpath, dstpath, type, callback) {
      callback = typeof type === "function" ? type : callback;
      type = typeof type === "function" ? false : type;
      pathExists(dstpath, (err, destinationExists) => {
        if (err)
          return callback(err);
        if (destinationExists)
          return callback(null);
        symlinkPaths(srcpath, dstpath, (err2, relative) => {
          if (err2)
            return callback(err2);
          srcpath = relative.toDst;
          symlinkType(relative.toCwd, type, (err3, type2) => {
            if (err3)
              return callback(err3);
            const dir = path2.dirname(dstpath);
            pathExists(dir, (err4, dirExists) => {
              if (err4)
                return callback(err4);
              if (dirExists)
                return fs2.symlink(srcpath, dstpath, type2, callback);
              mkdirs(dir, (err5) => {
                if (err5)
                  return callback(err5);
                fs2.symlink(srcpath, dstpath, type2, callback);
              });
            });
          });
        });
      });
    }
    function createSymlinkSync(srcpath, dstpath, type) {
      const destinationExists = fs2.existsSync(dstpath);
      if (destinationExists)
        return void 0;
      const relative = symlinkPathsSync(srcpath, dstpath);
      srcpath = relative.toDst;
      type = symlinkTypeSync(relative.toCwd, type);
      const dir = path2.dirname(dstpath);
      const exists = fs2.existsSync(dir);
      if (exists)
        return fs2.symlinkSync(srcpath, dstpath, type);
      mkdirsSync(dir);
      return fs2.symlinkSync(srcpath, dstpath, type);
    }
    module2.exports = {
      createSymlink: u(createSymlink),
      createSymlinkSync
    };
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/ensure/index.js
var require_ensure2 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/ensure/index.js"(exports, module2) {
    "use strict";
    var file = require_file2();
    var link = require_link2();
    var symlink = require_symlink2();
    module2.exports = {
      createFile: file.createFile,
      createFileSync: file.createFileSync,
      ensureFile: file.createFile,
      ensureFileSync: file.createFileSync,
      createLink: link.createLink,
      createLinkSync: link.createLinkSync,
      ensureLink: link.createLink,
      ensureLinkSync: link.createLinkSync,
      createSymlink: symlink.createSymlink,
      createSymlinkSync: symlink.createSymlinkSync,
      ensureSymlink: symlink.createSymlink,
      ensureSymlinkSync: symlink.createSymlinkSync
    };
  }
});

// node_modules/jsii-rosetta/node_modules/jsonfile/utils.js
var require_utils3 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/jsonfile/utils.js"(exports, module2) {
    function stringify(obj, { EOL = "\n", finalEOL = true, replacer = null, spaces } = {}) {
      const EOF = finalEOL ? EOL : "";
      const str = JSON.stringify(obj, replacer, spaces);
      return str.replace(/\n/g, EOL) + EOF;
    }
    function stripBom(content) {
      if (Buffer.isBuffer(content))
        content = content.toString("utf8");
      return content.replace(/^\uFEFF/, "");
    }
    module2.exports = { stringify, stripBom };
  }
});

// node_modules/jsii-rosetta/node_modules/jsonfile/index.js
var require_jsonfile3 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/jsonfile/index.js"(exports, module2) {
    var _fs;
    try {
      _fs = require_graceful_fs();
    } catch (_) {
      _fs = require("fs");
    }
    var universalify = require_universalify2();
    var { stringify, stripBom } = require_utils3();
    async function _readFile(file, options = {}) {
      if (typeof options === "string") {
        options = { encoding: options };
      }
      const fs2 = options.fs || _fs;
      const shouldThrow = "throws" in options ? options.throws : true;
      let data = await universalify.fromCallback(fs2.readFile)(file, options);
      data = stripBom(data);
      let obj;
      try {
        obj = JSON.parse(data, options ? options.reviver : null);
      } catch (err) {
        if (shouldThrow) {
          err.message = `${file}: ${err.message}`;
          throw err;
        } else {
          return null;
        }
      }
      return obj;
    }
    var readFile = universalify.fromPromise(_readFile);
    function readFileSync(file, options = {}) {
      if (typeof options === "string") {
        options = { encoding: options };
      }
      const fs2 = options.fs || _fs;
      const shouldThrow = "throws" in options ? options.throws : true;
      try {
        let content = fs2.readFileSync(file, options);
        content = stripBom(content);
        return JSON.parse(content, options.reviver);
      } catch (err) {
        if (shouldThrow) {
          err.message = `${file}: ${err.message}`;
          throw err;
        } else {
          return null;
        }
      }
    }
    async function _writeFile(file, obj, options = {}) {
      const fs2 = options.fs || _fs;
      const str = stringify(obj, options);
      await universalify.fromCallback(fs2.writeFile)(file, str, options);
    }
    var writeFile = universalify.fromPromise(_writeFile);
    function writeFileSync(file, obj, options = {}) {
      const fs2 = options.fs || _fs;
      const str = stringify(obj, options);
      return fs2.writeFileSync(file, str, options);
    }
    var jsonfile = {
      readFile,
      readFileSync,
      writeFile,
      writeFileSync
    };
    module2.exports = jsonfile;
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/json/jsonfile.js
var require_jsonfile4 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/json/jsonfile.js"(exports, module2) {
    "use strict";
    var jsonFile = require_jsonfile3();
    module2.exports = {
      readJson: jsonFile.readFile,
      readJsonSync: jsonFile.readFileSync,
      writeJson: jsonFile.writeFile,
      writeJsonSync: jsonFile.writeFileSync
    };
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/output/index.js
var require_output2 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/output/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var fs2 = require_graceful_fs();
    var path2 = require("path");
    var mkdir = require_mkdirs2();
    var pathExists = require_path_exists2().pathExists;
    function outputFile(file, data, encoding, callback) {
      if (typeof encoding === "function") {
        callback = encoding;
        encoding = "utf8";
      }
      const dir = path2.dirname(file);
      pathExists(dir, (err, itDoes) => {
        if (err)
          return callback(err);
        if (itDoes)
          return fs2.writeFile(file, data, encoding, callback);
        mkdir.mkdirs(dir, (err2) => {
          if (err2)
            return callback(err2);
          fs2.writeFile(file, data, encoding, callback);
        });
      });
    }
    function outputFileSync(file, ...args) {
      const dir = path2.dirname(file);
      if (fs2.existsSync(dir)) {
        return fs2.writeFileSync(file, ...args);
      }
      mkdir.mkdirsSync(dir);
      fs2.writeFileSync(file, ...args);
    }
    module2.exports = {
      outputFile: u(outputFile),
      outputFileSync
    };
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/json/output-json.js
var require_output_json2 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/json/output-json.js"(exports, module2) {
    "use strict";
    var { stringify } = require_utils3();
    var { outputFile } = require_output2();
    async function outputJson(file, data, options = {}) {
      const str = stringify(data, options);
      await outputFile(file, str, options);
    }
    module2.exports = outputJson;
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/json/output-json-sync.js
var require_output_json_sync2 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/json/output-json-sync.js"(exports, module2) {
    "use strict";
    var { stringify } = require_utils3();
    var { outputFileSync } = require_output2();
    function outputJsonSync(file, data, options) {
      const str = stringify(data, options);
      outputFileSync(file, str, options);
    }
    module2.exports = outputJsonSync;
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/json/index.js
var require_json2 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/json/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromPromise;
    var jsonFile = require_jsonfile4();
    jsonFile.outputJson = u(require_output_json2());
    jsonFile.outputJsonSync = require_output_json_sync2();
    jsonFile.outputJSON = jsonFile.outputJson;
    jsonFile.outputJSONSync = jsonFile.outputJsonSync;
    jsonFile.writeJSON = jsonFile.writeJson;
    jsonFile.writeJSONSync = jsonFile.writeJsonSync;
    jsonFile.readJSON = jsonFile.readJson;
    jsonFile.readJSONSync = jsonFile.readJsonSync;
    module2.exports = jsonFile;
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/move-sync/move-sync.js
var require_move_sync3 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/move-sync/move-sync.js"(exports, module2) {
    "use strict";
    var fs2 = require_graceful_fs();
    var path2 = require("path");
    var copySync = require_copy_sync4().copySync;
    var removeSync = require_remove2().removeSync;
    var mkdirpSync = require_mkdirs2().mkdirpSync;
    var stat = require_stat2();
    function moveSync(src, dest, opts) {
      opts = opts || {};
      const overwrite = opts.overwrite || opts.clobber || false;
      const { srcStat } = stat.checkPathsSync(src, dest, "move");
      stat.checkParentPathsSync(src, srcStat, dest, "move");
      mkdirpSync(path2.dirname(dest));
      return doRename(src, dest, overwrite);
    }
    function doRename(src, dest, overwrite) {
      if (overwrite) {
        removeSync(dest);
        return rename(src, dest, overwrite);
      }
      if (fs2.existsSync(dest))
        throw new Error("dest already exists.");
      return rename(src, dest, overwrite);
    }
    function rename(src, dest, overwrite) {
      try {
        fs2.renameSync(src, dest);
      } catch (err) {
        if (err.code !== "EXDEV")
          throw err;
        return moveAcrossDevice(src, dest, overwrite);
      }
    }
    function moveAcrossDevice(src, dest, overwrite) {
      const opts = {
        overwrite,
        errorOnExist: true
      };
      copySync(src, dest, opts);
      return removeSync(src);
    }
    module2.exports = moveSync;
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/move-sync/index.js
var require_move_sync4 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/move-sync/index.js"(exports, module2) {
    "use strict";
    module2.exports = {
      moveSync: require_move_sync3()
    };
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/move/move.js
var require_move3 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/move/move.js"(exports, module2) {
    "use strict";
    var fs2 = require_graceful_fs();
    var path2 = require("path");
    var copy = require_copy4().copy;
    var remove2 = require_remove2().remove;
    var mkdirp2 = require_mkdirs2().mkdirp;
    var pathExists = require_path_exists2().pathExists;
    var stat = require_stat2();
    function move(src, dest, opts, cb) {
      if (typeof opts === "function") {
        cb = opts;
        opts = {};
      }
      const overwrite = opts.overwrite || opts.clobber || false;
      stat.checkPaths(src, dest, "move", (err, stats) => {
        if (err)
          return cb(err);
        const { srcStat } = stats;
        stat.checkParentPaths(src, srcStat, dest, "move", (err2) => {
          if (err2)
            return cb(err2);
          mkdirp2(path2.dirname(dest), (err3) => {
            if (err3)
              return cb(err3);
            return doRename(src, dest, overwrite, cb);
          });
        });
      });
    }
    function doRename(src, dest, overwrite, cb) {
      if (overwrite) {
        return remove2(dest, (err) => {
          if (err)
            return cb(err);
          return rename(src, dest, overwrite, cb);
        });
      }
      pathExists(dest, (err, destExists) => {
        if (err)
          return cb(err);
        if (destExists)
          return cb(new Error("dest already exists."));
        return rename(src, dest, overwrite, cb);
      });
    }
    function rename(src, dest, overwrite, cb) {
      fs2.rename(src, dest, (err) => {
        if (!err)
          return cb();
        if (err.code !== "EXDEV")
          return cb(err);
        return moveAcrossDevice(src, dest, overwrite, cb);
      });
    }
    function moveAcrossDevice(src, dest, overwrite, cb) {
      const opts = {
        overwrite,
        errorOnExist: true
      };
      copy(src, dest, opts, (err) => {
        if (err)
          return cb(err);
        return remove2(src, cb);
      });
    }
    module2.exports = move;
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/move/index.js
var require_move4 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/move/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    module2.exports = {
      move: u(require_move3())
    };
  }
});

// node_modules/jsii-rosetta/node_modules/fs-extra/lib/index.js
var require_lib8 = __commonJS({
  "node_modules/jsii-rosetta/node_modules/fs-extra/lib/index.js"(exports, module2) {
    "use strict";
    module2.exports = __spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues(__spreadValues({}, require_fs3()), require_copy_sync4()), require_copy4()), require_empty2()), require_ensure2()), require_json2()), require_mkdirs2()), require_move_sync4()), require_move4()), require_output2()), require_path_exists2()), require_remove2());
    var fs2 = require("fs");
    if (Object.getOwnPropertyDescriptor(fs2, "promises")) {
      Object.defineProperty(module2.exports, "promises", {
        get() {
          return fs2.promises;
        }
      });
    }
  }
});

// node_modules/jsii-rosetta/lib/tablets/schema.js
var require_schema = __commonJS({
  "node_modules/jsii-rosetta/lib/tablets/schema.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.ORIGINAL_SNIPPET_KEY = void 0;
    exports.ORIGINAL_SNIPPET_KEY = "$";
  }
});

// node_modules/jsii-rosetta/package.json
var require_package = __commonJS({
  "node_modules/jsii-rosetta/package.json"(exports, module2) {
    module2.exports = {
      name: "jsii-rosetta",
      version: "1.39.0",
      description: "Translate TypeScript code snippets to other languages",
      main: "lib/index.js",
      bin: {
        "jsii-rosetta": "bin/jsii-rosetta"
      },
      scripts: {
        build: "tsc --build && npm run lint",
        watch: "tsc --build -w",
        lint: "eslint . --ext .js,.ts --ignore-path=.gitignore --ignore-pattern=examples/* --ignore-pattern=test/translations/*",
        "lint:fix": "yarn lint --fix",
        test: "jest",
        "test:update": "jest -u",
        package: "package-js"
      },
      devDependencies: {
        "@types/commonmark": "^0.27.5",
        "@types/fs-extra": "^9.0.13",
        "@types/jest": "^27.0.2",
        "@types/mock-fs": "^4.13.1",
        "@types/node": "^12.20.28",
        eslint: "^7.32.0",
        jest: "^27.2.4",
        jsii: "^1.39.0",
        "jsii-build-tools": "^1.39.0",
        "memory-streams": "^0.1.3",
        "mock-fs": "^5.1.1",
        prettier: "^2.4.1"
      },
      dependencies: {
        "@jsii/check-node": "1.39.0",
        "@jsii/spec": "^1.39.0",
        commonmark: "^0.30.0",
        "fs-extra": "^9.1.0",
        typescript: "~3.9.10",
        "@xmldom/xmldom": "^0.7.5",
        yargs: "^16.2.0"
      },
      license: "Apache-2.0",
      author: {
        name: "Amazon Web Services",
        url: "https://aws.amazon.com",
        organization: true
      },
      homepage: "https://github.com/aws/jsii",
      repository: {
        type: "git",
        url: "https://github.com/aws/jsii.git",
        directory: "packages/jsii-rosetta"
      },
      engines: {
        node: ">= 12.7.0"
      }
    };
  }
});

// node_modules/jsii-rosetta/lib/tablets/tablets.js
var require_tablets = __commonJS({
  "node_modules/jsii-rosetta/lib/tablets/tablets.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.TranslatedSnippet = exports.LanguageTablet = exports.DEFAULT_TABLET_NAME = void 0;
    var fs2 = require_lib8();
    var path2 = require("path");
    var key_1 = require_key();
    var schema_1 = require_schema();
    var TOOL_VERSION = require_package().version;
    exports.DEFAULT_TABLET_NAME = ".jsii.tabl.json";
    var LanguageTablet = class {
      constructor() {
        this.snippets = {};
      }
      addSnippet(snippet) {
        const existingSnippet = this.snippets[snippet.key];
        this.snippets[snippet.key] = existingSnippet ? existingSnippet.merge(snippet) : snippet;
      }
      get snippetKeys() {
        return Object.keys(this.snippets);
      }
      tryGetSnippet(key) {
        return this.snippets[key];
      }
      lookup(typeScriptSource, language) {
        const snippet = this.snippets[key_1.snippetKey(typeScriptSource)];
        return snippet === null || snippet === void 0 ? void 0 : snippet.get(language);
      }
      async load(filename) {
        const obj = await fs2.readJson(filename, { encoding: "utf-8" });
        if (!obj.toolVersion || !obj.snippets) {
          throw new Error(`File '${filename}' does not seem to be a Tablet file`);
        }
        if (obj.toolVersion !== TOOL_VERSION && TOOL_VERSION !== "0.0.0") {
          throw new Error(`Tablet file '${filename}' has been created with version '${obj.toolVersion}', cannot read with current version '${TOOL_VERSION}'`);
        }
        Object.assign(this.snippets, mapValues(obj.snippets, (schema) => TranslatedSnippet.fromSchema(schema)));
      }
      get count() {
        return Object.keys(this.snippets).length;
      }
      async save(filename) {
        await fs2.mkdirp(path2.dirname(filename));
        await fs2.writeJson(filename, this.toSchema(), {
          encoding: "utf-8",
          spaces: 2
        });
      }
      toSchema() {
        return {
          version: "1",
          toolVersion: TOOL_VERSION,
          snippets: mapValues(this.snippets, (s) => s.toSchema())
        };
      }
    };
    exports.LanguageTablet = LanguageTablet;
    var TranslatedSnippet = class {
      constructor() {
        this.translations = {};
        this._where = "";
      }
      static fromSchema(schema) {
        const ret = new TranslatedSnippet();
        Object.assign(ret.translations, schema.translations);
        ret._didCompile = schema.didCompile;
        ret._where = schema.where;
        return ret;
      }
      static fromSnippet(original, didCompile) {
        const ret = new TranslatedSnippet();
        Object.assign(ret.translations, {
          [schema_1.ORIGINAL_SNIPPET_KEY]: { source: original.visibleSource }
        });
        ret._didCompile = didCompile;
        ret._where = original.where;
        return ret;
      }
      get didCompile() {
        return this._didCompile;
      }
      get where() {
        return this._where;
      }
      get key() {
        if (this._key === void 0) {
          this._key = key_1.snippetKey(this.asTypescriptSnippet());
        }
        return this._key;
      }
      asTypescriptSnippet() {
        return {
          visibleSource: this.translations[schema_1.ORIGINAL_SNIPPET_KEY].source,
          where: this.where
        };
      }
      get originalSource() {
        return {
          source: this.translations[schema_1.ORIGINAL_SNIPPET_KEY].source,
          language: "typescript",
          didCompile: this.didCompile
        };
      }
      addTranslatedSource(language, translation) {
        this.translations[language] = { source: translation };
        return {
          source: translation,
          language,
          didCompile: this.didCompile
        };
      }
      get languages() {
        return Object.keys(this.translations).filter((x) => x !== schema_1.ORIGINAL_SNIPPET_KEY);
      }
      get(language) {
        const t = this.translations[language];
        return t && { source: t.source, language, didCompile: this.didCompile };
      }
      merge(other) {
        const ret = new TranslatedSnippet();
        Object.assign(ret.translations, this.translations, other.translations);
        ret._didCompile = this.didCompile;
        ret._where = this.where;
        return ret;
      }
      toTypeScriptSnippet() {
        return {
          source: this.originalSource,
          where: this.where
        };
      }
      toSchema() {
        return {
          translations: this.translations,
          didCompile: this.didCompile,
          where: this.where
        };
      }
    };
    exports.TranslatedSnippet = TranslatedSnippet;
    function mapValues(xs, fn) {
      const ret = {};
      for (const [key, value] of Object.entries(xs)) {
        ret[key] = fn(value);
      }
      return ret;
    }
  }
});

// node_modules/jsii-rosetta/lib/typescript/ts-compiler.js
var require_ts_compiler = __commonJS({
  "node_modules/jsii-rosetta/lib/typescript/ts-compiler.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.STANDARD_COMPILER_OPTIONS = exports.TypeScriptCompiler = void 0;
    var ts = require_typescript();
    var TypeScriptCompiler = class {
      constructor() {
        this.realHost = ts.createCompilerHost(exports.STANDARD_COMPILER_OPTIONS, true);
      }
      createInMemoryCompilerHost(sourcePath, sourceContents, currentDirectory) {
        const realHost = this.realHost;
        const sourceFile = ts.createSourceFile(sourcePath, sourceContents, ts.ScriptTarget.Latest);
        return __spreadProps(__spreadValues({}, realHost), {
          fileExists: (filePath) => filePath === sourcePath || realHost.fileExists(filePath),
          getCurrentDirectory: currentDirectory != null ? () => currentDirectory : realHost.getCurrentDirectory,
          getSourceFile: (fileName, languageVersion, onError, shouldCreateNewSourceFile) => fileName === sourcePath ? sourceFile : realHost.getSourceFile(fileName, languageVersion, onError, shouldCreateNewSourceFile),
          readFile: (filePath) => filePath === sourcePath ? sourceContents : realHost.readFile(filePath),
          writeFile: () => void 0
        });
      }
      compileInMemory(filename, contents, currentDirectory) {
        if (!filename.endsWith(".ts")) {
          filename += ".ts";
        }
        const program = ts.createProgram({
          rootNames: [filename],
          options: exports.STANDARD_COMPILER_OPTIONS,
          host: this.createInMemoryCompilerHost(filename, contents, currentDirectory)
        });
        const rootFile = program.getSourceFile(filename);
        if (rootFile == null) {
          throw new Error("Oopsie -- couldn't find root file back");
        }
        return { program, rootFile };
      }
    };
    exports.TypeScriptCompiler = TypeScriptCompiler;
    exports.STANDARD_COMPILER_OPTIONS = {
      alwaysStrict: true,
      charset: "utf8",
      declaration: true,
      experimentalDecorators: true,
      inlineSourceMap: true,
      inlineSources: true,
      lib: ["lib.es2016.d.ts", "lib.es2017.object.d.ts", "lib.es2017.string.d.ts"],
      module: ts.ModuleKind.CommonJS,
      noEmitOnError: true,
      noFallthroughCasesInSwitch: true,
      noImplicitAny: true,
      noImplicitReturns: true,
      noImplicitThis: true,
      noUnusedLocals: false,
      noUnusedParameters: false,
      resolveJsonModule: true,
      strict: true,
      strictNullChecks: true,
      strictPropertyInitialization: true,
      stripInternal: true,
      target: ts.ScriptTarget.ES2019,
      incremental: true,
      tsBuildInfoFile: ".tsbuildinfo"
    };
  }
});

// node_modules/jsii-rosetta/lib/translate.js
var require_translate = __commonJS({
  "node_modules/jsii-rosetta/lib/translate.js"(exports) {
    "use strict";
    var __classPrivateFieldGet = exports && exports.__classPrivateFieldGet || function(receiver, privateMap) {
      if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to get private field on non-instance");
      }
      return privateMap.get(receiver);
    };
    var __classPrivateFieldSet = exports && exports.__classPrivateFieldSet || function(receiver, privateMap, value) {
      if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to set private field on non-instance");
      }
      privateMap.set(receiver, value);
      return value;
    };
    var _diagnostics;
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.SnippetTranslator = exports.Translator = exports.translateTypeScript = void 0;
    var ts = require_typescript();
    var util_1 = require("util");
    var languages_1 = require_languages();
    var logging = require_logging();
    var o_tree_1 = require_o_tree();
    var renderer_1 = require_renderer();
    var snippet_1 = require_snippet();
    var key_1 = require_key();
    var tablets_1 = require_tablets();
    var ast_utils_1 = require_ast_utils();
    var ts_compiler_1 = require_ts_compiler();
    var util_2 = require_util3();
    function translateTypeScript(source, visitor, options = {}) {
      const translator = new SnippetTranslator({ visibleSource: source.contents, where: source.fileName }, options);
      const translated = translator.renderUsing(visitor);
      return {
        translation: translated,
        diagnostics: translator.diagnostics
      };
    }
    exports.translateTypeScript = translateTypeScript;
    var Translator = class {
      constructor(includeCompilerDiagnostics) {
        this.includeCompilerDiagnostics = includeCompilerDiagnostics;
        this.compiler = new ts_compiler_1.TypeScriptCompiler();
        _diagnostics.set(this, []);
      }
      translate(snip, languages = Object.values(languages_1.TargetLanguage)) {
        var _a;
        logging.debug(`Translating ${key_1.snippetKey(snip)} ${util_1.inspect((_a = snip.parameters) !== null && _a !== void 0 ? _a : {})}`);
        const translator = this.translatorFor(snip);
        const snippet = tablets_1.TranslatedSnippet.fromSnippet(snip, this.includeCompilerDiagnostics ? translator.compileDiagnostics.length === 0 : void 0);
        for (const lang of languages) {
          const languageConverterFactory = languages_1.TARGET_LANGUAGES[lang];
          const translated = translator.renderUsing(languageConverterFactory());
          snippet.addTranslatedSource(lang, translated);
        }
        __classPrivateFieldSet(this, _diagnostics, ts.sortAndDeduplicateDiagnostics(__classPrivateFieldGet(this, _diagnostics).concat(translator.diagnostics)));
        return snippet;
      }
      get diagnostics() {
        return Array.from(__classPrivateFieldGet(this, _diagnostics));
      }
      translatorFor(snippet) {
        const translator = new SnippetTranslator(snippet, {
          compiler: this.compiler,
          includeCompilerDiagnostics: this.includeCompilerDiagnostics
        });
        return translator;
      }
    };
    exports.Translator = Translator;
    _diagnostics = new WeakMap();
    var SnippetTranslator = class {
      constructor(snippet, options = {}) {
        var _a, _b, _c, _d;
        this.options = options;
        this.translateDiagnostics = [];
        this.compileDiagnostics = [];
        const compiler = (_a = options.compiler) !== null && _a !== void 0 ? _a : new ts_compiler_1.TypeScriptCompiler();
        const source = snippet_1.completeSource(snippet);
        const fakeCurrentDirectory = (_c = (_b = snippet.parameters) === null || _b === void 0 ? void 0 : _b[snippet_1.SnippetParameters.$COMPILATION_DIRECTORY]) !== null && _c !== void 0 ? _c : (_d = snippet.parameters) === null || _d === void 0 ? void 0 : _d[snippet_1.SnippetParameters.$PROJECT_DIRECTORY];
        this.compilation = compiler.compileInMemory(snippet.where, source, fakeCurrentDirectory);
        this.visibleSpans = ast_utils_1.calculateVisibleSpans(source);
        if (options.includeCompilerDiagnostics || snippet.strict) {
          const program = this.compilation.program;
          const diagnostics = [
            ...neverThrowing(program.getGlobalDiagnostics)(),
            ...neverThrowing(program.getSyntacticDiagnostics)(this.compilation.rootFile),
            ...neverThrowing(program.getDeclarationDiagnostics)(this.compilation.rootFile),
            ...neverThrowing(program.getSemanticDiagnostics)(this.compilation.rootFile)
          ];
          if (snippet.strict) {
            diagnostics.forEach(util_2.annotateStrictDiagnostic);
          }
          this.compileDiagnostics.push(...diagnostics);
        }
        function neverThrowing(call) {
          return (...args) => {
            try {
              return call(...args);
            } catch (err) {
              console.error(`Failed to execute ${call.name}: ${err}`);
              return [];
            }
          };
        }
      }
      renderUsing(visitor) {
        const converter = new renderer_1.AstRenderer(this.compilation.rootFile, this.compilation.program.getTypeChecker(), visitor, this.options);
        const converted = converter.convert(this.compilation.rootFile);
        this.translateDiagnostics.push(...filterVisibleDiagnostics(converter.diagnostics, this.visibleSpans));
        return o_tree_1.renderTree(converted, { visibleSpans: this.visibleSpans });
      }
      get diagnostics() {
        return ts.sortAndDeduplicateDiagnostics(this.compileDiagnostics.concat(this.translateDiagnostics));
      }
    };
    exports.SnippetTranslator = SnippetTranslator;
    function filterVisibleDiagnostics(diags, visibleSpans) {
      return diags.filter((d) => d.source !== "rosetta" || d.start === void 0 || visibleSpans.some((s) => o_tree_1.spanContains(s, d.start)));
    }
  }
});

// node_modules/jsii-rosetta/lib/fixtures.js
var require_fixtures = __commonJS({
  "node_modules/jsii-rosetta/lib/fixtures.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.fixturize = void 0;
    var fs2 = require_lib8();
    var path2 = require("path");
    var typescript_1 = require_typescript();
    var snippet_1 = require_snippet();
    function fixturize(snippet, loose = false) {
      var _a;
      let source = snippet.visibleSource;
      const parameters = (_a = snippet.parameters) !== null && _a !== void 0 ? _a : {};
      const directory = parameters[snippet_1.SnippetParameters.$PROJECT_DIRECTORY];
      if (!directory) {
        return snippet;
      }
      const literateSource = parameters[snippet_1.SnippetParameters.LITERATE_SOURCE];
      if (literateSource) {
        try {
          source = loadLiterateSource(directory, literateSource);
        } catch (ex) {
          if (!loose) {
            throw ex;
          }
        }
        parameters[snippet_1.SnippetParameters.$COMPILATION_DIRECTORY] = path2.join(directory, path2.dirname(literateSource));
      } else if (parameters[snippet_1.SnippetParameters.FIXTURE]) {
        source = loadAndSubFixture(directory, parameters.fixture, source, !loose);
      } else if (parameters[snippet_1.SnippetParameters.NO_FIXTURE] === void 0) {
        source = loadAndSubFixture(directory, "default", source, false);
      }
      return __spreadProps(__spreadValues({}, snippet), {
        completeSource: source,
        parameters
      });
    }
    exports.fixturize = fixturize;
    function loadLiterateSource(directory, literateFileName) {
      const fullPath = path2.join(directory, literateFileName);
      const exists = fs2.existsSync(fullPath);
      if (!exists) {
        throw new Error(`Sample uses literate source ${literateFileName}, but not found: ${fullPath}`);
      }
      return fs2.readFileSync(fullPath, { encoding: "utf-8" });
    }
    function loadAndSubFixture(directory, fixtureName, source, mustExist) {
      const fixtureFileName = path2.join(directory, `rosetta/${fixtureName}.ts-fixture`);
      const exists = fs2.existsSync(fixtureFileName);
      if (!exists && mustExist) {
        throw new Error(`Sample uses fixture ${fixtureName}, but not found: ${fixtureFileName}`);
      }
      if (!exists) {
        return source;
      }
      const fixtureContents = fs2.readFileSync(fixtureFileName, {
        encoding: "utf-8"
      });
      const subRegex = /[/]{3}[ \t]*here[ \t]*$/im;
      if (!subRegex.test(fixtureContents)) {
        throw new Error(`Fixture does not contain '/// here': ${fixtureFileName}`);
      }
      const { imports, statements } = sidelineImports(source);
      const show = "/// !show";
      const hide = "/// !hide";
      const result = fixtureContents.replace(subRegex, [
        "// Code snippet begins after !show marker below",
        show,
        statements,
        hide,
        "// Code snippet ended before !hide marker above"
      ].join("\n"));
      return imports ? [
        "// Hoisted imports begin after !show marker below",
        show,
        imports,
        hide,
        "// Hoisted imports ended before !hide marker above",
        result
      ].join("\n") : result;
    }
    function sidelineImports(source) {
      let imports = "";
      let statements = "";
      const sourceFile = typescript_1.createSourceFile("index.ts", source, typescript_1.ScriptTarget.Latest, true, typescript_1.ScriptKind.TS);
      for (const statement of sourceFile.statements) {
        if (statement.kind === typescript_1.SyntaxKind.ImportDeclaration || statement.kind === typescript_1.SyntaxKind.ImportEqualsDeclaration || statement.kind === typescript_1.SyntaxKind.VariableStatement && statement.getChildAt(0).getChildAt(0).kind === typescript_1.SyntaxKind.DeclareKeyword) {
          imports += statement.getFullText(sourceFile);
        } else {
          statements += statement.getFullText(sourceFile);
        }
      }
      return { imports, statements };
    }
  }
});

// node_modules/commonmark/dist/commonmark.js
var require_commonmark = __commonJS({
  "node_modules/commonmark/dist/commonmark.js"(exports, module2) {
    (function(global2, factory) {
      typeof exports === "object" && typeof module2 !== "undefined" ? factory(exports) : typeof define === "function" && define.amd ? define(["exports"], factory) : (global2 = global2 || self, factory(global2.commonmark = {}));
    })(exports, function(exports2) {
      "use strict";
      function isContainer(node) {
        switch (node._type) {
          case "document":
          case "block_quote":
          case "list":
          case "item":
          case "paragraph":
          case "heading":
          case "emph":
          case "strong":
          case "link":
          case "image":
          case "custom_inline":
          case "custom_block":
            return true;
          default:
            return false;
        }
      }
      var resumeAt = function(node, entering) {
        this.current = node;
        this.entering = entering === true;
      };
      var next = function() {
        var cur = this.current;
        var entering = this.entering;
        if (cur === null) {
          return null;
        }
        var container = isContainer(cur);
        if (entering && container) {
          if (cur._firstChild) {
            this.current = cur._firstChild;
            this.entering = true;
          } else {
            this.entering = false;
          }
        } else if (cur === this.root) {
          this.current = null;
        } else if (cur._next === null) {
          this.current = cur._parent;
          this.entering = false;
        } else {
          this.current = cur._next;
          this.entering = true;
        }
        return { entering, node: cur };
      };
      var NodeWalker = function(root) {
        return {
          current: root,
          root,
          entering: true,
          next,
          resumeAt
        };
      };
      var Node = function(nodeType, sourcepos) {
        this._type = nodeType;
        this._parent = null;
        this._firstChild = null;
        this._lastChild = null;
        this._prev = null;
        this._next = null;
        this._sourcepos = sourcepos;
        this._lastLineBlank = false;
        this._lastLineChecked = false;
        this._open = true;
        this._string_content = null;
        this._literal = null;
        this._listData = {};
        this._info = null;
        this._destination = null;
        this._title = null;
        this._isFenced = false;
        this._fenceChar = null;
        this._fenceLength = 0;
        this._fenceOffset = null;
        this._level = null;
        this._onEnter = null;
        this._onExit = null;
      };
      var proto = Node.prototype;
      Object.defineProperty(proto, "isContainer", {
        get: function() {
          return isContainer(this);
        }
      });
      Object.defineProperty(proto, "type", {
        get: function() {
          return this._type;
        }
      });
      Object.defineProperty(proto, "firstChild", {
        get: function() {
          return this._firstChild;
        }
      });
      Object.defineProperty(proto, "lastChild", {
        get: function() {
          return this._lastChild;
        }
      });
      Object.defineProperty(proto, "next", {
        get: function() {
          return this._next;
        }
      });
      Object.defineProperty(proto, "prev", {
        get: function() {
          return this._prev;
        }
      });
      Object.defineProperty(proto, "parent", {
        get: function() {
          return this._parent;
        }
      });
      Object.defineProperty(proto, "sourcepos", {
        get: function() {
          return this._sourcepos;
        }
      });
      Object.defineProperty(proto, "literal", {
        get: function() {
          return this._literal;
        },
        set: function(s) {
          this._literal = s;
        }
      });
      Object.defineProperty(proto, "destination", {
        get: function() {
          return this._destination;
        },
        set: function(s) {
          this._destination = s;
        }
      });
      Object.defineProperty(proto, "title", {
        get: function() {
          return this._title;
        },
        set: function(s) {
          this._title = s;
        }
      });
      Object.defineProperty(proto, "info", {
        get: function() {
          return this._info;
        },
        set: function(s) {
          this._info = s;
        }
      });
      Object.defineProperty(proto, "level", {
        get: function() {
          return this._level;
        },
        set: function(s) {
          this._level = s;
        }
      });
      Object.defineProperty(proto, "listType", {
        get: function() {
          return this._listData.type;
        },
        set: function(t) {
          this._listData.type = t;
        }
      });
      Object.defineProperty(proto, "listTight", {
        get: function() {
          return this._listData.tight;
        },
        set: function(t) {
          this._listData.tight = t;
        }
      });
      Object.defineProperty(proto, "listStart", {
        get: function() {
          return this._listData.start;
        },
        set: function(n) {
          this._listData.start = n;
        }
      });
      Object.defineProperty(proto, "listDelimiter", {
        get: function() {
          return this._listData.delimiter;
        },
        set: function(delim) {
          this._listData.delimiter = delim;
        }
      });
      Object.defineProperty(proto, "onEnter", {
        get: function() {
          return this._onEnter;
        },
        set: function(s) {
          this._onEnter = s;
        }
      });
      Object.defineProperty(proto, "onExit", {
        get: function() {
          return this._onExit;
        },
        set: function(s) {
          this._onExit = s;
        }
      });
      Node.prototype.appendChild = function(child) {
        child.unlink();
        child._parent = this;
        if (this._lastChild) {
          this._lastChild._next = child;
          child._prev = this._lastChild;
          this._lastChild = child;
        } else {
          this._firstChild = child;
          this._lastChild = child;
        }
      };
      Node.prototype.prependChild = function(child) {
        child.unlink();
        child._parent = this;
        if (this._firstChild) {
          this._firstChild._prev = child;
          child._next = this._firstChild;
          this._firstChild = child;
        } else {
          this._firstChild = child;
          this._lastChild = child;
        }
      };
      Node.prototype.unlink = function() {
        if (this._prev) {
          this._prev._next = this._next;
        } else if (this._parent) {
          this._parent._firstChild = this._next;
        }
        if (this._next) {
          this._next._prev = this._prev;
        } else if (this._parent) {
          this._parent._lastChild = this._prev;
        }
        this._parent = null;
        this._next = null;
        this._prev = null;
      };
      Node.prototype.insertAfter = function(sibling) {
        sibling.unlink();
        sibling._next = this._next;
        if (sibling._next) {
          sibling._next._prev = sibling;
        }
        sibling._prev = this;
        this._next = sibling;
        sibling._parent = this._parent;
        if (!sibling._next) {
          sibling._parent._lastChild = sibling;
        }
      };
      Node.prototype.insertBefore = function(sibling) {
        sibling.unlink();
        sibling._prev = this._prev;
        if (sibling._prev) {
          sibling._prev._next = sibling;
        }
        sibling._next = this;
        this._prev = sibling;
        sibling._parent = this._parent;
        if (!sibling._prev) {
          sibling._parent._firstChild = sibling;
        }
      };
      Node.prototype.walker = function() {
        var walker = new NodeWalker(this);
        return walker;
      };
      var encodeCache = {};
      function getEncodeCache(exclude) {
        var i, ch, cache = encodeCache[exclude];
        if (cache) {
          return cache;
        }
        cache = encodeCache[exclude] = [];
        for (i = 0; i < 128; i++) {
          ch = String.fromCharCode(i);
          if (/^[0-9a-z]$/i.test(ch)) {
            cache.push(ch);
          } else {
            cache.push("%" + ("0" + i.toString(16).toUpperCase()).slice(-2));
          }
        }
        for (i = 0; i < exclude.length; i++) {
          cache[exclude.charCodeAt(i)] = exclude[i];
        }
        return cache;
      }
      function encode(string, exclude, keepEscaped) {
        var i, l, code2, nextCode, cache, result = "";
        if (typeof exclude !== "string") {
          keepEscaped = exclude;
          exclude = encode.defaultChars;
        }
        if (typeof keepEscaped === "undefined") {
          keepEscaped = true;
        }
        cache = getEncodeCache(exclude);
        for (i = 0, l = string.length; i < l; i++) {
          code2 = string.charCodeAt(i);
          if (keepEscaped && code2 === 37 && i + 2 < l) {
            if (/^[0-9a-f]{2}$/i.test(string.slice(i + 1, i + 3))) {
              result += string.slice(i, i + 3);
              i += 2;
              continue;
            }
          }
          if (code2 < 128) {
            result += cache[code2];
            continue;
          }
          if (code2 >= 55296 && code2 <= 57343) {
            if (code2 >= 55296 && code2 <= 56319 && i + 1 < l) {
              nextCode = string.charCodeAt(i + 1);
              if (nextCode >= 56320 && nextCode <= 57343) {
                result += encodeURIComponent(string[i] + string[i + 1]);
                i++;
                continue;
              }
            }
            result += "%EF%BF%BD";
            continue;
          }
          result += encodeURIComponent(string[i]);
        }
        return result;
      }
      encode.defaultChars = ";/?:@&=+$,-_.!~*'()#";
      encode.componentChars = "-_.!~*'()";
      var encode_1 = encode;
      var commonjsGlobal = typeof globalThis !== "undefined" ? globalThis : typeof window !== "undefined" ? window : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : {};
      function unwrapExports(x) {
        return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, "default") ? x["default"] : x;
      }
      function createCommonjsModule(fn, module3) {
        return module3 = { exports: {} }, fn(module3, module3.exports), module3.exports;
      }
      function getCjsExportFromNamespace(n) {
        return n && n["default"] || n;
      }
      var Aacute = "\xC1";
      var aacute = "\xE1";
      var Abreve = "\u0102";
      var abreve = "\u0103";
      var ac = "\u223E";
      var acd = "\u223F";
      var acE = "\u223E\u0333";
      var Acirc = "\xC2";
      var acirc = "\xE2";
      var acute = "\xB4";
      var Acy = "\u0410";
      var acy = "\u0430";
      var AElig = "\xC6";
      var aelig = "\xE6";
      var af = "\u2061";
      var Afr = "\u{1D504}";
      var afr = "\u{1D51E}";
      var Agrave = "\xC0";
      var agrave = "\xE0";
      var alefsym = "\u2135";
      var aleph = "\u2135";
      var Alpha = "\u0391";
      var alpha = "\u03B1";
      var Amacr = "\u0100";
      var amacr = "\u0101";
      var amalg = "\u2A3F";
      var amp = "&";
      var AMP = "&";
      var andand = "\u2A55";
      var And = "\u2A53";
      var and = "\u2227";
      var andd = "\u2A5C";
      var andslope = "\u2A58";
      var andv = "\u2A5A";
      var ang = "\u2220";
      var ange = "\u29A4";
      var angle = "\u2220";
      var angmsdaa = "\u29A8";
      var angmsdab = "\u29A9";
      var angmsdac = "\u29AA";
      var angmsdad = "\u29AB";
      var angmsdae = "\u29AC";
      var angmsdaf = "\u29AD";
      var angmsdag = "\u29AE";
      var angmsdah = "\u29AF";
      var angmsd = "\u2221";
      var angrt = "\u221F";
      var angrtvb = "\u22BE";
      var angrtvbd = "\u299D";
      var angsph = "\u2222";
      var angst = "\xC5";
      var angzarr = "\u237C";
      var Aogon = "\u0104";
      var aogon = "\u0105";
      var Aopf = "\u{1D538}";
      var aopf = "\u{1D552}";
      var apacir = "\u2A6F";
      var ap = "\u2248";
      var apE = "\u2A70";
      var ape = "\u224A";
      var apid = "\u224B";
      var apos = "'";
      var ApplyFunction = "\u2061";
      var approx = "\u2248";
      var approxeq = "\u224A";
      var Aring = "\xC5";
      var aring = "\xE5";
      var Ascr = "\u{1D49C}";
      var ascr = "\u{1D4B6}";
      var Assign = "\u2254";
      var ast = "*";
      var asymp = "\u2248";
      var asympeq = "\u224D";
      var Atilde = "\xC3";
      var atilde = "\xE3";
      var Auml = "\xC4";
      var auml = "\xE4";
      var awconint = "\u2233";
      var awint = "\u2A11";
      var backcong = "\u224C";
      var backepsilon = "\u03F6";
      var backprime = "\u2035";
      var backsim = "\u223D";
      var backsimeq = "\u22CD";
      var Backslash = "\u2216";
      var Barv = "\u2AE7";
      var barvee = "\u22BD";
      var barwed = "\u2305";
      var Barwed = "\u2306";
      var barwedge = "\u2305";
      var bbrk = "\u23B5";
      var bbrktbrk = "\u23B6";
      var bcong = "\u224C";
      var Bcy = "\u0411";
      var bcy = "\u0431";
      var bdquo = "\u201E";
      var becaus = "\u2235";
      var because = "\u2235";
      var Because = "\u2235";
      var bemptyv = "\u29B0";
      var bepsi = "\u03F6";
      var bernou = "\u212C";
      var Bernoullis = "\u212C";
      var Beta = "\u0392";
      var beta = "\u03B2";
      var beth = "\u2136";
      var between = "\u226C";
      var Bfr = "\u{1D505}";
      var bfr = "\u{1D51F}";
      var bigcap = "\u22C2";
      var bigcirc = "\u25EF";
      var bigcup = "\u22C3";
      var bigodot = "\u2A00";
      var bigoplus = "\u2A01";
      var bigotimes = "\u2A02";
      var bigsqcup = "\u2A06";
      var bigstar = "\u2605";
      var bigtriangledown = "\u25BD";
      var bigtriangleup = "\u25B3";
      var biguplus = "\u2A04";
      var bigvee = "\u22C1";
      var bigwedge = "\u22C0";
      var bkarow = "\u290D";
      var blacklozenge = "\u29EB";
      var blacksquare = "\u25AA";
      var blacktriangle = "\u25B4";
      var blacktriangledown = "\u25BE";
      var blacktriangleleft = "\u25C2";
      var blacktriangleright = "\u25B8";
      var blank = "\u2423";
      var blk12 = "\u2592";
      var blk14 = "\u2591";
      var blk34 = "\u2593";
      var block = "\u2588";
      var bne = "=\u20E5";
      var bnequiv = "\u2261\u20E5";
      var bNot = "\u2AED";
      var bnot = "\u2310";
      var Bopf = "\u{1D539}";
      var bopf = "\u{1D553}";
      var bot = "\u22A5";
      var bottom = "\u22A5";
      var bowtie = "\u22C8";
      var boxbox = "\u29C9";
      var boxdl = "\u2510";
      var boxdL = "\u2555";
      var boxDl = "\u2556";
      var boxDL = "\u2557";
      var boxdr = "\u250C";
      var boxdR = "\u2552";
      var boxDr = "\u2553";
      var boxDR = "\u2554";
      var boxh = "\u2500";
      var boxH = "\u2550";
      var boxhd = "\u252C";
      var boxHd = "\u2564";
      var boxhD = "\u2565";
      var boxHD = "\u2566";
      var boxhu = "\u2534";
      var boxHu = "\u2567";
      var boxhU = "\u2568";
      var boxHU = "\u2569";
      var boxminus = "\u229F";
      var boxplus = "\u229E";
      var boxtimes = "\u22A0";
      var boxul = "\u2518";
      var boxuL = "\u255B";
      var boxUl = "\u255C";
      var boxUL = "\u255D";
      var boxur = "\u2514";
      var boxuR = "\u2558";
      var boxUr = "\u2559";
      var boxUR = "\u255A";
      var boxv = "\u2502";
      var boxV = "\u2551";
      var boxvh = "\u253C";
      var boxvH = "\u256A";
      var boxVh = "\u256B";
      var boxVH = "\u256C";
      var boxvl = "\u2524";
      var boxvL = "\u2561";
      var boxVl = "\u2562";
      var boxVL = "\u2563";
      var boxvr = "\u251C";
      var boxvR = "\u255E";
      var boxVr = "\u255F";
      var boxVR = "\u2560";
      var bprime = "\u2035";
      var breve = "\u02D8";
      var Breve = "\u02D8";
      var brvbar = "\xA6";
      var bscr = "\u{1D4B7}";
      var Bscr = "\u212C";
      var bsemi = "\u204F";
      var bsim = "\u223D";
      var bsime = "\u22CD";
      var bsolb = "\u29C5";
      var bsol = "\\";
      var bsolhsub = "\u27C8";
      var bull = "\u2022";
      var bullet = "\u2022";
      var bump = "\u224E";
      var bumpE = "\u2AAE";
      var bumpe = "\u224F";
      var Bumpeq = "\u224E";
      var bumpeq = "\u224F";
      var Cacute = "\u0106";
      var cacute = "\u0107";
      var capand = "\u2A44";
      var capbrcup = "\u2A49";
      var capcap = "\u2A4B";
      var cap = "\u2229";
      var Cap = "\u22D2";
      var capcup = "\u2A47";
      var capdot = "\u2A40";
      var CapitalDifferentialD = "\u2145";
      var caps = "\u2229\uFE00";
      var caret = "\u2041";
      var caron = "\u02C7";
      var Cayleys = "\u212D";
      var ccaps = "\u2A4D";
      var Ccaron = "\u010C";
      var ccaron = "\u010D";
      var Ccedil = "\xC7";
      var ccedil = "\xE7";
      var Ccirc = "\u0108";
      var ccirc = "\u0109";
      var Cconint = "\u2230";
      var ccups = "\u2A4C";
      var ccupssm = "\u2A50";
      var Cdot = "\u010A";
      var cdot = "\u010B";
      var cedil = "\xB8";
      var Cedilla = "\xB8";
      var cemptyv = "\u29B2";
      var cent = "\xA2";
      var centerdot = "\xB7";
      var CenterDot = "\xB7";
      var cfr = "\u{1D520}";
      var Cfr = "\u212D";
      var CHcy = "\u0427";
      var chcy = "\u0447";
      var check = "\u2713";
      var checkmark = "\u2713";
      var Chi = "\u03A7";
      var chi = "\u03C7";
      var circ = "\u02C6";
      var circeq = "\u2257";
      var circlearrowleft = "\u21BA";
      var circlearrowright = "\u21BB";
      var circledast = "\u229B";
      var circledcirc = "\u229A";
      var circleddash = "\u229D";
      var CircleDot = "\u2299";
      var circledR = "\xAE";
      var circledS = "\u24C8";
      var CircleMinus = "\u2296";
      var CirclePlus = "\u2295";
      var CircleTimes = "\u2297";
      var cir = "\u25CB";
      var cirE = "\u29C3";
      var cire = "\u2257";
      var cirfnint = "\u2A10";
      var cirmid = "\u2AEF";
      var cirscir = "\u29C2";
      var ClockwiseContourIntegral = "\u2232";
      var CloseCurlyDoubleQuote = "\u201D";
      var CloseCurlyQuote = "\u2019";
      var clubs = "\u2663";
      var clubsuit = "\u2663";
      var colon = ":";
      var Colon = "\u2237";
      var Colone = "\u2A74";
      var colone = "\u2254";
      var coloneq = "\u2254";
      var comma = ",";
      var commat = "@";
      var comp = "\u2201";
      var compfn = "\u2218";
      var complement = "\u2201";
      var complexes = "\u2102";
      var cong = "\u2245";
      var congdot = "\u2A6D";
      var Congruent = "\u2261";
      var conint = "\u222E";
      var Conint = "\u222F";
      var ContourIntegral = "\u222E";
      var copf = "\u{1D554}";
      var Copf = "\u2102";
      var coprod = "\u2210";
      var Coproduct = "\u2210";
      var copy = "\xA9";
      var COPY = "\xA9";
      var copysr = "\u2117";
      var CounterClockwiseContourIntegral = "\u2233";
      var crarr = "\u21B5";
      var cross = "\u2717";
      var Cross = "\u2A2F";
      var Cscr = "\u{1D49E}";
      var cscr = "\u{1D4B8}";
      var csub = "\u2ACF";
      var csube = "\u2AD1";
      var csup = "\u2AD0";
      var csupe = "\u2AD2";
      var ctdot = "\u22EF";
      var cudarrl = "\u2938";
      var cudarrr = "\u2935";
      var cuepr = "\u22DE";
      var cuesc = "\u22DF";
      var cularr = "\u21B6";
      var cularrp = "\u293D";
      var cupbrcap = "\u2A48";
      var cupcap = "\u2A46";
      var CupCap = "\u224D";
      var cup = "\u222A";
      var Cup = "\u22D3";
      var cupcup = "\u2A4A";
      var cupdot = "\u228D";
      var cupor = "\u2A45";
      var cups = "\u222A\uFE00";
      var curarr = "\u21B7";
      var curarrm = "\u293C";
      var curlyeqprec = "\u22DE";
      var curlyeqsucc = "\u22DF";
      var curlyvee = "\u22CE";
      var curlywedge = "\u22CF";
      var curren = "\xA4";
      var curvearrowleft = "\u21B6";
      var curvearrowright = "\u21B7";
      var cuvee = "\u22CE";
      var cuwed = "\u22CF";
      var cwconint = "\u2232";
      var cwint = "\u2231";
      var cylcty = "\u232D";
      var dagger = "\u2020";
      var Dagger = "\u2021";
      var daleth = "\u2138";
      var darr = "\u2193";
      var Darr = "\u21A1";
      var dArr = "\u21D3";
      var dash = "\u2010";
      var Dashv = "\u2AE4";
      var dashv = "\u22A3";
      var dbkarow = "\u290F";
      var dblac = "\u02DD";
      var Dcaron = "\u010E";
      var dcaron = "\u010F";
      var Dcy = "\u0414";
      var dcy = "\u0434";
      var ddagger = "\u2021";
      var ddarr = "\u21CA";
      var DD = "\u2145";
      var dd = "\u2146";
      var DDotrahd = "\u2911";
      var ddotseq = "\u2A77";
      var deg = "\xB0";
      var Del = "\u2207";
      var Delta = "\u0394";
      var delta = "\u03B4";
      var demptyv = "\u29B1";
      var dfisht = "\u297F";
      var Dfr = "\u{1D507}";
      var dfr = "\u{1D521}";
      var dHar = "\u2965";
      var dharl = "\u21C3";
      var dharr = "\u21C2";
      var DiacriticalAcute = "\xB4";
      var DiacriticalDot = "\u02D9";
      var DiacriticalDoubleAcute = "\u02DD";
      var DiacriticalGrave = "`";
      var DiacriticalTilde = "\u02DC";
      var diam = "\u22C4";
      var diamond = "\u22C4";
      var Diamond = "\u22C4";
      var diamondsuit = "\u2666";
      var diams = "\u2666";
      var die = "\xA8";
      var DifferentialD = "\u2146";
      var digamma = "\u03DD";
      var disin = "\u22F2";
      var div = "\xF7";
      var divide = "\xF7";
      var divideontimes = "\u22C7";
      var divonx = "\u22C7";
      var DJcy = "\u0402";
      var djcy = "\u0452";
      var dlcorn = "\u231E";
      var dlcrop = "\u230D";
      var dollar = "$";
      var Dopf = "\u{1D53B}";
      var dopf = "\u{1D555}";
      var Dot = "\xA8";
      var dot = "\u02D9";
      var DotDot = "\u20DC";
      var doteq = "\u2250";
      var doteqdot = "\u2251";
      var DotEqual = "\u2250";
      var dotminus = "\u2238";
      var dotplus = "\u2214";
      var dotsquare = "\u22A1";
      var doublebarwedge = "\u2306";
      var DoubleContourIntegral = "\u222F";
      var DoubleDot = "\xA8";
      var DoubleDownArrow = "\u21D3";
      var DoubleLeftArrow = "\u21D0";
      var DoubleLeftRightArrow = "\u21D4";
      var DoubleLeftTee = "\u2AE4";
      var DoubleLongLeftArrow = "\u27F8";
      var DoubleLongLeftRightArrow = "\u27FA";
      var DoubleLongRightArrow = "\u27F9";
      var DoubleRightArrow = "\u21D2";
      var DoubleRightTee = "\u22A8";
      var DoubleUpArrow = "\u21D1";
      var DoubleUpDownArrow = "\u21D5";
      var DoubleVerticalBar = "\u2225";
      var DownArrowBar = "\u2913";
      var downarrow = "\u2193";
      var DownArrow = "\u2193";
      var Downarrow = "\u21D3";
      var DownArrowUpArrow = "\u21F5";
      var DownBreve = "\u0311";
      var downdownarrows = "\u21CA";
      var downharpoonleft = "\u21C3";
      var downharpoonright = "\u21C2";
      var DownLeftRightVector = "\u2950";
      var DownLeftTeeVector = "\u295E";
      var DownLeftVectorBar = "\u2956";
      var DownLeftVector = "\u21BD";
      var DownRightTeeVector = "\u295F";
      var DownRightVectorBar = "\u2957";
      var DownRightVector = "\u21C1";
      var DownTeeArrow = "\u21A7";
      var DownTee = "\u22A4";
      var drbkarow = "\u2910";
      var drcorn = "\u231F";
      var drcrop = "\u230C";
      var Dscr = "\u{1D49F}";
      var dscr = "\u{1D4B9}";
      var DScy = "\u0405";
      var dscy = "\u0455";
      var dsol = "\u29F6";
      var Dstrok = "\u0110";
      var dstrok = "\u0111";
      var dtdot = "\u22F1";
      var dtri = "\u25BF";
      var dtrif = "\u25BE";
      var duarr = "\u21F5";
      var duhar = "\u296F";
      var dwangle = "\u29A6";
      var DZcy = "\u040F";
      var dzcy = "\u045F";
      var dzigrarr = "\u27FF";
      var Eacute = "\xC9";
      var eacute = "\xE9";
      var easter = "\u2A6E";
      var Ecaron = "\u011A";
      var ecaron = "\u011B";
      var Ecirc = "\xCA";
      var ecirc = "\xEA";
      var ecir = "\u2256";
      var ecolon = "\u2255";
      var Ecy = "\u042D";
      var ecy = "\u044D";
      var eDDot = "\u2A77";
      var Edot = "\u0116";
      var edot = "\u0117";
      var eDot = "\u2251";
      var ee = "\u2147";
      var efDot = "\u2252";
      var Efr = "\u{1D508}";
      var efr = "\u{1D522}";
      var eg = "\u2A9A";
      var Egrave = "\xC8";
      var egrave = "\xE8";
      var egs = "\u2A96";
      var egsdot = "\u2A98";
      var el = "\u2A99";
      var Element = "\u2208";
      var elinters = "\u23E7";
      var ell = "\u2113";
      var els = "\u2A95";
      var elsdot = "\u2A97";
      var Emacr = "\u0112";
      var emacr = "\u0113";
      var empty = "\u2205";
      var emptyset = "\u2205";
      var EmptySmallSquare = "\u25FB";
      var emptyv = "\u2205";
      var EmptyVerySmallSquare = "\u25AB";
      var emsp13 = "\u2004";
      var emsp14 = "\u2005";
      var emsp = "\u2003";
      var ENG = "\u014A";
      var eng = "\u014B";
      var ensp = "\u2002";
      var Eogon = "\u0118";
      var eogon = "\u0119";
      var Eopf = "\u{1D53C}";
      var eopf = "\u{1D556}";
      var epar = "\u22D5";
      var eparsl = "\u29E3";
      var eplus = "\u2A71";
      var epsi = "\u03B5";
      var Epsilon = "\u0395";
      var epsilon = "\u03B5";
      var epsiv = "\u03F5";
      var eqcirc = "\u2256";
      var eqcolon = "\u2255";
      var eqsim = "\u2242";
      var eqslantgtr = "\u2A96";
      var eqslantless = "\u2A95";
      var Equal = "\u2A75";
      var equals = "=";
      var EqualTilde = "\u2242";
      var equest = "\u225F";
      var Equilibrium = "\u21CC";
      var equiv = "\u2261";
      var equivDD = "\u2A78";
      var eqvparsl = "\u29E5";
      var erarr = "\u2971";
      var erDot = "\u2253";
      var escr = "\u212F";
      var Escr = "\u2130";
      var esdot = "\u2250";
      var Esim = "\u2A73";
      var esim = "\u2242";
      var Eta = "\u0397";
      var eta = "\u03B7";
      var ETH = "\xD0";
      var eth = "\xF0";
      var Euml = "\xCB";
      var euml = "\xEB";
      var euro = "\u20AC";
      var excl = "!";
      var exist = "\u2203";
      var Exists = "\u2203";
      var expectation = "\u2130";
      var exponentiale = "\u2147";
      var ExponentialE = "\u2147";
      var fallingdotseq = "\u2252";
      var Fcy = "\u0424";
      var fcy = "\u0444";
      var female = "\u2640";
      var ffilig = "\uFB03";
      var fflig = "\uFB00";
      var ffllig = "\uFB04";
      var Ffr = "\u{1D509}";
      var ffr = "\u{1D523}";
      var filig = "\uFB01";
      var FilledSmallSquare = "\u25FC";
      var FilledVerySmallSquare = "\u25AA";
      var fjlig = "fj";
      var flat = "\u266D";
      var fllig = "\uFB02";
      var fltns = "\u25B1";
      var fnof = "\u0192";
      var Fopf = "\u{1D53D}";
      var fopf = "\u{1D557}";
      var forall = "\u2200";
      var ForAll = "\u2200";
      var fork = "\u22D4";
      var forkv = "\u2AD9";
      var Fouriertrf = "\u2131";
      var fpartint = "\u2A0D";
      var frac12 = "\xBD";
      var frac13 = "\u2153";
      var frac14 = "\xBC";
      var frac15 = "\u2155";
      var frac16 = "\u2159";
      var frac18 = "\u215B";
      var frac23 = "\u2154";
      var frac25 = "\u2156";
      var frac34 = "\xBE";
      var frac35 = "\u2157";
      var frac38 = "\u215C";
      var frac45 = "\u2158";
      var frac56 = "\u215A";
      var frac58 = "\u215D";
      var frac78 = "\u215E";
      var frasl = "\u2044";
      var frown = "\u2322";
      var fscr = "\u{1D4BB}";
      var Fscr = "\u2131";
      var gacute = "\u01F5";
      var Gamma = "\u0393";
      var gamma = "\u03B3";
      var Gammad = "\u03DC";
      var gammad = "\u03DD";
      var gap = "\u2A86";
      var Gbreve = "\u011E";
      var gbreve = "\u011F";
      var Gcedil = "\u0122";
      var Gcirc = "\u011C";
      var gcirc = "\u011D";
      var Gcy = "\u0413";
      var gcy = "\u0433";
      var Gdot = "\u0120";
      var gdot = "\u0121";
      var ge = "\u2265";
      var gE = "\u2267";
      var gEl = "\u2A8C";
      var gel = "\u22DB";
      var geq = "\u2265";
      var geqq = "\u2267";
      var geqslant = "\u2A7E";
      var gescc = "\u2AA9";
      var ges = "\u2A7E";
      var gesdot = "\u2A80";
      var gesdoto = "\u2A82";
      var gesdotol = "\u2A84";
      var gesl = "\u22DB\uFE00";
      var gesles = "\u2A94";
      var Gfr = "\u{1D50A}";
      var gfr = "\u{1D524}";
      var gg = "\u226B";
      var Gg = "\u22D9";
      var ggg = "\u22D9";
      var gimel = "\u2137";
      var GJcy = "\u0403";
      var gjcy = "\u0453";
      var gla = "\u2AA5";
      var gl = "\u2277";
      var glE = "\u2A92";
      var glj = "\u2AA4";
      var gnap = "\u2A8A";
      var gnapprox = "\u2A8A";
      var gne = "\u2A88";
      var gnE = "\u2269";
      var gneq = "\u2A88";
      var gneqq = "\u2269";
      var gnsim = "\u22E7";
      var Gopf = "\u{1D53E}";
      var gopf = "\u{1D558}";
      var grave = "`";
      var GreaterEqual = "\u2265";
      var GreaterEqualLess = "\u22DB";
      var GreaterFullEqual = "\u2267";
      var GreaterGreater = "\u2AA2";
      var GreaterLess = "\u2277";
      var GreaterSlantEqual = "\u2A7E";
      var GreaterTilde = "\u2273";
      var Gscr = "\u{1D4A2}";
      var gscr = "\u210A";
      var gsim = "\u2273";
      var gsime = "\u2A8E";
      var gsiml = "\u2A90";
      var gtcc = "\u2AA7";
      var gtcir = "\u2A7A";
      var gt = ">";
      var GT = ">";
      var Gt = "\u226B";
      var gtdot = "\u22D7";
      var gtlPar = "\u2995";
      var gtquest = "\u2A7C";
      var gtrapprox = "\u2A86";
      var gtrarr = "\u2978";
      var gtrdot = "\u22D7";
      var gtreqless = "\u22DB";
      var gtreqqless = "\u2A8C";
      var gtrless = "\u2277";
      var gtrsim = "\u2273";
      var gvertneqq = "\u2269\uFE00";
      var gvnE = "\u2269\uFE00";
      var Hacek = "\u02C7";
      var hairsp = "\u200A";
      var half = "\xBD";
      var hamilt = "\u210B";
      var HARDcy = "\u042A";
      var hardcy = "\u044A";
      var harrcir = "\u2948";
      var harr = "\u2194";
      var hArr = "\u21D4";
      var harrw = "\u21AD";
      var Hat = "^";
      var hbar = "\u210F";
      var Hcirc = "\u0124";
      var hcirc = "\u0125";
      var hearts = "\u2665";
      var heartsuit = "\u2665";
      var hellip = "\u2026";
      var hercon = "\u22B9";
      var hfr = "\u{1D525}";
      var Hfr = "\u210C";
      var HilbertSpace = "\u210B";
      var hksearow = "\u2925";
      var hkswarow = "\u2926";
      var hoarr = "\u21FF";
      var homtht = "\u223B";
      var hookleftarrow = "\u21A9";
      var hookrightarrow = "\u21AA";
      var hopf = "\u{1D559}";
      var Hopf = "\u210D";
      var horbar = "\u2015";
      var HorizontalLine = "\u2500";
      var hscr = "\u{1D4BD}";
      var Hscr = "\u210B";
      var hslash = "\u210F";
      var Hstrok = "\u0126";
      var hstrok = "\u0127";
      var HumpDownHump = "\u224E";
      var HumpEqual = "\u224F";
      var hybull = "\u2043";
      var hyphen = "\u2010";
      var Iacute = "\xCD";
      var iacute = "\xED";
      var ic = "\u2063";
      var Icirc = "\xCE";
      var icirc = "\xEE";
      var Icy = "\u0418";
      var icy = "\u0438";
      var Idot = "\u0130";
      var IEcy = "\u0415";
      var iecy = "\u0435";
      var iexcl = "\xA1";
      var iff = "\u21D4";
      var ifr = "\u{1D526}";
      var Ifr = "\u2111";
      var Igrave = "\xCC";
      var igrave = "\xEC";
      var ii = "\u2148";
      var iiiint = "\u2A0C";
      var iiint = "\u222D";
      var iinfin = "\u29DC";
      var iiota = "\u2129";
      var IJlig = "\u0132";
      var ijlig = "\u0133";
      var Imacr = "\u012A";
      var imacr = "\u012B";
      var image = "\u2111";
      var ImaginaryI = "\u2148";
      var imagline = "\u2110";
      var imagpart = "\u2111";
      var imath = "\u0131";
      var Im = "\u2111";
      var imof = "\u22B7";
      var imped = "\u01B5";
      var Implies = "\u21D2";
      var incare = "\u2105";
      var infin = "\u221E";
      var infintie = "\u29DD";
      var inodot = "\u0131";
      var intcal = "\u22BA";
      var int = "\u222B";
      var Int = "\u222C";
      var integers = "\u2124";
      var Integral = "\u222B";
      var intercal = "\u22BA";
      var Intersection = "\u22C2";
      var intlarhk = "\u2A17";
      var intprod = "\u2A3C";
      var InvisibleComma = "\u2063";
      var InvisibleTimes = "\u2062";
      var IOcy = "\u0401";
      var iocy = "\u0451";
      var Iogon = "\u012E";
      var iogon = "\u012F";
      var Iopf = "\u{1D540}";
      var iopf = "\u{1D55A}";
      var Iota = "\u0399";
      var iota = "\u03B9";
      var iprod = "\u2A3C";
      var iquest = "\xBF";
      var iscr = "\u{1D4BE}";
      var Iscr = "\u2110";
      var isin = "\u2208";
      var isindot = "\u22F5";
      var isinE = "\u22F9";
      var isins = "\u22F4";
      var isinsv = "\u22F3";
      var isinv = "\u2208";
      var it = "\u2062";
      var Itilde = "\u0128";
      var itilde = "\u0129";
      var Iukcy = "\u0406";
      var iukcy = "\u0456";
      var Iuml = "\xCF";
      var iuml = "\xEF";
      var Jcirc = "\u0134";
      var jcirc = "\u0135";
      var Jcy = "\u0419";
      var jcy = "\u0439";
      var Jfr = "\u{1D50D}";
      var jfr = "\u{1D527}";
      var jmath = "\u0237";
      var Jopf = "\u{1D541}";
      var jopf = "\u{1D55B}";
      var Jscr = "\u{1D4A5}";
      var jscr = "\u{1D4BF}";
      var Jsercy = "\u0408";
      var jsercy = "\u0458";
      var Jukcy = "\u0404";
      var jukcy = "\u0454";
      var Kappa = "\u039A";
      var kappa = "\u03BA";
      var kappav = "\u03F0";
      var Kcedil = "\u0136";
      var kcedil = "\u0137";
      var Kcy = "\u041A";
      var kcy = "\u043A";
      var Kfr = "\u{1D50E}";
      var kfr = "\u{1D528}";
      var kgreen = "\u0138";
      var KHcy = "\u0425";
      var khcy = "\u0445";
      var KJcy = "\u040C";
      var kjcy = "\u045C";
      var Kopf = "\u{1D542}";
      var kopf = "\u{1D55C}";
      var Kscr = "\u{1D4A6}";
      var kscr = "\u{1D4C0}";
      var lAarr = "\u21DA";
      var Lacute = "\u0139";
      var lacute = "\u013A";
      var laemptyv = "\u29B4";
      var lagran = "\u2112";
      var Lambda = "\u039B";
      var lambda = "\u03BB";
      var lang = "\u27E8";
      var Lang = "\u27EA";
      var langd = "\u2991";
      var langle = "\u27E8";
      var lap = "\u2A85";
      var Laplacetrf = "\u2112";
      var laquo = "\xAB";
      var larrb = "\u21E4";
      var larrbfs = "\u291F";
      var larr = "\u2190";
      var Larr = "\u219E";
      var lArr = "\u21D0";
      var larrfs = "\u291D";
      var larrhk = "\u21A9";
      var larrlp = "\u21AB";
      var larrpl = "\u2939";
      var larrsim = "\u2973";
      var larrtl = "\u21A2";
      var latail = "\u2919";
      var lAtail = "\u291B";
      var lat = "\u2AAB";
      var late = "\u2AAD";
      var lates = "\u2AAD\uFE00";
      var lbarr = "\u290C";
      var lBarr = "\u290E";
      var lbbrk = "\u2772";
      var lbrace = "{";
      var lbrack = "[";
      var lbrke = "\u298B";
      var lbrksld = "\u298F";
      var lbrkslu = "\u298D";
      var Lcaron = "\u013D";
      var lcaron = "\u013E";
      var Lcedil = "\u013B";
      var lcedil = "\u013C";
      var lceil = "\u2308";
      var lcub = "{";
      var Lcy = "\u041B";
      var lcy = "\u043B";
      var ldca = "\u2936";
      var ldquo = "\u201C";
      var ldquor = "\u201E";
      var ldrdhar = "\u2967";
      var ldrushar = "\u294B";
      var ldsh = "\u21B2";
      var le = "\u2264";
      var lE = "\u2266";
      var LeftAngleBracket = "\u27E8";
      var LeftArrowBar = "\u21E4";
      var leftarrow = "\u2190";
      var LeftArrow = "\u2190";
      var Leftarrow = "\u21D0";
      var LeftArrowRightArrow = "\u21C6";
      var leftarrowtail = "\u21A2";
      var LeftCeiling = "\u2308";
      var LeftDoubleBracket = "\u27E6";
      var LeftDownTeeVector = "\u2961";
      var LeftDownVectorBar = "\u2959";
      var LeftDownVector = "\u21C3";
      var LeftFloor = "\u230A";
      var leftharpoondown = "\u21BD";
      var leftharpoonup = "\u21BC";
      var leftleftarrows = "\u21C7";
      var leftrightarrow = "\u2194";
      var LeftRightArrow = "\u2194";
      var Leftrightarrow = "\u21D4";
      var leftrightarrows = "\u21C6";
      var leftrightharpoons = "\u21CB";
      var leftrightsquigarrow = "\u21AD";
      var LeftRightVector = "\u294E";
      var LeftTeeArrow = "\u21A4";
      var LeftTee = "\u22A3";
      var LeftTeeVector = "\u295A";
      var leftthreetimes = "\u22CB";
      var LeftTriangleBar = "\u29CF";
      var LeftTriangle = "\u22B2";
      var LeftTriangleEqual = "\u22B4";
      var LeftUpDownVector = "\u2951";
      var LeftUpTeeVector = "\u2960";
      var LeftUpVectorBar = "\u2958";
      var LeftUpVector = "\u21BF";
      var LeftVectorBar = "\u2952";
      var LeftVector = "\u21BC";
      var lEg = "\u2A8B";
      var leg = "\u22DA";
      var leq = "\u2264";
      var leqq = "\u2266";
      var leqslant = "\u2A7D";
      var lescc = "\u2AA8";
      var les = "\u2A7D";
      var lesdot = "\u2A7F";
      var lesdoto = "\u2A81";
      var lesdotor = "\u2A83";
      var lesg = "\u22DA\uFE00";
      var lesges = "\u2A93";
      var lessapprox = "\u2A85";
      var lessdot = "\u22D6";
      var lesseqgtr = "\u22DA";
      var lesseqqgtr = "\u2A8B";
      var LessEqualGreater = "\u22DA";
      var LessFullEqual = "\u2266";
      var LessGreater = "\u2276";
      var lessgtr = "\u2276";
      var LessLess = "\u2AA1";
      var lesssim = "\u2272";
      var LessSlantEqual = "\u2A7D";
      var LessTilde = "\u2272";
      var lfisht = "\u297C";
      var lfloor = "\u230A";
      var Lfr = "\u{1D50F}";
      var lfr = "\u{1D529}";
      var lg = "\u2276";
      var lgE = "\u2A91";
      var lHar = "\u2962";
      var lhard = "\u21BD";
      var lharu = "\u21BC";
      var lharul = "\u296A";
      var lhblk = "\u2584";
      var LJcy = "\u0409";
      var ljcy = "\u0459";
      var llarr = "\u21C7";
      var ll = "\u226A";
      var Ll = "\u22D8";
      var llcorner = "\u231E";
      var Lleftarrow = "\u21DA";
      var llhard = "\u296B";
      var lltri = "\u25FA";
      var Lmidot = "\u013F";
      var lmidot = "\u0140";
      var lmoustache = "\u23B0";
      var lmoust = "\u23B0";
      var lnap = "\u2A89";
      var lnapprox = "\u2A89";
      var lne = "\u2A87";
      var lnE = "\u2268";
      var lneq = "\u2A87";
      var lneqq = "\u2268";
      var lnsim = "\u22E6";
      var loang = "\u27EC";
      var loarr = "\u21FD";
      var lobrk = "\u27E6";
      var longleftarrow = "\u27F5";
      var LongLeftArrow = "\u27F5";
      var Longleftarrow = "\u27F8";
      var longleftrightarrow = "\u27F7";
      var LongLeftRightArrow = "\u27F7";
      var Longleftrightarrow = "\u27FA";
      var longmapsto = "\u27FC";
      var longrightarrow = "\u27F6";
      var LongRightArrow = "\u27F6";
      var Longrightarrow = "\u27F9";
      var looparrowleft = "\u21AB";
      var looparrowright = "\u21AC";
      var lopar = "\u2985";
      var Lopf = "\u{1D543}";
      var lopf = "\u{1D55D}";
      var loplus = "\u2A2D";
      var lotimes = "\u2A34";
      var lowast = "\u2217";
      var lowbar = "_";
      var LowerLeftArrow = "\u2199";
      var LowerRightArrow = "\u2198";
      var loz = "\u25CA";
      var lozenge = "\u25CA";
      var lozf = "\u29EB";
      var lpar = "(";
      var lparlt = "\u2993";
      var lrarr = "\u21C6";
      var lrcorner = "\u231F";
      var lrhar = "\u21CB";
      var lrhard = "\u296D";
      var lrm = "\u200E";
      var lrtri = "\u22BF";
      var lsaquo = "\u2039";
      var lscr = "\u{1D4C1}";
      var Lscr = "\u2112";
      var lsh = "\u21B0";
      var Lsh = "\u21B0";
      var lsim = "\u2272";
      var lsime = "\u2A8D";
      var lsimg = "\u2A8F";
      var lsqb = "[";
      var lsquo = "\u2018";
      var lsquor = "\u201A";
      var Lstrok = "\u0141";
      var lstrok = "\u0142";
      var ltcc = "\u2AA6";
      var ltcir = "\u2A79";
      var lt = "<";
      var LT = "<";
      var Lt = "\u226A";
      var ltdot = "\u22D6";
      var lthree = "\u22CB";
      var ltimes = "\u22C9";
      var ltlarr = "\u2976";
      var ltquest = "\u2A7B";
      var ltri = "\u25C3";
      var ltrie = "\u22B4";
      var ltrif = "\u25C2";
      var ltrPar = "\u2996";
      var lurdshar = "\u294A";
      var luruhar = "\u2966";
      var lvertneqq = "\u2268\uFE00";
      var lvnE = "\u2268\uFE00";
      var macr = "\xAF";
      var male = "\u2642";
      var malt = "\u2720";
      var maltese = "\u2720";
      var map = "\u21A6";
      var mapsto = "\u21A6";
      var mapstodown = "\u21A7";
      var mapstoleft = "\u21A4";
      var mapstoup = "\u21A5";
      var marker = "\u25AE";
      var mcomma = "\u2A29";
      var Mcy = "\u041C";
      var mcy = "\u043C";
      var mdash = "\u2014";
      var mDDot = "\u223A";
      var measuredangle = "\u2221";
      var MediumSpace = "\u205F";
      var Mellintrf = "\u2133";
      var Mfr = "\u{1D510}";
      var mfr = "\u{1D52A}";
      var mho = "\u2127";
      var micro = "\xB5";
      var midast = "*";
      var midcir = "\u2AF0";
      var mid = "\u2223";
      var middot = "\xB7";
      var minusb = "\u229F";
      var minus = "\u2212";
      var minusd = "\u2238";
      var minusdu = "\u2A2A";
      var MinusPlus = "\u2213";
      var mlcp = "\u2ADB";
      var mldr = "\u2026";
      var mnplus = "\u2213";
      var models = "\u22A7";
      var Mopf = "\u{1D544}";
      var mopf = "\u{1D55E}";
      var mp = "\u2213";
      var mscr = "\u{1D4C2}";
      var Mscr = "\u2133";
      var mstpos = "\u223E";
      var Mu = "\u039C";
      var mu = "\u03BC";
      var multimap = "\u22B8";
      var mumap = "\u22B8";
      var nabla = "\u2207";
      var Nacute = "\u0143";
      var nacute = "\u0144";
      var nang = "\u2220\u20D2";
      var nap = "\u2249";
      var napE = "\u2A70\u0338";
      var napid = "\u224B\u0338";
      var napos = "\u0149";
      var napprox = "\u2249";
      var natural = "\u266E";
      var naturals = "\u2115";
      var natur = "\u266E";
      var nbsp = "\xA0";
      var nbump = "\u224E\u0338";
      var nbumpe = "\u224F\u0338";
      var ncap = "\u2A43";
      var Ncaron = "\u0147";
      var ncaron = "\u0148";
      var Ncedil = "\u0145";
      var ncedil = "\u0146";
      var ncong = "\u2247";
      var ncongdot = "\u2A6D\u0338";
      var ncup = "\u2A42";
      var Ncy = "\u041D";
      var ncy = "\u043D";
      var ndash = "\u2013";
      var nearhk = "\u2924";
      var nearr = "\u2197";
      var neArr = "\u21D7";
      var nearrow = "\u2197";
      var ne = "\u2260";
      var nedot = "\u2250\u0338";
      var NegativeMediumSpace = "\u200B";
      var NegativeThickSpace = "\u200B";
      var NegativeThinSpace = "\u200B";
      var NegativeVeryThinSpace = "\u200B";
      var nequiv = "\u2262";
      var nesear = "\u2928";
      var nesim = "\u2242\u0338";
      var NestedGreaterGreater = "\u226B";
      var NestedLessLess = "\u226A";
      var NewLine = "\n";
      var nexist = "\u2204";
      var nexists = "\u2204";
      var Nfr = "\u{1D511}";
      var nfr = "\u{1D52B}";
      var ngE = "\u2267\u0338";
      var nge = "\u2271";
      var ngeq = "\u2271";
      var ngeqq = "\u2267\u0338";
      var ngeqslant = "\u2A7E\u0338";
      var nges = "\u2A7E\u0338";
      var nGg = "\u22D9\u0338";
      var ngsim = "\u2275";
      var nGt = "\u226B\u20D2";
      var ngt = "\u226F";
      var ngtr = "\u226F";
      var nGtv = "\u226B\u0338";
      var nharr = "\u21AE";
      var nhArr = "\u21CE";
      var nhpar = "\u2AF2";
      var ni = "\u220B";
      var nis = "\u22FC";
      var nisd = "\u22FA";
      var niv = "\u220B";
      var NJcy = "\u040A";
      var njcy = "\u045A";
      var nlarr = "\u219A";
      var nlArr = "\u21CD";
      var nldr = "\u2025";
      var nlE = "\u2266\u0338";
      var nle = "\u2270";
      var nleftarrow = "\u219A";
      var nLeftarrow = "\u21CD";
      var nleftrightarrow = "\u21AE";
      var nLeftrightarrow = "\u21CE";
      var nleq = "\u2270";
      var nleqq = "\u2266\u0338";
      var nleqslant = "\u2A7D\u0338";
      var nles = "\u2A7D\u0338";
      var nless = "\u226E";
      var nLl = "\u22D8\u0338";
      var nlsim = "\u2274";
      var nLt = "\u226A\u20D2";
      var nlt = "\u226E";
      var nltri = "\u22EA";
      var nltrie = "\u22EC";
      var nLtv = "\u226A\u0338";
      var nmid = "\u2224";
      var NoBreak = "\u2060";
      var NonBreakingSpace = "\xA0";
      var nopf = "\u{1D55F}";
      var Nopf = "\u2115";
      var Not = "\u2AEC";
      var not = "\xAC";
      var NotCongruent = "\u2262";
      var NotCupCap = "\u226D";
      var NotDoubleVerticalBar = "\u2226";
      var NotElement = "\u2209";
      var NotEqual = "\u2260";
      var NotEqualTilde = "\u2242\u0338";
      var NotExists = "\u2204";
      var NotGreater = "\u226F";
      var NotGreaterEqual = "\u2271";
      var NotGreaterFullEqual = "\u2267\u0338";
      var NotGreaterGreater = "\u226B\u0338";
      var NotGreaterLess = "\u2279";
      var NotGreaterSlantEqual = "\u2A7E\u0338";
      var NotGreaterTilde = "\u2275";
      var NotHumpDownHump = "\u224E\u0338";
      var NotHumpEqual = "\u224F\u0338";
      var notin = "\u2209";
      var notindot = "\u22F5\u0338";
      var notinE = "\u22F9\u0338";
      var notinva = "\u2209";
      var notinvb = "\u22F7";
      var notinvc = "\u22F6";
      var NotLeftTriangleBar = "\u29CF\u0338";
      var NotLeftTriangle = "\u22EA";
      var NotLeftTriangleEqual = "\u22EC";
      var NotLess = "\u226E";
      var NotLessEqual = "\u2270";
      var NotLessGreater = "\u2278";
      var NotLessLess = "\u226A\u0338";
      var NotLessSlantEqual = "\u2A7D\u0338";
      var NotLessTilde = "\u2274";
      var NotNestedGreaterGreater = "\u2AA2\u0338";
      var NotNestedLessLess = "\u2AA1\u0338";
      var notni = "\u220C";
      var notniva = "\u220C";
      var notnivb = "\u22FE";
      var notnivc = "\u22FD";
      var NotPrecedes = "\u2280";
      var NotPrecedesEqual = "\u2AAF\u0338";
      var NotPrecedesSlantEqual = "\u22E0";
      var NotReverseElement = "\u220C";
      var NotRightTriangleBar = "\u29D0\u0338";
      var NotRightTriangle = "\u22EB";
      var NotRightTriangleEqual = "\u22ED";
      var NotSquareSubset = "\u228F\u0338";
      var NotSquareSubsetEqual = "\u22E2";
      var NotSquareSuperset = "\u2290\u0338";
      var NotSquareSupersetEqual = "\u22E3";
      var NotSubset = "\u2282\u20D2";
      var NotSubsetEqual = "\u2288";
      var NotSucceeds = "\u2281";
      var NotSucceedsEqual = "\u2AB0\u0338";
      var NotSucceedsSlantEqual = "\u22E1";
      var NotSucceedsTilde = "\u227F\u0338";
      var NotSuperset = "\u2283\u20D2";
      var NotSupersetEqual = "\u2289";
      var NotTilde = "\u2241";
      var NotTildeEqual = "\u2244";
      var NotTildeFullEqual = "\u2247";
      var NotTildeTilde = "\u2249";
      var NotVerticalBar = "\u2224";
      var nparallel = "\u2226";
      var npar = "\u2226";
      var nparsl = "\u2AFD\u20E5";
      var npart = "\u2202\u0338";
      var npolint = "\u2A14";
      var npr = "\u2280";
      var nprcue = "\u22E0";
      var nprec = "\u2280";
      var npreceq = "\u2AAF\u0338";
      var npre = "\u2AAF\u0338";
      var nrarrc = "\u2933\u0338";
      var nrarr = "\u219B";
      var nrArr = "\u21CF";
      var nrarrw = "\u219D\u0338";
      var nrightarrow = "\u219B";
      var nRightarrow = "\u21CF";
      var nrtri = "\u22EB";
      var nrtrie = "\u22ED";
      var nsc = "\u2281";
      var nsccue = "\u22E1";
      var nsce = "\u2AB0\u0338";
      var Nscr = "\u{1D4A9}";
      var nscr = "\u{1D4C3}";
      var nshortmid = "\u2224";
      var nshortparallel = "\u2226";
      var nsim = "\u2241";
      var nsime = "\u2244";
      var nsimeq = "\u2244";
      var nsmid = "\u2224";
      var nspar = "\u2226";
      var nsqsube = "\u22E2";
      var nsqsupe = "\u22E3";
      var nsub = "\u2284";
      var nsubE = "\u2AC5\u0338";
      var nsube = "\u2288";
      var nsubset = "\u2282\u20D2";
      var nsubseteq = "\u2288";
      var nsubseteqq = "\u2AC5\u0338";
      var nsucc = "\u2281";
      var nsucceq = "\u2AB0\u0338";
      var nsup = "\u2285";
      var nsupE = "\u2AC6\u0338";
      var nsupe = "\u2289";
      var nsupset = "\u2283\u20D2";
      var nsupseteq = "\u2289";
      var nsupseteqq = "\u2AC6\u0338";
      var ntgl = "\u2279";
      var Ntilde = "\xD1";
      var ntilde = "\xF1";
      var ntlg = "\u2278";
      var ntriangleleft = "\u22EA";
      var ntrianglelefteq = "\u22EC";
      var ntriangleright = "\u22EB";
      var ntrianglerighteq = "\u22ED";
      var Nu = "\u039D";
      var nu = "\u03BD";
      var num = "#";
      var numero = "\u2116";
      var numsp = "\u2007";
      var nvap = "\u224D\u20D2";
      var nvdash = "\u22AC";
      var nvDash = "\u22AD";
      var nVdash = "\u22AE";
      var nVDash = "\u22AF";
      var nvge = "\u2265\u20D2";
      var nvgt = ">\u20D2";
      var nvHarr = "\u2904";
      var nvinfin = "\u29DE";
      var nvlArr = "\u2902";
      var nvle = "\u2264\u20D2";
      var nvlt = "<\u20D2";
      var nvltrie = "\u22B4\u20D2";
      var nvrArr = "\u2903";
      var nvrtrie = "\u22B5\u20D2";
      var nvsim = "\u223C\u20D2";
      var nwarhk = "\u2923";
      var nwarr = "\u2196";
      var nwArr = "\u21D6";
      var nwarrow = "\u2196";
      var nwnear = "\u2927";
      var Oacute = "\xD3";
      var oacute = "\xF3";
      var oast = "\u229B";
      var Ocirc = "\xD4";
      var ocirc = "\xF4";
      var ocir = "\u229A";
      var Ocy = "\u041E";
      var ocy = "\u043E";
      var odash = "\u229D";
      var Odblac = "\u0150";
      var odblac = "\u0151";
      var odiv = "\u2A38";
      var odot = "\u2299";
      var odsold = "\u29BC";
      var OElig = "\u0152";
      var oelig = "\u0153";
      var ofcir = "\u29BF";
      var Ofr = "\u{1D512}";
      var ofr = "\u{1D52C}";
      var ogon = "\u02DB";
      var Ograve = "\xD2";
      var ograve = "\xF2";
      var ogt = "\u29C1";
      var ohbar = "\u29B5";
      var ohm = "\u03A9";
      var oint = "\u222E";
      var olarr = "\u21BA";
      var olcir = "\u29BE";
      var olcross = "\u29BB";
      var oline = "\u203E";
      var olt = "\u29C0";
      var Omacr = "\u014C";
      var omacr = "\u014D";
      var Omega = "\u03A9";
      var omega = "\u03C9";
      var Omicron = "\u039F";
      var omicron = "\u03BF";
      var omid = "\u29B6";
      var ominus = "\u2296";
      var Oopf = "\u{1D546}";
      var oopf = "\u{1D560}";
      var opar = "\u29B7";
      var OpenCurlyDoubleQuote = "\u201C";
      var OpenCurlyQuote = "\u2018";
      var operp = "\u29B9";
      var oplus = "\u2295";
      var orarr = "\u21BB";
      var Or = "\u2A54";
      var or = "\u2228";
      var ord = "\u2A5D";
      var order = "\u2134";
      var orderof = "\u2134";
      var ordf = "\xAA";
      var ordm = "\xBA";
      var origof = "\u22B6";
      var oror = "\u2A56";
      var orslope = "\u2A57";
      var orv = "\u2A5B";
      var oS = "\u24C8";
      var Oscr = "\u{1D4AA}";
      var oscr = "\u2134";
      var Oslash = "\xD8";
      var oslash = "\xF8";
      var osol = "\u2298";
      var Otilde = "\xD5";
      var otilde = "\xF5";
      var otimesas = "\u2A36";
      var Otimes = "\u2A37";
      var otimes = "\u2297";
      var Ouml = "\xD6";
      var ouml = "\xF6";
      var ovbar = "\u233D";
      var OverBar = "\u203E";
      var OverBrace = "\u23DE";
      var OverBracket = "\u23B4";
      var OverParenthesis = "\u23DC";
      var para = "\xB6";
      var parallel = "\u2225";
      var par = "\u2225";
      var parsim = "\u2AF3";
      var parsl = "\u2AFD";
      var part = "\u2202";
      var PartialD = "\u2202";
      var Pcy = "\u041F";
      var pcy = "\u043F";
      var percnt = "%";
      var period = ".";
      var permil = "\u2030";
      var perp = "\u22A5";
      var pertenk = "\u2031";
      var Pfr = "\u{1D513}";
      var pfr = "\u{1D52D}";
      var Phi = "\u03A6";
      var phi = "\u03C6";
      var phiv = "\u03D5";
      var phmmat = "\u2133";
      var phone = "\u260E";
      var Pi = "\u03A0";
      var pi = "\u03C0";
      var pitchfork = "\u22D4";
      var piv = "\u03D6";
      var planck = "\u210F";
      var planckh = "\u210E";
      var plankv = "\u210F";
      var plusacir = "\u2A23";
      var plusb = "\u229E";
      var pluscir = "\u2A22";
      var plus = "+";
      var plusdo = "\u2214";
      var plusdu = "\u2A25";
      var pluse = "\u2A72";
      var PlusMinus = "\xB1";
      var plusmn = "\xB1";
      var plussim = "\u2A26";
      var plustwo = "\u2A27";
      var pm = "\xB1";
      var Poincareplane = "\u210C";
      var pointint = "\u2A15";
      var popf = "\u{1D561}";
      var Popf = "\u2119";
      var pound = "\xA3";
      var prap = "\u2AB7";
      var Pr = "\u2ABB";
      var pr = "\u227A";
      var prcue = "\u227C";
      var precapprox = "\u2AB7";
      var prec = "\u227A";
      var preccurlyeq = "\u227C";
      var Precedes = "\u227A";
      var PrecedesEqual = "\u2AAF";
      var PrecedesSlantEqual = "\u227C";
      var PrecedesTilde = "\u227E";
      var preceq = "\u2AAF";
      var precnapprox = "\u2AB9";
      var precneqq = "\u2AB5";
      var precnsim = "\u22E8";
      var pre = "\u2AAF";
      var prE = "\u2AB3";
      var precsim = "\u227E";
      var prime = "\u2032";
      var Prime = "\u2033";
      var primes = "\u2119";
      var prnap = "\u2AB9";
      var prnE = "\u2AB5";
      var prnsim = "\u22E8";
      var prod = "\u220F";
      var Product = "\u220F";
      var profalar = "\u232E";
      var profline = "\u2312";
      var profsurf = "\u2313";
      var prop = "\u221D";
      var Proportional = "\u221D";
      var Proportion = "\u2237";
      var propto = "\u221D";
      var prsim = "\u227E";
      var prurel = "\u22B0";
      var Pscr = "\u{1D4AB}";
      var pscr = "\u{1D4C5}";
      var Psi = "\u03A8";
      var psi = "\u03C8";
      var puncsp = "\u2008";
      var Qfr = "\u{1D514}";
      var qfr = "\u{1D52E}";
      var qint = "\u2A0C";
      var qopf = "\u{1D562}";
      var Qopf = "\u211A";
      var qprime = "\u2057";
      var Qscr = "\u{1D4AC}";
      var qscr = "\u{1D4C6}";
      var quaternions = "\u210D";
      var quatint = "\u2A16";
      var quest = "?";
      var questeq = "\u225F";
      var quot = '"';
      var QUOT = '"';
      var rAarr = "\u21DB";
      var race = "\u223D\u0331";
      var Racute = "\u0154";
      var racute = "\u0155";
      var radic = "\u221A";
      var raemptyv = "\u29B3";
      var rang = "\u27E9";
      var Rang = "\u27EB";
      var rangd = "\u2992";
      var range = "\u29A5";
      var rangle = "\u27E9";
      var raquo = "\xBB";
      var rarrap = "\u2975";
      var rarrb = "\u21E5";
      var rarrbfs = "\u2920";
      var rarrc = "\u2933";
      var rarr = "\u2192";
      var Rarr = "\u21A0";
      var rArr = "\u21D2";
      var rarrfs = "\u291E";
      var rarrhk = "\u21AA";
      var rarrlp = "\u21AC";
      var rarrpl = "\u2945";
      var rarrsim = "\u2974";
      var Rarrtl = "\u2916";
      var rarrtl = "\u21A3";
      var rarrw = "\u219D";
      var ratail = "\u291A";
      var rAtail = "\u291C";
      var ratio = "\u2236";
      var rationals = "\u211A";
      var rbarr = "\u290D";
      var rBarr = "\u290F";
      var RBarr = "\u2910";
      var rbbrk = "\u2773";
      var rbrace = "}";
      var rbrack = "]";
      var rbrke = "\u298C";
      var rbrksld = "\u298E";
      var rbrkslu = "\u2990";
      var Rcaron = "\u0158";
      var rcaron = "\u0159";
      var Rcedil = "\u0156";
      var rcedil = "\u0157";
      var rceil = "\u2309";
      var rcub = "}";
      var Rcy = "\u0420";
      var rcy = "\u0440";
      var rdca = "\u2937";
      var rdldhar = "\u2969";
      var rdquo = "\u201D";
      var rdquor = "\u201D";
      var rdsh = "\u21B3";
      var real = "\u211C";
      var realine = "\u211B";
      var realpart = "\u211C";
      var reals = "\u211D";
      var Re = "\u211C";
      var rect = "\u25AD";
      var reg = "\xAE";
      var REG = "\xAE";
      var ReverseElement = "\u220B";
      var ReverseEquilibrium = "\u21CB";
      var ReverseUpEquilibrium = "\u296F";
      var rfisht = "\u297D";
      var rfloor = "\u230B";
      var rfr = "\u{1D52F}";
      var Rfr = "\u211C";
      var rHar = "\u2964";
      var rhard = "\u21C1";
      var rharu = "\u21C0";
      var rharul = "\u296C";
      var Rho = "\u03A1";
      var rho = "\u03C1";
      var rhov = "\u03F1";
      var RightAngleBracket = "\u27E9";
      var RightArrowBar = "\u21E5";
      var rightarrow = "\u2192";
      var RightArrow = "\u2192";
      var Rightarrow = "\u21D2";
      var RightArrowLeftArrow = "\u21C4";
      var rightarrowtail = "\u21A3";
      var RightCeiling = "\u2309";
      var RightDoubleBracket = "\u27E7";
      var RightDownTeeVector = "\u295D";
      var RightDownVectorBar = "\u2955";
      var RightDownVector = "\u21C2";
      var RightFloor = "\u230B";
      var rightharpoondown = "\u21C1";
      var rightharpoonup = "\u21C0";
      var rightleftarrows = "\u21C4";
      var rightleftharpoons = "\u21CC";
      var rightrightarrows = "\u21C9";
      var rightsquigarrow = "\u219D";
      var RightTeeArrow = "\u21A6";
      var RightTee = "\u22A2";
      var RightTeeVector = "\u295B";
      var rightthreetimes = "\u22CC";
      var RightTriangleBar = "\u29D0";
      var RightTriangle = "\u22B3";
      var RightTriangleEqual = "\u22B5";
      var RightUpDownVector = "\u294F";
      var RightUpTeeVector = "\u295C";
      var RightUpVectorBar = "\u2954";
      var RightUpVector = "\u21BE";
      var RightVectorBar = "\u2953";
      var RightVector = "\u21C0";
      var ring = "\u02DA";
      var risingdotseq = "\u2253";
      var rlarr = "\u21C4";
      var rlhar = "\u21CC";
      var rlm = "\u200F";
      var rmoustache = "\u23B1";
      var rmoust = "\u23B1";
      var rnmid = "\u2AEE";
      var roang = "\u27ED";
      var roarr = "\u21FE";
      var robrk = "\u27E7";
      var ropar = "\u2986";
      var ropf = "\u{1D563}";
      var Ropf = "\u211D";
      var roplus = "\u2A2E";
      var rotimes = "\u2A35";
      var RoundImplies = "\u2970";
      var rpar = ")";
      var rpargt = "\u2994";
      var rppolint = "\u2A12";
      var rrarr = "\u21C9";
      var Rrightarrow = "\u21DB";
      var rsaquo = "\u203A";
      var rscr = "\u{1D4C7}";
      var Rscr = "\u211B";
      var rsh = "\u21B1";
      var Rsh = "\u21B1";
      var rsqb = "]";
      var rsquo = "\u2019";
      var rsquor = "\u2019";
      var rthree = "\u22CC";
      var rtimes = "\u22CA";
      var rtri = "\u25B9";
      var rtrie = "\u22B5";
      var rtrif = "\u25B8";
      var rtriltri = "\u29CE";
      var RuleDelayed = "\u29F4";
      var ruluhar = "\u2968";
      var rx = "\u211E";
      var Sacute = "\u015A";
      var sacute = "\u015B";
      var sbquo = "\u201A";
      var scap = "\u2AB8";
      var Scaron = "\u0160";
      var scaron = "\u0161";
      var Sc = "\u2ABC";
      var sc = "\u227B";
      var sccue = "\u227D";
      var sce = "\u2AB0";
      var scE = "\u2AB4";
      var Scedil = "\u015E";
      var scedil = "\u015F";
      var Scirc = "\u015C";
      var scirc = "\u015D";
      var scnap = "\u2ABA";
      var scnE = "\u2AB6";
      var scnsim = "\u22E9";
      var scpolint = "\u2A13";
      var scsim = "\u227F";
      var Scy = "\u0421";
      var scy = "\u0441";
      var sdotb = "\u22A1";
      var sdot = "\u22C5";
      var sdote = "\u2A66";
      var searhk = "\u2925";
      var searr = "\u2198";
      var seArr = "\u21D8";
      var searrow = "\u2198";
      var sect = "\xA7";
      var semi = ";";
      var seswar = "\u2929";
      var setminus = "\u2216";
      var setmn = "\u2216";
      var sext = "\u2736";
      var Sfr = "\u{1D516}";
      var sfr = "\u{1D530}";
      var sfrown = "\u2322";
      var sharp = "\u266F";
      var SHCHcy = "\u0429";
      var shchcy = "\u0449";
      var SHcy = "\u0428";
      var shcy = "\u0448";
      var ShortDownArrow = "\u2193";
      var ShortLeftArrow = "\u2190";
      var shortmid = "\u2223";
      var shortparallel = "\u2225";
      var ShortRightArrow = "\u2192";
      var ShortUpArrow = "\u2191";
      var shy = "\xAD";
      var Sigma = "\u03A3";
      var sigma = "\u03C3";
      var sigmaf = "\u03C2";
      var sigmav = "\u03C2";
      var sim = "\u223C";
      var simdot = "\u2A6A";
      var sime = "\u2243";
      var simeq = "\u2243";
      var simg = "\u2A9E";
      var simgE = "\u2AA0";
      var siml = "\u2A9D";
      var simlE = "\u2A9F";
      var simne = "\u2246";
      var simplus = "\u2A24";
      var simrarr = "\u2972";
      var slarr = "\u2190";
      var SmallCircle = "\u2218";
      var smallsetminus = "\u2216";
      var smashp = "\u2A33";
      var smeparsl = "\u29E4";
      var smid = "\u2223";
      var smile = "\u2323";
      var smt = "\u2AAA";
      var smte = "\u2AAC";
      var smtes = "\u2AAC\uFE00";
      var SOFTcy = "\u042C";
      var softcy = "\u044C";
      var solbar = "\u233F";
      var solb = "\u29C4";
      var sol = "/";
      var Sopf = "\u{1D54A}";
      var sopf = "\u{1D564}";
      var spades = "\u2660";
      var spadesuit = "\u2660";
      var spar = "\u2225";
      var sqcap = "\u2293";
      var sqcaps = "\u2293\uFE00";
      var sqcup = "\u2294";
      var sqcups = "\u2294\uFE00";
      var Sqrt = "\u221A";
      var sqsub = "\u228F";
      var sqsube = "\u2291";
      var sqsubset = "\u228F";
      var sqsubseteq = "\u2291";
      var sqsup = "\u2290";
      var sqsupe = "\u2292";
      var sqsupset = "\u2290";
      var sqsupseteq = "\u2292";
      var square = "\u25A1";
      var Square = "\u25A1";
      var SquareIntersection = "\u2293";
      var SquareSubset = "\u228F";
      var SquareSubsetEqual = "\u2291";
      var SquareSuperset = "\u2290";
      var SquareSupersetEqual = "\u2292";
      var SquareUnion = "\u2294";
      var squarf = "\u25AA";
      var squ = "\u25A1";
      var squf = "\u25AA";
      var srarr = "\u2192";
      var Sscr = "\u{1D4AE}";
      var sscr = "\u{1D4C8}";
      var ssetmn = "\u2216";
      var ssmile = "\u2323";
      var sstarf = "\u22C6";
      var Star = "\u22C6";
      var star = "\u2606";
      var starf = "\u2605";
      var straightepsilon = "\u03F5";
      var straightphi = "\u03D5";
      var strns = "\xAF";
      var sub = "\u2282";
      var Sub = "\u22D0";
      var subdot = "\u2ABD";
      var subE = "\u2AC5";
      var sube = "\u2286";
      var subedot = "\u2AC3";
      var submult = "\u2AC1";
      var subnE = "\u2ACB";
      var subne = "\u228A";
      var subplus = "\u2ABF";
      var subrarr = "\u2979";
      var subset = "\u2282";
      var Subset = "\u22D0";
      var subseteq = "\u2286";
      var subseteqq = "\u2AC5";
      var SubsetEqual = "\u2286";
      var subsetneq = "\u228A";
      var subsetneqq = "\u2ACB";
      var subsim = "\u2AC7";
      var subsub = "\u2AD5";
      var subsup = "\u2AD3";
      var succapprox = "\u2AB8";
      var succ = "\u227B";
      var succcurlyeq = "\u227D";
      var Succeeds = "\u227B";
      var SucceedsEqual = "\u2AB0";
      var SucceedsSlantEqual = "\u227D";
      var SucceedsTilde = "\u227F";
      var succeq = "\u2AB0";
      var succnapprox = "\u2ABA";
      var succneqq = "\u2AB6";
      var succnsim = "\u22E9";
      var succsim = "\u227F";
      var SuchThat = "\u220B";
      var sum = "\u2211";
      var Sum = "\u2211";
      var sung = "\u266A";
      var sup1 = "\xB9";
      var sup2 = "\xB2";
      var sup3 = "\xB3";
      var sup = "\u2283";
      var Sup = "\u22D1";
      var supdot = "\u2ABE";
      var supdsub = "\u2AD8";
      var supE = "\u2AC6";
      var supe = "\u2287";
      var supedot = "\u2AC4";
      var Superset = "\u2283";
      var SupersetEqual = "\u2287";
      var suphsol = "\u27C9";
      var suphsub = "\u2AD7";
      var suplarr = "\u297B";
      var supmult = "\u2AC2";
      var supnE = "\u2ACC";
      var supne = "\u228B";
      var supplus = "\u2AC0";
      var supset = "\u2283";
      var Supset = "\u22D1";
      var supseteq = "\u2287";
      var supseteqq = "\u2AC6";
      var supsetneq = "\u228B";
      var supsetneqq = "\u2ACC";
      var supsim = "\u2AC8";
      var supsub = "\u2AD4";
      var supsup = "\u2AD6";
      var swarhk = "\u2926";
      var swarr = "\u2199";
      var swArr = "\u21D9";
      var swarrow = "\u2199";
      var swnwar = "\u292A";
      var szlig = "\xDF";
      var Tab = "	";
      var target = "\u2316";
      var Tau = "\u03A4";
      var tau = "\u03C4";
      var tbrk = "\u23B4";
      var Tcaron = "\u0164";
      var tcaron = "\u0165";
      var Tcedil = "\u0162";
      var tcedil = "\u0163";
      var Tcy = "\u0422";
      var tcy = "\u0442";
      var tdot = "\u20DB";
      var telrec = "\u2315";
      var Tfr = "\u{1D517}";
      var tfr = "\u{1D531}";
      var there4 = "\u2234";
      var therefore = "\u2234";
      var Therefore = "\u2234";
      var Theta = "\u0398";
      var theta = "\u03B8";
      var thetasym = "\u03D1";
      var thetav = "\u03D1";
      var thickapprox = "\u2248";
      var thicksim = "\u223C";
      var ThickSpace = "\u205F\u200A";
      var ThinSpace = "\u2009";
      var thinsp = "\u2009";
      var thkap = "\u2248";
      var thksim = "\u223C";
      var THORN = "\xDE";
      var thorn = "\xFE";
      var tilde = "\u02DC";
      var Tilde = "\u223C";
      var TildeEqual = "\u2243";
      var TildeFullEqual = "\u2245";
      var TildeTilde = "\u2248";
      var timesbar = "\u2A31";
      var timesb = "\u22A0";
      var times = "\xD7";
      var timesd = "\u2A30";
      var tint = "\u222D";
      var toea = "\u2928";
      var topbot = "\u2336";
      var topcir = "\u2AF1";
      var top = "\u22A4";
      var Topf = "\u{1D54B}";
      var topf = "\u{1D565}";
      var topfork = "\u2ADA";
      var tosa = "\u2929";
      var tprime = "\u2034";
      var trade = "\u2122";
      var TRADE = "\u2122";
      var triangle = "\u25B5";
      var triangledown = "\u25BF";
      var triangleleft = "\u25C3";
      var trianglelefteq = "\u22B4";
      var triangleq = "\u225C";
      var triangleright = "\u25B9";
      var trianglerighteq = "\u22B5";
      var tridot = "\u25EC";
      var trie = "\u225C";
      var triminus = "\u2A3A";
      var TripleDot = "\u20DB";
      var triplus = "\u2A39";
      var trisb = "\u29CD";
      var tritime = "\u2A3B";
      var trpezium = "\u23E2";
      var Tscr = "\u{1D4AF}";
      var tscr = "\u{1D4C9}";
      var TScy = "\u0426";
      var tscy = "\u0446";
      var TSHcy = "\u040B";
      var tshcy = "\u045B";
      var Tstrok = "\u0166";
      var tstrok = "\u0167";
      var twixt = "\u226C";
      var twoheadleftarrow = "\u219E";
      var twoheadrightarrow = "\u21A0";
      var Uacute = "\xDA";
      var uacute = "\xFA";
      var uarr = "\u2191";
      var Uarr = "\u219F";
      var uArr = "\u21D1";
      var Uarrocir = "\u2949";
      var Ubrcy = "\u040E";
      var ubrcy = "\u045E";
      var Ubreve = "\u016C";
      var ubreve = "\u016D";
      var Ucirc = "\xDB";
      var ucirc = "\xFB";
      var Ucy = "\u0423";
      var ucy = "\u0443";
      var udarr = "\u21C5";
      var Udblac = "\u0170";
      var udblac = "\u0171";
      var udhar = "\u296E";
      var ufisht = "\u297E";
      var Ufr = "\u{1D518}";
      var ufr = "\u{1D532}";
      var Ugrave = "\xD9";
      var ugrave = "\xF9";
      var uHar = "\u2963";
      var uharl = "\u21BF";
      var uharr = "\u21BE";
      var uhblk = "\u2580";
      var ulcorn = "\u231C";
      var ulcorner = "\u231C";
      var ulcrop = "\u230F";
      var ultri = "\u25F8";
      var Umacr = "\u016A";
      var umacr = "\u016B";
      var uml = "\xA8";
      var UnderBar = "_";
      var UnderBrace = "\u23DF";
      var UnderBracket = "\u23B5";
      var UnderParenthesis = "\u23DD";
      var Union = "\u22C3";
      var UnionPlus = "\u228E";
      var Uogon = "\u0172";
      var uogon = "\u0173";
      var Uopf = "\u{1D54C}";
      var uopf = "\u{1D566}";
      var UpArrowBar = "\u2912";
      var uparrow = "\u2191";
      var UpArrow = "\u2191";
      var Uparrow = "\u21D1";
      var UpArrowDownArrow = "\u21C5";
      var updownarrow = "\u2195";
      var UpDownArrow = "\u2195";
      var Updownarrow = "\u21D5";
      var UpEquilibrium = "\u296E";
      var upharpoonleft = "\u21BF";
      var upharpoonright = "\u21BE";
      var uplus = "\u228E";
      var UpperLeftArrow = "\u2196";
      var UpperRightArrow = "\u2197";
      var upsi = "\u03C5";
      var Upsi = "\u03D2";
      var upsih = "\u03D2";
      var Upsilon = "\u03A5";
      var upsilon = "\u03C5";
      var UpTeeArrow = "\u21A5";
      var UpTee = "\u22A5";
      var upuparrows = "\u21C8";
      var urcorn = "\u231D";
      var urcorner = "\u231D";
      var urcrop = "\u230E";
      var Uring = "\u016E";
      var uring = "\u016F";
      var urtri = "\u25F9";
      var Uscr = "\u{1D4B0}";
      var uscr = "\u{1D4CA}";
      var utdot = "\u22F0";
      var Utilde = "\u0168";
      var utilde = "\u0169";
      var utri = "\u25B5";
      var utrif = "\u25B4";
      var uuarr = "\u21C8";
      var Uuml = "\xDC";
      var uuml = "\xFC";
      var uwangle = "\u29A7";
      var vangrt = "\u299C";
      var varepsilon = "\u03F5";
      var varkappa = "\u03F0";
      var varnothing = "\u2205";
      var varphi = "\u03D5";
      var varpi = "\u03D6";
      var varpropto = "\u221D";
      var varr = "\u2195";
      var vArr = "\u21D5";
      var varrho = "\u03F1";
      var varsigma = "\u03C2";
      var varsubsetneq = "\u228A\uFE00";
      var varsubsetneqq = "\u2ACB\uFE00";
      var varsupsetneq = "\u228B\uFE00";
      var varsupsetneqq = "\u2ACC\uFE00";
      var vartheta = "\u03D1";
      var vartriangleleft = "\u22B2";
      var vartriangleright = "\u22B3";
      var vBar = "\u2AE8";
      var Vbar = "\u2AEB";
      var vBarv = "\u2AE9";
      var Vcy = "\u0412";
      var vcy = "\u0432";
      var vdash = "\u22A2";
      var vDash = "\u22A8";
      var Vdash = "\u22A9";
      var VDash = "\u22AB";
      var Vdashl = "\u2AE6";
      var veebar = "\u22BB";
      var vee = "\u2228";
      var Vee = "\u22C1";
      var veeeq = "\u225A";
      var vellip = "\u22EE";
      var verbar = "|";
      var Verbar = "\u2016";
      var vert = "|";
      var Vert = "\u2016";
      var VerticalBar = "\u2223";
      var VerticalLine = "|";
      var VerticalSeparator = "\u2758";
      var VerticalTilde = "\u2240";
      var VeryThinSpace = "\u200A";
      var Vfr = "\u{1D519}";
      var vfr = "\u{1D533}";
      var vltri = "\u22B2";
      var vnsub = "\u2282\u20D2";
      var vnsup = "\u2283\u20D2";
      var Vopf = "\u{1D54D}";
      var vopf = "\u{1D567}";
      var vprop = "\u221D";
      var vrtri = "\u22B3";
      var Vscr = "\u{1D4B1}";
      var vscr = "\u{1D4CB}";
      var vsubnE = "\u2ACB\uFE00";
      var vsubne = "\u228A\uFE00";
      var vsupnE = "\u2ACC\uFE00";
      var vsupne = "\u228B\uFE00";
      var Vvdash = "\u22AA";
      var vzigzag = "\u299A";
      var Wcirc = "\u0174";
      var wcirc = "\u0175";
      var wedbar = "\u2A5F";
      var wedge = "\u2227";
      var Wedge = "\u22C0";
      var wedgeq = "\u2259";
      var weierp = "\u2118";
      var Wfr = "\u{1D51A}";
      var wfr = "\u{1D534}";
      var Wopf = "\u{1D54E}";
      var wopf = "\u{1D568}";
      var wp = "\u2118";
      var wr = "\u2240";
      var wreath = "\u2240";
      var Wscr = "\u{1D4B2}";
      var wscr = "\u{1D4CC}";
      var xcap = "\u22C2";
      var xcirc = "\u25EF";
      var xcup = "\u22C3";
      var xdtri = "\u25BD";
      var Xfr = "\u{1D51B}";
      var xfr = "\u{1D535}";
      var xharr = "\u27F7";
      var xhArr = "\u27FA";
      var Xi = "\u039E";
      var xi = "\u03BE";
      var xlarr = "\u27F5";
      var xlArr = "\u27F8";
      var xmap = "\u27FC";
      var xnis = "\u22FB";
      var xodot = "\u2A00";
      var Xopf = "\u{1D54F}";
      var xopf = "\u{1D569}";
      var xoplus = "\u2A01";
      var xotime = "\u2A02";
      var xrarr = "\u27F6";
      var xrArr = "\u27F9";
      var Xscr = "\u{1D4B3}";
      var xscr = "\u{1D4CD}";
      var xsqcup = "\u2A06";
      var xuplus = "\u2A04";
      var xutri = "\u25B3";
      var xvee = "\u22C1";
      var xwedge = "\u22C0";
      var Yacute = "\xDD";
      var yacute = "\xFD";
      var YAcy = "\u042F";
      var yacy = "\u044F";
      var Ycirc = "\u0176";
      var ycirc = "\u0177";
      var Ycy = "\u042B";
      var ycy = "\u044B";
      var yen = "\xA5";
      var Yfr = "\u{1D51C}";
      var yfr = "\u{1D536}";
      var YIcy = "\u0407";
      var yicy = "\u0457";
      var Yopf = "\u{1D550}";
      var yopf = "\u{1D56A}";
      var Yscr = "\u{1D4B4}";
      var yscr = "\u{1D4CE}";
      var YUcy = "\u042E";
      var yucy = "\u044E";
      var yuml = "\xFF";
      var Yuml = "\u0178";
      var Zacute = "\u0179";
      var zacute = "\u017A";
      var Zcaron = "\u017D";
      var zcaron = "\u017E";
      var Zcy = "\u0417";
      var zcy = "\u0437";
      var Zdot = "\u017B";
      var zdot = "\u017C";
      var zeetrf = "\u2128";
      var ZeroWidthSpace = "\u200B";
      var Zeta = "\u0396";
      var zeta = "\u03B6";
      var zfr = "\u{1D537}";
      var Zfr = "\u2128";
      var ZHcy = "\u0416";
      var zhcy = "\u0436";
      var zigrarr = "\u21DD";
      var zopf = "\u{1D56B}";
      var Zopf = "\u2124";
      var Zscr = "\u{1D4B5}";
      var zscr = "\u{1D4CF}";
      var zwj = "\u200D";
      var zwnj = "\u200C";
      var entities = {
        Aacute,
        aacute,
        Abreve,
        abreve,
        ac,
        acd,
        acE,
        Acirc,
        acirc,
        acute,
        Acy,
        acy,
        AElig,
        aelig,
        af,
        Afr,
        afr,
        Agrave,
        agrave,
        alefsym,
        aleph,
        Alpha,
        alpha,
        Amacr,
        amacr,
        amalg,
        amp,
        AMP,
        andand,
        And,
        and,
        andd,
        andslope,
        andv,
        ang,
        ange,
        angle,
        angmsdaa,
        angmsdab,
        angmsdac,
        angmsdad,
        angmsdae,
        angmsdaf,
        angmsdag,
        angmsdah,
        angmsd,
        angrt,
        angrtvb,
        angrtvbd,
        angsph,
        angst,
        angzarr,
        Aogon,
        aogon,
        Aopf,
        aopf,
        apacir,
        ap,
        apE,
        ape,
        apid,
        apos,
        ApplyFunction,
        approx,
        approxeq,
        Aring,
        aring,
        Ascr,
        ascr,
        Assign,
        ast,
        asymp,
        asympeq,
        Atilde,
        atilde,
        Auml,
        auml,
        awconint,
        awint,
        backcong,
        backepsilon,
        backprime,
        backsim,
        backsimeq,
        Backslash,
        Barv,
        barvee,
        barwed,
        Barwed,
        barwedge,
        bbrk,
        bbrktbrk,
        bcong,
        Bcy,
        bcy,
        bdquo,
        becaus,
        because,
        Because,
        bemptyv,
        bepsi,
        bernou,
        Bernoullis,
        Beta,
        beta,
        beth,
        between,
        Bfr,
        bfr,
        bigcap,
        bigcirc,
        bigcup,
        bigodot,
        bigoplus,
        bigotimes,
        bigsqcup,
        bigstar,
        bigtriangledown,
        bigtriangleup,
        biguplus,
        bigvee,
        bigwedge,
        bkarow,
        blacklozenge,
        blacksquare,
        blacktriangle,
        blacktriangledown,
        blacktriangleleft,
        blacktriangleright,
        blank,
        blk12,
        blk14,
        blk34,
        block,
        bne,
        bnequiv,
        bNot,
        bnot,
        Bopf,
        bopf,
        bot,
        bottom,
        bowtie,
        boxbox,
        boxdl,
        boxdL,
        boxDl,
        boxDL,
        boxdr,
        boxdR,
        boxDr,
        boxDR,
        boxh,
        boxH,
        boxhd,
        boxHd,
        boxhD,
        boxHD,
        boxhu,
        boxHu,
        boxhU,
        boxHU,
        boxminus,
        boxplus,
        boxtimes,
        boxul,
        boxuL,
        boxUl,
        boxUL,
        boxur,
        boxuR,
        boxUr,
        boxUR,
        boxv,
        boxV,
        boxvh,
        boxvH,
        boxVh,
        boxVH,
        boxvl,
        boxvL,
        boxVl,
        boxVL,
        boxvr,
        boxvR,
        boxVr,
        boxVR,
        bprime,
        breve,
        Breve,
        brvbar,
        bscr,
        Bscr,
        bsemi,
        bsim,
        bsime,
        bsolb,
        bsol,
        bsolhsub,
        bull,
        bullet,
        bump,
        bumpE,
        bumpe,
        Bumpeq,
        bumpeq,
        Cacute,
        cacute,
        capand,
        capbrcup,
        capcap,
        cap,
        Cap,
        capcup,
        capdot,
        CapitalDifferentialD,
        caps,
        caret,
        caron,
        Cayleys,
        ccaps,
        Ccaron,
        ccaron,
        Ccedil,
        ccedil,
        Ccirc,
        ccirc,
        Cconint,
        ccups,
        ccupssm,
        Cdot,
        cdot,
        cedil,
        Cedilla,
        cemptyv,
        cent,
        centerdot,
        CenterDot,
        cfr,
        Cfr,
        CHcy,
        chcy,
        check,
        checkmark,
        Chi,
        chi,
        circ,
        circeq,
        circlearrowleft,
        circlearrowright,
        circledast,
        circledcirc,
        circleddash,
        CircleDot,
        circledR,
        circledS,
        CircleMinus,
        CirclePlus,
        CircleTimes,
        cir,
        cirE,
        cire,
        cirfnint,
        cirmid,
        cirscir,
        ClockwiseContourIntegral,
        CloseCurlyDoubleQuote,
        CloseCurlyQuote,
        clubs,
        clubsuit,
        colon,
        Colon,
        Colone,
        colone,
        coloneq,
        comma,
        commat,
        comp,
        compfn,
        complement,
        complexes,
        cong,
        congdot,
        Congruent,
        conint,
        Conint,
        ContourIntegral,
        copf,
        Copf,
        coprod,
        Coproduct,
        copy,
        COPY,
        copysr,
        CounterClockwiseContourIntegral,
        crarr,
        cross,
        Cross,
        Cscr,
        cscr,
        csub,
        csube,
        csup,
        csupe,
        ctdot,
        cudarrl,
        cudarrr,
        cuepr,
        cuesc,
        cularr,
        cularrp,
        cupbrcap,
        cupcap,
        CupCap,
        cup,
        Cup,
        cupcup,
        cupdot,
        cupor,
        cups,
        curarr,
        curarrm,
        curlyeqprec,
        curlyeqsucc,
        curlyvee,
        curlywedge,
        curren,
        curvearrowleft,
        curvearrowright,
        cuvee,
        cuwed,
        cwconint,
        cwint,
        cylcty,
        dagger,
        Dagger,
        daleth,
        darr,
        Darr,
        dArr,
        dash,
        Dashv,
        dashv,
        dbkarow,
        dblac,
        Dcaron,
        dcaron,
        Dcy,
        dcy,
        ddagger,
        ddarr,
        DD,
        dd,
        DDotrahd,
        ddotseq,
        deg,
        Del,
        Delta,
        delta,
        demptyv,
        dfisht,
        Dfr,
        dfr,
        dHar,
        dharl,
        dharr,
        DiacriticalAcute,
        DiacriticalDot,
        DiacriticalDoubleAcute,
        DiacriticalGrave,
        DiacriticalTilde,
        diam,
        diamond,
        Diamond,
        diamondsuit,
        diams,
        die,
        DifferentialD,
        digamma,
        disin,
        div,
        divide,
        divideontimes,
        divonx,
        DJcy,
        djcy,
        dlcorn,
        dlcrop,
        dollar,
        Dopf,
        dopf,
        Dot,
        dot,
        DotDot,
        doteq,
        doteqdot,
        DotEqual,
        dotminus,
        dotplus,
        dotsquare,
        doublebarwedge,
        DoubleContourIntegral,
        DoubleDot,
        DoubleDownArrow,
        DoubleLeftArrow,
        DoubleLeftRightArrow,
        DoubleLeftTee,
        DoubleLongLeftArrow,
        DoubleLongLeftRightArrow,
        DoubleLongRightArrow,
        DoubleRightArrow,
        DoubleRightTee,
        DoubleUpArrow,
        DoubleUpDownArrow,
        DoubleVerticalBar,
        DownArrowBar,
        downarrow,
        DownArrow,
        Downarrow,
        DownArrowUpArrow,
        DownBreve,
        downdownarrows,
        downharpoonleft,
        downharpoonright,
        DownLeftRightVector,
        DownLeftTeeVector,
        DownLeftVectorBar,
        DownLeftVector,
        DownRightTeeVector,
        DownRightVectorBar,
        DownRightVector,
        DownTeeArrow,
        DownTee,
        drbkarow,
        drcorn,
        drcrop,
        Dscr,
        dscr,
        DScy,
        dscy,
        dsol,
        Dstrok,
        dstrok,
        dtdot,
        dtri,
        dtrif,
        duarr,
        duhar,
        dwangle,
        DZcy,
        dzcy,
        dzigrarr,
        Eacute,
        eacute,
        easter,
        Ecaron,
        ecaron,
        Ecirc,
        ecirc,
        ecir,
        ecolon,
        Ecy,
        ecy,
        eDDot,
        Edot,
        edot,
        eDot,
        ee,
        efDot,
        Efr,
        efr,
        eg,
        Egrave,
        egrave,
        egs,
        egsdot,
        el,
        Element,
        elinters,
        ell,
        els,
        elsdot,
        Emacr,
        emacr,
        empty,
        emptyset,
        EmptySmallSquare,
        emptyv,
        EmptyVerySmallSquare,
        emsp13,
        emsp14,
        emsp,
        ENG,
        eng,
        ensp,
        Eogon,
        eogon,
        Eopf,
        eopf,
        epar,
        eparsl,
        eplus,
        epsi,
        Epsilon,
        epsilon,
        epsiv,
        eqcirc,
        eqcolon,
        eqsim,
        eqslantgtr,
        eqslantless,
        Equal,
        equals,
        EqualTilde,
        equest,
        Equilibrium,
        equiv,
        equivDD,
        eqvparsl,
        erarr,
        erDot,
        escr,
        Escr,
        esdot,
        Esim,
        esim,
        Eta,
        eta,
        ETH,
        eth,
        Euml,
        euml,
        euro,
        excl,
        exist,
        Exists,
        expectation,
        exponentiale,
        ExponentialE,
        fallingdotseq,
        Fcy,
        fcy,
        female,
        ffilig,
        fflig,
        ffllig,
        Ffr,
        ffr,
        filig,
        FilledSmallSquare,
        FilledVerySmallSquare,
        fjlig,
        flat,
        fllig,
        fltns,
        fnof,
        Fopf,
        fopf,
        forall,
        ForAll,
        fork,
        forkv,
        Fouriertrf,
        fpartint,
        frac12,
        frac13,
        frac14,
        frac15,
        frac16,
        frac18,
        frac23,
        frac25,
        frac34,
        frac35,
        frac38,
        frac45,
        frac56,
        frac58,
        frac78,
        frasl,
        frown,
        fscr,
        Fscr,
        gacute,
        Gamma,
        gamma,
        Gammad,
        gammad,
        gap,
        Gbreve,
        gbreve,
        Gcedil,
        Gcirc,
        gcirc,
        Gcy,
        gcy,
        Gdot,
        gdot,
        ge,
        gE,
        gEl,
        gel,
        geq,
        geqq,
        geqslant,
        gescc,
        ges,
        gesdot,
        gesdoto,
        gesdotol,
        gesl,
        gesles,
        Gfr,
        gfr,
        gg,
        Gg,
        ggg,
        gimel,
        GJcy,
        gjcy,
        gla,
        gl,
        glE,
        glj,
        gnap,
        gnapprox,
        gne,
        gnE,
        gneq,
        gneqq,
        gnsim,
        Gopf,
        gopf,
        grave,
        GreaterEqual,
        GreaterEqualLess,
        GreaterFullEqual,
        GreaterGreater,
        GreaterLess,
        GreaterSlantEqual,
        GreaterTilde,
        Gscr,
        gscr,
        gsim,
        gsime,
        gsiml,
        gtcc,
        gtcir,
        gt,
        GT,
        Gt,
        gtdot,
        gtlPar,
        gtquest,
        gtrapprox,
        gtrarr,
        gtrdot,
        gtreqless,
        gtreqqless,
        gtrless,
        gtrsim,
        gvertneqq,
        gvnE,
        Hacek,
        hairsp,
        half,
        hamilt,
        HARDcy,
        hardcy,
        harrcir,
        harr,
        hArr,
        harrw,
        Hat,
        hbar,
        Hcirc,
        hcirc,
        hearts,
        heartsuit,
        hellip,
        hercon,
        hfr,
        Hfr,
        HilbertSpace,
        hksearow,
        hkswarow,
        hoarr,
        homtht,
        hookleftarrow,
        hookrightarrow,
        hopf,
        Hopf,
        horbar,
        HorizontalLine,
        hscr,
        Hscr,
        hslash,
        Hstrok,
        hstrok,
        HumpDownHump,
        HumpEqual,
        hybull,
        hyphen,
        Iacute,
        iacute,
        ic,
        Icirc,
        icirc,
        Icy,
        icy,
        Idot,
        IEcy,
        iecy,
        iexcl,
        iff,
        ifr,
        Ifr,
        Igrave,
        igrave,
        ii,
        iiiint,
        iiint,
        iinfin,
        iiota,
        IJlig,
        ijlig,
        Imacr,
        imacr,
        image,
        ImaginaryI,
        imagline,
        imagpart,
        imath,
        Im,
        imof,
        imped,
        Implies,
        incare,
        "in": "\u2208",
        infin,
        infintie,
        inodot,
        intcal,
        int,
        Int,
        integers,
        Integral,
        intercal,
        Intersection,
        intlarhk,
        intprod,
        InvisibleComma,
        InvisibleTimes,
        IOcy,
        iocy,
        Iogon,
        iogon,
        Iopf,
        iopf,
        Iota,
        iota,
        iprod,
        iquest,
        iscr,
        Iscr,
        isin,
        isindot,
        isinE,
        isins,
        isinsv,
        isinv,
        it,
        Itilde,
        itilde,
        Iukcy,
        iukcy,
        Iuml,
        iuml,
        Jcirc,
        jcirc,
        Jcy,
        jcy,
        Jfr,
        jfr,
        jmath,
        Jopf,
        jopf,
        Jscr,
        jscr,
        Jsercy,
        jsercy,
        Jukcy,
        jukcy,
        Kappa,
        kappa,
        kappav,
        Kcedil,
        kcedil,
        Kcy,
        kcy,
        Kfr,
        kfr,
        kgreen,
        KHcy,
        khcy,
        KJcy,
        kjcy,
        Kopf,
        kopf,
        Kscr,
        kscr,
        lAarr,
        Lacute,
        lacute,
        laemptyv,
        lagran,
        Lambda,
        lambda,
        lang,
        Lang,
        langd,
        langle,
        lap,
        Laplacetrf,
        laquo,
        larrb,
        larrbfs,
        larr,
        Larr,
        lArr,
        larrfs,
        larrhk,
        larrlp,
        larrpl,
        larrsim,
        larrtl,
        latail,
        lAtail,
        lat,
        late,
        lates,
        lbarr,
        lBarr,
        lbbrk,
        lbrace,
        lbrack,
        lbrke,
        lbrksld,
        lbrkslu,
        Lcaron,
        lcaron,
        Lcedil,
        lcedil,
        lceil,
        lcub,
        Lcy,
        lcy,
        ldca,
        ldquo,
        ldquor,
        ldrdhar,
        ldrushar,
        ldsh,
        le,
        lE,
        LeftAngleBracket,
        LeftArrowBar,
        leftarrow,
        LeftArrow,
        Leftarrow,
        LeftArrowRightArrow,
        leftarrowtail,
        LeftCeiling,
        LeftDoubleBracket,
        LeftDownTeeVector,
        LeftDownVectorBar,
        LeftDownVector,
        LeftFloor,
        leftharpoondown,
        leftharpoonup,
        leftleftarrows,
        leftrightarrow,
        LeftRightArrow,
        Leftrightarrow,
        leftrightarrows,
        leftrightharpoons,
        leftrightsquigarrow,
        LeftRightVector,
        LeftTeeArrow,
        LeftTee,
        LeftTeeVector,
        leftthreetimes,
        LeftTriangleBar,
        LeftTriangle,
        LeftTriangleEqual,
        LeftUpDownVector,
        LeftUpTeeVector,
        LeftUpVectorBar,
        LeftUpVector,
        LeftVectorBar,
        LeftVector,
        lEg,
        leg,
        leq,
        leqq,
        leqslant,
        lescc,
        les,
        lesdot,
        lesdoto,
        lesdotor,
        lesg,
        lesges,
        lessapprox,
        lessdot,
        lesseqgtr,
        lesseqqgtr,
        LessEqualGreater,
        LessFullEqual,
        LessGreater,
        lessgtr,
        LessLess,
        lesssim,
        LessSlantEqual,
        LessTilde,
        lfisht,
        lfloor,
        Lfr,
        lfr,
        lg,
        lgE,
        lHar,
        lhard,
        lharu,
        lharul,
        lhblk,
        LJcy,
        ljcy,
        llarr,
        ll,
        Ll,
        llcorner,
        Lleftarrow,
        llhard,
        lltri,
        Lmidot,
        lmidot,
        lmoustache,
        lmoust,
        lnap,
        lnapprox,
        lne,
        lnE,
        lneq,
        lneqq,
        lnsim,
        loang,
        loarr,
        lobrk,
        longleftarrow,
        LongLeftArrow,
        Longleftarrow,
        longleftrightarrow,
        LongLeftRightArrow,
        Longleftrightarrow,
        longmapsto,
        longrightarrow,
        LongRightArrow,
        Longrightarrow,
        looparrowleft,
        looparrowright,
        lopar,
        Lopf,
        lopf,
        loplus,
        lotimes,
        lowast,
        lowbar,
        LowerLeftArrow,
        LowerRightArrow,
        loz,
        lozenge,
        lozf,
        lpar,
        lparlt,
        lrarr,
        lrcorner,
        lrhar,
        lrhard,
        lrm,
        lrtri,
        lsaquo,
        lscr,
        Lscr,
        lsh,
        Lsh,
        lsim,
        lsime,
        lsimg,
        lsqb,
        lsquo,
        lsquor,
        Lstrok,
        lstrok,
        ltcc,
        ltcir,
        lt,
        LT,
        Lt,
        ltdot,
        lthree,
        ltimes,
        ltlarr,
        ltquest,
        ltri,
        ltrie,
        ltrif,
        ltrPar,
        lurdshar,
        luruhar,
        lvertneqq,
        lvnE,
        macr,
        male,
        malt,
        maltese,
        "Map": "\u2905",
        map,
        mapsto,
        mapstodown,
        mapstoleft,
        mapstoup,
        marker,
        mcomma,
        Mcy,
        mcy,
        mdash,
        mDDot,
        measuredangle,
        MediumSpace,
        Mellintrf,
        Mfr,
        mfr,
        mho,
        micro,
        midast,
        midcir,
        mid,
        middot,
        minusb,
        minus,
        minusd,
        minusdu,
        MinusPlus,
        mlcp,
        mldr,
        mnplus,
        models,
        Mopf,
        mopf,
        mp,
        mscr,
        Mscr,
        mstpos,
        Mu,
        mu,
        multimap,
        mumap,
        nabla,
        Nacute,
        nacute,
        nang,
        nap,
        napE,
        napid,
        napos,
        napprox,
        natural,
        naturals,
        natur,
        nbsp,
        nbump,
        nbumpe,
        ncap,
        Ncaron,
        ncaron,
        Ncedil,
        ncedil,
        ncong,
        ncongdot,
        ncup,
        Ncy,
        ncy,
        ndash,
        nearhk,
        nearr,
        neArr,
        nearrow,
        ne,
        nedot,
        NegativeMediumSpace,
        NegativeThickSpace,
        NegativeThinSpace,
        NegativeVeryThinSpace,
        nequiv,
        nesear,
        nesim,
        NestedGreaterGreater,
        NestedLessLess,
        NewLine,
        nexist,
        nexists,
        Nfr,
        nfr,
        ngE,
        nge,
        ngeq,
        ngeqq,
        ngeqslant,
        nges,
        nGg,
        ngsim,
        nGt,
        ngt,
        ngtr,
        nGtv,
        nharr,
        nhArr,
        nhpar,
        ni,
        nis,
        nisd,
        niv,
        NJcy,
        njcy,
        nlarr,
        nlArr,
        nldr,
        nlE,
        nle,
        nleftarrow,
        nLeftarrow,
        nleftrightarrow,
        nLeftrightarrow,
        nleq,
        nleqq,
        nleqslant,
        nles,
        nless,
        nLl,
        nlsim,
        nLt,
        nlt,
        nltri,
        nltrie,
        nLtv,
        nmid,
        NoBreak,
        NonBreakingSpace,
        nopf,
        Nopf,
        Not,
        not,
        NotCongruent,
        NotCupCap,
        NotDoubleVerticalBar,
        NotElement,
        NotEqual,
        NotEqualTilde,
        NotExists,
        NotGreater,
        NotGreaterEqual,
        NotGreaterFullEqual,
        NotGreaterGreater,
        NotGreaterLess,
        NotGreaterSlantEqual,
        NotGreaterTilde,
        NotHumpDownHump,
        NotHumpEqual,
        notin,
        notindot,
        notinE,
        notinva,
        notinvb,
        notinvc,
        NotLeftTriangleBar,
        NotLeftTriangle,
        NotLeftTriangleEqual,
        NotLess,
        NotLessEqual,
        NotLessGreater,
        NotLessLess,
        NotLessSlantEqual,
        NotLessTilde,
        NotNestedGreaterGreater,
        NotNestedLessLess,
        notni,
        notniva,
        notnivb,
        notnivc,
        NotPrecedes,
        NotPrecedesEqual,
        NotPrecedesSlantEqual,
        NotReverseElement,
        NotRightTriangleBar,
        NotRightTriangle,
        NotRightTriangleEqual,
        NotSquareSubset,
        NotSquareSubsetEqual,
        NotSquareSuperset,
        NotSquareSupersetEqual,
        NotSubset,
        NotSubsetEqual,
        NotSucceeds,
        NotSucceedsEqual,
        NotSucceedsSlantEqual,
        NotSucceedsTilde,
        NotSuperset,
        NotSupersetEqual,
        NotTilde,
        NotTildeEqual,
        NotTildeFullEqual,
        NotTildeTilde,
        NotVerticalBar,
        nparallel,
        npar,
        nparsl,
        npart,
        npolint,
        npr,
        nprcue,
        nprec,
        npreceq,
        npre,
        nrarrc,
        nrarr,
        nrArr,
        nrarrw,
        nrightarrow,
        nRightarrow,
        nrtri,
        nrtrie,
        nsc,
        nsccue,
        nsce,
        Nscr,
        nscr,
        nshortmid,
        nshortparallel,
        nsim,
        nsime,
        nsimeq,
        nsmid,
        nspar,
        nsqsube,
        nsqsupe,
        nsub,
        nsubE,
        nsube,
        nsubset,
        nsubseteq,
        nsubseteqq,
        nsucc,
        nsucceq,
        nsup,
        nsupE,
        nsupe,
        nsupset,
        nsupseteq,
        nsupseteqq,
        ntgl,
        Ntilde,
        ntilde,
        ntlg,
        ntriangleleft,
        ntrianglelefteq,
        ntriangleright,
        ntrianglerighteq,
        Nu,
        nu,
        num,
        numero,
        numsp,
        nvap,
        nvdash,
        nvDash,
        nVdash,
        nVDash,
        nvge,
        nvgt,
        nvHarr,
        nvinfin,
        nvlArr,
        nvle,
        nvlt,
        nvltrie,
        nvrArr,
        nvrtrie,
        nvsim,
        nwarhk,
        nwarr,
        nwArr,
        nwarrow,
        nwnear,
        Oacute,
        oacute,
        oast,
        Ocirc,
        ocirc,
        ocir,
        Ocy,
        ocy,
        odash,
        Odblac,
        odblac,
        odiv,
        odot,
        odsold,
        OElig,
        oelig,
        ofcir,
        Ofr,
        ofr,
        ogon,
        Ograve,
        ograve,
        ogt,
        ohbar,
        ohm,
        oint,
        olarr,
        olcir,
        olcross,
        oline,
        olt,
        Omacr,
        omacr,
        Omega,
        omega,
        Omicron,
        omicron,
        omid,
        ominus,
        Oopf,
        oopf,
        opar,
        OpenCurlyDoubleQuote,
        OpenCurlyQuote,
        operp,
        oplus,
        orarr,
        Or,
        or,
        ord,
        order,
        orderof,
        ordf,
        ordm,
        origof,
        oror,
        orslope,
        orv,
        oS,
        Oscr,
        oscr,
        Oslash,
        oslash,
        osol,
        Otilde,
        otilde,
        otimesas,
        Otimes,
        otimes,
        Ouml,
        ouml,
        ovbar,
        OverBar,
        OverBrace,
        OverBracket,
        OverParenthesis,
        para,
        parallel,
        par,
        parsim,
        parsl,
        part,
        PartialD,
        Pcy,
        pcy,
        percnt,
        period,
        permil,
        perp,
        pertenk,
        Pfr,
        pfr,
        Phi,
        phi,
        phiv,
        phmmat,
        phone,
        Pi,
        pi,
        pitchfork,
        piv,
        planck,
        planckh,
        plankv,
        plusacir,
        plusb,
        pluscir,
        plus,
        plusdo,
        plusdu,
        pluse,
        PlusMinus,
        plusmn,
        plussim,
        plustwo,
        pm,
        Poincareplane,
        pointint,
        popf,
        Popf,
        pound,
        prap,
        Pr,
        pr,
        prcue,
        precapprox,
        prec,
        preccurlyeq,
        Precedes,
        PrecedesEqual,
        PrecedesSlantEqual,
        PrecedesTilde,
        preceq,
        precnapprox,
        precneqq,
        precnsim,
        pre,
        prE,
        precsim,
        prime,
        Prime,
        primes,
        prnap,
        prnE,
        prnsim,
        prod,
        Product,
        profalar,
        profline,
        profsurf,
        prop,
        Proportional,
        Proportion,
        propto,
        prsim,
        prurel,
        Pscr,
        pscr,
        Psi,
        psi,
        puncsp,
        Qfr,
        qfr,
        qint,
        qopf,
        Qopf,
        qprime,
        Qscr,
        qscr,
        quaternions,
        quatint,
        quest,
        questeq,
        quot,
        QUOT,
        rAarr,
        race,
        Racute,
        racute,
        radic,
        raemptyv,
        rang,
        Rang,
        rangd,
        range,
        rangle,
        raquo,
        rarrap,
        rarrb,
        rarrbfs,
        rarrc,
        rarr,
        Rarr,
        rArr,
        rarrfs,
        rarrhk,
        rarrlp,
        rarrpl,
        rarrsim,
        Rarrtl,
        rarrtl,
        rarrw,
        ratail,
        rAtail,
        ratio,
        rationals,
        rbarr,
        rBarr,
        RBarr,
        rbbrk,
        rbrace,
        rbrack,
        rbrke,
        rbrksld,
        rbrkslu,
        Rcaron,
        rcaron,
        Rcedil,
        rcedil,
        rceil,
        rcub,
        Rcy,
        rcy,
        rdca,
        rdldhar,
        rdquo,
        rdquor,
        rdsh,
        real,
        realine,
        realpart,
        reals,
        Re,
        rect,
        reg,
        REG,
        ReverseElement,
        ReverseEquilibrium,
        ReverseUpEquilibrium,
        rfisht,
        rfloor,
        rfr,
        Rfr,
        rHar,
        rhard,
        rharu,
        rharul,
        Rho,
        rho,
        rhov,
        RightAngleBracket,
        RightArrowBar,
        rightarrow,
        RightArrow,
        Rightarrow,
        RightArrowLeftArrow,
        rightarrowtail,
        RightCeiling,
        RightDoubleBracket,
        RightDownTeeVector,
        RightDownVectorBar,
        RightDownVector,
        RightFloor,
        rightharpoondown,
        rightharpoonup,
        rightleftarrows,
        rightleftharpoons,
        rightrightarrows,
        rightsquigarrow,
        RightTeeArrow,
        RightTee,
        RightTeeVector,
        rightthreetimes,
        RightTriangleBar,
        RightTriangle,
        RightTriangleEqual,
        RightUpDownVector,
        RightUpTeeVector,
        RightUpVectorBar,
        RightUpVector,
        RightVectorBar,
        RightVector,
        ring,
        risingdotseq,
        rlarr,
        rlhar,
        rlm,
        rmoustache,
        rmoust,
        rnmid,
        roang,
        roarr,
        robrk,
        ropar,
        ropf,
        Ropf,
        roplus,
        rotimes,
        RoundImplies,
        rpar,
        rpargt,
        rppolint,
        rrarr,
        Rrightarrow,
        rsaquo,
        rscr,
        Rscr,
        rsh,
        Rsh,
        rsqb,
        rsquo,
        rsquor,
        rthree,
        rtimes,
        rtri,
        rtrie,
        rtrif,
        rtriltri,
        RuleDelayed,
        ruluhar,
        rx,
        Sacute,
        sacute,
        sbquo,
        scap,
        Scaron,
        scaron,
        Sc,
        sc,
        sccue,
        sce,
        scE,
        Scedil,
        scedil,
        Scirc,
        scirc,
        scnap,
        scnE,
        scnsim,
        scpolint,
        scsim,
        Scy,
        scy,
        sdotb,
        sdot,
        sdote,
        searhk,
        searr,
        seArr,
        searrow,
        sect,
        semi,
        seswar,
        setminus,
        setmn,
        sext,
        Sfr,
        sfr,
        sfrown,
        sharp,
        SHCHcy,
        shchcy,
        SHcy,
        shcy,
        ShortDownArrow,
        ShortLeftArrow,
        shortmid,
        shortparallel,
        ShortRightArrow,
        ShortUpArrow,
        shy,
        Sigma,
        sigma,
        sigmaf,
        sigmav,
        sim,
        simdot,
        sime,
        simeq,
        simg,
        simgE,
        siml,
        simlE,
        simne,
        simplus,
        simrarr,
        slarr,
        SmallCircle,
        smallsetminus,
        smashp,
        smeparsl,
        smid,
        smile,
        smt,
        smte,
        smtes,
        SOFTcy,
        softcy,
        solbar,
        solb,
        sol,
        Sopf,
        sopf,
        spades,
        spadesuit,
        spar,
        sqcap,
        sqcaps,
        sqcup,
        sqcups,
        Sqrt,
        sqsub,
        sqsube,
        sqsubset,
        sqsubseteq,
        sqsup,
        sqsupe,
        sqsupset,
        sqsupseteq,
        square,
        Square,
        SquareIntersection,
        SquareSubset,
        SquareSubsetEqual,
        SquareSuperset,
        SquareSupersetEqual,
        SquareUnion,
        squarf,
        squ,
        squf,
        srarr,
        Sscr,
        sscr,
        ssetmn,
        ssmile,
        sstarf,
        Star,
        star,
        starf,
        straightepsilon,
        straightphi,
        strns,
        sub,
        Sub,
        subdot,
        subE,
        sube,
        subedot,
        submult,
        subnE,
        subne,
        subplus,
        subrarr,
        subset,
        Subset,
        subseteq,
        subseteqq,
        SubsetEqual,
        subsetneq,
        subsetneqq,
        subsim,
        subsub,
        subsup,
        succapprox,
        succ,
        succcurlyeq,
        Succeeds,
        SucceedsEqual,
        SucceedsSlantEqual,
        SucceedsTilde,
        succeq,
        succnapprox,
        succneqq,
        succnsim,
        succsim,
        SuchThat,
        sum,
        Sum,
        sung,
        sup1,
        sup2,
        sup3,
        sup,
        Sup,
        supdot,
        supdsub,
        supE,
        supe,
        supedot,
        Superset,
        SupersetEqual,
        suphsol,
        suphsub,
        suplarr,
        supmult,
        supnE,
        supne,
        supplus,
        supset,
        Supset,
        supseteq,
        supseteqq,
        supsetneq,
        supsetneqq,
        supsim,
        supsub,
        supsup,
        swarhk,
        swarr,
        swArr,
        swarrow,
        swnwar,
        szlig,
        Tab,
        target,
        Tau,
        tau,
        tbrk,
        Tcaron,
        tcaron,
        Tcedil,
        tcedil,
        Tcy,
        tcy,
        tdot,
        telrec,
        Tfr,
        tfr,
        there4,
        therefore,
        Therefore,
        Theta,
        theta,
        thetasym,
        thetav,
        thickapprox,
        thicksim,
        ThickSpace,
        ThinSpace,
        thinsp,
        thkap,
        thksim,
        THORN,
        thorn,
        tilde,
        Tilde,
        TildeEqual,
        TildeFullEqual,
        TildeTilde,
        timesbar,
        timesb,
        times,
        timesd,
        tint,
        toea,
        topbot,
        topcir,
        top,
        Topf,
        topf,
        topfork,
        tosa,
        tprime,
        trade,
        TRADE,
        triangle,
        triangledown,
        triangleleft,
        trianglelefteq,
        triangleq,
        triangleright,
        trianglerighteq,
        tridot,
        trie,
        triminus,
        TripleDot,
        triplus,
        trisb,
        tritime,
        trpezium,
        Tscr,
        tscr,
        TScy,
        tscy,
        TSHcy,
        tshcy,
        Tstrok,
        tstrok,
        twixt,
        twoheadleftarrow,
        twoheadrightarrow,
        Uacute,
        uacute,
        uarr,
        Uarr,
        uArr,
        Uarrocir,
        Ubrcy,
        ubrcy,
        Ubreve,
        ubreve,
        Ucirc,
        ucirc,
        Ucy,
        ucy,
        udarr,
        Udblac,
        udblac,
        udhar,
        ufisht,
        Ufr,
        ufr,
        Ugrave,
        ugrave,
        uHar,
        uharl,
        uharr,
        uhblk,
        ulcorn,
        ulcorner,
        ulcrop,
        ultri,
        Umacr,
        umacr,
        uml,
        UnderBar,
        UnderBrace,
        UnderBracket,
        UnderParenthesis,
        Union,
        UnionPlus,
        Uogon,
        uogon,
        Uopf,
        uopf,
        UpArrowBar,
        uparrow,
        UpArrow,
        Uparrow,
        UpArrowDownArrow,
        updownarrow,
        UpDownArrow,
        Updownarrow,
        UpEquilibrium,
        upharpoonleft,
        upharpoonright,
        uplus,
        UpperLeftArrow,
        UpperRightArrow,
        upsi,
        Upsi,
        upsih,
        Upsilon,
        upsilon,
        UpTeeArrow,
        UpTee,
        upuparrows,
        urcorn,
        urcorner,
        urcrop,
        Uring,
        uring,
        urtri,
        Uscr,
        uscr,
        utdot,
        Utilde,
        utilde,
        utri,
        utrif,
        uuarr,
        Uuml,
        uuml,
        uwangle,
        vangrt,
        varepsilon,
        varkappa,
        varnothing,
        varphi,
        varpi,
        varpropto,
        varr,
        vArr,
        varrho,
        varsigma,
        varsubsetneq,
        varsubsetneqq,
        varsupsetneq,
        varsupsetneqq,
        vartheta,
        vartriangleleft,
        vartriangleright,
        vBar,
        Vbar,
        vBarv,
        Vcy,
        vcy,
        vdash,
        vDash,
        Vdash,
        VDash,
        Vdashl,
        veebar,
        vee,
        Vee,
        veeeq,
        vellip,
        verbar,
        Verbar,
        vert,
        Vert,
        VerticalBar,
        VerticalLine,
        VerticalSeparator,
        VerticalTilde,
        VeryThinSpace,
        Vfr,
        vfr,
        vltri,
        vnsub,
        vnsup,
        Vopf,
        vopf,
        vprop,
        vrtri,
        Vscr,
        vscr,
        vsubnE,
        vsubne,
        vsupnE,
        vsupne,
        Vvdash,
        vzigzag,
        Wcirc,
        wcirc,
        wedbar,
        wedge,
        Wedge,
        wedgeq,
        weierp,
        Wfr,
        wfr,
        Wopf,
        wopf,
        wp,
        wr,
        wreath,
        Wscr,
        wscr,
        xcap,
        xcirc,
        xcup,
        xdtri,
        Xfr,
        xfr,
        xharr,
        xhArr,
        Xi,
        xi,
        xlarr,
        xlArr,
        xmap,
        xnis,
        xodot,
        Xopf,
        xopf,
        xoplus,
        xotime,
        xrarr,
        xrArr,
        Xscr,
        xscr,
        xsqcup,
        xuplus,
        xutri,
        xvee,
        xwedge,
        Yacute,
        yacute,
        YAcy,
        yacy,
        Ycirc,
        ycirc,
        Ycy,
        ycy,
        yen,
        Yfr,
        yfr,
        YIcy,
        yicy,
        Yopf,
        yopf,
        Yscr,
        yscr,
        YUcy,
        yucy,
        yuml,
        Yuml,
        Zacute,
        zacute,
        Zcaron,
        zcaron,
        Zcy,
        zcy,
        Zdot,
        zdot,
        zeetrf,
        ZeroWidthSpace,
        Zeta,
        zeta,
        zfr,
        Zfr,
        ZHcy,
        zhcy,
        zigrarr,
        zopf,
        Zopf,
        Zscr,
        zscr,
        zwj,
        zwnj
      };
      var entities$1 = /* @__PURE__ */ Object.freeze({
        __proto__: null,
        Aacute,
        aacute,
        Abreve,
        abreve,
        ac,
        acd,
        acE,
        Acirc,
        acirc,
        acute,
        Acy,
        acy,
        AElig,
        aelig,
        af,
        Afr,
        afr,
        Agrave,
        agrave,
        alefsym,
        aleph,
        Alpha,
        alpha,
        Amacr,
        amacr,
        amalg,
        amp,
        AMP,
        andand,
        And,
        and,
        andd,
        andslope,
        andv,
        ang,
        ange,
        angle,
        angmsdaa,
        angmsdab,
        angmsdac,
        angmsdad,
        angmsdae,
        angmsdaf,
        angmsdag,
        angmsdah,
        angmsd,
        angrt,
        angrtvb,
        angrtvbd,
        angsph,
        angst,
        angzarr,
        Aogon,
        aogon,
        Aopf,
        aopf,
        apacir,
        ap,
        apE,
        ape,
        apid,
        apos,
        ApplyFunction,
        approx,
        approxeq,
        Aring,
        aring,
        Ascr,
        ascr,
        Assign,
        ast,
        asymp,
        asympeq,
        Atilde,
        atilde,
        Auml,
        auml,
        awconint,
        awint,
        backcong,
        backepsilon,
        backprime,
        backsim,
        backsimeq,
        Backslash,
        Barv,
        barvee,
        barwed,
        Barwed,
        barwedge,
        bbrk,
        bbrktbrk,
        bcong,
        Bcy,
        bcy,
        bdquo,
        becaus,
        because,
        Because,
        bemptyv,
        bepsi,
        bernou,
        Bernoullis,
        Beta,
        beta,
        beth,
        between,
        Bfr,
        bfr,
        bigcap,
        bigcirc,
        bigcup,
        bigodot,
        bigoplus,
        bigotimes,
        bigsqcup,
        bigstar,
        bigtriangledown,
        bigtriangleup,
        biguplus,
        bigvee,
        bigwedge,
        bkarow,
        blacklozenge,
        blacksquare,
        blacktriangle,
        blacktriangledown,
        blacktriangleleft,
        blacktriangleright,
        blank,
        blk12,
        blk14,
        blk34,
        block,
        bne,
        bnequiv,
        bNot,
        bnot,
        Bopf,
        bopf,
        bot,
        bottom,
        bowtie,
        boxbox,
        boxdl,
        boxdL,
        boxDl,
        boxDL,
        boxdr,
        boxdR,
        boxDr,
        boxDR,
        boxh,
        boxH,
        boxhd,
        boxHd,
        boxhD,
        boxHD,
        boxhu,
        boxHu,
        boxhU,
        boxHU,
        boxminus,
        boxplus,
        boxtimes,
        boxul,
        boxuL,
        boxUl,
        boxUL,
        boxur,
        boxuR,
        boxUr,
        boxUR,
        boxv,
        boxV,
        boxvh,
        boxvH,
        boxVh,
        boxVH,
        boxvl,
        boxvL,
        boxVl,
        boxVL,
        boxvr,
        boxvR,
        boxVr,
        boxVR,
        bprime,
        breve,
        Breve,
        brvbar,
        bscr,
        Bscr,
        bsemi,
        bsim,
        bsime,
        bsolb,
        bsol,
        bsolhsub,
        bull,
        bullet,
        bump,
        bumpE,
        bumpe,
        Bumpeq,
        bumpeq,
        Cacute,
        cacute,
        capand,
        capbrcup,
        capcap,
        cap,
        Cap,
        capcup,
        capdot,
        CapitalDifferentialD,
        caps,
        caret,
        caron,
        Cayleys,
        ccaps,
        Ccaron,
        ccaron,
        Ccedil,
        ccedil,
        Ccirc,
        ccirc,
        Cconint,
        ccups,
        ccupssm,
        Cdot,
        cdot,
        cedil,
        Cedilla,
        cemptyv,
        cent,
        centerdot,
        CenterDot,
        cfr,
        Cfr,
        CHcy,
        chcy,
        check,
        checkmark,
        Chi,
        chi,
        circ,
        circeq,
        circlearrowleft,
        circlearrowright,
        circledast,
        circledcirc,
        circleddash,
        CircleDot,
        circledR,
        circledS,
        CircleMinus,
        CirclePlus,
        CircleTimes,
        cir,
        cirE,
        cire,
        cirfnint,
        cirmid,
        cirscir,
        ClockwiseContourIntegral,
        CloseCurlyDoubleQuote,
        CloseCurlyQuote,
        clubs,
        clubsuit,
        colon,
        Colon,
        Colone,
        colone,
        coloneq,
        comma,
        commat,
        comp,
        compfn,
        complement,
        complexes,
        cong,
        congdot,
        Congruent,
        conint,
        Conint,
        ContourIntegral,
        copf,
        Copf,
        coprod,
        Coproduct,
        copy,
        COPY,
        copysr,
        CounterClockwiseContourIntegral,
        crarr,
        cross,
        Cross,
        Cscr,
        cscr,
        csub,
        csube,
        csup,
        csupe,
        ctdot,
        cudarrl,
        cudarrr,
        cuepr,
        cuesc,
        cularr,
        cularrp,
        cupbrcap,
        cupcap,
        CupCap,
        cup,
        Cup,
        cupcup,
        cupdot,
        cupor,
        cups,
        curarr,
        curarrm,
        curlyeqprec,
        curlyeqsucc,
        curlyvee,
        curlywedge,
        curren,
        curvearrowleft,
        curvearrowright,
        cuvee,
        cuwed,
        cwconint,
        cwint,
        cylcty,
        dagger,
        Dagger,
        daleth,
        darr,
        Darr,
        dArr,
        dash,
        Dashv,
        dashv,
        dbkarow,
        dblac,
        Dcaron,
        dcaron,
        Dcy,
        dcy,
        ddagger,
        ddarr,
        DD,
        dd,
        DDotrahd,
        ddotseq,
        deg,
        Del,
        Delta,
        delta,
        demptyv,
        dfisht,
        Dfr,
        dfr,
        dHar,
        dharl,
        dharr,
        DiacriticalAcute,
        DiacriticalDot,
        DiacriticalDoubleAcute,
        DiacriticalGrave,
        DiacriticalTilde,
        diam,
        diamond,
        Diamond,
        diamondsuit,
        diams,
        die,
        DifferentialD,
        digamma,
        disin,
        div,
        divide,
        divideontimes,
        divonx,
        DJcy,
        djcy,
        dlcorn,
        dlcrop,
        dollar,
        Dopf,
        dopf,
        Dot,
        dot,
        DotDot,
        doteq,
        doteqdot,
        DotEqual,
        dotminus,
        dotplus,
        dotsquare,
        doublebarwedge,
        DoubleContourIntegral,
        DoubleDot,
        DoubleDownArrow,
        DoubleLeftArrow,
        DoubleLeftRightArrow,
        DoubleLeftTee,
        DoubleLongLeftArrow,
        DoubleLongLeftRightArrow,
        DoubleLongRightArrow,
        DoubleRightArrow,
        DoubleRightTee,
        DoubleUpArrow,
        DoubleUpDownArrow,
        DoubleVerticalBar,
        DownArrowBar,
        downarrow,
        DownArrow,
        Downarrow,
        DownArrowUpArrow,
        DownBreve,
        downdownarrows,
        downharpoonleft,
        downharpoonright,
        DownLeftRightVector,
        DownLeftTeeVector,
        DownLeftVectorBar,
        DownLeftVector,
        DownRightTeeVector,
        DownRightVectorBar,
        DownRightVector,
        DownTeeArrow,
        DownTee,
        drbkarow,
        drcorn,
        drcrop,
        Dscr,
        dscr,
        DScy,
        dscy,
        dsol,
        Dstrok,
        dstrok,
        dtdot,
        dtri,
        dtrif,
        duarr,
        duhar,
        dwangle,
        DZcy,
        dzcy,
        dzigrarr,
        Eacute,
        eacute,
        easter,
        Ecaron,
        ecaron,
        Ecirc,
        ecirc,
        ecir,
        ecolon,
        Ecy,
        ecy,
        eDDot,
        Edot,
        edot,
        eDot,
        ee,
        efDot,
        Efr,
        efr,
        eg,
        Egrave,
        egrave,
        egs,
        egsdot,
        el,
        Element,
        elinters,
        ell,
        els,
        elsdot,
        Emacr,
        emacr,
        empty,
        emptyset,
        EmptySmallSquare,
        emptyv,
        EmptyVerySmallSquare,
        emsp13,
        emsp14,
        emsp,
        ENG,
        eng,
        ensp,
        Eogon,
        eogon,
        Eopf,
        eopf,
        epar,
        eparsl,
        eplus,
        epsi,
        Epsilon,
        epsilon,
        epsiv,
        eqcirc,
        eqcolon,
        eqsim,
        eqslantgtr,
        eqslantless,
        Equal,
        equals,
        EqualTilde,
        equest,
        Equilibrium,
        equiv,
        equivDD,
        eqvparsl,
        erarr,
        erDot,
        escr,
        Escr,
        esdot,
        Esim,
        esim,
        Eta,
        eta,
        ETH,
        eth,
        Euml,
        euml,
        euro,
        excl,
        exist,
        Exists,
        expectation,
        exponentiale,
        ExponentialE,
        fallingdotseq,
        Fcy,
        fcy,
        female,
        ffilig,
        fflig,
        ffllig,
        Ffr,
        ffr,
        filig,
        FilledSmallSquare,
        FilledVerySmallSquare,
        fjlig,
        flat,
        fllig,
        fltns,
        fnof,
        Fopf,
        fopf,
        forall,
        ForAll,
        fork,
        forkv,
        Fouriertrf,
        fpartint,
        frac12,
        frac13,
        frac14,
        frac15,
        frac16,
        frac18,
        frac23,
        frac25,
        frac34,
        frac35,
        frac38,
        frac45,
        frac56,
        frac58,
        frac78,
        frasl,
        frown,
        fscr,
        Fscr,
        gacute,
        Gamma,
        gamma,
        Gammad,
        gammad,
        gap,
        Gbreve,
        gbreve,
        Gcedil,
        Gcirc,
        gcirc,
        Gcy,
        gcy,
        Gdot,
        gdot,
        ge,
        gE,
        gEl,
        gel,
        geq,
        geqq,
        geqslant,
        gescc,
        ges,
        gesdot,
        gesdoto,
        gesdotol,
        gesl,
        gesles,
        Gfr,
        gfr,
        gg,
        Gg,
        ggg,
        gimel,
        GJcy,
        gjcy,
        gla,
        gl,
        glE,
        glj,
        gnap,
        gnapprox,
        gne,
        gnE,
        gneq,
        gneqq,
        gnsim,
        Gopf,
        gopf,
        grave,
        GreaterEqual,
        GreaterEqualLess,
        GreaterFullEqual,
        GreaterGreater,
        GreaterLess,
        GreaterSlantEqual,
        GreaterTilde,
        Gscr,
        gscr,
        gsim,
        gsime,
        gsiml,
        gtcc,
        gtcir,
        gt,
        GT,
        Gt,
        gtdot,
        gtlPar,
        gtquest,
        gtrapprox,
        gtrarr,
        gtrdot,
        gtreqless,
        gtreqqless,
        gtrless,
        gtrsim,
        gvertneqq,
        gvnE,
        Hacek,
        hairsp,
        half,
        hamilt,
        HARDcy,
        hardcy,
        harrcir,
        harr,
        hArr,
        harrw,
        Hat,
        hbar,
        Hcirc,
        hcirc,
        hearts,
        heartsuit,
        hellip,
        hercon,
        hfr,
        Hfr,
        HilbertSpace,
        hksearow,
        hkswarow,
        hoarr,
        homtht,
        hookleftarrow,
        hookrightarrow,
        hopf,
        Hopf,
        horbar,
        HorizontalLine,
        hscr,
        Hscr,
        hslash,
        Hstrok,
        hstrok,
        HumpDownHump,
        HumpEqual,
        hybull,
        hyphen,
        Iacute,
        iacute,
        ic,
        Icirc,
        icirc,
        Icy,
        icy,
        Idot,
        IEcy,
        iecy,
        iexcl,
        iff,
        ifr,
        Ifr,
        Igrave,
        igrave,
        ii,
        iiiint,
        iiint,
        iinfin,
        iiota,
        IJlig,
        ijlig,
        Imacr,
        imacr,
        image,
        ImaginaryI,
        imagline,
        imagpart,
        imath,
        Im,
        imof,
        imped,
        Implies,
        incare,
        infin,
        infintie,
        inodot,
        intcal,
        int,
        Int,
        integers,
        Integral,
        intercal,
        Intersection,
        intlarhk,
        intprod,
        InvisibleComma,
        InvisibleTimes,
        IOcy,
        iocy,
        Iogon,
        iogon,
        Iopf,
        iopf,
        Iota,
        iota,
        iprod,
        iquest,
        iscr,
        Iscr,
        isin,
        isindot,
        isinE,
        isins,
        isinsv,
        isinv,
        it,
        Itilde,
        itilde,
        Iukcy,
        iukcy,
        Iuml,
        iuml,
        Jcirc,
        jcirc,
        Jcy,
        jcy,
        Jfr,
        jfr,
        jmath,
        Jopf,
        jopf,
        Jscr,
        jscr,
        Jsercy,
        jsercy,
        Jukcy,
        jukcy,
        Kappa,
        kappa,
        kappav,
        Kcedil,
        kcedil,
        Kcy,
        kcy,
        Kfr,
        kfr,
        kgreen,
        KHcy,
        khcy,
        KJcy,
        kjcy,
        Kopf,
        kopf,
        Kscr,
        kscr,
        lAarr,
        Lacute,
        lacute,
        laemptyv,
        lagran,
        Lambda,
        lambda,
        lang,
        Lang,
        langd,
        langle,
        lap,
        Laplacetrf,
        laquo,
        larrb,
        larrbfs,
        larr,
        Larr,
        lArr,
        larrfs,
        larrhk,
        larrlp,
        larrpl,
        larrsim,
        larrtl,
        latail,
        lAtail,
        lat,
        late,
        lates,
        lbarr,
        lBarr,
        lbbrk,
        lbrace,
        lbrack,
        lbrke,
        lbrksld,
        lbrkslu,
        Lcaron,
        lcaron,
        Lcedil,
        lcedil,
        lceil,
        lcub,
        Lcy,
        lcy,
        ldca,
        ldquo,
        ldquor,
        ldrdhar,
        ldrushar,
        ldsh,
        le,
        lE,
        LeftAngleBracket,
        LeftArrowBar,
        leftarrow,
        LeftArrow,
        Leftarrow,
        LeftArrowRightArrow,
        leftarrowtail,
        LeftCeiling,
        LeftDoubleBracket,
        LeftDownTeeVector,
        LeftDownVectorBar,
        LeftDownVector,
        LeftFloor,
        leftharpoondown,
        leftharpoonup,
        leftleftarrows,
        leftrightarrow,
        LeftRightArrow,
        Leftrightarrow,
        leftrightarrows,
        leftrightharpoons,
        leftrightsquigarrow,
        LeftRightVector,
        LeftTeeArrow,
        LeftTee,
        LeftTeeVector,
        leftthreetimes,
        LeftTriangleBar,
        LeftTriangle,
        LeftTriangleEqual,
        LeftUpDownVector,
        LeftUpTeeVector,
        LeftUpVectorBar,
        LeftUpVector,
        LeftVectorBar,
        LeftVector,
        lEg,
        leg,
        leq,
        leqq,
        leqslant,
        lescc,
        les,
        lesdot,
        lesdoto,
        lesdotor,
        lesg,
        lesges,
        lessapprox,
        lessdot,
        lesseqgtr,
        lesseqqgtr,
        LessEqualGreater,
        LessFullEqual,
        LessGreater,
        lessgtr,
        LessLess,
        lesssim,
        LessSlantEqual,
        LessTilde,
        lfisht,
        lfloor,
        Lfr,
        lfr,
        lg,
        lgE,
        lHar,
        lhard,
        lharu,
        lharul,
        lhblk,
        LJcy,
        ljcy,
        llarr,
        ll,
        Ll,
        llcorner,
        Lleftarrow,
        llhard,
        lltri,
        Lmidot,
        lmidot,
        lmoustache,
        lmoust,
        lnap,
        lnapprox,
        lne,
        lnE,
        lneq,
        lneqq,
        lnsim,
        loang,
        loarr,
        lobrk,
        longleftarrow,
        LongLeftArrow,
        Longleftarrow,
        longleftrightarrow,
        LongLeftRightArrow,
        Longleftrightarrow,
        longmapsto,
        longrightarrow,
        LongRightArrow,
        Longrightarrow,
        looparrowleft,
        looparrowright,
        lopar,
        Lopf,
        lopf,
        loplus,
        lotimes,
        lowast,
        lowbar,
        LowerLeftArrow,
        LowerRightArrow,
        loz,
        lozenge,
        lozf,
        lpar,
        lparlt,
        lrarr,
        lrcorner,
        lrhar,
        lrhard,
        lrm,
        lrtri,
        lsaquo,
        lscr,
        Lscr,
        lsh,
        Lsh,
        lsim,
        lsime,
        lsimg,
        lsqb,
        lsquo,
        lsquor,
        Lstrok,
        lstrok,
        ltcc,
        ltcir,
        lt,
        LT,
        Lt,
        ltdot,
        lthree,
        ltimes,
        ltlarr,
        ltquest,
        ltri,
        ltrie,
        ltrif,
        ltrPar,
        lurdshar,
        luruhar,
        lvertneqq,
        lvnE,
        macr,
        male,
        malt,
        maltese,
        map,
        mapsto,
        mapstodown,
        mapstoleft,
        mapstoup,
        marker,
        mcomma,
        Mcy,
        mcy,
        mdash,
        mDDot,
        measuredangle,
        MediumSpace,
        Mellintrf,
        Mfr,
        mfr,
        mho,
        micro,
        midast,
        midcir,
        mid,
        middot,
        minusb,
        minus,
        minusd,
        minusdu,
        MinusPlus,
        mlcp,
        mldr,
        mnplus,
        models,
        Mopf,
        mopf,
        mp,
        mscr,
        Mscr,
        mstpos,
        Mu,
        mu,
        multimap,
        mumap,
        nabla,
        Nacute,
        nacute,
        nang,
        nap,
        napE,
        napid,
        napos,
        napprox,
        natural,
        naturals,
        natur,
        nbsp,
        nbump,
        nbumpe,
        ncap,
        Ncaron,
        ncaron,
        Ncedil,
        ncedil,
        ncong,
        ncongdot,
        ncup,
        Ncy,
        ncy,
        ndash,
        nearhk,
        nearr,
        neArr,
        nearrow,
        ne,
        nedot,
        NegativeMediumSpace,
        NegativeThickSpace,
        NegativeThinSpace,
        NegativeVeryThinSpace,
        nequiv,
        nesear,
        nesim,
        NestedGreaterGreater,
        NestedLessLess,
        NewLine,
        nexist,
        nexists,
        Nfr,
        nfr,
        ngE,
        nge,
        ngeq,
        ngeqq,
        ngeqslant,
        nges,
        nGg,
        ngsim,
        nGt,
        ngt,
        ngtr,
        nGtv,
        nharr,
        nhArr,
        nhpar,
        ni,
        nis,
        nisd,
        niv,
        NJcy,
        njcy,
        nlarr,
        nlArr,
        nldr,
        nlE,
        nle,
        nleftarrow,
        nLeftarrow,
        nleftrightarrow,
        nLeftrightarrow,
        nleq,
        nleqq,
        nleqslant,
        nles,
        nless,
        nLl,
        nlsim,
        nLt,
        nlt,
        nltri,
        nltrie,
        nLtv,
        nmid,
        NoBreak,
        NonBreakingSpace,
        nopf,
        Nopf,
        Not,
        not,
        NotCongruent,
        NotCupCap,
        NotDoubleVerticalBar,
        NotElement,
        NotEqual,
        NotEqualTilde,
        NotExists,
        NotGreater,
        NotGreaterEqual,
        NotGreaterFullEqual,
        NotGreaterGreater,
        NotGreaterLess,
        NotGreaterSlantEqual,
        NotGreaterTilde,
        NotHumpDownHump,
        NotHumpEqual,
        notin,
        notindot,
        notinE,
        notinva,
        notinvb,
        notinvc,
        NotLeftTriangleBar,
        NotLeftTriangle,
        NotLeftTriangleEqual,
        NotLess,
        NotLessEqual,
        NotLessGreater,
        NotLessLess,
        NotLessSlantEqual,
        NotLessTilde,
        NotNestedGreaterGreater,
        NotNestedLessLess,
        notni,
        notniva,
        notnivb,
        notnivc,
        NotPrecedes,
        NotPrecedesEqual,
        NotPrecedesSlantEqual,
        NotReverseElement,
        NotRightTriangleBar,
        NotRightTriangle,
        NotRightTriangleEqual,
        NotSquareSubset,
        NotSquareSubsetEqual,
        NotSquareSuperset,
        NotSquareSupersetEqual,
        NotSubset,
        NotSubsetEqual,
        NotSucceeds,
        NotSucceedsEqual,
        NotSucceedsSlantEqual,
        NotSucceedsTilde,
        NotSuperset,
        NotSupersetEqual,
        NotTilde,
        NotTildeEqual,
        NotTildeFullEqual,
        NotTildeTilde,
        NotVerticalBar,
        nparallel,
        npar,
        nparsl,
        npart,
        npolint,
        npr,
        nprcue,
        nprec,
        npreceq,
        npre,
        nrarrc,
        nrarr,
        nrArr,
        nrarrw,
        nrightarrow,
        nRightarrow,
        nrtri,
        nrtrie,
        nsc,
        nsccue,
        nsce,
        Nscr,
        nscr,
        nshortmid,
        nshortparallel,
        nsim,
        nsime,
        nsimeq,
        nsmid,
        nspar,
        nsqsube,
        nsqsupe,
        nsub,
        nsubE,
        nsube,
        nsubset,
        nsubseteq,
        nsubseteqq,
        nsucc,
        nsucceq,
        nsup,
        nsupE,
        nsupe,
        nsupset,
        nsupseteq,
        nsupseteqq,
        ntgl,
        Ntilde,
        ntilde,
        ntlg,
        ntriangleleft,
        ntrianglelefteq,
        ntriangleright,
        ntrianglerighteq,
        Nu,
        nu,
        num,
        numero,
        numsp,
        nvap,
        nvdash,
        nvDash,
        nVdash,
        nVDash,
        nvge,
        nvgt,
        nvHarr,
        nvinfin,
        nvlArr,
        nvle,
        nvlt,
        nvltrie,
        nvrArr,
        nvrtrie,
        nvsim,
        nwarhk,
        nwarr,
        nwArr,
        nwarrow,
        nwnear,
        Oacute,
        oacute,
        oast,
        Ocirc,
        ocirc,
        ocir,
        Ocy,
        ocy,
        odash,
        Odblac,
        odblac,
        odiv,
        odot,
        odsold,
        OElig,
        oelig,
        ofcir,
        Ofr,
        ofr,
        ogon,
        Ograve,
        ograve,
        ogt,
        ohbar,
        ohm,
        oint,
        olarr,
        olcir,
        olcross,
        oline,
        olt,
        Omacr,
        omacr,
        Omega,
        omega,
        Omicron,
        omicron,
        omid,
        ominus,
        Oopf,
        oopf,
        opar,
        OpenCurlyDoubleQuote,
        OpenCurlyQuote,
        operp,
        oplus,
        orarr,
        Or,
        or,
        ord,
        order,
        orderof,
        ordf,
        ordm,
        origof,
        oror,
        orslope,
        orv,
        oS,
        Oscr,
        oscr,
        Oslash,
        oslash,
        osol,
        Otilde,
        otilde,
        otimesas,
        Otimes,
        otimes,
        Ouml,
        ouml,
        ovbar,
        OverBar,
        OverBrace,
        OverBracket,
        OverParenthesis,
        para,
        parallel,
        par,
        parsim,
        parsl,
        part,
        PartialD,
        Pcy,
        pcy,
        percnt,
        period,
        permil,
        perp,
        pertenk,
        Pfr,
        pfr,
        Phi,
        phi,
        phiv,
        phmmat,
        phone,
        Pi,
        pi,
        pitchfork,
        piv,
        planck,
        planckh,
        plankv,
        plusacir,
        plusb,
        pluscir,
        plus,
        plusdo,
        plusdu,
        pluse,
        PlusMinus,
        plusmn,
        plussim,
        plustwo,
        pm,
        Poincareplane,
        pointint,
        popf,
        Popf,
        pound,
        prap,
        Pr,
        pr,
        prcue,
        precapprox,
        prec,
        preccurlyeq,
        Precedes,
        PrecedesEqual,
        PrecedesSlantEqual,
        PrecedesTilde,
        preceq,
        precnapprox,
        precneqq,
        precnsim,
        pre,
        prE,
        precsim,
        prime,
        Prime,
        primes,
        prnap,
        prnE,
        prnsim,
        prod,
        Product,
        profalar,
        profline,
        profsurf,
        prop,
        Proportional,
        Proportion,
        propto,
        prsim,
        prurel,
        Pscr,
        pscr,
        Psi,
        psi,
        puncsp,
        Qfr,
        qfr,
        qint,
        qopf,
        Qopf,
        qprime,
        Qscr,
        qscr,
        quaternions,
        quatint,
        quest,
        questeq,
        quot,
        QUOT,
        rAarr,
        race,
        Racute,
        racute,
        radic,
        raemptyv,
        rang,
        Rang,
        rangd,
        range,
        rangle,
        raquo,
        rarrap,
        rarrb,
        rarrbfs,
        rarrc,
        rarr,
        Rarr,
        rArr,
        rarrfs,
        rarrhk,
        rarrlp,
        rarrpl,
        rarrsim,
        Rarrtl,
        rarrtl,
        rarrw,
        ratail,
        rAtail,
        ratio,
        rationals,
        rbarr,
        rBarr,
        RBarr,
        rbbrk,
        rbrace,
        rbrack,
        rbrke,
        rbrksld,
        rbrkslu,
        Rcaron,
        rcaron,
        Rcedil,
        rcedil,
        rceil,
        rcub,
        Rcy,
        rcy,
        rdca,
        rdldhar,
        rdquo,
        rdquor,
        rdsh,
        real,
        realine,
        realpart,
        reals,
        Re,
        rect,
        reg,
        REG,
        ReverseElement,
        ReverseEquilibrium,
        ReverseUpEquilibrium,
        rfisht,
        rfloor,
        rfr,
        Rfr,
        rHar,
        rhard,
        rharu,
        rharul,
        Rho,
        rho,
        rhov,
        RightAngleBracket,
        RightArrowBar,
        rightarrow,
        RightArrow,
        Rightarrow,
        RightArrowLeftArrow,
        rightarrowtail,
        RightCeiling,
        RightDoubleBracket,
        RightDownTeeVector,
        RightDownVectorBar,
        RightDownVector,
        RightFloor,
        rightharpoondown,
        rightharpoonup,
        rightleftarrows,
        rightleftharpoons,
        rightrightarrows,
        rightsquigarrow,
        RightTeeArrow,
        RightTee,
        RightTeeVector,
        rightthreetimes,
        RightTriangleBar,
        RightTriangle,
        RightTriangleEqual,
        RightUpDownVector,
        RightUpTeeVector,
        RightUpVectorBar,
        RightUpVector,
        RightVectorBar,
        RightVector,
        ring,
        risingdotseq,
        rlarr,
        rlhar,
        rlm,
        rmoustache,
        rmoust,
        rnmid,
        roang,
        roarr,
        robrk,
        ropar,
        ropf,
        Ropf,
        roplus,
        rotimes,
        RoundImplies,
        rpar,
        rpargt,
        rppolint,
        rrarr,
        Rrightarrow,
        rsaquo,
        rscr,
        Rscr,
        rsh,
        Rsh,
        rsqb,
        rsquo,
        rsquor,
        rthree,
        rtimes,
        rtri,
        rtrie,
        rtrif,
        rtriltri,
        RuleDelayed,
        ruluhar,
        rx,
        Sacute,
        sacute,
        sbquo,
        scap,
        Scaron,
        scaron,
        Sc,
        sc,
        sccue,
        sce,
        scE,
        Scedil,
        scedil,
        Scirc,
        scirc,
        scnap,
        scnE,
        scnsim,
        scpolint,
        scsim,
        Scy,
        scy,
        sdotb,
        sdot,
        sdote,
        searhk,
        searr,
        seArr,
        searrow,
        sect,
        semi,
        seswar,
        setminus,
        setmn,
        sext,
        Sfr,
        sfr,
        sfrown,
        sharp,
        SHCHcy,
        shchcy,
        SHcy,
        shcy,
        ShortDownArrow,
        ShortLeftArrow,
        shortmid,
        shortparallel,
        ShortRightArrow,
        ShortUpArrow,
        shy,
        Sigma,
        sigma,
        sigmaf,
        sigmav,
        sim,
        simdot,
        sime,
        simeq,
        simg,
        simgE,
        siml,
        simlE,
        simne,
        simplus,
        simrarr,
        slarr,
        SmallCircle,
        smallsetminus,
        smashp,
        smeparsl,
        smid,
        smile,
        smt,
        smte,
        smtes,
        SOFTcy,
        softcy,
        solbar,
        solb,
        sol,
        Sopf,
        sopf,
        spades,
        spadesuit,
        spar,
        sqcap,
        sqcaps,
        sqcup,
        sqcups,
        Sqrt,
        sqsub,
        sqsube,
        sqsubset,
        sqsubseteq,
        sqsup,
        sqsupe,
        sqsupset,
        sqsupseteq,
        square,
        Square,
        SquareIntersection,
        SquareSubset,
        SquareSubsetEqual,
        SquareSuperset,
        SquareSupersetEqual,
        SquareUnion,
        squarf,
        squ,
        squf,
        srarr,
        Sscr,
        sscr,
        ssetmn,
        ssmile,
        sstarf,
        Star,
        star,
        starf,
        straightepsilon,
        straightphi,
        strns,
        sub,
        Sub,
        subdot,
        subE,
        sube,
        subedot,
        submult,
        subnE,
        subne,
        subplus,
        subrarr,
        subset,
        Subset,
        subseteq,
        subseteqq,
        SubsetEqual,
        subsetneq,
        subsetneqq,
        subsim,
        subsub,
        subsup,
        succapprox,
        succ,
        succcurlyeq,
        Succeeds,
        SucceedsEqual,
        SucceedsSlantEqual,
        SucceedsTilde,
        succeq,
        succnapprox,
        succneqq,
        succnsim,
        succsim,
        SuchThat,
        sum,
        Sum,
        sung,
        sup1,
        sup2,
        sup3,
        sup,
        Sup,
        supdot,
        supdsub,
        supE,
        supe,
        supedot,
        Superset,
        SupersetEqual,
        suphsol,
        suphsub,
        suplarr,
        supmult,
        supnE,
        supne,
        supplus,
        supset,
        Supset,
        supseteq,
        supseteqq,
        supsetneq,
        supsetneqq,
        supsim,
        supsub,
        supsup,
        swarhk,
        swarr,
        swArr,
        swarrow,
        swnwar,
        szlig,
        Tab,
        target,
        Tau,
        tau,
        tbrk,
        Tcaron,
        tcaron,
        Tcedil,
        tcedil,
        Tcy,
        tcy,
        tdot,
        telrec,
        Tfr,
        tfr,
        there4,
        therefore,
        Therefore,
        Theta,
        theta,
        thetasym,
        thetav,
        thickapprox,
        thicksim,
        ThickSpace,
        ThinSpace,
        thinsp,
        thkap,
        thksim,
        THORN,
        thorn,
        tilde,
        Tilde,
        TildeEqual,
        TildeFullEqual,
        TildeTilde,
        timesbar,
        timesb,
        times,
        timesd,
        tint,
        toea,
        topbot,
        topcir,
        top,
        Topf,
        topf,
        topfork,
        tosa,
        tprime,
        trade,
        TRADE,
        triangle,
        triangledown,
        triangleleft,
        trianglelefteq,
        triangleq,
        triangleright,
        trianglerighteq,
        tridot,
        trie,
        triminus,
        TripleDot,
        triplus,
        trisb,
        tritime,
        trpezium,
        Tscr,
        tscr,
        TScy,
        tscy,
        TSHcy,
        tshcy,
        Tstrok,
        tstrok,
        twixt,
        twoheadleftarrow,
        twoheadrightarrow,
        Uacute,
        uacute,
        uarr,
        Uarr,
        uArr,
        Uarrocir,
        Ubrcy,
        ubrcy,
        Ubreve,
        ubreve,
        Ucirc,
        ucirc,
        Ucy,
        ucy,
        udarr,
        Udblac,
        udblac,
        udhar,
        ufisht,
        Ufr,
        ufr,
        Ugrave,
        ugrave,
        uHar,
        uharl,
        uharr,
        uhblk,
        ulcorn,
        ulcorner,
        ulcrop,
        ultri,
        Umacr,
        umacr,
        uml,
        UnderBar,
        UnderBrace,
        UnderBracket,
        UnderParenthesis,
        Union,
        UnionPlus,
        Uogon,
        uogon,
        Uopf,
        uopf,
        UpArrowBar,
        uparrow,
        UpArrow,
        Uparrow,
        UpArrowDownArrow,
        updownarrow,
        UpDownArrow,
        Updownarrow,
        UpEquilibrium,
        upharpoonleft,
        upharpoonright,
        uplus,
        UpperLeftArrow,
        UpperRightArrow,
        upsi,
        Upsi,
        upsih,
        Upsilon,
        upsilon,
        UpTeeArrow,
        UpTee,
        upuparrows,
        urcorn,
        urcorner,
        urcrop,
        Uring,
        uring,
        urtri,
        Uscr,
        uscr,
        utdot,
        Utilde,
        utilde,
        utri,
        utrif,
        uuarr,
        Uuml,
        uuml,
        uwangle,
        vangrt,
        varepsilon,
        varkappa,
        varnothing,
        varphi,
        varpi,
        varpropto,
        varr,
        vArr,
        varrho,
        varsigma,
        varsubsetneq,
        varsubsetneqq,
        varsupsetneq,
        varsupsetneqq,
        vartheta,
        vartriangleleft,
        vartriangleright,
        vBar,
        Vbar,
        vBarv,
        Vcy,
        vcy,
        vdash,
        vDash,
        Vdash,
        VDash,
        Vdashl,
        veebar,
        vee,
        Vee,
        veeeq,
        vellip,
        verbar,
        Verbar,
        vert,
        Vert,
        VerticalBar,
        VerticalLine,
        VerticalSeparator,
        VerticalTilde,
        VeryThinSpace,
        Vfr,
        vfr,
        vltri,
        vnsub,
        vnsup,
        Vopf,
        vopf,
        vprop,
        vrtri,
        Vscr,
        vscr,
        vsubnE,
        vsubne,
        vsupnE,
        vsupne,
        Vvdash,
        vzigzag,
        Wcirc,
        wcirc,
        wedbar,
        wedge,
        Wedge,
        wedgeq,
        weierp,
        Wfr,
        wfr,
        Wopf,
        wopf,
        wp,
        wr,
        wreath,
        Wscr,
        wscr,
        xcap,
        xcirc,
        xcup,
        xdtri,
        Xfr,
        xfr,
        xharr,
        xhArr,
        Xi,
        xi,
        xlarr,
        xlArr,
        xmap,
        xnis,
        xodot,
        Xopf,
        xopf,
        xoplus,
        xotime,
        xrarr,
        xrArr,
        Xscr,
        xscr,
        xsqcup,
        xuplus,
        xutri,
        xvee,
        xwedge,
        Yacute,
        yacute,
        YAcy,
        yacy,
        Ycirc,
        ycirc,
        Ycy,
        ycy,
        yen,
        Yfr,
        yfr,
        YIcy,
        yicy,
        Yopf,
        yopf,
        Yscr,
        yscr,
        YUcy,
        yucy,
        yuml,
        Yuml,
        Zacute,
        zacute,
        Zcaron,
        zcaron,
        Zcy,
        zcy,
        Zdot,
        zdot,
        zeetrf,
        ZeroWidthSpace,
        Zeta,
        zeta,
        zfr,
        Zfr,
        ZHcy,
        zhcy,
        zigrarr,
        zopf,
        Zopf,
        Zscr,
        zscr,
        zwj,
        zwnj,
        "default": entities
      });
      var Aacute$1 = "\xC1";
      var aacute$1 = "\xE1";
      var Acirc$1 = "\xC2";
      var acirc$1 = "\xE2";
      var acute$1 = "\xB4";
      var AElig$1 = "\xC6";
      var aelig$1 = "\xE6";
      var Agrave$1 = "\xC0";
      var agrave$1 = "\xE0";
      var amp$1 = "&";
      var AMP$1 = "&";
      var Aring$1 = "\xC5";
      var aring$1 = "\xE5";
      var Atilde$1 = "\xC3";
      var atilde$1 = "\xE3";
      var Auml$1 = "\xC4";
      var auml$1 = "\xE4";
      var brvbar$1 = "\xA6";
      var Ccedil$1 = "\xC7";
      var ccedil$1 = "\xE7";
      var cedil$1 = "\xB8";
      var cent$1 = "\xA2";
      var copy$1 = "\xA9";
      var COPY$1 = "\xA9";
      var curren$1 = "\xA4";
      var deg$1 = "\xB0";
      var divide$1 = "\xF7";
      var Eacute$1 = "\xC9";
      var eacute$1 = "\xE9";
      var Ecirc$1 = "\xCA";
      var ecirc$1 = "\xEA";
      var Egrave$1 = "\xC8";
      var egrave$1 = "\xE8";
      var ETH$1 = "\xD0";
      var eth$1 = "\xF0";
      var Euml$1 = "\xCB";
      var euml$1 = "\xEB";
      var frac12$1 = "\xBD";
      var frac14$1 = "\xBC";
      var frac34$1 = "\xBE";
      var gt$1 = ">";
      var GT$1 = ">";
      var Iacute$1 = "\xCD";
      var iacute$1 = "\xED";
      var Icirc$1 = "\xCE";
      var icirc$1 = "\xEE";
      var iexcl$1 = "\xA1";
      var Igrave$1 = "\xCC";
      var igrave$1 = "\xEC";
      var iquest$1 = "\xBF";
      var Iuml$1 = "\xCF";
      var iuml$1 = "\xEF";
      var laquo$1 = "\xAB";
      var lt$1 = "<";
      var LT$1 = "<";
      var macr$1 = "\xAF";
      var micro$1 = "\xB5";
      var middot$1 = "\xB7";
      var nbsp$1 = "\xA0";
      var not$1 = "\xAC";
      var Ntilde$1 = "\xD1";
      var ntilde$1 = "\xF1";
      var Oacute$1 = "\xD3";
      var oacute$1 = "\xF3";
      var Ocirc$1 = "\xD4";
      var ocirc$1 = "\xF4";
      var Ograve$1 = "\xD2";
      var ograve$1 = "\xF2";
      var ordf$1 = "\xAA";
      var ordm$1 = "\xBA";
      var Oslash$1 = "\xD8";
      var oslash$1 = "\xF8";
      var Otilde$1 = "\xD5";
      var otilde$1 = "\xF5";
      var Ouml$1 = "\xD6";
      var ouml$1 = "\xF6";
      var para$1 = "\xB6";
      var plusmn$1 = "\xB1";
      var pound$1 = "\xA3";
      var quot$1 = '"';
      var QUOT$1 = '"';
      var raquo$1 = "\xBB";
      var reg$1 = "\xAE";
      var REG$1 = "\xAE";
      var sect$1 = "\xA7";
      var shy$1 = "\xAD";
      var sup1$1 = "\xB9";
      var sup2$1 = "\xB2";
      var sup3$1 = "\xB3";
      var szlig$1 = "\xDF";
      var THORN$1 = "\xDE";
      var thorn$1 = "\xFE";
      var times$1 = "\xD7";
      var Uacute$1 = "\xDA";
      var uacute$1 = "\xFA";
      var Ucirc$1 = "\xDB";
      var ucirc$1 = "\xFB";
      var Ugrave$1 = "\xD9";
      var ugrave$1 = "\xF9";
      var uml$1 = "\xA8";
      var Uuml$1 = "\xDC";
      var uuml$1 = "\xFC";
      var Yacute$1 = "\xDD";
      var yacute$1 = "\xFD";
      var yen$1 = "\xA5";
      var yuml$1 = "\xFF";
      var legacy = {
        Aacute: Aacute$1,
        aacute: aacute$1,
        Acirc: Acirc$1,
        acirc: acirc$1,
        acute: acute$1,
        AElig: AElig$1,
        aelig: aelig$1,
        Agrave: Agrave$1,
        agrave: agrave$1,
        amp: amp$1,
        AMP: AMP$1,
        Aring: Aring$1,
        aring: aring$1,
        Atilde: Atilde$1,
        atilde: atilde$1,
        Auml: Auml$1,
        auml: auml$1,
        brvbar: brvbar$1,
        Ccedil: Ccedil$1,
        ccedil: ccedil$1,
        cedil: cedil$1,
        cent: cent$1,
        copy: copy$1,
        COPY: COPY$1,
        curren: curren$1,
        deg: deg$1,
        divide: divide$1,
        Eacute: Eacute$1,
        eacute: eacute$1,
        Ecirc: Ecirc$1,
        ecirc: ecirc$1,
        Egrave: Egrave$1,
        egrave: egrave$1,
        ETH: ETH$1,
        eth: eth$1,
        Euml: Euml$1,
        euml: euml$1,
        frac12: frac12$1,
        frac14: frac14$1,
        frac34: frac34$1,
        gt: gt$1,
        GT: GT$1,
        Iacute: Iacute$1,
        iacute: iacute$1,
        Icirc: Icirc$1,
        icirc: icirc$1,
        iexcl: iexcl$1,
        Igrave: Igrave$1,
        igrave: igrave$1,
        iquest: iquest$1,
        Iuml: Iuml$1,
        iuml: iuml$1,
        laquo: laquo$1,
        lt: lt$1,
        LT: LT$1,
        macr: macr$1,
        micro: micro$1,
        middot: middot$1,
        nbsp: nbsp$1,
        not: not$1,
        Ntilde: Ntilde$1,
        ntilde: ntilde$1,
        Oacute: Oacute$1,
        oacute: oacute$1,
        Ocirc: Ocirc$1,
        ocirc: ocirc$1,
        Ograve: Ograve$1,
        ograve: ograve$1,
        ordf: ordf$1,
        ordm: ordm$1,
        Oslash: Oslash$1,
        oslash: oslash$1,
        Otilde: Otilde$1,
        otilde: otilde$1,
        Ouml: Ouml$1,
        ouml: ouml$1,
        para: para$1,
        plusmn: plusmn$1,
        pound: pound$1,
        quot: quot$1,
        QUOT: QUOT$1,
        raquo: raquo$1,
        reg: reg$1,
        REG: REG$1,
        sect: sect$1,
        shy: shy$1,
        sup1: sup1$1,
        sup2: sup2$1,
        sup3: sup3$1,
        szlig: szlig$1,
        THORN: THORN$1,
        thorn: thorn$1,
        times: times$1,
        Uacute: Uacute$1,
        uacute: uacute$1,
        Ucirc: Ucirc$1,
        ucirc: ucirc$1,
        Ugrave: Ugrave$1,
        ugrave: ugrave$1,
        uml: uml$1,
        Uuml: Uuml$1,
        uuml: uuml$1,
        Yacute: Yacute$1,
        yacute: yacute$1,
        yen: yen$1,
        yuml: yuml$1
      };
      var legacy$1 = /* @__PURE__ */ Object.freeze({
        __proto__: null,
        Aacute: Aacute$1,
        aacute: aacute$1,
        Acirc: Acirc$1,
        acirc: acirc$1,
        acute: acute$1,
        AElig: AElig$1,
        aelig: aelig$1,
        Agrave: Agrave$1,
        agrave: agrave$1,
        amp: amp$1,
        AMP: AMP$1,
        Aring: Aring$1,
        aring: aring$1,
        Atilde: Atilde$1,
        atilde: atilde$1,
        Auml: Auml$1,
        auml: auml$1,
        brvbar: brvbar$1,
        Ccedil: Ccedil$1,
        ccedil: ccedil$1,
        cedil: cedil$1,
        cent: cent$1,
        copy: copy$1,
        COPY: COPY$1,
        curren: curren$1,
        deg: deg$1,
        divide: divide$1,
        Eacute: Eacute$1,
        eacute: eacute$1,
        Ecirc: Ecirc$1,
        ecirc: ecirc$1,
        Egrave: Egrave$1,
        egrave: egrave$1,
        ETH: ETH$1,
        eth: eth$1,
        Euml: Euml$1,
        euml: euml$1,
        frac12: frac12$1,
        frac14: frac14$1,
        frac34: frac34$1,
        gt: gt$1,
        GT: GT$1,
        Iacute: Iacute$1,
        iacute: iacute$1,
        Icirc: Icirc$1,
        icirc: icirc$1,
        iexcl: iexcl$1,
        Igrave: Igrave$1,
        igrave: igrave$1,
        iquest: iquest$1,
        Iuml: Iuml$1,
        iuml: iuml$1,
        laquo: laquo$1,
        lt: lt$1,
        LT: LT$1,
        macr: macr$1,
        micro: micro$1,
        middot: middot$1,
        nbsp: nbsp$1,
        not: not$1,
        Ntilde: Ntilde$1,
        ntilde: ntilde$1,
        Oacute: Oacute$1,
        oacute: oacute$1,
        Ocirc: Ocirc$1,
        ocirc: ocirc$1,
        Ograve: Ograve$1,
        ograve: ograve$1,
        ordf: ordf$1,
        ordm: ordm$1,
        Oslash: Oslash$1,
        oslash: oslash$1,
        Otilde: Otilde$1,
        otilde: otilde$1,
        Ouml: Ouml$1,
        ouml: ouml$1,
        para: para$1,
        plusmn: plusmn$1,
        pound: pound$1,
        quot: quot$1,
        QUOT: QUOT$1,
        raquo: raquo$1,
        reg: reg$1,
        REG: REG$1,
        sect: sect$1,
        shy: shy$1,
        sup1: sup1$1,
        sup2: sup2$1,
        sup3: sup3$1,
        szlig: szlig$1,
        THORN: THORN$1,
        thorn: thorn$1,
        times: times$1,
        Uacute: Uacute$1,
        uacute: uacute$1,
        Ucirc: Ucirc$1,
        ucirc: ucirc$1,
        Ugrave: Ugrave$1,
        ugrave: ugrave$1,
        uml: uml$1,
        Uuml: Uuml$1,
        uuml: uuml$1,
        Yacute: Yacute$1,
        yacute: yacute$1,
        yen: yen$1,
        yuml: yuml$1,
        "default": legacy
      });
      var amp$2 = "&";
      var apos$1 = "'";
      var gt$2 = ">";
      var lt$2 = "<";
      var quot$2 = '"';
      var xml = {
        amp: amp$2,
        apos: apos$1,
        gt: gt$2,
        lt: lt$2,
        quot: quot$2
      };
      var xml$1 = /* @__PURE__ */ Object.freeze({
        __proto__: null,
        amp: amp$2,
        apos: apos$1,
        gt: gt$2,
        lt: lt$2,
        quot: quot$2,
        "default": xml
      });
      var decode = {
        "0": 65533,
        "128": 8364,
        "130": 8218,
        "131": 402,
        "132": 8222,
        "133": 8230,
        "134": 8224,
        "135": 8225,
        "136": 710,
        "137": 8240,
        "138": 352,
        "139": 8249,
        "140": 338,
        "142": 381,
        "145": 8216,
        "146": 8217,
        "147": 8220,
        "148": 8221,
        "149": 8226,
        "150": 8211,
        "151": 8212,
        "152": 732,
        "153": 8482,
        "154": 353,
        "155": 8250,
        "156": 339,
        "158": 382,
        "159": 376
      };
      var decode$1 = /* @__PURE__ */ Object.freeze({
        __proto__: null,
        "default": decode
      });
      var require$$0 = getCjsExportFromNamespace(decode$1);
      var decode_codepoint = createCommonjsModule(function(module3, exports3) {
        var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || function(mod) {
          return mod && mod.__esModule ? mod : { "default": mod };
        };
        Object.defineProperty(exports3, "__esModule", { value: true });
        var decode_json_1 = __importDefault(require$$0);
        function decodeCodePoint(codePoint) {
          if (codePoint >= 55296 && codePoint <= 57343 || codePoint > 1114111) {
            return "\uFFFD";
          }
          if (codePoint in decode_json_1.default) {
            codePoint = decode_json_1.default[codePoint];
          }
          var output = "";
          if (codePoint > 65535) {
            codePoint -= 65536;
            output += String.fromCharCode(codePoint >>> 10 & 1023 | 55296);
            codePoint = 56320 | codePoint & 1023;
          }
          output += String.fromCharCode(codePoint);
          return output;
        }
        exports3.default = decodeCodePoint;
      });
      unwrapExports(decode_codepoint);
      var require$$1 = getCjsExportFromNamespace(entities$1);
      var require$$1$1 = getCjsExportFromNamespace(legacy$1);
      var require$$0$1 = getCjsExportFromNamespace(xml$1);
      var decode$2 = createCommonjsModule(function(module3, exports3) {
        var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || function(mod) {
          return mod && mod.__esModule ? mod : { "default": mod };
        };
        Object.defineProperty(exports3, "__esModule", { value: true });
        exports3.decodeHTML = exports3.decodeHTMLStrict = exports3.decodeXML = void 0;
        var entities_json_1 = __importDefault(require$$1);
        var legacy_json_1 = __importDefault(require$$1$1);
        var xml_json_1 = __importDefault(require$$0$1);
        var decode_codepoint_1 = __importDefault(decode_codepoint);
        exports3.decodeXML = getStrictDecoder(xml_json_1.default);
        exports3.decodeHTMLStrict = getStrictDecoder(entities_json_1.default);
        function getStrictDecoder(map2) {
          var keys = Object.keys(map2).join("|");
          var replace = getReplacer(map2);
          keys += "|#[xX][\\da-fA-F]+|#\\d+";
          var re = new RegExp("&(?:" + keys + ");", "g");
          return function(str) {
            return String(str).replace(re, replace);
          };
        }
        var sorter = function(a, b) {
          return a < b ? 1 : -1;
        };
        exports3.decodeHTML = function() {
          var legacy2 = Object.keys(legacy_json_1.default).sort(sorter);
          var keys = Object.keys(entities_json_1.default).sort(sorter);
          for (var i = 0, j = 0; i < keys.length; i++) {
            if (legacy2[j] === keys[i]) {
              keys[i] += ";?";
              j++;
            } else {
              keys[i] += ";";
            }
          }
          var re = new RegExp("&(?:" + keys.join("|") + "|#[xX][\\da-fA-F]+;?|#\\d+;?)", "g");
          var replace = getReplacer(entities_json_1.default);
          function replacer(str) {
            if (str.substr(-1) !== ";")
              str += ";";
            return replace(str);
          }
          return function(str) {
            return String(str).replace(re, replacer);
          };
        }();
        function getReplacer(map2) {
          return function replace(str) {
            if (str.charAt(1) === "#") {
              var secondChar = str.charAt(2);
              if (secondChar === "X" || secondChar === "x") {
                return decode_codepoint_1.default(parseInt(str.substr(3), 16));
              }
              return decode_codepoint_1.default(parseInt(str.substr(2), 10));
            }
            return map2[str.slice(1, -1)];
          };
        }
      });
      unwrapExports(decode$2);
      var decode_1 = decode$2.decodeHTML;
      var decode_2 = decode$2.decodeHTMLStrict;
      var decode_3 = decode$2.decodeXML;
      var encode$1 = createCommonjsModule(function(module3, exports3) {
        var __importDefault = commonjsGlobal && commonjsGlobal.__importDefault || function(mod) {
          return mod && mod.__esModule ? mod : { "default": mod };
        };
        Object.defineProperty(exports3, "__esModule", { value: true });
        exports3.escape = exports3.encodeHTML = exports3.encodeXML = void 0;
        var xml_json_1 = __importDefault(require$$0$1);
        var inverseXML = getInverseObj(xml_json_1.default);
        var xmlReplacer = getInverseReplacer(inverseXML);
        exports3.encodeXML = getInverse(inverseXML, xmlReplacer);
        var entities_json_1 = __importDefault(require$$1);
        var inverseHTML = getInverseObj(entities_json_1.default);
        var htmlReplacer = getInverseReplacer(inverseHTML);
        exports3.encodeHTML = getInverse(inverseHTML, htmlReplacer);
        function getInverseObj(obj) {
          return Object.keys(obj).sort().reduce(function(inverse, name) {
            inverse[obj[name]] = "&" + name + ";";
            return inverse;
          }, {});
        }
        function getInverseReplacer(inverse) {
          var single = [];
          var multiple = [];
          for (var _i = 0, _a = Object.keys(inverse); _i < _a.length; _i++) {
            var k = _a[_i];
            if (k.length === 1) {
              single.push("\\" + k);
            } else {
              multiple.push(k);
            }
          }
          single.sort();
          for (var start = 0; start < single.length - 1; start++) {
            var end = start;
            while (end < single.length - 1 && single[end].charCodeAt(1) + 1 === single[end + 1].charCodeAt(1)) {
              end += 1;
            }
            var count = 1 + end - start;
            if (count < 3)
              continue;
            single.splice(start, count, single[start] + "-" + single[end]);
          }
          multiple.unshift("[" + single.join("") + "]");
          return new RegExp(multiple.join("|"), "g");
        }
        var reNonASCII = /(?:[\x80-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])/g;
        function singleCharReplacer(c) {
          return "&#x" + c.codePointAt(0).toString(16).toUpperCase() + ";";
        }
        function getInverse(inverse, re) {
          return function(data) {
            return data.replace(re, function(name) {
              return inverse[name];
            }).replace(reNonASCII, singleCharReplacer);
          };
        }
        var reXmlChars = getInverseReplacer(inverseXML);
        function escape2(data) {
          return data.replace(reXmlChars, singleCharReplacer).replace(reNonASCII, singleCharReplacer);
        }
        exports3.escape = escape2;
      });
      unwrapExports(encode$1);
      var encode_1$1 = encode$1.escape;
      var encode_2 = encode$1.encodeHTML;
      var encode_3 = encode$1.encodeXML;
      var lib = createCommonjsModule(function(module3, exports3) {
        Object.defineProperty(exports3, "__esModule", { value: true });
        exports3.encode = exports3.decodeStrict = exports3.decode = void 0;
        function decode2(data, level) {
          return (!level || level <= 0 ? decode$2.decodeXML : decode$2.decodeHTML)(data);
        }
        exports3.decode = decode2;
        function decodeStrict(data, level) {
          return (!level || level <= 0 ? decode$2.decodeXML : decode$2.decodeHTMLStrict)(data);
        }
        exports3.decodeStrict = decodeStrict;
        function encode2(data, level) {
          return (!level || level <= 0 ? encode$1.encodeXML : encode$1.encodeHTML)(data);
        }
        exports3.encode = encode2;
        var encode_22 = encode$1;
        Object.defineProperty(exports3, "encodeXML", { enumerable: true, get: function() {
          return encode_22.encodeXML;
        } });
        Object.defineProperty(exports3, "encodeHTML", { enumerable: true, get: function() {
          return encode_22.encodeHTML;
        } });
        Object.defineProperty(exports3, "escape", { enumerable: true, get: function() {
          return encode_22.escape;
        } });
        Object.defineProperty(exports3, "encodeHTML4", { enumerable: true, get: function() {
          return encode_22.encodeHTML;
        } });
        Object.defineProperty(exports3, "encodeHTML5", { enumerable: true, get: function() {
          return encode_22.encodeHTML;
        } });
        var decode_22 = decode$2;
        Object.defineProperty(exports3, "decodeXML", { enumerable: true, get: function() {
          return decode_22.decodeXML;
        } });
        Object.defineProperty(exports3, "decodeHTML", { enumerable: true, get: function() {
          return decode_22.decodeHTML;
        } });
        Object.defineProperty(exports3, "decodeHTMLStrict", { enumerable: true, get: function() {
          return decode_22.decodeHTMLStrict;
        } });
        Object.defineProperty(exports3, "decodeHTML4", { enumerable: true, get: function() {
          return decode_22.decodeHTML;
        } });
        Object.defineProperty(exports3, "decodeHTML5", { enumerable: true, get: function() {
          return decode_22.decodeHTML;
        } });
        Object.defineProperty(exports3, "decodeHTML4Strict", { enumerable: true, get: function() {
          return decode_22.decodeHTMLStrict;
        } });
        Object.defineProperty(exports3, "decodeHTML5Strict", { enumerable: true, get: function() {
          return decode_22.decodeHTMLStrict;
        } });
        Object.defineProperty(exports3, "decodeXMLStrict", { enumerable: true, get: function() {
          return decode_22.decodeXML;
        } });
      });
      unwrapExports(lib);
      var lib_1 = lib.encode;
      var lib_2 = lib.decodeStrict;
      var lib_3 = lib.decode;
      var lib_4 = lib.encodeXML;
      var lib_5 = lib.encodeHTML;
      var lib_6 = lib.encodeHTML4;
      var lib_7 = lib.encodeHTML5;
      var lib_8 = lib.decodeXML;
      var lib_9 = lib.decodeHTML;
      var lib_10 = lib.decodeHTMLStrict;
      var lib_11 = lib.decodeHTML4;
      var lib_12 = lib.decodeHTML5;
      var lib_13 = lib.decodeHTML4Strict;
      var lib_14 = lib.decodeHTML5Strict;
      var lib_15 = lib.decodeXMLStrict;
      var C_BACKSLASH = 92;
      var ENTITY = "&(?:#x[a-f0-9]{1,6}|#[0-9]{1,7}|[a-z][a-z0-9]{1,31});";
      var TAGNAME = "[A-Za-z][A-Za-z0-9-]*";
      var ATTRIBUTENAME = "[a-zA-Z_:][a-zA-Z0-9:._-]*";
      var UNQUOTEDVALUE = "[^\"'=<>`\\x00-\\x20]+";
      var SINGLEQUOTEDVALUE = "'[^']*'";
      var DOUBLEQUOTEDVALUE = '"[^"]*"';
      var ATTRIBUTEVALUE = "(?:" + UNQUOTEDVALUE + "|" + SINGLEQUOTEDVALUE + "|" + DOUBLEQUOTEDVALUE + ")";
      var ATTRIBUTEVALUESPEC = "(?:\\s*=\\s*" + ATTRIBUTEVALUE + ")";
      var ATTRIBUTE = "(?:\\s+" + ATTRIBUTENAME + ATTRIBUTEVALUESPEC + "?)";
      var OPENTAG = "<" + TAGNAME + ATTRIBUTE + "*\\s*/?>";
      var CLOSETAG = "</" + TAGNAME + "\\s*[>]";
      var HTMLCOMMENT = "<!---->|<!--(?:-?[^>-])(?:-?[^-])*-->";
      var PROCESSINGINSTRUCTION = "[<][?][\\s\\S]*?[?][>]";
      var DECLARATION = "<![A-Z]+\\s+[^>]*>";
      var CDATA = "<!\\[CDATA\\[[\\s\\S]*?\\]\\]>";
      var HTMLTAG = "(?:" + OPENTAG + "|" + CLOSETAG + "|" + HTMLCOMMENT + "|" + PROCESSINGINSTRUCTION + "|" + DECLARATION + "|" + CDATA + ")";
      var reHtmlTag = new RegExp("^" + HTMLTAG);
      var reBackslashOrAmp = /[\\&]/;
      var ESCAPABLE = "[!\"#$%&'()*+,./:;<=>?@[\\\\\\]^_`{|}~-]";
      var reEntityOrEscapedChar = new RegExp("\\\\" + ESCAPABLE + "|" + ENTITY, "gi");
      var XMLSPECIAL = '[&<>"]';
      var reXmlSpecial = new RegExp(XMLSPECIAL, "g");
      var unescapeChar = function(s) {
        if (s.charCodeAt(0) === C_BACKSLASH) {
          return s.charAt(1);
        } else {
          return lib_9(s);
        }
      };
      var unescapeString = function(s) {
        if (reBackslashOrAmp.test(s)) {
          return s.replace(reEntityOrEscapedChar, unescapeChar);
        } else {
          return s;
        }
      };
      var normalizeURI = function(uri) {
        try {
          return encode_1(uri);
        } catch (err) {
          return uri;
        }
      };
      var replaceUnsafeChar = function(s) {
        switch (s) {
          case "&":
            return "&amp;";
          case "<":
            return "&lt;";
          case ">":
            return "&gt;";
          case '"':
            return "&quot;";
          default:
            return s;
        }
      };
      var escapeXml = function(s) {
        if (reXmlSpecial.test(s)) {
          return s.replace(reXmlSpecial, replaceUnsafeChar);
        } else {
          return s;
        }
      };
      var _fromCodePoint;
      function fromCodePoint(_) {
        return _fromCodePoint(_);
      }
      if (String.fromCodePoint) {
        _fromCodePoint = function(_) {
          try {
            return String.fromCodePoint(_);
          } catch (e) {
            if (e instanceof RangeError) {
              return String.fromCharCode(65533);
            }
            throw e;
          }
        };
      } else {
        var stringFromCharCode = String.fromCharCode;
        var floor = Math.floor;
        _fromCodePoint = function() {
          var MAX_SIZE = 16384;
          var codeUnits = [];
          var highSurrogate;
          var lowSurrogate;
          var index = -1;
          var length = arguments.length;
          if (!length) {
            return "";
          }
          var result = "";
          while (++index < length) {
            var codePoint = Number(arguments[index]);
            if (!isFinite(codePoint) || codePoint < 0 || codePoint > 1114111 || floor(codePoint) !== codePoint) {
              return String.fromCharCode(65533);
            }
            if (codePoint <= 65535) {
              codeUnits.push(codePoint);
            } else {
              codePoint -= 65536;
              highSurrogate = (codePoint >> 10) + 55296;
              lowSurrogate = codePoint % 1024 + 56320;
              codeUnits.push(highSurrogate, lowSurrogate);
            }
            if (index + 1 === length || codeUnits.length > MAX_SIZE) {
              result += stringFromCharCode.apply(null, codeUnits);
              codeUnits.length = 0;
            }
          }
          return result;
        };
      }
      if (!String.prototype.repeat) {
        (function() {
          var defineProperty = function() {
            try {
              var object = {};
              var $defineProperty = Object.defineProperty;
              var result = $defineProperty(object, object, object) && $defineProperty;
            } catch (error) {
            }
            return result;
          }();
          var repeat = function(count) {
            if (this == null) {
              throw TypeError();
            }
            var string = String(this);
            var n = count ? Number(count) : 0;
            if (n != n) {
              n = 0;
            }
            if (n < 0 || n == Infinity) {
              throw RangeError();
            }
            var result = "";
            while (n) {
              if (n % 2 == 1) {
                result += string;
              }
              if (n > 1) {
                string += string;
              }
              n >>= 1;
            }
            return result;
          };
          if (defineProperty) {
            defineProperty(String.prototype, "repeat", {
              "value": repeat,
              "configurable": true,
              "writable": true
            });
          } else {
            String.prototype.repeat = repeat;
          }
        })();
      }
      var normalizeURI$1 = normalizeURI;
      var unescapeString$1 = unescapeString;
      var C_NEWLINE = 10;
      var C_ASTERISK = 42;
      var C_UNDERSCORE = 95;
      var C_BACKTICK = 96;
      var C_OPEN_BRACKET = 91;
      var C_CLOSE_BRACKET = 93;
      var C_LESSTHAN = 60;
      var C_BANG = 33;
      var C_BACKSLASH$1 = 92;
      var C_AMPERSAND = 38;
      var C_OPEN_PAREN = 40;
      var C_CLOSE_PAREN = 41;
      var C_COLON = 58;
      var C_SINGLEQUOTE = 39;
      var C_DOUBLEQUOTE = 34;
      var ESCAPABLE$1 = ESCAPABLE;
      var ESCAPED_CHAR = "\\\\" + ESCAPABLE$1;
      var ENTITY$1 = ENTITY;
      var reHtmlTag$1 = reHtmlTag;
      var rePunctuation = new RegExp(/^[!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~\xA1\xA7\xAB\xB6\xB7\xBB\xBF\u037E\u0387\u055A-\u055F\u0589\u058A\u05BE\u05C0\u05C3\u05C6\u05F3\u05F4\u0609\u060A\u060C\u060D\u061B\u061E\u061F\u066A-\u066D\u06D4\u0700-\u070D\u07F7-\u07F9\u0830-\u083E\u085E\u0964\u0965\u0970\u0AF0\u0DF4\u0E4F\u0E5A\u0E5B\u0F04-\u0F12\u0F14\u0F3A-\u0F3D\u0F85\u0FD0-\u0FD4\u0FD9\u0FDA\u104A-\u104F\u10FB\u1360-\u1368\u1400\u166D\u166E\u169B\u169C\u16EB-\u16ED\u1735\u1736\u17D4-\u17D6\u17D8-\u17DA\u1800-\u180A\u1944\u1945\u1A1E\u1A1F\u1AA0-\u1AA6\u1AA8-\u1AAD\u1B5A-\u1B60\u1BFC-\u1BFF\u1C3B-\u1C3F\u1C7E\u1C7F\u1CC0-\u1CC7\u1CD3\u2010-\u2027\u2030-\u2043\u2045-\u2051\u2053-\u205E\u207D\u207E\u208D\u208E\u2308-\u230B\u2329\u232A\u2768-\u2775\u27C5\u27C6\u27E6-\u27EF\u2983-\u2998\u29D8-\u29DB\u29FC\u29FD\u2CF9-\u2CFC\u2CFE\u2CFF\u2D70\u2E00-\u2E2E\u2E30-\u2E42\u3001-\u3003\u3008-\u3011\u3014-\u301F\u3030\u303D\u30A0\u30FB\uA4FE\uA4FF\uA60D-\uA60F\uA673\uA67E\uA6F2-\uA6F7\uA874-\uA877\uA8CE\uA8CF\uA8F8-\uA8FA\uA8FC\uA92E\uA92F\uA95F\uA9C1-\uA9CD\uA9DE\uA9DF\uAA5C-\uAA5F\uAADE\uAADF\uAAF0\uAAF1\uABEB\uFD3E\uFD3F\uFE10-\uFE19\uFE30-\uFE52\uFE54-\uFE61\uFE63\uFE68\uFE6A\uFE6B\uFF01-\uFF03\uFF05-\uFF0A\uFF0C-\uFF0F\uFF1A\uFF1B\uFF1F\uFF20\uFF3B-\uFF3D\uFF3F\uFF5B\uFF5D\uFF5F-\uFF65]|\uD800[\uDD00-\uDD02\uDF9F\uDFD0]|\uD801\uDD6F|\uD802[\uDC57\uDD1F\uDD3F\uDE50-\uDE58\uDE7F\uDEF0-\uDEF6\uDF39-\uDF3F\uDF99-\uDF9C]|\uD804[\uDC47-\uDC4D\uDCBB\uDCBC\uDCBE-\uDCC1\uDD40-\uDD43\uDD74\uDD75\uDDC5-\uDDC9\uDDCD\uDDDB\uDDDD-\uDDDF\uDE38-\uDE3D\uDEA9]|\uD805[\uDCC6\uDDC1-\uDDD7\uDE41-\uDE43\uDF3C-\uDF3E]|\uD809[\uDC70-\uDC74]|\uD81A[\uDE6E\uDE6F\uDEF5\uDF37-\uDF3B\uDF44]|\uD82F\uDC9F|\uD836[\uDE87-\uDE8B]/);
      var reLinkTitle = new RegExp('^(?:"(' + ESCAPED_CHAR + `|[^"\\x00])*"|'(` + ESCAPED_CHAR + "|[^'\\x00])*'|\\((" + ESCAPED_CHAR + "|[^()\\x00])*\\))");
      var reLinkDestinationBraces = /^(?:<(?:[^<>\n\\\x00]|\\.)*>)/;
      var reEscapable = new RegExp("^" + ESCAPABLE$1);
      var reEntityHere = new RegExp("^" + ENTITY$1, "i");
      var reTicks = /`+/;
      var reTicksHere = /^`+/;
      var reEllipses = /\.\.\./g;
      var reDash = /--+/g;
      var reEmailAutolink = /^<([a-zA-Z0-9.!#$%&'*+\/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*)>/;
      var reAutolink = /^<[A-Za-z][A-Za-z0-9.+-]{1,31}:[^<>\x00-\x20]*>/i;
      var reSpnl = /^ *(?:\n *)?/;
      var reWhitespaceChar = /^[ \t\n\x0b\x0c\x0d]/;
      var reUnicodeWhitespaceChar = /^\s/;
      var reFinalSpace = / *$/;
      var reInitialSpace = /^ */;
      var reSpaceAtEndOfLine = /^ *(?:\n|$)/;
      var reLinkLabel = /^\[(?:[^\\\[\]]|\\.){0,1000}\]/s;
      var reMain = /^[^\n`\[\]\\!<&*_'"]+/m;
      var text = function(s) {
        var node = new Node("text");
        node._literal = s;
        return node;
      };
      var normalizeReference = function(string) {
        return string.slice(1, string.length - 1).trim().replace(/[ \t\r\n]+/, " ").toLowerCase().toUpperCase();
      };
      var match = function(re) {
        var m = re.exec(this.subject.slice(this.pos));
        if (m === null) {
          return null;
        } else {
          this.pos += m.index + m[0].length;
          return m[0];
        }
      };
      var peek = function() {
        if (this.pos < this.subject.length) {
          return this.subject.charCodeAt(this.pos);
        } else {
          return -1;
        }
      };
      var spnl = function() {
        this.match(reSpnl);
        return true;
      };
      var parseBackticks = function(block2) {
        var ticks = this.match(reTicksHere);
        if (ticks === null) {
          return false;
        }
        var afterOpenTicks = this.pos;
        var matched;
        var node;
        var contents;
        while ((matched = this.match(reTicks)) !== null) {
          if (matched === ticks) {
            node = new Node("code");
            contents = this.subject.slice(afterOpenTicks, this.pos - ticks.length).replace(/\n/gm, " ");
            if (contents.length > 0 && contents.match(/[^ ]/) !== null && contents[0] == " " && contents[contents.length - 1] == " ") {
              node._literal = contents.slice(1, contents.length - 1);
            } else {
              node._literal = contents;
            }
            block2.appendChild(node);
            return true;
          }
        }
        this.pos = afterOpenTicks;
        block2.appendChild(text(ticks));
        return true;
      };
      var parseBackslash = function(block2) {
        var subj = this.subject;
        var node;
        this.pos += 1;
        if (this.peek() === C_NEWLINE) {
          this.pos += 1;
          node = new Node("linebreak");
          block2.appendChild(node);
        } else if (reEscapable.test(subj.charAt(this.pos))) {
          block2.appendChild(text(subj.charAt(this.pos)));
          this.pos += 1;
        } else {
          block2.appendChild(text("\\"));
        }
        return true;
      };
      var parseAutolink = function(block2) {
        var m;
        var dest;
        var node;
        if (m = this.match(reEmailAutolink)) {
          dest = m.slice(1, m.length - 1);
          node = new Node("link");
          node._destination = normalizeURI$1("mailto:" + dest);
          node._title = "";
          node.appendChild(text(dest));
          block2.appendChild(node);
          return true;
        } else if (m = this.match(reAutolink)) {
          dest = m.slice(1, m.length - 1);
          node = new Node("link");
          node._destination = normalizeURI$1(dest);
          node._title = "";
          node.appendChild(text(dest));
          block2.appendChild(node);
          return true;
        } else {
          return false;
        }
      };
      var parseHtmlTag = function(block2) {
        var m = this.match(reHtmlTag$1);
        if (m === null) {
          return false;
        } else {
          var node = new Node("html_inline");
          node._literal = m;
          block2.appendChild(node);
          return true;
        }
      };
      var scanDelims = function(cc) {
        var numdelims = 0;
        var char_before, char_after, cc_after;
        var startpos = this.pos;
        var left_flanking, right_flanking, can_open, can_close;
        var after_is_whitespace, after_is_punctuation, before_is_whitespace, before_is_punctuation;
        if (cc === C_SINGLEQUOTE || cc === C_DOUBLEQUOTE) {
          numdelims++;
          this.pos++;
        } else {
          while (this.peek() === cc) {
            numdelims++;
            this.pos++;
          }
        }
        if (numdelims === 0) {
          return null;
        }
        char_before = startpos === 0 ? "\n" : this.subject.charAt(startpos - 1);
        cc_after = this.peek();
        if (cc_after === -1) {
          char_after = "\n";
        } else {
          char_after = fromCodePoint(cc_after);
        }
        after_is_whitespace = reUnicodeWhitespaceChar.test(char_after);
        after_is_punctuation = rePunctuation.test(char_after);
        before_is_whitespace = reUnicodeWhitespaceChar.test(char_before);
        before_is_punctuation = rePunctuation.test(char_before);
        left_flanking = !after_is_whitespace && (!after_is_punctuation || before_is_whitespace || before_is_punctuation);
        right_flanking = !before_is_whitespace && (!before_is_punctuation || after_is_whitespace || after_is_punctuation);
        if (cc === C_UNDERSCORE) {
          can_open = left_flanking && (!right_flanking || before_is_punctuation);
          can_close = right_flanking && (!left_flanking || after_is_punctuation);
        } else if (cc === C_SINGLEQUOTE || cc === C_DOUBLEQUOTE) {
          can_open = left_flanking && !right_flanking;
          can_close = right_flanking;
        } else {
          can_open = left_flanking;
          can_close = right_flanking;
        }
        this.pos = startpos;
        return { numdelims, can_open, can_close };
      };
      var handleDelim = function(cc, block2) {
        var res = this.scanDelims(cc);
        if (!res) {
          return false;
        }
        var numdelims = res.numdelims;
        var startpos = this.pos;
        var contents;
        this.pos += numdelims;
        if (cc === C_SINGLEQUOTE) {
          contents = "\u2019";
        } else if (cc === C_DOUBLEQUOTE) {
          contents = "\u201C";
        } else {
          contents = this.subject.slice(startpos, this.pos);
        }
        var node = text(contents);
        block2.appendChild(node);
        if ((res.can_open || res.can_close) && (this.options.smart || cc !== C_SINGLEQUOTE && cc !== C_DOUBLEQUOTE)) {
          this.delimiters = {
            cc,
            numdelims,
            origdelims: numdelims,
            node,
            previous: this.delimiters,
            next: null,
            can_open: res.can_open,
            can_close: res.can_close
          };
          if (this.delimiters.previous !== null) {
            this.delimiters.previous.next = this.delimiters;
          }
        }
        return true;
      };
      var removeDelimiter = function(delim) {
        if (delim.previous !== null) {
          delim.previous.next = delim.next;
        }
        if (delim.next === null) {
          this.delimiters = delim.previous;
        } else {
          delim.next.previous = delim.previous;
        }
      };
      var removeDelimitersBetween = function(bottom2, top2) {
        if (bottom2.next !== top2) {
          bottom2.next = top2;
          top2.previous = bottom2;
        }
      };
      var processEmphasis = function(stack_bottom) {
        var opener, closer, old_closer;
        var opener_inl, closer_inl;
        var tempstack;
        var use_delims;
        var tmp, next2;
        var opener_found;
        var openers_bottom = [];
        var openers_bottom_index;
        var odd_match = false;
        for (var i = 0; i < 8; i++) {
          openers_bottom[i] = stack_bottom;
        }
        closer = this.delimiters;
        while (closer !== null && closer.previous !== stack_bottom) {
          closer = closer.previous;
        }
        while (closer !== null) {
          var closercc = closer.cc;
          if (!closer.can_close) {
            closer = closer.next;
          } else {
            opener = closer.previous;
            opener_found = false;
            switch (closercc) {
              case C_SINGLEQUOTE:
                openers_bottom_index = 0;
                break;
              case C_DOUBLEQUOTE:
                openers_bottom_index = 1;
                break;
              case C_UNDERSCORE:
                openers_bottom_index = 2;
                break;
              case C_ASTERISK:
                openers_bottom_index = 3 + (closer.can_open ? 3 : 0) + closer.origdelims % 3;
                break;
            }
            while (opener !== null && opener !== stack_bottom && opener !== openers_bottom[openers_bottom_index]) {
              odd_match = (closer.can_open || opener.can_close) && closer.origdelims % 3 !== 0 && (opener.origdelims + closer.origdelims) % 3 === 0;
              if (opener.cc === closer.cc && opener.can_open && !odd_match) {
                opener_found = true;
                break;
              }
              opener = opener.previous;
            }
            old_closer = closer;
            if (closercc === C_ASTERISK || closercc === C_UNDERSCORE) {
              if (!opener_found) {
                closer = closer.next;
              } else {
                use_delims = closer.numdelims >= 2 && opener.numdelims >= 2 ? 2 : 1;
                opener_inl = opener.node;
                closer_inl = closer.node;
                opener.numdelims -= use_delims;
                closer.numdelims -= use_delims;
                opener_inl._literal = opener_inl._literal.slice(0, opener_inl._literal.length - use_delims);
                closer_inl._literal = closer_inl._literal.slice(0, closer_inl._literal.length - use_delims);
                var emph2 = new Node(use_delims === 1 ? "emph" : "strong");
                tmp = opener_inl._next;
                while (tmp && tmp !== closer_inl) {
                  next2 = tmp._next;
                  tmp.unlink();
                  emph2.appendChild(tmp);
                  tmp = next2;
                }
                opener_inl.insertAfter(emph2);
                removeDelimitersBetween(opener, closer);
                if (opener.numdelims === 0) {
                  opener_inl.unlink();
                  this.removeDelimiter(opener);
                }
                if (closer.numdelims === 0) {
                  closer_inl.unlink();
                  tempstack = closer.next;
                  this.removeDelimiter(closer);
                  closer = tempstack;
                }
              }
            } else if (closercc === C_SINGLEQUOTE) {
              closer.node._literal = "\u2019";
              if (opener_found) {
                opener.node._literal = "\u2018";
              }
              closer = closer.next;
            } else if (closercc === C_DOUBLEQUOTE) {
              closer.node._literal = "\u201D";
              if (opener_found) {
                opener.node.literal = "\u201C";
              }
              closer = closer.next;
            }
            if (!opener_found) {
              openers_bottom[openers_bottom_index] = old_closer.previous;
              if (!old_closer.can_open) {
                this.removeDelimiter(old_closer);
              }
            }
          }
        }
        while (this.delimiters !== null && this.delimiters !== stack_bottom) {
          this.removeDelimiter(this.delimiters);
        }
      };
      var parseLinkTitle = function() {
        var title = this.match(reLinkTitle);
        if (title === null) {
          return null;
        } else {
          return unescapeString$1(title.substr(1, title.length - 2));
        }
      };
      var parseLinkDestination = function() {
        var res = this.match(reLinkDestinationBraces);
        if (res === null) {
          if (this.peek() === C_LESSTHAN) {
            return null;
          }
          var savepos = this.pos;
          var openparens = 0;
          var c;
          while ((c = this.peek()) !== -1) {
            if (c === C_BACKSLASH$1 && reEscapable.test(this.subject.charAt(this.pos + 1))) {
              this.pos += 1;
              if (this.peek() !== -1) {
                this.pos += 1;
              }
            } else if (c === C_OPEN_PAREN) {
              this.pos += 1;
              openparens += 1;
            } else if (c === C_CLOSE_PAREN) {
              if (openparens < 1) {
                break;
              } else {
                this.pos += 1;
                openparens -= 1;
              }
            } else if (reWhitespaceChar.exec(fromCodePoint(c)) !== null) {
              break;
            } else {
              this.pos += 1;
            }
          }
          if (this.pos === savepos && c !== C_CLOSE_PAREN) {
            return null;
          }
          if (openparens !== 0) {
            return null;
          }
          res = this.subject.substr(savepos, this.pos - savepos);
          return normalizeURI$1(unescapeString$1(res));
        } else {
          return normalizeURI$1(unescapeString$1(res.substr(1, res.length - 2)));
        }
      };
      var parseLinkLabel = function() {
        var m = this.match(reLinkLabel);
        if (m === null || m.length > 1001) {
          return 0;
        } else {
          return m.length;
        }
      };
      var parseOpenBracket = function(block2) {
        var startpos = this.pos;
        this.pos += 1;
        var node = text("[");
        block2.appendChild(node);
        this.addBracket(node, startpos, false);
        return true;
      };
      var parseBang = function(block2) {
        var startpos = this.pos;
        this.pos += 1;
        if (this.peek() === C_OPEN_BRACKET) {
          this.pos += 1;
          var node = text("![");
          block2.appendChild(node);
          this.addBracket(node, startpos + 1, true);
        } else {
          block2.appendChild(text("!"));
        }
        return true;
      };
      var parseCloseBracket = function(block2) {
        var startpos;
        var is_image;
        var dest;
        var title;
        var matched = false;
        var reflabel;
        var opener;
        this.pos += 1;
        startpos = this.pos;
        opener = this.brackets;
        if (opener === null) {
          block2.appendChild(text("]"));
          return true;
        }
        if (!opener.active) {
          block2.appendChild(text("]"));
          this.removeBracket();
          return true;
        }
        is_image = opener.image;
        var savepos = this.pos;
        if (this.peek() === C_OPEN_PAREN) {
          this.pos++;
          if (this.spnl() && (dest = this.parseLinkDestination()) !== null && this.spnl() && (reWhitespaceChar.test(this.subject.charAt(this.pos - 1)) && (title = this.parseLinkTitle()) || true) && this.spnl() && this.peek() === C_CLOSE_PAREN) {
            this.pos += 1;
            matched = true;
          } else {
            this.pos = savepos;
          }
        }
        if (!matched) {
          var beforelabel = this.pos;
          var n = this.parseLinkLabel();
          if (n > 2) {
            reflabel = this.subject.slice(beforelabel, beforelabel + n);
          } else if (!opener.bracketAfter) {
            reflabel = this.subject.slice(opener.index, startpos);
          }
          if (n === 0) {
            this.pos = savepos;
          }
          if (reflabel) {
            var link2 = this.refmap[normalizeReference(reflabel)];
            if (link2) {
              dest = link2.destination;
              title = link2.title;
              matched = true;
            }
          }
        }
        if (matched) {
          var node = new Node(is_image ? "image" : "link");
          node._destination = dest;
          node._title = title || "";
          var tmp, next2;
          tmp = opener.node._next;
          while (tmp) {
            next2 = tmp._next;
            tmp.unlink();
            node.appendChild(tmp);
            tmp = next2;
          }
          block2.appendChild(node);
          this.processEmphasis(opener.previousDelimiter);
          this.removeBracket();
          opener.node.unlink();
          if (!is_image) {
            opener = this.brackets;
            while (opener !== null) {
              if (!opener.image) {
                opener.active = false;
              }
              opener = opener.previous;
            }
          }
          return true;
        } else {
          this.removeBracket();
          this.pos = startpos;
          block2.appendChild(text("]"));
          return true;
        }
      };
      var addBracket = function(node, index, image2) {
        if (this.brackets !== null) {
          this.brackets.bracketAfter = true;
        }
        this.brackets = {
          node,
          previous: this.brackets,
          previousDelimiter: this.delimiters,
          index,
          image: image2,
          active: true
        };
      };
      var removeBracket = function() {
        this.brackets = this.brackets.previous;
      };
      var parseEntity = function(block2) {
        var m;
        if (m = this.match(reEntityHere)) {
          block2.appendChild(text(lib_9(m)));
          return true;
        } else {
          return false;
        }
      };
      var parseString = function(block2) {
        var m;
        if (m = this.match(reMain)) {
          if (this.options.smart) {
            block2.appendChild(text(m.replace(reEllipses, "\u2026").replace(reDash, function(chars) {
              var enCount = 0;
              var emCount = 0;
              if (chars.length % 3 === 0) {
                emCount = chars.length / 3;
              } else if (chars.length % 2 === 0) {
                enCount = chars.length / 2;
              } else if (chars.length % 3 === 2) {
                enCount = 1;
                emCount = (chars.length - 2) / 3;
              } else {
                enCount = 2;
                emCount = (chars.length - 4) / 3;
              }
              return "\u2014".repeat(emCount) + "\u2013".repeat(enCount);
            })));
          } else {
            block2.appendChild(text(m));
          }
          return true;
        } else {
          return false;
        }
      };
      var parseNewline = function(block2) {
        this.pos += 1;
        var lastc = block2._lastChild;
        if (lastc && lastc.type === "text" && lastc._literal[lastc._literal.length - 1] === " ") {
          var hardbreak = lastc._literal[lastc._literal.length - 2] === " ";
          lastc._literal = lastc._literal.replace(reFinalSpace, "");
          block2.appendChild(new Node(hardbreak ? "linebreak" : "softbreak"));
        } else {
          block2.appendChild(new Node("softbreak"));
        }
        this.match(reInitialSpace);
        return true;
      };
      var parseReference = function(s, refmap) {
        this.subject = s;
        this.pos = 0;
        var rawlabel;
        var dest;
        var title;
        var matchChars;
        var startpos = this.pos;
        matchChars = this.parseLinkLabel();
        if (matchChars === 0) {
          return 0;
        } else {
          rawlabel = this.subject.substr(0, matchChars);
        }
        if (this.peek() === C_COLON) {
          this.pos++;
        } else {
          this.pos = startpos;
          return 0;
        }
        this.spnl();
        dest = this.parseLinkDestination();
        if (dest === null) {
          this.pos = startpos;
          return 0;
        }
        var beforetitle = this.pos;
        this.spnl();
        if (this.pos !== beforetitle) {
          title = this.parseLinkTitle();
        }
        if (title === null) {
          title = "";
          this.pos = beforetitle;
        }
        var atLineEnd = true;
        if (this.match(reSpaceAtEndOfLine) === null) {
          if (title === "") {
            atLineEnd = false;
          } else {
            title = "";
            this.pos = beforetitle;
            atLineEnd = this.match(reSpaceAtEndOfLine) !== null;
          }
        }
        if (!atLineEnd) {
          this.pos = startpos;
          return 0;
        }
        var normlabel = normalizeReference(rawlabel);
        if (normlabel === "") {
          this.pos = startpos;
          return 0;
        }
        if (!refmap[normlabel]) {
          refmap[normlabel] = { destination: dest, title };
        }
        return this.pos - startpos;
      };
      var parseInline = function(block2) {
        var res = false;
        var c = this.peek();
        if (c === -1) {
          return false;
        }
        switch (c) {
          case C_NEWLINE:
            res = this.parseNewline(block2);
            break;
          case C_BACKSLASH$1:
            res = this.parseBackslash(block2);
            break;
          case C_BACKTICK:
            res = this.parseBackticks(block2);
            break;
          case C_ASTERISK:
          case C_UNDERSCORE:
            res = this.handleDelim(c, block2);
            break;
          case C_SINGLEQUOTE:
          case C_DOUBLEQUOTE:
            res = this.options.smart && this.handleDelim(c, block2);
            break;
          case C_OPEN_BRACKET:
            res = this.parseOpenBracket(block2);
            break;
          case C_BANG:
            res = this.parseBang(block2);
            break;
          case C_CLOSE_BRACKET:
            res = this.parseCloseBracket(block2);
            break;
          case C_LESSTHAN:
            res = this.parseAutolink(block2) || this.parseHtmlTag(block2);
            break;
          case C_AMPERSAND:
            res = this.parseEntity(block2);
            break;
          default:
            res = this.parseString(block2);
            break;
        }
        if (!res) {
          this.pos += 1;
          block2.appendChild(text(fromCodePoint(c)));
        }
        return true;
      };
      var parseInlines = function(block2) {
        this.subject = block2._string_content.trim();
        this.pos = 0;
        this.delimiters = null;
        this.brackets = null;
        while (this.parseInline(block2)) {
        }
        block2._string_content = null;
        this.processEmphasis(null);
      };
      function InlineParser(options) {
        return {
          subject: "",
          delimiters: null,
          brackets: null,
          pos: 0,
          refmap: {},
          match,
          peek,
          spnl,
          parseBackticks,
          parseBackslash,
          parseAutolink,
          parseHtmlTag,
          scanDelims,
          handleDelim,
          parseLinkTitle,
          parseLinkDestination,
          parseLinkLabel,
          parseOpenBracket,
          parseBang,
          parseCloseBracket,
          addBracket,
          removeBracket,
          parseEntity,
          parseString,
          parseNewline,
          parseReference,
          parseInline,
          processEmphasis,
          removeDelimiter,
          options: options || {},
          parse: parseInlines
        };
      }
      var CODE_INDENT = 4;
      var C_TAB = 9;
      var C_NEWLINE$1 = 10;
      var C_GREATERTHAN = 62;
      var C_LESSTHAN$1 = 60;
      var C_SPACE = 32;
      var C_OPEN_BRACKET$1 = 91;
      var reHtmlBlockOpen = [
        /./,
        /^<(?:script|pre|textarea|style)(?:\s|>|$)/i,
        /^<!--/,
        /^<[?]/,
        /^<![A-Z]/,
        /^<!\[CDATA\[/,
        /^<[/]?(?:address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[123456]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul)(?:\s|[/]?[>]|$)/i,
        new RegExp("^(?:" + OPENTAG + "|" + CLOSETAG + ")\\s*$", "i")
      ];
      var reHtmlBlockClose = [
        /./,
        /<\/(?:script|pre|textarea|style)>/i,
        /-->/,
        /\?>/,
        />/,
        /\]\]>/
      ];
      var reThematicBreak = /^(?:\*[ \t]*){3,}$|^(?:_[ \t]*){3,}$|^(?:-[ \t]*){3,}$/;
      var reMaybeSpecial = /^[#`~*+_=<>0-9-]/;
      var reNonSpace = /[^ \t\f\v\r\n]/;
      var reBulletListMarker = /^[*+-]/;
      var reOrderedListMarker = /^(\d{1,9})([.)])/;
      var reATXHeadingMarker = /^#{1,6}(?:[ \t]+|$)/;
      var reCodeFence = /^`{3,}(?!.*`)|^~{3,}/;
      var reClosingCodeFence = /^(?:`{3,}|~{3,})(?= *$)/;
      var reSetextHeadingLine = /^(?:=+|-+)[ \t]*$/;
      var reLineEnding = /\r\n|\n|\r/;
      var isBlank = function(s) {
        return !reNonSpace.test(s);
      };
      var isSpaceOrTab = function(c) {
        return c === C_SPACE || c === C_TAB;
      };
      var peek$1 = function(ln, pos) {
        if (pos < ln.length) {
          return ln.charCodeAt(pos);
        } else {
          return -1;
        }
      };
      var endsWithBlankLine = function(block2) {
        while (block2) {
          if (block2._lastLineBlank) {
            return true;
          }
          var t = block2.type;
          if (!block2._lastLineChecked && (t === "list" || t === "item")) {
            block2._lastLineChecked = true;
            block2 = block2._lastChild;
          } else {
            block2._lastLineChecked = true;
            break;
          }
        }
        return false;
      };
      var addLine = function() {
        if (this.partiallyConsumedTab) {
          this.offset += 1;
          var charsToTab = 4 - this.column % 4;
          this.tip._string_content += " ".repeat(charsToTab);
        }
        this.tip._string_content += this.currentLine.slice(this.offset) + "\n";
      };
      var addChild = function(tag2, offset) {
        while (!this.blocks[this.tip.type].canContain(tag2)) {
          this.finalize(this.tip, this.lineNumber - 1);
        }
        var column_number = offset + 1;
        var newBlock = new Node(tag2, [
          [this.lineNumber, column_number],
          [0, 0]
        ]);
        newBlock._string_content = "";
        this.tip.appendChild(newBlock);
        this.tip = newBlock;
        return newBlock;
      };
      var parseListMarker = function(parser, container) {
        var rest = parser.currentLine.slice(parser.nextNonspace);
        var match2;
        var nextc;
        var spacesStartCol;
        var spacesStartOffset;
        var data = {
          type: null,
          tight: true,
          bulletChar: null,
          start: null,
          delimiter: null,
          padding: null,
          markerOffset: parser.indent
        };
        if (parser.indent >= 4) {
          return null;
        }
        if (match2 = rest.match(reBulletListMarker)) {
          data.type = "bullet";
          data.bulletChar = match2[0][0];
        } else if ((match2 = rest.match(reOrderedListMarker)) && (container.type !== "paragraph" || match2[1] == 1)) {
          data.type = "ordered";
          data.start = parseInt(match2[1]);
          data.delimiter = match2[2];
        } else {
          return null;
        }
        nextc = peek$1(parser.currentLine, parser.nextNonspace + match2[0].length);
        if (!(nextc === -1 || nextc === C_TAB || nextc === C_SPACE)) {
          return null;
        }
        if (container.type === "paragraph" && !parser.currentLine.slice(parser.nextNonspace + match2[0].length).match(reNonSpace)) {
          return null;
        }
        parser.advanceNextNonspace();
        parser.advanceOffset(match2[0].length, true);
        spacesStartCol = parser.column;
        spacesStartOffset = parser.offset;
        do {
          parser.advanceOffset(1, true);
          nextc = peek$1(parser.currentLine, parser.offset);
        } while (parser.column - spacesStartCol < 5 && isSpaceOrTab(nextc));
        var blank_item = peek$1(parser.currentLine, parser.offset) === -1;
        var spaces_after_marker = parser.column - spacesStartCol;
        if (spaces_after_marker >= 5 || spaces_after_marker < 1 || blank_item) {
          data.padding = match2[0].length + 1;
          parser.column = spacesStartCol;
          parser.offset = spacesStartOffset;
          if (isSpaceOrTab(peek$1(parser.currentLine, parser.offset))) {
            parser.advanceOffset(1, true);
          }
        } else {
          data.padding = match2[0].length + spaces_after_marker;
        }
        return data;
      };
      var listsMatch = function(list_data, item_data) {
        return list_data.type === item_data.type && list_data.delimiter === item_data.delimiter && list_data.bulletChar === item_data.bulletChar;
      };
      var closeUnmatchedBlocks = function() {
        if (!this.allClosed) {
          while (this.oldtip !== this.lastMatchedContainer) {
            var parent = this.oldtip._parent;
            this.finalize(this.oldtip, this.lineNumber - 1);
            this.oldtip = parent;
          }
          this.allClosed = true;
        }
      };
      var blocks = {
        document: {
          continue: function() {
            return 0;
          },
          finalize: function() {
            return;
          },
          canContain: function(t) {
            return t !== "item";
          },
          acceptsLines: false
        },
        list: {
          continue: function() {
            return 0;
          },
          finalize: function(parser, block2) {
            var item2 = block2._firstChild;
            while (item2) {
              if (endsWithBlankLine(item2) && item2._next) {
                block2._listData.tight = false;
                break;
              }
              var subitem = item2._firstChild;
              while (subitem) {
                if (endsWithBlankLine(subitem) && (item2._next || subitem._next)) {
                  block2._listData.tight = false;
                  break;
                }
                subitem = subitem._next;
              }
              item2 = item2._next;
            }
          },
          canContain: function(t) {
            return t === "item";
          },
          acceptsLines: false
        },
        block_quote: {
          continue: function(parser) {
            var ln = parser.currentLine;
            if (!parser.indented && peek$1(ln, parser.nextNonspace) === C_GREATERTHAN) {
              parser.advanceNextNonspace();
              parser.advanceOffset(1, false);
              if (isSpaceOrTab(peek$1(ln, parser.offset))) {
                parser.advanceOffset(1, true);
              }
            } else {
              return 1;
            }
            return 0;
          },
          finalize: function() {
            return;
          },
          canContain: function(t) {
            return t !== "item";
          },
          acceptsLines: false
        },
        item: {
          continue: function(parser, container) {
            if (parser.blank) {
              if (container._firstChild == null) {
                return 1;
              } else {
                parser.advanceNextNonspace();
              }
            } else if (parser.indent >= container._listData.markerOffset + container._listData.padding) {
              parser.advanceOffset(container._listData.markerOffset + container._listData.padding, true);
            } else {
              return 1;
            }
            return 0;
          },
          finalize: function() {
            return;
          },
          canContain: function(t) {
            return t !== "item";
          },
          acceptsLines: false
        },
        heading: {
          continue: function() {
            return 1;
          },
          finalize: function() {
            return;
          },
          canContain: function() {
            return false;
          },
          acceptsLines: false
        },
        thematic_break: {
          continue: function() {
            return 1;
          },
          finalize: function() {
            return;
          },
          canContain: function() {
            return false;
          },
          acceptsLines: false
        },
        code_block: {
          continue: function(parser, container) {
            var ln = parser.currentLine;
            var indent = parser.indent;
            if (container._isFenced) {
              var match2 = indent <= 3 && ln.charAt(parser.nextNonspace) === container._fenceChar && ln.slice(parser.nextNonspace).match(reClosingCodeFence);
              if (match2 && match2[0].length >= container._fenceLength) {
                parser.lastLineLength = parser.offset + indent + match2[0].length;
                parser.finalize(container, parser.lineNumber);
                return 2;
              } else {
                var i = container._fenceOffset;
                while (i > 0 && isSpaceOrTab(peek$1(ln, parser.offset))) {
                  parser.advanceOffset(1, true);
                  i--;
                }
              }
            } else {
              if (indent >= CODE_INDENT) {
                parser.advanceOffset(CODE_INDENT, true);
              } else if (parser.blank) {
                parser.advanceNextNonspace();
              } else {
                return 1;
              }
            }
            return 0;
          },
          finalize: function(parser, block2) {
            if (block2._isFenced) {
              var content = block2._string_content;
              var newlinePos = content.indexOf("\n");
              var firstLine = content.slice(0, newlinePos);
              var rest = content.slice(newlinePos + 1);
              block2.info = unescapeString(firstLine.trim());
              block2._literal = rest;
            } else {
              block2._literal = block2._string_content.replace(/(\n *)+$/, "\n");
            }
            block2._string_content = null;
          },
          canContain: function() {
            return false;
          },
          acceptsLines: true
        },
        html_block: {
          continue: function(parser, container) {
            return parser.blank && (container._htmlBlockType === 6 || container._htmlBlockType === 7) ? 1 : 0;
          },
          finalize: function(parser, block2) {
            block2._literal = block2._string_content.replace(/(\n *)+$/, "");
            block2._string_content = null;
          },
          canContain: function() {
            return false;
          },
          acceptsLines: true
        },
        paragraph: {
          continue: function(parser) {
            return parser.blank ? 1 : 0;
          },
          finalize: function(parser, block2) {
            var pos;
            var hasReferenceDefs = false;
            while (peek$1(block2._string_content, 0) === C_OPEN_BRACKET$1 && (pos = parser.inlineParser.parseReference(block2._string_content, parser.refmap))) {
              block2._string_content = block2._string_content.slice(pos);
              hasReferenceDefs = true;
            }
            if (hasReferenceDefs && isBlank(block2._string_content)) {
              block2.unlink();
            }
          },
          canContain: function() {
            return false;
          },
          acceptsLines: true
        }
      };
      var blockStarts = [
        function(parser) {
          if (!parser.indented && peek$1(parser.currentLine, parser.nextNonspace) === C_GREATERTHAN) {
            parser.advanceNextNonspace();
            parser.advanceOffset(1, false);
            if (isSpaceOrTab(peek$1(parser.currentLine, parser.offset))) {
              parser.advanceOffset(1, true);
            }
            parser.closeUnmatchedBlocks();
            parser.addChild("block_quote", parser.nextNonspace);
            return 1;
          } else {
            return 0;
          }
        },
        function(parser) {
          var match2;
          if (!parser.indented && (match2 = parser.currentLine.slice(parser.nextNonspace).match(reATXHeadingMarker))) {
            parser.advanceNextNonspace();
            parser.advanceOffset(match2[0].length, false);
            parser.closeUnmatchedBlocks();
            var container = parser.addChild("heading", parser.nextNonspace);
            container.level = match2[0].trim().length;
            container._string_content = parser.currentLine.slice(parser.offset).replace(/^[ \t]*#+[ \t]*$/, "").replace(/[ \t]+#+[ \t]*$/, "");
            parser.advanceOffset(parser.currentLine.length - parser.offset);
            return 2;
          } else {
            return 0;
          }
        },
        function(parser) {
          var match2;
          if (!parser.indented && (match2 = parser.currentLine.slice(parser.nextNonspace).match(reCodeFence))) {
            var fenceLength = match2[0].length;
            parser.closeUnmatchedBlocks();
            var container = parser.addChild("code_block", parser.nextNonspace);
            container._isFenced = true;
            container._fenceLength = fenceLength;
            container._fenceChar = match2[0][0];
            container._fenceOffset = parser.indent;
            parser.advanceNextNonspace();
            parser.advanceOffset(fenceLength, false);
            return 2;
          } else {
            return 0;
          }
        },
        function(parser, container) {
          if (!parser.indented && peek$1(parser.currentLine, parser.nextNonspace) === C_LESSTHAN$1) {
            var s = parser.currentLine.slice(parser.nextNonspace);
            var blockType;
            for (blockType = 1; blockType <= 7; blockType++) {
              if (reHtmlBlockOpen[blockType].test(s) && (blockType < 7 || container.type !== "paragraph" && !(!parser.allClosed && !parser.blank && parser.tip.type === "paragraph"))) {
                parser.closeUnmatchedBlocks();
                var b = parser.addChild("html_block", parser.offset);
                b._htmlBlockType = blockType;
                return 2;
              }
            }
          }
          return 0;
        },
        function(parser, container) {
          var match2;
          if (!parser.indented && container.type === "paragraph" && (match2 = parser.currentLine.slice(parser.nextNonspace).match(reSetextHeadingLine))) {
            parser.closeUnmatchedBlocks();
            var pos;
            while (peek$1(container._string_content, 0) === C_OPEN_BRACKET$1 && (pos = parser.inlineParser.parseReference(container._string_content, parser.refmap))) {
              container._string_content = container._string_content.slice(pos);
            }
            if (container._string_content.length > 0) {
              var heading2 = new Node("heading", container.sourcepos);
              heading2.level = match2[0][0] === "=" ? 1 : 2;
              heading2._string_content = container._string_content;
              container.insertAfter(heading2);
              container.unlink();
              parser.tip = heading2;
              parser.advanceOffset(parser.currentLine.length - parser.offset, false);
              return 2;
            } else {
              return 0;
            }
          } else {
            return 0;
          }
        },
        function(parser) {
          if (!parser.indented && reThematicBreak.test(parser.currentLine.slice(parser.nextNonspace))) {
            parser.closeUnmatchedBlocks();
            parser.addChild("thematic_break", parser.nextNonspace);
            parser.advanceOffset(parser.currentLine.length - parser.offset, false);
            return 2;
          } else {
            return 0;
          }
        },
        function(parser, container) {
          var data;
          if ((!parser.indented || container.type === "list") && (data = parseListMarker(parser, container))) {
            parser.closeUnmatchedBlocks();
            if (parser.tip.type !== "list" || !listsMatch(container._listData, data)) {
              container = parser.addChild("list", parser.nextNonspace);
              container._listData = data;
            }
            container = parser.addChild("item", parser.nextNonspace);
            container._listData = data;
            return 1;
          } else {
            return 0;
          }
        },
        function(parser) {
          if (parser.indented && parser.tip.type !== "paragraph" && !parser.blank) {
            parser.advanceOffset(CODE_INDENT, true);
            parser.closeUnmatchedBlocks();
            parser.addChild("code_block", parser.offset);
            return 2;
          } else {
            return 0;
          }
        }
      ];
      var advanceOffset = function(count, columns) {
        var currentLine = this.currentLine;
        var charsToTab, charsToAdvance;
        var c;
        while (count > 0 && (c = currentLine[this.offset])) {
          if (c === "	") {
            charsToTab = 4 - this.column % 4;
            if (columns) {
              this.partiallyConsumedTab = charsToTab > count;
              charsToAdvance = charsToTab > count ? count : charsToTab;
              this.column += charsToAdvance;
              this.offset += this.partiallyConsumedTab ? 0 : 1;
              count -= charsToAdvance;
            } else {
              this.partiallyConsumedTab = false;
              this.column += charsToTab;
              this.offset += 1;
              count -= 1;
            }
          } else {
            this.partiallyConsumedTab = false;
            this.offset += 1;
            this.column += 1;
            count -= 1;
          }
        }
      };
      var advanceNextNonspace = function() {
        this.offset = this.nextNonspace;
        this.column = this.nextNonspaceColumn;
        this.partiallyConsumedTab = false;
      };
      var findNextNonspace = function() {
        var currentLine = this.currentLine;
        var i = this.offset;
        var cols = this.column;
        var c;
        while ((c = currentLine.charAt(i)) !== "") {
          if (c === " ") {
            i++;
            cols++;
          } else if (c === "	") {
            i++;
            cols += 4 - cols % 4;
          } else {
            break;
          }
        }
        this.blank = c === "\n" || c === "\r" || c === "";
        this.nextNonspace = i;
        this.nextNonspaceColumn = cols;
        this.indent = this.nextNonspaceColumn - this.column;
        this.indented = this.indent >= CODE_INDENT;
      };
      var incorporateLine = function(ln) {
        var all_matched = true;
        var t;
        var container = this.doc;
        this.oldtip = this.tip;
        this.offset = 0;
        this.column = 0;
        this.blank = false;
        this.partiallyConsumedTab = false;
        this.lineNumber += 1;
        if (ln.indexOf("\0") !== -1) {
          ln = ln.replace(/\0/g, "\uFFFD");
        }
        this.currentLine = ln;
        var lastChild;
        while ((lastChild = container._lastChild) && lastChild._open) {
          container = lastChild;
          this.findNextNonspace();
          switch (this.blocks[container.type].continue(this, container)) {
            case 0:
              break;
            case 1:
              all_matched = false;
              break;
            case 2:
              return;
            default:
              throw "continue returned illegal value, must be 0, 1, or 2";
          }
          if (!all_matched) {
            container = container._parent;
            break;
          }
        }
        this.allClosed = container === this.oldtip;
        this.lastMatchedContainer = container;
        var matchedLeaf = container.type !== "paragraph" && blocks[container.type].acceptsLines;
        var starts = this.blockStarts;
        var startsLen = starts.length;
        while (!matchedLeaf) {
          this.findNextNonspace();
          if (!this.indented && !reMaybeSpecial.test(ln.slice(this.nextNonspace))) {
            this.advanceNextNonspace();
            break;
          }
          var i = 0;
          while (i < startsLen) {
            var res = starts[i](this, container);
            if (res === 1) {
              container = this.tip;
              break;
            } else if (res === 2) {
              container = this.tip;
              matchedLeaf = true;
              break;
            } else {
              i++;
            }
          }
          if (i === startsLen) {
            this.advanceNextNonspace();
            break;
          }
        }
        if (!this.allClosed && !this.blank && this.tip.type === "paragraph") {
          this.addLine();
        } else {
          this.closeUnmatchedBlocks();
          if (this.blank && container.lastChild) {
            container.lastChild._lastLineBlank = true;
          }
          t = container.type;
          var lastLineBlank = this.blank && !(t === "block_quote" || t === "code_block" && container._isFenced || t === "item" && !container._firstChild && container.sourcepos[0][0] === this.lineNumber);
          var cont = container;
          while (cont) {
            cont._lastLineBlank = lastLineBlank;
            cont = cont._parent;
          }
          if (this.blocks[t].acceptsLines) {
            this.addLine();
            if (t === "html_block" && container._htmlBlockType >= 1 && container._htmlBlockType <= 5 && reHtmlBlockClose[container._htmlBlockType].test(this.currentLine.slice(this.offset))) {
              this.lastLineLength = ln.length;
              this.finalize(container, this.lineNumber);
            }
          } else if (this.offset < ln.length && !this.blank) {
            container = this.addChild("paragraph", this.offset);
            this.advanceNextNonspace();
            this.addLine();
          }
        }
        this.lastLineLength = ln.length;
      };
      var finalize = function(block2, lineNumber) {
        var above = block2._parent;
        block2._open = false;
        block2.sourcepos[1] = [lineNumber, this.lastLineLength];
        this.blocks[block2.type].finalize(this, block2);
        this.tip = above;
      };
      var processInlines = function(block2) {
        var node, event, t;
        var walker = block2.walker();
        this.inlineParser.refmap = this.refmap;
        this.inlineParser.options = this.options;
        while (event = walker.next()) {
          node = event.node;
          t = node.type;
          if (!event.entering && (t === "paragraph" || t === "heading")) {
            this.inlineParser.parse(node);
          }
        }
      };
      var Document = function() {
        var doc = new Node("document", [
          [1, 1],
          [0, 0]
        ]);
        return doc;
      };
      var parse = function(input) {
        this.doc = new Document();
        this.tip = this.doc;
        this.refmap = {};
        this.lineNumber = 0;
        this.lastLineLength = 0;
        this.offset = 0;
        this.column = 0;
        this.lastMatchedContainer = this.doc;
        this.currentLine = "";
        if (this.options.time) {
          console.time("preparing input");
        }
        var lines = input.split(reLineEnding);
        var len = lines.length;
        if (input.charCodeAt(input.length - 1) === C_NEWLINE$1) {
          len -= 1;
        }
        if (this.options.time) {
          console.timeEnd("preparing input");
        }
        if (this.options.time) {
          console.time("block parsing");
        }
        for (var i = 0; i < len; i++) {
          this.incorporateLine(lines[i]);
        }
        while (this.tip) {
          this.finalize(this.tip, len);
        }
        if (this.options.time) {
          console.timeEnd("block parsing");
        }
        if (this.options.time) {
          console.time("inline parsing");
        }
        this.processInlines(this.doc);
        if (this.options.time) {
          console.timeEnd("inline parsing");
        }
        return this.doc;
      };
      function Parser(options) {
        return {
          doc: new Document(),
          blocks,
          blockStarts,
          tip: this.doc,
          oldtip: this.doc,
          currentLine: "",
          lineNumber: 0,
          offset: 0,
          column: 0,
          nextNonspace: 0,
          nextNonspaceColumn: 0,
          indent: 0,
          indented: false,
          blank: false,
          partiallyConsumedTab: false,
          allClosed: true,
          lastMatchedContainer: this.doc,
          refmap: {},
          lastLineLength: 0,
          inlineParser: new InlineParser(options),
          findNextNonspace,
          advanceOffset,
          advanceNextNonspace,
          addLine,
          addChild,
          incorporateLine,
          finalize,
          processInlines,
          closeUnmatchedBlocks,
          parse,
          options: options || {}
        };
      }
      function Renderer() {
      }
      function render(ast2) {
        var walker = ast2.walker(), event, type;
        this.buffer = "";
        this.lastOut = "\n";
        while (event = walker.next()) {
          type = event.node.type;
          if (this[type]) {
            this[type](event.node, event.entering);
          }
        }
        return this.buffer;
      }
      function lit(str) {
        this.buffer += str;
        this.lastOut = str;
      }
      function cr() {
        if (this.lastOut !== "\n") {
          this.lit("\n");
        }
      }
      function out(str) {
        this.lit(str);
      }
      function esc(str) {
        return str;
      }
      Renderer.prototype.render = render;
      Renderer.prototype.out = out;
      Renderer.prototype.lit = lit;
      Renderer.prototype.cr = cr;
      Renderer.prototype.esc = esc;
      var reUnsafeProtocol = /^javascript:|vbscript:|file:|data:/i;
      var reSafeDataProtocol = /^data:image\/(?:png|gif|jpeg|webp)/i;
      var potentiallyUnsafe = function(url) {
        return reUnsafeProtocol.test(url) && !reSafeDataProtocol.test(url);
      };
      function tag(name, attrs2, selfclosing) {
        if (this.disableTags > 0) {
          return;
        }
        this.buffer += "<" + name;
        if (attrs2 && attrs2.length > 0) {
          var i = 0;
          var attrib;
          while ((attrib = attrs2[i]) !== void 0) {
            this.buffer += " " + attrib[0] + '="' + attrib[1] + '"';
            i++;
          }
        }
        if (selfclosing) {
          this.buffer += " /";
        }
        this.buffer += ">";
        this.lastOut = ">";
      }
      function HtmlRenderer(options) {
        options = options || {};
        options.softbreak = options.softbreak || "\n";
        this.esc = options.esc || escapeXml;
        this.disableTags = 0;
        this.lastOut = "\n";
        this.options = options;
      }
      function text$1(node) {
        this.out(node.literal);
      }
      function softbreak() {
        this.lit(this.options.softbreak);
      }
      function linebreak() {
        this.tag("br", [], true);
        this.cr();
      }
      function link(node, entering) {
        var attrs2 = this.attrs(node);
        if (entering) {
          if (!(this.options.safe && potentiallyUnsafe(node.destination))) {
            attrs2.push(["href", this.esc(node.destination)]);
          }
          if (node.title) {
            attrs2.push(["title", this.esc(node.title)]);
          }
          this.tag("a", attrs2);
        } else {
          this.tag("/a");
        }
      }
      function image$1(node, entering) {
        if (entering) {
          if (this.disableTags === 0) {
            if (this.options.safe && potentiallyUnsafe(node.destination)) {
              this.lit('<img src="" alt="');
            } else {
              this.lit('<img src="' + this.esc(node.destination) + '" alt="');
            }
          }
          this.disableTags += 1;
        } else {
          this.disableTags -= 1;
          if (this.disableTags === 0) {
            if (node.title) {
              this.lit('" title="' + this.esc(node.title));
            }
            this.lit('" />');
          }
        }
      }
      function emph(node, entering) {
        this.tag(entering ? "em" : "/em");
      }
      function strong(node, entering) {
        this.tag(entering ? "strong" : "/strong");
      }
      function paragraph(node, entering) {
        var grandparent = node.parent.parent, attrs2 = this.attrs(node);
        if (grandparent !== null && grandparent.type === "list") {
          if (grandparent.listTight) {
            return;
          }
        }
        if (entering) {
          this.cr();
          this.tag("p", attrs2);
        } else {
          this.tag("/p");
          this.cr();
        }
      }
      function heading(node, entering) {
        var tagname = "h" + node.level, attrs2 = this.attrs(node);
        if (entering) {
          this.cr();
          this.tag(tagname, attrs2);
        } else {
          this.tag("/" + tagname);
          this.cr();
        }
      }
      function code(node) {
        this.tag("code");
        this.out(node.literal);
        this.tag("/code");
      }
      function code_block(node) {
        var info_words = node.info ? node.info.split(/\s+/) : [], attrs2 = this.attrs(node);
        if (info_words.length > 0 && info_words[0].length > 0) {
          attrs2.push(["class", "language-" + this.esc(info_words[0])]);
        }
        this.cr();
        this.tag("pre");
        this.tag("code", attrs2);
        this.out(node.literal);
        this.tag("/code");
        this.tag("/pre");
        this.cr();
      }
      function thematic_break(node) {
        var attrs2 = this.attrs(node);
        this.cr();
        this.tag("hr", attrs2, true);
        this.cr();
      }
      function block_quote(node, entering) {
        var attrs2 = this.attrs(node);
        if (entering) {
          this.cr();
          this.tag("blockquote", attrs2);
          this.cr();
        } else {
          this.cr();
          this.tag("/blockquote");
          this.cr();
        }
      }
      function list(node, entering) {
        var tagname = node.listType === "bullet" ? "ul" : "ol", attrs2 = this.attrs(node);
        if (entering) {
          var start = node.listStart;
          if (start !== null && start !== 1) {
            attrs2.push(["start", start.toString()]);
          }
          this.cr();
          this.tag(tagname, attrs2);
          this.cr();
        } else {
          this.cr();
          this.tag("/" + tagname);
          this.cr();
        }
      }
      function item(node, entering) {
        var attrs2 = this.attrs(node);
        if (entering) {
          this.tag("li", attrs2);
        } else {
          this.tag("/li");
          this.cr();
        }
      }
      function html_inline(node) {
        if (this.options.safe) {
          this.lit("<!-- raw HTML omitted -->");
        } else {
          this.lit(node.literal);
        }
      }
      function html_block(node) {
        this.cr();
        if (this.options.safe) {
          this.lit("<!-- raw HTML omitted -->");
        } else {
          this.lit(node.literal);
        }
        this.cr();
      }
      function custom_inline(node, entering) {
        if (entering && node.onEnter) {
          this.lit(node.onEnter);
        } else if (!entering && node.onExit) {
          this.lit(node.onExit);
        }
      }
      function custom_block(node, entering) {
        this.cr();
        if (entering && node.onEnter) {
          this.lit(node.onEnter);
        } else if (!entering && node.onExit) {
          this.lit(node.onExit);
        }
        this.cr();
      }
      function out$1(s) {
        this.lit(this.esc(s));
      }
      function attrs(node) {
        var att = [];
        if (this.options.sourcepos) {
          var pos = node.sourcepos;
          if (pos) {
            att.push([
              "data-sourcepos",
              String(pos[0][0]) + ":" + String(pos[0][1]) + "-" + String(pos[1][0]) + ":" + String(pos[1][1])
            ]);
          }
        }
        return att;
      }
      HtmlRenderer.prototype = Object.create(Renderer.prototype);
      HtmlRenderer.prototype.text = text$1;
      HtmlRenderer.prototype.html_inline = html_inline;
      HtmlRenderer.prototype.html_block = html_block;
      HtmlRenderer.prototype.softbreak = softbreak;
      HtmlRenderer.prototype.linebreak = linebreak;
      HtmlRenderer.prototype.link = link;
      HtmlRenderer.prototype.image = image$1;
      HtmlRenderer.prototype.emph = emph;
      HtmlRenderer.prototype.strong = strong;
      HtmlRenderer.prototype.paragraph = paragraph;
      HtmlRenderer.prototype.heading = heading;
      HtmlRenderer.prototype.code = code;
      HtmlRenderer.prototype.code_block = code_block;
      HtmlRenderer.prototype.thematic_break = thematic_break;
      HtmlRenderer.prototype.block_quote = block_quote;
      HtmlRenderer.prototype.list = list;
      HtmlRenderer.prototype.item = item;
      HtmlRenderer.prototype.custom_inline = custom_inline;
      HtmlRenderer.prototype.custom_block = custom_block;
      HtmlRenderer.prototype.esc = escapeXml;
      HtmlRenderer.prototype.out = out$1;
      HtmlRenderer.prototype.tag = tag;
      HtmlRenderer.prototype.attrs = attrs;
      var reXMLTag = /\<[^>]*\>/;
      function toTagName(s) {
        return s.replace(/([a-z])([A-Z])/g, "$1_$2").toLowerCase();
      }
      function XmlRenderer(options) {
        options = options || {};
        this.disableTags = 0;
        this.lastOut = "\n";
        this.indentLevel = 0;
        this.indent = "  ";
        this.esc = options.esc || escapeXml;
        this.options = options;
      }
      function render$1(ast2) {
        this.buffer = "";
        var attrs2;
        var tagname;
        var walker = ast2.walker();
        var event, node, entering;
        var container;
        var selfClosing;
        var nodetype;
        var options = this.options;
        if (options.time) {
          console.time("rendering");
        }
        this.buffer += '<?xml version="1.0" encoding="UTF-8"?>\n';
        this.buffer += '<!DOCTYPE document SYSTEM "CommonMark.dtd">\n';
        while (event = walker.next()) {
          entering = event.entering;
          node = event.node;
          nodetype = node.type;
          container = node.isContainer;
          selfClosing = nodetype === "thematic_break" || nodetype === "linebreak" || nodetype === "softbreak";
          tagname = toTagName(nodetype);
          if (entering) {
            attrs2 = [];
            switch (nodetype) {
              case "document":
                attrs2.push(["xmlns", "http://commonmark.org/xml/1.0"]);
                break;
              case "list":
                if (node.listType !== null) {
                  attrs2.push(["type", node.listType.toLowerCase()]);
                }
                if (node.listStart !== null) {
                  attrs2.push(["start", String(node.listStart)]);
                }
                if (node.listTight !== null) {
                  attrs2.push([
                    "tight",
                    node.listTight ? "true" : "false"
                  ]);
                }
                var delim = node.listDelimiter;
                if (delim !== null) {
                  var delimword = "";
                  if (delim === ".") {
                    delimword = "period";
                  } else {
                    delimword = "paren";
                  }
                  attrs2.push(["delimiter", delimword]);
                }
                break;
              case "code_block":
                if (node.info) {
                  attrs2.push(["info", node.info]);
                }
                break;
              case "heading":
                attrs2.push(["level", String(node.level)]);
                break;
              case "link":
              case "image":
                attrs2.push(["destination", node.destination]);
                attrs2.push(["title", node.title]);
                break;
              case "custom_inline":
              case "custom_block":
                attrs2.push(["on_enter", node.onEnter]);
                attrs2.push(["on_exit", node.onExit]);
                break;
            }
            if (options.sourcepos) {
              var pos = node.sourcepos;
              if (pos) {
                attrs2.push([
                  "sourcepos",
                  String(pos[0][0]) + ":" + String(pos[0][1]) + "-" + String(pos[1][0]) + ":" + String(pos[1][1])
                ]);
              }
            }
            this.cr();
            this.out(this.tag(tagname, attrs2, selfClosing));
            if (container) {
              this.indentLevel += 1;
            } else if (!container && !selfClosing) {
              var lit2 = node.literal;
              if (lit2) {
                this.out(this.esc(lit2));
              }
              this.out(this.tag("/" + tagname));
            }
          } else {
            this.indentLevel -= 1;
            this.cr();
            this.out(this.tag("/" + tagname));
          }
        }
        if (options.time) {
          console.timeEnd("rendering");
        }
        this.buffer += "\n";
        return this.buffer;
      }
      function out$2(s) {
        if (this.disableTags > 0) {
          this.buffer += s.replace(reXMLTag, "");
        } else {
          this.buffer += s;
        }
        this.lastOut = s;
      }
      function cr$1() {
        if (this.lastOut !== "\n") {
          this.buffer += "\n";
          this.lastOut = "\n";
          for (var i = this.indentLevel; i > 0; i--) {
            this.buffer += this.indent;
          }
        }
      }
      function tag$1(name, attrs2, selfclosing) {
        var result = "<" + name;
        if (attrs2 && attrs2.length > 0) {
          var i = 0;
          var attrib;
          while ((attrib = attrs2[i]) !== void 0) {
            result += " " + attrib[0] + '="' + this.esc(attrib[1]) + '"';
            i++;
          }
        }
        if (selfclosing) {
          result += " /";
        }
        result += ">";
        return result;
      }
      XmlRenderer.prototype = Object.create(Renderer.prototype);
      XmlRenderer.prototype.render = render$1;
      XmlRenderer.prototype.out = out$2;
      XmlRenderer.prototype.cr = cr$1;
      XmlRenderer.prototype.tag = tag$1;
      XmlRenderer.prototype.esc = escapeXml;
      exports2.HtmlRenderer = HtmlRenderer;
      exports2.Node = Node;
      exports2.Parser = Parser;
      exports2.Renderer = Renderer;
      exports2.XmlRenderer = XmlRenderer;
      Object.defineProperty(exports2, "__esModule", { value: true });
    });
  }
});

// node_modules/jsii-rosetta/lib/markdown/markdown.js
var require_markdown = __commonJS({
  "node_modules/jsii-rosetta/lib/markdown/markdown.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.cmNodeChildren = exports.prefixLines = exports.visitCommonMarkTree = exports.renderCommonMarkTree = exports.transformMarkdown = void 0;
    var cm = require_commonmark();
    function transformMarkdown(source, renderer, transform) {
      const parser = new cm.Parser();
      const doc = parser.parse(source);
      if (transform) {
        visitCommonMarkTree(doc, transform);
      }
      return renderCommonMarkTree(doc, renderer);
    }
    exports.transformMarkdown = transformMarkdown;
    function renderCommonMarkTree(node, renderer) {
      const context = {
        recurse(n) {
          return renderCommonMarkTree(n, renderer);
        },
        content() {
          return this.children().join("");
        },
        children() {
          const parts = [];
          for (const child of cmNodeChildren(node)) {
            parts.push(renderCommonMarkTree(child, renderer));
          }
          return parts;
        }
      };
      return renderer[node.type](node, context);
    }
    exports.renderCommonMarkTree = renderCommonMarkTree;
    function visitCommonMarkTree(node, visitor) {
      visitor[node.type](node);
      for (const child of cmNodeChildren(node)) {
        visitCommonMarkTree(child, visitor);
      }
    }
    exports.visitCommonMarkTree = visitCommonMarkTree;
    function prefixLines(prefix, x) {
      return x.split("\n").map((l) => prefix + l).join("\n");
    }
    exports.prefixLines = prefixLines;
    function* cmNodeChildren(node) {
      for (let child = node.firstChild; child !== null; child = child.next) {
        yield child;
      }
    }
    exports.cmNodeChildren = cmNodeChildren;
  }
});

// node_modules/jsii-rosetta/lib/markdown/replace-code-renderer.js
var require_replace_code_renderer = __commonJS({
  "node_modules/jsii-rosetta/lib/markdown/replace-code-renderer.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.ReplaceCodeTransform = void 0;
    var ReplaceCodeTransform = class {
      constructor(replacer) {
        this.replacer = replacer;
      }
      code_block(node) {
        var _a, _b;
        const ret = this.replacer({
          language: (_a = node.info) !== null && _a !== void 0 ? _a : "",
          source: (_b = node.literal) !== null && _b !== void 0 ? _b : ""
        });
        node.info = ret.language;
        node.literal = ret.source + (!ret.source || ret.source.endsWith("\n") ? "" : "\n");
      }
      block_quote() {
      }
      code() {
      }
      text() {
      }
      softbreak() {
      }
      linebreak() {
      }
      emph() {
      }
      strong() {
      }
      html_inline() {
      }
      html_block() {
      }
      link() {
      }
      image() {
      }
      document() {
      }
      paragraph() {
      }
      list() {
      }
      item() {
      }
      heading() {
      }
      thematic_break() {
      }
      custom_block() {
      }
      custom_inline() {
      }
    };
    exports.ReplaceCodeTransform = ReplaceCodeTransform;
  }
});

// node_modules/jsii-rosetta/lib/markdown/replace-typescript-transform.js
var require_replace_typescript_transform = __commonJS({
  "node_modules/jsii-rosetta/lib/markdown/replace-typescript-transform.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.ReplaceTypeScriptTransform = void 0;
    var snippet_1 = require_snippet();
    var replace_code_renderer_1 = require_replace_code_renderer();
    var ReplaceTypeScriptTransform = class extends replace_code_renderer_1.ReplaceCodeTransform {
      constructor(wherePrefix, strict, replacer) {
        let count = 0;
        super((block) => {
          var _a;
          const languageParts = block.language ? block.language.split(" ") : [];
          if (languageParts[0] !== "typescript" && languageParts[0] !== "ts") {
            return block;
          }
          count += 1;
          const tsSnippet = snippet_1.typeScriptSnippetFromSource(block.source, this.addSnippetNumber(count), strict, snippet_1.parseKeyValueList(languageParts.slice(1)));
          return (_a = replacer(tsSnippet)) !== null && _a !== void 0 ? _a : block;
        });
        this.wherePrefix = wherePrefix;
      }
      addSnippetNumber(snippetNumber) {
        if (snippetNumber === 1) {
          return this.wherePrefix;
        }
        return `${this.wherePrefix}-snippet${snippetNumber}`;
      }
    };
    exports.ReplaceTypeScriptTransform = ReplaceTypeScriptTransform;
  }
});

// node_modules/jsii-rosetta/lib/markdown/extract-snippets.js
var require_extract_snippets = __commonJS({
  "node_modules/jsii-rosetta/lib/markdown/extract-snippets.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.extractTypescriptSnippetsFromMarkdown = void 0;
    var cm = require_commonmark();
    var markdown_1 = require_markdown();
    var replace_typescript_transform_1 = require_replace_typescript_transform();
    function extractTypescriptSnippetsFromMarkdown(markdown, wherePrefix, strict) {
      const parser = new cm.Parser();
      const doc = parser.parse(markdown);
      const ret = [];
      markdown_1.visitCommonMarkTree(doc, new replace_typescript_transform_1.ReplaceTypeScriptTransform(wherePrefix, strict, (ts) => {
        ret.push(ts);
        return void 0;
      }));
      return ret;
    }
    exports.extractTypescriptSnippetsFromMarkdown = extractTypescriptSnippetsFromMarkdown;
  }
});

// node_modules/jsii-rosetta/lib/strict.js
var require_strict = __commonJS({
  "node_modules/jsii-rosetta/lib/strict.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.enforcesStrictMode = void 0;
    function enforcesStrictMode(assembly) {
      var _a, _b, _c;
      return !!((_c = (_b = (_a = assembly.metadata) === null || _a === void 0 ? void 0 : _a.jsii) === null || _b === void 0 ? void 0 : _b.rosetta) === null || _c === void 0 ? void 0 : _c.strict);
    }
    exports.enforcesStrictMode = enforcesStrictMode;
  }
});

// node_modules/jsii-rosetta/lib/jsii/assemblies.js
var require_assemblies = __commonJS({
  "node_modules/jsii-rosetta/lib/jsii/assemblies.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.allTypeScriptSnippets = exports.allSnippetSources = exports.loadAssemblies = void 0;
    var spec = require_lib5();
    var fs2 = require_lib8();
    var path2 = require("path");
    var fixtures_1 = require_fixtures();
    var extract_snippets_1 = require_extract_snippets();
    var snippet_1 = require_snippet();
    var strict_1 = require_strict();
    async function loadAssemblies(assemblyLocations, validateAssemblies) {
      return Promise.all(assemblyLocations.map(loadAssembly));
      async function loadAssembly(location) {
        const stat = await fs2.stat(location);
        if (stat.isDirectory()) {
          return loadAssembly(path2.join(location, ".jsii"));
        }
        return {
          assembly: await loadAssemblyFromFile(location, validateAssemblies),
          directory: path2.dirname(location)
        };
      }
    }
    exports.loadAssemblies = loadAssemblies;
    async function loadAssemblyFromFile(filename, validate) {
      const contents = await fs2.readJSON(filename, { encoding: "utf-8" });
      return validate ? spec.validateAssembly(contents) : contents;
    }
    function allSnippetSources(assembly) {
      var _a;
      const ret = [];
      if (assembly.readme) {
        ret.push({
          type: "markdown",
          markdown: assembly.readme.markdown,
          where: removeSlashes(`${assembly.name}-README`)
        });
      }
      for (const [submoduleFqn, submodule] of Object.entries((_a = assembly.submodules) !== null && _a !== void 0 ? _a : {})) {
        if (submodule.readme) {
          ret.push({
            type: "markdown",
            markdown: submodule.readme.markdown,
            where: removeSlashes(`${submoduleFqn}-README`)
          });
        }
      }
      if (assembly.types) {
        Object.values(assembly.types).forEach((type) => {
          var _a2, _b;
          emitDocs(type.docs, `${assembly.name}.${type.name}`);
          if (spec.isEnumType(type)) {
            type.members.forEach((m) => emitDocs(m.docs, `${assembly.name}.${type.name}.${m.name}`));
          }
          if (spec.isClassOrInterfaceType(type)) {
            ((_a2 = type.methods) !== null && _a2 !== void 0 ? _a2 : []).forEach((m) => emitDocs(m.docs, `${assembly.name}.${type.name}#${m.name}`));
            ((_b = type.properties) !== null && _b !== void 0 ? _b : []).forEach((m) => emitDocs(m.docs, `${assembly.name}.${type.name}#${m.name}`));
          }
        });
      }
      return ret;
      function emitDocs(docs, where) {
        if (!docs) {
          return;
        }
        if (docs.remarks) {
          ret.push({
            type: "markdown",
            markdown: docs.remarks,
            where: removeSlashes(where)
          });
        }
        if (docs.example && exampleLooksLikeSource(docs.example)) {
          ret.push({
            type: "literal",
            source: docs.example,
            where: removeSlashes(`${where}-example`)
          });
        }
      }
    }
    exports.allSnippetSources = allSnippetSources;
    function removeSlashes(x) {
      return x.replace(/\//g, ".");
    }
    function* allTypeScriptSnippets(assemblies, loose = false) {
      for (const { assembly, directory } of assemblies) {
        const strict = strict_1.enforcesStrictMode(assembly);
        for (const source of allSnippetSources(assembly)) {
          switch (source.type) {
            case "literal":
              const snippet = snippet_1.updateParameters(snippet_1.typeScriptSnippetFromSource(source.source, source.where, strict), {
                [snippet_1.SnippetParameters.$PROJECT_DIRECTORY]: directory
              });
              yield fixtures_1.fixturize(snippet, loose);
              break;
            case "markdown":
              for (const snippet2 of extract_snippets_1.extractTypescriptSnippetsFromMarkdown(source.markdown, source.where, strict)) {
                const withDirectory = snippet_1.updateParameters(snippet2, {
                  [snippet_1.SnippetParameters.$PROJECT_DIRECTORY]: directory
                });
                yield fixtures_1.fixturize(withDirectory, loose);
              }
          }
        }
      }
    }
    exports.allTypeScriptSnippets = allTypeScriptSnippets;
    function exampleLooksLikeSource(text) {
      return !!WHITESPACE.exec(text.trim());
    }
    var WHITESPACE = new RegExp("\\s");
  }
});

// node_modules/jsii-rosetta/lib/markdown/markdown-renderer.js
var require_markdown_renderer = __commonJS({
  "node_modules/jsii-rosetta/lib/markdown/markdown-renderer.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.stripTrailingWhitespace = exports.stripPara = exports.collapsePara = exports.para = exports.MarkdownRenderer = void 0;
    var markdown_1 = require_markdown();
    var MarkdownRenderer = class {
      block_quote(_node, context) {
        return para(markdown_1.prefixLines("> ", collapsePara(context.content())));
      }
      code(node, _context) {
        return `\`${node.literal}\``;
      }
      code_block(node, _context) {
        var _a;
        return para(`\`\`\`${(_a = node.info) !== null && _a !== void 0 ? _a : ""}
${node.literal}\`\`\``);
      }
      text(node, _context) {
        var _a;
        return (_a = node.literal) !== null && _a !== void 0 ? _a : "";
      }
      softbreak(_node, _context) {
        return "\n";
      }
      linebreak(_node, _context) {
        return "\\\n";
      }
      emph(_node, context) {
        return `*${context.content()}*`;
      }
      strong(_node, context) {
        return `**${context.content()}**`;
      }
      html_inline(node, _context) {
        var _a;
        return (_a = node.literal) !== null && _a !== void 0 ? _a : "";
      }
      html_block(node, _context) {
        var _a;
        return (_a = node.literal) !== null && _a !== void 0 ? _a : "";
      }
      link(node, context) {
        var _a;
        return `[${context.content()}](${(_a = node.destination) !== null && _a !== void 0 ? _a : ""})`;
      }
      image(node, context) {
        var _a;
        return `![${context.content()}](${(_a = node.destination) !== null && _a !== void 0 ? _a : ""})`;
      }
      document(_node, context) {
        return stripTrailingWhitespace(collapsePara(context.content()));
      }
      paragraph(_node, context) {
        return para(context.content());
      }
      list(node, context) {
        const items = [];
        let i = 1;
        for (const item of markdown_1.cmNodeChildren(node)) {
          const firstLinePrefix = determineItemPrefix(node, i);
          const hangingPrefix = " ".repeat(firstLinePrefix.length);
          const rendered = context.recurse(item);
          const prefixed = firstLinePrefix + markdown_1.prefixLines(hangingPrefix, rendered).substr(hangingPrefix.length);
          items.push(prefixed);
          i += 1;
        }
        return para(items.join("\n"));
      }
      item(_node, context) {
        return collapsePara(context.content());
      }
      heading(node, context) {
        return para(`${"#".repeat(node.level)} ${context.content()}`);
      }
      thematic_break(_node, _context) {
        return "---\n";
      }
      custom_block(_node, context) {
        return `<custom>${context.content()}</custom>`;
      }
      custom_inline(_node, context) {
        return `<custom>${context.content()}</custom>`;
      }
    };
    exports.MarkdownRenderer = MarkdownRenderer;
    var PARA_BREAK = "";
    function para(x) {
      return `${PARA_BREAK}${x}${PARA_BREAK}`;
    }
    exports.para = para;
    function collapsePara(x, brk = "\n\n") {
      return x.replace(/^\u001d+/, "").replace(/\u001d+$/, "").replace(/\u001d+/g, brk);
    }
    exports.collapsePara = collapsePara;
    function stripPara(x) {
      return x.replace(/^\u001d+/, "").replace(/\u001d+$/, "");
    }
    exports.stripPara = stripPara;
    function determineItemPrefix(listNode, index) {
      if (listNode.listType === "bullet") {
        return "* ";
      }
      return `${index}${listNode.listDelimiter} `;
    }
    function stripTrailingWhitespace(x) {
      return x.replace(/[ \t]+$/gm, "");
    }
    exports.stripTrailingWhitespace = stripTrailingWhitespace;
  }
});

// node_modules/jsii-rosetta/lib/rosetta.js
var require_rosetta = __commonJS({
  "node_modules/jsii-rosetta/lib/rosetta.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Rosetta = void 0;
    var fs2 = require_lib8();
    var path2 = require("path");
    var util_1 = require("util");
    var assemblies_1 = require_assemblies();
    var markdown_1 = require_markdown();
    var markdown_renderer_1 = require_markdown_renderer();
    var replace_typescript_transform_1 = require_replace_typescript_transform();
    var snippet_1 = require_snippet();
    var tablets_1 = require_tablets();
    var translate_1 = require_translate();
    var util_2 = require_util3();
    var Rosetta = class {
      constructor(options = {}) {
        var _a;
        this.options = options;
        this.loadedTablets = [];
        this.liveTablet = new tablets_1.LanguageTablet();
        this.extractedSnippets = new Map();
        this.loose = !!options.loose;
        this.translator = new translate_1.Translator((_a = options.includeCompilerDiagnostics) !== null && _a !== void 0 ? _a : false);
      }
      get diagnostics() {
        return this.translator.diagnostics;
      }
      async loadTabletFromFile(tabletFile) {
        const tablet = new tablets_1.LanguageTablet();
        await tablet.load(tabletFile);
        this.addTablet(tablet);
      }
      addTablet(tablet) {
        this.loadedTablets.push(tablet);
      }
      async addAssembly(assembly, assemblyDir) {
        if (await fs2.pathExists(path2.join(assemblyDir, tablets_1.DEFAULT_TABLET_NAME))) {
          await this.loadTabletFromFile(path2.join(assemblyDir, tablets_1.DEFAULT_TABLET_NAME));
          return;
        }
        if (this.options.liveConversion) {
          for (const tsnip of assemblies_1.allTypeScriptSnippets([{ assembly, directory: assemblyDir }], this.loose)) {
            this.extractedSnippets.set(tsnip.visibleSource, tsnip);
          }
        }
      }
      translateSnippet(source, targetLang) {
        for (const tab of this.allTablets) {
          const ret = tab.lookup(source, targetLang);
          if (ret !== void 0) {
            return ret;
          }
        }
        if (!this.options.liveConversion) {
          return void 0;
        }
        if (this.options.targetLanguages && !this.options.targetLanguages.includes(targetLang)) {
          throw new Error(`Rosetta configured for live conversion to ${this.options.targetLanguages.join(", ")}, but requested ${targetLang}`);
        }
        const extracted = this.extractedSnippets.get(source.visibleSource);
        if (extracted !== void 0) {
          const snippet2 = this.translator.translate(extracted, this.options.targetLanguages);
          this.liveTablet.addSnippet(snippet2);
          return snippet2.get(targetLang);
        }
        const snippet = this.translator.translate(source, this.options.targetLanguages);
        return snippet.get(targetLang);
      }
      translateSnippetsInMarkdown(markdown, targetLang, strict, translationToCodeBlock = id, compileDirectory = process.cwd()) {
        return markdown_1.transformMarkdown(markdown, new markdown_renderer_1.MarkdownRenderer(), new replace_typescript_transform_1.ReplaceTypeScriptTransform("markdown", strict, (tsSnip) => {
          const translated = this.translateSnippet(snippet_1.updateParameters(tsSnip, {
            [snippet_1.SnippetParameters.$COMPILATION_DIRECTORY]: compileDirectory
          }), targetLang);
          if (!translated) {
            return void 0;
          }
          return translationToCodeBlock(translated);
        }));
      }
      printDiagnostics(stream) {
        util_2.printDiagnostics(this.diagnostics, stream);
      }
      get hasErrors() {
        return this.diagnostics.some(util_1.isError);
      }
      get allTablets() {
        return [...this.loadedTablets, this.liveTablet];
      }
    };
    exports.Rosetta = Rosetta;
    function id(x) {
      return x;
    }
  }
});

// node_modules/jsii-rosetta/lib/markdown/escapes.js
var require_escapes = __commonJS({
  "node_modules/jsii-rosetta/lib/markdown/escapes.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.makeJavaEscaper = exports.makeXmlEscaper = void 0;
    function makeXmlEscaper() {
      const attr = [...TEXT, ...ATTR_ADDL];
      return {
        text: (x) => escapeText(TEXT, x),
        attribute: (x) => escapeText(attr, x),
        text2attr: (x) => escapeText(ATTR_ADDL, x)
      };
    }
    exports.makeXmlEscaper = makeXmlEscaper;
    function makeJavaEscaper() {
      const javaText = [...TEXT, [new RegExp("@", "g"), "&#64;"]];
      const javaAttr = [...javaText, ...ATTR_ADDL];
      return {
        text: (x) => escapeText(javaText, x),
        attribute: (x) => escapeText(javaAttr, x),
        text2attr: (x) => escapeText(ATTR_ADDL, x)
      };
    }
    exports.makeJavaEscaper = makeJavaEscaper;
    var TEXT = [
      [new RegExp("&", "g"), "&amp;"],
      [new RegExp("<", "g"), "&lt;"],
      [new RegExp(">", "g"), "&gt;"]
    ];
    var ATTR_ADDL = [
      [new RegExp('"', "g"), "&quot;"],
      [new RegExp("'", "g"), "&apos;"]
    ];
    function escapeText(set, what) {
      if (!what) {
        return "";
      }
      for (const [re, repl] of set) {
        what = what.replace(re, repl);
      }
      return what;
    }
  }
});

// node_modules/jsii-rosetta/lib/markdown/javadoc-renderer.js
var require_javadoc_renderer = __commonJS({
  "node_modules/jsii-rosetta/lib/markdown/javadoc-renderer.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.JavaDocRenderer = void 0;
    var escapes_1 = require_escapes();
    var markdown_renderer_1 = require_markdown_renderer();
    var ESCAPE = escapes_1.makeJavaEscaper();
    var JavaDocRenderer = class extends markdown_renderer_1.MarkdownRenderer {
      block_quote(_node, context) {
        return `<blockquote>${context.content()}</blockquote>`;
      }
      code(node, _context) {
        return `<code>${ESCAPE.text(node.literal)}</code>`;
      }
      code_block(node, _context) {
        return markdown_renderer_1.para(`<blockquote><pre>
${ESCAPE.text(node.literal)}</pre></blockquote>`);
      }
      text(node, _context) {
        var _a;
        return (_a = ESCAPE.text(node.literal)) !== null && _a !== void 0 ? _a : "";
      }
      link(node, context) {
        var _a;
        return `<a href="${(_a = ESCAPE.attribute(node.destination)) !== null && _a !== void 0 ? _a : ""}">${context.content()}</a>`;
      }
      document(_node, context) {
        return markdown_renderer_1.stripTrailingWhitespace(collapseParaJava(context.content()));
      }
      heading(node, context) {
        return markdown_renderer_1.para(`<h${node.level}>${context.content()}</h${node.level}>`);
      }
      list(node, context) {
        const tag = node.listType === "bullet" ? "ul" : "ol";
        return markdown_renderer_1.para(`<${tag}>
${context.content()}</${tag}>`);
      }
      item(_node, context) {
        return `<li>${markdown_renderer_1.stripPara(context.content())}</li>
`;
      }
      image(node, context) {
        var _a;
        return `<img alt="${ESCAPE.text2attr(context.content())}" src="${(_a = ESCAPE.attribute(node.destination)) !== null && _a !== void 0 ? _a : ""}">`;
      }
      emph(_node, context) {
        return `<em>${context.content()}</em>`;
      }
      strong(_node, context) {
        return `<strong>${context.content()}</strong>`;
      }
      thematic_break(_node, _context) {
        return markdown_renderer_1.para("<hr>");
      }
    };
    exports.JavaDocRenderer = JavaDocRenderer;
    function collapseParaJava(x) {
      return markdown_renderer_1.collapsePara(x, "\n<p>\n");
    }
  }
});

// node_modules/jsii-rosetta/lib/markdown/structure-renderer.js
var require_structure_renderer = __commonJS({
  "node_modules/jsii-rosetta/lib/markdown/structure-renderer.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.StructureRenderer = void 0;
    var markdown_1 = require_markdown();
    var StructureRenderer = class {
      block_quote(node, context) {
        return this.handle("block_quote", node, context);
      }
      code(node, context) {
        return this.handle("code", node, context);
      }
      code_block(node, context) {
        return this.handle("code_block", node, context);
      }
      text(node, context) {
        return this.handle("text", node, context);
      }
      softbreak(node, context) {
        return this.handle("softbreak", node, context);
      }
      linebreak(node, context) {
        return this.handle("linebreak", node, context);
      }
      emph(node, context) {
        return this.handle("emph", node, context);
      }
      strong(node, context) {
        return this.handle("strong", node, context);
      }
      html_inline(node, context) {
        return this.handle("html_inline", node, context);
      }
      html_block(node, context) {
        return this.handle("html_block", node, context);
      }
      link(node, context) {
        return this.handle("link", node, context);
      }
      image(node, context) {
        return this.handle("image", node, context);
      }
      document(node, context) {
        return this.handle("document", node, context);
      }
      paragraph(node, context) {
        return this.handle("paragraph", node, context);
      }
      list(node, context) {
        return this.handle("list", node, context);
      }
      item(node, context) {
        return this.handle("item", node, context);
      }
      heading(node, context) {
        return this.handle("heading", node, context);
      }
      thematic_break(node, context) {
        return this.handle("thematic_break", node, context);
      }
      custom_block(node, context) {
        return this.handle("custom_block", node, context);
      }
      custom_inline(node, context) {
        return this.handle("custom_inline", node, context);
      }
      handle(name, node, context) {
        const contents = context.content();
        const enterText = [name, inspectNode(node)].filter((x) => x).join(" ");
        if (contents) {
          return `(${enterText}
${markdown_1.prefixLines("  ", contents)})
`;
        }
        return `(${enterText})
`;
      }
    };
    exports.StructureRenderer = StructureRenderer;
    function inspectNode(n) {
      const INTERESTING_KEYS = [
        "literal",
        "destination",
        "title",
        "info",
        "level",
        "listType",
        "listTight",
        "listStart",
        "listDelimiter"
      ];
      const ret = {};
      for (const key of INTERESTING_KEYS) {
        const value = n[key];
        if (typeof value === "string" || typeof value === "number") {
          ret[key] = value;
        }
      }
      return JSON.stringify(ret);
    }
  }
});

// node_modules/@xmldom/xmldom/lib/conventions.js
var require_conventions = __commonJS({
  "node_modules/@xmldom/xmldom/lib/conventions.js"(exports) {
    "use strict";
    function freeze(object, oc) {
      if (oc === void 0) {
        oc = Object;
      }
      return oc && typeof oc.freeze === "function" ? oc.freeze(object) : object;
    }
    var MIME_TYPE = freeze({
      HTML: "text/html",
      isHTML: function(value) {
        return value === MIME_TYPE.HTML;
      },
      XML_APPLICATION: "application/xml",
      XML_TEXT: "text/xml",
      XML_XHTML_APPLICATION: "application/xhtml+xml",
      XML_SVG_IMAGE: "image/svg+xml"
    });
    var NAMESPACE = freeze({
      HTML: "http://www.w3.org/1999/xhtml",
      isHTML: function(uri) {
        return uri === NAMESPACE.HTML;
      },
      SVG: "http://www.w3.org/2000/svg",
      XML: "http://www.w3.org/XML/1998/namespace",
      XMLNS: "http://www.w3.org/2000/xmlns/"
    });
    exports.freeze = freeze;
    exports.MIME_TYPE = MIME_TYPE;
    exports.NAMESPACE = NAMESPACE;
  }
});

// node_modules/@xmldom/xmldom/lib/dom.js
var require_dom = __commonJS({
  "node_modules/@xmldom/xmldom/lib/dom.js"(exports) {
    var conventions = require_conventions();
    var NAMESPACE = conventions.NAMESPACE;
    function notEmptyString(input) {
      return input !== "";
    }
    function splitOnASCIIWhitespace(input) {
      return input ? input.split(/[\t\n\f\r ]+/).filter(notEmptyString) : [];
    }
    function orderedSetReducer(current, element) {
      if (!current.hasOwnProperty(element)) {
        current[element] = true;
      }
      return current;
    }
    function toOrderedSet(input) {
      if (!input)
        return [];
      var list = splitOnASCIIWhitespace(input);
      return Object.keys(list.reduce(orderedSetReducer, {}));
    }
    function arrayIncludes(list) {
      return function(element) {
        return list && list.indexOf(element) !== -1;
      };
    }
    function copy(src, dest) {
      for (var p in src) {
        dest[p] = src[p];
      }
    }
    function _extends(Class, Super) {
      var pt = Class.prototype;
      if (!(pt instanceof Super)) {
        let t2 = function() {
        };
        var t = t2;
        ;
        t2.prototype = Super.prototype;
        t2 = new t2();
        copy(pt, t2);
        Class.prototype = pt = t2;
      }
      if (pt.constructor != Class) {
        if (typeof Class != "function") {
          console.error("unknown Class:" + Class);
        }
        pt.constructor = Class;
      }
    }
    var NodeType = {};
    var ELEMENT_NODE = NodeType.ELEMENT_NODE = 1;
    var ATTRIBUTE_NODE = NodeType.ATTRIBUTE_NODE = 2;
    var TEXT_NODE = NodeType.TEXT_NODE = 3;
    var CDATA_SECTION_NODE = NodeType.CDATA_SECTION_NODE = 4;
    var ENTITY_REFERENCE_NODE = NodeType.ENTITY_REFERENCE_NODE = 5;
    var ENTITY_NODE = NodeType.ENTITY_NODE = 6;
    var PROCESSING_INSTRUCTION_NODE = NodeType.PROCESSING_INSTRUCTION_NODE = 7;
    var COMMENT_NODE = NodeType.COMMENT_NODE = 8;
    var DOCUMENT_NODE = NodeType.DOCUMENT_NODE = 9;
    var DOCUMENT_TYPE_NODE = NodeType.DOCUMENT_TYPE_NODE = 10;
    var DOCUMENT_FRAGMENT_NODE = NodeType.DOCUMENT_FRAGMENT_NODE = 11;
    var NOTATION_NODE = NodeType.NOTATION_NODE = 12;
    var ExceptionCode = {};
    var ExceptionMessage = {};
    var INDEX_SIZE_ERR = ExceptionCode.INDEX_SIZE_ERR = (ExceptionMessage[1] = "Index size error", 1);
    var DOMSTRING_SIZE_ERR = ExceptionCode.DOMSTRING_SIZE_ERR = (ExceptionMessage[2] = "DOMString size error", 2);
    var HIERARCHY_REQUEST_ERR = ExceptionCode.HIERARCHY_REQUEST_ERR = (ExceptionMessage[3] = "Hierarchy request error", 3);
    var WRONG_DOCUMENT_ERR = ExceptionCode.WRONG_DOCUMENT_ERR = (ExceptionMessage[4] = "Wrong document", 4);
    var INVALID_CHARACTER_ERR = ExceptionCode.INVALID_CHARACTER_ERR = (ExceptionMessage[5] = "Invalid character", 5);
    var NO_DATA_ALLOWED_ERR = ExceptionCode.NO_DATA_ALLOWED_ERR = (ExceptionMessage[6] = "No data allowed", 6);
    var NO_MODIFICATION_ALLOWED_ERR = ExceptionCode.NO_MODIFICATION_ALLOWED_ERR = (ExceptionMessage[7] = "No modification allowed", 7);
    var NOT_FOUND_ERR = ExceptionCode.NOT_FOUND_ERR = (ExceptionMessage[8] = "Not found", 8);
    var NOT_SUPPORTED_ERR = ExceptionCode.NOT_SUPPORTED_ERR = (ExceptionMessage[9] = "Not supported", 9);
    var INUSE_ATTRIBUTE_ERR = ExceptionCode.INUSE_ATTRIBUTE_ERR = (ExceptionMessage[10] = "Attribute in use", 10);
    var INVALID_STATE_ERR = ExceptionCode.INVALID_STATE_ERR = (ExceptionMessage[11] = "Invalid state", 11);
    var SYNTAX_ERR = ExceptionCode.SYNTAX_ERR = (ExceptionMessage[12] = "Syntax error", 12);
    var INVALID_MODIFICATION_ERR = ExceptionCode.INVALID_MODIFICATION_ERR = (ExceptionMessage[13] = "Invalid modification", 13);
    var NAMESPACE_ERR = ExceptionCode.NAMESPACE_ERR = (ExceptionMessage[14] = "Invalid namespace", 14);
    var INVALID_ACCESS_ERR = ExceptionCode.INVALID_ACCESS_ERR = (ExceptionMessage[15] = "Invalid access", 15);
    function DOMException(code, message) {
      if (message instanceof Error) {
        var error = message;
      } else {
        error = this;
        Error.call(this, ExceptionMessage[code]);
        this.message = ExceptionMessage[code];
        if (Error.captureStackTrace)
          Error.captureStackTrace(this, DOMException);
      }
      error.code = code;
      if (message)
        this.message = this.message + ": " + message;
      return error;
    }
    DOMException.prototype = Error.prototype;
    copy(ExceptionCode, DOMException);
    function NodeList() {
    }
    NodeList.prototype = {
      length: 0,
      item: function(index) {
        return this[index] || null;
      },
      toString: function(isHTML, nodeFilter) {
        for (var buf = [], i = 0; i < this.length; i++) {
          serializeToString(this[i], buf, isHTML, nodeFilter);
        }
        return buf.join("");
      }
    };
    function LiveNodeList(node, refresh) {
      this._node = node;
      this._refresh = refresh;
      _updateLiveList(this);
    }
    function _updateLiveList(list) {
      var inc = list._node._inc || list._node.ownerDocument._inc;
      if (list._inc != inc) {
        var ls = list._refresh(list._node);
        __set__(list, "length", ls.length);
        copy(ls, list);
        list._inc = inc;
      }
    }
    LiveNodeList.prototype.item = function(i) {
      _updateLiveList(this);
      return this[i];
    };
    _extends(LiveNodeList, NodeList);
    function NamedNodeMap() {
    }
    function _findNodeIndex(list, node) {
      var i = list.length;
      while (i--) {
        if (list[i] === node) {
          return i;
        }
      }
    }
    function _addNamedNode(el, list, newAttr, oldAttr) {
      if (oldAttr) {
        list[_findNodeIndex(list, oldAttr)] = newAttr;
      } else {
        list[list.length++] = newAttr;
      }
      if (el) {
        newAttr.ownerElement = el;
        var doc = el.ownerDocument;
        if (doc) {
          oldAttr && _onRemoveAttribute(doc, el, oldAttr);
          _onAddAttribute(doc, el, newAttr);
        }
      }
    }
    function _removeNamedNode(el, list, attr) {
      var i = _findNodeIndex(list, attr);
      if (i >= 0) {
        var lastIndex = list.length - 1;
        while (i < lastIndex) {
          list[i] = list[++i];
        }
        list.length = lastIndex;
        if (el) {
          var doc = el.ownerDocument;
          if (doc) {
            _onRemoveAttribute(doc, el, attr);
            attr.ownerElement = null;
          }
        }
      } else {
        throw DOMException(NOT_FOUND_ERR, new Error(el.tagName + "@" + attr));
      }
    }
    NamedNodeMap.prototype = {
      length: 0,
      item: NodeList.prototype.item,
      getNamedItem: function(key) {
        var i = this.length;
        while (i--) {
          var attr = this[i];
          if (attr.nodeName == key) {
            return attr;
          }
        }
      },
      setNamedItem: function(attr) {
        var el = attr.ownerElement;
        if (el && el != this._ownerElement) {
          throw new DOMException(INUSE_ATTRIBUTE_ERR);
        }
        var oldAttr = this.getNamedItem(attr.nodeName);
        _addNamedNode(this._ownerElement, this, attr, oldAttr);
        return oldAttr;
      },
      setNamedItemNS: function(attr) {
        var el = attr.ownerElement, oldAttr;
        if (el && el != this._ownerElement) {
          throw new DOMException(INUSE_ATTRIBUTE_ERR);
        }
        oldAttr = this.getNamedItemNS(attr.namespaceURI, attr.localName);
        _addNamedNode(this._ownerElement, this, attr, oldAttr);
        return oldAttr;
      },
      removeNamedItem: function(key) {
        var attr = this.getNamedItem(key);
        _removeNamedNode(this._ownerElement, this, attr);
        return attr;
      },
      removeNamedItemNS: function(namespaceURI, localName) {
        var attr = this.getNamedItemNS(namespaceURI, localName);
        _removeNamedNode(this._ownerElement, this, attr);
        return attr;
      },
      getNamedItemNS: function(namespaceURI, localName) {
        var i = this.length;
        while (i--) {
          var node = this[i];
          if (node.localName == localName && node.namespaceURI == namespaceURI) {
            return node;
          }
        }
        return null;
      }
    };
    function DOMImplementation() {
    }
    DOMImplementation.prototype = {
      hasFeature: function(feature, version) {
        return true;
      },
      createDocument: function(namespaceURI, qualifiedName, doctype) {
        var doc = new Document();
        doc.implementation = this;
        doc.childNodes = new NodeList();
        doc.doctype = doctype || null;
        if (doctype) {
          doc.appendChild(doctype);
        }
        if (qualifiedName) {
          var root = doc.createElementNS(namespaceURI, qualifiedName);
          doc.appendChild(root);
        }
        return doc;
      },
      createDocumentType: function(qualifiedName, publicId, systemId) {
        var node = new DocumentType();
        node.name = qualifiedName;
        node.nodeName = qualifiedName;
        node.publicId = publicId || "";
        node.systemId = systemId || "";
        return node;
      }
    };
    function Node() {
    }
    Node.prototype = {
      firstChild: null,
      lastChild: null,
      previousSibling: null,
      nextSibling: null,
      attributes: null,
      parentNode: null,
      childNodes: null,
      ownerDocument: null,
      nodeValue: null,
      namespaceURI: null,
      prefix: null,
      localName: null,
      insertBefore: function(newChild, refChild) {
        return _insertBefore(this, newChild, refChild);
      },
      replaceChild: function(newChild, oldChild) {
        this.insertBefore(newChild, oldChild);
        if (oldChild) {
          this.removeChild(oldChild);
        }
      },
      removeChild: function(oldChild) {
        return _removeChild(this, oldChild);
      },
      appendChild: function(newChild) {
        return this.insertBefore(newChild, null);
      },
      hasChildNodes: function() {
        return this.firstChild != null;
      },
      cloneNode: function(deep) {
        return cloneNode(this.ownerDocument || this, this, deep);
      },
      normalize: function() {
        var child = this.firstChild;
        while (child) {
          var next = child.nextSibling;
          if (next && next.nodeType == TEXT_NODE && child.nodeType == TEXT_NODE) {
            this.removeChild(next);
            child.appendData(next.data);
          } else {
            child.normalize();
            child = next;
          }
        }
      },
      isSupported: function(feature, version) {
        return this.ownerDocument.implementation.hasFeature(feature, version);
      },
      hasAttributes: function() {
        return this.attributes.length > 0;
      },
      lookupPrefix: function(namespaceURI) {
        var el = this;
        while (el) {
          var map = el._nsMap;
          if (map) {
            for (var n in map) {
              if (map[n] == namespaceURI) {
                return n;
              }
            }
          }
          el = el.nodeType == ATTRIBUTE_NODE ? el.ownerDocument : el.parentNode;
        }
        return null;
      },
      lookupNamespaceURI: function(prefix) {
        var el = this;
        while (el) {
          var map = el._nsMap;
          if (map) {
            if (prefix in map) {
              return map[prefix];
            }
          }
          el = el.nodeType == ATTRIBUTE_NODE ? el.ownerDocument : el.parentNode;
        }
        return null;
      },
      isDefaultNamespace: function(namespaceURI) {
        var prefix = this.lookupPrefix(namespaceURI);
        return prefix == null;
      }
    };
    function _xmlEncoder(c) {
      return c == "<" && "&lt;" || c == ">" && "&gt;" || c == "&" && "&amp;" || c == '"' && "&quot;" || "&#" + c.charCodeAt() + ";";
    }
    copy(NodeType, Node);
    copy(NodeType, Node.prototype);
    function _visitNode(node, callback) {
      if (callback(node)) {
        return true;
      }
      if (node = node.firstChild) {
        do {
          if (_visitNode(node, callback)) {
            return true;
          }
        } while (node = node.nextSibling);
      }
    }
    function Document() {
    }
    function _onAddAttribute(doc, el, newAttr) {
      doc && doc._inc++;
      var ns = newAttr.namespaceURI;
      if (ns === NAMESPACE.XMLNS) {
        el._nsMap[newAttr.prefix ? newAttr.localName : ""] = newAttr.value;
      }
    }
    function _onRemoveAttribute(doc, el, newAttr, remove2) {
      doc && doc._inc++;
      var ns = newAttr.namespaceURI;
      if (ns === NAMESPACE.XMLNS) {
        delete el._nsMap[newAttr.prefix ? newAttr.localName : ""];
      }
    }
    function _onUpdateChild(doc, el, newChild) {
      if (doc && doc._inc) {
        doc._inc++;
        var cs = el.childNodes;
        if (newChild) {
          cs[cs.length++] = newChild;
        } else {
          var child = el.firstChild;
          var i = 0;
          while (child) {
            cs[i++] = child;
            child = child.nextSibling;
          }
          cs.length = i;
        }
      }
    }
    function _removeChild(parentNode, child) {
      var previous = child.previousSibling;
      var next = child.nextSibling;
      if (previous) {
        previous.nextSibling = next;
      } else {
        parentNode.firstChild = next;
      }
      if (next) {
        next.previousSibling = previous;
      } else {
        parentNode.lastChild = previous;
      }
      _onUpdateChild(parentNode.ownerDocument, parentNode);
      return child;
    }
    function _insertBefore(parentNode, newChild, nextChild) {
      var cp = newChild.parentNode;
      if (cp) {
        cp.removeChild(newChild);
      }
      if (newChild.nodeType === DOCUMENT_FRAGMENT_NODE) {
        var newFirst = newChild.firstChild;
        if (newFirst == null) {
          return newChild;
        }
        var newLast = newChild.lastChild;
      } else {
        newFirst = newLast = newChild;
      }
      var pre = nextChild ? nextChild.previousSibling : parentNode.lastChild;
      newFirst.previousSibling = pre;
      newLast.nextSibling = nextChild;
      if (pre) {
        pre.nextSibling = newFirst;
      } else {
        parentNode.firstChild = newFirst;
      }
      if (nextChild == null) {
        parentNode.lastChild = newLast;
      } else {
        nextChild.previousSibling = newLast;
      }
      do {
        newFirst.parentNode = parentNode;
      } while (newFirst !== newLast && (newFirst = newFirst.nextSibling));
      _onUpdateChild(parentNode.ownerDocument || parentNode, parentNode);
      if (newChild.nodeType == DOCUMENT_FRAGMENT_NODE) {
        newChild.firstChild = newChild.lastChild = null;
      }
      return newChild;
    }
    function _appendSingleChild(parentNode, newChild) {
      var cp = newChild.parentNode;
      if (cp) {
        var pre = parentNode.lastChild;
        cp.removeChild(newChild);
        var pre = parentNode.lastChild;
      }
      var pre = parentNode.lastChild;
      newChild.parentNode = parentNode;
      newChild.previousSibling = pre;
      newChild.nextSibling = null;
      if (pre) {
        pre.nextSibling = newChild;
      } else {
        parentNode.firstChild = newChild;
      }
      parentNode.lastChild = newChild;
      _onUpdateChild(parentNode.ownerDocument, parentNode, newChild);
      return newChild;
    }
    Document.prototype = {
      nodeName: "#document",
      nodeType: DOCUMENT_NODE,
      doctype: null,
      documentElement: null,
      _inc: 1,
      insertBefore: function(newChild, refChild) {
        if (newChild.nodeType == DOCUMENT_FRAGMENT_NODE) {
          var child = newChild.firstChild;
          while (child) {
            var next = child.nextSibling;
            this.insertBefore(child, refChild);
            child = next;
          }
          return newChild;
        }
        if (this.documentElement == null && newChild.nodeType == ELEMENT_NODE) {
          this.documentElement = newChild;
        }
        return _insertBefore(this, newChild, refChild), newChild.ownerDocument = this, newChild;
      },
      removeChild: function(oldChild) {
        if (this.documentElement == oldChild) {
          this.documentElement = null;
        }
        return _removeChild(this, oldChild);
      },
      importNode: function(importedNode, deep) {
        return importNode(this, importedNode, deep);
      },
      getElementById: function(id) {
        var rtv = null;
        _visitNode(this.documentElement, function(node) {
          if (node.nodeType == ELEMENT_NODE) {
            if (node.getAttribute("id") == id) {
              rtv = node;
              return true;
            }
          }
        });
        return rtv;
      },
      getElementsByClassName: function(classNames) {
        var classNamesSet = toOrderedSet(classNames);
        return new LiveNodeList(this, function(base) {
          var ls = [];
          if (classNamesSet.length > 0) {
            _visitNode(base.documentElement, function(node) {
              if (node !== base && node.nodeType === ELEMENT_NODE) {
                var nodeClassNames = node.getAttribute("class");
                if (nodeClassNames) {
                  var matches = classNames === nodeClassNames;
                  if (!matches) {
                    var nodeClassNamesSet = toOrderedSet(nodeClassNames);
                    matches = classNamesSet.every(arrayIncludes(nodeClassNamesSet));
                  }
                  if (matches) {
                    ls.push(node);
                  }
                }
              }
            });
          }
          return ls;
        });
      },
      createElement: function(tagName) {
        var node = new Element();
        node.ownerDocument = this;
        node.nodeName = tagName;
        node.tagName = tagName;
        node.localName = tagName;
        node.childNodes = new NodeList();
        var attrs = node.attributes = new NamedNodeMap();
        attrs._ownerElement = node;
        return node;
      },
      createDocumentFragment: function() {
        var node = new DocumentFragment();
        node.ownerDocument = this;
        node.childNodes = new NodeList();
        return node;
      },
      createTextNode: function(data) {
        var node = new Text();
        node.ownerDocument = this;
        node.appendData(data);
        return node;
      },
      createComment: function(data) {
        var node = new Comment();
        node.ownerDocument = this;
        node.appendData(data);
        return node;
      },
      createCDATASection: function(data) {
        var node = new CDATASection();
        node.ownerDocument = this;
        node.appendData(data);
        return node;
      },
      createProcessingInstruction: function(target, data) {
        var node = new ProcessingInstruction();
        node.ownerDocument = this;
        node.tagName = node.target = target;
        node.nodeValue = node.data = data;
        return node;
      },
      createAttribute: function(name) {
        var node = new Attr();
        node.ownerDocument = this;
        node.name = name;
        node.nodeName = name;
        node.localName = name;
        node.specified = true;
        return node;
      },
      createEntityReference: function(name) {
        var node = new EntityReference();
        node.ownerDocument = this;
        node.nodeName = name;
        return node;
      },
      createElementNS: function(namespaceURI, qualifiedName) {
        var node = new Element();
        var pl = qualifiedName.split(":");
        var attrs = node.attributes = new NamedNodeMap();
        node.childNodes = new NodeList();
        node.ownerDocument = this;
        node.nodeName = qualifiedName;
        node.tagName = qualifiedName;
        node.namespaceURI = namespaceURI;
        if (pl.length == 2) {
          node.prefix = pl[0];
          node.localName = pl[1];
        } else {
          node.localName = qualifiedName;
        }
        attrs._ownerElement = node;
        return node;
      },
      createAttributeNS: function(namespaceURI, qualifiedName) {
        var node = new Attr();
        var pl = qualifiedName.split(":");
        node.ownerDocument = this;
        node.nodeName = qualifiedName;
        node.name = qualifiedName;
        node.namespaceURI = namespaceURI;
        node.specified = true;
        if (pl.length == 2) {
          node.prefix = pl[0];
          node.localName = pl[1];
        } else {
          node.localName = qualifiedName;
        }
        return node;
      }
    };
    _extends(Document, Node);
    function Element() {
      this._nsMap = {};
    }
    Element.prototype = {
      nodeType: ELEMENT_NODE,
      hasAttribute: function(name) {
        return this.getAttributeNode(name) != null;
      },
      getAttribute: function(name) {
        var attr = this.getAttributeNode(name);
        return attr && attr.value || "";
      },
      getAttributeNode: function(name) {
        return this.attributes.getNamedItem(name);
      },
      setAttribute: function(name, value) {
        var attr = this.ownerDocument.createAttribute(name);
        attr.value = attr.nodeValue = "" + value;
        this.setAttributeNode(attr);
      },
      removeAttribute: function(name) {
        var attr = this.getAttributeNode(name);
        attr && this.removeAttributeNode(attr);
      },
      appendChild: function(newChild) {
        if (newChild.nodeType === DOCUMENT_FRAGMENT_NODE) {
          return this.insertBefore(newChild, null);
        } else {
          return _appendSingleChild(this, newChild);
        }
      },
      setAttributeNode: function(newAttr) {
        return this.attributes.setNamedItem(newAttr);
      },
      setAttributeNodeNS: function(newAttr) {
        return this.attributes.setNamedItemNS(newAttr);
      },
      removeAttributeNode: function(oldAttr) {
        return this.attributes.removeNamedItem(oldAttr.nodeName);
      },
      removeAttributeNS: function(namespaceURI, localName) {
        var old = this.getAttributeNodeNS(namespaceURI, localName);
        old && this.removeAttributeNode(old);
      },
      hasAttributeNS: function(namespaceURI, localName) {
        return this.getAttributeNodeNS(namespaceURI, localName) != null;
      },
      getAttributeNS: function(namespaceURI, localName) {
        var attr = this.getAttributeNodeNS(namespaceURI, localName);
        return attr && attr.value || "";
      },
      setAttributeNS: function(namespaceURI, qualifiedName, value) {
        var attr = this.ownerDocument.createAttributeNS(namespaceURI, qualifiedName);
        attr.value = attr.nodeValue = "" + value;
        this.setAttributeNode(attr);
      },
      getAttributeNodeNS: function(namespaceURI, localName) {
        return this.attributes.getNamedItemNS(namespaceURI, localName);
      },
      getElementsByTagName: function(tagName) {
        return new LiveNodeList(this, function(base) {
          var ls = [];
          _visitNode(base, function(node) {
            if (node !== base && node.nodeType == ELEMENT_NODE && (tagName === "*" || node.tagName == tagName)) {
              ls.push(node);
            }
          });
          return ls;
        });
      },
      getElementsByTagNameNS: function(namespaceURI, localName) {
        return new LiveNodeList(this, function(base) {
          var ls = [];
          _visitNode(base, function(node) {
            if (node !== base && node.nodeType === ELEMENT_NODE && (namespaceURI === "*" || node.namespaceURI === namespaceURI) && (localName === "*" || node.localName == localName)) {
              ls.push(node);
            }
          });
          return ls;
        });
      }
    };
    Document.prototype.getElementsByTagName = Element.prototype.getElementsByTagName;
    Document.prototype.getElementsByTagNameNS = Element.prototype.getElementsByTagNameNS;
    _extends(Element, Node);
    function Attr() {
    }
    Attr.prototype.nodeType = ATTRIBUTE_NODE;
    _extends(Attr, Node);
    function CharacterData() {
    }
    CharacterData.prototype = {
      data: "",
      substringData: function(offset, count) {
        return this.data.substring(offset, offset + count);
      },
      appendData: function(text) {
        text = this.data + text;
        this.nodeValue = this.data = text;
        this.length = text.length;
      },
      insertData: function(offset, text) {
        this.replaceData(offset, 0, text);
      },
      appendChild: function(newChild) {
        throw new Error(ExceptionMessage[HIERARCHY_REQUEST_ERR]);
      },
      deleteData: function(offset, count) {
        this.replaceData(offset, count, "");
      },
      replaceData: function(offset, count, text) {
        var start = this.data.substring(0, offset);
        var end = this.data.substring(offset + count);
        text = start + text + end;
        this.nodeValue = this.data = text;
        this.length = text.length;
      }
    };
    _extends(CharacterData, Node);
    function Text() {
    }
    Text.prototype = {
      nodeName: "#text",
      nodeType: TEXT_NODE,
      splitText: function(offset) {
        var text = this.data;
        var newText = text.substring(offset);
        text = text.substring(0, offset);
        this.data = this.nodeValue = text;
        this.length = text.length;
        var newNode = this.ownerDocument.createTextNode(newText);
        if (this.parentNode) {
          this.parentNode.insertBefore(newNode, this.nextSibling);
        }
        return newNode;
      }
    };
    _extends(Text, CharacterData);
    function Comment() {
    }
    Comment.prototype = {
      nodeName: "#comment",
      nodeType: COMMENT_NODE
    };
    _extends(Comment, CharacterData);
    function CDATASection() {
    }
    CDATASection.prototype = {
      nodeName: "#cdata-section",
      nodeType: CDATA_SECTION_NODE
    };
    _extends(CDATASection, CharacterData);
    function DocumentType() {
    }
    DocumentType.prototype.nodeType = DOCUMENT_TYPE_NODE;
    _extends(DocumentType, Node);
    function Notation() {
    }
    Notation.prototype.nodeType = NOTATION_NODE;
    _extends(Notation, Node);
    function Entity() {
    }
    Entity.prototype.nodeType = ENTITY_NODE;
    _extends(Entity, Node);
    function EntityReference() {
    }
    EntityReference.prototype.nodeType = ENTITY_REFERENCE_NODE;
    _extends(EntityReference, Node);
    function DocumentFragment() {
    }
    DocumentFragment.prototype.nodeName = "#document-fragment";
    DocumentFragment.prototype.nodeType = DOCUMENT_FRAGMENT_NODE;
    _extends(DocumentFragment, Node);
    function ProcessingInstruction() {
    }
    ProcessingInstruction.prototype.nodeType = PROCESSING_INSTRUCTION_NODE;
    _extends(ProcessingInstruction, Node);
    function XMLSerializer() {
    }
    XMLSerializer.prototype.serializeToString = function(node, isHtml, nodeFilter) {
      return nodeSerializeToString.call(node, isHtml, nodeFilter);
    };
    Node.prototype.toString = nodeSerializeToString;
    function nodeSerializeToString(isHtml, nodeFilter) {
      var buf = [];
      var refNode = this.nodeType == 9 && this.documentElement || this;
      var prefix = refNode.prefix;
      var uri = refNode.namespaceURI;
      if (uri && prefix == null) {
        var prefix = refNode.lookupPrefix(uri);
        if (prefix == null) {
          var visibleNamespaces = [
            { namespace: uri, prefix: null }
          ];
        }
      }
      serializeToString(this, buf, isHtml, nodeFilter, visibleNamespaces);
      return buf.join("");
    }
    function needNamespaceDefine(node, isHTML, visibleNamespaces) {
      var prefix = node.prefix || "";
      var uri = node.namespaceURI;
      if (!uri) {
        return false;
      }
      if (prefix === "xml" && uri === NAMESPACE.XML || uri === NAMESPACE.XMLNS) {
        return false;
      }
      var i = visibleNamespaces.length;
      while (i--) {
        var ns = visibleNamespaces[i];
        if (ns.prefix === prefix) {
          return ns.namespace !== uri;
        }
      }
      return true;
    }
    function addSerializedAttribute(buf, qualifiedName, value) {
      buf.push(" ", qualifiedName, '="', value.replace(/[<&"]/g, _xmlEncoder), '"');
    }
    function serializeToString(node, buf, isHTML, nodeFilter, visibleNamespaces) {
      if (!visibleNamespaces) {
        visibleNamespaces = [];
      }
      if (nodeFilter) {
        node = nodeFilter(node);
        if (node) {
          if (typeof node == "string") {
            buf.push(node);
            return;
          }
        } else {
          return;
        }
      }
      switch (node.nodeType) {
        case ELEMENT_NODE:
          var attrs = node.attributes;
          var len = attrs.length;
          var child = node.firstChild;
          var nodeName = node.tagName;
          isHTML = NAMESPACE.isHTML(node.namespaceURI) || isHTML;
          var prefixedNodeName = nodeName;
          if (!isHTML && !node.prefix && node.namespaceURI) {
            var defaultNS;
            for (var ai = 0; ai < attrs.length; ai++) {
              if (attrs.item(ai).name === "xmlns") {
                defaultNS = attrs.item(ai).value;
                break;
              }
            }
            if (!defaultNS) {
              for (var nsi = visibleNamespaces.length - 1; nsi >= 0; nsi--) {
                var namespace = visibleNamespaces[nsi];
                if (namespace.prefix === "" && namespace.namespace === node.namespaceURI) {
                  defaultNS = namespace.namespace;
                  break;
                }
              }
            }
            if (defaultNS !== node.namespaceURI) {
              for (var nsi = visibleNamespaces.length - 1; nsi >= 0; nsi--) {
                var namespace = visibleNamespaces[nsi];
                if (namespace.namespace === node.namespaceURI) {
                  if (namespace.prefix) {
                    prefixedNodeName = namespace.prefix + ":" + nodeName;
                  }
                  break;
                }
              }
            }
          }
          buf.push("<", prefixedNodeName);
          for (var i = 0; i < len; i++) {
            var attr = attrs.item(i);
            if (attr.prefix == "xmlns") {
              visibleNamespaces.push({ prefix: attr.localName, namespace: attr.value });
            } else if (attr.nodeName == "xmlns") {
              visibleNamespaces.push({ prefix: "", namespace: attr.value });
            }
          }
          for (var i = 0; i < len; i++) {
            var attr = attrs.item(i);
            if (needNamespaceDefine(attr, isHTML, visibleNamespaces)) {
              var prefix = attr.prefix || "";
              var uri = attr.namespaceURI;
              addSerializedAttribute(buf, prefix ? "xmlns:" + prefix : "xmlns", uri);
              visibleNamespaces.push({ prefix, namespace: uri });
            }
            serializeToString(attr, buf, isHTML, nodeFilter, visibleNamespaces);
          }
          if (nodeName === prefixedNodeName && needNamespaceDefine(node, isHTML, visibleNamespaces)) {
            var prefix = node.prefix || "";
            var uri = node.namespaceURI;
            addSerializedAttribute(buf, prefix ? "xmlns:" + prefix : "xmlns", uri);
            visibleNamespaces.push({ prefix, namespace: uri });
          }
          if (child || isHTML && !/^(?:meta|link|img|br|hr|input)$/i.test(nodeName)) {
            buf.push(">");
            if (isHTML && /^script$/i.test(nodeName)) {
              while (child) {
                if (child.data) {
                  buf.push(child.data);
                } else {
                  serializeToString(child, buf, isHTML, nodeFilter, visibleNamespaces.slice());
                }
                child = child.nextSibling;
              }
            } else {
              while (child) {
                serializeToString(child, buf, isHTML, nodeFilter, visibleNamespaces.slice());
                child = child.nextSibling;
              }
            }
            buf.push("</", prefixedNodeName, ">");
          } else {
            buf.push("/>");
          }
          return;
        case DOCUMENT_NODE:
        case DOCUMENT_FRAGMENT_NODE:
          var child = node.firstChild;
          while (child) {
            serializeToString(child, buf, isHTML, nodeFilter, visibleNamespaces.slice());
            child = child.nextSibling;
          }
          return;
        case ATTRIBUTE_NODE:
          return addSerializedAttribute(buf, node.name, node.value);
        case TEXT_NODE:
          return buf.push(node.data.replace(/[<&]/g, _xmlEncoder).replace(/]]>/g, "]]&gt;"));
        case CDATA_SECTION_NODE:
          return buf.push("<![CDATA[", node.data, "]]>");
        case COMMENT_NODE:
          return buf.push("<!--", node.data, "-->");
        case DOCUMENT_TYPE_NODE:
          var pubid = node.publicId;
          var sysid = node.systemId;
          buf.push("<!DOCTYPE ", node.name);
          if (pubid) {
            buf.push(" PUBLIC ", pubid);
            if (sysid && sysid != ".") {
              buf.push(" ", sysid);
            }
            buf.push(">");
          } else if (sysid && sysid != ".") {
            buf.push(" SYSTEM ", sysid, ">");
          } else {
            var sub = node.internalSubset;
            if (sub) {
              buf.push(" [", sub, "]");
            }
            buf.push(">");
          }
          return;
        case PROCESSING_INSTRUCTION_NODE:
          return buf.push("<?", node.target, " ", node.data, "?>");
        case ENTITY_REFERENCE_NODE:
          return buf.push("&", node.nodeName, ";");
        default:
          buf.push("??", node.nodeName);
      }
    }
    function importNode(doc, node, deep) {
      var node2;
      switch (node.nodeType) {
        case ELEMENT_NODE:
          node2 = node.cloneNode(false);
          node2.ownerDocument = doc;
        case DOCUMENT_FRAGMENT_NODE:
          break;
        case ATTRIBUTE_NODE:
          deep = true;
          break;
      }
      if (!node2) {
        node2 = node.cloneNode(false);
      }
      node2.ownerDocument = doc;
      node2.parentNode = null;
      if (deep) {
        var child = node.firstChild;
        while (child) {
          node2.appendChild(importNode(doc, child, deep));
          child = child.nextSibling;
        }
      }
      return node2;
    }
    function cloneNode(doc, node, deep) {
      var node2 = new node.constructor();
      for (var n in node) {
        var v = node[n];
        if (typeof v != "object") {
          if (v != node2[n]) {
            node2[n] = v;
          }
        }
      }
      if (node.childNodes) {
        node2.childNodes = new NodeList();
      }
      node2.ownerDocument = doc;
      switch (node2.nodeType) {
        case ELEMENT_NODE:
          var attrs = node.attributes;
          var attrs2 = node2.attributes = new NamedNodeMap();
          var len = attrs.length;
          attrs2._ownerElement = node2;
          for (var i = 0; i < len; i++) {
            node2.setAttributeNode(cloneNode(doc, attrs.item(i), true));
          }
          break;
          ;
        case ATTRIBUTE_NODE:
          deep = true;
      }
      if (deep) {
        var child = node.firstChild;
        while (child) {
          node2.appendChild(cloneNode(doc, child, deep));
          child = child.nextSibling;
        }
      }
      return node2;
    }
    function __set__(object, key, value) {
      object[key] = value;
    }
    try {
      if (Object.defineProperty) {
        let getTextContent2 = function(node) {
          switch (node.nodeType) {
            case ELEMENT_NODE:
            case DOCUMENT_FRAGMENT_NODE:
              var buf = [];
              node = node.firstChild;
              while (node) {
                if (node.nodeType !== 7 && node.nodeType !== 8) {
                  buf.push(getTextContent2(node));
                }
                node = node.nextSibling;
              }
              return buf.join("");
            default:
              return node.nodeValue;
          }
        };
        getTextContent = getTextContent2;
        Object.defineProperty(LiveNodeList.prototype, "length", {
          get: function() {
            _updateLiveList(this);
            return this.$$length;
          }
        });
        Object.defineProperty(Node.prototype, "textContent", {
          get: function() {
            return getTextContent2(this);
          },
          set: function(data) {
            switch (this.nodeType) {
              case ELEMENT_NODE:
              case DOCUMENT_FRAGMENT_NODE:
                while (this.firstChild) {
                  this.removeChild(this.firstChild);
                }
                if (data || String(data)) {
                  this.appendChild(this.ownerDocument.createTextNode(data));
                }
                break;
              default:
                this.data = data;
                this.value = data;
                this.nodeValue = data;
            }
          }
        });
        __set__ = function(object, key, value) {
          object["$$" + key] = value;
        };
      }
    } catch (e) {
    }
    var getTextContent;
    exports.DocumentType = DocumentType;
    exports.DOMException = DOMException;
    exports.DOMImplementation = DOMImplementation;
    exports.Element = Element;
    exports.Node = Node;
    exports.NodeList = NodeList;
    exports.XMLSerializer = XMLSerializer;
  }
});

// node_modules/@xmldom/xmldom/lib/entities.js
var require_entities = __commonJS({
  "node_modules/@xmldom/xmldom/lib/entities.js"(exports) {
    var freeze = require_conventions().freeze;
    exports.XML_ENTITIES = freeze({ amp: "&", apos: "'", gt: ">", lt: "<", quot: '"' });
    exports.HTML_ENTITIES = freeze({
      lt: "<",
      gt: ">",
      amp: "&",
      quot: '"',
      apos: "'",
      Agrave: "\xC0",
      Aacute: "\xC1",
      Acirc: "\xC2",
      Atilde: "\xC3",
      Auml: "\xC4",
      Aring: "\xC5",
      AElig: "\xC6",
      Ccedil: "\xC7",
      Egrave: "\xC8",
      Eacute: "\xC9",
      Ecirc: "\xCA",
      Euml: "\xCB",
      Igrave: "\xCC",
      Iacute: "\xCD",
      Icirc: "\xCE",
      Iuml: "\xCF",
      ETH: "\xD0",
      Ntilde: "\xD1",
      Ograve: "\xD2",
      Oacute: "\xD3",
      Ocirc: "\xD4",
      Otilde: "\xD5",
      Ouml: "\xD6",
      Oslash: "\xD8",
      Ugrave: "\xD9",
      Uacute: "\xDA",
      Ucirc: "\xDB",
      Uuml: "\xDC",
      Yacute: "\xDD",
      THORN: "\xDE",
      szlig: "\xDF",
      agrave: "\xE0",
      aacute: "\xE1",
      acirc: "\xE2",
      atilde: "\xE3",
      auml: "\xE4",
      aring: "\xE5",
      aelig: "\xE6",
      ccedil: "\xE7",
      egrave: "\xE8",
      eacute: "\xE9",
      ecirc: "\xEA",
      euml: "\xEB",
      igrave: "\xEC",
      iacute: "\xED",
      icirc: "\xEE",
      iuml: "\xEF",
      eth: "\xF0",
      ntilde: "\xF1",
      ograve: "\xF2",
      oacute: "\xF3",
      ocirc: "\xF4",
      otilde: "\xF5",
      ouml: "\xF6",
      oslash: "\xF8",
      ugrave: "\xF9",
      uacute: "\xFA",
      ucirc: "\xFB",
      uuml: "\xFC",
      yacute: "\xFD",
      thorn: "\xFE",
      yuml: "\xFF",
      nbsp: "\xA0",
      iexcl: "\xA1",
      cent: "\xA2",
      pound: "\xA3",
      curren: "\xA4",
      yen: "\xA5",
      brvbar: "\xA6",
      sect: "\xA7",
      uml: "\xA8",
      copy: "\xA9",
      ordf: "\xAA",
      laquo: "\xAB",
      not: "\xAC",
      shy: "\xAD\xAD",
      reg: "\xAE",
      macr: "\xAF",
      deg: "\xB0",
      plusmn: "\xB1",
      sup2: "\xB2",
      sup3: "\xB3",
      acute: "\xB4",
      micro: "\xB5",
      para: "\xB6",
      middot: "\xB7",
      cedil: "\xB8",
      sup1: "\xB9",
      ordm: "\xBA",
      raquo: "\xBB",
      frac14: "\xBC",
      frac12: "\xBD",
      frac34: "\xBE",
      iquest: "\xBF",
      times: "\xD7",
      divide: "\xF7",
      forall: "\u2200",
      part: "\u2202",
      exist: "\u2203",
      empty: "\u2205",
      nabla: "\u2207",
      isin: "\u2208",
      notin: "\u2209",
      ni: "\u220B",
      prod: "\u220F",
      sum: "\u2211",
      minus: "\u2212",
      lowast: "\u2217",
      radic: "\u221A",
      prop: "\u221D",
      infin: "\u221E",
      ang: "\u2220",
      and: "\u2227",
      or: "\u2228",
      cap: "\u2229",
      cup: "\u222A",
      "int": "\u222B",
      there4: "\u2234",
      sim: "\u223C",
      cong: "\u2245",
      asymp: "\u2248",
      ne: "\u2260",
      equiv: "\u2261",
      le: "\u2264",
      ge: "\u2265",
      sub: "\u2282",
      sup: "\u2283",
      nsub: "\u2284",
      sube: "\u2286",
      supe: "\u2287",
      oplus: "\u2295",
      otimes: "\u2297",
      perp: "\u22A5",
      sdot: "\u22C5",
      Alpha: "\u0391",
      Beta: "\u0392",
      Gamma: "\u0393",
      Delta: "\u0394",
      Epsilon: "\u0395",
      Zeta: "\u0396",
      Eta: "\u0397",
      Theta: "\u0398",
      Iota: "\u0399",
      Kappa: "\u039A",
      Lambda: "\u039B",
      Mu: "\u039C",
      Nu: "\u039D",
      Xi: "\u039E",
      Omicron: "\u039F",
      Pi: "\u03A0",
      Rho: "\u03A1",
      Sigma: "\u03A3",
      Tau: "\u03A4",
      Upsilon: "\u03A5",
      Phi: "\u03A6",
      Chi: "\u03A7",
      Psi: "\u03A8",
      Omega: "\u03A9",
      alpha: "\u03B1",
      beta: "\u03B2",
      gamma: "\u03B3",
      delta: "\u03B4",
      epsilon: "\u03B5",
      zeta: "\u03B6",
      eta: "\u03B7",
      theta: "\u03B8",
      iota: "\u03B9",
      kappa: "\u03BA",
      lambda: "\u03BB",
      mu: "\u03BC",
      nu: "\u03BD",
      xi: "\u03BE",
      omicron: "\u03BF",
      pi: "\u03C0",
      rho: "\u03C1",
      sigmaf: "\u03C2",
      sigma: "\u03C3",
      tau: "\u03C4",
      upsilon: "\u03C5",
      phi: "\u03C6",
      chi: "\u03C7",
      psi: "\u03C8",
      omega: "\u03C9",
      thetasym: "\u03D1",
      upsih: "\u03D2",
      piv: "\u03D6",
      OElig: "\u0152",
      oelig: "\u0153",
      Scaron: "\u0160",
      scaron: "\u0161",
      Yuml: "\u0178",
      fnof: "\u0192",
      circ: "\u02C6",
      tilde: "\u02DC",
      ensp: "\u2002",
      emsp: "\u2003",
      thinsp: "\u2009",
      zwnj: "\u200C",
      zwj: "\u200D",
      lrm: "\u200E",
      rlm: "\u200F",
      ndash: "\u2013",
      mdash: "\u2014",
      lsquo: "\u2018",
      rsquo: "\u2019",
      sbquo: "\u201A",
      ldquo: "\u201C",
      rdquo: "\u201D",
      bdquo: "\u201E",
      dagger: "\u2020",
      Dagger: "\u2021",
      bull: "\u2022",
      hellip: "\u2026",
      permil: "\u2030",
      prime: "\u2032",
      Prime: "\u2033",
      lsaquo: "\u2039",
      rsaquo: "\u203A",
      oline: "\u203E",
      euro: "\u20AC",
      trade: "\u2122",
      larr: "\u2190",
      uarr: "\u2191",
      rarr: "\u2192",
      darr: "\u2193",
      harr: "\u2194",
      crarr: "\u21B5",
      lceil: "\u2308",
      rceil: "\u2309",
      lfloor: "\u230A",
      rfloor: "\u230B",
      loz: "\u25CA",
      spades: "\u2660",
      clubs: "\u2663",
      hearts: "\u2665",
      diams: "\u2666"
    });
    exports.entityMap = exports.HTML_ENTITIES;
  }
});

// node_modules/@xmldom/xmldom/lib/sax.js
var require_sax = __commonJS({
  "node_modules/@xmldom/xmldom/lib/sax.js"(exports) {
    var NAMESPACE = require_conventions().NAMESPACE;
    var nameStartChar = /[A-Z_a-z\xC0-\xD6\xD8-\xF6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/;
    var nameChar = new RegExp("[\\-\\.0-9" + nameStartChar.source.slice(1, -1) + "\\u00B7\\u0300-\\u036F\\u203F-\\u2040]");
    var tagNamePattern = new RegExp("^" + nameStartChar.source + nameChar.source + "*(?::" + nameStartChar.source + nameChar.source + "*)?$");
    var S_TAG = 0;
    var S_ATTR = 1;
    var S_ATTR_SPACE = 2;
    var S_EQ = 3;
    var S_ATTR_NOQUOT_VALUE = 4;
    var S_ATTR_END = 5;
    var S_TAG_SPACE = 6;
    var S_TAG_CLOSE = 7;
    function ParseError(message, locator) {
      this.message = message;
      this.locator = locator;
      if (Error.captureStackTrace)
        Error.captureStackTrace(this, ParseError);
    }
    ParseError.prototype = new Error();
    ParseError.prototype.name = ParseError.name;
    function XMLReader() {
    }
    XMLReader.prototype = {
      parse: function(source, defaultNSMap, entityMap) {
        var domBuilder = this.domBuilder;
        domBuilder.startDocument();
        _copy(defaultNSMap, defaultNSMap = {});
        parse(source, defaultNSMap, entityMap, domBuilder, this.errorHandler);
        domBuilder.endDocument();
      }
    };
    function parse(source, defaultNSMapCopy, entityMap, domBuilder, errorHandler) {
      function fixedFromCharCode(code) {
        if (code > 65535) {
          code -= 65536;
          var surrogate1 = 55296 + (code >> 10), surrogate2 = 56320 + (code & 1023);
          return String.fromCharCode(surrogate1, surrogate2);
        } else {
          return String.fromCharCode(code);
        }
      }
      function entityReplacer(a2) {
        var k = a2.slice(1, -1);
        if (k in entityMap) {
          return entityMap[k];
        } else if (k.charAt(0) === "#") {
          return fixedFromCharCode(parseInt(k.substr(1).replace("x", "0x")));
        } else {
          errorHandler.error("entity not found:" + a2);
          return a2;
        }
      }
      function appendText(end2) {
        if (end2 > start) {
          var xt = source.substring(start, end2).replace(/&#?\w+;/g, entityReplacer);
          locator && position(start);
          domBuilder.characters(xt, 0, end2 - start);
          start = end2;
        }
      }
      function position(p, m) {
        while (p >= lineEnd && (m = linePattern.exec(source))) {
          lineStart = m.index;
          lineEnd = lineStart + m[0].length;
          locator.lineNumber++;
        }
        locator.columnNumber = p - lineStart + 1;
      }
      var lineStart = 0;
      var lineEnd = 0;
      var linePattern = /.*(?:\r\n?|\n)|.*$/g;
      var locator = domBuilder.locator;
      var parseStack = [{ currentNSMap: defaultNSMapCopy }];
      var closeMap = {};
      var start = 0;
      while (true) {
        try {
          var tagStart = source.indexOf("<", start);
          if (tagStart < 0) {
            if (!source.substr(start).match(/^\s*$/)) {
              var doc = domBuilder.doc;
              var text = doc.createTextNode(source.substr(start));
              doc.appendChild(text);
              domBuilder.currentElement = text;
            }
            return;
          }
          if (tagStart > start) {
            appendText(tagStart);
          }
          switch (source.charAt(tagStart + 1)) {
            case "/":
              var end = source.indexOf(">", tagStart + 3);
              var tagName = source.substring(tagStart + 2, end).replace(/[ \t\n\r]+$/g, "");
              var config = parseStack.pop();
              if (end < 0) {
                tagName = source.substring(tagStart + 2).replace(/[\s<].*/, "");
                errorHandler.error("end tag name: " + tagName + " is not complete:" + config.tagName);
                end = tagStart + 1 + tagName.length;
              } else if (tagName.match(/\s</)) {
                tagName = tagName.replace(/[\s<].*/, "");
                errorHandler.error("end tag name: " + tagName + " maybe not complete");
                end = tagStart + 1 + tagName.length;
              }
              var localNSMap = config.localNSMap;
              var endMatch = config.tagName == tagName;
              var endIgnoreCaseMach = endMatch || config.tagName && config.tagName.toLowerCase() == tagName.toLowerCase();
              if (endIgnoreCaseMach) {
                domBuilder.endElement(config.uri, config.localName, tagName);
                if (localNSMap) {
                  for (var prefix in localNSMap) {
                    domBuilder.endPrefixMapping(prefix);
                  }
                }
                if (!endMatch) {
                  errorHandler.fatalError("end tag name: " + tagName + " is not match the current start tagName:" + config.tagName);
                }
              } else {
                parseStack.push(config);
              }
              end++;
              break;
            case "?":
              locator && position(tagStart);
              end = parseInstruction(source, tagStart, domBuilder);
              break;
            case "!":
              locator && position(tagStart);
              end = parseDCC(source, tagStart, domBuilder, errorHandler);
              break;
            default:
              locator && position(tagStart);
              var el = new ElementAttributes();
              var currentNSMap = parseStack[parseStack.length - 1].currentNSMap;
              var end = parseElementStartPart(source, tagStart, el, currentNSMap, entityReplacer, errorHandler);
              var len = el.length;
              if (!el.closed && fixSelfClosed(source, end, el.tagName, closeMap)) {
                el.closed = true;
                if (!entityMap.nbsp) {
                  errorHandler.warning("unclosed xml attribute");
                }
              }
              if (locator && len) {
                var locator2 = copyLocator(locator, {});
                for (var i = 0; i < len; i++) {
                  var a = el[i];
                  position(a.offset);
                  a.locator = copyLocator(locator, {});
                }
                domBuilder.locator = locator2;
                if (appendElement(el, domBuilder, currentNSMap)) {
                  parseStack.push(el);
                }
                domBuilder.locator = locator;
              } else {
                if (appendElement(el, domBuilder, currentNSMap)) {
                  parseStack.push(el);
                }
              }
              if (NAMESPACE.isHTML(el.uri) && !el.closed) {
                end = parseHtmlSpecialContent(source, end, el.tagName, entityReplacer, domBuilder);
              } else {
                end++;
              }
          }
        } catch (e) {
          if (e instanceof ParseError) {
            throw e;
          }
          errorHandler.error("element parse error: " + e);
          end = -1;
        }
        if (end > start) {
          start = end;
        } else {
          appendText(Math.max(tagStart, start) + 1);
        }
      }
    }
    function copyLocator(f, t) {
      t.lineNumber = f.lineNumber;
      t.columnNumber = f.columnNumber;
      return t;
    }
    function parseElementStartPart(source, start, el, currentNSMap, entityReplacer, errorHandler) {
      function addAttribute(qname, value2, startIndex) {
        if (el.attributeNames.hasOwnProperty(qname)) {
          errorHandler.fatalError("Attribute " + qname + " redefined");
        }
        el.addValue(qname, value2, startIndex);
      }
      var attrName;
      var value;
      var p = ++start;
      var s = S_TAG;
      while (true) {
        var c = source.charAt(p);
        switch (c) {
          case "=":
            if (s === S_ATTR) {
              attrName = source.slice(start, p);
              s = S_EQ;
            } else if (s === S_ATTR_SPACE) {
              s = S_EQ;
            } else {
              throw new Error("attribute equal must after attrName");
            }
            break;
          case "'":
          case '"':
            if (s === S_EQ || s === S_ATTR) {
              if (s === S_ATTR) {
                errorHandler.warning('attribute value must after "="');
                attrName = source.slice(start, p);
              }
              start = p + 1;
              p = source.indexOf(c, start);
              if (p > 0) {
                value = source.slice(start, p).replace(/&#?\w+;/g, entityReplacer);
                addAttribute(attrName, value, start - 1);
                s = S_ATTR_END;
              } else {
                throw new Error("attribute value no end '" + c + "' match");
              }
            } else if (s == S_ATTR_NOQUOT_VALUE) {
              value = source.slice(start, p).replace(/&#?\w+;/g, entityReplacer);
              addAttribute(attrName, value, start);
              errorHandler.warning('attribute "' + attrName + '" missed start quot(' + c + ")!!");
              start = p + 1;
              s = S_ATTR_END;
            } else {
              throw new Error('attribute value must after "="');
            }
            break;
          case "/":
            switch (s) {
              case S_TAG:
                el.setTagName(source.slice(start, p));
              case S_ATTR_END:
              case S_TAG_SPACE:
              case S_TAG_CLOSE:
                s = S_TAG_CLOSE;
                el.closed = true;
              case S_ATTR_NOQUOT_VALUE:
              case S_ATTR:
              case S_ATTR_SPACE:
                break;
              default:
                throw new Error("attribute invalid close char('/')");
            }
            break;
          case "":
            errorHandler.error("unexpected end of input");
            if (s == S_TAG) {
              el.setTagName(source.slice(start, p));
            }
            return p;
          case ">":
            switch (s) {
              case S_TAG:
                el.setTagName(source.slice(start, p));
              case S_ATTR_END:
              case S_TAG_SPACE:
              case S_TAG_CLOSE:
                break;
              case S_ATTR_NOQUOT_VALUE:
              case S_ATTR:
                value = source.slice(start, p);
                if (value.slice(-1) === "/") {
                  el.closed = true;
                  value = value.slice(0, -1);
                }
              case S_ATTR_SPACE:
                if (s === S_ATTR_SPACE) {
                  value = attrName;
                }
                if (s == S_ATTR_NOQUOT_VALUE) {
                  errorHandler.warning('attribute "' + value + '" missed quot(")!');
                  addAttribute(attrName, value.replace(/&#?\w+;/g, entityReplacer), start);
                } else {
                  if (!NAMESPACE.isHTML(currentNSMap[""]) || !value.match(/^(?:disabled|checked|selected)$/i)) {
                    errorHandler.warning('attribute "' + value + '" missed value!! "' + value + '" instead!!');
                  }
                  addAttribute(value, value, start);
                }
                break;
              case S_EQ:
                throw new Error("attribute value missed!!");
            }
            return p;
          case "\x80":
            c = " ";
          default:
            if (c <= " ") {
              switch (s) {
                case S_TAG:
                  el.setTagName(source.slice(start, p));
                  s = S_TAG_SPACE;
                  break;
                case S_ATTR:
                  attrName = source.slice(start, p);
                  s = S_ATTR_SPACE;
                  break;
                case S_ATTR_NOQUOT_VALUE:
                  var value = source.slice(start, p).replace(/&#?\w+;/g, entityReplacer);
                  errorHandler.warning('attribute "' + value + '" missed quot(")!!');
                  addAttribute(attrName, value, start);
                case S_ATTR_END:
                  s = S_TAG_SPACE;
                  break;
              }
            } else {
              switch (s) {
                case S_ATTR_SPACE:
                  var tagName = el.tagName;
                  if (!NAMESPACE.isHTML(currentNSMap[""]) || !attrName.match(/^(?:disabled|checked|selected)$/i)) {
                    errorHandler.warning('attribute "' + attrName + '" missed value!! "' + attrName + '" instead2!!');
                  }
                  addAttribute(attrName, attrName, start);
                  start = p;
                  s = S_ATTR;
                  break;
                case S_ATTR_END:
                  errorHandler.warning('attribute space is required"' + attrName + '"!!');
                case S_TAG_SPACE:
                  s = S_ATTR;
                  start = p;
                  break;
                case S_EQ:
                  s = S_ATTR_NOQUOT_VALUE;
                  start = p;
                  break;
                case S_TAG_CLOSE:
                  throw new Error("elements closed character '/' and '>' must be connected to");
              }
            }
        }
        p++;
      }
    }
    function appendElement(el, domBuilder, currentNSMap) {
      var tagName = el.tagName;
      var localNSMap = null;
      var i = el.length;
      while (i--) {
        var a = el[i];
        var qName = a.qName;
        var value = a.value;
        var nsp = qName.indexOf(":");
        if (nsp > 0) {
          var prefix = a.prefix = qName.slice(0, nsp);
          var localName = qName.slice(nsp + 1);
          var nsPrefix = prefix === "xmlns" && localName;
        } else {
          localName = qName;
          prefix = null;
          nsPrefix = qName === "xmlns" && "";
        }
        a.localName = localName;
        if (nsPrefix !== false) {
          if (localNSMap == null) {
            localNSMap = {};
            _copy(currentNSMap, currentNSMap = {});
          }
          currentNSMap[nsPrefix] = localNSMap[nsPrefix] = value;
          a.uri = NAMESPACE.XMLNS;
          domBuilder.startPrefixMapping(nsPrefix, value);
        }
      }
      var i = el.length;
      while (i--) {
        a = el[i];
        var prefix = a.prefix;
        if (prefix) {
          if (prefix === "xml") {
            a.uri = NAMESPACE.XML;
          }
          if (prefix !== "xmlns") {
            a.uri = currentNSMap[prefix || ""];
          }
        }
      }
      var nsp = tagName.indexOf(":");
      if (nsp > 0) {
        prefix = el.prefix = tagName.slice(0, nsp);
        localName = el.localName = tagName.slice(nsp + 1);
      } else {
        prefix = null;
        localName = el.localName = tagName;
      }
      var ns = el.uri = currentNSMap[prefix || ""];
      domBuilder.startElement(ns, localName, tagName, el);
      if (el.closed) {
        domBuilder.endElement(ns, localName, tagName);
        if (localNSMap) {
          for (prefix in localNSMap) {
            domBuilder.endPrefixMapping(prefix);
          }
        }
      } else {
        el.currentNSMap = currentNSMap;
        el.localNSMap = localNSMap;
        return true;
      }
    }
    function parseHtmlSpecialContent(source, elStartEnd, tagName, entityReplacer, domBuilder) {
      if (/^(?:script|textarea)$/i.test(tagName)) {
        var elEndStart = source.indexOf("</" + tagName + ">", elStartEnd);
        var text = source.substring(elStartEnd + 1, elEndStart);
        if (/[&<]/.test(text)) {
          if (/^script$/i.test(tagName)) {
            domBuilder.characters(text, 0, text.length);
            return elEndStart;
          }
          text = text.replace(/&#?\w+;/g, entityReplacer);
          domBuilder.characters(text, 0, text.length);
          return elEndStart;
        }
      }
      return elStartEnd + 1;
    }
    function fixSelfClosed(source, elStartEnd, tagName, closeMap) {
      var pos = closeMap[tagName];
      if (pos == null) {
        pos = source.lastIndexOf("</" + tagName + ">");
        if (pos < elStartEnd) {
          pos = source.lastIndexOf("</" + tagName);
        }
        closeMap[tagName] = pos;
      }
      return pos < elStartEnd;
    }
    function _copy(source, target) {
      for (var n in source) {
        target[n] = source[n];
      }
    }
    function parseDCC(source, start, domBuilder, errorHandler) {
      var next = source.charAt(start + 2);
      switch (next) {
        case "-":
          if (source.charAt(start + 3) === "-") {
            var end = source.indexOf("-->", start + 4);
            if (end > start) {
              domBuilder.comment(source, start + 4, end - start - 4);
              return end + 3;
            } else {
              errorHandler.error("Unclosed comment");
              return -1;
            }
          } else {
            return -1;
          }
        default:
          if (source.substr(start + 3, 6) == "CDATA[") {
            var end = source.indexOf("]]>", start + 9);
            domBuilder.startCDATA();
            domBuilder.characters(source, start + 9, end - start - 9);
            domBuilder.endCDATA();
            return end + 3;
          }
          var matchs = split(source, start);
          var len = matchs.length;
          if (len > 1 && /!doctype/i.test(matchs[0][0])) {
            var name = matchs[1][0];
            var pubid = false;
            var sysid = false;
            if (len > 3) {
              if (/^public$/i.test(matchs[2][0])) {
                pubid = matchs[3][0];
                sysid = len > 4 && matchs[4][0];
              } else if (/^system$/i.test(matchs[2][0])) {
                sysid = matchs[3][0];
              }
            }
            var lastMatch = matchs[len - 1];
            domBuilder.startDTD(name, pubid, sysid);
            domBuilder.endDTD();
            return lastMatch.index + lastMatch[0].length;
          }
      }
      return -1;
    }
    function parseInstruction(source, start, domBuilder) {
      var end = source.indexOf("?>", start);
      if (end) {
        var match = source.substring(start, end).match(/^<\?(\S*)\s*([\s\S]*?)\s*$/);
        if (match) {
          var len = match[0].length;
          domBuilder.processingInstruction(match[1], match[2]);
          return end + 2;
        } else {
          return -1;
        }
      }
      return -1;
    }
    function ElementAttributes() {
      this.attributeNames = {};
    }
    ElementAttributes.prototype = {
      setTagName: function(tagName) {
        if (!tagNamePattern.test(tagName)) {
          throw new Error("invalid tagName:" + tagName);
        }
        this.tagName = tagName;
      },
      addValue: function(qName, value, offset) {
        if (!tagNamePattern.test(qName)) {
          throw new Error("invalid attribute:" + qName);
        }
        this.attributeNames[qName] = this.length;
        this[this.length++] = { qName, value, offset };
      },
      length: 0,
      getLocalName: function(i) {
        return this[i].localName;
      },
      getLocator: function(i) {
        return this[i].locator;
      },
      getQName: function(i) {
        return this[i].qName;
      },
      getURI: function(i) {
        return this[i].uri;
      },
      getValue: function(i) {
        return this[i].value;
      }
    };
    function split(source, start) {
      var match;
      var buf = [];
      var reg = /'[^']+'|"[^"]+"|[^\s<>\/=]+=?|(\/?\s*>|<)/g;
      reg.lastIndex = start;
      reg.exec(source);
      while (match = reg.exec(source)) {
        buf.push(match);
        if (match[1])
          return buf;
      }
    }
    exports.XMLReader = XMLReader;
    exports.ParseError = ParseError;
  }
});

// node_modules/@xmldom/xmldom/lib/dom-parser.js
var require_dom_parser = __commonJS({
  "node_modules/@xmldom/xmldom/lib/dom-parser.js"(exports) {
    var conventions = require_conventions();
    var dom = require_dom();
    var entities = require_entities();
    var sax = require_sax();
    var DOMImplementation = dom.DOMImplementation;
    var NAMESPACE = conventions.NAMESPACE;
    var ParseError = sax.ParseError;
    var XMLReader = sax.XMLReader;
    function DOMParser(options) {
      this.options = options || { locator: {} };
    }
    DOMParser.prototype.parseFromString = function(source, mimeType) {
      var options = this.options;
      var sax2 = new XMLReader();
      var domBuilder = options.domBuilder || new DOMHandler();
      var errorHandler = options.errorHandler;
      var locator = options.locator;
      var defaultNSMap = options.xmlns || {};
      var isHTML = /\/x?html?$/.test(mimeType);
      var entityMap = isHTML ? entities.HTML_ENTITIES : entities.XML_ENTITIES;
      if (locator) {
        domBuilder.setDocumentLocator(locator);
      }
      sax2.errorHandler = buildErrorHandler(errorHandler, domBuilder, locator);
      sax2.domBuilder = options.domBuilder || domBuilder;
      if (isHTML) {
        defaultNSMap[""] = NAMESPACE.HTML;
      }
      defaultNSMap.xml = defaultNSMap.xml || NAMESPACE.XML;
      if (source && typeof source === "string") {
        sax2.parse(source, defaultNSMap, entityMap);
      } else {
        sax2.errorHandler.error("invalid doc source");
      }
      return domBuilder.doc;
    };
    function buildErrorHandler(errorImpl, domBuilder, locator) {
      if (!errorImpl) {
        if (domBuilder instanceof DOMHandler) {
          return domBuilder;
        }
        errorImpl = domBuilder;
      }
      var errorHandler = {};
      var isCallback = errorImpl instanceof Function;
      locator = locator || {};
      function build(key) {
        var fn = errorImpl[key];
        if (!fn && isCallback) {
          fn = errorImpl.length == 2 ? function(msg) {
            errorImpl(key, msg);
          } : errorImpl;
        }
        errorHandler[key] = fn && function(msg) {
          fn("[xmldom " + key + "]	" + msg + _locator(locator));
        } || function() {
        };
      }
      build("warning");
      build("error");
      build("fatalError");
      return errorHandler;
    }
    function DOMHandler() {
      this.cdata = false;
    }
    function position(locator, node) {
      node.lineNumber = locator.lineNumber;
      node.columnNumber = locator.columnNumber;
    }
    DOMHandler.prototype = {
      startDocument: function() {
        this.doc = new DOMImplementation().createDocument(null, null, null);
        if (this.locator) {
          this.doc.documentURI = this.locator.systemId;
        }
      },
      startElement: function(namespaceURI, localName, qName, attrs) {
        var doc = this.doc;
        var el = doc.createElementNS(namespaceURI, qName || localName);
        var len = attrs.length;
        appendElement(this, el);
        this.currentElement = el;
        this.locator && position(this.locator, el);
        for (var i = 0; i < len; i++) {
          var namespaceURI = attrs.getURI(i);
          var value = attrs.getValue(i);
          var qName = attrs.getQName(i);
          var attr = doc.createAttributeNS(namespaceURI, qName);
          this.locator && position(attrs.getLocator(i), attr);
          attr.value = attr.nodeValue = value;
          el.setAttributeNode(attr);
        }
      },
      endElement: function(namespaceURI, localName, qName) {
        var current = this.currentElement;
        var tagName = current.tagName;
        this.currentElement = current.parentNode;
      },
      startPrefixMapping: function(prefix, uri) {
      },
      endPrefixMapping: function(prefix) {
      },
      processingInstruction: function(target, data) {
        var ins = this.doc.createProcessingInstruction(target, data);
        this.locator && position(this.locator, ins);
        appendElement(this, ins);
      },
      ignorableWhitespace: function(ch, start, length) {
      },
      characters: function(chars, start, length) {
        chars = _toString.apply(this, arguments);
        if (chars) {
          if (this.cdata) {
            var charNode = this.doc.createCDATASection(chars);
          } else {
            var charNode = this.doc.createTextNode(chars);
          }
          if (this.currentElement) {
            this.currentElement.appendChild(charNode);
          } else if (/^\s*$/.test(chars)) {
            this.doc.appendChild(charNode);
          }
          this.locator && position(this.locator, charNode);
        }
      },
      skippedEntity: function(name) {
      },
      endDocument: function() {
        this.doc.normalize();
      },
      setDocumentLocator: function(locator) {
        if (this.locator = locator) {
          locator.lineNumber = 0;
        }
      },
      comment: function(chars, start, length) {
        chars = _toString.apply(this, arguments);
        var comm = this.doc.createComment(chars);
        this.locator && position(this.locator, comm);
        appendElement(this, comm);
      },
      startCDATA: function() {
        this.cdata = true;
      },
      endCDATA: function() {
        this.cdata = false;
      },
      startDTD: function(name, publicId, systemId) {
        var impl = this.doc.implementation;
        if (impl && impl.createDocumentType) {
          var dt = impl.createDocumentType(name, publicId, systemId);
          this.locator && position(this.locator, dt);
          appendElement(this, dt);
          this.doc.doctype = dt;
        }
      },
      warning: function(error) {
        console.warn("[xmldom warning]	" + error, _locator(this.locator));
      },
      error: function(error) {
        console.error("[xmldom error]	" + error, _locator(this.locator));
      },
      fatalError: function(error) {
        throw new ParseError(error, this.locator);
      }
    };
    function _locator(l) {
      if (l) {
        return "\n@" + (l.systemId || "") + "#[line:" + l.lineNumber + ",col:" + l.columnNumber + "]";
      }
    }
    function _toString(chars, start, length) {
      if (typeof chars == "string") {
        return chars.substr(start, length);
      } else {
        if (chars.length >= start + length || start) {
          return new java.lang.String(chars, start, length) + "";
        }
        return chars;
      }
    }
    "endDTD,startEntity,endEntity,attributeDecl,elementDecl,externalEntityDecl,internalEntityDecl,resolveEntity,getExternalSubset,notationDecl,unparsedEntityDecl".replace(/\w+/g, function(key) {
      DOMHandler.prototype[key] = function() {
        return null;
      };
    });
    function appendElement(hander, node) {
      if (!hander.currentElement) {
        hander.doc.appendChild(node);
      } else {
        hander.currentElement.appendChild(node);
      }
    }
    exports.__DOMHandler = DOMHandler;
    exports.DOMParser = DOMParser;
    exports.DOMImplementation = dom.DOMImplementation;
    exports.XMLSerializer = dom.XMLSerializer;
  }
});

// node_modules/@xmldom/xmldom/lib/index.js
var require_lib9 = __commonJS({
  "node_modules/@xmldom/xmldom/lib/index.js"(exports) {
    var dom = require_dom();
    exports.DOMImplementation = dom.DOMImplementation;
    exports.XMLSerializer = dom.XMLSerializer;
    exports.DOMParser = require_dom_parser().DOMParser;
  }
});

// node_modules/jsii-rosetta/lib/markdown/xml-comment-renderer.js
var require_xml_comment_renderer = __commonJS({
  "node_modules/jsii-rosetta/lib/markdown/xml-comment-renderer.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.CSharpXmlCommentRenderer = void 0;
    var escapes_1 = require_escapes();
    var markdown_1 = require_markdown();
    var markdown_renderer_1 = require_markdown_renderer();
    var ESCAPE = escapes_1.makeXmlEscaper();
    var { DOMParser, XMLSerializer } = require_lib9();
    var CSharpXmlCommentRenderer = class extends markdown_renderer_1.MarkdownRenderer {
      block_quote(_node, context) {
        return markdown_renderer_1.para(markdown_1.prefixLines("    ", markdown_renderer_1.stripPara(context.content())));
      }
      code(node, _context) {
        return `<c>${ESCAPE.text(node.literal)}</c>`;
      }
      code_block(node, _context) {
        return markdown_renderer_1.para(`<code><![CDATA[
${node.literal}]]></code>`);
      }
      text(node, _context) {
        var _a;
        return (_a = ESCAPE.text(node.literal)) !== null && _a !== void 0 ? _a : "";
      }
      link(node, context) {
        var _a;
        return `<a href="${(_a = ESCAPE.attribute(node.destination)) !== null && _a !== void 0 ? _a : ""}">${context.content()}</a>`;
      }
      image(node, context) {
        var _a;
        return `<img alt="${ESCAPE.text2attr(context.content())}" src="${(_a = ESCAPE.attribute(node.destination)) !== null && _a !== void 0 ? _a : ""}" />`;
      }
      emph(_node, context) {
        return `<em>${context.content()}</em>`;
      }
      strong(_node, context) {
        return `<strong>${context.content()}</strong>`;
      }
      heading(node, context) {
        return markdown_renderer_1.para(`<h${node.level}>${context.content()}</h${node.level}>`);
      }
      list(node, context) {
        const listType = node.listType === "bullet" ? "bullet" : "number";
        return markdown_renderer_1.para(`<list type="${listType}">
${context.content()}</list>`);
      }
      item(_node, context) {
        return `<description>${markdown_renderer_1.stripPara(context.content())}</description>
`;
      }
      thematic_break(_node, _context) {
        return markdown_renderer_1.para("<hr />");
      }
      html_inline(node, _context) {
        var _a;
        const html = (_a = node.literal) !== null && _a !== void 0 ? _a : "";
        try {
          const doc = new DOMParser().parseFromString(html, "text/html");
          return new XMLSerializer().serializeToString(doc);
        } catch {
          return html.replace(/[<>&]/g, (char) => {
            switch (char) {
              case "&":
                return "&amp;";
              case "<":
                return "&lt;";
              case ">":
                return "&gt;";
              default:
                return char;
            }
          });
        }
      }
      html_block(node, context) {
        return this.html_inline(node, context);
      }
    };
    exports.CSharpXmlCommentRenderer = CSharpXmlCommentRenderer;
  }
});

// node_modules/jsii-rosetta/lib/markdown/index.js
var require_markdown2 = __commonJS({
  "node_modules/jsii-rosetta/lib/markdown/index.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.markDownToXmlDoc = exports.markDownToJavaDoc = exports.markDownToStructure = void 0;
    var javadoc_renderer_1 = require_javadoc_renderer();
    var markdown_1 = require_markdown();
    var structure_renderer_1 = require_structure_renderer();
    var xml_comment_renderer_1 = require_xml_comment_renderer();
    function markDownToStructure(source) {
      return markdown_1.transformMarkdown(source, new structure_renderer_1.StructureRenderer());
    }
    exports.markDownToStructure = markDownToStructure;
    function markDownToJavaDoc(source) {
      return markdown_1.transformMarkdown(source, new javadoc_renderer_1.JavaDocRenderer());
    }
    exports.markDownToJavaDoc = markDownToJavaDoc;
    function markDownToXmlDoc(source) {
      return markdown_1.transformMarkdown(source, new xml_comment_renderer_1.CSharpXmlCommentRenderer());
    }
    exports.markDownToXmlDoc = markDownToXmlDoc;
  }
});

// node_modules/jsii-rosetta/lib/index.js
var require_lib10 = __commonJS({
  "node_modules/jsii-rosetta/lib/index.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        if (p !== "default" && !exports2.hasOwnProperty(p))
          __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    __exportStar(require_translate(), exports);
    var o_tree_1 = require_o_tree();
    Object.defineProperty(exports, "renderTree", { enumerable: true, get: function() {
      return o_tree_1.renderTree;
    } });
    var target_language_1 = require_target_language();
    Object.defineProperty(exports, "TargetLanguage", { enumerable: true, get: function() {
      return target_language_1.TargetLanguage;
    } });
    var csharp_1 = require_csharp();
    Object.defineProperty(exports, "CSharpVisitor", { enumerable: true, get: function() {
      return csharp_1.CSharpVisitor;
    } });
    var java_1 = require_java();
    Object.defineProperty(exports, "JavaVisitor", { enumerable: true, get: function() {
      return java_1.JavaVisitor;
    } });
    var python_1 = require_python();
    Object.defineProperty(exports, "PythonVisitor", { enumerable: true, get: function() {
      return python_1.PythonVisitor;
    } });
    __exportStar(require_tablets(), exports);
    __exportStar(require_rosetta(), exports);
    __exportStar(require_snippet(), exports);
    __exportStar(require_markdown2(), exports);
    __exportStar(require_strict(), exports);
  }
});

// node_modules/jsii-rosetta/lib/commands/transliterate.js
var require_transliterate = __commonJS({
  "node_modules/jsii-rosetta/lib/commands/transliterate.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.transliterateAssembly = void 0;
    var spec_1 = require_lib5();
    var fs_extra_1 = require_lib8();
    var path_1 = require("path");
    var fixtures_1 = require_fixtures();
    var logging_1 = require_logging();
    var rosetta_1 = require_rosetta();
    var snippet_1 = require_snippet();
    async function transliterateAssembly(assemblyLocations, targetLanguages, options = {}) {
      var _a, _b;
      const rosetta = new rosetta_1.Rosetta({
        includeCompilerDiagnostics: true,
        liveConversion: true,
        loose: options.loose,
        targetLanguages
      });
      if (options.tablet) {
        await rosetta.loadTabletFromFile(options.tablet);
      }
      const assemblies = await loadAssemblies(assemblyLocations, rosetta);
      for (const [location, loadAssembly] of assemblies.entries()) {
        for (const language of targetLanguages) {
          const now = new Date().getTime();
          const result = await loadAssembly();
          if ((_a = result.readme) === null || _a === void 0 ? void 0 : _a.markdown) {
            result.readme.markdown = rosetta.translateSnippetsInMarkdown(result.readme.markdown, language, true, (translation) => ({
              language: translation.language,
              source: prefixDisclaimer(translation)
            }), location);
          }
          for (const type of Object.values((_b = result.types) !== null && _b !== void 0 ? _b : {})) {
            transliterateType(type, rosetta, language, location, options.loose);
          }
          await fs_extra_1.writeJson(path_1.resolve(location, `${spec_1.SPEC_FILE_NAME}.${language}`), result, { spaces: 2 });
          const then = new Date().getTime();
          logging_1.debug(`Done transliterating ${result.name}@${result.version} to ${language} after ${then - now} milliseconds`);
        }
      }
      rosetta.printDiagnostics(process.stderr);
      if (rosetta.hasErrors && options.strict) {
        throw new Error("Strict mode is enabled and some examples failed compilation!");
      }
    }
    exports.transliterateAssembly = transliterateAssembly;
    async function loadAssemblies(directories, rosetta) {
      const result = new Map();
      for (const directory of directories) {
        const loader = () => fs_extra_1.readJson(path_1.resolve(directory, spec_1.SPEC_FILE_NAME));
        await rosetta.addAssembly(await loader(), directory);
        result.set(directory, loader);
      }
      return result;
    }
    function prefixDisclaimer(translation) {
      const comment = commentToken();
      const disclaimer = translation.didCompile ? "This example was automatically transliterated." : "This example was automatically transliterated with incomplete type information. It may not work as-is.";
      return [
        `${comment} ${disclaimer}`,
        `${comment} See https://github.com/aws/jsii/issues/826 for more information.`,
        "",
        translation.source
      ].join("\n");
      function commentToken() {
        switch (translation.language) {
          case "python":
          case "ruby":
            return "#";
          case "csharp":
          case "java":
          case "go":
          default:
            return "//";
        }
      }
    }
    function transliterateType(type, rosetta, language, workingDirectory, loose = false) {
      var _a, _b, _c, _d;
      transliterateDocs(type.docs);
      switch (type.kind) {
        case spec_1.TypeKind.Class:
          transliterateDocs((_a = type === null || type === void 0 ? void 0 : type.initializer) === null || _a === void 0 ? void 0 : _a.docs);
        case spec_1.TypeKind.Interface:
          for (const method of (_b = type.methods) !== null && _b !== void 0 ? _b : []) {
            transliterateDocs(method.docs);
            for (const parameter of (_c = method.parameters) !== null && _c !== void 0 ? _c : []) {
              transliterateDocs(parameter.docs);
            }
          }
          for (const property of (_d = type.properties) !== null && _d !== void 0 ? _d : []) {
            transliterateDocs(property.docs);
          }
          break;
        case spec_1.TypeKind.Enum:
          for (const member of type.members) {
            transliterateDocs(member.docs);
          }
          break;
        default:
          throw new Error(`Unsupported type kind: ${type.kind}`);
      }
      function transliterateDocs(docs) {
        if (docs === null || docs === void 0 ? void 0 : docs.example) {
          const snippet = fixtures_1.fixturize(snippet_1.typeScriptSnippetFromSource(docs.example, "example", true, {
            [snippet_1.SnippetParameters.$PROJECT_DIRECTORY]: workingDirectory
          }), loose);
          const translation = rosetta.translateSnippet(snippet, language);
          if (translation != null) {
            docs.example = prefixDisclaimer(translation);
          }
        }
      }
    }
  }
});

// node_modules/jsii-docgen/lib/docgen/render/markdown.js
var require_markdown3 = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/render/markdown.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Markdown = void 0;
    var sanitize2 = (input) => {
      return input.toLowerCase().replace(/[^a-zA-Z0-9 ]/g, "").replace(/ /g, "-");
    };
    var Markdown = class {
      constructor(options = {}) {
        var _a, _b;
        this.options = options;
        this._lines = new Array();
        this._sections = new Array();
        this.id = (_a = options.id) !== null && _a !== void 0 ? _a : (_b = options.header) === null || _b === void 0 ? void 0 : _b.title;
        this.header = this.formatHeader();
      }
      static sanitize(line) {
        let sanitized = line.trim();
        if (line.startsWith("-")) {
          sanitized = sanitized.substring(1, line.length).trim();
        }
        return sanitized;
      }
      static bold(text) {
        return `**${text}**`;
      }
      static pre(text) {
        return `\`${text}\``;
      }
      static italic(text) {
        return `*${text}*`;
      }
      docs(docs) {
        if (docs.summary) {
          this.lines(Markdown.sanitize(docs.summary));
          this.lines("");
        }
        if (docs.remarks) {
          this.lines(Markdown.sanitize(docs.remarks));
          this.lines("");
        }
        if (docs.docs.see) {
          this.quote(docs.docs.see);
        }
        const customLink = docs.customTag("link");
        if (customLink) {
          this.quote(`[${customLink}](${customLink})`);
        }
      }
      quote(line) {
        this.lines(`> ${line}`);
        this.lines("");
      }
      bullet(line) {
        this.lines(`- ${line}`);
      }
      code(language, ...snippet) {
        this.lines(`\`\`\`${language}`, ...snippet, "```");
        this.lines("");
      }
      lines(...lines) {
        this._lines.push(...lines);
      }
      split() {
        this.lines("---");
        this.lines("");
      }
      section(section) {
        this._sections.push(section);
      }
      render(headerSize = 0) {
        var _a;
        if (headerSize > 6) {
          throw new Error("Unable to render markdown. Header limit (6) reached.");
        }
        const content = [];
        if (this.header) {
          const anchor = sanitize2((_a = this.id) !== null && _a !== void 0 ? _a : "");
          const heading = `${"#".repeat(headerSize)} ${this.header}`;
          const headerSpan = !!process.env.HEADER_SPAN;
          if (headerSpan) {
            content.push(`${heading} <span data-heading-title="${this.header}" data-heading-id="${anchor}"></span>`);
          } else {
            content.push(`${heading} <a name="${this.id}"></a>`);
          }
          content.push("");
        }
        for (const line of this._lines) {
          content.push(`${line}`);
        }
        for (const section of this._sections) {
          content.push(section.render(headerSize + 1));
        }
        return content.join("\n");
      }
      formatHeader() {
        var _a, _b, _c, _d, _e, _f, _g;
        if (!((_a = this.options.header) === null || _a === void 0 ? void 0 : _a.title)) {
          return void 0;
        }
        let caption = this.options.header.title;
        if ((_c = (_b = this.options.header) === null || _b === void 0 ? void 0 : _b.pre) !== null && _c !== void 0 ? _c : false) {
          caption = `\`${caption}\``;
        }
        if ((_e = (_d = this.options.header) === null || _d === void 0 ? void 0 : _d.strike) !== null && _e !== void 0 ? _e : false) {
          caption = `~~${caption}~~`;
        }
        if ((_f = this.options.header) === null || _f === void 0 ? void 0 : _f.sup) {
          caption = `${caption}<sup>${(_g = this.options.header) === null || _g === void 0 ? void 0 : _g.sup}</sup>`;
        }
        return caption;
      }
    };
    exports.Markdown = Markdown;
    Markdown.EMPTY = new Markdown();
  }
});

// node_modules/case/dist/Case.js
var require_Case = __commonJS({
  "node_modules/case/dist/Case.js"(exports, module2) {
    (function() {
      "use strict";
      var unicodes = function(s, prefix) {
        prefix = prefix || "";
        return s.replace(/(^|-)/g, "$1\\u" + prefix).replace(/,/g, "\\u" + prefix);
      }, basicSymbols = unicodes("20-26,28-2F,3A-40,5B-60,7B-7E,A0-BF,D7,F7", "00"), baseLowerCase = "a-z" + unicodes("DF-F6,F8-FF", "00"), baseUpperCase = "A-Z" + unicodes("C0-D6,D8-DE", "00"), improperInTitle = "A|An|And|As|At|But|By|En|For|If|In|Of|On|Or|The|To|Vs?\\.?|Via", regexps = function(symbols, lowers, uppers, impropers) {
        symbols = symbols || basicSymbols;
        lowers = lowers || baseLowerCase;
        uppers = uppers || baseUpperCase;
        impropers = impropers || improperInTitle;
        return {
          capitalize: new RegExp("(^|[" + symbols + "])([" + lowers + "])", "g"),
          pascal: new RegExp("(^|[" + symbols + "])+([" + lowers + uppers + "])", "g"),
          fill: new RegExp("[" + symbols + "]+(.|$)", "g"),
          sentence: new RegExp('(^\\s*|[\\?\\!\\.]+"?\\s+"?|,\\s+")([' + lowers + "])", "g"),
          improper: new RegExp("\\b(" + impropers + ")\\b", "g"),
          relax: new RegExp("([^" + uppers + "])([" + uppers + "]*)([" + uppers + "])(?=[^" + uppers + "]|$)", "g"),
          upper: new RegExp("^[^" + lowers + "]+$"),
          hole: /[^\s]\s[^\s]/,
          apostrophe: /'/g,
          room: new RegExp("[" + symbols + "]")
        };
      }, re = regexps(), _ = {
        re,
        unicodes,
        regexps,
        types: [],
        up: String.prototype.toUpperCase,
        low: String.prototype.toLowerCase,
        cap: function(s) {
          return _.up.call(s.charAt(0)) + s.slice(1);
        },
        decap: function(s) {
          return _.low.call(s.charAt(0)) + s.slice(1);
        },
        deapostrophe: function(s) {
          return s.replace(re.apostrophe, "");
        },
        fill: function(s, fill, deapostrophe) {
          if (fill != null) {
            s = s.replace(re.fill, function(m, next) {
              return next ? fill + next : "";
            });
          }
          if (deapostrophe) {
            s = _.deapostrophe(s);
          }
          return s;
        },
        prep: function(s, fill, pascal, upper) {
          s = s == null ? "" : s + "";
          if (!upper && re.upper.test(s)) {
            s = _.low.call(s);
          }
          if (!fill && !re.hole.test(s)) {
            var holey = _.fill(s, " ");
            if (re.hole.test(holey)) {
              s = holey;
            }
          }
          if (!pascal && !re.room.test(s)) {
            s = s.replace(re.relax, _.relax);
          }
          return s;
        },
        relax: function(m, before, acronym, caps) {
          return before + " " + (acronym ? acronym + " " : "") + caps;
        }
      }, Case = {
        _,
        of: function(s) {
          for (var i = 0, m = _.types.length; i < m; i++) {
            if (Case[_.types[i]].apply(Case, arguments) === s) {
              return _.types[i];
            }
          }
        },
        flip: function(s) {
          return s.replace(/\w/g, function(l) {
            return (l == _.up.call(l) ? _.low : _.up).call(l);
          });
        },
        random: function(s) {
          return s.replace(/\w/g, function(l) {
            return (Math.round(Math.random()) ? _.up : _.low).call(l);
          });
        },
        type: function(type2, fn) {
          Case[type2] = fn;
          _.types.push(type2);
        }
      }, types = {
        lower: function(s, fill, deapostrophe) {
          return _.fill(_.low.call(_.prep(s, fill)), fill, deapostrophe);
        },
        snake: function(s) {
          return Case.lower(s, "_", true);
        },
        constant: function(s) {
          return Case.upper(s, "_", true);
        },
        camel: function(s) {
          return _.decap(Case.pascal(s));
        },
        kebab: function(s) {
          return Case.lower(s, "-", true);
        },
        upper: function(s, fill, deapostrophe) {
          return _.fill(_.up.call(_.prep(s, fill, false, true)), fill, deapostrophe);
        },
        capital: function(s, fill, deapostrophe) {
          return _.fill(_.prep(s).replace(re.capitalize, function(m, border, letter) {
            return border + _.up.call(letter);
          }), fill, deapostrophe);
        },
        header: function(s) {
          return Case.capital(s, "-", true);
        },
        pascal: function(s) {
          return _.fill(_.prep(s, false, true).replace(re.pascal, function(m, border, letter) {
            return _.up.call(letter);
          }), "", true);
        },
        title: function(s) {
          return Case.capital(s).replace(re.improper, function(small, p, i, s2) {
            return i > 0 && i < s2.lastIndexOf(" ") ? _.low.call(small) : small;
          });
        },
        sentence: function(s, names, abbreviations) {
          s = Case.lower(s).replace(re.sentence, function(m, prelude, letter) {
            return prelude + _.up.call(letter);
          });
          if (names) {
            names.forEach(function(name) {
              s = s.replace(new RegExp("\\b" + Case.lower(name) + "\\b", "g"), _.cap);
            });
          }
          if (abbreviations) {
            abbreviations.forEach(function(abbr) {
              s = s.replace(new RegExp("(\\b" + Case.lower(abbr) + "\\. +)(\\w)"), function(m, abbrAndSpace, letter) {
                return abbrAndSpace + _.low.call(letter);
              });
            });
          }
          return s;
        }
      };
      types.squish = types.pascal;
      Case.default = Case;
      for (var type in types) {
        Case.type(type, types[type]);
      }
      var define2 = typeof define2 === "function" ? define2 : function() {
      };
      define2(typeof module2 === "object" && module2.exports ? module2.exports = Case : this.Case = Case);
    }).call(exports);
  }
});

// node_modules/jsii-docgen/lib/docgen/transpile/transpile.js
var require_transpile = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/transpile/transpile.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.TranspileBase = exports.TranspiledTypeReference = exports.UnsupportedLanguageError = exports.Language = void 0;
    var Language2 = class {
      constructor(lang) {
        this.lang = lang;
      }
      static fromString(lang) {
        switch (lang) {
          case Language2.TYPESCRIPT.toString():
            return Language2.TYPESCRIPT;
          case Language2.PYTHON.toString():
            return Language2.PYTHON;
          case Language2.JAVA.toString():
            return Language2.JAVA;
          default:
            throw new UnsupportedLanguageError2(lang, Language2.values());
        }
      }
      static values() {
        return [Language2.TYPESCRIPT, Language2.PYTHON, Language2.JAVA];
      }
      toString() {
        return this.lang;
      }
    };
    exports.Language = Language2;
    Language2.TYPESCRIPT = new Language2("typescript");
    Language2.PYTHON = new Language2("python");
    Language2.JAVA = new Language2("java");
    var UnsupportedLanguageError2 = class extends Error {
      constructor(lang, supported) {
        super(`Unsupported language: ${lang}. Supported languages are: [${supported}]`);
      }
    };
    exports.UnsupportedLanguageError = UnsupportedLanguageError2;
    var TranspiledTypeReference = class {
      constructor(transpile, ref, primitive, isAny, type, arrayOfType, mapOfType, unionOfTypes) {
        this.transpile = transpile;
        this.ref = ref;
        this.primitive = primitive;
        this.isAny = isAny;
        this.type = type;
        this.arrayOfType = arrayOfType;
        this.mapOfType = mapOfType;
        this.unionOfTypes = unionOfTypes;
      }
      static primitive(transpile, ref, primitive) {
        return new TranspiledTypeReference(transpile, ref, primitive);
      }
      static any(transpile, ref) {
        return new TranspiledTypeReference(transpile, ref, void 0, true);
      }
      static type(transpile, ref, type) {
        return new TranspiledTypeReference(transpile, ref, void 0, void 0, type);
      }
      static arrayOfType(transpile, ref, tf) {
        return new TranspiledTypeReference(transpile, ref, void 0, void 0, void 0, tf);
      }
      static mapOfType(transpile, ref, tf) {
        return new TranspiledTypeReference(transpile, ref, void 0, void 0, void 0, void 0, tf);
      }
      static unionOfTypes(transpile, ref, tfs) {
        return new TranspiledTypeReference(transpile, ref, void 0, void 0, void 0, void 0, void 0, tfs);
      }
      toString(options) {
        var _a, _b;
        const tFormatter = (_a = options === null || options === void 0 ? void 0 : options.typeFormatter) !== null && _a !== void 0 ? _a : (t) => t.fqn;
        const sFormatter = (_b = options === null || options === void 0 ? void 0 : options.stringFormatter) !== null && _b !== void 0 ? _b : (s) => s;
        if (this.primitive) {
          return sFormatter(this.primitive);
        }
        if (this.type) {
          return tFormatter(this.type);
        }
        if (this.isAny) {
          return sFormatter(this.transpile.any());
        }
        if (this.arrayOfType) {
          const ref = this.arrayOfType.toString(options);
          return this.transpile.listOf(ref);
        }
        if (this.mapOfType) {
          const ref = this.mapOfType.toString(options);
          return this.transpile.mapOf(ref);
        }
        if (this.unionOfTypes) {
          const refs = this.unionOfTypes.map((t) => t.toString(options));
          return this.transpile.unionOf(refs);
        }
        throw new Error(`Invalid type reference: ${this.ref.toString()}`);
      }
    };
    exports.TranspiledTypeReference = TranspiledTypeReference;
    var TranspileBase = class {
      constructor(language) {
        this.language = language;
      }
      typeReference(ref) {
        if (ref.type) {
          const transpiled = this.type(ref.type);
          return TranspiledTypeReference.type(this, ref, transpiled);
        }
        if (ref.unionOfTypes) {
          const transpiled = ref.unionOfTypes.map((t) => this.typeReference(t));
          return TranspiledTypeReference.unionOfTypes(this, ref, transpiled);
        }
        if (ref.arrayOfType) {
          const transpiled = this.typeReference(ref.arrayOfType);
          return TranspiledTypeReference.arrayOfType(this, ref, transpiled);
        }
        if (ref.mapOfType) {
          const transpiled = this.typeReference(ref.mapOfType);
          return TranspiledTypeReference.mapOfType(this, ref, transpiled);
        }
        if (ref.isAny) {
          return TranspiledTypeReference.any(this, ref);
        }
        if (ref.primitive) {
          let transpiled;
          switch (ref.primitive) {
            case "string":
              transpiled = this.str();
              break;
            case "boolean":
              transpiled = this.boolean();
              break;
            case "number":
              transpiled = this.number();
              break;
            case "date":
              transpiled = this.date();
              break;
            case "json":
              transpiled = this.json();
              break;
            default:
              throw new Error(`Unsupported primitive type '${ref.primitive}'`);
          }
          return TranspiledTypeReference.primitive(this, ref, transpiled);
        }
        throw new Error(`Unsupported type: ${ref.toString()}`);
      }
      findSubmodule(type) {
        if (!type.namespace) {
          return void 0;
        }
        const submoduleFqn = `${type.assembly.name}.${type.namespace.split(".")[0]}`;
        const submodules = type.assembly.submodules.filter((s) => s.fqn === submoduleFqn);
        if (submodules.length > 1) {
          throw new Error(`Found multiple submodulues with fqn ${submoduleFqn}`);
        }
        if (submodules.length === 0) {
          return void 0;
        }
        return submodules[0];
      }
      getParentModule(moduleLike) {
        if (moduleLike.types.length === 0) {
          throw new Error(`unable to determine assembly since module does not have any types: ${moduleLike.fqn}`);
        }
        return moduleLike.types[0].assembly;
      }
    };
    exports.TranspileBase = TranspileBase;
  }
});

// node_modules/jsii-docgen/lib/docgen/transpile/java.js
var require_java2 = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/transpile/java.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
            __createBinding(result, mod, k);
      }
      __setModuleDefault(result, mod);
      return result;
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.JavaTranspile = void 0;
    var Case = __importStar(require_Case());
    var reflect = __importStar(require_lib7());
    var transpile = __importStar(require_transpile());
    var toCamelCase = (text) => {
      return Case.camel(text !== null && text !== void 0 ? text : "");
    };
    var toUpperCamelCase = (test) => {
      const camelCase = toCamelCase(test);
      return camelCase.charAt(0).toUpperCase() + camelCase.slice(1);
    };
    var prefixArrays = (arr) => {
      const out = [[]];
      const prefix = [];
      for (const elem of arr) {
        prefix.push(elem);
        out.push([...prefix]);
      }
      return out;
    };
    var propertyToParameter = (callable, property) => {
      return {
        docs: property.docs,
        method: callable,
        name: property.name,
        optional: property.optional,
        parentType: property.parentType,
        spec: property.spec,
        system: property.system,
        type: property.type,
        variadic: false
      };
    };
    var JavaTranspile = class extends transpile.TranspileBase {
      constructor() {
        super(transpile.Language.JAVA);
      }
      moduleLike(moduleLike) {
        var _a, _b, _c, _d;
        const javaPackage = (_b = (_a = moduleLike.targets) === null || _a === void 0 ? void 0 : _a.java) === null || _b === void 0 ? void 0 : _b.package;
        if (moduleLike instanceof reflect.Submodule) {
          const parent = this.getParentModule(moduleLike);
          const parentFqn = (_d = (_c = parent.targets) === null || _c === void 0 ? void 0 : _c.java) === null || _d === void 0 ? void 0 : _d.package;
          const submoduleJavaPackage = javaPackage !== null && javaPackage !== void 0 ? javaPackage : `${parentFqn}.${Case.snake(moduleLike.name)}`;
          return { name: parentFqn, submodule: submoduleJavaPackage };
        }
        return { name: javaPackage };
      }
      type(type) {
        const submodule = this.findSubmodule(type);
        const moduleLike = this.moduleLike(submodule ? submodule : type.assembly);
        const fqn = [];
        let namespace = type.namespace;
        if (namespace) {
          if (submodule && moduleLike.submodule) {
            fqn.push(namespace.replace(submodule.name, moduleLike.submodule));
          } else {
            fqn.push(moduleLike.name);
            fqn.push(namespace);
          }
        } else {
          fqn.push(moduleLike.name);
        }
        fqn.push(type.name);
        return {
          fqn: fqn.join("."),
          name: type.name,
          namespace,
          module: moduleLike.name,
          submodule: moduleLike.submodule,
          source: type,
          language: this.language
        };
      }
      callable(callable) {
        const type = this.type(callable.parentType);
        const parameters = callable.parameters.sort(this.optionalityCompare);
        const requiredParams = parameters.filter((p) => !p.optional);
        const optionalParams = parameters.filter((p) => p.optional);
        const name = callable.name;
        const inputLists = prefixArrays(optionalParams).map((optionals) => {
          return [...requiredParams, ...optionals].map((p) => this.formatParameter(this.parameter(p)));
        });
        const signatures = inputLists.map((inputs) => {
          return this.formatSignature(name, inputs);
        });
        let invocations;
        if (this.isClassBuilderGenerated(callable)) {
          const struct = this.extractFirstStruct(parameters);
          invocations = [this.formatClassBuilder(type, parameters, struct)];
          for (const property of struct.allProperties) {
            const parameter = propertyToParameter(callable, property);
            parameters.push(parameter);
          }
        } else {
          invocations = callable.kind === reflect.MemberKind.Initializer ? inputLists.map((inputs) => this.formatClassInitialization(type, inputs)) : inputLists.map((inputs) => this.formatInvocation(type, inputs, name));
        }
        return {
          name,
          parentType: type,
          import: this.formatImport(type),
          parameters,
          signatures,
          invocations
        };
      }
      class(klass) {
        return {
          name: klass.name,
          type: this.type(klass)
        };
      }
      struct(struct) {
        const type = this.type(struct);
        const indent = " ".repeat(4);
        const inputs = struct.allProperties.map((p) => this.formatBuilderMethod(this.property(p), indent)).flat();
        return {
          type,
          name: struct.name,
          import: this.formatImport(type),
          initialization: this.formatStructBuilder(type, inputs)
        };
      }
      interface(iface) {
        return {
          name: iface.name,
          type: this.type(iface)
        };
      }
      parameter(parameter) {
        const typeRef = this.typeReference(parameter.type);
        return {
          name: parameter.name,
          parentType: this.type(parameter.parentType),
          typeReference: typeRef,
          optional: parameter.optional,
          declaration: this.formatProperty(parameter.name, typeRef)
        };
      }
      property(property) {
        const typeRef = this.typeReference(property.type);
        return {
          name: property.name,
          parentType: this.type(property.parentType),
          typeReference: typeRef,
          optional: property.optional,
          declaration: this.formatProperty(property.name, typeRef)
        };
      }
      enum(enu) {
        return {
          fqn: this.type(enu).fqn,
          name: enu.name
        };
      }
      enumMember(em) {
        return {
          fqn: `${this.enum(em.enumType).fqn}.${em.name}`,
          name: em.name
        };
      }
      unionOf(types) {
        return types.join(" OR ");
      }
      listOf(type) {
        return `java.util.List<${type}>`;
      }
      mapOf(type) {
        return `java.util.Map<java.lang.String, ${type}>`;
      }
      any() {
        return "java.lang.Object";
      }
      str() {
        return "java.lang.String";
      }
      number() {
        return "java.lang.Number";
      }
      boolean() {
        return "java.lang.Boolean";
      }
      json() {
        return "com.fasterxml.jackson.databind.node.ObjectNode";
      }
      date() {
        return "java.time.Instant";
      }
      readme(readme) {
        return readme;
      }
      formatImport(type) {
        return `import ${type.fqn};`;
      }
      formatParameter(transpiled) {
        const tf = transpiled.typeReference.toString({
          typeFormatter: (t) => t.name
        });
        return `${tf} ${transpiled.name}`;
      }
      formatInputs(inputs) {
        return inputs.join(", ");
      }
      formatStructBuilder(type, methods) {
        const builder = `${type.name}.builder()`;
        return [
          builder,
          ...methods,
          "    .build();"
        ].join("\n");
      }
      formatClassInitialization(type, inputs) {
        return `new ${type.name}(${this.formatInputs(inputs)});`;
      }
      formatClassBuilder(type, parameters, struct) {
        const createArgs = this.formatInputs(parameters.map((p) => this.formatParameter(this.parameter(p))));
        const indent = " ".repeat(4);
        const methods = struct.allProperties.map((p) => this.formatBuilderMethod(this.property(p), indent)).flat();
        return [
          `${type.name}.Builder.create(${createArgs})`,
          ...methods,
          `${indent}.build();`
        ].join("\n");
      }
      formatSignature(name, inputs) {
        return `public ${name}(${this.formatInputs(inputs)})`;
      }
      formatBuilderMethod(transpiled, indent) {
        if (transpiled.optional)
          indent = "//" + indent.slice(2);
        const lowerCamel = toCamelCase(transpiled.name);
        const base = `${indent}.${lowerCamel}`;
        const tf = transpiled.typeReference.toString({
          typeFormatter: (t) => t.name
        });
        if (tf.includes(" OR ")) {
          const choices = tf.split(" OR ");
          return choices.map((typ) => `${base}(${typ})`);
        } else {
          return [`${base}(${tf})`];
        }
      }
      formatInvocation(type, inputs, method) {
        let target = type.name;
        if (method) {
          target = `${target}.${method}`;
        }
        return `${target}(${this.formatInputs(inputs)})`;
      }
      optionalityCompare(p1, p2) {
        if (!p1.optional && p2.optional) {
          return -1;
        }
        if (!p2.optional && p1.optional) {
          return 1;
        }
        return 0;
      }
      isStruct(p) {
        return p.type.fqn ? p.system.findFqn(p.type.fqn).isDataType() : false;
      }
      isClassBuilderGenerated(callable) {
        if (callable.kind !== reflect.MemberKind.Initializer) {
          return false;
        }
        const parameters = callable.parameters.sort(this.optionalityCompare);
        const firstStruct = parameters.find((param) => this.isStruct(param));
        if (!firstStruct) {
          return false;
        }
        return true;
      }
      extractFirstStruct(parameters) {
        const firstStruct = parameters.find((param) => this.isStruct(param));
        if (!firstStruct) {
          throw new Error("No struct found in parameter list.");
        }
        const struct = firstStruct.parentType.system.findInterface(firstStruct.type.fqn);
        parameters.splice(parameters.indexOf(firstStruct), 1);
        return struct;
      }
      formatProperty(name, typeReference) {
        const tf = typeReference.toString({
          typeFormatter: (t) => t.name
        });
        if (tf.includes(" OR ")) {
          return `public java.lang.Object get${toUpperCamelCase(name)}();`;
        } else {
          return `public ${tf} get${toUpperCamelCase(name)}();`;
        }
      }
    };
    exports.JavaTranspile = JavaTranspile;
  }
});

// node_modules/jsii-docgen/lib/docgen/transpile/python.js
var require_python2 = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/transpile/python.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
            __createBinding(result, mod, k);
      }
      __setModuleDefault(result, mod);
      return result;
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.PythonTranspile = void 0;
    var Case = __importStar(require_Case());
    var reflect = __importStar(require_lib7());
    var transpile = __importStar(require_transpile());
    var toSnakeCase = (text) => {
      return Case.snake(text !== null && text !== void 0 ? text : "");
    };
    var formatImport = (type) => {
      if (type.submodule) {
        return `from ${type.module} import ${type.submodule}`;
      }
      return `import ${type.module}`;
    };
    var formatArguments = (inputs) => {
      return inputs.length === 0 ? "()" : [
        "(",
        inputs.map((i) => `  ${i}`).join(",\n"),
        ")"
      ].join("\n");
    };
    var formatInvocation = (type, inputs, method) => {
      let target;
      if (type.submodule) {
        if (!type.namespace) {
          throw new Error(`Invalid type: ${type.fqn}: Types defined in a submodule (${type.submodule}) must have a namespace. `);
        }
        target = `${type.namespace}.${type.name}`;
      } else {
        target = type.fqn;
      }
      if (method) {
        target = `${target}.${method}`;
      }
      return `${target}${formatArguments(inputs)}`;
    };
    var formatSignature = (name, inputs) => {
      const def = "def ";
      return `${def}${name}${formatArguments(inputs)}`;
    };
    var propertyToParameter = (callable, property) => {
      return {
        docs: property.docs,
        method: callable,
        name: property.name,
        optional: property.optional,
        parentType: property.parentType,
        spec: property.spec,
        system: property.system,
        type: property.type,
        variadic: false
      };
    };
    var PythonTranspile = class extends transpile.TranspileBase {
      constructor() {
        super(transpile.Language.PYTHON);
      }
      readme(readme) {
        return readme;
      }
      unionOf(types) {
        return `${this.typing("Union")}[${types.join(", ")}]`;
      }
      listOf(type) {
        return `${this.typing("List")}[${type}]`;
      }
      mapOf(type) {
        return `${this.typing("Mapping")}[${type}]`;
      }
      any() {
        return this.typing("Any");
      }
      boolean() {
        return "bool";
      }
      str() {
        return "str";
      }
      number() {
        return `${this.typing("Union")}[int, float]`;
      }
      date() {
        return "datetime.datetime";
      }
      enum(enu) {
        return {
          fqn: this.type(enu).fqn,
          name: enu.name
        };
      }
      enumMember(em) {
        return {
          fqn: `${this.enum(em.enumType).fqn}.${em.name}`,
          name: em.name
        };
      }
      json() {
        return "any";
      }
      property(property) {
        const name = property.const ? property.name : toSnakeCase(property.name);
        const typeRef = this.typeReference(property.type);
        return {
          name,
          parentType: this.type(property.parentType),
          typeReference: typeRef,
          optional: property.optional,
          declaration: this.formatProperty(name, typeRef)
        };
      }
      class(klass) {
        return {
          name: klass.name,
          type: this.type(klass)
        };
      }
      parameter(parameter) {
        const name = toSnakeCase(parameter.name);
        const typeRef = this.typeReference(parameter.type);
        return {
          name,
          parentType: this.type(parameter.parentType),
          typeReference: typeRef,
          optional: parameter.optional,
          declaration: this.formatProperty(name, typeRef)
        };
      }
      struct(struct) {
        const type = this.type(struct);
        const inputs = struct.allProperties.map((p) => this.formatParameters(this.property(p)));
        return {
          type,
          name: struct.name,
          import: formatImport(type),
          initialization: formatInvocation(type, inputs)
        };
      }
      callable(callable) {
        const type = this.type(callable.parentType);
        const parameters = new Array();
        for (const p of callable.parameters.sort(this.optionalityCompare)) {
          if (!this.isStruct(p)) {
            parameters.push(p);
          } else {
            const struct = p.parentType.system.findInterface(p.type.fqn);
            for (const property of struct.allProperties) {
              const parameter = propertyToParameter(callable, property);
              parameters.push(parameter);
            }
          }
        }
        const name = toSnakeCase(callable.name);
        const inputs = parameters.map((p) => this.formatParameters(this.parameter(p)));
        return {
          name,
          parentType: type,
          import: formatImport(type),
          parameters,
          signatures: [formatSignature(name, inputs)],
          invocations: [formatInvocation(type, inputs, callable.kind === reflect.MemberKind.Initializer ? void 0 : name)]
        };
      }
      type(type) {
        const submodule = this.findSubmodule(type);
        const moduleLike = this.moduleLike(submodule ? submodule : type.assembly);
        const fqn = [moduleLike.name];
        if (type.namespace) {
          fqn.push(type.namespace);
        }
        fqn.push(type.name);
        return {
          fqn: fqn.join("."),
          name: type.name,
          namespace: type.namespace,
          module: moduleLike.name,
          submodule: moduleLike.submodule,
          source: type,
          language: this.language
        };
      }
      moduleLike(moduleLike) {
        var _a, _b, _c, _d;
        const pythonModule = (_b = (_a = moduleLike.targets) === null || _a === void 0 ? void 0 : _a.python) === null || _b === void 0 ? void 0 : _b.module;
        if (moduleLike instanceof reflect.Submodule) {
          const assembly = this.getParentModule(moduleLike);
          const parentPythonModule = (_d = (_c = assembly.targets) === null || _c === void 0 ? void 0 : _c.python) === null || _d === void 0 ? void 0 : _d.module;
          const submodulePythonModule = pythonModule !== null && pythonModule !== void 0 ? pythonModule : `${parentPythonModule}.${Case.snake(moduleLike.name)}`;
          const moduleParts = submodulePythonModule.split(".");
          return { name: moduleParts[0], submodule: moduleParts[1] };
        }
        if (!pythonModule) {
          throw new Error(`Python is not a supported target for module: ${moduleLike.fqn}`);
        }
        return { name: pythonModule };
      }
      interface(iface) {
        return {
          name: iface.name,
          type: this.type(iface)
        };
      }
      optionalityCompare(p1, p2) {
        if (!p1.optional && p2.optional) {
          return -1;
        }
        if (!p2.optional && p1.optional) {
          return 1;
        }
        return 0;
      }
      isStruct(p) {
        return p.type.fqn ? p.system.findFqn(p.type.fqn).isDataType() : false;
      }
      typing(type) {
        return `typing.${type}`;
      }
      formatParameters(transpiled) {
        const tf = transpiled.typeReference.toString({
          typeFormatter: (t) => t.name
        });
        return `${transpiled.name}: ${tf}${transpiled.optional ? " = None" : ""}`;
      }
      formatProperty(name, typeReference) {
        const tf = typeReference.toString({
          typeFormatter: (t) => t.name
        });
        return `${name}: ${tf}`;
      }
    };
    exports.PythonTranspile = PythonTranspile;
  }
});

// node_modules/jsii-docgen/lib/docgen/transpile/typescript.js
var require_typescript2 = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/transpile/typescript.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
            __createBinding(result, mod, k);
      }
      __setModuleDefault(result, mod);
      return result;
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.TypeScriptTranspile = void 0;
    var reflect = __importStar(require_lib7());
    var transpile = __importStar(require_transpile());
    var Case = require_Case();
    var toCamelCase = (text) => {
      return Case.camel(text !== null && text !== void 0 ? text : "");
    };
    var formatArguments = (inputs) => {
      return inputs.join(", ");
    };
    var formatStructInitialization = (type) => {
      const target = type.submodule ? `${type.namespace}.${type.name}` : type.name;
      return `const ${toCamelCase(type.name)}: ${target} = { ... }`;
    };
    var formatClassInitialization = (type, inputs) => {
      const target = type.submodule ? `${type.namespace}.${type.name}` : type.name;
      return `new ${target}(${formatArguments(inputs)})`;
    };
    var formatInvocation = (type, inputs, method) => {
      let target = type.submodule ? `${type.namespace}.${type.name}` : type.name;
      if (method) {
        target = `${target}.${method}`;
      }
      return `${target}(${formatArguments(inputs)})`;
    };
    var formatImport = (type) => {
      if (type.submodule) {
        return `import { ${type.submodule} } from '${type.module}'`;
      } else {
        return `import { ${type.name} } from '${type.module}'`;
      }
    };
    var formatSignature = (name, inputs) => {
      return `public ${name}(${formatArguments(inputs)})`;
    };
    var TypeScriptTranspile = class extends transpile.TranspileBase {
      constructor() {
        super(transpile.Language.TYPESCRIPT);
      }
      readme(readme) {
        return readme;
      }
      unionOf(types) {
        return `${types.join(" | ")}`;
      }
      listOf(type) {
        return `${type}[]`;
      }
      mapOf(type) {
        return `{[ key: string ]: ${type}}`;
      }
      any() {
        return "any";
      }
      boolean() {
        return "boolean";
      }
      str() {
        return "string";
      }
      number() {
        return "number";
      }
      date() {
        return "Date";
      }
      json() {
        return "object";
      }
      enum(enu) {
        return {
          fqn: this.type(enu).fqn,
          name: enu.name
        };
      }
      enumMember(em) {
        return {
          fqn: `${this.enum(em.enumType).fqn}.${em.name}`,
          name: em.name
        };
      }
      property(property) {
        const typeRef = this.typeReference(property.type);
        return {
          name: property.name,
          parentType: this.type(property.parentType),
          typeReference: typeRef,
          optional: property.optional,
          declaration: this.formatProperty(property.name, typeRef)
        };
      }
      class(klass) {
        return {
          name: klass.name,
          type: this.type(klass)
        };
      }
      parameter(parameter) {
        const typeRef = this.typeReference(parameter.type);
        return {
          name: parameter.name,
          parentType: this.type(parameter.parentType),
          typeReference: typeRef,
          optional: parameter.optional,
          declaration: this.formatProperty(parameter.name, typeRef)
        };
      }
      struct(struct) {
        const type = this.type(struct);
        return {
          type,
          name: struct.name,
          import: formatImport(type),
          initialization: formatStructInitialization(type)
        };
      }
      callable(callable) {
        const type = this.type(callable.parentType);
        const parameters = callable.parameters.sort(this.optionalityCompare);
        const name = callable.name;
        const inputs = parameters.map((p) => this.formatParameters(this.parameter(p)));
        const invocation = callable.kind === reflect.MemberKind.Initializer ? formatClassInitialization(type, inputs) : formatInvocation(type, inputs, name);
        return {
          name,
          parentType: type,
          import: formatImport(type),
          parameters,
          signatures: [formatSignature(name, inputs)],
          invocations: [invocation]
        };
      }
      interface(iface) {
        return {
          name: iface.name,
          type: this.type(iface)
        };
      }
      type(type) {
        const submodule = this.findSubmodule(type);
        const moduleLike = this.moduleLike(submodule ? submodule : type.assembly);
        const fqn = [moduleLike.name];
        if (type.namespace) {
          fqn.push(type.namespace);
        }
        fqn.push(type.name);
        return {
          fqn: fqn.join("."),
          name: type.name,
          namespace: type.namespace,
          module: moduleLike.name,
          submodule: moduleLike.submodule,
          source: type,
          language: this.language
        };
      }
      moduleLike(moduleLike) {
        if (moduleLike instanceof reflect.Submodule) {
          const fqnParts = moduleLike.fqn.split(".");
          return { name: fqnParts[0], submodule: fqnParts[1] };
        }
        return { name: moduleLike.fqn };
      }
      optionalityCompare(p1, p2) {
        if (!p1.optional && p2.optional) {
          return -1;
        }
        if (!p2.optional && p1.optional) {
          return 1;
        }
        return 0;
      }
      formatParameters(transpiled) {
        const tf = transpiled.typeReference.toString({
          typeFormatter: (t) => t.name
        });
        return `${transpiled.name}${transpiled.optional ? "?" : ""}: ${tf}`;
      }
      formatProperty(name, typeReference) {
        const tf = typeReference.toString({
          typeFormatter: (t) => t.name
        });
        return `public readonly ${name}: ${tf};`;
      }
    };
    exports.TypeScriptTranspile = TypeScriptTranspile;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/_npm.js
var require_npm = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/_npm.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
            __createBinding(result, mod, k);
      }
      __setModuleDefault(result, mod);
      return result;
    };
    var __classPrivateFieldGet = exports && exports.__classPrivateFieldGet || function(receiver, state, kind, f) {
      if (kind === "a" && !f)
        throw new TypeError("Private accessor was defined without a getter");
      if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
        throw new TypeError("Cannot read private member from an object whose class did not declare it");
      return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    };
    var __classPrivateFieldSet = exports && exports.__classPrivateFieldSet || function(receiver, state, value, kind, f) {
      if (kind === "m")
        throw new TypeError("Private method is not writable");
      if (kind === "a" && !f)
        throw new TypeError("Private accessor was defined without a setter");
      if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
        throw new TypeError("Cannot write private member to an object whose class did not declare it");
      return kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value), value;
    };
    var _Npm_npmCommand;
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Npm = void 0;
    var child_process_1 = require("child_process");
    var os2 = __importStar(require("os"));
    var path_1 = require("path");
    var __1 = require_lib11();
    var Npm = class {
      constructor(workingDirectory, logger = console.log) {
        this.workingDirectory = workingDirectory;
        this.logger = logger;
        _Npm_npmCommand.set(this, void 0);
      }
      async install(target) {
        return this.runCommand(await this.npmCommandPath(), [
          "install",
          "--ignore-scripts",
          "--no-bin-links",
          "--no-save",
          "--include=dev",
          target
        ], {
          cwd: this.workingDirectory,
          shell: true
        });
      }
      async npmCommandPath() {
        if (__classPrivateFieldGet(this, _Npm_npmCommand, "f")) {
          return __classPrivateFieldGet(this, _Npm_npmCommand, "f");
        }
        this.logger("Installing npm7...");
        await this.runCommand("npm", ["install", "npm@7", "--no-save"], {
          cwd: this.workingDirectory,
          shell: true
        });
        return __classPrivateFieldSet(this, _Npm_npmCommand, (0, path_1.join)(this.workingDirectory, "node_modules", ".bin", "npm"), "f");
      }
      async runCommand(command, args, options) {
        return new Promise((ok, ko) => {
          const child = (0, child_process_1.spawn)(command, args, __spreadProps(__spreadValues({}, options), { stdio: ["inherit", "pipe", "pipe"] }));
          const stdout = new Array();
          child.stdout.on("data", (chunk) => {
            process.stdout.write(chunk);
            stdout.push(Buffer.from(chunk));
          });
          const stderr = new Array();
          child.stderr.on("data", (chunk) => {
            process.stderr.write(chunk);
            stderr.push(Buffer.from(chunk));
          });
          child.once("error", ko);
          child.once("close", (code, signal) => {
            if (code === 0) {
              ok();
            } else {
              const fullCommand = [command, ...args].join(" ");
              if (signal != null) {
                return ko(new __1.NpmError(`Command "${fullCommand}" was killed by signal ${signal}`, { stdout, stderr }));
              }
              if (code === 228) {
                return ko(new __1.NoSpaceLeftOnDevice(`No space left on device when running "${fullCommand}"`));
              }
              const maybeerrno = 256 - code;
              for (const [errname, errno] of Object.entries(os2.constants.errno)) {
                if (maybeerrno === errno) {
                  return ko(new __1.NpmError(`Command "${fullCommand}' command exited with code ${code} (possibly ${errname})`, { stdout, stderr }));
                }
              }
              ko(new __1.NpmError(`Command "${fullCommand}' command exited with code ${code}`, { stdout, stderr }));
            }
          });
        });
      }
    };
    exports.Npm = Npm;
    _Npm_npmCommand = new WeakMap();
  }
});

// node_modules/jsii-docgen/lib/docgen/view/property.js
var require_property2 = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/property.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Property = void 0;
    var markdown_1 = require_markdown3();
    var Property = class {
      constructor(transpile, property, linkFormatter2) {
        this.transpile = transpile;
        this.property = property;
        this.linkFormatter = linkFormatter2;
        this.transpiled = transpile.property(property);
      }
      render() {
        var _a, _b;
        const optionality = this.property.const ? void 0 : this.property.optional ? "Optional" : "Required";
        const md = new markdown_1.Markdown({
          id: `${this.transpiled.parentType.fqn}.property.${this.transpiled.name}`,
          header: {
            title: this.transpiled.name,
            sup: optionality,
            pre: true,
            strike: this.property.docs.deprecated
          }
        });
        if (this.property.docs.deprecated) {
          md.bullet(`${markdown_1.Markdown.italic("Deprecated:")} ${this.property.docs.deprecationReason}`);
          md.lines("");
        }
        if (!this.property.const) {
          md.code(this.transpile.language.toString(), this.transpiled.declaration);
        }
        const metadata = {
          Type: this.transpiled.typeReference.toString({
            typeFormatter: (t) => `[${markdown_1.Markdown.pre(t.fqn)}](${this.linkFormatter(t)})`,
            stringFormatter: markdown_1.Markdown.pre
          })
        };
        if ((_a = this.property.spec.docs) === null || _a === void 0 ? void 0 : _a.default) {
          metadata.Default = markdown_1.Markdown.sanitize((_b = this.property.spec.docs) === null || _b === void 0 ? void 0 : _b.default);
        }
        for (const [key, value] of Object.entries(metadata)) {
          md.bullet(`${markdown_1.Markdown.italic(`${key}:`)} ${value}`);
        }
        md.lines("");
        if (this.property.docs) {
          md.docs(this.property.docs);
        }
        md.split();
        return md;
      }
    };
    exports.Property = Property;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/constant.js
var require_constant = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/constant.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Constant = void 0;
    var property_1 = require_property2();
    var Constant = class {
      constructor(transpile, property, linkFormatter2) {
        this.constant = new property_1.Property(transpile, property, linkFormatter2);
      }
      render() {
        return this.constant.render();
      }
    };
    exports.Constant = Constant;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/constants.js
var require_constants = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/constants.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Constants = void 0;
    var markdown_1 = require_markdown3();
    var constant_1 = require_constant();
    var Constants = class {
      constructor(transpile, properties, linkFormatter2) {
        this.constants = properties.filter((p) => !p.protected && p.const).map((p) => new constant_1.Constant(transpile, p, linkFormatter2));
      }
      render() {
        if (this.constants.length === 0) {
          return markdown_1.Markdown.EMPTY;
        }
        const md = new markdown_1.Markdown({ header: { title: "Constants" } });
        for (const c of this.constants) {
          md.section(c.render());
        }
        return md;
      }
    };
    exports.Constants = Constants;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/parameter.js
var require_parameter2 = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/parameter.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Parameter = void 0;
    var markdown_1 = require_markdown3();
    var Parameter = class {
      constructor(transpile, parameter, linkFormatter2) {
        this.parameter = parameter;
        this.linkFormatter = linkFormatter2;
        this.transpiled = transpile.parameter(parameter);
      }
      render() {
        var _a, _b;
        const optionality = this.parameter.optional ? "Optional" : "Required";
        const md = new markdown_1.Markdown({
          id: `${this.transpiled.parentType.fqn}.parameter.${this.transpiled.name}`,
          header: {
            title: this.transpiled.name,
            sup: optionality,
            pre: true,
            strike: this.parameter.docs.deprecated
          }
        });
        if (this.parameter.docs.deprecated) {
          md.bullet(`${markdown_1.Markdown.italic("Deprecated:")} ${this.parameter.docs.deprecationReason}`);
          md.lines("");
        }
        const metadata = {
          Type: this.transpiled.typeReference.toString({
            typeFormatter: (t) => `[${markdown_1.Markdown.pre(t.fqn)}](${this.linkFormatter(t)})`,
            stringFormatter: markdown_1.Markdown.pre
          })
        };
        if ((_a = this.parameter.spec.docs) === null || _a === void 0 ? void 0 : _a.default) {
          metadata.Default = markdown_1.Markdown.sanitize((_b = this.parameter.spec.docs) === null || _b === void 0 ? void 0 : _b.default);
        }
        for (const [key, value] of Object.entries(metadata)) {
          md.bullet(`${markdown_1.Markdown.italic(`${key}:`)} ${value}`);
        }
        md.lines("");
        if (this.parameter.docs) {
          md.docs(this.parameter.docs);
        }
        md.split();
        return md;
      }
    };
    exports.Parameter = Parameter;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/initializer.js
var require_initializer2 = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/initializer.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Initializer = void 0;
    var markdown_1 = require_markdown3();
    var parameter_1 = require_parameter2();
    var Initializer = class {
      constructor(transpile, initializer, linkFormatter2) {
        this.transpile = transpile;
        this.transpiled = transpile.callable(initializer);
        this.parameters = this.transpiled.parameters.map((p) => new parameter_1.Parameter(this.transpile, p, linkFormatter2));
      }
      render() {
        const md = new markdown_1.Markdown({
          id: `${this.transpiled.parentType.fqn}.Initializer`,
          header: {
            title: "Initializers"
          }
        });
        md.code(this.transpile.language.toString(), `${this.transpiled.import}`, "", ...this.transpiled.invocations);
        for (const parameter of this.parameters) {
          md.section(parameter.render());
        }
        return md;
      }
    };
    exports.Initializer = Initializer;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/instance-method.js
var require_instance_method = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/instance-method.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.InstanceMethod = void 0;
    var markdown_1 = require_markdown3();
    var parameter_1 = require_parameter2();
    var InstanceMethod = class {
      constructor(transpile, method, linkFormatter2) {
        this.transpile = transpile;
        this.method = method;
        this.transpiled = transpile.callable(method);
        this.parameters = this.transpiled.parameters.map((p) => new parameter_1.Parameter(this.transpile, p, linkFormatter2));
      }
      render() {
        const md = new markdown_1.Markdown({
          id: `${this.transpiled.parentType.fqn}.${this.transpiled.name}`,
          header: {
            title: this.transpiled.name,
            pre: true,
            strike: this.method.docs.deprecated
          }
        });
        md.code(this.transpile.language.toString(), this.transpiled.signatures.join("\n"));
        for (const parameter of this.parameters) {
          md.section(parameter.render());
        }
        return md;
      }
    };
    exports.InstanceMethod = InstanceMethod;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/instance-methods.js
var require_instance_methods = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/instance-methods.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.InstanceMethods = void 0;
    var markdown_1 = require_markdown3();
    var instance_method_1 = require_instance_method();
    var InstanceMethods = class {
      constructor(transpile, methods, linkFormatter2) {
        this.instanceMethods = methods.filter((m) => !m.protected && !m.static).map((m) => new instance_method_1.InstanceMethod(transpile, m, linkFormatter2));
      }
      render() {
        if (this.instanceMethods.length === 0) {
          return markdown_1.Markdown.EMPTY;
        }
        const md = new markdown_1.Markdown({ header: { title: "Methods" } });
        for (const method of this.instanceMethods) {
          md.section(method.render());
        }
        return md;
      }
    };
    exports.InstanceMethods = InstanceMethods;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/properties.js
var require_properties = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/properties.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Properties = void 0;
    var markdown_1 = require_markdown3();
    var property_1 = require_property2();
    var Properties = class {
      constructor(transpile, properties, linkFormatter2) {
        this.properties = properties.filter((p) => !p.protected && !p.const).map((p) => new property_1.Property(transpile, p, linkFormatter2));
      }
      render() {
        if (this.properties.length === 0) {
          return markdown_1.Markdown.EMPTY;
        }
        const md = new markdown_1.Markdown({ header: { title: "Properties" } });
        for (const property of this.properties) {
          md.section(property.render());
        }
        return md;
      }
    };
    exports.Properties = Properties;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/static-function.js
var require_static_function = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/static-function.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.StaticFunction = void 0;
    var markdown_1 = require_markdown3();
    var parameter_1 = require_parameter2();
    var StaticFunction = class {
      constructor(transpile, method, linkFormatter2) {
        this.transpile = transpile;
        this.method = method;
        this.transpiled = transpile.callable(method);
        this.parameters = this.transpiled.parameters.map((p) => new parameter_1.Parameter(this.transpile, p, linkFormatter2));
      }
      render() {
        const md = new markdown_1.Markdown({
          id: `${this.transpiled.parentType.fqn}.${this.transpiled.name}`,
          header: {
            title: this.transpiled.name,
            pre: true,
            strike: this.method.docs.deprecated
          }
        });
        md.code(this.transpile.language.toString(), `${this.transpiled.import}`, "", ...this.transpiled.invocations);
        for (const parameter of this.parameters) {
          md.section(parameter.render());
        }
        return md;
      }
    };
    exports.StaticFunction = StaticFunction;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/static-functions.js
var require_static_functions = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/static-functions.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.StaticFunctions = void 0;
    var markdown_1 = require_markdown3();
    var static_function_1 = require_static_function();
    var StaticFunctions = class {
      constructor(transpile, methods, linkFormatter2) {
        this.staticFunctions = methods.filter((m) => !m.protected && m.static).map((m) => new static_function_1.StaticFunction(transpile, m, linkFormatter2));
      }
      render() {
        if (this.staticFunctions.length === 0) {
          return markdown_1.Markdown.EMPTY;
        }
        const md = new markdown_1.Markdown({ header: { title: "Static Functions" } });
        for (const func of this.staticFunctions) {
          md.section(func.render());
        }
        return md;
      }
    };
    exports.StaticFunctions = StaticFunctions;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/class.js
var require_class2 = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/class.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Class = void 0;
    var markdown_1 = require_markdown3();
    var constants_1 = require_constants();
    var initializer_1 = require_initializer2();
    var instance_methods_1 = require_instance_methods();
    var properties_1 = require_properties();
    var static_functions_1 = require_static_functions();
    var CONSTRUCT_CLASS = "constructs.Construct";
    var Class = class {
      constructor(transpile, klass, linkFormatter2) {
        this.transpile = transpile;
        this.klass = klass;
        this.linkFormatter = linkFormatter2;
        if (klass.initializer) {
          this.initializer = new initializer_1.Initializer(transpile, klass.initializer, linkFormatter2);
        }
        this.instanceMethods = new instance_methods_1.InstanceMethods(transpile, klass.ownMethods, linkFormatter2);
        this.staticFunctions = new static_functions_1.StaticFunctions(transpile, klass.ownMethods, linkFormatter2);
        this.constants = new constants_1.Constants(transpile, klass.ownProperties, linkFormatter2);
        this.properties = new properties_1.Properties(transpile, klass.ownProperties, linkFormatter2);
        this.transpiled = transpile.class(klass);
      }
      static isConstruct(klass) {
        if (klass.fqn === CONSTRUCT_CLASS)
          return true;
        if (!klass.base) {
          return false;
        }
        return this.isConstruct(klass.base);
      }
      render() {
        const md = new markdown_1.Markdown({
          id: this.transpiled.type.fqn,
          header: { title: this.transpiled.name }
        });
        if (this.klass.interfaces.length > 0) {
          const ifaces = [];
          for (const iface of this.klass.interfaces) {
            const transpiled = this.transpile.type(iface);
            ifaces.push(`[${markdown_1.Markdown.pre(transpiled.fqn)}](${this.linkFormatter(transpiled)})`);
          }
          md.bullet(`${markdown_1.Markdown.italic("Implements:")} ${ifaces.join(", ")}`);
          md.lines("");
        }
        if (this.klass.docs) {
          md.docs(this.klass.docs);
        }
        if (this.initializer) {
          md.section(this.initializer.render());
        }
        md.section(this.instanceMethods.render());
        md.section(this.staticFunctions.render());
        md.section(this.properties.render());
        md.section(this.constants.render());
        return md;
      }
    };
    exports.Class = Class;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/classes.js
var require_classes = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/classes.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Classes = void 0;
    var markdown_1 = require_markdown3();
    var class_1 = require_class2();
    var Classes = class {
      constructor(transpile, classes, linkFormatter2) {
        this.classes = classes.filter((c) => !class_1.Class.isConstruct(c)).map((c) => new class_1.Class(transpile, c, linkFormatter2));
      }
      render() {
        if (this.classes.length === 0) {
          return markdown_1.Markdown.EMPTY;
        }
        const md = new markdown_1.Markdown({ header: { title: "Classes" } });
        for (const klass of this.classes) {
          md.section(klass.render());
        }
        return md;
      }
    };
    exports.Classes = Classes;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/construct.js
var require_construct = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/construct.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Construct = void 0;
    var class_1 = require_class2();
    var Construct = class {
      constructor(transpile, klass, linkFormatter2) {
        this.construct = new class_1.Class(transpile, klass, linkFormatter2);
      }
      render() {
        return this.construct.render();
      }
    };
    exports.Construct = Construct;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/constructs.js
var require_constructs = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/constructs.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Constructs = void 0;
    var markdown_1 = require_markdown3();
    var class_1 = require_class2();
    var construct_1 = require_construct();
    var Constructs = class {
      constructor(transpile, classes, linkFormatter2) {
        this.constructs = classes.filter((c) => class_1.Class.isConstruct(c)).map((c) => new construct_1.Construct(transpile, c, linkFormatter2));
      }
      render() {
        if (this.constructs.length === 0) {
          return markdown_1.Markdown.EMPTY;
        }
        const md = new markdown_1.Markdown({ header: { title: "Constructs" } });
        for (const construct of this.constructs) {
          md.section(construct.render());
        }
        return md;
      }
    };
    exports.Constructs = Constructs;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/enum-member.js
var require_enum_member = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/enum-member.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.EnumMember = void 0;
    var markdown_1 = require_markdown3();
    var EnumMember = class {
      constructor(transpile, em) {
        this.em = em;
        this.transpiled = transpile.enumMember(em);
      }
      render() {
        const md = new markdown_1.Markdown({
          id: `${this.transpiled.fqn}`,
          header: {
            title: this.transpiled.name,
            pre: true,
            strike: this.em.docs.deprecated
          }
        });
        if (this.em.docs.deprecated) {
          md.bullet(`${markdown_1.Markdown.italic("Deprecated:")} ${this.em.docs.deprecationReason}`);
          md.lines("");
        }
        if (this.em.docs) {
          md.docs(this.em.docs);
        }
        md.split();
        md.lines("");
        return md;
      }
    };
    exports.EnumMember = EnumMember;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/enum.js
var require_enum2 = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/enum.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Enum = void 0;
    var markdown_1 = require_markdown3();
    var enum_member_1 = require_enum_member();
    var Enum = class {
      constructor(transpile, enu) {
        this.transpile = transpile;
        this.enu = enu;
        this.members = enu.members.map((em) => new enum_member_1.EnumMember(transpile, em));
      }
      render() {
        const transpiled = this.transpile.enum(this.enu);
        const md = new markdown_1.Markdown({ header: { title: transpiled.name } });
        if (this.enu.docs) {
          md.docs(this.enu.docs);
        }
        for (const m of this.members) {
          md.section(m.render());
        }
        return md;
      }
    };
    exports.Enum = Enum;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/enums.js
var require_enums = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/enums.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Enums = void 0;
    var markdown_1 = require_markdown3();
    var enum_1 = require_enum2();
    var Enums = class {
      constructor(transpile, enums) {
        this.enums = enums.map((e) => new enum_1.Enum(transpile, e));
      }
      render() {
        if (this.enums.length === 0) {
          return markdown_1.Markdown.EMPTY;
        }
        const md = new markdown_1.Markdown({ header: { title: "Enums" } });
        for (const e of this.enums) {
          md.section(e.render());
        }
        return md;
      }
    };
    exports.Enums = Enums;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/interface.js
var require_interface2 = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/interface.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Interface = void 0;
    var markdown_1 = require_markdown3();
    var instance_methods_1 = require_instance_methods();
    var properties_1 = require_properties();
    var Interface = class {
      constructor(transpile, iface, linkFormatter2) {
        this.transpile = transpile;
        this.iface = iface;
        this.linkFormatter = linkFormatter2;
        this.transpiled = transpile.interface(iface);
        this.instanceMethods = new instance_methods_1.InstanceMethods(transpile, iface.ownMethods, linkFormatter2);
        this.properties = new properties_1.Properties(transpile, iface.allProperties, linkFormatter2);
      }
      static isStruct(iface) {
        return iface.datatype;
      }
      render() {
        const md = new markdown_1.Markdown({
          id: this.transpiled.type.fqn,
          header: { title: this.transpiled.name }
        });
        if (this.iface.interfaces.length > 0) {
          const ifaces = [];
          for (const iface of this.iface.interfaces) {
            const transpiled = this.transpile.type(iface);
            ifaces.push(`[${markdown_1.Markdown.pre(transpiled.fqn)}](${this.linkFormatter(transpiled)})`);
          }
          md.bullet(`${markdown_1.Markdown.italic("Extends:")} ${ifaces.join(", ")}`);
          md.lines("");
        }
        if (this.iface.allImplementations.length > 0) {
          const impls = [];
          for (const impl of this.iface.allImplementations) {
            const transpiled = this.transpile.type(impl);
            impls.push(`[${markdown_1.Markdown.pre(transpiled.fqn)}](${this.linkFormatter(transpiled)})`);
          }
          md.bullet(`${markdown_1.Markdown.italic("Implemented By:")} ${impls.join(", ")}`);
          md.lines("");
        }
        if (this.iface.docs) {
          md.docs(this.iface.docs);
        }
        md.section(this.instanceMethods.render());
        md.section(this.properties.render());
        return md;
      }
    };
    exports.Interface = Interface;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/interfaces.js
var require_interfaces = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/interfaces.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Interfaces = void 0;
    var markdown_1 = require_markdown3();
    var interface_1 = require_interface2();
    var Interfaces = class {
      constructor(transpile, interfaces, linkFormatter2) {
        this.interfaces = interfaces.filter((i) => !interface_1.Interface.isStruct(i)).map((i) => new interface_1.Interface(transpile, i, linkFormatter2));
      }
      render() {
        if (this.interfaces.length === 0) {
          return markdown_1.Markdown.EMPTY;
        }
        const md = new markdown_1.Markdown({ header: { title: "Protocols" } });
        for (const iface of this.interfaces) {
          md.section(iface.render());
        }
        return md;
      }
    };
    exports.Interfaces = Interfaces;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/struct.js
var require_struct = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/struct.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Struct = void 0;
    var markdown_1 = require_markdown3();
    var property_1 = require_property2();
    var Struct = class {
      constructor(transpile, iface, linkFormatter2) {
        this.transpile = transpile;
        this.iface = iface;
        this.properties = new Array();
        this.transpiled = transpile.struct(iface);
        for (const property of this.iface.allProperties) {
          this.properties.push(new property_1.Property(this.transpile, property, linkFormatter2));
        }
      }
      render() {
        const md = new markdown_1.Markdown({
          id: this.transpiled.type.fqn,
          header: { title: this.transpiled.name }
        });
        if (this.iface.docs) {
          md.docs(this.iface.docs);
        }
        const initializer = new markdown_1.Markdown({
          id: `${this.transpiled.type}.Initializer`,
          header: { title: "Initializer" }
        });
        initializer.code(this.transpile.language.toString(), `${this.transpiled.import}`, "", `${this.transpiled.initialization}`);
        for (const property of this.properties) {
          initializer.section(property.render());
        }
        md.section(initializer);
        return md;
      }
    };
    exports.Struct = Struct;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/structs.js
var require_structs = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/structs.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Structs = void 0;
    var markdown_1 = require_markdown3();
    var interface_1 = require_interface2();
    var struct_1 = require_struct();
    var Structs = class {
      constructor(transpile, interfaces, linkFormatter2) {
        this.structs = interfaces.filter((i) => interface_1.Interface.isStruct(i)).map((i) => new struct_1.Struct(transpile, i, linkFormatter2));
      }
      render() {
        if (this.structs.length === 0) {
          return markdown_1.Markdown.EMPTY;
        }
        const md = new markdown_1.Markdown({ header: { title: "Structs" } });
        for (const struct of this.structs) {
          md.section(struct.render());
        }
        return md;
      }
    };
    exports.Structs = Structs;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/api-reference.js
var require_api_reference = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/api-reference.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.ApiReference = void 0;
    var markdown_1 = require_markdown3();
    var classes_1 = require_classes();
    var constructs_1 = require_constructs();
    var enums_1 = require_enums();
    var interfaces_1 = require_interfaces();
    var structs_1 = require_structs();
    var ApiReference = class {
      constructor(transpile, assembly, linkFormatter2, submodule) {
        const classes = this.sortByName(submodule ? submodule.classes : assembly.classes);
        const interfaces = this.sortByName(submodule ? submodule.interfaces : assembly.interfaces);
        const enums = this.sortByName(submodule ? submodule.enums : assembly.enums);
        this.constructs = new constructs_1.Constructs(transpile, classes, linkFormatter2);
        this.classes = new classes_1.Classes(transpile, classes, linkFormatter2);
        this.structs = new structs_1.Structs(transpile, interfaces, linkFormatter2);
        this.interfaces = new interfaces_1.Interfaces(transpile, interfaces, linkFormatter2);
        this.enums = new enums_1.Enums(transpile, enums);
      }
      render() {
        const md = new markdown_1.Markdown({ header: { title: "API Reference" } });
        md.section(this.constructs.render());
        md.section(this.structs.render());
        md.section(this.classes.render());
        md.section(this.interfaces.render());
        md.section(this.enums.render());
        return md;
      }
      sortByName(arr) {
        return [...arr].sort((s1, s2) => s1.name.localeCompare(s2.name));
      }
    };
    exports.ApiReference = ApiReference;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/readme.js
var require_readme = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/readme.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Readme = void 0;
    var markdown_1 = require_markdown3();
    var Readme = class {
      constructor(transpile, assembly, submodule) {
        const readme = submodule ? submodule.readme : assembly.readme;
        this.readme = readme ? transpile.readme(readme.markdown) : void 0;
      }
      render() {
        if (!this.readme) {
          return markdown_1.Markdown.EMPTY;
        }
        const md = new markdown_1.Markdown();
        if (this.readme) {
          md.lines(this.readme);
        }
        return md;
      }
    };
    exports.Readme = Readme;
  }
});

// node_modules/jsii-docgen/lib/docgen/view/documentation.js
var require_documentation = __commonJS({
  "node_modules/jsii-docgen/lib/docgen/view/documentation.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
            __createBinding(result, mod, k);
      }
      __setModuleDefault(result, mod);
      return result;
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.extractPackageName = exports.Documentation = void 0;
    var os2 = __importStar(require("os"));
    var path2 = __importStar(require("path"));
    var fs2 = __importStar(require_lib2());
    var glob = __importStar(require_lib3());
    var reflect = __importStar(require_lib7());
    var jsii_rosetta_1 = require_lib10();
    var transliterate_1 = require_transliterate();
    var markdown_1 = require_markdown3();
    var java_1 = require_java2();
    var python_1 = require_python2();
    var transpile_1 = require_transpile();
    var typescript_1 = require_typescript2();
    var _npm_1 = require_npm();
    var api_reference_1 = require_api_reference();
    var readme_1 = require_readme();
    var Documentation2 = class {
      constructor(assembly, transpile) {
        this.assembly = assembly;
        this.transpile = transpile;
      }
      static async forPackage(target, options = {}) {
        return withTempDir(async (workdir) => {
          var _a;
          if (await fs2.pathExists(target) && !options.name) {
            throw new Error("'options.name' must be provided when installing local packages.");
          }
          const name = (_a = options === null || options === void 0 ? void 0 : options.name) !== null && _a !== void 0 ? _a : extractPackageName(target);
          const npm = new _npm_1.Npm(workdir);
          console.log(`Installing package ${target}`);
          await npm.install(target);
          return Documentation2.forProject(path2.join(workdir, "node_modules", name), __spreadProps(__spreadValues({}, options), { assembliesDir: workdir }));
        });
      }
      static async forProject(root, options = {}) {
        var _a;
        const manifestPath = path2.join(root, "package.json");
        if (!await fs2.pathExists(manifestPath)) {
          throw new Error(`Unable to locate ${manifestPath}`);
        }
        const assembliesDir = (_a = options === null || options === void 0 ? void 0 : options.assembliesDir) !== null && _a !== void 0 ? _a : root;
        const { name } = JSON.parse(await fs2.readFile(manifestPath, "utf-8"));
        return Documentation2.forAssembly(name, assembliesDir, {
          language: options === null || options === void 0 ? void 0 : options.language,
          loose: options === null || options === void 0 ? void 0 : options.loose
        });
      }
      static async forAssembly(assemblyName, assembliesDir, options) {
        return withTempDir(async (workdir) => {
          var _a, _b;
          await fs2.copy(assembliesDir, workdir);
          let transpile, language;
          switch ((_a = options === null || options === void 0 ? void 0 : options.language) !== null && _a !== void 0 ? _a : transpile_1.Language.TYPESCRIPT) {
            case transpile_1.Language.PYTHON:
              language = jsii_rosetta_1.TargetLanguage.PYTHON;
              transpile = new python_1.PythonTranspile();
              break;
            case transpile_1.Language.TYPESCRIPT:
              transpile = new typescript_1.TypeScriptTranspile();
              break;
            case transpile_1.Language.JAVA:
              language = jsii_rosetta_1.TargetLanguage.JAVA;
              transpile = new java_1.JavaTranspile();
              break;
            default:
              throw new Error(`Unsupported language: ${options === null || options === void 0 ? void 0 : options.language}. Supported languages are ${Object.values(transpile_1.Language)}`);
          }
          const assembly = await createAssembly(assemblyName, workdir, (_b = options === null || options === void 0 ? void 0 : options.loose) !== null && _b !== void 0 ? _b : true, language);
          return new Documentation2(assembly, transpile);
        });
      }
      render(options) {
        var _a, _b, _c;
        const submodule = (options === null || options === void 0 ? void 0 : options.submodule) ? this.findSubmodule(this.assembly, options.submodule) : void 0;
        const documentation = new markdown_1.Markdown();
        if ((_a = options === null || options === void 0 ? void 0 : options.readme) !== null && _a !== void 0 ? _a : true) {
          const readme = new readme_1.Readme(this.transpile, this.assembly, submodule);
          documentation.section(readme.render());
        }
        if ((_b = options === null || options === void 0 ? void 0 : options.apiReference) !== null && _b !== void 0 ? _b : true) {
          const apiReference = new api_reference_1.ApiReference(this.transpile, this.assembly, (_c = options === null || options === void 0 ? void 0 : options.linkFormatter) !== null && _c !== void 0 ? _c : (t) => `#${t.fqn}`, submodule);
          documentation.section(apiReference.render());
        }
        return documentation;
      }
      findSubmodule(assembly, submodule) {
        const submodules = assembly.submodules.filter((s) => s.name === submodule);
        if (submodules.length === 0) {
          throw new Error(`Submodule ${submodule} not found in assembly ${assembly.name}@${assembly.version}`);
        }
        if (submodules.length > 1) {
          throw new Error(`Found multiple submodules with name: ${submodule} in assembly ${assembly.name}@${assembly.version}`);
        }
        return submodules[0];
      }
    };
    exports.Documentation = Documentation2;
    async function withTempDir(work) {
      const workdir = await fs2.mkdtemp(path2.join(os2.tmpdir(), path2.sep));
      const cwd = process.cwd();
      try {
        process.chdir(workdir);
        return await work(workdir);
      } finally {
        process.chdir(cwd);
        await fs2.remove(workdir);
      }
    }
    async function createAssembly(name, tsDir, loose, language) {
      console.log(`Creating assembly in ${language !== null && language !== void 0 ? language : "ts"} for ${name} from ${tsDir} (loose: ${loose})`);
      const ts = new reflect.TypeSystem();
      for (let dotJsii of await glob.promise(`${tsDir}/**/.jsii`)) {
        const spec = JSON.parse(await fs2.readFile(dotJsii, "utf-8"));
        if (language && spec.name === name) {
          const packageDir = path2.dirname(dotJsii);
          await (0, transliterate_1.transliterateAssembly)([packageDir], [language], { loose });
          dotJsii = path2.join(packageDir, `.jsii.${language}`);
        }
        await ts.load(dotJsii);
      }
      return ts.findAssembly(name);
    }
    function extractPackageName(spec) {
      const firstAt = spec.indexOf("@");
      if (firstAt === 0) {
        const lastAt = spec.indexOf("@", firstAt + 1);
        if (lastAt === -1) {
          return spec;
        } else {
          return spec.substring(0, lastAt);
        }
      }
      if (firstAt > 0) {
        return spec.substring(0, firstAt);
      }
      return spec;
    }
    exports.extractPackageName = extractPackageName;
  }
});

// node_modules/jsii-docgen/package.json
var require_package2 = __commonJS({
  "node_modules/jsii-docgen/package.json"(exports, module2) {
    module2.exports = {
      name: "jsii-docgen",
      description: "generates api docs for jsii modules",
      repository: {
        type: "git",
        url: "https://github.com/cdklabs/jsii-docgen"
      },
      bin: {
        "jsii-docgen": "bin/jsii-docgen"
      },
      scripts: {
        clobber: "npx projen clobber",
        compile: "npx projen compile",
        "test:compile": "npx projen test:compile",
        test: "npx projen test",
        build: "npx projen build",
        "test:watch": "npx projen test:watch",
        "test:update": "npx projen test:update",
        bump: "npx projen bump",
        unbump: "npx projen unbump",
        "publish:github": "npx projen publish:github",
        "publish:npm": "npx projen publish:npm",
        default: "npx projen default",
        watch: "npx projen watch",
        package: "npx projen package",
        eslint: "npx projen eslint",
        release: "npx projen release",
        upgrade: "npx projen upgrade",
        projen: "npx projen"
      },
      author: {
        name: "Amazon Web Services",
        url: "https://aws.amazon.com",
        organization: true
      },
      devDependencies: {
        "@types/fs-extra": "^9.0.13",
        "@types/jest": "^26.0.24",
        "@types/node": "^12.7.0",
        "@typescript-eslint/eslint-plugin": "^4.33.0",
        "@typescript-eslint/parser": "^4.33.0",
        eslint: "^6.8.0",
        "eslint-import-resolver-node": "^0.3.6",
        "eslint-import-resolver-typescript": "^2.5.0",
        "eslint-plugin-import": "^2.25.2",
        jest: "^26.6.3",
        "jest-junit": "^12",
        "json-schema": "^0.3.0",
        "npm-check-updates": "^11",
        projen: "^0.30.3",
        "standard-version": "^9",
        "ts-jest": "^26.5.6",
        typescript: "~4.4.4"
      },
      dependencies: {
        "@jsii/spec": "^1.39.0",
        case: "^1.6.3",
        "fs-extra": "^10.0.0",
        glob: "^7.2.0",
        "glob-promise": "^3.4.0",
        "jsii-reflect": "^1.39.0",
        "jsii-rosetta": "^1.39.0",
        yargs: "^16.2.0"
      },
      bundledDependencies: [],
      engines: {
        node: ">= 12.7.0"
      },
      main: "lib/index.js",
      license: "Apache-2.0",
      version: "3.7.10",
      jest: {
        testMatch: [
          "**/__tests__/**/*.ts?(x)",
          "**/?(*.)+(spec|test).ts?(x)"
        ],
        clearMocks: true,
        collectCoverage: true,
        coverageReporters: [
          "json",
          "lcov",
          "clover",
          "text"
        ],
        coverageDirectory: "coverage",
        coveragePathIgnorePatterns: [
          "/node_modules/"
        ],
        testPathIgnorePatterns: [
          "/node_modules/"
        ],
        watchPathIgnorePatterns: [
          "/node_modules/"
        ],
        reporters: [
          "default",
          [
            "jest-junit",
            {
              outputDirectory: "test-reports"
            }
          ]
        ],
        preset: "ts-jest",
        globals: {
          "ts-jest": {
            tsconfig: "tsconfig.dev.json"
          }
        }
      },
      types: "lib/index.d.ts",
      "//": '~~ Generated by projen. To modify, edit .projenrc.js and run "npx projen".'
    };
  }
});

// node_modules/jsii-docgen/lib/errors.js
var require_errors = __commonJS({
  "node_modules/jsii-docgen/lib/errors.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.NpmError = exports.NoSpaceLeftOnDevice = void 0;
    var { name } = require_package2();
    var NoSpaceLeftOnDevice = class extends Error {
      constructor(message, stack) {
        super(message);
        this.name = `${name}.${this.constructor.name}`;
        if (this.stack) {
          this.stack = stack;
        } else {
          Error.captureStackTrace(this, this.constructor);
        }
      }
    };
    exports.NoSpaceLeftOnDevice = NoSpaceLeftOnDevice;
    var NpmError = class extends Error {
      constructor(message, stdio) {
        var _a;
        super(message);
        Error.captureStackTrace(this, this.constructor);
        this.stdout = Buffer.concat(stdio.stdout).toString("utf-8");
        this.stderr = Buffer.concat(stdio.stderr).toString("utf-8");
        this.name = `${name}.${this.constructor.name}`;
        const ERROR_CODE_REGEX = /^npm\s+ERR!\s+(?:code|errno)\s+(E[^\s]+|\d+)$/gm;
        for (const output of [this.stderr, this.stdout]) {
          const [, match] = (_a = ERROR_CODE_REGEX.exec(output)) !== null && _a !== void 0 ? _a : [];
          if (match) {
            this.npmErrorCode = match;
            this.name += `.${this.npmErrorCode}`;
            break;
          }
        }
      }
      toJSON() {
        return {
          name: this.name,
          message: this.message,
          stack: this.stack,
          npmErrorCode: this.npmErrorCode
        };
      }
    };
    exports.NpmError = NpmError;
  }
});

// node_modules/jsii-docgen/lib/index.js
var require_lib11 = __commonJS({
  "node_modules/jsii-docgen/lib/index.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p))
          __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.UnsupportedLanguageError = exports.Language = exports.Documentation = void 0;
    var documentation_1 = require_documentation();
    Object.defineProperty(exports, "Documentation", { enumerable: true, get: function() {
      return documentation_1.Documentation;
    } });
    var transpile_1 = require_transpile();
    Object.defineProperty(exports, "Language", { enumerable: true, get: function() {
      return transpile_1.Language;
    } });
    var transpile_2 = require_transpile();
    Object.defineProperty(exports, "UnsupportedLanguageError", { enumerable: true, get: function() {
      return transpile_2.UnsupportedLanguageError;
    } });
    __exportStar(require_errors(), exports);
  }
});

// node_modules/aws-sdk/lib/json/builder.js
var require_builder = __commonJS({
  "node_modules/aws-sdk/lib/json/builder.js"(exports, module2) {
    var util = require_util4();
    function JsonBuilder() {
    }
    JsonBuilder.prototype.build = function(value, shape) {
      return JSON.stringify(translate(value, shape));
    };
    function translate(value, shape) {
      if (!shape || value === void 0 || value === null)
        return void 0;
      switch (shape.type) {
        case "structure":
          return translateStructure(value, shape);
        case "map":
          return translateMap(value, shape);
        case "list":
          return translateList(value, shape);
        default:
          return translateScalar(value, shape);
      }
    }
    function translateStructure(structure, shape) {
      if (shape.isDocument) {
        return structure;
      }
      var struct = {};
      util.each(structure, function(name, value) {
        var memberShape = shape.members[name];
        if (memberShape) {
          if (memberShape.location !== "body")
            return;
          var locationName = memberShape.isLocationName ? memberShape.name : name;
          var result = translate(value, memberShape);
          if (result !== void 0)
            struct[locationName] = result;
        }
      });
      return struct;
    }
    function translateList(list, shape) {
      var out = [];
      util.arrayEach(list, function(value) {
        var result = translate(value, shape.member);
        if (result !== void 0)
          out.push(result);
      });
      return out;
    }
    function translateMap(map, shape) {
      var out = {};
      util.each(map, function(key, value) {
        var result = translate(value, shape.value);
        if (result !== void 0)
          out[key] = result;
      });
      return out;
    }
    function translateScalar(value, shape) {
      return shape.toWireFormat(value);
    }
    module2.exports = JsonBuilder;
  }
});

// node_modules/aws-sdk/lib/json/parser.js
var require_parser = __commonJS({
  "node_modules/aws-sdk/lib/json/parser.js"(exports, module2) {
    var util = require_util4();
    function JsonParser() {
    }
    JsonParser.prototype.parse = function(value, shape) {
      return translate(JSON.parse(value), shape);
    };
    function translate(value, shape) {
      if (!shape || value === void 0)
        return void 0;
      switch (shape.type) {
        case "structure":
          return translateStructure(value, shape);
        case "map":
          return translateMap(value, shape);
        case "list":
          return translateList(value, shape);
        default:
          return translateScalar(value, shape);
      }
    }
    function translateStructure(structure, shape) {
      if (structure == null)
        return void 0;
      if (shape.isDocument)
        return structure;
      var struct = {};
      var shapeMembers = shape.members;
      util.each(shapeMembers, function(name, memberShape) {
        var locationName = memberShape.isLocationName ? memberShape.name : name;
        if (Object.prototype.hasOwnProperty.call(structure, locationName)) {
          var value = structure[locationName];
          var result = translate(value, memberShape);
          if (result !== void 0)
            struct[name] = result;
        }
      });
      return struct;
    }
    function translateList(list, shape) {
      if (list == null)
        return void 0;
      var out = [];
      util.arrayEach(list, function(value) {
        var result = translate(value, shape.member);
        if (result === void 0)
          out.push(null);
        else
          out.push(result);
      });
      return out;
    }
    function translateMap(map, shape) {
      if (map == null)
        return void 0;
      var out = {};
      util.each(map, function(key, value) {
        var result = translate(value, shape.value);
        if (result === void 0)
          out[key] = null;
        else
          out[key] = result;
      });
      return out;
    }
    function translateScalar(value, shape) {
      return shape.toType(value);
    }
    module2.exports = JsonParser;
  }
});

// node_modules/aws-sdk/lib/protocol/helpers.js
var require_helpers2 = __commonJS({
  "node_modules/aws-sdk/lib/protocol/helpers.js"(exports, module2) {
    var util = require_util4();
    var AWS3 = require_core();
    function populateHostPrefix(request) {
      var enabled = request.service.config.hostPrefixEnabled;
      if (!enabled)
        return request;
      var operationModel = request.service.api.operations[request.operation];
      if (hasEndpointDiscover(request))
        return request;
      if (operationModel.endpoint && operationModel.endpoint.hostPrefix) {
        var hostPrefixNotation = operationModel.endpoint.hostPrefix;
        var hostPrefix = expandHostPrefix(hostPrefixNotation, request.params, operationModel.input);
        prependEndpointPrefix(request.httpRequest.endpoint, hostPrefix);
        validateHostname(request.httpRequest.endpoint.hostname);
      }
      return request;
    }
    function hasEndpointDiscover(request) {
      var api = request.service.api;
      var operationModel = api.operations[request.operation];
      var isEndpointOperation = api.endpointOperation && api.endpointOperation === util.string.lowerFirst(operationModel.name);
      return operationModel.endpointDiscoveryRequired !== "NULL" || isEndpointOperation === true;
    }
    function expandHostPrefix(hostPrefixNotation, params, shape) {
      util.each(shape.members, function(name, member) {
        if (member.hostLabel === true) {
          if (typeof params[name] !== "string" || params[name] === "") {
            throw util.error(new Error(), {
              message: "Parameter " + name + " should be a non-empty string.",
              code: "InvalidParameter"
            });
          }
          var regex = new RegExp("\\{" + name + "\\}", "g");
          hostPrefixNotation = hostPrefixNotation.replace(regex, params[name]);
        }
      });
      return hostPrefixNotation;
    }
    function prependEndpointPrefix(endpoint, prefix) {
      if (endpoint.host) {
        endpoint.host = prefix + endpoint.host;
      }
      if (endpoint.hostname) {
        endpoint.hostname = prefix + endpoint.hostname;
      }
    }
    function validateHostname(hostname) {
      var labels = hostname.split(".");
      var hostPattern = /^[a-zA-Z0-9]{1}$|^[a-zA-Z0-9][a-zA-Z0-9\-]*[a-zA-Z0-9]$/;
      util.arrayEach(labels, function(label) {
        if (!label.length || label.length < 1 || label.length > 63) {
          throw util.error(new Error(), {
            code: "ValidationError",
            message: "Hostname label length should be between 1 to 63 characters, inclusive."
          });
        }
        if (!hostPattern.test(label)) {
          throw AWS3.util.error(new Error(), { code: "ValidationError", message: label + " is not hostname compatible." });
        }
      });
    }
    module2.exports = {
      populateHostPrefix
    };
  }
});

// node_modules/aws-sdk/lib/protocol/json.js
var require_json3 = __commonJS({
  "node_modules/aws-sdk/lib/protocol/json.js"(exports, module2) {
    var util = require_util4();
    var JsonBuilder = require_builder();
    var JsonParser = require_parser();
    var populateHostPrefix = require_helpers2().populateHostPrefix;
    function buildRequest(req) {
      var httpRequest = req.httpRequest;
      var api = req.service.api;
      var target = api.targetPrefix + "." + api.operations[req.operation].name;
      var version = api.jsonVersion || "1.0";
      var input = api.operations[req.operation].input;
      var builder = new JsonBuilder();
      if (version === 1)
        version = "1.0";
      httpRequest.body = builder.build(req.params || {}, input);
      httpRequest.headers["Content-Type"] = "application/x-amz-json-" + version;
      httpRequest.headers["X-Amz-Target"] = target;
      populateHostPrefix(req);
    }
    function extractError(resp) {
      var error = {};
      var httpResponse = resp.httpResponse;
      error.code = httpResponse.headers["x-amzn-errortype"] || "UnknownError";
      if (typeof error.code === "string") {
        error.code = error.code.split(":")[0];
      }
      if (httpResponse.body.length > 0) {
        try {
          var e = JSON.parse(httpResponse.body.toString());
          var code = e.__type || e.code || e.Code;
          if (code) {
            error.code = code.split("#").pop();
          }
          if (error.code === "RequestEntityTooLarge") {
            error.message = "Request body must be less than 1 MB";
          } else {
            error.message = e.message || e.Message || null;
          }
        } catch (e2) {
          error.statusCode = httpResponse.statusCode;
          error.message = httpResponse.statusMessage;
        }
      } else {
        error.statusCode = httpResponse.statusCode;
        error.message = httpResponse.statusCode.toString();
      }
      resp.error = util.error(new Error(), error);
    }
    function extractData(resp) {
      var body = resp.httpResponse.body.toString() || "{}";
      if (resp.request.service.config.convertResponseTypes === false) {
        resp.data = JSON.parse(body);
      } else {
        var operation = resp.request.service.api.operations[resp.request.operation];
        var shape = operation.output || {};
        var parser = new JsonParser();
        resp.data = parser.parse(body, shape);
      }
    }
    module2.exports = {
      buildRequest,
      extractError,
      extractData
    };
  }
});

// node_modules/aws-sdk/lib/query/query_param_serializer.js
var require_query_param_serializer = __commonJS({
  "node_modules/aws-sdk/lib/query/query_param_serializer.js"(exports, module2) {
    var util = require_util4();
    function QueryParamSerializer() {
    }
    QueryParamSerializer.prototype.serialize = function(params, shape, fn) {
      serializeStructure("", params, shape, fn);
    };
    function ucfirst(shape) {
      if (shape.isQueryName || shape.api.protocol !== "ec2") {
        return shape.name;
      } else {
        return shape.name[0].toUpperCase() + shape.name.substr(1);
      }
    }
    function serializeStructure(prefix, struct, rules, fn) {
      util.each(rules.members, function(name, member) {
        var value = struct[name];
        if (value === null || value === void 0)
          return;
        var memberName = ucfirst(member);
        memberName = prefix ? prefix + "." + memberName : memberName;
        serializeMember(memberName, value, member, fn);
      });
    }
    function serializeMap(name, map, rules, fn) {
      var i = 1;
      util.each(map, function(key, value) {
        var prefix = rules.flattened ? "." : ".entry.";
        var position = prefix + i++ + ".";
        var keyName = position + (rules.key.name || "key");
        var valueName = position + (rules.value.name || "value");
        serializeMember(name + keyName, key, rules.key, fn);
        serializeMember(name + valueName, value, rules.value, fn);
      });
    }
    function serializeList(name, list, rules, fn) {
      var memberRules = rules.member || {};
      if (list.length === 0) {
        fn.call(this, name, null);
        return;
      }
      util.arrayEach(list, function(v, n) {
        var suffix = "." + (n + 1);
        if (rules.api.protocol === "ec2") {
          suffix = suffix + "";
        } else if (rules.flattened) {
          if (memberRules.name) {
            var parts = name.split(".");
            parts.pop();
            parts.push(ucfirst(memberRules));
            name = parts.join(".");
          }
        } else {
          suffix = "." + (memberRules.name ? memberRules.name : "member") + suffix;
        }
        serializeMember(name + suffix, v, memberRules, fn);
      });
    }
    function serializeMember(name, value, rules, fn) {
      if (value === null || value === void 0)
        return;
      if (rules.type === "structure") {
        serializeStructure(name, value, rules, fn);
      } else if (rules.type === "list") {
        serializeList(name, value, rules, fn);
      } else if (rules.type === "map") {
        serializeMap(name, value, rules, fn);
      } else {
        fn(name, rules.toWireFormat(value).toString());
      }
    }
    module2.exports = QueryParamSerializer;
  }
});

// node_modules/aws-sdk/lib/model/collection.js
var require_collection = __commonJS({
  "node_modules/aws-sdk/lib/model/collection.js"(exports, module2) {
    var memoizedProperty = require_util4().memoizedProperty;
    function memoize(name, value, factory, nameTr) {
      memoizedProperty(this, nameTr(name), function() {
        return factory(name, value);
      });
    }
    function Collection(iterable, options, factory, nameTr, callback) {
      nameTr = nameTr || String;
      var self2 = this;
      for (var id in iterable) {
        if (Object.prototype.hasOwnProperty.call(iterable, id)) {
          memoize.call(self2, id, iterable[id], factory, nameTr);
          if (callback)
            callback(id, iterable[id]);
        }
      }
    }
    module2.exports = Collection;
  }
});

// node_modules/aws-sdk/lib/model/shape.js
var require_shape = __commonJS({
  "node_modules/aws-sdk/lib/model/shape.js"(exports, module2) {
    var Collection = require_collection();
    var util = require_util4();
    function property(obj, name, value) {
      if (value !== null && value !== void 0) {
        util.property.apply(this, arguments);
      }
    }
    function memoizedProperty(obj, name) {
      if (!obj.constructor.prototype[name]) {
        util.memoizedProperty.apply(this, arguments);
      }
    }
    function Shape(shape, options, memberName) {
      options = options || {};
      property(this, "shape", shape.shape);
      property(this, "api", options.api, false);
      property(this, "type", shape.type);
      property(this, "enum", shape.enum);
      property(this, "min", shape.min);
      property(this, "max", shape.max);
      property(this, "pattern", shape.pattern);
      property(this, "location", shape.location || this.location || "body");
      property(this, "name", this.name || shape.xmlName || shape.queryName || shape.locationName || memberName);
      property(this, "isStreaming", shape.streaming || this.isStreaming || false);
      property(this, "requiresLength", shape.requiresLength, false);
      property(this, "isComposite", shape.isComposite || false);
      property(this, "isShape", true, false);
      property(this, "isQueryName", Boolean(shape.queryName), false);
      property(this, "isLocationName", Boolean(shape.locationName), false);
      property(this, "isIdempotent", shape.idempotencyToken === true);
      property(this, "isJsonValue", shape.jsonvalue === true);
      property(this, "isSensitive", shape.sensitive === true || shape.prototype && shape.prototype.sensitive === true);
      property(this, "isEventStream", Boolean(shape.eventstream), false);
      property(this, "isEvent", Boolean(shape.event), false);
      property(this, "isEventPayload", Boolean(shape.eventpayload), false);
      property(this, "isEventHeader", Boolean(shape.eventheader), false);
      property(this, "isTimestampFormatSet", Boolean(shape.timestampFormat) || shape.prototype && shape.prototype.isTimestampFormatSet === true, false);
      property(this, "endpointDiscoveryId", Boolean(shape.endpointdiscoveryid), false);
      property(this, "hostLabel", Boolean(shape.hostLabel), false);
      if (options.documentation) {
        property(this, "documentation", shape.documentation);
        property(this, "documentationUrl", shape.documentationUrl);
      }
      if (shape.xmlAttribute) {
        property(this, "isXmlAttribute", shape.xmlAttribute || false);
      }
      property(this, "defaultValue", null);
      this.toWireFormat = function(value) {
        if (value === null || value === void 0)
          return "";
        return value;
      };
      this.toType = function(value) {
        return value;
      };
    }
    Shape.normalizedTypes = {
      character: "string",
      double: "float",
      long: "integer",
      short: "integer",
      biginteger: "integer",
      bigdecimal: "float",
      blob: "binary"
    };
    Shape.types = {
      "structure": StructureShape,
      "list": ListShape,
      "map": MapShape,
      "boolean": BooleanShape,
      "timestamp": TimestampShape,
      "float": FloatShape,
      "integer": IntegerShape,
      "string": StringShape,
      "base64": Base64Shape,
      "binary": BinaryShape
    };
    Shape.resolve = function resolve(shape, options) {
      if (shape.shape) {
        var refShape = options.api.shapes[shape.shape];
        if (!refShape) {
          throw new Error("Cannot find shape reference: " + shape.shape);
        }
        return refShape;
      } else {
        return null;
      }
    };
    Shape.create = function create(shape, options, memberName) {
      if (shape.isShape)
        return shape;
      var refShape = Shape.resolve(shape, options);
      if (refShape) {
        var filteredKeys = Object.keys(shape);
        if (!options.documentation) {
          filteredKeys = filteredKeys.filter(function(name) {
            return !name.match(/documentation/);
          });
        }
        var InlineShape = function() {
          refShape.constructor.call(this, shape, options, memberName);
        };
        InlineShape.prototype = refShape;
        return new InlineShape();
      } else {
        if (!shape.type) {
          if (shape.members)
            shape.type = "structure";
          else if (shape.member)
            shape.type = "list";
          else if (shape.key)
            shape.type = "map";
          else
            shape.type = "string";
        }
        var origType = shape.type;
        if (Shape.normalizedTypes[shape.type]) {
          shape.type = Shape.normalizedTypes[shape.type];
        }
        if (Shape.types[shape.type]) {
          return new Shape.types[shape.type](shape, options, memberName);
        } else {
          throw new Error("Unrecognized shape type: " + origType);
        }
      }
    };
    function CompositeShape(shape) {
      Shape.apply(this, arguments);
      property(this, "isComposite", true);
      if (shape.flattened) {
        property(this, "flattened", shape.flattened || false);
      }
    }
    function StructureShape(shape, options) {
      var self2 = this;
      var requiredMap = null, firstInit = !this.isShape;
      CompositeShape.apply(this, arguments);
      if (firstInit) {
        property(this, "defaultValue", function() {
          return {};
        });
        property(this, "members", {});
        property(this, "memberNames", []);
        property(this, "required", []);
        property(this, "isRequired", function() {
          return false;
        });
        property(this, "isDocument", Boolean(shape.document));
      }
      if (shape.members) {
        property(this, "members", new Collection(shape.members, options, function(name, member) {
          return Shape.create(member, options, name);
        }));
        memoizedProperty(this, "memberNames", function() {
          return shape.xmlOrder || Object.keys(shape.members);
        });
        if (shape.event) {
          memoizedProperty(this, "eventPayloadMemberName", function() {
            var members = self2.members;
            var memberNames = self2.memberNames;
            for (var i = 0, iLen = memberNames.length; i < iLen; i++) {
              if (members[memberNames[i]].isEventPayload) {
                return memberNames[i];
              }
            }
          });
          memoizedProperty(this, "eventHeaderMemberNames", function() {
            var members = self2.members;
            var memberNames = self2.memberNames;
            var eventHeaderMemberNames = [];
            for (var i = 0, iLen = memberNames.length; i < iLen; i++) {
              if (members[memberNames[i]].isEventHeader) {
                eventHeaderMemberNames.push(memberNames[i]);
              }
            }
            return eventHeaderMemberNames;
          });
        }
      }
      if (shape.required) {
        property(this, "required", shape.required);
        property(this, "isRequired", function(name) {
          if (!requiredMap) {
            requiredMap = {};
            for (var i = 0; i < shape.required.length; i++) {
              requiredMap[shape.required[i]] = true;
            }
          }
          return requiredMap[name];
        }, false, true);
      }
      property(this, "resultWrapper", shape.resultWrapper || null);
      if (shape.payload) {
        property(this, "payload", shape.payload);
      }
      if (typeof shape.xmlNamespace === "string") {
        property(this, "xmlNamespaceUri", shape.xmlNamespace);
      } else if (typeof shape.xmlNamespace === "object") {
        property(this, "xmlNamespacePrefix", shape.xmlNamespace.prefix);
        property(this, "xmlNamespaceUri", shape.xmlNamespace.uri);
      }
    }
    function ListShape(shape, options) {
      var self2 = this, firstInit = !this.isShape;
      CompositeShape.apply(this, arguments);
      if (firstInit) {
        property(this, "defaultValue", function() {
          return [];
        });
      }
      if (shape.member) {
        memoizedProperty(this, "member", function() {
          return Shape.create(shape.member, options);
        });
      }
      if (this.flattened) {
        var oldName = this.name;
        memoizedProperty(this, "name", function() {
          return self2.member.name || oldName;
        });
      }
    }
    function MapShape(shape, options) {
      var firstInit = !this.isShape;
      CompositeShape.apply(this, arguments);
      if (firstInit) {
        property(this, "defaultValue", function() {
          return {};
        });
        property(this, "key", Shape.create({ type: "string" }, options));
        property(this, "value", Shape.create({ type: "string" }, options));
      }
      if (shape.key) {
        memoizedProperty(this, "key", function() {
          return Shape.create(shape.key, options);
        });
      }
      if (shape.value) {
        memoizedProperty(this, "value", function() {
          return Shape.create(shape.value, options);
        });
      }
    }
    function TimestampShape(shape) {
      var self2 = this;
      Shape.apply(this, arguments);
      if (shape.timestampFormat) {
        property(this, "timestampFormat", shape.timestampFormat);
      } else if (self2.isTimestampFormatSet && this.timestampFormat) {
        property(this, "timestampFormat", this.timestampFormat);
      } else if (this.location === "header") {
        property(this, "timestampFormat", "rfc822");
      } else if (this.location === "querystring") {
        property(this, "timestampFormat", "iso8601");
      } else if (this.api) {
        switch (this.api.protocol) {
          case "json":
          case "rest-json":
            property(this, "timestampFormat", "unixTimestamp");
            break;
          case "rest-xml":
          case "query":
          case "ec2":
            property(this, "timestampFormat", "iso8601");
            break;
        }
      }
      this.toType = function(value) {
        if (value === null || value === void 0)
          return null;
        if (typeof value.toUTCString === "function")
          return value;
        return typeof value === "string" || typeof value === "number" ? util.date.parseTimestamp(value) : null;
      };
      this.toWireFormat = function(value) {
        return util.date.format(value, self2.timestampFormat);
      };
    }
    function StringShape() {
      Shape.apply(this, arguments);
      var nullLessProtocols = ["rest-xml", "query", "ec2"];
      this.toType = function(value) {
        value = this.api && nullLessProtocols.indexOf(this.api.protocol) > -1 ? value || "" : value;
        if (this.isJsonValue) {
          return JSON.parse(value);
        }
        return value && typeof value.toString === "function" ? value.toString() : value;
      };
      this.toWireFormat = function(value) {
        return this.isJsonValue ? JSON.stringify(value) : value;
      };
    }
    function FloatShape() {
      Shape.apply(this, arguments);
      this.toType = function(value) {
        if (value === null || value === void 0)
          return null;
        return parseFloat(value);
      };
      this.toWireFormat = this.toType;
    }
    function IntegerShape() {
      Shape.apply(this, arguments);
      this.toType = function(value) {
        if (value === null || value === void 0)
          return null;
        return parseInt(value, 10);
      };
      this.toWireFormat = this.toType;
    }
    function BinaryShape() {
      Shape.apply(this, arguments);
      this.toType = function(value) {
        var buf = util.base64.decode(value);
        if (this.isSensitive && util.isNode() && typeof util.Buffer.alloc === "function") {
          var secureBuf = util.Buffer.alloc(buf.length, buf);
          buf.fill(0);
          buf = secureBuf;
        }
        return buf;
      };
      this.toWireFormat = util.base64.encode;
    }
    function Base64Shape() {
      BinaryShape.apply(this, arguments);
    }
    function BooleanShape() {
      Shape.apply(this, arguments);
      this.toType = function(value) {
        if (typeof value === "boolean")
          return value;
        if (value === null || value === void 0)
          return null;
        return value === "true";
      };
    }
    Shape.shapes = {
      StructureShape,
      ListShape,
      MapShape,
      StringShape,
      BooleanShape,
      Base64Shape
    };
    module2.exports = Shape;
  }
});

// node_modules/aws-sdk/lib/protocol/query.js
var require_query = __commonJS({
  "node_modules/aws-sdk/lib/protocol/query.js"(exports, module2) {
    var AWS3 = require_core();
    var util = require_util4();
    var QueryParamSerializer = require_query_param_serializer();
    var Shape = require_shape();
    var populateHostPrefix = require_helpers2().populateHostPrefix;
    function buildRequest(req) {
      var operation = req.service.api.operations[req.operation];
      var httpRequest = req.httpRequest;
      httpRequest.headers["Content-Type"] = "application/x-www-form-urlencoded; charset=utf-8";
      httpRequest.params = {
        Version: req.service.api.apiVersion,
        Action: operation.name
      };
      var builder = new QueryParamSerializer();
      builder.serialize(req.params, operation.input, function(name, value) {
        httpRequest.params[name] = value;
      });
      httpRequest.body = util.queryParamsToString(httpRequest.params);
      populateHostPrefix(req);
    }
    function extractError(resp) {
      var data, body = resp.httpResponse.body.toString();
      if (body.match("<UnknownOperationException")) {
        data = {
          Code: "UnknownOperation",
          Message: "Unknown operation " + resp.request.operation
        };
      } else {
        try {
          data = new AWS3.XML.Parser().parse(body);
        } catch (e) {
          data = {
            Code: resp.httpResponse.statusCode,
            Message: resp.httpResponse.statusMessage
          };
        }
      }
      if (data.requestId && !resp.requestId)
        resp.requestId = data.requestId;
      if (data.Errors)
        data = data.Errors;
      if (data.Error)
        data = data.Error;
      if (data.Code) {
        resp.error = util.error(new Error(), {
          code: data.Code,
          message: data.Message
        });
      } else {
        resp.error = util.error(new Error(), {
          code: resp.httpResponse.statusCode,
          message: null
        });
      }
    }
    function extractData(resp) {
      var req = resp.request;
      var operation = req.service.api.operations[req.operation];
      var shape = operation.output || {};
      var origRules = shape;
      if (origRules.resultWrapper) {
        var tmp = Shape.create({ type: "structure" });
        tmp.members[origRules.resultWrapper] = shape;
        tmp.memberNames = [origRules.resultWrapper];
        util.property(shape, "name", shape.resultWrapper);
        shape = tmp;
      }
      var parser = new AWS3.XML.Parser();
      if (shape && shape.members && !shape.members._XAMZRequestId) {
        var requestIdShape = Shape.create({ type: "string" }, { api: { protocol: "query" } }, "requestId");
        shape.members._XAMZRequestId = requestIdShape;
      }
      var data = parser.parse(resp.httpResponse.body.toString(), shape);
      resp.requestId = data._XAMZRequestId || data.requestId;
      if (data._XAMZRequestId)
        delete data._XAMZRequestId;
      if (origRules.resultWrapper) {
        if (data[origRules.resultWrapper]) {
          util.update(data, data[origRules.resultWrapper]);
          delete data[origRules.resultWrapper];
        }
      }
      resp.data = data;
    }
    module2.exports = {
      buildRequest,
      extractError,
      extractData
    };
  }
});

// node_modules/aws-sdk/lib/protocol/rest.js
var require_rest = __commonJS({
  "node_modules/aws-sdk/lib/protocol/rest.js"(exports, module2) {
    var util = require_util4();
    var populateHostPrefix = require_helpers2().populateHostPrefix;
    function populateMethod(req) {
      req.httpRequest.method = req.service.api.operations[req.operation].httpMethod;
    }
    function generateURI(endpointPath, operationPath, input, params) {
      var uri = [endpointPath, operationPath].join("/");
      uri = uri.replace(/\/+/g, "/");
      var queryString = {}, queryStringSet = false;
      util.each(input.members, function(name, member) {
        var paramValue = params[name];
        if (paramValue === null || paramValue === void 0)
          return;
        if (member.location === "uri") {
          var regex = new RegExp("\\{" + member.name + "(\\+)?\\}");
          uri = uri.replace(regex, function(_, plus) {
            var fn = plus ? util.uriEscapePath : util.uriEscape;
            return fn(String(paramValue));
          });
        } else if (member.location === "querystring") {
          queryStringSet = true;
          if (member.type === "list") {
            queryString[member.name] = paramValue.map(function(val) {
              return util.uriEscape(member.member.toWireFormat(val).toString());
            });
          } else if (member.type === "map") {
            util.each(paramValue, function(key, value) {
              if (Array.isArray(value)) {
                queryString[key] = value.map(function(val) {
                  return util.uriEscape(String(val));
                });
              } else {
                queryString[key] = util.uriEscape(String(value));
              }
            });
          } else {
            queryString[member.name] = util.uriEscape(member.toWireFormat(paramValue).toString());
          }
        }
      });
      if (queryStringSet) {
        uri += uri.indexOf("?") >= 0 ? "&" : "?";
        var parts = [];
        util.arrayEach(Object.keys(queryString).sort(), function(key) {
          if (!Array.isArray(queryString[key])) {
            queryString[key] = [queryString[key]];
          }
          for (var i = 0; i < queryString[key].length; i++) {
            parts.push(util.uriEscape(String(key)) + "=" + queryString[key][i]);
          }
        });
        uri += parts.join("&");
      }
      return uri;
    }
    function populateURI(req) {
      var operation = req.service.api.operations[req.operation];
      var input = operation.input;
      var uri = generateURI(req.httpRequest.endpoint.path, operation.httpPath, input, req.params);
      req.httpRequest.path = uri;
    }
    function populateHeaders(req) {
      var operation = req.service.api.operations[req.operation];
      util.each(operation.input.members, function(name, member) {
        var value = req.params[name];
        if (value === null || value === void 0)
          return;
        if (member.location === "headers" && member.type === "map") {
          util.each(value, function(key, memberValue) {
            req.httpRequest.headers[member.name + key] = memberValue;
          });
        } else if (member.location === "header") {
          value = member.toWireFormat(value).toString();
          if (member.isJsonValue) {
            value = util.base64.encode(value);
          }
          req.httpRequest.headers[member.name] = value;
        }
      });
    }
    function buildRequest(req) {
      populateMethod(req);
      populateURI(req);
      populateHeaders(req);
      populateHostPrefix(req);
    }
    function extractError() {
    }
    function extractData(resp) {
      var req = resp.request;
      var data = {};
      var r = resp.httpResponse;
      var operation = req.service.api.operations[req.operation];
      var output = operation.output;
      var headers = {};
      util.each(r.headers, function(k, v) {
        headers[k.toLowerCase()] = v;
      });
      util.each(output.members, function(name, member) {
        var header = (member.name || name).toLowerCase();
        if (member.location === "headers" && member.type === "map") {
          data[name] = {};
          var location = member.isLocationName ? member.name : "";
          var pattern = new RegExp("^" + location + "(.+)", "i");
          util.each(r.headers, function(k, v) {
            var result = k.match(pattern);
            if (result !== null) {
              data[name][result[1]] = v;
            }
          });
        } else if (member.location === "header") {
          if (headers[header] !== void 0) {
            var value = member.isJsonValue ? util.base64.decode(headers[header]) : headers[header];
            data[name] = member.toType(value);
          }
        } else if (member.location === "statusCode") {
          data[name] = parseInt(r.statusCode, 10);
        }
      });
      resp.data = data;
    }
    module2.exports = {
      buildRequest,
      extractError,
      extractData,
      generateURI
    };
  }
});

// node_modules/aws-sdk/lib/protocol/rest_json.js
var require_rest_json = __commonJS({
  "node_modules/aws-sdk/lib/protocol/rest_json.js"(exports, module2) {
    var util = require_util4();
    var Rest = require_rest();
    var Json = require_json3();
    var JsonBuilder = require_builder();
    var JsonParser = require_parser();
    function populateBody(req) {
      var builder = new JsonBuilder();
      var input = req.service.api.operations[req.operation].input;
      if (input.payload) {
        var params = {};
        var payloadShape = input.members[input.payload];
        params = req.params[input.payload];
        if (params === void 0)
          return;
        if (payloadShape.type === "structure") {
          req.httpRequest.body = builder.build(params, payloadShape);
          applyContentTypeHeader(req);
        } else {
          req.httpRequest.body = params;
          if (payloadShape.type === "binary" || payloadShape.isStreaming) {
            applyContentTypeHeader(req, true);
          }
        }
      } else {
        var body = builder.build(req.params, input);
        if (body !== "{}" || req.httpRequest.method !== "GET") {
          req.httpRequest.body = body;
        }
        applyContentTypeHeader(req);
      }
    }
    function applyContentTypeHeader(req, isBinary) {
      var operation = req.service.api.operations[req.operation];
      var input = operation.input;
      if (!req.httpRequest.headers["Content-Type"]) {
        var type = isBinary ? "binary/octet-stream" : "application/json";
        req.httpRequest.headers["Content-Type"] = type;
      }
    }
    function buildRequest(req) {
      Rest.buildRequest(req);
      if (["HEAD", "DELETE"].indexOf(req.httpRequest.method) < 0) {
        populateBody(req);
      }
    }
    function extractError(resp) {
      Json.extractError(resp);
    }
    function extractData(resp) {
      Rest.extractData(resp);
      var req = resp.request;
      var operation = req.service.api.operations[req.operation];
      var rules = req.service.api.operations[req.operation].output || {};
      var parser;
      var hasEventOutput = operation.hasEventOutput;
      if (rules.payload) {
        var payloadMember = rules.members[rules.payload];
        var body = resp.httpResponse.body;
        if (payloadMember.isEventStream) {
          parser = new JsonParser();
          resp.data[payload] = util.createEventStream(AWS.HttpClient.streamsApiVersion === 2 ? resp.httpResponse.stream : body, parser, payloadMember);
        } else if (payloadMember.type === "structure" || payloadMember.type === "list") {
          var parser = new JsonParser();
          resp.data[rules.payload] = parser.parse(body, payloadMember);
        } else if (payloadMember.type === "binary" || payloadMember.isStreaming) {
          resp.data[rules.payload] = body;
        } else {
          resp.data[rules.payload] = payloadMember.toType(body);
        }
      } else {
        var data = resp.data;
        Json.extractData(resp);
        resp.data = util.merge(data, resp.data);
      }
    }
    module2.exports = {
      buildRequest,
      extractError,
      extractData
    };
  }
});

// node_modules/aws-sdk/lib/protocol/rest_xml.js
var require_rest_xml = __commonJS({
  "node_modules/aws-sdk/lib/protocol/rest_xml.js"(exports, module2) {
    var AWS3 = require_core();
    var util = require_util4();
    var Rest = require_rest();
    function populateBody(req) {
      var input = req.service.api.operations[req.operation].input;
      var builder = new AWS3.XML.Builder();
      var params = req.params;
      var payload2 = input.payload;
      if (payload2) {
        var payloadMember = input.members[payload2];
        params = params[payload2];
        if (params === void 0)
          return;
        if (payloadMember.type === "structure") {
          var rootElement = payloadMember.name;
          req.httpRequest.body = builder.toXML(params, payloadMember, rootElement, true);
        } else {
          req.httpRequest.body = params;
        }
      } else {
        req.httpRequest.body = builder.toXML(params, input, input.name || input.shape || util.string.upperFirst(req.operation) + "Request");
      }
    }
    function buildRequest(req) {
      Rest.buildRequest(req);
      if (["GET", "HEAD"].indexOf(req.httpRequest.method) < 0) {
        populateBody(req);
      }
    }
    function extractError(resp) {
      Rest.extractError(resp);
      var data;
      try {
        data = new AWS3.XML.Parser().parse(resp.httpResponse.body.toString());
      } catch (e) {
        data = {
          Code: resp.httpResponse.statusCode,
          Message: resp.httpResponse.statusMessage
        };
      }
      if (data.Errors)
        data = data.Errors;
      if (data.Error)
        data = data.Error;
      if (data.Code) {
        resp.error = util.error(new Error(), {
          code: data.Code,
          message: data.Message
        });
      } else {
        resp.error = util.error(new Error(), {
          code: resp.httpResponse.statusCode,
          message: null
        });
      }
    }
    function extractData(resp) {
      Rest.extractData(resp);
      var parser;
      var req = resp.request;
      var body = resp.httpResponse.body;
      var operation = req.service.api.operations[req.operation];
      var output = operation.output;
      var hasEventOutput = operation.hasEventOutput;
      var payload2 = output.payload;
      if (payload2) {
        var payloadMember = output.members[payload2];
        if (payloadMember.isEventStream) {
          parser = new AWS3.XML.Parser();
          resp.data[payload2] = util.createEventStream(AWS3.HttpClient.streamsApiVersion === 2 ? resp.httpResponse.stream : resp.httpResponse.body, parser, payloadMember);
        } else if (payloadMember.type === "structure") {
          parser = new AWS3.XML.Parser();
          resp.data[payload2] = parser.parse(body.toString(), payloadMember);
        } else if (payloadMember.type === "binary" || payloadMember.isStreaming) {
          resp.data[payload2] = body;
        } else {
          resp.data[payload2] = payloadMember.toType(body);
        }
      } else if (body.length > 0) {
        parser = new AWS3.XML.Parser();
        var data = parser.parse(body.toString(), output);
        util.update(resp.data, data);
      }
    }
    module2.exports = {
      buildRequest,
      extractError,
      extractData
    };
  }
});

// node_modules/aws-sdk/lib/xml/escape-attribute.js
var require_escape_attribute = __commonJS({
  "node_modules/aws-sdk/lib/xml/escape-attribute.js"(exports, module2) {
    function escapeAttribute(value) {
      return value.replace(/&/g, "&amp;").replace(/'/g, "&apos;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;");
    }
    module2.exports = {
      escapeAttribute
    };
  }
});

// node_modules/aws-sdk/lib/xml/xml-node.js
var require_xml_node = __commonJS({
  "node_modules/aws-sdk/lib/xml/xml-node.js"(exports, module2) {
    var escapeAttribute = require_escape_attribute().escapeAttribute;
    function XmlNode(name, children) {
      if (children === void 0) {
        children = [];
      }
      this.name = name;
      this.children = children;
      this.attributes = {};
    }
    XmlNode.prototype.addAttribute = function(name, value) {
      this.attributes[name] = value;
      return this;
    };
    XmlNode.prototype.addChildNode = function(child) {
      this.children.push(child);
      return this;
    };
    XmlNode.prototype.removeAttribute = function(name) {
      delete this.attributes[name];
      return this;
    };
    XmlNode.prototype.toString = function() {
      var hasChildren = Boolean(this.children.length);
      var xmlText = "<" + this.name;
      var attributes = this.attributes;
      for (var i = 0, attributeNames = Object.keys(attributes); i < attributeNames.length; i++) {
        var attributeName = attributeNames[i];
        var attribute = attributes[attributeName];
        if (typeof attribute !== "undefined" && attribute !== null) {
          xmlText += " " + attributeName + '="' + escapeAttribute("" + attribute) + '"';
        }
      }
      return xmlText += !hasChildren ? "/>" : ">" + this.children.map(function(c) {
        return c.toString();
      }).join("") + "</" + this.name + ">";
    };
    module2.exports = {
      XmlNode
    };
  }
});

// node_modules/aws-sdk/lib/xml/escape-element.js
var require_escape_element = __commonJS({
  "node_modules/aws-sdk/lib/xml/escape-element.js"(exports, module2) {
    function escapeElement(value) {
      return value.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\r/g, "&#x0D;").replace(/\n/g, "&#x0A;").replace(/\u0085/g, "&#x85;").replace(/\u2028/, "&#x2028;");
    }
    module2.exports = {
      escapeElement
    };
  }
});

// node_modules/aws-sdk/lib/xml/xml-text.js
var require_xml_text = __commonJS({
  "node_modules/aws-sdk/lib/xml/xml-text.js"(exports, module2) {
    var escapeElement = require_escape_element().escapeElement;
    function XmlText(value) {
      this.value = value;
    }
    XmlText.prototype.toString = function() {
      return escapeElement("" + this.value);
    };
    module2.exports = {
      XmlText
    };
  }
});

// node_modules/aws-sdk/lib/xml/builder.js
var require_builder2 = __commonJS({
  "node_modules/aws-sdk/lib/xml/builder.js"(exports, module2) {
    var util = require_util4();
    var XmlNode = require_xml_node().XmlNode;
    var XmlText = require_xml_text().XmlText;
    function XmlBuilder() {
    }
    XmlBuilder.prototype.toXML = function(params, shape, rootElement, noEmpty) {
      var xml = new XmlNode(rootElement);
      applyNamespaces(xml, shape, true);
      serialize(xml, params, shape);
      return xml.children.length > 0 || noEmpty ? xml.toString() : "";
    };
    function serialize(xml, value, shape) {
      switch (shape.type) {
        case "structure":
          return serializeStructure(xml, value, shape);
        case "map":
          return serializeMap(xml, value, shape);
        case "list":
          return serializeList(xml, value, shape);
        default:
          return serializeScalar(xml, value, shape);
      }
    }
    function serializeStructure(xml, params, shape) {
      util.arrayEach(shape.memberNames, function(memberName) {
        var memberShape = shape.members[memberName];
        if (memberShape.location !== "body")
          return;
        var value = params[memberName];
        var name = memberShape.name;
        if (value !== void 0 && value !== null) {
          if (memberShape.isXmlAttribute) {
            xml.addAttribute(name, value);
          } else if (memberShape.flattened) {
            serialize(xml, value, memberShape);
          } else {
            var element = new XmlNode(name);
            xml.addChildNode(element);
            applyNamespaces(element, memberShape);
            serialize(element, value, memberShape);
          }
        }
      });
    }
    function serializeMap(xml, map, shape) {
      var xmlKey = shape.key.name || "key";
      var xmlValue = shape.value.name || "value";
      util.each(map, function(key, value) {
        var entry = new XmlNode(shape.flattened ? shape.name : "entry");
        xml.addChildNode(entry);
        var entryKey = new XmlNode(xmlKey);
        var entryValue = new XmlNode(xmlValue);
        entry.addChildNode(entryKey);
        entry.addChildNode(entryValue);
        serialize(entryKey, key, shape.key);
        serialize(entryValue, value, shape.value);
      });
    }
    function serializeList(xml, list, shape) {
      if (shape.flattened) {
        util.arrayEach(list, function(value) {
          var name = shape.member.name || shape.name;
          var element = new XmlNode(name);
          xml.addChildNode(element);
          serialize(element, value, shape.member);
        });
      } else {
        util.arrayEach(list, function(value) {
          var name = shape.member.name || "member";
          var element = new XmlNode(name);
          xml.addChildNode(element);
          serialize(element, value, shape.member);
        });
      }
    }
    function serializeScalar(xml, value, shape) {
      xml.addChildNode(new XmlText(shape.toWireFormat(value)));
    }
    function applyNamespaces(xml, shape, isRoot) {
      var uri, prefix = "xmlns";
      if (shape.xmlNamespaceUri) {
        uri = shape.xmlNamespaceUri;
        if (shape.xmlNamespacePrefix)
          prefix += ":" + shape.xmlNamespacePrefix;
      } else if (isRoot && shape.api.xmlNamespaceUri) {
        uri = shape.api.xmlNamespaceUri;
      }
      if (uri)
        xml.addAttribute(prefix, uri);
    }
    module2.exports = XmlBuilder;
  }
});

// node_modules/aws-sdk/lib/model/operation.js
var require_operation = __commonJS({
  "node_modules/aws-sdk/lib/model/operation.js"(exports, module2) {
    var Shape = require_shape();
    var util = require_util4();
    var property = util.property;
    var memoizedProperty = util.memoizedProperty;
    function Operation(name, operation, options) {
      var self2 = this;
      options = options || {};
      property(this, "name", operation.name || name);
      property(this, "api", options.api, false);
      operation.http = operation.http || {};
      property(this, "endpoint", operation.endpoint);
      property(this, "httpMethod", operation.http.method || "POST");
      property(this, "httpPath", operation.http.requestUri || "/");
      property(this, "authtype", operation.authtype || "");
      property(this, "endpointDiscoveryRequired", operation.endpointdiscovery ? operation.endpointdiscovery.required ? "REQUIRED" : "OPTIONAL" : "NULL");
      property(this, "httpChecksumRequired", operation.httpChecksumRequired, false);
      memoizedProperty(this, "input", function() {
        if (!operation.input) {
          return new Shape.create({ type: "structure" }, options);
        }
        return Shape.create(operation.input, options);
      });
      memoizedProperty(this, "output", function() {
        if (!operation.output) {
          return new Shape.create({ type: "structure" }, options);
        }
        return Shape.create(operation.output, options);
      });
      memoizedProperty(this, "errors", function() {
        var list = [];
        if (!operation.errors)
          return null;
        for (var i = 0; i < operation.errors.length; i++) {
          list.push(Shape.create(operation.errors[i], options));
        }
        return list;
      });
      memoizedProperty(this, "paginator", function() {
        return options.api.paginators[name];
      });
      if (options.documentation) {
        property(this, "documentation", operation.documentation);
        property(this, "documentationUrl", operation.documentationUrl);
      }
      memoizedProperty(this, "idempotentMembers", function() {
        var idempotentMembers = [];
        var input = self2.input;
        var members = input.members;
        if (!input.members) {
          return idempotentMembers;
        }
        for (var name2 in members) {
          if (!members.hasOwnProperty(name2)) {
            continue;
          }
          if (members[name2].isIdempotent === true) {
            idempotentMembers.push(name2);
          }
        }
        return idempotentMembers;
      });
      memoizedProperty(this, "hasEventOutput", function() {
        var output = self2.output;
        return hasEventStream(output);
      });
    }
    function hasEventStream(topLevelShape) {
      var members = topLevelShape.members;
      var payload2 = topLevelShape.payload;
      if (!topLevelShape.members) {
        return false;
      }
      if (payload2) {
        var payloadMember = members[payload2];
        return payloadMember.isEventStream;
      }
      for (var name in members) {
        if (!members.hasOwnProperty(name)) {
          if (members[name].isEventStream === true) {
            return true;
          }
        }
      }
      return false;
    }
    module2.exports = Operation;
  }
});

// node_modules/aws-sdk/lib/model/paginator.js
var require_paginator = __commonJS({
  "node_modules/aws-sdk/lib/model/paginator.js"(exports, module2) {
    var property = require_util4().property;
    function Paginator(name, paginator) {
      property(this, "inputToken", paginator.input_token);
      property(this, "limitKey", paginator.limit_key);
      property(this, "moreResults", paginator.more_results);
      property(this, "outputToken", paginator.output_token);
      property(this, "resultKey", paginator.result_key);
    }
    module2.exports = Paginator;
  }
});

// node_modules/aws-sdk/lib/model/resource_waiter.js
var require_resource_waiter = __commonJS({
  "node_modules/aws-sdk/lib/model/resource_waiter.js"(exports, module2) {
    var util = require_util4();
    var property = util.property;
    function ResourceWaiter(name, waiter, options) {
      options = options || {};
      property(this, "name", name);
      property(this, "api", options.api, false);
      if (waiter.operation) {
        property(this, "operation", util.string.lowerFirst(waiter.operation));
      }
      var self2 = this;
      var keys = [
        "type",
        "description",
        "delay",
        "maxAttempts",
        "acceptors"
      ];
      keys.forEach(function(key) {
        var value = waiter[key];
        if (value) {
          property(self2, key, value);
        }
      });
    }
    module2.exports = ResourceWaiter;
  }
});

// node_modules/aws-sdk/apis/metadata.json
var require_metadata = __commonJS({
  "node_modules/aws-sdk/apis/metadata.json"(exports, module2) {
    module2.exports = {
      acm: {
        name: "ACM",
        cors: true
      },
      apigateway: {
        name: "APIGateway",
        cors: true
      },
      applicationautoscaling: {
        prefix: "application-autoscaling",
        name: "ApplicationAutoScaling",
        cors: true
      },
      appstream: {
        name: "AppStream"
      },
      autoscaling: {
        name: "AutoScaling",
        cors: true
      },
      batch: {
        name: "Batch"
      },
      budgets: {
        name: "Budgets"
      },
      clouddirectory: {
        name: "CloudDirectory",
        versions: [
          "2016-05-10*"
        ]
      },
      cloudformation: {
        name: "CloudFormation",
        cors: true
      },
      cloudfront: {
        name: "CloudFront",
        versions: [
          "2013-05-12*",
          "2013-11-11*",
          "2014-05-31*",
          "2014-10-21*",
          "2014-11-06*",
          "2015-04-17*",
          "2015-07-27*",
          "2015-09-17*",
          "2016-01-13*",
          "2016-01-28*",
          "2016-08-01*",
          "2016-08-20*",
          "2016-09-07*",
          "2016-09-29*",
          "2016-11-25*",
          "2017-03-25*",
          "2017-10-30*",
          "2018-06-18*",
          "2018-11-05*",
          "2019-03-26*"
        ],
        cors: true
      },
      cloudhsm: {
        name: "CloudHSM",
        cors: true
      },
      cloudsearch: {
        name: "CloudSearch"
      },
      cloudsearchdomain: {
        name: "CloudSearchDomain"
      },
      cloudtrail: {
        name: "CloudTrail",
        cors: true
      },
      cloudwatch: {
        prefix: "monitoring",
        name: "CloudWatch",
        cors: true
      },
      cloudwatchevents: {
        prefix: "events",
        name: "CloudWatchEvents",
        versions: [
          "2014-02-03*"
        ],
        cors: true
      },
      cloudwatchlogs: {
        prefix: "logs",
        name: "CloudWatchLogs",
        cors: true
      },
      codebuild: {
        name: "CodeBuild",
        cors: true
      },
      codecommit: {
        name: "CodeCommit",
        cors: true
      },
      codedeploy: {
        name: "CodeDeploy",
        cors: true
      },
      codepipeline: {
        name: "CodePipeline",
        cors: true
      },
      cognitoidentity: {
        prefix: "cognito-identity",
        name: "CognitoIdentity",
        cors: true
      },
      cognitoidentityserviceprovider: {
        prefix: "cognito-idp",
        name: "CognitoIdentityServiceProvider",
        cors: true
      },
      cognitosync: {
        prefix: "cognito-sync",
        name: "CognitoSync",
        cors: true
      },
      configservice: {
        prefix: "config",
        name: "ConfigService",
        cors: true
      },
      cur: {
        name: "CUR",
        cors: true
      },
      datapipeline: {
        name: "DataPipeline"
      },
      devicefarm: {
        name: "DeviceFarm",
        cors: true
      },
      directconnect: {
        name: "DirectConnect",
        cors: true
      },
      directoryservice: {
        prefix: "ds",
        name: "DirectoryService"
      },
      discovery: {
        name: "Discovery"
      },
      dms: {
        name: "DMS"
      },
      dynamodb: {
        name: "DynamoDB",
        cors: true
      },
      dynamodbstreams: {
        prefix: "streams.dynamodb",
        name: "DynamoDBStreams",
        cors: true
      },
      ec2: {
        name: "EC2",
        versions: [
          "2013-06-15*",
          "2013-10-15*",
          "2014-02-01*",
          "2014-05-01*",
          "2014-06-15*",
          "2014-09-01*",
          "2014-10-01*",
          "2015-03-01*",
          "2015-04-15*",
          "2015-10-01*",
          "2016-04-01*",
          "2016-09-15*"
        ],
        cors: true
      },
      ecr: {
        name: "ECR",
        cors: true
      },
      ecs: {
        name: "ECS",
        cors: true
      },
      efs: {
        prefix: "elasticfilesystem",
        name: "EFS",
        cors: true
      },
      elasticache: {
        name: "ElastiCache",
        versions: [
          "2012-11-15*",
          "2014-03-24*",
          "2014-07-15*",
          "2014-09-30*"
        ],
        cors: true
      },
      elasticbeanstalk: {
        name: "ElasticBeanstalk",
        cors: true
      },
      elb: {
        prefix: "elasticloadbalancing",
        name: "ELB",
        cors: true
      },
      elbv2: {
        prefix: "elasticloadbalancingv2",
        name: "ELBv2",
        cors: true
      },
      emr: {
        prefix: "elasticmapreduce",
        name: "EMR",
        cors: true
      },
      es: {
        name: "ES"
      },
      elastictranscoder: {
        name: "ElasticTranscoder",
        cors: true
      },
      firehose: {
        name: "Firehose",
        cors: true
      },
      gamelift: {
        name: "GameLift",
        cors: true
      },
      glacier: {
        name: "Glacier"
      },
      health: {
        name: "Health"
      },
      iam: {
        name: "IAM",
        cors: true
      },
      importexport: {
        name: "ImportExport"
      },
      inspector: {
        name: "Inspector",
        versions: [
          "2015-08-18*"
        ],
        cors: true
      },
      iot: {
        name: "Iot",
        cors: true
      },
      iotdata: {
        prefix: "iot-data",
        name: "IotData",
        cors: true
      },
      kinesis: {
        name: "Kinesis",
        cors: true
      },
      kinesisanalytics: {
        name: "KinesisAnalytics"
      },
      kms: {
        name: "KMS",
        cors: true
      },
      lambda: {
        name: "Lambda",
        cors: true
      },
      lexruntime: {
        prefix: "runtime.lex",
        name: "LexRuntime",
        cors: true
      },
      lightsail: {
        name: "Lightsail"
      },
      machinelearning: {
        name: "MachineLearning",
        cors: true
      },
      marketplacecommerceanalytics: {
        name: "MarketplaceCommerceAnalytics",
        cors: true
      },
      marketplacemetering: {
        prefix: "meteringmarketplace",
        name: "MarketplaceMetering"
      },
      mturk: {
        prefix: "mturk-requester",
        name: "MTurk",
        cors: true
      },
      mobileanalytics: {
        name: "MobileAnalytics",
        cors: true
      },
      opsworks: {
        name: "OpsWorks",
        cors: true
      },
      opsworkscm: {
        name: "OpsWorksCM"
      },
      organizations: {
        name: "Organizations"
      },
      pinpoint: {
        name: "Pinpoint"
      },
      polly: {
        name: "Polly",
        cors: true
      },
      rds: {
        name: "RDS",
        versions: [
          "2014-09-01*"
        ],
        cors: true
      },
      redshift: {
        name: "Redshift",
        cors: true
      },
      rekognition: {
        name: "Rekognition",
        cors: true
      },
      resourcegroupstaggingapi: {
        name: "ResourceGroupsTaggingAPI"
      },
      route53: {
        name: "Route53",
        cors: true
      },
      route53domains: {
        name: "Route53Domains",
        cors: true
      },
      s3: {
        name: "S3",
        dualstackAvailable: true,
        cors: true
      },
      s3control: {
        name: "S3Control",
        dualstackAvailable: true,
        xmlNoDefaultLists: true
      },
      servicecatalog: {
        name: "ServiceCatalog",
        cors: true
      },
      ses: {
        prefix: "email",
        name: "SES",
        cors: true
      },
      shield: {
        name: "Shield"
      },
      simpledb: {
        prefix: "sdb",
        name: "SimpleDB"
      },
      sms: {
        name: "SMS"
      },
      snowball: {
        name: "Snowball"
      },
      sns: {
        name: "SNS",
        cors: true
      },
      sqs: {
        name: "SQS",
        cors: true
      },
      ssm: {
        name: "SSM",
        cors: true
      },
      storagegateway: {
        name: "StorageGateway",
        cors: true
      },
      stepfunctions: {
        prefix: "states",
        name: "StepFunctions"
      },
      sts: {
        name: "STS",
        cors: true
      },
      support: {
        name: "Support"
      },
      swf: {
        name: "SWF"
      },
      xray: {
        name: "XRay",
        cors: true
      },
      waf: {
        name: "WAF",
        cors: true
      },
      wafregional: {
        prefix: "waf-regional",
        name: "WAFRegional"
      },
      workdocs: {
        name: "WorkDocs",
        cors: true
      },
      workspaces: {
        name: "WorkSpaces"
      },
      codestar: {
        name: "CodeStar"
      },
      lexmodelbuildingservice: {
        prefix: "lex-models",
        name: "LexModelBuildingService",
        cors: true
      },
      marketplaceentitlementservice: {
        prefix: "entitlement.marketplace",
        name: "MarketplaceEntitlementService"
      },
      athena: {
        name: "Athena",
        cors: true
      },
      greengrass: {
        name: "Greengrass"
      },
      dax: {
        name: "DAX"
      },
      migrationhub: {
        prefix: "AWSMigrationHub",
        name: "MigrationHub"
      },
      cloudhsmv2: {
        name: "CloudHSMV2",
        cors: true
      },
      glue: {
        name: "Glue"
      },
      mobile: {
        name: "Mobile"
      },
      pricing: {
        name: "Pricing",
        cors: true
      },
      costexplorer: {
        prefix: "ce",
        name: "CostExplorer",
        cors: true
      },
      mediaconvert: {
        name: "MediaConvert"
      },
      medialive: {
        name: "MediaLive"
      },
      mediapackage: {
        name: "MediaPackage"
      },
      mediastore: {
        name: "MediaStore"
      },
      mediastoredata: {
        prefix: "mediastore-data",
        name: "MediaStoreData",
        cors: true
      },
      appsync: {
        name: "AppSync"
      },
      guardduty: {
        name: "GuardDuty"
      },
      mq: {
        name: "MQ"
      },
      comprehend: {
        name: "Comprehend",
        cors: true
      },
      iotjobsdataplane: {
        prefix: "iot-jobs-data",
        name: "IoTJobsDataPlane"
      },
      kinesisvideoarchivedmedia: {
        prefix: "kinesis-video-archived-media",
        name: "KinesisVideoArchivedMedia",
        cors: true
      },
      kinesisvideomedia: {
        prefix: "kinesis-video-media",
        name: "KinesisVideoMedia",
        cors: true
      },
      kinesisvideo: {
        name: "KinesisVideo",
        cors: true
      },
      sagemakerruntime: {
        prefix: "runtime.sagemaker",
        name: "SageMakerRuntime"
      },
      sagemaker: {
        name: "SageMaker"
      },
      translate: {
        name: "Translate",
        cors: true
      },
      resourcegroups: {
        prefix: "resource-groups",
        name: "ResourceGroups",
        cors: true
      },
      alexaforbusiness: {
        name: "AlexaForBusiness"
      },
      cloud9: {
        name: "Cloud9"
      },
      serverlessapplicationrepository: {
        prefix: "serverlessrepo",
        name: "ServerlessApplicationRepository"
      },
      servicediscovery: {
        name: "ServiceDiscovery"
      },
      workmail: {
        name: "WorkMail"
      },
      autoscalingplans: {
        prefix: "autoscaling-plans",
        name: "AutoScalingPlans"
      },
      transcribeservice: {
        prefix: "transcribe",
        name: "TranscribeService"
      },
      connect: {
        name: "Connect",
        cors: true
      },
      acmpca: {
        prefix: "acm-pca",
        name: "ACMPCA"
      },
      fms: {
        name: "FMS"
      },
      secretsmanager: {
        name: "SecretsManager",
        cors: true
      },
      iotanalytics: {
        name: "IoTAnalytics",
        cors: true
      },
      iot1clickdevicesservice: {
        prefix: "iot1click-devices",
        name: "IoT1ClickDevicesService"
      },
      iot1clickprojects: {
        prefix: "iot1click-projects",
        name: "IoT1ClickProjects"
      },
      pi: {
        name: "PI"
      },
      neptune: {
        name: "Neptune"
      },
      mediatailor: {
        name: "MediaTailor"
      },
      eks: {
        name: "EKS"
      },
      macie: {
        name: "Macie"
      },
      dlm: {
        name: "DLM"
      },
      signer: {
        name: "Signer"
      },
      chime: {
        name: "Chime"
      },
      pinpointemail: {
        prefix: "pinpoint-email",
        name: "PinpointEmail"
      },
      ram: {
        name: "RAM"
      },
      route53resolver: {
        name: "Route53Resolver"
      },
      pinpointsmsvoice: {
        prefix: "sms-voice",
        name: "PinpointSMSVoice"
      },
      quicksight: {
        name: "QuickSight"
      },
      rdsdataservice: {
        prefix: "rds-data",
        name: "RDSDataService"
      },
      amplify: {
        name: "Amplify"
      },
      datasync: {
        name: "DataSync"
      },
      robomaker: {
        name: "RoboMaker"
      },
      transfer: {
        name: "Transfer"
      },
      globalaccelerator: {
        name: "GlobalAccelerator"
      },
      comprehendmedical: {
        name: "ComprehendMedical",
        cors: true
      },
      kinesisanalyticsv2: {
        name: "KinesisAnalyticsV2"
      },
      mediaconnect: {
        name: "MediaConnect"
      },
      fsx: {
        name: "FSx"
      },
      securityhub: {
        name: "SecurityHub"
      },
      appmesh: {
        name: "AppMesh",
        versions: [
          "2018-10-01*"
        ]
      },
      licensemanager: {
        prefix: "license-manager",
        name: "LicenseManager"
      },
      kafka: {
        name: "Kafka"
      },
      apigatewaymanagementapi: {
        name: "ApiGatewayManagementApi"
      },
      apigatewayv2: {
        name: "ApiGatewayV2"
      },
      docdb: {
        name: "DocDB"
      },
      backup: {
        name: "Backup"
      },
      worklink: {
        name: "WorkLink"
      },
      textract: {
        name: "Textract"
      },
      managedblockchain: {
        name: "ManagedBlockchain"
      },
      mediapackagevod: {
        prefix: "mediapackage-vod",
        name: "MediaPackageVod"
      },
      groundstation: {
        name: "GroundStation"
      },
      iotthingsgraph: {
        name: "IoTThingsGraph"
      },
      iotevents: {
        name: "IoTEvents"
      },
      ioteventsdata: {
        prefix: "iotevents-data",
        name: "IoTEventsData"
      },
      personalize: {
        name: "Personalize",
        cors: true
      },
      personalizeevents: {
        prefix: "personalize-events",
        name: "PersonalizeEvents",
        cors: true
      },
      personalizeruntime: {
        prefix: "personalize-runtime",
        name: "PersonalizeRuntime",
        cors: true
      },
      applicationinsights: {
        prefix: "application-insights",
        name: "ApplicationInsights"
      },
      servicequotas: {
        prefix: "service-quotas",
        name: "ServiceQuotas"
      },
      ec2instanceconnect: {
        prefix: "ec2-instance-connect",
        name: "EC2InstanceConnect"
      },
      eventbridge: {
        name: "EventBridge"
      },
      lakeformation: {
        name: "LakeFormation"
      },
      forecastservice: {
        prefix: "forecast",
        name: "ForecastService",
        cors: true
      },
      forecastqueryservice: {
        prefix: "forecastquery",
        name: "ForecastQueryService",
        cors: true
      },
      qldb: {
        name: "QLDB"
      },
      qldbsession: {
        prefix: "qldb-session",
        name: "QLDBSession"
      },
      workmailmessageflow: {
        name: "WorkMailMessageFlow"
      },
      codestarnotifications: {
        prefix: "codestar-notifications",
        name: "CodeStarNotifications"
      },
      savingsplans: {
        name: "SavingsPlans"
      },
      sso: {
        name: "SSO"
      },
      ssooidc: {
        prefix: "sso-oidc",
        name: "SSOOIDC"
      },
      marketplacecatalog: {
        prefix: "marketplace-catalog",
        name: "MarketplaceCatalog"
      },
      dataexchange: {
        name: "DataExchange"
      },
      sesv2: {
        name: "SESV2"
      },
      migrationhubconfig: {
        prefix: "migrationhub-config",
        name: "MigrationHubConfig"
      },
      connectparticipant: {
        name: "ConnectParticipant"
      },
      appconfig: {
        name: "AppConfig"
      },
      iotsecuretunneling: {
        name: "IoTSecureTunneling"
      },
      wafv2: {
        name: "WAFV2"
      },
      elasticinference: {
        prefix: "elastic-inference",
        name: "ElasticInference"
      },
      imagebuilder: {
        name: "Imagebuilder"
      },
      schemas: {
        name: "Schemas"
      },
      accessanalyzer: {
        name: "AccessAnalyzer"
      },
      codegurureviewer: {
        prefix: "codeguru-reviewer",
        name: "CodeGuruReviewer"
      },
      codeguruprofiler: {
        name: "CodeGuruProfiler"
      },
      computeoptimizer: {
        prefix: "compute-optimizer",
        name: "ComputeOptimizer"
      },
      frauddetector: {
        name: "FraudDetector"
      },
      kendra: {
        name: "Kendra"
      },
      networkmanager: {
        name: "NetworkManager"
      },
      outposts: {
        name: "Outposts"
      },
      augmentedairuntime: {
        prefix: "sagemaker-a2i-runtime",
        name: "AugmentedAIRuntime"
      },
      ebs: {
        name: "EBS"
      },
      kinesisvideosignalingchannels: {
        prefix: "kinesis-video-signaling",
        name: "KinesisVideoSignalingChannels",
        cors: true
      },
      detective: {
        name: "Detective"
      },
      codestarconnections: {
        prefix: "codestar-connections",
        name: "CodeStarconnections"
      },
      synthetics: {
        name: "Synthetics"
      },
      iotsitewise: {
        name: "IoTSiteWise"
      },
      macie2: {
        name: "Macie2"
      },
      codeartifact: {
        name: "CodeArtifact"
      },
      honeycode: {
        name: "Honeycode"
      },
      ivs: {
        name: "IVS"
      },
      braket: {
        name: "Braket"
      },
      identitystore: {
        name: "IdentityStore"
      },
      appflow: {
        name: "Appflow"
      },
      redshiftdata: {
        prefix: "redshift-data",
        name: "RedshiftData"
      },
      ssoadmin: {
        prefix: "sso-admin",
        name: "SSOAdmin"
      },
      timestreamquery: {
        prefix: "timestream-query",
        name: "TimestreamQuery"
      },
      timestreamwrite: {
        prefix: "timestream-write",
        name: "TimestreamWrite"
      },
      s3outposts: {
        name: "S3Outposts"
      },
      databrew: {
        name: "DataBrew"
      },
      servicecatalogappregistry: {
        prefix: "servicecatalog-appregistry",
        name: "ServiceCatalogAppRegistry"
      },
      networkfirewall: {
        prefix: "network-firewall",
        name: "NetworkFirewall"
      },
      mwaa: {
        name: "MWAA"
      },
      amplifybackend: {
        name: "AmplifyBackend"
      },
      appintegrations: {
        name: "AppIntegrations"
      },
      connectcontactlens: {
        prefix: "connect-contact-lens",
        name: "ConnectContactLens"
      },
      devopsguru: {
        prefix: "devops-guru",
        name: "DevOpsGuru"
      },
      ecrpublic: {
        prefix: "ecr-public",
        name: "ECRPUBLIC"
      },
      lookoutvision: {
        name: "LookoutVision"
      },
      sagemakerfeaturestoreruntime: {
        prefix: "sagemaker-featurestore-runtime",
        name: "SageMakerFeatureStoreRuntime"
      },
      customerprofiles: {
        prefix: "customer-profiles",
        name: "CustomerProfiles"
      },
      auditmanager: {
        name: "AuditManager"
      },
      emrcontainers: {
        prefix: "emr-containers",
        name: "EMRcontainers"
      },
      healthlake: {
        name: "HealthLake"
      },
      sagemakeredge: {
        prefix: "sagemaker-edge",
        name: "SagemakerEdge"
      },
      amp: {
        name: "Amp"
      },
      greengrassv2: {
        name: "GreengrassV2"
      },
      iotdeviceadvisor: {
        name: "IotDeviceAdvisor"
      },
      iotfleethub: {
        name: "IoTFleetHub"
      },
      iotwireless: {
        name: "IoTWireless"
      },
      location: {
        name: "Location",
        cors: true
      },
      wellarchitected: {
        name: "WellArchitected"
      },
      lexmodelsv2: {
        prefix: "models.lex.v2",
        name: "LexModelsV2"
      },
      lexruntimev2: {
        prefix: "runtime.lex.v2",
        name: "LexRuntimeV2",
        cors: true
      },
      fis: {
        name: "Fis"
      },
      lookoutmetrics: {
        name: "LookoutMetrics"
      },
      mgn: {
        name: "Mgn"
      },
      lookoutequipment: {
        name: "LookoutEquipment"
      },
      nimble: {
        name: "Nimble"
      },
      finspace: {
        name: "Finspace"
      },
      finspacedata: {
        prefix: "finspace-data",
        name: "Finspacedata"
      },
      ssmcontacts: {
        prefix: "ssm-contacts",
        name: "SSMContacts"
      },
      ssmincidents: {
        prefix: "ssm-incidents",
        name: "SSMIncidents"
      },
      applicationcostprofiler: {
        name: "ApplicationCostProfiler"
      },
      apprunner: {
        name: "AppRunner"
      },
      proton: {
        name: "Proton"
      },
      route53recoverycluster: {
        prefix: "route53-recovery-cluster",
        name: "Route53RecoveryCluster"
      },
      route53recoverycontrolconfig: {
        prefix: "route53-recovery-control-config",
        name: "Route53RecoveryControlConfig"
      },
      route53recoveryreadiness: {
        prefix: "route53-recovery-readiness",
        name: "Route53RecoveryReadiness"
      },
      chimesdkidentity: {
        prefix: "chime-sdk-identity",
        name: "ChimeSDKIdentity"
      },
      chimesdkmessaging: {
        prefix: "chime-sdk-messaging",
        name: "ChimeSDKMessaging"
      },
      snowdevicemanagement: {
        prefix: "snow-device-management",
        name: "SnowDeviceManagement"
      },
      memorydb: {
        name: "MemoryDB"
      },
      opensearch: {
        name: "OpenSearch"
      },
      kafkaconnect: {
        name: "KafkaConnect"
      },
      voiceid: {
        prefix: "voice-id",
        name: "VoiceID"
      },
      wisdom: {
        name: "Wisdom"
      },
      account: {
        name: "Account"
      },
      cloudcontrol: {
        name: "CloudControl"
      },
      grafana: {
        name: "Grafana"
      }
    };
  }
});

// node_modules/aws-sdk/lib/model/api.js
var require_api = __commonJS({
  "node_modules/aws-sdk/lib/model/api.js"(exports, module2) {
    var Collection = require_collection();
    var Operation = require_operation();
    var Shape = require_shape();
    var Paginator = require_paginator();
    var ResourceWaiter = require_resource_waiter();
    var metadata = require_metadata();
    var util = require_util4();
    var property = util.property;
    var memoizedProperty = util.memoizedProperty;
    function Api(api, options) {
      var self2 = this;
      api = api || {};
      options = options || {};
      options.api = this;
      api.metadata = api.metadata || {};
      var serviceIdentifier = options.serviceIdentifier;
      delete options.serviceIdentifier;
      property(this, "isApi", true, false);
      property(this, "apiVersion", api.metadata.apiVersion);
      property(this, "endpointPrefix", api.metadata.endpointPrefix);
      property(this, "signingName", api.metadata.signingName);
      property(this, "globalEndpoint", api.metadata.globalEndpoint);
      property(this, "signatureVersion", api.metadata.signatureVersion);
      property(this, "jsonVersion", api.metadata.jsonVersion);
      property(this, "targetPrefix", api.metadata.targetPrefix);
      property(this, "protocol", api.metadata.protocol);
      property(this, "timestampFormat", api.metadata.timestampFormat);
      property(this, "xmlNamespaceUri", api.metadata.xmlNamespace);
      property(this, "abbreviation", api.metadata.serviceAbbreviation);
      property(this, "fullName", api.metadata.serviceFullName);
      property(this, "serviceId", api.metadata.serviceId);
      if (serviceIdentifier && metadata[serviceIdentifier]) {
        property(this, "xmlNoDefaultLists", metadata[serviceIdentifier].xmlNoDefaultLists, false);
      }
      memoizedProperty(this, "className", function() {
        var name = api.metadata.serviceAbbreviation || api.metadata.serviceFullName;
        if (!name)
          return null;
        name = name.replace(/^Amazon|AWS\s*|\(.*|\s+|\W+/g, "");
        if (name === "ElasticLoadBalancing")
          name = "ELB";
        return name;
      });
      function addEndpointOperation(name, operation) {
        if (operation.endpointoperation === true) {
          property(self2, "endpointOperation", util.string.lowerFirst(name));
        }
        if (operation.endpointdiscovery && !self2.hasRequiredEndpointDiscovery) {
          property(self2, "hasRequiredEndpointDiscovery", operation.endpointdiscovery.required === true);
        }
      }
      property(this, "operations", new Collection(api.operations, options, function(name, operation) {
        return new Operation(name, operation, options);
      }, util.string.lowerFirst, addEndpointOperation));
      property(this, "shapes", new Collection(api.shapes, options, function(name, shape) {
        return Shape.create(shape, options);
      }));
      property(this, "paginators", new Collection(api.paginators, options, function(name, paginator) {
        return new Paginator(name, paginator, options);
      }));
      property(this, "waiters", new Collection(api.waiters, options, function(name, waiter) {
        return new ResourceWaiter(name, waiter, options);
      }, util.string.lowerFirst));
      if (options.documentation) {
        property(this, "documentation", api.documentation);
        property(this, "documentationUrl", api.documentationUrl);
      }
    }
    module2.exports = Api;
  }
});

// node_modules/aws-sdk/lib/api_loader.js
var require_api_loader = __commonJS({
  "node_modules/aws-sdk/lib/api_loader.js"(exports, module2) {
    function apiLoader(svc, version) {
      if (!apiLoader.services.hasOwnProperty(svc)) {
        throw new Error("InvalidService: Failed to load api for " + svc);
      }
      return apiLoader.services[svc][version];
    }
    apiLoader.services = {};
    module2.exports = apiLoader;
  }
});

// node_modules/aws-sdk/vendor/endpoint-cache/utils/LRU.js
var require_LRU = __commonJS({
  "node_modules/aws-sdk/vendor/endpoint-cache/utils/LRU.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var LinkedListNode = function() {
      function LinkedListNode2(key, value) {
        this.key = key;
        this.value = value;
      }
      return LinkedListNode2;
    }();
    var LRUCache = function() {
      function LRUCache2(size) {
        this.nodeMap = {};
        this.size = 0;
        if (typeof size !== "number" || size < 1) {
          throw new Error("Cache size can only be positive number");
        }
        this.sizeLimit = size;
      }
      Object.defineProperty(LRUCache2.prototype, "length", {
        get: function() {
          return this.size;
        },
        enumerable: true,
        configurable: true
      });
      LRUCache2.prototype.prependToList = function(node) {
        if (!this.headerNode) {
          this.tailNode = node;
        } else {
          this.headerNode.prev = node;
          node.next = this.headerNode;
        }
        this.headerNode = node;
        this.size++;
      };
      LRUCache2.prototype.removeFromTail = function() {
        if (!this.tailNode) {
          return void 0;
        }
        var node = this.tailNode;
        var prevNode = node.prev;
        if (prevNode) {
          prevNode.next = void 0;
        }
        node.prev = void 0;
        this.tailNode = prevNode;
        this.size--;
        return node;
      };
      LRUCache2.prototype.detachFromList = function(node) {
        if (this.headerNode === node) {
          this.headerNode = node.next;
        }
        if (this.tailNode === node) {
          this.tailNode = node.prev;
        }
        if (node.prev) {
          node.prev.next = node.next;
        }
        if (node.next) {
          node.next.prev = node.prev;
        }
        node.next = void 0;
        node.prev = void 0;
        this.size--;
      };
      LRUCache2.prototype.get = function(key) {
        if (this.nodeMap[key]) {
          var node = this.nodeMap[key];
          this.detachFromList(node);
          this.prependToList(node);
          return node.value;
        }
      };
      LRUCache2.prototype.remove = function(key) {
        if (this.nodeMap[key]) {
          var node = this.nodeMap[key];
          this.detachFromList(node);
          delete this.nodeMap[key];
        }
      };
      LRUCache2.prototype.put = function(key, value) {
        if (this.nodeMap[key]) {
          this.remove(key);
        } else if (this.size === this.sizeLimit) {
          var tailNode = this.removeFromTail();
          var key_1 = tailNode.key;
          delete this.nodeMap[key_1];
        }
        var newNode = new LinkedListNode(key, value);
        this.nodeMap[key] = newNode;
        this.prependToList(newNode);
      };
      LRUCache2.prototype.empty = function() {
        var keys = Object.keys(this.nodeMap);
        for (var i = 0; i < keys.length; i++) {
          var key = keys[i];
          var node = this.nodeMap[key];
          this.detachFromList(node);
          delete this.nodeMap[key];
        }
      };
      return LRUCache2;
    }();
    exports.LRUCache = LRUCache;
  }
});

// node_modules/aws-sdk/vendor/endpoint-cache/index.js
var require_endpoint_cache = __commonJS({
  "node_modules/aws-sdk/vendor/endpoint-cache/index.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var LRU_1 = require_LRU();
    var CACHE_SIZE = 1e3;
    var EndpointCache = function() {
      function EndpointCache2(maxSize) {
        if (maxSize === void 0) {
          maxSize = CACHE_SIZE;
        }
        this.maxSize = maxSize;
        this.cache = new LRU_1.LRUCache(maxSize);
      }
      ;
      Object.defineProperty(EndpointCache2.prototype, "size", {
        get: function() {
          return this.cache.length;
        },
        enumerable: true,
        configurable: true
      });
      EndpointCache2.prototype.put = function(key, value) {
        var keyString = typeof key !== "string" ? EndpointCache2.getKeyString(key) : key;
        var endpointRecord = this.populateValue(value);
        this.cache.put(keyString, endpointRecord);
      };
      EndpointCache2.prototype.get = function(key) {
        var keyString = typeof key !== "string" ? EndpointCache2.getKeyString(key) : key;
        var now = Date.now();
        var records = this.cache.get(keyString);
        if (records) {
          for (var i = records.length - 1; i >= 0; i--) {
            var record = records[i];
            if (record.Expire < now) {
              records.splice(i, 1);
            }
          }
          if (records.length === 0) {
            this.cache.remove(keyString);
            return void 0;
          }
        }
        return records;
      };
      EndpointCache2.getKeyString = function(key) {
        var identifiers = [];
        var identifierNames = Object.keys(key).sort();
        for (var i = 0; i < identifierNames.length; i++) {
          var identifierName = identifierNames[i];
          if (key[identifierName] === void 0)
            continue;
          identifiers.push(key[identifierName]);
        }
        return identifiers.join(" ");
      };
      EndpointCache2.prototype.populateValue = function(endpoints) {
        var now = Date.now();
        return endpoints.map(function(endpoint) {
          return {
            Address: endpoint.Address || "",
            Expire: now + (endpoint.CachePeriodInMinutes || 1) * 60 * 1e3
          };
        });
      };
      EndpointCache2.prototype.empty = function() {
        this.cache.empty();
      };
      EndpointCache2.prototype.remove = function(key) {
        var keyString = typeof key !== "string" ? EndpointCache2.getKeyString(key) : key;
        this.cache.remove(keyString);
      };
      return EndpointCache2;
    }();
    exports.EndpointCache = EndpointCache;
  }
});

// node_modules/aws-sdk/lib/sequential_executor.js
var require_sequential_executor = __commonJS({
  "node_modules/aws-sdk/lib/sequential_executor.js"(exports, module2) {
    var AWS3 = require_core();
    AWS3.SequentialExecutor = AWS3.util.inherit({
      constructor: function SequentialExecutor() {
        this._events = {};
      },
      listeners: function listeners(eventName) {
        return this._events[eventName] ? this._events[eventName].slice(0) : [];
      },
      on: function on(eventName, listener, toHead) {
        if (this._events[eventName]) {
          toHead ? this._events[eventName].unshift(listener) : this._events[eventName].push(listener);
        } else {
          this._events[eventName] = [listener];
        }
        return this;
      },
      onAsync: function onAsync(eventName, listener, toHead) {
        listener._isAsync = true;
        return this.on(eventName, listener, toHead);
      },
      removeListener: function removeListener(eventName, listener) {
        var listeners = this._events[eventName];
        if (listeners) {
          var length = listeners.length;
          var position = -1;
          for (var i = 0; i < length; ++i) {
            if (listeners[i] === listener) {
              position = i;
            }
          }
          if (position > -1) {
            listeners.splice(position, 1);
          }
        }
        return this;
      },
      removeAllListeners: function removeAllListeners(eventName) {
        if (eventName) {
          delete this._events[eventName];
        } else {
          this._events = {};
        }
        return this;
      },
      emit: function emit(eventName, eventArgs, doneCallback) {
        if (!doneCallback)
          doneCallback = function() {
          };
        var listeners = this.listeners(eventName);
        var count = listeners.length;
        this.callListeners(listeners, eventArgs, doneCallback);
        return count > 0;
      },
      callListeners: function callListeners(listeners, args, doneCallback, prevError) {
        var self2 = this;
        var error = prevError || null;
        function callNextListener(err) {
          if (err) {
            error = AWS3.util.error(error || new Error(), err);
            if (self2._haltHandlersOnError) {
              return doneCallback.call(self2, error);
            }
          }
          self2.callListeners(listeners, args, doneCallback, error);
        }
        while (listeners.length > 0) {
          var listener = listeners.shift();
          if (listener._isAsync) {
            listener.apply(self2, args.concat([callNextListener]));
            return;
          } else {
            try {
              listener.apply(self2, args);
            } catch (err) {
              error = AWS3.util.error(error || new Error(), err);
            }
            if (error && self2._haltHandlersOnError) {
              doneCallback.call(self2, error);
              return;
            }
          }
        }
        doneCallback.call(self2, error);
      },
      addListeners: function addListeners(listeners) {
        var self2 = this;
        if (listeners._events)
          listeners = listeners._events;
        AWS3.util.each(listeners, function(event, callbacks) {
          if (typeof callbacks === "function")
            callbacks = [callbacks];
          AWS3.util.arrayEach(callbacks, function(callback) {
            self2.on(event, callback);
          });
        });
        return self2;
      },
      addNamedListener: function addNamedListener(name, eventName, callback, toHead) {
        this[name] = callback;
        this.addListener(eventName, callback, toHead);
        return this;
      },
      addNamedAsyncListener: function addNamedAsyncListener(name, eventName, callback, toHead) {
        callback._isAsync = true;
        return this.addNamedListener(name, eventName, callback, toHead);
      },
      addNamedListeners: function addNamedListeners(callback) {
        var self2 = this;
        callback(function() {
          self2.addNamedListener.apply(self2, arguments);
        }, function() {
          self2.addNamedAsyncListener.apply(self2, arguments);
        });
        return this;
      }
    });
    AWS3.SequentialExecutor.prototype.addListener = AWS3.SequentialExecutor.prototype.on;
    module2.exports = AWS3.SequentialExecutor;
  }
});

// node_modules/aws-sdk/lib/region_config_data.json
var require_region_config_data = __commonJS({
  "node_modules/aws-sdk/lib/region_config_data.json"(exports, module2) {
    module2.exports = {
      rules: {
        "*/*": {
          endpoint: "{service}.{region}.amazonaws.com"
        },
        "cn-*/*": {
          endpoint: "{service}.{region}.amazonaws.com.cn"
        },
        "us-iso-*/*": {
          endpoint: "{service}.{region}.c2s.ic.gov"
        },
        "us-isob-*/*": {
          endpoint: "{service}.{region}.sc2s.sgov.gov"
        },
        "*/budgets": "globalSSL",
        "*/cloudfront": "globalSSL",
        "*/sts": "globalSSL",
        "*/importexport": {
          endpoint: "{service}.amazonaws.com",
          signatureVersion: "v2",
          globalEndpoint: true
        },
        "*/route53": "globalSSL",
        "cn-*/route53": {
          endpoint: "{service}.amazonaws.com.cn",
          globalEndpoint: true,
          signingRegion: "cn-northwest-1"
        },
        "us-gov-*/route53": "globalGovCloud",
        "*/waf": "globalSSL",
        "*/iam": "globalSSL",
        "cn-*/iam": {
          endpoint: "{service}.cn-north-1.amazonaws.com.cn",
          globalEndpoint: true,
          signingRegion: "cn-north-1"
        },
        "us-gov-*/iam": "globalGovCloud",
        "us-gov-*/sts": {
          endpoint: "{service}.{region}.amazonaws.com"
        },
        "us-gov-west-1/s3": "s3signature",
        "us-west-1/s3": "s3signature",
        "us-west-2/s3": "s3signature",
        "eu-west-1/s3": "s3signature",
        "ap-southeast-1/s3": "s3signature",
        "ap-southeast-2/s3": "s3signature",
        "ap-northeast-1/s3": "s3signature",
        "sa-east-1/s3": "s3signature",
        "us-east-1/s3": {
          endpoint: "{service}.amazonaws.com",
          signatureVersion: "s3"
        },
        "us-east-1/sdb": {
          endpoint: "{service}.amazonaws.com",
          signatureVersion: "v2"
        },
        "*/sdb": {
          endpoint: "{service}.{region}.amazonaws.com",
          signatureVersion: "v2"
        }
      },
      patterns: {
        globalSSL: {
          endpoint: "https://{service}.amazonaws.com",
          globalEndpoint: true,
          signingRegion: "us-east-1"
        },
        globalGovCloud: {
          endpoint: "{service}.us-gov.amazonaws.com",
          globalEndpoint: true,
          signingRegion: "us-gov-west-1"
        },
        s3signature: {
          endpoint: "{service}.{region}.amazonaws.com",
          signatureVersion: "s3"
        }
      }
    };
  }
});

// node_modules/aws-sdk/lib/region_config.js
var require_region_config = __commonJS({
  "node_modules/aws-sdk/lib/region_config.js"(exports, module2) {
    var util = require_util4();
    var regionConfig = require_region_config_data();
    function generateRegionPrefix(region) {
      if (!region)
        return null;
      var parts = region.split("-");
      if (parts.length < 3)
        return null;
      return parts.slice(0, parts.length - 2).join("-") + "-*";
    }
    function derivedKeys(service) {
      var region = service.config.region;
      var regionPrefix = generateRegionPrefix(region);
      var endpointPrefix = service.api.endpointPrefix;
      return [
        [region, endpointPrefix],
        [regionPrefix, endpointPrefix],
        [region, "*"],
        [regionPrefix, "*"],
        ["*", endpointPrefix],
        ["*", "*"]
      ].map(function(item) {
        return item[0] && item[1] ? item.join("/") : null;
      });
    }
    function applyConfig(service, config) {
      util.each(config, function(key, value) {
        if (key === "globalEndpoint")
          return;
        if (service.config[key] === void 0 || service.config[key] === null) {
          service.config[key] = value;
        }
      });
    }
    function configureEndpoint(service) {
      var keys = derivedKeys(service);
      for (var i = 0; i < keys.length; i++) {
        var key = keys[i];
        if (!key)
          continue;
        if (Object.prototype.hasOwnProperty.call(regionConfig.rules, key)) {
          var config = regionConfig.rules[key];
          if (typeof config === "string") {
            config = regionConfig.patterns[config];
          }
          if (service.config.useDualstack && util.isDualstackAvailable(service)) {
            config = util.copy(config);
            config.endpoint = config.endpoint.replace(/{service}\.({region}\.)?/, "{service}.dualstack.{region}.");
          }
          service.isGlobalEndpoint = !!config.globalEndpoint;
          if (config.signingRegion) {
            service.signingRegion = config.signingRegion;
          }
          if (!config.signatureVersion)
            config.signatureVersion = "v4";
          applyConfig(service, config);
          return;
        }
      }
    }
    function getEndpointSuffix(region) {
      var regionRegexes = {
        "^(us|eu|ap|sa|ca|me)\\-\\w+\\-\\d+$": "amazonaws.com",
        "^cn\\-\\w+\\-\\d+$": "amazonaws.com.cn",
        "^us\\-gov\\-\\w+\\-\\d+$": "amazonaws.com",
        "^us\\-iso\\-\\w+\\-\\d+$": "c2s.ic.gov",
        "^us\\-isob\\-\\w+\\-\\d+$": "sc2s.sgov.gov"
      };
      var defaultSuffix = "amazonaws.com";
      var regexes = Object.keys(regionRegexes);
      for (var i = 0; i < regexes.length; i++) {
        var regionPattern = RegExp(regexes[i]);
        var dnsSuffix = regionRegexes[regexes[i]];
        if (regionPattern.test(region))
          return dnsSuffix;
      }
      return defaultSuffix;
    }
    module2.exports = {
      configureEndpoint,
      getEndpointSuffix
    };
  }
});

// node_modules/aws-sdk/lib/service.js
var require_service = __commonJS({
  "node_modules/aws-sdk/lib/service.js"(exports, module2) {
    var AWS3 = require_core();
    var Api = require_api();
    var regionConfig = require_region_config();
    var inherit = AWS3.util.inherit;
    var clientCount = 0;
    AWS3.Service = inherit({
      constructor: function Service(config) {
        if (!this.loadServiceClass) {
          throw AWS3.util.error(new Error(), "Service must be constructed with `new' operator");
        }
        var ServiceClass = this.loadServiceClass(config || {});
        if (ServiceClass) {
          var originalConfig = AWS3.util.copy(config);
          var svc = new ServiceClass(config);
          Object.defineProperty(svc, "_originalConfig", {
            get: function() {
              return originalConfig;
            },
            enumerable: false,
            configurable: true
          });
          svc._clientId = ++clientCount;
          return svc;
        }
        this.initialize(config);
      },
      initialize: function initialize(config) {
        var svcConfig = AWS3.config[this.serviceIdentifier];
        this.config = new AWS3.Config(AWS3.config);
        if (svcConfig)
          this.config.update(svcConfig, true);
        if (config)
          this.config.update(config, true);
        this.validateService();
        if (!this.config.endpoint)
          regionConfig.configureEndpoint(this);
        this.config.endpoint = this.endpointFromTemplate(this.config.endpoint);
        this.setEndpoint(this.config.endpoint);
        AWS3.SequentialExecutor.call(this);
        AWS3.Service.addDefaultMonitoringListeners(this);
        if ((this.config.clientSideMonitoring || AWS3.Service._clientSideMonitoring) && this.publisher) {
          var publisher = this.publisher;
          this.addNamedListener("PUBLISH_API_CALL", "apiCall", function PUBLISH_API_CALL(event) {
            process.nextTick(function() {
              publisher.eventHandler(event);
            });
          });
          this.addNamedListener("PUBLISH_API_ATTEMPT", "apiCallAttempt", function PUBLISH_API_ATTEMPT(event) {
            process.nextTick(function() {
              publisher.eventHandler(event);
            });
          });
        }
      },
      validateService: function validateService() {
      },
      loadServiceClass: function loadServiceClass(serviceConfig) {
        var config = serviceConfig;
        if (!AWS3.util.isEmpty(this.api)) {
          return null;
        } else if (config.apiConfig) {
          return AWS3.Service.defineServiceApi(this.constructor, config.apiConfig);
        } else if (!this.constructor.services) {
          return null;
        } else {
          config = new AWS3.Config(AWS3.config);
          config.update(serviceConfig, true);
          var version = config.apiVersions[this.constructor.serviceIdentifier];
          version = version || config.apiVersion;
          return this.getLatestServiceClass(version);
        }
      },
      getLatestServiceClass: function getLatestServiceClass(version) {
        version = this.getLatestServiceVersion(version);
        if (this.constructor.services[version] === null) {
          AWS3.Service.defineServiceApi(this.constructor, version);
        }
        return this.constructor.services[version];
      },
      getLatestServiceVersion: function getLatestServiceVersion(version) {
        if (!this.constructor.services || this.constructor.services.length === 0) {
          throw new Error("No services defined on " + this.constructor.serviceIdentifier);
        }
        if (!version) {
          version = "latest";
        } else if (AWS3.util.isType(version, Date)) {
          version = AWS3.util.date.iso8601(version).split("T")[0];
        }
        if (Object.hasOwnProperty(this.constructor.services, version)) {
          return version;
        }
        var keys = Object.keys(this.constructor.services).sort();
        var selectedVersion = null;
        for (var i = keys.length - 1; i >= 0; i--) {
          if (keys[i][keys[i].length - 1] !== "*") {
            selectedVersion = keys[i];
          }
          if (keys[i].substr(0, 10) <= version) {
            return selectedVersion;
          }
        }
        throw new Error("Could not find " + this.constructor.serviceIdentifier + " API to satisfy version constraint `" + version + "'");
      },
      api: {},
      defaultRetryCount: 3,
      customizeRequests: function customizeRequests(callback) {
        if (!callback) {
          this.customRequestHandler = null;
        } else if (typeof callback === "function") {
          this.customRequestHandler = callback;
        } else {
          throw new Error("Invalid callback type '" + typeof callback + "' provided in customizeRequests");
        }
      },
      makeRequest: function makeRequest(operation, params, callback) {
        if (typeof params === "function") {
          callback = params;
          params = null;
        }
        params = params || {};
        if (this.config.params) {
          var rules = this.api.operations[operation];
          if (rules) {
            params = AWS3.util.copy(params);
            AWS3.util.each(this.config.params, function(key, value) {
              if (rules.input.members[key]) {
                if (params[key] === void 0 || params[key] === null) {
                  params[key] = value;
                }
              }
            });
          }
        }
        var request = new AWS3.Request(this, operation, params);
        this.addAllRequestListeners(request);
        this.attachMonitoringEmitter(request);
        if (callback)
          request.send(callback);
        return request;
      },
      makeUnauthenticatedRequest: function makeUnauthenticatedRequest(operation, params, callback) {
        if (typeof params === "function") {
          callback = params;
          params = {};
        }
        var request = this.makeRequest(operation, params).toUnauthenticated();
        return callback ? request.send(callback) : request;
      },
      waitFor: function waitFor(state, params, callback) {
        var waiter = new AWS3.ResourceWaiter(this, state);
        return waiter.wait(params, callback);
      },
      addAllRequestListeners: function addAllRequestListeners(request) {
        var list = [
          AWS3.events,
          AWS3.EventListeners.Core,
          this.serviceInterface(),
          AWS3.EventListeners.CorePost
        ];
        for (var i = 0; i < list.length; i++) {
          if (list[i])
            request.addListeners(list[i]);
        }
        if (!this.config.paramValidation) {
          request.removeListener("validate", AWS3.EventListeners.Core.VALIDATE_PARAMETERS);
        }
        if (this.config.logger) {
          request.addListeners(AWS3.EventListeners.Logger);
        }
        this.setupRequestListeners(request);
        if (typeof this.constructor.prototype.customRequestHandler === "function") {
          this.constructor.prototype.customRequestHandler(request);
        }
        if (Object.prototype.hasOwnProperty.call(this, "customRequestHandler") && typeof this.customRequestHandler === "function") {
          this.customRequestHandler(request);
        }
      },
      apiCallEvent: function apiCallEvent(request) {
        var api = request.service.api.operations[request.operation];
        var monitoringEvent = {
          Type: "ApiCall",
          Api: api ? api.name : request.operation,
          Version: 1,
          Service: request.service.api.serviceId || request.service.api.endpointPrefix,
          Region: request.httpRequest.region,
          MaxRetriesExceeded: 0,
          UserAgent: request.httpRequest.getUserAgent()
        };
        var response = request.response;
        if (response.httpResponse.statusCode) {
          monitoringEvent.FinalHttpStatusCode = response.httpResponse.statusCode;
        }
        if (response.error) {
          var error = response.error;
          var statusCode = response.httpResponse.statusCode;
          if (statusCode > 299) {
            if (error.code)
              monitoringEvent.FinalAwsException = error.code;
            if (error.message)
              monitoringEvent.FinalAwsExceptionMessage = error.message;
          } else {
            if (error.code || error.name)
              monitoringEvent.FinalSdkException = error.code || error.name;
            if (error.message)
              monitoringEvent.FinalSdkExceptionMessage = error.message;
          }
        }
        return monitoringEvent;
      },
      apiAttemptEvent: function apiAttemptEvent(request) {
        var api = request.service.api.operations[request.operation];
        var monitoringEvent = {
          Type: "ApiCallAttempt",
          Api: api ? api.name : request.operation,
          Version: 1,
          Service: request.service.api.serviceId || request.service.api.endpointPrefix,
          Fqdn: request.httpRequest.endpoint.hostname,
          UserAgent: request.httpRequest.getUserAgent()
        };
        var response = request.response;
        if (response.httpResponse.statusCode) {
          monitoringEvent.HttpStatusCode = response.httpResponse.statusCode;
        }
        if (!request._unAuthenticated && request.service.config.credentials && request.service.config.credentials.accessKeyId) {
          monitoringEvent.AccessKey = request.service.config.credentials.accessKeyId;
        }
        if (!response.httpResponse.headers)
          return monitoringEvent;
        if (request.httpRequest.headers["x-amz-security-token"]) {
          monitoringEvent.SessionToken = request.httpRequest.headers["x-amz-security-token"];
        }
        if (response.httpResponse.headers["x-amzn-requestid"]) {
          monitoringEvent.XAmznRequestId = response.httpResponse.headers["x-amzn-requestid"];
        }
        if (response.httpResponse.headers["x-amz-request-id"]) {
          monitoringEvent.XAmzRequestId = response.httpResponse.headers["x-amz-request-id"];
        }
        if (response.httpResponse.headers["x-amz-id-2"]) {
          monitoringEvent.XAmzId2 = response.httpResponse.headers["x-amz-id-2"];
        }
        return monitoringEvent;
      },
      attemptFailEvent: function attemptFailEvent(request) {
        var monitoringEvent = this.apiAttemptEvent(request);
        var response = request.response;
        var error = response.error;
        if (response.httpResponse.statusCode > 299) {
          if (error.code)
            monitoringEvent.AwsException = error.code;
          if (error.message)
            monitoringEvent.AwsExceptionMessage = error.message;
        } else {
          if (error.code || error.name)
            monitoringEvent.SdkException = error.code || error.name;
          if (error.message)
            monitoringEvent.SdkExceptionMessage = error.message;
        }
        return monitoringEvent;
      },
      attachMonitoringEmitter: function attachMonitoringEmitter(request) {
        var attemptTimestamp;
        var attemptStartRealTime;
        var attemptLatency;
        var callStartRealTime;
        var attemptCount = 0;
        var region;
        var callTimestamp;
        var self2 = this;
        var addToHead = true;
        request.on("validate", function() {
          callStartRealTime = AWS3.util.realClock.now();
          callTimestamp = Date.now();
        }, addToHead);
        request.on("sign", function() {
          attemptStartRealTime = AWS3.util.realClock.now();
          attemptTimestamp = Date.now();
          region = request.httpRequest.region;
          attemptCount++;
        }, addToHead);
        request.on("validateResponse", function() {
          attemptLatency = Math.round(AWS3.util.realClock.now() - attemptStartRealTime);
        });
        request.addNamedListener("API_CALL_ATTEMPT", "success", function API_CALL_ATTEMPT() {
          var apiAttemptEvent = self2.apiAttemptEvent(request);
          apiAttemptEvent.Timestamp = attemptTimestamp;
          apiAttemptEvent.AttemptLatency = attemptLatency >= 0 ? attemptLatency : 0;
          apiAttemptEvent.Region = region;
          self2.emit("apiCallAttempt", [apiAttemptEvent]);
        });
        request.addNamedListener("API_CALL_ATTEMPT_RETRY", "retry", function API_CALL_ATTEMPT_RETRY() {
          var apiAttemptEvent = self2.attemptFailEvent(request);
          apiAttemptEvent.Timestamp = attemptTimestamp;
          attemptLatency = attemptLatency || Math.round(AWS3.util.realClock.now() - attemptStartRealTime);
          apiAttemptEvent.AttemptLatency = attemptLatency >= 0 ? attemptLatency : 0;
          apiAttemptEvent.Region = region;
          self2.emit("apiCallAttempt", [apiAttemptEvent]);
        });
        request.addNamedListener("API_CALL", "complete", function API_CALL() {
          var apiCallEvent = self2.apiCallEvent(request);
          apiCallEvent.AttemptCount = attemptCount;
          if (apiCallEvent.AttemptCount <= 0)
            return;
          apiCallEvent.Timestamp = callTimestamp;
          var latency = Math.round(AWS3.util.realClock.now() - callStartRealTime);
          apiCallEvent.Latency = latency >= 0 ? latency : 0;
          var response = request.response;
          if (response.error && response.error.retryable && typeof response.retryCount === "number" && typeof response.maxRetries === "number" && response.retryCount >= response.maxRetries) {
            apiCallEvent.MaxRetriesExceeded = 1;
          }
          self2.emit("apiCall", [apiCallEvent]);
        });
      },
      setupRequestListeners: function setupRequestListeners(request) {
      },
      getSigningName: function getSigningName() {
        return this.api.signingName || this.api.endpointPrefix;
      },
      getSignerClass: function getSignerClass(request) {
        var version;
        var operation = null;
        var authtype = "";
        if (request) {
          var operations = request.service.api.operations || {};
          operation = operations[request.operation] || null;
          authtype = operation ? operation.authtype : "";
        }
        if (this.config.signatureVersion) {
          version = this.config.signatureVersion;
        } else if (authtype === "v4" || authtype === "v4-unsigned-body") {
          version = "v4";
        } else {
          version = this.api.signatureVersion;
        }
        return AWS3.Signers.RequestSigner.getVersion(version);
      },
      serviceInterface: function serviceInterface() {
        switch (this.api.protocol) {
          case "ec2":
            return AWS3.EventListeners.Query;
          case "query":
            return AWS3.EventListeners.Query;
          case "json":
            return AWS3.EventListeners.Json;
          case "rest-json":
            return AWS3.EventListeners.RestJson;
          case "rest-xml":
            return AWS3.EventListeners.RestXml;
        }
        if (this.api.protocol) {
          throw new Error("Invalid service `protocol' " + this.api.protocol + " in API config");
        }
      },
      successfulResponse: function successfulResponse(resp) {
        return resp.httpResponse.statusCode < 300;
      },
      numRetries: function numRetries() {
        if (this.config.maxRetries !== void 0) {
          return this.config.maxRetries;
        } else {
          return this.defaultRetryCount;
        }
      },
      retryDelays: function retryDelays(retryCount, err) {
        return AWS3.util.calculateRetryDelay(retryCount, this.config.retryDelayOptions, err);
      },
      retryableError: function retryableError(error) {
        if (this.timeoutError(error))
          return true;
        if (this.networkingError(error))
          return true;
        if (this.expiredCredentialsError(error))
          return true;
        if (this.throttledError(error))
          return true;
        if (error.statusCode >= 500)
          return true;
        return false;
      },
      networkingError: function networkingError(error) {
        return error.code === "NetworkingError";
      },
      timeoutError: function timeoutError(error) {
        return error.code === "TimeoutError";
      },
      expiredCredentialsError: function expiredCredentialsError(error) {
        return error.code === "ExpiredTokenException";
      },
      clockSkewError: function clockSkewError(error) {
        switch (error.code) {
          case "RequestTimeTooSkewed":
          case "RequestExpired":
          case "InvalidSignatureException":
          case "SignatureDoesNotMatch":
          case "AuthFailure":
          case "RequestInTheFuture":
            return true;
          default:
            return false;
        }
      },
      getSkewCorrectedDate: function getSkewCorrectedDate() {
        return new Date(Date.now() + this.config.systemClockOffset);
      },
      applyClockOffset: function applyClockOffset(newServerTime) {
        if (newServerTime) {
          this.config.systemClockOffset = newServerTime - Date.now();
        }
      },
      isClockSkewed: function isClockSkewed(newServerTime) {
        if (newServerTime) {
          return Math.abs(this.getSkewCorrectedDate().getTime() - newServerTime) >= 3e5;
        }
      },
      throttledError: function throttledError(error) {
        if (error.statusCode === 429)
          return true;
        switch (error.code) {
          case "ProvisionedThroughputExceededException":
          case "Throttling":
          case "ThrottlingException":
          case "RequestLimitExceeded":
          case "RequestThrottled":
          case "RequestThrottledException":
          case "TooManyRequestsException":
          case "TransactionInProgressException":
          case "EC2ThrottledException":
            return true;
          default:
            return false;
        }
      },
      endpointFromTemplate: function endpointFromTemplate(endpoint) {
        if (typeof endpoint !== "string")
          return endpoint;
        var e = endpoint;
        e = e.replace(/\{service\}/g, this.api.endpointPrefix);
        e = e.replace(/\{region\}/g, this.config.region);
        e = e.replace(/\{scheme\}/g, this.config.sslEnabled ? "https" : "http");
        return e;
      },
      setEndpoint: function setEndpoint(endpoint) {
        this.endpoint = new AWS3.Endpoint(endpoint, this.config);
      },
      paginationConfig: function paginationConfig(operation, throwException) {
        var paginator = this.api.operations[operation].paginator;
        if (!paginator) {
          if (throwException) {
            var e = new Error();
            throw AWS3.util.error(e, "No pagination configuration for " + operation);
          }
          return null;
        }
        return paginator;
      }
    });
    AWS3.util.update(AWS3.Service, {
      defineMethods: function defineMethods(svc) {
        AWS3.util.each(svc.prototype.api.operations, function iterator(method) {
          if (svc.prototype[method])
            return;
          var operation = svc.prototype.api.operations[method];
          if (operation.authtype === "none") {
            svc.prototype[method] = function(params, callback) {
              return this.makeUnauthenticatedRequest(method, params, callback);
            };
          } else {
            svc.prototype[method] = function(params, callback) {
              return this.makeRequest(method, params, callback);
            };
          }
        });
      },
      defineService: function defineService(serviceIdentifier, versions, features) {
        AWS3.Service._serviceMap[serviceIdentifier] = true;
        if (!Array.isArray(versions)) {
          features = versions;
          versions = [];
        }
        var svc = inherit(AWS3.Service, features || {});
        if (typeof serviceIdentifier === "string") {
          AWS3.Service.addVersions(svc, versions);
          var identifier = svc.serviceIdentifier || serviceIdentifier;
          svc.serviceIdentifier = identifier;
        } else {
          svc.prototype.api = serviceIdentifier;
          AWS3.Service.defineMethods(svc);
        }
        AWS3.SequentialExecutor.call(this.prototype);
        if (!this.prototype.publisher && AWS3.util.clientSideMonitoring) {
          var Publisher = AWS3.util.clientSideMonitoring.Publisher;
          var configProvider = AWS3.util.clientSideMonitoring.configProvider;
          var publisherConfig = configProvider();
          this.prototype.publisher = new Publisher(publisherConfig);
          if (publisherConfig.enabled) {
            AWS3.Service._clientSideMonitoring = true;
          }
        }
        AWS3.SequentialExecutor.call(svc.prototype);
        AWS3.Service.addDefaultMonitoringListeners(svc.prototype);
        return svc;
      },
      addVersions: function addVersions(svc, versions) {
        if (!Array.isArray(versions))
          versions = [versions];
        svc.services = svc.services || {};
        for (var i = 0; i < versions.length; i++) {
          if (svc.services[versions[i]] === void 0) {
            svc.services[versions[i]] = null;
          }
        }
        svc.apiVersions = Object.keys(svc.services).sort();
      },
      defineServiceApi: function defineServiceApi(superclass, version, apiConfig) {
        var svc = inherit(superclass, {
          serviceIdentifier: superclass.serviceIdentifier
        });
        function setApi(api) {
          if (api.isApi) {
            svc.prototype.api = api;
          } else {
            svc.prototype.api = new Api(api, {
              serviceIdentifier: superclass.serviceIdentifier
            });
          }
        }
        if (typeof version === "string") {
          if (apiConfig) {
            setApi(apiConfig);
          } else {
            try {
              setApi(AWS3.apiLoader(superclass.serviceIdentifier, version));
            } catch (err) {
              throw AWS3.util.error(err, {
                message: "Could not find API configuration " + superclass.serviceIdentifier + "-" + version
              });
            }
          }
          if (!Object.prototype.hasOwnProperty.call(superclass.services, version)) {
            superclass.apiVersions = superclass.apiVersions.concat(version).sort();
          }
          superclass.services[version] = svc;
        } else {
          setApi(version);
        }
        AWS3.Service.defineMethods(svc);
        return svc;
      },
      hasService: function(identifier) {
        return Object.prototype.hasOwnProperty.call(AWS3.Service._serviceMap, identifier);
      },
      addDefaultMonitoringListeners: function addDefaultMonitoringListeners(attachOn) {
        attachOn.addNamedListener("MONITOR_EVENTS_BUBBLE", "apiCallAttempt", function EVENTS_BUBBLE(event) {
          var baseClass = Object.getPrototypeOf(attachOn);
          if (baseClass._events)
            baseClass.emit("apiCallAttempt", [event]);
        });
        attachOn.addNamedListener("CALL_EVENTS_BUBBLE", "apiCall", function CALL_EVENTS_BUBBLE(event) {
          var baseClass = Object.getPrototypeOf(attachOn);
          if (baseClass._events)
            baseClass.emit("apiCall", [event]);
        });
      },
      _serviceMap: {}
    });
    AWS3.util.mixin(AWS3.Service, AWS3.SequentialExecutor);
    module2.exports = AWS3.Service;
  }
});

// node_modules/aws-sdk/lib/credentials.js
var require_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials.js"() {
    var AWS3 = require_core();
    AWS3.Credentials = AWS3.util.inherit({
      constructor: function Credentials() {
        AWS3.util.hideProperties(this, ["secretAccessKey"]);
        this.expired = false;
        this.expireTime = null;
        this.refreshCallbacks = [];
        if (arguments.length === 1 && typeof arguments[0] === "object") {
          var creds = arguments[0].credentials || arguments[0];
          this.accessKeyId = creds.accessKeyId;
          this.secretAccessKey = creds.secretAccessKey;
          this.sessionToken = creds.sessionToken;
        } else {
          this.accessKeyId = arguments[0];
          this.secretAccessKey = arguments[1];
          this.sessionToken = arguments[2];
        }
      },
      expiryWindow: 15,
      needsRefresh: function needsRefresh() {
        var currentTime = AWS3.util.date.getDate().getTime();
        var adjustedTime = new Date(currentTime + this.expiryWindow * 1e3);
        if (this.expireTime && adjustedTime > this.expireTime) {
          return true;
        } else {
          return this.expired || !this.accessKeyId || !this.secretAccessKey;
        }
      },
      get: function get(callback) {
        var self2 = this;
        if (this.needsRefresh()) {
          this.refresh(function(err) {
            if (!err)
              self2.expired = false;
            if (callback)
              callback(err);
          });
        } else if (callback) {
          callback();
        }
      },
      refresh: function refresh(callback) {
        this.expired = false;
        callback();
      },
      coalesceRefresh: function coalesceRefresh(callback, sync) {
        var self2 = this;
        if (self2.refreshCallbacks.push(callback) === 1) {
          self2.load(function onLoad(err) {
            AWS3.util.arrayEach(self2.refreshCallbacks, function(callback2) {
              if (sync) {
                callback2(err);
              } else {
                AWS3.util.defer(function() {
                  callback2(err);
                });
              }
            });
            self2.refreshCallbacks.length = 0;
          });
        }
      },
      load: function load(callback) {
        callback();
      }
    });
    AWS3.Credentials.addPromisesToClass = function addPromisesToClass(PromiseDependency) {
      this.prototype.getPromise = AWS3.util.promisifyMethod("get", PromiseDependency);
      this.prototype.refreshPromise = AWS3.util.promisifyMethod("refresh", PromiseDependency);
    };
    AWS3.Credentials.deletePromisesFromClass = function deletePromisesFromClass() {
      delete this.prototype.getPromise;
      delete this.prototype.refreshPromise;
    };
    AWS3.util.addPromises(AWS3.Credentials);
  }
});

// node_modules/aws-sdk/lib/credentials/credential_provider_chain.js
var require_credential_provider_chain = __commonJS({
  "node_modules/aws-sdk/lib/credentials/credential_provider_chain.js"() {
    var AWS3 = require_core();
    AWS3.CredentialProviderChain = AWS3.util.inherit(AWS3.Credentials, {
      constructor: function CredentialProviderChain(providers) {
        if (providers) {
          this.providers = providers;
        } else {
          this.providers = AWS3.CredentialProviderChain.defaultProviders.slice(0);
        }
        this.resolveCallbacks = [];
      },
      resolve: function resolve(callback) {
        var self2 = this;
        if (self2.providers.length === 0) {
          callback(new Error("No providers"));
          return self2;
        }
        if (self2.resolveCallbacks.push(callback) === 1) {
          let resolveNext2 = function(err, creds) {
            if (!err && creds || index === providers.length) {
              AWS3.util.arrayEach(self2.resolveCallbacks, function(callback2) {
                callback2(err, creds);
              });
              self2.resolveCallbacks.length = 0;
              return;
            }
            var provider = providers[index++];
            if (typeof provider === "function") {
              creds = provider.call();
            } else {
              creds = provider;
            }
            if (creds.get) {
              creds.get(function(getErr) {
                resolveNext2(getErr, getErr ? null : creds);
              });
            } else {
              resolveNext2(null, creds);
            }
          };
          var resolveNext = resolveNext2;
          var index = 0;
          var providers = self2.providers.slice(0);
          resolveNext2();
        }
        return self2;
      }
    });
    AWS3.CredentialProviderChain.defaultProviders = [];
    AWS3.CredentialProviderChain.addPromisesToClass = function addPromisesToClass(PromiseDependency) {
      this.prototype.resolvePromise = AWS3.util.promisifyMethod("resolve", PromiseDependency);
    };
    AWS3.CredentialProviderChain.deletePromisesFromClass = function deletePromisesFromClass() {
      delete this.prototype.resolvePromise;
    };
    AWS3.util.addPromises(AWS3.CredentialProviderChain);
  }
});

// node_modules/aws-sdk/lib/config.js
var require_config = __commonJS({
  "node_modules/aws-sdk/lib/config.js"() {
    var AWS3 = require_core();
    require_credentials();
    require_credential_provider_chain();
    var PromisesDependency;
    AWS3.Config = AWS3.util.inherit({
      constructor: function Config(options) {
        if (options === void 0)
          options = {};
        options = this.extractCredentials(options);
        AWS3.util.each.call(this, this.keys, function(key, value) {
          this.set(key, options[key], value);
        });
      },
      getCredentials: function getCredentials(callback) {
        var self2 = this;
        function finish(err) {
          callback(err, err ? null : self2.credentials);
        }
        function credError(msg, err) {
          return new AWS3.util.error(err || new Error(), {
            code: "CredentialsError",
            message: msg,
            name: "CredentialsError"
          });
        }
        function getAsyncCredentials() {
          self2.credentials.get(function(err) {
            if (err) {
              var msg = "Could not load credentials from " + self2.credentials.constructor.name;
              err = credError(msg, err);
            }
            finish(err);
          });
        }
        function getStaticCredentials() {
          var err = null;
          if (!self2.credentials.accessKeyId || !self2.credentials.secretAccessKey) {
            err = credError("Missing credentials");
          }
          finish(err);
        }
        if (self2.credentials) {
          if (typeof self2.credentials.get === "function") {
            getAsyncCredentials();
          } else {
            getStaticCredentials();
          }
        } else if (self2.credentialProvider) {
          self2.credentialProvider.resolve(function(err, creds) {
            if (err) {
              err = credError("Could not load credentials from any providers", err);
            }
            self2.credentials = creds;
            finish(err);
          });
        } else {
          finish(credError("No credentials to load"));
        }
      },
      update: function update(options, allowUnknownKeys) {
        allowUnknownKeys = allowUnknownKeys || false;
        options = this.extractCredentials(options);
        AWS3.util.each.call(this, options, function(key, value) {
          if (allowUnknownKeys || Object.prototype.hasOwnProperty.call(this.keys, key) || AWS3.Service.hasService(key)) {
            this.set(key, value);
          }
        });
      },
      loadFromPath: function loadFromPath(path2) {
        this.clear();
        var options = JSON.parse(AWS3.util.readFileSync(path2));
        var fileSystemCreds = new AWS3.FileSystemCredentials(path2);
        var chain = new AWS3.CredentialProviderChain();
        chain.providers.unshift(fileSystemCreds);
        chain.resolve(function(err, creds) {
          if (err)
            throw err;
          else
            options.credentials = creds;
        });
        this.constructor(options);
        return this;
      },
      clear: function clear() {
        AWS3.util.each.call(this, this.keys, function(key) {
          delete this[key];
        });
        this.set("credentials", void 0);
        this.set("credentialProvider", void 0);
      },
      set: function set(property, value, defaultValue) {
        if (value === void 0) {
          if (defaultValue === void 0) {
            defaultValue = this.keys[property];
          }
          if (typeof defaultValue === "function") {
            this[property] = defaultValue.call(this);
          } else {
            this[property] = defaultValue;
          }
        } else if (property === "httpOptions" && this[property]) {
          this[property] = AWS3.util.merge(this[property], value);
        } else {
          this[property] = value;
        }
      },
      keys: {
        credentials: null,
        credentialProvider: null,
        region: null,
        logger: null,
        apiVersions: {},
        apiVersion: null,
        endpoint: void 0,
        httpOptions: {
          timeout: 12e4
        },
        maxRetries: void 0,
        maxRedirects: 10,
        paramValidation: true,
        sslEnabled: true,
        s3ForcePathStyle: false,
        s3BucketEndpoint: false,
        s3DisableBodySigning: true,
        s3UsEast1RegionalEndpoint: "legacy",
        s3UseArnRegion: void 0,
        computeChecksums: true,
        convertResponseTypes: true,
        correctClockSkew: false,
        customUserAgent: null,
        dynamoDbCrc32: true,
        systemClockOffset: 0,
        signatureVersion: null,
        signatureCache: true,
        retryDelayOptions: {},
        useAccelerateEndpoint: false,
        clientSideMonitoring: false,
        endpointDiscoveryEnabled: void 0,
        endpointCacheSize: 1e3,
        hostPrefixEnabled: true,
        stsRegionalEndpoints: "legacy"
      },
      extractCredentials: function extractCredentials(options) {
        if (options.accessKeyId && options.secretAccessKey) {
          options = AWS3.util.copy(options);
          options.credentials = new AWS3.Credentials(options);
        }
        return options;
      },
      setPromisesDependency: function setPromisesDependency(dep) {
        PromisesDependency = dep;
        if (dep === null && typeof Promise === "function") {
          PromisesDependency = Promise;
        }
        var constructors = [AWS3.Request, AWS3.Credentials, AWS3.CredentialProviderChain];
        if (AWS3.S3) {
          constructors.push(AWS3.S3);
          if (AWS3.S3.ManagedUpload) {
            constructors.push(AWS3.S3.ManagedUpload);
          }
        }
        AWS3.util.addPromises(constructors, PromisesDependency);
      },
      getPromisesDependency: function getPromisesDependency() {
        return PromisesDependency;
      }
    });
    AWS3.config = new AWS3.Config();
  }
});

// node_modules/aws-sdk/lib/http.js
var require_http = __commonJS({
  "node_modules/aws-sdk/lib/http.js"() {
    var AWS3 = require_core();
    var inherit = AWS3.util.inherit;
    AWS3.Endpoint = inherit({
      constructor: function Endpoint(endpoint, config) {
        AWS3.util.hideProperties(this, ["slashes", "auth", "hash", "search", "query"]);
        if (typeof endpoint === "undefined" || endpoint === null) {
          throw new Error("Invalid endpoint: " + endpoint);
        } else if (typeof endpoint !== "string") {
          return AWS3.util.copy(endpoint);
        }
        if (!endpoint.match(/^http/)) {
          var useSSL = config && config.sslEnabled !== void 0 ? config.sslEnabled : AWS3.config.sslEnabled;
          endpoint = (useSSL ? "https" : "http") + "://" + endpoint;
        }
        AWS3.util.update(this, AWS3.util.urlParse(endpoint));
        if (this.port) {
          this.port = parseInt(this.port, 10);
        } else {
          this.port = this.protocol === "https:" ? 443 : 80;
        }
      }
    });
    AWS3.HttpRequest = inherit({
      constructor: function HttpRequest(endpoint, region) {
        endpoint = new AWS3.Endpoint(endpoint);
        this.method = "POST";
        this.path = endpoint.path || "/";
        this.headers = {};
        this.body = "";
        this.endpoint = endpoint;
        this.region = region;
        this._userAgent = "";
        this.setUserAgent();
      },
      setUserAgent: function setUserAgent() {
        this._userAgent = this.headers[this.getUserAgentHeaderName()] = AWS3.util.userAgent();
      },
      getUserAgentHeaderName: function getUserAgentHeaderName() {
        var prefix = AWS3.util.isBrowser() ? "X-Amz-" : "";
        return prefix + "User-Agent";
      },
      appendToUserAgent: function appendToUserAgent(agentPartial) {
        if (typeof agentPartial === "string" && agentPartial) {
          this._userAgent += " " + agentPartial;
        }
        this.headers[this.getUserAgentHeaderName()] = this._userAgent;
      },
      getUserAgent: function getUserAgent() {
        return this._userAgent;
      },
      pathname: function pathname() {
        return this.path.split("?", 1)[0];
      },
      search: function search() {
        var query = this.path.split("?", 2)[1];
        if (query) {
          query = AWS3.util.queryStringParse(query);
          return AWS3.util.queryParamsToString(query);
        }
        return "";
      },
      updateEndpoint: function updateEndpoint(endpointStr) {
        var newEndpoint = new AWS3.Endpoint(endpointStr);
        this.endpoint = newEndpoint;
        this.path = newEndpoint.path || "/";
        if (this.headers["Host"]) {
          this.headers["Host"] = newEndpoint.host;
        }
      }
    });
    AWS3.HttpResponse = inherit({
      constructor: function HttpResponse() {
        this.statusCode = void 0;
        this.headers = {};
        this.body = void 0;
        this.streaming = false;
        this.stream = null;
      },
      createUnbufferedStream: function createUnbufferedStream() {
        this.streaming = true;
        return this.stream;
      }
    });
    AWS3.HttpClient = inherit({});
    AWS3.HttpClient.getInstance = function getInstance() {
      if (this.singleton === void 0) {
        this.singleton = new this();
      }
      return this.singleton;
    };
  }
});

// node_modules/aws-sdk/lib/discover_endpoint.js
var require_discover_endpoint = __commonJS({
  "node_modules/aws-sdk/lib/discover_endpoint.js"(exports, module2) {
    var AWS3 = require_core();
    var util = require_util4();
    var endpointDiscoveryEnabledEnvs = ["AWS_ENABLE_ENDPOINT_DISCOVERY", "AWS_ENDPOINT_DISCOVERY_ENABLED"];
    function getCacheKey(request) {
      var service = request.service;
      var api = service.api || {};
      var operations = api.operations;
      var identifiers = {};
      if (service.config.region) {
        identifiers.region = service.config.region;
      }
      if (api.serviceId) {
        identifiers.serviceId = api.serviceId;
      }
      if (service.config.credentials.accessKeyId) {
        identifiers.accessKeyId = service.config.credentials.accessKeyId;
      }
      return identifiers;
    }
    function marshallCustomIdentifiersHelper(result, params, shape) {
      if (!shape || params === void 0 || params === null)
        return;
      if (shape.type === "structure" && shape.required && shape.required.length > 0) {
        util.arrayEach(shape.required, function(name) {
          var memberShape = shape.members[name];
          if (memberShape.endpointDiscoveryId === true) {
            var locationName = memberShape.isLocationName ? memberShape.name : name;
            result[locationName] = String(params[name]);
          } else {
            marshallCustomIdentifiersHelper(result, params[name], memberShape);
          }
        });
      }
    }
    function marshallCustomIdentifiers(request, shape) {
      var identifiers = {};
      marshallCustomIdentifiersHelper(identifiers, request.params, shape);
      return identifiers;
    }
    function optionalDiscoverEndpoint(request) {
      var service = request.service;
      var api = service.api;
      var operationModel = api.operations ? api.operations[request.operation] : void 0;
      var inputShape = operationModel ? operationModel.input : void 0;
      var identifiers = marshallCustomIdentifiers(request, inputShape);
      var cacheKey = getCacheKey(request);
      if (Object.keys(identifiers).length > 0) {
        cacheKey = util.update(cacheKey, identifiers);
        if (operationModel)
          cacheKey.operation = operationModel.name;
      }
      var endpoints = AWS3.endpointCache.get(cacheKey);
      if (endpoints && endpoints.length === 1 && endpoints[0].Address === "") {
        return;
      } else if (endpoints && endpoints.length > 0) {
        request.httpRequest.updateEndpoint(endpoints[0].Address);
      } else {
        var endpointRequest = service.makeRequest(api.endpointOperation, {
          Operation: operationModel.name,
          Identifiers: identifiers
        });
        addApiVersionHeader(endpointRequest);
        endpointRequest.removeListener("validate", AWS3.EventListeners.Core.VALIDATE_PARAMETERS);
        endpointRequest.removeListener("retry", AWS3.EventListeners.Core.RETRY_CHECK);
        AWS3.endpointCache.put(cacheKey, [{
          Address: "",
          CachePeriodInMinutes: 1
        }]);
        endpointRequest.send(function(err, data) {
          if (data && data.Endpoints) {
            AWS3.endpointCache.put(cacheKey, data.Endpoints);
          } else if (err) {
            AWS3.endpointCache.put(cacheKey, [{
              Address: "",
              CachePeriodInMinutes: 1
            }]);
          }
        });
      }
    }
    var requestQueue = {};
    function requiredDiscoverEndpoint(request, done) {
      var service = request.service;
      var api = service.api;
      var operationModel = api.operations ? api.operations[request.operation] : void 0;
      var inputShape = operationModel ? operationModel.input : void 0;
      var identifiers = marshallCustomIdentifiers(request, inputShape);
      var cacheKey = getCacheKey(request);
      if (Object.keys(identifiers).length > 0) {
        cacheKey = util.update(cacheKey, identifiers);
        if (operationModel)
          cacheKey.operation = operationModel.name;
      }
      var cacheKeyStr = AWS3.EndpointCache.getKeyString(cacheKey);
      var endpoints = AWS3.endpointCache.get(cacheKeyStr);
      if (endpoints && endpoints.length === 1 && endpoints[0].Address === "") {
        if (!requestQueue[cacheKeyStr])
          requestQueue[cacheKeyStr] = [];
        requestQueue[cacheKeyStr].push({ request, callback: done });
        return;
      } else if (endpoints && endpoints.length > 0) {
        request.httpRequest.updateEndpoint(endpoints[0].Address);
        done();
      } else {
        var endpointRequest = service.makeRequest(api.endpointOperation, {
          Operation: operationModel.name,
          Identifiers: identifiers
        });
        endpointRequest.removeListener("validate", AWS3.EventListeners.Core.VALIDATE_PARAMETERS);
        addApiVersionHeader(endpointRequest);
        AWS3.endpointCache.put(cacheKeyStr, [{
          Address: "",
          CachePeriodInMinutes: 60
        }]);
        endpointRequest.send(function(err, data) {
          if (err) {
            request.response.error = util.error(err, { retryable: false });
            AWS3.endpointCache.remove(cacheKey);
            if (requestQueue[cacheKeyStr]) {
              var pendingRequests = requestQueue[cacheKeyStr];
              util.arrayEach(pendingRequests, function(requestContext) {
                requestContext.request.response.error = util.error(err, { retryable: false });
                requestContext.callback();
              });
              delete requestQueue[cacheKeyStr];
            }
          } else if (data) {
            AWS3.endpointCache.put(cacheKeyStr, data.Endpoints);
            request.httpRequest.updateEndpoint(data.Endpoints[0].Address);
            if (requestQueue[cacheKeyStr]) {
              var pendingRequests = requestQueue[cacheKeyStr];
              util.arrayEach(pendingRequests, function(requestContext) {
                requestContext.request.httpRequest.updateEndpoint(data.Endpoints[0].Address);
                requestContext.callback();
              });
              delete requestQueue[cacheKeyStr];
            }
          }
          done();
        });
      }
    }
    function addApiVersionHeader(endpointRequest) {
      var api = endpointRequest.service.api;
      var apiVersion = api.apiVersion;
      if (apiVersion && !endpointRequest.httpRequest.headers["x-amz-api-version"]) {
        endpointRequest.httpRequest.headers["x-amz-api-version"] = apiVersion;
      }
    }
    function invalidateCachedEndpoints(response) {
      var error = response.error;
      var httpResponse = response.httpResponse;
      if (error && (error.code === "InvalidEndpointException" || httpResponse.statusCode === 421)) {
        var request = response.request;
        var operations = request.service.api.operations || {};
        var inputShape = operations[request.operation] ? operations[request.operation].input : void 0;
        var identifiers = marshallCustomIdentifiers(request, inputShape);
        var cacheKey = getCacheKey(request);
        if (Object.keys(identifiers).length > 0) {
          cacheKey = util.update(cacheKey, identifiers);
          if (operations[request.operation])
            cacheKey.operation = operations[request.operation].name;
        }
        AWS3.endpointCache.remove(cacheKey);
      }
    }
    function hasCustomEndpoint(client) {
      if (client._originalConfig && client._originalConfig.endpoint && client._originalConfig.endpointDiscoveryEnabled === true) {
        throw util.error(new Error(), {
          code: "ConfigurationException",
          message: "Custom endpoint is supplied; endpointDiscoveryEnabled must not be true."
        });
      }
      ;
      var svcConfig = AWS3.config[client.serviceIdentifier] || {};
      return Boolean(AWS3.config.endpoint || svcConfig.endpoint || client._originalConfig && client._originalConfig.endpoint);
    }
    function isFalsy(value) {
      return ["false", "0"].indexOf(value) >= 0;
    }
    function resolveEndpointDiscoveryConfig(request) {
      var service = request.service || {};
      if (service.config.endpointDiscoveryEnabled !== void 0) {
        return service.config.endpointDiscoveryEnabled;
      }
      if (util.isBrowser())
        return void 0;
      for (var i = 0; i < endpointDiscoveryEnabledEnvs.length; i++) {
        var env2 = endpointDiscoveryEnabledEnvs[i];
        if (Object.prototype.hasOwnProperty.call(process.env, env2)) {
          if (process.env[env2] === "" || process.env[env2] === void 0) {
            throw util.error(new Error(), {
              code: "ConfigurationException",
              message: "environmental variable " + env2 + " cannot be set to nothing"
            });
          }
          return !isFalsy(process.env[env2]);
        }
      }
      var configFile = {};
      try {
        configFile = AWS3.util.iniLoader ? AWS3.util.iniLoader.loadFrom({
          isConfig: true,
          filename: process.env[AWS3.util.sharedConfigFileEnv]
        }) : {};
      } catch (e) {
      }
      var sharedFileConfig = configFile[process.env.AWS_PROFILE || AWS3.util.defaultProfile] || {};
      if (Object.prototype.hasOwnProperty.call(sharedFileConfig, "endpoint_discovery_enabled")) {
        if (sharedFileConfig.endpoint_discovery_enabled === void 0) {
          throw util.error(new Error(), {
            code: "ConfigurationException",
            message: "config file entry 'endpoint_discovery_enabled' cannot be set to nothing"
          });
        }
        return !isFalsy(sharedFileConfig.endpoint_discovery_enabled);
      }
      return void 0;
    }
    function discoverEndpoint(request, done) {
      var service = request.service || {};
      if (hasCustomEndpoint(service) || request.isPresigned())
        return done();
      var operations = service.api.operations || {};
      var operationModel = operations[request.operation];
      var isEndpointDiscoveryRequired = operationModel ? operationModel.endpointDiscoveryRequired : "NULL";
      var isEnabled = resolveEndpointDiscoveryConfig(request);
      var hasRequiredEndpointDiscovery = service.api.hasRequiredEndpointDiscovery;
      if (isEnabled || hasRequiredEndpointDiscovery) {
        request.httpRequest.appendToUserAgent("endpoint-discovery");
      }
      switch (isEndpointDiscoveryRequired) {
        case "OPTIONAL":
          if (isEnabled || hasRequiredEndpointDiscovery) {
            optionalDiscoverEndpoint(request);
            request.addNamedListener("INVALIDATE_CACHED_ENDPOINTS", "extractError", invalidateCachedEndpoints);
          }
          done();
          break;
        case "REQUIRED":
          if (isEnabled === false) {
            request.response.error = util.error(new Error(), {
              code: "ConfigurationException",
              message: "Endpoint Discovery is disabled but " + service.api.className + "." + request.operation + "() requires it. Please check your configurations."
            });
            done();
            break;
          }
          request.addNamedListener("INVALIDATE_CACHED_ENDPOINTS", "extractError", invalidateCachedEndpoints);
          requiredDiscoverEndpoint(request, done);
          break;
        case "NULL":
        default:
          done();
          break;
      }
    }
    module2.exports = {
      discoverEndpoint,
      requiredDiscoverEndpoint,
      optionalDiscoverEndpoint,
      marshallCustomIdentifiers,
      getCacheKey,
      invalidateCachedEndpoint: invalidateCachedEndpoints
    };
  }
});

// node_modules/aws-sdk/lib/event_listeners.js
var require_event_listeners = __commonJS({
  "node_modules/aws-sdk/lib/event_listeners.js"() {
    var AWS3 = require_core();
    var SequentialExecutor = require_sequential_executor();
    var DISCOVER_ENDPOINT = require_discover_endpoint().discoverEndpoint;
    AWS3.EventListeners = {
      Core: {}
    };
    function getOperationAuthtype(req) {
      if (!req.service.api.operations) {
        return "";
      }
      var operation = req.service.api.operations[req.operation];
      return operation ? operation.authtype : "";
    }
    AWS3.EventListeners = {
      Core: new SequentialExecutor().addNamedListeners(function(add, addAsync) {
        addAsync("VALIDATE_CREDENTIALS", "validate", function VALIDATE_CREDENTIALS(req, done) {
          if (!req.service.api.signatureVersion && !req.service.config.signatureVersion)
            return done();
          req.service.config.getCredentials(function(err) {
            if (err) {
              req.response.error = AWS3.util.error(err, { code: "CredentialsError", message: "Missing credentials in config, if using AWS_CONFIG_FILE, set AWS_SDK_LOAD_CONFIG=1" });
            }
            done();
          });
        });
        add("VALIDATE_REGION", "validate", function VALIDATE_REGION(req) {
          if (!req.service.isGlobalEndpoint) {
            var dnsHostRegex = new RegExp(/^([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9-]{0,61}[a-zA-Z0-9])$/);
            if (!req.service.config.region) {
              req.response.error = AWS3.util.error(new Error(), { code: "ConfigError", message: "Missing region in config" });
            } else if (!dnsHostRegex.test(req.service.config.region)) {
              req.response.error = AWS3.util.error(new Error(), { code: "ConfigError", message: "Invalid region in config" });
            }
          }
        });
        add("BUILD_IDEMPOTENCY_TOKENS", "validate", function BUILD_IDEMPOTENCY_TOKENS(req) {
          if (!req.service.api.operations) {
            return;
          }
          var operation = req.service.api.operations[req.operation];
          if (!operation) {
            return;
          }
          var idempotentMembers = operation.idempotentMembers;
          if (!idempotentMembers.length) {
            return;
          }
          var params = AWS3.util.copy(req.params);
          for (var i = 0, iLen = idempotentMembers.length; i < iLen; i++) {
            if (!params[idempotentMembers[i]]) {
              params[idempotentMembers[i]] = AWS3.util.uuid.v4();
            }
          }
          req.params = params;
        });
        add("VALIDATE_PARAMETERS", "validate", function VALIDATE_PARAMETERS(req) {
          if (!req.service.api.operations) {
            return;
          }
          var rules = req.service.api.operations[req.operation].input;
          var validation = req.service.config.paramValidation;
          new AWS3.ParamValidator(validation).validate(rules, req.params);
        });
        add("COMPUTE_CHECKSUM", "afterBuild", function COMPUTE_CHECKSUM(req) {
          if (!req.service.api.operations) {
            return;
          }
          var operation = req.service.api.operations[req.operation];
          if (!operation) {
            return;
          }
          var body = req.httpRequest.body;
          var isNonStreamingPayload = body && (AWS3.util.Buffer.isBuffer(body) || typeof body === "string");
          var headers = req.httpRequest.headers;
          if (operation.httpChecksumRequired && req.service.config.computeChecksums && isNonStreamingPayload && !headers["Content-MD5"]) {
            var md5 = AWS3.util.crypto.md5(body, "base64");
            headers["Content-MD5"] = md5;
          }
        });
        addAsync("COMPUTE_SHA256", "afterBuild", function COMPUTE_SHA256(req, done) {
          req.haltHandlersOnError();
          if (!req.service.api.operations) {
            return;
          }
          var operation = req.service.api.operations[req.operation];
          var authtype = operation ? operation.authtype : "";
          if (!req.service.api.signatureVersion && !authtype && !req.service.config.signatureVersion)
            return done();
          if (req.service.getSignerClass(req) === AWS3.Signers.V4) {
            var body = req.httpRequest.body || "";
            if (authtype.indexOf("unsigned-body") >= 0) {
              req.httpRequest.headers["X-Amz-Content-Sha256"] = "UNSIGNED-PAYLOAD";
              return done();
            }
            AWS3.util.computeSha256(body, function(err, sha) {
              if (err) {
                done(err);
              } else {
                req.httpRequest.headers["X-Amz-Content-Sha256"] = sha;
                done();
              }
            });
          } else {
            done();
          }
        });
        add("SET_CONTENT_LENGTH", "afterBuild", function SET_CONTENT_LENGTH(req) {
          var authtype = getOperationAuthtype(req);
          var payloadMember = AWS3.util.getRequestPayloadShape(req);
          if (req.httpRequest.headers["Content-Length"] === void 0) {
            try {
              var length = AWS3.util.string.byteLength(req.httpRequest.body);
              req.httpRequest.headers["Content-Length"] = length;
            } catch (err) {
              if (payloadMember && payloadMember.isStreaming) {
                if (payloadMember.requiresLength) {
                  throw err;
                } else if (authtype.indexOf("unsigned-body") >= 0) {
                  req.httpRequest.headers["Transfer-Encoding"] = "chunked";
                  return;
                } else {
                  throw err;
                }
              }
              throw err;
            }
          }
        });
        add("SET_HTTP_HOST", "afterBuild", function SET_HTTP_HOST(req) {
          req.httpRequest.headers["Host"] = req.httpRequest.endpoint.host;
        });
        add("RESTART", "restart", function RESTART() {
          var err = this.response.error;
          if (!err || !err.retryable)
            return;
          this.httpRequest = new AWS3.HttpRequest(this.service.endpoint, this.service.region);
          if (this.response.retryCount < this.service.config.maxRetries) {
            this.response.retryCount++;
          } else {
            this.response.error = null;
          }
        });
        var addToHead = true;
        addAsync("DISCOVER_ENDPOINT", "sign", DISCOVER_ENDPOINT, addToHead);
        addAsync("SIGN", "sign", function SIGN(req, done) {
          var service = req.service;
          var operations = req.service.api.operations || {};
          var operation = operations[req.operation];
          var authtype = operation ? operation.authtype : "";
          if (!service.api.signatureVersion && !authtype && !service.config.signatureVersion)
            return done();
          service.config.getCredentials(function(err, credentials) {
            if (err) {
              req.response.error = err;
              return done();
            }
            try {
              var date = service.getSkewCorrectedDate();
              var SignerClass = service.getSignerClass(req);
              var signer = new SignerClass(req.httpRequest, service.getSigningName(req), {
                signatureCache: service.config.signatureCache,
                operation,
                signatureVersion: service.api.signatureVersion
              });
              signer.setServiceClientId(service._clientId);
              delete req.httpRequest.headers["Authorization"];
              delete req.httpRequest.headers["Date"];
              delete req.httpRequest.headers["X-Amz-Date"];
              signer.addAuthorization(credentials, date);
              req.signedAt = date;
            } catch (e) {
              req.response.error = e;
            }
            done();
          });
        });
        add("VALIDATE_RESPONSE", "validateResponse", function VALIDATE_RESPONSE(resp) {
          if (this.service.successfulResponse(resp, this)) {
            resp.data = {};
            resp.error = null;
          } else {
            resp.data = null;
            resp.error = AWS3.util.error(new Error(), { code: "UnknownError", message: "An unknown error occurred." });
          }
        });
        addAsync("SEND", "send", function SEND(resp, done) {
          resp.httpResponse._abortCallback = done;
          resp.error = null;
          resp.data = null;
          function callback(httpResp) {
            resp.httpResponse.stream = httpResp;
            var stream = resp.request.httpRequest.stream;
            var service = resp.request.service;
            var api = service.api;
            var operationName = resp.request.operation;
            var operation = api.operations[operationName] || {};
            httpResp.on("headers", function onHeaders(statusCode, headers, statusMessage) {
              resp.request.emit("httpHeaders", [statusCode, headers, resp, statusMessage]);
              if (!resp.httpResponse.streaming) {
                if (AWS3.HttpClient.streamsApiVersion === 2) {
                  if (operation.hasEventOutput && service.successfulResponse(resp)) {
                    resp.request.emit("httpDone");
                    done();
                    return;
                  }
                  httpResp.on("readable", function onReadable() {
                    var data = httpResp.read();
                    if (data !== null) {
                      resp.request.emit("httpData", [data, resp]);
                    }
                  });
                } else {
                  httpResp.on("data", function onData(data) {
                    resp.request.emit("httpData", [data, resp]);
                  });
                }
              }
            });
            httpResp.on("end", function onEnd() {
              if (!stream || !stream.didCallback) {
                if (AWS3.HttpClient.streamsApiVersion === 2 && (operation.hasEventOutput && service.successfulResponse(resp))) {
                  return;
                }
                resp.request.emit("httpDone");
                done();
              }
            });
          }
          function progress(httpResp) {
            httpResp.on("sendProgress", function onSendProgress(value) {
              resp.request.emit("httpUploadProgress", [value, resp]);
            });
            httpResp.on("receiveProgress", function onReceiveProgress(value) {
              resp.request.emit("httpDownloadProgress", [value, resp]);
            });
          }
          function error(err) {
            if (err.code !== "RequestAbortedError") {
              var errCode = err.code === "TimeoutError" ? err.code : "NetworkingError";
              err = AWS3.util.error(err, {
                code: errCode,
                region: resp.request.httpRequest.region,
                hostname: resp.request.httpRequest.endpoint.hostname,
                retryable: true
              });
            }
            resp.error = err;
            resp.request.emit("httpError", [resp.error, resp], function() {
              done();
            });
          }
          function executeSend() {
            var http = AWS3.HttpClient.getInstance();
            var httpOptions = resp.request.service.config.httpOptions || {};
            try {
              var stream = http.handleRequest(resp.request.httpRequest, httpOptions, callback, error);
              progress(stream);
            } catch (err) {
              error(err);
            }
          }
          var timeDiff = (resp.request.service.getSkewCorrectedDate() - this.signedAt) / 1e3;
          if (timeDiff >= 60 * 10) {
            this.emit("sign", [this], function(err) {
              if (err)
                done(err);
              else
                executeSend();
            });
          } else {
            executeSend();
          }
        });
        add("HTTP_HEADERS", "httpHeaders", function HTTP_HEADERS(statusCode, headers, resp, statusMessage) {
          resp.httpResponse.statusCode = statusCode;
          resp.httpResponse.statusMessage = statusMessage;
          resp.httpResponse.headers = headers;
          resp.httpResponse.body = AWS3.util.buffer.toBuffer("");
          resp.httpResponse.buffers = [];
          resp.httpResponse.numBytes = 0;
          var dateHeader = headers.date || headers.Date;
          var service = resp.request.service;
          if (dateHeader) {
            var serverTime = Date.parse(dateHeader);
            if (service.config.correctClockSkew && service.isClockSkewed(serverTime)) {
              service.applyClockOffset(serverTime);
            }
          }
        });
        add("HTTP_DATA", "httpData", function HTTP_DATA(chunk, resp) {
          if (chunk) {
            if (AWS3.util.isNode()) {
              resp.httpResponse.numBytes += chunk.length;
              var total = resp.httpResponse.headers["content-length"];
              var progress = { loaded: resp.httpResponse.numBytes, total };
              resp.request.emit("httpDownloadProgress", [progress, resp]);
            }
            resp.httpResponse.buffers.push(AWS3.util.buffer.toBuffer(chunk));
          }
        });
        add("HTTP_DONE", "httpDone", function HTTP_DONE(resp) {
          if (resp.httpResponse.buffers && resp.httpResponse.buffers.length > 0) {
            var body = AWS3.util.buffer.concat(resp.httpResponse.buffers);
            resp.httpResponse.body = body;
          }
          delete resp.httpResponse.numBytes;
          delete resp.httpResponse.buffers;
        });
        add("FINALIZE_ERROR", "retry", function FINALIZE_ERROR(resp) {
          if (resp.httpResponse.statusCode) {
            resp.error.statusCode = resp.httpResponse.statusCode;
            if (resp.error.retryable === void 0) {
              resp.error.retryable = this.service.retryableError(resp.error, this);
            }
          }
        });
        add("INVALIDATE_CREDENTIALS", "retry", function INVALIDATE_CREDENTIALS(resp) {
          if (!resp.error)
            return;
          switch (resp.error.code) {
            case "RequestExpired":
            case "ExpiredTokenException":
            case "ExpiredToken":
              resp.error.retryable = true;
              resp.request.service.config.credentials.expired = true;
          }
        });
        add("EXPIRED_SIGNATURE", "retry", function EXPIRED_SIGNATURE(resp) {
          var err = resp.error;
          if (!err)
            return;
          if (typeof err.code === "string" && typeof err.message === "string") {
            if (err.code.match(/Signature/) && err.message.match(/expired/)) {
              resp.error.retryable = true;
            }
          }
        });
        add("CLOCK_SKEWED", "retry", function CLOCK_SKEWED(resp) {
          if (!resp.error)
            return;
          if (this.service.clockSkewError(resp.error) && this.service.config.correctClockSkew) {
            resp.error.retryable = true;
          }
        });
        add("REDIRECT", "retry", function REDIRECT(resp) {
          if (resp.error && resp.error.statusCode >= 300 && resp.error.statusCode < 400 && resp.httpResponse.headers["location"]) {
            this.httpRequest.endpoint = new AWS3.Endpoint(resp.httpResponse.headers["location"]);
            this.httpRequest.headers["Host"] = this.httpRequest.endpoint.host;
            resp.error.redirect = true;
            resp.error.retryable = true;
          }
        });
        add("RETRY_CHECK", "retry", function RETRY_CHECK(resp) {
          if (resp.error) {
            if (resp.error.redirect && resp.redirectCount < resp.maxRedirects) {
              resp.error.retryDelay = 0;
            } else if (resp.retryCount < resp.maxRetries) {
              resp.error.retryDelay = this.service.retryDelays(resp.retryCount, resp.error) || 0;
            }
          }
        });
        addAsync("RESET_RETRY_STATE", "afterRetry", function RESET_RETRY_STATE(resp, done) {
          var delay, willRetry = false;
          if (resp.error) {
            delay = resp.error.retryDelay || 0;
            if (resp.error.retryable && resp.retryCount < resp.maxRetries) {
              resp.retryCount++;
              willRetry = true;
            } else if (resp.error.redirect && resp.redirectCount < resp.maxRedirects) {
              resp.redirectCount++;
              willRetry = true;
            }
          }
          if (willRetry && delay >= 0) {
            resp.error = null;
            setTimeout(done, delay);
          } else {
            done();
          }
        });
      }),
      CorePost: new SequentialExecutor().addNamedListeners(function(add) {
        add("EXTRACT_REQUEST_ID", "extractData", AWS3.util.extractRequestId);
        add("EXTRACT_REQUEST_ID", "extractError", AWS3.util.extractRequestId);
        add("ENOTFOUND_ERROR", "httpError", function ENOTFOUND_ERROR(err) {
          function isDNSError(err2) {
            return err2.errno === "ENOTFOUND" || typeof err2.errno === "number" && typeof AWS3.util.getSystemErrorName === "function" && ["EAI_NONAME", "EAI_NODATA"].indexOf(AWS3.util.getSystemErrorName(err2.errno) >= 0);
          }
          if (err.code === "NetworkingError" && isDNSError(err)) {
            var message = "Inaccessible host: `" + err.hostname + "' at port `" + err.port + "'. This service may not be available in the `" + err.region + "' region.";
            this.response.error = AWS3.util.error(new Error(message), {
              code: "UnknownEndpoint",
              region: err.region,
              hostname: err.hostname,
              retryable: true,
              originalError: err
            });
          }
        });
      }),
      Logger: new SequentialExecutor().addNamedListeners(function(add) {
        add("LOG_REQUEST", "complete", function LOG_REQUEST(resp) {
          var req = resp.request;
          var logger = req.service.config.logger;
          if (!logger)
            return;
          function filterSensitiveLog(inputShape, shape) {
            if (!shape) {
              return shape;
            }
            if (inputShape.isSensitive) {
              return "***SensitiveInformation***";
            }
            switch (inputShape.type) {
              case "structure":
                var struct = {};
                AWS3.util.each(shape, function(subShapeName, subShape) {
                  if (Object.prototype.hasOwnProperty.call(inputShape.members, subShapeName)) {
                    struct[subShapeName] = filterSensitiveLog(inputShape.members[subShapeName], subShape);
                  } else {
                    struct[subShapeName] = subShape;
                  }
                });
                return struct;
              case "list":
                var list = [];
                AWS3.util.arrayEach(shape, function(subShape, index) {
                  list.push(filterSensitiveLog(inputShape.member, subShape));
                });
                return list;
              case "map":
                var map = {};
                AWS3.util.each(shape, function(key, value) {
                  map[key] = filterSensitiveLog(inputShape.value, value);
                });
                return map;
              default:
                return shape;
            }
          }
          function buildMessage() {
            var time = resp.request.service.getSkewCorrectedDate().getTime();
            var delta = (time - req.startTime.getTime()) / 1e3;
            var ansi = logger.isTTY ? true : false;
            var status = resp.httpResponse.statusCode;
            var censoredParams = req.params;
            if (req.service.api.operations && req.service.api.operations[req.operation] && req.service.api.operations[req.operation].input) {
              var inputShape = req.service.api.operations[req.operation].input;
              censoredParams = filterSensitiveLog(inputShape, req.params);
            }
            var params = require("util").inspect(censoredParams, true, null);
            var message = "";
            if (ansi)
              message += "[33m";
            message += "[AWS " + req.service.serviceIdentifier + " " + status;
            message += " " + delta.toString() + "s " + resp.retryCount + " retries]";
            if (ansi)
              message += "[0;1m";
            message += " " + AWS3.util.string.lowerFirst(req.operation);
            message += "(" + params + ")";
            if (ansi)
              message += "[0m";
            return message;
          }
          var line = buildMessage();
          if (typeof logger.log === "function") {
            logger.log(line);
          } else if (typeof logger.write === "function") {
            logger.write(line + "\n");
          }
        });
      }),
      Json: new SequentialExecutor().addNamedListeners(function(add) {
        var svc = require_json3();
        add("BUILD", "build", svc.buildRequest);
        add("EXTRACT_DATA", "extractData", svc.extractData);
        add("EXTRACT_ERROR", "extractError", svc.extractError);
      }),
      Rest: new SequentialExecutor().addNamedListeners(function(add) {
        var svc = require_rest();
        add("BUILD", "build", svc.buildRequest);
        add("EXTRACT_DATA", "extractData", svc.extractData);
        add("EXTRACT_ERROR", "extractError", svc.extractError);
      }),
      RestJson: new SequentialExecutor().addNamedListeners(function(add) {
        var svc = require_rest_json();
        add("BUILD", "build", svc.buildRequest);
        add("EXTRACT_DATA", "extractData", svc.extractData);
        add("EXTRACT_ERROR", "extractError", svc.extractError);
      }),
      RestXml: new SequentialExecutor().addNamedListeners(function(add) {
        var svc = require_rest_xml();
        add("BUILD", "build", svc.buildRequest);
        add("EXTRACT_DATA", "extractData", svc.extractData);
        add("EXTRACT_ERROR", "extractError", svc.extractError);
      }),
      Query: new SequentialExecutor().addNamedListeners(function(add) {
        var svc = require_query();
        add("BUILD", "build", svc.buildRequest);
        add("EXTRACT_DATA", "extractData", svc.extractData);
        add("EXTRACT_ERROR", "extractError", svc.extractError);
      })
    };
  }
});

// node_modules/aws-sdk/lib/state_machine.js
var require_state_machine = __commonJS({
  "node_modules/aws-sdk/lib/state_machine.js"(exports, module2) {
    function AcceptorStateMachine(states, state) {
      this.currentState = state || null;
      this.states = states || {};
    }
    AcceptorStateMachine.prototype.runTo = function runTo(finalState, done, bindObject, inputError) {
      if (typeof finalState === "function") {
        inputError = bindObject;
        bindObject = done;
        done = finalState;
        finalState = null;
      }
      var self2 = this;
      var state = self2.states[self2.currentState];
      state.fn.call(bindObject || self2, inputError, function(err) {
        if (err) {
          if (state.fail)
            self2.currentState = state.fail;
          else
            return done ? done.call(bindObject, err) : null;
        } else {
          if (state.accept)
            self2.currentState = state.accept;
          else
            return done ? done.call(bindObject) : null;
        }
        if (self2.currentState === finalState) {
          return done ? done.call(bindObject, err) : null;
        }
        self2.runTo(finalState, done, bindObject, err);
      });
    };
    AcceptorStateMachine.prototype.addState = function addState(name, acceptState, failState, fn) {
      if (typeof acceptState === "function") {
        fn = acceptState;
        acceptState = null;
        failState = null;
      } else if (typeof failState === "function") {
        fn = failState;
        failState = null;
      }
      if (!this.currentState)
        this.currentState = name;
      this.states[name] = { accept: acceptState, fail: failState, fn };
      return this;
    };
    module2.exports = AcceptorStateMachine;
  }
});

// node_modules/jmespath/jmespath.js
var require_jmespath = __commonJS({
  "node_modules/jmespath/jmespath.js"(exports) {
    (function(exports2) {
      "use strict";
      function isArray(obj) {
        if (obj !== null) {
          return Object.prototype.toString.call(obj) === "[object Array]";
        } else {
          return false;
        }
      }
      function isObject(obj) {
        if (obj !== null) {
          return Object.prototype.toString.call(obj) === "[object Object]";
        } else {
          return false;
        }
      }
      function strictDeepEqual(first, second) {
        if (first === second) {
          return true;
        }
        var firstType = Object.prototype.toString.call(first);
        if (firstType !== Object.prototype.toString.call(second)) {
          return false;
        }
        if (isArray(first) === true) {
          if (first.length !== second.length) {
            return false;
          }
          for (var i = 0; i < first.length; i++) {
            if (strictDeepEqual(first[i], second[i]) === false) {
              return false;
            }
          }
          return true;
        }
        if (isObject(first) === true) {
          var keysSeen = {};
          for (var key in first) {
            if (hasOwnProperty.call(first, key)) {
              if (strictDeepEqual(first[key], second[key]) === false) {
                return false;
              }
              keysSeen[key] = true;
            }
          }
          for (var key2 in second) {
            if (hasOwnProperty.call(second, key2)) {
              if (keysSeen[key2] !== true) {
                return false;
              }
            }
          }
          return true;
        }
        return false;
      }
      function isFalse(obj) {
        if (obj === "" || obj === false || obj === null) {
          return true;
        } else if (isArray(obj) && obj.length === 0) {
          return true;
        } else if (isObject(obj)) {
          for (var key in obj) {
            if (obj.hasOwnProperty(key)) {
              return false;
            }
          }
          return true;
        } else {
          return false;
        }
      }
      function objValues(obj) {
        var keys = Object.keys(obj);
        var values = [];
        for (var i = 0; i < keys.length; i++) {
          values.push(obj[keys[i]]);
        }
        return values;
      }
      function merge(a, b) {
        var merged = {};
        for (var key in a) {
          merged[key] = a[key];
        }
        for (var key2 in b) {
          merged[key2] = b[key2];
        }
        return merged;
      }
      var trimLeft;
      if (typeof String.prototype.trimLeft === "function") {
        trimLeft = function(str) {
          return str.trimLeft();
        };
      } else {
        trimLeft = function(str) {
          return str.match(/^\s*(.*)/)[1];
        };
      }
      var TYPE_NUMBER = 0;
      var TYPE_ANY = 1;
      var TYPE_STRING = 2;
      var TYPE_ARRAY = 3;
      var TYPE_OBJECT = 4;
      var TYPE_BOOLEAN = 5;
      var TYPE_EXPREF = 6;
      var TYPE_NULL = 7;
      var TYPE_ARRAY_NUMBER = 8;
      var TYPE_ARRAY_STRING = 9;
      var TOK_EOF = "EOF";
      var TOK_UNQUOTEDIDENTIFIER = "UnquotedIdentifier";
      var TOK_QUOTEDIDENTIFIER = "QuotedIdentifier";
      var TOK_RBRACKET = "Rbracket";
      var TOK_RPAREN = "Rparen";
      var TOK_COMMA = "Comma";
      var TOK_COLON = "Colon";
      var TOK_RBRACE = "Rbrace";
      var TOK_NUMBER = "Number";
      var TOK_CURRENT = "Current";
      var TOK_EXPREF = "Expref";
      var TOK_PIPE = "Pipe";
      var TOK_OR = "Or";
      var TOK_AND = "And";
      var TOK_EQ = "EQ";
      var TOK_GT = "GT";
      var TOK_LT = "LT";
      var TOK_GTE = "GTE";
      var TOK_LTE = "LTE";
      var TOK_NE = "NE";
      var TOK_FLATTEN = "Flatten";
      var TOK_STAR = "Star";
      var TOK_FILTER = "Filter";
      var TOK_DOT = "Dot";
      var TOK_NOT = "Not";
      var TOK_LBRACE = "Lbrace";
      var TOK_LBRACKET = "Lbracket";
      var TOK_LPAREN = "Lparen";
      var TOK_LITERAL = "Literal";
      var basicTokens = {
        ".": TOK_DOT,
        "*": TOK_STAR,
        ",": TOK_COMMA,
        ":": TOK_COLON,
        "{": TOK_LBRACE,
        "}": TOK_RBRACE,
        "]": TOK_RBRACKET,
        "(": TOK_LPAREN,
        ")": TOK_RPAREN,
        "@": TOK_CURRENT
      };
      var operatorStartToken = {
        "<": true,
        ">": true,
        "=": true,
        "!": true
      };
      var skipChars = {
        " ": true,
        "	": true,
        "\n": true
      };
      function isAlpha(ch) {
        return ch >= "a" && ch <= "z" || ch >= "A" && ch <= "Z" || ch === "_";
      }
      function isNum(ch) {
        return ch >= "0" && ch <= "9" || ch === "-";
      }
      function isAlphaNum(ch) {
        return ch >= "a" && ch <= "z" || ch >= "A" && ch <= "Z" || ch >= "0" && ch <= "9" || ch === "_";
      }
      function Lexer() {
      }
      Lexer.prototype = {
        tokenize: function(stream) {
          var tokens = [];
          this._current = 0;
          var start;
          var identifier;
          var token;
          while (this._current < stream.length) {
            if (isAlpha(stream[this._current])) {
              start = this._current;
              identifier = this._consumeUnquotedIdentifier(stream);
              tokens.push({
                type: TOK_UNQUOTEDIDENTIFIER,
                value: identifier,
                start
              });
            } else if (basicTokens[stream[this._current]] !== void 0) {
              tokens.push({
                type: basicTokens[stream[this._current]],
                value: stream[this._current],
                start: this._current
              });
              this._current++;
            } else if (isNum(stream[this._current])) {
              token = this._consumeNumber(stream);
              tokens.push(token);
            } else if (stream[this._current] === "[") {
              token = this._consumeLBracket(stream);
              tokens.push(token);
            } else if (stream[this._current] === '"') {
              start = this._current;
              identifier = this._consumeQuotedIdentifier(stream);
              tokens.push({
                type: TOK_QUOTEDIDENTIFIER,
                value: identifier,
                start
              });
            } else if (stream[this._current] === "'") {
              start = this._current;
              identifier = this._consumeRawStringLiteral(stream);
              tokens.push({
                type: TOK_LITERAL,
                value: identifier,
                start
              });
            } else if (stream[this._current] === "`") {
              start = this._current;
              var literal = this._consumeLiteral(stream);
              tokens.push({
                type: TOK_LITERAL,
                value: literal,
                start
              });
            } else if (operatorStartToken[stream[this._current]] !== void 0) {
              tokens.push(this._consumeOperator(stream));
            } else if (skipChars[stream[this._current]] !== void 0) {
              this._current++;
            } else if (stream[this._current] === "&") {
              start = this._current;
              this._current++;
              if (stream[this._current] === "&") {
                this._current++;
                tokens.push({ type: TOK_AND, value: "&&", start });
              } else {
                tokens.push({ type: TOK_EXPREF, value: "&", start });
              }
            } else if (stream[this._current] === "|") {
              start = this._current;
              this._current++;
              if (stream[this._current] === "|") {
                this._current++;
                tokens.push({ type: TOK_OR, value: "||", start });
              } else {
                tokens.push({ type: TOK_PIPE, value: "|", start });
              }
            } else {
              var error = new Error("Unknown character:" + stream[this._current]);
              error.name = "LexerError";
              throw error;
            }
          }
          return tokens;
        },
        _consumeUnquotedIdentifier: function(stream) {
          var start = this._current;
          this._current++;
          while (this._current < stream.length && isAlphaNum(stream[this._current])) {
            this._current++;
          }
          return stream.slice(start, this._current);
        },
        _consumeQuotedIdentifier: function(stream) {
          var start = this._current;
          this._current++;
          var maxLength = stream.length;
          while (stream[this._current] !== '"' && this._current < maxLength) {
            var current = this._current;
            if (stream[current] === "\\" && (stream[current + 1] === "\\" || stream[current + 1] === '"')) {
              current += 2;
            } else {
              current++;
            }
            this._current = current;
          }
          this._current++;
          return JSON.parse(stream.slice(start, this._current));
        },
        _consumeRawStringLiteral: function(stream) {
          var start = this._current;
          this._current++;
          var maxLength = stream.length;
          while (stream[this._current] !== "'" && this._current < maxLength) {
            var current = this._current;
            if (stream[current] === "\\" && (stream[current + 1] === "\\" || stream[current + 1] === "'")) {
              current += 2;
            } else {
              current++;
            }
            this._current = current;
          }
          this._current++;
          var literal = stream.slice(start + 1, this._current - 1);
          return literal.replace("\\'", "'");
        },
        _consumeNumber: function(stream) {
          var start = this._current;
          this._current++;
          var maxLength = stream.length;
          while (isNum(stream[this._current]) && this._current < maxLength) {
            this._current++;
          }
          var value = parseInt(stream.slice(start, this._current));
          return { type: TOK_NUMBER, value, start };
        },
        _consumeLBracket: function(stream) {
          var start = this._current;
          this._current++;
          if (stream[this._current] === "?") {
            this._current++;
            return { type: TOK_FILTER, value: "[?", start };
          } else if (stream[this._current] === "]") {
            this._current++;
            return { type: TOK_FLATTEN, value: "[]", start };
          } else {
            return { type: TOK_LBRACKET, value: "[", start };
          }
        },
        _consumeOperator: function(stream) {
          var start = this._current;
          var startingChar = stream[start];
          this._current++;
          if (startingChar === "!") {
            if (stream[this._current] === "=") {
              this._current++;
              return { type: TOK_NE, value: "!=", start };
            } else {
              return { type: TOK_NOT, value: "!", start };
            }
          } else if (startingChar === "<") {
            if (stream[this._current] === "=") {
              this._current++;
              return { type: TOK_LTE, value: "<=", start };
            } else {
              return { type: TOK_LT, value: "<", start };
            }
          } else if (startingChar === ">") {
            if (stream[this._current] === "=") {
              this._current++;
              return { type: TOK_GTE, value: ">=", start };
            } else {
              return { type: TOK_GT, value: ">", start };
            }
          } else if (startingChar === "=") {
            if (stream[this._current] === "=") {
              this._current++;
              return { type: TOK_EQ, value: "==", start };
            }
          }
        },
        _consumeLiteral: function(stream) {
          this._current++;
          var start = this._current;
          var maxLength = stream.length;
          var literal;
          while (stream[this._current] !== "`" && this._current < maxLength) {
            var current = this._current;
            if (stream[current] === "\\" && (stream[current + 1] === "\\" || stream[current + 1] === "`")) {
              current += 2;
            } else {
              current++;
            }
            this._current = current;
          }
          var literalString = trimLeft(stream.slice(start, this._current));
          literalString = literalString.replace("\\`", "`");
          if (this._looksLikeJSON(literalString)) {
            literal = JSON.parse(literalString);
          } else {
            literal = JSON.parse('"' + literalString + '"');
          }
          this._current++;
          return literal;
        },
        _looksLikeJSON: function(literalString) {
          var startingChars = '[{"';
          var jsonLiterals = ["true", "false", "null"];
          var numberLooking = "-0123456789";
          if (literalString === "") {
            return false;
          } else if (startingChars.indexOf(literalString[0]) >= 0) {
            return true;
          } else if (jsonLiterals.indexOf(literalString) >= 0) {
            return true;
          } else if (numberLooking.indexOf(literalString[0]) >= 0) {
            try {
              JSON.parse(literalString);
              return true;
            } catch (ex) {
              return false;
            }
          } else {
            return false;
          }
        }
      };
      var bindingPower = {};
      bindingPower[TOK_EOF] = 0;
      bindingPower[TOK_UNQUOTEDIDENTIFIER] = 0;
      bindingPower[TOK_QUOTEDIDENTIFIER] = 0;
      bindingPower[TOK_RBRACKET] = 0;
      bindingPower[TOK_RPAREN] = 0;
      bindingPower[TOK_COMMA] = 0;
      bindingPower[TOK_RBRACE] = 0;
      bindingPower[TOK_NUMBER] = 0;
      bindingPower[TOK_CURRENT] = 0;
      bindingPower[TOK_EXPREF] = 0;
      bindingPower[TOK_PIPE] = 1;
      bindingPower[TOK_OR] = 2;
      bindingPower[TOK_AND] = 3;
      bindingPower[TOK_EQ] = 5;
      bindingPower[TOK_GT] = 5;
      bindingPower[TOK_LT] = 5;
      bindingPower[TOK_GTE] = 5;
      bindingPower[TOK_LTE] = 5;
      bindingPower[TOK_NE] = 5;
      bindingPower[TOK_FLATTEN] = 9;
      bindingPower[TOK_STAR] = 20;
      bindingPower[TOK_FILTER] = 21;
      bindingPower[TOK_DOT] = 40;
      bindingPower[TOK_NOT] = 45;
      bindingPower[TOK_LBRACE] = 50;
      bindingPower[TOK_LBRACKET] = 55;
      bindingPower[TOK_LPAREN] = 60;
      function Parser() {
      }
      Parser.prototype = {
        parse: function(expression) {
          this._loadTokens(expression);
          this.index = 0;
          var ast = this.expression(0);
          if (this._lookahead(0) !== TOK_EOF) {
            var t = this._lookaheadToken(0);
            var error = new Error("Unexpected token type: " + t.type + ", value: " + t.value);
            error.name = "ParserError";
            throw error;
          }
          return ast;
        },
        _loadTokens: function(expression) {
          var lexer = new Lexer();
          var tokens = lexer.tokenize(expression);
          tokens.push({ type: TOK_EOF, value: "", start: expression.length });
          this.tokens = tokens;
        },
        expression: function(rbp) {
          var leftToken = this._lookaheadToken(0);
          this._advance();
          var left = this.nud(leftToken);
          var currentToken = this._lookahead(0);
          while (rbp < bindingPower[currentToken]) {
            this._advance();
            left = this.led(currentToken, left);
            currentToken = this._lookahead(0);
          }
          return left;
        },
        _lookahead: function(number) {
          return this.tokens[this.index + number].type;
        },
        _lookaheadToken: function(number) {
          return this.tokens[this.index + number];
        },
        _advance: function() {
          this.index++;
        },
        nud: function(token) {
          var left;
          var right;
          var expression;
          switch (token.type) {
            case TOK_LITERAL:
              return { type: "Literal", value: token.value };
            case TOK_UNQUOTEDIDENTIFIER:
              return { type: "Field", name: token.value };
            case TOK_QUOTEDIDENTIFIER:
              var node = { type: "Field", name: token.value };
              if (this._lookahead(0) === TOK_LPAREN) {
                throw new Error("Quoted identifier not allowed for function names.");
              } else {
                return node;
              }
              break;
            case TOK_NOT:
              right = this.expression(bindingPower.Not);
              return { type: "NotExpression", children: [right] };
            case TOK_STAR:
              left = { type: "Identity" };
              right = null;
              if (this._lookahead(0) === TOK_RBRACKET) {
                right = { type: "Identity" };
              } else {
                right = this._parseProjectionRHS(bindingPower.Star);
              }
              return { type: "ValueProjection", children: [left, right] };
            case TOK_FILTER:
              return this.led(token.type, { type: "Identity" });
            case TOK_LBRACE:
              return this._parseMultiselectHash();
            case TOK_FLATTEN:
              left = { type: TOK_FLATTEN, children: [{ type: "Identity" }] };
              right = this._parseProjectionRHS(bindingPower.Flatten);
              return { type: "Projection", children: [left, right] };
            case TOK_LBRACKET:
              if (this._lookahead(0) === TOK_NUMBER || this._lookahead(0) === TOK_COLON) {
                right = this._parseIndexExpression();
                return this._projectIfSlice({ type: "Identity" }, right);
              } else if (this._lookahead(0) === TOK_STAR && this._lookahead(1) === TOK_RBRACKET) {
                this._advance();
                this._advance();
                right = this._parseProjectionRHS(bindingPower.Star);
                return {
                  type: "Projection",
                  children: [{ type: "Identity" }, right]
                };
              } else {
                return this._parseMultiselectList();
              }
              break;
            case TOK_CURRENT:
              return { type: TOK_CURRENT };
            case TOK_EXPREF:
              expression = this.expression(bindingPower.Expref);
              return { type: "ExpressionReference", children: [expression] };
            case TOK_LPAREN:
              var args = [];
              while (this._lookahead(0) !== TOK_RPAREN) {
                if (this._lookahead(0) === TOK_CURRENT) {
                  expression = { type: TOK_CURRENT };
                  this._advance();
                } else {
                  expression = this.expression(0);
                }
                args.push(expression);
              }
              this._match(TOK_RPAREN);
              return args[0];
            default:
              this._errorToken(token);
          }
        },
        led: function(tokenName, left) {
          var right;
          switch (tokenName) {
            case TOK_DOT:
              var rbp = bindingPower.Dot;
              if (this._lookahead(0) !== TOK_STAR) {
                right = this._parseDotRHS(rbp);
                return { type: "Subexpression", children: [left, right] };
              } else {
                this._advance();
                right = this._parseProjectionRHS(rbp);
                return { type: "ValueProjection", children: [left, right] };
              }
              break;
            case TOK_PIPE:
              right = this.expression(bindingPower.Pipe);
              return { type: TOK_PIPE, children: [left, right] };
            case TOK_OR:
              right = this.expression(bindingPower.Or);
              return { type: "OrExpression", children: [left, right] };
            case TOK_AND:
              right = this.expression(bindingPower.And);
              return { type: "AndExpression", children: [left, right] };
            case TOK_LPAREN:
              var name = left.name;
              var args = [];
              var expression, node;
              while (this._lookahead(0) !== TOK_RPAREN) {
                if (this._lookahead(0) === TOK_CURRENT) {
                  expression = { type: TOK_CURRENT };
                  this._advance();
                } else {
                  expression = this.expression(0);
                }
                if (this._lookahead(0) === TOK_COMMA) {
                  this._match(TOK_COMMA);
                }
                args.push(expression);
              }
              this._match(TOK_RPAREN);
              node = { type: "Function", name, children: args };
              return node;
            case TOK_FILTER:
              var condition = this.expression(0);
              this._match(TOK_RBRACKET);
              if (this._lookahead(0) === TOK_FLATTEN) {
                right = { type: "Identity" };
              } else {
                right = this._parseProjectionRHS(bindingPower.Filter);
              }
              return { type: "FilterProjection", children: [left, right, condition] };
            case TOK_FLATTEN:
              var leftNode = { type: TOK_FLATTEN, children: [left] };
              var rightNode = this._parseProjectionRHS(bindingPower.Flatten);
              return { type: "Projection", children: [leftNode, rightNode] };
            case TOK_EQ:
            case TOK_NE:
            case TOK_GT:
            case TOK_GTE:
            case TOK_LT:
            case TOK_LTE:
              return this._parseComparator(left, tokenName);
            case TOK_LBRACKET:
              var token = this._lookaheadToken(0);
              if (token.type === TOK_NUMBER || token.type === TOK_COLON) {
                right = this._parseIndexExpression();
                return this._projectIfSlice(left, right);
              } else {
                this._match(TOK_STAR);
                this._match(TOK_RBRACKET);
                right = this._parseProjectionRHS(bindingPower.Star);
                return { type: "Projection", children: [left, right] };
              }
              break;
            default:
              this._errorToken(this._lookaheadToken(0));
          }
        },
        _match: function(tokenType) {
          if (this._lookahead(0) === tokenType) {
            this._advance();
          } else {
            var t = this._lookaheadToken(0);
            var error = new Error("Expected " + tokenType + ", got: " + t.type);
            error.name = "ParserError";
            throw error;
          }
        },
        _errorToken: function(token) {
          var error = new Error("Invalid token (" + token.type + '): "' + token.value + '"');
          error.name = "ParserError";
          throw error;
        },
        _parseIndexExpression: function() {
          if (this._lookahead(0) === TOK_COLON || this._lookahead(1) === TOK_COLON) {
            return this._parseSliceExpression();
          } else {
            var node = {
              type: "Index",
              value: this._lookaheadToken(0).value
            };
            this._advance();
            this._match(TOK_RBRACKET);
            return node;
          }
        },
        _projectIfSlice: function(left, right) {
          var indexExpr = { type: "IndexExpression", children: [left, right] };
          if (right.type === "Slice") {
            return {
              type: "Projection",
              children: [indexExpr, this._parseProjectionRHS(bindingPower.Star)]
            };
          } else {
            return indexExpr;
          }
        },
        _parseSliceExpression: function() {
          var parts = [null, null, null];
          var index = 0;
          var currentToken = this._lookahead(0);
          while (currentToken !== TOK_RBRACKET && index < 3) {
            if (currentToken === TOK_COLON) {
              index++;
              this._advance();
            } else if (currentToken === TOK_NUMBER) {
              parts[index] = this._lookaheadToken(0).value;
              this._advance();
            } else {
              var t = this._lookahead(0);
              var error = new Error("Syntax error, unexpected token: " + t.value + "(" + t.type + ")");
              error.name = "Parsererror";
              throw error;
            }
            currentToken = this._lookahead(0);
          }
          this._match(TOK_RBRACKET);
          return {
            type: "Slice",
            children: parts
          };
        },
        _parseComparator: function(left, comparator) {
          var right = this.expression(bindingPower[comparator]);
          return { type: "Comparator", name: comparator, children: [left, right] };
        },
        _parseDotRHS: function(rbp) {
          var lookahead = this._lookahead(0);
          var exprTokens = [TOK_UNQUOTEDIDENTIFIER, TOK_QUOTEDIDENTIFIER, TOK_STAR];
          if (exprTokens.indexOf(lookahead) >= 0) {
            return this.expression(rbp);
          } else if (lookahead === TOK_LBRACKET) {
            this._match(TOK_LBRACKET);
            return this._parseMultiselectList();
          } else if (lookahead === TOK_LBRACE) {
            this._match(TOK_LBRACE);
            return this._parseMultiselectHash();
          }
        },
        _parseProjectionRHS: function(rbp) {
          var right;
          if (bindingPower[this._lookahead(0)] < 10) {
            right = { type: "Identity" };
          } else if (this._lookahead(0) === TOK_LBRACKET) {
            right = this.expression(rbp);
          } else if (this._lookahead(0) === TOK_FILTER) {
            right = this.expression(rbp);
          } else if (this._lookahead(0) === TOK_DOT) {
            this._match(TOK_DOT);
            right = this._parseDotRHS(rbp);
          } else {
            var t = this._lookaheadToken(0);
            var error = new Error("Sytanx error, unexpected token: " + t.value + "(" + t.type + ")");
            error.name = "ParserError";
            throw error;
          }
          return right;
        },
        _parseMultiselectList: function() {
          var expressions = [];
          while (this._lookahead(0) !== TOK_RBRACKET) {
            var expression = this.expression(0);
            expressions.push(expression);
            if (this._lookahead(0) === TOK_COMMA) {
              this._match(TOK_COMMA);
              if (this._lookahead(0) === TOK_RBRACKET) {
                throw new Error("Unexpected token Rbracket");
              }
            }
          }
          this._match(TOK_RBRACKET);
          return { type: "MultiSelectList", children: expressions };
        },
        _parseMultiselectHash: function() {
          var pairs = [];
          var identifierTypes = [TOK_UNQUOTEDIDENTIFIER, TOK_QUOTEDIDENTIFIER];
          var keyToken, keyName, value, node;
          for (; ; ) {
            keyToken = this._lookaheadToken(0);
            if (identifierTypes.indexOf(keyToken.type) < 0) {
              throw new Error("Expecting an identifier token, got: " + keyToken.type);
            }
            keyName = keyToken.value;
            this._advance();
            this._match(TOK_COLON);
            value = this.expression(0);
            node = { type: "KeyValuePair", name: keyName, value };
            pairs.push(node);
            if (this._lookahead(0) === TOK_COMMA) {
              this._match(TOK_COMMA);
            } else if (this._lookahead(0) === TOK_RBRACE) {
              this._match(TOK_RBRACE);
              break;
            }
          }
          return { type: "MultiSelectHash", children: pairs };
        }
      };
      function TreeInterpreter(runtime) {
        this.runtime = runtime;
      }
      TreeInterpreter.prototype = {
        search: function(node, value) {
          return this.visit(node, value);
        },
        visit: function(node, value) {
          var matched, current, result, first, second, field, left, right, collected, i;
          switch (node.type) {
            case "Field":
              if (value === null) {
                return null;
              } else if (isObject(value)) {
                field = value[node.name];
                if (field === void 0) {
                  return null;
                } else {
                  return field;
                }
              } else {
                return null;
              }
              break;
            case "Subexpression":
              result = this.visit(node.children[0], value);
              for (i = 1; i < node.children.length; i++) {
                result = this.visit(node.children[1], result);
                if (result === null) {
                  return null;
                }
              }
              return result;
            case "IndexExpression":
              left = this.visit(node.children[0], value);
              right = this.visit(node.children[1], left);
              return right;
            case "Index":
              if (!isArray(value)) {
                return null;
              }
              var index = node.value;
              if (index < 0) {
                index = value.length + index;
              }
              result = value[index];
              if (result === void 0) {
                result = null;
              }
              return result;
            case "Slice":
              if (!isArray(value)) {
                return null;
              }
              var sliceParams = node.children.slice(0);
              var computed = this.computeSliceParams(value.length, sliceParams);
              var start = computed[0];
              var stop = computed[1];
              var step = computed[2];
              result = [];
              if (step > 0) {
                for (i = start; i < stop; i += step) {
                  result.push(value[i]);
                }
              } else {
                for (i = start; i > stop; i += step) {
                  result.push(value[i]);
                }
              }
              return result;
            case "Projection":
              var base = this.visit(node.children[0], value);
              if (!isArray(base)) {
                return null;
              }
              collected = [];
              for (i = 0; i < base.length; i++) {
                current = this.visit(node.children[1], base[i]);
                if (current !== null) {
                  collected.push(current);
                }
              }
              return collected;
            case "ValueProjection":
              base = this.visit(node.children[0], value);
              if (!isObject(base)) {
                return null;
              }
              collected = [];
              var values = objValues(base);
              for (i = 0; i < values.length; i++) {
                current = this.visit(node.children[1], values[i]);
                if (current !== null) {
                  collected.push(current);
                }
              }
              return collected;
            case "FilterProjection":
              base = this.visit(node.children[0], value);
              if (!isArray(base)) {
                return null;
              }
              var filtered = [];
              var finalResults = [];
              for (i = 0; i < base.length; i++) {
                matched = this.visit(node.children[2], base[i]);
                if (!isFalse(matched)) {
                  filtered.push(base[i]);
                }
              }
              for (var j = 0; j < filtered.length; j++) {
                current = this.visit(node.children[1], filtered[j]);
                if (current !== null) {
                  finalResults.push(current);
                }
              }
              return finalResults;
            case "Comparator":
              first = this.visit(node.children[0], value);
              second = this.visit(node.children[1], value);
              switch (node.name) {
                case TOK_EQ:
                  result = strictDeepEqual(first, second);
                  break;
                case TOK_NE:
                  result = !strictDeepEqual(first, second);
                  break;
                case TOK_GT:
                  result = first > second;
                  break;
                case TOK_GTE:
                  result = first >= second;
                  break;
                case TOK_LT:
                  result = first < second;
                  break;
                case TOK_LTE:
                  result = first <= second;
                  break;
                default:
                  throw new Error("Unknown comparator: " + node.name);
              }
              return result;
            case TOK_FLATTEN:
              var original = this.visit(node.children[0], value);
              if (!isArray(original)) {
                return null;
              }
              var merged = [];
              for (i = 0; i < original.length; i++) {
                current = original[i];
                if (isArray(current)) {
                  merged.push.apply(merged, current);
                } else {
                  merged.push(current);
                }
              }
              return merged;
            case "Identity":
              return value;
            case "MultiSelectList":
              if (value === null) {
                return null;
              }
              collected = [];
              for (i = 0; i < node.children.length; i++) {
                collected.push(this.visit(node.children[i], value));
              }
              return collected;
            case "MultiSelectHash":
              if (value === null) {
                return null;
              }
              collected = {};
              var child;
              for (i = 0; i < node.children.length; i++) {
                child = node.children[i];
                collected[child.name] = this.visit(child.value, value);
              }
              return collected;
            case "OrExpression":
              matched = this.visit(node.children[0], value);
              if (isFalse(matched)) {
                matched = this.visit(node.children[1], value);
              }
              return matched;
            case "AndExpression":
              first = this.visit(node.children[0], value);
              if (isFalse(first) === true) {
                return first;
              }
              return this.visit(node.children[1], value);
            case "NotExpression":
              first = this.visit(node.children[0], value);
              return isFalse(first);
            case "Literal":
              return node.value;
            case TOK_PIPE:
              left = this.visit(node.children[0], value);
              return this.visit(node.children[1], left);
            case TOK_CURRENT:
              return value;
            case "Function":
              var resolvedArgs = [];
              for (i = 0; i < node.children.length; i++) {
                resolvedArgs.push(this.visit(node.children[i], value));
              }
              return this.runtime.callFunction(node.name, resolvedArgs);
            case "ExpressionReference":
              var refNode = node.children[0];
              refNode.jmespathType = TOK_EXPREF;
              return refNode;
            default:
              throw new Error("Unknown node type: " + node.type);
          }
        },
        computeSliceParams: function(arrayLength, sliceParams) {
          var start = sliceParams[0];
          var stop = sliceParams[1];
          var step = sliceParams[2];
          var computed = [null, null, null];
          if (step === null) {
            step = 1;
          } else if (step === 0) {
            var error = new Error("Invalid slice, step cannot be 0");
            error.name = "RuntimeError";
            throw error;
          }
          var stepValueNegative = step < 0 ? true : false;
          if (start === null) {
            start = stepValueNegative ? arrayLength - 1 : 0;
          } else {
            start = this.capSliceRange(arrayLength, start, step);
          }
          if (stop === null) {
            stop = stepValueNegative ? -1 : arrayLength;
          } else {
            stop = this.capSliceRange(arrayLength, stop, step);
          }
          computed[0] = start;
          computed[1] = stop;
          computed[2] = step;
          return computed;
        },
        capSliceRange: function(arrayLength, actualValue, step) {
          if (actualValue < 0) {
            actualValue += arrayLength;
            if (actualValue < 0) {
              actualValue = step < 0 ? -1 : 0;
            }
          } else if (actualValue >= arrayLength) {
            actualValue = step < 0 ? arrayLength - 1 : arrayLength;
          }
          return actualValue;
        }
      };
      function Runtime(interpreter) {
        this._interpreter = interpreter;
        this.functionTable = {
          abs: { _func: this._functionAbs, _signature: [{ types: [TYPE_NUMBER] }] },
          avg: { _func: this._functionAvg, _signature: [{ types: [TYPE_ARRAY_NUMBER] }] },
          ceil: { _func: this._functionCeil, _signature: [{ types: [TYPE_NUMBER] }] },
          contains: {
            _func: this._functionContains,
            _signature: [
              { types: [TYPE_STRING, TYPE_ARRAY] },
              { types: [TYPE_ANY] }
            ]
          },
          "ends_with": {
            _func: this._functionEndsWith,
            _signature: [{ types: [TYPE_STRING] }, { types: [TYPE_STRING] }]
          },
          floor: { _func: this._functionFloor, _signature: [{ types: [TYPE_NUMBER] }] },
          length: {
            _func: this._functionLength,
            _signature: [{ types: [TYPE_STRING, TYPE_ARRAY, TYPE_OBJECT] }]
          },
          map: {
            _func: this._functionMap,
            _signature: [{ types: [TYPE_EXPREF] }, { types: [TYPE_ARRAY] }]
          },
          max: {
            _func: this._functionMax,
            _signature: [{ types: [TYPE_ARRAY_NUMBER, TYPE_ARRAY_STRING] }]
          },
          "merge": {
            _func: this._functionMerge,
            _signature: [{ types: [TYPE_OBJECT], variadic: true }]
          },
          "max_by": {
            _func: this._functionMaxBy,
            _signature: [{ types: [TYPE_ARRAY] }, { types: [TYPE_EXPREF] }]
          },
          sum: { _func: this._functionSum, _signature: [{ types: [TYPE_ARRAY_NUMBER] }] },
          "starts_with": {
            _func: this._functionStartsWith,
            _signature: [{ types: [TYPE_STRING] }, { types: [TYPE_STRING] }]
          },
          min: {
            _func: this._functionMin,
            _signature: [{ types: [TYPE_ARRAY_NUMBER, TYPE_ARRAY_STRING] }]
          },
          "min_by": {
            _func: this._functionMinBy,
            _signature: [{ types: [TYPE_ARRAY] }, { types: [TYPE_EXPREF] }]
          },
          type: { _func: this._functionType, _signature: [{ types: [TYPE_ANY] }] },
          keys: { _func: this._functionKeys, _signature: [{ types: [TYPE_OBJECT] }] },
          values: { _func: this._functionValues, _signature: [{ types: [TYPE_OBJECT] }] },
          sort: { _func: this._functionSort, _signature: [{ types: [TYPE_ARRAY_STRING, TYPE_ARRAY_NUMBER] }] },
          "sort_by": {
            _func: this._functionSortBy,
            _signature: [{ types: [TYPE_ARRAY] }, { types: [TYPE_EXPREF] }]
          },
          join: {
            _func: this._functionJoin,
            _signature: [
              { types: [TYPE_STRING] },
              { types: [TYPE_ARRAY_STRING] }
            ]
          },
          reverse: {
            _func: this._functionReverse,
            _signature: [{ types: [TYPE_STRING, TYPE_ARRAY] }]
          },
          "to_array": { _func: this._functionToArray, _signature: [{ types: [TYPE_ANY] }] },
          "to_string": { _func: this._functionToString, _signature: [{ types: [TYPE_ANY] }] },
          "to_number": { _func: this._functionToNumber, _signature: [{ types: [TYPE_ANY] }] },
          "not_null": {
            _func: this._functionNotNull,
            _signature: [{ types: [TYPE_ANY], variadic: true }]
          }
        };
      }
      Runtime.prototype = {
        callFunction: function(name, resolvedArgs) {
          var functionEntry = this.functionTable[name];
          if (functionEntry === void 0) {
            throw new Error("Unknown function: " + name + "()");
          }
          this._validateArgs(name, resolvedArgs, functionEntry._signature);
          return functionEntry._func.call(this, resolvedArgs);
        },
        _validateArgs: function(name, args, signature) {
          var pluralized;
          if (signature[signature.length - 1].variadic) {
            if (args.length < signature.length) {
              pluralized = signature.length === 1 ? " argument" : " arguments";
              throw new Error("ArgumentError: " + name + "() takes at least" + signature.length + pluralized + " but received " + args.length);
            }
          } else if (args.length !== signature.length) {
            pluralized = signature.length === 1 ? " argument" : " arguments";
            throw new Error("ArgumentError: " + name + "() takes " + signature.length + pluralized + " but received " + args.length);
          }
          var currentSpec;
          var actualType;
          var typeMatched;
          for (var i = 0; i < signature.length; i++) {
            typeMatched = false;
            currentSpec = signature[i].types;
            actualType = this._getTypeName(args[i]);
            for (var j = 0; j < currentSpec.length; j++) {
              if (this._typeMatches(actualType, currentSpec[j], args[i])) {
                typeMatched = true;
                break;
              }
            }
            if (!typeMatched) {
              throw new Error("TypeError: " + name + "() expected argument " + (i + 1) + " to be type " + currentSpec + " but received type " + actualType + " instead.");
            }
          }
        },
        _typeMatches: function(actual, expected, argValue) {
          if (expected === TYPE_ANY) {
            return true;
          }
          if (expected === TYPE_ARRAY_STRING || expected === TYPE_ARRAY_NUMBER || expected === TYPE_ARRAY) {
            if (expected === TYPE_ARRAY) {
              return actual === TYPE_ARRAY;
            } else if (actual === TYPE_ARRAY) {
              var subtype;
              if (expected === TYPE_ARRAY_NUMBER) {
                subtype = TYPE_NUMBER;
              } else if (expected === TYPE_ARRAY_STRING) {
                subtype = TYPE_STRING;
              }
              for (var i = 0; i < argValue.length; i++) {
                if (!this._typeMatches(this._getTypeName(argValue[i]), subtype, argValue[i])) {
                  return false;
                }
              }
              return true;
            }
          } else {
            return actual === expected;
          }
        },
        _getTypeName: function(obj) {
          switch (Object.prototype.toString.call(obj)) {
            case "[object String]":
              return TYPE_STRING;
            case "[object Number]":
              return TYPE_NUMBER;
            case "[object Array]":
              return TYPE_ARRAY;
            case "[object Boolean]":
              return TYPE_BOOLEAN;
            case "[object Null]":
              return TYPE_NULL;
            case "[object Object]":
              if (obj.jmespathType === TOK_EXPREF) {
                return TYPE_EXPREF;
              } else {
                return TYPE_OBJECT;
              }
          }
        },
        _functionStartsWith: function(resolvedArgs) {
          return resolvedArgs[0].lastIndexOf(resolvedArgs[1]) === 0;
        },
        _functionEndsWith: function(resolvedArgs) {
          var searchStr = resolvedArgs[0];
          var suffix = resolvedArgs[1];
          return searchStr.indexOf(suffix, searchStr.length - suffix.length) !== -1;
        },
        _functionReverse: function(resolvedArgs) {
          var typeName = this._getTypeName(resolvedArgs[0]);
          if (typeName === TYPE_STRING) {
            var originalStr = resolvedArgs[0];
            var reversedStr = "";
            for (var i = originalStr.length - 1; i >= 0; i--) {
              reversedStr += originalStr[i];
            }
            return reversedStr;
          } else {
            var reversedArray = resolvedArgs[0].slice(0);
            reversedArray.reverse();
            return reversedArray;
          }
        },
        _functionAbs: function(resolvedArgs) {
          return Math.abs(resolvedArgs[0]);
        },
        _functionCeil: function(resolvedArgs) {
          return Math.ceil(resolvedArgs[0]);
        },
        _functionAvg: function(resolvedArgs) {
          var sum = 0;
          var inputArray = resolvedArgs[0];
          for (var i = 0; i < inputArray.length; i++) {
            sum += inputArray[i];
          }
          return sum / inputArray.length;
        },
        _functionContains: function(resolvedArgs) {
          return resolvedArgs[0].indexOf(resolvedArgs[1]) >= 0;
        },
        _functionFloor: function(resolvedArgs) {
          return Math.floor(resolvedArgs[0]);
        },
        _functionLength: function(resolvedArgs) {
          if (!isObject(resolvedArgs[0])) {
            return resolvedArgs[0].length;
          } else {
            return Object.keys(resolvedArgs[0]).length;
          }
        },
        _functionMap: function(resolvedArgs) {
          var mapped = [];
          var interpreter = this._interpreter;
          var exprefNode = resolvedArgs[0];
          var elements = resolvedArgs[1];
          for (var i = 0; i < elements.length; i++) {
            mapped.push(interpreter.visit(exprefNode, elements[i]));
          }
          return mapped;
        },
        _functionMerge: function(resolvedArgs) {
          var merged = {};
          for (var i = 0; i < resolvedArgs.length; i++) {
            var current = resolvedArgs[i];
            for (var key in current) {
              merged[key] = current[key];
            }
          }
          return merged;
        },
        _functionMax: function(resolvedArgs) {
          if (resolvedArgs[0].length > 0) {
            var typeName = this._getTypeName(resolvedArgs[0][0]);
            if (typeName === TYPE_NUMBER) {
              return Math.max.apply(Math, resolvedArgs[0]);
            } else {
              var elements = resolvedArgs[0];
              var maxElement = elements[0];
              for (var i = 1; i < elements.length; i++) {
                if (maxElement.localeCompare(elements[i]) < 0) {
                  maxElement = elements[i];
                }
              }
              return maxElement;
            }
          } else {
            return null;
          }
        },
        _functionMin: function(resolvedArgs) {
          if (resolvedArgs[0].length > 0) {
            var typeName = this._getTypeName(resolvedArgs[0][0]);
            if (typeName === TYPE_NUMBER) {
              return Math.min.apply(Math, resolvedArgs[0]);
            } else {
              var elements = resolvedArgs[0];
              var minElement = elements[0];
              for (var i = 1; i < elements.length; i++) {
                if (elements[i].localeCompare(minElement) < 0) {
                  minElement = elements[i];
                }
              }
              return minElement;
            }
          } else {
            return null;
          }
        },
        _functionSum: function(resolvedArgs) {
          var sum = 0;
          var listToSum = resolvedArgs[0];
          for (var i = 0; i < listToSum.length; i++) {
            sum += listToSum[i];
          }
          return sum;
        },
        _functionType: function(resolvedArgs) {
          switch (this._getTypeName(resolvedArgs[0])) {
            case TYPE_NUMBER:
              return "number";
            case TYPE_STRING:
              return "string";
            case TYPE_ARRAY:
              return "array";
            case TYPE_OBJECT:
              return "object";
            case TYPE_BOOLEAN:
              return "boolean";
            case TYPE_EXPREF:
              return "expref";
            case TYPE_NULL:
              return "null";
          }
        },
        _functionKeys: function(resolvedArgs) {
          return Object.keys(resolvedArgs[0]);
        },
        _functionValues: function(resolvedArgs) {
          var obj = resolvedArgs[0];
          var keys = Object.keys(obj);
          var values = [];
          for (var i = 0; i < keys.length; i++) {
            values.push(obj[keys[i]]);
          }
          return values;
        },
        _functionJoin: function(resolvedArgs) {
          var joinChar = resolvedArgs[0];
          var listJoin = resolvedArgs[1];
          return listJoin.join(joinChar);
        },
        _functionToArray: function(resolvedArgs) {
          if (this._getTypeName(resolvedArgs[0]) === TYPE_ARRAY) {
            return resolvedArgs[0];
          } else {
            return [resolvedArgs[0]];
          }
        },
        _functionToString: function(resolvedArgs) {
          if (this._getTypeName(resolvedArgs[0]) === TYPE_STRING) {
            return resolvedArgs[0];
          } else {
            return JSON.stringify(resolvedArgs[0]);
          }
        },
        _functionToNumber: function(resolvedArgs) {
          var typeName = this._getTypeName(resolvedArgs[0]);
          var convertedValue;
          if (typeName === TYPE_NUMBER) {
            return resolvedArgs[0];
          } else if (typeName === TYPE_STRING) {
            convertedValue = +resolvedArgs[0];
            if (!isNaN(convertedValue)) {
              return convertedValue;
            }
          }
          return null;
        },
        _functionNotNull: function(resolvedArgs) {
          for (var i = 0; i < resolvedArgs.length; i++) {
            if (this._getTypeName(resolvedArgs[i]) !== TYPE_NULL) {
              return resolvedArgs[i];
            }
          }
          return null;
        },
        _functionSort: function(resolvedArgs) {
          var sortedArray = resolvedArgs[0].slice(0);
          sortedArray.sort();
          return sortedArray;
        },
        _functionSortBy: function(resolvedArgs) {
          var sortedArray = resolvedArgs[0].slice(0);
          if (sortedArray.length === 0) {
            return sortedArray;
          }
          var interpreter = this._interpreter;
          var exprefNode = resolvedArgs[1];
          var requiredType = this._getTypeName(interpreter.visit(exprefNode, sortedArray[0]));
          if ([TYPE_NUMBER, TYPE_STRING].indexOf(requiredType) < 0) {
            throw new Error("TypeError");
          }
          var that = this;
          var decorated = [];
          for (var i = 0; i < sortedArray.length; i++) {
            decorated.push([i, sortedArray[i]]);
          }
          decorated.sort(function(a, b) {
            var exprA = interpreter.visit(exprefNode, a[1]);
            var exprB = interpreter.visit(exprefNode, b[1]);
            if (that._getTypeName(exprA) !== requiredType) {
              throw new Error("TypeError: expected " + requiredType + ", received " + that._getTypeName(exprA));
            } else if (that._getTypeName(exprB) !== requiredType) {
              throw new Error("TypeError: expected " + requiredType + ", received " + that._getTypeName(exprB));
            }
            if (exprA > exprB) {
              return 1;
            } else if (exprA < exprB) {
              return -1;
            } else {
              return a[0] - b[0];
            }
          });
          for (var j = 0; j < decorated.length; j++) {
            sortedArray[j] = decorated[j][1];
          }
          return sortedArray;
        },
        _functionMaxBy: function(resolvedArgs) {
          var exprefNode = resolvedArgs[1];
          var resolvedArray = resolvedArgs[0];
          var keyFunction = this.createKeyFunction(exprefNode, [TYPE_NUMBER, TYPE_STRING]);
          var maxNumber = -Infinity;
          var maxRecord;
          var current;
          for (var i = 0; i < resolvedArray.length; i++) {
            current = keyFunction(resolvedArray[i]);
            if (current > maxNumber) {
              maxNumber = current;
              maxRecord = resolvedArray[i];
            }
          }
          return maxRecord;
        },
        _functionMinBy: function(resolvedArgs) {
          var exprefNode = resolvedArgs[1];
          var resolvedArray = resolvedArgs[0];
          var keyFunction = this.createKeyFunction(exprefNode, [TYPE_NUMBER, TYPE_STRING]);
          var minNumber = Infinity;
          var minRecord;
          var current;
          for (var i = 0; i < resolvedArray.length; i++) {
            current = keyFunction(resolvedArray[i]);
            if (current < minNumber) {
              minNumber = current;
              minRecord = resolvedArray[i];
            }
          }
          return minRecord;
        },
        createKeyFunction: function(exprefNode, allowedTypes) {
          var that = this;
          var interpreter = this._interpreter;
          var keyFunc = function(x) {
            var current = interpreter.visit(exprefNode, x);
            if (allowedTypes.indexOf(that._getTypeName(current)) < 0) {
              var msg = "TypeError: expected one of " + allowedTypes + ", received " + that._getTypeName(current);
              throw new Error(msg);
            }
            return current;
          };
          return keyFunc;
        }
      };
      function compile(stream) {
        var parser = new Parser();
        var ast = parser.parse(stream);
        return ast;
      }
      function tokenize(stream) {
        var lexer = new Lexer();
        return lexer.tokenize(stream);
      }
      function search(data, expression) {
        var parser = new Parser();
        var runtime = new Runtime();
        var interpreter = new TreeInterpreter(runtime);
        runtime._interpreter = interpreter;
        var node = parser.parse(expression);
        return interpreter.search(node, data);
      }
      exports2.tokenize = tokenize;
      exports2.compile = compile;
      exports2.search = search;
      exports2.strictDeepEqual = strictDeepEqual;
    })(typeof exports === "undefined" ? exports.jmespath = {} : exports);
  }
});

// node_modules/aws-sdk/lib/request.js
var require_request = __commonJS({
  "node_modules/aws-sdk/lib/request.js"() {
    var AWS3 = require_core();
    var AcceptorStateMachine = require_state_machine();
    var inherit = AWS3.util.inherit;
    var domain = AWS3.util.domain;
    var jmespath = require_jmespath();
    var hardErrorStates = { success: 1, error: 1, complete: 1 };
    function isTerminalState(machine) {
      return Object.prototype.hasOwnProperty.call(hardErrorStates, machine._asm.currentState);
    }
    var fsm = new AcceptorStateMachine();
    fsm.setupStates = function() {
      var transition = function(_, done) {
        var self2 = this;
        self2._haltHandlersOnError = false;
        self2.emit(self2._asm.currentState, function(err) {
          if (err) {
            if (isTerminalState(self2)) {
              if (domain && self2.domain instanceof domain.Domain) {
                err.domainEmitter = self2;
                err.domain = self2.domain;
                err.domainThrown = false;
                self2.domain.emit("error", err);
              } else {
                throw err;
              }
            } else {
              self2.response.error = err;
              done(err);
            }
          } else {
            done(self2.response.error);
          }
        });
      };
      this.addState("validate", "build", "error", transition);
      this.addState("build", "afterBuild", "restart", transition);
      this.addState("afterBuild", "sign", "restart", transition);
      this.addState("sign", "send", "retry", transition);
      this.addState("retry", "afterRetry", "afterRetry", transition);
      this.addState("afterRetry", "sign", "error", transition);
      this.addState("send", "validateResponse", "retry", transition);
      this.addState("validateResponse", "extractData", "extractError", transition);
      this.addState("extractError", "extractData", "retry", transition);
      this.addState("extractData", "success", "retry", transition);
      this.addState("restart", "build", "error", transition);
      this.addState("success", "complete", "complete", transition);
      this.addState("error", "complete", "complete", transition);
      this.addState("complete", null, null, transition);
    };
    fsm.setupStates();
    AWS3.Request = inherit({
      constructor: function Request(service, operation, params) {
        var endpoint = service.endpoint;
        var region = service.config.region;
        var customUserAgent = service.config.customUserAgent;
        if (service.isGlobalEndpoint) {
          if (service.signingRegion) {
            region = service.signingRegion;
          } else {
            region = "us-east-1";
          }
        }
        this.domain = domain && domain.active;
        this.service = service;
        this.operation = operation;
        this.params = params || {};
        this.httpRequest = new AWS3.HttpRequest(endpoint, region);
        this.httpRequest.appendToUserAgent(customUserAgent);
        this.startTime = service.getSkewCorrectedDate();
        this.response = new AWS3.Response(this);
        this._asm = new AcceptorStateMachine(fsm.states, "validate");
        this._haltHandlersOnError = false;
        AWS3.SequentialExecutor.call(this);
        this.emit = this.emitEvent;
      },
      send: function send(callback) {
        if (callback) {
          this.httpRequest.appendToUserAgent("callback");
          this.on("complete", function(resp) {
            callback.call(resp, resp.error, resp.data);
          });
        }
        this.runTo();
        return this.response;
      },
      build: function build(callback) {
        return this.runTo("send", callback);
      },
      runTo: function runTo(state, done) {
        this._asm.runTo(state, done, this);
        return this;
      },
      abort: function abort() {
        this.removeAllListeners("validateResponse");
        this.removeAllListeners("extractError");
        this.on("validateResponse", function addAbortedError(resp) {
          resp.error = AWS3.util.error(new Error("Request aborted by user"), {
            code: "RequestAbortedError",
            retryable: false
          });
        });
        if (this.httpRequest.stream && !this.httpRequest.stream.didCallback) {
          this.httpRequest.stream.abort();
          if (this.httpRequest._abortCallback) {
            this.httpRequest._abortCallback();
          } else {
            this.removeAllListeners("send");
          }
        }
        return this;
      },
      eachPage: function eachPage(callback) {
        callback = AWS3.util.fn.makeAsync(callback, 3);
        function wrappedCallback(response) {
          callback.call(response, response.error, response.data, function(result) {
            if (result === false)
              return;
            if (response.hasNextPage()) {
              response.nextPage().on("complete", wrappedCallback).send();
            } else {
              callback.call(response, null, null, AWS3.util.fn.noop);
            }
          });
        }
        this.on("complete", wrappedCallback).send();
      },
      eachItem: function eachItem(callback) {
        var self2 = this;
        function wrappedCallback(err, data) {
          if (err)
            return callback(err, null);
          if (data === null)
            return callback(null, null);
          var config = self2.service.paginationConfig(self2.operation);
          var resultKey = config.resultKey;
          if (Array.isArray(resultKey))
            resultKey = resultKey[0];
          var items = jmespath.search(data, resultKey);
          var continueIteration = true;
          AWS3.util.arrayEach(items, function(item) {
            continueIteration = callback(null, item);
            if (continueIteration === false) {
              return AWS3.util.abort;
            }
          });
          return continueIteration;
        }
        this.eachPage(wrappedCallback);
      },
      isPageable: function isPageable() {
        return this.service.paginationConfig(this.operation) ? true : false;
      },
      createReadStream: function createReadStream() {
        var streams = AWS3.util.stream;
        var req = this;
        var stream = null;
        if (AWS3.HttpClient.streamsApiVersion === 2) {
          stream = new streams.PassThrough();
          process.nextTick(function() {
            req.send();
          });
        } else {
          stream = new streams.Stream();
          stream.readable = true;
          stream.sent = false;
          stream.on("newListener", function(event) {
            if (!stream.sent && event === "data") {
              stream.sent = true;
              process.nextTick(function() {
                req.send();
              });
            }
          });
        }
        this.on("error", function(err) {
          stream.emit("error", err);
        });
        this.on("httpHeaders", function streamHeaders(statusCode, headers, resp) {
          if (statusCode < 300) {
            req.removeListener("httpData", AWS3.EventListeners.Core.HTTP_DATA);
            req.removeListener("httpError", AWS3.EventListeners.Core.HTTP_ERROR);
            req.on("httpError", function streamHttpError(error) {
              resp.error = error;
              resp.error.retryable = false;
            });
            var shouldCheckContentLength = false;
            var expectedLen;
            if (req.httpRequest.method !== "HEAD") {
              expectedLen = parseInt(headers["content-length"], 10);
            }
            if (expectedLen !== void 0 && !isNaN(expectedLen) && expectedLen >= 0) {
              shouldCheckContentLength = true;
              var receivedLen = 0;
            }
            var checkContentLengthAndEmit = function checkContentLengthAndEmit2() {
              if (shouldCheckContentLength && receivedLen !== expectedLen) {
                stream.emit("error", AWS3.util.error(new Error("Stream content length mismatch. Received " + receivedLen + " of " + expectedLen + " bytes."), { code: "StreamContentLengthMismatch" }));
              } else if (AWS3.HttpClient.streamsApiVersion === 2) {
                stream.end();
              } else {
                stream.emit("end");
              }
            };
            var httpStream = resp.httpResponse.createUnbufferedStream();
            if (AWS3.HttpClient.streamsApiVersion === 2) {
              if (shouldCheckContentLength) {
                var lengthAccumulator = new streams.PassThrough();
                lengthAccumulator._write = function(chunk) {
                  if (chunk && chunk.length) {
                    receivedLen += chunk.length;
                  }
                  return streams.PassThrough.prototype._write.apply(this, arguments);
                };
                lengthAccumulator.on("end", checkContentLengthAndEmit);
                stream.on("error", function(err) {
                  shouldCheckContentLength = false;
                  httpStream.unpipe(lengthAccumulator);
                  lengthAccumulator.emit("end");
                  lengthAccumulator.end();
                });
                httpStream.pipe(lengthAccumulator).pipe(stream, { end: false });
              } else {
                httpStream.pipe(stream);
              }
            } else {
              if (shouldCheckContentLength) {
                httpStream.on("data", function(arg) {
                  if (arg && arg.length) {
                    receivedLen += arg.length;
                  }
                });
              }
              httpStream.on("data", function(arg) {
                stream.emit("data", arg);
              });
              httpStream.on("end", checkContentLengthAndEmit);
            }
            httpStream.on("error", function(err) {
              shouldCheckContentLength = false;
              stream.emit("error", err);
            });
          }
        });
        return stream;
      },
      emitEvent: function emit(eventName, args, done) {
        if (typeof args === "function") {
          done = args;
          args = null;
        }
        if (!done)
          done = function() {
          };
        if (!args)
          args = this.eventParameters(eventName, this.response);
        var origEmit = AWS3.SequentialExecutor.prototype.emit;
        origEmit.call(this, eventName, args, function(err) {
          if (err)
            this.response.error = err;
          done.call(this, err);
        });
      },
      eventParameters: function eventParameters(eventName) {
        switch (eventName) {
          case "restart":
          case "validate":
          case "sign":
          case "build":
          case "afterValidate":
          case "afterBuild":
            return [this];
          case "error":
            return [this.response.error, this.response];
          default:
            return [this.response];
        }
      },
      presign: function presign(expires, callback) {
        if (!callback && typeof expires === "function") {
          callback = expires;
          expires = null;
        }
        return new AWS3.Signers.Presign().sign(this.toGet(), expires, callback);
      },
      isPresigned: function isPresigned() {
        return Object.prototype.hasOwnProperty.call(this.httpRequest.headers, "presigned-expires");
      },
      toUnauthenticated: function toUnauthenticated() {
        this._unAuthenticated = true;
        this.removeListener("validate", AWS3.EventListeners.Core.VALIDATE_CREDENTIALS);
        this.removeListener("sign", AWS3.EventListeners.Core.SIGN);
        return this;
      },
      toGet: function toGet() {
        if (this.service.api.protocol === "query" || this.service.api.protocol === "ec2") {
          this.removeListener("build", this.buildAsGet);
          this.addListener("build", this.buildAsGet);
        }
        return this;
      },
      buildAsGet: function buildAsGet(request) {
        request.httpRequest.method = "GET";
        request.httpRequest.path = request.service.endpoint.path + "?" + request.httpRequest.body;
        request.httpRequest.body = "";
        delete request.httpRequest.headers["Content-Length"];
        delete request.httpRequest.headers["Content-Type"];
      },
      haltHandlersOnError: function haltHandlersOnError() {
        this._haltHandlersOnError = true;
      }
    });
    AWS3.Request.addPromisesToClass = function addPromisesToClass(PromiseDependency) {
      this.prototype.promise = function promise() {
        var self2 = this;
        this.httpRequest.appendToUserAgent("promise");
        return new PromiseDependency(function(resolve, reject) {
          self2.on("complete", function(resp) {
            if (resp.error) {
              reject(resp.error);
            } else {
              resolve(Object.defineProperty(resp.data || {}, "$response", { value: resp }));
            }
          });
          self2.runTo();
        });
      };
    };
    AWS3.Request.deletePromisesFromClass = function deletePromisesFromClass() {
      delete this.prototype.promise;
    };
    AWS3.util.addPromises(AWS3.Request);
    AWS3.util.mixin(AWS3.Request, AWS3.SequentialExecutor);
  }
});

// node_modules/aws-sdk/lib/response.js
var require_response = __commonJS({
  "node_modules/aws-sdk/lib/response.js"() {
    var AWS3 = require_core();
    var inherit = AWS3.util.inherit;
    var jmespath = require_jmespath();
    AWS3.Response = inherit({
      constructor: function Response(request) {
        this.request = request;
        this.data = null;
        this.error = null;
        this.retryCount = 0;
        this.redirectCount = 0;
        this.httpResponse = new AWS3.HttpResponse();
        if (request) {
          this.maxRetries = request.service.numRetries();
          this.maxRedirects = request.service.config.maxRedirects;
        }
      },
      nextPage: function nextPage(callback) {
        var config;
        var service = this.request.service;
        var operation = this.request.operation;
        try {
          config = service.paginationConfig(operation, true);
        } catch (e) {
          this.error = e;
        }
        if (!this.hasNextPage()) {
          if (callback)
            callback(this.error, null);
          else if (this.error)
            throw this.error;
          return null;
        }
        var params = AWS3.util.copy(this.request.params);
        if (!this.nextPageTokens) {
          return callback ? callback(null, null) : null;
        } else {
          var inputTokens = config.inputToken;
          if (typeof inputTokens === "string")
            inputTokens = [inputTokens];
          for (var i = 0; i < inputTokens.length; i++) {
            params[inputTokens[i]] = this.nextPageTokens[i];
          }
          return service.makeRequest(this.request.operation, params, callback);
        }
      },
      hasNextPage: function hasNextPage() {
        this.cacheNextPageTokens();
        if (this.nextPageTokens)
          return true;
        if (this.nextPageTokens === void 0)
          return void 0;
        else
          return false;
      },
      cacheNextPageTokens: function cacheNextPageTokens() {
        if (Object.prototype.hasOwnProperty.call(this, "nextPageTokens"))
          return this.nextPageTokens;
        this.nextPageTokens = void 0;
        var config = this.request.service.paginationConfig(this.request.operation);
        if (!config)
          return this.nextPageTokens;
        this.nextPageTokens = null;
        if (config.moreResults) {
          if (!jmespath.search(this.data, config.moreResults)) {
            return this.nextPageTokens;
          }
        }
        var exprs = config.outputToken;
        if (typeof exprs === "string")
          exprs = [exprs];
        AWS3.util.arrayEach.call(this, exprs, function(expr) {
          var output = jmespath.search(this.data, expr);
          if (output) {
            this.nextPageTokens = this.nextPageTokens || [];
            this.nextPageTokens.push(output);
          }
        });
        return this.nextPageTokens;
      }
    });
  }
});

// node_modules/aws-sdk/lib/resource_waiter.js
var require_resource_waiter2 = __commonJS({
  "node_modules/aws-sdk/lib/resource_waiter.js"() {
    var AWS3 = require_core();
    var inherit = AWS3.util.inherit;
    var jmespath = require_jmespath();
    function CHECK_ACCEPTORS(resp) {
      var waiter = resp.request._waiter;
      var acceptors = waiter.config.acceptors;
      var acceptorMatched = false;
      var state = "retry";
      acceptors.forEach(function(acceptor) {
        if (!acceptorMatched) {
          var matcher = waiter.matchers[acceptor.matcher];
          if (matcher && matcher(resp, acceptor.expected, acceptor.argument)) {
            acceptorMatched = true;
            state = acceptor.state;
          }
        }
      });
      if (!acceptorMatched && resp.error)
        state = "failure";
      if (state === "success") {
        waiter.setSuccess(resp);
      } else {
        waiter.setError(resp, state === "retry");
      }
    }
    AWS3.ResourceWaiter = inherit({
      constructor: function constructor(service, state) {
        this.service = service;
        this.state = state;
        this.loadWaiterConfig(this.state);
      },
      service: null,
      state: null,
      config: null,
      matchers: {
        path: function(resp, expected, argument) {
          try {
            var result = jmespath.search(resp.data, argument);
          } catch (err) {
            return false;
          }
          return jmespath.strictDeepEqual(result, expected);
        },
        pathAll: function(resp, expected, argument) {
          try {
            var results = jmespath.search(resp.data, argument);
          } catch (err) {
            return false;
          }
          if (!Array.isArray(results))
            results = [results];
          var numResults = results.length;
          if (!numResults)
            return false;
          for (var ind = 0; ind < numResults; ind++) {
            if (!jmespath.strictDeepEqual(results[ind], expected)) {
              return false;
            }
          }
          return true;
        },
        pathAny: function(resp, expected, argument) {
          try {
            var results = jmespath.search(resp.data, argument);
          } catch (err) {
            return false;
          }
          if (!Array.isArray(results))
            results = [results];
          var numResults = results.length;
          for (var ind = 0; ind < numResults; ind++) {
            if (jmespath.strictDeepEqual(results[ind], expected)) {
              return true;
            }
          }
          return false;
        },
        status: function(resp, expected) {
          var statusCode = resp.httpResponse.statusCode;
          return typeof statusCode === "number" && statusCode === expected;
        },
        error: function(resp, expected) {
          if (typeof expected === "string" && resp.error) {
            return expected === resp.error.code;
          }
          return expected === !!resp.error;
        }
      },
      listeners: new AWS3.SequentialExecutor().addNamedListeners(function(add) {
        add("RETRY_CHECK", "retry", function(resp) {
          var waiter = resp.request._waiter;
          if (resp.error && resp.error.code === "ResourceNotReady") {
            resp.error.retryDelay = (waiter.config.delay || 0) * 1e3;
          }
        });
        add("CHECK_OUTPUT", "extractData", CHECK_ACCEPTORS);
        add("CHECK_ERROR", "extractError", CHECK_ACCEPTORS);
      }),
      wait: function wait(params, callback) {
        if (typeof params === "function") {
          callback = params;
          params = void 0;
        }
        if (params && params.$waiter) {
          params = AWS3.util.copy(params);
          if (typeof params.$waiter.delay === "number") {
            this.config.delay = params.$waiter.delay;
          }
          if (typeof params.$waiter.maxAttempts === "number") {
            this.config.maxAttempts = params.$waiter.maxAttempts;
          }
          delete params.$waiter;
        }
        var request = this.service.makeRequest(this.config.operation, params);
        request._waiter = this;
        request.response.maxRetries = this.config.maxAttempts;
        request.addListeners(this.listeners);
        if (callback)
          request.send(callback);
        return request;
      },
      setSuccess: function setSuccess(resp) {
        resp.error = null;
        resp.data = resp.data || {};
        resp.request.removeAllListeners("extractData");
      },
      setError: function setError(resp, retryable) {
        resp.data = null;
        resp.error = AWS3.util.error(resp.error || new Error(), {
          code: "ResourceNotReady",
          message: "Resource is not in the state " + this.state,
          retryable
        });
      },
      loadWaiterConfig: function loadWaiterConfig(state) {
        if (!this.service.api.waiters[state]) {
          throw new AWS3.util.error(new Error(), {
            code: "StateNotFoundError",
            message: "State " + state + " not found."
          });
        }
        this.config = AWS3.util.copy(this.service.api.waiters[state]);
      }
    });
  }
});

// node_modules/aws-sdk/lib/signers/v2.js
var require_v2 = __commonJS({
  "node_modules/aws-sdk/lib/signers/v2.js"(exports, module2) {
    var AWS3 = require_core();
    var inherit = AWS3.util.inherit;
    AWS3.Signers.V2 = inherit(AWS3.Signers.RequestSigner, {
      addAuthorization: function addAuthorization(credentials, date) {
        if (!date)
          date = AWS3.util.date.getDate();
        var r = this.request;
        r.params.Timestamp = AWS3.util.date.iso8601(date);
        r.params.SignatureVersion = "2";
        r.params.SignatureMethod = "HmacSHA256";
        r.params.AWSAccessKeyId = credentials.accessKeyId;
        if (credentials.sessionToken) {
          r.params.SecurityToken = credentials.sessionToken;
        }
        delete r.params.Signature;
        r.params.Signature = this.signature(credentials);
        r.body = AWS3.util.queryParamsToString(r.params);
        r.headers["Content-Length"] = r.body.length;
      },
      signature: function signature(credentials) {
        return AWS3.util.crypto.hmac(credentials.secretAccessKey, this.stringToSign(), "base64");
      },
      stringToSign: function stringToSign() {
        var parts = [];
        parts.push(this.request.method);
        parts.push(this.request.endpoint.host.toLowerCase());
        parts.push(this.request.pathname());
        parts.push(AWS3.util.queryParamsToString(this.request.params));
        return parts.join("\n");
      }
    });
    module2.exports = AWS3.Signers.V2;
  }
});

// node_modules/aws-sdk/lib/signers/v3.js
var require_v3 = __commonJS({
  "node_modules/aws-sdk/lib/signers/v3.js"(exports, module2) {
    var AWS3 = require_core();
    var inherit = AWS3.util.inherit;
    AWS3.Signers.V3 = inherit(AWS3.Signers.RequestSigner, {
      addAuthorization: function addAuthorization(credentials, date) {
        var datetime = AWS3.util.date.rfc822(date);
        this.request.headers["X-Amz-Date"] = datetime;
        if (credentials.sessionToken) {
          this.request.headers["x-amz-security-token"] = credentials.sessionToken;
        }
        this.request.headers["X-Amzn-Authorization"] = this.authorization(credentials, datetime);
      },
      authorization: function authorization(credentials) {
        return "AWS3 AWSAccessKeyId=" + credentials.accessKeyId + ",Algorithm=HmacSHA256,SignedHeaders=" + this.signedHeaders() + ",Signature=" + this.signature(credentials);
      },
      signedHeaders: function signedHeaders() {
        var headers = [];
        AWS3.util.arrayEach(this.headersToSign(), function iterator(h) {
          headers.push(h.toLowerCase());
        });
        return headers.sort().join(";");
      },
      canonicalHeaders: function canonicalHeaders() {
        var headers = this.request.headers;
        var parts = [];
        AWS3.util.arrayEach(this.headersToSign(), function iterator(h) {
          parts.push(h.toLowerCase().trim() + ":" + String(headers[h]).trim());
        });
        return parts.sort().join("\n") + "\n";
      },
      headersToSign: function headersToSign() {
        var headers = [];
        AWS3.util.each(this.request.headers, function iterator(k) {
          if (k === "Host" || k === "Content-Encoding" || k.match(/^X-Amz/i)) {
            headers.push(k);
          }
        });
        return headers;
      },
      signature: function signature(credentials) {
        return AWS3.util.crypto.hmac(credentials.secretAccessKey, this.stringToSign(), "base64");
      },
      stringToSign: function stringToSign() {
        var parts = [];
        parts.push(this.request.method);
        parts.push("/");
        parts.push("");
        parts.push(this.canonicalHeaders());
        parts.push(this.request.body);
        return AWS3.util.crypto.sha256(parts.join("\n"));
      }
    });
    module2.exports = AWS3.Signers.V3;
  }
});

// node_modules/aws-sdk/lib/signers/v3https.js
var require_v3https = __commonJS({
  "node_modules/aws-sdk/lib/signers/v3https.js"(exports, module2) {
    var AWS3 = require_core();
    var inherit = AWS3.util.inherit;
    require_v3();
    AWS3.Signers.V3Https = inherit(AWS3.Signers.V3, {
      authorization: function authorization(credentials) {
        return "AWS3-HTTPS AWSAccessKeyId=" + credentials.accessKeyId + ",Algorithm=HmacSHA256,Signature=" + this.signature(credentials);
      },
      stringToSign: function stringToSign() {
        return this.request.headers["X-Amz-Date"];
      }
    });
    module2.exports = AWS3.Signers.V3Https;
  }
});

// node_modules/aws-sdk/lib/signers/v4_credentials.js
var require_v4_credentials = __commonJS({
  "node_modules/aws-sdk/lib/signers/v4_credentials.js"(exports, module2) {
    var AWS3 = require_core();
    var cachedSecret = {};
    var cacheQueue = [];
    var maxCacheEntries = 50;
    var v4Identifier = "aws4_request";
    module2.exports = {
      createScope: function createScope(date, region, serviceName) {
        return [
          date.substr(0, 8),
          region,
          serviceName,
          v4Identifier
        ].join("/");
      },
      getSigningKey: function getSigningKey(credentials, date, region, service, shouldCache) {
        var credsIdentifier = AWS3.util.crypto.hmac(credentials.secretAccessKey, credentials.accessKeyId, "base64");
        var cacheKey = [credsIdentifier, date, region, service].join("_");
        shouldCache = shouldCache !== false;
        if (shouldCache && cacheKey in cachedSecret) {
          return cachedSecret[cacheKey];
        }
        var kDate = AWS3.util.crypto.hmac("AWS4" + credentials.secretAccessKey, date, "buffer");
        var kRegion = AWS3.util.crypto.hmac(kDate, region, "buffer");
        var kService = AWS3.util.crypto.hmac(kRegion, service, "buffer");
        var signingKey = AWS3.util.crypto.hmac(kService, v4Identifier, "buffer");
        if (shouldCache) {
          cachedSecret[cacheKey] = signingKey;
          cacheQueue.push(cacheKey);
          if (cacheQueue.length > maxCacheEntries) {
            delete cachedSecret[cacheQueue.shift()];
          }
        }
        return signingKey;
      },
      emptyCache: function emptyCache() {
        cachedSecret = {};
        cacheQueue = [];
      }
    };
  }
});

// node_modules/aws-sdk/lib/signers/v4.js
var require_v4 = __commonJS({
  "node_modules/aws-sdk/lib/signers/v4.js"(exports, module2) {
    var AWS3 = require_core();
    var v4Credentials = require_v4_credentials();
    var inherit = AWS3.util.inherit;
    var expiresHeader = "presigned-expires";
    AWS3.Signers.V4 = inherit(AWS3.Signers.RequestSigner, {
      constructor: function V4(request, serviceName, options) {
        AWS3.Signers.RequestSigner.call(this, request);
        this.serviceName = serviceName;
        options = options || {};
        this.signatureCache = typeof options.signatureCache === "boolean" ? options.signatureCache : true;
        this.operation = options.operation;
        this.signatureVersion = options.signatureVersion;
      },
      algorithm: "AWS4-HMAC-SHA256",
      addAuthorization: function addAuthorization(credentials, date) {
        var datetime = AWS3.util.date.iso8601(date).replace(/[:\-]|\.\d{3}/g, "");
        if (this.isPresigned()) {
          this.updateForPresigned(credentials, datetime);
        } else {
          this.addHeaders(credentials, datetime);
        }
        this.request.headers["Authorization"] = this.authorization(credentials, datetime);
      },
      addHeaders: function addHeaders(credentials, datetime) {
        this.request.headers["X-Amz-Date"] = datetime;
        if (credentials.sessionToken) {
          this.request.headers["x-amz-security-token"] = credentials.sessionToken;
        }
      },
      updateForPresigned: function updateForPresigned(credentials, datetime) {
        var credString = this.credentialString(datetime);
        var qs = {
          "X-Amz-Date": datetime,
          "X-Amz-Algorithm": this.algorithm,
          "X-Amz-Credential": credentials.accessKeyId + "/" + credString,
          "X-Amz-Expires": this.request.headers[expiresHeader],
          "X-Amz-SignedHeaders": this.signedHeaders()
        };
        if (credentials.sessionToken) {
          qs["X-Amz-Security-Token"] = credentials.sessionToken;
        }
        if (this.request.headers["Content-Type"]) {
          qs["Content-Type"] = this.request.headers["Content-Type"];
        }
        if (this.request.headers["Content-MD5"]) {
          qs["Content-MD5"] = this.request.headers["Content-MD5"];
        }
        if (this.request.headers["Cache-Control"]) {
          qs["Cache-Control"] = this.request.headers["Cache-Control"];
        }
        AWS3.util.each.call(this, this.request.headers, function(key, value) {
          if (key === expiresHeader)
            return;
          if (this.isSignableHeader(key)) {
            var lowerKey = key.toLowerCase();
            if (lowerKey.indexOf("x-amz-meta-") === 0) {
              qs[lowerKey] = value;
            } else if (lowerKey.indexOf("x-amz-") === 0) {
              qs[key] = value;
            }
          }
        });
        var sep = this.request.path.indexOf("?") >= 0 ? "&" : "?";
        this.request.path += sep + AWS3.util.queryParamsToString(qs);
      },
      authorization: function authorization(credentials, datetime) {
        var parts = [];
        var credString = this.credentialString(datetime);
        parts.push(this.algorithm + " Credential=" + credentials.accessKeyId + "/" + credString);
        parts.push("SignedHeaders=" + this.signedHeaders());
        parts.push("Signature=" + this.signature(credentials, datetime));
        return parts.join(", ");
      },
      signature: function signature(credentials, datetime) {
        var signingKey = v4Credentials.getSigningKey(credentials, datetime.substr(0, 8), this.request.region, this.serviceName, this.signatureCache);
        return AWS3.util.crypto.hmac(signingKey, this.stringToSign(datetime), "hex");
      },
      stringToSign: function stringToSign(datetime) {
        var parts = [];
        parts.push("AWS4-HMAC-SHA256");
        parts.push(datetime);
        parts.push(this.credentialString(datetime));
        parts.push(this.hexEncodedHash(this.canonicalString()));
        return parts.join("\n");
      },
      canonicalString: function canonicalString() {
        var parts = [], pathname = this.request.pathname();
        if (this.serviceName !== "s3" && this.signatureVersion !== "s3v4")
          pathname = AWS3.util.uriEscapePath(pathname);
        parts.push(this.request.method);
        parts.push(pathname);
        parts.push(this.request.search());
        parts.push(this.canonicalHeaders() + "\n");
        parts.push(this.signedHeaders());
        parts.push(this.hexEncodedBodyHash());
        return parts.join("\n");
      },
      canonicalHeaders: function canonicalHeaders() {
        var headers = [];
        AWS3.util.each.call(this, this.request.headers, function(key, item) {
          headers.push([key, item]);
        });
        headers.sort(function(a, b) {
          return a[0].toLowerCase() < b[0].toLowerCase() ? -1 : 1;
        });
        var parts = [];
        AWS3.util.arrayEach.call(this, headers, function(item) {
          var key = item[0].toLowerCase();
          if (this.isSignableHeader(key)) {
            var value = item[1];
            if (typeof value === "undefined" || value === null || typeof value.toString !== "function") {
              throw AWS3.util.error(new Error("Header " + key + " contains invalid value"), {
                code: "InvalidHeader"
              });
            }
            parts.push(key + ":" + this.canonicalHeaderValues(value.toString()));
          }
        });
        return parts.join("\n");
      },
      canonicalHeaderValues: function canonicalHeaderValues(values) {
        return values.replace(/\s+/g, " ").replace(/^\s+|\s+$/g, "");
      },
      signedHeaders: function signedHeaders() {
        var keys = [];
        AWS3.util.each.call(this, this.request.headers, function(key) {
          key = key.toLowerCase();
          if (this.isSignableHeader(key))
            keys.push(key);
        });
        return keys.sort().join(";");
      },
      credentialString: function credentialString(datetime) {
        return v4Credentials.createScope(datetime.substr(0, 8), this.request.region, this.serviceName);
      },
      hexEncodedHash: function hash(string) {
        return AWS3.util.crypto.sha256(string, "hex");
      },
      hexEncodedBodyHash: function hexEncodedBodyHash() {
        var request = this.request;
        if (this.isPresigned() && ["s3", "s3-object-lambda"].indexOf(this.serviceName) > -1 && !request.body) {
          return "UNSIGNED-PAYLOAD";
        } else if (request.headers["X-Amz-Content-Sha256"]) {
          return request.headers["X-Amz-Content-Sha256"];
        } else {
          return this.hexEncodedHash(this.request.body || "");
        }
      },
      unsignableHeaders: [
        "authorization",
        "content-type",
        "content-length",
        "user-agent",
        expiresHeader,
        "expect",
        "x-amzn-trace-id"
      ],
      isSignableHeader: function isSignableHeader(key) {
        if (key.toLowerCase().indexOf("x-amz-") === 0)
          return true;
        return this.unsignableHeaders.indexOf(key) < 0;
      },
      isPresigned: function isPresigned() {
        return this.request.headers[expiresHeader] ? true : false;
      }
    });
    module2.exports = AWS3.Signers.V4;
  }
});

// node_modules/aws-sdk/lib/signers/s3.js
var require_s3 = __commonJS({
  "node_modules/aws-sdk/lib/signers/s3.js"(exports, module2) {
    var AWS3 = require_core();
    var inherit = AWS3.util.inherit;
    AWS3.Signers.S3 = inherit(AWS3.Signers.RequestSigner, {
      subResources: {
        "acl": 1,
        "accelerate": 1,
        "analytics": 1,
        "cors": 1,
        "lifecycle": 1,
        "delete": 1,
        "inventory": 1,
        "location": 1,
        "logging": 1,
        "metrics": 1,
        "notification": 1,
        "partNumber": 1,
        "policy": 1,
        "requestPayment": 1,
        "replication": 1,
        "restore": 1,
        "tagging": 1,
        "torrent": 1,
        "uploadId": 1,
        "uploads": 1,
        "versionId": 1,
        "versioning": 1,
        "versions": 1,
        "website": 1
      },
      responseHeaders: {
        "response-content-type": 1,
        "response-content-language": 1,
        "response-expires": 1,
        "response-cache-control": 1,
        "response-content-disposition": 1,
        "response-content-encoding": 1
      },
      addAuthorization: function addAuthorization(credentials, date) {
        if (!this.request.headers["presigned-expires"]) {
          this.request.headers["X-Amz-Date"] = AWS3.util.date.rfc822(date);
        }
        if (credentials.sessionToken) {
          this.request.headers["x-amz-security-token"] = credentials.sessionToken;
        }
        var signature = this.sign(credentials.secretAccessKey, this.stringToSign());
        var auth = "AWS " + credentials.accessKeyId + ":" + signature;
        this.request.headers["Authorization"] = auth;
      },
      stringToSign: function stringToSign() {
        var r = this.request;
        var parts = [];
        parts.push(r.method);
        parts.push(r.headers["Content-MD5"] || "");
        parts.push(r.headers["Content-Type"] || "");
        parts.push(r.headers["presigned-expires"] || "");
        var headers = this.canonicalizedAmzHeaders();
        if (headers)
          parts.push(headers);
        parts.push(this.canonicalizedResource());
        return parts.join("\n");
      },
      canonicalizedAmzHeaders: function canonicalizedAmzHeaders() {
        var amzHeaders = [];
        AWS3.util.each(this.request.headers, function(name) {
          if (name.match(/^x-amz-/i))
            amzHeaders.push(name);
        });
        amzHeaders.sort(function(a, b) {
          return a.toLowerCase() < b.toLowerCase() ? -1 : 1;
        });
        var parts = [];
        AWS3.util.arrayEach.call(this, amzHeaders, function(name) {
          parts.push(name.toLowerCase() + ":" + String(this.request.headers[name]));
        });
        return parts.join("\n");
      },
      canonicalizedResource: function canonicalizedResource() {
        var r = this.request;
        var parts = r.path.split("?");
        var path2 = parts[0];
        var querystring = parts[1];
        var resource = "";
        if (r.virtualHostedBucket)
          resource += "/" + r.virtualHostedBucket;
        resource += path2;
        if (querystring) {
          var resources = [];
          AWS3.util.arrayEach.call(this, querystring.split("&"), function(param) {
            var name = param.split("=")[0];
            var value = param.split("=")[1];
            if (this.subResources[name] || this.responseHeaders[name]) {
              var subresource = { name };
              if (value !== void 0) {
                if (this.subResources[name]) {
                  subresource.value = value;
                } else {
                  subresource.value = decodeURIComponent(value);
                }
              }
              resources.push(subresource);
            }
          });
          resources.sort(function(a, b) {
            return a.name < b.name ? -1 : 1;
          });
          if (resources.length) {
            querystring = [];
            AWS3.util.arrayEach(resources, function(res) {
              if (res.value === void 0) {
                querystring.push(res.name);
              } else {
                querystring.push(res.name + "=" + res.value);
              }
            });
            resource += "?" + querystring.join("&");
          }
        }
        return resource;
      },
      sign: function sign(secret, string) {
        return AWS3.util.crypto.hmac(secret, string, "base64", "sha1");
      }
    });
    module2.exports = AWS3.Signers.S3;
  }
});

// node_modules/aws-sdk/lib/signers/presign.js
var require_presign = __commonJS({
  "node_modules/aws-sdk/lib/signers/presign.js"(exports, module2) {
    var AWS3 = require_core();
    var inherit = AWS3.util.inherit;
    var expiresHeader = "presigned-expires";
    function signedUrlBuilder(request) {
      var expires = request.httpRequest.headers[expiresHeader];
      var signerClass = request.service.getSignerClass(request);
      delete request.httpRequest.headers["User-Agent"];
      delete request.httpRequest.headers["X-Amz-User-Agent"];
      if (signerClass === AWS3.Signers.V4) {
        if (expires > 604800) {
          var message = "Presigning does not support expiry time greater than a week with SigV4 signing.";
          throw AWS3.util.error(new Error(), {
            code: "InvalidExpiryTime",
            message,
            retryable: false
          });
        }
        request.httpRequest.headers[expiresHeader] = expires;
      } else if (signerClass === AWS3.Signers.S3) {
        var now = request.service ? request.service.getSkewCorrectedDate() : AWS3.util.date.getDate();
        request.httpRequest.headers[expiresHeader] = parseInt(AWS3.util.date.unixTimestamp(now) + expires, 10).toString();
      } else {
        throw AWS3.util.error(new Error(), {
          message: "Presigning only supports S3 or SigV4 signing.",
          code: "UnsupportedSigner",
          retryable: false
        });
      }
    }
    function signedUrlSigner(request) {
      var endpoint = request.httpRequest.endpoint;
      var parsedUrl = AWS3.util.urlParse(request.httpRequest.path);
      var queryParams = {};
      if (parsedUrl.search) {
        queryParams = AWS3.util.queryStringParse(parsedUrl.search.substr(1));
      }
      var auth = request.httpRequest.headers["Authorization"].split(" ");
      if (auth[0] === "AWS") {
        auth = auth[1].split(":");
        queryParams["Signature"] = auth.pop();
        queryParams["AWSAccessKeyId"] = auth.join(":");
        AWS3.util.each(request.httpRequest.headers, function(key, value) {
          if (key === expiresHeader)
            key = "Expires";
          if (key.indexOf("x-amz-meta-") === 0) {
            delete queryParams[key];
            key = key.toLowerCase();
          }
          queryParams[key] = value;
        });
        delete request.httpRequest.headers[expiresHeader];
        delete queryParams["Authorization"];
        delete queryParams["Host"];
      } else if (auth[0] === "AWS4-HMAC-SHA256") {
        auth.shift();
        var rest = auth.join(" ");
        var signature = rest.match(/Signature=(.*?)(?:,|\s|\r?\n|$)/)[1];
        queryParams["X-Amz-Signature"] = signature;
        delete queryParams["Expires"];
      }
      endpoint.pathname = parsedUrl.pathname;
      endpoint.search = AWS3.util.queryParamsToString(queryParams);
    }
    AWS3.Signers.Presign = inherit({
      sign: function sign(request, expireTime, callback) {
        request.httpRequest.headers[expiresHeader] = expireTime || 3600;
        request.on("build", signedUrlBuilder);
        request.on("sign", signedUrlSigner);
        request.removeListener("afterBuild", AWS3.EventListeners.Core.SET_CONTENT_LENGTH);
        request.removeListener("afterBuild", AWS3.EventListeners.Core.COMPUTE_SHA256);
        request.emit("beforePresign", [request]);
        if (callback) {
          request.build(function() {
            if (this.response.error)
              callback(this.response.error);
            else {
              callback(null, AWS3.util.urlFormat(request.httpRequest.endpoint));
            }
          });
        } else {
          request.build();
          if (request.response.error)
            throw request.response.error;
          return AWS3.util.urlFormat(request.httpRequest.endpoint);
        }
      }
    });
    module2.exports = AWS3.Signers.Presign;
  }
});

// node_modules/aws-sdk/lib/signers/request_signer.js
var require_request_signer = __commonJS({
  "node_modules/aws-sdk/lib/signers/request_signer.js"() {
    var AWS3 = require_core();
    var inherit = AWS3.util.inherit;
    AWS3.Signers.RequestSigner = inherit({
      constructor: function RequestSigner(request) {
        this.request = request;
      },
      setServiceClientId: function setServiceClientId(id) {
        this.serviceClientId = id;
      },
      getServiceClientId: function getServiceClientId() {
        return this.serviceClientId;
      }
    });
    AWS3.Signers.RequestSigner.getVersion = function getVersion(version) {
      switch (version) {
        case "v2":
          return AWS3.Signers.V2;
        case "v3":
          return AWS3.Signers.V3;
        case "s3v4":
          return AWS3.Signers.V4;
        case "v4":
          return AWS3.Signers.V4;
        case "s3":
          return AWS3.Signers.S3;
        case "v3https":
          return AWS3.Signers.V3Https;
      }
      throw new Error("Unknown signing version " + version);
    };
    require_v2();
    require_v3();
    require_v3https();
    require_v4();
    require_s3();
    require_presign();
  }
});

// node_modules/aws-sdk/lib/param_validator.js
var require_param_validator = __commonJS({
  "node_modules/aws-sdk/lib/param_validator.js"() {
    var AWS3 = require_core();
    AWS3.ParamValidator = AWS3.util.inherit({
      constructor: function ParamValidator(validation) {
        if (validation === true || validation === void 0) {
          validation = { "min": true };
        }
        this.validation = validation;
      },
      validate: function validate(shape, params, context) {
        this.errors = [];
        this.validateMember(shape, params || {}, context || "params");
        if (this.errors.length > 1) {
          var msg = this.errors.join("\n* ");
          msg = "There were " + this.errors.length + " validation errors:\n* " + msg;
          throw AWS3.util.error(new Error(msg), { code: "MultipleValidationErrors", errors: this.errors });
        } else if (this.errors.length === 1) {
          throw this.errors[0];
        } else {
          return true;
        }
      },
      fail: function fail(code, message) {
        this.errors.push(AWS3.util.error(new Error(message), { code }));
      },
      validateStructure: function validateStructure(shape, params, context) {
        this.validateType(params, context, ["object"], "structure");
        var paramName;
        for (var i = 0; shape.required && i < shape.required.length; i++) {
          paramName = shape.required[i];
          var value = params[paramName];
          if (value === void 0 || value === null) {
            this.fail("MissingRequiredParameter", "Missing required key '" + paramName + "' in " + context);
          }
        }
        for (paramName in params) {
          if (!Object.prototype.hasOwnProperty.call(params, paramName))
            continue;
          var paramValue = params[paramName], memberShape = shape.members[paramName];
          if (memberShape !== void 0) {
            var memberContext = [context, paramName].join(".");
            this.validateMember(memberShape, paramValue, memberContext);
          } else if (paramValue !== void 0 && paramValue !== null) {
            this.fail("UnexpectedParameter", "Unexpected key '" + paramName + "' found in " + context);
          }
        }
        return true;
      },
      validateMember: function validateMember(shape, param, context) {
        switch (shape.type) {
          case "structure":
            return this.validateStructure(shape, param, context);
          case "list":
            return this.validateList(shape, param, context);
          case "map":
            return this.validateMap(shape, param, context);
          default:
            return this.validateScalar(shape, param, context);
        }
      },
      validateList: function validateList(shape, params, context) {
        if (this.validateType(params, context, [Array])) {
          this.validateRange(shape, params.length, context, "list member count");
          for (var i = 0; i < params.length; i++) {
            this.validateMember(shape.member, params[i], context + "[" + i + "]");
          }
        }
      },
      validateMap: function validateMap(shape, params, context) {
        if (this.validateType(params, context, ["object"], "map")) {
          var mapCount = 0;
          for (var param in params) {
            if (!Object.prototype.hasOwnProperty.call(params, param))
              continue;
            this.validateMember(shape.key, param, context + "[key='" + param + "']");
            this.validateMember(shape.value, params[param], context + "['" + param + "']");
            mapCount++;
          }
          this.validateRange(shape, mapCount, context, "map member count");
        }
      },
      validateScalar: function validateScalar(shape, value, context) {
        switch (shape.type) {
          case null:
          case void 0:
          case "string":
            return this.validateString(shape, value, context);
          case "base64":
          case "binary":
            return this.validatePayload(value, context);
          case "integer":
          case "float":
            return this.validateNumber(shape, value, context);
          case "boolean":
            return this.validateType(value, context, ["boolean"]);
          case "timestamp":
            return this.validateType(value, context, [
              Date,
              /^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}(\.\d+)?Z$/,
              "number"
            ], "Date object, ISO-8601 string, or a UNIX timestamp");
          default:
            return this.fail("UnkownType", "Unhandled type " + shape.type + " for " + context);
        }
      },
      validateString: function validateString(shape, value, context) {
        var validTypes = ["string"];
        if (shape.isJsonValue) {
          validTypes = validTypes.concat(["number", "object", "boolean"]);
        }
        if (value !== null && this.validateType(value, context, validTypes)) {
          this.validateEnum(shape, value, context);
          this.validateRange(shape, value.length, context, "string length");
          this.validatePattern(shape, value, context);
          this.validateUri(shape, value, context);
        }
      },
      validateUri: function validateUri(shape, value, context) {
        if (shape["location"] === "uri") {
          if (value.length === 0) {
            this.fail("UriParameterError", 'Expected uri parameter to have length >= 1, but found "' + value + '" for ' + context);
          }
        }
      },
      validatePattern: function validatePattern(shape, value, context) {
        if (this.validation["pattern"] && shape["pattern"] !== void 0) {
          if (!new RegExp(shape["pattern"]).test(value)) {
            this.fail("PatternMatchError", 'Provided value "' + value + '" does not match regex pattern /' + shape["pattern"] + "/ for " + context);
          }
        }
      },
      validateRange: function validateRange(shape, value, context, descriptor) {
        if (this.validation["min"]) {
          if (shape["min"] !== void 0 && value < shape["min"]) {
            this.fail("MinRangeError", "Expected " + descriptor + " >= " + shape["min"] + ", but found " + value + " for " + context);
          }
        }
        if (this.validation["max"]) {
          if (shape["max"] !== void 0 && value > shape["max"]) {
            this.fail("MaxRangeError", "Expected " + descriptor + " <= " + shape["max"] + ", but found " + value + " for " + context);
          }
        }
      },
      validateEnum: function validateRange(shape, value, context) {
        if (this.validation["enum"] && shape["enum"] !== void 0) {
          if (shape["enum"].indexOf(value) === -1) {
            this.fail("EnumError", "Found string value of " + value + ", but expected " + shape["enum"].join("|") + " for " + context);
          }
        }
      },
      validateType: function validateType(value, context, acceptedTypes, type) {
        if (value === null || value === void 0)
          return false;
        var foundInvalidType = false;
        for (var i = 0; i < acceptedTypes.length; i++) {
          if (typeof acceptedTypes[i] === "string") {
            if (typeof value === acceptedTypes[i])
              return true;
          } else if (acceptedTypes[i] instanceof RegExp) {
            if ((value || "").toString().match(acceptedTypes[i]))
              return true;
          } else {
            if (value instanceof acceptedTypes[i])
              return true;
            if (AWS3.util.isType(value, acceptedTypes[i]))
              return true;
            if (!type && !foundInvalidType)
              acceptedTypes = acceptedTypes.slice();
            acceptedTypes[i] = AWS3.util.typeName(acceptedTypes[i]);
          }
          foundInvalidType = true;
        }
        var acceptedType = type;
        if (!acceptedType) {
          acceptedType = acceptedTypes.join(", ").replace(/,([^,]+)$/, ", or$1");
        }
        var vowel = acceptedType.match(/^[aeiou]/i) ? "n" : "";
        this.fail("InvalidParameterType", "Expected " + context + " to be a" + vowel + " " + acceptedType);
        return false;
      },
      validateNumber: function validateNumber(shape, value, context) {
        if (value === null || value === void 0)
          return;
        if (typeof value === "string") {
          var castedValue = parseFloat(value);
          if (castedValue.toString() === value)
            value = castedValue;
        }
        if (this.validateType(value, context, ["number"])) {
          this.validateRange(shape, value, context, "numeric value");
        }
      },
      validatePayload: function validatePayload(value, context) {
        if (value === null || value === void 0)
          return;
        if (typeof value === "string")
          return;
        if (value && typeof value.byteLength === "number")
          return;
        if (AWS3.util.isNode()) {
          var Stream = AWS3.util.stream.Stream;
          if (AWS3.util.Buffer.isBuffer(value) || value instanceof Stream)
            return;
        } else {
          if (typeof Blob !== void 0 && value instanceof Blob)
            return;
        }
        var types = ["Buffer", "Stream", "File", "Blob", "ArrayBuffer", "DataView"];
        if (value) {
          for (var i = 0; i < types.length; i++) {
            if (AWS3.util.isType(value, types[i]))
              return;
            if (AWS3.util.typeName(value.constructor) === types[i])
              return;
          }
        }
        this.fail("InvalidParameterType", "Expected " + context + " to be a string, Buffer, Stream, Blob, or typed array object");
      }
    });
  }
});

// node_modules/aws-sdk/lib/core.js
var require_core = __commonJS({
  "node_modules/aws-sdk/lib/core.js"(exports, module2) {
    var AWS3 = { util: require_util4() };
    var _hidden = {};
    _hidden.toString();
    module2.exports = AWS3;
    AWS3.util.update(AWS3, {
      VERSION: "2.1010.0",
      Signers: {},
      Protocol: {
        Json: require_json3(),
        Query: require_query(),
        Rest: require_rest(),
        RestJson: require_rest_json(),
        RestXml: require_rest_xml()
      },
      XML: {
        Builder: require_builder2(),
        Parser: null
      },
      JSON: {
        Builder: require_builder(),
        Parser: require_parser()
      },
      Model: {
        Api: require_api(),
        Operation: require_operation(),
        Shape: require_shape(),
        Paginator: require_paginator(),
        ResourceWaiter: require_resource_waiter()
      },
      apiLoader: require_api_loader(),
      EndpointCache: require_endpoint_cache().EndpointCache
    });
    require_sequential_executor();
    require_service();
    require_config();
    require_http();
    require_event_listeners();
    require_request();
    require_response();
    require_resource_waiter2();
    require_request_signer();
    require_param_validator();
    AWS3.events = new AWS3.SequentialExecutor();
    AWS3.util.memoizedProperty(AWS3, "endpointCache", function() {
      return new AWS3.EndpointCache(AWS3.config.endpointCacheSize);
    }, true);
  }
});

// node_modules/aws-sdk/node_modules/uuid/lib/rng.js
var require_rng = __commonJS({
  "node_modules/aws-sdk/node_modules/uuid/lib/rng.js"(exports, module2) {
    var crypto = require("crypto");
    module2.exports = function nodeRNG() {
      return crypto.randomBytes(16);
    };
  }
});

// node_modules/aws-sdk/node_modules/uuid/lib/bytesToUuid.js
var require_bytesToUuid = __commonJS({
  "node_modules/aws-sdk/node_modules/uuid/lib/bytesToUuid.js"(exports, module2) {
    var byteToHex = [];
    for (i = 0; i < 256; ++i) {
      byteToHex[i] = (i + 256).toString(16).substr(1);
    }
    var i;
    function bytesToUuid(buf, offset) {
      var i2 = offset || 0;
      var bth = byteToHex;
      return [
        bth[buf[i2++]],
        bth[buf[i2++]],
        bth[buf[i2++]],
        bth[buf[i2++]],
        "-",
        bth[buf[i2++]],
        bth[buf[i2++]],
        "-",
        bth[buf[i2++]],
        bth[buf[i2++]],
        "-",
        bth[buf[i2++]],
        bth[buf[i2++]],
        "-",
        bth[buf[i2++]],
        bth[buf[i2++]],
        bth[buf[i2++]],
        bth[buf[i2++]],
        bth[buf[i2++]],
        bth[buf[i2++]]
      ].join("");
    }
    module2.exports = bytesToUuid;
  }
});

// node_modules/aws-sdk/node_modules/uuid/v1.js
var require_v1 = __commonJS({
  "node_modules/aws-sdk/node_modules/uuid/v1.js"(exports, module2) {
    var rng = require_rng();
    var bytesToUuid = require_bytesToUuid();
    var _nodeId;
    var _clockseq;
    var _lastMSecs = 0;
    var _lastNSecs = 0;
    function v1(options, buf, offset) {
      var i = buf && offset || 0;
      var b = buf || [];
      options = options || {};
      var node = options.node || _nodeId;
      var clockseq = options.clockseq !== void 0 ? options.clockseq : _clockseq;
      if (node == null || clockseq == null) {
        var seedBytes = rng();
        if (node == null) {
          node = _nodeId = [
            seedBytes[0] | 1,
            seedBytes[1],
            seedBytes[2],
            seedBytes[3],
            seedBytes[4],
            seedBytes[5]
          ];
        }
        if (clockseq == null) {
          clockseq = _clockseq = (seedBytes[6] << 8 | seedBytes[7]) & 16383;
        }
      }
      var msecs = options.msecs !== void 0 ? options.msecs : new Date().getTime();
      var nsecs = options.nsecs !== void 0 ? options.nsecs : _lastNSecs + 1;
      var dt = msecs - _lastMSecs + (nsecs - _lastNSecs) / 1e4;
      if (dt < 0 && options.clockseq === void 0) {
        clockseq = clockseq + 1 & 16383;
      }
      if ((dt < 0 || msecs > _lastMSecs) && options.nsecs === void 0) {
        nsecs = 0;
      }
      if (nsecs >= 1e4) {
        throw new Error("uuid.v1(): Can't create more than 10M uuids/sec");
      }
      _lastMSecs = msecs;
      _lastNSecs = nsecs;
      _clockseq = clockseq;
      msecs += 122192928e5;
      var tl = ((msecs & 268435455) * 1e4 + nsecs) % 4294967296;
      b[i++] = tl >>> 24 & 255;
      b[i++] = tl >>> 16 & 255;
      b[i++] = tl >>> 8 & 255;
      b[i++] = tl & 255;
      var tmh = msecs / 4294967296 * 1e4 & 268435455;
      b[i++] = tmh >>> 8 & 255;
      b[i++] = tmh & 255;
      b[i++] = tmh >>> 24 & 15 | 16;
      b[i++] = tmh >>> 16 & 255;
      b[i++] = clockseq >>> 8 | 128;
      b[i++] = clockseq & 255;
      for (var n = 0; n < 6; ++n) {
        b[i + n] = node[n];
      }
      return buf ? buf : bytesToUuid(b);
    }
    module2.exports = v1;
  }
});

// node_modules/aws-sdk/node_modules/uuid/v4.js
var require_v42 = __commonJS({
  "node_modules/aws-sdk/node_modules/uuid/v4.js"(exports, module2) {
    var rng = require_rng();
    var bytesToUuid = require_bytesToUuid();
    function v4(options, buf, offset) {
      var i = buf && offset || 0;
      if (typeof options == "string") {
        buf = options === "binary" ? new Array(16) : null;
        options = null;
      }
      options = options || {};
      var rnds = options.random || (options.rng || rng)();
      rnds[6] = rnds[6] & 15 | 64;
      rnds[8] = rnds[8] & 63 | 128;
      if (buf) {
        for (var ii = 0; ii < 16; ++ii) {
          buf[i + ii] = rnds[ii];
        }
      }
      return buf || bytesToUuid(rnds);
    }
    module2.exports = v4;
  }
});

// node_modules/aws-sdk/node_modules/uuid/index.js
var require_uuid = __commonJS({
  "node_modules/aws-sdk/node_modules/uuid/index.js"(exports, module2) {
    var v1 = require_v1();
    var v4 = require_v42();
    var uuid = v4;
    uuid.v1 = v1;
    uuid.v4 = v4;
    module2.exports = uuid;
  }
});

// node_modules/aws-sdk/lib/util.js
var require_util4 = __commonJS({
  "node_modules/aws-sdk/lib/util.js"(exports, module2) {
    var AWS3;
    var util = {
      environment: "nodejs",
      engine: function engine() {
        if (util.isBrowser() && typeof navigator !== "undefined") {
          return navigator.userAgent;
        } else {
          var engine2 = process.platform + "/" + process.version;
          if (process.env.AWS_EXECUTION_ENV) {
            engine2 += " exec-env/" + process.env.AWS_EXECUTION_ENV;
          }
          return engine2;
        }
      },
      userAgent: function userAgent() {
        var name = util.environment;
        var agent = "aws-sdk-" + name + "/" + require_core().VERSION;
        if (name === "nodejs")
          agent += " " + util.engine();
        return agent;
      },
      uriEscape: function uriEscape(string) {
        var output = encodeURIComponent(string);
        output = output.replace(/[^A-Za-z0-9_.~\-%]+/g, escape);
        output = output.replace(/[*]/g, function(ch) {
          return "%" + ch.charCodeAt(0).toString(16).toUpperCase();
        });
        return output;
      },
      uriEscapePath: function uriEscapePath(string) {
        var parts = [];
        util.arrayEach(string.split("/"), function(part) {
          parts.push(util.uriEscape(part));
        });
        return parts.join("/");
      },
      urlParse: function urlParse(url) {
        return util.url.parse(url);
      },
      urlFormat: function urlFormat(url) {
        return util.url.format(url);
      },
      queryStringParse: function queryStringParse(qs) {
        return util.querystring.parse(qs);
      },
      queryParamsToString: function queryParamsToString(params) {
        var items = [];
        var escape2 = util.uriEscape;
        var sortedKeys = Object.keys(params).sort();
        util.arrayEach(sortedKeys, function(name) {
          var value = params[name];
          var ename = escape2(name);
          var result = ename + "=";
          if (Array.isArray(value)) {
            var vals = [];
            util.arrayEach(value, function(item) {
              vals.push(escape2(item));
            });
            result = ename + "=" + vals.sort().join("&" + ename + "=");
          } else if (value !== void 0 && value !== null) {
            result = ename + "=" + escape2(value);
          }
          items.push(result);
        });
        return items.join("&");
      },
      readFileSync: function readFileSync(path2) {
        if (util.isBrowser())
          return null;
        return require("fs").readFileSync(path2, "utf-8");
      },
      base64: {
        encode: function encode64(string) {
          if (typeof string === "number") {
            throw util.error(new Error("Cannot base64 encode number " + string));
          }
          if (string === null || typeof string === "undefined") {
            return string;
          }
          var buf = util.buffer.toBuffer(string);
          return buf.toString("base64");
        },
        decode: function decode64(string) {
          if (typeof string === "number") {
            throw util.error(new Error("Cannot base64 decode number " + string));
          }
          if (string === null || typeof string === "undefined") {
            return string;
          }
          return util.buffer.toBuffer(string, "base64");
        }
      },
      buffer: {
        toBuffer: function(data, encoding) {
          return typeof util.Buffer.from === "function" && util.Buffer.from !== Uint8Array.from ? util.Buffer.from(data, encoding) : new util.Buffer(data, encoding);
        },
        alloc: function(size, fill, encoding) {
          if (typeof size !== "number") {
            throw new Error("size passed to alloc must be a number.");
          }
          if (typeof util.Buffer.alloc === "function") {
            return util.Buffer.alloc(size, fill, encoding);
          } else {
            var buf = new util.Buffer(size);
            if (fill !== void 0 && typeof buf.fill === "function") {
              buf.fill(fill, void 0, void 0, encoding);
            }
            return buf;
          }
        },
        toStream: function toStream(buffer) {
          if (!util.Buffer.isBuffer(buffer))
            buffer = util.buffer.toBuffer(buffer);
          var readable = new util.stream.Readable();
          var pos = 0;
          readable._read = function(size) {
            if (pos >= buffer.length)
              return readable.push(null);
            var end = pos + size;
            if (end > buffer.length)
              end = buffer.length;
            readable.push(buffer.slice(pos, end));
            pos = end;
          };
          return readable;
        },
        concat: function(buffers) {
          var length = 0, offset = 0, buffer = null, i;
          for (i = 0; i < buffers.length; i++) {
            length += buffers[i].length;
          }
          buffer = util.buffer.alloc(length);
          for (i = 0; i < buffers.length; i++) {
            buffers[i].copy(buffer, offset);
            offset += buffers[i].length;
          }
          return buffer;
        }
      },
      string: {
        byteLength: function byteLength(string) {
          if (string === null || string === void 0)
            return 0;
          if (typeof string === "string")
            string = util.buffer.toBuffer(string);
          if (typeof string.byteLength === "number") {
            return string.byteLength;
          } else if (typeof string.length === "number") {
            return string.length;
          } else if (typeof string.size === "number") {
            return string.size;
          } else if (typeof string.path === "string") {
            return require("fs").lstatSync(string.path).size;
          } else {
            throw util.error(new Error("Cannot determine length of " + string), { object: string });
          }
        },
        upperFirst: function upperFirst(string) {
          return string[0].toUpperCase() + string.substr(1);
        },
        lowerFirst: function lowerFirst(string) {
          return string[0].toLowerCase() + string.substr(1);
        }
      },
      ini: {
        parse: function string(ini) {
          var currentSection, map = {};
          util.arrayEach(ini.split(/\r?\n/), function(line) {
            line = line.split(/(^|\s)[;#]/)[0];
            var section = line.match(/^\s*\[([^\[\]]+)\]\s*$/);
            if (section) {
              currentSection = section[1];
              if (currentSection === "__proto__" || currentSection.split(/\s/)[1] === "__proto__") {
                throw util.error(new Error("Cannot load profile name '" + currentSection + "' from shared ini file."));
              }
            } else if (currentSection) {
              var item = line.match(/^\s*(.+?)\s*=\s*(.+?)\s*$/);
              if (item) {
                map[currentSection] = map[currentSection] || {};
                map[currentSection][item[1]] = item[2];
              }
            }
          });
          return map;
        }
      },
      fn: {
        noop: function() {
        },
        callback: function(err) {
          if (err)
            throw err;
        },
        makeAsync: function makeAsync(fn, expectedArgs) {
          if (expectedArgs && expectedArgs <= fn.length) {
            return fn;
          }
          return function() {
            var args = Array.prototype.slice.call(arguments, 0);
            var callback = args.pop();
            var result = fn.apply(null, args);
            callback(result);
          };
        }
      },
      date: {
        getDate: function getDate() {
          if (!AWS3)
            AWS3 = require_core();
          if (AWS3.config.systemClockOffset) {
            return new Date(new Date().getTime() + AWS3.config.systemClockOffset);
          } else {
            return new Date();
          }
        },
        iso8601: function iso8601(date) {
          if (date === void 0) {
            date = util.date.getDate();
          }
          return date.toISOString().replace(/\.\d{3}Z$/, "Z");
        },
        rfc822: function rfc822(date) {
          if (date === void 0) {
            date = util.date.getDate();
          }
          return date.toUTCString();
        },
        unixTimestamp: function unixTimestamp(date) {
          if (date === void 0) {
            date = util.date.getDate();
          }
          return date.getTime() / 1e3;
        },
        from: function format(date) {
          if (typeof date === "number") {
            return new Date(date * 1e3);
          } else {
            return new Date(date);
          }
        },
        format: function format(date, formatter) {
          if (!formatter)
            formatter = "iso8601";
          return util.date[formatter](util.date.from(date));
        },
        parseTimestamp: function parseTimestamp(value) {
          if (typeof value === "number") {
            return new Date(value * 1e3);
          } else if (value.match(/^\d+$/)) {
            return new Date(value * 1e3);
          } else if (value.match(/^\d{4}/)) {
            return new Date(value);
          } else if (value.match(/^\w{3},/)) {
            return new Date(value);
          } else {
            throw util.error(new Error("unhandled timestamp format: " + value), { code: "TimestampParserError" });
          }
        }
      },
      crypto: {
        crc32Table: [
          0,
          1996959894,
          3993919788,
          2567524794,
          124634137,
          1886057615,
          3915621685,
          2657392035,
          249268274,
          2044508324,
          3772115230,
          2547177864,
          162941995,
          2125561021,
          3887607047,
          2428444049,
          498536548,
          1789927666,
          4089016648,
          2227061214,
          450548861,
          1843258603,
          4107580753,
          2211677639,
          325883990,
          1684777152,
          4251122042,
          2321926636,
          335633487,
          1661365465,
          4195302755,
          2366115317,
          997073096,
          1281953886,
          3579855332,
          2724688242,
          1006888145,
          1258607687,
          3524101629,
          2768942443,
          901097722,
          1119000684,
          3686517206,
          2898065728,
          853044451,
          1172266101,
          3705015759,
          2882616665,
          651767980,
          1373503546,
          3369554304,
          3218104598,
          565507253,
          1454621731,
          3485111705,
          3099436303,
          671266974,
          1594198024,
          3322730930,
          2970347812,
          795835527,
          1483230225,
          3244367275,
          3060149565,
          1994146192,
          31158534,
          2563907772,
          4023717930,
          1907459465,
          112637215,
          2680153253,
          3904427059,
          2013776290,
          251722036,
          2517215374,
          3775830040,
          2137656763,
          141376813,
          2439277719,
          3865271297,
          1802195444,
          476864866,
          2238001368,
          4066508878,
          1812370925,
          453092731,
          2181625025,
          4111451223,
          1706088902,
          314042704,
          2344532202,
          4240017532,
          1658658271,
          366619977,
          2362670323,
          4224994405,
          1303535960,
          984961486,
          2747007092,
          3569037538,
          1256170817,
          1037604311,
          2765210733,
          3554079995,
          1131014506,
          879679996,
          2909243462,
          3663771856,
          1141124467,
          855842277,
          2852801631,
          3708648649,
          1342533948,
          654459306,
          3188396048,
          3373015174,
          1466479909,
          544179635,
          3110523913,
          3462522015,
          1591671054,
          702138776,
          2966460450,
          3352799412,
          1504918807,
          783551873,
          3082640443,
          3233442989,
          3988292384,
          2596254646,
          62317068,
          1957810842,
          3939845945,
          2647816111,
          81470997,
          1943803523,
          3814918930,
          2489596804,
          225274430,
          2053790376,
          3826175755,
          2466906013,
          167816743,
          2097651377,
          4027552580,
          2265490386,
          503444072,
          1762050814,
          4150417245,
          2154129355,
          426522225,
          1852507879,
          4275313526,
          2312317920,
          282753626,
          1742555852,
          4189708143,
          2394877945,
          397917763,
          1622183637,
          3604390888,
          2714866558,
          953729732,
          1340076626,
          3518719985,
          2797360999,
          1068828381,
          1219638859,
          3624741850,
          2936675148,
          906185462,
          1090812512,
          3747672003,
          2825379669,
          829329135,
          1181335161,
          3412177804,
          3160834842,
          628085408,
          1382605366,
          3423369109,
          3138078467,
          570562233,
          1426400815,
          3317316542,
          2998733608,
          733239954,
          1555261956,
          3268935591,
          3050360625,
          752459403,
          1541320221,
          2607071920,
          3965973030,
          1969922972,
          40735498,
          2617837225,
          3943577151,
          1913087877,
          83908371,
          2512341634,
          3803740692,
          2075208622,
          213261112,
          2463272603,
          3855990285,
          2094854071,
          198958881,
          2262029012,
          4057260610,
          1759359992,
          534414190,
          2176718541,
          4139329115,
          1873836001,
          414664567,
          2282248934,
          4279200368,
          1711684554,
          285281116,
          2405801727,
          4167216745,
          1634467795,
          376229701,
          2685067896,
          3608007406,
          1308918612,
          956543938,
          2808555105,
          3495958263,
          1231636301,
          1047427035,
          2932959818,
          3654703836,
          1088359270,
          936918e3,
          2847714899,
          3736837829,
          1202900863,
          817233897,
          3183342108,
          3401237130,
          1404277552,
          615818150,
          3134207493,
          3453421203,
          1423857449,
          601450431,
          3009837614,
          3294710456,
          1567103746,
          711928724,
          3020668471,
          3272380065,
          1510334235,
          755167117
        ],
        crc32: function crc32(data) {
          var tbl = util.crypto.crc32Table;
          var crc = 0 ^ -1;
          if (typeof data === "string") {
            data = util.buffer.toBuffer(data);
          }
          for (var i = 0; i < data.length; i++) {
            var code = data.readUInt8(i);
            crc = crc >>> 8 ^ tbl[(crc ^ code) & 255];
          }
          return (crc ^ -1) >>> 0;
        },
        hmac: function hmac(key, string, digest, fn) {
          if (!digest)
            digest = "binary";
          if (digest === "buffer") {
            digest = void 0;
          }
          if (!fn)
            fn = "sha256";
          if (typeof string === "string")
            string = util.buffer.toBuffer(string);
          return util.crypto.lib.createHmac(fn, key).update(string).digest(digest);
        },
        md5: function md5(data, digest, callback) {
          return util.crypto.hash("md5", data, digest, callback);
        },
        sha256: function sha256(data, digest, callback) {
          return util.crypto.hash("sha256", data, digest, callback);
        },
        hash: function(algorithm, data, digest, callback) {
          var hash = util.crypto.createHash(algorithm);
          if (!digest) {
            digest = "binary";
          }
          if (digest === "buffer") {
            digest = void 0;
          }
          if (typeof data === "string")
            data = util.buffer.toBuffer(data);
          var sliceFn = util.arraySliceFn(data);
          var isBuffer = util.Buffer.isBuffer(data);
          if (util.isBrowser() && typeof ArrayBuffer !== "undefined" && data && data.buffer instanceof ArrayBuffer)
            isBuffer = true;
          if (callback && typeof data === "object" && typeof data.on === "function" && !isBuffer) {
            data.on("data", function(chunk) {
              hash.update(chunk);
            });
            data.on("error", function(err) {
              callback(err);
            });
            data.on("end", function() {
              callback(null, hash.digest(digest));
            });
          } else if (callback && sliceFn && !isBuffer && typeof FileReader !== "undefined") {
            var index = 0, size = 1024 * 512;
            var reader = new FileReader();
            reader.onerror = function() {
              callback(new Error("Failed to read data."));
            };
            reader.onload = function() {
              var buf = new util.Buffer(new Uint8Array(reader.result));
              hash.update(buf);
              index += buf.length;
              reader._continueReading();
            };
            reader._continueReading = function() {
              if (index >= data.size) {
                callback(null, hash.digest(digest));
                return;
              }
              var back = index + size;
              if (back > data.size)
                back = data.size;
              reader.readAsArrayBuffer(sliceFn.call(data, index, back));
            };
            reader._continueReading();
          } else {
            if (util.isBrowser() && typeof data === "object" && !isBuffer) {
              data = new util.Buffer(new Uint8Array(data));
            }
            var out = hash.update(data).digest(digest);
            if (callback)
              callback(null, out);
            return out;
          }
        },
        toHex: function toHex(data) {
          var out = [];
          for (var i = 0; i < data.length; i++) {
            out.push(("0" + data.charCodeAt(i).toString(16)).substr(-2, 2));
          }
          return out.join("");
        },
        createHash: function createHash(algorithm) {
          return util.crypto.lib.createHash(algorithm);
        }
      },
      abort: {},
      each: function each(object, iterFunction) {
        for (var key in object) {
          if (Object.prototype.hasOwnProperty.call(object, key)) {
            var ret = iterFunction.call(this, key, object[key]);
            if (ret === util.abort)
              break;
          }
        }
      },
      arrayEach: function arrayEach(array, iterFunction) {
        for (var idx in array) {
          if (Object.prototype.hasOwnProperty.call(array, idx)) {
            var ret = iterFunction.call(this, array[idx], parseInt(idx, 10));
            if (ret === util.abort)
              break;
          }
        }
      },
      update: function update(obj1, obj2) {
        util.each(obj2, function iterator(key, item) {
          obj1[key] = item;
        });
        return obj1;
      },
      merge: function merge(obj1, obj2) {
        return util.update(util.copy(obj1), obj2);
      },
      copy: function copy(object) {
        if (object === null || object === void 0)
          return object;
        var dupe = {};
        for (var key in object) {
          dupe[key] = object[key];
        }
        return dupe;
      },
      isEmpty: function isEmpty(obj) {
        for (var prop in obj) {
          if (Object.prototype.hasOwnProperty.call(obj, prop)) {
            return false;
          }
        }
        return true;
      },
      arraySliceFn: function arraySliceFn(obj) {
        var fn = obj.slice || obj.webkitSlice || obj.mozSlice;
        return typeof fn === "function" ? fn : null;
      },
      isType: function isType(obj, type) {
        if (typeof type === "function")
          type = util.typeName(type);
        return Object.prototype.toString.call(obj) === "[object " + type + "]";
      },
      typeName: function typeName(type) {
        if (Object.prototype.hasOwnProperty.call(type, "name"))
          return type.name;
        var str = type.toString();
        var match = str.match(/^\s*function (.+)\(/);
        return match ? match[1] : str;
      },
      error: function error(err, options) {
        var originalError = null;
        if (typeof err.message === "string" && err.message !== "") {
          if (typeof options === "string" || options && options.message) {
            originalError = util.copy(err);
            originalError.message = err.message;
          }
        }
        err.message = err.message || null;
        if (typeof options === "string") {
          err.message = options;
        } else if (typeof options === "object" && options !== null) {
          util.update(err, options);
          if (options.message)
            err.message = options.message;
          if (options.code || options.name)
            err.code = options.code || options.name;
          if (options.stack)
            err.stack = options.stack;
        }
        if (typeof Object.defineProperty === "function") {
          Object.defineProperty(err, "name", { writable: true, enumerable: false });
          Object.defineProperty(err, "message", { enumerable: true });
        }
        err.name = String(options && options.name || err.name || err.code || "Error");
        err.time = new Date();
        if (originalError)
          err.originalError = originalError;
        return err;
      },
      inherit: function inherit(klass, features) {
        var newObject = null;
        if (features === void 0) {
          features = klass;
          klass = Object;
          newObject = {};
        } else {
          var ctor = function ConstructorWrapper() {
          };
          ctor.prototype = klass.prototype;
          newObject = new ctor();
        }
        if (features.constructor === Object) {
          features.constructor = function() {
            if (klass !== Object) {
              return klass.apply(this, arguments);
            }
          };
        }
        features.constructor.prototype = newObject;
        util.update(features.constructor.prototype, features);
        features.constructor.__super__ = klass;
        return features.constructor;
      },
      mixin: function mixin() {
        var klass = arguments[0];
        for (var i = 1; i < arguments.length; i++) {
          for (var prop in arguments[i].prototype) {
            var fn = arguments[i].prototype[prop];
            if (prop !== "constructor") {
              klass.prototype[prop] = fn;
            }
          }
        }
        return klass;
      },
      hideProperties: function hideProperties(obj, props) {
        if (typeof Object.defineProperty !== "function")
          return;
        util.arrayEach(props, function(key) {
          Object.defineProperty(obj, key, {
            enumerable: false,
            writable: true,
            configurable: true
          });
        });
      },
      property: function property(obj, name, value, enumerable, isValue) {
        var opts = {
          configurable: true,
          enumerable: enumerable !== void 0 ? enumerable : true
        };
        if (typeof value === "function" && !isValue) {
          opts.get = value;
        } else {
          opts.value = value;
          opts.writable = true;
        }
        Object.defineProperty(obj, name, opts);
      },
      memoizedProperty: function memoizedProperty(obj, name, get, enumerable) {
        var cachedValue = null;
        util.property(obj, name, function() {
          if (cachedValue === null) {
            cachedValue = get();
          }
          return cachedValue;
        }, enumerable);
      },
      hoistPayloadMember: function hoistPayloadMember(resp) {
        var req = resp.request;
        var operationName = req.operation;
        var operation = req.service.api.operations[operationName];
        var output = operation.output;
        if (output.payload && !operation.hasEventOutput) {
          var payloadMember = output.members[output.payload];
          var responsePayload = resp.data[output.payload];
          if (payloadMember.type === "structure") {
            util.each(responsePayload, function(key, value) {
              util.property(resp.data, key, value, false);
            });
          }
        }
      },
      computeSha256: function computeSha256(body, done) {
        if (util.isNode()) {
          var Stream = util.stream.Stream;
          var fs2 = require("fs");
          if (typeof Stream === "function" && body instanceof Stream) {
            if (typeof body.path === "string") {
              var settings = {};
              if (typeof body.start === "number") {
                settings.start = body.start;
              }
              if (typeof body.end === "number") {
                settings.end = body.end;
              }
              body = fs2.createReadStream(body.path, settings);
            } else {
              return done(new Error("Non-file stream objects are not supported with SigV4"));
            }
          }
        }
        util.crypto.sha256(body, "hex", function(err, sha) {
          if (err)
            done(err);
          else
            done(null, sha);
        });
      },
      isClockSkewed: function isClockSkewed(serverTime) {
        if (serverTime) {
          util.property(AWS3.config, "isClockSkewed", Math.abs(new Date().getTime() - serverTime) >= 3e5, false);
          return AWS3.config.isClockSkewed;
        }
      },
      applyClockOffset: function applyClockOffset(serverTime) {
        if (serverTime)
          AWS3.config.systemClockOffset = serverTime - new Date().getTime();
      },
      extractRequestId: function extractRequestId(resp) {
        var requestId = resp.httpResponse.headers["x-amz-request-id"] || resp.httpResponse.headers["x-amzn-requestid"];
        if (!requestId && resp.data && resp.data.ResponseMetadata) {
          requestId = resp.data.ResponseMetadata.RequestId;
        }
        if (requestId) {
          resp.requestId = requestId;
        }
        if (resp.error) {
          resp.error.requestId = requestId;
        }
      },
      addPromises: function addPromises(constructors, PromiseDependency) {
        var deletePromises = false;
        if (PromiseDependency === void 0 && AWS3 && AWS3.config) {
          PromiseDependency = AWS3.config.getPromisesDependency();
        }
        if (PromiseDependency === void 0 && typeof Promise !== "undefined") {
          PromiseDependency = Promise;
        }
        if (typeof PromiseDependency !== "function")
          deletePromises = true;
        if (!Array.isArray(constructors))
          constructors = [constructors];
        for (var ind = 0; ind < constructors.length; ind++) {
          var constructor = constructors[ind];
          if (deletePromises) {
            if (constructor.deletePromisesFromClass) {
              constructor.deletePromisesFromClass();
            }
          } else if (constructor.addPromisesToClass) {
            constructor.addPromisesToClass(PromiseDependency);
          }
        }
      },
      promisifyMethod: function promisifyMethod(methodName, PromiseDependency) {
        return function promise() {
          var self2 = this;
          var args = Array.prototype.slice.call(arguments);
          return new PromiseDependency(function(resolve, reject) {
            args.push(function(err, data) {
              if (err) {
                reject(err);
              } else {
                resolve(data);
              }
            });
            self2[methodName].apply(self2, args);
          });
        };
      },
      isDualstackAvailable: function isDualstackAvailable(service) {
        if (!service)
          return false;
        var metadata = require_metadata();
        if (typeof service !== "string")
          service = service.serviceIdentifier;
        if (typeof service !== "string" || !metadata.hasOwnProperty(service))
          return false;
        return !!metadata[service].dualstackAvailable;
      },
      calculateRetryDelay: function calculateRetryDelay(retryCount, retryDelayOptions, err) {
        if (!retryDelayOptions)
          retryDelayOptions = {};
        var customBackoff = retryDelayOptions.customBackoff || null;
        if (typeof customBackoff === "function") {
          return customBackoff(retryCount, err);
        }
        var base = typeof retryDelayOptions.base === "number" ? retryDelayOptions.base : 100;
        var delay = Math.random() * (Math.pow(2, retryCount) * base);
        return delay;
      },
      handleRequestWithRetries: function handleRequestWithRetries(httpRequest, options, cb) {
        if (!options)
          options = {};
        var http = AWS3.HttpClient.getInstance();
        var httpOptions = options.httpOptions || {};
        var retryCount = 0;
        var errCallback = function(err) {
          var maxRetries = options.maxRetries || 0;
          if (err && err.code === "TimeoutError")
            err.retryable = true;
          if (err && err.retryable && retryCount < maxRetries) {
            var delay = util.calculateRetryDelay(retryCount, options.retryDelayOptions, err);
            if (delay >= 0) {
              retryCount++;
              setTimeout(sendRequest, delay + (err.retryAfter || 0));
              return;
            }
          }
          cb(err);
        };
        var sendRequest = function() {
          var data = "";
          http.handleRequest(httpRequest, httpOptions, function(httpResponse) {
            httpResponse.on("data", function(chunk) {
              data += chunk.toString();
            });
            httpResponse.on("end", function() {
              var statusCode = httpResponse.statusCode;
              if (statusCode < 300) {
                cb(null, data);
              } else {
                var retryAfter = parseInt(httpResponse.headers["retry-after"], 10) * 1e3 || 0;
                var err = util.error(new Error(), {
                  statusCode,
                  retryable: statusCode >= 500 || statusCode === 429
                });
                if (retryAfter && err.retryable)
                  err.retryAfter = retryAfter;
                errCallback(err);
              }
            });
          }, errCallback);
        };
        AWS3.util.defer(sendRequest);
      },
      uuid: {
        v4: function uuidV4() {
          return require_uuid().v4();
        }
      },
      convertPayloadToString: function convertPayloadToString(resp) {
        var req = resp.request;
        var operation = req.operation;
        var rules = req.service.api.operations[operation].output || {};
        if (rules.payload && resp.data[rules.payload]) {
          resp.data[rules.payload] = resp.data[rules.payload].toString();
        }
      },
      defer: function defer(callback) {
        if (typeof process === "object" && typeof process.nextTick === "function") {
          process.nextTick(callback);
        } else if (typeof setImmediate === "function") {
          setImmediate(callback);
        } else {
          setTimeout(callback, 0);
        }
      },
      getRequestPayloadShape: function getRequestPayloadShape(req) {
        var operations = req.service.api.operations;
        if (!operations)
          return void 0;
        var operation = (operations || {})[req.operation];
        if (!operation || !operation.input || !operation.input.payload)
          return void 0;
        return operation.input.members[operation.input.payload];
      },
      getProfilesFromSharedConfig: function getProfilesFromSharedConfig(iniLoader, filename) {
        var profiles = {};
        var profilesFromConfig = {};
        if (process.env[util.configOptInEnv]) {
          var profilesFromConfig = iniLoader.loadFrom({
            isConfig: true,
            filename: process.env[util.sharedConfigFileEnv]
          });
        }
        var profilesFromCreds = {};
        try {
          var profilesFromCreds = iniLoader.loadFrom({
            filename: filename || process.env[util.configOptInEnv] && process.env[util.sharedCredentialsFileEnv]
          });
        } catch (error) {
          if (!process.env[util.configOptInEnv])
            throw error;
        }
        for (var i = 0, profileNames = Object.keys(profilesFromConfig); i < profileNames.length; i++) {
          profiles[profileNames[i]] = objectAssign(profiles[profileNames[i]] || {}, profilesFromConfig[profileNames[i]]);
        }
        for (var i = 0, profileNames = Object.keys(profilesFromCreds); i < profileNames.length; i++) {
          profiles[profileNames[i]] = objectAssign(profiles[profileNames[i]] || {}, profilesFromCreds[profileNames[i]]);
        }
        return profiles;
        function objectAssign(target, source) {
          for (var i2 = 0, keys = Object.keys(source); i2 < keys.length; i2++) {
            target[keys[i2]] = source[keys[i2]];
          }
          return target;
        }
      },
      ARN: {
        validate: function validateARN(str) {
          return str && str.indexOf("arn:") === 0 && str.split(":").length >= 6;
        },
        parse: function parseARN(arn) {
          var matched = arn.split(":");
          return {
            partition: matched[1],
            service: matched[2],
            region: matched[3],
            accountId: matched[4],
            resource: matched.slice(5).join(":")
          };
        },
        build: function buildARN(arnObject) {
          if (arnObject.service === void 0 || arnObject.region === void 0 || arnObject.accountId === void 0 || arnObject.resource === void 0)
            throw util.error(new Error("Input ARN object is invalid"));
          return "arn:" + (arnObject.partition || "aws") + ":" + arnObject.service + ":" + arnObject.region + ":" + arnObject.accountId + ":" + arnObject.resource;
        }
      },
      defaultProfile: "default",
      configOptInEnv: "AWS_SDK_LOAD_CONFIG",
      sharedCredentialsFileEnv: "AWS_SHARED_CREDENTIALS_FILE",
      sharedConfigFileEnv: "AWS_CONFIG_FILE",
      imdsDisabledEnv: "AWS_EC2_METADATA_DISABLED"
    };
    module2.exports = util;
  }
});

// node_modules/aws-sdk/lib/event-stream/event-message-chunker-stream.js
var require_event_message_chunker_stream = __commonJS({
  "node_modules/aws-sdk/lib/event-stream/event-message-chunker-stream.js"(exports, module2) {
    var util = require_core().util;
    var Transform = require("stream").Transform;
    var allocBuffer = util.buffer.alloc;
    function EventMessageChunkerStream(options) {
      Transform.call(this, options);
      this.currentMessageTotalLength = 0;
      this.currentMessagePendingLength = 0;
      this.currentMessage = null;
      this.messageLengthBuffer = null;
    }
    EventMessageChunkerStream.prototype = Object.create(Transform.prototype);
    EventMessageChunkerStream.prototype._transform = function(chunk, encoding, callback) {
      var chunkLength = chunk.length;
      var currentOffset = 0;
      while (currentOffset < chunkLength) {
        if (!this.currentMessage) {
          var bytesRemaining = chunkLength - currentOffset;
          if (!this.messageLengthBuffer) {
            this.messageLengthBuffer = allocBuffer(4);
          }
          var numBytesForTotal = Math.min(4 - this.currentMessagePendingLength, bytesRemaining);
          chunk.copy(this.messageLengthBuffer, this.currentMessagePendingLength, currentOffset, currentOffset + numBytesForTotal);
          this.currentMessagePendingLength += numBytesForTotal;
          currentOffset += numBytesForTotal;
          if (this.currentMessagePendingLength < 4) {
            break;
          }
          this.allocateMessage(this.messageLengthBuffer.readUInt32BE(0));
          this.messageLengthBuffer = null;
        }
        var numBytesToWrite = Math.min(this.currentMessageTotalLength - this.currentMessagePendingLength, chunkLength - currentOffset);
        chunk.copy(this.currentMessage, this.currentMessagePendingLength, currentOffset, currentOffset + numBytesToWrite);
        this.currentMessagePendingLength += numBytesToWrite;
        currentOffset += numBytesToWrite;
        if (this.currentMessageTotalLength && this.currentMessageTotalLength === this.currentMessagePendingLength) {
          this.push(this.currentMessage);
          this.currentMessage = null;
          this.currentMessageTotalLength = 0;
          this.currentMessagePendingLength = 0;
        }
      }
      callback();
    };
    EventMessageChunkerStream.prototype._flush = function(callback) {
      if (this.currentMessageTotalLength) {
        if (this.currentMessageTotalLength === this.currentMessagePendingLength) {
          callback(null, this.currentMessage);
        } else {
          callback(new Error("Truncated event message received."));
        }
      } else {
        callback();
      }
    };
    EventMessageChunkerStream.prototype.allocateMessage = function(size) {
      if (typeof size !== "number") {
        throw new Error("Attempted to allocate an event message where size was not a number: " + size);
      }
      this.currentMessageTotalLength = size;
      this.currentMessagePendingLength = 4;
      this.currentMessage = allocBuffer(size);
      this.currentMessage.writeUInt32BE(size, 0);
    };
    module2.exports = {
      EventMessageChunkerStream
    };
  }
});

// node_modules/aws-sdk/lib/event-stream/int64.js
var require_int64 = __commonJS({
  "node_modules/aws-sdk/lib/event-stream/int64.js"(exports, module2) {
    var util = require_core().util;
    var toBuffer = util.buffer.toBuffer;
    function Int64(bytes) {
      if (bytes.length !== 8) {
        throw new Error("Int64 buffers must be exactly 8 bytes");
      }
      if (!util.Buffer.isBuffer(bytes))
        bytes = toBuffer(bytes);
      this.bytes = bytes;
    }
    Int64.fromNumber = function(number) {
      if (number > 9223372036854776e3 || number < -9223372036854776e3) {
        throw new Error(number + " is too large (or, if negative, too small) to represent as an Int64");
      }
      var bytes = new Uint8Array(8);
      for (var i = 7, remaining = Math.abs(Math.round(number)); i > -1 && remaining > 0; i--, remaining /= 256) {
        bytes[i] = remaining;
      }
      if (number < 0) {
        negate(bytes);
      }
      return new Int64(bytes);
    };
    Int64.prototype.valueOf = function() {
      var bytes = this.bytes.slice(0);
      var negative = bytes[0] & 128;
      if (negative) {
        negate(bytes);
      }
      return parseInt(bytes.toString("hex"), 16) * (negative ? -1 : 1);
    };
    Int64.prototype.toString = function() {
      return String(this.valueOf());
    };
    function negate(bytes) {
      for (var i = 0; i < 8; i++) {
        bytes[i] ^= 255;
      }
      for (var i = 7; i > -1; i--) {
        bytes[i]++;
        if (bytes[i] !== 0) {
          break;
        }
      }
    }
    module2.exports = {
      Int64
    };
  }
});

// node_modules/aws-sdk/lib/event-stream/split-message.js
var require_split_message = __commonJS({
  "node_modules/aws-sdk/lib/event-stream/split-message.js"(exports, module2) {
    var util = require_core().util;
    var toBuffer = util.buffer.toBuffer;
    var PRELUDE_MEMBER_LENGTH = 4;
    var PRELUDE_LENGTH = PRELUDE_MEMBER_LENGTH * 2;
    var CHECKSUM_LENGTH = 4;
    var MINIMUM_MESSAGE_LENGTH = PRELUDE_LENGTH + CHECKSUM_LENGTH * 2;
    function splitMessage(message) {
      if (!util.Buffer.isBuffer(message))
        message = toBuffer(message);
      if (message.length < MINIMUM_MESSAGE_LENGTH) {
        throw new Error("Provided message too short to accommodate event stream message overhead");
      }
      if (message.length !== message.readUInt32BE(0)) {
        throw new Error("Reported message length does not match received message length");
      }
      var expectedPreludeChecksum = message.readUInt32BE(PRELUDE_LENGTH);
      if (expectedPreludeChecksum !== util.crypto.crc32(message.slice(0, PRELUDE_LENGTH))) {
        throw new Error("The prelude checksum specified in the message (" + expectedPreludeChecksum + ") does not match the calculated CRC32 checksum.");
      }
      var expectedMessageChecksum = message.readUInt32BE(message.length - CHECKSUM_LENGTH);
      if (expectedMessageChecksum !== util.crypto.crc32(message.slice(0, message.length - CHECKSUM_LENGTH))) {
        throw new Error("The message checksum did not match the expected value of " + expectedMessageChecksum);
      }
      var headersStart = PRELUDE_LENGTH + CHECKSUM_LENGTH;
      var headersEnd = headersStart + message.readUInt32BE(PRELUDE_MEMBER_LENGTH);
      return {
        headers: message.slice(headersStart, headersEnd),
        body: message.slice(headersEnd, message.length - CHECKSUM_LENGTH)
      };
    }
    module2.exports = {
      splitMessage
    };
  }
});

// node_modules/aws-sdk/lib/event-stream/parse-message.js
var require_parse_message = __commonJS({
  "node_modules/aws-sdk/lib/event-stream/parse-message.js"(exports, module2) {
    var Int64 = require_int64().Int64;
    var splitMessage = require_split_message().splitMessage;
    var BOOLEAN_TAG = "boolean";
    var BYTE_TAG = "byte";
    var SHORT_TAG = "short";
    var INT_TAG = "integer";
    var LONG_TAG = "long";
    var BINARY_TAG = "binary";
    var STRING_TAG = "string";
    var TIMESTAMP_TAG = "timestamp";
    var UUID_TAG = "uuid";
    function parseHeaders(headers) {
      var out = {};
      var position = 0;
      while (position < headers.length) {
        var nameLength = headers.readUInt8(position++);
        var name = headers.slice(position, position + nameLength).toString();
        position += nameLength;
        switch (headers.readUInt8(position++)) {
          case 0:
            out[name] = {
              type: BOOLEAN_TAG,
              value: true
            };
            break;
          case 1:
            out[name] = {
              type: BOOLEAN_TAG,
              value: false
            };
            break;
          case 2:
            out[name] = {
              type: BYTE_TAG,
              value: headers.readInt8(position++)
            };
            break;
          case 3:
            out[name] = {
              type: SHORT_TAG,
              value: headers.readInt16BE(position)
            };
            position += 2;
            break;
          case 4:
            out[name] = {
              type: INT_TAG,
              value: headers.readInt32BE(position)
            };
            position += 4;
            break;
          case 5:
            out[name] = {
              type: LONG_TAG,
              value: new Int64(headers.slice(position, position + 8))
            };
            position += 8;
            break;
          case 6:
            var binaryLength = headers.readUInt16BE(position);
            position += 2;
            out[name] = {
              type: BINARY_TAG,
              value: headers.slice(position, position + binaryLength)
            };
            position += binaryLength;
            break;
          case 7:
            var stringLength = headers.readUInt16BE(position);
            position += 2;
            out[name] = {
              type: STRING_TAG,
              value: headers.slice(position, position + stringLength).toString()
            };
            position += stringLength;
            break;
          case 8:
            out[name] = {
              type: TIMESTAMP_TAG,
              value: new Date(new Int64(headers.slice(position, position + 8)).valueOf())
            };
            position += 8;
            break;
          case 9:
            var uuidChars = headers.slice(position, position + 16).toString("hex");
            position += 16;
            out[name] = {
              type: UUID_TAG,
              value: uuidChars.substr(0, 8) + "-" + uuidChars.substr(8, 4) + "-" + uuidChars.substr(12, 4) + "-" + uuidChars.substr(16, 4) + "-" + uuidChars.substr(20)
            };
            break;
          default:
            throw new Error("Unrecognized header type tag");
        }
      }
      return out;
    }
    function parseMessage(message) {
      var parsed = splitMessage(message);
      return { headers: parseHeaders(parsed.headers), body: parsed.body };
    }
    module2.exports = {
      parseMessage
    };
  }
});

// node_modules/aws-sdk/lib/event-stream/parse-event.js
var require_parse_event = __commonJS({
  "node_modules/aws-sdk/lib/event-stream/parse-event.js"(exports, module2) {
    var parseMessage = require_parse_message().parseMessage;
    function parseEvent(parser, message, shape) {
      var parsedMessage = parseMessage(message);
      var messageType = parsedMessage.headers[":message-type"];
      if (messageType) {
        if (messageType.value === "error") {
          throw parseError(parsedMessage);
        } else if (messageType.value !== "event") {
          return;
        }
      }
      var eventType = parsedMessage.headers[":event-type"];
      var eventModel = shape.members[eventType.value];
      if (!eventModel) {
        return;
      }
      var result = {};
      var eventPayloadMemberName = eventModel.eventPayloadMemberName;
      if (eventPayloadMemberName) {
        var payloadShape = eventModel.members[eventPayloadMemberName];
        if (payloadShape.type === "binary") {
          result[eventPayloadMemberName] = parsedMessage.body;
        } else {
          result[eventPayloadMemberName] = parser.parse(parsedMessage.body.toString(), payloadShape);
        }
      }
      var eventHeaderNames = eventModel.eventHeaderMemberNames;
      for (var i = 0; i < eventHeaderNames.length; i++) {
        var name = eventHeaderNames[i];
        if (parsedMessage.headers[name]) {
          result[name] = eventModel.members[name].toType(parsedMessage.headers[name].value);
        }
      }
      var output = {};
      output[eventType.value] = result;
      return output;
    }
    function parseError(message) {
      var errorCode = message.headers[":error-code"];
      var errorMessage = message.headers[":error-message"];
      var error = new Error(errorMessage.value || errorMessage);
      error.code = error.name = errorCode.value || errorCode;
      return error;
    }
    module2.exports = {
      parseEvent
    };
  }
});

// node_modules/aws-sdk/lib/event-stream/event-message-unmarshaller-stream.js
var require_event_message_unmarshaller_stream = __commonJS({
  "node_modules/aws-sdk/lib/event-stream/event-message-unmarshaller-stream.js"(exports, module2) {
    var Transform = require("stream").Transform;
    var parseEvent = require_parse_event().parseEvent;
    function EventUnmarshallerStream(options) {
      options = options || {};
      options.readableObjectMode = true;
      Transform.call(this, options);
      this._readableState.objectMode = true;
      this.parser = options.parser;
      this.eventStreamModel = options.eventStreamModel;
    }
    EventUnmarshallerStream.prototype = Object.create(Transform.prototype);
    EventUnmarshallerStream.prototype._transform = function(chunk, encoding, callback) {
      try {
        var event = parseEvent(this.parser, chunk, this.eventStreamModel);
        this.push(event);
        return callback();
      } catch (err) {
        callback(err);
      }
    };
    module2.exports = {
      EventUnmarshallerStream
    };
  }
});

// node_modules/aws-sdk/lib/event-stream/streaming-create-event-stream.js
var require_streaming_create_event_stream = __commonJS({
  "node_modules/aws-sdk/lib/event-stream/streaming-create-event-stream.js"(exports, module2) {
    var EventMessageChunkerStream = require_event_message_chunker_stream().EventMessageChunkerStream;
    var EventUnmarshallerStream = require_event_message_unmarshaller_stream().EventUnmarshallerStream;
    function createEventStream(stream, parser, model) {
      var eventStream = new EventUnmarshallerStream({
        parser,
        eventStreamModel: model
      });
      var eventMessageChunker = new EventMessageChunkerStream();
      stream.pipe(eventMessageChunker).pipe(eventStream);
      stream.on("error", function(err) {
        eventMessageChunker.emit("error", err);
      });
      eventMessageChunker.on("error", function(err) {
        eventStream.emit("error", err);
      });
      return eventStream;
    }
    module2.exports = {
      createEventStream
    };
  }
});

// node_modules/aws-sdk/lib/event-stream/event-message-chunker.js
var require_event_message_chunker = __commonJS({
  "node_modules/aws-sdk/lib/event-stream/event-message-chunker.js"(exports, module2) {
    function eventMessageChunker(buffer) {
      var messages = [];
      var offset = 0;
      while (offset < buffer.length) {
        var totalLength = buffer.readInt32BE(offset);
        var message = buffer.slice(offset, totalLength + offset);
        offset += totalLength;
        messages.push(message);
      }
      return messages;
    }
    module2.exports = {
      eventMessageChunker
    };
  }
});

// node_modules/aws-sdk/lib/event-stream/buffered-create-event-stream.js
var require_buffered_create_event_stream = __commonJS({
  "node_modules/aws-sdk/lib/event-stream/buffered-create-event-stream.js"(exports, module2) {
    var eventMessageChunker = require_event_message_chunker().eventMessageChunker;
    var parseEvent = require_parse_event().parseEvent;
    function createEventStream(body, parser, model) {
      var eventMessages = eventMessageChunker(body);
      var events = [];
      for (var i = 0; i < eventMessages.length; i++) {
        events.push(parseEvent(parser, eventMessages[i], model));
      }
      return events;
    }
    module2.exports = {
      createEventStream
    };
  }
});

// node_modules/aws-sdk/lib/realclock/nodeClock.js
var require_nodeClock = __commonJS({
  "node_modules/aws-sdk/lib/realclock/nodeClock.js"(exports, module2) {
    module2.exports = {
      now: function now() {
        var second = process.hrtime();
        return second[0] * 1e3 + second[1] / 1e6;
      }
    };
  }
});

// node_modules/aws-sdk/lib/publisher/index.js
var require_publisher = __commonJS({
  "node_modules/aws-sdk/lib/publisher/index.js"(exports, module2) {
    var util = require_core().util;
    var dgram = require("dgram");
    var stringToBuffer = util.buffer.toBuffer;
    var MAX_MESSAGE_SIZE = 1024 * 8;
    function Publisher(options) {
      options = options || {};
      this.enabled = options.enabled || false;
      this.port = options.port || 31e3;
      this.clientId = options.clientId || "";
      this.address = options.host || "127.0.0.1";
      if (this.clientId.length > 255) {
        this.clientId = this.clientId.substr(0, 255);
      }
      this.messagesInFlight = 0;
    }
    Publisher.prototype.fieldsToTrim = {
      UserAgent: 256,
      SdkException: 128,
      SdkExceptionMessage: 512,
      AwsException: 128,
      AwsExceptionMessage: 512,
      FinalSdkException: 128,
      FinalSdkExceptionMessage: 512,
      FinalAwsException: 128,
      FinalAwsExceptionMessage: 512
    };
    Publisher.prototype.trimFields = function(event) {
      var trimmableFields = Object.keys(this.fieldsToTrim);
      for (var i = 0, iLen = trimmableFields.length; i < iLen; i++) {
        var field = trimmableFields[i];
        if (event.hasOwnProperty(field)) {
          var maxLength = this.fieldsToTrim[field];
          var value = event[field];
          if (value && value.length > maxLength) {
            event[field] = value.substr(0, maxLength);
          }
        }
      }
      return event;
    };
    Publisher.prototype.eventHandler = function(event) {
      event.ClientId = this.clientId;
      this.trimFields(event);
      var message = stringToBuffer(JSON.stringify(event));
      if (!this.enabled || message.length > MAX_MESSAGE_SIZE) {
        return;
      }
      this.publishDatagram(message);
    };
    Publisher.prototype.publishDatagram = function(message) {
      var self2 = this;
      var client = this.getClient();
      this.messagesInFlight++;
      this.client.send(message, 0, message.length, this.port, this.address, function(err, bytes) {
        if (--self2.messagesInFlight <= 0) {
          self2.destroyClient();
        }
      });
    };
    Publisher.prototype.getClient = function() {
      if (!this.client) {
        this.client = dgram.createSocket("udp4");
      }
      return this.client;
    };
    Publisher.prototype.destroyClient = function() {
      if (this.client) {
        this.client.close();
        this.client = void 0;
      }
    };
    module2.exports = {
      Publisher
    };
  }
});

// node_modules/aws-sdk/lib/publisher/configuration.js
var require_configuration2 = __commonJS({
  "node_modules/aws-sdk/lib/publisher/configuration.js"(exports, module2) {
    var AWS3 = require_core();
    function resolveMonitoringConfig() {
      var config = {
        port: void 0,
        clientId: void 0,
        enabled: void 0,
        host: void 0
      };
      if (fromEnvironment(config) || fromConfigFile(config))
        return toJSType(config);
      return toJSType(config);
    }
    function fromEnvironment(config) {
      config.port = config.port || process.env.AWS_CSM_PORT;
      config.enabled = config.enabled || process.env.AWS_CSM_ENABLED;
      config.clientId = config.clientId || process.env.AWS_CSM_CLIENT_ID;
      config.host = config.host || process.env.AWS_CSM_HOST;
      return config.port && config.enabled && config.clientId && config.host || ["false", "0"].indexOf(config.enabled) >= 0;
    }
    function fromConfigFile(config) {
      var sharedFileConfig;
      try {
        var configFile = AWS3.util.iniLoader.loadFrom({
          isConfig: true,
          filename: process.env[AWS3.util.sharedConfigFileEnv]
        });
        var sharedFileConfig = configFile[process.env.AWS_PROFILE || AWS3.util.defaultProfile];
      } catch (err) {
        return false;
      }
      if (!sharedFileConfig)
        return config;
      config.port = config.port || sharedFileConfig.csm_port;
      config.enabled = config.enabled || sharedFileConfig.csm_enabled;
      config.clientId = config.clientId || sharedFileConfig.csm_client_id;
      config.host = config.host || sharedFileConfig.csm_host;
      return config.port && config.enabled && config.clientId && config.host;
    }
    function toJSType(config) {
      var falsyNotations = ["false", "0", void 0];
      if (!config.enabled || falsyNotations.indexOf(config.enabled.toLowerCase()) >= 0) {
        config.enabled = false;
      } else {
        config.enabled = true;
      }
      config.port = config.port ? parseInt(config.port, 10) : void 0;
      return config;
    }
    module2.exports = resolveMonitoringConfig;
  }
});

// node_modules/aws-sdk/lib/shared-ini/ini-loader.js
var require_ini_loader = __commonJS({
  "node_modules/aws-sdk/lib/shared-ini/ini-loader.js"(exports, module2) {
    var AWS3 = require_core();
    var os2 = require("os");
    var path2 = require("path");
    function parseFile(filename, isConfig) {
      var content = AWS3.util.ini.parse(AWS3.util.readFileSync(filename));
      var tmpContent = {};
      Object.keys(content).forEach(function(profileName) {
        var profileContent = content[profileName];
        profileName = isConfig ? profileName.replace(/^profile\s/, "") : profileName;
        Object.defineProperty(tmpContent, profileName, {
          value: profileContent,
          enumerable: true
        });
      });
      return tmpContent;
    }
    AWS3.IniLoader = AWS3.util.inherit({
      constructor: function IniLoader2() {
        this.resolvedProfiles = {};
      },
      clearCachedFiles: function clearCachedFiles() {
        this.resolvedProfiles = {};
      },
      loadFrom: function loadFrom(options) {
        options = options || {};
        var isConfig = options.isConfig === true;
        var filename = options.filename || this.getDefaultFilePath(isConfig);
        if (!this.resolvedProfiles[filename]) {
          var fileContent = this.parseFile(filename, isConfig);
          Object.defineProperty(this.resolvedProfiles, filename, { value: fileContent });
        }
        return this.resolvedProfiles[filename];
      },
      parseFile,
      getDefaultFilePath: function getDefaultFilePath(isConfig) {
        return path2.join(this.getHomeDir(), ".aws", isConfig ? "config" : "credentials");
      },
      getHomeDir: function getHomeDir() {
        var env2 = process.env;
        var home = env2.HOME || env2.USERPROFILE || (env2.HOMEPATH ? (env2.HOMEDRIVE || "C:/") + env2.HOMEPATH : null);
        if (home) {
          return home;
        }
        if (typeof os2.homedir === "function") {
          return os2.homedir();
        }
        throw AWS3.util.error(new Error("Cannot load credentials, HOME path not set"));
      }
    });
    var IniLoader = AWS3.IniLoader;
    module2.exports = {
      IniLoader,
      parseFile
    };
  }
});

// node_modules/aws-sdk/lib/shared-ini/index.js
var require_shared_ini = __commonJS({
  "node_modules/aws-sdk/lib/shared-ini/index.js"(exports, module2) {
    var IniLoader = require_ini_loader().IniLoader;
    module2.exports.iniLoader = new IniLoader();
  }
});

// node_modules/aws-sdk/lib/config_regional_endpoint.js
var require_config_regional_endpoint = __commonJS({
  "node_modules/aws-sdk/lib/config_regional_endpoint.js"(exports, module2) {
    var AWS3 = require_core();
    function validateRegionalEndpointsFlagValue(configValue, errorOptions) {
      if (typeof configValue !== "string")
        return void 0;
      else if (["legacy", "regional"].indexOf(configValue.toLowerCase()) >= 0) {
        return configValue.toLowerCase();
      } else {
        throw AWS3.util.error(new Error(), errorOptions);
      }
    }
    function resolveRegionalEndpointsFlag(originalConfig, options) {
      originalConfig = originalConfig || {};
      var resolved;
      if (originalConfig[options.clientConfig]) {
        resolved = validateRegionalEndpointsFlagValue(originalConfig[options.clientConfig], {
          code: "InvalidConfiguration",
          message: 'invalid "' + options.clientConfig + '" configuration. Expect "legacy"  or "regional". Got "' + originalConfig[options.clientConfig] + '".'
        });
        if (resolved)
          return resolved;
      }
      if (!AWS3.util.isNode())
        return resolved;
      if (Object.prototype.hasOwnProperty.call(process.env, options.env)) {
        var envFlag = process.env[options.env];
        resolved = validateRegionalEndpointsFlagValue(envFlag, {
          code: "InvalidEnvironmentalVariable",
          message: "invalid " + options.env + ' environmental variable. Expect "legacy"  or "regional". Got "' + process.env[options.env] + '".'
        });
        if (resolved)
          return resolved;
      }
      var profile = {};
      try {
        var profiles = AWS3.util.getProfilesFromSharedConfig(AWS3.util.iniLoader);
        profile = profiles[process.env.AWS_PROFILE || AWS3.util.defaultProfile];
      } catch (e) {
      }
      ;
      if (profile && Object.prototype.hasOwnProperty.call(profile, options.sharedConfig)) {
        var fileFlag = profile[options.sharedConfig];
        resolved = validateRegionalEndpointsFlagValue(fileFlag, {
          code: "InvalidConfiguration",
          message: "invalid " + options.sharedConfig + ' profile config. Expect "legacy"  or "regional". Got "' + profile[options.sharedConfig] + '".'
        });
        if (resolved)
          return resolved;
      }
      return resolved;
    }
    module2.exports = resolveRegionalEndpointsFlag;
  }
});

// node_modules/aws-sdk/lib/services/sts.js
var require_sts = __commonJS({
  "node_modules/aws-sdk/lib/services/sts.js"() {
    var AWS3 = require_core();
    var resolveRegionalEndpointsFlag = require_config_regional_endpoint();
    var ENV_REGIONAL_ENDPOINT_ENABLED = "AWS_STS_REGIONAL_ENDPOINTS";
    var CONFIG_REGIONAL_ENDPOINT_ENABLED = "sts_regional_endpoints";
    AWS3.util.update(AWS3.STS.prototype, {
      credentialsFrom: function credentialsFrom(data, credentials) {
        if (!data)
          return null;
        if (!credentials)
          credentials = new AWS3.TemporaryCredentials();
        credentials.expired = false;
        credentials.accessKeyId = data.Credentials.AccessKeyId;
        credentials.secretAccessKey = data.Credentials.SecretAccessKey;
        credentials.sessionToken = data.Credentials.SessionToken;
        credentials.expireTime = data.Credentials.Expiration;
        return credentials;
      },
      assumeRoleWithWebIdentity: function assumeRoleWithWebIdentity(params, callback) {
        return this.makeUnauthenticatedRequest("assumeRoleWithWebIdentity", params, callback);
      },
      assumeRoleWithSAML: function assumeRoleWithSAML(params, callback) {
        return this.makeUnauthenticatedRequest("assumeRoleWithSAML", params, callback);
      },
      setupRequestListeners: function setupRequestListeners(request) {
        request.addListener("validate", this.optInRegionalEndpoint, true);
      },
      optInRegionalEndpoint: function optInRegionalEndpoint(req) {
        var service = req.service;
        var config = service.config;
        config.stsRegionalEndpoints = resolveRegionalEndpointsFlag(service._originalConfig, {
          env: ENV_REGIONAL_ENDPOINT_ENABLED,
          sharedConfig: CONFIG_REGIONAL_ENDPOINT_ENABLED,
          clientConfig: "stsRegionalEndpoints"
        });
        if (config.stsRegionalEndpoints === "regional" && service.isGlobalEndpoint) {
          if (!config.region) {
            throw AWS3.util.error(new Error(), { code: "ConfigError", message: "Missing region in config" });
          }
          var insertPoint = config.endpoint.indexOf(".amazonaws.com");
          var regionalEndpoint2 = config.endpoint.substring(0, insertPoint) + "." + config.region + config.endpoint.substring(insertPoint);
          req.httpRequest.updateEndpoint(regionalEndpoint2);
          req.httpRequest.region = config.region;
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/sts-2011-06-15.min.json
var require_sts_2011_06_15_min = __commonJS({
  "node_modules/aws-sdk/apis/sts-2011-06-15.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2011-06-15",
        endpointPrefix: "sts",
        globalEndpoint: "sts.amazonaws.com",
        protocol: "query",
        serviceAbbreviation: "AWS STS",
        serviceFullName: "AWS Security Token Service",
        serviceId: "STS",
        signatureVersion: "v4",
        uid: "sts-2011-06-15",
        xmlNamespace: "https://sts.amazonaws.com/doc/2011-06-15/"
      },
      operations: {
        AssumeRole: {
          input: {
            type: "structure",
            required: [
              "RoleArn",
              "RoleSessionName"
            ],
            members: {
              RoleArn: {},
              RoleSessionName: {},
              PolicyArns: {
                shape: "S4"
              },
              Policy: {},
              DurationSeconds: {
                type: "integer"
              },
              Tags: {
                shape: "S8"
              },
              TransitiveTagKeys: {
                type: "list",
                member: {}
              },
              ExternalId: {},
              SerialNumber: {},
              TokenCode: {},
              SourceIdentity: {}
            }
          },
          output: {
            resultWrapper: "AssumeRoleResult",
            type: "structure",
            members: {
              Credentials: {
                shape: "Si"
              },
              AssumedRoleUser: {
                shape: "Sn"
              },
              PackedPolicySize: {
                type: "integer"
              },
              SourceIdentity: {}
            }
          }
        },
        AssumeRoleWithSAML: {
          input: {
            type: "structure",
            required: [
              "RoleArn",
              "PrincipalArn",
              "SAMLAssertion"
            ],
            members: {
              RoleArn: {},
              PrincipalArn: {},
              SAMLAssertion: {},
              PolicyArns: {
                shape: "S4"
              },
              Policy: {},
              DurationSeconds: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "AssumeRoleWithSAMLResult",
            type: "structure",
            members: {
              Credentials: {
                shape: "Si"
              },
              AssumedRoleUser: {
                shape: "Sn"
              },
              PackedPolicySize: {
                type: "integer"
              },
              Subject: {},
              SubjectType: {},
              Issuer: {},
              Audience: {},
              NameQualifier: {},
              SourceIdentity: {}
            }
          }
        },
        AssumeRoleWithWebIdentity: {
          input: {
            type: "structure",
            required: [
              "RoleArn",
              "RoleSessionName",
              "WebIdentityToken"
            ],
            members: {
              RoleArn: {},
              RoleSessionName: {},
              WebIdentityToken: {},
              ProviderId: {},
              PolicyArns: {
                shape: "S4"
              },
              Policy: {},
              DurationSeconds: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "AssumeRoleWithWebIdentityResult",
            type: "structure",
            members: {
              Credentials: {
                shape: "Si"
              },
              SubjectFromWebIdentityToken: {},
              AssumedRoleUser: {
                shape: "Sn"
              },
              PackedPolicySize: {
                type: "integer"
              },
              Provider: {},
              Audience: {},
              SourceIdentity: {}
            }
          }
        },
        DecodeAuthorizationMessage: {
          input: {
            type: "structure",
            required: [
              "EncodedMessage"
            ],
            members: {
              EncodedMessage: {}
            }
          },
          output: {
            resultWrapper: "DecodeAuthorizationMessageResult",
            type: "structure",
            members: {
              DecodedMessage: {}
            }
          }
        },
        GetAccessKeyInfo: {
          input: {
            type: "structure",
            required: [
              "AccessKeyId"
            ],
            members: {
              AccessKeyId: {}
            }
          },
          output: {
            resultWrapper: "GetAccessKeyInfoResult",
            type: "structure",
            members: {
              Account: {}
            }
          }
        },
        GetCallerIdentity: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            resultWrapper: "GetCallerIdentityResult",
            type: "structure",
            members: {
              UserId: {},
              Account: {},
              Arn: {}
            }
          }
        },
        GetFederationToken: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Policy: {},
              PolicyArns: {
                shape: "S4"
              },
              DurationSeconds: {
                type: "integer"
              },
              Tags: {
                shape: "S8"
              }
            }
          },
          output: {
            resultWrapper: "GetFederationTokenResult",
            type: "structure",
            members: {
              Credentials: {
                shape: "Si"
              },
              FederatedUser: {
                type: "structure",
                required: [
                  "FederatedUserId",
                  "Arn"
                ],
                members: {
                  FederatedUserId: {},
                  Arn: {}
                }
              },
              PackedPolicySize: {
                type: "integer"
              }
            }
          }
        },
        GetSessionToken: {
          input: {
            type: "structure",
            members: {
              DurationSeconds: {
                type: "integer"
              },
              SerialNumber: {},
              TokenCode: {}
            }
          },
          output: {
            resultWrapper: "GetSessionTokenResult",
            type: "structure",
            members: {
              Credentials: {
                shape: "Si"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {
            type: "structure",
            members: {
              arn: {}
            }
          }
        },
        S8: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Si: {
          type: "structure",
          required: [
            "AccessKeyId",
            "SecretAccessKey",
            "SessionToken",
            "Expiration"
          ],
          members: {
            AccessKeyId: {},
            SecretAccessKey: {},
            SessionToken: {},
            Expiration: {
              type: "timestamp"
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "AssumedRoleId",
            "Arn"
          ],
          members: {
            AssumedRoleId: {},
            Arn: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sts-2011-06-15.paginators.json
var require_sts_2011_06_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sts-2011-06-15.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/sts.js
var require_sts2 = __commonJS({
  "node_modules/aws-sdk/clients/sts.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["sts"] = {};
    AWS3.STS = Service.defineService("sts", ["2011-06-15"]);
    require_sts();
    Object.defineProperty(apiLoader.services["sts"], "2011-06-15", {
      get: function get() {
        var model = require_sts_2011_06_15_min();
        model.paginators = require_sts_2011_06_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.STS;
  }
});

// node_modules/aws-sdk/lib/credentials/temporary_credentials.js
var require_temporary_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/temporary_credentials.js"() {
    var AWS3 = require_core();
    var STS = require_sts2();
    AWS3.TemporaryCredentials = AWS3.util.inherit(AWS3.Credentials, {
      constructor: function TemporaryCredentials(params, masterCredentials) {
        AWS3.Credentials.call(this);
        this.loadMasterCredentials(masterCredentials);
        this.expired = true;
        this.params = params || {};
        if (this.params.RoleArn) {
          this.params.RoleSessionName = this.params.RoleSessionName || "temporary-credentials";
        }
      },
      refresh: function refresh(callback) {
        this.coalesceRefresh(callback || AWS3.util.fn.callback);
      },
      load: function load(callback) {
        var self2 = this;
        self2.createClients();
        self2.masterCredentials.get(function() {
          self2.service.config.credentials = self2.masterCredentials;
          var operation = self2.params.RoleArn ? self2.service.assumeRole : self2.service.getSessionToken;
          operation.call(self2.service, function(err, data) {
            if (!err) {
              self2.service.credentialsFrom(data, self2);
            }
            callback(err);
          });
        });
      },
      loadMasterCredentials: function loadMasterCredentials(masterCredentials) {
        this.masterCredentials = masterCredentials || AWS3.config.credentials;
        while (this.masterCredentials.masterCredentials) {
          this.masterCredentials = this.masterCredentials.masterCredentials;
        }
        if (typeof this.masterCredentials.get !== "function") {
          this.masterCredentials = new AWS3.Credentials(this.masterCredentials);
        }
      },
      createClients: function() {
        this.service = this.service || new STS({ params: this.params });
      }
    });
  }
});

// node_modules/aws-sdk/lib/credentials/chainable_temporary_credentials.js
var require_chainable_temporary_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/chainable_temporary_credentials.js"() {
    var AWS3 = require_core();
    var STS = require_sts2();
    AWS3.ChainableTemporaryCredentials = AWS3.util.inherit(AWS3.Credentials, {
      constructor: function ChainableTemporaryCredentials(options) {
        AWS3.Credentials.call(this);
        options = options || {};
        this.errorCode = "ChainableTemporaryCredentialsProviderFailure";
        this.expired = true;
        this.tokenCodeFn = null;
        var params = AWS3.util.copy(options.params) || {};
        if (params.RoleArn) {
          params.RoleSessionName = params.RoleSessionName || "temporary-credentials";
        }
        if (params.SerialNumber) {
          if (!options.tokenCodeFn || typeof options.tokenCodeFn !== "function") {
            throw new AWS3.util.error(new Error("tokenCodeFn must be a function when params.SerialNumber is given"), { code: this.errorCode });
          } else {
            this.tokenCodeFn = options.tokenCodeFn;
          }
        }
        var config = AWS3.util.merge({
          params,
          credentials: options.masterCredentials || AWS3.config.credentials
        }, options.stsConfig || {});
        this.service = new STS(config);
      },
      refresh: function refresh(callback) {
        this.coalesceRefresh(callback || AWS3.util.fn.callback);
      },
      load: function load(callback) {
        var self2 = this;
        var operation = self2.service.config.params.RoleArn ? "assumeRole" : "getSessionToken";
        this.getTokenCode(function(err, tokenCode) {
          var params = {};
          if (err) {
            callback(err);
            return;
          }
          if (tokenCode) {
            params.TokenCode = tokenCode;
          }
          self2.service[operation](params, function(err2, data) {
            if (!err2) {
              self2.service.credentialsFrom(data, self2);
            }
            callback(err2);
          });
        });
      },
      getTokenCode: function getTokenCode(callback) {
        var self2 = this;
        if (this.tokenCodeFn) {
          this.tokenCodeFn(this.service.config.params.SerialNumber, function(err, token) {
            if (err) {
              var message = err;
              if (err instanceof Error) {
                message = err.message;
              }
              callback(AWS3.util.error(new Error("Error fetching MFA token: " + message), { code: self2.errorCode }));
              return;
            }
            callback(null, token);
          });
        } else {
          callback(null);
        }
      }
    });
  }
});

// node_modules/aws-sdk/lib/credentials/web_identity_credentials.js
var require_web_identity_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/web_identity_credentials.js"() {
    var AWS3 = require_core();
    var STS = require_sts2();
    AWS3.WebIdentityCredentials = AWS3.util.inherit(AWS3.Credentials, {
      constructor: function WebIdentityCredentials(params, clientConfig) {
        AWS3.Credentials.call(this);
        this.expired = true;
        this.params = params;
        this.params.RoleSessionName = this.params.RoleSessionName || "web-identity";
        this.data = null;
        this._clientConfig = AWS3.util.copy(clientConfig || {});
      },
      refresh: function refresh(callback) {
        this.coalesceRefresh(callback || AWS3.util.fn.callback);
      },
      load: function load(callback) {
        var self2 = this;
        self2.createClients();
        self2.service.assumeRoleWithWebIdentity(function(err, data) {
          self2.data = null;
          if (!err) {
            self2.data = data;
            self2.service.credentialsFrom(data, self2);
          }
          callback(err);
        });
      },
      createClients: function() {
        if (!this.service) {
          var stsConfig = AWS3.util.merge({}, this._clientConfig);
          stsConfig.params = this.params;
          this.service = new STS(stsConfig);
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/cognito-identity-2014-06-30.min.json
var require_cognito_identity_2014_06_30_min = __commonJS({
  "node_modules/aws-sdk/apis/cognito-identity-2014-06-30.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-06-30",
        endpointPrefix: "cognito-identity",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Cognito Identity",
        serviceId: "Cognito Identity",
        signatureVersion: "v4",
        targetPrefix: "AWSCognitoIdentityService",
        uid: "cognito-identity-2014-06-30"
      },
      operations: {
        CreateIdentityPool: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolName",
              "AllowUnauthenticatedIdentities"
            ],
            members: {
              IdentityPoolName: {},
              AllowUnauthenticatedIdentities: {
                type: "boolean"
              },
              AllowClassicFlow: {
                type: "boolean"
              },
              SupportedLoginProviders: {
                shape: "S5"
              },
              DeveloperProviderName: {},
              OpenIdConnectProviderARNs: {
                shape: "S9"
              },
              CognitoIdentityProviders: {
                shape: "Sb"
              },
              SamlProviderARNs: {
                shape: "Sg"
              },
              IdentityPoolTags: {
                shape: "Sh"
              }
            }
          },
          output: {
            shape: "Sk"
          }
        },
        DeleteIdentities: {
          input: {
            type: "structure",
            required: [
              "IdentityIdsToDelete"
            ],
            members: {
              IdentityIdsToDelete: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UnprocessedIdentityIds: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IdentityId: {},
                    ErrorCode: {}
                  }
                }
              }
            }
          }
        },
        DeleteIdentityPool: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {}
            }
          }
        },
        DescribeIdentity: {
          input: {
            type: "structure",
            required: [
              "IdentityId"
            ],
            members: {
              IdentityId: {}
            }
          },
          output: {
            shape: "Sv"
          }
        },
        DescribeIdentityPool: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {}
            }
          },
          output: {
            shape: "Sk"
          }
        },
        GetCredentialsForIdentity: {
          input: {
            type: "structure",
            required: [
              "IdentityId"
            ],
            members: {
              IdentityId: {},
              Logins: {
                shape: "S10"
              },
              CustomRoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityId: {},
              Credentials: {
                type: "structure",
                members: {
                  AccessKeyId: {},
                  SecretKey: {},
                  SessionToken: {},
                  Expiration: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          authtype: "none"
        },
        GetId: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              AccountId: {},
              IdentityPoolId: {},
              Logins: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityId: {}
            }
          },
          authtype: "none"
        },
        GetIdentityPoolRoles: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPoolId: {},
              Roles: {
                shape: "S1c"
              },
              RoleMappings: {
                shape: "S1e"
              }
            }
          }
        },
        GetOpenIdToken: {
          input: {
            type: "structure",
            required: [
              "IdentityId"
            ],
            members: {
              IdentityId: {},
              Logins: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityId: {},
              Token: {}
            }
          },
          authtype: "none"
        },
        GetOpenIdTokenForDeveloperIdentity: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "Logins"
            ],
            members: {
              IdentityPoolId: {},
              IdentityId: {},
              Logins: {
                shape: "S10"
              },
              PrincipalTags: {
                shape: "S1s"
              },
              TokenDuration: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityId: {},
              Token: {}
            }
          }
        },
        GetPrincipalTagAttributeMap: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "IdentityProviderName"
            ],
            members: {
              IdentityPoolId: {},
              IdentityProviderName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPoolId: {},
              IdentityProviderName: {},
              UseDefaults: {
                type: "boolean"
              },
              PrincipalTags: {
                shape: "S1s"
              }
            }
          }
        },
        ListIdentities: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "MaxResults"
            ],
            members: {
              IdentityPoolId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              HideDisabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPoolId: {},
              Identities: {
                type: "list",
                member: {
                  shape: "Sv"
                }
              },
              NextToken: {}
            }
          }
        },
        ListIdentityPools: {
          input: {
            type: "structure",
            required: [
              "MaxResults"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPools: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IdentityPoolId: {},
                    IdentityPoolName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sh"
              }
            }
          }
        },
        LookupDeveloperIdentity: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {},
              IdentityId: {},
              DeveloperUserIdentifier: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityId: {},
              DeveloperUserIdentifierList: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        MergeDeveloperIdentities: {
          input: {
            type: "structure",
            required: [
              "SourceUserIdentifier",
              "DestinationUserIdentifier",
              "DeveloperProviderName",
              "IdentityPoolId"
            ],
            members: {
              SourceUserIdentifier: {},
              DestinationUserIdentifier: {},
              DeveloperProviderName: {},
              IdentityPoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityId: {}
            }
          }
        },
        SetIdentityPoolRoles: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "Roles"
            ],
            members: {
              IdentityPoolId: {},
              Roles: {
                shape: "S1c"
              },
              RoleMappings: {
                shape: "S1e"
              }
            }
          }
        },
        SetPrincipalTagAttributeMap: {
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "IdentityProviderName"
            ],
            members: {
              IdentityPoolId: {},
              IdentityProviderName: {},
              UseDefaults: {
                type: "boolean"
              },
              PrincipalTags: {
                shape: "S1s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPoolId: {},
              IdentityProviderName: {},
              UseDefaults: {
                type: "boolean"
              },
              PrincipalTags: {
                shape: "S1s"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UnlinkDeveloperIdentity: {
          input: {
            type: "structure",
            required: [
              "IdentityId",
              "IdentityPoolId",
              "DeveloperProviderName",
              "DeveloperUserIdentifier"
            ],
            members: {
              IdentityId: {},
              IdentityPoolId: {},
              DeveloperProviderName: {},
              DeveloperUserIdentifier: {}
            }
          }
        },
        UnlinkIdentity: {
          input: {
            type: "structure",
            required: [
              "IdentityId",
              "Logins",
              "LoginsToRemove"
            ],
            members: {
              IdentityId: {},
              Logins: {
                shape: "S10"
              },
              LoginsToRemove: {
                shape: "Sw"
              }
            }
          },
          authtype: "none"
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateIdentityPool: {
          input: {
            shape: "Sk"
          },
          output: {
            shape: "Sk"
          }
        }
      },
      shapes: {
        S5: {
          type: "map",
          key: {},
          value: {}
        },
        S9: {
          type: "list",
          member: {}
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ProviderName: {},
              ClientId: {},
              ServerSideTokenCheck: {
                type: "boolean"
              }
            }
          }
        },
        Sg: {
          type: "list",
          member: {}
        },
        Sh: {
          type: "map",
          key: {},
          value: {}
        },
        Sk: {
          type: "structure",
          required: [
            "IdentityPoolId",
            "IdentityPoolName",
            "AllowUnauthenticatedIdentities"
          ],
          members: {
            IdentityPoolId: {},
            IdentityPoolName: {},
            AllowUnauthenticatedIdentities: {
              type: "boolean"
            },
            AllowClassicFlow: {
              type: "boolean"
            },
            SupportedLoginProviders: {
              shape: "S5"
            },
            DeveloperProviderName: {},
            OpenIdConnectProviderARNs: {
              shape: "S9"
            },
            CognitoIdentityProviders: {
              shape: "Sb"
            },
            SamlProviderARNs: {
              shape: "Sg"
            },
            IdentityPoolTags: {
              shape: "Sh"
            }
          }
        },
        Sv: {
          type: "structure",
          members: {
            IdentityId: {},
            Logins: {
              shape: "Sw"
            },
            CreationDate: {
              type: "timestamp"
            },
            LastModifiedDate: {
              type: "timestamp"
            }
          }
        },
        Sw: {
          type: "list",
          member: {}
        },
        S10: {
          type: "map",
          key: {},
          value: {}
        },
        S1c: {
          type: "map",
          key: {},
          value: {}
        },
        S1e: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "Type"
            ],
            members: {
              Type: {},
              AmbiguousRoleResolution: {},
              RulesConfiguration: {
                type: "structure",
                required: [
                  "Rules"
                ],
                members: {
                  Rules: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Claim",
                        "MatchType",
                        "Value",
                        "RoleARN"
                      ],
                      members: {
                        Claim: {},
                        MatchType: {},
                        Value: {},
                        RoleARN: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S1s: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cognito-identity-2014-06-30.paginators.json
var require_cognito_identity_2014_06_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cognito-identity-2014-06-30.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListIdentityPools: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "IdentityPools"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cognitoidentity.js
var require_cognitoidentity = __commonJS({
  "node_modules/aws-sdk/clients/cognitoidentity.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["cognitoidentity"] = {};
    AWS3.CognitoIdentity = Service.defineService("cognitoidentity", ["2014-06-30"]);
    Object.defineProperty(apiLoader.services["cognitoidentity"], "2014-06-30", {
      get: function get() {
        var model = require_cognito_identity_2014_06_30_min();
        model.paginators = require_cognito_identity_2014_06_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CognitoIdentity;
  }
});

// node_modules/aws-sdk/lib/credentials/cognito_identity_credentials.js
var require_cognito_identity_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/cognito_identity_credentials.js"() {
    var AWS3 = require_core();
    var CognitoIdentity = require_cognitoidentity();
    var STS = require_sts2();
    AWS3.CognitoIdentityCredentials = AWS3.util.inherit(AWS3.Credentials, {
      localStorageKey: {
        id: "aws.cognito.identity-id.",
        providers: "aws.cognito.identity-providers."
      },
      constructor: function CognitoIdentityCredentials(params, clientConfig) {
        AWS3.Credentials.call(this);
        this.expired = true;
        this.params = params;
        this.data = null;
        this._identityId = null;
        this._clientConfig = AWS3.util.copy(clientConfig || {});
        this.loadCachedId();
        var self2 = this;
        Object.defineProperty(this, "identityId", {
          get: function() {
            self2.loadCachedId();
            return self2._identityId || self2.params.IdentityId;
          },
          set: function(identityId) {
            self2._identityId = identityId;
          }
        });
      },
      refresh: function refresh(callback) {
        this.coalesceRefresh(callback || AWS3.util.fn.callback);
      },
      load: function load(callback) {
        var self2 = this;
        self2.createClients();
        self2.data = null;
        self2._identityId = null;
        self2.getId(function(err) {
          if (!err) {
            if (!self2.params.RoleArn) {
              self2.getCredentialsForIdentity(callback);
            } else {
              self2.getCredentialsFromSTS(callback);
            }
          } else {
            self2.clearIdOnNotAuthorized(err);
            callback(err);
          }
        });
      },
      clearCachedId: function clearCache() {
        this._identityId = null;
        delete this.params.IdentityId;
        var poolId = this.params.IdentityPoolId;
        var loginId = this.params.LoginId || "";
        delete this.storage[this.localStorageKey.id + poolId + loginId];
        delete this.storage[this.localStorageKey.providers + poolId + loginId];
      },
      clearIdOnNotAuthorized: function clearIdOnNotAuthorized(err) {
        var self2 = this;
        if (err.code == "NotAuthorizedException") {
          self2.clearCachedId();
        }
      },
      getId: function getId(callback) {
        var self2 = this;
        if (typeof self2.params.IdentityId === "string") {
          return callback(null, self2.params.IdentityId);
        }
        self2.cognito.getId(function(err, data) {
          if (!err && data.IdentityId) {
            self2.params.IdentityId = data.IdentityId;
            callback(null, data.IdentityId);
          } else {
            callback(err);
          }
        });
      },
      loadCredentials: function loadCredentials(data, credentials) {
        if (!data || !credentials)
          return;
        credentials.expired = false;
        credentials.accessKeyId = data.Credentials.AccessKeyId;
        credentials.secretAccessKey = data.Credentials.SecretKey;
        credentials.sessionToken = data.Credentials.SessionToken;
        credentials.expireTime = data.Credentials.Expiration;
      },
      getCredentialsForIdentity: function getCredentialsForIdentity(callback) {
        var self2 = this;
        self2.cognito.getCredentialsForIdentity(function(err, data) {
          if (!err) {
            self2.cacheId(data);
            self2.data = data;
            self2.loadCredentials(self2.data, self2);
          } else {
            self2.clearIdOnNotAuthorized(err);
          }
          callback(err);
        });
      },
      getCredentialsFromSTS: function getCredentialsFromSTS(callback) {
        var self2 = this;
        self2.cognito.getOpenIdToken(function(err, data) {
          if (!err) {
            self2.cacheId(data);
            self2.params.WebIdentityToken = data.Token;
            self2.webIdentityCredentials.refresh(function(webErr) {
              if (!webErr) {
                self2.data = self2.webIdentityCredentials.data;
                self2.sts.credentialsFrom(self2.data, self2);
              }
              callback(webErr);
            });
          } else {
            self2.clearIdOnNotAuthorized(err);
            callback(err);
          }
        });
      },
      loadCachedId: function loadCachedId() {
        var self2 = this;
        if (AWS3.util.isBrowser() && !self2.params.IdentityId) {
          var id = self2.getStorage("id");
          if (id && self2.params.Logins) {
            var actualProviders = Object.keys(self2.params.Logins);
            var cachedProviders = (self2.getStorage("providers") || "").split(",");
            var intersect = cachedProviders.filter(function(n) {
              return actualProviders.indexOf(n) !== -1;
            });
            if (intersect.length !== 0) {
              self2.params.IdentityId = id;
            }
          } else if (id) {
            self2.params.IdentityId = id;
          }
        }
      },
      createClients: function() {
        var clientConfig = this._clientConfig;
        this.webIdentityCredentials = this.webIdentityCredentials || new AWS3.WebIdentityCredentials(this.params, clientConfig);
        if (!this.cognito) {
          var cognitoConfig = AWS3.util.merge({}, clientConfig);
          cognitoConfig.params = this.params;
          this.cognito = new CognitoIdentity(cognitoConfig);
        }
        this.sts = this.sts || new STS(clientConfig);
      },
      cacheId: function cacheId(data) {
        this._identityId = data.IdentityId;
        this.params.IdentityId = this._identityId;
        if (AWS3.util.isBrowser()) {
          this.setStorage("id", data.IdentityId);
          if (this.params.Logins) {
            this.setStorage("providers", Object.keys(this.params.Logins).join(","));
          }
        }
      },
      getStorage: function getStorage(key) {
        return this.storage[this.localStorageKey[key] + this.params.IdentityPoolId + (this.params.LoginId || "")];
      },
      setStorage: function setStorage(key, val) {
        try {
          this.storage[this.localStorageKey[key] + this.params.IdentityPoolId + (this.params.LoginId || "")] = val;
        } catch (_) {
        }
      },
      storage: function() {
        try {
          var storage = AWS3.util.isBrowser() && window.localStorage !== null && typeof window.localStorage === "object" ? window.localStorage : {};
          storage["aws.test-storage"] = "foobar";
          delete storage["aws.test-storage"];
          return storage;
        } catch (_) {
          return {};
        }
      }()
    });
  }
});

// node_modules/aws-sdk/lib/credentials/saml_credentials.js
var require_saml_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/saml_credentials.js"() {
    var AWS3 = require_core();
    var STS = require_sts2();
    AWS3.SAMLCredentials = AWS3.util.inherit(AWS3.Credentials, {
      constructor: function SAMLCredentials(params) {
        AWS3.Credentials.call(this);
        this.expired = true;
        this.params = params;
      },
      refresh: function refresh(callback) {
        this.coalesceRefresh(callback || AWS3.util.fn.callback);
      },
      load: function load(callback) {
        var self2 = this;
        self2.createClients();
        self2.service.assumeRoleWithSAML(function(err, data) {
          if (!err) {
            self2.service.credentialsFrom(data, self2);
          }
          callback(err);
        });
      },
      createClients: function() {
        this.service = this.service || new STS({ params: this.params });
      }
    });
  }
});

// node_modules/aws-sdk/lib/credentials/process_credentials.js
var require_process_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/process_credentials.js"() {
    var AWS3 = require_core();
    var proc = require("child_process");
    var iniLoader = AWS3.util.iniLoader;
    AWS3.ProcessCredentials = AWS3.util.inherit(AWS3.Credentials, {
      constructor: function ProcessCredentials(options) {
        AWS3.Credentials.call(this);
        options = options || {};
        this.filename = options.filename;
        this.profile = options.profile || process.env.AWS_PROFILE || AWS3.util.defaultProfile;
        this.get(options.callback || AWS3.util.fn.noop);
      },
      load: function load(callback) {
        var self2 = this;
        try {
          var profiles = AWS3.util.getProfilesFromSharedConfig(iniLoader, this.filename);
          var profile = profiles[this.profile] || {};
          if (Object.keys(profile).length === 0) {
            throw AWS3.util.error(new Error("Profile " + this.profile + " not found"), { code: "ProcessCredentialsProviderFailure" });
          }
          if (profile["credential_process"]) {
            this.loadViaCredentialProcess(profile, function(err, data) {
              if (err) {
                callback(err, null);
              } else {
                self2.expired = false;
                self2.accessKeyId = data.AccessKeyId;
                self2.secretAccessKey = data.SecretAccessKey;
                self2.sessionToken = data.SessionToken;
                if (data.Expiration) {
                  self2.expireTime = new Date(data.Expiration);
                }
                callback(null);
              }
            });
          } else {
            throw AWS3.util.error(new Error("Profile " + this.profile + " did not include credential process"), { code: "ProcessCredentialsProviderFailure" });
          }
        } catch (err) {
          callback(err);
        }
      },
      loadViaCredentialProcess: function loadViaCredentialProcess(profile, callback) {
        proc.exec(profile["credential_process"], { env: process.env }, function(err, stdOut, stdErr) {
          if (err) {
            callback(AWS3.util.error(new Error("credential_process returned error"), { code: "ProcessCredentialsProviderFailure" }), null);
          } else {
            try {
              var credData = JSON.parse(stdOut);
              if (credData.Expiration) {
                var currentTime = AWS3.util.date.getDate();
                var expireTime = new Date(credData.Expiration);
                if (expireTime < currentTime) {
                  throw Error("credential_process returned expired credentials");
                }
              }
              if (credData.Version !== 1) {
                throw Error("credential_process does not return Version == 1");
              }
              callback(null, credData);
            } catch (err2) {
              callback(AWS3.util.error(new Error(err2.message), { code: "ProcessCredentialsProviderFailure" }), null);
            }
          }
        });
      },
      refresh: function refresh(callback) {
        iniLoader.clearCachedFiles();
        this.coalesceRefresh(callback || AWS3.util.fn.callback);
      }
    });
  }
});

// node_modules/xml2js/lib/defaults.js
var require_defaults = __commonJS({
  "node_modules/xml2js/lib/defaults.js"(exports) {
    (function() {
      exports.defaults = {
        "0.1": {
          explicitCharkey: false,
          trim: true,
          normalize: true,
          normalizeTags: false,
          attrkey: "@",
          charkey: "#",
          explicitArray: false,
          ignoreAttrs: false,
          mergeAttrs: false,
          explicitRoot: false,
          validator: null,
          xmlns: false,
          explicitChildren: false,
          childkey: "@@",
          charsAsChildren: false,
          includeWhiteChars: false,
          async: false,
          strict: true,
          attrNameProcessors: null,
          attrValueProcessors: null,
          tagNameProcessors: null,
          valueProcessors: null,
          emptyTag: ""
        },
        "0.2": {
          explicitCharkey: false,
          trim: false,
          normalize: false,
          normalizeTags: false,
          attrkey: "$",
          charkey: "_",
          explicitArray: true,
          ignoreAttrs: false,
          mergeAttrs: false,
          explicitRoot: true,
          validator: null,
          xmlns: false,
          explicitChildren: false,
          preserveChildrenOrder: false,
          childkey: "$$",
          charsAsChildren: false,
          includeWhiteChars: false,
          async: false,
          strict: true,
          attrNameProcessors: null,
          attrValueProcessors: null,
          tagNameProcessors: null,
          valueProcessors: null,
          rootName: "root",
          xmldec: {
            "version": "1.0",
            "encoding": "UTF-8",
            "standalone": true
          },
          doctype: null,
          renderOpts: {
            "pretty": true,
            "indent": "  ",
            "newline": "\n"
          },
          headless: false,
          chunkSize: 1e4,
          emptyTag: "",
          cdata: false
        }
      };
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/Utility.js
var require_Utility = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/Utility.js"(exports, module2) {
    (function() {
      var assign, isArray, isEmpty, isFunction, isObject, isPlainObject, slice = [].slice, hasProp = {}.hasOwnProperty;
      assign = function() {
        var i, key, len, source, sources, target;
        target = arguments[0], sources = 2 <= arguments.length ? slice.call(arguments, 1) : [];
        if (isFunction(Object.assign)) {
          Object.assign.apply(null, arguments);
        } else {
          for (i = 0, len = sources.length; i < len; i++) {
            source = sources[i];
            if (source != null) {
              for (key in source) {
                if (!hasProp.call(source, key))
                  continue;
                target[key] = source[key];
              }
            }
          }
        }
        return target;
      };
      isFunction = function(val) {
        return !!val && Object.prototype.toString.call(val) === "[object Function]";
      };
      isObject = function(val) {
        var ref;
        return !!val && ((ref = typeof val) === "function" || ref === "object");
      };
      isArray = function(val) {
        if (isFunction(Array.isArray)) {
          return Array.isArray(val);
        } else {
          return Object.prototype.toString.call(val) === "[object Array]";
        }
      };
      isEmpty = function(val) {
        var key;
        if (isArray(val)) {
          return !val.length;
        } else {
          for (key in val) {
            if (!hasProp.call(val, key))
              continue;
            return false;
          }
          return true;
        }
      };
      isPlainObject = function(val) {
        var ctor, proto;
        return isObject(val) && (proto = Object.getPrototypeOf(val)) && (ctor = proto.constructor) && typeof ctor === "function" && ctor instanceof ctor && Function.prototype.toString.call(ctor) === Function.prototype.toString.call(Object);
      };
      module2.exports.assign = assign;
      module2.exports.isFunction = isFunction;
      module2.exports.isObject = isObject;
      module2.exports.isArray = isArray;
      module2.exports.isEmpty = isEmpty;
      module2.exports.isPlainObject = isPlainObject;
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLAttribute.js
var require_XMLAttribute = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLAttribute.js"(exports, module2) {
    (function() {
      var XMLAttribute;
      module2.exports = XMLAttribute = function() {
        function XMLAttribute2(parent, name, value) {
          this.options = parent.options;
          this.stringify = parent.stringify;
          if (name == null) {
            throw new Error("Missing attribute name of element " + parent.name);
          }
          if (value == null) {
            throw new Error("Missing attribute value for attribute " + name + " of element " + parent.name);
          }
          this.name = this.stringify.attName(name);
          this.value = this.stringify.attValue(value);
        }
        XMLAttribute2.prototype.clone = function() {
          return Object.create(this);
        };
        XMLAttribute2.prototype.toString = function(options) {
          return this.options.writer.set(options).attribute(this);
        };
        return XMLAttribute2;
      }();
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLElement.js
var require_XMLElement = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLElement.js"(exports, module2) {
    (function() {
      var XMLAttribute, XMLElement, XMLNode, isFunction, isObject, ref, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      ref = require_Utility(), isObject = ref.isObject, isFunction = ref.isFunction;
      XMLNode = require_XMLNode();
      XMLAttribute = require_XMLAttribute();
      module2.exports = XMLElement = function(superClass) {
        extend(XMLElement2, superClass);
        function XMLElement2(parent, name, attributes) {
          XMLElement2.__super__.constructor.call(this, parent);
          if (name == null) {
            throw new Error("Missing element name");
          }
          this.name = this.stringify.eleName(name);
          this.attributes = {};
          if (attributes != null) {
            this.attribute(attributes);
          }
          if (parent.isDocument) {
            this.isRoot = true;
            this.documentObject = parent;
            parent.rootObject = this;
          }
        }
        XMLElement2.prototype.clone = function() {
          var att, attName, clonedSelf, ref1;
          clonedSelf = Object.create(this);
          if (clonedSelf.isRoot) {
            clonedSelf.documentObject = null;
          }
          clonedSelf.attributes = {};
          ref1 = this.attributes;
          for (attName in ref1) {
            if (!hasProp.call(ref1, attName))
              continue;
            att = ref1[attName];
            clonedSelf.attributes[attName] = att.clone();
          }
          clonedSelf.children = [];
          this.children.forEach(function(child) {
            var clonedChild;
            clonedChild = child.clone();
            clonedChild.parent = clonedSelf;
            return clonedSelf.children.push(clonedChild);
          });
          return clonedSelf;
        };
        XMLElement2.prototype.attribute = function(name, value) {
          var attName, attValue;
          if (name != null) {
            name = name.valueOf();
          }
          if (isObject(name)) {
            for (attName in name) {
              if (!hasProp.call(name, attName))
                continue;
              attValue = name[attName];
              this.attribute(attName, attValue);
            }
          } else {
            if (isFunction(value)) {
              value = value.apply();
            }
            if (!this.options.skipNullAttributes || value != null) {
              this.attributes[name] = new XMLAttribute(this, name, value);
            }
          }
          return this;
        };
        XMLElement2.prototype.removeAttribute = function(name) {
          var attName, i, len;
          if (name == null) {
            throw new Error("Missing attribute name");
          }
          name = name.valueOf();
          if (Array.isArray(name)) {
            for (i = 0, len = name.length; i < len; i++) {
              attName = name[i];
              delete this.attributes[attName];
            }
          } else {
            delete this.attributes[name];
          }
          return this;
        };
        XMLElement2.prototype.toString = function(options) {
          return this.options.writer.set(options).element(this);
        };
        XMLElement2.prototype.att = function(name, value) {
          return this.attribute(name, value);
        };
        XMLElement2.prototype.a = function(name, value) {
          return this.attribute(name, value);
        };
        return XMLElement2;
      }(XMLNode);
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLCData.js
var require_XMLCData = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLCData.js"(exports, module2) {
    (function() {
      var XMLCData, XMLNode, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      XMLNode = require_XMLNode();
      module2.exports = XMLCData = function(superClass) {
        extend(XMLCData2, superClass);
        function XMLCData2(parent, text) {
          XMLCData2.__super__.constructor.call(this, parent);
          if (text == null) {
            throw new Error("Missing CDATA text");
          }
          this.text = this.stringify.cdata(text);
        }
        XMLCData2.prototype.clone = function() {
          return Object.create(this);
        };
        XMLCData2.prototype.toString = function(options) {
          return this.options.writer.set(options).cdata(this);
        };
        return XMLCData2;
      }(XMLNode);
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLComment.js
var require_XMLComment = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLComment.js"(exports, module2) {
    (function() {
      var XMLComment, XMLNode, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      XMLNode = require_XMLNode();
      module2.exports = XMLComment = function(superClass) {
        extend(XMLComment2, superClass);
        function XMLComment2(parent, text) {
          XMLComment2.__super__.constructor.call(this, parent);
          if (text == null) {
            throw new Error("Missing comment text");
          }
          this.text = this.stringify.comment(text);
        }
        XMLComment2.prototype.clone = function() {
          return Object.create(this);
        };
        XMLComment2.prototype.toString = function(options) {
          return this.options.writer.set(options).comment(this);
        };
        return XMLComment2;
      }(XMLNode);
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDeclaration.js
var require_XMLDeclaration = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDeclaration.js"(exports, module2) {
    (function() {
      var XMLDeclaration, XMLNode, isObject, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      isObject = require_Utility().isObject;
      XMLNode = require_XMLNode();
      module2.exports = XMLDeclaration = function(superClass) {
        extend(XMLDeclaration2, superClass);
        function XMLDeclaration2(parent, version, encoding, standalone) {
          var ref;
          XMLDeclaration2.__super__.constructor.call(this, parent);
          if (isObject(version)) {
            ref = version, version = ref.version, encoding = ref.encoding, standalone = ref.standalone;
          }
          if (!version) {
            version = "1.0";
          }
          this.version = this.stringify.xmlVersion(version);
          if (encoding != null) {
            this.encoding = this.stringify.xmlEncoding(encoding);
          }
          if (standalone != null) {
            this.standalone = this.stringify.xmlStandalone(standalone);
          }
        }
        XMLDeclaration2.prototype.toString = function(options) {
          return this.options.writer.set(options).declaration(this);
        };
        return XMLDeclaration2;
      }(XMLNode);
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDTDAttList.js
var require_XMLDTDAttList = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDTDAttList.js"(exports, module2) {
    (function() {
      var XMLDTDAttList, XMLNode, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      XMLNode = require_XMLNode();
      module2.exports = XMLDTDAttList = function(superClass) {
        extend(XMLDTDAttList2, superClass);
        function XMLDTDAttList2(parent, elementName, attributeName, attributeType, defaultValueType, defaultValue) {
          XMLDTDAttList2.__super__.constructor.call(this, parent);
          if (elementName == null) {
            throw new Error("Missing DTD element name");
          }
          if (attributeName == null) {
            throw new Error("Missing DTD attribute name");
          }
          if (!attributeType) {
            throw new Error("Missing DTD attribute type");
          }
          if (!defaultValueType) {
            throw new Error("Missing DTD attribute default");
          }
          if (defaultValueType.indexOf("#") !== 0) {
            defaultValueType = "#" + defaultValueType;
          }
          if (!defaultValueType.match(/^(#REQUIRED|#IMPLIED|#FIXED|#DEFAULT)$/)) {
            throw new Error("Invalid default value type; expected: #REQUIRED, #IMPLIED, #FIXED or #DEFAULT");
          }
          if (defaultValue && !defaultValueType.match(/^(#FIXED|#DEFAULT)$/)) {
            throw new Error("Default value only applies to #FIXED or #DEFAULT");
          }
          this.elementName = this.stringify.eleName(elementName);
          this.attributeName = this.stringify.attName(attributeName);
          this.attributeType = this.stringify.dtdAttType(attributeType);
          this.defaultValue = this.stringify.dtdAttDefault(defaultValue);
          this.defaultValueType = defaultValueType;
        }
        XMLDTDAttList2.prototype.toString = function(options) {
          return this.options.writer.set(options).dtdAttList(this);
        };
        return XMLDTDAttList2;
      }(XMLNode);
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDTDEntity.js
var require_XMLDTDEntity = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDTDEntity.js"(exports, module2) {
    (function() {
      var XMLDTDEntity, XMLNode, isObject, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      isObject = require_Utility().isObject;
      XMLNode = require_XMLNode();
      module2.exports = XMLDTDEntity = function(superClass) {
        extend(XMLDTDEntity2, superClass);
        function XMLDTDEntity2(parent, pe, name, value) {
          XMLDTDEntity2.__super__.constructor.call(this, parent);
          if (name == null) {
            throw new Error("Missing entity name");
          }
          if (value == null) {
            throw new Error("Missing entity value");
          }
          this.pe = !!pe;
          this.name = this.stringify.eleName(name);
          if (!isObject(value)) {
            this.value = this.stringify.dtdEntityValue(value);
          } else {
            if (!value.pubID && !value.sysID) {
              throw new Error("Public and/or system identifiers are required for an external entity");
            }
            if (value.pubID && !value.sysID) {
              throw new Error("System identifier is required for a public external entity");
            }
            if (value.pubID != null) {
              this.pubID = this.stringify.dtdPubID(value.pubID);
            }
            if (value.sysID != null) {
              this.sysID = this.stringify.dtdSysID(value.sysID);
            }
            if (value.nData != null) {
              this.nData = this.stringify.dtdNData(value.nData);
            }
            if (this.pe && this.nData) {
              throw new Error("Notation declaration is not allowed in a parameter entity");
            }
          }
        }
        XMLDTDEntity2.prototype.toString = function(options) {
          return this.options.writer.set(options).dtdEntity(this);
        };
        return XMLDTDEntity2;
      }(XMLNode);
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDTDElement.js
var require_XMLDTDElement = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDTDElement.js"(exports, module2) {
    (function() {
      var XMLDTDElement, XMLNode, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      XMLNode = require_XMLNode();
      module2.exports = XMLDTDElement = function(superClass) {
        extend(XMLDTDElement2, superClass);
        function XMLDTDElement2(parent, name, value) {
          XMLDTDElement2.__super__.constructor.call(this, parent);
          if (name == null) {
            throw new Error("Missing DTD element name");
          }
          if (!value) {
            value = "(#PCDATA)";
          }
          if (Array.isArray(value)) {
            value = "(" + value.join(",") + ")";
          }
          this.name = this.stringify.eleName(name);
          this.value = this.stringify.dtdElementValue(value);
        }
        XMLDTDElement2.prototype.toString = function(options) {
          return this.options.writer.set(options).dtdElement(this);
        };
        return XMLDTDElement2;
      }(XMLNode);
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDTDNotation.js
var require_XMLDTDNotation = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDTDNotation.js"(exports, module2) {
    (function() {
      var XMLDTDNotation, XMLNode, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      XMLNode = require_XMLNode();
      module2.exports = XMLDTDNotation = function(superClass) {
        extend(XMLDTDNotation2, superClass);
        function XMLDTDNotation2(parent, name, value) {
          XMLDTDNotation2.__super__.constructor.call(this, parent);
          if (name == null) {
            throw new Error("Missing notation name");
          }
          if (!value.pubID && !value.sysID) {
            throw new Error("Public or system identifiers are required for an external entity");
          }
          this.name = this.stringify.eleName(name);
          if (value.pubID != null) {
            this.pubID = this.stringify.dtdPubID(value.pubID);
          }
          if (value.sysID != null) {
            this.sysID = this.stringify.dtdSysID(value.sysID);
          }
        }
        XMLDTDNotation2.prototype.toString = function(options) {
          return this.options.writer.set(options).dtdNotation(this);
        };
        return XMLDTDNotation2;
      }(XMLNode);
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDocType.js
var require_XMLDocType = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDocType.js"(exports, module2) {
    (function() {
      var XMLDTDAttList, XMLDTDElement, XMLDTDEntity, XMLDTDNotation, XMLDocType, XMLNode, isObject, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      isObject = require_Utility().isObject;
      XMLNode = require_XMLNode();
      XMLDTDAttList = require_XMLDTDAttList();
      XMLDTDEntity = require_XMLDTDEntity();
      XMLDTDElement = require_XMLDTDElement();
      XMLDTDNotation = require_XMLDTDNotation();
      module2.exports = XMLDocType = function(superClass) {
        extend(XMLDocType2, superClass);
        function XMLDocType2(parent, pubID, sysID) {
          var ref, ref1;
          XMLDocType2.__super__.constructor.call(this, parent);
          this.documentObject = parent;
          if (isObject(pubID)) {
            ref = pubID, pubID = ref.pubID, sysID = ref.sysID;
          }
          if (sysID == null) {
            ref1 = [pubID, sysID], sysID = ref1[0], pubID = ref1[1];
          }
          if (pubID != null) {
            this.pubID = this.stringify.dtdPubID(pubID);
          }
          if (sysID != null) {
            this.sysID = this.stringify.dtdSysID(sysID);
          }
        }
        XMLDocType2.prototype.element = function(name, value) {
          var child;
          child = new XMLDTDElement(this, name, value);
          this.children.push(child);
          return this;
        };
        XMLDocType2.prototype.attList = function(elementName, attributeName, attributeType, defaultValueType, defaultValue) {
          var child;
          child = new XMLDTDAttList(this, elementName, attributeName, attributeType, defaultValueType, defaultValue);
          this.children.push(child);
          return this;
        };
        XMLDocType2.prototype.entity = function(name, value) {
          var child;
          child = new XMLDTDEntity(this, false, name, value);
          this.children.push(child);
          return this;
        };
        XMLDocType2.prototype.pEntity = function(name, value) {
          var child;
          child = new XMLDTDEntity(this, true, name, value);
          this.children.push(child);
          return this;
        };
        XMLDocType2.prototype.notation = function(name, value) {
          var child;
          child = new XMLDTDNotation(this, name, value);
          this.children.push(child);
          return this;
        };
        XMLDocType2.prototype.toString = function(options) {
          return this.options.writer.set(options).docType(this);
        };
        XMLDocType2.prototype.ele = function(name, value) {
          return this.element(name, value);
        };
        XMLDocType2.prototype.att = function(elementName, attributeName, attributeType, defaultValueType, defaultValue) {
          return this.attList(elementName, attributeName, attributeType, defaultValueType, defaultValue);
        };
        XMLDocType2.prototype.ent = function(name, value) {
          return this.entity(name, value);
        };
        XMLDocType2.prototype.pent = function(name, value) {
          return this.pEntity(name, value);
        };
        XMLDocType2.prototype.not = function(name, value) {
          return this.notation(name, value);
        };
        XMLDocType2.prototype.up = function() {
          return this.root() || this.documentObject;
        };
        return XMLDocType2;
      }(XMLNode);
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLRaw.js
var require_XMLRaw = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLRaw.js"(exports, module2) {
    (function() {
      var XMLNode, XMLRaw, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      XMLNode = require_XMLNode();
      module2.exports = XMLRaw = function(superClass) {
        extend(XMLRaw2, superClass);
        function XMLRaw2(parent, text) {
          XMLRaw2.__super__.constructor.call(this, parent);
          if (text == null) {
            throw new Error("Missing raw text");
          }
          this.value = this.stringify.raw(text);
        }
        XMLRaw2.prototype.clone = function() {
          return Object.create(this);
        };
        XMLRaw2.prototype.toString = function(options) {
          return this.options.writer.set(options).raw(this);
        };
        return XMLRaw2;
      }(XMLNode);
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLText.js
var require_XMLText = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLText.js"(exports, module2) {
    (function() {
      var XMLNode, XMLText, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      XMLNode = require_XMLNode();
      module2.exports = XMLText = function(superClass) {
        extend(XMLText2, superClass);
        function XMLText2(parent, text) {
          XMLText2.__super__.constructor.call(this, parent);
          if (text == null) {
            throw new Error("Missing element text");
          }
          this.value = this.stringify.eleText(text);
        }
        XMLText2.prototype.clone = function() {
          return Object.create(this);
        };
        XMLText2.prototype.toString = function(options) {
          return this.options.writer.set(options).text(this);
        };
        return XMLText2;
      }(XMLNode);
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLProcessingInstruction.js
var require_XMLProcessingInstruction = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLProcessingInstruction.js"(exports, module2) {
    (function() {
      var XMLNode, XMLProcessingInstruction, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      XMLNode = require_XMLNode();
      module2.exports = XMLProcessingInstruction = function(superClass) {
        extend(XMLProcessingInstruction2, superClass);
        function XMLProcessingInstruction2(parent, target, value) {
          XMLProcessingInstruction2.__super__.constructor.call(this, parent);
          if (target == null) {
            throw new Error("Missing instruction target");
          }
          this.target = this.stringify.insTarget(target);
          if (value) {
            this.value = this.stringify.insValue(value);
          }
        }
        XMLProcessingInstruction2.prototype.clone = function() {
          return Object.create(this);
        };
        XMLProcessingInstruction2.prototype.toString = function(options) {
          return this.options.writer.set(options).processingInstruction(this);
        };
        return XMLProcessingInstruction2;
      }(XMLNode);
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLNode.js
var require_XMLNode = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLNode.js"(exports, module2) {
    (function() {
      var XMLCData, XMLComment, XMLDeclaration, XMLDocType, XMLElement, XMLNode, XMLProcessingInstruction, XMLRaw, XMLText, isEmpty, isFunction, isObject, ref, hasProp = {}.hasOwnProperty;
      ref = require_Utility(), isObject = ref.isObject, isFunction = ref.isFunction, isEmpty = ref.isEmpty;
      XMLElement = null;
      XMLCData = null;
      XMLComment = null;
      XMLDeclaration = null;
      XMLDocType = null;
      XMLRaw = null;
      XMLText = null;
      XMLProcessingInstruction = null;
      module2.exports = XMLNode = function() {
        function XMLNode2(parent) {
          this.parent = parent;
          if (this.parent) {
            this.options = this.parent.options;
            this.stringify = this.parent.stringify;
          }
          this.children = [];
          if (!XMLElement) {
            XMLElement = require_XMLElement();
            XMLCData = require_XMLCData();
            XMLComment = require_XMLComment();
            XMLDeclaration = require_XMLDeclaration();
            XMLDocType = require_XMLDocType();
            XMLRaw = require_XMLRaw();
            XMLText = require_XMLText();
            XMLProcessingInstruction = require_XMLProcessingInstruction();
          }
        }
        XMLNode2.prototype.element = function(name, attributes, text) {
          var childNode, item, j, k, key, lastChild, len, len1, ref1, val;
          lastChild = null;
          if (attributes == null) {
            attributes = {};
          }
          attributes = attributes.valueOf();
          if (!isObject(attributes)) {
            ref1 = [attributes, text], text = ref1[0], attributes = ref1[1];
          }
          if (name != null) {
            name = name.valueOf();
          }
          if (Array.isArray(name)) {
            for (j = 0, len = name.length; j < len; j++) {
              item = name[j];
              lastChild = this.element(item);
            }
          } else if (isFunction(name)) {
            lastChild = this.element(name.apply());
          } else if (isObject(name)) {
            for (key in name) {
              if (!hasProp.call(name, key))
                continue;
              val = name[key];
              if (isFunction(val)) {
                val = val.apply();
              }
              if (isObject(val) && isEmpty(val)) {
                val = null;
              }
              if (!this.options.ignoreDecorators && this.stringify.convertAttKey && key.indexOf(this.stringify.convertAttKey) === 0) {
                lastChild = this.attribute(key.substr(this.stringify.convertAttKey.length), val);
              } else if (!this.options.separateArrayItems && Array.isArray(val)) {
                for (k = 0, len1 = val.length; k < len1; k++) {
                  item = val[k];
                  childNode = {};
                  childNode[key] = item;
                  lastChild = this.element(childNode);
                }
              } else if (isObject(val)) {
                lastChild = this.element(key);
                lastChild.element(val);
              } else {
                lastChild = this.element(key, val);
              }
            }
          } else {
            if (!this.options.ignoreDecorators && this.stringify.convertTextKey && name.indexOf(this.stringify.convertTextKey) === 0) {
              lastChild = this.text(text);
            } else if (!this.options.ignoreDecorators && this.stringify.convertCDataKey && name.indexOf(this.stringify.convertCDataKey) === 0) {
              lastChild = this.cdata(text);
            } else if (!this.options.ignoreDecorators && this.stringify.convertCommentKey && name.indexOf(this.stringify.convertCommentKey) === 0) {
              lastChild = this.comment(text);
            } else if (!this.options.ignoreDecorators && this.stringify.convertRawKey && name.indexOf(this.stringify.convertRawKey) === 0) {
              lastChild = this.raw(text);
            } else if (!this.options.ignoreDecorators && this.stringify.convertPIKey && name.indexOf(this.stringify.convertPIKey) === 0) {
              lastChild = this.instruction(name.substr(this.stringify.convertPIKey.length), text);
            } else {
              lastChild = this.node(name, attributes, text);
            }
          }
          if (lastChild == null) {
            throw new Error("Could not create any elements with: " + name);
          }
          return lastChild;
        };
        XMLNode2.prototype.insertBefore = function(name, attributes, text) {
          var child, i, removed;
          if (this.isRoot) {
            throw new Error("Cannot insert elements at root level");
          }
          i = this.parent.children.indexOf(this);
          removed = this.parent.children.splice(i);
          child = this.parent.element(name, attributes, text);
          Array.prototype.push.apply(this.parent.children, removed);
          return child;
        };
        XMLNode2.prototype.insertAfter = function(name, attributes, text) {
          var child, i, removed;
          if (this.isRoot) {
            throw new Error("Cannot insert elements at root level");
          }
          i = this.parent.children.indexOf(this);
          removed = this.parent.children.splice(i + 1);
          child = this.parent.element(name, attributes, text);
          Array.prototype.push.apply(this.parent.children, removed);
          return child;
        };
        XMLNode2.prototype.remove = function() {
          var i, ref1;
          if (this.isRoot) {
            throw new Error("Cannot remove the root element");
          }
          i = this.parent.children.indexOf(this);
          [].splice.apply(this.parent.children, [i, i - i + 1].concat(ref1 = [])), ref1;
          return this.parent;
        };
        XMLNode2.prototype.node = function(name, attributes, text) {
          var child, ref1;
          if (name != null) {
            name = name.valueOf();
          }
          attributes || (attributes = {});
          attributes = attributes.valueOf();
          if (!isObject(attributes)) {
            ref1 = [attributes, text], text = ref1[0], attributes = ref1[1];
          }
          child = new XMLElement(this, name, attributes);
          if (text != null) {
            child.text(text);
          }
          this.children.push(child);
          return child;
        };
        XMLNode2.prototype.text = function(value) {
          var child;
          child = new XMLText(this, value);
          this.children.push(child);
          return this;
        };
        XMLNode2.prototype.cdata = function(value) {
          var child;
          child = new XMLCData(this, value);
          this.children.push(child);
          return this;
        };
        XMLNode2.prototype.comment = function(value) {
          var child;
          child = new XMLComment(this, value);
          this.children.push(child);
          return this;
        };
        XMLNode2.prototype.commentBefore = function(value) {
          var child, i, removed;
          i = this.parent.children.indexOf(this);
          removed = this.parent.children.splice(i);
          child = this.parent.comment(value);
          Array.prototype.push.apply(this.parent.children, removed);
          return this;
        };
        XMLNode2.prototype.commentAfter = function(value) {
          var child, i, removed;
          i = this.parent.children.indexOf(this);
          removed = this.parent.children.splice(i + 1);
          child = this.parent.comment(value);
          Array.prototype.push.apply(this.parent.children, removed);
          return this;
        };
        XMLNode2.prototype.raw = function(value) {
          var child;
          child = new XMLRaw(this, value);
          this.children.push(child);
          return this;
        };
        XMLNode2.prototype.instruction = function(target, value) {
          var insTarget, insValue, instruction, j, len;
          if (target != null) {
            target = target.valueOf();
          }
          if (value != null) {
            value = value.valueOf();
          }
          if (Array.isArray(target)) {
            for (j = 0, len = target.length; j < len; j++) {
              insTarget = target[j];
              this.instruction(insTarget);
            }
          } else if (isObject(target)) {
            for (insTarget in target) {
              if (!hasProp.call(target, insTarget))
                continue;
              insValue = target[insTarget];
              this.instruction(insTarget, insValue);
            }
          } else {
            if (isFunction(value)) {
              value = value.apply();
            }
            instruction = new XMLProcessingInstruction(this, target, value);
            this.children.push(instruction);
          }
          return this;
        };
        XMLNode2.prototype.instructionBefore = function(target, value) {
          var child, i, removed;
          i = this.parent.children.indexOf(this);
          removed = this.parent.children.splice(i);
          child = this.parent.instruction(target, value);
          Array.prototype.push.apply(this.parent.children, removed);
          return this;
        };
        XMLNode2.prototype.instructionAfter = function(target, value) {
          var child, i, removed;
          i = this.parent.children.indexOf(this);
          removed = this.parent.children.splice(i + 1);
          child = this.parent.instruction(target, value);
          Array.prototype.push.apply(this.parent.children, removed);
          return this;
        };
        XMLNode2.prototype.declaration = function(version, encoding, standalone) {
          var doc, xmldec;
          doc = this.document();
          xmldec = new XMLDeclaration(doc, version, encoding, standalone);
          if (doc.children[0] instanceof XMLDeclaration) {
            doc.children[0] = xmldec;
          } else {
            doc.children.unshift(xmldec);
          }
          return doc.root() || doc;
        };
        XMLNode2.prototype.doctype = function(pubID, sysID) {
          var child, doc, doctype, i, j, k, len, len1, ref1, ref2;
          doc = this.document();
          doctype = new XMLDocType(doc, pubID, sysID);
          ref1 = doc.children;
          for (i = j = 0, len = ref1.length; j < len; i = ++j) {
            child = ref1[i];
            if (child instanceof XMLDocType) {
              doc.children[i] = doctype;
              return doctype;
            }
          }
          ref2 = doc.children;
          for (i = k = 0, len1 = ref2.length; k < len1; i = ++k) {
            child = ref2[i];
            if (child.isRoot) {
              doc.children.splice(i, 0, doctype);
              return doctype;
            }
          }
          doc.children.push(doctype);
          return doctype;
        };
        XMLNode2.prototype.up = function() {
          if (this.isRoot) {
            throw new Error("The root node has no parent. Use doc() if you need to get the document object.");
          }
          return this.parent;
        };
        XMLNode2.prototype.root = function() {
          var node;
          node = this;
          while (node) {
            if (node.isDocument) {
              return node.rootObject;
            } else if (node.isRoot) {
              return node;
            } else {
              node = node.parent;
            }
          }
        };
        XMLNode2.prototype.document = function() {
          var node;
          node = this;
          while (node) {
            if (node.isDocument) {
              return node;
            } else {
              node = node.parent;
            }
          }
        };
        XMLNode2.prototype.end = function(options) {
          return this.document().end(options);
        };
        XMLNode2.prototype.prev = function() {
          var i;
          i = this.parent.children.indexOf(this);
          if (i < 1) {
            throw new Error("Already at the first node");
          }
          return this.parent.children[i - 1];
        };
        XMLNode2.prototype.next = function() {
          var i;
          i = this.parent.children.indexOf(this);
          if (i === -1 || i === this.parent.children.length - 1) {
            throw new Error("Already at the last node");
          }
          return this.parent.children[i + 1];
        };
        XMLNode2.prototype.importDocument = function(doc) {
          var clonedRoot;
          clonedRoot = doc.root().clone();
          clonedRoot.parent = this;
          clonedRoot.isRoot = false;
          this.children.push(clonedRoot);
          return this;
        };
        XMLNode2.prototype.ele = function(name, attributes, text) {
          return this.element(name, attributes, text);
        };
        XMLNode2.prototype.nod = function(name, attributes, text) {
          return this.node(name, attributes, text);
        };
        XMLNode2.prototype.txt = function(value) {
          return this.text(value);
        };
        XMLNode2.prototype.dat = function(value) {
          return this.cdata(value);
        };
        XMLNode2.prototype.com = function(value) {
          return this.comment(value);
        };
        XMLNode2.prototype.ins = function(target, value) {
          return this.instruction(target, value);
        };
        XMLNode2.prototype.doc = function() {
          return this.document();
        };
        XMLNode2.prototype.dec = function(version, encoding, standalone) {
          return this.declaration(version, encoding, standalone);
        };
        XMLNode2.prototype.dtd = function(pubID, sysID) {
          return this.doctype(pubID, sysID);
        };
        XMLNode2.prototype.e = function(name, attributes, text) {
          return this.element(name, attributes, text);
        };
        XMLNode2.prototype.n = function(name, attributes, text) {
          return this.node(name, attributes, text);
        };
        XMLNode2.prototype.t = function(value) {
          return this.text(value);
        };
        XMLNode2.prototype.d = function(value) {
          return this.cdata(value);
        };
        XMLNode2.prototype.c = function(value) {
          return this.comment(value);
        };
        XMLNode2.prototype.r = function(value) {
          return this.raw(value);
        };
        XMLNode2.prototype.i = function(target, value) {
          return this.instruction(target, value);
        };
        XMLNode2.prototype.u = function() {
          return this.up();
        };
        XMLNode2.prototype.importXMLBuilder = function(doc) {
          return this.importDocument(doc);
        };
        return XMLNode2;
      }();
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLStringifier.js
var require_XMLStringifier = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLStringifier.js"(exports, module2) {
    (function() {
      var XMLStringifier, bind = function(fn, me) {
        return function() {
          return fn.apply(me, arguments);
        };
      }, hasProp = {}.hasOwnProperty;
      module2.exports = XMLStringifier = function() {
        function XMLStringifier2(options) {
          this.assertLegalChar = bind(this.assertLegalChar, this);
          var key, ref, value;
          options || (options = {});
          this.noDoubleEncoding = options.noDoubleEncoding;
          ref = options.stringify || {};
          for (key in ref) {
            if (!hasProp.call(ref, key))
              continue;
            value = ref[key];
            this[key] = value;
          }
        }
        XMLStringifier2.prototype.eleName = function(val) {
          val = "" + val || "";
          return this.assertLegalChar(val);
        };
        XMLStringifier2.prototype.eleText = function(val) {
          val = "" + val || "";
          return this.assertLegalChar(this.elEscape(val));
        };
        XMLStringifier2.prototype.cdata = function(val) {
          val = "" + val || "";
          val = val.replace("]]>", "]]]]><![CDATA[>");
          return this.assertLegalChar(val);
        };
        XMLStringifier2.prototype.comment = function(val) {
          val = "" + val || "";
          if (val.match(/--/)) {
            throw new Error("Comment text cannot contain double-hypen: " + val);
          }
          return this.assertLegalChar(val);
        };
        XMLStringifier2.prototype.raw = function(val) {
          return "" + val || "";
        };
        XMLStringifier2.prototype.attName = function(val) {
          return val = "" + val || "";
        };
        XMLStringifier2.prototype.attValue = function(val) {
          val = "" + val || "";
          return this.attEscape(val);
        };
        XMLStringifier2.prototype.insTarget = function(val) {
          return "" + val || "";
        };
        XMLStringifier2.prototype.insValue = function(val) {
          val = "" + val || "";
          if (val.match(/\?>/)) {
            throw new Error("Invalid processing instruction value: " + val);
          }
          return val;
        };
        XMLStringifier2.prototype.xmlVersion = function(val) {
          val = "" + val || "";
          if (!val.match(/1\.[0-9]+/)) {
            throw new Error("Invalid version number: " + val);
          }
          return val;
        };
        XMLStringifier2.prototype.xmlEncoding = function(val) {
          val = "" + val || "";
          if (!val.match(/^[A-Za-z](?:[A-Za-z0-9._-])*$/)) {
            throw new Error("Invalid encoding: " + val);
          }
          return val;
        };
        XMLStringifier2.prototype.xmlStandalone = function(val) {
          if (val) {
            return "yes";
          } else {
            return "no";
          }
        };
        XMLStringifier2.prototype.dtdPubID = function(val) {
          return "" + val || "";
        };
        XMLStringifier2.prototype.dtdSysID = function(val) {
          return "" + val || "";
        };
        XMLStringifier2.prototype.dtdElementValue = function(val) {
          return "" + val || "";
        };
        XMLStringifier2.prototype.dtdAttType = function(val) {
          return "" + val || "";
        };
        XMLStringifier2.prototype.dtdAttDefault = function(val) {
          if (val != null) {
            return "" + val || "";
          } else {
            return val;
          }
        };
        XMLStringifier2.prototype.dtdEntityValue = function(val) {
          return "" + val || "";
        };
        XMLStringifier2.prototype.dtdNData = function(val) {
          return "" + val || "";
        };
        XMLStringifier2.prototype.convertAttKey = "@";
        XMLStringifier2.prototype.convertPIKey = "?";
        XMLStringifier2.prototype.convertTextKey = "#text";
        XMLStringifier2.prototype.convertCDataKey = "#cdata";
        XMLStringifier2.prototype.convertCommentKey = "#comment";
        XMLStringifier2.prototype.convertRawKey = "#raw";
        XMLStringifier2.prototype.assertLegalChar = function(str) {
          var res;
          res = str.match(/[\0\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/);
          if (res) {
            throw new Error("Invalid character in string: " + str + " at index " + res.index);
          }
          return str;
        };
        XMLStringifier2.prototype.elEscape = function(str) {
          var ampregex;
          ampregex = this.noDoubleEncoding ? /(?!&\S+;)&/g : /&/g;
          return str.replace(ampregex, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\r/g, "&#xD;");
        };
        XMLStringifier2.prototype.attEscape = function(str) {
          var ampregex;
          ampregex = this.noDoubleEncoding ? /(?!&\S+;)&/g : /&/g;
          return str.replace(ampregex, "&amp;").replace(/</g, "&lt;").replace(/"/g, "&quot;").replace(/\t/g, "&#x9;").replace(/\n/g, "&#xA;").replace(/\r/g, "&#xD;");
        };
        return XMLStringifier2;
      }();
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLWriterBase.js
var require_XMLWriterBase = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLWriterBase.js"(exports, module2) {
    (function() {
      var XMLWriterBase, hasProp = {}.hasOwnProperty;
      module2.exports = XMLWriterBase = function() {
        function XMLWriterBase2(options) {
          var key, ref, ref1, ref2, ref3, ref4, ref5, ref6, value;
          options || (options = {});
          this.pretty = options.pretty || false;
          this.allowEmpty = (ref = options.allowEmpty) != null ? ref : false;
          if (this.pretty) {
            this.indent = (ref1 = options.indent) != null ? ref1 : "  ";
            this.newline = (ref2 = options.newline) != null ? ref2 : "\n";
            this.offset = (ref3 = options.offset) != null ? ref3 : 0;
            this.dontprettytextnodes = (ref4 = options.dontprettytextnodes) != null ? ref4 : 0;
          } else {
            this.indent = "";
            this.newline = "";
            this.offset = 0;
            this.dontprettytextnodes = 0;
          }
          this.spacebeforeslash = (ref5 = options.spacebeforeslash) != null ? ref5 : "";
          if (this.spacebeforeslash === true) {
            this.spacebeforeslash = " ";
          }
          this.newlinedefault = this.newline;
          this.prettydefault = this.pretty;
          ref6 = options.writer || {};
          for (key in ref6) {
            if (!hasProp.call(ref6, key))
              continue;
            value = ref6[key];
            this[key] = value;
          }
        }
        XMLWriterBase2.prototype.set = function(options) {
          var key, ref, value;
          options || (options = {});
          if ("pretty" in options) {
            this.pretty = options.pretty;
          }
          if ("allowEmpty" in options) {
            this.allowEmpty = options.allowEmpty;
          }
          if (this.pretty) {
            this.indent = "indent" in options ? options.indent : "  ";
            this.newline = "newline" in options ? options.newline : "\n";
            this.offset = "offset" in options ? options.offset : 0;
            this.dontprettytextnodes = "dontprettytextnodes" in options ? options.dontprettytextnodes : 0;
          } else {
            this.indent = "";
            this.newline = "";
            this.offset = 0;
            this.dontprettytextnodes = 0;
          }
          this.spacebeforeslash = "spacebeforeslash" in options ? options.spacebeforeslash : "";
          if (this.spacebeforeslash === true) {
            this.spacebeforeslash = " ";
          }
          this.newlinedefault = this.newline;
          this.prettydefault = this.pretty;
          ref = options.writer || {};
          for (key in ref) {
            if (!hasProp.call(ref, key))
              continue;
            value = ref[key];
            this[key] = value;
          }
          return this;
        };
        XMLWriterBase2.prototype.space = function(level) {
          var indent;
          if (this.pretty) {
            indent = (level || 0) + this.offset + 1;
            if (indent > 0) {
              return new Array(indent).join(this.indent);
            } else {
              return "";
            }
          } else {
            return "";
          }
        };
        return XMLWriterBase2;
      }();
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLStringWriter.js
var require_XMLStringWriter = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLStringWriter.js"(exports, module2) {
    (function() {
      var XMLCData, XMLComment, XMLDTDAttList, XMLDTDElement, XMLDTDEntity, XMLDTDNotation, XMLDeclaration, XMLDocType, XMLElement, XMLProcessingInstruction, XMLRaw, XMLStringWriter, XMLText, XMLWriterBase, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      XMLDeclaration = require_XMLDeclaration();
      XMLDocType = require_XMLDocType();
      XMLCData = require_XMLCData();
      XMLComment = require_XMLComment();
      XMLElement = require_XMLElement();
      XMLRaw = require_XMLRaw();
      XMLText = require_XMLText();
      XMLProcessingInstruction = require_XMLProcessingInstruction();
      XMLDTDAttList = require_XMLDTDAttList();
      XMLDTDElement = require_XMLDTDElement();
      XMLDTDEntity = require_XMLDTDEntity();
      XMLDTDNotation = require_XMLDTDNotation();
      XMLWriterBase = require_XMLWriterBase();
      module2.exports = XMLStringWriter = function(superClass) {
        extend(XMLStringWriter2, superClass);
        function XMLStringWriter2(options) {
          XMLStringWriter2.__super__.constructor.call(this, options);
        }
        XMLStringWriter2.prototype.document = function(doc) {
          var child, i, len, r, ref;
          this.textispresent = false;
          r = "";
          ref = doc.children;
          for (i = 0, len = ref.length; i < len; i++) {
            child = ref[i];
            r += function() {
              switch (false) {
                case !(child instanceof XMLDeclaration):
                  return this.declaration(child);
                case !(child instanceof XMLDocType):
                  return this.docType(child);
                case !(child instanceof XMLComment):
                  return this.comment(child);
                case !(child instanceof XMLProcessingInstruction):
                  return this.processingInstruction(child);
                default:
                  return this.element(child, 0);
              }
            }.call(this);
          }
          if (this.pretty && r.slice(-this.newline.length) === this.newline) {
            r = r.slice(0, -this.newline.length);
          }
          return r;
        };
        XMLStringWriter2.prototype.attribute = function(att) {
          return " " + att.name + '="' + att.value + '"';
        };
        XMLStringWriter2.prototype.cdata = function(node, level) {
          return this.space(level) + "<![CDATA[" + node.text + "]]>" + this.newline;
        };
        XMLStringWriter2.prototype.comment = function(node, level) {
          return this.space(level) + "<!-- " + node.text + " -->" + this.newline;
        };
        XMLStringWriter2.prototype.declaration = function(node, level) {
          var r;
          r = this.space(level);
          r += '<?xml version="' + node.version + '"';
          if (node.encoding != null) {
            r += ' encoding="' + node.encoding + '"';
          }
          if (node.standalone != null) {
            r += ' standalone="' + node.standalone + '"';
          }
          r += this.spacebeforeslash + "?>";
          r += this.newline;
          return r;
        };
        XMLStringWriter2.prototype.docType = function(node, level) {
          var child, i, len, r, ref;
          level || (level = 0);
          r = this.space(level);
          r += "<!DOCTYPE " + node.root().name;
          if (node.pubID && node.sysID) {
            r += ' PUBLIC "' + node.pubID + '" "' + node.sysID + '"';
          } else if (node.sysID) {
            r += ' SYSTEM "' + node.sysID + '"';
          }
          if (node.children.length > 0) {
            r += " [";
            r += this.newline;
            ref = node.children;
            for (i = 0, len = ref.length; i < len; i++) {
              child = ref[i];
              r += function() {
                switch (false) {
                  case !(child instanceof XMLDTDAttList):
                    return this.dtdAttList(child, level + 1);
                  case !(child instanceof XMLDTDElement):
                    return this.dtdElement(child, level + 1);
                  case !(child instanceof XMLDTDEntity):
                    return this.dtdEntity(child, level + 1);
                  case !(child instanceof XMLDTDNotation):
                    return this.dtdNotation(child, level + 1);
                  case !(child instanceof XMLCData):
                    return this.cdata(child, level + 1);
                  case !(child instanceof XMLComment):
                    return this.comment(child, level + 1);
                  case !(child instanceof XMLProcessingInstruction):
                    return this.processingInstruction(child, level + 1);
                  default:
                    throw new Error("Unknown DTD node type: " + child.constructor.name);
                }
              }.call(this);
            }
            r += "]";
          }
          r += this.spacebeforeslash + ">";
          r += this.newline;
          return r;
        };
        XMLStringWriter2.prototype.element = function(node, level) {
          var att, child, i, j, len, len1, name, r, ref, ref1, ref2, space, textispresentwasset;
          level || (level = 0);
          textispresentwasset = false;
          if (this.textispresent) {
            this.newline = "";
            this.pretty = false;
          } else {
            this.newline = this.newlinedefault;
            this.pretty = this.prettydefault;
          }
          space = this.space(level);
          r = "";
          r += space + "<" + node.name;
          ref = node.attributes;
          for (name in ref) {
            if (!hasProp.call(ref, name))
              continue;
            att = ref[name];
            r += this.attribute(att);
          }
          if (node.children.length === 0 || node.children.every(function(e) {
            return e.value === "";
          })) {
            if (this.allowEmpty) {
              r += "></" + node.name + ">" + this.newline;
            } else {
              r += this.spacebeforeslash + "/>" + this.newline;
            }
          } else if (this.pretty && node.children.length === 1 && node.children[0].value != null) {
            r += ">";
            r += node.children[0].value;
            r += "</" + node.name + ">" + this.newline;
          } else {
            if (this.dontprettytextnodes) {
              ref1 = node.children;
              for (i = 0, len = ref1.length; i < len; i++) {
                child = ref1[i];
                if (child.value != null) {
                  this.textispresent++;
                  textispresentwasset = true;
                  break;
                }
              }
            }
            if (this.textispresent) {
              this.newline = "";
              this.pretty = false;
              space = this.space(level);
            }
            r += ">" + this.newline;
            ref2 = node.children;
            for (j = 0, len1 = ref2.length; j < len1; j++) {
              child = ref2[j];
              r += function() {
                switch (false) {
                  case !(child instanceof XMLCData):
                    return this.cdata(child, level + 1);
                  case !(child instanceof XMLComment):
                    return this.comment(child, level + 1);
                  case !(child instanceof XMLElement):
                    return this.element(child, level + 1);
                  case !(child instanceof XMLRaw):
                    return this.raw(child, level + 1);
                  case !(child instanceof XMLText):
                    return this.text(child, level + 1);
                  case !(child instanceof XMLProcessingInstruction):
                    return this.processingInstruction(child, level + 1);
                  default:
                    throw new Error("Unknown XML node type: " + child.constructor.name);
                }
              }.call(this);
            }
            if (textispresentwasset) {
              this.textispresent--;
            }
            if (!this.textispresent) {
              this.newline = this.newlinedefault;
              this.pretty = this.prettydefault;
            }
            r += space + "</" + node.name + ">" + this.newline;
          }
          return r;
        };
        XMLStringWriter2.prototype.processingInstruction = function(node, level) {
          var r;
          r = this.space(level) + "<?" + node.target;
          if (node.value) {
            r += " " + node.value;
          }
          r += this.spacebeforeslash + "?>" + this.newline;
          return r;
        };
        XMLStringWriter2.prototype.raw = function(node, level) {
          return this.space(level) + node.value + this.newline;
        };
        XMLStringWriter2.prototype.text = function(node, level) {
          return this.space(level) + node.value + this.newline;
        };
        XMLStringWriter2.prototype.dtdAttList = function(node, level) {
          var r;
          r = this.space(level) + "<!ATTLIST " + node.elementName + " " + node.attributeName + " " + node.attributeType;
          if (node.defaultValueType !== "#DEFAULT") {
            r += " " + node.defaultValueType;
          }
          if (node.defaultValue) {
            r += ' "' + node.defaultValue + '"';
          }
          r += this.spacebeforeslash + ">" + this.newline;
          return r;
        };
        XMLStringWriter2.prototype.dtdElement = function(node, level) {
          return this.space(level) + "<!ELEMENT " + node.name + " " + node.value + this.spacebeforeslash + ">" + this.newline;
        };
        XMLStringWriter2.prototype.dtdEntity = function(node, level) {
          var r;
          r = this.space(level) + "<!ENTITY";
          if (node.pe) {
            r += " %";
          }
          r += " " + node.name;
          if (node.value) {
            r += ' "' + node.value + '"';
          } else {
            if (node.pubID && node.sysID) {
              r += ' PUBLIC "' + node.pubID + '" "' + node.sysID + '"';
            } else if (node.sysID) {
              r += ' SYSTEM "' + node.sysID + '"';
            }
            if (node.nData) {
              r += " NDATA " + node.nData;
            }
          }
          r += this.spacebeforeslash + ">" + this.newline;
          return r;
        };
        XMLStringWriter2.prototype.dtdNotation = function(node, level) {
          var r;
          r = this.space(level) + "<!NOTATION " + node.name;
          if (node.pubID && node.sysID) {
            r += ' PUBLIC "' + node.pubID + '" "' + node.sysID + '"';
          } else if (node.pubID) {
            r += ' PUBLIC "' + node.pubID + '"';
          } else if (node.sysID) {
            r += ' SYSTEM "' + node.sysID + '"';
          }
          r += this.spacebeforeslash + ">" + this.newline;
          return r;
        };
        XMLStringWriter2.prototype.openNode = function(node, level) {
          var att, name, r, ref;
          level || (level = 0);
          if (node instanceof XMLElement) {
            r = this.space(level) + "<" + node.name;
            ref = node.attributes;
            for (name in ref) {
              if (!hasProp.call(ref, name))
                continue;
              att = ref[name];
              r += this.attribute(att);
            }
            r += (node.children ? ">" : "/>") + this.newline;
            return r;
          } else {
            r = this.space(level) + "<!DOCTYPE " + node.rootNodeName;
            if (node.pubID && node.sysID) {
              r += ' PUBLIC "' + node.pubID + '" "' + node.sysID + '"';
            } else if (node.sysID) {
              r += ' SYSTEM "' + node.sysID + '"';
            }
            r += (node.children ? " [" : ">") + this.newline;
            return r;
          }
        };
        XMLStringWriter2.prototype.closeNode = function(node, level) {
          level || (level = 0);
          switch (false) {
            case !(node instanceof XMLElement):
              return this.space(level) + "</" + node.name + ">" + this.newline;
            case !(node instanceof XMLDocType):
              return this.space(level) + "]>" + this.newline;
          }
        };
        return XMLStringWriter2;
      }(XMLWriterBase);
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDocument.js
var require_XMLDocument = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDocument.js"(exports, module2) {
    (function() {
      var XMLDocument, XMLNode, XMLStringWriter, XMLStringifier, isPlainObject, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      isPlainObject = require_Utility().isPlainObject;
      XMLNode = require_XMLNode();
      XMLStringifier = require_XMLStringifier();
      XMLStringWriter = require_XMLStringWriter();
      module2.exports = XMLDocument = function(superClass) {
        extend(XMLDocument2, superClass);
        function XMLDocument2(options) {
          XMLDocument2.__super__.constructor.call(this, null);
          options || (options = {});
          if (!options.writer) {
            options.writer = new XMLStringWriter();
          }
          this.options = options;
          this.stringify = new XMLStringifier(options);
          this.isDocument = true;
        }
        XMLDocument2.prototype.end = function(writer) {
          var writerOptions;
          if (!writer) {
            writer = this.options.writer;
          } else if (isPlainObject(writer)) {
            writerOptions = writer;
            writer = this.options.writer.set(writerOptions);
          }
          return writer.document(this);
        };
        XMLDocument2.prototype.toString = function(options) {
          return this.options.writer.set(options).document(this);
        };
        return XMLDocument2;
      }(XMLNode);
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDocumentCB.js
var require_XMLDocumentCB = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLDocumentCB.js"(exports, module2) {
    (function() {
      var XMLAttribute, XMLCData, XMLComment, XMLDTDAttList, XMLDTDElement, XMLDTDEntity, XMLDTDNotation, XMLDeclaration, XMLDocType, XMLDocumentCB, XMLElement, XMLProcessingInstruction, XMLRaw, XMLStringWriter, XMLStringifier, XMLText, isFunction, isObject, isPlainObject, ref, hasProp = {}.hasOwnProperty;
      ref = require_Utility(), isObject = ref.isObject, isFunction = ref.isFunction, isPlainObject = ref.isPlainObject;
      XMLElement = require_XMLElement();
      XMLCData = require_XMLCData();
      XMLComment = require_XMLComment();
      XMLRaw = require_XMLRaw();
      XMLText = require_XMLText();
      XMLProcessingInstruction = require_XMLProcessingInstruction();
      XMLDeclaration = require_XMLDeclaration();
      XMLDocType = require_XMLDocType();
      XMLDTDAttList = require_XMLDTDAttList();
      XMLDTDEntity = require_XMLDTDEntity();
      XMLDTDElement = require_XMLDTDElement();
      XMLDTDNotation = require_XMLDTDNotation();
      XMLAttribute = require_XMLAttribute();
      XMLStringifier = require_XMLStringifier();
      XMLStringWriter = require_XMLStringWriter();
      module2.exports = XMLDocumentCB = function() {
        function XMLDocumentCB2(options, onData, onEnd) {
          var writerOptions;
          options || (options = {});
          if (!options.writer) {
            options.writer = new XMLStringWriter(options);
          } else if (isPlainObject(options.writer)) {
            writerOptions = options.writer;
            options.writer = new XMLStringWriter(writerOptions);
          }
          this.options = options;
          this.writer = options.writer;
          this.stringify = new XMLStringifier(options);
          this.onDataCallback = onData || function() {
          };
          this.onEndCallback = onEnd || function() {
          };
          this.currentNode = null;
          this.currentLevel = -1;
          this.openTags = {};
          this.documentStarted = false;
          this.documentCompleted = false;
          this.root = null;
        }
        XMLDocumentCB2.prototype.node = function(name, attributes, text) {
          var ref1;
          if (name == null) {
            throw new Error("Missing node name");
          }
          if (this.root && this.currentLevel === -1) {
            throw new Error("Document can only have one root node");
          }
          this.openCurrent();
          name = name.valueOf();
          if (attributes == null) {
            attributes = {};
          }
          attributes = attributes.valueOf();
          if (!isObject(attributes)) {
            ref1 = [attributes, text], text = ref1[0], attributes = ref1[1];
          }
          this.currentNode = new XMLElement(this, name, attributes);
          this.currentNode.children = false;
          this.currentLevel++;
          this.openTags[this.currentLevel] = this.currentNode;
          if (text != null) {
            this.text(text);
          }
          return this;
        };
        XMLDocumentCB2.prototype.element = function(name, attributes, text) {
          if (this.currentNode && this.currentNode instanceof XMLDocType) {
            return this.dtdElement.apply(this, arguments);
          } else {
            return this.node(name, attributes, text);
          }
        };
        XMLDocumentCB2.prototype.attribute = function(name, value) {
          var attName, attValue;
          if (!this.currentNode || this.currentNode.children) {
            throw new Error("att() can only be used immediately after an ele() call in callback mode");
          }
          if (name != null) {
            name = name.valueOf();
          }
          if (isObject(name)) {
            for (attName in name) {
              if (!hasProp.call(name, attName))
                continue;
              attValue = name[attName];
              this.attribute(attName, attValue);
            }
          } else {
            if (isFunction(value)) {
              value = value.apply();
            }
            if (!this.options.skipNullAttributes || value != null) {
              this.currentNode.attributes[name] = new XMLAttribute(this, name, value);
            }
          }
          return this;
        };
        XMLDocumentCB2.prototype.text = function(value) {
          var node;
          this.openCurrent();
          node = new XMLText(this, value);
          this.onData(this.writer.text(node, this.currentLevel + 1));
          return this;
        };
        XMLDocumentCB2.prototype.cdata = function(value) {
          var node;
          this.openCurrent();
          node = new XMLCData(this, value);
          this.onData(this.writer.cdata(node, this.currentLevel + 1));
          return this;
        };
        XMLDocumentCB2.prototype.comment = function(value) {
          var node;
          this.openCurrent();
          node = new XMLComment(this, value);
          this.onData(this.writer.comment(node, this.currentLevel + 1));
          return this;
        };
        XMLDocumentCB2.prototype.raw = function(value) {
          var node;
          this.openCurrent();
          node = new XMLRaw(this, value);
          this.onData(this.writer.raw(node, this.currentLevel + 1));
          return this;
        };
        XMLDocumentCB2.prototype.instruction = function(target, value) {
          var i, insTarget, insValue, len, node;
          this.openCurrent();
          if (target != null) {
            target = target.valueOf();
          }
          if (value != null) {
            value = value.valueOf();
          }
          if (Array.isArray(target)) {
            for (i = 0, len = target.length; i < len; i++) {
              insTarget = target[i];
              this.instruction(insTarget);
            }
          } else if (isObject(target)) {
            for (insTarget in target) {
              if (!hasProp.call(target, insTarget))
                continue;
              insValue = target[insTarget];
              this.instruction(insTarget, insValue);
            }
          } else {
            if (isFunction(value)) {
              value = value.apply();
            }
            node = new XMLProcessingInstruction(this, target, value);
            this.onData(this.writer.processingInstruction(node, this.currentLevel + 1));
          }
          return this;
        };
        XMLDocumentCB2.prototype.declaration = function(version, encoding, standalone) {
          var node;
          this.openCurrent();
          if (this.documentStarted) {
            throw new Error("declaration() must be the first node");
          }
          node = new XMLDeclaration(this, version, encoding, standalone);
          this.onData(this.writer.declaration(node, this.currentLevel + 1));
          return this;
        };
        XMLDocumentCB2.prototype.doctype = function(root, pubID, sysID) {
          this.openCurrent();
          if (root == null) {
            throw new Error("Missing root node name");
          }
          if (this.root) {
            throw new Error("dtd() must come before the root node");
          }
          this.currentNode = new XMLDocType(this, pubID, sysID);
          this.currentNode.rootNodeName = root;
          this.currentNode.children = false;
          this.currentLevel++;
          this.openTags[this.currentLevel] = this.currentNode;
          return this;
        };
        XMLDocumentCB2.prototype.dtdElement = function(name, value) {
          var node;
          this.openCurrent();
          node = new XMLDTDElement(this, name, value);
          this.onData(this.writer.dtdElement(node, this.currentLevel + 1));
          return this;
        };
        XMLDocumentCB2.prototype.attList = function(elementName, attributeName, attributeType, defaultValueType, defaultValue) {
          var node;
          this.openCurrent();
          node = new XMLDTDAttList(this, elementName, attributeName, attributeType, defaultValueType, defaultValue);
          this.onData(this.writer.dtdAttList(node, this.currentLevel + 1));
          return this;
        };
        XMLDocumentCB2.prototype.entity = function(name, value) {
          var node;
          this.openCurrent();
          node = new XMLDTDEntity(this, false, name, value);
          this.onData(this.writer.dtdEntity(node, this.currentLevel + 1));
          return this;
        };
        XMLDocumentCB2.prototype.pEntity = function(name, value) {
          var node;
          this.openCurrent();
          node = new XMLDTDEntity(this, true, name, value);
          this.onData(this.writer.dtdEntity(node, this.currentLevel + 1));
          return this;
        };
        XMLDocumentCB2.prototype.notation = function(name, value) {
          var node;
          this.openCurrent();
          node = new XMLDTDNotation(this, name, value);
          this.onData(this.writer.dtdNotation(node, this.currentLevel + 1));
          return this;
        };
        XMLDocumentCB2.prototype.up = function() {
          if (this.currentLevel < 0) {
            throw new Error("The document node has no parent");
          }
          if (this.currentNode) {
            if (this.currentNode.children) {
              this.closeNode(this.currentNode);
            } else {
              this.openNode(this.currentNode);
            }
            this.currentNode = null;
          } else {
            this.closeNode(this.openTags[this.currentLevel]);
          }
          delete this.openTags[this.currentLevel];
          this.currentLevel--;
          return this;
        };
        XMLDocumentCB2.prototype.end = function() {
          while (this.currentLevel >= 0) {
            this.up();
          }
          return this.onEnd();
        };
        XMLDocumentCB2.prototype.openCurrent = function() {
          if (this.currentNode) {
            this.currentNode.children = true;
            return this.openNode(this.currentNode);
          }
        };
        XMLDocumentCB2.prototype.openNode = function(node) {
          if (!node.isOpen) {
            if (!this.root && this.currentLevel === 0 && node instanceof XMLElement) {
              this.root = node;
            }
            this.onData(this.writer.openNode(node, this.currentLevel));
            return node.isOpen = true;
          }
        };
        XMLDocumentCB2.prototype.closeNode = function(node) {
          if (!node.isClosed) {
            this.onData(this.writer.closeNode(node, this.currentLevel));
            return node.isClosed = true;
          }
        };
        XMLDocumentCB2.prototype.onData = function(chunk) {
          this.documentStarted = true;
          return this.onDataCallback(chunk);
        };
        XMLDocumentCB2.prototype.onEnd = function() {
          this.documentCompleted = true;
          return this.onEndCallback();
        };
        XMLDocumentCB2.prototype.ele = function() {
          return this.element.apply(this, arguments);
        };
        XMLDocumentCB2.prototype.nod = function(name, attributes, text) {
          return this.node(name, attributes, text);
        };
        XMLDocumentCB2.prototype.txt = function(value) {
          return this.text(value);
        };
        XMLDocumentCB2.prototype.dat = function(value) {
          return this.cdata(value);
        };
        XMLDocumentCB2.prototype.com = function(value) {
          return this.comment(value);
        };
        XMLDocumentCB2.prototype.ins = function(target, value) {
          return this.instruction(target, value);
        };
        XMLDocumentCB2.prototype.dec = function(version, encoding, standalone) {
          return this.declaration(version, encoding, standalone);
        };
        XMLDocumentCB2.prototype.dtd = function(root, pubID, sysID) {
          return this.doctype(root, pubID, sysID);
        };
        XMLDocumentCB2.prototype.e = function(name, attributes, text) {
          return this.element(name, attributes, text);
        };
        XMLDocumentCB2.prototype.n = function(name, attributes, text) {
          return this.node(name, attributes, text);
        };
        XMLDocumentCB2.prototype.t = function(value) {
          return this.text(value);
        };
        XMLDocumentCB2.prototype.d = function(value) {
          return this.cdata(value);
        };
        XMLDocumentCB2.prototype.c = function(value) {
          return this.comment(value);
        };
        XMLDocumentCB2.prototype.r = function(value) {
          return this.raw(value);
        };
        XMLDocumentCB2.prototype.i = function(target, value) {
          return this.instruction(target, value);
        };
        XMLDocumentCB2.prototype.att = function() {
          if (this.currentNode && this.currentNode instanceof XMLDocType) {
            return this.attList.apply(this, arguments);
          } else {
            return this.attribute.apply(this, arguments);
          }
        };
        XMLDocumentCB2.prototype.a = function() {
          if (this.currentNode && this.currentNode instanceof XMLDocType) {
            return this.attList.apply(this, arguments);
          } else {
            return this.attribute.apply(this, arguments);
          }
        };
        XMLDocumentCB2.prototype.ent = function(name, value) {
          return this.entity(name, value);
        };
        XMLDocumentCB2.prototype.pent = function(name, value) {
          return this.pEntity(name, value);
        };
        XMLDocumentCB2.prototype.not = function(name, value) {
          return this.notation(name, value);
        };
        return XMLDocumentCB2;
      }();
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/XMLStreamWriter.js
var require_XMLStreamWriter = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/XMLStreamWriter.js"(exports, module2) {
    (function() {
      var XMLCData, XMLComment, XMLDTDAttList, XMLDTDElement, XMLDTDEntity, XMLDTDNotation, XMLDeclaration, XMLDocType, XMLElement, XMLProcessingInstruction, XMLRaw, XMLStreamWriter, XMLText, XMLWriterBase, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      XMLDeclaration = require_XMLDeclaration();
      XMLDocType = require_XMLDocType();
      XMLCData = require_XMLCData();
      XMLComment = require_XMLComment();
      XMLElement = require_XMLElement();
      XMLRaw = require_XMLRaw();
      XMLText = require_XMLText();
      XMLProcessingInstruction = require_XMLProcessingInstruction();
      XMLDTDAttList = require_XMLDTDAttList();
      XMLDTDElement = require_XMLDTDElement();
      XMLDTDEntity = require_XMLDTDEntity();
      XMLDTDNotation = require_XMLDTDNotation();
      XMLWriterBase = require_XMLWriterBase();
      module2.exports = XMLStreamWriter = function(superClass) {
        extend(XMLStreamWriter2, superClass);
        function XMLStreamWriter2(stream, options) {
          XMLStreamWriter2.__super__.constructor.call(this, options);
          this.stream = stream;
        }
        XMLStreamWriter2.prototype.document = function(doc) {
          var child, i, j, len, len1, ref, ref1, results;
          ref = doc.children;
          for (i = 0, len = ref.length; i < len; i++) {
            child = ref[i];
            child.isLastRootNode = false;
          }
          doc.children[doc.children.length - 1].isLastRootNode = true;
          ref1 = doc.children;
          results = [];
          for (j = 0, len1 = ref1.length; j < len1; j++) {
            child = ref1[j];
            switch (false) {
              case !(child instanceof XMLDeclaration):
                results.push(this.declaration(child));
                break;
              case !(child instanceof XMLDocType):
                results.push(this.docType(child));
                break;
              case !(child instanceof XMLComment):
                results.push(this.comment(child));
                break;
              case !(child instanceof XMLProcessingInstruction):
                results.push(this.processingInstruction(child));
                break;
              default:
                results.push(this.element(child));
            }
          }
          return results;
        };
        XMLStreamWriter2.prototype.attribute = function(att) {
          return this.stream.write(" " + att.name + '="' + att.value + '"');
        };
        XMLStreamWriter2.prototype.cdata = function(node, level) {
          return this.stream.write(this.space(level) + "<![CDATA[" + node.text + "]]>" + this.endline(node));
        };
        XMLStreamWriter2.prototype.comment = function(node, level) {
          return this.stream.write(this.space(level) + "<!-- " + node.text + " -->" + this.endline(node));
        };
        XMLStreamWriter2.prototype.declaration = function(node, level) {
          this.stream.write(this.space(level));
          this.stream.write('<?xml version="' + node.version + '"');
          if (node.encoding != null) {
            this.stream.write(' encoding="' + node.encoding + '"');
          }
          if (node.standalone != null) {
            this.stream.write(' standalone="' + node.standalone + '"');
          }
          this.stream.write(this.spacebeforeslash + "?>");
          return this.stream.write(this.endline(node));
        };
        XMLStreamWriter2.prototype.docType = function(node, level) {
          var child, i, len, ref;
          level || (level = 0);
          this.stream.write(this.space(level));
          this.stream.write("<!DOCTYPE " + node.root().name);
          if (node.pubID && node.sysID) {
            this.stream.write(' PUBLIC "' + node.pubID + '" "' + node.sysID + '"');
          } else if (node.sysID) {
            this.stream.write(' SYSTEM "' + node.sysID + '"');
          }
          if (node.children.length > 0) {
            this.stream.write(" [");
            this.stream.write(this.endline(node));
            ref = node.children;
            for (i = 0, len = ref.length; i < len; i++) {
              child = ref[i];
              switch (false) {
                case !(child instanceof XMLDTDAttList):
                  this.dtdAttList(child, level + 1);
                  break;
                case !(child instanceof XMLDTDElement):
                  this.dtdElement(child, level + 1);
                  break;
                case !(child instanceof XMLDTDEntity):
                  this.dtdEntity(child, level + 1);
                  break;
                case !(child instanceof XMLDTDNotation):
                  this.dtdNotation(child, level + 1);
                  break;
                case !(child instanceof XMLCData):
                  this.cdata(child, level + 1);
                  break;
                case !(child instanceof XMLComment):
                  this.comment(child, level + 1);
                  break;
                case !(child instanceof XMLProcessingInstruction):
                  this.processingInstruction(child, level + 1);
                  break;
                default:
                  throw new Error("Unknown DTD node type: " + child.constructor.name);
              }
            }
            this.stream.write("]");
          }
          this.stream.write(this.spacebeforeslash + ">");
          return this.stream.write(this.endline(node));
        };
        XMLStreamWriter2.prototype.element = function(node, level) {
          var att, child, i, len, name, ref, ref1, space;
          level || (level = 0);
          space = this.space(level);
          this.stream.write(space + "<" + node.name);
          ref = node.attributes;
          for (name in ref) {
            if (!hasProp.call(ref, name))
              continue;
            att = ref[name];
            this.attribute(att);
          }
          if (node.children.length === 0 || node.children.every(function(e) {
            return e.value === "";
          })) {
            if (this.allowEmpty) {
              this.stream.write("></" + node.name + ">");
            } else {
              this.stream.write(this.spacebeforeslash + "/>");
            }
          } else if (this.pretty && node.children.length === 1 && node.children[0].value != null) {
            this.stream.write(">");
            this.stream.write(node.children[0].value);
            this.stream.write("</" + node.name + ">");
          } else {
            this.stream.write(">" + this.newline);
            ref1 = node.children;
            for (i = 0, len = ref1.length; i < len; i++) {
              child = ref1[i];
              switch (false) {
                case !(child instanceof XMLCData):
                  this.cdata(child, level + 1);
                  break;
                case !(child instanceof XMLComment):
                  this.comment(child, level + 1);
                  break;
                case !(child instanceof XMLElement):
                  this.element(child, level + 1);
                  break;
                case !(child instanceof XMLRaw):
                  this.raw(child, level + 1);
                  break;
                case !(child instanceof XMLText):
                  this.text(child, level + 1);
                  break;
                case !(child instanceof XMLProcessingInstruction):
                  this.processingInstruction(child, level + 1);
                  break;
                default:
                  throw new Error("Unknown XML node type: " + child.constructor.name);
              }
            }
            this.stream.write(space + "</" + node.name + ">");
          }
          return this.stream.write(this.endline(node));
        };
        XMLStreamWriter2.prototype.processingInstruction = function(node, level) {
          this.stream.write(this.space(level) + "<?" + node.target);
          if (node.value) {
            this.stream.write(" " + node.value);
          }
          return this.stream.write(this.spacebeforeslash + "?>" + this.endline(node));
        };
        XMLStreamWriter2.prototype.raw = function(node, level) {
          return this.stream.write(this.space(level) + node.value + this.endline(node));
        };
        XMLStreamWriter2.prototype.text = function(node, level) {
          return this.stream.write(this.space(level) + node.value + this.endline(node));
        };
        XMLStreamWriter2.prototype.dtdAttList = function(node, level) {
          this.stream.write(this.space(level) + "<!ATTLIST " + node.elementName + " " + node.attributeName + " " + node.attributeType);
          if (node.defaultValueType !== "#DEFAULT") {
            this.stream.write(" " + node.defaultValueType);
          }
          if (node.defaultValue) {
            this.stream.write(' "' + node.defaultValue + '"');
          }
          return this.stream.write(this.spacebeforeslash + ">" + this.endline(node));
        };
        XMLStreamWriter2.prototype.dtdElement = function(node, level) {
          this.stream.write(this.space(level) + "<!ELEMENT " + node.name + " " + node.value);
          return this.stream.write(this.spacebeforeslash + ">" + this.endline(node));
        };
        XMLStreamWriter2.prototype.dtdEntity = function(node, level) {
          this.stream.write(this.space(level) + "<!ENTITY");
          if (node.pe) {
            this.stream.write(" %");
          }
          this.stream.write(" " + node.name);
          if (node.value) {
            this.stream.write(' "' + node.value + '"');
          } else {
            if (node.pubID && node.sysID) {
              this.stream.write(' PUBLIC "' + node.pubID + '" "' + node.sysID + '"');
            } else if (node.sysID) {
              this.stream.write(' SYSTEM "' + node.sysID + '"');
            }
            if (node.nData) {
              this.stream.write(" NDATA " + node.nData);
            }
          }
          return this.stream.write(this.spacebeforeslash + ">" + this.endline(node));
        };
        XMLStreamWriter2.prototype.dtdNotation = function(node, level) {
          this.stream.write(this.space(level) + "<!NOTATION " + node.name);
          if (node.pubID && node.sysID) {
            this.stream.write(' PUBLIC "' + node.pubID + '" "' + node.sysID + '"');
          } else if (node.pubID) {
            this.stream.write(' PUBLIC "' + node.pubID + '"');
          } else if (node.sysID) {
            this.stream.write(' SYSTEM "' + node.sysID + '"');
          }
          return this.stream.write(this.spacebeforeslash + ">" + this.endline(node));
        };
        XMLStreamWriter2.prototype.endline = function(node) {
          if (!node.isLastRootNode) {
            return this.newline;
          } else {
            return "";
          }
        };
        return XMLStreamWriter2;
      }(XMLWriterBase);
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/xmlbuilder/lib/index.js
var require_lib12 = __commonJS({
  "node_modules/xml2js/node_modules/xmlbuilder/lib/index.js"(exports, module2) {
    (function() {
      var XMLDocument, XMLDocumentCB, XMLStreamWriter, XMLStringWriter, assign, isFunction, ref;
      ref = require_Utility(), assign = ref.assign, isFunction = ref.isFunction;
      XMLDocument = require_XMLDocument();
      XMLDocumentCB = require_XMLDocumentCB();
      XMLStringWriter = require_XMLStringWriter();
      XMLStreamWriter = require_XMLStreamWriter();
      module2.exports.create = function(name, xmldec, doctype, options) {
        var doc, root;
        if (name == null) {
          throw new Error("Root element needs a name");
        }
        options = assign({}, xmldec, doctype, options);
        doc = new XMLDocument(options);
        root = doc.element(name);
        if (!options.headless) {
          doc.declaration(options);
          if (options.pubID != null || options.sysID != null) {
            doc.doctype(options);
          }
        }
        return root;
      };
      module2.exports.begin = function(options, onData, onEnd) {
        var ref1;
        if (isFunction(options)) {
          ref1 = [options, onData], onData = ref1[0], onEnd = ref1[1];
          options = {};
        }
        if (onData) {
          return new XMLDocumentCB(options, onData, onEnd);
        } else {
          return new XMLDocument(options);
        }
      };
      module2.exports.stringWriter = function(options) {
        return new XMLStringWriter(options);
      };
      module2.exports.streamWriter = function(stream, options) {
        return new XMLStreamWriter(stream, options);
      };
    }).call(exports);
  }
});

// node_modules/xml2js/lib/builder.js
var require_builder3 = __commonJS({
  "node_modules/xml2js/lib/builder.js"(exports) {
    (function() {
      "use strict";
      var builder, defaults, escapeCDATA, requiresCDATA, wrapCDATA, hasProp = {}.hasOwnProperty;
      builder = require_lib12();
      defaults = require_defaults().defaults;
      requiresCDATA = function(entry) {
        return typeof entry === "string" && (entry.indexOf("&") >= 0 || entry.indexOf(">") >= 0 || entry.indexOf("<") >= 0);
      };
      wrapCDATA = function(entry) {
        return "<![CDATA[" + escapeCDATA(entry) + "]]>";
      };
      escapeCDATA = function(entry) {
        return entry.replace("]]>", "]]]]><![CDATA[>");
      };
      exports.Builder = function() {
        function Builder(opts) {
          var key, ref, value;
          this.options = {};
          ref = defaults["0.2"];
          for (key in ref) {
            if (!hasProp.call(ref, key))
              continue;
            value = ref[key];
            this.options[key] = value;
          }
          for (key in opts) {
            if (!hasProp.call(opts, key))
              continue;
            value = opts[key];
            this.options[key] = value;
          }
        }
        Builder.prototype.buildObject = function(rootObj) {
          var attrkey, charkey, render, rootElement, rootName;
          attrkey = this.options.attrkey;
          charkey = this.options.charkey;
          if (Object.keys(rootObj).length === 1 && this.options.rootName === defaults["0.2"].rootName) {
            rootName = Object.keys(rootObj)[0];
            rootObj = rootObj[rootName];
          } else {
            rootName = this.options.rootName;
          }
          render = function(_this) {
            return function(element, obj) {
              var attr, child, entry, index, key, value;
              if (typeof obj !== "object") {
                if (_this.options.cdata && requiresCDATA(obj)) {
                  element.raw(wrapCDATA(obj));
                } else {
                  element.txt(obj);
                }
              } else if (Array.isArray(obj)) {
                for (index in obj) {
                  if (!hasProp.call(obj, index))
                    continue;
                  child = obj[index];
                  for (key in child) {
                    entry = child[key];
                    element = render(element.ele(key), entry).up();
                  }
                }
              } else {
                for (key in obj) {
                  if (!hasProp.call(obj, key))
                    continue;
                  child = obj[key];
                  if (key === attrkey) {
                    if (typeof child === "object") {
                      for (attr in child) {
                        value = child[attr];
                        element = element.att(attr, value);
                      }
                    }
                  } else if (key === charkey) {
                    if (_this.options.cdata && requiresCDATA(child)) {
                      element = element.raw(wrapCDATA(child));
                    } else {
                      element = element.txt(child);
                    }
                  } else if (Array.isArray(child)) {
                    for (index in child) {
                      if (!hasProp.call(child, index))
                        continue;
                      entry = child[index];
                      if (typeof entry === "string") {
                        if (_this.options.cdata && requiresCDATA(entry)) {
                          element = element.ele(key).raw(wrapCDATA(entry)).up();
                        } else {
                          element = element.ele(key, entry).up();
                        }
                      } else {
                        element = render(element.ele(key), entry).up();
                      }
                    }
                  } else if (typeof child === "object") {
                    element = render(element.ele(key), child).up();
                  } else {
                    if (typeof child === "string" && _this.options.cdata && requiresCDATA(child)) {
                      element = element.ele(key).raw(wrapCDATA(child)).up();
                    } else {
                      if (child == null) {
                        child = "";
                      }
                      element = element.ele(key, child.toString()).up();
                    }
                  }
                }
              }
              return element;
            };
          }(this);
          rootElement = builder.create(rootName, this.options.xmldec, this.options.doctype, {
            headless: this.options.headless,
            allowSurrogateChars: this.options.allowSurrogateChars
          });
          return render(rootElement, rootObj).end(this.options.renderOpts);
        };
        return Builder;
      }();
    }).call(exports);
  }
});

// node_modules/xml2js/node_modules/sax/lib/sax.js
var require_sax2 = __commonJS({
  "node_modules/xml2js/node_modules/sax/lib/sax.js"(exports) {
    (function(sax) {
      sax.parser = function(strict, opt) {
        return new SAXParser(strict, opt);
      };
      sax.SAXParser = SAXParser;
      sax.SAXStream = SAXStream;
      sax.createStream = createStream;
      sax.MAX_BUFFER_LENGTH = 64 * 1024;
      var buffers = [
        "comment",
        "sgmlDecl",
        "textNode",
        "tagName",
        "doctype",
        "procInstName",
        "procInstBody",
        "entity",
        "attribName",
        "attribValue",
        "cdata",
        "script"
      ];
      sax.EVENTS = [
        "text",
        "processinginstruction",
        "sgmldeclaration",
        "doctype",
        "comment",
        "opentagstart",
        "attribute",
        "opentag",
        "closetag",
        "opencdata",
        "cdata",
        "closecdata",
        "error",
        "end",
        "ready",
        "script",
        "opennamespace",
        "closenamespace"
      ];
      function SAXParser(strict, opt) {
        if (!(this instanceof SAXParser)) {
          return new SAXParser(strict, opt);
        }
        var parser = this;
        clearBuffers(parser);
        parser.q = parser.c = "";
        parser.bufferCheckPosition = sax.MAX_BUFFER_LENGTH;
        parser.opt = opt || {};
        parser.opt.lowercase = parser.opt.lowercase || parser.opt.lowercasetags;
        parser.looseCase = parser.opt.lowercase ? "toLowerCase" : "toUpperCase";
        parser.tags = [];
        parser.closed = parser.closedRoot = parser.sawRoot = false;
        parser.tag = parser.error = null;
        parser.strict = !!strict;
        parser.noscript = !!(strict || parser.opt.noscript);
        parser.state = S.BEGIN;
        parser.strictEntities = parser.opt.strictEntities;
        parser.ENTITIES = parser.strictEntities ? Object.create(sax.XML_ENTITIES) : Object.create(sax.ENTITIES);
        parser.attribList = [];
        if (parser.opt.xmlns) {
          parser.ns = Object.create(rootNS);
        }
        parser.trackPosition = parser.opt.position !== false;
        if (parser.trackPosition) {
          parser.position = parser.line = parser.column = 0;
        }
        emit(parser, "onready");
      }
      if (!Object.create) {
        Object.create = function(o) {
          function F() {
          }
          F.prototype = o;
          var newf = new F();
          return newf;
        };
      }
      if (!Object.keys) {
        Object.keys = function(o) {
          var a = [];
          for (var i in o)
            if (o.hasOwnProperty(i))
              a.push(i);
          return a;
        };
      }
      function checkBufferLength(parser) {
        var maxAllowed = Math.max(sax.MAX_BUFFER_LENGTH, 10);
        var maxActual = 0;
        for (var i = 0, l = buffers.length; i < l; i++) {
          var len = parser[buffers[i]].length;
          if (len > maxAllowed) {
            switch (buffers[i]) {
              case "textNode":
                closeText(parser);
                break;
              case "cdata":
                emitNode(parser, "oncdata", parser.cdata);
                parser.cdata = "";
                break;
              case "script":
                emitNode(parser, "onscript", parser.script);
                parser.script = "";
                break;
              default:
                error(parser, "Max buffer length exceeded: " + buffers[i]);
            }
          }
          maxActual = Math.max(maxActual, len);
        }
        var m = sax.MAX_BUFFER_LENGTH - maxActual;
        parser.bufferCheckPosition = m + parser.position;
      }
      function clearBuffers(parser) {
        for (var i = 0, l = buffers.length; i < l; i++) {
          parser[buffers[i]] = "";
        }
      }
      function flushBuffers(parser) {
        closeText(parser);
        if (parser.cdata !== "") {
          emitNode(parser, "oncdata", parser.cdata);
          parser.cdata = "";
        }
        if (parser.script !== "") {
          emitNode(parser, "onscript", parser.script);
          parser.script = "";
        }
      }
      SAXParser.prototype = {
        end: function() {
          end(this);
        },
        write,
        resume: function() {
          this.error = null;
          return this;
        },
        close: function() {
          return this.write(null);
        },
        flush: function() {
          flushBuffers(this);
        }
      };
      var Stream;
      try {
        Stream = require("stream").Stream;
      } catch (ex) {
        Stream = function() {
        };
      }
      var streamWraps = sax.EVENTS.filter(function(ev) {
        return ev !== "error" && ev !== "end";
      });
      function createStream(strict, opt) {
        return new SAXStream(strict, opt);
      }
      function SAXStream(strict, opt) {
        if (!(this instanceof SAXStream)) {
          return new SAXStream(strict, opt);
        }
        Stream.apply(this);
        this._parser = new SAXParser(strict, opt);
        this.writable = true;
        this.readable = true;
        var me = this;
        this._parser.onend = function() {
          me.emit("end");
        };
        this._parser.onerror = function(er) {
          me.emit("error", er);
          me._parser.error = null;
        };
        this._decoder = null;
        streamWraps.forEach(function(ev) {
          Object.defineProperty(me, "on" + ev, {
            get: function() {
              return me._parser["on" + ev];
            },
            set: function(h) {
              if (!h) {
                me.removeAllListeners(ev);
                me._parser["on" + ev] = h;
                return h;
              }
              me.on(ev, h);
            },
            enumerable: true,
            configurable: false
          });
        });
      }
      SAXStream.prototype = Object.create(Stream.prototype, {
        constructor: {
          value: SAXStream
        }
      });
      SAXStream.prototype.write = function(data) {
        if (typeof Buffer === "function" && typeof Buffer.isBuffer === "function" && Buffer.isBuffer(data)) {
          if (!this._decoder) {
            var SD = require("string_decoder").StringDecoder;
            this._decoder = new SD("utf8");
          }
          data = this._decoder.write(data);
        }
        this._parser.write(data.toString());
        this.emit("data", data);
        return true;
      };
      SAXStream.prototype.end = function(chunk) {
        if (chunk && chunk.length) {
          this.write(chunk);
        }
        this._parser.end();
        return true;
      };
      SAXStream.prototype.on = function(ev, handler2) {
        var me = this;
        if (!me._parser["on" + ev] && streamWraps.indexOf(ev) !== -1) {
          me._parser["on" + ev] = function() {
            var args = arguments.length === 1 ? [arguments[0]] : Array.apply(null, arguments);
            args.splice(0, 0, ev);
            me.emit.apply(me, args);
          };
        }
        return Stream.prototype.on.call(me, ev, handler2);
      };
      var CDATA = "[CDATA[";
      var DOCTYPE = "DOCTYPE";
      var XML_NAMESPACE = "http://www.w3.org/XML/1998/namespace";
      var XMLNS_NAMESPACE = "http://www.w3.org/2000/xmlns/";
      var rootNS = { xml: XML_NAMESPACE, xmlns: XMLNS_NAMESPACE };
      var nameStart = /[:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/;
      var nameBody = /[:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\u00B7\u0300-\u036F\u203F-\u2040.\d-]/;
      var entityStart = /[#:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/;
      var entityBody = /[#:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\u00B7\u0300-\u036F\u203F-\u2040.\d-]/;
      function isWhitespace(c) {
        return c === " " || c === "\n" || c === "\r" || c === "	";
      }
      function isQuote(c) {
        return c === '"' || c === "'";
      }
      function isAttribEnd(c) {
        return c === ">" || isWhitespace(c);
      }
      function isMatch(regex, c) {
        return regex.test(c);
      }
      function notMatch(regex, c) {
        return !isMatch(regex, c);
      }
      var S = 0;
      sax.STATE = {
        BEGIN: S++,
        BEGIN_WHITESPACE: S++,
        TEXT: S++,
        TEXT_ENTITY: S++,
        OPEN_WAKA: S++,
        SGML_DECL: S++,
        SGML_DECL_QUOTED: S++,
        DOCTYPE: S++,
        DOCTYPE_QUOTED: S++,
        DOCTYPE_DTD: S++,
        DOCTYPE_DTD_QUOTED: S++,
        COMMENT_STARTING: S++,
        COMMENT: S++,
        COMMENT_ENDING: S++,
        COMMENT_ENDED: S++,
        CDATA: S++,
        CDATA_ENDING: S++,
        CDATA_ENDING_2: S++,
        PROC_INST: S++,
        PROC_INST_BODY: S++,
        PROC_INST_ENDING: S++,
        OPEN_TAG: S++,
        OPEN_TAG_SLASH: S++,
        ATTRIB: S++,
        ATTRIB_NAME: S++,
        ATTRIB_NAME_SAW_WHITE: S++,
        ATTRIB_VALUE: S++,
        ATTRIB_VALUE_QUOTED: S++,
        ATTRIB_VALUE_CLOSED: S++,
        ATTRIB_VALUE_UNQUOTED: S++,
        ATTRIB_VALUE_ENTITY_Q: S++,
        ATTRIB_VALUE_ENTITY_U: S++,
        CLOSE_TAG: S++,
        CLOSE_TAG_SAW_WHITE: S++,
        SCRIPT: S++,
        SCRIPT_ENDING: S++
      };
      sax.XML_ENTITIES = {
        "amp": "&",
        "gt": ">",
        "lt": "<",
        "quot": '"',
        "apos": "'"
      };
      sax.ENTITIES = {
        "amp": "&",
        "gt": ">",
        "lt": "<",
        "quot": '"',
        "apos": "'",
        "AElig": 198,
        "Aacute": 193,
        "Acirc": 194,
        "Agrave": 192,
        "Aring": 197,
        "Atilde": 195,
        "Auml": 196,
        "Ccedil": 199,
        "ETH": 208,
        "Eacute": 201,
        "Ecirc": 202,
        "Egrave": 200,
        "Euml": 203,
        "Iacute": 205,
        "Icirc": 206,
        "Igrave": 204,
        "Iuml": 207,
        "Ntilde": 209,
        "Oacute": 211,
        "Ocirc": 212,
        "Ograve": 210,
        "Oslash": 216,
        "Otilde": 213,
        "Ouml": 214,
        "THORN": 222,
        "Uacute": 218,
        "Ucirc": 219,
        "Ugrave": 217,
        "Uuml": 220,
        "Yacute": 221,
        "aacute": 225,
        "acirc": 226,
        "aelig": 230,
        "agrave": 224,
        "aring": 229,
        "atilde": 227,
        "auml": 228,
        "ccedil": 231,
        "eacute": 233,
        "ecirc": 234,
        "egrave": 232,
        "eth": 240,
        "euml": 235,
        "iacute": 237,
        "icirc": 238,
        "igrave": 236,
        "iuml": 239,
        "ntilde": 241,
        "oacute": 243,
        "ocirc": 244,
        "ograve": 242,
        "oslash": 248,
        "otilde": 245,
        "ouml": 246,
        "szlig": 223,
        "thorn": 254,
        "uacute": 250,
        "ucirc": 251,
        "ugrave": 249,
        "uuml": 252,
        "yacute": 253,
        "yuml": 255,
        "copy": 169,
        "reg": 174,
        "nbsp": 160,
        "iexcl": 161,
        "cent": 162,
        "pound": 163,
        "curren": 164,
        "yen": 165,
        "brvbar": 166,
        "sect": 167,
        "uml": 168,
        "ordf": 170,
        "laquo": 171,
        "not": 172,
        "shy": 173,
        "macr": 175,
        "deg": 176,
        "plusmn": 177,
        "sup1": 185,
        "sup2": 178,
        "sup3": 179,
        "acute": 180,
        "micro": 181,
        "para": 182,
        "middot": 183,
        "cedil": 184,
        "ordm": 186,
        "raquo": 187,
        "frac14": 188,
        "frac12": 189,
        "frac34": 190,
        "iquest": 191,
        "times": 215,
        "divide": 247,
        "OElig": 338,
        "oelig": 339,
        "Scaron": 352,
        "scaron": 353,
        "Yuml": 376,
        "fnof": 402,
        "circ": 710,
        "tilde": 732,
        "Alpha": 913,
        "Beta": 914,
        "Gamma": 915,
        "Delta": 916,
        "Epsilon": 917,
        "Zeta": 918,
        "Eta": 919,
        "Theta": 920,
        "Iota": 921,
        "Kappa": 922,
        "Lambda": 923,
        "Mu": 924,
        "Nu": 925,
        "Xi": 926,
        "Omicron": 927,
        "Pi": 928,
        "Rho": 929,
        "Sigma": 931,
        "Tau": 932,
        "Upsilon": 933,
        "Phi": 934,
        "Chi": 935,
        "Psi": 936,
        "Omega": 937,
        "alpha": 945,
        "beta": 946,
        "gamma": 947,
        "delta": 948,
        "epsilon": 949,
        "zeta": 950,
        "eta": 951,
        "theta": 952,
        "iota": 953,
        "kappa": 954,
        "lambda": 955,
        "mu": 956,
        "nu": 957,
        "xi": 958,
        "omicron": 959,
        "pi": 960,
        "rho": 961,
        "sigmaf": 962,
        "sigma": 963,
        "tau": 964,
        "upsilon": 965,
        "phi": 966,
        "chi": 967,
        "psi": 968,
        "omega": 969,
        "thetasym": 977,
        "upsih": 978,
        "piv": 982,
        "ensp": 8194,
        "emsp": 8195,
        "thinsp": 8201,
        "zwnj": 8204,
        "zwj": 8205,
        "lrm": 8206,
        "rlm": 8207,
        "ndash": 8211,
        "mdash": 8212,
        "lsquo": 8216,
        "rsquo": 8217,
        "sbquo": 8218,
        "ldquo": 8220,
        "rdquo": 8221,
        "bdquo": 8222,
        "dagger": 8224,
        "Dagger": 8225,
        "bull": 8226,
        "hellip": 8230,
        "permil": 8240,
        "prime": 8242,
        "Prime": 8243,
        "lsaquo": 8249,
        "rsaquo": 8250,
        "oline": 8254,
        "frasl": 8260,
        "euro": 8364,
        "image": 8465,
        "weierp": 8472,
        "real": 8476,
        "trade": 8482,
        "alefsym": 8501,
        "larr": 8592,
        "uarr": 8593,
        "rarr": 8594,
        "darr": 8595,
        "harr": 8596,
        "crarr": 8629,
        "lArr": 8656,
        "uArr": 8657,
        "rArr": 8658,
        "dArr": 8659,
        "hArr": 8660,
        "forall": 8704,
        "part": 8706,
        "exist": 8707,
        "empty": 8709,
        "nabla": 8711,
        "isin": 8712,
        "notin": 8713,
        "ni": 8715,
        "prod": 8719,
        "sum": 8721,
        "minus": 8722,
        "lowast": 8727,
        "radic": 8730,
        "prop": 8733,
        "infin": 8734,
        "ang": 8736,
        "and": 8743,
        "or": 8744,
        "cap": 8745,
        "cup": 8746,
        "int": 8747,
        "there4": 8756,
        "sim": 8764,
        "cong": 8773,
        "asymp": 8776,
        "ne": 8800,
        "equiv": 8801,
        "le": 8804,
        "ge": 8805,
        "sub": 8834,
        "sup": 8835,
        "nsub": 8836,
        "sube": 8838,
        "supe": 8839,
        "oplus": 8853,
        "otimes": 8855,
        "perp": 8869,
        "sdot": 8901,
        "lceil": 8968,
        "rceil": 8969,
        "lfloor": 8970,
        "rfloor": 8971,
        "lang": 9001,
        "rang": 9002,
        "loz": 9674,
        "spades": 9824,
        "clubs": 9827,
        "hearts": 9829,
        "diams": 9830
      };
      Object.keys(sax.ENTITIES).forEach(function(key) {
        var e = sax.ENTITIES[key];
        var s2 = typeof e === "number" ? String.fromCharCode(e) : e;
        sax.ENTITIES[key] = s2;
      });
      for (var s in sax.STATE) {
        sax.STATE[sax.STATE[s]] = s;
      }
      S = sax.STATE;
      function emit(parser, event, data) {
        parser[event] && parser[event](data);
      }
      function emitNode(parser, nodeType, data) {
        if (parser.textNode)
          closeText(parser);
        emit(parser, nodeType, data);
      }
      function closeText(parser) {
        parser.textNode = textopts(parser.opt, parser.textNode);
        if (parser.textNode)
          emit(parser, "ontext", parser.textNode);
        parser.textNode = "";
      }
      function textopts(opt, text) {
        if (opt.trim)
          text = text.trim();
        if (opt.normalize)
          text = text.replace(/\s+/g, " ");
        return text;
      }
      function error(parser, er) {
        closeText(parser);
        if (parser.trackPosition) {
          er += "\nLine: " + parser.line + "\nColumn: " + parser.column + "\nChar: " + parser.c;
        }
        er = new Error(er);
        parser.error = er;
        emit(parser, "onerror", er);
        return parser;
      }
      function end(parser) {
        if (parser.sawRoot && !parser.closedRoot)
          strictFail(parser, "Unclosed root tag");
        if (parser.state !== S.BEGIN && parser.state !== S.BEGIN_WHITESPACE && parser.state !== S.TEXT) {
          error(parser, "Unexpected end");
        }
        closeText(parser);
        parser.c = "";
        parser.closed = true;
        emit(parser, "onend");
        SAXParser.call(parser, parser.strict, parser.opt);
        return parser;
      }
      function strictFail(parser, message) {
        if (typeof parser !== "object" || !(parser instanceof SAXParser)) {
          throw new Error("bad call to strictFail");
        }
        if (parser.strict) {
          error(parser, message);
        }
      }
      function newTag(parser) {
        if (!parser.strict)
          parser.tagName = parser.tagName[parser.looseCase]();
        var parent = parser.tags[parser.tags.length - 1] || parser;
        var tag = parser.tag = { name: parser.tagName, attributes: {} };
        if (parser.opt.xmlns) {
          tag.ns = parent.ns;
        }
        parser.attribList.length = 0;
        emitNode(parser, "onopentagstart", tag);
      }
      function qname(name, attribute) {
        var i = name.indexOf(":");
        var qualName = i < 0 ? ["", name] : name.split(":");
        var prefix = qualName[0];
        var local = qualName[1];
        if (attribute && name === "xmlns") {
          prefix = "xmlns";
          local = "";
        }
        return { prefix, local };
      }
      function attrib(parser) {
        if (!parser.strict) {
          parser.attribName = parser.attribName[parser.looseCase]();
        }
        if (parser.attribList.indexOf(parser.attribName) !== -1 || parser.tag.attributes.hasOwnProperty(parser.attribName)) {
          parser.attribName = parser.attribValue = "";
          return;
        }
        if (parser.opt.xmlns) {
          var qn = qname(parser.attribName, true);
          var prefix = qn.prefix;
          var local = qn.local;
          if (prefix === "xmlns") {
            if (local === "xml" && parser.attribValue !== XML_NAMESPACE) {
              strictFail(parser, "xml: prefix must be bound to " + XML_NAMESPACE + "\nActual: " + parser.attribValue);
            } else if (local === "xmlns" && parser.attribValue !== XMLNS_NAMESPACE) {
              strictFail(parser, "xmlns: prefix must be bound to " + XMLNS_NAMESPACE + "\nActual: " + parser.attribValue);
            } else {
              var tag = parser.tag;
              var parent = parser.tags[parser.tags.length - 1] || parser;
              if (tag.ns === parent.ns) {
                tag.ns = Object.create(parent.ns);
              }
              tag.ns[local] = parser.attribValue;
            }
          }
          parser.attribList.push([parser.attribName, parser.attribValue]);
        } else {
          parser.tag.attributes[parser.attribName] = parser.attribValue;
          emitNode(parser, "onattribute", {
            name: parser.attribName,
            value: parser.attribValue
          });
        }
        parser.attribName = parser.attribValue = "";
      }
      function openTag(parser, selfClosing) {
        if (parser.opt.xmlns) {
          var tag = parser.tag;
          var qn = qname(parser.tagName);
          tag.prefix = qn.prefix;
          tag.local = qn.local;
          tag.uri = tag.ns[qn.prefix] || "";
          if (tag.prefix && !tag.uri) {
            strictFail(parser, "Unbound namespace prefix: " + JSON.stringify(parser.tagName));
            tag.uri = qn.prefix;
          }
          var parent = parser.tags[parser.tags.length - 1] || parser;
          if (tag.ns && parent.ns !== tag.ns) {
            Object.keys(tag.ns).forEach(function(p) {
              emitNode(parser, "onopennamespace", {
                prefix: p,
                uri: tag.ns[p]
              });
            });
          }
          for (var i = 0, l = parser.attribList.length; i < l; i++) {
            var nv = parser.attribList[i];
            var name = nv[0];
            var value = nv[1];
            var qualName = qname(name, true);
            var prefix = qualName.prefix;
            var local = qualName.local;
            var uri = prefix === "" ? "" : tag.ns[prefix] || "";
            var a = {
              name,
              value,
              prefix,
              local,
              uri
            };
            if (prefix && prefix !== "xmlns" && !uri) {
              strictFail(parser, "Unbound namespace prefix: " + JSON.stringify(prefix));
              a.uri = prefix;
            }
            parser.tag.attributes[name] = a;
            emitNode(parser, "onattribute", a);
          }
          parser.attribList.length = 0;
        }
        parser.tag.isSelfClosing = !!selfClosing;
        parser.sawRoot = true;
        parser.tags.push(parser.tag);
        emitNode(parser, "onopentag", parser.tag);
        if (!selfClosing) {
          if (!parser.noscript && parser.tagName.toLowerCase() === "script") {
            parser.state = S.SCRIPT;
          } else {
            parser.state = S.TEXT;
          }
          parser.tag = null;
          parser.tagName = "";
        }
        parser.attribName = parser.attribValue = "";
        parser.attribList.length = 0;
      }
      function closeTag(parser) {
        if (!parser.tagName) {
          strictFail(parser, "Weird empty close tag.");
          parser.textNode += "</>";
          parser.state = S.TEXT;
          return;
        }
        if (parser.script) {
          if (parser.tagName !== "script") {
            parser.script += "</" + parser.tagName + ">";
            parser.tagName = "";
            parser.state = S.SCRIPT;
            return;
          }
          emitNode(parser, "onscript", parser.script);
          parser.script = "";
        }
        var t = parser.tags.length;
        var tagName = parser.tagName;
        if (!parser.strict) {
          tagName = tagName[parser.looseCase]();
        }
        var closeTo = tagName;
        while (t--) {
          var close = parser.tags[t];
          if (close.name !== closeTo) {
            strictFail(parser, "Unexpected close tag");
          } else {
            break;
          }
        }
        if (t < 0) {
          strictFail(parser, "Unmatched closing tag: " + parser.tagName);
          parser.textNode += "</" + parser.tagName + ">";
          parser.state = S.TEXT;
          return;
        }
        parser.tagName = tagName;
        var s2 = parser.tags.length;
        while (s2-- > t) {
          var tag = parser.tag = parser.tags.pop();
          parser.tagName = parser.tag.name;
          emitNode(parser, "onclosetag", parser.tagName);
          var x = {};
          for (var i in tag.ns) {
            x[i] = tag.ns[i];
          }
          var parent = parser.tags[parser.tags.length - 1] || parser;
          if (parser.opt.xmlns && tag.ns !== parent.ns) {
            Object.keys(tag.ns).forEach(function(p) {
              var n = tag.ns[p];
              emitNode(parser, "onclosenamespace", { prefix: p, uri: n });
            });
          }
        }
        if (t === 0)
          parser.closedRoot = true;
        parser.tagName = parser.attribValue = parser.attribName = "";
        parser.attribList.length = 0;
        parser.state = S.TEXT;
      }
      function parseEntity(parser) {
        var entity = parser.entity;
        var entityLC = entity.toLowerCase();
        var num;
        var numStr = "";
        if (parser.ENTITIES[entity]) {
          return parser.ENTITIES[entity];
        }
        if (parser.ENTITIES[entityLC]) {
          return parser.ENTITIES[entityLC];
        }
        entity = entityLC;
        if (entity.charAt(0) === "#") {
          if (entity.charAt(1) === "x") {
            entity = entity.slice(2);
            num = parseInt(entity, 16);
            numStr = num.toString(16);
          } else {
            entity = entity.slice(1);
            num = parseInt(entity, 10);
            numStr = num.toString(10);
          }
        }
        entity = entity.replace(/^0+/, "");
        if (isNaN(num) || numStr.toLowerCase() !== entity) {
          strictFail(parser, "Invalid character entity");
          return "&" + parser.entity + ";";
        }
        return String.fromCodePoint(num);
      }
      function beginWhiteSpace(parser, c) {
        if (c === "<") {
          parser.state = S.OPEN_WAKA;
          parser.startTagPosition = parser.position;
        } else if (!isWhitespace(c)) {
          strictFail(parser, "Non-whitespace before first tag.");
          parser.textNode = c;
          parser.state = S.TEXT;
        }
      }
      function charAt(chunk, i) {
        var result = "";
        if (i < chunk.length) {
          result = chunk.charAt(i);
        }
        return result;
      }
      function write(chunk) {
        var parser = this;
        if (this.error) {
          throw this.error;
        }
        if (parser.closed) {
          return error(parser, "Cannot write after close. Assign an onready handler.");
        }
        if (chunk === null) {
          return end(parser);
        }
        if (typeof chunk === "object") {
          chunk = chunk.toString();
        }
        var i = 0;
        var c = "";
        while (true) {
          c = charAt(chunk, i++);
          parser.c = c;
          if (!c) {
            break;
          }
          if (parser.trackPosition) {
            parser.position++;
            if (c === "\n") {
              parser.line++;
              parser.column = 0;
            } else {
              parser.column++;
            }
          }
          switch (parser.state) {
            case S.BEGIN:
              parser.state = S.BEGIN_WHITESPACE;
              if (c === "\uFEFF") {
                continue;
              }
              beginWhiteSpace(parser, c);
              continue;
            case S.BEGIN_WHITESPACE:
              beginWhiteSpace(parser, c);
              continue;
            case S.TEXT:
              if (parser.sawRoot && !parser.closedRoot) {
                var starti = i - 1;
                while (c && c !== "<" && c !== "&") {
                  c = charAt(chunk, i++);
                  if (c && parser.trackPosition) {
                    parser.position++;
                    if (c === "\n") {
                      parser.line++;
                      parser.column = 0;
                    } else {
                      parser.column++;
                    }
                  }
                }
                parser.textNode += chunk.substring(starti, i - 1);
              }
              if (c === "<" && !(parser.sawRoot && parser.closedRoot && !parser.strict)) {
                parser.state = S.OPEN_WAKA;
                parser.startTagPosition = parser.position;
              } else {
                if (!isWhitespace(c) && (!parser.sawRoot || parser.closedRoot)) {
                  strictFail(parser, "Text data outside of root node.");
                }
                if (c === "&") {
                  parser.state = S.TEXT_ENTITY;
                } else {
                  parser.textNode += c;
                }
              }
              continue;
            case S.SCRIPT:
              if (c === "<") {
                parser.state = S.SCRIPT_ENDING;
              } else {
                parser.script += c;
              }
              continue;
            case S.SCRIPT_ENDING:
              if (c === "/") {
                parser.state = S.CLOSE_TAG;
              } else {
                parser.script += "<" + c;
                parser.state = S.SCRIPT;
              }
              continue;
            case S.OPEN_WAKA:
              if (c === "!") {
                parser.state = S.SGML_DECL;
                parser.sgmlDecl = "";
              } else if (isWhitespace(c)) {
              } else if (isMatch(nameStart, c)) {
                parser.state = S.OPEN_TAG;
                parser.tagName = c;
              } else if (c === "/") {
                parser.state = S.CLOSE_TAG;
                parser.tagName = "";
              } else if (c === "?") {
                parser.state = S.PROC_INST;
                parser.procInstName = parser.procInstBody = "";
              } else {
                strictFail(parser, "Unencoded <");
                if (parser.startTagPosition + 1 < parser.position) {
                  var pad = parser.position - parser.startTagPosition;
                  c = new Array(pad).join(" ") + c;
                }
                parser.textNode += "<" + c;
                parser.state = S.TEXT;
              }
              continue;
            case S.SGML_DECL:
              if ((parser.sgmlDecl + c).toUpperCase() === CDATA) {
                emitNode(parser, "onopencdata");
                parser.state = S.CDATA;
                parser.sgmlDecl = "";
                parser.cdata = "";
              } else if (parser.sgmlDecl + c === "--") {
                parser.state = S.COMMENT;
                parser.comment = "";
                parser.sgmlDecl = "";
              } else if ((parser.sgmlDecl + c).toUpperCase() === DOCTYPE) {
                parser.state = S.DOCTYPE;
                if (parser.doctype || parser.sawRoot) {
                  strictFail(parser, "Inappropriately located doctype declaration");
                }
                parser.doctype = "";
                parser.sgmlDecl = "";
              } else if (c === ">") {
                emitNode(parser, "onsgmldeclaration", parser.sgmlDecl);
                parser.sgmlDecl = "";
                parser.state = S.TEXT;
              } else if (isQuote(c)) {
                parser.state = S.SGML_DECL_QUOTED;
                parser.sgmlDecl += c;
              } else {
                parser.sgmlDecl += c;
              }
              continue;
            case S.SGML_DECL_QUOTED:
              if (c === parser.q) {
                parser.state = S.SGML_DECL;
                parser.q = "";
              }
              parser.sgmlDecl += c;
              continue;
            case S.DOCTYPE:
              if (c === ">") {
                parser.state = S.TEXT;
                emitNode(parser, "ondoctype", parser.doctype);
                parser.doctype = true;
              } else {
                parser.doctype += c;
                if (c === "[") {
                  parser.state = S.DOCTYPE_DTD;
                } else if (isQuote(c)) {
                  parser.state = S.DOCTYPE_QUOTED;
                  parser.q = c;
                }
              }
              continue;
            case S.DOCTYPE_QUOTED:
              parser.doctype += c;
              if (c === parser.q) {
                parser.q = "";
                parser.state = S.DOCTYPE;
              }
              continue;
            case S.DOCTYPE_DTD:
              parser.doctype += c;
              if (c === "]") {
                parser.state = S.DOCTYPE;
              } else if (isQuote(c)) {
                parser.state = S.DOCTYPE_DTD_QUOTED;
                parser.q = c;
              }
              continue;
            case S.DOCTYPE_DTD_QUOTED:
              parser.doctype += c;
              if (c === parser.q) {
                parser.state = S.DOCTYPE_DTD;
                parser.q = "";
              }
              continue;
            case S.COMMENT:
              if (c === "-") {
                parser.state = S.COMMENT_ENDING;
              } else {
                parser.comment += c;
              }
              continue;
            case S.COMMENT_ENDING:
              if (c === "-") {
                parser.state = S.COMMENT_ENDED;
                parser.comment = textopts(parser.opt, parser.comment);
                if (parser.comment) {
                  emitNode(parser, "oncomment", parser.comment);
                }
                parser.comment = "";
              } else {
                parser.comment += "-" + c;
                parser.state = S.COMMENT;
              }
              continue;
            case S.COMMENT_ENDED:
              if (c !== ">") {
                strictFail(parser, "Malformed comment");
                parser.comment += "--" + c;
                parser.state = S.COMMENT;
              } else {
                parser.state = S.TEXT;
              }
              continue;
            case S.CDATA:
              if (c === "]") {
                parser.state = S.CDATA_ENDING;
              } else {
                parser.cdata += c;
              }
              continue;
            case S.CDATA_ENDING:
              if (c === "]") {
                parser.state = S.CDATA_ENDING_2;
              } else {
                parser.cdata += "]" + c;
                parser.state = S.CDATA;
              }
              continue;
            case S.CDATA_ENDING_2:
              if (c === ">") {
                if (parser.cdata) {
                  emitNode(parser, "oncdata", parser.cdata);
                }
                emitNode(parser, "onclosecdata");
                parser.cdata = "";
                parser.state = S.TEXT;
              } else if (c === "]") {
                parser.cdata += "]";
              } else {
                parser.cdata += "]]" + c;
                parser.state = S.CDATA;
              }
              continue;
            case S.PROC_INST:
              if (c === "?") {
                parser.state = S.PROC_INST_ENDING;
              } else if (isWhitespace(c)) {
                parser.state = S.PROC_INST_BODY;
              } else {
                parser.procInstName += c;
              }
              continue;
            case S.PROC_INST_BODY:
              if (!parser.procInstBody && isWhitespace(c)) {
                continue;
              } else if (c === "?") {
                parser.state = S.PROC_INST_ENDING;
              } else {
                parser.procInstBody += c;
              }
              continue;
            case S.PROC_INST_ENDING:
              if (c === ">") {
                emitNode(parser, "onprocessinginstruction", {
                  name: parser.procInstName,
                  body: parser.procInstBody
                });
                parser.procInstName = parser.procInstBody = "";
                parser.state = S.TEXT;
              } else {
                parser.procInstBody += "?" + c;
                parser.state = S.PROC_INST_BODY;
              }
              continue;
            case S.OPEN_TAG:
              if (isMatch(nameBody, c)) {
                parser.tagName += c;
              } else {
                newTag(parser);
                if (c === ">") {
                  openTag(parser);
                } else if (c === "/") {
                  parser.state = S.OPEN_TAG_SLASH;
                } else {
                  if (!isWhitespace(c)) {
                    strictFail(parser, "Invalid character in tag name");
                  }
                  parser.state = S.ATTRIB;
                }
              }
              continue;
            case S.OPEN_TAG_SLASH:
              if (c === ">") {
                openTag(parser, true);
                closeTag(parser);
              } else {
                strictFail(parser, "Forward-slash in opening tag not followed by >");
                parser.state = S.ATTRIB;
              }
              continue;
            case S.ATTRIB:
              if (isWhitespace(c)) {
                continue;
              } else if (c === ">") {
                openTag(parser);
              } else if (c === "/") {
                parser.state = S.OPEN_TAG_SLASH;
              } else if (isMatch(nameStart, c)) {
                parser.attribName = c;
                parser.attribValue = "";
                parser.state = S.ATTRIB_NAME;
              } else {
                strictFail(parser, "Invalid attribute name");
              }
              continue;
            case S.ATTRIB_NAME:
              if (c === "=") {
                parser.state = S.ATTRIB_VALUE;
              } else if (c === ">") {
                strictFail(parser, "Attribute without value");
                parser.attribValue = parser.attribName;
                attrib(parser);
                openTag(parser);
              } else if (isWhitespace(c)) {
                parser.state = S.ATTRIB_NAME_SAW_WHITE;
              } else if (isMatch(nameBody, c)) {
                parser.attribName += c;
              } else {
                strictFail(parser, "Invalid attribute name");
              }
              continue;
            case S.ATTRIB_NAME_SAW_WHITE:
              if (c === "=") {
                parser.state = S.ATTRIB_VALUE;
              } else if (isWhitespace(c)) {
                continue;
              } else {
                strictFail(parser, "Attribute without value");
                parser.tag.attributes[parser.attribName] = "";
                parser.attribValue = "";
                emitNode(parser, "onattribute", {
                  name: parser.attribName,
                  value: ""
                });
                parser.attribName = "";
                if (c === ">") {
                  openTag(parser);
                } else if (isMatch(nameStart, c)) {
                  parser.attribName = c;
                  parser.state = S.ATTRIB_NAME;
                } else {
                  strictFail(parser, "Invalid attribute name");
                  parser.state = S.ATTRIB;
                }
              }
              continue;
            case S.ATTRIB_VALUE:
              if (isWhitespace(c)) {
                continue;
              } else if (isQuote(c)) {
                parser.q = c;
                parser.state = S.ATTRIB_VALUE_QUOTED;
              } else {
                strictFail(parser, "Unquoted attribute value");
                parser.state = S.ATTRIB_VALUE_UNQUOTED;
                parser.attribValue = c;
              }
              continue;
            case S.ATTRIB_VALUE_QUOTED:
              if (c !== parser.q) {
                if (c === "&") {
                  parser.state = S.ATTRIB_VALUE_ENTITY_Q;
                } else {
                  parser.attribValue += c;
                }
                continue;
              }
              attrib(parser);
              parser.q = "";
              parser.state = S.ATTRIB_VALUE_CLOSED;
              continue;
            case S.ATTRIB_VALUE_CLOSED:
              if (isWhitespace(c)) {
                parser.state = S.ATTRIB;
              } else if (c === ">") {
                openTag(parser);
              } else if (c === "/") {
                parser.state = S.OPEN_TAG_SLASH;
              } else if (isMatch(nameStart, c)) {
                strictFail(parser, "No whitespace between attributes");
                parser.attribName = c;
                parser.attribValue = "";
                parser.state = S.ATTRIB_NAME;
              } else {
                strictFail(parser, "Invalid attribute name");
              }
              continue;
            case S.ATTRIB_VALUE_UNQUOTED:
              if (!isAttribEnd(c)) {
                if (c === "&") {
                  parser.state = S.ATTRIB_VALUE_ENTITY_U;
                } else {
                  parser.attribValue += c;
                }
                continue;
              }
              attrib(parser);
              if (c === ">") {
                openTag(parser);
              } else {
                parser.state = S.ATTRIB;
              }
              continue;
            case S.CLOSE_TAG:
              if (!parser.tagName) {
                if (isWhitespace(c)) {
                  continue;
                } else if (notMatch(nameStart, c)) {
                  if (parser.script) {
                    parser.script += "</" + c;
                    parser.state = S.SCRIPT;
                  } else {
                    strictFail(parser, "Invalid tagname in closing tag.");
                  }
                } else {
                  parser.tagName = c;
                }
              } else if (c === ">") {
                closeTag(parser);
              } else if (isMatch(nameBody, c)) {
                parser.tagName += c;
              } else if (parser.script) {
                parser.script += "</" + parser.tagName;
                parser.tagName = "";
                parser.state = S.SCRIPT;
              } else {
                if (!isWhitespace(c)) {
                  strictFail(parser, "Invalid tagname in closing tag");
                }
                parser.state = S.CLOSE_TAG_SAW_WHITE;
              }
              continue;
            case S.CLOSE_TAG_SAW_WHITE:
              if (isWhitespace(c)) {
                continue;
              }
              if (c === ">") {
                closeTag(parser);
              } else {
                strictFail(parser, "Invalid characters in closing tag");
              }
              continue;
            case S.TEXT_ENTITY:
            case S.ATTRIB_VALUE_ENTITY_Q:
            case S.ATTRIB_VALUE_ENTITY_U:
              var returnState;
              var buffer;
              switch (parser.state) {
                case S.TEXT_ENTITY:
                  returnState = S.TEXT;
                  buffer = "textNode";
                  break;
                case S.ATTRIB_VALUE_ENTITY_Q:
                  returnState = S.ATTRIB_VALUE_QUOTED;
                  buffer = "attribValue";
                  break;
                case S.ATTRIB_VALUE_ENTITY_U:
                  returnState = S.ATTRIB_VALUE_UNQUOTED;
                  buffer = "attribValue";
                  break;
              }
              if (c === ";") {
                parser[buffer] += parseEntity(parser);
                parser.entity = "";
                parser.state = returnState;
              } else if (isMatch(parser.entity.length ? entityBody : entityStart, c)) {
                parser.entity += c;
              } else {
                strictFail(parser, "Invalid character in entity name");
                parser[buffer] += "&" + parser.entity + c;
                parser.entity = "";
                parser.state = returnState;
              }
              continue;
            default:
              throw new Error(parser, "Unknown state: " + parser.state);
          }
        }
        if (parser.position >= parser.bufferCheckPosition) {
          checkBufferLength(parser);
        }
        return parser;
      }
      if (!String.fromCodePoint) {
        (function() {
          var stringFromCharCode = String.fromCharCode;
          var floor = Math.floor;
          var fromCodePoint = function() {
            var MAX_SIZE = 16384;
            var codeUnits = [];
            var highSurrogate;
            var lowSurrogate;
            var index = -1;
            var length = arguments.length;
            if (!length) {
              return "";
            }
            var result = "";
            while (++index < length) {
              var codePoint = Number(arguments[index]);
              if (!isFinite(codePoint) || codePoint < 0 || codePoint > 1114111 || floor(codePoint) !== codePoint) {
                throw RangeError("Invalid code point: " + codePoint);
              }
              if (codePoint <= 65535) {
                codeUnits.push(codePoint);
              } else {
                codePoint -= 65536;
                highSurrogate = (codePoint >> 10) + 55296;
                lowSurrogate = codePoint % 1024 + 56320;
                codeUnits.push(highSurrogate, lowSurrogate);
              }
              if (index + 1 === length || codeUnits.length > MAX_SIZE) {
                result += stringFromCharCode.apply(null, codeUnits);
                codeUnits.length = 0;
              }
            }
            return result;
          };
          if (Object.defineProperty) {
            Object.defineProperty(String, "fromCodePoint", {
              value: fromCodePoint,
              configurable: true,
              writable: true
            });
          } else {
            String.fromCodePoint = fromCodePoint;
          }
        })();
      }
    })(typeof exports === "undefined" ? exports.sax = {} : exports);
  }
});

// node_modules/xml2js/lib/bom.js
var require_bom = __commonJS({
  "node_modules/xml2js/lib/bom.js"(exports) {
    (function() {
      "use strict";
      exports.stripBOM = function(str) {
        if (str[0] === "\uFEFF") {
          return str.substring(1);
        } else {
          return str;
        }
      };
    }).call(exports);
  }
});

// node_modules/xml2js/lib/processors.js
var require_processors = __commonJS({
  "node_modules/xml2js/lib/processors.js"(exports) {
    (function() {
      "use strict";
      var prefixMatch;
      prefixMatch = new RegExp(/(?!xmlns)^.*:/);
      exports.normalize = function(str) {
        return str.toLowerCase();
      };
      exports.firstCharLowerCase = function(str) {
        return str.charAt(0).toLowerCase() + str.slice(1);
      };
      exports.stripPrefix = function(str) {
        return str.replace(prefixMatch, "");
      };
      exports.parseNumbers = function(str) {
        if (!isNaN(str)) {
          str = str % 1 === 0 ? parseInt(str, 10) : parseFloat(str);
        }
        return str;
      };
      exports.parseBooleans = function(str) {
        if (/^(?:true|false)$/i.test(str)) {
          str = str.toLowerCase() === "true";
        }
        return str;
      };
    }).call(exports);
  }
});

// node_modules/xml2js/lib/parser.js
var require_parser2 = __commonJS({
  "node_modules/xml2js/lib/parser.js"(exports) {
    (function() {
      "use strict";
      var bom, defaults, events, isEmpty, processItem, processors, sax, setImmediate2, bind = function(fn, me) {
        return function() {
          return fn.apply(me, arguments);
        };
      }, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      sax = require_sax2();
      events = require("events");
      bom = require_bom();
      processors = require_processors();
      setImmediate2 = require("timers").setImmediate;
      defaults = require_defaults().defaults;
      isEmpty = function(thing) {
        return typeof thing === "object" && thing != null && Object.keys(thing).length === 0;
      };
      processItem = function(processors2, item, key) {
        var i, len, process2;
        for (i = 0, len = processors2.length; i < len; i++) {
          process2 = processors2[i];
          item = process2(item, key);
        }
        return item;
      };
      exports.Parser = function(superClass) {
        extend(Parser, superClass);
        function Parser(opts) {
          this.parseString = bind(this.parseString, this);
          this.reset = bind(this.reset, this);
          this.assignOrPush = bind(this.assignOrPush, this);
          this.processAsync = bind(this.processAsync, this);
          var key, ref, value;
          if (!(this instanceof exports.Parser)) {
            return new exports.Parser(opts);
          }
          this.options = {};
          ref = defaults["0.2"];
          for (key in ref) {
            if (!hasProp.call(ref, key))
              continue;
            value = ref[key];
            this.options[key] = value;
          }
          for (key in opts) {
            if (!hasProp.call(opts, key))
              continue;
            value = opts[key];
            this.options[key] = value;
          }
          if (this.options.xmlns) {
            this.options.xmlnskey = this.options.attrkey + "ns";
          }
          if (this.options.normalizeTags) {
            if (!this.options.tagNameProcessors) {
              this.options.tagNameProcessors = [];
            }
            this.options.tagNameProcessors.unshift(processors.normalize);
          }
          this.reset();
        }
        Parser.prototype.processAsync = function() {
          var chunk, err;
          try {
            if (this.remaining.length <= this.options.chunkSize) {
              chunk = this.remaining;
              this.remaining = "";
              this.saxParser = this.saxParser.write(chunk);
              return this.saxParser.close();
            } else {
              chunk = this.remaining.substr(0, this.options.chunkSize);
              this.remaining = this.remaining.substr(this.options.chunkSize, this.remaining.length);
              this.saxParser = this.saxParser.write(chunk);
              return setImmediate2(this.processAsync);
            }
          } catch (error1) {
            err = error1;
            if (!this.saxParser.errThrown) {
              this.saxParser.errThrown = true;
              return this.emit(err);
            }
          }
        };
        Parser.prototype.assignOrPush = function(obj, key, newValue) {
          if (!(key in obj)) {
            if (!this.options.explicitArray) {
              return obj[key] = newValue;
            } else {
              return obj[key] = [newValue];
            }
          } else {
            if (!(obj[key] instanceof Array)) {
              obj[key] = [obj[key]];
            }
            return obj[key].push(newValue);
          }
        };
        Parser.prototype.reset = function() {
          var attrkey, charkey, ontext, stack;
          this.removeAllListeners();
          this.saxParser = sax.parser(this.options.strict, {
            trim: false,
            normalize: false,
            xmlns: this.options.xmlns
          });
          this.saxParser.errThrown = false;
          this.saxParser.onerror = function(_this) {
            return function(error) {
              _this.saxParser.resume();
              if (!_this.saxParser.errThrown) {
                _this.saxParser.errThrown = true;
                return _this.emit("error", error);
              }
            };
          }(this);
          this.saxParser.onend = function(_this) {
            return function() {
              if (!_this.saxParser.ended) {
                _this.saxParser.ended = true;
                return _this.emit("end", _this.resultObject);
              }
            };
          }(this);
          this.saxParser.ended = false;
          this.EXPLICIT_CHARKEY = this.options.explicitCharkey;
          this.resultObject = null;
          stack = [];
          attrkey = this.options.attrkey;
          charkey = this.options.charkey;
          this.saxParser.onopentag = function(_this) {
            return function(node) {
              var key, newValue, obj, processedKey, ref;
              obj = {};
              obj[charkey] = "";
              if (!_this.options.ignoreAttrs) {
                ref = node.attributes;
                for (key in ref) {
                  if (!hasProp.call(ref, key))
                    continue;
                  if (!(attrkey in obj) && !_this.options.mergeAttrs) {
                    obj[attrkey] = {};
                  }
                  newValue = _this.options.attrValueProcessors ? processItem(_this.options.attrValueProcessors, node.attributes[key], key) : node.attributes[key];
                  processedKey = _this.options.attrNameProcessors ? processItem(_this.options.attrNameProcessors, key) : key;
                  if (_this.options.mergeAttrs) {
                    _this.assignOrPush(obj, processedKey, newValue);
                  } else {
                    obj[attrkey][processedKey] = newValue;
                  }
                }
              }
              obj["#name"] = _this.options.tagNameProcessors ? processItem(_this.options.tagNameProcessors, node.name) : node.name;
              if (_this.options.xmlns) {
                obj[_this.options.xmlnskey] = {
                  uri: node.uri,
                  local: node.local
                };
              }
              return stack.push(obj);
            };
          }(this);
          this.saxParser.onclosetag = function(_this) {
            return function() {
              var cdata, emptyStr, key, node, nodeName, obj, objClone, old, s, xpath;
              obj = stack.pop();
              nodeName = obj["#name"];
              if (!_this.options.explicitChildren || !_this.options.preserveChildrenOrder) {
                delete obj["#name"];
              }
              if (obj.cdata === true) {
                cdata = obj.cdata;
                delete obj.cdata;
              }
              s = stack[stack.length - 1];
              if (obj[charkey].match(/^\s*$/) && !cdata) {
                emptyStr = obj[charkey];
                delete obj[charkey];
              } else {
                if (_this.options.trim) {
                  obj[charkey] = obj[charkey].trim();
                }
                if (_this.options.normalize) {
                  obj[charkey] = obj[charkey].replace(/\s{2,}/g, " ").trim();
                }
                obj[charkey] = _this.options.valueProcessors ? processItem(_this.options.valueProcessors, obj[charkey], nodeName) : obj[charkey];
                if (Object.keys(obj).length === 1 && charkey in obj && !_this.EXPLICIT_CHARKEY) {
                  obj = obj[charkey];
                }
              }
              if (isEmpty(obj)) {
                obj = _this.options.emptyTag !== "" ? _this.options.emptyTag : emptyStr;
              }
              if (_this.options.validator != null) {
                xpath = "/" + function() {
                  var i, len, results;
                  results = [];
                  for (i = 0, len = stack.length; i < len; i++) {
                    node = stack[i];
                    results.push(node["#name"]);
                  }
                  return results;
                }().concat(nodeName).join("/");
                (function() {
                  var err;
                  try {
                    return obj = _this.options.validator(xpath, s && s[nodeName], obj);
                  } catch (error1) {
                    err = error1;
                    return _this.emit("error", err);
                  }
                })();
              }
              if (_this.options.explicitChildren && !_this.options.mergeAttrs && typeof obj === "object") {
                if (!_this.options.preserveChildrenOrder) {
                  node = {};
                  if (_this.options.attrkey in obj) {
                    node[_this.options.attrkey] = obj[_this.options.attrkey];
                    delete obj[_this.options.attrkey];
                  }
                  if (!_this.options.charsAsChildren && _this.options.charkey in obj) {
                    node[_this.options.charkey] = obj[_this.options.charkey];
                    delete obj[_this.options.charkey];
                  }
                  if (Object.getOwnPropertyNames(obj).length > 0) {
                    node[_this.options.childkey] = obj;
                  }
                  obj = node;
                } else if (s) {
                  s[_this.options.childkey] = s[_this.options.childkey] || [];
                  objClone = {};
                  for (key in obj) {
                    if (!hasProp.call(obj, key))
                      continue;
                    objClone[key] = obj[key];
                  }
                  s[_this.options.childkey].push(objClone);
                  delete obj["#name"];
                  if (Object.keys(obj).length === 1 && charkey in obj && !_this.EXPLICIT_CHARKEY) {
                    obj = obj[charkey];
                  }
                }
              }
              if (stack.length > 0) {
                return _this.assignOrPush(s, nodeName, obj);
              } else {
                if (_this.options.explicitRoot) {
                  old = obj;
                  obj = {};
                  obj[nodeName] = old;
                }
                _this.resultObject = obj;
                _this.saxParser.ended = true;
                return _this.emit("end", _this.resultObject);
              }
            };
          }(this);
          ontext = function(_this) {
            return function(text) {
              var charChild, s;
              s = stack[stack.length - 1];
              if (s) {
                s[charkey] += text;
                if (_this.options.explicitChildren && _this.options.preserveChildrenOrder && _this.options.charsAsChildren && (_this.options.includeWhiteChars || text.replace(/\\n/g, "").trim() !== "")) {
                  s[_this.options.childkey] = s[_this.options.childkey] || [];
                  charChild = {
                    "#name": "__text__"
                  };
                  charChild[charkey] = text;
                  if (_this.options.normalize) {
                    charChild[charkey] = charChild[charkey].replace(/\s{2,}/g, " ").trim();
                  }
                  s[_this.options.childkey].push(charChild);
                }
                return s;
              }
            };
          }(this);
          this.saxParser.ontext = ontext;
          return this.saxParser.oncdata = function(_this) {
            return function(text) {
              var s;
              s = ontext(text);
              if (s) {
                return s.cdata = true;
              }
            };
          }(this);
        };
        Parser.prototype.parseString = function(str, cb) {
          var err;
          if (cb != null && typeof cb === "function") {
            this.on("end", function(result) {
              this.reset();
              return cb(null, result);
            });
            this.on("error", function(err2) {
              this.reset();
              return cb(err2);
            });
          }
          try {
            str = str.toString();
            if (str.trim() === "") {
              this.emit("end", null);
              return true;
            }
            str = bom.stripBOM(str);
            if (this.options.async) {
              this.remaining = str;
              setImmediate2(this.processAsync);
              return this.saxParser;
            }
            return this.saxParser.write(str).close();
          } catch (error1) {
            err = error1;
            if (!(this.saxParser.errThrown || this.saxParser.ended)) {
              this.emit("error", err);
              return this.saxParser.errThrown = true;
            } else if (this.saxParser.ended) {
              throw err;
            }
          }
        };
        return Parser;
      }(events.EventEmitter);
      exports.parseString = function(str, a, b) {
        var cb, options, parser;
        if (b != null) {
          if (typeof b === "function") {
            cb = b;
          }
          if (typeof a === "object") {
            options = a;
          }
        } else {
          if (typeof a === "function") {
            cb = a;
          }
          options = {};
        }
        parser = new exports.Parser(options);
        return parser.parseString(str, cb);
      };
    }).call(exports);
  }
});

// node_modules/xml2js/lib/xml2js.js
var require_xml2js = __commonJS({
  "node_modules/xml2js/lib/xml2js.js"(exports) {
    (function() {
      "use strict";
      var builder, defaults, parser, processors, extend = function(child, parent) {
        for (var key in parent) {
          if (hasProp.call(parent, key))
            child[key] = parent[key];
        }
        function ctor() {
          this.constructor = child;
        }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
        child.__super__ = parent.prototype;
        return child;
      }, hasProp = {}.hasOwnProperty;
      defaults = require_defaults();
      builder = require_builder3();
      parser = require_parser2();
      processors = require_processors();
      exports.defaults = defaults.defaults;
      exports.processors = processors;
      exports.ValidationError = function(superClass) {
        extend(ValidationError, superClass);
        function ValidationError(message) {
          this.message = message;
        }
        return ValidationError;
      }(Error);
      exports.Builder = builder.Builder;
      exports.Parser = parser.Parser;
      exports.parseString = parser.parseString;
    }).call(exports);
  }
});

// node_modules/aws-sdk/lib/xml/node_parser.js
var require_node_parser = __commonJS({
  "node_modules/aws-sdk/lib/xml/node_parser.js"(exports, module2) {
    var AWS3 = require_core();
    var util = AWS3.util;
    var Shape = AWS3.Model.Shape;
    var xml2js = require_xml2js();
    var options = {
      explicitCharkey: false,
      trim: false,
      normalize: false,
      explicitRoot: false,
      emptyTag: null,
      explicitArray: true,
      ignoreAttrs: false,
      mergeAttrs: false,
      validator: null
    };
    function NodeXmlParser() {
    }
    NodeXmlParser.prototype.parse = function(xml, shape) {
      shape = shape || {};
      var result = null;
      var error = null;
      var parser = new xml2js.Parser(options);
      parser.parseString(xml, function(e, r) {
        error = e;
        result = r;
      });
      if (result) {
        var data = parseXml(result, shape);
        if (result.ResponseMetadata) {
          data.ResponseMetadata = parseXml(result.ResponseMetadata[0], {});
        }
        return data;
      } else if (error) {
        throw util.error(error, { code: "XMLParserError", retryable: true });
      } else {
        return parseXml({}, shape);
      }
    };
    function parseXml(xml, shape) {
      switch (shape.type) {
        case "structure":
          return parseStructure(xml, shape);
        case "map":
          return parseMap(xml, shape);
        case "list":
          return parseList(xml, shape);
        case void 0:
        case null:
          return parseUnknown(xml);
        default:
          return parseScalar(xml, shape);
      }
    }
    function parseStructure(xml, shape) {
      var data = {};
      if (xml === null)
        return data;
      util.each(shape.members, function(memberName, memberShape) {
        var xmlName = memberShape.name;
        if (Object.prototype.hasOwnProperty.call(xml, xmlName) && Array.isArray(xml[xmlName])) {
          var xmlChild = xml[xmlName];
          if (!memberShape.flattened)
            xmlChild = xmlChild[0];
          data[memberName] = parseXml(xmlChild, memberShape);
        } else if (memberShape.isXmlAttribute && xml.$ && Object.prototype.hasOwnProperty.call(xml.$, xmlName)) {
          data[memberName] = parseScalar(xml.$[xmlName], memberShape);
        } else if (memberShape.type === "list" && !shape.api.xmlNoDefaultLists) {
          data[memberName] = memberShape.defaultValue;
        }
      });
      return data;
    }
    function parseMap(xml, shape) {
      var data = {};
      if (xml === null)
        return data;
      var xmlKey = shape.key.name || "key";
      var xmlValue = shape.value.name || "value";
      var iterable = shape.flattened ? xml : xml.entry;
      if (Array.isArray(iterable)) {
        util.arrayEach(iterable, function(child) {
          data[child[xmlKey][0]] = parseXml(child[xmlValue][0], shape.value);
        });
      }
      return data;
    }
    function parseList(xml, shape) {
      var data = [];
      var name = shape.member.name || "member";
      if (shape.flattened) {
        util.arrayEach(xml, function(xmlChild) {
          data.push(parseXml(xmlChild, shape.member));
        });
      } else if (xml && Array.isArray(xml[name])) {
        util.arrayEach(xml[name], function(child) {
          data.push(parseXml(child, shape.member));
        });
      }
      return data;
    }
    function parseScalar(text, shape) {
      if (text && text.$ && text.$.encoding === "base64") {
        shape = new Shape.create({ type: text.$.encoding });
      }
      if (text && text._)
        text = text._;
      if (typeof shape.toType === "function") {
        return shape.toType(text);
      } else {
        return text;
      }
    }
    function parseUnknown(xml) {
      if (xml === void 0 || xml === null)
        return "";
      if (typeof xml === "string")
        return xml;
      if (Array.isArray(xml)) {
        var arr = [];
        for (i = 0; i < xml.length; i++) {
          arr.push(parseXml(xml[i], {}));
        }
        return arr;
      }
      var keys = Object.keys(xml), i;
      if (keys.length === 0 || keys.length === 1 && keys[0] === "$") {
        return {};
      }
      var data = {};
      for (i = 0; i < keys.length; i++) {
        var key = keys[i], value = xml[key];
        if (key === "$")
          continue;
        if (value.length > 1) {
          data[key] = parseList(value, { member: {} });
        } else {
          data[key] = parseXml(value[0], {});
        }
      }
      return data;
    }
    module2.exports = NodeXmlParser;
  }
});

// node_modules/aws-sdk/lib/http/node.js
var require_node = __commonJS({
  "node_modules/aws-sdk/lib/http/node.js"() {
    var AWS3 = require_core();
    var Stream = AWS3.util.stream.Stream;
    var TransformStream = AWS3.util.stream.Transform;
    var ReadableStream = AWS3.util.stream.Readable;
    require_http();
    var CONNECTION_REUSE_ENV_NAME = "AWS_NODEJS_CONNECTION_REUSE_ENABLED";
    AWS3.NodeHttpClient = AWS3.util.inherit({
      handleRequest: function handleRequest(httpRequest, httpOptions, callback, errCallback) {
        var self2 = this;
        var endpoint = httpRequest.endpoint;
        var pathPrefix = "";
        if (!httpOptions)
          httpOptions = {};
        if (httpOptions.proxy) {
          pathPrefix = endpoint.protocol + "//" + endpoint.hostname;
          if (endpoint.port !== 80 && endpoint.port !== 443) {
            pathPrefix += ":" + endpoint.port;
          }
          endpoint = new AWS3.Endpoint(httpOptions.proxy);
        }
        var useSSL = endpoint.protocol === "https:";
        var http = useSSL ? require("https") : require("http");
        var options = {
          host: endpoint.hostname,
          port: endpoint.port,
          method: httpRequest.method,
          headers: httpRequest.headers,
          path: pathPrefix + httpRequest.path
        };
        if (!httpOptions.agent) {
          options.agent = this.getAgent(useSSL, {
            keepAlive: process.env[CONNECTION_REUSE_ENV_NAME] === "1" ? true : false
          });
        }
        AWS3.util.update(options, httpOptions);
        delete options.proxy;
        delete options.timeout;
        var stream = http.request(options, function(httpResp) {
          if (stream.didCallback)
            return;
          callback(httpResp);
          httpResp.emit("headers", httpResp.statusCode, httpResp.headers, httpResp.statusMessage);
        });
        httpRequest.stream = stream;
        stream.didCallback = false;
        if (httpOptions.connectTimeout) {
          var connectTimeoutId;
          stream.on("socket", function(socket) {
            if (socket.connecting) {
              connectTimeoutId = setTimeout(function connectTimeout() {
                if (stream.didCallback)
                  return;
                stream.didCallback = true;
                stream.abort();
                errCallback(AWS3.util.error(new Error("Socket timed out without establishing a connection"), { code: "TimeoutError" }));
              }, httpOptions.connectTimeout);
              socket.on("connect", function() {
                clearTimeout(connectTimeoutId);
                connectTimeoutId = null;
              });
            }
          });
        }
        stream.setTimeout(httpOptions.timeout || 0, function() {
          if (stream.didCallback)
            return;
          stream.didCallback = true;
          var msg = "Connection timed out after " + httpOptions.timeout + "ms";
          errCallback(AWS3.util.error(new Error(msg), { code: "TimeoutError" }));
          stream.abort();
        });
        stream.on("error", function(err) {
          if (connectTimeoutId) {
            clearTimeout(connectTimeoutId);
            connectTimeoutId = null;
          }
          if (stream.didCallback)
            return;
          stream.didCallback = true;
          if (err.code === "ECONNRESET" || err.code === "EPIPE" || err.code === "ETIMEDOUT") {
            errCallback(AWS3.util.error(err, { code: "TimeoutError" }));
          } else {
            errCallback(err);
          }
        });
        var expect = httpRequest.headers.Expect || httpRequest.headers.expect;
        if (expect === "100-continue") {
          stream.once("continue", function() {
            self2.writeBody(stream, httpRequest);
          });
        } else {
          this.writeBody(stream, httpRequest);
        }
        return stream;
      },
      writeBody: function writeBody(stream, httpRequest) {
        var body = httpRequest.body;
        var totalBytes = parseInt(httpRequest.headers["Content-Length"], 10);
        if (body instanceof Stream) {
          var progressStream = this.progressStream(stream, totalBytes);
          if (progressStream) {
            body.pipe(progressStream).pipe(stream);
          } else {
            body.pipe(stream);
          }
        } else if (body) {
          stream.once("finish", function() {
            stream.emit("sendProgress", {
              loaded: totalBytes,
              total: totalBytes
            });
          });
          stream.end(body);
        } else {
          stream.end();
        }
      },
      getAgent: function getAgent(useSSL, agentOptions) {
        var http = useSSL ? require("https") : require("http");
        if (useSSL) {
          if (!AWS3.NodeHttpClient.sslAgent) {
            AWS3.NodeHttpClient.sslAgent = new http.Agent(AWS3.util.merge({
              rejectUnauthorized: process.env.NODE_TLS_REJECT_UNAUTHORIZED === "0" ? false : true
            }, agentOptions || {}));
            AWS3.NodeHttpClient.sslAgent.setMaxListeners(0);
            Object.defineProperty(AWS3.NodeHttpClient.sslAgent, "maxSockets", {
              enumerable: true,
              get: function() {
                var defaultMaxSockets = 50;
                var globalAgent = http.globalAgent;
                if (globalAgent && globalAgent.maxSockets !== Infinity && typeof globalAgent.maxSockets === "number") {
                  return globalAgent.maxSockets;
                }
                return defaultMaxSockets;
              }
            });
          }
          return AWS3.NodeHttpClient.sslAgent;
        } else {
          if (!AWS3.NodeHttpClient.agent) {
            AWS3.NodeHttpClient.agent = new http.Agent(agentOptions);
          }
          return AWS3.NodeHttpClient.agent;
        }
      },
      progressStream: function progressStream(stream, totalBytes) {
        if (typeof TransformStream === "undefined") {
          return;
        }
        var loadedBytes = 0;
        var reporter = new TransformStream();
        reporter._transform = function(chunk, encoding, callback) {
          if (chunk) {
            loadedBytes += chunk.length;
            stream.emit("sendProgress", {
              loaded: loadedBytes,
              total: totalBytes
            });
          }
          callback(null, chunk);
        };
        return reporter;
      },
      emitter: null
    });
    AWS3.HttpClient.prototype = AWS3.NodeHttpClient.prototype;
    AWS3.HttpClient.streamsApiVersion = ReadableStream ? 2 : 1;
  }
});

// node_modules/aws-sdk/lib/credentials/token_file_web_identity_credentials.js
var require_token_file_web_identity_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/token_file_web_identity_credentials.js"() {
    var AWS3 = require_core();
    var fs2 = require("fs");
    var STS = require_sts2();
    var iniLoader = AWS3.util.iniLoader;
    AWS3.TokenFileWebIdentityCredentials = AWS3.util.inherit(AWS3.Credentials, {
      constructor: function TokenFileWebIdentityCredentials(clientConfig) {
        AWS3.Credentials.call(this);
        this.data = null;
        this.clientConfig = AWS3.util.copy(clientConfig || {});
      },
      getParamsFromEnv: function getParamsFromEnv() {
        var ENV_TOKEN_FILE = "AWS_WEB_IDENTITY_TOKEN_FILE", ENV_ROLE_ARN = "AWS_ROLE_ARN";
        if (process.env[ENV_TOKEN_FILE] && process.env[ENV_ROLE_ARN]) {
          return [{
            envTokenFile: process.env[ENV_TOKEN_FILE],
            roleArn: process.env[ENV_ROLE_ARN],
            roleSessionName: process.env["AWS_ROLE_SESSION_NAME"]
          }];
        }
      },
      getParamsFromSharedConfig: function getParamsFromSharedConfig() {
        var profiles = AWS3.util.getProfilesFromSharedConfig(iniLoader);
        var profileName = process.env.AWS_PROFILE || AWS3.util.defaultProfile;
        var profile = profiles[profileName] || {};
        if (Object.keys(profile).length === 0) {
          throw AWS3.util.error(new Error("Profile " + profileName + " not found"), { code: "TokenFileWebIdentityCredentialsProviderFailure" });
        }
        var paramsArray = [];
        while (!profile["web_identity_token_file"] && profile["source_profile"]) {
          paramsArray.unshift({
            roleArn: profile["role_arn"],
            roleSessionName: profile["role_session_name"]
          });
          var sourceProfile = profile["source_profile"];
          profile = profiles[sourceProfile];
        }
        paramsArray.unshift({
          envTokenFile: profile["web_identity_token_file"],
          roleArn: profile["role_arn"],
          roleSessionName: profile["role_session_name"]
        });
        return paramsArray;
      },
      refresh: function refresh(callback) {
        this.coalesceRefresh(callback || AWS3.util.fn.callback);
      },
      assumeRoleChaining: function assumeRoleChaining(paramsArray, callback) {
        var self2 = this;
        if (paramsArray.length === 0) {
          self2.service.credentialsFrom(self2.data, self2);
          callback();
        } else {
          var params = paramsArray.shift();
          self2.service.config.credentials = self2.service.credentialsFrom(self2.data, self2);
          self2.service.assumeRole({
            RoleArn: params.roleArn,
            RoleSessionName: params.roleSessionName || "token-file-web-identity"
          }, function(err, data) {
            self2.data = null;
            if (err) {
              callback(err);
            } else {
              self2.data = data;
              self2.assumeRoleChaining(paramsArray, callback);
            }
          });
        }
      },
      load: function load(callback) {
        var self2 = this;
        try {
          var paramsArray = self2.getParamsFromEnv();
          if (!paramsArray) {
            paramsArray = self2.getParamsFromSharedConfig();
          }
          if (paramsArray) {
            var params = paramsArray.shift();
            var oidcToken = fs2.readFileSync(params.envTokenFile, { encoding: "ascii" });
            if (!self2.service) {
              self2.createClients();
            }
            self2.service.assumeRoleWithWebIdentity({
              WebIdentityToken: oidcToken,
              RoleArn: params.roleArn,
              RoleSessionName: params.roleSessionName || "token-file-web-identity"
            }, function(err, data) {
              self2.data = null;
              if (err) {
                callback(err);
              } else {
                self2.data = data;
                self2.assumeRoleChaining(paramsArray, callback);
              }
            });
          }
        } catch (err) {
          callback(err);
        }
      },
      createClients: function() {
        if (!this.service) {
          var stsConfig = AWS3.util.merge({}, this.clientConfig);
          this.service = new STS(stsConfig);
          this.service.retryableError = function(error) {
            if (error.code === "IDPCommunicationErrorException" || error.code === "InvalidIdentityToken") {
              return true;
            } else {
              return AWS3.Service.prototype.retryableError.call(this, error);
            }
          };
        }
      }
    });
  }
});

// node_modules/aws-sdk/lib/metadata_service/endpoint.js
var require_endpoint = __commonJS({
  "node_modules/aws-sdk/lib/metadata_service/endpoint.js"(exports, module2) {
    var Endpoint = {
      IPv4: "http://169.254.169.254",
      IPv6: "http://[fd00:ec2::254]"
    };
    module2.exports = Endpoint;
  }
});

// node_modules/aws-sdk/lib/metadata_service/endpoint_mode.js
var require_endpoint_mode = __commonJS({
  "node_modules/aws-sdk/lib/metadata_service/endpoint_mode.js"(exports, module2) {
    var EndpointMode = {
      IPv4: "IPv4",
      IPv6: "IPv6"
    };
    module2.exports = EndpointMode;
  }
});

// node_modules/aws-sdk/lib/metadata_service/endpoint_config_options.js
var require_endpoint_config_options = __commonJS({
  "node_modules/aws-sdk/lib/metadata_service/endpoint_config_options.js"(exports, module2) {
    var ENV_ENDPOINT_NAME = "AWS_EC2_METADATA_SERVICE_ENDPOINT";
    var CONFIG_ENDPOINT_NAME = "ec2_metadata_service_endpoint";
    var ENDPOINT_CONFIG_OPTIONS = {
      environmentVariableSelector: function(env2) {
        return env2[ENV_ENDPOINT_NAME];
      },
      configFileSelector: function(profile) {
        return profile[CONFIG_ENDPOINT_NAME];
      },
      default: void 0
    };
    module2.exports = {
      ENV_ENDPOINT_NAME,
      CONFIG_ENDPOINT_NAME,
      ENDPOINT_CONFIG_OPTIONS
    };
  }
});

// node_modules/aws-sdk/lib/metadata_service/endpoint_mode_config_options.js
var require_endpoint_mode_config_options = __commonJS({
  "node_modules/aws-sdk/lib/metadata_service/endpoint_mode_config_options.js"(exports, module2) {
    var EndpointMode = require_endpoint_mode();
    var ENV_ENDPOINT_MODE_NAME = "AWS_EC2_METADATA_SERVICE_ENDPOINT_MODE";
    var CONFIG_ENDPOINT_MODE_NAME = "ec2_metadata_service_endpoint_mode";
    var ENDPOINT_MODE_CONFIG_OPTIONS = {
      environmentVariableSelector: function(env2) {
        return env2[ENV_ENDPOINT_MODE_NAME];
      },
      configFileSelector: function(profile) {
        return profile[CONFIG_ENDPOINT_MODE_NAME];
      },
      default: EndpointMode.IPv4
    };
    module2.exports = {
      ENV_ENDPOINT_MODE_NAME,
      CONFIG_ENDPOINT_MODE_NAME,
      ENDPOINT_MODE_CONFIG_OPTIONS
    };
  }
});

// node_modules/aws-sdk/lib/metadata_service/get_metadata_service_endpoint.js
var require_get_metadata_service_endpoint = __commonJS({
  "node_modules/aws-sdk/lib/metadata_service/get_metadata_service_endpoint.js"(exports, module2) {
    var AWS3 = require_core();
    var Endpoint = require_endpoint();
    var EndpointMode = require_endpoint_mode();
    var ENDPOINT_CONFIG_OPTIONS = require_endpoint_config_options().ENDPOINT_CONFIG_OPTIONS;
    var ENDPOINT_MODE_CONFIG_OPTIONS = require_endpoint_mode_config_options().ENDPOINT_MODE_CONFIG_OPTIONS;
    var getMetadataServiceEndpoint = function() {
      var endpoint = AWS3.util.loadConfig(ENDPOINT_CONFIG_OPTIONS);
      if (endpoint !== void 0)
        return endpoint;
      var endpointMode = AWS3.util.loadConfig(ENDPOINT_MODE_CONFIG_OPTIONS);
      switch (endpointMode) {
        case EndpointMode.IPv4:
          return Endpoint.IPv4;
        case EndpointMode.IPv6:
          return Endpoint.IPv6;
        default:
          throw new Error("Unsupported endpoint mode: " + endpointMode);
      }
    };
    module2.exports = getMetadataServiceEndpoint;
  }
});

// node_modules/aws-sdk/lib/metadata_service.js
var require_metadata_service = __commonJS({
  "node_modules/aws-sdk/lib/metadata_service.js"(exports, module2) {
    var AWS3 = require_core();
    require_http();
    var inherit = AWS3.util.inherit;
    var getMetadataServiceEndpoint = require_get_metadata_service_endpoint();
    var URL = require("url").URL;
    AWS3.MetadataService = inherit({
      endpoint: getMetadataServiceEndpoint(),
      httpOptions: { timeout: 0 },
      disableFetchToken: false,
      constructor: function MetadataService(options) {
        if (options && options.host) {
          options.endpoint = "http://" + options.host;
          delete options.host;
        }
        AWS3.util.update(this, options);
      },
      request: function request(path2, options, callback) {
        if (arguments.length === 2) {
          callback = options;
          options = {};
        }
        if (process.env[AWS3.util.imdsDisabledEnv]) {
          callback(new Error("EC2 Instance Metadata Service access disabled"));
          return;
        }
        path2 = path2 || "/";
        if (URL) {
          new URL(this.endpoint);
        }
        var httpRequest = new AWS3.HttpRequest(this.endpoint + path2);
        httpRequest.method = options.method || "GET";
        if (options.headers) {
          httpRequest.headers = options.headers;
        }
        AWS3.util.handleRequestWithRetries(httpRequest, this, callback);
      },
      loadCredentialsCallbacks: [],
      fetchMetadataToken: function fetchMetadataToken(callback) {
        var self2 = this;
        var tokenFetchPath = "/latest/api/token";
        self2.request(tokenFetchPath, {
          "method": "PUT",
          "headers": {
            "x-aws-ec2-metadata-token-ttl-seconds": "21600"
          }
        }, callback);
      },
      fetchCredentials: function fetchCredentials(options, cb) {
        var self2 = this;
        var basePath = "/latest/meta-data/iam/security-credentials/";
        self2.request(basePath, options, function(err, roleName) {
          if (err) {
            self2.disableFetchToken = !(err.statusCode === 401);
            cb(AWS3.util.error(err, {
              message: "EC2 Metadata roleName request returned error"
            }));
            return;
          }
          roleName = roleName.split("\n")[0];
          self2.request(basePath + roleName, options, function(credErr, credData) {
            if (credErr) {
              self2.disableFetchToken = !(credErr.statusCode === 401);
              cb(AWS3.util.error(credErr, {
                message: "EC2 Metadata creds request returned error"
              }));
              return;
            }
            try {
              var credentials = JSON.parse(credData);
              cb(null, credentials);
            } catch (parseError) {
              cb(parseError);
            }
          });
        });
      },
      loadCredentials: function loadCredentials(callback) {
        var self2 = this;
        self2.loadCredentialsCallbacks.push(callback);
        if (self2.loadCredentialsCallbacks.length > 1) {
          return;
        }
        function callbacks(err, creds) {
          var cb;
          while ((cb = self2.loadCredentialsCallbacks.shift()) !== void 0) {
            cb(err, creds);
          }
        }
        if (self2.disableFetchToken) {
          self2.fetchCredentials({}, callbacks);
        } else {
          self2.fetchMetadataToken(function(tokenError, token) {
            if (tokenError) {
              if (tokenError.code === "TimeoutError") {
                self2.disableFetchToken = true;
              } else if (tokenError.retryable === true) {
                callbacks(AWS3.util.error(tokenError, {
                  message: "EC2 Metadata token request returned error"
                }));
                return;
              } else if (tokenError.statusCode === 400) {
                callbacks(AWS3.util.error(tokenError, {
                  message: "EC2 Metadata token request returned 400"
                }));
                return;
              }
            }
            var options = {};
            if (token) {
              options.headers = {
                "x-aws-ec2-metadata-token": token
              };
            }
            self2.fetchCredentials(options, callbacks);
          });
        }
      }
    });
    module2.exports = AWS3.MetadataService;
  }
});

// node_modules/aws-sdk/lib/credentials/ec2_metadata_credentials.js
var require_ec2_metadata_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/ec2_metadata_credentials.js"() {
    var AWS3 = require_core();
    require_metadata_service();
    AWS3.EC2MetadataCredentials = AWS3.util.inherit(AWS3.Credentials, {
      constructor: function EC2MetadataCredentials(options) {
        AWS3.Credentials.call(this);
        options = options ? AWS3.util.copy(options) : {};
        options = AWS3.util.merge({ maxRetries: this.defaultMaxRetries }, options);
        if (!options.httpOptions)
          options.httpOptions = {};
        options.httpOptions = AWS3.util.merge({
          timeout: this.defaultTimeout,
          connectTimeout: this.defaultConnectTimeout
        }, options.httpOptions);
        this.metadataService = new AWS3.MetadataService(options);
        this.metadata = {};
      },
      defaultTimeout: 1e3,
      defaultConnectTimeout: 1e3,
      defaultMaxRetries: 3,
      refresh: function refresh(callback) {
        this.coalesceRefresh(callback || AWS3.util.fn.callback);
      },
      load: function load(callback) {
        var self2 = this;
        self2.metadataService.loadCredentials(function(err, creds) {
          if (!err) {
            var currentTime = AWS3.util.date.getDate();
            var expireTime = new Date(creds.Expiration);
            if (expireTime < currentTime) {
              err = AWS3.util.error(new Error("EC2 Instance Metadata Serivce provided expired credentials"), { code: "EC2MetadataCredentialsProviderFailure" });
            } else {
              self2.expired = false;
              self2.metadata = creds;
              self2.accessKeyId = creds.AccessKeyId;
              self2.secretAccessKey = creds.SecretAccessKey;
              self2.sessionToken = creds.Token;
              self2.expireTime = expireTime;
            }
          }
          callback(err);
        });
      }
    });
  }
});

// node_modules/aws-sdk/lib/credentials/remote_credentials.js
var require_remote_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/remote_credentials.js"() {
    var AWS3 = require_core();
    var ENV_RELATIVE_URI = "AWS_CONTAINER_CREDENTIALS_RELATIVE_URI";
    var ENV_FULL_URI = "AWS_CONTAINER_CREDENTIALS_FULL_URI";
    var ENV_AUTH_TOKEN = "AWS_CONTAINER_AUTHORIZATION_TOKEN";
    var FULL_URI_UNRESTRICTED_PROTOCOLS = ["https:"];
    var FULL_URI_ALLOWED_PROTOCOLS = ["http:", "https:"];
    var FULL_URI_ALLOWED_HOSTNAMES = ["localhost", "127.0.0.1"];
    var RELATIVE_URI_HOST = "169.254.170.2";
    AWS3.RemoteCredentials = AWS3.util.inherit(AWS3.Credentials, {
      constructor: function RemoteCredentials(options) {
        AWS3.Credentials.call(this);
        options = options ? AWS3.util.copy(options) : {};
        if (!options.httpOptions)
          options.httpOptions = {};
        options.httpOptions = AWS3.util.merge(this.httpOptions, options.httpOptions);
        AWS3.util.update(this, options);
      },
      httpOptions: { timeout: 1e3 },
      maxRetries: 3,
      isConfiguredForEcsCredentials: function isConfiguredForEcsCredentials() {
        return Boolean(process && process.env && (process.env[ENV_RELATIVE_URI] || process.env[ENV_FULL_URI]));
      },
      getECSFullUri: function getECSFullUri() {
        if (process && process.env) {
          var relative = process.env[ENV_RELATIVE_URI], full = process.env[ENV_FULL_URI];
          if (relative) {
            return "http://" + RELATIVE_URI_HOST + relative;
          } else if (full) {
            var parsed = AWS3.util.urlParse(full);
            if (FULL_URI_ALLOWED_PROTOCOLS.indexOf(parsed.protocol) < 0) {
              throw AWS3.util.error(new Error("Unsupported protocol:  AWS.RemoteCredentials supports " + FULL_URI_ALLOWED_PROTOCOLS.join(",") + " only; " + parsed.protocol + " requested."), { code: "ECSCredentialsProviderFailure" });
            }
            if (FULL_URI_UNRESTRICTED_PROTOCOLS.indexOf(parsed.protocol) < 0 && FULL_URI_ALLOWED_HOSTNAMES.indexOf(parsed.hostname) < 0) {
              throw AWS3.util.error(new Error("Unsupported hostname: AWS.RemoteCredentials only supports " + FULL_URI_ALLOWED_HOSTNAMES.join(",") + " for " + parsed.protocol + "; " + parsed.protocol + "//" + parsed.hostname + " requested."), { code: "ECSCredentialsProviderFailure" });
            }
            return full;
          } else {
            throw AWS3.util.error(new Error("Variable " + ENV_RELATIVE_URI + " or " + ENV_FULL_URI + " must be set to use AWS.RemoteCredentials."), { code: "ECSCredentialsProviderFailure" });
          }
        } else {
          throw AWS3.util.error(new Error("No process info available"), { code: "ECSCredentialsProviderFailure" });
        }
      },
      getECSAuthToken: function getECSAuthToken() {
        if (process && process.env && process.env[ENV_FULL_URI]) {
          return process.env[ENV_AUTH_TOKEN];
        }
      },
      credsFormatIsValid: function credsFormatIsValid(credData) {
        return !!credData.accessKeyId && !!credData.secretAccessKey && !!credData.sessionToken && !!credData.expireTime;
      },
      formatCreds: function formatCreds(credData) {
        if (!!credData.credentials) {
          credData = credData.credentials;
        }
        return {
          expired: false,
          accessKeyId: credData.accessKeyId || credData.AccessKeyId,
          secretAccessKey: credData.secretAccessKey || credData.SecretAccessKey,
          sessionToken: credData.sessionToken || credData.Token,
          expireTime: new Date(credData.expiration || credData.Expiration)
        };
      },
      request: function request(url, callback) {
        var httpRequest = new AWS3.HttpRequest(url);
        httpRequest.method = "GET";
        httpRequest.headers.Accept = "application/json";
        var token = this.getECSAuthToken();
        if (token) {
          httpRequest.headers.Authorization = token;
        }
        AWS3.util.handleRequestWithRetries(httpRequest, this, callback);
      },
      refresh: function refresh(callback) {
        this.coalesceRefresh(callback || AWS3.util.fn.callback);
      },
      load: function load(callback) {
        var self2 = this;
        var fullUri;
        try {
          fullUri = this.getECSFullUri();
        } catch (err) {
          callback(err);
          return;
        }
        this.request(fullUri, function(err, data) {
          if (!err) {
            try {
              data = JSON.parse(data);
              var creds = self2.formatCreds(data);
              if (!self2.credsFormatIsValid(creds)) {
                throw AWS3.util.error(new Error("Response data is not in valid format"), { code: "ECSCredentialsProviderFailure" });
              }
              AWS3.util.update(self2, creds);
            } catch (dataError) {
              err = dataError;
            }
          }
          callback(err, creds);
        });
      }
    });
  }
});

// node_modules/aws-sdk/lib/credentials/ecs_credentials.js
var require_ecs_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/ecs_credentials.js"() {
    var AWS3 = require_core();
    AWS3.ECSCredentials = AWS3.RemoteCredentials;
  }
});

// node_modules/aws-sdk/lib/credentials/environment_credentials.js
var require_environment_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/environment_credentials.js"() {
    var AWS3 = require_core();
    AWS3.EnvironmentCredentials = AWS3.util.inherit(AWS3.Credentials, {
      constructor: function EnvironmentCredentials(envPrefix) {
        AWS3.Credentials.call(this);
        this.envPrefix = envPrefix;
        this.get(function() {
        });
      },
      refresh: function refresh(callback) {
        if (!callback)
          callback = AWS3.util.fn.callback;
        if (!process || !process.env) {
          callback(AWS3.util.error(new Error("No process info or environment variables available"), { code: "EnvironmentCredentialsProviderFailure" }));
          return;
        }
        var keys = ["ACCESS_KEY_ID", "SECRET_ACCESS_KEY", "SESSION_TOKEN"];
        var values = [];
        for (var i = 0; i < keys.length; i++) {
          var prefix = "";
          if (this.envPrefix)
            prefix = this.envPrefix + "_";
          values[i] = process.env[prefix + keys[i]];
          if (!values[i] && keys[i] !== "SESSION_TOKEN") {
            callback(AWS3.util.error(new Error("Variable " + prefix + keys[i] + " not set."), { code: "EnvironmentCredentialsProviderFailure" }));
            return;
          }
        }
        this.expired = false;
        AWS3.Credentials.apply(this, values);
        callback();
      }
    });
  }
});

// node_modules/aws-sdk/lib/credentials/file_system_credentials.js
var require_file_system_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/file_system_credentials.js"() {
    var AWS3 = require_core();
    AWS3.FileSystemCredentials = AWS3.util.inherit(AWS3.Credentials, {
      constructor: function FileSystemCredentials(filename) {
        AWS3.Credentials.call(this);
        this.filename = filename;
        this.get(function() {
        });
      },
      refresh: function refresh(callback) {
        if (!callback)
          callback = AWS3.util.fn.callback;
        try {
          var creds = JSON.parse(AWS3.util.readFileSync(this.filename));
          AWS3.Credentials.call(this, creds);
          if (!this.accessKeyId || !this.secretAccessKey) {
            throw AWS3.util.error(new Error("Credentials not set in " + this.filename), { code: "FileSystemCredentialsProviderFailure" });
          }
          this.expired = false;
          callback();
        } catch (err) {
          callback(err);
        }
      }
    });
  }
});

// node_modules/aws-sdk/lib/credentials/shared_ini_file_credentials.js
var require_shared_ini_file_credentials = __commonJS({
  "node_modules/aws-sdk/lib/credentials/shared_ini_file_credentials.js"() {
    var AWS3 = require_core();
    var STS = require_sts2();
    var iniLoader = AWS3.util.iniLoader;
    var ASSUME_ROLE_DEFAULT_REGION = "us-east-1";
    AWS3.SharedIniFileCredentials = AWS3.util.inherit(AWS3.Credentials, {
      constructor: function SharedIniFileCredentials(options) {
        AWS3.Credentials.call(this);
        options = options || {};
        this.filename = options.filename;
        this.profile = options.profile || process.env.AWS_PROFILE || AWS3.util.defaultProfile;
        this.disableAssumeRole = Boolean(options.disableAssumeRole);
        this.preferStaticCredentials = Boolean(options.preferStaticCredentials);
        this.tokenCodeFn = options.tokenCodeFn || null;
        this.httpOptions = options.httpOptions || null;
        this.get(options.callback || AWS3.util.fn.noop);
      },
      load: function load(callback) {
        var self2 = this;
        try {
          var profiles = AWS3.util.getProfilesFromSharedConfig(iniLoader, this.filename);
          var profile = profiles[this.profile] || {};
          if (Object.keys(profile).length === 0) {
            throw AWS3.util.error(new Error("Profile " + this.profile + " not found"), { code: "SharedIniFileCredentialsProviderFailure" });
          }
          var preferStaticCredentialsToRoleArn = Boolean(this.preferStaticCredentials && profile["aws_access_key_id"] && profile["aws_secret_access_key"]);
          if (profile["role_arn"] && !preferStaticCredentialsToRoleArn) {
            this.loadRoleProfile(profiles, profile, function(err, data) {
              if (err) {
                callback(err);
              } else {
                self2.expired = false;
                self2.accessKeyId = data.Credentials.AccessKeyId;
                self2.secretAccessKey = data.Credentials.SecretAccessKey;
                self2.sessionToken = data.Credentials.SessionToken;
                self2.expireTime = data.Credentials.Expiration;
                callback(null);
              }
            });
            return;
          }
          this.accessKeyId = profile["aws_access_key_id"];
          this.secretAccessKey = profile["aws_secret_access_key"];
          this.sessionToken = profile["aws_session_token"];
          if (!this.accessKeyId || !this.secretAccessKey) {
            throw AWS3.util.error(new Error("Credentials not set for profile " + this.profile), { code: "SharedIniFileCredentialsProviderFailure" });
          }
          this.expired = false;
          callback(null);
        } catch (err) {
          callback(err);
        }
      },
      refresh: function refresh(callback) {
        iniLoader.clearCachedFiles();
        this.coalesceRefresh(callback || AWS3.util.fn.callback, this.disableAssumeRole);
      },
      loadRoleProfile: function loadRoleProfile(creds, roleProfile, callback) {
        if (this.disableAssumeRole) {
          throw AWS3.util.error(new Error("Role assumption profiles are disabled. Failed to load profile " + this.profile + " from " + creds.filename), { code: "SharedIniFileCredentialsProviderFailure" });
        }
        var self2 = this;
        var roleArn = roleProfile["role_arn"];
        var roleSessionName = roleProfile["role_session_name"];
        var externalId = roleProfile["external_id"];
        var mfaSerial = roleProfile["mfa_serial"];
        var sourceProfileName = roleProfile["source_profile"];
        var profileRegion = roleProfile["region"] || ASSUME_ROLE_DEFAULT_REGION;
        if (!sourceProfileName) {
          throw AWS3.util.error(new Error("source_profile is not set using profile " + this.profile), { code: "SharedIniFileCredentialsProviderFailure" });
        }
        var sourceProfileExistanceTest = creds[sourceProfileName];
        if (typeof sourceProfileExistanceTest !== "object") {
          throw AWS3.util.error(new Error("source_profile " + sourceProfileName + " using profile " + this.profile + " does not exist"), { code: "SharedIniFileCredentialsProviderFailure" });
        }
        var sourceCredentials = new AWS3.SharedIniFileCredentials(AWS3.util.merge(this.options || {}, {
          profile: sourceProfileName,
          preferStaticCredentials: true
        }));
        this.roleArn = roleArn;
        var sts = new STS({
          credentials: sourceCredentials,
          region: profileRegion,
          httpOptions: this.httpOptions
        });
        var roleParams = {
          RoleArn: roleArn,
          RoleSessionName: roleSessionName || "aws-sdk-js-" + Date.now()
        };
        if (externalId) {
          roleParams.ExternalId = externalId;
        }
        if (mfaSerial && self2.tokenCodeFn) {
          roleParams.SerialNumber = mfaSerial;
          self2.tokenCodeFn(mfaSerial, function(err, token) {
            if (err) {
              var message;
              if (err instanceof Error) {
                message = err.message;
              } else {
                message = err;
              }
              callback(AWS3.util.error(new Error("Error fetching MFA token: " + message), { code: "SharedIniFileCredentialsProviderFailure" }));
              return;
            }
            roleParams.TokenCode = token;
            sts.assumeRole(roleParams, callback);
          });
          return;
        }
        sts.assumeRole(roleParams, callback);
      }
    });
  }
});

// node_modules/aws-sdk/lib/node_loader.js
var require_node_loader = __commonJS({
  "node_modules/aws-sdk/lib/node_loader.js"(exports, module2) {
    var util = require_util4();
    util.isBrowser = function() {
      return false;
    };
    util.isNode = function() {
      return true;
    };
    util.crypto.lib = require("crypto");
    util.Buffer = require("buffer").Buffer;
    util.domain = require("domain");
    util.stream = require("stream");
    util.url = require("url");
    util.querystring = require("querystring");
    util.environment = "nodejs";
    util.createEventStream = util.stream.Readable ? require_streaming_create_event_stream().createEventStream : require_buffered_create_event_stream().createEventStream;
    util.realClock = require_nodeClock();
    util.clientSideMonitoring = {
      Publisher: require_publisher().Publisher,
      configProvider: require_configuration2()
    };
    util.iniLoader = require_shared_ini().iniLoader;
    util.getSystemErrorName = require("util").getSystemErrorName;
    util.loadConfig = function(options) {
      var envValue = options.environmentVariableSelector(process.env);
      if (envValue !== void 0) {
        return envValue;
      }
      var configFile = {};
      try {
        configFile = util.iniLoader ? util.iniLoader.loadFrom({
          isConfig: true,
          filename: process.env[util.sharedConfigFileEnv]
        }) : {};
      } catch (e) {
      }
      var sharedFileConfig = configFile[process.env.AWS_PROFILE || util.defaultProfile] || {};
      var configValue = options.configFileSelector(sharedFileConfig);
      if (configValue !== void 0) {
        return configValue;
      }
      if (typeof options.default === "function") {
        return options.default();
      }
      return options.default;
    };
    var AWS3;
    module2.exports = AWS3 = require_core();
    require_credentials();
    require_credential_provider_chain();
    require_temporary_credentials();
    require_chainable_temporary_credentials();
    require_web_identity_credentials();
    require_cognito_identity_credentials();
    require_saml_credentials();
    require_process_credentials();
    AWS3.XML.Parser = require_node_parser();
    require_node();
    require_ini_loader();
    require_token_file_web_identity_credentials();
    require_ec2_metadata_credentials();
    require_remote_credentials();
    require_ecs_credentials();
    require_environment_credentials();
    require_file_system_credentials();
    require_shared_ini_file_credentials();
    require_process_credentials();
    AWS3.CredentialProviderChain.defaultProviders = [
      function() {
        return new AWS3.EnvironmentCredentials("AWS");
      },
      function() {
        return new AWS3.EnvironmentCredentials("AMAZON");
      },
      function() {
        return new AWS3.SharedIniFileCredentials();
      },
      function() {
        return new AWS3.ECSCredentials();
      },
      function() {
        return new AWS3.ProcessCredentials();
      },
      function() {
        return new AWS3.TokenFileWebIdentityCredentials();
      },
      function() {
        return new AWS3.EC2MetadataCredentials();
      }
    ];
    AWS3.util.update(AWS3.Config.prototype.keys, {
      credentials: function() {
        var credentials = null;
        new AWS3.CredentialProviderChain([
          function() {
            return new AWS3.EnvironmentCredentials("AWS");
          },
          function() {
            return new AWS3.EnvironmentCredentials("AMAZON");
          },
          function() {
            return new AWS3.SharedIniFileCredentials({ disableAssumeRole: true });
          }
        ]).resolve(function(err, creds) {
          if (!err)
            credentials = creds;
        });
        return credentials;
      },
      credentialProvider: function() {
        return new AWS3.CredentialProviderChain();
      },
      logger: function() {
        return process.env.AWSJS_DEBUG ? console : null;
      },
      region: function() {
        var env2 = process.env;
        var region = env2.AWS_REGION || env2.AMAZON_REGION;
        if (env2[AWS3.util.configOptInEnv]) {
          var toCheck = [
            { filename: env2[AWS3.util.sharedCredentialsFileEnv] },
            { isConfig: true, filename: env2[AWS3.util.sharedConfigFileEnv] }
          ];
          var iniLoader = AWS3.util.iniLoader;
          while (!region && toCheck.length) {
            var configFile = {};
            var fileInfo = toCheck.shift();
            try {
              configFile = iniLoader.loadFrom(fileInfo);
            } catch (err) {
              if (fileInfo.isConfig)
                throw err;
            }
            var profile = configFile[env2.AWS_PROFILE || AWS3.util.defaultProfile];
            region = profile && profile.region;
          }
        }
        return region;
      }
    });
    AWS3.config = new AWS3.Config();
  }
});

// node_modules/aws-sdk/apis/acm-2015-12-08.min.json
var require_acm_2015_12_08_min = __commonJS({
  "node_modules/aws-sdk/apis/acm-2015-12-08.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-12-08",
        endpointPrefix: "acm",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "ACM",
        serviceFullName: "AWS Certificate Manager",
        serviceId: "ACM",
        signatureVersion: "v4",
        targetPrefix: "CertificateManager",
        uid: "acm-2015-12-08"
      },
      operations: {
        AddTagsToCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateArn",
              "Tags"
            ],
            members: {
              CertificateArn: {},
              Tags: {
                shape: "S3"
              }
            }
          }
        },
        DeleteCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateArn"
            ],
            members: {
              CertificateArn: {}
            }
          }
        },
        DescribeCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateArn"
            ],
            members: {
              CertificateArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Certificate: {
                type: "structure",
                members: {
                  CertificateArn: {},
                  DomainName: {},
                  SubjectAlternativeNames: {
                    shape: "Sc"
                  },
                  DomainValidationOptions: {
                    shape: "Sd"
                  },
                  Serial: {},
                  Subject: {},
                  Issuer: {},
                  CreatedAt: {
                    type: "timestamp"
                  },
                  IssuedAt: {
                    type: "timestamp"
                  },
                  ImportedAt: {
                    type: "timestamp"
                  },
                  Status: {},
                  RevokedAt: {
                    type: "timestamp"
                  },
                  RevocationReason: {},
                  NotBefore: {
                    type: "timestamp"
                  },
                  NotAfter: {
                    type: "timestamp"
                  },
                  KeyAlgorithm: {},
                  SignatureAlgorithm: {},
                  InUseBy: {
                    type: "list",
                    member: {}
                  },
                  FailureReason: {},
                  Type: {},
                  RenewalSummary: {
                    type: "structure",
                    required: [
                      "RenewalStatus",
                      "DomainValidationOptions",
                      "UpdatedAt"
                    ],
                    members: {
                      RenewalStatus: {},
                      DomainValidationOptions: {
                        shape: "Sd"
                      },
                      RenewalStatusReason: {},
                      UpdatedAt: {
                        type: "timestamp"
                      }
                    }
                  },
                  KeyUsages: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {}
                      }
                    }
                  },
                  ExtendedKeyUsages: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        OID: {}
                      }
                    }
                  },
                  CertificateAuthorityArn: {},
                  RenewalEligibility: {},
                  Options: {
                    shape: "S11"
                  }
                }
              }
            }
          }
        },
        ExportCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateArn",
              "Passphrase"
            ],
            members: {
              CertificateArn: {},
              Passphrase: {
                type: "blob",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Certificate: {},
              CertificateChain: {},
              PrivateKey: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        GetAccountConfiguration: {
          output: {
            type: "structure",
            members: {
              ExpiryEvents: {
                shape: "S1a"
              }
            }
          }
        },
        GetCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateArn"
            ],
            members: {
              CertificateArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Certificate: {},
              CertificateChain: {}
            }
          }
        },
        ImportCertificate: {
          input: {
            type: "structure",
            required: [
              "Certificate",
              "PrivateKey"
            ],
            members: {
              CertificateArn: {},
              Certificate: {
                type: "blob"
              },
              PrivateKey: {
                type: "blob",
                sensitive: true
              },
              CertificateChain: {
                type: "blob"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CertificateArn: {}
            }
          }
        },
        ListCertificates: {
          input: {
            type: "structure",
            members: {
              CertificateStatuses: {
                type: "list",
                member: {}
              },
              Includes: {
                type: "structure",
                members: {
                  extendedKeyUsage: {
                    type: "list",
                    member: {}
                  },
                  keyUsage: {
                    type: "list",
                    member: {}
                  },
                  keyTypes: {
                    type: "list",
                    member: {}
                  }
                }
              },
              NextToken: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              CertificateSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CertificateArn: {},
                    DomainName: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateArn"
            ],
            members: {
              CertificateArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S3"
              }
            }
          }
        },
        PutAccountConfiguration: {
          input: {
            type: "structure",
            required: [
              "IdempotencyToken"
            ],
            members: {
              ExpiryEvents: {
                shape: "S1a"
              },
              IdempotencyToken: {}
            }
          }
        },
        RemoveTagsFromCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateArn",
              "Tags"
            ],
            members: {
              CertificateArn: {},
              Tags: {
                shape: "S3"
              }
            }
          }
        },
        RenewCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateArn"
            ],
            members: {
              CertificateArn: {}
            }
          }
        },
        RequestCertificate: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              ValidationMethod: {},
              SubjectAlternativeNames: {
                shape: "Sc"
              },
              IdempotencyToken: {},
              DomainValidationOptions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DomainName",
                    "ValidationDomain"
                  ],
                  members: {
                    DomainName: {},
                    ValidationDomain: {}
                  }
                }
              },
              Options: {
                shape: "S11"
              },
              CertificateAuthorityArn: {},
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CertificateArn: {}
            }
          }
        },
        ResendValidationEmail: {
          input: {
            type: "structure",
            required: [
              "CertificateArn",
              "Domain",
              "ValidationDomain"
            ],
            members: {
              CertificateArn: {},
              Domain: {},
              ValidationDomain: {}
            }
          }
        },
        UpdateCertificateOptions: {
          input: {
            type: "structure",
            required: [
              "CertificateArn",
              "Options"
            ],
            members: {
              CertificateArn: {},
              Options: {
                shape: "S11"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sc: {
          type: "list",
          member: {}
        },
        Sd: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              ValidationEmails: {
                type: "list",
                member: {}
              },
              ValidationDomain: {},
              ValidationStatus: {},
              ResourceRecord: {
                type: "structure",
                required: [
                  "Name",
                  "Type",
                  "Value"
                ],
                members: {
                  Name: {},
                  Type: {},
                  Value: {}
                }
              },
              ValidationMethod: {}
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            CertificateTransparencyLoggingPreference: {}
          }
        },
        S1a: {
          type: "structure",
          members: {
            DaysBeforeExpiry: {
              type: "integer"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/acm-2015-12-08.paginators.json
var require_acm_2015_12_08_paginators = __commonJS({
  "node_modules/aws-sdk/apis/acm-2015-12-08.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListCertificates: {
          input_token: "NextToken",
          limit_key: "MaxItems",
          output_token: "NextToken",
          result_key: "CertificateSummaryList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/acm-2015-12-08.waiters2.json
var require_acm_2015_12_08_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/acm-2015-12-08.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        CertificateValidated: {
          delay: 60,
          maxAttempts: 40,
          operation: "DescribeCertificate",
          acceptors: [
            {
              matcher: "pathAll",
              expected: "SUCCESS",
              argument: "Certificate.DomainValidationOptions[].ValidationStatus",
              state: "success"
            },
            {
              matcher: "pathAny",
              expected: "PENDING_VALIDATION",
              argument: "Certificate.DomainValidationOptions[].ValidationStatus",
              state: "retry"
            },
            {
              matcher: "path",
              expected: "FAILED",
              argument: "Certificate.Status",
              state: "failure"
            },
            {
              matcher: "error",
              expected: "ResourceNotFoundException",
              state: "failure"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/acm.js
var require_acm = __commonJS({
  "node_modules/aws-sdk/clients/acm.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["acm"] = {};
    AWS3.ACM = Service.defineService("acm", ["2015-12-08"]);
    Object.defineProperty(apiLoader.services["acm"], "2015-12-08", {
      get: function get() {
        var model = require_acm_2015_12_08_min();
        model.paginators = require_acm_2015_12_08_paginators().pagination;
        model.waiters = require_acm_2015_12_08_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ACM;
  }
});

// node_modules/aws-sdk/lib/services/apigateway.js
var require_apigateway = __commonJS({
  "node_modules/aws-sdk/lib/services/apigateway.js"() {
    var AWS3 = require_core();
    AWS3.util.update(AWS3.APIGateway.prototype, {
      setAcceptHeader: function setAcceptHeader(req) {
        var httpRequest = req.httpRequest;
        if (!httpRequest.headers.Accept) {
          httpRequest.headers["Accept"] = "application/json";
        }
      },
      setupRequestListeners: function setupRequestListeners(request) {
        request.addListener("build", this.setAcceptHeader);
        if (request.operation === "getExport") {
          var params = request.params || {};
          if (params.exportType === "swagger") {
            request.addListener("extractData", AWS3.util.convertPayloadToString);
          }
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/apigateway-2015-07-09.min.json
var require_apigateway_2015_07_09_min = __commonJS({
  "node_modules/aws-sdk/apis/apigateway-2015-07-09.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-07-09",
        endpointPrefix: "apigateway",
        protocol: "rest-json",
        serviceFullName: "Amazon API Gateway",
        serviceId: "API Gateway",
        signatureVersion: "v4",
        uid: "apigateway-2015-07-09"
      },
      operations: {
        CreateApiKey: {
          http: {
            requestUri: "/apikeys",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              name: {},
              description: {},
              enabled: {
                type: "boolean"
              },
              generateDistinctId: {
                type: "boolean"
              },
              value: {},
              stageKeys: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    restApiId: {},
                    stageName: {}
                  }
                }
              },
              customerId: {},
              tags: {
                shape: "S6"
              }
            }
          },
          output: {
            shape: "S7"
          }
        },
        CreateAuthorizer: {
          http: {
            requestUri: "/restapis/{restapi_id}/authorizers",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "name",
              "type"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              name: {},
              type: {},
              providerARNs: {
                shape: "Sc"
              },
              authType: {},
              authorizerUri: {},
              authorizerCredentials: {},
              identitySource: {},
              identityValidationExpression: {},
              authorizerResultTtlInSeconds: {
                type: "integer"
              }
            }
          },
          output: {
            shape: "Sf"
          }
        },
        CreateBasePathMapping: {
          http: {
            requestUri: "/domainnames/{domain_name}/basepathmappings",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "domainName",
              "restApiId"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domain_name"
              },
              basePath: {},
              restApiId: {},
              stage: {}
            }
          },
          output: {
            shape: "Sh"
          }
        },
        CreateDeployment: {
          http: {
            requestUri: "/restapis/{restapi_id}/deployments",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              stageName: {},
              stageDescription: {},
              description: {},
              cacheClusterEnabled: {
                type: "boolean"
              },
              cacheClusterSize: {},
              variables: {
                shape: "S6"
              },
              canarySettings: {
                type: "structure",
                members: {
                  percentTraffic: {
                    type: "double"
                  },
                  stageVariableOverrides: {
                    shape: "S6"
                  },
                  useStageCache: {
                    type: "boolean"
                  }
                }
              },
              tracingEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "Sn"
          }
        },
        CreateDocumentationPart: {
          http: {
            requestUri: "/restapis/{restapi_id}/documentation/parts",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "location",
              "properties"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              location: {
                shape: "Ss"
              },
              properties: {}
            }
          },
          output: {
            shape: "Sv"
          }
        },
        CreateDocumentationVersion: {
          http: {
            requestUri: "/restapis/{restapi_id}/documentation/versions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "documentationVersion"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              documentationVersion: {},
              stageName: {},
              description: {}
            }
          },
          output: {
            shape: "Sx"
          }
        },
        CreateDomainName: {
          http: {
            requestUri: "/domainnames",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {},
              certificateName: {},
              certificateBody: {},
              certificatePrivateKey: {},
              certificateChain: {},
              certificateArn: {},
              regionalCertificateName: {},
              regionalCertificateArn: {},
              endpointConfiguration: {
                shape: "Sz"
              },
              tags: {
                shape: "S6"
              },
              securityPolicy: {},
              mutualTlsAuthentication: {
                type: "structure",
                members: {
                  truststoreUri: {},
                  truststoreVersion: {}
                }
              },
              ownershipVerificationCertificateArn: {}
            }
          },
          output: {
            shape: "S14"
          }
        },
        CreateModel: {
          http: {
            requestUri: "/restapis/{restapi_id}/models",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "name",
              "contentType"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              name: {},
              description: {},
              schema: {},
              contentType: {}
            }
          },
          output: {
            shape: "S18"
          }
        },
        CreateRequestValidator: {
          http: {
            requestUri: "/restapis/{restapi_id}/requestvalidators",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              name: {},
              validateRequestBody: {
                type: "boolean"
              },
              validateRequestParameters: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S1a"
          }
        },
        CreateResource: {
          http: {
            requestUri: "/restapis/{restapi_id}/resources/{parent_id}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "parentId",
              "pathPart"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              parentId: {
                location: "uri",
                locationName: "parent_id"
              },
              pathPart: {}
            }
          },
          output: {
            shape: "S1c"
          }
        },
        CreateRestApi: {
          http: {
            requestUri: "/restapis",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              version: {},
              cloneFrom: {},
              binaryMediaTypes: {
                shape: "S9"
              },
              minimumCompressionSize: {
                type: "integer"
              },
              apiKeySource: {},
              endpointConfiguration: {
                shape: "Sz"
              },
              policy: {},
              tags: {
                shape: "S6"
              },
              disableExecuteApiEndpoint: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S1t"
          }
        },
        CreateStage: {
          http: {
            requestUri: "/restapis/{restapi_id}/stages",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "stageName",
              "deploymentId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              stageName: {},
              deploymentId: {},
              description: {},
              cacheClusterEnabled: {
                type: "boolean"
              },
              cacheClusterSize: {},
              variables: {
                shape: "S6"
              },
              documentationVersion: {},
              canarySettings: {
                shape: "S1v"
              },
              tracingEnabled: {
                type: "boolean"
              },
              tags: {
                shape: "S6"
              }
            }
          },
          output: {
            shape: "S1w"
          }
        },
        CreateUsagePlan: {
          http: {
            requestUri: "/usageplans",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              apiStages: {
                shape: "S23"
              },
              throttle: {
                shape: "S26"
              },
              quota: {
                shape: "S27"
              },
              tags: {
                shape: "S6"
              }
            }
          },
          output: {
            shape: "S29"
          }
        },
        CreateUsagePlanKey: {
          http: {
            requestUri: "/usageplans/{usageplanId}/keys",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "usagePlanId",
              "keyId",
              "keyType"
            ],
            members: {
              usagePlanId: {
                location: "uri",
                locationName: "usageplanId"
              },
              keyId: {},
              keyType: {}
            }
          },
          output: {
            shape: "S2b"
          }
        },
        CreateVpcLink: {
          http: {
            requestUri: "/vpclinks",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "name",
              "targetArns"
            ],
            members: {
              name: {},
              description: {},
              targetArns: {
                shape: "S9"
              },
              tags: {
                shape: "S6"
              }
            }
          },
          output: {
            shape: "S2d"
          }
        },
        DeleteApiKey: {
          http: {
            method: "DELETE",
            requestUri: "/apikeys/{api_Key}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "apiKey"
            ],
            members: {
              apiKey: {
                location: "uri",
                locationName: "api_Key"
              }
            }
          }
        },
        DeleteAuthorizer: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/authorizers/{authorizer_id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "authorizerId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              authorizerId: {
                location: "uri",
                locationName: "authorizer_id"
              }
            }
          }
        },
        DeleteBasePathMapping: {
          http: {
            method: "DELETE",
            requestUri: "/domainnames/{domain_name}/basepathmappings/{base_path}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "domainName",
              "basePath"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domain_name"
              },
              basePath: {
                location: "uri",
                locationName: "base_path"
              }
            }
          }
        },
        DeleteClientCertificate: {
          http: {
            method: "DELETE",
            requestUri: "/clientcertificates/{clientcertificate_id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "clientCertificateId"
            ],
            members: {
              clientCertificateId: {
                location: "uri",
                locationName: "clientcertificate_id"
              }
            }
          }
        },
        DeleteDeployment: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/deployments/{deployment_id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "deploymentId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              deploymentId: {
                location: "uri",
                locationName: "deployment_id"
              }
            }
          }
        },
        DeleteDocumentationPart: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/documentation/parts/{part_id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "documentationPartId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              documentationPartId: {
                location: "uri",
                locationName: "part_id"
              }
            }
          }
        },
        DeleteDocumentationVersion: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/documentation/versions/{doc_version}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "documentationVersion"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              documentationVersion: {
                location: "uri",
                locationName: "doc_version"
              }
            }
          }
        },
        DeleteDomainName: {
          http: {
            method: "DELETE",
            requestUri: "/domainnames/{domain_name}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domain_name"
              }
            }
          }
        },
        DeleteGatewayResponse: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/gatewayresponses/{response_type}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "responseType"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              responseType: {
                location: "uri",
                locationName: "response_type"
              }
            }
          }
        },
        DeleteIntegration: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/integration",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              }
            }
          }
        },
        DeleteIntegrationResponse: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/integration/responses/{status_code}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod",
              "statusCode"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              statusCode: {
                location: "uri",
                locationName: "status_code"
              }
            }
          }
        },
        DeleteMethod: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              }
            }
          }
        },
        DeleteMethodResponse: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/responses/{status_code}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod",
              "statusCode"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              statusCode: {
                location: "uri",
                locationName: "status_code"
              }
            }
          }
        },
        DeleteModel: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/models/{model_name}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "modelName"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              modelName: {
                location: "uri",
                locationName: "model_name"
              }
            }
          }
        },
        DeleteRequestValidator: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/requestvalidators/{requestvalidator_id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "requestValidatorId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              requestValidatorId: {
                location: "uri",
                locationName: "requestvalidator_id"
              }
            }
          }
        },
        DeleteResource: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              }
            }
          }
        },
        DeleteRestApi: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              }
            }
          }
        },
        DeleteStage: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/stages/{stage_name}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "stageName"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              stageName: {
                location: "uri",
                locationName: "stage_name"
              }
            }
          }
        },
        DeleteUsagePlan: {
          http: {
            method: "DELETE",
            requestUri: "/usageplans/{usageplanId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "usagePlanId"
            ],
            members: {
              usagePlanId: {
                location: "uri",
                locationName: "usageplanId"
              }
            }
          }
        },
        DeleteUsagePlanKey: {
          http: {
            method: "DELETE",
            requestUri: "/usageplans/{usageplanId}/keys/{keyId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "usagePlanId",
              "keyId"
            ],
            members: {
              usagePlanId: {
                location: "uri",
                locationName: "usageplanId"
              },
              keyId: {
                location: "uri",
                locationName: "keyId"
              }
            }
          }
        },
        DeleteVpcLink: {
          http: {
            method: "DELETE",
            requestUri: "/vpclinks/{vpclink_id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "vpcLinkId"
            ],
            members: {
              vpcLinkId: {
                location: "uri",
                locationName: "vpclink_id"
              }
            }
          }
        },
        FlushStageAuthorizersCache: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/stages/{stage_name}/cache/authorizers",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "stageName"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              stageName: {
                location: "uri",
                locationName: "stage_name"
              }
            }
          }
        },
        FlushStageCache: {
          http: {
            method: "DELETE",
            requestUri: "/restapis/{restapi_id}/stages/{stage_name}/cache/data",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "stageName"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              stageName: {
                location: "uri",
                locationName: "stage_name"
              }
            }
          }
        },
        GenerateClientCertificate: {
          http: {
            requestUri: "/clientcertificates",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              description: {},
              tags: {
                shape: "S6"
              }
            }
          },
          output: {
            shape: "S34"
          }
        },
        GetAccount: {
          http: {
            method: "GET",
            requestUri: "/account"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            shape: "S36"
          }
        },
        GetApiKey: {
          http: {
            method: "GET",
            requestUri: "/apikeys/{api_Key}"
          },
          input: {
            type: "structure",
            required: [
              "apiKey"
            ],
            members: {
              apiKey: {
                location: "uri",
                locationName: "api_Key"
              },
              includeValue: {
                location: "querystring",
                locationName: "includeValue",
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S7"
          }
        },
        GetApiKeys: {
          http: {
            method: "GET",
            requestUri: "/apikeys"
          },
          input: {
            type: "structure",
            members: {
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              nameQuery: {
                location: "querystring",
                locationName: "name"
              },
              customerId: {
                location: "querystring",
                locationName: "customerId"
              },
              includeValues: {
                location: "querystring",
                locationName: "includeValues",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              warnings: {
                shape: "S9"
              },
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S7"
                }
              }
            }
          }
        },
        GetAuthorizer: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/authorizers/{authorizer_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "authorizerId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              authorizerId: {
                location: "uri",
                locationName: "authorizer_id"
              }
            }
          },
          output: {
            shape: "Sf"
          }
        },
        GetAuthorizers: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/authorizers"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "Sf"
                }
              }
            }
          }
        },
        GetBasePathMapping: {
          http: {
            method: "GET",
            requestUri: "/domainnames/{domain_name}/basepathmappings/{base_path}"
          },
          input: {
            type: "structure",
            required: [
              "domainName",
              "basePath"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domain_name"
              },
              basePath: {
                location: "uri",
                locationName: "base_path"
              }
            }
          },
          output: {
            shape: "Sh"
          }
        },
        GetBasePathMappings: {
          http: {
            method: "GET",
            requestUri: "/domainnames/{domain_name}/basepathmappings"
          },
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domain_name"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "Sh"
                }
              }
            }
          }
        },
        GetClientCertificate: {
          http: {
            method: "GET",
            requestUri: "/clientcertificates/{clientcertificate_id}"
          },
          input: {
            type: "structure",
            required: [
              "clientCertificateId"
            ],
            members: {
              clientCertificateId: {
                location: "uri",
                locationName: "clientcertificate_id"
              }
            }
          },
          output: {
            shape: "S34"
          }
        },
        GetClientCertificates: {
          http: {
            method: "GET",
            requestUri: "/clientcertificates"
          },
          input: {
            type: "structure",
            members: {
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S34"
                }
              }
            }
          }
        },
        GetDeployment: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/deployments/{deployment_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "deploymentId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              deploymentId: {
                location: "uri",
                locationName: "deployment_id"
              },
              embed: {
                shape: "S9",
                location: "querystring",
                locationName: "embed"
              }
            }
          },
          output: {
            shape: "Sn"
          }
        },
        GetDeployments: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/deployments"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "Sn"
                }
              }
            }
          }
        },
        GetDocumentationPart: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/documentation/parts/{part_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "documentationPartId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              documentationPartId: {
                location: "uri",
                locationName: "part_id"
              }
            }
          },
          output: {
            shape: "Sv"
          }
        },
        GetDocumentationParts: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/documentation/parts"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              type: {
                location: "querystring",
                locationName: "type"
              },
              nameQuery: {
                location: "querystring",
                locationName: "name"
              },
              path: {
                location: "querystring",
                locationName: "path"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              locationStatus: {
                location: "querystring",
                locationName: "locationStatus"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "Sv"
                }
              }
            }
          }
        },
        GetDocumentationVersion: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/documentation/versions/{doc_version}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "documentationVersion"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              documentationVersion: {
                location: "uri",
                locationName: "doc_version"
              }
            }
          },
          output: {
            shape: "Sx"
          }
        },
        GetDocumentationVersions: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/documentation/versions"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "Sx"
                }
              }
            }
          }
        },
        GetDomainName: {
          http: {
            method: "GET",
            requestUri: "/domainnames/{domain_name}"
          },
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domain_name"
              }
            }
          },
          output: {
            shape: "S14"
          }
        },
        GetDomainNames: {
          http: {
            method: "GET",
            requestUri: "/domainnames"
          },
          input: {
            type: "structure",
            members: {
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S14"
                }
              }
            }
          }
        },
        GetExport: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/stages/{stage_name}/exports/{export_type}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "stageName",
              "exportType"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              stageName: {
                location: "uri",
                locationName: "stage_name"
              },
              exportType: {
                location: "uri",
                locationName: "export_type"
              },
              parameters: {
                shape: "S6",
                location: "querystring"
              },
              accepts: {
                location: "header",
                locationName: "Accept"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              contentDisposition: {
                location: "header",
                locationName: "Content-Disposition"
              },
              body: {
                type: "blob"
              }
            },
            payload: "body"
          }
        },
        GetGatewayResponse: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/gatewayresponses/{response_type}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "responseType"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              responseType: {
                location: "uri",
                locationName: "response_type"
              }
            }
          },
          output: {
            shape: "S48"
          }
        },
        GetGatewayResponses: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/gatewayresponses"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S48"
                }
              }
            }
          }
        },
        GetIntegration: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/integration"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              }
            }
          },
          output: {
            shape: "S1j"
          }
        },
        GetIntegrationResponse: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/integration/responses/{status_code}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod",
              "statusCode"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              statusCode: {
                location: "uri",
                locationName: "status_code"
              }
            }
          },
          output: {
            shape: "S1p"
          }
        },
        GetMethod: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              }
            }
          },
          output: {
            shape: "S1e"
          }
        },
        GetMethodResponse: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/responses/{status_code}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod",
              "statusCode"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              statusCode: {
                location: "uri",
                locationName: "status_code"
              }
            }
          },
          output: {
            shape: "S1h"
          }
        },
        GetModel: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/models/{model_name}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "modelName"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              modelName: {
                location: "uri",
                locationName: "model_name"
              },
              flatten: {
                location: "querystring",
                locationName: "flatten",
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S18"
          }
        },
        GetModelTemplate: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/models/{model_name}/default_template"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "modelName"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              modelName: {
                location: "uri",
                locationName: "model_name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              value: {}
            }
          }
        },
        GetModels: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/models"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S18"
                }
              }
            }
          }
        },
        GetRequestValidator: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/requestvalidators/{requestvalidator_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "requestValidatorId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              requestValidatorId: {
                location: "uri",
                locationName: "requestvalidator_id"
              }
            }
          },
          output: {
            shape: "S1a"
          }
        },
        GetRequestValidators: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/requestvalidators"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S1a"
                }
              }
            }
          }
        },
        GetResource: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              embed: {
                shape: "S9",
                location: "querystring",
                locationName: "embed"
              }
            }
          },
          output: {
            shape: "S1c"
          }
        },
        GetResources: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/resources"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              embed: {
                shape: "S9",
                location: "querystring",
                locationName: "embed"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S1c"
                }
              }
            }
          }
        },
        GetRestApi: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              }
            }
          },
          output: {
            shape: "S1t"
          }
        },
        GetRestApis: {
          http: {
            method: "GET",
            requestUri: "/restapis"
          },
          input: {
            type: "structure",
            members: {
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S1t"
                }
              }
            }
          }
        },
        GetSdk: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/stages/{stage_name}/sdks/{sdk_type}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "stageName",
              "sdkType"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              stageName: {
                location: "uri",
                locationName: "stage_name"
              },
              sdkType: {
                location: "uri",
                locationName: "sdk_type"
              },
              parameters: {
                shape: "S6",
                location: "querystring"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              contentDisposition: {
                location: "header",
                locationName: "Content-Disposition"
              },
              body: {
                type: "blob"
              }
            },
            payload: "body"
          }
        },
        GetSdkType: {
          http: {
            method: "GET",
            requestUri: "/sdktypes/{sdktype_id}"
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "sdktype_id"
              }
            }
          },
          output: {
            shape: "S51"
          }
        },
        GetSdkTypes: {
          http: {
            method: "GET",
            requestUri: "/sdktypes"
          },
          input: {
            type: "structure",
            members: {
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S51"
                }
              }
            }
          }
        },
        GetStage: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/stages/{stage_name}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "stageName"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              stageName: {
                location: "uri",
                locationName: "stage_name"
              }
            }
          },
          output: {
            shape: "S1w"
          }
        },
        GetStages: {
          http: {
            method: "GET",
            requestUri: "/restapis/{restapi_id}/stages"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              deploymentId: {
                location: "querystring",
                locationName: "deploymentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              item: {
                type: "list",
                member: {
                  shape: "S1w"
                }
              }
            }
          }
        },
        GetTags: {
          http: {
            method: "GET",
            requestUri: "/tags/{resource_arn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resource_arn"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S6"
              }
            }
          }
        },
        GetUsage: {
          http: {
            method: "GET",
            requestUri: "/usageplans/{usageplanId}/usage"
          },
          input: {
            type: "structure",
            required: [
              "usagePlanId",
              "startDate",
              "endDate"
            ],
            members: {
              usagePlanId: {
                location: "uri",
                locationName: "usageplanId"
              },
              keyId: {
                location: "querystring",
                locationName: "keyId"
              },
              startDate: {
                location: "querystring",
                locationName: "startDate"
              },
              endDate: {
                location: "querystring",
                locationName: "endDate"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            shape: "S5e"
          }
        },
        GetUsagePlan: {
          http: {
            method: "GET",
            requestUri: "/usageplans/{usageplanId}"
          },
          input: {
            type: "structure",
            required: [
              "usagePlanId"
            ],
            members: {
              usagePlanId: {
                location: "uri",
                locationName: "usageplanId"
              }
            }
          },
          output: {
            shape: "S29"
          }
        },
        GetUsagePlanKey: {
          http: {
            method: "GET",
            requestUri: "/usageplans/{usageplanId}/keys/{keyId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "usagePlanId",
              "keyId"
            ],
            members: {
              usagePlanId: {
                location: "uri",
                locationName: "usageplanId"
              },
              keyId: {
                location: "uri",
                locationName: "keyId"
              }
            }
          },
          output: {
            shape: "S2b"
          }
        },
        GetUsagePlanKeys: {
          http: {
            method: "GET",
            requestUri: "/usageplans/{usageplanId}/keys"
          },
          input: {
            type: "structure",
            required: [
              "usagePlanId"
            ],
            members: {
              usagePlanId: {
                location: "uri",
                locationName: "usageplanId"
              },
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              nameQuery: {
                location: "querystring",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S2b"
                }
              }
            }
          }
        },
        GetUsagePlans: {
          http: {
            method: "GET",
            requestUri: "/usageplans"
          },
          input: {
            type: "structure",
            members: {
              position: {
                location: "querystring",
                locationName: "position"
              },
              keyId: {
                location: "querystring",
                locationName: "keyId"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S29"
                }
              }
            }
          }
        },
        GetVpcLink: {
          http: {
            method: "GET",
            requestUri: "/vpclinks/{vpclink_id}"
          },
          input: {
            type: "structure",
            required: [
              "vpcLinkId"
            ],
            members: {
              vpcLinkId: {
                location: "uri",
                locationName: "vpclink_id"
              }
            }
          },
          output: {
            shape: "S2d"
          }
        },
        GetVpcLinks: {
          http: {
            method: "GET",
            requestUri: "/vpclinks"
          },
          input: {
            type: "structure",
            members: {
              position: {
                location: "querystring",
                locationName: "position"
              },
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              position: {},
              items: {
                locationName: "item",
                type: "list",
                member: {
                  shape: "S2d"
                }
              }
            }
          }
        },
        ImportApiKeys: {
          http: {
            requestUri: "/apikeys?mode=import",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "body",
              "format"
            ],
            members: {
              body: {
                type: "blob"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              failOnWarnings: {
                location: "querystring",
                locationName: "failonwarnings",
                type: "boolean"
              }
            },
            payload: "body"
          },
          output: {
            type: "structure",
            members: {
              ids: {
                shape: "S9"
              },
              warnings: {
                shape: "S9"
              }
            }
          }
        },
        ImportDocumentationParts: {
          http: {
            method: "PUT",
            requestUri: "/restapis/{restapi_id}/documentation/parts"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "body"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              mode: {
                location: "querystring",
                locationName: "mode"
              },
              failOnWarnings: {
                location: "querystring",
                locationName: "failonwarnings",
                type: "boolean"
              },
              body: {
                type: "blob"
              }
            },
            payload: "body"
          },
          output: {
            type: "structure",
            members: {
              ids: {
                shape: "S9"
              },
              warnings: {
                shape: "S9"
              }
            }
          }
        },
        ImportRestApi: {
          http: {
            requestUri: "/restapis?mode=import",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "body"
            ],
            members: {
              failOnWarnings: {
                location: "querystring",
                locationName: "failonwarnings",
                type: "boolean"
              },
              parameters: {
                shape: "S6",
                location: "querystring"
              },
              body: {
                type: "blob"
              }
            },
            payload: "body"
          },
          output: {
            shape: "S1t"
          }
        },
        PutGatewayResponse: {
          http: {
            method: "PUT",
            requestUri: "/restapis/{restapi_id}/gatewayresponses/{response_type}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "responseType"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              responseType: {
                location: "uri",
                locationName: "response_type"
              },
              statusCode: {},
              responseParameters: {
                shape: "S6"
              },
              responseTemplates: {
                shape: "S6"
              }
            }
          },
          output: {
            shape: "S48"
          }
        },
        PutIntegration: {
          http: {
            method: "PUT",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/integration",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod",
              "type"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              type: {},
              integrationHttpMethod: {
                locationName: "httpMethod"
              },
              uri: {},
              connectionType: {},
              connectionId: {},
              credentials: {},
              requestParameters: {
                shape: "S6"
              },
              requestTemplates: {
                shape: "S6"
              },
              passthroughBehavior: {},
              cacheNamespace: {},
              cacheKeyParameters: {
                shape: "S9"
              },
              contentHandling: {},
              timeoutInMillis: {
                type: "integer"
              },
              tlsConfig: {
                shape: "S1q"
              }
            }
          },
          output: {
            shape: "S1j"
          }
        },
        PutIntegrationResponse: {
          http: {
            method: "PUT",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/integration/responses/{status_code}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod",
              "statusCode"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              statusCode: {
                location: "uri",
                locationName: "status_code"
              },
              selectionPattern: {},
              responseParameters: {
                shape: "S6"
              },
              responseTemplates: {
                shape: "S6"
              },
              contentHandling: {}
            }
          },
          output: {
            shape: "S1p"
          }
        },
        PutMethod: {
          http: {
            method: "PUT",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod",
              "authorizationType"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              authorizationType: {},
              authorizerId: {},
              apiKeyRequired: {
                type: "boolean"
              },
              operationName: {},
              requestParameters: {
                shape: "S1f"
              },
              requestModels: {
                shape: "S6"
              },
              requestValidatorId: {},
              authorizationScopes: {
                shape: "S9"
              }
            }
          },
          output: {
            shape: "S1e"
          }
        },
        PutMethodResponse: {
          http: {
            method: "PUT",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/responses/{status_code}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod",
              "statusCode"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              statusCode: {
                location: "uri",
                locationName: "status_code"
              },
              responseParameters: {
                shape: "S1f"
              },
              responseModels: {
                shape: "S6"
              }
            }
          },
          output: {
            shape: "S1h"
          }
        },
        PutRestApi: {
          http: {
            method: "PUT",
            requestUri: "/restapis/{restapi_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "body"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              mode: {
                location: "querystring",
                locationName: "mode"
              },
              failOnWarnings: {
                location: "querystring",
                locationName: "failonwarnings",
                type: "boolean"
              },
              parameters: {
                shape: "S6",
                location: "querystring"
              },
              body: {
                type: "blob"
              }
            },
            payload: "body"
          },
          output: {
            shape: "S1t"
          }
        },
        TagResource: {
          http: {
            method: "PUT",
            requestUri: "/tags/{resource_arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resource_arn"
              },
              tags: {
                shape: "S6"
              }
            }
          }
        },
        TestInvokeAuthorizer: {
          http: {
            requestUri: "/restapis/{restapi_id}/authorizers/{authorizer_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "authorizerId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              authorizerId: {
                location: "uri",
                locationName: "authorizer_id"
              },
              headers: {
                shape: "S6"
              },
              multiValueHeaders: {
                shape: "S6a"
              },
              pathWithQueryString: {},
              body: {},
              stageVariables: {
                shape: "S6"
              },
              additionalContext: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              clientStatus: {
                type: "integer"
              },
              log: {},
              latency: {
                type: "long"
              },
              principalId: {},
              policy: {},
              authorization: {
                shape: "S6a"
              },
              claims: {
                shape: "S6"
              }
            }
          }
        },
        TestInvokeMethod: {
          http: {
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              pathWithQueryString: {},
              body: {},
              headers: {
                shape: "S6"
              },
              multiValueHeaders: {
                shape: "S6a"
              },
              clientCertificateId: {},
              stageVariables: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {
                type: "integer"
              },
              body: {},
              headers: {
                shape: "S6"
              },
              multiValueHeaders: {
                shape: "S6a"
              },
              log: {},
              latency: {
                type: "long"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resource_arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resource_arn"
              },
              tagKeys: {
                shape: "S9",
                location: "querystring",
                locationName: "tagKeys"
              }
            }
          }
        },
        UpdateAccount: {
          http: {
            method: "PATCH",
            requestUri: "/account"
          },
          input: {
            type: "structure",
            members: {
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S36"
          }
        },
        UpdateApiKey: {
          http: {
            method: "PATCH",
            requestUri: "/apikeys/{api_Key}"
          },
          input: {
            type: "structure",
            required: [
              "apiKey"
            ],
            members: {
              apiKey: {
                location: "uri",
                locationName: "api_Key"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S7"
          }
        },
        UpdateAuthorizer: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/authorizers/{authorizer_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "authorizerId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              authorizerId: {
                location: "uri",
                locationName: "authorizer_id"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "Sf"
          }
        },
        UpdateBasePathMapping: {
          http: {
            method: "PATCH",
            requestUri: "/domainnames/{domain_name}/basepathmappings/{base_path}"
          },
          input: {
            type: "structure",
            required: [
              "domainName",
              "basePath"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domain_name"
              },
              basePath: {
                location: "uri",
                locationName: "base_path"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "Sh"
          }
        },
        UpdateClientCertificate: {
          http: {
            method: "PATCH",
            requestUri: "/clientcertificates/{clientcertificate_id}"
          },
          input: {
            type: "structure",
            required: [
              "clientCertificateId"
            ],
            members: {
              clientCertificateId: {
                location: "uri",
                locationName: "clientcertificate_id"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S34"
          }
        },
        UpdateDeployment: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/deployments/{deployment_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "deploymentId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              deploymentId: {
                location: "uri",
                locationName: "deployment_id"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "Sn"
          }
        },
        UpdateDocumentationPart: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/documentation/parts/{part_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "documentationPartId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              documentationPartId: {
                location: "uri",
                locationName: "part_id"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "Sv"
          }
        },
        UpdateDocumentationVersion: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/documentation/versions/{doc_version}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "documentationVersion"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              documentationVersion: {
                location: "uri",
                locationName: "doc_version"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "Sx"
          }
        },
        UpdateDomainName: {
          http: {
            method: "PATCH",
            requestUri: "/domainnames/{domain_name}"
          },
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {
                location: "uri",
                locationName: "domain_name"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S14"
          }
        },
        UpdateGatewayResponse: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/gatewayresponses/{response_type}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "responseType"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              responseType: {
                location: "uri",
                locationName: "response_type"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S48"
          }
        },
        UpdateIntegration: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/integration"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S1j"
          }
        },
        UpdateIntegrationResponse: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/integration/responses/{status_code}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod",
              "statusCode"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              statusCode: {
                location: "uri",
                locationName: "status_code"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S1p"
          }
        },
        UpdateMethod: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S1e"
          }
        },
        UpdateMethodResponse: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}/methods/{http_method}/responses/{status_code}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId",
              "httpMethod",
              "statusCode"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              httpMethod: {
                location: "uri",
                locationName: "http_method"
              },
              statusCode: {
                location: "uri",
                locationName: "status_code"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S1h"
          }
        },
        UpdateModel: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/models/{model_name}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "modelName"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              modelName: {
                location: "uri",
                locationName: "model_name"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S18"
          }
        },
        UpdateRequestValidator: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/requestvalidators/{requestvalidator_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "requestValidatorId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              requestValidatorId: {
                location: "uri",
                locationName: "requestvalidator_id"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S1a"
          }
        },
        UpdateResource: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/resources/{resource_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "resourceId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              resourceId: {
                location: "uri",
                locationName: "resource_id"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S1c"
          }
        },
        UpdateRestApi: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S1t"
          }
        },
        UpdateStage: {
          http: {
            method: "PATCH",
            requestUri: "/restapis/{restapi_id}/stages/{stage_name}"
          },
          input: {
            type: "structure",
            required: [
              "restApiId",
              "stageName"
            ],
            members: {
              restApiId: {
                location: "uri",
                locationName: "restapi_id"
              },
              stageName: {
                location: "uri",
                locationName: "stage_name"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S1w"
          }
        },
        UpdateUsage: {
          http: {
            method: "PATCH",
            requestUri: "/usageplans/{usageplanId}/keys/{keyId}/usage"
          },
          input: {
            type: "structure",
            required: [
              "usagePlanId",
              "keyId"
            ],
            members: {
              usagePlanId: {
                location: "uri",
                locationName: "usageplanId"
              },
              keyId: {
                location: "uri",
                locationName: "keyId"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S5e"
          }
        },
        UpdateUsagePlan: {
          http: {
            method: "PATCH",
            requestUri: "/usageplans/{usageplanId}"
          },
          input: {
            type: "structure",
            required: [
              "usagePlanId"
            ],
            members: {
              usagePlanId: {
                location: "uri",
                locationName: "usageplanId"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S29"
          }
        },
        UpdateVpcLink: {
          http: {
            method: "PATCH",
            requestUri: "/vpclinks/{vpclink_id}"
          },
          input: {
            type: "structure",
            required: [
              "vpcLinkId"
            ],
            members: {
              vpcLinkId: {
                location: "uri",
                locationName: "vpclink_id"
              },
              patchOperations: {
                shape: "S6g"
              }
            }
          },
          output: {
            shape: "S2d"
          }
        }
      },
      shapes: {
        S6: {
          type: "map",
          key: {},
          value: {}
        },
        S7: {
          type: "structure",
          members: {
            id: {},
            value: {},
            name: {},
            customerId: {},
            description: {},
            enabled: {
              type: "boolean"
            },
            createdDate: {
              type: "timestamp"
            },
            lastUpdatedDate: {
              type: "timestamp"
            },
            stageKeys: {
              shape: "S9"
            },
            tags: {
              shape: "S6"
            }
          }
        },
        S9: {
          type: "list",
          member: {}
        },
        Sc: {
          type: "list",
          member: {}
        },
        Sf: {
          type: "structure",
          members: {
            id: {},
            name: {},
            type: {},
            providerARNs: {
              shape: "Sc"
            },
            authType: {},
            authorizerUri: {},
            authorizerCredentials: {},
            identitySource: {},
            identityValidationExpression: {},
            authorizerResultTtlInSeconds: {
              type: "integer"
            }
          }
        },
        Sh: {
          type: "structure",
          members: {
            basePath: {},
            restApiId: {},
            stage: {}
          }
        },
        Sn: {
          type: "structure",
          members: {
            id: {},
            description: {},
            createdDate: {
              type: "timestamp"
            },
            apiSummary: {
              type: "map",
              key: {},
              value: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    authorizationType: {},
                    apiKeyRequired: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        Ss: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            path: {},
            method: {},
            statusCode: {},
            name: {}
          }
        },
        Sv: {
          type: "structure",
          members: {
            id: {},
            location: {
              shape: "Ss"
            },
            properties: {}
          }
        },
        Sx: {
          type: "structure",
          members: {
            version: {},
            createdDate: {
              type: "timestamp"
            },
            description: {}
          }
        },
        Sz: {
          type: "structure",
          members: {
            types: {
              type: "list",
              member: {}
            },
            vpcEndpointIds: {
              shape: "S9"
            }
          }
        },
        S14: {
          type: "structure",
          members: {
            domainName: {},
            certificateName: {},
            certificateArn: {},
            certificateUploadDate: {
              type: "timestamp"
            },
            regionalDomainName: {},
            regionalHostedZoneId: {},
            regionalCertificateName: {},
            regionalCertificateArn: {},
            distributionDomainName: {},
            distributionHostedZoneId: {},
            endpointConfiguration: {
              shape: "Sz"
            },
            domainNameStatus: {},
            domainNameStatusMessage: {},
            securityPolicy: {},
            tags: {
              shape: "S6"
            },
            mutualTlsAuthentication: {
              type: "structure",
              members: {
                truststoreUri: {},
                truststoreVersion: {},
                truststoreWarnings: {
                  shape: "S9"
                }
              }
            },
            ownershipVerificationCertificateArn: {}
          }
        },
        S18: {
          type: "structure",
          members: {
            id: {},
            name: {},
            description: {},
            schema: {},
            contentType: {}
          }
        },
        S1a: {
          type: "structure",
          members: {
            id: {},
            name: {},
            validateRequestBody: {
              type: "boolean"
            },
            validateRequestParameters: {
              type: "boolean"
            }
          }
        },
        S1c: {
          type: "structure",
          members: {
            id: {},
            parentId: {},
            pathPart: {},
            path: {},
            resourceMethods: {
              type: "map",
              key: {},
              value: {
                shape: "S1e"
              }
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            httpMethod: {},
            authorizationType: {},
            authorizerId: {},
            apiKeyRequired: {
              type: "boolean"
            },
            requestValidatorId: {},
            operationName: {},
            requestParameters: {
              shape: "S1f"
            },
            requestModels: {
              shape: "S6"
            },
            methodResponses: {
              type: "map",
              key: {},
              value: {
                shape: "S1h"
              }
            },
            methodIntegration: {
              shape: "S1j"
            },
            authorizationScopes: {
              shape: "S9"
            }
          }
        },
        S1f: {
          type: "map",
          key: {},
          value: {
            type: "boolean"
          }
        },
        S1h: {
          type: "structure",
          members: {
            statusCode: {},
            responseParameters: {
              shape: "S1f"
            },
            responseModels: {
              shape: "S6"
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            type: {},
            httpMethod: {},
            uri: {},
            connectionType: {},
            connectionId: {},
            credentials: {},
            requestParameters: {
              shape: "S6"
            },
            requestTemplates: {
              shape: "S6"
            },
            passthroughBehavior: {},
            contentHandling: {},
            timeoutInMillis: {
              type: "integer"
            },
            cacheNamespace: {},
            cacheKeyParameters: {
              shape: "S9"
            },
            integrationResponses: {
              type: "map",
              key: {},
              value: {
                shape: "S1p"
              }
            },
            tlsConfig: {
              shape: "S1q"
            }
          }
        },
        S1p: {
          type: "structure",
          members: {
            statusCode: {},
            selectionPattern: {},
            responseParameters: {
              shape: "S6"
            },
            responseTemplates: {
              shape: "S6"
            },
            contentHandling: {}
          }
        },
        S1q: {
          type: "structure",
          members: {
            insecureSkipVerification: {
              type: "boolean"
            }
          }
        },
        S1t: {
          type: "structure",
          members: {
            id: {},
            name: {},
            description: {},
            createdDate: {
              type: "timestamp"
            },
            version: {},
            warnings: {
              shape: "S9"
            },
            binaryMediaTypes: {
              shape: "S9"
            },
            minimumCompressionSize: {
              type: "integer"
            },
            apiKeySource: {},
            endpointConfiguration: {
              shape: "Sz"
            },
            policy: {},
            tags: {
              shape: "S6"
            },
            disableExecuteApiEndpoint: {
              type: "boolean"
            }
          }
        },
        S1v: {
          type: "structure",
          members: {
            percentTraffic: {
              type: "double"
            },
            deploymentId: {},
            stageVariableOverrides: {
              shape: "S6"
            },
            useStageCache: {
              type: "boolean"
            }
          }
        },
        S1w: {
          type: "structure",
          members: {
            deploymentId: {},
            clientCertificateId: {},
            stageName: {},
            description: {},
            cacheClusterEnabled: {
              type: "boolean"
            },
            cacheClusterSize: {},
            cacheClusterStatus: {},
            methodSettings: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  metricsEnabled: {
                    type: "boolean"
                  },
                  loggingLevel: {},
                  dataTraceEnabled: {
                    type: "boolean"
                  },
                  throttlingBurstLimit: {
                    type: "integer"
                  },
                  throttlingRateLimit: {
                    type: "double"
                  },
                  cachingEnabled: {
                    type: "boolean"
                  },
                  cacheTtlInSeconds: {
                    type: "integer"
                  },
                  cacheDataEncrypted: {
                    type: "boolean"
                  },
                  requireAuthorizationForCacheControl: {
                    type: "boolean"
                  },
                  unauthorizedCacheControlHeaderStrategy: {}
                }
              }
            },
            variables: {
              shape: "S6"
            },
            documentationVersion: {},
            accessLogSettings: {
              type: "structure",
              members: {
                format: {},
                destinationArn: {}
              }
            },
            canarySettings: {
              shape: "S1v"
            },
            tracingEnabled: {
              type: "boolean"
            },
            webAclArn: {},
            tags: {
              shape: "S6"
            },
            createdDate: {
              type: "timestamp"
            },
            lastUpdatedDate: {
              type: "timestamp"
            }
          }
        },
        S23: {
          type: "list",
          member: {
            type: "structure",
            members: {
              apiId: {},
              stage: {},
              throttle: {
                type: "map",
                key: {},
                value: {
                  shape: "S26"
                }
              }
            }
          }
        },
        S26: {
          type: "structure",
          members: {
            burstLimit: {
              type: "integer"
            },
            rateLimit: {
              type: "double"
            }
          }
        },
        S27: {
          type: "structure",
          members: {
            limit: {
              type: "integer"
            },
            offset: {
              type: "integer"
            },
            period: {}
          }
        },
        S29: {
          type: "structure",
          members: {
            id: {},
            name: {},
            description: {},
            apiStages: {
              shape: "S23"
            },
            throttle: {
              shape: "S26"
            },
            quota: {
              shape: "S27"
            },
            productCode: {},
            tags: {
              shape: "S6"
            }
          }
        },
        S2b: {
          type: "structure",
          members: {
            id: {},
            type: {},
            value: {},
            name: {}
          }
        },
        S2d: {
          type: "structure",
          members: {
            id: {},
            name: {},
            description: {},
            targetArns: {
              shape: "S9"
            },
            status: {},
            statusMessage: {},
            tags: {
              shape: "S6"
            }
          }
        },
        S34: {
          type: "structure",
          members: {
            clientCertificateId: {},
            description: {},
            pemEncodedCertificate: {},
            createdDate: {
              type: "timestamp"
            },
            expirationDate: {
              type: "timestamp"
            },
            tags: {
              shape: "S6"
            }
          }
        },
        S36: {
          type: "structure",
          members: {
            cloudwatchRoleArn: {},
            throttleSettings: {
              shape: "S26"
            },
            features: {
              shape: "S9"
            },
            apiKeyVersion: {}
          }
        },
        S48: {
          type: "structure",
          members: {
            responseType: {},
            statusCode: {},
            responseParameters: {
              shape: "S6"
            },
            responseTemplates: {
              shape: "S6"
            },
            defaultResponse: {
              type: "boolean"
            }
          }
        },
        S51: {
          type: "structure",
          members: {
            id: {},
            friendlyName: {},
            description: {},
            configurationProperties: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  name: {},
                  friendlyName: {},
                  description: {},
                  required: {
                    type: "boolean"
                  },
                  defaultValue: {}
                }
              }
            }
          }
        },
        S5e: {
          type: "structure",
          members: {
            usagePlanId: {},
            startDate: {},
            endDate: {},
            position: {},
            items: {
              locationName: "values",
              type: "map",
              key: {},
              value: {
                type: "list",
                member: {
                  type: "list",
                  member: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S6a: {
          type: "map",
          key: {},
          value: {
            shape: "S9"
          }
        },
        S6g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              op: {},
              path: {},
              value: {},
              from: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/apigateway-2015-07-09.paginators.json
var require_apigateway_2015_07_09_paginators = __commonJS({
  "node_modules/aws-sdk/apis/apigateway-2015-07-09.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetApiKeys: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetBasePathMappings: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetClientCertificates: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetDeployments: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetDomainNames: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetModels: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetResources: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetRestApis: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetUsage: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetUsagePlanKeys: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetUsagePlans: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        },
        GetVpcLinks: {
          input_token: "position",
          limit_key: "limit",
          output_token: "position",
          result_key: "items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/apigateway.js
var require_apigateway2 = __commonJS({
  "node_modules/aws-sdk/clients/apigateway.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["apigateway"] = {};
    AWS3.APIGateway = Service.defineService("apigateway", ["2015-07-09"]);
    require_apigateway();
    Object.defineProperty(apiLoader.services["apigateway"], "2015-07-09", {
      get: function get() {
        var model = require_apigateway_2015_07_09_min();
        model.paginators = require_apigateway_2015_07_09_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.APIGateway;
  }
});

// node_modules/aws-sdk/apis/application-autoscaling-2016-02-06.min.json
var require_application_autoscaling_2016_02_06_min = __commonJS({
  "node_modules/aws-sdk/apis/application-autoscaling-2016-02-06.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-02-06",
        endpointPrefix: "application-autoscaling",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Application Auto Scaling",
        serviceId: "Application Auto Scaling",
        signatureVersion: "v4",
        signingName: "application-autoscaling",
        targetPrefix: "AnyScaleFrontendService",
        uid: "application-autoscaling-2016-02-06"
      },
      operations: {
        DeleteScalingPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyName",
              "ServiceNamespace",
              "ResourceId",
              "ScalableDimension"
            ],
            members: {
              PolicyName: {},
              ServiceNamespace: {},
              ResourceId: {},
              ScalableDimension: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteScheduledAction: {
          input: {
            type: "structure",
            required: [
              "ServiceNamespace",
              "ScheduledActionName",
              "ResourceId",
              "ScalableDimension"
            ],
            members: {
              ServiceNamespace: {},
              ScheduledActionName: {},
              ResourceId: {},
              ScalableDimension: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterScalableTarget: {
          input: {
            type: "structure",
            required: [
              "ServiceNamespace",
              "ResourceId",
              "ScalableDimension"
            ],
            members: {
              ServiceNamespace: {},
              ResourceId: {},
              ScalableDimension: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeScalableTargets: {
          input: {
            type: "structure",
            required: [
              "ServiceNamespace"
            ],
            members: {
              ServiceNamespace: {},
              ResourceIds: {
                shape: "Sb"
              },
              ScalableDimension: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ScalableTargets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ServiceNamespace",
                    "ResourceId",
                    "ScalableDimension",
                    "MinCapacity",
                    "MaxCapacity",
                    "RoleARN",
                    "CreationTime"
                  ],
                  members: {
                    ServiceNamespace: {},
                    ResourceId: {},
                    ScalableDimension: {},
                    MinCapacity: {
                      type: "integer"
                    },
                    MaxCapacity: {
                      type: "integer"
                    },
                    RoleARN: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    SuspendedState: {
                      shape: "Sj"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeScalingActivities: {
          input: {
            type: "structure",
            required: [
              "ServiceNamespace"
            ],
            members: {
              ServiceNamespace: {},
              ResourceId: {},
              ScalableDimension: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ScalingActivities: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ActivityId",
                    "ServiceNamespace",
                    "ResourceId",
                    "ScalableDimension",
                    "Description",
                    "Cause",
                    "StartTime",
                    "StatusCode"
                  ],
                  members: {
                    ActivityId: {},
                    ServiceNamespace: {},
                    ResourceId: {},
                    ScalableDimension: {},
                    Description: {},
                    Cause: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    StatusCode: {},
                    StatusMessage: {},
                    Details: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeScalingPolicies: {
          input: {
            type: "structure",
            required: [
              "ServiceNamespace"
            ],
            members: {
              PolicyNames: {
                shape: "Sb"
              },
              ServiceNamespace: {},
              ResourceId: {},
              ScalableDimension: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ScalingPolicies: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "PolicyARN",
                    "PolicyName",
                    "ServiceNamespace",
                    "ResourceId",
                    "ScalableDimension",
                    "PolicyType",
                    "CreationTime"
                  ],
                  members: {
                    PolicyARN: {},
                    PolicyName: {},
                    ServiceNamespace: {},
                    ResourceId: {},
                    ScalableDimension: {},
                    PolicyType: {},
                    StepScalingPolicyConfiguration: {
                      shape: "Sx"
                    },
                    TargetTrackingScalingPolicyConfiguration: {
                      shape: "S16"
                    },
                    Alarms: {
                      shape: "S1k"
                    },
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeScheduledActions: {
          input: {
            type: "structure",
            required: [
              "ServiceNamespace"
            ],
            members: {
              ScheduledActionNames: {
                shape: "Sb"
              },
              ServiceNamespace: {},
              ResourceId: {},
              ScalableDimension: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ScheduledActions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ScheduledActionName",
                    "ScheduledActionARN",
                    "ServiceNamespace",
                    "Schedule",
                    "ResourceId",
                    "CreationTime"
                  ],
                  members: {
                    ScheduledActionName: {},
                    ScheduledActionARN: {},
                    ServiceNamespace: {},
                    Schedule: {},
                    Timezone: {},
                    ResourceId: {},
                    ScalableDimension: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    ScalableTargetAction: {
                      shape: "S1r"
                    },
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        PutScalingPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyName",
              "ServiceNamespace",
              "ResourceId",
              "ScalableDimension"
            ],
            members: {
              PolicyName: {},
              ServiceNamespace: {},
              ResourceId: {},
              ScalableDimension: {},
              PolicyType: {},
              StepScalingPolicyConfiguration: {
                shape: "Sx"
              },
              TargetTrackingScalingPolicyConfiguration: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "PolicyARN"
            ],
            members: {
              PolicyARN: {},
              Alarms: {
                shape: "S1k"
              }
            }
          }
        },
        PutScheduledAction: {
          input: {
            type: "structure",
            required: [
              "ServiceNamespace",
              "ScheduledActionName",
              "ResourceId",
              "ScalableDimension"
            ],
            members: {
              ServiceNamespace: {},
              Schedule: {},
              Timezone: {},
              ScheduledActionName: {},
              ResourceId: {},
              ScalableDimension: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              ScalableTargetAction: {
                shape: "S1r"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RegisterScalableTarget: {
          input: {
            type: "structure",
            required: [
              "ServiceNamespace",
              "ResourceId",
              "ScalableDimension"
            ],
            members: {
              ServiceNamespace: {},
              ResourceId: {},
              ScalableDimension: {},
              MinCapacity: {
                type: "integer"
              },
              MaxCapacity: {
                type: "integer"
              },
              RoleARN: {},
              SuspendedState: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sb: {
          type: "list",
          member: {}
        },
        Sj: {
          type: "structure",
          members: {
            DynamicScalingInSuspended: {
              type: "boolean"
            },
            DynamicScalingOutSuspended: {
              type: "boolean"
            },
            ScheduledScalingSuspended: {
              type: "boolean"
            }
          }
        },
        Sx: {
          type: "structure",
          members: {
            AdjustmentType: {},
            StepAdjustments: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ScalingAdjustment"
                ],
                members: {
                  MetricIntervalLowerBound: {
                    type: "double"
                  },
                  MetricIntervalUpperBound: {
                    type: "double"
                  },
                  ScalingAdjustment: {
                    type: "integer"
                  }
                }
              }
            },
            MinAdjustmentMagnitude: {
              type: "integer"
            },
            Cooldown: {
              type: "integer"
            },
            MetricAggregationType: {}
          }
        },
        S16: {
          type: "structure",
          required: [
            "TargetValue"
          ],
          members: {
            TargetValue: {
              type: "double"
            },
            PredefinedMetricSpecification: {
              type: "structure",
              required: [
                "PredefinedMetricType"
              ],
              members: {
                PredefinedMetricType: {},
                ResourceLabel: {}
              }
            },
            CustomizedMetricSpecification: {
              type: "structure",
              required: [
                "MetricName",
                "Namespace",
                "Statistic"
              ],
              members: {
                MetricName: {},
                Namespace: {},
                Dimensions: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Name",
                      "Value"
                    ],
                    members: {
                      Name: {},
                      Value: {}
                    }
                  }
                },
                Statistic: {},
                Unit: {}
              }
            },
            ScaleOutCooldown: {
              type: "integer"
            },
            ScaleInCooldown: {
              type: "integer"
            },
            DisableScaleIn: {
              type: "boolean"
            }
          }
        },
        S1k: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AlarmName",
              "AlarmARN"
            ],
            members: {
              AlarmName: {},
              AlarmARN: {}
            }
          }
        },
        S1r: {
          type: "structure",
          members: {
            MinCapacity: {
              type: "integer"
            },
            MaxCapacity: {
              type: "integer"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/application-autoscaling-2016-02-06.paginators.json
var require_application_autoscaling_2016_02_06_paginators = __commonJS({
  "node_modules/aws-sdk/apis/application-autoscaling-2016-02-06.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeScalableTargets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ScalableTargets"
        },
        DescribeScalingActivities: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ScalingActivities"
        },
        DescribeScalingPolicies: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ScalingPolicies"
        },
        DescribeScheduledActions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ScheduledActions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/applicationautoscaling.js
var require_applicationautoscaling = __commonJS({
  "node_modules/aws-sdk/clients/applicationautoscaling.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["applicationautoscaling"] = {};
    AWS3.ApplicationAutoScaling = Service.defineService("applicationautoscaling", ["2016-02-06"]);
    Object.defineProperty(apiLoader.services["applicationautoscaling"], "2016-02-06", {
      get: function get() {
        var model = require_application_autoscaling_2016_02_06_min();
        model.paginators = require_application_autoscaling_2016_02_06_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ApplicationAutoScaling;
  }
});

// node_modules/aws-sdk/apis/appstream-2016-12-01.min.json
var require_appstream_2016_12_01_min = __commonJS({
  "node_modules/aws-sdk/apis/appstream-2016-12-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-12-01",
        endpointPrefix: "appstream2",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon AppStream",
        serviceId: "AppStream",
        signatureVersion: "v4",
        signingName: "appstream",
        targetPrefix: "PhotonAdminProxyService",
        uid: "appstream-2016-12-01"
      },
      operations: {
        AssociateFleet: {
          input: {
            type: "structure",
            required: [
              "FleetName",
              "StackName"
            ],
            members: {
              FleetName: {},
              StackName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        BatchAssociateUserStack: {
          input: {
            type: "structure",
            required: [
              "UserStackAssociations"
            ],
            members: {
              UserStackAssociations: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                shape: "Sb"
              }
            }
          }
        },
        BatchDisassociateUserStack: {
          input: {
            type: "structure",
            required: [
              "UserStackAssociations"
            ],
            members: {
              UserStackAssociations: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                shape: "Sb"
              }
            }
          }
        },
        CopyImage: {
          input: {
            type: "structure",
            required: [
              "SourceImageName",
              "DestinationImageName",
              "DestinationRegion"
            ],
            members: {
              SourceImageName: {},
              DestinationImageName: {},
              DestinationRegion: {},
              DestinationImageDescription: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DestinationImageName: {}
            }
          }
        },
        CreateDirectoryConfig: {
          input: {
            type: "structure",
            required: [
              "DirectoryName",
              "OrganizationalUnitDistinguishedNames"
            ],
            members: {
              DirectoryName: {},
              OrganizationalUnitDistinguishedNames: {
                shape: "Sn"
              },
              ServiceAccountCredentials: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryConfig: {
                shape: "St"
              }
            }
          }
        },
        CreateFleet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "InstanceType",
              "ComputeCapacity"
            ],
            members: {
              Name: {},
              ImageName: {},
              ImageArn: {},
              InstanceType: {},
              FleetType: {},
              ComputeCapacity: {
                shape: "Sy"
              },
              VpcConfig: {
                shape: "S10"
              },
              MaxUserDurationInSeconds: {
                type: "integer"
              },
              DisconnectTimeoutInSeconds: {
                type: "integer"
              },
              Description: {},
              DisplayName: {},
              EnableDefaultInternetAccess: {
                type: "boolean"
              },
              DomainJoinInfo: {
                shape: "S15"
              },
              Tags: {
                shape: "S16"
              },
              IdleDisconnectTimeoutInSeconds: {
                type: "integer"
              },
              IamRoleArn: {},
              StreamView: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Fleet: {
                shape: "S1b"
              }
            }
          }
        },
        CreateImageBuilder: {
          input: {
            type: "structure",
            required: [
              "Name",
              "InstanceType"
            ],
            members: {
              Name: {},
              ImageName: {},
              ImageArn: {},
              InstanceType: {},
              Description: {},
              DisplayName: {},
              VpcConfig: {
                shape: "S10"
              },
              IamRoleArn: {},
              EnableDefaultInternetAccess: {
                type: "boolean"
              },
              DomainJoinInfo: {
                shape: "S15"
              },
              AppstreamAgentVersion: {},
              Tags: {
                shape: "S16"
              },
              AccessEndpoints: {
                shape: "S1j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageBuilder: {
                shape: "S1n"
              }
            }
          }
        },
        CreateImageBuilderStreamingURL: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Validity: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingURL: {},
              Expires: {
                type: "timestamp"
              }
            }
          }
        },
        CreateStack: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              DisplayName: {},
              StorageConnectors: {
                shape: "S1z"
              },
              RedirectURL: {},
              FeedbackURL: {},
              UserSettings: {
                shape: "S27"
              },
              ApplicationSettings: {
                shape: "S2b"
              },
              Tags: {
                shape: "S16"
              },
              AccessEndpoints: {
                shape: "S1j"
              },
              EmbedHostDomains: {
                shape: "S2d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Stack: {
                shape: "S2g"
              }
            }
          }
        },
        CreateStreamingURL: {
          input: {
            type: "structure",
            required: [
              "StackName",
              "FleetName",
              "UserId"
            ],
            members: {
              StackName: {},
              FleetName: {},
              UserId: {},
              ApplicationId: {},
              Validity: {
                type: "long"
              },
              SessionContext: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingURL: {},
              Expires: {
                type: "timestamp"
              }
            }
          }
        },
        CreateUpdatedImage: {
          input: {
            type: "structure",
            required: [
              "existingImageName",
              "newImageName"
            ],
            members: {
              existingImageName: {},
              newImageName: {},
              newImageDescription: {},
              newImageDisplayName: {},
              newImageTags: {
                shape: "S16"
              },
              dryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              image: {
                shape: "S2q"
              },
              canUpdateImage: {
                type: "boolean"
              }
            }
          }
        },
        CreateUsageReportSubscription: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              S3BucketName: {},
              Schedule: {}
            }
          }
        },
        CreateUser: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "AuthenticationType"
            ],
            members: {
              UserName: {
                shape: "S7"
              },
              MessageAction: {},
              FirstName: {
                shape: "S34"
              },
              LastName: {
                shape: "S34"
              },
              AuthenticationType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDirectoryConfig: {
          input: {
            type: "structure",
            required: [
              "DirectoryName"
            ],
            members: {
              DirectoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteFleet: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteImage: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Image: {
                shape: "S2q"
              }
            }
          }
        },
        DeleteImageBuilder: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImageBuilder: {
                shape: "S1n"
              }
            }
          }
        },
        DeleteImagePermissions: {
          input: {
            type: "structure",
            required: [
              "Name",
              "SharedAccountId"
            ],
            members: {
              Name: {},
              SharedAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteStack: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteUsageReportSubscription: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteUser: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "AuthenticationType"
            ],
            members: {
              UserName: {
                shape: "S7"
              },
              AuthenticationType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeDirectoryConfigs: {
          input: {
            type: "structure",
            members: {
              DirectoryNames: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryConfigs: {
                type: "list",
                member: {
                  shape: "St"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeFleets: {
          input: {
            type: "structure",
            members: {
              Names: {
                shape: "S3s"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Fleets: {
                type: "list",
                member: {
                  shape: "S1b"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeImageBuilders: {
          input: {
            type: "structure",
            members: {
              Names: {
                shape: "S3s"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImageBuilders: {
                type: "list",
                member: {
                  shape: "S1n"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeImagePermissions: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              MaxResults: {
                type: "integer"
              },
              SharedAwsAccountIds: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              SharedImagePermissionsList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "sharedAccountId",
                    "imagePermissions"
                  ],
                  members: {
                    sharedAccountId: {},
                    imagePermissions: {
                      shape: "S2y"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeImages: {
          input: {
            type: "structure",
            members: {
              Names: {
                shape: "S3s"
              },
              Arns: {
                type: "list",
                member: {}
              },
              Type: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Images: {
                type: "list",
                member: {
                  shape: "S2q"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeSessions: {
          input: {
            type: "structure",
            required: [
              "StackName",
              "FleetName"
            ],
            members: {
              StackName: {},
              FleetName: {},
              UserId: {},
              NextToken: {},
              Limit: {
                type: "integer"
              },
              AuthenticationType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Sessions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id",
                    "UserId",
                    "StackName",
                    "FleetName",
                    "State"
                  ],
                  members: {
                    Id: {},
                    UserId: {},
                    StackName: {},
                    FleetName: {},
                    State: {},
                    ConnectionState: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    MaxExpirationTime: {
                      type: "timestamp"
                    },
                    AuthenticationType: {},
                    NetworkAccessConfiguration: {
                      shape: "S1s"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeStacks: {
          input: {
            type: "structure",
            members: {
              Names: {
                shape: "S3s"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Stacks: {
                type: "list",
                member: {
                  shape: "S2g"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeUsageReportSubscriptions: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UsageReportSubscriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    S3BucketName: {},
                    Schedule: {},
                    LastGeneratedReportDate: {
                      type: "timestamp"
                    },
                    SubscriptionErrors: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ErrorCode: {},
                          ErrorMessage: {}
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeUserStackAssociations: {
          input: {
            type: "structure",
            members: {
              StackName: {},
              UserName: {
                shape: "S7"
              },
              AuthenticationType: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserStackAssociations: {
                shape: "S5"
              },
              NextToken: {}
            }
          }
        },
        DescribeUsers: {
          input: {
            type: "structure",
            required: [
              "AuthenticationType"
            ],
            members: {
              AuthenticationType: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Users: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AuthenticationType"
                  ],
                  members: {
                    Arn: {},
                    UserName: {
                      shape: "S7"
                    },
                    Enabled: {
                      type: "boolean"
                    },
                    Status: {},
                    FirstName: {
                      shape: "S34"
                    },
                    LastName: {
                      shape: "S34"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    },
                    AuthenticationType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DisableUser: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "AuthenticationType"
            ],
            members: {
              UserName: {
                shape: "S7"
              },
              AuthenticationType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateFleet: {
          input: {
            type: "structure",
            required: [
              "FleetName",
              "StackName"
            ],
            members: {
              FleetName: {},
              StackName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableUser: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "AuthenticationType"
            ],
            members: {
              UserName: {
                shape: "S7"
              },
              AuthenticationType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ExpireSession: {
          input: {
            type: "structure",
            required: [
              "SessionId"
            ],
            members: {
              SessionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListAssociatedFleets: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Names: {
                shape: "S3s"
              },
              NextToken: {}
            }
          }
        },
        ListAssociatedStacks: {
          input: {
            type: "structure",
            required: [
              "FleetName"
            ],
            members: {
              FleetName: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Names: {
                shape: "S3s"
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S16"
              }
            }
          }
        },
        StartFleet: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartImageBuilder: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              AppstreamAgentVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImageBuilder: {
                shape: "S1n"
              }
            }
          }
        },
        StopFleet: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopImageBuilder: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImageBuilder: {
                shape: "S1n"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDirectoryConfig: {
          input: {
            type: "structure",
            required: [
              "DirectoryName"
            ],
            members: {
              DirectoryName: {},
              OrganizationalUnitDistinguishedNames: {
                shape: "Sn"
              },
              ServiceAccountCredentials: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryConfig: {
                shape: "St"
              }
            }
          }
        },
        UpdateFleet: {
          input: {
            type: "structure",
            members: {
              ImageName: {},
              ImageArn: {},
              Name: {},
              InstanceType: {},
              ComputeCapacity: {
                shape: "Sy"
              },
              VpcConfig: {
                shape: "S10"
              },
              MaxUserDurationInSeconds: {
                type: "integer"
              },
              DisconnectTimeoutInSeconds: {
                type: "integer"
              },
              DeleteVpcConfig: {
                deprecated: true,
                type: "boolean"
              },
              Description: {},
              DisplayName: {},
              EnableDefaultInternetAccess: {
                type: "boolean"
              },
              DomainJoinInfo: {
                shape: "S15"
              },
              IdleDisconnectTimeoutInSeconds: {
                type: "integer"
              },
              AttributesToDelete: {
                type: "list",
                member: {}
              },
              IamRoleArn: {},
              StreamView: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Fleet: {
                shape: "S1b"
              }
            }
          }
        },
        UpdateImagePermissions: {
          input: {
            type: "structure",
            required: [
              "Name",
              "SharedAccountId",
              "ImagePermissions"
            ],
            members: {
              Name: {},
              SharedAccountId: {},
              ImagePermissions: {
                shape: "S2y"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateStack: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              DisplayName: {},
              Description: {},
              Name: {},
              StorageConnectors: {
                shape: "S1z"
              },
              DeleteStorageConnectors: {
                deprecated: true,
                type: "boolean"
              },
              RedirectURL: {},
              FeedbackURL: {},
              AttributesToDelete: {
                type: "list",
                member: {}
              },
              UserSettings: {
                shape: "S27"
              },
              ApplicationSettings: {
                shape: "S2b"
              },
              AccessEndpoints: {
                shape: "S1j"
              },
              EmbedHostDomains: {
                shape: "S2d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Stack: {
                shape: "S2g"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {
            shape: "S6"
          }
        },
        S6: {
          type: "structure",
          required: [
            "StackName",
            "UserName",
            "AuthenticationType"
          ],
          members: {
            StackName: {},
            UserName: {
              shape: "S7"
            },
            AuthenticationType: {},
            SendEmailNotification: {
              type: "boolean"
            }
          }
        },
        S7: {
          type: "string",
          sensitive: true
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            members: {
              UserStackAssociation: {
                shape: "S6"
              },
              ErrorCode: {},
              ErrorMessage: {}
            }
          }
        },
        Sn: {
          type: "list",
          member: {}
        },
        Sp: {
          type: "structure",
          required: [
            "AccountName",
            "AccountPassword"
          ],
          members: {
            AccountName: {
              type: "string",
              sensitive: true
            },
            AccountPassword: {
              type: "string",
              sensitive: true
            }
          }
        },
        St: {
          type: "structure",
          required: [
            "DirectoryName"
          ],
          members: {
            DirectoryName: {},
            OrganizationalUnitDistinguishedNames: {
              shape: "Sn"
            },
            ServiceAccountCredentials: {
              shape: "Sp"
            },
            CreatedTime: {
              type: "timestamp"
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "DesiredInstances"
          ],
          members: {
            DesiredInstances: {
              type: "integer"
            }
          }
        },
        S10: {
          type: "structure",
          members: {
            SubnetIds: {
              type: "list",
              member: {}
            },
            SecurityGroupIds: {
              type: "list",
              member: {}
            }
          }
        },
        S15: {
          type: "structure",
          members: {
            DirectoryName: {},
            OrganizationalUnitDistinguishedName: {}
          }
        },
        S16: {
          type: "map",
          key: {},
          value: {}
        },
        S1b: {
          type: "structure",
          required: [
            "Arn",
            "Name",
            "InstanceType",
            "ComputeCapacityStatus",
            "State"
          ],
          members: {
            Arn: {},
            Name: {},
            DisplayName: {},
            Description: {},
            ImageName: {},
            ImageArn: {},
            InstanceType: {},
            FleetType: {},
            ComputeCapacityStatus: {
              type: "structure",
              required: [
                "Desired"
              ],
              members: {
                Desired: {
                  type: "integer"
                },
                Running: {
                  type: "integer"
                },
                InUse: {
                  type: "integer"
                },
                Available: {
                  type: "integer"
                }
              }
            },
            MaxUserDurationInSeconds: {
              type: "integer"
            },
            DisconnectTimeoutInSeconds: {
              type: "integer"
            },
            State: {},
            VpcConfig: {
              shape: "S10"
            },
            CreatedTime: {
              type: "timestamp"
            },
            FleetErrors: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ErrorCode: {},
                  ErrorMessage: {}
                }
              }
            },
            EnableDefaultInternetAccess: {
              type: "boolean"
            },
            DomainJoinInfo: {
              shape: "S15"
            },
            IdleDisconnectTimeoutInSeconds: {
              type: "integer"
            },
            IamRoleArn: {},
            StreamView: {}
          }
        },
        S1j: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "EndpointType"
            ],
            members: {
              EndpointType: {},
              VpceId: {}
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            Arn: {},
            ImageArn: {},
            Description: {},
            DisplayName: {},
            VpcConfig: {
              shape: "S10"
            },
            InstanceType: {},
            Platform: {},
            IamRoleArn: {},
            State: {},
            StateChangeReason: {
              type: "structure",
              members: {
                Code: {},
                Message: {}
              }
            },
            CreatedTime: {
              type: "timestamp"
            },
            EnableDefaultInternetAccess: {
              type: "boolean"
            },
            DomainJoinInfo: {
              shape: "S15"
            },
            NetworkAccessConfiguration: {
              shape: "S1s"
            },
            ImageBuilderErrors: {
              shape: "S1t"
            },
            AppstreamAgentVersion: {},
            AccessEndpoints: {
              shape: "S1j"
            }
          }
        },
        S1s: {
          type: "structure",
          members: {
            EniPrivateIpAddress: {},
            EniId: {}
          }
        },
        S1t: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ErrorCode: {},
              ErrorMessage: {},
              ErrorTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        S1z: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ConnectorType"
            ],
            members: {
              ConnectorType: {},
              ResourceIdentifier: {},
              Domains: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S27: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Action",
              "Permission"
            ],
            members: {
              Action: {},
              Permission: {}
            }
          }
        },
        S2b: {
          type: "structure",
          required: [
            "Enabled"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            SettingsGroup: {}
          }
        },
        S2d: {
          type: "list",
          member: {}
        },
        S2g: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Arn: {},
            Name: {},
            Description: {},
            DisplayName: {},
            CreatedTime: {
              type: "timestamp"
            },
            StorageConnectors: {
              shape: "S1z"
            },
            RedirectURL: {},
            FeedbackURL: {},
            StackErrors: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ErrorCode: {},
                  ErrorMessage: {}
                }
              }
            },
            UserSettings: {
              shape: "S27"
            },
            ApplicationSettings: {
              type: "structure",
              members: {
                Enabled: {
                  type: "boolean"
                },
                SettingsGroup: {},
                S3BucketName: {}
              }
            },
            AccessEndpoints: {
              shape: "S1j"
            },
            EmbedHostDomains: {
              shape: "S2d"
            }
          }
        },
        S2q: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            Arn: {},
            BaseImageArn: {},
            DisplayName: {},
            State: {},
            Visibility: {},
            ImageBuilderSupported: {
              type: "boolean"
            },
            ImageBuilderName: {},
            Platform: {},
            Description: {},
            StateChangeReason: {
              type: "structure",
              members: {
                Code: {},
                Message: {}
              }
            },
            Applications: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {},
                  DisplayName: {},
                  IconURL: {},
                  LaunchPath: {},
                  LaunchParameters: {},
                  Enabled: {
                    type: "boolean"
                  },
                  Metadata: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            },
            CreatedTime: {
              type: "timestamp"
            },
            PublicBaseImageReleasedDate: {
              type: "timestamp"
            },
            AppstreamAgentVersion: {},
            ImagePermissions: {
              shape: "S2y"
            },
            ImageErrors: {
              shape: "S1t"
            }
          }
        },
        S2y: {
          type: "structure",
          members: {
            allowFleet: {
              type: "boolean"
            },
            allowImageBuilder: {
              type: "boolean"
            }
          }
        },
        S34: {
          type: "string",
          sensitive: true
        },
        S3s: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/appstream-2016-12-01.paginators.json
var require_appstream_2016_12_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/appstream-2016-12-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeImagePermissions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeImages: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/appstream-2016-12-01.waiters2.json
var require_appstream_2016_12_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/appstream-2016-12-01.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        FleetStarted: {
          delay: 30,
          maxAttempts: 40,
          operation: "DescribeFleets",
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "Fleets[].State",
              expected: "ACTIVE"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "Fleets[].State",
              expected: "PENDING_DEACTIVATE"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "Fleets[].State",
              expected: "INACTIVE"
            }
          ]
        },
        FleetStopped: {
          delay: 30,
          maxAttempts: 40,
          operation: "DescribeFleets",
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "Fleets[].State",
              expected: "INACTIVE"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "Fleets[].State",
              expected: "PENDING_ACTIVATE"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "Fleets[].State",
              expected: "ACTIVE"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/appstream.js
var require_appstream = __commonJS({
  "node_modules/aws-sdk/clients/appstream.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["appstream"] = {};
    AWS3.AppStream = Service.defineService("appstream", ["2016-12-01"]);
    Object.defineProperty(apiLoader.services["appstream"], "2016-12-01", {
      get: function get() {
        var model = require_appstream_2016_12_01_min();
        model.paginators = require_appstream_2016_12_01_paginators().pagination;
        model.waiters = require_appstream_2016_12_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.AppStream;
  }
});

// node_modules/aws-sdk/apis/autoscaling-2011-01-01.min.json
var require_autoscaling_2011_01_01_min = __commonJS({
  "node_modules/aws-sdk/apis/autoscaling-2011-01-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2011-01-01",
        endpointPrefix: "autoscaling",
        protocol: "query",
        serviceFullName: "Auto Scaling",
        serviceId: "Auto Scaling",
        signatureVersion: "v4",
        uid: "autoscaling-2011-01-01",
        xmlNamespace: "http://autoscaling.amazonaws.com/doc/2011-01-01/"
      },
      operations: {
        AttachInstances: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              InstanceIds: {
                shape: "S2"
              },
              AutoScalingGroupName: {}
            }
          }
        },
        AttachLoadBalancerTargetGroups: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "TargetGroupARNs"
            ],
            members: {
              AutoScalingGroupName: {},
              TargetGroupARNs: {
                shape: "S6"
              }
            }
          },
          output: {
            resultWrapper: "AttachLoadBalancerTargetGroupsResult",
            type: "structure",
            members: {}
          }
        },
        AttachLoadBalancers: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "LoadBalancerNames"
            ],
            members: {
              AutoScalingGroupName: {},
              LoadBalancerNames: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "AttachLoadBalancersResult",
            type: "structure",
            members: {}
          }
        },
        BatchDeleteScheduledAction: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "ScheduledActionNames"
            ],
            members: {
              AutoScalingGroupName: {},
              ScheduledActionNames: {
                shape: "Sd"
              }
            }
          },
          output: {
            resultWrapper: "BatchDeleteScheduledActionResult",
            type: "structure",
            members: {
              FailedScheduledActions: {
                shape: "Sf"
              }
            }
          }
        },
        BatchPutScheduledUpdateGroupAction: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "ScheduledUpdateGroupActions"
            ],
            members: {
              AutoScalingGroupName: {},
              ScheduledUpdateGroupActions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ScheduledActionName"
                  ],
                  members: {
                    ScheduledActionName: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    Recurrence: {},
                    MinSize: {
                      type: "integer"
                    },
                    MaxSize: {
                      type: "integer"
                    },
                    DesiredCapacity: {
                      type: "integer"
                    },
                    TimeZone: {}
                  }
                }
              }
            }
          },
          output: {
            resultWrapper: "BatchPutScheduledUpdateGroupActionResult",
            type: "structure",
            members: {
              FailedScheduledUpdateGroupActions: {
                shape: "Sf"
              }
            }
          }
        },
        CancelInstanceRefresh: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {}
            }
          },
          output: {
            resultWrapper: "CancelInstanceRefreshResult",
            type: "structure",
            members: {
              InstanceRefreshId: {}
            }
          }
        },
        CompleteLifecycleAction: {
          input: {
            type: "structure",
            required: [
              "LifecycleHookName",
              "AutoScalingGroupName",
              "LifecycleActionResult"
            ],
            members: {
              LifecycleHookName: {},
              AutoScalingGroupName: {},
              LifecycleActionToken: {},
              LifecycleActionResult: {},
              InstanceId: {}
            }
          },
          output: {
            resultWrapper: "CompleteLifecycleActionResult",
            type: "structure",
            members: {}
          }
        },
        CreateAutoScalingGroup: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "MinSize",
              "MaxSize"
            ],
            members: {
              AutoScalingGroupName: {},
              LaunchConfigurationName: {},
              LaunchTemplate: {
                shape: "S10"
              },
              MixedInstancesPolicy: {
                shape: "S12"
              },
              InstanceId: {},
              MinSize: {
                type: "integer"
              },
              MaxSize: {
                type: "integer"
              },
              DesiredCapacity: {
                type: "integer"
              },
              DefaultCooldown: {
                type: "integer"
              },
              AvailabilityZones: {
                shape: "S1d"
              },
              LoadBalancerNames: {
                shape: "Sa"
              },
              TargetGroupARNs: {
                shape: "S6"
              },
              HealthCheckType: {},
              HealthCheckGracePeriod: {
                type: "integer"
              },
              PlacementGroup: {},
              VPCZoneIdentifier: {},
              TerminationPolicies: {
                shape: "S1g"
              },
              NewInstancesProtectedFromScaleIn: {
                type: "boolean"
              },
              CapacityRebalance: {
                type: "boolean"
              },
              LifecycleHookSpecificationList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "LifecycleHookName",
                    "LifecycleTransition"
                  ],
                  members: {
                    LifecycleHookName: {},
                    LifecycleTransition: {},
                    NotificationMetadata: {},
                    HeartbeatTimeout: {
                      type: "integer"
                    },
                    DefaultResult: {},
                    NotificationTargetARN: {},
                    RoleARN: {}
                  }
                }
              },
              Tags: {
                shape: "S1q"
              },
              ServiceLinkedRoleARN: {},
              MaxInstanceLifetime: {
                type: "integer"
              },
              Context: {}
            }
          }
        },
        CreateLaunchConfiguration: {
          input: {
            type: "structure",
            required: [
              "LaunchConfigurationName"
            ],
            members: {
              LaunchConfigurationName: {},
              ImageId: {},
              KeyName: {},
              SecurityGroups: {
                shape: "S1y"
              },
              ClassicLinkVPCId: {},
              ClassicLinkVPCSecurityGroups: {
                shape: "S1z"
              },
              UserData: {},
              InstanceId: {},
              InstanceType: {},
              KernelId: {},
              RamdiskId: {},
              BlockDeviceMappings: {
                shape: "S21"
              },
              InstanceMonitoring: {
                shape: "S2b"
              },
              SpotPrice: {},
              IamInstanceProfile: {},
              EbsOptimized: {
                type: "boolean"
              },
              AssociatePublicIpAddress: {
                type: "boolean"
              },
              PlacementTenancy: {},
              MetadataOptions: {
                shape: "S2g"
              }
            }
          }
        },
        CreateOrUpdateTags: {
          input: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "S1q"
              }
            }
          }
        },
        DeleteAutoScalingGroup: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              ForceDelete: {
                type: "boolean"
              }
            }
          }
        },
        DeleteLaunchConfiguration: {
          input: {
            type: "structure",
            required: [
              "LaunchConfigurationName"
            ],
            members: {
              LaunchConfigurationName: {}
            }
          }
        },
        DeleteLifecycleHook: {
          input: {
            type: "structure",
            required: [
              "LifecycleHookName",
              "AutoScalingGroupName"
            ],
            members: {
              LifecycleHookName: {},
              AutoScalingGroupName: {}
            }
          },
          output: {
            resultWrapper: "DeleteLifecycleHookResult",
            type: "structure",
            members: {}
          }
        },
        DeleteNotificationConfiguration: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "TopicARN"
            ],
            members: {
              AutoScalingGroupName: {},
              TopicARN: {}
            }
          }
        },
        DeletePolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyName"
            ],
            members: {
              AutoScalingGroupName: {},
              PolicyName: {}
            }
          }
        },
        DeleteScheduledAction: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "ScheduledActionName"
            ],
            members: {
              AutoScalingGroupName: {},
              ScheduledActionName: {}
            }
          }
        },
        DeleteTags: {
          input: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "S1q"
              }
            }
          }
        },
        DeleteWarmPool: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              ForceDelete: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DeleteWarmPoolResult",
            type: "structure",
            members: {}
          }
        },
        DescribeAccountLimits: {
          output: {
            resultWrapper: "DescribeAccountLimitsResult",
            type: "structure",
            members: {
              MaxNumberOfAutoScalingGroups: {
                type: "integer"
              },
              MaxNumberOfLaunchConfigurations: {
                type: "integer"
              },
              NumberOfAutoScalingGroups: {
                type: "integer"
              },
              NumberOfLaunchConfigurations: {
                type: "integer"
              }
            }
          }
        },
        DescribeAdjustmentTypes: {
          output: {
            resultWrapper: "DescribeAdjustmentTypesResult",
            type: "structure",
            members: {
              AdjustmentTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AdjustmentType: {}
                  }
                }
              }
            }
          }
        },
        DescribeAutoScalingGroups: {
          input: {
            type: "structure",
            members: {
              AutoScalingGroupNames: {
                shape: "S35"
              },
              NextToken: {},
              MaxRecords: {
                type: "integer"
              },
              Filters: {
                shape: "S37"
              }
            }
          },
          output: {
            resultWrapper: "DescribeAutoScalingGroupsResult",
            type: "structure",
            required: [
              "AutoScalingGroups"
            ],
            members: {
              AutoScalingGroups: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AutoScalingGroupName",
                    "MinSize",
                    "MaxSize",
                    "DesiredCapacity",
                    "DefaultCooldown",
                    "AvailabilityZones",
                    "HealthCheckType",
                    "CreatedTime"
                  ],
                  members: {
                    AutoScalingGroupName: {},
                    AutoScalingGroupARN: {},
                    LaunchConfigurationName: {},
                    LaunchTemplate: {
                      shape: "S10"
                    },
                    MixedInstancesPolicy: {
                      shape: "S12"
                    },
                    MinSize: {
                      type: "integer"
                    },
                    MaxSize: {
                      type: "integer"
                    },
                    DesiredCapacity: {
                      type: "integer"
                    },
                    PredictedCapacity: {
                      type: "integer"
                    },
                    DefaultCooldown: {
                      type: "integer"
                    },
                    AvailabilityZones: {
                      shape: "S1d"
                    },
                    LoadBalancerNames: {
                      shape: "Sa"
                    },
                    TargetGroupARNs: {
                      shape: "S6"
                    },
                    HealthCheckType: {},
                    HealthCheckGracePeriod: {
                      type: "integer"
                    },
                    Instances: {
                      shape: "S3e"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    },
                    SuspendedProcesses: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ProcessName: {},
                          SuspensionReason: {}
                        }
                      }
                    },
                    PlacementGroup: {},
                    VPCZoneIdentifier: {},
                    EnabledMetrics: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Metric: {},
                          Granularity: {}
                        }
                      }
                    },
                    Status: {},
                    Tags: {
                      shape: "S3l"
                    },
                    TerminationPolicies: {
                      shape: "S1g"
                    },
                    NewInstancesProtectedFromScaleIn: {
                      type: "boolean"
                    },
                    ServiceLinkedRoleARN: {},
                    MaxInstanceLifetime: {
                      type: "integer"
                    },
                    CapacityRebalance: {
                      type: "boolean"
                    },
                    WarmPoolConfiguration: {
                      shape: "S3n"
                    },
                    WarmPoolSize: {
                      type: "integer"
                    },
                    Context: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAutoScalingInstances: {
          input: {
            type: "structure",
            members: {
              InstanceIds: {
                shape: "S2"
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeAutoScalingInstancesResult",
            type: "structure",
            members: {
              AutoScalingInstances: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "InstanceId",
                    "AutoScalingGroupName",
                    "AvailabilityZone",
                    "LifecycleState",
                    "HealthStatus",
                    "ProtectedFromScaleIn"
                  ],
                  members: {
                    InstanceId: {},
                    InstanceType: {},
                    AutoScalingGroupName: {},
                    AvailabilityZone: {},
                    LifecycleState: {},
                    HealthStatus: {},
                    LaunchConfigurationName: {},
                    LaunchTemplate: {
                      shape: "S10"
                    },
                    ProtectedFromScaleIn: {
                      type: "boolean"
                    },
                    WeightedCapacity: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAutoScalingNotificationTypes: {
          output: {
            resultWrapper: "DescribeAutoScalingNotificationTypesResult",
            type: "structure",
            members: {
              AutoScalingNotificationTypes: {
                shape: "S3y"
              }
            }
          }
        },
        DescribeInstanceRefreshes: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              InstanceRefreshIds: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeInstanceRefreshesResult",
            type: "structure",
            members: {
              InstanceRefreshes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InstanceRefreshId: {},
                    AutoScalingGroupName: {},
                    Status: {},
                    StatusReason: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    PercentageComplete: {
                      type: "integer"
                    },
                    InstancesToUpdate: {
                      type: "integer"
                    },
                    ProgressDetails: {
                      type: "structure",
                      members: {
                        LivePoolProgress: {
                          type: "structure",
                          members: {
                            PercentageComplete: {
                              type: "integer"
                            },
                            InstancesToUpdate: {
                              type: "integer"
                            }
                          }
                        },
                        WarmPoolProgress: {
                          type: "structure",
                          members: {
                            PercentageComplete: {
                              type: "integer"
                            },
                            InstancesToUpdate: {
                              type: "integer"
                            }
                          }
                        }
                      }
                    },
                    Preferences: {
                      shape: "S4a"
                    },
                    DesiredConfiguration: {
                      shape: "S4g"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeLaunchConfigurations: {
          input: {
            type: "structure",
            members: {
              LaunchConfigurationNames: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeLaunchConfigurationsResult",
            type: "structure",
            required: [
              "LaunchConfigurations"
            ],
            members: {
              LaunchConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "LaunchConfigurationName",
                    "ImageId",
                    "InstanceType",
                    "CreatedTime"
                  ],
                  members: {
                    LaunchConfigurationName: {},
                    LaunchConfigurationARN: {},
                    ImageId: {},
                    KeyName: {},
                    SecurityGroups: {
                      shape: "S1y"
                    },
                    ClassicLinkVPCId: {},
                    ClassicLinkVPCSecurityGroups: {
                      shape: "S1z"
                    },
                    UserData: {},
                    InstanceType: {},
                    KernelId: {},
                    RamdiskId: {},
                    BlockDeviceMappings: {
                      shape: "S21"
                    },
                    InstanceMonitoring: {
                      shape: "S2b"
                    },
                    SpotPrice: {},
                    IamInstanceProfile: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    EbsOptimized: {
                      type: "boolean"
                    },
                    AssociatePublicIpAddress: {
                      type: "boolean"
                    },
                    PlacementTenancy: {},
                    MetadataOptions: {
                      shape: "S2g"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeLifecycleHookTypes: {
          output: {
            resultWrapper: "DescribeLifecycleHookTypesResult",
            type: "structure",
            members: {
              LifecycleHookTypes: {
                shape: "S3y"
              }
            }
          }
        },
        DescribeLifecycleHooks: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              LifecycleHookNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "DescribeLifecycleHooksResult",
            type: "structure",
            members: {
              LifecycleHooks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LifecycleHookName: {},
                    AutoScalingGroupName: {},
                    LifecycleTransition: {},
                    NotificationTargetARN: {},
                    RoleARN: {},
                    NotificationMetadata: {},
                    HeartbeatTimeout: {
                      type: "integer"
                    },
                    GlobalTimeout: {
                      type: "integer"
                    },
                    DefaultResult: {}
                  }
                }
              }
            }
          }
        },
        DescribeLoadBalancerTargetGroups: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              NextToken: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeLoadBalancerTargetGroupsResult",
            type: "structure",
            members: {
              LoadBalancerTargetGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LoadBalancerTargetGroupARN: {},
                    State: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeLoadBalancers: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              NextToken: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeLoadBalancersResult",
            type: "structure",
            members: {
              LoadBalancers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LoadBalancerName: {},
                    State: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMetricCollectionTypes: {
          output: {
            resultWrapper: "DescribeMetricCollectionTypesResult",
            type: "structure",
            members: {
              Metrics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Metric: {}
                  }
                }
              },
              Granularities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Granularity: {}
                  }
                }
              }
            }
          }
        },
        DescribeNotificationConfigurations: {
          input: {
            type: "structure",
            members: {
              AutoScalingGroupNames: {
                shape: "S35"
              },
              NextToken: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeNotificationConfigurationsResult",
            type: "structure",
            required: [
              "NotificationConfigurations"
            ],
            members: {
              NotificationConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AutoScalingGroupName: {},
                    TopicARN: {},
                    NotificationType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribePolicies: {
          input: {
            type: "structure",
            members: {
              AutoScalingGroupName: {},
              PolicyNames: {
                type: "list",
                member: {}
              },
              PolicyTypes: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribePoliciesResult",
            type: "structure",
            members: {
              ScalingPolicies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AutoScalingGroupName: {},
                    PolicyName: {},
                    PolicyARN: {},
                    PolicyType: {},
                    AdjustmentType: {},
                    MinAdjustmentStep: {
                      shape: "S5g"
                    },
                    MinAdjustmentMagnitude: {
                      type: "integer"
                    },
                    ScalingAdjustment: {
                      type: "integer"
                    },
                    Cooldown: {
                      type: "integer"
                    },
                    StepAdjustments: {
                      shape: "S5j"
                    },
                    MetricAggregationType: {},
                    EstimatedInstanceWarmup: {
                      type: "integer"
                    },
                    Alarms: {
                      shape: "S5n"
                    },
                    TargetTrackingConfiguration: {
                      shape: "S5p"
                    },
                    Enabled: {
                      type: "boolean"
                    },
                    PredictiveScalingConfiguration: {
                      shape: "S63"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeScalingActivities: {
          input: {
            type: "structure",
            members: {
              ActivityIds: {
                type: "list",
                member: {}
              },
              AutoScalingGroupName: {},
              IncludeDeletedGroups: {
                type: "boolean"
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeScalingActivitiesResult",
            type: "structure",
            required: [
              "Activities"
            ],
            members: {
              Activities: {
                shape: "S6k"
              },
              NextToken: {}
            }
          }
        },
        DescribeScalingProcessTypes: {
          output: {
            resultWrapper: "DescribeScalingProcessTypesResult",
            type: "structure",
            members: {
              Processes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ProcessName"
                  ],
                  members: {
                    ProcessName: {}
                  }
                }
              }
            }
          }
        },
        DescribeScheduledActions: {
          input: {
            type: "structure",
            members: {
              AutoScalingGroupName: {},
              ScheduledActionNames: {
                shape: "Sd"
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              NextToken: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeScheduledActionsResult",
            type: "structure",
            members: {
              ScheduledUpdateGroupActions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AutoScalingGroupName: {},
                    ScheduledActionName: {},
                    ScheduledActionARN: {},
                    Time: {
                      type: "timestamp"
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    Recurrence: {},
                    MinSize: {
                      type: "integer"
                    },
                    MaxSize: {
                      type: "integer"
                    },
                    DesiredCapacity: {
                      type: "integer"
                    },
                    TimeZone: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeTags: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S37"
              },
              NextToken: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeTagsResult",
            type: "structure",
            members: {
              Tags: {
                shape: "S3l"
              },
              NextToken: {}
            }
          }
        },
        DescribeTerminationPolicyTypes: {
          output: {
            resultWrapper: "DescribeTerminationPolicyTypesResult",
            type: "structure",
            members: {
              TerminationPolicyTypes: {
                shape: "S1g"
              }
            }
          }
        },
        DescribeWarmPool: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeWarmPoolResult",
            type: "structure",
            members: {
              WarmPoolConfiguration: {
                shape: "S3n"
              },
              Instances: {
                shape: "S3e"
              },
              NextToken: {}
            }
          }
        },
        DetachInstances: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "ShouldDecrementDesiredCapacity"
            ],
            members: {
              InstanceIds: {
                shape: "S2"
              },
              AutoScalingGroupName: {},
              ShouldDecrementDesiredCapacity: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DetachInstancesResult",
            type: "structure",
            members: {
              Activities: {
                shape: "S6k"
              }
            }
          }
        },
        DetachLoadBalancerTargetGroups: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "TargetGroupARNs"
            ],
            members: {
              AutoScalingGroupName: {},
              TargetGroupARNs: {
                shape: "S6"
              }
            }
          },
          output: {
            resultWrapper: "DetachLoadBalancerTargetGroupsResult",
            type: "structure",
            members: {}
          }
        },
        DetachLoadBalancers: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "LoadBalancerNames"
            ],
            members: {
              AutoScalingGroupName: {},
              LoadBalancerNames: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "DetachLoadBalancersResult",
            type: "structure",
            members: {}
          }
        },
        DisableMetricsCollection: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              Metrics: {
                shape: "S79"
              }
            }
          }
        },
        EnableMetricsCollection: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "Granularity"
            ],
            members: {
              AutoScalingGroupName: {},
              Metrics: {
                shape: "S79"
              },
              Granularity: {}
            }
          }
        },
        EnterStandby: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "ShouldDecrementDesiredCapacity"
            ],
            members: {
              InstanceIds: {
                shape: "S2"
              },
              AutoScalingGroupName: {},
              ShouldDecrementDesiredCapacity: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "EnterStandbyResult",
            type: "structure",
            members: {
              Activities: {
                shape: "S6k"
              }
            }
          }
        },
        ExecutePolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyName"
            ],
            members: {
              AutoScalingGroupName: {},
              PolicyName: {},
              HonorCooldown: {
                type: "boolean"
              },
              MetricValue: {
                type: "double"
              },
              BreachThreshold: {
                type: "double"
              }
            }
          }
        },
        ExitStandby: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              InstanceIds: {
                shape: "S2"
              },
              AutoScalingGroupName: {}
            }
          },
          output: {
            resultWrapper: "ExitStandbyResult",
            type: "structure",
            members: {
              Activities: {
                shape: "S6k"
              }
            }
          }
        },
        GetPredictiveScalingForecast: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "PolicyName",
              "StartTime",
              "EndTime"
            ],
            members: {
              AutoScalingGroupName: {},
              PolicyName: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            resultWrapper: "GetPredictiveScalingForecastResult",
            type: "structure",
            required: [
              "LoadForecast",
              "CapacityForecast",
              "UpdateTime"
            ],
            members: {
              LoadForecast: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Timestamps",
                    "Values",
                    "MetricSpecification"
                  ],
                  members: {
                    Timestamps: {
                      shape: "S7l"
                    },
                    Values: {
                      shape: "S7m"
                    },
                    MetricSpecification: {
                      shape: "S65"
                    }
                  }
                }
              },
              CapacityForecast: {
                type: "structure",
                required: [
                  "Timestamps",
                  "Values"
                ],
                members: {
                  Timestamps: {
                    shape: "S7l"
                  },
                  Values: {
                    shape: "S7m"
                  }
                }
              },
              UpdateTime: {
                type: "timestamp"
              }
            }
          }
        },
        PutLifecycleHook: {
          input: {
            type: "structure",
            required: [
              "LifecycleHookName",
              "AutoScalingGroupName"
            ],
            members: {
              LifecycleHookName: {},
              AutoScalingGroupName: {},
              LifecycleTransition: {},
              RoleARN: {},
              NotificationTargetARN: {},
              NotificationMetadata: {},
              HeartbeatTimeout: {
                type: "integer"
              },
              DefaultResult: {}
            }
          },
          output: {
            resultWrapper: "PutLifecycleHookResult",
            type: "structure",
            members: {}
          }
        },
        PutNotificationConfiguration: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "TopicARN",
              "NotificationTypes"
            ],
            members: {
              AutoScalingGroupName: {},
              TopicARN: {},
              NotificationTypes: {
                shape: "S3y"
              }
            }
          }
        },
        PutScalingPolicy: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "PolicyName"
            ],
            members: {
              AutoScalingGroupName: {},
              PolicyName: {},
              PolicyType: {},
              AdjustmentType: {},
              MinAdjustmentStep: {
                shape: "S5g"
              },
              MinAdjustmentMagnitude: {
                type: "integer"
              },
              ScalingAdjustment: {
                type: "integer"
              },
              Cooldown: {
                type: "integer"
              },
              MetricAggregationType: {},
              StepAdjustments: {
                shape: "S5j"
              },
              EstimatedInstanceWarmup: {
                type: "integer"
              },
              TargetTrackingConfiguration: {
                shape: "S5p"
              },
              Enabled: {
                type: "boolean"
              },
              PredictiveScalingConfiguration: {
                shape: "S63"
              }
            }
          },
          output: {
            resultWrapper: "PutScalingPolicyResult",
            type: "structure",
            members: {
              PolicyARN: {},
              Alarms: {
                shape: "S5n"
              }
            }
          }
        },
        PutScheduledUpdateGroupAction: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "ScheduledActionName"
            ],
            members: {
              AutoScalingGroupName: {},
              ScheduledActionName: {},
              Time: {
                type: "timestamp"
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Recurrence: {},
              MinSize: {
                type: "integer"
              },
              MaxSize: {
                type: "integer"
              },
              DesiredCapacity: {
                type: "integer"
              },
              TimeZone: {}
            }
          }
        },
        PutWarmPool: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              MaxGroupPreparedCapacity: {
                type: "integer"
              },
              MinSize: {
                type: "integer"
              },
              PoolState: {}
            }
          },
          output: {
            resultWrapper: "PutWarmPoolResult",
            type: "structure",
            members: {}
          }
        },
        RecordLifecycleActionHeartbeat: {
          input: {
            type: "structure",
            required: [
              "LifecycleHookName",
              "AutoScalingGroupName"
            ],
            members: {
              LifecycleHookName: {},
              AutoScalingGroupName: {},
              LifecycleActionToken: {},
              InstanceId: {}
            }
          },
          output: {
            resultWrapper: "RecordLifecycleActionHeartbeatResult",
            type: "structure",
            members: {}
          }
        },
        ResumeProcesses: {
          input: {
            shape: "S7y"
          }
        },
        SetDesiredCapacity: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName",
              "DesiredCapacity"
            ],
            members: {
              AutoScalingGroupName: {},
              DesiredCapacity: {
                type: "integer"
              },
              HonorCooldown: {
                type: "boolean"
              }
            }
          }
        },
        SetInstanceHealth: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "HealthStatus"
            ],
            members: {
              InstanceId: {},
              HealthStatus: {},
              ShouldRespectGracePeriod: {
                type: "boolean"
              }
            }
          }
        },
        SetInstanceProtection: {
          input: {
            type: "structure",
            required: [
              "InstanceIds",
              "AutoScalingGroupName",
              "ProtectedFromScaleIn"
            ],
            members: {
              InstanceIds: {
                shape: "S2"
              },
              AutoScalingGroupName: {},
              ProtectedFromScaleIn: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "SetInstanceProtectionResult",
            type: "structure",
            members: {}
          }
        },
        StartInstanceRefresh: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              Strategy: {},
              DesiredConfiguration: {
                shape: "S4g"
              },
              Preferences: {
                shape: "S4a"
              }
            }
          },
          output: {
            resultWrapper: "StartInstanceRefreshResult",
            type: "structure",
            members: {
              InstanceRefreshId: {}
            }
          }
        },
        SuspendProcesses: {
          input: {
            shape: "S7y"
          }
        },
        TerminateInstanceInAutoScalingGroup: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ShouldDecrementDesiredCapacity"
            ],
            members: {
              InstanceId: {},
              ShouldDecrementDesiredCapacity: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "TerminateInstanceInAutoScalingGroupResult",
            type: "structure",
            members: {
              Activity: {
                shape: "S6l"
              }
            }
          }
        },
        UpdateAutoScalingGroup: {
          input: {
            type: "structure",
            required: [
              "AutoScalingGroupName"
            ],
            members: {
              AutoScalingGroupName: {},
              LaunchConfigurationName: {},
              LaunchTemplate: {
                shape: "S10"
              },
              MixedInstancesPolicy: {
                shape: "S12"
              },
              MinSize: {
                type: "integer"
              },
              MaxSize: {
                type: "integer"
              },
              DesiredCapacity: {
                type: "integer"
              },
              DefaultCooldown: {
                type: "integer"
              },
              AvailabilityZones: {
                shape: "S1d"
              },
              HealthCheckType: {},
              HealthCheckGracePeriod: {
                type: "integer"
              },
              PlacementGroup: {},
              VPCZoneIdentifier: {},
              TerminationPolicies: {
                shape: "S1g"
              },
              NewInstancesProtectedFromScaleIn: {
                type: "boolean"
              },
              ServiceLinkedRoleARN: {},
              MaxInstanceLifetime: {
                type: "integer"
              },
              CapacityRebalance: {
                type: "boolean"
              },
              Context: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {}
        },
        S6: {
          type: "list",
          member: {}
        },
        Sa: {
          type: "list",
          member: {}
        },
        Sd: {
          type: "list",
          member: {}
        },
        Sf: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ScheduledActionName"
            ],
            members: {
              ScheduledActionName: {},
              ErrorCode: {},
              ErrorMessage: {}
            }
          }
        },
        S10: {
          type: "structure",
          members: {
            LaunchTemplateId: {},
            LaunchTemplateName: {},
            Version: {}
          }
        },
        S12: {
          type: "structure",
          members: {
            LaunchTemplate: {
              type: "structure",
              members: {
                LaunchTemplateSpecification: {
                  shape: "S10"
                },
                Overrides: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      InstanceType: {},
                      WeightedCapacity: {},
                      LaunchTemplateSpecification: {
                        shape: "S10"
                      }
                    }
                  }
                }
              }
            },
            InstancesDistribution: {
              type: "structure",
              members: {
                OnDemandAllocationStrategy: {},
                OnDemandBaseCapacity: {
                  type: "integer"
                },
                OnDemandPercentageAboveBaseCapacity: {
                  type: "integer"
                },
                SpotAllocationStrategy: {},
                SpotInstancePools: {
                  type: "integer"
                },
                SpotMaxPrice: {}
              }
            }
          }
        },
        S1d: {
          type: "list",
          member: {}
        },
        S1g: {
          type: "list",
          member: {}
        },
        S1q: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              ResourceId: {},
              ResourceType: {},
              Key: {},
              Value: {},
              PropagateAtLaunch: {
                type: "boolean"
              }
            }
          }
        },
        S1y: {
          type: "list",
          member: {}
        },
        S1z: {
          type: "list",
          member: {}
        },
        S21: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DeviceName"
            ],
            members: {
              VirtualName: {},
              DeviceName: {},
              Ebs: {
                type: "structure",
                members: {
                  SnapshotId: {},
                  VolumeSize: {
                    type: "integer"
                  },
                  VolumeType: {},
                  DeleteOnTermination: {
                    type: "boolean"
                  },
                  Iops: {
                    type: "integer"
                  },
                  Encrypted: {
                    type: "boolean"
                  },
                  Throughput: {
                    type: "integer"
                  }
                }
              },
              NoDevice: {
                type: "boolean"
              }
            }
          }
        },
        S2b: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            }
          }
        },
        S2g: {
          type: "structure",
          members: {
            HttpTokens: {},
            HttpPutResponseHopLimit: {
              type: "integer"
            },
            HttpEndpoint: {}
          }
        },
        S35: {
          type: "list",
          member: {}
        },
        S37: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S3e: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "InstanceId",
              "AvailabilityZone",
              "LifecycleState",
              "HealthStatus",
              "ProtectedFromScaleIn"
            ],
            members: {
              InstanceId: {},
              InstanceType: {},
              AvailabilityZone: {},
              LifecycleState: {},
              HealthStatus: {},
              LaunchConfigurationName: {},
              LaunchTemplate: {
                shape: "S10"
              },
              ProtectedFromScaleIn: {
                type: "boolean"
              },
              WeightedCapacity: {}
            }
          }
        },
        S3l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceId: {},
              ResourceType: {},
              Key: {},
              Value: {},
              PropagateAtLaunch: {
                type: "boolean"
              }
            }
          }
        },
        S3n: {
          type: "structure",
          members: {
            MaxGroupPreparedCapacity: {
              type: "integer"
            },
            MinSize: {
              type: "integer"
            },
            PoolState: {},
            Status: {}
          }
        },
        S3y: {
          type: "list",
          member: {}
        },
        S4a: {
          type: "structure",
          members: {
            MinHealthyPercentage: {
              type: "integer"
            },
            InstanceWarmup: {
              type: "integer"
            },
            CheckpointPercentages: {
              type: "list",
              member: {
                type: "integer"
              }
            },
            CheckpointDelay: {
              type: "integer"
            },
            SkipMatching: {
              type: "boolean"
            }
          }
        },
        S4g: {
          type: "structure",
          members: {
            LaunchTemplate: {
              shape: "S10"
            },
            MixedInstancesPolicy: {
              shape: "S12"
            }
          }
        },
        S5g: {
          type: "integer",
          deprecated: true
        },
        S5j: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ScalingAdjustment"
            ],
            members: {
              MetricIntervalLowerBound: {
                type: "double"
              },
              MetricIntervalUpperBound: {
                type: "double"
              },
              ScalingAdjustment: {
                type: "integer"
              }
            }
          }
        },
        S5n: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AlarmName: {},
              AlarmARN: {}
            }
          }
        },
        S5p: {
          type: "structure",
          required: [
            "TargetValue"
          ],
          members: {
            PredefinedMetricSpecification: {
              type: "structure",
              required: [
                "PredefinedMetricType"
              ],
              members: {
                PredefinedMetricType: {},
                ResourceLabel: {}
              }
            },
            CustomizedMetricSpecification: {
              type: "structure",
              required: [
                "MetricName",
                "Namespace",
                "Statistic"
              ],
              members: {
                MetricName: {},
                Namespace: {},
                Dimensions: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Name",
                      "Value"
                    ],
                    members: {
                      Name: {},
                      Value: {}
                    }
                  }
                },
                Statistic: {},
                Unit: {}
              }
            },
            TargetValue: {
              type: "double"
            },
            DisableScaleIn: {
              type: "boolean"
            }
          }
        },
        S63: {
          type: "structure",
          required: [
            "MetricSpecifications"
          ],
          members: {
            MetricSpecifications: {
              type: "list",
              member: {
                shape: "S65"
              }
            },
            Mode: {},
            SchedulingBufferTime: {
              type: "integer"
            },
            MaxCapacityBreachBehavior: {},
            MaxCapacityBuffer: {
              type: "integer"
            }
          }
        },
        S65: {
          type: "structure",
          required: [
            "TargetValue"
          ],
          members: {
            TargetValue: {
              type: "double"
            },
            PredefinedMetricPairSpecification: {
              type: "structure",
              required: [
                "PredefinedMetricType"
              ],
              members: {
                PredefinedMetricType: {},
                ResourceLabel: {}
              }
            },
            PredefinedScalingMetricSpecification: {
              type: "structure",
              required: [
                "PredefinedMetricType"
              ],
              members: {
                PredefinedMetricType: {},
                ResourceLabel: {}
              }
            },
            PredefinedLoadMetricSpecification: {
              type: "structure",
              required: [
                "PredefinedMetricType"
              ],
              members: {
                PredefinedMetricType: {},
                ResourceLabel: {}
              }
            }
          }
        },
        S6k: {
          type: "list",
          member: {
            shape: "S6l"
          }
        },
        S6l: {
          type: "structure",
          required: [
            "ActivityId",
            "AutoScalingGroupName",
            "Cause",
            "StartTime",
            "StatusCode"
          ],
          members: {
            ActivityId: {},
            AutoScalingGroupName: {},
            Description: {},
            Cause: {},
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            StatusCode: {},
            StatusMessage: {},
            Progress: {
              type: "integer"
            },
            Details: {},
            AutoScalingGroupState: {},
            AutoScalingGroupARN: {}
          }
        },
        S79: {
          type: "list",
          member: {}
        },
        S7l: {
          type: "list",
          member: {
            type: "timestamp"
          }
        },
        S7m: {
          type: "list",
          member: {
            type: "double"
          }
        },
        S7y: {
          type: "structure",
          required: [
            "AutoScalingGroupName"
          ],
          members: {
            AutoScalingGroupName: {},
            ScalingProcesses: {
              type: "list",
              member: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/autoscaling-2011-01-01.paginators.json
var require_autoscaling_2011_01_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/autoscaling-2011-01-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeAutoScalingGroups: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "AutoScalingGroups"
        },
        DescribeAutoScalingInstances: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "AutoScalingInstances"
        },
        DescribeLaunchConfigurations: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "LaunchConfigurations"
        },
        DescribeNotificationConfigurations: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "NotificationConfigurations"
        },
        DescribePolicies: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "ScalingPolicies"
        },
        DescribeScalingActivities: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "Activities"
        },
        DescribeScheduledActions: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "ScheduledUpdateGroupActions"
        },
        DescribeTags: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "Tags"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/autoscaling.js
var require_autoscaling = __commonJS({
  "node_modules/aws-sdk/clients/autoscaling.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["autoscaling"] = {};
    AWS3.AutoScaling = Service.defineService("autoscaling", ["2011-01-01"]);
    Object.defineProperty(apiLoader.services["autoscaling"], "2011-01-01", {
      get: function get() {
        var model = require_autoscaling_2011_01_01_min();
        model.paginators = require_autoscaling_2011_01_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.AutoScaling;
  }
});

// node_modules/aws-sdk/apis/batch-2016-08-10.min.json
var require_batch_2016_08_10_min = __commonJS({
  "node_modules/aws-sdk/apis/batch-2016-08-10.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-08-10",
        endpointPrefix: "batch",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "AWS Batch",
        serviceFullName: "AWS Batch",
        serviceId: "Batch",
        signatureVersion: "v4",
        uid: "batch-2016-08-10"
      },
      operations: {
        CancelJob: {
          http: {
            requestUri: "/v1/canceljob"
          },
          input: {
            type: "structure",
            required: [
              "jobId",
              "reason"
            ],
            members: {
              jobId: {},
              reason: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateComputeEnvironment: {
          http: {
            requestUri: "/v1/createcomputeenvironment"
          },
          input: {
            type: "structure",
            required: [
              "computeEnvironmentName",
              "type"
            ],
            members: {
              computeEnvironmentName: {},
              type: {},
              state: {},
              computeResources: {
                shape: "S7"
              },
              serviceRole: {},
              tags: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              computeEnvironmentName: {},
              computeEnvironmentArn: {}
            }
          }
        },
        CreateJobQueue: {
          http: {
            requestUri: "/v1/createjobqueue"
          },
          input: {
            type: "structure",
            required: [
              "jobQueueName",
              "priority",
              "computeEnvironmentOrder"
            ],
            members: {
              jobQueueName: {},
              state: {},
              priority: {
                type: "integer"
              },
              computeEnvironmentOrder: {
                shape: "So"
              },
              tags: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobQueueName",
              "jobQueueArn"
            ],
            members: {
              jobQueueName: {},
              jobQueueArn: {}
            }
          }
        },
        DeleteComputeEnvironment: {
          http: {
            requestUri: "/v1/deletecomputeenvironment"
          },
          input: {
            type: "structure",
            required: [
              "computeEnvironment"
            ],
            members: {
              computeEnvironment: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteJobQueue: {
          http: {
            requestUri: "/v1/deletejobqueue"
          },
          input: {
            type: "structure",
            required: [
              "jobQueue"
            ],
            members: {
              jobQueue: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterJobDefinition: {
          http: {
            requestUri: "/v1/deregisterjobdefinition"
          },
          input: {
            type: "structure",
            required: [
              "jobDefinition"
            ],
            members: {
              jobDefinition: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeComputeEnvironments: {
          http: {
            requestUri: "/v1/describecomputeenvironments"
          },
          input: {
            type: "structure",
            members: {
              computeEnvironments: {
                shape: "Sb"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              computeEnvironments: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "computeEnvironmentName",
                    "computeEnvironmentArn",
                    "ecsClusterArn"
                  ],
                  members: {
                    computeEnvironmentName: {},
                    computeEnvironmentArn: {},
                    ecsClusterArn: {},
                    tags: {
                      shape: "Si"
                    },
                    type: {},
                    state: {},
                    status: {},
                    statusReason: {},
                    computeResources: {
                      shape: "S7"
                    },
                    serviceRole: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeJobDefinitions: {
          http: {
            requestUri: "/v1/describejobdefinitions"
          },
          input: {
            type: "structure",
            members: {
              jobDefinitions: {
                shape: "Sb"
              },
              maxResults: {
                type: "integer"
              },
              jobDefinitionName: {},
              status: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              jobDefinitions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "jobDefinitionName",
                    "jobDefinitionArn",
                    "revision",
                    "type"
                  ],
                  members: {
                    jobDefinitionName: {},
                    jobDefinitionArn: {},
                    revision: {
                      type: "integer"
                    },
                    status: {},
                    type: {},
                    parameters: {
                      shape: "S16"
                    },
                    retryStrategy: {
                      shape: "S17"
                    },
                    containerProperties: {
                      shape: "S1b"
                    },
                    timeout: {
                      shape: "S28"
                    },
                    nodeProperties: {
                      shape: "S29"
                    },
                    tags: {
                      shape: "Si"
                    },
                    propagateTags: {
                      type: "boolean"
                    },
                    platformCapabilities: {
                      shape: "S2c"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeJobQueues: {
          http: {
            requestUri: "/v1/describejobqueues"
          },
          input: {
            type: "structure",
            members: {
              jobQueues: {
                shape: "Sb"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              jobQueues: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "jobQueueName",
                    "jobQueueArn",
                    "state",
                    "priority",
                    "computeEnvironmentOrder"
                  ],
                  members: {
                    jobQueueName: {},
                    jobQueueArn: {},
                    state: {},
                    status: {},
                    statusReason: {},
                    priority: {
                      type: "integer"
                    },
                    computeEnvironmentOrder: {
                      shape: "So"
                    },
                    tags: {
                      shape: "Si"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeJobs: {
          http: {
            requestUri: "/v1/describejobs"
          },
          input: {
            type: "structure",
            required: [
              "jobs"
            ],
            members: {
              jobs: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "jobName",
                    "jobId",
                    "jobQueue",
                    "status",
                    "startedAt",
                    "jobDefinition"
                  ],
                  members: {
                    jobArn: {},
                    jobName: {},
                    jobId: {},
                    jobQueue: {},
                    status: {},
                    attempts: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          container: {
                            type: "structure",
                            members: {
                              containerInstanceArn: {},
                              taskArn: {},
                              exitCode: {
                                type: "integer"
                              },
                              reason: {},
                              logStreamName: {},
                              networkInterfaces: {
                                shape: "S2r"
                              }
                            }
                          },
                          startedAt: {
                            type: "long"
                          },
                          stoppedAt: {
                            type: "long"
                          },
                          statusReason: {}
                        }
                      }
                    },
                    statusReason: {},
                    createdAt: {
                      type: "long"
                    },
                    retryStrategy: {
                      shape: "S17"
                    },
                    startedAt: {
                      type: "long"
                    },
                    stoppedAt: {
                      type: "long"
                    },
                    dependsOn: {
                      shape: "S2u"
                    },
                    jobDefinition: {},
                    parameters: {
                      shape: "S16"
                    },
                    container: {
                      type: "structure",
                      members: {
                        image: {},
                        vcpus: {
                          type: "integer"
                        },
                        memory: {
                          type: "integer"
                        },
                        command: {
                          shape: "Sb"
                        },
                        jobRoleArn: {},
                        executionRoleArn: {},
                        volumes: {
                          shape: "S1c"
                        },
                        environment: {
                          shape: "S1j"
                        },
                        mountPoints: {
                          shape: "S1l"
                        },
                        readonlyRootFilesystem: {
                          type: "boolean"
                        },
                        ulimits: {
                          shape: "S1o"
                        },
                        privileged: {
                          type: "boolean"
                        },
                        user: {},
                        exitCode: {
                          type: "integer"
                        },
                        reason: {},
                        containerInstanceArn: {},
                        taskArn: {},
                        logStreamName: {},
                        instanceType: {},
                        networkInterfaces: {
                          shape: "S2r"
                        },
                        resourceRequirements: {
                          shape: "S1q"
                        },
                        linuxParameters: {
                          shape: "S1t"
                        },
                        logConfiguration: {
                          shape: "S20"
                        },
                        secrets: {
                          shape: "S23"
                        },
                        networkConfiguration: {
                          shape: "S25"
                        },
                        fargatePlatformConfiguration: {
                          shape: "S27"
                        }
                      }
                    },
                    nodeDetails: {
                      type: "structure",
                      members: {
                        nodeIndex: {
                          type: "integer"
                        },
                        isMainNode: {
                          type: "boolean"
                        }
                      }
                    },
                    nodeProperties: {
                      shape: "S29"
                    },
                    arrayProperties: {
                      type: "structure",
                      members: {
                        statusSummary: {
                          type: "map",
                          key: {},
                          value: {
                            type: "integer"
                          }
                        },
                        size: {
                          type: "integer"
                        },
                        index: {
                          type: "integer"
                        }
                      }
                    },
                    timeout: {
                      shape: "S28"
                    },
                    tags: {
                      shape: "Si"
                    },
                    propagateTags: {
                      type: "boolean"
                    },
                    platformCapabilities: {
                      shape: "S2c"
                    }
                  }
                }
              }
            }
          }
        },
        ListJobs: {
          http: {
            requestUri: "/v1/listjobs"
          },
          input: {
            type: "structure",
            members: {
              jobQueue: {},
              arrayJobId: {},
              multiNodeJobId: {},
              jobStatus: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      shape: "Sb"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobSummaryList"
            ],
            members: {
              jobSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "jobId",
                    "jobName"
                  ],
                  members: {
                    jobArn: {},
                    jobId: {},
                    jobName: {},
                    createdAt: {
                      type: "long"
                    },
                    status: {},
                    statusReason: {},
                    startedAt: {
                      type: "long"
                    },
                    stoppedAt: {
                      type: "long"
                    },
                    container: {
                      type: "structure",
                      members: {
                        exitCode: {
                          type: "integer"
                        },
                        reason: {}
                      }
                    },
                    arrayProperties: {
                      type: "structure",
                      members: {
                        size: {
                          type: "integer"
                        },
                        index: {
                          type: "integer"
                        }
                      }
                    },
                    nodeProperties: {
                      type: "structure",
                      members: {
                        isMainNode: {
                          type: "boolean"
                        },
                        numNodes: {
                          type: "integer"
                        },
                        nodeIndex: {
                          type: "integer"
                        }
                      }
                    },
                    jobDefinition: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/v1/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Si"
              }
            }
          }
        },
        RegisterJobDefinition: {
          http: {
            requestUri: "/v1/registerjobdefinition"
          },
          input: {
            type: "structure",
            required: [
              "jobDefinitionName",
              "type"
            ],
            members: {
              jobDefinitionName: {},
              type: {},
              parameters: {
                shape: "S16"
              },
              containerProperties: {
                shape: "S1b"
              },
              nodeProperties: {
                shape: "S29"
              },
              retryStrategy: {
                shape: "S17"
              },
              propagateTags: {
                type: "boolean"
              },
              timeout: {
                shape: "S28"
              },
              tags: {
                shape: "Si"
              },
              platformCapabilities: {
                shape: "S2c"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobDefinitionName",
              "jobDefinitionArn",
              "revision"
            ],
            members: {
              jobDefinitionName: {},
              jobDefinitionArn: {},
              revision: {
                type: "integer"
              }
            }
          }
        },
        SubmitJob: {
          http: {
            requestUri: "/v1/submitjob"
          },
          input: {
            type: "structure",
            required: [
              "jobName",
              "jobQueue",
              "jobDefinition"
            ],
            members: {
              jobName: {},
              jobQueue: {},
              arrayProperties: {
                type: "structure",
                members: {
                  size: {
                    type: "integer"
                  }
                }
              },
              dependsOn: {
                shape: "S2u"
              },
              jobDefinition: {},
              parameters: {
                shape: "S16"
              },
              containerOverrides: {
                shape: "S3h"
              },
              nodeOverrides: {
                type: "structure",
                members: {
                  numNodes: {
                    type: "integer"
                  },
                  nodePropertyOverrides: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "targetNodes"
                      ],
                      members: {
                        targetNodes: {},
                        containerOverrides: {
                          shape: "S3h"
                        }
                      }
                    }
                  }
                }
              },
              retryStrategy: {
                shape: "S17"
              },
              propagateTags: {
                type: "boolean"
              },
              timeout: {
                shape: "S28"
              },
              tags: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobName",
              "jobId"
            ],
            members: {
              jobArn: {},
              jobName: {},
              jobId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/v1/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TerminateJob: {
          http: {
            requestUri: "/v1/terminatejob"
          },
          input: {
            type: "structure",
            required: [
              "jobId",
              "reason"
            ],
            members: {
              jobId: {},
              reason: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/v1/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateComputeEnvironment: {
          http: {
            requestUri: "/v1/updatecomputeenvironment"
          },
          input: {
            type: "structure",
            required: [
              "computeEnvironment"
            ],
            members: {
              computeEnvironment: {},
              state: {},
              computeResources: {
                type: "structure",
                members: {
                  minvCpus: {
                    type: "integer"
                  },
                  maxvCpus: {
                    type: "integer"
                  },
                  desiredvCpus: {
                    type: "integer"
                  },
                  subnets: {
                    shape: "Sb"
                  },
                  securityGroupIds: {
                    shape: "Sb"
                  }
                }
              },
              serviceRole: {}
            }
          },
          output: {
            type: "structure",
            members: {
              computeEnvironmentName: {},
              computeEnvironmentArn: {}
            }
          }
        },
        UpdateJobQueue: {
          http: {
            requestUri: "/v1/updatejobqueue"
          },
          input: {
            type: "structure",
            required: [
              "jobQueue"
            ],
            members: {
              jobQueue: {},
              state: {},
              priority: {
                type: "integer"
              },
              computeEnvironmentOrder: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobQueueName: {},
              jobQueueArn: {}
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "structure",
          required: [
            "type",
            "maxvCpus",
            "subnets"
          ],
          members: {
            type: {},
            allocationStrategy: {},
            minvCpus: {
              type: "integer"
            },
            maxvCpus: {
              type: "integer"
            },
            desiredvCpus: {
              type: "integer"
            },
            instanceTypes: {
              shape: "Sb"
            },
            imageId: {
              deprecated: true,
              deprecatedMessage: "This field is deprecated, use ec2Configuration[].imageIdOverride instead."
            },
            subnets: {
              shape: "Sb"
            },
            securityGroupIds: {
              shape: "Sb"
            },
            ec2KeyPair: {},
            instanceRole: {},
            tags: {
              type: "map",
              key: {},
              value: {}
            },
            placementGroup: {},
            bidPercentage: {
              type: "integer"
            },
            spotIamFleetRole: {},
            launchTemplate: {
              type: "structure",
              members: {
                launchTemplateId: {},
                launchTemplateName: {},
                version: {}
              }
            },
            ec2Configuration: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "imageType"
                ],
                members: {
                  imageType: {},
                  imageIdOverride: {}
                }
              }
            }
          }
        },
        Sb: {
          type: "list",
          member: {}
        },
        Si: {
          type: "map",
          key: {},
          value: {}
        },
        So: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "order",
              "computeEnvironment"
            ],
            members: {
              order: {
                type: "integer"
              },
              computeEnvironment: {}
            }
          }
        },
        S16: {
          type: "map",
          key: {},
          value: {}
        },
        S17: {
          type: "structure",
          members: {
            attempts: {
              type: "integer"
            },
            evaluateOnExit: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "action"
                ],
                members: {
                  onStatusReason: {},
                  onReason: {},
                  onExitCode: {},
                  action: {}
                }
              }
            }
          }
        },
        S1b: {
          type: "structure",
          members: {
            image: {},
            vcpus: {
              deprecated: true,
              deprecatedMessage: "This field is deprecated, use resourceRequirements instead.",
              type: "integer"
            },
            memory: {
              deprecated: true,
              deprecatedMessage: "This field is deprecated, use resourceRequirements instead.",
              type: "integer"
            },
            command: {
              shape: "Sb"
            },
            jobRoleArn: {},
            executionRoleArn: {},
            volumes: {
              shape: "S1c"
            },
            environment: {
              shape: "S1j"
            },
            mountPoints: {
              shape: "S1l"
            },
            readonlyRootFilesystem: {
              type: "boolean"
            },
            privileged: {
              type: "boolean"
            },
            ulimits: {
              shape: "S1o"
            },
            user: {},
            instanceType: {},
            resourceRequirements: {
              shape: "S1q"
            },
            linuxParameters: {
              shape: "S1t"
            },
            logConfiguration: {
              shape: "S20"
            },
            secrets: {
              shape: "S23"
            },
            networkConfiguration: {
              shape: "S25"
            },
            fargatePlatformConfiguration: {
              shape: "S27"
            }
          }
        },
        S1c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              host: {
                type: "structure",
                members: {
                  sourcePath: {}
                }
              },
              name: {},
              efsVolumeConfiguration: {
                type: "structure",
                required: [
                  "fileSystemId"
                ],
                members: {
                  fileSystemId: {},
                  rootDirectory: {},
                  transitEncryption: {},
                  transitEncryptionPort: {
                    type: "integer"
                  },
                  authorizationConfig: {
                    type: "structure",
                    members: {
                      accessPointId: {},
                      iam: {}
                    }
                  }
                }
              }
            }
          }
        },
        S1j: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              value: {}
            }
          }
        },
        S1l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              containerPath: {},
              readOnly: {
                type: "boolean"
              },
              sourceVolume: {}
            }
          }
        },
        S1o: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "hardLimit",
              "name",
              "softLimit"
            ],
            members: {
              hardLimit: {
                type: "integer"
              },
              name: {},
              softLimit: {
                type: "integer"
              }
            }
          }
        },
        S1q: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "value",
              "type"
            ],
            members: {
              value: {},
              type: {}
            }
          }
        },
        S1t: {
          type: "structure",
          members: {
            devices: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "hostPath"
                ],
                members: {
                  hostPath: {},
                  containerPath: {},
                  permissions: {
                    type: "list",
                    member: {}
                  }
                }
              }
            },
            initProcessEnabled: {
              type: "boolean"
            },
            sharedMemorySize: {
              type: "integer"
            },
            tmpfs: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "containerPath",
                  "size"
                ],
                members: {
                  containerPath: {},
                  size: {
                    type: "integer"
                  },
                  mountOptions: {
                    shape: "Sb"
                  }
                }
              }
            },
            maxSwap: {
              type: "integer"
            },
            swappiness: {
              type: "integer"
            }
          }
        },
        S20: {
          type: "structure",
          required: [
            "logDriver"
          ],
          members: {
            logDriver: {},
            options: {
              type: "map",
              key: {},
              value: {}
            },
            secretOptions: {
              shape: "S23"
            }
          }
        },
        S23: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "valueFrom"
            ],
            members: {
              name: {},
              valueFrom: {}
            }
          }
        },
        S25: {
          type: "structure",
          members: {
            assignPublicIp: {}
          }
        },
        S27: {
          type: "structure",
          members: {
            platformVersion: {}
          }
        },
        S28: {
          type: "structure",
          members: {
            attemptDurationSeconds: {
              type: "integer"
            }
          }
        },
        S29: {
          type: "structure",
          required: [
            "numNodes",
            "mainNode",
            "nodeRangeProperties"
          ],
          members: {
            numNodes: {
              type: "integer"
            },
            mainNode: {
              type: "integer"
            },
            nodeRangeProperties: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "targetNodes"
                ],
                members: {
                  targetNodes: {},
                  container: {
                    shape: "S1b"
                  }
                }
              }
            }
          }
        },
        S2c: {
          type: "list",
          member: {}
        },
        S2r: {
          type: "list",
          member: {
            type: "structure",
            members: {
              attachmentId: {},
              ipv6Address: {},
              privateIpv4Address: {}
            }
          }
        },
        S2u: {
          type: "list",
          member: {
            type: "structure",
            members: {
              jobId: {},
              type: {}
            }
          }
        },
        S3h: {
          type: "structure",
          members: {
            vcpus: {
              deprecated: true,
              deprecatedMessage: "This field is deprecated, use resourceRequirements instead.",
              type: "integer"
            },
            memory: {
              deprecated: true,
              deprecatedMessage: "This field is deprecated, use resourceRequirements instead.",
              type: "integer"
            },
            command: {
              shape: "Sb"
            },
            instanceType: {},
            environment: {
              shape: "S1j"
            },
            resourceRequirements: {
              shape: "S1q"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/batch-2016-08-10.paginators.json
var require_batch_2016_08_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/batch-2016-08-10.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeComputeEnvironments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "computeEnvironments"
        },
        DescribeJobDefinitions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "jobDefinitions"
        },
        DescribeJobQueues: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "jobQueues"
        },
        ListJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "jobSummaryList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/batch.js
var require_batch = __commonJS({
  "node_modules/aws-sdk/clients/batch.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["batch"] = {};
    AWS3.Batch = Service.defineService("batch", ["2016-08-10"]);
    Object.defineProperty(apiLoader.services["batch"], "2016-08-10", {
      get: function get() {
        var model = require_batch_2016_08_10_min();
        model.paginators = require_batch_2016_08_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Batch;
  }
});

// node_modules/aws-sdk/apis/budgets-2016-10-20.min.json
var require_budgets_2016_10_20_min = __commonJS({
  "node_modules/aws-sdk/apis/budgets-2016-10-20.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-10-20",
        endpointPrefix: "budgets",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "AWSBudgets",
        serviceFullName: "AWS Budgets",
        serviceId: "Budgets",
        signatureVersion: "v4",
        targetPrefix: "AWSBudgetServiceGateway",
        uid: "budgets-2016-10-20"
      },
      operations: {
        CreateBudget: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Budget"
            ],
            members: {
              AccountId: {},
              Budget: {
                shape: "S3"
              },
              NotificationsWithSubscribers: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Notification",
                    "Subscribers"
                  ],
                  members: {
                    Notification: {
                      shape: "Sl"
                    },
                    Subscribers: {
                      shape: "Sr"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateBudgetAction: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "NotificationType",
              "ActionType",
              "ActionThreshold",
              "Definition",
              "ExecutionRoleArn",
              "ApprovalModel",
              "Subscribers"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              NotificationType: {},
              ActionType: {},
              ActionThreshold: {
                shape: "Sy"
              },
              Definition: {
                shape: "Sz"
              },
              ExecutionRoleArn: {},
              ApprovalModel: {},
              Subscribers: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "ActionId"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              ActionId: {}
            }
          }
        },
        CreateNotification: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "Notification",
              "Subscribers"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              Notification: {
                shape: "Sl"
              },
              Subscribers: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateSubscriber: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "Notification",
              "Subscriber"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              Notification: {
                shape: "Sl"
              },
              Subscriber: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteBudget: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName"
            ],
            members: {
              AccountId: {},
              BudgetName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteBudgetAction: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "ActionId"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              ActionId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "Action"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              Action: {
                shape: "S1t"
              }
            }
          }
        },
        DeleteNotification: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "Notification"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              Notification: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSubscriber: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "Notification",
              "Subscriber"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              Notification: {
                shape: "Sl"
              },
              Subscriber: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeBudget: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName"
            ],
            members: {
              AccountId: {},
              BudgetName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Budget: {
                shape: "S3"
              }
            }
          }
        },
        DescribeBudgetAction: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "ActionId"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              ActionId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "Action"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              Action: {
                shape: "S1t"
              }
            }
          }
        },
        DescribeBudgetActionHistories: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "ActionId"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              ActionId: {},
              TimePeriod: {
                shape: "Sf"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ActionHistories"
            ],
            members: {
              ActionHistories: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Timestamp",
                    "Status",
                    "EventType",
                    "ActionHistoryDetails"
                  ],
                  members: {
                    Timestamp: {
                      type: "timestamp"
                    },
                    Status: {},
                    EventType: {},
                    ActionHistoryDetails: {
                      type: "structure",
                      required: [
                        "Message",
                        "Action"
                      ],
                      members: {
                        Message: {},
                        Action: {
                          shape: "S1t"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeBudgetActionsForAccount: {
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Actions"
            ],
            members: {
              Actions: {
                shape: "S2c"
              },
              NextToken: {}
            }
          }
        },
        DescribeBudgetActionsForBudget: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Actions"
            ],
            members: {
              Actions: {
                shape: "S2c"
              },
              NextToken: {}
            }
          }
        },
        DescribeBudgetPerformanceHistory: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              TimePeriod: {
                shape: "Sf"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BudgetPerformanceHistory: {
                type: "structure",
                members: {
                  BudgetName: {},
                  BudgetType: {},
                  CostFilters: {
                    shape: "Sa"
                  },
                  CostTypes: {
                    shape: "Sc"
                  },
                  TimeUnit: {},
                  BudgetedAndActualAmountsList: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        BudgetedAmount: {
                          shape: "S5"
                        },
                        ActualAmount: {
                          shape: "S5"
                        },
                        TimePeriod: {
                          shape: "Sf"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeBudgets: {
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Budgets: {
                type: "list",
                member: {
                  shape: "S3"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeNotificationsForBudget: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Notifications: {
                type: "list",
                member: {
                  shape: "Sl"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeSubscribersForNotification: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "Notification"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              Notification: {
                shape: "Sl"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Subscribers: {
                shape: "Sr"
              },
              NextToken: {}
            }
          }
        },
        ExecuteBudgetAction: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "ActionId",
              "ExecutionType"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              ActionId: {},
              ExecutionType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "ActionId",
              "ExecutionType"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              ActionId: {},
              ExecutionType: {}
            }
          }
        },
        UpdateBudget: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "NewBudget"
            ],
            members: {
              AccountId: {},
              NewBudget: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateBudgetAction: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "ActionId"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              ActionId: {},
              NotificationType: {},
              ActionThreshold: {
                shape: "Sy"
              },
              Definition: {
                shape: "Sz"
              },
              ExecutionRoleArn: {},
              ApprovalModel: {},
              Subscribers: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "OldAction",
              "NewAction"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              OldAction: {
                shape: "S1t"
              },
              NewAction: {
                shape: "S1t"
              }
            }
          }
        },
        UpdateNotification: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "OldNotification",
              "NewNotification"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              OldNotification: {
                shape: "Sl"
              },
              NewNotification: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateSubscriber: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BudgetName",
              "Notification",
              "OldSubscriber",
              "NewSubscriber"
            ],
            members: {
              AccountId: {},
              BudgetName: {},
              Notification: {
                shape: "Sl"
              },
              OldSubscriber: {
                shape: "Ss"
              },
              NewSubscriber: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          required: [
            "BudgetName",
            "TimeUnit",
            "BudgetType"
          ],
          members: {
            BudgetName: {},
            BudgetLimit: {
              shape: "S5"
            },
            PlannedBudgetLimits: {
              type: "map",
              key: {},
              value: {
                shape: "S5"
              }
            },
            CostFilters: {
              shape: "Sa"
            },
            CostTypes: {
              shape: "Sc"
            },
            TimeUnit: {},
            TimePeriod: {
              shape: "Sf"
            },
            CalculatedSpend: {
              type: "structure",
              required: [
                "ActualSpend"
              ],
              members: {
                ActualSpend: {
                  shape: "S5"
                },
                ForecastedSpend: {
                  shape: "S5"
                }
              }
            },
            BudgetType: {},
            LastUpdatedTime: {
              type: "timestamp"
            }
          }
        },
        S5: {
          type: "structure",
          required: [
            "Amount",
            "Unit"
          ],
          members: {
            Amount: {},
            Unit: {}
          }
        },
        Sa: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          }
        },
        Sc: {
          type: "structure",
          members: {
            IncludeTax: {
              type: "boolean"
            },
            IncludeSubscription: {
              type: "boolean"
            },
            UseBlended: {
              type: "boolean"
            },
            IncludeRefund: {
              type: "boolean"
            },
            IncludeCredit: {
              type: "boolean"
            },
            IncludeUpfront: {
              type: "boolean"
            },
            IncludeRecurring: {
              type: "boolean"
            },
            IncludeOtherSubscription: {
              type: "boolean"
            },
            IncludeSupport: {
              type: "boolean"
            },
            IncludeDiscount: {
              type: "boolean"
            },
            UseAmortized: {
              type: "boolean"
            }
          }
        },
        Sf: {
          type: "structure",
          members: {
            Start: {
              type: "timestamp"
            },
            End: {
              type: "timestamp"
            }
          }
        },
        Sl: {
          type: "structure",
          required: [
            "NotificationType",
            "ComparisonOperator",
            "Threshold"
          ],
          members: {
            NotificationType: {},
            ComparisonOperator: {},
            Threshold: {
              type: "double"
            },
            ThresholdType: {},
            NotificationState: {}
          }
        },
        Sr: {
          type: "list",
          member: {
            shape: "Ss"
          }
        },
        Ss: {
          type: "structure",
          required: [
            "SubscriptionType",
            "Address"
          ],
          members: {
            SubscriptionType: {},
            Address: {
              type: "string",
              sensitive: true
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "ActionThresholdValue",
            "ActionThresholdType"
          ],
          members: {
            ActionThresholdValue: {
              type: "double"
            },
            ActionThresholdType: {}
          }
        },
        Sz: {
          type: "structure",
          members: {
            IamActionDefinition: {
              type: "structure",
              required: [
                "PolicyArn"
              ],
              members: {
                PolicyArn: {},
                Roles: {
                  type: "list",
                  member: {}
                },
                Groups: {
                  type: "list",
                  member: {}
                },
                Users: {
                  type: "list",
                  member: {}
                }
              }
            },
            ScpActionDefinition: {
              type: "structure",
              required: [
                "PolicyId",
                "TargetIds"
              ],
              members: {
                PolicyId: {},
                TargetIds: {
                  type: "list",
                  member: {}
                }
              }
            },
            SsmActionDefinition: {
              type: "structure",
              required: [
                "ActionSubType",
                "Region",
                "InstanceIds"
              ],
              members: {
                ActionSubType: {},
                Region: {},
                InstanceIds: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        S1t: {
          type: "structure",
          required: [
            "ActionId",
            "BudgetName",
            "NotificationType",
            "ActionType",
            "ActionThreshold",
            "Definition",
            "ExecutionRoleArn",
            "ApprovalModel",
            "Status",
            "Subscribers"
          ],
          members: {
            ActionId: {},
            BudgetName: {},
            NotificationType: {},
            ActionType: {},
            ActionThreshold: {
              shape: "Sy"
            },
            Definition: {
              shape: "Sz"
            },
            ExecutionRoleArn: {},
            ApprovalModel: {},
            Status: {},
            Subscribers: {
              shape: "Sr"
            }
          }
        },
        S2c: {
          type: "list",
          member: {
            shape: "S1t"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/budgets-2016-10-20.paginators.json
var require_budgets_2016_10_20_paginators = __commonJS({
  "node_modules/aws-sdk/apis/budgets-2016-10-20.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeBudgetActionHistories: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ActionHistories"
        },
        DescribeBudgetActionsForAccount: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Actions"
        },
        DescribeBudgetActionsForBudget: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Actions"
        },
        DescribeBudgetPerformanceHistory: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "BudgetPerformanceHistory"
        },
        DescribeBudgets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Budgets"
        },
        DescribeNotificationsForBudget: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Notifications"
        },
        DescribeSubscribersForNotification: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Subscribers"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/budgets.js
var require_budgets = __commonJS({
  "node_modules/aws-sdk/clients/budgets.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["budgets"] = {};
    AWS3.Budgets = Service.defineService("budgets", ["2016-10-20"]);
    Object.defineProperty(apiLoader.services["budgets"], "2016-10-20", {
      get: function get() {
        var model = require_budgets_2016_10_20_min();
        model.paginators = require_budgets_2016_10_20_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Budgets;
  }
});

// node_modules/aws-sdk/apis/clouddirectory-2016-05-10.min.json
var require_clouddirectory_2016_05_10_min = __commonJS({
  "node_modules/aws-sdk/apis/clouddirectory-2016-05-10.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-05-10",
        endpointPrefix: "clouddirectory",
        protocol: "rest-json",
        serviceFullName: "Amazon CloudDirectory",
        serviceId: "CloudDirectory",
        signatureVersion: "v4",
        signingName: "clouddirectory",
        uid: "clouddirectory-2016-05-10"
      },
      operations: {
        AddFacetToObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/facets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "SchemaFacet",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              SchemaFacet: {
                shape: "S3"
              },
              ObjectAttributeList: {
                shape: "S5"
              },
              ObjectReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ApplySchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/apply",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PublishedSchemaArn",
              "DirectoryArn"
            ],
            members: {
              PublishedSchemaArn: {},
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppliedSchemaArn: {},
              DirectoryArn: {}
            }
          }
        },
        AttachObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/attach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ParentReference",
              "ChildReference",
              "LinkName"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ParentReference: {
                shape: "Sf"
              },
              ChildReference: {
                shape: "Sf"
              },
              LinkName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AttachedObjectIdentifier: {}
            }
          }
        },
        AttachPolicy: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/policy/attach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "PolicyReference",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              PolicyReference: {
                shape: "Sf"
              },
              ObjectReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AttachToIndex: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/index/attach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "IndexReference",
              "TargetReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              IndexReference: {
                shape: "Sf"
              },
              TargetReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AttachedObjectIdentifier: {}
            }
          }
        },
        AttachTypedLink: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/attach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "SourceObjectReference",
              "TargetObjectReference",
              "TypedLinkFacet",
              "Attributes"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              SourceObjectReference: {
                shape: "Sf"
              },
              TargetObjectReference: {
                shape: "Sf"
              },
              TypedLinkFacet: {
                shape: "St"
              },
              Attributes: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TypedLinkSpecifier: {
                shape: "Sy"
              }
            }
          }
        },
        BatchRead: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/batchread",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "Operations"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Operations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ListObjectAttributes: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        },
                        FacetFilter: {
                          shape: "S3"
                        }
                      }
                    },
                    ListObjectChildren: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListAttachedIndices: {
                      type: "structure",
                      required: [
                        "TargetReference"
                      ],
                      members: {
                        TargetReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListObjectParentPaths: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    GetObjectInformation: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    GetObjectAttributes: {
                      type: "structure",
                      required: [
                        "ObjectReference",
                        "SchemaFacet",
                        "AttributeNames"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        SchemaFacet: {
                          shape: "S3"
                        },
                        AttributeNames: {
                          shape: "S1a"
                        }
                      }
                    },
                    ListObjectPolicies: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListPolicyAttachments: {
                      type: "structure",
                      required: [
                        "PolicyReference"
                      ],
                      members: {
                        PolicyReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    LookupPolicy: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListIndex: {
                      type: "structure",
                      required: [
                        "IndexReference"
                      ],
                      members: {
                        RangesOnIndexedValues: {
                          shape: "S1f"
                        },
                        IndexReference: {
                          shape: "Sf"
                        },
                        MaxResults: {
                          type: "integer"
                        },
                        NextToken: {}
                      }
                    },
                    ListOutgoingTypedLinks: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        FilterAttributeRanges: {
                          shape: "S1k"
                        },
                        FilterTypedLink: {
                          shape: "St"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListIncomingTypedLinks: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        FilterAttributeRanges: {
                          shape: "S1k"
                        },
                        FilterTypedLink: {
                          shape: "St"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    GetLinkAttributes: {
                      type: "structure",
                      required: [
                        "TypedLinkSpecifier",
                        "AttributeNames"
                      ],
                      members: {
                        TypedLinkSpecifier: {
                          shape: "Sy"
                        },
                        AttributeNames: {
                          shape: "S1a"
                        }
                      }
                    }
                  }
                }
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Responses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SuccessfulResponse: {
                      type: "structure",
                      members: {
                        ListObjectAttributes: {
                          type: "structure",
                          members: {
                            Attributes: {
                              shape: "S5"
                            },
                            NextToken: {}
                          }
                        },
                        ListObjectChildren: {
                          type: "structure",
                          members: {
                            Children: {
                              shape: "S1v"
                            },
                            NextToken: {}
                          }
                        },
                        GetObjectInformation: {
                          type: "structure",
                          members: {
                            SchemaFacets: {
                              shape: "S1x"
                            },
                            ObjectIdentifier: {}
                          }
                        },
                        GetObjectAttributes: {
                          type: "structure",
                          members: {
                            Attributes: {
                              shape: "S5"
                            }
                          }
                        },
                        ListAttachedIndices: {
                          type: "structure",
                          members: {
                            IndexAttachments: {
                              shape: "S20"
                            },
                            NextToken: {}
                          }
                        },
                        ListObjectParentPaths: {
                          type: "structure",
                          members: {
                            PathToObjectIdentifiersList: {
                              shape: "S23"
                            },
                            NextToken: {}
                          }
                        },
                        ListObjectPolicies: {
                          type: "structure",
                          members: {
                            AttachedPolicyIds: {
                              shape: "S26"
                            },
                            NextToken: {}
                          }
                        },
                        ListPolicyAttachments: {
                          type: "structure",
                          members: {
                            ObjectIdentifiers: {
                              shape: "S26"
                            },
                            NextToken: {}
                          }
                        },
                        LookupPolicy: {
                          type: "structure",
                          members: {
                            PolicyToPathList: {
                              shape: "S2a"
                            },
                            NextToken: {}
                          }
                        },
                        ListIndex: {
                          type: "structure",
                          members: {
                            IndexAttachments: {
                              shape: "S20"
                            },
                            NextToken: {}
                          }
                        },
                        ListOutgoingTypedLinks: {
                          type: "structure",
                          members: {
                            TypedLinkSpecifiers: {
                              shape: "S2h"
                            },
                            NextToken: {}
                          }
                        },
                        ListIncomingTypedLinks: {
                          type: "structure",
                          members: {
                            LinkSpecifiers: {
                              shape: "S2h"
                            },
                            NextToken: {}
                          }
                        },
                        GetLinkAttributes: {
                          type: "structure",
                          members: {
                            Attributes: {
                              shape: "S5"
                            }
                          }
                        }
                      }
                    },
                    ExceptionResponse: {
                      type: "structure",
                      members: {
                        Type: {},
                        Message: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        BatchWrite: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/batchwrite",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "Operations"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Operations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreateObject: {
                      type: "structure",
                      required: [
                        "SchemaFacet",
                        "ObjectAttributeList"
                      ],
                      members: {
                        SchemaFacet: {
                          shape: "S1x"
                        },
                        ObjectAttributeList: {
                          shape: "S5"
                        },
                        ParentReference: {
                          shape: "Sf"
                        },
                        LinkName: {},
                        BatchReferenceName: {}
                      }
                    },
                    AttachObject: {
                      type: "structure",
                      required: [
                        "ParentReference",
                        "ChildReference",
                        "LinkName"
                      ],
                      members: {
                        ParentReference: {
                          shape: "Sf"
                        },
                        ChildReference: {
                          shape: "Sf"
                        },
                        LinkName: {}
                      }
                    },
                    DetachObject: {
                      type: "structure",
                      required: [
                        "ParentReference",
                        "LinkName"
                      ],
                      members: {
                        ParentReference: {
                          shape: "Sf"
                        },
                        LinkName: {},
                        BatchReferenceName: {}
                      }
                    },
                    UpdateObjectAttributes: {
                      type: "structure",
                      required: [
                        "ObjectReference",
                        "AttributeUpdates"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        AttributeUpdates: {
                          shape: "S2v"
                        }
                      }
                    },
                    DeleteObject: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    AddFacetToObject: {
                      type: "structure",
                      required: [
                        "SchemaFacet",
                        "ObjectAttributeList",
                        "ObjectReference"
                      ],
                      members: {
                        SchemaFacet: {
                          shape: "S3"
                        },
                        ObjectAttributeList: {
                          shape: "S5"
                        },
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    RemoveFacetFromObject: {
                      type: "structure",
                      required: [
                        "SchemaFacet",
                        "ObjectReference"
                      ],
                      members: {
                        SchemaFacet: {
                          shape: "S3"
                        },
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    AttachPolicy: {
                      type: "structure",
                      required: [
                        "PolicyReference",
                        "ObjectReference"
                      ],
                      members: {
                        PolicyReference: {
                          shape: "Sf"
                        },
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    DetachPolicy: {
                      type: "structure",
                      required: [
                        "PolicyReference",
                        "ObjectReference"
                      ],
                      members: {
                        PolicyReference: {
                          shape: "Sf"
                        },
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    CreateIndex: {
                      type: "structure",
                      required: [
                        "OrderedIndexedAttributeList",
                        "IsUnique"
                      ],
                      members: {
                        OrderedIndexedAttributeList: {
                          shape: "S35"
                        },
                        IsUnique: {
                          type: "boolean"
                        },
                        ParentReference: {
                          shape: "Sf"
                        },
                        LinkName: {},
                        BatchReferenceName: {}
                      }
                    },
                    AttachToIndex: {
                      type: "structure",
                      required: [
                        "IndexReference",
                        "TargetReference"
                      ],
                      members: {
                        IndexReference: {
                          shape: "Sf"
                        },
                        TargetReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    DetachFromIndex: {
                      type: "structure",
                      required: [
                        "IndexReference",
                        "TargetReference"
                      ],
                      members: {
                        IndexReference: {
                          shape: "Sf"
                        },
                        TargetReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    AttachTypedLink: {
                      type: "structure",
                      required: [
                        "SourceObjectReference",
                        "TargetObjectReference",
                        "TypedLinkFacet",
                        "Attributes"
                      ],
                      members: {
                        SourceObjectReference: {
                          shape: "Sf"
                        },
                        TargetObjectReference: {
                          shape: "Sf"
                        },
                        TypedLinkFacet: {
                          shape: "St"
                        },
                        Attributes: {
                          shape: "Sv"
                        }
                      }
                    },
                    DetachTypedLink: {
                      type: "structure",
                      required: [
                        "TypedLinkSpecifier"
                      ],
                      members: {
                        TypedLinkSpecifier: {
                          shape: "Sy"
                        }
                      }
                    },
                    UpdateLinkAttributes: {
                      type: "structure",
                      required: [
                        "TypedLinkSpecifier",
                        "AttributeUpdates"
                      ],
                      members: {
                        TypedLinkSpecifier: {
                          shape: "Sy"
                        },
                        AttributeUpdates: {
                          shape: "S3c"
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Responses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreateObject: {
                      type: "structure",
                      members: {
                        ObjectIdentifier: {}
                      }
                    },
                    AttachObject: {
                      type: "structure",
                      members: {
                        attachedObjectIdentifier: {}
                      }
                    },
                    DetachObject: {
                      type: "structure",
                      members: {
                        detachedObjectIdentifier: {}
                      }
                    },
                    UpdateObjectAttributes: {
                      type: "structure",
                      members: {
                        ObjectIdentifier: {}
                      }
                    },
                    DeleteObject: {
                      type: "structure",
                      members: {}
                    },
                    AddFacetToObject: {
                      type: "structure",
                      members: {}
                    },
                    RemoveFacetFromObject: {
                      type: "structure",
                      members: {}
                    },
                    AttachPolicy: {
                      type: "structure",
                      members: {}
                    },
                    DetachPolicy: {
                      type: "structure",
                      members: {}
                    },
                    CreateIndex: {
                      type: "structure",
                      members: {
                        ObjectIdentifier: {}
                      }
                    },
                    AttachToIndex: {
                      type: "structure",
                      members: {
                        AttachedObjectIdentifier: {}
                      }
                    },
                    DetachFromIndex: {
                      type: "structure",
                      members: {
                        DetachedObjectIdentifier: {}
                      }
                    },
                    AttachTypedLink: {
                      type: "structure",
                      members: {
                        TypedLinkSpecifier: {
                          shape: "Sy"
                        }
                      }
                    },
                    DetachTypedLink: {
                      type: "structure",
                      members: {}
                    },
                    UpdateLinkAttributes: {
                      type: "structure",
                      members: {}
                    }
                  }
                }
              }
            }
          }
        },
        CreateDirectory: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/directory/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "SchemaArn"
            ],
            members: {
              Name: {},
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DirectoryArn",
              "Name",
              "ObjectIdentifier",
              "AppliedSchemaArn"
            ],
            members: {
              DirectoryArn: {},
              Name: {},
              ObjectIdentifier: {},
              AppliedSchemaArn: {}
            }
          }
        },
        CreateFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/facet/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name",
              "ObjectType"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {},
              Attributes: {
                shape: "S42"
              },
              ObjectType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateIndex: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/index",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "OrderedIndexedAttributeList",
              "IsUnique"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              OrderedIndexedAttributeList: {
                shape: "S35"
              },
              IsUnique: {
                type: "boolean"
              },
              ParentReference: {
                shape: "Sf"
              },
              LinkName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectIdentifier: {}
            }
          }
        },
        CreateObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "SchemaFacets"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              SchemaFacets: {
                shape: "S1x"
              },
              ObjectAttributeList: {
                shape: "S5"
              },
              ParentReference: {
                shape: "Sf"
              },
              LinkName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectIdentifier: {}
            }
          }
        },
        CreateSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArn: {}
            }
          }
        },
        CreateTypedLinkFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Facet"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Facet: {
                type: "structure",
                required: [
                  "Name",
                  "Attributes",
                  "IdentityAttributeOrder"
                ],
                members: {
                  Name: {},
                  Attributes: {
                    shape: "S4q"
                  },
                  IdentityAttributeOrder: {
                    shape: "S1a"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDirectory: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/directory",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {}
            }
          }
        },
        DeleteFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/facet/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArn: {}
            }
          }
        },
        DeleteTypedLinkFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DetachFromIndex: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/index/detach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "IndexReference",
              "TargetReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              IndexReference: {
                shape: "Sf"
              },
              TargetReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DetachedObjectIdentifier: {}
            }
          }
        },
        DetachObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/detach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ParentReference",
              "LinkName"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ParentReference: {
                shape: "Sf"
              },
              LinkName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DetachedObjectIdentifier: {}
            }
          }
        },
        DetachPolicy: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/policy/detach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "PolicyReference",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              PolicyReference: {
                shape: "Sf"
              },
              ObjectReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DetachTypedLink: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/detach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "TypedLinkSpecifier"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              TypedLinkSpecifier: {
                shape: "Sy"
              }
            }
          }
        },
        DisableDirectory: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/directory/disable",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {}
            }
          }
        },
        EnableDirectory: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/directory/enable",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {}
            }
          }
        },
        GetAppliedSchemaVersion: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/getappliedschema",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn"
            ],
            members: {
              SchemaArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AppliedSchemaArn: {}
            }
          }
        },
        GetDirectory: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/directory/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Directory"
            ],
            members: {
              Directory: {
                shape: "S5i"
              }
            }
          }
        },
        GetFacet: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/facet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Facet: {
                type: "structure",
                members: {
                  Name: {},
                  ObjectType: {}
                }
              }
            }
          }
        },
        GetLinkAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/attributes/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "TypedLinkSpecifier",
              "AttributeNames"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              TypedLinkSpecifier: {
                shape: "Sy"
              },
              AttributeNames: {
                shape: "S1a"
              },
              ConsistencyLevel: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S5"
              }
            }
          }
        },
        GetObjectAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/attributes/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference",
              "SchemaFacet",
              "AttributeNames"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              },
              SchemaFacet: {
                shape: "S3"
              },
              AttributeNames: {
                shape: "S1a"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S5"
              }
            }
          }
        },
        GetObjectInformation: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/information",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaFacets: {
                shape: "S1x"
              },
              ObjectIdentifier: {}
            }
          }
        },
        GetSchemaAsJson: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/json",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Document: {}
            }
          }
        },
        GetTypedLinkFacetInformation: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityAttributeOrder: {
                shape: "S1a"
              }
            }
          }
        },
        ListAppliedSchemaArns: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/applied",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {},
              SchemaArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArns: {
                shape: "S61"
              },
              NextToken: {}
            }
          }
        },
        ListAttachedIndices: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/indices",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "TargetReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              TargetReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IndexAttachments: {
                shape: "S20"
              },
              NextToken: {}
            }
          }
        },
        ListDevelopmentSchemaArns: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/development",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArns: {
                shape: "S61"
              },
              NextToken: {}
            }
          }
        },
        ListDirectories: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/directory/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              state: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Directories"
            ],
            members: {
              Directories: {
                type: "list",
                member: {
                  shape: "S5i"
                }
              },
              NextToken: {}
            }
          }
        },
        ListFacetAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/facet/attributes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S42"
              },
              NextToken: {}
            }
          }
        },
        ListFacetNames: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/facet/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FacetNames: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListIncomingTypedLinks: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/incoming",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              FilterAttributeRanges: {
                shape: "S1k"
              },
              FilterTypedLink: {
                shape: "St"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LinkSpecifiers: {
                shape: "S2h"
              },
              NextToken: {}
            }
          }
        },
        ListIndex: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/index/targets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "IndexReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              RangesOnIndexedValues: {
                shape: "S1f"
              },
              IndexReference: {
                shape: "Sf"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IndexAttachments: {
                shape: "S20"
              },
              NextToken: {}
            }
          }
        },
        ListObjectAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/attributes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              },
              FacetFilter: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S5"
              },
              NextToken: {}
            }
          }
        },
        ListObjectChildren: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/children",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Children: {
                shape: "S1v"
              },
              NextToken: {}
            }
          }
        },
        ListObjectParentPaths: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/parentpaths",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PathToObjectIdentifiersList: {
                shape: "S23"
              },
              NextToken: {}
            }
          }
        },
        ListObjectParents: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/parent",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Parents: {
                type: "map",
                key: {},
                value: {}
              },
              NextToken: {}
            }
          }
        },
        ListObjectPolicies: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AttachedPolicyIds: {
                shape: "S26"
              },
              NextToken: {}
            }
          }
        },
        ListOutgoingTypedLinks: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/outgoing",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              FilterAttributeRanges: {
                shape: "S1k"
              },
              FilterTypedLink: {
                shape: "St"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TypedLinkSpecifiers: {
                shape: "S2h"
              },
              NextToken: {}
            }
          }
        },
        ListPolicyAttachments: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/policy/attachment",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "PolicyReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              PolicyReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectIdentifiers: {
                shape: "S26"
              },
              NextToken: {}
            }
          }
        },
        ListPublishedSchemaArns: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/published",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              SchemaArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArns: {
                shape: "S61"
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/tags",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S72"
              },
              NextToken: {}
            }
          }
        },
        ListTypedLinkFacetAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet/attributes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S4q"
              },
              NextToken: {}
            }
          }
        },
        ListTypedLinkFacetNames: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FacetNames: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        LookupPolicy: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/policy/lookup",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyToPathList: {
                shape: "S2a"
              },
              NextToken: {}
            }
          }
        },
        PublishSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/publish",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DevelopmentSchemaArn",
              "Version"
            ],
            members: {
              DevelopmentSchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Version: {},
              MinorVersion: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PublishedSchemaArn: {}
            }
          }
        },
        PutSchemaFromJson: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/json",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Document"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Document: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          }
        },
        RemoveFacetFromObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/facets/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "SchemaFacet",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              SchemaFacet: {
                shape: "S3"
              },
              ObjectReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/tags/add",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S72"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/tags/remove",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/facet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {},
              AttributeUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Attribute: {
                      shape: "S43"
                    },
                    Action: {}
                  }
                }
              },
              ObjectType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLinkAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/attributes/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "TypedLinkSpecifier",
              "AttributeUpdates"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              TypedLinkSpecifier: {
                shape: "Sy"
              },
              AttributeUpdates: {
                shape: "S3c"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateObjectAttributes: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference",
              "AttributeUpdates"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              AttributeUpdates: {
                shape: "S2v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectIdentifier: {}
            }
          }
        },
        UpdateSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArn: {}
            }
          }
        },
        UpdateTypedLinkFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name",
              "AttributeUpdates",
              "IdentityAttributeOrder"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {},
              AttributeUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Attribute",
                    "Action"
                  ],
                  members: {
                    Attribute: {
                      shape: "S4r"
                    },
                    Action: {}
                  }
                }
              },
              IdentityAttributeOrder: {
                shape: "S1a"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpgradeAppliedSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/upgradeapplied",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PublishedSchemaArn",
              "DirectoryArn"
            ],
            members: {
              PublishedSchemaArn: {},
              DirectoryArn: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpgradedSchemaArn: {},
              DirectoryArn: {}
            }
          }
        },
        UpgradePublishedSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/upgradepublished",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DevelopmentSchemaArn",
              "PublishedSchemaArn",
              "MinorVersion"
            ],
            members: {
              DevelopmentSchemaArn: {},
              PublishedSchemaArn: {},
              MinorVersion: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpgradedSchemaArn: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          members: {
            SchemaArn: {},
            FacetName: {}
          }
        },
        S5: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {
                shape: "S7"
              },
              Value: {
                shape: "S9"
              }
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "SchemaArn",
            "FacetName",
            "Name"
          ],
          members: {
            SchemaArn: {},
            FacetName: {},
            Name: {}
          }
        },
        S9: {
          type: "structure",
          members: {
            StringValue: {},
            BinaryValue: {
              type: "blob"
            },
            BooleanValue: {
              type: "boolean"
            },
            NumberValue: {},
            DatetimeValue: {
              type: "timestamp"
            }
          }
        },
        Sf: {
          type: "structure",
          members: {
            Selector: {}
          }
        },
        St: {
          type: "structure",
          required: [
            "SchemaArn",
            "TypedLinkName"
          ],
          members: {
            SchemaArn: {},
            TypedLinkName: {}
          }
        },
        Sv: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AttributeName",
              "Value"
            ],
            members: {
              AttributeName: {},
              Value: {
                shape: "S9"
              }
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "TypedLinkFacet",
            "SourceObjectReference",
            "TargetObjectReference",
            "IdentityAttributeValues"
          ],
          members: {
            TypedLinkFacet: {
              shape: "St"
            },
            SourceObjectReference: {
              shape: "Sf"
            },
            TargetObjectReference: {
              shape: "Sf"
            },
            IdentityAttributeValues: {
              shape: "Sv"
            }
          }
        },
        S1a: {
          type: "list",
          member: {}
        },
        S1f: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AttributeKey: {
                shape: "S7"
              },
              Range: {
                shape: "S1h"
              }
            }
          }
        },
        S1h: {
          type: "structure",
          required: [
            "StartMode",
            "EndMode"
          ],
          members: {
            StartMode: {},
            StartValue: {
              shape: "S9"
            },
            EndMode: {},
            EndValue: {
              shape: "S9"
            }
          }
        },
        S1k: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Range"
            ],
            members: {
              AttributeName: {},
              Range: {
                shape: "S1h"
              }
            }
          }
        },
        S1v: {
          type: "map",
          key: {},
          value: {}
        },
        S1x: {
          type: "list",
          member: {
            shape: "S3"
          }
        },
        S20: {
          type: "list",
          member: {
            type: "structure",
            members: {
              IndexedAttributes: {
                shape: "S5"
              },
              ObjectIdentifier: {}
            }
          }
        },
        S23: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Path: {},
              ObjectIdentifiers: {
                shape: "S26"
              }
            }
          }
        },
        S26: {
          type: "list",
          member: {}
        },
        S2a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Path: {},
              Policies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PolicyId: {},
                    ObjectIdentifier: {},
                    PolicyType: {}
                  }
                }
              }
            }
          }
        },
        S2h: {
          type: "list",
          member: {
            shape: "Sy"
          }
        },
        S2v: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ObjectAttributeKey: {
                shape: "S7"
              },
              ObjectAttributeAction: {
                type: "structure",
                members: {
                  ObjectAttributeActionType: {},
                  ObjectAttributeUpdateValue: {
                    shape: "S9"
                  }
                }
              }
            }
          }
        },
        S35: {
          type: "list",
          member: {
            shape: "S7"
          }
        },
        S3c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AttributeKey: {
                shape: "S7"
              },
              AttributeAction: {
                type: "structure",
                members: {
                  AttributeActionType: {},
                  AttributeUpdateValue: {
                    shape: "S9"
                  }
                }
              }
            }
          }
        },
        S42: {
          type: "list",
          member: {
            shape: "S43"
          }
        },
        S43: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            AttributeDefinition: {
              type: "structure",
              required: [
                "Type"
              ],
              members: {
                Type: {},
                DefaultValue: {
                  shape: "S9"
                },
                IsImmutable: {
                  type: "boolean"
                },
                Rules: {
                  shape: "S46"
                }
              }
            },
            AttributeReference: {
              type: "structure",
              required: [
                "TargetFacetName",
                "TargetAttributeName"
              ],
              members: {
                TargetFacetName: {},
                TargetAttributeName: {}
              }
            },
            RequiredBehavior: {}
          }
        },
        S46: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Type: {},
              Parameters: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        S4q: {
          type: "list",
          member: {
            shape: "S4r"
          }
        },
        S4r: {
          type: "structure",
          required: [
            "Name",
            "Type",
            "RequiredBehavior"
          ],
          members: {
            Name: {},
            Type: {},
            DefaultValue: {
              shape: "S9"
            },
            IsImmutable: {
              type: "boolean"
            },
            Rules: {
              shape: "S46"
            },
            RequiredBehavior: {}
          }
        },
        S5i: {
          type: "structure",
          members: {
            Name: {},
            DirectoryArn: {},
            State: {},
            CreationDateTime: {
              type: "timestamp"
            }
          }
        },
        S61: {
          type: "list",
          member: {}
        },
        S72: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/clouddirectory-2016-05-10.paginators.json
var require_clouddirectory_2016_05_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/clouddirectory-2016-05-10.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAppliedSchemaArns: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAttachedIndices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDevelopmentSchemaArns: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDirectories: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListFacetAttributes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListFacetNames: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListIndex: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjectAttributes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjectChildren: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjectParentPaths: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjectParents: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjectPolicies: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPolicyAttachments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPublishedSchemaArns: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTypedLinkFacetAttributes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTypedLinkFacetNames: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        LookupPolicy: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/clouddirectory-2017-01-11.min.json
var require_clouddirectory_2017_01_11_min = __commonJS({
  "node_modules/aws-sdk/apis/clouddirectory-2017-01-11.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-01-11",
        endpointPrefix: "clouddirectory",
        protocol: "rest-json",
        serviceFullName: "Amazon CloudDirectory",
        serviceId: "CloudDirectory",
        signatureVersion: "v4",
        signingName: "clouddirectory",
        uid: "clouddirectory-2017-01-11"
      },
      operations: {
        AddFacetToObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/facets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "SchemaFacet",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              SchemaFacet: {
                shape: "S3"
              },
              ObjectAttributeList: {
                shape: "S5"
              },
              ObjectReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ApplySchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/apply",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PublishedSchemaArn",
              "DirectoryArn"
            ],
            members: {
              PublishedSchemaArn: {},
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppliedSchemaArn: {},
              DirectoryArn: {}
            }
          }
        },
        AttachObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/attach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ParentReference",
              "ChildReference",
              "LinkName"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ParentReference: {
                shape: "Sf"
              },
              ChildReference: {
                shape: "Sf"
              },
              LinkName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AttachedObjectIdentifier: {}
            }
          }
        },
        AttachPolicy: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/policy/attach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "PolicyReference",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              PolicyReference: {
                shape: "Sf"
              },
              ObjectReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AttachToIndex: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/index/attach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "IndexReference",
              "TargetReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              IndexReference: {
                shape: "Sf"
              },
              TargetReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AttachedObjectIdentifier: {}
            }
          }
        },
        AttachTypedLink: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/attach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "SourceObjectReference",
              "TargetObjectReference",
              "TypedLinkFacet",
              "Attributes"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              SourceObjectReference: {
                shape: "Sf"
              },
              TargetObjectReference: {
                shape: "Sf"
              },
              TypedLinkFacet: {
                shape: "St"
              },
              Attributes: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TypedLinkSpecifier: {
                shape: "Sy"
              }
            }
          }
        },
        BatchRead: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/batchread",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "Operations"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Operations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ListObjectAttributes: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        },
                        FacetFilter: {
                          shape: "S3"
                        }
                      }
                    },
                    ListObjectChildren: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListAttachedIndices: {
                      type: "structure",
                      required: [
                        "TargetReference"
                      ],
                      members: {
                        TargetReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListObjectParentPaths: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    GetObjectInformation: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    GetObjectAttributes: {
                      type: "structure",
                      required: [
                        "ObjectReference",
                        "SchemaFacet",
                        "AttributeNames"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        SchemaFacet: {
                          shape: "S3"
                        },
                        AttributeNames: {
                          shape: "S1a"
                        }
                      }
                    },
                    ListObjectParents: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListObjectPolicies: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListPolicyAttachments: {
                      type: "structure",
                      required: [
                        "PolicyReference"
                      ],
                      members: {
                        PolicyReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    LookupPolicy: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListIndex: {
                      type: "structure",
                      required: [
                        "IndexReference"
                      ],
                      members: {
                        RangesOnIndexedValues: {
                          shape: "S1g"
                        },
                        IndexReference: {
                          shape: "Sf"
                        },
                        MaxResults: {
                          type: "integer"
                        },
                        NextToken: {}
                      }
                    },
                    ListOutgoingTypedLinks: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        FilterAttributeRanges: {
                          shape: "S1l"
                        },
                        FilterTypedLink: {
                          shape: "St"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    ListIncomingTypedLinks: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        FilterAttributeRanges: {
                          shape: "S1l"
                        },
                        FilterTypedLink: {
                          shape: "St"
                        },
                        NextToken: {},
                        MaxResults: {
                          type: "integer"
                        }
                      }
                    },
                    GetLinkAttributes: {
                      type: "structure",
                      required: [
                        "TypedLinkSpecifier",
                        "AttributeNames"
                      ],
                      members: {
                        TypedLinkSpecifier: {
                          shape: "Sy"
                        },
                        AttributeNames: {
                          shape: "S1a"
                        }
                      }
                    }
                  }
                }
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Responses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SuccessfulResponse: {
                      type: "structure",
                      members: {
                        ListObjectAttributes: {
                          type: "structure",
                          members: {
                            Attributes: {
                              shape: "S5"
                            },
                            NextToken: {}
                          }
                        },
                        ListObjectChildren: {
                          type: "structure",
                          members: {
                            Children: {
                              shape: "S1w"
                            },
                            NextToken: {}
                          }
                        },
                        GetObjectInformation: {
                          type: "structure",
                          members: {
                            SchemaFacets: {
                              shape: "S1y"
                            },
                            ObjectIdentifier: {}
                          }
                        },
                        GetObjectAttributes: {
                          type: "structure",
                          members: {
                            Attributes: {
                              shape: "S5"
                            }
                          }
                        },
                        ListAttachedIndices: {
                          type: "structure",
                          members: {
                            IndexAttachments: {
                              shape: "S21"
                            },
                            NextToken: {}
                          }
                        },
                        ListObjectParentPaths: {
                          type: "structure",
                          members: {
                            PathToObjectIdentifiersList: {
                              shape: "S24"
                            },
                            NextToken: {}
                          }
                        },
                        ListObjectPolicies: {
                          type: "structure",
                          members: {
                            AttachedPolicyIds: {
                              shape: "S27"
                            },
                            NextToken: {}
                          }
                        },
                        ListPolicyAttachments: {
                          type: "structure",
                          members: {
                            ObjectIdentifiers: {
                              shape: "S27"
                            },
                            NextToken: {}
                          }
                        },
                        LookupPolicy: {
                          type: "structure",
                          members: {
                            PolicyToPathList: {
                              shape: "S2b"
                            },
                            NextToken: {}
                          }
                        },
                        ListIndex: {
                          type: "structure",
                          members: {
                            IndexAttachments: {
                              shape: "S21"
                            },
                            NextToken: {}
                          }
                        },
                        ListOutgoingTypedLinks: {
                          type: "structure",
                          members: {
                            TypedLinkSpecifiers: {
                              shape: "S2i"
                            },
                            NextToken: {}
                          }
                        },
                        ListIncomingTypedLinks: {
                          type: "structure",
                          members: {
                            LinkSpecifiers: {
                              shape: "S2i"
                            },
                            NextToken: {}
                          }
                        },
                        GetLinkAttributes: {
                          type: "structure",
                          members: {
                            Attributes: {
                              shape: "S5"
                            }
                          }
                        },
                        ListObjectParents: {
                          type: "structure",
                          members: {
                            ParentLinks: {
                              shape: "S2m"
                            },
                            NextToken: {}
                          }
                        }
                      }
                    },
                    ExceptionResponse: {
                      type: "structure",
                      members: {
                        Type: {},
                        Message: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        BatchWrite: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/batchwrite",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "Operations"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Operations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreateObject: {
                      type: "structure",
                      required: [
                        "SchemaFacet",
                        "ObjectAttributeList"
                      ],
                      members: {
                        SchemaFacet: {
                          shape: "S1y"
                        },
                        ObjectAttributeList: {
                          shape: "S5"
                        },
                        ParentReference: {
                          shape: "Sf"
                        },
                        LinkName: {},
                        BatchReferenceName: {}
                      }
                    },
                    AttachObject: {
                      type: "structure",
                      required: [
                        "ParentReference",
                        "ChildReference",
                        "LinkName"
                      ],
                      members: {
                        ParentReference: {
                          shape: "Sf"
                        },
                        ChildReference: {
                          shape: "Sf"
                        },
                        LinkName: {}
                      }
                    },
                    DetachObject: {
                      type: "structure",
                      required: [
                        "ParentReference",
                        "LinkName"
                      ],
                      members: {
                        ParentReference: {
                          shape: "Sf"
                        },
                        LinkName: {},
                        BatchReferenceName: {}
                      }
                    },
                    UpdateObjectAttributes: {
                      type: "structure",
                      required: [
                        "ObjectReference",
                        "AttributeUpdates"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        },
                        AttributeUpdates: {
                          shape: "S2z"
                        }
                      }
                    },
                    DeleteObject: {
                      type: "structure",
                      required: [
                        "ObjectReference"
                      ],
                      members: {
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    AddFacetToObject: {
                      type: "structure",
                      required: [
                        "SchemaFacet",
                        "ObjectAttributeList",
                        "ObjectReference"
                      ],
                      members: {
                        SchemaFacet: {
                          shape: "S3"
                        },
                        ObjectAttributeList: {
                          shape: "S5"
                        },
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    RemoveFacetFromObject: {
                      type: "structure",
                      required: [
                        "SchemaFacet",
                        "ObjectReference"
                      ],
                      members: {
                        SchemaFacet: {
                          shape: "S3"
                        },
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    AttachPolicy: {
                      type: "structure",
                      required: [
                        "PolicyReference",
                        "ObjectReference"
                      ],
                      members: {
                        PolicyReference: {
                          shape: "Sf"
                        },
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    DetachPolicy: {
                      type: "structure",
                      required: [
                        "PolicyReference",
                        "ObjectReference"
                      ],
                      members: {
                        PolicyReference: {
                          shape: "Sf"
                        },
                        ObjectReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    CreateIndex: {
                      type: "structure",
                      required: [
                        "OrderedIndexedAttributeList",
                        "IsUnique"
                      ],
                      members: {
                        OrderedIndexedAttributeList: {
                          shape: "S39"
                        },
                        IsUnique: {
                          type: "boolean"
                        },
                        ParentReference: {
                          shape: "Sf"
                        },
                        LinkName: {},
                        BatchReferenceName: {}
                      }
                    },
                    AttachToIndex: {
                      type: "structure",
                      required: [
                        "IndexReference",
                        "TargetReference"
                      ],
                      members: {
                        IndexReference: {
                          shape: "Sf"
                        },
                        TargetReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    DetachFromIndex: {
                      type: "structure",
                      required: [
                        "IndexReference",
                        "TargetReference"
                      ],
                      members: {
                        IndexReference: {
                          shape: "Sf"
                        },
                        TargetReference: {
                          shape: "Sf"
                        }
                      }
                    },
                    AttachTypedLink: {
                      type: "structure",
                      required: [
                        "SourceObjectReference",
                        "TargetObjectReference",
                        "TypedLinkFacet",
                        "Attributes"
                      ],
                      members: {
                        SourceObjectReference: {
                          shape: "Sf"
                        },
                        TargetObjectReference: {
                          shape: "Sf"
                        },
                        TypedLinkFacet: {
                          shape: "St"
                        },
                        Attributes: {
                          shape: "Sv"
                        }
                      }
                    },
                    DetachTypedLink: {
                      type: "structure",
                      required: [
                        "TypedLinkSpecifier"
                      ],
                      members: {
                        TypedLinkSpecifier: {
                          shape: "Sy"
                        }
                      }
                    },
                    UpdateLinkAttributes: {
                      type: "structure",
                      required: [
                        "TypedLinkSpecifier",
                        "AttributeUpdates"
                      ],
                      members: {
                        TypedLinkSpecifier: {
                          shape: "Sy"
                        },
                        AttributeUpdates: {
                          shape: "S3g"
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Responses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreateObject: {
                      type: "structure",
                      members: {
                        ObjectIdentifier: {}
                      }
                    },
                    AttachObject: {
                      type: "structure",
                      members: {
                        attachedObjectIdentifier: {}
                      }
                    },
                    DetachObject: {
                      type: "structure",
                      members: {
                        detachedObjectIdentifier: {}
                      }
                    },
                    UpdateObjectAttributes: {
                      type: "structure",
                      members: {
                        ObjectIdentifier: {}
                      }
                    },
                    DeleteObject: {
                      type: "structure",
                      members: {}
                    },
                    AddFacetToObject: {
                      type: "structure",
                      members: {}
                    },
                    RemoveFacetFromObject: {
                      type: "structure",
                      members: {}
                    },
                    AttachPolicy: {
                      type: "structure",
                      members: {}
                    },
                    DetachPolicy: {
                      type: "structure",
                      members: {}
                    },
                    CreateIndex: {
                      type: "structure",
                      members: {
                        ObjectIdentifier: {}
                      }
                    },
                    AttachToIndex: {
                      type: "structure",
                      members: {
                        AttachedObjectIdentifier: {}
                      }
                    },
                    DetachFromIndex: {
                      type: "structure",
                      members: {
                        DetachedObjectIdentifier: {}
                      }
                    },
                    AttachTypedLink: {
                      type: "structure",
                      members: {
                        TypedLinkSpecifier: {
                          shape: "Sy"
                        }
                      }
                    },
                    DetachTypedLink: {
                      type: "structure",
                      members: {}
                    },
                    UpdateLinkAttributes: {
                      type: "structure",
                      members: {}
                    }
                  }
                }
              }
            }
          }
        },
        CreateDirectory: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/directory/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "SchemaArn"
            ],
            members: {
              Name: {},
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DirectoryArn",
              "Name",
              "ObjectIdentifier",
              "AppliedSchemaArn"
            ],
            members: {
              DirectoryArn: {},
              Name: {},
              ObjectIdentifier: {},
              AppliedSchemaArn: {}
            }
          }
        },
        CreateFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/facet/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {},
              Attributes: {
                shape: "S46"
              },
              ObjectType: {},
              FacetStyle: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateIndex: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/index",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "OrderedIndexedAttributeList",
              "IsUnique"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              OrderedIndexedAttributeList: {
                shape: "S39"
              },
              IsUnique: {
                type: "boolean"
              },
              ParentReference: {
                shape: "Sf"
              },
              LinkName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectIdentifier: {}
            }
          }
        },
        CreateObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "SchemaFacets"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              SchemaFacets: {
                shape: "S1y"
              },
              ObjectAttributeList: {
                shape: "S5"
              },
              ParentReference: {
                shape: "Sf"
              },
              LinkName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectIdentifier: {}
            }
          }
        },
        CreateSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArn: {}
            }
          }
        },
        CreateTypedLinkFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Facet"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Facet: {
                type: "structure",
                required: [
                  "Name",
                  "Attributes",
                  "IdentityAttributeOrder"
                ],
                members: {
                  Name: {},
                  Attributes: {
                    shape: "S4v"
                  },
                  IdentityAttributeOrder: {
                    shape: "S1a"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDirectory: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/directory",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {}
            }
          }
        },
        DeleteFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/facet/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArn: {}
            }
          }
        },
        DeleteTypedLinkFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DetachFromIndex: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/index/detach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "IndexReference",
              "TargetReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              IndexReference: {
                shape: "Sf"
              },
              TargetReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DetachedObjectIdentifier: {}
            }
          }
        },
        DetachObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/detach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ParentReference",
              "LinkName"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ParentReference: {
                shape: "Sf"
              },
              LinkName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DetachedObjectIdentifier: {}
            }
          }
        },
        DetachPolicy: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/policy/detach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "PolicyReference",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              PolicyReference: {
                shape: "Sf"
              },
              ObjectReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DetachTypedLink: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/detach",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "TypedLinkSpecifier"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              TypedLinkSpecifier: {
                shape: "Sy"
              }
            }
          }
        },
        DisableDirectory: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/directory/disable",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {}
            }
          }
        },
        EnableDirectory: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/directory/enable",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {}
            }
          }
        },
        GetAppliedSchemaVersion: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/getappliedschema",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn"
            ],
            members: {
              SchemaArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AppliedSchemaArn: {}
            }
          }
        },
        GetDirectory: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/directory/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Directory"
            ],
            members: {
              Directory: {
                shape: "S5n"
              }
            }
          }
        },
        GetFacet: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/facet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Facet: {
                type: "structure",
                members: {
                  Name: {},
                  ObjectType: {},
                  FacetStyle: {}
                }
              }
            }
          }
        },
        GetLinkAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/attributes/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "TypedLinkSpecifier",
              "AttributeNames"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              TypedLinkSpecifier: {
                shape: "Sy"
              },
              AttributeNames: {
                shape: "S1a"
              },
              ConsistencyLevel: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S5"
              }
            }
          }
        },
        GetObjectAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/attributes/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference",
              "SchemaFacet",
              "AttributeNames"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              },
              SchemaFacet: {
                shape: "S3"
              },
              AttributeNames: {
                shape: "S1a"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S5"
              }
            }
          }
        },
        GetObjectInformation: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/information",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaFacets: {
                shape: "S1y"
              },
              ObjectIdentifier: {}
            }
          }
        },
        GetSchemaAsJson: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/json",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Document: {}
            }
          }
        },
        GetTypedLinkFacetInformation: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityAttributeOrder: {
                shape: "S1a"
              }
            }
          }
        },
        ListAppliedSchemaArns: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/applied",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn"
            ],
            members: {
              DirectoryArn: {},
              SchemaArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArns: {
                shape: "S66"
              },
              NextToken: {}
            }
          }
        },
        ListAttachedIndices: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/indices",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "TargetReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              TargetReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IndexAttachments: {
                shape: "S21"
              },
              NextToken: {}
            }
          }
        },
        ListDevelopmentSchemaArns: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/development",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArns: {
                shape: "S66"
              },
              NextToken: {}
            }
          }
        },
        ListDirectories: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/directory/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              state: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Directories"
            ],
            members: {
              Directories: {
                type: "list",
                member: {
                  shape: "S5n"
                }
              },
              NextToken: {}
            }
          }
        },
        ListFacetAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/facet/attributes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S46"
              },
              NextToken: {}
            }
          }
        },
        ListFacetNames: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/facet/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FacetNames: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListIncomingTypedLinks: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/incoming",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              FilterAttributeRanges: {
                shape: "S1l"
              },
              FilterTypedLink: {
                shape: "St"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LinkSpecifiers: {
                shape: "S2i"
              },
              NextToken: {}
            }
          }
        },
        ListIndex: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/index/targets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "IndexReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              RangesOnIndexedValues: {
                shape: "S1g"
              },
              IndexReference: {
                shape: "Sf"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IndexAttachments: {
                shape: "S21"
              },
              NextToken: {}
            }
          }
        },
        ListManagedSchemaArns: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/managed",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              SchemaArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArns: {
                shape: "S66"
              },
              NextToken: {}
            }
          }
        },
        ListObjectAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/attributes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              },
              FacetFilter: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S5"
              },
              NextToken: {}
            }
          }
        },
        ListObjectChildren: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/children",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Children: {
                shape: "S1w"
              },
              NextToken: {}
            }
          }
        },
        ListObjectParentPaths: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/parentpaths",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PathToObjectIdentifiersList: {
                shape: "S24"
              },
              NextToken: {}
            }
          }
        },
        ListObjectParents: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/parent",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              },
              IncludeAllLinksToEachParent: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Parents: {
                type: "map",
                key: {},
                value: {}
              },
              NextToken: {},
              ParentLinks: {
                shape: "S2m"
              }
            }
          }
        },
        ListObjectPolicies: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/object/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AttachedPolicyIds: {
                shape: "S27"
              },
              NextToken: {}
            }
          }
        },
        ListOutgoingTypedLinks: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/outgoing",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              FilterAttributeRanges: {
                shape: "S1l"
              },
              FilterTypedLink: {
                shape: "St"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TypedLinkSpecifiers: {
                shape: "S2i"
              },
              NextToken: {}
            }
          }
        },
        ListPolicyAttachments: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/policy/attachment",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "PolicyReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              PolicyReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ConsistencyLevel: {
                location: "header",
                locationName: "x-amz-consistency-level"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectIdentifiers: {
                shape: "S27"
              },
              NextToken: {}
            }
          }
        },
        ListPublishedSchemaArns: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/schema/published",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              SchemaArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArns: {
                shape: "S66"
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/tags",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S79"
              },
              NextToken: {}
            }
          }
        },
        ListTypedLinkFacetAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet/attributes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S4v"
              },
              NextToken: {}
            }
          }
        },
        ListTypedLinkFacetNames: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FacetNames: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        LookupPolicy: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/policy/lookup",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyToPathList: {
                shape: "S2b"
              },
              NextToken: {}
            }
          }
        },
        PublishSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/publish",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DevelopmentSchemaArn",
              "Version"
            ],
            members: {
              DevelopmentSchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Version: {},
              MinorVersion: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PublishedSchemaArn: {}
            }
          }
        },
        PutSchemaFromJson: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/json",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Document"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Document: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          }
        },
        RemoveFacetFromObject: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/facets/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "SchemaFacet",
              "ObjectReference"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              SchemaFacet: {
                shape: "S3"
              },
              ObjectReference: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/tags/add",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S79"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/tags/remove",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/facet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {},
              AttributeUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Attribute: {
                      shape: "S47"
                    },
                    Action: {}
                  }
                }
              },
              ObjectType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLinkAttributes: {
          http: {
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/attributes/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "TypedLinkSpecifier",
              "AttributeUpdates"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              TypedLinkSpecifier: {
                shape: "Sy"
              },
              AttributeUpdates: {
                shape: "S3g"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateObjectAttributes: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/object/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DirectoryArn",
              "ObjectReference",
              "AttributeUpdates"
            ],
            members: {
              DirectoryArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              ObjectReference: {
                shape: "Sf"
              },
              AttributeUpdates: {
                shape: "S2z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectIdentifier: {}
            }
          }
        },
        UpdateSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArn: {}
            }
          }
        },
        UpdateTypedLinkFacet: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/typedlink/facet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SchemaArn",
              "Name",
              "AttributeUpdates",
              "IdentityAttributeOrder"
            ],
            members: {
              SchemaArn: {
                location: "header",
                locationName: "x-amz-data-partition"
              },
              Name: {},
              AttributeUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Attribute",
                    "Action"
                  ],
                  members: {
                    Attribute: {
                      shape: "S4w"
                    },
                    Action: {}
                  }
                }
              },
              IdentityAttributeOrder: {
                shape: "S1a"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpgradeAppliedSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/upgradeapplied",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PublishedSchemaArn",
              "DirectoryArn"
            ],
            members: {
              PublishedSchemaArn: {},
              DirectoryArn: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpgradedSchemaArn: {},
              DirectoryArn: {}
            }
          }
        },
        UpgradePublishedSchema: {
          http: {
            method: "PUT",
            requestUri: "/amazonclouddirectory/2017-01-11/schema/upgradepublished",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DevelopmentSchemaArn",
              "PublishedSchemaArn",
              "MinorVersion"
            ],
            members: {
              DevelopmentSchemaArn: {},
              PublishedSchemaArn: {},
              MinorVersion: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpgradedSchemaArn: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          members: {
            SchemaArn: {},
            FacetName: {}
          }
        },
        S5: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {
                shape: "S7"
              },
              Value: {
                shape: "S9"
              }
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "SchemaArn",
            "FacetName",
            "Name"
          ],
          members: {
            SchemaArn: {},
            FacetName: {},
            Name: {}
          }
        },
        S9: {
          type: "structure",
          members: {
            StringValue: {},
            BinaryValue: {
              type: "blob"
            },
            BooleanValue: {
              type: "boolean"
            },
            NumberValue: {},
            DatetimeValue: {
              type: "timestamp"
            }
          }
        },
        Sf: {
          type: "structure",
          members: {
            Selector: {}
          }
        },
        St: {
          type: "structure",
          required: [
            "SchemaArn",
            "TypedLinkName"
          ],
          members: {
            SchemaArn: {},
            TypedLinkName: {}
          }
        },
        Sv: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AttributeName",
              "Value"
            ],
            members: {
              AttributeName: {},
              Value: {
                shape: "S9"
              }
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "TypedLinkFacet",
            "SourceObjectReference",
            "TargetObjectReference",
            "IdentityAttributeValues"
          ],
          members: {
            TypedLinkFacet: {
              shape: "St"
            },
            SourceObjectReference: {
              shape: "Sf"
            },
            TargetObjectReference: {
              shape: "Sf"
            },
            IdentityAttributeValues: {
              shape: "Sv"
            }
          }
        },
        S1a: {
          type: "list",
          member: {}
        },
        S1g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AttributeKey: {
                shape: "S7"
              },
              Range: {
                shape: "S1i"
              }
            }
          }
        },
        S1i: {
          type: "structure",
          required: [
            "StartMode",
            "EndMode"
          ],
          members: {
            StartMode: {},
            StartValue: {
              shape: "S9"
            },
            EndMode: {},
            EndValue: {
              shape: "S9"
            }
          }
        },
        S1l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Range"
            ],
            members: {
              AttributeName: {},
              Range: {
                shape: "S1i"
              }
            }
          }
        },
        S1w: {
          type: "map",
          key: {},
          value: {}
        },
        S1y: {
          type: "list",
          member: {
            shape: "S3"
          }
        },
        S21: {
          type: "list",
          member: {
            type: "structure",
            members: {
              IndexedAttributes: {
                shape: "S5"
              },
              ObjectIdentifier: {}
            }
          }
        },
        S24: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Path: {},
              ObjectIdentifiers: {
                shape: "S27"
              }
            }
          }
        },
        S27: {
          type: "list",
          member: {}
        },
        S2b: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Path: {},
              Policies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PolicyId: {},
                    ObjectIdentifier: {},
                    PolicyType: {}
                  }
                }
              }
            }
          }
        },
        S2i: {
          type: "list",
          member: {
            shape: "Sy"
          }
        },
        S2m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ObjectIdentifier: {},
              LinkName: {}
            }
          }
        },
        S2z: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ObjectAttributeKey: {
                shape: "S7"
              },
              ObjectAttributeAction: {
                type: "structure",
                members: {
                  ObjectAttributeActionType: {},
                  ObjectAttributeUpdateValue: {
                    shape: "S9"
                  }
                }
              }
            }
          }
        },
        S39: {
          type: "list",
          member: {
            shape: "S7"
          }
        },
        S3g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AttributeKey: {
                shape: "S7"
              },
              AttributeAction: {
                type: "structure",
                members: {
                  AttributeActionType: {},
                  AttributeUpdateValue: {
                    shape: "S9"
                  }
                }
              }
            }
          }
        },
        S46: {
          type: "list",
          member: {
            shape: "S47"
          }
        },
        S47: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            AttributeDefinition: {
              type: "structure",
              required: [
                "Type"
              ],
              members: {
                Type: {},
                DefaultValue: {
                  shape: "S9"
                },
                IsImmutable: {
                  type: "boolean"
                },
                Rules: {
                  shape: "S4a"
                }
              }
            },
            AttributeReference: {
              type: "structure",
              required: [
                "TargetFacetName",
                "TargetAttributeName"
              ],
              members: {
                TargetFacetName: {},
                TargetAttributeName: {}
              }
            },
            RequiredBehavior: {}
          }
        },
        S4a: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Type: {},
              Parameters: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        S4v: {
          type: "list",
          member: {
            shape: "S4w"
          }
        },
        S4w: {
          type: "structure",
          required: [
            "Name",
            "Type",
            "RequiredBehavior"
          ],
          members: {
            Name: {},
            Type: {},
            DefaultValue: {
              shape: "S9"
            },
            IsImmutable: {
              type: "boolean"
            },
            Rules: {
              shape: "S4a"
            },
            RequiredBehavior: {}
          }
        },
        S5n: {
          type: "structure",
          members: {
            Name: {},
            DirectoryArn: {},
            State: {},
            CreationDateTime: {
              type: "timestamp"
            }
          }
        },
        S66: {
          type: "list",
          member: {}
        },
        S79: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/clouddirectory-2017-01-11.paginators.json
var require_clouddirectory_2017_01_11_paginators = __commonJS({
  "node_modules/aws-sdk/apis/clouddirectory-2017-01-11.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAppliedSchemaArns: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAttachedIndices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDevelopmentSchemaArns: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDirectories: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListFacetAttributes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListFacetNames: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListIndex: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListManagedSchemaArns: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjectAttributes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjectChildren: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjectParentPaths: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjectParents: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListObjectPolicies: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPolicyAttachments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPublishedSchemaArns: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTypedLinkFacetAttributes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTypedLinkFacetNames: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        LookupPolicy: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/clouddirectory.js
var require_clouddirectory = __commonJS({
  "node_modules/aws-sdk/clients/clouddirectory.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["clouddirectory"] = {};
    AWS3.CloudDirectory = Service.defineService("clouddirectory", ["2016-05-10", "2016-05-10*", "2017-01-11"]);
    Object.defineProperty(apiLoader.services["clouddirectory"], "2016-05-10", {
      get: function get() {
        var model = require_clouddirectory_2016_05_10_min();
        model.paginators = require_clouddirectory_2016_05_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["clouddirectory"], "2017-01-11", {
      get: function get() {
        var model = require_clouddirectory_2017_01_11_min();
        model.paginators = require_clouddirectory_2017_01_11_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CloudDirectory;
  }
});

// node_modules/aws-sdk/apis/cloudformation-2010-05-15.min.json
var require_cloudformation_2010_05_15_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudformation-2010-05-15.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2010-05-15",
        endpointPrefix: "cloudformation",
        protocol: "query",
        serviceFullName: "AWS CloudFormation",
        serviceId: "CloudFormation",
        signatureVersion: "v4",
        uid: "cloudformation-2010-05-15",
        xmlNamespace: "http://cloudformation.amazonaws.com/doc/2010-05-15/"
      },
      operations: {
        ActivateType: {
          input: {
            type: "structure",
            members: {
              Type: {},
              PublicTypeArn: {},
              PublisherId: {},
              TypeName: {},
              TypeNameAlias: {},
              AutoUpdate: {
                type: "boolean"
              },
              LoggingConfig: {
                shape: "S7"
              },
              ExecutionRoleArn: {},
              VersionBump: {},
              MajorVersion: {
                type: "long"
              }
            }
          },
          output: {
            resultWrapper: "ActivateTypeResult",
            type: "structure",
            members: {
              Arn: {}
            }
          },
          idempotent: true
        },
        BatchDescribeTypeConfigurations: {
          input: {
            type: "structure",
            required: [
              "TypeConfigurationIdentifiers"
            ],
            members: {
              TypeConfigurationIdentifiers: {
                type: "list",
                member: {
                  shape: "Sg"
                }
              }
            }
          },
          output: {
            resultWrapper: "BatchDescribeTypeConfigurationsResult",
            type: "structure",
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ErrorCode: {},
                    ErrorMessage: {},
                    TypeConfigurationIdentifier: {
                      shape: "Sg"
                    }
                  }
                }
              },
              UnprocessedTypeConfigurations: {
                type: "list",
                member: {
                  shape: "Sg"
                }
              },
              TypeConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Alias: {},
                    Configuration: {},
                    LastUpdated: {
                      type: "timestamp"
                    },
                    TypeArn: {},
                    TypeName: {},
                    IsDefaultConfiguration: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        CancelUpdateStack: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              ClientRequestToken: {}
            }
          }
        },
        ContinueUpdateRollback: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              RoleARN: {},
              ResourcesToSkip: {
                type: "list",
                member: {}
              },
              ClientRequestToken: {}
            }
          },
          output: {
            resultWrapper: "ContinueUpdateRollbackResult",
            type: "structure",
            members: {}
          }
        },
        CreateChangeSet: {
          input: {
            type: "structure",
            required: [
              "StackName",
              "ChangeSetName"
            ],
            members: {
              StackName: {},
              TemplateBody: {},
              TemplateURL: {},
              UsePreviousTemplate: {
                type: "boolean"
              },
              Parameters: {
                shape: "S18"
              },
              Capabilities: {
                shape: "S1d"
              },
              ResourceTypes: {
                shape: "S1f"
              },
              RoleARN: {},
              RollbackConfiguration: {
                shape: "S1h"
              },
              NotificationARNs: {
                shape: "S1n"
              },
              Tags: {
                shape: "S1p"
              },
              ChangeSetName: {},
              ClientToken: {},
              Description: {},
              ChangeSetType: {},
              ResourcesToImport: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ResourceType",
                    "LogicalResourceId",
                    "ResourceIdentifier"
                  ],
                  members: {
                    ResourceType: {},
                    LogicalResourceId: {},
                    ResourceIdentifier: {
                      type: "map",
                      key: {},
                      value: {}
                    }
                  }
                }
              },
              IncludeNestedStacks: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateChangeSetResult",
            type: "structure",
            members: {
              Id: {},
              StackId: {}
            }
          }
        },
        CreateStack: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              TemplateBody: {},
              TemplateURL: {},
              Parameters: {
                shape: "S18"
              },
              DisableRollback: {
                type: "boolean"
              },
              RollbackConfiguration: {
                shape: "S1h"
              },
              TimeoutInMinutes: {
                type: "integer"
              },
              NotificationARNs: {
                shape: "S1n"
              },
              Capabilities: {
                shape: "S1d"
              },
              ResourceTypes: {
                shape: "S1f"
              },
              RoleARN: {},
              OnFailure: {},
              StackPolicyBody: {},
              StackPolicyURL: {},
              Tags: {
                shape: "S1p"
              },
              ClientRequestToken: {},
              EnableTerminationProtection: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateStackResult",
            type: "structure",
            members: {
              StackId: {}
            }
          }
        },
        CreateStackInstances: {
          input: {
            type: "structure",
            required: [
              "StackSetName",
              "Regions"
            ],
            members: {
              StackSetName: {},
              Accounts: {
                shape: "S2h"
              },
              DeploymentTargets: {
                shape: "S2j"
              },
              Regions: {
                shape: "S2n"
              },
              ParameterOverrides: {
                shape: "S18"
              },
              OperationPreferences: {
                shape: "S2p"
              },
              OperationId: {
                idempotencyToken: true
              },
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "CreateStackInstancesResult",
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        CreateStackSet: {
          input: {
            type: "structure",
            required: [
              "StackSetName"
            ],
            members: {
              StackSetName: {},
              Description: {},
              TemplateBody: {},
              TemplateURL: {},
              StackId: {},
              Parameters: {
                shape: "S18"
              },
              Capabilities: {
                shape: "S1d"
              },
              Tags: {
                shape: "S1p"
              },
              AdministrationRoleARN: {},
              ExecutionRoleName: {},
              PermissionModel: {},
              AutoDeployment: {
                shape: "S30"
              },
              CallAs: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            resultWrapper: "CreateStackSetResult",
            type: "structure",
            members: {
              StackSetId: {}
            }
          }
        },
        DeactivateType: {
          input: {
            type: "structure",
            members: {
              TypeName: {},
              Type: {},
              Arn: {}
            }
          },
          output: {
            resultWrapper: "DeactivateTypeResult",
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteChangeSet: {
          input: {
            type: "structure",
            required: [
              "ChangeSetName"
            ],
            members: {
              ChangeSetName: {},
              StackName: {}
            }
          },
          output: {
            resultWrapper: "DeleteChangeSetResult",
            type: "structure",
            members: {}
          }
        },
        DeleteStack: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              RetainResources: {
                type: "list",
                member: {}
              },
              RoleARN: {},
              ClientRequestToken: {}
            }
          }
        },
        DeleteStackInstances: {
          input: {
            type: "structure",
            required: [
              "StackSetName",
              "Regions",
              "RetainStacks"
            ],
            members: {
              StackSetName: {},
              Accounts: {
                shape: "S2h"
              },
              DeploymentTargets: {
                shape: "S2j"
              },
              Regions: {
                shape: "S2n"
              },
              OperationPreferences: {
                shape: "S2p"
              },
              RetainStacks: {
                type: "boolean"
              },
              OperationId: {
                idempotencyToken: true
              },
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "DeleteStackInstancesResult",
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        DeleteStackSet: {
          input: {
            type: "structure",
            required: [
              "StackSetName"
            ],
            members: {
              StackSetName: {},
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "DeleteStackSetResult",
            type: "structure",
            members: {}
          }
        },
        DeregisterType: {
          input: {
            type: "structure",
            members: {
              Arn: {},
              Type: {},
              TypeName: {},
              VersionId: {}
            }
          },
          output: {
            resultWrapper: "DeregisterTypeResult",
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DescribeAccountLimits: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeAccountLimitsResult",
            type: "structure",
            members: {
              AccountLimits: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Value: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeChangeSet: {
          input: {
            type: "structure",
            required: [
              "ChangeSetName"
            ],
            members: {
              ChangeSetName: {},
              StackName: {},
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeChangeSetResult",
            type: "structure",
            members: {
              ChangeSetName: {},
              ChangeSetId: {},
              StackId: {},
              StackName: {},
              Description: {},
              Parameters: {
                shape: "S18"
              },
              CreationTime: {
                type: "timestamp"
              },
              ExecutionStatus: {},
              Status: {},
              StatusReason: {},
              NotificationARNs: {
                shape: "S1n"
              },
              RollbackConfiguration: {
                shape: "S1h"
              },
              Capabilities: {
                shape: "S1d"
              },
              Tags: {
                shape: "S1p"
              },
              Changes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    ResourceChange: {
                      type: "structure",
                      members: {
                        Action: {},
                        LogicalResourceId: {},
                        PhysicalResourceId: {},
                        ResourceType: {},
                        Replacement: {},
                        Scope: {
                          type: "list",
                          member: {}
                        },
                        Details: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Target: {
                                type: "structure",
                                members: {
                                  Attribute: {},
                                  Name: {},
                                  RequiresRecreation: {}
                                }
                              },
                              Evaluation: {},
                              ChangeSource: {},
                              CausingEntity: {}
                            }
                          }
                        },
                        ChangeSetId: {},
                        ModuleInfo: {
                          shape: "S4f"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {},
              IncludeNestedStacks: {
                type: "boolean"
              },
              ParentChangeSetId: {},
              RootChangeSetId: {}
            }
          }
        },
        DescribePublisher: {
          input: {
            type: "structure",
            members: {
              PublisherId: {}
            }
          },
          output: {
            resultWrapper: "DescribePublisherResult",
            type: "structure",
            members: {
              PublisherId: {},
              PublisherStatus: {},
              IdentityProvider: {},
              PublisherProfile: {}
            }
          },
          idempotent: true
        },
        DescribeStackDriftDetectionStatus: {
          input: {
            type: "structure",
            required: [
              "StackDriftDetectionId"
            ],
            members: {
              StackDriftDetectionId: {}
            }
          },
          output: {
            resultWrapper: "DescribeStackDriftDetectionStatusResult",
            type: "structure",
            required: [
              "StackId",
              "StackDriftDetectionId",
              "DetectionStatus",
              "Timestamp"
            ],
            members: {
              StackId: {},
              StackDriftDetectionId: {},
              StackDriftStatus: {},
              DetectionStatus: {},
              DetectionStatusReason: {},
              DriftedStackResourceCount: {
                type: "integer"
              },
              Timestamp: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeStackEvents: {
          input: {
            type: "structure",
            members: {
              StackName: {},
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeStackEventsResult",
            type: "structure",
            members: {
              StackEvents: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "StackId",
                    "EventId",
                    "StackName",
                    "Timestamp"
                  ],
                  members: {
                    StackId: {},
                    EventId: {},
                    StackName: {},
                    LogicalResourceId: {},
                    PhysicalResourceId: {},
                    ResourceType: {},
                    Timestamp: {
                      type: "timestamp"
                    },
                    ResourceStatus: {},
                    ResourceStatusReason: {},
                    ResourceProperties: {},
                    ClientRequestToken: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeStackInstance: {
          input: {
            type: "structure",
            required: [
              "StackSetName",
              "StackInstanceAccount",
              "StackInstanceRegion"
            ],
            members: {
              StackSetName: {},
              StackInstanceAccount: {},
              StackInstanceRegion: {},
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "DescribeStackInstanceResult",
            type: "structure",
            members: {
              StackInstance: {
                type: "structure",
                members: {
                  StackSetId: {},
                  Region: {},
                  Account: {},
                  StackId: {},
                  ParameterOverrides: {
                    shape: "S18"
                  },
                  Status: {},
                  StackInstanceStatus: {
                    shape: "S56"
                  },
                  StatusReason: {},
                  OrganizationalUnitId: {},
                  DriftStatus: {},
                  LastDriftCheckTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeStackResource: {
          input: {
            type: "structure",
            required: [
              "StackName",
              "LogicalResourceId"
            ],
            members: {
              StackName: {},
              LogicalResourceId: {}
            }
          },
          output: {
            resultWrapper: "DescribeStackResourceResult",
            type: "structure",
            members: {
              StackResourceDetail: {
                type: "structure",
                required: [
                  "LogicalResourceId",
                  "ResourceType",
                  "LastUpdatedTimestamp",
                  "ResourceStatus"
                ],
                members: {
                  StackName: {},
                  StackId: {},
                  LogicalResourceId: {},
                  PhysicalResourceId: {},
                  ResourceType: {},
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  },
                  ResourceStatus: {},
                  ResourceStatusReason: {},
                  Description: {},
                  Metadata: {},
                  DriftInformation: {
                    shape: "S5d"
                  },
                  ModuleInfo: {
                    shape: "S4f"
                  }
                }
              }
            }
          }
        },
        DescribeStackResourceDrifts: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              StackResourceDriftStatusFilters: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeStackResourceDriftsResult",
            type: "structure",
            required: [
              "StackResourceDrifts"
            ],
            members: {
              StackResourceDrifts: {
                type: "list",
                member: {
                  shape: "S5k"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeStackResources: {
          input: {
            type: "structure",
            members: {
              StackName: {},
              LogicalResourceId: {},
              PhysicalResourceId: {}
            }
          },
          output: {
            resultWrapper: "DescribeStackResourcesResult",
            type: "structure",
            members: {
              StackResources: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "LogicalResourceId",
                    "ResourceType",
                    "Timestamp",
                    "ResourceStatus"
                  ],
                  members: {
                    StackName: {},
                    StackId: {},
                    LogicalResourceId: {},
                    PhysicalResourceId: {},
                    ResourceType: {},
                    Timestamp: {
                      type: "timestamp"
                    },
                    ResourceStatus: {},
                    ResourceStatusReason: {},
                    Description: {},
                    DriftInformation: {
                      shape: "S5d"
                    },
                    ModuleInfo: {
                      shape: "S4f"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeStackSet: {
          input: {
            type: "structure",
            required: [
              "StackSetName"
            ],
            members: {
              StackSetName: {},
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "DescribeStackSetResult",
            type: "structure",
            members: {
              StackSet: {
                type: "structure",
                members: {
                  StackSetName: {},
                  StackSetId: {},
                  Description: {},
                  Status: {},
                  TemplateBody: {},
                  Parameters: {
                    shape: "S18"
                  },
                  Capabilities: {
                    shape: "S1d"
                  },
                  Tags: {
                    shape: "S1p"
                  },
                  StackSetARN: {},
                  AdministrationRoleARN: {},
                  ExecutionRoleName: {},
                  StackSetDriftDetectionDetails: {
                    shape: "S64"
                  },
                  AutoDeployment: {
                    shape: "S30"
                  },
                  PermissionModel: {},
                  OrganizationalUnitIds: {
                    shape: "S2l"
                  }
                }
              }
            }
          }
        },
        DescribeStackSetOperation: {
          input: {
            type: "structure",
            required: [
              "StackSetName",
              "OperationId"
            ],
            members: {
              StackSetName: {},
              OperationId: {},
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "DescribeStackSetOperationResult",
            type: "structure",
            members: {
              StackSetOperation: {
                type: "structure",
                members: {
                  OperationId: {},
                  StackSetId: {},
                  Action: {},
                  Status: {},
                  OperationPreferences: {
                    shape: "S2p"
                  },
                  RetainStacks: {
                    type: "boolean"
                  },
                  AdministrationRoleARN: {},
                  ExecutionRoleName: {},
                  CreationTimestamp: {
                    type: "timestamp"
                  },
                  EndTimestamp: {
                    type: "timestamp"
                  },
                  DeploymentTargets: {
                    shape: "S2j"
                  },
                  StackSetDriftDetectionDetails: {
                    shape: "S64"
                  }
                }
              }
            }
          }
        },
        DescribeStacks: {
          input: {
            type: "structure",
            members: {
              StackName: {},
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeStacksResult",
            type: "structure",
            members: {
              Stacks: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "StackName",
                    "CreationTime",
                    "StackStatus"
                  ],
                  members: {
                    StackId: {},
                    StackName: {},
                    ChangeSetId: {},
                    Description: {},
                    Parameters: {
                      shape: "S18"
                    },
                    CreationTime: {
                      type: "timestamp"
                    },
                    DeletionTime: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    },
                    RollbackConfiguration: {
                      shape: "S1h"
                    },
                    StackStatus: {},
                    StackStatusReason: {},
                    DisableRollback: {
                      type: "boolean"
                    },
                    NotificationARNs: {
                      shape: "S1n"
                    },
                    TimeoutInMinutes: {
                      type: "integer"
                    },
                    Capabilities: {
                      shape: "S1d"
                    },
                    Outputs: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          OutputKey: {},
                          OutputValue: {},
                          Description: {},
                          ExportName: {}
                        }
                      }
                    },
                    RoleARN: {},
                    Tags: {
                      shape: "S1p"
                    },
                    EnableTerminationProtection: {
                      type: "boolean"
                    },
                    ParentId: {},
                    RootId: {},
                    DriftInformation: {
                      type: "structure",
                      required: [
                        "StackDriftStatus"
                      ],
                      members: {
                        StackDriftStatus: {},
                        LastCheckTimestamp: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeType: {
          input: {
            type: "structure",
            members: {
              Type: {},
              TypeName: {},
              Arn: {},
              VersionId: {},
              PublisherId: {},
              PublicVersionNumber: {}
            }
          },
          output: {
            resultWrapper: "DescribeTypeResult",
            type: "structure",
            members: {
              Arn: {},
              Type: {},
              TypeName: {},
              DefaultVersionId: {},
              IsDefaultVersion: {
                type: "boolean"
              },
              TypeTestsStatus: {},
              TypeTestsStatusDescription: {},
              Description: {},
              Schema: {},
              ProvisioningType: {},
              DeprecatedStatus: {},
              LoggingConfig: {
                shape: "S7"
              },
              RequiredActivatedTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TypeNameAlias: {},
                    OriginalTypeName: {},
                    PublisherId: {},
                    SupportedMajorVersions: {
                      type: "list",
                      member: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              ExecutionRoleArn: {},
              Visibility: {},
              SourceUrl: {},
              DocumentationUrl: {},
              LastUpdated: {
                type: "timestamp"
              },
              TimeCreated: {
                type: "timestamp"
              },
              ConfigurationSchema: {},
              PublisherId: {},
              OriginalTypeName: {},
              OriginalTypeArn: {},
              PublicVersionNumber: {},
              LatestPublicVersion: {},
              IsActivated: {
                type: "boolean"
              },
              AutoUpdate: {
                type: "boolean"
              }
            }
          },
          idempotent: true
        },
        DescribeTypeRegistration: {
          input: {
            type: "structure",
            required: [
              "RegistrationToken"
            ],
            members: {
              RegistrationToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeTypeRegistrationResult",
            type: "structure",
            members: {
              ProgressStatus: {},
              Description: {},
              TypeArn: {},
              TypeVersionArn: {}
            }
          },
          idempotent: true
        },
        DetectStackDrift: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              LogicalResourceIds: {
                shape: "S7i"
              }
            }
          },
          output: {
            resultWrapper: "DetectStackDriftResult",
            type: "structure",
            required: [
              "StackDriftDetectionId"
            ],
            members: {
              StackDriftDetectionId: {}
            }
          }
        },
        DetectStackResourceDrift: {
          input: {
            type: "structure",
            required: [
              "StackName",
              "LogicalResourceId"
            ],
            members: {
              StackName: {},
              LogicalResourceId: {}
            }
          },
          output: {
            resultWrapper: "DetectStackResourceDriftResult",
            type: "structure",
            required: [
              "StackResourceDrift"
            ],
            members: {
              StackResourceDrift: {
                shape: "S5k"
              }
            }
          }
        },
        DetectStackSetDrift: {
          input: {
            type: "structure",
            required: [
              "StackSetName"
            ],
            members: {
              StackSetName: {},
              OperationPreferences: {
                shape: "S2p"
              },
              OperationId: {
                idempotencyToken: true
              },
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "DetectStackSetDriftResult",
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        EstimateTemplateCost: {
          input: {
            type: "structure",
            members: {
              TemplateBody: {},
              TemplateURL: {},
              Parameters: {
                shape: "S18"
              }
            }
          },
          output: {
            resultWrapper: "EstimateTemplateCostResult",
            type: "structure",
            members: {
              Url: {}
            }
          }
        },
        ExecuteChangeSet: {
          input: {
            type: "structure",
            required: [
              "ChangeSetName"
            ],
            members: {
              ChangeSetName: {},
              StackName: {},
              ClientRequestToken: {},
              DisableRollback: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ExecuteChangeSetResult",
            type: "structure",
            members: {}
          }
        },
        GetStackPolicy: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {}
            }
          },
          output: {
            resultWrapper: "GetStackPolicyResult",
            type: "structure",
            members: {
              StackPolicyBody: {}
            }
          }
        },
        GetTemplate: {
          input: {
            type: "structure",
            members: {
              StackName: {},
              ChangeSetName: {},
              TemplateStage: {}
            }
          },
          output: {
            resultWrapper: "GetTemplateResult",
            type: "structure",
            members: {
              TemplateBody: {},
              StagesAvailable: {
                type: "list",
                member: {}
              }
            }
          }
        },
        GetTemplateSummary: {
          input: {
            type: "structure",
            members: {
              TemplateBody: {},
              TemplateURL: {},
              StackName: {},
              StackSetName: {},
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "GetTemplateSummaryResult",
            type: "structure",
            members: {
              Parameters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ParameterKey: {},
                    DefaultValue: {},
                    ParameterType: {},
                    NoEcho: {
                      type: "boolean"
                    },
                    Description: {},
                    ParameterConstraints: {
                      type: "structure",
                      members: {
                        AllowedValues: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                }
              },
              Description: {},
              Capabilities: {
                shape: "S1d"
              },
              CapabilitiesReason: {},
              ResourceTypes: {
                shape: "S1f"
              },
              Version: {},
              Metadata: {},
              DeclaredTransforms: {
                shape: "S8b"
              },
              ResourceIdentifierSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceType: {},
                    LogicalResourceIds: {
                      shape: "S7i"
                    },
                    ResourceIdentifiers: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        ImportStacksToStackSet: {
          input: {
            type: "structure",
            required: [
              "StackSetName",
              "StackIds"
            ],
            members: {
              StackSetName: {},
              StackIds: {
                type: "list",
                member: {}
              },
              OperationPreferences: {
                shape: "S2p"
              },
              OperationId: {
                idempotencyToken: true
              },
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "ImportStacksToStackSetResult",
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        ListChangeSets: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListChangeSetsResult",
            type: "structure",
            members: {
              Summaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StackId: {},
                    StackName: {},
                    ChangeSetId: {},
                    ChangeSetName: {},
                    ExecutionStatus: {},
                    Status: {},
                    StatusReason: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    Description: {},
                    IncludeNestedStacks: {
                      type: "boolean"
                    },
                    ParentChangeSetId: {},
                    RootChangeSetId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListExports: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListExportsResult",
            type: "structure",
            members: {
              Exports: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ExportingStackId: {},
                    Name: {},
                    Value: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListImports: {
          input: {
            type: "structure",
            required: [
              "ExportName"
            ],
            members: {
              ExportName: {},
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListImportsResult",
            type: "structure",
            members: {
              Imports: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListStackInstances: {
          input: {
            type: "structure",
            required: [
              "StackSetName"
            ],
            members: {
              StackSetName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Values: {}
                  }
                }
              },
              StackInstanceAccount: {},
              StackInstanceRegion: {},
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "ListStackInstancesResult",
            type: "structure",
            members: {
              Summaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StackSetId: {},
                    Region: {},
                    Account: {},
                    StackId: {},
                    Status: {},
                    StatusReason: {},
                    StackInstanceStatus: {
                      shape: "S56"
                    },
                    OrganizationalUnitId: {},
                    DriftStatus: {},
                    LastDriftCheckTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListStackResources: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListStackResourcesResult",
            type: "structure",
            members: {
              StackResourceSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "LogicalResourceId",
                    "ResourceType",
                    "LastUpdatedTimestamp",
                    "ResourceStatus"
                  ],
                  members: {
                    LogicalResourceId: {},
                    PhysicalResourceId: {},
                    ResourceType: {},
                    LastUpdatedTimestamp: {
                      type: "timestamp"
                    },
                    ResourceStatus: {},
                    ResourceStatusReason: {},
                    DriftInformation: {
                      type: "structure",
                      required: [
                        "StackResourceDriftStatus"
                      ],
                      members: {
                        StackResourceDriftStatus: {},
                        LastCheckTimestamp: {
                          type: "timestamp"
                        }
                      }
                    },
                    ModuleInfo: {
                      shape: "S4f"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListStackSetOperationResults: {
          input: {
            type: "structure",
            required: [
              "StackSetName",
              "OperationId"
            ],
            members: {
              StackSetName: {},
              OperationId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "ListStackSetOperationResultsResult",
            type: "structure",
            members: {
              Summaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Account: {},
                    Region: {},
                    Status: {},
                    StatusReason: {},
                    AccountGateResult: {
                      type: "structure",
                      members: {
                        Status: {},
                        StatusReason: {}
                      }
                    },
                    OrganizationalUnitId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListStackSetOperations: {
          input: {
            type: "structure",
            required: [
              "StackSetName"
            ],
            members: {
              StackSetName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "ListStackSetOperationsResult",
            type: "structure",
            members: {
              Summaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    OperationId: {},
                    Action: {},
                    Status: {},
                    CreationTimestamp: {
                      type: "timestamp"
                    },
                    EndTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListStackSets: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Status: {},
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "ListStackSetsResult",
            type: "structure",
            members: {
              Summaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StackSetName: {},
                    StackSetId: {},
                    Description: {},
                    Status: {},
                    AutoDeployment: {
                      shape: "S30"
                    },
                    PermissionModel: {},
                    DriftStatus: {},
                    LastDriftCheckTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListStacks: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              StackStatusFilter: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "ListStacksResult",
            type: "structure",
            members: {
              StackSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "StackName",
                    "CreationTime",
                    "StackStatus"
                  ],
                  members: {
                    StackId: {},
                    StackName: {},
                    TemplateDescription: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    },
                    DeletionTime: {
                      type: "timestamp"
                    },
                    StackStatus: {},
                    StackStatusReason: {},
                    ParentId: {},
                    RootId: {},
                    DriftInformation: {
                      type: "structure",
                      required: [
                        "StackDriftStatus"
                      ],
                      members: {
                        StackDriftStatus: {},
                        LastCheckTimestamp: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTypeRegistrations: {
          input: {
            type: "structure",
            members: {
              Type: {},
              TypeName: {},
              TypeArn: {},
              RegistrationStatusFilter: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListTypeRegistrationsResult",
            type: "structure",
            members: {
              RegistrationTokenList: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListTypeVersions: {
          input: {
            type: "structure",
            members: {
              Type: {},
              TypeName: {},
              Arn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DeprecatedStatus: {},
              PublisherId: {}
            }
          },
          output: {
            resultWrapper: "ListTypeVersionsResult",
            type: "structure",
            members: {
              TypeVersionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    TypeName: {},
                    VersionId: {},
                    IsDefaultVersion: {
                      type: "boolean"
                    },
                    Arn: {},
                    TimeCreated: {
                      type: "timestamp"
                    },
                    Description: {},
                    PublicVersionNumber: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListTypes: {
          input: {
            type: "structure",
            members: {
              Visibility: {},
              ProvisioningType: {},
              DeprecatedStatus: {},
              Type: {},
              Filters: {
                type: "structure",
                members: {
                  Category: {},
                  PublisherId: {},
                  TypeNamePrefix: {}
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListTypesResult",
            type: "structure",
            members: {
              TypeSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    TypeName: {},
                    DefaultVersionId: {},
                    TypeArn: {},
                    LastUpdated: {
                      type: "timestamp"
                    },
                    Description: {},
                    PublisherId: {},
                    OriginalTypeName: {},
                    PublicVersionNumber: {},
                    LatestPublicVersion: {},
                    PublisherIdentity: {},
                    PublisherName: {},
                    IsActivated: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        PublishType: {
          input: {
            type: "structure",
            members: {
              Type: {},
              Arn: {},
              TypeName: {},
              PublicVersionNumber: {}
            }
          },
          output: {
            resultWrapper: "PublishTypeResult",
            type: "structure",
            members: {
              PublicTypeArn: {}
            }
          },
          idempotent: true
        },
        RecordHandlerProgress: {
          input: {
            type: "structure",
            required: [
              "BearerToken",
              "OperationStatus"
            ],
            members: {
              BearerToken: {},
              OperationStatus: {},
              CurrentOperationStatus: {},
              StatusMessage: {},
              ErrorCode: {},
              ResourceModel: {},
              ClientRequestToken: {}
            }
          },
          output: {
            resultWrapper: "RecordHandlerProgressResult",
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        RegisterPublisher: {
          input: {
            type: "structure",
            members: {
              AcceptTermsAndConditions: {
                type: "boolean"
              },
              ConnectionArn: {}
            }
          },
          output: {
            resultWrapper: "RegisterPublisherResult",
            type: "structure",
            members: {
              PublisherId: {}
            }
          },
          idempotent: true
        },
        RegisterType: {
          input: {
            type: "structure",
            required: [
              "TypeName",
              "SchemaHandlerPackage"
            ],
            members: {
              Type: {},
              TypeName: {},
              SchemaHandlerPackage: {},
              LoggingConfig: {
                shape: "S7"
              },
              ExecutionRoleArn: {},
              ClientRequestToken: {}
            }
          },
          output: {
            resultWrapper: "RegisterTypeResult",
            type: "structure",
            members: {
              RegistrationToken: {}
            }
          },
          idempotent: true
        },
        RollbackStack: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              RoleARN: {},
              ClientRequestToken: {}
            }
          },
          output: {
            resultWrapper: "RollbackStackResult",
            type: "structure",
            members: {
              StackId: {}
            }
          }
        },
        SetStackPolicy: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              StackPolicyBody: {},
              StackPolicyURL: {}
            }
          }
        },
        SetTypeConfiguration: {
          input: {
            type: "structure",
            required: [
              "Configuration"
            ],
            members: {
              TypeArn: {},
              Configuration: {},
              ConfigurationAlias: {},
              TypeName: {},
              Type: {}
            }
          },
          output: {
            resultWrapper: "SetTypeConfigurationResult",
            type: "structure",
            members: {
              ConfigurationArn: {}
            }
          }
        },
        SetTypeDefaultVersion: {
          input: {
            type: "structure",
            members: {
              Arn: {},
              Type: {},
              TypeName: {},
              VersionId: {}
            }
          },
          output: {
            resultWrapper: "SetTypeDefaultVersionResult",
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        SignalResource: {
          input: {
            type: "structure",
            required: [
              "StackName",
              "LogicalResourceId",
              "UniqueId",
              "Status"
            ],
            members: {
              StackName: {},
              LogicalResourceId: {},
              UniqueId: {},
              Status: {}
            }
          }
        },
        StopStackSetOperation: {
          input: {
            type: "structure",
            required: [
              "StackSetName",
              "OperationId"
            ],
            members: {
              StackSetName: {},
              OperationId: {},
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "StopStackSetOperationResult",
            type: "structure",
            members: {}
          }
        },
        TestType: {
          input: {
            type: "structure",
            members: {
              Arn: {},
              Type: {},
              TypeName: {},
              VersionId: {},
              LogDeliveryBucket: {}
            }
          },
          output: {
            resultWrapper: "TestTypeResult",
            type: "structure",
            members: {
              TypeVersionArn: {}
            }
          },
          idempotent: true
        },
        UpdateStack: {
          input: {
            type: "structure",
            required: [
              "StackName"
            ],
            members: {
              StackName: {},
              TemplateBody: {},
              TemplateURL: {},
              UsePreviousTemplate: {
                type: "boolean"
              },
              StackPolicyDuringUpdateBody: {},
              StackPolicyDuringUpdateURL: {},
              Parameters: {
                shape: "S18"
              },
              Capabilities: {
                shape: "S1d"
              },
              ResourceTypes: {
                shape: "S1f"
              },
              RoleARN: {},
              RollbackConfiguration: {
                shape: "S1h"
              },
              StackPolicyBody: {},
              StackPolicyURL: {},
              NotificationARNs: {
                shape: "S1n"
              },
              Tags: {
                shape: "S1p"
              },
              DisableRollback: {
                type: "boolean"
              },
              ClientRequestToken: {}
            }
          },
          output: {
            resultWrapper: "UpdateStackResult",
            type: "structure",
            members: {
              StackId: {}
            }
          }
        },
        UpdateStackInstances: {
          input: {
            type: "structure",
            required: [
              "StackSetName",
              "Regions"
            ],
            members: {
              StackSetName: {},
              Accounts: {
                shape: "S2h"
              },
              DeploymentTargets: {
                shape: "S2j"
              },
              Regions: {
                shape: "S2n"
              },
              ParameterOverrides: {
                shape: "S18"
              },
              OperationPreferences: {
                shape: "S2p"
              },
              OperationId: {
                idempotencyToken: true
              },
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "UpdateStackInstancesResult",
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        UpdateStackSet: {
          input: {
            type: "structure",
            required: [
              "StackSetName"
            ],
            members: {
              StackSetName: {},
              Description: {},
              TemplateBody: {},
              TemplateURL: {},
              UsePreviousTemplate: {
                type: "boolean"
              },
              Parameters: {
                shape: "S18"
              },
              Capabilities: {
                shape: "S1d"
              },
              Tags: {
                shape: "S1p"
              },
              OperationPreferences: {
                shape: "S2p"
              },
              AdministrationRoleARN: {},
              ExecutionRoleName: {},
              DeploymentTargets: {
                shape: "S2j"
              },
              PermissionModel: {},
              AutoDeployment: {
                shape: "S30"
              },
              OperationId: {
                idempotencyToken: true
              },
              Accounts: {
                shape: "S2h"
              },
              Regions: {
                shape: "S2n"
              },
              CallAs: {}
            }
          },
          output: {
            resultWrapper: "UpdateStackSetResult",
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        UpdateTerminationProtection: {
          input: {
            type: "structure",
            required: [
              "EnableTerminationProtection",
              "StackName"
            ],
            members: {
              EnableTerminationProtection: {
                type: "boolean"
              },
              StackName: {}
            }
          },
          output: {
            resultWrapper: "UpdateTerminationProtectionResult",
            type: "structure",
            members: {
              StackId: {}
            }
          }
        },
        ValidateTemplate: {
          input: {
            type: "structure",
            members: {
              TemplateBody: {},
              TemplateURL: {}
            }
          },
          output: {
            resultWrapper: "ValidateTemplateResult",
            type: "structure",
            members: {
              Parameters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ParameterKey: {},
                    DefaultValue: {},
                    NoEcho: {
                      type: "boolean"
                    },
                    Description: {}
                  }
                }
              },
              Description: {},
              Capabilities: {
                shape: "S1d"
              },
              CapabilitiesReason: {},
              DeclaredTransforms: {
                shape: "S8b"
              }
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "structure",
          required: [
            "LogRoleArn",
            "LogGroupName"
          ],
          members: {
            LogRoleArn: {},
            LogGroupName: {}
          }
        },
        Sg: {
          type: "structure",
          members: {
            TypeArn: {},
            TypeConfigurationAlias: {},
            TypeConfigurationArn: {},
            Type: {},
            TypeName: {}
          }
        },
        S18: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ParameterKey: {},
              ParameterValue: {},
              UsePreviousValue: {
                type: "boolean"
              },
              ResolvedValue: {}
            }
          }
        },
        S1d: {
          type: "list",
          member: {}
        },
        S1f: {
          type: "list",
          member: {}
        },
        S1h: {
          type: "structure",
          members: {
            RollbackTriggers: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Arn",
                  "Type"
                ],
                members: {
                  Arn: {},
                  Type: {}
                }
              }
            },
            MonitoringTimeInMinutes: {
              type: "integer"
            }
          }
        },
        S1n: {
          type: "list",
          member: {}
        },
        S1p: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S2h: {
          type: "list",
          member: {}
        },
        S2j: {
          type: "structure",
          members: {
            Accounts: {
              shape: "S2h"
            },
            AccountsUrl: {},
            OrganizationalUnitIds: {
              shape: "S2l"
            }
          }
        },
        S2l: {
          type: "list",
          member: {}
        },
        S2n: {
          type: "list",
          member: {}
        },
        S2p: {
          type: "structure",
          members: {
            RegionConcurrencyType: {},
            RegionOrder: {
              shape: "S2n"
            },
            FailureToleranceCount: {
              type: "integer"
            },
            FailureTolerancePercentage: {
              type: "integer"
            },
            MaxConcurrentCount: {
              type: "integer"
            },
            MaxConcurrentPercentage: {
              type: "integer"
            }
          }
        },
        S30: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            RetainStacksOnAccountRemoval: {
              type: "boolean"
            }
          }
        },
        S4f: {
          type: "structure",
          members: {
            TypeHierarchy: {},
            LogicalIdHierarchy: {}
          }
        },
        S56: {
          type: "structure",
          members: {
            DetailedStatus: {}
          }
        },
        S5d: {
          type: "structure",
          required: [
            "StackResourceDriftStatus"
          ],
          members: {
            StackResourceDriftStatus: {},
            LastCheckTimestamp: {
              type: "timestamp"
            }
          }
        },
        S5k: {
          type: "structure",
          required: [
            "StackId",
            "LogicalResourceId",
            "ResourceType",
            "StackResourceDriftStatus",
            "Timestamp"
          ],
          members: {
            StackId: {},
            LogicalResourceId: {},
            PhysicalResourceId: {},
            PhysicalResourceIdContext: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Key",
                  "Value"
                ],
                members: {
                  Key: {},
                  Value: {}
                }
              }
            },
            ResourceType: {},
            ExpectedProperties: {},
            ActualProperties: {},
            PropertyDifferences: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "PropertyPath",
                  "ExpectedValue",
                  "ActualValue",
                  "DifferenceType"
                ],
                members: {
                  PropertyPath: {},
                  ExpectedValue: {},
                  ActualValue: {},
                  DifferenceType: {}
                }
              }
            },
            StackResourceDriftStatus: {},
            Timestamp: {
              type: "timestamp"
            },
            ModuleInfo: {
              shape: "S4f"
            }
          }
        },
        S64: {
          type: "structure",
          members: {
            DriftStatus: {},
            DriftDetectionStatus: {},
            LastDriftCheckTimestamp: {
              type: "timestamp"
            },
            TotalStackInstancesCount: {
              type: "integer"
            },
            DriftedStackInstancesCount: {
              type: "integer"
            },
            InSyncStackInstancesCount: {
              type: "integer"
            },
            InProgressStackInstancesCount: {
              type: "integer"
            },
            FailedStackInstancesCount: {
              type: "integer"
            }
          }
        },
        S7i: {
          type: "list",
          member: {}
        },
        S8b: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudformation-2010-05-15.paginators.json
var require_cloudformation_2010_05_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudformation-2010-05-15.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeAccountLimits: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "AccountLimits"
        },
        DescribeStackEvents: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "StackEvents"
        },
        DescribeStackResourceDrifts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        DescribeStackResources: {
          result_key: "StackResources"
        },
        DescribeStacks: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Stacks"
        },
        ListChangeSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Summaries"
        },
        ListExports: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Exports"
        },
        ListImports: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Imports"
        },
        ListStackInstances: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Summaries"
        },
        ListStackResources: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "StackResourceSummaries"
        },
        ListStackSetOperationResults: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Summaries"
        },
        ListStackSetOperations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Summaries"
        },
        ListStackSets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Summaries"
        },
        ListStacks: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "StackSummaries"
        },
        ListTypeRegistrations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTypeVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTypes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TypeSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudformation-2010-05-15.waiters2.json
var require_cloudformation_2010_05_15_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/cloudformation-2010-05-15.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        StackExists: {
          delay: 5,
          operation: "DescribeStacks",
          maxAttempts: 20,
          acceptors: [
            {
              matcher: "status",
              expected: 200,
              state: "success"
            },
            {
              matcher: "error",
              expected: "ValidationError",
              state: "retry"
            }
          ]
        },
        StackCreateComplete: {
          delay: 30,
          operation: "DescribeStacks",
          maxAttempts: 120,
          description: "Wait until stack status is CREATE_COMPLETE.",
          acceptors: [
            {
              argument: "Stacks[].StackStatus",
              expected: "CREATE_COMPLETE",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "CREATE_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "DELETE_COMPLETE",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "DELETE_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "ROLLBACK_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "ROLLBACK_COMPLETE",
              matcher: "pathAny",
              state: "failure"
            },
            {
              expected: "ValidationError",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        StackDeleteComplete: {
          delay: 30,
          operation: "DescribeStacks",
          maxAttempts: 120,
          description: "Wait until stack status is DELETE_COMPLETE.",
          acceptors: [
            {
              argument: "Stacks[].StackStatus",
              expected: "DELETE_COMPLETE",
              matcher: "pathAll",
              state: "success"
            },
            {
              expected: "ValidationError",
              matcher: "error",
              state: "success"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "DELETE_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "CREATE_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "ROLLBACK_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_ROLLBACK_IN_PROGRESS",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_ROLLBACK_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_ROLLBACK_COMPLETE",
              matcher: "pathAny",
              state: "failure"
            }
          ]
        },
        StackUpdateComplete: {
          delay: 30,
          maxAttempts: 120,
          operation: "DescribeStacks",
          description: "Wait until stack status is UPDATE_COMPLETE.",
          acceptors: [
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_COMPLETE",
              matcher: "pathAll",
              state: "success"
            },
            {
              expected: "UPDATE_FAILED",
              matcher: "pathAny",
              state: "failure",
              argument: "Stacks[].StackStatus"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_ROLLBACK_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              expected: "UPDATE_ROLLBACK_COMPLETE",
              matcher: "pathAny",
              state: "failure",
              argument: "Stacks[].StackStatus"
            },
            {
              expected: "ValidationError",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        StackImportComplete: {
          delay: 30,
          maxAttempts: 120,
          operation: "DescribeStacks",
          description: "Wait until stack status is IMPORT_COMPLETE.",
          acceptors: [
            {
              argument: "Stacks[].StackStatus",
              expected: "IMPORT_COMPLETE",
              matcher: "pathAll",
              state: "success"
            },
            {
              expected: "ROLLBACK_COMPLETE",
              matcher: "pathAny",
              state: "failure",
              argument: "Stacks[].StackStatus"
            },
            {
              expected: "ROLLBACK_FAILED",
              matcher: "pathAny",
              state: "failure",
              argument: "Stacks[].StackStatus"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "IMPORT_ROLLBACK_IN_PROGRESS",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "IMPORT_ROLLBACK_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              expected: "IMPORT_ROLLBACK_COMPLETE",
              matcher: "pathAny",
              state: "failure",
              argument: "Stacks[].StackStatus"
            },
            {
              expected: "ValidationError",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        StackRollbackComplete: {
          delay: 30,
          operation: "DescribeStacks",
          maxAttempts: 120,
          description: "Wait until stack status is UPDATE_ROLLBACK_COMPLETE.",
          acceptors: [
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_ROLLBACK_COMPLETE",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "UPDATE_ROLLBACK_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Stacks[].StackStatus",
              expected: "DELETE_FAILED",
              matcher: "pathAny",
              state: "failure"
            },
            {
              expected: "ValidationError",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        ChangeSetCreateComplete: {
          delay: 30,
          operation: "DescribeChangeSet",
          maxAttempts: 120,
          description: "Wait until change set status is CREATE_COMPLETE.",
          acceptors: [
            {
              argument: "Status",
              expected: "CREATE_COMPLETE",
              matcher: "path",
              state: "success"
            },
            {
              argument: "Status",
              expected: "FAILED",
              matcher: "path",
              state: "failure"
            },
            {
              expected: "ValidationError",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        TypeRegistrationComplete: {
          delay: 30,
          operation: "DescribeTypeRegistration",
          maxAttempts: 120,
          description: "Wait until type registration is COMPLETE.",
          acceptors: [
            {
              argument: "ProgressStatus",
              expected: "COMPLETE",
              matcher: "path",
              state: "success"
            },
            {
              argument: "ProgressStatus",
              expected: "FAILED",
              matcher: "path",
              state: "failure"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cloudformation.js
var require_cloudformation = __commonJS({
  "node_modules/aws-sdk/clients/cloudformation.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["cloudformation"] = {};
    AWS3.CloudFormation = Service.defineService("cloudformation", ["2010-05-15"]);
    Object.defineProperty(apiLoader.services["cloudformation"], "2010-05-15", {
      get: function get() {
        var model = require_cloudformation_2010_05_15_min();
        model.paginators = require_cloudformation_2010_05_15_paginators().pagination;
        model.waiters = require_cloudformation_2010_05_15_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CloudFormation;
  }
});

// node_modules/aws-sdk/lib/cloudfront/signer.js
var require_signer = __commonJS({
  "node_modules/aws-sdk/lib/cloudfront/signer.js"(exports, module2) {
    var AWS3 = require_core();
    var url = AWS3.util.url;
    var crypto = AWS3.util.crypto.lib;
    var base64Encode = AWS3.util.base64.encode;
    var inherit = AWS3.util.inherit;
    var queryEncode = function(string) {
      var replacements = {
        "+": "-",
        "=": "_",
        "/": "~"
      };
      return string.replace(/[\+=\/]/g, function(match) {
        return replacements[match];
      });
    };
    var signPolicy = function(policy, privateKey) {
      var sign = crypto.createSign("RSA-SHA1");
      sign.write(policy);
      return queryEncode(sign.sign(privateKey, "base64"));
    };
    var signWithCannedPolicy = function(url2, expires, keyPairId, privateKey) {
      var policy = JSON.stringify({
        Statement: [
          {
            Resource: url2,
            Condition: { DateLessThan: { "AWS:EpochTime": expires } }
          }
        ]
      });
      return {
        Expires: expires,
        "Key-Pair-Id": keyPairId,
        Signature: signPolicy(policy.toString(), privateKey)
      };
    };
    var signWithCustomPolicy = function(policy, keyPairId, privateKey) {
      policy = policy.replace(/\s/mg, "");
      return {
        Policy: queryEncode(base64Encode(policy)),
        "Key-Pair-Id": keyPairId,
        Signature: signPolicy(policy, privateKey)
      };
    };
    var determineScheme = function(url2) {
      var parts = url2.split("://");
      if (parts.length < 2) {
        throw new Error("Invalid URL.");
      }
      return parts[0].replace("*", "");
    };
    var getRtmpUrl = function(rtmpUrl) {
      var parsed = url.parse(rtmpUrl);
      return parsed.path.replace(/^\//, "") + (parsed.hash || "");
    };
    var getResource = function(url2) {
      switch (determineScheme(url2)) {
        case "http":
        case "https":
          return url2;
        case "rtmp":
          return getRtmpUrl(url2);
        default:
          throw new Error("Invalid URI scheme. Scheme must be one of http, https, or rtmp");
      }
    };
    var handleError = function(err, callback) {
      if (!callback || typeof callback !== "function") {
        throw err;
      }
      callback(err);
    };
    var handleSuccess = function(result, callback) {
      if (!callback || typeof callback !== "function") {
        return result;
      }
      callback(null, result);
    };
    AWS3.CloudFront.Signer = inherit({
      constructor: function Signer(keyPairId, privateKey) {
        if (keyPairId === void 0 || privateKey === void 0) {
          throw new Error("A key pair ID and private key are required");
        }
        this.keyPairId = keyPairId;
        this.privateKey = privateKey;
      },
      getSignedCookie: function(options, cb) {
        var signatureHash = "policy" in options ? signWithCustomPolicy(options.policy, this.keyPairId, this.privateKey) : signWithCannedPolicy(options.url, options.expires, this.keyPairId, this.privateKey);
        var cookieHash = {};
        for (var key in signatureHash) {
          if (Object.prototype.hasOwnProperty.call(signatureHash, key)) {
            cookieHash["CloudFront-" + key] = signatureHash[key];
          }
        }
        return handleSuccess(cookieHash, cb);
      },
      getSignedUrl: function(options, cb) {
        try {
          var resource = getResource(options.url);
        } catch (err) {
          return handleError(err, cb);
        }
        var parsedUrl = url.parse(options.url, true), signatureHash = Object.prototype.hasOwnProperty.call(options, "policy") ? signWithCustomPolicy(options.policy, this.keyPairId, this.privateKey) : signWithCannedPolicy(resource, options.expires, this.keyPairId, this.privateKey);
        parsedUrl.search = null;
        for (var key in signatureHash) {
          if (Object.prototype.hasOwnProperty.call(signatureHash, key)) {
            parsedUrl.query[key] = signatureHash[key];
          }
        }
        try {
          var signedUrl = determineScheme(options.url) === "rtmp" ? getRtmpUrl(url.format(parsedUrl)) : url.format(parsedUrl);
        } catch (err) {
          return handleError(err, cb);
        }
        return handleSuccess(signedUrl, cb);
      }
    });
    module2.exports = AWS3.CloudFront.Signer;
  }
});

// node_modules/aws-sdk/lib/services/cloudfront.js
var require_cloudfront = __commonJS({
  "node_modules/aws-sdk/lib/services/cloudfront.js"() {
    var AWS3 = require_core();
    require_signer();
    AWS3.util.update(AWS3.CloudFront.prototype, {
      setupRequestListeners: function setupRequestListeners(request) {
        request.addListener("extractData", AWS3.util.hoistPayloadMember);
      }
    });
  }
});

// node_modules/aws-sdk/apis/cloudfront-2016-11-25.min.json
var require_cloudfront_2016_11_25_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2016-11-25.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-11-25",
        endpointPrefix: "cloudfront",
        globalEndpoint: "cloudfront.amazonaws.com",
        protocol: "rest-xml",
        serviceAbbreviation: "CloudFront",
        serviceFullName: "Amazon CloudFront",
        serviceId: "CloudFront",
        signatureVersion: "v4",
        uid: "cloudfront-2016-11-25"
      },
      operations: {
        CreateCloudFrontOriginAccessIdentity: {
          http: {
            requestUri: "/2016-11-25/origin-access-identity/cloudfront",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        CreateDistribution: {
          http: {
            requestUri: "/2016-11-25/distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                }
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1s"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateDistributionWithTags: {
          http: {
            requestUri: "/2016-11-25/distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfigWithTags"
            ],
            members: {
              DistributionConfigWithTags: {
                locationName: "DistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                },
                type: "structure",
                required: [
                  "DistributionConfig",
                  "Tags"
                ],
                members: {
                  DistributionConfig: {
                    shape: "S7"
                  },
                  Tags: {
                    shape: "S21"
                  }
                }
              }
            },
            payload: "DistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1s"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateInvalidation: {
          http: {
            requestUri: "/2016-11-25/distribution/{DistributionId}/invalidation",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "InvalidationBatch"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              InvalidationBatch: {
                shape: "S28",
                locationName: "InvalidationBatch",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                }
              }
            },
            payload: "InvalidationBatch"
          },
          output: {
            type: "structure",
            members: {
              Location: {
                location: "header",
                locationName: "Location"
              },
              Invalidation: {
                shape: "S2c"
              }
            },
            payload: "Invalidation"
          }
        },
        CreateStreamingDistribution: {
          http: {
            requestUri: "/2016-11-25/streaming-distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S2e",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                }
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S2i"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        CreateStreamingDistributionWithTags: {
          http: {
            requestUri: "/2016-11-25/streaming-distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfigWithTags"
            ],
            members: {
              StreamingDistributionConfigWithTags: {
                locationName: "StreamingDistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                },
                type: "structure",
                required: [
                  "StreamingDistributionConfig",
                  "Tags"
                ],
                members: {
                  StreamingDistributionConfig: {
                    shape: "S2e"
                  },
                  Tags: {
                    shape: "S21"
                  }
                }
              }
            },
            payload: "StreamingDistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S2i"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        DeleteCloudFrontOriginAccessIdentity: {
          http: {
            method: "DELETE",
            requestUri: "/2016-11-25/origin-access-identity/cloudfront/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2016-11-25/distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteStreamingDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2016-11-25/streaming-distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        GetCloudFrontOriginAccessIdentity: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/origin-access-identity/cloudfront/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        GetCloudFrontOriginAccessIdentityConfig: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          }
        },
        GetDistribution: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1s"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        GetDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionConfig: {
                shape: "S7"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "DistributionConfig"
          }
        },
        GetInvalidation: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/distribution/{DistributionId}/invalidation/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "Id"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invalidation: {
                shape: "S2c"
              }
            },
            payload: "Invalidation"
          }
        },
        GetStreamingDistribution: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/streaming-distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S2i"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        GetStreamingDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionConfig: {
                shape: "S2e"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistributionConfig"
          }
        },
        ListCloudFrontOriginAccessIdentities: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/origin-access-identity/cloudfront"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "CloudFrontOriginAccessIdentitySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "S3CanonicalUserId",
                        "Comment"
                      ],
                      members: {
                        Id: {},
                        S3CanonicalUserId: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityList"
          }
        },
        ListDistributions: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S3a"
              }
            },
            payload: "DistributionList"
          }
        },
        ListDistributionsByWebACLId: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/distributionsByWebACLId/{WebACLId}"
          },
          input: {
            type: "structure",
            required: [
              "WebACLId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              WebACLId: {
                location: "uri",
                locationName: "WebACLId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S3a"
              }
            },
            payload: "DistributionList"
          }
        },
        ListInvalidations: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/distribution/{DistributionId}/invalidation"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InvalidationList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "InvalidationSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "CreateTime",
                        "Status"
                      ],
                      members: {
                        Id: {},
                        CreateTime: {
                          type: "timestamp"
                        },
                        Status: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "InvalidationList"
          }
        },
        ListStreamingDistributions: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/streaming-distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "StreamingDistributionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "ARN",
                        "Status",
                        "LastModifiedTime",
                        "DomainName",
                        "S3Origin",
                        "Aliases",
                        "TrustedSigners",
                        "Comment",
                        "PriceClass",
                        "Enabled"
                      ],
                      members: {
                        Id: {},
                        ARN: {},
                        Status: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        DomainName: {},
                        S3Origin: {
                          shape: "S2f"
                        },
                        Aliases: {
                          shape: "S8"
                        },
                        TrustedSigners: {
                          shape: "Sy"
                        },
                        Comment: {},
                        PriceClass: {},
                        Enabled: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "StreamingDistributionList"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2016-11-25/tagging"
          },
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "S21"
              }
            },
            payload: "Tags"
          }
        },
        TagResource: {
          http: {
            requestUri: "/2016-11-25/tagging?Operation=Tag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "Tags"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              Tags: {
                shape: "S21",
                locationName: "Tags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                }
              }
            },
            payload: "Tags"
          }
        },
        UntagResource: {
          http: {
            requestUri: "/2016-11-25/tagging?Operation=Untag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "TagKeys"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              TagKeys: {
                locationName: "TagKeys",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                },
                type: "structure",
                members: {
                  Items: {
                    type: "list",
                    member: {
                      locationName: "Key"
                    }
                  }
                }
              }
            },
            payload: "TagKeys"
          }
        },
        UpdateCloudFrontOriginAccessIdentity: {
          http: {
            method: "PUT",
            requestUri: "/2016-11-25/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig",
              "Id"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        UpdateDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2016-11-25/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig",
              "Id"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1s"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        UpdateStreamingDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2016-11-25/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig",
              "Id"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S2e",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2016-11-25/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S2i"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "CallerReference",
            "Comment"
          ],
          members: {
            CallerReference: {},
            Comment: {}
          }
        },
        S5: {
          type: "structure",
          required: [
            "Id",
            "S3CanonicalUserId"
          ],
          members: {
            Id: {},
            S3CanonicalUserId: {},
            CloudFrontOriginAccessIdentityConfig: {
              shape: "S2"
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "CallerReference",
            "Origins",
            "DefaultCacheBehavior",
            "Comment",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            Aliases: {
              shape: "S8"
            },
            DefaultRootObject: {},
            Origins: {
              shape: "Sb"
            },
            DefaultCacheBehavior: {
              shape: "Sn"
            },
            CacheBehaviors: {
              shape: "S1a"
            },
            CustomErrorResponses: {
              shape: "S1d"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "IncludeCookies",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                IncludeCookies: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            },
            ViewerCertificate: {
              shape: "S1i"
            },
            Restrictions: {
              shape: "S1m"
            },
            WebACLId: {},
            HttpVersion: {},
            IsIPV6Enabled: {
              type: "boolean"
            }
          }
        },
        S8: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CNAME"
              }
            }
          }
        },
        Sb: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Origin",
                type: "structure",
                required: [
                  "Id",
                  "DomainName"
                ],
                members: {
                  Id: {},
                  DomainName: {},
                  OriginPath: {},
                  CustomHeaders: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "OriginCustomHeader",
                          type: "structure",
                          required: [
                            "HeaderName",
                            "HeaderValue"
                          ],
                          members: {
                            HeaderName: {},
                            HeaderValue: {}
                          }
                        }
                      }
                    }
                  },
                  S3OriginConfig: {
                    type: "structure",
                    required: [
                      "OriginAccessIdentity"
                    ],
                    members: {
                      OriginAccessIdentity: {}
                    }
                  },
                  CustomOriginConfig: {
                    type: "structure",
                    required: [
                      "HTTPPort",
                      "HTTPSPort",
                      "OriginProtocolPolicy"
                    ],
                    members: {
                      HTTPPort: {
                        type: "integer"
                      },
                      HTTPSPort: {
                        type: "integer"
                      },
                      OriginProtocolPolicy: {},
                      OriginSslProtocols: {
                        type: "structure",
                        required: [
                          "Quantity",
                          "Items"
                        ],
                        members: {
                          Quantity: {
                            type: "integer"
                          },
                          Items: {
                            type: "list",
                            member: {
                              locationName: "SslProtocol"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "TargetOriginId",
            "ForwardedValues",
            "TrustedSigners",
            "ViewerProtocolPolicy",
            "MinTTL"
          ],
          members: {
            TargetOriginId: {},
            ForwardedValues: {
              shape: "So"
            },
            TrustedSigners: {
              shape: "Sy"
            },
            ViewerProtocolPolicy: {},
            MinTTL: {
              type: "long"
            },
            AllowedMethods: {
              shape: "S12"
            },
            SmoothStreaming: {
              type: "boolean"
            },
            DefaultTTL: {
              type: "long"
            },
            MaxTTL: {
              type: "long"
            },
            Compress: {
              type: "boolean"
            },
            LambdaFunctionAssociations: {
              shape: "S16"
            }
          }
        },
        So: {
          type: "structure",
          required: [
            "QueryString",
            "Cookies"
          ],
          members: {
            QueryString: {
              type: "boolean"
            },
            Cookies: {
              type: "structure",
              required: [
                "Forward"
              ],
              members: {
                Forward: {},
                WhitelistedNames: {
                  type: "structure",
                  required: [
                    "Quantity"
                  ],
                  members: {
                    Quantity: {
                      type: "integer"
                    },
                    Items: {
                      type: "list",
                      member: {
                        locationName: "Name"
                      }
                    }
                  }
                }
              }
            },
            Headers: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            },
            QueryStringCacheKeys: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "AwsAccountNumber"
              }
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "Quantity",
            "Items"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              shape: "S13"
            },
            CachedMethods: {
              type: "structure",
              required: [
                "Quantity",
                "Items"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  shape: "S13"
                }
              }
            }
          }
        },
        S13: {
          type: "list",
          member: {
            locationName: "Method"
          }
        },
        S16: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "LambdaFunctionAssociation",
                type: "structure",
                members: {
                  LambdaFunctionARN: {},
                  EventType: {}
                }
              }
            }
          }
        },
        S1a: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CacheBehavior",
                type: "structure",
                required: [
                  "PathPattern",
                  "TargetOriginId",
                  "ForwardedValues",
                  "TrustedSigners",
                  "ViewerProtocolPolicy",
                  "MinTTL"
                ],
                members: {
                  PathPattern: {},
                  TargetOriginId: {},
                  ForwardedValues: {
                    shape: "So"
                  },
                  TrustedSigners: {
                    shape: "Sy"
                  },
                  ViewerProtocolPolicy: {},
                  MinTTL: {
                    type: "long"
                  },
                  AllowedMethods: {
                    shape: "S12"
                  },
                  SmoothStreaming: {
                    type: "boolean"
                  },
                  DefaultTTL: {
                    type: "long"
                  },
                  MaxTTL: {
                    type: "long"
                  },
                  Compress: {
                    type: "boolean"
                  },
                  LambdaFunctionAssociations: {
                    shape: "S16"
                  }
                }
              }
            }
          }
        },
        S1d: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CustomErrorResponse",
                type: "structure",
                required: [
                  "ErrorCode"
                ],
                members: {
                  ErrorCode: {
                    type: "integer"
                  },
                  ResponsePagePath: {},
                  ResponseCode: {},
                  ErrorCachingMinTTL: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S1i: {
          type: "structure",
          members: {
            CloudFrontDefaultCertificate: {
              type: "boolean"
            },
            IAMCertificateId: {},
            ACMCertificateArn: {},
            SSLSupportMethod: {},
            MinimumProtocolVersion: {},
            Certificate: {
              deprecated: true
            },
            CertificateSource: {
              deprecated: true
            }
          }
        },
        S1m: {
          type: "structure",
          required: [
            "GeoRestriction"
          ],
          members: {
            GeoRestriction: {
              type: "structure",
              required: [
                "RestrictionType",
                "Quantity"
              ],
              members: {
                RestrictionType: {},
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Location"
                  }
                }
              }
            }
          }
        },
        S1s: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "LastModifiedTime",
            "InProgressInvalidationBatches",
            "DomainName",
            "ActiveTrustedSigners",
            "DistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            InProgressInvalidationBatches: {
              type: "integer"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S1u"
            },
            DistributionConfig: {
              shape: "S7"
            }
          }
        },
        S1u: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Signer",
                type: "structure",
                members: {
                  AwsAccountNumber: {},
                  KeyPairIds: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "KeyPairId"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S21: {
          type: "structure",
          members: {
            Items: {
              type: "list",
              member: {
                locationName: "Tag",
                type: "structure",
                required: [
                  "Key"
                ],
                members: {
                  Key: {},
                  Value: {}
                }
              }
            }
          }
        },
        S28: {
          type: "structure",
          required: [
            "Paths",
            "CallerReference"
          ],
          members: {
            Paths: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Path"
                  }
                }
              }
            },
            CallerReference: {}
          }
        },
        S2c: {
          type: "structure",
          required: [
            "Id",
            "Status",
            "CreateTime",
            "InvalidationBatch"
          ],
          members: {
            Id: {},
            Status: {},
            CreateTime: {
              type: "timestamp"
            },
            InvalidationBatch: {
              shape: "S28"
            }
          }
        },
        S2e: {
          type: "structure",
          required: [
            "CallerReference",
            "S3Origin",
            "Comment",
            "TrustedSigners",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            S3Origin: {
              shape: "S2f"
            },
            Aliases: {
              shape: "S8"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            TrustedSigners: {
              shape: "Sy"
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            }
          }
        },
        S2f: {
          type: "structure",
          required: [
            "DomainName",
            "OriginAccessIdentity"
          ],
          members: {
            DomainName: {},
            OriginAccessIdentity: {}
          }
        },
        S2i: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "DomainName",
            "ActiveTrustedSigners",
            "StreamingDistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S1u"
            },
            StreamingDistributionConfig: {
              shape: "S2e"
            }
          }
        },
        S3a: {
          type: "structure",
          required: [
            "Marker",
            "MaxItems",
            "IsTruncated",
            "Quantity"
          ],
          members: {
            Marker: {},
            NextMarker: {},
            MaxItems: {
              type: "integer"
            },
            IsTruncated: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "DistributionSummary",
                type: "structure",
                required: [
                  "Id",
                  "ARN",
                  "Status",
                  "LastModifiedTime",
                  "DomainName",
                  "Aliases",
                  "Origins",
                  "DefaultCacheBehavior",
                  "CacheBehaviors",
                  "CustomErrorResponses",
                  "Comment",
                  "PriceClass",
                  "Enabled",
                  "ViewerCertificate",
                  "Restrictions",
                  "WebACLId",
                  "HttpVersion",
                  "IsIPV6Enabled"
                ],
                members: {
                  Id: {},
                  ARN: {},
                  Status: {},
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  DomainName: {},
                  Aliases: {
                    shape: "S8"
                  },
                  Origins: {
                    shape: "Sb"
                  },
                  DefaultCacheBehavior: {
                    shape: "Sn"
                  },
                  CacheBehaviors: {
                    shape: "S1a"
                  },
                  CustomErrorResponses: {
                    shape: "S1d"
                  },
                  Comment: {},
                  PriceClass: {},
                  Enabled: {
                    type: "boolean"
                  },
                  ViewerCertificate: {
                    shape: "S1i"
                  },
                  Restrictions: {
                    shape: "S1m"
                  },
                  WebACLId: {},
                  HttpVersion: {},
                  IsIPV6Enabled: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2016-11-25.paginators.json
var require_cloudfront_2016_11_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2016-11-25.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListCloudFrontOriginAccessIdentities: {
          input_token: "Marker",
          output_token: "CloudFrontOriginAccessIdentityList.NextMarker",
          limit_key: "MaxItems",
          more_results: "CloudFrontOriginAccessIdentityList.IsTruncated",
          result_key: "CloudFrontOriginAccessIdentityList.Items"
        },
        ListDistributions: {
          input_token: "Marker",
          output_token: "DistributionList.NextMarker",
          limit_key: "MaxItems",
          more_results: "DistributionList.IsTruncated",
          result_key: "DistributionList.Items"
        },
        ListInvalidations: {
          input_token: "Marker",
          output_token: "InvalidationList.NextMarker",
          limit_key: "MaxItems",
          more_results: "InvalidationList.IsTruncated",
          result_key: "InvalidationList.Items"
        },
        ListStreamingDistributions: {
          input_token: "Marker",
          output_token: "StreamingDistributionList.NextMarker",
          limit_key: "MaxItems",
          more_results: "StreamingDistributionList.IsTruncated",
          result_key: "StreamingDistributionList.Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2016-11-25.waiters2.json
var require_cloudfront_2016_11_25_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2016-11-25.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DistributionDeployed: {
          delay: 60,
          operation: "GetDistribution",
          maxAttempts: 25,
          description: "Wait until a distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "Distribution.Status"
            }
          ]
        },
        InvalidationCompleted: {
          delay: 20,
          operation: "GetInvalidation",
          maxAttempts: 30,
          description: "Wait until an invalidation has completed.",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "Invalidation.Status"
            }
          ]
        },
        StreamingDistributionDeployed: {
          delay: 60,
          operation: "GetStreamingDistribution",
          maxAttempts: 25,
          description: "Wait until a streaming distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "StreamingDistribution.Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2017-03-25.min.json
var require_cloudfront_2017_03_25_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2017-03-25.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-03-25",
        endpointPrefix: "cloudfront",
        globalEndpoint: "cloudfront.amazonaws.com",
        protocol: "rest-xml",
        serviceAbbreviation: "CloudFront",
        serviceFullName: "Amazon CloudFront",
        serviceId: "CloudFront",
        signatureVersion: "v4",
        uid: "cloudfront-2017-03-25"
      },
      operations: {
        CreateCloudFrontOriginAccessIdentity: {
          http: {
            requestUri: "/2017-03-25/origin-access-identity/cloudfront",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        CreateDistribution: {
          http: {
            requestUri: "/2017-03-25/distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                }
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1s"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateDistributionWithTags: {
          http: {
            requestUri: "/2017-03-25/distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfigWithTags"
            ],
            members: {
              DistributionConfigWithTags: {
                locationName: "DistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                },
                type: "structure",
                required: [
                  "DistributionConfig",
                  "Tags"
                ],
                members: {
                  DistributionConfig: {
                    shape: "S7"
                  },
                  Tags: {
                    shape: "S21"
                  }
                }
              }
            },
            payload: "DistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1s"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateInvalidation: {
          http: {
            requestUri: "/2017-03-25/distribution/{DistributionId}/invalidation",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "InvalidationBatch"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              InvalidationBatch: {
                shape: "S28",
                locationName: "InvalidationBatch",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                }
              }
            },
            payload: "InvalidationBatch"
          },
          output: {
            type: "structure",
            members: {
              Location: {
                location: "header",
                locationName: "Location"
              },
              Invalidation: {
                shape: "S2c"
              }
            },
            payload: "Invalidation"
          }
        },
        CreateStreamingDistribution: {
          http: {
            requestUri: "/2017-03-25/streaming-distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S2e",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                }
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S2i"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        CreateStreamingDistributionWithTags: {
          http: {
            requestUri: "/2017-03-25/streaming-distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfigWithTags"
            ],
            members: {
              StreamingDistributionConfigWithTags: {
                locationName: "StreamingDistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                },
                type: "structure",
                required: [
                  "StreamingDistributionConfig",
                  "Tags"
                ],
                members: {
                  StreamingDistributionConfig: {
                    shape: "S2e"
                  },
                  Tags: {
                    shape: "S21"
                  }
                }
              }
            },
            payload: "StreamingDistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S2i"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        DeleteCloudFrontOriginAccessIdentity: {
          http: {
            method: "DELETE",
            requestUri: "/2017-03-25/origin-access-identity/cloudfront/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2017-03-25/distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteServiceLinkedRole: {
          http: {
            method: "DELETE",
            requestUri: "/2017-03-25/service-linked-role/{RoleName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "RoleName"
            ],
            members: {
              RoleName: {
                location: "uri",
                locationName: "RoleName"
              }
            }
          }
        },
        DeleteStreamingDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2017-03-25/streaming-distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        GetCloudFrontOriginAccessIdentity: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/origin-access-identity/cloudfront/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        GetCloudFrontOriginAccessIdentityConfig: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          }
        },
        GetDistribution: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1s"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        GetDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionConfig: {
                shape: "S7"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "DistributionConfig"
          }
        },
        GetInvalidation: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/distribution/{DistributionId}/invalidation/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "Id"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invalidation: {
                shape: "S2c"
              }
            },
            payload: "Invalidation"
          }
        },
        GetStreamingDistribution: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/streaming-distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S2i"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        GetStreamingDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionConfig: {
                shape: "S2e"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistributionConfig"
          }
        },
        ListCloudFrontOriginAccessIdentities: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/origin-access-identity/cloudfront"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "CloudFrontOriginAccessIdentitySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "S3CanonicalUserId",
                        "Comment"
                      ],
                      members: {
                        Id: {},
                        S3CanonicalUserId: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityList"
          }
        },
        ListDistributions: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S3b"
              }
            },
            payload: "DistributionList"
          }
        },
        ListDistributionsByWebACLId: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/distributionsByWebACLId/{WebACLId}"
          },
          input: {
            type: "structure",
            required: [
              "WebACLId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              WebACLId: {
                location: "uri",
                locationName: "WebACLId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S3b"
              }
            },
            payload: "DistributionList"
          }
        },
        ListInvalidations: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/distribution/{DistributionId}/invalidation"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InvalidationList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "InvalidationSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "CreateTime",
                        "Status"
                      ],
                      members: {
                        Id: {},
                        CreateTime: {
                          type: "timestamp"
                        },
                        Status: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "InvalidationList"
          }
        },
        ListStreamingDistributions: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/streaming-distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "StreamingDistributionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "ARN",
                        "Status",
                        "LastModifiedTime",
                        "DomainName",
                        "S3Origin",
                        "Aliases",
                        "TrustedSigners",
                        "Comment",
                        "PriceClass",
                        "Enabled"
                      ],
                      members: {
                        Id: {},
                        ARN: {},
                        Status: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        DomainName: {},
                        S3Origin: {
                          shape: "S2f"
                        },
                        Aliases: {
                          shape: "S8"
                        },
                        TrustedSigners: {
                          shape: "Sy"
                        },
                        Comment: {},
                        PriceClass: {},
                        Enabled: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "StreamingDistributionList"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2017-03-25/tagging"
          },
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "S21"
              }
            },
            payload: "Tags"
          }
        },
        TagResource: {
          http: {
            requestUri: "/2017-03-25/tagging?Operation=Tag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "Tags"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              Tags: {
                shape: "S21",
                locationName: "Tags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                }
              }
            },
            payload: "Tags"
          }
        },
        UntagResource: {
          http: {
            requestUri: "/2017-03-25/tagging?Operation=Untag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "TagKeys"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              TagKeys: {
                locationName: "TagKeys",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                },
                type: "structure",
                members: {
                  Items: {
                    type: "list",
                    member: {
                      locationName: "Key"
                    }
                  }
                }
              }
            },
            payload: "TagKeys"
          }
        },
        UpdateCloudFrontOriginAccessIdentity: {
          http: {
            method: "PUT",
            requestUri: "/2017-03-25/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig",
              "Id"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        UpdateDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2017-03-25/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig",
              "Id"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1s"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        UpdateStreamingDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2017-03-25/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig",
              "Id"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S2e",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-03-25/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S2i"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "CallerReference",
            "Comment"
          ],
          members: {
            CallerReference: {},
            Comment: {}
          }
        },
        S5: {
          type: "structure",
          required: [
            "Id",
            "S3CanonicalUserId"
          ],
          members: {
            Id: {},
            S3CanonicalUserId: {},
            CloudFrontOriginAccessIdentityConfig: {
              shape: "S2"
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "CallerReference",
            "Origins",
            "DefaultCacheBehavior",
            "Comment",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            Aliases: {
              shape: "S8"
            },
            DefaultRootObject: {},
            Origins: {
              shape: "Sb"
            },
            DefaultCacheBehavior: {
              shape: "Sn"
            },
            CacheBehaviors: {
              shape: "S1a"
            },
            CustomErrorResponses: {
              shape: "S1d"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "IncludeCookies",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                IncludeCookies: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            },
            ViewerCertificate: {
              shape: "S1i"
            },
            Restrictions: {
              shape: "S1m"
            },
            WebACLId: {},
            HttpVersion: {},
            IsIPV6Enabled: {
              type: "boolean"
            }
          }
        },
        S8: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CNAME"
              }
            }
          }
        },
        Sb: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Origin",
                type: "structure",
                required: [
                  "Id",
                  "DomainName"
                ],
                members: {
                  Id: {},
                  DomainName: {},
                  OriginPath: {},
                  CustomHeaders: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "OriginCustomHeader",
                          type: "structure",
                          required: [
                            "HeaderName",
                            "HeaderValue"
                          ],
                          members: {
                            HeaderName: {},
                            HeaderValue: {}
                          }
                        }
                      }
                    }
                  },
                  S3OriginConfig: {
                    type: "structure",
                    required: [
                      "OriginAccessIdentity"
                    ],
                    members: {
                      OriginAccessIdentity: {}
                    }
                  },
                  CustomOriginConfig: {
                    type: "structure",
                    required: [
                      "HTTPPort",
                      "HTTPSPort",
                      "OriginProtocolPolicy"
                    ],
                    members: {
                      HTTPPort: {
                        type: "integer"
                      },
                      HTTPSPort: {
                        type: "integer"
                      },
                      OriginProtocolPolicy: {},
                      OriginSslProtocols: {
                        type: "structure",
                        required: [
                          "Quantity",
                          "Items"
                        ],
                        members: {
                          Quantity: {
                            type: "integer"
                          },
                          Items: {
                            type: "list",
                            member: {
                              locationName: "SslProtocol"
                            }
                          }
                        }
                      },
                      OriginReadTimeout: {
                        type: "integer"
                      },
                      OriginKeepaliveTimeout: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "TargetOriginId",
            "ForwardedValues",
            "TrustedSigners",
            "ViewerProtocolPolicy",
            "MinTTL"
          ],
          members: {
            TargetOriginId: {},
            ForwardedValues: {
              shape: "So"
            },
            TrustedSigners: {
              shape: "Sy"
            },
            ViewerProtocolPolicy: {},
            MinTTL: {
              type: "long"
            },
            AllowedMethods: {
              shape: "S12"
            },
            SmoothStreaming: {
              type: "boolean"
            },
            DefaultTTL: {
              type: "long"
            },
            MaxTTL: {
              type: "long"
            },
            Compress: {
              type: "boolean"
            },
            LambdaFunctionAssociations: {
              shape: "S16"
            }
          }
        },
        So: {
          type: "structure",
          required: [
            "QueryString",
            "Cookies"
          ],
          members: {
            QueryString: {
              type: "boolean"
            },
            Cookies: {
              type: "structure",
              required: [
                "Forward"
              ],
              members: {
                Forward: {},
                WhitelistedNames: {
                  type: "structure",
                  required: [
                    "Quantity"
                  ],
                  members: {
                    Quantity: {
                      type: "integer"
                    },
                    Items: {
                      type: "list",
                      member: {
                        locationName: "Name"
                      }
                    }
                  }
                }
              }
            },
            Headers: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            },
            QueryStringCacheKeys: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "AwsAccountNumber"
              }
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "Quantity",
            "Items"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              shape: "S13"
            },
            CachedMethods: {
              type: "structure",
              required: [
                "Quantity",
                "Items"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  shape: "S13"
                }
              }
            }
          }
        },
        S13: {
          type: "list",
          member: {
            locationName: "Method"
          }
        },
        S16: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "LambdaFunctionAssociation",
                type: "structure",
                members: {
                  LambdaFunctionARN: {},
                  EventType: {}
                }
              }
            }
          }
        },
        S1a: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CacheBehavior",
                type: "structure",
                required: [
                  "PathPattern",
                  "TargetOriginId",
                  "ForwardedValues",
                  "TrustedSigners",
                  "ViewerProtocolPolicy",
                  "MinTTL"
                ],
                members: {
                  PathPattern: {},
                  TargetOriginId: {},
                  ForwardedValues: {
                    shape: "So"
                  },
                  TrustedSigners: {
                    shape: "Sy"
                  },
                  ViewerProtocolPolicy: {},
                  MinTTL: {
                    type: "long"
                  },
                  AllowedMethods: {
                    shape: "S12"
                  },
                  SmoothStreaming: {
                    type: "boolean"
                  },
                  DefaultTTL: {
                    type: "long"
                  },
                  MaxTTL: {
                    type: "long"
                  },
                  Compress: {
                    type: "boolean"
                  },
                  LambdaFunctionAssociations: {
                    shape: "S16"
                  }
                }
              }
            }
          }
        },
        S1d: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CustomErrorResponse",
                type: "structure",
                required: [
                  "ErrorCode"
                ],
                members: {
                  ErrorCode: {
                    type: "integer"
                  },
                  ResponsePagePath: {},
                  ResponseCode: {},
                  ErrorCachingMinTTL: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S1i: {
          type: "structure",
          members: {
            CloudFrontDefaultCertificate: {
              type: "boolean"
            },
            IAMCertificateId: {},
            ACMCertificateArn: {},
            SSLSupportMethod: {},
            MinimumProtocolVersion: {},
            Certificate: {
              deprecated: true
            },
            CertificateSource: {
              deprecated: true
            }
          }
        },
        S1m: {
          type: "structure",
          required: [
            "GeoRestriction"
          ],
          members: {
            GeoRestriction: {
              type: "structure",
              required: [
                "RestrictionType",
                "Quantity"
              ],
              members: {
                RestrictionType: {},
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Location"
                  }
                }
              }
            }
          }
        },
        S1s: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "LastModifiedTime",
            "InProgressInvalidationBatches",
            "DomainName",
            "ActiveTrustedSigners",
            "DistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            InProgressInvalidationBatches: {
              type: "integer"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S1u"
            },
            DistributionConfig: {
              shape: "S7"
            }
          }
        },
        S1u: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Signer",
                type: "structure",
                members: {
                  AwsAccountNumber: {},
                  KeyPairIds: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "KeyPairId"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S21: {
          type: "structure",
          members: {
            Items: {
              type: "list",
              member: {
                locationName: "Tag",
                type: "structure",
                required: [
                  "Key"
                ],
                members: {
                  Key: {},
                  Value: {}
                }
              }
            }
          }
        },
        S28: {
          type: "structure",
          required: [
            "Paths",
            "CallerReference"
          ],
          members: {
            Paths: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Path"
                  }
                }
              }
            },
            CallerReference: {}
          }
        },
        S2c: {
          type: "structure",
          required: [
            "Id",
            "Status",
            "CreateTime",
            "InvalidationBatch"
          ],
          members: {
            Id: {},
            Status: {},
            CreateTime: {
              type: "timestamp"
            },
            InvalidationBatch: {
              shape: "S28"
            }
          }
        },
        S2e: {
          type: "structure",
          required: [
            "CallerReference",
            "S3Origin",
            "Comment",
            "TrustedSigners",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            S3Origin: {
              shape: "S2f"
            },
            Aliases: {
              shape: "S8"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            TrustedSigners: {
              shape: "Sy"
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            }
          }
        },
        S2f: {
          type: "structure",
          required: [
            "DomainName",
            "OriginAccessIdentity"
          ],
          members: {
            DomainName: {},
            OriginAccessIdentity: {}
          }
        },
        S2i: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "DomainName",
            "ActiveTrustedSigners",
            "StreamingDistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S1u"
            },
            StreamingDistributionConfig: {
              shape: "S2e"
            }
          }
        },
        S3b: {
          type: "structure",
          required: [
            "Marker",
            "MaxItems",
            "IsTruncated",
            "Quantity"
          ],
          members: {
            Marker: {},
            NextMarker: {},
            MaxItems: {
              type: "integer"
            },
            IsTruncated: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "DistributionSummary",
                type: "structure",
                required: [
                  "Id",
                  "ARN",
                  "Status",
                  "LastModifiedTime",
                  "DomainName",
                  "Aliases",
                  "Origins",
                  "DefaultCacheBehavior",
                  "CacheBehaviors",
                  "CustomErrorResponses",
                  "Comment",
                  "PriceClass",
                  "Enabled",
                  "ViewerCertificate",
                  "Restrictions",
                  "WebACLId",
                  "HttpVersion",
                  "IsIPV6Enabled"
                ],
                members: {
                  Id: {},
                  ARN: {},
                  Status: {},
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  DomainName: {},
                  Aliases: {
                    shape: "S8"
                  },
                  Origins: {
                    shape: "Sb"
                  },
                  DefaultCacheBehavior: {
                    shape: "Sn"
                  },
                  CacheBehaviors: {
                    shape: "S1a"
                  },
                  CustomErrorResponses: {
                    shape: "S1d"
                  },
                  Comment: {},
                  PriceClass: {},
                  Enabled: {
                    type: "boolean"
                  },
                  ViewerCertificate: {
                    shape: "S1i"
                  },
                  Restrictions: {
                    shape: "S1m"
                  },
                  WebACLId: {},
                  HttpVersion: {},
                  IsIPV6Enabled: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2017-03-25.paginators.json
var require_cloudfront_2017_03_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2017-03-25.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListCloudFrontOriginAccessIdentities: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "CloudFrontOriginAccessIdentityList.IsTruncated",
          output_token: "CloudFrontOriginAccessIdentityList.NextMarker",
          result_key: "CloudFrontOriginAccessIdentityList.Items"
        },
        ListDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "DistributionList.IsTruncated",
          output_token: "DistributionList.NextMarker",
          result_key: "DistributionList.Items"
        },
        ListInvalidations: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "InvalidationList.IsTruncated",
          output_token: "InvalidationList.NextMarker",
          result_key: "InvalidationList.Items"
        },
        ListStreamingDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "StreamingDistributionList.IsTruncated",
          output_token: "StreamingDistributionList.NextMarker",
          result_key: "StreamingDistributionList.Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2017-03-25.waiters2.json
var require_cloudfront_2017_03_25_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2017-03-25.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DistributionDeployed: {
          delay: 60,
          operation: "GetDistribution",
          maxAttempts: 25,
          description: "Wait until a distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "Distribution.Status"
            }
          ]
        },
        InvalidationCompleted: {
          delay: 20,
          operation: "GetInvalidation",
          maxAttempts: 30,
          description: "Wait until an invalidation has completed.",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "Invalidation.Status"
            }
          ]
        },
        StreamingDistributionDeployed: {
          delay: 60,
          operation: "GetStreamingDistribution",
          maxAttempts: 25,
          description: "Wait until a streaming distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "StreamingDistribution.Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2017-10-30.min.json
var require_cloudfront_2017_10_30_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2017-10-30.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-10-30",
        endpointPrefix: "cloudfront",
        globalEndpoint: "cloudfront.amazonaws.com",
        protocol: "rest-xml",
        serviceAbbreviation: "CloudFront",
        serviceFullName: "Amazon CloudFront",
        serviceId: "CloudFront",
        signatureVersion: "v4",
        uid: "cloudfront-2017-10-30"
      },
      operations: {
        CreateCloudFrontOriginAccessIdentity: {
          http: {
            requestUri: "/2017-10-30/origin-access-identity/cloudfront",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        CreateDistribution: {
          http: {
            requestUri: "/2017-10-30/distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1t"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateDistributionWithTags: {
          http: {
            requestUri: "/2017-10-30/distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfigWithTags"
            ],
            members: {
              DistributionConfigWithTags: {
                locationName: "DistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                },
                type: "structure",
                required: [
                  "DistributionConfig",
                  "Tags"
                ],
                members: {
                  DistributionConfig: {
                    shape: "S7"
                  },
                  Tags: {
                    shape: "S22"
                  }
                }
              }
            },
            payload: "DistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1t"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateFieldLevelEncryptionConfig: {
          http: {
            requestUri: "/2017-10-30/field-level-encryption",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionConfig"
            ],
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S29",
                locationName: "FieldLevelEncryptionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              }
            },
            payload: "FieldLevelEncryptionConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2k"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        CreateFieldLevelEncryptionProfile: {
          http: {
            requestUri: "/2017-10-30/field-level-encryption-profile",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionProfileConfig"
            ],
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2m",
                locationName: "FieldLevelEncryptionProfileConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S2t"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        CreateInvalidation: {
          http: {
            requestUri: "/2017-10-30/distribution/{DistributionId}/invalidation",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "InvalidationBatch"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              InvalidationBatch: {
                shape: "S2v",
                locationName: "InvalidationBatch",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              }
            },
            payload: "InvalidationBatch"
          },
          output: {
            type: "structure",
            members: {
              Location: {
                location: "header",
                locationName: "Location"
              },
              Invalidation: {
                shape: "S2z"
              }
            },
            payload: "Invalidation"
          }
        },
        CreatePublicKey: {
          http: {
            requestUri: "/2017-10-30/public-key",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "PublicKeyConfig"
            ],
            members: {
              PublicKeyConfig: {
                shape: "S31",
                locationName: "PublicKeyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              }
            },
            payload: "PublicKeyConfig"
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S33"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        CreateStreamingDistribution: {
          http: {
            requestUri: "/2017-10-30/streaming-distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S35",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S39"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        CreateStreamingDistributionWithTags: {
          http: {
            requestUri: "/2017-10-30/streaming-distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfigWithTags"
            ],
            members: {
              StreamingDistributionConfigWithTags: {
                locationName: "StreamingDistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                },
                type: "structure",
                required: [
                  "StreamingDistributionConfig",
                  "Tags"
                ],
                members: {
                  StreamingDistributionConfig: {
                    shape: "S35"
                  },
                  Tags: {
                    shape: "S22"
                  }
                }
              }
            },
            payload: "StreamingDistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S39"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        DeleteCloudFrontOriginAccessIdentity: {
          http: {
            method: "DELETE",
            requestUri: "/2017-10-30/origin-access-identity/cloudfront/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2017-10-30/distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFieldLevelEncryptionConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2017-10-30/field-level-encryption/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFieldLevelEncryptionProfile: {
          http: {
            method: "DELETE",
            requestUri: "/2017-10-30/field-level-encryption-profile/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeletePublicKey: {
          http: {
            method: "DELETE",
            requestUri: "/2017-10-30/public-key/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteStreamingDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2017-10-30/streaming-distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        GetCloudFrontOriginAccessIdentity: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/origin-access-identity/cloudfront/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        GetCloudFrontOriginAccessIdentityConfig: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          }
        },
        GetDistribution: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        GetDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionConfig: {
                shape: "S7"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "DistributionConfig"
          }
        },
        GetFieldLevelEncryption: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/field-level-encryption/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2k"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        GetFieldLevelEncryptionConfig: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/field-level-encryption/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S29"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionConfig"
          }
        },
        GetFieldLevelEncryptionProfile: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/field-level-encryption-profile/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S2t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        GetFieldLevelEncryptionProfileConfig: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/field-level-encryption-profile/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2m"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          }
        },
        GetInvalidation: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/distribution/{DistributionId}/invalidation/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "Id"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invalidation: {
                shape: "S2z"
              }
            },
            payload: "Invalidation"
          }
        },
        GetPublicKey: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/public-key/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S33"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        GetPublicKeyConfig: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/public-key/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyConfig: {
                shape: "S31"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKeyConfig"
          }
        },
        GetStreamingDistribution: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/streaming-distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S39"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        GetStreamingDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionConfig: {
                shape: "S35"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistributionConfig"
          }
        },
        ListCloudFrontOriginAccessIdentities: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/origin-access-identity/cloudfront"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "CloudFrontOriginAccessIdentitySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "S3CanonicalUserId",
                        "Comment"
                      ],
                      members: {
                        Id: {},
                        S3CanonicalUserId: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityList"
          }
        },
        ListDistributions: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S4g"
              }
            },
            payload: "DistributionList"
          }
        },
        ListDistributionsByWebACLId: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/distributionsByWebACLId/{WebACLId}"
          },
          input: {
            type: "structure",
            required: [
              "WebACLId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              WebACLId: {
                location: "uri",
                locationName: "WebACLId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S4g"
              }
            },
            payload: "DistributionList"
          }
        },
        ListFieldLevelEncryptionConfigs: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/field-level-encryption"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "FieldLevelEncryptionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "LastModifiedTime"
                      ],
                      members: {
                        Id: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Comment: {},
                        QueryArgProfileConfig: {
                          shape: "S2a"
                        },
                        ContentTypeProfileConfig: {
                          shape: "S2e"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "FieldLevelEncryptionList"
          }
        },
        ListFieldLevelEncryptionProfiles: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/field-level-encryption-profile"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfileList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "FieldLevelEncryptionProfileSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "LastModifiedTime",
                        "Name",
                        "EncryptionEntities"
                      ],
                      members: {
                        Id: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Name: {},
                        EncryptionEntities: {
                          shape: "S2n"
                        },
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "FieldLevelEncryptionProfileList"
          }
        },
        ListInvalidations: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/distribution/{DistributionId}/invalidation"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InvalidationList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "InvalidationSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "CreateTime",
                        "Status"
                      ],
                      members: {
                        Id: {},
                        CreateTime: {
                          type: "timestamp"
                        },
                        Status: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "InvalidationList"
          }
        },
        ListPublicKeys: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/public-key"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "PublicKeySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "Name",
                        "CreatedTime",
                        "EncodedKey"
                      ],
                      members: {
                        Id: {},
                        Name: {},
                        CreatedTime: {
                          type: "timestamp"
                        },
                        EncodedKey: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "PublicKeyList"
          }
        },
        ListStreamingDistributions: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/streaming-distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "StreamingDistributionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "ARN",
                        "Status",
                        "LastModifiedTime",
                        "DomainName",
                        "S3Origin",
                        "Aliases",
                        "TrustedSigners",
                        "Comment",
                        "PriceClass",
                        "Enabled"
                      ],
                      members: {
                        Id: {},
                        ARN: {},
                        Status: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        DomainName: {},
                        S3Origin: {
                          shape: "S36"
                        },
                        Aliases: {
                          shape: "S8"
                        },
                        TrustedSigners: {
                          shape: "Sy"
                        },
                        Comment: {},
                        PriceClass: {},
                        Enabled: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "StreamingDistributionList"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2017-10-30/tagging"
          },
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "S22"
              }
            },
            payload: "Tags"
          }
        },
        TagResource: {
          http: {
            requestUri: "/2017-10-30/tagging?Operation=Tag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "Tags"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              Tags: {
                shape: "S22",
                locationName: "Tags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              }
            },
            payload: "Tags"
          }
        },
        UntagResource: {
          http: {
            requestUri: "/2017-10-30/tagging?Operation=Untag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "TagKeys"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              TagKeys: {
                locationName: "TagKeys",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                },
                type: "structure",
                members: {
                  Items: {
                    type: "list",
                    member: {
                      locationName: "Key"
                    }
                  }
                }
              }
            },
            payload: "TagKeys"
          }
        },
        UpdateCloudFrontOriginAccessIdentity: {
          http: {
            method: "PUT",
            requestUri: "/2017-10-30/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig",
              "Id"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        UpdateDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2017-10-30/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig",
              "Id"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        UpdateFieldLevelEncryptionConfig: {
          http: {
            method: "PUT",
            requestUri: "/2017-10-30/field-level-encryption/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionConfig",
              "Id"
            ],
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S29",
                locationName: "FieldLevelEncryptionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "FieldLevelEncryptionConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2k"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        UpdateFieldLevelEncryptionProfile: {
          http: {
            method: "PUT",
            requestUri: "/2017-10-30/field-level-encryption-profile/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionProfileConfig",
              "Id"
            ],
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2m",
                locationName: "FieldLevelEncryptionProfileConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S2t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        UpdatePublicKey: {
          http: {
            method: "PUT",
            requestUri: "/2017-10-30/public-key/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "PublicKeyConfig",
              "Id"
            ],
            members: {
              PublicKeyConfig: {
                shape: "S31",
                locationName: "PublicKeyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "PublicKeyConfig"
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S33"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        UpdateStreamingDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2017-10-30/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig",
              "Id"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S35",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2017-10-30/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S39"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "CallerReference",
            "Comment"
          ],
          members: {
            CallerReference: {},
            Comment: {}
          }
        },
        S5: {
          type: "structure",
          required: [
            "Id",
            "S3CanonicalUserId"
          ],
          members: {
            Id: {},
            S3CanonicalUserId: {},
            CloudFrontOriginAccessIdentityConfig: {
              shape: "S2"
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "CallerReference",
            "Origins",
            "DefaultCacheBehavior",
            "Comment",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            Aliases: {
              shape: "S8"
            },
            DefaultRootObject: {},
            Origins: {
              shape: "Sb"
            },
            DefaultCacheBehavior: {
              shape: "Sn"
            },
            CacheBehaviors: {
              shape: "S1b"
            },
            CustomErrorResponses: {
              shape: "S1e"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "IncludeCookies",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                IncludeCookies: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            },
            ViewerCertificate: {
              shape: "S1j"
            },
            Restrictions: {
              shape: "S1n"
            },
            WebACLId: {},
            HttpVersion: {},
            IsIPV6Enabled: {
              type: "boolean"
            }
          }
        },
        S8: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CNAME"
              }
            }
          }
        },
        Sb: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Origin",
                type: "structure",
                required: [
                  "Id",
                  "DomainName"
                ],
                members: {
                  Id: {},
                  DomainName: {},
                  OriginPath: {},
                  CustomHeaders: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "OriginCustomHeader",
                          type: "structure",
                          required: [
                            "HeaderName",
                            "HeaderValue"
                          ],
                          members: {
                            HeaderName: {},
                            HeaderValue: {}
                          }
                        }
                      }
                    }
                  },
                  S3OriginConfig: {
                    type: "structure",
                    required: [
                      "OriginAccessIdentity"
                    ],
                    members: {
                      OriginAccessIdentity: {}
                    }
                  },
                  CustomOriginConfig: {
                    type: "structure",
                    required: [
                      "HTTPPort",
                      "HTTPSPort",
                      "OriginProtocolPolicy"
                    ],
                    members: {
                      HTTPPort: {
                        type: "integer"
                      },
                      HTTPSPort: {
                        type: "integer"
                      },
                      OriginProtocolPolicy: {},
                      OriginSslProtocols: {
                        type: "structure",
                        required: [
                          "Quantity",
                          "Items"
                        ],
                        members: {
                          Quantity: {
                            type: "integer"
                          },
                          Items: {
                            type: "list",
                            member: {
                              locationName: "SslProtocol"
                            }
                          }
                        }
                      },
                      OriginReadTimeout: {
                        type: "integer"
                      },
                      OriginKeepaliveTimeout: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "TargetOriginId",
            "ForwardedValues",
            "TrustedSigners",
            "ViewerProtocolPolicy",
            "MinTTL"
          ],
          members: {
            TargetOriginId: {},
            ForwardedValues: {
              shape: "So"
            },
            TrustedSigners: {
              shape: "Sy"
            },
            ViewerProtocolPolicy: {},
            MinTTL: {
              type: "long"
            },
            AllowedMethods: {
              shape: "S12"
            },
            SmoothStreaming: {
              type: "boolean"
            },
            DefaultTTL: {
              type: "long"
            },
            MaxTTL: {
              type: "long"
            },
            Compress: {
              type: "boolean"
            },
            LambdaFunctionAssociations: {
              shape: "S16"
            },
            FieldLevelEncryptionId: {}
          }
        },
        So: {
          type: "structure",
          required: [
            "QueryString",
            "Cookies"
          ],
          members: {
            QueryString: {
              type: "boolean"
            },
            Cookies: {
              type: "structure",
              required: [
                "Forward"
              ],
              members: {
                Forward: {},
                WhitelistedNames: {
                  type: "structure",
                  required: [
                    "Quantity"
                  ],
                  members: {
                    Quantity: {
                      type: "integer"
                    },
                    Items: {
                      type: "list",
                      member: {
                        locationName: "Name"
                      }
                    }
                  }
                }
              }
            },
            Headers: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            },
            QueryStringCacheKeys: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "AwsAccountNumber"
              }
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "Quantity",
            "Items"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              shape: "S13"
            },
            CachedMethods: {
              type: "structure",
              required: [
                "Quantity",
                "Items"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  shape: "S13"
                }
              }
            }
          }
        },
        S13: {
          type: "list",
          member: {
            locationName: "Method"
          }
        },
        S16: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "LambdaFunctionAssociation",
                type: "structure",
                required: [
                  "LambdaFunctionARN",
                  "EventType"
                ],
                members: {
                  LambdaFunctionARN: {},
                  EventType: {}
                }
              }
            }
          }
        },
        S1b: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CacheBehavior",
                type: "structure",
                required: [
                  "PathPattern",
                  "TargetOriginId",
                  "ForwardedValues",
                  "TrustedSigners",
                  "ViewerProtocolPolicy",
                  "MinTTL"
                ],
                members: {
                  PathPattern: {},
                  TargetOriginId: {},
                  ForwardedValues: {
                    shape: "So"
                  },
                  TrustedSigners: {
                    shape: "Sy"
                  },
                  ViewerProtocolPolicy: {},
                  MinTTL: {
                    type: "long"
                  },
                  AllowedMethods: {
                    shape: "S12"
                  },
                  SmoothStreaming: {
                    type: "boolean"
                  },
                  DefaultTTL: {
                    type: "long"
                  },
                  MaxTTL: {
                    type: "long"
                  },
                  Compress: {
                    type: "boolean"
                  },
                  LambdaFunctionAssociations: {
                    shape: "S16"
                  },
                  FieldLevelEncryptionId: {}
                }
              }
            }
          }
        },
        S1e: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CustomErrorResponse",
                type: "structure",
                required: [
                  "ErrorCode"
                ],
                members: {
                  ErrorCode: {
                    type: "integer"
                  },
                  ResponsePagePath: {},
                  ResponseCode: {},
                  ErrorCachingMinTTL: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            CloudFrontDefaultCertificate: {
              type: "boolean"
            },
            IAMCertificateId: {},
            ACMCertificateArn: {},
            SSLSupportMethod: {},
            MinimumProtocolVersion: {},
            Certificate: {
              deprecated: true
            },
            CertificateSource: {
              deprecated: true
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "GeoRestriction"
          ],
          members: {
            GeoRestriction: {
              type: "structure",
              required: [
                "RestrictionType",
                "Quantity"
              ],
              members: {
                RestrictionType: {},
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Location"
                  }
                }
              }
            }
          }
        },
        S1t: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "LastModifiedTime",
            "InProgressInvalidationBatches",
            "DomainName",
            "ActiveTrustedSigners",
            "DistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            InProgressInvalidationBatches: {
              type: "integer"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S1v"
            },
            DistributionConfig: {
              shape: "S7"
            }
          }
        },
        S1v: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Signer",
                type: "structure",
                members: {
                  AwsAccountNumber: {},
                  KeyPairIds: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "KeyPairId"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S22: {
          type: "structure",
          members: {
            Items: {
              type: "list",
              member: {
                locationName: "Tag",
                type: "structure",
                required: [
                  "Key"
                ],
                members: {
                  Key: {},
                  Value: {}
                }
              }
            }
          }
        },
        S29: {
          type: "structure",
          required: [
            "CallerReference"
          ],
          members: {
            CallerReference: {},
            Comment: {},
            QueryArgProfileConfig: {
              shape: "S2a"
            },
            ContentTypeProfileConfig: {
              shape: "S2e"
            }
          }
        },
        S2a: {
          type: "structure",
          required: [
            "ForwardWhenQueryArgProfileIsUnknown"
          ],
          members: {
            ForwardWhenQueryArgProfileIsUnknown: {
              type: "boolean"
            },
            QueryArgProfiles: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "QueryArgProfile",
                    type: "structure",
                    required: [
                      "QueryArg",
                      "ProfileId"
                    ],
                    members: {
                      QueryArg: {},
                      ProfileId: {}
                    }
                  }
                }
              }
            }
          }
        },
        S2e: {
          type: "structure",
          required: [
            "ForwardWhenContentTypeIsUnknown"
          ],
          members: {
            ForwardWhenContentTypeIsUnknown: {
              type: "boolean"
            },
            ContentTypeProfiles: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "ContentTypeProfile",
                    type: "structure",
                    required: [
                      "Format",
                      "ContentType"
                    ],
                    members: {
                      Format: {},
                      ProfileId: {},
                      ContentType: {}
                    }
                  }
                }
              }
            }
          }
        },
        S2k: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "FieldLevelEncryptionConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            FieldLevelEncryptionConfig: {
              shape: "S29"
            }
          }
        },
        S2m: {
          type: "structure",
          required: [
            "Name",
            "CallerReference",
            "EncryptionEntities"
          ],
          members: {
            Name: {},
            CallerReference: {},
            Comment: {},
            EncryptionEntities: {
              shape: "S2n"
            }
          }
        },
        S2n: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "EncryptionEntity",
                type: "structure",
                required: [
                  "PublicKeyId",
                  "ProviderId",
                  "FieldPatterns"
                ],
                members: {
                  PublicKeyId: {},
                  ProviderId: {},
                  FieldPatterns: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "FieldPattern"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S2t: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "FieldLevelEncryptionProfileConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            FieldLevelEncryptionProfileConfig: {
              shape: "S2m"
            }
          }
        },
        S2v: {
          type: "structure",
          required: [
            "Paths",
            "CallerReference"
          ],
          members: {
            Paths: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Path"
                  }
                }
              }
            },
            CallerReference: {}
          }
        },
        S2z: {
          type: "structure",
          required: [
            "Id",
            "Status",
            "CreateTime",
            "InvalidationBatch"
          ],
          members: {
            Id: {},
            Status: {},
            CreateTime: {
              type: "timestamp"
            },
            InvalidationBatch: {
              shape: "S2v"
            }
          }
        },
        S31: {
          type: "structure",
          required: [
            "CallerReference",
            "Name",
            "EncodedKey"
          ],
          members: {
            CallerReference: {},
            Name: {},
            EncodedKey: {},
            Comment: {}
          }
        },
        S33: {
          type: "structure",
          required: [
            "Id",
            "CreatedTime",
            "PublicKeyConfig"
          ],
          members: {
            Id: {},
            CreatedTime: {
              type: "timestamp"
            },
            PublicKeyConfig: {
              shape: "S31"
            }
          }
        },
        S35: {
          type: "structure",
          required: [
            "CallerReference",
            "S3Origin",
            "Comment",
            "TrustedSigners",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            S3Origin: {
              shape: "S36"
            },
            Aliases: {
              shape: "S8"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            TrustedSigners: {
              shape: "Sy"
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            }
          }
        },
        S36: {
          type: "structure",
          required: [
            "DomainName",
            "OriginAccessIdentity"
          ],
          members: {
            DomainName: {},
            OriginAccessIdentity: {}
          }
        },
        S39: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "DomainName",
            "ActiveTrustedSigners",
            "StreamingDistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S1v"
            },
            StreamingDistributionConfig: {
              shape: "S35"
            }
          }
        },
        S4g: {
          type: "structure",
          required: [
            "Marker",
            "MaxItems",
            "IsTruncated",
            "Quantity"
          ],
          members: {
            Marker: {},
            NextMarker: {},
            MaxItems: {
              type: "integer"
            },
            IsTruncated: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "DistributionSummary",
                type: "structure",
                required: [
                  "Id",
                  "ARN",
                  "Status",
                  "LastModifiedTime",
                  "DomainName",
                  "Aliases",
                  "Origins",
                  "DefaultCacheBehavior",
                  "CacheBehaviors",
                  "CustomErrorResponses",
                  "Comment",
                  "PriceClass",
                  "Enabled",
                  "ViewerCertificate",
                  "Restrictions",
                  "WebACLId",
                  "HttpVersion",
                  "IsIPV6Enabled"
                ],
                members: {
                  Id: {},
                  ARN: {},
                  Status: {},
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  DomainName: {},
                  Aliases: {
                    shape: "S8"
                  },
                  Origins: {
                    shape: "Sb"
                  },
                  DefaultCacheBehavior: {
                    shape: "Sn"
                  },
                  CacheBehaviors: {
                    shape: "S1b"
                  },
                  CustomErrorResponses: {
                    shape: "S1e"
                  },
                  Comment: {},
                  PriceClass: {},
                  Enabled: {
                    type: "boolean"
                  },
                  ViewerCertificate: {
                    shape: "S1j"
                  },
                  Restrictions: {
                    shape: "S1n"
                  },
                  WebACLId: {},
                  HttpVersion: {},
                  IsIPV6Enabled: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2017-10-30.paginators.json
var require_cloudfront_2017_10_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2017-10-30.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListCloudFrontOriginAccessIdentities: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "CloudFrontOriginAccessIdentityList.IsTruncated",
          output_token: "CloudFrontOriginAccessIdentityList.NextMarker",
          result_key: "CloudFrontOriginAccessIdentityList.Items"
        },
        ListDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "DistributionList.IsTruncated",
          output_token: "DistributionList.NextMarker",
          result_key: "DistributionList.Items"
        },
        ListInvalidations: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "InvalidationList.IsTruncated",
          output_token: "InvalidationList.NextMarker",
          result_key: "InvalidationList.Items"
        },
        ListStreamingDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "StreamingDistributionList.IsTruncated",
          output_token: "StreamingDistributionList.NextMarker",
          result_key: "StreamingDistributionList.Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2017-10-30.waiters2.json
var require_cloudfront_2017_10_30_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2017-10-30.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DistributionDeployed: {
          delay: 60,
          operation: "GetDistribution",
          maxAttempts: 25,
          description: "Wait until a distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "Distribution.Status"
            }
          ]
        },
        InvalidationCompleted: {
          delay: 20,
          operation: "GetInvalidation",
          maxAttempts: 30,
          description: "Wait until an invalidation has completed.",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "Invalidation.Status"
            }
          ]
        },
        StreamingDistributionDeployed: {
          delay: 60,
          operation: "GetStreamingDistribution",
          maxAttempts: 25,
          description: "Wait until a streaming distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "StreamingDistribution.Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2018-06-18.min.json
var require_cloudfront_2018_06_18_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2018-06-18.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-06-18",
        endpointPrefix: "cloudfront",
        globalEndpoint: "cloudfront.amazonaws.com",
        protocol: "rest-xml",
        serviceAbbreviation: "CloudFront",
        serviceFullName: "Amazon CloudFront",
        serviceId: "CloudFront",
        signatureVersion: "v4",
        uid: "cloudfront-2018-06-18"
      },
      operations: {
        CreateCloudFrontOriginAccessIdentity: {
          http: {
            requestUri: "/2018-06-18/origin-access-identity/cloudfront",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        CreateDistribution: {
          http: {
            requestUri: "/2018-06-18/distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1t"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateDistributionWithTags: {
          http: {
            requestUri: "/2018-06-18/distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfigWithTags"
            ],
            members: {
              DistributionConfigWithTags: {
                locationName: "DistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                },
                type: "structure",
                required: [
                  "DistributionConfig",
                  "Tags"
                ],
                members: {
                  DistributionConfig: {
                    shape: "S7"
                  },
                  Tags: {
                    shape: "S22"
                  }
                }
              }
            },
            payload: "DistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1t"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateFieldLevelEncryptionConfig: {
          http: {
            requestUri: "/2018-06-18/field-level-encryption",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionConfig"
            ],
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S29",
                locationName: "FieldLevelEncryptionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              }
            },
            payload: "FieldLevelEncryptionConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2k"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        CreateFieldLevelEncryptionProfile: {
          http: {
            requestUri: "/2018-06-18/field-level-encryption-profile",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionProfileConfig"
            ],
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2m",
                locationName: "FieldLevelEncryptionProfileConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S2t"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        CreateInvalidation: {
          http: {
            requestUri: "/2018-06-18/distribution/{DistributionId}/invalidation",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "InvalidationBatch"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              InvalidationBatch: {
                shape: "S2v",
                locationName: "InvalidationBatch",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              }
            },
            payload: "InvalidationBatch"
          },
          output: {
            type: "structure",
            members: {
              Location: {
                location: "header",
                locationName: "Location"
              },
              Invalidation: {
                shape: "S2z"
              }
            },
            payload: "Invalidation"
          }
        },
        CreatePublicKey: {
          http: {
            requestUri: "/2018-06-18/public-key",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "PublicKeyConfig"
            ],
            members: {
              PublicKeyConfig: {
                shape: "S31",
                locationName: "PublicKeyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              }
            },
            payload: "PublicKeyConfig"
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S33"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        CreateStreamingDistribution: {
          http: {
            requestUri: "/2018-06-18/streaming-distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S35",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S39"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        CreateStreamingDistributionWithTags: {
          http: {
            requestUri: "/2018-06-18/streaming-distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfigWithTags"
            ],
            members: {
              StreamingDistributionConfigWithTags: {
                locationName: "StreamingDistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                },
                type: "structure",
                required: [
                  "StreamingDistributionConfig",
                  "Tags"
                ],
                members: {
                  StreamingDistributionConfig: {
                    shape: "S35"
                  },
                  Tags: {
                    shape: "S22"
                  }
                }
              }
            },
            payload: "StreamingDistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S39"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        DeleteCloudFrontOriginAccessIdentity: {
          http: {
            method: "DELETE",
            requestUri: "/2018-06-18/origin-access-identity/cloudfront/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2018-06-18/distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFieldLevelEncryptionConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2018-06-18/field-level-encryption/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFieldLevelEncryptionProfile: {
          http: {
            method: "DELETE",
            requestUri: "/2018-06-18/field-level-encryption-profile/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeletePublicKey: {
          http: {
            method: "DELETE",
            requestUri: "/2018-06-18/public-key/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteStreamingDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2018-06-18/streaming-distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        GetCloudFrontOriginAccessIdentity: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/origin-access-identity/cloudfront/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        GetCloudFrontOriginAccessIdentityConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          }
        },
        GetDistribution: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        GetDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionConfig: {
                shape: "S7"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "DistributionConfig"
          }
        },
        GetFieldLevelEncryption: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/field-level-encryption/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2k"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        GetFieldLevelEncryptionConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/field-level-encryption/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S29"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionConfig"
          }
        },
        GetFieldLevelEncryptionProfile: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/field-level-encryption-profile/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S2t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        GetFieldLevelEncryptionProfileConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/field-level-encryption-profile/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2m"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          }
        },
        GetInvalidation: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/distribution/{DistributionId}/invalidation/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "Id"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invalidation: {
                shape: "S2z"
              }
            },
            payload: "Invalidation"
          }
        },
        GetPublicKey: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/public-key/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S33"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        GetPublicKeyConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/public-key/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyConfig: {
                shape: "S31"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKeyConfig"
          }
        },
        GetStreamingDistribution: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/streaming-distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S39"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        GetStreamingDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionConfig: {
                shape: "S35"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistributionConfig"
          }
        },
        ListCloudFrontOriginAccessIdentities: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/origin-access-identity/cloudfront"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "CloudFrontOriginAccessIdentitySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "S3CanonicalUserId",
                        "Comment"
                      ],
                      members: {
                        Id: {},
                        S3CanonicalUserId: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityList"
          }
        },
        ListDistributions: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S4g"
              }
            },
            payload: "DistributionList"
          }
        },
        ListDistributionsByWebACLId: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/distributionsByWebACLId/{WebACLId}"
          },
          input: {
            type: "structure",
            required: [
              "WebACLId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              WebACLId: {
                location: "uri",
                locationName: "WebACLId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S4g"
              }
            },
            payload: "DistributionList"
          }
        },
        ListFieldLevelEncryptionConfigs: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/field-level-encryption"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "FieldLevelEncryptionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "LastModifiedTime"
                      ],
                      members: {
                        Id: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Comment: {},
                        QueryArgProfileConfig: {
                          shape: "S2a"
                        },
                        ContentTypeProfileConfig: {
                          shape: "S2e"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "FieldLevelEncryptionList"
          }
        },
        ListFieldLevelEncryptionProfiles: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/field-level-encryption-profile"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfileList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "FieldLevelEncryptionProfileSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "LastModifiedTime",
                        "Name",
                        "EncryptionEntities"
                      ],
                      members: {
                        Id: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Name: {},
                        EncryptionEntities: {
                          shape: "S2n"
                        },
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "FieldLevelEncryptionProfileList"
          }
        },
        ListInvalidations: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/distribution/{DistributionId}/invalidation"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InvalidationList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "InvalidationSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "CreateTime",
                        "Status"
                      ],
                      members: {
                        Id: {},
                        CreateTime: {
                          type: "timestamp"
                        },
                        Status: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "InvalidationList"
          }
        },
        ListPublicKeys: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/public-key"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "PublicKeySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "Name",
                        "CreatedTime",
                        "EncodedKey"
                      ],
                      members: {
                        Id: {},
                        Name: {},
                        CreatedTime: {
                          type: "timestamp"
                        },
                        EncodedKey: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "PublicKeyList"
          }
        },
        ListStreamingDistributions: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/streaming-distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "StreamingDistributionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "ARN",
                        "Status",
                        "LastModifiedTime",
                        "DomainName",
                        "S3Origin",
                        "Aliases",
                        "TrustedSigners",
                        "Comment",
                        "PriceClass",
                        "Enabled"
                      ],
                      members: {
                        Id: {},
                        ARN: {},
                        Status: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        DomainName: {},
                        S3Origin: {
                          shape: "S36"
                        },
                        Aliases: {
                          shape: "S8"
                        },
                        TrustedSigners: {
                          shape: "Sy"
                        },
                        Comment: {},
                        PriceClass: {},
                        Enabled: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "StreamingDistributionList"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2018-06-18/tagging"
          },
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "S22"
              }
            },
            payload: "Tags"
          }
        },
        TagResource: {
          http: {
            requestUri: "/2018-06-18/tagging?Operation=Tag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "Tags"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              Tags: {
                shape: "S22",
                locationName: "Tags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              }
            },
            payload: "Tags"
          }
        },
        UntagResource: {
          http: {
            requestUri: "/2018-06-18/tagging?Operation=Untag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "TagKeys"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              TagKeys: {
                locationName: "TagKeys",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                },
                type: "structure",
                members: {
                  Items: {
                    type: "list",
                    member: {
                      locationName: "Key"
                    }
                  }
                }
              }
            },
            payload: "TagKeys"
          }
        },
        UpdateCloudFrontOriginAccessIdentity: {
          http: {
            method: "PUT",
            requestUri: "/2018-06-18/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig",
              "Id"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        UpdateDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2018-06-18/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig",
              "Id"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S1t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        UpdateFieldLevelEncryptionConfig: {
          http: {
            method: "PUT",
            requestUri: "/2018-06-18/field-level-encryption/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionConfig",
              "Id"
            ],
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S29",
                locationName: "FieldLevelEncryptionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "FieldLevelEncryptionConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2k"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        UpdateFieldLevelEncryptionProfile: {
          http: {
            method: "PUT",
            requestUri: "/2018-06-18/field-level-encryption-profile/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionProfileConfig",
              "Id"
            ],
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2m",
                locationName: "FieldLevelEncryptionProfileConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S2t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        UpdatePublicKey: {
          http: {
            method: "PUT",
            requestUri: "/2018-06-18/public-key/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "PublicKeyConfig",
              "Id"
            ],
            members: {
              PublicKeyConfig: {
                shape: "S31",
                locationName: "PublicKeyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "PublicKeyConfig"
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S33"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        UpdateStreamingDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2018-06-18/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig",
              "Id"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S35",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-06-18/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S39"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "CallerReference",
            "Comment"
          ],
          members: {
            CallerReference: {},
            Comment: {}
          }
        },
        S5: {
          type: "structure",
          required: [
            "Id",
            "S3CanonicalUserId"
          ],
          members: {
            Id: {},
            S3CanonicalUserId: {},
            CloudFrontOriginAccessIdentityConfig: {
              shape: "S2"
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "CallerReference",
            "Origins",
            "DefaultCacheBehavior",
            "Comment",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            Aliases: {
              shape: "S8"
            },
            DefaultRootObject: {},
            Origins: {
              shape: "Sb"
            },
            DefaultCacheBehavior: {
              shape: "Sn"
            },
            CacheBehaviors: {
              shape: "S1b"
            },
            CustomErrorResponses: {
              shape: "S1e"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "IncludeCookies",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                IncludeCookies: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            },
            ViewerCertificate: {
              shape: "S1j"
            },
            Restrictions: {
              shape: "S1n"
            },
            WebACLId: {},
            HttpVersion: {},
            IsIPV6Enabled: {
              type: "boolean"
            }
          }
        },
        S8: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CNAME"
              }
            }
          }
        },
        Sb: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Origin",
                type: "structure",
                required: [
                  "Id",
                  "DomainName"
                ],
                members: {
                  Id: {},
                  DomainName: {},
                  OriginPath: {},
                  CustomHeaders: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "OriginCustomHeader",
                          type: "structure",
                          required: [
                            "HeaderName",
                            "HeaderValue"
                          ],
                          members: {
                            HeaderName: {},
                            HeaderValue: {}
                          }
                        }
                      }
                    }
                  },
                  S3OriginConfig: {
                    type: "structure",
                    required: [
                      "OriginAccessIdentity"
                    ],
                    members: {
                      OriginAccessIdentity: {}
                    }
                  },
                  CustomOriginConfig: {
                    type: "structure",
                    required: [
                      "HTTPPort",
                      "HTTPSPort",
                      "OriginProtocolPolicy"
                    ],
                    members: {
                      HTTPPort: {
                        type: "integer"
                      },
                      HTTPSPort: {
                        type: "integer"
                      },
                      OriginProtocolPolicy: {},
                      OriginSslProtocols: {
                        type: "structure",
                        required: [
                          "Quantity",
                          "Items"
                        ],
                        members: {
                          Quantity: {
                            type: "integer"
                          },
                          Items: {
                            type: "list",
                            member: {
                              locationName: "SslProtocol"
                            }
                          }
                        }
                      },
                      OriginReadTimeout: {
                        type: "integer"
                      },
                      OriginKeepaliveTimeout: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "TargetOriginId",
            "ForwardedValues",
            "TrustedSigners",
            "ViewerProtocolPolicy",
            "MinTTL"
          ],
          members: {
            TargetOriginId: {},
            ForwardedValues: {
              shape: "So"
            },
            TrustedSigners: {
              shape: "Sy"
            },
            ViewerProtocolPolicy: {},
            MinTTL: {
              type: "long"
            },
            AllowedMethods: {
              shape: "S12"
            },
            SmoothStreaming: {
              type: "boolean"
            },
            DefaultTTL: {
              type: "long"
            },
            MaxTTL: {
              type: "long"
            },
            Compress: {
              type: "boolean"
            },
            LambdaFunctionAssociations: {
              shape: "S16"
            },
            FieldLevelEncryptionId: {}
          }
        },
        So: {
          type: "structure",
          required: [
            "QueryString",
            "Cookies"
          ],
          members: {
            QueryString: {
              type: "boolean"
            },
            Cookies: {
              type: "structure",
              required: [
                "Forward"
              ],
              members: {
                Forward: {},
                WhitelistedNames: {
                  type: "structure",
                  required: [
                    "Quantity"
                  ],
                  members: {
                    Quantity: {
                      type: "integer"
                    },
                    Items: {
                      type: "list",
                      member: {
                        locationName: "Name"
                      }
                    }
                  }
                }
              }
            },
            Headers: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            },
            QueryStringCacheKeys: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "AwsAccountNumber"
              }
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "Quantity",
            "Items"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              shape: "S13"
            },
            CachedMethods: {
              type: "structure",
              required: [
                "Quantity",
                "Items"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  shape: "S13"
                }
              }
            }
          }
        },
        S13: {
          type: "list",
          member: {
            locationName: "Method"
          }
        },
        S16: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "LambdaFunctionAssociation",
                type: "structure",
                required: [
                  "LambdaFunctionARN",
                  "EventType"
                ],
                members: {
                  LambdaFunctionARN: {},
                  EventType: {},
                  IncludeBody: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S1b: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CacheBehavior",
                type: "structure",
                required: [
                  "PathPattern",
                  "TargetOriginId",
                  "ForwardedValues",
                  "TrustedSigners",
                  "ViewerProtocolPolicy",
                  "MinTTL"
                ],
                members: {
                  PathPattern: {},
                  TargetOriginId: {},
                  ForwardedValues: {
                    shape: "So"
                  },
                  TrustedSigners: {
                    shape: "Sy"
                  },
                  ViewerProtocolPolicy: {},
                  MinTTL: {
                    type: "long"
                  },
                  AllowedMethods: {
                    shape: "S12"
                  },
                  SmoothStreaming: {
                    type: "boolean"
                  },
                  DefaultTTL: {
                    type: "long"
                  },
                  MaxTTL: {
                    type: "long"
                  },
                  Compress: {
                    type: "boolean"
                  },
                  LambdaFunctionAssociations: {
                    shape: "S16"
                  },
                  FieldLevelEncryptionId: {}
                }
              }
            }
          }
        },
        S1e: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CustomErrorResponse",
                type: "structure",
                required: [
                  "ErrorCode"
                ],
                members: {
                  ErrorCode: {
                    type: "integer"
                  },
                  ResponsePagePath: {},
                  ResponseCode: {},
                  ErrorCachingMinTTL: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            CloudFrontDefaultCertificate: {
              type: "boolean"
            },
            IAMCertificateId: {},
            ACMCertificateArn: {},
            SSLSupportMethod: {},
            MinimumProtocolVersion: {},
            Certificate: {
              deprecated: true
            },
            CertificateSource: {
              deprecated: true
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "GeoRestriction"
          ],
          members: {
            GeoRestriction: {
              type: "structure",
              required: [
                "RestrictionType",
                "Quantity"
              ],
              members: {
                RestrictionType: {},
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Location"
                  }
                }
              }
            }
          }
        },
        S1t: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "LastModifiedTime",
            "InProgressInvalidationBatches",
            "DomainName",
            "ActiveTrustedSigners",
            "DistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            InProgressInvalidationBatches: {
              type: "integer"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S1v"
            },
            DistributionConfig: {
              shape: "S7"
            }
          }
        },
        S1v: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Signer",
                type: "structure",
                members: {
                  AwsAccountNumber: {},
                  KeyPairIds: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "KeyPairId"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S22: {
          type: "structure",
          members: {
            Items: {
              type: "list",
              member: {
                locationName: "Tag",
                type: "structure",
                required: [
                  "Key"
                ],
                members: {
                  Key: {},
                  Value: {}
                }
              }
            }
          }
        },
        S29: {
          type: "structure",
          required: [
            "CallerReference"
          ],
          members: {
            CallerReference: {},
            Comment: {},
            QueryArgProfileConfig: {
              shape: "S2a"
            },
            ContentTypeProfileConfig: {
              shape: "S2e"
            }
          }
        },
        S2a: {
          type: "structure",
          required: [
            "ForwardWhenQueryArgProfileIsUnknown"
          ],
          members: {
            ForwardWhenQueryArgProfileIsUnknown: {
              type: "boolean"
            },
            QueryArgProfiles: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "QueryArgProfile",
                    type: "structure",
                    required: [
                      "QueryArg",
                      "ProfileId"
                    ],
                    members: {
                      QueryArg: {},
                      ProfileId: {}
                    }
                  }
                }
              }
            }
          }
        },
        S2e: {
          type: "structure",
          required: [
            "ForwardWhenContentTypeIsUnknown"
          ],
          members: {
            ForwardWhenContentTypeIsUnknown: {
              type: "boolean"
            },
            ContentTypeProfiles: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "ContentTypeProfile",
                    type: "structure",
                    required: [
                      "Format",
                      "ContentType"
                    ],
                    members: {
                      Format: {},
                      ProfileId: {},
                      ContentType: {}
                    }
                  }
                }
              }
            }
          }
        },
        S2k: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "FieldLevelEncryptionConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            FieldLevelEncryptionConfig: {
              shape: "S29"
            }
          }
        },
        S2m: {
          type: "structure",
          required: [
            "Name",
            "CallerReference",
            "EncryptionEntities"
          ],
          members: {
            Name: {},
            CallerReference: {},
            Comment: {},
            EncryptionEntities: {
              shape: "S2n"
            }
          }
        },
        S2n: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "EncryptionEntity",
                type: "structure",
                required: [
                  "PublicKeyId",
                  "ProviderId",
                  "FieldPatterns"
                ],
                members: {
                  PublicKeyId: {},
                  ProviderId: {},
                  FieldPatterns: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "FieldPattern"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S2t: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "FieldLevelEncryptionProfileConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            FieldLevelEncryptionProfileConfig: {
              shape: "S2m"
            }
          }
        },
        S2v: {
          type: "structure",
          required: [
            "Paths",
            "CallerReference"
          ],
          members: {
            Paths: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Path"
                  }
                }
              }
            },
            CallerReference: {}
          }
        },
        S2z: {
          type: "structure",
          required: [
            "Id",
            "Status",
            "CreateTime",
            "InvalidationBatch"
          ],
          members: {
            Id: {},
            Status: {},
            CreateTime: {
              type: "timestamp"
            },
            InvalidationBatch: {
              shape: "S2v"
            }
          }
        },
        S31: {
          type: "structure",
          required: [
            "CallerReference",
            "Name",
            "EncodedKey"
          ],
          members: {
            CallerReference: {},
            Name: {},
            EncodedKey: {},
            Comment: {}
          }
        },
        S33: {
          type: "structure",
          required: [
            "Id",
            "CreatedTime",
            "PublicKeyConfig"
          ],
          members: {
            Id: {},
            CreatedTime: {
              type: "timestamp"
            },
            PublicKeyConfig: {
              shape: "S31"
            }
          }
        },
        S35: {
          type: "structure",
          required: [
            "CallerReference",
            "S3Origin",
            "Comment",
            "TrustedSigners",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            S3Origin: {
              shape: "S36"
            },
            Aliases: {
              shape: "S8"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            TrustedSigners: {
              shape: "Sy"
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            }
          }
        },
        S36: {
          type: "structure",
          required: [
            "DomainName",
            "OriginAccessIdentity"
          ],
          members: {
            DomainName: {},
            OriginAccessIdentity: {}
          }
        },
        S39: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "DomainName",
            "ActiveTrustedSigners",
            "StreamingDistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S1v"
            },
            StreamingDistributionConfig: {
              shape: "S35"
            }
          }
        },
        S4g: {
          type: "structure",
          required: [
            "Marker",
            "MaxItems",
            "IsTruncated",
            "Quantity"
          ],
          members: {
            Marker: {},
            NextMarker: {},
            MaxItems: {
              type: "integer"
            },
            IsTruncated: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "DistributionSummary",
                type: "structure",
                required: [
                  "Id",
                  "ARN",
                  "Status",
                  "LastModifiedTime",
                  "DomainName",
                  "Aliases",
                  "Origins",
                  "DefaultCacheBehavior",
                  "CacheBehaviors",
                  "CustomErrorResponses",
                  "Comment",
                  "PriceClass",
                  "Enabled",
                  "ViewerCertificate",
                  "Restrictions",
                  "WebACLId",
                  "HttpVersion",
                  "IsIPV6Enabled"
                ],
                members: {
                  Id: {},
                  ARN: {},
                  Status: {},
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  DomainName: {},
                  Aliases: {
                    shape: "S8"
                  },
                  Origins: {
                    shape: "Sb"
                  },
                  DefaultCacheBehavior: {
                    shape: "Sn"
                  },
                  CacheBehaviors: {
                    shape: "S1b"
                  },
                  CustomErrorResponses: {
                    shape: "S1e"
                  },
                  Comment: {},
                  PriceClass: {},
                  Enabled: {
                    type: "boolean"
                  },
                  ViewerCertificate: {
                    shape: "S1j"
                  },
                  Restrictions: {
                    shape: "S1n"
                  },
                  WebACLId: {},
                  HttpVersion: {},
                  IsIPV6Enabled: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2018-06-18.paginators.json
var require_cloudfront_2018_06_18_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2018-06-18.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListCloudFrontOriginAccessIdentities: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "CloudFrontOriginAccessIdentityList.IsTruncated",
          output_token: "CloudFrontOriginAccessIdentityList.NextMarker",
          result_key: "CloudFrontOriginAccessIdentityList.Items"
        },
        ListDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "DistributionList.IsTruncated",
          output_token: "DistributionList.NextMarker",
          result_key: "DistributionList.Items"
        },
        ListInvalidations: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "InvalidationList.IsTruncated",
          output_token: "InvalidationList.NextMarker",
          result_key: "InvalidationList.Items"
        },
        ListStreamingDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "StreamingDistributionList.IsTruncated",
          output_token: "StreamingDistributionList.NextMarker",
          result_key: "StreamingDistributionList.Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2018-06-18.waiters2.json
var require_cloudfront_2018_06_18_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2018-06-18.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DistributionDeployed: {
          delay: 60,
          operation: "GetDistribution",
          maxAttempts: 25,
          description: "Wait until a distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "Distribution.Status"
            }
          ]
        },
        InvalidationCompleted: {
          delay: 20,
          operation: "GetInvalidation",
          maxAttempts: 30,
          description: "Wait until an invalidation has completed.",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "Invalidation.Status"
            }
          ]
        },
        StreamingDistributionDeployed: {
          delay: 60,
          operation: "GetStreamingDistribution",
          maxAttempts: 25,
          description: "Wait until a streaming distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "StreamingDistribution.Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2018-11-05.min.json
var require_cloudfront_2018_11_05_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2018-11-05.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-11-05",
        endpointPrefix: "cloudfront",
        globalEndpoint: "cloudfront.amazonaws.com",
        protocol: "rest-xml",
        serviceAbbreviation: "CloudFront",
        serviceFullName: "Amazon CloudFront",
        serviceId: "CloudFront",
        signatureVersion: "v4",
        uid: "cloudfront-2018-11-05"
      },
      operations: {
        CreateCloudFrontOriginAccessIdentity: {
          http: {
            requestUri: "/2018-11-05/origin-access-identity/cloudfront",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        CreateDistribution: {
          http: {
            requestUri: "/2018-11-05/distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S22"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateDistributionWithTags: {
          http: {
            requestUri: "/2018-11-05/distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfigWithTags"
            ],
            members: {
              DistributionConfigWithTags: {
                locationName: "DistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                },
                type: "structure",
                required: [
                  "DistributionConfig",
                  "Tags"
                ],
                members: {
                  DistributionConfig: {
                    shape: "S7"
                  },
                  Tags: {
                    shape: "S2b"
                  }
                }
              }
            },
            payload: "DistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S22"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateFieldLevelEncryptionConfig: {
          http: {
            requestUri: "/2018-11-05/field-level-encryption",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionConfig"
            ],
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S2i",
                locationName: "FieldLevelEncryptionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              }
            },
            payload: "FieldLevelEncryptionConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2t"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        CreateFieldLevelEncryptionProfile: {
          http: {
            requestUri: "/2018-11-05/field-level-encryption-profile",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionProfileConfig"
            ],
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2v",
                locationName: "FieldLevelEncryptionProfileConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S32"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        CreateInvalidation: {
          http: {
            requestUri: "/2018-11-05/distribution/{DistributionId}/invalidation",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "InvalidationBatch"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              InvalidationBatch: {
                shape: "S34",
                locationName: "InvalidationBatch",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              }
            },
            payload: "InvalidationBatch"
          },
          output: {
            type: "structure",
            members: {
              Location: {
                location: "header",
                locationName: "Location"
              },
              Invalidation: {
                shape: "S38"
              }
            },
            payload: "Invalidation"
          }
        },
        CreatePublicKey: {
          http: {
            requestUri: "/2018-11-05/public-key",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "PublicKeyConfig"
            ],
            members: {
              PublicKeyConfig: {
                shape: "S3a",
                locationName: "PublicKeyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              }
            },
            payload: "PublicKeyConfig"
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S3c"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        CreateStreamingDistribution: {
          http: {
            requestUri: "/2018-11-05/streaming-distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S3e",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S3i"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        CreateStreamingDistributionWithTags: {
          http: {
            requestUri: "/2018-11-05/streaming-distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfigWithTags"
            ],
            members: {
              StreamingDistributionConfigWithTags: {
                locationName: "StreamingDistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                },
                type: "structure",
                required: [
                  "StreamingDistributionConfig",
                  "Tags"
                ],
                members: {
                  StreamingDistributionConfig: {
                    shape: "S3e"
                  },
                  Tags: {
                    shape: "S2b"
                  }
                }
              }
            },
            payload: "StreamingDistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S3i"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        DeleteCloudFrontOriginAccessIdentity: {
          http: {
            method: "DELETE",
            requestUri: "/2018-11-05/origin-access-identity/cloudfront/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2018-11-05/distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFieldLevelEncryptionConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2018-11-05/field-level-encryption/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFieldLevelEncryptionProfile: {
          http: {
            method: "DELETE",
            requestUri: "/2018-11-05/field-level-encryption-profile/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeletePublicKey: {
          http: {
            method: "DELETE",
            requestUri: "/2018-11-05/public-key/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteStreamingDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2018-11-05/streaming-distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        GetCloudFrontOriginAccessIdentity: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/origin-access-identity/cloudfront/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        GetCloudFrontOriginAccessIdentityConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          }
        },
        GetDistribution: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S22"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        GetDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionConfig: {
                shape: "S7"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "DistributionConfig"
          }
        },
        GetFieldLevelEncryption: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/field-level-encryption/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        GetFieldLevelEncryptionConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/field-level-encryption/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S2i"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionConfig"
          }
        },
        GetFieldLevelEncryptionProfile: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/field-level-encryption-profile/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S32"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        GetFieldLevelEncryptionProfileConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/field-level-encryption-profile/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2v"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          }
        },
        GetInvalidation: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/distribution/{DistributionId}/invalidation/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "Id"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invalidation: {
                shape: "S38"
              }
            },
            payload: "Invalidation"
          }
        },
        GetPublicKey: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/public-key/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S3c"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        GetPublicKeyConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/public-key/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyConfig: {
                shape: "S3a"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKeyConfig"
          }
        },
        GetStreamingDistribution: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/streaming-distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S3i"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        GetStreamingDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionConfig: {
                shape: "S3e"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistributionConfig"
          }
        },
        ListCloudFrontOriginAccessIdentities: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/origin-access-identity/cloudfront"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "CloudFrontOriginAccessIdentitySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "S3CanonicalUserId",
                        "Comment"
                      ],
                      members: {
                        Id: {},
                        S3CanonicalUserId: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityList"
          }
        },
        ListDistributions: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S4p"
              }
            },
            payload: "DistributionList"
          }
        },
        ListDistributionsByWebACLId: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/distributionsByWebACLId/{WebACLId}"
          },
          input: {
            type: "structure",
            required: [
              "WebACLId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              WebACLId: {
                location: "uri",
                locationName: "WebACLId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S4p"
              }
            },
            payload: "DistributionList"
          }
        },
        ListFieldLevelEncryptionConfigs: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/field-level-encryption"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "FieldLevelEncryptionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "LastModifiedTime"
                      ],
                      members: {
                        Id: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Comment: {},
                        QueryArgProfileConfig: {
                          shape: "S2j"
                        },
                        ContentTypeProfileConfig: {
                          shape: "S2n"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "FieldLevelEncryptionList"
          }
        },
        ListFieldLevelEncryptionProfiles: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/field-level-encryption-profile"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfileList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "FieldLevelEncryptionProfileSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "LastModifiedTime",
                        "Name",
                        "EncryptionEntities"
                      ],
                      members: {
                        Id: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Name: {},
                        EncryptionEntities: {
                          shape: "S2w"
                        },
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "FieldLevelEncryptionProfileList"
          }
        },
        ListInvalidations: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/distribution/{DistributionId}/invalidation"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InvalidationList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "InvalidationSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "CreateTime",
                        "Status"
                      ],
                      members: {
                        Id: {},
                        CreateTime: {
                          type: "timestamp"
                        },
                        Status: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "InvalidationList"
          }
        },
        ListPublicKeys: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/public-key"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "PublicKeySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "Name",
                        "CreatedTime",
                        "EncodedKey"
                      ],
                      members: {
                        Id: {},
                        Name: {},
                        CreatedTime: {
                          type: "timestamp"
                        },
                        EncodedKey: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "PublicKeyList"
          }
        },
        ListStreamingDistributions: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/streaming-distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "StreamingDistributionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "ARN",
                        "Status",
                        "LastModifiedTime",
                        "DomainName",
                        "S3Origin",
                        "Aliases",
                        "TrustedSigners",
                        "Comment",
                        "PriceClass",
                        "Enabled"
                      ],
                      members: {
                        Id: {},
                        ARN: {},
                        Status: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        DomainName: {},
                        S3Origin: {
                          shape: "S3f"
                        },
                        Aliases: {
                          shape: "S8"
                        },
                        TrustedSigners: {
                          shape: "S17"
                        },
                        Comment: {},
                        PriceClass: {},
                        Enabled: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "StreamingDistributionList"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2018-11-05/tagging"
          },
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "S2b"
              }
            },
            payload: "Tags"
          }
        },
        TagResource: {
          http: {
            requestUri: "/2018-11-05/tagging?Operation=Tag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "Tags"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              Tags: {
                shape: "S2b",
                locationName: "Tags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              }
            },
            payload: "Tags"
          }
        },
        UntagResource: {
          http: {
            requestUri: "/2018-11-05/tagging?Operation=Untag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "TagKeys"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              TagKeys: {
                locationName: "TagKeys",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                },
                type: "structure",
                members: {
                  Items: {
                    type: "list",
                    member: {
                      locationName: "Key"
                    }
                  }
                }
              }
            },
            payload: "TagKeys"
          }
        },
        UpdateCloudFrontOriginAccessIdentity: {
          http: {
            method: "PUT",
            requestUri: "/2018-11-05/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig",
              "Id"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        UpdateDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2018-11-05/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig",
              "Id"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S22"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        UpdateFieldLevelEncryptionConfig: {
          http: {
            method: "PUT",
            requestUri: "/2018-11-05/field-level-encryption/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionConfig",
              "Id"
            ],
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S2i",
                locationName: "FieldLevelEncryptionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "FieldLevelEncryptionConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2t"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        UpdateFieldLevelEncryptionProfile: {
          http: {
            method: "PUT",
            requestUri: "/2018-11-05/field-level-encryption-profile/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionProfileConfig",
              "Id"
            ],
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2v",
                locationName: "FieldLevelEncryptionProfileConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S32"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        UpdatePublicKey: {
          http: {
            method: "PUT",
            requestUri: "/2018-11-05/public-key/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "PublicKeyConfig",
              "Id"
            ],
            members: {
              PublicKeyConfig: {
                shape: "S3a",
                locationName: "PublicKeyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "PublicKeyConfig"
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S3c"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        UpdateStreamingDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2018-11-05/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig",
              "Id"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S3e",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2018-11-05/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S3i"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "CallerReference",
            "Comment"
          ],
          members: {
            CallerReference: {},
            Comment: {}
          }
        },
        S5: {
          type: "structure",
          required: [
            "Id",
            "S3CanonicalUserId"
          ],
          members: {
            Id: {},
            S3CanonicalUserId: {},
            CloudFrontOriginAccessIdentityConfig: {
              shape: "S2"
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "CallerReference",
            "Origins",
            "DefaultCacheBehavior",
            "Comment",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            Aliases: {
              shape: "S8"
            },
            DefaultRootObject: {},
            Origins: {
              shape: "Sb"
            },
            OriginGroups: {
              shape: "Sn"
            },
            DefaultCacheBehavior: {
              shape: "Sw"
            },
            CacheBehaviors: {
              shape: "S1k"
            },
            CustomErrorResponses: {
              shape: "S1n"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "IncludeCookies",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                IncludeCookies: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            },
            ViewerCertificate: {
              shape: "S1s"
            },
            Restrictions: {
              shape: "S1w"
            },
            WebACLId: {},
            HttpVersion: {},
            IsIPV6Enabled: {
              type: "boolean"
            }
          }
        },
        S8: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CNAME"
              }
            }
          }
        },
        Sb: {
          type: "structure",
          required: [
            "Quantity",
            "Items"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Origin",
                type: "structure",
                required: [
                  "Id",
                  "DomainName"
                ],
                members: {
                  Id: {},
                  DomainName: {},
                  OriginPath: {},
                  CustomHeaders: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "OriginCustomHeader",
                          type: "structure",
                          required: [
                            "HeaderName",
                            "HeaderValue"
                          ],
                          members: {
                            HeaderName: {},
                            HeaderValue: {}
                          }
                        }
                      }
                    }
                  },
                  S3OriginConfig: {
                    type: "structure",
                    required: [
                      "OriginAccessIdentity"
                    ],
                    members: {
                      OriginAccessIdentity: {}
                    }
                  },
                  CustomOriginConfig: {
                    type: "structure",
                    required: [
                      "HTTPPort",
                      "HTTPSPort",
                      "OriginProtocolPolicy"
                    ],
                    members: {
                      HTTPPort: {
                        type: "integer"
                      },
                      HTTPSPort: {
                        type: "integer"
                      },
                      OriginProtocolPolicy: {},
                      OriginSslProtocols: {
                        type: "structure",
                        required: [
                          "Quantity",
                          "Items"
                        ],
                        members: {
                          Quantity: {
                            type: "integer"
                          },
                          Items: {
                            type: "list",
                            member: {
                              locationName: "SslProtocol"
                            }
                          }
                        }
                      },
                      OriginReadTimeout: {
                        type: "integer"
                      },
                      OriginKeepaliveTimeout: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "OriginGroup",
                type: "structure",
                required: [
                  "Id",
                  "FailoverCriteria",
                  "Members"
                ],
                members: {
                  Id: {},
                  FailoverCriteria: {
                    type: "structure",
                    required: [
                      "StatusCodes"
                    ],
                    members: {
                      StatusCodes: {
                        type: "structure",
                        required: [
                          "Quantity",
                          "Items"
                        ],
                        members: {
                          Quantity: {
                            type: "integer"
                          },
                          Items: {
                            type: "list",
                            member: {
                              locationName: "StatusCode",
                              type: "integer"
                            }
                          }
                        }
                      }
                    }
                  },
                  Members: {
                    type: "structure",
                    required: [
                      "Quantity",
                      "Items"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "OriginGroupMember",
                          type: "structure",
                          required: [
                            "OriginId"
                          ],
                          members: {
                            OriginId: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sw: {
          type: "structure",
          required: [
            "TargetOriginId",
            "ForwardedValues",
            "TrustedSigners",
            "ViewerProtocolPolicy",
            "MinTTL"
          ],
          members: {
            TargetOriginId: {},
            ForwardedValues: {
              shape: "Sx"
            },
            TrustedSigners: {
              shape: "S17"
            },
            ViewerProtocolPolicy: {},
            MinTTL: {
              type: "long"
            },
            AllowedMethods: {
              shape: "S1b"
            },
            SmoothStreaming: {
              type: "boolean"
            },
            DefaultTTL: {
              type: "long"
            },
            MaxTTL: {
              type: "long"
            },
            Compress: {
              type: "boolean"
            },
            LambdaFunctionAssociations: {
              shape: "S1f"
            },
            FieldLevelEncryptionId: {}
          }
        },
        Sx: {
          type: "structure",
          required: [
            "QueryString",
            "Cookies"
          ],
          members: {
            QueryString: {
              type: "boolean"
            },
            Cookies: {
              type: "structure",
              required: [
                "Forward"
              ],
              members: {
                Forward: {},
                WhitelistedNames: {
                  type: "structure",
                  required: [
                    "Quantity"
                  ],
                  members: {
                    Quantity: {
                      type: "integer"
                    },
                    Items: {
                      type: "list",
                      member: {
                        locationName: "Name"
                      }
                    }
                  }
                }
              }
            },
            Headers: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            },
            QueryStringCacheKeys: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            }
          }
        },
        S17: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "AwsAccountNumber"
              }
            }
          }
        },
        S1b: {
          type: "structure",
          required: [
            "Quantity",
            "Items"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              shape: "S1c"
            },
            CachedMethods: {
              type: "structure",
              required: [
                "Quantity",
                "Items"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  shape: "S1c"
                }
              }
            }
          }
        },
        S1c: {
          type: "list",
          member: {
            locationName: "Method"
          }
        },
        S1f: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "LambdaFunctionAssociation",
                type: "structure",
                required: [
                  "LambdaFunctionARN",
                  "EventType"
                ],
                members: {
                  LambdaFunctionARN: {},
                  EventType: {},
                  IncludeBody: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S1k: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CacheBehavior",
                type: "structure",
                required: [
                  "PathPattern",
                  "TargetOriginId",
                  "ForwardedValues",
                  "TrustedSigners",
                  "ViewerProtocolPolicy",
                  "MinTTL"
                ],
                members: {
                  PathPattern: {},
                  TargetOriginId: {},
                  ForwardedValues: {
                    shape: "Sx"
                  },
                  TrustedSigners: {
                    shape: "S17"
                  },
                  ViewerProtocolPolicy: {},
                  MinTTL: {
                    type: "long"
                  },
                  AllowedMethods: {
                    shape: "S1b"
                  },
                  SmoothStreaming: {
                    type: "boolean"
                  },
                  DefaultTTL: {
                    type: "long"
                  },
                  MaxTTL: {
                    type: "long"
                  },
                  Compress: {
                    type: "boolean"
                  },
                  LambdaFunctionAssociations: {
                    shape: "S1f"
                  },
                  FieldLevelEncryptionId: {}
                }
              }
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CustomErrorResponse",
                type: "structure",
                required: [
                  "ErrorCode"
                ],
                members: {
                  ErrorCode: {
                    type: "integer"
                  },
                  ResponsePagePath: {},
                  ResponseCode: {},
                  ErrorCachingMinTTL: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S1s: {
          type: "structure",
          members: {
            CloudFrontDefaultCertificate: {
              type: "boolean"
            },
            IAMCertificateId: {},
            ACMCertificateArn: {},
            SSLSupportMethod: {},
            MinimumProtocolVersion: {},
            Certificate: {
              deprecated: true
            },
            CertificateSource: {
              deprecated: true
            }
          }
        },
        S1w: {
          type: "structure",
          required: [
            "GeoRestriction"
          ],
          members: {
            GeoRestriction: {
              type: "structure",
              required: [
                "RestrictionType",
                "Quantity"
              ],
              members: {
                RestrictionType: {},
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Location"
                  }
                }
              }
            }
          }
        },
        S22: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "LastModifiedTime",
            "InProgressInvalidationBatches",
            "DomainName",
            "ActiveTrustedSigners",
            "DistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            InProgressInvalidationBatches: {
              type: "integer"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S24"
            },
            DistributionConfig: {
              shape: "S7"
            }
          }
        },
        S24: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Signer",
                type: "structure",
                members: {
                  AwsAccountNumber: {},
                  KeyPairIds: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "KeyPairId"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S2b: {
          type: "structure",
          members: {
            Items: {
              type: "list",
              member: {
                locationName: "Tag",
                type: "structure",
                required: [
                  "Key"
                ],
                members: {
                  Key: {},
                  Value: {}
                }
              }
            }
          }
        },
        S2i: {
          type: "structure",
          required: [
            "CallerReference"
          ],
          members: {
            CallerReference: {},
            Comment: {},
            QueryArgProfileConfig: {
              shape: "S2j"
            },
            ContentTypeProfileConfig: {
              shape: "S2n"
            }
          }
        },
        S2j: {
          type: "structure",
          required: [
            "ForwardWhenQueryArgProfileIsUnknown"
          ],
          members: {
            ForwardWhenQueryArgProfileIsUnknown: {
              type: "boolean"
            },
            QueryArgProfiles: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "QueryArgProfile",
                    type: "structure",
                    required: [
                      "QueryArg",
                      "ProfileId"
                    ],
                    members: {
                      QueryArg: {},
                      ProfileId: {}
                    }
                  }
                }
              }
            }
          }
        },
        S2n: {
          type: "structure",
          required: [
            "ForwardWhenContentTypeIsUnknown"
          ],
          members: {
            ForwardWhenContentTypeIsUnknown: {
              type: "boolean"
            },
            ContentTypeProfiles: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "ContentTypeProfile",
                    type: "structure",
                    required: [
                      "Format",
                      "ContentType"
                    ],
                    members: {
                      Format: {},
                      ProfileId: {},
                      ContentType: {}
                    }
                  }
                }
              }
            }
          }
        },
        S2t: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "FieldLevelEncryptionConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            FieldLevelEncryptionConfig: {
              shape: "S2i"
            }
          }
        },
        S2v: {
          type: "structure",
          required: [
            "Name",
            "CallerReference",
            "EncryptionEntities"
          ],
          members: {
            Name: {},
            CallerReference: {},
            Comment: {},
            EncryptionEntities: {
              shape: "S2w"
            }
          }
        },
        S2w: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "EncryptionEntity",
                type: "structure",
                required: [
                  "PublicKeyId",
                  "ProviderId",
                  "FieldPatterns"
                ],
                members: {
                  PublicKeyId: {},
                  ProviderId: {},
                  FieldPatterns: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "FieldPattern"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S32: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "FieldLevelEncryptionProfileConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            FieldLevelEncryptionProfileConfig: {
              shape: "S2v"
            }
          }
        },
        S34: {
          type: "structure",
          required: [
            "Paths",
            "CallerReference"
          ],
          members: {
            Paths: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Path"
                  }
                }
              }
            },
            CallerReference: {}
          }
        },
        S38: {
          type: "structure",
          required: [
            "Id",
            "Status",
            "CreateTime",
            "InvalidationBatch"
          ],
          members: {
            Id: {},
            Status: {},
            CreateTime: {
              type: "timestamp"
            },
            InvalidationBatch: {
              shape: "S34"
            }
          }
        },
        S3a: {
          type: "structure",
          required: [
            "CallerReference",
            "Name",
            "EncodedKey"
          ],
          members: {
            CallerReference: {},
            Name: {},
            EncodedKey: {},
            Comment: {}
          }
        },
        S3c: {
          type: "structure",
          required: [
            "Id",
            "CreatedTime",
            "PublicKeyConfig"
          ],
          members: {
            Id: {},
            CreatedTime: {
              type: "timestamp"
            },
            PublicKeyConfig: {
              shape: "S3a"
            }
          }
        },
        S3e: {
          type: "structure",
          required: [
            "CallerReference",
            "S3Origin",
            "Comment",
            "TrustedSigners",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            S3Origin: {
              shape: "S3f"
            },
            Aliases: {
              shape: "S8"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            TrustedSigners: {
              shape: "S17"
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            }
          }
        },
        S3f: {
          type: "structure",
          required: [
            "DomainName",
            "OriginAccessIdentity"
          ],
          members: {
            DomainName: {},
            OriginAccessIdentity: {}
          }
        },
        S3i: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "DomainName",
            "ActiveTrustedSigners",
            "StreamingDistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S24"
            },
            StreamingDistributionConfig: {
              shape: "S3e"
            }
          }
        },
        S4p: {
          type: "structure",
          required: [
            "Marker",
            "MaxItems",
            "IsTruncated",
            "Quantity"
          ],
          members: {
            Marker: {},
            NextMarker: {},
            MaxItems: {
              type: "integer"
            },
            IsTruncated: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "DistributionSummary",
                type: "structure",
                required: [
                  "Id",
                  "ARN",
                  "Status",
                  "LastModifiedTime",
                  "DomainName",
                  "Aliases",
                  "Origins",
                  "DefaultCacheBehavior",
                  "CacheBehaviors",
                  "CustomErrorResponses",
                  "Comment",
                  "PriceClass",
                  "Enabled",
                  "ViewerCertificate",
                  "Restrictions",
                  "WebACLId",
                  "HttpVersion",
                  "IsIPV6Enabled"
                ],
                members: {
                  Id: {},
                  ARN: {},
                  Status: {},
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  DomainName: {},
                  Aliases: {
                    shape: "S8"
                  },
                  Origins: {
                    shape: "Sb"
                  },
                  OriginGroups: {
                    shape: "Sn"
                  },
                  DefaultCacheBehavior: {
                    shape: "Sw"
                  },
                  CacheBehaviors: {
                    shape: "S1k"
                  },
                  CustomErrorResponses: {
                    shape: "S1n"
                  },
                  Comment: {},
                  PriceClass: {},
                  Enabled: {
                    type: "boolean"
                  },
                  ViewerCertificate: {
                    shape: "S1s"
                  },
                  Restrictions: {
                    shape: "S1w"
                  },
                  WebACLId: {},
                  HttpVersion: {},
                  IsIPV6Enabled: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2018-11-05.paginators.json
var require_cloudfront_2018_11_05_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2018-11-05.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListCloudFrontOriginAccessIdentities: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "CloudFrontOriginAccessIdentityList.IsTruncated",
          output_token: "CloudFrontOriginAccessIdentityList.NextMarker",
          result_key: "CloudFrontOriginAccessIdentityList.Items"
        },
        ListDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "DistributionList.IsTruncated",
          output_token: "DistributionList.NextMarker",
          result_key: "DistributionList.Items"
        },
        ListInvalidations: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "InvalidationList.IsTruncated",
          output_token: "InvalidationList.NextMarker",
          result_key: "InvalidationList.Items"
        },
        ListStreamingDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "StreamingDistributionList.IsTruncated",
          output_token: "StreamingDistributionList.NextMarker",
          result_key: "StreamingDistributionList.Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2018-11-05.waiters2.json
var require_cloudfront_2018_11_05_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2018-11-05.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DistributionDeployed: {
          delay: 60,
          operation: "GetDistribution",
          maxAttempts: 25,
          description: "Wait until a distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "Distribution.Status"
            }
          ]
        },
        InvalidationCompleted: {
          delay: 20,
          operation: "GetInvalidation",
          maxAttempts: 30,
          description: "Wait until an invalidation has completed.",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "Invalidation.Status"
            }
          ]
        },
        StreamingDistributionDeployed: {
          delay: 60,
          operation: "GetStreamingDistribution",
          maxAttempts: 25,
          description: "Wait until a streaming distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "StreamingDistribution.Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2019-03-26.min.json
var require_cloudfront_2019_03_26_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2019-03-26.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-03-26",
        endpointPrefix: "cloudfront",
        globalEndpoint: "cloudfront.amazonaws.com",
        protocol: "rest-xml",
        serviceAbbreviation: "CloudFront",
        serviceFullName: "Amazon CloudFront",
        serviceId: "CloudFront",
        signatureVersion: "v4",
        uid: "cloudfront-2019-03-26"
      },
      operations: {
        CreateCloudFrontOriginAccessIdentity: {
          http: {
            requestUri: "/2019-03-26/origin-access-identity/cloudfront",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        CreateDistribution: {
          http: {
            requestUri: "/2019-03-26/distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S23"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateDistributionWithTags: {
          http: {
            requestUri: "/2019-03-26/distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfigWithTags"
            ],
            members: {
              DistributionConfigWithTags: {
                locationName: "DistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                },
                type: "structure",
                required: [
                  "DistributionConfig",
                  "Tags"
                ],
                members: {
                  DistributionConfig: {
                    shape: "S7"
                  },
                  Tags: {
                    shape: "S2f"
                  }
                }
              }
            },
            payload: "DistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S23"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateFieldLevelEncryptionConfig: {
          http: {
            requestUri: "/2019-03-26/field-level-encryption",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionConfig"
            ],
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S2m",
                locationName: "FieldLevelEncryptionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              }
            },
            payload: "FieldLevelEncryptionConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2x"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        CreateFieldLevelEncryptionProfile: {
          http: {
            requestUri: "/2019-03-26/field-level-encryption-profile",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionProfileConfig"
            ],
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2z",
                locationName: "FieldLevelEncryptionProfileConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S36"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        CreateInvalidation: {
          http: {
            requestUri: "/2019-03-26/distribution/{DistributionId}/invalidation",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "InvalidationBatch"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              InvalidationBatch: {
                shape: "S38",
                locationName: "InvalidationBatch",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              }
            },
            payload: "InvalidationBatch"
          },
          output: {
            type: "structure",
            members: {
              Location: {
                location: "header",
                locationName: "Location"
              },
              Invalidation: {
                shape: "S3c"
              }
            },
            payload: "Invalidation"
          }
        },
        CreatePublicKey: {
          http: {
            requestUri: "/2019-03-26/public-key",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "PublicKeyConfig"
            ],
            members: {
              PublicKeyConfig: {
                shape: "S3e",
                locationName: "PublicKeyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              }
            },
            payload: "PublicKeyConfig"
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S3g"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        CreateStreamingDistribution: {
          http: {
            requestUri: "/2019-03-26/streaming-distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S3i",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S3m"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        CreateStreamingDistributionWithTags: {
          http: {
            requestUri: "/2019-03-26/streaming-distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfigWithTags"
            ],
            members: {
              StreamingDistributionConfigWithTags: {
                locationName: "StreamingDistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                },
                type: "structure",
                required: [
                  "StreamingDistributionConfig",
                  "Tags"
                ],
                members: {
                  StreamingDistributionConfig: {
                    shape: "S3i"
                  },
                  Tags: {
                    shape: "S2f"
                  }
                }
              }
            },
            payload: "StreamingDistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S3m"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        DeleteCloudFrontOriginAccessIdentity: {
          http: {
            method: "DELETE",
            requestUri: "/2019-03-26/origin-access-identity/cloudfront/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2019-03-26/distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFieldLevelEncryptionConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2019-03-26/field-level-encryption/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFieldLevelEncryptionProfile: {
          http: {
            method: "DELETE",
            requestUri: "/2019-03-26/field-level-encryption-profile/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeletePublicKey: {
          http: {
            method: "DELETE",
            requestUri: "/2019-03-26/public-key/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteStreamingDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2019-03-26/streaming-distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        GetCloudFrontOriginAccessIdentity: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/origin-access-identity/cloudfront/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        GetCloudFrontOriginAccessIdentityConfig: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          }
        },
        GetDistribution: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S23"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        GetDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionConfig: {
                shape: "S7"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "DistributionConfig"
          }
        },
        GetFieldLevelEncryption: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/field-level-encryption/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2x"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        GetFieldLevelEncryptionConfig: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/field-level-encryption/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S2m"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionConfig"
          }
        },
        GetFieldLevelEncryptionProfile: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/field-level-encryption-profile/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S36"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        GetFieldLevelEncryptionProfileConfig: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/field-level-encryption-profile/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2z"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          }
        },
        GetInvalidation: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/distribution/{DistributionId}/invalidation/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "Id"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invalidation: {
                shape: "S3c"
              }
            },
            payload: "Invalidation"
          }
        },
        GetPublicKey: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/public-key/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S3g"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        GetPublicKeyConfig: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/public-key/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyConfig: {
                shape: "S3e"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKeyConfig"
          }
        },
        GetStreamingDistribution: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/streaming-distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S3m"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        GetStreamingDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionConfig: {
                shape: "S3i"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistributionConfig"
          }
        },
        ListCloudFrontOriginAccessIdentities: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/origin-access-identity/cloudfront"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "CloudFrontOriginAccessIdentitySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "S3CanonicalUserId",
                        "Comment"
                      ],
                      members: {
                        Id: {},
                        S3CanonicalUserId: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityList"
          }
        },
        ListDistributions: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S4t"
              }
            },
            payload: "DistributionList"
          }
        },
        ListDistributionsByWebACLId: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/distributionsByWebACLId/{WebACLId}"
          },
          input: {
            type: "structure",
            required: [
              "WebACLId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              WebACLId: {
                location: "uri",
                locationName: "WebACLId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S4t"
              }
            },
            payload: "DistributionList"
          }
        },
        ListFieldLevelEncryptionConfigs: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/field-level-encryption"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "FieldLevelEncryptionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "LastModifiedTime"
                      ],
                      members: {
                        Id: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Comment: {},
                        QueryArgProfileConfig: {
                          shape: "S2n"
                        },
                        ContentTypeProfileConfig: {
                          shape: "S2r"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "FieldLevelEncryptionList"
          }
        },
        ListFieldLevelEncryptionProfiles: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/field-level-encryption-profile"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfileList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "FieldLevelEncryptionProfileSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "LastModifiedTime",
                        "Name",
                        "EncryptionEntities"
                      ],
                      members: {
                        Id: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Name: {},
                        EncryptionEntities: {
                          shape: "S30"
                        },
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "FieldLevelEncryptionProfileList"
          }
        },
        ListInvalidations: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/distribution/{DistributionId}/invalidation"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InvalidationList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "InvalidationSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "CreateTime",
                        "Status"
                      ],
                      members: {
                        Id: {},
                        CreateTime: {
                          type: "timestamp"
                        },
                        Status: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "InvalidationList"
          }
        },
        ListPublicKeys: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/public-key"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "PublicKeySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "Name",
                        "CreatedTime",
                        "EncodedKey"
                      ],
                      members: {
                        Id: {},
                        Name: {},
                        CreatedTime: {
                          type: "timestamp"
                        },
                        EncodedKey: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "PublicKeyList"
          }
        },
        ListStreamingDistributions: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/streaming-distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "StreamingDistributionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "ARN",
                        "Status",
                        "LastModifiedTime",
                        "DomainName",
                        "S3Origin",
                        "Aliases",
                        "TrustedSigners",
                        "Comment",
                        "PriceClass",
                        "Enabled"
                      ],
                      members: {
                        Id: {},
                        ARN: {},
                        Status: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        DomainName: {},
                        S3Origin: {
                          shape: "S3j"
                        },
                        Aliases: {
                          shape: "S8"
                        },
                        TrustedSigners: {
                          shape: "S17"
                        },
                        Comment: {},
                        PriceClass: {},
                        Enabled: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "StreamingDistributionList"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2019-03-26/tagging"
          },
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "S2f"
              }
            },
            payload: "Tags"
          }
        },
        TagResource: {
          http: {
            requestUri: "/2019-03-26/tagging?Operation=Tag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "Tags"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              Tags: {
                shape: "S2f",
                locationName: "Tags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              }
            },
            payload: "Tags"
          }
        },
        UntagResource: {
          http: {
            requestUri: "/2019-03-26/tagging?Operation=Untag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "TagKeys"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              TagKeys: {
                locationName: "TagKeys",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                },
                type: "structure",
                members: {
                  Items: {
                    type: "list",
                    member: {
                      locationName: "Key"
                    }
                  }
                }
              }
            },
            payload: "TagKeys"
          }
        },
        UpdateCloudFrontOriginAccessIdentity: {
          http: {
            method: "PUT",
            requestUri: "/2019-03-26/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig",
              "Id"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "S2",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "S5"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        UpdateDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2019-03-26/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig",
              "Id"
            ],
            members: {
              DistributionConfig: {
                shape: "S7",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S23"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        UpdateFieldLevelEncryptionConfig: {
          http: {
            method: "PUT",
            requestUri: "/2019-03-26/field-level-encryption/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionConfig",
              "Id"
            ],
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S2m",
                locationName: "FieldLevelEncryptionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "FieldLevelEncryptionConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S2x"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        UpdateFieldLevelEncryptionProfile: {
          http: {
            method: "PUT",
            requestUri: "/2019-03-26/field-level-encryption-profile/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionProfileConfig",
              "Id"
            ],
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S2z",
                locationName: "FieldLevelEncryptionProfileConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S36"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        UpdatePublicKey: {
          http: {
            method: "PUT",
            requestUri: "/2019-03-26/public-key/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "PublicKeyConfig",
              "Id"
            ],
            members: {
              PublicKeyConfig: {
                shape: "S3e",
                locationName: "PublicKeyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "PublicKeyConfig"
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S3g"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        UpdateStreamingDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2019-03-26/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig",
              "Id"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S3i",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2019-03-26/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S3m"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "CallerReference",
            "Comment"
          ],
          members: {
            CallerReference: {},
            Comment: {}
          }
        },
        S5: {
          type: "structure",
          required: [
            "Id",
            "S3CanonicalUserId"
          ],
          members: {
            Id: {},
            S3CanonicalUserId: {},
            CloudFrontOriginAccessIdentityConfig: {
              shape: "S2"
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "CallerReference",
            "Origins",
            "DefaultCacheBehavior",
            "Comment",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            Aliases: {
              shape: "S8"
            },
            DefaultRootObject: {},
            Origins: {
              shape: "Sb"
            },
            OriginGroups: {
              shape: "Sn"
            },
            DefaultCacheBehavior: {
              shape: "Sw"
            },
            CacheBehaviors: {
              shape: "S1k"
            },
            CustomErrorResponses: {
              shape: "S1n"
            },
            Comment: {
              type: "string",
              sensitive: true
            },
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "IncludeCookies",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                IncludeCookies: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            },
            ViewerCertificate: {
              shape: "S1t"
            },
            Restrictions: {
              shape: "S1x"
            },
            WebACLId: {},
            HttpVersion: {},
            IsIPV6Enabled: {
              type: "boolean"
            }
          }
        },
        S8: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CNAME"
              }
            }
          }
        },
        Sb: {
          type: "structure",
          required: [
            "Quantity",
            "Items"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Origin",
                type: "structure",
                required: [
                  "Id",
                  "DomainName"
                ],
                members: {
                  Id: {},
                  DomainName: {},
                  OriginPath: {},
                  CustomHeaders: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "OriginCustomHeader",
                          type: "structure",
                          required: [
                            "HeaderName",
                            "HeaderValue"
                          ],
                          members: {
                            HeaderName: {},
                            HeaderValue: {}
                          }
                        }
                      }
                    }
                  },
                  S3OriginConfig: {
                    type: "structure",
                    required: [
                      "OriginAccessIdentity"
                    ],
                    members: {
                      OriginAccessIdentity: {}
                    }
                  },
                  CustomOriginConfig: {
                    type: "structure",
                    required: [
                      "HTTPPort",
                      "HTTPSPort",
                      "OriginProtocolPolicy"
                    ],
                    members: {
                      HTTPPort: {
                        type: "integer"
                      },
                      HTTPSPort: {
                        type: "integer"
                      },
                      OriginProtocolPolicy: {},
                      OriginSslProtocols: {
                        type: "structure",
                        required: [
                          "Quantity",
                          "Items"
                        ],
                        members: {
                          Quantity: {
                            type: "integer"
                          },
                          Items: {
                            type: "list",
                            member: {
                              locationName: "SslProtocol"
                            }
                          }
                        }
                      },
                      OriginReadTimeout: {
                        type: "integer"
                      },
                      OriginKeepaliveTimeout: {
                        type: "integer"
                      }
                    }
                  },
                  ConnectionAttempts: {
                    type: "integer"
                  },
                  ConnectionTimeout: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "OriginGroup",
                type: "structure",
                required: [
                  "Id",
                  "FailoverCriteria",
                  "Members"
                ],
                members: {
                  Id: {},
                  FailoverCriteria: {
                    type: "structure",
                    required: [
                      "StatusCodes"
                    ],
                    members: {
                      StatusCodes: {
                        type: "structure",
                        required: [
                          "Quantity",
                          "Items"
                        ],
                        members: {
                          Quantity: {
                            type: "integer"
                          },
                          Items: {
                            type: "list",
                            member: {
                              locationName: "StatusCode",
                              type: "integer"
                            }
                          }
                        }
                      }
                    }
                  },
                  Members: {
                    type: "structure",
                    required: [
                      "Quantity",
                      "Items"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "OriginGroupMember",
                          type: "structure",
                          required: [
                            "OriginId"
                          ],
                          members: {
                            OriginId: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sw: {
          type: "structure",
          required: [
            "TargetOriginId",
            "ForwardedValues",
            "TrustedSigners",
            "ViewerProtocolPolicy",
            "MinTTL"
          ],
          members: {
            TargetOriginId: {},
            ForwardedValues: {
              shape: "Sx"
            },
            TrustedSigners: {
              shape: "S17"
            },
            ViewerProtocolPolicy: {},
            MinTTL: {
              type: "long"
            },
            AllowedMethods: {
              shape: "S1b"
            },
            SmoothStreaming: {
              type: "boolean"
            },
            DefaultTTL: {
              type: "long"
            },
            MaxTTL: {
              type: "long"
            },
            Compress: {
              type: "boolean"
            },
            LambdaFunctionAssociations: {
              shape: "S1f"
            },
            FieldLevelEncryptionId: {}
          }
        },
        Sx: {
          type: "structure",
          required: [
            "QueryString",
            "Cookies"
          ],
          members: {
            QueryString: {
              type: "boolean"
            },
            Cookies: {
              type: "structure",
              required: [
                "Forward"
              ],
              members: {
                Forward: {},
                WhitelistedNames: {
                  type: "structure",
                  required: [
                    "Quantity"
                  ],
                  members: {
                    Quantity: {
                      type: "integer"
                    },
                    Items: {
                      type: "list",
                      member: {
                        locationName: "Name"
                      }
                    }
                  }
                }
              }
            },
            Headers: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            },
            QueryStringCacheKeys: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            }
          }
        },
        S17: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "AwsAccountNumber"
              }
            }
          }
        },
        S1b: {
          type: "structure",
          required: [
            "Quantity",
            "Items"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              shape: "S1c"
            },
            CachedMethods: {
              type: "structure",
              required: [
                "Quantity",
                "Items"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  shape: "S1c"
                }
              }
            }
          }
        },
        S1c: {
          type: "list",
          member: {
            locationName: "Method"
          }
        },
        S1f: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "LambdaFunctionAssociation",
                type: "structure",
                required: [
                  "LambdaFunctionARN",
                  "EventType"
                ],
                members: {
                  LambdaFunctionARN: {},
                  EventType: {},
                  IncludeBody: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S1k: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CacheBehavior",
                type: "structure",
                required: [
                  "PathPattern",
                  "TargetOriginId",
                  "ForwardedValues",
                  "TrustedSigners",
                  "ViewerProtocolPolicy",
                  "MinTTL"
                ],
                members: {
                  PathPattern: {},
                  TargetOriginId: {},
                  ForwardedValues: {
                    shape: "Sx"
                  },
                  TrustedSigners: {
                    shape: "S17"
                  },
                  ViewerProtocolPolicy: {},
                  MinTTL: {
                    type: "long"
                  },
                  AllowedMethods: {
                    shape: "S1b"
                  },
                  SmoothStreaming: {
                    type: "boolean"
                  },
                  DefaultTTL: {
                    type: "long"
                  },
                  MaxTTL: {
                    type: "long"
                  },
                  Compress: {
                    type: "boolean"
                  },
                  LambdaFunctionAssociations: {
                    shape: "S1f"
                  },
                  FieldLevelEncryptionId: {}
                }
              }
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CustomErrorResponse",
                type: "structure",
                required: [
                  "ErrorCode"
                ],
                members: {
                  ErrorCode: {
                    type: "integer"
                  },
                  ResponsePagePath: {},
                  ResponseCode: {},
                  ErrorCachingMinTTL: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S1t: {
          type: "structure",
          members: {
            CloudFrontDefaultCertificate: {
              type: "boolean"
            },
            IAMCertificateId: {},
            ACMCertificateArn: {},
            SSLSupportMethod: {},
            MinimumProtocolVersion: {},
            Certificate: {
              deprecated: true
            },
            CertificateSource: {
              deprecated: true
            }
          }
        },
        S1x: {
          type: "structure",
          required: [
            "GeoRestriction"
          ],
          members: {
            GeoRestriction: {
              type: "structure",
              required: [
                "RestrictionType",
                "Quantity"
              ],
              members: {
                RestrictionType: {},
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Location"
                  }
                }
              }
            }
          }
        },
        S23: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "LastModifiedTime",
            "InProgressInvalidationBatches",
            "DomainName",
            "ActiveTrustedSigners",
            "DistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            InProgressInvalidationBatches: {
              type: "integer"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S25"
            },
            DistributionConfig: {
              shape: "S7"
            },
            AliasICPRecordals: {
              shape: "S2a"
            }
          }
        },
        S25: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Signer",
                type: "structure",
                members: {
                  AwsAccountNumber: {},
                  KeyPairIds: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "KeyPairId"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S2a: {
          type: "list",
          member: {
            locationName: "AliasICPRecordal",
            type: "structure",
            members: {
              CNAME: {},
              ICPRecordalStatus: {}
            }
          }
        },
        S2f: {
          type: "structure",
          members: {
            Items: {
              type: "list",
              member: {
                locationName: "Tag",
                type: "structure",
                required: [
                  "Key"
                ],
                members: {
                  Key: {},
                  Value: {}
                }
              }
            }
          }
        },
        S2m: {
          type: "structure",
          required: [
            "CallerReference"
          ],
          members: {
            CallerReference: {},
            Comment: {},
            QueryArgProfileConfig: {
              shape: "S2n"
            },
            ContentTypeProfileConfig: {
              shape: "S2r"
            }
          }
        },
        S2n: {
          type: "structure",
          required: [
            "ForwardWhenQueryArgProfileIsUnknown"
          ],
          members: {
            ForwardWhenQueryArgProfileIsUnknown: {
              type: "boolean"
            },
            QueryArgProfiles: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "QueryArgProfile",
                    type: "structure",
                    required: [
                      "QueryArg",
                      "ProfileId"
                    ],
                    members: {
                      QueryArg: {},
                      ProfileId: {}
                    }
                  }
                }
              }
            }
          }
        },
        S2r: {
          type: "structure",
          required: [
            "ForwardWhenContentTypeIsUnknown"
          ],
          members: {
            ForwardWhenContentTypeIsUnknown: {
              type: "boolean"
            },
            ContentTypeProfiles: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "ContentTypeProfile",
                    type: "structure",
                    required: [
                      "Format",
                      "ContentType"
                    ],
                    members: {
                      Format: {},
                      ProfileId: {},
                      ContentType: {}
                    }
                  }
                }
              }
            }
          }
        },
        S2x: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "FieldLevelEncryptionConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            FieldLevelEncryptionConfig: {
              shape: "S2m"
            }
          }
        },
        S2z: {
          type: "structure",
          required: [
            "Name",
            "CallerReference",
            "EncryptionEntities"
          ],
          members: {
            Name: {},
            CallerReference: {},
            Comment: {},
            EncryptionEntities: {
              shape: "S30"
            }
          }
        },
        S30: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "EncryptionEntity",
                type: "structure",
                required: [
                  "PublicKeyId",
                  "ProviderId",
                  "FieldPatterns"
                ],
                members: {
                  PublicKeyId: {},
                  ProviderId: {},
                  FieldPatterns: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "FieldPattern"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S36: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "FieldLevelEncryptionProfileConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            FieldLevelEncryptionProfileConfig: {
              shape: "S2z"
            }
          }
        },
        S38: {
          type: "structure",
          required: [
            "Paths",
            "CallerReference"
          ],
          members: {
            Paths: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Path"
                  }
                }
              }
            },
            CallerReference: {}
          }
        },
        S3c: {
          type: "structure",
          required: [
            "Id",
            "Status",
            "CreateTime",
            "InvalidationBatch"
          ],
          members: {
            Id: {},
            Status: {},
            CreateTime: {
              type: "timestamp"
            },
            InvalidationBatch: {
              shape: "S38"
            }
          }
        },
        S3e: {
          type: "structure",
          required: [
            "CallerReference",
            "Name",
            "EncodedKey"
          ],
          members: {
            CallerReference: {},
            Name: {},
            EncodedKey: {},
            Comment: {}
          }
        },
        S3g: {
          type: "structure",
          required: [
            "Id",
            "CreatedTime",
            "PublicKeyConfig"
          ],
          members: {
            Id: {},
            CreatedTime: {
              type: "timestamp"
            },
            PublicKeyConfig: {
              shape: "S3e"
            }
          }
        },
        S3i: {
          type: "structure",
          required: [
            "CallerReference",
            "S3Origin",
            "Comment",
            "TrustedSigners",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            S3Origin: {
              shape: "S3j"
            },
            Aliases: {
              shape: "S8"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            TrustedSigners: {
              shape: "S17"
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            }
          }
        },
        S3j: {
          type: "structure",
          required: [
            "DomainName",
            "OriginAccessIdentity"
          ],
          members: {
            DomainName: {},
            OriginAccessIdentity: {}
          }
        },
        S3m: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "DomainName",
            "ActiveTrustedSigners",
            "StreamingDistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S25"
            },
            StreamingDistributionConfig: {
              shape: "S3i"
            }
          }
        },
        S4t: {
          type: "structure",
          required: [
            "Marker",
            "MaxItems",
            "IsTruncated",
            "Quantity"
          ],
          members: {
            Marker: {},
            NextMarker: {},
            MaxItems: {
              type: "integer"
            },
            IsTruncated: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "DistributionSummary",
                type: "structure",
                required: [
                  "Id",
                  "ARN",
                  "Status",
                  "LastModifiedTime",
                  "DomainName",
                  "Aliases",
                  "Origins",
                  "DefaultCacheBehavior",
                  "CacheBehaviors",
                  "CustomErrorResponses",
                  "Comment",
                  "PriceClass",
                  "Enabled",
                  "ViewerCertificate",
                  "Restrictions",
                  "WebACLId",
                  "HttpVersion",
                  "IsIPV6Enabled"
                ],
                members: {
                  Id: {},
                  ARN: {},
                  Status: {},
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  DomainName: {},
                  Aliases: {
                    shape: "S8"
                  },
                  Origins: {
                    shape: "Sb"
                  },
                  OriginGroups: {
                    shape: "Sn"
                  },
                  DefaultCacheBehavior: {
                    shape: "Sw"
                  },
                  CacheBehaviors: {
                    shape: "S1k"
                  },
                  CustomErrorResponses: {
                    shape: "S1n"
                  },
                  Comment: {},
                  PriceClass: {},
                  Enabled: {
                    type: "boolean"
                  },
                  ViewerCertificate: {
                    shape: "S1t"
                  },
                  Restrictions: {
                    shape: "S1x"
                  },
                  WebACLId: {},
                  HttpVersion: {},
                  IsIPV6Enabled: {
                    type: "boolean"
                  },
                  AliasICPRecordals: {
                    shape: "S2a"
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2019-03-26.paginators.json
var require_cloudfront_2019_03_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2019-03-26.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListCloudFrontOriginAccessIdentities: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "CloudFrontOriginAccessIdentityList.IsTruncated",
          output_token: "CloudFrontOriginAccessIdentityList.NextMarker",
          result_key: "CloudFrontOriginAccessIdentityList.Items"
        },
        ListDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "DistributionList.IsTruncated",
          output_token: "DistributionList.NextMarker",
          result_key: "DistributionList.Items"
        },
        ListInvalidations: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "InvalidationList.IsTruncated",
          output_token: "InvalidationList.NextMarker",
          result_key: "InvalidationList.Items"
        },
        ListStreamingDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "StreamingDistributionList.IsTruncated",
          output_token: "StreamingDistributionList.NextMarker",
          result_key: "StreamingDistributionList.Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2019-03-26.waiters2.json
var require_cloudfront_2019_03_26_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2019-03-26.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DistributionDeployed: {
          delay: 60,
          operation: "GetDistribution",
          maxAttempts: 35,
          description: "Wait until a distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "Distribution.Status"
            }
          ]
        },
        InvalidationCompleted: {
          delay: 20,
          operation: "GetInvalidation",
          maxAttempts: 30,
          description: "Wait until an invalidation has completed.",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "Invalidation.Status"
            }
          ]
        },
        StreamingDistributionDeployed: {
          delay: 60,
          operation: "GetStreamingDistribution",
          maxAttempts: 25,
          description: "Wait until a streaming distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "StreamingDistribution.Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2020-05-31.min.json
var require_cloudfront_2020_05_31_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2020-05-31.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-05-31",
        endpointPrefix: "cloudfront",
        globalEndpoint: "cloudfront.amazonaws.com",
        protocol: "rest-xml",
        serviceAbbreviation: "CloudFront",
        serviceFullName: "Amazon CloudFront",
        serviceId: "CloudFront",
        signatureVersion: "v4",
        uid: "cloudfront-2020-05-31"
      },
      operations: {
        AssociateAlias: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/distribution/{TargetDistributionId}/associate-alias",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TargetDistributionId",
              "Alias"
            ],
            members: {
              TargetDistributionId: {
                location: "uri",
                locationName: "TargetDistributionId"
              },
              Alias: {
                location: "querystring",
                locationName: "Alias"
              }
            }
          }
        },
        CreateCachePolicy: {
          http: {
            requestUri: "/2020-05-31/cache-policy",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "CachePolicyConfig"
            ],
            members: {
              CachePolicyConfig: {
                shape: "S4",
                locationName: "CachePolicyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "CachePolicyConfig"
          },
          output: {
            type: "structure",
            members: {
              CachePolicy: {
                shape: "Sm"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CachePolicy"
          }
        },
        CreateCloudFrontOriginAccessIdentity: {
          http: {
            requestUri: "/2020-05-31/origin-access-identity/cloudfront",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "Sp",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "Sr"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        CreateDistribution: {
          http: {
            requestUri: "/2020-05-31/distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig"
            ],
            members: {
              DistributionConfig: {
                shape: "St",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S2q"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateDistributionWithTags: {
          http: {
            requestUri: "/2020-05-31/distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfigWithTags"
            ],
            members: {
              DistributionConfigWithTags: {
                locationName: "DistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                },
                type: "structure",
                required: [
                  "DistributionConfig",
                  "Tags"
                ],
                members: {
                  DistributionConfig: {
                    shape: "St"
                  },
                  Tags: {
                    shape: "S34"
                  }
                }
              }
            },
            payload: "DistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S2q"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        CreateFieldLevelEncryptionConfig: {
          http: {
            requestUri: "/2020-05-31/field-level-encryption",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionConfig"
            ],
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S3b",
                locationName: "FieldLevelEncryptionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "FieldLevelEncryptionConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S3m"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        CreateFieldLevelEncryptionProfile: {
          http: {
            requestUri: "/2020-05-31/field-level-encryption-profile",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionProfileConfig"
            ],
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S3o",
                locationName: "FieldLevelEncryptionProfileConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S3v"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        CreateFunction: {
          http: {
            requestUri: "/2020-05-31/function",
            responseCode: 201
          },
          input: {
            locationName: "CreateFunctionRequest",
            xmlNamespace: {
              uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
            },
            type: "structure",
            required: [
              "Name",
              "FunctionConfig",
              "FunctionCode"
            ],
            members: {
              Name: {},
              FunctionConfig: {
                shape: "S3y"
              },
              FunctionCode: {
                shape: "S40"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FunctionSummary: {
                shape: "S42"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FunctionSummary"
          }
        },
        CreateInvalidation: {
          http: {
            requestUri: "/2020-05-31/distribution/{DistributionId}/invalidation",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "InvalidationBatch"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              InvalidationBatch: {
                shape: "S46",
                locationName: "InvalidationBatch",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "InvalidationBatch"
          },
          output: {
            type: "structure",
            members: {
              Location: {
                location: "header",
                locationName: "Location"
              },
              Invalidation: {
                shape: "S4a"
              }
            },
            payload: "Invalidation"
          }
        },
        CreateKeyGroup: {
          http: {
            requestUri: "/2020-05-31/key-group",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "KeyGroupConfig"
            ],
            members: {
              KeyGroupConfig: {
                shape: "S4c",
                locationName: "KeyGroupConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "KeyGroupConfig"
          },
          output: {
            type: "structure",
            members: {
              KeyGroup: {
                shape: "S4f"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "KeyGroup"
          }
        },
        CreateMonitoringSubscription: {
          http: {
            requestUri: "/2020-05-31/distributions/{DistributionId}/monitoring-subscription"
          },
          input: {
            type: "structure",
            required: [
              "MonitoringSubscription",
              "DistributionId"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              MonitoringSubscription: {
                shape: "S4h",
                locationName: "MonitoringSubscription",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "MonitoringSubscription"
          },
          output: {
            type: "structure",
            members: {
              MonitoringSubscription: {
                shape: "S4h"
              }
            },
            payload: "MonitoringSubscription"
          }
        },
        CreateOriginRequestPolicy: {
          http: {
            requestUri: "/2020-05-31/origin-request-policy",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "OriginRequestPolicyConfig"
            ],
            members: {
              OriginRequestPolicyConfig: {
                shape: "S4m",
                locationName: "OriginRequestPolicyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "OriginRequestPolicyConfig"
          },
          output: {
            type: "structure",
            members: {
              OriginRequestPolicy: {
                shape: "S4u"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "OriginRequestPolicy"
          }
        },
        CreatePublicKey: {
          http: {
            requestUri: "/2020-05-31/public-key",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "PublicKeyConfig"
            ],
            members: {
              PublicKeyConfig: {
                shape: "S4w",
                locationName: "PublicKeyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "PublicKeyConfig"
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S4y"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        CreateRealtimeLogConfig: {
          http: {
            requestUri: "/2020-05-31/realtime-log-config",
            responseCode: 201
          },
          input: {
            locationName: "CreateRealtimeLogConfigRequest",
            xmlNamespace: {
              uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
            },
            type: "structure",
            required: [
              "EndPoints",
              "Fields",
              "Name",
              "SamplingRate"
            ],
            members: {
              EndPoints: {
                shape: "S50"
              },
              Fields: {
                shape: "S53"
              },
              Name: {},
              SamplingRate: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RealtimeLogConfig: {
                shape: "S55"
              }
            }
          }
        },
        CreateStreamingDistribution: {
          http: {
            requestUri: "/2020-05-31/streaming-distribution",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S57",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S5b"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        CreateStreamingDistributionWithTags: {
          http: {
            requestUri: "/2020-05-31/streaming-distribution?WithTags",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfigWithTags"
            ],
            members: {
              StreamingDistributionConfigWithTags: {
                locationName: "StreamingDistributionConfigWithTags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                },
                type: "structure",
                required: [
                  "StreamingDistributionConfig",
                  "Tags"
                ],
                members: {
                  StreamingDistributionConfig: {
                    shape: "S57"
                  },
                  Tags: {
                    shape: "S34"
                  }
                }
              }
            },
            payload: "StreamingDistributionConfigWithTags"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S5b"
              },
              Location: {
                location: "header",
                locationName: "Location"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        DeleteCachePolicy: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/cache-policy/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteCloudFrontOriginAccessIdentity: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/origin-access-identity/cloudfront/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFieldLevelEncryptionConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/field-level-encryption/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFieldLevelEncryptionProfile: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/field-level-encryption-profile/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteFunction: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/function/{Name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "IfMatch",
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteKeyGroup: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/key-group/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteMonitoringSubscription: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/distributions/{DistributionId}/monitoring-subscription"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteOriginRequestPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/origin-request-policy/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeletePublicKey: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/public-key/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DeleteRealtimeLogConfig: {
          http: {
            requestUri: "/2020-05-31/delete-realtime-log-config/",
            responseCode: 204
          },
          input: {
            locationName: "DeleteRealtimeLogConfigRequest",
            xmlNamespace: {
              uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
            },
            type: "structure",
            members: {
              Name: {},
              ARN: {}
            }
          }
        },
        DeleteStreamingDistribution: {
          http: {
            method: "DELETE",
            requestUri: "/2020-05-31/streaming-distribution/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          }
        },
        DescribeFunction: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/function/{Name}/describe"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              Stage: {
                location: "querystring",
                locationName: "Stage"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FunctionSummary: {
                shape: "S42"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FunctionSummary"
          }
        },
        GetCachePolicy: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/cache-policy/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CachePolicy: {
                shape: "Sm"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CachePolicy"
          }
        },
        GetCachePolicyConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/cache-policy/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CachePolicyConfig: {
                shape: "S4"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CachePolicyConfig"
          }
        },
        GetCloudFrontOriginAccessIdentity: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/origin-access-identity/cloudfront/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "Sr"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        GetCloudFrontOriginAccessIdentityConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "Sp"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          }
        },
        GetDistribution: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S2q"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        GetDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionConfig: {
                shape: "St"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "DistributionConfig"
          }
        },
        GetFieldLevelEncryption: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/field-level-encryption/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S3m"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        GetFieldLevelEncryptionConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/field-level-encryption/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S3b"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionConfig"
          }
        },
        GetFieldLevelEncryptionProfile: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/field-level-encryption-profile/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S3v"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        GetFieldLevelEncryptionProfileConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/field-level-encryption-profile/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S3o"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          }
        },
        GetFunction: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/function/{Name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              Stage: {
                location: "querystring",
                locationName: "Stage"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FunctionCode: {
                shape: "S40"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              }
            },
            payload: "FunctionCode"
          }
        },
        GetInvalidation: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distribution/{DistributionId}/invalidation/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "Id"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invalidation: {
                shape: "S4a"
              }
            },
            payload: "Invalidation"
          }
        },
        GetKeyGroup: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/key-group/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyGroup: {
                shape: "S4f"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "KeyGroup"
          }
        },
        GetKeyGroupConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/key-group/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyGroupConfig: {
                shape: "S4c"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "KeyGroupConfig"
          }
        },
        GetMonitoringSubscription: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distributions/{DistributionId}/monitoring-subscription"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MonitoringSubscription: {
                shape: "S4h"
              }
            },
            payload: "MonitoringSubscription"
          }
        },
        GetOriginRequestPolicy: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/origin-request-policy/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OriginRequestPolicy: {
                shape: "S4u"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "OriginRequestPolicy"
          }
        },
        GetOriginRequestPolicyConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/origin-request-policy/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OriginRequestPolicyConfig: {
                shape: "S4m"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "OriginRequestPolicyConfig"
          }
        },
        GetPublicKey: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/public-key/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S4y"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        GetPublicKeyConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/public-key/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyConfig: {
                shape: "S4w"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKeyConfig"
          }
        },
        GetRealtimeLogConfig: {
          http: {
            requestUri: "/2020-05-31/get-realtime-log-config/"
          },
          input: {
            locationName: "GetRealtimeLogConfigRequest",
            xmlNamespace: {
              uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
            },
            type: "structure",
            members: {
              Name: {},
              ARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RealtimeLogConfig: {
                shape: "S55"
              }
            }
          }
        },
        GetStreamingDistribution: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/streaming-distribution/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S5b"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        },
        GetStreamingDistributionConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionConfig: {
                shape: "S57"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistributionConfig"
          }
        },
        ListCachePolicies: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/cache-policy"
          },
          input: {
            type: "structure",
            members: {
              Type: {
                location: "querystring",
                locationName: "Type"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CachePolicyList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "CachePolicySummary",
                      type: "structure",
                      required: [
                        "Type",
                        "CachePolicy"
                      ],
                      members: {
                        Type: {},
                        CachePolicy: {
                          shape: "Sm"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "CachePolicyList"
          }
        },
        ListCloudFrontOriginAccessIdentities: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/origin-access-identity/cloudfront"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentityList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "CloudFrontOriginAccessIdentitySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "S3CanonicalUserId",
                        "Comment"
                      ],
                      members: {
                        Id: {},
                        S3CanonicalUserId: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "CloudFrontOriginAccessIdentityList"
          }
        },
        ListConflictingAliases: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/conflicting-alias",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DistributionId",
              "Alias"
            ],
            members: {
              DistributionId: {
                location: "querystring",
                locationName: "DistributionId"
              },
              Alias: {
                location: "querystring",
                locationName: "Alias"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConflictingAliasesList: {
                type: "structure",
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "ConflictingAlias",
                      type: "structure",
                      members: {
                        Alias: {},
                        DistributionId: {},
                        AccountId: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "ConflictingAliasesList"
          }
        },
        ListDistributions: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S7n"
              }
            },
            payload: "DistributionList"
          }
        },
        ListDistributionsByCachePolicyId: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distributionsByCachePolicyId/{CachePolicyId}"
          },
          input: {
            type: "structure",
            required: [
              "CachePolicyId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              CachePolicyId: {
                location: "uri",
                locationName: "CachePolicyId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionIdList: {
                shape: "S7s"
              }
            },
            payload: "DistributionIdList"
          }
        },
        ListDistributionsByKeyGroup: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distributionsByKeyGroupId/{KeyGroupId}"
          },
          input: {
            type: "structure",
            required: [
              "KeyGroupId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              KeyGroupId: {
                location: "uri",
                locationName: "KeyGroupId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionIdList: {
                shape: "S7s"
              }
            },
            payload: "DistributionIdList"
          }
        },
        ListDistributionsByOriginRequestPolicyId: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distributionsByOriginRequestPolicyId/{OriginRequestPolicyId}"
          },
          input: {
            type: "structure",
            required: [
              "OriginRequestPolicyId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              OriginRequestPolicyId: {
                location: "uri",
                locationName: "OriginRequestPolicyId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionIdList: {
                shape: "S7s"
              }
            },
            payload: "DistributionIdList"
          }
        },
        ListDistributionsByRealtimeLogConfig: {
          http: {
            requestUri: "/2020-05-31/distributionsByRealtimeLogConfig/"
          },
          input: {
            locationName: "ListDistributionsByRealtimeLogConfigRequest",
            xmlNamespace: {
              uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
            },
            type: "structure",
            members: {
              Marker: {},
              MaxItems: {},
              RealtimeLogConfigName: {},
              RealtimeLogConfigArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S7n"
              }
            },
            payload: "DistributionList"
          }
        },
        ListDistributionsByWebACLId: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distributionsByWebACLId/{WebACLId}"
          },
          input: {
            type: "structure",
            required: [
              "WebACLId"
            ],
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              WebACLId: {
                location: "uri",
                locationName: "WebACLId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DistributionList: {
                shape: "S7n"
              }
            },
            payload: "DistributionList"
          }
        },
        ListFieldLevelEncryptionConfigs: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/field-level-encryption"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "FieldLevelEncryptionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "LastModifiedTime"
                      ],
                      members: {
                        Id: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Comment: {},
                        QueryArgProfileConfig: {
                          shape: "S3c"
                        },
                        ContentTypeProfileConfig: {
                          shape: "S3g"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "FieldLevelEncryptionList"
          }
        },
        ListFieldLevelEncryptionProfiles: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/field-level-encryption-profile"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfileList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "FieldLevelEncryptionProfileSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "LastModifiedTime",
                        "Name",
                        "EncryptionEntities"
                      ],
                      members: {
                        Id: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        Name: {},
                        EncryptionEntities: {
                          shape: "S3p"
                        },
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "FieldLevelEncryptionProfileList"
          }
        },
        ListFunctions: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/function"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              Stage: {
                location: "querystring",
                locationName: "Stage"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FunctionList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      shape: "S42",
                      locationName: "FunctionSummary"
                    }
                  }
                }
              }
            },
            payload: "FunctionList"
          }
        },
        ListInvalidations: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/distribution/{DistributionId}/invalidation"
          },
          input: {
            type: "structure",
            required: [
              "DistributionId"
            ],
            members: {
              DistributionId: {
                location: "uri",
                locationName: "DistributionId"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InvalidationList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "InvalidationSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "CreateTime",
                        "Status"
                      ],
                      members: {
                        Id: {},
                        CreateTime: {
                          type: "timestamp"
                        },
                        Status: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "InvalidationList"
          }
        },
        ListKeyGroups: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/key-group"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyGroupList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "KeyGroupSummary",
                      type: "structure",
                      required: [
                        "KeyGroup"
                      ],
                      members: {
                        KeyGroup: {
                          shape: "S4f"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "KeyGroupList"
          }
        },
        ListOriginRequestPolicies: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/origin-request-policy"
          },
          input: {
            type: "structure",
            members: {
              Type: {
                location: "querystring",
                locationName: "Type"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OriginRequestPolicyList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "OriginRequestPolicySummary",
                      type: "structure",
                      required: [
                        "Type",
                        "OriginRequestPolicy"
                      ],
                      members: {
                        Type: {},
                        OriginRequestPolicy: {
                          shape: "S4u"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "OriginRequestPolicyList"
          }
        },
        ListPublicKeys: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/public-key"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyList: {
                type: "structure",
                required: [
                  "MaxItems",
                  "Quantity"
                ],
                members: {
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "PublicKeySummary",
                      type: "structure",
                      required: [
                        "Id",
                        "Name",
                        "CreatedTime",
                        "EncodedKey"
                      ],
                      members: {
                        Id: {},
                        Name: {},
                        CreatedTime: {
                          type: "timestamp"
                        },
                        EncodedKey: {},
                        Comment: {}
                      }
                    }
                  }
                }
              }
            },
            payload: "PublicKeyList"
          }
        },
        ListRealtimeLogConfigs: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/realtime-log-config"
          },
          input: {
            type: "structure",
            members: {
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RealtimeLogConfigs: {
                type: "structure",
                required: [
                  "MaxItems",
                  "IsTruncated",
                  "Marker"
                ],
                members: {
                  MaxItems: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      shape: "S55"
                    }
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Marker: {},
                  NextMarker: {}
                }
              }
            },
            payload: "RealtimeLogConfigs"
          }
        },
        ListStreamingDistributions: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/streaming-distribution"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingDistributionList: {
                type: "structure",
                required: [
                  "Marker",
                  "MaxItems",
                  "IsTruncated",
                  "Quantity"
                ],
                members: {
                  Marker: {},
                  NextMarker: {},
                  MaxItems: {
                    type: "integer"
                  },
                  IsTruncated: {
                    type: "boolean"
                  },
                  Quantity: {
                    type: "integer"
                  },
                  Items: {
                    type: "list",
                    member: {
                      locationName: "StreamingDistributionSummary",
                      type: "structure",
                      required: [
                        "Id",
                        "ARN",
                        "Status",
                        "LastModifiedTime",
                        "DomainName",
                        "S3Origin",
                        "Aliases",
                        "TrustedSigners",
                        "Comment",
                        "PriceClass",
                        "Enabled"
                      ],
                      members: {
                        Id: {},
                        ARN: {},
                        Status: {},
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        DomainName: {},
                        S3Origin: {
                          shape: "S58"
                        },
                        Aliases: {
                          shape: "Su"
                        },
                        TrustedSigners: {
                          shape: "S1k"
                        },
                        Comment: {},
                        PriceClass: {},
                        Enabled: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            },
            payload: "StreamingDistributionList"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2020-05-31/tagging"
          },
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "S34"
              }
            },
            payload: "Tags"
          }
        },
        PublishFunction: {
          http: {
            requestUri: "/2020-05-31/function/{Name}/publish"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "IfMatch"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FunctionSummary: {
                shape: "S42"
              }
            },
            payload: "FunctionSummary"
          }
        },
        TagResource: {
          http: {
            requestUri: "/2020-05-31/tagging?Operation=Tag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "Tags"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              Tags: {
                shape: "S34",
                locationName: "Tags",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              }
            },
            payload: "Tags"
          }
        },
        TestFunction: {
          http: {
            requestUri: "/2020-05-31/function/{Name}/test"
          },
          input: {
            locationName: "TestFunctionRequest",
            xmlNamespace: {
              uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
            },
            type: "structure",
            required: [
              "Name",
              "IfMatch",
              "EventObject"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              },
              Stage: {},
              EventObject: {
                type: "blob",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TestResult: {
                type: "structure",
                members: {
                  FunctionSummary: {
                    shape: "S42"
                  },
                  ComputeUtilization: {},
                  FunctionExecutionLogs: {
                    type: "list",
                    member: {}
                  },
                  FunctionErrorMessage: {},
                  FunctionOutput: {}
                }
              }
            },
            payload: "TestResult"
          }
        },
        UntagResource: {
          http: {
            requestUri: "/2020-05-31/tagging?Operation=Untag",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "TagKeys"
            ],
            members: {
              Resource: {
                location: "querystring",
                locationName: "Resource"
              },
              TagKeys: {
                locationName: "TagKeys",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                },
                type: "structure",
                members: {
                  Items: {
                    type: "list",
                    member: {
                      locationName: "Key"
                    }
                  }
                }
              }
            },
            payload: "TagKeys"
          }
        },
        UpdateCachePolicy: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/cache-policy/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "CachePolicyConfig",
              "Id"
            ],
            members: {
              CachePolicyConfig: {
                shape: "S4",
                locationName: "CachePolicyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "CachePolicyConfig"
          },
          output: {
            type: "structure",
            members: {
              CachePolicy: {
                shape: "Sm"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CachePolicy"
          }
        },
        UpdateCloudFrontOriginAccessIdentity: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/origin-access-identity/cloudfront/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "CloudFrontOriginAccessIdentityConfig",
              "Id"
            ],
            members: {
              CloudFrontOriginAccessIdentityConfig: {
                shape: "Sp",
                locationName: "CloudFrontOriginAccessIdentityConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "CloudFrontOriginAccessIdentityConfig"
          },
          output: {
            type: "structure",
            members: {
              CloudFrontOriginAccessIdentity: {
                shape: "Sr"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "CloudFrontOriginAccessIdentity"
          }
        },
        UpdateDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "DistributionConfig",
              "Id"
            ],
            members: {
              DistributionConfig: {
                shape: "St",
                locationName: "DistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "DistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              Distribution: {
                shape: "S2q"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "Distribution"
          }
        },
        UpdateFieldLevelEncryptionConfig: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/field-level-encryption/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionConfig",
              "Id"
            ],
            members: {
              FieldLevelEncryptionConfig: {
                shape: "S3b",
                locationName: "FieldLevelEncryptionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "FieldLevelEncryptionConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryption: {
                shape: "S3m"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryption"
          }
        },
        UpdateFieldLevelEncryptionProfile: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/field-level-encryption-profile/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "FieldLevelEncryptionProfileConfig",
              "Id"
            ],
            members: {
              FieldLevelEncryptionProfileConfig: {
                shape: "S3o",
                locationName: "FieldLevelEncryptionProfileConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "FieldLevelEncryptionProfileConfig"
          },
          output: {
            type: "structure",
            members: {
              FieldLevelEncryptionProfile: {
                shape: "S3v"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "FieldLevelEncryptionProfile"
          }
        },
        UpdateFunction: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/function/{Name}"
          },
          input: {
            locationName: "UpdateFunctionRequest",
            xmlNamespace: {
              uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
            },
            type: "structure",
            required: [
              "IfMatch",
              "FunctionConfig",
              "FunctionCode",
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              },
              FunctionConfig: {
                shape: "S3y"
              },
              FunctionCode: {
                shape: "S40"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FunctionSummary: {
                shape: "S42"
              },
              ETag: {
                location: "header",
                locationName: "ETtag"
              }
            },
            payload: "FunctionSummary"
          }
        },
        UpdateKeyGroup: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/key-group/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "KeyGroupConfig",
              "Id"
            ],
            members: {
              KeyGroupConfig: {
                shape: "S4c",
                locationName: "KeyGroupConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "KeyGroupConfig"
          },
          output: {
            type: "structure",
            members: {
              KeyGroup: {
                shape: "S4f"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "KeyGroup"
          }
        },
        UpdateOriginRequestPolicy: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/origin-request-policy/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "OriginRequestPolicyConfig",
              "Id"
            ],
            members: {
              OriginRequestPolicyConfig: {
                shape: "S4m",
                locationName: "OriginRequestPolicyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "OriginRequestPolicyConfig"
          },
          output: {
            type: "structure",
            members: {
              OriginRequestPolicy: {
                shape: "S4u"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "OriginRequestPolicy"
          }
        },
        UpdatePublicKey: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/public-key/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "PublicKeyConfig",
              "Id"
            ],
            members: {
              PublicKeyConfig: {
                shape: "S4w",
                locationName: "PublicKeyConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "PublicKeyConfig"
          },
          output: {
            type: "structure",
            members: {
              PublicKey: {
                shape: "S4y"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "PublicKey"
          }
        },
        UpdateRealtimeLogConfig: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/realtime-log-config/"
          },
          input: {
            locationName: "UpdateRealtimeLogConfigRequest",
            xmlNamespace: {
              uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
            },
            type: "structure",
            members: {
              EndPoints: {
                shape: "S50"
              },
              Fields: {
                shape: "S53"
              },
              Name: {},
              ARN: {},
              SamplingRate: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RealtimeLogConfig: {
                shape: "S55"
              }
            }
          }
        },
        UpdateStreamingDistribution: {
          http: {
            method: "PUT",
            requestUri: "/2020-05-31/streaming-distribution/{Id}/config"
          },
          input: {
            type: "structure",
            required: [
              "StreamingDistributionConfig",
              "Id"
            ],
            members: {
              StreamingDistributionConfig: {
                shape: "S57",
                locationName: "StreamingDistributionConfig",
                xmlNamespace: {
                  uri: "http://cloudfront.amazonaws.com/doc/2020-05-31/"
                }
              },
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              }
            },
            payload: "StreamingDistributionConfig"
          },
          output: {
            type: "structure",
            members: {
              StreamingDistribution: {
                shape: "S5b"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              }
            },
            payload: "StreamingDistribution"
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "Name",
            "MinTTL"
          ],
          members: {
            Comment: {},
            Name: {},
            DefaultTTL: {
              type: "long"
            },
            MaxTTL: {
              type: "long"
            },
            MinTTL: {
              type: "long"
            },
            ParametersInCacheKeyAndForwardedToOrigin: {
              type: "structure",
              required: [
                "EnableAcceptEncodingGzip",
                "HeadersConfig",
                "CookiesConfig",
                "QueryStringsConfig"
              ],
              members: {
                EnableAcceptEncodingGzip: {
                  type: "boolean"
                },
                EnableAcceptEncodingBrotli: {
                  type: "boolean"
                },
                HeadersConfig: {
                  type: "structure",
                  required: [
                    "HeaderBehavior"
                  ],
                  members: {
                    HeaderBehavior: {},
                    Headers: {
                      shape: "Sa"
                    }
                  }
                },
                CookiesConfig: {
                  type: "structure",
                  required: [
                    "CookieBehavior"
                  ],
                  members: {
                    CookieBehavior: {},
                    Cookies: {
                      shape: "Sf"
                    }
                  }
                },
                QueryStringsConfig: {
                  type: "structure",
                  required: [
                    "QueryStringBehavior"
                  ],
                  members: {
                    QueryStringBehavior: {},
                    QueryStrings: {
                      shape: "Sj"
                    }
                  }
                }
              }
            }
          }
        },
        Sa: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Name"
              }
            }
          }
        },
        Sf: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Name"
              }
            }
          }
        },
        Sj: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Name"
              }
            }
          }
        },
        Sm: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "CachePolicyConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            CachePolicyConfig: {
              shape: "S4"
            }
          }
        },
        Sp: {
          type: "structure",
          required: [
            "CallerReference",
            "Comment"
          ],
          members: {
            CallerReference: {},
            Comment: {}
          }
        },
        Sr: {
          type: "structure",
          required: [
            "Id",
            "S3CanonicalUserId"
          ],
          members: {
            Id: {},
            S3CanonicalUserId: {},
            CloudFrontOriginAccessIdentityConfig: {
              shape: "Sp"
            }
          }
        },
        St: {
          type: "structure",
          required: [
            "CallerReference",
            "Origins",
            "DefaultCacheBehavior",
            "Comment",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            Aliases: {
              shape: "Su"
            },
            DefaultRootObject: {},
            Origins: {
              shape: "Sw"
            },
            OriginGroups: {
              shape: "S1a"
            },
            DefaultCacheBehavior: {
              shape: "S1j"
            },
            CacheBehaviors: {
              shape: "S27"
            },
            CustomErrorResponses: {
              shape: "S2a"
            },
            Comment: {
              type: "string",
              sensitive: true
            },
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "IncludeCookies",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                IncludeCookies: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            },
            ViewerCertificate: {
              shape: "S2g"
            },
            Restrictions: {
              shape: "S2k"
            },
            WebACLId: {},
            HttpVersion: {},
            IsIPV6Enabled: {
              type: "boolean"
            }
          }
        },
        Su: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CNAME"
              }
            }
          }
        },
        Sw: {
          type: "structure",
          required: [
            "Quantity",
            "Items"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Origin",
                type: "structure",
                required: [
                  "Id",
                  "DomainName"
                ],
                members: {
                  Id: {},
                  DomainName: {},
                  OriginPath: {},
                  CustomHeaders: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "OriginCustomHeader",
                          type: "structure",
                          required: [
                            "HeaderName",
                            "HeaderValue"
                          ],
                          members: {
                            HeaderName: {},
                            HeaderValue: {}
                          }
                        }
                      }
                    }
                  },
                  S3OriginConfig: {
                    type: "structure",
                    required: [
                      "OriginAccessIdentity"
                    ],
                    members: {
                      OriginAccessIdentity: {}
                    }
                  },
                  CustomOriginConfig: {
                    type: "structure",
                    required: [
                      "HTTPPort",
                      "HTTPSPort",
                      "OriginProtocolPolicy"
                    ],
                    members: {
                      HTTPPort: {
                        type: "integer"
                      },
                      HTTPSPort: {
                        type: "integer"
                      },
                      OriginProtocolPolicy: {},
                      OriginSslProtocols: {
                        type: "structure",
                        required: [
                          "Quantity",
                          "Items"
                        ],
                        members: {
                          Quantity: {
                            type: "integer"
                          },
                          Items: {
                            type: "list",
                            member: {
                              locationName: "SslProtocol"
                            }
                          }
                        }
                      },
                      OriginReadTimeout: {
                        type: "integer"
                      },
                      OriginKeepaliveTimeout: {
                        type: "integer"
                      }
                    }
                  },
                  ConnectionAttempts: {
                    type: "integer"
                  },
                  ConnectionTimeout: {
                    type: "integer"
                  },
                  OriginShield: {
                    type: "structure",
                    required: [
                      "Enabled"
                    ],
                    members: {
                      Enabled: {
                        type: "boolean"
                      },
                      OriginShieldRegion: {}
                    }
                  }
                }
              }
            }
          }
        },
        S1a: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "OriginGroup",
                type: "structure",
                required: [
                  "Id",
                  "FailoverCriteria",
                  "Members"
                ],
                members: {
                  Id: {},
                  FailoverCriteria: {
                    type: "structure",
                    required: [
                      "StatusCodes"
                    ],
                    members: {
                      StatusCodes: {
                        type: "structure",
                        required: [
                          "Quantity",
                          "Items"
                        ],
                        members: {
                          Quantity: {
                            type: "integer"
                          },
                          Items: {
                            type: "list",
                            member: {
                              locationName: "StatusCode",
                              type: "integer"
                            }
                          }
                        }
                      }
                    }
                  },
                  Members: {
                    type: "structure",
                    required: [
                      "Quantity",
                      "Items"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "OriginGroupMember",
                          type: "structure",
                          required: [
                            "OriginId"
                          ],
                          members: {
                            OriginId: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S1j: {
          type: "structure",
          required: [
            "TargetOriginId",
            "ViewerProtocolPolicy"
          ],
          members: {
            TargetOriginId: {},
            TrustedSigners: {
              shape: "S1k"
            },
            TrustedKeyGroups: {
              shape: "S1m"
            },
            ViewerProtocolPolicy: {},
            AllowedMethods: {
              shape: "S1p"
            },
            SmoothStreaming: {
              type: "boolean"
            },
            Compress: {
              type: "boolean"
            },
            LambdaFunctionAssociations: {
              shape: "S1t"
            },
            FunctionAssociations: {
              shape: "S1y"
            },
            FieldLevelEncryptionId: {},
            RealtimeLogConfigArn: {},
            CachePolicyId: {},
            OriginRequestPolicyId: {},
            ForwardedValues: {
              shape: "S22",
              deprecated: true
            },
            MinTTL: {
              deprecated: true,
              type: "long"
            },
            DefaultTTL: {
              deprecated: true,
              type: "long"
            },
            MaxTTL: {
              deprecated: true,
              type: "long"
            }
          }
        },
        S1k: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "AwsAccountNumber"
              }
            }
          }
        },
        S1m: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "KeyGroup"
              }
            }
          }
        },
        S1p: {
          type: "structure",
          required: [
            "Quantity",
            "Items"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              shape: "S1q"
            },
            CachedMethods: {
              type: "structure",
              required: [
                "Quantity",
                "Items"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  shape: "S1q"
                }
              }
            }
          }
        },
        S1q: {
          type: "list",
          member: {
            locationName: "Method"
          }
        },
        S1t: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "LambdaFunctionAssociation",
                type: "structure",
                required: [
                  "LambdaFunctionARN",
                  "EventType"
                ],
                members: {
                  LambdaFunctionARN: {},
                  EventType: {},
                  IncludeBody: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S1y: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "FunctionAssociation",
                type: "structure",
                required: [
                  "FunctionARN",
                  "EventType"
                ],
                members: {
                  FunctionARN: {},
                  EventType: {}
                }
              }
            }
          }
        },
        S22: {
          type: "structure",
          required: [
            "QueryString",
            "Cookies"
          ],
          members: {
            QueryString: {
              type: "boolean"
            },
            Cookies: {
              type: "structure",
              required: [
                "Forward"
              ],
              members: {
                Forward: {},
                WhitelistedNames: {
                  shape: "Sf"
                }
              }
            },
            Headers: {
              shape: "Sa"
            },
            QueryStringCacheKeys: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Name"
                  }
                }
              }
            }
          }
        },
        S27: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CacheBehavior",
                type: "structure",
                required: [
                  "PathPattern",
                  "TargetOriginId",
                  "ViewerProtocolPolicy"
                ],
                members: {
                  PathPattern: {},
                  TargetOriginId: {},
                  TrustedSigners: {
                    shape: "S1k"
                  },
                  TrustedKeyGroups: {
                    shape: "S1m"
                  },
                  ViewerProtocolPolicy: {},
                  AllowedMethods: {
                    shape: "S1p"
                  },
                  SmoothStreaming: {
                    type: "boolean"
                  },
                  Compress: {
                    type: "boolean"
                  },
                  LambdaFunctionAssociations: {
                    shape: "S1t"
                  },
                  FunctionAssociations: {
                    shape: "S1y"
                  },
                  FieldLevelEncryptionId: {},
                  RealtimeLogConfigArn: {},
                  CachePolicyId: {},
                  OriginRequestPolicyId: {},
                  ForwardedValues: {
                    shape: "S22",
                    deprecated: true
                  },
                  MinTTL: {
                    deprecated: true,
                    type: "long"
                  },
                  DefaultTTL: {
                    deprecated: true,
                    type: "long"
                  },
                  MaxTTL: {
                    deprecated: true,
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S2a: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "CustomErrorResponse",
                type: "structure",
                required: [
                  "ErrorCode"
                ],
                members: {
                  ErrorCode: {
                    type: "integer"
                  },
                  ResponsePagePath: {},
                  ResponseCode: {},
                  ErrorCachingMinTTL: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S2g: {
          type: "structure",
          members: {
            CloudFrontDefaultCertificate: {
              type: "boolean"
            },
            IAMCertificateId: {},
            ACMCertificateArn: {},
            SSLSupportMethod: {},
            MinimumProtocolVersion: {},
            Certificate: {
              deprecated: true
            },
            CertificateSource: {
              deprecated: true
            }
          }
        },
        S2k: {
          type: "structure",
          required: [
            "GeoRestriction"
          ],
          members: {
            GeoRestriction: {
              type: "structure",
              required: [
                "RestrictionType",
                "Quantity"
              ],
              members: {
                RestrictionType: {},
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Location"
                  }
                }
              }
            }
          }
        },
        S2q: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "LastModifiedTime",
            "InProgressInvalidationBatches",
            "DomainName",
            "DistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            InProgressInvalidationBatches: {
              type: "integer"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S2r"
            },
            ActiveTrustedKeyGroups: {
              type: "structure",
              required: [
                "Enabled",
                "Quantity"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "KeyGroup",
                    type: "structure",
                    members: {
                      KeyGroupId: {},
                      KeyPairIds: {
                        shape: "S2u"
                      }
                    }
                  }
                }
              }
            },
            DistributionConfig: {
              shape: "St"
            },
            AliasICPRecordals: {
              shape: "S2z"
            }
          }
        },
        S2r: {
          type: "structure",
          required: [
            "Enabled",
            "Quantity"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "Signer",
                type: "structure",
                members: {
                  AwsAccountNumber: {},
                  KeyPairIds: {
                    shape: "S2u"
                  }
                }
              }
            }
          }
        },
        S2u: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "KeyPairId"
              }
            }
          }
        },
        S2z: {
          type: "list",
          member: {
            locationName: "AliasICPRecordal",
            type: "structure",
            members: {
              CNAME: {},
              ICPRecordalStatus: {}
            }
          }
        },
        S34: {
          type: "structure",
          members: {
            Items: {
              type: "list",
              member: {
                locationName: "Tag",
                type: "structure",
                required: [
                  "Key"
                ],
                members: {
                  Key: {},
                  Value: {}
                }
              }
            }
          }
        },
        S3b: {
          type: "structure",
          required: [
            "CallerReference"
          ],
          members: {
            CallerReference: {},
            Comment: {},
            QueryArgProfileConfig: {
              shape: "S3c"
            },
            ContentTypeProfileConfig: {
              shape: "S3g"
            }
          }
        },
        S3c: {
          type: "structure",
          required: [
            "ForwardWhenQueryArgProfileIsUnknown"
          ],
          members: {
            ForwardWhenQueryArgProfileIsUnknown: {
              type: "boolean"
            },
            QueryArgProfiles: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "QueryArgProfile",
                    type: "structure",
                    required: [
                      "QueryArg",
                      "ProfileId"
                    ],
                    members: {
                      QueryArg: {},
                      ProfileId: {}
                    }
                  }
                }
              }
            }
          }
        },
        S3g: {
          type: "structure",
          required: [
            "ForwardWhenContentTypeIsUnknown"
          ],
          members: {
            ForwardWhenContentTypeIsUnknown: {
              type: "boolean"
            },
            ContentTypeProfiles: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "ContentTypeProfile",
                    type: "structure",
                    required: [
                      "Format",
                      "ContentType"
                    ],
                    members: {
                      Format: {},
                      ProfileId: {},
                      ContentType: {}
                    }
                  }
                }
              }
            }
          }
        },
        S3m: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "FieldLevelEncryptionConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            FieldLevelEncryptionConfig: {
              shape: "S3b"
            }
          }
        },
        S3o: {
          type: "structure",
          required: [
            "Name",
            "CallerReference",
            "EncryptionEntities"
          ],
          members: {
            Name: {},
            CallerReference: {},
            Comment: {},
            EncryptionEntities: {
              shape: "S3p"
            }
          }
        },
        S3p: {
          type: "structure",
          required: [
            "Quantity"
          ],
          members: {
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "EncryptionEntity",
                type: "structure",
                required: [
                  "PublicKeyId",
                  "ProviderId",
                  "FieldPatterns"
                ],
                members: {
                  PublicKeyId: {},
                  ProviderId: {},
                  FieldPatterns: {
                    type: "structure",
                    required: [
                      "Quantity"
                    ],
                    members: {
                      Quantity: {
                        type: "integer"
                      },
                      Items: {
                        type: "list",
                        member: {
                          locationName: "FieldPattern"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S3v: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "FieldLevelEncryptionProfileConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            FieldLevelEncryptionProfileConfig: {
              shape: "S3o"
            }
          }
        },
        S3y: {
          type: "structure",
          required: [
            "Comment",
            "Runtime"
          ],
          members: {
            Comment: {},
            Runtime: {}
          }
        },
        S40: {
          type: "blob",
          sensitive: true
        },
        S42: {
          type: "structure",
          required: [
            "Name",
            "FunctionConfig",
            "FunctionMetadata"
          ],
          members: {
            Name: {},
            Status: {},
            FunctionConfig: {
              shape: "S3y"
            },
            FunctionMetadata: {
              type: "structure",
              required: [
                "FunctionARN",
                "LastModifiedTime"
              ],
              members: {
                FunctionARN: {},
                Stage: {},
                CreatedTime: {
                  type: "timestamp"
                },
                LastModifiedTime: {
                  type: "timestamp"
                }
              }
            }
          }
        },
        S46: {
          type: "structure",
          required: [
            "Paths",
            "CallerReference"
          ],
          members: {
            Paths: {
              type: "structure",
              required: [
                "Quantity"
              ],
              members: {
                Quantity: {
                  type: "integer"
                },
                Items: {
                  type: "list",
                  member: {
                    locationName: "Path"
                  }
                }
              }
            },
            CallerReference: {}
          }
        },
        S4a: {
          type: "structure",
          required: [
            "Id",
            "Status",
            "CreateTime",
            "InvalidationBatch"
          ],
          members: {
            Id: {},
            Status: {},
            CreateTime: {
              type: "timestamp"
            },
            InvalidationBatch: {
              shape: "S46"
            }
          }
        },
        S4c: {
          type: "structure",
          required: [
            "Name",
            "Items"
          ],
          members: {
            Name: {},
            Items: {
              type: "list",
              member: {
                locationName: "PublicKey"
              }
            },
            Comment: {}
          }
        },
        S4f: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "KeyGroupConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            KeyGroupConfig: {
              shape: "S4c"
            }
          }
        },
        S4h: {
          type: "structure",
          members: {
            RealtimeMetricsSubscriptionConfig: {
              type: "structure",
              required: [
                "RealtimeMetricsSubscriptionStatus"
              ],
              members: {
                RealtimeMetricsSubscriptionStatus: {}
              }
            }
          }
        },
        S4m: {
          type: "structure",
          required: [
            "Name",
            "HeadersConfig",
            "CookiesConfig",
            "QueryStringsConfig"
          ],
          members: {
            Comment: {},
            Name: {},
            HeadersConfig: {
              type: "structure",
              required: [
                "HeaderBehavior"
              ],
              members: {
                HeaderBehavior: {},
                Headers: {
                  shape: "Sa"
                }
              }
            },
            CookiesConfig: {
              type: "structure",
              required: [
                "CookieBehavior"
              ],
              members: {
                CookieBehavior: {},
                Cookies: {
                  shape: "Sf"
                }
              }
            },
            QueryStringsConfig: {
              type: "structure",
              required: [
                "QueryStringBehavior"
              ],
              members: {
                QueryStringBehavior: {},
                QueryStrings: {
                  shape: "Sj"
                }
              }
            }
          }
        },
        S4u: {
          type: "structure",
          required: [
            "Id",
            "LastModifiedTime",
            "OriginRequestPolicyConfig"
          ],
          members: {
            Id: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            OriginRequestPolicyConfig: {
              shape: "S4m"
            }
          }
        },
        S4w: {
          type: "structure",
          required: [
            "CallerReference",
            "Name",
            "EncodedKey"
          ],
          members: {
            CallerReference: {},
            Name: {},
            EncodedKey: {},
            Comment: {}
          }
        },
        S4y: {
          type: "structure",
          required: [
            "Id",
            "CreatedTime",
            "PublicKeyConfig"
          ],
          members: {
            Id: {},
            CreatedTime: {
              type: "timestamp"
            },
            PublicKeyConfig: {
              shape: "S4w"
            }
          }
        },
        S50: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "StreamType"
            ],
            members: {
              StreamType: {},
              KinesisStreamConfig: {
                type: "structure",
                required: [
                  "RoleARN",
                  "StreamARN"
                ],
                members: {
                  RoleARN: {},
                  StreamARN: {}
                }
              }
            }
          }
        },
        S53: {
          type: "list",
          member: {
            locationName: "Field"
          }
        },
        S55: {
          type: "structure",
          required: [
            "ARN",
            "Name",
            "SamplingRate",
            "EndPoints",
            "Fields"
          ],
          members: {
            ARN: {},
            Name: {},
            SamplingRate: {
              type: "long"
            },
            EndPoints: {
              shape: "S50"
            },
            Fields: {
              shape: "S53"
            }
          }
        },
        S57: {
          type: "structure",
          required: [
            "CallerReference",
            "S3Origin",
            "Comment",
            "TrustedSigners",
            "Enabled"
          ],
          members: {
            CallerReference: {},
            S3Origin: {
              shape: "S58"
            },
            Aliases: {
              shape: "Su"
            },
            Comment: {},
            Logging: {
              type: "structure",
              required: [
                "Enabled",
                "Bucket",
                "Prefix"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                Bucket: {},
                Prefix: {}
              }
            },
            TrustedSigners: {
              shape: "S1k"
            },
            PriceClass: {},
            Enabled: {
              type: "boolean"
            }
          }
        },
        S58: {
          type: "structure",
          required: [
            "DomainName",
            "OriginAccessIdentity"
          ],
          members: {
            DomainName: {},
            OriginAccessIdentity: {}
          }
        },
        S5b: {
          type: "structure",
          required: [
            "Id",
            "ARN",
            "Status",
            "DomainName",
            "ActiveTrustedSigners",
            "StreamingDistributionConfig"
          ],
          members: {
            Id: {},
            ARN: {},
            Status: {},
            LastModifiedTime: {
              type: "timestamp"
            },
            DomainName: {},
            ActiveTrustedSigners: {
              shape: "S2r"
            },
            StreamingDistributionConfig: {
              shape: "S57"
            }
          }
        },
        S7n: {
          type: "structure",
          required: [
            "Marker",
            "MaxItems",
            "IsTruncated",
            "Quantity"
          ],
          members: {
            Marker: {},
            NextMarker: {},
            MaxItems: {
              type: "integer"
            },
            IsTruncated: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "DistributionSummary",
                type: "structure",
                required: [
                  "Id",
                  "ARN",
                  "Status",
                  "LastModifiedTime",
                  "DomainName",
                  "Aliases",
                  "Origins",
                  "DefaultCacheBehavior",
                  "CacheBehaviors",
                  "CustomErrorResponses",
                  "Comment",
                  "PriceClass",
                  "Enabled",
                  "ViewerCertificate",
                  "Restrictions",
                  "WebACLId",
                  "HttpVersion",
                  "IsIPV6Enabled"
                ],
                members: {
                  Id: {},
                  ARN: {},
                  Status: {},
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  DomainName: {},
                  Aliases: {
                    shape: "Su"
                  },
                  Origins: {
                    shape: "Sw"
                  },
                  OriginGroups: {
                    shape: "S1a"
                  },
                  DefaultCacheBehavior: {
                    shape: "S1j"
                  },
                  CacheBehaviors: {
                    shape: "S27"
                  },
                  CustomErrorResponses: {
                    shape: "S2a"
                  },
                  Comment: {},
                  PriceClass: {},
                  Enabled: {
                    type: "boolean"
                  },
                  ViewerCertificate: {
                    shape: "S2g"
                  },
                  Restrictions: {
                    shape: "S2k"
                  },
                  WebACLId: {},
                  HttpVersion: {},
                  IsIPV6Enabled: {
                    type: "boolean"
                  },
                  AliasICPRecordals: {
                    shape: "S2z"
                  }
                }
              }
            }
          }
        },
        S7s: {
          type: "structure",
          required: [
            "Marker",
            "MaxItems",
            "IsTruncated",
            "Quantity"
          ],
          members: {
            Marker: {},
            NextMarker: {},
            MaxItems: {
              type: "integer"
            },
            IsTruncated: {
              type: "boolean"
            },
            Quantity: {
              type: "integer"
            },
            Items: {
              type: "list",
              member: {
                locationName: "DistributionId"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2020-05-31.paginators.json
var require_cloudfront_2020_05_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2020-05-31.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListCloudFrontOriginAccessIdentities: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "CloudFrontOriginAccessIdentityList.IsTruncated",
          output_token: "CloudFrontOriginAccessIdentityList.NextMarker",
          result_key: "CloudFrontOriginAccessIdentityList.Items"
        },
        ListDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "DistributionList.IsTruncated",
          output_token: "DistributionList.NextMarker",
          result_key: "DistributionList.Items"
        },
        ListInvalidations: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "InvalidationList.IsTruncated",
          output_token: "InvalidationList.NextMarker",
          result_key: "InvalidationList.Items"
        },
        ListStreamingDistributions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "StreamingDistributionList.IsTruncated",
          output_token: "StreamingDistributionList.NextMarker",
          result_key: "StreamingDistributionList.Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudfront-2020-05-31.waiters2.json
var require_cloudfront_2020_05_31_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/cloudfront-2020-05-31.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DistributionDeployed: {
          delay: 60,
          operation: "GetDistribution",
          maxAttempts: 35,
          description: "Wait until a distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "Distribution.Status"
            }
          ]
        },
        InvalidationCompleted: {
          delay: 20,
          operation: "GetInvalidation",
          maxAttempts: 30,
          description: "Wait until an invalidation has completed.",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "Invalidation.Status"
            }
          ]
        },
        StreamingDistributionDeployed: {
          delay: 60,
          operation: "GetStreamingDistribution",
          maxAttempts: 25,
          description: "Wait until a streaming distribution is deployed.",
          acceptors: [
            {
              expected: "Deployed",
              matcher: "path",
              state: "success",
              argument: "StreamingDistribution.Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cloudfront.js
var require_cloudfront2 = __commonJS({
  "node_modules/aws-sdk/clients/cloudfront.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["cloudfront"] = {};
    AWS3.CloudFront = Service.defineService("cloudfront", ["2013-05-12*", "2013-11-11*", "2014-05-31*", "2014-10-21*", "2014-11-06*", "2015-04-17*", "2015-07-27*", "2015-09-17*", "2016-01-13*", "2016-01-28*", "2016-08-01*", "2016-08-20*", "2016-09-07*", "2016-09-29*", "2016-11-25", "2016-11-25*", "2017-03-25", "2017-03-25*", "2017-10-30", "2017-10-30*", "2018-06-18", "2018-06-18*", "2018-11-05", "2018-11-05*", "2019-03-26", "2019-03-26*", "2020-05-31"]);
    require_cloudfront();
    Object.defineProperty(apiLoader.services["cloudfront"], "2016-11-25", {
      get: function get() {
        var model = require_cloudfront_2016_11_25_min();
        model.paginators = require_cloudfront_2016_11_25_paginators().pagination;
        model.waiters = require_cloudfront_2016_11_25_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["cloudfront"], "2017-03-25", {
      get: function get() {
        var model = require_cloudfront_2017_03_25_min();
        model.paginators = require_cloudfront_2017_03_25_paginators().pagination;
        model.waiters = require_cloudfront_2017_03_25_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["cloudfront"], "2017-10-30", {
      get: function get() {
        var model = require_cloudfront_2017_10_30_min();
        model.paginators = require_cloudfront_2017_10_30_paginators().pagination;
        model.waiters = require_cloudfront_2017_10_30_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["cloudfront"], "2018-06-18", {
      get: function get() {
        var model = require_cloudfront_2018_06_18_min();
        model.paginators = require_cloudfront_2018_06_18_paginators().pagination;
        model.waiters = require_cloudfront_2018_06_18_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["cloudfront"], "2018-11-05", {
      get: function get() {
        var model = require_cloudfront_2018_11_05_min();
        model.paginators = require_cloudfront_2018_11_05_paginators().pagination;
        model.waiters = require_cloudfront_2018_11_05_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["cloudfront"], "2019-03-26", {
      get: function get() {
        var model = require_cloudfront_2019_03_26_min();
        model.paginators = require_cloudfront_2019_03_26_paginators().pagination;
        model.waiters = require_cloudfront_2019_03_26_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["cloudfront"], "2020-05-31", {
      get: function get() {
        var model = require_cloudfront_2020_05_31_min();
        model.paginators = require_cloudfront_2020_05_31_paginators().pagination;
        model.waiters = require_cloudfront_2020_05_31_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CloudFront;
  }
});

// node_modules/aws-sdk/apis/cloudhsm-2014-05-30.min.json
var require_cloudhsm_2014_05_30_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudhsm-2014-05-30.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-05-30",
        endpointPrefix: "cloudhsm",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "CloudHSM",
        serviceFullName: "Amazon CloudHSM",
        serviceId: "CloudHSM",
        signatureVersion: "v4",
        targetPrefix: "CloudHsmFrontendService",
        uid: "cloudhsm-2014-05-30"
      },
      operations: {
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagList"
            ],
            members: {
              ResourceArn: {},
              TagList: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Status: {}
            }
          }
        },
        CreateHapg: {
          input: {
            type: "structure",
            required: [
              "Label"
            ],
            members: {
              Label: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HapgArn: {}
            }
          }
        },
        CreateHsm: {
          input: {
            type: "structure",
            required: [
              "SubnetId",
              "SshKey",
              "IamRoleArn",
              "SubscriptionType"
            ],
            members: {
              SubnetId: {},
              SshKey: {},
              EniIp: {},
              IamRoleArn: {},
              ExternalId: {},
              SubscriptionType: {},
              ClientToken: {},
              SyslogIp: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HsmArn: {}
            }
          }
        },
        CreateLunaClient: {
          input: {
            type: "structure",
            required: [
              "Certificate"
            ],
            members: {
              Label: {},
              Certificate: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ClientArn: {}
            }
          }
        },
        DeleteHapg: {
          input: {
            type: "structure",
            required: [
              "HapgArn"
            ],
            members: {
              HapgArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Status: {}
            }
          }
        },
        DeleteHsm: {
          input: {
            type: "structure",
            required: [
              "HsmArn"
            ],
            members: {
              HsmArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Status: {}
            }
          }
        },
        DeleteLunaClient: {
          input: {
            type: "structure",
            required: [
              "ClientArn"
            ],
            members: {
              ClientArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Status: {}
            }
          }
        },
        DescribeHapg: {
          input: {
            type: "structure",
            required: [
              "HapgArn"
            ],
            members: {
              HapgArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HapgArn: {},
              HapgSerial: {},
              HsmsLastActionFailed: {
                shape: "Sz"
              },
              HsmsPendingDeletion: {
                shape: "Sz"
              },
              HsmsPendingRegistration: {
                shape: "Sz"
              },
              Label: {},
              LastModifiedTimestamp: {},
              PartitionSerialList: {
                shape: "S11"
              },
              State: {}
            }
          }
        },
        DescribeHsm: {
          input: {
            type: "structure",
            members: {
              HsmArn: {},
              HsmSerialNumber: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HsmArn: {},
              Status: {},
              StatusDetails: {},
              AvailabilityZone: {},
              EniId: {},
              EniIp: {},
              SubscriptionType: {},
              SubscriptionStartDate: {},
              SubscriptionEndDate: {},
              VpcId: {},
              SubnetId: {},
              IamRoleArn: {},
              SerialNumber: {},
              VendorName: {},
              HsmType: {},
              SoftwareVersion: {},
              SshPublicKey: {},
              SshKeyLastUpdated: {},
              ServerCertUri: {},
              ServerCertLastUpdated: {},
              Partitions: {
                type: "list",
                member: {}
              }
            }
          }
        },
        DescribeLunaClient: {
          input: {
            type: "structure",
            members: {
              ClientArn: {},
              CertificateFingerprint: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ClientArn: {},
              Certificate: {},
              CertificateFingerprint: {},
              LastModifiedTimestamp: {},
              Label: {}
            }
          }
        },
        GetConfig: {
          input: {
            type: "structure",
            required: [
              "ClientArn",
              "ClientVersion",
              "HapgList"
            ],
            members: {
              ClientArn: {},
              ClientVersion: {},
              HapgList: {
                shape: "S1i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigType: {},
              ConfigFile: {},
              ConfigCred: {}
            }
          }
        },
        ListAvailableZones: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              AZList: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListHapgs: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "HapgList"
            ],
            members: {
              HapgList: {
                shape: "S1i"
              },
              NextToken: {}
            }
          }
        },
        ListHsms: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HsmList: {
                shape: "Sz"
              },
              NextToken: {}
            }
          }
        },
        ListLunaClients: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ClientList"
            ],
            members: {
              ClientList: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TagList"
            ],
            members: {
              TagList: {
                shape: "S3"
              }
            }
          }
        },
        ModifyHapg: {
          input: {
            type: "structure",
            required: [
              "HapgArn"
            ],
            members: {
              HapgArn: {},
              Label: {},
              PartitionSerialList: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HapgArn: {}
            }
          }
        },
        ModifyHsm: {
          input: {
            type: "structure",
            required: [
              "HsmArn"
            ],
            members: {
              HsmArn: {},
              SubnetId: {},
              EniIp: {},
              IamRoleArn: {},
              ExternalId: {},
              SyslogIp: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HsmArn: {}
            }
          }
        },
        ModifyLunaClient: {
          input: {
            type: "structure",
            required: [
              "ClientArn",
              "Certificate"
            ],
            members: {
              ClientArn: {},
              Certificate: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ClientArn: {}
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeyList"
            ],
            members: {
              ResourceArn: {},
              TagKeyList: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Status: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sz: {
          type: "list",
          member: {}
        },
        S11: {
          type: "list",
          member: {}
        },
        S1i: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudhsm-2014-05-30.paginators.json
var require_cloudhsm_2014_05_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudhsm-2014-05-30.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/cloudhsm.js
var require_cloudhsm = __commonJS({
  "node_modules/aws-sdk/clients/cloudhsm.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["cloudhsm"] = {};
    AWS3.CloudHSM = Service.defineService("cloudhsm", ["2014-05-30"]);
    Object.defineProperty(apiLoader.services["cloudhsm"], "2014-05-30", {
      get: function get() {
        var model = require_cloudhsm_2014_05_30_min();
        model.paginators = require_cloudhsm_2014_05_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CloudHSM;
  }
});

// node_modules/aws-sdk/apis/cloudsearch-2011-02-01.min.json
var require_cloudsearch_2011_02_01_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudsearch-2011-02-01.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2011-02-01",
        endpointPrefix: "cloudsearch",
        serviceFullName: "Amazon CloudSearch",
        serviceId: "CloudSearch",
        signatureVersion: "v4",
        xmlNamespace: "http://cloudsearch.amazonaws.com/doc/2011-02-01/",
        protocol: "query"
      },
      operations: {
        CreateDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "CreateDomainResult",
            type: "structure",
            members: {
              DomainStatus: {
                shape: "S4"
              }
            }
          }
        },
        DefineIndexField: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "IndexField"
            ],
            members: {
              DomainName: {},
              IndexField: {
                shape: "Sf"
              }
            }
          },
          output: {
            resultWrapper: "DefineIndexFieldResult",
            type: "structure",
            required: [
              "IndexField"
            ],
            members: {
              IndexField: {
                shape: "Sx"
              }
            }
          }
        },
        DefineRankExpression: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "RankExpression"
            ],
            members: {
              DomainName: {},
              RankExpression: {
                shape: "S12"
              }
            }
          },
          output: {
            resultWrapper: "DefineRankExpressionResult",
            type: "structure",
            required: [
              "RankExpression"
            ],
            members: {
              RankExpression: {
                shape: "S15"
              }
            }
          }
        },
        DeleteDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "DeleteDomainResult",
            type: "structure",
            members: {
              DomainStatus: {
                shape: "S4"
              }
            }
          }
        },
        DeleteIndexField: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "IndexFieldName"
            ],
            members: {
              DomainName: {},
              IndexFieldName: {}
            }
          },
          output: {
            resultWrapper: "DeleteIndexFieldResult",
            type: "structure",
            required: [
              "IndexField"
            ],
            members: {
              IndexField: {
                shape: "Sx"
              }
            }
          }
        },
        DeleteRankExpression: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "RankName"
            ],
            members: {
              DomainName: {},
              RankName: {}
            }
          },
          output: {
            resultWrapper: "DeleteRankExpressionResult",
            type: "structure",
            required: [
              "RankExpression"
            ],
            members: {
              RankExpression: {
                shape: "S15"
              }
            }
          }
        },
        DescribeAvailabilityOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "DescribeAvailabilityOptionsResult",
            type: "structure",
            members: {
              AvailabilityOptions: {
                shape: "S1e"
              }
            }
          }
        },
        DescribeDefaultSearchField: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "DescribeDefaultSearchFieldResult",
            type: "structure",
            required: [
              "DefaultSearchField"
            ],
            members: {
              DefaultSearchField: {
                shape: "S1i"
              }
            }
          }
        },
        DescribeDomains: {
          input: {
            type: "structure",
            members: {
              DomainNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "DescribeDomainsResult",
            type: "structure",
            required: [
              "DomainStatusList"
            ],
            members: {
              DomainStatusList: {
                type: "list",
                member: {
                  shape: "S4"
                }
              }
            }
          }
        },
        DescribeIndexFields: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              FieldNames: {
                shape: "S1o"
              }
            }
          },
          output: {
            resultWrapper: "DescribeIndexFieldsResult",
            type: "structure",
            required: [
              "IndexFields"
            ],
            members: {
              IndexFields: {
                type: "list",
                member: {
                  shape: "Sx"
                }
              }
            }
          }
        },
        DescribeRankExpressions: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              RankNames: {
                shape: "S1o"
              }
            }
          },
          output: {
            resultWrapper: "DescribeRankExpressionsResult",
            type: "structure",
            required: [
              "RankExpressions"
            ],
            members: {
              RankExpressions: {
                type: "list",
                member: {
                  shape: "S15"
                }
              }
            }
          }
        },
        DescribeServiceAccessPolicies: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "DescribeServiceAccessPoliciesResult",
            type: "structure",
            required: [
              "AccessPolicies"
            ],
            members: {
              AccessPolicies: {
                shape: "S1w"
              }
            }
          }
        },
        DescribeStemmingOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "DescribeStemmingOptionsResult",
            type: "structure",
            required: [
              "Stems"
            ],
            members: {
              Stems: {
                shape: "S20"
              }
            }
          }
        },
        DescribeStopwordOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "DescribeStopwordOptionsResult",
            type: "structure",
            required: [
              "Stopwords"
            ],
            members: {
              Stopwords: {
                shape: "S24"
              }
            }
          }
        },
        DescribeSynonymOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "DescribeSynonymOptionsResult",
            type: "structure",
            required: [
              "Synonyms"
            ],
            members: {
              Synonyms: {
                shape: "S28"
              }
            }
          }
        },
        IndexDocuments: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "IndexDocumentsResult",
            type: "structure",
            members: {
              FieldNames: {
                shape: "S1o"
              }
            }
          }
        },
        UpdateAvailabilityOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "MultiAZ"
            ],
            members: {
              DomainName: {},
              MultiAZ: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "UpdateAvailabilityOptionsResult",
            type: "structure",
            members: {
              AvailabilityOptions: {
                shape: "S1e"
              }
            }
          }
        },
        UpdateDefaultSearchField: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "DefaultSearchField"
            ],
            members: {
              DomainName: {},
              DefaultSearchField: {}
            }
          },
          output: {
            resultWrapper: "UpdateDefaultSearchFieldResult",
            type: "structure",
            required: [
              "DefaultSearchField"
            ],
            members: {
              DefaultSearchField: {
                shape: "S1i"
              }
            }
          }
        },
        UpdateServiceAccessPolicies: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "AccessPolicies"
            ],
            members: {
              DomainName: {},
              AccessPolicies: {}
            }
          },
          output: {
            resultWrapper: "UpdateServiceAccessPoliciesResult",
            type: "structure",
            required: [
              "AccessPolicies"
            ],
            members: {
              AccessPolicies: {
                shape: "S1w"
              }
            }
          }
        },
        UpdateStemmingOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Stems"
            ],
            members: {
              DomainName: {},
              Stems: {}
            }
          },
          output: {
            resultWrapper: "UpdateStemmingOptionsResult",
            type: "structure",
            required: [
              "Stems"
            ],
            members: {
              Stems: {
                shape: "S20"
              }
            }
          }
        },
        UpdateStopwordOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Stopwords"
            ],
            members: {
              DomainName: {},
              Stopwords: {}
            }
          },
          output: {
            resultWrapper: "UpdateStopwordOptionsResult",
            type: "structure",
            required: [
              "Stopwords"
            ],
            members: {
              Stopwords: {
                shape: "S24"
              }
            }
          }
        },
        UpdateSynonymOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Synonyms"
            ],
            members: {
              DomainName: {},
              Synonyms: {}
            }
          },
          output: {
            resultWrapper: "UpdateSynonymOptionsResult",
            type: "structure",
            required: [
              "Synonyms"
            ],
            members: {
              Synonyms: {
                shape: "S28"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "DomainId",
            "DomainName",
            "RequiresIndexDocuments"
          ],
          members: {
            DomainId: {},
            DomainName: {},
            Created: {
              type: "boolean"
            },
            Deleted: {
              type: "boolean"
            },
            NumSearchableDocs: {
              type: "long"
            },
            DocService: {
              shape: "S8"
            },
            SearchService: {
              shape: "S8"
            },
            RequiresIndexDocuments: {
              type: "boolean"
            },
            Processing: {
              type: "boolean"
            },
            SearchInstanceType: {},
            SearchPartitionCount: {
              type: "integer"
            },
            SearchInstanceCount: {
              type: "integer"
            }
          }
        },
        S8: {
          type: "structure",
          members: {
            Arn: {},
            Endpoint: {}
          }
        },
        Sf: {
          type: "structure",
          required: [
            "IndexFieldName",
            "IndexFieldType"
          ],
          members: {
            IndexFieldName: {},
            IndexFieldType: {},
            UIntOptions: {
              type: "structure",
              members: {
                DefaultValue: {
                  type: "integer"
                }
              }
            },
            LiteralOptions: {
              type: "structure",
              members: {
                DefaultValue: {},
                SearchEnabled: {
                  type: "boolean"
                },
                FacetEnabled: {
                  type: "boolean"
                },
                ResultEnabled: {
                  type: "boolean"
                }
              }
            },
            TextOptions: {
              type: "structure",
              members: {
                DefaultValue: {},
                FacetEnabled: {
                  type: "boolean"
                },
                ResultEnabled: {
                  type: "boolean"
                },
                TextProcessor: {}
              }
            },
            SourceAttributes: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "SourceDataFunction"
                ],
                members: {
                  SourceDataFunction: {},
                  SourceDataCopy: {
                    type: "structure",
                    required: [
                      "SourceName"
                    ],
                    members: {
                      SourceName: {},
                      DefaultValue: {}
                    }
                  },
                  SourceDataTrimTitle: {
                    type: "structure",
                    required: [
                      "SourceName"
                    ],
                    members: {
                      SourceName: {},
                      DefaultValue: {},
                      Separator: {},
                      Language: {}
                    }
                  },
                  SourceDataMap: {
                    type: "structure",
                    required: [
                      "SourceName"
                    ],
                    members: {
                      SourceName: {},
                      DefaultValue: {},
                      Cases: {
                        type: "map",
                        key: {},
                        value: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sx: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {
              shape: "Sf"
            },
            Status: {
              shape: "Sy"
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "CreationDate",
            "UpdateDate",
            "State"
          ],
          members: {
            CreationDate: {
              type: "timestamp"
            },
            UpdateDate: {
              type: "timestamp"
            },
            UpdateVersion: {
              type: "integer"
            },
            State: {},
            PendingDeletion: {
              type: "boolean"
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "RankName",
            "RankExpression"
          ],
          members: {
            RankName: {},
            RankExpression: {}
          }
        },
        S15: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {
              shape: "S12"
            },
            Status: {
              shape: "Sy"
            }
          }
        },
        S1e: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {
              type: "boolean"
            },
            Status: {
              shape: "Sy"
            }
          }
        },
        S1i: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {},
            Status: {
              shape: "Sy"
            }
          }
        },
        S1o: {
          type: "list",
          member: {}
        },
        S1w: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {},
            Status: {
              shape: "Sy"
            }
          }
        },
        S20: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {},
            Status: {
              shape: "Sy"
            }
          }
        },
        S24: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {},
            Status: {
              shape: "Sy"
            }
          }
        },
        S28: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {},
            Status: {
              shape: "Sy"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudsearch-2011-02-01.paginators.json
var require_cloudsearch_2011_02_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudsearch-2011-02-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeDomains: {
          result_key: "DomainStatusList"
        },
        DescribeIndexFields: {
          result_key: "IndexFields"
        },
        DescribeRankExpressions: {
          result_key: "RankExpressions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudsearch-2013-01-01.min.json
var require_cloudsearch_2013_01_01_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudsearch-2013-01-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-01-01",
        endpointPrefix: "cloudsearch",
        protocol: "query",
        serviceFullName: "Amazon CloudSearch",
        serviceId: "CloudSearch",
        signatureVersion: "v4",
        uid: "cloudsearch-2013-01-01",
        xmlNamespace: "http://cloudsearch.amazonaws.com/doc/2013-01-01/"
      },
      operations: {
        BuildSuggesters: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "BuildSuggestersResult",
            type: "structure",
            members: {
              FieldNames: {
                shape: "S4"
              }
            }
          }
        },
        CreateDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "CreateDomainResult",
            type: "structure",
            members: {
              DomainStatus: {
                shape: "S8"
              }
            }
          }
        },
        DefineAnalysisScheme: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "AnalysisScheme"
            ],
            members: {
              DomainName: {},
              AnalysisScheme: {
                shape: "Sl"
              }
            }
          },
          output: {
            resultWrapper: "DefineAnalysisSchemeResult",
            type: "structure",
            required: [
              "AnalysisScheme"
            ],
            members: {
              AnalysisScheme: {
                shape: "Ss"
              }
            }
          }
        },
        DefineExpression: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Expression"
            ],
            members: {
              DomainName: {},
              Expression: {
                shape: "Sy"
              }
            }
          },
          output: {
            resultWrapper: "DefineExpressionResult",
            type: "structure",
            required: [
              "Expression"
            ],
            members: {
              Expression: {
                shape: "S11"
              }
            }
          }
        },
        DefineIndexField: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "IndexField"
            ],
            members: {
              DomainName: {},
              IndexField: {
                shape: "S13"
              }
            }
          },
          output: {
            resultWrapper: "DefineIndexFieldResult",
            type: "structure",
            required: [
              "IndexField"
            ],
            members: {
              IndexField: {
                shape: "S1n"
              }
            }
          }
        },
        DefineSuggester: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Suggester"
            ],
            members: {
              DomainName: {},
              Suggester: {
                shape: "S1p"
              }
            }
          },
          output: {
            resultWrapper: "DefineSuggesterResult",
            type: "structure",
            required: [
              "Suggester"
            ],
            members: {
              Suggester: {
                shape: "S1t"
              }
            }
          }
        },
        DeleteAnalysisScheme: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "AnalysisSchemeName"
            ],
            members: {
              DomainName: {},
              AnalysisSchemeName: {}
            }
          },
          output: {
            resultWrapper: "DeleteAnalysisSchemeResult",
            type: "structure",
            required: [
              "AnalysisScheme"
            ],
            members: {
              AnalysisScheme: {
                shape: "Ss"
              }
            }
          }
        },
        DeleteDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "DeleteDomainResult",
            type: "structure",
            members: {
              DomainStatus: {
                shape: "S8"
              }
            }
          }
        },
        DeleteExpression: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ExpressionName"
            ],
            members: {
              DomainName: {},
              ExpressionName: {}
            }
          },
          output: {
            resultWrapper: "DeleteExpressionResult",
            type: "structure",
            required: [
              "Expression"
            ],
            members: {
              Expression: {
                shape: "S11"
              }
            }
          }
        },
        DeleteIndexField: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "IndexFieldName"
            ],
            members: {
              DomainName: {},
              IndexFieldName: {}
            }
          },
          output: {
            resultWrapper: "DeleteIndexFieldResult",
            type: "structure",
            required: [
              "IndexField"
            ],
            members: {
              IndexField: {
                shape: "S1n"
              }
            }
          }
        },
        DeleteSuggester: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "SuggesterName"
            ],
            members: {
              DomainName: {},
              SuggesterName: {}
            }
          },
          output: {
            resultWrapper: "DeleteSuggesterResult",
            type: "structure",
            required: [
              "Suggester"
            ],
            members: {
              Suggester: {
                shape: "S1t"
              }
            }
          }
        },
        DescribeAnalysisSchemes: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              AnalysisSchemeNames: {
                shape: "S25"
              },
              Deployed: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeAnalysisSchemesResult",
            type: "structure",
            required: [
              "AnalysisSchemes"
            ],
            members: {
              AnalysisSchemes: {
                type: "list",
                member: {
                  shape: "Ss"
                }
              }
            }
          }
        },
        DescribeAvailabilityOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              Deployed: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeAvailabilityOptionsResult",
            type: "structure",
            members: {
              AvailabilityOptions: {
                shape: "S2a"
              }
            }
          }
        },
        DescribeDomainEndpointOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              Deployed: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDomainEndpointOptionsResult",
            type: "structure",
            members: {
              DomainEndpointOptions: {
                shape: "S2e"
              }
            }
          }
        },
        DescribeDomains: {
          input: {
            type: "structure",
            members: {
              DomainNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "DescribeDomainsResult",
            type: "structure",
            required: [
              "DomainStatusList"
            ],
            members: {
              DomainStatusList: {
                type: "list",
                member: {
                  shape: "S8"
                }
              }
            }
          }
        },
        DescribeExpressions: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              ExpressionNames: {
                shape: "S25"
              },
              Deployed: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeExpressionsResult",
            type: "structure",
            required: [
              "Expressions"
            ],
            members: {
              Expressions: {
                type: "list",
                member: {
                  shape: "S11"
                }
              }
            }
          }
        },
        DescribeIndexFields: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              FieldNames: {
                type: "list",
                member: {}
              },
              Deployed: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeIndexFieldsResult",
            type: "structure",
            required: [
              "IndexFields"
            ],
            members: {
              IndexFields: {
                type: "list",
                member: {
                  shape: "S1n"
                }
              }
            }
          }
        },
        DescribeScalingParameters: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "DescribeScalingParametersResult",
            type: "structure",
            required: [
              "ScalingParameters"
            ],
            members: {
              ScalingParameters: {
                shape: "S2u"
              }
            }
          }
        },
        DescribeServiceAccessPolicies: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              Deployed: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeServiceAccessPoliciesResult",
            type: "structure",
            required: [
              "AccessPolicies"
            ],
            members: {
              AccessPolicies: {
                shape: "S2z"
              }
            }
          }
        },
        DescribeSuggesters: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              SuggesterNames: {
                shape: "S25"
              },
              Deployed: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeSuggestersResult",
            type: "structure",
            required: [
              "Suggesters"
            ],
            members: {
              Suggesters: {
                type: "list",
                member: {
                  shape: "S1t"
                }
              }
            }
          }
        },
        IndexDocuments: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "IndexDocumentsResult",
            type: "structure",
            members: {
              FieldNames: {
                shape: "S4"
              }
            }
          }
        },
        ListDomainNames: {
          output: {
            resultWrapper: "ListDomainNamesResult",
            type: "structure",
            members: {
              DomainNames: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        UpdateAvailabilityOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "MultiAZ"
            ],
            members: {
              DomainName: {},
              MultiAZ: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "UpdateAvailabilityOptionsResult",
            type: "structure",
            members: {
              AvailabilityOptions: {
                shape: "S2a"
              }
            }
          }
        },
        UpdateDomainEndpointOptions: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "DomainEndpointOptions"
            ],
            members: {
              DomainName: {},
              DomainEndpointOptions: {
                shape: "S2f"
              }
            }
          },
          output: {
            resultWrapper: "UpdateDomainEndpointOptionsResult",
            type: "structure",
            members: {
              DomainEndpointOptions: {
                shape: "S2e"
              }
            }
          }
        },
        UpdateScalingParameters: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ScalingParameters"
            ],
            members: {
              DomainName: {},
              ScalingParameters: {
                shape: "S2v"
              }
            }
          },
          output: {
            resultWrapper: "UpdateScalingParametersResult",
            type: "structure",
            required: [
              "ScalingParameters"
            ],
            members: {
              ScalingParameters: {
                shape: "S2u"
              }
            }
          }
        },
        UpdateServiceAccessPolicies: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "AccessPolicies"
            ],
            members: {
              DomainName: {},
              AccessPolicies: {}
            }
          },
          output: {
            resultWrapper: "UpdateServiceAccessPoliciesResult",
            type: "structure",
            required: [
              "AccessPolicies"
            ],
            members: {
              AccessPolicies: {
                shape: "S2z"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {}
        },
        S8: {
          type: "structure",
          required: [
            "DomainId",
            "DomainName",
            "RequiresIndexDocuments"
          ],
          members: {
            DomainId: {},
            DomainName: {},
            ARN: {},
            Created: {
              type: "boolean"
            },
            Deleted: {
              type: "boolean"
            },
            DocService: {
              shape: "Sc"
            },
            SearchService: {
              shape: "Sc"
            },
            RequiresIndexDocuments: {
              type: "boolean"
            },
            Processing: {
              type: "boolean"
            },
            SearchInstanceType: {},
            SearchPartitionCount: {
              type: "integer"
            },
            SearchInstanceCount: {
              type: "integer"
            },
            Limits: {
              type: "structure",
              required: [
                "MaximumReplicationCount",
                "MaximumPartitionCount"
              ],
              members: {
                MaximumReplicationCount: {
                  type: "integer"
                },
                MaximumPartitionCount: {
                  type: "integer"
                }
              }
            }
          }
        },
        Sc: {
          type: "structure",
          members: {
            Endpoint: {}
          }
        },
        Sl: {
          type: "structure",
          required: [
            "AnalysisSchemeName",
            "AnalysisSchemeLanguage"
          ],
          members: {
            AnalysisSchemeName: {},
            AnalysisSchemeLanguage: {},
            AnalysisOptions: {
              type: "structure",
              members: {
                Synonyms: {},
                Stopwords: {},
                StemmingDictionary: {},
                JapaneseTokenizationDictionary: {},
                AlgorithmicStemming: {}
              }
            }
          }
        },
        Ss: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {
              shape: "Sl"
            },
            Status: {
              shape: "St"
            }
          }
        },
        St: {
          type: "structure",
          required: [
            "CreationDate",
            "UpdateDate",
            "State"
          ],
          members: {
            CreationDate: {
              type: "timestamp"
            },
            UpdateDate: {
              type: "timestamp"
            },
            UpdateVersion: {
              type: "integer"
            },
            State: {},
            PendingDeletion: {
              type: "boolean"
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "ExpressionName",
            "ExpressionValue"
          ],
          members: {
            ExpressionName: {},
            ExpressionValue: {}
          }
        },
        S11: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {
              shape: "Sy"
            },
            Status: {
              shape: "St"
            }
          }
        },
        S13: {
          type: "structure",
          required: [
            "IndexFieldName",
            "IndexFieldType"
          ],
          members: {
            IndexFieldName: {},
            IndexFieldType: {},
            IntOptions: {
              type: "structure",
              members: {
                DefaultValue: {
                  type: "long"
                },
                SourceField: {},
                FacetEnabled: {
                  type: "boolean"
                },
                SearchEnabled: {
                  type: "boolean"
                },
                ReturnEnabled: {
                  type: "boolean"
                },
                SortEnabled: {
                  type: "boolean"
                }
              }
            },
            DoubleOptions: {
              type: "structure",
              members: {
                DefaultValue: {
                  type: "double"
                },
                SourceField: {},
                FacetEnabled: {
                  type: "boolean"
                },
                SearchEnabled: {
                  type: "boolean"
                },
                ReturnEnabled: {
                  type: "boolean"
                },
                SortEnabled: {
                  type: "boolean"
                }
              }
            },
            LiteralOptions: {
              type: "structure",
              members: {
                DefaultValue: {},
                SourceField: {},
                FacetEnabled: {
                  type: "boolean"
                },
                SearchEnabled: {
                  type: "boolean"
                },
                ReturnEnabled: {
                  type: "boolean"
                },
                SortEnabled: {
                  type: "boolean"
                }
              }
            },
            TextOptions: {
              type: "structure",
              members: {
                DefaultValue: {},
                SourceField: {},
                ReturnEnabled: {
                  type: "boolean"
                },
                SortEnabled: {
                  type: "boolean"
                },
                HighlightEnabled: {
                  type: "boolean"
                },
                AnalysisScheme: {}
              }
            },
            DateOptions: {
              type: "structure",
              members: {
                DefaultValue: {},
                SourceField: {},
                FacetEnabled: {
                  type: "boolean"
                },
                SearchEnabled: {
                  type: "boolean"
                },
                ReturnEnabled: {
                  type: "boolean"
                },
                SortEnabled: {
                  type: "boolean"
                }
              }
            },
            LatLonOptions: {
              type: "structure",
              members: {
                DefaultValue: {},
                SourceField: {},
                FacetEnabled: {
                  type: "boolean"
                },
                SearchEnabled: {
                  type: "boolean"
                },
                ReturnEnabled: {
                  type: "boolean"
                },
                SortEnabled: {
                  type: "boolean"
                }
              }
            },
            IntArrayOptions: {
              type: "structure",
              members: {
                DefaultValue: {
                  type: "long"
                },
                SourceFields: {},
                FacetEnabled: {
                  type: "boolean"
                },
                SearchEnabled: {
                  type: "boolean"
                },
                ReturnEnabled: {
                  type: "boolean"
                }
              }
            },
            DoubleArrayOptions: {
              type: "structure",
              members: {
                DefaultValue: {
                  type: "double"
                },
                SourceFields: {},
                FacetEnabled: {
                  type: "boolean"
                },
                SearchEnabled: {
                  type: "boolean"
                },
                ReturnEnabled: {
                  type: "boolean"
                }
              }
            },
            LiteralArrayOptions: {
              type: "structure",
              members: {
                DefaultValue: {},
                SourceFields: {},
                FacetEnabled: {
                  type: "boolean"
                },
                SearchEnabled: {
                  type: "boolean"
                },
                ReturnEnabled: {
                  type: "boolean"
                }
              }
            },
            TextArrayOptions: {
              type: "structure",
              members: {
                DefaultValue: {},
                SourceFields: {},
                ReturnEnabled: {
                  type: "boolean"
                },
                HighlightEnabled: {
                  type: "boolean"
                },
                AnalysisScheme: {}
              }
            },
            DateArrayOptions: {
              type: "structure",
              members: {
                DefaultValue: {},
                SourceFields: {},
                FacetEnabled: {
                  type: "boolean"
                },
                SearchEnabled: {
                  type: "boolean"
                },
                ReturnEnabled: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {
              shape: "S13"
            },
            Status: {
              shape: "St"
            }
          }
        },
        S1p: {
          type: "structure",
          required: [
            "SuggesterName",
            "DocumentSuggesterOptions"
          ],
          members: {
            SuggesterName: {},
            DocumentSuggesterOptions: {
              type: "structure",
              required: [
                "SourceField"
              ],
              members: {
                SourceField: {},
                FuzzyMatching: {},
                SortExpression: {}
              }
            }
          }
        },
        S1t: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {
              shape: "S1p"
            },
            Status: {
              shape: "St"
            }
          }
        },
        S25: {
          type: "list",
          member: {}
        },
        S2a: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {
              type: "boolean"
            },
            Status: {
              shape: "St"
            }
          }
        },
        S2e: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {
              shape: "S2f"
            },
            Status: {
              shape: "St"
            }
          }
        },
        S2f: {
          type: "structure",
          members: {
            EnforceHTTPS: {
              type: "boolean"
            },
            TLSSecurityPolicy: {}
          }
        },
        S2u: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {
              shape: "S2v"
            },
            Status: {
              shape: "St"
            }
          }
        },
        S2v: {
          type: "structure",
          members: {
            DesiredInstanceType: {},
            DesiredReplicationCount: {
              type: "integer"
            },
            DesiredPartitionCount: {
              type: "integer"
            }
          }
        },
        S2z: {
          type: "structure",
          required: [
            "Options",
            "Status"
          ],
          members: {
            Options: {},
            Status: {
              shape: "St"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudsearch-2013-01-01.paginators.json
var require_cloudsearch_2013_01_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudsearch-2013-01-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeAnalysisSchemes: {
          result_key: "AnalysisSchemes"
        },
        DescribeDomains: {
          result_key: "DomainStatusList"
        },
        DescribeExpressions: {
          result_key: "Expressions"
        },
        DescribeIndexFields: {
          result_key: "IndexFields"
        },
        DescribeSuggesters: {
          result_key: "Suggesters"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cloudsearch.js
var require_cloudsearch = __commonJS({
  "node_modules/aws-sdk/clients/cloudsearch.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["cloudsearch"] = {};
    AWS3.CloudSearch = Service.defineService("cloudsearch", ["2011-02-01", "2013-01-01"]);
    Object.defineProperty(apiLoader.services["cloudsearch"], "2011-02-01", {
      get: function get() {
        var model = require_cloudsearch_2011_02_01_min();
        model.paginators = require_cloudsearch_2011_02_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["cloudsearch"], "2013-01-01", {
      get: function get() {
        var model = require_cloudsearch_2013_01_01_min();
        model.paginators = require_cloudsearch_2013_01_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CloudSearch;
  }
});

// node_modules/aws-sdk/lib/services/cloudsearchdomain.js
var require_cloudsearchdomain = __commonJS({
  "node_modules/aws-sdk/lib/services/cloudsearchdomain.js"() {
    var AWS3 = require_core();
    AWS3.util.update(AWS3.CloudSearchDomain.prototype, {
      validateService: function validateService() {
        if (!this.config.endpoint || this.config.endpoint.indexOf("{") >= 0) {
          var msg = "AWS.CloudSearchDomain requires an explicit `endpoint' configuration option.";
          throw AWS3.util.error(new Error(), { name: "InvalidEndpoint", message: msg });
        }
      },
      setupRequestListeners: function setupRequestListeners(request) {
        request.removeListener("validate", AWS3.EventListeners.Core.VALIDATE_CREDENTIALS);
        request.onAsync("validate", this.validateCredentials);
        request.addListener("validate", this.updateRegion);
        if (request.operation === "search") {
          request.addListener("build", this.convertGetToPost);
        }
      },
      validateCredentials: function(req, done) {
        if (!req.service.api.signatureVersion)
          return done();
        req.service.config.getCredentials(function(err) {
          if (err) {
            req.removeListener("sign", AWS3.EventListeners.Core.SIGN);
          }
          done();
        });
      },
      convertGetToPost: function(request) {
        var httpRequest = request.httpRequest;
        var path2 = httpRequest.path.split("?");
        httpRequest.method = "POST";
        httpRequest.path = path2[0];
        httpRequest.body = path2[1];
        httpRequest.headers["Content-Length"] = httpRequest.body.length;
        httpRequest.headers["Content-Type"] = "application/x-www-form-urlencoded";
      },
      updateRegion: function updateRegion(request) {
        var endpoint = request.httpRequest.endpoint.hostname;
        var zones = endpoint.split(".");
        request.httpRequest.region = zones[1] || request.httpRequest.region;
      }
    });
  }
});

// node_modules/aws-sdk/apis/cloudsearchdomain-2013-01-01.min.json
var require_cloudsearchdomain_2013_01_01_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudsearchdomain-2013-01-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-01-01",
        endpointPrefix: "cloudsearchdomain",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon CloudSearch Domain",
        serviceId: "CloudSearch Domain",
        signatureVersion: "v4",
        signingName: "cloudsearch",
        uid: "cloudsearchdomain-2013-01-01"
      },
      operations: {
        Search: {
          http: {
            method: "GET",
            requestUri: "/2013-01-01/search?format=sdk&pretty=true"
          },
          input: {
            type: "structure",
            required: [
              "query"
            ],
            members: {
              cursor: {
                location: "querystring",
                locationName: "cursor"
              },
              expr: {
                location: "querystring",
                locationName: "expr"
              },
              facet: {
                location: "querystring",
                locationName: "facet"
              },
              filterQuery: {
                location: "querystring",
                locationName: "fq"
              },
              highlight: {
                location: "querystring",
                locationName: "highlight"
              },
              partial: {
                location: "querystring",
                locationName: "partial",
                type: "boolean"
              },
              query: {
                location: "querystring",
                locationName: "q"
              },
              queryOptions: {
                location: "querystring",
                locationName: "q.options"
              },
              queryParser: {
                location: "querystring",
                locationName: "q.parser"
              },
              return: {
                location: "querystring",
                locationName: "return"
              },
              size: {
                location: "querystring",
                locationName: "size",
                type: "long"
              },
              sort: {
                location: "querystring",
                locationName: "sort"
              },
              start: {
                location: "querystring",
                locationName: "start",
                type: "long"
              },
              stats: {
                location: "querystring",
                locationName: "stats"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {
                type: "structure",
                members: {
                  timems: {
                    type: "long"
                  },
                  rid: {}
                }
              },
              hits: {
                type: "structure",
                members: {
                  found: {
                    type: "long"
                  },
                  start: {
                    type: "long"
                  },
                  cursor: {},
                  hit: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        id: {},
                        fields: {
                          type: "map",
                          key: {},
                          value: {
                            type: "list",
                            member: {}
                          }
                        },
                        exprs: {
                          type: "map",
                          key: {},
                          value: {}
                        },
                        highlights: {
                          type: "map",
                          key: {},
                          value: {}
                        }
                      }
                    }
                  }
                }
              },
              facets: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    buckets: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          value: {},
                          count: {
                            type: "long"
                          }
                        }
                      }
                    }
                  }
                }
              },
              stats: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    min: {},
                    max: {},
                    count: {
                      type: "long"
                    },
                    missing: {
                      type: "long"
                    },
                    sum: {
                      type: "double"
                    },
                    sumOfSquares: {
                      type: "double"
                    },
                    mean: {},
                    stddev: {
                      type: "double"
                    }
                  }
                }
              }
            }
          }
        },
        Suggest: {
          http: {
            method: "GET",
            requestUri: "/2013-01-01/suggest?format=sdk&pretty=true"
          },
          input: {
            type: "structure",
            required: [
              "query",
              "suggester"
            ],
            members: {
              query: {
                location: "querystring",
                locationName: "q"
              },
              suggester: {
                location: "querystring",
                locationName: "suggester"
              },
              size: {
                location: "querystring",
                locationName: "size",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {
                type: "structure",
                members: {
                  timems: {
                    type: "long"
                  },
                  rid: {}
                }
              },
              suggest: {
                type: "structure",
                members: {
                  query: {},
                  found: {
                    type: "long"
                  },
                  suggestions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        suggestion: {},
                        score: {
                          type: "long"
                        },
                        id: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        UploadDocuments: {
          http: {
            requestUri: "/2013-01-01/documents/batch?format=sdk"
          },
          input: {
            type: "structure",
            required: [
              "documents",
              "contentType"
            ],
            members: {
              documents: {
                type: "blob",
                streaming: true
              },
              contentType: {
                location: "header",
                locationName: "Content-Type"
              }
            },
            payload: "documents"
          },
          output: {
            type: "structure",
            members: {
              status: {},
              adds: {
                type: "long"
              },
              deletes: {
                type: "long"
              },
              warnings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    message: {}
                  }
                }
              }
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/clients/cloudsearchdomain.js
var require_cloudsearchdomain2 = __commonJS({
  "node_modules/aws-sdk/clients/cloudsearchdomain.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["cloudsearchdomain"] = {};
    AWS3.CloudSearchDomain = Service.defineService("cloudsearchdomain", ["2013-01-01"]);
    require_cloudsearchdomain();
    Object.defineProperty(apiLoader.services["cloudsearchdomain"], "2013-01-01", {
      get: function get() {
        var model = require_cloudsearchdomain_2013_01_01_min();
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CloudSearchDomain;
  }
});

// node_modules/aws-sdk/apis/cloudtrail-2013-11-01.min.json
var require_cloudtrail_2013_11_01_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudtrail-2013-11-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-11-01",
        endpointPrefix: "cloudtrail",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "CloudTrail",
        serviceFullName: "AWS CloudTrail",
        serviceId: "CloudTrail",
        signatureVersion: "v4",
        targetPrefix: "com.amazonaws.cloudtrail.v20131101.CloudTrail_20131101",
        uid: "cloudtrail-2013-11-01"
      },
      operations: {
        AddTags: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {},
              TagsList: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        CreateTrail: {
          input: {
            type: "structure",
            required: [
              "Name",
              "S3BucketName"
            ],
            members: {
              Name: {},
              S3BucketName: {},
              S3KeyPrefix: {},
              SnsTopicName: {},
              IncludeGlobalServiceEvents: {
                type: "boolean"
              },
              IsMultiRegionTrail: {
                type: "boolean"
              },
              EnableLogFileValidation: {
                type: "boolean"
              },
              CloudWatchLogsLogGroupArn: {},
              CloudWatchLogsRoleArn: {},
              KmsKeyId: {},
              IsOrganizationTrail: {
                type: "boolean"
              },
              TagsList: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              S3BucketName: {},
              S3KeyPrefix: {},
              SnsTopicName: {
                deprecated: true
              },
              SnsTopicARN: {},
              IncludeGlobalServiceEvents: {
                type: "boolean"
              },
              IsMultiRegionTrail: {
                type: "boolean"
              },
              TrailARN: {},
              LogFileValidationEnabled: {
                type: "boolean"
              },
              CloudWatchLogsLogGroupArn: {},
              CloudWatchLogsRoleArn: {},
              KmsKeyId: {},
              IsOrganizationTrail: {
                type: "boolean"
              }
            }
          },
          idempotent: true
        },
        DeleteTrail: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DescribeTrails: {
          input: {
            type: "structure",
            members: {
              trailNameList: {
                type: "list",
                member: {}
              },
              includeShadowTrails: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              trailList: {
                type: "list",
                member: {
                  shape: "Sf"
                }
              }
            }
          },
          idempotent: true
        },
        GetEventSelectors: {
          input: {
            type: "structure",
            required: [
              "TrailName"
            ],
            members: {
              TrailName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrailARN: {},
              EventSelectors: {
                shape: "Si"
              },
              AdvancedEventSelectors: {
                shape: "Sp"
              }
            }
          },
          idempotent: true
        },
        GetInsightSelectors: {
          input: {
            type: "structure",
            required: [
              "TrailName"
            ],
            members: {
              TrailName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrailARN: {},
              InsightSelectors: {
                shape: "Sz"
              }
            }
          },
          idempotent: true
        },
        GetTrail: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Trail: {
                shape: "Sf"
              }
            }
          },
          idempotent: true
        },
        GetTrailStatus: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IsLogging: {
                type: "boolean"
              },
              LatestDeliveryError: {},
              LatestNotificationError: {},
              LatestDeliveryTime: {
                type: "timestamp"
              },
              LatestNotificationTime: {
                type: "timestamp"
              },
              StartLoggingTime: {
                type: "timestamp"
              },
              StopLoggingTime: {
                type: "timestamp"
              },
              LatestCloudWatchLogsDeliveryError: {},
              LatestCloudWatchLogsDeliveryTime: {
                type: "timestamp"
              },
              LatestDigestDeliveryTime: {
                type: "timestamp"
              },
              LatestDigestDeliveryError: {},
              LatestDeliveryAttemptTime: {},
              LatestNotificationAttemptTime: {},
              LatestNotificationAttemptSucceeded: {},
              LatestDeliveryAttemptSucceeded: {},
              TimeLoggingStarted: {},
              TimeLoggingStopped: {}
            }
          },
          idempotent: true
        },
        ListPublicKeys: {
          input: {
            type: "structure",
            members: {
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Value: {
                      type: "blob"
                    },
                    ValidityStartTime: {
                      type: "timestamp"
                    },
                    ValidityEndTime: {
                      type: "timestamp"
                    },
                    Fingerprint: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListTags: {
          input: {
            type: "structure",
            required: [
              "ResourceIdList"
            ],
            members: {
              ResourceIdList: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceTagList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceId: {},
                    TagsList: {
                      shape: "S3"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListTrails: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Trails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TrailARN: {},
                    Name: {},
                    HomeRegion: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        LookupEvents: {
          input: {
            type: "structure",
            members: {
              LookupAttributes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AttributeKey",
                    "AttributeValue"
                  ],
                  members: {
                    AttributeKey: {},
                    AttributeValue: {}
                  }
                }
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              EventCategory: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventId: {},
                    EventName: {},
                    ReadOnly: {},
                    AccessKeyId: {},
                    EventTime: {
                      type: "timestamp"
                    },
                    EventSource: {},
                    Username: {},
                    Resources: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ResourceType: {},
                          ResourceName: {}
                        }
                      }
                    },
                    CloudTrailEvent: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        PutEventSelectors: {
          input: {
            type: "structure",
            required: [
              "TrailName"
            ],
            members: {
              TrailName: {},
              EventSelectors: {
                shape: "Si"
              },
              AdvancedEventSelectors: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrailARN: {},
              EventSelectors: {
                shape: "Si"
              },
              AdvancedEventSelectors: {
                shape: "Sp"
              }
            }
          },
          idempotent: true
        },
        PutInsightSelectors: {
          input: {
            type: "structure",
            required: [
              "TrailName",
              "InsightSelectors"
            ],
            members: {
              TrailName: {},
              InsightSelectors: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrailARN: {},
              InsightSelectors: {
                shape: "Sz"
              }
            }
          },
          idempotent: true
        },
        RemoveTags: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {},
              TagsList: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        StartLogging: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        StopLogging: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateTrail: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              S3BucketName: {},
              S3KeyPrefix: {},
              SnsTopicName: {},
              IncludeGlobalServiceEvents: {
                type: "boolean"
              },
              IsMultiRegionTrail: {
                type: "boolean"
              },
              EnableLogFileValidation: {
                type: "boolean"
              },
              CloudWatchLogsLogGroupArn: {},
              CloudWatchLogsRoleArn: {},
              KmsKeyId: {},
              IsOrganizationTrail: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              S3BucketName: {},
              S3KeyPrefix: {},
              SnsTopicName: {
                deprecated: true
              },
              SnsTopicARN: {},
              IncludeGlobalServiceEvents: {
                type: "boolean"
              },
              IsMultiRegionTrail: {
                type: "boolean"
              },
              TrailARN: {},
              LogFileValidationEnabled: {
                type: "boolean"
              },
              CloudWatchLogsLogGroupArn: {},
              CloudWatchLogsRoleArn: {},
              KmsKeyId: {},
              IsOrganizationTrail: {
                type: "boolean"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sf: {
          type: "structure",
          members: {
            Name: {},
            S3BucketName: {},
            S3KeyPrefix: {},
            SnsTopicName: {
              deprecated: true
            },
            SnsTopicARN: {},
            IncludeGlobalServiceEvents: {
              type: "boolean"
            },
            IsMultiRegionTrail: {
              type: "boolean"
            },
            HomeRegion: {},
            TrailARN: {},
            LogFileValidationEnabled: {
              type: "boolean"
            },
            CloudWatchLogsLogGroupArn: {},
            CloudWatchLogsRoleArn: {},
            KmsKeyId: {},
            HasCustomEventSelectors: {
              type: "boolean"
            },
            HasInsightSelectors: {
              type: "boolean"
            },
            IsOrganizationTrail: {
              type: "boolean"
            }
          }
        },
        Si: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ReadWriteType: {},
              IncludeManagementEvents: {
                type: "boolean"
              },
              DataResources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              ExcludeManagementEventSources: {
                type: "list",
                member: {}
              }
            }
          }
        },
        Sp: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "FieldSelectors"
            ],
            members: {
              Name: {},
              FieldSelectors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Field"
                  ],
                  members: {
                    Field: {},
                    Equals: {
                      shape: "Sv"
                    },
                    StartsWith: {
                      shape: "Sv"
                    },
                    EndsWith: {
                      shape: "Sv"
                    },
                    NotEquals: {
                      shape: "Sv"
                    },
                    NotStartsWith: {
                      shape: "Sv"
                    },
                    NotEndsWith: {
                      shape: "Sv"
                    }
                  }
                }
              }
            }
          }
        },
        Sv: {
          type: "list",
          member: {}
        },
        Sz: {
          type: "list",
          member: {
            type: "structure",
            members: {
              InsightType: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudtrail-2013-11-01.paginators.json
var require_cloudtrail_2013_11_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudtrail-2013-11-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeTrails: {
          result_key: "trailList"
        },
        ListPublicKeys: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "PublicKeyList"
        },
        ListTags: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "ResourceTagList"
        },
        ListTrails: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Trails"
        },
        LookupEvents: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Events"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cloudtrail.js
var require_cloudtrail = __commonJS({
  "node_modules/aws-sdk/clients/cloudtrail.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["cloudtrail"] = {};
    AWS3.CloudTrail = Service.defineService("cloudtrail", ["2013-11-01"]);
    Object.defineProperty(apiLoader.services["cloudtrail"], "2013-11-01", {
      get: function get() {
        var model = require_cloudtrail_2013_11_01_min();
        model.paginators = require_cloudtrail_2013_11_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CloudTrail;
  }
});

// node_modules/aws-sdk/apis/monitoring-2010-08-01.min.json
var require_monitoring_2010_08_01_min = __commonJS({
  "node_modules/aws-sdk/apis/monitoring-2010-08-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2010-08-01",
        endpointPrefix: "monitoring",
        protocol: "query",
        serviceAbbreviation: "CloudWatch",
        serviceFullName: "Amazon CloudWatch",
        serviceId: "CloudWatch",
        signatureVersion: "v4",
        uid: "monitoring-2010-08-01",
        xmlNamespace: "http://monitoring.amazonaws.com/doc/2010-08-01/"
      },
      operations: {
        DeleteAlarms: {
          input: {
            type: "structure",
            required: [
              "AlarmNames"
            ],
            members: {
              AlarmNames: {
                shape: "S2"
              }
            }
          }
        },
        DeleteAnomalyDetector: {
          input: {
            type: "structure",
            required: [
              "Namespace",
              "MetricName",
              "Stat"
            ],
            members: {
              Namespace: {},
              MetricName: {},
              Dimensions: {
                shape: "S7"
              },
              Stat: {}
            }
          },
          output: {
            resultWrapper: "DeleteAnomalyDetectorResult",
            type: "structure",
            members: {}
          }
        },
        DeleteDashboards: {
          input: {
            type: "structure",
            required: [
              "DashboardNames"
            ],
            members: {
              DashboardNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "DeleteDashboardsResult",
            type: "structure",
            members: {}
          }
        },
        DeleteInsightRules: {
          input: {
            type: "structure",
            required: [
              "RuleNames"
            ],
            members: {
              RuleNames: {
                shape: "Si"
              }
            }
          },
          output: {
            resultWrapper: "DeleteInsightRulesResult",
            type: "structure",
            members: {
              Failures: {
                shape: "Sl"
              }
            }
          }
        },
        DeleteMetricStream: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            resultWrapper: "DeleteMetricStreamResult",
            type: "structure",
            members: {}
          }
        },
        DescribeAlarmHistory: {
          input: {
            type: "structure",
            members: {
              AlarmName: {},
              AlarmTypes: {
                shape: "Sv"
              },
              HistoryItemType: {},
              StartDate: {
                type: "timestamp"
              },
              EndDate: {
                type: "timestamp"
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {},
              ScanBy: {}
            }
          },
          output: {
            resultWrapper: "DescribeAlarmHistoryResult",
            type: "structure",
            members: {
              AlarmHistoryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AlarmName: {},
                    AlarmType: {},
                    Timestamp: {
                      type: "timestamp"
                    },
                    HistoryItemType: {},
                    HistorySummary: {},
                    HistoryData: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAlarms: {
          input: {
            type: "structure",
            members: {
              AlarmNames: {
                shape: "S2"
              },
              AlarmNamePrefix: {},
              AlarmTypes: {
                shape: "Sv"
              },
              ChildrenOfAlarmName: {},
              ParentsOfAlarmName: {},
              StateValue: {},
              ActionPrefix: {},
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeAlarmsResult",
            type: "structure",
            members: {
              CompositeAlarms: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ActionsEnabled: {
                      type: "boolean"
                    },
                    AlarmActions: {
                      shape: "S1f"
                    },
                    AlarmArn: {},
                    AlarmConfigurationUpdatedTimestamp: {
                      type: "timestamp"
                    },
                    AlarmDescription: {},
                    AlarmName: {},
                    AlarmRule: {},
                    InsufficientDataActions: {
                      shape: "S1f"
                    },
                    OKActions: {
                      shape: "S1f"
                    },
                    StateReason: {},
                    StateReasonData: {},
                    StateUpdatedTimestamp: {
                      type: "timestamp"
                    },
                    StateValue: {}
                  },
                  xmlOrder: [
                    "ActionsEnabled",
                    "AlarmActions",
                    "AlarmArn",
                    "AlarmConfigurationUpdatedTimestamp",
                    "AlarmDescription",
                    "AlarmName",
                    "AlarmRule",
                    "InsufficientDataActions",
                    "OKActions",
                    "StateReason",
                    "StateReasonData",
                    "StateUpdatedTimestamp",
                    "StateValue"
                  ]
                }
              },
              MetricAlarms: {
                shape: "S1m"
              },
              NextToken: {}
            }
          }
        },
        DescribeAlarmsForMetric: {
          input: {
            type: "structure",
            required: [
              "MetricName",
              "Namespace"
            ],
            members: {
              MetricName: {},
              Namespace: {},
              Statistic: {},
              ExtendedStatistic: {},
              Dimensions: {
                shape: "S7"
              },
              Period: {
                type: "integer"
              },
              Unit: {}
            }
          },
          output: {
            resultWrapper: "DescribeAlarmsForMetricResult",
            type: "structure",
            members: {
              MetricAlarms: {
                shape: "S1m"
              }
            }
          }
        },
        DescribeAnomalyDetectors: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Namespace: {},
              MetricName: {},
              Dimensions: {
                shape: "S7"
              }
            }
          },
          output: {
            resultWrapper: "DescribeAnomalyDetectorsResult",
            type: "structure",
            members: {
              AnomalyDetectors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Namespace: {},
                    MetricName: {},
                    Dimensions: {
                      shape: "S7"
                    },
                    Stat: {},
                    Configuration: {
                      shape: "S2f"
                    },
                    StateValue: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeInsightRules: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeInsightRulesResult",
            type: "structure",
            members: {
              NextToken: {},
              InsightRules: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "State",
                    "Schema",
                    "Definition"
                  ],
                  members: {
                    Name: {},
                    State: {},
                    Schema: {},
                    Definition: {}
                  }
                }
              }
            }
          }
        },
        DisableAlarmActions: {
          input: {
            type: "structure",
            required: [
              "AlarmNames"
            ],
            members: {
              AlarmNames: {
                shape: "S2"
              }
            }
          }
        },
        DisableInsightRules: {
          input: {
            type: "structure",
            required: [
              "RuleNames"
            ],
            members: {
              RuleNames: {
                shape: "Si"
              }
            }
          },
          output: {
            resultWrapper: "DisableInsightRulesResult",
            type: "structure",
            members: {
              Failures: {
                shape: "Sl"
              }
            }
          }
        },
        EnableAlarmActions: {
          input: {
            type: "structure",
            required: [
              "AlarmNames"
            ],
            members: {
              AlarmNames: {
                shape: "S2"
              }
            }
          }
        },
        EnableInsightRules: {
          input: {
            type: "structure",
            required: [
              "RuleNames"
            ],
            members: {
              RuleNames: {
                shape: "Si"
              }
            }
          },
          output: {
            resultWrapper: "EnableInsightRulesResult",
            type: "structure",
            members: {
              Failures: {
                shape: "Sl"
              }
            }
          }
        },
        GetDashboard: {
          input: {
            type: "structure",
            required: [
              "DashboardName"
            ],
            members: {
              DashboardName: {}
            }
          },
          output: {
            resultWrapper: "GetDashboardResult",
            type: "structure",
            members: {
              DashboardArn: {},
              DashboardBody: {},
              DashboardName: {}
            }
          }
        },
        GetInsightRuleReport: {
          input: {
            type: "structure",
            required: [
              "RuleName",
              "StartTime",
              "EndTime",
              "Period"
            ],
            members: {
              RuleName: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Period: {
                type: "integer"
              },
              MaxContributorCount: {
                type: "integer"
              },
              Metrics: {
                type: "list",
                member: {}
              },
              OrderBy: {}
            }
          },
          output: {
            resultWrapper: "GetInsightRuleReportResult",
            type: "structure",
            members: {
              KeyLabels: {
                type: "list",
                member: {}
              },
              AggregationStatistic: {},
              AggregateValue: {
                type: "double"
              },
              ApproximateUniqueCount: {
                type: "long"
              },
              Contributors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Keys",
                    "ApproximateAggregateValue",
                    "Datapoints"
                  ],
                  members: {
                    Keys: {
                      type: "list",
                      member: {}
                    },
                    ApproximateAggregateValue: {
                      type: "double"
                    },
                    Datapoints: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Timestamp",
                          "ApproximateValue"
                        ],
                        members: {
                          Timestamp: {
                            type: "timestamp"
                          },
                          ApproximateValue: {
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                }
              },
              MetricDatapoints: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Timestamp"
                  ],
                  members: {
                    Timestamp: {
                      type: "timestamp"
                    },
                    UniqueContributors: {
                      type: "double"
                    },
                    MaxContributorValue: {
                      type: "double"
                    },
                    SampleCount: {
                      type: "double"
                    },
                    Average: {
                      type: "double"
                    },
                    Sum: {
                      type: "double"
                    },
                    Minimum: {
                      type: "double"
                    },
                    Maximum: {
                      type: "double"
                    }
                  }
                }
              }
            }
          }
        },
        GetMetricData: {
          input: {
            type: "structure",
            required: [
              "MetricDataQueries",
              "StartTime",
              "EndTime"
            ],
            members: {
              MetricDataQueries: {
                shape: "S1y"
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              NextToken: {},
              ScanBy: {},
              MaxDatapoints: {
                type: "integer"
              },
              LabelOptions: {
                type: "structure",
                members: {
                  Timezone: {}
                }
              }
            }
          },
          output: {
            resultWrapper: "GetMetricDataResult",
            type: "structure",
            members: {
              MetricDataResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Label: {},
                    Timestamps: {
                      type: "list",
                      member: {
                        type: "timestamp"
                      }
                    },
                    Values: {
                      type: "list",
                      member: {
                        type: "double"
                      }
                    },
                    StatusCode: {},
                    Messages: {
                      shape: "S3w"
                    }
                  }
                }
              },
              NextToken: {},
              Messages: {
                shape: "S3w"
              }
            }
          }
        },
        GetMetricStatistics: {
          input: {
            type: "structure",
            required: [
              "Namespace",
              "MetricName",
              "StartTime",
              "EndTime",
              "Period"
            ],
            members: {
              Namespace: {},
              MetricName: {},
              Dimensions: {
                shape: "S7"
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Period: {
                type: "integer"
              },
              Statistics: {
                type: "list",
                member: {}
              },
              ExtendedStatistics: {
                type: "list",
                member: {}
              },
              Unit: {}
            }
          },
          output: {
            resultWrapper: "GetMetricStatisticsResult",
            type: "structure",
            members: {
              Label: {},
              Datapoints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "timestamp"
                    },
                    SampleCount: {
                      type: "double"
                    },
                    Average: {
                      type: "double"
                    },
                    Sum: {
                      type: "double"
                    },
                    Minimum: {
                      type: "double"
                    },
                    Maximum: {
                      type: "double"
                    },
                    Unit: {},
                    ExtendedStatistics: {
                      type: "map",
                      key: {},
                      value: {
                        type: "double"
                      }
                    }
                  },
                  xmlOrder: [
                    "Timestamp",
                    "SampleCount",
                    "Average",
                    "Sum",
                    "Minimum",
                    "Maximum",
                    "Unit",
                    "ExtendedStatistics"
                  ]
                }
              }
            }
          }
        },
        GetMetricStream: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            resultWrapper: "GetMetricStreamResult",
            type: "structure",
            members: {
              Arn: {},
              Name: {},
              IncludeFilters: {
                shape: "S4a"
              },
              ExcludeFilters: {
                shape: "S4a"
              },
              FirehoseArn: {},
              RoleArn: {},
              State: {},
              CreationDate: {
                type: "timestamp"
              },
              LastUpdateDate: {
                type: "timestamp"
              },
              OutputFormat: {}
            }
          }
        },
        GetMetricWidgetImage: {
          input: {
            type: "structure",
            required: [
              "MetricWidget"
            ],
            members: {
              MetricWidget: {},
              OutputFormat: {}
            }
          },
          output: {
            resultWrapper: "GetMetricWidgetImageResult",
            type: "structure",
            members: {
              MetricWidgetImage: {
                type: "blob"
              }
            }
          }
        },
        ListDashboards: {
          input: {
            type: "structure",
            members: {
              DashboardNamePrefix: {},
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListDashboardsResult",
            type: "structure",
            members: {
              DashboardEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DashboardName: {},
                    DashboardArn: {},
                    LastModified: {
                      type: "timestamp"
                    },
                    Size: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListMetricStreams: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListMetricStreamsResult",
            type: "structure",
            members: {
              NextToken: {},
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    LastUpdateDate: {
                      type: "timestamp"
                    },
                    Name: {},
                    FirehoseArn: {},
                    State: {},
                    OutputFormat: {}
                  }
                }
              }
            }
          }
        },
        ListMetrics: {
          input: {
            type: "structure",
            members: {
              Namespace: {},
              MetricName: {},
              Dimensions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name"
                  ],
                  members: {
                    Name: {},
                    Value: {}
                  }
                }
              },
              NextToken: {},
              RecentlyActive: {}
            }
          },
          output: {
            resultWrapper: "ListMetricsResult",
            type: "structure",
            members: {
              Metrics: {
                type: "list",
                member: {
                  shape: "S22"
                }
              },
              NextToken: {}
            },
            xmlOrder: [
              "Metrics",
              "NextToken"
            ]
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            resultWrapper: "ListTagsForResourceResult",
            type: "structure",
            members: {
              Tags: {
                shape: "S53"
              }
            }
          }
        },
        PutAnomalyDetector: {
          input: {
            type: "structure",
            required: [
              "Namespace",
              "MetricName",
              "Stat"
            ],
            members: {
              Namespace: {},
              MetricName: {},
              Dimensions: {
                shape: "S7"
              },
              Stat: {},
              Configuration: {
                shape: "S2f"
              }
            }
          },
          output: {
            resultWrapper: "PutAnomalyDetectorResult",
            type: "structure",
            members: {}
          }
        },
        PutCompositeAlarm: {
          input: {
            type: "structure",
            required: [
              "AlarmName",
              "AlarmRule"
            ],
            members: {
              ActionsEnabled: {
                type: "boolean"
              },
              AlarmActions: {
                shape: "S1f"
              },
              AlarmDescription: {},
              AlarmName: {},
              AlarmRule: {},
              InsufficientDataActions: {
                shape: "S1f"
              },
              OKActions: {
                shape: "S1f"
              },
              Tags: {
                shape: "S53"
              }
            }
          }
        },
        PutDashboard: {
          input: {
            type: "structure",
            required: [
              "DashboardName",
              "DashboardBody"
            ],
            members: {
              DashboardName: {},
              DashboardBody: {}
            }
          },
          output: {
            resultWrapper: "PutDashboardResult",
            type: "structure",
            members: {
              DashboardValidationMessages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DataPath: {},
                    Message: {}
                  }
                }
              }
            }
          }
        },
        PutInsightRule: {
          input: {
            type: "structure",
            required: [
              "RuleName",
              "RuleDefinition"
            ],
            members: {
              RuleName: {},
              RuleState: {},
              RuleDefinition: {},
              Tags: {
                shape: "S53"
              }
            }
          },
          output: {
            resultWrapper: "PutInsightRuleResult",
            type: "structure",
            members: {}
          }
        },
        PutMetricAlarm: {
          input: {
            type: "structure",
            required: [
              "AlarmName",
              "EvaluationPeriods",
              "ComparisonOperator"
            ],
            members: {
              AlarmName: {},
              AlarmDescription: {},
              ActionsEnabled: {
                type: "boolean"
              },
              OKActions: {
                shape: "S1f"
              },
              AlarmActions: {
                shape: "S1f"
              },
              InsufficientDataActions: {
                shape: "S1f"
              },
              MetricName: {},
              Namespace: {},
              Statistic: {},
              ExtendedStatistic: {},
              Dimensions: {
                shape: "S7"
              },
              Period: {
                type: "integer"
              },
              Unit: {},
              EvaluationPeriods: {
                type: "integer"
              },
              DatapointsToAlarm: {
                type: "integer"
              },
              Threshold: {
                type: "double"
              },
              ComparisonOperator: {},
              TreatMissingData: {},
              EvaluateLowSampleCountPercentile: {},
              Metrics: {
                shape: "S1y"
              },
              Tags: {
                shape: "S53"
              },
              ThresholdMetricId: {}
            }
          }
        },
        PutMetricData: {
          input: {
            type: "structure",
            required: [
              "Namespace",
              "MetricData"
            ],
            members: {
              Namespace: {},
              MetricData: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "MetricName"
                  ],
                  members: {
                    MetricName: {},
                    Dimensions: {
                      shape: "S7"
                    },
                    Timestamp: {
                      type: "timestamp"
                    },
                    Value: {
                      type: "double"
                    },
                    StatisticValues: {
                      type: "structure",
                      required: [
                        "SampleCount",
                        "Sum",
                        "Minimum",
                        "Maximum"
                      ],
                      members: {
                        SampleCount: {
                          type: "double"
                        },
                        Sum: {
                          type: "double"
                        },
                        Minimum: {
                          type: "double"
                        },
                        Maximum: {
                          type: "double"
                        }
                      }
                    },
                    Values: {
                      type: "list",
                      member: {
                        type: "double"
                      }
                    },
                    Counts: {
                      type: "list",
                      member: {
                        type: "double"
                      }
                    },
                    Unit: {},
                    StorageResolution: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        PutMetricStream: {
          input: {
            type: "structure",
            required: [
              "Name",
              "FirehoseArn",
              "RoleArn",
              "OutputFormat"
            ],
            members: {
              Name: {},
              IncludeFilters: {
                shape: "S4a"
              },
              ExcludeFilters: {
                shape: "S4a"
              },
              FirehoseArn: {},
              RoleArn: {},
              OutputFormat: {},
              Tags: {
                shape: "S53"
              }
            }
          },
          output: {
            resultWrapper: "PutMetricStreamResult",
            type: "structure",
            members: {
              Arn: {}
            }
          }
        },
        SetAlarmState: {
          input: {
            type: "structure",
            required: [
              "AlarmName",
              "StateValue",
              "StateReason"
            ],
            members: {
              AlarmName: {},
              StateValue: {},
              StateReason: {},
              StateReasonData: {}
            }
          }
        },
        StartMetricStreams: {
          input: {
            type: "structure",
            required: [
              "Names"
            ],
            members: {
              Names: {
                shape: "S5u"
              }
            }
          },
          output: {
            resultWrapper: "StartMetricStreamsResult",
            type: "structure",
            members: {}
          }
        },
        StopMetricStreams: {
          input: {
            type: "structure",
            required: [
              "Names"
            ],
            members: {
              Names: {
                shape: "S5u"
              }
            }
          },
          output: {
            resultWrapper: "StopMetricStreamsResult",
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S53"
              }
            }
          },
          output: {
            resultWrapper: "TagResourceResult",
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "UntagResourceResult",
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {}
        },
        S7: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {}
            },
            xmlOrder: [
              "Name",
              "Value"
            ]
          }
        },
        Si: {
          type: "list",
          member: {}
        },
        Sl: {
          type: "list",
          member: {
            type: "structure",
            members: {
              FailureResource: {},
              ExceptionType: {},
              FailureCode: {},
              FailureDescription: {}
            }
          }
        },
        Sv: {
          type: "list",
          member: {}
        },
        S1f: {
          type: "list",
          member: {}
        },
        S1m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AlarmName: {},
              AlarmArn: {},
              AlarmDescription: {},
              AlarmConfigurationUpdatedTimestamp: {
                type: "timestamp"
              },
              ActionsEnabled: {
                type: "boolean"
              },
              OKActions: {
                shape: "S1f"
              },
              AlarmActions: {
                shape: "S1f"
              },
              InsufficientDataActions: {
                shape: "S1f"
              },
              StateValue: {},
              StateReason: {},
              StateReasonData: {},
              StateUpdatedTimestamp: {
                type: "timestamp"
              },
              MetricName: {},
              Namespace: {},
              Statistic: {},
              ExtendedStatistic: {},
              Dimensions: {
                shape: "S7"
              },
              Period: {
                type: "integer"
              },
              Unit: {},
              EvaluationPeriods: {
                type: "integer"
              },
              DatapointsToAlarm: {
                type: "integer"
              },
              Threshold: {
                type: "double"
              },
              ComparisonOperator: {},
              TreatMissingData: {},
              EvaluateLowSampleCountPercentile: {},
              Metrics: {
                shape: "S1y"
              },
              ThresholdMetricId: {}
            },
            xmlOrder: [
              "AlarmName",
              "AlarmArn",
              "AlarmDescription",
              "AlarmConfigurationUpdatedTimestamp",
              "ActionsEnabled",
              "OKActions",
              "AlarmActions",
              "InsufficientDataActions",
              "StateValue",
              "StateReason",
              "StateReasonData",
              "StateUpdatedTimestamp",
              "MetricName",
              "Namespace",
              "Statistic",
              "Dimensions",
              "Period",
              "Unit",
              "EvaluationPeriods",
              "Threshold",
              "ComparisonOperator",
              "ExtendedStatistic",
              "TreatMissingData",
              "EvaluateLowSampleCountPercentile",
              "DatapointsToAlarm",
              "Metrics",
              "ThresholdMetricId"
            ]
          }
        },
        S1y: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {},
              MetricStat: {
                type: "structure",
                required: [
                  "Metric",
                  "Period",
                  "Stat"
                ],
                members: {
                  Metric: {
                    shape: "S22"
                  },
                  Period: {
                    type: "integer"
                  },
                  Stat: {},
                  Unit: {}
                }
              },
              Expression: {},
              Label: {},
              ReturnData: {
                type: "boolean"
              },
              Period: {
                type: "integer"
              },
              AccountId: {}
            }
          }
        },
        S22: {
          type: "structure",
          members: {
            Namespace: {},
            MetricName: {},
            Dimensions: {
              shape: "S7"
            }
          },
          xmlOrder: [
            "Namespace",
            "MetricName",
            "Dimensions"
          ]
        },
        S2f: {
          type: "structure",
          members: {
            ExcludedTimeRanges: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "StartTime",
                  "EndTime"
                ],
                members: {
                  StartTime: {
                    type: "timestamp"
                  },
                  EndTime: {
                    type: "timestamp"
                  }
                },
                xmlOrder: [
                  "StartTime",
                  "EndTime"
                ]
              }
            },
            MetricTimezone: {}
          }
        },
        S3w: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Code: {},
              Value: {}
            }
          }
        },
        S4a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Namespace: {}
            }
          }
        },
        S53: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S5u: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/monitoring-2010-08-01.paginators.json
var require_monitoring_2010_08_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/monitoring-2010-08-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeAlarmHistory: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "AlarmHistoryItems"
        },
        DescribeAlarms: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: [
            "MetricAlarms",
            "CompositeAlarms"
          ]
        },
        DescribeAlarmsForMetric: {
          result_key: "MetricAlarms"
        },
        DescribeInsightRules: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetMetricData: {
          input_token: "NextToken",
          limit_key: "MaxDatapoints",
          output_token: "NextToken",
          result_key: [
            "MetricDataResults",
            "Messages"
          ]
        },
        ListDashboards: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "DashboardEntries"
        },
        ListMetricStreams: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListMetrics: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Metrics"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/monitoring-2010-08-01.waiters2.json
var require_monitoring_2010_08_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/monitoring-2010-08-01.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        AlarmExists: {
          delay: 5,
          maxAttempts: 40,
          operation: "DescribeAlarms",
          acceptors: [
            {
              matcher: "path",
              expected: true,
              argument: "length(MetricAlarms[]) > `0`",
              state: "success"
            }
          ]
        },
        CompositeAlarmExists: {
          delay: 5,
          maxAttempts: 40,
          operation: "DescribeAlarms",
          acceptors: [
            {
              matcher: "path",
              expected: true,
              argument: "length(CompositeAlarms[]) > `0`",
              state: "success"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cloudwatch.js
var require_cloudwatch = __commonJS({
  "node_modules/aws-sdk/clients/cloudwatch.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["cloudwatch"] = {};
    AWS3.CloudWatch = Service.defineService("cloudwatch", ["2010-08-01"]);
    Object.defineProperty(apiLoader.services["cloudwatch"], "2010-08-01", {
      get: function get() {
        var model = require_monitoring_2010_08_01_min();
        model.paginators = require_monitoring_2010_08_01_paginators().pagination;
        model.waiters = require_monitoring_2010_08_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CloudWatch;
  }
});

// node_modules/aws-sdk/apis/events-2015-10-07.min.json
var require_events_2015_10_07_min = __commonJS({
  "node_modules/aws-sdk/apis/events-2015-10-07.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-10-07",
        endpointPrefix: "events",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon CloudWatch Events",
        serviceId: "CloudWatch Events",
        signatureVersion: "v4",
        targetPrefix: "AWSEvents",
        uid: "events-2015-10-07"
      },
      operations: {
        ActivateEventSource: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        CancelReplay: {
          input: {
            type: "structure",
            required: [
              "ReplayName"
            ],
            members: {
              ReplayName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplayArn: {},
              State: {},
              StateReason: {}
            }
          }
        },
        CreateApiDestination: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ConnectionArn",
              "InvocationEndpoint",
              "HttpMethod"
            ],
            members: {
              Name: {},
              Description: {},
              ConnectionArn: {},
              InvocationEndpoint: {},
              HttpMethod: {},
              InvocationRateLimitPerSecond: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApiDestinationArn: {},
              ApiDestinationState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateArchive: {
          input: {
            type: "structure",
            required: [
              "ArchiveName",
              "EventSourceArn"
            ],
            members: {
              ArchiveName: {},
              EventSourceArn: {},
              Description: {},
              EventPattern: {},
              RetentionDays: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ArchiveArn: {},
              State: {},
              StateReason: {},
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateConnection: {
          input: {
            type: "structure",
            required: [
              "Name",
              "AuthorizationType",
              "AuthParameters"
            ],
            members: {
              Name: {},
              Description: {},
              AuthorizationType: {},
              AuthParameters: {
                type: "structure",
                members: {
                  BasicAuthParameters: {
                    type: "structure",
                    required: [
                      "Username",
                      "Password"
                    ],
                    members: {
                      Username: {},
                      Password: {}
                    }
                  },
                  OAuthParameters: {
                    type: "structure",
                    required: [
                      "ClientParameters",
                      "AuthorizationEndpoint",
                      "HttpMethod"
                    ],
                    members: {
                      ClientParameters: {
                        type: "structure",
                        required: [
                          "ClientID",
                          "ClientSecret"
                        ],
                        members: {
                          ClientID: {},
                          ClientSecret: {}
                        }
                      },
                      AuthorizationEndpoint: {},
                      HttpMethod: {},
                      OAuthHttpParameters: {
                        shape: "S14"
                      }
                    }
                  },
                  ApiKeyAuthParameters: {
                    type: "structure",
                    required: [
                      "ApiKeyName",
                      "ApiKeyValue"
                    ],
                    members: {
                      ApiKeyName: {},
                      ApiKeyValue: {}
                    }
                  },
                  InvocationHttpParameters: {
                    shape: "S14"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionArn: {},
              ConnectionState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateEventBus: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              EventSourceName: {},
              Tags: {
                shape: "S1m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventBusArn: {}
            }
          }
        },
        CreatePartnerEventSource: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Account"
            ],
            members: {
              Name: {},
              Account: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EventSourceArn: {}
            }
          }
        },
        DeactivateEventSource: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DeauthorizeConnection: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionArn: {},
              ConnectionState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastAuthorizedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteApiDestination: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteArchive: {
          input: {
            type: "structure",
            required: [
              "ArchiveName"
            ],
            members: {
              ArchiveName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteConnection: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionArn: {},
              ConnectionState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastAuthorizedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteEventBus: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DeletePartnerEventSource: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Account"
            ],
            members: {
              Name: {},
              Account: {}
            }
          }
        },
        DeleteRule: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              EventBusName: {},
              Force: {
                type: "boolean"
              }
            }
          }
        },
        DescribeApiDestination: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApiDestinationArn: {},
              Name: {},
              Description: {},
              ApiDestinationState: {},
              ConnectionArn: {},
              InvocationEndpoint: {},
              HttpMethod: {},
              InvocationRateLimitPerSecond: {
                type: "integer"
              },
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeArchive: {
          input: {
            type: "structure",
            required: [
              "ArchiveName"
            ],
            members: {
              ArchiveName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ArchiveArn: {},
              ArchiveName: {},
              EventSourceArn: {},
              Description: {},
              EventPattern: {},
              State: {},
              StateReason: {},
              RetentionDays: {
                type: "integer"
              },
              SizeBytes: {
                type: "long"
              },
              EventCount: {
                type: "long"
              },
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeConnection: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionArn: {},
              Name: {},
              Description: {},
              ConnectionState: {},
              StateReason: {},
              AuthorizationType: {},
              SecretArn: {},
              AuthParameters: {
                type: "structure",
                members: {
                  BasicAuthParameters: {
                    type: "structure",
                    members: {
                      Username: {}
                    }
                  },
                  OAuthParameters: {
                    type: "structure",
                    members: {
                      ClientParameters: {
                        type: "structure",
                        members: {
                          ClientID: {}
                        }
                      },
                      AuthorizationEndpoint: {},
                      HttpMethod: {},
                      OAuthHttpParameters: {
                        shape: "S14"
                      }
                    }
                  },
                  ApiKeyAuthParameters: {
                    type: "structure",
                    members: {
                      ApiKeyName: {}
                    }
                  },
                  InvocationHttpParameters: {
                    shape: "S14"
                  }
                }
              },
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastAuthorizedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeEventBus: {
          input: {
            type: "structure",
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Arn: {},
              Policy: {}
            }
          }
        },
        DescribeEventSource: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreatedBy: {},
              CreationTime: {
                type: "timestamp"
              },
              ExpirationTime: {
                type: "timestamp"
              },
              Name: {},
              State: {}
            }
          }
        },
        DescribePartnerEventSource: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Name: {}
            }
          }
        },
        DescribeReplay: {
          input: {
            type: "structure",
            required: [
              "ReplayName"
            ],
            members: {
              ReplayName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplayName: {},
              ReplayArn: {},
              Description: {},
              State: {},
              StateReason: {},
              EventSourceArn: {},
              Destination: {
                shape: "S2w"
              },
              EventStartTime: {
                type: "timestamp"
              },
              EventEndTime: {
                type: "timestamp"
              },
              EventLastReplayedTime: {
                type: "timestamp"
              },
              ReplayStartTime: {
                type: "timestamp"
              },
              ReplayEndTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeRule: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              EventBusName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Arn: {},
              EventPattern: {},
              ScheduleExpression: {},
              State: {},
              Description: {},
              RoleArn: {},
              ManagedBy: {},
              EventBusName: {},
              CreatedBy: {}
            }
          }
        },
        DisableRule: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              EventBusName: {}
            }
          }
        },
        EnableRule: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              EventBusName: {}
            }
          }
        },
        ListApiDestinations: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              ConnectionArn: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApiDestinations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApiDestinationArn: {},
                    Name: {},
                    ApiDestinationState: {},
                    ConnectionArn: {},
                    InvocationEndpoint: {},
                    HttpMethod: {},
                    InvocationRateLimitPerSecond: {
                      type: "integer"
                    },
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListArchives: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              EventSourceArn: {},
              State: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Archives: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ArchiveName: {},
                    EventSourceArn: {},
                    State: {},
                    StateReason: {},
                    RetentionDays: {
                      type: "integer"
                    },
                    SizeBytes: {
                      type: "long"
                    },
                    EventCount: {
                      type: "long"
                    },
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListConnections: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              ConnectionState: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connections: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConnectionArn: {},
                    Name: {},
                    ConnectionState: {},
                    StateReason: {},
                    AuthorizationType: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LastAuthorizedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEventBuses: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventBuses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Arn: {},
                    Policy: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEventSources: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventSources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreatedBy: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    ExpirationTime: {
                      type: "timestamp"
                    },
                    Name: {},
                    State: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPartnerEventSourceAccounts: {
          input: {
            type: "structure",
            required: [
              "EventSourceName"
            ],
            members: {
              EventSourceName: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PartnerEventSourceAccounts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Account: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    ExpirationTime: {
                      type: "timestamp"
                    },
                    State: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPartnerEventSources: {
          input: {
            type: "structure",
            required: [
              "NamePrefix"
            ],
            members: {
              NamePrefix: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PartnerEventSources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListReplays: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              State: {},
              EventSourceArn: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Replays: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReplayName: {},
                    EventSourceArn: {},
                    State: {},
                    StateReason: {},
                    EventStartTime: {
                      type: "timestamp"
                    },
                    EventEndTime: {
                      type: "timestamp"
                    },
                    EventLastReplayedTime: {
                      type: "timestamp"
                    },
                    ReplayStartTime: {
                      type: "timestamp"
                    },
                    ReplayEndTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRuleNamesByTarget: {
          input: {
            type: "structure",
            required: [
              "TargetArn"
            ],
            members: {
              TargetArn: {},
              EventBusName: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RuleNames: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListRules: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              EventBusName: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Arn: {},
                    EventPattern: {},
                    State: {},
                    Description: {},
                    ScheduleExpression: {},
                    RoleArn: {},
                    ManagedBy: {},
                    EventBusName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S1m"
              }
            }
          }
        },
        ListTargetsByRule: {
          input: {
            type: "structure",
            required: [
              "Rule"
            ],
            members: {
              Rule: {},
              EventBusName: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Targets: {
                shape: "S4l"
              },
              NextToken: {}
            }
          }
        },
        PutEvents: {
          input: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Time: {
                      type: "timestamp"
                    },
                    Source: {},
                    Resources: {
                      shape: "S6j"
                    },
                    DetailType: {},
                    Detail: {},
                    EventBusName: {},
                    TraceHeader: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEntryCount: {
                type: "integer"
              },
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        PutPartnerEvents: {
          input: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Time: {
                      type: "timestamp"
                    },
                    Source: {},
                    Resources: {
                      shape: "S6j"
                    },
                    DetailType: {},
                    Detail: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEntryCount: {
                type: "integer"
              },
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        PutPermission: {
          input: {
            type: "structure",
            members: {
              EventBusName: {},
              Action: {},
              Principal: {},
              StatementId: {},
              Condition: {
                type: "structure",
                required: [
                  "Type",
                  "Key",
                  "Value"
                ],
                members: {
                  Type: {},
                  Key: {},
                  Value: {}
                }
              },
              Policy: {}
            }
          }
        },
        PutRule: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              ScheduleExpression: {},
              EventPattern: {},
              State: {},
              Description: {},
              RoleArn: {},
              Tags: {
                shape: "S1m"
              },
              EventBusName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RuleArn: {}
            }
          }
        },
        PutTargets: {
          input: {
            type: "structure",
            required: [
              "Rule",
              "Targets"
            ],
            members: {
              Rule: {},
              EventBusName: {},
              Targets: {
                shape: "S4l"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEntryCount: {
                type: "integer"
              },
              FailedEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TargetId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        RemovePermission: {
          input: {
            type: "structure",
            members: {
              StatementId: {},
              RemoveAllPermissions: {
                type: "boolean"
              },
              EventBusName: {}
            }
          }
        },
        RemoveTargets: {
          input: {
            type: "structure",
            required: [
              "Rule",
              "Ids"
            ],
            members: {
              Rule: {},
              EventBusName: {},
              Ids: {
                type: "list",
                member: {}
              },
              Force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEntryCount: {
                type: "integer"
              },
              FailedEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TargetId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        StartReplay: {
          input: {
            type: "structure",
            required: [
              "ReplayName",
              "EventSourceArn",
              "EventStartTime",
              "EventEndTime",
              "Destination"
            ],
            members: {
              ReplayName: {},
              Description: {},
              EventSourceArn: {},
              EventStartTime: {
                type: "timestamp"
              },
              EventEndTime: {
                type: "timestamp"
              },
              Destination: {
                shape: "S2w"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplayArn: {},
              State: {},
              StateReason: {},
              ReplayStartTime: {
                type: "timestamp"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S1m"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TestEventPattern: {
          input: {
            type: "structure",
            required: [
              "EventPattern",
              "Event"
            ],
            members: {
              EventPattern: {},
              Event: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Result: {
                type: "boolean"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApiDestination: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              ConnectionArn: {},
              InvocationEndpoint: {},
              HttpMethod: {},
              InvocationRateLimitPerSecond: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApiDestinationArn: {},
              ApiDestinationState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateArchive: {
          input: {
            type: "structure",
            required: [
              "ArchiveName"
            ],
            members: {
              ArchiveName: {},
              Description: {},
              EventPattern: {},
              RetentionDays: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ArchiveArn: {},
              State: {},
              StateReason: {},
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateConnection: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              AuthorizationType: {},
              AuthParameters: {
                type: "structure",
                members: {
                  BasicAuthParameters: {
                    type: "structure",
                    members: {
                      Username: {},
                      Password: {}
                    }
                  },
                  OAuthParameters: {
                    type: "structure",
                    members: {
                      ClientParameters: {
                        type: "structure",
                        members: {
                          ClientID: {},
                          ClientSecret: {}
                        }
                      },
                      AuthorizationEndpoint: {},
                      HttpMethod: {},
                      OAuthHttpParameters: {
                        shape: "S14"
                      }
                    }
                  },
                  ApiKeyAuthParameters: {
                    type: "structure",
                    members: {
                      ApiKeyName: {},
                      ApiKeyValue: {}
                    }
                  },
                  InvocationHttpParameters: {
                    shape: "S14"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionArn: {},
              ConnectionState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastAuthorizedTime: {
                type: "timestamp"
              }
            }
          }
        }
      },
      shapes: {
        S14: {
          type: "structure",
          members: {
            HeaderParameters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {},
                  IsValueSecret: {
                    type: "boolean"
                  }
                }
              }
            },
            QueryStringParameters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {},
                  IsValueSecret: {
                    type: "boolean"
                  }
                }
              }
            },
            BodyParameters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {},
                  IsValueSecret: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S1m: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S2w: {
          type: "structure",
          required: [
            "Arn"
          ],
          members: {
            Arn: {},
            FilterArns: {
              type: "list",
              member: {}
            }
          }
        },
        S4l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Id",
              "Arn"
            ],
            members: {
              Id: {},
              Arn: {},
              RoleArn: {},
              Input: {},
              InputPath: {},
              InputTransformer: {
                type: "structure",
                required: [
                  "InputTemplate"
                ],
                members: {
                  InputPathsMap: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  InputTemplate: {}
                }
              },
              KinesisParameters: {
                type: "structure",
                required: [
                  "PartitionKeyPath"
                ],
                members: {
                  PartitionKeyPath: {}
                }
              },
              RunCommandParameters: {
                type: "structure",
                required: [
                  "RunCommandTargets"
                ],
                members: {
                  RunCommandTargets: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Key",
                        "Values"
                      ],
                      members: {
                        Key: {},
                        Values: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                }
              },
              EcsParameters: {
                type: "structure",
                required: [
                  "TaskDefinitionArn"
                ],
                members: {
                  TaskDefinitionArn: {},
                  TaskCount: {
                    type: "integer"
                  },
                  LaunchType: {},
                  NetworkConfiguration: {
                    type: "structure",
                    members: {
                      awsvpcConfiguration: {
                        type: "structure",
                        required: [
                          "Subnets"
                        ],
                        members: {
                          Subnets: {
                            shape: "S57"
                          },
                          SecurityGroups: {
                            shape: "S57"
                          },
                          AssignPublicIp: {}
                        }
                      }
                    }
                  },
                  PlatformVersion: {},
                  Group: {},
                  CapacityProviderStrategy: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "capacityProvider"
                      ],
                      members: {
                        capacityProvider: {},
                        weight: {
                          type: "integer"
                        },
                        base: {
                          type: "integer"
                        }
                      }
                    }
                  },
                  EnableECSManagedTags: {
                    type: "boolean"
                  },
                  EnableExecuteCommand: {
                    type: "boolean"
                  },
                  PlacementConstraints: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        type: {},
                        expression: {}
                      }
                    }
                  },
                  PlacementStrategy: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        type: {},
                        field: {}
                      }
                    }
                  },
                  PropagateTags: {},
                  ReferenceId: {},
                  Tags: {
                    shape: "S1m"
                  }
                }
              },
              BatchParameters: {
                type: "structure",
                required: [
                  "JobDefinition",
                  "JobName"
                ],
                members: {
                  JobDefinition: {},
                  JobName: {},
                  ArrayProperties: {
                    type: "structure",
                    members: {
                      Size: {
                        type: "integer"
                      }
                    }
                  },
                  RetryStrategy: {
                    type: "structure",
                    members: {
                      Attempts: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              SqsParameters: {
                type: "structure",
                members: {
                  MessageGroupId: {}
                }
              },
              HttpParameters: {
                type: "structure",
                members: {
                  PathParameterValues: {
                    type: "list",
                    member: {}
                  },
                  HeaderParameters: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  QueryStringParameters: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              },
              RedshiftDataParameters: {
                type: "structure",
                required: [
                  "Database",
                  "Sql"
                ],
                members: {
                  SecretManagerArn: {},
                  Database: {},
                  DbUser: {},
                  Sql: {},
                  StatementName: {},
                  WithEvent: {
                    type: "boolean"
                  }
                }
              },
              SageMakerPipelineParameters: {
                type: "structure",
                members: {
                  PipelineParameterList: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Name",
                        "Value"
                      ],
                      members: {
                        Name: {},
                        Value: {}
                      }
                    }
                  }
                }
              },
              DeadLetterConfig: {
                type: "structure",
                members: {
                  Arn: {}
                }
              },
              RetryPolicy: {
                type: "structure",
                members: {
                  MaximumRetryAttempts: {
                    type: "integer"
                  },
                  MaximumEventAgeInSeconds: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        S57: {
          type: "list",
          member: {}
        },
        S6j: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/events-2015-10-07.paginators.json
var require_events_2015_10_07_paginators = __commonJS({
  "node_modules/aws-sdk/apis/events-2015-10-07.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/cloudwatchevents.js
var require_cloudwatchevents = __commonJS({
  "node_modules/aws-sdk/clients/cloudwatchevents.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["cloudwatchevents"] = {};
    AWS3.CloudWatchEvents = Service.defineService("cloudwatchevents", ["2014-02-03*", "2015-10-07"]);
    Object.defineProperty(apiLoader.services["cloudwatchevents"], "2015-10-07", {
      get: function get() {
        var model = require_events_2015_10_07_min();
        model.paginators = require_events_2015_10_07_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CloudWatchEvents;
  }
});

// node_modules/aws-sdk/apis/logs-2014-03-28.min.json
var require_logs_2014_03_28_min = __commonJS({
  "node_modules/aws-sdk/apis/logs-2014-03-28.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-03-28",
        endpointPrefix: "logs",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon CloudWatch Logs",
        serviceId: "CloudWatch Logs",
        signatureVersion: "v4",
        targetPrefix: "Logs_20140328",
        uid: "logs-2014-03-28"
      },
      operations: {
        AssociateKmsKey: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "kmsKeyId"
            ],
            members: {
              logGroupName: {},
              kmsKeyId: {}
            }
          }
        },
        CancelExportTask: {
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {}
            }
          }
        },
        CreateExportTask: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "from",
              "to",
              "destination"
            ],
            members: {
              taskName: {},
              logGroupName: {},
              logStreamNamePrefix: {},
              from: {
                type: "long"
              },
              to: {
                type: "long"
              },
              destination: {},
              destinationPrefix: {}
            }
          },
          output: {
            type: "structure",
            members: {
              taskId: {}
            }
          }
        },
        CreateLogGroup: {
          input: {
            type: "structure",
            required: [
              "logGroupName"
            ],
            members: {
              logGroupName: {},
              kmsKeyId: {},
              tags: {
                shape: "Se"
              }
            }
          }
        },
        CreateLogStream: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "logStreamName"
            ],
            members: {
              logGroupName: {},
              logStreamName: {}
            }
          }
        },
        DeleteDestination: {
          input: {
            type: "structure",
            required: [
              "destinationName"
            ],
            members: {
              destinationName: {}
            }
          }
        },
        DeleteLogGroup: {
          input: {
            type: "structure",
            required: [
              "logGroupName"
            ],
            members: {
              logGroupName: {}
            }
          }
        },
        DeleteLogStream: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "logStreamName"
            ],
            members: {
              logGroupName: {},
              logStreamName: {}
            }
          }
        },
        DeleteMetricFilter: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "filterName"
            ],
            members: {
              logGroupName: {},
              filterName: {}
            }
          }
        },
        DeleteQueryDefinition: {
          input: {
            type: "structure",
            required: [
              "queryDefinitionId"
            ],
            members: {
              queryDefinitionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              success: {
                type: "boolean"
              }
            }
          }
        },
        DeleteResourcePolicy: {
          input: {
            type: "structure",
            members: {
              policyName: {}
            }
          }
        },
        DeleteRetentionPolicy: {
          input: {
            type: "structure",
            required: [
              "logGroupName"
            ],
            members: {
              logGroupName: {}
            }
          }
        },
        DeleteSubscriptionFilter: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "filterName"
            ],
            members: {
              logGroupName: {},
              filterName: {}
            }
          }
        },
        DescribeDestinations: {
          input: {
            type: "structure",
            members: {
              DestinationNamePrefix: {},
              nextToken: {},
              limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              destinations: {
                type: "list",
                member: {
                  shape: "S11"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeExportTasks: {
          input: {
            type: "structure",
            members: {
              taskId: {},
              statusCode: {},
              nextToken: {},
              limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              exportTasks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    taskId: {},
                    taskName: {},
                    logGroupName: {},
                    from: {
                      type: "long"
                    },
                    to: {
                      type: "long"
                    },
                    destination: {},
                    destinationPrefix: {},
                    status: {
                      type: "structure",
                      members: {
                        code: {},
                        message: {}
                      }
                    },
                    executionInfo: {
                      type: "structure",
                      members: {
                        creationTime: {
                          type: "long"
                        },
                        completionTime: {
                          type: "long"
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeLogGroups: {
          input: {
            type: "structure",
            members: {
              logGroupNamePrefix: {},
              nextToken: {},
              limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              logGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    logGroupName: {},
                    creationTime: {
                      type: "long"
                    },
                    retentionInDays: {
                      type: "integer"
                    },
                    metricFilterCount: {
                      type: "integer"
                    },
                    arn: {},
                    storedBytes: {
                      type: "long"
                    },
                    kmsKeyId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeLogStreams: {
          input: {
            type: "structure",
            required: [
              "logGroupName"
            ],
            members: {
              logGroupName: {},
              logStreamNamePrefix: {},
              orderBy: {},
              descending: {
                type: "boolean"
              },
              nextToken: {},
              limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              logStreams: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    logStreamName: {},
                    creationTime: {
                      type: "long"
                    },
                    firstEventTimestamp: {
                      type: "long"
                    },
                    lastEventTimestamp: {
                      type: "long"
                    },
                    lastIngestionTime: {
                      type: "long"
                    },
                    uploadSequenceToken: {},
                    arn: {},
                    storedBytes: {
                      deprecated: true,
                      deprecatedMessage: "Starting on June 17, 2019, this parameter will be deprecated for log streams, and will be reported as zero. This change applies only to log streams. The storedBytes parameter for log groups is not affected.",
                      type: "long"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeMetricFilters: {
          input: {
            type: "structure",
            members: {
              logGroupName: {},
              filterNamePrefix: {},
              nextToken: {},
              limit: {
                type: "integer"
              },
              metricName: {},
              metricNamespace: {}
            }
          },
          output: {
            type: "structure",
            members: {
              metricFilters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    filterName: {},
                    filterPattern: {},
                    metricTransformations: {
                      shape: "S1z"
                    },
                    creationTime: {
                      type: "long"
                    },
                    logGroupName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeQueries: {
          input: {
            type: "structure",
            members: {
              logGroupName: {},
              status: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              queries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    queryId: {},
                    queryString: {},
                    status: {},
                    createTime: {
                      type: "long"
                    },
                    logGroupName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeQueryDefinitions: {
          input: {
            type: "structure",
            members: {
              queryDefinitionNamePrefix: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              queryDefinitions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    queryDefinitionId: {},
                    name: {},
                    queryString: {},
                    lastModified: {
                      type: "long"
                    },
                    logGroupNames: {
                      shape: "S2l"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeResourcePolicies: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourcePolicies: {
                type: "list",
                member: {
                  shape: "S2p"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeSubscriptionFilters: {
          input: {
            type: "structure",
            required: [
              "logGroupName"
            ],
            members: {
              logGroupName: {},
              filterNamePrefix: {},
              nextToken: {},
              limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              subscriptionFilters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    filterName: {},
                    logGroupName: {},
                    filterPattern: {},
                    destinationArn: {},
                    roleArn: {},
                    distribution: {},
                    creationTime: {
                      type: "long"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DisassociateKmsKey: {
          input: {
            type: "structure",
            required: [
              "logGroupName"
            ],
            members: {
              logGroupName: {}
            }
          }
        },
        FilterLogEvents: {
          input: {
            type: "structure",
            required: [
              "logGroupName"
            ],
            members: {
              logGroupName: {},
              logStreamNames: {
                type: "list",
                member: {}
              },
              logStreamNamePrefix: {},
              startTime: {
                type: "long"
              },
              endTime: {
                type: "long"
              },
              filterPattern: {},
              nextToken: {},
              limit: {
                type: "integer"
              },
              interleaved: {
                deprecated: true,
                deprecatedMessage: "Starting on June 17, 2019, this parameter will be ignored and the value will be assumed to be true. The response from this operation will always interleave events from multiple log streams within a log group.",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    logStreamName: {},
                    timestamp: {
                      type: "long"
                    },
                    message: {},
                    ingestionTime: {
                      type: "long"
                    },
                    eventId: {}
                  }
                }
              },
              searchedLogStreams: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    logStreamName: {},
                    searchedCompletely: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetLogEvents: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "logStreamName"
            ],
            members: {
              logGroupName: {},
              logStreamName: {},
              startTime: {
                type: "long"
              },
              endTime: {
                type: "long"
              },
              nextToken: {},
              limit: {
                type: "integer"
              },
              startFromHead: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    timestamp: {
                      type: "long"
                    },
                    message: {},
                    ingestionTime: {
                      type: "long"
                    }
                  }
                }
              },
              nextForwardToken: {},
              nextBackwardToken: {}
            }
          }
        },
        GetLogGroupFields: {
          input: {
            type: "structure",
            required: [
              "logGroupName"
            ],
            members: {
              logGroupName: {},
              time: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              logGroupFields: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    percent: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        GetLogRecord: {
          input: {
            type: "structure",
            required: [
              "logRecordPointer"
            ],
            members: {
              logRecordPointer: {}
            }
          },
          output: {
            type: "structure",
            members: {
              logRecord: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        GetQueryResults: {
          input: {
            type: "structure",
            required: [
              "queryId"
            ],
            members: {
              queryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              results: {
                type: "list",
                member: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      field: {},
                      value: {}
                    }
                  }
                }
              },
              statistics: {
                type: "structure",
                members: {
                  recordsMatched: {
                    type: "double"
                  },
                  recordsScanned: {
                    type: "double"
                  },
                  bytesScanned: {
                    type: "double"
                  }
                }
              },
              status: {}
            }
          }
        },
        ListTagsLogGroup: {
          input: {
            type: "structure",
            required: [
              "logGroupName"
            ],
            members: {
              logGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Se"
              }
            }
          }
        },
        PutDestination: {
          input: {
            type: "structure",
            required: [
              "destinationName",
              "targetArn",
              "roleArn"
            ],
            members: {
              destinationName: {},
              targetArn: {},
              roleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              destination: {
                shape: "S11"
              }
            }
          }
        },
        PutDestinationPolicy: {
          input: {
            type: "structure",
            required: [
              "destinationName",
              "accessPolicy"
            ],
            members: {
              destinationName: {},
              accessPolicy: {}
            }
          }
        },
        PutLogEvents: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "logStreamName",
              "logEvents"
            ],
            members: {
              logGroupName: {},
              logStreamName: {},
              logEvents: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "timestamp",
                    "message"
                  ],
                  members: {
                    timestamp: {
                      type: "long"
                    },
                    message: {}
                  }
                }
              },
              sequenceToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextSequenceToken: {},
              rejectedLogEventsInfo: {
                type: "structure",
                members: {
                  tooNewLogEventStartIndex: {
                    type: "integer"
                  },
                  tooOldLogEventEndIndex: {
                    type: "integer"
                  },
                  expiredLogEventEndIndex: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        PutMetricFilter: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "filterName",
              "filterPattern",
              "metricTransformations"
            ],
            members: {
              logGroupName: {},
              filterName: {},
              filterPattern: {},
              metricTransformations: {
                shape: "S1z"
              }
            }
          }
        },
        PutQueryDefinition: {
          input: {
            type: "structure",
            required: [
              "name",
              "queryString"
            ],
            members: {
              name: {},
              queryDefinitionId: {},
              logGroupNames: {
                shape: "S2l"
              },
              queryString: {}
            }
          },
          output: {
            type: "structure",
            members: {
              queryDefinitionId: {}
            }
          }
        },
        PutResourcePolicy: {
          input: {
            type: "structure",
            members: {
              policyName: {},
              policyDocument: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourcePolicy: {
                shape: "S2p"
              }
            }
          }
        },
        PutRetentionPolicy: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "retentionInDays"
            ],
            members: {
              logGroupName: {},
              retentionInDays: {
                type: "integer"
              }
            }
          }
        },
        PutSubscriptionFilter: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "filterName",
              "filterPattern",
              "destinationArn"
            ],
            members: {
              logGroupName: {},
              filterName: {},
              filterPattern: {},
              destinationArn: {},
              roleArn: {},
              distribution: {}
            }
          }
        },
        StartQuery: {
          input: {
            type: "structure",
            required: [
              "startTime",
              "endTime",
              "queryString"
            ],
            members: {
              logGroupName: {},
              logGroupNames: {
                shape: "S2l"
              },
              startTime: {
                type: "long"
              },
              endTime: {
                type: "long"
              },
              queryString: {},
              limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              queryId: {}
            }
          }
        },
        StopQuery: {
          input: {
            type: "structure",
            required: [
              "queryId"
            ],
            members: {
              queryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              success: {
                type: "boolean"
              }
            }
          }
        },
        TagLogGroup: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "tags"
            ],
            members: {
              logGroupName: {},
              tags: {
                shape: "Se"
              }
            }
          }
        },
        TestMetricFilter: {
          input: {
            type: "structure",
            required: [
              "filterPattern",
              "logEventMessages"
            ],
            members: {
              filterPattern: {},
              logEventMessages: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              matches: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    eventNumber: {
                      type: "long"
                    },
                    eventMessage: {},
                    extractedValues: {
                      type: "map",
                      key: {},
                      value: {}
                    }
                  }
                }
              }
            }
          }
        },
        UntagLogGroup: {
          input: {
            type: "structure",
            required: [
              "logGroupName",
              "tags"
            ],
            members: {
              logGroupName: {},
              tags: {
                type: "list",
                member: {}
              }
            }
          }
        }
      },
      shapes: {
        Se: {
          type: "map",
          key: {},
          value: {}
        },
        S11: {
          type: "structure",
          members: {
            destinationName: {},
            targetArn: {},
            roleArn: {},
            accessPolicy: {},
            arn: {},
            creationTime: {
              type: "long"
            }
          }
        },
        S1z: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "metricName",
              "metricNamespace",
              "metricValue"
            ],
            members: {
              metricName: {},
              metricNamespace: {},
              metricValue: {},
              defaultValue: {
                type: "double"
              },
              dimensions: {
                type: "map",
                key: {},
                value: {}
              },
              unit: {}
            }
          }
        },
        S2l: {
          type: "list",
          member: {}
        },
        S2p: {
          type: "structure",
          members: {
            policyName: {},
            policyDocument: {},
            lastUpdatedTime: {
              type: "long"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/logs-2014-03-28.paginators.json
var require_logs_2014_03_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/logs-2014-03-28.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeDestinations: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "destinations"
        },
        DescribeLogGroups: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "logGroups"
        },
        DescribeLogStreams: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "logStreams"
        },
        DescribeMetricFilters: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "metricFilters"
        },
        DescribeSubscriptionFilters: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "subscriptionFilters"
        },
        FilterLogEvents: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: [
            "events",
            "searchedLogStreams"
          ]
        },
        GetLogEvents: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextForwardToken",
          result_key: "events"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cloudwatchlogs.js
var require_cloudwatchlogs = __commonJS({
  "node_modules/aws-sdk/clients/cloudwatchlogs.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["cloudwatchlogs"] = {};
    AWS3.CloudWatchLogs = Service.defineService("cloudwatchlogs", ["2014-03-28"]);
    Object.defineProperty(apiLoader.services["cloudwatchlogs"], "2014-03-28", {
      get: function get() {
        var model = require_logs_2014_03_28_min();
        model.paginators = require_logs_2014_03_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CloudWatchLogs;
  }
});

// node_modules/aws-sdk/apis/codebuild-2016-10-06.min.json
var require_codebuild_2016_10_06_min = __commonJS({
  "node_modules/aws-sdk/apis/codebuild-2016-10-06.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-10-06",
        endpointPrefix: "codebuild",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS CodeBuild",
        serviceId: "CodeBuild",
        signatureVersion: "v4",
        targetPrefix: "CodeBuild_20161006",
        uid: "codebuild-2016-10-06"
      },
      operations: {
        BatchDeleteBuilds: {
          input: {
            type: "structure",
            required: [
              "ids"
            ],
            members: {
              ids: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              buildsDeleted: {
                shape: "S2"
              },
              buildsNotDeleted: {
                shape: "S5"
              }
            }
          }
        },
        BatchGetBuildBatches: {
          input: {
            type: "structure",
            required: [
              "ids"
            ],
            members: {
              ids: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              buildBatches: {
                type: "list",
                member: {
                  shape: "Sc"
                }
              },
              buildBatchesNotFound: {
                shape: "S9"
              }
            }
          }
        },
        BatchGetBuilds: {
          input: {
            type: "structure",
            required: [
              "ids"
            ],
            members: {
              ids: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              builds: {
                type: "list",
                member: {
                  shape: "S23"
                }
              },
              buildsNotFound: {
                shape: "S2"
              }
            }
          }
        },
        BatchGetProjects: {
          input: {
            type: "structure",
            required: [
              "names"
            ],
            members: {
              names: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              projects: {
                type: "list",
                member: {
                  shape: "S2h"
                }
              },
              projectsNotFound: {
                shape: "S2e"
              }
            }
          }
        },
        BatchGetReportGroups: {
          input: {
            type: "structure",
            required: [
              "reportGroupArns"
            ],
            members: {
              reportGroupArns: {
                shape: "S32"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              reportGroups: {
                type: "list",
                member: {
                  shape: "S35"
                }
              },
              reportGroupsNotFound: {
                shape: "S32"
              }
            }
          }
        },
        BatchGetReports: {
          input: {
            type: "structure",
            required: [
              "reportArns"
            ],
            members: {
              reportArns: {
                shape: "S3e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              reports: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    type: {},
                    name: {},
                    reportGroupArn: {},
                    executionId: {},
                    status: {},
                    created: {
                      type: "timestamp"
                    },
                    expired: {
                      type: "timestamp"
                    },
                    exportConfig: {
                      shape: "S38"
                    },
                    truncated: {
                      type: "boolean"
                    },
                    testSummary: {
                      type: "structure",
                      required: [
                        "total",
                        "statusCounts",
                        "durationInNanoSeconds"
                      ],
                      members: {
                        total: {
                          type: "integer"
                        },
                        statusCounts: {
                          type: "map",
                          key: {},
                          value: {
                            type: "integer"
                          }
                        },
                        durationInNanoSeconds: {
                          type: "long"
                        }
                      }
                    },
                    codeCoverageSummary: {
                      type: "structure",
                      members: {
                        lineCoveragePercentage: {
                          type: "double"
                        },
                        linesCovered: {
                          type: "integer"
                        },
                        linesMissed: {
                          type: "integer"
                        },
                        branchCoveragePercentage: {
                          type: "double"
                        },
                        branchesCovered: {
                          type: "integer"
                        },
                        branchesMissed: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              },
              reportsNotFound: {
                shape: "S3e"
              }
            }
          }
        },
        CreateProject: {
          input: {
            type: "structure",
            required: [
              "name",
              "source",
              "artifacts",
              "environment",
              "serviceRole"
            ],
            members: {
              name: {},
              description: {},
              source: {
                shape: "Sl"
              },
              secondarySources: {
                shape: "St"
              },
              sourceVersion: {},
              secondarySourceVersions: {
                shape: "Su"
              },
              artifacts: {
                shape: "S2k"
              },
              secondaryArtifacts: {
                shape: "S2n"
              },
              cache: {
                shape: "Sz"
              },
              environment: {
                shape: "S13"
              },
              serviceRole: {},
              timeoutInMinutes: {
                type: "integer"
              },
              queuedTimeoutInMinutes: {
                type: "integer"
              },
              encryptionKey: {},
              tags: {
                shape: "S2p"
              },
              vpcConfig: {
                shape: "S1i"
              },
              badgeEnabled: {
                type: "boolean"
              },
              logsConfig: {
                shape: "S1c"
              },
              fileSystemLocations: {
                shape: "S1l"
              },
              buildBatchConfig: {
                shape: "S1o"
              },
              concurrentBuildLimit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              project: {
                shape: "S2h"
              }
            }
          }
        },
        CreateReportGroup: {
          input: {
            type: "structure",
            required: [
              "name",
              "type",
              "exportConfig"
            ],
            members: {
              name: {},
              type: {},
              exportConfig: {
                shape: "S38"
              },
              tags: {
                shape: "S2p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              reportGroup: {
                shape: "S35"
              }
            }
          }
        },
        CreateWebhook: {
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {},
              branchFilter: {},
              filterGroups: {
                shape: "S2u"
              },
              buildType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              webhook: {
                shape: "S2t"
              }
            }
          }
        },
        DeleteBuildBatch: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              statusCode: {},
              buildsDeleted: {
                shape: "S2"
              },
              buildsNotDeleted: {
                shape: "S5"
              }
            }
          }
        },
        DeleteProject: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteReport: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteReportGroup: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              deleteReports: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSourceCredentials: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {}
            }
          }
        },
        DeleteWebhook: {
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeCodeCoverages: {
          input: {
            type: "structure",
            required: [
              "reportArn"
            ],
            members: {
              reportArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              sortOrder: {},
              sortBy: {},
              minLineCoveragePercentage: {
                type: "double"
              },
              maxLineCoveragePercentage: {
                type: "double"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              codeCoverages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    reportARN: {},
                    filePath: {},
                    lineCoveragePercentage: {
                      type: "double"
                    },
                    linesCovered: {
                      type: "integer"
                    },
                    linesMissed: {
                      type: "integer"
                    },
                    branchCoveragePercentage: {
                      type: "double"
                    },
                    branchesCovered: {
                      type: "integer"
                    },
                    branchesMissed: {
                      type: "integer"
                    },
                    expired: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeTestCases: {
          input: {
            type: "structure",
            required: [
              "reportArn"
            ],
            members: {
              reportArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filter: {
                type: "structure",
                members: {
                  status: {},
                  keyword: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              testCases: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    reportArn: {},
                    testRawDataPath: {},
                    prefix: {},
                    name: {},
                    status: {},
                    durationInNanoSeconds: {
                      type: "long"
                    },
                    message: {},
                    expired: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        GetReportGroupTrend: {
          input: {
            type: "structure",
            required: [
              "reportGroupArn",
              "trendField"
            ],
            members: {
              reportGroupArn: {},
              numOfReports: {
                type: "integer"
              },
              trendField: {}
            }
          },
          output: {
            type: "structure",
            members: {
              stats: {
                type: "structure",
                members: {
                  average: {},
                  max: {},
                  min: {}
                }
              },
              rawData: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    reportArn: {},
                    data: {}
                  }
                }
              }
            }
          }
        },
        GetResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              policy: {}
            }
          }
        },
        ImportSourceCredentials: {
          input: {
            type: "structure",
            required: [
              "token",
              "serverType",
              "authType"
            ],
            members: {
              username: {},
              token: {
                type: "string",
                sensitive: true
              },
              serverType: {},
              authType: {},
              shouldOverwrite: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {}
            }
          }
        },
        InvalidateProjectCache: {
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListBuildBatches: {
          input: {
            type: "structure",
            members: {
              filter: {
                shape: "S50"
              },
              maxResults: {
                type: "integer"
              },
              sortOrder: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ids: {
                shape: "S9"
              },
              nextToken: {}
            }
          }
        },
        ListBuildBatchesForProject: {
          input: {
            type: "structure",
            members: {
              projectName: {},
              filter: {
                shape: "S50"
              },
              maxResults: {
                type: "integer"
              },
              sortOrder: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ids: {
                shape: "S9"
              },
              nextToken: {}
            }
          }
        },
        ListBuilds: {
          input: {
            type: "structure",
            members: {
              sortOrder: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ids: {
                shape: "S2"
              },
              nextToken: {}
            }
          }
        },
        ListBuildsForProject: {
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {},
              sortOrder: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ids: {
                shape: "S2"
              },
              nextToken: {}
            }
          }
        },
        ListCuratedEnvironmentImages: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              platforms: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    platform: {},
                    languages: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          language: {},
                          images: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                name: {},
                                description: {},
                                versions: {
                                  type: "list",
                                  member: {}
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListProjects: {
          input: {
            type: "structure",
            members: {
              sortBy: {},
              sortOrder: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              projects: {
                shape: "S2e"
              }
            }
          }
        },
        ListReportGroups: {
          input: {
            type: "structure",
            members: {
              sortOrder: {},
              sortBy: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              reportGroups: {
                shape: "S32"
              }
            }
          }
        },
        ListReports: {
          input: {
            type: "structure",
            members: {
              sortOrder: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filter: {
                shape: "S5q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              reports: {
                shape: "S3e"
              }
            }
          }
        },
        ListReportsForReportGroup: {
          input: {
            type: "structure",
            required: [
              "reportGroupArn"
            ],
            members: {
              reportGroupArn: {},
              nextToken: {},
              sortOrder: {},
              maxResults: {
                type: "integer"
              },
              filter: {
                shape: "S5q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              reports: {
                shape: "S3e"
              }
            }
          }
        },
        ListSharedProjects: {
          input: {
            type: "structure",
            members: {
              sortBy: {},
              sortOrder: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              projects: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListSharedReportGroups: {
          input: {
            type: "structure",
            members: {
              sortOrder: {},
              sortBy: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              reportGroups: {
                shape: "S32"
              }
            }
          }
        },
        ListSourceCredentials: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              sourceCredentialsInfos: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    serverType: {},
                    authType: {}
                  }
                }
              }
            }
          }
        },
        PutResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "policy",
              "resourceArn"
            ],
            members: {
              policy: {},
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceArn: {}
            }
          }
        },
        RetryBuild: {
          input: {
            type: "structure",
            members: {
              id: {},
              idempotencyToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              build: {
                shape: "S23"
              }
            }
          }
        },
        RetryBuildBatch: {
          input: {
            type: "structure",
            members: {
              id: {},
              idempotencyToken: {},
              retryType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              buildBatch: {
                shape: "Sc"
              }
            }
          }
        },
        StartBuild: {
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {},
              secondarySourcesOverride: {
                shape: "St"
              },
              secondarySourcesVersionOverride: {
                shape: "Su"
              },
              sourceVersion: {},
              artifactsOverride: {
                shape: "S2k"
              },
              secondaryArtifactsOverride: {
                shape: "S2n"
              },
              environmentVariablesOverride: {
                shape: "S16"
              },
              sourceTypeOverride: {},
              sourceLocationOverride: {},
              sourceAuthOverride: {
                shape: "Sq"
              },
              gitCloneDepthOverride: {
                type: "integer"
              },
              gitSubmodulesConfigOverride: {
                shape: "So"
              },
              buildspecOverride: {},
              insecureSslOverride: {
                type: "boolean"
              },
              reportBuildStatusOverride: {
                type: "boolean"
              },
              buildStatusConfigOverride: {
                shape: "Ss"
              },
              environmentTypeOverride: {},
              imageOverride: {},
              computeTypeOverride: {},
              certificateOverride: {},
              cacheOverride: {
                shape: "Sz"
              },
              serviceRoleOverride: {},
              privilegedModeOverride: {
                type: "boolean"
              },
              timeoutInMinutesOverride: {
                type: "integer"
              },
              queuedTimeoutInMinutesOverride: {
                type: "integer"
              },
              encryptionKeyOverride: {},
              idempotencyToken: {},
              logsConfigOverride: {
                shape: "S1c"
              },
              registryCredentialOverride: {
                shape: "S19"
              },
              imagePullCredentialsTypeOverride: {},
              debugSessionEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              build: {
                shape: "S23"
              }
            }
          }
        },
        StartBuildBatch: {
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {},
              secondarySourcesOverride: {
                shape: "St"
              },
              secondarySourcesVersionOverride: {
                shape: "Su"
              },
              sourceVersion: {},
              artifactsOverride: {
                shape: "S2k"
              },
              secondaryArtifactsOverride: {
                shape: "S2n"
              },
              environmentVariablesOverride: {
                shape: "S16"
              },
              sourceTypeOverride: {},
              sourceLocationOverride: {},
              sourceAuthOverride: {
                shape: "Sq"
              },
              gitCloneDepthOverride: {
                type: "integer"
              },
              gitSubmodulesConfigOverride: {
                shape: "So"
              },
              buildspecOverride: {},
              insecureSslOverride: {
                type: "boolean"
              },
              reportBuildBatchStatusOverride: {
                type: "boolean"
              },
              environmentTypeOverride: {},
              imageOverride: {},
              computeTypeOverride: {},
              certificateOverride: {},
              cacheOverride: {
                shape: "Sz"
              },
              serviceRoleOverride: {},
              privilegedModeOverride: {
                type: "boolean"
              },
              buildTimeoutInMinutesOverride: {
                type: "integer"
              },
              queuedTimeoutInMinutesOverride: {
                type: "integer"
              },
              encryptionKeyOverride: {},
              idempotencyToken: {},
              logsConfigOverride: {
                shape: "S1c"
              },
              registryCredentialOverride: {
                shape: "S19"
              },
              imagePullCredentialsTypeOverride: {},
              buildBatchConfigOverride: {
                shape: "S1o"
              },
              debugSessionEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              buildBatch: {
                shape: "Sc"
              }
            }
          }
        },
        StopBuild: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              build: {
                shape: "S23"
              }
            }
          }
        },
        StopBuildBatch: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              buildBatch: {
                shape: "Sc"
              }
            }
          }
        },
        UpdateProject: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              source: {
                shape: "Sl"
              },
              secondarySources: {
                shape: "St"
              },
              sourceVersion: {},
              secondarySourceVersions: {
                shape: "Su"
              },
              artifacts: {
                shape: "S2k"
              },
              secondaryArtifacts: {
                shape: "S2n"
              },
              cache: {
                shape: "Sz"
              },
              environment: {
                shape: "S13"
              },
              serviceRole: {},
              timeoutInMinutes: {
                type: "integer"
              },
              queuedTimeoutInMinutes: {
                type: "integer"
              },
              encryptionKey: {},
              tags: {
                shape: "S2p"
              },
              vpcConfig: {
                shape: "S1i"
              },
              badgeEnabled: {
                type: "boolean"
              },
              logsConfig: {
                shape: "S1c"
              },
              fileSystemLocations: {
                shape: "S1l"
              },
              buildBatchConfig: {
                shape: "S1o"
              },
              concurrentBuildLimit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              project: {
                shape: "S2h"
              }
            }
          }
        },
        UpdateProjectVisibility: {
          input: {
            type: "structure",
            required: [
              "projectArn",
              "projectVisibility"
            ],
            members: {
              projectArn: {},
              projectVisibility: {},
              resourceAccessRole: {}
            }
          },
          output: {
            type: "structure",
            members: {
              projectArn: {},
              publicProjectAlias: {},
              projectVisibility: {}
            }
          }
        },
        UpdateReportGroup: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              exportConfig: {
                shape: "S38"
              },
              tags: {
                shape: "S2p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              reportGroup: {
                shape: "S35"
              }
            }
          }
        },
        UpdateWebhook: {
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {},
              branchFilter: {},
              rotateSecret: {
                type: "boolean"
              },
              filterGroups: {
                shape: "S2u"
              },
              buildType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              webhook: {
                shape: "S2t"
              }
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {}
        },
        S5: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              statusCode: {}
            }
          }
        },
        S9: {
          type: "list",
          member: {}
        },
        Sc: {
          type: "structure",
          members: {
            id: {},
            arn: {},
            startTime: {
              type: "timestamp"
            },
            endTime: {
              type: "timestamp"
            },
            currentPhase: {},
            buildBatchStatus: {},
            sourceVersion: {},
            resolvedSourceVersion: {},
            projectName: {},
            phases: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  phaseType: {},
                  phaseStatus: {},
                  startTime: {
                    type: "timestamp"
                  },
                  endTime: {
                    type: "timestamp"
                  },
                  durationInSeconds: {
                    type: "long"
                  },
                  contexts: {
                    shape: "Sj"
                  }
                }
              }
            },
            source: {
              shape: "Sl"
            },
            secondarySources: {
              shape: "St"
            },
            secondarySourceVersions: {
              shape: "Su"
            },
            artifacts: {
              shape: "Sw"
            },
            secondaryArtifacts: {
              shape: "Sy"
            },
            cache: {
              shape: "Sz"
            },
            environment: {
              shape: "S13"
            },
            serviceRole: {},
            logConfig: {
              shape: "S1c"
            },
            buildTimeoutInMinutes: {
              type: "integer"
            },
            queuedTimeoutInMinutes: {
              type: "integer"
            },
            complete: {
              type: "boolean"
            },
            initiator: {},
            vpcConfig: {
              shape: "S1i"
            },
            encryptionKey: {},
            buildBatchNumber: {
              type: "long"
            },
            fileSystemLocations: {
              shape: "S1l"
            },
            buildBatchConfig: {
              shape: "S1o"
            },
            buildGroups: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  identifier: {},
                  dependsOn: {
                    type: "list",
                    member: {}
                  },
                  ignoreFailure: {
                    type: "boolean"
                  },
                  currentBuildSummary: {
                    shape: "S1v"
                  },
                  priorBuildSummaryList: {
                    type: "list",
                    member: {
                      shape: "S1v"
                    }
                  }
                }
              }
            },
            debugSessionEnabled: {
              type: "boolean"
            }
          }
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            members: {
              statusCode: {},
              message: {}
            }
          }
        },
        Sl: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            location: {},
            gitCloneDepth: {
              type: "integer"
            },
            gitSubmodulesConfig: {
              shape: "So"
            },
            buildspec: {},
            auth: {
              shape: "Sq"
            },
            reportBuildStatus: {
              type: "boolean"
            },
            buildStatusConfig: {
              shape: "Ss"
            },
            insecureSsl: {
              type: "boolean"
            },
            sourceIdentifier: {}
          }
        },
        So: {
          type: "structure",
          required: [
            "fetchSubmodules"
          ],
          members: {
            fetchSubmodules: {
              type: "boolean"
            }
          }
        },
        Sq: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            resource: {}
          }
        },
        Ss: {
          type: "structure",
          members: {
            context: {},
            targetUrl: {}
          }
        },
        St: {
          type: "list",
          member: {
            shape: "Sl"
          }
        },
        Su: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "sourceIdentifier",
              "sourceVersion"
            ],
            members: {
              sourceIdentifier: {},
              sourceVersion: {}
            }
          }
        },
        Sw: {
          type: "structure",
          members: {
            location: {},
            sha256sum: {},
            md5sum: {},
            overrideArtifactName: {
              type: "boolean"
            },
            encryptionDisabled: {
              type: "boolean"
            },
            artifactIdentifier: {},
            bucketOwnerAccess: {}
          }
        },
        Sy: {
          type: "list",
          member: {
            shape: "Sw"
          }
        },
        Sz: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            location: {},
            modes: {
              type: "list",
              member: {}
            }
          }
        },
        S13: {
          type: "structure",
          required: [
            "type",
            "image",
            "computeType"
          ],
          members: {
            type: {},
            image: {},
            computeType: {},
            environmentVariables: {
              shape: "S16"
            },
            privilegedMode: {
              type: "boolean"
            },
            certificate: {},
            registryCredential: {
              shape: "S19"
            },
            imagePullCredentialsType: {}
          }
        },
        S16: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "value"
            ],
            members: {
              name: {},
              value: {},
              type: {}
            }
          }
        },
        S19: {
          type: "structure",
          required: [
            "credential",
            "credentialProvider"
          ],
          members: {
            credential: {},
            credentialProvider: {}
          }
        },
        S1c: {
          type: "structure",
          members: {
            cloudWatchLogs: {
              shape: "S1d"
            },
            s3Logs: {
              shape: "S1f"
            }
          }
        },
        S1d: {
          type: "structure",
          required: [
            "status"
          ],
          members: {
            status: {},
            groupName: {},
            streamName: {}
          }
        },
        S1f: {
          type: "structure",
          required: [
            "status"
          ],
          members: {
            status: {},
            location: {},
            encryptionDisabled: {
              type: "boolean"
            },
            bucketOwnerAccess: {}
          }
        },
        S1i: {
          type: "structure",
          members: {
            vpcId: {},
            subnets: {
              type: "list",
              member: {}
            },
            securityGroupIds: {
              type: "list",
              member: {}
            }
          }
        },
        S1l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              type: {},
              location: {},
              mountPoint: {},
              identifier: {},
              mountOptions: {}
            }
          }
        },
        S1o: {
          type: "structure",
          members: {
            serviceRole: {},
            combineArtifacts: {
              type: "boolean"
            },
            restrictions: {
              type: "structure",
              members: {
                maximumBuildsAllowed: {
                  type: "integer"
                },
                computeTypesAllowed: {
                  type: "list",
                  member: {}
                }
              }
            },
            timeoutInMins: {
              type: "integer"
            },
            batchReportMode: {}
          }
        },
        S1v: {
          type: "structure",
          members: {
            arn: {},
            requestedOn: {
              type: "timestamp"
            },
            buildStatus: {},
            primaryArtifact: {
              shape: "S1w"
            },
            secondaryArtifacts: {
              type: "list",
              member: {
                shape: "S1w"
              }
            }
          }
        },
        S1w: {
          type: "structure",
          members: {
            type: {},
            location: {},
            identifier: {}
          }
        },
        S23: {
          type: "structure",
          members: {
            id: {},
            arn: {},
            buildNumber: {
              type: "long"
            },
            startTime: {
              type: "timestamp"
            },
            endTime: {
              type: "timestamp"
            },
            currentPhase: {},
            buildStatus: {},
            sourceVersion: {},
            resolvedSourceVersion: {},
            projectName: {},
            phases: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  phaseType: {},
                  phaseStatus: {},
                  startTime: {
                    type: "timestamp"
                  },
                  endTime: {
                    type: "timestamp"
                  },
                  durationInSeconds: {
                    type: "long"
                  },
                  contexts: {
                    shape: "Sj"
                  }
                }
              }
            },
            source: {
              shape: "Sl"
            },
            secondarySources: {
              shape: "St"
            },
            secondarySourceVersions: {
              shape: "Su"
            },
            artifacts: {
              shape: "Sw"
            },
            secondaryArtifacts: {
              shape: "Sy"
            },
            cache: {
              shape: "Sz"
            },
            environment: {
              shape: "S13"
            },
            serviceRole: {},
            logs: {
              type: "structure",
              members: {
                groupName: {},
                streamName: {},
                deepLink: {},
                s3DeepLink: {},
                cloudWatchLogsArn: {},
                s3LogsArn: {},
                cloudWatchLogs: {
                  shape: "S1d"
                },
                s3Logs: {
                  shape: "S1f"
                }
              }
            },
            timeoutInMinutes: {
              type: "integer"
            },
            queuedTimeoutInMinutes: {
              type: "integer"
            },
            buildComplete: {
              type: "boolean"
            },
            initiator: {},
            vpcConfig: {
              shape: "S1i"
            },
            networkInterface: {
              type: "structure",
              members: {
                subnetId: {},
                networkInterfaceId: {}
              }
            },
            encryptionKey: {},
            exportedEnvironmentVariables: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  name: {},
                  value: {}
                }
              }
            },
            reportArns: {
              type: "list",
              member: {}
            },
            fileSystemLocations: {
              shape: "S1l"
            },
            debugSession: {
              type: "structure",
              members: {
                sessionEnabled: {
                  type: "boolean"
                },
                sessionTarget: {}
              }
            },
            buildBatchArn: {}
          }
        },
        S2e: {
          type: "list",
          member: {}
        },
        S2h: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            description: {},
            source: {
              shape: "Sl"
            },
            secondarySources: {
              shape: "St"
            },
            sourceVersion: {},
            secondarySourceVersions: {
              shape: "Su"
            },
            artifacts: {
              shape: "S2k"
            },
            secondaryArtifacts: {
              shape: "S2n"
            },
            cache: {
              shape: "Sz"
            },
            environment: {
              shape: "S13"
            },
            serviceRole: {},
            timeoutInMinutes: {
              type: "integer"
            },
            queuedTimeoutInMinutes: {
              type: "integer"
            },
            encryptionKey: {},
            tags: {
              shape: "S2p"
            },
            created: {
              type: "timestamp"
            },
            lastModified: {
              type: "timestamp"
            },
            webhook: {
              shape: "S2t"
            },
            vpcConfig: {
              shape: "S1i"
            },
            badge: {
              type: "structure",
              members: {
                badgeEnabled: {
                  type: "boolean"
                },
                badgeRequestUrl: {}
              }
            },
            logsConfig: {
              shape: "S1c"
            },
            fileSystemLocations: {
              shape: "S1l"
            },
            buildBatchConfig: {
              shape: "S1o"
            },
            concurrentBuildLimit: {
              type: "integer"
            },
            projectVisibility: {},
            publicProjectAlias: {},
            resourceAccessRole: {}
          }
        },
        S2k: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            location: {},
            path: {},
            namespaceType: {},
            name: {},
            packaging: {},
            overrideArtifactName: {
              type: "boolean"
            },
            encryptionDisabled: {
              type: "boolean"
            },
            artifactIdentifier: {},
            bucketOwnerAccess: {}
          }
        },
        S2n: {
          type: "list",
          member: {
            shape: "S2k"
          }
        },
        S2p: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {}
            }
          }
        },
        S2t: {
          type: "structure",
          members: {
            url: {},
            payloadUrl: {},
            secret: {},
            branchFilter: {},
            filterGroups: {
              shape: "S2u"
            },
            buildType: {},
            lastModifiedSecret: {
              type: "timestamp"
            }
          }
        },
        S2u: {
          type: "list",
          member: {
            type: "list",
            member: {
              type: "structure",
              required: [
                "type",
                "pattern"
              ],
              members: {
                type: {},
                pattern: {},
                excludeMatchedPattern: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S32: {
          type: "list",
          member: {}
        },
        S35: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            type: {},
            exportConfig: {
              shape: "S38"
            },
            created: {
              type: "timestamp"
            },
            lastModified: {
              type: "timestamp"
            },
            tags: {
              shape: "S2p"
            },
            status: {}
          }
        },
        S38: {
          type: "structure",
          members: {
            exportConfigType: {},
            s3Destination: {
              type: "structure",
              members: {
                bucket: {},
                bucketOwner: {},
                path: {},
                packaging: {},
                encryptionKey: {},
                encryptionDisabled: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S3e: {
          type: "list",
          member: {}
        },
        S50: {
          type: "structure",
          members: {
            status: {}
          }
        },
        S5q: {
          type: "structure",
          members: {
            status: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codebuild-2016-10-06.paginators.json
var require_codebuild_2016_10_06_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codebuild-2016-10-06.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeCodeCoverages: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "codeCoverages"
        },
        DescribeTestCases: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "testCases"
        },
        ListBuildBatches: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "ids"
        },
        ListBuildBatchesForProject: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "ids"
        },
        ListBuilds: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "ids"
        },
        ListBuildsForProject: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "ids"
        },
        ListProjects: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "projects"
        },
        ListReportGroups: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "reportGroups"
        },
        ListReports: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "reports"
        },
        ListReportsForReportGroup: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "reports"
        },
        ListSharedProjects: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "projects"
        },
        ListSharedReportGroups: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "reportGroups"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/codebuild.js
var require_codebuild = __commonJS({
  "node_modules/aws-sdk/clients/codebuild.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["codebuild"] = {};
    AWS3.CodeBuild = Service.defineService("codebuild", ["2016-10-06"]);
    Object.defineProperty(apiLoader.services["codebuild"], "2016-10-06", {
      get: function get() {
        var model = require_codebuild_2016_10_06_min();
        model.paginators = require_codebuild_2016_10_06_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CodeBuild;
  }
});

// node_modules/aws-sdk/apis/codecommit-2015-04-13.min.json
var require_codecommit_2015_04_13_min = __commonJS({
  "node_modules/aws-sdk/apis/codecommit-2015-04-13.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-04-13",
        endpointPrefix: "codecommit",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "CodeCommit",
        serviceFullName: "AWS CodeCommit",
        serviceId: "CodeCommit",
        signatureVersion: "v4",
        targetPrefix: "CodeCommit_20150413",
        uid: "codecommit-2015-04-13"
      },
      operations: {
        AssociateApprovalRuleTemplateWithRepository: {
          input: {
            type: "structure",
            required: [
              "approvalRuleTemplateName",
              "repositoryName"
            ],
            members: {
              approvalRuleTemplateName: {},
              repositoryName: {}
            }
          }
        },
        BatchAssociateApprovalRuleTemplateWithRepositories: {
          input: {
            type: "structure",
            required: [
              "approvalRuleTemplateName",
              "repositoryNames"
            ],
            members: {
              approvalRuleTemplateName: {},
              repositoryNames: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "associatedRepositoryNames",
              "errors"
            ],
            members: {
              associatedRepositoryNames: {
                shape: "S5"
              },
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    repositoryName: {},
                    errorCode: {},
                    errorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchDescribeMergeConflicts: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "destinationCommitSpecifier",
              "sourceCommitSpecifier",
              "mergeOption"
            ],
            members: {
              repositoryName: {},
              destinationCommitSpecifier: {},
              sourceCommitSpecifier: {},
              mergeOption: {},
              maxMergeHunks: {
                type: "integer"
              },
              maxConflictFiles: {
                type: "integer"
              },
              filePaths: {
                type: "list",
                member: {}
              },
              conflictDetailLevel: {},
              conflictResolutionStrategy: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "conflicts",
              "destinationCommitId",
              "sourceCommitId"
            ],
            members: {
              conflicts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    conflictMetadata: {
                      shape: "Sn"
                    },
                    mergeHunks: {
                      shape: "S12"
                    }
                  }
                }
              },
              nextToken: {},
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "filePath",
                    "exceptionName",
                    "message"
                  ],
                  members: {
                    filePath: {},
                    exceptionName: {},
                    message: {}
                  }
                }
              },
              destinationCommitId: {},
              sourceCommitId: {},
              baseCommitId: {}
            }
          }
        },
        BatchDisassociateApprovalRuleTemplateFromRepositories: {
          input: {
            type: "structure",
            required: [
              "approvalRuleTemplateName",
              "repositoryNames"
            ],
            members: {
              approvalRuleTemplateName: {},
              repositoryNames: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "disassociatedRepositoryNames",
              "errors"
            ],
            members: {
              disassociatedRepositoryNames: {
                shape: "S5"
              },
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    repositoryName: {},
                    errorCode: {},
                    errorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchGetCommits: {
          input: {
            type: "structure",
            required: [
              "commitIds",
              "repositoryName"
            ],
            members: {
              commitIds: {
                type: "list",
                member: {}
              },
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              commits: {
                type: "list",
                member: {
                  shape: "S1l"
                }
              },
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    commitId: {},
                    errorCode: {},
                    errorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchGetRepositories: {
          input: {
            type: "structure",
            required: [
              "repositoryNames"
            ],
            members: {
              repositoryNames: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repositories: {
                type: "list",
                member: {
                  shape: "S1x"
                }
              },
              repositoriesNotFound: {
                type: "list",
                member: {}
              }
            }
          }
        },
        CreateApprovalRuleTemplate: {
          input: {
            type: "structure",
            required: [
              "approvalRuleTemplateName",
              "approvalRuleTemplateContent"
            ],
            members: {
              approvalRuleTemplateName: {},
              approvalRuleTemplateContent: {},
              approvalRuleTemplateDescription: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "approvalRuleTemplate"
            ],
            members: {
              approvalRuleTemplate: {
                shape: "S2c"
              }
            }
          }
        },
        CreateBranch: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "branchName",
              "commitId"
            ],
            members: {
              repositoryName: {},
              branchName: {},
              commitId: {}
            }
          }
        },
        CreateCommit: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "branchName"
            ],
            members: {
              repositoryName: {},
              branchName: {},
              parentCommitId: {},
              authorName: {},
              email: {},
              commitMessage: {},
              keepEmptyFolders: {
                type: "boolean"
              },
              putFiles: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "filePath"
                  ],
                  members: {
                    filePath: {},
                    fileMode: {},
                    fileContent: {
                      type: "blob"
                    },
                    sourceFile: {
                      type: "structure",
                      required: [
                        "filePath"
                      ],
                      members: {
                        filePath: {},
                        isMove: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              },
              deleteFiles: {
                shape: "S2o"
              },
              setFileModes: {
                shape: "S2q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              commitId: {},
              treeId: {},
              filesAdded: {
                shape: "S2t"
              },
              filesUpdated: {
                shape: "S2t"
              },
              filesDeleted: {
                shape: "S2t"
              }
            }
          }
        },
        CreatePullRequest: {
          input: {
            type: "structure",
            required: [
              "title",
              "targets"
            ],
            members: {
              title: {},
              description: {},
              targets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "repositoryName",
                    "sourceReference"
                  ],
                  members: {
                    repositoryName: {},
                    sourceReference: {},
                    destinationReference: {}
                  }
                }
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "pullRequest"
            ],
            members: {
              pullRequest: {
                shape: "S33"
              }
            }
          }
        },
        CreatePullRequestApprovalRule: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "approvalRuleName",
              "approvalRuleContent"
            ],
            members: {
              pullRequestId: {},
              approvalRuleName: {},
              approvalRuleContent: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "approvalRule"
            ],
            members: {
              approvalRule: {
                shape: "S3c"
              }
            }
          }
        },
        CreateRepository: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {},
              repositoryDescription: {},
              tags: {
                shape: "S3k"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repositoryMetadata: {
                shape: "S1x"
              }
            }
          }
        },
        CreateUnreferencedMergeCommit: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "sourceCommitSpecifier",
              "destinationCommitSpecifier",
              "mergeOption"
            ],
            members: {
              repositoryName: {},
              sourceCommitSpecifier: {},
              destinationCommitSpecifier: {},
              mergeOption: {},
              conflictDetailLevel: {},
              conflictResolutionStrategy: {},
              authorName: {},
              email: {},
              commitMessage: {},
              keepEmptyFolders: {
                type: "boolean"
              },
              conflictResolution: {
                shape: "S3p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              commitId: {},
              treeId: {}
            }
          }
        },
        DeleteApprovalRuleTemplate: {
          input: {
            type: "structure",
            required: [
              "approvalRuleTemplateName"
            ],
            members: {
              approvalRuleTemplateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "approvalRuleTemplateId"
            ],
            members: {
              approvalRuleTemplateId: {}
            }
          }
        },
        DeleteBranch: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "branchName"
            ],
            members: {
              repositoryName: {},
              branchName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deletedBranch: {
                shape: "S3y"
              }
            }
          }
        },
        DeleteCommentContent: {
          input: {
            type: "structure",
            required: [
              "commentId"
            ],
            members: {
              commentId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              comment: {
                shape: "S42"
              }
            }
          }
        },
        DeleteFile: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "branchName",
              "filePath",
              "parentCommitId"
            ],
            members: {
              repositoryName: {},
              branchName: {},
              filePath: {},
              parentCommitId: {},
              keepEmptyFolders: {
                type: "boolean"
              },
              commitMessage: {},
              name: {},
              email: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "commitId",
              "blobId",
              "treeId",
              "filePath"
            ],
            members: {
              commitId: {},
              blobId: {},
              treeId: {},
              filePath: {}
            }
          }
        },
        DeletePullRequestApprovalRule: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "approvalRuleName"
            ],
            members: {
              pullRequestId: {},
              approvalRuleName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "approvalRuleId"
            ],
            members: {
              approvalRuleId: {}
            }
          }
        },
        DeleteRepository: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              repositoryId: {}
            }
          }
        },
        DescribeMergeConflicts: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "destinationCommitSpecifier",
              "sourceCommitSpecifier",
              "mergeOption",
              "filePath"
            ],
            members: {
              repositoryName: {},
              destinationCommitSpecifier: {},
              sourceCommitSpecifier: {},
              mergeOption: {},
              maxMergeHunks: {
                type: "integer"
              },
              filePath: {},
              conflictDetailLevel: {},
              conflictResolutionStrategy: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "conflictMetadata",
              "mergeHunks",
              "destinationCommitId",
              "sourceCommitId"
            ],
            members: {
              conflictMetadata: {
                shape: "Sn"
              },
              mergeHunks: {
                shape: "S12"
              },
              nextToken: {},
              destinationCommitId: {},
              sourceCommitId: {},
              baseCommitId: {}
            }
          }
        },
        DescribePullRequestEvents: {
          input: {
            type: "structure",
            required: [
              "pullRequestId"
            ],
            members: {
              pullRequestId: {},
              pullRequestEventType: {},
              actorArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "pullRequestEvents"
            ],
            members: {
              pullRequestEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    pullRequestId: {},
                    eventDate: {
                      type: "timestamp"
                    },
                    pullRequestEventType: {},
                    actorArn: {},
                    pullRequestCreatedEventMetadata: {
                      type: "structure",
                      members: {
                        repositoryName: {},
                        sourceCommitId: {},
                        destinationCommitId: {},
                        mergeBase: {}
                      }
                    },
                    pullRequestStatusChangedEventMetadata: {
                      type: "structure",
                      members: {
                        pullRequestStatus: {}
                      }
                    },
                    pullRequestSourceReferenceUpdatedEventMetadata: {
                      type: "structure",
                      members: {
                        repositoryName: {},
                        beforeCommitId: {},
                        afterCommitId: {},
                        mergeBase: {}
                      }
                    },
                    pullRequestMergedStateChangedEventMetadata: {
                      type: "structure",
                      members: {
                        repositoryName: {},
                        destinationReference: {},
                        mergeMetadata: {
                          shape: "S38"
                        }
                      }
                    },
                    approvalRuleEventMetadata: {
                      type: "structure",
                      members: {
                        approvalRuleName: {},
                        approvalRuleId: {},
                        approvalRuleContent: {}
                      }
                    },
                    approvalStateChangedEventMetadata: {
                      type: "structure",
                      members: {
                        revisionId: {},
                        approvalStatus: {}
                      }
                    },
                    approvalRuleOverriddenEventMetadata: {
                      type: "structure",
                      members: {
                        revisionId: {},
                        overrideStatus: {}
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DisassociateApprovalRuleTemplateFromRepository: {
          input: {
            type: "structure",
            required: [
              "approvalRuleTemplateName",
              "repositoryName"
            ],
            members: {
              approvalRuleTemplateName: {},
              repositoryName: {}
            }
          }
        },
        EvaluatePullRequestApprovalRules: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "revisionId"
            ],
            members: {
              pullRequestId: {},
              revisionId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "evaluation"
            ],
            members: {
              evaluation: {
                type: "structure",
                members: {
                  approved: {
                    type: "boolean"
                  },
                  overridden: {
                    type: "boolean"
                  },
                  approvalRulesSatisfied: {
                    type: "list",
                    member: {}
                  },
                  approvalRulesNotSatisfied: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        GetApprovalRuleTemplate: {
          input: {
            type: "structure",
            required: [
              "approvalRuleTemplateName"
            ],
            members: {
              approvalRuleTemplateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "approvalRuleTemplate"
            ],
            members: {
              approvalRuleTemplate: {
                shape: "S2c"
              }
            }
          }
        },
        GetBlob: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "blobId"
            ],
            members: {
              repositoryName: {},
              blobId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "content"
            ],
            members: {
              content: {
                type: "blob"
              }
            }
          }
        },
        GetBranch: {
          input: {
            type: "structure",
            members: {
              repositoryName: {},
              branchName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              branch: {
                shape: "S3y"
              }
            }
          }
        },
        GetComment: {
          input: {
            type: "structure",
            required: [
              "commentId"
            ],
            members: {
              commentId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              comment: {
                shape: "S42"
              }
            }
          }
        },
        GetCommentReactions: {
          input: {
            type: "structure",
            required: [
              "commentId"
            ],
            members: {
              commentId: {},
              reactionUserArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "reactionsForComment"
            ],
            members: {
              reactionsForComment: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    reaction: {
                      type: "structure",
                      members: {
                        emoji: {},
                        shortCode: {},
                        unicode: {}
                      }
                    },
                    reactionUsers: {
                      type: "list",
                      member: {}
                    },
                    reactionsFromDeletedUsersCount: {
                      type: "integer"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetCommentsForComparedCommit: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "afterCommitId"
            ],
            members: {
              repositoryName: {},
              beforeCommitId: {},
              afterCommitId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              commentsForComparedCommitData: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    repositoryName: {},
                    beforeCommitId: {},
                    afterCommitId: {},
                    beforeBlobId: {},
                    afterBlobId: {},
                    location: {
                      shape: "S5q"
                    },
                    comments: {
                      shape: "S5t"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetCommentsForPullRequest: {
          input: {
            type: "structure",
            required: [
              "pullRequestId"
            ],
            members: {
              pullRequestId: {},
              repositoryName: {},
              beforeCommitId: {},
              afterCommitId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              commentsForPullRequestData: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    pullRequestId: {},
                    repositoryName: {},
                    beforeCommitId: {},
                    afterCommitId: {},
                    beforeBlobId: {},
                    afterBlobId: {},
                    location: {
                      shape: "S5q"
                    },
                    comments: {
                      shape: "S5t"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetCommit: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "commitId"
            ],
            members: {
              repositoryName: {},
              commitId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "commit"
            ],
            members: {
              commit: {
                shape: "S1l"
              }
            }
          }
        },
        GetDifferences: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "afterCommitSpecifier"
            ],
            members: {
              repositoryName: {},
              beforeCommitSpecifier: {},
              afterCommitSpecifier: {},
              beforePath: {},
              afterPath: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              differences: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    beforeBlob: {
                      shape: "S65"
                    },
                    afterBlob: {
                      shape: "S65"
                    },
                    changeType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetFile: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "filePath"
            ],
            members: {
              repositoryName: {},
              commitSpecifier: {},
              filePath: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "commitId",
              "blobId",
              "filePath",
              "fileMode",
              "fileSize",
              "fileContent"
            ],
            members: {
              commitId: {},
              blobId: {},
              filePath: {},
              fileMode: {},
              fileSize: {
                type: "long"
              },
              fileContent: {
                type: "blob"
              }
            }
          }
        },
        GetFolder: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "folderPath"
            ],
            members: {
              repositoryName: {},
              commitSpecifier: {},
              folderPath: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "commitId",
              "folderPath"
            ],
            members: {
              commitId: {},
              folderPath: {},
              treeId: {},
              subFolders: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    treeId: {},
                    absolutePath: {},
                    relativePath: {}
                  }
                }
              },
              files: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    blobId: {},
                    absolutePath: {},
                    relativePath: {},
                    fileMode: {}
                  }
                }
              },
              symbolicLinks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    blobId: {},
                    absolutePath: {},
                    relativePath: {},
                    fileMode: {}
                  }
                }
              },
              subModules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    commitId: {},
                    absolutePath: {},
                    relativePath: {}
                  }
                }
              }
            }
          }
        },
        GetMergeCommit: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "sourceCommitSpecifier",
              "destinationCommitSpecifier"
            ],
            members: {
              repositoryName: {},
              sourceCommitSpecifier: {},
              destinationCommitSpecifier: {},
              conflictDetailLevel: {},
              conflictResolutionStrategy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              sourceCommitId: {},
              destinationCommitId: {},
              baseCommitId: {},
              mergedCommitId: {}
            }
          }
        },
        GetMergeConflicts: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "destinationCommitSpecifier",
              "sourceCommitSpecifier",
              "mergeOption"
            ],
            members: {
              repositoryName: {},
              destinationCommitSpecifier: {},
              sourceCommitSpecifier: {},
              mergeOption: {},
              conflictDetailLevel: {},
              maxConflictFiles: {
                type: "integer"
              },
              conflictResolutionStrategy: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "mergeable",
              "destinationCommitId",
              "sourceCommitId",
              "conflictMetadataList"
            ],
            members: {
              mergeable: {
                type: "boolean"
              },
              destinationCommitId: {},
              sourceCommitId: {},
              baseCommitId: {},
              conflictMetadataList: {
                type: "list",
                member: {
                  shape: "Sn"
                }
              },
              nextToken: {}
            }
          }
        },
        GetMergeOptions: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "sourceCommitSpecifier",
              "destinationCommitSpecifier"
            ],
            members: {
              repositoryName: {},
              sourceCommitSpecifier: {},
              destinationCommitSpecifier: {},
              conflictDetailLevel: {},
              conflictResolutionStrategy: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "mergeOptions",
              "sourceCommitId",
              "destinationCommitId",
              "baseCommitId"
            ],
            members: {
              mergeOptions: {
                type: "list",
                member: {}
              },
              sourceCommitId: {},
              destinationCommitId: {},
              baseCommitId: {}
            }
          }
        },
        GetPullRequest: {
          input: {
            type: "structure",
            required: [
              "pullRequestId"
            ],
            members: {
              pullRequestId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "pullRequest"
            ],
            members: {
              pullRequest: {
                shape: "S33"
              }
            }
          }
        },
        GetPullRequestApprovalStates: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "revisionId"
            ],
            members: {
              pullRequestId: {},
              revisionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              approvals: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    userArn: {},
                    approvalState: {}
                  }
                }
              }
            }
          }
        },
        GetPullRequestOverrideState: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "revisionId"
            ],
            members: {
              pullRequestId: {},
              revisionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              overridden: {
                type: "boolean"
              },
              overrider: {}
            }
          }
        },
        GetRepository: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              repositoryMetadata: {
                shape: "S1x"
              }
            }
          }
        },
        GetRepositoryTriggers: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              configurationId: {},
              triggers: {
                shape: "S76"
              }
            }
          }
        },
        ListApprovalRuleTemplates: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              approvalRuleTemplateNames: {
                shape: "S7f"
              },
              nextToken: {}
            }
          }
        },
        ListAssociatedApprovalRuleTemplatesForRepository: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              approvalRuleTemplateNames: {
                shape: "S7f"
              },
              nextToken: {}
            }
          }
        },
        ListBranches: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              branches: {
                shape: "S7a"
              },
              nextToken: {}
            }
          }
        },
        ListPullRequests: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {},
              authorArn: {},
              pullRequestStatus: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "pullRequestIds"
            ],
            members: {
              pullRequestIds: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        ListRepositories: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              sortBy: {},
              order: {}
            }
          },
          output: {
            type: "structure",
            members: {
              repositories: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    repositoryName: {},
                    repositoryId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRepositoriesForApprovalRuleTemplate: {
          input: {
            type: "structure",
            required: [
              "approvalRuleTemplateName"
            ],
            members: {
              approvalRuleTemplateName: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repositoryNames: {
                shape: "S5"
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S3k"
              },
              nextToken: {}
            }
          }
        },
        MergeBranchesByFastForward: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "sourceCommitSpecifier",
              "destinationCommitSpecifier"
            ],
            members: {
              repositoryName: {},
              sourceCommitSpecifier: {},
              destinationCommitSpecifier: {},
              targetBranch: {}
            }
          },
          output: {
            type: "structure",
            members: {
              commitId: {},
              treeId: {}
            }
          }
        },
        MergeBranchesBySquash: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "sourceCommitSpecifier",
              "destinationCommitSpecifier"
            ],
            members: {
              repositoryName: {},
              sourceCommitSpecifier: {},
              destinationCommitSpecifier: {},
              targetBranch: {},
              conflictDetailLevel: {},
              conflictResolutionStrategy: {},
              authorName: {},
              email: {},
              commitMessage: {},
              keepEmptyFolders: {
                type: "boolean"
              },
              conflictResolution: {
                shape: "S3p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              commitId: {},
              treeId: {}
            }
          }
        },
        MergeBranchesByThreeWay: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "sourceCommitSpecifier",
              "destinationCommitSpecifier"
            ],
            members: {
              repositoryName: {},
              sourceCommitSpecifier: {},
              destinationCommitSpecifier: {},
              targetBranch: {},
              conflictDetailLevel: {},
              conflictResolutionStrategy: {},
              authorName: {},
              email: {},
              commitMessage: {},
              keepEmptyFolders: {
                type: "boolean"
              },
              conflictResolution: {
                shape: "S3p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              commitId: {},
              treeId: {}
            }
          }
        },
        MergePullRequestByFastForward: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "repositoryName"
            ],
            members: {
              pullRequestId: {},
              repositoryName: {},
              sourceCommitId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              pullRequest: {
                shape: "S33"
              }
            }
          }
        },
        MergePullRequestBySquash: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "repositoryName"
            ],
            members: {
              pullRequestId: {},
              repositoryName: {},
              sourceCommitId: {},
              conflictDetailLevel: {},
              conflictResolutionStrategy: {},
              commitMessage: {},
              authorName: {},
              email: {},
              keepEmptyFolders: {
                type: "boolean"
              },
              conflictResolution: {
                shape: "S3p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pullRequest: {
                shape: "S33"
              }
            }
          }
        },
        MergePullRequestByThreeWay: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "repositoryName"
            ],
            members: {
              pullRequestId: {},
              repositoryName: {},
              sourceCommitId: {},
              conflictDetailLevel: {},
              conflictResolutionStrategy: {},
              commitMessage: {},
              authorName: {},
              email: {},
              keepEmptyFolders: {
                type: "boolean"
              },
              conflictResolution: {
                shape: "S3p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pullRequest: {
                shape: "S33"
              }
            }
          }
        },
        OverridePullRequestApprovalRules: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "revisionId",
              "overrideStatus"
            ],
            members: {
              pullRequestId: {},
              revisionId: {},
              overrideStatus: {}
            }
          }
        },
        PostCommentForComparedCommit: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "afterCommitId",
              "content"
            ],
            members: {
              repositoryName: {},
              beforeCommitId: {},
              afterCommitId: {},
              location: {
                shape: "S5q"
              },
              content: {},
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repositoryName: {},
              beforeCommitId: {},
              afterCommitId: {},
              beforeBlobId: {},
              afterBlobId: {},
              location: {
                shape: "S5q"
              },
              comment: {
                shape: "S42"
              }
            }
          },
          idempotent: true
        },
        PostCommentForPullRequest: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "repositoryName",
              "beforeCommitId",
              "afterCommitId",
              "content"
            ],
            members: {
              pullRequestId: {},
              repositoryName: {},
              beforeCommitId: {},
              afterCommitId: {},
              location: {
                shape: "S5q"
              },
              content: {},
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repositoryName: {},
              pullRequestId: {},
              beforeCommitId: {},
              afterCommitId: {},
              beforeBlobId: {},
              afterBlobId: {},
              location: {
                shape: "S5q"
              },
              comment: {
                shape: "S42"
              }
            }
          },
          idempotent: true
        },
        PostCommentReply: {
          input: {
            type: "structure",
            required: [
              "inReplyTo",
              "content"
            ],
            members: {
              inReplyTo: {},
              clientRequestToken: {
                idempotencyToken: true
              },
              content: {}
            }
          },
          output: {
            type: "structure",
            members: {
              comment: {
                shape: "S42"
              }
            }
          },
          idempotent: true
        },
        PutCommentReaction: {
          input: {
            type: "structure",
            required: [
              "commentId",
              "reactionValue"
            ],
            members: {
              commentId: {},
              reactionValue: {}
            }
          }
        },
        PutFile: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "branchName",
              "fileContent",
              "filePath"
            ],
            members: {
              repositoryName: {},
              branchName: {},
              fileContent: {
                type: "blob"
              },
              filePath: {},
              fileMode: {},
              parentCommitId: {},
              commitMessage: {},
              name: {},
              email: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "commitId",
              "blobId",
              "treeId"
            ],
            members: {
              commitId: {},
              blobId: {},
              treeId: {}
            }
          }
        },
        PutRepositoryTriggers: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "triggers"
            ],
            members: {
              repositoryName: {},
              triggers: {
                shape: "S76"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              configurationId: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S3k"
              }
            }
          }
        },
        TestRepositoryTriggers: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "triggers"
            ],
            members: {
              repositoryName: {},
              triggers: {
                shape: "S76"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              successfulExecutions: {
                type: "list",
                member: {}
              },
              failedExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    trigger: {},
                    failureMessage: {}
                  }
                }
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateApprovalRuleTemplateContent: {
          input: {
            type: "structure",
            required: [
              "approvalRuleTemplateName",
              "newRuleContent"
            ],
            members: {
              approvalRuleTemplateName: {},
              newRuleContent: {},
              existingRuleContentSha256: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "approvalRuleTemplate"
            ],
            members: {
              approvalRuleTemplate: {
                shape: "S2c"
              }
            }
          }
        },
        UpdateApprovalRuleTemplateDescription: {
          input: {
            type: "structure",
            required: [
              "approvalRuleTemplateName",
              "approvalRuleTemplateDescription"
            ],
            members: {
              approvalRuleTemplateName: {},
              approvalRuleTemplateDescription: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "approvalRuleTemplate"
            ],
            members: {
              approvalRuleTemplate: {
                shape: "S2c"
              }
            }
          }
        },
        UpdateApprovalRuleTemplateName: {
          input: {
            type: "structure",
            required: [
              "oldApprovalRuleTemplateName",
              "newApprovalRuleTemplateName"
            ],
            members: {
              oldApprovalRuleTemplateName: {},
              newApprovalRuleTemplateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "approvalRuleTemplate"
            ],
            members: {
              approvalRuleTemplate: {
                shape: "S2c"
              }
            }
          }
        },
        UpdateComment: {
          input: {
            type: "structure",
            required: [
              "commentId",
              "content"
            ],
            members: {
              commentId: {},
              content: {}
            }
          },
          output: {
            type: "structure",
            members: {
              comment: {
                shape: "S42"
              }
            }
          }
        },
        UpdateDefaultBranch: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "defaultBranchName"
            ],
            members: {
              repositoryName: {},
              defaultBranchName: {}
            }
          }
        },
        UpdatePullRequestApprovalRuleContent: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "approvalRuleName",
              "newRuleContent"
            ],
            members: {
              pullRequestId: {},
              approvalRuleName: {},
              existingRuleContentSha256: {},
              newRuleContent: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "approvalRule"
            ],
            members: {
              approvalRule: {
                shape: "S3c"
              }
            }
          }
        },
        UpdatePullRequestApprovalState: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "revisionId",
              "approvalState"
            ],
            members: {
              pullRequestId: {},
              revisionId: {},
              approvalState: {}
            }
          }
        },
        UpdatePullRequestDescription: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "description"
            ],
            members: {
              pullRequestId: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "pullRequest"
            ],
            members: {
              pullRequest: {
                shape: "S33"
              }
            }
          }
        },
        UpdatePullRequestStatus: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "pullRequestStatus"
            ],
            members: {
              pullRequestId: {},
              pullRequestStatus: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "pullRequest"
            ],
            members: {
              pullRequest: {
                shape: "S33"
              }
            }
          }
        },
        UpdatePullRequestTitle: {
          input: {
            type: "structure",
            required: [
              "pullRequestId",
              "title"
            ],
            members: {
              pullRequestId: {},
              title: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "pullRequest"
            ],
            members: {
              pullRequest: {
                shape: "S33"
              }
            }
          }
        },
        UpdateRepositoryDescription: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {},
              repositoryDescription: {}
            }
          }
        },
        UpdateRepositoryName: {
          input: {
            type: "structure",
            required: [
              "oldName",
              "newName"
            ],
            members: {
              oldName: {},
              newName: {}
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {}
        },
        Sn: {
          type: "structure",
          members: {
            filePath: {},
            fileSizes: {
              type: "structure",
              members: {
                source: {
                  type: "long"
                },
                destination: {
                  type: "long"
                },
                base: {
                  type: "long"
                }
              }
            },
            fileModes: {
              type: "structure",
              members: {
                source: {},
                destination: {},
                base: {}
              }
            },
            objectTypes: {
              type: "structure",
              members: {
                source: {},
                destination: {},
                base: {}
              }
            },
            numberOfConflicts: {
              type: "integer"
            },
            isBinaryFile: {
              type: "structure",
              members: {
                source: {
                  type: "boolean"
                },
                destination: {
                  type: "boolean"
                },
                base: {
                  type: "boolean"
                }
              }
            },
            contentConflict: {
              type: "boolean"
            },
            fileModeConflict: {
              type: "boolean"
            },
            objectTypeConflict: {
              type: "boolean"
            },
            mergeOperations: {
              type: "structure",
              members: {
                source: {},
                destination: {}
              }
            }
          }
        },
        S12: {
          type: "list",
          member: {
            type: "structure",
            members: {
              isConflict: {
                type: "boolean"
              },
              source: {
                shape: "S15"
              },
              destination: {
                shape: "S15"
              },
              base: {
                shape: "S15"
              }
            }
          }
        },
        S15: {
          type: "structure",
          members: {
            startLine: {
              type: "integer"
            },
            endLine: {
              type: "integer"
            },
            hunkContent: {}
          }
        },
        S1l: {
          type: "structure",
          members: {
            commitId: {},
            treeId: {},
            parents: {
              type: "list",
              member: {}
            },
            message: {},
            author: {
              shape: "S1n"
            },
            committer: {
              shape: "S1n"
            },
            additionalData: {}
          }
        },
        S1n: {
          type: "structure",
          members: {
            name: {},
            email: {},
            date: {}
          }
        },
        S1x: {
          type: "structure",
          members: {
            accountId: {},
            repositoryId: {},
            repositoryName: {},
            repositoryDescription: {},
            defaultBranch: {},
            lastModifiedDate: {
              type: "timestamp"
            },
            creationDate: {
              type: "timestamp"
            },
            cloneUrlHttp: {},
            cloneUrlSsh: {},
            Arn: {}
          }
        },
        S2c: {
          type: "structure",
          members: {
            approvalRuleTemplateId: {},
            approvalRuleTemplateName: {},
            approvalRuleTemplateDescription: {},
            approvalRuleTemplateContent: {},
            ruleContentSha256: {},
            lastModifiedDate: {
              type: "timestamp"
            },
            creationDate: {
              type: "timestamp"
            },
            lastModifiedUser: {}
          }
        },
        S2o: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "filePath"
            ],
            members: {
              filePath: {}
            }
          }
        },
        S2q: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "filePath",
              "fileMode"
            ],
            members: {
              filePath: {},
              fileMode: {}
            }
          }
        },
        S2t: {
          type: "list",
          member: {
            type: "structure",
            members: {
              absolutePath: {},
              blobId: {},
              fileMode: {}
            }
          }
        },
        S33: {
          type: "structure",
          members: {
            pullRequestId: {},
            title: {},
            description: {},
            lastActivityDate: {
              type: "timestamp"
            },
            creationDate: {
              type: "timestamp"
            },
            pullRequestStatus: {},
            authorArn: {},
            pullRequestTargets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  repositoryName: {},
                  sourceReference: {},
                  destinationReference: {},
                  destinationCommit: {},
                  sourceCommit: {},
                  mergeBase: {},
                  mergeMetadata: {
                    shape: "S38"
                  }
                }
              }
            },
            clientRequestToken: {},
            revisionId: {},
            approvalRules: {
              type: "list",
              member: {
                shape: "S3c"
              }
            }
          }
        },
        S38: {
          type: "structure",
          members: {
            isMerged: {
              type: "boolean"
            },
            mergedBy: {},
            mergeCommitId: {},
            mergeOption: {}
          }
        },
        S3c: {
          type: "structure",
          members: {
            approvalRuleId: {},
            approvalRuleName: {},
            approvalRuleContent: {},
            ruleContentSha256: {},
            lastModifiedDate: {
              type: "timestamp"
            },
            creationDate: {
              type: "timestamp"
            },
            lastModifiedUser: {},
            originApprovalRuleTemplate: {
              type: "structure",
              members: {
                approvalRuleTemplateId: {},
                approvalRuleTemplateName: {}
              }
            }
          }
        },
        S3k: {
          type: "map",
          key: {},
          value: {}
        },
        S3p: {
          type: "structure",
          members: {
            replaceContents: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "filePath",
                  "replacementType"
                ],
                members: {
                  filePath: {},
                  replacementType: {},
                  content: {
                    type: "blob"
                  },
                  fileMode: {}
                }
              }
            },
            deleteFiles: {
              shape: "S2o"
            },
            setFileModes: {
              shape: "S2q"
            }
          }
        },
        S3y: {
          type: "structure",
          members: {
            branchName: {},
            commitId: {}
          }
        },
        S42: {
          type: "structure",
          members: {
            commentId: {},
            content: {},
            inReplyTo: {},
            creationDate: {
              type: "timestamp"
            },
            lastModifiedDate: {
              type: "timestamp"
            },
            authorArn: {},
            deleted: {
              type: "boolean"
            },
            clientRequestToken: {},
            callerReactions: {
              type: "list",
              member: {}
            },
            reactionCounts: {
              type: "map",
              key: {},
              value: {
                type: "integer"
              }
            }
          }
        },
        S5q: {
          type: "structure",
          members: {
            filePath: {},
            filePosition: {
              type: "long"
            },
            relativeFileVersion: {}
          }
        },
        S5t: {
          type: "list",
          member: {
            shape: "S42"
          }
        },
        S65: {
          type: "structure",
          members: {
            blobId: {},
            path: {},
            mode: {}
          }
        },
        S76: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "destinationArn",
              "events"
            ],
            members: {
              name: {},
              destinationArn: {},
              customData: {},
              branches: {
                shape: "S7a"
              },
              events: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S7a: {
          type: "list",
          member: {}
        },
        S7f: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codecommit-2015-04-13.paginators.json
var require_codecommit_2015_04_13_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codecommit-2015-04-13.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeMergeConflicts: {
          input_token: "nextToken",
          limit_key: "maxMergeHunks",
          output_token: "nextToken"
        },
        DescribePullRequestEvents: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken"
        },
        GetCommentReactions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken"
        },
        GetCommentsForComparedCommit: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken"
        },
        GetCommentsForPullRequest: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken"
        },
        GetDifferences: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetMergeConflicts: {
          input_token: "nextToken",
          limit_key: "maxConflictFiles",
          output_token: "nextToken"
        },
        ListApprovalRuleTemplates: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken"
        },
        ListAssociatedApprovalRuleTemplatesForRepository: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken"
        },
        ListBranches: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "branches"
        },
        ListPullRequests: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken"
        },
        ListRepositories: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "repositories"
        },
        ListRepositoriesForApprovalRuleTemplate: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/codecommit.js
var require_codecommit = __commonJS({
  "node_modules/aws-sdk/clients/codecommit.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["codecommit"] = {};
    AWS3.CodeCommit = Service.defineService("codecommit", ["2015-04-13"]);
    Object.defineProperty(apiLoader.services["codecommit"], "2015-04-13", {
      get: function get() {
        var model = require_codecommit_2015_04_13_min();
        model.paginators = require_codecommit_2015_04_13_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CodeCommit;
  }
});

// node_modules/aws-sdk/apis/codedeploy-2014-10-06.min.json
var require_codedeploy_2014_10_06_min = __commonJS({
  "node_modules/aws-sdk/apis/codedeploy-2014-10-06.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-10-06",
        endpointPrefix: "codedeploy",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "CodeDeploy",
        serviceFullName: "AWS CodeDeploy",
        serviceId: "CodeDeploy",
        signatureVersion: "v4",
        targetPrefix: "CodeDeploy_20141006",
        uid: "codedeploy-2014-10-06"
      },
      operations: {
        AddTagsToOnPremisesInstances: {
          input: {
            type: "structure",
            required: [
              "tags",
              "instanceNames"
            ],
            members: {
              tags: {
                shape: "S2"
              },
              instanceNames: {
                shape: "S6"
              }
            }
          }
        },
        BatchGetApplicationRevisions: {
          input: {
            type: "structure",
            required: [
              "applicationName",
              "revisions"
            ],
            members: {
              applicationName: {},
              revisions: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationName: {},
              errorMessage: {},
              revisions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    revisionLocation: {
                      shape: "Sb"
                    },
                    genericRevisionInfo: {
                      shape: "Su"
                    }
                  }
                }
              }
            }
          }
        },
        BatchGetApplications: {
          input: {
            type: "structure",
            required: [
              "applicationNames"
            ],
            members: {
              applicationNames: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationsInfo: {
                type: "list",
                member: {
                  shape: "S13"
                }
              }
            }
          }
        },
        BatchGetDeploymentGroups: {
          input: {
            type: "structure",
            required: [
              "applicationName",
              "deploymentGroupNames"
            ],
            members: {
              applicationName: {},
              deploymentGroupNames: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentGroupsInfo: {
                type: "list",
                member: {
                  shape: "S1b"
                }
              },
              errorMessage: {}
            }
          }
        },
        BatchGetDeploymentInstances: {
          input: {
            type: "structure",
            required: [
              "deploymentId",
              "instanceIds"
            ],
            members: {
              deploymentId: {},
              instanceIds: {
                shape: "S32"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              instancesSummary: {
                type: "list",
                member: {
                  shape: "S36"
                }
              },
              errorMessage: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This operation is deprecated, use BatchGetDeploymentTargets instead."
        },
        BatchGetDeploymentTargets: {
          input: {
            type: "structure",
            members: {
              deploymentId: {},
              targetIds: {
                shape: "S3j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentTargets: {
                type: "list",
                member: {
                  shape: "S3n"
                }
              }
            }
          }
        },
        BatchGetDeployments: {
          input: {
            type: "structure",
            required: [
              "deploymentIds"
            ],
            members: {
              deploymentIds: {
                shape: "S49"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentsInfo: {
                type: "list",
                member: {
                  shape: "S4c"
                }
              }
            }
          }
        },
        BatchGetOnPremisesInstances: {
          input: {
            type: "structure",
            required: [
              "instanceNames"
            ],
            members: {
              instanceNames: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              instanceInfos: {
                type: "list",
                member: {
                  shape: "S4t"
                }
              }
            }
          }
        },
        ContinueDeployment: {
          input: {
            type: "structure",
            members: {
              deploymentId: {},
              deploymentWaitType: {}
            }
          }
        },
        CreateApplication: {
          input: {
            type: "structure",
            required: [
              "applicationName"
            ],
            members: {
              applicationName: {},
              computePlatform: {},
              tags: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationId: {}
            }
          }
        },
        CreateDeployment: {
          input: {
            type: "structure",
            required: [
              "applicationName"
            ],
            members: {
              applicationName: {},
              deploymentGroupName: {},
              revision: {
                shape: "Sb"
              },
              deploymentConfigName: {},
              description: {},
              ignoreApplicationStopFailures: {
                type: "boolean"
              },
              targetInstances: {
                shape: "S4j"
              },
              autoRollbackConfiguration: {
                shape: "S1z"
              },
              updateOutdatedInstancesOnly: {
                type: "boolean"
              },
              fileExistsBehavior: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentId: {}
            }
          }
        },
        CreateDeploymentConfig: {
          input: {
            type: "structure",
            required: [
              "deploymentConfigName"
            ],
            members: {
              deploymentConfigName: {},
              minimumHealthyHosts: {
                shape: "S54"
              },
              trafficRoutingConfig: {
                shape: "S57"
              },
              computePlatform: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentConfigId: {}
            }
          }
        },
        CreateDeploymentGroup: {
          input: {
            type: "structure",
            required: [
              "applicationName",
              "deploymentGroupName",
              "serviceRoleArn"
            ],
            members: {
              applicationName: {},
              deploymentGroupName: {},
              deploymentConfigName: {},
              ec2TagFilters: {
                shape: "S1e"
              },
              onPremisesInstanceTagFilters: {
                shape: "S1h"
              },
              autoScalingGroups: {
                shape: "S4k"
              },
              serviceRoleArn: {},
              triggerConfigurations: {
                shape: "S1p"
              },
              alarmConfiguration: {
                shape: "S1v"
              },
              autoRollbackConfiguration: {
                shape: "S1z"
              },
              outdatedInstancesStrategy: {},
              deploymentStyle: {
                shape: "S22"
              },
              blueGreenDeploymentConfiguration: {
                shape: "S26"
              },
              loadBalancerInfo: {
                shape: "S2e"
              },
              ec2TagSet: {
                shape: "S2t"
              },
              ecsServices: {
                shape: "S2x"
              },
              onPremisesTagSet: {
                shape: "S2v"
              },
              tags: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentGroupId: {}
            }
          }
        },
        DeleteApplication: {
          input: {
            type: "structure",
            required: [
              "applicationName"
            ],
            members: {
              applicationName: {}
            }
          }
        },
        DeleteDeploymentConfig: {
          input: {
            type: "structure",
            required: [
              "deploymentConfigName"
            ],
            members: {
              deploymentConfigName: {}
            }
          }
        },
        DeleteDeploymentGroup: {
          input: {
            type: "structure",
            required: [
              "applicationName",
              "deploymentGroupName"
            ],
            members: {
              applicationName: {},
              deploymentGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              hooksNotCleanedUp: {
                shape: "S1k"
              }
            }
          }
        },
        DeleteGitHubAccountToken: {
          input: {
            type: "structure",
            members: {
              tokenName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tokenName: {}
            }
          }
        },
        DeleteResourcesByExternalId: {
          input: {
            type: "structure",
            members: {
              externalId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterOnPremisesInstance: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {}
            }
          }
        },
        GetApplication: {
          input: {
            type: "structure",
            required: [
              "applicationName"
            ],
            members: {
              applicationName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              application: {
                shape: "S13"
              }
            }
          }
        },
        GetApplicationRevision: {
          input: {
            type: "structure",
            required: [
              "applicationName",
              "revision"
            ],
            members: {
              applicationName: {},
              revision: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationName: {},
              revision: {
                shape: "Sb"
              },
              revisionInfo: {
                shape: "Su"
              }
            }
          }
        },
        GetDeployment: {
          input: {
            type: "structure",
            required: [
              "deploymentId"
            ],
            members: {
              deploymentId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentInfo: {
                shape: "S4c"
              }
            }
          }
        },
        GetDeploymentConfig: {
          input: {
            type: "structure",
            required: [
              "deploymentConfigName"
            ],
            members: {
              deploymentConfigName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentConfigInfo: {
                type: "structure",
                members: {
                  deploymentConfigId: {},
                  deploymentConfigName: {},
                  minimumHealthyHosts: {
                    shape: "S54"
                  },
                  createTime: {
                    type: "timestamp"
                  },
                  computePlatform: {},
                  trafficRoutingConfig: {
                    shape: "S57"
                  }
                }
              }
            }
          }
        },
        GetDeploymentGroup: {
          input: {
            type: "structure",
            required: [
              "applicationName",
              "deploymentGroupName"
            ],
            members: {
              applicationName: {},
              deploymentGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentGroupInfo: {
                shape: "S1b"
              }
            }
          }
        },
        GetDeploymentInstance: {
          input: {
            type: "structure",
            required: [
              "deploymentId",
              "instanceId"
            ],
            members: {
              deploymentId: {},
              instanceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              instanceSummary: {
                shape: "S36"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "This operation is deprecated, use GetDeploymentTarget instead."
        },
        GetDeploymentTarget: {
          input: {
            type: "structure",
            members: {
              deploymentId: {},
              targetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentTarget: {
                shape: "S3n"
              }
            }
          }
        },
        GetOnPremisesInstance: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              instanceInfo: {
                shape: "S4t"
              }
            }
          }
        },
        ListApplicationRevisions: {
          input: {
            type: "structure",
            required: [
              "applicationName"
            ],
            members: {
              applicationName: {},
              sortBy: {},
              sortOrder: {},
              s3Bucket: {},
              s3KeyPrefix: {},
              deployed: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              revisions: {
                shape: "Sa"
              },
              nextToken: {}
            }
          }
        },
        ListApplications: {
          input: {
            type: "structure",
            members: {
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              applications: {
                shape: "S10"
              },
              nextToken: {}
            }
          }
        },
        ListDeploymentConfigs: {
          input: {
            type: "structure",
            members: {
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentConfigsList: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        ListDeploymentGroups: {
          input: {
            type: "structure",
            required: [
              "applicationName"
            ],
            members: {
              applicationName: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              applicationName: {},
              deploymentGroups: {
                shape: "Sw"
              },
              nextToken: {}
            }
          }
        },
        ListDeploymentInstances: {
          input: {
            type: "structure",
            required: [
              "deploymentId"
            ],
            members: {
              deploymentId: {},
              nextToken: {},
              instanceStatusFilter: {
                type: "list",
                member: {
                  shape: "S37"
                }
              },
              instanceTypeFilter: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              instancesList: {
                shape: "S32"
              },
              nextToken: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This operation is deprecated, use ListDeploymentTargets instead."
        },
        ListDeploymentTargets: {
          input: {
            type: "structure",
            members: {
              deploymentId: {},
              nextToken: {},
              targetFilters: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              targetIds: {
                shape: "S3j"
              },
              nextToken: {}
            }
          }
        },
        ListDeployments: {
          input: {
            type: "structure",
            members: {
              applicationName: {},
              deploymentGroupName: {},
              externalId: {},
              includeOnlyStatuses: {
                type: "list",
                member: {}
              },
              createTimeRange: {
                type: "structure",
                members: {
                  start: {
                    type: "timestamp"
                  },
                  end: {
                    type: "timestamp"
                  }
                }
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deployments: {
                shape: "S49"
              },
              nextToken: {}
            }
          }
        },
        ListGitHubAccountTokenNames: {
          input: {
            type: "structure",
            members: {
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tokenNameList: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        ListOnPremisesInstances: {
          input: {
            type: "structure",
            members: {
              registrationStatus: {},
              tagFilters: {
                shape: "S1h"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              instanceNames: {
                shape: "S6"
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S2"
              },
              NextToken: {}
            }
          }
        },
        PutLifecycleEventHookExecutionStatus: {
          input: {
            type: "structure",
            members: {
              deploymentId: {},
              lifecycleEventHookExecutionId: {},
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              lifecycleEventHookExecutionId: {}
            }
          }
        },
        RegisterApplicationRevision: {
          input: {
            type: "structure",
            required: [
              "applicationName",
              "revision"
            ],
            members: {
              applicationName: {},
              description: {},
              revision: {
                shape: "Sb"
              }
            }
          }
        },
        RegisterOnPremisesInstance: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {},
              iamSessionArn: {},
              iamUserArn: {}
            }
          }
        },
        RemoveTagsFromOnPremisesInstances: {
          input: {
            type: "structure",
            required: [
              "tags",
              "instanceNames"
            ],
            members: {
              tags: {
                shape: "S2"
              },
              instanceNames: {
                shape: "S6"
              }
            }
          }
        },
        SkipWaitTimeForInstanceTermination: {
          input: {
            type: "structure",
            members: {
              deploymentId: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This operation is deprecated, use ContinueDeployment with DeploymentWaitType instead."
        },
        StopDeployment: {
          input: {
            type: "structure",
            required: [
              "deploymentId"
            ],
            members: {
              deploymentId: {},
              autoRollbackEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {},
              statusMessage: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApplication: {
          input: {
            type: "structure",
            members: {
              applicationName: {},
              newApplicationName: {}
            }
          }
        },
        UpdateDeploymentGroup: {
          input: {
            type: "structure",
            required: [
              "applicationName",
              "currentDeploymentGroupName"
            ],
            members: {
              applicationName: {},
              currentDeploymentGroupName: {},
              newDeploymentGroupName: {},
              deploymentConfigName: {},
              ec2TagFilters: {
                shape: "S1e"
              },
              onPremisesInstanceTagFilters: {
                shape: "S1h"
              },
              autoScalingGroups: {
                shape: "S4k"
              },
              serviceRoleArn: {},
              triggerConfigurations: {
                shape: "S1p"
              },
              alarmConfiguration: {
                shape: "S1v"
              },
              autoRollbackConfiguration: {
                shape: "S1z"
              },
              outdatedInstancesStrategy: {},
              deploymentStyle: {
                shape: "S22"
              },
              blueGreenDeploymentConfiguration: {
                shape: "S26"
              },
              loadBalancerInfo: {
                shape: "S2e"
              },
              ec2TagSet: {
                shape: "S2t"
              },
              ecsServices: {
                shape: "S2x"
              },
              onPremisesTagSet: {
                shape: "S2v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              hooksNotCleanedUp: {
                shape: "S1k"
              }
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S6: {
          type: "list",
          member: {}
        },
        Sa: {
          type: "list",
          member: {
            shape: "Sb"
          }
        },
        Sb: {
          type: "structure",
          members: {
            revisionType: {},
            s3Location: {
              type: "structure",
              members: {
                bucket: {},
                key: {},
                bundleType: {},
                version: {},
                eTag: {}
              }
            },
            gitHubLocation: {
              type: "structure",
              members: {
                repository: {},
                commitId: {}
              }
            },
            string: {
              type: "structure",
              members: {
                content: {},
                sha256: {}
              },
              deprecated: true,
              deprecatedMessage: "RawString and String revision type are deprecated, use AppSpecContent type instead."
            },
            appSpecContent: {
              type: "structure",
              members: {
                content: {},
                sha256: {}
              }
            }
          }
        },
        Su: {
          type: "structure",
          members: {
            description: {},
            deploymentGroups: {
              shape: "Sw"
            },
            firstUsedTime: {
              type: "timestamp"
            },
            lastUsedTime: {
              type: "timestamp"
            },
            registerTime: {
              type: "timestamp"
            }
          }
        },
        Sw: {
          type: "list",
          member: {}
        },
        S10: {
          type: "list",
          member: {}
        },
        S13: {
          type: "structure",
          members: {
            applicationId: {},
            applicationName: {},
            createTime: {
              type: "timestamp"
            },
            linkedToGitHub: {
              type: "boolean"
            },
            gitHubAccountName: {},
            computePlatform: {}
          }
        },
        S1b: {
          type: "structure",
          members: {
            applicationName: {},
            deploymentGroupId: {},
            deploymentGroupName: {},
            deploymentConfigName: {},
            ec2TagFilters: {
              shape: "S1e"
            },
            onPremisesInstanceTagFilters: {
              shape: "S1h"
            },
            autoScalingGroups: {
              shape: "S1k"
            },
            serviceRoleArn: {},
            targetRevision: {
              shape: "Sb"
            },
            triggerConfigurations: {
              shape: "S1p"
            },
            alarmConfiguration: {
              shape: "S1v"
            },
            autoRollbackConfiguration: {
              shape: "S1z"
            },
            deploymentStyle: {
              shape: "S22"
            },
            outdatedInstancesStrategy: {},
            blueGreenDeploymentConfiguration: {
              shape: "S26"
            },
            loadBalancerInfo: {
              shape: "S2e"
            },
            lastSuccessfulDeployment: {
              shape: "S2q"
            },
            lastAttemptedDeployment: {
              shape: "S2q"
            },
            ec2TagSet: {
              shape: "S2t"
            },
            onPremisesTagSet: {
              shape: "S2v"
            },
            computePlatform: {},
            ecsServices: {
              shape: "S2x"
            }
          }
        },
        S1e: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {},
              Type: {}
            }
          }
        },
        S1h: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {},
              Type: {}
            }
          }
        },
        S1k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              hook: {}
            }
          }
        },
        S1p: {
          type: "list",
          member: {
            type: "structure",
            members: {
              triggerName: {},
              triggerTargetArn: {},
              triggerEvents: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S1v: {
          type: "structure",
          members: {
            enabled: {
              type: "boolean"
            },
            ignorePollAlarmFailure: {
              type: "boolean"
            },
            alarms: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  name: {}
                }
              }
            }
          }
        },
        S1z: {
          type: "structure",
          members: {
            enabled: {
              type: "boolean"
            },
            events: {
              type: "list",
              member: {}
            }
          }
        },
        S22: {
          type: "structure",
          members: {
            deploymentType: {},
            deploymentOption: {}
          }
        },
        S26: {
          type: "structure",
          members: {
            terminateBlueInstancesOnDeploymentSuccess: {
              type: "structure",
              members: {
                action: {},
                terminationWaitTimeInMinutes: {
                  type: "integer"
                }
              }
            },
            deploymentReadyOption: {
              type: "structure",
              members: {
                actionOnTimeout: {},
                waitTimeInMinutes: {
                  type: "integer"
                }
              }
            },
            greenFleetProvisioningOption: {
              type: "structure",
              members: {
                action: {}
              }
            }
          }
        },
        S2e: {
          type: "structure",
          members: {
            elbInfoList: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  name: {}
                }
              }
            },
            targetGroupInfoList: {
              shape: "S2i"
            },
            targetGroupPairInfoList: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  targetGroups: {
                    shape: "S2i"
                  },
                  prodTrafficRoute: {
                    shape: "S2n"
                  },
                  testTrafficRoute: {
                    shape: "S2n"
                  }
                }
              }
            }
          }
        },
        S2i: {
          type: "list",
          member: {
            shape: "S2j"
          }
        },
        S2j: {
          type: "structure",
          members: {
            name: {}
          }
        },
        S2n: {
          type: "structure",
          members: {
            listenerArns: {
              type: "list",
              member: {}
            }
          }
        },
        S2q: {
          type: "structure",
          members: {
            deploymentId: {},
            status: {},
            endTime: {
              type: "timestamp"
            },
            createTime: {
              type: "timestamp"
            }
          }
        },
        S2t: {
          type: "structure",
          members: {
            ec2TagSetList: {
              type: "list",
              member: {
                shape: "S1e"
              }
            }
          }
        },
        S2v: {
          type: "structure",
          members: {
            onPremisesTagSetList: {
              type: "list",
              member: {
                shape: "S1h"
              }
            }
          }
        },
        S2x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              serviceName: {},
              clusterName: {}
            }
          }
        },
        S32: {
          type: "list",
          member: {}
        },
        S36: {
          type: "structure",
          members: {
            deploymentId: {},
            instanceId: {},
            status: {
              shape: "S37"
            },
            lastUpdatedAt: {
              type: "timestamp"
            },
            lifecycleEvents: {
              shape: "S38"
            },
            instanceType: {}
          },
          deprecated: true,
          deprecatedMessage: "InstanceSummary is deprecated, use DeploymentTarget instead."
        },
        S37: {
          type: "string",
          deprecated: true,
          deprecatedMessage: "InstanceStatus is deprecated, use TargetStatus instead."
        },
        S38: {
          type: "list",
          member: {
            type: "structure",
            members: {
              lifecycleEventName: {},
              diagnostics: {
                type: "structure",
                members: {
                  errorCode: {},
                  scriptName: {},
                  message: {},
                  logTail: {}
                }
              },
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              status: {}
            }
          }
        },
        S3j: {
          type: "list",
          member: {}
        },
        S3n: {
          type: "structure",
          members: {
            deploymentTargetType: {},
            instanceTarget: {
              type: "structure",
              members: {
                deploymentId: {},
                targetId: {},
                targetArn: {},
                status: {},
                lastUpdatedAt: {
                  type: "timestamp"
                },
                lifecycleEvents: {
                  shape: "S38"
                },
                instanceLabel: {}
              }
            },
            lambdaTarget: {
              type: "structure",
              members: {
                deploymentId: {},
                targetId: {},
                targetArn: {},
                status: {},
                lastUpdatedAt: {
                  type: "timestamp"
                },
                lifecycleEvents: {
                  shape: "S38"
                },
                lambdaFunctionInfo: {
                  type: "structure",
                  members: {
                    functionName: {},
                    functionAlias: {},
                    currentVersion: {},
                    targetVersion: {},
                    targetVersionWeight: {
                      type: "double"
                    }
                  }
                }
              }
            },
            ecsTarget: {
              type: "structure",
              members: {
                deploymentId: {},
                targetId: {},
                targetArn: {},
                lastUpdatedAt: {
                  type: "timestamp"
                },
                lifecycleEvents: {
                  shape: "S38"
                },
                status: {},
                taskSetsInfo: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      identifer: {},
                      desiredCount: {
                        type: "long"
                      },
                      pendingCount: {
                        type: "long"
                      },
                      runningCount: {
                        type: "long"
                      },
                      status: {},
                      trafficWeight: {
                        type: "double"
                      },
                      targetGroup: {
                        shape: "S2j"
                      },
                      taskSetLabel: {}
                    }
                  }
                }
              }
            },
            cloudFormationTarget: {
              type: "structure",
              members: {
                deploymentId: {},
                targetId: {},
                lastUpdatedAt: {
                  type: "timestamp"
                },
                lifecycleEvents: {
                  shape: "S38"
                },
                status: {},
                resourceType: {},
                targetVersionWeight: {
                  type: "double"
                }
              }
            }
          }
        },
        S49: {
          type: "list",
          member: {}
        },
        S4c: {
          type: "structure",
          members: {
            applicationName: {},
            deploymentGroupName: {},
            deploymentConfigName: {},
            deploymentId: {},
            previousRevision: {
              shape: "Sb"
            },
            revision: {
              shape: "Sb"
            },
            status: {},
            errorInformation: {
              type: "structure",
              members: {
                code: {},
                message: {}
              }
            },
            createTime: {
              type: "timestamp"
            },
            startTime: {
              type: "timestamp"
            },
            completeTime: {
              type: "timestamp"
            },
            deploymentOverview: {
              type: "structure",
              members: {
                Pending: {
                  type: "long"
                },
                InProgress: {
                  type: "long"
                },
                Succeeded: {
                  type: "long"
                },
                Failed: {
                  type: "long"
                },
                Skipped: {
                  type: "long"
                },
                Ready: {
                  type: "long"
                }
              }
            },
            description: {},
            creator: {},
            ignoreApplicationStopFailures: {
              type: "boolean"
            },
            autoRollbackConfiguration: {
              shape: "S1z"
            },
            updateOutdatedInstancesOnly: {
              type: "boolean"
            },
            rollbackInfo: {
              type: "structure",
              members: {
                rollbackDeploymentId: {},
                rollbackTriggeringDeploymentId: {},
                rollbackMessage: {}
              }
            },
            deploymentStyle: {
              shape: "S22"
            },
            targetInstances: {
              shape: "S4j"
            },
            instanceTerminationWaitTimeStarted: {
              type: "boolean"
            },
            blueGreenDeploymentConfiguration: {
              shape: "S26"
            },
            loadBalancerInfo: {
              shape: "S2e"
            },
            additionalDeploymentStatusInfo: {
              type: "string",
              deprecated: true,
              deprecatedMessage: "AdditionalDeploymentStatusInfo is deprecated, use DeploymentStatusMessageList instead."
            },
            fileExistsBehavior: {},
            deploymentStatusMessages: {
              type: "list",
              member: {}
            },
            computePlatform: {},
            externalId: {},
            relatedDeployments: {
              type: "structure",
              members: {
                autoUpdateOutdatedInstancesRootDeploymentId: {},
                autoUpdateOutdatedInstancesDeploymentIds: {
                  shape: "S49"
                }
              }
            }
          }
        },
        S4j: {
          type: "structure",
          members: {
            tagFilters: {
              shape: "S1e"
            },
            autoScalingGroups: {
              shape: "S4k"
            },
            ec2TagSet: {
              shape: "S2t"
            }
          }
        },
        S4k: {
          type: "list",
          member: {}
        },
        S4t: {
          type: "structure",
          members: {
            instanceName: {},
            iamSessionArn: {},
            iamUserArn: {},
            instanceArn: {},
            registerTime: {
              type: "timestamp"
            },
            deregisterTime: {
              type: "timestamp"
            },
            tags: {
              shape: "S2"
            }
          }
        },
        S54: {
          type: "structure",
          members: {
            type: {},
            value: {
              type: "integer"
            }
          }
        },
        S57: {
          type: "structure",
          members: {
            type: {},
            timeBasedCanary: {
              type: "structure",
              members: {
                canaryPercentage: {
                  type: "integer"
                },
                canaryInterval: {
                  type: "integer"
                }
              }
            },
            timeBasedLinear: {
              type: "structure",
              members: {
                linearPercentage: {
                  type: "integer"
                },
                linearInterval: {
                  type: "integer"
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codedeploy-2014-10-06.paginators.json
var require_codedeploy_2014_10_06_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codedeploy-2014-10-06.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListApplicationRevisions: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "revisions"
        },
        ListApplications: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "applications"
        },
        ListDeploymentConfigs: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "deploymentConfigsList"
        },
        ListDeploymentGroups: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "deploymentGroups"
        },
        ListDeploymentInstances: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "instancesList"
        },
        ListDeployments: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "deployments"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codedeploy-2014-10-06.waiters2.json
var require_codedeploy_2014_10_06_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/codedeploy-2014-10-06.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DeploymentSuccessful: {
          delay: 15,
          operation: "GetDeployment",
          maxAttempts: 120,
          acceptors: [
            {
              expected: "Succeeded",
              matcher: "path",
              state: "success",
              argument: "deploymentInfo.status"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "deploymentInfo.status"
            },
            {
              expected: "Stopped",
              matcher: "path",
              state: "failure",
              argument: "deploymentInfo.status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/codedeploy.js
var require_codedeploy = __commonJS({
  "node_modules/aws-sdk/clients/codedeploy.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["codedeploy"] = {};
    AWS3.CodeDeploy = Service.defineService("codedeploy", ["2014-10-06"]);
    Object.defineProperty(apiLoader.services["codedeploy"], "2014-10-06", {
      get: function get() {
        var model = require_codedeploy_2014_10_06_min();
        model.paginators = require_codedeploy_2014_10_06_paginators().pagination;
        model.waiters = require_codedeploy_2014_10_06_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CodeDeploy;
  }
});

// node_modules/aws-sdk/apis/codepipeline-2015-07-09.min.json
var require_codepipeline_2015_07_09_min = __commonJS({
  "node_modules/aws-sdk/apis/codepipeline-2015-07-09.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-07-09",
        endpointPrefix: "codepipeline",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "CodePipeline",
        serviceFullName: "AWS CodePipeline",
        serviceId: "CodePipeline",
        signatureVersion: "v4",
        targetPrefix: "CodePipeline_20150709",
        uid: "codepipeline-2015-07-09"
      },
      operations: {
        AcknowledgeJob: {
          input: {
            type: "structure",
            required: [
              "jobId",
              "nonce"
            ],
            members: {
              jobId: {},
              nonce: {}
            }
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          }
        },
        AcknowledgeThirdPartyJob: {
          input: {
            type: "structure",
            required: [
              "jobId",
              "nonce",
              "clientToken"
            ],
            members: {
              jobId: {},
              nonce: {},
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          }
        },
        CreateCustomActionType: {
          input: {
            type: "structure",
            required: [
              "category",
              "provider",
              "version",
              "inputArtifactDetails",
              "outputArtifactDetails"
            ],
            members: {
              category: {},
              provider: {},
              version: {},
              settings: {
                shape: "Se"
              },
              configurationProperties: {
                shape: "Sh"
              },
              inputArtifactDetails: {
                shape: "Sn"
              },
              outputArtifactDetails: {
                shape: "Sn"
              },
              tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "actionType"
            ],
            members: {
              actionType: {
                shape: "Sv"
              },
              tags: {
                shape: "Sq"
              }
            }
          }
        },
        CreatePipeline: {
          input: {
            type: "structure",
            required: [
              "pipeline"
            ],
            members: {
              pipeline: {
                shape: "Sz"
              },
              tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pipeline: {
                shape: "Sz"
              },
              tags: {
                shape: "Sq"
              }
            }
          }
        },
        DeleteCustomActionType: {
          input: {
            type: "structure",
            required: [
              "category",
              "provider",
              "version"
            ],
            members: {
              category: {},
              provider: {},
              version: {}
            }
          }
        },
        DeletePipeline: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          }
        },
        DeleteWebhook: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterWebhookWithThirdParty: {
          input: {
            type: "structure",
            members: {
              webhookName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableStageTransition: {
          input: {
            type: "structure",
            required: [
              "pipelineName",
              "stageName",
              "transitionType",
              "reason"
            ],
            members: {
              pipelineName: {},
              stageName: {},
              transitionType: {},
              reason: {}
            }
          }
        },
        EnableStageTransition: {
          input: {
            type: "structure",
            required: [
              "pipelineName",
              "stageName",
              "transitionType"
            ],
            members: {
              pipelineName: {},
              stageName: {},
              transitionType: {}
            }
          }
        },
        GetActionType: {
          input: {
            type: "structure",
            required: [
              "category",
              "owner",
              "provider",
              "version"
            ],
            members: {
              category: {},
              owner: {},
              provider: {},
              version: {}
            }
          },
          output: {
            type: "structure",
            members: {
              actionType: {
                shape: "S29"
              }
            }
          }
        },
        GetJobDetails: {
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              jobDetails: {
                type: "structure",
                members: {
                  id: {},
                  data: {
                    shape: "S31"
                  },
                  accountId: {}
                }
              }
            }
          }
        },
        GetPipeline: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              version: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pipeline: {
                shape: "Sz"
              },
              metadata: {
                type: "structure",
                members: {
                  pipelineArn: {},
                  created: {
                    type: "timestamp"
                  },
                  updated: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        GetPipelineExecution: {
          input: {
            type: "structure",
            required: [
              "pipelineName",
              "pipelineExecutionId"
            ],
            members: {
              pipelineName: {},
              pipelineExecutionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              pipelineExecution: {
                type: "structure",
                members: {
                  pipelineName: {},
                  pipelineVersion: {
                    type: "integer"
                  },
                  pipelineExecutionId: {},
                  status: {},
                  statusSummary: {},
                  artifactRevisions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        name: {},
                        revisionId: {},
                        revisionChangeIdentifier: {},
                        revisionSummary: {},
                        created: {
                          type: "timestamp"
                        },
                        revisionUrl: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetPipelineState: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              pipelineName: {},
              pipelineVersion: {
                type: "integer"
              },
              stageStates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    stageName: {},
                    inboundExecution: {
                      shape: "S43"
                    },
                    inboundTransitionState: {
                      type: "structure",
                      members: {
                        enabled: {
                          type: "boolean"
                        },
                        lastChangedBy: {},
                        lastChangedAt: {
                          type: "timestamp"
                        },
                        disabledReason: {}
                      }
                    },
                    actionStates: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          actionName: {},
                          currentRevision: {
                            shape: "S4b"
                          },
                          latestExecution: {
                            type: "structure",
                            members: {
                              actionExecutionId: {},
                              status: {},
                              summary: {},
                              lastStatusChange: {
                                type: "timestamp"
                              },
                              token: {},
                              lastUpdatedBy: {},
                              externalExecutionId: {},
                              externalExecutionUrl: {},
                              percentComplete: {
                                type: "integer"
                              },
                              errorDetails: {
                                type: "structure",
                                members: {
                                  code: {},
                                  message: {}
                                }
                              }
                            }
                          },
                          entityUrl: {},
                          revisionUrl: {}
                        }
                      }
                    },
                    latestExecution: {
                      shape: "S43"
                    }
                  }
                }
              },
              created: {
                type: "timestamp"
              },
              updated: {
                type: "timestamp"
              }
            }
          }
        },
        GetThirdPartyJobDetails: {
          input: {
            type: "structure",
            required: [
              "jobId",
              "clientToken"
            ],
            members: {
              jobId: {},
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              jobDetails: {
                type: "structure",
                members: {
                  id: {},
                  data: {
                    type: "structure",
                    members: {
                      actionTypeId: {
                        shape: "Sw"
                      },
                      actionConfiguration: {
                        shape: "S32"
                      },
                      pipelineContext: {
                        shape: "S33"
                      },
                      inputArtifacts: {
                        shape: "S39"
                      },
                      outputArtifacts: {
                        shape: "S39"
                      },
                      artifactCredentials: {
                        shape: "S3h"
                      },
                      continuationToken: {},
                      encryptionKey: {
                        shape: "S15"
                      }
                    }
                  },
                  nonce: {}
                }
              }
            }
          }
        },
        ListActionExecutions: {
          input: {
            type: "structure",
            required: [
              "pipelineName"
            ],
            members: {
              pipelineName: {},
              filter: {
                type: "structure",
                members: {
                  pipelineExecutionId: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              actionExecutionDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    pipelineExecutionId: {},
                    actionExecutionId: {},
                    pipelineVersion: {
                      type: "integer"
                    },
                    stageName: {},
                    actionName: {},
                    startTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    },
                    status: {},
                    input: {
                      type: "structure",
                      members: {
                        actionTypeId: {
                          shape: "Sw"
                        },
                        configuration: {
                          shape: "S1l"
                        },
                        resolvedConfiguration: {
                          type: "map",
                          key: {},
                          value: {}
                        },
                        roleArn: {},
                        region: {},
                        inputArtifacts: {
                          shape: "S50"
                        },
                        namespace: {}
                      }
                    },
                    output: {
                      type: "structure",
                      members: {
                        outputArtifacts: {
                          shape: "S50"
                        },
                        executionResult: {
                          type: "structure",
                          members: {
                            externalExecutionId: {},
                            externalExecutionSummary: {},
                            externalExecutionUrl: {}
                          }
                        },
                        outputVariables: {
                          shape: "S59"
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListActionTypes: {
          input: {
            type: "structure",
            members: {
              actionOwnerFilter: {},
              nextToken: {},
              regionFilter: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "actionTypes"
            ],
            members: {
              actionTypes: {
                type: "list",
                member: {
                  shape: "Sv"
                }
              },
              nextToken: {}
            }
          }
        },
        ListPipelineExecutions: {
          input: {
            type: "structure",
            required: [
              "pipelineName"
            ],
            members: {
              pipelineName: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              pipelineExecutionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    pipelineExecutionId: {},
                    status: {},
                    startTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    },
                    sourceRevisions: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "actionName"
                        ],
                        members: {
                          actionName: {},
                          revisionId: {},
                          revisionSummary: {},
                          revisionUrl: {}
                        }
                      }
                    },
                    trigger: {
                      type: "structure",
                      members: {
                        triggerType: {},
                        triggerDetail: {}
                      }
                    },
                    stopTrigger: {
                      type: "structure",
                      members: {
                        reason: {}
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListPipelines: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pipelines: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    version: {
                      type: "integer"
                    },
                    created: {
                      type: "timestamp"
                    },
                    updated: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sq"
              },
              nextToken: {}
            }
          }
        },
        ListWebhooks: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              webhooks: {
                type: "list",
                member: {
                  shape: "S61"
                }
              },
              NextToken: {}
            }
          }
        },
        PollForJobs: {
          input: {
            type: "structure",
            required: [
              "actionTypeId"
            ],
            members: {
              actionTypeId: {
                shape: "Sw"
              },
              maxBatchSize: {
                type: "integer"
              },
              queryParam: {
                type: "map",
                key: {},
                value: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    data: {
                      shape: "S31"
                    },
                    nonce: {},
                    accountId: {}
                  }
                }
              }
            }
          }
        },
        PollForThirdPartyJobs: {
          input: {
            type: "structure",
            required: [
              "actionTypeId"
            ],
            members: {
              actionTypeId: {
                shape: "Sw"
              },
              maxBatchSize: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    clientId: {},
                    jobId: {}
                  }
                }
              }
            }
          }
        },
        PutActionRevision: {
          input: {
            type: "structure",
            required: [
              "pipelineName",
              "stageName",
              "actionName",
              "actionRevision"
            ],
            members: {
              pipelineName: {},
              stageName: {},
              actionName: {},
              actionRevision: {
                shape: "S4b"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              newRevision: {
                type: "boolean"
              },
              pipelineExecutionId: {}
            }
          }
        },
        PutApprovalResult: {
          input: {
            type: "structure",
            required: [
              "pipelineName",
              "stageName",
              "actionName",
              "result",
              "token"
            ],
            members: {
              pipelineName: {},
              stageName: {},
              actionName: {},
              result: {
                type: "structure",
                required: [
                  "summary",
                  "status"
                ],
                members: {
                  summary: {},
                  status: {}
                }
              },
              token: {}
            }
          },
          output: {
            type: "structure",
            members: {
              approvedAt: {
                type: "timestamp"
              }
            }
          }
        },
        PutJobFailureResult: {
          input: {
            type: "structure",
            required: [
              "jobId",
              "failureDetails"
            ],
            members: {
              jobId: {},
              failureDetails: {
                shape: "S71"
              }
            }
          }
        },
        PutJobSuccessResult: {
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {},
              currentRevision: {
                shape: "S74"
              },
              continuationToken: {},
              executionDetails: {
                shape: "S76"
              },
              outputVariables: {
                shape: "S59"
              }
            }
          }
        },
        PutThirdPartyJobFailureResult: {
          input: {
            type: "structure",
            required: [
              "jobId",
              "clientToken",
              "failureDetails"
            ],
            members: {
              jobId: {},
              clientToken: {},
              failureDetails: {
                shape: "S71"
              }
            }
          }
        },
        PutThirdPartyJobSuccessResult: {
          input: {
            type: "structure",
            required: [
              "jobId",
              "clientToken"
            ],
            members: {
              jobId: {},
              clientToken: {},
              currentRevision: {
                shape: "S74"
              },
              continuationToken: {},
              executionDetails: {
                shape: "S76"
              }
            }
          }
        },
        PutWebhook: {
          input: {
            type: "structure",
            required: [
              "webhook"
            ],
            members: {
              webhook: {
                shape: "S62"
              },
              tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              webhook: {
                shape: "S61"
              }
            }
          }
        },
        RegisterWebhookWithThirdParty: {
          input: {
            type: "structure",
            members: {
              webhookName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RetryStageExecution: {
          input: {
            type: "structure",
            required: [
              "pipelineName",
              "stageName",
              "pipelineExecutionId",
              "retryMode"
            ],
            members: {
              pipelineName: {},
              stageName: {},
              pipelineExecutionId: {},
              retryMode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              pipelineExecutionId: {}
            }
          }
        },
        StartPipelineExecution: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pipelineExecutionId: {}
            }
          }
        },
        StopPipelineExecution: {
          input: {
            type: "structure",
            required: [
              "pipelineName",
              "pipelineExecutionId"
            ],
            members: {
              pipelineName: {},
              pipelineExecutionId: {},
              abandon: {
                type: "boolean"
              },
              reason: {}
            }
          },
          output: {
            type: "structure",
            members: {
              pipelineExecutionId: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateActionType: {
          input: {
            type: "structure",
            required: [
              "actionType"
            ],
            members: {
              actionType: {
                shape: "S29"
              }
            }
          }
        },
        UpdatePipeline: {
          input: {
            type: "structure",
            required: [
              "pipeline"
            ],
            members: {
              pipeline: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pipeline: {
                shape: "Sz"
              }
            }
          }
        }
      },
      shapes: {
        Se: {
          type: "structure",
          members: {
            thirdPartyConfigurationUrl: {},
            entityUrlTemplate: {},
            executionUrlTemplate: {},
            revisionUrlTemplate: {}
          }
        },
        Sh: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "required",
              "key",
              "secret"
            ],
            members: {
              name: {},
              required: {
                type: "boolean"
              },
              key: {
                type: "boolean"
              },
              secret: {
                type: "boolean"
              },
              queryable: {
                type: "boolean"
              },
              description: {},
              type: {}
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "minimumCount",
            "maximumCount"
          ],
          members: {
            minimumCount: {
              type: "integer"
            },
            maximumCount: {
              type: "integer"
            }
          }
        },
        Sq: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sv: {
          type: "structure",
          required: [
            "id",
            "inputArtifactDetails",
            "outputArtifactDetails"
          ],
          members: {
            id: {
              shape: "Sw"
            },
            settings: {
              shape: "Se"
            },
            actionConfigurationProperties: {
              shape: "Sh"
            },
            inputArtifactDetails: {
              shape: "Sn"
            },
            outputArtifactDetails: {
              shape: "Sn"
            }
          }
        },
        Sw: {
          type: "structure",
          required: [
            "category",
            "owner",
            "provider",
            "version"
          ],
          members: {
            category: {},
            owner: {},
            provider: {},
            version: {}
          }
        },
        Sz: {
          type: "structure",
          required: [
            "name",
            "roleArn",
            "stages"
          ],
          members: {
            name: {},
            roleArn: {},
            artifactStore: {
              shape: "S12"
            },
            artifactStores: {
              type: "map",
              key: {},
              value: {
                shape: "S12"
              }
            },
            stages: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "name",
                  "actions"
                ],
                members: {
                  name: {},
                  blockers: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "name",
                        "type"
                      ],
                      members: {
                        name: {},
                        type: {}
                      }
                    }
                  },
                  actions: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "name",
                        "actionTypeId"
                      ],
                      members: {
                        name: {},
                        actionTypeId: {
                          shape: "Sw"
                        },
                        runOrder: {
                          type: "integer"
                        },
                        configuration: {
                          shape: "S1l"
                        },
                        outputArtifacts: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "name"
                            ],
                            members: {
                              name: {}
                            }
                          }
                        },
                        inputArtifacts: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "name"
                            ],
                            members: {
                              name: {}
                            }
                          }
                        },
                        roleArn: {},
                        region: {},
                        namespace: {}
                      }
                    }
                  }
                }
              }
            },
            version: {
              type: "integer"
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "type",
            "location"
          ],
          members: {
            type: {},
            location: {},
            encryptionKey: {
              shape: "S15"
            }
          }
        },
        S15: {
          type: "structure",
          required: [
            "id",
            "type"
          ],
          members: {
            id: {},
            type: {}
          }
        },
        S1l: {
          type: "map",
          key: {},
          value: {}
        },
        S29: {
          type: "structure",
          required: [
            "executor",
            "id",
            "inputArtifactDetails",
            "outputArtifactDetails"
          ],
          members: {
            description: {},
            executor: {
              type: "structure",
              required: [
                "configuration",
                "type"
              ],
              members: {
                configuration: {
                  type: "structure",
                  members: {
                    lambdaExecutorConfiguration: {
                      type: "structure",
                      required: [
                        "lambdaFunctionArn"
                      ],
                      members: {
                        lambdaFunctionArn: {}
                      }
                    },
                    jobWorkerExecutorConfiguration: {
                      type: "structure",
                      members: {
                        pollingAccounts: {
                          type: "list",
                          member: {}
                        },
                        pollingServicePrincipals: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                },
                type: {},
                policyStatementsTemplate: {},
                jobTimeout: {
                  type: "integer"
                }
              }
            },
            id: {
              type: "structure",
              required: [
                "category",
                "owner",
                "provider",
                "version"
              ],
              members: {
                category: {},
                owner: {},
                provider: {},
                version: {}
              }
            },
            inputArtifactDetails: {
              shape: "S2o"
            },
            outputArtifactDetails: {
              shape: "S2o"
            },
            permissions: {
              type: "structure",
              required: [
                "allowedAccounts"
              ],
              members: {
                allowedAccounts: {
                  type: "list",
                  member: {}
                }
              }
            },
            properties: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "name",
                  "optional",
                  "key",
                  "noEcho"
                ],
                members: {
                  name: {},
                  optional: {
                    type: "boolean"
                  },
                  key: {
                    type: "boolean"
                  },
                  noEcho: {
                    type: "boolean"
                  },
                  queryable: {
                    type: "boolean"
                  },
                  description: {}
                }
              }
            },
            urls: {
              type: "structure",
              members: {
                configurationUrl: {},
                entityUrlTemplate: {},
                executionUrlTemplate: {},
                revisionUrlTemplate: {}
              }
            }
          }
        },
        S2o: {
          type: "structure",
          required: [
            "minimumCount",
            "maximumCount"
          ],
          members: {
            minimumCount: {
              type: "integer"
            },
            maximumCount: {
              type: "integer"
            }
          }
        },
        S31: {
          type: "structure",
          members: {
            actionTypeId: {
              shape: "Sw"
            },
            actionConfiguration: {
              shape: "S32"
            },
            pipelineContext: {
              shape: "S33"
            },
            inputArtifacts: {
              shape: "S39"
            },
            outputArtifacts: {
              shape: "S39"
            },
            artifactCredentials: {
              shape: "S3h"
            },
            continuationToken: {},
            encryptionKey: {
              shape: "S15"
            }
          }
        },
        S32: {
          type: "structure",
          members: {
            configuration: {
              shape: "S1l"
            }
          }
        },
        S33: {
          type: "structure",
          members: {
            pipelineName: {},
            stage: {
              type: "structure",
              members: {
                name: {}
              }
            },
            action: {
              type: "structure",
              members: {
                name: {},
                actionExecutionId: {}
              }
            },
            pipelineArn: {},
            pipelineExecutionId: {}
          }
        },
        S39: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              revision: {},
              location: {
                type: "structure",
                members: {
                  type: {},
                  s3Location: {
                    type: "structure",
                    required: [
                      "bucketName",
                      "objectKey"
                    ],
                    members: {
                      bucketName: {},
                      objectKey: {}
                    }
                  }
                }
              }
            }
          }
        },
        S3h: {
          type: "structure",
          required: [
            "accessKeyId",
            "secretAccessKey",
            "sessionToken"
          ],
          members: {
            accessKeyId: {
              type: "string",
              sensitive: true
            },
            secretAccessKey: {
              type: "string",
              sensitive: true
            },
            sessionToken: {
              type: "string",
              sensitive: true
            }
          },
          sensitive: true
        },
        S43: {
          type: "structure",
          required: [
            "pipelineExecutionId",
            "status"
          ],
          members: {
            pipelineExecutionId: {},
            status: {}
          }
        },
        S4b: {
          type: "structure",
          required: [
            "revisionId",
            "revisionChangeId",
            "created"
          ],
          members: {
            revisionId: {},
            revisionChangeId: {},
            created: {
              type: "timestamp"
            }
          }
        },
        S50: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              s3location: {
                type: "structure",
                members: {
                  bucket: {},
                  key: {}
                }
              }
            }
          }
        },
        S59: {
          type: "map",
          key: {},
          value: {}
        },
        S61: {
          type: "structure",
          required: [
            "definition",
            "url"
          ],
          members: {
            definition: {
              shape: "S62"
            },
            url: {},
            errorMessage: {},
            errorCode: {},
            lastTriggered: {
              type: "timestamp"
            },
            arn: {},
            tags: {
              shape: "Sq"
            }
          }
        },
        S62: {
          type: "structure",
          required: [
            "name",
            "targetPipeline",
            "targetAction",
            "filters",
            "authentication",
            "authenticationConfiguration"
          ],
          members: {
            name: {},
            targetPipeline: {},
            targetAction: {},
            filters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "jsonPath"
                ],
                members: {
                  jsonPath: {},
                  matchEquals: {}
                }
              }
            },
            authentication: {},
            authenticationConfiguration: {
              type: "structure",
              members: {
                AllowedIPRange: {},
                SecretToken: {}
              }
            }
          }
        },
        S71: {
          type: "structure",
          required: [
            "type",
            "message"
          ],
          members: {
            type: {},
            message: {},
            externalExecutionId: {}
          }
        },
        S74: {
          type: "structure",
          required: [
            "revision",
            "changeIdentifier"
          ],
          members: {
            revision: {},
            changeIdentifier: {},
            created: {
              type: "timestamp"
            },
            revisionSummary: {}
          }
        },
        S76: {
          type: "structure",
          members: {
            summary: {},
            externalExecutionId: {},
            percentComplete: {
              type: "integer"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codepipeline-2015-07-09.paginators.json
var require_codepipeline_2015_07_09_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codepipeline-2015-07-09.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListActionExecutions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "actionExecutionDetails"
        },
        ListActionTypes: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "actionTypes"
        },
        ListPipelineExecutions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "pipelineExecutionSummaries"
        },
        ListPipelines: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "pipelines"
        },
        ListTagsForResource: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "tags"
        },
        ListWebhooks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "webhooks"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/codepipeline.js
var require_codepipeline = __commonJS({
  "node_modules/aws-sdk/clients/codepipeline.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["codepipeline"] = {};
    AWS3.CodePipeline = Service.defineService("codepipeline", ["2015-07-09"]);
    Object.defineProperty(apiLoader.services["codepipeline"], "2015-07-09", {
      get: function get() {
        var model = require_codepipeline_2015_07_09_min();
        model.paginators = require_codepipeline_2015_07_09_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CodePipeline;
  }
});

// node_modules/aws-sdk/apis/cognito-idp-2016-04-18.min.json
var require_cognito_idp_2016_04_18_min = __commonJS({
  "node_modules/aws-sdk/apis/cognito-idp-2016-04-18.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-04-18",
        endpointPrefix: "cognito-idp",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Cognito Identity Provider",
        serviceId: "Cognito Identity Provider",
        signatureVersion: "v4",
        targetPrefix: "AWSCognitoIdentityProviderService",
        uid: "cognito-idp-2016-04-18"
      },
      operations: {
        AddCustomAttributes: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "CustomAttributes"
            ],
            members: {
              UserPoolId: {},
              CustomAttributes: {
                type: "list",
                member: {
                  shape: "S4"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminAddUserToGroup: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username",
              "GroupName"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              GroupName: {}
            }
          }
        },
        AdminConfirmSignUp: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminCreateUser: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              UserAttributes: {
                shape: "Sj"
              },
              ValidationData: {
                shape: "Sj"
              },
              TemporaryPassword: {
                shape: "Sn"
              },
              ForceAliasCreation: {
                type: "boolean"
              },
              MessageAction: {},
              DesiredDeliveryMediums: {
                type: "list",
                member: {}
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "St"
              }
            }
          }
        },
        AdminDeleteUser: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              }
            }
          }
        },
        AdminDeleteUserAttributes: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username",
              "UserAttributeNames"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              UserAttributeNames: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminDisableProviderForUser: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "User"
            ],
            members: {
              UserPoolId: {},
              User: {
                shape: "S13"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminDisableUser: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminEnableUser: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminForgetDevice: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username",
              "DeviceKey"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              DeviceKey: {}
            }
          }
        },
        AdminGetDevice: {
          input: {
            type: "structure",
            required: [
              "DeviceKey",
              "UserPoolId",
              "Username"
            ],
            members: {
              DeviceKey: {},
              UserPoolId: {},
              Username: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Device"
            ],
            members: {
              Device: {
                shape: "S1e"
              }
            }
          }
        },
        AdminGetUser: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Username"
            ],
            members: {
              Username: {
                shape: "Sd"
              },
              UserAttributes: {
                shape: "Sj"
              },
              UserCreateDate: {
                type: "timestamp"
              },
              UserLastModifiedDate: {
                type: "timestamp"
              },
              Enabled: {
                type: "boolean"
              },
              UserStatus: {},
              MFAOptions: {
                shape: "Sw"
              },
              PreferredMfaSetting: {},
              UserMFASettingList: {
                shape: "S1h"
              }
            }
          }
        },
        AdminInitiateAuth: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "ClientId",
              "AuthFlow"
            ],
            members: {
              UserPoolId: {},
              ClientId: {
                shape: "S1j"
              },
              AuthFlow: {},
              AuthParameters: {
                shape: "S1l"
              },
              ClientMetadata: {
                shape: "Sg"
              },
              AnalyticsMetadata: {
                shape: "S1m"
              },
              ContextData: {
                shape: "S1n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChallengeName: {},
              Session: {},
              ChallengeParameters: {
                shape: "S1t"
              },
              AuthenticationResult: {
                shape: "S1u"
              }
            }
          }
        },
        AdminLinkProviderForUser: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "DestinationUser",
              "SourceUser"
            ],
            members: {
              UserPoolId: {},
              DestinationUser: {
                shape: "S13"
              },
              SourceUser: {
                shape: "S13"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminListDevices: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              Limit: {
                type: "integer"
              },
              PaginationToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Devices: {
                shape: "S24"
              },
              PaginationToken: {}
            }
          }
        },
        AdminListGroupsForUser: {
          input: {
            type: "structure",
            required: [
              "Username",
              "UserPoolId"
            ],
            members: {
              Username: {
                shape: "Sd"
              },
              UserPoolId: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Groups: {
                shape: "S28"
              },
              NextToken: {}
            }
          }
        },
        AdminListUserAuthEvents: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AuthEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventId: {},
                    EventType: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    EventResponse: {},
                    EventRisk: {
                      type: "structure",
                      members: {
                        RiskDecision: {},
                        RiskLevel: {},
                        CompromisedCredentialsDetected: {
                          type: "boolean"
                        }
                      }
                    },
                    ChallengeResponses: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ChallengeName: {},
                          ChallengeResponse: {}
                        }
                      }
                    },
                    EventContextData: {
                      type: "structure",
                      members: {
                        IpAddress: {},
                        DeviceName: {},
                        Timezone: {},
                        City: {},
                        Country: {}
                      }
                    },
                    EventFeedback: {
                      type: "structure",
                      required: [
                        "FeedbackValue",
                        "Provider"
                      ],
                      members: {
                        FeedbackValue: {},
                        Provider: {},
                        FeedbackDate: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        AdminRemoveUserFromGroup: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username",
              "GroupName"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              GroupName: {}
            }
          }
        },
        AdminResetUserPassword: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminRespondToAuthChallenge: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "ClientId",
              "ChallengeName"
            ],
            members: {
              UserPoolId: {},
              ClientId: {
                shape: "S1j"
              },
              ChallengeName: {},
              ChallengeResponses: {
                shape: "S2y"
              },
              Session: {},
              AnalyticsMetadata: {
                shape: "S1m"
              },
              ContextData: {
                shape: "S1n"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChallengeName: {},
              Session: {},
              ChallengeParameters: {
                shape: "S1t"
              },
              AuthenticationResult: {
                shape: "S1u"
              }
            }
          }
        },
        AdminSetUserMFAPreference: {
          input: {
            type: "structure",
            required: [
              "Username",
              "UserPoolId"
            ],
            members: {
              SMSMfaSettings: {
                shape: "S31"
              },
              SoftwareTokenMfaSettings: {
                shape: "S32"
              },
              Username: {
                shape: "Sd"
              },
              UserPoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminSetUserPassword: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username",
              "Password"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              Password: {
                shape: "Sn"
              },
              Permanent: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminSetUserSettings: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username",
              "MFAOptions"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              MFAOptions: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminUpdateAuthEventFeedback: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username",
              "EventId",
              "FeedbackValue"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              EventId: {},
              FeedbackValue: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminUpdateDeviceStatus: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username",
              "DeviceKey"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              DeviceKey: {},
              DeviceRememberedStatus: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminUpdateUserAttributes: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username",
              "UserAttributes"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              UserAttributes: {
                shape: "Sj"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AdminUserGlobalSignOut: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateSoftwareToken: {
          input: {
            type: "structure",
            members: {
              AccessToken: {
                shape: "S1v"
              },
              Session: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SecretCode: {
                type: "string",
                sensitive: true
              },
              Session: {}
            }
          }
        },
        ChangePassword: {
          input: {
            type: "structure",
            required: [
              "PreviousPassword",
              "ProposedPassword",
              "AccessToken"
            ],
            members: {
              PreviousPassword: {
                shape: "Sn"
              },
              ProposedPassword: {
                shape: "Sn"
              },
              AccessToken: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          authtype: "none"
        },
        ConfirmDevice: {
          input: {
            type: "structure",
            required: [
              "AccessToken",
              "DeviceKey"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              },
              DeviceKey: {},
              DeviceSecretVerifierConfig: {
                type: "structure",
                members: {
                  PasswordVerifier: {},
                  Salt: {}
                }
              },
              DeviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserConfirmationNecessary: {
                type: "boolean"
              }
            }
          }
        },
        ConfirmForgotPassword: {
          input: {
            type: "structure",
            required: [
              "ClientId",
              "Username",
              "ConfirmationCode",
              "Password"
            ],
            members: {
              ClientId: {
                shape: "S1j"
              },
              SecretHash: {
                shape: "S3s"
              },
              Username: {
                shape: "Sd"
              },
              ConfirmationCode: {},
              Password: {
                shape: "Sn"
              },
              AnalyticsMetadata: {
                shape: "S1m"
              },
              UserContextData: {
                shape: "S3u"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          authtype: "none"
        },
        ConfirmSignUp: {
          input: {
            type: "structure",
            required: [
              "ClientId",
              "Username",
              "ConfirmationCode"
            ],
            members: {
              ClientId: {
                shape: "S1j"
              },
              SecretHash: {
                shape: "S3s"
              },
              Username: {
                shape: "Sd"
              },
              ConfirmationCode: {},
              ForceAliasCreation: {
                type: "boolean"
              },
              AnalyticsMetadata: {
                shape: "S1m"
              },
              UserContextData: {
                shape: "S3u"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          authtype: "none"
        },
        CreateGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "UserPoolId"
            ],
            members: {
              GroupName: {},
              UserPoolId: {},
              Description: {},
              RoleArn: {},
              Precedence: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "S29"
              }
            }
          }
        },
        CreateIdentityProvider: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "ProviderName",
              "ProviderType",
              "ProviderDetails"
            ],
            members: {
              UserPoolId: {},
              ProviderName: {},
              ProviderType: {},
              ProviderDetails: {
                shape: "S43"
              },
              AttributeMapping: {
                shape: "S44"
              },
              IdpIdentifiers: {
                shape: "S46"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "IdentityProvider"
            ],
            members: {
              IdentityProvider: {
                shape: "S49"
              }
            }
          }
        },
        CreateResourceServer: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Identifier",
              "Name"
            ],
            members: {
              UserPoolId: {},
              Identifier: {},
              Name: {},
              Scopes: {
                shape: "S4d"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceServer"
            ],
            members: {
              ResourceServer: {
                shape: "S4i"
              }
            }
          }
        },
        CreateUserImportJob: {
          input: {
            type: "structure",
            required: [
              "JobName",
              "UserPoolId",
              "CloudWatchLogsRoleArn"
            ],
            members: {
              JobName: {},
              UserPoolId: {},
              CloudWatchLogsRoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserImportJob: {
                shape: "S4m"
              }
            }
          }
        },
        CreateUserPool: {
          input: {
            type: "structure",
            required: [
              "PoolName"
            ],
            members: {
              PoolName: {},
              Policies: {
                shape: "S4u"
              },
              LambdaConfig: {
                shape: "S4y"
              },
              AutoVerifiedAttributes: {
                shape: "S53"
              },
              AliasAttributes: {
                shape: "S55"
              },
              UsernameAttributes: {
                shape: "S57"
              },
              SmsVerificationMessage: {},
              EmailVerificationMessage: {},
              EmailVerificationSubject: {},
              VerificationMessageTemplate: {
                shape: "S5c"
              },
              SmsAuthenticationMessage: {},
              MfaConfiguration: {},
              DeviceConfiguration: {
                shape: "S5h"
              },
              EmailConfiguration: {
                shape: "S5i"
              },
              SmsConfiguration: {
                shape: "S5m"
              },
              UserPoolTags: {
                shape: "S5n"
              },
              AdminCreateUserConfig: {
                shape: "S5q"
              },
              Schema: {
                shape: "S5t"
              },
              UserPoolAddOns: {
                shape: "S5u"
              },
              UsernameConfiguration: {
                shape: "S5w"
              },
              AccountRecoverySetting: {
                shape: "S5x"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserPool: {
                shape: "S63"
              }
            }
          }
        },
        CreateUserPoolClient: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "ClientName"
            ],
            members: {
              UserPoolId: {},
              ClientName: {},
              GenerateSecret: {
                type: "boolean"
              },
              RefreshTokenValidity: {
                type: "integer"
              },
              AccessTokenValidity: {
                type: "integer"
              },
              IdTokenValidity: {
                type: "integer"
              },
              TokenValidityUnits: {
                shape: "S6c"
              },
              ReadAttributes: {
                shape: "S6e"
              },
              WriteAttributes: {
                shape: "S6e"
              },
              ExplicitAuthFlows: {
                shape: "S6g"
              },
              SupportedIdentityProviders: {
                shape: "S6i"
              },
              CallbackURLs: {
                shape: "S6j"
              },
              LogoutURLs: {
                shape: "S6l"
              },
              DefaultRedirectURI: {},
              AllowedOAuthFlows: {
                shape: "S6m"
              },
              AllowedOAuthScopes: {
                shape: "S6o"
              },
              AllowedOAuthFlowsUserPoolClient: {
                type: "boolean"
              },
              AnalyticsConfiguration: {
                shape: "S6q"
              },
              PreventUserExistenceErrors: {},
              EnableTokenRevocation: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserPoolClient: {
                shape: "S6u"
              }
            }
          }
        },
        CreateUserPoolDomain: {
          input: {
            type: "structure",
            required: [
              "Domain",
              "UserPoolId"
            ],
            members: {
              Domain: {},
              UserPoolId: {},
              CustomDomainConfig: {
                shape: "S6x"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontDomain: {}
            }
          }
        },
        DeleteGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "UserPoolId"
            ],
            members: {
              GroupName: {},
              UserPoolId: {}
            }
          }
        },
        DeleteIdentityProvider: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "ProviderName"
            ],
            members: {
              UserPoolId: {},
              ProviderName: {}
            }
          }
        },
        DeleteResourceServer: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Identifier"
            ],
            members: {
              UserPoolId: {},
              Identifier: {}
            }
          }
        },
        DeleteUser: {
          input: {
            type: "structure",
            required: [
              "AccessToken"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              }
            }
          },
          authtype: "none"
        },
        DeleteUserAttributes: {
          input: {
            type: "structure",
            required: [
              "UserAttributeNames",
              "AccessToken"
            ],
            members: {
              UserAttributeNames: {
                shape: "S10"
              },
              AccessToken: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          authtype: "none"
        },
        DeleteUserPool: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {}
            }
          }
        },
        DeleteUserPoolClient: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "ClientId"
            ],
            members: {
              UserPoolId: {},
              ClientId: {
                shape: "S1j"
              }
            }
          }
        },
        DeleteUserPoolDomain: {
          input: {
            type: "structure",
            required: [
              "Domain",
              "UserPoolId"
            ],
            members: {
              Domain: {},
              UserPoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeIdentityProvider: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "ProviderName"
            ],
            members: {
              UserPoolId: {},
              ProviderName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "IdentityProvider"
            ],
            members: {
              IdentityProvider: {
                shape: "S49"
              }
            }
          }
        },
        DescribeResourceServer: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Identifier"
            ],
            members: {
              UserPoolId: {},
              Identifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceServer"
            ],
            members: {
              ResourceServer: {
                shape: "S4i"
              }
            }
          }
        },
        DescribeRiskConfiguration: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              ClientId: {
                shape: "S1j"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RiskConfiguration"
            ],
            members: {
              RiskConfiguration: {
                shape: "S7f"
              }
            }
          }
        },
        DescribeUserImportJob: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "JobId"
            ],
            members: {
              UserPoolId: {},
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserImportJob: {
                shape: "S4m"
              }
            }
          }
        },
        DescribeUserPool: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserPool: {
                shape: "S63"
              }
            }
          }
        },
        DescribeUserPoolClient: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "ClientId"
            ],
            members: {
              UserPoolId: {},
              ClientId: {
                shape: "S1j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserPoolClient: {
                shape: "S6u"
              }
            }
          }
        },
        DescribeUserPoolDomain: {
          input: {
            type: "structure",
            required: [
              "Domain"
            ],
            members: {
              Domain: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DomainDescription: {
                type: "structure",
                members: {
                  UserPoolId: {},
                  AWSAccountId: {},
                  Domain: {},
                  S3Bucket: {},
                  CloudFrontDistribution: {},
                  Version: {},
                  Status: {},
                  CustomDomainConfig: {
                    shape: "S6x"
                  }
                }
              }
            }
          }
        },
        ForgetDevice: {
          input: {
            type: "structure",
            required: [
              "DeviceKey"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              },
              DeviceKey: {}
            }
          }
        },
        ForgotPassword: {
          input: {
            type: "structure",
            required: [
              "ClientId",
              "Username"
            ],
            members: {
              ClientId: {
                shape: "S1j"
              },
              SecretHash: {
                shape: "S3s"
              },
              UserContextData: {
                shape: "S3u"
              },
              Username: {
                shape: "Sd"
              },
              AnalyticsMetadata: {
                shape: "S1m"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CodeDeliveryDetails: {
                shape: "S8d"
              }
            }
          },
          authtype: "none"
        },
        GetCSVHeader: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserPoolId: {},
              CSVHeader: {
                type: "list",
                member: {}
              }
            }
          }
        },
        GetDevice: {
          input: {
            type: "structure",
            required: [
              "DeviceKey"
            ],
            members: {
              DeviceKey: {},
              AccessToken: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Device"
            ],
            members: {
              Device: {
                shape: "S1e"
              }
            }
          }
        },
        GetGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "UserPoolId"
            ],
            members: {
              GroupName: {},
              UserPoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "S29"
              }
            }
          }
        },
        GetIdentityProviderByIdentifier: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "IdpIdentifier"
            ],
            members: {
              UserPoolId: {},
              IdpIdentifier: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "IdentityProvider"
            ],
            members: {
              IdentityProvider: {
                shape: "S49"
              }
            }
          }
        },
        GetSigningCertificate: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Certificate: {}
            }
          }
        },
        GetUICustomization: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              ClientId: {
                shape: "S1j"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UICustomization"
            ],
            members: {
              UICustomization: {
                shape: "S8r"
              }
            }
          }
        },
        GetUser: {
          input: {
            type: "structure",
            required: [
              "AccessToken"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Username",
              "UserAttributes"
            ],
            members: {
              Username: {
                shape: "Sd"
              },
              UserAttributes: {
                shape: "Sj"
              },
              MFAOptions: {
                shape: "Sw"
              },
              PreferredMfaSetting: {},
              UserMFASettingList: {
                shape: "S1h"
              }
            }
          },
          authtype: "none"
        },
        GetUserAttributeVerificationCode: {
          input: {
            type: "structure",
            required: [
              "AccessToken",
              "AttributeName"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              },
              AttributeName: {},
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CodeDeliveryDetails: {
                shape: "S8d"
              }
            }
          },
          authtype: "none"
        },
        GetUserPoolMfaConfig: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SmsMfaConfiguration: {
                shape: "S91"
              },
              SoftwareTokenMfaConfiguration: {
                shape: "S92"
              },
              MfaConfiguration: {}
            }
          }
        },
        GlobalSignOut: {
          input: {
            type: "structure",
            required: [
              "AccessToken"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        InitiateAuth: {
          input: {
            type: "structure",
            required: [
              "AuthFlow",
              "ClientId"
            ],
            members: {
              AuthFlow: {},
              AuthParameters: {
                shape: "S1l"
              },
              ClientMetadata: {
                shape: "Sg"
              },
              ClientId: {
                shape: "S1j"
              },
              AnalyticsMetadata: {
                shape: "S1m"
              },
              UserContextData: {
                shape: "S3u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChallengeName: {},
              Session: {},
              ChallengeParameters: {
                shape: "S1t"
              },
              AuthenticationResult: {
                shape: "S1u"
              }
            }
          },
          authtype: "none"
        },
        ListDevices: {
          input: {
            type: "structure",
            required: [
              "AccessToken"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              },
              Limit: {
                type: "integer"
              },
              PaginationToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Devices: {
                shape: "S24"
              },
              PaginationToken: {}
            }
          }
        },
        ListGroups: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Groups: {
                shape: "S28"
              },
              NextToken: {}
            }
          }
        },
        ListIdentityProviders: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Providers"
            ],
            members: {
              Providers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProviderName: {},
                    ProviderType: {},
                    LastModifiedDate: {
                      type: "timestamp"
                    },
                    CreationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListResourceServers: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceServers"
            ],
            members: {
              ResourceServers: {
                type: "list",
                member: {
                  shape: "S4i"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S5n"
              }
            }
          }
        },
        ListUserImportJobs: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "MaxResults"
            ],
            members: {
              UserPoolId: {},
              MaxResults: {
                type: "integer"
              },
              PaginationToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserImportJobs: {
                type: "list",
                member: {
                  shape: "S4m"
                }
              },
              PaginationToken: {}
            }
          }
        },
        ListUserPoolClients: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserPoolClients: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ClientId: {
                      shape: "S1j"
                    },
                    UserPoolId: {},
                    ClientName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListUserPools: {
          input: {
            type: "structure",
            required: [
              "MaxResults"
            ],
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserPools: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    LambdaConfig: {
                      shape: "S4y"
                    },
                    Status: {},
                    LastModifiedDate: {
                      type: "timestamp"
                    },
                    CreationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListUsers: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              AttributesToGet: {
                type: "list",
                member: {}
              },
              Limit: {
                type: "integer"
              },
              PaginationToken: {},
              Filter: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Users: {
                shape: "Sa4"
              },
              PaginationToken: {}
            }
          }
        },
        ListUsersInGroup: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "GroupName"
            ],
            members: {
              UserPoolId: {},
              GroupName: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Users: {
                shape: "Sa4"
              },
              NextToken: {}
            }
          }
        },
        ResendConfirmationCode: {
          input: {
            type: "structure",
            required: [
              "ClientId",
              "Username"
            ],
            members: {
              ClientId: {
                shape: "S1j"
              },
              SecretHash: {
                shape: "S3s"
              },
              UserContextData: {
                shape: "S3u"
              },
              Username: {
                shape: "Sd"
              },
              AnalyticsMetadata: {
                shape: "S1m"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CodeDeliveryDetails: {
                shape: "S8d"
              }
            }
          },
          authtype: "none"
        },
        RespondToAuthChallenge: {
          input: {
            type: "structure",
            required: [
              "ClientId",
              "ChallengeName"
            ],
            members: {
              ClientId: {
                shape: "S1j"
              },
              ChallengeName: {},
              Session: {},
              ChallengeResponses: {
                shape: "S2y"
              },
              AnalyticsMetadata: {
                shape: "S1m"
              },
              UserContextData: {
                shape: "S3u"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChallengeName: {},
              Session: {},
              ChallengeParameters: {
                shape: "S1t"
              },
              AuthenticationResult: {
                shape: "S1u"
              }
            }
          },
          authtype: "none"
        },
        RevokeToken: {
          input: {
            type: "structure",
            required: [
              "Token",
              "ClientId"
            ],
            members: {
              Token: {
                shape: "S1v"
              },
              ClientId: {
                shape: "S1j"
              },
              ClientSecret: {
                shape: "S6v"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SetRiskConfiguration: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              ClientId: {
                shape: "S1j"
              },
              CompromisedCredentialsRiskConfiguration: {
                shape: "S7g"
              },
              AccountTakeoverRiskConfiguration: {
                shape: "S7l"
              },
              RiskExceptionConfiguration: {
                shape: "S7u"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RiskConfiguration"
            ],
            members: {
              RiskConfiguration: {
                shape: "S7f"
              }
            }
          }
        },
        SetUICustomization: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              ClientId: {
                shape: "S1j"
              },
              CSS: {},
              ImageFile: {
                type: "blob"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UICustomization"
            ],
            members: {
              UICustomization: {
                shape: "S8r"
              }
            }
          }
        },
        SetUserMFAPreference: {
          input: {
            type: "structure",
            required: [
              "AccessToken"
            ],
            members: {
              SMSMfaSettings: {
                shape: "S31"
              },
              SoftwareTokenMfaSettings: {
                shape: "S32"
              },
              AccessToken: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SetUserPoolMfaConfig: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              SmsMfaConfiguration: {
                shape: "S91"
              },
              SoftwareTokenMfaConfiguration: {
                shape: "S92"
              },
              MfaConfiguration: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SmsMfaConfiguration: {
                shape: "S91"
              },
              SoftwareTokenMfaConfiguration: {
                shape: "S92"
              },
              MfaConfiguration: {}
            }
          }
        },
        SetUserSettings: {
          input: {
            type: "structure",
            required: [
              "AccessToken",
              "MFAOptions"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              },
              MFAOptions: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          authtype: "none"
        },
        SignUp: {
          input: {
            type: "structure",
            required: [
              "ClientId",
              "Username",
              "Password"
            ],
            members: {
              ClientId: {
                shape: "S1j"
              },
              SecretHash: {
                shape: "S3s"
              },
              Username: {
                shape: "Sd"
              },
              Password: {
                shape: "Sn"
              },
              UserAttributes: {
                shape: "Sj"
              },
              ValidationData: {
                shape: "Sj"
              },
              AnalyticsMetadata: {
                shape: "S1m"
              },
              UserContextData: {
                shape: "S3u"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UserConfirmed",
              "UserSub"
            ],
            members: {
              UserConfirmed: {
                type: "boolean"
              },
              CodeDeliveryDetails: {
                shape: "S8d"
              },
              UserSub: {}
            }
          },
          authtype: "none"
        },
        StartUserImportJob: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "JobId"
            ],
            members: {
              UserPoolId: {},
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserImportJob: {
                shape: "S4m"
              }
            }
          }
        },
        StopUserImportJob: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "JobId"
            ],
            members: {
              UserPoolId: {},
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserImportJob: {
                shape: "S4m"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S5n"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAuthEventFeedback: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Username",
              "EventId",
              "FeedbackToken",
              "FeedbackValue"
            ],
            members: {
              UserPoolId: {},
              Username: {
                shape: "Sd"
              },
              EventId: {},
              FeedbackToken: {
                shape: "S1v"
              },
              FeedbackValue: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDeviceStatus: {
          input: {
            type: "structure",
            required: [
              "AccessToken",
              "DeviceKey"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              },
              DeviceKey: {},
              DeviceRememberedStatus: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "UserPoolId"
            ],
            members: {
              GroupName: {},
              UserPoolId: {},
              Description: {},
              RoleArn: {},
              Precedence: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "S29"
              }
            }
          }
        },
        UpdateIdentityProvider: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "ProviderName"
            ],
            members: {
              UserPoolId: {},
              ProviderName: {},
              ProviderDetails: {
                shape: "S43"
              },
              AttributeMapping: {
                shape: "S44"
              },
              IdpIdentifiers: {
                shape: "S46"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "IdentityProvider"
            ],
            members: {
              IdentityProvider: {
                shape: "S49"
              }
            }
          }
        },
        UpdateResourceServer: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "Identifier",
              "Name"
            ],
            members: {
              UserPoolId: {},
              Identifier: {},
              Name: {},
              Scopes: {
                shape: "S4d"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceServer"
            ],
            members: {
              ResourceServer: {
                shape: "S4i"
              }
            }
          }
        },
        UpdateUserAttributes: {
          input: {
            type: "structure",
            required: [
              "UserAttributes",
              "AccessToken"
            ],
            members: {
              UserAttributes: {
                shape: "Sj"
              },
              AccessToken: {
                shape: "S1v"
              },
              ClientMetadata: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CodeDeliveryDetailsList: {
                type: "list",
                member: {
                  shape: "S8d"
                }
              }
            }
          },
          authtype: "none"
        },
        UpdateUserPool: {
          input: {
            type: "structure",
            required: [
              "UserPoolId"
            ],
            members: {
              UserPoolId: {},
              Policies: {
                shape: "S4u"
              },
              LambdaConfig: {
                shape: "S4y"
              },
              AutoVerifiedAttributes: {
                shape: "S53"
              },
              SmsVerificationMessage: {},
              EmailVerificationMessage: {},
              EmailVerificationSubject: {},
              VerificationMessageTemplate: {
                shape: "S5c"
              },
              SmsAuthenticationMessage: {},
              MfaConfiguration: {},
              DeviceConfiguration: {
                shape: "S5h"
              },
              EmailConfiguration: {
                shape: "S5i"
              },
              SmsConfiguration: {
                shape: "S5m"
              },
              UserPoolTags: {
                shape: "S5n"
              },
              AdminCreateUserConfig: {
                shape: "S5q"
              },
              UserPoolAddOns: {
                shape: "S5u"
              },
              AccountRecoverySetting: {
                shape: "S5x"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateUserPoolClient: {
          input: {
            type: "structure",
            required: [
              "UserPoolId",
              "ClientId"
            ],
            members: {
              UserPoolId: {},
              ClientId: {
                shape: "S1j"
              },
              ClientName: {},
              RefreshTokenValidity: {
                type: "integer"
              },
              AccessTokenValidity: {
                type: "integer"
              },
              IdTokenValidity: {
                type: "integer"
              },
              TokenValidityUnits: {
                shape: "S6c"
              },
              ReadAttributes: {
                shape: "S6e"
              },
              WriteAttributes: {
                shape: "S6e"
              },
              ExplicitAuthFlows: {
                shape: "S6g"
              },
              SupportedIdentityProviders: {
                shape: "S6i"
              },
              CallbackURLs: {
                shape: "S6j"
              },
              LogoutURLs: {
                shape: "S6l"
              },
              DefaultRedirectURI: {},
              AllowedOAuthFlows: {
                shape: "S6m"
              },
              AllowedOAuthScopes: {
                shape: "S6o"
              },
              AllowedOAuthFlowsUserPoolClient: {
                type: "boolean"
              },
              AnalyticsConfiguration: {
                shape: "S6q"
              },
              PreventUserExistenceErrors: {},
              EnableTokenRevocation: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserPoolClient: {
                shape: "S6u"
              }
            }
          }
        },
        UpdateUserPoolDomain: {
          input: {
            type: "structure",
            required: [
              "Domain",
              "UserPoolId",
              "CustomDomainConfig"
            ],
            members: {
              Domain: {},
              UserPoolId: {},
              CustomDomainConfig: {
                shape: "S6x"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CloudFrontDomain: {}
            }
          }
        },
        VerifySoftwareToken: {
          input: {
            type: "structure",
            required: [
              "UserCode"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              },
              Session: {},
              UserCode: {},
              FriendlyDeviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              Session: {}
            }
          }
        },
        VerifyUserAttribute: {
          input: {
            type: "structure",
            required: [
              "AccessToken",
              "AttributeName",
              "Code"
            ],
            members: {
              AccessToken: {
                shape: "S1v"
              },
              AttributeName: {},
              Code: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          authtype: "none"
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            Name: {},
            AttributeDataType: {},
            DeveloperOnlyAttribute: {
              type: "boolean"
            },
            Mutable: {
              type: "boolean"
            },
            Required: {
              type: "boolean"
            },
            NumberAttributeConstraints: {
              type: "structure",
              members: {
                MinValue: {},
                MaxValue: {}
              }
            },
            StringAttributeConstraints: {
              type: "structure",
              members: {
                MinLength: {},
                MaxLength: {}
              }
            }
          }
        },
        Sd: {
          type: "string",
          sensitive: true
        },
        Sg: {
          type: "map",
          key: {},
          value: {}
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Value: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        Sn: {
          type: "string",
          sensitive: true
        },
        St: {
          type: "structure",
          members: {
            Username: {
              shape: "Sd"
            },
            Attributes: {
              shape: "Sj"
            },
            UserCreateDate: {
              type: "timestamp"
            },
            UserLastModifiedDate: {
              type: "timestamp"
            },
            Enabled: {
              type: "boolean"
            },
            UserStatus: {},
            MFAOptions: {
              shape: "Sw"
            }
          }
        },
        Sw: {
          type: "list",
          member: {
            type: "structure",
            members: {
              DeliveryMedium: {},
              AttributeName: {}
            }
          }
        },
        S10: {
          type: "list",
          member: {}
        },
        S13: {
          type: "structure",
          members: {
            ProviderName: {},
            ProviderAttributeName: {},
            ProviderAttributeValue: {}
          }
        },
        S1e: {
          type: "structure",
          members: {
            DeviceKey: {},
            DeviceAttributes: {
              shape: "Sj"
            },
            DeviceCreateDate: {
              type: "timestamp"
            },
            DeviceLastModifiedDate: {
              type: "timestamp"
            },
            DeviceLastAuthenticatedDate: {
              type: "timestamp"
            }
          }
        },
        S1h: {
          type: "list",
          member: {}
        },
        S1j: {
          type: "string",
          sensitive: true
        },
        S1l: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        S1m: {
          type: "structure",
          members: {
            AnalyticsEndpointId: {}
          }
        },
        S1n: {
          type: "structure",
          required: [
            "IpAddress",
            "ServerName",
            "ServerPath",
            "HttpHeaders"
          ],
          members: {
            IpAddress: {},
            ServerName: {},
            ServerPath: {},
            HttpHeaders: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  headerName: {},
                  headerValue: {}
                }
              }
            },
            EncodedData: {}
          }
        },
        S1t: {
          type: "map",
          key: {},
          value: {}
        },
        S1u: {
          type: "structure",
          members: {
            AccessToken: {
              shape: "S1v"
            },
            ExpiresIn: {
              type: "integer"
            },
            TokenType: {},
            RefreshToken: {
              shape: "S1v"
            },
            IdToken: {
              shape: "S1v"
            },
            NewDeviceMetadata: {
              type: "structure",
              members: {
                DeviceKey: {},
                DeviceGroupKey: {}
              }
            }
          }
        },
        S1v: {
          type: "string",
          sensitive: true
        },
        S24: {
          type: "list",
          member: {
            shape: "S1e"
          }
        },
        S28: {
          type: "list",
          member: {
            shape: "S29"
          }
        },
        S29: {
          type: "structure",
          members: {
            GroupName: {},
            UserPoolId: {},
            Description: {},
            RoleArn: {},
            Precedence: {
              type: "integer"
            },
            LastModifiedDate: {
              type: "timestamp"
            },
            CreationDate: {
              type: "timestamp"
            }
          }
        },
        S2y: {
          type: "map",
          key: {},
          value: {}
        },
        S31: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            PreferredMfa: {
              type: "boolean"
            }
          }
        },
        S32: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            PreferredMfa: {
              type: "boolean"
            }
          }
        },
        S3s: {
          type: "string",
          sensitive: true
        },
        S3u: {
          type: "structure",
          members: {
            EncodedData: {}
          }
        },
        S43: {
          type: "map",
          key: {},
          value: {}
        },
        S44: {
          type: "map",
          key: {},
          value: {}
        },
        S46: {
          type: "list",
          member: {}
        },
        S49: {
          type: "structure",
          members: {
            UserPoolId: {},
            ProviderName: {},
            ProviderType: {},
            ProviderDetails: {
              shape: "S43"
            },
            AttributeMapping: {
              shape: "S44"
            },
            IdpIdentifiers: {
              shape: "S46"
            },
            LastModifiedDate: {
              type: "timestamp"
            },
            CreationDate: {
              type: "timestamp"
            }
          }
        },
        S4d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ScopeName",
              "ScopeDescription"
            ],
            members: {
              ScopeName: {},
              ScopeDescription: {}
            }
          }
        },
        S4i: {
          type: "structure",
          members: {
            UserPoolId: {},
            Identifier: {},
            Name: {},
            Scopes: {
              shape: "S4d"
            }
          }
        },
        S4m: {
          type: "structure",
          members: {
            JobName: {},
            JobId: {},
            UserPoolId: {},
            PreSignedUrl: {},
            CreationDate: {
              type: "timestamp"
            },
            StartDate: {
              type: "timestamp"
            },
            CompletionDate: {
              type: "timestamp"
            },
            Status: {},
            CloudWatchLogsRoleArn: {},
            ImportedUsers: {
              type: "long"
            },
            SkippedUsers: {
              type: "long"
            },
            FailedUsers: {
              type: "long"
            },
            CompletionMessage: {}
          }
        },
        S4u: {
          type: "structure",
          members: {
            PasswordPolicy: {
              type: "structure",
              members: {
                MinimumLength: {
                  type: "integer"
                },
                RequireUppercase: {
                  type: "boolean"
                },
                RequireLowercase: {
                  type: "boolean"
                },
                RequireNumbers: {
                  type: "boolean"
                },
                RequireSymbols: {
                  type: "boolean"
                },
                TemporaryPasswordValidityDays: {
                  type: "integer"
                }
              }
            }
          }
        },
        S4y: {
          type: "structure",
          members: {
            PreSignUp: {},
            CustomMessage: {},
            PostConfirmation: {},
            PreAuthentication: {},
            PostAuthentication: {},
            DefineAuthChallenge: {},
            CreateAuthChallenge: {},
            VerifyAuthChallengeResponse: {},
            PreTokenGeneration: {},
            UserMigration: {},
            CustomSMSSender: {
              type: "structure",
              required: [
                "LambdaVersion",
                "LambdaArn"
              ],
              members: {
                LambdaVersion: {},
                LambdaArn: {}
              }
            },
            CustomEmailSender: {
              type: "structure",
              required: [
                "LambdaVersion",
                "LambdaArn"
              ],
              members: {
                LambdaVersion: {},
                LambdaArn: {}
              }
            },
            KMSKeyID: {}
          }
        },
        S53: {
          type: "list",
          member: {}
        },
        S55: {
          type: "list",
          member: {}
        },
        S57: {
          type: "list",
          member: {}
        },
        S5c: {
          type: "structure",
          members: {
            SmsMessage: {},
            EmailMessage: {},
            EmailSubject: {},
            EmailMessageByLink: {},
            EmailSubjectByLink: {},
            DefaultEmailOption: {}
          }
        },
        S5h: {
          type: "structure",
          members: {
            ChallengeRequiredOnNewDevice: {
              type: "boolean"
            },
            DeviceOnlyRememberedOnUserPrompt: {
              type: "boolean"
            }
          }
        },
        S5i: {
          type: "structure",
          members: {
            SourceArn: {},
            ReplyToEmailAddress: {},
            EmailSendingAccount: {},
            From: {},
            ConfigurationSet: {}
          }
        },
        S5m: {
          type: "structure",
          required: [
            "SnsCallerArn"
          ],
          members: {
            SnsCallerArn: {},
            ExternalId: {}
          }
        },
        S5n: {
          type: "map",
          key: {},
          value: {}
        },
        S5q: {
          type: "structure",
          members: {
            AllowAdminCreateUserOnly: {
              type: "boolean"
            },
            UnusedAccountValidityDays: {
              type: "integer"
            },
            InviteMessageTemplate: {
              type: "structure",
              members: {
                SMSMessage: {},
                EmailMessage: {},
                EmailSubject: {}
              }
            }
          }
        },
        S5t: {
          type: "list",
          member: {
            shape: "S4"
          }
        },
        S5u: {
          type: "structure",
          required: [
            "AdvancedSecurityMode"
          ],
          members: {
            AdvancedSecurityMode: {}
          }
        },
        S5w: {
          type: "structure",
          required: [
            "CaseSensitive"
          ],
          members: {
            CaseSensitive: {
              type: "boolean"
            }
          }
        },
        S5x: {
          type: "structure",
          members: {
            RecoveryMechanisms: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Priority",
                  "Name"
                ],
                members: {
                  Priority: {
                    type: "integer"
                  },
                  Name: {}
                }
              }
            }
          }
        },
        S63: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            Policies: {
              shape: "S4u"
            },
            LambdaConfig: {
              shape: "S4y"
            },
            Status: {},
            LastModifiedDate: {
              type: "timestamp"
            },
            CreationDate: {
              type: "timestamp"
            },
            SchemaAttributes: {
              shape: "S5t"
            },
            AutoVerifiedAttributes: {
              shape: "S53"
            },
            AliasAttributes: {
              shape: "S55"
            },
            UsernameAttributes: {
              shape: "S57"
            },
            SmsVerificationMessage: {},
            EmailVerificationMessage: {},
            EmailVerificationSubject: {},
            VerificationMessageTemplate: {
              shape: "S5c"
            },
            SmsAuthenticationMessage: {},
            MfaConfiguration: {},
            DeviceConfiguration: {
              shape: "S5h"
            },
            EstimatedNumberOfUsers: {
              type: "integer"
            },
            EmailConfiguration: {
              shape: "S5i"
            },
            SmsConfiguration: {
              shape: "S5m"
            },
            UserPoolTags: {
              shape: "S5n"
            },
            SmsConfigurationFailure: {},
            EmailConfigurationFailure: {},
            Domain: {},
            CustomDomain: {},
            AdminCreateUserConfig: {
              shape: "S5q"
            },
            UserPoolAddOns: {
              shape: "S5u"
            },
            UsernameConfiguration: {
              shape: "S5w"
            },
            Arn: {},
            AccountRecoverySetting: {
              shape: "S5x"
            }
          }
        },
        S6c: {
          type: "structure",
          members: {
            AccessToken: {},
            IdToken: {},
            RefreshToken: {}
          }
        },
        S6e: {
          type: "list",
          member: {}
        },
        S6g: {
          type: "list",
          member: {}
        },
        S6i: {
          type: "list",
          member: {}
        },
        S6j: {
          type: "list",
          member: {}
        },
        S6l: {
          type: "list",
          member: {}
        },
        S6m: {
          type: "list",
          member: {}
        },
        S6o: {
          type: "list",
          member: {}
        },
        S6q: {
          type: "structure",
          members: {
            ApplicationId: {},
            ApplicationArn: {},
            RoleArn: {},
            ExternalId: {},
            UserDataShared: {
              type: "boolean"
            }
          }
        },
        S6u: {
          type: "structure",
          members: {
            UserPoolId: {},
            ClientName: {},
            ClientId: {
              shape: "S1j"
            },
            ClientSecret: {
              shape: "S6v"
            },
            LastModifiedDate: {
              type: "timestamp"
            },
            CreationDate: {
              type: "timestamp"
            },
            RefreshTokenValidity: {
              type: "integer"
            },
            AccessTokenValidity: {
              type: "integer"
            },
            IdTokenValidity: {
              type: "integer"
            },
            TokenValidityUnits: {
              shape: "S6c"
            },
            ReadAttributes: {
              shape: "S6e"
            },
            WriteAttributes: {
              shape: "S6e"
            },
            ExplicitAuthFlows: {
              shape: "S6g"
            },
            SupportedIdentityProviders: {
              shape: "S6i"
            },
            CallbackURLs: {
              shape: "S6j"
            },
            LogoutURLs: {
              shape: "S6l"
            },
            DefaultRedirectURI: {},
            AllowedOAuthFlows: {
              shape: "S6m"
            },
            AllowedOAuthScopes: {
              shape: "S6o"
            },
            AllowedOAuthFlowsUserPoolClient: {
              type: "boolean"
            },
            AnalyticsConfiguration: {
              shape: "S6q"
            },
            PreventUserExistenceErrors: {},
            EnableTokenRevocation: {
              type: "boolean"
            }
          }
        },
        S6v: {
          type: "string",
          sensitive: true
        },
        S6x: {
          type: "structure",
          required: [
            "CertificateArn"
          ],
          members: {
            CertificateArn: {}
          }
        },
        S7f: {
          type: "structure",
          members: {
            UserPoolId: {},
            ClientId: {
              shape: "S1j"
            },
            CompromisedCredentialsRiskConfiguration: {
              shape: "S7g"
            },
            AccountTakeoverRiskConfiguration: {
              shape: "S7l"
            },
            RiskExceptionConfiguration: {
              shape: "S7u"
            },
            LastModifiedDate: {
              type: "timestamp"
            }
          }
        },
        S7g: {
          type: "structure",
          required: [
            "Actions"
          ],
          members: {
            EventFilter: {
              type: "list",
              member: {}
            },
            Actions: {
              type: "structure",
              required: [
                "EventAction"
              ],
              members: {
                EventAction: {}
              }
            }
          }
        },
        S7l: {
          type: "structure",
          required: [
            "Actions"
          ],
          members: {
            NotifyConfiguration: {
              type: "structure",
              required: [
                "SourceArn"
              ],
              members: {
                From: {},
                ReplyTo: {},
                SourceArn: {},
                BlockEmail: {
                  shape: "S7n"
                },
                NoActionEmail: {
                  shape: "S7n"
                },
                MfaEmail: {
                  shape: "S7n"
                }
              }
            },
            Actions: {
              type: "structure",
              members: {
                LowAction: {
                  shape: "S7r"
                },
                MediumAction: {
                  shape: "S7r"
                },
                HighAction: {
                  shape: "S7r"
                }
              }
            }
          }
        },
        S7n: {
          type: "structure",
          required: [
            "Subject"
          ],
          members: {
            Subject: {},
            HtmlBody: {},
            TextBody: {}
          }
        },
        S7r: {
          type: "structure",
          required: [
            "Notify",
            "EventAction"
          ],
          members: {
            Notify: {
              type: "boolean"
            },
            EventAction: {}
          }
        },
        S7u: {
          type: "structure",
          members: {
            BlockedIPRangeList: {
              type: "list",
              member: {}
            },
            SkippedIPRangeList: {
              type: "list",
              member: {}
            }
          }
        },
        S8d: {
          type: "structure",
          members: {
            Destination: {},
            DeliveryMedium: {},
            AttributeName: {}
          }
        },
        S8r: {
          type: "structure",
          members: {
            UserPoolId: {},
            ClientId: {
              shape: "S1j"
            },
            ImageUrl: {},
            CSS: {},
            CSSVersion: {},
            LastModifiedDate: {
              type: "timestamp"
            },
            CreationDate: {
              type: "timestamp"
            }
          }
        },
        S91: {
          type: "structure",
          members: {
            SmsAuthenticationMessage: {},
            SmsConfiguration: {
              shape: "S5m"
            }
          }
        },
        S92: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            }
          }
        },
        Sa4: {
          type: "list",
          member: {
            shape: "St"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cognito-idp-2016-04-18.paginators.json
var require_cognito_idp_2016_04_18_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cognito-idp-2016-04-18.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        AdminListGroupsForUser: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Groups"
        },
        AdminListUserAuthEvents: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AuthEvents"
        },
        ListGroups: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Groups"
        },
        ListIdentityProviders: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Providers"
        },
        ListResourceServers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ResourceServers"
        },
        ListUserPoolClients: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "UserPoolClients"
        },
        ListUserPools: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "UserPools"
        },
        ListUsers: {
          input_token: "PaginationToken",
          limit_key: "Limit",
          output_token: "PaginationToken",
          result_key: "Users"
        },
        ListUsersInGroup: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Users"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cognitoidentityserviceprovider.js
var require_cognitoidentityserviceprovider = __commonJS({
  "node_modules/aws-sdk/clients/cognitoidentityserviceprovider.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["cognitoidentityserviceprovider"] = {};
    AWS3.CognitoIdentityServiceProvider = Service.defineService("cognitoidentityserviceprovider", ["2016-04-18"]);
    Object.defineProperty(apiLoader.services["cognitoidentityserviceprovider"], "2016-04-18", {
      get: function get() {
        var model = require_cognito_idp_2016_04_18_min();
        model.paginators = require_cognito_idp_2016_04_18_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CognitoIdentityServiceProvider;
  }
});

// node_modules/aws-sdk/apis/cognito-sync-2014-06-30.min.json
var require_cognito_sync_2014_06_30_min = __commonJS({
  "node_modules/aws-sdk/apis/cognito-sync-2014-06-30.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-06-30",
        endpointPrefix: "cognito-sync",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Cognito Sync",
        serviceId: "Cognito Sync",
        signatureVersion: "v4",
        uid: "cognito-sync-2014-06-30"
      },
      operations: {
        BulkPublish: {
          http: {
            requestUri: "/identitypools/{IdentityPoolId}/bulkpublish",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPoolId: {}
            }
          }
        },
        DeleteDataset: {
          http: {
            method: "DELETE",
            requestUri: "/identitypools/{IdentityPoolId}/identities/{IdentityId}/datasets/{DatasetName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "IdentityId",
              "DatasetName"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              IdentityId: {
                location: "uri",
                locationName: "IdentityId"
              },
              DatasetName: {
                location: "uri",
                locationName: "DatasetName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Dataset: {
                shape: "S8"
              }
            }
          }
        },
        DescribeDataset: {
          http: {
            method: "GET",
            requestUri: "/identitypools/{IdentityPoolId}/identities/{IdentityId}/datasets/{DatasetName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "IdentityId",
              "DatasetName"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              IdentityId: {
                location: "uri",
                locationName: "IdentityId"
              },
              DatasetName: {
                location: "uri",
                locationName: "DatasetName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Dataset: {
                shape: "S8"
              }
            }
          }
        },
        DescribeIdentityPoolUsage: {
          http: {
            method: "GET",
            requestUri: "/identitypools/{IdentityPoolId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPoolUsage: {
                shape: "Sg"
              }
            }
          }
        },
        DescribeIdentityUsage: {
          http: {
            method: "GET",
            requestUri: "/identitypools/{IdentityPoolId}/identities/{IdentityId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "IdentityId"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              IdentityId: {
                location: "uri",
                locationName: "IdentityId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityUsage: {
                type: "structure",
                members: {
                  IdentityId: {},
                  IdentityPoolId: {},
                  LastModifiedDate: {
                    type: "timestamp"
                  },
                  DatasetCount: {
                    type: "integer"
                  },
                  DataStorage: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        GetBulkPublishDetails: {
          http: {
            requestUri: "/identitypools/{IdentityPoolId}/getBulkPublishDetails",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPoolId: {},
              BulkPublishStartTime: {
                type: "timestamp"
              },
              BulkPublishCompleteTime: {
                type: "timestamp"
              },
              BulkPublishStatus: {},
              FailureMessage: {}
            }
          }
        },
        GetCognitoEvents: {
          http: {
            method: "GET",
            requestUri: "/identitypools/{IdentityPoolId}/events",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Events: {
                shape: "Sq"
              }
            }
          }
        },
        GetIdentityPoolConfiguration: {
          http: {
            method: "GET",
            requestUri: "/identitypools/{IdentityPoolId}/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPoolId: {},
              PushSync: {
                shape: "Sv"
              },
              CognitoStreams: {
                shape: "Sz"
              }
            }
          }
        },
        ListDatasets: {
          http: {
            method: "GET",
            requestUri: "/identitypools/{IdentityPoolId}/identities/{IdentityId}/datasets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityId",
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              IdentityId: {
                location: "uri",
                locationName: "IdentityId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Datasets: {
                type: "list",
                member: {
                  shape: "S8"
                }
              },
              Count: {
                type: "integer"
              },
              NextToken: {}
            }
          }
        },
        ListIdentityPoolUsage: {
          http: {
            method: "GET",
            requestUri: "/identitypools",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPoolUsages: {
                type: "list",
                member: {
                  shape: "Sg"
                }
              },
              MaxResults: {
                type: "integer"
              },
              Count: {
                type: "integer"
              },
              NextToken: {}
            }
          }
        },
        ListRecords: {
          http: {
            method: "GET",
            requestUri: "/identitypools/{IdentityPoolId}/identities/{IdentityId}/datasets/{DatasetName}/records",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "IdentityId",
              "DatasetName"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              IdentityId: {
                location: "uri",
                locationName: "IdentityId"
              },
              DatasetName: {
                location: "uri",
                locationName: "DatasetName"
              },
              LastSyncCount: {
                location: "querystring",
                locationName: "lastSyncCount",
                type: "long"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              SyncSessionToken: {
                location: "querystring",
                locationName: "syncSessionToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Records: {
                shape: "S1c"
              },
              NextToken: {},
              Count: {
                type: "integer"
              },
              DatasetSyncCount: {
                type: "long"
              },
              LastModifiedBy: {},
              MergedDatasetNames: {
                type: "list",
                member: {}
              },
              DatasetExists: {
                type: "boolean"
              },
              DatasetDeletedAfterRequestedSyncCount: {
                type: "boolean"
              },
              SyncSessionToken: {}
            }
          }
        },
        RegisterDevice: {
          http: {
            requestUri: "/identitypools/{IdentityPoolId}/identity/{IdentityId}/device",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "IdentityId",
              "Platform",
              "Token"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              IdentityId: {
                location: "uri",
                locationName: "IdentityId"
              },
              Platform: {},
              Token: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DeviceId: {}
            }
          }
        },
        SetCognitoEvents: {
          http: {
            requestUri: "/identitypools/{IdentityPoolId}/events",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "Events"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              Events: {
                shape: "Sq"
              }
            }
          }
        },
        SetIdentityPoolConfiguration: {
          http: {
            requestUri: "/identitypools/{IdentityPoolId}/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              PushSync: {
                shape: "Sv"
              },
              CognitoStreams: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityPoolId: {},
              PushSync: {
                shape: "Sv"
              },
              CognitoStreams: {
                shape: "Sz"
              }
            }
          }
        },
        SubscribeToDataset: {
          http: {
            requestUri: "/identitypools/{IdentityPoolId}/identities/{IdentityId}/datasets/{DatasetName}/subscriptions/{DeviceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "IdentityId",
              "DatasetName",
              "DeviceId"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              IdentityId: {
                location: "uri",
                locationName: "IdentityId"
              },
              DatasetName: {
                location: "uri",
                locationName: "DatasetName"
              },
              DeviceId: {
                location: "uri",
                locationName: "DeviceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UnsubscribeFromDataset: {
          http: {
            method: "DELETE",
            requestUri: "/identitypools/{IdentityPoolId}/identities/{IdentityId}/datasets/{DatasetName}/subscriptions/{DeviceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "IdentityId",
              "DatasetName",
              "DeviceId"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              IdentityId: {
                location: "uri",
                locationName: "IdentityId"
              },
              DatasetName: {
                location: "uri",
                locationName: "DatasetName"
              },
              DeviceId: {
                location: "uri",
                locationName: "DeviceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRecords: {
          http: {
            requestUri: "/identitypools/{IdentityPoolId}/identities/{IdentityId}/datasets/{DatasetName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IdentityPoolId",
              "IdentityId",
              "DatasetName",
              "SyncSessionToken"
            ],
            members: {
              IdentityPoolId: {
                location: "uri",
                locationName: "IdentityPoolId"
              },
              IdentityId: {
                location: "uri",
                locationName: "IdentityId"
              },
              DatasetName: {
                location: "uri",
                locationName: "DatasetName"
              },
              DeviceId: {},
              RecordPatches: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Op",
                    "Key",
                    "SyncCount"
                  ],
                  members: {
                    Op: {},
                    Key: {},
                    Value: {},
                    SyncCount: {
                      type: "long"
                    },
                    DeviceLastModifiedDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              SyncSessionToken: {},
              ClientContext: {
                location: "header",
                locationName: "x-amz-Client-Context"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Records: {
                shape: "S1c"
              }
            }
          }
        }
      },
      shapes: {
        S8: {
          type: "structure",
          members: {
            IdentityId: {},
            DatasetName: {},
            CreationDate: {
              type: "timestamp"
            },
            LastModifiedDate: {
              type: "timestamp"
            },
            LastModifiedBy: {},
            DataStorage: {
              type: "long"
            },
            NumRecords: {
              type: "long"
            }
          }
        },
        Sg: {
          type: "structure",
          members: {
            IdentityPoolId: {},
            SyncSessionsCount: {
              type: "long"
            },
            DataStorage: {
              type: "long"
            },
            LastModifiedDate: {
              type: "timestamp"
            }
          }
        },
        Sq: {
          type: "map",
          key: {},
          value: {}
        },
        Sv: {
          type: "structure",
          members: {
            ApplicationArns: {
              type: "list",
              member: {}
            },
            RoleArn: {}
          }
        },
        Sz: {
          type: "structure",
          members: {
            StreamName: {},
            RoleArn: {},
            StreamingStatus: {}
          }
        },
        S1c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {},
              SyncCount: {
                type: "long"
              },
              LastModifiedDate: {
                type: "timestamp"
              },
              LastModifiedBy: {},
              DeviceLastModifiedDate: {
                type: "timestamp"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cognito-sync-2014-06-30.paginators.json
var require_cognito_sync_2014_06_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cognito-sync-2014-06-30.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/cognitosync.js
var require_cognitosync = __commonJS({
  "node_modules/aws-sdk/clients/cognitosync.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["cognitosync"] = {};
    AWS3.CognitoSync = Service.defineService("cognitosync", ["2014-06-30"]);
    Object.defineProperty(apiLoader.services["cognitosync"], "2014-06-30", {
      get: function get() {
        var model = require_cognito_sync_2014_06_30_min();
        model.paginators = require_cognito_sync_2014_06_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CognitoSync;
  }
});

// node_modules/aws-sdk/apis/config-2014-11-12.min.json
var require_config_2014_11_12_min = __commonJS({
  "node_modules/aws-sdk/apis/config-2014-11-12.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-11-12",
        endpointPrefix: "config",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Config Service",
        serviceFullName: "AWS Config",
        serviceId: "Config Service",
        signatureVersion: "v4",
        targetPrefix: "StarlingDoveService",
        uid: "config-2014-11-12"
      },
      operations: {
        BatchGetAggregateResourceConfig: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName",
              "ResourceIdentifiers"
            ],
            members: {
              ConfigurationAggregatorName: {},
              ResourceIdentifiers: {
                type: "list",
                member: {
                  shape: "S4"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BaseConfigurationItems: {
                shape: "Sb"
              },
              UnprocessedResourceIdentifiers: {
                type: "list",
                member: {
                  shape: "S4"
                }
              }
            }
          }
        },
        BatchGetResourceConfig: {
          input: {
            type: "structure",
            required: [
              "resourceKeys"
            ],
            members: {
              resourceKeys: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              baseConfigurationItems: {
                shape: "Sb"
              },
              unprocessedResourceKeys: {
                shape: "Sq"
              }
            }
          }
        },
        DeleteAggregationAuthorization: {
          input: {
            type: "structure",
            required: [
              "AuthorizedAccountId",
              "AuthorizedAwsRegion"
            ],
            members: {
              AuthorizedAccountId: {},
              AuthorizedAwsRegion: {}
            }
          }
        },
        DeleteConfigRule: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleName"
            ],
            members: {
              ConfigRuleName: {}
            }
          }
        },
        DeleteConfigurationAggregator: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName"
            ],
            members: {
              ConfigurationAggregatorName: {}
            }
          }
        },
        DeleteConfigurationRecorder: {
          input: {
            type: "structure",
            required: [
              "ConfigurationRecorderName"
            ],
            members: {
              ConfigurationRecorderName: {}
            }
          }
        },
        DeleteConformancePack: {
          input: {
            type: "structure",
            required: [
              "ConformancePackName"
            ],
            members: {
              ConformancePackName: {}
            }
          }
        },
        DeleteDeliveryChannel: {
          input: {
            type: "structure",
            required: [
              "DeliveryChannelName"
            ],
            members: {
              DeliveryChannelName: {}
            }
          }
        },
        DeleteEvaluationResults: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleName"
            ],
            members: {
              ConfigRuleName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteOrganizationConfigRule: {
          input: {
            type: "structure",
            required: [
              "OrganizationConfigRuleName"
            ],
            members: {
              OrganizationConfigRuleName: {}
            }
          }
        },
        DeleteOrganizationConformancePack: {
          input: {
            type: "structure",
            required: [
              "OrganizationConformancePackName"
            ],
            members: {
              OrganizationConformancePackName: {}
            }
          }
        },
        DeletePendingAggregationRequest: {
          input: {
            type: "structure",
            required: [
              "RequesterAccountId",
              "RequesterAwsRegion"
            ],
            members: {
              RequesterAccountId: {},
              RequesterAwsRegion: {}
            }
          }
        },
        DeleteRemediationConfiguration: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleName"
            ],
            members: {
              ConfigRuleName: {},
              ResourceType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRemediationExceptions: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleName",
              "ResourceKeys"
            ],
            members: {
              ConfigRuleName: {},
              ResourceKeys: {
                shape: "S1f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedBatches: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FailureMessage: {},
                    FailedItems: {
                      shape: "S1f"
                    }
                  }
                }
              }
            }
          }
        },
        DeleteResourceConfig: {
          input: {
            type: "structure",
            required: [
              "ResourceType",
              "ResourceId"
            ],
            members: {
              ResourceType: {},
              ResourceId: {}
            }
          }
        },
        DeleteRetentionConfiguration: {
          input: {
            type: "structure",
            required: [
              "RetentionConfigurationName"
            ],
            members: {
              RetentionConfigurationName: {}
            }
          }
        },
        DeleteStoredQuery: {
          input: {
            type: "structure",
            required: [
              "QueryName"
            ],
            members: {
              QueryName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeliverConfigSnapshot: {
          input: {
            type: "structure",
            required: [
              "deliveryChannelName"
            ],
            members: {
              deliveryChannelName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              configSnapshotId: {}
            }
          }
        },
        DescribeAggregateComplianceByConfigRules: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName"
            ],
            members: {
              ConfigurationAggregatorName: {},
              Filters: {
                type: "structure",
                members: {
                  ConfigRuleName: {},
                  ComplianceType: {},
                  AccountId: {},
                  AwsRegion: {}
                }
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AggregateComplianceByConfigRules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConfigRuleName: {},
                    Compliance: {
                      shape: "S23"
                    },
                    AccountId: {},
                    AwsRegion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAggregateComplianceByConformancePacks: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName"
            ],
            members: {
              ConfigurationAggregatorName: {},
              Filters: {
                type: "structure",
                members: {
                  ConformancePackName: {},
                  ComplianceType: {},
                  AccountId: {},
                  AwsRegion: {}
                }
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AggregateComplianceByConformancePacks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConformancePackName: {},
                    Compliance: {
                      type: "structure",
                      members: {
                        ComplianceType: {},
                        CompliantRuleCount: {
                          type: "integer"
                        },
                        NonCompliantRuleCount: {
                          type: "integer"
                        },
                        TotalRuleCount: {
                          type: "integer"
                        }
                      }
                    },
                    AccountId: {},
                    AwsRegion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAggregationAuthorizations: {
          input: {
            type: "structure",
            members: {
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AggregationAuthorizations: {
                type: "list",
                member: {
                  shape: "S2i"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeComplianceByConfigRule: {
          input: {
            type: "structure",
            members: {
              ConfigRuleNames: {
                shape: "S2l"
              },
              ComplianceTypes: {
                shape: "S2m"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ComplianceByConfigRules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConfigRuleName: {},
                    Compliance: {
                      shape: "S23"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeComplianceByResource: {
          input: {
            type: "structure",
            members: {
              ResourceType: {},
              ResourceId: {},
              ComplianceTypes: {
                shape: "S2m"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ComplianceByResources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceType: {},
                    ResourceId: {},
                    Compliance: {
                      shape: "S23"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeConfigRuleEvaluationStatus: {
          input: {
            type: "structure",
            members: {
              ConfigRuleNames: {
                shape: "S2l"
              },
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigRulesEvaluationStatus: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConfigRuleName: {},
                    ConfigRuleArn: {},
                    ConfigRuleId: {},
                    LastSuccessfulInvocationTime: {
                      type: "timestamp"
                    },
                    LastFailedInvocationTime: {
                      type: "timestamp"
                    },
                    LastSuccessfulEvaluationTime: {
                      type: "timestamp"
                    },
                    LastFailedEvaluationTime: {
                      type: "timestamp"
                    },
                    FirstActivatedTime: {
                      type: "timestamp"
                    },
                    LastDeactivatedTime: {
                      type: "timestamp"
                    },
                    LastErrorCode: {},
                    LastErrorMessage: {},
                    FirstEvaluationStarted: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeConfigRules: {
          input: {
            type: "structure",
            members: {
              ConfigRuleNames: {
                shape: "S2l"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigRules: {
                type: "list",
                member: {
                  shape: "S33"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeConfigurationAggregatorSourcesStatus: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName"
            ],
            members: {
              ConfigurationAggregatorName: {},
              UpdateStatus: {
                type: "list",
                member: {}
              },
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AggregatedSourceStatusList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceId: {},
                    SourceType: {},
                    AwsRegion: {},
                    LastUpdateStatus: {},
                    LastUpdateTime: {
                      type: "timestamp"
                    },
                    LastErrorCode: {},
                    LastErrorMessage: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeConfigurationAggregators: {
          input: {
            type: "structure",
            members: {
              ConfigurationAggregatorNames: {
                type: "list",
                member: {}
              },
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationAggregators: {
                type: "list",
                member: {
                  shape: "S3r"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeConfigurationRecorderStatus: {
          input: {
            type: "structure",
            members: {
              ConfigurationRecorderNames: {
                shape: "S3z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationRecordersStatus: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    lastStartTime: {
                      type: "timestamp"
                    },
                    lastStopTime: {
                      type: "timestamp"
                    },
                    recording: {
                      type: "boolean"
                    },
                    lastStatus: {},
                    lastErrorCode: {},
                    lastErrorMessage: {},
                    lastStatusChangeTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeConfigurationRecorders: {
          input: {
            type: "structure",
            members: {
              ConfigurationRecorderNames: {
                shape: "S3z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationRecorders: {
                type: "list",
                member: {
                  shape: "S47"
                }
              }
            }
          }
        },
        DescribeConformancePackCompliance: {
          input: {
            type: "structure",
            required: [
              "ConformancePackName"
            ],
            members: {
              ConformancePackName: {},
              Filters: {
                type: "structure",
                members: {
                  ConfigRuleNames: {
                    shape: "S4e"
                  },
                  ComplianceType: {}
                }
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ConformancePackName",
              "ConformancePackRuleComplianceList"
            ],
            members: {
              ConformancePackName: {},
              ConformancePackRuleComplianceList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConfigRuleName: {},
                    ComplianceType: {},
                    Controls: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeConformancePackStatus: {
          input: {
            type: "structure",
            members: {
              ConformancePackNames: {
                shape: "S4l"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConformancePackStatusDetails: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ConformancePackName",
                    "ConformancePackId",
                    "ConformancePackArn",
                    "ConformancePackState",
                    "StackArn",
                    "LastUpdateRequestedTime"
                  ],
                  members: {
                    ConformancePackName: {},
                    ConformancePackId: {},
                    ConformancePackArn: {},
                    ConformancePackState: {},
                    StackArn: {},
                    ConformancePackStatusReason: {},
                    LastUpdateRequestedTime: {
                      type: "timestamp"
                    },
                    LastUpdateCompletedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeConformancePacks: {
          input: {
            type: "structure",
            members: {
              ConformancePackNames: {
                shape: "S4l"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConformancePackDetails: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ConformancePackName",
                    "ConformancePackArn",
                    "ConformancePackId"
                  ],
                  members: {
                    ConformancePackName: {},
                    ConformancePackArn: {},
                    ConformancePackId: {},
                    DeliveryS3Bucket: {},
                    DeliveryS3KeyPrefix: {},
                    ConformancePackInputParameters: {
                      shape: "S51"
                    },
                    LastUpdateRequestedTime: {
                      type: "timestamp"
                    },
                    CreatedBy: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeDeliveryChannelStatus: {
          input: {
            type: "structure",
            members: {
              DeliveryChannelNames: {
                shape: "S56"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeliveryChannelsStatus: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    configSnapshotDeliveryInfo: {
                      shape: "S5a"
                    },
                    configHistoryDeliveryInfo: {
                      shape: "S5a"
                    },
                    configStreamDeliveryInfo: {
                      type: "structure",
                      members: {
                        lastStatus: {},
                        lastErrorCode: {},
                        lastErrorMessage: {},
                        lastStatusChangeTime: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeDeliveryChannels: {
          input: {
            type: "structure",
            members: {
              DeliveryChannelNames: {
                shape: "S56"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeliveryChannels: {
                type: "list",
                member: {
                  shape: "S5g"
                }
              }
            }
          }
        },
        DescribeOrganizationConfigRuleStatuses: {
          input: {
            type: "structure",
            members: {
              OrganizationConfigRuleNames: {
                shape: "S5j"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationConfigRuleStatuses: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "OrganizationConfigRuleName",
                    "OrganizationRuleStatus"
                  ],
                  members: {
                    OrganizationConfigRuleName: {},
                    OrganizationRuleStatus: {},
                    ErrorCode: {},
                    ErrorMessage: {},
                    LastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeOrganizationConfigRules: {
          input: {
            type: "structure",
            members: {
              OrganizationConfigRuleNames: {
                shape: "S5j"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationConfigRules: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "OrganizationConfigRuleName",
                    "OrganizationConfigRuleArn"
                  ],
                  members: {
                    OrganizationConfigRuleName: {},
                    OrganizationConfigRuleArn: {},
                    OrganizationManagedRuleMetadata: {
                      shape: "S5t"
                    },
                    OrganizationCustomRuleMetadata: {
                      shape: "S5y"
                    },
                    ExcludedAccounts: {
                      shape: "S61"
                    },
                    LastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeOrganizationConformancePackStatuses: {
          input: {
            type: "structure",
            members: {
              OrganizationConformancePackNames: {
                shape: "S63"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationConformancePackStatuses: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "OrganizationConformancePackName",
                    "Status"
                  ],
                  members: {
                    OrganizationConformancePackName: {},
                    Status: {},
                    ErrorCode: {},
                    ErrorMessage: {},
                    LastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeOrganizationConformancePacks: {
          input: {
            type: "structure",
            members: {
              OrganizationConformancePackNames: {
                shape: "S63"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationConformancePacks: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "OrganizationConformancePackName",
                    "OrganizationConformancePackArn",
                    "LastUpdateTime"
                  ],
                  members: {
                    OrganizationConformancePackName: {},
                    OrganizationConformancePackArn: {},
                    DeliveryS3Bucket: {},
                    DeliveryS3KeyPrefix: {},
                    ConformancePackInputParameters: {
                      shape: "S51"
                    },
                    ExcludedAccounts: {
                      shape: "S61"
                    },
                    LastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribePendingAggregationRequests: {
          input: {
            type: "structure",
            members: {
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PendingAggregationRequests: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RequesterAccountId: {},
                    RequesterAwsRegion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeRemediationConfigurations: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleNames"
            ],
            members: {
              ConfigRuleNames: {
                shape: "S2l"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RemediationConfigurations: {
                shape: "S6j"
              }
            }
          }
        },
        DescribeRemediationExceptions: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleName"
            ],
            members: {
              ConfigRuleName: {},
              ResourceKeys: {
                shape: "S1f"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RemediationExceptions: {
                shape: "S6z"
              },
              NextToken: {}
            }
          }
        },
        DescribeRemediationExecutionStatus: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleName"
            ],
            members: {
              ConfigRuleName: {},
              ResourceKeys: {
                shape: "Sq"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RemediationExecutionStatuses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceKey: {
                      shape: "Sr"
                    },
                    State: {},
                    StepDetails: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {},
                          State: {},
                          ErrorMessage: {},
                          StartTime: {
                            type: "timestamp"
                          },
                          StopTime: {
                            type: "timestamp"
                          }
                        }
                      }
                    },
                    InvocationTime: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeRetentionConfigurations: {
          input: {
            type: "structure",
            members: {
              RetentionConfigurationNames: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RetentionConfigurations: {
                type: "list",
                member: {
                  shape: "S7d"
                }
              },
              NextToken: {}
            }
          }
        },
        GetAggregateComplianceDetailsByConfigRule: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName",
              "ConfigRuleName",
              "AccountId",
              "AwsRegion"
            ],
            members: {
              ConfigurationAggregatorName: {},
              ConfigRuleName: {},
              AccountId: {},
              AwsRegion: {},
              ComplianceType: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AggregateEvaluationResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EvaluationResultIdentifier: {
                      shape: "S7j"
                    },
                    ComplianceType: {},
                    ResultRecordedTime: {
                      type: "timestamp"
                    },
                    ConfigRuleInvokedTime: {
                      type: "timestamp"
                    },
                    Annotation: {},
                    AccountId: {},
                    AwsRegion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetAggregateConfigRuleComplianceSummary: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName"
            ],
            members: {
              ConfigurationAggregatorName: {},
              Filters: {
                type: "structure",
                members: {
                  AccountId: {},
                  AwsRegion: {}
                }
              },
              GroupByKey: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GroupByKey: {},
              AggregateComplianceCounts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GroupName: {},
                    ComplianceSummary: {
                      shape: "S7r"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetAggregateConformancePackComplianceSummary: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName"
            ],
            members: {
              ConfigurationAggregatorName: {},
              Filters: {
                type: "structure",
                members: {
                  AccountId: {},
                  AwsRegion: {}
                }
              },
              GroupByKey: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AggregateConformancePackComplianceSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ComplianceSummary: {
                      type: "structure",
                      members: {
                        CompliantConformancePackCount: {
                          type: "integer"
                        },
                        NonCompliantConformancePackCount: {
                          type: "integer"
                        }
                      }
                    },
                    GroupName: {}
                  }
                }
              },
              GroupByKey: {},
              NextToken: {}
            }
          }
        },
        GetAggregateDiscoveredResourceCounts: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName"
            ],
            members: {
              ConfigurationAggregatorName: {},
              Filters: {
                type: "structure",
                members: {
                  ResourceType: {},
                  AccountId: {},
                  Region: {}
                }
              },
              GroupByKey: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TotalDiscoveredResources"
            ],
            members: {
              TotalDiscoveredResources: {
                type: "long"
              },
              GroupByKey: {},
              GroupedResourceCounts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "GroupName",
                    "ResourceCount"
                  ],
                  members: {
                    GroupName: {},
                    ResourceCount: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetAggregateResourceConfig: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName",
              "ResourceIdentifier"
            ],
            members: {
              ConfigurationAggregatorName: {},
              ResourceIdentifier: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationItem: {
                shape: "S88"
              }
            }
          }
        },
        GetComplianceDetailsByConfigRule: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleName"
            ],
            members: {
              ConfigRuleName: {},
              ComplianceTypes: {
                shape: "S2m"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EvaluationResults: {
                shape: "S8k"
              },
              NextToken: {}
            }
          }
        },
        GetComplianceDetailsByResource: {
          input: {
            type: "structure",
            required: [
              "ResourceType",
              "ResourceId"
            ],
            members: {
              ResourceType: {},
              ResourceId: {},
              ComplianceTypes: {
                shape: "S2m"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EvaluationResults: {
                shape: "S8k"
              },
              NextToken: {}
            }
          }
        },
        GetComplianceSummaryByConfigRule: {
          output: {
            type: "structure",
            members: {
              ComplianceSummary: {
                shape: "S7r"
              }
            }
          }
        },
        GetComplianceSummaryByResourceType: {
          input: {
            type: "structure",
            members: {
              ResourceTypes: {
                shape: "S8q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ComplianceSummariesByResourceType: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceType: {},
                    ComplianceSummary: {
                      shape: "S7r"
                    }
                  }
                }
              }
            }
          }
        },
        GetConformancePackComplianceDetails: {
          input: {
            type: "structure",
            required: [
              "ConformancePackName"
            ],
            members: {
              ConformancePackName: {},
              Filters: {
                type: "structure",
                members: {
                  ConfigRuleNames: {
                    shape: "S4e"
                  },
                  ComplianceType: {},
                  ResourceType: {},
                  ResourceIds: {
                    type: "list",
                    member: {}
                  }
                }
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ConformancePackName"
            ],
            members: {
              ConformancePackName: {},
              ConformancePackRuleEvaluationResults: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ComplianceType",
                    "EvaluationResultIdentifier",
                    "ConfigRuleInvokedTime",
                    "ResultRecordedTime"
                  ],
                  members: {
                    ComplianceType: {},
                    EvaluationResultIdentifier: {
                      shape: "S7j"
                    },
                    ConfigRuleInvokedTime: {
                      type: "timestamp"
                    },
                    ResultRecordedTime: {
                      type: "timestamp"
                    },
                    Annotation: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetConformancePackComplianceSummary: {
          input: {
            type: "structure",
            required: [
              "ConformancePackNames"
            ],
            members: {
              ConformancePackNames: {
                type: "list",
                member: {}
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConformancePackComplianceSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ConformancePackName",
                    "ConformancePackComplianceStatus"
                  ],
                  members: {
                    ConformancePackName: {},
                    ConformancePackComplianceStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetDiscoveredResourceCounts: {
          input: {
            type: "structure",
            members: {
              resourceTypes: {
                shape: "S8q"
              },
              limit: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              totalDiscoveredResources: {
                type: "long"
              },
              resourceCounts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    resourceType: {},
                    count: {
                      type: "long"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetOrganizationConfigRuleDetailedStatus: {
          input: {
            type: "structure",
            required: [
              "OrganizationConfigRuleName"
            ],
            members: {
              OrganizationConfigRuleName: {},
              Filters: {
                type: "structure",
                members: {
                  AccountId: {},
                  MemberAccountRuleStatus: {}
                }
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationConfigRuleDetailedStatus: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AccountId",
                    "ConfigRuleName",
                    "MemberAccountRuleStatus"
                  ],
                  members: {
                    AccountId: {},
                    ConfigRuleName: {},
                    MemberAccountRuleStatus: {},
                    ErrorCode: {},
                    ErrorMessage: {},
                    LastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetOrganizationConformancePackDetailedStatus: {
          input: {
            type: "structure",
            required: [
              "OrganizationConformancePackName"
            ],
            members: {
              OrganizationConformancePackName: {},
              Filters: {
                type: "structure",
                members: {
                  AccountId: {},
                  Status: {}
                }
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationConformancePackDetailedStatuses: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AccountId",
                    "ConformancePackName",
                    "Status"
                  ],
                  members: {
                    AccountId: {},
                    ConformancePackName: {},
                    Status: {},
                    ErrorCode: {},
                    ErrorMessage: {},
                    LastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetResourceConfigHistory: {
          input: {
            type: "structure",
            required: [
              "resourceType",
              "resourceId"
            ],
            members: {
              resourceType: {},
              resourceId: {},
              laterTime: {
                type: "timestamp"
              },
              earlierTime: {
                type: "timestamp"
              },
              chronologicalOrder: {},
              limit: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              configurationItems: {
                type: "list",
                member: {
                  shape: "S88"
                }
              },
              nextToken: {}
            }
          }
        },
        GetStoredQuery: {
          input: {
            type: "structure",
            required: [
              "QueryName"
            ],
            members: {
              QueryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StoredQuery: {
                shape: "S9v"
              }
            }
          }
        },
        ListAggregateDiscoveredResources: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName",
              "ResourceType"
            ],
            members: {
              ConfigurationAggregatorName: {},
              ResourceType: {},
              Filters: {
                type: "structure",
                members: {
                  AccountId: {},
                  ResourceId: {},
                  ResourceName: {},
                  Region: {}
                }
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceIdentifiers: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              NextToken: {}
            }
          }
        },
        ListDiscoveredResources: {
          input: {
            type: "structure",
            required: [
              "resourceType"
            ],
            members: {
              resourceType: {},
              resourceIds: {
                type: "list",
                member: {}
              },
              resourceName: {},
              limit: {
                type: "integer"
              },
              includeDeletedResources: {
                type: "boolean"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceIdentifiers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    resourceType: {},
                    resourceId: {},
                    resourceName: {},
                    resourceDeletionTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListStoredQueries: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StoredQueryMetadata: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "QueryId",
                    "QueryArn",
                    "QueryName"
                  ],
                  members: {
                    QueryId: {},
                    QueryArn: {},
                    QueryName: {},
                    Description: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sah"
              },
              NextToken: {}
            }
          }
        },
        PutAggregationAuthorization: {
          input: {
            type: "structure",
            required: [
              "AuthorizedAccountId",
              "AuthorizedAwsRegion"
            ],
            members: {
              AuthorizedAccountId: {},
              AuthorizedAwsRegion: {},
              Tags: {
                shape: "Sam"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AggregationAuthorization: {
                shape: "S2i"
              }
            }
          }
        },
        PutConfigRule: {
          input: {
            type: "structure",
            required: [
              "ConfigRule"
            ],
            members: {
              ConfigRule: {
                shape: "S33"
              },
              Tags: {
                shape: "Sam"
              }
            }
          }
        },
        PutConfigurationAggregator: {
          input: {
            type: "structure",
            required: [
              "ConfigurationAggregatorName"
            ],
            members: {
              ConfigurationAggregatorName: {},
              AccountAggregationSources: {
                shape: "S3t"
              },
              OrganizationAggregationSource: {
                shape: "S3x"
              },
              Tags: {
                shape: "Sam"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationAggregator: {
                shape: "S3r"
              }
            }
          }
        },
        PutConfigurationRecorder: {
          input: {
            type: "structure",
            required: [
              "ConfigurationRecorder"
            ],
            members: {
              ConfigurationRecorder: {
                shape: "S47"
              }
            }
          }
        },
        PutConformancePack: {
          input: {
            type: "structure",
            required: [
              "ConformancePackName"
            ],
            members: {
              ConformancePackName: {},
              TemplateS3Uri: {},
              TemplateBody: {},
              DeliveryS3Bucket: {},
              DeliveryS3KeyPrefix: {},
              ConformancePackInputParameters: {
                shape: "S51"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConformancePackArn: {}
            }
          }
        },
        PutDeliveryChannel: {
          input: {
            type: "structure",
            required: [
              "DeliveryChannel"
            ],
            members: {
              DeliveryChannel: {
                shape: "S5g"
              }
            }
          }
        },
        PutEvaluations: {
          input: {
            type: "structure",
            required: [
              "ResultToken"
            ],
            members: {
              Evaluations: {
                shape: "Say"
              },
              ResultToken: {},
              TestMode: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEvaluations: {
                shape: "Say"
              }
            }
          }
        },
        PutExternalEvaluation: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleName",
              "ExternalEvaluation"
            ],
            members: {
              ConfigRuleName: {},
              ExternalEvaluation: {
                type: "structure",
                required: [
                  "ComplianceResourceType",
                  "ComplianceResourceId",
                  "ComplianceType",
                  "OrderingTimestamp"
                ],
                members: {
                  ComplianceResourceType: {},
                  ComplianceResourceId: {},
                  ComplianceType: {},
                  Annotation: {},
                  OrderingTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutOrganizationConfigRule: {
          input: {
            type: "structure",
            required: [
              "OrganizationConfigRuleName"
            ],
            members: {
              OrganizationConfigRuleName: {},
              OrganizationManagedRuleMetadata: {
                shape: "S5t"
              },
              OrganizationCustomRuleMetadata: {
                shape: "S5y"
              },
              ExcludedAccounts: {
                shape: "S61"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationConfigRuleArn: {}
            }
          }
        },
        PutOrganizationConformancePack: {
          input: {
            type: "structure",
            required: [
              "OrganizationConformancePackName"
            ],
            members: {
              OrganizationConformancePackName: {},
              TemplateS3Uri: {},
              TemplateBody: {},
              DeliveryS3Bucket: {},
              DeliveryS3KeyPrefix: {},
              ConformancePackInputParameters: {
                shape: "S51"
              },
              ExcludedAccounts: {
                shape: "S61"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationConformancePackArn: {}
            }
          }
        },
        PutRemediationConfigurations: {
          input: {
            type: "structure",
            required: [
              "RemediationConfigurations"
            ],
            members: {
              RemediationConfigurations: {
                shape: "S6j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedBatches: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FailureMessage: {},
                    FailedItems: {
                      shape: "S6j"
                    }
                  }
                }
              }
            }
          }
        },
        PutRemediationExceptions: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleName",
              "ResourceKeys"
            ],
            members: {
              ConfigRuleName: {},
              ResourceKeys: {
                shape: "S1f"
              },
              Message: {},
              ExpirationTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedBatches: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FailureMessage: {},
                    FailedItems: {
                      shape: "S6z"
                    }
                  }
                }
              }
            }
          }
        },
        PutResourceConfig: {
          input: {
            type: "structure",
            required: [
              "ResourceType",
              "SchemaVersionId",
              "ResourceId",
              "Configuration"
            ],
            members: {
              ResourceType: {},
              SchemaVersionId: {},
              ResourceId: {},
              ResourceName: {},
              Configuration: {},
              Tags: {
                shape: "S8a"
              }
            }
          }
        },
        PutRetentionConfiguration: {
          input: {
            type: "structure",
            required: [
              "RetentionPeriodInDays"
            ],
            members: {
              RetentionPeriodInDays: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RetentionConfiguration: {
                shape: "S7d"
              }
            }
          }
        },
        PutStoredQuery: {
          input: {
            type: "structure",
            required: [
              "StoredQuery"
            ],
            members: {
              StoredQuery: {
                shape: "S9v"
              },
              Tags: {
                shape: "Sam"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QueryArn: {}
            }
          }
        },
        SelectAggregateResourceConfig: {
          input: {
            type: "structure",
            required: [
              "Expression",
              "ConfigurationAggregatorName"
            ],
            members: {
              Expression: {},
              ConfigurationAggregatorName: {},
              Limit: {
                type: "integer"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                shape: "Sbq"
              },
              QueryInfo: {
                shape: "Sbr"
              },
              NextToken: {}
            }
          }
        },
        SelectResourceConfig: {
          input: {
            type: "structure",
            required: [
              "Expression"
            ],
            members: {
              Expression: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                shape: "Sbq"
              },
              QueryInfo: {
                shape: "Sbr"
              },
              NextToken: {}
            }
          }
        },
        StartConfigRulesEvaluation: {
          input: {
            type: "structure",
            members: {
              ConfigRuleNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartConfigurationRecorder: {
          input: {
            type: "structure",
            required: [
              "ConfigurationRecorderName"
            ],
            members: {
              ConfigurationRecorderName: {}
            }
          }
        },
        StartRemediationExecution: {
          input: {
            type: "structure",
            required: [
              "ConfigRuleName",
              "ResourceKeys"
            ],
            members: {
              ConfigRuleName: {},
              ResourceKeys: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailureMessage: {},
              FailedItems: {
                shape: "Sq"
              }
            }
          }
        },
        StopConfigurationRecorder: {
          input: {
            type: "structure",
            required: [
              "ConfigurationRecorderName"
            ],
            members: {
              ConfigurationRecorderName: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sah"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "SourceAccountId",
            "SourceRegion",
            "ResourceId",
            "ResourceType"
          ],
          members: {
            SourceAccountId: {},
            SourceRegion: {},
            ResourceId: {},
            ResourceType: {},
            ResourceName: {}
          }
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            members: {
              version: {},
              accountId: {},
              configurationItemCaptureTime: {
                type: "timestamp"
              },
              configurationItemStatus: {},
              configurationStateId: {},
              arn: {},
              resourceType: {},
              resourceId: {},
              resourceName: {},
              awsRegion: {},
              availabilityZone: {},
              resourceCreationTime: {
                type: "timestamp"
              },
              configuration: {},
              supplementaryConfiguration: {
                shape: "Sl"
              }
            }
          }
        },
        Sl: {
          type: "map",
          key: {},
          value: {}
        },
        Sq: {
          type: "list",
          member: {
            shape: "Sr"
          }
        },
        Sr: {
          type: "structure",
          required: [
            "resourceType",
            "resourceId"
          ],
          members: {
            resourceType: {},
            resourceId: {}
          }
        },
        S1f: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceType: {},
              ResourceId: {}
            }
          }
        },
        S23: {
          type: "structure",
          members: {
            ComplianceType: {},
            ComplianceContributorCount: {
              shape: "S24"
            }
          }
        },
        S24: {
          type: "structure",
          members: {
            CappedCount: {
              type: "integer"
            },
            CapExceeded: {
              type: "boolean"
            }
          }
        },
        S2i: {
          type: "structure",
          members: {
            AggregationAuthorizationArn: {},
            AuthorizedAccountId: {},
            AuthorizedAwsRegion: {},
            CreationTime: {
              type: "timestamp"
            }
          }
        },
        S2l: {
          type: "list",
          member: {}
        },
        S2m: {
          type: "list",
          member: {}
        },
        S33: {
          type: "structure",
          required: [
            "Source"
          ],
          members: {
            ConfigRuleName: {},
            ConfigRuleArn: {},
            ConfigRuleId: {},
            Description: {},
            Scope: {
              type: "structure",
              members: {
                ComplianceResourceTypes: {
                  type: "list",
                  member: {}
                },
                TagKey: {},
                TagValue: {},
                ComplianceResourceId: {}
              }
            },
            Source: {
              type: "structure",
              required: [
                "Owner",
                "SourceIdentifier"
              ],
              members: {
                Owner: {},
                SourceIdentifier: {},
                SourceDetails: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      EventSource: {},
                      MessageType: {},
                      MaximumExecutionFrequency: {}
                    }
                  }
                }
              }
            },
            InputParameters: {},
            MaximumExecutionFrequency: {},
            ConfigRuleState: {},
            CreatedBy: {}
          }
        },
        S3r: {
          type: "structure",
          members: {
            ConfigurationAggregatorName: {},
            ConfigurationAggregatorArn: {},
            AccountAggregationSources: {
              shape: "S3t"
            },
            OrganizationAggregationSource: {
              shape: "S3x"
            },
            CreationTime: {
              type: "timestamp"
            },
            LastUpdatedTime: {
              type: "timestamp"
            },
            CreatedBy: {}
          }
        },
        S3t: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AccountIds"
            ],
            members: {
              AccountIds: {
                type: "list",
                member: {}
              },
              AllAwsRegions: {
                type: "boolean"
              },
              AwsRegions: {
                shape: "S3w"
              }
            }
          }
        },
        S3w: {
          type: "list",
          member: {}
        },
        S3x: {
          type: "structure",
          required: [
            "RoleArn"
          ],
          members: {
            RoleArn: {},
            AwsRegions: {
              shape: "S3w"
            },
            AllAwsRegions: {
              type: "boolean"
            }
          }
        },
        S3z: {
          type: "list",
          member: {}
        },
        S47: {
          type: "structure",
          members: {
            name: {},
            roleARN: {},
            recordingGroup: {
              type: "structure",
              members: {
                allSupported: {
                  type: "boolean"
                },
                includeGlobalResourceTypes: {
                  type: "boolean"
                },
                resourceTypes: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        S4e: {
          type: "list",
          member: {}
        },
        S4l: {
          type: "list",
          member: {}
        },
        S51: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ParameterName",
              "ParameterValue"
            ],
            members: {
              ParameterName: {},
              ParameterValue: {}
            }
          }
        },
        S56: {
          type: "list",
          member: {}
        },
        S5a: {
          type: "structure",
          members: {
            lastStatus: {},
            lastErrorCode: {},
            lastErrorMessage: {},
            lastAttemptTime: {
              type: "timestamp"
            },
            lastSuccessfulTime: {
              type: "timestamp"
            },
            nextDeliveryTime: {
              type: "timestamp"
            }
          }
        },
        S5g: {
          type: "structure",
          members: {
            name: {},
            s3BucketName: {},
            s3KeyPrefix: {},
            s3KmsKeyArn: {},
            snsTopicARN: {},
            configSnapshotDeliveryProperties: {
              type: "structure",
              members: {
                deliveryFrequency: {}
              }
            }
          }
        },
        S5j: {
          type: "list",
          member: {}
        },
        S5t: {
          type: "structure",
          required: [
            "RuleIdentifier"
          ],
          members: {
            Description: {},
            RuleIdentifier: {},
            InputParameters: {},
            MaximumExecutionFrequency: {},
            ResourceTypesScope: {
              shape: "S5w"
            },
            ResourceIdScope: {},
            TagKeyScope: {},
            TagValueScope: {}
          }
        },
        S5w: {
          type: "list",
          member: {}
        },
        S5y: {
          type: "structure",
          required: [
            "LambdaFunctionArn",
            "OrganizationConfigRuleTriggerTypes"
          ],
          members: {
            Description: {},
            LambdaFunctionArn: {},
            OrganizationConfigRuleTriggerTypes: {
              type: "list",
              member: {}
            },
            InputParameters: {},
            MaximumExecutionFrequency: {},
            ResourceTypesScope: {
              shape: "S5w"
            },
            ResourceIdScope: {},
            TagKeyScope: {},
            TagValueScope: {}
          }
        },
        S61: {
          type: "list",
          member: {}
        },
        S63: {
          type: "list",
          member: {}
        },
        S6j: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ConfigRuleName",
              "TargetType",
              "TargetId"
            ],
            members: {
              ConfigRuleName: {},
              TargetType: {},
              TargetId: {},
              TargetVersion: {},
              Parameters: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    ResourceValue: {
                      type: "structure",
                      required: [
                        "Value"
                      ],
                      members: {
                        Value: {}
                      }
                    },
                    StaticValue: {
                      type: "structure",
                      required: [
                        "Values"
                      ],
                      members: {
                        Values: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                }
              },
              ResourceType: {},
              Automatic: {
                type: "boolean"
              },
              ExecutionControls: {
                type: "structure",
                members: {
                  SsmControls: {
                    type: "structure",
                    members: {
                      ConcurrentExecutionRatePercentage: {
                        type: "integer"
                      },
                      ErrorPercentage: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              MaximumAutomaticAttempts: {
                type: "integer"
              },
              RetryAttemptSeconds: {
                type: "long"
              },
              Arn: {},
              CreatedByService: {}
            }
          }
        },
        S6z: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ConfigRuleName",
              "ResourceType",
              "ResourceId"
            ],
            members: {
              ConfigRuleName: {},
              ResourceType: {},
              ResourceId: {},
              Message: {},
              ExpirationTime: {
                type: "timestamp"
              }
            }
          }
        },
        S7d: {
          type: "structure",
          required: [
            "Name",
            "RetentionPeriodInDays"
          ],
          members: {
            Name: {},
            RetentionPeriodInDays: {
              type: "integer"
            }
          }
        },
        S7j: {
          type: "structure",
          members: {
            EvaluationResultQualifier: {
              type: "structure",
              members: {
                ConfigRuleName: {},
                ResourceType: {},
                ResourceId: {}
              }
            },
            OrderingTimestamp: {
              type: "timestamp"
            }
          }
        },
        S7r: {
          type: "structure",
          members: {
            CompliantResourceCount: {
              shape: "S24"
            },
            NonCompliantResourceCount: {
              shape: "S24"
            },
            ComplianceSummaryTimestamp: {
              type: "timestamp"
            }
          }
        },
        S88: {
          type: "structure",
          members: {
            version: {},
            accountId: {},
            configurationItemCaptureTime: {
              type: "timestamp"
            },
            configurationItemStatus: {},
            configurationStateId: {},
            configurationItemMD5Hash: {},
            arn: {},
            resourceType: {},
            resourceId: {},
            resourceName: {},
            awsRegion: {},
            availabilityZone: {},
            resourceCreationTime: {
              type: "timestamp"
            },
            tags: {
              shape: "S8a"
            },
            relatedEvents: {
              type: "list",
              member: {}
            },
            relationships: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  resourceType: {},
                  resourceId: {},
                  resourceName: {},
                  relationshipName: {}
                }
              }
            },
            configuration: {},
            supplementaryConfiguration: {
              shape: "Sl"
            }
          }
        },
        S8a: {
          type: "map",
          key: {},
          value: {}
        },
        S8k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              EvaluationResultIdentifier: {
                shape: "S7j"
              },
              ComplianceType: {},
              ResultRecordedTime: {
                type: "timestamp"
              },
              ConfigRuleInvokedTime: {
                type: "timestamp"
              },
              Annotation: {},
              ResultToken: {}
            }
          }
        },
        S8q: {
          type: "list",
          member: {}
        },
        S9v: {
          type: "structure",
          required: [
            "QueryName"
          ],
          members: {
            QueryId: {},
            QueryArn: {},
            QueryName: {},
            Description: {},
            Expression: {}
          }
        },
        Sah: {
          type: "list",
          member: {
            shape: "Sai"
          }
        },
        Sai: {
          type: "structure",
          members: {
            Key: {},
            Value: {}
          }
        },
        Sam: {
          type: "list",
          member: {
            shape: "Sai"
          }
        },
        Say: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ComplianceResourceType",
              "ComplianceResourceId",
              "ComplianceType",
              "OrderingTimestamp"
            ],
            members: {
              ComplianceResourceType: {},
              ComplianceResourceId: {},
              ComplianceType: {},
              Annotation: {},
              OrderingTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        Sbq: {
          type: "list",
          member: {}
        },
        Sbr: {
          type: "structure",
          members: {
            SelectFields: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {}
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/config-2014-11-12.paginators.json
var require_config_2014_11_12_paginators = __commonJS({
  "node_modules/aws-sdk/apis/config-2014-11-12.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeAggregateComplianceByConfigRules: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken"
        },
        DescribeAggregateComplianceByConformancePacks: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "AggregateComplianceByConformancePacks"
        },
        DescribeAggregationAuthorizations: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "AggregationAuthorizations"
        },
        DescribeComplianceByConfigRule: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "ComplianceByConfigRules"
        },
        DescribeComplianceByResource: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "ComplianceByResources"
        },
        DescribeConfigRuleEvaluationStatus: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "ConfigRulesEvaluationStatus"
        },
        DescribeConfigRules: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "ConfigRules"
        },
        DescribeConfigurationAggregatorSourcesStatus: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "AggregatedSourceStatusList"
        },
        DescribeConfigurationAggregators: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "ConfigurationAggregators"
        },
        DescribeConformancePackCompliance: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken"
        },
        DescribeConformancePackStatus: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "ConformancePackStatusDetails"
        },
        DescribeConformancePacks: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "ConformancePackDetails"
        },
        DescribeOrganizationConfigRuleStatuses: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "OrganizationConfigRuleStatuses"
        },
        DescribeOrganizationConfigRules: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "OrganizationConfigRules"
        },
        DescribeOrganizationConformancePackStatuses: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "OrganizationConformancePackStatuses"
        },
        DescribeOrganizationConformancePacks: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "OrganizationConformancePacks"
        },
        DescribePendingAggregationRequests: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "PendingAggregationRequests"
        },
        DescribeRemediationExceptions: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken"
        },
        DescribeRemediationExecutionStatus: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "RemediationExecutionStatuses"
        },
        DescribeRetentionConfigurations: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "RetentionConfigurations"
        },
        GetAggregateComplianceDetailsByConfigRule: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "AggregateEvaluationResults"
        },
        GetAggregateConfigRuleComplianceSummary: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken"
        },
        GetAggregateConformancePackComplianceSummary: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken"
        },
        GetAggregateDiscoveredResourceCounts: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken"
        },
        GetComplianceDetailsByConfigRule: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "EvaluationResults"
        },
        GetComplianceDetailsByResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "EvaluationResults"
        },
        GetConformancePackComplianceDetails: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken"
        },
        GetConformancePackComplianceSummary: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "ConformancePackComplianceSummaryList"
        },
        GetDiscoveredResourceCounts: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken"
        },
        GetOrganizationConfigRuleDetailedStatus: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "OrganizationConfigRuleDetailedStatus"
        },
        GetOrganizationConformancePackDetailedStatus: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "OrganizationConformancePackDetailedStatuses"
        },
        GetResourceConfigHistory: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "configurationItems"
        },
        ListAggregateDiscoveredResources: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "ResourceIdentifiers"
        },
        ListDiscoveredResources: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "resourceIdentifiers"
        },
        ListStoredQueries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Tags"
        },
        SelectAggregateResourceConfig: {
          input_token: "NextToken",
          limit_key: "Limit",
          non_aggregate_keys: [
            "QueryInfo"
          ],
          output_token: "NextToken",
          result_key: "Results"
        },
        SelectResourceConfig: {
          input_token: "NextToken",
          limit_key: "Limit",
          non_aggregate_keys: [
            "QueryInfo"
          ],
          output_token: "NextToken",
          result_key: "Results"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/configservice.js
var require_configservice = __commonJS({
  "node_modules/aws-sdk/clients/configservice.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["configservice"] = {};
    AWS3.ConfigService = Service.defineService("configservice", ["2014-11-12"]);
    Object.defineProperty(apiLoader.services["configservice"], "2014-11-12", {
      get: function get() {
        var model = require_config_2014_11_12_min();
        model.paginators = require_config_2014_11_12_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ConfigService;
  }
});

// node_modules/aws-sdk/apis/cur-2017-01-06.min.json
var require_cur_2017_01_06_min = __commonJS({
  "node_modules/aws-sdk/apis/cur-2017-01-06.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-01-06",
        endpointPrefix: "cur",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Cost and Usage Report Service",
        serviceId: "Cost and Usage Report Service",
        signatureVersion: "v4",
        signingName: "cur",
        targetPrefix: "AWSOrigamiServiceGatewayService",
        uid: "cur-2017-01-06"
      },
      operations: {
        DeleteReportDefinition: {
          input: {
            type: "structure",
            members: {
              ReportName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResponseMessage: {}
            }
          }
        },
        DescribeReportDefinitions: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReportDefinitions: {
                type: "list",
                member: {
                  shape: "Sa"
                }
              },
              NextToken: {}
            }
          }
        },
        ModifyReportDefinition: {
          input: {
            type: "structure",
            required: [
              "ReportName",
              "ReportDefinition"
            ],
            members: {
              ReportName: {},
              ReportDefinition: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutReportDefinition: {
          input: {
            type: "structure",
            required: [
              "ReportDefinition"
            ],
            members: {
              ReportDefinition: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sa: {
          type: "structure",
          required: [
            "ReportName",
            "TimeUnit",
            "Format",
            "Compression",
            "AdditionalSchemaElements",
            "S3Bucket",
            "S3Prefix",
            "S3Region"
          ],
          members: {
            ReportName: {},
            TimeUnit: {},
            Format: {},
            Compression: {},
            AdditionalSchemaElements: {
              type: "list",
              member: {}
            },
            S3Bucket: {},
            S3Prefix: {},
            S3Region: {},
            AdditionalArtifacts: {
              type: "list",
              member: {}
            },
            RefreshClosedReports: {
              type: "boolean"
            },
            ReportVersioning: {},
            BillingViewArn: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cur-2017-01-06.paginators.json
var require_cur_2017_01_06_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cur-2017-01-06.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeReportDefinitions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cur.js
var require_cur = __commonJS({
  "node_modules/aws-sdk/clients/cur.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["cur"] = {};
    AWS3.CUR = Service.defineService("cur", ["2017-01-06"]);
    Object.defineProperty(apiLoader.services["cur"], "2017-01-06", {
      get: function get() {
        var model = require_cur_2017_01_06_min();
        model.paginators = require_cur_2017_01_06_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CUR;
  }
});

// node_modules/aws-sdk/apis/datapipeline-2012-10-29.min.json
var require_datapipeline_2012_10_29_min = __commonJS({
  "node_modules/aws-sdk/apis/datapipeline-2012-10-29.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2012-10-29",
        endpointPrefix: "datapipeline",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Data Pipeline",
        serviceId: "Data Pipeline",
        signatureVersion: "v4",
        targetPrefix: "DataPipeline",
        uid: "datapipeline-2012-10-29"
      },
      operations: {
        ActivatePipeline: {
          input: {
            type: "structure",
            required: [
              "pipelineId"
            ],
            members: {
              pipelineId: {},
              parameterValues: {
                shape: "S3"
              },
              startTimestamp: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AddTags: {
          input: {
            type: "structure",
            required: [
              "pipelineId",
              "tags"
            ],
            members: {
              pipelineId: {},
              tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreatePipeline: {
          input: {
            type: "structure",
            required: [
              "name",
              "uniqueId"
            ],
            members: {
              name: {},
              uniqueId: {},
              description: {},
              tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "pipelineId"
            ],
            members: {
              pipelineId: {}
            }
          }
        },
        DeactivatePipeline: {
          input: {
            type: "structure",
            required: [
              "pipelineId"
            ],
            members: {
              pipelineId: {},
              cancelActive: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePipeline: {
          input: {
            type: "structure",
            required: [
              "pipelineId"
            ],
            members: {
              pipelineId: {}
            }
          }
        },
        DescribeObjects: {
          input: {
            type: "structure",
            required: [
              "pipelineId",
              "objectIds"
            ],
            members: {
              pipelineId: {},
              objectIds: {
                shape: "Sn"
              },
              evaluateExpressions: {
                type: "boolean"
              },
              marker: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "pipelineObjects"
            ],
            members: {
              pipelineObjects: {
                shape: "Sq"
              },
              marker: {},
              hasMoreResults: {
                type: "boolean"
              }
            }
          }
        },
        DescribePipelines: {
          input: {
            type: "structure",
            required: [
              "pipelineIds"
            ],
            members: {
              pipelineIds: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "pipelineDescriptionList"
            ],
            members: {
              pipelineDescriptionList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "pipelineId",
                    "name",
                    "fields"
                  ],
                  members: {
                    pipelineId: {},
                    name: {},
                    fields: {
                      shape: "Ss"
                    },
                    description: {},
                    tags: {
                      shape: "Sa"
                    }
                  }
                }
              }
            }
          }
        },
        EvaluateExpression: {
          input: {
            type: "structure",
            required: [
              "pipelineId",
              "objectId",
              "expression"
            ],
            members: {
              pipelineId: {},
              objectId: {},
              expression: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "evaluatedExpression"
            ],
            members: {
              evaluatedExpression: {}
            }
          }
        },
        GetPipelineDefinition: {
          input: {
            type: "structure",
            required: [
              "pipelineId"
            ],
            members: {
              pipelineId: {},
              version: {}
            }
          },
          output: {
            type: "structure",
            members: {
              pipelineObjects: {
                shape: "Sq"
              },
              parameterObjects: {
                shape: "S13"
              },
              parameterValues: {
                shape: "S3"
              }
            }
          }
        },
        ListPipelines: {
          input: {
            type: "structure",
            members: {
              marker: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "pipelineIdList"
            ],
            members: {
              pipelineIdList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    name: {}
                  }
                }
              },
              marker: {},
              hasMoreResults: {
                type: "boolean"
              }
            }
          }
        },
        PollForTask: {
          input: {
            type: "structure",
            required: [
              "workerGroup"
            ],
            members: {
              workerGroup: {},
              hostname: {},
              instanceIdentity: {
                type: "structure",
                members: {
                  document: {},
                  signature: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskObject: {
                type: "structure",
                members: {
                  taskId: {},
                  pipelineId: {},
                  attemptId: {},
                  objects: {
                    type: "map",
                    key: {},
                    value: {
                      shape: "Sr"
                    }
                  }
                }
              }
            }
          }
        },
        PutPipelineDefinition: {
          input: {
            type: "structure",
            required: [
              "pipelineId",
              "pipelineObjects"
            ],
            members: {
              pipelineId: {},
              pipelineObjects: {
                shape: "Sq"
              },
              parameterObjects: {
                shape: "S13"
              },
              parameterValues: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "errored"
            ],
            members: {
              validationErrors: {
                shape: "S1l"
              },
              validationWarnings: {
                shape: "S1p"
              },
              errored: {
                type: "boolean"
              }
            }
          }
        },
        QueryObjects: {
          input: {
            type: "structure",
            required: [
              "pipelineId",
              "sphere"
            ],
            members: {
              pipelineId: {},
              query: {
                type: "structure",
                members: {
                  selectors: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        fieldName: {},
                        operator: {
                          type: "structure",
                          members: {
                            type: {},
                            values: {
                              shape: "S1x"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              sphere: {},
              marker: {},
              limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ids: {
                shape: "Sn"
              },
              marker: {},
              hasMoreResults: {
                type: "boolean"
              }
            }
          }
        },
        RemoveTags: {
          input: {
            type: "structure",
            required: [
              "pipelineId",
              "tagKeys"
            ],
            members: {
              pipelineId: {},
              tagKeys: {
                shape: "S1x"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ReportTaskProgress: {
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {},
              fields: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "canceled"
            ],
            members: {
              canceled: {
                type: "boolean"
              }
            }
          }
        },
        ReportTaskRunnerHeartbeat: {
          input: {
            type: "structure",
            required: [
              "taskrunnerId"
            ],
            members: {
              taskrunnerId: {},
              workerGroup: {},
              hostname: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "terminate"
            ],
            members: {
              terminate: {
                type: "boolean"
              }
            }
          }
        },
        SetStatus: {
          input: {
            type: "structure",
            required: [
              "pipelineId",
              "objectIds",
              "status"
            ],
            members: {
              pipelineId: {},
              objectIds: {
                shape: "Sn"
              },
              status: {}
            }
          }
        },
        SetTaskStatus: {
          input: {
            type: "structure",
            required: [
              "taskId",
              "taskStatus"
            ],
            members: {
              taskId: {},
              taskStatus: {},
              errorId: {},
              errorMessage: {},
              errorStackTrace: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ValidatePipelineDefinition: {
          input: {
            type: "structure",
            required: [
              "pipelineId",
              "pipelineObjects"
            ],
            members: {
              pipelineId: {},
              pipelineObjects: {
                shape: "Sq"
              },
              parameterObjects: {
                shape: "S13"
              },
              parameterValues: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "errored"
            ],
            members: {
              validationErrors: {
                shape: "S1l"
              },
              validationWarnings: {
                shape: "S1p"
              },
              errored: {
                type: "boolean"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "id",
              "stringValue"
            ],
            members: {
              id: {},
              stringValue: {}
            }
          }
        },
        Sa: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sn: {
          type: "list",
          member: {}
        },
        Sq: {
          type: "list",
          member: {
            shape: "Sr"
          }
        },
        Sr: {
          type: "structure",
          required: [
            "id",
            "name",
            "fields"
          ],
          members: {
            id: {},
            name: {},
            fields: {
              shape: "Ss"
            }
          }
        },
        Ss: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key"
            ],
            members: {
              key: {},
              stringValue: {},
              refValue: {}
            }
          }
        },
        S13: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "id",
              "attributes"
            ],
            members: {
              id: {},
              attributes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "key",
                    "stringValue"
                  ],
                  members: {
                    key: {},
                    stringValue: {}
                  }
                }
              }
            }
          }
        },
        S1l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              errors: {
                shape: "S1n"
              }
            }
          }
        },
        S1n: {
          type: "list",
          member: {}
        },
        S1p: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              warnings: {
                shape: "S1n"
              }
            }
          }
        },
        S1x: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/datapipeline-2012-10-29.paginators.json
var require_datapipeline_2012_10_29_paginators = __commonJS({
  "node_modules/aws-sdk/apis/datapipeline-2012-10-29.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeObjects: {
          input_token: "marker",
          more_results: "hasMoreResults",
          output_token: "marker",
          result_key: "pipelineObjects"
        },
        DescribePipelines: {
          result_key: "pipelineDescriptionList"
        },
        ListPipelines: {
          input_token: "marker",
          more_results: "hasMoreResults",
          output_token: "marker",
          result_key: "pipelineIdList"
        },
        QueryObjects: {
          input_token: "marker",
          limit_key: "limit",
          more_results: "hasMoreResults",
          output_token: "marker",
          result_key: "ids"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/datapipeline.js
var require_datapipeline = __commonJS({
  "node_modules/aws-sdk/clients/datapipeline.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["datapipeline"] = {};
    AWS3.DataPipeline = Service.defineService("datapipeline", ["2012-10-29"]);
    Object.defineProperty(apiLoader.services["datapipeline"], "2012-10-29", {
      get: function get() {
        var model = require_datapipeline_2012_10_29_min();
        model.paginators = require_datapipeline_2012_10_29_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.DataPipeline;
  }
});

// node_modules/aws-sdk/apis/devicefarm-2015-06-23.min.json
var require_devicefarm_2015_06_23_min = __commonJS({
  "node_modules/aws-sdk/apis/devicefarm-2015-06-23.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-06-23",
        endpointPrefix: "devicefarm",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Device Farm",
        serviceId: "Device Farm",
        signatureVersion: "v4",
        targetPrefix: "DeviceFarm_20150623",
        uid: "devicefarm-2015-06-23"
      },
      operations: {
        CreateDevicePool: {
          input: {
            type: "structure",
            required: [
              "projectArn",
              "name",
              "rules"
            ],
            members: {
              projectArn: {},
              name: {},
              description: {},
              rules: {
                shape: "S5"
              },
              maxDevices: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              devicePool: {
                shape: "Sc"
              }
            }
          }
        },
        CreateInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              packageCleanup: {
                type: "boolean"
              },
              excludeAppPackagesFromCleanup: {
                shape: "Sg"
              },
              rebootAfterUse: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              instanceProfile: {
                shape: "Si"
              }
            }
          }
        },
        CreateNetworkProfile: {
          input: {
            type: "structure",
            required: [
              "projectArn",
              "name"
            ],
            members: {
              projectArn: {},
              name: {},
              description: {},
              type: {},
              uplinkBandwidthBits: {
                type: "long"
              },
              downlinkBandwidthBits: {
                type: "long"
              },
              uplinkDelayMs: {
                type: "long"
              },
              downlinkDelayMs: {
                type: "long"
              },
              uplinkJitterMs: {
                type: "long"
              },
              downlinkJitterMs: {
                type: "long"
              },
              uplinkLossPercent: {
                type: "integer"
              },
              downlinkLossPercent: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              networkProfile: {
                shape: "So"
              }
            }
          }
        },
        CreateProject: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              defaultJobTimeoutMinutes: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              project: {
                shape: "Ss"
              }
            }
          }
        },
        CreateRemoteAccessSession: {
          input: {
            type: "structure",
            required: [
              "projectArn",
              "deviceArn"
            ],
            members: {
              projectArn: {},
              deviceArn: {},
              instanceArn: {},
              sshPublicKey: {},
              remoteDebugEnabled: {
                type: "boolean"
              },
              remoteRecordEnabled: {
                type: "boolean"
              },
              remoteRecordAppArn: {},
              name: {},
              clientId: {},
              configuration: {
                type: "structure",
                members: {
                  billingMethod: {},
                  vpceConfigurationArns: {
                    shape: "Sz"
                  }
                }
              },
              interactionMode: {},
              skipAppResign: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              remoteAccessSession: {
                shape: "S12"
              }
            }
          }
        },
        CreateTestGridProject: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              vpcConfig: {
                shape: "S1m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              testGridProject: {
                shape: "S1r"
              }
            }
          }
        },
        CreateTestGridUrl: {
          input: {
            type: "structure",
            required: [
              "projectArn",
              "expiresInSeconds"
            ],
            members: {
              projectArn: {},
              expiresInSeconds: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              url: {
                shape: "S1w"
              },
              expires: {
                type: "timestamp"
              }
            }
          }
        },
        CreateUpload: {
          input: {
            type: "structure",
            required: [
              "projectArn",
              "name",
              "type"
            ],
            members: {
              projectArn: {},
              name: {},
              type: {},
              contentType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              upload: {
                shape: "S21"
              }
            }
          }
        },
        CreateVPCEConfiguration: {
          input: {
            type: "structure",
            required: [
              "vpceConfigurationName",
              "vpceServiceName",
              "serviceDnsName"
            ],
            members: {
              vpceConfigurationName: {},
              vpceServiceName: {},
              serviceDnsName: {},
              vpceConfigurationDescription: {}
            }
          },
          output: {
            type: "structure",
            members: {
              vpceConfiguration: {
                shape: "S2c"
              }
            }
          }
        },
        DeleteDevicePool: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteNetworkProfile: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteProject: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRemoteAccessSession: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRun: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTestGridProject: {
          input: {
            type: "structure",
            required: [
              "projectArn"
            ],
            members: {
              projectArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteUpload: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteVPCEConfiguration: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAccountSettings: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              accountSettings: {
                type: "structure",
                members: {
                  awsAccountNumber: {},
                  unmeteredDevices: {
                    shape: "S2z"
                  },
                  unmeteredRemoteAccessDevices: {
                    shape: "S2z"
                  },
                  maxJobTimeoutMinutes: {
                    type: "integer"
                  },
                  trialMinutes: {
                    type: "structure",
                    members: {
                      total: {
                        type: "double"
                      },
                      remaining: {
                        type: "double"
                      }
                    }
                  },
                  maxSlots: {
                    type: "map",
                    key: {},
                    value: {
                      type: "integer"
                    }
                  },
                  defaultJobTimeoutMinutes: {
                    type: "integer"
                  },
                  skipAppResign: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        GetDevice: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              device: {
                shape: "S15"
              }
            }
          }
        },
        GetDeviceInstance: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deviceInstance: {
                shape: "S1c"
              }
            }
          }
        },
        GetDevicePool: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              devicePool: {
                shape: "Sc"
              }
            }
          }
        },
        GetDevicePoolCompatibility: {
          input: {
            type: "structure",
            required: [
              "devicePoolArn"
            ],
            members: {
              devicePoolArn: {},
              appArn: {},
              testType: {},
              test: {
                shape: "S3a"
              },
              configuration: {
                shape: "S3d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              compatibleDevices: {
                shape: "S3l"
              },
              incompatibleDevices: {
                shape: "S3l"
              }
            }
          }
        },
        GetInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              instanceProfile: {
                shape: "Si"
              }
            }
          }
        },
        GetJob: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              job: {
                shape: "S3t"
              }
            }
          }
        },
        GetNetworkProfile: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              networkProfile: {
                shape: "So"
              }
            }
          }
        },
        GetOfferingStatus: {
          input: {
            type: "structure",
            members: {
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              current: {
                shape: "S41"
              },
              nextPeriod: {
                shape: "S41"
              },
              nextToken: {}
            }
          }
        },
        GetProject: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              project: {
                shape: "Ss"
              }
            }
          }
        },
        GetRemoteAccessSession: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              remoteAccessSession: {
                shape: "S12"
              }
            }
          }
        },
        GetRun: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              run: {
                shape: "S4i"
              }
            }
          }
        },
        GetSuite: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              suite: {
                shape: "S4r"
              }
            }
          }
        },
        GetTest: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              test: {
                shape: "S4u"
              }
            }
          }
        },
        GetTestGridProject: {
          input: {
            type: "structure",
            required: [
              "projectArn"
            ],
            members: {
              projectArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              testGridProject: {
                shape: "S1r"
              }
            }
          }
        },
        GetTestGridSession: {
          input: {
            type: "structure",
            members: {
              projectArn: {},
              sessionId: {},
              sessionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              testGridSession: {
                shape: "S50"
              }
            }
          }
        },
        GetUpload: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              upload: {
                shape: "S21"
              }
            }
          }
        },
        GetVPCEConfiguration: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              vpceConfiguration: {
                shape: "S2c"
              }
            }
          }
        },
        InstallToRemoteAccessSession: {
          input: {
            type: "structure",
            required: [
              "remoteAccessSessionArn",
              "appArn"
            ],
            members: {
              remoteAccessSessionArn: {},
              appArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              appUpload: {
                shape: "S21"
              }
            }
          }
        },
        ListArtifacts: {
          input: {
            type: "structure",
            required: [
              "arn",
              "type"
            ],
            members: {
              arn: {},
              type: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              artifacts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    type: {},
                    extension: {},
                    url: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDeviceInstances: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deviceInstances: {
                shape: "S1b"
              },
              nextToken: {}
            }
          }
        },
        ListDevicePools: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              type: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              devicePools: {
                type: "list",
                member: {
                  shape: "Sc"
                }
              },
              nextToken: {}
            }
          }
        },
        ListDevices: {
          input: {
            type: "structure",
            members: {
              arn: {},
              nextToken: {},
              filters: {
                shape: "S4l"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              devices: {
                type: "list",
                member: {
                  shape: "S15"
                }
              },
              nextToken: {}
            }
          }
        },
        ListInstanceProfiles: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              instanceProfiles: {
                type: "list",
                member: {
                  shape: "Si"
                }
              },
              nextToken: {}
            }
          }
        },
        ListJobs: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              jobs: {
                type: "list",
                member: {
                  shape: "S3t"
                }
              },
              nextToken: {}
            }
          }
        },
        ListNetworkProfiles: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              type: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              networkProfiles: {
                type: "list",
                member: {
                  shape: "So"
                }
              },
              nextToken: {}
            }
          }
        },
        ListOfferingPromotions: {
          input: {
            type: "structure",
            members: {
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              offeringPromotions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    description: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListOfferingTransactions: {
          input: {
            type: "structure",
            members: {
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              offeringTransactions: {
                type: "list",
                member: {
                  shape: "S64"
                }
              },
              nextToken: {}
            }
          }
        },
        ListOfferings: {
          input: {
            type: "structure",
            members: {
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              offerings: {
                type: "list",
                member: {
                  shape: "S45"
                }
              },
              nextToken: {}
            }
          }
        },
        ListProjects: {
          input: {
            type: "structure",
            members: {
              arn: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              projects: {
                type: "list",
                member: {
                  shape: "Ss"
                }
              },
              nextToken: {}
            }
          }
        },
        ListRemoteAccessSessions: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              remoteAccessSessions: {
                type: "list",
                member: {
                  shape: "S12"
                }
              },
              nextToken: {}
            }
          }
        },
        ListRuns: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              runs: {
                type: "list",
                member: {
                  shape: "S4i"
                }
              },
              nextToken: {}
            }
          }
        },
        ListSamples: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              samples: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    type: {},
                    url: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSuites: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              suites: {
                type: "list",
                member: {
                  shape: "S4r"
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S6s"
              }
            }
          }
        },
        ListTestGridProjects: {
          input: {
            type: "structure",
            members: {
              maxResult: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              testGridProjects: {
                type: "list",
                member: {
                  shape: "S1r"
                }
              },
              nextToken: {}
            }
          }
        },
        ListTestGridSessionActions: {
          input: {
            type: "structure",
            required: [
              "sessionArn"
            ],
            members: {
              sessionArn: {},
              maxResult: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              actions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    action: {},
                    started: {
                      type: "timestamp"
                    },
                    duration: {
                      type: "long"
                    },
                    statusCode: {},
                    requestMethod: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTestGridSessionArtifacts: {
          input: {
            type: "structure",
            required: [
              "sessionArn"
            ],
            members: {
              sessionArn: {},
              type: {},
              maxResult: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              artifacts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    filename: {},
                    type: {},
                    url: {
                      shape: "S1w"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTestGridSessions: {
          input: {
            type: "structure",
            required: [
              "projectArn"
            ],
            members: {
              projectArn: {},
              status: {},
              creationTimeAfter: {
                type: "timestamp"
              },
              creationTimeBefore: {
                type: "timestamp"
              },
              endTimeAfter: {
                type: "timestamp"
              },
              endTimeBefore: {
                type: "timestamp"
              },
              maxResult: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              testGridSessions: {
                type: "list",
                member: {
                  shape: "S50"
                }
              },
              nextToken: {}
            }
          }
        },
        ListTests: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tests: {
                type: "list",
                member: {
                  shape: "S4u"
                }
              },
              nextToken: {}
            }
          }
        },
        ListUniqueProblems: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              uniqueProblems: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      message: {},
                      problems: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            run: {
                              shape: "S7n"
                            },
                            job: {
                              shape: "S7n"
                            },
                            suite: {
                              shape: "S7n"
                            },
                            test: {
                              shape: "S7n"
                            },
                            device: {
                              shape: "S15"
                            },
                            result: {},
                            message: {}
                          }
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListUploads: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              type: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              uploads: {
                type: "list",
                member: {
                  shape: "S21"
                }
              },
              nextToken: {}
            }
          }
        },
        ListVPCEConfigurations: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              vpceConfigurations: {
                type: "list",
                member: {
                  shape: "S2c"
                }
              },
              nextToken: {}
            }
          }
        },
        PurchaseOffering: {
          input: {
            type: "structure",
            required: [
              "offeringId",
              "quantity"
            ],
            members: {
              offeringId: {},
              quantity: {
                type: "integer"
              },
              offeringPromotionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              offeringTransaction: {
                shape: "S64"
              }
            }
          }
        },
        RenewOffering: {
          input: {
            type: "structure",
            required: [
              "offeringId",
              "quantity"
            ],
            members: {
              offeringId: {},
              quantity: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              offeringTransaction: {
                shape: "S64"
              }
            }
          }
        },
        ScheduleRun: {
          input: {
            type: "structure",
            required: [
              "projectArn",
              "test"
            ],
            members: {
              projectArn: {},
              appArn: {},
              devicePoolArn: {},
              deviceSelectionConfiguration: {
                type: "structure",
                required: [
                  "filters",
                  "maxDevices"
                ],
                members: {
                  filters: {
                    shape: "S4l"
                  },
                  maxDevices: {
                    type: "integer"
                  }
                }
              },
              name: {},
              test: {
                shape: "S3a"
              },
              configuration: {
                shape: "S3d"
              },
              executionConfiguration: {
                type: "structure",
                members: {
                  jobTimeoutMinutes: {
                    type: "integer"
                  },
                  accountsCleanup: {
                    type: "boolean"
                  },
                  appPackagesCleanup: {
                    type: "boolean"
                  },
                  videoCapture: {
                    type: "boolean"
                  },
                  skipAppResign: {
                    type: "boolean"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              run: {
                shape: "S4i"
              }
            }
          }
        },
        StopJob: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              job: {
                shape: "S3t"
              }
            }
          }
        },
        StopRemoteAccessSession: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              remoteAccessSession: {
                shape: "S12"
              }
            }
          }
        },
        StopRun: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              run: {
                shape: "S4i"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S6s"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDeviceInstance: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              profileArn: {},
              labels: {
                shape: "S1d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deviceInstance: {
                shape: "S1c"
              }
            }
          }
        },
        UpdateDevicePool: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              name: {},
              description: {},
              rules: {
                shape: "S5"
              },
              maxDevices: {
                type: "integer"
              },
              clearMaxDevices: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              devicePool: {
                shape: "Sc"
              }
            }
          }
        },
        UpdateInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              name: {},
              description: {},
              packageCleanup: {
                type: "boolean"
              },
              excludeAppPackagesFromCleanup: {
                shape: "Sg"
              },
              rebootAfterUse: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              instanceProfile: {
                shape: "Si"
              }
            }
          }
        },
        UpdateNetworkProfile: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              name: {},
              description: {},
              type: {},
              uplinkBandwidthBits: {
                type: "long"
              },
              downlinkBandwidthBits: {
                type: "long"
              },
              uplinkDelayMs: {
                type: "long"
              },
              downlinkDelayMs: {
                type: "long"
              },
              uplinkJitterMs: {
                type: "long"
              },
              downlinkJitterMs: {
                type: "long"
              },
              uplinkLossPercent: {
                type: "integer"
              },
              downlinkLossPercent: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              networkProfile: {
                shape: "So"
              }
            }
          }
        },
        UpdateProject: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              name: {},
              defaultJobTimeoutMinutes: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              project: {
                shape: "Ss"
              }
            }
          }
        },
        UpdateTestGridProject: {
          input: {
            type: "structure",
            required: [
              "projectArn"
            ],
            members: {
              projectArn: {},
              name: {},
              description: {},
              vpcConfig: {
                shape: "S1m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              testGridProject: {
                shape: "S1r"
              }
            }
          }
        },
        UpdateUpload: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              name: {},
              contentType: {},
              editContent: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              upload: {
                shape: "S21"
              }
            }
          }
        },
        UpdateVPCEConfiguration: {
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              vpceConfigurationName: {},
              vpceServiceName: {},
              serviceDnsName: {},
              vpceConfigurationDescription: {}
            }
          },
          output: {
            type: "structure",
            members: {
              vpceConfiguration: {
                shape: "S2c"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {
            type: "structure",
            members: {
              attribute: {},
              operator: {},
              value: {}
            }
          }
        },
        Sc: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            description: {},
            type: {},
            rules: {
              shape: "S5"
            },
            maxDevices: {
              type: "integer"
            }
          }
        },
        Sg: {
          type: "list",
          member: {}
        },
        Si: {
          type: "structure",
          members: {
            arn: {},
            packageCleanup: {
              type: "boolean"
            },
            excludeAppPackagesFromCleanup: {
              shape: "Sg"
            },
            rebootAfterUse: {
              type: "boolean"
            },
            name: {},
            description: {}
          }
        },
        So: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            description: {},
            type: {},
            uplinkBandwidthBits: {
              type: "long"
            },
            downlinkBandwidthBits: {
              type: "long"
            },
            uplinkDelayMs: {
              type: "long"
            },
            downlinkDelayMs: {
              type: "long"
            },
            uplinkJitterMs: {
              type: "long"
            },
            downlinkJitterMs: {
              type: "long"
            },
            uplinkLossPercent: {
              type: "integer"
            },
            downlinkLossPercent: {
              type: "integer"
            }
          }
        },
        Ss: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            defaultJobTimeoutMinutes: {
              type: "integer"
            },
            created: {
              type: "timestamp"
            }
          }
        },
        Sz: {
          type: "list",
          member: {}
        },
        S12: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            created: {
              type: "timestamp"
            },
            status: {},
            result: {},
            message: {},
            started: {
              type: "timestamp"
            },
            stopped: {
              type: "timestamp"
            },
            device: {
              shape: "S15"
            },
            instanceArn: {},
            remoteDebugEnabled: {
              type: "boolean"
            },
            remoteRecordEnabled: {
              type: "boolean"
            },
            remoteRecordAppArn: {},
            hostAddress: {},
            clientId: {},
            billingMethod: {},
            deviceMinutes: {
              shape: "S1h"
            },
            endpoint: {},
            deviceUdid: {},
            interactionMode: {},
            skipAppResign: {
              type: "boolean"
            }
          }
        },
        S15: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            manufacturer: {},
            model: {},
            modelId: {},
            formFactor: {},
            platform: {},
            os: {},
            cpu: {
              type: "structure",
              members: {
                frequency: {},
                architecture: {},
                clock: {
                  type: "double"
                }
              }
            },
            resolution: {
              type: "structure",
              members: {
                width: {
                  type: "integer"
                },
                height: {
                  type: "integer"
                }
              }
            },
            heapSize: {
              type: "long"
            },
            memory: {
              type: "long"
            },
            image: {},
            carrier: {},
            radio: {},
            remoteAccessEnabled: {
              type: "boolean"
            },
            remoteDebugEnabled: {
              type: "boolean"
            },
            fleetType: {},
            fleetName: {},
            instances: {
              shape: "S1b"
            },
            availability: {}
          }
        },
        S1b: {
          type: "list",
          member: {
            shape: "S1c"
          }
        },
        S1c: {
          type: "structure",
          members: {
            arn: {},
            deviceArn: {},
            labels: {
              shape: "S1d"
            },
            status: {},
            udid: {},
            instanceProfile: {
              shape: "Si"
            }
          }
        },
        S1d: {
          type: "list",
          member: {}
        },
        S1h: {
          type: "structure",
          members: {
            total: {
              type: "double"
            },
            metered: {
              type: "double"
            },
            unmetered: {
              type: "double"
            }
          }
        },
        S1m: {
          type: "structure",
          required: [
            "securityGroupIds",
            "subnetIds",
            "vpcId"
          ],
          members: {
            securityGroupIds: {
              type: "list",
              member: {}
            },
            subnetIds: {
              type: "list",
              member: {}
            },
            vpcId: {}
          }
        },
        S1r: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            description: {},
            vpcConfig: {
              shape: "S1m"
            },
            created: {
              type: "timestamp"
            }
          }
        },
        S1w: {
          type: "string",
          sensitive: true
        },
        S21: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            created: {
              type: "timestamp"
            },
            type: {},
            status: {},
            url: {
              type: "string",
              sensitive: true
            },
            metadata: {},
            contentType: {},
            message: {},
            category: {}
          }
        },
        S2c: {
          type: "structure",
          members: {
            arn: {},
            vpceConfigurationName: {},
            vpceServiceName: {},
            serviceDnsName: {},
            vpceConfigurationDescription: {}
          }
        },
        S2z: {
          type: "map",
          key: {},
          value: {
            type: "integer"
          }
        },
        S3a: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            testPackageArn: {},
            testSpecArn: {},
            filter: {},
            parameters: {
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        S3d: {
          type: "structure",
          members: {
            extraDataPackageArn: {},
            networkProfileArn: {},
            locale: {},
            location: {
              shape: "S3e"
            },
            vpceConfigurationArns: {
              shape: "Sz"
            },
            customerArtifactPaths: {
              shape: "S3f"
            },
            radios: {
              shape: "S3j"
            },
            auxiliaryApps: {
              shape: "Sz"
            },
            billingMethod: {}
          }
        },
        S3e: {
          type: "structure",
          required: [
            "latitude",
            "longitude"
          ],
          members: {
            latitude: {
              type: "double"
            },
            longitude: {
              type: "double"
            }
          }
        },
        S3f: {
          type: "structure",
          members: {
            iosPaths: {
              type: "list",
              member: {}
            },
            androidPaths: {
              type: "list",
              member: {}
            },
            deviceHostPaths: {
              type: "list",
              member: {}
            }
          }
        },
        S3j: {
          type: "structure",
          members: {
            wifi: {
              type: "boolean"
            },
            bluetooth: {
              type: "boolean"
            },
            nfc: {
              type: "boolean"
            },
            gps: {
              type: "boolean"
            }
          }
        },
        S3l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              device: {
                shape: "S15"
              },
              compatible: {
                type: "boolean"
              },
              incompatibilityMessages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    message: {},
                    type: {}
                  }
                }
              }
            }
          }
        },
        S3t: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            type: {},
            created: {
              type: "timestamp"
            },
            status: {},
            result: {},
            started: {
              type: "timestamp"
            },
            stopped: {
              type: "timestamp"
            },
            counters: {
              shape: "S3u"
            },
            message: {},
            device: {
              shape: "S15"
            },
            instanceArn: {},
            deviceMinutes: {
              shape: "S1h"
            },
            videoEndpoint: {},
            videoCapture: {
              type: "boolean"
            }
          }
        },
        S3u: {
          type: "structure",
          members: {
            total: {
              type: "integer"
            },
            passed: {
              type: "integer"
            },
            failed: {
              type: "integer"
            },
            warned: {
              type: "integer"
            },
            errored: {
              type: "integer"
            },
            stopped: {
              type: "integer"
            },
            skipped: {
              type: "integer"
            }
          }
        },
        S41: {
          type: "map",
          key: {},
          value: {
            shape: "S43"
          }
        },
        S43: {
          type: "structure",
          members: {
            type: {},
            offering: {
              shape: "S45"
            },
            quantity: {
              type: "integer"
            },
            effectiveOn: {
              type: "timestamp"
            }
          }
        },
        S45: {
          type: "structure",
          members: {
            id: {},
            description: {},
            type: {},
            platform: {},
            recurringCharges: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  cost: {
                    shape: "S49"
                  },
                  frequency: {}
                }
              }
            }
          }
        },
        S49: {
          type: "structure",
          members: {
            amount: {
              type: "double"
            },
            currencyCode: {}
          }
        },
        S4i: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            type: {},
            platform: {},
            created: {
              type: "timestamp"
            },
            status: {},
            result: {},
            started: {
              type: "timestamp"
            },
            stopped: {
              type: "timestamp"
            },
            counters: {
              shape: "S3u"
            },
            message: {},
            totalJobs: {
              type: "integer"
            },
            completedJobs: {
              type: "integer"
            },
            billingMethod: {},
            deviceMinutes: {
              shape: "S1h"
            },
            networkProfile: {
              shape: "So"
            },
            parsingResultUrl: {},
            resultCode: {},
            seed: {
              type: "integer"
            },
            appUpload: {},
            eventCount: {
              type: "integer"
            },
            jobTimeoutMinutes: {
              type: "integer"
            },
            devicePoolArn: {},
            locale: {},
            radios: {
              shape: "S3j"
            },
            location: {
              shape: "S3e"
            },
            customerArtifactPaths: {
              shape: "S3f"
            },
            webUrl: {},
            skipAppResign: {
              type: "boolean"
            },
            testSpecArn: {},
            deviceSelectionResult: {
              type: "structure",
              members: {
                filters: {
                  shape: "S4l"
                },
                matchedDevicesCount: {
                  type: "integer"
                },
                maxDevices: {
                  type: "integer"
                }
              }
            }
          }
        },
        S4l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "attribute",
              "operator",
              "values"
            ],
            members: {
              attribute: {},
              operator: {},
              values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S4r: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            type: {},
            created: {
              type: "timestamp"
            },
            status: {},
            result: {},
            started: {
              type: "timestamp"
            },
            stopped: {
              type: "timestamp"
            },
            counters: {
              shape: "S3u"
            },
            message: {},
            deviceMinutes: {
              shape: "S1h"
            }
          }
        },
        S4u: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            type: {},
            created: {
              type: "timestamp"
            },
            status: {},
            result: {},
            started: {
              type: "timestamp"
            },
            stopped: {
              type: "timestamp"
            },
            counters: {
              shape: "S3u"
            },
            message: {},
            deviceMinutes: {
              shape: "S1h"
            }
          }
        },
        S50: {
          type: "structure",
          members: {
            arn: {},
            status: {},
            created: {
              type: "timestamp"
            },
            ended: {
              type: "timestamp"
            },
            billingMinutes: {
              type: "double"
            },
            seleniumProperties: {}
          }
        },
        S64: {
          type: "structure",
          members: {
            offeringStatus: {
              shape: "S43"
            },
            transactionId: {},
            offeringPromotionId: {},
            createdOn: {
              type: "timestamp"
            },
            cost: {
              shape: "S49"
            }
          }
        },
        S6s: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S7n: {
          type: "structure",
          members: {
            arn: {},
            name: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/devicefarm-2015-06-23.paginators.json
var require_devicefarm_2015_06_23_paginators = __commonJS({
  "node_modules/aws-sdk/apis/devicefarm-2015-06-23.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetOfferingStatus: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: [
            "current",
            "nextPeriod"
          ]
        },
        ListArtifacts: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "artifacts"
        },
        ListDevicePools: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "devicePools"
        },
        ListDevices: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "devices"
        },
        ListJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "jobs"
        },
        ListOfferingTransactions: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "offeringTransactions"
        },
        ListOfferings: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "offerings"
        },
        ListProjects: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "projects"
        },
        ListRuns: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "runs"
        },
        ListSamples: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "samples"
        },
        ListSuites: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "suites"
        },
        ListTestGridProjects: {
          input_token: "nextToken",
          limit_key: "maxResult",
          output_token: "nextToken"
        },
        ListTestGridSessionActions: {
          input_token: "nextToken",
          limit_key: "maxResult",
          output_token: "nextToken"
        },
        ListTestGridSessionArtifacts: {
          input_token: "nextToken",
          limit_key: "maxResult",
          output_token: "nextToken"
        },
        ListTestGridSessions: {
          input_token: "nextToken",
          limit_key: "maxResult",
          output_token: "nextToken"
        },
        ListTests: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "tests"
        },
        ListUniqueProblems: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "uniqueProblems"
        },
        ListUploads: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "uploads"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/devicefarm.js
var require_devicefarm = __commonJS({
  "node_modules/aws-sdk/clients/devicefarm.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["devicefarm"] = {};
    AWS3.DeviceFarm = Service.defineService("devicefarm", ["2015-06-23"]);
    Object.defineProperty(apiLoader.services["devicefarm"], "2015-06-23", {
      get: function get() {
        var model = require_devicefarm_2015_06_23_min();
        model.paginators = require_devicefarm_2015_06_23_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.DeviceFarm;
  }
});

// node_modules/aws-sdk/apis/directconnect-2012-10-25.min.json
var require_directconnect_2012_10_25_min = __commonJS({
  "node_modules/aws-sdk/apis/directconnect-2012-10-25.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2012-10-25",
        endpointPrefix: "directconnect",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Direct Connect",
        serviceId: "Direct Connect",
        signatureVersion: "v4",
        targetPrefix: "OvertureService",
        uid: "directconnect-2012-10-25"
      },
      operations: {
        AcceptDirectConnectGatewayAssociationProposal: {
          input: {
            type: "structure",
            required: [
              "directConnectGatewayId",
              "proposalId",
              "associatedGatewayOwnerAccount"
            ],
            members: {
              directConnectGatewayId: {},
              proposalId: {},
              associatedGatewayOwnerAccount: {},
              overrideAllowedPrefixesToDirectConnectGateway: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGatewayAssociation: {
                shape: "S9"
              }
            }
          }
        },
        AllocateConnectionOnInterconnect: {
          input: {
            type: "structure",
            required: [
              "bandwidth",
              "connectionName",
              "ownerAccount",
              "interconnectId",
              "vlan"
            ],
            members: {
              bandwidth: {},
              connectionName: {},
              ownerAccount: {},
              interconnectId: {},
              vlan: {
                type: "integer"
              }
            }
          },
          output: {
            shape: "So"
          },
          deprecated: true
        },
        AllocateHostedConnection: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "ownerAccount",
              "bandwidth",
              "connectionName",
              "vlan"
            ],
            members: {
              connectionId: {},
              ownerAccount: {},
              bandwidth: {},
              connectionName: {},
              vlan: {
                type: "integer"
              },
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            shape: "So"
          }
        },
        AllocatePrivateVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "ownerAccount",
              "newPrivateVirtualInterfaceAllocation"
            ],
            members: {
              connectionId: {},
              ownerAccount: {},
              newPrivateVirtualInterfaceAllocation: {
                type: "structure",
                required: [
                  "virtualInterfaceName",
                  "vlan",
                  "asn"
                ],
                members: {
                  virtualInterfaceName: {},
                  vlan: {
                    type: "integer"
                  },
                  asn: {
                    type: "integer"
                  },
                  mtu: {
                    type: "integer"
                  },
                  authKey: {},
                  amazonAddress: {},
                  addressFamily: {},
                  customerAddress: {},
                  tags: {
                    shape: "S10"
                  }
                }
              }
            }
          },
          output: {
            shape: "S1o"
          }
        },
        AllocatePublicVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "ownerAccount",
              "newPublicVirtualInterfaceAllocation"
            ],
            members: {
              connectionId: {},
              ownerAccount: {},
              newPublicVirtualInterfaceAllocation: {
                type: "structure",
                required: [
                  "virtualInterfaceName",
                  "vlan",
                  "asn"
                ],
                members: {
                  virtualInterfaceName: {},
                  vlan: {
                    type: "integer"
                  },
                  asn: {
                    type: "integer"
                  },
                  authKey: {},
                  amazonAddress: {},
                  customerAddress: {},
                  addressFamily: {},
                  routeFilterPrefixes: {
                    shape: "S5"
                  },
                  tags: {
                    shape: "S10"
                  }
                }
              }
            }
          },
          output: {
            shape: "S1o"
          }
        },
        AllocateTransitVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "ownerAccount",
              "newTransitVirtualInterfaceAllocation"
            ],
            members: {
              connectionId: {},
              ownerAccount: {},
              newTransitVirtualInterfaceAllocation: {
                type: "structure",
                members: {
                  virtualInterfaceName: {},
                  vlan: {
                    type: "integer"
                  },
                  asn: {
                    type: "integer"
                  },
                  mtu: {
                    type: "integer"
                  },
                  authKey: {},
                  amazonAddress: {},
                  customerAddress: {},
                  addressFamily: {},
                  tags: {
                    shape: "S10"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterface: {
                shape: "S1o"
              }
            }
          }
        },
        AssociateConnectionWithLag: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "lagId"
            ],
            members: {
              connectionId: {},
              lagId: {}
            }
          },
          output: {
            shape: "So"
          }
        },
        AssociateHostedConnection: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "parentConnectionId"
            ],
            members: {
              connectionId: {},
              parentConnectionId: {}
            }
          },
          output: {
            shape: "So"
          }
        },
        AssociateMacSecKey: {
          input: {
            type: "structure",
            required: [
              "connectionId"
            ],
            members: {
              connectionId: {},
              secretARN: {},
              ckn: {},
              cak: {}
            }
          },
          output: {
            type: "structure",
            members: {
              connectionId: {},
              macSecKeys: {
                shape: "S18"
              }
            }
          }
        },
        AssociateVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "virtualInterfaceId",
              "connectionId"
            ],
            members: {
              virtualInterfaceId: {},
              connectionId: {}
            }
          },
          output: {
            shape: "S1o"
          }
        },
        ConfirmConnection: {
          input: {
            type: "structure",
            required: [
              "connectionId"
            ],
            members: {
              connectionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              connectionState: {}
            }
          }
        },
        ConfirmPrivateVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "virtualInterfaceId"
            ],
            members: {
              virtualInterfaceId: {},
              virtualGatewayId: {},
              directConnectGatewayId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterfaceState: {}
            }
          }
        },
        ConfirmPublicVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "virtualInterfaceId"
            ],
            members: {
              virtualInterfaceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterfaceState: {}
            }
          }
        },
        ConfirmTransitVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "virtualInterfaceId",
              "directConnectGatewayId"
            ],
            members: {
              virtualInterfaceId: {},
              directConnectGatewayId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterfaceState: {}
            }
          }
        },
        CreateBGPPeer: {
          input: {
            type: "structure",
            members: {
              virtualInterfaceId: {},
              newBGPPeer: {
                type: "structure",
                members: {
                  asn: {
                    type: "integer"
                  },
                  authKey: {},
                  addressFamily: {},
                  amazonAddress: {},
                  customerAddress: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterface: {
                shape: "S1o"
              }
            }
          }
        },
        CreateConnection: {
          input: {
            type: "structure",
            required: [
              "location",
              "bandwidth",
              "connectionName"
            ],
            members: {
              location: {},
              bandwidth: {},
              connectionName: {},
              lagId: {},
              tags: {
                shape: "S10"
              },
              providerName: {},
              requestMACSec: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "So"
          }
        },
        CreateDirectConnectGateway: {
          input: {
            type: "structure",
            required: [
              "directConnectGatewayName"
            ],
            members: {
              directConnectGatewayName: {},
              amazonSideAsn: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGateway: {
                shape: "S2q"
              }
            }
          }
        },
        CreateDirectConnectGatewayAssociation: {
          input: {
            type: "structure",
            required: [
              "directConnectGatewayId"
            ],
            members: {
              directConnectGatewayId: {},
              gatewayId: {},
              addAllowedPrefixesToDirectConnectGateway: {
                shape: "S5"
              },
              virtualGatewayId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGatewayAssociation: {
                shape: "S9"
              }
            }
          }
        },
        CreateDirectConnectGatewayAssociationProposal: {
          input: {
            type: "structure",
            required: [
              "directConnectGatewayId",
              "directConnectGatewayOwnerAccount",
              "gatewayId"
            ],
            members: {
              directConnectGatewayId: {},
              directConnectGatewayOwnerAccount: {},
              gatewayId: {},
              addAllowedPrefixesToDirectConnectGateway: {
                shape: "S5"
              },
              removeAllowedPrefixesToDirectConnectGateway: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGatewayAssociationProposal: {
                shape: "S2x"
              }
            }
          }
        },
        CreateInterconnect: {
          input: {
            type: "structure",
            required: [
              "interconnectName",
              "bandwidth",
              "location"
            ],
            members: {
              interconnectName: {},
              bandwidth: {},
              location: {},
              lagId: {},
              tags: {
                shape: "S10"
              },
              providerName: {}
            }
          },
          output: {
            shape: "S31"
          }
        },
        CreateLag: {
          input: {
            type: "structure",
            required: [
              "numberOfConnections",
              "location",
              "connectionsBandwidth",
              "lagName"
            ],
            members: {
              numberOfConnections: {
                type: "integer"
              },
              location: {},
              connectionsBandwidth: {},
              lagName: {},
              connectionId: {},
              tags: {
                shape: "S10"
              },
              childConnectionTags: {
                shape: "S10"
              },
              providerName: {},
              requestMACSec: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S36"
          }
        },
        CreatePrivateVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "newPrivateVirtualInterface"
            ],
            members: {
              connectionId: {},
              newPrivateVirtualInterface: {
                type: "structure",
                required: [
                  "virtualInterfaceName",
                  "vlan",
                  "asn"
                ],
                members: {
                  virtualInterfaceName: {},
                  vlan: {
                    type: "integer"
                  },
                  asn: {
                    type: "integer"
                  },
                  mtu: {
                    type: "integer"
                  },
                  authKey: {},
                  amazonAddress: {},
                  customerAddress: {},
                  addressFamily: {},
                  virtualGatewayId: {},
                  directConnectGatewayId: {},
                  tags: {
                    shape: "S10"
                  }
                }
              }
            }
          },
          output: {
            shape: "S1o"
          }
        },
        CreatePublicVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "newPublicVirtualInterface"
            ],
            members: {
              connectionId: {},
              newPublicVirtualInterface: {
                type: "structure",
                required: [
                  "virtualInterfaceName",
                  "vlan",
                  "asn"
                ],
                members: {
                  virtualInterfaceName: {},
                  vlan: {
                    type: "integer"
                  },
                  asn: {
                    type: "integer"
                  },
                  authKey: {},
                  amazonAddress: {},
                  customerAddress: {},
                  addressFamily: {},
                  routeFilterPrefixes: {
                    shape: "S5"
                  },
                  tags: {
                    shape: "S10"
                  }
                }
              }
            }
          },
          output: {
            shape: "S1o"
          }
        },
        CreateTransitVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "newTransitVirtualInterface"
            ],
            members: {
              connectionId: {},
              newTransitVirtualInterface: {
                type: "structure",
                members: {
                  virtualInterfaceName: {},
                  vlan: {
                    type: "integer"
                  },
                  asn: {
                    type: "integer"
                  },
                  mtu: {
                    type: "integer"
                  },
                  authKey: {},
                  amazonAddress: {},
                  customerAddress: {},
                  addressFamily: {},
                  directConnectGatewayId: {},
                  tags: {
                    shape: "S10"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterface: {
                shape: "S1o"
              }
            }
          }
        },
        DeleteBGPPeer: {
          input: {
            type: "structure",
            members: {
              virtualInterfaceId: {},
              asn: {
                type: "integer"
              },
              customerAddress: {},
              bgpPeerId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterface: {
                shape: "S1o"
              }
            }
          }
        },
        DeleteConnection: {
          input: {
            type: "structure",
            required: [
              "connectionId"
            ],
            members: {
              connectionId: {}
            }
          },
          output: {
            shape: "So"
          }
        },
        DeleteDirectConnectGateway: {
          input: {
            type: "structure",
            required: [
              "directConnectGatewayId"
            ],
            members: {
              directConnectGatewayId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGateway: {
                shape: "S2q"
              }
            }
          }
        },
        DeleteDirectConnectGatewayAssociation: {
          input: {
            type: "structure",
            members: {
              associationId: {},
              directConnectGatewayId: {},
              virtualGatewayId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGatewayAssociation: {
                shape: "S9"
              }
            }
          }
        },
        DeleteDirectConnectGatewayAssociationProposal: {
          input: {
            type: "structure",
            required: [
              "proposalId"
            ],
            members: {
              proposalId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGatewayAssociationProposal: {
                shape: "S2x"
              }
            }
          }
        },
        DeleteInterconnect: {
          input: {
            type: "structure",
            required: [
              "interconnectId"
            ],
            members: {
              interconnectId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              interconnectState: {}
            }
          }
        },
        DeleteLag: {
          input: {
            type: "structure",
            required: [
              "lagId"
            ],
            members: {
              lagId: {}
            }
          },
          output: {
            shape: "S36"
          }
        },
        DeleteVirtualInterface: {
          input: {
            type: "structure",
            required: [
              "virtualInterfaceId"
            ],
            members: {
              virtualInterfaceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterfaceState: {}
            }
          }
        },
        DescribeConnectionLoa: {
          input: {
            type: "structure",
            required: [
              "connectionId"
            ],
            members: {
              connectionId: {},
              providerName: {},
              loaContentType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              loa: {
                shape: "S3y"
              }
            }
          },
          deprecated: true
        },
        DescribeConnections: {
          input: {
            type: "structure",
            members: {
              connectionId: {}
            }
          },
          output: {
            shape: "S41"
          }
        },
        DescribeConnectionsOnInterconnect: {
          input: {
            type: "structure",
            required: [
              "interconnectId"
            ],
            members: {
              interconnectId: {}
            }
          },
          output: {
            shape: "S41"
          },
          deprecated: true
        },
        DescribeDirectConnectGatewayAssociationProposals: {
          input: {
            type: "structure",
            members: {
              directConnectGatewayId: {},
              proposalId: {},
              associatedGatewayId: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGatewayAssociationProposals: {
                type: "list",
                member: {
                  shape: "S2x"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeDirectConnectGatewayAssociations: {
          input: {
            type: "structure",
            members: {
              associationId: {},
              associatedGatewayId: {},
              directConnectGatewayId: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              virtualGatewayId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGatewayAssociations: {
                type: "list",
                member: {
                  shape: "S9"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeDirectConnectGatewayAttachments: {
          input: {
            type: "structure",
            members: {
              directConnectGatewayId: {},
              virtualInterfaceId: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGatewayAttachments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    directConnectGatewayId: {},
                    virtualInterfaceId: {},
                    virtualInterfaceRegion: {},
                    virtualInterfaceOwnerAccount: {},
                    attachmentState: {},
                    attachmentType: {},
                    stateChangeError: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeDirectConnectGateways: {
          input: {
            type: "structure",
            members: {
              directConnectGatewayId: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGateways: {
                type: "list",
                member: {
                  shape: "S2q"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeHostedConnections: {
          input: {
            type: "structure",
            required: [
              "connectionId"
            ],
            members: {
              connectionId: {}
            }
          },
          output: {
            shape: "S41"
          }
        },
        DescribeInterconnectLoa: {
          input: {
            type: "structure",
            required: [
              "interconnectId"
            ],
            members: {
              interconnectId: {},
              providerName: {},
              loaContentType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              loa: {
                shape: "S3y"
              }
            }
          },
          deprecated: true
        },
        DescribeInterconnects: {
          input: {
            type: "structure",
            members: {
              interconnectId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              interconnects: {
                type: "list",
                member: {
                  shape: "S31"
                }
              }
            }
          }
        },
        DescribeLags: {
          input: {
            type: "structure",
            members: {
              lagId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              lags: {
                type: "list",
                member: {
                  shape: "S36"
                }
              }
            }
          }
        },
        DescribeLoa: {
          input: {
            type: "structure",
            required: [
              "connectionId"
            ],
            members: {
              connectionId: {},
              providerName: {},
              loaContentType: {}
            }
          },
          output: {
            shape: "S3y"
          }
        },
        DescribeLocations: {
          output: {
            type: "structure",
            members: {
              locations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    locationCode: {},
                    locationName: {},
                    region: {},
                    availablePortSpeeds: {
                      type: "list",
                      member: {}
                    },
                    availableProviders: {
                      type: "list",
                      member: {}
                    },
                    availableMacSecPortSpeeds: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        DescribeTags: {
          input: {
            type: "structure",
            required: [
              "resourceArns"
            ],
            members: {
              resourceArns: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceTags: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    resourceArn: {},
                    tags: {
                      shape: "S10"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeVirtualGateways: {
          output: {
            type: "structure",
            members: {
              virtualGateways: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    virtualGatewayId: {},
                    virtualGatewayState: {}
                  }
                }
              }
            }
          }
        },
        DescribeVirtualInterfaces: {
          input: {
            type: "structure",
            members: {
              connectionId: {},
              virtualInterfaceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterfaces: {
                type: "list",
                member: {
                  shape: "S1o"
                }
              }
            }
          }
        },
        DisassociateConnectionFromLag: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "lagId"
            ],
            members: {
              connectionId: {},
              lagId: {}
            }
          },
          output: {
            shape: "So"
          }
        },
        DisassociateMacSecKey: {
          input: {
            type: "structure",
            required: [
              "connectionId",
              "secretARN"
            ],
            members: {
              connectionId: {},
              secretARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              connectionId: {},
              macSecKeys: {
                shape: "S18"
              }
            }
          }
        },
        ListVirtualInterfaceTestHistory: {
          input: {
            type: "structure",
            members: {
              testId: {},
              virtualInterfaceId: {},
              bgpPeers: {
                shape: "S5m"
              },
              status: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterfaceTestHistory: {
                type: "list",
                member: {
                  shape: "S5q"
                }
              },
              nextToken: {}
            }
          }
        },
        StartBgpFailoverTest: {
          input: {
            type: "structure",
            required: [
              "virtualInterfaceId"
            ],
            members: {
              virtualInterfaceId: {},
              bgpPeers: {
                shape: "S5m"
              },
              testDurationInMinutes: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterfaceTest: {
                shape: "S5q"
              }
            }
          }
        },
        StopBgpFailoverTest: {
          input: {
            type: "structure",
            required: [
              "virtualInterfaceId"
            ],
            members: {
              virtualInterfaceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              virtualInterfaceTest: {
                shape: "S5q"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateConnection: {
          input: {
            type: "structure",
            required: [
              "connectionId"
            ],
            members: {
              connectionId: {},
              connectionName: {},
              encryptionMode: {}
            }
          },
          output: {
            shape: "So"
          }
        },
        UpdateDirectConnectGatewayAssociation: {
          input: {
            type: "structure",
            members: {
              associationId: {},
              addAllowedPrefixesToDirectConnectGateway: {
                shape: "S5"
              },
              removeAllowedPrefixesToDirectConnectGateway: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              directConnectGatewayAssociation: {
                shape: "S9"
              }
            }
          }
        },
        UpdateLag: {
          input: {
            type: "structure",
            required: [
              "lagId"
            ],
            members: {
              lagId: {},
              lagName: {},
              minimumLinks: {
                type: "integer"
              },
              encryptionMode: {}
            }
          },
          output: {
            shape: "S36"
          }
        },
        UpdateVirtualInterfaceAttributes: {
          input: {
            type: "structure",
            required: [
              "virtualInterfaceId"
            ],
            members: {
              virtualInterfaceId: {},
              mtu: {
                type: "integer"
              }
            }
          },
          output: {
            shape: "S1o"
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {
            type: "structure",
            members: {
              cidr: {}
            }
          }
        },
        S9: {
          type: "structure",
          members: {
            directConnectGatewayId: {},
            directConnectGatewayOwnerAccount: {},
            associationState: {},
            stateChangeError: {},
            associatedGateway: {
              shape: "Sc"
            },
            associationId: {},
            allowedPrefixesToDirectConnectGateway: {
              shape: "S5"
            },
            virtualGatewayId: {},
            virtualGatewayRegion: {
              type: "string",
              deprecated: true
            },
            virtualGatewayOwnerAccount: {}
          }
        },
        Sc: {
          type: "structure",
          members: {
            id: {},
            type: {},
            ownerAccount: {},
            region: {}
          }
        },
        So: {
          type: "structure",
          members: {
            ownerAccount: {},
            connectionId: {},
            connectionName: {},
            connectionState: {},
            region: {},
            location: {},
            bandwidth: {},
            vlan: {
              type: "integer"
            },
            partnerName: {},
            loaIssueTime: {
              type: "timestamp"
            },
            lagId: {},
            awsDevice: {
              shape: "Sv"
            },
            jumboFrameCapable: {
              type: "boolean"
            },
            awsDeviceV2: {},
            awsLogicalDeviceId: {},
            hasLogicalRedundancy: {},
            tags: {
              shape: "S10"
            },
            providerName: {},
            macSecCapable: {
              type: "boolean"
            },
            portEncryptionStatus: {},
            encryptionMode: {},
            macSecKeys: {
              shape: "S18"
            }
          }
        },
        Sv: {
          type: "string",
          deprecated: true
        },
        S10: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        S18: {
          type: "list",
          member: {
            type: "structure",
            members: {
              secretARN: {},
              ckn: {},
              state: {},
              startOn: {}
            }
          }
        },
        S1o: {
          type: "structure",
          members: {
            ownerAccount: {},
            virtualInterfaceId: {},
            location: {},
            connectionId: {},
            virtualInterfaceType: {},
            virtualInterfaceName: {},
            vlan: {
              type: "integer"
            },
            asn: {
              type: "integer"
            },
            amazonSideAsn: {
              type: "long"
            },
            authKey: {},
            amazonAddress: {},
            customerAddress: {},
            addressFamily: {},
            virtualInterfaceState: {},
            customerRouterConfig: {},
            mtu: {
              type: "integer"
            },
            jumboFrameCapable: {
              type: "boolean"
            },
            virtualGatewayId: {},
            directConnectGatewayId: {},
            routeFilterPrefixes: {
              shape: "S5"
            },
            bgpPeers: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  bgpPeerId: {},
                  asn: {
                    type: "integer"
                  },
                  authKey: {},
                  addressFamily: {},
                  amazonAddress: {},
                  customerAddress: {},
                  bgpPeerState: {},
                  bgpStatus: {},
                  awsDeviceV2: {},
                  awsLogicalDeviceId: {}
                }
              }
            },
            region: {},
            awsDeviceV2: {},
            awsLogicalDeviceId: {},
            tags: {
              shape: "S10"
            }
          }
        },
        S2q: {
          type: "structure",
          members: {
            directConnectGatewayId: {},
            directConnectGatewayName: {},
            amazonSideAsn: {
              type: "long"
            },
            ownerAccount: {},
            directConnectGatewayState: {},
            stateChangeError: {}
          }
        },
        S2x: {
          type: "structure",
          members: {
            proposalId: {},
            directConnectGatewayId: {},
            directConnectGatewayOwnerAccount: {},
            proposalState: {},
            associatedGateway: {
              shape: "Sc"
            },
            existingAllowedPrefixesToDirectConnectGateway: {
              shape: "S5"
            },
            requestedAllowedPrefixesToDirectConnectGateway: {
              shape: "S5"
            }
          }
        },
        S31: {
          type: "structure",
          members: {
            interconnectId: {},
            interconnectName: {},
            interconnectState: {},
            region: {},
            location: {},
            bandwidth: {},
            loaIssueTime: {
              type: "timestamp"
            },
            lagId: {},
            awsDevice: {
              shape: "Sv"
            },
            jumboFrameCapable: {
              type: "boolean"
            },
            awsDeviceV2: {},
            awsLogicalDeviceId: {},
            hasLogicalRedundancy: {},
            tags: {
              shape: "S10"
            },
            providerName: {}
          }
        },
        S36: {
          type: "structure",
          members: {
            connectionsBandwidth: {},
            numberOfConnections: {
              type: "integer"
            },
            lagId: {},
            ownerAccount: {},
            lagName: {},
            lagState: {},
            location: {},
            region: {},
            minimumLinks: {
              type: "integer"
            },
            awsDevice: {
              shape: "Sv"
            },
            awsDeviceV2: {},
            awsLogicalDeviceId: {},
            connections: {
              shape: "S38"
            },
            allowsHostedConnections: {
              type: "boolean"
            },
            jumboFrameCapable: {
              type: "boolean"
            },
            hasLogicalRedundancy: {},
            tags: {
              shape: "S10"
            },
            providerName: {},
            macSecCapable: {
              type: "boolean"
            },
            encryptionMode: {},
            macSecKeys: {
              shape: "S18"
            }
          }
        },
        S38: {
          type: "list",
          member: {
            shape: "So"
          }
        },
        S3y: {
          type: "structure",
          members: {
            loaContent: {
              type: "blob"
            },
            loaContentType: {}
          }
        },
        S41: {
          type: "structure",
          members: {
            connections: {
              shape: "S38"
            }
          }
        },
        S5m: {
          type: "list",
          member: {}
        },
        S5q: {
          type: "structure",
          members: {
            testId: {},
            virtualInterfaceId: {},
            bgpPeers: {
              shape: "S5m"
            },
            status: {},
            ownerAccount: {},
            testDurationInMinutes: {
              type: "integer"
            },
            startTime: {
              type: "timestamp"
            },
            endTime: {
              type: "timestamp"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/directconnect-2012-10-25.paginators.json
var require_directconnect_2012_10_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/directconnect-2012-10-25.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeConnections: {
          result_key: "connections"
        },
        DescribeConnectionsOnInterconnect: {
          result_key: "connections"
        },
        DescribeInterconnects: {
          result_key: "interconnects"
        },
        DescribeLocations: {
          result_key: "locations"
        },
        DescribeVirtualGateways: {
          result_key: "virtualGateways"
        },
        DescribeVirtualInterfaces: {
          result_key: "virtualInterfaces"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/directconnect.js
var require_directconnect = __commonJS({
  "node_modules/aws-sdk/clients/directconnect.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["directconnect"] = {};
    AWS3.DirectConnect = Service.defineService("directconnect", ["2012-10-25"]);
    Object.defineProperty(apiLoader.services["directconnect"], "2012-10-25", {
      get: function get() {
        var model = require_directconnect_2012_10_25_min();
        model.paginators = require_directconnect_2012_10_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.DirectConnect;
  }
});

// node_modules/aws-sdk/apis/ds-2015-04-16.min.json
var require_ds_2015_04_16_min = __commonJS({
  "node_modules/aws-sdk/apis/ds-2015-04-16.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-04-16",
        endpointPrefix: "ds",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Directory Service",
        serviceFullName: "AWS Directory Service",
        serviceId: "Directory Service",
        signatureVersion: "v4",
        targetPrefix: "DirectoryService_20150416",
        uid: "ds-2015-04-16"
      },
      operations: {
        AcceptSharedDirectory: {
          input: {
            type: "structure",
            required: [
              "SharedDirectoryId"
            ],
            members: {
              SharedDirectoryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SharedDirectory: {
                shape: "S4"
              }
            }
          }
        },
        AddIpRoutes: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "IpRoutes"
            ],
            members: {
              DirectoryId: {},
              IpRoutes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CidrIp: {},
                    Description: {}
                  }
                }
              },
              UpdateSecurityGroupForDirectoryControllers: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AddRegion: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "RegionName",
              "VPCSettings"
            ],
            members: {
              DirectoryId: {},
              RegionName: {},
              VPCSettings: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "Tags"
            ],
            members: {
              ResourceId: {},
              Tags: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelSchemaExtension: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "SchemaExtensionId"
            ],
            members: {
              DirectoryId: {},
              SchemaExtensionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ConnectDirectory: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Password",
              "Size",
              "ConnectSettings"
            ],
            members: {
              Name: {},
              ShortName: {},
              Password: {
                shape: "S12"
              },
              Description: {},
              Size: {},
              ConnectSettings: {
                type: "structure",
                required: [
                  "VpcId",
                  "SubnetIds",
                  "CustomerDnsIps",
                  "CustomerUserName"
                ],
                members: {
                  VpcId: {},
                  SubnetIds: {
                    shape: "Sm"
                  },
                  CustomerDnsIps: {
                    shape: "S15"
                  },
                  CustomerUserName: {}
                }
              },
              Tags: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryId: {}
            }
          }
        },
        CreateAlias: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "Alias"
            ],
            members: {
              DirectoryId: {},
              Alias: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryId: {},
              Alias: {}
            }
          }
        },
        CreateComputer: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "ComputerName",
              "Password"
            ],
            members: {
              DirectoryId: {},
              ComputerName: {},
              Password: {
                type: "string",
                sensitive: true
              },
              OrganizationalUnitDistinguishedName: {},
              ComputerAttributes: {
                shape: "S1g"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Computer: {
                type: "structure",
                members: {
                  ComputerId: {},
                  ComputerName: {},
                  ComputerAttributes: {
                    shape: "S1g"
                  }
                }
              }
            }
          }
        },
        CreateConditionalForwarder: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "RemoteDomainName",
              "DnsIpAddrs"
            ],
            members: {
              DirectoryId: {},
              RemoteDomainName: {},
              DnsIpAddrs: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDirectory: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Password",
              "Size"
            ],
            members: {
              Name: {},
              ShortName: {},
              Password: {
                shape: "S1r"
              },
              Description: {},
              Size: {},
              VpcSettings: {
                shape: "Sk"
              },
              Tags: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryId: {}
            }
          }
        },
        CreateLogSubscription: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "LogGroupName"
            ],
            members: {
              DirectoryId: {},
              LogGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateMicrosoftAD: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Password",
              "VpcSettings"
            ],
            members: {
              Name: {},
              ShortName: {},
              Password: {
                shape: "S1r"
              },
              Description: {},
              VpcSettings: {
                shape: "Sk"
              },
              Edition: {},
              Tags: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryId: {}
            }
          }
        },
        CreateSnapshot: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SnapshotId: {}
            }
          }
        },
        CreateTrust: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "RemoteDomainName",
              "TrustPassword",
              "TrustDirection"
            ],
            members: {
              DirectoryId: {},
              RemoteDomainName: {},
              TrustPassword: {
                type: "string",
                sensitive: true
              },
              TrustDirection: {},
              TrustType: {},
              ConditionalForwarderIpAddrs: {
                shape: "S15"
              },
              SelectiveAuth: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrustId: {}
            }
          }
        },
        DeleteConditionalForwarder: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "RemoteDomainName"
            ],
            members: {
              DirectoryId: {},
              RemoteDomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDirectory: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryId: {}
            }
          }
        },
        DeleteLogSubscription: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSnapshot: {
          input: {
            type: "structure",
            required: [
              "SnapshotId"
            ],
            members: {
              SnapshotId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SnapshotId: {}
            }
          }
        },
        DeleteTrust: {
          input: {
            type: "structure",
            required: [
              "TrustId"
            ],
            members: {
              TrustId: {},
              DeleteAssociatedConditionalForwarder: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrustId: {}
            }
          }
        },
        DeregisterCertificate: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "CertificateId"
            ],
            members: {
              DirectoryId: {},
              CertificateId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterEventTopic: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "TopicName"
            ],
            members: {
              DirectoryId: {},
              TopicName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeCertificate: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "CertificateId"
            ],
            members: {
              DirectoryId: {},
              CertificateId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Certificate: {
                type: "structure",
                members: {
                  CertificateId: {},
                  State: {},
                  StateReason: {},
                  CommonName: {},
                  RegisteredDateTime: {
                    type: "timestamp"
                  },
                  ExpiryDateTime: {
                    type: "timestamp"
                  },
                  Type: {},
                  ClientCertAuthSettings: {
                    shape: "S30"
                  }
                }
              }
            }
          }
        },
        DescribeClientAuthenticationSettings: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              Type: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientAuthenticationSettingsInfo: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    Status: {},
                    LastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeConditionalForwarders: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              RemoteDomainNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConditionalForwarders: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RemoteDomainName: {},
                    DnsIpAddrs: {
                      shape: "S15"
                    },
                    ReplicationScope: {}
                  }
                }
              }
            }
          }
        },
        DescribeDirectories: {
          input: {
            type: "structure",
            members: {
              DirectoryIds: {
                shape: "S3h"
              },
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DirectoryDescriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DirectoryId: {},
                    Name: {},
                    ShortName: {},
                    Size: {},
                    Edition: {},
                    Alias: {},
                    AccessUrl: {},
                    Description: {},
                    DnsIpAddrs: {
                      shape: "S15"
                    },
                    Stage: {},
                    ShareStatus: {},
                    ShareMethod: {},
                    ShareNotes: {
                      shape: "S8"
                    },
                    LaunchTime: {
                      type: "timestamp"
                    },
                    StageLastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    Type: {},
                    VpcSettings: {
                      shape: "S3q"
                    },
                    ConnectSettings: {
                      type: "structure",
                      members: {
                        VpcId: {},
                        SubnetIds: {
                          shape: "Sm"
                        },
                        CustomerUserName: {},
                        SecurityGroupId: {},
                        AvailabilityZones: {
                          shape: "S3s"
                        },
                        ConnectIps: {
                          type: "list",
                          member: {}
                        }
                      }
                    },
                    RadiusSettings: {
                      shape: "S3w"
                    },
                    RadiusStatus: {},
                    StageReason: {},
                    SsoEnabled: {
                      type: "boolean"
                    },
                    DesiredNumberOfDomainControllers: {
                      type: "integer"
                    },
                    OwnerDirectoryDescription: {
                      type: "structure",
                      members: {
                        DirectoryId: {},
                        AccountId: {},
                        DnsIpAddrs: {
                          shape: "S15"
                        },
                        VpcSettings: {
                          shape: "S3q"
                        },
                        RadiusSettings: {
                          shape: "S3w"
                        },
                        RadiusStatus: {}
                      }
                    },
                    RegionsInfo: {
                      type: "structure",
                      members: {
                        PrimaryRegion: {},
                        AdditionalRegions: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeDomainControllers: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              DomainControllerIds: {
                type: "list",
                member: {}
              },
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainControllers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DirectoryId: {},
                    DomainControllerId: {},
                    DnsIpAddr: {},
                    VpcId: {},
                    SubnetId: {},
                    AvailabilityZone: {},
                    Status: {},
                    StatusReason: {},
                    LaunchTime: {
                      type: "timestamp"
                    },
                    StatusLastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeEventTopics: {
          input: {
            type: "structure",
            members: {
              DirectoryId: {},
              TopicNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventTopics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DirectoryId: {},
                    TopicName: {},
                    TopicArn: {},
                    CreatedDateTime: {
                      type: "timestamp"
                    },
                    Status: {}
                  }
                }
              }
            }
          }
        },
        DescribeLDAPSSettings: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              Type: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LDAPSSettingsInfo: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LDAPSStatus: {},
                    LDAPSStatusReason: {},
                    LastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeRegions: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              RegionName: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegionsDescription: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DirectoryId: {},
                    RegionName: {},
                    RegionType: {},
                    Status: {},
                    VpcSettings: {
                      shape: "Sk"
                    },
                    DesiredNumberOfDomainControllers: {
                      type: "integer"
                    },
                    LaunchTime: {
                      type: "timestamp"
                    },
                    StatusLastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    LastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeSharedDirectories: {
          input: {
            type: "structure",
            required: [
              "OwnerDirectoryId"
            ],
            members: {
              OwnerDirectoryId: {},
              SharedDirectoryIds: {
                shape: "S3h"
              },
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SharedDirectories: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeSnapshots: {
          input: {
            type: "structure",
            members: {
              DirectoryId: {},
              SnapshotIds: {
                type: "list",
                member: {}
              },
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Snapshots: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DirectoryId: {},
                    SnapshotId: {},
                    Type: {},
                    Name: {},
                    Status: {},
                    StartTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeTrusts: {
          input: {
            type: "structure",
            members: {
              DirectoryId: {},
              TrustIds: {
                type: "list",
                member: {}
              },
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Trusts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DirectoryId: {},
                    TrustId: {},
                    RemoteDomainName: {},
                    TrustType: {},
                    TrustDirection: {},
                    TrustState: {},
                    CreatedDateTime: {
                      type: "timestamp"
                    },
                    LastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    StateLastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    TrustStateReason: {},
                    SelectiveAuth: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DisableClientAuthentication: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "Type"
            ],
            members: {
              DirectoryId: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableLDAPS: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "Type"
            ],
            members: {
              DirectoryId: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableRadius: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableSso: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              UserName: {},
              Password: {
                shape: "S12"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableClientAuthentication: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "Type"
            ],
            members: {
              DirectoryId: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableLDAPS: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "Type"
            ],
            members: {
              DirectoryId: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableRadius: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "RadiusSettings"
            ],
            members: {
              DirectoryId: {},
              RadiusSettings: {
                shape: "S3w"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableSso: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              UserName: {},
              Password: {
                shape: "S12"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetDirectoryLimits: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              DirectoryLimits: {
                type: "structure",
                members: {
                  CloudOnlyDirectoriesLimit: {
                    type: "integer"
                  },
                  CloudOnlyDirectoriesCurrentCount: {
                    type: "integer"
                  },
                  CloudOnlyDirectoriesLimitReached: {
                    type: "boolean"
                  },
                  CloudOnlyMicrosoftADLimit: {
                    type: "integer"
                  },
                  CloudOnlyMicrosoftADCurrentCount: {
                    type: "integer"
                  },
                  CloudOnlyMicrosoftADLimitReached: {
                    type: "boolean"
                  },
                  ConnectedDirectoriesLimit: {
                    type: "integer"
                  },
                  ConnectedDirectoriesCurrentCount: {
                    type: "integer"
                  },
                  ConnectedDirectoriesLimitReached: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        GetSnapshotLimits: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SnapshotLimits: {
                type: "structure",
                members: {
                  ManualSnapshotsLimit: {
                    type: "integer"
                  },
                  ManualSnapshotsCurrentCount: {
                    type: "integer"
                  },
                  ManualSnapshotsLimitReached: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        ListCertificates: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              CertificatesInfo: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CertificateId: {},
                    CommonName: {},
                    State: {},
                    ExpiryDateTime: {
                      type: "timestamp"
                    },
                    Type: {}
                  }
                }
              }
            }
          }
        },
        ListIpRoutes: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IpRoutesInfo: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DirectoryId: {},
                    CidrIp: {},
                    IpRouteStatusMsg: {},
                    AddedDateTime: {
                      type: "timestamp"
                    },
                    IpRouteStatusReason: {},
                    Description: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLogSubscriptions: {
          input: {
            type: "structure",
            members: {
              DirectoryId: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LogSubscriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DirectoryId: {},
                    LogGroupName: {},
                    SubscriptionCreatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSchemaExtensions: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaExtensionsInfo: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DirectoryId: {},
                    SchemaExtensionId: {},
                    Description: {},
                    SchemaExtensionStatus: {},
                    SchemaExtensionStatusReason: {},
                    StartDateTime: {
                      type: "timestamp"
                    },
                    EndDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sr"
              },
              NextToken: {}
            }
          }
        },
        RegisterCertificate: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "CertificateData"
            ],
            members: {
              DirectoryId: {},
              CertificateData: {},
              Type: {},
              ClientCertAuthSettings: {
                shape: "S30"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CertificateId: {}
            }
          }
        },
        RegisterEventTopic: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "TopicName"
            ],
            members: {
              DirectoryId: {},
              TopicName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RejectSharedDirectory: {
          input: {
            type: "structure",
            required: [
              "SharedDirectoryId"
            ],
            members: {
              SharedDirectoryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SharedDirectoryId: {}
            }
          }
        },
        RemoveIpRoutes: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "CidrIps"
            ],
            members: {
              DirectoryId: {},
              CidrIps: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RemoveRegion: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "TagKeys"
            ],
            members: {
              ResourceId: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ResetUserPassword: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "UserName",
              "NewPassword"
            ],
            members: {
              DirectoryId: {},
              UserName: {},
              NewPassword: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RestoreFromSnapshot: {
          input: {
            type: "structure",
            required: [
              "SnapshotId"
            ],
            members: {
              SnapshotId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ShareDirectory: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "ShareTarget",
              "ShareMethod"
            ],
            members: {
              DirectoryId: {},
              ShareNotes: {
                shape: "S8"
              },
              ShareTarget: {
                type: "structure",
                required: [
                  "Id",
                  "Type"
                ],
                members: {
                  Id: {},
                  Type: {}
                }
              },
              ShareMethod: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SharedDirectoryId: {}
            }
          }
        },
        StartSchemaExtension: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "CreateSnapshotBeforeSchemaExtension",
              "LdifContent",
              "Description"
            ],
            members: {
              DirectoryId: {},
              CreateSnapshotBeforeSchemaExtension: {
                type: "boolean"
              },
              LdifContent: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaExtensionId: {}
            }
          }
        },
        UnshareDirectory: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "UnshareTarget"
            ],
            members: {
              DirectoryId: {},
              UnshareTarget: {
                type: "structure",
                required: [
                  "Id",
                  "Type"
                ],
                members: {
                  Id: {},
                  Type: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SharedDirectoryId: {}
            }
          }
        },
        UpdateConditionalForwarder: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "RemoteDomainName",
              "DnsIpAddrs"
            ],
            members: {
              DirectoryId: {},
              RemoteDomainName: {},
              DnsIpAddrs: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateNumberOfDomainControllers: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "DesiredNumber"
            ],
            members: {
              DirectoryId: {},
              DesiredNumber: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRadius: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "RadiusSettings"
            ],
            members: {
              DirectoryId: {},
              RadiusSettings: {
                shape: "S3w"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateTrust: {
          input: {
            type: "structure",
            required: [
              "TrustId"
            ],
            members: {
              TrustId: {},
              SelectiveAuth: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              TrustId: {}
            }
          }
        },
        VerifyTrust: {
          input: {
            type: "structure",
            required: [
              "TrustId"
            ],
            members: {
              TrustId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrustId: {}
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            OwnerAccountId: {},
            OwnerDirectoryId: {},
            ShareMethod: {},
            SharedAccountId: {},
            SharedDirectoryId: {},
            ShareStatus: {},
            ShareNotes: {
              shape: "S8"
            },
            CreatedDateTime: {
              type: "timestamp"
            },
            LastUpdatedDateTime: {
              type: "timestamp"
            }
          }
        },
        S8: {
          type: "string",
          sensitive: true
        },
        Sk: {
          type: "structure",
          required: [
            "VpcId",
            "SubnetIds"
          ],
          members: {
            VpcId: {},
            SubnetIds: {
              shape: "Sm"
            }
          }
        },
        Sm: {
          type: "list",
          member: {}
        },
        Sr: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S12: {
          type: "string",
          sensitive: true
        },
        S15: {
          type: "list",
          member: {}
        },
        S1g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        S1r: {
          type: "string",
          sensitive: true
        },
        S30: {
          type: "structure",
          members: {
            OCSPUrl: {}
          }
        },
        S3h: {
          type: "list",
          member: {}
        },
        S3q: {
          type: "structure",
          members: {
            VpcId: {},
            SubnetIds: {
              shape: "Sm"
            },
            SecurityGroupId: {},
            AvailabilityZones: {
              shape: "S3s"
            }
          }
        },
        S3s: {
          type: "list",
          member: {}
        },
        S3w: {
          type: "structure",
          members: {
            RadiusServers: {
              type: "list",
              member: {}
            },
            RadiusPort: {
              type: "integer"
            },
            RadiusTimeout: {
              type: "integer"
            },
            RadiusRetries: {
              type: "integer"
            },
            SharedSecret: {
              type: "string",
              sensitive: true
            },
            AuthenticationProtocol: {},
            DisplayLabel: {},
            UseSameUsername: {
              type: "boolean"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ds-2015-04-16.paginators.json
var require_ds_2015_04_16_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ds-2015-04-16.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeDomainControllers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/directoryservice.js
var require_directoryservice = __commonJS({
  "node_modules/aws-sdk/clients/directoryservice.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["directoryservice"] = {};
    AWS3.DirectoryService = Service.defineService("directoryservice", ["2015-04-16"]);
    Object.defineProperty(apiLoader.services["directoryservice"], "2015-04-16", {
      get: function get() {
        var model = require_ds_2015_04_16_min();
        model.paginators = require_ds_2015_04_16_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.DirectoryService;
  }
});

// node_modules/aws-sdk/apis/discovery-2015-11-01.min.json
var require_discovery_2015_11_01_min = __commonJS({
  "node_modules/aws-sdk/apis/discovery-2015-11-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-11-01",
        endpointPrefix: "discovery",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Application Discovery Service",
        serviceId: "Application Discovery Service",
        signatureVersion: "v4",
        targetPrefix: "AWSPoseidonService_V2015_11_01",
        uid: "discovery-2015-11-01"
      },
      operations: {
        AssociateConfigurationItemsToApplication: {
          input: {
            type: "structure",
            required: [
              "applicationConfigurationId",
              "configurationIds"
            ],
            members: {
              applicationConfigurationId: {},
              configurationIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        BatchDeleteImportData: {
          input: {
            type: "structure",
            required: [
              "importTaskIds"
            ],
            members: {
              importTaskIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    importTaskId: {},
                    errorCode: {},
                    errorDescription: {}
                  }
                }
              }
            }
          }
        },
        CreateApplication: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              configurationId: {}
            }
          }
        },
        CreateTags: {
          input: {
            type: "structure",
            required: [
              "configurationIds",
              "tags"
            ],
            members: {
              configurationIds: {
                shape: "S3"
              },
              tags: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApplications: {
          input: {
            type: "structure",
            required: [
              "configurationIds"
            ],
            members: {
              configurationIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTags: {
          input: {
            type: "structure",
            required: [
              "configurationIds"
            ],
            members: {
              configurationIds: {
                shape: "S3"
              },
              tags: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeAgents: {
          input: {
            type: "structure",
            members: {
              agentIds: {
                shape: "St"
              },
              filters: {
                shape: "Sv"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              agentsInfo: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    agentId: {},
                    hostName: {},
                    agentNetworkInfoList: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ipAddress: {},
                          macAddress: {}
                        }
                      }
                    },
                    connectorId: {},
                    version: {},
                    health: {},
                    lastHealthPingTime: {},
                    collectionStatus: {},
                    agentType: {},
                    registeredTime: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeConfigurations: {
          input: {
            type: "structure",
            required: [
              "configurationIds"
            ],
            members: {
              configurationIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              configurations: {
                type: "list",
                member: {
                  type: "map",
                  key: {},
                  value: {}
                }
              }
            }
          }
        },
        DescribeContinuousExports: {
          input: {
            type: "structure",
            members: {
              exportIds: {
                type: "list",
                member: {}
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              descriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    exportId: {},
                    status: {},
                    statusDetail: {},
                    s3Bucket: {},
                    startTime: {
                      type: "timestamp"
                    },
                    stopTime: {
                      type: "timestamp"
                    },
                    dataSource: {},
                    schemaStorageConfig: {
                      shape: "S1o"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeExportConfigurations: {
          input: {
            type: "structure",
            members: {
              exportIds: {
                shape: "S1r"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              exportsInfo: {
                shape: "S1t"
              },
              nextToken: {}
            }
          },
          deprecated: true
        },
        DescribeExportTasks: {
          input: {
            type: "structure",
            members: {
              exportIds: {
                shape: "S1r"
              },
              filters: {
                shape: "S21"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              exportsInfo: {
                shape: "S1t"
              },
              nextToken: {}
            }
          }
        },
        DescribeImportTasks: {
          input: {
            type: "structure",
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              tasks: {
                type: "list",
                member: {
                  shape: "S2e"
                }
              }
            }
          }
        },
        DescribeTags: {
          input: {
            type: "structure",
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values"
                  ],
                  members: {
                    name: {},
                    values: {
                      shape: "Sx"
                    }
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    configurationType: {},
                    configurationId: {},
                    key: {},
                    value: {},
                    timeOfCreation: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DisassociateConfigurationItemsFromApplication: {
          input: {
            type: "structure",
            required: [
              "applicationConfigurationId",
              "configurationIds"
            ],
            members: {
              applicationConfigurationId: {},
              configurationIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ExportConfigurations: {
          output: {
            type: "structure",
            members: {
              exportId: {}
            }
          },
          deprecated: true
        },
        GetDiscoverySummary: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              servers: {
                type: "long"
              },
              applications: {
                type: "long"
              },
              serversMappedToApplications: {
                type: "long"
              },
              serversMappedtoTags: {
                type: "long"
              },
              agentSummary: {
                type: "structure",
                required: [
                  "activeAgents",
                  "healthyAgents",
                  "blackListedAgents",
                  "shutdownAgents",
                  "unhealthyAgents",
                  "totalAgents",
                  "unknownAgents"
                ],
                members: {
                  activeAgents: {
                    type: "integer"
                  },
                  healthyAgents: {
                    type: "integer"
                  },
                  blackListedAgents: {
                    type: "integer"
                  },
                  shutdownAgents: {
                    type: "integer"
                  },
                  unhealthyAgents: {
                    type: "integer"
                  },
                  totalAgents: {
                    type: "integer"
                  },
                  unknownAgents: {
                    type: "integer"
                  }
                }
              },
              connectorSummary: {
                type: "structure",
                required: [
                  "activeConnectors",
                  "healthyConnectors",
                  "blackListedConnectors",
                  "shutdownConnectors",
                  "unhealthyConnectors",
                  "totalConnectors",
                  "unknownConnectors"
                ],
                members: {
                  activeConnectors: {
                    type: "integer"
                  },
                  healthyConnectors: {
                    type: "integer"
                  },
                  blackListedConnectors: {
                    type: "integer"
                  },
                  shutdownConnectors: {
                    type: "integer"
                  },
                  unhealthyConnectors: {
                    type: "integer"
                  },
                  totalConnectors: {
                    type: "integer"
                  },
                  unknownConnectors: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        ListConfigurations: {
          input: {
            type: "structure",
            required: [
              "configurationType"
            ],
            members: {
              configurationType: {},
              filters: {
                shape: "Sv"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              orderBy: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "fieldName"
                  ],
                  members: {
                    fieldName: {},
                    sortOrder: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              configurations: {
                type: "list",
                member: {
                  type: "map",
                  key: {},
                  value: {}
                }
              },
              nextToken: {}
            }
          }
        },
        ListServerNeighbors: {
          input: {
            type: "structure",
            required: [
              "configurationId"
            ],
            members: {
              configurationId: {},
              portInformationNeeded: {
                type: "boolean"
              },
              neighborConfigurationIds: {
                shape: "S3"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "neighbors"
            ],
            members: {
              neighbors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "sourceServerId",
                    "destinationServerId",
                    "connectionsCount"
                  ],
                  members: {
                    sourceServerId: {},
                    destinationServerId: {},
                    destinationPort: {
                      type: "integer"
                    },
                    transportProtocol: {},
                    connectionsCount: {
                      type: "long"
                    }
                  }
                }
              },
              nextToken: {},
              knownDependencyCount: {
                type: "long"
              }
            }
          }
        },
        StartContinuousExport: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              exportId: {},
              s3Bucket: {},
              startTime: {
                type: "timestamp"
              },
              dataSource: {},
              schemaStorageConfig: {
                shape: "S1o"
              }
            }
          }
        },
        StartDataCollectionByAgentIds: {
          input: {
            type: "structure",
            required: [
              "agentIds"
            ],
            members: {
              agentIds: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              agentsConfigurationStatus: {
                shape: "S3f"
              }
            }
          }
        },
        StartExportTask: {
          input: {
            type: "structure",
            members: {
              exportDataFormat: {
                type: "list",
                member: {}
              },
              filters: {
                shape: "S21"
              },
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              exportId: {}
            }
          }
        },
        StartImportTask: {
          input: {
            type: "structure",
            required: [
              "name",
              "importUrl"
            ],
            members: {
              clientRequestToken: {
                idempotencyToken: true
              },
              name: {},
              importUrl: {}
            }
          },
          output: {
            type: "structure",
            members: {
              task: {
                shape: "S2e"
              }
            }
          }
        },
        StopContinuousExport: {
          input: {
            type: "structure",
            required: [
              "exportId"
            ],
            members: {
              exportId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              startTime: {
                type: "timestamp"
              },
              stopTime: {
                type: "timestamp"
              }
            }
          }
        },
        StopDataCollectionByAgentIds: {
          input: {
            type: "structure",
            required: [
              "agentIds"
            ],
            members: {
              agentIds: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              agentsConfigurationStatus: {
                shape: "S3f"
              }
            }
          }
        },
        UpdateApplication: {
          input: {
            type: "structure",
            required: [
              "configurationId"
            ],
            members: {
              configurationId: {},
              name: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        Si: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        St: {
          type: "list",
          member: {}
        },
        Sv: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "values",
              "condition"
            ],
            members: {
              name: {},
              values: {
                shape: "Sx"
              },
              condition: {}
            }
          }
        },
        Sx: {
          type: "list",
          member: {}
        },
        S1o: {
          type: "map",
          key: {},
          value: {}
        },
        S1r: {
          type: "list",
          member: {}
        },
        S1t: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "exportId",
              "exportStatus",
              "statusMessage",
              "exportRequestTime"
            ],
            members: {
              exportId: {},
              exportStatus: {},
              statusMessage: {},
              configurationsDownloadUrl: {},
              exportRequestTime: {
                type: "timestamp"
              },
              isTruncated: {
                type: "boolean"
              },
              requestedStartTime: {
                type: "timestamp"
              },
              requestedEndTime: {
                type: "timestamp"
              }
            }
          }
        },
        S21: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "values",
              "condition"
            ],
            members: {
              name: {},
              values: {
                shape: "Sx"
              },
              condition: {}
            }
          }
        },
        S2e: {
          type: "structure",
          members: {
            importTaskId: {},
            clientRequestToken: {},
            name: {},
            importUrl: {},
            status: {},
            importRequestTime: {
              type: "timestamp"
            },
            importCompletionTime: {
              type: "timestamp"
            },
            importDeletedTime: {
              type: "timestamp"
            },
            serverImportSuccess: {
              type: "integer"
            },
            serverImportFailure: {
              type: "integer"
            },
            applicationImportSuccess: {
              type: "integer"
            },
            applicationImportFailure: {
              type: "integer"
            },
            errorsAndFailedEntriesZip: {}
          }
        },
        S3f: {
          type: "list",
          member: {
            type: "structure",
            members: {
              agentId: {},
              operationSucceeded: {
                type: "boolean"
              },
              description: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/discovery-2015-11-01.paginators.json
var require_discovery_2015_11_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/discovery-2015-11-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeContinuousExports: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        DescribeImportTasks: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/discovery.js
var require_discovery = __commonJS({
  "node_modules/aws-sdk/clients/discovery.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["discovery"] = {};
    AWS3.Discovery = Service.defineService("discovery", ["2015-11-01"]);
    Object.defineProperty(apiLoader.services["discovery"], "2015-11-01", {
      get: function get() {
        var model = require_discovery_2015_11_01_min();
        model.paginators = require_discovery_2015_11_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Discovery;
  }
});

// node_modules/aws-sdk/apis/dms-2016-01-01.min.json
var require_dms_2016_01_01_min = __commonJS({
  "node_modules/aws-sdk/apis/dms-2016-01-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-01-01",
        endpointPrefix: "dms",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Database Migration Service",
        serviceId: "Database Migration Service",
        signatureVersion: "v4",
        targetPrefix: "AmazonDMSv20160101",
        uid: "dms-2016-01-01"
      },
      operations: {
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ApplyPendingMaintenanceAction: {
          input: {
            type: "structure",
            required: [
              "ReplicationInstanceArn",
              "ApplyAction",
              "OptInType"
            ],
            members: {
              ReplicationInstanceArn: {},
              ApplyAction: {},
              OptInType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourcePendingMaintenanceActions: {
                shape: "S8"
              }
            }
          }
        },
        CancelReplicationTaskAssessmentRun: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskAssessmentRunArn"
            ],
            members: {
              ReplicationTaskAssessmentRunArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTaskAssessmentRun: {
                shape: "Se"
              }
            }
          }
        },
        CreateEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointIdentifier",
              "EndpointType",
              "EngineName"
            ],
            members: {
              EndpointIdentifier: {},
              EndpointType: {},
              EngineName: {},
              Username: {},
              Password: {
                shape: "Sj"
              },
              ServerName: {},
              Port: {
                type: "integer"
              },
              DatabaseName: {},
              ExtraConnectionAttributes: {},
              KmsKeyId: {},
              Tags: {
                shape: "S3"
              },
              CertificateArn: {},
              SslMode: {},
              ServiceAccessRoleArn: {},
              ExternalTableDefinition: {},
              DynamoDbSettings: {
                shape: "Sm"
              },
              S3Settings: {
                shape: "Sn"
              },
              DmsTransferSettings: {
                shape: "Sx"
              },
              MongoDbSettings: {
                shape: "Sy"
              },
              KinesisSettings: {
                shape: "S12"
              },
              KafkaSettings: {
                shape: "S14"
              },
              ElasticsearchSettings: {
                shape: "S16"
              },
              NeptuneSettings: {
                shape: "S17"
              },
              RedshiftSettings: {
                shape: "S18"
              },
              PostgreSQLSettings: {
                shape: "S19"
              },
              MySQLSettings: {
                shape: "S1b"
              },
              OracleSettings: {
                shape: "S1d"
              },
              SybaseSettings: {
                shape: "S1g"
              },
              MicrosoftSQLServerSettings: {
                shape: "S1h"
              },
              IBMDb2Settings: {
                shape: "S1j"
              },
              ResourceIdentifier: {},
              DocDbSettings: {
                shape: "S1k"
              },
              RedisSettings: {
                shape: "S1l"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Endpoint: {
                shape: "S1p"
              }
            }
          }
        },
        CreateEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SnsTopicArn"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S1r"
              },
              SourceIds: {
                shape: "S1s"
              },
              Enabled: {
                type: "boolean"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S1u"
              }
            }
          }
        },
        CreateReplicationInstance: {
          input: {
            type: "structure",
            required: [
              "ReplicationInstanceIdentifier",
              "ReplicationInstanceClass"
            ],
            members: {
              ReplicationInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              ReplicationInstanceClass: {},
              VpcSecurityGroupIds: {
                shape: "S1x"
              },
              AvailabilityZone: {},
              ReplicationSubnetGroupIdentifier: {},
              PreferredMaintenanceWindow: {},
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Tags: {
                shape: "S3"
              },
              KmsKeyId: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              DnsNameServers: {},
              ResourceIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationInstance: {
                shape: "S1z"
              }
            }
          }
        },
        CreateReplicationSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "ReplicationSubnetGroupIdentifier",
              "ReplicationSubnetGroupDescription",
              "SubnetIds"
            ],
            members: {
              ReplicationSubnetGroupIdentifier: {},
              ReplicationSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S2a"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationSubnetGroup: {
                shape: "S22"
              }
            }
          }
        },
        CreateReplicationTask: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskIdentifier",
              "SourceEndpointArn",
              "TargetEndpointArn",
              "ReplicationInstanceArn",
              "MigrationType",
              "TableMappings"
            ],
            members: {
              ReplicationTaskIdentifier: {},
              SourceEndpointArn: {},
              TargetEndpointArn: {},
              ReplicationInstanceArn: {},
              MigrationType: {},
              TableMappings: {},
              ReplicationTaskSettings: {},
              CdcStartTime: {
                type: "timestamp"
              },
              CdcStartPosition: {},
              CdcStopPosition: {},
              Tags: {
                shape: "S3"
              },
              TaskData: {},
              ResourceIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTask: {
                shape: "S2f"
              }
            }
          }
        },
        DeleteCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateArn"
            ],
            members: {
              CertificateArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Certificate: {
                shape: "S2k"
              }
            }
          }
        },
        DeleteConnection: {
          input: {
            type: "structure",
            required: [
              "EndpointArn",
              "ReplicationInstanceArn"
            ],
            members: {
              EndpointArn: {},
              ReplicationInstanceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "S2o"
              }
            }
          }
        },
        DeleteEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Endpoint: {
                shape: "S1p"
              }
            }
          }
        },
        DeleteEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S1u"
              }
            }
          }
        },
        DeleteReplicationInstance: {
          input: {
            type: "structure",
            required: [
              "ReplicationInstanceArn"
            ],
            members: {
              ReplicationInstanceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationInstance: {
                shape: "S1z"
              }
            }
          }
        },
        DeleteReplicationSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "ReplicationSubnetGroupIdentifier"
            ],
            members: {
              ReplicationSubnetGroupIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteReplicationTask: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskArn"
            ],
            members: {
              ReplicationTaskArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTask: {
                shape: "S2f"
              }
            }
          }
        },
        DeleteReplicationTaskAssessmentRun: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskAssessmentRunArn"
            ],
            members: {
              ReplicationTaskAssessmentRunArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTaskAssessmentRun: {
                shape: "Se"
              }
            }
          }
        },
        DescribeAccountAttributes: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              AccountQuotas: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountQuotaName: {},
                    Used: {
                      type: "long"
                    },
                    Max: {
                      type: "long"
                    }
                  }
                }
              },
              UniqueAccountIdentifier: {}
            }
          }
        },
        DescribeApplicableIndividualAssessments: {
          input: {
            type: "structure",
            members: {
              ReplicationTaskArn: {},
              ReplicationInstanceArn: {},
              SourceEngineName: {},
              TargetEngineName: {},
              MigrationType: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IndividualAssessmentNames: {
                type: "list",
                member: {}
              },
              Marker: {}
            }
          }
        },
        DescribeCertificates: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S39"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              Certificates: {
                type: "list",
                member: {
                  shape: "S2k"
                }
              }
            }
          }
        },
        DescribeConnections: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S39"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              Connections: {
                type: "list",
                member: {
                  shape: "S2o"
                }
              }
            }
          }
        },
        DescribeEndpointSettings: {
          input: {
            type: "structure",
            required: [
              "EngineName"
            ],
            members: {
              EngineName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              EndpointSettings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Type: {},
                    EnumValues: {
                      type: "list",
                      member: {}
                    },
                    Sensitive: {
                      type: "boolean"
                    },
                    Units: {},
                    Applicability: {},
                    IntValueMin: {
                      type: "integer"
                    },
                    IntValueMax: {
                      type: "integer"
                    },
                    DefaultValue: {}
                  }
                }
              }
            }
          }
        },
        DescribeEndpointTypes: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S39"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              SupportedEndpointTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EngineName: {},
                    SupportsCDC: {
                      type: "boolean"
                    },
                    EndpointType: {},
                    ReplicationInstanceEngineMinimumVersion: {},
                    EngineDisplayName: {}
                  }
                }
              }
            }
          }
        },
        DescribeEndpoints: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S39"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              Endpoints: {
                type: "list",
                member: {
                  shape: "S1p"
                }
              }
            }
          }
        },
        DescribeEventCategories: {
          input: {
            type: "structure",
            members: {
              SourceType: {},
              Filters: {
                shape: "S39"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventCategoryGroupList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceType: {},
                    EventCategories: {
                      shape: "S1r"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeEventSubscriptions: {
          input: {
            type: "structure",
            members: {
              SubscriptionName: {},
              Filters: {
                shape: "S39"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              EventSubscriptionsList: {
                type: "list",
                member: {
                  shape: "S1u"
                }
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceIdentifier: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              EventCategories: {
                shape: "S1r"
              },
              Filters: {
                shape: "S39"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              Events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceIdentifier: {},
                    SourceType: {},
                    Message: {},
                    EventCategories: {
                      shape: "S1r"
                    },
                    Date: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeOrderableReplicationInstances: {
          input: {
            type: "structure",
            members: {
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrderableReplicationInstances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EngineVersion: {},
                    ReplicationInstanceClass: {},
                    StorageType: {},
                    MinAllocatedStorage: {
                      type: "integer"
                    },
                    MaxAllocatedStorage: {
                      type: "integer"
                    },
                    DefaultAllocatedStorage: {
                      type: "integer"
                    },
                    IncludedAllocatedStorage: {
                      type: "integer"
                    },
                    AvailabilityZones: {
                      type: "list",
                      member: {}
                    },
                    ReleaseStatus: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribePendingMaintenanceActions: {
          input: {
            type: "structure",
            members: {
              ReplicationInstanceArn: {},
              Filters: {
                shape: "S39"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PendingMaintenanceActions: {
                type: "list",
                member: {
                  shape: "S8"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeRefreshSchemasStatus: {
          input: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RefreshSchemasStatus: {
                shape: "S4h"
              }
            }
          }
        },
        DescribeReplicationInstanceTaskLogs: {
          input: {
            type: "structure",
            required: [
              "ReplicationInstanceArn"
            ],
            members: {
              ReplicationInstanceArn: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationInstanceArn: {},
              ReplicationInstanceTaskLogs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReplicationTaskName: {},
                    ReplicationTaskArn: {},
                    ReplicationInstanceTaskLogSize: {
                      type: "long"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeReplicationInstances: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S39"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              ReplicationInstances: {
                type: "list",
                member: {
                  shape: "S1z"
                }
              }
            }
          }
        },
        DescribeReplicationSubnetGroups: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S39"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              ReplicationSubnetGroups: {
                type: "list",
                member: {
                  shape: "S22"
                }
              }
            }
          }
        },
        DescribeReplicationTaskAssessmentResults: {
          input: {
            type: "structure",
            members: {
              ReplicationTaskArn: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              BucketName: {},
              ReplicationTaskAssessmentResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReplicationTaskIdentifier: {},
                    ReplicationTaskArn: {},
                    ReplicationTaskLastAssessmentDate: {
                      type: "timestamp"
                    },
                    AssessmentStatus: {},
                    AssessmentResultsFile: {},
                    AssessmentResults: {},
                    S3ObjectUrl: {}
                  }
                }
              }
            }
          }
        },
        DescribeReplicationTaskAssessmentRuns: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S39"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              ReplicationTaskAssessmentRuns: {
                type: "list",
                member: {
                  shape: "Se"
                }
              }
            }
          }
        },
        DescribeReplicationTaskIndividualAssessments: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S39"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              ReplicationTaskIndividualAssessments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReplicationTaskIndividualAssessmentArn: {},
                    ReplicationTaskAssessmentRunArn: {},
                    IndividualAssessmentName: {},
                    Status: {},
                    ReplicationTaskIndividualAssessmentStartDate: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeReplicationTasks: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S39"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              WithoutSettings: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              ReplicationTasks: {
                type: "list",
                member: {
                  shape: "S2f"
                }
              }
            }
          }
        },
        DescribeSchemas: {
          input: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              Schemas: {
                type: "list",
                member: {}
              }
            }
          }
        },
        DescribeTableStatistics: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskArn"
            ],
            members: {
              ReplicationTaskArn: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              Filters: {
                shape: "S39"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTaskArn: {},
              TableStatistics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SchemaName: {},
                    TableName: {},
                    Inserts: {
                      type: "long"
                    },
                    Deletes: {
                      type: "long"
                    },
                    Updates: {
                      type: "long"
                    },
                    Ddls: {
                      type: "long"
                    },
                    FullLoadRows: {
                      type: "long"
                    },
                    FullLoadCondtnlChkFailedRows: {
                      type: "long"
                    },
                    FullLoadErrorRows: {
                      type: "long"
                    },
                    FullLoadStartTime: {
                      type: "timestamp"
                    },
                    FullLoadEndTime: {
                      type: "timestamp"
                    },
                    FullLoadReloaded: {
                      type: "boolean"
                    },
                    LastUpdateTime: {
                      type: "timestamp"
                    },
                    TableState: {},
                    ValidationPendingRecords: {
                      type: "long"
                    },
                    ValidationFailedRecords: {
                      type: "long"
                    },
                    ValidationSuspendedRecords: {
                      type: "long"
                    },
                    ValidationState: {},
                    ValidationStateDetails: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ImportCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateIdentifier"
            ],
            members: {
              CertificateIdentifier: {},
              CertificatePem: {
                shape: "Sj"
              },
              CertificateWallet: {
                type: "blob"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Certificate: {
                shape: "S2k"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            members: {
              ResourceArn: {},
              ResourceArnList: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "S3"
              }
            }
          }
        },
        ModifyEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {},
              EndpointIdentifier: {},
              EndpointType: {},
              EngineName: {},
              Username: {},
              Password: {
                shape: "Sj"
              },
              ServerName: {},
              Port: {
                type: "integer"
              },
              DatabaseName: {},
              ExtraConnectionAttributes: {},
              CertificateArn: {},
              SslMode: {},
              ServiceAccessRoleArn: {},
              ExternalTableDefinition: {},
              DynamoDbSettings: {
                shape: "Sm"
              },
              S3Settings: {
                shape: "Sn"
              },
              DmsTransferSettings: {
                shape: "Sx"
              },
              MongoDbSettings: {
                shape: "Sy"
              },
              KinesisSettings: {
                shape: "S12"
              },
              KafkaSettings: {
                shape: "S14"
              },
              ElasticsearchSettings: {
                shape: "S16"
              },
              NeptuneSettings: {
                shape: "S17"
              },
              RedshiftSettings: {
                shape: "S18"
              },
              PostgreSQLSettings: {
                shape: "S19"
              },
              MySQLSettings: {
                shape: "S1b"
              },
              OracleSettings: {
                shape: "S1d"
              },
              SybaseSettings: {
                shape: "S1g"
              },
              MicrosoftSQLServerSettings: {
                shape: "S1h"
              },
              IBMDb2Settings: {
                shape: "S1j"
              },
              DocDbSettings: {
                shape: "S1k"
              },
              RedisSettings: {
                shape: "S1l"
              },
              ExactSettings: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Endpoint: {
                shape: "S1p"
              }
            }
          }
        },
        ModifyEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S1r"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S1u"
              }
            }
          }
        },
        ModifyReplicationInstance: {
          input: {
            type: "structure",
            required: [
              "ReplicationInstanceArn"
            ],
            members: {
              ReplicationInstanceArn: {},
              AllocatedStorage: {
                type: "integer"
              },
              ApplyImmediately: {
                type: "boolean"
              },
              ReplicationInstanceClass: {},
              VpcSecurityGroupIds: {
                shape: "S1x"
              },
              PreferredMaintenanceWindow: {},
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              ReplicationInstanceIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationInstance: {
                shape: "S1z"
              }
            }
          }
        },
        ModifyReplicationSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "ReplicationSubnetGroupIdentifier",
              "SubnetIds"
            ],
            members: {
              ReplicationSubnetGroupIdentifier: {},
              ReplicationSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S2a"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationSubnetGroup: {
                shape: "S22"
              }
            }
          }
        },
        ModifyReplicationTask: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskArn"
            ],
            members: {
              ReplicationTaskArn: {},
              ReplicationTaskIdentifier: {},
              MigrationType: {},
              TableMappings: {},
              ReplicationTaskSettings: {},
              CdcStartTime: {
                type: "timestamp"
              },
              CdcStartPosition: {},
              CdcStopPosition: {},
              TaskData: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTask: {
                shape: "S2f"
              }
            }
          }
        },
        MoveReplicationTask: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskArn",
              "TargetReplicationInstanceArn"
            ],
            members: {
              ReplicationTaskArn: {},
              TargetReplicationInstanceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTask: {
                shape: "S2f"
              }
            }
          }
        },
        RebootReplicationInstance: {
          input: {
            type: "structure",
            required: [
              "ReplicationInstanceArn"
            ],
            members: {
              ReplicationInstanceArn: {},
              ForceFailover: {
                type: "boolean"
              },
              ForcePlannedFailover: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationInstance: {
                shape: "S1z"
              }
            }
          }
        },
        RefreshSchemas: {
          input: {
            type: "structure",
            required: [
              "EndpointArn",
              "ReplicationInstanceArn"
            ],
            members: {
              EndpointArn: {},
              ReplicationInstanceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RefreshSchemasStatus: {
                shape: "S4h"
              }
            }
          }
        },
        ReloadTables: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskArn",
              "TablesToReload"
            ],
            members: {
              ReplicationTaskArn: {},
              TablesToReload: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SchemaName",
                    "TableName"
                  ],
                  members: {
                    SchemaName: {},
                    TableName: {}
                  }
                }
              },
              ReloadOption: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTaskArn: {}
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartReplicationTask: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskArn",
              "StartReplicationTaskType"
            ],
            members: {
              ReplicationTaskArn: {},
              StartReplicationTaskType: {},
              CdcStartTime: {
                type: "timestamp"
              },
              CdcStartPosition: {},
              CdcStopPosition: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTask: {
                shape: "S2f"
              }
            }
          }
        },
        StartReplicationTaskAssessment: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskArn"
            ],
            members: {
              ReplicationTaskArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTask: {
                shape: "S2f"
              }
            }
          }
        },
        StartReplicationTaskAssessmentRun: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskArn",
              "ServiceAccessRoleArn",
              "ResultLocationBucket",
              "AssessmentRunName"
            ],
            members: {
              ReplicationTaskArn: {},
              ServiceAccessRoleArn: {},
              ResultLocationBucket: {},
              ResultLocationFolder: {},
              ResultEncryptionMode: {},
              ResultKmsKeyArn: {},
              AssessmentRunName: {},
              IncludeOnly: {
                type: "list",
                member: {}
              },
              Exclude: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTaskAssessmentRun: {
                shape: "Se"
              }
            }
          }
        },
        StopReplicationTask: {
          input: {
            type: "structure",
            required: [
              "ReplicationTaskArn"
            ],
            members: {
              ReplicationTaskArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationTask: {
                shape: "S2f"
              }
            }
          }
        },
        TestConnection: {
          input: {
            type: "structure",
            required: [
              "ReplicationInstanceArn",
              "EndpointArn"
            ],
            members: {
              ReplicationInstanceArn: {},
              EndpointArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "S2o"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {},
              ResourceArn: {}
            }
          }
        },
        S8: {
          type: "structure",
          members: {
            ResourceIdentifier: {},
            PendingMaintenanceActionDetails: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Action: {},
                  AutoAppliedAfterDate: {
                    type: "timestamp"
                  },
                  ForcedApplyDate: {
                    type: "timestamp"
                  },
                  OptInStatus: {},
                  CurrentApplyDate: {
                    type: "timestamp"
                  },
                  Description: {}
                }
              }
            }
          }
        },
        Se: {
          type: "structure",
          members: {
            ReplicationTaskAssessmentRunArn: {},
            ReplicationTaskArn: {},
            Status: {},
            ReplicationTaskAssessmentRunCreationDate: {
              type: "timestamp"
            },
            AssessmentProgress: {
              type: "structure",
              members: {
                IndividualAssessmentCount: {
                  type: "integer"
                },
                IndividualAssessmentCompletedCount: {
                  type: "integer"
                }
              }
            },
            LastFailureMessage: {},
            ServiceAccessRoleArn: {},
            ResultLocationBucket: {},
            ResultLocationFolder: {},
            ResultEncryptionMode: {},
            ResultKmsKeyArn: {},
            AssessmentRunName: {}
          }
        },
        Sj: {
          type: "string",
          sensitive: true
        },
        Sm: {
          type: "structure",
          required: [
            "ServiceAccessRoleArn"
          ],
          members: {
            ServiceAccessRoleArn: {}
          }
        },
        Sn: {
          type: "structure",
          members: {
            ServiceAccessRoleArn: {},
            ExternalTableDefinition: {},
            CsvRowDelimiter: {},
            CsvDelimiter: {},
            BucketFolder: {},
            BucketName: {},
            CompressionType: {},
            EncryptionMode: {},
            ServerSideEncryptionKmsKeyId: {},
            DataFormat: {},
            EncodingType: {},
            DictPageSizeLimit: {
              type: "integer"
            },
            RowGroupLength: {
              type: "integer"
            },
            DataPageSize: {
              type: "integer"
            },
            ParquetVersion: {},
            EnableStatistics: {
              type: "boolean"
            },
            IncludeOpForFullLoad: {
              type: "boolean"
            },
            CdcInsertsOnly: {
              type: "boolean"
            },
            TimestampColumnName: {},
            ParquetTimestampInMillisecond: {
              type: "boolean"
            },
            CdcInsertsAndUpdates: {
              type: "boolean"
            },
            DatePartitionEnabled: {
              type: "boolean"
            },
            DatePartitionSequence: {},
            DatePartitionDelimiter: {},
            UseCsvNoSupValue: {
              type: "boolean"
            },
            CsvNoSupValue: {},
            PreserveTransactions: {
              type: "boolean"
            },
            CdcPath: {},
            CannedAclForObjects: {},
            AddColumnName: {
              type: "boolean"
            },
            CdcMaxBatchInterval: {
              type: "integer"
            },
            CdcMinFileSize: {
              type: "integer"
            },
            CsvNullValue: {},
            IgnoreHeaderRows: {
              type: "integer"
            },
            MaxFileSize: {
              type: "integer"
            },
            Rfc4180: {
              type: "boolean"
            }
          }
        },
        Sx: {
          type: "structure",
          members: {
            ServiceAccessRoleArn: {},
            BucketName: {}
          }
        },
        Sy: {
          type: "structure",
          members: {
            Username: {},
            Password: {
              shape: "Sj"
            },
            ServerName: {},
            Port: {
              type: "integer"
            },
            DatabaseName: {},
            AuthType: {},
            AuthMechanism: {},
            NestingLevel: {},
            ExtractDocId: {},
            DocsToInvestigate: {},
            AuthSource: {},
            KmsKeyId: {},
            SecretsManagerAccessRoleArn: {},
            SecretsManagerSecretId: {}
          }
        },
        S12: {
          type: "structure",
          members: {
            StreamArn: {},
            MessageFormat: {},
            ServiceAccessRoleArn: {},
            IncludeTransactionDetails: {
              type: "boolean"
            },
            IncludePartitionValue: {
              type: "boolean"
            },
            PartitionIncludeSchemaTable: {
              type: "boolean"
            },
            IncludeTableAlterOperations: {
              type: "boolean"
            },
            IncludeControlDetails: {
              type: "boolean"
            },
            IncludeNullAndEmpty: {
              type: "boolean"
            },
            NoHexPrefix: {
              type: "boolean"
            }
          }
        },
        S14: {
          type: "structure",
          members: {
            Broker: {},
            Topic: {},
            MessageFormat: {},
            IncludeTransactionDetails: {
              type: "boolean"
            },
            IncludePartitionValue: {
              type: "boolean"
            },
            PartitionIncludeSchemaTable: {
              type: "boolean"
            },
            IncludeTableAlterOperations: {
              type: "boolean"
            },
            IncludeControlDetails: {
              type: "boolean"
            },
            MessageMaxBytes: {
              type: "integer"
            },
            IncludeNullAndEmpty: {
              type: "boolean"
            },
            SecurityProtocol: {},
            SslClientCertificateArn: {},
            SslClientKeyArn: {},
            SslClientKeyPassword: {
              shape: "Sj"
            },
            SslCaCertificateArn: {},
            SaslUsername: {},
            SaslPassword: {
              shape: "Sj"
            },
            NoHexPrefix: {
              type: "boolean"
            }
          }
        },
        S16: {
          type: "structure",
          required: [
            "ServiceAccessRoleArn",
            "EndpointUri"
          ],
          members: {
            ServiceAccessRoleArn: {},
            EndpointUri: {},
            FullLoadErrorPercentage: {
              type: "integer"
            },
            ErrorRetryDuration: {
              type: "integer"
            }
          }
        },
        S17: {
          type: "structure",
          required: [
            "S3BucketName",
            "S3BucketFolder"
          ],
          members: {
            ServiceAccessRoleArn: {},
            S3BucketName: {},
            S3BucketFolder: {},
            ErrorRetryDuration: {
              type: "integer"
            },
            MaxFileSize: {
              type: "integer"
            },
            MaxRetryCount: {
              type: "integer"
            },
            IamAuthEnabled: {
              type: "boolean"
            }
          }
        },
        S18: {
          type: "structure",
          members: {
            AcceptAnyDate: {
              type: "boolean"
            },
            AfterConnectScript: {},
            BucketFolder: {},
            BucketName: {},
            CaseSensitiveNames: {
              type: "boolean"
            },
            CompUpdate: {
              type: "boolean"
            },
            ConnectionTimeout: {
              type: "integer"
            },
            DatabaseName: {},
            DateFormat: {},
            EmptyAsNull: {
              type: "boolean"
            },
            EncryptionMode: {},
            ExplicitIds: {
              type: "boolean"
            },
            FileTransferUploadStreams: {
              type: "integer"
            },
            LoadTimeout: {
              type: "integer"
            },
            MaxFileSize: {
              type: "integer"
            },
            Password: {
              shape: "Sj"
            },
            Port: {
              type: "integer"
            },
            RemoveQuotes: {
              type: "boolean"
            },
            ReplaceInvalidChars: {},
            ReplaceChars: {},
            ServerName: {},
            ServiceAccessRoleArn: {},
            ServerSideEncryptionKmsKeyId: {},
            TimeFormat: {},
            TrimBlanks: {
              type: "boolean"
            },
            TruncateColumns: {
              type: "boolean"
            },
            Username: {},
            WriteBufferSize: {
              type: "integer"
            },
            SecretsManagerAccessRoleArn: {},
            SecretsManagerSecretId: {}
          }
        },
        S19: {
          type: "structure",
          members: {
            AfterConnectScript: {},
            CaptureDdls: {
              type: "boolean"
            },
            MaxFileSize: {
              type: "integer"
            },
            DatabaseName: {},
            DdlArtifactsSchema: {},
            ExecuteTimeout: {
              type: "integer"
            },
            FailTasksOnLobTruncation: {
              type: "boolean"
            },
            HeartbeatEnable: {
              type: "boolean"
            },
            HeartbeatSchema: {},
            HeartbeatFrequency: {
              type: "integer"
            },
            Password: {
              shape: "Sj"
            },
            Port: {
              type: "integer"
            },
            ServerName: {},
            Username: {},
            SlotName: {},
            PluginName: {},
            SecretsManagerAccessRoleArn: {},
            SecretsManagerSecretId: {}
          }
        },
        S1b: {
          type: "structure",
          members: {
            AfterConnectScript: {},
            CleanSourceMetadataOnMismatch: {
              type: "boolean"
            },
            DatabaseName: {},
            EventsPollInterval: {
              type: "integer"
            },
            TargetDbType: {},
            MaxFileSize: {
              type: "integer"
            },
            ParallelLoadThreads: {
              type: "integer"
            },
            Password: {
              shape: "Sj"
            },
            Port: {
              type: "integer"
            },
            ServerName: {},
            ServerTimezone: {},
            Username: {},
            SecretsManagerAccessRoleArn: {},
            SecretsManagerSecretId: {}
          }
        },
        S1d: {
          type: "structure",
          members: {
            AddSupplementalLogging: {
              type: "boolean"
            },
            ArchivedLogDestId: {
              type: "integer"
            },
            AdditionalArchivedLogDestId: {
              type: "integer"
            },
            ExtraArchivedLogDestIds: {
              type: "list",
              member: {
                type: "integer"
              }
            },
            AllowSelectNestedTables: {
              type: "boolean"
            },
            ParallelAsmReadThreads: {
              type: "integer"
            },
            ReadAheadBlocks: {
              type: "integer"
            },
            AccessAlternateDirectly: {
              type: "boolean"
            },
            UseAlternateFolderForOnline: {
              type: "boolean"
            },
            OraclePathPrefix: {},
            UsePathPrefix: {},
            ReplacePathPrefix: {
              type: "boolean"
            },
            EnableHomogenousTablespace: {
              type: "boolean"
            },
            DirectPathNoLog: {
              type: "boolean"
            },
            ArchivedLogsOnly: {
              type: "boolean"
            },
            AsmPassword: {
              shape: "Sj"
            },
            AsmServer: {},
            AsmUser: {},
            CharLengthSemantics: {},
            DatabaseName: {},
            DirectPathParallelLoad: {
              type: "boolean"
            },
            FailTasksOnLobTruncation: {
              type: "boolean"
            },
            NumberDatatypeScale: {
              type: "integer"
            },
            Password: {
              shape: "Sj"
            },
            Port: {
              type: "integer"
            },
            ReadTableSpaceName: {
              type: "boolean"
            },
            RetryInterval: {
              type: "integer"
            },
            SecurityDbEncryption: {
              shape: "Sj"
            },
            SecurityDbEncryptionName: {},
            ServerName: {},
            SpatialDataOptionToGeoJsonFunctionName: {},
            StandbyDelayTime: {
              type: "integer"
            },
            Username: {},
            UseBFile: {
              type: "boolean"
            },
            UseDirectPathFullLoad: {
              type: "boolean"
            },
            UseLogminerReader: {
              type: "boolean"
            },
            SecretsManagerAccessRoleArn: {},
            SecretsManagerSecretId: {},
            SecretsManagerOracleAsmAccessRoleArn: {},
            SecretsManagerOracleAsmSecretId: {}
          }
        },
        S1g: {
          type: "structure",
          members: {
            DatabaseName: {},
            Password: {
              shape: "Sj"
            },
            Port: {
              type: "integer"
            },
            ServerName: {},
            Username: {},
            SecretsManagerAccessRoleArn: {},
            SecretsManagerSecretId: {}
          }
        },
        S1h: {
          type: "structure",
          members: {
            Port: {
              type: "integer"
            },
            BcpPacketSize: {
              type: "integer"
            },
            DatabaseName: {},
            ControlTablesFileGroup: {},
            Password: {
              shape: "Sj"
            },
            QuerySingleAlwaysOnNode: {
              type: "boolean"
            },
            ReadBackupOnly: {
              type: "boolean"
            },
            SafeguardPolicy: {},
            ServerName: {},
            Username: {},
            UseBcpFullLoad: {
              type: "boolean"
            },
            UseThirdPartyBackupDevice: {
              type: "boolean"
            },
            SecretsManagerAccessRoleArn: {},
            SecretsManagerSecretId: {}
          }
        },
        S1j: {
          type: "structure",
          members: {
            DatabaseName: {},
            Password: {
              shape: "Sj"
            },
            Port: {
              type: "integer"
            },
            ServerName: {},
            SetDataCaptureChanges: {
              type: "boolean"
            },
            CurrentLsn: {},
            MaxKBytesPerRead: {
              type: "integer"
            },
            Username: {},
            SecretsManagerAccessRoleArn: {},
            SecretsManagerSecretId: {}
          }
        },
        S1k: {
          type: "structure",
          members: {
            Username: {},
            Password: {
              shape: "Sj"
            },
            ServerName: {},
            Port: {
              type: "integer"
            },
            DatabaseName: {},
            NestingLevel: {},
            ExtractDocId: {
              type: "boolean"
            },
            DocsToInvestigate: {
              type: "integer"
            },
            KmsKeyId: {},
            SecretsManagerAccessRoleArn: {},
            SecretsManagerSecretId: {}
          }
        },
        S1l: {
          type: "structure",
          required: [
            "ServerName",
            "Port"
          ],
          members: {
            ServerName: {},
            Port: {
              type: "integer"
            },
            SslSecurityProtocol: {},
            AuthType: {},
            AuthUserName: {},
            AuthPassword: {
              shape: "Sj"
            },
            SslCaCertificateArn: {}
          }
        },
        S1p: {
          type: "structure",
          members: {
            EndpointIdentifier: {},
            EndpointType: {},
            EngineName: {},
            EngineDisplayName: {},
            Username: {},
            ServerName: {},
            Port: {
              type: "integer"
            },
            DatabaseName: {},
            ExtraConnectionAttributes: {},
            Status: {},
            KmsKeyId: {},
            EndpointArn: {},
            CertificateArn: {},
            SslMode: {},
            ServiceAccessRoleArn: {},
            ExternalTableDefinition: {},
            ExternalId: {},
            DynamoDbSettings: {
              shape: "Sm"
            },
            S3Settings: {
              shape: "Sn"
            },
            DmsTransferSettings: {
              shape: "Sx"
            },
            MongoDbSettings: {
              shape: "Sy"
            },
            KinesisSettings: {
              shape: "S12"
            },
            KafkaSettings: {
              shape: "S14"
            },
            ElasticsearchSettings: {
              shape: "S16"
            },
            NeptuneSettings: {
              shape: "S17"
            },
            RedshiftSettings: {
              shape: "S18"
            },
            PostgreSQLSettings: {
              shape: "S19"
            },
            MySQLSettings: {
              shape: "S1b"
            },
            OracleSettings: {
              shape: "S1d"
            },
            SybaseSettings: {
              shape: "S1g"
            },
            MicrosoftSQLServerSettings: {
              shape: "S1h"
            },
            IBMDb2Settings: {
              shape: "S1j"
            },
            DocDbSettings: {
              shape: "S1k"
            },
            RedisSettings: {
              shape: "S1l"
            }
          }
        },
        S1r: {
          type: "list",
          member: {}
        },
        S1s: {
          type: "list",
          member: {}
        },
        S1u: {
          type: "structure",
          members: {
            CustomerAwsId: {},
            CustSubscriptionId: {},
            SnsTopicArn: {},
            Status: {},
            SubscriptionCreationTime: {},
            SourceType: {},
            SourceIdsList: {
              shape: "S1s"
            },
            EventCategoriesList: {
              shape: "S1r"
            },
            Enabled: {
              type: "boolean"
            }
          }
        },
        S1x: {
          type: "list",
          member: {}
        },
        S1z: {
          type: "structure",
          members: {
            ReplicationInstanceIdentifier: {},
            ReplicationInstanceClass: {},
            ReplicationInstanceStatus: {},
            AllocatedStorage: {
              type: "integer"
            },
            InstanceCreateTime: {
              type: "timestamp"
            },
            VpcSecurityGroups: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  VpcSecurityGroupId: {},
                  Status: {}
                }
              }
            },
            AvailabilityZone: {},
            ReplicationSubnetGroup: {
              shape: "S22"
            },
            PreferredMaintenanceWindow: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                ReplicationInstanceClass: {},
                AllocatedStorage: {
                  type: "integer"
                },
                MultiAZ: {
                  type: "boolean"
                },
                EngineVersion: {}
              }
            },
            MultiAZ: {
              type: "boolean"
            },
            EngineVersion: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            KmsKeyId: {},
            ReplicationInstanceArn: {},
            ReplicationInstancePublicIpAddress: {
              deprecated: true
            },
            ReplicationInstancePrivateIpAddress: {
              deprecated: true
            },
            ReplicationInstancePublicIpAddresses: {
              type: "list",
              member: {}
            },
            ReplicationInstancePrivateIpAddresses: {
              type: "list",
              member: {}
            },
            PubliclyAccessible: {
              type: "boolean"
            },
            SecondaryAvailabilityZone: {},
            FreeUntil: {
              type: "timestamp"
            },
            DnsNameServers: {}
          }
        },
        S22: {
          type: "structure",
          members: {
            ReplicationSubnetGroupIdentifier: {},
            ReplicationSubnetGroupDescription: {},
            VpcId: {},
            SubnetGroupStatus: {},
            Subnets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {
                    type: "structure",
                    members: {
                      Name: {}
                    }
                  },
                  SubnetStatus: {}
                }
              }
            }
          }
        },
        S2a: {
          type: "list",
          member: {}
        },
        S2f: {
          type: "structure",
          members: {
            ReplicationTaskIdentifier: {},
            SourceEndpointArn: {},
            TargetEndpointArn: {},
            ReplicationInstanceArn: {},
            MigrationType: {},
            TableMappings: {},
            ReplicationTaskSettings: {},
            Status: {},
            LastFailureMessage: {},
            StopReason: {},
            ReplicationTaskCreationDate: {
              type: "timestamp"
            },
            ReplicationTaskStartDate: {
              type: "timestamp"
            },
            CdcStartPosition: {},
            CdcStopPosition: {},
            RecoveryCheckpoint: {},
            ReplicationTaskArn: {},
            ReplicationTaskStats: {
              type: "structure",
              members: {
                FullLoadProgressPercent: {
                  type: "integer"
                },
                ElapsedTimeMillis: {
                  type: "long"
                },
                TablesLoaded: {
                  type: "integer"
                },
                TablesLoading: {
                  type: "integer"
                },
                TablesQueued: {
                  type: "integer"
                },
                TablesErrored: {
                  type: "integer"
                },
                FreshStartDate: {
                  type: "timestamp"
                },
                StartDate: {
                  type: "timestamp"
                },
                StopDate: {
                  type: "timestamp"
                },
                FullLoadStartDate: {
                  type: "timestamp"
                },
                FullLoadFinishDate: {
                  type: "timestamp"
                }
              }
            },
            TaskData: {},
            TargetReplicationInstanceArn: {}
          }
        },
        S2k: {
          type: "structure",
          members: {
            CertificateIdentifier: {},
            CertificateCreationDate: {
              type: "timestamp"
            },
            CertificatePem: {},
            CertificateWallet: {
              type: "blob"
            },
            CertificateArn: {},
            CertificateOwner: {},
            ValidFromDate: {
              type: "timestamp"
            },
            ValidToDate: {
              type: "timestamp"
            },
            SigningAlgorithm: {},
            KeyLength: {
              type: "integer"
            }
          }
        },
        S2o: {
          type: "structure",
          members: {
            ReplicationInstanceArn: {},
            EndpointArn: {},
            Status: {},
            LastFailureMessage: {},
            EndpointIdentifier: {},
            ReplicationInstanceIdentifier: {}
          }
        },
        S39: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Values"
            ],
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S4h: {
          type: "structure",
          members: {
            EndpointArn: {},
            ReplicationInstanceArn: {},
            Status: {},
            LastRefreshDate: {
              type: "timestamp"
            },
            LastFailureMessage: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dms-2016-01-01.paginators.json
var require_dms_2016_01_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/dms-2016-01-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeApplicableIndividualAssessments: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeCertificates: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeConnections: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeEndpointSettings: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeEndpointTypes: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeEndpoints: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeEventSubscriptions: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeEvents: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeOrderableReplicationInstances: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribePendingMaintenanceActions: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeReplicationInstanceTaskLogs: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeReplicationInstances: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeReplicationSubnetGroups: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeReplicationTaskAssessmentResults: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeReplicationTaskAssessmentRuns: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeReplicationTaskIndividualAssessments: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeReplicationTasks: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeSchemas: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        },
        DescribeTableStatistics: {
          input_token: "Marker",
          output_token: "Marker",
          limit_key: "MaxRecords"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dms-2016-01-01.waiters2.json
var require_dms_2016_01_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/dms-2016-01-01.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        TestConnectionSucceeds: {
          acceptors: [
            {
              argument: "Connections[].Status",
              expected: "successful",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "Connections[].Status",
              expected: "failed",
              matcher: "pathAny",
              state: "failure"
            }
          ],
          delay: 5,
          description: "Wait until testing connection succeeds.",
          maxAttempts: 60,
          operation: "DescribeConnections"
        },
        EndpointDeleted: {
          acceptors: [
            {
              expected: "ResourceNotFoundFault",
              matcher: "error",
              state: "success"
            },
            {
              argument: "Endpoints[].Status",
              expected: "active",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "Endpoints[].Status",
              expected: "creating",
              matcher: "pathAny",
              state: "failure"
            }
          ],
          delay: 5,
          description: "Wait until testing endpoint is deleted.",
          maxAttempts: 60,
          operation: "DescribeEndpoints"
        },
        ReplicationInstanceAvailable: {
          acceptors: [
            {
              argument: "ReplicationInstances[].ReplicationInstanceStatus",
              expected: "available",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "ReplicationInstances[].ReplicationInstanceStatus",
              expected: "deleting",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationInstances[].ReplicationInstanceStatus",
              expected: "incompatible-credentials",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationInstances[].ReplicationInstanceStatus",
              expected: "incompatible-network",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationInstances[].ReplicationInstanceStatus",
              expected: "inaccessible-encryption-credentials",
              matcher: "pathAny",
              state: "failure"
            }
          ],
          delay: 60,
          description: "Wait until DMS replication instance is available.",
          maxAttempts: 60,
          operation: "DescribeReplicationInstances"
        },
        ReplicationInstanceDeleted: {
          acceptors: [
            {
              argument: "ReplicationInstances[].ReplicationInstanceStatus",
              expected: "available",
              matcher: "pathAny",
              state: "failure"
            },
            {
              expected: "ResourceNotFoundFault",
              matcher: "error",
              state: "success"
            }
          ],
          delay: 15,
          description: "Wait until DMS replication instance is deleted.",
          maxAttempts: 60,
          operation: "DescribeReplicationInstances"
        },
        ReplicationTaskReady: {
          acceptors: [
            {
              argument: "ReplicationTasks[].Status",
              expected: "ready",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "starting",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "running",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "stopping",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "stopped",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "failed",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "modifying",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "testing",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "deleting",
              matcher: "pathAny",
              state: "failure"
            }
          ],
          delay: 15,
          description: "Wait until DMS replication task is ready.",
          maxAttempts: 60,
          operation: "DescribeReplicationTasks"
        },
        ReplicationTaskStopped: {
          acceptors: [
            {
              argument: "ReplicationTasks[].Status",
              expected: "stopped",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "ready",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "creating",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "starting",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "failed",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "modifying",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "testing",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "deleting",
              matcher: "pathAny",
              state: "failure"
            }
          ],
          delay: 15,
          description: "Wait until DMS replication task is stopped.",
          maxAttempts: 60,
          operation: "DescribeReplicationTasks"
        },
        ReplicationTaskRunning: {
          acceptors: [
            {
              argument: "ReplicationTasks[].Status",
              expected: "running",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "ready",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "creating",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "stopping",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "stopped",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "failed",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "modifying",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "testing",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "deleting",
              matcher: "pathAny",
              state: "failure"
            }
          ],
          delay: 15,
          description: "Wait until DMS replication task is running.",
          maxAttempts: 60,
          operation: "DescribeReplicationTasks"
        },
        ReplicationTaskDeleted: {
          acceptors: [
            {
              argument: "ReplicationTasks[].Status",
              expected: "ready",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "creating",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "stopped",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "running",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "ReplicationTasks[].Status",
              expected: "failed",
              matcher: "pathAny",
              state: "failure"
            },
            {
              expected: "ResourceNotFoundFault",
              matcher: "error",
              state: "success"
            }
          ],
          delay: 15,
          description: "Wait until DMS replication task is deleted.",
          maxAttempts: 60,
          operation: "DescribeReplicationTasks"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/dms.js
var require_dms = __commonJS({
  "node_modules/aws-sdk/clients/dms.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["dms"] = {};
    AWS3.DMS = Service.defineService("dms", ["2016-01-01"]);
    Object.defineProperty(apiLoader.services["dms"], "2016-01-01", {
      get: function get() {
        var model = require_dms_2016_01_01_min();
        model.paginators = require_dms_2016_01_01_paginators().pagination;
        model.waiters = require_dms_2016_01_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.DMS;
  }
});

// node_modules/aws-sdk/lib/dynamodb/types.js
var require_types2 = __commonJS({
  "node_modules/aws-sdk/lib/dynamodb/types.js"(exports, module2) {
    var util = require_core().util;
    function typeOf(data) {
      if (data === null && typeof data === "object") {
        return "null";
      } else if (data !== void 0 && isBinary(data)) {
        return "Binary";
      } else if (data !== void 0 && data.constructor) {
        return data.wrapperName || util.typeName(data.constructor);
      } else if (data !== void 0 && typeof data === "object") {
        return "Object";
      } else {
        return "undefined";
      }
    }
    function isBinary(data) {
      var types = [
        "Buffer",
        "File",
        "Blob",
        "ArrayBuffer",
        "DataView",
        "Int8Array",
        "Uint8Array",
        "Uint8ClampedArray",
        "Int16Array",
        "Uint16Array",
        "Int32Array",
        "Uint32Array",
        "Float32Array",
        "Float64Array"
      ];
      if (util.isNode()) {
        var Stream = util.stream.Stream;
        if (util.Buffer.isBuffer(data) || data instanceof Stream) {
          return true;
        }
      }
      for (var i = 0; i < types.length; i++) {
        if (data !== void 0 && data.constructor) {
          if (util.isType(data, types[i]))
            return true;
          if (util.typeName(data.constructor) === types[i])
            return true;
        }
      }
      return false;
    }
    module2.exports = {
      typeOf,
      isBinary
    };
  }
});

// node_modules/aws-sdk/lib/dynamodb/set.js
var require_set = __commonJS({
  "node_modules/aws-sdk/lib/dynamodb/set.js"(exports, module2) {
    var util = require_core().util;
    var typeOf = require_types2().typeOf;
    var memberTypeToSetType = {
      "String": "String",
      "Number": "Number",
      "NumberValue": "Number",
      "Binary": "Binary"
    };
    var DynamoDBSet = util.inherit({
      constructor: function Set2(list, options) {
        options = options || {};
        this.wrapperName = "Set";
        this.initialize(list, options.validate);
      },
      initialize: function(list, validate) {
        var self2 = this;
        self2.values = [].concat(list);
        self2.detectType();
        if (validate) {
          self2.validate();
        }
      },
      detectType: function() {
        this.type = memberTypeToSetType[typeOf(this.values[0])];
        if (!this.type) {
          throw util.error(new Error(), {
            code: "InvalidSetType",
            message: "Sets can contain string, number, or binary values"
          });
        }
      },
      validate: function() {
        var self2 = this;
        var length = self2.values.length;
        var values = self2.values;
        for (var i = 0; i < length; i++) {
          if (memberTypeToSetType[typeOf(values[i])] !== self2.type) {
            throw util.error(new Error(), {
              code: "InvalidType",
              message: self2.type + " Set contains " + typeOf(values[i]) + " value"
            });
          }
        }
      },
      toJSON: function() {
        var self2 = this;
        return self2.values;
      }
    });
    module2.exports = DynamoDBSet;
  }
});

// node_modules/aws-sdk/lib/dynamodb/numberValue.js
var require_numberValue = __commonJS({
  "node_modules/aws-sdk/lib/dynamodb/numberValue.js"(exports, module2) {
    var util = require_core().util;
    var DynamoDBNumberValue = util.inherit({
      constructor: function NumberValue(value) {
        this.wrapperName = "NumberValue";
        this.value = value.toString();
      },
      toJSON: function() {
        return this.toNumber();
      },
      toNumber: function() {
        return Number(this.value);
      },
      toString: function() {
        return this.value;
      }
    });
    module2.exports = DynamoDBNumberValue;
  }
});

// node_modules/aws-sdk/lib/dynamodb/converter.js
var require_converter = __commonJS({
  "node_modules/aws-sdk/lib/dynamodb/converter.js"(exports, module2) {
    var AWS3 = require_core();
    var util = AWS3.util;
    var typeOf = require_types2().typeOf;
    var DynamoDBSet = require_set();
    var NumberValue = require_numberValue();
    AWS3.DynamoDB.Converter = {
      input: function convertInput(data, options) {
        options = options || {};
        var type = typeOf(data);
        if (type === "Object") {
          return formatMap(data, options);
        } else if (type === "Array") {
          return formatList(data, options);
        } else if (type === "Set") {
          return formatSet(data, options);
        } else if (type === "String") {
          if (data.length === 0 && options.convertEmptyValues) {
            return convertInput(null);
          }
          return { S: data };
        } else if (type === "Number" || type === "NumberValue") {
          return { N: data.toString() };
        } else if (type === "Binary") {
          if (data.length === 0 && options.convertEmptyValues) {
            return convertInput(null);
          }
          return { B: data };
        } else if (type === "Boolean") {
          return { BOOL: data };
        } else if (type === "null") {
          return { NULL: true };
        } else if (type !== "undefined" && type !== "Function") {
          return formatMap(data, options);
        }
      },
      marshall: function marshallItem(data, options) {
        return AWS3.DynamoDB.Converter.input(data, options).M;
      },
      output: function convertOutput(data, options) {
        options = options || {};
        var list, map, i;
        for (var type in data) {
          var values = data[type];
          if (type === "M") {
            map = {};
            for (var key in values) {
              map[key] = convertOutput(values[key], options);
            }
            return map;
          } else if (type === "L") {
            list = [];
            for (i = 0; i < values.length; i++) {
              list.push(convertOutput(values[i], options));
            }
            return list;
          } else if (type === "SS") {
            list = [];
            for (i = 0; i < values.length; i++) {
              list.push(values[i] + "");
            }
            return new DynamoDBSet(list);
          } else if (type === "NS") {
            list = [];
            for (i = 0; i < values.length; i++) {
              list.push(convertNumber(values[i], options.wrapNumbers));
            }
            return new DynamoDBSet(list);
          } else if (type === "BS") {
            list = [];
            for (i = 0; i < values.length; i++) {
              list.push(AWS3.util.buffer.toBuffer(values[i]));
            }
            return new DynamoDBSet(list);
          } else if (type === "S") {
            return values + "";
          } else if (type === "N") {
            return convertNumber(values, options.wrapNumbers);
          } else if (type === "B") {
            return util.buffer.toBuffer(values);
          } else if (type === "BOOL") {
            return values === "true" || values === "TRUE" || values === true;
          } else if (type === "NULL") {
            return null;
          }
        }
      },
      unmarshall: function unmarshall(data, options) {
        return AWS3.DynamoDB.Converter.output({ M: data }, options);
      }
    };
    function formatList(data, options) {
      var list = { L: [] };
      for (var i = 0; i < data.length; i++) {
        list["L"].push(AWS3.DynamoDB.Converter.input(data[i], options));
      }
      return list;
    }
    function convertNumber(value, wrapNumbers) {
      return wrapNumbers ? new NumberValue(value) : Number(value);
    }
    function formatMap(data, options) {
      var map = { M: {} };
      for (var key in data) {
        var formatted = AWS3.DynamoDB.Converter.input(data[key], options);
        if (formatted !== void 0) {
          map["M"][key] = formatted;
        }
      }
      return map;
    }
    function formatSet(data, options) {
      options = options || {};
      var values = data.values;
      if (options.convertEmptyValues) {
        values = filterEmptySetValues(data);
        if (values.length === 0) {
          return AWS3.DynamoDB.Converter.input(null);
        }
      }
      var map = {};
      switch (data.type) {
        case "String":
          map["SS"] = values;
          break;
        case "Binary":
          map["BS"] = values;
          break;
        case "Number":
          map["NS"] = values.map(function(value) {
            return value.toString();
          });
      }
      return map;
    }
    function filterEmptySetValues(set) {
      var nonEmptyValues = [];
      var potentiallyEmptyTypes = {
        String: true,
        Binary: true,
        Number: false
      };
      if (potentiallyEmptyTypes[set.type]) {
        for (var i = 0; i < set.values.length; i++) {
          if (set.values[i].length === 0) {
            continue;
          }
          nonEmptyValues.push(set.values[i]);
        }
        return nonEmptyValues;
      }
      return set.values;
    }
    module2.exports = AWS3.DynamoDB.Converter;
  }
});

// node_modules/aws-sdk/lib/dynamodb/translator.js
var require_translator = __commonJS({
  "node_modules/aws-sdk/lib/dynamodb/translator.js"(exports, module2) {
    var util = require_core().util;
    var convert = require_converter();
    var Translator = function(options) {
      options = options || {};
      this.attrValue = options.attrValue;
      this.convertEmptyValues = Boolean(options.convertEmptyValues);
      this.wrapNumbers = Boolean(options.wrapNumbers);
    };
    Translator.prototype.translateInput = function(value, shape) {
      this.mode = "input";
      return this.translate(value, shape);
    };
    Translator.prototype.translateOutput = function(value, shape) {
      this.mode = "output";
      return this.translate(value, shape);
    };
    Translator.prototype.translate = function(value, shape) {
      var self2 = this;
      if (!shape || value === void 0)
        return void 0;
      if (shape.shape === self2.attrValue) {
        return convert[self2.mode](value, {
          convertEmptyValues: self2.convertEmptyValues,
          wrapNumbers: self2.wrapNumbers
        });
      }
      switch (shape.type) {
        case "structure":
          return self2.translateStructure(value, shape);
        case "map":
          return self2.translateMap(value, shape);
        case "list":
          return self2.translateList(value, shape);
        default:
          return self2.translateScalar(value, shape);
      }
    };
    Translator.prototype.translateStructure = function(structure, shape) {
      var self2 = this;
      if (structure == null)
        return void 0;
      var struct = {};
      util.each(structure, function(name, value) {
        var memberShape = shape.members[name];
        if (memberShape) {
          var result = self2.translate(value, memberShape);
          if (result !== void 0)
            struct[name] = result;
        }
      });
      return struct;
    };
    Translator.prototype.translateList = function(list, shape) {
      var self2 = this;
      if (list == null)
        return void 0;
      var out = [];
      util.arrayEach(list, function(value) {
        var result = self2.translate(value, shape.member);
        if (result === void 0)
          out.push(null);
        else
          out.push(result);
      });
      return out;
    };
    Translator.prototype.translateMap = function(map, shape) {
      var self2 = this;
      if (map == null)
        return void 0;
      var out = {};
      util.each(map, function(key, value) {
        var result = self2.translate(value, shape.value);
        if (result === void 0)
          out[key] = null;
        else
          out[key] = result;
      });
      return out;
    };
    Translator.prototype.translateScalar = function(value, shape) {
      return shape.toType(value);
    };
    module2.exports = Translator;
  }
});

// node_modules/aws-sdk/lib/dynamodb/document_client.js
var require_document_client = __commonJS({
  "node_modules/aws-sdk/lib/dynamodb/document_client.js"(exports, module2) {
    var AWS3 = require_core();
    var Translator = require_translator();
    var DynamoDBSet = require_set();
    AWS3.DynamoDB.DocumentClient = AWS3.util.inherit({
      constructor: function DocumentClient(options) {
        var self2 = this;
        self2.options = options || {};
        self2.configure(self2.options);
      },
      configure: function configure(options) {
        var self2 = this;
        self2.service = options.service;
        self2.bindServiceObject(options);
        self2.attrValue = options.attrValue = self2.service.api.operations.putItem.input.members.Item.value.shape;
      },
      bindServiceObject: function bindServiceObject(options) {
        var self2 = this;
        options = options || {};
        if (!self2.service) {
          self2.service = new AWS3.DynamoDB(options);
        } else {
          var config = AWS3.util.copy(self2.service.config);
          self2.service = new self2.service.constructor.__super__(config);
          self2.service.config.params = AWS3.util.merge(self2.service.config.params || {}, options.params);
        }
      },
      makeServiceRequest: function(operation, params, callback) {
        var self2 = this;
        var request = self2.service[operation](params);
        self2.setupRequest(request);
        self2.setupResponse(request);
        if (typeof callback === "function") {
          request.send(callback);
        }
        return request;
      },
      serviceClientOperationsMap: {
        batchGet: "batchGetItem",
        batchWrite: "batchWriteItem",
        delete: "deleteItem",
        get: "getItem",
        put: "putItem",
        query: "query",
        scan: "scan",
        update: "updateItem",
        transactGet: "transactGetItems",
        transactWrite: "transactWriteItems"
      },
      batchGet: function(params, callback) {
        var operation = this.serviceClientOperationsMap["batchGet"];
        return this.makeServiceRequest(operation, params, callback);
      },
      batchWrite: function(params, callback) {
        var operation = this.serviceClientOperationsMap["batchWrite"];
        return this.makeServiceRequest(operation, params, callback);
      },
      delete: function(params, callback) {
        var operation = this.serviceClientOperationsMap["delete"];
        return this.makeServiceRequest(operation, params, callback);
      },
      get: function(params, callback) {
        var operation = this.serviceClientOperationsMap["get"];
        return this.makeServiceRequest(operation, params, callback);
      },
      put: function(params, callback) {
        var operation = this.serviceClientOperationsMap["put"];
        return this.makeServiceRequest(operation, params, callback);
      },
      update: function(params, callback) {
        var operation = this.serviceClientOperationsMap["update"];
        return this.makeServiceRequest(operation, params, callback);
      },
      scan: function(params, callback) {
        var operation = this.serviceClientOperationsMap["scan"];
        return this.makeServiceRequest(operation, params, callback);
      },
      query: function(params, callback) {
        var operation = this.serviceClientOperationsMap["query"];
        return this.makeServiceRequest(operation, params, callback);
      },
      transactWrite: function(params, callback) {
        var operation = this.serviceClientOperationsMap["transactWrite"];
        return this.makeServiceRequest(operation, params, callback);
      },
      transactGet: function(params, callback) {
        var operation = this.serviceClientOperationsMap["transactGet"];
        return this.makeServiceRequest(operation, params, callback);
      },
      createSet: function(list, options) {
        options = options || {};
        return new DynamoDBSet(list, options);
      },
      getTranslator: function() {
        return new Translator(this.options);
      },
      setupRequest: function setupRequest(request) {
        var self2 = this;
        var translator = self2.getTranslator();
        var operation = request.operation;
        var inputShape = request.service.api.operations[operation].input;
        request._events.validate.unshift(function(req) {
          req.rawParams = AWS3.util.copy(req.params);
          req.params = translator.translateInput(req.rawParams, inputShape);
        });
      },
      setupResponse: function setupResponse(request) {
        var self2 = this;
        var translator = self2.getTranslator();
        var outputShape = self2.service.api.operations[request.operation].output;
        request.on("extractData", function(response2) {
          response2.data = translator.translateOutput(response2.data, outputShape);
        });
        var response = request.response;
        response.nextPage = function(cb) {
          var resp = this;
          var req = resp.request;
          var config;
          var service = req.service;
          var operation = req.operation;
          try {
            config = service.paginationConfig(operation, true);
          } catch (e) {
            resp.error = e;
          }
          if (!resp.hasNextPage()) {
            if (cb)
              cb(resp.error, null);
            else if (resp.error)
              throw resp.error;
            return null;
          }
          var params = AWS3.util.copy(req.rawParams);
          if (!resp.nextPageTokens) {
            return cb ? cb(null, null) : null;
          } else {
            var inputTokens = config.inputToken;
            if (typeof inputTokens === "string")
              inputTokens = [inputTokens];
            for (var i = 0; i < inputTokens.length; i++) {
              params[inputTokens[i]] = resp.nextPageTokens[i];
            }
            return self2[operation](params, cb);
          }
        };
      }
    });
    module2.exports = AWS3.DynamoDB.DocumentClient;
  }
});

// node_modules/aws-sdk/lib/services/dynamodb.js
var require_dynamodb = __commonJS({
  "node_modules/aws-sdk/lib/services/dynamodb.js"() {
    var AWS3 = require_core();
    require_document_client();
    AWS3.util.update(AWS3.DynamoDB.prototype, {
      setupRequestListeners: function setupRequestListeners(request) {
        if (request.service.config.dynamoDbCrc32) {
          request.removeListener("extractData", AWS3.EventListeners.Json.EXTRACT_DATA);
          request.addListener("extractData", this.checkCrc32);
          request.addListener("extractData", AWS3.EventListeners.Json.EXTRACT_DATA);
        }
      },
      checkCrc32: function checkCrc32(resp) {
        if (!resp.httpResponse.streaming && !resp.request.service.crc32IsValid(resp)) {
          resp.data = null;
          resp.error = AWS3.util.error(new Error(), {
            code: "CRC32CheckFailed",
            message: "CRC32 integrity check failed",
            retryable: true
          });
          resp.request.haltHandlersOnError();
          throw resp.error;
        }
      },
      crc32IsValid: function crc32IsValid(resp) {
        var crc = resp.httpResponse.headers["x-amz-crc32"];
        if (!crc)
          return true;
        return parseInt(crc, 10) === AWS3.util.crypto.crc32(resp.httpResponse.body);
      },
      defaultRetryCount: 10,
      retryDelays: function retryDelays(retryCount, err) {
        var retryDelayOptions = AWS3.util.copy(this.config.retryDelayOptions);
        if (typeof retryDelayOptions.base !== "number") {
          retryDelayOptions.base = 50;
        }
        var delay = AWS3.util.calculateRetryDelay(retryCount, retryDelayOptions, err);
        return delay;
      }
    });
  }
});

// node_modules/aws-sdk/apis/dynamodb-2011-12-05.min.json
var require_dynamodb_2011_12_05_min = __commonJS({
  "node_modules/aws-sdk/apis/dynamodb-2011-12-05.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2011-12-05",
        endpointPrefix: "dynamodb",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "DynamoDB",
        serviceFullName: "Amazon DynamoDB",
        serviceId: "DynamoDB",
        signatureVersion: "v4",
        targetPrefix: "DynamoDB_20111205",
        uid: "dynamodb-2011-12-05"
      },
      operations: {
        BatchGetItem: {
          input: {
            type: "structure",
            required: [
              "RequestItems"
            ],
            members: {
              RequestItems: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Responses: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    Items: {
                      shape: "Sk"
                    },
                    ConsumedCapacityUnits: {
                      type: "double"
                    }
                  }
                }
              },
              UnprocessedKeys: {
                shape: "S2"
              }
            }
          }
        },
        BatchWriteItem: {
          input: {
            type: "structure",
            required: [
              "RequestItems"
            ],
            members: {
              RequestItems: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Responses: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    ConsumedCapacityUnits: {
                      type: "double"
                    }
                  }
                }
              },
              UnprocessedItems: {
                shape: "So"
              }
            }
          }
        },
        CreateTable: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "KeySchema",
              "ProvisionedThroughput"
            ],
            members: {
              TableName: {},
              KeySchema: {
                shape: "Sy"
              },
              ProvisionedThroughput: {
                shape: "S12"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableDescription: {
                shape: "S15"
              }
            }
          }
        },
        DeleteItem: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "Key"
            ],
            members: {
              TableName: {},
              Key: {
                shape: "S6"
              },
              Expected: {
                shape: "S1b"
              },
              ReturnValues: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "Sl"
              },
              ConsumedCapacityUnits: {
                type: "double"
              }
            }
          }
        },
        DeleteTable: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TableDescription: {
                shape: "S15"
              }
            }
          }
        },
        DescribeTable: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Table: {
                shape: "S15"
              }
            }
          }
        },
        GetItem: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "Key"
            ],
            members: {
              TableName: {},
              Key: {
                shape: "S6"
              },
              AttributesToGet: {
                shape: "Se"
              },
              ConsistentRead: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Item: {
                shape: "Sl"
              },
              ConsumedCapacityUnits: {
                type: "double"
              }
            }
          }
        },
        ListTables: {
          input: {
            type: "structure",
            members: {
              ExclusiveStartTableName: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableNames: {
                type: "list",
                member: {}
              },
              LastEvaluatedTableName: {}
            }
          }
        },
        PutItem: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "Item"
            ],
            members: {
              TableName: {},
              Item: {
                shape: "Ss"
              },
              Expected: {
                shape: "S1b"
              },
              ReturnValues: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "Sl"
              },
              ConsumedCapacityUnits: {
                type: "double"
              }
            }
          }
        },
        Query: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "HashKeyValue"
            ],
            members: {
              TableName: {},
              AttributesToGet: {
                shape: "Se"
              },
              Limit: {
                type: "integer"
              },
              ConsistentRead: {
                type: "boolean"
              },
              Count: {
                type: "boolean"
              },
              HashKeyValue: {
                shape: "S7"
              },
              RangeKeyCondition: {
                shape: "S1u"
              },
              ScanIndexForward: {
                type: "boolean"
              },
              ExclusiveStartKey: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                shape: "Sk"
              },
              Count: {
                type: "integer"
              },
              LastEvaluatedKey: {
                shape: "S6"
              },
              ConsumedCapacityUnits: {
                type: "double"
              }
            }
          }
        },
        Scan: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {},
              AttributesToGet: {
                shape: "Se"
              },
              Limit: {
                type: "integer"
              },
              Count: {
                type: "boolean"
              },
              ScanFilter: {
                type: "map",
                key: {},
                value: {
                  shape: "S1u"
                }
              },
              ExclusiveStartKey: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                shape: "Sk"
              },
              Count: {
                type: "integer"
              },
              ScannedCount: {
                type: "integer"
              },
              LastEvaluatedKey: {
                shape: "S6"
              },
              ConsumedCapacityUnits: {
                type: "double"
              }
            }
          }
        },
        UpdateItem: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "Key",
              "AttributeUpdates"
            ],
            members: {
              TableName: {},
              Key: {
                shape: "S6"
              },
              AttributeUpdates: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    Value: {
                      shape: "S7"
                    },
                    Action: {}
                  }
                }
              },
              Expected: {
                shape: "S1b"
              },
              ReturnValues: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "Sl"
              },
              ConsumedCapacityUnits: {
                type: "double"
              }
            }
          }
        },
        UpdateTable: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "ProvisionedThroughput"
            ],
            members: {
              TableName: {},
              ProvisionedThroughput: {
                shape: "S12"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableDescription: {
                shape: "S15"
              }
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "Keys"
            ],
            members: {
              Keys: {
                type: "list",
                member: {
                  shape: "S6"
                }
              },
              AttributesToGet: {
                shape: "Se"
              },
              ConsistentRead: {
                type: "boolean"
              }
            }
          }
        },
        S6: {
          type: "structure",
          required: [
            "HashKeyElement"
          ],
          members: {
            HashKeyElement: {
              shape: "S7"
            },
            RangeKeyElement: {
              shape: "S7"
            }
          }
        },
        S7: {
          type: "structure",
          members: {
            S: {},
            N: {},
            B: {
              type: "blob"
            },
            SS: {
              type: "list",
              member: {}
            },
            NS: {
              type: "list",
              member: {}
            },
            BS: {
              type: "list",
              member: {
                type: "blob"
              }
            }
          }
        },
        Se: {
          type: "list",
          member: {}
        },
        Sk: {
          type: "list",
          member: {
            shape: "Sl"
          }
        },
        Sl: {
          type: "map",
          key: {},
          value: {
            shape: "S7"
          }
        },
        So: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {
              type: "structure",
              members: {
                PutRequest: {
                  type: "structure",
                  required: [
                    "Item"
                  ],
                  members: {
                    Item: {
                      shape: "Ss"
                    }
                  }
                },
                DeleteRequest: {
                  type: "structure",
                  required: [
                    "Key"
                  ],
                  members: {
                    Key: {
                      shape: "S6"
                    }
                  }
                }
              }
            }
          }
        },
        Ss: {
          type: "map",
          key: {},
          value: {
            shape: "S7"
          }
        },
        Sy: {
          type: "structure",
          required: [
            "HashKeyElement"
          ],
          members: {
            HashKeyElement: {
              shape: "Sz"
            },
            RangeKeyElement: {
              shape: "Sz"
            }
          }
        },
        Sz: {
          type: "structure",
          required: [
            "AttributeName",
            "AttributeType"
          ],
          members: {
            AttributeName: {},
            AttributeType: {}
          }
        },
        S12: {
          type: "structure",
          required: [
            "ReadCapacityUnits",
            "WriteCapacityUnits"
          ],
          members: {
            ReadCapacityUnits: {
              type: "long"
            },
            WriteCapacityUnits: {
              type: "long"
            }
          }
        },
        S15: {
          type: "structure",
          members: {
            TableName: {},
            KeySchema: {
              shape: "Sy"
            },
            TableStatus: {},
            CreationDateTime: {
              type: "timestamp"
            },
            ProvisionedThroughput: {
              type: "structure",
              members: {
                LastIncreaseDateTime: {
                  type: "timestamp"
                },
                LastDecreaseDateTime: {
                  type: "timestamp"
                },
                NumberOfDecreasesToday: {
                  type: "long"
                },
                ReadCapacityUnits: {
                  type: "long"
                },
                WriteCapacityUnits: {
                  type: "long"
                }
              }
            },
            TableSizeBytes: {
              type: "long"
            },
            ItemCount: {
              type: "long"
            }
          }
        },
        S1b: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Value: {
                shape: "S7"
              },
              Exists: {
                type: "boolean"
              }
            }
          }
        },
        S1u: {
          type: "structure",
          required: [
            "ComparisonOperator"
          ],
          members: {
            AttributeValueList: {
              type: "list",
              member: {
                shape: "S7"
              }
            },
            ComparisonOperator: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dynamodb-2011-12-05.paginators.json
var require_dynamodb_2011_12_05_paginators = __commonJS({
  "node_modules/aws-sdk/apis/dynamodb-2011-12-05.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        BatchGetItem: {
          input_token: "RequestItems",
          output_token: "UnprocessedKeys"
        },
        ListTables: {
          input_token: "ExclusiveStartTableName",
          limit_key: "Limit",
          output_token: "LastEvaluatedTableName",
          result_key: "TableNames"
        },
        Query: {
          input_token: "ExclusiveStartKey",
          limit_key: "Limit",
          output_token: "LastEvaluatedKey",
          result_key: "Items"
        },
        Scan: {
          input_token: "ExclusiveStartKey",
          limit_key: "Limit",
          output_token: "LastEvaluatedKey",
          result_key: "Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dynamodb-2011-12-05.waiters2.json
var require_dynamodb_2011_12_05_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/dynamodb-2011-12-05.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        TableExists: {
          delay: 20,
          operation: "DescribeTable",
          maxAttempts: 25,
          acceptors: [
            {
              expected: "ACTIVE",
              matcher: "path",
              state: "success",
              argument: "Table.TableStatus"
            },
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "retry"
            }
          ]
        },
        TableNotExists: {
          delay: 20,
          operation: "DescribeTable",
          maxAttempts: 25,
          acceptors: [
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "success"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dynamodb-2012-08-10.min.json
var require_dynamodb_2012_08_10_min = __commonJS({
  "node_modules/aws-sdk/apis/dynamodb-2012-08-10.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2012-08-10",
        endpointPrefix: "dynamodb",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "DynamoDB",
        serviceFullName: "Amazon DynamoDB",
        serviceId: "DynamoDB",
        signatureVersion: "v4",
        targetPrefix: "DynamoDB_20120810",
        uid: "dynamodb-2012-08-10"
      },
      operations: {
        BatchExecuteStatement: {
          input: {
            type: "structure",
            required: [
              "Statements"
            ],
            members: {
              Statements: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Statement"
                  ],
                  members: {
                    Statement: {},
                    Parameters: {
                      shape: "S5"
                    },
                    ConsistentRead: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Responses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Error: {
                      type: "structure",
                      members: {
                        Code: {},
                        Message: {}
                      }
                    },
                    TableName: {},
                    Item: {
                      shape: "Sq"
                    }
                  }
                }
              }
            }
          }
        },
        BatchGetItem: {
          input: {
            type: "structure",
            required: [
              "RequestItems"
            ],
            members: {
              RequestItems: {
                shape: "Ss"
              },
              ReturnConsumedCapacity: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Responses: {
                type: "map",
                key: {},
                value: {
                  shape: "S13"
                }
              },
              UnprocessedKeys: {
                shape: "Ss"
              },
              ConsumedCapacity: {
                shape: "S14"
              }
            }
          },
          endpointdiscovery: {}
        },
        BatchWriteItem: {
          input: {
            type: "structure",
            required: [
              "RequestItems"
            ],
            members: {
              RequestItems: {
                shape: "S1b"
              },
              ReturnConsumedCapacity: {},
              ReturnItemCollectionMetrics: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UnprocessedItems: {
                shape: "S1b"
              },
              ItemCollectionMetrics: {
                shape: "S1j"
              },
              ConsumedCapacity: {
                shape: "S14"
              }
            }
          },
          endpointdiscovery: {}
        },
        CreateBackup: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "BackupName"
            ],
            members: {
              TableName: {},
              BackupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BackupDetails: {
                shape: "S1s"
              }
            }
          },
          endpointdiscovery: {}
        },
        CreateGlobalTable: {
          input: {
            type: "structure",
            required: [
              "GlobalTableName",
              "ReplicationGroup"
            ],
            members: {
              GlobalTableName: {},
              ReplicationGroup: {
                shape: "S20"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GlobalTableDescription: {
                shape: "S24"
              }
            }
          },
          endpointdiscovery: {}
        },
        CreateTable: {
          input: {
            type: "structure",
            required: [
              "AttributeDefinitions",
              "TableName",
              "KeySchema"
            ],
            members: {
              AttributeDefinitions: {
                shape: "S2i"
              },
              TableName: {},
              KeySchema: {
                shape: "S2m"
              },
              LocalSecondaryIndexes: {
                shape: "S2p"
              },
              GlobalSecondaryIndexes: {
                shape: "S2v"
              },
              BillingMode: {},
              ProvisionedThroughput: {
                shape: "S2x"
              },
              StreamSpecification: {
                shape: "S2z"
              },
              SSESpecification: {
                shape: "S32"
              },
              Tags: {
                shape: "S35"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableDescription: {
                shape: "S3a"
              }
            }
          },
          endpointdiscovery: {}
        },
        DeleteBackup: {
          input: {
            type: "structure",
            required: [
              "BackupArn"
            ],
            members: {
              BackupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BackupDescription: {
                shape: "S3y"
              }
            }
          },
          endpointdiscovery: {}
        },
        DeleteItem: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "Key"
            ],
            members: {
              TableName: {},
              Key: {
                shape: "Sv"
              },
              Expected: {
                shape: "S4b"
              },
              ConditionalOperator: {},
              ReturnValues: {},
              ReturnConsumedCapacity: {},
              ReturnItemCollectionMetrics: {},
              ConditionExpression: {},
              ExpressionAttributeNames: {
                shape: "Sy"
              },
              ExpressionAttributeValues: {
                shape: "S4j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "Sq"
              },
              ConsumedCapacity: {
                shape: "S15"
              },
              ItemCollectionMetrics: {
                shape: "S1l"
              }
            }
          },
          endpointdiscovery: {}
        },
        DeleteTable: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TableDescription: {
                shape: "S3a"
              }
            }
          },
          endpointdiscovery: {}
        },
        DescribeBackup: {
          input: {
            type: "structure",
            required: [
              "BackupArn"
            ],
            members: {
              BackupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BackupDescription: {
                shape: "S3y"
              }
            }
          },
          endpointdiscovery: {}
        },
        DescribeContinuousBackups: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ContinuousBackupsDescription: {
                shape: "S4s"
              }
            }
          },
          endpointdiscovery: {}
        },
        DescribeContributorInsights: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {},
              IndexName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TableName: {},
              IndexName: {},
              ContributorInsightsRuleList: {
                type: "list",
                member: {}
              },
              ContributorInsightsStatus: {},
              LastUpdateDateTime: {
                type: "timestamp"
              },
              FailureException: {
                type: "structure",
                members: {
                  ExceptionName: {},
                  ExceptionDescription: {}
                }
              }
            }
          }
        },
        DescribeEndpoints: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "Endpoints"
            ],
            members: {
              Endpoints: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Address",
                    "CachePeriodInMinutes"
                  ],
                  members: {
                    Address: {},
                    CachePeriodInMinutes: {
                      type: "long"
                    }
                  }
                }
              }
            }
          },
          endpointoperation: true
        },
        DescribeExport: {
          input: {
            type: "structure",
            required: [
              "ExportArn"
            ],
            members: {
              ExportArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExportDescription: {
                shape: "S5c"
              }
            }
          }
        },
        DescribeGlobalTable: {
          input: {
            type: "structure",
            required: [
              "GlobalTableName"
            ],
            members: {
              GlobalTableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GlobalTableDescription: {
                shape: "S24"
              }
            }
          },
          endpointdiscovery: {}
        },
        DescribeGlobalTableSettings: {
          input: {
            type: "structure",
            required: [
              "GlobalTableName"
            ],
            members: {
              GlobalTableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GlobalTableName: {},
              ReplicaSettings: {
                shape: "S5w"
              }
            }
          },
          endpointdiscovery: {}
        },
        DescribeKinesisStreamingDestination: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TableName: {},
              KinesisDataStreamDestinations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StreamArn: {},
                    DestinationStatus: {},
                    DestinationStatusDescription: {}
                  }
                }
              }
            }
          },
          endpointdiscovery: {}
        },
        DescribeLimits: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              AccountMaxReadCapacityUnits: {
                type: "long"
              },
              AccountMaxWriteCapacityUnits: {
                type: "long"
              },
              TableMaxReadCapacityUnits: {
                type: "long"
              },
              TableMaxWriteCapacityUnits: {
                type: "long"
              }
            }
          },
          endpointdiscovery: {}
        },
        DescribeTable: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Table: {
                shape: "S3a"
              }
            }
          },
          endpointdiscovery: {}
        },
        DescribeTableReplicaAutoScaling: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TableAutoScalingDescription: {
                shape: "S6i"
              }
            }
          }
        },
        DescribeTimeToLive: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TimeToLiveDescription: {
                shape: "S47"
              }
            }
          },
          endpointdiscovery: {}
        },
        DisableKinesisStreamingDestination: {
          input: {
            shape: "S6p"
          },
          output: {
            shape: "S6q"
          },
          endpointdiscovery: {}
        },
        EnableKinesisStreamingDestination: {
          input: {
            shape: "S6p"
          },
          output: {
            shape: "S6q"
          },
          endpointdiscovery: {}
        },
        ExecuteStatement: {
          input: {
            type: "structure",
            required: [
              "Statement"
            ],
            members: {
              Statement: {},
              Parameters: {
                shape: "S5"
              },
              ConsistentRead: {
                type: "boolean"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                shape: "S13"
              },
              NextToken: {}
            }
          }
        },
        ExecuteTransaction: {
          input: {
            type: "structure",
            required: [
              "TransactStatements"
            ],
            members: {
              TransactStatements: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Statement"
                  ],
                  members: {
                    Statement: {},
                    Parameters: {
                      shape: "S5"
                    }
                  }
                }
              },
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Responses: {
                shape: "S6z"
              }
            }
          }
        },
        ExportTableToPointInTime: {
          input: {
            type: "structure",
            required: [
              "TableArn",
              "S3Bucket"
            ],
            members: {
              TableArn: {},
              ExportTime: {
                type: "timestamp"
              },
              ClientToken: {
                idempotencyToken: true
              },
              S3Bucket: {},
              S3BucketOwner: {},
              S3Prefix: {},
              S3SseAlgorithm: {},
              S3SseKmsKeyId: {},
              ExportFormat: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExportDescription: {
                shape: "S5c"
              }
            }
          }
        },
        GetItem: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "Key"
            ],
            members: {
              TableName: {},
              Key: {
                shape: "Sv"
              },
              AttributesToGet: {
                shape: "Sw"
              },
              ConsistentRead: {
                type: "boolean"
              },
              ReturnConsumedCapacity: {},
              ProjectionExpression: {},
              ExpressionAttributeNames: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Item: {
                shape: "Sq"
              },
              ConsumedCapacity: {
                shape: "S15"
              }
            }
          },
          endpointdiscovery: {}
        },
        ListBackups: {
          input: {
            type: "structure",
            members: {
              TableName: {},
              Limit: {
                type: "integer"
              },
              TimeRangeLowerBound: {
                type: "timestamp"
              },
              TimeRangeUpperBound: {
                type: "timestamp"
              },
              ExclusiveStartBackupArn: {},
              BackupType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BackupSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TableName: {},
                    TableId: {},
                    TableArn: {},
                    BackupArn: {},
                    BackupName: {},
                    BackupCreationDateTime: {
                      type: "timestamp"
                    },
                    BackupExpiryDateTime: {
                      type: "timestamp"
                    },
                    BackupStatus: {},
                    BackupType: {},
                    BackupSizeBytes: {
                      type: "long"
                    }
                  }
                }
              },
              LastEvaluatedBackupArn: {}
            }
          },
          endpointdiscovery: {}
        },
        ListContributorInsights: {
          input: {
            type: "structure",
            members: {
              TableName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContributorInsightsSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TableName: {},
                    IndexName: {},
                    ContributorInsightsStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListExports: {
          input: {
            type: "structure",
            members: {
              TableArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExportSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ExportArn: {},
                    ExportStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListGlobalTables: {
          input: {
            type: "structure",
            members: {
              ExclusiveStartGlobalTableName: {},
              Limit: {
                type: "integer"
              },
              RegionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GlobalTables: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GlobalTableName: {},
                    ReplicationGroup: {
                      shape: "S20"
                    }
                  }
                }
              },
              LastEvaluatedGlobalTableName: {}
            }
          },
          endpointdiscovery: {}
        },
        ListTables: {
          input: {
            type: "structure",
            members: {
              ExclusiveStartTableName: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableNames: {
                type: "list",
                member: {}
              },
              LastEvaluatedTableName: {}
            }
          },
          endpointdiscovery: {}
        },
        ListTagsOfResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S35"
              },
              NextToken: {}
            }
          },
          endpointdiscovery: {}
        },
        PutItem: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "Item"
            ],
            members: {
              TableName: {},
              Item: {
                shape: "S1f"
              },
              Expected: {
                shape: "S4b"
              },
              ReturnValues: {},
              ReturnConsumedCapacity: {},
              ReturnItemCollectionMetrics: {},
              ConditionalOperator: {},
              ConditionExpression: {},
              ExpressionAttributeNames: {
                shape: "Sy"
              },
              ExpressionAttributeValues: {
                shape: "S4j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "Sq"
              },
              ConsumedCapacity: {
                shape: "S15"
              },
              ItemCollectionMetrics: {
                shape: "S1l"
              }
            }
          },
          endpointdiscovery: {}
        },
        Query: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {},
              IndexName: {},
              Select: {},
              AttributesToGet: {
                shape: "Sw"
              },
              Limit: {
                type: "integer"
              },
              ConsistentRead: {
                type: "boolean"
              },
              KeyConditions: {
                type: "map",
                key: {},
                value: {
                  shape: "S86"
                }
              },
              QueryFilter: {
                shape: "S87"
              },
              ConditionalOperator: {},
              ScanIndexForward: {
                type: "boolean"
              },
              ExclusiveStartKey: {
                shape: "Sv"
              },
              ReturnConsumedCapacity: {},
              ProjectionExpression: {},
              FilterExpression: {},
              KeyConditionExpression: {},
              ExpressionAttributeNames: {
                shape: "Sy"
              },
              ExpressionAttributeValues: {
                shape: "S4j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                shape: "S13"
              },
              Count: {
                type: "integer"
              },
              ScannedCount: {
                type: "integer"
              },
              LastEvaluatedKey: {
                shape: "Sv"
              },
              ConsumedCapacity: {
                shape: "S15"
              }
            }
          },
          endpointdiscovery: {}
        },
        RestoreTableFromBackup: {
          input: {
            type: "structure",
            required: [
              "TargetTableName",
              "BackupArn"
            ],
            members: {
              TargetTableName: {},
              BackupArn: {},
              BillingModeOverride: {},
              GlobalSecondaryIndexOverride: {
                shape: "S2v"
              },
              LocalSecondaryIndexOverride: {
                shape: "S2p"
              },
              ProvisionedThroughputOverride: {
                shape: "S2x"
              },
              SSESpecificationOverride: {
                shape: "S32"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableDescription: {
                shape: "S3a"
              }
            }
          },
          endpointdiscovery: {}
        },
        RestoreTableToPointInTime: {
          input: {
            type: "structure",
            required: [
              "TargetTableName"
            ],
            members: {
              SourceTableArn: {},
              SourceTableName: {},
              TargetTableName: {},
              UseLatestRestorableTime: {
                type: "boolean"
              },
              RestoreDateTime: {
                type: "timestamp"
              },
              BillingModeOverride: {},
              GlobalSecondaryIndexOverride: {
                shape: "S2v"
              },
              LocalSecondaryIndexOverride: {
                shape: "S2p"
              },
              ProvisionedThroughputOverride: {
                shape: "S2x"
              },
              SSESpecificationOverride: {
                shape: "S32"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableDescription: {
                shape: "S3a"
              }
            }
          },
          endpointdiscovery: {}
        },
        Scan: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              TableName: {},
              IndexName: {},
              AttributesToGet: {
                shape: "Sw"
              },
              Limit: {
                type: "integer"
              },
              Select: {},
              ScanFilter: {
                shape: "S87"
              },
              ConditionalOperator: {},
              ExclusiveStartKey: {
                shape: "Sv"
              },
              ReturnConsumedCapacity: {},
              TotalSegments: {
                type: "integer"
              },
              Segment: {
                type: "integer"
              },
              ProjectionExpression: {},
              FilterExpression: {},
              ExpressionAttributeNames: {
                shape: "Sy"
              },
              ExpressionAttributeValues: {
                shape: "S4j"
              },
              ConsistentRead: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                shape: "S13"
              },
              Count: {
                type: "integer"
              },
              ScannedCount: {
                type: "integer"
              },
              LastEvaluatedKey: {
                shape: "Sv"
              },
              ConsumedCapacity: {
                shape: "S15"
              }
            }
          },
          endpointdiscovery: {}
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S35"
              }
            }
          },
          endpointdiscovery: {}
        },
        TransactGetItems: {
          input: {
            type: "structure",
            required: [
              "TransactItems"
            ],
            members: {
              TransactItems: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Get"
                  ],
                  members: {
                    Get: {
                      type: "structure",
                      required: [
                        "Key",
                        "TableName"
                      ],
                      members: {
                        Key: {
                          shape: "Sv"
                        },
                        TableName: {},
                        ProjectionExpression: {},
                        ExpressionAttributeNames: {
                          shape: "Sy"
                        }
                      }
                    }
                  }
                }
              },
              ReturnConsumedCapacity: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConsumedCapacity: {
                shape: "S14"
              },
              Responses: {
                shape: "S6z"
              }
            }
          },
          endpointdiscovery: {}
        },
        TransactWriteItems: {
          input: {
            type: "structure",
            required: [
              "TransactItems"
            ],
            members: {
              TransactItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConditionCheck: {
                      type: "structure",
                      required: [
                        "Key",
                        "TableName",
                        "ConditionExpression"
                      ],
                      members: {
                        Key: {
                          shape: "Sv"
                        },
                        TableName: {},
                        ConditionExpression: {},
                        ExpressionAttributeNames: {
                          shape: "Sy"
                        },
                        ExpressionAttributeValues: {
                          shape: "S4j"
                        },
                        ReturnValuesOnConditionCheckFailure: {}
                      }
                    },
                    Put: {
                      type: "structure",
                      required: [
                        "Item",
                        "TableName"
                      ],
                      members: {
                        Item: {
                          shape: "S1f"
                        },
                        TableName: {},
                        ConditionExpression: {},
                        ExpressionAttributeNames: {
                          shape: "Sy"
                        },
                        ExpressionAttributeValues: {
                          shape: "S4j"
                        },
                        ReturnValuesOnConditionCheckFailure: {}
                      }
                    },
                    Delete: {
                      type: "structure",
                      required: [
                        "Key",
                        "TableName"
                      ],
                      members: {
                        Key: {
                          shape: "Sv"
                        },
                        TableName: {},
                        ConditionExpression: {},
                        ExpressionAttributeNames: {
                          shape: "Sy"
                        },
                        ExpressionAttributeValues: {
                          shape: "S4j"
                        },
                        ReturnValuesOnConditionCheckFailure: {}
                      }
                    },
                    Update: {
                      type: "structure",
                      required: [
                        "Key",
                        "UpdateExpression",
                        "TableName"
                      ],
                      members: {
                        Key: {
                          shape: "Sv"
                        },
                        UpdateExpression: {},
                        TableName: {},
                        ConditionExpression: {},
                        ExpressionAttributeNames: {
                          shape: "Sy"
                        },
                        ExpressionAttributeValues: {
                          shape: "S4j"
                        },
                        ReturnValuesOnConditionCheckFailure: {}
                      }
                    }
                  }
                }
              },
              ReturnConsumedCapacity: {},
              ReturnItemCollectionMetrics: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConsumedCapacity: {
                shape: "S14"
              },
              ItemCollectionMetrics: {
                shape: "S1j"
              }
            }
          },
          endpointdiscovery: {}
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          endpointdiscovery: {}
        },
        UpdateContinuousBackups: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "PointInTimeRecoverySpecification"
            ],
            members: {
              TableName: {},
              PointInTimeRecoverySpecification: {
                type: "structure",
                required: [
                  "PointInTimeRecoveryEnabled"
                ],
                members: {
                  PointInTimeRecoveryEnabled: {
                    type: "boolean"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContinuousBackupsDescription: {
                shape: "S4s"
              }
            }
          },
          endpointdiscovery: {}
        },
        UpdateContributorInsights: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "ContributorInsightsAction"
            ],
            members: {
              TableName: {},
              IndexName: {},
              ContributorInsightsAction: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TableName: {},
              IndexName: {},
              ContributorInsightsStatus: {}
            }
          }
        },
        UpdateGlobalTable: {
          input: {
            type: "structure",
            required: [
              "GlobalTableName",
              "ReplicaUpdates"
            ],
            members: {
              GlobalTableName: {},
              ReplicaUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Create: {
                      type: "structure",
                      required: [
                        "RegionName"
                      ],
                      members: {
                        RegionName: {}
                      }
                    },
                    Delete: {
                      type: "structure",
                      required: [
                        "RegionName"
                      ],
                      members: {
                        RegionName: {}
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GlobalTableDescription: {
                shape: "S24"
              }
            }
          },
          endpointdiscovery: {}
        },
        UpdateGlobalTableSettings: {
          input: {
            type: "structure",
            required: [
              "GlobalTableName"
            ],
            members: {
              GlobalTableName: {},
              GlobalTableBillingMode: {},
              GlobalTableProvisionedWriteCapacityUnits: {
                type: "long"
              },
              GlobalTableProvisionedWriteCapacityAutoScalingSettingsUpdate: {
                shape: "S9e"
              },
              GlobalTableGlobalSecondaryIndexSettingsUpdate: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "IndexName"
                  ],
                  members: {
                    IndexName: {},
                    ProvisionedWriteCapacityUnits: {
                      type: "long"
                    },
                    ProvisionedWriteCapacityAutoScalingSettingsUpdate: {
                      shape: "S9e"
                    }
                  }
                }
              },
              ReplicaSettingsUpdate: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RegionName"
                  ],
                  members: {
                    RegionName: {},
                    ReplicaProvisionedReadCapacityUnits: {
                      type: "long"
                    },
                    ReplicaProvisionedReadCapacityAutoScalingSettingsUpdate: {
                      shape: "S9e"
                    },
                    ReplicaGlobalSecondaryIndexSettingsUpdate: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "IndexName"
                        ],
                        members: {
                          IndexName: {},
                          ProvisionedReadCapacityUnits: {
                            type: "long"
                          },
                          ProvisionedReadCapacityAutoScalingSettingsUpdate: {
                            shape: "S9e"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GlobalTableName: {},
              ReplicaSettings: {
                shape: "S5w"
              }
            }
          },
          endpointdiscovery: {}
        },
        UpdateItem: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "Key"
            ],
            members: {
              TableName: {},
              Key: {
                shape: "Sv"
              },
              AttributeUpdates: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    Value: {
                      shape: "S6"
                    },
                    Action: {}
                  }
                }
              },
              Expected: {
                shape: "S4b"
              },
              ConditionalOperator: {},
              ReturnValues: {},
              ReturnConsumedCapacity: {},
              ReturnItemCollectionMetrics: {},
              UpdateExpression: {},
              ConditionExpression: {},
              ExpressionAttributeNames: {
                shape: "Sy"
              },
              ExpressionAttributeValues: {
                shape: "S4j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "Sq"
              },
              ConsumedCapacity: {
                shape: "S15"
              },
              ItemCollectionMetrics: {
                shape: "S1l"
              }
            }
          },
          endpointdiscovery: {}
        },
        UpdateTable: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              AttributeDefinitions: {
                shape: "S2i"
              },
              TableName: {},
              BillingMode: {},
              ProvisionedThroughput: {
                shape: "S2x"
              },
              GlobalSecondaryIndexUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Update: {
                      type: "structure",
                      required: [
                        "IndexName",
                        "ProvisionedThroughput"
                      ],
                      members: {
                        IndexName: {},
                        ProvisionedThroughput: {
                          shape: "S2x"
                        }
                      }
                    },
                    Create: {
                      type: "structure",
                      required: [
                        "IndexName",
                        "KeySchema",
                        "Projection"
                      ],
                      members: {
                        IndexName: {},
                        KeySchema: {
                          shape: "S2m"
                        },
                        Projection: {
                          shape: "S2r"
                        },
                        ProvisionedThroughput: {
                          shape: "S2x"
                        }
                      }
                    },
                    Delete: {
                      type: "structure",
                      required: [
                        "IndexName"
                      ],
                      members: {
                        IndexName: {}
                      }
                    }
                  }
                }
              },
              StreamSpecification: {
                shape: "S2z"
              },
              SSESpecification: {
                shape: "S32"
              },
              ReplicaUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Create: {
                      type: "structure",
                      required: [
                        "RegionName"
                      ],
                      members: {
                        RegionName: {},
                        KMSMasterKeyId: {},
                        ProvisionedThroughputOverride: {
                          shape: "S2b"
                        },
                        GlobalSecondaryIndexes: {
                          shape: "Sa3"
                        }
                      }
                    },
                    Update: {
                      type: "structure",
                      required: [
                        "RegionName"
                      ],
                      members: {
                        RegionName: {},
                        KMSMasterKeyId: {},
                        ProvisionedThroughputOverride: {
                          shape: "S2b"
                        },
                        GlobalSecondaryIndexes: {
                          shape: "Sa3"
                        }
                      }
                    },
                    Delete: {
                      type: "structure",
                      required: [
                        "RegionName"
                      ],
                      members: {
                        RegionName: {}
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableDescription: {
                shape: "S3a"
              }
            }
          },
          endpointdiscovery: {}
        },
        UpdateTableReplicaAutoScaling: {
          input: {
            type: "structure",
            required: [
              "TableName"
            ],
            members: {
              GlobalSecondaryIndexUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IndexName: {},
                    ProvisionedWriteCapacityAutoScalingUpdate: {
                      shape: "S9e"
                    }
                  }
                }
              },
              TableName: {},
              ProvisionedWriteCapacityAutoScalingUpdate: {
                shape: "S9e"
              },
              ReplicaUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RegionName"
                  ],
                  members: {
                    RegionName: {},
                    ReplicaGlobalSecondaryIndexUpdates: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          IndexName: {},
                          ProvisionedReadCapacityAutoScalingUpdate: {
                            shape: "S9e"
                          }
                        }
                      }
                    },
                    ReplicaProvisionedReadCapacityAutoScalingUpdate: {
                      shape: "S9e"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableAutoScalingDescription: {
                shape: "S6i"
              }
            }
          }
        },
        UpdateTimeToLive: {
          input: {
            type: "structure",
            required: [
              "TableName",
              "TimeToLiveSpecification"
            ],
            members: {
              TableName: {},
              TimeToLiveSpecification: {
                shape: "Sah"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TimeToLiveSpecification: {
                shape: "Sah"
              }
            }
          },
          endpointdiscovery: {}
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {
            shape: "S6"
          }
        },
        S6: {
          type: "structure",
          members: {
            S: {},
            N: {},
            B: {
              type: "blob"
            },
            SS: {
              type: "list",
              member: {}
            },
            NS: {
              type: "list",
              member: {}
            },
            BS: {
              type: "list",
              member: {
                type: "blob"
              }
            },
            M: {
              type: "map",
              key: {},
              value: {
                shape: "S6"
              }
            },
            L: {
              type: "list",
              member: {
                shape: "S6"
              }
            },
            NULL: {
              type: "boolean"
            },
            BOOL: {
              type: "boolean"
            }
          }
        },
        Sq: {
          type: "map",
          key: {},
          value: {
            shape: "S6"
          }
        },
        Ss: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "Keys"
            ],
            members: {
              Keys: {
                type: "list",
                member: {
                  shape: "Sv"
                }
              },
              AttributesToGet: {
                shape: "Sw"
              },
              ConsistentRead: {
                type: "boolean"
              },
              ProjectionExpression: {},
              ExpressionAttributeNames: {
                shape: "Sy"
              }
            }
          }
        },
        Sv: {
          type: "map",
          key: {},
          value: {
            shape: "S6"
          }
        },
        Sw: {
          type: "list",
          member: {}
        },
        Sy: {
          type: "map",
          key: {},
          value: {}
        },
        S13: {
          type: "list",
          member: {
            shape: "Sq"
          }
        },
        S14: {
          type: "list",
          member: {
            shape: "S15"
          }
        },
        S15: {
          type: "structure",
          members: {
            TableName: {},
            CapacityUnits: {
              type: "double"
            },
            ReadCapacityUnits: {
              type: "double"
            },
            WriteCapacityUnits: {
              type: "double"
            },
            Table: {
              shape: "S17"
            },
            LocalSecondaryIndexes: {
              shape: "S18"
            },
            GlobalSecondaryIndexes: {
              shape: "S18"
            }
          }
        },
        S17: {
          type: "structure",
          members: {
            ReadCapacityUnits: {
              type: "double"
            },
            WriteCapacityUnits: {
              type: "double"
            },
            CapacityUnits: {
              type: "double"
            }
          }
        },
        S18: {
          type: "map",
          key: {},
          value: {
            shape: "S17"
          }
        },
        S1b: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {
              type: "structure",
              members: {
                PutRequest: {
                  type: "structure",
                  required: [
                    "Item"
                  ],
                  members: {
                    Item: {
                      shape: "S1f"
                    }
                  }
                },
                DeleteRequest: {
                  type: "structure",
                  required: [
                    "Key"
                  ],
                  members: {
                    Key: {
                      shape: "Sv"
                    }
                  }
                }
              }
            }
          }
        },
        S1f: {
          type: "map",
          key: {},
          value: {
            shape: "S6"
          }
        },
        S1j: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {
              shape: "S1l"
            }
          }
        },
        S1l: {
          type: "structure",
          members: {
            ItemCollectionKey: {
              type: "map",
              key: {},
              value: {
                shape: "S6"
              }
            },
            SizeEstimateRangeGB: {
              type: "list",
              member: {
                type: "double"
              }
            }
          }
        },
        S1s: {
          type: "structure",
          required: [
            "BackupArn",
            "BackupName",
            "BackupStatus",
            "BackupType",
            "BackupCreationDateTime"
          ],
          members: {
            BackupArn: {},
            BackupName: {},
            BackupSizeBytes: {
              type: "long"
            },
            BackupStatus: {},
            BackupType: {},
            BackupCreationDateTime: {
              type: "timestamp"
            },
            BackupExpiryDateTime: {
              type: "timestamp"
            }
          }
        },
        S20: {
          type: "list",
          member: {
            type: "structure",
            members: {
              RegionName: {}
            }
          }
        },
        S24: {
          type: "structure",
          members: {
            ReplicationGroup: {
              shape: "S25"
            },
            GlobalTableArn: {},
            CreationDateTime: {
              type: "timestamp"
            },
            GlobalTableStatus: {},
            GlobalTableName: {}
          }
        },
        S25: {
          type: "list",
          member: {
            type: "structure",
            members: {
              RegionName: {},
              ReplicaStatus: {},
              ReplicaStatusDescription: {},
              ReplicaStatusPercentProgress: {},
              KMSMasterKeyId: {},
              ProvisionedThroughputOverride: {
                shape: "S2b"
              },
              GlobalSecondaryIndexes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IndexName: {},
                    ProvisionedThroughputOverride: {
                      shape: "S2b"
                    }
                  }
                }
              },
              ReplicaInaccessibleDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        S2b: {
          type: "structure",
          members: {
            ReadCapacityUnits: {
              type: "long"
            }
          }
        },
        S2i: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AttributeName",
              "AttributeType"
            ],
            members: {
              AttributeName: {},
              AttributeType: {}
            }
          }
        },
        S2m: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AttributeName",
              "KeyType"
            ],
            members: {
              AttributeName: {},
              KeyType: {}
            }
          }
        },
        S2p: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "IndexName",
              "KeySchema",
              "Projection"
            ],
            members: {
              IndexName: {},
              KeySchema: {
                shape: "S2m"
              },
              Projection: {
                shape: "S2r"
              }
            }
          }
        },
        S2r: {
          type: "structure",
          members: {
            ProjectionType: {},
            NonKeyAttributes: {
              type: "list",
              member: {}
            }
          }
        },
        S2v: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "IndexName",
              "KeySchema",
              "Projection"
            ],
            members: {
              IndexName: {},
              KeySchema: {
                shape: "S2m"
              },
              Projection: {
                shape: "S2r"
              },
              ProvisionedThroughput: {
                shape: "S2x"
              }
            }
          }
        },
        S2x: {
          type: "structure",
          required: [
            "ReadCapacityUnits",
            "WriteCapacityUnits"
          ],
          members: {
            ReadCapacityUnits: {
              type: "long"
            },
            WriteCapacityUnits: {
              type: "long"
            }
          }
        },
        S2z: {
          type: "structure",
          required: [
            "StreamEnabled"
          ],
          members: {
            StreamEnabled: {
              type: "boolean"
            },
            StreamViewType: {}
          }
        },
        S32: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            SSEType: {},
            KMSMasterKeyId: {}
          }
        },
        S35: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S3a: {
          type: "structure",
          members: {
            AttributeDefinitions: {
              shape: "S2i"
            },
            TableName: {},
            KeySchema: {
              shape: "S2m"
            },
            TableStatus: {},
            CreationDateTime: {
              type: "timestamp"
            },
            ProvisionedThroughput: {
              shape: "S3c"
            },
            TableSizeBytes: {
              type: "long"
            },
            ItemCount: {
              type: "long"
            },
            TableArn: {},
            TableId: {},
            BillingModeSummary: {
              shape: "S3g"
            },
            LocalSecondaryIndexes: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  IndexName: {},
                  KeySchema: {
                    shape: "S2m"
                  },
                  Projection: {
                    shape: "S2r"
                  },
                  IndexSizeBytes: {
                    type: "long"
                  },
                  ItemCount: {
                    type: "long"
                  },
                  IndexArn: {}
                }
              }
            },
            GlobalSecondaryIndexes: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  IndexName: {},
                  KeySchema: {
                    shape: "S2m"
                  },
                  Projection: {
                    shape: "S2r"
                  },
                  IndexStatus: {},
                  Backfilling: {
                    type: "boolean"
                  },
                  ProvisionedThroughput: {
                    shape: "S3c"
                  },
                  IndexSizeBytes: {
                    type: "long"
                  },
                  ItemCount: {
                    type: "long"
                  },
                  IndexArn: {}
                }
              }
            },
            StreamSpecification: {
              shape: "S2z"
            },
            LatestStreamLabel: {},
            LatestStreamArn: {},
            GlobalTableVersion: {},
            Replicas: {
              shape: "S25"
            },
            RestoreSummary: {
              type: "structure",
              required: [
                "RestoreDateTime",
                "RestoreInProgress"
              ],
              members: {
                SourceBackupArn: {},
                SourceTableArn: {},
                RestoreDateTime: {
                  type: "timestamp"
                },
                RestoreInProgress: {
                  type: "boolean"
                }
              }
            },
            SSEDescription: {
              shape: "S3r"
            },
            ArchivalSummary: {
              type: "structure",
              members: {
                ArchivalDateTime: {
                  type: "timestamp"
                },
                ArchivalReason: {},
                ArchivalBackupArn: {}
              }
            }
          }
        },
        S3c: {
          type: "structure",
          members: {
            LastIncreaseDateTime: {
              type: "timestamp"
            },
            LastDecreaseDateTime: {
              type: "timestamp"
            },
            NumberOfDecreasesToday: {
              type: "long"
            },
            ReadCapacityUnits: {
              type: "long"
            },
            WriteCapacityUnits: {
              type: "long"
            }
          }
        },
        S3g: {
          type: "structure",
          members: {
            BillingMode: {},
            LastUpdateToPayPerRequestDateTime: {
              type: "timestamp"
            }
          }
        },
        S3r: {
          type: "structure",
          members: {
            Status: {},
            SSEType: {},
            KMSMasterKeyArn: {},
            InaccessibleEncryptionDateTime: {
              type: "timestamp"
            }
          }
        },
        S3y: {
          type: "structure",
          members: {
            BackupDetails: {
              shape: "S1s"
            },
            SourceTableDetails: {
              type: "structure",
              required: [
                "TableName",
                "TableId",
                "KeySchema",
                "TableCreationDateTime",
                "ProvisionedThroughput"
              ],
              members: {
                TableName: {},
                TableId: {},
                TableArn: {},
                TableSizeBytes: {
                  type: "long"
                },
                KeySchema: {
                  shape: "S2m"
                },
                TableCreationDateTime: {
                  type: "timestamp"
                },
                ProvisionedThroughput: {
                  shape: "S2x"
                },
                ItemCount: {
                  type: "long"
                },
                BillingMode: {}
              }
            },
            SourceTableFeatureDetails: {
              type: "structure",
              members: {
                LocalSecondaryIndexes: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      IndexName: {},
                      KeySchema: {
                        shape: "S2m"
                      },
                      Projection: {
                        shape: "S2r"
                      }
                    }
                  }
                },
                GlobalSecondaryIndexes: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      IndexName: {},
                      KeySchema: {
                        shape: "S2m"
                      },
                      Projection: {
                        shape: "S2r"
                      },
                      ProvisionedThroughput: {
                        shape: "S2x"
                      }
                    }
                  }
                },
                StreamDescription: {
                  shape: "S2z"
                },
                TimeToLiveDescription: {
                  shape: "S47"
                },
                SSEDescription: {
                  shape: "S3r"
                }
              }
            }
          }
        },
        S47: {
          type: "structure",
          members: {
            TimeToLiveStatus: {},
            AttributeName: {}
          }
        },
        S4b: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Value: {
                shape: "S6"
              },
              Exists: {
                type: "boolean"
              },
              ComparisonOperator: {},
              AttributeValueList: {
                shape: "S4f"
              }
            }
          }
        },
        S4f: {
          type: "list",
          member: {
            shape: "S6"
          }
        },
        S4j: {
          type: "map",
          key: {},
          value: {
            shape: "S6"
          }
        },
        S4s: {
          type: "structure",
          required: [
            "ContinuousBackupsStatus"
          ],
          members: {
            ContinuousBackupsStatus: {},
            PointInTimeRecoveryDescription: {
              type: "structure",
              members: {
                PointInTimeRecoveryStatus: {},
                EarliestRestorableDateTime: {
                  type: "timestamp"
                },
                LatestRestorableDateTime: {
                  type: "timestamp"
                }
              }
            }
          }
        },
        S5c: {
          type: "structure",
          members: {
            ExportArn: {},
            ExportStatus: {},
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            ExportManifest: {},
            TableArn: {},
            TableId: {},
            ExportTime: {
              type: "timestamp"
            },
            ClientToken: {},
            S3Bucket: {},
            S3BucketOwner: {},
            S3Prefix: {},
            S3SseAlgorithm: {},
            S3SseKmsKeyId: {},
            FailureCode: {},
            FailureMessage: {},
            ExportFormat: {},
            BilledSizeBytes: {
              type: "long"
            },
            ItemCount: {
              type: "long"
            }
          }
        },
        S5w: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "RegionName"
            ],
            members: {
              RegionName: {},
              ReplicaStatus: {},
              ReplicaBillingModeSummary: {
                shape: "S3g"
              },
              ReplicaProvisionedReadCapacityUnits: {
                type: "long"
              },
              ReplicaProvisionedReadCapacityAutoScalingSettings: {
                shape: "S5y"
              },
              ReplicaProvisionedWriteCapacityUnits: {
                type: "long"
              },
              ReplicaProvisionedWriteCapacityAutoScalingSettings: {
                shape: "S5y"
              },
              ReplicaGlobalSecondaryIndexSettings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "IndexName"
                  ],
                  members: {
                    IndexName: {},
                    IndexStatus: {},
                    ProvisionedReadCapacityUnits: {
                      type: "long"
                    },
                    ProvisionedReadCapacityAutoScalingSettings: {
                      shape: "S5y"
                    },
                    ProvisionedWriteCapacityUnits: {
                      type: "long"
                    },
                    ProvisionedWriteCapacityAutoScalingSettings: {
                      shape: "S5y"
                    }
                  }
                }
              }
            }
          }
        },
        S5y: {
          type: "structure",
          members: {
            MinimumUnits: {
              type: "long"
            },
            MaximumUnits: {
              type: "long"
            },
            AutoScalingDisabled: {
              type: "boolean"
            },
            AutoScalingRoleArn: {},
            ScalingPolicies: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  PolicyName: {},
                  TargetTrackingScalingPolicyConfiguration: {
                    type: "structure",
                    required: [
                      "TargetValue"
                    ],
                    members: {
                      DisableScaleIn: {
                        type: "boolean"
                      },
                      ScaleInCooldown: {
                        type: "integer"
                      },
                      ScaleOutCooldown: {
                        type: "integer"
                      },
                      TargetValue: {
                        type: "double"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S6i: {
          type: "structure",
          members: {
            TableName: {},
            TableStatus: {},
            Replicas: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  RegionName: {},
                  GlobalSecondaryIndexes: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        IndexName: {},
                        IndexStatus: {},
                        ProvisionedReadCapacityAutoScalingSettings: {
                          shape: "S5y"
                        },
                        ProvisionedWriteCapacityAutoScalingSettings: {
                          shape: "S5y"
                        }
                      }
                    }
                  },
                  ReplicaProvisionedReadCapacityAutoScalingSettings: {
                    shape: "S5y"
                  },
                  ReplicaProvisionedWriteCapacityAutoScalingSettings: {
                    shape: "S5y"
                  },
                  ReplicaStatus: {}
                }
              }
            }
          }
        },
        S6p: {
          type: "structure",
          required: [
            "TableName",
            "StreamArn"
          ],
          members: {
            TableName: {},
            StreamArn: {}
          }
        },
        S6q: {
          type: "structure",
          members: {
            TableName: {},
            StreamArn: {},
            DestinationStatus: {}
          }
        },
        S6z: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Item: {
                shape: "Sq"
              }
            }
          }
        },
        S86: {
          type: "structure",
          required: [
            "ComparisonOperator"
          ],
          members: {
            AttributeValueList: {
              shape: "S4f"
            },
            ComparisonOperator: {}
          }
        },
        S87: {
          type: "map",
          key: {},
          value: {
            shape: "S86"
          }
        },
        S9e: {
          type: "structure",
          members: {
            MinimumUnits: {
              type: "long"
            },
            MaximumUnits: {
              type: "long"
            },
            AutoScalingDisabled: {
              type: "boolean"
            },
            AutoScalingRoleArn: {},
            ScalingPolicyUpdate: {
              type: "structure",
              required: [
                "TargetTrackingScalingPolicyConfiguration"
              ],
              members: {
                PolicyName: {},
                TargetTrackingScalingPolicyConfiguration: {
                  type: "structure",
                  required: [
                    "TargetValue"
                  ],
                  members: {
                    DisableScaleIn: {
                      type: "boolean"
                    },
                    ScaleInCooldown: {
                      type: "integer"
                    },
                    ScaleOutCooldown: {
                      type: "integer"
                    },
                    TargetValue: {
                      type: "double"
                    }
                  }
                }
              }
            }
          }
        },
        Sa3: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "IndexName"
            ],
            members: {
              IndexName: {},
              ProvisionedThroughputOverride: {
                shape: "S2b"
              }
            }
          }
        },
        Sah: {
          type: "structure",
          required: [
            "Enabled",
            "AttributeName"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            AttributeName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dynamodb-2012-08-10.paginators.json
var require_dynamodb_2012_08_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/dynamodb-2012-08-10.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        BatchGetItem: {
          input_token: "RequestItems",
          output_token: "UnprocessedKeys"
        },
        ListContributorInsights: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListExports: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTables: {
          input_token: "ExclusiveStartTableName",
          limit_key: "Limit",
          output_token: "LastEvaluatedTableName",
          result_key: "TableNames"
        },
        Query: {
          input_token: "ExclusiveStartKey",
          limit_key: "Limit",
          output_token: "LastEvaluatedKey",
          result_key: "Items"
        },
        Scan: {
          input_token: "ExclusiveStartKey",
          limit_key: "Limit",
          output_token: "LastEvaluatedKey",
          result_key: "Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dynamodb-2012-08-10.waiters2.json
var require_dynamodb_2012_08_10_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/dynamodb-2012-08-10.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        TableExists: {
          delay: 20,
          operation: "DescribeTable",
          maxAttempts: 25,
          acceptors: [
            {
              expected: "ACTIVE",
              matcher: "path",
              state: "success",
              argument: "Table.TableStatus"
            },
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "retry"
            }
          ]
        },
        TableNotExists: {
          delay: 20,
          operation: "DescribeTable",
          maxAttempts: 25,
          acceptors: [
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "success"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/dynamodb.js
var require_dynamodb2 = __commonJS({
  "node_modules/aws-sdk/clients/dynamodb.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["dynamodb"] = {};
    AWS3.DynamoDB = Service.defineService("dynamodb", ["2011-12-05", "2012-08-10"]);
    require_dynamodb();
    Object.defineProperty(apiLoader.services["dynamodb"], "2011-12-05", {
      get: function get() {
        var model = require_dynamodb_2011_12_05_min();
        model.paginators = require_dynamodb_2011_12_05_paginators().pagination;
        model.waiters = require_dynamodb_2011_12_05_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["dynamodb"], "2012-08-10", {
      get: function get() {
        var model = require_dynamodb_2012_08_10_min();
        model.paginators = require_dynamodb_2012_08_10_paginators().pagination;
        model.waiters = require_dynamodb_2012_08_10_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.DynamoDB;
  }
});

// node_modules/aws-sdk/apis/streams.dynamodb-2012-08-10.min.json
var require_streams_dynamodb_2012_08_10_min = __commonJS({
  "node_modules/aws-sdk/apis/streams.dynamodb-2012-08-10.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2012-08-10",
        endpointPrefix: "streams.dynamodb",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "Amazon DynamoDB Streams",
        serviceId: "DynamoDB Streams",
        signatureVersion: "v4",
        signingName: "dynamodb",
        targetPrefix: "DynamoDBStreams_20120810",
        uid: "streams-dynamodb-2012-08-10"
      },
      operations: {
        DescribeStream: {
          input: {
            type: "structure",
            required: [
              "StreamArn"
            ],
            members: {
              StreamArn: {},
              Limit: {
                type: "integer"
              },
              ExclusiveStartShardId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StreamDescription: {
                type: "structure",
                members: {
                  StreamArn: {},
                  StreamLabel: {},
                  StreamStatus: {},
                  StreamViewType: {},
                  CreationRequestDateTime: {
                    type: "timestamp"
                  },
                  TableName: {},
                  KeySchema: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "AttributeName",
                        "KeyType"
                      ],
                      members: {
                        AttributeName: {},
                        KeyType: {}
                      }
                    }
                  },
                  Shards: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ShardId: {},
                        SequenceNumberRange: {
                          type: "structure",
                          members: {
                            StartingSequenceNumber: {},
                            EndingSequenceNumber: {}
                          }
                        },
                        ParentShardId: {}
                      }
                    }
                  },
                  LastEvaluatedShardId: {}
                }
              }
            }
          }
        },
        GetRecords: {
          input: {
            type: "structure",
            required: [
              "ShardIterator"
            ],
            members: {
              ShardIterator: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Records: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    eventID: {},
                    eventName: {},
                    eventVersion: {},
                    eventSource: {},
                    awsRegion: {},
                    dynamodb: {
                      type: "structure",
                      members: {
                        ApproximateCreationDateTime: {
                          type: "timestamp"
                        },
                        Keys: {
                          shape: "Sr"
                        },
                        NewImage: {
                          shape: "Sr"
                        },
                        OldImage: {
                          shape: "Sr"
                        },
                        SequenceNumber: {},
                        SizeBytes: {
                          type: "long"
                        },
                        StreamViewType: {}
                      }
                    },
                    userIdentity: {
                      type: "structure",
                      members: {
                        PrincipalId: {},
                        Type: {}
                      }
                    }
                  }
                }
              },
              NextShardIterator: {}
            }
          }
        },
        GetShardIterator: {
          input: {
            type: "structure",
            required: [
              "StreamArn",
              "ShardId",
              "ShardIteratorType"
            ],
            members: {
              StreamArn: {},
              ShardId: {},
              ShardIteratorType: {},
              SequenceNumber: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ShardIterator: {}
            }
          }
        },
        ListStreams: {
          input: {
            type: "structure",
            members: {
              TableName: {},
              Limit: {
                type: "integer"
              },
              ExclusiveStartStreamArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Streams: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StreamArn: {},
                    TableName: {},
                    StreamLabel: {}
                  }
                }
              },
              LastEvaluatedStreamArn: {}
            }
          }
        }
      },
      shapes: {
        Sr: {
          type: "map",
          key: {},
          value: {
            shape: "St"
          }
        },
        St: {
          type: "structure",
          members: {
            S: {},
            N: {},
            B: {
              type: "blob"
            },
            SS: {
              type: "list",
              member: {}
            },
            NS: {
              type: "list",
              member: {}
            },
            BS: {
              type: "list",
              member: {
                type: "blob"
              }
            },
            M: {
              type: "map",
              key: {},
              value: {
                shape: "St"
              }
            },
            L: {
              type: "list",
              member: {
                shape: "St"
              }
            },
            NULL: {
              type: "boolean"
            },
            BOOL: {
              type: "boolean"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/streams.dynamodb-2012-08-10.paginators.json
var require_streams_dynamodb_2012_08_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/streams.dynamodb-2012-08-10.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/dynamodbstreams.js
var require_dynamodbstreams = __commonJS({
  "node_modules/aws-sdk/clients/dynamodbstreams.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["dynamodbstreams"] = {};
    AWS3.DynamoDBStreams = Service.defineService("dynamodbstreams", ["2012-08-10"]);
    Object.defineProperty(apiLoader.services["dynamodbstreams"], "2012-08-10", {
      get: function get() {
        var model = require_streams_dynamodb_2012_08_10_min();
        model.paginators = require_streams_dynamodb_2012_08_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.DynamoDBStreams;
  }
});

// node_modules/aws-sdk/lib/services/ec2.js
var require_ec2 = __commonJS({
  "node_modules/aws-sdk/lib/services/ec2.js"() {
    var AWS3 = require_core();
    AWS3.util.update(AWS3.EC2.prototype, {
      setupRequestListeners: function setupRequestListeners(request) {
        request.removeListener("extractError", AWS3.EventListeners.Query.EXTRACT_ERROR);
        request.addListener("extractError", this.extractError);
        if (request.operation === "copySnapshot") {
          request.onAsync("validate", this.buildCopySnapshotPresignedUrl);
        }
      },
      buildCopySnapshotPresignedUrl: function buildCopySnapshotPresignedUrl(req, done) {
        if (req.params.PresignedUrl || req._subRequest) {
          return done();
        }
        req.params = AWS3.util.copy(req.params);
        req.params.DestinationRegion = req.service.config.region;
        var config = AWS3.util.copy(req.service.config);
        delete config.endpoint;
        config.region = req.params.SourceRegion;
        var svc = new req.service.constructor(config);
        var newReq = svc[req.operation](req.params);
        newReq._subRequest = true;
        newReq.presign(function(err, url) {
          if (err)
            done(err);
          else {
            req.params.PresignedUrl = url;
            done();
          }
        });
      },
      extractError: function extractError(resp) {
        var httpResponse = resp.httpResponse;
        var data = new AWS3.XML.Parser().parse(httpResponse.body.toString() || "");
        if (data.Errors) {
          resp.error = AWS3.util.error(new Error(), {
            code: data.Errors.Error.Code,
            message: data.Errors.Error.Message
          });
        } else {
          resp.error = AWS3.util.error(new Error(), {
            code: httpResponse.statusCode,
            message: null
          });
        }
        resp.error.requestId = data.RequestID || null;
      }
    });
  }
});

// node_modules/aws-sdk/apis/ec2-2016-11-15.min.json
var require_ec2_2016_11_15_min = __commonJS({
  "node_modules/aws-sdk/apis/ec2-2016-11-15.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-11-15",
        endpointPrefix: "ec2",
        protocol: "ec2",
        serviceAbbreviation: "Amazon EC2",
        serviceFullName: "Amazon Elastic Compute Cloud",
        serviceId: "EC2",
        signatureVersion: "v4",
        uid: "ec2-2016-11-15",
        xmlNamespace: "http://ec2.amazonaws.com/doc/2016-11-15"
      },
      operations: {
        AcceptReservedInstancesExchangeQuote: {
          input: {
            type: "structure",
            required: [
              "ReservedInstanceIds"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ReservedInstanceIds: {
                shape: "S3",
                locationName: "ReservedInstanceId"
              },
              TargetConfigurations: {
                shape: "S5",
                locationName: "TargetConfiguration"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ExchangeId: {
                locationName: "exchangeId"
              }
            }
          }
        },
        AcceptTransitGatewayMulticastDomainAssociations: {
          input: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomainId: {},
              TransitGatewayAttachmentId: {},
              SubnetIds: {
                shape: "Se"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Associations: {
                shape: "Sg",
                locationName: "associations"
              }
            }
          }
        },
        AcceptTransitGatewayPeeringAttachment: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPeeringAttachment: {
                shape: "Sn",
                locationName: "transitGatewayPeeringAttachment"
              }
            }
          }
        },
        AcceptTransitGatewayVpcAttachment: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayVpcAttachment: {
                shape: "Sw",
                locationName: "transitGatewayVpcAttachment"
              }
            }
          }
        },
        AcceptVpcEndpointConnections: {
          input: {
            type: "structure",
            required: [
              "ServiceId",
              "VpcEndpointIds"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceId: {},
              VpcEndpointIds: {
                shape: "S13",
                locationName: "VpcEndpointId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Unsuccessful: {
                shape: "S16",
                locationName: "unsuccessful"
              }
            }
          }
        },
        AcceptVpcPeeringConnection: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcPeeringConnectionId: {
                locationName: "vpcPeeringConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpcPeeringConnection: {
                shape: "S1c",
                locationName: "vpcPeeringConnection"
              }
            }
          }
        },
        AdvertiseByoipCidr: {
          input: {
            type: "structure",
            required: [
              "Cidr"
            ],
            members: {
              Cidr: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidr: {
                shape: "S1n",
                locationName: "byoipCidr"
              }
            }
          }
        },
        AllocateAddress: {
          input: {
            type: "structure",
            members: {
              Domain: {},
              Address: {},
              PublicIpv4Pool: {},
              NetworkBorderGroup: {},
              CustomerOwnedIpv4Pool: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicIp: {
                locationName: "publicIp"
              },
              AllocationId: {
                locationName: "allocationId"
              },
              PublicIpv4Pool: {
                locationName: "publicIpv4Pool"
              },
              NetworkBorderGroup: {
                locationName: "networkBorderGroup"
              },
              Domain: {
                locationName: "domain"
              },
              CustomerOwnedIp: {
                locationName: "customerOwnedIp"
              },
              CustomerOwnedIpv4Pool: {
                locationName: "customerOwnedIpv4Pool"
              },
              CarrierIp: {
                locationName: "carrierIp"
              }
            }
          }
        },
        AllocateHosts: {
          input: {
            type: "structure",
            required: [
              "AvailabilityZone",
              "Quantity"
            ],
            members: {
              AutoPlacement: {
                locationName: "autoPlacement"
              },
              AvailabilityZone: {
                locationName: "availabilityZone"
              },
              ClientToken: {
                locationName: "clientToken"
              },
              InstanceType: {
                locationName: "instanceType"
              },
              InstanceFamily: {},
              Quantity: {
                locationName: "quantity",
                type: "integer"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              HostRecovery: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HostIds: {
                shape: "S21",
                locationName: "hostIdSet"
              }
            }
          }
        },
        ApplySecurityGroupsToClientVpnTargetNetwork: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId",
              "VpcId",
              "SecurityGroupIds"
            ],
            members: {
              ClientVpnEndpointId: {},
              VpcId: {},
              SecurityGroupIds: {
                shape: "S25",
                locationName: "SecurityGroupId"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityGroupIds: {
                shape: "S25",
                locationName: "securityGroupIds"
              }
            }
          }
        },
        AssignIpv6Addresses: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfaceId"
            ],
            members: {
              Ipv6AddressCount: {
                locationName: "ipv6AddressCount",
                type: "integer"
              },
              Ipv6Addresses: {
                shape: "S29",
                locationName: "ipv6Addresses"
              },
              Ipv6PrefixCount: {
                type: "integer"
              },
              Ipv6Prefixes: {
                shape: "S2a",
                locationName: "Ipv6Prefix"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssignedIpv6Addresses: {
                shape: "S29",
                locationName: "assignedIpv6Addresses"
              },
              AssignedIpv6Prefixes: {
                shape: "S2a",
                locationName: "assignedIpv6PrefixSet"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              }
            }
          }
        },
        AssignPrivateIpAddresses: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfaceId"
            ],
            members: {
              AllowReassignment: {
                locationName: "allowReassignment",
                type: "boolean"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              PrivateIpAddresses: {
                shape: "S2e",
                locationName: "privateIpAddress"
              },
              SecondaryPrivateIpAddressCount: {
                locationName: "secondaryPrivateIpAddressCount",
                type: "integer"
              },
              Ipv4Prefixes: {
                shape: "S2a",
                locationName: "Ipv4Prefix"
              },
              Ipv4PrefixCount: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              AssignedPrivateIpAddresses: {
                locationName: "assignedPrivateIpAddressesSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    PrivateIpAddress: {
                      locationName: "privateIpAddress"
                    }
                  }
                }
              },
              AssignedIpv4Prefixes: {
                shape: "S2i",
                locationName: "assignedIpv4PrefixSet"
              }
            }
          }
        },
        AssociateAddress: {
          input: {
            type: "structure",
            members: {
              AllocationId: {},
              InstanceId: {},
              PublicIp: {},
              AllowReassociation: {
                locationName: "allowReassociation",
                type: "boolean"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              PrivateIpAddress: {
                locationName: "privateIpAddress"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationId: {
                locationName: "associationId"
              }
            }
          }
        },
        AssociateClientVpnTargetNetwork: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId",
              "SubnetId"
            ],
            members: {
              ClientVpnEndpointId: {},
              SubnetId: {},
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationId: {
                locationName: "associationId"
              },
              Status: {
                shape: "S2r",
                locationName: "status"
              }
            }
          }
        },
        AssociateDhcpOptions: {
          input: {
            type: "structure",
            required: [
              "DhcpOptionsId",
              "VpcId"
            ],
            members: {
              DhcpOptionsId: {},
              VpcId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        AssociateEnclaveCertificateIamRole: {
          input: {
            type: "structure",
            members: {
              CertificateArn: {},
              RoleArn: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CertificateS3BucketName: {
                locationName: "certificateS3BucketName"
              },
              CertificateS3ObjectKey: {
                locationName: "certificateS3ObjectKey"
              },
              EncryptionKmsKeyId: {
                locationName: "encryptionKmsKeyId"
              }
            }
          }
        },
        AssociateIamInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "IamInstanceProfile",
              "InstanceId"
            ],
            members: {
              IamInstanceProfile: {
                shape: "S2z"
              },
              InstanceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IamInstanceProfileAssociation: {
                shape: "S31",
                locationName: "iamInstanceProfileAssociation"
              }
            }
          }
        },
        AssociateInstanceEventWindow: {
          input: {
            type: "structure",
            required: [
              "InstanceEventWindowId",
              "AssociationTarget"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceEventWindowId: {},
              AssociationTarget: {
                type: "structure",
                members: {
                  InstanceIds: {
                    shape: "S37",
                    locationName: "InstanceId"
                  },
                  InstanceTags: {
                    shape: "Ss",
                    locationName: "InstanceTag"
                  },
                  DedicatedHostIds: {
                    shape: "S38",
                    locationName: "DedicatedHostId"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceEventWindow: {
                shape: "S3b",
                locationName: "instanceEventWindow"
              }
            }
          }
        },
        AssociateRouteTable: {
          input: {
            type: "structure",
            required: [
              "RouteTableId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              RouteTableId: {
                locationName: "routeTableId"
              },
              SubnetId: {
                locationName: "subnetId"
              },
              GatewayId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationId: {
                locationName: "associationId"
              },
              AssociationState: {
                shape: "S3n",
                locationName: "associationState"
              }
            }
          }
        },
        AssociateSubnetCidrBlock: {
          input: {
            type: "structure",
            required: [
              "Ipv6CidrBlock",
              "SubnetId"
            ],
            members: {
              Ipv6CidrBlock: {
                locationName: "ipv6CidrBlock"
              },
              SubnetId: {
                locationName: "subnetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Ipv6CidrBlockAssociation: {
                shape: "S3r",
                locationName: "ipv6CidrBlockAssociation"
              },
              SubnetId: {
                locationName: "subnetId"
              }
            }
          }
        },
        AssociateTransitGatewayMulticastDomain: {
          input: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomainId: {},
              TransitGatewayAttachmentId: {},
              SubnetIds: {
                shape: "S3w"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Associations: {
                shape: "Sg",
                locationName: "associations"
              }
            }
          }
        },
        AssociateTransitGatewayRouteTable: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId",
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Association: {
                shape: "S41",
                locationName: "association"
              }
            }
          }
        },
        AssociateTrunkInterface: {
          input: {
            type: "structure",
            required: [
              "BranchInterfaceId",
              "TrunkInterfaceId"
            ],
            members: {
              BranchInterfaceId: {},
              TrunkInterfaceId: {},
              VlanId: {
                type: "integer"
              },
              GreKey: {
                type: "integer"
              },
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InterfaceAssociation: {
                shape: "S45",
                locationName: "interfaceAssociation"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        AssociateVpcCidrBlock: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              AmazonProvidedIpv6CidrBlock: {
                locationName: "amazonProvidedIpv6CidrBlock",
                type: "boolean"
              },
              CidrBlock: {},
              VpcId: {
                locationName: "vpcId"
              },
              Ipv6CidrBlockNetworkBorderGroup: {},
              Ipv6Pool: {},
              Ipv6CidrBlock: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Ipv6CidrBlockAssociation: {
                shape: "S4b",
                locationName: "ipv6CidrBlockAssociation"
              },
              CidrBlockAssociation: {
                shape: "S4e",
                locationName: "cidrBlockAssociation"
              },
              VpcId: {
                locationName: "vpcId"
              }
            }
          }
        },
        AttachClassicLinkVpc: {
          input: {
            type: "structure",
            required: [
              "Groups",
              "InstanceId",
              "VpcId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Groups: {
                shape: "S4g",
                locationName: "SecurityGroupId"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              VpcId: {
                locationName: "vpcId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        AttachInternetGateway: {
          input: {
            type: "structure",
            required: [
              "InternetGatewayId",
              "VpcId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InternetGatewayId: {
                locationName: "internetGatewayId"
              },
              VpcId: {
                locationName: "vpcId"
              }
            }
          }
        },
        AttachNetworkInterface: {
          input: {
            type: "structure",
            required: [
              "DeviceIndex",
              "InstanceId",
              "NetworkInterfaceId"
            ],
            members: {
              DeviceIndex: {
                locationName: "deviceIndex",
                type: "integer"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              NetworkCardIndex: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AttachmentId: {
                locationName: "attachmentId"
              },
              NetworkCardIndex: {
                locationName: "networkCardIndex",
                type: "integer"
              }
            }
          }
        },
        AttachVolume: {
          input: {
            type: "structure",
            required: [
              "Device",
              "InstanceId",
              "VolumeId"
            ],
            members: {
              Device: {},
              InstanceId: {},
              VolumeId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S4o"
          }
        },
        AttachVpnGateway: {
          input: {
            type: "structure",
            required: [
              "VpcId",
              "VpnGatewayId"
            ],
            members: {
              VpcId: {},
              VpnGatewayId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpcAttachment: {
                shape: "S4t",
                locationName: "attachment"
              }
            }
          }
        },
        AuthorizeClientVpnIngress: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId",
              "TargetNetworkCidr"
            ],
            members: {
              ClientVpnEndpointId: {},
              TargetNetworkCidr: {},
              AccessGroupId: {},
              AuthorizeAllGroups: {
                type: "boolean"
              },
              Description: {},
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                shape: "S4x",
                locationName: "status"
              }
            }
          }
        },
        AuthorizeSecurityGroupEgress: {
          input: {
            type: "structure",
            required: [
              "GroupId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              GroupId: {
                locationName: "groupId"
              },
              IpPermissions: {
                shape: "S50",
                locationName: "ipPermissions"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              CidrIp: {
                locationName: "cidrIp"
              },
              FromPort: {
                locationName: "fromPort",
                type: "integer"
              },
              IpProtocol: {
                locationName: "ipProtocol"
              },
              ToPort: {
                locationName: "toPort",
                type: "integer"
              },
              SourceSecurityGroupName: {
                locationName: "sourceSecurityGroupName"
              },
              SourceSecurityGroupOwnerId: {
                locationName: "sourceSecurityGroupOwnerId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              },
              SecurityGroupRules: {
                shape: "S5b",
                locationName: "securityGroupRuleSet"
              }
            }
          }
        },
        AuthorizeSecurityGroupIngress: {
          input: {
            type: "structure",
            members: {
              CidrIp: {},
              FromPort: {
                type: "integer"
              },
              GroupId: {},
              GroupName: {},
              IpPermissions: {
                shape: "S50"
              },
              IpProtocol: {},
              SourceSecurityGroupName: {},
              SourceSecurityGroupOwnerId: {},
              ToPort: {
                type: "integer"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              },
              SecurityGroupRules: {
                shape: "S5b",
                locationName: "securityGroupRuleSet"
              }
            }
          }
        },
        BundleInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Storage"
            ],
            members: {
              InstanceId: {},
              Storage: {
                shape: "S5k"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BundleTask: {
                shape: "S5o",
                locationName: "bundleInstanceTask"
              }
            }
          }
        },
        CancelBundleTask: {
          input: {
            type: "structure",
            required: [
              "BundleId"
            ],
            members: {
              BundleId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BundleTask: {
                shape: "S5o",
                locationName: "bundleInstanceTask"
              }
            }
          }
        },
        CancelCapacityReservation: {
          input: {
            type: "structure",
            required: [
              "CapacityReservationId"
            ],
            members: {
              CapacityReservationId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        CancelCapacityReservationFleets: {
          input: {
            type: "structure",
            required: [
              "CapacityReservationFleetIds"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              CapacityReservationFleetIds: {
                shape: "S5y",
                locationName: "CapacityReservationFleetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuccessfulFleetCancellations: {
                locationName: "successfulFleetCancellationSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CurrentFleetState: {
                      locationName: "currentFleetState"
                    },
                    PreviousFleetState: {
                      locationName: "previousFleetState"
                    },
                    CapacityReservationFleetId: {
                      locationName: "capacityReservationFleetId"
                    }
                  }
                }
              },
              FailedFleetCancellations: {
                locationName: "failedFleetCancellationSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CapacityReservationFleetId: {
                      locationName: "capacityReservationFleetId"
                    },
                    CancelCapacityReservationFleetError: {
                      locationName: "cancelCapacityReservationFleetError",
                      type: "structure",
                      members: {
                        Code: {
                          locationName: "code"
                        },
                        Message: {
                          locationName: "message"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        CancelConversionTask: {
          input: {
            type: "structure",
            required: [
              "ConversionTaskId"
            ],
            members: {
              ConversionTaskId: {
                locationName: "conversionTaskId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              ReasonMessage: {
                locationName: "reasonMessage"
              }
            }
          }
        },
        CancelExportTask: {
          input: {
            type: "structure",
            required: [
              "ExportTaskId"
            ],
            members: {
              ExportTaskId: {
                locationName: "exportTaskId"
              }
            }
          }
        },
        CancelImportTask: {
          input: {
            type: "structure",
            members: {
              CancelReason: {},
              DryRun: {
                type: "boolean"
              },
              ImportTaskId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImportTaskId: {
                locationName: "importTaskId"
              },
              PreviousState: {
                locationName: "previousState"
              },
              State: {
                locationName: "state"
              }
            }
          }
        },
        CancelReservedInstancesListing: {
          input: {
            type: "structure",
            required: [
              "ReservedInstancesListingId"
            ],
            members: {
              ReservedInstancesListingId: {
                locationName: "reservedInstancesListingId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedInstancesListings: {
                shape: "S6j",
                locationName: "reservedInstancesListingsSet"
              }
            }
          }
        },
        CancelSpotFleetRequests: {
          input: {
            type: "structure",
            required: [
              "SpotFleetRequestIds",
              "TerminateInstances"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              SpotFleetRequestIds: {
                shape: "S6v",
                locationName: "spotFleetRequestId"
              },
              TerminateInstances: {
                locationName: "terminateInstances",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuccessfulFleetRequests: {
                locationName: "successfulFleetRequestSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CurrentSpotFleetRequestState: {
                      locationName: "currentSpotFleetRequestState"
                    },
                    PreviousSpotFleetRequestState: {
                      locationName: "previousSpotFleetRequestState"
                    },
                    SpotFleetRequestId: {
                      locationName: "spotFleetRequestId"
                    }
                  }
                }
              },
              UnsuccessfulFleetRequests: {
                locationName: "unsuccessfulFleetRequestSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Error: {
                      locationName: "error",
                      type: "structure",
                      members: {
                        Code: {
                          locationName: "code"
                        },
                        Message: {
                          locationName: "message"
                        }
                      }
                    },
                    SpotFleetRequestId: {
                      locationName: "spotFleetRequestId"
                    }
                  }
                }
              }
            }
          }
        },
        CancelSpotInstanceRequests: {
          input: {
            type: "structure",
            required: [
              "SpotInstanceRequestIds"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              SpotInstanceRequestIds: {
                shape: "S76",
                locationName: "SpotInstanceRequestId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CancelledSpotInstanceRequests: {
                locationName: "spotInstanceRequestSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    SpotInstanceRequestId: {
                      locationName: "spotInstanceRequestId"
                    },
                    State: {
                      locationName: "state"
                    }
                  }
                }
              }
            }
          }
        },
        ConfirmProductInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ProductCode"
            ],
            members: {
              InstanceId: {},
              ProductCode: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OwnerId: {
                locationName: "ownerId"
              },
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        CopyFpgaImage: {
          input: {
            type: "structure",
            required: [
              "SourceFpgaImageId",
              "SourceRegion"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              SourceFpgaImageId: {},
              Description: {},
              Name: {},
              SourceRegion: {},
              ClientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FpgaImageId: {
                locationName: "fpgaImageId"
              }
            }
          }
        },
        CopyImage: {
          input: {
            type: "structure",
            required: [
              "Name",
              "SourceImageId",
              "SourceRegion"
            ],
            members: {
              ClientToken: {},
              Description: {},
              Encrypted: {
                locationName: "encrypted",
                type: "boolean"
              },
              KmsKeyId: {
                locationName: "kmsKeyId"
              },
              Name: {},
              SourceImageId: {},
              SourceRegion: {},
              DestinationOutpostArn: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageId: {
                locationName: "imageId"
              }
            }
          }
        },
        CopySnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceRegion",
              "SourceSnapshotId"
            ],
            members: {
              Description: {},
              DestinationOutpostArn: {},
              DestinationRegion: {
                locationName: "destinationRegion"
              },
              Encrypted: {
                locationName: "encrypted",
                type: "boolean"
              },
              KmsKeyId: {
                locationName: "kmsKeyId"
              },
              PresignedUrl: {
                locationName: "presignedUrl"
              },
              SourceRegion: {},
              SourceSnapshotId: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SnapshotId: {
                locationName: "snapshotId"
              },
              Tags: {
                shape: "Ss",
                locationName: "tagSet"
              }
            }
          }
        },
        CreateCapacityReservation: {
          input: {
            type: "structure",
            required: [
              "InstanceType",
              "InstancePlatform",
              "InstanceCount"
            ],
            members: {
              ClientToken: {},
              InstanceType: {},
              InstancePlatform: {},
              AvailabilityZone: {},
              AvailabilityZoneId: {},
              Tenancy: {},
              InstanceCount: {
                type: "integer"
              },
              EbsOptimized: {
                type: "boolean"
              },
              EphemeralStorage: {
                type: "boolean"
              },
              EndDate: {
                type: "timestamp"
              },
              EndDateType: {},
              InstanceMatchCriteria: {},
              TagSpecifications: {
                shape: "S1t"
              },
              DryRun: {
                type: "boolean"
              },
              OutpostArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CapacityReservation: {
                shape: "S7s",
                locationName: "capacityReservation"
              }
            }
          }
        },
        CreateCapacityReservationFleet: {
          input: {
            type: "structure",
            required: [
              "InstanceTypeSpecifications",
              "TotalTargetCapacity"
            ],
            members: {
              AllocationStrategy: {},
              ClientToken: {
                idempotencyToken: true
              },
              InstanceTypeSpecifications: {
                locationName: "InstanceTypeSpecification",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InstanceType: {},
                    InstancePlatform: {},
                    Weight: {
                      type: "double"
                    },
                    AvailabilityZone: {},
                    AvailabilityZoneId: {},
                    EbsOptimized: {
                      type: "boolean"
                    },
                    Priority: {
                      type: "integer"
                    }
                  }
                }
              },
              Tenancy: {},
              TotalTargetCapacity: {
                type: "integer"
              },
              EndDate: {
                type: "timestamp"
              },
              InstanceMatchCriteria: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CapacityReservationFleetId: {
                locationName: "capacityReservationFleetId"
              },
              State: {
                locationName: "state"
              },
              TotalTargetCapacity: {
                locationName: "totalTargetCapacity",
                type: "integer"
              },
              TotalFulfilledCapacity: {
                locationName: "totalFulfilledCapacity",
                type: "double"
              },
              InstanceMatchCriteria: {
                locationName: "instanceMatchCriteria"
              },
              AllocationStrategy: {
                locationName: "allocationStrategy"
              },
              CreateTime: {
                locationName: "createTime",
                type: "timestamp"
              },
              EndDate: {
                locationName: "endDate",
                type: "timestamp"
              },
              Tenancy: {
                locationName: "tenancy"
              },
              FleetCapacityReservations: {
                shape: "S84",
                locationName: "fleetCapacityReservationSet"
              },
              Tags: {
                shape: "Ss",
                locationName: "tagSet"
              }
            }
          }
        },
        CreateCarrierGateway: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              VpcId: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CarrierGateway: {
                shape: "S88",
                locationName: "carrierGateway"
              }
            }
          }
        },
        CreateClientVpnEndpoint: {
          input: {
            type: "structure",
            required: [
              "ClientCidrBlock",
              "ServerCertificateArn",
              "AuthenticationOptions",
              "ConnectionLogOptions"
            ],
            members: {
              ClientCidrBlock: {},
              ServerCertificateArn: {},
              AuthenticationOptions: {
                locationName: "Authentication",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    ActiveDirectory: {
                      type: "structure",
                      members: {
                        DirectoryId: {}
                      }
                    },
                    MutualAuthentication: {
                      type: "structure",
                      members: {
                        ClientRootCertificateChainArn: {}
                      }
                    },
                    FederatedAuthentication: {
                      type: "structure",
                      members: {
                        SAMLProviderArn: {},
                        SelfServiceSAMLProviderArn: {}
                      }
                    }
                  }
                }
              },
              ConnectionLogOptions: {
                shape: "S8i"
              },
              DnsServers: {
                shape: "Se"
              },
              TransportProtocol: {},
              VpnPort: {
                type: "integer"
              },
              Description: {},
              SplitTunnel: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              SecurityGroupIds: {
                shape: "S25",
                locationName: "SecurityGroupId"
              },
              VpcId: {},
              SelfServicePortal: {},
              ClientConnectOptions: {
                shape: "S8l"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientVpnEndpointId: {
                locationName: "clientVpnEndpointId"
              },
              Status: {
                shape: "S8n",
                locationName: "status"
              },
              DnsName: {
                locationName: "dnsName"
              }
            }
          }
        },
        CreateClientVpnRoute: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId",
              "DestinationCidrBlock",
              "TargetVpcSubnetId"
            ],
            members: {
              ClientVpnEndpointId: {},
              DestinationCidrBlock: {},
              TargetVpcSubnetId: {},
              Description: {},
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                shape: "S8r",
                locationName: "status"
              }
            }
          }
        },
        CreateCustomerGateway: {
          input: {
            type: "structure",
            required: [
              "BgpAsn",
              "Type"
            ],
            members: {
              BgpAsn: {
                type: "integer"
              },
              PublicIp: {
                locationName: "IpAddress"
              },
              CertificateArn: {},
              Type: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              DeviceName: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CustomerGateway: {
                shape: "S8w",
                locationName: "customerGateway"
              }
            }
          }
        },
        CreateDefaultSubnet: {
          input: {
            type: "structure",
            required: [
              "AvailabilityZone"
            ],
            members: {
              AvailabilityZone: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Subnet: {
                shape: "S8z",
                locationName: "subnet"
              }
            }
          }
        },
        CreateDefaultVpc: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Vpc: {
                shape: "S95",
                locationName: "vpc"
              }
            }
          }
        },
        CreateDhcpOptions: {
          input: {
            type: "structure",
            required: [
              "DhcpConfigurations"
            ],
            members: {
              DhcpConfigurations: {
                locationName: "dhcpConfiguration",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Key: {
                      locationName: "key"
                    },
                    Values: {
                      shape: "Se",
                      locationName: "Value"
                    }
                  }
                }
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DhcpOptions: {
                shape: "S9e",
                locationName: "dhcpOptions"
              }
            }
          }
        },
        CreateEgressOnlyInternetGateway: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              ClientToken: {},
              DryRun: {
                type: "boolean"
              },
              VpcId: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientToken: {
                locationName: "clientToken"
              },
              EgressOnlyInternetGateway: {
                shape: "S9l",
                locationName: "egressOnlyInternetGateway"
              }
            }
          }
        },
        CreateFleet: {
          input: {
            type: "structure",
            required: [
              "LaunchTemplateConfigs",
              "TargetCapacitySpecification"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ClientToken: {},
              SpotOptions: {
                type: "structure",
                members: {
                  AllocationStrategy: {},
                  MaintenanceStrategies: {
                    type: "structure",
                    members: {
                      CapacityRebalance: {
                        type: "structure",
                        members: {
                          ReplacementStrategy: {}
                        }
                      }
                    }
                  },
                  InstanceInterruptionBehavior: {},
                  InstancePoolsToUseCount: {
                    type: "integer"
                  },
                  SingleInstanceType: {
                    type: "boolean"
                  },
                  SingleAvailabilityZone: {
                    type: "boolean"
                  },
                  MinTargetCapacity: {
                    type: "integer"
                  },
                  MaxTotalPrice: {}
                }
              },
              OnDemandOptions: {
                type: "structure",
                members: {
                  AllocationStrategy: {},
                  CapacityReservationOptions: {
                    type: "structure",
                    members: {
                      UsageStrategy: {}
                    }
                  },
                  SingleInstanceType: {
                    type: "boolean"
                  },
                  SingleAvailabilityZone: {
                    type: "boolean"
                  },
                  MinTargetCapacity: {
                    type: "integer"
                  },
                  MaxTotalPrice: {}
                }
              },
              ExcessCapacityTerminationPolicy: {},
              LaunchTemplateConfigs: {
                shape: "Sa1"
              },
              TargetCapacitySpecification: {
                shape: "Saa"
              },
              TerminateInstancesWithExpiration: {
                type: "boolean"
              },
              Type: {},
              ValidFrom: {
                type: "timestamp"
              },
              ValidUntil: {
                type: "timestamp"
              },
              ReplaceUnhealthyInstances: {
                type: "boolean"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              Context: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {
                locationName: "fleetId"
              },
              Errors: {
                locationName: "errorSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    LaunchTemplateAndOverrides: {
                      shape: "Sah",
                      locationName: "launchTemplateAndOverrides"
                    },
                    Lifecycle: {
                      locationName: "lifecycle"
                    },
                    ErrorCode: {
                      locationName: "errorCode"
                    },
                    ErrorMessage: {
                      locationName: "errorMessage"
                    }
                  }
                }
              },
              Instances: {
                locationName: "fleetInstanceSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    LaunchTemplateAndOverrides: {
                      shape: "Sah",
                      locationName: "launchTemplateAndOverrides"
                    },
                    Lifecycle: {
                      locationName: "lifecycle"
                    },
                    InstanceIds: {
                      shape: "Sao",
                      locationName: "instanceIds"
                    },
                    InstanceType: {
                      locationName: "instanceType"
                    },
                    Platform: {
                      locationName: "platform"
                    }
                  }
                }
              }
            }
          }
        },
        CreateFlowLogs: {
          input: {
            type: "structure",
            required: [
              "ResourceIds",
              "ResourceType",
              "TrafficType"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ClientToken: {},
              DeliverLogsPermissionArn: {},
              LogGroupName: {},
              ResourceIds: {
                locationName: "ResourceId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              ResourceType: {},
              TrafficType: {},
              LogDestinationType: {},
              LogDestination: {},
              LogFormat: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              MaxAggregationInterval: {
                type: "integer"
              },
              DestinationOptions: {
                type: "structure",
                members: {
                  FileFormat: {},
                  HiveCompatiblePartitions: {
                    type: "boolean"
                  },
                  PerHourPartition: {
                    type: "boolean"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientToken: {
                locationName: "clientToken"
              },
              FlowLogIds: {
                shape: "Se",
                locationName: "flowLogIdSet"
              },
              Unsuccessful: {
                shape: "S16",
                locationName: "unsuccessful"
              }
            }
          }
        },
        CreateFpgaImage: {
          input: {
            type: "structure",
            required: [
              "InputStorageLocation"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InputStorageLocation: {
                shape: "Sb0"
              },
              LogsStorageLocation: {
                shape: "Sb0"
              },
              Description: {},
              Name: {},
              ClientToken: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FpgaImageId: {
                locationName: "fpgaImageId"
              },
              FpgaImageGlobalId: {
                locationName: "fpgaImageGlobalId"
              }
            }
          }
        },
        CreateImage: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name"
            ],
            members: {
              BlockDeviceMappings: {
                shape: "Sb3",
                locationName: "blockDeviceMapping"
              },
              Description: {
                locationName: "description"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              Name: {
                locationName: "name"
              },
              NoReboot: {
                locationName: "noReboot",
                type: "boolean"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageId: {
                locationName: "imageId"
              }
            }
          }
        },
        CreateInstanceEventWindow: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Name: {},
              TimeRanges: {
                shape: "Sba",
                locationName: "TimeRange"
              },
              CronExpression: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceEventWindow: {
                shape: "S3b",
                locationName: "instanceEventWindow"
              }
            }
          }
        },
        CreateInstanceExportTask: {
          input: {
            type: "structure",
            required: [
              "ExportToS3Task",
              "InstanceId",
              "TargetEnvironment"
            ],
            members: {
              Description: {
                locationName: "description"
              },
              ExportToS3Task: {
                locationName: "exportToS3",
                type: "structure",
                members: {
                  ContainerFormat: {
                    locationName: "containerFormat"
                  },
                  DiskImageFormat: {
                    locationName: "diskImageFormat"
                  },
                  S3Bucket: {
                    locationName: "s3Bucket"
                  },
                  S3Prefix: {
                    locationName: "s3Prefix"
                  }
                }
              },
              InstanceId: {
                locationName: "instanceId"
              },
              TargetEnvironment: {
                locationName: "targetEnvironment"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ExportTask: {
                shape: "Sbj",
                locationName: "exportTask"
              }
            }
          }
        },
        CreateInternetGateway: {
          input: {
            type: "structure",
            members: {
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InternetGateway: {
                shape: "Sbp",
                locationName: "internetGateway"
              }
            }
          }
        },
        CreateKeyPair: {
          input: {
            type: "structure",
            required: [
              "KeyName"
            ],
            members: {
              KeyName: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              KeyType: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyFingerprint: {
                locationName: "keyFingerprint"
              },
              KeyMaterial: {
                locationName: "keyMaterial",
                type: "string",
                sensitive: true
              },
              KeyName: {
                locationName: "keyName"
              },
              KeyPairId: {
                locationName: "keyPairId"
              },
              Tags: {
                shape: "Ss",
                locationName: "tagSet"
              }
            }
          }
        },
        CreateLaunchTemplate: {
          input: {
            type: "structure",
            required: [
              "LaunchTemplateName",
              "LaunchTemplateData"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ClientToken: {},
              LaunchTemplateName: {},
              VersionDescription: {},
              LaunchTemplateData: {
                shape: "Sbw"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LaunchTemplate: {
                shape: "Sda",
                locationName: "launchTemplate"
              },
              Warning: {
                shape: "Sdb",
                locationName: "warning"
              }
            }
          }
        },
        CreateLaunchTemplateVersion: {
          input: {
            type: "structure",
            required: [
              "LaunchTemplateData"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ClientToken: {},
              LaunchTemplateId: {},
              LaunchTemplateName: {},
              SourceVersion: {},
              VersionDescription: {},
              LaunchTemplateData: {
                shape: "Sbw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LaunchTemplateVersion: {
                shape: "Sdg",
                locationName: "launchTemplateVersion"
              },
              Warning: {
                shape: "Sdb",
                locationName: "warning"
              }
            }
          }
        },
        CreateLocalGatewayRoute: {
          input: {
            type: "structure",
            required: [
              "DestinationCidrBlock",
              "LocalGatewayRouteTableId",
              "LocalGatewayVirtualInterfaceGroupId"
            ],
            members: {
              DestinationCidrBlock: {},
              LocalGatewayRouteTableId: {},
              LocalGatewayVirtualInterfaceGroupId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Route: {
                shape: "Sei",
                locationName: "route"
              }
            }
          }
        },
        CreateLocalGatewayRouteTableVpcAssociation: {
          input: {
            type: "structure",
            required: [
              "LocalGatewayRouteTableId",
              "VpcId"
            ],
            members: {
              LocalGatewayRouteTableId: {},
              VpcId: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalGatewayRouteTableVpcAssociation: {
                shape: "Sen",
                locationName: "localGatewayRouteTableVpcAssociation"
              }
            }
          }
        },
        CreateManagedPrefixList: {
          input: {
            type: "structure",
            required: [
              "PrefixListName",
              "MaxEntries",
              "AddressFamily"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              PrefixListName: {},
              Entries: {
                shape: "Seq",
                locationName: "Entry"
              },
              MaxEntries: {
                type: "integer"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              AddressFamily: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PrefixList: {
                shape: "Set",
                locationName: "prefixList"
              }
            }
          }
        },
        CreateNatGateway: {
          input: {
            type: "structure",
            required: [
              "SubnetId"
            ],
            members: {
              AllocationId: {},
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              },
              SubnetId: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              ConnectivityType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ClientToken: {
                locationName: "clientToken"
              },
              NatGateway: {
                shape: "Sey",
                locationName: "natGateway"
              }
            }
          }
        },
        CreateNetworkAcl: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcId: {
                locationName: "vpcId"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkAcl: {
                shape: "Sf5",
                locationName: "networkAcl"
              }
            }
          }
        },
        CreateNetworkAclEntry: {
          input: {
            type: "structure",
            required: [
              "Egress",
              "NetworkAclId",
              "Protocol",
              "RuleAction",
              "RuleNumber"
            ],
            members: {
              CidrBlock: {
                locationName: "cidrBlock"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Egress: {
                locationName: "egress",
                type: "boolean"
              },
              IcmpTypeCode: {
                shape: "Sfa",
                locationName: "Icmp"
              },
              Ipv6CidrBlock: {
                locationName: "ipv6CidrBlock"
              },
              NetworkAclId: {
                locationName: "networkAclId"
              },
              PortRange: {
                shape: "Sfb",
                locationName: "portRange"
              },
              Protocol: {
                locationName: "protocol"
              },
              RuleAction: {
                locationName: "ruleAction"
              },
              RuleNumber: {
                locationName: "ruleNumber",
                type: "integer"
              }
            }
          }
        },
        CreateNetworkInsightsPath: {
          input: {
            type: "structure",
            required: [
              "Source",
              "Destination",
              "Protocol",
              "ClientToken"
            ],
            members: {
              SourceIp: {},
              DestinationIp: {},
              Source: {},
              Destination: {},
              Protocol: {},
              DestinationPort: {
                type: "integer"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInsightsPath: {
                shape: "Sfk",
                locationName: "networkInsightsPath"
              }
            }
          }
        },
        CreateNetworkInterface: {
          input: {
            type: "structure",
            required: [
              "SubnetId"
            ],
            members: {
              Description: {
                locationName: "description"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Groups: {
                shape: "Sc4",
                locationName: "SecurityGroupId"
              },
              Ipv6AddressCount: {
                locationName: "ipv6AddressCount",
                type: "integer"
              },
              Ipv6Addresses: {
                shape: "Sdo",
                locationName: "ipv6Addresses"
              },
              PrivateIpAddress: {
                locationName: "privateIpAddress"
              },
              PrivateIpAddresses: {
                shape: "Sc7",
                locationName: "privateIpAddresses"
              },
              SecondaryPrivateIpAddressCount: {
                locationName: "secondaryPrivateIpAddressCount",
                type: "integer"
              },
              Ipv4Prefixes: {
                shape: "Sc9",
                locationName: "Ipv4Prefix"
              },
              Ipv4PrefixCount: {
                type: "integer"
              },
              Ipv6Prefixes: {
                shape: "Scb",
                locationName: "Ipv6Prefix"
              },
              Ipv6PrefixCount: {
                type: "integer"
              },
              InterfaceType: {},
              SubnetId: {
                locationName: "subnetId"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInterface: {
                shape: "Sfp",
                locationName: "networkInterface"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        CreateNetworkInterfacePermission: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfaceId",
              "Permission"
            ],
            members: {
              NetworkInterfaceId: {},
              AwsAccountId: {},
              AwsService: {},
              Permission: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InterfacePermission: {
                shape: "Sg5",
                locationName: "interfacePermission"
              }
            }
          }
        },
        CreatePlacementGroup: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              GroupName: {
                locationName: "groupName"
              },
              Strategy: {
                locationName: "strategy"
              },
              PartitionCount: {
                type: "integer"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PlacementGroup: {
                shape: "Sgb",
                locationName: "placementGroup"
              }
            }
          }
        },
        CreateReplaceRootVolumeTask: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              SnapshotId: {},
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplaceRootVolumeTask: {
                shape: "Sgf",
                locationName: "replaceRootVolumeTask"
              }
            }
          }
        },
        CreateReservedInstancesListing: {
          input: {
            type: "structure",
            required: [
              "ClientToken",
              "InstanceCount",
              "PriceSchedules",
              "ReservedInstancesId"
            ],
            members: {
              ClientToken: {
                locationName: "clientToken"
              },
              InstanceCount: {
                locationName: "instanceCount",
                type: "integer"
              },
              PriceSchedules: {
                locationName: "priceSchedules",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CurrencyCode: {
                      locationName: "currencyCode"
                    },
                    Price: {
                      locationName: "price",
                      type: "double"
                    },
                    Term: {
                      locationName: "term",
                      type: "long"
                    }
                  }
                }
              },
              ReservedInstancesId: {
                locationName: "reservedInstancesId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedInstancesListings: {
                shape: "S6j",
                locationName: "reservedInstancesListingsSet"
              }
            }
          }
        },
        CreateRestoreImageTask: {
          input: {
            type: "structure",
            required: [
              "Bucket",
              "ObjectKey"
            ],
            members: {
              Bucket: {},
              ObjectKey: {},
              Name: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageId: {
                locationName: "imageId"
              }
            }
          }
        },
        CreateRoute: {
          input: {
            type: "structure",
            required: [
              "RouteTableId"
            ],
            members: {
              DestinationCidrBlock: {
                locationName: "destinationCidrBlock"
              },
              DestinationIpv6CidrBlock: {
                locationName: "destinationIpv6CidrBlock"
              },
              DestinationPrefixListId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcEndpointId: {},
              EgressOnlyInternetGatewayId: {
                locationName: "egressOnlyInternetGatewayId"
              },
              GatewayId: {
                locationName: "gatewayId"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              NatGatewayId: {
                locationName: "natGatewayId"
              },
              TransitGatewayId: {},
              LocalGatewayId: {},
              CarrierGatewayId: {},
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              RouteTableId: {
                locationName: "routeTableId"
              },
              VpcPeeringConnectionId: {
                locationName: "vpcPeeringConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        CreateRouteTable: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcId: {
                locationName: "vpcId"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RouteTable: {
                shape: "Sgv",
                locationName: "routeTable"
              }
            }
          }
        },
        CreateSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "Description",
              "GroupName"
            ],
            members: {
              Description: {
                locationName: "GroupDescription"
              },
              GroupName: {},
              VpcId: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupId: {
                locationName: "groupId"
              },
              Tags: {
                shape: "Ss",
                locationName: "tagSet"
              }
            }
          }
        },
        CreateSnapshot: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              Description: {},
              OutpostArn: {},
              VolumeId: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            shape: "Sh7"
          }
        },
        CreateSnapshots: {
          input: {
            type: "structure",
            required: [
              "InstanceSpecification"
            ],
            members: {
              Description: {},
              InstanceSpecification: {
                type: "structure",
                members: {
                  InstanceId: {},
                  ExcludeBootVolume: {
                    type: "boolean"
                  }
                }
              },
              OutpostArn: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              },
              CopyTagsFromSource: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Snapshots: {
                locationName: "snapshotSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Description: {
                      locationName: "description"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    },
                    Encrypted: {
                      locationName: "encrypted",
                      type: "boolean"
                    },
                    VolumeId: {
                      locationName: "volumeId"
                    },
                    State: {
                      locationName: "state"
                    },
                    VolumeSize: {
                      locationName: "volumeSize",
                      type: "integer"
                    },
                    StartTime: {
                      locationName: "startTime",
                      type: "timestamp"
                    },
                    Progress: {
                      locationName: "progress"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    SnapshotId: {
                      locationName: "snapshotId"
                    },
                    OutpostArn: {
                      locationName: "outpostArn"
                    }
                  }
                }
              }
            }
          }
        },
        CreateSpotDatafeedSubscription: {
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                locationName: "bucket"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Prefix: {
                locationName: "prefix"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SpotDatafeedSubscription: {
                shape: "Shh",
                locationName: "spotDatafeedSubscription"
              }
            }
          }
        },
        CreateStoreImageTask: {
          input: {
            type: "structure",
            required: [
              "ImageId",
              "Bucket"
            ],
            members: {
              ImageId: {},
              Bucket: {},
              S3ObjectTags: {
                locationName: "S3ObjectTag",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Key: {},
                    Value: {}
                  }
                }
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectKey: {
                locationName: "objectKey"
              }
            }
          }
        },
        CreateSubnet: {
          input: {
            type: "structure",
            required: [
              "CidrBlock",
              "VpcId"
            ],
            members: {
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              AvailabilityZone: {},
              AvailabilityZoneId: {},
              CidrBlock: {},
              Ipv6CidrBlock: {},
              OutpostArn: {},
              VpcId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Subnet: {
                shape: "S8z",
                locationName: "subnet"
              }
            }
          }
        },
        CreateSubnetCidrReservation: {
          input: {
            type: "structure",
            required: [
              "SubnetId",
              "Cidr",
              "ReservationType"
            ],
            members: {
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              SubnetId: {},
              Cidr: {},
              ReservationType: {},
              Description: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SubnetCidrReservation: {
                shape: "Sht",
                locationName: "subnetCidrReservation"
              }
            }
          }
        },
        CreateTags: {
          input: {
            type: "structure",
            required: [
              "Resources",
              "Tags"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Resources: {
                shape: "Shw",
                locationName: "ResourceId"
              },
              Tags: {
                shape: "Ss",
                locationName: "Tag"
              }
            }
          }
        },
        CreateTrafficMirrorFilter: {
          input: {
            type: "structure",
            members: {
              Description: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorFilter: {
                shape: "Si0",
                locationName: "trafficMirrorFilter"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        CreateTrafficMirrorFilterRule: {
          input: {
            type: "structure",
            required: [
              "TrafficMirrorFilterId",
              "TrafficDirection",
              "RuleNumber",
              "RuleAction",
              "DestinationCidrBlock",
              "SourceCidrBlock"
            ],
            members: {
              TrafficMirrorFilterId: {},
              TrafficDirection: {},
              RuleNumber: {
                type: "integer"
              },
              RuleAction: {},
              DestinationPortRange: {
                shape: "Sia"
              },
              SourcePortRange: {
                shape: "Sia"
              },
              Protocol: {
                type: "integer"
              },
              DestinationCidrBlock: {},
              SourceCidrBlock: {},
              Description: {},
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorFilterRule: {
                shape: "Si2",
                locationName: "trafficMirrorFilterRule"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        CreateTrafficMirrorSession: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfaceId",
              "TrafficMirrorTargetId",
              "TrafficMirrorFilterId",
              "SessionNumber"
            ],
            members: {
              NetworkInterfaceId: {},
              TrafficMirrorTargetId: {},
              TrafficMirrorFilterId: {},
              PacketLength: {
                type: "integer"
              },
              SessionNumber: {
                type: "integer"
              },
              VirtualNetworkId: {
                type: "integer"
              },
              Description: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorSession: {
                shape: "Sif",
                locationName: "trafficMirrorSession"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        CreateTrafficMirrorTarget: {
          input: {
            type: "structure",
            members: {
              NetworkInterfaceId: {},
              NetworkLoadBalancerArn: {},
              Description: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorTarget: {
                shape: "Sii",
                locationName: "trafficMirrorTarget"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        CreateTransitGateway: {
          input: {
            type: "structure",
            members: {
              Description: {},
              Options: {
                type: "structure",
                members: {
                  AmazonSideAsn: {
                    type: "long"
                  },
                  AutoAcceptSharedAttachments: {},
                  DefaultRouteTableAssociation: {},
                  DefaultRouteTablePropagation: {},
                  VpnEcmpSupport: {},
                  DnsSupport: {},
                  MulticastSupport: {},
                  TransitGatewayCidrBlocks: {
                    shape: "Sir"
                  }
                }
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGateway: {
                shape: "Sit",
                locationName: "transitGateway"
              }
            }
          }
        },
        CreateTransitGatewayConnect: {
          input: {
            type: "structure",
            required: [
              "TransportTransitGatewayAttachmentId",
              "Options"
            ],
            members: {
              TransportTransitGatewayAttachmentId: {},
              Options: {
                type: "structure",
                required: [
                  "Protocol"
                ],
                members: {
                  Protocol: {}
                }
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayConnect: {
                shape: "Sj0",
                locationName: "transitGatewayConnect"
              }
            }
          }
        },
        CreateTransitGatewayConnectPeer: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayAttachmentId",
              "PeerAddress",
              "InsideCidrBlocks"
            ],
            members: {
              TransitGatewayAttachmentId: {},
              TransitGatewayAddress: {},
              PeerAddress: {},
              BgpOptions: {
                type: "structure",
                members: {
                  PeerAsn: {
                    type: "long"
                  }
                }
              },
              InsideCidrBlocks: {
                shape: "Sj4"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayConnectPeer: {
                shape: "Sj6",
                locationName: "transitGatewayConnectPeer"
              }
            }
          }
        },
        CreateTransitGatewayMulticastDomain: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayId"
            ],
            members: {
              TransitGatewayId: {},
              Options: {
                type: "structure",
                members: {
                  Igmpv2Support: {},
                  StaticSourcesSupport: {},
                  AutoAcceptSharedAssociations: {}
                }
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomain: {
                shape: "Sjj",
                locationName: "transitGatewayMulticastDomain"
              }
            }
          }
        },
        CreateTransitGatewayPeeringAttachment: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayId",
              "PeerTransitGatewayId",
              "PeerAccountId",
              "PeerRegion"
            ],
            members: {
              TransitGatewayId: {},
              PeerTransitGatewayId: {},
              PeerAccountId: {},
              PeerRegion: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPeeringAttachment: {
                shape: "Sn",
                locationName: "transitGatewayPeeringAttachment"
              }
            }
          }
        },
        CreateTransitGatewayPrefixListReference: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId",
              "PrefixListId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              PrefixListId: {},
              TransitGatewayAttachmentId: {},
              Blackhole: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPrefixListReference: {
                shape: "Sjr",
                locationName: "transitGatewayPrefixListReference"
              }
            }
          }
        },
        CreateTransitGatewayRoute: {
          input: {
            type: "structure",
            required: [
              "DestinationCidrBlock",
              "TransitGatewayRouteTableId"
            ],
            members: {
              DestinationCidrBlock: {},
              TransitGatewayRouteTableId: {},
              TransitGatewayAttachmentId: {},
              Blackhole: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Route: {
                shape: "Sjw",
                locationName: "route"
              }
            }
          }
        },
        CreateTransitGatewayRouteTable: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayId"
            ],
            members: {
              TransitGatewayId: {},
              TagSpecifications: {
                shape: "S1t"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayRouteTable: {
                shape: "Sk3",
                locationName: "transitGatewayRouteTable"
              }
            }
          }
        },
        CreateTransitGatewayVpcAttachment: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayId",
              "VpcId",
              "SubnetIds"
            ],
            members: {
              TransitGatewayId: {},
              VpcId: {},
              SubnetIds: {
                shape: "S3w"
              },
              Options: {
                type: "structure",
                members: {
                  DnsSupport: {},
                  Ipv6Support: {},
                  ApplianceModeSupport: {}
                }
              },
              TagSpecifications: {
                shape: "S1t"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayVpcAttachment: {
                shape: "Sw",
                locationName: "transitGatewayVpcAttachment"
              }
            }
          }
        },
        CreateVolume: {
          input: {
            type: "structure",
            required: [
              "AvailabilityZone"
            ],
            members: {
              AvailabilityZone: {},
              Encrypted: {
                locationName: "encrypted",
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              KmsKeyId: {},
              OutpostArn: {},
              Size: {
                type: "integer"
              },
              SnapshotId: {},
              VolumeType: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              MultiAttachEnabled: {
                type: "boolean"
              },
              Throughput: {
                type: "integer"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            shape: "Sk9"
          }
        },
        CreateVpc: {
          input: {
            type: "structure",
            required: [
              "CidrBlock"
            ],
            members: {
              CidrBlock: {},
              AmazonProvidedIpv6CidrBlock: {
                locationName: "amazonProvidedIpv6CidrBlock",
                type: "boolean"
              },
              Ipv6Pool: {},
              Ipv6CidrBlock: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InstanceTenancy: {
                locationName: "instanceTenancy"
              },
              Ipv6CidrBlockNetworkBorderGroup: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Vpc: {
                shape: "S95",
                locationName: "vpc"
              }
            }
          }
        },
        CreateVpcEndpoint: {
          input: {
            type: "structure",
            required: [
              "VpcId",
              "ServiceName"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              VpcEndpointType: {},
              VpcId: {},
              ServiceName: {},
              PolicyDocument: {},
              RouteTableIds: {
                shape: "Skg",
                locationName: "RouteTableId"
              },
              SubnetIds: {
                shape: "Skh",
                locationName: "SubnetId"
              },
              SecurityGroupIds: {
                shape: "Ski",
                locationName: "SecurityGroupId"
              },
              ClientToken: {},
              PrivateDnsEnabled: {
                type: "boolean"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpcEndpoint: {
                shape: "Skk",
                locationName: "vpcEndpoint"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        CreateVpcEndpointConnectionNotification: {
          input: {
            type: "structure",
            required: [
              "ConnectionNotificationArn",
              "ConnectionEvents"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceId: {},
              VpcEndpointId: {},
              ConnectionNotificationArn: {},
              ConnectionEvents: {
                shape: "Se"
              },
              ClientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionNotification: {
                shape: "Skt",
                locationName: "connectionNotification"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        CreateVpcEndpointServiceConfiguration: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              AcceptanceRequired: {
                type: "boolean"
              },
              PrivateDnsName: {},
              NetworkLoadBalancerArns: {
                shape: "Se",
                locationName: "NetworkLoadBalancerArn"
              },
              GatewayLoadBalancerArns: {
                shape: "Se",
                locationName: "GatewayLoadBalancerArn"
              },
              ClientToken: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceConfiguration: {
                shape: "Sky",
                locationName: "serviceConfiguration"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        CreateVpcPeeringConnection: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              PeerOwnerId: {
                locationName: "peerOwnerId"
              },
              PeerVpcId: {
                locationName: "peerVpcId"
              },
              VpcId: {
                locationName: "vpcId"
              },
              PeerRegion: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpcPeeringConnection: {
                shape: "S1c",
                locationName: "vpcPeeringConnection"
              }
            }
          }
        },
        CreateVpnConnection: {
          input: {
            type: "structure",
            required: [
              "CustomerGatewayId",
              "Type"
            ],
            members: {
              CustomerGatewayId: {},
              Type: {},
              VpnGatewayId: {},
              TransitGatewayId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Options: {
                locationName: "options",
                type: "structure",
                members: {
                  EnableAcceleration: {
                    type: "boolean"
                  },
                  StaticRoutesOnly: {
                    locationName: "staticRoutesOnly",
                    type: "boolean"
                  },
                  TunnelInsideIpVersion: {},
                  TunnelOptions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        TunnelInsideCidr: {},
                        TunnelInsideIpv6Cidr: {},
                        PreSharedKey: {},
                        Phase1LifetimeSeconds: {
                          type: "integer"
                        },
                        Phase2LifetimeSeconds: {
                          type: "integer"
                        },
                        RekeyMarginTimeSeconds: {
                          type: "integer"
                        },
                        RekeyFuzzPercentage: {
                          type: "integer"
                        },
                        ReplayWindowSize: {
                          type: "integer"
                        },
                        DPDTimeoutSeconds: {
                          type: "integer"
                        },
                        DPDTimeoutAction: {},
                        Phase1EncryptionAlgorithms: {
                          shape: "Sld",
                          locationName: "Phase1EncryptionAlgorithm"
                        },
                        Phase2EncryptionAlgorithms: {
                          shape: "Slf",
                          locationName: "Phase2EncryptionAlgorithm"
                        },
                        Phase1IntegrityAlgorithms: {
                          shape: "Slh",
                          locationName: "Phase1IntegrityAlgorithm"
                        },
                        Phase2IntegrityAlgorithms: {
                          shape: "Slj",
                          locationName: "Phase2IntegrityAlgorithm"
                        },
                        Phase1DHGroupNumbers: {
                          shape: "Sll",
                          locationName: "Phase1DHGroupNumber"
                        },
                        Phase2DHGroupNumbers: {
                          shape: "Sln",
                          locationName: "Phase2DHGroupNumber"
                        },
                        IKEVersions: {
                          shape: "Slp",
                          locationName: "IKEVersion"
                        },
                        StartupAction: {}
                      }
                    }
                  },
                  LocalIpv4NetworkCidr: {},
                  RemoteIpv4NetworkCidr: {},
                  LocalIpv6NetworkCidr: {},
                  RemoteIpv6NetworkCidr: {}
                }
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnConnection: {
                shape: "Sls",
                locationName: "vpnConnection"
              }
            }
          }
        },
        CreateVpnConnectionRoute: {
          input: {
            type: "structure",
            required: [
              "DestinationCidrBlock",
              "VpnConnectionId"
            ],
            members: {
              DestinationCidrBlock: {},
              VpnConnectionId: {}
            }
          }
        },
        CreateVpnGateway: {
          input: {
            type: "structure",
            required: [
              "Type"
            ],
            members: {
              AvailabilityZone: {},
              Type: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              AmazonSideAsn: {
                type: "long"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnGateway: {
                shape: "Sml",
                locationName: "vpnGateway"
              }
            }
          }
        },
        DeleteCarrierGateway: {
          input: {
            type: "structure",
            required: [
              "CarrierGatewayId"
            ],
            members: {
              CarrierGatewayId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CarrierGateway: {
                shape: "S88",
                locationName: "carrierGateway"
              }
            }
          }
        },
        DeleteClientVpnEndpoint: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId"
            ],
            members: {
              ClientVpnEndpointId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                shape: "S8n",
                locationName: "status"
              }
            }
          }
        },
        DeleteClientVpnRoute: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId",
              "DestinationCidrBlock"
            ],
            members: {
              ClientVpnEndpointId: {},
              TargetVpcSubnetId: {},
              DestinationCidrBlock: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                shape: "S8r",
                locationName: "status"
              }
            }
          }
        },
        DeleteCustomerGateway: {
          input: {
            type: "structure",
            required: [
              "CustomerGatewayId"
            ],
            members: {
              CustomerGatewayId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeleteDhcpOptions: {
          input: {
            type: "structure",
            required: [
              "DhcpOptionsId"
            ],
            members: {
              DhcpOptionsId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeleteEgressOnlyInternetGateway: {
          input: {
            type: "structure",
            required: [
              "EgressOnlyInternetGatewayId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              EgressOnlyInternetGatewayId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReturnCode: {
                locationName: "returnCode",
                type: "boolean"
              }
            }
          }
        },
        DeleteFleets: {
          input: {
            type: "structure",
            required: [
              "FleetIds",
              "TerminateInstances"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              FleetIds: {
                shape: "Smz",
                locationName: "FleetId"
              },
              TerminateInstances: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuccessfulFleetDeletions: {
                locationName: "successfulFleetDeletionSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CurrentFleetState: {
                      locationName: "currentFleetState"
                    },
                    PreviousFleetState: {
                      locationName: "previousFleetState"
                    },
                    FleetId: {
                      locationName: "fleetId"
                    }
                  }
                }
              },
              UnsuccessfulFleetDeletions: {
                locationName: "unsuccessfulFleetDeletionSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Error: {
                      locationName: "error",
                      type: "structure",
                      members: {
                        Code: {
                          locationName: "code"
                        },
                        Message: {
                          locationName: "message"
                        }
                      }
                    },
                    FleetId: {
                      locationName: "fleetId"
                    }
                  }
                }
              }
            }
          }
        },
        DeleteFlowLogs: {
          input: {
            type: "structure",
            required: [
              "FlowLogIds"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              FlowLogIds: {
                shape: "Sn9",
                locationName: "FlowLogId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Unsuccessful: {
                shape: "S16",
                locationName: "unsuccessful"
              }
            }
          }
        },
        DeleteFpgaImage: {
          input: {
            type: "structure",
            required: [
              "FpgaImageId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              FpgaImageId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        DeleteInstanceEventWindow: {
          input: {
            type: "structure",
            required: [
              "InstanceEventWindowId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ForceDelete: {
                type: "boolean"
              },
              InstanceEventWindowId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceEventWindowState: {
                locationName: "instanceEventWindowState",
                type: "structure",
                members: {
                  InstanceEventWindowId: {
                    locationName: "instanceEventWindowId"
                  },
                  State: {
                    locationName: "state"
                  }
                }
              }
            }
          }
        },
        DeleteInternetGateway: {
          input: {
            type: "structure",
            required: [
              "InternetGatewayId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InternetGatewayId: {
                locationName: "internetGatewayId"
              }
            }
          }
        },
        DeleteKeyPair: {
          input: {
            type: "structure",
            members: {
              KeyName: {},
              KeyPairId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeleteLaunchTemplate: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              LaunchTemplateId: {},
              LaunchTemplateName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LaunchTemplate: {
                shape: "Sda",
                locationName: "launchTemplate"
              }
            }
          }
        },
        DeleteLaunchTemplateVersions: {
          input: {
            type: "structure",
            required: [
              "Versions"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              LaunchTemplateId: {},
              LaunchTemplateName: {},
              Versions: {
                shape: "Sno",
                locationName: "LaunchTemplateVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuccessfullyDeletedLaunchTemplateVersions: {
                locationName: "successfullyDeletedLaunchTemplateVersionSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    LaunchTemplateId: {
                      locationName: "launchTemplateId"
                    },
                    LaunchTemplateName: {
                      locationName: "launchTemplateName"
                    },
                    VersionNumber: {
                      locationName: "versionNumber",
                      type: "long"
                    }
                  }
                }
              },
              UnsuccessfullyDeletedLaunchTemplateVersions: {
                locationName: "unsuccessfullyDeletedLaunchTemplateVersionSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    LaunchTemplateId: {
                      locationName: "launchTemplateId"
                    },
                    LaunchTemplateName: {
                      locationName: "launchTemplateName"
                    },
                    VersionNumber: {
                      locationName: "versionNumber",
                      type: "long"
                    },
                    ResponseError: {
                      locationName: "responseError",
                      type: "structure",
                      members: {
                        Code: {
                          locationName: "code"
                        },
                        Message: {
                          locationName: "message"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DeleteLocalGatewayRoute: {
          input: {
            type: "structure",
            required: [
              "DestinationCidrBlock",
              "LocalGatewayRouteTableId"
            ],
            members: {
              DestinationCidrBlock: {},
              LocalGatewayRouteTableId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Route: {
                shape: "Sei",
                locationName: "route"
              }
            }
          }
        },
        DeleteLocalGatewayRouteTableVpcAssociation: {
          input: {
            type: "structure",
            required: [
              "LocalGatewayRouteTableVpcAssociationId"
            ],
            members: {
              LocalGatewayRouteTableVpcAssociationId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalGatewayRouteTableVpcAssociation: {
                shape: "Sen",
                locationName: "localGatewayRouteTableVpcAssociation"
              }
            }
          }
        },
        DeleteManagedPrefixList: {
          input: {
            type: "structure",
            required: [
              "PrefixListId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              PrefixListId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PrefixList: {
                shape: "Set",
                locationName: "prefixList"
              }
            }
          }
        },
        DeleteNatGateway: {
          input: {
            type: "structure",
            required: [
              "NatGatewayId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              NatGatewayId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NatGatewayId: {
                locationName: "natGatewayId"
              }
            }
          }
        },
        DeleteNetworkAcl: {
          input: {
            type: "structure",
            required: [
              "NetworkAclId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NetworkAclId: {
                locationName: "networkAclId"
              }
            }
          }
        },
        DeleteNetworkAclEntry: {
          input: {
            type: "structure",
            required: [
              "Egress",
              "NetworkAclId",
              "RuleNumber"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Egress: {
                locationName: "egress",
                type: "boolean"
              },
              NetworkAclId: {
                locationName: "networkAclId"
              },
              RuleNumber: {
                locationName: "ruleNumber",
                type: "integer"
              }
            }
          }
        },
        DeleteNetworkInsightsAnalysis: {
          input: {
            type: "structure",
            required: [
              "NetworkInsightsAnalysisId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              NetworkInsightsAnalysisId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInsightsAnalysisId: {
                locationName: "networkInsightsAnalysisId"
              }
            }
          }
        },
        DeleteNetworkInsightsPath: {
          input: {
            type: "structure",
            required: [
              "NetworkInsightsPathId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              NetworkInsightsPathId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInsightsPathId: {
                locationName: "networkInsightsPathId"
              }
            }
          }
        },
        DeleteNetworkInterface: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfaceId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              }
            }
          }
        },
        DeleteNetworkInterfacePermission: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfacePermissionId"
            ],
            members: {
              NetworkInterfacePermissionId: {},
              Force: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        DeletePlacementGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              GroupName: {
                locationName: "groupName"
              }
            }
          }
        },
        DeleteQueuedReservedInstances: {
          input: {
            type: "structure",
            required: [
              "ReservedInstancesIds"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ReservedInstancesIds: {
                locationName: "ReservedInstancesId",
                type: "list",
                member: {
                  locationName: "item"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuccessfulQueuedPurchaseDeletions: {
                locationName: "successfulQueuedPurchaseDeletionSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ReservedInstancesId: {
                      locationName: "reservedInstancesId"
                    }
                  }
                }
              },
              FailedQueuedPurchaseDeletions: {
                locationName: "failedQueuedPurchaseDeletionSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Error: {
                      locationName: "error",
                      type: "structure",
                      members: {
                        Code: {
                          locationName: "code"
                        },
                        Message: {
                          locationName: "message"
                        }
                      }
                    },
                    ReservedInstancesId: {
                      locationName: "reservedInstancesId"
                    }
                  }
                }
              }
            }
          }
        },
        DeleteRoute: {
          input: {
            type: "structure",
            required: [
              "RouteTableId"
            ],
            members: {
              DestinationCidrBlock: {
                locationName: "destinationCidrBlock"
              },
              DestinationIpv6CidrBlock: {
                locationName: "destinationIpv6CidrBlock"
              },
              DestinationPrefixListId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              RouteTableId: {
                locationName: "routeTableId"
              }
            }
          }
        },
        DeleteRouteTable: {
          input: {
            type: "structure",
            required: [
              "RouteTableId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              RouteTableId: {
                locationName: "routeTableId"
              }
            }
          }
        },
        DeleteSecurityGroup: {
          input: {
            type: "structure",
            members: {
              GroupId: {},
              GroupName: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeleteSnapshot: {
          input: {
            type: "structure",
            required: [
              "SnapshotId"
            ],
            members: {
              SnapshotId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeleteSpotDatafeedSubscription: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeleteSubnet: {
          input: {
            type: "structure",
            required: [
              "SubnetId"
            ],
            members: {
              SubnetId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeleteSubnetCidrReservation: {
          input: {
            type: "structure",
            required: [
              "SubnetCidrReservationId"
            ],
            members: {
              SubnetCidrReservationId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeletedSubnetCidrReservation: {
                shape: "Sht",
                locationName: "deletedSubnetCidrReservation"
              }
            }
          }
        },
        DeleteTags: {
          input: {
            type: "structure",
            required: [
              "Resources"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Resources: {
                shape: "Shw",
                locationName: "resourceId"
              },
              Tags: {
                shape: "Ss",
                locationName: "tag"
              }
            }
          }
        },
        DeleteTrafficMirrorFilter: {
          input: {
            type: "structure",
            required: [
              "TrafficMirrorFilterId"
            ],
            members: {
              TrafficMirrorFilterId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorFilterId: {
                locationName: "trafficMirrorFilterId"
              }
            }
          }
        },
        DeleteTrafficMirrorFilterRule: {
          input: {
            type: "structure",
            required: [
              "TrafficMirrorFilterRuleId"
            ],
            members: {
              TrafficMirrorFilterRuleId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorFilterRuleId: {
                locationName: "trafficMirrorFilterRuleId"
              }
            }
          }
        },
        DeleteTrafficMirrorSession: {
          input: {
            type: "structure",
            required: [
              "TrafficMirrorSessionId"
            ],
            members: {
              TrafficMirrorSessionId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorSessionId: {
                locationName: "trafficMirrorSessionId"
              }
            }
          }
        },
        DeleteTrafficMirrorTarget: {
          input: {
            type: "structure",
            required: [
              "TrafficMirrorTargetId"
            ],
            members: {
              TrafficMirrorTargetId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorTargetId: {
                locationName: "trafficMirrorTargetId"
              }
            }
          }
        },
        DeleteTransitGateway: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayId"
            ],
            members: {
              TransitGatewayId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGateway: {
                shape: "Sit",
                locationName: "transitGateway"
              }
            }
          }
        },
        DeleteTransitGatewayConnect: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayConnect: {
                shape: "Sj0",
                locationName: "transitGatewayConnect"
              }
            }
          }
        },
        DeleteTransitGatewayConnectPeer: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayConnectPeerId"
            ],
            members: {
              TransitGatewayConnectPeerId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayConnectPeer: {
                shape: "Sj6",
                locationName: "transitGatewayConnectPeer"
              }
            }
          }
        },
        DeleteTransitGatewayMulticastDomain: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayMulticastDomainId"
            ],
            members: {
              TransitGatewayMulticastDomainId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomain: {
                shape: "Sjj",
                locationName: "transitGatewayMulticastDomain"
              }
            }
          }
        },
        DeleteTransitGatewayPeeringAttachment: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPeeringAttachment: {
                shape: "Sn",
                locationName: "transitGatewayPeeringAttachment"
              }
            }
          }
        },
        DeleteTransitGatewayPrefixListReference: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId",
              "PrefixListId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              PrefixListId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPrefixListReference: {
                shape: "Sjr",
                locationName: "transitGatewayPrefixListReference"
              }
            }
          }
        },
        DeleteTransitGatewayRoute: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId",
              "DestinationCidrBlock"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              DestinationCidrBlock: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Route: {
                shape: "Sjw",
                locationName: "route"
              }
            }
          }
        },
        DeleteTransitGatewayRouteTable: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayRouteTable: {
                shape: "Sk3",
                locationName: "transitGatewayRouteTable"
              }
            }
          }
        },
        DeleteTransitGatewayVpcAttachment: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayVpcAttachment: {
                shape: "Sw",
                locationName: "transitGatewayVpcAttachment"
              }
            }
          }
        },
        DeleteVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              VolumeId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeleteVpc: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              VpcId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeleteVpcEndpointConnectionNotifications: {
          input: {
            type: "structure",
            required: [
              "ConnectionNotificationIds"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ConnectionNotificationIds: {
                locationName: "ConnectionNotificationId",
                type: "list",
                member: {
                  locationName: "item"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Unsuccessful: {
                shape: "S16",
                locationName: "unsuccessful"
              }
            }
          }
        },
        DeleteVpcEndpointServiceConfigurations: {
          input: {
            type: "structure",
            required: [
              "ServiceIds"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceIds: {
                shape: "Spx",
                locationName: "ServiceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Unsuccessful: {
                shape: "S16",
                locationName: "unsuccessful"
              }
            }
          }
        },
        DeleteVpcEndpoints: {
          input: {
            type: "structure",
            required: [
              "VpcEndpointIds"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              VpcEndpointIds: {
                shape: "S13",
                locationName: "VpcEndpointId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Unsuccessful: {
                shape: "S16",
                locationName: "unsuccessful"
              }
            }
          }
        },
        DeleteVpcPeeringConnection: {
          input: {
            type: "structure",
            required: [
              "VpcPeeringConnectionId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcPeeringConnectionId: {
                locationName: "vpcPeeringConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        DeleteVpnConnection: {
          input: {
            type: "structure",
            required: [
              "VpnConnectionId"
            ],
            members: {
              VpnConnectionId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeleteVpnConnectionRoute: {
          input: {
            type: "structure",
            required: [
              "DestinationCidrBlock",
              "VpnConnectionId"
            ],
            members: {
              DestinationCidrBlock: {},
              VpnConnectionId: {}
            }
          }
        },
        DeleteVpnGateway: {
          input: {
            type: "structure",
            required: [
              "VpnGatewayId"
            ],
            members: {
              VpnGatewayId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeprovisionByoipCidr: {
          input: {
            type: "structure",
            required: [
              "Cidr"
            ],
            members: {
              Cidr: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidr: {
                shape: "S1n",
                locationName: "byoipCidr"
              }
            }
          }
        },
        DeregisterImage: {
          input: {
            type: "structure",
            required: [
              "ImageId"
            ],
            members: {
              ImageId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DeregisterInstanceEventNotificationAttributes: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceTagAttribute: {
                type: "structure",
                members: {
                  IncludeAllTagsOfInstance: {
                    type: "boolean"
                  },
                  InstanceTagKeys: {
                    shape: "Sqb",
                    locationName: "InstanceTagKey"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceTagAttribute: {
                shape: "Sqd",
                locationName: "instanceTagAttribute"
              }
            }
          }
        },
        DeregisterTransitGatewayMulticastGroupMembers: {
          input: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomainId: {},
              GroupIpAddress: {},
              NetworkInterfaceIds: {
                shape: "Sqf"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeregisteredMulticastGroupMembers: {
                locationName: "deregisteredMulticastGroupMembers",
                type: "structure",
                members: {
                  TransitGatewayMulticastDomainId: {
                    locationName: "transitGatewayMulticastDomainId"
                  },
                  DeregisteredNetworkInterfaceIds: {
                    shape: "Se",
                    locationName: "deregisteredNetworkInterfaceIds"
                  },
                  GroupIpAddress: {
                    locationName: "groupIpAddress"
                  }
                }
              }
            }
          }
        },
        DeregisterTransitGatewayMulticastGroupSources: {
          input: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomainId: {},
              GroupIpAddress: {},
              NetworkInterfaceIds: {
                shape: "Sqf"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeregisteredMulticastGroupSources: {
                locationName: "deregisteredMulticastGroupSources",
                type: "structure",
                members: {
                  TransitGatewayMulticastDomainId: {
                    locationName: "transitGatewayMulticastDomainId"
                  },
                  DeregisteredNetworkInterfaceIds: {
                    shape: "Se",
                    locationName: "deregisteredNetworkInterfaceIds"
                  },
                  GroupIpAddress: {
                    locationName: "groupIpAddress"
                  }
                }
              }
            }
          }
        },
        DescribeAccountAttributes: {
          input: {
            type: "structure",
            members: {
              AttributeNames: {
                locationName: "attributeName",
                type: "list",
                member: {
                  locationName: "attributeName"
                }
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccountAttributes: {
                locationName: "accountAttributeSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AttributeName: {
                      locationName: "attributeName"
                    },
                    AttributeValues: {
                      locationName: "attributeValueSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          AttributeValue: {
                            locationName: "attributeValue"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeAddresses: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              PublicIps: {
                locationName: "PublicIp",
                type: "list",
                member: {
                  locationName: "PublicIp"
                }
              },
              AllocationIds: {
                locationName: "AllocationId",
                type: "list",
                member: {
                  locationName: "AllocationId"
                }
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Addresses: {
                locationName: "addressesSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceId: {
                      locationName: "instanceId"
                    },
                    PublicIp: {
                      locationName: "publicIp"
                    },
                    AllocationId: {
                      locationName: "allocationId"
                    },
                    AssociationId: {
                      locationName: "associationId"
                    },
                    Domain: {
                      locationName: "domain"
                    },
                    NetworkInterfaceId: {
                      locationName: "networkInterfaceId"
                    },
                    NetworkInterfaceOwnerId: {
                      locationName: "networkInterfaceOwnerId"
                    },
                    PrivateIpAddress: {
                      locationName: "privateIpAddress"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    },
                    PublicIpv4Pool: {
                      locationName: "publicIpv4Pool"
                    },
                    NetworkBorderGroup: {
                      locationName: "networkBorderGroup"
                    },
                    CustomerOwnedIp: {
                      locationName: "customerOwnedIp"
                    },
                    CustomerOwnedIpv4Pool: {
                      locationName: "customerOwnedIpv4Pool"
                    },
                    CarrierIp: {
                      locationName: "carrierIp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeAddressesAttribute: {
          input: {
            type: "structure",
            members: {
              AllocationIds: {
                locationName: "AllocationId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Attribute: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Addresses: {
                locationName: "addressSet",
                type: "list",
                member: {
                  shape: "Sr8",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeAggregateIdFormat: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UseLongIdsAggregated: {
                locationName: "useLongIdsAggregated",
                type: "boolean"
              },
              Statuses: {
                shape: "Src",
                locationName: "statusSet"
              }
            }
          }
        },
        DescribeAvailabilityZones: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              ZoneNames: {
                locationName: "ZoneName",
                type: "list",
                member: {
                  locationName: "ZoneName"
                }
              },
              ZoneIds: {
                locationName: "ZoneId",
                type: "list",
                member: {
                  locationName: "ZoneId"
                }
              },
              AllAvailabilityZones: {
                type: "boolean"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AvailabilityZones: {
                locationName: "availabilityZoneInfo",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    State: {
                      locationName: "zoneState"
                    },
                    OptInStatus: {
                      locationName: "optInStatus"
                    },
                    Messages: {
                      locationName: "messageSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          Message: {
                            locationName: "message"
                          }
                        }
                      }
                    },
                    RegionName: {
                      locationName: "regionName"
                    },
                    ZoneName: {
                      locationName: "zoneName"
                    },
                    ZoneId: {
                      locationName: "zoneId"
                    },
                    GroupName: {
                      locationName: "groupName"
                    },
                    NetworkBorderGroup: {
                      locationName: "networkBorderGroup"
                    },
                    ZoneType: {
                      locationName: "zoneType"
                    },
                    ParentZoneName: {
                      locationName: "parentZoneName"
                    },
                    ParentZoneId: {
                      locationName: "parentZoneId"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeBundleTasks: {
          input: {
            type: "structure",
            members: {
              BundleIds: {
                locationName: "BundleId",
                type: "list",
                member: {
                  locationName: "BundleId"
                }
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BundleTasks: {
                locationName: "bundleInstanceTasksSet",
                type: "list",
                member: {
                  shape: "S5o",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribeByoipCidrs: {
          input: {
            type: "structure",
            required: [
              "MaxResults"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidrs: {
                locationName: "byoipCidrSet",
                type: "list",
                member: {
                  shape: "S1n",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeCapacityReservationFleets: {
          input: {
            type: "structure",
            members: {
              CapacityReservationFleetIds: {
                shape: "S5y",
                locationName: "CapacityReservationFleetId"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CapacityReservationFleets: {
                locationName: "capacityReservationFleetSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CapacityReservationFleetId: {
                      locationName: "capacityReservationFleetId"
                    },
                    CapacityReservationFleetArn: {
                      locationName: "capacityReservationFleetArn"
                    },
                    State: {
                      locationName: "state"
                    },
                    TotalTargetCapacity: {
                      locationName: "totalTargetCapacity",
                      type: "integer"
                    },
                    TotalFulfilledCapacity: {
                      locationName: "totalFulfilledCapacity",
                      type: "double"
                    },
                    Tenancy: {
                      locationName: "tenancy"
                    },
                    EndDate: {
                      locationName: "endDate",
                      type: "timestamp"
                    },
                    CreateTime: {
                      locationName: "createTime",
                      type: "timestamp"
                    },
                    InstanceMatchCriteria: {
                      locationName: "instanceMatchCriteria"
                    },
                    AllocationStrategy: {
                      locationName: "allocationStrategy"
                    },
                    InstanceTypeSpecifications: {
                      shape: "S84",
                      locationName: "instanceTypeSpecificationSet"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeCapacityReservations: {
          input: {
            type: "structure",
            members: {
              CapacityReservationIds: {
                locationName: "CapacityReservationId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              CapacityReservations: {
                locationName: "capacityReservationSet",
                type: "list",
                member: {
                  shape: "S7s",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribeCarrierGateways: {
          input: {
            type: "structure",
            members: {
              CarrierGatewayIds: {
                locationName: "CarrierGatewayId",
                type: "list",
                member: {}
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CarrierGateways: {
                locationName: "carrierGatewaySet",
                type: "list",
                member: {
                  shape: "S88",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeClassicLinkInstances: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InstanceIds: {
                shape: "Ssc",
                locationName: "InstanceId"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Instances: {
                locationName: "instancesSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Groups: {
                      shape: "Sfs",
                      locationName: "groupSet"
                    },
                    InstanceId: {
                      locationName: "instanceId"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    },
                    VpcId: {
                      locationName: "vpcId"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeClientVpnAuthorizationRules: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId"
            ],
            members: {
              ClientVpnEndpointId: {},
              DryRun: {
                type: "boolean"
              },
              NextToken: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AuthorizationRules: {
                locationName: "authorizationRule",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ClientVpnEndpointId: {
                      locationName: "clientVpnEndpointId"
                    },
                    Description: {
                      locationName: "description"
                    },
                    GroupId: {
                      locationName: "groupId"
                    },
                    AccessAll: {
                      locationName: "accessAll",
                      type: "boolean"
                    },
                    DestinationCidr: {
                      locationName: "destinationCidr"
                    },
                    Status: {
                      shape: "S4x",
                      locationName: "status"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeClientVpnConnections: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId"
            ],
            members: {
              ClientVpnEndpointId: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connections: {
                locationName: "connections",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ClientVpnEndpointId: {
                      locationName: "clientVpnEndpointId"
                    },
                    Timestamp: {
                      locationName: "timestamp"
                    },
                    ConnectionId: {
                      locationName: "connectionId"
                    },
                    Username: {
                      locationName: "username"
                    },
                    ConnectionEstablishedTime: {
                      locationName: "connectionEstablishedTime"
                    },
                    IngressBytes: {
                      locationName: "ingressBytes"
                    },
                    EgressBytes: {
                      locationName: "egressBytes"
                    },
                    IngressPackets: {
                      locationName: "ingressPackets"
                    },
                    EgressPackets: {
                      locationName: "egressPackets"
                    },
                    ClientIp: {
                      locationName: "clientIp"
                    },
                    CommonName: {
                      locationName: "commonName"
                    },
                    Status: {
                      shape: "Ssr",
                      locationName: "status"
                    },
                    ConnectionEndTime: {
                      locationName: "connectionEndTime"
                    },
                    PostureComplianceStatuses: {
                      shape: "Se",
                      locationName: "postureComplianceStatusSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeClientVpnEndpoints: {
          input: {
            type: "structure",
            members: {
              ClientVpnEndpointIds: {
                locationName: "ClientVpnEndpointId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientVpnEndpoints: {
                locationName: "clientVpnEndpoint",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ClientVpnEndpointId: {
                      locationName: "clientVpnEndpointId"
                    },
                    Description: {
                      locationName: "description"
                    },
                    Status: {
                      shape: "S8n",
                      locationName: "status"
                    },
                    CreationTime: {
                      locationName: "creationTime"
                    },
                    DeletionTime: {
                      locationName: "deletionTime"
                    },
                    DnsName: {
                      locationName: "dnsName"
                    },
                    ClientCidrBlock: {
                      locationName: "clientCidrBlock"
                    },
                    DnsServers: {
                      shape: "Se",
                      locationName: "dnsServer"
                    },
                    SplitTunnel: {
                      locationName: "splitTunnel",
                      type: "boolean"
                    },
                    VpnProtocol: {
                      locationName: "vpnProtocol"
                    },
                    TransportProtocol: {
                      locationName: "transportProtocol"
                    },
                    VpnPort: {
                      locationName: "vpnPort",
                      type: "integer"
                    },
                    AssociatedTargetNetworks: {
                      deprecated: true,
                      deprecatedMessage: "This property is deprecated. To view the target networks associated with a Client VPN endpoint, call DescribeClientVpnTargetNetworks and inspect the clientVpnTargetNetworks response element.",
                      locationName: "associatedTargetNetwork",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          NetworkId: {
                            locationName: "networkId"
                          },
                          NetworkType: {
                            locationName: "networkType"
                          }
                        }
                      }
                    },
                    ServerCertificateArn: {
                      locationName: "serverCertificateArn"
                    },
                    AuthenticationOptions: {
                      locationName: "authenticationOptions",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          Type: {
                            locationName: "type"
                          },
                          ActiveDirectory: {
                            locationName: "activeDirectory",
                            type: "structure",
                            members: {
                              DirectoryId: {
                                locationName: "directoryId"
                              }
                            }
                          },
                          MutualAuthentication: {
                            locationName: "mutualAuthentication",
                            type: "structure",
                            members: {
                              ClientRootCertificateChain: {
                                locationName: "clientRootCertificateChain"
                              }
                            }
                          },
                          FederatedAuthentication: {
                            locationName: "federatedAuthentication",
                            type: "structure",
                            members: {
                              SamlProviderArn: {
                                locationName: "samlProviderArn"
                              },
                              SelfServiceSamlProviderArn: {
                                locationName: "selfServiceSamlProviderArn"
                              }
                            }
                          }
                        }
                      }
                    },
                    ConnectionLogOptions: {
                      locationName: "connectionLogOptions",
                      type: "structure",
                      members: {
                        Enabled: {
                          type: "boolean"
                        },
                        CloudwatchLogGroup: {},
                        CloudwatchLogStream: {}
                      }
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    },
                    SecurityGroupIds: {
                      shape: "S25",
                      locationName: "securityGroupIdSet"
                    },
                    VpcId: {
                      locationName: "vpcId"
                    },
                    SelfServicePortalUrl: {
                      locationName: "selfServicePortalUrl"
                    },
                    ClientConnectOptions: {
                      locationName: "clientConnectOptions",
                      type: "structure",
                      members: {
                        Enabled: {
                          locationName: "enabled",
                          type: "boolean"
                        },
                        LambdaFunctionArn: {
                          locationName: "lambdaFunctionArn"
                        },
                        Status: {
                          locationName: "status",
                          type: "structure",
                          members: {
                            Code: {
                              locationName: "code"
                            },
                            Message: {
                              locationName: "message"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeClientVpnRoutes: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId"
            ],
            members: {
              ClientVpnEndpointId: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Routes: {
                locationName: "routes",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ClientVpnEndpointId: {
                      locationName: "clientVpnEndpointId"
                    },
                    DestinationCidr: {
                      locationName: "destinationCidr"
                    },
                    TargetSubnet: {
                      locationName: "targetSubnet"
                    },
                    Type: {
                      locationName: "type"
                    },
                    Origin: {
                      locationName: "origin"
                    },
                    Status: {
                      shape: "S8r",
                      locationName: "status"
                    },
                    Description: {
                      locationName: "description"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeClientVpnTargetNetworks: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId"
            ],
            members: {
              ClientVpnEndpointId: {},
              AssociationIds: {
                shape: "Se"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientVpnTargetNetworks: {
                locationName: "clientVpnTargetNetworks",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AssociationId: {
                      locationName: "associationId"
                    },
                    VpcId: {
                      locationName: "vpcId"
                    },
                    TargetNetworkId: {
                      locationName: "targetNetworkId"
                    },
                    ClientVpnEndpointId: {
                      locationName: "clientVpnEndpointId"
                    },
                    Status: {
                      shape: "S2r",
                      locationName: "status"
                    },
                    SecurityGroups: {
                      shape: "Se",
                      locationName: "securityGroups"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeCoipPools: {
          input: {
            type: "structure",
            members: {
              PoolIds: {
                locationName: "PoolId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CoipPools: {
                locationName: "coipPoolSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    PoolId: {
                      locationName: "poolId"
                    },
                    PoolCidrs: {
                      shape: "Se",
                      locationName: "poolCidrSet"
                    },
                    LocalGatewayRouteTableId: {
                      locationName: "localGatewayRouteTableId"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    },
                    PoolArn: {
                      locationName: "poolArn"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeConversionTasks: {
          input: {
            type: "structure",
            members: {
              ConversionTaskIds: {
                locationName: "conversionTaskId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConversionTasks: {
                locationName: "conversionTasks",
                type: "list",
                member: {
                  shape: "Stw",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribeCustomerGateways: {
          input: {
            type: "structure",
            members: {
              CustomerGatewayIds: {
                locationName: "CustomerGatewayId",
                type: "list",
                member: {
                  locationName: "CustomerGatewayId"
                }
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CustomerGateways: {
                locationName: "customerGatewaySet",
                type: "list",
                member: {
                  shape: "S8w",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribeDhcpOptions: {
          input: {
            type: "structure",
            members: {
              DhcpOptionsIds: {
                locationName: "DhcpOptionsId",
                type: "list",
                member: {
                  locationName: "DhcpOptionsId"
                }
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DhcpOptions: {
                locationName: "dhcpOptionsSet",
                type: "list",
                member: {
                  shape: "S9e",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeEgressOnlyInternetGateways: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              EgressOnlyInternetGatewayIds: {
                locationName: "EgressOnlyInternetGatewayId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EgressOnlyInternetGateways: {
                locationName: "egressOnlyInternetGatewaySet",
                type: "list",
                member: {
                  shape: "S9l",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeElasticGpus: {
          input: {
            type: "structure",
            members: {
              ElasticGpuIds: {
                locationName: "ElasticGpuId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ElasticGpuSet: {
                locationName: "elasticGpuSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ElasticGpuId: {
                      locationName: "elasticGpuId"
                    },
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    ElasticGpuType: {
                      locationName: "elasticGpuType"
                    },
                    ElasticGpuHealth: {
                      locationName: "elasticGpuHealth",
                      type: "structure",
                      members: {
                        Status: {
                          locationName: "status"
                        }
                      }
                    },
                    ElasticGpuState: {
                      locationName: "elasticGpuState"
                    },
                    InstanceId: {
                      locationName: "instanceId"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeExportImageTasks: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              ExportImageTaskIds: {
                locationName: "ExportImageTaskId",
                type: "list",
                member: {
                  locationName: "ExportImageTaskId"
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExportImageTasks: {
                locationName: "exportImageTaskSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Description: {
                      locationName: "description"
                    },
                    ExportImageTaskId: {
                      locationName: "exportImageTaskId"
                    },
                    ImageId: {
                      locationName: "imageId"
                    },
                    Progress: {
                      locationName: "progress"
                    },
                    S3ExportLocation: {
                      shape: "Suz",
                      locationName: "s3ExportLocation"
                    },
                    Status: {
                      locationName: "status"
                    },
                    StatusMessage: {
                      locationName: "statusMessage"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeExportTasks: {
          input: {
            type: "structure",
            members: {
              ExportTaskIds: {
                locationName: "exportTaskId",
                type: "list",
                member: {
                  locationName: "ExportTaskId"
                }
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ExportTasks: {
                locationName: "exportTaskSet",
                type: "list",
                member: {
                  shape: "Sbj",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribeFastSnapshotRestores: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FastSnapshotRestores: {
                locationName: "fastSnapshotRestoreSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    SnapshotId: {
                      locationName: "snapshotId"
                    },
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    State: {
                      locationName: "state"
                    },
                    StateTransitionReason: {
                      locationName: "stateTransitionReason"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    OwnerAlias: {
                      locationName: "ownerAlias"
                    },
                    EnablingTime: {
                      locationName: "enablingTime",
                      type: "timestamp"
                    },
                    OptimizingTime: {
                      locationName: "optimizingTime",
                      type: "timestamp"
                    },
                    EnabledTime: {
                      locationName: "enabledTime",
                      type: "timestamp"
                    },
                    DisablingTime: {
                      locationName: "disablingTime",
                      type: "timestamp"
                    },
                    DisabledTime: {
                      locationName: "disabledTime",
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeFleetHistory: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "StartTime"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              EventType: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              FleetId: {},
              StartTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HistoryRecords: {
                locationName: "historyRecordSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    EventInformation: {
                      shape: "Svg",
                      locationName: "eventInformation"
                    },
                    EventType: {
                      locationName: "eventType"
                    },
                    Timestamp: {
                      locationName: "timestamp",
                      type: "timestamp"
                    }
                  }
                }
              },
              LastEvaluatedTime: {
                locationName: "lastEvaluatedTime",
                type: "timestamp"
              },
              NextToken: {
                locationName: "nextToken"
              },
              FleetId: {
                locationName: "fleetId"
              },
              StartTime: {
                locationName: "startTime",
                type: "timestamp"
              }
            }
          }
        },
        DescribeFleetInstances: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              FleetId: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ActiveInstances: {
                shape: "Svj",
                locationName: "activeInstanceSet"
              },
              NextToken: {
                locationName: "nextToken"
              },
              FleetId: {
                locationName: "fleetId"
              }
            }
          }
        },
        DescribeFleets: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              FleetIds: {
                shape: "Smz",
                locationName: "FleetId"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Fleets: {
                locationName: "fleetSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ActivityStatus: {
                      locationName: "activityStatus"
                    },
                    CreateTime: {
                      locationName: "createTime",
                      type: "timestamp"
                    },
                    FleetId: {
                      locationName: "fleetId"
                    },
                    FleetState: {
                      locationName: "fleetState"
                    },
                    ClientToken: {
                      locationName: "clientToken"
                    },
                    ExcessCapacityTerminationPolicy: {
                      locationName: "excessCapacityTerminationPolicy"
                    },
                    FulfilledCapacity: {
                      locationName: "fulfilledCapacity",
                      type: "double"
                    },
                    FulfilledOnDemandCapacity: {
                      locationName: "fulfilledOnDemandCapacity",
                      type: "double"
                    },
                    LaunchTemplateConfigs: {
                      locationName: "launchTemplateConfigs",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          LaunchTemplateSpecification: {
                            shape: "Sai",
                            locationName: "launchTemplateSpecification"
                          },
                          Overrides: {
                            locationName: "overrides",
                            type: "list",
                            member: {
                              shape: "Saj",
                              locationName: "item"
                            }
                          }
                        }
                      }
                    },
                    TargetCapacitySpecification: {
                      locationName: "targetCapacitySpecification",
                      type: "structure",
                      members: {
                        TotalTargetCapacity: {
                          locationName: "totalTargetCapacity",
                          type: "integer"
                        },
                        OnDemandTargetCapacity: {
                          locationName: "onDemandTargetCapacity",
                          type: "integer"
                        },
                        SpotTargetCapacity: {
                          locationName: "spotTargetCapacity",
                          type: "integer"
                        },
                        DefaultTargetCapacityType: {
                          locationName: "defaultTargetCapacityType"
                        }
                      }
                    },
                    TerminateInstancesWithExpiration: {
                      locationName: "terminateInstancesWithExpiration",
                      type: "boolean"
                    },
                    Type: {
                      locationName: "type"
                    },
                    ValidFrom: {
                      locationName: "validFrom",
                      type: "timestamp"
                    },
                    ValidUntil: {
                      locationName: "validUntil",
                      type: "timestamp"
                    },
                    ReplaceUnhealthyInstances: {
                      locationName: "replaceUnhealthyInstances",
                      type: "boolean"
                    },
                    SpotOptions: {
                      locationName: "spotOptions",
                      type: "structure",
                      members: {
                        AllocationStrategy: {
                          locationName: "allocationStrategy"
                        },
                        MaintenanceStrategies: {
                          locationName: "maintenanceStrategies",
                          type: "structure",
                          members: {
                            CapacityRebalance: {
                              locationName: "capacityRebalance",
                              type: "structure",
                              members: {
                                ReplacementStrategy: {
                                  locationName: "replacementStrategy"
                                }
                              }
                            }
                          }
                        },
                        InstanceInterruptionBehavior: {
                          locationName: "instanceInterruptionBehavior"
                        },
                        InstancePoolsToUseCount: {
                          locationName: "instancePoolsToUseCount",
                          type: "integer"
                        },
                        SingleInstanceType: {
                          locationName: "singleInstanceType",
                          type: "boolean"
                        },
                        SingleAvailabilityZone: {
                          locationName: "singleAvailabilityZone",
                          type: "boolean"
                        },
                        MinTargetCapacity: {
                          locationName: "minTargetCapacity",
                          type: "integer"
                        },
                        MaxTotalPrice: {
                          locationName: "maxTotalPrice"
                        }
                      }
                    },
                    OnDemandOptions: {
                      locationName: "onDemandOptions",
                      type: "structure",
                      members: {
                        AllocationStrategy: {
                          locationName: "allocationStrategy"
                        },
                        CapacityReservationOptions: {
                          locationName: "capacityReservationOptions",
                          type: "structure",
                          members: {
                            UsageStrategy: {
                              locationName: "usageStrategy"
                            }
                          }
                        },
                        SingleInstanceType: {
                          locationName: "singleInstanceType",
                          type: "boolean"
                        },
                        SingleAvailabilityZone: {
                          locationName: "singleAvailabilityZone",
                          type: "boolean"
                        },
                        MinTargetCapacity: {
                          locationName: "minTargetCapacity",
                          type: "integer"
                        },
                        MaxTotalPrice: {
                          locationName: "maxTotalPrice"
                        }
                      }
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    },
                    Errors: {
                      locationName: "errorSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          LaunchTemplateAndOverrides: {
                            shape: "Sah",
                            locationName: "launchTemplateAndOverrides"
                          },
                          Lifecycle: {
                            locationName: "lifecycle"
                          },
                          ErrorCode: {
                            locationName: "errorCode"
                          },
                          ErrorMessage: {
                            locationName: "errorMessage"
                          }
                        }
                      }
                    },
                    Instances: {
                      locationName: "fleetInstanceSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          LaunchTemplateAndOverrides: {
                            shape: "Sah",
                            locationName: "launchTemplateAndOverrides"
                          },
                          Lifecycle: {
                            locationName: "lifecycle"
                          },
                          InstanceIds: {
                            shape: "Sao",
                            locationName: "instanceIds"
                          },
                          InstanceType: {
                            locationName: "instanceType"
                          },
                          Platform: {
                            locationName: "platform"
                          }
                        }
                      }
                    },
                    Context: {
                      locationName: "context"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeFlowLogs: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filter: {
                shape: "Squ"
              },
              FlowLogIds: {
                shape: "Sn9",
                locationName: "FlowLogId"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FlowLogs: {
                locationName: "flowLogSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CreationTime: {
                      locationName: "creationTime",
                      type: "timestamp"
                    },
                    DeliverLogsErrorMessage: {
                      locationName: "deliverLogsErrorMessage"
                    },
                    DeliverLogsPermissionArn: {
                      locationName: "deliverLogsPermissionArn"
                    },
                    DeliverLogsStatus: {
                      locationName: "deliverLogsStatus"
                    },
                    FlowLogId: {
                      locationName: "flowLogId"
                    },
                    FlowLogStatus: {
                      locationName: "flowLogStatus"
                    },
                    LogGroupName: {
                      locationName: "logGroupName"
                    },
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    TrafficType: {
                      locationName: "trafficType"
                    },
                    LogDestinationType: {
                      locationName: "logDestinationType"
                    },
                    LogDestination: {
                      locationName: "logDestination"
                    },
                    LogFormat: {
                      locationName: "logFormat"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    },
                    MaxAggregationInterval: {
                      locationName: "maxAggregationInterval",
                      type: "integer"
                    },
                    DestinationOptions: {
                      locationName: "destinationOptions",
                      type: "structure",
                      members: {
                        FileFormat: {
                          locationName: "fileFormat"
                        },
                        HiveCompatiblePartitions: {
                          locationName: "hiveCompatiblePartitions",
                          type: "boolean"
                        },
                        PerHourPartition: {
                          locationName: "perHourPartition",
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeFpgaImageAttribute: {
          input: {
            type: "structure",
            required: [
              "FpgaImageId",
              "Attribute"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              FpgaImageId: {},
              Attribute: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FpgaImageAttribute: {
                shape: "Swc",
                locationName: "fpgaImageAttribute"
              }
            }
          }
        },
        DescribeFpgaImages: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              FpgaImageIds: {
                locationName: "FpgaImageId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Owners: {
                shape: "Swl",
                locationName: "Owner"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FpgaImages: {
                locationName: "fpgaImageSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    FpgaImageId: {
                      locationName: "fpgaImageId"
                    },
                    FpgaImageGlobalId: {
                      locationName: "fpgaImageGlobalId"
                    },
                    Name: {
                      locationName: "name"
                    },
                    Description: {
                      locationName: "description"
                    },
                    ShellVersion: {
                      locationName: "shellVersion"
                    },
                    PciId: {
                      locationName: "pciId",
                      type: "structure",
                      members: {
                        DeviceId: {},
                        VendorId: {},
                        SubsystemId: {},
                        SubsystemVendorId: {}
                      }
                    },
                    State: {
                      locationName: "state",
                      type: "structure",
                      members: {
                        Code: {
                          locationName: "code"
                        },
                        Message: {
                          locationName: "message"
                        }
                      }
                    },
                    CreateTime: {
                      locationName: "createTime",
                      type: "timestamp"
                    },
                    UpdateTime: {
                      locationName: "updateTime",
                      type: "timestamp"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    OwnerAlias: {
                      locationName: "ownerAlias"
                    },
                    ProductCodes: {
                      shape: "Swg",
                      locationName: "productCodes"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tags"
                    },
                    Public: {
                      locationName: "public",
                      type: "boolean"
                    },
                    DataRetentionSupport: {
                      locationName: "dataRetentionSupport",
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeHostReservationOfferings: {
          input: {
            type: "structure",
            members: {
              Filter: {
                shape: "Squ"
              },
              MaxDuration: {
                type: "integer"
              },
              MaxResults: {
                type: "integer"
              },
              MinDuration: {
                type: "integer"
              },
              NextToken: {},
              OfferingId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              OfferingSet: {
                locationName: "offeringSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CurrencyCode: {
                      locationName: "currencyCode"
                    },
                    Duration: {
                      locationName: "duration",
                      type: "integer"
                    },
                    HourlyPrice: {
                      locationName: "hourlyPrice"
                    },
                    InstanceFamily: {
                      locationName: "instanceFamily"
                    },
                    OfferingId: {
                      locationName: "offeringId"
                    },
                    PaymentOption: {
                      locationName: "paymentOption"
                    },
                    UpfrontPrice: {
                      locationName: "upfrontPrice"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeHostReservations: {
          input: {
            type: "structure",
            members: {
              Filter: {
                shape: "Squ"
              },
              HostReservationIdSet: {
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HostReservationSet: {
                locationName: "hostReservationSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Count: {
                      locationName: "count",
                      type: "integer"
                    },
                    CurrencyCode: {
                      locationName: "currencyCode"
                    },
                    Duration: {
                      locationName: "duration",
                      type: "integer"
                    },
                    End: {
                      locationName: "end",
                      type: "timestamp"
                    },
                    HostIdSet: {
                      shape: "Sx6",
                      locationName: "hostIdSet"
                    },
                    HostReservationId: {
                      locationName: "hostReservationId"
                    },
                    HourlyPrice: {
                      locationName: "hourlyPrice"
                    },
                    InstanceFamily: {
                      locationName: "instanceFamily"
                    },
                    OfferingId: {
                      locationName: "offeringId"
                    },
                    PaymentOption: {
                      locationName: "paymentOption"
                    },
                    Start: {
                      locationName: "start",
                      type: "timestamp"
                    },
                    State: {
                      locationName: "state"
                    },
                    UpfrontPrice: {
                      locationName: "upfrontPrice"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeHosts: {
          input: {
            type: "structure",
            members: {
              Filter: {
                shape: "Squ",
                locationName: "filter"
              },
              HostIds: {
                shape: "Sx9",
                locationName: "hostId"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Hosts: {
                locationName: "hostSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AutoPlacement: {
                      locationName: "autoPlacement"
                    },
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    AvailableCapacity: {
                      locationName: "availableCapacity",
                      type: "structure",
                      members: {
                        AvailableInstanceCapacity: {
                          locationName: "availableInstanceCapacity",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "structure",
                            members: {
                              AvailableCapacity: {
                                locationName: "availableCapacity",
                                type: "integer"
                              },
                              InstanceType: {
                                locationName: "instanceType"
                              },
                              TotalCapacity: {
                                locationName: "totalCapacity",
                                type: "integer"
                              }
                            }
                          }
                        },
                        AvailableVCpus: {
                          locationName: "availableVCpus",
                          type: "integer"
                        }
                      }
                    },
                    ClientToken: {
                      locationName: "clientToken"
                    },
                    HostId: {
                      locationName: "hostId"
                    },
                    HostProperties: {
                      locationName: "hostProperties",
                      type: "structure",
                      members: {
                        Cores: {
                          locationName: "cores",
                          type: "integer"
                        },
                        InstanceType: {
                          locationName: "instanceType"
                        },
                        InstanceFamily: {
                          locationName: "instanceFamily"
                        },
                        Sockets: {
                          locationName: "sockets",
                          type: "integer"
                        },
                        TotalVCpus: {
                          locationName: "totalVCpus",
                          type: "integer"
                        }
                      }
                    },
                    HostReservationId: {
                      locationName: "hostReservationId"
                    },
                    Instances: {
                      locationName: "instances",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          InstanceId: {
                            locationName: "instanceId"
                          },
                          InstanceType: {
                            locationName: "instanceType"
                          },
                          OwnerId: {
                            locationName: "ownerId"
                          }
                        }
                      }
                    },
                    State: {
                      locationName: "state"
                    },
                    AllocationTime: {
                      locationName: "allocationTime",
                      type: "timestamp"
                    },
                    ReleaseTime: {
                      locationName: "releaseTime",
                      type: "timestamp"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    },
                    HostRecovery: {
                      locationName: "hostRecovery"
                    },
                    AllowsMultipleInstanceTypes: {
                      locationName: "allowsMultipleInstanceTypes"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    AvailabilityZoneId: {
                      locationName: "availabilityZoneId"
                    },
                    MemberOfServiceLinkedResourceGroup: {
                      locationName: "memberOfServiceLinkedResourceGroup",
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeIamInstanceProfileAssociations: {
          input: {
            type: "structure",
            members: {
              AssociationIds: {
                locationName: "AssociationId",
                type: "list",
                member: {
                  locationName: "AssociationId"
                }
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IamInstanceProfileAssociations: {
                locationName: "iamInstanceProfileAssociationSet",
                type: "list",
                member: {
                  shape: "S31",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeIdFormat: {
          input: {
            type: "structure",
            members: {
              Resource: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Statuses: {
                shape: "Src",
                locationName: "statusSet"
              }
            }
          }
        },
        DescribeIdentityIdFormat: {
          input: {
            type: "structure",
            required: [
              "PrincipalArn"
            ],
            members: {
              PrincipalArn: {
                locationName: "principalArn"
              },
              Resource: {
                locationName: "resource"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Statuses: {
                shape: "Src",
                locationName: "statusSet"
              }
            }
          }
        },
        DescribeImageAttribute: {
          input: {
            type: "structure",
            required: [
              "Attribute",
              "ImageId"
            ],
            members: {
              Attribute: {},
              ImageId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BlockDeviceMappings: {
                shape: "Sxy",
                locationName: "blockDeviceMapping"
              },
              ImageId: {
                locationName: "imageId"
              },
              LaunchPermissions: {
                shape: "Sxz",
                locationName: "launchPermission"
              },
              ProductCodes: {
                shape: "Swg",
                locationName: "productCodes"
              },
              Description: {
                shape: "S9i",
                locationName: "description"
              },
              KernelId: {
                shape: "S9i",
                locationName: "kernel"
              },
              RamdiskId: {
                shape: "S9i",
                locationName: "ramdisk"
              },
              SriovNetSupport: {
                shape: "S9i",
                locationName: "sriovNetSupport"
              },
              BootMode: {
                shape: "S9i",
                locationName: "bootMode"
              }
            }
          }
        },
        DescribeImages: {
          input: {
            type: "structure",
            members: {
              ExecutableUsers: {
                locationName: "ExecutableBy",
                type: "list",
                member: {
                  locationName: "ExecutableBy"
                }
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              ImageIds: {
                locationName: "ImageId",
                type: "list",
                member: {
                  locationName: "ImageId"
                }
              },
              Owners: {
                shape: "Swl",
                locationName: "Owner"
              },
              IncludeDeprecated: {
                type: "boolean"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Images: {
                locationName: "imagesSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Architecture: {
                      locationName: "architecture"
                    },
                    CreationDate: {
                      locationName: "creationDate"
                    },
                    ImageId: {
                      locationName: "imageId"
                    },
                    ImageLocation: {
                      locationName: "imageLocation"
                    },
                    ImageType: {
                      locationName: "imageType"
                    },
                    Public: {
                      locationName: "isPublic",
                      type: "boolean"
                    },
                    KernelId: {
                      locationName: "kernelId"
                    },
                    OwnerId: {
                      locationName: "imageOwnerId"
                    },
                    Platform: {
                      locationName: "platform"
                    },
                    PlatformDetails: {
                      locationName: "platformDetails"
                    },
                    UsageOperation: {
                      locationName: "usageOperation"
                    },
                    ProductCodes: {
                      shape: "Swg",
                      locationName: "productCodes"
                    },
                    RamdiskId: {
                      locationName: "ramdiskId"
                    },
                    State: {
                      locationName: "imageState"
                    },
                    BlockDeviceMappings: {
                      shape: "Sxy",
                      locationName: "blockDeviceMapping"
                    },
                    Description: {
                      locationName: "description"
                    },
                    EnaSupport: {
                      locationName: "enaSupport",
                      type: "boolean"
                    },
                    Hypervisor: {
                      locationName: "hypervisor"
                    },
                    ImageOwnerAlias: {
                      locationName: "imageOwnerAlias"
                    },
                    Name: {
                      locationName: "name"
                    },
                    RootDeviceName: {
                      locationName: "rootDeviceName"
                    },
                    RootDeviceType: {
                      locationName: "rootDeviceType"
                    },
                    SriovNetSupport: {
                      locationName: "sriovNetSupport"
                    },
                    StateReason: {
                      shape: "Syc",
                      locationName: "stateReason"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    },
                    VirtualizationType: {
                      locationName: "virtualizationType"
                    },
                    BootMode: {
                      locationName: "bootMode"
                    },
                    DeprecationTime: {
                      locationName: "deprecationTime"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeImportImageTasks: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "Squ"
              },
              ImportTaskIds: {
                locationName: "ImportTaskId",
                type: "list",
                member: {
                  locationName: "ImportTaskId"
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImportImageTasks: {
                locationName: "importImageTaskSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Architecture: {
                      locationName: "architecture"
                    },
                    Description: {
                      locationName: "description"
                    },
                    Encrypted: {
                      locationName: "encrypted",
                      type: "boolean"
                    },
                    Hypervisor: {
                      locationName: "hypervisor"
                    },
                    ImageId: {
                      locationName: "imageId"
                    },
                    ImportTaskId: {
                      locationName: "importTaskId"
                    },
                    KmsKeyId: {
                      locationName: "kmsKeyId"
                    },
                    LicenseType: {
                      locationName: "licenseType"
                    },
                    Platform: {
                      locationName: "platform"
                    },
                    Progress: {
                      locationName: "progress"
                    },
                    SnapshotDetails: {
                      shape: "Syl",
                      locationName: "snapshotDetailSet"
                    },
                    Status: {
                      locationName: "status"
                    },
                    StatusMessage: {
                      locationName: "statusMessage"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    },
                    LicenseSpecifications: {
                      shape: "Syo",
                      locationName: "licenseSpecifications"
                    },
                    UsageOperation: {
                      locationName: "usageOperation"
                    },
                    BootMode: {
                      locationName: "bootMode"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeImportSnapshotTasks: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "Squ"
              },
              ImportTaskIds: {
                locationName: "ImportTaskId",
                type: "list",
                member: {
                  locationName: "ImportTaskId"
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImportSnapshotTasks: {
                locationName: "importSnapshotTaskSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Description: {
                      locationName: "description"
                    },
                    ImportTaskId: {
                      locationName: "importTaskId"
                    },
                    SnapshotTaskDetail: {
                      shape: "Syw",
                      locationName: "snapshotTaskDetail"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeInstanceAttribute: {
          input: {
            type: "structure",
            required: [
              "Attribute",
              "InstanceId"
            ],
            members: {
              Attribute: {
                locationName: "attribute"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InstanceId: {
                locationName: "instanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Groups: {
                shape: "Sfs",
                locationName: "groupSet"
              },
              BlockDeviceMappings: {
                shape: "Sz0",
                locationName: "blockDeviceMapping"
              },
              DisableApiTermination: {
                shape: "Sz3",
                locationName: "disableApiTermination"
              },
              EnaSupport: {
                shape: "Sz3",
                locationName: "enaSupport"
              },
              EnclaveOptions: {
                shape: "Sz4",
                locationName: "enclaveOptions"
              },
              EbsOptimized: {
                shape: "Sz3",
                locationName: "ebsOptimized"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              InstanceInitiatedShutdownBehavior: {
                shape: "S9i",
                locationName: "instanceInitiatedShutdownBehavior"
              },
              InstanceType: {
                shape: "S9i",
                locationName: "instanceType"
              },
              KernelId: {
                shape: "S9i",
                locationName: "kernel"
              },
              ProductCodes: {
                shape: "Swg",
                locationName: "productCodes"
              },
              RamdiskId: {
                shape: "S9i",
                locationName: "ramdisk"
              },
              RootDeviceName: {
                shape: "S9i",
                locationName: "rootDeviceName"
              },
              SourceDestCheck: {
                shape: "Sz3",
                locationName: "sourceDestCheck"
              },
              SriovNetSupport: {
                shape: "S9i",
                locationName: "sriovNetSupport"
              },
              UserData: {
                shape: "S9i",
                locationName: "userData"
              }
            }
          }
        },
        DescribeInstanceCreditSpecifications: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              InstanceIds: {
                shape: "Ssc",
                locationName: "InstanceId"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceCreditSpecifications: {
                locationName: "instanceCreditSpecificationSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceId: {
                      locationName: "instanceId"
                    },
                    CpuCredits: {
                      locationName: "cpuCredits"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeInstanceEventNotificationAttributes: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceTagAttribute: {
                shape: "Sqd",
                locationName: "instanceTagAttribute"
              }
            }
          }
        },
        DescribeInstanceEventWindows: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceEventWindowIds: {
                locationName: "InstanceEventWindowId",
                type: "list",
                member: {
                  locationName: "InstanceEventWindowId"
                }
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceEventWindows: {
                locationName: "instanceEventWindowSet",
                type: "list",
                member: {
                  shape: "S3b",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeInstanceStatus: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              InstanceIds: {
                shape: "Ssc",
                locationName: "InstanceId"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              IncludeAllInstances: {
                locationName: "includeAllInstances",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceStatuses: {
                locationName: "instanceStatusSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    OutpostArn: {
                      locationName: "outpostArn"
                    },
                    Events: {
                      locationName: "eventsSet",
                      type: "list",
                      member: {
                        shape: "Szm",
                        locationName: "item"
                      }
                    },
                    InstanceId: {
                      locationName: "instanceId"
                    },
                    InstanceState: {
                      shape: "Szp",
                      locationName: "instanceState"
                    },
                    InstanceStatus: {
                      shape: "Szr",
                      locationName: "instanceStatus"
                    },
                    SystemStatus: {
                      shape: "Szr",
                      locationName: "systemStatus"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeInstanceTypeOfferings: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              LocationType: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceTypeOfferings: {
                locationName: "instanceTypeOfferingSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceType: {
                      locationName: "instanceType"
                    },
                    LocationType: {
                      locationName: "locationType"
                    },
                    Location: {
                      locationName: "location"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeInstanceTypes: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceTypes: {
                locationName: "InstanceType",
                type: "list",
                member: {}
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceTypes: {
                locationName: "instanceTypeSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceType: {
                      locationName: "instanceType"
                    },
                    CurrentGeneration: {
                      locationName: "currentGeneration",
                      type: "boolean"
                    },
                    FreeTierEligible: {
                      locationName: "freeTierEligible",
                      type: "boolean"
                    },
                    SupportedUsageClasses: {
                      locationName: "supportedUsageClasses",
                      type: "list",
                      member: {
                        locationName: "item"
                      }
                    },
                    SupportedRootDeviceTypes: {
                      locationName: "supportedRootDeviceTypes",
                      type: "list",
                      member: {
                        locationName: "item"
                      }
                    },
                    SupportedVirtualizationTypes: {
                      locationName: "supportedVirtualizationTypes",
                      type: "list",
                      member: {
                        locationName: "item"
                      }
                    },
                    BareMetal: {
                      locationName: "bareMetal",
                      type: "boolean"
                    },
                    Hypervisor: {
                      locationName: "hypervisor"
                    },
                    ProcessorInfo: {
                      locationName: "processorInfo",
                      type: "structure",
                      members: {
                        SupportedArchitectures: {
                          locationName: "supportedArchitectures",
                          type: "list",
                          member: {
                            locationName: "item"
                          }
                        },
                        SustainedClockSpeedInGhz: {
                          locationName: "sustainedClockSpeedInGhz",
                          type: "double"
                        }
                      }
                    },
                    VCpuInfo: {
                      locationName: "vCpuInfo",
                      type: "structure",
                      members: {
                        DefaultVCpus: {
                          locationName: "defaultVCpus",
                          type: "integer"
                        },
                        DefaultCores: {
                          locationName: "defaultCores",
                          type: "integer"
                        },
                        DefaultThreadsPerCore: {
                          locationName: "defaultThreadsPerCore",
                          type: "integer"
                        },
                        ValidCores: {
                          locationName: "validCores",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "integer"
                          }
                        },
                        ValidThreadsPerCore: {
                          locationName: "validThreadsPerCore",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "integer"
                          }
                        }
                      }
                    },
                    MemoryInfo: {
                      locationName: "memoryInfo",
                      type: "structure",
                      members: {
                        SizeInMiB: {
                          locationName: "sizeInMiB",
                          type: "long"
                        }
                      }
                    },
                    InstanceStorageSupported: {
                      locationName: "instanceStorageSupported",
                      type: "boolean"
                    },
                    InstanceStorageInfo: {
                      locationName: "instanceStorageInfo",
                      type: "structure",
                      members: {
                        TotalSizeInGB: {
                          locationName: "totalSizeInGB",
                          type: "long"
                        },
                        Disks: {
                          locationName: "disks",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "structure",
                            members: {
                              SizeInGB: {
                                locationName: "sizeInGB",
                                type: "long"
                              },
                              Count: {
                                locationName: "count",
                                type: "integer"
                              },
                              Type: {
                                locationName: "type"
                              }
                            }
                          }
                        },
                        NvmeSupport: {
                          locationName: "nvmeSupport"
                        },
                        EncryptionSupport: {
                          locationName: "encryptionSupport"
                        }
                      }
                    },
                    EbsInfo: {
                      locationName: "ebsInfo",
                      type: "structure",
                      members: {
                        EbsOptimizedSupport: {
                          locationName: "ebsOptimizedSupport"
                        },
                        EncryptionSupport: {
                          locationName: "encryptionSupport"
                        },
                        EbsOptimizedInfo: {
                          locationName: "ebsOptimizedInfo",
                          type: "structure",
                          members: {
                            BaselineBandwidthInMbps: {
                              locationName: "baselineBandwidthInMbps",
                              type: "integer"
                            },
                            BaselineThroughputInMBps: {
                              locationName: "baselineThroughputInMBps",
                              type: "double"
                            },
                            BaselineIops: {
                              locationName: "baselineIops",
                              type: "integer"
                            },
                            MaximumBandwidthInMbps: {
                              locationName: "maximumBandwidthInMbps",
                              type: "integer"
                            },
                            MaximumThroughputInMBps: {
                              locationName: "maximumThroughputInMBps",
                              type: "double"
                            },
                            MaximumIops: {
                              locationName: "maximumIops",
                              type: "integer"
                            }
                          }
                        },
                        NvmeSupport: {
                          locationName: "nvmeSupport"
                        }
                      }
                    },
                    NetworkInfo: {
                      locationName: "networkInfo",
                      type: "structure",
                      members: {
                        NetworkPerformance: {
                          locationName: "networkPerformance"
                        },
                        MaximumNetworkInterfaces: {
                          locationName: "maximumNetworkInterfaces",
                          type: "integer"
                        },
                        MaximumNetworkCards: {
                          locationName: "maximumNetworkCards",
                          type: "integer"
                        },
                        DefaultNetworkCardIndex: {
                          locationName: "defaultNetworkCardIndex",
                          type: "integer"
                        },
                        NetworkCards: {
                          locationName: "networkCards",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "structure",
                            members: {
                              NetworkCardIndex: {
                                locationName: "networkCardIndex",
                                type: "integer"
                              },
                              NetworkPerformance: {
                                locationName: "networkPerformance"
                              },
                              MaximumNetworkInterfaces: {
                                locationName: "maximumNetworkInterfaces",
                                type: "integer"
                              }
                            }
                          }
                        },
                        Ipv4AddressesPerInterface: {
                          locationName: "ipv4AddressesPerInterface",
                          type: "integer"
                        },
                        Ipv6AddressesPerInterface: {
                          locationName: "ipv6AddressesPerInterface",
                          type: "integer"
                        },
                        Ipv6Supported: {
                          locationName: "ipv6Supported",
                          type: "boolean"
                        },
                        EnaSupport: {
                          locationName: "enaSupport"
                        },
                        EfaSupported: {
                          locationName: "efaSupported",
                          type: "boolean"
                        },
                        EfaInfo: {
                          locationName: "efaInfo",
                          type: "structure",
                          members: {
                            MaximumEfaInterfaces: {
                              locationName: "maximumEfaInterfaces",
                              type: "integer"
                            }
                          }
                        },
                        EncryptionInTransitSupported: {
                          locationName: "encryptionInTransitSupported",
                          type: "boolean"
                        }
                      }
                    },
                    GpuInfo: {
                      locationName: "gpuInfo",
                      type: "structure",
                      members: {
                        Gpus: {
                          locationName: "gpus",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "structure",
                            members: {
                              Name: {
                                locationName: "name"
                              },
                              Manufacturer: {
                                locationName: "manufacturer"
                              },
                              Count: {
                                locationName: "count",
                                type: "integer"
                              },
                              MemoryInfo: {
                                locationName: "memoryInfo",
                                type: "structure",
                                members: {
                                  SizeInMiB: {
                                    locationName: "sizeInMiB",
                                    type: "integer"
                                  }
                                }
                              }
                            }
                          }
                        },
                        TotalGpuMemoryInMiB: {
                          locationName: "totalGpuMemoryInMiB",
                          type: "integer"
                        }
                      }
                    },
                    FpgaInfo: {
                      locationName: "fpgaInfo",
                      type: "structure",
                      members: {
                        Fpgas: {
                          locationName: "fpgas",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "structure",
                            members: {
                              Name: {
                                locationName: "name"
                              },
                              Manufacturer: {
                                locationName: "manufacturer"
                              },
                              Count: {
                                locationName: "count",
                                type: "integer"
                              },
                              MemoryInfo: {
                                locationName: "memoryInfo",
                                type: "structure",
                                members: {
                                  SizeInMiB: {
                                    locationName: "sizeInMiB",
                                    type: "integer"
                                  }
                                }
                              }
                            }
                          }
                        },
                        TotalFpgaMemoryInMiB: {
                          locationName: "totalFpgaMemoryInMiB",
                          type: "integer"
                        }
                      }
                    },
                    PlacementGroupInfo: {
                      locationName: "placementGroupInfo",
                      type: "structure",
                      members: {
                        SupportedStrategies: {
                          locationName: "supportedStrategies",
                          type: "list",
                          member: {
                            locationName: "item"
                          }
                        }
                      }
                    },
                    InferenceAcceleratorInfo: {
                      locationName: "inferenceAcceleratorInfo",
                      type: "structure",
                      members: {
                        Accelerators: {
                          locationName: "item",
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Count: {
                                locationName: "count",
                                type: "integer"
                              },
                              Name: {
                                locationName: "name"
                              },
                              Manufacturer: {
                                locationName: "manufacturer"
                              }
                            }
                          }
                        }
                      }
                    },
                    HibernationSupported: {
                      locationName: "hibernationSupported",
                      type: "boolean"
                    },
                    BurstablePerformanceSupported: {
                      locationName: "burstablePerformanceSupported",
                      type: "boolean"
                    },
                    DedicatedHostsSupported: {
                      locationName: "dedicatedHostsSupported",
                      type: "boolean"
                    },
                    AutoRecoverySupported: {
                      locationName: "autoRecoverySupported",
                      type: "boolean"
                    },
                    SupportedBootModes: {
                      locationName: "supportedBootModes",
                      type: "list",
                      member: {
                        locationName: "item"
                      }
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeInstances: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              InstanceIds: {
                shape: "Ssc",
                locationName: "InstanceId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Reservations: {
                locationName: "reservationSet",
                type: "list",
                member: {
                  shape: "S12v",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeInternetGateways: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InternetGatewayIds: {
                locationName: "internetGatewayId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InternetGateways: {
                locationName: "internetGatewaySet",
                type: "list",
                member: {
                  shape: "Sbp",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeIpv6Pools: {
          input: {
            type: "structure",
            members: {
              PoolIds: {
                locationName: "PoolId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Ipv6Pools: {
                locationName: "ipv6PoolSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    PoolId: {
                      locationName: "poolId"
                    },
                    Description: {
                      locationName: "description"
                    },
                    PoolCidrBlocks: {
                      locationName: "poolCidrBlockSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          Cidr: {
                            locationName: "poolCidrBlock"
                          }
                        }
                      }
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeKeyPairs: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              KeyNames: {
                locationName: "KeyName",
                type: "list",
                member: {
                  locationName: "KeyName"
                }
              },
              KeyPairIds: {
                locationName: "KeyPairId",
                type: "list",
                member: {
                  locationName: "KeyPairId"
                }
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyPairs: {
                locationName: "keySet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    KeyPairId: {
                      locationName: "keyPairId"
                    },
                    KeyFingerprint: {
                      locationName: "keyFingerprint"
                    },
                    KeyName: {
                      locationName: "keyName"
                    },
                    KeyType: {
                      locationName: "keyType"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeLaunchTemplateVersions: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              LaunchTemplateId: {},
              LaunchTemplateName: {},
              Versions: {
                shape: "Sno",
                locationName: "LaunchTemplateVersion"
              },
              MinVersion: {},
              MaxVersion: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LaunchTemplateVersions: {
                locationName: "launchTemplateVersionSet",
                type: "list",
                member: {
                  shape: "Sdg",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeLaunchTemplates: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              LaunchTemplateIds: {
                locationName: "LaunchTemplateId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              LaunchTemplateNames: {
                locationName: "LaunchTemplateName",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LaunchTemplates: {
                locationName: "launchTemplates",
                type: "list",
                member: {
                  shape: "Sda",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociations: {
          input: {
            type: "structure",
            members: {
              LocalGatewayRouteTableVirtualInterfaceGroupAssociationIds: {
                locationName: "LocalGatewayRouteTableVirtualInterfaceGroupAssociationId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalGatewayRouteTableVirtualInterfaceGroupAssociations: {
                locationName: "localGatewayRouteTableVirtualInterfaceGroupAssociationSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    LocalGatewayRouteTableVirtualInterfaceGroupAssociationId: {
                      locationName: "localGatewayRouteTableVirtualInterfaceGroupAssociationId"
                    },
                    LocalGatewayVirtualInterfaceGroupId: {
                      locationName: "localGatewayVirtualInterfaceGroupId"
                    },
                    LocalGatewayId: {
                      locationName: "localGatewayId"
                    },
                    LocalGatewayRouteTableId: {
                      locationName: "localGatewayRouteTableId"
                    },
                    LocalGatewayRouteTableArn: {
                      locationName: "localGatewayRouteTableArn"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    State: {
                      locationName: "state"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeLocalGatewayRouteTableVpcAssociations: {
          input: {
            type: "structure",
            members: {
              LocalGatewayRouteTableVpcAssociationIds: {
                locationName: "LocalGatewayRouteTableVpcAssociationId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalGatewayRouteTableVpcAssociations: {
                locationName: "localGatewayRouteTableVpcAssociationSet",
                type: "list",
                member: {
                  shape: "Sen",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeLocalGatewayRouteTables: {
          input: {
            type: "structure",
            members: {
              LocalGatewayRouteTableIds: {
                locationName: "LocalGatewayRouteTableId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalGatewayRouteTables: {
                locationName: "localGatewayRouteTableSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    LocalGatewayRouteTableId: {
                      locationName: "localGatewayRouteTableId"
                    },
                    LocalGatewayRouteTableArn: {
                      locationName: "localGatewayRouteTableArn"
                    },
                    LocalGatewayId: {
                      locationName: "localGatewayId"
                    },
                    OutpostArn: {
                      locationName: "outpostArn"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    State: {
                      locationName: "state"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeLocalGatewayVirtualInterfaceGroups: {
          input: {
            type: "structure",
            members: {
              LocalGatewayVirtualInterfaceGroupIds: {
                locationName: "LocalGatewayVirtualInterfaceGroupId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalGatewayVirtualInterfaceGroups: {
                locationName: "localGatewayVirtualInterfaceGroupSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    LocalGatewayVirtualInterfaceGroupId: {
                      locationName: "localGatewayVirtualInterfaceGroupId"
                    },
                    LocalGatewayVirtualInterfaceIds: {
                      shape: "S152",
                      locationName: "localGatewayVirtualInterfaceIdSet"
                    },
                    LocalGatewayId: {
                      locationName: "localGatewayId"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeLocalGatewayVirtualInterfaces: {
          input: {
            type: "structure",
            members: {
              LocalGatewayVirtualInterfaceIds: {
                shape: "S152",
                locationName: "LocalGatewayVirtualInterfaceId"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalGatewayVirtualInterfaces: {
                locationName: "localGatewayVirtualInterfaceSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    LocalGatewayVirtualInterfaceId: {
                      locationName: "localGatewayVirtualInterfaceId"
                    },
                    LocalGatewayId: {
                      locationName: "localGatewayId"
                    },
                    Vlan: {
                      locationName: "vlan",
                      type: "integer"
                    },
                    LocalAddress: {
                      locationName: "localAddress"
                    },
                    PeerAddress: {
                      locationName: "peerAddress"
                    },
                    LocalBgpAsn: {
                      locationName: "localBgpAsn",
                      type: "integer"
                    },
                    PeerBgpAsn: {
                      locationName: "peerBgpAsn",
                      type: "integer"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeLocalGateways: {
          input: {
            type: "structure",
            members: {
              LocalGatewayIds: {
                locationName: "LocalGatewayId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocalGateways: {
                locationName: "localGatewaySet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    LocalGatewayId: {
                      locationName: "localGatewayId"
                    },
                    OutpostArn: {
                      locationName: "outpostArn"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    State: {
                      locationName: "state"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeManagedPrefixLists: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              PrefixListIds: {
                shape: "Se",
                locationName: "PrefixListId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              PrefixLists: {
                locationName: "prefixListSet",
                type: "list",
                member: {
                  shape: "Set",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribeMovingAddresses: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              },
              PublicIps: {
                shape: "Se",
                locationName: "publicIp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MovingAddressStatuses: {
                locationName: "movingAddressStatusSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    MoveStatus: {
                      locationName: "moveStatus"
                    },
                    PublicIp: {
                      locationName: "publicIp"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeNatGateways: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filter: {
                shape: "Squ"
              },
              MaxResults: {
                type: "integer"
              },
              NatGatewayIds: {
                locationName: "NatGatewayId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NatGateways: {
                locationName: "natGatewaySet",
                type: "list",
                member: {
                  shape: "Sey",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeNetworkAcls: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NetworkAclIds: {
                locationName: "NetworkAclId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkAcls: {
                locationName: "networkAclSet",
                type: "list",
                member: {
                  shape: "Sf5",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeNetworkInsightsAnalyses: {
          input: {
            type: "structure",
            members: {
              NetworkInsightsAnalysisIds: {
                locationName: "NetworkInsightsAnalysisId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NetworkInsightsPathId: {},
              AnalysisStartTime: {
                type: "timestamp"
              },
              AnalysisEndTime: {
                type: "timestamp"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInsightsAnalyses: {
                locationName: "networkInsightsAnalysisSet",
                type: "list",
                member: {
                  shape: "S162",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeNetworkInsightsPaths: {
          input: {
            type: "structure",
            members: {
              NetworkInsightsPathIds: {
                locationName: "NetworkInsightsPathId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInsightsPaths: {
                locationName: "networkInsightsPathSet",
                type: "list",
                member: {
                  shape: "Sfk",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeNetworkInterfaceAttribute: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfaceId"
            ],
            members: {
              Attribute: {
                locationName: "attribute"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attachment: {
                shape: "Sfr",
                locationName: "attachment"
              },
              Description: {
                shape: "S9i",
                locationName: "description"
              },
              Groups: {
                shape: "Sfs",
                locationName: "groupSet"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              SourceDestCheck: {
                shape: "Sz3",
                locationName: "sourceDestCheck"
              }
            }
          }
        },
        DescribeNetworkInterfacePermissions: {
          input: {
            type: "structure",
            members: {
              NetworkInterfacePermissionIds: {
                locationName: "NetworkInterfacePermissionId",
                type: "list",
                member: {}
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInterfacePermissions: {
                locationName: "networkInterfacePermissions",
                type: "list",
                member: {
                  shape: "Sg5",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeNetworkInterfaces: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NetworkInterfaceIds: {
                locationName: "NetworkInterfaceId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInterfaces: {
                locationName: "networkInterfaceSet",
                type: "list",
                member: {
                  shape: "Sfp",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribePlacementGroups: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              GroupNames: {
                locationName: "groupName",
                type: "list",
                member: {}
              },
              GroupIds: {
                locationName: "GroupId",
                type: "list",
                member: {
                  locationName: "GroupId"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PlacementGroups: {
                locationName: "placementGroupSet",
                type: "list",
                member: {
                  shape: "Sgb",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribePrefixLists: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              PrefixListIds: {
                locationName: "PrefixListId",
                type: "list",
                member: {
                  locationName: "item"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              PrefixLists: {
                locationName: "prefixListSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Cidrs: {
                      shape: "Se",
                      locationName: "cidrSet"
                    },
                    PrefixListId: {
                      locationName: "prefixListId"
                    },
                    PrefixListName: {
                      locationName: "prefixListName"
                    }
                  }
                }
              }
            }
          }
        },
        DescribePrincipalIdFormat: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Resources: {
                locationName: "Resource",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Principals: {
                locationName: "principalSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    Statuses: {
                      shape: "Src",
                      locationName: "statusSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribePublicIpv4Pools: {
          input: {
            type: "structure",
            members: {
              PoolIds: {
                locationName: "PoolId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicIpv4Pools: {
                locationName: "publicIpv4PoolSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    PoolId: {
                      locationName: "poolId"
                    },
                    Description: {
                      locationName: "description"
                    },
                    PoolAddressRanges: {
                      locationName: "poolAddressRangeSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          FirstAddress: {
                            locationName: "firstAddress"
                          },
                          LastAddress: {
                            locationName: "lastAddress"
                          },
                          AddressCount: {
                            locationName: "addressCount",
                            type: "integer"
                          },
                          AvailableAddressCount: {
                            locationName: "availableAddressCount",
                            type: "integer"
                          }
                        }
                      }
                    },
                    TotalAddressCount: {
                      locationName: "totalAddressCount",
                      type: "integer"
                    },
                    TotalAvailableAddressCount: {
                      locationName: "totalAvailableAddressCount",
                      type: "integer"
                    },
                    NetworkBorderGroup: {
                      locationName: "networkBorderGroup"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeRegions: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              RegionNames: {
                locationName: "RegionName",
                type: "list",
                member: {
                  locationName: "RegionName"
                }
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              AllRegions: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Regions: {
                locationName: "regionInfo",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Endpoint: {
                      locationName: "regionEndpoint"
                    },
                    RegionName: {
                      locationName: "regionName"
                    },
                    OptInStatus: {
                      locationName: "optInStatus"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeReplaceRootVolumeTasks: {
          input: {
            type: "structure",
            members: {
              ReplaceRootVolumeTaskIds: {
                locationName: "ReplaceRootVolumeTaskId",
                type: "list",
                member: {
                  locationName: "ReplaceRootVolumeTaskId"
                }
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplaceRootVolumeTasks: {
                locationName: "replaceRootVolumeTaskSet",
                type: "list",
                member: {
                  shape: "Sgf",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeReservedInstances: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              OfferingClass: {},
              ReservedInstancesIds: {
                shape: "S184",
                locationName: "ReservedInstancesId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              OfferingType: {
                locationName: "offeringType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedInstances: {
                locationName: "reservedInstancesSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    Duration: {
                      locationName: "duration",
                      type: "long"
                    },
                    End: {
                      locationName: "end",
                      type: "timestamp"
                    },
                    FixedPrice: {
                      locationName: "fixedPrice",
                      type: "float"
                    },
                    InstanceCount: {
                      locationName: "instanceCount",
                      type: "integer"
                    },
                    InstanceType: {
                      locationName: "instanceType"
                    },
                    ProductDescription: {
                      locationName: "productDescription"
                    },
                    ReservedInstancesId: {
                      locationName: "reservedInstancesId"
                    },
                    Start: {
                      locationName: "start",
                      type: "timestamp"
                    },
                    State: {
                      locationName: "state"
                    },
                    UsagePrice: {
                      locationName: "usagePrice",
                      type: "float"
                    },
                    CurrencyCode: {
                      locationName: "currencyCode"
                    },
                    InstanceTenancy: {
                      locationName: "instanceTenancy"
                    },
                    OfferingClass: {
                      locationName: "offeringClass"
                    },
                    OfferingType: {
                      locationName: "offeringType"
                    },
                    RecurringCharges: {
                      shape: "S18c",
                      locationName: "recurringCharges"
                    },
                    Scope: {
                      locationName: "scope"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeReservedInstancesListings: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              ReservedInstancesId: {
                locationName: "reservedInstancesId"
              },
              ReservedInstancesListingId: {
                locationName: "reservedInstancesListingId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedInstancesListings: {
                shape: "S6j",
                locationName: "reservedInstancesListingsSet"
              }
            }
          }
        },
        DescribeReservedInstancesModifications: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              ReservedInstancesModificationIds: {
                locationName: "ReservedInstancesModificationId",
                type: "list",
                member: {
                  locationName: "ReservedInstancesModificationId"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              ReservedInstancesModifications: {
                locationName: "reservedInstancesModificationsSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ClientToken: {
                      locationName: "clientToken"
                    },
                    CreateDate: {
                      locationName: "createDate",
                      type: "timestamp"
                    },
                    EffectiveDate: {
                      locationName: "effectiveDate",
                      type: "timestamp"
                    },
                    ModificationResults: {
                      locationName: "modificationResultSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          ReservedInstancesId: {
                            locationName: "reservedInstancesId"
                          },
                          TargetConfiguration: {
                            shape: "S18q",
                            locationName: "targetConfiguration"
                          }
                        }
                      }
                    },
                    ReservedInstancesIds: {
                      locationName: "reservedInstancesSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          ReservedInstancesId: {
                            locationName: "reservedInstancesId"
                          }
                        }
                      }
                    },
                    ReservedInstancesModificationId: {
                      locationName: "reservedInstancesModificationId"
                    },
                    Status: {
                      locationName: "status"
                    },
                    StatusMessage: {
                      locationName: "statusMessage"
                    },
                    UpdateDate: {
                      locationName: "updateDate",
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeReservedInstancesOfferings: {
          input: {
            type: "structure",
            members: {
              AvailabilityZone: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              IncludeMarketplace: {
                type: "boolean"
              },
              InstanceType: {},
              MaxDuration: {
                type: "long"
              },
              MaxInstanceCount: {
                type: "integer"
              },
              MinDuration: {
                type: "long"
              },
              OfferingClass: {},
              ProductDescription: {},
              ReservedInstancesOfferingIds: {
                locationName: "ReservedInstancesOfferingId",
                type: "list",
                member: {}
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InstanceTenancy: {
                locationName: "instanceTenancy"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              },
              OfferingType: {
                locationName: "offeringType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedInstancesOfferings: {
                locationName: "reservedInstancesOfferingsSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    Duration: {
                      locationName: "duration",
                      type: "long"
                    },
                    FixedPrice: {
                      locationName: "fixedPrice",
                      type: "float"
                    },
                    InstanceType: {
                      locationName: "instanceType"
                    },
                    ProductDescription: {
                      locationName: "productDescription"
                    },
                    ReservedInstancesOfferingId: {
                      locationName: "reservedInstancesOfferingId"
                    },
                    UsagePrice: {
                      locationName: "usagePrice",
                      type: "float"
                    },
                    CurrencyCode: {
                      locationName: "currencyCode"
                    },
                    InstanceTenancy: {
                      locationName: "instanceTenancy"
                    },
                    Marketplace: {
                      locationName: "marketplace",
                      type: "boolean"
                    },
                    OfferingClass: {
                      locationName: "offeringClass"
                    },
                    OfferingType: {
                      locationName: "offeringType"
                    },
                    PricingDetails: {
                      locationName: "pricingDetailsSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          Count: {
                            locationName: "count",
                            type: "integer"
                          },
                          Price: {
                            locationName: "price",
                            type: "double"
                          }
                        }
                      }
                    },
                    RecurringCharges: {
                      shape: "S18c",
                      locationName: "recurringCharges"
                    },
                    Scope: {
                      locationName: "scope"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeRouteTables: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              RouteTableIds: {
                locationName: "RouteTableId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RouteTables: {
                locationName: "routeTableSet",
                type: "list",
                member: {
                  shape: "Sgv",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeScheduledInstanceAvailability: {
          input: {
            type: "structure",
            required: [
              "FirstSlotStartTimeRange",
              "Recurrence"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              FirstSlotStartTimeRange: {
                type: "structure",
                required: [
                  "EarliestTime",
                  "LatestTime"
                ],
                members: {
                  EarliestTime: {
                    type: "timestamp"
                  },
                  LatestTime: {
                    type: "timestamp"
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              MaxSlotDurationInHours: {
                type: "integer"
              },
              MinSlotDurationInHours: {
                type: "integer"
              },
              NextToken: {},
              Recurrence: {
                type: "structure",
                members: {
                  Frequency: {},
                  Interval: {
                    type: "integer"
                  },
                  OccurrenceDays: {
                    locationName: "OccurrenceDay",
                    type: "list",
                    member: {
                      locationName: "OccurenceDay",
                      type: "integer"
                    }
                  },
                  OccurrenceRelativeToEnd: {
                    type: "boolean"
                  },
                  OccurrenceUnit: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              ScheduledInstanceAvailabilitySet: {
                locationName: "scheduledInstanceAvailabilitySet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    AvailableInstanceCount: {
                      locationName: "availableInstanceCount",
                      type: "integer"
                    },
                    FirstSlotStartTime: {
                      locationName: "firstSlotStartTime",
                      type: "timestamp"
                    },
                    HourlyPrice: {
                      locationName: "hourlyPrice"
                    },
                    InstanceType: {
                      locationName: "instanceType"
                    },
                    MaxTermDurationInDays: {
                      locationName: "maxTermDurationInDays",
                      type: "integer"
                    },
                    MinTermDurationInDays: {
                      locationName: "minTermDurationInDays",
                      type: "integer"
                    },
                    NetworkPlatform: {
                      locationName: "networkPlatform"
                    },
                    Platform: {
                      locationName: "platform"
                    },
                    PurchaseToken: {
                      locationName: "purchaseToken"
                    },
                    Recurrence: {
                      shape: "S19d",
                      locationName: "recurrence"
                    },
                    SlotDurationInHours: {
                      locationName: "slotDurationInHours",
                      type: "integer"
                    },
                    TotalScheduledInstanceHours: {
                      locationName: "totalScheduledInstanceHours",
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeScheduledInstances: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ScheduledInstanceIds: {
                locationName: "ScheduledInstanceId",
                type: "list",
                member: {
                  locationName: "ScheduledInstanceId"
                }
              },
              SlotStartTimeRange: {
                type: "structure",
                members: {
                  EarliestTime: {
                    type: "timestamp"
                  },
                  LatestTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              ScheduledInstanceSet: {
                locationName: "scheduledInstanceSet",
                type: "list",
                member: {
                  shape: "S19l",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribeSecurityGroupReferences: {
          input: {
            type: "structure",
            required: [
              "GroupId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              GroupId: {
                type: "list",
                member: {
                  locationName: "item"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityGroupReferenceSet: {
                locationName: "securityGroupReferenceSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    GroupId: {
                      locationName: "groupId"
                    },
                    ReferencingVpcId: {
                      locationName: "referencingVpcId"
                    },
                    VpcPeeringConnectionId: {
                      locationName: "vpcPeeringConnectionId"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeSecurityGroupRules: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              SecurityGroupRuleIds: {
                shape: "S19s",
                locationName: "SecurityGroupRuleId"
              },
              DryRun: {
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityGroupRules: {
                shape: "S5b",
                locationName: "securityGroupRuleSet"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeSecurityGroups: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              GroupIds: {
                shape: "S4g",
                locationName: "GroupId"
              },
              GroupNames: {
                shape: "S19w",
                locationName: "GroupName"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityGroups: {
                locationName: "securityGroupInfo",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Description: {
                      locationName: "groupDescription"
                    },
                    GroupName: {
                      locationName: "groupName"
                    },
                    IpPermissions: {
                      shape: "S50",
                      locationName: "ipPermissions"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    GroupId: {
                      locationName: "groupId"
                    },
                    IpPermissionsEgress: {
                      shape: "S50",
                      locationName: "ipPermissionsEgress"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    },
                    VpcId: {
                      locationName: "vpcId"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeSnapshotAttribute: {
          input: {
            type: "structure",
            required: [
              "Attribute",
              "SnapshotId"
            ],
            members: {
              Attribute: {},
              SnapshotId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CreateVolumePermissions: {
                shape: "S1a4",
                locationName: "createVolumePermission"
              },
              ProductCodes: {
                shape: "Swg",
                locationName: "productCodes"
              },
              SnapshotId: {
                locationName: "snapshotId"
              }
            }
          }
        },
        DescribeSnapshots: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              OwnerIds: {
                shape: "Swl",
                locationName: "Owner"
              },
              RestorableByUserIds: {
                locationName: "RestorableBy",
                type: "list",
                member: {}
              },
              SnapshotIds: {
                shape: "S1a8",
                locationName: "SnapshotId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Snapshots: {
                locationName: "snapshotSet",
                type: "list",
                member: {
                  shape: "Sh7",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeSpotDatafeedSubscription: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SpotDatafeedSubscription: {
                shape: "Shh",
                locationName: "spotDatafeedSubscription"
              }
            }
          }
        },
        DescribeSpotFleetInstances: {
          input: {
            type: "structure",
            required: [
              "SpotFleetRequestId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              },
              SpotFleetRequestId: {
                locationName: "spotFleetRequestId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ActiveInstances: {
                shape: "Svj",
                locationName: "activeInstanceSet"
              },
              NextToken: {
                locationName: "nextToken"
              },
              SpotFleetRequestId: {
                locationName: "spotFleetRequestId"
              }
            }
          }
        },
        DescribeSpotFleetRequestHistory: {
          input: {
            type: "structure",
            required: [
              "SpotFleetRequestId",
              "StartTime"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              EventType: {
                locationName: "eventType"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              },
              SpotFleetRequestId: {
                locationName: "spotFleetRequestId"
              },
              StartTime: {
                locationName: "startTime",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HistoryRecords: {
                locationName: "historyRecordSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    EventInformation: {
                      shape: "Svg",
                      locationName: "eventInformation"
                    },
                    EventType: {
                      locationName: "eventType"
                    },
                    Timestamp: {
                      locationName: "timestamp",
                      type: "timestamp"
                    }
                  }
                }
              },
              LastEvaluatedTime: {
                locationName: "lastEvaluatedTime",
                type: "timestamp"
              },
              NextToken: {
                locationName: "nextToken"
              },
              SpotFleetRequestId: {
                locationName: "spotFleetRequestId"
              },
              StartTime: {
                locationName: "startTime",
                type: "timestamp"
              }
            }
          }
        },
        DescribeSpotFleetRequests: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              },
              SpotFleetRequestIds: {
                shape: "S6v",
                locationName: "spotFleetRequestId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              SpotFleetRequestConfigs: {
                locationName: "spotFleetRequestConfigSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ActivityStatus: {
                      locationName: "activityStatus"
                    },
                    CreateTime: {
                      locationName: "createTime",
                      type: "timestamp"
                    },
                    SpotFleetRequestConfig: {
                      shape: "S1ar",
                      locationName: "spotFleetRequestConfig"
                    },
                    SpotFleetRequestId: {
                      locationName: "spotFleetRequestId"
                    },
                    SpotFleetRequestState: {
                      locationName: "spotFleetRequestState"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeSpotInstanceRequests: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              SpotInstanceRequestIds: {
                shape: "S76",
                locationName: "SpotInstanceRequestId"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SpotInstanceRequests: {
                shape: "S1bj",
                locationName: "spotInstanceRequestSet"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeSpotPriceHistory: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              AvailabilityZone: {
                locationName: "availabilityZone"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              EndTime: {
                locationName: "endTime",
                type: "timestamp"
              },
              InstanceTypes: {
                locationName: "InstanceType",
                type: "list",
                member: {}
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              },
              ProductDescriptions: {
                locationName: "ProductDescription",
                type: "list",
                member: {}
              },
              StartTime: {
                locationName: "startTime",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              SpotPriceHistory: {
                locationName: "spotPriceHistorySet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    InstanceType: {
                      locationName: "instanceType"
                    },
                    ProductDescription: {
                      locationName: "productDescription"
                    },
                    SpotPrice: {
                      locationName: "spotPrice"
                    },
                    Timestamp: {
                      locationName: "timestamp",
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeStaleSecurityGroups: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              VpcId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              StaleSecurityGroupSet: {
                locationName: "staleSecurityGroupSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Description: {
                      locationName: "description"
                    },
                    GroupId: {
                      locationName: "groupId"
                    },
                    GroupName: {
                      locationName: "groupName"
                    },
                    StaleIpPermissions: {
                      shape: "S1c1",
                      locationName: "staleIpPermissions"
                    },
                    StaleIpPermissionsEgress: {
                      shape: "S1c1",
                      locationName: "staleIpPermissionsEgress"
                    },
                    VpcId: {
                      locationName: "vpcId"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeStoreImageTasks: {
          input: {
            type: "structure",
            members: {
              ImageIds: {
                locationName: "ImageId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StoreImageTaskResults: {
                locationName: "storeImageTaskResultSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AmiId: {
                      locationName: "amiId"
                    },
                    TaskStartTime: {
                      locationName: "taskStartTime",
                      type: "timestamp"
                    },
                    Bucket: {
                      locationName: "bucket"
                    },
                    S3objectKey: {
                      locationName: "s3objectKey"
                    },
                    ProgressPercentage: {
                      locationName: "progressPercentage",
                      type: "integer"
                    },
                    StoreTaskState: {
                      locationName: "storeTaskState"
                    },
                    StoreTaskFailureReason: {
                      locationName: "storeTaskFailureReason"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeSubnets: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              SubnetIds: {
                locationName: "SubnetId",
                type: "list",
                member: {
                  locationName: "SubnetId"
                }
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Subnets: {
                locationName: "subnetSet",
                type: "list",
                member: {
                  shape: "S8z",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTags: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Tags: {
                locationName: "tagSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Key: {
                      locationName: "key"
                    },
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    ResourceType: {
                      locationName: "resourceType"
                    },
                    Value: {
                      locationName: "value"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeTrafficMirrorFilters: {
          input: {
            type: "structure",
            members: {
              TrafficMirrorFilterIds: {
                locationName: "TrafficMirrorFilterId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorFilters: {
                locationName: "trafficMirrorFilterSet",
                type: "list",
                member: {
                  shape: "Si0",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTrafficMirrorSessions: {
          input: {
            type: "structure",
            members: {
              TrafficMirrorSessionIds: {
                locationName: "TrafficMirrorSessionId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorSessions: {
                locationName: "trafficMirrorSessionSet",
                type: "list",
                member: {
                  shape: "Sif",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTrafficMirrorTargets: {
          input: {
            type: "structure",
            members: {
              TrafficMirrorTargetIds: {
                locationName: "TrafficMirrorTargetId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorTargets: {
                locationName: "trafficMirrorTargetSet",
                type: "list",
                member: {
                  shape: "Sii",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTransitGatewayAttachments: {
          input: {
            type: "structure",
            members: {
              TransitGatewayAttachmentIds: {
                shape: "S1cz"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayAttachments: {
                locationName: "transitGatewayAttachments",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    TransitGatewayAttachmentId: {
                      locationName: "transitGatewayAttachmentId"
                    },
                    TransitGatewayId: {
                      locationName: "transitGatewayId"
                    },
                    TransitGatewayOwnerId: {
                      locationName: "transitGatewayOwnerId"
                    },
                    ResourceOwnerId: {
                      locationName: "resourceOwnerId"
                    },
                    ResourceType: {
                      locationName: "resourceType"
                    },
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    State: {
                      locationName: "state"
                    },
                    Association: {
                      locationName: "association",
                      type: "structure",
                      members: {
                        TransitGatewayRouteTableId: {
                          locationName: "transitGatewayRouteTableId"
                        },
                        State: {
                          locationName: "state"
                        }
                      }
                    },
                    CreationTime: {
                      locationName: "creationTime",
                      type: "timestamp"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTransitGatewayConnectPeers: {
          input: {
            type: "structure",
            members: {
              TransitGatewayConnectPeerIds: {
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayConnectPeers: {
                locationName: "transitGatewayConnectPeerSet",
                type: "list",
                member: {
                  shape: "Sj6",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTransitGatewayConnects: {
          input: {
            type: "structure",
            members: {
              TransitGatewayAttachmentIds: {
                shape: "S1cz"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayConnects: {
                locationName: "transitGatewayConnectSet",
                type: "list",
                member: {
                  shape: "Sj0",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTransitGatewayMulticastDomains: {
          input: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomainIds: {
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomains: {
                locationName: "transitGatewayMulticastDomains",
                type: "list",
                member: {
                  shape: "Sjj",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTransitGatewayPeeringAttachments: {
          input: {
            type: "structure",
            members: {
              TransitGatewayAttachmentIds: {
                shape: "S1cz"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPeeringAttachments: {
                locationName: "transitGatewayPeeringAttachments",
                type: "list",
                member: {
                  shape: "Sn",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTransitGatewayRouteTables: {
          input: {
            type: "structure",
            members: {
              TransitGatewayRouteTableIds: {
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayRouteTables: {
                locationName: "transitGatewayRouteTables",
                type: "list",
                member: {
                  shape: "Sk3",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTransitGatewayVpcAttachments: {
          input: {
            type: "structure",
            members: {
              TransitGatewayAttachmentIds: {
                shape: "S1cz"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayVpcAttachments: {
                locationName: "transitGatewayVpcAttachments",
                type: "list",
                member: {
                  shape: "Sw",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTransitGateways: {
          input: {
            type: "structure",
            members: {
              TransitGatewayIds: {
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGateways: {
                locationName: "transitGatewaySet",
                type: "list",
                member: {
                  shape: "Sit",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeTrunkInterfaceAssociations: {
          input: {
            type: "structure",
            members: {
              AssociationIds: {
                locationName: "AssociationId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InterfaceAssociations: {
                locationName: "interfaceAssociationSet",
                type: "list",
                member: {
                  shape: "S45",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVolumeAttribute: {
          input: {
            type: "structure",
            required: [
              "Attribute",
              "VolumeId"
            ],
            members: {
              Attribute: {},
              VolumeId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AutoEnableIO: {
                shape: "Sz3",
                locationName: "autoEnableIO"
              },
              ProductCodes: {
                shape: "Swg",
                locationName: "productCodes"
              },
              VolumeId: {
                locationName: "volumeId"
              }
            }
          }
        },
        DescribeVolumeStatus: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              VolumeIds: {
                shape: "S1e3",
                locationName: "VolumeId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              VolumeStatuses: {
                locationName: "volumeStatusSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Actions: {
                      locationName: "actionsSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          Code: {
                            locationName: "code"
                          },
                          Description: {
                            locationName: "description"
                          },
                          EventId: {
                            locationName: "eventId"
                          },
                          EventType: {
                            locationName: "eventType"
                          }
                        }
                      }
                    },
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    OutpostArn: {
                      locationName: "outpostArn"
                    },
                    Events: {
                      locationName: "eventsSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          Description: {
                            locationName: "description"
                          },
                          EventId: {
                            locationName: "eventId"
                          },
                          EventType: {
                            locationName: "eventType"
                          },
                          NotAfter: {
                            locationName: "notAfter",
                            type: "timestamp"
                          },
                          NotBefore: {
                            locationName: "notBefore",
                            type: "timestamp"
                          },
                          InstanceId: {
                            locationName: "instanceId"
                          }
                        }
                      }
                    },
                    VolumeId: {
                      locationName: "volumeId"
                    },
                    VolumeStatus: {
                      locationName: "volumeStatus",
                      type: "structure",
                      members: {
                        Details: {
                          locationName: "details",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "structure",
                            members: {
                              Name: {
                                locationName: "name"
                              },
                              Status: {
                                locationName: "status"
                              }
                            }
                          }
                        },
                        Status: {
                          locationName: "status"
                        }
                      }
                    },
                    AttachmentStatuses: {
                      locationName: "attachmentStatuses",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          IoPerformance: {
                            locationName: "ioPerformance"
                          },
                          InstanceId: {
                            locationName: "instanceId"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeVolumes: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              VolumeIds: {
                shape: "S1e3",
                locationName: "VolumeId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Volumes: {
                locationName: "volumeSet",
                type: "list",
                member: {
                  shape: "Sk9",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVolumesModifications: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              VolumeIds: {
                shape: "S1e3",
                locationName: "VolumeId"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VolumesModifications: {
                locationName: "volumeModificationSet",
                type: "list",
                member: {
                  shape: "S1eo",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVpcAttribute: {
          input: {
            type: "structure",
            required: [
              "Attribute",
              "VpcId"
            ],
            members: {
              Attribute: {},
              VpcId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpcId: {
                locationName: "vpcId"
              },
              EnableDnsHostnames: {
                shape: "Sz3",
                locationName: "enableDnsHostnames"
              },
              EnableDnsSupport: {
                shape: "Sz3",
                locationName: "enableDnsSupport"
              }
            }
          }
        },
        DescribeVpcClassicLink: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcIds: {
                shape: "S1eu",
                locationName: "VpcId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Vpcs: {
                locationName: "vpcSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ClassicLinkEnabled: {
                      locationName: "classicLinkEnabled",
                      type: "boolean"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    },
                    VpcId: {
                      locationName: "vpcId"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeVpcClassicLinkDnsSupport: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              },
              VpcIds: {
                shape: "S1eu"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Vpcs: {
                locationName: "vpcs",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ClassicLinkDnsSupported: {
                      locationName: "classicLinkDnsSupported",
                      type: "boolean"
                    },
                    VpcId: {
                      locationName: "vpcId"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeVpcEndpointConnectionNotifications: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              ConnectionNotificationId: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionNotificationSet: {
                locationName: "connectionNotificationSet",
                type: "list",
                member: {
                  shape: "Skt",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVpcEndpointConnections: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VpcEndpointConnections: {
                locationName: "vpcEndpointConnectionSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ServiceId: {
                      locationName: "serviceId"
                    },
                    VpcEndpointId: {
                      locationName: "vpcEndpointId"
                    },
                    VpcEndpointOwner: {
                      locationName: "vpcEndpointOwner"
                    },
                    VpcEndpointState: {
                      locationName: "vpcEndpointState"
                    },
                    CreationTimestamp: {
                      locationName: "creationTimestamp",
                      type: "timestamp"
                    },
                    DnsEntries: {
                      shape: "Sko",
                      locationName: "dnsEntrySet"
                    },
                    NetworkLoadBalancerArns: {
                      shape: "Se",
                      locationName: "networkLoadBalancerArnSet"
                    },
                    GatewayLoadBalancerArns: {
                      shape: "Se",
                      locationName: "gatewayLoadBalancerArnSet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVpcEndpointServiceConfigurations: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceIds: {
                shape: "Spx",
                locationName: "ServiceId"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceConfigurations: {
                locationName: "serviceConfigurationSet",
                type: "list",
                member: {
                  shape: "Sky",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVpcEndpointServicePermissions: {
          input: {
            type: "structure",
            required: [
              "ServiceId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceId: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AllowedPrincipals: {
                locationName: "allowedPrincipals",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    PrincipalType: {
                      locationName: "principalType"
                    },
                    Principal: {
                      locationName: "principal"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVpcEndpointServices: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceNames: {
                shape: "Se",
                locationName: "ServiceName"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceNames: {
                shape: "Se",
                locationName: "serviceNameSet"
              },
              ServiceDetails: {
                locationName: "serviceDetailSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ServiceName: {
                      locationName: "serviceName"
                    },
                    ServiceId: {
                      locationName: "serviceId"
                    },
                    ServiceType: {
                      shape: "Skz",
                      locationName: "serviceType"
                    },
                    AvailabilityZones: {
                      shape: "Se",
                      locationName: "availabilityZoneSet"
                    },
                    Owner: {
                      locationName: "owner"
                    },
                    BaseEndpointDnsNames: {
                      shape: "Se",
                      locationName: "baseEndpointDnsNameSet"
                    },
                    PrivateDnsName: {
                      locationName: "privateDnsName"
                    },
                    PrivateDnsNames: {
                      locationName: "privateDnsNameSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          PrivateDnsName: {
                            locationName: "privateDnsName"
                          }
                        }
                      }
                    },
                    VpcEndpointPolicySupported: {
                      locationName: "vpcEndpointPolicySupported",
                      type: "boolean"
                    },
                    AcceptanceRequired: {
                      locationName: "acceptanceRequired",
                      type: "boolean"
                    },
                    ManagesVpcEndpoints: {
                      locationName: "managesVpcEndpoints",
                      type: "boolean"
                    },
                    Tags: {
                      shape: "Ss",
                      locationName: "tagSet"
                    },
                    PrivateDnsNameVerificationState: {
                      locationName: "privateDnsNameVerificationState"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVpcEndpoints: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              VpcEndpointIds: {
                shape: "S13",
                locationName: "VpcEndpointId"
              },
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VpcEndpoints: {
                locationName: "vpcEndpointSet",
                type: "list",
                member: {
                  shape: "Skk",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVpcPeeringConnections: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcPeeringConnectionIds: {
                locationName: "VpcPeeringConnectionId",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpcPeeringConnections: {
                locationName: "vpcPeeringConnectionSet",
                type: "list",
                member: {
                  shape: "S1c",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVpcs: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              VpcIds: {
                locationName: "VpcId",
                type: "list",
                member: {
                  locationName: "VpcId"
                }
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Vpcs: {
                locationName: "vpcSet",
                type: "list",
                member: {
                  shape: "S95",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeVpnConnections: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              VpnConnectionIds: {
                locationName: "VpnConnectionId",
                type: "list",
                member: {
                  locationName: "VpnConnectionId"
                }
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnConnections: {
                locationName: "vpnConnectionSet",
                type: "list",
                member: {
                  shape: "Sls",
                  locationName: "item"
                }
              }
            }
          }
        },
        DescribeVpnGateways: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              VpnGatewayIds: {
                locationName: "VpnGatewayId",
                type: "list",
                member: {
                  locationName: "VpnGatewayId"
                }
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnGateways: {
                locationName: "vpnGatewaySet",
                type: "list",
                member: {
                  shape: "Sml",
                  locationName: "item"
                }
              }
            }
          }
        },
        DetachClassicLinkVpc: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "VpcId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              VpcId: {
                locationName: "vpcId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        DetachInternetGateway: {
          input: {
            type: "structure",
            required: [
              "InternetGatewayId",
              "VpcId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InternetGatewayId: {
                locationName: "internetGatewayId"
              },
              VpcId: {
                locationName: "vpcId"
              }
            }
          }
        },
        DetachNetworkInterface: {
          input: {
            type: "structure",
            required: [
              "AttachmentId"
            ],
            members: {
              AttachmentId: {
                locationName: "attachmentId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Force: {
                locationName: "force",
                type: "boolean"
              }
            }
          }
        },
        DetachVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              Device: {},
              Force: {
                type: "boolean"
              },
              InstanceId: {},
              VolumeId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S4o"
          }
        },
        DetachVpnGateway: {
          input: {
            type: "structure",
            required: [
              "VpcId",
              "VpnGatewayId"
            ],
            members: {
              VpcId: {},
              VpnGatewayId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DisableEbsEncryptionByDefault: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EbsEncryptionByDefault: {
                locationName: "ebsEncryptionByDefault",
                type: "boolean"
              }
            }
          }
        },
        DisableFastSnapshotRestores: {
          input: {
            type: "structure",
            required: [
              "AvailabilityZones",
              "SourceSnapshotIds"
            ],
            members: {
              AvailabilityZones: {
                shape: "S1gk",
                locationName: "AvailabilityZone"
              },
              SourceSnapshotIds: {
                shape: "S1a8",
                locationName: "SourceSnapshotId"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Successful: {
                locationName: "successful",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    SnapshotId: {
                      locationName: "snapshotId"
                    },
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    State: {
                      locationName: "state"
                    },
                    StateTransitionReason: {
                      locationName: "stateTransitionReason"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    OwnerAlias: {
                      locationName: "ownerAlias"
                    },
                    EnablingTime: {
                      locationName: "enablingTime",
                      type: "timestamp"
                    },
                    OptimizingTime: {
                      locationName: "optimizingTime",
                      type: "timestamp"
                    },
                    EnabledTime: {
                      locationName: "enabledTime",
                      type: "timestamp"
                    },
                    DisablingTime: {
                      locationName: "disablingTime",
                      type: "timestamp"
                    },
                    DisabledTime: {
                      locationName: "disabledTime",
                      type: "timestamp"
                    }
                  }
                }
              },
              Unsuccessful: {
                locationName: "unsuccessful",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    SnapshotId: {
                      locationName: "snapshotId"
                    },
                    FastSnapshotRestoreStateErrors: {
                      locationName: "fastSnapshotRestoreStateErrorSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          AvailabilityZone: {
                            locationName: "availabilityZone"
                          },
                          Error: {
                            locationName: "error",
                            type: "structure",
                            members: {
                              Code: {
                                locationName: "code"
                              },
                              Message: {
                                locationName: "message"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DisableImageDeprecation: {
          input: {
            type: "structure",
            required: [
              "ImageId"
            ],
            members: {
              ImageId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        DisableSerialConsoleAccess: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SerialConsoleAccessEnabled: {
                locationName: "serialConsoleAccessEnabled",
                type: "boolean"
              }
            }
          }
        },
        DisableTransitGatewayRouteTablePropagation: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId",
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Propagation: {
                shape: "S1gz",
                locationName: "propagation"
              }
            }
          }
        },
        DisableVgwRoutePropagation: {
          input: {
            type: "structure",
            required: [
              "GatewayId",
              "RouteTableId"
            ],
            members: {
              GatewayId: {},
              RouteTableId: {},
              DryRun: {
                type: "boolean"
              }
            }
          }
        },
        DisableVpcClassicLink: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcId: {
                locationName: "vpcId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        DisableVpcClassicLinkDnsSupport: {
          input: {
            type: "structure",
            members: {
              VpcId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        DisassociateAddress: {
          input: {
            type: "structure",
            members: {
              AssociationId: {},
              PublicIp: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DisassociateClientVpnTargetNetwork: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId",
              "AssociationId"
            ],
            members: {
              ClientVpnEndpointId: {},
              AssociationId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationId: {
                locationName: "associationId"
              },
              Status: {
                shape: "S2r",
                locationName: "status"
              }
            }
          }
        },
        DisassociateEnclaveCertificateIamRole: {
          input: {
            type: "structure",
            members: {
              CertificateArn: {},
              RoleArn: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        DisassociateIamInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "AssociationId"
            ],
            members: {
              AssociationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IamInstanceProfileAssociation: {
                shape: "S31",
                locationName: "iamInstanceProfileAssociation"
              }
            }
          }
        },
        DisassociateInstanceEventWindow: {
          input: {
            type: "structure",
            required: [
              "InstanceEventWindowId",
              "AssociationTarget"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceEventWindowId: {},
              AssociationTarget: {
                type: "structure",
                members: {
                  InstanceIds: {
                    shape: "S37",
                    locationName: "InstanceId"
                  },
                  InstanceTags: {
                    shape: "Ss",
                    locationName: "InstanceTag"
                  },
                  DedicatedHostIds: {
                    shape: "S38",
                    locationName: "DedicatedHostId"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceEventWindow: {
                shape: "S3b",
                locationName: "instanceEventWindow"
              }
            }
          }
        },
        DisassociateRouteTable: {
          input: {
            type: "structure",
            required: [
              "AssociationId"
            ],
            members: {
              AssociationId: {
                locationName: "associationId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        DisassociateSubnetCidrBlock: {
          input: {
            type: "structure",
            required: [
              "AssociationId"
            ],
            members: {
              AssociationId: {
                locationName: "associationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Ipv6CidrBlockAssociation: {
                shape: "S3r",
                locationName: "ipv6CidrBlockAssociation"
              },
              SubnetId: {
                locationName: "subnetId"
              }
            }
          }
        },
        DisassociateTransitGatewayMulticastDomain: {
          input: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomainId: {},
              TransitGatewayAttachmentId: {},
              SubnetIds: {
                shape: "S3w"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Associations: {
                shape: "Sg",
                locationName: "associations"
              }
            }
          }
        },
        DisassociateTransitGatewayRouteTable: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId",
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Association: {
                shape: "S41",
                locationName: "association"
              }
            }
          }
        },
        DisassociateTrunkInterface: {
          input: {
            type: "structure",
            required: [
              "AssociationId"
            ],
            members: {
              AssociationId: {},
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              },
              ClientToken: {
                locationName: "clientToken"
              }
            }
          }
        },
        DisassociateVpcCidrBlock: {
          input: {
            type: "structure",
            required: [
              "AssociationId"
            ],
            members: {
              AssociationId: {
                locationName: "associationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Ipv6CidrBlockAssociation: {
                shape: "S4b",
                locationName: "ipv6CidrBlockAssociation"
              },
              CidrBlockAssociation: {
                shape: "S4e",
                locationName: "cidrBlockAssociation"
              },
              VpcId: {
                locationName: "vpcId"
              }
            }
          }
        },
        EnableEbsEncryptionByDefault: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EbsEncryptionByDefault: {
                locationName: "ebsEncryptionByDefault",
                type: "boolean"
              }
            }
          }
        },
        EnableFastSnapshotRestores: {
          input: {
            type: "structure",
            required: [
              "AvailabilityZones",
              "SourceSnapshotIds"
            ],
            members: {
              AvailabilityZones: {
                shape: "S1gk",
                locationName: "AvailabilityZone"
              },
              SourceSnapshotIds: {
                shape: "S1a8",
                locationName: "SourceSnapshotId"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Successful: {
                locationName: "successful",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    SnapshotId: {
                      locationName: "snapshotId"
                    },
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    State: {
                      locationName: "state"
                    },
                    StateTransitionReason: {
                      locationName: "stateTransitionReason"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    },
                    OwnerAlias: {
                      locationName: "ownerAlias"
                    },
                    EnablingTime: {
                      locationName: "enablingTime",
                      type: "timestamp"
                    },
                    OptimizingTime: {
                      locationName: "optimizingTime",
                      type: "timestamp"
                    },
                    EnabledTime: {
                      locationName: "enabledTime",
                      type: "timestamp"
                    },
                    DisablingTime: {
                      locationName: "disablingTime",
                      type: "timestamp"
                    },
                    DisabledTime: {
                      locationName: "disabledTime",
                      type: "timestamp"
                    }
                  }
                }
              },
              Unsuccessful: {
                locationName: "unsuccessful",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    SnapshotId: {
                      locationName: "snapshotId"
                    },
                    FastSnapshotRestoreStateErrors: {
                      locationName: "fastSnapshotRestoreStateErrorSet",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          AvailabilityZone: {
                            locationName: "availabilityZone"
                          },
                          Error: {
                            locationName: "error",
                            type: "structure",
                            members: {
                              Code: {
                                locationName: "code"
                              },
                              Message: {
                                locationName: "message"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        EnableImageDeprecation: {
          input: {
            type: "structure",
            required: [
              "ImageId",
              "DeprecateAt"
            ],
            members: {
              ImageId: {},
              DeprecateAt: {
                type: "timestamp"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        EnableSerialConsoleAccess: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SerialConsoleAccessEnabled: {
                locationName: "serialConsoleAccessEnabled",
                type: "boolean"
              }
            }
          }
        },
        EnableTransitGatewayRouteTablePropagation: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId",
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Propagation: {
                shape: "S1gz",
                locationName: "propagation"
              }
            }
          }
        },
        EnableVgwRoutePropagation: {
          input: {
            type: "structure",
            required: [
              "GatewayId",
              "RouteTableId"
            ],
            members: {
              GatewayId: {},
              RouteTableId: {},
              DryRun: {
                type: "boolean"
              }
            }
          }
        },
        EnableVolumeIO: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VolumeId: {
                locationName: "volumeId"
              }
            }
          }
        },
        EnableVpcClassicLink: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcId: {
                locationName: "vpcId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        EnableVpcClassicLinkDnsSupport: {
          input: {
            type: "structure",
            members: {
              VpcId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ExportClientVpnClientCertificateRevocationList: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId"
            ],
            members: {
              ClientVpnEndpointId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CertificateRevocationList: {
                locationName: "certificateRevocationList"
              },
              Status: {
                locationName: "status",
                type: "structure",
                members: {
                  Code: {
                    locationName: "code"
                  },
                  Message: {
                    locationName: "message"
                  }
                }
              }
            }
          }
        },
        ExportClientVpnClientConfiguration: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId"
            ],
            members: {
              ClientVpnEndpointId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientConfiguration: {
                locationName: "clientConfiguration"
              }
            }
          }
        },
        ExportImage: {
          input: {
            type: "structure",
            required: [
              "DiskImageFormat",
              "ImageId",
              "S3ExportLocation"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              Description: {},
              DiskImageFormat: {},
              DryRun: {
                type: "boolean"
              },
              ImageId: {},
              S3ExportLocation: {
                type: "structure",
                required: [
                  "S3Bucket"
                ],
                members: {
                  S3Bucket: {},
                  S3Prefix: {}
                }
              },
              RoleName: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Description: {
                locationName: "description"
              },
              DiskImageFormat: {
                locationName: "diskImageFormat"
              },
              ExportImageTaskId: {
                locationName: "exportImageTaskId"
              },
              ImageId: {
                locationName: "imageId"
              },
              RoleName: {
                locationName: "roleName"
              },
              Progress: {
                locationName: "progress"
              },
              S3ExportLocation: {
                shape: "Suz",
                locationName: "s3ExportLocation"
              },
              Status: {
                locationName: "status"
              },
              StatusMessage: {
                locationName: "statusMessage"
              },
              Tags: {
                shape: "Ss",
                locationName: "tagSet"
              }
            }
          }
        },
        ExportTransitGatewayRoutes: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId",
              "S3Bucket"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              S3Bucket: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              S3Location: {
                locationName: "s3Location"
              }
            }
          }
        },
        GetAssociatedEnclaveCertificateIamRoles: {
          input: {
            type: "structure",
            members: {
              CertificateArn: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssociatedRoles: {
                locationName: "associatedRoleSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AssociatedRoleArn: {
                      locationName: "associatedRoleArn"
                    },
                    CertificateS3BucketName: {
                      locationName: "certificateS3BucketName"
                    },
                    CertificateS3ObjectKey: {
                      locationName: "certificateS3ObjectKey"
                    },
                    EncryptionKmsKeyId: {
                      locationName: "encryptionKmsKeyId"
                    }
                  }
                }
              }
            }
          }
        },
        GetAssociatedIpv6PoolCidrs: {
          input: {
            type: "structure",
            required: [
              "PoolId"
            ],
            members: {
              PoolId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Ipv6CidrAssociations: {
                locationName: "ipv6CidrAssociationSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Ipv6Cidr: {
                      locationName: "ipv6Cidr"
                    },
                    AssociatedResource: {
                      locationName: "associatedResource"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetCapacityReservationUsage: {
          input: {
            type: "structure",
            required: [
              "CapacityReservationId"
            ],
            members: {
              CapacityReservationId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              CapacityReservationId: {
                locationName: "capacityReservationId"
              },
              InstanceType: {
                locationName: "instanceType"
              },
              TotalInstanceCount: {
                locationName: "totalInstanceCount",
                type: "integer"
              },
              AvailableInstanceCount: {
                locationName: "availableInstanceCount",
                type: "integer"
              },
              State: {
                locationName: "state"
              },
              InstanceUsages: {
                locationName: "instanceUsageSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AccountId: {
                      locationName: "accountId"
                    },
                    UsedInstanceCount: {
                      locationName: "usedInstanceCount",
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        GetCoipPoolUsage: {
          input: {
            type: "structure",
            required: [
              "PoolId"
            ],
            members: {
              PoolId: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CoipPoolId: {
                locationName: "coipPoolId"
              },
              CoipAddressUsages: {
                locationName: "coipAddressUsageSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    AllocationId: {
                      locationName: "allocationId"
                    },
                    AwsAccountId: {
                      locationName: "awsAccountId"
                    },
                    AwsService: {
                      locationName: "awsService"
                    },
                    CoIp: {
                      locationName: "coIp"
                    }
                  }
                }
              },
              LocalGatewayRouteTableId: {
                locationName: "localGatewayRouteTableId"
              }
            }
          }
        },
        GetConsoleOutput: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Latest: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceId: {
                locationName: "instanceId"
              },
              Output: {
                locationName: "output"
              },
              Timestamp: {
                locationName: "timestamp",
                type: "timestamp"
              }
            }
          }
        },
        GetConsoleScreenshot: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceId: {},
              WakeUp: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageData: {
                locationName: "imageData"
              },
              InstanceId: {
                locationName: "instanceId"
              }
            }
          }
        },
        GetDefaultCreditSpecification: {
          input: {
            type: "structure",
            required: [
              "InstanceFamily"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceFamily: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceFamilyCreditSpecification: {
                shape: "S1jh",
                locationName: "instanceFamilyCreditSpecification"
              }
            }
          }
        },
        GetEbsDefaultKmsKeyId: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KmsKeyId: {
                locationName: "kmsKeyId"
              }
            }
          }
        },
        GetEbsEncryptionByDefault: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EbsEncryptionByDefault: {
                locationName: "ebsEncryptionByDefault",
                type: "boolean"
              }
            }
          }
        },
        GetFlowLogsIntegrationTemplate: {
          input: {
            type: "structure",
            required: [
              "FlowLogId",
              "ConfigDeliveryS3DestinationArn",
              "IntegrateServices"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              FlowLogId: {},
              ConfigDeliveryS3DestinationArn: {},
              IntegrateServices: {
                locationName: "IntegrateService",
                type: "structure",
                members: {
                  AthenaIntegrations: {
                    locationName: "AthenaIntegration",
                    type: "list",
                    member: {
                      locationName: "item",
                      type: "structure",
                      required: [
                        "IntegrationResultS3DestinationArn",
                        "PartitionLoadFrequency"
                      ],
                      members: {
                        IntegrationResultS3DestinationArn: {},
                        PartitionLoadFrequency: {},
                        PartitionStartDate: {
                          type: "timestamp"
                        },
                        PartitionEndDate: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Result: {
                locationName: "result"
              }
            }
          }
        },
        GetGroupsForCapacityReservation: {
          input: {
            type: "structure",
            required: [
              "CapacityReservationId"
            ],
            members: {
              CapacityReservationId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              CapacityReservationGroups: {
                locationName: "capacityReservationGroupSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    GroupArn: {
                      locationName: "groupArn"
                    },
                    OwnerId: {
                      locationName: "ownerId"
                    }
                  }
                }
              }
            }
          }
        },
        GetHostReservationPurchasePreview: {
          input: {
            type: "structure",
            required: [
              "HostIdSet",
              "OfferingId"
            ],
            members: {
              HostIdSet: {
                shape: "S1jy"
              },
              OfferingId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CurrencyCode: {
                locationName: "currencyCode"
              },
              Purchase: {
                shape: "S1k0",
                locationName: "purchase"
              },
              TotalHourlyPrice: {
                locationName: "totalHourlyPrice"
              },
              TotalUpfrontPrice: {
                locationName: "totalUpfrontPrice"
              }
            }
          }
        },
        GetLaunchTemplateData: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LaunchTemplateData: {
                shape: "Sdh",
                locationName: "launchTemplateData"
              }
            }
          }
        },
        GetManagedPrefixListAssociations: {
          input: {
            type: "structure",
            required: [
              "PrefixListId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              PrefixListId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PrefixListAssociations: {
                locationName: "prefixListAssociationSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    ResourceOwner: {
                      locationName: "resourceOwner"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetManagedPrefixListEntries: {
          input: {
            type: "structure",
            required: [
              "PrefixListId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              PrefixListId: {},
              TargetVersion: {
                type: "long"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Entries: {
                locationName: "entrySet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Cidr: {
                      locationName: "cidr"
                    },
                    Description: {
                      locationName: "description"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetPasswordData: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceId: {
                locationName: "instanceId"
              },
              PasswordData: {
                locationName: "passwordData"
              },
              Timestamp: {
                locationName: "timestamp",
                type: "timestamp"
              }
            }
          }
        },
        GetReservedInstancesExchangeQuote: {
          input: {
            type: "structure",
            required: [
              "ReservedInstanceIds"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ReservedInstanceIds: {
                shape: "S3",
                locationName: "ReservedInstanceId"
              },
              TargetConfigurations: {
                shape: "S5",
                locationName: "TargetConfiguration"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CurrencyCode: {
                locationName: "currencyCode"
              },
              IsValidExchange: {
                locationName: "isValidExchange",
                type: "boolean"
              },
              OutputReservedInstancesWillExpireAt: {
                locationName: "outputReservedInstancesWillExpireAt",
                type: "timestamp"
              },
              PaymentDue: {
                locationName: "paymentDue"
              },
              ReservedInstanceValueRollup: {
                shape: "S1kh",
                locationName: "reservedInstanceValueRollup"
              },
              ReservedInstanceValueSet: {
                locationName: "reservedInstanceValueSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ReservationValue: {
                      shape: "S1kh",
                      locationName: "reservationValue"
                    },
                    ReservedInstanceId: {
                      locationName: "reservedInstanceId"
                    }
                  }
                }
              },
              TargetConfigurationValueRollup: {
                shape: "S1kh",
                locationName: "targetConfigurationValueRollup"
              },
              TargetConfigurationValueSet: {
                locationName: "targetConfigurationValueSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ReservationValue: {
                      shape: "S1kh",
                      locationName: "reservationValue"
                    },
                    TargetConfiguration: {
                      locationName: "targetConfiguration",
                      type: "structure",
                      members: {
                        InstanceCount: {
                          locationName: "instanceCount",
                          type: "integer"
                        },
                        OfferingId: {
                          locationName: "offeringId"
                        }
                      }
                    }
                  }
                }
              },
              ValidationFailureReason: {
                locationName: "validationFailureReason"
              }
            }
          }
        },
        GetSerialConsoleAccessStatus: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SerialConsoleAccessEnabled: {
                locationName: "serialConsoleAccessEnabled",
                type: "boolean"
              }
            }
          }
        },
        GetSubnetCidrReservations: {
          input: {
            type: "structure",
            required: [
              "SubnetId"
            ],
            members: {
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              SubnetId: {},
              DryRun: {
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SubnetIpv4CidrReservations: {
                shape: "S1ks",
                locationName: "subnetIpv4CidrReservationSet"
              },
              SubnetIpv6CidrReservations: {
                shape: "S1ks",
                locationName: "subnetIpv6CidrReservationSet"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetTransitGatewayAttachmentPropagations: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayAttachmentId: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayAttachmentPropagations: {
                locationName: "transitGatewayAttachmentPropagations",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    TransitGatewayRouteTableId: {
                      locationName: "transitGatewayRouteTableId"
                    },
                    State: {
                      locationName: "state"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetTransitGatewayMulticastDomainAssociations: {
          input: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomainId: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MulticastDomainAssociations: {
                locationName: "multicastDomainAssociations",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    TransitGatewayAttachmentId: {
                      locationName: "transitGatewayAttachmentId"
                    },
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    ResourceType: {
                      locationName: "resourceType"
                    },
                    ResourceOwnerId: {
                      locationName: "resourceOwnerId"
                    },
                    Subnet: {
                      shape: "Sj",
                      locationName: "subnet"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetTransitGatewayPrefixListReferences: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPrefixListReferences: {
                locationName: "transitGatewayPrefixListReferenceSet",
                type: "list",
                member: {
                  shape: "Sjr",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetTransitGatewayRouteTableAssociations: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Associations: {
                locationName: "associations",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    TransitGatewayAttachmentId: {
                      locationName: "transitGatewayAttachmentId"
                    },
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    ResourceType: {
                      locationName: "resourceType"
                    },
                    State: {
                      locationName: "state"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetTransitGatewayRouteTablePropagations: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayRouteTablePropagations: {
                locationName: "transitGatewayRouteTablePropagations",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    TransitGatewayAttachmentId: {
                      locationName: "transitGatewayAttachmentId"
                    },
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    ResourceType: {
                      locationName: "resourceType"
                    },
                    State: {
                      locationName: "state"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetVpnConnectionDeviceSampleConfiguration: {
          input: {
            type: "structure",
            required: [
              "VpnConnectionId",
              "VpnConnectionDeviceTypeId"
            ],
            members: {
              VpnConnectionId: {},
              VpnConnectionDeviceTypeId: {},
              InternetKeyExchangeVersion: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnConnectionDeviceSampleConfiguration: {
                locationName: "vpnConnectionDeviceSampleConfiguration",
                type: "string",
                sensitive: true
              }
            }
          }
        },
        GetVpnConnectionDeviceTypes: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnConnectionDeviceTypes: {
                locationName: "vpnConnectionDeviceTypeSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    VpnConnectionDeviceTypeId: {
                      locationName: "vpnConnectionDeviceTypeId"
                    },
                    Vendor: {
                      locationName: "vendor"
                    },
                    Platform: {
                      locationName: "platform"
                    },
                    Software: {
                      locationName: "software"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ImportClientVpnClientCertificateRevocationList: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId",
              "CertificateRevocationList"
            ],
            members: {
              ClientVpnEndpointId: {},
              CertificateRevocationList: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ImportImage: {
          input: {
            type: "structure",
            members: {
              Architecture: {},
              ClientData: {
                shape: "S1lo"
              },
              ClientToken: {},
              Description: {},
              DiskContainers: {
                locationName: "DiskContainer",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Description: {},
                    DeviceName: {},
                    Format: {},
                    SnapshotId: {},
                    Url: {},
                    UserBucket: {
                      shape: "S1lr"
                    }
                  }
                }
              },
              DryRun: {
                type: "boolean"
              },
              Encrypted: {
                type: "boolean"
              },
              Hypervisor: {},
              KmsKeyId: {},
              LicenseType: {},
              Platform: {},
              RoleName: {},
              LicenseSpecifications: {
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    LicenseConfigurationArn: {}
                  }
                }
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              UsageOperation: {},
              BootMode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Architecture: {
                locationName: "architecture"
              },
              Description: {
                locationName: "description"
              },
              Encrypted: {
                locationName: "encrypted",
                type: "boolean"
              },
              Hypervisor: {
                locationName: "hypervisor"
              },
              ImageId: {
                locationName: "imageId"
              },
              ImportTaskId: {
                locationName: "importTaskId"
              },
              KmsKeyId: {
                locationName: "kmsKeyId"
              },
              LicenseType: {
                locationName: "licenseType"
              },
              Platform: {
                locationName: "platform"
              },
              Progress: {
                locationName: "progress"
              },
              SnapshotDetails: {
                shape: "Syl",
                locationName: "snapshotDetailSet"
              },
              Status: {
                locationName: "status"
              },
              StatusMessage: {
                locationName: "statusMessage"
              },
              LicenseSpecifications: {
                shape: "Syo",
                locationName: "licenseSpecifications"
              },
              Tags: {
                shape: "Ss",
                locationName: "tagSet"
              },
              UsageOperation: {
                locationName: "usageOperation"
              }
            }
          }
        },
        ImportInstance: {
          input: {
            type: "structure",
            required: [
              "Platform"
            ],
            members: {
              Description: {
                locationName: "description"
              },
              DiskImages: {
                locationName: "diskImage",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Description: {},
                    Image: {
                      shape: "S1ly"
                    },
                    Volume: {
                      shape: "S1lz"
                    }
                  }
                }
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              LaunchSpecification: {
                locationName: "launchSpecification",
                type: "structure",
                members: {
                  AdditionalInfo: {
                    locationName: "additionalInfo"
                  },
                  Architecture: {
                    locationName: "architecture"
                  },
                  GroupIds: {
                    shape: "Sc4",
                    locationName: "GroupId"
                  },
                  GroupNames: {
                    shape: "Scq",
                    locationName: "GroupName"
                  },
                  InstanceInitiatedShutdownBehavior: {
                    locationName: "instanceInitiatedShutdownBehavior"
                  },
                  InstanceType: {
                    locationName: "instanceType"
                  },
                  Monitoring: {
                    locationName: "monitoring",
                    type: "boolean"
                  },
                  Placement: {
                    shape: "Sa8",
                    locationName: "placement"
                  },
                  PrivateIpAddress: {
                    locationName: "privateIpAddress"
                  },
                  SubnetId: {
                    locationName: "subnetId"
                  },
                  UserData: {
                    locationName: "userData",
                    type: "structure",
                    members: {
                      Data: {
                        locationName: "data"
                      }
                    },
                    sensitive: true
                  }
                }
              },
              Platform: {
                locationName: "platform"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConversionTask: {
                shape: "Stw",
                locationName: "conversionTask"
              }
            }
          }
        },
        ImportKeyPair: {
          input: {
            type: "structure",
            required: [
              "KeyName",
              "PublicKeyMaterial"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              KeyName: {
                locationName: "keyName"
              },
              PublicKeyMaterial: {
                locationName: "publicKeyMaterial",
                type: "blob"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyFingerprint: {
                locationName: "keyFingerprint"
              },
              KeyName: {
                locationName: "keyName"
              },
              KeyPairId: {
                locationName: "keyPairId"
              },
              Tags: {
                shape: "Ss",
                locationName: "tagSet"
              }
            }
          }
        },
        ImportSnapshot: {
          input: {
            type: "structure",
            members: {
              ClientData: {
                shape: "S1lo"
              },
              ClientToken: {},
              Description: {},
              DiskContainer: {
                type: "structure",
                members: {
                  Description: {},
                  Format: {},
                  Url: {},
                  UserBucket: {
                    shape: "S1lr"
                  }
                }
              },
              DryRun: {
                type: "boolean"
              },
              Encrypted: {
                type: "boolean"
              },
              KmsKeyId: {},
              RoleName: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Description: {
                locationName: "description"
              },
              ImportTaskId: {
                locationName: "importTaskId"
              },
              SnapshotTaskDetail: {
                shape: "Syw",
                locationName: "snapshotTaskDetail"
              },
              Tags: {
                shape: "Ss",
                locationName: "tagSet"
              }
            }
          }
        },
        ImportVolume: {
          input: {
            type: "structure",
            required: [
              "AvailabilityZone",
              "Image",
              "Volume"
            ],
            members: {
              AvailabilityZone: {
                locationName: "availabilityZone"
              },
              Description: {
                locationName: "description"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Image: {
                shape: "S1ly",
                locationName: "image"
              },
              Volume: {
                shape: "S1lz",
                locationName: "volume"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConversionTask: {
                shape: "Stw",
                locationName: "conversionTask"
              }
            }
          }
        },
        ModifyAddressAttribute: {
          input: {
            type: "structure",
            required: [
              "AllocationId"
            ],
            members: {
              AllocationId: {},
              DomainName: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Address: {
                shape: "Sr8",
                locationName: "address"
              }
            }
          }
        },
        ModifyAvailabilityZoneGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "OptInStatus"
            ],
            members: {
              GroupName: {},
              OptInStatus: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyCapacityReservation: {
          input: {
            type: "structure",
            required: [
              "CapacityReservationId"
            ],
            members: {
              CapacityReservationId: {},
              InstanceCount: {
                type: "integer"
              },
              EndDate: {
                type: "timestamp"
              },
              EndDateType: {},
              Accept: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyCapacityReservationFleet: {
          input: {
            type: "structure",
            required: [
              "CapacityReservationFleetId"
            ],
            members: {
              CapacityReservationFleetId: {},
              TotalTargetCapacity: {
                type: "integer"
              },
              EndDate: {
                type: "timestamp"
              },
              DryRun: {
                type: "boolean"
              },
              RemoveEndDate: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyClientVpnEndpoint: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId"
            ],
            members: {
              ClientVpnEndpointId: {},
              ServerCertificateArn: {},
              ConnectionLogOptions: {
                shape: "S8i"
              },
              DnsServers: {
                type: "structure",
                members: {
                  CustomDnsServers: {
                    shape: "Se"
                  },
                  Enabled: {
                    type: "boolean"
                  }
                }
              },
              VpnPort: {
                type: "integer"
              },
              Description: {},
              SplitTunnel: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              },
              SecurityGroupIds: {
                shape: "S25",
                locationName: "SecurityGroupId"
              },
              VpcId: {},
              SelfServicePortal: {},
              ClientConnectOptions: {
                shape: "S8l"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyDefaultCreditSpecification: {
          input: {
            type: "structure",
            required: [
              "InstanceFamily",
              "CpuCredits"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceFamily: {},
              CpuCredits: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceFamilyCreditSpecification: {
                shape: "S1jh",
                locationName: "instanceFamilyCreditSpecification"
              }
            }
          }
        },
        ModifyEbsDefaultKmsKeyId: {
          input: {
            type: "structure",
            required: [
              "KmsKeyId"
            ],
            members: {
              KmsKeyId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KmsKeyId: {
                locationName: "kmsKeyId"
              }
            }
          }
        },
        ModifyFleet: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ExcessCapacityTerminationPolicy: {},
              LaunchTemplateConfigs: {
                shape: "Sa1",
                locationName: "LaunchTemplateConfig"
              },
              FleetId: {},
              TargetCapacitySpecification: {
                shape: "Saa"
              },
              Context: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyFpgaImageAttribute: {
          input: {
            type: "structure",
            required: [
              "FpgaImageId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              FpgaImageId: {},
              Attribute: {},
              OperationType: {},
              UserIds: {
                shape: "S1mu",
                locationName: "UserId"
              },
              UserGroups: {
                shape: "S1mv",
                locationName: "UserGroup"
              },
              ProductCodes: {
                shape: "S1mw",
                locationName: "ProductCode"
              },
              LoadPermission: {
                type: "structure",
                members: {
                  Add: {
                    shape: "S1my"
                  },
                  Remove: {
                    shape: "S1my"
                  }
                }
              },
              Description: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FpgaImageAttribute: {
                shape: "Swc",
                locationName: "fpgaImageAttribute"
              }
            }
          }
        },
        ModifyHosts: {
          input: {
            type: "structure",
            required: [
              "HostIds"
            ],
            members: {
              AutoPlacement: {
                locationName: "autoPlacement"
              },
              HostIds: {
                shape: "Sx9",
                locationName: "hostId"
              },
              HostRecovery: {},
              InstanceType: {},
              InstanceFamily: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Successful: {
                shape: "S21",
                locationName: "successful"
              },
              Unsuccessful: {
                shape: "S1n3",
                locationName: "unsuccessful"
              }
            }
          }
        },
        ModifyIdFormat: {
          input: {
            type: "structure",
            required: [
              "Resource",
              "UseLongIds"
            ],
            members: {
              Resource: {},
              UseLongIds: {
                type: "boolean"
              }
            }
          }
        },
        ModifyIdentityIdFormat: {
          input: {
            type: "structure",
            required: [
              "PrincipalArn",
              "Resource",
              "UseLongIds"
            ],
            members: {
              PrincipalArn: {
                locationName: "principalArn"
              },
              Resource: {
                locationName: "resource"
              },
              UseLongIds: {
                locationName: "useLongIds",
                type: "boolean"
              }
            }
          }
        },
        ModifyImageAttribute: {
          input: {
            type: "structure",
            required: [
              "ImageId"
            ],
            members: {
              Attribute: {},
              Description: {
                shape: "S9i"
              },
              ImageId: {},
              LaunchPermission: {
                type: "structure",
                members: {
                  Add: {
                    shape: "Sxz"
                  },
                  Remove: {
                    shape: "Sxz"
                  }
                }
              },
              OperationType: {},
              ProductCodes: {
                shape: "S1mw",
                locationName: "ProductCode"
              },
              UserGroups: {
                shape: "S1mv",
                locationName: "UserGroup"
              },
              UserIds: {
                shape: "S1mu",
                locationName: "UserId"
              },
              Value: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        ModifyInstanceAttribute: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              SourceDestCheck: {
                shape: "Sz3"
              },
              Attribute: {
                locationName: "attribute"
              },
              BlockDeviceMappings: {
                locationName: "blockDeviceMapping",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    DeviceName: {
                      locationName: "deviceName"
                    },
                    Ebs: {
                      locationName: "ebs",
                      type: "structure",
                      members: {
                        DeleteOnTermination: {
                          locationName: "deleteOnTermination",
                          type: "boolean"
                        },
                        VolumeId: {
                          locationName: "volumeId"
                        }
                      }
                    },
                    NoDevice: {
                      locationName: "noDevice"
                    },
                    VirtualName: {
                      locationName: "virtualName"
                    }
                  }
                }
              },
              DisableApiTermination: {
                shape: "Sz3",
                locationName: "disableApiTermination"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              EbsOptimized: {
                shape: "Sz3",
                locationName: "ebsOptimized"
              },
              EnaSupport: {
                shape: "Sz3",
                locationName: "enaSupport"
              },
              Groups: {
                shape: "S4g",
                locationName: "GroupId"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              InstanceInitiatedShutdownBehavior: {
                shape: "S9i",
                locationName: "instanceInitiatedShutdownBehavior"
              },
              InstanceType: {
                shape: "S9i",
                locationName: "instanceType"
              },
              Kernel: {
                shape: "S9i",
                locationName: "kernel"
              },
              Ramdisk: {
                shape: "S9i",
                locationName: "ramdisk"
              },
              SriovNetSupport: {
                shape: "S9i",
                locationName: "sriovNetSupport"
              },
              UserData: {
                locationName: "userData",
                type: "structure",
                members: {
                  Value: {
                    locationName: "value",
                    type: "blob"
                  }
                }
              },
              Value: {
                locationName: "value"
              }
            }
          }
        },
        ModifyInstanceCapacityReservationAttributes: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "CapacityReservationSpecification"
            ],
            members: {
              InstanceId: {},
              CapacityReservationSpecification: {
                shape: "S1ne"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyInstanceCreditSpecification: {
          input: {
            type: "structure",
            required: [
              "InstanceCreditSpecifications"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ClientToken: {},
              InstanceCreditSpecifications: {
                locationName: "InstanceCreditSpecification",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceId: {},
                    CpuCredits: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuccessfulInstanceCreditSpecifications: {
                locationName: "successfulInstanceCreditSpecificationSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceId: {
                      locationName: "instanceId"
                    }
                  }
                }
              },
              UnsuccessfulInstanceCreditSpecifications: {
                locationName: "unsuccessfulInstanceCreditSpecificationSet",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceId: {
                      locationName: "instanceId"
                    },
                    Error: {
                      locationName: "error",
                      type: "structure",
                      members: {
                        Code: {
                          locationName: "code"
                        },
                        Message: {
                          locationName: "message"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ModifyInstanceEventStartTime: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "InstanceEventId",
              "NotBefore"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceId: {},
              InstanceEventId: {},
              NotBefore: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Event: {
                shape: "Szm",
                locationName: "event"
              }
            }
          }
        },
        ModifyInstanceEventWindow: {
          input: {
            type: "structure",
            required: [
              "InstanceEventWindowId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              Name: {},
              InstanceEventWindowId: {},
              TimeRanges: {
                shape: "Sba",
                locationName: "TimeRange"
              },
              CronExpression: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceEventWindow: {
                shape: "S3b",
                locationName: "instanceEventWindow"
              }
            }
          }
        },
        ModifyInstanceMetadataOptions: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              HttpTokens: {},
              HttpPutResponseHopLimit: {
                type: "integer"
              },
              HttpEndpoint: {},
              DryRun: {
                type: "boolean"
              },
              HttpProtocolIpv6: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceId: {
                locationName: "instanceId"
              },
              InstanceMetadataOptions: {
                shape: "S13k",
                locationName: "instanceMetadataOptions"
              }
            }
          }
        },
        ModifyInstancePlacement: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              Affinity: {
                locationName: "affinity"
              },
              GroupName: {},
              HostId: {
                locationName: "hostId"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              Tenancy: {
                locationName: "tenancy"
              },
              PartitionNumber: {
                type: "integer"
              },
              HostResourceGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyLaunchTemplate: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              ClientToken: {},
              LaunchTemplateId: {},
              LaunchTemplateName: {},
              DefaultVersion: {
                locationName: "SetDefaultVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LaunchTemplate: {
                shape: "Sda",
                locationName: "launchTemplate"
              }
            }
          }
        },
        ModifyManagedPrefixList: {
          input: {
            type: "structure",
            required: [
              "PrefixListId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              PrefixListId: {},
              CurrentVersion: {
                type: "long"
              },
              PrefixListName: {},
              AddEntries: {
                shape: "Seq",
                locationName: "AddEntry"
              },
              RemoveEntries: {
                locationName: "RemoveEntry",
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Cidr"
                  ],
                  members: {
                    Cidr: {}
                  }
                }
              },
              MaxEntries: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PrefixList: {
                shape: "Set",
                locationName: "prefixList"
              }
            }
          }
        },
        ModifyNetworkInterfaceAttribute: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfaceId"
            ],
            members: {
              Attachment: {
                locationName: "attachment",
                type: "structure",
                members: {
                  AttachmentId: {
                    locationName: "attachmentId"
                  },
                  DeleteOnTermination: {
                    locationName: "deleteOnTermination",
                    type: "boolean"
                  }
                }
              },
              Description: {
                shape: "S9i",
                locationName: "description"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Groups: {
                shape: "Sc4",
                locationName: "SecurityGroupId"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              SourceDestCheck: {
                shape: "Sz3",
                locationName: "sourceDestCheck"
              }
            }
          }
        },
        ModifyReservedInstances: {
          input: {
            type: "structure",
            required: [
              "ReservedInstancesIds",
              "TargetConfigurations"
            ],
            members: {
              ReservedInstancesIds: {
                shape: "S184",
                locationName: "ReservedInstancesId"
              },
              ClientToken: {
                locationName: "clientToken"
              },
              TargetConfigurations: {
                locationName: "ReservedInstancesConfigurationSetItemType",
                type: "list",
                member: {
                  shape: "S18q",
                  locationName: "item"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedInstancesModificationId: {
                locationName: "reservedInstancesModificationId"
              }
            }
          }
        },
        ModifySecurityGroupRules: {
          input: {
            type: "structure",
            required: [
              "GroupId",
              "SecurityGroupRules"
            ],
            members: {
              GroupId: {},
              SecurityGroupRules: {
                locationName: "SecurityGroupRule",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    SecurityGroupRuleId: {},
                    SecurityGroupRule: {
                      type: "structure",
                      members: {
                        IpProtocol: {},
                        FromPort: {
                          type: "integer"
                        },
                        ToPort: {
                          type: "integer"
                        },
                        CidrIpv4: {},
                        CidrIpv6: {},
                        PrefixListId: {},
                        ReferencedGroupId: {},
                        Description: {}
                      }
                    }
                  }
                }
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifySnapshotAttribute: {
          input: {
            type: "structure",
            required: [
              "SnapshotId"
            ],
            members: {
              Attribute: {},
              CreateVolumePermission: {
                type: "structure",
                members: {
                  Add: {
                    shape: "S1a4"
                  },
                  Remove: {
                    shape: "S1a4"
                  }
                }
              },
              GroupNames: {
                shape: "S19w",
                locationName: "UserGroup"
              },
              OperationType: {},
              SnapshotId: {},
              UserIds: {
                shape: "S1mu",
                locationName: "UserId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        ModifySpotFleetRequest: {
          input: {
            type: "structure",
            required: [
              "SpotFleetRequestId"
            ],
            members: {
              ExcessCapacityTerminationPolicy: {
                locationName: "excessCapacityTerminationPolicy"
              },
              LaunchTemplateConfigs: {
                shape: "S1b6",
                locationName: "LaunchTemplateConfig"
              },
              SpotFleetRequestId: {
                locationName: "spotFleetRequestId"
              },
              TargetCapacity: {
                locationName: "targetCapacity",
                type: "integer"
              },
              OnDemandTargetCapacity: {
                type: "integer"
              },
              Context: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifySubnetAttribute: {
          input: {
            type: "structure",
            required: [
              "SubnetId"
            ],
            members: {
              AssignIpv6AddressOnCreation: {
                shape: "Sz3"
              },
              MapPublicIpOnLaunch: {
                shape: "Sz3"
              },
              SubnetId: {
                locationName: "subnetId"
              },
              MapCustomerOwnedIpOnLaunch: {
                shape: "Sz3"
              },
              CustomerOwnedIpv4Pool: {}
            }
          }
        },
        ModifyTrafficMirrorFilterNetworkServices: {
          input: {
            type: "structure",
            required: [
              "TrafficMirrorFilterId"
            ],
            members: {
              TrafficMirrorFilterId: {},
              AddNetworkServices: {
                shape: "Si6",
                locationName: "AddNetworkService"
              },
              RemoveNetworkServices: {
                shape: "Si6",
                locationName: "RemoveNetworkService"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorFilter: {
                shape: "Si0",
                locationName: "trafficMirrorFilter"
              }
            }
          }
        },
        ModifyTrafficMirrorFilterRule: {
          input: {
            type: "structure",
            required: [
              "TrafficMirrorFilterRuleId"
            ],
            members: {
              TrafficMirrorFilterRuleId: {},
              TrafficDirection: {},
              RuleNumber: {
                type: "integer"
              },
              RuleAction: {},
              DestinationPortRange: {
                shape: "Sia"
              },
              SourcePortRange: {
                shape: "Sia"
              },
              Protocol: {
                type: "integer"
              },
              DestinationCidrBlock: {},
              SourceCidrBlock: {},
              Description: {},
              RemoveFields: {
                locationName: "RemoveField",
                type: "list",
                member: {}
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorFilterRule: {
                shape: "Si2",
                locationName: "trafficMirrorFilterRule"
              }
            }
          }
        },
        ModifyTrafficMirrorSession: {
          input: {
            type: "structure",
            required: [
              "TrafficMirrorSessionId"
            ],
            members: {
              TrafficMirrorSessionId: {},
              TrafficMirrorTargetId: {},
              TrafficMirrorFilterId: {},
              PacketLength: {
                type: "integer"
              },
              SessionNumber: {
                type: "integer"
              },
              VirtualNetworkId: {
                type: "integer"
              },
              Description: {},
              RemoveFields: {
                locationName: "RemoveField",
                type: "list",
                member: {}
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrafficMirrorSession: {
                shape: "Sif",
                locationName: "trafficMirrorSession"
              }
            }
          }
        },
        ModifyTransitGateway: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayId"
            ],
            members: {
              TransitGatewayId: {},
              Description: {},
              Options: {
                type: "structure",
                members: {
                  AddTransitGatewayCidrBlocks: {
                    shape: "Sir"
                  },
                  RemoveTransitGatewayCidrBlocks: {
                    shape: "Sir"
                  },
                  VpnEcmpSupport: {},
                  DnsSupport: {},
                  AutoAcceptSharedAttachments: {},
                  DefaultRouteTableAssociation: {},
                  AssociationDefaultRouteTableId: {},
                  DefaultRouteTablePropagation: {},
                  PropagationDefaultRouteTableId: {}
                }
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGateway: {
                shape: "Sit",
                locationName: "transitGateway"
              }
            }
          }
        },
        ModifyTransitGatewayPrefixListReference: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId",
              "PrefixListId"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              PrefixListId: {},
              TransitGatewayAttachmentId: {},
              Blackhole: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPrefixListReference: {
                shape: "Sjr",
                locationName: "transitGatewayPrefixListReference"
              }
            }
          }
        },
        ModifyTransitGatewayVpcAttachment: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayAttachmentId: {},
              AddSubnetIds: {
                shape: "S3w"
              },
              RemoveSubnetIds: {
                shape: "S3w"
              },
              Options: {
                type: "structure",
                members: {
                  DnsSupport: {},
                  Ipv6Support: {},
                  ApplianceModeSupport: {}
                }
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayVpcAttachment: {
                shape: "Sw",
                locationName: "transitGatewayVpcAttachment"
              }
            }
          }
        },
        ModifyVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              VolumeId: {},
              Size: {
                type: "integer"
              },
              VolumeType: {},
              Iops: {
                type: "integer"
              },
              Throughput: {
                type: "integer"
              },
              MultiAttachEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeModification: {
                shape: "S1eo",
                locationName: "volumeModification"
              }
            }
          }
        },
        ModifyVolumeAttribute: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              AutoEnableIO: {
                shape: "Sz3"
              },
              VolumeId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        ModifyVpcAttribute: {
          input: {
            type: "structure",
            required: [
              "VpcId"
            ],
            members: {
              EnableDnsHostnames: {
                shape: "Sz3"
              },
              EnableDnsSupport: {
                shape: "Sz3"
              },
              VpcId: {
                locationName: "vpcId"
              }
            }
          }
        },
        ModifyVpcEndpoint: {
          input: {
            type: "structure",
            required: [
              "VpcEndpointId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              VpcEndpointId: {},
              ResetPolicy: {
                type: "boolean"
              },
              PolicyDocument: {},
              AddRouteTableIds: {
                shape: "Skg",
                locationName: "AddRouteTableId"
              },
              RemoveRouteTableIds: {
                shape: "Skg",
                locationName: "RemoveRouteTableId"
              },
              AddSubnetIds: {
                shape: "Skh",
                locationName: "AddSubnetId"
              },
              RemoveSubnetIds: {
                shape: "Skh",
                locationName: "RemoveSubnetId"
              },
              AddSecurityGroupIds: {
                shape: "Ski",
                locationName: "AddSecurityGroupId"
              },
              RemoveSecurityGroupIds: {
                shape: "Ski",
                locationName: "RemoveSecurityGroupId"
              },
              PrivateDnsEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyVpcEndpointConnectionNotification: {
          input: {
            type: "structure",
            required: [
              "ConnectionNotificationId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ConnectionNotificationId: {},
              ConnectionNotificationArn: {},
              ConnectionEvents: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReturnValue: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyVpcEndpointServiceConfiguration: {
          input: {
            type: "structure",
            required: [
              "ServiceId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceId: {},
              PrivateDnsName: {},
              RemovePrivateDnsName: {
                type: "boolean"
              },
              AcceptanceRequired: {
                type: "boolean"
              },
              AddNetworkLoadBalancerArns: {
                shape: "Se",
                locationName: "AddNetworkLoadBalancerArn"
              },
              RemoveNetworkLoadBalancerArns: {
                shape: "Se",
                locationName: "RemoveNetworkLoadBalancerArn"
              },
              AddGatewayLoadBalancerArns: {
                shape: "Se",
                locationName: "AddGatewayLoadBalancerArn"
              },
              RemoveGatewayLoadBalancerArns: {
                shape: "Se",
                locationName: "RemoveGatewayLoadBalancerArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyVpcEndpointServicePermissions: {
          input: {
            type: "structure",
            required: [
              "ServiceId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceId: {},
              AddAllowedPrincipals: {
                shape: "Se"
              },
              RemoveAllowedPrincipals: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReturnValue: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyVpcPeeringConnectionOptions: {
          input: {
            type: "structure",
            required: [
              "VpcPeeringConnectionId"
            ],
            members: {
              AccepterPeeringConnectionOptions: {
                shape: "S1pg"
              },
              DryRun: {
                type: "boolean"
              },
              RequesterPeeringConnectionOptions: {
                shape: "S1pg"
              },
              VpcPeeringConnectionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccepterPeeringConnectionOptions: {
                shape: "S1pi",
                locationName: "accepterPeeringConnectionOptions"
              },
              RequesterPeeringConnectionOptions: {
                shape: "S1pi",
                locationName: "requesterPeeringConnectionOptions"
              }
            }
          }
        },
        ModifyVpcTenancy: {
          input: {
            type: "structure",
            required: [
              "VpcId",
              "InstanceTenancy"
            ],
            members: {
              VpcId: {},
              InstanceTenancy: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReturnValue: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ModifyVpnConnection: {
          input: {
            type: "structure",
            required: [
              "VpnConnectionId"
            ],
            members: {
              VpnConnectionId: {},
              TransitGatewayId: {},
              CustomerGatewayId: {},
              VpnGatewayId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnConnection: {
                shape: "Sls",
                locationName: "vpnConnection"
              }
            }
          }
        },
        ModifyVpnConnectionOptions: {
          input: {
            type: "structure",
            required: [
              "VpnConnectionId"
            ],
            members: {
              VpnConnectionId: {},
              LocalIpv4NetworkCidr: {},
              RemoteIpv4NetworkCidr: {},
              LocalIpv6NetworkCidr: {},
              RemoteIpv6NetworkCidr: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnConnection: {
                shape: "Sls",
                locationName: "vpnConnection"
              }
            }
          }
        },
        ModifyVpnTunnelCertificate: {
          input: {
            type: "structure",
            required: [
              "VpnConnectionId",
              "VpnTunnelOutsideIpAddress"
            ],
            members: {
              VpnConnectionId: {},
              VpnTunnelOutsideIpAddress: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnConnection: {
                shape: "Sls",
                locationName: "vpnConnection"
              }
            }
          }
        },
        ModifyVpnTunnelOptions: {
          input: {
            type: "structure",
            required: [
              "VpnConnectionId",
              "VpnTunnelOutsideIpAddress",
              "TunnelOptions"
            ],
            members: {
              VpnConnectionId: {},
              VpnTunnelOutsideIpAddress: {},
              TunnelOptions: {
                type: "structure",
                members: {
                  TunnelInsideCidr: {},
                  TunnelInsideIpv6Cidr: {},
                  PreSharedKey: {},
                  Phase1LifetimeSeconds: {
                    type: "integer"
                  },
                  Phase2LifetimeSeconds: {
                    type: "integer"
                  },
                  RekeyMarginTimeSeconds: {
                    type: "integer"
                  },
                  RekeyFuzzPercentage: {
                    type: "integer"
                  },
                  ReplayWindowSize: {
                    type: "integer"
                  },
                  DPDTimeoutSeconds: {
                    type: "integer"
                  },
                  DPDTimeoutAction: {},
                  Phase1EncryptionAlgorithms: {
                    shape: "Sld",
                    locationName: "Phase1EncryptionAlgorithm"
                  },
                  Phase2EncryptionAlgorithms: {
                    shape: "Slf",
                    locationName: "Phase2EncryptionAlgorithm"
                  },
                  Phase1IntegrityAlgorithms: {
                    shape: "Slh",
                    locationName: "Phase1IntegrityAlgorithm"
                  },
                  Phase2IntegrityAlgorithms: {
                    shape: "Slj",
                    locationName: "Phase2IntegrityAlgorithm"
                  },
                  Phase1DHGroupNumbers: {
                    shape: "Sll",
                    locationName: "Phase1DHGroupNumber"
                  },
                  Phase2DHGroupNumbers: {
                    shape: "Sln",
                    locationName: "Phase2DHGroupNumber"
                  },
                  IKEVersions: {
                    shape: "Slp",
                    locationName: "IKEVersion"
                  },
                  StartupAction: {}
                }
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VpnConnection: {
                shape: "Sls",
                locationName: "vpnConnection"
              }
            }
          }
        },
        MonitorInstances: {
          input: {
            type: "structure",
            required: [
              "InstanceIds"
            ],
            members: {
              InstanceIds: {
                shape: "Ssc",
                locationName: "InstanceId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceMonitorings: {
                shape: "S1px",
                locationName: "instancesSet"
              }
            }
          }
        },
        MoveAddressToVpc: {
          input: {
            type: "structure",
            required: [
              "PublicIp"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              PublicIp: {
                locationName: "publicIp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AllocationId: {
                locationName: "allocationId"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        ProvisionByoipCidr: {
          input: {
            type: "structure",
            required: [
              "Cidr"
            ],
            members: {
              Cidr: {},
              CidrAuthorizationContext: {
                type: "structure",
                required: [
                  "Message",
                  "Signature"
                ],
                members: {
                  Message: {},
                  Signature: {}
                }
              },
              PubliclyAdvertisable: {
                type: "boolean"
              },
              Description: {},
              DryRun: {
                type: "boolean"
              },
              PoolTagSpecifications: {
                shape: "S1t",
                locationName: "PoolTagSpecification"
              },
              MultiRegion: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidr: {
                shape: "S1n",
                locationName: "byoipCidr"
              }
            }
          }
        },
        PurchaseHostReservation: {
          input: {
            type: "structure",
            required: [
              "HostIdSet",
              "OfferingId"
            ],
            members: {
              ClientToken: {},
              CurrencyCode: {},
              HostIdSet: {
                shape: "S1jy"
              },
              LimitPrice: {},
              OfferingId: {},
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientToken: {
                locationName: "clientToken"
              },
              CurrencyCode: {
                locationName: "currencyCode"
              },
              Purchase: {
                shape: "S1k0",
                locationName: "purchase"
              },
              TotalHourlyPrice: {
                locationName: "totalHourlyPrice"
              },
              TotalUpfrontPrice: {
                locationName: "totalUpfrontPrice"
              }
            }
          }
        },
        PurchaseReservedInstancesOffering: {
          input: {
            type: "structure",
            required: [
              "InstanceCount",
              "ReservedInstancesOfferingId"
            ],
            members: {
              InstanceCount: {
                type: "integer"
              },
              ReservedInstancesOfferingId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              LimitPrice: {
                locationName: "limitPrice",
                type: "structure",
                members: {
                  Amount: {
                    locationName: "amount",
                    type: "double"
                  },
                  CurrencyCode: {
                    locationName: "currencyCode"
                  }
                }
              },
              PurchaseTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedInstancesId: {
                locationName: "reservedInstancesId"
              }
            }
          }
        },
        PurchaseScheduledInstances: {
          input: {
            type: "structure",
            required: [
              "PurchaseRequests"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              },
              PurchaseRequests: {
                locationName: "PurchaseRequest",
                type: "list",
                member: {
                  locationName: "PurchaseRequest",
                  type: "structure",
                  required: [
                    "InstanceCount",
                    "PurchaseToken"
                  ],
                  members: {
                    InstanceCount: {
                      type: "integer"
                    },
                    PurchaseToken: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ScheduledInstanceSet: {
                locationName: "scheduledInstanceSet",
                type: "list",
                member: {
                  shape: "S19l",
                  locationName: "item"
                }
              }
            }
          }
        },
        RebootInstances: {
          input: {
            type: "structure",
            required: [
              "InstanceIds"
            ],
            members: {
              InstanceIds: {
                shape: "Ssc",
                locationName: "InstanceId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        RegisterImage: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              ImageLocation: {},
              Architecture: {
                locationName: "architecture"
              },
              BlockDeviceMappings: {
                shape: "Sb3",
                locationName: "BlockDeviceMapping"
              },
              Description: {
                locationName: "description"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              EnaSupport: {
                locationName: "enaSupport",
                type: "boolean"
              },
              KernelId: {
                locationName: "kernelId"
              },
              Name: {
                locationName: "name"
              },
              BillingProducts: {
                locationName: "BillingProduct",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              RamdiskId: {
                locationName: "ramdiskId"
              },
              RootDeviceName: {
                locationName: "rootDeviceName"
              },
              SriovNetSupport: {
                locationName: "sriovNetSupport"
              },
              VirtualizationType: {
                locationName: "virtualizationType"
              },
              BootMode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImageId: {
                locationName: "imageId"
              }
            }
          }
        },
        RegisterInstanceEventNotificationAttributes: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              InstanceTagAttribute: {
                type: "structure",
                members: {
                  IncludeAllTagsOfInstance: {
                    type: "boolean"
                  },
                  InstanceTagKeys: {
                    shape: "Sqb",
                    locationName: "InstanceTagKey"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceTagAttribute: {
                shape: "Sqd",
                locationName: "instanceTagAttribute"
              }
            }
          }
        },
        RegisterTransitGatewayMulticastGroupMembers: {
          input: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomainId: {},
              GroupIpAddress: {},
              NetworkInterfaceIds: {
                shape: "Sqf"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RegisteredMulticastGroupMembers: {
                locationName: "registeredMulticastGroupMembers",
                type: "structure",
                members: {
                  TransitGatewayMulticastDomainId: {
                    locationName: "transitGatewayMulticastDomainId"
                  },
                  RegisteredNetworkInterfaceIds: {
                    shape: "Se",
                    locationName: "registeredNetworkInterfaceIds"
                  },
                  GroupIpAddress: {
                    locationName: "groupIpAddress"
                  }
                }
              }
            }
          }
        },
        RegisterTransitGatewayMulticastGroupSources: {
          input: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomainId: {},
              GroupIpAddress: {},
              NetworkInterfaceIds: {
                shape: "Sqf"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RegisteredMulticastGroupSources: {
                locationName: "registeredMulticastGroupSources",
                type: "structure",
                members: {
                  TransitGatewayMulticastDomainId: {
                    locationName: "transitGatewayMulticastDomainId"
                  },
                  RegisteredNetworkInterfaceIds: {
                    shape: "Se",
                    locationName: "registeredNetworkInterfaceIds"
                  },
                  GroupIpAddress: {
                    locationName: "groupIpAddress"
                  }
                }
              }
            }
          }
        },
        RejectTransitGatewayMulticastDomainAssociations: {
          input: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomainId: {},
              TransitGatewayAttachmentId: {},
              SubnetIds: {
                shape: "Se"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Associations: {
                shape: "Sg",
                locationName: "associations"
              }
            }
          }
        },
        RejectTransitGatewayPeeringAttachment: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayPeeringAttachment: {
                shape: "Sn",
                locationName: "transitGatewayPeeringAttachment"
              }
            }
          }
        },
        RejectTransitGatewayVpcAttachment: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayAttachmentId"
            ],
            members: {
              TransitGatewayAttachmentId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayVpcAttachment: {
                shape: "Sw",
                locationName: "transitGatewayVpcAttachment"
              }
            }
          }
        },
        RejectVpcEndpointConnections: {
          input: {
            type: "structure",
            required: [
              "ServiceId",
              "VpcEndpointIds"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceId: {},
              VpcEndpointIds: {
                shape: "S13",
                locationName: "VpcEndpointId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Unsuccessful: {
                shape: "S16",
                locationName: "unsuccessful"
              }
            }
          }
        },
        RejectVpcPeeringConnection: {
          input: {
            type: "structure",
            required: [
              "VpcPeeringConnectionId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcPeeringConnectionId: {
                locationName: "vpcPeeringConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ReleaseAddress: {
          input: {
            type: "structure",
            members: {
              AllocationId: {},
              PublicIp: {},
              NetworkBorderGroup: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        ReleaseHosts: {
          input: {
            type: "structure",
            required: [
              "HostIds"
            ],
            members: {
              HostIds: {
                shape: "Sx9",
                locationName: "hostId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Successful: {
                shape: "S21",
                locationName: "successful"
              },
              Unsuccessful: {
                shape: "S1n3",
                locationName: "unsuccessful"
              }
            }
          }
        },
        ReplaceIamInstanceProfileAssociation: {
          input: {
            type: "structure",
            required: [
              "IamInstanceProfile",
              "AssociationId"
            ],
            members: {
              IamInstanceProfile: {
                shape: "S2z"
              },
              AssociationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IamInstanceProfileAssociation: {
                shape: "S31",
                locationName: "iamInstanceProfileAssociation"
              }
            }
          }
        },
        ReplaceNetworkAclAssociation: {
          input: {
            type: "structure",
            required: [
              "AssociationId",
              "NetworkAclId"
            ],
            members: {
              AssociationId: {
                locationName: "associationId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NetworkAclId: {
                locationName: "networkAclId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NewAssociationId: {
                locationName: "newAssociationId"
              }
            }
          }
        },
        ReplaceNetworkAclEntry: {
          input: {
            type: "structure",
            required: [
              "Egress",
              "NetworkAclId",
              "Protocol",
              "RuleAction",
              "RuleNumber"
            ],
            members: {
              CidrBlock: {
                locationName: "cidrBlock"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Egress: {
                locationName: "egress",
                type: "boolean"
              },
              IcmpTypeCode: {
                shape: "Sfa",
                locationName: "Icmp"
              },
              Ipv6CidrBlock: {
                locationName: "ipv6CidrBlock"
              },
              NetworkAclId: {
                locationName: "networkAclId"
              },
              PortRange: {
                shape: "Sfb",
                locationName: "portRange"
              },
              Protocol: {
                locationName: "protocol"
              },
              RuleAction: {
                locationName: "ruleAction"
              },
              RuleNumber: {
                locationName: "ruleNumber",
                type: "integer"
              }
            }
          }
        },
        ReplaceRoute: {
          input: {
            type: "structure",
            required: [
              "RouteTableId"
            ],
            members: {
              DestinationCidrBlock: {
                locationName: "destinationCidrBlock"
              },
              DestinationIpv6CidrBlock: {
                locationName: "destinationIpv6CidrBlock"
              },
              DestinationPrefixListId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              VpcEndpointId: {},
              EgressOnlyInternetGatewayId: {
                locationName: "egressOnlyInternetGatewayId"
              },
              GatewayId: {
                locationName: "gatewayId"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              LocalTarget: {
                type: "boolean"
              },
              NatGatewayId: {
                locationName: "natGatewayId"
              },
              TransitGatewayId: {},
              LocalGatewayId: {},
              CarrierGatewayId: {},
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              RouteTableId: {
                locationName: "routeTableId"
              },
              VpcPeeringConnectionId: {
                locationName: "vpcPeeringConnectionId"
              }
            }
          }
        },
        ReplaceRouteTableAssociation: {
          input: {
            type: "structure",
            required: [
              "AssociationId",
              "RouteTableId"
            ],
            members: {
              AssociationId: {
                locationName: "associationId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              RouteTableId: {
                locationName: "routeTableId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NewAssociationId: {
                locationName: "newAssociationId"
              },
              AssociationState: {
                shape: "S3n",
                locationName: "associationState"
              }
            }
          }
        },
        ReplaceTransitGatewayRoute: {
          input: {
            type: "structure",
            required: [
              "DestinationCidrBlock",
              "TransitGatewayRouteTableId"
            ],
            members: {
              DestinationCidrBlock: {},
              TransitGatewayRouteTableId: {},
              TransitGatewayAttachmentId: {},
              Blackhole: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Route: {
                shape: "Sjw",
                locationName: "route"
              }
            }
          }
        },
        ReportInstanceStatus: {
          input: {
            type: "structure",
            required: [
              "Instances",
              "ReasonCodes",
              "Status"
            ],
            members: {
              Description: {
                locationName: "description"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              EndTime: {
                locationName: "endTime",
                type: "timestamp"
              },
              Instances: {
                shape: "Ssc",
                locationName: "instanceId"
              },
              ReasonCodes: {
                locationName: "reasonCode",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              StartTime: {
                locationName: "startTime",
                type: "timestamp"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        RequestSpotFleet: {
          input: {
            type: "structure",
            required: [
              "SpotFleetRequestConfig"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              SpotFleetRequestConfig: {
                shape: "S1ar",
                locationName: "spotFleetRequestConfig"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SpotFleetRequestId: {
                locationName: "spotFleetRequestId"
              }
            }
          }
        },
        RequestSpotInstances: {
          input: {
            type: "structure",
            members: {
              AvailabilityZoneGroup: {
                locationName: "availabilityZoneGroup"
              },
              BlockDurationMinutes: {
                locationName: "blockDurationMinutes",
                type: "integer"
              },
              ClientToken: {
                locationName: "clientToken"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InstanceCount: {
                locationName: "instanceCount",
                type: "integer"
              },
              LaunchGroup: {
                locationName: "launchGroup"
              },
              LaunchSpecification: {
                type: "structure",
                members: {
                  SecurityGroupIds: {
                    locationName: "SecurityGroupId",
                    type: "list",
                    member: {
                      locationName: "item"
                    }
                  },
                  SecurityGroups: {
                    locationName: "SecurityGroup",
                    type: "list",
                    member: {
                      locationName: "item"
                    }
                  },
                  AddressingType: {
                    locationName: "addressingType"
                  },
                  BlockDeviceMappings: {
                    shape: "Sxy",
                    locationName: "blockDeviceMapping"
                  },
                  EbsOptimized: {
                    locationName: "ebsOptimized",
                    type: "boolean"
                  },
                  IamInstanceProfile: {
                    shape: "S2z",
                    locationName: "iamInstanceProfile"
                  },
                  ImageId: {
                    locationName: "imageId"
                  },
                  InstanceType: {
                    locationName: "instanceType"
                  },
                  KernelId: {
                    locationName: "kernelId"
                  },
                  KeyName: {
                    locationName: "keyName"
                  },
                  Monitoring: {
                    shape: "S1bm",
                    locationName: "monitoring"
                  },
                  NetworkInterfaces: {
                    shape: "S1b1",
                    locationName: "NetworkInterface"
                  },
                  Placement: {
                    shape: "S1b3",
                    locationName: "placement"
                  },
                  RamdiskId: {
                    locationName: "ramdiskId"
                  },
                  SubnetId: {
                    locationName: "subnetId"
                  },
                  UserData: {
                    locationName: "userData"
                  }
                }
              },
              SpotPrice: {
                locationName: "spotPrice"
              },
              Type: {
                locationName: "type"
              },
              ValidFrom: {
                locationName: "validFrom",
                type: "timestamp"
              },
              ValidUntil: {
                locationName: "validUntil",
                type: "timestamp"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              InstanceInterruptionBehavior: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SpotInstanceRequests: {
                shape: "S1bj",
                locationName: "spotInstanceRequestSet"
              }
            }
          }
        },
        ResetAddressAttribute: {
          input: {
            type: "structure",
            required: [
              "AllocationId",
              "Attribute"
            ],
            members: {
              AllocationId: {},
              Attribute: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Address: {
                shape: "Sr8",
                locationName: "address"
              }
            }
          }
        },
        ResetEbsDefaultKmsKeyId: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KmsKeyId: {
                locationName: "kmsKeyId"
              }
            }
          }
        },
        ResetFpgaImageAttribute: {
          input: {
            type: "structure",
            required: [
              "FpgaImageId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              FpgaImageId: {},
              Attribute: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        ResetImageAttribute: {
          input: {
            type: "structure",
            required: [
              "Attribute",
              "ImageId"
            ],
            members: {
              Attribute: {},
              ImageId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        ResetInstanceAttribute: {
          input: {
            type: "structure",
            required: [
              "Attribute",
              "InstanceId"
            ],
            members: {
              Attribute: {
                locationName: "attribute"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              InstanceId: {
                locationName: "instanceId"
              }
            }
          }
        },
        ResetNetworkInterfaceAttribute: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfaceId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              SourceDestCheck: {
                locationName: "sourceDestCheck"
              }
            }
          }
        },
        ResetSnapshotAttribute: {
          input: {
            type: "structure",
            required: [
              "Attribute",
              "SnapshotId"
            ],
            members: {
              Attribute: {},
              SnapshotId: {},
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          }
        },
        RestoreAddressToClassic: {
          input: {
            type: "structure",
            required: [
              "PublicIp"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              PublicIp: {
                locationName: "publicIp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicIp: {
                locationName: "publicIp"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        RestoreManagedPrefixListVersion: {
          input: {
            type: "structure",
            required: [
              "PrefixListId",
              "PreviousVersion",
              "CurrentVersion"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              PrefixListId: {},
              PreviousVersion: {
                type: "long"
              },
              CurrentVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PrefixList: {
                shape: "Set",
                locationName: "prefixList"
              }
            }
          }
        },
        RevokeClientVpnIngress: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId",
              "TargetNetworkCidr"
            ],
            members: {
              ClientVpnEndpointId: {},
              TargetNetworkCidr: {},
              AccessGroupId: {},
              RevokeAllGroups: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                shape: "S4x",
                locationName: "status"
              }
            }
          }
        },
        RevokeSecurityGroupEgress: {
          input: {
            type: "structure",
            required: [
              "GroupId"
            ],
            members: {
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              GroupId: {
                locationName: "groupId"
              },
              IpPermissions: {
                shape: "S50",
                locationName: "ipPermissions"
              },
              SecurityGroupRuleIds: {
                shape: "S19s",
                locationName: "SecurityGroupRuleId"
              },
              CidrIp: {
                locationName: "cidrIp"
              },
              FromPort: {
                locationName: "fromPort",
                type: "integer"
              },
              IpProtocol: {
                locationName: "ipProtocol"
              },
              ToPort: {
                locationName: "toPort",
                type: "integer"
              },
              SourceSecurityGroupName: {
                locationName: "sourceSecurityGroupName"
              },
              SourceSecurityGroupOwnerId: {
                locationName: "sourceSecurityGroupOwnerId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              },
              UnknownIpPermissions: {
                shape: "S50",
                locationName: "unknownIpPermissionSet"
              }
            }
          }
        },
        RevokeSecurityGroupIngress: {
          input: {
            type: "structure",
            members: {
              CidrIp: {},
              FromPort: {
                type: "integer"
              },
              GroupId: {},
              GroupName: {},
              IpPermissions: {
                shape: "S50"
              },
              IpProtocol: {},
              SourceSecurityGroupName: {},
              SourceSecurityGroupOwnerId: {},
              ToPort: {
                type: "integer"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              SecurityGroupRuleIds: {
                shape: "S19s",
                locationName: "SecurityGroupRuleId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              },
              UnknownIpPermissions: {
                shape: "S50",
                locationName: "unknownIpPermissionSet"
              }
            }
          }
        },
        RunInstances: {
          input: {
            type: "structure",
            required: [
              "MaxCount",
              "MinCount"
            ],
            members: {
              BlockDeviceMappings: {
                shape: "Sb3",
                locationName: "BlockDeviceMapping"
              },
              ImageId: {},
              InstanceType: {},
              Ipv6AddressCount: {
                type: "integer"
              },
              Ipv6Addresses: {
                shape: "Sdo",
                locationName: "Ipv6Address"
              },
              KernelId: {},
              KeyName: {},
              MaxCount: {
                type: "integer"
              },
              MinCount: {
                type: "integer"
              },
              Monitoring: {
                shape: "S1bm"
              },
              Placement: {
                shape: "Sa8"
              },
              RamdiskId: {},
              SecurityGroupIds: {
                shape: "Sc4",
                locationName: "SecurityGroupId"
              },
              SecurityGroups: {
                shape: "Scq",
                locationName: "SecurityGroup"
              },
              SubnetId: {},
              UserData: {},
              AdditionalInfo: {
                locationName: "additionalInfo"
              },
              ClientToken: {
                idempotencyToken: true,
                locationName: "clientToken"
              },
              DisableApiTermination: {
                locationName: "disableApiTermination",
                type: "boolean"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              EbsOptimized: {
                locationName: "ebsOptimized",
                type: "boolean"
              },
              IamInstanceProfile: {
                shape: "S2z",
                locationName: "iamInstanceProfile"
              },
              InstanceInitiatedShutdownBehavior: {
                locationName: "instanceInitiatedShutdownBehavior"
              },
              NetworkInterfaces: {
                shape: "S1b1",
                locationName: "networkInterface"
              },
              PrivateIpAddress: {
                locationName: "privateIpAddress"
              },
              ElasticGpuSpecification: {
                type: "list",
                member: {
                  shape: "Scm",
                  locationName: "item"
                }
              },
              ElasticInferenceAccelerators: {
                locationName: "ElasticInferenceAccelerator",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  required: [
                    "Type"
                  ],
                  members: {
                    Type: {},
                    Count: {
                      type: "integer"
                    }
                  }
                }
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              LaunchTemplate: {
                type: "structure",
                members: {
                  LaunchTemplateId: {},
                  LaunchTemplateName: {},
                  Version: {}
                }
              },
              InstanceMarketOptions: {
                type: "structure",
                members: {
                  MarketType: {},
                  SpotOptions: {
                    type: "structure",
                    members: {
                      MaxPrice: {},
                      SpotInstanceType: {},
                      BlockDurationMinutes: {
                        type: "integer"
                      },
                      ValidUntil: {
                        type: "timestamp"
                      },
                      InstanceInterruptionBehavior: {}
                    }
                  }
                }
              },
              CreditSpecification: {
                shape: "Scw"
              },
              CpuOptions: {
                type: "structure",
                members: {
                  CoreCount: {
                    type: "integer"
                  },
                  ThreadsPerCore: {
                    type: "integer"
                  }
                }
              },
              CapacityReservationSpecification: {
                shape: "S1ne"
              },
              HibernationOptions: {
                type: "structure",
                members: {
                  Configured: {
                    type: "boolean"
                  }
                }
              },
              LicenseSpecifications: {
                locationName: "LicenseSpecification",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    LicenseConfigurationArn: {}
                  }
                }
              },
              MetadataOptions: {
                type: "structure",
                members: {
                  HttpTokens: {},
                  HttpPutResponseHopLimit: {
                    type: "integer"
                  },
                  HttpEndpoint: {},
                  HttpProtocolIpv6: {}
                }
              },
              EnclaveOptions: {
                type: "structure",
                members: {
                  Enabled: {
                    type: "boolean"
                  }
                }
              }
            }
          },
          output: {
            shape: "S12v"
          }
        },
        RunScheduledInstances: {
          input: {
            type: "structure",
            required: [
              "LaunchSpecification",
              "ScheduledInstanceId"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              DryRun: {
                type: "boolean"
              },
              InstanceCount: {
                type: "integer"
              },
              LaunchSpecification: {
                type: "structure",
                required: [
                  "ImageId"
                ],
                members: {
                  BlockDeviceMappings: {
                    locationName: "BlockDeviceMapping",
                    type: "list",
                    member: {
                      locationName: "BlockDeviceMapping",
                      type: "structure",
                      members: {
                        DeviceName: {},
                        Ebs: {
                          type: "structure",
                          members: {
                            DeleteOnTermination: {
                              type: "boolean"
                            },
                            Encrypted: {
                              type: "boolean"
                            },
                            Iops: {
                              type: "integer"
                            },
                            SnapshotId: {},
                            VolumeSize: {
                              type: "integer"
                            },
                            VolumeType: {}
                          }
                        },
                        NoDevice: {},
                        VirtualName: {}
                      }
                    }
                  },
                  EbsOptimized: {
                    type: "boolean"
                  },
                  IamInstanceProfile: {
                    type: "structure",
                    members: {
                      Arn: {},
                      Name: {}
                    }
                  },
                  ImageId: {},
                  InstanceType: {},
                  KernelId: {},
                  KeyName: {},
                  Monitoring: {
                    type: "structure",
                    members: {
                      Enabled: {
                        type: "boolean"
                      }
                    }
                  },
                  NetworkInterfaces: {
                    locationName: "NetworkInterface",
                    type: "list",
                    member: {
                      locationName: "NetworkInterface",
                      type: "structure",
                      members: {
                        AssociatePublicIpAddress: {
                          type: "boolean"
                        },
                        DeleteOnTermination: {
                          type: "boolean"
                        },
                        Description: {},
                        DeviceIndex: {
                          type: "integer"
                        },
                        Groups: {
                          shape: "S1t0",
                          locationName: "Group"
                        },
                        Ipv6AddressCount: {
                          type: "integer"
                        },
                        Ipv6Addresses: {
                          locationName: "Ipv6Address",
                          type: "list",
                          member: {
                            locationName: "Ipv6Address",
                            type: "structure",
                            members: {
                              Ipv6Address: {}
                            }
                          }
                        },
                        NetworkInterfaceId: {},
                        PrivateIpAddress: {},
                        PrivateIpAddressConfigs: {
                          locationName: "PrivateIpAddressConfig",
                          type: "list",
                          member: {
                            locationName: "PrivateIpAddressConfigSet",
                            type: "structure",
                            members: {
                              Primary: {
                                type: "boolean"
                              },
                              PrivateIpAddress: {}
                            }
                          }
                        },
                        SecondaryPrivateIpAddressCount: {
                          type: "integer"
                        },
                        SubnetId: {}
                      }
                    }
                  },
                  Placement: {
                    type: "structure",
                    members: {
                      AvailabilityZone: {},
                      GroupName: {}
                    }
                  },
                  RamdiskId: {},
                  SecurityGroupIds: {
                    shape: "S1t0",
                    locationName: "SecurityGroupId"
                  },
                  SubnetId: {},
                  UserData: {}
                }
              },
              ScheduledInstanceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceIdSet: {
                locationName: "instanceIdSet",
                type: "list",
                member: {
                  locationName: "item"
                }
              }
            }
          }
        },
        SearchLocalGatewayRoutes: {
          input: {
            type: "structure",
            required: [
              "LocalGatewayRouteTableId"
            ],
            members: {
              LocalGatewayRouteTableId: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Routes: {
                locationName: "routeSet",
                type: "list",
                member: {
                  shape: "Sei",
                  locationName: "item"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        SearchTransitGatewayMulticastGroups: {
          input: {
            type: "structure",
            members: {
              TransitGatewayMulticastDomainId: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MulticastGroups: {
                locationName: "multicastGroups",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    GroupIpAddress: {
                      locationName: "groupIpAddress"
                    },
                    TransitGatewayAttachmentId: {
                      locationName: "transitGatewayAttachmentId"
                    },
                    SubnetId: {
                      locationName: "subnetId"
                    },
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    ResourceType: {
                      locationName: "resourceType"
                    },
                    ResourceOwnerId: {
                      locationName: "resourceOwnerId"
                    },
                    NetworkInterfaceId: {
                      locationName: "networkInterfaceId"
                    },
                    GroupMember: {
                      locationName: "groupMember",
                      type: "boolean"
                    },
                    GroupSource: {
                      locationName: "groupSource",
                      type: "boolean"
                    },
                    MemberType: {
                      locationName: "memberType"
                    },
                    SourceType: {
                      locationName: "sourceType"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        SearchTransitGatewayRoutes: {
          input: {
            type: "structure",
            required: [
              "TransitGatewayRouteTableId",
              "Filters"
            ],
            members: {
              TransitGatewayRouteTableId: {},
              Filters: {
                shape: "Squ",
                locationName: "Filter"
              },
              MaxResults: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Routes: {
                locationName: "routeSet",
                type: "list",
                member: {
                  shape: "Sjw",
                  locationName: "item"
                }
              },
              AdditionalRoutesAvailable: {
                locationName: "additionalRoutesAvailable",
                type: "boolean"
              }
            }
          }
        },
        SendDiagnosticInterrupt: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              DryRun: {
                type: "boolean"
              }
            }
          }
        },
        StartInstances: {
          input: {
            type: "structure",
            required: [
              "InstanceIds"
            ],
            members: {
              InstanceIds: {
                shape: "Ssc",
                locationName: "InstanceId"
              },
              AdditionalInfo: {
                locationName: "additionalInfo"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StartingInstances: {
                shape: "S1to",
                locationName: "instancesSet"
              }
            }
          }
        },
        StartNetworkInsightsAnalysis: {
          input: {
            type: "structure",
            required: [
              "NetworkInsightsPathId",
              "ClientToken"
            ],
            members: {
              NetworkInsightsPathId: {},
              FilterInArns: {
                shape: "S163",
                locationName: "FilterInArn"
              },
              DryRun: {
                type: "boolean"
              },
              TagSpecifications: {
                shape: "S1t",
                locationName: "TagSpecification"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInsightsAnalysis: {
                shape: "S162",
                locationName: "networkInsightsAnalysis"
              }
            }
          }
        },
        StartVpcEndpointServicePrivateDnsVerification: {
          input: {
            type: "structure",
            required: [
              "ServiceId"
            ],
            members: {
              DryRun: {
                type: "boolean"
              },
              ServiceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReturnValue: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        StopInstances: {
          input: {
            type: "structure",
            required: [
              "InstanceIds"
            ],
            members: {
              InstanceIds: {
                shape: "Ssc",
                locationName: "InstanceId"
              },
              Hibernate: {
                type: "boolean"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              },
              Force: {
                locationName: "force",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StoppingInstances: {
                shape: "S1to",
                locationName: "instancesSet"
              }
            }
          }
        },
        TerminateClientVpnConnections: {
          input: {
            type: "structure",
            required: [
              "ClientVpnEndpointId"
            ],
            members: {
              ClientVpnEndpointId: {},
              ConnectionId: {},
              Username: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientVpnEndpointId: {
                locationName: "clientVpnEndpointId"
              },
              Username: {
                locationName: "username"
              },
              ConnectionStatuses: {
                locationName: "connectionStatuses",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    ConnectionId: {
                      locationName: "connectionId"
                    },
                    PreviousStatus: {
                      shape: "Ssr",
                      locationName: "previousStatus"
                    },
                    CurrentStatus: {
                      shape: "Ssr",
                      locationName: "currentStatus"
                    }
                  }
                }
              }
            }
          }
        },
        TerminateInstances: {
          input: {
            type: "structure",
            required: [
              "InstanceIds"
            ],
            members: {
              InstanceIds: {
                shape: "Ssc",
                locationName: "InstanceId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TerminatingInstances: {
                shape: "S1to",
                locationName: "instancesSet"
              }
            }
          }
        },
        UnassignIpv6Addresses: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfaceId"
            ],
            members: {
              Ipv6Addresses: {
                shape: "S29",
                locationName: "ipv6Addresses"
              },
              Ipv6Prefixes: {
                shape: "S2a",
                locationName: "Ipv6Prefix"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              UnassignedIpv6Addresses: {
                shape: "S29",
                locationName: "unassignedIpv6Addresses"
              },
              UnassignedIpv6Prefixes: {
                shape: "S2a",
                locationName: "unassignedIpv6PrefixSet"
              }
            }
          }
        },
        UnassignPrivateIpAddresses: {
          input: {
            type: "structure",
            required: [
              "NetworkInterfaceId"
            ],
            members: {
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              PrivateIpAddresses: {
                shape: "S2e",
                locationName: "privateIpAddress"
              },
              Ipv4Prefixes: {
                shape: "S2a",
                locationName: "Ipv4Prefix"
              }
            }
          }
        },
        UnmonitorInstances: {
          input: {
            type: "structure",
            required: [
              "InstanceIds"
            ],
            members: {
              InstanceIds: {
                shape: "Ssc",
                locationName: "InstanceId"
              },
              DryRun: {
                locationName: "dryRun",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceMonitorings: {
                shape: "S1px",
                locationName: "instancesSet"
              }
            }
          }
        },
        UpdateSecurityGroupRuleDescriptionsEgress: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              GroupId: {},
              GroupName: {},
              IpPermissions: {
                shape: "S50"
              },
              SecurityGroupRuleDescriptions: {
                shape: "S1u8",
                locationName: "SecurityGroupRuleDescription"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        UpdateSecurityGroupRuleDescriptionsIngress: {
          input: {
            type: "structure",
            members: {
              DryRun: {
                type: "boolean"
              },
              GroupId: {},
              GroupName: {},
              IpPermissions: {
                shape: "S50"
              },
              SecurityGroupRuleDescriptions: {
                shape: "S1u8",
                locationName: "SecurityGroupRuleDescription"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Return: {
                locationName: "return",
                type: "boolean"
              }
            }
          }
        },
        WithdrawByoipCidr: {
          input: {
            type: "structure",
            required: [
              "Cidr"
            ],
            members: {
              Cidr: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidr: {
                shape: "S1n",
                locationName: "byoipCidr"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            locationName: "ReservedInstanceId"
          }
        },
        S5: {
          type: "list",
          member: {
            locationName: "TargetConfigurationRequest",
            type: "structure",
            required: [
              "OfferingId"
            ],
            members: {
              InstanceCount: {
                type: "integer"
              },
              OfferingId: {}
            }
          }
        },
        Se: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sg: {
          type: "structure",
          members: {
            TransitGatewayMulticastDomainId: {
              locationName: "transitGatewayMulticastDomainId"
            },
            TransitGatewayAttachmentId: {
              locationName: "transitGatewayAttachmentId"
            },
            ResourceId: {
              locationName: "resourceId"
            },
            ResourceType: {
              locationName: "resourceType"
            },
            ResourceOwnerId: {
              locationName: "resourceOwnerId"
            },
            Subnets: {
              locationName: "subnets",
              type: "list",
              member: {
                shape: "Sj",
                locationName: "item"
              }
            }
          }
        },
        Sj: {
          type: "structure",
          members: {
            SubnetId: {
              locationName: "subnetId"
            },
            State: {
              locationName: "state"
            }
          }
        },
        Sn: {
          type: "structure",
          members: {
            TransitGatewayAttachmentId: {
              locationName: "transitGatewayAttachmentId"
            },
            RequesterTgwInfo: {
              shape: "So",
              locationName: "requesterTgwInfo"
            },
            AccepterTgwInfo: {
              shape: "So",
              locationName: "accepterTgwInfo"
            },
            Status: {
              locationName: "status",
              type: "structure",
              members: {
                Code: {
                  locationName: "code"
                },
                Message: {
                  locationName: "message"
                }
              }
            },
            State: {
              locationName: "state"
            },
            CreationTime: {
              locationName: "creationTime",
              type: "timestamp"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        So: {
          type: "structure",
          members: {
            TransitGatewayId: {
              locationName: "transitGatewayId"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            Region: {
              locationName: "region"
            }
          }
        },
        Ss: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Key: {
                locationName: "key"
              },
              Value: {
                locationName: "value"
              }
            }
          }
        },
        Sw: {
          type: "structure",
          members: {
            TransitGatewayAttachmentId: {
              locationName: "transitGatewayAttachmentId"
            },
            TransitGatewayId: {
              locationName: "transitGatewayId"
            },
            VpcId: {
              locationName: "vpcId"
            },
            VpcOwnerId: {
              locationName: "vpcOwnerId"
            },
            State: {
              locationName: "state"
            },
            SubnetIds: {
              shape: "Se",
              locationName: "subnetIds"
            },
            CreationTime: {
              locationName: "creationTime",
              type: "timestamp"
            },
            Options: {
              locationName: "options",
              type: "structure",
              members: {
                DnsSupport: {
                  locationName: "dnsSupport"
                },
                Ipv6Support: {
                  locationName: "ipv6Support"
                },
                ApplianceModeSupport: {
                  locationName: "applianceModeSupport"
                }
              }
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        S13: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S16: {
          type: "list",
          member: {
            shape: "S17",
            locationName: "item"
          }
        },
        S17: {
          type: "structure",
          members: {
            Error: {
              locationName: "error",
              type: "structure",
              members: {
                Code: {
                  locationName: "code"
                },
                Message: {
                  locationName: "message"
                }
              }
            },
            ResourceId: {
              locationName: "resourceId"
            }
          }
        },
        S1c: {
          type: "structure",
          members: {
            AccepterVpcInfo: {
              shape: "S1d",
              locationName: "accepterVpcInfo"
            },
            ExpirationTime: {
              locationName: "expirationTime",
              type: "timestamp"
            },
            RequesterVpcInfo: {
              shape: "S1d",
              locationName: "requesterVpcInfo"
            },
            Status: {
              locationName: "status",
              type: "structure",
              members: {
                Code: {
                  locationName: "code"
                },
                Message: {
                  locationName: "message"
                }
              }
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            },
            VpcPeeringConnectionId: {
              locationName: "vpcPeeringConnectionId"
            }
          }
        },
        S1d: {
          type: "structure",
          members: {
            CidrBlock: {
              locationName: "cidrBlock"
            },
            Ipv6CidrBlockSet: {
              locationName: "ipv6CidrBlockSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  Ipv6CidrBlock: {
                    locationName: "ipv6CidrBlock"
                  }
                }
              }
            },
            CidrBlockSet: {
              locationName: "cidrBlockSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  CidrBlock: {
                    locationName: "cidrBlock"
                  }
                }
              }
            },
            OwnerId: {
              locationName: "ownerId"
            },
            PeeringOptions: {
              locationName: "peeringOptions",
              type: "structure",
              members: {
                AllowDnsResolutionFromRemoteVpc: {
                  locationName: "allowDnsResolutionFromRemoteVpc",
                  type: "boolean"
                },
                AllowEgressFromLocalClassicLinkToRemoteVpc: {
                  locationName: "allowEgressFromLocalClassicLinkToRemoteVpc",
                  type: "boolean"
                },
                AllowEgressFromLocalVpcToRemoteClassicLink: {
                  locationName: "allowEgressFromLocalVpcToRemoteClassicLink",
                  type: "boolean"
                }
              }
            },
            VpcId: {
              locationName: "vpcId"
            },
            Region: {
              locationName: "region"
            }
          }
        },
        S1n: {
          type: "structure",
          members: {
            Cidr: {
              locationName: "cidr"
            },
            Description: {
              locationName: "description"
            },
            StatusMessage: {
              locationName: "statusMessage"
            },
            State: {
              locationName: "state"
            }
          }
        },
        S1t: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              ResourceType: {
                locationName: "resourceType"
              },
              Tags: {
                shape: "Ss",
                locationName: "Tag"
              }
            }
          }
        },
        S21: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S25: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S29: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S2a: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S2e: {
          type: "list",
          member: {
            locationName: "PrivateIpAddress"
          }
        },
        S2i: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Ipv4Prefix: {
                locationName: "ipv4Prefix"
              }
            }
          }
        },
        S2r: {
          type: "structure",
          members: {
            Code: {
              locationName: "code"
            },
            Message: {
              locationName: "message"
            }
          }
        },
        S2z: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            Name: {
              locationName: "name"
            }
          }
        },
        S31: {
          type: "structure",
          members: {
            AssociationId: {
              locationName: "associationId"
            },
            InstanceId: {
              locationName: "instanceId"
            },
            IamInstanceProfile: {
              shape: "S32",
              locationName: "iamInstanceProfile"
            },
            State: {
              locationName: "state"
            },
            Timestamp: {
              locationName: "timestamp",
              type: "timestamp"
            }
          }
        },
        S32: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            Id: {
              locationName: "id"
            }
          }
        },
        S37: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S38: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S3b: {
          type: "structure",
          members: {
            InstanceEventWindowId: {
              locationName: "instanceEventWindowId"
            },
            TimeRanges: {
              locationName: "timeRangeSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  StartWeekDay: {
                    locationName: "startWeekDay"
                  },
                  StartHour: {
                    locationName: "startHour",
                    type: "integer"
                  },
                  EndWeekDay: {
                    locationName: "endWeekDay"
                  },
                  EndHour: {
                    locationName: "endHour",
                    type: "integer"
                  }
                }
              }
            },
            Name: {
              locationName: "name"
            },
            CronExpression: {
              locationName: "cronExpression"
            },
            AssociationTarget: {
              locationName: "associationTarget",
              type: "structure",
              members: {
                InstanceIds: {
                  shape: "S37",
                  locationName: "instanceIdSet"
                },
                Tags: {
                  shape: "Ss",
                  locationName: "tagSet"
                },
                DedicatedHostIds: {
                  shape: "S38",
                  locationName: "dedicatedHostIdSet"
                }
              }
            },
            State: {
              locationName: "state"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        S3n: {
          type: "structure",
          members: {
            State: {
              locationName: "state"
            },
            StatusMessage: {
              locationName: "statusMessage"
            }
          }
        },
        S3r: {
          type: "structure",
          members: {
            AssociationId: {
              locationName: "associationId"
            },
            Ipv6CidrBlock: {
              locationName: "ipv6CidrBlock"
            },
            Ipv6CidrBlockState: {
              locationName: "ipv6CidrBlockState",
              type: "structure",
              members: {
                State: {
                  locationName: "state"
                },
                StatusMessage: {
                  locationName: "statusMessage"
                }
              }
            }
          }
        },
        S3w: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S41: {
          type: "structure",
          members: {
            TransitGatewayRouteTableId: {
              locationName: "transitGatewayRouteTableId"
            },
            TransitGatewayAttachmentId: {
              locationName: "transitGatewayAttachmentId"
            },
            ResourceId: {
              locationName: "resourceId"
            },
            ResourceType: {
              locationName: "resourceType"
            },
            State: {
              locationName: "state"
            }
          }
        },
        S45: {
          type: "structure",
          members: {
            AssociationId: {
              locationName: "associationId"
            },
            BranchInterfaceId: {
              locationName: "branchInterfaceId"
            },
            TrunkInterfaceId: {
              locationName: "trunkInterfaceId"
            },
            InterfaceProtocol: {
              locationName: "interfaceProtocol"
            },
            VlanId: {
              locationName: "vlanId",
              type: "integer"
            },
            GreKey: {
              locationName: "greKey",
              type: "integer"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        S4b: {
          type: "structure",
          members: {
            AssociationId: {
              locationName: "associationId"
            },
            Ipv6CidrBlock: {
              locationName: "ipv6CidrBlock"
            },
            Ipv6CidrBlockState: {
              shape: "S4c",
              locationName: "ipv6CidrBlockState"
            },
            NetworkBorderGroup: {
              locationName: "networkBorderGroup"
            },
            Ipv6Pool: {
              locationName: "ipv6Pool"
            }
          }
        },
        S4c: {
          type: "structure",
          members: {
            State: {
              locationName: "state"
            },
            StatusMessage: {
              locationName: "statusMessage"
            }
          }
        },
        S4e: {
          type: "structure",
          members: {
            AssociationId: {
              locationName: "associationId"
            },
            CidrBlock: {
              locationName: "cidrBlock"
            },
            CidrBlockState: {
              shape: "S4c",
              locationName: "cidrBlockState"
            }
          }
        },
        S4g: {
          type: "list",
          member: {
            locationName: "groupId"
          }
        },
        S4o: {
          type: "structure",
          members: {
            AttachTime: {
              locationName: "attachTime",
              type: "timestamp"
            },
            Device: {
              locationName: "device"
            },
            InstanceId: {
              locationName: "instanceId"
            },
            State: {
              locationName: "status"
            },
            VolumeId: {
              locationName: "volumeId"
            },
            DeleteOnTermination: {
              locationName: "deleteOnTermination",
              type: "boolean"
            }
          }
        },
        S4t: {
          type: "structure",
          members: {
            State: {
              locationName: "state"
            },
            VpcId: {
              locationName: "vpcId"
            }
          }
        },
        S4x: {
          type: "structure",
          members: {
            Code: {
              locationName: "code"
            },
            Message: {
              locationName: "message"
            }
          }
        },
        S50: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              FromPort: {
                locationName: "fromPort",
                type: "integer"
              },
              IpProtocol: {
                locationName: "ipProtocol"
              },
              IpRanges: {
                locationName: "ipRanges",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CidrIp: {
                      locationName: "cidrIp"
                    },
                    Description: {
                      locationName: "description"
                    }
                  }
                }
              },
              Ipv6Ranges: {
                locationName: "ipv6Ranges",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    CidrIpv6: {
                      locationName: "cidrIpv6"
                    },
                    Description: {
                      locationName: "description"
                    }
                  }
                }
              },
              PrefixListIds: {
                locationName: "prefixListIds",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Description: {
                      locationName: "description"
                    },
                    PrefixListId: {
                      locationName: "prefixListId"
                    }
                  }
                }
              },
              ToPort: {
                locationName: "toPort",
                type: "integer"
              },
              UserIdGroupPairs: {
                locationName: "groups",
                type: "list",
                member: {
                  shape: "S59",
                  locationName: "item"
                }
              }
            }
          }
        },
        S59: {
          type: "structure",
          members: {
            Description: {
              locationName: "description"
            },
            GroupId: {
              locationName: "groupId"
            },
            GroupName: {
              locationName: "groupName"
            },
            PeeringStatus: {
              locationName: "peeringStatus"
            },
            UserId: {
              locationName: "userId"
            },
            VpcId: {
              locationName: "vpcId"
            },
            VpcPeeringConnectionId: {
              locationName: "vpcPeeringConnectionId"
            }
          }
        },
        S5b: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              SecurityGroupRuleId: {
                locationName: "securityGroupRuleId"
              },
              GroupId: {
                locationName: "groupId"
              },
              GroupOwnerId: {
                locationName: "groupOwnerId"
              },
              IsEgress: {
                locationName: "isEgress",
                type: "boolean"
              },
              IpProtocol: {
                locationName: "ipProtocol"
              },
              FromPort: {
                locationName: "fromPort",
                type: "integer"
              },
              ToPort: {
                locationName: "toPort",
                type: "integer"
              },
              CidrIpv4: {
                locationName: "cidrIpv4"
              },
              CidrIpv6: {
                locationName: "cidrIpv6"
              },
              PrefixListId: {
                locationName: "prefixListId"
              },
              ReferencedGroupInfo: {
                locationName: "referencedGroupInfo",
                type: "structure",
                members: {
                  GroupId: {
                    locationName: "groupId"
                  },
                  PeeringStatus: {
                    locationName: "peeringStatus"
                  },
                  UserId: {
                    locationName: "userId"
                  },
                  VpcId: {
                    locationName: "vpcId"
                  },
                  VpcPeeringConnectionId: {
                    locationName: "vpcPeeringConnectionId"
                  }
                }
              },
              Description: {
                locationName: "description"
              },
              Tags: {
                shape: "Ss",
                locationName: "tagSet"
              }
            }
          }
        },
        S5k: {
          type: "structure",
          members: {
            S3: {
              type: "structure",
              members: {
                AWSAccessKeyId: {},
                Bucket: {
                  locationName: "bucket"
                },
                Prefix: {
                  locationName: "prefix"
                },
                UploadPolicy: {
                  locationName: "uploadPolicy",
                  type: "blob"
                },
                UploadPolicySignature: {
                  locationName: "uploadPolicySignature"
                }
              }
            }
          }
        },
        S5o: {
          type: "structure",
          members: {
            BundleId: {
              locationName: "bundleId"
            },
            BundleTaskError: {
              locationName: "error",
              type: "structure",
              members: {
                Code: {
                  locationName: "code"
                },
                Message: {
                  locationName: "message"
                }
              }
            },
            InstanceId: {
              locationName: "instanceId"
            },
            Progress: {
              locationName: "progress"
            },
            StartTime: {
              locationName: "startTime",
              type: "timestamp"
            },
            State: {
              locationName: "state"
            },
            Storage: {
              shape: "S5k",
              locationName: "storage"
            },
            UpdateTime: {
              locationName: "updateTime",
              type: "timestamp"
            }
          }
        },
        S5y: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S6j: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              ClientToken: {
                locationName: "clientToken"
              },
              CreateDate: {
                locationName: "createDate",
                type: "timestamp"
              },
              InstanceCounts: {
                locationName: "instanceCounts",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceCount: {
                      locationName: "instanceCount",
                      type: "integer"
                    },
                    State: {
                      locationName: "state"
                    }
                  }
                }
              },
              PriceSchedules: {
                locationName: "priceSchedules",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    Active: {
                      locationName: "active",
                      type: "boolean"
                    },
                    CurrencyCode: {
                      locationName: "currencyCode"
                    },
                    Price: {
                      locationName: "price",
                      type: "double"
                    },
                    Term: {
                      locationName: "term",
                      type: "long"
                    }
                  }
                }
              },
              ReservedInstancesId: {
                locationName: "reservedInstancesId"
              },
              ReservedInstancesListingId: {
                locationName: "reservedInstancesListingId"
              },
              Status: {
                locationName: "status"
              },
              StatusMessage: {
                locationName: "statusMessage"
              },
              Tags: {
                shape: "Ss",
                locationName: "tagSet"
              },
              UpdateDate: {
                locationName: "updateDate",
                type: "timestamp"
              }
            }
          }
        },
        S6v: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S76: {
          type: "list",
          member: {
            locationName: "SpotInstanceRequestId"
          }
        },
        S7s: {
          type: "structure",
          members: {
            CapacityReservationId: {
              locationName: "capacityReservationId"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            CapacityReservationArn: {
              locationName: "capacityReservationArn"
            },
            AvailabilityZoneId: {
              locationName: "availabilityZoneId"
            },
            InstanceType: {
              locationName: "instanceType"
            },
            InstancePlatform: {
              locationName: "instancePlatform"
            },
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            Tenancy: {
              locationName: "tenancy"
            },
            TotalInstanceCount: {
              locationName: "totalInstanceCount",
              type: "integer"
            },
            AvailableInstanceCount: {
              locationName: "availableInstanceCount",
              type: "integer"
            },
            EbsOptimized: {
              locationName: "ebsOptimized",
              type: "boolean"
            },
            EphemeralStorage: {
              locationName: "ephemeralStorage",
              type: "boolean"
            },
            State: {
              locationName: "state"
            },
            StartDate: {
              locationName: "startDate",
              type: "timestamp"
            },
            EndDate: {
              locationName: "endDate",
              type: "timestamp"
            },
            EndDateType: {
              locationName: "endDateType"
            },
            InstanceMatchCriteria: {
              locationName: "instanceMatchCriteria"
            },
            CreateDate: {
              locationName: "createDate",
              type: "timestamp"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            },
            OutpostArn: {
              locationName: "outpostArn"
            },
            CapacityReservationFleetId: {
              locationName: "capacityReservationFleetId"
            }
          }
        },
        S84: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              CapacityReservationId: {
                locationName: "capacityReservationId"
              },
              AvailabilityZoneId: {
                locationName: "availabilityZoneId"
              },
              InstanceType: {
                locationName: "instanceType"
              },
              InstancePlatform: {
                locationName: "instancePlatform"
              },
              AvailabilityZone: {
                locationName: "availabilityZone"
              },
              TotalInstanceCount: {
                locationName: "totalInstanceCount",
                type: "integer"
              },
              FulfilledCapacity: {
                locationName: "fulfilledCapacity",
                type: "double"
              },
              EbsOptimized: {
                locationName: "ebsOptimized",
                type: "boolean"
              },
              CreateDate: {
                locationName: "createDate",
                type: "timestamp"
              },
              Weight: {
                locationName: "weight",
                type: "double"
              },
              Priority: {
                locationName: "priority",
                type: "integer"
              }
            }
          }
        },
        S88: {
          type: "structure",
          members: {
            CarrierGatewayId: {
              locationName: "carrierGatewayId"
            },
            VpcId: {
              locationName: "vpcId"
            },
            State: {
              locationName: "state"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        S8i: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            CloudwatchLogGroup: {},
            CloudwatchLogStream: {}
          }
        },
        S8l: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            LambdaFunctionArn: {}
          }
        },
        S8n: {
          type: "structure",
          members: {
            Code: {
              locationName: "code"
            },
            Message: {
              locationName: "message"
            }
          }
        },
        S8r: {
          type: "structure",
          members: {
            Code: {
              locationName: "code"
            },
            Message: {
              locationName: "message"
            }
          }
        },
        S8w: {
          type: "structure",
          members: {
            BgpAsn: {
              locationName: "bgpAsn"
            },
            CustomerGatewayId: {
              locationName: "customerGatewayId"
            },
            IpAddress: {
              locationName: "ipAddress"
            },
            CertificateArn: {
              locationName: "certificateArn"
            },
            State: {
              locationName: "state"
            },
            Type: {
              locationName: "type"
            },
            DeviceName: {
              locationName: "deviceName"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        S8z: {
          type: "structure",
          members: {
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            AvailabilityZoneId: {
              locationName: "availabilityZoneId"
            },
            AvailableIpAddressCount: {
              locationName: "availableIpAddressCount",
              type: "integer"
            },
            CidrBlock: {
              locationName: "cidrBlock"
            },
            DefaultForAz: {
              locationName: "defaultForAz",
              type: "boolean"
            },
            MapPublicIpOnLaunch: {
              locationName: "mapPublicIpOnLaunch",
              type: "boolean"
            },
            MapCustomerOwnedIpOnLaunch: {
              locationName: "mapCustomerOwnedIpOnLaunch",
              type: "boolean"
            },
            CustomerOwnedIpv4Pool: {
              locationName: "customerOwnedIpv4Pool"
            },
            State: {
              locationName: "state"
            },
            SubnetId: {
              locationName: "subnetId"
            },
            VpcId: {
              locationName: "vpcId"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            AssignIpv6AddressOnCreation: {
              locationName: "assignIpv6AddressOnCreation",
              type: "boolean"
            },
            Ipv6CidrBlockAssociationSet: {
              locationName: "ipv6CidrBlockAssociationSet",
              type: "list",
              member: {
                shape: "S3r",
                locationName: "item"
              }
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            },
            SubnetArn: {
              locationName: "subnetArn"
            },
            OutpostArn: {
              locationName: "outpostArn"
            }
          }
        },
        S95: {
          type: "structure",
          members: {
            CidrBlock: {
              locationName: "cidrBlock"
            },
            DhcpOptionsId: {
              locationName: "dhcpOptionsId"
            },
            State: {
              locationName: "state"
            },
            VpcId: {
              locationName: "vpcId"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            InstanceTenancy: {
              locationName: "instanceTenancy"
            },
            Ipv6CidrBlockAssociationSet: {
              locationName: "ipv6CidrBlockAssociationSet",
              type: "list",
              member: {
                shape: "S4b",
                locationName: "item"
              }
            },
            CidrBlockAssociationSet: {
              locationName: "cidrBlockAssociationSet",
              type: "list",
              member: {
                shape: "S4e",
                locationName: "item"
              }
            },
            IsDefault: {
              locationName: "isDefault",
              type: "boolean"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        S9e: {
          type: "structure",
          members: {
            DhcpConfigurations: {
              locationName: "dhcpConfigurationSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  Key: {
                    locationName: "key"
                  },
                  Values: {
                    locationName: "valueSet",
                    type: "list",
                    member: {
                      shape: "S9i",
                      locationName: "item"
                    }
                  }
                }
              }
            },
            DhcpOptionsId: {
              locationName: "dhcpOptionsId"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        S9i: {
          type: "structure",
          members: {
            Value: {
              locationName: "value"
            }
          }
        },
        S9l: {
          type: "structure",
          members: {
            Attachments: {
              shape: "S9m",
              locationName: "attachmentSet"
            },
            EgressOnlyInternetGatewayId: {
              locationName: "egressOnlyInternetGatewayId"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        S9m: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              State: {
                locationName: "state"
              },
              VpcId: {
                locationName: "vpcId"
              }
            }
          }
        },
        Sa1: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              LaunchTemplateSpecification: {
                type: "structure",
                members: {
                  LaunchTemplateId: {},
                  LaunchTemplateName: {},
                  Version: {}
                }
              },
              Overrides: {
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceType: {},
                    MaxPrice: {},
                    SubnetId: {},
                    AvailabilityZone: {},
                    WeightedCapacity: {
                      type: "double"
                    },
                    Priority: {
                      type: "double"
                    },
                    Placement: {
                      shape: "Sa8"
                    }
                  }
                }
              }
            }
          }
        },
        Sa8: {
          type: "structure",
          members: {
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            Affinity: {
              locationName: "affinity"
            },
            GroupName: {
              locationName: "groupName"
            },
            PartitionNumber: {
              locationName: "partitionNumber",
              type: "integer"
            },
            HostId: {
              locationName: "hostId"
            },
            Tenancy: {
              locationName: "tenancy"
            },
            SpreadDomain: {
              locationName: "spreadDomain"
            },
            HostResourceGroupArn: {
              locationName: "hostResourceGroupArn"
            }
          }
        },
        Saa: {
          type: "structure",
          required: [
            "TotalTargetCapacity"
          ],
          members: {
            TotalTargetCapacity: {
              type: "integer"
            },
            OnDemandTargetCapacity: {
              type: "integer"
            },
            SpotTargetCapacity: {
              type: "integer"
            },
            DefaultTargetCapacityType: {}
          }
        },
        Sah: {
          type: "structure",
          members: {
            LaunchTemplateSpecification: {
              shape: "Sai",
              locationName: "launchTemplateSpecification"
            },
            Overrides: {
              shape: "Saj",
              locationName: "overrides"
            }
          }
        },
        Sai: {
          type: "structure",
          members: {
            LaunchTemplateId: {
              locationName: "launchTemplateId"
            },
            LaunchTemplateName: {
              locationName: "launchTemplateName"
            },
            Version: {
              locationName: "version"
            }
          }
        },
        Saj: {
          type: "structure",
          members: {
            InstanceType: {
              locationName: "instanceType"
            },
            MaxPrice: {
              locationName: "maxPrice"
            },
            SubnetId: {
              locationName: "subnetId"
            },
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            WeightedCapacity: {
              locationName: "weightedCapacity",
              type: "double"
            },
            Priority: {
              locationName: "priority",
              type: "double"
            },
            Placement: {
              locationName: "placement",
              type: "structure",
              members: {
                GroupName: {
                  locationName: "groupName"
                }
              }
            }
          }
        },
        Sao: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sb0: {
          type: "structure",
          members: {
            Bucket: {},
            Key: {}
          }
        },
        Sb3: {
          type: "list",
          member: {
            shape: "Sb4",
            locationName: "BlockDeviceMapping"
          }
        },
        Sb4: {
          type: "structure",
          members: {
            DeviceName: {
              locationName: "deviceName"
            },
            VirtualName: {
              locationName: "virtualName"
            },
            Ebs: {
              locationName: "ebs",
              type: "structure",
              members: {
                DeleteOnTermination: {
                  locationName: "deleteOnTermination",
                  type: "boolean"
                },
                Iops: {
                  locationName: "iops",
                  type: "integer"
                },
                SnapshotId: {
                  locationName: "snapshotId"
                },
                VolumeSize: {
                  locationName: "volumeSize",
                  type: "integer"
                },
                VolumeType: {
                  locationName: "volumeType"
                },
                KmsKeyId: {},
                Throughput: {
                  locationName: "throughput",
                  type: "integer"
                },
                OutpostArn: {
                  locationName: "outpostArn"
                },
                Encrypted: {
                  locationName: "encrypted",
                  type: "boolean"
                }
              }
            },
            NoDevice: {
              locationName: "noDevice"
            }
          }
        },
        Sba: {
          type: "list",
          member: {
            type: "structure",
            members: {
              StartWeekDay: {},
              StartHour: {
                type: "integer"
              },
              EndWeekDay: {},
              EndHour: {
                type: "integer"
              }
            }
          }
        },
        Sbj: {
          type: "structure",
          members: {
            Description: {
              locationName: "description"
            },
            ExportTaskId: {
              locationName: "exportTaskId"
            },
            ExportToS3Task: {
              locationName: "exportToS3",
              type: "structure",
              members: {
                ContainerFormat: {
                  locationName: "containerFormat"
                },
                DiskImageFormat: {
                  locationName: "diskImageFormat"
                },
                S3Bucket: {
                  locationName: "s3Bucket"
                },
                S3Key: {
                  locationName: "s3Key"
                }
              }
            },
            InstanceExportDetails: {
              locationName: "instanceExport",
              type: "structure",
              members: {
                InstanceId: {
                  locationName: "instanceId"
                },
                TargetEnvironment: {
                  locationName: "targetEnvironment"
                }
              }
            },
            State: {
              locationName: "state"
            },
            StatusMessage: {
              locationName: "statusMessage"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        Sbp: {
          type: "structure",
          members: {
            Attachments: {
              shape: "S9m",
              locationName: "attachmentSet"
            },
            InternetGatewayId: {
              locationName: "internetGatewayId"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        Sbw: {
          type: "structure",
          members: {
            KernelId: {},
            EbsOptimized: {
              type: "boolean"
            },
            IamInstanceProfile: {
              type: "structure",
              members: {
                Arn: {},
                Name: {}
              }
            },
            BlockDeviceMappings: {
              locationName: "BlockDeviceMapping",
              type: "list",
              member: {
                locationName: "BlockDeviceMapping",
                type: "structure",
                members: {
                  DeviceName: {},
                  VirtualName: {},
                  Ebs: {
                    type: "structure",
                    members: {
                      Encrypted: {
                        type: "boolean"
                      },
                      DeleteOnTermination: {
                        type: "boolean"
                      },
                      Iops: {
                        type: "integer"
                      },
                      KmsKeyId: {},
                      SnapshotId: {},
                      VolumeSize: {
                        type: "integer"
                      },
                      VolumeType: {},
                      Throughput: {
                        type: "integer"
                      }
                    }
                  },
                  NoDevice: {}
                }
              }
            },
            NetworkInterfaces: {
              locationName: "NetworkInterface",
              type: "list",
              member: {
                locationName: "InstanceNetworkInterfaceSpecification",
                type: "structure",
                members: {
                  AssociateCarrierIpAddress: {
                    type: "boolean"
                  },
                  AssociatePublicIpAddress: {
                    type: "boolean"
                  },
                  DeleteOnTermination: {
                    type: "boolean"
                  },
                  Description: {},
                  DeviceIndex: {
                    type: "integer"
                  },
                  Groups: {
                    shape: "Sc4",
                    locationName: "SecurityGroupId"
                  },
                  InterfaceType: {},
                  Ipv6AddressCount: {
                    type: "integer"
                  },
                  Ipv6Addresses: {
                    type: "list",
                    member: {
                      locationName: "InstanceIpv6Address",
                      type: "structure",
                      members: {
                        Ipv6Address: {}
                      }
                    }
                  },
                  NetworkInterfaceId: {},
                  PrivateIpAddress: {},
                  PrivateIpAddresses: {
                    shape: "Sc7"
                  },
                  SecondaryPrivateIpAddressCount: {
                    type: "integer"
                  },
                  SubnetId: {},
                  NetworkCardIndex: {
                    type: "integer"
                  },
                  Ipv4Prefixes: {
                    shape: "Sc9",
                    locationName: "Ipv4Prefix"
                  },
                  Ipv4PrefixCount: {
                    type: "integer"
                  },
                  Ipv6Prefixes: {
                    shape: "Scb",
                    locationName: "Ipv6Prefix"
                  },
                  Ipv6PrefixCount: {
                    type: "integer"
                  }
                }
              }
            },
            ImageId: {},
            InstanceType: {},
            KeyName: {},
            Monitoring: {
              type: "structure",
              members: {
                Enabled: {
                  type: "boolean"
                }
              }
            },
            Placement: {
              type: "structure",
              members: {
                AvailabilityZone: {},
                Affinity: {},
                GroupName: {},
                HostId: {},
                Tenancy: {},
                SpreadDomain: {},
                HostResourceGroupArn: {},
                PartitionNumber: {
                  type: "integer"
                }
              }
            },
            RamDiskId: {},
            DisableApiTermination: {
              type: "boolean"
            },
            InstanceInitiatedShutdownBehavior: {},
            UserData: {},
            TagSpecifications: {
              locationName: "TagSpecification",
              type: "list",
              member: {
                locationName: "LaunchTemplateTagSpecificationRequest",
                type: "structure",
                members: {
                  ResourceType: {},
                  Tags: {
                    shape: "Ss",
                    locationName: "Tag"
                  }
                }
              }
            },
            ElasticGpuSpecifications: {
              locationName: "ElasticGpuSpecification",
              type: "list",
              member: {
                shape: "Scm",
                locationName: "ElasticGpuSpecification"
              }
            },
            ElasticInferenceAccelerators: {
              locationName: "ElasticInferenceAccelerator",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                required: [
                  "Type"
                ],
                members: {
                  Type: {},
                  Count: {
                    type: "integer"
                  }
                }
              }
            },
            SecurityGroupIds: {
              shape: "Sc4",
              locationName: "SecurityGroupId"
            },
            SecurityGroups: {
              shape: "Scq",
              locationName: "SecurityGroup"
            },
            InstanceMarketOptions: {
              type: "structure",
              members: {
                MarketType: {},
                SpotOptions: {
                  type: "structure",
                  members: {
                    MaxPrice: {},
                    SpotInstanceType: {},
                    BlockDurationMinutes: {
                      type: "integer"
                    },
                    ValidUntil: {
                      type: "timestamp"
                    },
                    InstanceInterruptionBehavior: {}
                  }
                }
              }
            },
            CreditSpecification: {
              shape: "Scw"
            },
            CpuOptions: {
              type: "structure",
              members: {
                CoreCount: {
                  type: "integer"
                },
                ThreadsPerCore: {
                  type: "integer"
                }
              }
            },
            CapacityReservationSpecification: {
              type: "structure",
              members: {
                CapacityReservationPreference: {},
                CapacityReservationTarget: {
                  shape: "Sd0"
                }
              }
            },
            LicenseSpecifications: {
              locationName: "LicenseSpecification",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  LicenseConfigurationArn: {}
                }
              }
            },
            HibernationOptions: {
              type: "structure",
              members: {
                Configured: {
                  type: "boolean"
                }
              }
            },
            MetadataOptions: {
              type: "structure",
              members: {
                HttpTokens: {},
                HttpPutResponseHopLimit: {
                  type: "integer"
                },
                HttpEndpoint: {},
                HttpProtocolIpv6: {}
              }
            },
            EnclaveOptions: {
              type: "structure",
              members: {
                Enabled: {
                  type: "boolean"
                }
              }
            }
          }
        },
        Sc4: {
          type: "list",
          member: {
            locationName: "SecurityGroupId"
          }
        },
        Sc7: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Primary: {
                locationName: "primary",
                type: "boolean"
              },
              PrivateIpAddress: {
                locationName: "privateIpAddress"
              }
            }
          }
        },
        Sc9: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Ipv4Prefix: {}
            }
          }
        },
        Scb: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Ipv6Prefix: {}
            }
          }
        },
        Scm: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Type: {}
          }
        },
        Scq: {
          type: "list",
          member: {
            locationName: "SecurityGroup"
          }
        },
        Scw: {
          type: "structure",
          required: [
            "CpuCredits"
          ],
          members: {
            CpuCredits: {}
          }
        },
        Sd0: {
          type: "structure",
          members: {
            CapacityReservationId: {},
            CapacityReservationResourceGroupArn: {}
          }
        },
        Sda: {
          type: "structure",
          members: {
            LaunchTemplateId: {
              locationName: "launchTemplateId"
            },
            LaunchTemplateName: {
              locationName: "launchTemplateName"
            },
            CreateTime: {
              locationName: "createTime",
              type: "timestamp"
            },
            CreatedBy: {
              locationName: "createdBy"
            },
            DefaultVersionNumber: {
              locationName: "defaultVersionNumber",
              type: "long"
            },
            LatestVersionNumber: {
              locationName: "latestVersionNumber",
              type: "long"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        Sdb: {
          type: "structure",
          members: {
            Errors: {
              locationName: "errorSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  Code: {
                    locationName: "code"
                  },
                  Message: {
                    locationName: "message"
                  }
                }
              }
            }
          }
        },
        Sdg: {
          type: "structure",
          members: {
            LaunchTemplateId: {
              locationName: "launchTemplateId"
            },
            LaunchTemplateName: {
              locationName: "launchTemplateName"
            },
            VersionNumber: {
              locationName: "versionNumber",
              type: "long"
            },
            VersionDescription: {
              locationName: "versionDescription"
            },
            CreateTime: {
              locationName: "createTime",
              type: "timestamp"
            },
            CreatedBy: {
              locationName: "createdBy"
            },
            DefaultVersion: {
              locationName: "defaultVersion",
              type: "boolean"
            },
            LaunchTemplateData: {
              shape: "Sdh",
              locationName: "launchTemplateData"
            }
          }
        },
        Sdh: {
          type: "structure",
          members: {
            KernelId: {
              locationName: "kernelId"
            },
            EbsOptimized: {
              locationName: "ebsOptimized",
              type: "boolean"
            },
            IamInstanceProfile: {
              locationName: "iamInstanceProfile",
              type: "structure",
              members: {
                Arn: {
                  locationName: "arn"
                },
                Name: {
                  locationName: "name"
                }
              }
            },
            BlockDeviceMappings: {
              locationName: "blockDeviceMappingSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  DeviceName: {
                    locationName: "deviceName"
                  },
                  VirtualName: {
                    locationName: "virtualName"
                  },
                  Ebs: {
                    locationName: "ebs",
                    type: "structure",
                    members: {
                      Encrypted: {
                        locationName: "encrypted",
                        type: "boolean"
                      },
                      DeleteOnTermination: {
                        locationName: "deleteOnTermination",
                        type: "boolean"
                      },
                      Iops: {
                        locationName: "iops",
                        type: "integer"
                      },
                      KmsKeyId: {
                        locationName: "kmsKeyId"
                      },
                      SnapshotId: {
                        locationName: "snapshotId"
                      },
                      VolumeSize: {
                        locationName: "volumeSize",
                        type: "integer"
                      },
                      VolumeType: {
                        locationName: "volumeType"
                      },
                      Throughput: {
                        locationName: "throughput",
                        type: "integer"
                      }
                    }
                  },
                  NoDevice: {
                    locationName: "noDevice"
                  }
                }
              }
            },
            NetworkInterfaces: {
              locationName: "networkInterfaceSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  AssociateCarrierIpAddress: {
                    locationName: "associateCarrierIpAddress",
                    type: "boolean"
                  },
                  AssociatePublicIpAddress: {
                    locationName: "associatePublicIpAddress",
                    type: "boolean"
                  },
                  DeleteOnTermination: {
                    locationName: "deleteOnTermination",
                    type: "boolean"
                  },
                  Description: {
                    locationName: "description"
                  },
                  DeviceIndex: {
                    locationName: "deviceIndex",
                    type: "integer"
                  },
                  Groups: {
                    shape: "S4g",
                    locationName: "groupSet"
                  },
                  InterfaceType: {
                    locationName: "interfaceType"
                  },
                  Ipv6AddressCount: {
                    locationName: "ipv6AddressCount",
                    type: "integer"
                  },
                  Ipv6Addresses: {
                    shape: "Sdo",
                    locationName: "ipv6AddressesSet"
                  },
                  NetworkInterfaceId: {
                    locationName: "networkInterfaceId"
                  },
                  PrivateIpAddress: {
                    locationName: "privateIpAddress"
                  },
                  PrivateIpAddresses: {
                    shape: "Sc7",
                    locationName: "privateIpAddressesSet"
                  },
                  SecondaryPrivateIpAddressCount: {
                    locationName: "secondaryPrivateIpAddressCount",
                    type: "integer"
                  },
                  SubnetId: {
                    locationName: "subnetId"
                  },
                  NetworkCardIndex: {
                    locationName: "networkCardIndex",
                    type: "integer"
                  },
                  Ipv4Prefixes: {
                    locationName: "ipv4PrefixSet",
                    type: "list",
                    member: {
                      locationName: "item",
                      type: "structure",
                      members: {
                        Ipv4Prefix: {
                          locationName: "ipv4Prefix"
                        }
                      }
                    }
                  },
                  Ipv4PrefixCount: {
                    locationName: "ipv4PrefixCount",
                    type: "integer"
                  },
                  Ipv6Prefixes: {
                    locationName: "ipv6PrefixSet",
                    type: "list",
                    member: {
                      locationName: "item",
                      type: "structure",
                      members: {
                        Ipv6Prefix: {
                          locationName: "ipv6Prefix"
                        }
                      }
                    }
                  },
                  Ipv6PrefixCount: {
                    locationName: "ipv6PrefixCount",
                    type: "integer"
                  }
                }
              }
            },
            ImageId: {
              locationName: "imageId"
            },
            InstanceType: {
              locationName: "instanceType"
            },
            KeyName: {
              locationName: "keyName"
            },
            Monitoring: {
              locationName: "monitoring",
              type: "structure",
              members: {
                Enabled: {
                  locationName: "enabled",
                  type: "boolean"
                }
              }
            },
            Placement: {
              locationName: "placement",
              type: "structure",
              members: {
                AvailabilityZone: {
                  locationName: "availabilityZone"
                },
                Affinity: {
                  locationName: "affinity"
                },
                GroupName: {
                  locationName: "groupName"
                },
                HostId: {
                  locationName: "hostId"
                },
                Tenancy: {
                  locationName: "tenancy"
                },
                SpreadDomain: {
                  locationName: "spreadDomain"
                },
                HostResourceGroupArn: {
                  locationName: "hostResourceGroupArn"
                },
                PartitionNumber: {
                  locationName: "partitionNumber",
                  type: "integer"
                }
              }
            },
            RamDiskId: {
              locationName: "ramDiskId"
            },
            DisableApiTermination: {
              locationName: "disableApiTermination",
              type: "boolean"
            },
            InstanceInitiatedShutdownBehavior: {
              locationName: "instanceInitiatedShutdownBehavior"
            },
            UserData: {
              locationName: "userData"
            },
            TagSpecifications: {
              locationName: "tagSpecificationSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  ResourceType: {
                    locationName: "resourceType"
                  },
                  Tags: {
                    shape: "Ss",
                    locationName: "tagSet"
                  }
                }
              }
            },
            ElasticGpuSpecifications: {
              locationName: "elasticGpuSpecificationSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  Type: {
                    locationName: "type"
                  }
                }
              }
            },
            ElasticInferenceAccelerators: {
              locationName: "elasticInferenceAcceleratorSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  Type: {
                    locationName: "type"
                  },
                  Count: {
                    locationName: "count",
                    type: "integer"
                  }
                }
              }
            },
            SecurityGroupIds: {
              shape: "Se",
              locationName: "securityGroupIdSet"
            },
            SecurityGroups: {
              shape: "Se",
              locationName: "securityGroupSet"
            },
            InstanceMarketOptions: {
              locationName: "instanceMarketOptions",
              type: "structure",
              members: {
                MarketType: {
                  locationName: "marketType"
                },
                SpotOptions: {
                  locationName: "spotOptions",
                  type: "structure",
                  members: {
                    MaxPrice: {
                      locationName: "maxPrice"
                    },
                    SpotInstanceType: {
                      locationName: "spotInstanceType"
                    },
                    BlockDurationMinutes: {
                      locationName: "blockDurationMinutes",
                      type: "integer"
                    },
                    ValidUntil: {
                      locationName: "validUntil",
                      type: "timestamp"
                    },
                    InstanceInterruptionBehavior: {
                      locationName: "instanceInterruptionBehavior"
                    }
                  }
                }
              }
            },
            CreditSpecification: {
              locationName: "creditSpecification",
              type: "structure",
              members: {
                CpuCredits: {
                  locationName: "cpuCredits"
                }
              }
            },
            CpuOptions: {
              locationName: "cpuOptions",
              type: "structure",
              members: {
                CoreCount: {
                  locationName: "coreCount",
                  type: "integer"
                },
                ThreadsPerCore: {
                  locationName: "threadsPerCore",
                  type: "integer"
                }
              }
            },
            CapacityReservationSpecification: {
              locationName: "capacityReservationSpecification",
              type: "structure",
              members: {
                CapacityReservationPreference: {
                  locationName: "capacityReservationPreference"
                },
                CapacityReservationTarget: {
                  shape: "Se7",
                  locationName: "capacityReservationTarget"
                }
              }
            },
            LicenseSpecifications: {
              locationName: "licenseSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  LicenseConfigurationArn: {
                    locationName: "licenseConfigurationArn"
                  }
                }
              }
            },
            HibernationOptions: {
              locationName: "hibernationOptions",
              type: "structure",
              members: {
                Configured: {
                  locationName: "configured",
                  type: "boolean"
                }
              }
            },
            MetadataOptions: {
              locationName: "metadataOptions",
              type: "structure",
              members: {
                State: {
                  locationName: "state"
                },
                HttpTokens: {
                  locationName: "httpTokens"
                },
                HttpPutResponseHopLimit: {
                  locationName: "httpPutResponseHopLimit",
                  type: "integer"
                },
                HttpEndpoint: {
                  locationName: "httpEndpoint"
                },
                HttpProtocolIpv6: {
                  locationName: "httpProtocolIpv6"
                }
              }
            },
            EnclaveOptions: {
              locationName: "enclaveOptions",
              type: "structure",
              members: {
                Enabled: {
                  locationName: "enabled",
                  type: "boolean"
                }
              }
            }
          }
        },
        Sdo: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Ipv6Address: {
                locationName: "ipv6Address"
              }
            }
          }
        },
        Se7: {
          type: "structure",
          members: {
            CapacityReservationId: {
              locationName: "capacityReservationId"
            },
            CapacityReservationResourceGroupArn: {
              locationName: "capacityReservationResourceGroupArn"
            }
          }
        },
        Sei: {
          type: "structure",
          members: {
            DestinationCidrBlock: {
              locationName: "destinationCidrBlock"
            },
            LocalGatewayVirtualInterfaceGroupId: {
              locationName: "localGatewayVirtualInterfaceGroupId"
            },
            Type: {
              locationName: "type"
            },
            State: {
              locationName: "state"
            },
            LocalGatewayRouteTableId: {
              locationName: "localGatewayRouteTableId"
            },
            LocalGatewayRouteTableArn: {
              locationName: "localGatewayRouteTableArn"
            },
            OwnerId: {
              locationName: "ownerId"
            }
          }
        },
        Sen: {
          type: "structure",
          members: {
            LocalGatewayRouteTableVpcAssociationId: {
              locationName: "localGatewayRouteTableVpcAssociationId"
            },
            LocalGatewayRouteTableId: {
              locationName: "localGatewayRouteTableId"
            },
            LocalGatewayRouteTableArn: {
              locationName: "localGatewayRouteTableArn"
            },
            LocalGatewayId: {
              locationName: "localGatewayId"
            },
            VpcId: {
              locationName: "vpcId"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            State: {
              locationName: "state"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        Seq: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Cidr"
            ],
            members: {
              Cidr: {},
              Description: {}
            }
          }
        },
        Set: {
          type: "structure",
          members: {
            PrefixListId: {
              locationName: "prefixListId"
            },
            AddressFamily: {
              locationName: "addressFamily"
            },
            State: {
              locationName: "state"
            },
            StateMessage: {
              locationName: "stateMessage"
            },
            PrefixListArn: {
              locationName: "prefixListArn"
            },
            PrefixListName: {
              locationName: "prefixListName"
            },
            MaxEntries: {
              locationName: "maxEntries",
              type: "integer"
            },
            Version: {
              locationName: "version",
              type: "long"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            },
            OwnerId: {
              locationName: "ownerId"
            }
          }
        },
        Sey: {
          type: "structure",
          members: {
            CreateTime: {
              locationName: "createTime",
              type: "timestamp"
            },
            DeleteTime: {
              locationName: "deleteTime",
              type: "timestamp"
            },
            FailureCode: {
              locationName: "failureCode"
            },
            FailureMessage: {
              locationName: "failureMessage"
            },
            NatGatewayAddresses: {
              locationName: "natGatewayAddressSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  AllocationId: {
                    locationName: "allocationId"
                  },
                  NetworkInterfaceId: {
                    locationName: "networkInterfaceId"
                  },
                  PrivateIp: {
                    locationName: "privateIp"
                  },
                  PublicIp: {
                    locationName: "publicIp"
                  }
                }
              }
            },
            NatGatewayId: {
              locationName: "natGatewayId"
            },
            ProvisionedBandwidth: {
              locationName: "provisionedBandwidth",
              type: "structure",
              members: {
                ProvisionTime: {
                  locationName: "provisionTime",
                  type: "timestamp"
                },
                Provisioned: {
                  locationName: "provisioned"
                },
                RequestTime: {
                  locationName: "requestTime",
                  type: "timestamp"
                },
                Requested: {
                  locationName: "requested"
                },
                Status: {
                  locationName: "status"
                }
              }
            },
            State: {
              locationName: "state"
            },
            SubnetId: {
              locationName: "subnetId"
            },
            VpcId: {
              locationName: "vpcId"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            },
            ConnectivityType: {
              locationName: "connectivityType"
            }
          }
        },
        Sf5: {
          type: "structure",
          members: {
            Associations: {
              locationName: "associationSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  NetworkAclAssociationId: {
                    locationName: "networkAclAssociationId"
                  },
                  NetworkAclId: {
                    locationName: "networkAclId"
                  },
                  SubnetId: {
                    locationName: "subnetId"
                  }
                }
              }
            },
            Entries: {
              locationName: "entrySet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  CidrBlock: {
                    locationName: "cidrBlock"
                  },
                  Egress: {
                    locationName: "egress",
                    type: "boolean"
                  },
                  IcmpTypeCode: {
                    shape: "Sfa",
                    locationName: "icmpTypeCode"
                  },
                  Ipv6CidrBlock: {
                    locationName: "ipv6CidrBlock"
                  },
                  PortRange: {
                    shape: "Sfb",
                    locationName: "portRange"
                  },
                  Protocol: {
                    locationName: "protocol"
                  },
                  RuleAction: {
                    locationName: "ruleAction"
                  },
                  RuleNumber: {
                    locationName: "ruleNumber",
                    type: "integer"
                  }
                }
              }
            },
            IsDefault: {
              locationName: "default",
              type: "boolean"
            },
            NetworkAclId: {
              locationName: "networkAclId"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            },
            VpcId: {
              locationName: "vpcId"
            },
            OwnerId: {
              locationName: "ownerId"
            }
          }
        },
        Sfa: {
          type: "structure",
          members: {
            Code: {
              locationName: "code",
              type: "integer"
            },
            Type: {
              locationName: "type",
              type: "integer"
            }
          }
        },
        Sfb: {
          type: "structure",
          members: {
            From: {
              locationName: "from",
              type: "integer"
            },
            To: {
              locationName: "to",
              type: "integer"
            }
          }
        },
        Sfk: {
          type: "structure",
          members: {
            NetworkInsightsPathId: {
              locationName: "networkInsightsPathId"
            },
            NetworkInsightsPathArn: {
              locationName: "networkInsightsPathArn"
            },
            CreatedDate: {
              locationName: "createdDate",
              type: "timestamp"
            },
            Source: {
              locationName: "source"
            },
            Destination: {
              locationName: "destination"
            },
            SourceIp: {
              locationName: "sourceIp"
            },
            DestinationIp: {
              locationName: "destinationIp"
            },
            Protocol: {
              locationName: "protocol"
            },
            DestinationPort: {
              locationName: "destinationPort",
              type: "integer"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        Sfp: {
          type: "structure",
          members: {
            Association: {
              shape: "Sfq",
              locationName: "association"
            },
            Attachment: {
              shape: "Sfr",
              locationName: "attachment"
            },
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            Description: {
              locationName: "description"
            },
            Groups: {
              shape: "Sfs",
              locationName: "groupSet"
            },
            InterfaceType: {
              locationName: "interfaceType"
            },
            Ipv6Addresses: {
              locationName: "ipv6AddressesSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  Ipv6Address: {
                    locationName: "ipv6Address"
                  }
                }
              }
            },
            MacAddress: {
              locationName: "macAddress"
            },
            NetworkInterfaceId: {
              locationName: "networkInterfaceId"
            },
            OutpostArn: {
              locationName: "outpostArn"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            PrivateDnsName: {
              locationName: "privateDnsName"
            },
            PrivateIpAddress: {
              locationName: "privateIpAddress"
            },
            PrivateIpAddresses: {
              locationName: "privateIpAddressesSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  Association: {
                    shape: "Sfq",
                    locationName: "association"
                  },
                  Primary: {
                    locationName: "primary",
                    type: "boolean"
                  },
                  PrivateDnsName: {
                    locationName: "privateDnsName"
                  },
                  PrivateIpAddress: {
                    locationName: "privateIpAddress"
                  }
                }
              }
            },
            Ipv4Prefixes: {
              shape: "S2i",
              locationName: "ipv4PrefixSet"
            },
            Ipv6Prefixes: {
              locationName: "ipv6PrefixSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  Ipv6Prefix: {
                    locationName: "ipv6Prefix"
                  }
                }
              }
            },
            RequesterId: {
              locationName: "requesterId"
            },
            RequesterManaged: {
              locationName: "requesterManaged",
              type: "boolean"
            },
            SourceDestCheck: {
              locationName: "sourceDestCheck",
              type: "boolean"
            },
            Status: {
              locationName: "status"
            },
            SubnetId: {
              locationName: "subnetId"
            },
            TagSet: {
              shape: "Ss",
              locationName: "tagSet"
            },
            VpcId: {
              locationName: "vpcId"
            }
          }
        },
        Sfq: {
          type: "structure",
          members: {
            AllocationId: {
              locationName: "allocationId"
            },
            AssociationId: {
              locationName: "associationId"
            },
            IpOwnerId: {
              locationName: "ipOwnerId"
            },
            PublicDnsName: {
              locationName: "publicDnsName"
            },
            PublicIp: {
              locationName: "publicIp"
            },
            CustomerOwnedIp: {
              locationName: "customerOwnedIp"
            },
            CarrierIp: {
              locationName: "carrierIp"
            }
          }
        },
        Sfr: {
          type: "structure",
          members: {
            AttachTime: {
              locationName: "attachTime",
              type: "timestamp"
            },
            AttachmentId: {
              locationName: "attachmentId"
            },
            DeleteOnTermination: {
              locationName: "deleteOnTermination",
              type: "boolean"
            },
            DeviceIndex: {
              locationName: "deviceIndex",
              type: "integer"
            },
            NetworkCardIndex: {
              locationName: "networkCardIndex",
              type: "integer"
            },
            InstanceId: {
              locationName: "instanceId"
            },
            InstanceOwnerId: {
              locationName: "instanceOwnerId"
            },
            Status: {
              locationName: "status"
            }
          }
        },
        Sfs: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              GroupName: {
                locationName: "groupName"
              },
              GroupId: {
                locationName: "groupId"
              }
            }
          }
        },
        Sg5: {
          type: "structure",
          members: {
            NetworkInterfacePermissionId: {
              locationName: "networkInterfacePermissionId"
            },
            NetworkInterfaceId: {
              locationName: "networkInterfaceId"
            },
            AwsAccountId: {
              locationName: "awsAccountId"
            },
            AwsService: {
              locationName: "awsService"
            },
            Permission: {
              locationName: "permission"
            },
            PermissionState: {
              locationName: "permissionState",
              type: "structure",
              members: {
                State: {
                  locationName: "state"
                },
                StatusMessage: {
                  locationName: "statusMessage"
                }
              }
            }
          }
        },
        Sgb: {
          type: "structure",
          members: {
            GroupName: {
              locationName: "groupName"
            },
            State: {
              locationName: "state"
            },
            Strategy: {
              locationName: "strategy"
            },
            PartitionCount: {
              locationName: "partitionCount",
              type: "integer"
            },
            GroupId: {
              locationName: "groupId"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        Sgf: {
          type: "structure",
          members: {
            ReplaceRootVolumeTaskId: {
              locationName: "replaceRootVolumeTaskId"
            },
            InstanceId: {
              locationName: "instanceId"
            },
            TaskState: {
              locationName: "taskState"
            },
            StartTime: {
              locationName: "startTime"
            },
            CompleteTime: {
              locationName: "completeTime"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        Sgv: {
          type: "structure",
          members: {
            Associations: {
              locationName: "associationSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  Main: {
                    locationName: "main",
                    type: "boolean"
                  },
                  RouteTableAssociationId: {
                    locationName: "routeTableAssociationId"
                  },
                  RouteTableId: {
                    locationName: "routeTableId"
                  },
                  SubnetId: {
                    locationName: "subnetId"
                  },
                  GatewayId: {
                    locationName: "gatewayId"
                  },
                  AssociationState: {
                    shape: "S3n",
                    locationName: "associationState"
                  }
                }
              }
            },
            PropagatingVgws: {
              locationName: "propagatingVgwSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  GatewayId: {
                    locationName: "gatewayId"
                  }
                }
              }
            },
            RouteTableId: {
              locationName: "routeTableId"
            },
            Routes: {
              locationName: "routeSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  DestinationCidrBlock: {
                    locationName: "destinationCidrBlock"
                  },
                  DestinationIpv6CidrBlock: {
                    locationName: "destinationIpv6CidrBlock"
                  },
                  DestinationPrefixListId: {
                    locationName: "destinationPrefixListId"
                  },
                  EgressOnlyInternetGatewayId: {
                    locationName: "egressOnlyInternetGatewayId"
                  },
                  GatewayId: {
                    locationName: "gatewayId"
                  },
                  InstanceId: {
                    locationName: "instanceId"
                  },
                  InstanceOwnerId: {
                    locationName: "instanceOwnerId"
                  },
                  NatGatewayId: {
                    locationName: "natGatewayId"
                  },
                  TransitGatewayId: {
                    locationName: "transitGatewayId"
                  },
                  LocalGatewayId: {
                    locationName: "localGatewayId"
                  },
                  CarrierGatewayId: {
                    locationName: "carrierGatewayId"
                  },
                  NetworkInterfaceId: {
                    locationName: "networkInterfaceId"
                  },
                  Origin: {
                    locationName: "origin"
                  },
                  State: {
                    locationName: "state"
                  },
                  VpcPeeringConnectionId: {
                    locationName: "vpcPeeringConnectionId"
                  }
                }
              }
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            },
            VpcId: {
              locationName: "vpcId"
            },
            OwnerId: {
              locationName: "ownerId"
            }
          }
        },
        Sh7: {
          type: "structure",
          members: {
            DataEncryptionKeyId: {
              locationName: "dataEncryptionKeyId"
            },
            Description: {
              locationName: "description"
            },
            Encrypted: {
              locationName: "encrypted",
              type: "boolean"
            },
            KmsKeyId: {
              locationName: "kmsKeyId"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            Progress: {
              locationName: "progress"
            },
            SnapshotId: {
              locationName: "snapshotId"
            },
            StartTime: {
              locationName: "startTime",
              type: "timestamp"
            },
            State: {
              locationName: "status"
            },
            StateMessage: {
              locationName: "statusMessage"
            },
            VolumeId: {
              locationName: "volumeId"
            },
            VolumeSize: {
              locationName: "volumeSize",
              type: "integer"
            },
            OwnerAlias: {
              locationName: "ownerAlias"
            },
            OutpostArn: {
              locationName: "outpostArn"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        Shh: {
          type: "structure",
          members: {
            Bucket: {
              locationName: "bucket"
            },
            Fault: {
              shape: "Shi",
              locationName: "fault"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            Prefix: {
              locationName: "prefix"
            },
            State: {
              locationName: "state"
            }
          }
        },
        Shi: {
          type: "structure",
          members: {
            Code: {
              locationName: "code"
            },
            Message: {
              locationName: "message"
            }
          }
        },
        Sht: {
          type: "structure",
          members: {
            SubnetCidrReservationId: {
              locationName: "subnetCidrReservationId"
            },
            SubnetId: {
              locationName: "subnetId"
            },
            Cidr: {
              locationName: "cidr"
            },
            ReservationType: {
              locationName: "reservationType"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            Description: {
              locationName: "description"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        Shw: {
          type: "list",
          member: {}
        },
        Si0: {
          type: "structure",
          members: {
            TrafficMirrorFilterId: {
              locationName: "trafficMirrorFilterId"
            },
            IngressFilterRules: {
              shape: "Si1",
              locationName: "ingressFilterRuleSet"
            },
            EgressFilterRules: {
              shape: "Si1",
              locationName: "egressFilterRuleSet"
            },
            NetworkServices: {
              shape: "Si6",
              locationName: "networkServiceSet"
            },
            Description: {
              locationName: "description"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        Si1: {
          type: "list",
          member: {
            shape: "Si2",
            locationName: "item"
          }
        },
        Si2: {
          type: "structure",
          members: {
            TrafficMirrorFilterRuleId: {
              locationName: "trafficMirrorFilterRuleId"
            },
            TrafficMirrorFilterId: {
              locationName: "trafficMirrorFilterId"
            },
            TrafficDirection: {
              locationName: "trafficDirection"
            },
            RuleNumber: {
              locationName: "ruleNumber",
              type: "integer"
            },
            RuleAction: {
              locationName: "ruleAction"
            },
            Protocol: {
              locationName: "protocol",
              type: "integer"
            },
            DestinationPortRange: {
              shape: "Si5",
              locationName: "destinationPortRange"
            },
            SourcePortRange: {
              shape: "Si5",
              locationName: "sourcePortRange"
            },
            DestinationCidrBlock: {
              locationName: "destinationCidrBlock"
            },
            SourceCidrBlock: {
              locationName: "sourceCidrBlock"
            },
            Description: {
              locationName: "description"
            }
          }
        },
        Si5: {
          type: "structure",
          members: {
            FromPort: {
              locationName: "fromPort",
              type: "integer"
            },
            ToPort: {
              locationName: "toPort",
              type: "integer"
            }
          }
        },
        Si6: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sia: {
          type: "structure",
          members: {
            FromPort: {
              type: "integer"
            },
            ToPort: {
              type: "integer"
            }
          }
        },
        Sif: {
          type: "structure",
          members: {
            TrafficMirrorSessionId: {
              locationName: "trafficMirrorSessionId"
            },
            TrafficMirrorTargetId: {
              locationName: "trafficMirrorTargetId"
            },
            TrafficMirrorFilterId: {
              locationName: "trafficMirrorFilterId"
            },
            NetworkInterfaceId: {
              locationName: "networkInterfaceId"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            PacketLength: {
              locationName: "packetLength",
              type: "integer"
            },
            SessionNumber: {
              locationName: "sessionNumber",
              type: "integer"
            },
            VirtualNetworkId: {
              locationName: "virtualNetworkId",
              type: "integer"
            },
            Description: {
              locationName: "description"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        Sii: {
          type: "structure",
          members: {
            TrafficMirrorTargetId: {
              locationName: "trafficMirrorTargetId"
            },
            NetworkInterfaceId: {
              locationName: "networkInterfaceId"
            },
            NetworkLoadBalancerArn: {
              locationName: "networkLoadBalancerArn"
            },
            Type: {
              locationName: "type"
            },
            Description: {
              locationName: "description"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        Sir: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sit: {
          type: "structure",
          members: {
            TransitGatewayId: {
              locationName: "transitGatewayId"
            },
            TransitGatewayArn: {
              locationName: "transitGatewayArn"
            },
            State: {
              locationName: "state"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            Description: {
              locationName: "description"
            },
            CreationTime: {
              locationName: "creationTime",
              type: "timestamp"
            },
            Options: {
              locationName: "options",
              type: "structure",
              members: {
                AmazonSideAsn: {
                  locationName: "amazonSideAsn",
                  type: "long"
                },
                TransitGatewayCidrBlocks: {
                  shape: "Se",
                  locationName: "transitGatewayCidrBlocks"
                },
                AutoAcceptSharedAttachments: {
                  locationName: "autoAcceptSharedAttachments"
                },
                DefaultRouteTableAssociation: {
                  locationName: "defaultRouteTableAssociation"
                },
                AssociationDefaultRouteTableId: {
                  locationName: "associationDefaultRouteTableId"
                },
                DefaultRouteTablePropagation: {
                  locationName: "defaultRouteTablePropagation"
                },
                PropagationDefaultRouteTableId: {
                  locationName: "propagationDefaultRouteTableId"
                },
                VpnEcmpSupport: {
                  locationName: "vpnEcmpSupport"
                },
                DnsSupport: {
                  locationName: "dnsSupport"
                },
                MulticastSupport: {
                  locationName: "multicastSupport"
                }
              }
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        Sj0: {
          type: "structure",
          members: {
            TransitGatewayAttachmentId: {
              locationName: "transitGatewayAttachmentId"
            },
            TransportTransitGatewayAttachmentId: {
              locationName: "transportTransitGatewayAttachmentId"
            },
            TransitGatewayId: {
              locationName: "transitGatewayId"
            },
            State: {
              locationName: "state"
            },
            CreationTime: {
              locationName: "creationTime",
              type: "timestamp"
            },
            Options: {
              locationName: "options",
              type: "structure",
              members: {
                Protocol: {
                  locationName: "protocol"
                }
              }
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        Sj4: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sj6: {
          type: "structure",
          members: {
            TransitGatewayAttachmentId: {
              locationName: "transitGatewayAttachmentId"
            },
            TransitGatewayConnectPeerId: {
              locationName: "transitGatewayConnectPeerId"
            },
            State: {
              locationName: "state"
            },
            CreationTime: {
              locationName: "creationTime",
              type: "timestamp"
            },
            ConnectPeerConfiguration: {
              locationName: "connectPeerConfiguration",
              type: "structure",
              members: {
                TransitGatewayAddress: {
                  locationName: "transitGatewayAddress"
                },
                PeerAddress: {
                  locationName: "peerAddress"
                },
                InsideCidrBlocks: {
                  shape: "Sj4",
                  locationName: "insideCidrBlocks"
                },
                Protocol: {
                  locationName: "protocol"
                },
                BgpConfigurations: {
                  locationName: "bgpConfigurations",
                  type: "list",
                  member: {
                    locationName: "item",
                    type: "structure",
                    members: {
                      TransitGatewayAsn: {
                        locationName: "transitGatewayAsn",
                        type: "long"
                      },
                      PeerAsn: {
                        locationName: "peerAsn",
                        type: "long"
                      },
                      TransitGatewayAddress: {
                        locationName: "transitGatewayAddress"
                      },
                      PeerAddress: {
                        locationName: "peerAddress"
                      },
                      BgpStatus: {
                        locationName: "bgpStatus"
                      }
                    }
                  }
                }
              }
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        Sjj: {
          type: "structure",
          members: {
            TransitGatewayMulticastDomainId: {
              locationName: "transitGatewayMulticastDomainId"
            },
            TransitGatewayId: {
              locationName: "transitGatewayId"
            },
            TransitGatewayMulticastDomainArn: {
              locationName: "transitGatewayMulticastDomainArn"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            Options: {
              locationName: "options",
              type: "structure",
              members: {
                Igmpv2Support: {
                  locationName: "igmpv2Support"
                },
                StaticSourcesSupport: {
                  locationName: "staticSourcesSupport"
                },
                AutoAcceptSharedAssociations: {
                  locationName: "autoAcceptSharedAssociations"
                }
              }
            },
            State: {
              locationName: "state"
            },
            CreationTime: {
              locationName: "creationTime",
              type: "timestamp"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        Sjr: {
          type: "structure",
          members: {
            TransitGatewayRouteTableId: {
              locationName: "transitGatewayRouteTableId"
            },
            PrefixListId: {
              locationName: "prefixListId"
            },
            PrefixListOwnerId: {
              locationName: "prefixListOwnerId"
            },
            State: {
              locationName: "state"
            },
            Blackhole: {
              locationName: "blackhole",
              type: "boolean"
            },
            TransitGatewayAttachment: {
              locationName: "transitGatewayAttachment",
              type: "structure",
              members: {
                TransitGatewayAttachmentId: {
                  locationName: "transitGatewayAttachmentId"
                },
                ResourceType: {
                  locationName: "resourceType"
                },
                ResourceId: {
                  locationName: "resourceId"
                }
              }
            }
          }
        },
        Sjw: {
          type: "structure",
          members: {
            DestinationCidrBlock: {
              locationName: "destinationCidrBlock"
            },
            PrefixListId: {
              locationName: "prefixListId"
            },
            TransitGatewayAttachments: {
              locationName: "transitGatewayAttachments",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  ResourceId: {
                    locationName: "resourceId"
                  },
                  TransitGatewayAttachmentId: {
                    locationName: "transitGatewayAttachmentId"
                  },
                  ResourceType: {
                    locationName: "resourceType"
                  }
                }
              }
            },
            Type: {
              locationName: "type"
            },
            State: {
              locationName: "state"
            }
          }
        },
        Sk3: {
          type: "structure",
          members: {
            TransitGatewayRouteTableId: {
              locationName: "transitGatewayRouteTableId"
            },
            TransitGatewayId: {
              locationName: "transitGatewayId"
            },
            State: {
              locationName: "state"
            },
            DefaultAssociationRouteTable: {
              locationName: "defaultAssociationRouteTable",
              type: "boolean"
            },
            DefaultPropagationRouteTable: {
              locationName: "defaultPropagationRouteTable",
              type: "boolean"
            },
            CreationTime: {
              locationName: "creationTime",
              type: "timestamp"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        Sk9: {
          type: "structure",
          members: {
            Attachments: {
              locationName: "attachmentSet",
              type: "list",
              member: {
                shape: "S4o",
                locationName: "item"
              }
            },
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            CreateTime: {
              locationName: "createTime",
              type: "timestamp"
            },
            Encrypted: {
              locationName: "encrypted",
              type: "boolean"
            },
            KmsKeyId: {
              locationName: "kmsKeyId"
            },
            OutpostArn: {
              locationName: "outpostArn"
            },
            Size: {
              locationName: "size",
              type: "integer"
            },
            SnapshotId: {
              locationName: "snapshotId"
            },
            State: {
              locationName: "status"
            },
            VolumeId: {
              locationName: "volumeId"
            },
            Iops: {
              locationName: "iops",
              type: "integer"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            },
            VolumeType: {
              locationName: "volumeType"
            },
            FastRestored: {
              locationName: "fastRestored",
              type: "boolean"
            },
            MultiAttachEnabled: {
              locationName: "multiAttachEnabled",
              type: "boolean"
            },
            Throughput: {
              locationName: "throughput",
              type: "integer"
            }
          }
        },
        Skg: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Skh: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Ski: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Skk: {
          type: "structure",
          members: {
            VpcEndpointId: {
              locationName: "vpcEndpointId"
            },
            VpcEndpointType: {
              locationName: "vpcEndpointType"
            },
            VpcId: {
              locationName: "vpcId"
            },
            ServiceName: {
              locationName: "serviceName"
            },
            State: {
              locationName: "state"
            },
            PolicyDocument: {
              locationName: "policyDocument"
            },
            RouteTableIds: {
              shape: "Se",
              locationName: "routeTableIdSet"
            },
            SubnetIds: {
              shape: "Se",
              locationName: "subnetIdSet"
            },
            Groups: {
              locationName: "groupSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  GroupId: {
                    locationName: "groupId"
                  },
                  GroupName: {
                    locationName: "groupName"
                  }
                }
              }
            },
            PrivateDnsEnabled: {
              locationName: "privateDnsEnabled",
              type: "boolean"
            },
            RequesterManaged: {
              locationName: "requesterManaged",
              type: "boolean"
            },
            NetworkInterfaceIds: {
              shape: "Se",
              locationName: "networkInterfaceIdSet"
            },
            DnsEntries: {
              shape: "Sko",
              locationName: "dnsEntrySet"
            },
            CreationTimestamp: {
              locationName: "creationTimestamp",
              type: "timestamp"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            },
            OwnerId: {
              locationName: "ownerId"
            },
            LastError: {
              locationName: "lastError",
              type: "structure",
              members: {
                Message: {
                  locationName: "message"
                },
                Code: {
                  locationName: "code"
                }
              }
            }
          }
        },
        Sko: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              DnsName: {
                locationName: "dnsName"
              },
              HostedZoneId: {
                locationName: "hostedZoneId"
              }
            }
          }
        },
        Skt: {
          type: "structure",
          members: {
            ConnectionNotificationId: {
              locationName: "connectionNotificationId"
            },
            ServiceId: {
              locationName: "serviceId"
            },
            VpcEndpointId: {
              locationName: "vpcEndpointId"
            },
            ConnectionNotificationType: {
              locationName: "connectionNotificationType"
            },
            ConnectionNotificationArn: {
              locationName: "connectionNotificationArn"
            },
            ConnectionEvents: {
              shape: "Se",
              locationName: "connectionEvents"
            },
            ConnectionNotificationState: {
              locationName: "connectionNotificationState"
            }
          }
        },
        Sky: {
          type: "structure",
          members: {
            ServiceType: {
              shape: "Skz",
              locationName: "serviceType"
            },
            ServiceId: {
              locationName: "serviceId"
            },
            ServiceName: {
              locationName: "serviceName"
            },
            ServiceState: {
              locationName: "serviceState"
            },
            AvailabilityZones: {
              shape: "Se",
              locationName: "availabilityZoneSet"
            },
            AcceptanceRequired: {
              locationName: "acceptanceRequired",
              type: "boolean"
            },
            ManagesVpcEndpoints: {
              locationName: "managesVpcEndpoints",
              type: "boolean"
            },
            NetworkLoadBalancerArns: {
              shape: "Se",
              locationName: "networkLoadBalancerArnSet"
            },
            GatewayLoadBalancerArns: {
              shape: "Se",
              locationName: "gatewayLoadBalancerArnSet"
            },
            BaseEndpointDnsNames: {
              shape: "Se",
              locationName: "baseEndpointDnsNameSet"
            },
            PrivateDnsName: {
              locationName: "privateDnsName"
            },
            PrivateDnsNameConfiguration: {
              locationName: "privateDnsNameConfiguration",
              type: "structure",
              members: {
                State: {
                  locationName: "state"
                },
                Type: {
                  locationName: "type"
                },
                Value: {
                  locationName: "value"
                },
                Name: {
                  locationName: "name"
                }
              }
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        Skz: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              ServiceType: {
                locationName: "serviceType"
              }
            }
          }
        },
        Sld: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Value: {}
            }
          }
        },
        Slf: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Value: {}
            }
          }
        },
        Slh: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Value: {}
            }
          }
        },
        Slj: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Value: {}
            }
          }
        },
        Sll: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Value: {
                type: "integer"
              }
            }
          }
        },
        Sln: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Value: {
                type: "integer"
              }
            }
          }
        },
        Slp: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Value: {}
            }
          }
        },
        Sls: {
          type: "structure",
          members: {
            CustomerGatewayConfiguration: {
              locationName: "customerGatewayConfiguration"
            },
            CustomerGatewayId: {
              locationName: "customerGatewayId"
            },
            Category: {
              locationName: "category"
            },
            State: {
              locationName: "state"
            },
            Type: {
              locationName: "type"
            },
            VpnConnectionId: {
              locationName: "vpnConnectionId"
            },
            VpnGatewayId: {
              locationName: "vpnGatewayId"
            },
            TransitGatewayId: {
              locationName: "transitGatewayId"
            },
            Options: {
              locationName: "options",
              type: "structure",
              members: {
                EnableAcceleration: {
                  locationName: "enableAcceleration",
                  type: "boolean"
                },
                StaticRoutesOnly: {
                  locationName: "staticRoutesOnly",
                  type: "boolean"
                },
                LocalIpv4NetworkCidr: {
                  locationName: "localIpv4NetworkCidr"
                },
                RemoteIpv4NetworkCidr: {
                  locationName: "remoteIpv4NetworkCidr"
                },
                LocalIpv6NetworkCidr: {
                  locationName: "localIpv6NetworkCidr"
                },
                RemoteIpv6NetworkCidr: {
                  locationName: "remoteIpv6NetworkCidr"
                },
                TunnelInsideIpVersion: {
                  locationName: "tunnelInsideIpVersion"
                },
                TunnelOptions: {
                  locationName: "tunnelOptionSet",
                  type: "list",
                  member: {
                    locationName: "item",
                    type: "structure",
                    members: {
                      OutsideIpAddress: {
                        locationName: "outsideIpAddress"
                      },
                      TunnelInsideCidr: {
                        locationName: "tunnelInsideCidr"
                      },
                      TunnelInsideIpv6Cidr: {
                        locationName: "tunnelInsideIpv6Cidr"
                      },
                      PreSharedKey: {
                        locationName: "preSharedKey"
                      },
                      Phase1LifetimeSeconds: {
                        locationName: "phase1LifetimeSeconds",
                        type: "integer"
                      },
                      Phase2LifetimeSeconds: {
                        locationName: "phase2LifetimeSeconds",
                        type: "integer"
                      },
                      RekeyMarginTimeSeconds: {
                        locationName: "rekeyMarginTimeSeconds",
                        type: "integer"
                      },
                      RekeyFuzzPercentage: {
                        locationName: "rekeyFuzzPercentage",
                        type: "integer"
                      },
                      ReplayWindowSize: {
                        locationName: "replayWindowSize",
                        type: "integer"
                      },
                      DpdTimeoutSeconds: {
                        locationName: "dpdTimeoutSeconds",
                        type: "integer"
                      },
                      DpdTimeoutAction: {
                        locationName: "dpdTimeoutAction"
                      },
                      Phase1EncryptionAlgorithms: {
                        locationName: "phase1EncryptionAlgorithmSet",
                        type: "list",
                        member: {
                          locationName: "item",
                          type: "structure",
                          members: {
                            Value: {
                              locationName: "value"
                            }
                          }
                        }
                      },
                      Phase2EncryptionAlgorithms: {
                        locationName: "phase2EncryptionAlgorithmSet",
                        type: "list",
                        member: {
                          locationName: "item",
                          type: "structure",
                          members: {
                            Value: {
                              locationName: "value"
                            }
                          }
                        }
                      },
                      Phase1IntegrityAlgorithms: {
                        locationName: "phase1IntegrityAlgorithmSet",
                        type: "list",
                        member: {
                          locationName: "item",
                          type: "structure",
                          members: {
                            Value: {
                              locationName: "value"
                            }
                          }
                        }
                      },
                      Phase2IntegrityAlgorithms: {
                        locationName: "phase2IntegrityAlgorithmSet",
                        type: "list",
                        member: {
                          locationName: "item",
                          type: "structure",
                          members: {
                            Value: {
                              locationName: "value"
                            }
                          }
                        }
                      },
                      Phase1DHGroupNumbers: {
                        locationName: "phase1DHGroupNumberSet",
                        type: "list",
                        member: {
                          locationName: "item",
                          type: "structure",
                          members: {
                            Value: {
                              locationName: "value",
                              type: "integer"
                            }
                          }
                        }
                      },
                      Phase2DHGroupNumbers: {
                        locationName: "phase2DHGroupNumberSet",
                        type: "list",
                        member: {
                          locationName: "item",
                          type: "structure",
                          members: {
                            Value: {
                              locationName: "value",
                              type: "integer"
                            }
                          }
                        }
                      },
                      IkeVersions: {
                        locationName: "ikeVersionSet",
                        type: "list",
                        member: {
                          locationName: "item",
                          type: "structure",
                          members: {
                            Value: {
                              locationName: "value"
                            }
                          }
                        }
                      },
                      StartupAction: {
                        locationName: "startupAction"
                      }
                    }
                  }
                }
              }
            },
            Routes: {
              locationName: "routes",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  DestinationCidrBlock: {
                    locationName: "destinationCidrBlock"
                  },
                  Source: {
                    locationName: "source"
                  },
                  State: {
                    locationName: "state"
                  }
                }
              }
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            },
            VgwTelemetry: {
              locationName: "vgwTelemetry",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  AcceptedRouteCount: {
                    locationName: "acceptedRouteCount",
                    type: "integer"
                  },
                  LastStatusChange: {
                    locationName: "lastStatusChange",
                    type: "timestamp"
                  },
                  OutsideIpAddress: {
                    locationName: "outsideIpAddress"
                  },
                  Status: {
                    locationName: "status"
                  },
                  StatusMessage: {
                    locationName: "statusMessage"
                  },
                  CertificateArn: {
                    locationName: "certificateArn"
                  }
                }
              }
            }
          }
        },
        Sml: {
          type: "structure",
          members: {
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            State: {
              locationName: "state"
            },
            Type: {
              locationName: "type"
            },
            VpcAttachments: {
              locationName: "attachments",
              type: "list",
              member: {
                shape: "S4t",
                locationName: "item"
              }
            },
            VpnGatewayId: {
              locationName: "vpnGatewayId"
            },
            AmazonSideAsn: {
              locationName: "amazonSideAsn",
              type: "long"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        Smz: {
          type: "list",
          member: {}
        },
        Sn9: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sno: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Spx: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sqb: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sqd: {
          type: "structure",
          members: {
            InstanceTagKeys: {
              shape: "Sqb",
              locationName: "instanceTagKeySet"
            },
            IncludeAllTagsOfInstance: {
              locationName: "includeAllTagsOfInstance",
              type: "boolean"
            }
          }
        },
        Sqf: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Squ: {
          type: "list",
          member: {
            locationName: "Filter",
            type: "structure",
            members: {
              Name: {},
              Values: {
                shape: "Se",
                locationName: "Value"
              }
            }
          }
        },
        Sr8: {
          type: "structure",
          members: {
            PublicIp: {
              locationName: "publicIp"
            },
            AllocationId: {
              locationName: "allocationId"
            },
            PtrRecord: {
              locationName: "ptrRecord"
            },
            PtrRecordUpdate: {
              locationName: "ptrRecordUpdate",
              type: "structure",
              members: {
                Value: {
                  locationName: "value"
                },
                Status: {
                  locationName: "status"
                },
                Reason: {
                  locationName: "reason"
                }
              }
            }
          }
        },
        Src: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Deadline: {
                locationName: "deadline",
                type: "timestamp"
              },
              Resource: {
                locationName: "resource"
              },
              UseLongIds: {
                locationName: "useLongIds",
                type: "boolean"
              }
            }
          }
        },
        Ssc: {
          type: "list",
          member: {
            locationName: "InstanceId"
          }
        },
        Ssr: {
          type: "structure",
          members: {
            Code: {
              locationName: "code"
            },
            Message: {
              locationName: "message"
            }
          }
        },
        Stw: {
          type: "structure",
          members: {
            ConversionTaskId: {
              locationName: "conversionTaskId"
            },
            ExpirationTime: {
              locationName: "expirationTime"
            },
            ImportInstance: {
              locationName: "importInstance",
              type: "structure",
              members: {
                Description: {
                  locationName: "description"
                },
                InstanceId: {
                  locationName: "instanceId"
                },
                Platform: {
                  locationName: "platform"
                },
                Volumes: {
                  locationName: "volumes",
                  type: "list",
                  member: {
                    locationName: "item",
                    type: "structure",
                    members: {
                      AvailabilityZone: {
                        locationName: "availabilityZone"
                      },
                      BytesConverted: {
                        locationName: "bytesConverted",
                        type: "long"
                      },
                      Description: {
                        locationName: "description"
                      },
                      Image: {
                        shape: "Su0",
                        locationName: "image"
                      },
                      Status: {
                        locationName: "status"
                      },
                      StatusMessage: {
                        locationName: "statusMessage"
                      },
                      Volume: {
                        shape: "Su1",
                        locationName: "volume"
                      }
                    }
                  }
                }
              }
            },
            ImportVolume: {
              locationName: "importVolume",
              type: "structure",
              members: {
                AvailabilityZone: {
                  locationName: "availabilityZone"
                },
                BytesConverted: {
                  locationName: "bytesConverted",
                  type: "long"
                },
                Description: {
                  locationName: "description"
                },
                Image: {
                  shape: "Su0",
                  locationName: "image"
                },
                Volume: {
                  shape: "Su1",
                  locationName: "volume"
                }
              }
            },
            State: {
              locationName: "state"
            },
            StatusMessage: {
              locationName: "statusMessage"
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        Su0: {
          type: "structure",
          members: {
            Checksum: {
              locationName: "checksum"
            },
            Format: {
              locationName: "format"
            },
            ImportManifestUrl: {
              locationName: "importManifestUrl"
            },
            Size: {
              locationName: "size",
              type: "long"
            }
          }
        },
        Su1: {
          type: "structure",
          members: {
            Id: {
              locationName: "id"
            },
            Size: {
              locationName: "size",
              type: "long"
            }
          }
        },
        Suz: {
          type: "structure",
          members: {
            S3Bucket: {
              locationName: "s3Bucket"
            },
            S3Prefix: {
              locationName: "s3Prefix"
            }
          }
        },
        Svg: {
          type: "structure",
          members: {
            EventDescription: {
              locationName: "eventDescription"
            },
            EventSubType: {
              locationName: "eventSubType"
            },
            InstanceId: {
              locationName: "instanceId"
            }
          }
        },
        Svj: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              InstanceId: {
                locationName: "instanceId"
              },
              InstanceType: {
                locationName: "instanceType"
              },
              SpotInstanceRequestId: {
                locationName: "spotInstanceRequestId"
              },
              InstanceHealth: {
                locationName: "instanceHealth"
              }
            }
          }
        },
        Swc: {
          type: "structure",
          members: {
            FpgaImageId: {
              locationName: "fpgaImageId"
            },
            Name: {
              locationName: "name"
            },
            Description: {
              locationName: "description"
            },
            LoadPermissions: {
              locationName: "loadPermissions",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  UserId: {
                    locationName: "userId"
                  },
                  Group: {
                    locationName: "group"
                  }
                }
              }
            },
            ProductCodes: {
              shape: "Swg",
              locationName: "productCodes"
            }
          }
        },
        Swg: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              ProductCodeId: {
                locationName: "productCode"
              },
              ProductCodeType: {
                locationName: "type"
              }
            }
          }
        },
        Swl: {
          type: "list",
          member: {
            locationName: "Owner"
          }
        },
        Sx6: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sx9: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        Sxy: {
          type: "list",
          member: {
            shape: "Sb4",
            locationName: "item"
          }
        },
        Sxz: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Group: {
                locationName: "group"
              },
              UserId: {
                locationName: "userId"
              }
            }
          }
        },
        Syc: {
          type: "structure",
          members: {
            Code: {
              locationName: "code"
            },
            Message: {
              locationName: "message"
            }
          }
        },
        Syl: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Description: {
                locationName: "description"
              },
              DeviceName: {
                locationName: "deviceName"
              },
              DiskImageSize: {
                locationName: "diskImageSize",
                type: "double"
              },
              Format: {
                locationName: "format"
              },
              Progress: {
                locationName: "progress"
              },
              SnapshotId: {
                locationName: "snapshotId"
              },
              Status: {
                locationName: "status"
              },
              StatusMessage: {
                locationName: "statusMessage"
              },
              Url: {
                locationName: "url"
              },
              UserBucket: {
                shape: "Syn",
                locationName: "userBucket"
              }
            }
          }
        },
        Syn: {
          type: "structure",
          members: {
            S3Bucket: {
              locationName: "s3Bucket"
            },
            S3Key: {
              locationName: "s3Key"
            }
          }
        },
        Syo: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              LicenseConfigurationArn: {
                locationName: "licenseConfigurationArn"
              }
            }
          }
        },
        Syw: {
          type: "structure",
          members: {
            Description: {
              locationName: "description"
            },
            DiskImageSize: {
              locationName: "diskImageSize",
              type: "double"
            },
            Encrypted: {
              locationName: "encrypted",
              type: "boolean"
            },
            Format: {
              locationName: "format"
            },
            KmsKeyId: {
              locationName: "kmsKeyId"
            },
            Progress: {
              locationName: "progress"
            },
            SnapshotId: {
              locationName: "snapshotId"
            },
            Status: {
              locationName: "status"
            },
            StatusMessage: {
              locationName: "statusMessage"
            },
            Url: {
              locationName: "url"
            },
            UserBucket: {
              shape: "Syn",
              locationName: "userBucket"
            }
          }
        },
        Sz0: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              DeviceName: {
                locationName: "deviceName"
              },
              Ebs: {
                locationName: "ebs",
                type: "structure",
                members: {
                  AttachTime: {
                    locationName: "attachTime",
                    type: "timestamp"
                  },
                  DeleteOnTermination: {
                    locationName: "deleteOnTermination",
                    type: "boolean"
                  },
                  Status: {
                    locationName: "status"
                  },
                  VolumeId: {
                    locationName: "volumeId"
                  }
                }
              }
            }
          }
        },
        Sz3: {
          type: "structure",
          members: {
            Value: {
              locationName: "value",
              type: "boolean"
            }
          }
        },
        Sz4: {
          type: "structure",
          members: {
            Enabled: {
              locationName: "enabled",
              type: "boolean"
            }
          }
        },
        Szm: {
          type: "structure",
          members: {
            InstanceEventId: {
              locationName: "instanceEventId"
            },
            Code: {
              locationName: "code"
            },
            Description: {
              locationName: "description"
            },
            NotAfter: {
              locationName: "notAfter",
              type: "timestamp"
            },
            NotBefore: {
              locationName: "notBefore",
              type: "timestamp"
            },
            NotBeforeDeadline: {
              locationName: "notBeforeDeadline",
              type: "timestamp"
            }
          }
        },
        Szp: {
          type: "structure",
          members: {
            Code: {
              locationName: "code",
              type: "integer"
            },
            Name: {
              locationName: "name"
            }
          }
        },
        Szr: {
          type: "structure",
          members: {
            Details: {
              locationName: "details",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  ImpairedSince: {
                    locationName: "impairedSince",
                    type: "timestamp"
                  },
                  Name: {
                    locationName: "name"
                  },
                  Status: {
                    locationName: "status"
                  }
                }
              }
            },
            Status: {
              locationName: "status"
            }
          }
        },
        S12v: {
          type: "structure",
          members: {
            Groups: {
              shape: "Sfs",
              locationName: "groupSet"
            },
            Instances: {
              locationName: "instancesSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  AmiLaunchIndex: {
                    locationName: "amiLaunchIndex",
                    type: "integer"
                  },
                  ImageId: {
                    locationName: "imageId"
                  },
                  InstanceId: {
                    locationName: "instanceId"
                  },
                  InstanceType: {
                    locationName: "instanceType"
                  },
                  KernelId: {
                    locationName: "kernelId"
                  },
                  KeyName: {
                    locationName: "keyName"
                  },
                  LaunchTime: {
                    locationName: "launchTime",
                    type: "timestamp"
                  },
                  Monitoring: {
                    shape: "S12y",
                    locationName: "monitoring"
                  },
                  Placement: {
                    shape: "Sa8",
                    locationName: "placement"
                  },
                  Platform: {
                    locationName: "platform"
                  },
                  PrivateDnsName: {
                    locationName: "privateDnsName"
                  },
                  PrivateIpAddress: {
                    locationName: "privateIpAddress"
                  },
                  ProductCodes: {
                    shape: "Swg",
                    locationName: "productCodes"
                  },
                  PublicDnsName: {
                    locationName: "dnsName"
                  },
                  PublicIpAddress: {
                    locationName: "ipAddress"
                  },
                  RamdiskId: {
                    locationName: "ramdiskId"
                  },
                  State: {
                    shape: "Szp",
                    locationName: "instanceState"
                  },
                  StateTransitionReason: {
                    locationName: "reason"
                  },
                  SubnetId: {
                    locationName: "subnetId"
                  },
                  VpcId: {
                    locationName: "vpcId"
                  },
                  Architecture: {
                    locationName: "architecture"
                  },
                  BlockDeviceMappings: {
                    shape: "Sz0",
                    locationName: "blockDeviceMapping"
                  },
                  ClientToken: {
                    locationName: "clientToken"
                  },
                  EbsOptimized: {
                    locationName: "ebsOptimized",
                    type: "boolean"
                  },
                  EnaSupport: {
                    locationName: "enaSupport",
                    type: "boolean"
                  },
                  Hypervisor: {
                    locationName: "hypervisor"
                  },
                  IamInstanceProfile: {
                    shape: "S32",
                    locationName: "iamInstanceProfile"
                  },
                  InstanceLifecycle: {
                    locationName: "instanceLifecycle"
                  },
                  ElasticGpuAssociations: {
                    locationName: "elasticGpuAssociationSet",
                    type: "list",
                    member: {
                      locationName: "item",
                      type: "structure",
                      members: {
                        ElasticGpuId: {
                          locationName: "elasticGpuId"
                        },
                        ElasticGpuAssociationId: {
                          locationName: "elasticGpuAssociationId"
                        },
                        ElasticGpuAssociationState: {
                          locationName: "elasticGpuAssociationState"
                        },
                        ElasticGpuAssociationTime: {
                          locationName: "elasticGpuAssociationTime"
                        }
                      }
                    }
                  },
                  ElasticInferenceAcceleratorAssociations: {
                    locationName: "elasticInferenceAcceleratorAssociationSet",
                    type: "list",
                    member: {
                      locationName: "item",
                      type: "structure",
                      members: {
                        ElasticInferenceAcceleratorArn: {
                          locationName: "elasticInferenceAcceleratorArn"
                        },
                        ElasticInferenceAcceleratorAssociationId: {
                          locationName: "elasticInferenceAcceleratorAssociationId"
                        },
                        ElasticInferenceAcceleratorAssociationState: {
                          locationName: "elasticInferenceAcceleratorAssociationState"
                        },
                        ElasticInferenceAcceleratorAssociationTime: {
                          locationName: "elasticInferenceAcceleratorAssociationTime",
                          type: "timestamp"
                        }
                      }
                    }
                  },
                  NetworkInterfaces: {
                    locationName: "networkInterfaceSet",
                    type: "list",
                    member: {
                      locationName: "item",
                      type: "structure",
                      members: {
                        Association: {
                          shape: "S137",
                          locationName: "association"
                        },
                        Attachment: {
                          locationName: "attachment",
                          type: "structure",
                          members: {
                            AttachTime: {
                              locationName: "attachTime",
                              type: "timestamp"
                            },
                            AttachmentId: {
                              locationName: "attachmentId"
                            },
                            DeleteOnTermination: {
                              locationName: "deleteOnTermination",
                              type: "boolean"
                            },
                            DeviceIndex: {
                              locationName: "deviceIndex",
                              type: "integer"
                            },
                            Status: {
                              locationName: "status"
                            },
                            NetworkCardIndex: {
                              locationName: "networkCardIndex",
                              type: "integer"
                            }
                          }
                        },
                        Description: {
                          locationName: "description"
                        },
                        Groups: {
                          shape: "Sfs",
                          locationName: "groupSet"
                        },
                        Ipv6Addresses: {
                          shape: "Sdo",
                          locationName: "ipv6AddressesSet"
                        },
                        MacAddress: {
                          locationName: "macAddress"
                        },
                        NetworkInterfaceId: {
                          locationName: "networkInterfaceId"
                        },
                        OwnerId: {
                          locationName: "ownerId"
                        },
                        PrivateDnsName: {
                          locationName: "privateDnsName"
                        },
                        PrivateIpAddress: {
                          locationName: "privateIpAddress"
                        },
                        PrivateIpAddresses: {
                          locationName: "privateIpAddressesSet",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "structure",
                            members: {
                              Association: {
                                shape: "S137",
                                locationName: "association"
                              },
                              Primary: {
                                locationName: "primary",
                                type: "boolean"
                              },
                              PrivateDnsName: {
                                locationName: "privateDnsName"
                              },
                              PrivateIpAddress: {
                                locationName: "privateIpAddress"
                              }
                            }
                          }
                        },
                        SourceDestCheck: {
                          locationName: "sourceDestCheck",
                          type: "boolean"
                        },
                        Status: {
                          locationName: "status"
                        },
                        SubnetId: {
                          locationName: "subnetId"
                        },
                        VpcId: {
                          locationName: "vpcId"
                        },
                        InterfaceType: {
                          locationName: "interfaceType"
                        },
                        Ipv4Prefixes: {
                          locationName: "ipv4PrefixSet",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "structure",
                            members: {
                              Ipv4Prefix: {
                                locationName: "ipv4Prefix"
                              }
                            }
                          }
                        },
                        Ipv6Prefixes: {
                          locationName: "ipv6PrefixSet",
                          type: "list",
                          member: {
                            locationName: "item",
                            type: "structure",
                            members: {
                              Ipv6Prefix: {
                                locationName: "ipv6Prefix"
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  OutpostArn: {
                    locationName: "outpostArn"
                  },
                  RootDeviceName: {
                    locationName: "rootDeviceName"
                  },
                  RootDeviceType: {
                    locationName: "rootDeviceType"
                  },
                  SecurityGroups: {
                    shape: "Sfs",
                    locationName: "groupSet"
                  },
                  SourceDestCheck: {
                    locationName: "sourceDestCheck",
                    type: "boolean"
                  },
                  SpotInstanceRequestId: {
                    locationName: "spotInstanceRequestId"
                  },
                  SriovNetSupport: {
                    locationName: "sriovNetSupport"
                  },
                  StateReason: {
                    shape: "Syc",
                    locationName: "stateReason"
                  },
                  Tags: {
                    shape: "Ss",
                    locationName: "tagSet"
                  },
                  VirtualizationType: {
                    locationName: "virtualizationType"
                  },
                  CpuOptions: {
                    locationName: "cpuOptions",
                    type: "structure",
                    members: {
                      CoreCount: {
                        locationName: "coreCount",
                        type: "integer"
                      },
                      ThreadsPerCore: {
                        locationName: "threadsPerCore",
                        type: "integer"
                      }
                    }
                  },
                  CapacityReservationId: {
                    locationName: "capacityReservationId"
                  },
                  CapacityReservationSpecification: {
                    locationName: "capacityReservationSpecification",
                    type: "structure",
                    members: {
                      CapacityReservationPreference: {
                        locationName: "capacityReservationPreference"
                      },
                      CapacityReservationTarget: {
                        shape: "Se7",
                        locationName: "capacityReservationTarget"
                      }
                    }
                  },
                  HibernationOptions: {
                    locationName: "hibernationOptions",
                    type: "structure",
                    members: {
                      Configured: {
                        locationName: "configured",
                        type: "boolean"
                      }
                    }
                  },
                  Licenses: {
                    locationName: "licenseSet",
                    type: "list",
                    member: {
                      locationName: "item",
                      type: "structure",
                      members: {
                        LicenseConfigurationArn: {
                          locationName: "licenseConfigurationArn"
                        }
                      }
                    }
                  },
                  MetadataOptions: {
                    shape: "S13k",
                    locationName: "metadataOptions"
                  },
                  EnclaveOptions: {
                    shape: "Sz4",
                    locationName: "enclaveOptions"
                  },
                  BootMode: {
                    locationName: "bootMode"
                  },
                  PlatformDetails: {
                    locationName: "platformDetails"
                  },
                  UsageOperation: {
                    locationName: "usageOperation"
                  },
                  UsageOperationUpdateTime: {
                    locationName: "usageOperationUpdateTime",
                    type: "timestamp"
                  }
                }
              }
            },
            OwnerId: {
              locationName: "ownerId"
            },
            RequesterId: {
              locationName: "requesterId"
            },
            ReservationId: {
              locationName: "reservationId"
            }
          }
        },
        S12y: {
          type: "structure",
          members: {
            State: {
              locationName: "state"
            }
          }
        },
        S137: {
          type: "structure",
          members: {
            CarrierIp: {
              locationName: "carrierIp"
            },
            IpOwnerId: {
              locationName: "ipOwnerId"
            },
            PublicDnsName: {
              locationName: "publicDnsName"
            },
            PublicIp: {
              locationName: "publicIp"
            }
          }
        },
        S13k: {
          type: "structure",
          members: {
            State: {
              locationName: "state"
            },
            HttpTokens: {
              locationName: "httpTokens"
            },
            HttpPutResponseHopLimit: {
              locationName: "httpPutResponseHopLimit",
              type: "integer"
            },
            HttpEndpoint: {
              locationName: "httpEndpoint"
            },
            HttpProtocolIpv6: {
              locationName: "httpProtocolIpv6"
            }
          }
        },
        S152: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S162: {
          type: "structure",
          members: {
            NetworkInsightsAnalysisId: {
              locationName: "networkInsightsAnalysisId"
            },
            NetworkInsightsAnalysisArn: {
              locationName: "networkInsightsAnalysisArn"
            },
            NetworkInsightsPathId: {
              locationName: "networkInsightsPathId"
            },
            FilterInArns: {
              shape: "S163",
              locationName: "filterInArnSet"
            },
            StartDate: {
              locationName: "startDate",
              type: "timestamp"
            },
            Status: {
              locationName: "status"
            },
            StatusMessage: {
              locationName: "statusMessage"
            },
            NetworkPathFound: {
              locationName: "networkPathFound",
              type: "boolean"
            },
            ForwardPathComponents: {
              shape: "S165",
              locationName: "forwardPathComponentSet"
            },
            ReturnPathComponents: {
              shape: "S165",
              locationName: "returnPathComponentSet"
            },
            Explanations: {
              locationName: "explanationSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  Acl: {
                    shape: "S168",
                    locationName: "acl"
                  },
                  AclRule: {
                    shape: "S167",
                    locationName: "aclRule"
                  },
                  Address: {
                    locationName: "address"
                  },
                  Addresses: {
                    shape: "S16a",
                    locationName: "addressSet"
                  },
                  AttachedTo: {
                    shape: "S168",
                    locationName: "attachedTo"
                  },
                  AvailabilityZones: {
                    shape: "Se",
                    locationName: "availabilityZoneSet"
                  },
                  Cidrs: {
                    shape: "Se",
                    locationName: "cidrSet"
                  },
                  Component: {
                    shape: "S168",
                    locationName: "component"
                  },
                  CustomerGateway: {
                    shape: "S168",
                    locationName: "customerGateway"
                  },
                  Destination: {
                    shape: "S168",
                    locationName: "destination"
                  },
                  DestinationVpc: {
                    shape: "S168",
                    locationName: "destinationVpc"
                  },
                  Direction: {
                    locationName: "direction"
                  },
                  ExplanationCode: {
                    locationName: "explanationCode"
                  },
                  IngressRouteTable: {
                    shape: "S168",
                    locationName: "ingressRouteTable"
                  },
                  InternetGateway: {
                    shape: "S168",
                    locationName: "internetGateway"
                  },
                  LoadBalancerArn: {
                    locationName: "loadBalancerArn"
                  },
                  ClassicLoadBalancerListener: {
                    locationName: "classicLoadBalancerListener",
                    type: "structure",
                    members: {
                      LoadBalancerPort: {
                        locationName: "loadBalancerPort",
                        type: "integer"
                      },
                      InstancePort: {
                        locationName: "instancePort",
                        type: "integer"
                      }
                    }
                  },
                  LoadBalancerListenerPort: {
                    locationName: "loadBalancerListenerPort",
                    type: "integer"
                  },
                  LoadBalancerTarget: {
                    locationName: "loadBalancerTarget",
                    type: "structure",
                    members: {
                      Address: {
                        locationName: "address"
                      },
                      AvailabilityZone: {
                        locationName: "availabilityZone"
                      },
                      Instance: {
                        shape: "S168",
                        locationName: "instance"
                      },
                      Port: {
                        locationName: "port",
                        type: "integer"
                      }
                    }
                  },
                  LoadBalancerTargetGroup: {
                    shape: "S168",
                    locationName: "loadBalancerTargetGroup"
                  },
                  LoadBalancerTargetGroups: {
                    shape: "S16i",
                    locationName: "loadBalancerTargetGroupSet"
                  },
                  LoadBalancerTargetPort: {
                    locationName: "loadBalancerTargetPort",
                    type: "integer"
                  },
                  ElasticLoadBalancerListener: {
                    shape: "S168",
                    locationName: "elasticLoadBalancerListener"
                  },
                  MissingComponent: {
                    locationName: "missingComponent"
                  },
                  NatGateway: {
                    shape: "S168",
                    locationName: "natGateway"
                  },
                  NetworkInterface: {
                    shape: "S168",
                    locationName: "networkInterface"
                  },
                  PacketField: {
                    locationName: "packetField"
                  },
                  VpcPeeringConnection: {
                    shape: "S168",
                    locationName: "vpcPeeringConnection"
                  },
                  Port: {
                    locationName: "port",
                    type: "integer"
                  },
                  PortRanges: {
                    shape: "S16b",
                    locationName: "portRangeSet"
                  },
                  PrefixList: {
                    shape: "S168",
                    locationName: "prefixList"
                  },
                  Protocols: {
                    locationName: "protocolSet",
                    type: "list",
                    member: {
                      locationName: "item"
                    }
                  },
                  RouteTableRoute: {
                    shape: "S16c",
                    locationName: "routeTableRoute"
                  },
                  RouteTable: {
                    shape: "S168",
                    locationName: "routeTable"
                  },
                  SecurityGroup: {
                    shape: "S168",
                    locationName: "securityGroup"
                  },
                  SecurityGroupRule: {
                    shape: "S16d",
                    locationName: "securityGroupRule"
                  },
                  SecurityGroups: {
                    shape: "S16i",
                    locationName: "securityGroupSet"
                  },
                  SourceVpc: {
                    shape: "S168",
                    locationName: "sourceVpc"
                  },
                  State: {
                    locationName: "state"
                  },
                  Subnet: {
                    shape: "S168",
                    locationName: "subnet"
                  },
                  SubnetRouteTable: {
                    shape: "S168",
                    locationName: "subnetRouteTable"
                  },
                  Vpc: {
                    shape: "S168",
                    locationName: "vpc"
                  },
                  VpcEndpoint: {
                    shape: "S168",
                    locationName: "vpcEndpoint"
                  },
                  VpnConnection: {
                    shape: "S168",
                    locationName: "vpnConnection"
                  },
                  VpnGateway: {
                    shape: "S168",
                    locationName: "vpnGateway"
                  }
                }
              }
            },
            AlternatePathHints: {
              locationName: "alternatePathHintSet",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  ComponentId: {
                    locationName: "componentId"
                  },
                  ComponentArn: {
                    locationName: "componentArn"
                  }
                }
              }
            },
            Tags: {
              shape: "Ss",
              locationName: "tagSet"
            }
          }
        },
        S163: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S165: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              SequenceNumber: {
                locationName: "sequenceNumber",
                type: "integer"
              },
              AclRule: {
                shape: "S167",
                locationName: "aclRule"
              },
              Component: {
                shape: "S168",
                locationName: "component"
              },
              DestinationVpc: {
                shape: "S168",
                locationName: "destinationVpc"
              },
              OutboundHeader: {
                shape: "S169",
                locationName: "outboundHeader"
              },
              InboundHeader: {
                shape: "S169",
                locationName: "inboundHeader"
              },
              RouteTableRoute: {
                shape: "S16c",
                locationName: "routeTableRoute"
              },
              SecurityGroupRule: {
                shape: "S16d",
                locationName: "securityGroupRule"
              },
              SourceVpc: {
                shape: "S168",
                locationName: "sourceVpc"
              },
              Subnet: {
                shape: "S168",
                locationName: "subnet"
              },
              Vpc: {
                shape: "S168",
                locationName: "vpc"
              }
            }
          }
        },
        S167: {
          type: "structure",
          members: {
            Cidr: {
              locationName: "cidr"
            },
            Egress: {
              locationName: "egress",
              type: "boolean"
            },
            PortRange: {
              shape: "Sfb",
              locationName: "portRange"
            },
            Protocol: {
              locationName: "protocol"
            },
            RuleAction: {
              locationName: "ruleAction"
            },
            RuleNumber: {
              locationName: "ruleNumber",
              type: "integer"
            }
          }
        },
        S168: {
          type: "structure",
          members: {
            Id: {
              locationName: "id"
            },
            Arn: {
              locationName: "arn"
            }
          }
        },
        S169: {
          type: "structure",
          members: {
            DestinationAddresses: {
              shape: "S16a",
              locationName: "destinationAddressSet"
            },
            DestinationPortRanges: {
              shape: "S16b",
              locationName: "destinationPortRangeSet"
            },
            Protocol: {
              locationName: "protocol"
            },
            SourceAddresses: {
              shape: "S16a",
              locationName: "sourceAddressSet"
            },
            SourcePortRanges: {
              shape: "S16b",
              locationName: "sourcePortRangeSet"
            }
          }
        },
        S16a: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S16b: {
          type: "list",
          member: {
            shape: "Sfb",
            locationName: "item"
          }
        },
        S16c: {
          type: "structure",
          members: {
            DestinationCidr: {
              locationName: "destinationCidr"
            },
            DestinationPrefixListId: {
              locationName: "destinationPrefixListId"
            },
            EgressOnlyInternetGatewayId: {
              locationName: "egressOnlyInternetGatewayId"
            },
            GatewayId: {
              locationName: "gatewayId"
            },
            InstanceId: {
              locationName: "instanceId"
            },
            NatGatewayId: {
              locationName: "natGatewayId"
            },
            NetworkInterfaceId: {
              locationName: "networkInterfaceId"
            },
            Origin: {
              locationName: "origin"
            },
            TransitGatewayId: {
              locationName: "transitGatewayId"
            },
            VpcPeeringConnectionId: {
              locationName: "vpcPeeringConnectionId"
            }
          }
        },
        S16d: {
          type: "structure",
          members: {
            Cidr: {
              locationName: "cidr"
            },
            Direction: {
              locationName: "direction"
            },
            SecurityGroupId: {
              locationName: "securityGroupId"
            },
            PortRange: {
              shape: "Sfb",
              locationName: "portRange"
            },
            PrefixListId: {
              locationName: "prefixListId"
            },
            Protocol: {
              locationName: "protocol"
            }
          }
        },
        S16i: {
          type: "list",
          member: {
            shape: "S168",
            locationName: "item"
          }
        },
        S184: {
          type: "list",
          member: {
            locationName: "ReservedInstancesId"
          }
        },
        S18c: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Amount: {
                locationName: "amount",
                type: "double"
              },
              Frequency: {
                locationName: "frequency"
              }
            }
          }
        },
        S18q: {
          type: "structure",
          members: {
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            InstanceCount: {
              locationName: "instanceCount",
              type: "integer"
            },
            InstanceType: {
              locationName: "instanceType"
            },
            Platform: {
              locationName: "platform"
            },
            Scope: {
              locationName: "scope"
            }
          }
        },
        S19d: {
          type: "structure",
          members: {
            Frequency: {
              locationName: "frequency"
            },
            Interval: {
              locationName: "interval",
              type: "integer"
            },
            OccurrenceDaySet: {
              locationName: "occurrenceDaySet",
              type: "list",
              member: {
                locationName: "item",
                type: "integer"
              }
            },
            OccurrenceRelativeToEnd: {
              locationName: "occurrenceRelativeToEnd",
              type: "boolean"
            },
            OccurrenceUnit: {
              locationName: "occurrenceUnit"
            }
          }
        },
        S19l: {
          type: "structure",
          members: {
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            CreateDate: {
              locationName: "createDate",
              type: "timestamp"
            },
            HourlyPrice: {
              locationName: "hourlyPrice"
            },
            InstanceCount: {
              locationName: "instanceCount",
              type: "integer"
            },
            InstanceType: {
              locationName: "instanceType"
            },
            NetworkPlatform: {
              locationName: "networkPlatform"
            },
            NextSlotStartTime: {
              locationName: "nextSlotStartTime",
              type: "timestamp"
            },
            Platform: {
              locationName: "platform"
            },
            PreviousSlotEndTime: {
              locationName: "previousSlotEndTime",
              type: "timestamp"
            },
            Recurrence: {
              shape: "S19d",
              locationName: "recurrence"
            },
            ScheduledInstanceId: {
              locationName: "scheduledInstanceId"
            },
            SlotDurationInHours: {
              locationName: "slotDurationInHours",
              type: "integer"
            },
            TermEndDate: {
              locationName: "termEndDate",
              type: "timestamp"
            },
            TermStartDate: {
              locationName: "termStartDate",
              type: "timestamp"
            },
            TotalScheduledInstanceHours: {
              locationName: "totalScheduledInstanceHours",
              type: "integer"
            }
          }
        },
        S19s: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S19w: {
          type: "list",
          member: {
            locationName: "GroupName"
          }
        },
        S1a4: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Group: {
                locationName: "group"
              },
              UserId: {
                locationName: "userId"
              }
            }
          }
        },
        S1a8: {
          type: "list",
          member: {
            locationName: "SnapshotId"
          }
        },
        S1ar: {
          type: "structure",
          required: [
            "IamFleetRole",
            "TargetCapacity"
          ],
          members: {
            AllocationStrategy: {
              locationName: "allocationStrategy"
            },
            OnDemandAllocationStrategy: {
              locationName: "onDemandAllocationStrategy"
            },
            SpotMaintenanceStrategies: {
              locationName: "spotMaintenanceStrategies",
              type: "structure",
              members: {
                CapacityRebalance: {
                  locationName: "capacityRebalance",
                  type: "structure",
                  members: {
                    ReplacementStrategy: {
                      locationName: "replacementStrategy"
                    }
                  }
                }
              }
            },
            ClientToken: {
              locationName: "clientToken"
            },
            ExcessCapacityTerminationPolicy: {
              locationName: "excessCapacityTerminationPolicy"
            },
            FulfilledCapacity: {
              locationName: "fulfilledCapacity",
              type: "double"
            },
            OnDemandFulfilledCapacity: {
              locationName: "onDemandFulfilledCapacity",
              type: "double"
            },
            IamFleetRole: {
              locationName: "iamFleetRole"
            },
            LaunchSpecifications: {
              locationName: "launchSpecifications",
              type: "list",
              member: {
                locationName: "item",
                type: "structure",
                members: {
                  SecurityGroups: {
                    shape: "Sfs",
                    locationName: "groupSet"
                  },
                  AddressingType: {
                    locationName: "addressingType"
                  },
                  BlockDeviceMappings: {
                    shape: "Sxy",
                    locationName: "blockDeviceMapping"
                  },
                  EbsOptimized: {
                    locationName: "ebsOptimized",
                    type: "boolean"
                  },
                  IamInstanceProfile: {
                    shape: "S2z",
                    locationName: "iamInstanceProfile"
                  },
                  ImageId: {
                    locationName: "imageId"
                  },
                  InstanceType: {
                    locationName: "instanceType"
                  },
                  KernelId: {
                    locationName: "kernelId"
                  },
                  KeyName: {
                    locationName: "keyName"
                  },
                  Monitoring: {
                    locationName: "monitoring",
                    type: "structure",
                    members: {
                      Enabled: {
                        locationName: "enabled",
                        type: "boolean"
                      }
                    }
                  },
                  NetworkInterfaces: {
                    shape: "S1b1",
                    locationName: "networkInterfaceSet"
                  },
                  Placement: {
                    shape: "S1b3",
                    locationName: "placement"
                  },
                  RamdiskId: {
                    locationName: "ramdiskId"
                  },
                  SpotPrice: {
                    locationName: "spotPrice"
                  },
                  SubnetId: {
                    locationName: "subnetId"
                  },
                  UserData: {
                    locationName: "userData"
                  },
                  WeightedCapacity: {
                    locationName: "weightedCapacity",
                    type: "double"
                  },
                  TagSpecifications: {
                    locationName: "tagSpecificationSet",
                    type: "list",
                    member: {
                      locationName: "item",
                      type: "structure",
                      members: {
                        ResourceType: {
                          locationName: "resourceType"
                        },
                        Tags: {
                          shape: "Ss",
                          locationName: "tag"
                        }
                      }
                    }
                  }
                }
              }
            },
            LaunchTemplateConfigs: {
              shape: "S1b6",
              locationName: "launchTemplateConfigs"
            },
            SpotPrice: {
              locationName: "spotPrice"
            },
            TargetCapacity: {
              locationName: "targetCapacity",
              type: "integer"
            },
            OnDemandTargetCapacity: {
              locationName: "onDemandTargetCapacity",
              type: "integer"
            },
            OnDemandMaxTotalPrice: {
              locationName: "onDemandMaxTotalPrice"
            },
            SpotMaxTotalPrice: {
              locationName: "spotMaxTotalPrice"
            },
            TerminateInstancesWithExpiration: {
              locationName: "terminateInstancesWithExpiration",
              type: "boolean"
            },
            Type: {
              locationName: "type"
            },
            ValidFrom: {
              locationName: "validFrom",
              type: "timestamp"
            },
            ValidUntil: {
              locationName: "validUntil",
              type: "timestamp"
            },
            ReplaceUnhealthyInstances: {
              locationName: "replaceUnhealthyInstances",
              type: "boolean"
            },
            InstanceInterruptionBehavior: {
              locationName: "instanceInterruptionBehavior"
            },
            LoadBalancersConfig: {
              locationName: "loadBalancersConfig",
              type: "structure",
              members: {
                ClassicLoadBalancersConfig: {
                  locationName: "classicLoadBalancersConfig",
                  type: "structure",
                  members: {
                    ClassicLoadBalancers: {
                      locationName: "classicLoadBalancers",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          Name: {
                            locationName: "name"
                          }
                        }
                      }
                    }
                  }
                },
                TargetGroupsConfig: {
                  locationName: "targetGroupsConfig",
                  type: "structure",
                  members: {
                    TargetGroups: {
                      locationName: "targetGroups",
                      type: "list",
                      member: {
                        locationName: "item",
                        type: "structure",
                        members: {
                          Arn: {
                            locationName: "arn"
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            InstancePoolsToUseCount: {
              locationName: "instancePoolsToUseCount",
              type: "integer"
            },
            Context: {
              locationName: "context"
            },
            TagSpecifications: {
              shape: "S1t",
              locationName: "TagSpecification"
            }
          }
        },
        S1b1: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              AssociatePublicIpAddress: {
                locationName: "associatePublicIpAddress",
                type: "boolean"
              },
              DeleteOnTermination: {
                locationName: "deleteOnTermination",
                type: "boolean"
              },
              Description: {
                locationName: "description"
              },
              DeviceIndex: {
                locationName: "deviceIndex",
                type: "integer"
              },
              Groups: {
                shape: "Sc4",
                locationName: "SecurityGroupId"
              },
              Ipv6AddressCount: {
                locationName: "ipv6AddressCount",
                type: "integer"
              },
              Ipv6Addresses: {
                shape: "Sdo",
                locationName: "ipv6AddressesSet",
                queryName: "Ipv6Addresses"
              },
              NetworkInterfaceId: {
                locationName: "networkInterfaceId"
              },
              PrivateIpAddress: {
                locationName: "privateIpAddress"
              },
              PrivateIpAddresses: {
                shape: "Sc7",
                locationName: "privateIpAddressesSet",
                queryName: "PrivateIpAddresses"
              },
              SecondaryPrivateIpAddressCount: {
                locationName: "secondaryPrivateIpAddressCount",
                type: "integer"
              },
              SubnetId: {
                locationName: "subnetId"
              },
              AssociateCarrierIpAddress: {
                type: "boolean"
              },
              InterfaceType: {},
              NetworkCardIndex: {
                type: "integer"
              },
              Ipv4Prefixes: {
                shape: "Sc9",
                locationName: "Ipv4Prefix"
              },
              Ipv4PrefixCount: {
                type: "integer"
              },
              Ipv6Prefixes: {
                shape: "Scb",
                locationName: "Ipv6Prefix"
              },
              Ipv6PrefixCount: {
                type: "integer"
              }
            }
          }
        },
        S1b3: {
          type: "structure",
          members: {
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            GroupName: {
              locationName: "groupName"
            },
            Tenancy: {
              locationName: "tenancy"
            }
          }
        },
        S1b6: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              LaunchTemplateSpecification: {
                shape: "Sai",
                locationName: "launchTemplateSpecification"
              },
              Overrides: {
                locationName: "overrides",
                type: "list",
                member: {
                  locationName: "item",
                  type: "structure",
                  members: {
                    InstanceType: {
                      locationName: "instanceType"
                    },
                    SpotPrice: {
                      locationName: "spotPrice"
                    },
                    SubnetId: {
                      locationName: "subnetId"
                    },
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    WeightedCapacity: {
                      locationName: "weightedCapacity",
                      type: "double"
                    },
                    Priority: {
                      locationName: "priority",
                      type: "double"
                    }
                  }
                }
              }
            }
          }
        },
        S1bj: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              ActualBlockHourlyPrice: {
                locationName: "actualBlockHourlyPrice"
              },
              AvailabilityZoneGroup: {
                locationName: "availabilityZoneGroup"
              },
              BlockDurationMinutes: {
                locationName: "blockDurationMinutes",
                type: "integer"
              },
              CreateTime: {
                locationName: "createTime",
                type: "timestamp"
              },
              Fault: {
                shape: "Shi",
                locationName: "fault"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              LaunchGroup: {
                locationName: "launchGroup"
              },
              LaunchSpecification: {
                locationName: "launchSpecification",
                type: "structure",
                members: {
                  UserData: {
                    locationName: "userData"
                  },
                  SecurityGroups: {
                    shape: "Sfs",
                    locationName: "groupSet"
                  },
                  AddressingType: {
                    locationName: "addressingType"
                  },
                  BlockDeviceMappings: {
                    shape: "Sxy",
                    locationName: "blockDeviceMapping"
                  },
                  EbsOptimized: {
                    locationName: "ebsOptimized",
                    type: "boolean"
                  },
                  IamInstanceProfile: {
                    shape: "S2z",
                    locationName: "iamInstanceProfile"
                  },
                  ImageId: {
                    locationName: "imageId"
                  },
                  InstanceType: {
                    locationName: "instanceType"
                  },
                  KernelId: {
                    locationName: "kernelId"
                  },
                  KeyName: {
                    locationName: "keyName"
                  },
                  NetworkInterfaces: {
                    shape: "S1b1",
                    locationName: "networkInterfaceSet"
                  },
                  Placement: {
                    shape: "S1b3",
                    locationName: "placement"
                  },
                  RamdiskId: {
                    locationName: "ramdiskId"
                  },
                  SubnetId: {
                    locationName: "subnetId"
                  },
                  Monitoring: {
                    shape: "S1bm",
                    locationName: "monitoring"
                  }
                }
              },
              LaunchedAvailabilityZone: {
                locationName: "launchedAvailabilityZone"
              },
              ProductDescription: {
                locationName: "productDescription"
              },
              SpotInstanceRequestId: {
                locationName: "spotInstanceRequestId"
              },
              SpotPrice: {
                locationName: "spotPrice"
              },
              State: {
                locationName: "state"
              },
              Status: {
                locationName: "status",
                type: "structure",
                members: {
                  Code: {
                    locationName: "code"
                  },
                  Message: {
                    locationName: "message"
                  },
                  UpdateTime: {
                    locationName: "updateTime",
                    type: "timestamp"
                  }
                }
              },
              Tags: {
                shape: "Ss",
                locationName: "tagSet"
              },
              Type: {
                locationName: "type"
              },
              ValidFrom: {
                locationName: "validFrom",
                type: "timestamp"
              },
              ValidUntil: {
                locationName: "validUntil",
                type: "timestamp"
              },
              InstanceInterruptionBehavior: {
                locationName: "instanceInterruptionBehavior"
              }
            }
          }
        },
        S1bm: {
          type: "structure",
          required: [
            "Enabled"
          ],
          members: {
            Enabled: {
              locationName: "enabled",
              type: "boolean"
            }
          }
        },
        S1c1: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              FromPort: {
                locationName: "fromPort",
                type: "integer"
              },
              IpProtocol: {
                locationName: "ipProtocol"
              },
              IpRanges: {
                locationName: "ipRanges",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              PrefixListIds: {
                locationName: "prefixListIds",
                type: "list",
                member: {
                  locationName: "item"
                }
              },
              ToPort: {
                locationName: "toPort",
                type: "integer"
              },
              UserIdGroupPairs: {
                locationName: "groups",
                type: "list",
                member: {
                  shape: "S59",
                  locationName: "item"
                }
              }
            }
          }
        },
        S1cz: {
          type: "list",
          member: {}
        },
        S1e3: {
          type: "list",
          member: {
            locationName: "VolumeId"
          }
        },
        S1eo: {
          type: "structure",
          members: {
            VolumeId: {
              locationName: "volumeId"
            },
            ModificationState: {
              locationName: "modificationState"
            },
            StatusMessage: {
              locationName: "statusMessage"
            },
            TargetSize: {
              locationName: "targetSize",
              type: "integer"
            },
            TargetIops: {
              locationName: "targetIops",
              type: "integer"
            },
            TargetVolumeType: {
              locationName: "targetVolumeType"
            },
            TargetThroughput: {
              locationName: "targetThroughput",
              type: "integer"
            },
            TargetMultiAttachEnabled: {
              locationName: "targetMultiAttachEnabled",
              type: "boolean"
            },
            OriginalSize: {
              locationName: "originalSize",
              type: "integer"
            },
            OriginalIops: {
              locationName: "originalIops",
              type: "integer"
            },
            OriginalVolumeType: {
              locationName: "originalVolumeType"
            },
            OriginalThroughput: {
              locationName: "originalThroughput",
              type: "integer"
            },
            OriginalMultiAttachEnabled: {
              locationName: "originalMultiAttachEnabled",
              type: "boolean"
            },
            Progress: {
              locationName: "progress",
              type: "long"
            },
            StartTime: {
              locationName: "startTime",
              type: "timestamp"
            },
            EndTime: {
              locationName: "endTime",
              type: "timestamp"
            }
          }
        },
        S1eu: {
          type: "list",
          member: {
            locationName: "VpcId"
          }
        },
        S1gk: {
          type: "list",
          member: {
            locationName: "AvailabilityZone"
          }
        },
        S1gz: {
          type: "structure",
          members: {
            TransitGatewayAttachmentId: {
              locationName: "transitGatewayAttachmentId"
            },
            ResourceId: {
              locationName: "resourceId"
            },
            ResourceType: {
              locationName: "resourceType"
            },
            TransitGatewayRouteTableId: {
              locationName: "transitGatewayRouteTableId"
            },
            State: {
              locationName: "state"
            }
          }
        },
        S1jh: {
          type: "structure",
          members: {
            InstanceFamily: {
              locationName: "instanceFamily"
            },
            CpuCredits: {
              locationName: "cpuCredits"
            }
          }
        },
        S1jy: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S1k0: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              CurrencyCode: {
                locationName: "currencyCode"
              },
              Duration: {
                locationName: "duration",
                type: "integer"
              },
              HostIdSet: {
                shape: "Sx6",
                locationName: "hostIdSet"
              },
              HostReservationId: {
                locationName: "hostReservationId"
              },
              HourlyPrice: {
                locationName: "hourlyPrice"
              },
              InstanceFamily: {
                locationName: "instanceFamily"
              },
              PaymentOption: {
                locationName: "paymentOption"
              },
              UpfrontPrice: {
                locationName: "upfrontPrice"
              }
            }
          }
        },
        S1kh: {
          type: "structure",
          members: {
            HourlyPrice: {
              locationName: "hourlyPrice"
            },
            RemainingTotalValue: {
              locationName: "remainingTotalValue"
            },
            RemainingUpfrontValue: {
              locationName: "remainingUpfrontValue"
            }
          }
        },
        S1ks: {
          type: "list",
          member: {
            shape: "Sht",
            locationName: "item"
          }
        },
        S1lo: {
          type: "structure",
          members: {
            Comment: {},
            UploadEnd: {
              type: "timestamp"
            },
            UploadSize: {
              type: "double"
            },
            UploadStart: {
              type: "timestamp"
            }
          }
        },
        S1lr: {
          type: "structure",
          members: {
            S3Bucket: {},
            S3Key: {}
          }
        },
        S1ly: {
          type: "structure",
          required: [
            "Bytes",
            "Format",
            "ImportManifestUrl"
          ],
          members: {
            Bytes: {
              locationName: "bytes",
              type: "long"
            },
            Format: {
              locationName: "format"
            },
            ImportManifestUrl: {
              locationName: "importManifestUrl"
            }
          }
        },
        S1lz: {
          type: "structure",
          required: [
            "Size"
          ],
          members: {
            Size: {
              locationName: "size",
              type: "long"
            }
          }
        },
        S1mu: {
          type: "list",
          member: {
            locationName: "UserId"
          }
        },
        S1mv: {
          type: "list",
          member: {
            locationName: "UserGroup"
          }
        },
        S1mw: {
          type: "list",
          member: {
            locationName: "ProductCode"
          }
        },
        S1my: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              Group: {},
              UserId: {}
            }
          }
        },
        S1n3: {
          type: "list",
          member: {
            shape: "S17",
            locationName: "item"
          }
        },
        S1ne: {
          type: "structure",
          members: {
            CapacityReservationPreference: {},
            CapacityReservationTarget: {
              shape: "Sd0"
            }
          }
        },
        S1pg: {
          type: "structure",
          members: {
            AllowDnsResolutionFromRemoteVpc: {
              type: "boolean"
            },
            AllowEgressFromLocalClassicLinkToRemoteVpc: {
              type: "boolean"
            },
            AllowEgressFromLocalVpcToRemoteClassicLink: {
              type: "boolean"
            }
          }
        },
        S1pi: {
          type: "structure",
          members: {
            AllowDnsResolutionFromRemoteVpc: {
              locationName: "allowDnsResolutionFromRemoteVpc",
              type: "boolean"
            },
            AllowEgressFromLocalClassicLinkToRemoteVpc: {
              locationName: "allowEgressFromLocalClassicLinkToRemoteVpc",
              type: "boolean"
            },
            AllowEgressFromLocalVpcToRemoteClassicLink: {
              locationName: "allowEgressFromLocalVpcToRemoteClassicLink",
              type: "boolean"
            }
          }
        },
        S1px: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              InstanceId: {
                locationName: "instanceId"
              },
              Monitoring: {
                shape: "S12y",
                locationName: "monitoring"
              }
            }
          }
        },
        S1t0: {
          type: "list",
          member: {
            locationName: "SecurityGroupId"
          }
        },
        S1to: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              CurrentState: {
                shape: "Szp",
                locationName: "currentState"
              },
              InstanceId: {
                locationName: "instanceId"
              },
              PreviousState: {
                shape: "Szp",
                locationName: "previousState"
              }
            }
          }
        },
        S1u8: {
          type: "list",
          member: {
            locationName: "item",
            type: "structure",
            members: {
              SecurityGroupRuleId: {},
              Description: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ec2-2016-11-15.paginators.json
var require_ec2_2016_11_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ec2-2016-11-15.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeAccountAttributes: {
          result_key: "AccountAttributes"
        },
        DescribeAddresses: {
          result_key: "Addresses"
        },
        DescribeAddressesAttribute: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Addresses"
        },
        DescribeAvailabilityZones: {
          result_key: "AvailabilityZones"
        },
        DescribeBundleTasks: {
          result_key: "BundleTasks"
        },
        DescribeByoipCidrs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ByoipCidrs"
        },
        DescribeCapacityReservationFleets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CapacityReservationFleets"
        },
        DescribeCapacityReservations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CapacityReservations"
        },
        DescribeCarrierGateways: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CarrierGateways"
        },
        DescribeClassicLinkInstances: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Instances"
        },
        DescribeClientVpnAuthorizationRules: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AuthorizationRules"
        },
        DescribeClientVpnConnections: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Connections"
        },
        DescribeClientVpnEndpoints: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ClientVpnEndpoints"
        },
        DescribeClientVpnRoutes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Routes"
        },
        DescribeClientVpnTargetNetworks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ClientVpnTargetNetworks"
        },
        DescribeCoipPools: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CoipPools"
        },
        DescribeConversionTasks: {
          result_key: "ConversionTasks"
        },
        DescribeCustomerGateways: {
          result_key: "CustomerGateways"
        },
        DescribeDhcpOptions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DhcpOptions"
        },
        DescribeEgressOnlyInternetGateways: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "EgressOnlyInternetGateways"
        },
        DescribeExportImageTasks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ExportImageTasks"
        },
        DescribeExportTasks: {
          result_key: "ExportTasks"
        },
        DescribeFastSnapshotRestores: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "FastSnapshotRestores"
        },
        DescribeFleets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Fleets"
        },
        DescribeFlowLogs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "FlowLogs"
        },
        DescribeFpgaImages: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "FpgaImages"
        },
        DescribeHostReservationOfferings: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "OfferingSet"
        },
        DescribeHostReservations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "HostReservationSet"
        },
        DescribeHosts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Hosts"
        },
        DescribeIamInstanceProfileAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "IamInstanceProfileAssociations"
        },
        DescribeImages: {
          result_key: "Images"
        },
        DescribeImportImageTasks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ImportImageTasks"
        },
        DescribeImportSnapshotTasks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ImportSnapshotTasks"
        },
        DescribeInstanceCreditSpecifications: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstanceCreditSpecifications"
        },
        DescribeInstanceEventWindows: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstanceEventWindows"
        },
        DescribeInstanceStatus: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstanceStatuses"
        },
        DescribeInstanceTypeOfferings: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstanceTypeOfferings"
        },
        DescribeInstanceTypes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstanceTypes"
        },
        DescribeInstances: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Reservations"
        },
        DescribeInternetGateways: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InternetGateways"
        },
        DescribeIpv6Pools: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Ipv6Pools"
        },
        DescribeKeyPairs: {
          result_key: "KeyPairs"
        },
        DescribeLaunchTemplateVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LaunchTemplateVersions"
        },
        DescribeLaunchTemplates: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LaunchTemplates"
        },
        DescribeLocalGatewayRouteTableVirtualInterfaceGroupAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LocalGatewayRouteTableVirtualInterfaceGroupAssociations"
        },
        DescribeLocalGatewayRouteTableVpcAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LocalGatewayRouteTableVpcAssociations"
        },
        DescribeLocalGatewayRouteTables: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LocalGatewayRouteTables"
        },
        DescribeLocalGatewayVirtualInterfaceGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LocalGatewayVirtualInterfaceGroups"
        },
        DescribeLocalGatewayVirtualInterfaces: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LocalGatewayVirtualInterfaces"
        },
        DescribeLocalGateways: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LocalGateways"
        },
        DescribeManagedPrefixLists: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PrefixLists"
        },
        DescribeMovingAddresses: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "MovingAddressStatuses"
        },
        DescribeNatGateways: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "NatGateways"
        },
        DescribeNetworkAcls: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "NetworkAcls"
        },
        DescribeNetworkInsightsAnalyses: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "NetworkInsightsAnalyses"
        },
        DescribeNetworkInsightsPaths: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "NetworkInsightsPaths"
        },
        DescribeNetworkInterfacePermissions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "NetworkInterfacePermissions"
        },
        DescribeNetworkInterfaces: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "NetworkInterfaces"
        },
        DescribePlacementGroups: {
          result_key: "PlacementGroups"
        },
        DescribePrefixLists: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PrefixLists"
        },
        DescribePrincipalIdFormat: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Principals"
        },
        DescribePublicIpv4Pools: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PublicIpv4Pools"
        },
        DescribeRegions: {
          result_key: "Regions"
        },
        DescribeReplaceRootVolumeTasks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ReplaceRootVolumeTasks"
        },
        DescribeReservedInstances: {
          result_key: "ReservedInstances"
        },
        DescribeReservedInstancesListings: {
          result_key: "ReservedInstancesListings"
        },
        DescribeReservedInstancesModifications: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "ReservedInstancesModifications"
        },
        DescribeReservedInstancesOfferings: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ReservedInstancesOfferings"
        },
        DescribeRouteTables: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "RouteTables"
        },
        DescribeScheduledInstanceAvailability: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ScheduledInstanceAvailabilitySet"
        },
        DescribeScheduledInstances: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ScheduledInstanceSet"
        },
        DescribeSecurityGroupRules: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "SecurityGroupRules"
        },
        DescribeSecurityGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "SecurityGroups"
        },
        DescribeSnapshots: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Snapshots"
        },
        DescribeSpotFleetRequests: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "SpotFleetRequestConfigs"
        },
        DescribeSpotInstanceRequests: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "SpotInstanceRequests"
        },
        DescribeSpotPriceHistory: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "SpotPriceHistory"
        },
        DescribeStaleSecurityGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "StaleSecurityGroupSet"
        },
        DescribeStoreImageTasks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "StoreImageTaskResults"
        },
        DescribeSubnets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Subnets"
        },
        DescribeTags: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Tags"
        },
        DescribeTrafficMirrorFilters: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TrafficMirrorFilters"
        },
        DescribeTrafficMirrorSessions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TrafficMirrorSessions"
        },
        DescribeTrafficMirrorTargets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TrafficMirrorTargets"
        },
        DescribeTransitGatewayAttachments: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayAttachments"
        },
        DescribeTransitGatewayConnectPeers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayConnectPeers"
        },
        DescribeTransitGatewayConnects: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayConnects"
        },
        DescribeTransitGatewayMulticastDomains: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayMulticastDomains"
        },
        DescribeTransitGatewayPeeringAttachments: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayPeeringAttachments"
        },
        DescribeTransitGatewayRouteTables: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayRouteTables"
        },
        DescribeTransitGatewayVpcAttachments: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayVpcAttachments"
        },
        DescribeTransitGateways: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGateways"
        },
        DescribeTrunkInterfaceAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InterfaceAssociations"
        },
        DescribeVolumeStatus: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "VolumeStatuses"
        },
        DescribeVolumes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Volumes"
        },
        DescribeVolumesModifications: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "VolumesModifications"
        },
        DescribeVpcClassicLinkDnsSupport: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Vpcs"
        },
        DescribeVpcEndpointConnectionNotifications: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ConnectionNotificationSet"
        },
        DescribeVpcEndpointConnections: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "VpcEndpointConnections"
        },
        DescribeVpcEndpointServiceConfigurations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ServiceConfigurations"
        },
        DescribeVpcEndpointServicePermissions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AllowedPrincipals"
        },
        DescribeVpcEndpoints: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "VpcEndpoints"
        },
        DescribeVpcPeeringConnections: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "VpcPeeringConnections"
        },
        DescribeVpcs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Vpcs"
        },
        DescribeVpnConnections: {
          result_key: "VpnConnections"
        },
        DescribeVpnGateways: {
          result_key: "VpnGateways"
        },
        GetAssociatedIpv6PoolCidrs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Ipv6CidrAssociations"
        },
        GetGroupsForCapacityReservation: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CapacityReservationGroups"
        },
        GetManagedPrefixListAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PrefixListAssociations"
        },
        GetManagedPrefixListEntries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Entries"
        },
        GetTransitGatewayAttachmentPropagations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayAttachmentPropagations"
        },
        GetTransitGatewayMulticastDomainAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "MulticastDomainAssociations"
        },
        GetTransitGatewayPrefixListReferences: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayPrefixListReferences"
        },
        GetTransitGatewayRouteTableAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Associations"
        },
        GetTransitGatewayRouteTablePropagations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TransitGatewayRouteTablePropagations"
        },
        GetVpnConnectionDeviceTypes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "VpnConnectionDeviceTypes"
        },
        SearchLocalGatewayRoutes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Routes"
        },
        SearchTransitGatewayMulticastGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "MulticastGroups"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ec2-2016-11-15.waiters2.json
var require_ec2_2016_11_15_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/ec2-2016-11-15.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        InstanceExists: {
          delay: 5,
          maxAttempts: 40,
          operation: "DescribeInstances",
          acceptors: [
            {
              matcher: "path",
              expected: true,
              argument: "length(Reservations[]) > `0`",
              state: "success"
            },
            {
              matcher: "error",
              expected: "InvalidInstanceID.NotFound",
              state: "retry"
            }
          ]
        },
        BundleTaskComplete: {
          delay: 15,
          operation: "DescribeBundleTasks",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "complete",
              matcher: "pathAll",
              state: "success",
              argument: "BundleTasks[].State"
            },
            {
              expected: "failed",
              matcher: "pathAny",
              state: "failure",
              argument: "BundleTasks[].State"
            }
          ]
        },
        ConversionTaskCancelled: {
          delay: 15,
          operation: "DescribeConversionTasks",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "cancelled",
              matcher: "pathAll",
              state: "success",
              argument: "ConversionTasks[].State"
            }
          ]
        },
        ConversionTaskCompleted: {
          delay: 15,
          operation: "DescribeConversionTasks",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "completed",
              matcher: "pathAll",
              state: "success",
              argument: "ConversionTasks[].State"
            },
            {
              expected: "cancelled",
              matcher: "pathAny",
              state: "failure",
              argument: "ConversionTasks[].State"
            },
            {
              expected: "cancelling",
              matcher: "pathAny",
              state: "failure",
              argument: "ConversionTasks[].State"
            }
          ]
        },
        ConversionTaskDeleted: {
          delay: 15,
          operation: "DescribeConversionTasks",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "deleted",
              matcher: "pathAll",
              state: "success",
              argument: "ConversionTasks[].State"
            }
          ]
        },
        CustomerGatewayAvailable: {
          delay: 15,
          operation: "DescribeCustomerGateways",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "CustomerGateways[].State"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "CustomerGateways[].State"
            },
            {
              expected: "deleting",
              matcher: "pathAny",
              state: "failure",
              argument: "CustomerGateways[].State"
            }
          ]
        },
        ExportTaskCancelled: {
          delay: 15,
          operation: "DescribeExportTasks",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "cancelled",
              matcher: "pathAll",
              state: "success",
              argument: "ExportTasks[].State"
            }
          ]
        },
        ExportTaskCompleted: {
          delay: 15,
          operation: "DescribeExportTasks",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "completed",
              matcher: "pathAll",
              state: "success",
              argument: "ExportTasks[].State"
            }
          ]
        },
        ImageExists: {
          operation: "DescribeImages",
          maxAttempts: 40,
          delay: 15,
          acceptors: [
            {
              matcher: "path",
              expected: true,
              argument: "length(Images[]) > `0`",
              state: "success"
            },
            {
              matcher: "error",
              expected: "InvalidAMIID.NotFound",
              state: "retry"
            }
          ]
        },
        ImageAvailable: {
          operation: "DescribeImages",
          maxAttempts: 40,
          delay: 15,
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "Images[].State",
              expected: "available"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "Images[].State",
              expected: "failed"
            }
          ]
        },
        InstanceRunning: {
          delay: 15,
          operation: "DescribeInstances",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "running",
              matcher: "pathAll",
              state: "success",
              argument: "Reservations[].Instances[].State.Name"
            },
            {
              expected: "shutting-down",
              matcher: "pathAny",
              state: "failure",
              argument: "Reservations[].Instances[].State.Name"
            },
            {
              expected: "terminated",
              matcher: "pathAny",
              state: "failure",
              argument: "Reservations[].Instances[].State.Name"
            },
            {
              expected: "stopping",
              matcher: "pathAny",
              state: "failure",
              argument: "Reservations[].Instances[].State.Name"
            },
            {
              matcher: "error",
              expected: "InvalidInstanceID.NotFound",
              state: "retry"
            }
          ]
        },
        InstanceStatusOk: {
          operation: "DescribeInstanceStatus",
          maxAttempts: 40,
          delay: 15,
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "InstanceStatuses[].InstanceStatus.Status",
              expected: "ok"
            },
            {
              matcher: "error",
              expected: "InvalidInstanceID.NotFound",
              state: "retry"
            }
          ]
        },
        InstanceStopped: {
          delay: 15,
          operation: "DescribeInstances",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "stopped",
              matcher: "pathAll",
              state: "success",
              argument: "Reservations[].Instances[].State.Name"
            },
            {
              expected: "pending",
              matcher: "pathAny",
              state: "failure",
              argument: "Reservations[].Instances[].State.Name"
            },
            {
              expected: "terminated",
              matcher: "pathAny",
              state: "failure",
              argument: "Reservations[].Instances[].State.Name"
            }
          ]
        },
        InstanceTerminated: {
          delay: 15,
          operation: "DescribeInstances",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "terminated",
              matcher: "pathAll",
              state: "success",
              argument: "Reservations[].Instances[].State.Name"
            },
            {
              expected: "pending",
              matcher: "pathAny",
              state: "failure",
              argument: "Reservations[].Instances[].State.Name"
            },
            {
              expected: "stopping",
              matcher: "pathAny",
              state: "failure",
              argument: "Reservations[].Instances[].State.Name"
            }
          ]
        },
        KeyPairExists: {
          operation: "DescribeKeyPairs",
          delay: 5,
          maxAttempts: 6,
          acceptors: [
            {
              expected: true,
              matcher: "path",
              state: "success",
              argument: "length(KeyPairs[].KeyName) > `0`"
            },
            {
              expected: "InvalidKeyPair.NotFound",
              matcher: "error",
              state: "retry"
            }
          ]
        },
        NatGatewayAvailable: {
          operation: "DescribeNatGateways",
          delay: 15,
          maxAttempts: 40,
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "NatGateways[].State",
              expected: "available"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "NatGateways[].State",
              expected: "failed"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "NatGateways[].State",
              expected: "deleting"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "NatGateways[].State",
              expected: "deleted"
            },
            {
              state: "retry",
              matcher: "error",
              expected: "NatGatewayNotFound"
            }
          ]
        },
        NetworkInterfaceAvailable: {
          operation: "DescribeNetworkInterfaces",
          delay: 20,
          maxAttempts: 10,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "NetworkInterfaces[].Status"
            },
            {
              expected: "InvalidNetworkInterfaceID.NotFound",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        PasswordDataAvailable: {
          operation: "GetPasswordData",
          maxAttempts: 40,
          delay: 15,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "length(PasswordData) > `0`",
              expected: true
            }
          ]
        },
        SnapshotCompleted: {
          delay: 15,
          operation: "DescribeSnapshots",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "completed",
              matcher: "pathAll",
              state: "success",
              argument: "Snapshots[].State"
            },
            {
              expected: "error",
              matcher: "pathAny",
              state: "failure",
              argument: "Snapshots[].State"
            }
          ]
        },
        SecurityGroupExists: {
          operation: "DescribeSecurityGroups",
          delay: 5,
          maxAttempts: 6,
          acceptors: [
            {
              expected: true,
              matcher: "path",
              state: "success",
              argument: "length(SecurityGroups[].GroupId) > `0`"
            },
            {
              expected: "InvalidGroup.NotFound",
              matcher: "error",
              state: "retry"
            }
          ]
        },
        SpotInstanceRequestFulfilled: {
          operation: "DescribeSpotInstanceRequests",
          maxAttempts: 40,
          delay: 15,
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "SpotInstanceRequests[].Status.Code",
              expected: "fulfilled"
            },
            {
              state: "success",
              matcher: "pathAll",
              argument: "SpotInstanceRequests[].Status.Code",
              expected: "request-canceled-and-instance-running"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "SpotInstanceRequests[].Status.Code",
              expected: "schedule-expired"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "SpotInstanceRequests[].Status.Code",
              expected: "canceled-before-fulfillment"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "SpotInstanceRequests[].Status.Code",
              expected: "bad-parameters"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "SpotInstanceRequests[].Status.Code",
              expected: "system-error"
            },
            {
              state: "retry",
              matcher: "error",
              expected: "InvalidSpotInstanceRequestID.NotFound"
            }
          ]
        },
        SubnetAvailable: {
          delay: 15,
          operation: "DescribeSubnets",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "Subnets[].State"
            }
          ]
        },
        SystemStatusOk: {
          operation: "DescribeInstanceStatus",
          maxAttempts: 40,
          delay: 15,
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "InstanceStatuses[].SystemStatus.Status",
              expected: "ok"
            }
          ]
        },
        VolumeAvailable: {
          delay: 15,
          operation: "DescribeVolumes",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "Volumes[].State"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "Volumes[].State"
            }
          ]
        },
        VolumeDeleted: {
          delay: 15,
          operation: "DescribeVolumes",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "deleted",
              matcher: "pathAll",
              state: "success",
              argument: "Volumes[].State"
            },
            {
              matcher: "error",
              expected: "InvalidVolume.NotFound",
              state: "success"
            }
          ]
        },
        VolumeInUse: {
          delay: 15,
          operation: "DescribeVolumes",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "in-use",
              matcher: "pathAll",
              state: "success",
              argument: "Volumes[].State"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "Volumes[].State"
            }
          ]
        },
        VpcAvailable: {
          delay: 15,
          operation: "DescribeVpcs",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "Vpcs[].State"
            }
          ]
        },
        VpcExists: {
          operation: "DescribeVpcs",
          delay: 1,
          maxAttempts: 5,
          acceptors: [
            {
              matcher: "status",
              expected: 200,
              state: "success"
            },
            {
              matcher: "error",
              expected: "InvalidVpcID.NotFound",
              state: "retry"
            }
          ]
        },
        VpnConnectionAvailable: {
          delay: 15,
          operation: "DescribeVpnConnections",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "VpnConnections[].State"
            },
            {
              expected: "deleting",
              matcher: "pathAny",
              state: "failure",
              argument: "VpnConnections[].State"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "VpnConnections[].State"
            }
          ]
        },
        VpnConnectionDeleted: {
          delay: 15,
          operation: "DescribeVpnConnections",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "deleted",
              matcher: "pathAll",
              state: "success",
              argument: "VpnConnections[].State"
            },
            {
              expected: "pending",
              matcher: "pathAny",
              state: "failure",
              argument: "VpnConnections[].State"
            }
          ]
        },
        VpcPeeringConnectionExists: {
          delay: 15,
          operation: "DescribeVpcPeeringConnections",
          maxAttempts: 40,
          acceptors: [
            {
              matcher: "status",
              expected: 200,
              state: "success"
            },
            {
              matcher: "error",
              expected: "InvalidVpcPeeringConnectionID.NotFound",
              state: "retry"
            }
          ]
        },
        VpcPeeringConnectionDeleted: {
          delay: 15,
          operation: "DescribeVpcPeeringConnections",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "deleted",
              matcher: "pathAll",
              state: "success",
              argument: "VpcPeeringConnections[].Status.Code"
            },
            {
              matcher: "error",
              expected: "InvalidVpcPeeringConnectionID.NotFound",
              state: "success"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ec2.js
var require_ec22 = __commonJS({
  "node_modules/aws-sdk/clients/ec2.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["ec2"] = {};
    AWS3.EC2 = Service.defineService("ec2", ["2013-06-15*", "2013-10-15*", "2014-02-01*", "2014-05-01*", "2014-06-15*", "2014-09-01*", "2014-10-01*", "2015-03-01*", "2015-04-15*", "2015-10-01*", "2016-04-01*", "2016-09-15*", "2016-11-15"]);
    require_ec2();
    Object.defineProperty(apiLoader.services["ec2"], "2016-11-15", {
      get: function get() {
        var model = require_ec2_2016_11_15_min();
        model.paginators = require_ec2_2016_11_15_paginators().pagination;
        model.waiters = require_ec2_2016_11_15_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.EC2;
  }
});

// node_modules/aws-sdk/apis/ecr-2015-09-21.min.json
var require_ecr_2015_09_21_min = __commonJS({
  "node_modules/aws-sdk/apis/ecr-2015-09-21.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-09-21",
        endpointPrefix: "api.ecr",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Amazon ECR",
        serviceFullName: "Amazon EC2 Container Registry",
        serviceId: "ECR",
        signatureVersion: "v4",
        signingName: "ecr",
        targetPrefix: "AmazonEC2ContainerRegistry_V20150921",
        uid: "ecr-2015-09-21"
      },
      operations: {
        BatchCheckLayerAvailability: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "layerDigests"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              layerDigests: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              layers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    layerDigest: {},
                    layerAvailability: {},
                    layerSize: {
                      type: "long"
                    },
                    mediaType: {}
                  }
                }
              },
              failures: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    layerDigest: {},
                    failureCode: {},
                    failureReason: {}
                  }
                }
              }
            }
          }
        },
        BatchDeleteImage: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "imageIds"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageIds: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              imageIds: {
                shape: "Si"
              },
              failures: {
                shape: "Sn"
              }
            }
          }
        },
        BatchGetImage: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "imageIds"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageIds: {
                shape: "Si"
              },
              acceptedMediaTypes: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              images: {
                type: "list",
                member: {
                  shape: "Sv"
                }
              },
              failures: {
                shape: "Sn"
              }
            }
          }
        },
        CompleteLayerUpload: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "uploadId",
              "layerDigests"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              uploadId: {},
              layerDigests: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              uploadId: {},
              layerDigest: {}
            }
          }
        },
        CreateRepository: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              tags: {
                shape: "S12"
              },
              imageTagMutability: {},
              imageScanningConfiguration: {
                shape: "S17"
              },
              encryptionConfiguration: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S1d"
              }
            }
          }
        },
        DeleteLifecyclePolicy: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              lifecyclePolicyText: {},
              lastEvaluatedAt: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteRegistryPolicy: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              policyText: {}
            }
          }
        },
        DeleteRepository: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S1d"
              }
            }
          }
        },
        DeleteRepositoryPolicy: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              policyText: {}
            }
          }
        },
        DescribeImageReplicationStatus: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "imageId"
            ],
            members: {
              repositoryName: {},
              imageId: {
                shape: "Sj"
              },
              registryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              repositoryName: {},
              imageId: {
                shape: "Sj"
              },
              replicationStatuses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    region: {},
                    registryId: {},
                    status: {},
                    failureCode: {}
                  }
                }
              }
            }
          }
        },
        DescribeImageScanFindings: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "imageId"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageId: {
                shape: "Sj"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              imageId: {
                shape: "Sj"
              },
              imageScanStatus: {
                shape: "S25"
              },
              imageScanFindings: {
                type: "structure",
                members: {
                  imageScanCompletedAt: {
                    type: "timestamp"
                  },
                  vulnerabilitySourceUpdatedAt: {
                    type: "timestamp"
                  },
                  findings: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        name: {},
                        description: {},
                        uri: {},
                        severity: {},
                        attributes: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "key"
                            ],
                            members: {
                              key: {},
                              value: {}
                            }
                          }
                        }
                      }
                    }
                  },
                  findingSeverityCounts: {
                    shape: "S2k"
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeImages: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageIds: {
                shape: "Si"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filter: {
                type: "structure",
                members: {
                  tagStatus: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              imageDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    registryId: {},
                    repositoryName: {},
                    imageDigest: {},
                    imageTags: {
                      shape: "S2s"
                    },
                    imageSizeInBytes: {
                      type: "long"
                    },
                    imagePushedAt: {
                      type: "timestamp"
                    },
                    imageScanStatus: {
                      shape: "S25"
                    },
                    imageScanFindingsSummary: {
                      type: "structure",
                      members: {
                        imageScanCompletedAt: {
                          type: "timestamp"
                        },
                        vulnerabilitySourceUpdatedAt: {
                          type: "timestamp"
                        },
                        findingSeverityCounts: {
                          shape: "S2k"
                        }
                      }
                    },
                    imageManifestMediaType: {},
                    artifactMediaType: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeRegistry: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              replicationConfiguration: {
                shape: "S2y"
              }
            }
          }
        },
        DescribeRepositories: {
          input: {
            type: "structure",
            members: {
              registryId: {},
              repositoryNames: {
                type: "list",
                member: {}
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repositories: {
                type: "list",
                member: {
                  shape: "S1d"
                }
              },
              nextToken: {}
            }
          }
        },
        GetAuthorizationToken: {
          input: {
            type: "structure",
            members: {
              registryIds: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated. The returned authorization token can be used to access any Amazon ECR registry that the IAM principal has access to, specifying a registry ID doesn't change the permissions scope of the authorization token.",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              authorizationData: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    authorizationToken: {},
                    expiresAt: {
                      type: "timestamp"
                    },
                    proxyEndpoint: {}
                  }
                }
              }
            }
          }
        },
        GetDownloadUrlForLayer: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "layerDigest"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              layerDigest: {}
            }
          },
          output: {
            type: "structure",
            members: {
              downloadUrl: {},
              layerDigest: {}
            }
          }
        },
        GetLifecyclePolicy: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              lifecyclePolicyText: {},
              lastEvaluatedAt: {
                type: "timestamp"
              }
            }
          }
        },
        GetLifecyclePolicyPreview: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageIds: {
                shape: "Si"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filter: {
                type: "structure",
                members: {
                  tagStatus: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              lifecyclePolicyText: {},
              status: {},
              nextToken: {},
              previewResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    imageTags: {
                      shape: "S2s"
                    },
                    imageDigest: {},
                    imagePushedAt: {
                      type: "timestamp"
                    },
                    action: {
                      type: "structure",
                      members: {
                        type: {}
                      }
                    },
                    appliedRulePriority: {
                      type: "integer"
                    }
                  }
                }
              },
              summary: {
                type: "structure",
                members: {
                  expiringImageTotalCount: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        GetRegistryPolicy: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              policyText: {}
            }
          }
        },
        GetRepositoryPolicy: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              policyText: {}
            }
          }
        },
        InitiateLayerUpload: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              uploadId: {},
              partSize: {
                type: "long"
              }
            }
          }
        },
        ListImages: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filter: {
                type: "structure",
                members: {
                  tagStatus: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              imageIds: {
                shape: "Si"
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S12"
              }
            }
          }
        },
        PutImage: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "imageManifest"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageManifest: {},
              imageManifestMediaType: {},
              imageTag: {},
              imageDigest: {}
            }
          },
          output: {
            type: "structure",
            members: {
              image: {
                shape: "Sv"
              }
            }
          }
        },
        PutImageScanningConfiguration: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "imageScanningConfiguration"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageScanningConfiguration: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              imageScanningConfiguration: {
                shape: "S17"
              }
            }
          }
        },
        PutImageTagMutability: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "imageTagMutability"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageTagMutability: {}
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              imageTagMutability: {}
            }
          }
        },
        PutLifecyclePolicy: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "lifecyclePolicyText"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              lifecyclePolicyText: {}
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              lifecyclePolicyText: {}
            }
          }
        },
        PutRegistryPolicy: {
          input: {
            type: "structure",
            required: [
              "policyText"
            ],
            members: {
              policyText: {}
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              policyText: {}
            }
          }
        },
        PutReplicationConfiguration: {
          input: {
            type: "structure",
            required: [
              "replicationConfiguration"
            ],
            members: {
              replicationConfiguration: {
                shape: "S2y"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              replicationConfiguration: {
                shape: "S2y"
              }
            }
          }
        },
        SetRepositoryPolicy: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "policyText"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              policyText: {},
              force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              policyText: {}
            }
          }
        },
        StartImageScan: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "imageId"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageId: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              imageId: {
                shape: "Sj"
              },
              imageScanStatus: {
                shape: "S25"
              }
            }
          }
        },
        StartLifecyclePolicyPreview: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              lifecyclePolicyText: {}
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              lifecyclePolicyText: {},
              status: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S12"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UploadLayerPart: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "uploadId",
              "partFirstByte",
              "partLastByte",
              "layerPartBlob"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              uploadId: {},
              partFirstByte: {
                type: "long"
              },
              partLastByte: {
                type: "long"
              },
              layerPartBlob: {
                type: "blob"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              uploadId: {},
              lastByteReceived: {
                type: "long"
              }
            }
          }
        }
      },
      shapes: {
        Si: {
          type: "list",
          member: {
            shape: "Sj"
          }
        },
        Sj: {
          type: "structure",
          members: {
            imageDigest: {},
            imageTag: {}
          }
        },
        Sn: {
          type: "list",
          member: {
            type: "structure",
            members: {
              imageId: {
                shape: "Sj"
              },
              failureCode: {},
              failureReason: {}
            }
          }
        },
        Sv: {
          type: "structure",
          members: {
            registryId: {},
            repositoryName: {},
            imageId: {
              shape: "Sj"
            },
            imageManifest: {},
            imageManifestMediaType: {}
          }
        },
        S12: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S17: {
          type: "structure",
          members: {
            scanOnPush: {
              type: "boolean"
            }
          }
        },
        S19: {
          type: "structure",
          required: [
            "encryptionType"
          ],
          members: {
            encryptionType: {},
            kmsKey: {}
          }
        },
        S1d: {
          type: "structure",
          members: {
            repositoryArn: {},
            registryId: {},
            repositoryName: {},
            repositoryUri: {},
            createdAt: {
              type: "timestamp"
            },
            imageTagMutability: {},
            imageScanningConfiguration: {
              shape: "S17"
            },
            encryptionConfiguration: {
              shape: "S19"
            }
          }
        },
        S25: {
          type: "structure",
          members: {
            status: {},
            description: {}
          }
        },
        S2k: {
          type: "map",
          key: {},
          value: {
            type: "integer"
          }
        },
        S2s: {
          type: "list",
          member: {}
        },
        S2y: {
          type: "structure",
          required: [
            "rules"
          ],
          members: {
            rules: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "destinations"
                ],
                members: {
                  destinations: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "region",
                        "registryId"
                      ],
                      members: {
                        region: {},
                        registryId: {}
                      }
                    }
                  },
                  repositoryFilters: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "filter",
                        "filterType"
                      ],
                      members: {
                        filter: {},
                        filterType: {}
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ecr-2015-09-21.paginators.json
var require_ecr_2015_09_21_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ecr-2015-09-21.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeImageScanFindings: {
          input_token: "nextToken",
          limit_key: "maxResults",
          non_aggregate_keys: [
            "registryId",
            "repositoryName",
            "imageId",
            "imageScanStatus",
            "imageScanFindings"
          ],
          output_token: "nextToken",
          result_key: "imageScanFindings.findings"
        },
        DescribeImages: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "imageDetails"
        },
        DescribeRepositories: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "repositories"
        },
        GetLifecyclePolicyPreview: {
          input_token: "nextToken",
          limit_key: "maxResults",
          non_aggregate_keys: [
            "registryId",
            "repositoryName",
            "lifecyclePolicyText",
            "status",
            "summary"
          ],
          output_token: "nextToken",
          result_key: "previewResults"
        },
        ListImages: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "imageIds"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ecr-2015-09-21.waiters2.json
var require_ecr_2015_09_21_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/ecr-2015-09-21.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ImageScanComplete: {
          description: "Wait until an image scan is complete and findings can be accessed",
          operation: "DescribeImageScanFindings",
          delay: 5,
          maxAttempts: 60,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "imageScanStatus.status",
              expected: "COMPLETE"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "imageScanStatus.status",
              expected: "FAILED"
            }
          ]
        },
        LifecyclePolicyPreviewComplete: {
          description: "Wait until a lifecycle policy preview request is complete and results can be accessed",
          operation: "GetLifecyclePolicyPreview",
          delay: 5,
          maxAttempts: 20,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "status",
              expected: "COMPLETE"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "status",
              expected: "FAILED"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ecr.js
var require_ecr = __commonJS({
  "node_modules/aws-sdk/clients/ecr.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["ecr"] = {};
    AWS3.ECR = Service.defineService("ecr", ["2015-09-21"]);
    Object.defineProperty(apiLoader.services["ecr"], "2015-09-21", {
      get: function get() {
        var model = require_ecr_2015_09_21_min();
        model.paginators = require_ecr_2015_09_21_paginators().pagination;
        model.waiters = require_ecr_2015_09_21_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ECR;
  }
});

// node_modules/aws-sdk/apis/ecs-2014-11-13.min.json
var require_ecs_2014_11_13_min = __commonJS({
  "node_modules/aws-sdk/apis/ecs-2014-11-13.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-11-13",
        endpointPrefix: "ecs",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Amazon ECS",
        serviceFullName: "Amazon EC2 Container Service",
        serviceId: "ECS",
        signatureVersion: "v4",
        targetPrefix: "AmazonEC2ContainerServiceV20141113",
        uid: "ecs-2014-11-13"
      },
      operations: {
        CreateCapacityProvider: {
          input: {
            type: "structure",
            required: [
              "name",
              "autoScalingGroupProvider"
            ],
            members: {
              name: {},
              autoScalingGroupProvider: {
                shape: "S3"
              },
              tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              capacityProvider: {
                shape: "Sf"
              }
            }
          }
        },
        CreateCluster: {
          input: {
            type: "structure",
            members: {
              clusterName: {},
              tags: {
                shape: "Sa"
              },
              settings: {
                shape: "Sj"
              },
              configuration: {
                shape: "Sm"
              },
              capacityProviders: {
                shape: "Sr"
              },
              defaultCapacityProviderStrategy: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              cluster: {
                shape: "Sx"
              }
            }
          }
        },
        CreateService: {
          input: {
            type: "structure",
            required: [
              "serviceName"
            ],
            members: {
              cluster: {},
              serviceName: {},
              taskDefinition: {},
              loadBalancers: {
                shape: "S15"
              },
              serviceRegistries: {
                shape: "S18"
              },
              desiredCount: {
                type: "integer"
              },
              clientToken: {},
              launchType: {},
              capacityProviderStrategy: {
                shape: "Ss"
              },
              platformVersion: {},
              role: {},
              deploymentConfiguration: {
                shape: "S1b"
              },
              placementConstraints: {
                shape: "S1d"
              },
              placementStrategy: {
                shape: "S1g"
              },
              networkConfiguration: {
                shape: "S1j"
              },
              healthCheckGracePeriodSeconds: {
                type: "integer"
              },
              schedulingStrategy: {},
              deploymentController: {
                shape: "S1n"
              },
              tags: {
                shape: "Sa"
              },
              enableECSManagedTags: {
                type: "boolean"
              },
              propagateTags: {},
              enableExecuteCommand: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              service: {
                shape: "S1r"
              }
            }
          }
        },
        CreateTaskSet: {
          input: {
            type: "structure",
            required: [
              "service",
              "cluster",
              "taskDefinition"
            ],
            members: {
              service: {},
              cluster: {},
              externalId: {},
              taskDefinition: {},
              networkConfiguration: {
                shape: "S1j"
              },
              loadBalancers: {
                shape: "S15"
              },
              serviceRegistries: {
                shape: "S18"
              },
              launchType: {},
              capacityProviderStrategy: {
                shape: "Ss"
              },
              platformVersion: {},
              scale: {
                shape: "S1v"
              },
              clientToken: {},
              tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskSet: {
                shape: "S1t"
              }
            }
          }
        },
        DeleteAccountSetting: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              principalArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              setting: {
                shape: "S29"
              }
            }
          }
        },
        DeleteAttributes: {
          input: {
            type: "structure",
            required: [
              "attributes"
            ],
            members: {
              cluster: {},
              attributes: {
                shape: "S2b"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              attributes: {
                shape: "S2b"
              }
            }
          }
        },
        DeleteCapacityProvider: {
          input: {
            type: "structure",
            required: [
              "capacityProvider"
            ],
            members: {
              capacityProvider: {}
            }
          },
          output: {
            type: "structure",
            members: {
              capacityProvider: {
                shape: "Sf"
              }
            }
          }
        },
        DeleteCluster: {
          input: {
            type: "structure",
            required: [
              "cluster"
            ],
            members: {
              cluster: {}
            }
          },
          output: {
            type: "structure",
            members: {
              cluster: {
                shape: "Sx"
              }
            }
          }
        },
        DeleteService: {
          input: {
            type: "structure",
            required: [
              "service"
            ],
            members: {
              cluster: {},
              service: {},
              force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              service: {
                shape: "S1r"
              }
            }
          }
        },
        DeleteTaskSet: {
          input: {
            type: "structure",
            required: [
              "cluster",
              "service",
              "taskSet"
            ],
            members: {
              cluster: {},
              service: {},
              taskSet: {},
              force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskSet: {
                shape: "S1t"
              }
            }
          }
        },
        DeregisterContainerInstance: {
          input: {
            type: "structure",
            required: [
              "containerInstance"
            ],
            members: {
              cluster: {},
              containerInstance: {},
              force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              containerInstance: {
                shape: "S2q"
              }
            }
          }
        },
        DeregisterTaskDefinition: {
          input: {
            type: "structure",
            required: [
              "taskDefinition"
            ],
            members: {
              taskDefinition: {}
            }
          },
          output: {
            type: "structure",
            members: {
              taskDefinition: {
                shape: "S2y"
              }
            }
          }
        },
        DescribeCapacityProviders: {
          input: {
            type: "structure",
            members: {
              capacityProviders: {
                shape: "Sr"
              },
              include: {
                type: "list",
                member: {}
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              capacityProviders: {
                type: "list",
                member: {
                  shape: "Sf"
                }
              },
              failures: {
                shape: "S55"
              },
              nextToken: {}
            }
          }
        },
        DescribeClusters: {
          input: {
            type: "structure",
            members: {
              clusters: {
                shape: "Sr"
              },
              include: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              clusters: {
                type: "list",
                member: {
                  shape: "Sx"
                }
              },
              failures: {
                shape: "S55"
              }
            }
          }
        },
        DescribeContainerInstances: {
          input: {
            type: "structure",
            required: [
              "containerInstances"
            ],
            members: {
              cluster: {},
              containerInstances: {
                shape: "Sr"
              },
              include: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              containerInstances: {
                shape: "S5g"
              },
              failures: {
                shape: "S55"
              }
            }
          }
        },
        DescribeServices: {
          input: {
            type: "structure",
            required: [
              "services"
            ],
            members: {
              cluster: {},
              services: {
                shape: "Sr"
              },
              include: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              services: {
                type: "list",
                member: {
                  shape: "S1r"
                }
              },
              failures: {
                shape: "S55"
              }
            }
          }
        },
        DescribeTaskDefinition: {
          input: {
            type: "structure",
            required: [
              "taskDefinition"
            ],
            members: {
              taskDefinition: {},
              include: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskDefinition: {
                shape: "S2y"
              },
              tags: {
                shape: "Sa"
              }
            }
          }
        },
        DescribeTaskSets: {
          input: {
            type: "structure",
            required: [
              "cluster",
              "service"
            ],
            members: {
              cluster: {},
              service: {},
              taskSets: {
                shape: "Sr"
              },
              include: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskSets: {
                shape: "S1s"
              },
              failures: {
                shape: "S55"
              }
            }
          }
        },
        DescribeTasks: {
          input: {
            type: "structure",
            required: [
              "tasks"
            ],
            members: {
              cluster: {},
              tasks: {
                shape: "Sr"
              },
              include: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tasks: {
                shape: "S5y"
              },
              failures: {
                shape: "S55"
              }
            }
          }
        },
        DiscoverPollEndpoint: {
          input: {
            type: "structure",
            members: {
              containerInstance: {},
              cluster: {}
            }
          },
          output: {
            type: "structure",
            members: {
              endpoint: {},
              telemetryEndpoint: {}
            }
          }
        },
        ExecuteCommand: {
          input: {
            type: "structure",
            required: [
              "command",
              "interactive",
              "task"
            ],
            members: {
              cluster: {},
              container: {},
              command: {},
              interactive: {
                type: "boolean"
              },
              task: {}
            }
          },
          output: {
            type: "structure",
            members: {
              clusterArn: {},
              containerArn: {},
              containerName: {},
              interactive: {
                type: "boolean"
              },
              session: {
                type: "structure",
                members: {
                  sessionId: {},
                  streamUrl: {},
                  tokenValue: {
                    type: "string",
                    sensitive: true
                  }
                }
              },
              taskArn: {}
            }
          }
        },
        ListAccountSettings: {
          input: {
            type: "structure",
            members: {
              name: {},
              value: {},
              principalArn: {},
              effectiveSettings: {
                type: "boolean"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              settings: {
                type: "list",
                member: {
                  shape: "S29"
                }
              },
              nextToken: {}
            }
          }
        },
        ListAttributes: {
          input: {
            type: "structure",
            required: [
              "targetType"
            ],
            members: {
              cluster: {},
              targetType: {},
              attributeName: {},
              attributeValue: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              attributes: {
                shape: "S2b"
              },
              nextToken: {}
            }
          }
        },
        ListClusters: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              clusterArns: {
                shape: "Sr"
              },
              nextToken: {}
            }
          }
        },
        ListContainerInstances: {
          input: {
            type: "structure",
            members: {
              cluster: {},
              filter: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              containerInstanceArns: {
                shape: "Sr"
              },
              nextToken: {}
            }
          }
        },
        ListServices: {
          input: {
            type: "structure",
            members: {
              cluster: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              launchType: {},
              schedulingStrategy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              serviceArns: {
                shape: "Sr"
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sa"
              }
            }
          }
        },
        ListTaskDefinitionFamilies: {
          input: {
            type: "structure",
            members: {
              familyPrefix: {},
              status: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              families: {
                shape: "Sr"
              },
              nextToken: {}
            }
          }
        },
        ListTaskDefinitions: {
          input: {
            type: "structure",
            members: {
              familyPrefix: {},
              status: {},
              sort: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskDefinitionArns: {
                shape: "Sr"
              },
              nextToken: {}
            }
          }
        },
        ListTasks: {
          input: {
            type: "structure",
            members: {
              cluster: {},
              containerInstance: {},
              family: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              startedBy: {},
              serviceName: {},
              desiredStatus: {},
              launchType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              taskArns: {
                shape: "Sr"
              },
              nextToken: {}
            }
          }
        },
        PutAccountSetting: {
          input: {
            type: "structure",
            required: [
              "name",
              "value"
            ],
            members: {
              name: {},
              value: {},
              principalArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              setting: {
                shape: "S29"
              }
            }
          }
        },
        PutAccountSettingDefault: {
          input: {
            type: "structure",
            required: [
              "name",
              "value"
            ],
            members: {
              name: {},
              value: {}
            }
          },
          output: {
            type: "structure",
            members: {
              setting: {
                shape: "S29"
              }
            }
          }
        },
        PutAttributes: {
          input: {
            type: "structure",
            required: [
              "attributes"
            ],
            members: {
              cluster: {},
              attributes: {
                shape: "S2b"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              attributes: {
                shape: "S2b"
              }
            }
          }
        },
        PutClusterCapacityProviders: {
          input: {
            type: "structure",
            required: [
              "cluster",
              "capacityProviders",
              "defaultCapacityProviderStrategy"
            ],
            members: {
              cluster: {},
              capacityProviders: {
                shape: "Sr"
              },
              defaultCapacityProviderStrategy: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              cluster: {
                shape: "Sx"
              }
            }
          }
        },
        RegisterContainerInstance: {
          input: {
            type: "structure",
            members: {
              cluster: {},
              instanceIdentityDocument: {},
              instanceIdentityDocumentSignature: {},
              totalResources: {
                shape: "S2t"
              },
              versionInfo: {
                shape: "S2s"
              },
              containerInstanceArn: {},
              attributes: {
                shape: "S2b"
              },
              platformDevices: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "type"
                  ],
                  members: {
                    id: {},
                    type: {}
                  }
                }
              },
              tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              containerInstance: {
                shape: "S2q"
              }
            }
          }
        },
        RegisterTaskDefinition: {
          input: {
            type: "structure",
            required: [
              "family",
              "containerDefinitions"
            ],
            members: {
              family: {},
              taskRoleArn: {},
              executionRoleArn: {},
              networkMode: {},
              containerDefinitions: {
                shape: "S2z"
              },
              volumes: {
                shape: "S49"
              },
              placementConstraints: {
                shape: "S4n"
              },
              requiresCompatibilities: {
                shape: "S4q"
              },
              cpu: {},
              memory: {},
              tags: {
                shape: "Sa"
              },
              pidMode: {},
              ipcMode: {},
              proxyConfiguration: {
                shape: "S4w"
              },
              inferenceAccelerators: {
                shape: "S4s"
              },
              ephemeralStorage: {
                shape: "S4z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskDefinition: {
                shape: "S2y"
              },
              tags: {
                shape: "Sa"
              }
            }
          }
        },
        RunTask: {
          input: {
            type: "structure",
            required: [
              "taskDefinition"
            ],
            members: {
              capacityProviderStrategy: {
                shape: "Ss"
              },
              cluster: {},
              count: {
                type: "integer"
              },
              enableECSManagedTags: {
                type: "boolean"
              },
              enableExecuteCommand: {
                type: "boolean"
              },
              group: {},
              launchType: {},
              networkConfiguration: {
                shape: "S1j"
              },
              overrides: {
                shape: "S6c"
              },
              placementConstraints: {
                shape: "S1d"
              },
              placementStrategy: {
                shape: "S1g"
              },
              platformVersion: {},
              propagateTags: {},
              referenceId: {},
              startedBy: {},
              tags: {
                shape: "Sa"
              },
              taskDefinition: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tasks: {
                shape: "S5y"
              },
              failures: {
                shape: "S55"
              }
            }
          }
        },
        StartTask: {
          input: {
            type: "structure",
            required: [
              "containerInstances",
              "taskDefinition"
            ],
            members: {
              cluster: {},
              containerInstances: {
                shape: "Sr"
              },
              enableECSManagedTags: {
                type: "boolean"
              },
              enableExecuteCommand: {
                type: "boolean"
              },
              group: {},
              networkConfiguration: {
                shape: "S1j"
              },
              overrides: {
                shape: "S6c"
              },
              propagateTags: {},
              referenceId: {},
              startedBy: {},
              tags: {
                shape: "Sa"
              },
              taskDefinition: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tasks: {
                shape: "S5y"
              },
              failures: {
                shape: "S55"
              }
            }
          }
        },
        StopTask: {
          input: {
            type: "structure",
            required: [
              "task"
            ],
            members: {
              cluster: {},
              task: {},
              reason: {}
            }
          },
          output: {
            type: "structure",
            members: {
              task: {
                shape: "S5z"
              }
            }
          }
        },
        SubmitAttachmentStateChanges: {
          input: {
            type: "structure",
            required: [
              "attachments"
            ],
            members: {
              cluster: {},
              attachments: {
                shape: "S7x"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              acknowledgment: {}
            }
          }
        },
        SubmitContainerStateChange: {
          input: {
            type: "structure",
            members: {
              cluster: {},
              task: {},
              containerName: {},
              runtimeId: {},
              status: {},
              exitCode: {
                type: "integer"
              },
              reason: {},
              networkBindings: {
                shape: "S63"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              acknowledgment: {}
            }
          }
        },
        SubmitTaskStateChange: {
          input: {
            type: "structure",
            members: {
              cluster: {},
              task: {},
              status: {},
              reason: {},
              containers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    containerName: {},
                    imageDigest: {},
                    runtimeId: {},
                    exitCode: {
                      type: "integer"
                    },
                    networkBindings: {
                      shape: "S63"
                    },
                    reason: {},
                    status: {}
                  }
                }
              },
              attachments: {
                shape: "S7x"
              },
              managedAgents: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "containerName",
                    "managedAgentName",
                    "status"
                  ],
                  members: {
                    containerName: {},
                    managedAgentName: {},
                    status: {},
                    reason: {}
                  }
                }
              },
              pullStartedAt: {
                type: "timestamp"
              },
              pullStoppedAt: {
                type: "timestamp"
              },
              executionStoppedAt: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              acknowledgment: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateCapacityProvider: {
          input: {
            type: "structure",
            required: [
              "name",
              "autoScalingGroupProvider"
            ],
            members: {
              name: {},
              autoScalingGroupProvider: {
                type: "structure",
                members: {
                  managedScaling: {
                    shape: "S4"
                  },
                  managedTerminationProtection: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              capacityProvider: {
                shape: "Sf"
              }
            }
          }
        },
        UpdateCluster: {
          input: {
            type: "structure",
            required: [
              "cluster"
            ],
            members: {
              cluster: {},
              settings: {
                shape: "Sj"
              },
              configuration: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              cluster: {
                shape: "Sx"
              }
            }
          }
        },
        UpdateClusterSettings: {
          input: {
            type: "structure",
            required: [
              "cluster",
              "settings"
            ],
            members: {
              cluster: {},
              settings: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              cluster: {
                shape: "Sx"
              }
            }
          }
        },
        UpdateContainerAgent: {
          input: {
            type: "structure",
            required: [
              "containerInstance"
            ],
            members: {
              cluster: {},
              containerInstance: {}
            }
          },
          output: {
            type: "structure",
            members: {
              containerInstance: {
                shape: "S2q"
              }
            }
          }
        },
        UpdateContainerInstancesState: {
          input: {
            type: "structure",
            required: [
              "containerInstances",
              "status"
            ],
            members: {
              cluster: {},
              containerInstances: {
                shape: "Sr"
              },
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              containerInstances: {
                shape: "S5g"
              },
              failures: {
                shape: "S55"
              }
            }
          }
        },
        UpdateService: {
          input: {
            type: "structure",
            required: [
              "service"
            ],
            members: {
              cluster: {},
              service: {},
              desiredCount: {
                type: "integer"
              },
              taskDefinition: {},
              capacityProviderStrategy: {
                shape: "Ss"
              },
              deploymentConfiguration: {
                shape: "S1b"
              },
              networkConfiguration: {
                shape: "S1j"
              },
              placementConstraints: {
                shape: "S1d"
              },
              placementStrategy: {
                shape: "S1g"
              },
              platformVersion: {},
              forceNewDeployment: {
                type: "boolean"
              },
              healthCheckGracePeriodSeconds: {
                type: "integer"
              },
              enableExecuteCommand: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              service: {
                shape: "S1r"
              }
            }
          }
        },
        UpdateServicePrimaryTaskSet: {
          input: {
            type: "structure",
            required: [
              "cluster",
              "service",
              "primaryTaskSet"
            ],
            members: {
              cluster: {},
              service: {},
              primaryTaskSet: {}
            }
          },
          output: {
            type: "structure",
            members: {
              taskSet: {
                shape: "S1t"
              }
            }
          }
        },
        UpdateTaskSet: {
          input: {
            type: "structure",
            required: [
              "cluster",
              "service",
              "taskSet",
              "scale"
            ],
            members: {
              cluster: {},
              service: {},
              taskSet: {},
              scale: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskSet: {
                shape: "S1t"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          required: [
            "autoScalingGroupArn"
          ],
          members: {
            autoScalingGroupArn: {},
            managedScaling: {
              shape: "S4"
            },
            managedTerminationProtection: {}
          }
        },
        S4: {
          type: "structure",
          members: {
            status: {},
            targetCapacity: {
              type: "integer"
            },
            minimumScalingStepSize: {
              type: "integer"
            },
            maximumScalingStepSize: {
              type: "integer"
            },
            instanceWarmupPeriod: {
              type: "integer"
            }
          }
        },
        Sa: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sf: {
          type: "structure",
          members: {
            capacityProviderArn: {},
            name: {},
            status: {},
            autoScalingGroupProvider: {
              shape: "S3"
            },
            updateStatus: {},
            updateStatusReason: {},
            tags: {
              shape: "Sa"
            }
          }
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              value: {}
            }
          }
        },
        Sm: {
          type: "structure",
          members: {
            executeCommandConfiguration: {
              type: "structure",
              members: {
                kmsKeyId: {},
                logging: {},
                logConfiguration: {
                  type: "structure",
                  members: {
                    cloudWatchLogGroupName: {},
                    cloudWatchEncryptionEnabled: {
                      type: "boolean"
                    },
                    s3BucketName: {},
                    s3EncryptionEnabled: {
                      type: "boolean"
                    },
                    s3KeyPrefix: {}
                  }
                }
              }
            }
          }
        },
        Sr: {
          type: "list",
          member: {}
        },
        Ss: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "capacityProvider"
            ],
            members: {
              capacityProvider: {},
              weight: {
                type: "integer"
              },
              base: {
                type: "integer"
              }
            }
          }
        },
        Sx: {
          type: "structure",
          members: {
            clusterArn: {},
            clusterName: {},
            configuration: {
              shape: "Sm"
            },
            status: {},
            registeredContainerInstancesCount: {
              type: "integer"
            },
            runningTasksCount: {
              type: "integer"
            },
            pendingTasksCount: {
              type: "integer"
            },
            activeServicesCount: {
              type: "integer"
            },
            statistics: {
              type: "list",
              member: {
                shape: "S10"
              }
            },
            tags: {
              shape: "Sa"
            },
            settings: {
              shape: "Sj"
            },
            capacityProviders: {
              shape: "Sr"
            },
            defaultCapacityProviderStrategy: {
              shape: "Ss"
            },
            attachments: {
              shape: "S11"
            },
            attachmentsStatus: {}
          }
        },
        S10: {
          type: "structure",
          members: {
            name: {},
            value: {}
          }
        },
        S11: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              type: {},
              status: {},
              details: {
                type: "list",
                member: {
                  shape: "S10"
                }
              }
            }
          }
        },
        S15: {
          type: "list",
          member: {
            type: "structure",
            members: {
              targetGroupArn: {},
              loadBalancerName: {},
              containerName: {},
              containerPort: {
                type: "integer"
              }
            }
          }
        },
        S18: {
          type: "list",
          member: {
            type: "structure",
            members: {
              registryArn: {},
              port: {
                type: "integer"
              },
              containerName: {},
              containerPort: {
                type: "integer"
              }
            }
          }
        },
        S1b: {
          type: "structure",
          members: {
            deploymentCircuitBreaker: {
              type: "structure",
              required: [
                "enable",
                "rollback"
              ],
              members: {
                enable: {
                  type: "boolean"
                },
                rollback: {
                  type: "boolean"
                }
              }
            },
            maximumPercent: {
              type: "integer"
            },
            minimumHealthyPercent: {
              type: "integer"
            }
          }
        },
        S1d: {
          type: "list",
          member: {
            type: "structure",
            members: {
              type: {},
              expression: {}
            }
          }
        },
        S1g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              type: {},
              field: {}
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            awsvpcConfiguration: {
              type: "structure",
              required: [
                "subnets"
              ],
              members: {
                subnets: {
                  shape: "Sr"
                },
                securityGroups: {
                  shape: "Sr"
                },
                assignPublicIp: {}
              }
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {}
          }
        },
        S1r: {
          type: "structure",
          members: {
            serviceArn: {},
            serviceName: {},
            clusterArn: {},
            loadBalancers: {
              shape: "S15"
            },
            serviceRegistries: {
              shape: "S18"
            },
            status: {},
            desiredCount: {
              type: "integer"
            },
            runningCount: {
              type: "integer"
            },
            pendingCount: {
              type: "integer"
            },
            launchType: {},
            capacityProviderStrategy: {
              shape: "Ss"
            },
            platformVersion: {},
            taskDefinition: {},
            deploymentConfiguration: {
              shape: "S1b"
            },
            taskSets: {
              shape: "S1s"
            },
            deployments: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  id: {},
                  status: {},
                  taskDefinition: {},
                  desiredCount: {
                    type: "integer"
                  },
                  pendingCount: {
                    type: "integer"
                  },
                  runningCount: {
                    type: "integer"
                  },
                  failedTasks: {
                    type: "integer"
                  },
                  createdAt: {
                    type: "timestamp"
                  },
                  updatedAt: {
                    type: "timestamp"
                  },
                  capacityProviderStrategy: {
                    shape: "Ss"
                  },
                  launchType: {},
                  platformVersion: {},
                  networkConfiguration: {
                    shape: "S1j"
                  },
                  rolloutState: {},
                  rolloutStateReason: {}
                }
              }
            },
            roleArn: {},
            events: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  id: {},
                  createdAt: {
                    type: "timestamp"
                  },
                  message: {}
                }
              }
            },
            createdAt: {
              type: "timestamp"
            },
            placementConstraints: {
              shape: "S1d"
            },
            placementStrategy: {
              shape: "S1g"
            },
            networkConfiguration: {
              shape: "S1j"
            },
            healthCheckGracePeriodSeconds: {
              type: "integer"
            },
            schedulingStrategy: {},
            deploymentController: {
              shape: "S1n"
            },
            tags: {
              shape: "Sa"
            },
            createdBy: {},
            enableECSManagedTags: {
              type: "boolean"
            },
            propagateTags: {},
            enableExecuteCommand: {
              type: "boolean"
            }
          }
        },
        S1s: {
          type: "list",
          member: {
            shape: "S1t"
          }
        },
        S1t: {
          type: "structure",
          members: {
            id: {},
            taskSetArn: {},
            serviceArn: {},
            clusterArn: {},
            startedBy: {},
            externalId: {},
            status: {},
            taskDefinition: {},
            computedDesiredCount: {
              type: "integer"
            },
            pendingCount: {
              type: "integer"
            },
            runningCount: {
              type: "integer"
            },
            createdAt: {
              type: "timestamp"
            },
            updatedAt: {
              type: "timestamp"
            },
            launchType: {},
            capacityProviderStrategy: {
              shape: "Ss"
            },
            platformVersion: {},
            networkConfiguration: {
              shape: "S1j"
            },
            loadBalancers: {
              shape: "S15"
            },
            serviceRegistries: {
              shape: "S18"
            },
            scale: {
              shape: "S1v"
            },
            stabilityStatus: {},
            stabilityStatusAt: {
              type: "timestamp"
            },
            tags: {
              shape: "Sa"
            }
          }
        },
        S1v: {
          type: "structure",
          members: {
            value: {
              type: "double"
            },
            unit: {}
          }
        },
        S29: {
          type: "structure",
          members: {
            name: {},
            value: {},
            principalArn: {}
          }
        },
        S2b: {
          type: "list",
          member: {
            shape: "S2c"
          }
        },
        S2c: {
          type: "structure",
          required: [
            "name"
          ],
          members: {
            name: {},
            value: {},
            targetType: {},
            targetId: {}
          }
        },
        S2q: {
          type: "structure",
          members: {
            containerInstanceArn: {},
            ec2InstanceId: {},
            capacityProviderName: {},
            version: {
              type: "long"
            },
            versionInfo: {
              shape: "S2s"
            },
            remainingResources: {
              shape: "S2t"
            },
            registeredResources: {
              shape: "S2t"
            },
            status: {},
            statusReason: {},
            agentConnected: {
              type: "boolean"
            },
            runningTasksCount: {
              type: "integer"
            },
            pendingTasksCount: {
              type: "integer"
            },
            agentUpdateStatus: {},
            attributes: {
              shape: "S2b"
            },
            registeredAt: {
              type: "timestamp"
            },
            attachments: {
              shape: "S11"
            },
            tags: {
              shape: "Sa"
            }
          }
        },
        S2s: {
          type: "structure",
          members: {
            agentVersion: {},
            agentHash: {},
            dockerVersion: {}
          }
        },
        S2t: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              type: {},
              doubleValue: {
                type: "double"
              },
              longValue: {
                type: "long"
              },
              integerValue: {
                type: "integer"
              },
              stringSetValue: {
                shape: "Sr"
              }
            }
          }
        },
        S2y: {
          type: "structure",
          members: {
            taskDefinitionArn: {},
            containerDefinitions: {
              shape: "S2z"
            },
            family: {},
            taskRoleArn: {},
            executionRoleArn: {},
            networkMode: {},
            revision: {
              type: "integer"
            },
            volumes: {
              shape: "S49"
            },
            status: {},
            requiresAttributes: {
              type: "list",
              member: {
                shape: "S2c"
              }
            },
            placementConstraints: {
              shape: "S4n"
            },
            compatibilities: {
              shape: "S4q"
            },
            requiresCompatibilities: {
              shape: "S4q"
            },
            cpu: {},
            memory: {},
            inferenceAccelerators: {
              shape: "S4s"
            },
            pidMode: {},
            ipcMode: {},
            proxyConfiguration: {
              shape: "S4w"
            },
            registeredAt: {
              type: "timestamp"
            },
            deregisteredAt: {
              type: "timestamp"
            },
            registeredBy: {},
            ephemeralStorage: {
              shape: "S4z"
            }
          }
        },
        S2z: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              image: {},
              repositoryCredentials: {
                type: "structure",
                required: [
                  "credentialsParameter"
                ],
                members: {
                  credentialsParameter: {}
                }
              },
              cpu: {
                type: "integer"
              },
              memory: {
                type: "integer"
              },
              memoryReservation: {
                type: "integer"
              },
              links: {
                shape: "Sr"
              },
              portMappings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    containerPort: {
                      type: "integer"
                    },
                    hostPort: {
                      type: "integer"
                    },
                    protocol: {}
                  }
                }
              },
              essential: {
                type: "boolean"
              },
              entryPoint: {
                shape: "Sr"
              },
              command: {
                shape: "Sr"
              },
              environment: {
                shape: "S35"
              },
              environmentFiles: {
                shape: "S36"
              },
              mountPoints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    sourceVolume: {},
                    containerPath: {},
                    readOnly: {
                      type: "boolean"
                    }
                  }
                }
              },
              volumesFrom: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    sourceContainer: {},
                    readOnly: {
                      type: "boolean"
                    }
                  }
                }
              },
              linuxParameters: {
                type: "structure",
                members: {
                  capabilities: {
                    type: "structure",
                    members: {
                      add: {
                        shape: "Sr"
                      },
                      drop: {
                        shape: "Sr"
                      }
                    }
                  },
                  devices: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "hostPath"
                      ],
                      members: {
                        hostPath: {},
                        containerPath: {},
                        permissions: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  },
                  initProcessEnabled: {
                    type: "boolean"
                  },
                  sharedMemorySize: {
                    type: "integer"
                  },
                  tmpfs: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "containerPath",
                        "size"
                      ],
                      members: {
                        containerPath: {},
                        size: {
                          type: "integer"
                        },
                        mountOptions: {
                          shape: "Sr"
                        }
                      }
                    }
                  },
                  maxSwap: {
                    type: "integer"
                  },
                  swappiness: {
                    type: "integer"
                  }
                }
              },
              secrets: {
                shape: "S3l"
              },
              dependsOn: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "containerName",
                    "condition"
                  ],
                  members: {
                    containerName: {},
                    condition: {}
                  }
                }
              },
              startTimeout: {
                type: "integer"
              },
              stopTimeout: {
                type: "integer"
              },
              hostname: {},
              user: {},
              workingDirectory: {},
              disableNetworking: {
                type: "boolean"
              },
              privileged: {
                type: "boolean"
              },
              readonlyRootFilesystem: {
                type: "boolean"
              },
              dnsServers: {
                shape: "Sr"
              },
              dnsSearchDomains: {
                shape: "Sr"
              },
              extraHosts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "hostname",
                    "ipAddress"
                  ],
                  members: {
                    hostname: {},
                    ipAddress: {}
                  }
                }
              },
              dockerSecurityOptions: {
                shape: "Sr"
              },
              interactive: {
                type: "boolean"
              },
              pseudoTerminal: {
                type: "boolean"
              },
              dockerLabels: {
                type: "map",
                key: {},
                value: {}
              },
              ulimits: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "softLimit",
                    "hardLimit"
                  ],
                  members: {
                    name: {},
                    softLimit: {
                      type: "integer"
                    },
                    hardLimit: {
                      type: "integer"
                    }
                  }
                }
              },
              logConfiguration: {
                type: "structure",
                required: [
                  "logDriver"
                ],
                members: {
                  logDriver: {},
                  options: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  secretOptions: {
                    shape: "S3l"
                  }
                }
              },
              healthCheck: {
                type: "structure",
                required: [
                  "command"
                ],
                members: {
                  command: {
                    shape: "Sr"
                  },
                  interval: {
                    type: "integer"
                  },
                  timeout: {
                    type: "integer"
                  },
                  retries: {
                    type: "integer"
                  },
                  startPeriod: {
                    type: "integer"
                  }
                }
              },
              systemControls: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    namespace: {},
                    value: {}
                  }
                }
              },
              resourceRequirements: {
                shape: "S42"
              },
              firelensConfiguration: {
                type: "structure",
                required: [
                  "type"
                ],
                members: {
                  type: {},
                  options: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            }
          }
        },
        S35: {
          type: "list",
          member: {
            shape: "S10"
          }
        },
        S36: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "value",
              "type"
            ],
            members: {
              value: {},
              type: {}
            }
          }
        },
        S3l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "valueFrom"
            ],
            members: {
              name: {},
              valueFrom: {}
            }
          }
        },
        S42: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "value",
              "type"
            ],
            members: {
              value: {},
              type: {}
            }
          }
        },
        S49: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              host: {
                type: "structure",
                members: {
                  sourcePath: {}
                }
              },
              dockerVolumeConfiguration: {
                type: "structure",
                members: {
                  scope: {},
                  autoprovision: {
                    type: "boolean"
                  },
                  driver: {},
                  driverOpts: {
                    shape: "S4e"
                  },
                  labels: {
                    shape: "S4e"
                  }
                }
              },
              efsVolumeConfiguration: {
                type: "structure",
                required: [
                  "fileSystemId"
                ],
                members: {
                  fileSystemId: {},
                  rootDirectory: {},
                  transitEncryption: {},
                  transitEncryptionPort: {
                    type: "integer"
                  },
                  authorizationConfig: {
                    type: "structure",
                    members: {
                      accessPointId: {},
                      iam: {}
                    }
                  }
                }
              },
              fsxWindowsFileServerVolumeConfiguration: {
                type: "structure",
                required: [
                  "fileSystemId",
                  "rootDirectory",
                  "authorizationConfig"
                ],
                members: {
                  fileSystemId: {},
                  rootDirectory: {},
                  authorizationConfig: {
                    type: "structure",
                    required: [
                      "credentialsParameter",
                      "domain"
                    ],
                    members: {
                      credentialsParameter: {},
                      domain: {}
                    }
                  }
                }
              }
            }
          }
        },
        S4e: {
          type: "map",
          key: {},
          value: {}
        },
        S4n: {
          type: "list",
          member: {
            type: "structure",
            members: {
              type: {},
              expression: {}
            }
          }
        },
        S4q: {
          type: "list",
          member: {}
        },
        S4s: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "deviceName",
              "deviceType"
            ],
            members: {
              deviceName: {},
              deviceType: {}
            }
          }
        },
        S4w: {
          type: "structure",
          required: [
            "containerName"
          ],
          members: {
            type: {},
            containerName: {},
            properties: {
              type: "list",
              member: {
                shape: "S10"
              }
            }
          }
        },
        S4z: {
          type: "structure",
          required: [
            "sizeInGiB"
          ],
          members: {
            sizeInGiB: {
              type: "integer"
            }
          }
        },
        S55: {
          type: "list",
          member: {
            type: "structure",
            members: {
              arn: {},
              reason: {},
              detail: {}
            }
          }
        },
        S5g: {
          type: "list",
          member: {
            shape: "S2q"
          }
        },
        S5y: {
          type: "list",
          member: {
            shape: "S5z"
          }
        },
        S5z: {
          type: "structure",
          members: {
            attachments: {
              shape: "S11"
            },
            attributes: {
              shape: "S2b"
            },
            availabilityZone: {},
            capacityProviderName: {},
            clusterArn: {},
            connectivity: {},
            connectivityAt: {
              type: "timestamp"
            },
            containerInstanceArn: {},
            containers: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  containerArn: {},
                  taskArn: {},
                  name: {},
                  image: {},
                  imageDigest: {},
                  runtimeId: {},
                  lastStatus: {},
                  exitCode: {
                    type: "integer"
                  },
                  reason: {},
                  networkBindings: {
                    shape: "S63"
                  },
                  networkInterfaces: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        attachmentId: {},
                        privateIpv4Address: {},
                        ipv6Address: {}
                      }
                    }
                  },
                  healthStatus: {},
                  managedAgents: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        lastStartedAt: {
                          type: "timestamp"
                        },
                        name: {},
                        reason: {},
                        lastStatus: {}
                      }
                    }
                  },
                  cpu: {},
                  memory: {},
                  memoryReservation: {},
                  gpuIds: {
                    type: "list",
                    member: {}
                  }
                }
              }
            },
            cpu: {},
            createdAt: {
              type: "timestamp"
            },
            desiredStatus: {},
            enableExecuteCommand: {
              type: "boolean"
            },
            executionStoppedAt: {
              type: "timestamp"
            },
            group: {},
            healthStatus: {},
            inferenceAccelerators: {
              shape: "S4s"
            },
            lastStatus: {},
            launchType: {},
            memory: {},
            overrides: {
              shape: "S6c"
            },
            platformVersion: {},
            pullStartedAt: {
              type: "timestamp"
            },
            pullStoppedAt: {
              type: "timestamp"
            },
            startedAt: {
              type: "timestamp"
            },
            startedBy: {},
            stopCode: {},
            stoppedAt: {
              type: "timestamp"
            },
            stoppedReason: {},
            stoppingAt: {
              type: "timestamp"
            },
            tags: {
              shape: "Sa"
            },
            taskArn: {},
            taskDefinitionArn: {},
            version: {
              type: "long"
            },
            ephemeralStorage: {
              shape: "S4z"
            }
          }
        },
        S63: {
          type: "list",
          member: {
            type: "structure",
            members: {
              bindIP: {},
              containerPort: {
                type: "integer"
              },
              hostPort: {
                type: "integer"
              },
              protocol: {}
            }
          }
        },
        S6c: {
          type: "structure",
          members: {
            containerOverrides: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  name: {},
                  command: {
                    shape: "Sr"
                  },
                  environment: {
                    shape: "S35"
                  },
                  environmentFiles: {
                    shape: "S36"
                  },
                  cpu: {
                    type: "integer"
                  },
                  memory: {
                    type: "integer"
                  },
                  memoryReservation: {
                    type: "integer"
                  },
                  resourceRequirements: {
                    shape: "S42"
                  }
                }
              }
            },
            cpu: {},
            inferenceAcceleratorOverrides: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  deviceName: {},
                  deviceType: {}
                }
              }
            },
            executionRoleArn: {},
            memory: {},
            taskRoleArn: {},
            ephemeralStorage: {
              shape: "S4z"
            }
          }
        },
        S7x: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "attachmentArn",
              "status"
            ],
            members: {
              attachmentArn: {},
              status: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ecs-2014-11-13.paginators.json
var require_ecs_2014_11_13_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ecs-2014-11-13.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAccountSettings: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "settings"
        },
        ListAttributes: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "attributes"
        },
        ListClusters: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "clusterArns"
        },
        ListContainerInstances: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "containerInstanceArns"
        },
        ListServices: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "serviceArns"
        },
        ListTaskDefinitionFamilies: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "families"
        },
        ListTaskDefinitions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "taskDefinitionArns"
        },
        ListTasks: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "taskArns"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ecs-2014-11-13.waiters2.json
var require_ecs_2014_11_13_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/ecs-2014-11-13.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        TasksRunning: {
          delay: 6,
          operation: "DescribeTasks",
          maxAttempts: 100,
          acceptors: [
            {
              expected: "STOPPED",
              matcher: "pathAny",
              state: "failure",
              argument: "tasks[].lastStatus"
            },
            {
              expected: "MISSING",
              matcher: "pathAny",
              state: "failure",
              argument: "failures[].reason"
            },
            {
              expected: "RUNNING",
              matcher: "pathAll",
              state: "success",
              argument: "tasks[].lastStatus"
            }
          ]
        },
        TasksStopped: {
          delay: 6,
          operation: "DescribeTasks",
          maxAttempts: 100,
          acceptors: [
            {
              expected: "STOPPED",
              matcher: "pathAll",
              state: "success",
              argument: "tasks[].lastStatus"
            }
          ]
        },
        ServicesStable: {
          delay: 15,
          operation: "DescribeServices",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "MISSING",
              matcher: "pathAny",
              state: "failure",
              argument: "failures[].reason"
            },
            {
              expected: "DRAINING",
              matcher: "pathAny",
              state: "failure",
              argument: "services[].status"
            },
            {
              expected: "INACTIVE",
              matcher: "pathAny",
              state: "failure",
              argument: "services[].status"
            },
            {
              expected: true,
              matcher: "path",
              state: "success",
              argument: "length(services[?!(length(deployments) == `1` && runningCount == desiredCount)]) == `0`"
            }
          ]
        },
        ServicesInactive: {
          delay: 15,
          operation: "DescribeServices",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "MISSING",
              matcher: "pathAny",
              state: "failure",
              argument: "failures[].reason"
            },
            {
              expected: "INACTIVE",
              matcher: "pathAny",
              state: "success",
              argument: "services[].status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ecs.js
var require_ecs = __commonJS({
  "node_modules/aws-sdk/clients/ecs.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["ecs"] = {};
    AWS3.ECS = Service.defineService("ecs", ["2014-11-13"]);
    Object.defineProperty(apiLoader.services["ecs"], "2014-11-13", {
      get: function get() {
        var model = require_ecs_2014_11_13_min();
        model.paginators = require_ecs_2014_11_13_paginators().pagination;
        model.waiters = require_ecs_2014_11_13_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ECS;
  }
});

// node_modules/aws-sdk/apis/elasticfilesystem-2015-02-01.min.json
var require_elasticfilesystem_2015_02_01_min = __commonJS({
  "node_modules/aws-sdk/apis/elasticfilesystem-2015-02-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-02-01",
        endpointPrefix: "elasticfilesystem",
        protocol: "rest-json",
        serviceAbbreviation: "EFS",
        serviceFullName: "Amazon Elastic File System",
        serviceId: "EFS",
        signatureVersion: "v4",
        uid: "elasticfilesystem-2015-02-01"
      },
      operations: {
        CreateAccessPoint: {
          http: {
            requestUri: "/2015-02-01/access-points",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ClientToken",
              "FileSystemId"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S3"
              },
              FileSystemId: {},
              PosixUser: {
                shape: "S8"
              },
              RootDirectory: {
                shape: "Sc"
              }
            }
          },
          output: {
            shape: "Si"
          }
        },
        CreateFileSystem: {
          http: {
            requestUri: "/2015-02-01/file-systems",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "CreationToken"
            ],
            members: {
              CreationToken: {
                idempotencyToken: true
              },
              PerformanceMode: {},
              Encrypted: {
                type: "boolean"
              },
              KmsKeyId: {},
              ThroughputMode: {},
              ProvisionedThroughputInMibps: {
                type: "double"
              },
              AvailabilityZoneName: {},
              Backup: {
                type: "boolean"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            shape: "Sx"
          }
        },
        CreateMountTarget: {
          http: {
            requestUri: "/2015-02-01/mount-targets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId",
              "SubnetId"
            ],
            members: {
              FileSystemId: {},
              SubnetId: {},
              IpAddress: {},
              SecurityGroups: {
                shape: "S18"
              }
            }
          },
          output: {
            shape: "S1a"
          }
        },
        CreateTags: {
          http: {
            requestUri: "/2015-02-01/create-tags/{FileSystemId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId",
              "Tags"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Use TagResource."
        },
        DeleteAccessPoint: {
          http: {
            method: "DELETE",
            requestUri: "/2015-02-01/access-points/{AccessPointId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccessPointId"
            ],
            members: {
              AccessPointId: {
                location: "uri",
                locationName: "AccessPointId"
              }
            }
          }
        },
        DeleteFileSystem: {
          http: {
            method: "DELETE",
            requestUri: "/2015-02-01/file-systems/{FileSystemId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              }
            }
          }
        },
        DeleteFileSystemPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/2015-02-01/file-systems/{FileSystemId}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              }
            }
          }
        },
        DeleteMountTarget: {
          http: {
            method: "DELETE",
            requestUri: "/2015-02-01/mount-targets/{MountTargetId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MountTargetId"
            ],
            members: {
              MountTargetId: {
                location: "uri",
                locationName: "MountTargetId"
              }
            }
          }
        },
        DeleteTags: {
          http: {
            requestUri: "/2015-02-01/delete-tags/{FileSystemId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId",
              "TagKeys"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              },
              TagKeys: {
                shape: "S1k"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "Use UntagResource."
        },
        DescribeAccessPoints: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/access-points",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              AccessPointId: {
                location: "querystring",
                locationName: "AccessPointId"
              },
              FileSystemId: {
                location: "querystring",
                locationName: "FileSystemId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessPoints: {
                type: "list",
                member: {
                  shape: "Si"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAccountPreferences: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/account-preferences",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceIdPreference: {
                shape: "S1s"
              },
              NextToken: {}
            }
          }
        },
        DescribeBackupPolicy: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/file-systems/{FileSystemId}/backup-policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              }
            }
          },
          output: {
            shape: "S1x"
          }
        },
        DescribeFileSystemPolicy: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/file-systems/{FileSystemId}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              }
            }
          },
          output: {
            shape: "S21"
          }
        },
        DescribeFileSystems: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/file-systems",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              CreationToken: {
                location: "querystring",
                locationName: "CreationToken"
              },
              FileSystemId: {
                location: "querystring",
                locationName: "FileSystemId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              FileSystems: {
                type: "list",
                member: {
                  shape: "Sx"
                }
              },
              NextMarker: {}
            }
          }
        },
        DescribeLifecycleConfiguration: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/file-systems/{FileSystemId}/lifecycle-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              }
            }
          },
          output: {
            shape: "S29"
          }
        },
        DescribeMountTargetSecurityGroups: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/mount-targets/{MountTargetId}/security-groups",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MountTargetId"
            ],
            members: {
              MountTargetId: {
                location: "uri",
                locationName: "MountTargetId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "SecurityGroups"
            ],
            members: {
              SecurityGroups: {
                shape: "S18"
              }
            }
          }
        },
        DescribeMountTargets: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/mount-targets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              FileSystemId: {
                location: "querystring",
                locationName: "FileSystemId"
              },
              MountTargetId: {
                location: "querystring",
                locationName: "MountTargetId"
              },
              AccessPointId: {
                location: "querystring",
                locationName: "AccessPointId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              MountTargets: {
                type: "list",
                member: {
                  shape: "S1a"
                }
              },
              NextMarker: {}
            }
          }
        },
        DescribeTags: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/tags/{FileSystemId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Marker: {},
              Tags: {
                shape: "S3"
              },
              NextMarker: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "Use ListTagsForResource."
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2015-02-01/resource-tags/{ResourceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S3"
              },
              NextToken: {}
            }
          }
        },
        ModifyMountTargetSecurityGroups: {
          http: {
            method: "PUT",
            requestUri: "/2015-02-01/mount-targets/{MountTargetId}/security-groups",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MountTargetId"
            ],
            members: {
              MountTargetId: {
                location: "uri",
                locationName: "MountTargetId"
              },
              SecurityGroups: {
                shape: "S18"
              }
            }
          }
        },
        PutAccountPreferences: {
          http: {
            method: "PUT",
            requestUri: "/2015-02-01/account-preferences",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceIdType"
            ],
            members: {
              ResourceIdType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceIdPreference: {
                shape: "S1s"
              }
            }
          }
        },
        PutBackupPolicy: {
          http: {
            method: "PUT",
            requestUri: "/2015-02-01/file-systems/{FileSystemId}/backup-policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId",
              "BackupPolicy"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              },
              BackupPolicy: {
                shape: "S1y"
              }
            }
          },
          output: {
            shape: "S1x"
          }
        },
        PutFileSystemPolicy: {
          http: {
            method: "PUT",
            requestUri: "/2015-02-01/file-systems/{FileSystemId}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId",
              "Policy"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              },
              Policy: {},
              BypassPolicyLockoutSafetyCheck: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S21"
          }
        },
        PutLifecycleConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/2015-02-01/file-systems/{FileSystemId}/lifecycle-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId",
              "LifecyclePolicies"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              },
              LifecyclePolicies: {
                shape: "S2a"
              }
            }
          },
          output: {
            shape: "S29"
          }
        },
        TagResource: {
          http: {
            requestUri: "/2015-02-01/resource-tags/{ResourceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "Tags"
            ],
            members: {
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              Tags: {
                shape: "S3"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/2015-02-01/resource-tags/{ResourceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "TagKeys"
            ],
            members: {
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              TagKeys: {
                shape: "S1k",
                location: "querystring",
                locationName: "tagKeys"
              }
            }
          }
        },
        UpdateFileSystem: {
          http: {
            method: "PUT",
            requestUri: "/2015-02-01/file-systems/{FileSystemId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              FileSystemId: {
                location: "uri",
                locationName: "FileSystemId"
              },
              ThroughputMode: {},
              ProvisionedThroughputInMibps: {
                type: "double"
              }
            }
          },
          output: {
            shape: "Sx"
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S8: {
          type: "structure",
          required: [
            "Uid",
            "Gid"
          ],
          members: {
            Uid: {
              type: "long"
            },
            Gid: {
              type: "long"
            },
            SecondaryGids: {
              type: "list",
              member: {
                type: "long"
              }
            }
          }
        },
        Sc: {
          type: "structure",
          members: {
            Path: {},
            CreationInfo: {
              type: "structure",
              required: [
                "OwnerUid",
                "OwnerGid",
                "Permissions"
              ],
              members: {
                OwnerUid: {
                  type: "long"
                },
                OwnerGid: {
                  type: "long"
                },
                Permissions: {}
              }
            }
          }
        },
        Si: {
          type: "structure",
          members: {
            ClientToken: {},
            Name: {},
            Tags: {
              shape: "S3"
            },
            AccessPointId: {},
            AccessPointArn: {},
            FileSystemId: {},
            PosixUser: {
              shape: "S8"
            },
            RootDirectory: {
              shape: "Sc"
            },
            OwnerId: {},
            LifeCycleState: {}
          }
        },
        Sx: {
          type: "structure",
          required: [
            "OwnerId",
            "CreationToken",
            "FileSystemId",
            "CreationTime",
            "LifeCycleState",
            "NumberOfMountTargets",
            "SizeInBytes",
            "PerformanceMode",
            "Tags"
          ],
          members: {
            OwnerId: {},
            CreationToken: {},
            FileSystemId: {},
            FileSystemArn: {},
            CreationTime: {
              type: "timestamp"
            },
            LifeCycleState: {},
            Name: {},
            NumberOfMountTargets: {
              type: "integer"
            },
            SizeInBytes: {
              type: "structure",
              required: [
                "Value"
              ],
              members: {
                Value: {
                  type: "long"
                },
                Timestamp: {
                  type: "timestamp"
                },
                ValueInIA: {
                  type: "long"
                },
                ValueInStandard: {
                  type: "long"
                }
              }
            },
            PerformanceMode: {},
            Encrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            ThroughputMode: {},
            ProvisionedThroughputInMibps: {
              type: "double"
            },
            AvailabilityZoneName: {},
            AvailabilityZoneId: {},
            Tags: {
              shape: "S3"
            }
          }
        },
        S18: {
          type: "list",
          member: {}
        },
        S1a: {
          type: "structure",
          required: [
            "MountTargetId",
            "FileSystemId",
            "SubnetId",
            "LifeCycleState"
          ],
          members: {
            OwnerId: {},
            MountTargetId: {},
            FileSystemId: {},
            SubnetId: {},
            LifeCycleState: {},
            IpAddress: {},
            NetworkInterfaceId: {},
            AvailabilityZoneId: {},
            AvailabilityZoneName: {},
            VpcId: {}
          }
        },
        S1k: {
          type: "list",
          member: {}
        },
        S1s: {
          type: "structure",
          members: {
            ResourceIdType: {},
            Resources: {
              type: "list",
              member: {}
            }
          }
        },
        S1x: {
          type: "structure",
          members: {
            BackupPolicy: {
              shape: "S1y"
            }
          }
        },
        S1y: {
          type: "structure",
          required: [
            "Status"
          ],
          members: {
            Status: {}
          }
        },
        S21: {
          type: "structure",
          members: {
            FileSystemId: {},
            Policy: {}
          }
        },
        S29: {
          type: "structure",
          members: {
            LifecyclePolicies: {
              shape: "S2a"
            }
          }
        },
        S2a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              TransitionToIA: {},
              TransitionToPrimaryStorageClass: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticfilesystem-2015-02-01.paginators.json
var require_elasticfilesystem_2015_02_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/elasticfilesystem-2015-02-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeAccessPoints: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeFileSystems: {
          input_token: "Marker",
          output_token: "NextMarker",
          limit_key: "MaxItems"
        },
        DescribeTags: {
          input_token: "Marker",
          output_token: "NextMarker",
          limit_key: "MaxItems"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/efs.js
var require_efs = __commonJS({
  "node_modules/aws-sdk/clients/efs.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["efs"] = {};
    AWS3.EFS = Service.defineService("efs", ["2015-02-01"]);
    Object.defineProperty(apiLoader.services["efs"], "2015-02-01", {
      get: function get() {
        var model = require_elasticfilesystem_2015_02_01_min();
        model.paginators = require_elasticfilesystem_2015_02_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.EFS;
  }
});

// node_modules/aws-sdk/apis/elasticache-2015-02-02.min.json
var require_elasticache_2015_02_02_min = __commonJS({
  "node_modules/aws-sdk/apis/elasticache-2015-02-02.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-02-02",
        endpointPrefix: "elasticache",
        protocol: "query",
        serviceFullName: "Amazon ElastiCache",
        serviceId: "ElastiCache",
        signatureVersion: "v4",
        uid: "elasticache-2015-02-02",
        xmlNamespace: "http://elasticache.amazonaws.com/doc/2015-02-02/"
      },
      operations: {
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "Tags"
            ],
            members: {
              ResourceName: {},
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            shape: "S5",
            resultWrapper: "AddTagsToResourceResult"
          }
        },
        AuthorizeCacheSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "CacheSecurityGroupName",
              "EC2SecurityGroupName",
              "EC2SecurityGroupOwnerId"
            ],
            members: {
              CacheSecurityGroupName: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "AuthorizeCacheSecurityGroupIngressResult",
            type: "structure",
            members: {
              CacheSecurityGroup: {
                shape: "S8"
              }
            }
          }
        },
        BatchApplyUpdateAction: {
          input: {
            type: "structure",
            required: [
              "ServiceUpdateName"
            ],
            members: {
              ReplicationGroupIds: {
                shape: "Sc"
              },
              CacheClusterIds: {
                shape: "Sd"
              },
              ServiceUpdateName: {}
            }
          },
          output: {
            shape: "Se",
            resultWrapper: "BatchApplyUpdateActionResult"
          }
        },
        BatchStopUpdateAction: {
          input: {
            type: "structure",
            required: [
              "ServiceUpdateName"
            ],
            members: {
              ReplicationGroupIds: {
                shape: "Sc"
              },
              CacheClusterIds: {
                shape: "Sd"
              },
              ServiceUpdateName: {}
            }
          },
          output: {
            shape: "Se",
            resultWrapper: "BatchStopUpdateActionResult"
          }
        },
        CompleteMigration: {
          input: {
            type: "structure",
            required: [
              "ReplicationGroupId"
            ],
            members: {
              ReplicationGroupId: {},
              Force: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CompleteMigrationResult",
            type: "structure",
            members: {
              ReplicationGroup: {
                shape: "So"
              }
            }
          }
        },
        CopySnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceSnapshotName",
              "TargetSnapshotName"
            ],
            members: {
              SourceSnapshotName: {},
              TargetSnapshotName: {},
              TargetBucket: {},
              KmsKeyId: {},
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            resultWrapper: "CopySnapshotResult",
            type: "structure",
            members: {
              Snapshot: {
                shape: "S1p"
              }
            }
          }
        },
        CreateCacheCluster: {
          input: {
            type: "structure",
            required: [
              "CacheClusterId"
            ],
            members: {
              CacheClusterId: {},
              ReplicationGroupId: {},
              AZMode: {},
              PreferredAvailabilityZone: {},
              PreferredAvailabilityZones: {
                shape: "S1y"
              },
              NumCacheNodes: {
                type: "integer"
              },
              CacheNodeType: {},
              Engine: {},
              EngineVersion: {},
              CacheParameterGroupName: {},
              CacheSubnetGroupName: {},
              CacheSecurityGroupNames: {
                shape: "S1z"
              },
              SecurityGroupIds: {
                shape: "S20"
              },
              Tags: {
                shape: "S3"
              },
              SnapshotArns: {
                shape: "S21"
              },
              SnapshotName: {},
              PreferredMaintenanceWindow: {},
              Port: {
                type: "integer"
              },
              NotificationTopicArn: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              SnapshotRetentionLimit: {
                type: "integer"
              },
              SnapshotWindow: {},
              AuthToken: {},
              OutpostMode: {},
              PreferredOutpostArn: {},
              PreferredOutpostArns: {
                shape: "S23"
              },
              LogDeliveryConfigurations: {
                shape: "S24"
              }
            }
          },
          output: {
            resultWrapper: "CreateCacheClusterResult",
            type: "structure",
            members: {
              CacheCluster: {
                shape: "S27"
              }
            }
          }
        },
        CreateCacheParameterGroup: {
          input: {
            type: "structure",
            required: [
              "CacheParameterGroupName",
              "CacheParameterGroupFamily",
              "Description"
            ],
            members: {
              CacheParameterGroupName: {},
              CacheParameterGroupFamily: {},
              Description: {},
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            resultWrapper: "CreateCacheParameterGroupResult",
            type: "structure",
            members: {
              CacheParameterGroup: {
                shape: "S2k"
              }
            }
          }
        },
        CreateCacheSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "CacheSecurityGroupName",
              "Description"
            ],
            members: {
              CacheSecurityGroupName: {},
              Description: {},
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            resultWrapper: "CreateCacheSecurityGroupResult",
            type: "structure",
            members: {
              CacheSecurityGroup: {
                shape: "S8"
              }
            }
          }
        },
        CreateCacheSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "CacheSubnetGroupName",
              "CacheSubnetGroupDescription",
              "SubnetIds"
            ],
            members: {
              CacheSubnetGroupName: {},
              CacheSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S2o"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            resultWrapper: "CreateCacheSubnetGroupResult",
            type: "structure",
            members: {
              CacheSubnetGroup: {
                shape: "S2q"
              }
            }
          }
        },
        CreateGlobalReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "GlobalReplicationGroupIdSuffix",
              "PrimaryReplicationGroupId"
            ],
            members: {
              GlobalReplicationGroupIdSuffix: {},
              GlobalReplicationGroupDescription: {},
              PrimaryReplicationGroupId: {}
            }
          },
          output: {
            resultWrapper: "CreateGlobalReplicationGroupResult",
            type: "structure",
            members: {
              GlobalReplicationGroup: {
                shape: "S2x"
              }
            }
          }
        },
        CreateReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "ReplicationGroupId",
              "ReplicationGroupDescription"
            ],
            members: {
              ReplicationGroupId: {},
              ReplicationGroupDescription: {},
              GlobalReplicationGroupId: {},
              PrimaryClusterId: {},
              AutomaticFailoverEnabled: {
                type: "boolean"
              },
              MultiAZEnabled: {
                type: "boolean"
              },
              NumCacheClusters: {
                type: "integer"
              },
              PreferredCacheClusterAZs: {
                shape: "S1u"
              },
              NumNodeGroups: {
                type: "integer"
              },
              ReplicasPerNodeGroup: {
                type: "integer"
              },
              NodeGroupConfiguration: {
                type: "list",
                member: {
                  shape: "S1s",
                  locationName: "NodeGroupConfiguration"
                }
              },
              CacheNodeType: {},
              Engine: {},
              EngineVersion: {},
              CacheParameterGroupName: {},
              CacheSubnetGroupName: {},
              CacheSecurityGroupNames: {
                shape: "S1z"
              },
              SecurityGroupIds: {
                shape: "S20"
              },
              Tags: {
                shape: "S3"
              },
              SnapshotArns: {
                shape: "S21"
              },
              SnapshotName: {},
              PreferredMaintenanceWindow: {},
              Port: {
                type: "integer"
              },
              NotificationTopicArn: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              SnapshotRetentionLimit: {
                type: "integer"
              },
              SnapshotWindow: {},
              AuthToken: {},
              TransitEncryptionEnabled: {
                type: "boolean"
              },
              AtRestEncryptionEnabled: {
                type: "boolean"
              },
              KmsKeyId: {},
              UserGroupIds: {
                type: "list",
                member: {}
              },
              LogDeliveryConfigurations: {
                shape: "S24"
              }
            }
          },
          output: {
            resultWrapper: "CreateReplicationGroupResult",
            type: "structure",
            members: {
              ReplicationGroup: {
                shape: "So"
              }
            }
          }
        },
        CreateSnapshot: {
          input: {
            type: "structure",
            required: [
              "SnapshotName"
            ],
            members: {
              ReplicationGroupId: {},
              CacheClusterId: {},
              SnapshotName: {},
              KmsKeyId: {},
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            resultWrapper: "CreateSnapshotResult",
            type: "structure",
            members: {
              Snapshot: {
                shape: "S1p"
              }
            }
          }
        },
        CreateUser: {
          input: {
            type: "structure",
            required: [
              "UserId",
              "UserName",
              "Engine",
              "AccessString"
            ],
            members: {
              UserId: {},
              UserName: {},
              Engine: {},
              Passwords: {
                shape: "S3c"
              },
              AccessString: {},
              NoPasswordRequired: {
                type: "boolean"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            shape: "S3e",
            resultWrapper: "CreateUserResult"
          }
        },
        CreateUserGroup: {
          input: {
            type: "structure",
            required: [
              "UserGroupId",
              "Engine"
            ],
            members: {
              UserGroupId: {},
              Engine: {},
              UserIds: {
                shape: "S3i"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            shape: "S3j",
            resultWrapper: "CreateUserGroupResult"
          }
        },
        DecreaseNodeGroupsInGlobalReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "GlobalReplicationGroupId",
              "NodeGroupCount",
              "ApplyImmediately"
            ],
            members: {
              GlobalReplicationGroupId: {},
              NodeGroupCount: {
                type: "integer"
              },
              GlobalNodeGroupsToRemove: {
                shape: "S3o"
              },
              GlobalNodeGroupsToRetain: {
                shape: "S3o"
              },
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DecreaseNodeGroupsInGlobalReplicationGroupResult",
            type: "structure",
            members: {
              GlobalReplicationGroup: {
                shape: "S2x"
              }
            }
          }
        },
        DecreaseReplicaCount: {
          input: {
            type: "structure",
            required: [
              "ReplicationGroupId",
              "ApplyImmediately"
            ],
            members: {
              ReplicationGroupId: {},
              NewReplicaCount: {
                type: "integer"
              },
              ReplicaConfiguration: {
                shape: "S3r"
              },
              ReplicasToRemove: {
                type: "list",
                member: {}
              },
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DecreaseReplicaCountResult",
            type: "structure",
            members: {
              ReplicationGroup: {
                shape: "So"
              }
            }
          }
        },
        DeleteCacheCluster: {
          input: {
            type: "structure",
            required: [
              "CacheClusterId"
            ],
            members: {
              CacheClusterId: {},
              FinalSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteCacheClusterResult",
            type: "structure",
            members: {
              CacheCluster: {
                shape: "S27"
              }
            }
          }
        },
        DeleteCacheParameterGroup: {
          input: {
            type: "structure",
            required: [
              "CacheParameterGroupName"
            ],
            members: {
              CacheParameterGroupName: {}
            }
          }
        },
        DeleteCacheSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "CacheSecurityGroupName"
            ],
            members: {
              CacheSecurityGroupName: {}
            }
          }
        },
        DeleteCacheSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "CacheSubnetGroupName"
            ],
            members: {
              CacheSubnetGroupName: {}
            }
          }
        },
        DeleteGlobalReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "GlobalReplicationGroupId",
              "RetainPrimaryReplicationGroup"
            ],
            members: {
              GlobalReplicationGroupId: {},
              RetainPrimaryReplicationGroup: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DeleteGlobalReplicationGroupResult",
            type: "structure",
            members: {
              GlobalReplicationGroup: {
                shape: "S2x"
              }
            }
          }
        },
        DeleteReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "ReplicationGroupId"
            ],
            members: {
              ReplicationGroupId: {},
              RetainPrimaryCluster: {
                type: "boolean"
              },
              FinalSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteReplicationGroupResult",
            type: "structure",
            members: {
              ReplicationGroup: {
                shape: "So"
              }
            }
          }
        },
        DeleteSnapshot: {
          input: {
            type: "structure",
            required: [
              "SnapshotName"
            ],
            members: {
              SnapshotName: {}
            }
          },
          output: {
            resultWrapper: "DeleteSnapshotResult",
            type: "structure",
            members: {
              Snapshot: {
                shape: "S1p"
              }
            }
          }
        },
        DeleteUser: {
          input: {
            type: "structure",
            required: [
              "UserId"
            ],
            members: {
              UserId: {}
            }
          },
          output: {
            shape: "S3e",
            resultWrapper: "DeleteUserResult"
          }
        },
        DeleteUserGroup: {
          input: {
            type: "structure",
            required: [
              "UserGroupId"
            ],
            members: {
              UserGroupId: {}
            }
          },
          output: {
            shape: "S3j",
            resultWrapper: "DeleteUserGroupResult"
          }
        },
        DescribeCacheClusters: {
          input: {
            type: "structure",
            members: {
              CacheClusterId: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              ShowCacheNodeInfo: {
                type: "boolean"
              },
              ShowCacheClustersNotInReplicationGroups: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeCacheClustersResult",
            type: "structure",
            members: {
              Marker: {},
              CacheClusters: {
                type: "list",
                member: {
                  shape: "S27",
                  locationName: "CacheCluster"
                }
              }
            }
          }
        },
        DescribeCacheEngineVersions: {
          input: {
            type: "structure",
            members: {
              Engine: {},
              EngineVersion: {},
              CacheParameterGroupFamily: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              DefaultOnly: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeCacheEngineVersionsResult",
            type: "structure",
            members: {
              Marker: {},
              CacheEngineVersions: {
                type: "list",
                member: {
                  locationName: "CacheEngineVersion",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    CacheParameterGroupFamily: {},
                    CacheEngineDescription: {},
                    CacheEngineVersionDescription: {}
                  }
                }
              }
            }
          }
        },
        DescribeCacheParameterGroups: {
          input: {
            type: "structure",
            members: {
              CacheParameterGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeCacheParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              CacheParameterGroups: {
                type: "list",
                member: {
                  shape: "S2k",
                  locationName: "CacheParameterGroup"
                }
              }
            }
          }
        },
        DescribeCacheParameters: {
          input: {
            type: "structure",
            required: [
              "CacheParameterGroupName"
            ],
            members: {
              CacheParameterGroupName: {},
              Source: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeCacheParametersResult",
            type: "structure",
            members: {
              Marker: {},
              Parameters: {
                shape: "S4k"
              },
              CacheNodeTypeSpecificParameters: {
                shape: "S4n"
              }
            }
          }
        },
        DescribeCacheSecurityGroups: {
          input: {
            type: "structure",
            members: {
              CacheSecurityGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeCacheSecurityGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              CacheSecurityGroups: {
                type: "list",
                member: {
                  shape: "S8",
                  locationName: "CacheSecurityGroup"
                }
              }
            }
          }
        },
        DescribeCacheSubnetGroups: {
          input: {
            type: "structure",
            members: {
              CacheSubnetGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeCacheSubnetGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              CacheSubnetGroups: {
                type: "list",
                member: {
                  shape: "S2q",
                  locationName: "CacheSubnetGroup"
                }
              }
            }
          }
        },
        DescribeEngineDefaultParameters: {
          input: {
            type: "structure",
            required: [
              "CacheParameterGroupFamily"
            ],
            members: {
              CacheParameterGroupFamily: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEngineDefaultParametersResult",
            type: "structure",
            members: {
              EngineDefaults: {
                type: "structure",
                members: {
                  CacheParameterGroupFamily: {},
                  Marker: {},
                  Parameters: {
                    shape: "S4k"
                  },
                  CacheNodeTypeSpecificParameters: {
                    shape: "S4n"
                  }
                },
                wrapper: true
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceIdentifier: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventsResult",
            type: "structure",
            members: {
              Marker: {},
              Events: {
                type: "list",
                member: {
                  locationName: "Event",
                  type: "structure",
                  members: {
                    SourceIdentifier: {},
                    SourceType: {},
                    Message: {},
                    Date: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeGlobalReplicationGroups: {
          input: {
            type: "structure",
            members: {
              GlobalReplicationGroupId: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              ShowMemberInfo: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeGlobalReplicationGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              GlobalReplicationGroups: {
                type: "list",
                member: {
                  shape: "S2x",
                  locationName: "GlobalReplicationGroup"
                }
              }
            }
          }
        },
        DescribeReplicationGroups: {
          input: {
            type: "structure",
            members: {
              ReplicationGroupId: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReplicationGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              ReplicationGroups: {
                type: "list",
                member: {
                  shape: "So",
                  locationName: "ReplicationGroup"
                }
              }
            }
          }
        },
        DescribeReservedCacheNodes: {
          input: {
            type: "structure",
            members: {
              ReservedCacheNodeId: {},
              ReservedCacheNodesOfferingId: {},
              CacheNodeType: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedCacheNodesResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedCacheNodes: {
                type: "list",
                member: {
                  shape: "S5e",
                  locationName: "ReservedCacheNode"
                }
              }
            }
          }
        },
        DescribeReservedCacheNodesOfferings: {
          input: {
            type: "structure",
            members: {
              ReservedCacheNodesOfferingId: {},
              CacheNodeType: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedCacheNodesOfferingsResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedCacheNodesOfferings: {
                type: "list",
                member: {
                  locationName: "ReservedCacheNodesOffering",
                  type: "structure",
                  members: {
                    ReservedCacheNodesOfferingId: {},
                    CacheNodeType: {},
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    UsagePrice: {
                      type: "double"
                    },
                    ProductDescription: {},
                    OfferingType: {},
                    RecurringCharges: {
                      shape: "S5f"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeServiceUpdates: {
          input: {
            type: "structure",
            members: {
              ServiceUpdateName: {},
              ServiceUpdateStatus: {
                shape: "S5m"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeServiceUpdatesResult",
            type: "structure",
            members: {
              Marker: {},
              ServiceUpdates: {
                type: "list",
                member: {
                  locationName: "ServiceUpdate",
                  type: "structure",
                  members: {
                    ServiceUpdateName: {},
                    ServiceUpdateReleaseDate: {
                      type: "timestamp"
                    },
                    ServiceUpdateEndDate: {
                      type: "timestamp"
                    },
                    ServiceUpdateSeverity: {},
                    ServiceUpdateRecommendedApplyByDate: {
                      type: "timestamp"
                    },
                    ServiceUpdateStatus: {},
                    ServiceUpdateDescription: {},
                    ServiceUpdateType: {},
                    Engine: {},
                    EngineVersion: {},
                    AutoUpdateAfterRecommendedApplyByDate: {
                      type: "boolean"
                    },
                    EstimatedUpdateTime: {}
                  }
                }
              }
            }
          }
        },
        DescribeSnapshots: {
          input: {
            type: "structure",
            members: {
              ReplicationGroupId: {},
              CacheClusterId: {},
              SnapshotName: {},
              SnapshotSource: {},
              Marker: {},
              MaxRecords: {
                type: "integer"
              },
              ShowNodeGroupConfig: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeSnapshotsResult",
            type: "structure",
            members: {
              Marker: {},
              Snapshots: {
                type: "list",
                member: {
                  shape: "S1p",
                  locationName: "Snapshot"
                }
              }
            }
          }
        },
        DescribeUpdateActions: {
          input: {
            type: "structure",
            members: {
              ServiceUpdateName: {},
              ReplicationGroupIds: {
                shape: "Sc"
              },
              CacheClusterIds: {
                shape: "Sd"
              },
              Engine: {},
              ServiceUpdateStatus: {
                shape: "S5m"
              },
              ServiceUpdateTimeRange: {
                type: "structure",
                members: {
                  StartTime: {
                    type: "timestamp"
                  },
                  EndTime: {
                    type: "timestamp"
                  }
                }
              },
              UpdateActionStatus: {
                type: "list",
                member: {}
              },
              ShowNodeLevelUpdateStatus: {
                type: "boolean"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeUpdateActionsResult",
            type: "structure",
            members: {
              Marker: {},
              UpdateActions: {
                type: "list",
                member: {
                  locationName: "UpdateAction",
                  type: "structure",
                  members: {
                    ReplicationGroupId: {},
                    CacheClusterId: {},
                    ServiceUpdateName: {},
                    ServiceUpdateReleaseDate: {
                      type: "timestamp"
                    },
                    ServiceUpdateSeverity: {},
                    ServiceUpdateStatus: {},
                    ServiceUpdateRecommendedApplyByDate: {
                      type: "timestamp"
                    },
                    ServiceUpdateType: {},
                    UpdateActionAvailableDate: {
                      type: "timestamp"
                    },
                    UpdateActionStatus: {},
                    NodesUpdated: {},
                    UpdateActionStatusModifiedDate: {
                      type: "timestamp"
                    },
                    SlaMet: {},
                    NodeGroupUpdateStatus: {
                      type: "list",
                      member: {
                        locationName: "NodeGroupUpdateStatus",
                        type: "structure",
                        members: {
                          NodeGroupId: {},
                          NodeGroupMemberUpdateStatus: {
                            type: "list",
                            member: {
                              locationName: "NodeGroupMemberUpdateStatus",
                              type: "structure",
                              members: {
                                CacheClusterId: {},
                                CacheNodeId: {},
                                NodeUpdateStatus: {},
                                NodeDeletionDate: {
                                  type: "timestamp"
                                },
                                NodeUpdateStartDate: {
                                  type: "timestamp"
                                },
                                NodeUpdateEndDate: {
                                  type: "timestamp"
                                },
                                NodeUpdateInitiatedBy: {},
                                NodeUpdateInitiatedDate: {
                                  type: "timestamp"
                                },
                                NodeUpdateStatusModifiedDate: {
                                  type: "timestamp"
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    CacheNodeUpdateStatus: {
                      type: "list",
                      member: {
                        locationName: "CacheNodeUpdateStatus",
                        type: "structure",
                        members: {
                          CacheNodeId: {},
                          NodeUpdateStatus: {},
                          NodeDeletionDate: {
                            type: "timestamp"
                          },
                          NodeUpdateStartDate: {
                            type: "timestamp"
                          },
                          NodeUpdateEndDate: {
                            type: "timestamp"
                          },
                          NodeUpdateInitiatedBy: {},
                          NodeUpdateInitiatedDate: {
                            type: "timestamp"
                          },
                          NodeUpdateStatusModifiedDate: {
                            type: "timestamp"
                          }
                        }
                      }
                    },
                    EstimatedUpdateTime: {},
                    Engine: {}
                  }
                }
              }
            }
          }
        },
        DescribeUserGroups: {
          input: {
            type: "structure",
            members: {
              UserGroupId: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeUserGroupsResult",
            type: "structure",
            members: {
              UserGroups: {
                type: "list",
                member: {
                  shape: "S3j"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeUsers: {
          input: {
            type: "structure",
            members: {
              Engine: {},
              UserId: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeUsersResult",
            type: "structure",
            members: {
              Users: {
                type: "list",
                member: {
                  shape: "S3e"
                }
              },
              Marker: {}
            }
          }
        },
        DisassociateGlobalReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "GlobalReplicationGroupId",
              "ReplicationGroupId",
              "ReplicationGroupRegion"
            ],
            members: {
              GlobalReplicationGroupId: {},
              ReplicationGroupId: {},
              ReplicationGroupRegion: {}
            }
          },
          output: {
            resultWrapper: "DisassociateGlobalReplicationGroupResult",
            type: "structure",
            members: {
              GlobalReplicationGroup: {
                shape: "S2x"
              }
            }
          }
        },
        FailoverGlobalReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "GlobalReplicationGroupId",
              "PrimaryRegion",
              "PrimaryReplicationGroupId"
            ],
            members: {
              GlobalReplicationGroupId: {},
              PrimaryRegion: {},
              PrimaryReplicationGroupId: {}
            }
          },
          output: {
            resultWrapper: "FailoverGlobalReplicationGroupResult",
            type: "structure",
            members: {
              GlobalReplicationGroup: {
                shape: "S2x"
              }
            }
          }
        },
        IncreaseNodeGroupsInGlobalReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "GlobalReplicationGroupId",
              "NodeGroupCount",
              "ApplyImmediately"
            ],
            members: {
              GlobalReplicationGroupId: {},
              NodeGroupCount: {
                type: "integer"
              },
              RegionalConfigurations: {
                type: "list",
                member: {
                  locationName: "RegionalConfiguration",
                  type: "structure",
                  required: [
                    "ReplicationGroupId",
                    "ReplicationGroupRegion",
                    "ReshardingConfiguration"
                  ],
                  members: {
                    ReplicationGroupId: {},
                    ReplicationGroupRegion: {},
                    ReshardingConfiguration: {
                      shape: "S6t"
                    }
                  }
                }
              },
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "IncreaseNodeGroupsInGlobalReplicationGroupResult",
            type: "structure",
            members: {
              GlobalReplicationGroup: {
                shape: "S2x"
              }
            }
          }
        },
        IncreaseReplicaCount: {
          input: {
            type: "structure",
            required: [
              "ReplicationGroupId",
              "ApplyImmediately"
            ],
            members: {
              ReplicationGroupId: {},
              NewReplicaCount: {
                type: "integer"
              },
              ReplicaConfiguration: {
                shape: "S3r"
              },
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "IncreaseReplicaCountResult",
            type: "structure",
            members: {
              ReplicationGroup: {
                shape: "So"
              }
            }
          }
        },
        ListAllowedNodeTypeModifications: {
          input: {
            type: "structure",
            members: {
              CacheClusterId: {},
              ReplicationGroupId: {}
            }
          },
          output: {
            resultWrapper: "ListAllowedNodeTypeModificationsResult",
            type: "structure",
            members: {
              ScaleUpModifications: {
                shape: "S70"
              },
              ScaleDownModifications: {
                shape: "S70"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName"
            ],
            members: {
              ResourceName: {}
            }
          },
          output: {
            shape: "S5",
            resultWrapper: "ListTagsForResourceResult"
          }
        },
        ModifyCacheCluster: {
          input: {
            type: "structure",
            required: [
              "CacheClusterId"
            ],
            members: {
              CacheClusterId: {},
              NumCacheNodes: {
                type: "integer"
              },
              CacheNodeIdsToRemove: {
                shape: "S29"
              },
              AZMode: {},
              NewAvailabilityZones: {
                shape: "S1y"
              },
              CacheSecurityGroupNames: {
                shape: "S1z"
              },
              SecurityGroupIds: {
                shape: "S20"
              },
              PreferredMaintenanceWindow: {},
              NotificationTopicArn: {},
              CacheParameterGroupName: {},
              NotificationTopicStatus: {},
              ApplyImmediately: {
                type: "boolean"
              },
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              SnapshotRetentionLimit: {
                type: "integer"
              },
              SnapshotWindow: {},
              CacheNodeType: {},
              AuthToken: {},
              AuthTokenUpdateStrategy: {},
              LogDeliveryConfigurations: {
                shape: "S24"
              }
            }
          },
          output: {
            resultWrapper: "ModifyCacheClusterResult",
            type: "structure",
            members: {
              CacheCluster: {
                shape: "S27"
              }
            }
          }
        },
        ModifyCacheParameterGroup: {
          input: {
            type: "structure",
            required: [
              "CacheParameterGroupName",
              "ParameterNameValues"
            ],
            members: {
              CacheParameterGroupName: {},
              ParameterNameValues: {
                shape: "S76"
              }
            }
          },
          output: {
            shape: "S78",
            resultWrapper: "ModifyCacheParameterGroupResult"
          }
        },
        ModifyCacheSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "CacheSubnetGroupName"
            ],
            members: {
              CacheSubnetGroupName: {},
              CacheSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S2o"
              }
            }
          },
          output: {
            resultWrapper: "ModifyCacheSubnetGroupResult",
            type: "structure",
            members: {
              CacheSubnetGroup: {
                shape: "S2q"
              }
            }
          }
        },
        ModifyGlobalReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "GlobalReplicationGroupId",
              "ApplyImmediately"
            ],
            members: {
              GlobalReplicationGroupId: {},
              ApplyImmediately: {
                type: "boolean"
              },
              CacheNodeType: {},
              EngineVersion: {},
              CacheParameterGroupName: {},
              GlobalReplicationGroupDescription: {},
              AutomaticFailoverEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyGlobalReplicationGroupResult",
            type: "structure",
            members: {
              GlobalReplicationGroup: {
                shape: "S2x"
              }
            }
          }
        },
        ModifyReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "ReplicationGroupId"
            ],
            members: {
              ReplicationGroupId: {},
              ReplicationGroupDescription: {},
              PrimaryClusterId: {},
              SnapshottingClusterId: {},
              AutomaticFailoverEnabled: {
                type: "boolean"
              },
              MultiAZEnabled: {
                type: "boolean"
              },
              NodeGroupId: {
                deprecated: true
              },
              CacheSecurityGroupNames: {
                shape: "S1z"
              },
              SecurityGroupIds: {
                shape: "S20"
              },
              PreferredMaintenanceWindow: {},
              NotificationTopicArn: {},
              CacheParameterGroupName: {},
              NotificationTopicStatus: {},
              ApplyImmediately: {
                type: "boolean"
              },
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              SnapshotRetentionLimit: {
                type: "integer"
              },
              SnapshotWindow: {},
              CacheNodeType: {},
              AuthToken: {},
              AuthTokenUpdateStrategy: {},
              UserGroupIdsToAdd: {
                shape: "Sx"
              },
              UserGroupIdsToRemove: {
                shape: "Sx"
              },
              RemoveUserGroups: {
                type: "boolean"
              },
              LogDeliveryConfigurations: {
                shape: "S24"
              }
            }
          },
          output: {
            resultWrapper: "ModifyReplicationGroupResult",
            type: "structure",
            members: {
              ReplicationGroup: {
                shape: "So"
              }
            }
          }
        },
        ModifyReplicationGroupShardConfiguration: {
          input: {
            type: "structure",
            required: [
              "ReplicationGroupId",
              "NodeGroupCount",
              "ApplyImmediately"
            ],
            members: {
              ReplicationGroupId: {},
              NodeGroupCount: {
                type: "integer"
              },
              ApplyImmediately: {
                type: "boolean"
              },
              ReshardingConfiguration: {
                shape: "S6t"
              },
              NodeGroupsToRemove: {
                type: "list",
                member: {
                  locationName: "NodeGroupToRemove"
                }
              },
              NodeGroupsToRetain: {
                type: "list",
                member: {
                  locationName: "NodeGroupToRetain"
                }
              }
            }
          },
          output: {
            resultWrapper: "ModifyReplicationGroupShardConfigurationResult",
            type: "structure",
            members: {
              ReplicationGroup: {
                shape: "So"
              }
            }
          }
        },
        ModifyUser: {
          input: {
            type: "structure",
            required: [
              "UserId"
            ],
            members: {
              UserId: {},
              AccessString: {},
              AppendAccessString: {},
              Passwords: {
                shape: "S3c"
              },
              NoPasswordRequired: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S3e",
            resultWrapper: "ModifyUserResult"
          }
        },
        ModifyUserGroup: {
          input: {
            type: "structure",
            required: [
              "UserGroupId"
            ],
            members: {
              UserGroupId: {},
              UserIdsToAdd: {
                shape: "S3i"
              },
              UserIdsToRemove: {
                shape: "S3i"
              }
            }
          },
          output: {
            shape: "S3j",
            resultWrapper: "ModifyUserGroupResult"
          }
        },
        PurchaseReservedCacheNodesOffering: {
          input: {
            type: "structure",
            required: [
              "ReservedCacheNodesOfferingId"
            ],
            members: {
              ReservedCacheNodesOfferingId: {},
              ReservedCacheNodeId: {},
              CacheNodeCount: {
                type: "integer"
              },
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            resultWrapper: "PurchaseReservedCacheNodesOfferingResult",
            type: "structure",
            members: {
              ReservedCacheNode: {
                shape: "S5e"
              }
            }
          }
        },
        RebalanceSlotsInGlobalReplicationGroup: {
          input: {
            type: "structure",
            required: [
              "GlobalReplicationGroupId",
              "ApplyImmediately"
            ],
            members: {
              GlobalReplicationGroupId: {},
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RebalanceSlotsInGlobalReplicationGroupResult",
            type: "structure",
            members: {
              GlobalReplicationGroup: {
                shape: "S2x"
              }
            }
          }
        },
        RebootCacheCluster: {
          input: {
            type: "structure",
            required: [
              "CacheClusterId",
              "CacheNodeIdsToReboot"
            ],
            members: {
              CacheClusterId: {},
              CacheNodeIdsToReboot: {
                shape: "S29"
              }
            }
          },
          output: {
            resultWrapper: "RebootCacheClusterResult",
            type: "structure",
            members: {
              CacheCluster: {
                shape: "S27"
              }
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "TagKeys"
            ],
            members: {
              ResourceName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            shape: "S5",
            resultWrapper: "RemoveTagsFromResourceResult"
          }
        },
        ResetCacheParameterGroup: {
          input: {
            type: "structure",
            required: [
              "CacheParameterGroupName"
            ],
            members: {
              CacheParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              ParameterNameValues: {
                shape: "S76"
              }
            }
          },
          output: {
            shape: "S78",
            resultWrapper: "ResetCacheParameterGroupResult"
          }
        },
        RevokeCacheSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "CacheSecurityGroupName",
              "EC2SecurityGroupName",
              "EC2SecurityGroupOwnerId"
            ],
            members: {
              CacheSecurityGroupName: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "RevokeCacheSecurityGroupIngressResult",
            type: "structure",
            members: {
              CacheSecurityGroup: {
                shape: "S8"
              }
            }
          }
        },
        StartMigration: {
          input: {
            type: "structure",
            required: [
              "ReplicationGroupId",
              "CustomerNodeEndpointList"
            ],
            members: {
              ReplicationGroupId: {},
              CustomerNodeEndpointList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Address: {},
                    Port: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          },
          output: {
            resultWrapper: "StartMigrationResult",
            type: "structure",
            members: {
              ReplicationGroup: {
                shape: "So"
              }
            }
          }
        },
        TestFailover: {
          input: {
            type: "structure",
            required: [
              "ReplicationGroupId",
              "NodeGroupId"
            ],
            members: {
              ReplicationGroupId: {},
              NodeGroupId: {}
            }
          },
          output: {
            resultWrapper: "TestFailoverResult",
            type: "structure",
            members: {
              ReplicationGroup: {
                shape: "So"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S5: {
          type: "structure",
          members: {
            TagList: {
              shape: "S3"
            }
          }
        },
        S8: {
          type: "structure",
          members: {
            OwnerId: {},
            CacheSecurityGroupName: {},
            Description: {},
            EC2SecurityGroups: {
              type: "list",
              member: {
                locationName: "EC2SecurityGroup",
                type: "structure",
                members: {
                  Status: {},
                  EC2SecurityGroupName: {},
                  EC2SecurityGroupOwnerId: {}
                }
              }
            },
            ARN: {}
          },
          wrapper: true
        },
        Sc: {
          type: "list",
          member: {}
        },
        Sd: {
          type: "list",
          member: {}
        },
        Se: {
          type: "structure",
          members: {
            ProcessedUpdateActions: {
              type: "list",
              member: {
                locationName: "ProcessedUpdateAction",
                type: "structure",
                members: {
                  ReplicationGroupId: {},
                  CacheClusterId: {},
                  ServiceUpdateName: {},
                  UpdateActionStatus: {}
                }
              }
            },
            UnprocessedUpdateActions: {
              type: "list",
              member: {
                locationName: "UnprocessedUpdateAction",
                type: "structure",
                members: {
                  ReplicationGroupId: {},
                  CacheClusterId: {},
                  ServiceUpdateName: {},
                  ErrorType: {},
                  ErrorMessage: {}
                }
              }
            }
          }
        },
        So: {
          type: "structure",
          members: {
            ReplicationGroupId: {},
            Description: {},
            GlobalReplicationGroupInfo: {
              type: "structure",
              members: {
                GlobalReplicationGroupId: {},
                GlobalReplicationGroupMemberRole: {}
              }
            },
            Status: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                PrimaryClusterId: {},
                AutomaticFailoverStatus: {},
                Resharding: {
                  type: "structure",
                  members: {
                    SlotMigration: {
                      type: "structure",
                      members: {
                        ProgressPercentage: {
                          type: "double"
                        }
                      }
                    }
                  }
                },
                AuthTokenStatus: {},
                UserGroups: {
                  type: "structure",
                  members: {
                    UserGroupIdsToAdd: {
                      shape: "Sx"
                    },
                    UserGroupIdsToRemove: {
                      shape: "Sx"
                    }
                  }
                },
                LogDeliveryConfigurations: {
                  shape: "Sz"
                }
              }
            },
            MemberClusters: {
              type: "list",
              member: {
                locationName: "ClusterId"
              }
            },
            NodeGroups: {
              type: "list",
              member: {
                locationName: "NodeGroup",
                type: "structure",
                members: {
                  NodeGroupId: {},
                  Status: {},
                  PrimaryEndpoint: {
                    shape: "S1a"
                  },
                  ReaderEndpoint: {
                    shape: "S1a"
                  },
                  Slots: {},
                  NodeGroupMembers: {
                    type: "list",
                    member: {
                      locationName: "NodeGroupMember",
                      type: "structure",
                      members: {
                        CacheClusterId: {},
                        CacheNodeId: {},
                        ReadEndpoint: {
                          shape: "S1a"
                        },
                        PreferredAvailabilityZone: {},
                        PreferredOutpostArn: {},
                        CurrentRole: {}
                      }
                    }
                  }
                }
              }
            },
            SnapshottingClusterId: {},
            AutomaticFailover: {},
            MultiAZ: {},
            ConfigurationEndpoint: {
              shape: "S1a"
            },
            SnapshotRetentionLimit: {
              type: "integer"
            },
            SnapshotWindow: {},
            ClusterEnabled: {
              type: "boolean"
            },
            CacheNodeType: {},
            AuthTokenEnabled: {
              type: "boolean"
            },
            AuthTokenLastModifiedDate: {
              type: "timestamp"
            },
            TransitEncryptionEnabled: {
              type: "boolean"
            },
            AtRestEncryptionEnabled: {
              type: "boolean"
            },
            MemberClustersOutpostArns: {
              type: "list",
              member: {
                locationName: "ReplicationGroupOutpostArn"
              }
            },
            KmsKeyId: {},
            ARN: {},
            UserGroupIds: {
              shape: "Sx"
            },
            LogDeliveryConfigurations: {
              shape: "S1k"
            },
            ReplicationGroupCreateTime: {
              type: "timestamp"
            }
          },
          wrapper: true
        },
        Sx: {
          type: "list",
          member: {}
        },
        Sz: {
          type: "list",
          member: {
            type: "structure",
            members: {
              LogType: {},
              DestinationType: {},
              DestinationDetails: {
                shape: "S13"
              },
              LogFormat: {}
            }
          },
          locationName: "PendingLogDeliveryConfiguration"
        },
        S13: {
          type: "structure",
          members: {
            CloudWatchLogsDetails: {
              type: "structure",
              members: {
                LogGroup: {}
              }
            },
            KinesisFirehoseDetails: {
              type: "structure",
              members: {
                DeliveryStream: {}
              }
            }
          }
        },
        S1a: {
          type: "structure",
          members: {
            Address: {},
            Port: {
              type: "integer"
            }
          }
        },
        S1k: {
          type: "list",
          member: {
            locationName: "LogDeliveryConfiguration",
            type: "structure",
            members: {
              LogType: {},
              DestinationType: {},
              DestinationDetails: {
                shape: "S13"
              },
              LogFormat: {},
              Status: {},
              Message: {}
            }
          }
        },
        S1p: {
          type: "structure",
          members: {
            SnapshotName: {},
            ReplicationGroupId: {},
            ReplicationGroupDescription: {},
            CacheClusterId: {},
            SnapshotStatus: {},
            SnapshotSource: {},
            CacheNodeType: {},
            Engine: {},
            EngineVersion: {},
            NumCacheNodes: {
              type: "integer"
            },
            PreferredAvailabilityZone: {},
            PreferredOutpostArn: {},
            CacheClusterCreateTime: {
              type: "timestamp"
            },
            PreferredMaintenanceWindow: {},
            TopicArn: {},
            Port: {
              type: "integer"
            },
            CacheParameterGroupName: {},
            CacheSubnetGroupName: {},
            VpcId: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            SnapshotRetentionLimit: {
              type: "integer"
            },
            SnapshotWindow: {},
            NumNodeGroups: {
              type: "integer"
            },
            AutomaticFailover: {},
            NodeSnapshots: {
              type: "list",
              member: {
                locationName: "NodeSnapshot",
                type: "structure",
                members: {
                  CacheClusterId: {},
                  NodeGroupId: {},
                  CacheNodeId: {},
                  NodeGroupConfiguration: {
                    shape: "S1s"
                  },
                  CacheSize: {},
                  CacheNodeCreateTime: {
                    type: "timestamp"
                  },
                  SnapshotCreateTime: {
                    type: "timestamp"
                  }
                },
                wrapper: true
              }
            },
            KmsKeyId: {},
            ARN: {}
          },
          wrapper: true
        },
        S1s: {
          type: "structure",
          members: {
            NodeGroupId: {},
            Slots: {},
            ReplicaCount: {
              type: "integer"
            },
            PrimaryAvailabilityZone: {},
            ReplicaAvailabilityZones: {
              shape: "S1u"
            },
            PrimaryOutpostArn: {},
            ReplicaOutpostArns: {
              type: "list",
              member: {
                locationName: "OutpostArn"
              }
            }
          }
        },
        S1u: {
          type: "list",
          member: {
            locationName: "AvailabilityZone"
          }
        },
        S1y: {
          type: "list",
          member: {
            locationName: "PreferredAvailabilityZone"
          }
        },
        S1z: {
          type: "list",
          member: {
            locationName: "CacheSecurityGroupName"
          }
        },
        S20: {
          type: "list",
          member: {
            locationName: "SecurityGroupId"
          }
        },
        S21: {
          type: "list",
          member: {
            locationName: "SnapshotArn"
          }
        },
        S23: {
          type: "list",
          member: {
            locationName: "PreferredOutpostArn"
          }
        },
        S24: {
          type: "list",
          member: {
            locationName: "LogDeliveryConfigurationRequest",
            type: "structure",
            members: {
              LogType: {},
              DestinationType: {},
              DestinationDetails: {
                shape: "S13"
              },
              LogFormat: {},
              Enabled: {
                type: "boolean"
              }
            }
          }
        },
        S27: {
          type: "structure",
          members: {
            CacheClusterId: {},
            ConfigurationEndpoint: {
              shape: "S1a"
            },
            ClientDownloadLandingPage: {},
            CacheNodeType: {},
            Engine: {},
            EngineVersion: {},
            CacheClusterStatus: {},
            NumCacheNodes: {
              type: "integer"
            },
            PreferredAvailabilityZone: {},
            PreferredOutpostArn: {},
            CacheClusterCreateTime: {
              type: "timestamp"
            },
            PreferredMaintenanceWindow: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                NumCacheNodes: {
                  type: "integer"
                },
                CacheNodeIdsToRemove: {
                  shape: "S29"
                },
                EngineVersion: {},
                CacheNodeType: {},
                AuthTokenStatus: {},
                LogDeliveryConfigurations: {
                  shape: "Sz"
                }
              }
            },
            NotificationConfiguration: {
              type: "structure",
              members: {
                TopicArn: {},
                TopicStatus: {}
              }
            },
            CacheSecurityGroups: {
              type: "list",
              member: {
                locationName: "CacheSecurityGroup",
                type: "structure",
                members: {
                  CacheSecurityGroupName: {},
                  Status: {}
                }
              }
            },
            CacheParameterGroup: {
              type: "structure",
              members: {
                CacheParameterGroupName: {},
                ParameterApplyStatus: {},
                CacheNodeIdsToReboot: {
                  shape: "S29"
                }
              }
            },
            CacheSubnetGroupName: {},
            CacheNodes: {
              type: "list",
              member: {
                locationName: "CacheNode",
                type: "structure",
                members: {
                  CacheNodeId: {},
                  CacheNodeStatus: {},
                  CacheNodeCreateTime: {
                    type: "timestamp"
                  },
                  Endpoint: {
                    shape: "S1a"
                  },
                  ParameterGroupStatus: {},
                  SourceCacheNodeId: {},
                  CustomerAvailabilityZone: {},
                  CustomerOutpostArn: {}
                }
              }
            },
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            SecurityGroups: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  SecurityGroupId: {},
                  Status: {}
                }
              }
            },
            ReplicationGroupId: {},
            SnapshotRetentionLimit: {
              type: "integer"
            },
            SnapshotWindow: {},
            AuthTokenEnabled: {
              type: "boolean"
            },
            AuthTokenLastModifiedDate: {
              type: "timestamp"
            },
            TransitEncryptionEnabled: {
              type: "boolean"
            },
            AtRestEncryptionEnabled: {
              type: "boolean"
            },
            ARN: {},
            ReplicationGroupLogDeliveryEnabled: {
              type: "boolean"
            },
            LogDeliveryConfigurations: {
              shape: "S1k"
            }
          },
          wrapper: true
        },
        S29: {
          type: "list",
          member: {
            locationName: "CacheNodeId"
          }
        },
        S2k: {
          type: "structure",
          members: {
            CacheParameterGroupName: {},
            CacheParameterGroupFamily: {},
            Description: {},
            IsGlobal: {
              type: "boolean"
            },
            ARN: {}
          },
          wrapper: true
        },
        S2o: {
          type: "list",
          member: {
            locationName: "SubnetIdentifier"
          }
        },
        S2q: {
          type: "structure",
          members: {
            CacheSubnetGroupName: {},
            CacheSubnetGroupDescription: {},
            VpcId: {},
            Subnets: {
              type: "list",
              member: {
                locationName: "Subnet",
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {
                    type: "structure",
                    members: {
                      Name: {}
                    },
                    wrapper: true
                  },
                  SubnetOutpost: {
                    type: "structure",
                    members: {
                      SubnetOutpostArn: {}
                    }
                  }
                }
              }
            },
            ARN: {}
          },
          wrapper: true
        },
        S2x: {
          type: "structure",
          members: {
            GlobalReplicationGroupId: {},
            GlobalReplicationGroupDescription: {},
            Status: {},
            CacheNodeType: {},
            Engine: {},
            EngineVersion: {},
            Members: {
              type: "list",
              member: {
                locationName: "GlobalReplicationGroupMember",
                type: "structure",
                members: {
                  ReplicationGroupId: {},
                  ReplicationGroupRegion: {},
                  Role: {},
                  AutomaticFailover: {},
                  Status: {}
                },
                wrapper: true
              }
            },
            ClusterEnabled: {
              type: "boolean"
            },
            GlobalNodeGroups: {
              type: "list",
              member: {
                locationName: "GlobalNodeGroup",
                type: "structure",
                members: {
                  GlobalNodeGroupId: {},
                  Slots: {}
                }
              }
            },
            AuthTokenEnabled: {
              type: "boolean"
            },
            TransitEncryptionEnabled: {
              type: "boolean"
            },
            AtRestEncryptionEnabled: {
              type: "boolean"
            },
            ARN: {}
          },
          wrapper: true
        },
        S3c: {
          type: "list",
          member: {}
        },
        S3e: {
          type: "structure",
          members: {
            UserId: {},
            UserName: {},
            Status: {},
            Engine: {},
            AccessString: {},
            UserGroupIds: {
              shape: "Sx"
            },
            Authentication: {
              type: "structure",
              members: {
                Type: {},
                PasswordCount: {
                  type: "integer"
                }
              }
            },
            ARN: {}
          }
        },
        S3i: {
          type: "list",
          member: {}
        },
        S3j: {
          type: "structure",
          members: {
            UserGroupId: {},
            Status: {},
            Engine: {},
            UserIds: {
              shape: "S3k"
            },
            PendingChanges: {
              type: "structure",
              members: {
                UserIdsToRemove: {
                  shape: "S3k"
                },
                UserIdsToAdd: {
                  shape: "S3k"
                }
              }
            },
            ReplicationGroups: {
              type: "list",
              member: {}
            },
            ARN: {}
          }
        },
        S3k: {
          type: "list",
          member: {}
        },
        S3o: {
          type: "list",
          member: {
            locationName: "GlobalNodeGroupId"
          }
        },
        S3r: {
          type: "list",
          member: {
            locationName: "ConfigureShard",
            type: "structure",
            required: [
              "NodeGroupId",
              "NewReplicaCount"
            ],
            members: {
              NodeGroupId: {},
              NewReplicaCount: {
                type: "integer"
              },
              PreferredAvailabilityZones: {
                shape: "S1y"
              },
              PreferredOutpostArns: {
                shape: "S23"
              }
            }
          }
        },
        S4k: {
          type: "list",
          member: {
            locationName: "Parameter",
            type: "structure",
            members: {
              ParameterName: {},
              ParameterValue: {},
              Description: {},
              Source: {},
              DataType: {},
              AllowedValues: {},
              IsModifiable: {
                type: "boolean"
              },
              MinimumEngineVersion: {},
              ChangeType: {}
            }
          }
        },
        S4n: {
          type: "list",
          member: {
            locationName: "CacheNodeTypeSpecificParameter",
            type: "structure",
            members: {
              ParameterName: {},
              Description: {},
              Source: {},
              DataType: {},
              AllowedValues: {},
              IsModifiable: {
                type: "boolean"
              },
              MinimumEngineVersion: {},
              CacheNodeTypeSpecificValues: {
                type: "list",
                member: {
                  locationName: "CacheNodeTypeSpecificValue",
                  type: "structure",
                  members: {
                    CacheNodeType: {},
                    Value: {}
                  }
                }
              },
              ChangeType: {}
            }
          }
        },
        S5e: {
          type: "structure",
          members: {
            ReservedCacheNodeId: {},
            ReservedCacheNodesOfferingId: {},
            CacheNodeType: {},
            StartTime: {
              type: "timestamp"
            },
            Duration: {
              type: "integer"
            },
            FixedPrice: {
              type: "double"
            },
            UsagePrice: {
              type: "double"
            },
            CacheNodeCount: {
              type: "integer"
            },
            ProductDescription: {},
            OfferingType: {},
            State: {},
            RecurringCharges: {
              shape: "S5f"
            },
            ReservationARN: {}
          },
          wrapper: true
        },
        S5f: {
          type: "list",
          member: {
            locationName: "RecurringCharge",
            type: "structure",
            members: {
              RecurringChargeAmount: {
                type: "double"
              },
              RecurringChargeFrequency: {}
            },
            wrapper: true
          }
        },
        S5m: {
          type: "list",
          member: {}
        },
        S6t: {
          type: "list",
          member: {
            locationName: "ReshardingConfiguration",
            type: "structure",
            members: {
              NodeGroupId: {},
              PreferredAvailabilityZones: {
                shape: "S1u"
              }
            }
          }
        },
        S70: {
          type: "list",
          member: {}
        },
        S76: {
          type: "list",
          member: {
            locationName: "ParameterNameValue",
            type: "structure",
            members: {
              ParameterName: {},
              ParameterValue: {}
            }
          }
        },
        S78: {
          type: "structure",
          members: {
            CacheParameterGroupName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticache-2015-02-02.paginators.json
var require_elasticache_2015_02_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/elasticache-2015-02-02.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeCacheClusters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "CacheClusters"
        },
        DescribeCacheEngineVersions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "CacheEngineVersions"
        },
        DescribeCacheParameterGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "CacheParameterGroups"
        },
        DescribeCacheParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Parameters"
        },
        DescribeCacheSecurityGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "CacheSecurityGroups"
        },
        DescribeCacheSubnetGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "CacheSubnetGroups"
        },
        DescribeEngineDefaultParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "EngineDefaults.Marker",
          result_key: "EngineDefaults.Parameters"
        },
        DescribeEvents: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Events"
        },
        DescribeGlobalReplicationGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "GlobalReplicationGroups"
        },
        DescribeReplicationGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReplicationGroups"
        },
        DescribeReservedCacheNodes: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedCacheNodes"
        },
        DescribeReservedCacheNodesOfferings: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedCacheNodesOfferings"
        },
        DescribeServiceUpdates: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ServiceUpdates"
        },
        DescribeSnapshots: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Snapshots"
        },
        DescribeUpdateActions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "UpdateActions"
        },
        DescribeUserGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "UserGroups"
        },
        DescribeUsers: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Users"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticache-2015-02-02.waiters2.json
var require_elasticache_2015_02_02_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/elasticache-2015-02-02.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        CacheClusterAvailable: {
          acceptors: [
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "available",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "deleted",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "deleting",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "incompatible-network",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "restore-failed",
              matcher: "pathAny",
              state: "failure"
            }
          ],
          delay: 15,
          description: "Wait until ElastiCache cluster is available.",
          maxAttempts: 40,
          operation: "DescribeCacheClusters"
        },
        CacheClusterDeleted: {
          acceptors: [
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "deleted",
              matcher: "pathAll",
              state: "success"
            },
            {
              expected: "CacheClusterNotFound",
              matcher: "error",
              state: "success"
            },
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "available",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "creating",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "incompatible-network",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "modifying",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "restore-failed",
              matcher: "pathAny",
              state: "failure"
            },
            {
              argument: "CacheClusters[].CacheClusterStatus",
              expected: "snapshotting",
              matcher: "pathAny",
              state: "failure"
            }
          ],
          delay: 15,
          description: "Wait until ElastiCache cluster is deleted.",
          maxAttempts: 40,
          operation: "DescribeCacheClusters"
        },
        ReplicationGroupAvailable: {
          acceptors: [
            {
              argument: "ReplicationGroups[].Status",
              expected: "available",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "ReplicationGroups[].Status",
              expected: "deleted",
              matcher: "pathAny",
              state: "failure"
            }
          ],
          delay: 15,
          description: "Wait until ElastiCache replication group is available.",
          maxAttempts: 40,
          operation: "DescribeReplicationGroups"
        },
        ReplicationGroupDeleted: {
          acceptors: [
            {
              argument: "ReplicationGroups[].Status",
              expected: "deleted",
              matcher: "pathAll",
              state: "success"
            },
            {
              argument: "ReplicationGroups[].Status",
              expected: "available",
              matcher: "pathAny",
              state: "failure"
            },
            {
              expected: "ReplicationGroupNotFoundFault",
              matcher: "error",
              state: "success"
            }
          ],
          delay: 15,
          description: "Wait until ElastiCache replication group is deleted.",
          maxAttempts: 40,
          operation: "DescribeReplicationGroups"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/elasticache.js
var require_elasticache = __commonJS({
  "node_modules/aws-sdk/clients/elasticache.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["elasticache"] = {};
    AWS3.ElastiCache = Service.defineService("elasticache", ["2012-11-15*", "2014-03-24*", "2014-07-15*", "2014-09-30*", "2015-02-02"]);
    Object.defineProperty(apiLoader.services["elasticache"], "2015-02-02", {
      get: function get() {
        var model = require_elasticache_2015_02_02_min();
        model.paginators = require_elasticache_2015_02_02_paginators().pagination;
        model.waiters = require_elasticache_2015_02_02_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ElastiCache;
  }
});

// node_modules/aws-sdk/apis/elasticbeanstalk-2010-12-01.min.json
var require_elasticbeanstalk_2010_12_01_min = __commonJS({
  "node_modules/aws-sdk/apis/elasticbeanstalk-2010-12-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2010-12-01",
        endpointPrefix: "elasticbeanstalk",
        protocol: "query",
        serviceAbbreviation: "Elastic Beanstalk",
        serviceFullName: "AWS Elastic Beanstalk",
        serviceId: "Elastic Beanstalk",
        signatureVersion: "v4",
        uid: "elasticbeanstalk-2010-12-01",
        xmlNamespace: "http://elasticbeanstalk.amazonaws.com/docs/2010-12-01/"
      },
      operations: {
        AbortEnvironmentUpdate: {
          input: {
            type: "structure",
            members: {
              EnvironmentId: {},
              EnvironmentName: {}
            }
          }
        },
        ApplyEnvironmentManagedAction: {
          input: {
            type: "structure",
            required: [
              "ActionId"
            ],
            members: {
              EnvironmentName: {},
              EnvironmentId: {},
              ActionId: {}
            }
          },
          output: {
            resultWrapper: "ApplyEnvironmentManagedActionResult",
            type: "structure",
            members: {
              ActionId: {},
              ActionDescription: {},
              ActionType: {},
              Status: {}
            }
          }
        },
        AssociateEnvironmentOperationsRole: {
          input: {
            type: "structure",
            required: [
              "EnvironmentName",
              "OperationsRole"
            ],
            members: {
              EnvironmentName: {},
              OperationsRole: {}
            }
          }
        },
        CheckDNSAvailability: {
          input: {
            type: "structure",
            required: [
              "CNAMEPrefix"
            ],
            members: {
              CNAMEPrefix: {}
            }
          },
          output: {
            resultWrapper: "CheckDNSAvailabilityResult",
            type: "structure",
            members: {
              Available: {
                type: "boolean"
              },
              FullyQualifiedCNAME: {}
            }
          }
        },
        ComposeEnvironments: {
          input: {
            type: "structure",
            members: {
              ApplicationName: {},
              GroupName: {},
              VersionLabels: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            shape: "Sk",
            resultWrapper: "ComposeEnvironmentsResult"
          }
        },
        CreateApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              Description: {},
              ResourceLifecycleConfig: {
                shape: "S19"
              },
              Tags: {
                shape: "S1f"
              }
            }
          },
          output: {
            shape: "S1j",
            resultWrapper: "CreateApplicationResult"
          }
        },
        CreateApplicationVersion: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "VersionLabel"
            ],
            members: {
              ApplicationName: {},
              VersionLabel: {},
              Description: {},
              SourceBuildInformation: {
                shape: "S1p"
              },
              SourceBundle: {
                shape: "S1t"
              },
              BuildConfiguration: {
                type: "structure",
                required: [
                  "CodeBuildServiceRole",
                  "Image"
                ],
                members: {
                  ArtifactName: {},
                  CodeBuildServiceRole: {},
                  ComputeType: {},
                  Image: {},
                  TimeoutInMinutes: {
                    type: "integer"
                  }
                }
              },
              AutoCreateApplication: {
                type: "boolean"
              },
              Process: {
                type: "boolean"
              },
              Tags: {
                shape: "S1f"
              }
            }
          },
          output: {
            shape: "S21",
            resultWrapper: "CreateApplicationVersionResult"
          }
        },
        CreateConfigurationTemplate: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "TemplateName"
            ],
            members: {
              ApplicationName: {},
              TemplateName: {},
              SolutionStackName: {},
              PlatformArn: {},
              SourceConfiguration: {
                type: "structure",
                members: {
                  ApplicationName: {},
                  TemplateName: {}
                }
              },
              EnvironmentId: {},
              Description: {},
              OptionSettings: {
                shape: "S27"
              },
              Tags: {
                shape: "S1f"
              }
            }
          },
          output: {
            shape: "S2d",
            resultWrapper: "CreateConfigurationTemplateResult"
          }
        },
        CreateEnvironment: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              EnvironmentName: {},
              GroupName: {},
              Description: {},
              CNAMEPrefix: {},
              Tier: {
                shape: "S13"
              },
              Tags: {
                shape: "S1f"
              },
              VersionLabel: {},
              TemplateName: {},
              SolutionStackName: {},
              PlatformArn: {},
              OptionSettings: {
                shape: "S27"
              },
              OptionsToRemove: {
                shape: "S2g"
              },
              OperationsRole: {}
            }
          },
          output: {
            shape: "Sm",
            resultWrapper: "CreateEnvironmentResult"
          }
        },
        CreatePlatformVersion: {
          input: {
            type: "structure",
            required: [
              "PlatformName",
              "PlatformVersion",
              "PlatformDefinitionBundle"
            ],
            members: {
              PlatformName: {},
              PlatformVersion: {},
              PlatformDefinitionBundle: {
                shape: "S1t"
              },
              EnvironmentName: {},
              OptionSettings: {
                shape: "S27"
              },
              Tags: {
                shape: "S1f"
              }
            }
          },
          output: {
            resultWrapper: "CreatePlatformVersionResult",
            type: "structure",
            members: {
              PlatformSummary: {
                shape: "S2m"
              },
              Builder: {
                type: "structure",
                members: {
                  ARN: {}
                }
              }
            }
          }
        },
        CreateStorageLocation: {
          output: {
            resultWrapper: "CreateStorageLocationResult",
            type: "structure",
            members: {
              S3Bucket: {}
            }
          }
        },
        DeleteApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              TerminateEnvByForce: {
                type: "boolean"
              }
            }
          }
        },
        DeleteApplicationVersion: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "VersionLabel"
            ],
            members: {
              ApplicationName: {},
              VersionLabel: {},
              DeleteSourceBundle: {
                type: "boolean"
              }
            }
          }
        },
        DeleteConfigurationTemplate: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "TemplateName"
            ],
            members: {
              ApplicationName: {},
              TemplateName: {}
            }
          }
        },
        DeleteEnvironmentConfiguration: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "EnvironmentName"
            ],
            members: {
              ApplicationName: {},
              EnvironmentName: {}
            }
          }
        },
        DeletePlatformVersion: {
          input: {
            type: "structure",
            members: {
              PlatformArn: {}
            }
          },
          output: {
            resultWrapper: "DeletePlatformVersionResult",
            type: "structure",
            members: {
              PlatformSummary: {
                shape: "S2m"
              }
            }
          }
        },
        DescribeAccountAttributes: {
          output: {
            resultWrapper: "DescribeAccountAttributesResult",
            type: "structure",
            members: {
              ResourceQuotas: {
                type: "structure",
                members: {
                  ApplicationQuota: {
                    shape: "S3c"
                  },
                  ApplicationVersionQuota: {
                    shape: "S3c"
                  },
                  EnvironmentQuota: {
                    shape: "S3c"
                  },
                  ConfigurationTemplateQuota: {
                    shape: "S3c"
                  },
                  CustomPlatformQuota: {
                    shape: "S3c"
                  }
                }
              }
            }
          }
        },
        DescribeApplicationVersions: {
          input: {
            type: "structure",
            members: {
              ApplicationName: {},
              VersionLabels: {
                shape: "S1m"
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeApplicationVersionsResult",
            type: "structure",
            members: {
              ApplicationVersions: {
                type: "list",
                member: {
                  shape: "S22"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeApplications: {
          input: {
            type: "structure",
            members: {
              ApplicationNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "DescribeApplicationsResult",
            type: "structure",
            members: {
              Applications: {
                type: "list",
                member: {
                  shape: "S1k"
                }
              }
            }
          }
        },
        DescribeConfigurationOptions: {
          input: {
            type: "structure",
            members: {
              ApplicationName: {},
              TemplateName: {},
              EnvironmentName: {},
              SolutionStackName: {},
              PlatformArn: {},
              Options: {
                shape: "S2g"
              }
            }
          },
          output: {
            resultWrapper: "DescribeConfigurationOptionsResult",
            type: "structure",
            members: {
              SolutionStackName: {},
              PlatformArn: {},
              Options: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Namespace: {},
                    Name: {},
                    DefaultValue: {},
                    ChangeSeverity: {},
                    UserDefined: {
                      type: "boolean"
                    },
                    ValueType: {},
                    ValueOptions: {
                      type: "list",
                      member: {}
                    },
                    MinValue: {
                      type: "integer"
                    },
                    MaxValue: {
                      type: "integer"
                    },
                    MaxLength: {
                      type: "integer"
                    },
                    Regex: {
                      type: "structure",
                      members: {
                        Pattern: {},
                        Label: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeConfigurationSettings: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              TemplateName: {},
              EnvironmentName: {}
            }
          },
          output: {
            resultWrapper: "DescribeConfigurationSettingsResult",
            type: "structure",
            members: {
              ConfigurationSettings: {
                type: "list",
                member: {
                  shape: "S2d"
                }
              }
            }
          }
        },
        DescribeEnvironmentHealth: {
          input: {
            type: "structure",
            members: {
              EnvironmentName: {},
              EnvironmentId: {},
              AttributeNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "DescribeEnvironmentHealthResult",
            type: "structure",
            members: {
              EnvironmentName: {},
              HealthStatus: {},
              Status: {},
              Color: {},
              Causes: {
                shape: "S48"
              },
              ApplicationMetrics: {
                shape: "S4a"
              },
              InstancesHealth: {
                type: "structure",
                members: {
                  NoData: {
                    type: "integer"
                  },
                  Unknown: {
                    type: "integer"
                  },
                  Pending: {
                    type: "integer"
                  },
                  Ok: {
                    type: "integer"
                  },
                  Info: {
                    type: "integer"
                  },
                  Warning: {
                    type: "integer"
                  },
                  Degraded: {
                    type: "integer"
                  },
                  Severe: {
                    type: "integer"
                  }
                }
              },
              RefreshedAt: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeEnvironmentManagedActionHistory: {
          input: {
            type: "structure",
            members: {
              EnvironmentId: {},
              EnvironmentName: {},
              NextToken: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeEnvironmentManagedActionHistoryResult",
            type: "structure",
            members: {
              ManagedActionHistoryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ActionId: {},
                    ActionType: {},
                    ActionDescription: {},
                    FailureType: {},
                    Status: {},
                    FailureDescription: {},
                    ExecutedTime: {
                      type: "timestamp"
                    },
                    FinishedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeEnvironmentManagedActions: {
          input: {
            type: "structure",
            members: {
              EnvironmentName: {},
              EnvironmentId: {},
              Status: {}
            }
          },
          output: {
            resultWrapper: "DescribeEnvironmentManagedActionsResult",
            type: "structure",
            members: {
              ManagedActions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ActionId: {},
                    ActionDescription: {},
                    ActionType: {},
                    Status: {},
                    WindowStartTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeEnvironmentResources: {
          input: {
            type: "structure",
            members: {
              EnvironmentId: {},
              EnvironmentName: {}
            }
          },
          output: {
            resultWrapper: "DescribeEnvironmentResourcesResult",
            type: "structure",
            members: {
              EnvironmentResources: {
                type: "structure",
                members: {
                  EnvironmentName: {},
                  AutoScalingGroups: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {}
                      }
                    }
                  },
                  Instances: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Id: {}
                      }
                    }
                  },
                  LaunchConfigurations: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {}
                      }
                    }
                  },
                  LaunchTemplates: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Id: {}
                      }
                    }
                  },
                  LoadBalancers: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {}
                      }
                    }
                  },
                  Triggers: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {}
                      }
                    }
                  },
                  Queues: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        URL: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeEnvironments: {
          input: {
            type: "structure",
            members: {
              ApplicationName: {},
              VersionLabel: {},
              EnvironmentIds: {
                type: "list",
                member: {}
              },
              EnvironmentNames: {
                type: "list",
                member: {}
              },
              IncludeDeleted: {
                type: "boolean"
              },
              IncludedDeletedBackTo: {
                type: "timestamp"
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            shape: "Sk",
            resultWrapper: "DescribeEnvironmentsResult"
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              ApplicationName: {},
              VersionLabel: {},
              TemplateName: {},
              EnvironmentId: {},
              EnvironmentName: {},
              PlatformArn: {},
              RequestId: {},
              Severity: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventsResult",
            type: "structure",
            members: {
              Events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventDate: {
                      type: "timestamp"
                    },
                    Message: {},
                    ApplicationName: {},
                    VersionLabel: {},
                    TemplateName: {},
                    EnvironmentName: {},
                    PlatformArn: {},
                    RequestId: {},
                    Severity: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeInstancesHealth: {
          input: {
            type: "structure",
            members: {
              EnvironmentName: {},
              EnvironmentId: {},
              AttributeNames: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "DescribeInstancesHealthResult",
            type: "structure",
            members: {
              InstanceHealthList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InstanceId: {},
                    HealthStatus: {},
                    Color: {},
                    Causes: {
                      shape: "S48"
                    },
                    LaunchedAt: {
                      type: "timestamp"
                    },
                    ApplicationMetrics: {
                      shape: "S4a"
                    },
                    System: {
                      type: "structure",
                      members: {
                        CPUUtilization: {
                          type: "structure",
                          members: {
                            User: {
                              type: "double"
                            },
                            Nice: {
                              type: "double"
                            },
                            System: {
                              type: "double"
                            },
                            Idle: {
                              type: "double"
                            },
                            IOWait: {
                              type: "double"
                            },
                            IRQ: {
                              type: "double"
                            },
                            SoftIRQ: {
                              type: "double"
                            },
                            Privileged: {
                              type: "double"
                            }
                          }
                        },
                        LoadAverage: {
                          type: "list",
                          member: {
                            type: "double"
                          }
                        }
                      }
                    },
                    Deployment: {
                      type: "structure",
                      members: {
                        VersionLabel: {},
                        DeploymentId: {
                          type: "long"
                        },
                        Status: {},
                        DeploymentTime: {
                          type: "timestamp"
                        }
                      }
                    },
                    AvailabilityZone: {},
                    InstanceType: {}
                  }
                }
              },
              RefreshedAt: {
                type: "timestamp"
              },
              NextToken: {}
            }
          }
        },
        DescribePlatformVersion: {
          input: {
            type: "structure",
            members: {
              PlatformArn: {}
            }
          },
          output: {
            resultWrapper: "DescribePlatformVersionResult",
            type: "structure",
            members: {
              PlatformDescription: {
                type: "structure",
                members: {
                  PlatformArn: {},
                  PlatformOwner: {},
                  PlatformName: {},
                  PlatformVersion: {},
                  SolutionStackName: {},
                  PlatformStatus: {},
                  DateCreated: {
                    type: "timestamp"
                  },
                  DateUpdated: {
                    type: "timestamp"
                  },
                  PlatformCategory: {},
                  Description: {},
                  Maintainer: {},
                  OperatingSystemName: {},
                  OperatingSystemVersion: {},
                  ProgrammingLanguages: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        Version: {}
                      }
                    }
                  },
                  Frameworks: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        Version: {}
                      }
                    }
                  },
                  CustomAmiList: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        VirtualizationType: {},
                        ImageId: {}
                      }
                    }
                  },
                  SupportedTierList: {
                    shape: "S2s"
                  },
                  SupportedAddonList: {
                    shape: "S2u"
                  },
                  PlatformLifecycleState: {},
                  PlatformBranchName: {},
                  PlatformBranchLifecycleState: {}
                }
              }
            }
          }
        },
        DisassociateEnvironmentOperationsRole: {
          input: {
            type: "structure",
            required: [
              "EnvironmentName"
            ],
            members: {
              EnvironmentName: {}
            }
          }
        },
        ListAvailableSolutionStacks: {
          output: {
            resultWrapper: "ListAvailableSolutionStacksResult",
            type: "structure",
            members: {
              SolutionStacks: {
                type: "list",
                member: {}
              },
              SolutionStackDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SolutionStackName: {},
                    PermittedFileTypes: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        ListPlatformBranches: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Attribute: {},
                    Operator: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListPlatformBranchesResult",
            type: "structure",
            members: {
              PlatformBranchSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PlatformName: {},
                    BranchName: {},
                    LifecycleState: {},
                    BranchOrder: {
                      type: "integer"
                    },
                    SupportedTierList: {
                      shape: "S2s"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPlatformVersions: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    Operator: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxRecords: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListPlatformVersionsResult",
            type: "structure",
            members: {
              PlatformSummaryList: {
                type: "list",
                member: {
                  shape: "S2m"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            resultWrapper: "ListTagsForResourceResult",
            type: "structure",
            members: {
              ResourceArn: {},
              ResourceTags: {
                shape: "S7g"
              }
            }
          }
        },
        RebuildEnvironment: {
          input: {
            type: "structure",
            members: {
              EnvironmentId: {},
              EnvironmentName: {}
            }
          }
        },
        RequestEnvironmentInfo: {
          input: {
            type: "structure",
            required: [
              "InfoType"
            ],
            members: {
              EnvironmentId: {},
              EnvironmentName: {},
              InfoType: {}
            }
          }
        },
        RestartAppServer: {
          input: {
            type: "structure",
            members: {
              EnvironmentId: {},
              EnvironmentName: {}
            }
          }
        },
        RetrieveEnvironmentInfo: {
          input: {
            type: "structure",
            required: [
              "InfoType"
            ],
            members: {
              EnvironmentId: {},
              EnvironmentName: {},
              InfoType: {}
            }
          },
          output: {
            resultWrapper: "RetrieveEnvironmentInfoResult",
            type: "structure",
            members: {
              EnvironmentInfo: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InfoType: {},
                    Ec2InstanceId: {},
                    SampleTimestamp: {
                      type: "timestamp"
                    },
                    Message: {}
                  }
                }
              }
            }
          }
        },
        SwapEnvironmentCNAMEs: {
          input: {
            type: "structure",
            members: {
              SourceEnvironmentId: {},
              SourceEnvironmentName: {},
              DestinationEnvironmentId: {},
              DestinationEnvironmentName: {}
            }
          }
        },
        TerminateEnvironment: {
          input: {
            type: "structure",
            members: {
              EnvironmentId: {},
              EnvironmentName: {},
              TerminateResources: {
                type: "boolean"
              },
              ForceTerminate: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "Sm",
            resultWrapper: "TerminateEnvironmentResult"
          }
        },
        UpdateApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              Description: {}
            }
          },
          output: {
            shape: "S1j",
            resultWrapper: "UpdateApplicationResult"
          }
        },
        UpdateApplicationResourceLifecycle: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "ResourceLifecycleConfig"
            ],
            members: {
              ApplicationName: {},
              ResourceLifecycleConfig: {
                shape: "S19"
              }
            }
          },
          output: {
            resultWrapper: "UpdateApplicationResourceLifecycleResult",
            type: "structure",
            members: {
              ApplicationName: {},
              ResourceLifecycleConfig: {
                shape: "S19"
              }
            }
          }
        },
        UpdateApplicationVersion: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "VersionLabel"
            ],
            members: {
              ApplicationName: {},
              VersionLabel: {},
              Description: {}
            }
          },
          output: {
            shape: "S21",
            resultWrapper: "UpdateApplicationVersionResult"
          }
        },
        UpdateConfigurationTemplate: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "TemplateName"
            ],
            members: {
              ApplicationName: {},
              TemplateName: {},
              Description: {},
              OptionSettings: {
                shape: "S27"
              },
              OptionsToRemove: {
                shape: "S2g"
              }
            }
          },
          output: {
            shape: "S2d",
            resultWrapper: "UpdateConfigurationTemplateResult"
          }
        },
        UpdateEnvironment: {
          input: {
            type: "structure",
            members: {
              ApplicationName: {},
              EnvironmentId: {},
              EnvironmentName: {},
              GroupName: {},
              Description: {},
              Tier: {
                shape: "S13"
              },
              VersionLabel: {},
              TemplateName: {},
              SolutionStackName: {},
              PlatformArn: {},
              OptionSettings: {
                shape: "S27"
              },
              OptionsToRemove: {
                shape: "S2g"
              }
            }
          },
          output: {
            shape: "Sm",
            resultWrapper: "UpdateEnvironmentResult"
          }
        },
        UpdateTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              TagsToAdd: {
                shape: "S7g"
              },
              TagsToRemove: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ValidateConfigurationSettings: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "OptionSettings"
            ],
            members: {
              ApplicationName: {},
              TemplateName: {},
              EnvironmentName: {},
              OptionSettings: {
                shape: "S27"
              }
            }
          },
          output: {
            resultWrapper: "ValidateConfigurationSettingsResult",
            type: "structure",
            members: {
              Messages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Message: {},
                    Severity: {},
                    Namespace: {},
                    OptionName: {}
                  }
                }
              }
            }
          }
        }
      },
      shapes: {
        Sk: {
          type: "structure",
          members: {
            Environments: {
              type: "list",
              member: {
                shape: "Sm"
              }
            },
            NextToken: {}
          }
        },
        Sm: {
          type: "structure",
          members: {
            EnvironmentName: {},
            EnvironmentId: {},
            ApplicationName: {},
            VersionLabel: {},
            SolutionStackName: {},
            PlatformArn: {},
            TemplateName: {},
            Description: {},
            EndpointURL: {},
            CNAME: {},
            DateCreated: {
              type: "timestamp"
            },
            DateUpdated: {
              type: "timestamp"
            },
            Status: {},
            AbortableOperationInProgress: {
              type: "boolean"
            },
            Health: {},
            HealthStatus: {},
            Resources: {
              type: "structure",
              members: {
                LoadBalancer: {
                  type: "structure",
                  members: {
                    LoadBalancerName: {},
                    Domain: {},
                    Listeners: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Protocol: {},
                          Port: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            Tier: {
              shape: "S13"
            },
            EnvironmentLinks: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  LinkName: {},
                  EnvironmentName: {}
                }
              }
            },
            EnvironmentArn: {},
            OperationsRole: {}
          }
        },
        S13: {
          type: "structure",
          members: {
            Name: {},
            Type: {},
            Version: {}
          }
        },
        S19: {
          type: "structure",
          members: {
            ServiceRole: {},
            VersionLifecycleConfig: {
              type: "structure",
              members: {
                MaxCountRule: {
                  type: "structure",
                  required: [
                    "Enabled"
                  ],
                  members: {
                    Enabled: {
                      type: "boolean"
                    },
                    MaxCount: {
                      type: "integer"
                    },
                    DeleteSourceFromS3: {
                      type: "boolean"
                    }
                  }
                },
                MaxAgeRule: {
                  type: "structure",
                  required: [
                    "Enabled"
                  ],
                  members: {
                    Enabled: {
                      type: "boolean"
                    },
                    MaxAgeInDays: {
                      type: "integer"
                    },
                    DeleteSourceFromS3: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        S1f: {
          type: "list",
          member: {
            shape: "S1g"
          }
        },
        S1g: {
          type: "structure",
          members: {
            Key: {},
            Value: {}
          }
        },
        S1j: {
          type: "structure",
          members: {
            Application: {
              shape: "S1k"
            }
          }
        },
        S1k: {
          type: "structure",
          members: {
            ApplicationArn: {},
            ApplicationName: {},
            Description: {},
            DateCreated: {
              type: "timestamp"
            },
            DateUpdated: {
              type: "timestamp"
            },
            Versions: {
              shape: "S1m"
            },
            ConfigurationTemplates: {
              type: "list",
              member: {}
            },
            ResourceLifecycleConfig: {
              shape: "S19"
            }
          }
        },
        S1m: {
          type: "list",
          member: {}
        },
        S1p: {
          type: "structure",
          required: [
            "SourceType",
            "SourceRepository",
            "SourceLocation"
          ],
          members: {
            SourceType: {},
            SourceRepository: {},
            SourceLocation: {}
          }
        },
        S1t: {
          type: "structure",
          members: {
            S3Bucket: {},
            S3Key: {}
          }
        },
        S21: {
          type: "structure",
          members: {
            ApplicationVersion: {
              shape: "S22"
            }
          }
        },
        S22: {
          type: "structure",
          members: {
            ApplicationVersionArn: {},
            ApplicationName: {},
            Description: {},
            VersionLabel: {},
            SourceBuildInformation: {
              shape: "S1p"
            },
            BuildArn: {},
            SourceBundle: {
              shape: "S1t"
            },
            DateCreated: {
              type: "timestamp"
            },
            DateUpdated: {
              type: "timestamp"
            },
            Status: {}
          }
        },
        S27: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceName: {},
              Namespace: {},
              OptionName: {},
              Value: {}
            }
          }
        },
        S2d: {
          type: "structure",
          members: {
            SolutionStackName: {},
            PlatformArn: {},
            ApplicationName: {},
            TemplateName: {},
            Description: {},
            EnvironmentName: {},
            DeploymentStatus: {},
            DateCreated: {
              type: "timestamp"
            },
            DateUpdated: {
              type: "timestamp"
            },
            OptionSettings: {
              shape: "S27"
            }
          }
        },
        S2g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceName: {},
              Namespace: {},
              OptionName: {}
            }
          }
        },
        S2m: {
          type: "structure",
          members: {
            PlatformArn: {},
            PlatformOwner: {},
            PlatformStatus: {},
            PlatformCategory: {},
            OperatingSystemName: {},
            OperatingSystemVersion: {},
            SupportedTierList: {
              shape: "S2s"
            },
            SupportedAddonList: {
              shape: "S2u"
            },
            PlatformLifecycleState: {},
            PlatformVersion: {},
            PlatformBranchName: {},
            PlatformBranchLifecycleState: {}
          }
        },
        S2s: {
          type: "list",
          member: {}
        },
        S2u: {
          type: "list",
          member: {}
        },
        S3c: {
          type: "structure",
          members: {
            Maximum: {
              type: "integer"
            }
          }
        },
        S48: {
          type: "list",
          member: {}
        },
        S4a: {
          type: "structure",
          members: {
            Duration: {
              type: "integer"
            },
            RequestCount: {
              type: "integer"
            },
            StatusCodes: {
              type: "structure",
              members: {
                Status2xx: {
                  type: "integer"
                },
                Status3xx: {
                  type: "integer"
                },
                Status4xx: {
                  type: "integer"
                },
                Status5xx: {
                  type: "integer"
                }
              }
            },
            Latency: {
              type: "structure",
              members: {
                P999: {
                  type: "double"
                },
                P99: {
                  type: "double"
                },
                P95: {
                  type: "double"
                },
                P90: {
                  type: "double"
                },
                P85: {
                  type: "double"
                },
                P75: {
                  type: "double"
                },
                P50: {
                  type: "double"
                },
                P10: {
                  type: "double"
                }
              }
            }
          }
        },
        S7g: {
          type: "list",
          member: {
            shape: "S1g"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticbeanstalk-2010-12-01.paginators.json
var require_elasticbeanstalk_2010_12_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/elasticbeanstalk-2010-12-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeApplicationVersions: {
          result_key: "ApplicationVersions"
        },
        DescribeApplications: {
          result_key: "Applications"
        },
        DescribeConfigurationOptions: {
          result_key: "Options"
        },
        DescribeEnvironmentManagedActionHistory: {
          input_token: "NextToken",
          limit_key: "MaxItems",
          output_token: "NextToken",
          result_key: "ManagedActionHistoryItems"
        },
        DescribeEnvironments: {
          result_key: "Environments"
        },
        DescribeEvents: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "Events"
        },
        ListAvailableSolutionStacks: {
          result_key: "SolutionStacks"
        },
        ListPlatformBranches: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken"
        },
        ListPlatformVersions: {
          input_token: "NextToken",
          limit_key: "MaxRecords",
          output_token: "NextToken",
          result_key: "PlatformSummaryList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticbeanstalk-2010-12-01.waiters2.json
var require_elasticbeanstalk_2010_12_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/elasticbeanstalk-2010-12-01.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        EnvironmentExists: {
          delay: 20,
          maxAttempts: 20,
          operation: "DescribeEnvironments",
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "Environments[].Status",
              expected: "Ready"
            },
            {
              state: "retry",
              matcher: "pathAll",
              argument: "Environments[].Status",
              expected: "Launching"
            }
          ]
        },
        EnvironmentUpdated: {
          delay: 20,
          maxAttempts: 20,
          operation: "DescribeEnvironments",
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "Environments[].Status",
              expected: "Ready"
            },
            {
              state: "retry",
              matcher: "pathAll",
              argument: "Environments[].Status",
              expected: "Updating"
            }
          ]
        },
        EnvironmentTerminated: {
          delay: 20,
          maxAttempts: 20,
          operation: "DescribeEnvironments",
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "Environments[].Status",
              expected: "Terminated"
            },
            {
              state: "retry",
              matcher: "pathAll",
              argument: "Environments[].Status",
              expected: "Terminating"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/elasticbeanstalk.js
var require_elasticbeanstalk = __commonJS({
  "node_modules/aws-sdk/clients/elasticbeanstalk.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["elasticbeanstalk"] = {};
    AWS3.ElasticBeanstalk = Service.defineService("elasticbeanstalk", ["2010-12-01"]);
    Object.defineProperty(apiLoader.services["elasticbeanstalk"], "2010-12-01", {
      get: function get() {
        var model = require_elasticbeanstalk_2010_12_01_min();
        model.paginators = require_elasticbeanstalk_2010_12_01_paginators().pagination;
        model.waiters = require_elasticbeanstalk_2010_12_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ElasticBeanstalk;
  }
});

// node_modules/aws-sdk/apis/elasticloadbalancing-2012-06-01.min.json
var require_elasticloadbalancing_2012_06_01_min = __commonJS({
  "node_modules/aws-sdk/apis/elasticloadbalancing-2012-06-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2012-06-01",
        endpointPrefix: "elasticloadbalancing",
        protocol: "query",
        serviceFullName: "Elastic Load Balancing",
        serviceId: "Elastic Load Balancing",
        signatureVersion: "v4",
        uid: "elasticloadbalancing-2012-06-01",
        xmlNamespace: "http://elasticloadbalancing.amazonaws.com/doc/2012-06-01/"
      },
      operations: {
        AddTags: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerNames",
              "Tags"
            ],
            members: {
              LoadBalancerNames: {
                shape: "S2"
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            resultWrapper: "AddTagsResult",
            type: "structure",
            members: {}
          }
        },
        ApplySecurityGroupsToLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "SecurityGroups"
            ],
            members: {
              LoadBalancerName: {},
              SecurityGroups: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "ApplySecurityGroupsToLoadBalancerResult",
            type: "structure",
            members: {
              SecurityGroups: {
                shape: "Sa"
              }
            }
          }
        },
        AttachLoadBalancerToSubnets: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "Subnets"
            ],
            members: {
              LoadBalancerName: {},
              Subnets: {
                shape: "Se"
              }
            }
          },
          output: {
            resultWrapper: "AttachLoadBalancerToSubnetsResult",
            type: "structure",
            members: {
              Subnets: {
                shape: "Se"
              }
            }
          }
        },
        ConfigureHealthCheck: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "HealthCheck"
            ],
            members: {
              LoadBalancerName: {},
              HealthCheck: {
                shape: "Si"
              }
            }
          },
          output: {
            resultWrapper: "ConfigureHealthCheckResult",
            type: "structure",
            members: {
              HealthCheck: {
                shape: "Si"
              }
            }
          }
        },
        CreateAppCookieStickinessPolicy: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "PolicyName",
              "CookieName"
            ],
            members: {
              LoadBalancerName: {},
              PolicyName: {},
              CookieName: {}
            }
          },
          output: {
            resultWrapper: "CreateAppCookieStickinessPolicyResult",
            type: "structure",
            members: {}
          }
        },
        CreateLBCookieStickinessPolicy: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "PolicyName"
            ],
            members: {
              LoadBalancerName: {},
              PolicyName: {},
              CookieExpirationPeriod: {
                type: "long"
              }
            }
          },
          output: {
            resultWrapper: "CreateLBCookieStickinessPolicyResult",
            type: "structure",
            members: {}
          }
        },
        CreateLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "Listeners"
            ],
            members: {
              LoadBalancerName: {},
              Listeners: {
                shape: "Sx"
              },
              AvailabilityZones: {
                shape: "S13"
              },
              Subnets: {
                shape: "Se"
              },
              SecurityGroups: {
                shape: "Sa"
              },
              Scheme: {},
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            resultWrapper: "CreateLoadBalancerResult",
            type: "structure",
            members: {
              DNSName: {}
            }
          }
        },
        CreateLoadBalancerListeners: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "Listeners"
            ],
            members: {
              LoadBalancerName: {},
              Listeners: {
                shape: "Sx"
              }
            }
          },
          output: {
            resultWrapper: "CreateLoadBalancerListenersResult",
            type: "structure",
            members: {}
          }
        },
        CreateLoadBalancerPolicy: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "PolicyName",
              "PolicyTypeName"
            ],
            members: {
              LoadBalancerName: {},
              PolicyName: {},
              PolicyTypeName: {},
              PolicyAttributes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AttributeName: {},
                    AttributeValue: {}
                  }
                }
              }
            }
          },
          output: {
            resultWrapper: "CreateLoadBalancerPolicyResult",
            type: "structure",
            members: {}
          }
        },
        DeleteLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName"
            ],
            members: {
              LoadBalancerName: {}
            }
          },
          output: {
            resultWrapper: "DeleteLoadBalancerResult",
            type: "structure",
            members: {}
          }
        },
        DeleteLoadBalancerListeners: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "LoadBalancerPorts"
            ],
            members: {
              LoadBalancerName: {},
              LoadBalancerPorts: {
                type: "list",
                member: {
                  type: "integer"
                }
              }
            }
          },
          output: {
            resultWrapper: "DeleteLoadBalancerListenersResult",
            type: "structure",
            members: {}
          }
        },
        DeleteLoadBalancerPolicy: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "PolicyName"
            ],
            members: {
              LoadBalancerName: {},
              PolicyName: {}
            }
          },
          output: {
            resultWrapper: "DeleteLoadBalancerPolicyResult",
            type: "structure",
            members: {}
          }
        },
        DeregisterInstancesFromLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "Instances"
            ],
            members: {
              LoadBalancerName: {},
              Instances: {
                shape: "S1p"
              }
            }
          },
          output: {
            resultWrapper: "DeregisterInstancesFromLoadBalancerResult",
            type: "structure",
            members: {
              Instances: {
                shape: "S1p"
              }
            }
          }
        },
        DescribeAccountLimits: {
          input: {
            type: "structure",
            members: {
              Marker: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeAccountLimitsResult",
            type: "structure",
            members: {
              Limits: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Max: {}
                  }
                }
              },
              NextMarker: {}
            }
          }
        },
        DescribeInstanceHealth: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName"
            ],
            members: {
              LoadBalancerName: {},
              Instances: {
                shape: "S1p"
              }
            }
          },
          output: {
            resultWrapper: "DescribeInstanceHealthResult",
            type: "structure",
            members: {
              InstanceStates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InstanceId: {},
                    State: {},
                    ReasonCode: {},
                    Description: {}
                  }
                }
              }
            }
          }
        },
        DescribeLoadBalancerAttributes: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName"
            ],
            members: {
              LoadBalancerName: {}
            }
          },
          output: {
            resultWrapper: "DescribeLoadBalancerAttributesResult",
            type: "structure",
            members: {
              LoadBalancerAttributes: {
                shape: "S2a"
              }
            }
          }
        },
        DescribeLoadBalancerPolicies: {
          input: {
            type: "structure",
            members: {
              LoadBalancerName: {},
              PolicyNames: {
                shape: "S2s"
              }
            }
          },
          output: {
            resultWrapper: "DescribeLoadBalancerPoliciesResult",
            type: "structure",
            members: {
              PolicyDescriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PolicyName: {},
                    PolicyTypeName: {},
                    PolicyAttributeDescriptions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          AttributeName: {},
                          AttributeValue: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeLoadBalancerPolicyTypes: {
          input: {
            type: "structure",
            members: {
              PolicyTypeNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "DescribeLoadBalancerPolicyTypesResult",
            type: "structure",
            members: {
              PolicyTypeDescriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PolicyTypeName: {},
                    Description: {},
                    PolicyAttributeTypeDescriptions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          AttributeName: {},
                          AttributeType: {},
                          Description: {},
                          DefaultValue: {},
                          Cardinality: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeLoadBalancers: {
          input: {
            type: "structure",
            members: {
              LoadBalancerNames: {
                shape: "S2"
              },
              Marker: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeLoadBalancersResult",
            type: "structure",
            members: {
              LoadBalancerDescriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LoadBalancerName: {},
                    DNSName: {},
                    CanonicalHostedZoneName: {},
                    CanonicalHostedZoneNameID: {},
                    ListenerDescriptions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Listener: {
                            shape: "Sy"
                          },
                          PolicyNames: {
                            shape: "S2s"
                          }
                        }
                      }
                    },
                    Policies: {
                      type: "structure",
                      members: {
                        AppCookieStickinessPolicies: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              PolicyName: {},
                              CookieName: {}
                            }
                          }
                        },
                        LBCookieStickinessPolicies: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              PolicyName: {},
                              CookieExpirationPeriod: {
                                type: "long"
                              }
                            }
                          }
                        },
                        OtherPolicies: {
                          shape: "S2s"
                        }
                      }
                    },
                    BackendServerDescriptions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          InstancePort: {
                            type: "integer"
                          },
                          PolicyNames: {
                            shape: "S2s"
                          }
                        }
                      }
                    },
                    AvailabilityZones: {
                      shape: "S13"
                    },
                    Subnets: {
                      shape: "Se"
                    },
                    VPCId: {},
                    Instances: {
                      shape: "S1p"
                    },
                    HealthCheck: {
                      shape: "Si"
                    },
                    SourceSecurityGroup: {
                      type: "structure",
                      members: {
                        OwnerAlias: {},
                        GroupName: {}
                      }
                    },
                    SecurityGroups: {
                      shape: "Sa"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    },
                    Scheme: {}
                  }
                }
              },
              NextMarker: {}
            }
          }
        },
        DescribeTags: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerNames"
            ],
            members: {
              LoadBalancerNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "DescribeTagsResult",
            type: "structure",
            members: {
              TagDescriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LoadBalancerName: {},
                    Tags: {
                      shape: "S4"
                    }
                  }
                }
              }
            }
          }
        },
        DetachLoadBalancerFromSubnets: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "Subnets"
            ],
            members: {
              LoadBalancerName: {},
              Subnets: {
                shape: "Se"
              }
            }
          },
          output: {
            resultWrapper: "DetachLoadBalancerFromSubnetsResult",
            type: "structure",
            members: {
              Subnets: {
                shape: "Se"
              }
            }
          }
        },
        DisableAvailabilityZonesForLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "AvailabilityZones"
            ],
            members: {
              LoadBalancerName: {},
              AvailabilityZones: {
                shape: "S13"
              }
            }
          },
          output: {
            resultWrapper: "DisableAvailabilityZonesForLoadBalancerResult",
            type: "structure",
            members: {
              AvailabilityZones: {
                shape: "S13"
              }
            }
          }
        },
        EnableAvailabilityZonesForLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "AvailabilityZones"
            ],
            members: {
              LoadBalancerName: {},
              AvailabilityZones: {
                shape: "S13"
              }
            }
          },
          output: {
            resultWrapper: "EnableAvailabilityZonesForLoadBalancerResult",
            type: "structure",
            members: {
              AvailabilityZones: {
                shape: "S13"
              }
            }
          }
        },
        ModifyLoadBalancerAttributes: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "LoadBalancerAttributes"
            ],
            members: {
              LoadBalancerName: {},
              LoadBalancerAttributes: {
                shape: "S2a"
              }
            }
          },
          output: {
            resultWrapper: "ModifyLoadBalancerAttributesResult",
            type: "structure",
            members: {
              LoadBalancerName: {},
              LoadBalancerAttributes: {
                shape: "S2a"
              }
            }
          }
        },
        RegisterInstancesWithLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "Instances"
            ],
            members: {
              LoadBalancerName: {},
              Instances: {
                shape: "S1p"
              }
            }
          },
          output: {
            resultWrapper: "RegisterInstancesWithLoadBalancerResult",
            type: "structure",
            members: {
              Instances: {
                shape: "S1p"
              }
            }
          }
        },
        RemoveTags: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerNames",
              "Tags"
            ],
            members: {
              LoadBalancerNames: {
                shape: "S2"
              },
              Tags: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {}
                  }
                }
              }
            }
          },
          output: {
            resultWrapper: "RemoveTagsResult",
            type: "structure",
            members: {}
          }
        },
        SetLoadBalancerListenerSSLCertificate: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "LoadBalancerPort",
              "SSLCertificateId"
            ],
            members: {
              LoadBalancerName: {},
              LoadBalancerPort: {
                type: "integer"
              },
              SSLCertificateId: {}
            }
          },
          output: {
            resultWrapper: "SetLoadBalancerListenerSSLCertificateResult",
            type: "structure",
            members: {}
          }
        },
        SetLoadBalancerPoliciesForBackendServer: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "InstancePort",
              "PolicyNames"
            ],
            members: {
              LoadBalancerName: {},
              InstancePort: {
                type: "integer"
              },
              PolicyNames: {
                shape: "S2s"
              }
            }
          },
          output: {
            resultWrapper: "SetLoadBalancerPoliciesForBackendServerResult",
            type: "structure",
            members: {}
          }
        },
        SetLoadBalancerPoliciesOfListener: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerName",
              "LoadBalancerPort",
              "PolicyNames"
            ],
            members: {
              LoadBalancerName: {},
              LoadBalancerPort: {
                type: "integer"
              },
              PolicyNames: {
                shape: "S2s"
              }
            }
          },
          output: {
            resultWrapper: "SetLoadBalancerPoliciesOfListenerResult",
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {}
        },
        S4: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sa: {
          type: "list",
          member: {}
        },
        Se: {
          type: "list",
          member: {}
        },
        Si: {
          type: "structure",
          required: [
            "Target",
            "Interval",
            "Timeout",
            "UnhealthyThreshold",
            "HealthyThreshold"
          ],
          members: {
            Target: {},
            Interval: {
              type: "integer"
            },
            Timeout: {
              type: "integer"
            },
            UnhealthyThreshold: {
              type: "integer"
            },
            HealthyThreshold: {
              type: "integer"
            }
          }
        },
        Sx: {
          type: "list",
          member: {
            shape: "Sy"
          }
        },
        Sy: {
          type: "structure",
          required: [
            "Protocol",
            "LoadBalancerPort",
            "InstancePort"
          ],
          members: {
            Protocol: {},
            LoadBalancerPort: {
              type: "integer"
            },
            InstanceProtocol: {},
            InstancePort: {
              type: "integer"
            },
            SSLCertificateId: {}
          }
        },
        S13: {
          type: "list",
          member: {}
        },
        S1p: {
          type: "list",
          member: {
            type: "structure",
            members: {
              InstanceId: {}
            }
          }
        },
        S2a: {
          type: "structure",
          members: {
            CrossZoneLoadBalancing: {
              type: "structure",
              required: [
                "Enabled"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                }
              }
            },
            AccessLog: {
              type: "structure",
              required: [
                "Enabled"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                S3BucketName: {},
                EmitInterval: {
                  type: "integer"
                },
                S3BucketPrefix: {}
              }
            },
            ConnectionDraining: {
              type: "structure",
              required: [
                "Enabled"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                Timeout: {
                  type: "integer"
                }
              }
            },
            ConnectionSettings: {
              type: "structure",
              required: [
                "IdleTimeout"
              ],
              members: {
                IdleTimeout: {
                  type: "integer"
                }
              }
            },
            AdditionalAttributes: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {}
                }
              }
            }
          }
        },
        S2s: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticloadbalancing-2012-06-01.paginators.json
var require_elasticloadbalancing_2012_06_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/elasticloadbalancing-2012-06-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeInstanceHealth: {
          result_key: "InstanceStates"
        },
        DescribeLoadBalancerPolicies: {
          result_key: "PolicyDescriptions"
        },
        DescribeLoadBalancerPolicyTypes: {
          result_key: "PolicyTypeDescriptions"
        },
        DescribeLoadBalancers: {
          input_token: "Marker",
          output_token: "NextMarker",
          result_key: "LoadBalancerDescriptions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticloadbalancing-2012-06-01.waiters2.json
var require_elasticloadbalancing_2012_06_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/elasticloadbalancing-2012-06-01.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        InstanceDeregistered: {
          delay: 15,
          operation: "DescribeInstanceHealth",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "OutOfService",
              matcher: "pathAll",
              state: "success",
              argument: "InstanceStates[].State"
            },
            {
              matcher: "error",
              expected: "InvalidInstance",
              state: "success"
            }
          ]
        },
        AnyInstanceInService: {
          acceptors: [
            {
              argument: "InstanceStates[].State",
              expected: "InService",
              matcher: "pathAny",
              state: "success"
            }
          ],
          delay: 15,
          maxAttempts: 40,
          operation: "DescribeInstanceHealth"
        },
        InstanceInService: {
          acceptors: [
            {
              argument: "InstanceStates[].State",
              expected: "InService",
              matcher: "pathAll",
              state: "success"
            },
            {
              matcher: "error",
              expected: "InvalidInstance",
              state: "retry"
            }
          ],
          delay: 15,
          maxAttempts: 40,
          operation: "DescribeInstanceHealth"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/elb.js
var require_elb = __commonJS({
  "node_modules/aws-sdk/clients/elb.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["elb"] = {};
    AWS3.ELB = Service.defineService("elb", ["2012-06-01"]);
    Object.defineProperty(apiLoader.services["elb"], "2012-06-01", {
      get: function get() {
        var model = require_elasticloadbalancing_2012_06_01_min();
        model.paginators = require_elasticloadbalancing_2012_06_01_paginators().pagination;
        model.waiters = require_elasticloadbalancing_2012_06_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ELB;
  }
});

// node_modules/aws-sdk/apis/elasticloadbalancingv2-2015-12-01.min.json
var require_elasticloadbalancingv2_2015_12_01_min = __commonJS({
  "node_modules/aws-sdk/apis/elasticloadbalancingv2-2015-12-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-12-01",
        endpointPrefix: "elasticloadbalancing",
        protocol: "query",
        serviceAbbreviation: "Elastic Load Balancing v2",
        serviceFullName: "Elastic Load Balancing",
        serviceId: "Elastic Load Balancing v2",
        signatureVersion: "v4",
        uid: "elasticloadbalancingv2-2015-12-01",
        xmlNamespace: "http://elasticloadbalancing.amazonaws.com/doc/2015-12-01/"
      },
      operations: {
        AddListenerCertificates: {
          input: {
            type: "structure",
            required: [
              "ListenerArn",
              "Certificates"
            ],
            members: {
              ListenerArn: {},
              Certificates: {
                shape: "S3"
              }
            }
          },
          output: {
            resultWrapper: "AddListenerCertificatesResult",
            type: "structure",
            members: {
              Certificates: {
                shape: "S3"
              }
            }
          }
        },
        AddTags: {
          input: {
            type: "structure",
            required: [
              "ResourceArns",
              "Tags"
            ],
            members: {
              ResourceArns: {
                shape: "S9"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "AddTagsResult",
            type: "structure",
            members: {}
          }
        },
        CreateListener: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerArn",
              "DefaultActions"
            ],
            members: {
              LoadBalancerArn: {},
              Protocol: {},
              Port: {
                type: "integer"
              },
              SslPolicy: {},
              Certificates: {
                shape: "S3"
              },
              DefaultActions: {
                shape: "Sl"
              },
              AlpnPolicy: {
                shape: "S1y"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateListenerResult",
            type: "structure",
            members: {
              Listeners: {
                shape: "S21"
              }
            }
          }
        },
        CreateLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Subnets: {
                shape: "S25"
              },
              SubnetMappings: {
                shape: "S27"
              },
              SecurityGroups: {
                shape: "S2c"
              },
              Scheme: {},
              Tags: {
                shape: "Sb"
              },
              Type: {},
              IpAddressType: {},
              CustomerOwnedIpv4Pool: {}
            }
          },
          output: {
            resultWrapper: "CreateLoadBalancerResult",
            type: "structure",
            members: {
              LoadBalancers: {
                shape: "S2j"
              }
            }
          }
        },
        CreateRule: {
          input: {
            type: "structure",
            required: [
              "ListenerArn",
              "Conditions",
              "Priority",
              "Actions"
            ],
            members: {
              ListenerArn: {},
              Conditions: {
                shape: "S30"
              },
              Priority: {
                type: "integer"
              },
              Actions: {
                shape: "Sl"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateRuleResult",
            type: "structure",
            members: {
              Rules: {
                shape: "S3g"
              }
            }
          }
        },
        CreateTargetGroup: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Protocol: {},
              ProtocolVersion: {},
              Port: {
                type: "integer"
              },
              VpcId: {},
              HealthCheckProtocol: {},
              HealthCheckPort: {},
              HealthCheckEnabled: {
                type: "boolean"
              },
              HealthCheckPath: {},
              HealthCheckIntervalSeconds: {
                type: "integer"
              },
              HealthCheckTimeoutSeconds: {
                type: "integer"
              },
              HealthyThresholdCount: {
                type: "integer"
              },
              UnhealthyThresholdCount: {
                type: "integer"
              },
              Matcher: {
                shape: "S3u"
              },
              TargetType: {},
              Tags: {
                shape: "Sb"
              },
              IpAddressType: {}
            }
          },
          output: {
            resultWrapper: "CreateTargetGroupResult",
            type: "structure",
            members: {
              TargetGroups: {
                shape: "S40"
              }
            }
          }
        },
        DeleteListener: {
          input: {
            type: "structure",
            required: [
              "ListenerArn"
            ],
            members: {
              ListenerArn: {}
            }
          },
          output: {
            resultWrapper: "DeleteListenerResult",
            type: "structure",
            members: {}
          }
        },
        DeleteLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerArn"
            ],
            members: {
              LoadBalancerArn: {}
            }
          },
          output: {
            resultWrapper: "DeleteLoadBalancerResult",
            type: "structure",
            members: {}
          }
        },
        DeleteRule: {
          input: {
            type: "structure",
            required: [
              "RuleArn"
            ],
            members: {
              RuleArn: {}
            }
          },
          output: {
            resultWrapper: "DeleteRuleResult",
            type: "structure",
            members: {}
          }
        },
        DeleteTargetGroup: {
          input: {
            type: "structure",
            required: [
              "TargetGroupArn"
            ],
            members: {
              TargetGroupArn: {}
            }
          },
          output: {
            resultWrapper: "DeleteTargetGroupResult",
            type: "structure",
            members: {}
          }
        },
        DeregisterTargets: {
          input: {
            type: "structure",
            required: [
              "TargetGroupArn",
              "Targets"
            ],
            members: {
              TargetGroupArn: {},
              Targets: {
                shape: "S4c"
              }
            }
          },
          output: {
            resultWrapper: "DeregisterTargetsResult",
            type: "structure",
            members: {}
          }
        },
        DescribeAccountLimits: {
          input: {
            type: "structure",
            members: {
              Marker: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeAccountLimitsResult",
            type: "structure",
            members: {
              Limits: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Max: {}
                  }
                }
              },
              NextMarker: {}
            }
          }
        },
        DescribeListenerCertificates: {
          input: {
            type: "structure",
            required: [
              "ListenerArn"
            ],
            members: {
              ListenerArn: {},
              Marker: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeListenerCertificatesResult",
            type: "structure",
            members: {
              Certificates: {
                shape: "S3"
              },
              NextMarker: {}
            }
          }
        },
        DescribeListeners: {
          input: {
            type: "structure",
            members: {
              LoadBalancerArn: {},
              ListenerArns: {
                type: "list",
                member: {}
              },
              Marker: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeListenersResult",
            type: "structure",
            members: {
              Listeners: {
                shape: "S21"
              },
              NextMarker: {}
            }
          }
        },
        DescribeLoadBalancerAttributes: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerArn"
            ],
            members: {
              LoadBalancerArn: {}
            }
          },
          output: {
            resultWrapper: "DescribeLoadBalancerAttributesResult",
            type: "structure",
            members: {
              Attributes: {
                shape: "S4v"
              }
            }
          }
        },
        DescribeLoadBalancers: {
          input: {
            type: "structure",
            members: {
              LoadBalancerArns: {
                shape: "S42"
              },
              Names: {
                type: "list",
                member: {}
              },
              Marker: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeLoadBalancersResult",
            type: "structure",
            members: {
              LoadBalancers: {
                shape: "S2j"
              },
              NextMarker: {}
            }
          }
        },
        DescribeRules: {
          input: {
            type: "structure",
            members: {
              ListenerArn: {},
              RuleArns: {
                type: "list",
                member: {}
              },
              Marker: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeRulesResult",
            type: "structure",
            members: {
              Rules: {
                shape: "S3g"
              },
              NextMarker: {}
            }
          }
        },
        DescribeSSLPolicies: {
          input: {
            type: "structure",
            members: {
              Names: {
                type: "list",
                member: {}
              },
              Marker: {},
              PageSize: {
                type: "integer"
              },
              LoadBalancerType: {}
            }
          },
          output: {
            resultWrapper: "DescribeSSLPoliciesResult",
            type: "structure",
            members: {
              SslPolicies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SslProtocols: {
                      type: "list",
                      member: {}
                    },
                    Ciphers: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {},
                          Priority: {
                            type: "integer"
                          }
                        }
                      }
                    },
                    Name: {},
                    SupportedLoadBalancerTypes: {
                      shape: "S33"
                    }
                  }
                }
              },
              NextMarker: {}
            }
          }
        },
        DescribeTags: {
          input: {
            type: "structure",
            required: [
              "ResourceArns"
            ],
            members: {
              ResourceArns: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "DescribeTagsResult",
            type: "structure",
            members: {
              TagDescriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceArn: {},
                    Tags: {
                      shape: "Sb"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeTargetGroupAttributes: {
          input: {
            type: "structure",
            required: [
              "TargetGroupArn"
            ],
            members: {
              TargetGroupArn: {}
            }
          },
          output: {
            resultWrapper: "DescribeTargetGroupAttributesResult",
            type: "structure",
            members: {
              Attributes: {
                shape: "S5m"
              }
            }
          }
        },
        DescribeTargetGroups: {
          input: {
            type: "structure",
            members: {
              LoadBalancerArn: {},
              TargetGroupArns: {
                type: "list",
                member: {}
              },
              Names: {
                type: "list",
                member: {}
              },
              Marker: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeTargetGroupsResult",
            type: "structure",
            members: {
              TargetGroups: {
                shape: "S40"
              },
              NextMarker: {}
            }
          }
        },
        DescribeTargetHealth: {
          input: {
            type: "structure",
            required: [
              "TargetGroupArn"
            ],
            members: {
              TargetGroupArn: {},
              Targets: {
                shape: "S4c"
              }
            }
          },
          output: {
            resultWrapper: "DescribeTargetHealthResult",
            type: "structure",
            members: {
              TargetHealthDescriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Target: {
                      shape: "S4d"
                    },
                    HealthCheckPort: {},
                    TargetHealth: {
                      type: "structure",
                      members: {
                        State: {},
                        Reason: {},
                        Description: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ModifyListener: {
          input: {
            type: "structure",
            required: [
              "ListenerArn"
            ],
            members: {
              ListenerArn: {},
              Port: {
                type: "integer"
              },
              Protocol: {},
              SslPolicy: {},
              Certificates: {
                shape: "S3"
              },
              DefaultActions: {
                shape: "Sl"
              },
              AlpnPolicy: {
                shape: "S1y"
              }
            }
          },
          output: {
            resultWrapper: "ModifyListenerResult",
            type: "structure",
            members: {
              Listeners: {
                shape: "S21"
              }
            }
          }
        },
        ModifyLoadBalancerAttributes: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerArn",
              "Attributes"
            ],
            members: {
              LoadBalancerArn: {},
              Attributes: {
                shape: "S4v"
              }
            }
          },
          output: {
            resultWrapper: "ModifyLoadBalancerAttributesResult",
            type: "structure",
            members: {
              Attributes: {
                shape: "S4v"
              }
            }
          }
        },
        ModifyRule: {
          input: {
            type: "structure",
            required: [
              "RuleArn"
            ],
            members: {
              RuleArn: {},
              Conditions: {
                shape: "S30"
              },
              Actions: {
                shape: "Sl"
              }
            }
          },
          output: {
            resultWrapper: "ModifyRuleResult",
            type: "structure",
            members: {
              Rules: {
                shape: "S3g"
              }
            }
          }
        },
        ModifyTargetGroup: {
          input: {
            type: "structure",
            required: [
              "TargetGroupArn"
            ],
            members: {
              TargetGroupArn: {},
              HealthCheckProtocol: {},
              HealthCheckPort: {},
              HealthCheckPath: {},
              HealthCheckEnabled: {
                type: "boolean"
              },
              HealthCheckIntervalSeconds: {
                type: "integer"
              },
              HealthCheckTimeoutSeconds: {
                type: "integer"
              },
              HealthyThresholdCount: {
                type: "integer"
              },
              UnhealthyThresholdCount: {
                type: "integer"
              },
              Matcher: {
                shape: "S3u"
              }
            }
          },
          output: {
            resultWrapper: "ModifyTargetGroupResult",
            type: "structure",
            members: {
              TargetGroups: {
                shape: "S40"
              }
            }
          }
        },
        ModifyTargetGroupAttributes: {
          input: {
            type: "structure",
            required: [
              "TargetGroupArn",
              "Attributes"
            ],
            members: {
              TargetGroupArn: {},
              Attributes: {
                shape: "S5m"
              }
            }
          },
          output: {
            resultWrapper: "ModifyTargetGroupAttributesResult",
            type: "structure",
            members: {
              Attributes: {
                shape: "S5m"
              }
            }
          }
        },
        RegisterTargets: {
          input: {
            type: "structure",
            required: [
              "TargetGroupArn",
              "Targets"
            ],
            members: {
              TargetGroupArn: {},
              Targets: {
                shape: "S4c"
              }
            }
          },
          output: {
            resultWrapper: "RegisterTargetsResult",
            type: "structure",
            members: {}
          }
        },
        RemoveListenerCertificates: {
          input: {
            type: "structure",
            required: [
              "ListenerArn",
              "Certificates"
            ],
            members: {
              ListenerArn: {},
              Certificates: {
                shape: "S3"
              }
            }
          },
          output: {
            resultWrapper: "RemoveListenerCertificatesResult",
            type: "structure",
            members: {}
          }
        },
        RemoveTags: {
          input: {
            type: "structure",
            required: [
              "ResourceArns",
              "TagKeys"
            ],
            members: {
              ResourceArns: {
                shape: "S9"
              },
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "RemoveTagsResult",
            type: "structure",
            members: {}
          }
        },
        SetIpAddressType: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerArn",
              "IpAddressType"
            ],
            members: {
              LoadBalancerArn: {},
              IpAddressType: {}
            }
          },
          output: {
            resultWrapper: "SetIpAddressTypeResult",
            type: "structure",
            members: {
              IpAddressType: {}
            }
          }
        },
        SetRulePriorities: {
          input: {
            type: "structure",
            required: [
              "RulePriorities"
            ],
            members: {
              RulePriorities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RuleArn: {},
                    Priority: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          },
          output: {
            resultWrapper: "SetRulePrioritiesResult",
            type: "structure",
            members: {
              Rules: {
                shape: "S3g"
              }
            }
          }
        },
        SetSecurityGroups: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerArn",
              "SecurityGroups"
            ],
            members: {
              LoadBalancerArn: {},
              SecurityGroups: {
                shape: "S2c"
              }
            }
          },
          output: {
            resultWrapper: "SetSecurityGroupsResult",
            type: "structure",
            members: {
              SecurityGroupIds: {
                shape: "S2c"
              }
            }
          }
        },
        SetSubnets: {
          input: {
            type: "structure",
            required: [
              "LoadBalancerArn"
            ],
            members: {
              LoadBalancerArn: {},
              Subnets: {
                shape: "S25"
              },
              SubnetMappings: {
                shape: "S27"
              },
              IpAddressType: {}
            }
          },
          output: {
            resultWrapper: "SetSubnetsResult",
            type: "structure",
            members: {
              AvailabilityZones: {
                shape: "S2s"
              },
              IpAddressType: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            members: {
              CertificateArn: {},
              IsDefault: {
                type: "boolean"
              }
            }
          }
        },
        S9: {
          type: "list",
          member: {}
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sl: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Type"
            ],
            members: {
              Type: {},
              TargetGroupArn: {},
              AuthenticateOidcConfig: {
                type: "structure",
                required: [
                  "Issuer",
                  "AuthorizationEndpoint",
                  "TokenEndpoint",
                  "UserInfoEndpoint",
                  "ClientId"
                ],
                members: {
                  Issuer: {},
                  AuthorizationEndpoint: {},
                  TokenEndpoint: {},
                  UserInfoEndpoint: {},
                  ClientId: {},
                  ClientSecret: {},
                  SessionCookieName: {},
                  Scope: {},
                  SessionTimeout: {
                    type: "long"
                  },
                  AuthenticationRequestExtraParams: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  OnUnauthenticatedRequest: {},
                  UseExistingClientSecret: {
                    type: "boolean"
                  }
                }
              },
              AuthenticateCognitoConfig: {
                type: "structure",
                required: [
                  "UserPoolArn",
                  "UserPoolClientId",
                  "UserPoolDomain"
                ],
                members: {
                  UserPoolArn: {},
                  UserPoolClientId: {},
                  UserPoolDomain: {},
                  SessionCookieName: {},
                  Scope: {},
                  SessionTimeout: {
                    type: "long"
                  },
                  AuthenticationRequestExtraParams: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  OnUnauthenticatedRequest: {}
                }
              },
              Order: {
                type: "integer"
              },
              RedirectConfig: {
                type: "structure",
                required: [
                  "StatusCode"
                ],
                members: {
                  Protocol: {},
                  Port: {},
                  Host: {},
                  Path: {},
                  Query: {},
                  StatusCode: {}
                }
              },
              FixedResponseConfig: {
                type: "structure",
                required: [
                  "StatusCode"
                ],
                members: {
                  MessageBody: {},
                  StatusCode: {},
                  ContentType: {}
                }
              },
              ForwardConfig: {
                type: "structure",
                members: {
                  TargetGroups: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        TargetGroupArn: {},
                        Weight: {
                          type: "integer"
                        }
                      }
                    }
                  },
                  TargetGroupStickinessConfig: {
                    type: "structure",
                    members: {
                      Enabled: {
                        type: "boolean"
                      },
                      DurationSeconds: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S1y: {
          type: "list",
          member: {}
        },
        S21: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ListenerArn: {},
              LoadBalancerArn: {},
              Port: {
                type: "integer"
              },
              Protocol: {},
              Certificates: {
                shape: "S3"
              },
              SslPolicy: {},
              DefaultActions: {
                shape: "Sl"
              },
              AlpnPolicy: {
                shape: "S1y"
              }
            }
          }
        },
        S25: {
          type: "list",
          member: {}
        },
        S27: {
          type: "list",
          member: {
            type: "structure",
            members: {
              SubnetId: {},
              AllocationId: {},
              PrivateIPv4Address: {},
              IPv6Address: {}
            }
          }
        },
        S2c: {
          type: "list",
          member: {}
        },
        S2j: {
          type: "list",
          member: {
            type: "structure",
            members: {
              LoadBalancerArn: {},
              DNSName: {},
              CanonicalHostedZoneId: {},
              CreatedTime: {
                type: "timestamp"
              },
              LoadBalancerName: {},
              Scheme: {},
              VpcId: {},
              State: {
                type: "structure",
                members: {
                  Code: {},
                  Reason: {}
                }
              },
              Type: {},
              AvailabilityZones: {
                shape: "S2s"
              },
              SecurityGroups: {
                shape: "S2c"
              },
              IpAddressType: {},
              CustomerOwnedIpv4Pool: {}
            }
          }
        },
        S2s: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ZoneName: {},
              SubnetId: {},
              OutpostId: {},
              LoadBalancerAddresses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IpAddress: {},
                    AllocationId: {},
                    PrivateIPv4Address: {},
                    IPv6Address: {}
                  }
                }
              }
            }
          }
        },
        S30: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Field: {},
              Values: {
                shape: "S33"
              },
              HostHeaderConfig: {
                type: "structure",
                members: {
                  Values: {
                    shape: "S33"
                  }
                }
              },
              PathPatternConfig: {
                type: "structure",
                members: {
                  Values: {
                    shape: "S33"
                  }
                }
              },
              HttpHeaderConfig: {
                type: "structure",
                members: {
                  HttpHeaderName: {},
                  Values: {
                    shape: "S33"
                  }
                }
              },
              QueryStringConfig: {
                type: "structure",
                members: {
                  Values: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Key: {},
                        Value: {}
                      }
                    }
                  }
                }
              },
              HttpRequestMethodConfig: {
                type: "structure",
                members: {
                  Values: {
                    shape: "S33"
                  }
                }
              },
              SourceIpConfig: {
                type: "structure",
                members: {
                  Values: {
                    shape: "S33"
                  }
                }
              }
            }
          }
        },
        S33: {
          type: "list",
          member: {}
        },
        S3g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              RuleArn: {},
              Priority: {},
              Conditions: {
                shape: "S30"
              },
              Actions: {
                shape: "Sl"
              },
              IsDefault: {
                type: "boolean"
              }
            }
          }
        },
        S3u: {
          type: "structure",
          members: {
            HttpCode: {},
            GrpcCode: {}
          }
        },
        S40: {
          type: "list",
          member: {
            type: "structure",
            members: {
              TargetGroupArn: {},
              TargetGroupName: {},
              Protocol: {},
              Port: {
                type: "integer"
              },
              VpcId: {},
              HealthCheckProtocol: {},
              HealthCheckPort: {},
              HealthCheckEnabled: {
                type: "boolean"
              },
              HealthCheckIntervalSeconds: {
                type: "integer"
              },
              HealthCheckTimeoutSeconds: {
                type: "integer"
              },
              HealthyThresholdCount: {
                type: "integer"
              },
              UnhealthyThresholdCount: {
                type: "integer"
              },
              HealthCheckPath: {},
              Matcher: {
                shape: "S3u"
              },
              LoadBalancerArns: {
                shape: "S42"
              },
              TargetType: {},
              ProtocolVersion: {},
              IpAddressType: {}
            }
          }
        },
        S42: {
          type: "list",
          member: {}
        },
        S4c: {
          type: "list",
          member: {
            shape: "S4d"
          }
        },
        S4d: {
          type: "structure",
          required: [
            "Id"
          ],
          members: {
            Id: {},
            Port: {
              type: "integer"
            },
            AvailabilityZone: {}
          }
        },
        S4v: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S5m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticloadbalancingv2-2015-12-01.paginators.json
var require_elasticloadbalancingv2_2015_12_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/elasticloadbalancingv2-2015-12-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeListeners: {
          input_token: "Marker",
          output_token: "NextMarker",
          result_key: "Listeners"
        },
        DescribeLoadBalancers: {
          input_token: "Marker",
          output_token: "NextMarker",
          result_key: "LoadBalancers"
        },
        DescribeTargetGroups: {
          input_token: "Marker",
          output_token: "NextMarker",
          result_key: "TargetGroups"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticloadbalancingv2-2015-12-01.waiters2.json
var require_elasticloadbalancingv2_2015_12_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/elasticloadbalancingv2-2015-12-01.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        LoadBalancerExists: {
          delay: 15,
          operation: "DescribeLoadBalancers",
          maxAttempts: 40,
          acceptors: [
            {
              matcher: "status",
              expected: 200,
              state: "success"
            },
            {
              matcher: "error",
              expected: "LoadBalancerNotFound",
              state: "retry"
            }
          ]
        },
        LoadBalancerAvailable: {
          delay: 15,
          operation: "DescribeLoadBalancers",
          maxAttempts: 40,
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "LoadBalancers[].State.Code",
              expected: "active"
            },
            {
              state: "retry",
              matcher: "pathAny",
              argument: "LoadBalancers[].State.Code",
              expected: "provisioning"
            },
            {
              state: "retry",
              matcher: "error",
              expected: "LoadBalancerNotFound"
            }
          ]
        },
        LoadBalancersDeleted: {
          delay: 15,
          operation: "DescribeLoadBalancers",
          maxAttempts: 40,
          acceptors: [
            {
              state: "retry",
              matcher: "pathAll",
              argument: "LoadBalancers[].State.Code",
              expected: "active"
            },
            {
              matcher: "error",
              expected: "LoadBalancerNotFound",
              state: "success"
            }
          ]
        },
        TargetInService: {
          delay: 15,
          maxAttempts: 40,
          operation: "DescribeTargetHealth",
          acceptors: [
            {
              argument: "TargetHealthDescriptions[].TargetHealth.State",
              expected: "healthy",
              matcher: "pathAll",
              state: "success"
            },
            {
              matcher: "error",
              expected: "InvalidInstance",
              state: "retry"
            }
          ]
        },
        TargetDeregistered: {
          delay: 15,
          maxAttempts: 40,
          operation: "DescribeTargetHealth",
          acceptors: [
            {
              matcher: "error",
              expected: "InvalidTarget",
              state: "success"
            },
            {
              argument: "TargetHealthDescriptions[].TargetHealth.State",
              expected: "unused",
              matcher: "pathAll",
              state: "success"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/elbv2.js
var require_elbv2 = __commonJS({
  "node_modules/aws-sdk/clients/elbv2.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["elbv2"] = {};
    AWS3.ELBv2 = Service.defineService("elbv2", ["2015-12-01"]);
    Object.defineProperty(apiLoader.services["elbv2"], "2015-12-01", {
      get: function get() {
        var model = require_elasticloadbalancingv2_2015_12_01_min();
        model.paginators = require_elasticloadbalancingv2_2015_12_01_paginators().pagination;
        model.waiters = require_elasticloadbalancingv2_2015_12_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ELBv2;
  }
});

// node_modules/aws-sdk/apis/elasticmapreduce-2009-03-31.min.json
var require_elasticmapreduce_2009_03_31_min = __commonJS({
  "node_modules/aws-sdk/apis/elasticmapreduce-2009-03-31.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2009-03-31",
        endpointPrefix: "elasticmapreduce",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Amazon EMR",
        serviceFullName: "Amazon EMR",
        serviceId: "EMR",
        signatureVersion: "v4",
        targetPrefix: "ElasticMapReduce",
        uid: "elasticmapreduce-2009-03-31"
      },
      operations: {
        AddInstanceFleet: {
          input: {
            type: "structure",
            required: [
              "ClusterId",
              "InstanceFleet"
            ],
            members: {
              ClusterId: {},
              InstanceFleet: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClusterId: {},
              InstanceFleetId: {},
              ClusterArn: {}
            }
          }
        },
        AddInstanceGroups: {
          input: {
            type: "structure",
            required: [
              "InstanceGroups",
              "JobFlowId"
            ],
            members: {
              InstanceGroups: {
                shape: "Sx"
              },
              JobFlowId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobFlowId: {},
              InstanceGroupIds: {
                type: "list",
                member: {}
              },
              ClusterArn: {}
            }
          }
        },
        AddJobFlowSteps: {
          input: {
            type: "structure",
            required: [
              "JobFlowId",
              "Steps"
            ],
            members: {
              JobFlowId: {},
              Steps: {
                shape: "S1i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StepIds: {
                shape: "S1r"
              }
            }
          }
        },
        AddTags: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "Tags"
            ],
            members: {
              ResourceId: {},
              Tags: {
                shape: "S1u"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelSteps: {
          input: {
            type: "structure",
            required: [
              "ClusterId",
              "StepIds"
            ],
            members: {
              ClusterId: {},
              StepIds: {
                shape: "S1r"
              },
              StepCancellationOption: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CancelStepsInfoList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StepId: {},
                    Status: {},
                    Reason: {}
                  }
                }
              }
            }
          }
        },
        CreateSecurityConfiguration: {
          input: {
            type: "structure",
            required: [
              "Name",
              "SecurityConfiguration"
            ],
            members: {
              Name: {},
              SecurityConfiguration: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Name",
              "CreationDateTime"
            ],
            members: {
              Name: {},
              CreationDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateStudio: {
          input: {
            type: "structure",
            required: [
              "Name",
              "AuthMode",
              "VpcId",
              "SubnetIds",
              "ServiceRole",
              "WorkspaceSecurityGroupId",
              "EngineSecurityGroupId",
              "DefaultS3Location"
            ],
            members: {
              Name: {},
              Description: {},
              AuthMode: {},
              VpcId: {},
              SubnetIds: {
                shape: "S29"
              },
              ServiceRole: {},
              UserRole: {},
              WorkspaceSecurityGroupId: {},
              EngineSecurityGroupId: {},
              DefaultS3Location: {},
              IdpAuthUrl: {},
              IdpRelayStateParameterName: {},
              Tags: {
                shape: "S1u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StudioId: {},
              Url: {}
            }
          }
        },
        CreateStudioSessionMapping: {
          input: {
            type: "structure",
            required: [
              "StudioId",
              "IdentityType",
              "SessionPolicyArn"
            ],
            members: {
              StudioId: {},
              IdentityId: {},
              IdentityName: {},
              IdentityType: {},
              SessionPolicyArn: {}
            }
          }
        },
        DeleteSecurityConfiguration: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteStudio: {
          input: {
            type: "structure",
            required: [
              "StudioId"
            ],
            members: {
              StudioId: {}
            }
          }
        },
        DeleteStudioSessionMapping: {
          input: {
            type: "structure",
            required: [
              "StudioId",
              "IdentityType"
            ],
            members: {
              StudioId: {},
              IdentityId: {},
              IdentityName: {},
              IdentityType: {}
            }
          }
        },
        DescribeCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                type: "structure",
                members: {
                  Id: {},
                  Name: {},
                  Status: {
                    shape: "S2l"
                  },
                  Ec2InstanceAttributes: {
                    type: "structure",
                    members: {
                      Ec2KeyName: {},
                      Ec2SubnetId: {},
                      RequestedEc2SubnetIds: {
                        shape: "S2r"
                      },
                      Ec2AvailabilityZone: {},
                      RequestedEc2AvailabilityZones: {
                        shape: "S2r"
                      },
                      IamInstanceProfile: {},
                      EmrManagedMasterSecurityGroup: {},
                      EmrManagedSlaveSecurityGroup: {},
                      ServiceAccessSecurityGroup: {},
                      AdditionalMasterSecurityGroups: {
                        shape: "S2s"
                      },
                      AdditionalSlaveSecurityGroups: {
                        shape: "S2s"
                      }
                    }
                  },
                  InstanceCollectionType: {},
                  LogUri: {},
                  LogEncryptionKmsKeyId: {},
                  RequestedAmiVersion: {},
                  RunningAmiVersion: {},
                  ReleaseLabel: {},
                  AutoTerminate: {
                    type: "boolean"
                  },
                  TerminationProtected: {
                    type: "boolean"
                  },
                  VisibleToAllUsers: {
                    type: "boolean"
                  },
                  Applications: {
                    shape: "S2v"
                  },
                  Tags: {
                    shape: "S1u"
                  },
                  ServiceRole: {},
                  NormalizedInstanceHours: {
                    type: "integer"
                  },
                  MasterPublicDnsName: {},
                  Configurations: {
                    shape: "Sh"
                  },
                  SecurityConfiguration: {},
                  AutoScalingRole: {},
                  ScaleDownBehavior: {},
                  CustomAmiId: {},
                  EbsRootVolumeSize: {
                    type: "integer"
                  },
                  RepoUpgradeOnBoot: {},
                  KerberosAttributes: {
                    shape: "S2z"
                  },
                  ClusterArn: {},
                  OutpostArn: {},
                  StepConcurrencyLevel: {
                    type: "integer"
                  },
                  PlacementGroups: {
                    shape: "S31"
                  }
                }
              }
            }
          }
        },
        DescribeJobFlows: {
          input: {
            type: "structure",
            members: {
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              JobFlowIds: {
                shape: "S1p"
              },
              JobFlowStates: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobFlows: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "JobFlowId",
                    "Name",
                    "ExecutionStatusDetail",
                    "Instances"
                  ],
                  members: {
                    JobFlowId: {},
                    Name: {},
                    LogUri: {},
                    LogEncryptionKmsKeyId: {},
                    AmiVersion: {},
                    ExecutionStatusDetail: {
                      type: "structure",
                      required: [
                        "State",
                        "CreationDateTime"
                      ],
                      members: {
                        State: {},
                        CreationDateTime: {
                          type: "timestamp"
                        },
                        StartDateTime: {
                          type: "timestamp"
                        },
                        ReadyDateTime: {
                          type: "timestamp"
                        },
                        EndDateTime: {
                          type: "timestamp"
                        },
                        LastStateChangeReason: {}
                      }
                    },
                    Instances: {
                      type: "structure",
                      required: [
                        "MasterInstanceType",
                        "SlaveInstanceType",
                        "InstanceCount"
                      ],
                      members: {
                        MasterInstanceType: {},
                        MasterPublicDnsName: {},
                        MasterInstanceId: {},
                        SlaveInstanceType: {},
                        InstanceCount: {
                          type: "integer"
                        },
                        InstanceGroups: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "Market",
                              "InstanceRole",
                              "InstanceType",
                              "InstanceRequestCount",
                              "InstanceRunningCount",
                              "State",
                              "CreationDateTime"
                            ],
                            members: {
                              InstanceGroupId: {},
                              Name: {},
                              Market: {},
                              InstanceRole: {},
                              BidPrice: {},
                              InstanceType: {},
                              InstanceRequestCount: {
                                type: "integer"
                              },
                              InstanceRunningCount: {
                                type: "integer"
                              },
                              State: {},
                              LastStateChangeReason: {},
                              CreationDateTime: {
                                type: "timestamp"
                              },
                              StartDateTime: {
                                type: "timestamp"
                              },
                              ReadyDateTime: {
                                type: "timestamp"
                              },
                              EndDateTime: {
                                type: "timestamp"
                              },
                              CustomAmiId: {}
                            }
                          }
                        },
                        NormalizedInstanceHours: {
                          type: "integer"
                        },
                        Ec2KeyName: {},
                        Ec2SubnetId: {},
                        Placement: {
                          shape: "S3f"
                        },
                        KeepJobFlowAliveWhenNoSteps: {
                          type: "boolean"
                        },
                        TerminationProtected: {
                          type: "boolean"
                        },
                        HadoopVersion: {}
                      }
                    },
                    Steps: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "StepConfig",
                          "ExecutionStatusDetail"
                        ],
                        members: {
                          StepConfig: {
                            shape: "S1j"
                          },
                          ExecutionStatusDetail: {
                            type: "structure",
                            required: [
                              "State",
                              "CreationDateTime"
                            ],
                            members: {
                              State: {},
                              CreationDateTime: {
                                type: "timestamp"
                              },
                              StartDateTime: {
                                type: "timestamp"
                              },
                              EndDateTime: {
                                type: "timestamp"
                              },
                              LastStateChangeReason: {}
                            }
                          }
                        }
                      }
                    },
                    BootstrapActions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          BootstrapActionConfig: {
                            shape: "S3m"
                          }
                        }
                      }
                    },
                    SupportedProducts: {
                      shape: "S3o"
                    },
                    VisibleToAllUsers: {
                      type: "boolean"
                    },
                    JobFlowRole: {},
                    ServiceRole: {},
                    AutoScalingRole: {},
                    ScaleDownBehavior: {}
                  }
                }
              }
            }
          },
          deprecated: true
        },
        DescribeNotebookExecution: {
          input: {
            type: "structure",
            required: [
              "NotebookExecutionId"
            ],
            members: {
              NotebookExecutionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NotebookExecution: {
                type: "structure",
                members: {
                  NotebookExecutionId: {},
                  EditorId: {},
                  ExecutionEngine: {
                    shape: "S3s"
                  },
                  NotebookExecutionName: {},
                  NotebookParams: {},
                  Status: {},
                  StartTime: {
                    type: "timestamp"
                  },
                  EndTime: {
                    type: "timestamp"
                  },
                  Arn: {},
                  OutputNotebookURI: {},
                  LastStateChangeReason: {},
                  NotebookInstanceSecurityGroupId: {},
                  Tags: {
                    shape: "S1u"
                  }
                }
              }
            }
          }
        },
        DescribeReleaseLabel: {
          input: {
            type: "structure",
            members: {
              ReleaseLabel: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReleaseLabel: {},
              Applications: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Version: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeSecurityConfiguration: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              SecurityConfiguration: {},
              CreationDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeStep: {
          input: {
            type: "structure",
            required: [
              "ClusterId",
              "StepId"
            ],
            members: {
              ClusterId: {},
              StepId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Step: {
                type: "structure",
                members: {
                  Id: {},
                  Name: {},
                  Config: {
                    shape: "S45"
                  },
                  ActionOnFailure: {},
                  Status: {
                    shape: "S46"
                  }
                }
              }
            }
          }
        },
        DescribeStudio: {
          input: {
            type: "structure",
            required: [
              "StudioId"
            ],
            members: {
              StudioId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Studio: {
                type: "structure",
                members: {
                  StudioId: {},
                  StudioArn: {},
                  Name: {},
                  Description: {},
                  AuthMode: {},
                  VpcId: {},
                  SubnetIds: {
                    shape: "S29"
                  },
                  ServiceRole: {},
                  UserRole: {},
                  WorkspaceSecurityGroupId: {},
                  EngineSecurityGroupId: {},
                  Url: {},
                  CreationTime: {
                    type: "timestamp"
                  },
                  DefaultS3Location: {},
                  IdpAuthUrl: {},
                  IdpRelayStateParameterName: {},
                  Tags: {
                    shape: "S1u"
                  }
                }
              }
            }
          }
        },
        GetAutoTerminationPolicy: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AutoTerminationPolicy: {
                shape: "S4h"
              }
            }
          }
        },
        GetBlockPublicAccessConfiguration: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "BlockPublicAccessConfiguration",
              "BlockPublicAccessConfigurationMetadata"
            ],
            members: {
              BlockPublicAccessConfiguration: {
                shape: "S4l"
              },
              BlockPublicAccessConfigurationMetadata: {
                type: "structure",
                required: [
                  "CreationDateTime",
                  "CreatedByArn"
                ],
                members: {
                  CreationDateTime: {
                    type: "timestamp"
                  },
                  CreatedByArn: {}
                }
              }
            }
          }
        },
        GetManagedScalingPolicy: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ManagedScalingPolicy: {
                shape: "S4s"
              }
            }
          }
        },
        GetStudioSessionMapping: {
          input: {
            type: "structure",
            required: [
              "StudioId",
              "IdentityType"
            ],
            members: {
              StudioId: {},
              IdentityId: {},
              IdentityName: {},
              IdentityType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SessionMapping: {
                type: "structure",
                members: {
                  StudioId: {},
                  IdentityId: {},
                  IdentityName: {},
                  IdentityType: {},
                  SessionPolicyArn: {},
                  CreationTime: {
                    type: "timestamp"
                  },
                  LastModifiedTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        ListBootstrapActions: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BootstrapActions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    ScriptPath: {},
                    Args: {
                      shape: "S2s"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListClusters: {
          input: {
            type: "structure",
            members: {
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              ClusterStates: {
                type: "list",
                member: {}
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Clusters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Status: {
                      shape: "S2l"
                    },
                    NormalizedInstanceHours: {
                      type: "integer"
                    },
                    ClusterArn: {},
                    OutpostArn: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListInstanceFleets: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceFleets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Status: {
                      type: "structure",
                      members: {
                        State: {},
                        StateChangeReason: {
                          type: "structure",
                          members: {
                            Code: {},
                            Message: {}
                          }
                        },
                        Timeline: {
                          type: "structure",
                          members: {
                            CreationDateTime: {
                              type: "timestamp"
                            },
                            ReadyDateTime: {
                              type: "timestamp"
                            },
                            EndDateTime: {
                              type: "timestamp"
                            }
                          }
                        }
                      }
                    },
                    InstanceFleetType: {},
                    TargetOnDemandCapacity: {
                      type: "integer"
                    },
                    TargetSpotCapacity: {
                      type: "integer"
                    },
                    ProvisionedOnDemandCapacity: {
                      type: "integer"
                    },
                    ProvisionedSpotCapacity: {
                      type: "integer"
                    },
                    InstanceTypeSpecifications: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          InstanceType: {},
                          WeightedCapacity: {
                            type: "integer"
                          },
                          BidPrice: {},
                          BidPriceAsPercentageOfOnDemandPrice: {
                            type: "double"
                          },
                          Configurations: {
                            shape: "Sh"
                          },
                          EbsBlockDevices: {
                            shape: "S5j"
                          },
                          EbsOptimized: {
                            type: "boolean"
                          },
                          CustomAmiId: {}
                        }
                      }
                    },
                    LaunchSpecifications: {
                      shape: "Sk"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListInstanceGroups: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Market: {},
                    InstanceGroupType: {},
                    BidPrice: {},
                    InstanceType: {},
                    RequestedInstanceCount: {
                      type: "integer"
                    },
                    RunningInstanceCount: {
                      type: "integer"
                    },
                    Status: {
                      type: "structure",
                      members: {
                        State: {},
                        StateChangeReason: {
                          type: "structure",
                          members: {
                            Code: {},
                            Message: {}
                          }
                        },
                        Timeline: {
                          type: "structure",
                          members: {
                            CreationDateTime: {
                              type: "timestamp"
                            },
                            ReadyDateTime: {
                              type: "timestamp"
                            },
                            EndDateTime: {
                              type: "timestamp"
                            }
                          }
                        }
                      }
                    },
                    Configurations: {
                      shape: "Sh"
                    },
                    ConfigurationsVersion: {
                      type: "long"
                    },
                    LastSuccessfullyAppliedConfigurations: {
                      shape: "Sh"
                    },
                    LastSuccessfullyAppliedConfigurationsVersion: {
                      type: "long"
                    },
                    EbsBlockDevices: {
                      shape: "S5j"
                    },
                    EbsOptimized: {
                      type: "boolean"
                    },
                    ShrinkPolicy: {
                      shape: "S5v"
                    },
                    AutoScalingPolicy: {
                      shape: "S5z"
                    },
                    CustomAmiId: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListInstances: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              InstanceGroupId: {},
              InstanceGroupTypes: {
                type: "list",
                member: {}
              },
              InstanceFleetId: {},
              InstanceFleetType: {},
              InstanceStates: {
                type: "list",
                member: {}
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Instances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Ec2InstanceId: {},
                    PublicDnsName: {},
                    PublicIpAddress: {},
                    PrivateDnsName: {},
                    PrivateIpAddress: {},
                    Status: {
                      type: "structure",
                      members: {
                        State: {},
                        StateChangeReason: {
                          type: "structure",
                          members: {
                            Code: {},
                            Message: {}
                          }
                        },
                        Timeline: {
                          type: "structure",
                          members: {
                            CreationDateTime: {
                              type: "timestamp"
                            },
                            ReadyDateTime: {
                              type: "timestamp"
                            },
                            EndDateTime: {
                              type: "timestamp"
                            }
                          }
                        }
                      }
                    },
                    InstanceGroupId: {},
                    InstanceFleetId: {},
                    Market: {},
                    InstanceType: {},
                    EbsVolumes: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Device: {},
                          VolumeId: {}
                        }
                      }
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListNotebookExecutions: {
          input: {
            type: "structure",
            members: {
              EditorId: {},
              Status: {},
              From: {
                type: "timestamp"
              },
              To: {
                type: "timestamp"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NotebookExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    NotebookExecutionId: {},
                    EditorId: {},
                    NotebookExecutionName: {},
                    Status: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListReleaseLabels: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "structure",
                members: {
                  Prefix: {},
                  Application: {}
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReleaseLabels: {
                shape: "S2s"
              },
              NextToken: {}
            }
          }
        },
        ListSecurityConfigurations: {
          input: {
            type: "structure",
            members: {
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    CreationDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListSteps: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              StepStates: {
                type: "list",
                member: {}
              },
              StepIds: {
                shape: "S1p"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Steps: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Config: {
                      shape: "S45"
                    },
                    ActionOnFailure: {},
                    Status: {
                      shape: "S46"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListStudioSessionMappings: {
          input: {
            type: "structure",
            members: {
              StudioId: {},
              IdentityType: {},
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SessionMappings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StudioId: {},
                    IdentityId: {},
                    IdentityName: {},
                    IdentityType: {},
                    SessionPolicyArn: {},
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListStudios: {
          input: {
            type: "structure",
            members: {
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Studios: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StudioId: {},
                    Name: {},
                    VpcId: {},
                    Description: {},
                    Url: {},
                    AuthMode: {},
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ModifyCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              StepConcurrencyLevel: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StepConcurrencyLevel: {
                type: "integer"
              }
            }
          }
        },
        ModifyInstanceFleet: {
          input: {
            type: "structure",
            required: [
              "ClusterId",
              "InstanceFleet"
            ],
            members: {
              ClusterId: {},
              InstanceFleet: {
                type: "structure",
                required: [
                  "InstanceFleetId"
                ],
                members: {
                  InstanceFleetId: {},
                  TargetOnDemandCapacity: {
                    type: "integer"
                  },
                  TargetSpotCapacity: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        ModifyInstanceGroups: {
          input: {
            type: "structure",
            members: {
              ClusterId: {},
              InstanceGroups: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "InstanceGroupId"
                  ],
                  members: {
                    InstanceGroupId: {},
                    InstanceCount: {
                      type: "integer"
                    },
                    EC2InstanceIdsToTerminate: {
                      type: "list",
                      member: {}
                    },
                    ShrinkPolicy: {
                      shape: "S5v"
                    },
                    Configurations: {
                      shape: "Sh"
                    }
                  }
                }
              }
            }
          }
        },
        PutAutoScalingPolicy: {
          input: {
            type: "structure",
            required: [
              "ClusterId",
              "InstanceGroupId",
              "AutoScalingPolicy"
            ],
            members: {
              ClusterId: {},
              InstanceGroupId: {},
              AutoScalingPolicy: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClusterId: {},
              InstanceGroupId: {},
              AutoScalingPolicy: {
                shape: "S5z"
              },
              ClusterArn: {}
            }
          }
        },
        PutAutoTerminationPolicy: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              AutoTerminationPolicy: {
                shape: "S4h"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutBlockPublicAccessConfiguration: {
          input: {
            type: "structure",
            required: [
              "BlockPublicAccessConfiguration"
            ],
            members: {
              BlockPublicAccessConfiguration: {
                shape: "S4l"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutManagedScalingPolicy: {
          input: {
            type: "structure",
            required: [
              "ClusterId",
              "ManagedScalingPolicy"
            ],
            members: {
              ClusterId: {},
              ManagedScalingPolicy: {
                shape: "S4s"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RemoveAutoScalingPolicy: {
          input: {
            type: "structure",
            required: [
              "ClusterId",
              "InstanceGroupId"
            ],
            members: {
              ClusterId: {},
              InstanceGroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RemoveAutoTerminationPolicy: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RemoveManagedScalingPolicy: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RemoveTags: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "TagKeys"
            ],
            members: {
              ResourceId: {},
              TagKeys: {
                shape: "S2s"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RunJobFlow: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Instances"
            ],
            members: {
              Name: {},
              LogUri: {},
              LogEncryptionKmsKeyId: {},
              AdditionalInfo: {},
              AmiVersion: {},
              ReleaseLabel: {},
              Instances: {
                type: "structure",
                members: {
                  MasterInstanceType: {},
                  SlaveInstanceType: {},
                  InstanceCount: {
                    type: "integer"
                  },
                  InstanceGroups: {
                    shape: "Sx"
                  },
                  InstanceFleets: {
                    type: "list",
                    member: {
                      shape: "S3"
                    }
                  },
                  Ec2KeyName: {},
                  Placement: {
                    shape: "S3f"
                  },
                  KeepJobFlowAliveWhenNoSteps: {
                    type: "boolean"
                  },
                  TerminationProtected: {
                    type: "boolean"
                  },
                  HadoopVersion: {},
                  Ec2SubnetId: {},
                  Ec2SubnetIds: {
                    shape: "S2r"
                  },
                  EmrManagedMasterSecurityGroup: {},
                  EmrManagedSlaveSecurityGroup: {},
                  ServiceAccessSecurityGroup: {},
                  AdditionalMasterSecurityGroups: {
                    shape: "S7w"
                  },
                  AdditionalSlaveSecurityGroups: {
                    shape: "S7w"
                  }
                }
              },
              Steps: {
                shape: "S1i"
              },
              BootstrapActions: {
                type: "list",
                member: {
                  shape: "S3m"
                }
              },
              SupportedProducts: {
                shape: "S3o"
              },
              NewSupportedProducts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Args: {
                      shape: "S1p"
                    }
                  }
                }
              },
              Applications: {
                shape: "S2v"
              },
              Configurations: {
                shape: "Sh"
              },
              VisibleToAllUsers: {
                type: "boolean"
              },
              JobFlowRole: {},
              ServiceRole: {},
              Tags: {
                shape: "S1u"
              },
              SecurityConfiguration: {},
              AutoScalingRole: {},
              ScaleDownBehavior: {},
              CustomAmiId: {},
              EbsRootVolumeSize: {
                type: "integer"
              },
              RepoUpgradeOnBoot: {},
              KerberosAttributes: {
                shape: "S2z"
              },
              StepConcurrencyLevel: {
                type: "integer"
              },
              ManagedScalingPolicy: {
                shape: "S4s"
              },
              PlacementGroupConfigs: {
                shape: "S31"
              },
              AutoTerminationPolicy: {
                shape: "S4h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobFlowId: {},
              ClusterArn: {}
            }
          }
        },
        SetTerminationProtection: {
          input: {
            type: "structure",
            required: [
              "JobFlowIds",
              "TerminationProtected"
            ],
            members: {
              JobFlowIds: {
                shape: "S1p"
              },
              TerminationProtected: {
                type: "boolean"
              }
            }
          }
        },
        SetVisibleToAllUsers: {
          input: {
            type: "structure",
            required: [
              "JobFlowIds",
              "VisibleToAllUsers"
            ],
            members: {
              JobFlowIds: {
                shape: "S1p"
              },
              VisibleToAllUsers: {
                type: "boolean"
              }
            }
          }
        },
        StartNotebookExecution: {
          input: {
            type: "structure",
            required: [
              "EditorId",
              "RelativePath",
              "ExecutionEngine",
              "ServiceRole"
            ],
            members: {
              EditorId: {},
              RelativePath: {},
              NotebookExecutionName: {},
              NotebookParams: {},
              ExecutionEngine: {
                shape: "S3s"
              },
              ServiceRole: {},
              NotebookInstanceSecurityGroupId: {},
              Tags: {
                shape: "S1u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NotebookExecutionId: {}
            }
          }
        },
        StopNotebookExecution: {
          input: {
            type: "structure",
            required: [
              "NotebookExecutionId"
            ],
            members: {
              NotebookExecutionId: {}
            }
          }
        },
        TerminateJobFlows: {
          input: {
            type: "structure",
            required: [
              "JobFlowIds"
            ],
            members: {
              JobFlowIds: {
                shape: "S1p"
              }
            }
          }
        },
        UpdateStudio: {
          input: {
            type: "structure",
            required: [
              "StudioId"
            ],
            members: {
              StudioId: {},
              Name: {},
              Description: {},
              SubnetIds: {
                shape: "S29"
              },
              DefaultS3Location: {}
            }
          }
        },
        UpdateStudioSessionMapping: {
          input: {
            type: "structure",
            required: [
              "StudioId",
              "IdentityType",
              "SessionPolicyArn"
            ],
            members: {
              StudioId: {},
              IdentityId: {},
              IdentityName: {},
              IdentityType: {},
              SessionPolicyArn: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          required: [
            "InstanceFleetType"
          ],
          members: {
            Name: {},
            InstanceFleetType: {},
            TargetOnDemandCapacity: {
              type: "integer"
            },
            TargetSpotCapacity: {
              type: "integer"
            },
            InstanceTypeConfigs: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "InstanceType"
                ],
                members: {
                  InstanceType: {},
                  WeightedCapacity: {
                    type: "integer"
                  },
                  BidPrice: {},
                  BidPriceAsPercentageOfOnDemandPrice: {
                    type: "double"
                  },
                  EbsConfiguration: {
                    shape: "Sa"
                  },
                  Configurations: {
                    shape: "Sh"
                  },
                  CustomAmiId: {}
                }
              }
            },
            LaunchSpecifications: {
              shape: "Sk"
            }
          }
        },
        Sa: {
          type: "structure",
          members: {
            EbsBlockDeviceConfigs: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "VolumeSpecification"
                ],
                members: {
                  VolumeSpecification: {
                    shape: "Sd"
                  },
                  VolumesPerInstance: {
                    type: "integer"
                  }
                }
              }
            },
            EbsOptimized: {
              type: "boolean"
            }
          }
        },
        Sd: {
          type: "structure",
          required: [
            "VolumeType",
            "SizeInGB"
          ],
          members: {
            VolumeType: {},
            Iops: {
              type: "integer"
            },
            SizeInGB: {
              type: "integer"
            }
          }
        },
        Sh: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Classification: {},
              Configurations: {
                shape: "Sh"
              },
              Properties: {
                shape: "Sj"
              }
            }
          }
        },
        Sj: {
          type: "map",
          key: {},
          value: {}
        },
        Sk: {
          type: "structure",
          members: {
            SpotSpecification: {
              type: "structure",
              required: [
                "TimeoutDurationMinutes",
                "TimeoutAction"
              ],
              members: {
                TimeoutDurationMinutes: {
                  type: "integer"
                },
                TimeoutAction: {},
                BlockDurationMinutes: {
                  type: "integer"
                },
                AllocationStrategy: {}
              }
            },
            OnDemandSpecification: {
              type: "structure",
              required: [
                "AllocationStrategy"
              ],
              members: {
                AllocationStrategy: {},
                CapacityReservationOptions: {
                  type: "structure",
                  members: {
                    UsageStrategy: {},
                    CapacityReservationPreference: {},
                    CapacityReservationResourceGroupArn: {}
                  }
                }
              }
            }
          }
        },
        Sx: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "InstanceRole",
              "InstanceType",
              "InstanceCount"
            ],
            members: {
              Name: {},
              Market: {},
              InstanceRole: {},
              BidPrice: {},
              InstanceType: {},
              InstanceCount: {
                type: "integer"
              },
              Configurations: {
                shape: "Sh"
              },
              EbsConfiguration: {
                shape: "Sa"
              },
              AutoScalingPolicy: {
                shape: "S11"
              },
              CustomAmiId: {}
            }
          }
        },
        S11: {
          type: "structure",
          required: [
            "Constraints",
            "Rules"
          ],
          members: {
            Constraints: {
              shape: "S12"
            },
            Rules: {
              shape: "S13"
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "MinCapacity",
            "MaxCapacity"
          ],
          members: {
            MinCapacity: {
              type: "integer"
            },
            MaxCapacity: {
              type: "integer"
            }
          }
        },
        S13: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Action",
              "Trigger"
            ],
            members: {
              Name: {},
              Description: {},
              Action: {
                type: "structure",
                required: [
                  "SimpleScalingPolicyConfiguration"
                ],
                members: {
                  Market: {},
                  SimpleScalingPolicyConfiguration: {
                    type: "structure",
                    required: [
                      "ScalingAdjustment"
                    ],
                    members: {
                      AdjustmentType: {},
                      ScalingAdjustment: {
                        type: "integer"
                      },
                      CoolDown: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              Trigger: {
                type: "structure",
                required: [
                  "CloudWatchAlarmDefinition"
                ],
                members: {
                  CloudWatchAlarmDefinition: {
                    type: "structure",
                    required: [
                      "ComparisonOperator",
                      "MetricName",
                      "Period",
                      "Threshold"
                    ],
                    members: {
                      ComparisonOperator: {},
                      EvaluationPeriods: {
                        type: "integer"
                      },
                      MetricName: {},
                      Namespace: {},
                      Period: {
                        type: "integer"
                      },
                      Statistic: {},
                      Threshold: {
                        type: "double"
                      },
                      Unit: {},
                      Dimensions: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            Key: {},
                            Value: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S1i: {
          type: "list",
          member: {
            shape: "S1j"
          }
        },
        S1j: {
          type: "structure",
          required: [
            "Name",
            "HadoopJarStep"
          ],
          members: {
            Name: {},
            ActionOnFailure: {},
            HadoopJarStep: {
              type: "structure",
              required: [
                "Jar"
              ],
              members: {
                Properties: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      Key: {},
                      Value: {}
                    }
                  }
                },
                Jar: {},
                MainClass: {},
                Args: {
                  shape: "S1p"
                }
              }
            }
          }
        },
        S1p: {
          type: "list",
          member: {}
        },
        S1r: {
          type: "list",
          member: {}
        },
        S1u: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S29: {
          type: "list",
          member: {}
        },
        S2l: {
          type: "structure",
          members: {
            State: {},
            StateChangeReason: {
              type: "structure",
              members: {
                Code: {},
                Message: {}
              }
            },
            Timeline: {
              type: "structure",
              members: {
                CreationDateTime: {
                  type: "timestamp"
                },
                ReadyDateTime: {
                  type: "timestamp"
                },
                EndDateTime: {
                  type: "timestamp"
                }
              }
            }
          }
        },
        S2r: {
          type: "list",
          member: {}
        },
        S2s: {
          type: "list",
          member: {}
        },
        S2v: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Version: {},
              Args: {
                shape: "S2s"
              },
              AdditionalInfo: {
                shape: "Sj"
              }
            }
          }
        },
        S2z: {
          type: "structure",
          required: [
            "Realm",
            "KdcAdminPassword"
          ],
          members: {
            Realm: {},
            KdcAdminPassword: {},
            CrossRealmTrustPrincipalPassword: {},
            ADDomainJoinUser: {},
            ADDomainJoinPassword: {}
          }
        },
        S31: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "InstanceRole"
            ],
            members: {
              InstanceRole: {},
              PlacementStrategy: {}
            }
          }
        },
        S3f: {
          type: "structure",
          members: {
            AvailabilityZone: {},
            AvailabilityZones: {
              shape: "S2r"
            }
          }
        },
        S3m: {
          type: "structure",
          required: [
            "Name",
            "ScriptBootstrapAction"
          ],
          members: {
            Name: {},
            ScriptBootstrapAction: {
              type: "structure",
              required: [
                "Path"
              ],
              members: {
                Path: {},
                Args: {
                  shape: "S1p"
                }
              }
            }
          }
        },
        S3o: {
          type: "list",
          member: {}
        },
        S3s: {
          type: "structure",
          required: [
            "Id"
          ],
          members: {
            Id: {},
            Type: {},
            MasterInstanceSecurityGroupId: {}
          }
        },
        S45: {
          type: "structure",
          members: {
            Jar: {},
            Properties: {
              shape: "Sj"
            },
            MainClass: {},
            Args: {
              shape: "S2s"
            }
          }
        },
        S46: {
          type: "structure",
          members: {
            State: {},
            StateChangeReason: {
              type: "structure",
              members: {
                Code: {},
                Message: {}
              }
            },
            FailureDetails: {
              type: "structure",
              members: {
                Reason: {},
                Message: {},
                LogFile: {}
              }
            },
            Timeline: {
              type: "structure",
              members: {
                CreationDateTime: {
                  type: "timestamp"
                },
                StartDateTime: {
                  type: "timestamp"
                },
                EndDateTime: {
                  type: "timestamp"
                }
              }
            }
          }
        },
        S4h: {
          type: "structure",
          members: {
            IdleTimeout: {
              type: "long"
            }
          }
        },
        S4l: {
          type: "structure",
          required: [
            "BlockPublicSecurityGroupRules"
          ],
          members: {
            BlockPublicSecurityGroupRules: {
              type: "boolean"
            },
            PermittedPublicSecurityGroupRuleRanges: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "MinRange"
                ],
                members: {
                  MinRange: {
                    type: "integer"
                  },
                  MaxRange: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        S4s: {
          type: "structure",
          members: {
            ComputeLimits: {
              type: "structure",
              required: [
                "UnitType",
                "MinimumCapacityUnits",
                "MaximumCapacityUnits"
              ],
              members: {
                UnitType: {},
                MinimumCapacityUnits: {
                  type: "integer"
                },
                MaximumCapacityUnits: {
                  type: "integer"
                },
                MaximumOnDemandCapacityUnits: {
                  type: "integer"
                },
                MaximumCoreCapacityUnits: {
                  type: "integer"
                }
              }
            }
          }
        },
        S5j: {
          type: "list",
          member: {
            type: "structure",
            members: {
              VolumeSpecification: {
                shape: "Sd"
              },
              Device: {}
            }
          }
        },
        S5v: {
          type: "structure",
          members: {
            DecommissionTimeout: {
              type: "integer"
            },
            InstanceResizePolicy: {
              type: "structure",
              members: {
                InstancesToTerminate: {
                  shape: "S5x"
                },
                InstancesToProtect: {
                  shape: "S5x"
                },
                InstanceTerminationTimeout: {
                  type: "integer"
                }
              }
            }
          }
        },
        S5x: {
          type: "list",
          member: {}
        },
        S5z: {
          type: "structure",
          members: {
            Status: {
              type: "structure",
              members: {
                State: {},
                StateChangeReason: {
                  type: "structure",
                  members: {
                    Code: {},
                    Message: {}
                  }
                }
              }
            },
            Constraints: {
              shape: "S12"
            },
            Rules: {
              shape: "S13"
            }
          }
        },
        S7w: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticmapreduce-2009-03-31.paginators.json
var require_elasticmapreduce_2009_03_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/elasticmapreduce-2009-03-31.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeJobFlows: {
          result_key: "JobFlows"
        },
        ListBootstrapActions: {
          input_token: "Marker",
          output_token: "Marker",
          result_key: "BootstrapActions"
        },
        ListClusters: {
          input_token: "Marker",
          output_token: "Marker",
          result_key: "Clusters"
        },
        ListInstanceFleets: {
          input_token: "Marker",
          output_token: "Marker",
          result_key: "InstanceFleets"
        },
        ListInstanceGroups: {
          input_token: "Marker",
          output_token: "Marker",
          result_key: "InstanceGroups"
        },
        ListInstances: {
          input_token: "Marker",
          output_token: "Marker",
          result_key: "Instances"
        },
        ListNotebookExecutions: {
          input_token: "Marker",
          output_token: "Marker",
          result_key: "NotebookExecutions"
        },
        ListReleaseLabels: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListSecurityConfigurations: {
          input_token: "Marker",
          output_token: "Marker",
          result_key: "SecurityConfigurations"
        },
        ListSteps: {
          input_token: "Marker",
          output_token: "Marker",
          result_key: "Steps"
        },
        ListStudioSessionMappings: {
          input_token: "Marker",
          output_token: "Marker",
          result_key: "SessionMappings"
        },
        ListStudios: {
          input_token: "Marker",
          output_token: "Marker",
          result_key: "Studios"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elasticmapreduce-2009-03-31.waiters2.json
var require_elasticmapreduce_2009_03_31_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/elasticmapreduce-2009-03-31.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ClusterRunning: {
          delay: 30,
          operation: "DescribeCluster",
          maxAttempts: 60,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "Cluster.Status.State",
              expected: "RUNNING"
            },
            {
              state: "success",
              matcher: "path",
              argument: "Cluster.Status.State",
              expected: "WAITING"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "Cluster.Status.State",
              expected: "TERMINATING"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "Cluster.Status.State",
              expected: "TERMINATED"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "Cluster.Status.State",
              expected: "TERMINATED_WITH_ERRORS"
            }
          ]
        },
        StepComplete: {
          delay: 30,
          operation: "DescribeStep",
          maxAttempts: 60,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "Step.Status.State",
              expected: "COMPLETED"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "Step.Status.State",
              expected: "FAILED"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "Step.Status.State",
              expected: "CANCELLED"
            }
          ]
        },
        ClusterTerminated: {
          delay: 30,
          operation: "DescribeCluster",
          maxAttempts: 60,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "Cluster.Status.State",
              expected: "TERMINATED"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "Cluster.Status.State",
              expected: "TERMINATED_WITH_ERRORS"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/emr.js
var require_emr = __commonJS({
  "node_modules/aws-sdk/clients/emr.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["emr"] = {};
    AWS3.EMR = Service.defineService("emr", ["2009-03-31"]);
    Object.defineProperty(apiLoader.services["emr"], "2009-03-31", {
      get: function get() {
        var model = require_elasticmapreduce_2009_03_31_min();
        model.paginators = require_elasticmapreduce_2009_03_31_paginators().pagination;
        model.waiters = require_elasticmapreduce_2009_03_31_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.EMR;
  }
});

// node_modules/aws-sdk/apis/es-2015-01-01.min.json
var require_es_2015_01_01_min = __commonJS({
  "node_modules/aws-sdk/apis/es-2015-01-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-01-01",
        endpointPrefix: "es",
        protocol: "rest-json",
        serviceFullName: "Amazon Elasticsearch Service",
        serviceId: "Elasticsearch Service",
        signatureVersion: "v4",
        uid: "es-2015-01-01"
      },
      operations: {
        AcceptInboundCrossClusterSearchConnection: {
          http: {
            method: "PUT",
            requestUri: "/2015-01-01/es/ccs/inboundConnection/{ConnectionId}/accept"
          },
          input: {
            type: "structure",
            required: [
              "CrossClusterSearchConnectionId"
            ],
            members: {
              CrossClusterSearchConnectionId: {
                location: "uri",
                locationName: "ConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CrossClusterSearchConnection: {
                shape: "S4"
              }
            }
          }
        },
        AddTags: {
          http: {
            requestUri: "/2015-01-01/tags"
          },
          input: {
            type: "structure",
            required: [
              "ARN",
              "TagList"
            ],
            members: {
              ARN: {},
              TagList: {
                shape: "Se"
              }
            }
          }
        },
        AssociatePackage: {
          http: {
            requestUri: "/2015-01-01/packages/associate/{PackageID}/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "PackageID",
              "DomainName"
            ],
            members: {
              PackageID: {
                location: "uri",
                locationName: "PackageID"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainPackageDetails: {
                shape: "Sl"
              }
            }
          }
        },
        CancelElasticsearchServiceSoftwareUpdate: {
          http: {
            requestUri: "/2015-01-01/es/serviceSoftwareUpdate/cancel"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceSoftwareOptions: {
                shape: "Sx"
              }
            }
          }
        },
        CreateElasticsearchDomain: {
          http: {
            requestUri: "/2015-01-01/es/domain"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              ElasticsearchVersion: {},
              ElasticsearchClusterConfig: {
                shape: "S14"
              },
              EBSOptions: {
                shape: "S1a"
              },
              AccessPolicies: {},
              SnapshotOptions: {
                shape: "S1d"
              },
              VPCOptions: {
                shape: "S1e"
              },
              CognitoOptions: {
                shape: "S1g"
              },
              EncryptionAtRestOptions: {
                shape: "S1k"
              },
              NodeToNodeEncryptionOptions: {
                shape: "S1m"
              },
              AdvancedOptions: {
                shape: "S1n"
              },
              LogPublishingOptions: {
                shape: "S1o"
              },
              DomainEndpointOptions: {
                shape: "S1s"
              },
              AdvancedSecurityOptions: {
                shape: "S1v"
              },
              AutoTuneOptions: {
                type: "structure",
                members: {
                  DesiredState: {},
                  MaintenanceSchedules: {
                    shape: "S26"
                  }
                }
              },
              TagList: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainStatus: {
                shape: "S2d"
              }
            }
          }
        },
        CreateOutboundCrossClusterSearchConnection: {
          http: {
            requestUri: "/2015-01-01/es/ccs/outboundConnection"
          },
          input: {
            type: "structure",
            required: [
              "SourceDomainInfo",
              "DestinationDomainInfo",
              "ConnectionAlias"
            ],
            members: {
              SourceDomainInfo: {
                shape: "S5"
              },
              DestinationDomainInfo: {
                shape: "S5"
              },
              ConnectionAlias: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SourceDomainInfo: {
                shape: "S5"
              },
              DestinationDomainInfo: {
                shape: "S5"
              },
              ConnectionAlias: {},
              ConnectionStatus: {
                shape: "S2p"
              },
              CrossClusterSearchConnectionId: {}
            }
          }
        },
        CreatePackage: {
          http: {
            requestUri: "/2015-01-01/packages"
          },
          input: {
            type: "structure",
            required: [
              "PackageName",
              "PackageType",
              "PackageSource"
            ],
            members: {
              PackageName: {},
              PackageType: {},
              PackageDescription: {},
              PackageSource: {
                shape: "S2t"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PackageDetails: {
                shape: "S2x"
              }
            }
          }
        },
        DeleteElasticsearchDomain: {
          http: {
            method: "DELETE",
            requestUri: "/2015-01-01/es/domain/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainStatus: {
                shape: "S2d"
              }
            }
          }
        },
        DeleteElasticsearchServiceRole: {
          http: {
            method: "DELETE",
            requestUri: "/2015-01-01/es/role"
          }
        },
        DeleteInboundCrossClusterSearchConnection: {
          http: {
            method: "DELETE",
            requestUri: "/2015-01-01/es/ccs/inboundConnection/{ConnectionId}"
          },
          input: {
            type: "structure",
            required: [
              "CrossClusterSearchConnectionId"
            ],
            members: {
              CrossClusterSearchConnectionId: {
                location: "uri",
                locationName: "ConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CrossClusterSearchConnection: {
                shape: "S4"
              }
            }
          }
        },
        DeleteOutboundCrossClusterSearchConnection: {
          http: {
            method: "DELETE",
            requestUri: "/2015-01-01/es/ccs/outboundConnection/{ConnectionId}"
          },
          input: {
            type: "structure",
            required: [
              "CrossClusterSearchConnectionId"
            ],
            members: {
              CrossClusterSearchConnectionId: {
                location: "uri",
                locationName: "ConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CrossClusterSearchConnection: {
                shape: "S36"
              }
            }
          }
        },
        DeletePackage: {
          http: {
            method: "DELETE",
            requestUri: "/2015-01-01/packages/{PackageID}"
          },
          input: {
            type: "structure",
            required: [
              "PackageID"
            ],
            members: {
              PackageID: {
                location: "uri",
                locationName: "PackageID"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PackageDetails: {
                shape: "S2x"
              }
            }
          }
        },
        DescribeDomainAutoTunes: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/domain/{DomainName}/autoTunes"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AutoTunes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AutoTuneType: {},
                    AutoTuneDetails: {
                      type: "structure",
                      members: {
                        ScheduledAutoTuneDetails: {
                          type: "structure",
                          members: {
                            Date: {
                              type: "timestamp"
                            },
                            ActionType: {},
                            Action: {},
                            Severity: {}
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeElasticsearchDomain: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/domain/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainStatus"
            ],
            members: {
              DomainStatus: {
                shape: "S2d"
              }
            }
          }
        },
        DescribeElasticsearchDomainConfig: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/domain/{DomainName}/config"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainConfig"
            ],
            members: {
              DomainConfig: {
                shape: "S3q"
              }
            }
          }
        },
        DescribeElasticsearchDomains: {
          http: {
            requestUri: "/2015-01-01/es/domain-info"
          },
          input: {
            type: "structure",
            required: [
              "DomainNames"
            ],
            members: {
              DomainNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainStatusList"
            ],
            members: {
              DomainStatusList: {
                type: "list",
                member: {
                  shape: "S2d"
                }
              }
            }
          }
        },
        DescribeElasticsearchInstanceTypeLimits: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/instanceTypeLimits/{ElasticsearchVersion}/{InstanceType}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceType",
              "ElasticsearchVersion"
            ],
            members: {
              DomainName: {
                location: "querystring",
                locationName: "domainName"
              },
              InstanceType: {
                location: "uri",
                locationName: "InstanceType"
              },
              ElasticsearchVersion: {
                location: "uri",
                locationName: "ElasticsearchVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LimitsByRole: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    StorageTypes: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          StorageTypeName: {},
                          StorageSubTypeName: {},
                          StorageTypeLimits: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                LimitName: {},
                                LimitValues: {
                                  shape: "S4s"
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    InstanceLimits: {
                      type: "structure",
                      members: {
                        InstanceCountLimits: {
                          type: "structure",
                          members: {
                            MinimumInstanceCount: {
                              type: "integer"
                            },
                            MaximumInstanceCount: {
                              type: "integer"
                            }
                          }
                        }
                      }
                    },
                    AdditionalLimits: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          LimitName: {},
                          LimitValues: {
                            shape: "S4s"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeInboundCrossClusterSearchConnections: {
          http: {
            requestUri: "/2015-01-01/es/ccs/inboundConnection/search"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S51"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CrossClusterSearchConnections: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeOutboundCrossClusterSearchConnections: {
          http: {
            requestUri: "/2015-01-01/es/ccs/outboundConnection/search"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S51"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CrossClusterSearchConnections: {
                type: "list",
                member: {
                  shape: "S36"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribePackages: {
          http: {
            requestUri: "/2015-01-01/packages/describe"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Value: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PackageDetailsList: {
                type: "list",
                member: {
                  shape: "S2x"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeReservedElasticsearchInstanceOfferings: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/reservedInstanceOfferings"
          },
          input: {
            type: "structure",
            members: {
              ReservedElasticsearchInstanceOfferingId: {
                location: "querystring",
                locationName: "offeringId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ReservedElasticsearchInstanceOfferings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReservedElasticsearchInstanceOfferingId: {},
                    ElasticsearchInstanceType: {},
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    UsagePrice: {
                      type: "double"
                    },
                    CurrencyCode: {},
                    PaymentOption: {},
                    RecurringCharges: {
                      shape: "S5q"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeReservedElasticsearchInstances: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/reservedInstances"
          },
          input: {
            type: "structure",
            members: {
              ReservedElasticsearchInstanceId: {
                location: "querystring",
                locationName: "reservationId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ReservedElasticsearchInstances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReservationName: {},
                    ReservedElasticsearchInstanceId: {},
                    ReservedElasticsearchInstanceOfferingId: {},
                    ElasticsearchInstanceType: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    UsagePrice: {
                      type: "double"
                    },
                    CurrencyCode: {},
                    ElasticsearchInstanceCount: {
                      type: "integer"
                    },
                    State: {},
                    PaymentOption: {},
                    RecurringCharges: {
                      shape: "S5q"
                    }
                  }
                }
              }
            }
          }
        },
        DissociatePackage: {
          http: {
            requestUri: "/2015-01-01/packages/dissociate/{PackageID}/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "PackageID",
              "DomainName"
            ],
            members: {
              PackageID: {
                location: "uri",
                locationName: "PackageID"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainPackageDetails: {
                shape: "Sl"
              }
            }
          }
        },
        GetCompatibleElasticsearchVersions: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/compatibleVersions"
          },
          input: {
            type: "structure",
            members: {
              DomainName: {
                location: "querystring",
                locationName: "domainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CompatibleElasticsearchVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceVersion: {},
                    TargetVersions: {
                      shape: "S63"
                    }
                  }
                }
              }
            }
          }
        },
        GetPackageVersionHistory: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/packages/{PackageID}/history"
          },
          input: {
            type: "structure",
            required: [
              "PackageID"
            ],
            members: {
              PackageID: {
                location: "uri",
                locationName: "PackageID"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PackageID: {},
              PackageVersionHistoryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PackageVersion: {},
                    CommitMessage: {},
                    CreatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetUpgradeHistory: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/upgradeDomain/{DomainName}/history"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpgradeHistories: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UpgradeName: {},
                    StartTimestamp: {
                      type: "timestamp"
                    },
                    UpgradeStatus: {},
                    StepsList: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          UpgradeStep: {},
                          UpgradeStepStatus: {},
                          Issues: {
                            type: "list",
                            member: {}
                          },
                          ProgressPercent: {
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetUpgradeStatus: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/upgradeDomain/{DomainName}/status"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpgradeStep: {},
              StepStatus: {},
              UpgradeName: {}
            }
          }
        },
        ListDomainNames: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/domain"
          },
          input: {
            type: "structure",
            members: {
              EngineType: {
                location: "querystring",
                locationName: "engineType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainNames: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainName: {},
                    EngineType: {}
                  }
                }
              }
            }
          }
        },
        ListDomainsForPackage: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/packages/{PackageID}/domains"
          },
          input: {
            type: "structure",
            required: [
              "PackageID"
            ],
            members: {
              PackageID: {
                location: "uri",
                locationName: "PackageID"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainPackageDetailsList: {
                shape: "S6u"
              },
              NextToken: {}
            }
          }
        },
        ListElasticsearchInstanceTypes: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/instanceTypes/{ElasticsearchVersion}"
          },
          input: {
            type: "structure",
            required: [
              "ElasticsearchVersion"
            ],
            members: {
              ElasticsearchVersion: {
                location: "uri",
                locationName: "ElasticsearchVersion"
              },
              DomainName: {
                location: "querystring",
                locationName: "domainName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ElasticsearchInstanceTypes: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListElasticsearchVersions: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/es/versions"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ElasticsearchVersions: {
                shape: "S63"
              },
              NextToken: {}
            }
          }
        },
        ListPackagesForDomain: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/domain/{DomainName}/packages"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainPackageDetailsList: {
                shape: "S6u"
              },
              NextToken: {}
            }
          }
        },
        ListTags: {
          http: {
            method: "GET",
            requestUri: "/2015-01-01/tags/"
          },
          input: {
            type: "structure",
            required: [
              "ARN"
            ],
            members: {
              ARN: {
                location: "querystring",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "Se"
              }
            }
          }
        },
        PurchaseReservedElasticsearchInstanceOffering: {
          http: {
            requestUri: "/2015-01-01/es/purchaseReservedInstanceOffering"
          },
          input: {
            type: "structure",
            required: [
              "ReservedElasticsearchInstanceOfferingId",
              "ReservationName"
            ],
            members: {
              ReservedElasticsearchInstanceOfferingId: {},
              ReservationName: {},
              InstanceCount: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedElasticsearchInstanceId: {},
              ReservationName: {}
            }
          }
        },
        RejectInboundCrossClusterSearchConnection: {
          http: {
            method: "PUT",
            requestUri: "/2015-01-01/es/ccs/inboundConnection/{ConnectionId}/reject"
          },
          input: {
            type: "structure",
            required: [
              "CrossClusterSearchConnectionId"
            ],
            members: {
              CrossClusterSearchConnectionId: {
                location: "uri",
                locationName: "ConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CrossClusterSearchConnection: {
                shape: "S4"
              }
            }
          }
        },
        RemoveTags: {
          http: {
            requestUri: "/2015-01-01/tags-removal"
          },
          input: {
            type: "structure",
            required: [
              "ARN",
              "TagKeys"
            ],
            members: {
              ARN: {},
              TagKeys: {
                shape: "S1f"
              }
            }
          }
        },
        StartElasticsearchServiceSoftwareUpdate: {
          http: {
            requestUri: "/2015-01-01/es/serviceSoftwareUpdate/start"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceSoftwareOptions: {
                shape: "Sx"
              }
            }
          }
        },
        UpdateElasticsearchDomainConfig: {
          http: {
            requestUri: "/2015-01-01/es/domain/{DomainName}/config"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              ElasticsearchClusterConfig: {
                shape: "S14"
              },
              EBSOptions: {
                shape: "S1a"
              },
              SnapshotOptions: {
                shape: "S1d"
              },
              VPCOptions: {
                shape: "S1e"
              },
              CognitoOptions: {
                shape: "S1g"
              },
              AdvancedOptions: {
                shape: "S1n"
              },
              AccessPolicies: {},
              LogPublishingOptions: {
                shape: "S1o"
              },
              DomainEndpointOptions: {
                shape: "S1s"
              },
              AdvancedSecurityOptions: {
                shape: "S1v"
              },
              NodeToNodeEncryptionOptions: {
                shape: "S1m"
              },
              EncryptionAtRestOptions: {
                shape: "S1k"
              },
              AutoTuneOptions: {
                shape: "S49"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainConfig"
            ],
            members: {
              DomainConfig: {
                shape: "S3q"
              }
            }
          }
        },
        UpdatePackage: {
          http: {
            requestUri: "/2015-01-01/packages/update"
          },
          input: {
            type: "structure",
            required: [
              "PackageID",
              "PackageSource"
            ],
            members: {
              PackageID: {},
              PackageSource: {
                shape: "S2t"
              },
              PackageDescription: {},
              CommitMessage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PackageDetails: {
                shape: "S2x"
              }
            }
          }
        },
        UpgradeElasticsearchDomain: {
          http: {
            requestUri: "/2015-01-01/es/upgradeDomain"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "TargetVersion"
            ],
            members: {
              DomainName: {},
              TargetVersion: {},
              PerformCheckOnly: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainName: {},
              TargetVersion: {},
              PerformCheckOnly: {
                type: "boolean"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            SourceDomainInfo: {
              shape: "S5"
            },
            DestinationDomainInfo: {
              shape: "S5"
            },
            CrossClusterSearchConnectionId: {},
            ConnectionStatus: {
              type: "structure",
              members: {
                StatusCode: {},
                Message: {}
              }
            }
          }
        },
        S5: {
          type: "structure",
          required: [
            "DomainName"
          ],
          members: {
            OwnerId: {},
            DomainName: {},
            Region: {}
          }
        },
        Se: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sl: {
          type: "structure",
          members: {
            PackageID: {},
            PackageName: {},
            PackageType: {},
            LastUpdated: {
              type: "timestamp"
            },
            DomainName: {},
            DomainPackageStatus: {},
            PackageVersion: {},
            ReferencePath: {},
            ErrorDetails: {
              shape: "Ss"
            }
          }
        },
        Ss: {
          type: "structure",
          members: {
            ErrorType: {},
            ErrorMessage: {}
          }
        },
        Sx: {
          type: "structure",
          members: {
            CurrentVersion: {},
            NewVersion: {},
            UpdateAvailable: {
              type: "boolean"
            },
            Cancellable: {
              type: "boolean"
            },
            UpdateStatus: {},
            Description: {},
            AutomatedUpdateDate: {
              type: "timestamp"
            },
            OptionalDeployment: {
              type: "boolean"
            }
          }
        },
        S14: {
          type: "structure",
          members: {
            InstanceType: {},
            InstanceCount: {
              type: "integer"
            },
            DedicatedMasterEnabled: {
              type: "boolean"
            },
            ZoneAwarenessEnabled: {
              type: "boolean"
            },
            ZoneAwarenessConfig: {
              type: "structure",
              members: {
                AvailabilityZoneCount: {
                  type: "integer"
                }
              }
            },
            DedicatedMasterType: {},
            DedicatedMasterCount: {
              type: "integer"
            },
            WarmEnabled: {
              type: "boolean"
            },
            WarmType: {},
            WarmCount: {
              type: "integer"
            },
            ColdStorageOptions: {
              type: "structure",
              required: [
                "Enabled"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S1a: {
          type: "structure",
          members: {
            EBSEnabled: {
              type: "boolean"
            },
            VolumeType: {},
            VolumeSize: {
              type: "integer"
            },
            Iops: {
              type: "integer"
            }
          }
        },
        S1d: {
          type: "structure",
          members: {
            AutomatedSnapshotStartHour: {
              type: "integer"
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            SubnetIds: {
              shape: "S1f"
            },
            SecurityGroupIds: {
              shape: "S1f"
            }
          }
        },
        S1f: {
          type: "list",
          member: {}
        },
        S1g: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            UserPoolId: {},
            IdentityPoolId: {},
            RoleArn: {}
          }
        },
        S1k: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            KmsKeyId: {}
          }
        },
        S1m: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            }
          }
        },
        S1n: {
          type: "map",
          key: {},
          value: {}
        },
        S1o: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              CloudWatchLogsLogGroupArn: {},
              Enabled: {
                type: "boolean"
              }
            }
          }
        },
        S1s: {
          type: "structure",
          members: {
            EnforceHTTPS: {
              type: "boolean"
            },
            TLSSecurityPolicy: {},
            CustomEndpointEnabled: {
              type: "boolean"
            },
            CustomEndpoint: {},
            CustomEndpointCertificateArn: {}
          }
        },
        S1v: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            InternalUserDatabaseEnabled: {
              type: "boolean"
            },
            MasterUserOptions: {
              type: "structure",
              members: {
                MasterUserARN: {},
                MasterUserName: {
                  shape: "S1x"
                },
                MasterUserPassword: {
                  type: "string",
                  sensitive: true
                }
              }
            },
            SAMLOptions: {
              type: "structure",
              members: {
                Enabled: {
                  type: "boolean"
                },
                Idp: {
                  shape: "S20"
                },
                MasterUserName: {
                  shape: "S1x"
                },
                MasterBackendRole: {},
                SubjectKey: {},
                RolesKey: {},
                SessionTimeoutMinutes: {
                  type: "integer"
                }
              }
            }
          }
        },
        S1x: {
          type: "string",
          sensitive: true
        },
        S20: {
          type: "structure",
          required: [
            "MetadataContent",
            "EntityId"
          ],
          members: {
            MetadataContent: {},
            EntityId: {}
          }
        },
        S26: {
          type: "list",
          member: {
            type: "structure",
            members: {
              StartAt: {
                type: "timestamp"
              },
              Duration: {
                type: "structure",
                members: {
                  Value: {
                    type: "long"
                  },
                  Unit: {}
                }
              },
              CronExpressionForRecurrence: {}
            }
          }
        },
        S2d: {
          type: "structure",
          required: [
            "DomainId",
            "DomainName",
            "ARN",
            "ElasticsearchClusterConfig"
          ],
          members: {
            DomainId: {},
            DomainName: {},
            ARN: {},
            Created: {
              type: "boolean"
            },
            Deleted: {
              type: "boolean"
            },
            Endpoint: {},
            Endpoints: {
              type: "map",
              key: {},
              value: {}
            },
            Processing: {
              type: "boolean"
            },
            UpgradeProcessing: {
              type: "boolean"
            },
            ElasticsearchVersion: {},
            ElasticsearchClusterConfig: {
              shape: "S14"
            },
            EBSOptions: {
              shape: "S1a"
            },
            AccessPolicies: {},
            SnapshotOptions: {
              shape: "S1d"
            },
            VPCOptions: {
              shape: "S2h"
            },
            CognitoOptions: {
              shape: "S1g"
            },
            EncryptionAtRestOptions: {
              shape: "S1k"
            },
            NodeToNodeEncryptionOptions: {
              shape: "S1m"
            },
            AdvancedOptions: {
              shape: "S1n"
            },
            LogPublishingOptions: {
              shape: "S1o"
            },
            ServiceSoftwareOptions: {
              shape: "Sx"
            },
            DomainEndpointOptions: {
              shape: "S1s"
            },
            AdvancedSecurityOptions: {
              shape: "S2i"
            },
            AutoTuneOptions: {
              type: "structure",
              members: {
                State: {},
                ErrorMessage: {}
              }
            }
          }
        },
        S2h: {
          type: "structure",
          members: {
            VPCId: {},
            SubnetIds: {
              shape: "S1f"
            },
            AvailabilityZones: {
              shape: "S1f"
            },
            SecurityGroupIds: {
              shape: "S1f"
            }
          }
        },
        S2i: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            InternalUserDatabaseEnabled: {
              type: "boolean"
            },
            SAMLOptions: {
              type: "structure",
              members: {
                Enabled: {
                  type: "boolean"
                },
                Idp: {
                  shape: "S20"
                },
                SubjectKey: {},
                RolesKey: {},
                SessionTimeoutMinutes: {
                  type: "integer"
                }
              }
            }
          }
        },
        S2p: {
          type: "structure",
          members: {
            StatusCode: {},
            Message: {}
          }
        },
        S2t: {
          type: "structure",
          members: {
            S3BucketName: {},
            S3Key: {}
          }
        },
        S2x: {
          type: "structure",
          members: {
            PackageID: {},
            PackageName: {},
            PackageType: {},
            PackageDescription: {},
            PackageStatus: {},
            CreatedAt: {
              type: "timestamp"
            },
            LastUpdatedAt: {
              type: "timestamp"
            },
            AvailablePackageVersion: {},
            ErrorDetails: {
              shape: "Ss"
            }
          }
        },
        S36: {
          type: "structure",
          members: {
            SourceDomainInfo: {
              shape: "S5"
            },
            DestinationDomainInfo: {
              shape: "S5"
            },
            CrossClusterSearchConnectionId: {},
            ConnectionAlias: {},
            ConnectionStatus: {
              shape: "S2p"
            }
          }
        },
        S3q: {
          type: "structure",
          members: {
            ElasticsearchVersion: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {},
                Status: {
                  shape: "S3s"
                }
              }
            },
            ElasticsearchClusterConfig: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S14"
                },
                Status: {
                  shape: "S3s"
                }
              }
            },
            EBSOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1a"
                },
                Status: {
                  shape: "S3s"
                }
              }
            },
            AccessPolicies: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {},
                Status: {
                  shape: "S3s"
                }
              }
            },
            SnapshotOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1d"
                },
                Status: {
                  shape: "S3s"
                }
              }
            },
            VPCOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S2h"
                },
                Status: {
                  shape: "S3s"
                }
              }
            },
            CognitoOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1g"
                },
                Status: {
                  shape: "S3s"
                }
              }
            },
            EncryptionAtRestOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1k"
                },
                Status: {
                  shape: "S3s"
                }
              }
            },
            NodeToNodeEncryptionOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1m"
                },
                Status: {
                  shape: "S3s"
                }
              }
            },
            AdvancedOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1n"
                },
                Status: {
                  shape: "S3s"
                }
              }
            },
            LogPublishingOptions: {
              type: "structure",
              members: {
                Options: {
                  shape: "S1o"
                },
                Status: {
                  shape: "S3s"
                }
              }
            },
            DomainEndpointOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1s"
                },
                Status: {
                  shape: "S3s"
                }
              }
            },
            AdvancedSecurityOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S2i"
                },
                Status: {
                  shape: "S3s"
                }
              }
            },
            AutoTuneOptions: {
              type: "structure",
              members: {
                Options: {
                  shape: "S49"
                },
                Status: {
                  type: "structure",
                  required: [
                    "CreationDate",
                    "UpdateDate",
                    "State"
                  ],
                  members: {
                    CreationDate: {
                      type: "timestamp"
                    },
                    UpdateDate: {
                      type: "timestamp"
                    },
                    UpdateVersion: {
                      type: "integer"
                    },
                    State: {},
                    ErrorMessage: {},
                    PendingDeletion: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        S3s: {
          type: "structure",
          required: [
            "CreationDate",
            "UpdateDate",
            "State"
          ],
          members: {
            CreationDate: {
              type: "timestamp"
            },
            UpdateDate: {
              type: "timestamp"
            },
            UpdateVersion: {
              type: "integer"
            },
            State: {},
            PendingDeletion: {
              type: "boolean"
            }
          }
        },
        S49: {
          type: "structure",
          members: {
            DesiredState: {},
            RollbackOnDisable: {},
            MaintenanceSchedules: {
              shape: "S26"
            }
          }
        },
        S4s: {
          type: "list",
          member: {}
        },
        S51: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S5q: {
          type: "list",
          member: {
            type: "structure",
            members: {
              RecurringChargeAmount: {
                type: "double"
              },
              RecurringChargeFrequency: {}
            }
          }
        },
        S63: {
          type: "list",
          member: {}
        },
        S6u: {
          type: "list",
          member: {
            shape: "Sl"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/es-2015-01-01.paginators.json
var require_es_2015_01_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/es-2015-01-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeDomainAutoTunes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeInboundCrossClusterSearchConnections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeOutboundCrossClusterSearchConnections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribePackages: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeReservedElasticsearchInstanceOfferings: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeReservedElasticsearchInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        GetPackageVersionHistory: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        GetUpgradeHistory: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDomainsForPackage: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListElasticsearchInstanceTypes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListElasticsearchVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPackagesForDomain: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/es.js
var require_es = __commonJS({
  "node_modules/aws-sdk/clients/es.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["es"] = {};
    AWS3.ES = Service.defineService("es", ["2015-01-01"]);
    Object.defineProperty(apiLoader.services["es"], "2015-01-01", {
      get: function get() {
        var model = require_es_2015_01_01_min();
        model.paginators = require_es_2015_01_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ES;
  }
});

// node_modules/aws-sdk/apis/elastictranscoder-2012-09-25.min.json
var require_elastictranscoder_2012_09_25_min = __commonJS({
  "node_modules/aws-sdk/apis/elastictranscoder-2012-09-25.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2012-09-25",
        endpointPrefix: "elastictranscoder",
        protocol: "rest-json",
        serviceFullName: "Amazon Elastic Transcoder",
        serviceId: "Elastic Transcoder",
        signatureVersion: "v4",
        uid: "elastictranscoder-2012-09-25"
      },
      operations: {
        CancelJob: {
          http: {
            method: "DELETE",
            requestUri: "/2012-09-25/jobs/{Id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateJob: {
          http: {
            requestUri: "/2012-09-25/jobs",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "PipelineId"
            ],
            members: {
              PipelineId: {},
              Input: {
                shape: "S5"
              },
              Inputs: {
                shape: "St"
              },
              Output: {
                shape: "Su"
              },
              Outputs: {
                type: "list",
                member: {
                  shape: "Su"
                }
              },
              OutputKeyPrefix: {},
              Playlists: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Format: {},
                    OutputKeys: {
                      shape: "S1l"
                    },
                    HlsContentProtection: {
                      shape: "S1m"
                    },
                    PlayReadyDrm: {
                      shape: "S1q"
                    }
                  }
                }
              },
              UserMetadata: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Job: {
                shape: "S1y"
              }
            }
          }
        },
        CreatePipeline: {
          http: {
            requestUri: "/2012-09-25/pipelines",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "InputBucket",
              "Role"
            ],
            members: {
              Name: {},
              InputBucket: {},
              OutputBucket: {},
              Role: {},
              AwsKmsKeyArn: {},
              Notifications: {
                shape: "S2a"
              },
              ContentConfig: {
                shape: "S2c"
              },
              ThumbnailConfig: {
                shape: "S2c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Pipeline: {
                shape: "S2l"
              },
              Warnings: {
                shape: "S2n"
              }
            }
          }
        },
        CreatePreset: {
          http: {
            requestUri: "/2012-09-25/presets",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Container"
            ],
            members: {
              Name: {},
              Description: {},
              Container: {},
              Video: {
                shape: "S2r"
              },
              Audio: {
                shape: "S37"
              },
              Thumbnails: {
                shape: "S3i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Preset: {
                shape: "S3m"
              },
              Warning: {}
            }
          }
        },
        DeletePipeline: {
          http: {
            method: "DELETE",
            requestUri: "/2012-09-25/pipelines/{Id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePreset: {
          http: {
            method: "DELETE",
            requestUri: "/2012-09-25/presets/{Id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListJobsByPipeline: {
          http: {
            method: "GET",
            requestUri: "/2012-09-25/jobsByPipeline/{PipelineId}"
          },
          input: {
            type: "structure",
            required: [
              "PipelineId"
            ],
            members: {
              PipelineId: {
                location: "uri",
                locationName: "PipelineId"
              },
              Ascending: {
                location: "querystring",
                locationName: "Ascending"
              },
              PageToken: {
                location: "querystring",
                locationName: "PageToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Jobs: {
                shape: "S3v"
              },
              NextPageToken: {}
            }
          }
        },
        ListJobsByStatus: {
          http: {
            method: "GET",
            requestUri: "/2012-09-25/jobsByStatus/{Status}"
          },
          input: {
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Status: {
                location: "uri",
                locationName: "Status"
              },
              Ascending: {
                location: "querystring",
                locationName: "Ascending"
              },
              PageToken: {
                location: "querystring",
                locationName: "PageToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Jobs: {
                shape: "S3v"
              },
              NextPageToken: {}
            }
          }
        },
        ListPipelines: {
          http: {
            method: "GET",
            requestUri: "/2012-09-25/pipelines"
          },
          input: {
            type: "structure",
            members: {
              Ascending: {
                location: "querystring",
                locationName: "Ascending"
              },
              PageToken: {
                location: "querystring",
                locationName: "PageToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Pipelines: {
                type: "list",
                member: {
                  shape: "S2l"
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListPresets: {
          http: {
            method: "GET",
            requestUri: "/2012-09-25/presets"
          },
          input: {
            type: "structure",
            members: {
              Ascending: {
                location: "querystring",
                locationName: "Ascending"
              },
              PageToken: {
                location: "querystring",
                locationName: "PageToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Presets: {
                type: "list",
                member: {
                  shape: "S3m"
                }
              },
              NextPageToken: {}
            }
          }
        },
        ReadJob: {
          http: {
            method: "GET",
            requestUri: "/2012-09-25/jobs/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Job: {
                shape: "S1y"
              }
            }
          }
        },
        ReadPipeline: {
          http: {
            method: "GET",
            requestUri: "/2012-09-25/pipelines/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Pipeline: {
                shape: "S2l"
              },
              Warnings: {
                shape: "S2n"
              }
            }
          }
        },
        ReadPreset: {
          http: {
            method: "GET",
            requestUri: "/2012-09-25/presets/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Preset: {
                shape: "S3m"
              }
            }
          }
        },
        TestRole: {
          http: {
            requestUri: "/2012-09-25/roleTests",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Role",
              "InputBucket",
              "OutputBucket",
              "Topics"
            ],
            members: {
              Role: {},
              InputBucket: {},
              OutputBucket: {},
              Topics: {
                type: "list",
                member: {}
              }
            },
            deprecated: true
          },
          output: {
            type: "structure",
            members: {
              Success: {},
              Messages: {
                type: "list",
                member: {}
              }
            },
            deprecated: true
          },
          deprecated: true
        },
        UpdatePipeline: {
          http: {
            method: "PUT",
            requestUri: "/2012-09-25/pipelines/{Id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Name: {},
              InputBucket: {},
              Role: {},
              AwsKmsKeyArn: {},
              Notifications: {
                shape: "S2a"
              },
              ContentConfig: {
                shape: "S2c"
              },
              ThumbnailConfig: {
                shape: "S2c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Pipeline: {
                shape: "S2l"
              },
              Warnings: {
                shape: "S2n"
              }
            }
          }
        },
        UpdatePipelineNotifications: {
          http: {
            requestUri: "/2012-09-25/pipelines/{Id}/notifications"
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "Notifications"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Notifications: {
                shape: "S2a"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Pipeline: {
                shape: "S2l"
              }
            }
          }
        },
        UpdatePipelineStatus: {
          http: {
            requestUri: "/2012-09-25/pipelines/{Id}/status"
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "Status"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Pipeline: {
                shape: "S2l"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            Key: {},
            FrameRate: {},
            Resolution: {},
            AspectRatio: {},
            Interlaced: {},
            Container: {},
            Encryption: {
              shape: "Sc"
            },
            TimeSpan: {
              shape: "Sg"
            },
            InputCaptions: {
              type: "structure",
              members: {
                MergePolicy: {},
                CaptionSources: {
                  shape: "Sk"
                }
              }
            },
            DetectedProperties: {
              type: "structure",
              members: {
                Width: {
                  type: "integer"
                },
                Height: {
                  type: "integer"
                },
                FrameRate: {},
                FileSize: {
                  type: "long"
                },
                DurationMillis: {
                  type: "long"
                }
              }
            }
          }
        },
        Sc: {
          type: "structure",
          members: {
            Mode: {},
            Key: {},
            KeyMd5: {},
            InitializationVector: {}
          }
        },
        Sg: {
          type: "structure",
          members: {
            StartTime: {},
            Duration: {}
          }
        },
        Sk: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Language: {},
              TimeOffset: {},
              Label: {},
              Encryption: {
                shape: "Sc"
              }
            }
          }
        },
        St: {
          type: "list",
          member: {
            shape: "S5"
          }
        },
        Su: {
          type: "structure",
          members: {
            Key: {},
            ThumbnailPattern: {},
            ThumbnailEncryption: {
              shape: "Sc"
            },
            Rotate: {},
            PresetId: {},
            SegmentDuration: {},
            Watermarks: {
              shape: "Sx"
            },
            AlbumArt: {
              shape: "S11"
            },
            Composition: {
              shape: "S19",
              deprecated: true
            },
            Captions: {
              shape: "S1b"
            },
            Encryption: {
              shape: "Sc"
            }
          }
        },
        Sx: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PresetWatermarkId: {},
              InputKey: {},
              Encryption: {
                shape: "Sc"
              }
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            MergePolicy: {},
            Artwork: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  InputKey: {},
                  MaxWidth: {},
                  MaxHeight: {},
                  SizingPolicy: {},
                  PaddingPolicy: {},
                  AlbumArtFormat: {},
                  Encryption: {
                    shape: "Sc"
                  }
                }
              }
            }
          }
        },
        S19: {
          type: "list",
          member: {
            type: "structure",
            members: {
              TimeSpan: {
                shape: "Sg"
              }
            },
            deprecated: true
          },
          deprecated: true
        },
        S1b: {
          type: "structure",
          members: {
            MergePolicy: {
              deprecated: true
            },
            CaptionSources: {
              shape: "Sk",
              deprecated: true
            },
            CaptionFormats: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Format: {},
                  Pattern: {},
                  Encryption: {
                    shape: "Sc"
                  }
                }
              }
            }
          }
        },
        S1l: {
          type: "list",
          member: {}
        },
        S1m: {
          type: "structure",
          members: {
            Method: {},
            Key: {},
            KeyMd5: {},
            InitializationVector: {},
            LicenseAcquisitionUrl: {},
            KeyStoragePolicy: {}
          }
        },
        S1q: {
          type: "structure",
          members: {
            Format: {},
            Key: {},
            KeyMd5: {},
            KeyId: {},
            InitializationVector: {},
            LicenseAcquisitionUrl: {}
          }
        },
        S1v: {
          type: "map",
          key: {},
          value: {}
        },
        S1y: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            PipelineId: {},
            Input: {
              shape: "S5"
            },
            Inputs: {
              shape: "St"
            },
            Output: {
              shape: "S1z"
            },
            Outputs: {
              type: "list",
              member: {
                shape: "S1z"
              }
            },
            OutputKeyPrefix: {},
            Playlists: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {},
                  Format: {},
                  OutputKeys: {
                    shape: "S1l"
                  },
                  HlsContentProtection: {
                    shape: "S1m"
                  },
                  PlayReadyDrm: {
                    shape: "S1q"
                  },
                  Status: {},
                  StatusDetail: {}
                }
              }
            },
            Status: {},
            UserMetadata: {
              shape: "S1v"
            },
            Timing: {
              type: "structure",
              members: {
                SubmitTimeMillis: {
                  type: "long"
                },
                StartTimeMillis: {
                  type: "long"
                },
                FinishTimeMillis: {
                  type: "long"
                }
              }
            }
          }
        },
        S1z: {
          type: "structure",
          members: {
            Id: {},
            Key: {},
            ThumbnailPattern: {},
            ThumbnailEncryption: {
              shape: "Sc"
            },
            Rotate: {},
            PresetId: {},
            SegmentDuration: {},
            Status: {},
            StatusDetail: {},
            Duration: {
              type: "long"
            },
            Width: {
              type: "integer"
            },
            Height: {
              type: "integer"
            },
            FrameRate: {},
            FileSize: {
              type: "long"
            },
            DurationMillis: {
              type: "long"
            },
            Watermarks: {
              shape: "Sx"
            },
            AlbumArt: {
              shape: "S11"
            },
            Composition: {
              shape: "S19",
              deprecated: true
            },
            Captions: {
              shape: "S1b"
            },
            Encryption: {
              shape: "Sc"
            },
            AppliedColorSpaceConversion: {}
          }
        },
        S2a: {
          type: "structure",
          members: {
            Progressing: {},
            Completed: {},
            Warning: {},
            Error: {}
          }
        },
        S2c: {
          type: "structure",
          members: {
            Bucket: {},
            StorageClass: {},
            Permissions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  GranteeType: {},
                  Grantee: {},
                  Access: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        S2l: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {},
            Status: {},
            InputBucket: {},
            OutputBucket: {},
            Role: {},
            AwsKmsKeyArn: {},
            Notifications: {
              shape: "S2a"
            },
            ContentConfig: {
              shape: "S2c"
            },
            ThumbnailConfig: {
              shape: "S2c"
            }
          }
        },
        S2n: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Code: {},
              Message: {}
            }
          }
        },
        S2r: {
          type: "structure",
          members: {
            Codec: {},
            CodecOptions: {
              type: "map",
              key: {},
              value: {}
            },
            KeyframesMaxDist: {},
            FixedGOP: {},
            BitRate: {},
            FrameRate: {},
            MaxFrameRate: {},
            Resolution: {},
            AspectRatio: {},
            MaxWidth: {},
            MaxHeight: {},
            DisplayAspectRatio: {},
            SizingPolicy: {},
            PaddingPolicy: {},
            Watermarks: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Id: {},
                  MaxWidth: {},
                  MaxHeight: {},
                  SizingPolicy: {},
                  HorizontalAlign: {},
                  HorizontalOffset: {},
                  VerticalAlign: {},
                  VerticalOffset: {},
                  Opacity: {},
                  Target: {}
                }
              }
            }
          }
        },
        S37: {
          type: "structure",
          members: {
            Codec: {},
            SampleRate: {},
            BitRate: {},
            Channels: {},
            AudioPackingMode: {},
            CodecOptions: {
              type: "structure",
              members: {
                Profile: {},
                BitDepth: {},
                BitOrder: {},
                Signed: {}
              }
            }
          }
        },
        S3i: {
          type: "structure",
          members: {
            Format: {},
            Interval: {},
            Resolution: {},
            AspectRatio: {},
            MaxWidth: {},
            MaxHeight: {},
            SizingPolicy: {},
            PaddingPolicy: {}
          }
        },
        S3m: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {},
            Description: {},
            Container: {},
            Audio: {
              shape: "S37"
            },
            Video: {
              shape: "S2r"
            },
            Thumbnails: {
              shape: "S3i"
            },
            Type: {}
          }
        },
        S3v: {
          type: "list",
          member: {
            shape: "S1y"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elastictranscoder-2012-09-25.paginators.json
var require_elastictranscoder_2012_09_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/elastictranscoder-2012-09-25.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListJobsByPipeline: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          result_key: "Jobs"
        },
        ListJobsByStatus: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          result_key: "Jobs"
        },
        ListPipelines: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          result_key: "Pipelines"
        },
        ListPresets: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          result_key: "Presets"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elastictranscoder-2012-09-25.waiters2.json
var require_elastictranscoder_2012_09_25_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/elastictranscoder-2012-09-25.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        JobComplete: {
          delay: 30,
          operation: "ReadJob",
          maxAttempts: 120,
          acceptors: [
            {
              expected: "Complete",
              matcher: "path",
              state: "success",
              argument: "Job.Status"
            },
            {
              expected: "Canceled",
              matcher: "path",
              state: "failure",
              argument: "Job.Status"
            },
            {
              expected: "Error",
              matcher: "path",
              state: "failure",
              argument: "Job.Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/elastictranscoder.js
var require_elastictranscoder = __commonJS({
  "node_modules/aws-sdk/clients/elastictranscoder.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["elastictranscoder"] = {};
    AWS3.ElasticTranscoder = Service.defineService("elastictranscoder", ["2012-09-25"]);
    Object.defineProperty(apiLoader.services["elastictranscoder"], "2012-09-25", {
      get: function get() {
        var model = require_elastictranscoder_2012_09_25_min();
        model.paginators = require_elastictranscoder_2012_09_25_paginators().pagination;
        model.waiters = require_elastictranscoder_2012_09_25_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ElasticTranscoder;
  }
});

// node_modules/aws-sdk/apis/firehose-2015-08-04.min.json
var require_firehose_2015_08_04_min = __commonJS({
  "node_modules/aws-sdk/apis/firehose-2015-08-04.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-08-04",
        endpointPrefix: "firehose",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Firehose",
        serviceFullName: "Amazon Kinesis Firehose",
        serviceId: "Firehose",
        signatureVersion: "v4",
        targetPrefix: "Firehose_20150804",
        uid: "firehose-2015-08-04"
      },
      operations: {
        CreateDeliveryStream: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName"
            ],
            members: {
              DeliveryStreamName: {},
              DeliveryStreamType: {},
              KinesisStreamSourceConfiguration: {
                type: "structure",
                required: [
                  "KinesisStreamARN",
                  "RoleARN"
                ],
                members: {
                  KinesisStreamARN: {},
                  RoleARN: {}
                }
              },
              DeliveryStreamEncryptionConfigurationInput: {
                shape: "S7"
              },
              S3DestinationConfiguration: {
                shape: "Sa",
                deprecated: true
              },
              ExtendedS3DestinationConfiguration: {
                type: "structure",
                required: [
                  "RoleARN",
                  "BucketARN"
                ],
                members: {
                  RoleARN: {},
                  BucketARN: {},
                  Prefix: {},
                  ErrorOutputPrefix: {},
                  BufferingHints: {
                    shape: "Se"
                  },
                  CompressionFormat: {},
                  EncryptionConfiguration: {
                    shape: "Si"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  S3BackupMode: {},
                  S3BackupConfiguration: {
                    shape: "Sa"
                  },
                  DataFormatConversionConfiguration: {
                    shape: "Sz"
                  },
                  DynamicPartitioningConfiguration: {
                    shape: "S1o"
                  }
                }
              },
              RedshiftDestinationConfiguration: {
                type: "structure",
                required: [
                  "RoleARN",
                  "ClusterJDBCURL",
                  "CopyCommand",
                  "Username",
                  "Password",
                  "S3Configuration"
                ],
                members: {
                  RoleARN: {},
                  ClusterJDBCURL: {},
                  CopyCommand: {
                    shape: "S1t"
                  },
                  Username: {
                    shape: "S1x"
                  },
                  Password: {
                    shape: "S1y"
                  },
                  RetryOptions: {
                    shape: "S1z"
                  },
                  S3Configuration: {
                    shape: "Sa"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  S3BackupMode: {},
                  S3BackupConfiguration: {
                    shape: "Sa"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  }
                }
              },
              ElasticsearchDestinationConfiguration: {
                type: "structure",
                required: [
                  "RoleARN",
                  "IndexName",
                  "S3Configuration"
                ],
                members: {
                  RoleARN: {},
                  DomainARN: {},
                  ClusterEndpoint: {},
                  IndexName: {},
                  TypeName: {},
                  IndexRotationPeriod: {},
                  BufferingHints: {
                    shape: "S28"
                  },
                  RetryOptions: {
                    shape: "S2b"
                  },
                  S3BackupMode: {},
                  S3Configuration: {
                    shape: "Sa"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  },
                  VpcConfiguration: {
                    shape: "S2e"
                  }
                }
              },
              AmazonopensearchserviceDestinationConfiguration: {
                type: "structure",
                required: [
                  "RoleARN",
                  "IndexName",
                  "S3Configuration"
                ],
                members: {
                  RoleARN: {},
                  DomainARN: {},
                  ClusterEndpoint: {},
                  IndexName: {},
                  TypeName: {},
                  IndexRotationPeriod: {},
                  BufferingHints: {
                    shape: "S2n"
                  },
                  RetryOptions: {
                    shape: "S2q"
                  },
                  S3BackupMode: {},
                  S3Configuration: {
                    shape: "Sa"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  },
                  VpcConfiguration: {
                    shape: "S2e"
                  }
                }
              },
              SplunkDestinationConfiguration: {
                type: "structure",
                required: [
                  "HECEndpoint",
                  "HECEndpointType",
                  "HECToken",
                  "S3Configuration"
                ],
                members: {
                  HECEndpoint: {},
                  HECEndpointType: {},
                  HECToken: {},
                  HECAcknowledgmentTimeoutInSeconds: {
                    type: "integer"
                  },
                  RetryOptions: {
                    shape: "S2y"
                  },
                  S3BackupMode: {},
                  S3Configuration: {
                    shape: "Sa"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  }
                }
              },
              HttpEndpointDestinationConfiguration: {
                type: "structure",
                required: [
                  "EndpointConfiguration",
                  "S3Configuration"
                ],
                members: {
                  EndpointConfiguration: {
                    shape: "S32"
                  },
                  BufferingHints: {
                    shape: "S36"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  },
                  RequestConfiguration: {
                    shape: "S39"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  RoleARN: {},
                  RetryOptions: {
                    shape: "S3f"
                  },
                  S3BackupMode: {},
                  S3Configuration: {
                    shape: "Sa"
                  }
                }
              },
              Tags: {
                shape: "S3i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeliveryStreamARN: {}
            }
          }
        },
        DeleteDeliveryStream: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName"
            ],
            members: {
              DeliveryStreamName: {},
              AllowForceDelete: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeDeliveryStream: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName"
            ],
            members: {
              DeliveryStreamName: {},
              Limit: {
                type: "integer"
              },
              ExclusiveStartDestinationId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DeliveryStreamDescription"
            ],
            members: {
              DeliveryStreamDescription: {
                type: "structure",
                required: [
                  "DeliveryStreamName",
                  "DeliveryStreamARN",
                  "DeliveryStreamStatus",
                  "DeliveryStreamType",
                  "VersionId",
                  "Destinations",
                  "HasMoreDestinations"
                ],
                members: {
                  DeliveryStreamName: {},
                  DeliveryStreamARN: {},
                  DeliveryStreamStatus: {},
                  FailureDescription: {
                    shape: "S3w"
                  },
                  DeliveryStreamEncryptionConfiguration: {
                    type: "structure",
                    members: {
                      KeyARN: {},
                      KeyType: {},
                      Status: {},
                      FailureDescription: {
                        shape: "S3w"
                      }
                    }
                  },
                  DeliveryStreamType: {},
                  VersionId: {},
                  CreateTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdateTimestamp: {
                    type: "timestamp"
                  },
                  Source: {
                    type: "structure",
                    members: {
                      KinesisStreamSourceDescription: {
                        type: "structure",
                        members: {
                          KinesisStreamARN: {},
                          RoleARN: {},
                          DeliveryStartTimestamp: {
                            type: "timestamp"
                          }
                        }
                      }
                    }
                  },
                  Destinations: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "DestinationId"
                      ],
                      members: {
                        DestinationId: {},
                        S3DestinationDescription: {
                          shape: "S47"
                        },
                        ExtendedS3DestinationDescription: {
                          type: "structure",
                          required: [
                            "RoleARN",
                            "BucketARN",
                            "BufferingHints",
                            "CompressionFormat",
                            "EncryptionConfiguration"
                          ],
                          members: {
                            RoleARN: {},
                            BucketARN: {},
                            Prefix: {},
                            ErrorOutputPrefix: {},
                            BufferingHints: {
                              shape: "Se"
                            },
                            CompressionFormat: {},
                            EncryptionConfiguration: {
                              shape: "Si"
                            },
                            CloudWatchLoggingOptions: {
                              shape: "Sl"
                            },
                            ProcessingConfiguration: {
                              shape: "Sq"
                            },
                            S3BackupMode: {},
                            S3BackupDescription: {
                              shape: "S47"
                            },
                            DataFormatConversionConfiguration: {
                              shape: "Sz"
                            },
                            DynamicPartitioningConfiguration: {
                              shape: "S1o"
                            }
                          }
                        },
                        RedshiftDestinationDescription: {
                          type: "structure",
                          required: [
                            "RoleARN",
                            "ClusterJDBCURL",
                            "CopyCommand",
                            "Username",
                            "S3DestinationDescription"
                          ],
                          members: {
                            RoleARN: {},
                            ClusterJDBCURL: {},
                            CopyCommand: {
                              shape: "S1t"
                            },
                            Username: {
                              shape: "S1x"
                            },
                            RetryOptions: {
                              shape: "S1z"
                            },
                            S3DestinationDescription: {
                              shape: "S47"
                            },
                            ProcessingConfiguration: {
                              shape: "Sq"
                            },
                            S3BackupMode: {},
                            S3BackupDescription: {
                              shape: "S47"
                            },
                            CloudWatchLoggingOptions: {
                              shape: "Sl"
                            }
                          }
                        },
                        ElasticsearchDestinationDescription: {
                          type: "structure",
                          members: {
                            RoleARN: {},
                            DomainARN: {},
                            ClusterEndpoint: {},
                            IndexName: {},
                            TypeName: {},
                            IndexRotationPeriod: {},
                            BufferingHints: {
                              shape: "S28"
                            },
                            RetryOptions: {
                              shape: "S2b"
                            },
                            S3BackupMode: {},
                            S3DestinationDescription: {
                              shape: "S47"
                            },
                            ProcessingConfiguration: {
                              shape: "Sq"
                            },
                            CloudWatchLoggingOptions: {
                              shape: "Sl"
                            },
                            VpcConfigurationDescription: {
                              shape: "S4b"
                            }
                          }
                        },
                        AmazonopensearchserviceDestinationDescription: {
                          type: "structure",
                          members: {
                            RoleARN: {},
                            DomainARN: {},
                            ClusterEndpoint: {},
                            IndexName: {},
                            TypeName: {},
                            IndexRotationPeriod: {},
                            BufferingHints: {
                              shape: "S2n"
                            },
                            RetryOptions: {
                              shape: "S2q"
                            },
                            S3BackupMode: {},
                            S3DestinationDescription: {
                              shape: "S47"
                            },
                            ProcessingConfiguration: {
                              shape: "Sq"
                            },
                            CloudWatchLoggingOptions: {
                              shape: "Sl"
                            },
                            VpcConfigurationDescription: {
                              shape: "S4b"
                            }
                          }
                        },
                        SplunkDestinationDescription: {
                          type: "structure",
                          members: {
                            HECEndpoint: {},
                            HECEndpointType: {},
                            HECToken: {},
                            HECAcknowledgmentTimeoutInSeconds: {
                              type: "integer"
                            },
                            RetryOptions: {
                              shape: "S2y"
                            },
                            S3BackupMode: {},
                            S3DestinationDescription: {
                              shape: "S47"
                            },
                            ProcessingConfiguration: {
                              shape: "Sq"
                            },
                            CloudWatchLoggingOptions: {
                              shape: "Sl"
                            }
                          }
                        },
                        HttpEndpointDestinationDescription: {
                          type: "structure",
                          members: {
                            EndpointConfiguration: {
                              type: "structure",
                              members: {
                                Url: {
                                  shape: "S33"
                                },
                                Name: {}
                              }
                            },
                            BufferingHints: {
                              shape: "S36"
                            },
                            CloudWatchLoggingOptions: {
                              shape: "Sl"
                            },
                            RequestConfiguration: {
                              shape: "S39"
                            },
                            ProcessingConfiguration: {
                              shape: "Sq"
                            },
                            RoleARN: {},
                            RetryOptions: {
                              shape: "S3f"
                            },
                            S3BackupMode: {},
                            S3DestinationDescription: {
                              shape: "S47"
                            }
                          }
                        }
                      }
                    }
                  },
                  HasMoreDestinations: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        ListDeliveryStreams: {
          input: {
            type: "structure",
            members: {
              Limit: {
                type: "integer"
              },
              DeliveryStreamType: {},
              ExclusiveStartDeliveryStreamName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DeliveryStreamNames",
              "HasMoreDeliveryStreams"
            ],
            members: {
              DeliveryStreamNames: {
                type: "list",
                member: {}
              },
              HasMoreDeliveryStreams: {
                type: "boolean"
              }
            }
          }
        },
        ListTagsForDeliveryStream: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName"
            ],
            members: {
              DeliveryStreamName: {},
              ExclusiveStartTagKey: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags",
              "HasMoreTags"
            ],
            members: {
              Tags: {
                type: "list",
                member: {
                  shape: "S3j"
                }
              },
              HasMoreTags: {
                type: "boolean"
              }
            }
          }
        },
        PutRecord: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName",
              "Record"
            ],
            members: {
              DeliveryStreamName: {},
              Record: {
                shape: "S4p"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RecordId"
            ],
            members: {
              RecordId: {},
              Encrypted: {
                type: "boolean"
              }
            }
          }
        },
        PutRecordBatch: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName",
              "Records"
            ],
            members: {
              DeliveryStreamName: {},
              Records: {
                type: "list",
                member: {
                  shape: "S4p"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "FailedPutCount",
              "RequestResponses"
            ],
            members: {
              FailedPutCount: {
                type: "integer"
              },
              Encrypted: {
                type: "boolean"
              },
              RequestResponses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RecordId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        StartDeliveryStreamEncryption: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName"
            ],
            members: {
              DeliveryStreamName: {},
              DeliveryStreamEncryptionConfigurationInput: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopDeliveryStreamEncryption: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName"
            ],
            members: {
              DeliveryStreamName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagDeliveryStream: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName",
              "Tags"
            ],
            members: {
              DeliveryStreamName: {},
              Tags: {
                shape: "S3i"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagDeliveryStream: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName",
              "TagKeys"
            ],
            members: {
              DeliveryStreamName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDestination: {
          input: {
            type: "structure",
            required: [
              "DeliveryStreamName",
              "CurrentDeliveryStreamVersionId",
              "DestinationId"
            ],
            members: {
              DeliveryStreamName: {},
              CurrentDeliveryStreamVersionId: {},
              DestinationId: {},
              S3DestinationUpdate: {
                shape: "S5a",
                deprecated: true
              },
              ExtendedS3DestinationUpdate: {
                type: "structure",
                members: {
                  RoleARN: {},
                  BucketARN: {},
                  Prefix: {},
                  ErrorOutputPrefix: {},
                  BufferingHints: {
                    shape: "Se"
                  },
                  CompressionFormat: {},
                  EncryptionConfiguration: {
                    shape: "Si"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  S3BackupMode: {},
                  S3BackupUpdate: {
                    shape: "S5a"
                  },
                  DataFormatConversionConfiguration: {
                    shape: "Sz"
                  },
                  DynamicPartitioningConfiguration: {
                    shape: "S1o"
                  }
                }
              },
              RedshiftDestinationUpdate: {
                type: "structure",
                members: {
                  RoleARN: {},
                  ClusterJDBCURL: {},
                  CopyCommand: {
                    shape: "S1t"
                  },
                  Username: {
                    shape: "S1x"
                  },
                  Password: {
                    shape: "S1y"
                  },
                  RetryOptions: {
                    shape: "S1z"
                  },
                  S3Update: {
                    shape: "S5a"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  S3BackupMode: {},
                  S3BackupUpdate: {
                    shape: "S5a"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  }
                }
              },
              ElasticsearchDestinationUpdate: {
                type: "structure",
                members: {
                  RoleARN: {},
                  DomainARN: {},
                  ClusterEndpoint: {},
                  IndexName: {},
                  TypeName: {},
                  IndexRotationPeriod: {},
                  BufferingHints: {
                    shape: "S28"
                  },
                  RetryOptions: {
                    shape: "S2b"
                  },
                  S3Update: {
                    shape: "S5a"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  }
                }
              },
              AmazonopensearchserviceDestinationUpdate: {
                type: "structure",
                members: {
                  RoleARN: {},
                  DomainARN: {},
                  ClusterEndpoint: {},
                  IndexName: {},
                  TypeName: {},
                  IndexRotationPeriod: {},
                  BufferingHints: {
                    shape: "S2n"
                  },
                  RetryOptions: {
                    shape: "S2q"
                  },
                  S3Update: {
                    shape: "S5a"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  }
                }
              },
              SplunkDestinationUpdate: {
                type: "structure",
                members: {
                  HECEndpoint: {},
                  HECEndpointType: {},
                  HECToken: {},
                  HECAcknowledgmentTimeoutInSeconds: {
                    type: "integer"
                  },
                  RetryOptions: {
                    shape: "S2y"
                  },
                  S3BackupMode: {},
                  S3Update: {
                    shape: "S5a"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  }
                }
              },
              HttpEndpointDestinationUpdate: {
                type: "structure",
                members: {
                  EndpointConfiguration: {
                    shape: "S32"
                  },
                  BufferingHints: {
                    shape: "S36"
                  },
                  CloudWatchLoggingOptions: {
                    shape: "Sl"
                  },
                  RequestConfiguration: {
                    shape: "S39"
                  },
                  ProcessingConfiguration: {
                    shape: "Sq"
                  },
                  RoleARN: {},
                  RetryOptions: {
                    shape: "S3f"
                  },
                  S3BackupMode: {},
                  S3Update: {
                    shape: "S5a"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S7: {
          type: "structure",
          required: [
            "KeyType"
          ],
          members: {
            KeyARN: {},
            KeyType: {}
          }
        },
        Sa: {
          type: "structure",
          required: [
            "RoleARN",
            "BucketARN"
          ],
          members: {
            RoleARN: {},
            BucketARN: {},
            Prefix: {},
            ErrorOutputPrefix: {},
            BufferingHints: {
              shape: "Se"
            },
            CompressionFormat: {},
            EncryptionConfiguration: {
              shape: "Si"
            },
            CloudWatchLoggingOptions: {
              shape: "Sl"
            }
          }
        },
        Se: {
          type: "structure",
          members: {
            SizeInMBs: {
              type: "integer"
            },
            IntervalInSeconds: {
              type: "integer"
            }
          }
        },
        Si: {
          type: "structure",
          members: {
            NoEncryptionConfig: {},
            KMSEncryptionConfig: {
              type: "structure",
              required: [
                "AWSKMSKeyARN"
              ],
              members: {
                AWSKMSKeyARN: {}
              }
            }
          }
        },
        Sl: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            LogGroupName: {},
            LogStreamName: {}
          }
        },
        Sq: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            Processors: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Type"
                ],
                members: {
                  Type: {},
                  Parameters: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "ParameterName",
                        "ParameterValue"
                      ],
                      members: {
                        ParameterName: {},
                        ParameterValue: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sz: {
          type: "structure",
          members: {
            SchemaConfiguration: {
              type: "structure",
              members: {
                RoleARN: {},
                CatalogId: {},
                DatabaseName: {},
                TableName: {},
                Region: {},
                VersionId: {}
              }
            },
            InputFormatConfiguration: {
              type: "structure",
              members: {
                Deserializer: {
                  type: "structure",
                  members: {
                    OpenXJsonSerDe: {
                      type: "structure",
                      members: {
                        ConvertDotsInJsonKeysToUnderscores: {
                          type: "boolean"
                        },
                        CaseInsensitive: {
                          type: "boolean"
                        },
                        ColumnToJsonKeyMappings: {
                          type: "map",
                          key: {},
                          value: {}
                        }
                      }
                    },
                    HiveJsonSerDe: {
                      type: "structure",
                      members: {
                        TimestampFormats: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                }
              }
            },
            OutputFormatConfiguration: {
              type: "structure",
              members: {
                Serializer: {
                  type: "structure",
                  members: {
                    ParquetSerDe: {
                      type: "structure",
                      members: {
                        BlockSizeBytes: {
                          type: "integer"
                        },
                        PageSizeBytes: {
                          type: "integer"
                        },
                        Compression: {},
                        EnableDictionaryCompression: {
                          type: "boolean"
                        },
                        MaxPaddingBytes: {
                          type: "integer"
                        },
                        WriterVersion: {}
                      }
                    },
                    OrcSerDe: {
                      type: "structure",
                      members: {
                        StripeSizeBytes: {
                          type: "integer"
                        },
                        BlockSizeBytes: {
                          type: "integer"
                        },
                        RowIndexStride: {
                          type: "integer"
                        },
                        EnablePadding: {
                          type: "boolean"
                        },
                        PaddingTolerance: {
                          type: "double"
                        },
                        Compression: {},
                        BloomFilterColumns: {
                          type: "list",
                          member: {}
                        },
                        BloomFilterFalsePositiveProbability: {
                          type: "double"
                        },
                        DictionaryKeyThreshold: {
                          type: "double"
                        },
                        FormatVersion: {}
                      }
                    }
                  }
                }
              }
            },
            Enabled: {
              type: "boolean"
            }
          }
        },
        S1o: {
          type: "structure",
          members: {
            RetryOptions: {
              type: "structure",
              members: {
                DurationInSeconds: {
                  type: "integer"
                }
              }
            },
            Enabled: {
              type: "boolean"
            }
          }
        },
        S1t: {
          type: "structure",
          required: [
            "DataTableName"
          ],
          members: {
            DataTableName: {},
            DataTableColumns: {},
            CopyOptions: {}
          }
        },
        S1x: {
          type: "string",
          sensitive: true
        },
        S1y: {
          type: "string",
          sensitive: true
        },
        S1z: {
          type: "structure",
          members: {
            DurationInSeconds: {
              type: "integer"
            }
          }
        },
        S28: {
          type: "structure",
          members: {
            IntervalInSeconds: {
              type: "integer"
            },
            SizeInMBs: {
              type: "integer"
            }
          }
        },
        S2b: {
          type: "structure",
          members: {
            DurationInSeconds: {
              type: "integer"
            }
          }
        },
        S2e: {
          type: "structure",
          required: [
            "SubnetIds",
            "RoleARN",
            "SecurityGroupIds"
          ],
          members: {
            SubnetIds: {
              shape: "S2f"
            },
            RoleARN: {},
            SecurityGroupIds: {
              shape: "S2g"
            }
          }
        },
        S2f: {
          type: "list",
          member: {}
        },
        S2g: {
          type: "list",
          member: {}
        },
        S2n: {
          type: "structure",
          members: {
            IntervalInSeconds: {
              type: "integer"
            },
            SizeInMBs: {
              type: "integer"
            }
          }
        },
        S2q: {
          type: "structure",
          members: {
            DurationInSeconds: {
              type: "integer"
            }
          }
        },
        S2y: {
          type: "structure",
          members: {
            DurationInSeconds: {
              type: "integer"
            }
          }
        },
        S32: {
          type: "structure",
          required: [
            "Url"
          ],
          members: {
            Url: {
              shape: "S33"
            },
            Name: {},
            AccessKey: {
              type: "string",
              sensitive: true
            }
          }
        },
        S33: {
          type: "string",
          sensitive: true
        },
        S36: {
          type: "structure",
          members: {
            SizeInMBs: {
              type: "integer"
            },
            IntervalInSeconds: {
              type: "integer"
            }
          }
        },
        S39: {
          type: "structure",
          members: {
            ContentEncoding: {},
            CommonAttributes: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "AttributeName",
                  "AttributeValue"
                ],
                members: {
                  AttributeName: {
                    type: "string",
                    sensitive: true
                  },
                  AttributeValue: {
                    type: "string",
                    sensitive: true
                  }
                }
              }
            }
          }
        },
        S3f: {
          type: "structure",
          members: {
            DurationInSeconds: {
              type: "integer"
            }
          }
        },
        S3i: {
          type: "list",
          member: {
            shape: "S3j"
          }
        },
        S3j: {
          type: "structure",
          required: [
            "Key"
          ],
          members: {
            Key: {},
            Value: {}
          }
        },
        S3w: {
          type: "structure",
          required: [
            "Type",
            "Details"
          ],
          members: {
            Type: {},
            Details: {}
          }
        },
        S47: {
          type: "structure",
          required: [
            "RoleARN",
            "BucketARN",
            "BufferingHints",
            "CompressionFormat",
            "EncryptionConfiguration"
          ],
          members: {
            RoleARN: {},
            BucketARN: {},
            Prefix: {},
            ErrorOutputPrefix: {},
            BufferingHints: {
              shape: "Se"
            },
            CompressionFormat: {},
            EncryptionConfiguration: {
              shape: "Si"
            },
            CloudWatchLoggingOptions: {
              shape: "Sl"
            }
          }
        },
        S4b: {
          type: "structure",
          required: [
            "SubnetIds",
            "RoleARN",
            "SecurityGroupIds",
            "VpcId"
          ],
          members: {
            SubnetIds: {
              shape: "S2f"
            },
            RoleARN: {},
            SecurityGroupIds: {
              shape: "S2g"
            },
            VpcId: {}
          }
        },
        S4p: {
          type: "structure",
          required: [
            "Data"
          ],
          members: {
            Data: {
              type: "blob"
            }
          }
        },
        S5a: {
          type: "structure",
          members: {
            RoleARN: {},
            BucketARN: {},
            Prefix: {},
            ErrorOutputPrefix: {},
            BufferingHints: {
              shape: "Se"
            },
            CompressionFormat: {},
            EncryptionConfiguration: {
              shape: "Si"
            },
            CloudWatchLoggingOptions: {
              shape: "Sl"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/firehose-2015-08-04.paginators.json
var require_firehose_2015_08_04_paginators = __commonJS({
  "node_modules/aws-sdk/apis/firehose-2015-08-04.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/firehose.js
var require_firehose = __commonJS({
  "node_modules/aws-sdk/clients/firehose.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["firehose"] = {};
    AWS3.Firehose = Service.defineService("firehose", ["2015-08-04"]);
    Object.defineProperty(apiLoader.services["firehose"], "2015-08-04", {
      get: function get() {
        var model = require_firehose_2015_08_04_min();
        model.paginators = require_firehose_2015_08_04_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Firehose;
  }
});

// node_modules/aws-sdk/apis/gamelift-2015-10-01.min.json
var require_gamelift_2015_10_01_min = __commonJS({
  "node_modules/aws-sdk/apis/gamelift-2015-10-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-10-01",
        endpointPrefix: "gamelift",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon GameLift",
        serviceId: "GameLift",
        signatureVersion: "v4",
        targetPrefix: "GameLift",
        uid: "gamelift-2015-10-01"
      },
      operations: {
        AcceptMatch: {
          input: {
            type: "structure",
            required: [
              "TicketId",
              "PlayerIds",
              "AcceptanceType"
            ],
            members: {
              TicketId: {},
              PlayerIds: {
                shape: "S3"
              },
              AcceptanceType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ClaimGameServer: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName"
            ],
            members: {
              GameServerGroupName: {},
              GameServerId: {},
              GameServerData: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameServer: {
                shape: "Sc"
              }
            }
          }
        },
        CreateAlias: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RoutingStrategy"
            ],
            members: {
              Name: {},
              Description: {},
              RoutingStrategy: {
                shape: "Sm"
              },
              Tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Alias: {
                shape: "Sv"
              }
            }
          }
        },
        CreateBuild: {
          input: {
            type: "structure",
            members: {
              Name: {},
              Version: {},
              StorageLocation: {
                shape: "Sz"
              },
              OperatingSystem: {},
              Tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Build: {
                shape: "S13"
              },
              UploadCredentials: {
                shape: "S18"
              },
              StorageLocation: {
                shape: "Sz"
              }
            }
          }
        },
        CreateFleet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "EC2InstanceType"
            ],
            members: {
              Name: {},
              Description: {},
              BuildId: {},
              ScriptId: {},
              ServerLaunchPath: {},
              ServerLaunchParameters: {},
              LogPaths: {
                shape: "S3"
              },
              EC2InstanceType: {},
              EC2InboundPermissions: {
                shape: "S1d"
              },
              NewGameSessionProtectionPolicy: {},
              RuntimeConfiguration: {
                shape: "S1j"
              },
              ResourceCreationLimitPolicy: {
                shape: "S1p"
              },
              MetricGroups: {
                shape: "S1r"
              },
              PeerVpcAwsAccountId: {},
              PeerVpcId: {},
              FleetType: {},
              InstanceRoleArn: {},
              CertificateConfiguration: {
                shape: "S1u"
              },
              Locations: {
                shape: "S1w"
              },
              Tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FleetAttributes: {
                shape: "S20"
              },
              LocationStates: {
                shape: "S27"
              }
            }
          }
        },
        CreateFleetLocations: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "Locations"
            ],
            members: {
              FleetId: {},
              Locations: {
                shape: "S1w"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {},
              FleetArn: {},
              LocationStates: {
                shape: "S27"
              }
            }
          }
        },
        CreateGameServerGroup: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName",
              "RoleArn",
              "MinSize",
              "MaxSize",
              "LaunchTemplate",
              "InstanceDefinitions"
            ],
            members: {
              GameServerGroupName: {},
              RoleArn: {},
              MinSize: {
                type: "integer"
              },
              MaxSize: {
                type: "integer"
              },
              LaunchTemplate: {
                type: "structure",
                members: {
                  LaunchTemplateId: {},
                  LaunchTemplateName: {},
                  Version: {}
                }
              },
              InstanceDefinitions: {
                shape: "S2i"
              },
              AutoScalingPolicy: {
                type: "structure",
                required: [
                  "TargetTrackingConfiguration"
                ],
                members: {
                  EstimatedInstanceWarmup: {
                    type: "integer"
                  },
                  TargetTrackingConfiguration: {
                    type: "structure",
                    required: [
                      "TargetValue"
                    ],
                    members: {
                      TargetValue: {
                        type: "double"
                      }
                    }
                  }
                }
              },
              BalancingStrategy: {},
              GameServerProtectionPolicy: {},
              VpcSubnets: {
                type: "list",
                member: {}
              },
              Tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GameServerGroup: {
                shape: "S2u"
              }
            }
          }
        },
        CreateGameSession: {
          input: {
            type: "structure",
            required: [
              "MaximumPlayerSessionCount"
            ],
            members: {
              FleetId: {},
              AliasId: {},
              MaximumPlayerSessionCount: {
                type: "integer"
              },
              Name: {},
              GameProperties: {
                shape: "S31"
              },
              CreatorId: {},
              GameSessionId: {},
              IdempotencyToken: {},
              GameSessionData: {},
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameSession: {
                shape: "S38"
              }
            }
          }
        },
        CreateGameSessionQueue: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              TimeoutInSeconds: {
                type: "integer"
              },
              PlayerLatencyPolicies: {
                shape: "S3h"
              },
              Destinations: {
                shape: "S3j"
              },
              FilterConfiguration: {
                shape: "S3m"
              },
              PriorityConfiguration: {
                shape: "S3o"
              },
              CustomEventData: {},
              NotificationTarget: {},
              Tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GameSessionQueue: {
                shape: "S3u"
              }
            }
          }
        },
        CreateMatchmakingConfiguration: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RequestTimeoutSeconds",
              "AcceptanceRequired",
              "RuleSetName"
            ],
            members: {
              Name: {},
              Description: {},
              GameSessionQueueArns: {
                shape: "S3x"
              },
              RequestTimeoutSeconds: {
                type: "integer"
              },
              AcceptanceTimeoutSeconds: {
                type: "integer"
              },
              AcceptanceRequired: {
                type: "boolean"
              },
              RuleSetName: {},
              NotificationTarget: {},
              AdditionalPlayerCount: {
                type: "integer"
              },
              CustomEventData: {},
              GameProperties: {
                shape: "S31"
              },
              GameSessionData: {},
              BackfillMode: {},
              FlexMatchMode: {},
              Tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Configuration: {
                shape: "S48"
              }
            }
          }
        },
        CreateMatchmakingRuleSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RuleSetBody"
            ],
            members: {
              Name: {},
              RuleSetBody: {},
              Tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RuleSet"
            ],
            members: {
              RuleSet: {
                shape: "S4e"
              }
            }
          }
        },
        CreatePlayerSession: {
          input: {
            type: "structure",
            required: [
              "GameSessionId",
              "PlayerId"
            ],
            members: {
              GameSessionId: {},
              PlayerId: {},
              PlayerData: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PlayerSession: {
                shape: "S4i"
              }
            }
          }
        },
        CreatePlayerSessions: {
          input: {
            type: "structure",
            required: [
              "GameSessionId",
              "PlayerIds"
            ],
            members: {
              GameSessionId: {},
              PlayerIds: {
                type: "list",
                member: {}
              },
              PlayerDataMap: {
                type: "map",
                key: {},
                value: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PlayerSessions: {
                shape: "S4p"
              }
            }
          }
        },
        CreateScript: {
          input: {
            type: "structure",
            members: {
              Name: {},
              Version: {},
              StorageLocation: {
                shape: "Sz"
              },
              ZipFile: {
                type: "blob"
              },
              Tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Script: {
                shape: "S4t"
              }
            }
          }
        },
        CreateVpcPeeringAuthorization: {
          input: {
            type: "structure",
            required: [
              "GameLiftAwsAccountId",
              "PeerVpcId"
            ],
            members: {
              GameLiftAwsAccountId: {},
              PeerVpcId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VpcPeeringAuthorization: {
                shape: "S4w"
              }
            }
          }
        },
        CreateVpcPeeringConnection: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "PeerVpcAwsAccountId",
              "PeerVpcId"
            ],
            members: {
              FleetId: {},
              PeerVpcAwsAccountId: {},
              PeerVpcId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAlias: {
          input: {
            type: "structure",
            required: [
              "AliasId"
            ],
            members: {
              AliasId: {}
            }
          }
        },
        DeleteBuild: {
          input: {
            type: "structure",
            required: [
              "BuildId"
            ],
            members: {
              BuildId: {}
            }
          }
        },
        DeleteFleet: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {}
            }
          }
        },
        DeleteFleetLocations: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "Locations"
            ],
            members: {
              FleetId: {},
              Locations: {
                shape: "S3n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {},
              FleetArn: {},
              LocationStates: {
                shape: "S27"
              }
            }
          }
        },
        DeleteGameServerGroup: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName"
            ],
            members: {
              GameServerGroupName: {},
              DeleteOption: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameServerGroup: {
                shape: "S2u"
              }
            }
          }
        },
        DeleteGameSessionQueue: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteMatchmakingConfiguration: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteMatchmakingRuleSet: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteScalingPolicy: {
          input: {
            type: "structure",
            required: [
              "Name",
              "FleetId"
            ],
            members: {
              Name: {},
              FleetId: {}
            }
          }
        },
        DeleteScript: {
          input: {
            type: "structure",
            required: [
              "ScriptId"
            ],
            members: {
              ScriptId: {}
            }
          }
        },
        DeleteVpcPeeringAuthorization: {
          input: {
            type: "structure",
            required: [
              "GameLiftAwsAccountId",
              "PeerVpcId"
            ],
            members: {
              GameLiftAwsAccountId: {},
              PeerVpcId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteVpcPeeringConnection: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "VpcPeeringConnectionId"
            ],
            members: {
              FleetId: {},
              VpcPeeringConnectionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterGameServer: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName",
              "GameServerId"
            ],
            members: {
              GameServerGroupName: {},
              GameServerId: {}
            }
          }
        },
        DescribeAlias: {
          input: {
            type: "structure",
            required: [
              "AliasId"
            ],
            members: {
              AliasId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Alias: {
                shape: "Sv"
              }
            }
          }
        },
        DescribeBuild: {
          input: {
            type: "structure",
            required: [
              "BuildId"
            ],
            members: {
              BuildId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Build: {
                shape: "S13"
              }
            }
          }
        },
        DescribeEC2InstanceLimits: {
          input: {
            type: "structure",
            members: {
              EC2InstanceType: {},
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EC2InstanceLimits: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EC2InstanceType: {},
                    CurrentInstances: {
                      type: "integer"
                    },
                    InstanceLimit: {
                      type: "integer"
                    },
                    Location: {}
                  }
                }
              }
            }
          }
        },
        DescribeFleetAttributes: {
          input: {
            type: "structure",
            members: {
              FleetIds: {
                shape: "S5v"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetAttributes: {
                type: "list",
                member: {
                  shape: "S20"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeFleetCapacity: {
          input: {
            type: "structure",
            members: {
              FleetIds: {
                shape: "S5v"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetCapacity: {
                type: "list",
                member: {
                  shape: "S61"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeFleetEvents: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventId: {},
                    ResourceId: {},
                    EventCode: {},
                    Message: {},
                    EventTime: {
                      type: "timestamp"
                    },
                    PreSignedLogUrl: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeFleetLocationAttributes: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {},
              Locations: {
                shape: "S3n"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {},
              FleetArn: {},
              LocationAttributes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LocationState: {
                      shape: "S28"
                    },
                    StoppedActions: {
                      shape: "S25"
                    },
                    UpdateStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeFleetLocationCapacity: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "Location"
            ],
            members: {
              FleetId: {},
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetCapacity: {
                shape: "S61"
              }
            }
          }
        },
        DescribeFleetLocationUtilization: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "Location"
            ],
            members: {
              FleetId: {},
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetUtilization: {
                shape: "S6h"
              }
            }
          }
        },
        DescribeFleetPortSettings: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {},
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {},
              FleetArn: {},
              InboundPermissions: {
                shape: "S1d"
              },
              UpdateStatus: {},
              Location: {}
            }
          }
        },
        DescribeFleetUtilization: {
          input: {
            type: "structure",
            members: {
              FleetIds: {
                shape: "S5v"
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetUtilization: {
                type: "list",
                member: {
                  shape: "S6h"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeGameServer: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName",
              "GameServerId"
            ],
            members: {
              GameServerGroupName: {},
              GameServerId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameServer: {
                shape: "Sc"
              }
            }
          }
        },
        DescribeGameServerGroup: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName"
            ],
            members: {
              GameServerGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameServerGroup: {
                shape: "S2u"
              }
            }
          }
        },
        DescribeGameServerInstances: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName"
            ],
            members: {
              GameServerGroupName: {},
              InstanceIds: {
                type: "list",
                member: {}
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameServerInstances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GameServerGroupName: {},
                    GameServerGroupArn: {},
                    InstanceId: {},
                    InstanceStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeGameSessionDetails: {
          input: {
            type: "structure",
            members: {
              FleetId: {},
              GameSessionId: {},
              AliasId: {},
              Location: {},
              StatusFilter: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameSessionDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GameSession: {
                      shape: "S38"
                    },
                    ProtectionPolicy: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeGameSessionPlacement: {
          input: {
            type: "structure",
            required: [
              "PlacementId"
            ],
            members: {
              PlacementId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameSessionPlacement: {
                shape: "S73"
              }
            }
          }
        },
        DescribeGameSessionQueues: {
          input: {
            type: "structure",
            members: {
              Names: {
                type: "list",
                member: {}
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameSessionQueues: {
                type: "list",
                member: {
                  shape: "S3u"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeGameSessions: {
          input: {
            type: "structure",
            members: {
              FleetId: {},
              GameSessionId: {},
              AliasId: {},
              Location: {},
              StatusFilter: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameSessions: {
                shape: "S7g"
              },
              NextToken: {}
            }
          }
        },
        DescribeInstances: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {},
              InstanceId: {},
              Limit: {
                type: "integer"
              },
              NextToken: {},
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Instances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FleetId: {},
                    FleetArn: {},
                    InstanceId: {},
                    IpAddress: {},
                    DnsName: {},
                    OperatingSystem: {},
                    Type: {},
                    Status: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    Location: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMatchmaking: {
          input: {
            type: "structure",
            required: [
              "TicketIds"
            ],
            members: {
              TicketIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TicketList: {
                type: "list",
                member: {
                  shape: "S7r"
                }
              }
            }
          }
        },
        DescribeMatchmakingConfigurations: {
          input: {
            type: "structure",
            members: {
              Names: {
                type: "list",
                member: {}
              },
              RuleSetName: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Configurations: {
                type: "list",
                member: {
                  shape: "S48"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMatchmakingRuleSets: {
          input: {
            type: "structure",
            members: {
              Names: {
                type: "list",
                member: {}
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RuleSets"
            ],
            members: {
              RuleSets: {
                type: "list",
                member: {
                  shape: "S4e"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribePlayerSessions: {
          input: {
            type: "structure",
            members: {
              GameSessionId: {},
              PlayerId: {},
              PlayerSessionId: {},
              PlayerSessionStatusFilter: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PlayerSessions: {
                shape: "S4p"
              },
              NextToken: {}
            }
          }
        },
        DescribeRuntimeConfiguration: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RuntimeConfiguration: {
                shape: "S1j"
              }
            }
          }
        },
        DescribeScalingPolicies: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {},
              StatusFilter: {},
              Limit: {
                type: "integer"
              },
              NextToken: {},
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ScalingPolicies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FleetId: {},
                    FleetArn: {},
                    Name: {},
                    Status: {},
                    ScalingAdjustment: {
                      type: "integer"
                    },
                    ScalingAdjustmentType: {},
                    ComparisonOperator: {},
                    Threshold: {
                      type: "double"
                    },
                    EvaluationPeriods: {
                      type: "integer"
                    },
                    MetricName: {},
                    PolicyType: {},
                    TargetConfiguration: {
                      shape: "S8s"
                    },
                    UpdateStatus: {},
                    Location: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeScript: {
          input: {
            type: "structure",
            required: [
              "ScriptId"
            ],
            members: {
              ScriptId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Script: {
                shape: "S4t"
              }
            }
          }
        },
        DescribeVpcPeeringAuthorizations: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              VpcPeeringAuthorizations: {
                type: "list",
                member: {
                  shape: "S4w"
                }
              }
            }
          }
        },
        DescribeVpcPeeringConnections: {
          input: {
            type: "structure",
            members: {
              FleetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VpcPeeringConnections: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FleetId: {},
                    FleetArn: {},
                    IpV4CidrBlock: {},
                    VpcPeeringConnectionId: {},
                    Status: {
                      type: "structure",
                      members: {
                        Code: {},
                        Message: {}
                      }
                    },
                    PeerVpcId: {},
                    GameLiftVpcId: {}
                  }
                }
              }
            }
          }
        },
        GetGameSessionLogUrl: {
          input: {
            type: "structure",
            required: [
              "GameSessionId"
            ],
            members: {
              GameSessionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PreSignedUrl: {}
            }
          }
        },
        GetInstanceAccess: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "InstanceId"
            ],
            members: {
              FleetId: {},
              InstanceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceAccess: {
                type: "structure",
                members: {
                  FleetId: {},
                  InstanceId: {},
                  IpAddress: {},
                  OperatingSystem: {},
                  Credentials: {
                    type: "structure",
                    members: {
                      UserName: {},
                      Secret: {}
                    },
                    sensitive: true
                  }
                }
              }
            }
          }
        },
        ListAliases: {
          input: {
            type: "structure",
            members: {
              RoutingStrategyType: {},
              Name: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Aliases: {
                type: "list",
                member: {
                  shape: "Sv"
                }
              },
              NextToken: {}
            }
          }
        },
        ListBuilds: {
          input: {
            type: "structure",
            members: {
              Status: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Builds: {
                type: "list",
                member: {
                  shape: "S13"
                }
              },
              NextToken: {}
            }
          }
        },
        ListFleets: {
          input: {
            type: "structure",
            members: {
              BuildId: {},
              ScriptId: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetIds: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListGameServerGroups: {
          input: {
            type: "structure",
            members: {
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameServerGroups: {
                type: "list",
                member: {
                  shape: "S2u"
                }
              },
              NextToken: {}
            }
          }
        },
        ListGameServers: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName"
            ],
            members: {
              GameServerGroupName: {},
              SortOrder: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameServers: {
                type: "list",
                member: {
                  shape: "Sc"
                }
              },
              NextToken: {}
            }
          }
        },
        ListScripts: {
          input: {
            type: "structure",
            members: {
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Scripts: {
                type: "list",
                member: {
                  shape: "S4t"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sq"
              }
            }
          }
        },
        PutScalingPolicy: {
          input: {
            type: "structure",
            required: [
              "Name",
              "FleetId",
              "MetricName"
            ],
            members: {
              Name: {},
              FleetId: {},
              ScalingAdjustment: {
                type: "integer"
              },
              ScalingAdjustmentType: {},
              Threshold: {
                type: "double"
              },
              ComparisonOperator: {},
              EvaluationPeriods: {
                type: "integer"
              },
              MetricName: {},
              PolicyType: {},
              TargetConfiguration: {
                shape: "S8s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        RegisterGameServer: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName",
              "GameServerId",
              "InstanceId"
            ],
            members: {
              GameServerGroupName: {},
              GameServerId: {},
              InstanceId: {},
              ConnectionInfo: {},
              GameServerData: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameServer: {
                shape: "Sc"
              }
            }
          }
        },
        RequestUploadCredentials: {
          input: {
            type: "structure",
            required: [
              "BuildId"
            ],
            members: {
              BuildId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UploadCredentials: {
                shape: "S18"
              },
              StorageLocation: {
                shape: "Sz"
              }
            }
          }
        },
        ResolveAlias: {
          input: {
            type: "structure",
            required: [
              "AliasId"
            ],
            members: {
              AliasId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {},
              FleetArn: {}
            }
          }
        },
        ResumeGameServerGroup: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName",
              "ResumeActions"
            ],
            members: {
              GameServerGroupName: {},
              ResumeActions: {
                shape: "S2x"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GameServerGroup: {
                shape: "S2u"
              }
            }
          }
        },
        SearchGameSessions: {
          input: {
            type: "structure",
            members: {
              FleetId: {},
              AliasId: {},
              Location: {},
              FilterExpression: {},
              SortExpression: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameSessions: {
                shape: "S7g"
              },
              NextToken: {}
            }
          }
        },
        StartFleetActions: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "Actions"
            ],
            members: {
              FleetId: {},
              Actions: {
                shape: "S25"
              },
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {},
              FleetArn: {}
            }
          }
        },
        StartGameSessionPlacement: {
          input: {
            type: "structure",
            required: [
              "PlacementId",
              "GameSessionQueueName",
              "MaximumPlayerSessionCount"
            ],
            members: {
              PlacementId: {},
              GameSessionQueueName: {},
              GameProperties: {
                shape: "S31"
              },
              MaximumPlayerSessionCount: {
                type: "integer"
              },
              GameSessionName: {},
              PlayerLatencies: {
                shape: "S75"
              },
              DesiredPlayerSessions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PlayerId: {},
                    PlayerData: {}
                  }
                }
              },
              GameSessionData: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameSessionPlacement: {
                shape: "S73"
              }
            }
          }
        },
        StartMatchBackfill: {
          input: {
            type: "structure",
            required: [
              "ConfigurationName",
              "Players"
            ],
            members: {
              TicketId: {},
              ConfigurationName: {},
              GameSessionArn: {},
              Players: {
                shape: "S7u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MatchmakingTicket: {
                shape: "S7r"
              }
            }
          }
        },
        StartMatchmaking: {
          input: {
            type: "structure",
            required: [
              "ConfigurationName",
              "Players"
            ],
            members: {
              TicketId: {},
              ConfigurationName: {},
              Players: {
                shape: "S7u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MatchmakingTicket: {
                shape: "S7r"
              }
            }
          }
        },
        StopFleetActions: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "Actions"
            ],
            members: {
              FleetId: {},
              Actions: {
                shape: "S25"
              },
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {},
              FleetArn: {}
            }
          }
        },
        StopGameSessionPlacement: {
          input: {
            type: "structure",
            required: [
              "PlacementId"
            ],
            members: {
              PlacementId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameSessionPlacement: {
                shape: "S73"
              }
            }
          }
        },
        StopMatchmaking: {
          input: {
            type: "structure",
            required: [
              "TicketId"
            ],
            members: {
              TicketId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SuspendGameServerGroup: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName",
              "SuspendActions"
            ],
            members: {
              GameServerGroupName: {},
              SuspendActions: {
                shape: "S2x"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GameServerGroup: {
                shape: "S2u"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAlias: {
          input: {
            type: "structure",
            required: [
              "AliasId"
            ],
            members: {
              AliasId: {},
              Name: {},
              Description: {},
              RoutingStrategy: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Alias: {
                shape: "Sv"
              }
            }
          }
        },
        UpdateBuild: {
          input: {
            type: "structure",
            required: [
              "BuildId"
            ],
            members: {
              BuildId: {},
              Name: {},
              Version: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Build: {
                shape: "S13"
              }
            }
          }
        },
        UpdateFleetAttributes: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {},
              Name: {},
              Description: {},
              NewGameSessionProtectionPolicy: {},
              ResourceCreationLimitPolicy: {
                shape: "S1p"
              },
              MetricGroups: {
                shape: "S1r"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {}
            }
          }
        },
        UpdateFleetCapacity: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {},
              DesiredInstances: {
                type: "integer"
              },
              MinSize: {
                type: "integer"
              },
              MaxSize: {
                type: "integer"
              },
              Location: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {},
              FleetArn: {},
              Location: {}
            }
          }
        },
        UpdateFleetPortSettings: {
          input: {
            type: "structure",
            required: [
              "FleetId"
            ],
            members: {
              FleetId: {},
              InboundPermissionAuthorizations: {
                shape: "S1d"
              },
              InboundPermissionRevocations: {
                shape: "S1d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FleetId: {}
            }
          }
        },
        UpdateGameServer: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName",
              "GameServerId"
            ],
            members: {
              GameServerGroupName: {},
              GameServerId: {},
              GameServerData: {},
              UtilizationStatus: {},
              HealthCheck: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameServer: {
                shape: "Sc"
              }
            }
          }
        },
        UpdateGameServerGroup: {
          input: {
            type: "structure",
            required: [
              "GameServerGroupName"
            ],
            members: {
              GameServerGroupName: {},
              RoleArn: {},
              InstanceDefinitions: {
                shape: "S2i"
              },
              GameServerProtectionPolicy: {},
              BalancingStrategy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameServerGroup: {
                shape: "S2u"
              }
            }
          }
        },
        UpdateGameSession: {
          input: {
            type: "structure",
            required: [
              "GameSessionId"
            ],
            members: {
              GameSessionId: {},
              MaximumPlayerSessionCount: {
                type: "integer"
              },
              Name: {},
              PlayerSessionCreationPolicy: {},
              ProtectionPolicy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameSession: {
                shape: "S38"
              }
            }
          }
        },
        UpdateGameSessionQueue: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              TimeoutInSeconds: {
                type: "integer"
              },
              PlayerLatencyPolicies: {
                shape: "S3h"
              },
              Destinations: {
                shape: "S3j"
              },
              FilterConfiguration: {
                shape: "S3m"
              },
              PriorityConfiguration: {
                shape: "S3o"
              },
              CustomEventData: {},
              NotificationTarget: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GameSessionQueue: {
                shape: "S3u"
              }
            }
          }
        },
        UpdateMatchmakingConfiguration: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              GameSessionQueueArns: {
                shape: "S3x"
              },
              RequestTimeoutSeconds: {
                type: "integer"
              },
              AcceptanceTimeoutSeconds: {
                type: "integer"
              },
              AcceptanceRequired: {
                type: "boolean"
              },
              RuleSetName: {},
              NotificationTarget: {},
              AdditionalPlayerCount: {
                type: "integer"
              },
              CustomEventData: {},
              GameProperties: {
                shape: "S31"
              },
              GameSessionData: {},
              BackfillMode: {},
              FlexMatchMode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Configuration: {
                shape: "S48"
              }
            }
          }
        },
        UpdateRuntimeConfiguration: {
          input: {
            type: "structure",
            required: [
              "FleetId",
              "RuntimeConfiguration"
            ],
            members: {
              FleetId: {},
              RuntimeConfiguration: {
                shape: "S1j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RuntimeConfiguration: {
                shape: "S1j"
              }
            }
          }
        },
        UpdateScript: {
          input: {
            type: "structure",
            required: [
              "ScriptId"
            ],
            members: {
              ScriptId: {},
              Name: {},
              Version: {},
              StorageLocation: {
                shape: "Sz"
              },
              ZipFile: {
                type: "blob"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Script: {
                shape: "S4t"
              }
            }
          }
        },
        ValidateMatchmakingRuleSet: {
          input: {
            type: "structure",
            required: [
              "RuleSetBody"
            ],
            members: {
              RuleSetBody: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Valid: {
                type: "boolean"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        Sc: {
          type: "structure",
          members: {
            GameServerGroupName: {},
            GameServerGroupArn: {},
            GameServerId: {},
            InstanceId: {},
            ConnectionInfo: {},
            GameServerData: {},
            ClaimStatus: {},
            UtilizationStatus: {},
            RegistrationTime: {
              type: "timestamp"
            },
            LastClaimTime: {
              type: "timestamp"
            },
            LastHealthCheckTime: {
              type: "timestamp"
            }
          }
        },
        Sm: {
          type: "structure",
          members: {
            Type: {},
            FleetId: {},
            Message: {}
          }
        },
        Sq: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sv: {
          type: "structure",
          members: {
            AliasId: {},
            Name: {},
            AliasArn: {},
            Description: {},
            RoutingStrategy: {
              shape: "Sm"
            },
            CreationTime: {
              type: "timestamp"
            },
            LastUpdatedTime: {
              type: "timestamp"
            }
          }
        },
        Sz: {
          type: "structure",
          members: {
            Bucket: {},
            Key: {},
            RoleArn: {},
            ObjectVersion: {}
          }
        },
        S13: {
          type: "structure",
          members: {
            BuildId: {},
            BuildArn: {},
            Name: {},
            Version: {},
            Status: {},
            SizeOnDisk: {
              type: "long"
            },
            OperatingSystem: {},
            CreationTime: {
              type: "timestamp"
            }
          }
        },
        S18: {
          type: "structure",
          members: {
            AccessKeyId: {},
            SecretAccessKey: {},
            SessionToken: {}
          },
          sensitive: true
        },
        S1d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "FromPort",
              "ToPort",
              "IpRange",
              "Protocol"
            ],
            members: {
              FromPort: {
                type: "integer"
              },
              ToPort: {
                type: "integer"
              },
              IpRange: {},
              Protocol: {}
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            ServerProcesses: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "LaunchPath",
                  "ConcurrentExecutions"
                ],
                members: {
                  LaunchPath: {},
                  Parameters: {},
                  ConcurrentExecutions: {
                    type: "integer"
                  }
                }
              }
            },
            MaxConcurrentGameSessionActivations: {
              type: "integer"
            },
            GameSessionActivationTimeoutSeconds: {
              type: "integer"
            }
          }
        },
        S1p: {
          type: "structure",
          members: {
            NewGameSessionsPerCreator: {
              type: "integer"
            },
            PolicyPeriodInMinutes: {
              type: "integer"
            }
          }
        },
        S1r: {
          type: "list",
          member: {}
        },
        S1u: {
          type: "structure",
          required: [
            "CertificateType"
          ],
          members: {
            CertificateType: {}
          }
        },
        S1w: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Location: {}
            }
          }
        },
        S20: {
          type: "structure",
          members: {
            FleetId: {},
            FleetArn: {},
            FleetType: {},
            InstanceType: {},
            Description: {},
            Name: {},
            CreationTime: {
              type: "timestamp"
            },
            TerminationTime: {
              type: "timestamp"
            },
            Status: {},
            BuildId: {},
            BuildArn: {},
            ScriptId: {},
            ScriptArn: {},
            ServerLaunchPath: {},
            ServerLaunchParameters: {},
            LogPaths: {
              shape: "S3"
            },
            NewGameSessionProtectionPolicy: {},
            OperatingSystem: {},
            ResourceCreationLimitPolicy: {
              shape: "S1p"
            },
            MetricGroups: {
              shape: "S1r"
            },
            StoppedActions: {
              shape: "S25"
            },
            InstanceRoleArn: {},
            CertificateConfiguration: {
              shape: "S1u"
            }
          }
        },
        S25: {
          type: "list",
          member: {}
        },
        S27: {
          type: "list",
          member: {
            shape: "S28"
          }
        },
        S28: {
          type: "structure",
          members: {
            Location: {},
            Status: {}
          }
        },
        S2i: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "InstanceType"
            ],
            members: {
              InstanceType: {},
              WeightedCapacity: {}
            }
          }
        },
        S2u: {
          type: "structure",
          members: {
            GameServerGroupName: {},
            GameServerGroupArn: {},
            RoleArn: {},
            InstanceDefinitions: {
              shape: "S2i"
            },
            BalancingStrategy: {},
            GameServerProtectionPolicy: {},
            AutoScalingGroupArn: {},
            Status: {},
            StatusReason: {},
            SuspendedActions: {
              shape: "S2x"
            },
            CreationTime: {
              type: "timestamp"
            },
            LastUpdatedTime: {
              type: "timestamp"
            }
          }
        },
        S2x: {
          type: "list",
          member: {}
        },
        S31: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S38: {
          type: "structure",
          members: {
            GameSessionId: {},
            Name: {},
            FleetId: {},
            FleetArn: {},
            CreationTime: {
              type: "timestamp"
            },
            TerminationTime: {
              type: "timestamp"
            },
            CurrentPlayerSessionCount: {
              type: "integer"
            },
            MaximumPlayerSessionCount: {
              type: "integer"
            },
            Status: {},
            StatusReason: {},
            GameProperties: {
              shape: "S31"
            },
            IpAddress: {},
            DnsName: {},
            Port: {
              type: "integer"
            },
            PlayerSessionCreationPolicy: {},
            CreatorId: {},
            GameSessionData: {},
            MatchmakerData: {},
            Location: {}
          }
        },
        S3h: {
          type: "list",
          member: {
            type: "structure",
            members: {
              MaximumIndividualPlayerLatencyMilliseconds: {
                type: "integer"
              },
              PolicyDurationSeconds: {
                type: "integer"
              }
            }
          }
        },
        S3j: {
          type: "list",
          member: {
            type: "structure",
            members: {
              DestinationArn: {}
            }
          }
        },
        S3m: {
          type: "structure",
          members: {
            AllowedLocations: {
              shape: "S3n"
            }
          }
        },
        S3n: {
          type: "list",
          member: {}
        },
        S3o: {
          type: "structure",
          members: {
            PriorityOrder: {
              type: "list",
              member: {}
            },
            LocationOrder: {
              shape: "S3n"
            }
          }
        },
        S3u: {
          type: "structure",
          members: {
            Name: {},
            GameSessionQueueArn: {},
            TimeoutInSeconds: {
              type: "integer"
            },
            PlayerLatencyPolicies: {
              shape: "S3h"
            },
            Destinations: {
              shape: "S3j"
            },
            FilterConfiguration: {
              shape: "S3m"
            },
            PriorityConfiguration: {
              shape: "S3o"
            },
            CustomEventData: {},
            NotificationTarget: {}
          }
        },
        S3x: {
          type: "list",
          member: {}
        },
        S48: {
          type: "structure",
          members: {
            Name: {},
            ConfigurationArn: {},
            Description: {},
            GameSessionQueueArns: {
              shape: "S3x"
            },
            RequestTimeoutSeconds: {
              type: "integer"
            },
            AcceptanceTimeoutSeconds: {
              type: "integer"
            },
            AcceptanceRequired: {
              type: "boolean"
            },
            RuleSetName: {},
            RuleSetArn: {},
            NotificationTarget: {},
            AdditionalPlayerCount: {
              type: "integer"
            },
            CustomEventData: {},
            CreationTime: {
              type: "timestamp"
            },
            GameProperties: {
              shape: "S31"
            },
            GameSessionData: {},
            BackfillMode: {},
            FlexMatchMode: {}
          }
        },
        S4e: {
          type: "structure",
          required: [
            "RuleSetBody"
          ],
          members: {
            RuleSetName: {},
            RuleSetArn: {},
            RuleSetBody: {},
            CreationTime: {
              type: "timestamp"
            }
          }
        },
        S4i: {
          type: "structure",
          members: {
            PlayerSessionId: {},
            PlayerId: {},
            GameSessionId: {},
            FleetId: {},
            FleetArn: {},
            CreationTime: {
              type: "timestamp"
            },
            TerminationTime: {
              type: "timestamp"
            },
            Status: {},
            IpAddress: {},
            DnsName: {},
            Port: {
              type: "integer"
            },
            PlayerData: {}
          }
        },
        S4p: {
          type: "list",
          member: {
            shape: "S4i"
          }
        },
        S4t: {
          type: "structure",
          members: {
            ScriptId: {},
            ScriptArn: {},
            Name: {},
            Version: {},
            SizeOnDisk: {
              type: "long"
            },
            CreationTime: {
              type: "timestamp"
            },
            StorageLocation: {
              shape: "Sz"
            }
          }
        },
        S4w: {
          type: "structure",
          members: {
            GameLiftAwsAccountId: {},
            PeerVpcAwsAccountId: {},
            PeerVpcId: {},
            CreationTime: {
              type: "timestamp"
            },
            ExpirationTime: {
              type: "timestamp"
            }
          }
        },
        S5v: {
          type: "list",
          member: {}
        },
        S61: {
          type: "structure",
          members: {
            FleetId: {},
            FleetArn: {},
            InstanceType: {},
            InstanceCounts: {
              type: "structure",
              members: {
                DESIRED: {
                  type: "integer"
                },
                MINIMUM: {
                  type: "integer"
                },
                MAXIMUM: {
                  type: "integer"
                },
                PENDING: {
                  type: "integer"
                },
                ACTIVE: {
                  type: "integer"
                },
                IDLE: {
                  type: "integer"
                },
                TERMINATING: {
                  type: "integer"
                }
              }
            },
            Location: {}
          }
        },
        S6h: {
          type: "structure",
          members: {
            FleetId: {},
            FleetArn: {},
            ActiveServerProcessCount: {
              type: "integer"
            },
            ActiveGameSessionCount: {
              type: "integer"
            },
            CurrentPlayerSessionCount: {
              type: "integer"
            },
            MaximumPlayerSessionCount: {
              type: "integer"
            },
            Location: {}
          }
        },
        S73: {
          type: "structure",
          members: {
            PlacementId: {},
            GameSessionQueueName: {},
            Status: {},
            GameProperties: {
              shape: "S31"
            },
            MaximumPlayerSessionCount: {
              type: "integer"
            },
            GameSessionName: {},
            GameSessionId: {},
            GameSessionArn: {},
            GameSessionRegion: {},
            PlayerLatencies: {
              shape: "S75"
            },
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            IpAddress: {},
            DnsName: {},
            Port: {
              type: "integer"
            },
            PlacedPlayerSessions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  PlayerId: {},
                  PlayerSessionId: {}
                }
              }
            },
            GameSessionData: {},
            MatchmakerData: {}
          }
        },
        S75: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PlayerId: {},
              RegionIdentifier: {},
              LatencyInMilliseconds: {
                type: "float"
              }
            }
          }
        },
        S7g: {
          type: "list",
          member: {
            shape: "S38"
          }
        },
        S7r: {
          type: "structure",
          members: {
            TicketId: {},
            ConfigurationName: {},
            ConfigurationArn: {},
            Status: {},
            StatusReason: {},
            StatusMessage: {},
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            Players: {
              shape: "S7u"
            },
            GameSessionConnectionInfo: {
              type: "structure",
              members: {
                GameSessionArn: {},
                IpAddress: {},
                DnsName: {},
                Port: {
                  type: "integer"
                },
                MatchedPlayerSessions: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      PlayerId: {},
                      PlayerSessionId: {}
                    }
                  }
                }
              }
            },
            EstimatedWaitTime: {
              type: "integer"
            }
          }
        },
        S7u: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PlayerId: {},
              PlayerAttributes: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    S: {},
                    N: {
                      type: "double"
                    },
                    SL: {
                      shape: "S3"
                    },
                    SDM: {
                      type: "map",
                      key: {},
                      value: {
                        type: "double"
                      }
                    }
                  }
                }
              },
              Team: {},
              LatencyInMs: {
                type: "map",
                key: {},
                value: {
                  type: "integer"
                }
              }
            }
          }
        },
        S8s: {
          type: "structure",
          required: [
            "TargetValue"
          ],
          members: {
            TargetValue: {
              type: "double"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/gamelift-2015-10-01.paginators.json
var require_gamelift_2015_10_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/gamelift-2015-10-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeFleetAttributes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "FleetAttributes"
        },
        DescribeFleetCapacity: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "FleetCapacity"
        },
        DescribeFleetEvents: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Events"
        },
        DescribeFleetLocationAttributes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit"
        },
        DescribeFleetUtilization: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "FleetUtilization"
        },
        DescribeGameServerInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "GameServerInstances"
        },
        DescribeGameSessionDetails: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "GameSessionDetails"
        },
        DescribeGameSessionQueues: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "GameSessionQueues"
        },
        DescribeGameSessions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "GameSessions"
        },
        DescribeInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Instances"
        },
        DescribeMatchmakingConfigurations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Configurations"
        },
        DescribeMatchmakingRuleSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "RuleSets"
        },
        DescribePlayerSessions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "PlayerSessions"
        },
        DescribeScalingPolicies: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "ScalingPolicies"
        },
        ListAliases: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Aliases"
        },
        ListBuilds: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Builds"
        },
        ListFleets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "FleetIds"
        },
        ListGameServerGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "GameServerGroups"
        },
        ListGameServers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "GameServers"
        },
        ListScripts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Scripts"
        },
        SearchGameSessions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "GameSessions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/gamelift.js
var require_gamelift = __commonJS({
  "node_modules/aws-sdk/clients/gamelift.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["gamelift"] = {};
    AWS3.GameLift = Service.defineService("gamelift", ["2015-10-01"]);
    Object.defineProperty(apiLoader.services["gamelift"], "2015-10-01", {
      get: function get() {
        var model = require_gamelift_2015_10_01_min();
        model.paginators = require_gamelift_2015_10_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.GameLift;
  }
});

// node_modules/aws-sdk/lib/services/glacier.js
var require_glacier = __commonJS({
  "node_modules/aws-sdk/lib/services/glacier.js"() {
    var AWS3 = require_core();
    AWS3.util.update(AWS3.Glacier.prototype, {
      setupRequestListeners: function setupRequestListeners(request) {
        if (Array.isArray(request._events.validate)) {
          request._events.validate.unshift(this.validateAccountId);
        } else {
          request.on("validate", this.validateAccountId);
        }
        request.removeListener("afterBuild", AWS3.EventListeners.Core.COMPUTE_SHA256);
        request.on("build", this.addGlacierApiVersion);
        request.on("build", this.addTreeHashHeaders);
      },
      validateAccountId: function validateAccountId(request) {
        if (request.params.accountId !== void 0)
          return;
        request.params = AWS3.util.copy(request.params);
        request.params.accountId = "-";
      },
      addGlacierApiVersion: function addGlacierApiVersion(request) {
        var version = request.service.api.apiVersion;
        request.httpRequest.headers["x-amz-glacier-version"] = version;
      },
      addTreeHashHeaders: function addTreeHashHeaders(request) {
        if (request.params.body === void 0)
          return;
        var hashes = request.service.computeChecksums(request.params.body);
        request.httpRequest.headers["X-Amz-Content-Sha256"] = hashes.linearHash;
        if (!request.httpRequest.headers["x-amz-sha256-tree-hash"]) {
          request.httpRequest.headers["x-amz-sha256-tree-hash"] = hashes.treeHash;
        }
      },
      computeChecksums: function computeChecksums(data) {
        if (!AWS3.util.Buffer.isBuffer(data))
          data = AWS3.util.buffer.toBuffer(data);
        var mb = 1024 * 1024;
        var hashes = [];
        var hash = AWS3.util.crypto.createHash("sha256");
        for (var i = 0; i < data.length; i += mb) {
          var chunk = data.slice(i, Math.min(i + mb, data.length));
          hash.update(chunk);
          hashes.push(AWS3.util.crypto.sha256(chunk));
        }
        return {
          linearHash: hash.digest("hex"),
          treeHash: this.buildHashTree(hashes)
        };
      },
      buildHashTree: function buildHashTree(hashes) {
        while (hashes.length > 1) {
          var tmpHashes = [];
          for (var i = 0; i < hashes.length; i += 2) {
            if (hashes[i + 1]) {
              var tmpHash = AWS3.util.buffer.alloc(64);
              tmpHash.write(hashes[i], 0, 32, "binary");
              tmpHash.write(hashes[i + 1], 32, 32, "binary");
              tmpHashes.push(AWS3.util.crypto.sha256(tmpHash));
            } else {
              tmpHashes.push(hashes[i]);
            }
          }
          hashes = tmpHashes;
        }
        return AWS3.util.crypto.toHex(hashes[0]);
      }
    });
  }
});

// node_modules/aws-sdk/apis/glacier-2012-06-01.min.json
var require_glacier_2012_06_01_min = __commonJS({
  "node_modules/aws-sdk/apis/glacier-2012-06-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2012-06-01",
        checksumFormat: "sha256",
        endpointPrefix: "glacier",
        protocol: "rest-json",
        serviceFullName: "Amazon Glacier",
        serviceId: "Glacier",
        signatureVersion: "v4",
        uid: "glacier-2012-06-01"
      },
      operations: {
        AbortMultipartUpload: {
          http: {
            method: "DELETE",
            requestUri: "/{accountId}/vaults/{vaultName}/multipart-uploads/{uploadId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName",
              "uploadId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              uploadId: {
                location: "uri",
                locationName: "uploadId"
              }
            }
          }
        },
        AbortVaultLock: {
          http: {
            method: "DELETE",
            requestUri: "/{accountId}/vaults/{vaultName}/lock-policy",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              }
            }
          }
        },
        AddTagsToVault: {
          http: {
            requestUri: "/{accountId}/vaults/{vaultName}/tags?operation=add",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              Tags: {
                shape: "S5"
              }
            }
          }
        },
        CompleteMultipartUpload: {
          http: {
            requestUri: "/{accountId}/vaults/{vaultName}/multipart-uploads/{uploadId}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName",
              "uploadId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              uploadId: {
                location: "uri",
                locationName: "uploadId"
              },
              archiveSize: {
                location: "header",
                locationName: "x-amz-archive-size"
              },
              checksum: {
                location: "header",
                locationName: "x-amz-sha256-tree-hash"
              }
            }
          },
          output: {
            shape: "S9"
          }
        },
        CompleteVaultLock: {
          http: {
            requestUri: "/{accountId}/vaults/{vaultName}/lock-policy/{lockId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName",
              "lockId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              lockId: {
                location: "uri",
                locationName: "lockId"
              }
            }
          }
        },
        CreateVault: {
          http: {
            method: "PUT",
            requestUri: "/{accountId}/vaults/{vaultName}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              location: {
                location: "header",
                locationName: "Location"
              }
            }
          }
        },
        DeleteArchive: {
          http: {
            method: "DELETE",
            requestUri: "/{accountId}/vaults/{vaultName}/archives/{archiveId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName",
              "archiveId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              archiveId: {
                location: "uri",
                locationName: "archiveId"
              }
            }
          }
        },
        DeleteVault: {
          http: {
            method: "DELETE",
            requestUri: "/{accountId}/vaults/{vaultName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              }
            }
          }
        },
        DeleteVaultAccessPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/{accountId}/vaults/{vaultName}/access-policy",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              }
            }
          }
        },
        DeleteVaultNotifications: {
          http: {
            method: "DELETE",
            requestUri: "/{accountId}/vaults/{vaultName}/notification-configuration",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              }
            }
          }
        },
        DescribeJob: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults/{vaultName}/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName",
              "jobId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            shape: "Si"
          }
        },
        DescribeVault: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults/{vaultName}"
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              }
            }
          },
          output: {
            shape: "S1a"
          }
        },
        GetDataRetrievalPolicy: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/policies/data-retrieval"
          },
          input: {
            type: "structure",
            required: [
              "accountId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                shape: "S1e"
              }
            }
          }
        },
        GetJobOutput: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults/{vaultName}/jobs/{jobId}/output"
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName",
              "jobId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              range: {
                location: "header",
                locationName: "Range"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              body: {
                shape: "S1k"
              },
              checksum: {
                location: "header",
                locationName: "x-amz-sha256-tree-hash"
              },
              status: {
                location: "statusCode",
                type: "integer"
              },
              contentRange: {
                location: "header",
                locationName: "Content-Range"
              },
              acceptRanges: {
                location: "header",
                locationName: "Accept-Ranges"
              },
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              archiveDescription: {
                location: "header",
                locationName: "x-amz-archive-description"
              }
            },
            payload: "body"
          }
        },
        GetVaultAccessPolicy: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults/{vaultName}/access-policy"
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policy: {
                shape: "S1o"
              }
            },
            payload: "policy"
          }
        },
        GetVaultLock: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults/{vaultName}/lock-policy"
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {},
              State: {},
              ExpirationDate: {},
              CreationDate: {}
            }
          }
        },
        GetVaultNotifications: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults/{vaultName}/notification-configuration"
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              vaultNotificationConfig: {
                shape: "S1t"
              }
            },
            payload: "vaultNotificationConfig"
          }
        },
        InitiateJob: {
          http: {
            requestUri: "/{accountId}/vaults/{vaultName}/jobs",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              jobParameters: {
                type: "structure",
                members: {
                  Format: {},
                  Type: {},
                  ArchiveId: {},
                  Description: {},
                  SNSTopic: {},
                  RetrievalByteRange: {},
                  Tier: {},
                  InventoryRetrievalParameters: {
                    type: "structure",
                    members: {
                      StartDate: {},
                      EndDate: {},
                      Limit: {},
                      Marker: {}
                    }
                  },
                  SelectParameters: {
                    shape: "Sp"
                  },
                  OutputLocation: {
                    shape: "Sx"
                  }
                }
              }
            },
            payload: "jobParameters"
          },
          output: {
            type: "structure",
            members: {
              location: {
                location: "header",
                locationName: "Location"
              },
              jobId: {
                location: "header",
                locationName: "x-amz-job-id"
              },
              jobOutputPath: {
                location: "header",
                locationName: "x-amz-job-output-path"
              }
            }
          }
        },
        InitiateMultipartUpload: {
          http: {
            requestUri: "/{accountId}/vaults/{vaultName}/multipart-uploads",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              archiveDescription: {
                location: "header",
                locationName: "x-amz-archive-description"
              },
              partSize: {
                location: "header",
                locationName: "x-amz-part-size"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              location: {
                location: "header",
                locationName: "Location"
              },
              uploadId: {
                location: "header",
                locationName: "x-amz-multipart-upload-id"
              }
            }
          }
        },
        InitiateVaultLock: {
          http: {
            requestUri: "/{accountId}/vaults/{vaultName}/lock-policy",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              policy: {
                type: "structure",
                members: {
                  Policy: {}
                }
              }
            },
            payload: "policy"
          },
          output: {
            type: "structure",
            members: {
              lockId: {
                location: "header",
                locationName: "x-amz-lock-id"
              }
            }
          }
        },
        ListJobs: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults/{vaultName}/jobs"
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              limit: {
                location: "querystring",
                locationName: "limit"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              statuscode: {
                location: "querystring",
                locationName: "statuscode"
              },
              completed: {
                location: "querystring",
                locationName: "completed"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobList: {
                type: "list",
                member: {
                  shape: "Si"
                }
              },
              Marker: {}
            }
          }
        },
        ListMultipartUploads: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults/{vaultName}/multipart-uploads"
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              limit: {
                location: "querystring",
                locationName: "limit"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UploadsList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MultipartUploadId: {},
                    VaultARN: {},
                    ArchiveDescription: {},
                    PartSizeInBytes: {
                      type: "long"
                    },
                    CreationDate: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListParts: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults/{vaultName}/multipart-uploads/{uploadId}"
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName",
              "uploadId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              uploadId: {
                location: "uri",
                locationName: "uploadId"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              limit: {
                location: "querystring",
                locationName: "limit"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MultipartUploadId: {},
              VaultARN: {},
              ArchiveDescription: {},
              PartSizeInBytes: {
                type: "long"
              },
              CreationDate: {},
              Parts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RangeInBytes: {},
                    SHA256TreeHash: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListProvisionedCapacity: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/provisioned-capacity"
          },
          input: {
            type: "structure",
            required: [
              "accountId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisionedCapacityList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CapacityId: {},
                    StartDate: {},
                    ExpirationDate: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForVault: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults/{vaultName}/tags"
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S5"
              }
            }
          }
        },
        ListVaults: {
          http: {
            method: "GET",
            requestUri: "/{accountId}/vaults"
          },
          input: {
            type: "structure",
            required: [
              "accountId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              limit: {
                location: "querystring",
                locationName: "limit"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VaultList: {
                type: "list",
                member: {
                  shape: "S1a"
                }
              },
              Marker: {}
            }
          }
        },
        PurchaseProvisionedCapacity: {
          http: {
            requestUri: "/{accountId}/provisioned-capacity",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "accountId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              capacityId: {
                location: "header",
                locationName: "x-amz-capacity-id"
              }
            }
          }
        },
        RemoveTagsFromVault: {
          http: {
            requestUri: "/{accountId}/vaults/{vaultName}/tags?operation=remove",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        SetDataRetrievalPolicy: {
          http: {
            method: "PUT",
            requestUri: "/{accountId}/policies/data-retrieval",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              Policy: {
                shape: "S1e"
              }
            }
          }
        },
        SetVaultAccessPolicy: {
          http: {
            method: "PUT",
            requestUri: "/{accountId}/vaults/{vaultName}/access-policy",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              policy: {
                shape: "S1o"
              }
            },
            payload: "policy"
          }
        },
        SetVaultNotifications: {
          http: {
            method: "PUT",
            requestUri: "/{accountId}/vaults/{vaultName}/notification-configuration",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              vaultNotificationConfig: {
                shape: "S1t"
              }
            },
            payload: "vaultNotificationConfig"
          }
        },
        UploadArchive: {
          http: {
            requestUri: "/{accountId}/vaults/{vaultName}/archives",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "vaultName",
              "accountId"
            ],
            members: {
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              archiveDescription: {
                location: "header",
                locationName: "x-amz-archive-description"
              },
              checksum: {
                location: "header",
                locationName: "x-amz-sha256-tree-hash"
              },
              body: {
                shape: "S1k"
              }
            },
            payload: "body"
          },
          output: {
            shape: "S9"
          }
        },
        UploadMultipartPart: {
          http: {
            method: "PUT",
            requestUri: "/{accountId}/vaults/{vaultName}/multipart-uploads/{uploadId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accountId",
              "vaultName",
              "uploadId"
            ],
            members: {
              accountId: {
                location: "uri",
                locationName: "accountId"
              },
              vaultName: {
                location: "uri",
                locationName: "vaultName"
              },
              uploadId: {
                location: "uri",
                locationName: "uploadId"
              },
              checksum: {
                location: "header",
                locationName: "x-amz-sha256-tree-hash"
              },
              range: {
                location: "header",
                locationName: "Content-Range"
              },
              body: {
                shape: "S1k"
              }
            },
            payload: "body"
          },
          output: {
            type: "structure",
            members: {
              checksum: {
                location: "header",
                locationName: "x-amz-sha256-tree-hash"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "map",
          key: {},
          value: {}
        },
        S9: {
          type: "structure",
          members: {
            location: {
              location: "header",
              locationName: "Location"
            },
            checksum: {
              location: "header",
              locationName: "x-amz-sha256-tree-hash"
            },
            archiveId: {
              location: "header",
              locationName: "x-amz-archive-id"
            }
          }
        },
        Si: {
          type: "structure",
          members: {
            JobId: {},
            JobDescription: {},
            Action: {},
            ArchiveId: {},
            VaultARN: {},
            CreationDate: {},
            Completed: {
              type: "boolean"
            },
            StatusCode: {},
            StatusMessage: {},
            ArchiveSizeInBytes: {
              type: "long"
            },
            InventorySizeInBytes: {
              type: "long"
            },
            SNSTopic: {},
            CompletionDate: {},
            SHA256TreeHash: {},
            ArchiveSHA256TreeHash: {},
            RetrievalByteRange: {},
            Tier: {},
            InventoryRetrievalParameters: {
              type: "structure",
              members: {
                Format: {},
                StartDate: {},
                EndDate: {},
                Limit: {},
                Marker: {}
              }
            },
            JobOutputPath: {},
            SelectParameters: {
              shape: "Sp"
            },
            OutputLocation: {
              shape: "Sx"
            }
          }
        },
        Sp: {
          type: "structure",
          members: {
            InputSerialization: {
              type: "structure",
              members: {
                csv: {
                  type: "structure",
                  members: {
                    FileHeaderInfo: {},
                    Comments: {},
                    QuoteEscapeCharacter: {},
                    RecordDelimiter: {},
                    FieldDelimiter: {},
                    QuoteCharacter: {}
                  }
                }
              }
            },
            ExpressionType: {},
            Expression: {},
            OutputSerialization: {
              type: "structure",
              members: {
                csv: {
                  type: "structure",
                  members: {
                    QuoteFields: {},
                    QuoteEscapeCharacter: {},
                    RecordDelimiter: {},
                    FieldDelimiter: {},
                    QuoteCharacter: {}
                  }
                }
              }
            }
          }
        },
        Sx: {
          type: "structure",
          members: {
            S3: {
              type: "structure",
              members: {
                BucketName: {},
                Prefix: {},
                Encryption: {
                  type: "structure",
                  members: {
                    EncryptionType: {},
                    KMSKeyId: {},
                    KMSContext: {}
                  }
                },
                CannedACL: {},
                AccessControlList: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      Grantee: {
                        type: "structure",
                        required: [
                          "Type"
                        ],
                        members: {
                          Type: {},
                          DisplayName: {},
                          URI: {},
                          ID: {},
                          EmailAddress: {}
                        }
                      },
                      Permission: {}
                    }
                  }
                },
                Tagging: {
                  shape: "S17"
                },
                UserMetadata: {
                  shape: "S17"
                },
                StorageClass: {}
              }
            }
          }
        },
        S17: {
          type: "map",
          key: {},
          value: {}
        },
        S1a: {
          type: "structure",
          members: {
            VaultARN: {},
            VaultName: {},
            CreationDate: {},
            LastInventoryDate: {},
            NumberOfArchives: {
              type: "long"
            },
            SizeInBytes: {
              type: "long"
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            Rules: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Strategy: {},
                  BytesPerHour: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S1k: {
          type: "blob",
          streaming: true
        },
        S1o: {
          type: "structure",
          members: {
            Policy: {}
          }
        },
        S1t: {
          type: "structure",
          members: {
            SNSTopic: {},
            Events: {
              type: "list",
              member: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/glacier-2012-06-01.paginators.json
var require_glacier_2012_06_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/glacier-2012-06-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListJobs: {
          input_token: "marker",
          limit_key: "limit",
          output_token: "Marker",
          result_key: "JobList"
        },
        ListMultipartUploads: {
          input_token: "marker",
          limit_key: "limit",
          output_token: "Marker",
          result_key: "UploadsList"
        },
        ListParts: {
          input_token: "marker",
          limit_key: "limit",
          output_token: "Marker",
          result_key: "Parts"
        },
        ListVaults: {
          input_token: "marker",
          limit_key: "limit",
          output_token: "Marker",
          result_key: "VaultList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/glacier-2012-06-01.waiters2.json
var require_glacier_2012_06_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/glacier-2012-06-01.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        VaultExists: {
          operation: "DescribeVault",
          delay: 3,
          maxAttempts: 15,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 200
            },
            {
              state: "retry",
              matcher: "error",
              expected: "ResourceNotFoundException"
            }
          ]
        },
        VaultNotExists: {
          operation: "DescribeVault",
          delay: 3,
          maxAttempts: 15,
          acceptors: [
            {
              state: "retry",
              matcher: "status",
              expected: 200
            },
            {
              state: "success",
              matcher: "error",
              expected: "ResourceNotFoundException"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/glacier.js
var require_glacier2 = __commonJS({
  "node_modules/aws-sdk/clients/glacier.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["glacier"] = {};
    AWS3.Glacier = Service.defineService("glacier", ["2012-06-01"]);
    require_glacier();
    Object.defineProperty(apiLoader.services["glacier"], "2012-06-01", {
      get: function get() {
        var model = require_glacier_2012_06_01_min();
        model.paginators = require_glacier_2012_06_01_paginators().pagination;
        model.waiters = require_glacier_2012_06_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Glacier;
  }
});

// node_modules/aws-sdk/apis/health-2016-08-04.min.json
var require_health_2016_08_04_min = __commonJS({
  "node_modules/aws-sdk/apis/health-2016-08-04.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-08-04",
        endpointPrefix: "health",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "AWSHealth",
        serviceFullName: "AWS Health APIs and Notifications",
        serviceId: "Health",
        signatureVersion: "v4",
        targetPrefix: "AWSHealth_20160804",
        uid: "health-2016-08-04"
      },
      operations: {
        DescribeAffectedAccountsForOrganization: {
          input: {
            type: "structure",
            required: [
              "eventArn"
            ],
            members: {
              eventArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              affectedAccounts: {
                type: "list",
                member: {}
              },
              eventScopeCode: {},
              nextToken: {}
            }
          },
          idempotent: true
        },
        DescribeAffectedEntities: {
          input: {
            type: "structure",
            required: [
              "filter"
            ],
            members: {
              filter: {
                type: "structure",
                required: [
                  "eventArns"
                ],
                members: {
                  eventArns: {
                    shape: "Sb"
                  },
                  entityArns: {
                    shape: "Sc"
                  },
                  entityValues: {
                    shape: "Se"
                  },
                  lastUpdatedTimes: {
                    shape: "Sg"
                  },
                  tags: {
                    shape: "Sj"
                  },
                  statusCodes: {
                    type: "list",
                    member: {}
                  }
                }
              },
              locale: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              entities: {
                shape: "Sr"
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        DescribeAffectedEntitiesForOrganization: {
          input: {
            type: "structure",
            required: [
              "organizationEntityFilters"
            ],
            members: {
              organizationEntityFilters: {
                type: "list",
                member: {
                  shape: "Sw"
                }
              },
              locale: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              entities: {
                shape: "Sr"
              },
              failedSet: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    awsAccountId: {},
                    eventArn: {},
                    errorName: {},
                    errorMessage: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        DescribeEntityAggregates: {
          input: {
            type: "structure",
            members: {
              eventArns: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              entityAggregates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    eventArn: {},
                    count: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeEventAggregates: {
          input: {
            type: "structure",
            required: [
              "aggregateField"
            ],
            members: {
              filter: {
                shape: "S19"
              },
              aggregateField: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              eventAggregates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    aggregateValue: {},
                    count: {
                      type: "integer"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        DescribeEventDetails: {
          input: {
            type: "structure",
            required: [
              "eventArns"
            ],
            members: {
              eventArns: {
                shape: "Sb"
              },
              locale: {}
            }
          },
          output: {
            type: "structure",
            members: {
              successfulSet: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    event: {
                      shape: "S1v"
                    },
                    eventDescription: {
                      shape: "S1x"
                    },
                    eventMetadata: {
                      shape: "S1z"
                    }
                  }
                }
              },
              failedSet: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    eventArn: {},
                    errorName: {},
                    errorMessage: {}
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeEventDetailsForOrganization: {
          input: {
            type: "structure",
            required: [
              "organizationEventDetailFilters"
            ],
            members: {
              organizationEventDetailFilters: {
                type: "list",
                member: {
                  shape: "Sw"
                }
              },
              locale: {}
            }
          },
          output: {
            type: "structure",
            members: {
              successfulSet: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    awsAccountId: {},
                    event: {
                      shape: "S1v"
                    },
                    eventDescription: {
                      shape: "S1x"
                    },
                    eventMetadata: {
                      shape: "S1z"
                    }
                  }
                }
              },
              failedSet: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    awsAccountId: {},
                    eventArn: {},
                    errorName: {},
                    errorMessage: {}
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeEventTypes: {
          input: {
            type: "structure",
            members: {
              filter: {
                type: "structure",
                members: {
                  eventTypeCodes: {
                    type: "list",
                    member: {}
                  },
                  services: {
                    shape: "S1c"
                  },
                  eventTypeCategories: {
                    type: "list",
                    member: {}
                  }
                }
              },
              locale: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              eventTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    service: {},
                    code: {},
                    category: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              filter: {
                shape: "S19"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              locale: {}
            }
          },
          output: {
            type: "structure",
            members: {
              events: {
                type: "list",
                member: {
                  shape: "S1v"
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        DescribeEventsForOrganization: {
          input: {
            type: "structure",
            members: {
              filter: {
                type: "structure",
                members: {
                  eventTypeCodes: {
                    shape: "S1a"
                  },
                  awsAccountIds: {
                    type: "list",
                    member: {}
                  },
                  services: {
                    shape: "S1c"
                  },
                  regions: {
                    shape: "S1e"
                  },
                  startTime: {
                    shape: "Sh"
                  },
                  endTime: {
                    shape: "Sh"
                  },
                  lastUpdatedTime: {
                    shape: "Sh"
                  },
                  entityArns: {
                    shape: "Sc"
                  },
                  entityValues: {
                    shape: "Se"
                  },
                  eventTypeCategories: {
                    shape: "S1i"
                  },
                  eventStatusCodes: {
                    shape: "S1k"
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              locale: {}
            }
          },
          output: {
            type: "structure",
            members: {
              events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    service: {},
                    eventTypeCode: {},
                    eventTypeCategory: {},
                    eventScopeCode: {},
                    region: {},
                    startTime: {
                      type: "timestamp"
                    },
                    endTime: {
                      type: "timestamp"
                    },
                    lastUpdatedTime: {
                      type: "timestamp"
                    },
                    statusCode: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        DescribeHealthServiceStatusForOrganization: {
          output: {
            type: "structure",
            members: {
              healthServiceAccessStatusForOrganization: {}
            }
          },
          idempotent: true
        },
        DisableHealthServiceAccessForOrganization: {
          idempotent: true
        },
        EnableHealthServiceAccessForOrganization: {
          idempotent: true
        }
      },
      shapes: {
        Sb: {
          type: "list",
          member: {}
        },
        Sc: {
          type: "list",
          member: {}
        },
        Se: {
          type: "list",
          member: {}
        },
        Sg: {
          type: "list",
          member: {
            shape: "Sh"
          }
        },
        Sh: {
          type: "structure",
          members: {
            from: {
              type: "timestamp"
            },
            to: {
              type: "timestamp"
            }
          }
        },
        Sj: {
          type: "list",
          member: {
            shape: "Sk"
          }
        },
        Sk: {
          type: "map",
          key: {},
          value: {}
        },
        Sr: {
          type: "list",
          member: {
            type: "structure",
            members: {
              entityArn: {},
              eventArn: {},
              entityValue: {},
              entityUrl: {},
              awsAccountId: {},
              lastUpdatedTime: {
                type: "timestamp"
              },
              statusCode: {},
              tags: {
                shape: "Sk"
              }
            }
          }
        },
        Sw: {
          type: "structure",
          required: [
            "eventArn"
          ],
          members: {
            eventArn: {},
            awsAccountId: {}
          }
        },
        S19: {
          type: "structure",
          members: {
            eventArns: {
              shape: "Sb"
            },
            eventTypeCodes: {
              shape: "S1a"
            },
            services: {
              shape: "S1c"
            },
            regions: {
              shape: "S1e"
            },
            availabilityZones: {
              type: "list",
              member: {}
            },
            startTimes: {
              shape: "Sg"
            },
            endTimes: {
              shape: "Sg"
            },
            lastUpdatedTimes: {
              shape: "Sg"
            },
            entityArns: {
              shape: "Sc"
            },
            entityValues: {
              shape: "Se"
            },
            eventTypeCategories: {
              shape: "S1i"
            },
            tags: {
              shape: "Sj"
            },
            eventStatusCodes: {
              shape: "S1k"
            }
          }
        },
        S1a: {
          type: "list",
          member: {}
        },
        S1c: {
          type: "list",
          member: {}
        },
        S1e: {
          type: "list",
          member: {}
        },
        S1i: {
          type: "list",
          member: {}
        },
        S1k: {
          type: "list",
          member: {}
        },
        S1v: {
          type: "structure",
          members: {
            arn: {},
            service: {},
            eventTypeCode: {},
            eventTypeCategory: {},
            region: {},
            availabilityZone: {},
            startTime: {
              type: "timestamp"
            },
            endTime: {
              type: "timestamp"
            },
            lastUpdatedTime: {
              type: "timestamp"
            },
            statusCode: {},
            eventScopeCode: {}
          }
        },
        S1x: {
          type: "structure",
          members: {
            latestDescription: {}
          }
        },
        S1z: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/health-2016-08-04.paginators.json
var require_health_2016_08_04_paginators = __commonJS({
  "node_modules/aws-sdk/apis/health-2016-08-04.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeAffectedAccountsForOrganization: {
          input_token: "nextToken",
          limit_key: "maxResults",
          non_aggregate_keys: [
            "eventScopeCode"
          ],
          output_token: "nextToken",
          result_key: "affectedAccounts"
        },
        DescribeAffectedEntities: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "entities"
        },
        DescribeAffectedEntitiesForOrganization: {
          input_token: "nextToken",
          limit_key: "maxResults",
          non_aggregate_keys: [
            "failedSet"
          ],
          output_token: "nextToken",
          result_key: "entities"
        },
        DescribeEntityAggregates: {
          result_key: "entityAggregates"
        },
        DescribeEventAggregates: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "eventAggregates"
        },
        DescribeEventTypes: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "eventTypes"
        },
        DescribeEvents: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "events"
        },
        DescribeEventsForOrganization: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "events"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/health.js
var require_health = __commonJS({
  "node_modules/aws-sdk/clients/health.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["health"] = {};
    AWS3.Health = Service.defineService("health", ["2016-08-04"]);
    Object.defineProperty(apiLoader.services["health"], "2016-08-04", {
      get: function get() {
        var model = require_health_2016_08_04_min();
        model.paginators = require_health_2016_08_04_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Health;
  }
});

// node_modules/aws-sdk/apis/iam-2010-05-08.min.json
var require_iam_2010_05_08_min = __commonJS({
  "node_modules/aws-sdk/apis/iam-2010-05-08.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2010-05-08",
        endpointPrefix: "iam",
        globalEndpoint: "iam.amazonaws.com",
        protocol: "query",
        serviceAbbreviation: "IAM",
        serviceFullName: "AWS Identity and Access Management",
        serviceId: "IAM",
        signatureVersion: "v4",
        uid: "iam-2010-05-08",
        xmlNamespace: "https://iam.amazonaws.com/doc/2010-05-08/"
      },
      operations: {
        AddClientIDToOpenIDConnectProvider: {
          input: {
            type: "structure",
            required: [
              "OpenIDConnectProviderArn",
              "ClientID"
            ],
            members: {
              OpenIDConnectProviderArn: {},
              ClientID: {}
            }
          }
        },
        AddRoleToInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "InstanceProfileName",
              "RoleName"
            ],
            members: {
              InstanceProfileName: {},
              RoleName: {}
            }
          }
        },
        AddUserToGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "UserName"
            ],
            members: {
              GroupName: {},
              UserName: {}
            }
          }
        },
        AttachGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "PolicyArn"
            ],
            members: {
              GroupName: {},
              PolicyArn: {}
            }
          }
        },
        AttachRolePolicy: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "PolicyArn"
            ],
            members: {
              RoleName: {},
              PolicyArn: {}
            }
          }
        },
        AttachUserPolicy: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "PolicyArn"
            ],
            members: {
              UserName: {},
              PolicyArn: {}
            }
          }
        },
        ChangePassword: {
          input: {
            type: "structure",
            required: [
              "OldPassword",
              "NewPassword"
            ],
            members: {
              OldPassword: {
                shape: "Sf"
              },
              NewPassword: {
                shape: "Sf"
              }
            }
          }
        },
        CreateAccessKey: {
          input: {
            type: "structure",
            members: {
              UserName: {}
            }
          },
          output: {
            resultWrapper: "CreateAccessKeyResult",
            type: "structure",
            required: [
              "AccessKey"
            ],
            members: {
              AccessKey: {
                type: "structure",
                required: [
                  "UserName",
                  "AccessKeyId",
                  "Status",
                  "SecretAccessKey"
                ],
                members: {
                  UserName: {},
                  AccessKeyId: {},
                  Status: {},
                  SecretAccessKey: {
                    type: "string",
                    sensitive: true
                  },
                  CreateDate: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        CreateAccountAlias: {
          input: {
            type: "structure",
            required: [
              "AccountAlias"
            ],
            members: {
              AccountAlias: {}
            }
          }
        },
        CreateGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName"
            ],
            members: {
              Path: {},
              GroupName: {}
            }
          },
          output: {
            resultWrapper: "CreateGroupResult",
            type: "structure",
            required: [
              "Group"
            ],
            members: {
              Group: {
                shape: "Ss"
              }
            }
          }
        },
        CreateInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "InstanceProfileName"
            ],
            members: {
              InstanceProfileName: {},
              Path: {},
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "CreateInstanceProfileResult",
            type: "structure",
            required: [
              "InstanceProfile"
            ],
            members: {
              InstanceProfile: {
                shape: "S10"
              }
            }
          }
        },
        CreateLoginProfile: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "Password"
            ],
            members: {
              UserName: {},
              Password: {
                shape: "Sf"
              },
              PasswordResetRequired: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateLoginProfileResult",
            type: "structure",
            required: [
              "LoginProfile"
            ],
            members: {
              LoginProfile: {
                shape: "S1d"
              }
            }
          }
        },
        CreateOpenIDConnectProvider: {
          input: {
            type: "structure",
            required: [
              "Url",
              "ThumbprintList"
            ],
            members: {
              Url: {},
              ClientIDList: {
                shape: "S1g"
              },
              ThumbprintList: {
                shape: "S1h"
              },
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "CreateOpenIDConnectProviderResult",
            type: "structure",
            members: {
              OpenIDConnectProviderArn: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        CreatePolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyName",
              "PolicyDocument"
            ],
            members: {
              PolicyName: {},
              Path: {},
              PolicyDocument: {},
              Description: {},
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "CreatePolicyResult",
            type: "structure",
            members: {
              Policy: {
                shape: "S1p"
              }
            }
          }
        },
        CreatePolicyVersion: {
          input: {
            type: "structure",
            required: [
              "PolicyArn",
              "PolicyDocument"
            ],
            members: {
              PolicyArn: {},
              PolicyDocument: {},
              SetAsDefault: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreatePolicyVersionResult",
            type: "structure",
            members: {
              PolicyVersion: {
                shape: "S1u"
              }
            }
          }
        },
        CreateRole: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "AssumeRolePolicyDocument"
            ],
            members: {
              Path: {},
              RoleName: {},
              AssumeRolePolicyDocument: {},
              Description: {},
              MaxSessionDuration: {
                type: "integer"
              },
              PermissionsBoundary: {},
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "CreateRoleResult",
            type: "structure",
            required: [
              "Role"
            ],
            members: {
              Role: {
                shape: "S12"
              }
            }
          }
        },
        CreateSAMLProvider: {
          input: {
            type: "structure",
            required: [
              "SAMLMetadataDocument",
              "Name"
            ],
            members: {
              SAMLMetadataDocument: {},
              Name: {},
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "CreateSAMLProviderResult",
            type: "structure",
            members: {
              SAMLProviderArn: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        CreateServiceLinkedRole: {
          input: {
            type: "structure",
            required: [
              "AWSServiceName"
            ],
            members: {
              AWSServiceName: {},
              Description: {},
              CustomSuffix: {}
            }
          },
          output: {
            resultWrapper: "CreateServiceLinkedRoleResult",
            type: "structure",
            members: {
              Role: {
                shape: "S12"
              }
            }
          }
        },
        CreateServiceSpecificCredential: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "ServiceName"
            ],
            members: {
              UserName: {},
              ServiceName: {}
            }
          },
          output: {
            resultWrapper: "CreateServiceSpecificCredentialResult",
            type: "structure",
            members: {
              ServiceSpecificCredential: {
                shape: "S27"
              }
            }
          }
        },
        CreateUser: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              Path: {},
              UserName: {},
              PermissionsBoundary: {},
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "CreateUserResult",
            type: "structure",
            members: {
              User: {
                shape: "S2d"
              }
            }
          }
        },
        CreateVirtualMFADevice: {
          input: {
            type: "structure",
            required: [
              "VirtualMFADeviceName"
            ],
            members: {
              Path: {},
              VirtualMFADeviceName: {},
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "CreateVirtualMFADeviceResult",
            type: "structure",
            required: [
              "VirtualMFADevice"
            ],
            members: {
              VirtualMFADevice: {
                shape: "S2h"
              }
            }
          }
        },
        DeactivateMFADevice: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "SerialNumber"
            ],
            members: {
              UserName: {},
              SerialNumber: {}
            }
          }
        },
        DeleteAccessKey: {
          input: {
            type: "structure",
            required: [
              "AccessKeyId"
            ],
            members: {
              UserName: {},
              AccessKeyId: {}
            }
          }
        },
        DeleteAccountAlias: {
          input: {
            type: "structure",
            required: [
              "AccountAlias"
            ],
            members: {
              AccountAlias: {}
            }
          }
        },
        DeleteAccountPasswordPolicy: {},
        DeleteGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName"
            ],
            members: {
              GroupName: {}
            }
          }
        },
        DeleteGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "PolicyName"
            ],
            members: {
              GroupName: {},
              PolicyName: {}
            }
          }
        },
        DeleteInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "InstanceProfileName"
            ],
            members: {
              InstanceProfileName: {}
            }
          }
        },
        DeleteLoginProfile: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {}
            }
          }
        },
        DeleteOpenIDConnectProvider: {
          input: {
            type: "structure",
            required: [
              "OpenIDConnectProviderArn"
            ],
            members: {
              OpenIDConnectProviderArn: {}
            }
          }
        },
        DeletePolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyArn"
            ],
            members: {
              PolicyArn: {}
            }
          }
        },
        DeletePolicyVersion: {
          input: {
            type: "structure",
            required: [
              "PolicyArn",
              "VersionId"
            ],
            members: {
              PolicyArn: {},
              VersionId: {}
            }
          }
        },
        DeleteRole: {
          input: {
            type: "structure",
            required: [
              "RoleName"
            ],
            members: {
              RoleName: {}
            }
          }
        },
        DeleteRolePermissionsBoundary: {
          input: {
            type: "structure",
            required: [
              "RoleName"
            ],
            members: {
              RoleName: {}
            }
          }
        },
        DeleteRolePolicy: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "PolicyName"
            ],
            members: {
              RoleName: {},
              PolicyName: {}
            }
          }
        },
        DeleteSAMLProvider: {
          input: {
            type: "structure",
            required: [
              "SAMLProviderArn"
            ],
            members: {
              SAMLProviderArn: {}
            }
          }
        },
        DeleteSSHPublicKey: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "SSHPublicKeyId"
            ],
            members: {
              UserName: {},
              SSHPublicKeyId: {}
            }
          }
        },
        DeleteServerCertificate: {
          input: {
            type: "structure",
            required: [
              "ServerCertificateName"
            ],
            members: {
              ServerCertificateName: {}
            }
          }
        },
        DeleteServiceLinkedRole: {
          input: {
            type: "structure",
            required: [
              "RoleName"
            ],
            members: {
              RoleName: {}
            }
          },
          output: {
            resultWrapper: "DeleteServiceLinkedRoleResult",
            type: "structure",
            required: [
              "DeletionTaskId"
            ],
            members: {
              DeletionTaskId: {}
            }
          }
        },
        DeleteServiceSpecificCredential: {
          input: {
            type: "structure",
            required: [
              "ServiceSpecificCredentialId"
            ],
            members: {
              UserName: {},
              ServiceSpecificCredentialId: {}
            }
          }
        },
        DeleteSigningCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateId"
            ],
            members: {
              UserName: {},
              CertificateId: {}
            }
          }
        },
        DeleteUser: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {}
            }
          }
        },
        DeleteUserPermissionsBoundary: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {}
            }
          }
        },
        DeleteUserPolicy: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "PolicyName"
            ],
            members: {
              UserName: {},
              PolicyName: {}
            }
          }
        },
        DeleteVirtualMFADevice: {
          input: {
            type: "structure",
            required: [
              "SerialNumber"
            ],
            members: {
              SerialNumber: {}
            }
          }
        },
        DetachGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "PolicyArn"
            ],
            members: {
              GroupName: {},
              PolicyArn: {}
            }
          }
        },
        DetachRolePolicy: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "PolicyArn"
            ],
            members: {
              RoleName: {},
              PolicyArn: {}
            }
          }
        },
        DetachUserPolicy: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "PolicyArn"
            ],
            members: {
              UserName: {},
              PolicyArn: {}
            }
          }
        },
        EnableMFADevice: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "SerialNumber",
              "AuthenticationCode1",
              "AuthenticationCode2"
            ],
            members: {
              UserName: {},
              SerialNumber: {},
              AuthenticationCode1: {},
              AuthenticationCode2: {}
            }
          }
        },
        GenerateCredentialReport: {
          output: {
            resultWrapper: "GenerateCredentialReportResult",
            type: "structure",
            members: {
              State: {},
              Description: {}
            }
          }
        },
        GenerateOrganizationsAccessReport: {
          input: {
            type: "structure",
            required: [
              "EntityPath"
            ],
            members: {
              EntityPath: {},
              OrganizationsPolicyId: {}
            }
          },
          output: {
            resultWrapper: "GenerateOrganizationsAccessReportResult",
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        GenerateServiceLastAccessedDetails: {
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {},
              Granularity: {}
            }
          },
          output: {
            resultWrapper: "GenerateServiceLastAccessedDetailsResult",
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        GetAccessKeyLastUsed: {
          input: {
            type: "structure",
            required: [
              "AccessKeyId"
            ],
            members: {
              AccessKeyId: {}
            }
          },
          output: {
            resultWrapper: "GetAccessKeyLastUsedResult",
            type: "structure",
            members: {
              UserName: {},
              AccessKeyLastUsed: {
                type: "structure",
                required: [
                  "LastUsedDate",
                  "ServiceName",
                  "Region"
                ],
                members: {
                  LastUsedDate: {
                    type: "timestamp"
                  },
                  ServiceName: {},
                  Region: {}
                }
              }
            }
          }
        },
        GetAccountAuthorizationDetails: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "list",
                member: {}
              },
              MaxItems: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "GetAccountAuthorizationDetailsResult",
            type: "structure",
            members: {
              UserDetailList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Path: {},
                    UserName: {},
                    UserId: {},
                    Arn: {},
                    CreateDate: {
                      type: "timestamp"
                    },
                    UserPolicyList: {
                      shape: "S43"
                    },
                    GroupList: {
                      type: "list",
                      member: {}
                    },
                    AttachedManagedPolicies: {
                      shape: "S46"
                    },
                    PermissionsBoundary: {
                      shape: "S16"
                    },
                    Tags: {
                      shape: "Sv"
                    }
                  }
                }
              },
              GroupDetailList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Path: {},
                    GroupName: {},
                    GroupId: {},
                    Arn: {},
                    CreateDate: {
                      type: "timestamp"
                    },
                    GroupPolicyList: {
                      shape: "S43"
                    },
                    AttachedManagedPolicies: {
                      shape: "S46"
                    }
                  }
                }
              },
              RoleDetailList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Path: {},
                    RoleName: {},
                    RoleId: {},
                    Arn: {},
                    CreateDate: {
                      type: "timestamp"
                    },
                    AssumeRolePolicyDocument: {},
                    InstanceProfileList: {
                      shape: "S4c"
                    },
                    RolePolicyList: {
                      shape: "S43"
                    },
                    AttachedManagedPolicies: {
                      shape: "S46"
                    },
                    PermissionsBoundary: {
                      shape: "S16"
                    },
                    Tags: {
                      shape: "Sv"
                    },
                    RoleLastUsed: {
                      shape: "S18"
                    }
                  }
                }
              },
              Policies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PolicyName: {},
                    PolicyId: {},
                    Arn: {},
                    Path: {},
                    DefaultVersionId: {},
                    AttachmentCount: {
                      type: "integer"
                    },
                    PermissionsBoundaryUsageCount: {
                      type: "integer"
                    },
                    IsAttachable: {
                      type: "boolean"
                    },
                    Description: {},
                    CreateDate: {
                      type: "timestamp"
                    },
                    UpdateDate: {
                      type: "timestamp"
                    },
                    PolicyVersionList: {
                      shape: "S4f"
                    }
                  }
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        GetAccountPasswordPolicy: {
          output: {
            resultWrapper: "GetAccountPasswordPolicyResult",
            type: "structure",
            required: [
              "PasswordPolicy"
            ],
            members: {
              PasswordPolicy: {
                type: "structure",
                members: {
                  MinimumPasswordLength: {
                    type: "integer"
                  },
                  RequireSymbols: {
                    type: "boolean"
                  },
                  RequireNumbers: {
                    type: "boolean"
                  },
                  RequireUppercaseCharacters: {
                    type: "boolean"
                  },
                  RequireLowercaseCharacters: {
                    type: "boolean"
                  },
                  AllowUsersToChangePassword: {
                    type: "boolean"
                  },
                  ExpirePasswords: {
                    type: "boolean"
                  },
                  MaxPasswordAge: {
                    type: "integer"
                  },
                  PasswordReusePrevention: {
                    type: "integer"
                  },
                  HardExpiry: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        GetAccountSummary: {
          output: {
            resultWrapper: "GetAccountSummaryResult",
            type: "structure",
            members: {
              SummaryMap: {
                type: "map",
                key: {},
                value: {
                  type: "integer"
                }
              }
            }
          }
        },
        GetContextKeysForCustomPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyInputList"
            ],
            members: {
              PolicyInputList: {
                shape: "S4s"
              }
            }
          },
          output: {
            shape: "S4t",
            resultWrapper: "GetContextKeysForCustomPolicyResult"
          }
        },
        GetContextKeysForPrincipalPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicySourceArn"
            ],
            members: {
              PolicySourceArn: {},
              PolicyInputList: {
                shape: "S4s"
              }
            }
          },
          output: {
            shape: "S4t",
            resultWrapper: "GetContextKeysForPrincipalPolicyResult"
          }
        },
        GetCredentialReport: {
          output: {
            resultWrapper: "GetCredentialReportResult",
            type: "structure",
            members: {
              Content: {
                type: "blob"
              },
              ReportFormat: {},
              GeneratedTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName"
            ],
            members: {
              GroupName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "GetGroupResult",
            type: "structure",
            required: [
              "Group",
              "Users"
            ],
            members: {
              Group: {
                shape: "Ss"
              },
              Users: {
                shape: "S52"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        GetGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "PolicyName"
            ],
            members: {
              GroupName: {},
              PolicyName: {}
            }
          },
          output: {
            resultWrapper: "GetGroupPolicyResult",
            type: "structure",
            required: [
              "GroupName",
              "PolicyName",
              "PolicyDocument"
            ],
            members: {
              GroupName: {},
              PolicyName: {},
              PolicyDocument: {}
            }
          }
        },
        GetInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "InstanceProfileName"
            ],
            members: {
              InstanceProfileName: {}
            }
          },
          output: {
            resultWrapper: "GetInstanceProfileResult",
            type: "structure",
            required: [
              "InstanceProfile"
            ],
            members: {
              InstanceProfile: {
                shape: "S10"
              }
            }
          }
        },
        GetLoginProfile: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {}
            }
          },
          output: {
            resultWrapper: "GetLoginProfileResult",
            type: "structure",
            required: [
              "LoginProfile"
            ],
            members: {
              LoginProfile: {
                shape: "S1d"
              }
            }
          }
        },
        GetOpenIDConnectProvider: {
          input: {
            type: "structure",
            required: [
              "OpenIDConnectProviderArn"
            ],
            members: {
              OpenIDConnectProviderArn: {}
            }
          },
          output: {
            resultWrapper: "GetOpenIDConnectProviderResult",
            type: "structure",
            members: {
              Url: {},
              ClientIDList: {
                shape: "S1g"
              },
              ThumbprintList: {
                shape: "S1h"
              },
              CreateDate: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        GetOrganizationsAccessReport: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxItems: {
                type: "integer"
              },
              Marker: {},
              SortKey: {}
            }
          },
          output: {
            resultWrapper: "GetOrganizationsAccessReportResult",
            type: "structure",
            required: [
              "JobStatus",
              "JobCreationDate"
            ],
            members: {
              JobStatus: {},
              JobCreationDate: {
                type: "timestamp"
              },
              JobCompletionDate: {
                type: "timestamp"
              },
              NumberOfServicesAccessible: {
                type: "integer"
              },
              NumberOfServicesNotAccessed: {
                type: "integer"
              },
              AccessDetails: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ServiceName",
                    "ServiceNamespace"
                  ],
                  members: {
                    ServiceName: {},
                    ServiceNamespace: {},
                    Region: {},
                    EntityPath: {},
                    LastAuthenticatedTime: {
                      type: "timestamp"
                    },
                    TotalAuthenticatedEntities: {
                      type: "integer"
                    }
                  }
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {},
              ErrorDetails: {
                shape: "S5k"
              }
            }
          }
        },
        GetPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyArn"
            ],
            members: {
              PolicyArn: {}
            }
          },
          output: {
            resultWrapper: "GetPolicyResult",
            type: "structure",
            members: {
              Policy: {
                shape: "S1p"
              }
            }
          }
        },
        GetPolicyVersion: {
          input: {
            type: "structure",
            required: [
              "PolicyArn",
              "VersionId"
            ],
            members: {
              PolicyArn: {},
              VersionId: {}
            }
          },
          output: {
            resultWrapper: "GetPolicyVersionResult",
            type: "structure",
            members: {
              PolicyVersion: {
                shape: "S1u"
              }
            }
          }
        },
        GetRole: {
          input: {
            type: "structure",
            required: [
              "RoleName"
            ],
            members: {
              RoleName: {}
            }
          },
          output: {
            resultWrapper: "GetRoleResult",
            type: "structure",
            required: [
              "Role"
            ],
            members: {
              Role: {
                shape: "S12"
              }
            }
          }
        },
        GetRolePolicy: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "PolicyName"
            ],
            members: {
              RoleName: {},
              PolicyName: {}
            }
          },
          output: {
            resultWrapper: "GetRolePolicyResult",
            type: "structure",
            required: [
              "RoleName",
              "PolicyName",
              "PolicyDocument"
            ],
            members: {
              RoleName: {},
              PolicyName: {},
              PolicyDocument: {}
            }
          }
        },
        GetSAMLProvider: {
          input: {
            type: "structure",
            required: [
              "SAMLProviderArn"
            ],
            members: {
              SAMLProviderArn: {}
            }
          },
          output: {
            resultWrapper: "GetSAMLProviderResult",
            type: "structure",
            members: {
              SAMLMetadataDocument: {},
              CreateDate: {
                type: "timestamp"
              },
              ValidUntil: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        GetSSHPublicKey: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "SSHPublicKeyId",
              "Encoding"
            ],
            members: {
              UserName: {},
              SSHPublicKeyId: {},
              Encoding: {}
            }
          },
          output: {
            resultWrapper: "GetSSHPublicKeyResult",
            type: "structure",
            members: {
              SSHPublicKey: {
                shape: "S5y"
              }
            }
          }
        },
        GetServerCertificate: {
          input: {
            type: "structure",
            required: [
              "ServerCertificateName"
            ],
            members: {
              ServerCertificateName: {}
            }
          },
          output: {
            resultWrapper: "GetServerCertificateResult",
            type: "structure",
            required: [
              "ServerCertificate"
            ],
            members: {
              ServerCertificate: {
                type: "structure",
                required: [
                  "ServerCertificateMetadata",
                  "CertificateBody"
                ],
                members: {
                  ServerCertificateMetadata: {
                    shape: "S64"
                  },
                  CertificateBody: {},
                  CertificateChain: {},
                  Tags: {
                    shape: "Sv"
                  }
                }
              }
            }
          }
        },
        GetServiceLastAccessedDetails: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxItems: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "GetServiceLastAccessedDetailsResult",
            type: "structure",
            required: [
              "JobStatus",
              "JobCreationDate",
              "ServicesLastAccessed",
              "JobCompletionDate"
            ],
            members: {
              JobStatus: {},
              JobType: {},
              JobCreationDate: {
                type: "timestamp"
              },
              ServicesLastAccessed: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ServiceName",
                    "ServiceNamespace"
                  ],
                  members: {
                    ServiceName: {},
                    LastAuthenticated: {
                      type: "timestamp"
                    },
                    ServiceNamespace: {},
                    LastAuthenticatedEntity: {},
                    LastAuthenticatedRegion: {},
                    TotalAuthenticatedEntities: {
                      type: "integer"
                    },
                    TrackedActionsLastAccessed: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ActionName: {},
                          LastAccessedEntity: {},
                          LastAccessedTime: {
                            type: "timestamp"
                          },
                          LastAccessedRegion: {}
                        }
                      }
                    }
                  }
                }
              },
              JobCompletionDate: {
                type: "timestamp"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {},
              Error: {
                shape: "S5k"
              }
            }
          }
        },
        GetServiceLastAccessedDetailsWithEntities: {
          input: {
            type: "structure",
            required: [
              "JobId",
              "ServiceNamespace"
            ],
            members: {
              JobId: {},
              ServiceNamespace: {},
              MaxItems: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "GetServiceLastAccessedDetailsWithEntitiesResult",
            type: "structure",
            required: [
              "JobStatus",
              "JobCreationDate",
              "JobCompletionDate",
              "EntityDetailsList"
            ],
            members: {
              JobStatus: {},
              JobCreationDate: {
                type: "timestamp"
              },
              JobCompletionDate: {
                type: "timestamp"
              },
              EntityDetailsList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "EntityInfo"
                  ],
                  members: {
                    EntityInfo: {
                      type: "structure",
                      required: [
                        "Arn",
                        "Name",
                        "Type",
                        "Id"
                      ],
                      members: {
                        Arn: {},
                        Name: {},
                        Type: {},
                        Id: {},
                        Path: {}
                      }
                    },
                    LastAuthenticated: {
                      type: "timestamp"
                    }
                  }
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {},
              Error: {
                shape: "S5k"
              }
            }
          }
        },
        GetServiceLinkedRoleDeletionStatus: {
          input: {
            type: "structure",
            required: [
              "DeletionTaskId"
            ],
            members: {
              DeletionTaskId: {}
            }
          },
          output: {
            resultWrapper: "GetServiceLinkedRoleDeletionStatusResult",
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Status: {},
              Reason: {
                type: "structure",
                members: {
                  Reason: {},
                  RoleUsageList: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Region: {},
                        Resources: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetUser: {
          input: {
            type: "structure",
            members: {
              UserName: {}
            }
          },
          output: {
            resultWrapper: "GetUserResult",
            type: "structure",
            required: [
              "User"
            ],
            members: {
              User: {
                shape: "S2d"
              }
            }
          }
        },
        GetUserPolicy: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "PolicyName"
            ],
            members: {
              UserName: {},
              PolicyName: {}
            }
          },
          output: {
            resultWrapper: "GetUserPolicyResult",
            type: "structure",
            required: [
              "UserName",
              "PolicyName",
              "PolicyDocument"
            ],
            members: {
              UserName: {},
              PolicyName: {},
              PolicyDocument: {}
            }
          }
        },
        ListAccessKeys: {
          input: {
            type: "structure",
            members: {
              UserName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListAccessKeysResult",
            type: "structure",
            required: [
              "AccessKeyMetadata"
            ],
            members: {
              AccessKeyMetadata: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UserName: {},
                    AccessKeyId: {},
                    Status: {},
                    CreateDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListAccountAliases: {
          input: {
            type: "structure",
            members: {
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListAccountAliasesResult",
            type: "structure",
            required: [
              "AccountAliases"
            ],
            members: {
              AccountAliases: {
                type: "list",
                member: {}
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListAttachedGroupPolicies: {
          input: {
            type: "structure",
            required: [
              "GroupName"
            ],
            members: {
              GroupName: {},
              PathPrefix: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListAttachedGroupPoliciesResult",
            type: "structure",
            members: {
              AttachedPolicies: {
                shape: "S46"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListAttachedRolePolicies: {
          input: {
            type: "structure",
            required: [
              "RoleName"
            ],
            members: {
              RoleName: {},
              PathPrefix: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListAttachedRolePoliciesResult",
            type: "structure",
            members: {
              AttachedPolicies: {
                shape: "S46"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListAttachedUserPolicies: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {},
              PathPrefix: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListAttachedUserPoliciesResult",
            type: "structure",
            members: {
              AttachedPolicies: {
                shape: "S46"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListEntitiesForPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyArn"
            ],
            members: {
              PolicyArn: {},
              EntityFilter: {},
              PathPrefix: {},
              PolicyUsageFilter: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListEntitiesForPolicyResult",
            type: "structure",
            members: {
              PolicyGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GroupName: {},
                    GroupId: {}
                  }
                }
              },
              PolicyUsers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UserName: {},
                    UserId: {}
                  }
                }
              },
              PolicyRoles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RoleName: {},
                    RoleId: {}
                  }
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListGroupPolicies: {
          input: {
            type: "structure",
            required: [
              "GroupName"
            ],
            members: {
              GroupName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListGroupPoliciesResult",
            type: "structure",
            required: [
              "PolicyNames"
            ],
            members: {
              PolicyNames: {
                shape: "S7k"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListGroups: {
          input: {
            type: "structure",
            members: {
              PathPrefix: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListGroupsResult",
            type: "structure",
            required: [
              "Groups"
            ],
            members: {
              Groups: {
                shape: "S7o"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListGroupsForUser: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListGroupsForUserResult",
            type: "structure",
            required: [
              "Groups"
            ],
            members: {
              Groups: {
                shape: "S7o"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListInstanceProfileTags: {
          input: {
            type: "structure",
            required: [
              "InstanceProfileName"
            ],
            members: {
              InstanceProfileName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListInstanceProfileTagsResult",
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Sv"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListInstanceProfiles: {
          input: {
            type: "structure",
            members: {
              PathPrefix: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListInstanceProfilesResult",
            type: "structure",
            required: [
              "InstanceProfiles"
            ],
            members: {
              InstanceProfiles: {
                shape: "S4c"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListInstanceProfilesForRole: {
          input: {
            type: "structure",
            required: [
              "RoleName"
            ],
            members: {
              RoleName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListInstanceProfilesForRoleResult",
            type: "structure",
            required: [
              "InstanceProfiles"
            ],
            members: {
              InstanceProfiles: {
                shape: "S4c"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListMFADeviceTags: {
          input: {
            type: "structure",
            required: [
              "SerialNumber"
            ],
            members: {
              SerialNumber: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListMFADeviceTagsResult",
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Sv"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListMFADevices: {
          input: {
            type: "structure",
            members: {
              UserName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListMFADevicesResult",
            type: "structure",
            required: [
              "MFADevices"
            ],
            members: {
              MFADevices: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "UserName",
                    "SerialNumber",
                    "EnableDate"
                  ],
                  members: {
                    UserName: {},
                    SerialNumber: {},
                    EnableDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListOpenIDConnectProviderTags: {
          input: {
            type: "structure",
            required: [
              "OpenIDConnectProviderArn"
            ],
            members: {
              OpenIDConnectProviderArn: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListOpenIDConnectProviderTagsResult",
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Sv"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListOpenIDConnectProviders: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            resultWrapper: "ListOpenIDConnectProvidersResult",
            type: "structure",
            members: {
              OpenIDConnectProviderList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {}
                  }
                }
              }
            }
          }
        },
        ListPolicies: {
          input: {
            type: "structure",
            members: {
              Scope: {},
              OnlyAttached: {
                type: "boolean"
              },
              PathPrefix: {},
              PolicyUsageFilter: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListPoliciesResult",
            type: "structure",
            members: {
              Policies: {
                type: "list",
                member: {
                  shape: "S1p"
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListPoliciesGrantingServiceAccess: {
          input: {
            type: "structure",
            required: [
              "Arn",
              "ServiceNamespaces"
            ],
            members: {
              Marker: {},
              Arn: {},
              ServiceNamespaces: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "ListPoliciesGrantingServiceAccessResult",
            type: "structure",
            required: [
              "PoliciesGrantingServiceAccess"
            ],
            members: {
              PoliciesGrantingServiceAccess: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ServiceNamespace: {},
                    Policies: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "PolicyName",
                          "PolicyType"
                        ],
                        members: {
                          PolicyName: {},
                          PolicyType: {},
                          PolicyArn: {},
                          EntityType: {},
                          EntityName: {}
                        }
                      }
                    }
                  }
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListPolicyTags: {
          input: {
            type: "structure",
            required: [
              "PolicyArn"
            ],
            members: {
              PolicyArn: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListPolicyTagsResult",
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Sv"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListPolicyVersions: {
          input: {
            type: "structure",
            required: [
              "PolicyArn"
            ],
            members: {
              PolicyArn: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListPolicyVersionsResult",
            type: "structure",
            members: {
              Versions: {
                shape: "S4f"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListRolePolicies: {
          input: {
            type: "structure",
            required: [
              "RoleName"
            ],
            members: {
              RoleName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListRolePoliciesResult",
            type: "structure",
            required: [
              "PolicyNames"
            ],
            members: {
              PolicyNames: {
                shape: "S7k"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListRoleTags: {
          input: {
            type: "structure",
            required: [
              "RoleName"
            ],
            members: {
              RoleName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListRoleTagsResult",
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Sv"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListRoles: {
          input: {
            type: "structure",
            members: {
              PathPrefix: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListRolesResult",
            type: "structure",
            required: [
              "Roles"
            ],
            members: {
              Roles: {
                shape: "S11"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListSAMLProviderTags: {
          input: {
            type: "structure",
            required: [
              "SAMLProviderArn"
            ],
            members: {
              SAMLProviderArn: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListSAMLProviderTagsResult",
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Sv"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListSAMLProviders: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            resultWrapper: "ListSAMLProvidersResult",
            type: "structure",
            members: {
              SAMLProviderList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    ValidUntil: {
                      type: "timestamp"
                    },
                    CreateDate: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListSSHPublicKeys: {
          input: {
            type: "structure",
            members: {
              UserName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListSSHPublicKeysResult",
            type: "structure",
            members: {
              SSHPublicKeys: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "UserName",
                    "SSHPublicKeyId",
                    "Status",
                    "UploadDate"
                  ],
                  members: {
                    UserName: {},
                    SSHPublicKeyId: {},
                    Status: {},
                    UploadDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListServerCertificateTags: {
          input: {
            type: "structure",
            required: [
              "ServerCertificateName"
            ],
            members: {
              ServerCertificateName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListServerCertificateTagsResult",
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Sv"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListServerCertificates: {
          input: {
            type: "structure",
            members: {
              PathPrefix: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListServerCertificatesResult",
            type: "structure",
            required: [
              "ServerCertificateMetadataList"
            ],
            members: {
              ServerCertificateMetadataList: {
                type: "list",
                member: {
                  shape: "S64"
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListServiceSpecificCredentials: {
          input: {
            type: "structure",
            members: {
              UserName: {},
              ServiceName: {}
            }
          },
          output: {
            resultWrapper: "ListServiceSpecificCredentialsResult",
            type: "structure",
            members: {
              ServiceSpecificCredentials: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "UserName",
                    "Status",
                    "ServiceUserName",
                    "CreateDate",
                    "ServiceSpecificCredentialId",
                    "ServiceName"
                  ],
                  members: {
                    UserName: {},
                    Status: {},
                    ServiceUserName: {},
                    CreateDate: {
                      type: "timestamp"
                    },
                    ServiceSpecificCredentialId: {},
                    ServiceName: {}
                  }
                }
              }
            }
          }
        },
        ListSigningCertificates: {
          input: {
            type: "structure",
            members: {
              UserName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListSigningCertificatesResult",
            type: "structure",
            required: [
              "Certificates"
            ],
            members: {
              Certificates: {
                type: "list",
                member: {
                  shape: "S9i"
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListUserPolicies: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListUserPoliciesResult",
            type: "structure",
            required: [
              "PolicyNames"
            ],
            members: {
              PolicyNames: {
                shape: "S7k"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListUserTags: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListUserTagsResult",
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Sv"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListUsers: {
          input: {
            type: "structure",
            members: {
              PathPrefix: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListUsersResult",
            type: "structure",
            required: [
              "Users"
            ],
            members: {
              Users: {
                shape: "S52"
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        ListVirtualMFADevices: {
          input: {
            type: "structure",
            members: {
              AssignmentStatus: {},
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListVirtualMFADevicesResult",
            type: "structure",
            required: [
              "VirtualMFADevices"
            ],
            members: {
              VirtualMFADevices: {
                type: "list",
                member: {
                  shape: "S2h"
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              Marker: {}
            }
          }
        },
        PutGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "PolicyName",
              "PolicyDocument"
            ],
            members: {
              GroupName: {},
              PolicyName: {},
              PolicyDocument: {}
            }
          }
        },
        PutRolePermissionsBoundary: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "PermissionsBoundary"
            ],
            members: {
              RoleName: {},
              PermissionsBoundary: {}
            }
          }
        },
        PutRolePolicy: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "PolicyName",
              "PolicyDocument"
            ],
            members: {
              RoleName: {},
              PolicyName: {},
              PolicyDocument: {}
            }
          }
        },
        PutUserPermissionsBoundary: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "PermissionsBoundary"
            ],
            members: {
              UserName: {},
              PermissionsBoundary: {}
            }
          }
        },
        PutUserPolicy: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "PolicyName",
              "PolicyDocument"
            ],
            members: {
              UserName: {},
              PolicyName: {},
              PolicyDocument: {}
            }
          }
        },
        RemoveClientIDFromOpenIDConnectProvider: {
          input: {
            type: "structure",
            required: [
              "OpenIDConnectProviderArn",
              "ClientID"
            ],
            members: {
              OpenIDConnectProviderArn: {},
              ClientID: {}
            }
          }
        },
        RemoveRoleFromInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "InstanceProfileName",
              "RoleName"
            ],
            members: {
              InstanceProfileName: {},
              RoleName: {}
            }
          }
        },
        RemoveUserFromGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName",
              "UserName"
            ],
            members: {
              GroupName: {},
              UserName: {}
            }
          }
        },
        ResetServiceSpecificCredential: {
          input: {
            type: "structure",
            required: [
              "ServiceSpecificCredentialId"
            ],
            members: {
              UserName: {},
              ServiceSpecificCredentialId: {}
            }
          },
          output: {
            resultWrapper: "ResetServiceSpecificCredentialResult",
            type: "structure",
            members: {
              ServiceSpecificCredential: {
                shape: "S27"
              }
            }
          }
        },
        ResyncMFADevice: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "SerialNumber",
              "AuthenticationCode1",
              "AuthenticationCode2"
            ],
            members: {
              UserName: {},
              SerialNumber: {},
              AuthenticationCode1: {},
              AuthenticationCode2: {}
            }
          }
        },
        SetDefaultPolicyVersion: {
          input: {
            type: "structure",
            required: [
              "PolicyArn",
              "VersionId"
            ],
            members: {
              PolicyArn: {},
              VersionId: {}
            }
          }
        },
        SetSecurityTokenServicePreferences: {
          input: {
            type: "structure",
            required: [
              "GlobalEndpointTokenVersion"
            ],
            members: {
              GlobalEndpointTokenVersion: {}
            }
          }
        },
        SimulateCustomPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyInputList",
              "ActionNames"
            ],
            members: {
              PolicyInputList: {
                shape: "S4s"
              },
              PermissionsBoundaryPolicyInputList: {
                shape: "S4s"
              },
              ActionNames: {
                shape: "Sa8"
              },
              ResourceArns: {
                shape: "Saa"
              },
              ResourcePolicy: {},
              ResourceOwner: {},
              CallerArn: {},
              ContextEntries: {
                shape: "Sac"
              },
              ResourceHandlingOption: {},
              MaxItems: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            shape: "Sai",
            resultWrapper: "SimulateCustomPolicyResult"
          }
        },
        SimulatePrincipalPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicySourceArn",
              "ActionNames"
            ],
            members: {
              PolicySourceArn: {},
              PolicyInputList: {
                shape: "S4s"
              },
              PermissionsBoundaryPolicyInputList: {
                shape: "S4s"
              },
              ActionNames: {
                shape: "Sa8"
              },
              ResourceArns: {
                shape: "Saa"
              },
              ResourcePolicy: {},
              ResourceOwner: {},
              CallerArn: {},
              ContextEntries: {
                shape: "Sac"
              },
              ResourceHandlingOption: {},
              MaxItems: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            shape: "Sai",
            resultWrapper: "SimulatePrincipalPolicyResult"
          }
        },
        TagInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "InstanceProfileName",
              "Tags"
            ],
            members: {
              InstanceProfileName: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        TagMFADevice: {
          input: {
            type: "structure",
            required: [
              "SerialNumber",
              "Tags"
            ],
            members: {
              SerialNumber: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        TagOpenIDConnectProvider: {
          input: {
            type: "structure",
            required: [
              "OpenIDConnectProviderArn",
              "Tags"
            ],
            members: {
              OpenIDConnectProviderArn: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        TagPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyArn",
              "Tags"
            ],
            members: {
              PolicyArn: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        TagRole: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "Tags"
            ],
            members: {
              RoleName: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        TagSAMLProvider: {
          input: {
            type: "structure",
            required: [
              "SAMLProviderArn",
              "Tags"
            ],
            members: {
              SAMLProviderArn: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        TagServerCertificate: {
          input: {
            type: "structure",
            required: [
              "ServerCertificateName",
              "Tags"
            ],
            members: {
              ServerCertificateName: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        TagUser: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "Tags"
            ],
            members: {
              UserName: {},
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        UntagInstanceProfile: {
          input: {
            type: "structure",
            required: [
              "InstanceProfileName",
              "TagKeys"
            ],
            members: {
              InstanceProfileName: {},
              TagKeys: {
                shape: "Sb9"
              }
            }
          }
        },
        UntagMFADevice: {
          input: {
            type: "structure",
            required: [
              "SerialNumber",
              "TagKeys"
            ],
            members: {
              SerialNumber: {},
              TagKeys: {
                shape: "Sb9"
              }
            }
          }
        },
        UntagOpenIDConnectProvider: {
          input: {
            type: "structure",
            required: [
              "OpenIDConnectProviderArn",
              "TagKeys"
            ],
            members: {
              OpenIDConnectProviderArn: {},
              TagKeys: {
                shape: "Sb9"
              }
            }
          }
        },
        UntagPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyArn",
              "TagKeys"
            ],
            members: {
              PolicyArn: {},
              TagKeys: {
                shape: "Sb9"
              }
            }
          }
        },
        UntagRole: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "TagKeys"
            ],
            members: {
              RoleName: {},
              TagKeys: {
                shape: "Sb9"
              }
            }
          }
        },
        UntagSAMLProvider: {
          input: {
            type: "structure",
            required: [
              "SAMLProviderArn",
              "TagKeys"
            ],
            members: {
              SAMLProviderArn: {},
              TagKeys: {
                shape: "Sb9"
              }
            }
          }
        },
        UntagServerCertificate: {
          input: {
            type: "structure",
            required: [
              "ServerCertificateName",
              "TagKeys"
            ],
            members: {
              ServerCertificateName: {},
              TagKeys: {
                shape: "Sb9"
              }
            }
          }
        },
        UntagUser: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "TagKeys"
            ],
            members: {
              UserName: {},
              TagKeys: {
                shape: "Sb9"
              }
            }
          }
        },
        UpdateAccessKey: {
          input: {
            type: "structure",
            required: [
              "AccessKeyId",
              "Status"
            ],
            members: {
              UserName: {},
              AccessKeyId: {},
              Status: {}
            }
          }
        },
        UpdateAccountPasswordPolicy: {
          input: {
            type: "structure",
            members: {
              MinimumPasswordLength: {
                type: "integer"
              },
              RequireSymbols: {
                type: "boolean"
              },
              RequireNumbers: {
                type: "boolean"
              },
              RequireUppercaseCharacters: {
                type: "boolean"
              },
              RequireLowercaseCharacters: {
                type: "boolean"
              },
              AllowUsersToChangePassword: {
                type: "boolean"
              },
              MaxPasswordAge: {
                type: "integer"
              },
              PasswordReusePrevention: {
                type: "integer"
              },
              HardExpiry: {
                type: "boolean"
              }
            }
          }
        },
        UpdateAssumeRolePolicy: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "PolicyDocument"
            ],
            members: {
              RoleName: {},
              PolicyDocument: {}
            }
          }
        },
        UpdateGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName"
            ],
            members: {
              GroupName: {},
              NewPath: {},
              NewGroupName: {}
            }
          }
        },
        UpdateLoginProfile: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {},
              Password: {
                shape: "Sf"
              },
              PasswordResetRequired: {
                type: "boolean"
              }
            }
          }
        },
        UpdateOpenIDConnectProviderThumbprint: {
          input: {
            type: "structure",
            required: [
              "OpenIDConnectProviderArn",
              "ThumbprintList"
            ],
            members: {
              OpenIDConnectProviderArn: {},
              ThumbprintList: {
                shape: "S1h"
              }
            }
          }
        },
        UpdateRole: {
          input: {
            type: "structure",
            required: [
              "RoleName"
            ],
            members: {
              RoleName: {},
              Description: {},
              MaxSessionDuration: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "UpdateRoleResult",
            type: "structure",
            members: {}
          }
        },
        UpdateRoleDescription: {
          input: {
            type: "structure",
            required: [
              "RoleName",
              "Description"
            ],
            members: {
              RoleName: {},
              Description: {}
            }
          },
          output: {
            resultWrapper: "UpdateRoleDescriptionResult",
            type: "structure",
            members: {
              Role: {
                shape: "S12"
              }
            }
          }
        },
        UpdateSAMLProvider: {
          input: {
            type: "structure",
            required: [
              "SAMLMetadataDocument",
              "SAMLProviderArn"
            ],
            members: {
              SAMLMetadataDocument: {},
              SAMLProviderArn: {}
            }
          },
          output: {
            resultWrapper: "UpdateSAMLProviderResult",
            type: "structure",
            members: {
              SAMLProviderArn: {}
            }
          }
        },
        UpdateSSHPublicKey: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "SSHPublicKeyId",
              "Status"
            ],
            members: {
              UserName: {},
              SSHPublicKeyId: {},
              Status: {}
            }
          }
        },
        UpdateServerCertificate: {
          input: {
            type: "structure",
            required: [
              "ServerCertificateName"
            ],
            members: {
              ServerCertificateName: {},
              NewPath: {},
              NewServerCertificateName: {}
            }
          }
        },
        UpdateServiceSpecificCredential: {
          input: {
            type: "structure",
            required: [
              "ServiceSpecificCredentialId",
              "Status"
            ],
            members: {
              UserName: {},
              ServiceSpecificCredentialId: {},
              Status: {}
            }
          }
        },
        UpdateSigningCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateId",
              "Status"
            ],
            members: {
              UserName: {},
              CertificateId: {},
              Status: {}
            }
          }
        },
        UpdateUser: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {},
              NewPath: {},
              NewUserName: {}
            }
          }
        },
        UploadSSHPublicKey: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "SSHPublicKeyBody"
            ],
            members: {
              UserName: {},
              SSHPublicKeyBody: {}
            }
          },
          output: {
            resultWrapper: "UploadSSHPublicKeyResult",
            type: "structure",
            members: {
              SSHPublicKey: {
                shape: "S5y"
              }
            }
          }
        },
        UploadServerCertificate: {
          input: {
            type: "structure",
            required: [
              "ServerCertificateName",
              "CertificateBody",
              "PrivateKey"
            ],
            members: {
              Path: {},
              ServerCertificateName: {},
              CertificateBody: {},
              PrivateKey: {
                type: "string",
                sensitive: true
              },
              CertificateChain: {},
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "UploadServerCertificateResult",
            type: "structure",
            members: {
              ServerCertificateMetadata: {
                shape: "S64"
              },
              Tags: {
                shape: "Sv"
              }
            }
          }
        },
        UploadSigningCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateBody"
            ],
            members: {
              UserName: {},
              CertificateBody: {}
            }
          },
          output: {
            resultWrapper: "UploadSigningCertificateResult",
            type: "structure",
            required: [
              "Certificate"
            ],
            members: {
              Certificate: {
                shape: "S9i"
              }
            }
          }
        }
      },
      shapes: {
        Sf: {
          type: "string",
          sensitive: true
        },
        Ss: {
          type: "structure",
          required: [
            "Path",
            "GroupName",
            "GroupId",
            "Arn",
            "CreateDate"
          ],
          members: {
            Path: {},
            GroupName: {},
            GroupId: {},
            Arn: {},
            CreateDate: {
              type: "timestamp"
            }
          }
        },
        Sv: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S10: {
          type: "structure",
          required: [
            "Path",
            "InstanceProfileName",
            "InstanceProfileId",
            "Arn",
            "CreateDate",
            "Roles"
          ],
          members: {
            Path: {},
            InstanceProfileName: {},
            InstanceProfileId: {},
            Arn: {},
            CreateDate: {
              type: "timestamp"
            },
            Roles: {
              shape: "S11"
            },
            Tags: {
              shape: "Sv"
            }
          }
        },
        S11: {
          type: "list",
          member: {
            shape: "S12"
          }
        },
        S12: {
          type: "structure",
          required: [
            "Path",
            "RoleName",
            "RoleId",
            "Arn",
            "CreateDate"
          ],
          members: {
            Path: {},
            RoleName: {},
            RoleId: {},
            Arn: {},
            CreateDate: {
              type: "timestamp"
            },
            AssumeRolePolicyDocument: {},
            Description: {},
            MaxSessionDuration: {
              type: "integer"
            },
            PermissionsBoundary: {
              shape: "S16"
            },
            Tags: {
              shape: "Sv"
            },
            RoleLastUsed: {
              shape: "S18"
            }
          }
        },
        S16: {
          type: "structure",
          members: {
            PermissionsBoundaryType: {},
            PermissionsBoundaryArn: {}
          }
        },
        S18: {
          type: "structure",
          members: {
            LastUsedDate: {
              type: "timestamp"
            },
            Region: {}
          }
        },
        S1d: {
          type: "structure",
          required: [
            "UserName",
            "CreateDate"
          ],
          members: {
            UserName: {},
            CreateDate: {
              type: "timestamp"
            },
            PasswordResetRequired: {
              type: "boolean"
            }
          }
        },
        S1g: {
          type: "list",
          member: {}
        },
        S1h: {
          type: "list",
          member: {}
        },
        S1p: {
          type: "structure",
          members: {
            PolicyName: {},
            PolicyId: {},
            Arn: {},
            Path: {},
            DefaultVersionId: {},
            AttachmentCount: {
              type: "integer"
            },
            PermissionsBoundaryUsageCount: {
              type: "integer"
            },
            IsAttachable: {
              type: "boolean"
            },
            Description: {},
            CreateDate: {
              type: "timestamp"
            },
            UpdateDate: {
              type: "timestamp"
            },
            Tags: {
              shape: "Sv"
            }
          }
        },
        S1u: {
          type: "structure",
          members: {
            Document: {},
            VersionId: {},
            IsDefaultVersion: {
              type: "boolean"
            },
            CreateDate: {
              type: "timestamp"
            }
          }
        },
        S27: {
          type: "structure",
          required: [
            "CreateDate",
            "ServiceName",
            "ServiceUserName",
            "ServicePassword",
            "ServiceSpecificCredentialId",
            "UserName",
            "Status"
          ],
          members: {
            CreateDate: {
              type: "timestamp"
            },
            ServiceName: {},
            ServiceUserName: {},
            ServicePassword: {
              type: "string",
              sensitive: true
            },
            ServiceSpecificCredentialId: {},
            UserName: {},
            Status: {}
          }
        },
        S2d: {
          type: "structure",
          required: [
            "Path",
            "UserName",
            "UserId",
            "Arn",
            "CreateDate"
          ],
          members: {
            Path: {},
            UserName: {},
            UserId: {},
            Arn: {},
            CreateDate: {
              type: "timestamp"
            },
            PasswordLastUsed: {
              type: "timestamp"
            },
            PermissionsBoundary: {
              shape: "S16"
            },
            Tags: {
              shape: "Sv"
            }
          }
        },
        S2h: {
          type: "structure",
          required: [
            "SerialNumber"
          ],
          members: {
            SerialNumber: {},
            Base32StringSeed: {
              shape: "S2j"
            },
            QRCodePNG: {
              shape: "S2j"
            },
            User: {
              shape: "S2d"
            },
            EnableDate: {
              type: "timestamp"
            },
            Tags: {
              shape: "Sv"
            }
          }
        },
        S2j: {
          type: "blob",
          sensitive: true
        },
        S43: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PolicyName: {},
              PolicyDocument: {}
            }
          }
        },
        S46: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PolicyName: {},
              PolicyArn: {}
            }
          }
        },
        S4c: {
          type: "list",
          member: {
            shape: "S10"
          }
        },
        S4f: {
          type: "list",
          member: {
            shape: "S1u"
          }
        },
        S4s: {
          type: "list",
          member: {}
        },
        S4t: {
          type: "structure",
          members: {
            ContextKeyNames: {
              shape: "S4u"
            }
          }
        },
        S4u: {
          type: "list",
          member: {}
        },
        S52: {
          type: "list",
          member: {
            shape: "S2d"
          }
        },
        S5k: {
          type: "structure",
          required: [
            "Message",
            "Code"
          ],
          members: {
            Message: {},
            Code: {}
          }
        },
        S5y: {
          type: "structure",
          required: [
            "UserName",
            "SSHPublicKeyId",
            "Fingerprint",
            "SSHPublicKeyBody",
            "Status"
          ],
          members: {
            UserName: {},
            SSHPublicKeyId: {},
            Fingerprint: {},
            SSHPublicKeyBody: {},
            Status: {},
            UploadDate: {
              type: "timestamp"
            }
          }
        },
        S64: {
          type: "structure",
          required: [
            "Path",
            "ServerCertificateName",
            "ServerCertificateId",
            "Arn"
          ],
          members: {
            Path: {},
            ServerCertificateName: {},
            ServerCertificateId: {},
            Arn: {},
            UploadDate: {
              type: "timestamp"
            },
            Expiration: {
              type: "timestamp"
            }
          }
        },
        S7k: {
          type: "list",
          member: {}
        },
        S7o: {
          type: "list",
          member: {
            shape: "Ss"
          }
        },
        S9i: {
          type: "structure",
          required: [
            "UserName",
            "CertificateId",
            "CertificateBody",
            "Status"
          ],
          members: {
            UserName: {},
            CertificateId: {},
            CertificateBody: {},
            Status: {},
            UploadDate: {
              type: "timestamp"
            }
          }
        },
        Sa8: {
          type: "list",
          member: {}
        },
        Saa: {
          type: "list",
          member: {}
        },
        Sac: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ContextKeyName: {},
              ContextKeyValues: {
                type: "list",
                member: {}
              },
              ContextKeyType: {}
            }
          }
        },
        Sai: {
          type: "structure",
          members: {
            EvaluationResults: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "EvalActionName",
                  "EvalDecision"
                ],
                members: {
                  EvalActionName: {},
                  EvalResourceName: {},
                  EvalDecision: {},
                  MatchedStatements: {
                    shape: "Sam"
                  },
                  MissingContextValues: {
                    shape: "S4u"
                  },
                  OrganizationsDecisionDetail: {
                    type: "structure",
                    members: {
                      AllowedByOrganizations: {
                        type: "boolean"
                      }
                    }
                  },
                  PermissionsBoundaryDecisionDetail: {
                    shape: "Sau"
                  },
                  EvalDecisionDetails: {
                    shape: "Sav"
                  },
                  ResourceSpecificResults: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "EvalResourceName",
                        "EvalResourceDecision"
                      ],
                      members: {
                        EvalResourceName: {},
                        EvalResourceDecision: {},
                        MatchedStatements: {
                          shape: "Sam"
                        },
                        MissingContextValues: {
                          shape: "S4u"
                        },
                        EvalDecisionDetails: {
                          shape: "Sav"
                        },
                        PermissionsBoundaryDecisionDetail: {
                          shape: "Sau"
                        }
                      }
                    }
                  }
                }
              }
            },
            IsTruncated: {
              type: "boolean"
            },
            Marker: {}
          }
        },
        Sam: {
          type: "list",
          member: {
            type: "structure",
            members: {
              SourcePolicyId: {},
              SourcePolicyType: {},
              StartPosition: {
                shape: "Saq"
              },
              EndPosition: {
                shape: "Saq"
              }
            }
          }
        },
        Saq: {
          type: "structure",
          members: {
            Line: {
              type: "integer"
            },
            Column: {
              type: "integer"
            }
          }
        },
        Sau: {
          type: "structure",
          members: {
            AllowedByPermissionsBoundary: {
              type: "boolean"
            }
          }
        },
        Sav: {
          type: "map",
          key: {},
          value: {}
        },
        Sb9: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iam-2010-05-08.paginators.json
var require_iam_2010_05_08_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iam-2010-05-08.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetAccountAuthorizationDetails: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: [
            "UserDetailList",
            "GroupDetailList",
            "RoleDetailList",
            "Policies"
          ]
        },
        GetGroup: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Users"
        },
        ListAccessKeys: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "AccessKeyMetadata"
        },
        ListAccountAliases: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "AccountAliases"
        },
        ListAttachedGroupPolicies: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "AttachedPolicies"
        },
        ListAttachedRolePolicies: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "AttachedPolicies"
        },
        ListAttachedUserPolicies: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "AttachedPolicies"
        },
        ListEntitiesForPolicy: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: [
            "PolicyGroups",
            "PolicyUsers",
            "PolicyRoles"
          ]
        },
        ListGroupPolicies: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "PolicyNames"
        },
        ListGroups: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Groups"
        },
        ListGroupsForUser: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Groups"
        },
        ListInstanceProfiles: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "InstanceProfiles"
        },
        ListInstanceProfilesForRole: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "InstanceProfiles"
        },
        ListMFADevices: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "MFADevices"
        },
        ListPolicies: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Policies"
        },
        ListPolicyVersions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Versions"
        },
        ListRolePolicies: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "PolicyNames"
        },
        ListRoles: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Roles"
        },
        ListSAMLProviders: {
          result_key: "SAMLProviderList"
        },
        ListSSHPublicKeys: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "SSHPublicKeys"
        },
        ListServerCertificates: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "ServerCertificateMetadataList"
        },
        ListSigningCertificates: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Certificates"
        },
        ListUserPolicies: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "PolicyNames"
        },
        ListUserTags: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Tags"
        },
        ListUsers: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "Users"
        },
        ListVirtualMFADevices: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "VirtualMFADevices"
        },
        SimulateCustomPolicy: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "EvaluationResults"
        },
        SimulatePrincipalPolicy: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "Marker",
          result_key: "EvaluationResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iam-2010-05-08.waiters2.json
var require_iam_2010_05_08_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/iam-2010-05-08.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        InstanceProfileExists: {
          delay: 1,
          operation: "GetInstanceProfile",
          maxAttempts: 40,
          acceptors: [
            {
              expected: 200,
              matcher: "status",
              state: "success"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 404
            }
          ]
        },
        UserExists: {
          delay: 1,
          operation: "GetUser",
          maxAttempts: 20,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 200
            },
            {
              state: "retry",
              matcher: "error",
              expected: "NoSuchEntity"
            }
          ]
        },
        RoleExists: {
          delay: 1,
          operation: "GetRole",
          maxAttempts: 20,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 200
            },
            {
              state: "retry",
              matcher: "error",
              expected: "NoSuchEntity"
            }
          ]
        },
        PolicyExists: {
          delay: 1,
          operation: "GetPolicy",
          maxAttempts: 20,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 200
            },
            {
              state: "retry",
              matcher: "error",
              expected: "NoSuchEntity"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iam.js
var require_iam = __commonJS({
  "node_modules/aws-sdk/clients/iam.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["iam"] = {};
    AWS3.IAM = Service.defineService("iam", ["2010-05-08"]);
    Object.defineProperty(apiLoader.services["iam"], "2010-05-08", {
      get: function get() {
        var model = require_iam_2010_05_08_min();
        model.paginators = require_iam_2010_05_08_paginators().pagination;
        model.waiters = require_iam_2010_05_08_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.IAM;
  }
});

// node_modules/aws-sdk/apis/importexport-2010-06-01.min.json
var require_importexport_2010_06_01_min = __commonJS({
  "node_modules/aws-sdk/apis/importexport-2010-06-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        uid: "importexport-2010-06-01",
        apiVersion: "2010-06-01",
        endpointPrefix: "importexport",
        globalEndpoint: "importexport.amazonaws.com",
        serviceFullName: "AWS Import/Export",
        serviceId: "ImportExport",
        signatureVersion: "v2",
        xmlNamespace: "http://importexport.amazonaws.com/doc/2010-06-01/",
        protocol: "query"
      },
      operations: {
        CancelJob: {
          http: {
            requestUri: "/?Operation=CancelJob"
          },
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              APIVersion: {}
            }
          },
          output: {
            resultWrapper: "CancelJobResult",
            type: "structure",
            members: {
              Success: {
                type: "boolean"
              }
            }
          }
        },
        CreateJob: {
          http: {
            requestUri: "/?Operation=CreateJob"
          },
          input: {
            type: "structure",
            required: [
              "JobType",
              "Manifest",
              "ValidateOnly"
            ],
            members: {
              JobType: {},
              Manifest: {},
              ManifestAddendum: {},
              ValidateOnly: {
                type: "boolean"
              },
              APIVersion: {}
            }
          },
          output: {
            resultWrapper: "CreateJobResult",
            type: "structure",
            members: {
              JobId: {},
              JobType: {},
              Signature: {},
              SignatureFileContents: {},
              WarningMessage: {},
              ArtifactList: {
                shape: "Sf"
              }
            }
          }
        },
        GetShippingLabel: {
          http: {
            requestUri: "/?Operation=GetShippingLabel"
          },
          input: {
            type: "structure",
            required: [
              "jobIds"
            ],
            members: {
              jobIds: {
                type: "list",
                member: {}
              },
              name: {},
              company: {},
              phoneNumber: {},
              country: {},
              stateOrProvince: {},
              city: {},
              postalCode: {},
              street1: {},
              street2: {},
              street3: {},
              APIVersion: {}
            }
          },
          output: {
            resultWrapper: "GetShippingLabelResult",
            type: "structure",
            members: {
              ShippingLabelURL: {},
              Warning: {}
            }
          }
        },
        GetStatus: {
          http: {
            requestUri: "/?Operation=GetStatus"
          },
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              APIVersion: {}
            }
          },
          output: {
            resultWrapper: "GetStatusResult",
            type: "structure",
            members: {
              JobId: {},
              JobType: {},
              LocationCode: {},
              LocationMessage: {},
              ProgressCode: {},
              ProgressMessage: {},
              Carrier: {},
              TrackingNumber: {},
              LogBucket: {},
              LogKey: {},
              ErrorCount: {
                type: "integer"
              },
              Signature: {},
              SignatureFileContents: {},
              CurrentManifest: {},
              CreationDate: {
                type: "timestamp"
              },
              ArtifactList: {
                shape: "Sf"
              }
            }
          }
        },
        ListJobs: {
          http: {
            requestUri: "/?Operation=ListJobs"
          },
          input: {
            type: "structure",
            members: {
              MaxJobs: {
                type: "integer"
              },
              Marker: {},
              APIVersion: {}
            }
          },
          output: {
            resultWrapper: "ListJobsResult",
            type: "structure",
            members: {
              Jobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    JobId: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    IsCanceled: {
                      type: "boolean"
                    },
                    JobType: {}
                  }
                }
              },
              IsTruncated: {
                type: "boolean"
              }
            }
          }
        },
        UpdateJob: {
          http: {
            requestUri: "/?Operation=UpdateJob"
          },
          input: {
            type: "structure",
            required: [
              "JobId",
              "Manifest",
              "JobType",
              "ValidateOnly"
            ],
            members: {
              JobId: {},
              Manifest: {},
              JobType: {},
              ValidateOnly: {
                type: "boolean"
              },
              APIVersion: {}
            }
          },
          output: {
            resultWrapper: "UpdateJobResult",
            type: "structure",
            members: {
              Success: {
                type: "boolean"
              },
              WarningMessage: {},
              ArtifactList: {
                shape: "Sf"
              }
            }
          }
        }
      },
      shapes: {
        Sf: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Description: {},
              URL: {}
            }
          }
        }
      },
      examples: {}
    };
  }
});

// node_modules/aws-sdk/apis/importexport-2010-06-01.paginators.json
var require_importexport_2010_06_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/importexport-2010-06-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListJobs: {
          input_token: "Marker",
          output_token: "Jobs[-1].JobId",
          more_results: "IsTruncated",
          limit_key: "MaxJobs",
          result_key: "Jobs"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/importexport.js
var require_importexport = __commonJS({
  "node_modules/aws-sdk/clients/importexport.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["importexport"] = {};
    AWS3.ImportExport = Service.defineService("importexport", ["2010-06-01"]);
    Object.defineProperty(apiLoader.services["importexport"], "2010-06-01", {
      get: function get() {
        var model = require_importexport_2010_06_01_min();
        model.paginators = require_importexport_2010_06_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ImportExport;
  }
});

// node_modules/aws-sdk/apis/inspector-2016-02-16.min.json
var require_inspector_2016_02_16_min = __commonJS({
  "node_modules/aws-sdk/apis/inspector-2016-02-16.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-02-16",
        endpointPrefix: "inspector",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Inspector",
        serviceId: "Inspector",
        signatureVersion: "v4",
        targetPrefix: "InspectorService",
        uid: "inspector-2016-02-16"
      },
      operations: {
        AddAttributesToFindings: {
          input: {
            type: "structure",
            required: [
              "findingArns",
              "attributes"
            ],
            members: {
              findingArns: {
                shape: "S2"
              },
              attributes: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "failedItems"
            ],
            members: {
              failedItems: {
                shape: "S9"
              }
            }
          }
        },
        CreateAssessmentTarget: {
          input: {
            type: "structure",
            required: [
              "assessmentTargetName"
            ],
            members: {
              assessmentTargetName: {},
              resourceGroupArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentTargetArn"
            ],
            members: {
              assessmentTargetArn: {}
            }
          }
        },
        CreateAssessmentTemplate: {
          input: {
            type: "structure",
            required: [
              "assessmentTargetArn",
              "assessmentTemplateName",
              "durationInSeconds",
              "rulesPackageArns"
            ],
            members: {
              assessmentTargetArn: {},
              assessmentTemplateName: {},
              durationInSeconds: {
                type: "integer"
              },
              rulesPackageArns: {
                shape: "Sj"
              },
              userAttributesForFindings: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentTemplateArn"
            ],
            members: {
              assessmentTemplateArn: {}
            }
          }
        },
        CreateExclusionsPreview: {
          input: {
            type: "structure",
            required: [
              "assessmentTemplateArn"
            ],
            members: {
              assessmentTemplateArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "previewToken"
            ],
            members: {
              previewToken: {}
            }
          }
        },
        CreateResourceGroup: {
          input: {
            type: "structure",
            required: [
              "resourceGroupTags"
            ],
            members: {
              resourceGroupTags: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "resourceGroupArn"
            ],
            members: {
              resourceGroupArn: {}
            }
          }
        },
        DeleteAssessmentRun: {
          input: {
            type: "structure",
            required: [
              "assessmentRunArn"
            ],
            members: {
              assessmentRunArn: {}
            }
          }
        },
        DeleteAssessmentTarget: {
          input: {
            type: "structure",
            required: [
              "assessmentTargetArn"
            ],
            members: {
              assessmentTargetArn: {}
            }
          }
        },
        DeleteAssessmentTemplate: {
          input: {
            type: "structure",
            required: [
              "assessmentTemplateArn"
            ],
            members: {
              assessmentTemplateArn: {}
            }
          }
        },
        DescribeAssessmentRuns: {
          input: {
            type: "structure",
            required: [
              "assessmentRunArns"
            ],
            members: {
              assessmentRunArns: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentRuns",
              "failedItems"
            ],
            members: {
              assessmentRuns: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "name",
                    "assessmentTemplateArn",
                    "state",
                    "durationInSeconds",
                    "rulesPackageArns",
                    "userAttributesForFindings",
                    "createdAt",
                    "stateChangedAt",
                    "dataCollected",
                    "stateChanges",
                    "notifications",
                    "findingCounts"
                  ],
                  members: {
                    arn: {},
                    name: {},
                    assessmentTemplateArn: {},
                    state: {},
                    durationInSeconds: {
                      type: "integer"
                    },
                    rulesPackageArns: {
                      type: "list",
                      member: {}
                    },
                    userAttributesForFindings: {
                      shape: "S4"
                    },
                    createdAt: {
                      type: "timestamp"
                    },
                    startedAt: {
                      type: "timestamp"
                    },
                    completedAt: {
                      type: "timestamp"
                    },
                    stateChangedAt: {
                      type: "timestamp"
                    },
                    dataCollected: {
                      type: "boolean"
                    },
                    stateChanges: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "stateChangedAt",
                          "state"
                        ],
                        members: {
                          stateChangedAt: {
                            type: "timestamp"
                          },
                          state: {}
                        }
                      }
                    },
                    notifications: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "date",
                          "event",
                          "error"
                        ],
                        members: {
                          date: {
                            type: "timestamp"
                          },
                          event: {},
                          message: {},
                          error: {
                            type: "boolean"
                          },
                          snsTopicArn: {},
                          snsPublishStatusCode: {}
                        }
                      }
                    },
                    findingCounts: {
                      type: "map",
                      key: {},
                      value: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              failedItems: {
                shape: "S9"
              }
            }
          }
        },
        DescribeAssessmentTargets: {
          input: {
            type: "structure",
            required: [
              "assessmentTargetArns"
            ],
            members: {
              assessmentTargetArns: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentTargets",
              "failedItems"
            ],
            members: {
              assessmentTargets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "name",
                    "createdAt",
                    "updatedAt"
                  ],
                  members: {
                    arn: {},
                    name: {},
                    resourceGroupArn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    updatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              failedItems: {
                shape: "S9"
              }
            }
          }
        },
        DescribeAssessmentTemplates: {
          input: {
            type: "structure",
            required: [
              "assessmentTemplateArns"
            ],
            members: {
              assessmentTemplateArns: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentTemplates",
              "failedItems"
            ],
            members: {
              assessmentTemplates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "name",
                    "assessmentTargetArn",
                    "durationInSeconds",
                    "rulesPackageArns",
                    "userAttributesForFindings",
                    "assessmentRunCount",
                    "createdAt"
                  ],
                  members: {
                    arn: {},
                    name: {},
                    assessmentTargetArn: {},
                    durationInSeconds: {
                      type: "integer"
                    },
                    rulesPackageArns: {
                      shape: "Sj"
                    },
                    userAttributesForFindings: {
                      shape: "S4"
                    },
                    lastAssessmentRunArn: {},
                    assessmentRunCount: {
                      type: "integer"
                    },
                    createdAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              failedItems: {
                shape: "S9"
              }
            }
          }
        },
        DescribeCrossAccountAccessRole: {
          output: {
            type: "structure",
            required: [
              "roleArn",
              "valid",
              "registeredAt"
            ],
            members: {
              roleArn: {},
              valid: {
                type: "boolean"
              },
              registeredAt: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeExclusions: {
          input: {
            type: "structure",
            required: [
              "exclusionArns"
            ],
            members: {
              exclusionArns: {
                type: "list",
                member: {}
              },
              locale: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "exclusions",
              "failedItems"
            ],
            members: {
              exclusions: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "arn",
                    "title",
                    "description",
                    "recommendation",
                    "scopes"
                  ],
                  members: {
                    arn: {},
                    title: {},
                    description: {},
                    recommendation: {},
                    scopes: {
                      shape: "S1x"
                    },
                    attributes: {
                      shape: "S21"
                    }
                  }
                }
              },
              failedItems: {
                shape: "S9"
              }
            }
          }
        },
        DescribeFindings: {
          input: {
            type: "structure",
            required: [
              "findingArns"
            ],
            members: {
              findingArns: {
                shape: "Sy"
              },
              locale: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "findings",
              "failedItems"
            ],
            members: {
              findings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "attributes",
                    "userAttributes",
                    "createdAt",
                    "updatedAt"
                  ],
                  members: {
                    arn: {},
                    schemaVersion: {
                      type: "integer"
                    },
                    service: {},
                    serviceAttributes: {
                      type: "structure",
                      required: [
                        "schemaVersion"
                      ],
                      members: {
                        schemaVersion: {
                          type: "integer"
                        },
                        assessmentRunArn: {},
                        rulesPackageArn: {}
                      }
                    },
                    assetType: {},
                    assetAttributes: {
                      type: "structure",
                      required: [
                        "schemaVersion"
                      ],
                      members: {
                        schemaVersion: {
                          type: "integer"
                        },
                        agentId: {},
                        autoScalingGroup: {},
                        amiId: {},
                        hostname: {},
                        ipv4Addresses: {
                          type: "list",
                          member: {}
                        },
                        tags: {
                          type: "list",
                          member: {
                            shape: "S2i"
                          }
                        },
                        networkInterfaces: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              networkInterfaceId: {},
                              subnetId: {},
                              vpcId: {},
                              privateDnsName: {},
                              privateIpAddress: {},
                              privateIpAddresses: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    privateDnsName: {},
                                    privateIpAddress: {}
                                  }
                                }
                              },
                              publicDnsName: {},
                              publicIp: {},
                              ipv6Addresses: {
                                type: "list",
                                member: {}
                              },
                              securityGroups: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    groupName: {},
                                    groupId: {}
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    id: {},
                    title: {},
                    description: {},
                    recommendation: {},
                    severity: {},
                    numericSeverity: {
                      type: "double"
                    },
                    confidence: {
                      type: "integer"
                    },
                    indicatorOfCompromise: {
                      type: "boolean"
                    },
                    attributes: {
                      shape: "S21"
                    },
                    userAttributes: {
                      shape: "S4"
                    },
                    createdAt: {
                      type: "timestamp"
                    },
                    updatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              failedItems: {
                shape: "S9"
              }
            }
          }
        },
        DescribeResourceGroups: {
          input: {
            type: "structure",
            required: [
              "resourceGroupArns"
            ],
            members: {
              resourceGroupArns: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "resourceGroups",
              "failedItems"
            ],
            members: {
              resourceGroups: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "tags",
                    "createdAt"
                  ],
                  members: {
                    arn: {},
                    tags: {
                      shape: "Sp"
                    },
                    createdAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              failedItems: {
                shape: "S9"
              }
            }
          }
        },
        DescribeRulesPackages: {
          input: {
            type: "structure",
            required: [
              "rulesPackageArns"
            ],
            members: {
              rulesPackageArns: {
                shape: "Sy"
              },
              locale: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "rulesPackages",
              "failedItems"
            ],
            members: {
              rulesPackages: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "name",
                    "version",
                    "provider"
                  ],
                  members: {
                    arn: {},
                    name: {},
                    version: {},
                    provider: {},
                    description: {}
                  }
                }
              },
              failedItems: {
                shape: "S9"
              }
            }
          }
        },
        GetAssessmentReport: {
          input: {
            type: "structure",
            required: [
              "assessmentRunArn",
              "reportFileFormat",
              "reportType"
            ],
            members: {
              assessmentRunArn: {},
              reportFileFormat: {},
              reportType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "status"
            ],
            members: {
              status: {},
              url: {}
            }
          }
        },
        GetExclusionsPreview: {
          input: {
            type: "structure",
            required: [
              "assessmentTemplateArn",
              "previewToken"
            ],
            members: {
              assessmentTemplateArn: {},
              previewToken: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              locale: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "previewStatus"
            ],
            members: {
              previewStatus: {},
              exclusionPreviews: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "title",
                    "description",
                    "recommendation",
                    "scopes"
                  ],
                  members: {
                    title: {},
                    description: {},
                    recommendation: {},
                    scopes: {
                      shape: "S1x"
                    },
                    attributes: {
                      shape: "S21"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetTelemetryMetadata: {
          input: {
            type: "structure",
            required: [
              "assessmentRunArn"
            ],
            members: {
              assessmentRunArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "telemetryMetadata"
            ],
            members: {
              telemetryMetadata: {
                shape: "S3j"
              }
            }
          }
        },
        ListAssessmentRunAgents: {
          input: {
            type: "structure",
            required: [
              "assessmentRunArn"
            ],
            members: {
              assessmentRunArn: {},
              filter: {
                type: "structure",
                required: [
                  "agentHealths",
                  "agentHealthCodes"
                ],
                members: {
                  agentHealths: {
                    type: "list",
                    member: {}
                  },
                  agentHealthCodes: {
                    type: "list",
                    member: {}
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentRunAgents"
            ],
            members: {
              assessmentRunAgents: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "agentId",
                    "assessmentRunArn",
                    "agentHealth",
                    "agentHealthCode",
                    "telemetryMetadata"
                  ],
                  members: {
                    agentId: {},
                    assessmentRunArn: {},
                    agentHealth: {},
                    agentHealthCode: {},
                    agentHealthDetails: {},
                    autoScalingGroup: {},
                    telemetryMetadata: {
                      shape: "S3j"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAssessmentRuns: {
          input: {
            type: "structure",
            members: {
              assessmentTemplateArns: {
                shape: "S3x"
              },
              filter: {
                type: "structure",
                members: {
                  namePattern: {},
                  states: {
                    type: "list",
                    member: {}
                  },
                  durationRange: {
                    shape: "S41"
                  },
                  rulesPackageArns: {
                    shape: "S42"
                  },
                  startTimeRange: {
                    shape: "S43"
                  },
                  completionTimeRange: {
                    shape: "S43"
                  },
                  stateChangeTimeRange: {
                    shape: "S43"
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentRunArns"
            ],
            members: {
              assessmentRunArns: {
                shape: "S45"
              },
              nextToken: {}
            }
          }
        },
        ListAssessmentTargets: {
          input: {
            type: "structure",
            members: {
              filter: {
                type: "structure",
                members: {
                  assessmentTargetNamePattern: {}
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentTargetArns"
            ],
            members: {
              assessmentTargetArns: {
                shape: "S45"
              },
              nextToken: {}
            }
          }
        },
        ListAssessmentTemplates: {
          input: {
            type: "structure",
            members: {
              assessmentTargetArns: {
                shape: "S3x"
              },
              filter: {
                type: "structure",
                members: {
                  namePattern: {},
                  durationRange: {
                    shape: "S41"
                  },
                  rulesPackageArns: {
                    shape: "S42"
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentTemplateArns"
            ],
            members: {
              assessmentTemplateArns: {
                shape: "S45"
              },
              nextToken: {}
            }
          }
        },
        ListEventSubscriptions: {
          input: {
            type: "structure",
            members: {
              resourceArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "subscriptions"
            ],
            members: {
              subscriptions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "resourceArn",
                    "topicArn",
                    "eventSubscriptions"
                  ],
                  members: {
                    resourceArn: {},
                    topicArn: {},
                    eventSubscriptions: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "event",
                          "subscribedAt"
                        ],
                        members: {
                          event: {},
                          subscribedAt: {
                            type: "timestamp"
                          }
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListExclusions: {
          input: {
            type: "structure",
            required: [
              "assessmentRunArn"
            ],
            members: {
              assessmentRunArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "exclusionArns"
            ],
            members: {
              exclusionArns: {
                shape: "S45"
              },
              nextToken: {}
            }
          }
        },
        ListFindings: {
          input: {
            type: "structure",
            members: {
              assessmentRunArns: {
                shape: "S3x"
              },
              filter: {
                type: "structure",
                members: {
                  agentIds: {
                    type: "list",
                    member: {}
                  },
                  autoScalingGroups: {
                    type: "list",
                    member: {}
                  },
                  ruleNames: {
                    type: "list",
                    member: {}
                  },
                  severities: {
                    type: "list",
                    member: {}
                  },
                  rulesPackageArns: {
                    shape: "S42"
                  },
                  attributes: {
                    shape: "S21"
                  },
                  userAttributes: {
                    shape: "S21"
                  },
                  creationTimeRange: {
                    shape: "S43"
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "findingArns"
            ],
            members: {
              findingArns: {
                shape: "S45"
              },
              nextToken: {}
            }
          }
        },
        ListRulesPackages: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "rulesPackageArns"
            ],
            members: {
              rulesPackageArns: {
                shape: "S45"
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              tags: {
                shape: "S4x"
              }
            }
          }
        },
        PreviewAgents: {
          input: {
            type: "structure",
            required: [
              "previewAgentsArn"
            ],
            members: {
              previewAgentsArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "agentPreviews"
            ],
            members: {
              agentPreviews: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "agentId"
                  ],
                  members: {
                    hostname: {},
                    agentId: {},
                    autoScalingGroup: {},
                    agentHealth: {},
                    agentVersion: {},
                    operatingSystem: {},
                    kernelVersion: {},
                    ipv4Address: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        RegisterCrossAccountAccessRole: {
          input: {
            type: "structure",
            required: [
              "roleArn"
            ],
            members: {
              roleArn: {}
            }
          }
        },
        RemoveAttributesFromFindings: {
          input: {
            type: "structure",
            required: [
              "findingArns",
              "attributeKeys"
            ],
            members: {
              findingArns: {
                shape: "S2"
              },
              attributeKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "failedItems"
            ],
            members: {
              failedItems: {
                shape: "S9"
              }
            }
          }
        },
        SetTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S4x"
              }
            }
          }
        },
        StartAssessmentRun: {
          input: {
            type: "structure",
            required: [
              "assessmentTemplateArn"
            ],
            members: {
              assessmentTemplateArn: {},
              assessmentRunName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "assessmentRunArn"
            ],
            members: {
              assessmentRunArn: {}
            }
          }
        },
        StopAssessmentRun: {
          input: {
            type: "structure",
            required: [
              "assessmentRunArn"
            ],
            members: {
              assessmentRunArn: {},
              stopAction: {}
            }
          }
        },
        SubscribeToEvent: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "event",
              "topicArn"
            ],
            members: {
              resourceArn: {},
              event: {},
              topicArn: {}
            }
          }
        },
        UnsubscribeFromEvent: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "event",
              "topicArn"
            ],
            members: {
              resourceArn: {},
              event: {},
              topicArn: {}
            }
          }
        },
        UpdateAssessmentTarget: {
          input: {
            type: "structure",
            required: [
              "assessmentTargetArn",
              "assessmentTargetName"
            ],
            members: {
              assessmentTargetArn: {},
              assessmentTargetName: {},
              resourceGroupArn: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {}
        },
        S4: {
          type: "list",
          member: {
            shape: "S5"
          }
        },
        S5: {
          type: "structure",
          required: [
            "key"
          ],
          members: {
            key: {},
            value: {}
          }
        },
        S9: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "failureCode",
              "retryable"
            ],
            members: {
              failureCode: {},
              retryable: {
                type: "boolean"
              }
            }
          }
        },
        Sj: {
          type: "list",
          member: {}
        },
        Sp: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sy: {
          type: "list",
          member: {}
        },
        S1x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {}
            }
          }
        },
        S21: {
          type: "list",
          member: {
            shape: "S5"
          }
        },
        S2i: {
          type: "structure",
          required: [
            "key"
          ],
          members: {
            key: {},
            value: {}
          }
        },
        S3j: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "messageType",
              "count"
            ],
            members: {
              messageType: {},
              count: {
                type: "long"
              },
              dataSize: {
                type: "long"
              }
            }
          }
        },
        S3x: {
          type: "list",
          member: {}
        },
        S41: {
          type: "structure",
          members: {
            minSeconds: {
              type: "integer"
            },
            maxSeconds: {
              type: "integer"
            }
          }
        },
        S42: {
          type: "list",
          member: {}
        },
        S43: {
          type: "structure",
          members: {
            beginDate: {
              type: "timestamp"
            },
            endDate: {
              type: "timestamp"
            }
          }
        },
        S45: {
          type: "list",
          member: {}
        },
        S4x: {
          type: "list",
          member: {
            shape: "S2i"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/inspector-2016-02-16.paginators.json
var require_inspector_2016_02_16_paginators = __commonJS({
  "node_modules/aws-sdk/apis/inspector-2016-02-16.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetExclusionsPreview: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAssessmentRunAgents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAssessmentRuns: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAssessmentTargets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAssessmentTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListEventSubscriptions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListExclusions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListFindings: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListRulesPackages: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        PreviewAgents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/inspector.js
var require_inspector = __commonJS({
  "node_modules/aws-sdk/clients/inspector.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["inspector"] = {};
    AWS3.Inspector = Service.defineService("inspector", ["2015-08-18*", "2016-02-16"]);
    Object.defineProperty(apiLoader.services["inspector"], "2016-02-16", {
      get: function get() {
        var model = require_inspector_2016_02_16_min();
        model.paginators = require_inspector_2016_02_16_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Inspector;
  }
});

// node_modules/aws-sdk/apis/iot-2015-05-28.min.json
var require_iot_2015_05_28_min = __commonJS({
  "node_modules/aws-sdk/apis/iot-2015-05-28.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-05-28",
        endpointPrefix: "iot",
        protocol: "rest-json",
        serviceFullName: "AWS IoT",
        serviceId: "IoT",
        signatureVersion: "v4",
        signingName: "execute-api",
        uid: "iot-2015-05-28"
      },
      operations: {
        AcceptCertificateTransfer: {
          http: {
            method: "PATCH",
            requestUri: "/accept-certificate-transfer/{certificateId}"
          },
          input: {
            type: "structure",
            required: [
              "certificateId"
            ],
            members: {
              certificateId: {
                location: "uri",
                locationName: "certificateId"
              },
              setAsActive: {
                location: "querystring",
                locationName: "setAsActive",
                type: "boolean"
              }
            }
          }
        },
        AddThingToBillingGroup: {
          http: {
            method: "PUT",
            requestUri: "/billing-groups/addThingToBillingGroup"
          },
          input: {
            type: "structure",
            members: {
              billingGroupName: {},
              billingGroupArn: {},
              thingName: {},
              thingArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AddThingToThingGroup: {
          http: {
            method: "PUT",
            requestUri: "/thing-groups/addThingToThingGroup"
          },
          input: {
            type: "structure",
            members: {
              thingGroupName: {},
              thingGroupArn: {},
              thingName: {},
              thingArn: {},
              overrideDynamicGroups: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateTargetsWithJob: {
          http: {
            requestUri: "/jobs/{jobId}/targets"
          },
          input: {
            type: "structure",
            required: [
              "targets",
              "jobId"
            ],
            members: {
              targets: {
                shape: "Sg"
              },
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              comment: {},
              namespaceId: {
                location: "querystring",
                locationName: "namespaceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobArn: {},
              jobId: {},
              description: {}
            }
          }
        },
        AttachPolicy: {
          http: {
            method: "PUT",
            requestUri: "/target-policies/{policyName}"
          },
          input: {
            type: "structure",
            required: [
              "policyName",
              "target"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              },
              target: {}
            }
          }
        },
        AttachPrincipalPolicy: {
          http: {
            method: "PUT",
            requestUri: "/principal-policies/{policyName}"
          },
          input: {
            type: "structure",
            required: [
              "policyName",
              "principal"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              },
              principal: {
                location: "header",
                locationName: "x-amzn-iot-principal"
              }
            }
          },
          deprecated: true
        },
        AttachSecurityProfile: {
          http: {
            method: "PUT",
            requestUri: "/security-profiles/{securityProfileName}/targets"
          },
          input: {
            type: "structure",
            required: [
              "securityProfileName",
              "securityProfileTargetArn"
            ],
            members: {
              securityProfileName: {
                location: "uri",
                locationName: "securityProfileName"
              },
              securityProfileTargetArn: {
                location: "querystring",
                locationName: "securityProfileTargetArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AttachThingPrincipal: {
          http: {
            method: "PUT",
            requestUri: "/things/{thingName}/principals"
          },
          input: {
            type: "structure",
            required: [
              "thingName",
              "principal"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              principal: {
                location: "header",
                locationName: "x-amzn-principal"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelAuditMitigationActionsTask: {
          http: {
            method: "PUT",
            requestUri: "/audit/mitigationactions/tasks/{taskId}/cancel"
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelAuditTask: {
          http: {
            method: "PUT",
            requestUri: "/audit/tasks/{taskId}/cancel"
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelCertificateTransfer: {
          http: {
            method: "PATCH",
            requestUri: "/cancel-certificate-transfer/{certificateId}"
          },
          input: {
            type: "structure",
            required: [
              "certificateId"
            ],
            members: {
              certificateId: {
                location: "uri",
                locationName: "certificateId"
              }
            }
          }
        },
        CancelDetectMitigationActionsTask: {
          http: {
            method: "PUT",
            requestUri: "/detect/mitigationactions/tasks/{taskId}/cancel"
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelJob: {
          http: {
            method: "PUT",
            requestUri: "/jobs/{jobId}/cancel"
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              reasonCode: {},
              comment: {},
              force: {
                location: "querystring",
                locationName: "force",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobArn: {},
              jobId: {},
              description: {}
            }
          }
        },
        CancelJobExecution: {
          http: {
            method: "PUT",
            requestUri: "/things/{thingName}/jobs/{jobId}/cancel"
          },
          input: {
            type: "structure",
            required: [
              "jobId",
              "thingName"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              force: {
                location: "querystring",
                locationName: "force",
                type: "boolean"
              },
              expectedVersion: {
                type: "long"
              },
              statusDetails: {
                shape: "S1e"
              }
            }
          }
        },
        ClearDefaultAuthorizer: {
          http: {
            method: "DELETE",
            requestUri: "/default-authorizer"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ConfirmTopicRuleDestination: {
          http: {
            method: "GET",
            requestUri: "/confirmdestination/{confirmationToken+}"
          },
          input: {
            type: "structure",
            required: [
              "confirmationToken"
            ],
            members: {
              confirmationToken: {
                location: "uri",
                locationName: "confirmationToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateAuditSuppression: {
          http: {
            requestUri: "/audit/suppressions/create"
          },
          input: {
            type: "structure",
            required: [
              "checkName",
              "resourceIdentifier",
              "clientRequestToken"
            ],
            members: {
              checkName: {},
              resourceIdentifier: {
                shape: "S1o"
              },
              expirationDate: {
                type: "timestamp"
              },
              suppressIndefinitely: {
                type: "boolean"
              },
              description: {},
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateAuthorizer: {
          http: {
            requestUri: "/authorizer/{authorizerName}"
          },
          input: {
            type: "structure",
            required: [
              "authorizerName",
              "authorizerFunctionArn"
            ],
            members: {
              authorizerName: {
                location: "uri",
                locationName: "authorizerName"
              },
              authorizerFunctionArn: {},
              tokenKeyName: {},
              tokenSigningPublicKeys: {
                shape: "S25"
              },
              status: {},
              tags: {
                shape: "S29"
              },
              signingDisabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              authorizerName: {},
              authorizerArn: {}
            }
          }
        },
        CreateBillingGroup: {
          http: {
            requestUri: "/billing-groups/{billingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "billingGroupName"
            ],
            members: {
              billingGroupName: {
                location: "uri",
                locationName: "billingGroupName"
              },
              billingGroupProperties: {
                shape: "S2h"
              },
              tags: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              billingGroupName: {},
              billingGroupArn: {},
              billingGroupId: {}
            }
          }
        },
        CreateCertificateFromCsr: {
          http: {
            requestUri: "/certificates"
          },
          input: {
            type: "structure",
            required: [
              "certificateSigningRequest"
            ],
            members: {
              certificateSigningRequest: {},
              setAsActive: {
                location: "querystring",
                locationName: "setAsActive",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificateArn: {},
              certificateId: {},
              certificatePem: {}
            }
          }
        },
        CreateCustomMetric: {
          http: {
            requestUri: "/custom-metric/{metricName}"
          },
          input: {
            type: "structure",
            required: [
              "metricName",
              "metricType",
              "clientRequestToken"
            ],
            members: {
              metricName: {
                location: "uri",
                locationName: "metricName"
              },
              displayName: {},
              metricType: {},
              tags: {
                shape: "S29"
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              metricArn: {}
            }
          }
        },
        CreateDimension: {
          http: {
            requestUri: "/dimensions/{name}"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "type",
              "stringValues",
              "clientRequestToken"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              type: {},
              stringValues: {
                shape: "S2z"
              },
              tags: {
                shape: "S29"
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              arn: {}
            }
          }
        },
        CreateDomainConfiguration: {
          http: {
            requestUri: "/domainConfigurations/{domainConfigurationName}"
          },
          input: {
            type: "structure",
            required: [
              "domainConfigurationName"
            ],
            members: {
              domainConfigurationName: {
                location: "uri",
                locationName: "domainConfigurationName"
              },
              domainName: {},
              serverCertificateArns: {
                type: "list",
                member: {}
              },
              validationCertificateArn: {},
              authorizerConfig: {
                shape: "S38"
              },
              serviceType: {},
              tags: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              domainConfigurationName: {},
              domainConfigurationArn: {}
            }
          }
        },
        CreateDynamicThingGroup: {
          http: {
            requestUri: "/dynamic-thing-groups/{thingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "thingGroupName",
              "queryString"
            ],
            members: {
              thingGroupName: {
                location: "uri",
                locationName: "thingGroupName"
              },
              thingGroupProperties: {
                shape: "S3e"
              },
              indexName: {},
              queryString: {},
              queryVersion: {},
              tags: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              thingGroupName: {},
              thingGroupArn: {},
              thingGroupId: {},
              indexName: {},
              queryString: {},
              queryVersion: {}
            }
          }
        },
        CreateFleetMetric: {
          http: {
            method: "PUT",
            requestUri: "/fleet-metric/{metricName}"
          },
          input: {
            type: "structure",
            required: [
              "metricName",
              "queryString",
              "aggregationType",
              "period",
              "aggregationField"
            ],
            members: {
              metricName: {
                location: "uri",
                locationName: "metricName"
              },
              queryString: {},
              aggregationType: {
                shape: "S3s"
              },
              period: {
                type: "integer"
              },
              aggregationField: {},
              description: {},
              queryVersion: {},
              indexName: {},
              unit: {},
              tags: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              metricArn: {}
            }
          }
        },
        CreateJob: {
          http: {
            method: "PUT",
            requestUri: "/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "jobId",
              "targets"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              targets: {
                shape: "Sg"
              },
              documentSource: {},
              document: {},
              description: {},
              presignedUrlConfig: {
                shape: "S45"
              },
              targetSelection: {},
              jobExecutionsRolloutConfig: {
                shape: "S48"
              },
              abortConfig: {
                shape: "S4f"
              },
              timeoutConfig: {
                shape: "S4m"
              },
              tags: {
                shape: "S29"
              },
              namespaceId: {},
              jobTemplateArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              jobArn: {},
              jobId: {},
              description: {}
            }
          }
        },
        CreateJobTemplate: {
          http: {
            method: "PUT",
            requestUri: "/job-templates/{jobTemplateId}"
          },
          input: {
            type: "structure",
            required: [
              "jobTemplateId",
              "description"
            ],
            members: {
              jobTemplateId: {
                location: "uri",
                locationName: "jobTemplateId"
              },
              jobArn: {},
              documentSource: {},
              document: {},
              description: {},
              presignedUrlConfig: {
                shape: "S45"
              },
              jobExecutionsRolloutConfig: {
                shape: "S48"
              },
              abortConfig: {
                shape: "S4f"
              },
              timeoutConfig: {
                shape: "S4m"
              },
              tags: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobTemplateArn: {},
              jobTemplateId: {}
            }
          }
        },
        CreateKeysAndCertificate: {
          http: {
            requestUri: "/keys-and-certificate"
          },
          input: {
            type: "structure",
            members: {
              setAsActive: {
                location: "querystring",
                locationName: "setAsActive",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificateArn: {},
              certificateId: {},
              certificatePem: {},
              keyPair: {
                shape: "S4v"
              }
            }
          }
        },
        CreateMitigationAction: {
          http: {
            requestUri: "/mitigationactions/actions/{actionName}"
          },
          input: {
            type: "structure",
            required: [
              "actionName",
              "roleArn",
              "actionParams"
            ],
            members: {
              actionName: {
                location: "uri",
                locationName: "actionName"
              },
              roleArn: {},
              actionParams: {
                shape: "S50"
              },
              tags: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              actionArn: {},
              actionId: {}
            }
          }
        },
        CreateOTAUpdate: {
          http: {
            requestUri: "/otaUpdates/{otaUpdateId}"
          },
          input: {
            type: "structure",
            required: [
              "otaUpdateId",
              "targets",
              "files",
              "roleArn"
            ],
            members: {
              otaUpdateId: {
                location: "uri",
                locationName: "otaUpdateId"
              },
              description: {},
              targets: {
                shape: "S5j"
              },
              protocols: {
                shape: "S5l"
              },
              targetSelection: {},
              awsJobExecutionsRolloutConfig: {
                shape: "S5n"
              },
              awsJobPresignedUrlConfig: {
                shape: "S5u"
              },
              awsJobAbortConfig: {
                type: "structure",
                required: [
                  "abortCriteriaList"
                ],
                members: {
                  abortCriteriaList: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "failureType",
                        "action",
                        "thresholdPercentage",
                        "minNumberOfExecutedThings"
                      ],
                      members: {
                        failureType: {},
                        action: {},
                        thresholdPercentage: {
                          type: "double"
                        },
                        minNumberOfExecutedThings: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              },
              awsJobTimeoutConfig: {
                type: "structure",
                members: {
                  inProgressTimeoutInMinutes: {
                    type: "long"
                  }
                }
              },
              files: {
                shape: "S65"
              },
              roleArn: {},
              additionalParameters: {
                shape: "S73"
              },
              tags: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              otaUpdateId: {},
              awsIotJobId: {},
              otaUpdateArn: {},
              awsIotJobArn: {},
              otaUpdateStatus: {}
            }
          }
        },
        CreatePolicy: {
          http: {
            requestUri: "/policies/{policyName}"
          },
          input: {
            type: "structure",
            required: [
              "policyName",
              "policyDocument"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              },
              policyDocument: {},
              tags: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policyName: {},
              policyArn: {},
              policyDocument: {},
              policyVersionId: {}
            }
          }
        },
        CreatePolicyVersion: {
          http: {
            requestUri: "/policies/{policyName}/version"
          },
          input: {
            type: "structure",
            required: [
              "policyName",
              "policyDocument"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              },
              policyDocument: {},
              setAsDefault: {
                location: "querystring",
                locationName: "setAsDefault",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policyArn: {},
              policyDocument: {},
              policyVersionId: {},
              isDefaultVersion: {
                type: "boolean"
              }
            }
          }
        },
        CreateProvisioningClaim: {
          http: {
            requestUri: "/provisioning-templates/{templateName}/provisioning-claim"
          },
          input: {
            type: "structure",
            required: [
              "templateName"
            ],
            members: {
              templateName: {
                location: "uri",
                locationName: "templateName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificateId: {},
              certificatePem: {},
              keyPair: {
                shape: "S4v"
              },
              expiration: {
                type: "timestamp"
              }
            }
          }
        },
        CreateProvisioningTemplate: {
          http: {
            requestUri: "/provisioning-templates"
          },
          input: {
            type: "structure",
            required: [
              "templateName",
              "templateBody",
              "provisioningRoleArn"
            ],
            members: {
              templateName: {},
              description: {},
              templateBody: {},
              enabled: {
                type: "boolean"
              },
              provisioningRoleArn: {},
              preProvisioningHook: {
                shape: "S7p"
              },
              tags: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              templateArn: {},
              templateName: {},
              defaultVersionId: {
                type: "integer"
              }
            }
          }
        },
        CreateProvisioningTemplateVersion: {
          http: {
            requestUri: "/provisioning-templates/{templateName}/versions"
          },
          input: {
            type: "structure",
            required: [
              "templateName",
              "templateBody"
            ],
            members: {
              templateName: {
                location: "uri",
                locationName: "templateName"
              },
              templateBody: {},
              setAsDefault: {
                location: "querystring",
                locationName: "setAsDefault",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              templateArn: {},
              templateName: {},
              versionId: {
                type: "integer"
              },
              isDefaultVersion: {
                type: "boolean"
              }
            }
          }
        },
        CreateRoleAlias: {
          http: {
            requestUri: "/role-aliases/{roleAlias}"
          },
          input: {
            type: "structure",
            required: [
              "roleAlias",
              "roleArn"
            ],
            members: {
              roleAlias: {
                location: "uri",
                locationName: "roleAlias"
              },
              roleArn: {},
              credentialDurationSeconds: {
                type: "integer"
              },
              tags: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              roleAlias: {},
              roleAliasArn: {}
            }
          }
        },
        CreateScheduledAudit: {
          http: {
            requestUri: "/audit/scheduledaudits/{scheduledAuditName}"
          },
          input: {
            type: "structure",
            required: [
              "frequency",
              "targetCheckNames",
              "scheduledAuditName"
            ],
            members: {
              frequency: {},
              dayOfMonth: {},
              dayOfWeek: {},
              targetCheckNames: {
                shape: "S84"
              },
              scheduledAuditName: {
                location: "uri",
                locationName: "scheduledAuditName"
              },
              tags: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              scheduledAuditArn: {}
            }
          }
        },
        CreateSecurityProfile: {
          http: {
            requestUri: "/security-profiles/{securityProfileName}"
          },
          input: {
            type: "structure",
            required: [
              "securityProfileName"
            ],
            members: {
              securityProfileName: {
                location: "uri",
                locationName: "securityProfileName"
              },
              securityProfileDescription: {},
              behaviors: {
                shape: "S8a"
              },
              alertTargets: {
                shape: "S90"
              },
              additionalMetricsToRetain: {
                shape: "S94",
                deprecated: true,
                deprecatedMessage: "Use additionalMetricsToRetainV2."
              },
              additionalMetricsToRetainV2: {
                shape: "S95"
              },
              tags: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              securityProfileName: {},
              securityProfileArn: {}
            }
          }
        },
        CreateStream: {
          http: {
            requestUri: "/streams/{streamId}"
          },
          input: {
            type: "structure",
            required: [
              "streamId",
              "files",
              "roleArn"
            ],
            members: {
              streamId: {
                location: "uri",
                locationName: "streamId"
              },
              description: {},
              files: {
                shape: "S9b"
              },
              roleArn: {},
              tags: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              streamId: {},
              streamArn: {},
              description: {},
              streamVersion: {
                type: "integer"
              }
            }
          }
        },
        CreateThing: {
          http: {
            requestUri: "/things/{thingName}"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              thingTypeName: {},
              attributePayload: {
                shape: "S3g"
              },
              billingGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              thingName: {},
              thingArn: {},
              thingId: {}
            }
          }
        },
        CreateThingGroup: {
          http: {
            requestUri: "/thing-groups/{thingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "thingGroupName"
            ],
            members: {
              thingGroupName: {
                location: "uri",
                locationName: "thingGroupName"
              },
              parentGroupName: {},
              thingGroupProperties: {
                shape: "S3e"
              },
              tags: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              thingGroupName: {},
              thingGroupArn: {},
              thingGroupId: {}
            }
          }
        },
        CreateThingType: {
          http: {
            requestUri: "/thing-types/{thingTypeName}"
          },
          input: {
            type: "structure",
            required: [
              "thingTypeName"
            ],
            members: {
              thingTypeName: {
                location: "uri",
                locationName: "thingTypeName"
              },
              thingTypeProperties: {
                shape: "S9n"
              },
              tags: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              thingTypeName: {},
              thingTypeArn: {},
              thingTypeId: {}
            }
          }
        },
        CreateTopicRule: {
          http: {
            requestUri: "/rules/{ruleName}"
          },
          input: {
            type: "structure",
            required: [
              "ruleName",
              "topicRulePayload"
            ],
            members: {
              ruleName: {
                location: "uri",
                locationName: "ruleName"
              },
              topicRulePayload: {
                shape: "S9v"
              },
              tags: {
                location: "header",
                locationName: "x-amz-tagging"
              }
            },
            payload: "topicRulePayload"
          }
        },
        CreateTopicRuleDestination: {
          http: {
            requestUri: "/destinations"
          },
          input: {
            type: "structure",
            required: [
              "destinationConfiguration"
            ],
            members: {
              destinationConfiguration: {
                type: "structure",
                members: {
                  httpUrlConfiguration: {
                    type: "structure",
                    required: [
                      "confirmationUrl"
                    ],
                    members: {
                      confirmationUrl: {}
                    }
                  },
                  vpcConfiguration: {
                    type: "structure",
                    required: [
                      "subnetIds",
                      "vpcId",
                      "roleArn"
                    ],
                    members: {
                      subnetIds: {
                        shape: "Scw"
                      },
                      securityGroups: {
                        shape: "Scy"
                      },
                      vpcId: {},
                      roleArn: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              topicRuleDestination: {
                shape: "Sd2"
              }
            }
          }
        },
        DeleteAccountAuditConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/audit/configuration"
          },
          input: {
            type: "structure",
            members: {
              deleteScheduledAudits: {
                location: "querystring",
                locationName: "deleteScheduledAudits",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAuditSuppression: {
          http: {
            requestUri: "/audit/suppressions/delete"
          },
          input: {
            type: "structure",
            required: [
              "checkName",
              "resourceIdentifier"
            ],
            members: {
              checkName: {},
              resourceIdentifier: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAuthorizer: {
          http: {
            method: "DELETE",
            requestUri: "/authorizer/{authorizerName}"
          },
          input: {
            type: "structure",
            required: [
              "authorizerName"
            ],
            members: {
              authorizerName: {
                location: "uri",
                locationName: "authorizerName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteBillingGroup: {
          http: {
            method: "DELETE",
            requestUri: "/billing-groups/{billingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "billingGroupName"
            ],
            members: {
              billingGroupName: {
                location: "uri",
                locationName: "billingGroupName"
              },
              expectedVersion: {
                location: "querystring",
                locationName: "expectedVersion",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCACertificate: {
          http: {
            method: "DELETE",
            requestUri: "/cacertificate/{caCertificateId}"
          },
          input: {
            type: "structure",
            required: [
              "certificateId"
            ],
            members: {
              certificateId: {
                location: "uri",
                locationName: "caCertificateId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCertificate: {
          http: {
            method: "DELETE",
            requestUri: "/certificates/{certificateId}"
          },
          input: {
            type: "structure",
            required: [
              "certificateId"
            ],
            members: {
              certificateId: {
                location: "uri",
                locationName: "certificateId"
              },
              forceDelete: {
                location: "querystring",
                locationName: "forceDelete",
                type: "boolean"
              }
            }
          }
        },
        DeleteCustomMetric: {
          http: {
            method: "DELETE",
            requestUri: "/custom-metric/{metricName}"
          },
          input: {
            type: "structure",
            required: [
              "metricName"
            ],
            members: {
              metricName: {
                location: "uri",
                locationName: "metricName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDimension: {
          http: {
            method: "DELETE",
            requestUri: "/dimensions/{name}"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDomainConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/domainConfigurations/{domainConfigurationName}"
          },
          input: {
            type: "structure",
            required: [
              "domainConfigurationName"
            ],
            members: {
              domainConfigurationName: {
                location: "uri",
                locationName: "domainConfigurationName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDynamicThingGroup: {
          http: {
            method: "DELETE",
            requestUri: "/dynamic-thing-groups/{thingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "thingGroupName"
            ],
            members: {
              thingGroupName: {
                location: "uri",
                locationName: "thingGroupName"
              },
              expectedVersion: {
                location: "querystring",
                locationName: "expectedVersion",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteFleetMetric: {
          http: {
            method: "DELETE",
            requestUri: "/fleet-metric/{metricName}"
          },
          input: {
            type: "structure",
            required: [
              "metricName"
            ],
            members: {
              metricName: {
                location: "uri",
                locationName: "metricName"
              },
              expectedVersion: {
                location: "querystring",
                locationName: "expectedVersion",
                type: "long"
              }
            }
          }
        },
        DeleteJob: {
          http: {
            method: "DELETE",
            requestUri: "/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              force: {
                location: "querystring",
                locationName: "force",
                type: "boolean"
              },
              namespaceId: {
                location: "querystring",
                locationName: "namespaceId"
              }
            }
          }
        },
        DeleteJobExecution: {
          http: {
            method: "DELETE",
            requestUri: "/things/{thingName}/jobs/{jobId}/executionNumber/{executionNumber}"
          },
          input: {
            type: "structure",
            required: [
              "jobId",
              "thingName",
              "executionNumber"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              executionNumber: {
                location: "uri",
                locationName: "executionNumber",
                type: "long"
              },
              force: {
                location: "querystring",
                locationName: "force",
                type: "boolean"
              },
              namespaceId: {
                location: "querystring",
                locationName: "namespaceId"
              }
            }
          }
        },
        DeleteJobTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/job-templates/{jobTemplateId}"
          },
          input: {
            type: "structure",
            required: [
              "jobTemplateId"
            ],
            members: {
              jobTemplateId: {
                location: "uri",
                locationName: "jobTemplateId"
              }
            }
          }
        },
        DeleteMitigationAction: {
          http: {
            method: "DELETE",
            requestUri: "/mitigationactions/actions/{actionName}"
          },
          input: {
            type: "structure",
            required: [
              "actionName"
            ],
            members: {
              actionName: {
                location: "uri",
                locationName: "actionName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteOTAUpdate: {
          http: {
            method: "DELETE",
            requestUri: "/otaUpdates/{otaUpdateId}"
          },
          input: {
            type: "structure",
            required: [
              "otaUpdateId"
            ],
            members: {
              otaUpdateId: {
                location: "uri",
                locationName: "otaUpdateId"
              },
              deleteStream: {
                location: "querystring",
                locationName: "deleteStream",
                type: "boolean"
              },
              forceDeleteAWSJob: {
                location: "querystring",
                locationName: "forceDeleteAWSJob",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePolicy: {
          http: {
            method: "DELETE",
            requestUri: "/policies/{policyName}"
          },
          input: {
            type: "structure",
            required: [
              "policyName"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              }
            }
          }
        },
        DeletePolicyVersion: {
          http: {
            method: "DELETE",
            requestUri: "/policies/{policyName}/version/{policyVersionId}"
          },
          input: {
            type: "structure",
            required: [
              "policyName",
              "policyVersionId"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              },
              policyVersionId: {
                location: "uri",
                locationName: "policyVersionId"
              }
            }
          }
        },
        DeleteProvisioningTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/provisioning-templates/{templateName}"
          },
          input: {
            type: "structure",
            required: [
              "templateName"
            ],
            members: {
              templateName: {
                location: "uri",
                locationName: "templateName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteProvisioningTemplateVersion: {
          http: {
            method: "DELETE",
            requestUri: "/provisioning-templates/{templateName}/versions/{versionId}"
          },
          input: {
            type: "structure",
            required: [
              "templateName",
              "versionId"
            ],
            members: {
              templateName: {
                location: "uri",
                locationName: "templateName"
              },
              versionId: {
                location: "uri",
                locationName: "versionId",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRegistrationCode: {
          http: {
            method: "DELETE",
            requestUri: "/registrationcode"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRoleAlias: {
          http: {
            method: "DELETE",
            requestUri: "/role-aliases/{roleAlias}"
          },
          input: {
            type: "structure",
            required: [
              "roleAlias"
            ],
            members: {
              roleAlias: {
                location: "uri",
                locationName: "roleAlias"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteScheduledAudit: {
          http: {
            method: "DELETE",
            requestUri: "/audit/scheduledaudits/{scheduledAuditName}"
          },
          input: {
            type: "structure",
            required: [
              "scheduledAuditName"
            ],
            members: {
              scheduledAuditName: {
                location: "uri",
                locationName: "scheduledAuditName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSecurityProfile: {
          http: {
            method: "DELETE",
            requestUri: "/security-profiles/{securityProfileName}"
          },
          input: {
            type: "structure",
            required: [
              "securityProfileName"
            ],
            members: {
              securityProfileName: {
                location: "uri",
                locationName: "securityProfileName"
              },
              expectedVersion: {
                location: "querystring",
                locationName: "expectedVersion",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteStream: {
          http: {
            method: "DELETE",
            requestUri: "/streams/{streamId}"
          },
          input: {
            type: "structure",
            required: [
              "streamId"
            ],
            members: {
              streamId: {
                location: "uri",
                locationName: "streamId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteThing: {
          http: {
            method: "DELETE",
            requestUri: "/things/{thingName}"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              expectedVersion: {
                location: "querystring",
                locationName: "expectedVersion",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteThingGroup: {
          http: {
            method: "DELETE",
            requestUri: "/thing-groups/{thingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "thingGroupName"
            ],
            members: {
              thingGroupName: {
                location: "uri",
                locationName: "thingGroupName"
              },
              expectedVersion: {
                location: "querystring",
                locationName: "expectedVersion",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteThingType: {
          http: {
            method: "DELETE",
            requestUri: "/thing-types/{thingTypeName}"
          },
          input: {
            type: "structure",
            required: [
              "thingTypeName"
            ],
            members: {
              thingTypeName: {
                location: "uri",
                locationName: "thingTypeName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTopicRule: {
          http: {
            method: "DELETE",
            requestUri: "/rules/{ruleName}"
          },
          input: {
            type: "structure",
            required: [
              "ruleName"
            ],
            members: {
              ruleName: {
                location: "uri",
                locationName: "ruleName"
              }
            }
          }
        },
        DeleteTopicRuleDestination: {
          http: {
            method: "DELETE",
            requestUri: "/destinations/{arn+}"
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {
                location: "uri",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteV2LoggingLevel: {
          http: {
            method: "DELETE",
            requestUri: "/v2LoggingLevel"
          },
          input: {
            type: "structure",
            required: [
              "targetType",
              "targetName"
            ],
            members: {
              targetType: {
                location: "querystring",
                locationName: "targetType"
              },
              targetName: {
                location: "querystring",
                locationName: "targetName"
              }
            }
          }
        },
        DeprecateThingType: {
          http: {
            requestUri: "/thing-types/{thingTypeName}/deprecate"
          },
          input: {
            type: "structure",
            required: [
              "thingTypeName"
            ],
            members: {
              thingTypeName: {
                location: "uri",
                locationName: "thingTypeName"
              },
              undoDeprecate: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeAccountAuditConfiguration: {
          http: {
            method: "GET",
            requestUri: "/audit/configuration"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              roleArn: {},
              auditNotificationTargetConfigurations: {
                shape: "Sf2"
              },
              auditCheckConfigurations: {
                shape: "Sf5"
              }
            }
          }
        },
        DescribeAuditFinding: {
          http: {
            method: "GET",
            requestUri: "/audit/findings/{findingId}"
          },
          input: {
            type: "structure",
            required: [
              "findingId"
            ],
            members: {
              findingId: {
                location: "uri",
                locationName: "findingId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              finding: {
                shape: "Sfa"
              }
            }
          }
        },
        DescribeAuditMitigationActionsTask: {
          http: {
            method: "GET",
            requestUri: "/audit/mitigationactions/tasks/{taskId}"
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskStatus: {},
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              taskStatistics: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    totalFindingsCount: {
                      type: "long"
                    },
                    failedFindingsCount: {
                      type: "long"
                    },
                    succeededFindingsCount: {
                      type: "long"
                    },
                    skippedFindingsCount: {
                      type: "long"
                    },
                    canceledFindingsCount: {
                      type: "long"
                    }
                  }
                }
              },
              target: {
                shape: "Sfu"
              },
              auditCheckToActionsMapping: {
                shape: "Sfy"
              },
              actionsDefinition: {
                shape: "Sg0"
              }
            }
          }
        },
        DescribeAuditSuppression: {
          http: {
            requestUri: "/audit/suppressions/describe"
          },
          input: {
            type: "structure",
            required: [
              "checkName",
              "resourceIdentifier"
            ],
            members: {
              checkName: {},
              resourceIdentifier: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              checkName: {},
              resourceIdentifier: {
                shape: "S1o"
              },
              expirationDate: {
                type: "timestamp"
              },
              suppressIndefinitely: {
                type: "boolean"
              },
              description: {}
            }
          }
        },
        DescribeAuditTask: {
          http: {
            method: "GET",
            requestUri: "/audit/tasks/{taskId}"
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskStatus: {},
              taskType: {},
              taskStartTime: {
                type: "timestamp"
              },
              taskStatistics: {
                type: "structure",
                members: {
                  totalChecks: {
                    type: "integer"
                  },
                  inProgressChecks: {
                    type: "integer"
                  },
                  waitingForDataCollectionChecks: {
                    type: "integer"
                  },
                  compliantChecks: {
                    type: "integer"
                  },
                  nonCompliantChecks: {
                    type: "integer"
                  },
                  failedChecks: {
                    type: "integer"
                  },
                  canceledChecks: {
                    type: "integer"
                  }
                }
              },
              scheduledAuditName: {},
              auditDetails: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    checkRunStatus: {},
                    checkCompliant: {
                      type: "boolean"
                    },
                    totalResourcesCount: {
                      type: "long"
                    },
                    nonCompliantResourcesCount: {
                      type: "long"
                    },
                    suppressedNonCompliantResourcesCount: {
                      type: "long"
                    },
                    errorCode: {},
                    message: {}
                  }
                }
              }
            }
          }
        },
        DescribeAuthorizer: {
          http: {
            method: "GET",
            requestUri: "/authorizer/{authorizerName}"
          },
          input: {
            type: "structure",
            required: [
              "authorizerName"
            ],
            members: {
              authorizerName: {
                location: "uri",
                locationName: "authorizerName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              authorizerDescription: {
                shape: "Sgr"
              }
            }
          }
        },
        DescribeBillingGroup: {
          http: {
            method: "GET",
            requestUri: "/billing-groups/{billingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "billingGroupName"
            ],
            members: {
              billingGroupName: {
                location: "uri",
                locationName: "billingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              billingGroupName: {},
              billingGroupId: {},
              billingGroupArn: {},
              version: {
                type: "long"
              },
              billingGroupProperties: {
                shape: "S2h"
              },
              billingGroupMetadata: {
                type: "structure",
                members: {
                  creationDate: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeCACertificate: {
          http: {
            method: "GET",
            requestUri: "/cacertificate/{caCertificateId}"
          },
          input: {
            type: "structure",
            required: [
              "certificateId"
            ],
            members: {
              certificateId: {
                location: "uri",
                locationName: "caCertificateId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificateDescription: {
                type: "structure",
                members: {
                  certificateArn: {},
                  certificateId: {},
                  status: {},
                  certificatePem: {},
                  ownedBy: {},
                  creationDate: {
                    type: "timestamp"
                  },
                  autoRegistrationStatus: {},
                  lastModifiedDate: {
                    type: "timestamp"
                  },
                  customerVersion: {
                    type: "integer"
                  },
                  generationId: {},
                  validity: {
                    shape: "Sh4"
                  }
                }
              },
              registrationConfig: {
                shape: "Sh5"
              }
            }
          }
        },
        DescribeCertificate: {
          http: {
            method: "GET",
            requestUri: "/certificates/{certificateId}"
          },
          input: {
            type: "structure",
            required: [
              "certificateId"
            ],
            members: {
              certificateId: {
                location: "uri",
                locationName: "certificateId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificateDescription: {
                type: "structure",
                members: {
                  certificateArn: {},
                  certificateId: {},
                  caCertificateId: {},
                  status: {},
                  certificatePem: {},
                  ownedBy: {},
                  previousOwnedBy: {},
                  creationDate: {
                    type: "timestamp"
                  },
                  lastModifiedDate: {
                    type: "timestamp"
                  },
                  customerVersion: {
                    type: "integer"
                  },
                  transferData: {
                    type: "structure",
                    members: {
                      transferMessage: {},
                      rejectReason: {},
                      transferDate: {
                        type: "timestamp"
                      },
                      acceptDate: {
                        type: "timestamp"
                      },
                      rejectDate: {
                        type: "timestamp"
                      }
                    }
                  },
                  generationId: {},
                  validity: {
                    shape: "Sh4"
                  },
                  certificateMode: {}
                }
              }
            }
          }
        },
        DescribeCustomMetric: {
          http: {
            method: "GET",
            requestUri: "/custom-metric/{metricName}"
          },
          input: {
            type: "structure",
            required: [
              "metricName"
            ],
            members: {
              metricName: {
                location: "uri",
                locationName: "metricName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              metricArn: {},
              metricType: {},
              displayName: {},
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeDefaultAuthorizer: {
          http: {
            method: "GET",
            requestUri: "/default-authorizer"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              authorizerDescription: {
                shape: "Sgr"
              }
            }
          }
        },
        DescribeDetectMitigationActionsTask: {
          http: {
            method: "GET",
            requestUri: "/detect/mitigationactions/tasks/{taskId}"
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskSummary: {
                shape: "Shj"
              }
            }
          }
        },
        DescribeDimension: {
          http: {
            method: "GET",
            requestUri: "/dimensions/{name}"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              arn: {},
              type: {},
              stringValues: {
                shape: "S2z"
              },
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeDomainConfiguration: {
          http: {
            method: "GET",
            requestUri: "/domainConfigurations/{domainConfigurationName}"
          },
          input: {
            type: "structure",
            required: [
              "domainConfigurationName"
            ],
            members: {
              domainConfigurationName: {
                location: "uri",
                locationName: "domainConfigurationName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              domainConfigurationName: {},
              domainConfigurationArn: {},
              domainName: {},
              serverCertificates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    serverCertificateArn: {},
                    serverCertificateStatus: {},
                    serverCertificateStatusDetail: {}
                  }
                }
              },
              authorizerConfig: {
                shape: "S38"
              },
              domainConfigurationStatus: {},
              serviceType: {},
              domainType: {},
              lastStatusChangeDate: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeEndpoint: {
          http: {
            method: "GET",
            requestUri: "/endpoint"
          },
          input: {
            type: "structure",
            members: {
              endpointType: {
                location: "querystring",
                locationName: "endpointType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              endpointAddress: {}
            }
          }
        },
        DescribeEventConfigurations: {
          http: {
            method: "GET",
            requestUri: "/event-configurations"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              eventConfigurations: {
                shape: "Si9"
              },
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeFleetMetric: {
          http: {
            method: "GET",
            requestUri: "/fleet-metric/{metricName}"
          },
          input: {
            type: "structure",
            required: [
              "metricName"
            ],
            members: {
              metricName: {
                location: "uri",
                locationName: "metricName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              queryString: {},
              aggregationType: {
                shape: "S3s"
              },
              period: {
                type: "integer"
              },
              aggregationField: {},
              description: {},
              queryVersion: {},
              indexName: {},
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              },
              unit: {},
              version: {
                type: "long"
              },
              metricArn: {}
            }
          }
        },
        DescribeIndex: {
          http: {
            method: "GET",
            requestUri: "/indices/{indexName}"
          },
          input: {
            type: "structure",
            required: [
              "indexName"
            ],
            members: {
              indexName: {
                location: "uri",
                locationName: "indexName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              indexName: {},
              indexStatus: {},
              schema: {}
            }
          }
        },
        DescribeJob: {
          http: {
            method: "GET",
            requestUri: "/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              documentSource: {},
              job: {
                type: "structure",
                members: {
                  jobArn: {},
                  jobId: {},
                  targetSelection: {},
                  status: {},
                  forceCanceled: {
                    type: "boolean"
                  },
                  reasonCode: {},
                  comment: {},
                  targets: {
                    shape: "Sg"
                  },
                  description: {},
                  presignedUrlConfig: {
                    shape: "S45"
                  },
                  jobExecutionsRolloutConfig: {
                    shape: "S48"
                  },
                  abortConfig: {
                    shape: "S4f"
                  },
                  createdAt: {
                    type: "timestamp"
                  },
                  lastUpdatedAt: {
                    type: "timestamp"
                  },
                  completedAt: {
                    type: "timestamp"
                  },
                  jobProcessDetails: {
                    type: "structure",
                    members: {
                      processingTargets: {
                        type: "list",
                        member: {}
                      },
                      numberOfCanceledThings: {
                        type: "integer"
                      },
                      numberOfSucceededThings: {
                        type: "integer"
                      },
                      numberOfFailedThings: {
                        type: "integer"
                      },
                      numberOfRejectedThings: {
                        type: "integer"
                      },
                      numberOfQueuedThings: {
                        type: "integer"
                      },
                      numberOfInProgressThings: {
                        type: "integer"
                      },
                      numberOfRemovedThings: {
                        type: "integer"
                      },
                      numberOfTimedOutThings: {
                        type: "integer"
                      }
                    }
                  },
                  timeoutConfig: {
                    shape: "S4m"
                  },
                  namespaceId: {},
                  jobTemplateArn: {}
                }
              }
            }
          }
        },
        DescribeJobExecution: {
          http: {
            method: "GET",
            requestUri: "/things/{thingName}/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "jobId",
              "thingName"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              executionNumber: {
                location: "querystring",
                locationName: "executionNumber",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              execution: {
                type: "structure",
                members: {
                  jobId: {},
                  status: {},
                  forceCanceled: {
                    type: "boolean"
                  },
                  statusDetails: {
                    type: "structure",
                    members: {
                      detailsMap: {
                        shape: "S1e"
                      }
                    }
                  },
                  thingArn: {},
                  queuedAt: {
                    type: "timestamp"
                  },
                  startedAt: {
                    type: "timestamp"
                  },
                  lastUpdatedAt: {
                    type: "timestamp"
                  },
                  executionNumber: {
                    type: "long"
                  },
                  versionNumber: {
                    type: "long"
                  },
                  approximateSecondsBeforeTimedOut: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        DescribeJobTemplate: {
          http: {
            method: "GET",
            requestUri: "/job-templates/{jobTemplateId}"
          },
          input: {
            type: "structure",
            required: [
              "jobTemplateId"
            ],
            members: {
              jobTemplateId: {
                location: "uri",
                locationName: "jobTemplateId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobTemplateArn: {},
              jobTemplateId: {},
              description: {},
              documentSource: {},
              document: {},
              createdAt: {
                type: "timestamp"
              },
              presignedUrlConfig: {
                shape: "S45"
              },
              jobExecutionsRolloutConfig: {
                shape: "S48"
              },
              abortConfig: {
                shape: "S4f"
              },
              timeoutConfig: {
                shape: "S4m"
              }
            }
          }
        },
        DescribeMitigationAction: {
          http: {
            method: "GET",
            requestUri: "/mitigationactions/actions/{actionName}"
          },
          input: {
            type: "structure",
            required: [
              "actionName"
            ],
            members: {
              actionName: {
                location: "uri",
                locationName: "actionName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              actionName: {},
              actionType: {},
              actionArn: {},
              actionId: {},
              roleArn: {},
              actionParams: {
                shape: "S50"
              },
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeProvisioningTemplate: {
          http: {
            method: "GET",
            requestUri: "/provisioning-templates/{templateName}"
          },
          input: {
            type: "structure",
            required: [
              "templateName"
            ],
            members: {
              templateName: {
                location: "uri",
                locationName: "templateName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              templateArn: {},
              templateName: {},
              description: {},
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              },
              defaultVersionId: {
                type: "integer"
              },
              templateBody: {},
              enabled: {
                type: "boolean"
              },
              provisioningRoleArn: {},
              preProvisioningHook: {
                shape: "S7p"
              }
            }
          }
        },
        DescribeProvisioningTemplateVersion: {
          http: {
            method: "GET",
            requestUri: "/provisioning-templates/{templateName}/versions/{versionId}"
          },
          input: {
            type: "structure",
            required: [
              "templateName",
              "versionId"
            ],
            members: {
              templateName: {
                location: "uri",
                locationName: "templateName"
              },
              versionId: {
                location: "uri",
                locationName: "versionId",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              versionId: {
                type: "integer"
              },
              creationDate: {
                type: "timestamp"
              },
              templateBody: {},
              isDefaultVersion: {
                type: "boolean"
              }
            }
          }
        },
        DescribeRoleAlias: {
          http: {
            method: "GET",
            requestUri: "/role-aliases/{roleAlias}"
          },
          input: {
            type: "structure",
            required: [
              "roleAlias"
            ],
            members: {
              roleAlias: {
                location: "uri",
                locationName: "roleAlias"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              roleAliasDescription: {
                type: "structure",
                members: {
                  roleAlias: {},
                  roleAliasArn: {},
                  roleArn: {},
                  owner: {},
                  credentialDurationSeconds: {
                    type: "integer"
                  },
                  creationDate: {
                    type: "timestamp"
                  },
                  lastModifiedDate: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeScheduledAudit: {
          http: {
            method: "GET",
            requestUri: "/audit/scheduledaudits/{scheduledAuditName}"
          },
          input: {
            type: "structure",
            required: [
              "scheduledAuditName"
            ],
            members: {
              scheduledAuditName: {
                location: "uri",
                locationName: "scheduledAuditName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              frequency: {},
              dayOfMonth: {},
              dayOfWeek: {},
              targetCheckNames: {
                shape: "S84"
              },
              scheduledAuditName: {},
              scheduledAuditArn: {}
            }
          }
        },
        DescribeSecurityProfile: {
          http: {
            method: "GET",
            requestUri: "/security-profiles/{securityProfileName}"
          },
          input: {
            type: "structure",
            required: [
              "securityProfileName"
            ],
            members: {
              securityProfileName: {
                location: "uri",
                locationName: "securityProfileName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              securityProfileName: {},
              securityProfileArn: {},
              securityProfileDescription: {},
              behaviors: {
                shape: "S8a"
              },
              alertTargets: {
                shape: "S90"
              },
              additionalMetricsToRetain: {
                shape: "S94",
                deprecated: true,
                deprecatedMessage: "Use additionalMetricsToRetainV2."
              },
              additionalMetricsToRetainV2: {
                shape: "S95"
              },
              version: {
                type: "long"
              },
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeStream: {
          http: {
            method: "GET",
            requestUri: "/streams/{streamId}"
          },
          input: {
            type: "structure",
            required: [
              "streamId"
            ],
            members: {
              streamId: {
                location: "uri",
                locationName: "streamId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              streamInfo: {
                type: "structure",
                members: {
                  streamId: {},
                  streamArn: {},
                  streamVersion: {
                    type: "integer"
                  },
                  description: {},
                  files: {
                    shape: "S9b"
                  },
                  createdAt: {
                    type: "timestamp"
                  },
                  lastUpdatedAt: {
                    type: "timestamp"
                  },
                  roleArn: {}
                }
              }
            }
          }
        },
        DescribeThing: {
          http: {
            method: "GET",
            requestUri: "/things/{thingName}"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              defaultClientId: {},
              thingName: {},
              thingId: {},
              thingArn: {},
              thingTypeName: {},
              attributes: {
                shape: "S3h"
              },
              version: {
                type: "long"
              },
              billingGroupName: {}
            }
          }
        },
        DescribeThingGroup: {
          http: {
            method: "GET",
            requestUri: "/thing-groups/{thingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "thingGroupName"
            ],
            members: {
              thingGroupName: {
                location: "uri",
                locationName: "thingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              thingGroupName: {},
              thingGroupId: {},
              thingGroupArn: {},
              version: {
                type: "long"
              },
              thingGroupProperties: {
                shape: "S3e"
              },
              thingGroupMetadata: {
                type: "structure",
                members: {
                  parentGroupName: {},
                  rootToParentThingGroups: {
                    shape: "Sju"
                  },
                  creationDate: {
                    type: "timestamp"
                  }
                }
              },
              indexName: {},
              queryString: {},
              queryVersion: {},
              status: {}
            }
          }
        },
        DescribeThingRegistrationTask: {
          http: {
            method: "GET",
            requestUri: "/thing-registration-tasks/{taskId}"
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskId: {},
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              },
              templateBody: {},
              inputFileBucket: {},
              inputFileKey: {},
              roleArn: {},
              status: {},
              message: {},
              successCount: {
                type: "integer"
              },
              failureCount: {
                type: "integer"
              },
              percentageProgress: {
                type: "integer"
              }
            }
          }
        },
        DescribeThingType: {
          http: {
            method: "GET",
            requestUri: "/thing-types/{thingTypeName}"
          },
          input: {
            type: "structure",
            required: [
              "thingTypeName"
            ],
            members: {
              thingTypeName: {
                location: "uri",
                locationName: "thingTypeName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              thingTypeName: {},
              thingTypeId: {},
              thingTypeArn: {},
              thingTypeProperties: {
                shape: "S9n"
              },
              thingTypeMetadata: {
                shape: "Sk7"
              }
            }
          }
        },
        DetachPolicy: {
          http: {
            requestUri: "/target-policies/{policyName}"
          },
          input: {
            type: "structure",
            required: [
              "policyName",
              "target"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              },
              target: {}
            }
          }
        },
        DetachPrincipalPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/principal-policies/{policyName}"
          },
          input: {
            type: "structure",
            required: [
              "policyName",
              "principal"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              },
              principal: {
                location: "header",
                locationName: "x-amzn-iot-principal"
              }
            }
          },
          deprecated: true
        },
        DetachSecurityProfile: {
          http: {
            method: "DELETE",
            requestUri: "/security-profiles/{securityProfileName}/targets"
          },
          input: {
            type: "structure",
            required: [
              "securityProfileName",
              "securityProfileTargetArn"
            ],
            members: {
              securityProfileName: {
                location: "uri",
                locationName: "securityProfileName"
              },
              securityProfileTargetArn: {
                location: "querystring",
                locationName: "securityProfileTargetArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DetachThingPrincipal: {
          http: {
            method: "DELETE",
            requestUri: "/things/{thingName}/principals"
          },
          input: {
            type: "structure",
            required: [
              "thingName",
              "principal"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              principal: {
                location: "header",
                locationName: "x-amzn-principal"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableTopicRule: {
          http: {
            requestUri: "/rules/{ruleName}/disable"
          },
          input: {
            type: "structure",
            required: [
              "ruleName"
            ],
            members: {
              ruleName: {
                location: "uri",
                locationName: "ruleName"
              }
            }
          }
        },
        EnableTopicRule: {
          http: {
            requestUri: "/rules/{ruleName}/enable"
          },
          input: {
            type: "structure",
            required: [
              "ruleName"
            ],
            members: {
              ruleName: {
                location: "uri",
                locationName: "ruleName"
              }
            }
          }
        },
        GetBehaviorModelTrainingSummaries: {
          http: {
            method: "GET",
            requestUri: "/behavior-model-training/summaries"
          },
          input: {
            type: "structure",
            members: {
              securityProfileName: {
                location: "querystring",
                locationName: "securityProfileName"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    securityProfileName: {},
                    behaviorName: {},
                    trainingDataCollectionStartDate: {
                      type: "timestamp"
                    },
                    modelStatus: {},
                    datapointsCollectionPercentage: {
                      type: "double"
                    },
                    lastModelRefreshDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetBucketsAggregation: {
          http: {
            requestUri: "/indices/buckets"
          },
          input: {
            type: "structure",
            required: [
              "queryString",
              "aggregationField",
              "bucketsAggregationType"
            ],
            members: {
              indexName: {},
              queryString: {},
              aggregationField: {},
              queryVersion: {},
              bucketsAggregationType: {
                type: "structure",
                members: {
                  termsAggregation: {
                    type: "structure",
                    members: {
                      maxBuckets: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              totalCount: {
                type: "integer"
              },
              buckets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    keyValue: {},
                    count: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        GetCardinality: {
          http: {
            requestUri: "/indices/cardinality"
          },
          input: {
            type: "structure",
            required: [
              "queryString"
            ],
            members: {
              indexName: {},
              queryString: {},
              aggregationField: {},
              queryVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              cardinality: {
                type: "integer"
              }
            }
          }
        },
        GetEffectivePolicies: {
          http: {
            requestUri: "/effective-policies"
          },
          input: {
            type: "structure",
            members: {
              principal: {},
              cognitoIdentityPoolId: {},
              thingName: {
                location: "querystring",
                locationName: "thingName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              effectivePolicies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    policyName: {},
                    policyArn: {},
                    policyDocument: {}
                  }
                }
              }
            }
          }
        },
        GetIndexingConfiguration: {
          http: {
            method: "GET",
            requestUri: "/indexing/config"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              thingIndexingConfiguration: {
                shape: "Sl6"
              },
              thingGroupIndexingConfiguration: {
                shape: "Sld"
              }
            }
          }
        },
        GetJobDocument: {
          http: {
            method: "GET",
            requestUri: "/jobs/{jobId}/job-document"
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              document: {}
            }
          }
        },
        GetLoggingOptions: {
          http: {
            method: "GET",
            requestUri: "/loggingOptions"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              roleArn: {},
              logLevel: {}
            }
          }
        },
        GetOTAUpdate: {
          http: {
            method: "GET",
            requestUri: "/otaUpdates/{otaUpdateId}"
          },
          input: {
            type: "structure",
            required: [
              "otaUpdateId"
            ],
            members: {
              otaUpdateId: {
                location: "uri",
                locationName: "otaUpdateId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              otaUpdateInfo: {
                type: "structure",
                members: {
                  otaUpdateId: {},
                  otaUpdateArn: {},
                  creationDate: {
                    type: "timestamp"
                  },
                  lastModifiedDate: {
                    type: "timestamp"
                  },
                  description: {},
                  targets: {
                    shape: "S5j"
                  },
                  protocols: {
                    shape: "S5l"
                  },
                  awsJobExecutionsRolloutConfig: {
                    shape: "S5n"
                  },
                  awsJobPresignedUrlConfig: {
                    shape: "S5u"
                  },
                  targetSelection: {},
                  otaUpdateFiles: {
                    shape: "S65"
                  },
                  otaUpdateStatus: {},
                  awsIotJobId: {},
                  awsIotJobArn: {},
                  errorInfo: {
                    type: "structure",
                    members: {
                      code: {},
                      message: {}
                    }
                  },
                  additionalParameters: {
                    shape: "S73"
                  }
                }
              }
            }
          }
        },
        GetPercentiles: {
          http: {
            requestUri: "/indices/percentiles"
          },
          input: {
            type: "structure",
            required: [
              "queryString"
            ],
            members: {
              indexName: {},
              queryString: {},
              aggregationField: {},
              queryVersion: {},
              percents: {
                type: "list",
                member: {
                  type: "double"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              percentiles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    percent: {
                      type: "double"
                    },
                    value: {
                      type: "double"
                    }
                  }
                }
              }
            }
          }
        },
        GetPolicy: {
          http: {
            method: "GET",
            requestUri: "/policies/{policyName}"
          },
          input: {
            type: "structure",
            required: [
              "policyName"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policyName: {},
              policyArn: {},
              policyDocument: {},
              defaultVersionId: {},
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              },
              generationId: {}
            }
          }
        },
        GetPolicyVersion: {
          http: {
            method: "GET",
            requestUri: "/policies/{policyName}/version/{policyVersionId}"
          },
          input: {
            type: "structure",
            required: [
              "policyName",
              "policyVersionId"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              },
              policyVersionId: {
                location: "uri",
                locationName: "policyVersionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policyArn: {},
              policyName: {},
              policyDocument: {},
              policyVersionId: {},
              isDefaultVersion: {
                type: "boolean"
              },
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              },
              generationId: {}
            }
          }
        },
        GetRegistrationCode: {
          http: {
            method: "GET",
            requestUri: "/registrationcode"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              registrationCode: {}
            }
          }
        },
        GetStatistics: {
          http: {
            requestUri: "/indices/statistics"
          },
          input: {
            type: "structure",
            required: [
              "queryString"
            ],
            members: {
              indexName: {},
              queryString: {},
              aggregationField: {},
              queryVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              statistics: {
                type: "structure",
                members: {
                  count: {
                    type: "integer"
                  },
                  average: {
                    type: "double"
                  },
                  sum: {
                    type: "double"
                  },
                  minimum: {
                    type: "double"
                  },
                  maximum: {
                    type: "double"
                  },
                  sumOfSquares: {
                    type: "double"
                  },
                  variance: {
                    type: "double"
                  },
                  stdDeviation: {
                    type: "double"
                  }
                }
              }
            }
          }
        },
        GetTopicRule: {
          http: {
            method: "GET",
            requestUri: "/rules/{ruleName}"
          },
          input: {
            type: "structure",
            required: [
              "ruleName"
            ],
            members: {
              ruleName: {
                location: "uri",
                locationName: "ruleName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ruleArn: {},
              rule: {
                type: "structure",
                members: {
                  ruleName: {},
                  sql: {},
                  description: {},
                  createdAt: {
                    type: "timestamp"
                  },
                  actions: {
                    shape: "S9y"
                  },
                  ruleDisabled: {
                    type: "boolean"
                  },
                  awsIotSqlVersion: {},
                  errorAction: {
                    shape: "S9z"
                  }
                }
              }
            }
          }
        },
        GetTopicRuleDestination: {
          http: {
            method: "GET",
            requestUri: "/destinations/{arn+}"
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {
                location: "uri",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              topicRuleDestination: {
                shape: "Sd2"
              }
            }
          }
        },
        GetV2LoggingOptions: {
          http: {
            method: "GET",
            requestUri: "/v2LoggingOptions"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              roleArn: {},
              defaultLogLevel: {},
              disableAllLogs: {
                type: "boolean"
              }
            }
          }
        },
        ListActiveViolations: {
          http: {
            method: "GET",
            requestUri: "/active-violations"
          },
          input: {
            type: "structure",
            members: {
              thingName: {
                location: "querystring",
                locationName: "thingName"
              },
              securityProfileName: {
                location: "querystring",
                locationName: "securityProfileName"
              },
              behaviorCriteriaType: {
                location: "querystring",
                locationName: "behaviorCriteriaType"
              },
              listSuppressedAlerts: {
                location: "querystring",
                locationName: "listSuppressedAlerts",
                type: "boolean"
              },
              verificationState: {
                location: "querystring",
                locationName: "verificationState"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              activeViolations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    violationId: {},
                    thingName: {},
                    securityProfileName: {},
                    behavior: {
                      shape: "S8b"
                    },
                    lastViolationValue: {
                      shape: "S8i"
                    },
                    violationEventAdditionalInfo: {
                      shape: "Smv"
                    },
                    verificationState: {},
                    verificationStateDescription: {},
                    lastViolationTime: {
                      type: "timestamp"
                    },
                    violationStartTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAttachedPolicies: {
          http: {
            requestUri: "/attached-policies/{target}"
          },
          input: {
            type: "structure",
            required: [
              "target"
            ],
            members: {
              target: {
                location: "uri",
                locationName: "target"
              },
              recursive: {
                location: "querystring",
                locationName: "recursive",
                type: "boolean"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policies: {
                shape: "Sn2"
              },
              nextMarker: {}
            }
          }
        },
        ListAuditFindings: {
          http: {
            requestUri: "/audit/findings"
          },
          input: {
            type: "structure",
            members: {
              taskId: {},
              checkName: {},
              resourceIdentifier: {
                shape: "S1o"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              listSuppressedFindings: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              findings: {
                type: "list",
                member: {
                  shape: "Sfa"
                }
              },
              nextToken: {}
            }
          }
        },
        ListAuditMitigationActionsExecutions: {
          http: {
            method: "GET",
            requestUri: "/audit/mitigationactions/executions"
          },
          input: {
            type: "structure",
            required: [
              "taskId",
              "findingId"
            ],
            members: {
              taskId: {
                location: "querystring",
                locationName: "taskId"
              },
              actionStatus: {
                location: "querystring",
                locationName: "actionStatus"
              },
              findingId: {
                location: "querystring",
                locationName: "findingId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              actionsExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    taskId: {},
                    findingId: {},
                    actionName: {},
                    actionId: {},
                    status: {},
                    startTime: {
                      type: "timestamp"
                    },
                    endTime: {
                      type: "timestamp"
                    },
                    errorCode: {},
                    message: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAuditMitigationActionsTasks: {
          http: {
            method: "GET",
            requestUri: "/audit/mitigationactions/tasks"
          },
          input: {
            type: "structure",
            required: [
              "startTime",
              "endTime"
            ],
            members: {
              auditTaskId: {
                location: "querystring",
                locationName: "auditTaskId"
              },
              findingId: {
                location: "querystring",
                locationName: "findingId"
              },
              taskStatus: {
                location: "querystring",
                locationName: "taskStatus"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              startTime: {
                location: "querystring",
                locationName: "startTime",
                type: "timestamp"
              },
              endTime: {
                location: "querystring",
                locationName: "endTime",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tasks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    taskId: {},
                    startTime: {
                      type: "timestamp"
                    },
                    taskStatus: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAuditSuppressions: {
          http: {
            requestUri: "/audit/suppressions/list"
          },
          input: {
            type: "structure",
            members: {
              checkName: {},
              resourceIdentifier: {
                shape: "S1o"
              },
              ascendingOrder: {
                type: "boolean"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              suppressions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "checkName",
                    "resourceIdentifier"
                  ],
                  members: {
                    checkName: {},
                    resourceIdentifier: {
                      shape: "S1o"
                    },
                    expirationDate: {
                      type: "timestamp"
                    },
                    suppressIndefinitely: {
                      type: "boolean"
                    },
                    description: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAuditTasks: {
          http: {
            method: "GET",
            requestUri: "/audit/tasks"
          },
          input: {
            type: "structure",
            required: [
              "startTime",
              "endTime"
            ],
            members: {
              startTime: {
                location: "querystring",
                locationName: "startTime",
                type: "timestamp"
              },
              endTime: {
                location: "querystring",
                locationName: "endTime",
                type: "timestamp"
              },
              taskType: {
                location: "querystring",
                locationName: "taskType"
              },
              taskStatus: {
                location: "querystring",
                locationName: "taskStatus"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tasks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    taskId: {},
                    taskStatus: {},
                    taskType: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAuthorizers: {
          http: {
            method: "GET",
            requestUri: "/authorizers/"
          },
          input: {
            type: "structure",
            members: {
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              },
              status: {
                location: "querystring",
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              authorizers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    authorizerName: {},
                    authorizerArn: {}
                  }
                }
              },
              nextMarker: {}
            }
          }
        },
        ListBillingGroups: {
          http: {
            method: "GET",
            requestUri: "/billing-groups"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              namePrefixFilter: {
                location: "querystring",
                locationName: "namePrefixFilter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              billingGroups: {
                type: "list",
                member: {
                  shape: "Sjv"
                }
              },
              nextToken: {}
            }
          }
        },
        ListCACertificates: {
          http: {
            method: "GET",
            requestUri: "/cacertificates"
          },
          input: {
            type: "structure",
            members: {
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    certificateArn: {},
                    certificateId: {},
                    status: {},
                    creationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextMarker: {}
            }
          }
        },
        ListCertificates: {
          http: {
            method: "GET",
            requestUri: "/certificates"
          },
          input: {
            type: "structure",
            members: {
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificates: {
                shape: "So4"
              },
              nextMarker: {}
            }
          }
        },
        ListCertificatesByCA: {
          http: {
            method: "GET",
            requestUri: "/certificates-by-ca/{caCertificateId}"
          },
          input: {
            type: "structure",
            required: [
              "caCertificateId"
            ],
            members: {
              caCertificateId: {
                location: "uri",
                locationName: "caCertificateId"
              },
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificates: {
                shape: "So4"
              },
              nextMarker: {}
            }
          }
        },
        ListCustomMetrics: {
          http: {
            method: "GET",
            requestUri: "/custom-metrics"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricNames: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        ListDetectMitigationActionsExecutions: {
          http: {
            method: "GET",
            requestUri: "/detect/mitigationactions/executions"
          },
          input: {
            type: "structure",
            members: {
              taskId: {
                location: "querystring",
                locationName: "taskId"
              },
              violationId: {
                location: "querystring",
                locationName: "violationId"
              },
              thingName: {
                location: "querystring",
                locationName: "thingName"
              },
              startTime: {
                location: "querystring",
                locationName: "startTime",
                type: "timestamp"
              },
              endTime: {
                location: "querystring",
                locationName: "endTime",
                type: "timestamp"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              actionsExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    taskId: {},
                    violationId: {},
                    actionName: {},
                    thingName: {},
                    executionStartDate: {
                      type: "timestamp"
                    },
                    executionEndDate: {
                      type: "timestamp"
                    },
                    status: {},
                    errorCode: {},
                    message: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDetectMitigationActionsTasks: {
          http: {
            method: "GET",
            requestUri: "/detect/mitigationactions/tasks"
          },
          input: {
            type: "structure",
            required: [
              "startTime",
              "endTime"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              startTime: {
                location: "querystring",
                locationName: "startTime",
                type: "timestamp"
              },
              endTime: {
                location: "querystring",
                locationName: "endTime",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tasks: {
                type: "list",
                member: {
                  shape: "Shj"
                }
              },
              nextToken: {}
            }
          }
        },
        ListDimensions: {
          http: {
            method: "GET",
            requestUri: "/dimensions"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dimensionNames: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        ListDomainConfigurations: {
          http: {
            method: "GET",
            requestUri: "/domainConfigurations"
          },
          input: {
            type: "structure",
            members: {
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              },
              serviceType: {
                location: "querystring",
                locationName: "serviceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              domainConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    domainConfigurationName: {},
                    domainConfigurationArn: {},
                    serviceType: {}
                  }
                }
              },
              nextMarker: {}
            }
          }
        },
        ListFleetMetrics: {
          http: {
            method: "GET",
            requestUri: "/fleet-metrics"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              fleetMetrics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    metricName: {},
                    metricArn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListIndices: {
          http: {
            method: "GET",
            requestUri: "/indices"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              indexNames: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        ListJobExecutionsForJob: {
          http: {
            method: "GET",
            requestUri: "/jobs/{jobId}/things"
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              status: {
                location: "querystring",
                locationName: "status"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              executionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    thingArn: {},
                    jobExecutionSummary: {
                      shape: "Sp4"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListJobExecutionsForThing: {
          http: {
            method: "GET",
            requestUri: "/things/{thingName}/jobs"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              status: {
                location: "querystring",
                locationName: "status"
              },
              namespaceId: {
                location: "querystring",
                locationName: "namespaceId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              executionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    jobId: {},
                    jobExecutionSummary: {
                      shape: "Sp4"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListJobTemplates: {
          http: {
            method: "GET",
            requestUri: "/job-templates"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobTemplates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    jobTemplateArn: {},
                    jobTemplateId: {},
                    description: {},
                    createdAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListJobs: {
          http: {
            method: "GET",
            requestUri: "/jobs"
          },
          input: {
            type: "structure",
            members: {
              status: {
                location: "querystring",
                locationName: "status"
              },
              targetSelection: {
                location: "querystring",
                locationName: "targetSelection"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              thingGroupName: {
                location: "querystring",
                locationName: "thingGroupName"
              },
              thingGroupId: {
                location: "querystring",
                locationName: "thingGroupId"
              },
              namespaceId: {
                location: "querystring",
                locationName: "namespaceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    jobArn: {},
                    jobId: {},
                    thingGroupId: {},
                    targetSelection: {},
                    status: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    completedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListMitigationActions: {
          http: {
            method: "GET",
            requestUri: "/mitigationactions/actions"
          },
          input: {
            type: "structure",
            members: {
              actionType: {
                location: "querystring",
                locationName: "actionType"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              actionIdentifiers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    actionName: {},
                    actionArn: {},
                    creationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListOTAUpdates: {
          http: {
            method: "GET",
            requestUri: "/otaUpdates"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              otaUpdateStatus: {
                location: "querystring",
                locationName: "otaUpdateStatus"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              otaUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    otaUpdateId: {},
                    otaUpdateArn: {},
                    creationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListOutgoingCertificates: {
          http: {
            method: "GET",
            requestUri: "/certificates-out-going"
          },
          input: {
            type: "structure",
            members: {
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              outgoingCertificates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    certificateArn: {},
                    certificateId: {},
                    transferredTo: {},
                    transferDate: {
                      type: "timestamp"
                    },
                    transferMessage: {},
                    creationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextMarker: {}
            }
          }
        },
        ListPolicies: {
          http: {
            method: "GET",
            requestUri: "/policies"
          },
          input: {
            type: "structure",
            members: {
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policies: {
                shape: "Sn2"
              },
              nextMarker: {}
            }
          }
        },
        ListPolicyPrincipals: {
          http: {
            method: "GET",
            requestUri: "/policy-principals"
          },
          input: {
            type: "structure",
            required: [
              "policyName"
            ],
            members: {
              policyName: {
                location: "header",
                locationName: "x-amzn-iot-policy"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              principals: {
                shape: "Spx"
              },
              nextMarker: {}
            }
          },
          deprecated: true
        },
        ListPolicyVersions: {
          http: {
            method: "GET",
            requestUri: "/policies/{policyName}/version"
          },
          input: {
            type: "structure",
            required: [
              "policyName"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policyVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    versionId: {},
                    isDefaultVersion: {
                      type: "boolean"
                    },
                    createDate: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListPrincipalPolicies: {
          http: {
            method: "GET",
            requestUri: "/principal-policies"
          },
          input: {
            type: "structure",
            required: [
              "principal"
            ],
            members: {
              principal: {
                location: "header",
                locationName: "x-amzn-iot-principal"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policies: {
                shape: "Sn2"
              },
              nextMarker: {}
            }
          },
          deprecated: true
        },
        ListPrincipalThings: {
          http: {
            method: "GET",
            requestUri: "/principals/things"
          },
          input: {
            type: "structure",
            required: [
              "principal"
            ],
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              principal: {
                location: "header",
                locationName: "x-amzn-principal"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              things: {
                shape: "Sq7"
              },
              nextToken: {}
            }
          }
        },
        ListProvisioningTemplateVersions: {
          http: {
            method: "GET",
            requestUri: "/provisioning-templates/{templateName}/versions"
          },
          input: {
            type: "structure",
            required: [
              "templateName"
            ],
            members: {
              templateName: {
                location: "uri",
                locationName: "templateName"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              versions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    versionId: {
                      type: "integer"
                    },
                    creationDate: {
                      type: "timestamp"
                    },
                    isDefaultVersion: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListProvisioningTemplates: {
          http: {
            method: "GET",
            requestUri: "/provisioning-templates"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              templates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    templateArn: {},
                    templateName: {},
                    description: {},
                    creationDate: {
                      type: "timestamp"
                    },
                    lastModifiedDate: {
                      type: "timestamp"
                    },
                    enabled: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRoleAliases: {
          http: {
            method: "GET",
            requestUri: "/role-aliases"
          },
          input: {
            type: "structure",
            members: {
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              roleAliases: {
                type: "list",
                member: {}
              },
              nextMarker: {}
            }
          }
        },
        ListScheduledAudits: {
          http: {
            method: "GET",
            requestUri: "/audit/scheduledaudits"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              scheduledAudits: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    scheduledAuditName: {},
                    scheduledAuditArn: {},
                    frequency: {},
                    dayOfMonth: {},
                    dayOfWeek: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSecurityProfiles: {
          http: {
            method: "GET",
            requestUri: "/security-profiles"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              dimensionName: {
                location: "querystring",
                locationName: "dimensionName"
              },
              metricName: {
                location: "querystring",
                locationName: "metricName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              securityProfileIdentifiers: {
                type: "list",
                member: {
                  shape: "Sqq"
                }
              },
              nextToken: {}
            }
          }
        },
        ListSecurityProfilesForTarget: {
          http: {
            method: "GET",
            requestUri: "/security-profiles-for-target"
          },
          input: {
            type: "structure",
            required: [
              "securityProfileTargetArn"
            ],
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              recursive: {
                location: "querystring",
                locationName: "recursive",
                type: "boolean"
              },
              securityProfileTargetArn: {
                location: "querystring",
                locationName: "securityProfileTargetArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              securityProfileTargetMappings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    securityProfileIdentifier: {
                      shape: "Sqq"
                    },
                    target: {
                      shape: "Sqv"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListStreams: {
          http: {
            method: "GET",
            requestUri: "/streams"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ascendingOrder: {
                location: "querystring",
                locationName: "isAscendingOrder",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              streams: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    streamId: {},
                    streamArn: {},
                    streamVersion: {
                      type: "integer"
                    },
                    description: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S29"
              },
              nextToken: {}
            }
          }
        },
        ListTargetsForPolicy: {
          http: {
            requestUri: "/policy-targets/{policyName}"
          },
          input: {
            type: "structure",
            required: [
              "policyName"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              },
              marker: {
                location: "querystring",
                locationName: "marker"
              },
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              targets: {
                type: "list",
                member: {}
              },
              nextMarker: {}
            }
          }
        },
        ListTargetsForSecurityProfile: {
          http: {
            method: "GET",
            requestUri: "/security-profiles/{securityProfileName}/targets"
          },
          input: {
            type: "structure",
            required: [
              "securityProfileName"
            ],
            members: {
              securityProfileName: {
                location: "uri",
                locationName: "securityProfileName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              securityProfileTargets: {
                type: "list",
                member: {
                  shape: "Sqv"
                }
              },
              nextToken: {}
            }
          }
        },
        ListThingGroups: {
          http: {
            method: "GET",
            requestUri: "/thing-groups"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              parentGroup: {
                location: "querystring",
                locationName: "parentGroup"
              },
              namePrefixFilter: {
                location: "querystring",
                locationName: "namePrefixFilter"
              },
              recursive: {
                location: "querystring",
                locationName: "recursive",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              thingGroups: {
                shape: "Sju"
              },
              nextToken: {}
            }
          }
        },
        ListThingGroupsForThing: {
          http: {
            method: "GET",
            requestUri: "/things/{thingName}/thing-groups"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              thingGroups: {
                shape: "Sju"
              },
              nextToken: {}
            }
          }
        },
        ListThingPrincipals: {
          http: {
            method: "GET",
            requestUri: "/things/{thingName}/principals"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              thingName: {
                location: "uri",
                locationName: "thingName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              principals: {
                shape: "Spx"
              },
              nextToken: {}
            }
          }
        },
        ListThingRegistrationTaskReports: {
          http: {
            method: "GET",
            requestUri: "/thing-registration-tasks/{taskId}/reports"
          },
          input: {
            type: "structure",
            required: [
              "taskId",
              "reportType"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              },
              reportType: {
                location: "querystring",
                locationName: "reportType"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceLinks: {
                type: "list",
                member: {}
              },
              reportType: {},
              nextToken: {}
            }
          }
        },
        ListThingRegistrationTasks: {
          http: {
            method: "GET",
            requestUri: "/thing-registration-tasks"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              status: {
                location: "querystring",
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskIds: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        ListThingTypes: {
          http: {
            method: "GET",
            requestUri: "/thing-types"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              thingTypeName: {
                location: "querystring",
                locationName: "thingTypeName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              thingTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    thingTypeName: {},
                    thingTypeArn: {},
                    thingTypeProperties: {
                      shape: "S9n"
                    },
                    thingTypeMetadata: {
                      shape: "Sk7"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListThings: {
          http: {
            method: "GET",
            requestUri: "/things"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              attributeName: {
                location: "querystring",
                locationName: "attributeName"
              },
              attributeValue: {
                location: "querystring",
                locationName: "attributeValue"
              },
              thingTypeName: {
                location: "querystring",
                locationName: "thingTypeName"
              },
              usePrefixAttributeValue: {
                location: "querystring",
                locationName: "usePrefixAttributeValue",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              things: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    thingName: {},
                    thingTypeName: {},
                    thingArn: {},
                    attributes: {
                      shape: "S3h"
                    },
                    version: {
                      type: "long"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListThingsInBillingGroup: {
          http: {
            method: "GET",
            requestUri: "/billing-groups/{billingGroupName}/things"
          },
          input: {
            type: "structure",
            required: [
              "billingGroupName"
            ],
            members: {
              billingGroupName: {
                location: "uri",
                locationName: "billingGroupName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              things: {
                shape: "Sq7"
              },
              nextToken: {}
            }
          }
        },
        ListThingsInThingGroup: {
          http: {
            method: "GET",
            requestUri: "/thing-groups/{thingGroupName}/things"
          },
          input: {
            type: "structure",
            required: [
              "thingGroupName"
            ],
            members: {
              thingGroupName: {
                location: "uri",
                locationName: "thingGroupName"
              },
              recursive: {
                location: "querystring",
                locationName: "recursive",
                type: "boolean"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              things: {
                shape: "Sq7"
              },
              nextToken: {}
            }
          }
        },
        ListTopicRuleDestinations: {
          http: {
            method: "GET",
            requestUri: "/destinations"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              destinationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    status: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    statusReason: {},
                    httpUrlSummary: {
                      type: "structure",
                      members: {
                        confirmationUrl: {}
                      }
                    },
                    vpcDestinationSummary: {
                      type: "structure",
                      members: {
                        subnetIds: {
                          shape: "Scw"
                        },
                        securityGroups: {
                          shape: "Scy"
                        },
                        vpcId: {},
                        roleArn: {}
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTopicRules: {
          http: {
            method: "GET",
            requestUri: "/rules"
          },
          input: {
            type: "structure",
            members: {
              topic: {
                location: "querystring",
                locationName: "topic"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ruleDisabled: {
                location: "querystring",
                locationName: "ruleDisabled",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              rules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ruleArn: {},
                    ruleName: {},
                    topicPattern: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    ruleDisabled: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListV2LoggingLevels: {
          http: {
            method: "GET",
            requestUri: "/v2LoggingLevel"
          },
          input: {
            type: "structure",
            members: {
              targetType: {
                location: "querystring",
                locationName: "targetType"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              logTargetConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    logTarget: {
                      shape: "Ssj"
                    },
                    logLevel: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListViolationEvents: {
          http: {
            method: "GET",
            requestUri: "/violation-events"
          },
          input: {
            type: "structure",
            required: [
              "startTime",
              "endTime"
            ],
            members: {
              startTime: {
                location: "querystring",
                locationName: "startTime",
                type: "timestamp"
              },
              endTime: {
                location: "querystring",
                locationName: "endTime",
                type: "timestamp"
              },
              thingName: {
                location: "querystring",
                locationName: "thingName"
              },
              securityProfileName: {
                location: "querystring",
                locationName: "securityProfileName"
              },
              behaviorCriteriaType: {
                location: "querystring",
                locationName: "behaviorCriteriaType"
              },
              listSuppressedAlerts: {
                location: "querystring",
                locationName: "listSuppressedAlerts",
                type: "boolean"
              },
              verificationState: {
                location: "querystring",
                locationName: "verificationState"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              violationEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    violationId: {},
                    thingName: {},
                    securityProfileName: {},
                    behavior: {
                      shape: "S8b"
                    },
                    metricValue: {
                      shape: "S8i"
                    },
                    violationEventAdditionalInfo: {
                      shape: "Smv"
                    },
                    violationEventType: {},
                    verificationState: {},
                    verificationStateDescription: {},
                    violationEventTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        PutVerificationStateOnViolation: {
          http: {
            requestUri: "/violations/verification-state/{violationId}"
          },
          input: {
            type: "structure",
            required: [
              "violationId",
              "verificationState"
            ],
            members: {
              violationId: {
                location: "uri",
                locationName: "violationId"
              },
              verificationState: {},
              verificationStateDescription: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RegisterCACertificate: {
          http: {
            requestUri: "/cacertificate"
          },
          input: {
            type: "structure",
            required: [
              "caCertificate",
              "verificationCertificate"
            ],
            members: {
              caCertificate: {},
              verificationCertificate: {},
              setAsActive: {
                location: "querystring",
                locationName: "setAsActive",
                type: "boolean"
              },
              allowAutoRegistration: {
                location: "querystring",
                locationName: "allowAutoRegistration",
                type: "boolean"
              },
              registrationConfig: {
                shape: "Sh5"
              },
              tags: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificateArn: {},
              certificateId: {}
            }
          }
        },
        RegisterCertificate: {
          http: {
            requestUri: "/certificate/register"
          },
          input: {
            type: "structure",
            required: [
              "certificatePem"
            ],
            members: {
              certificatePem: {},
              caCertificatePem: {},
              setAsActive: {
                deprecated: true,
                location: "querystring",
                locationName: "setAsActive",
                type: "boolean"
              },
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              certificateArn: {},
              certificateId: {}
            }
          }
        },
        RegisterCertificateWithoutCA: {
          http: {
            requestUri: "/certificate/register-no-ca"
          },
          input: {
            type: "structure",
            required: [
              "certificatePem"
            ],
            members: {
              certificatePem: {},
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              certificateArn: {},
              certificateId: {}
            }
          }
        },
        RegisterThing: {
          http: {
            requestUri: "/things"
          },
          input: {
            type: "structure",
            required: [
              "templateBody"
            ],
            members: {
              templateBody: {},
              parameters: {
                type: "map",
                key: {},
                value: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificatePem: {},
              resourceArns: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        RejectCertificateTransfer: {
          http: {
            method: "PATCH",
            requestUri: "/reject-certificate-transfer/{certificateId}"
          },
          input: {
            type: "structure",
            required: [
              "certificateId"
            ],
            members: {
              certificateId: {
                location: "uri",
                locationName: "certificateId"
              },
              rejectReason: {}
            }
          }
        },
        RemoveThingFromBillingGroup: {
          http: {
            method: "PUT",
            requestUri: "/billing-groups/removeThingFromBillingGroup"
          },
          input: {
            type: "structure",
            members: {
              billingGroupName: {},
              billingGroupArn: {},
              thingName: {},
              thingArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RemoveThingFromThingGroup: {
          http: {
            method: "PUT",
            requestUri: "/thing-groups/removeThingFromThingGroup"
          },
          input: {
            type: "structure",
            members: {
              thingGroupName: {},
              thingGroupArn: {},
              thingName: {},
              thingArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ReplaceTopicRule: {
          http: {
            method: "PATCH",
            requestUri: "/rules/{ruleName}"
          },
          input: {
            type: "structure",
            required: [
              "ruleName",
              "topicRulePayload"
            ],
            members: {
              ruleName: {
                location: "uri",
                locationName: "ruleName"
              },
              topicRulePayload: {
                shape: "S9v"
              }
            },
            payload: "topicRulePayload"
          }
        },
        SearchIndex: {
          http: {
            requestUri: "/indices/search"
          },
          input: {
            type: "structure",
            required: [
              "queryString"
            ],
            members: {
              indexName: {},
              queryString: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              queryVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              things: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    thingName: {},
                    thingId: {},
                    thingTypeName: {},
                    thingGroupNames: {
                      shape: "Stf"
                    },
                    attributes: {
                      shape: "S3h"
                    },
                    shadow: {},
                    connectivity: {
                      type: "structure",
                      members: {
                        connected: {
                          type: "boolean"
                        },
                        timestamp: {
                          type: "long"
                        },
                        disconnectReason: {}
                      }
                    }
                  }
                }
              },
              thingGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    thingGroupName: {},
                    thingGroupId: {},
                    thingGroupDescription: {},
                    attributes: {
                      shape: "S3h"
                    },
                    parentGroupNames: {
                      shape: "Stf"
                    }
                  }
                }
              }
            }
          }
        },
        SetDefaultAuthorizer: {
          http: {
            requestUri: "/default-authorizer"
          },
          input: {
            type: "structure",
            required: [
              "authorizerName"
            ],
            members: {
              authorizerName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              authorizerName: {},
              authorizerArn: {}
            }
          }
        },
        SetDefaultPolicyVersion: {
          http: {
            method: "PATCH",
            requestUri: "/policies/{policyName}/version/{policyVersionId}"
          },
          input: {
            type: "structure",
            required: [
              "policyName",
              "policyVersionId"
            ],
            members: {
              policyName: {
                location: "uri",
                locationName: "policyName"
              },
              policyVersionId: {
                location: "uri",
                locationName: "policyVersionId"
              }
            }
          }
        },
        SetLoggingOptions: {
          http: {
            requestUri: "/loggingOptions"
          },
          input: {
            type: "structure",
            required: [
              "loggingOptionsPayload"
            ],
            members: {
              loggingOptionsPayload: {
                type: "structure",
                required: [
                  "roleArn"
                ],
                members: {
                  roleArn: {},
                  logLevel: {}
                }
              }
            },
            payload: "loggingOptionsPayload"
          }
        },
        SetV2LoggingLevel: {
          http: {
            requestUri: "/v2LoggingLevel"
          },
          input: {
            type: "structure",
            required: [
              "logTarget",
              "logLevel"
            ],
            members: {
              logTarget: {
                shape: "Ssj"
              },
              logLevel: {}
            }
          }
        },
        SetV2LoggingOptions: {
          http: {
            requestUri: "/v2LoggingOptions"
          },
          input: {
            type: "structure",
            members: {
              roleArn: {},
              defaultLogLevel: {},
              disableAllLogs: {
                type: "boolean"
              }
            }
          }
        },
        StartAuditMitigationActionsTask: {
          http: {
            requestUri: "/audit/mitigationactions/tasks/{taskId}"
          },
          input: {
            type: "structure",
            required: [
              "taskId",
              "target",
              "auditCheckToActionsMapping",
              "clientRequestToken"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              },
              target: {
                shape: "Sfu"
              },
              auditCheckToActionsMapping: {
                shape: "Sfy"
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskId: {}
            }
          }
        },
        StartDetectMitigationActionsTask: {
          http: {
            method: "PUT",
            requestUri: "/detect/mitigationactions/tasks/{taskId}"
          },
          input: {
            type: "structure",
            required: [
              "taskId",
              "target",
              "actions",
              "clientRequestToken"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              },
              target: {
                shape: "Shl"
              },
              actions: {
                type: "list",
                member: {}
              },
              violationEventOccurrenceRange: {
                shape: "Sho"
              },
              includeOnlyActiveViolations: {
                type: "boolean"
              },
              includeSuppressedAlerts: {
                type: "boolean"
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskId: {}
            }
          }
        },
        StartOnDemandAuditTask: {
          http: {
            requestUri: "/audit/tasks"
          },
          input: {
            type: "structure",
            required: [
              "targetCheckNames"
            ],
            members: {
              targetCheckNames: {
                shape: "S84"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskId: {}
            }
          }
        },
        StartThingRegistrationTask: {
          http: {
            requestUri: "/thing-registration-tasks"
          },
          input: {
            type: "structure",
            required: [
              "templateBody",
              "inputFileBucket",
              "inputFileKey",
              "roleArn"
            ],
            members: {
              templateBody: {},
              inputFileBucket: {},
              inputFileKey: {},
              roleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              taskId: {}
            }
          }
        },
        StopThingRegistrationTask: {
          http: {
            method: "PUT",
            requestUri: "/thing-registration-tasks/{taskId}/cancel"
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TestAuthorization: {
          http: {
            requestUri: "/test-authorization"
          },
          input: {
            type: "structure",
            required: [
              "authInfos"
            ],
            members: {
              principal: {},
              cognitoIdentityPoolId: {},
              authInfos: {
                type: "list",
                member: {
                  shape: "Su9"
                }
              },
              clientId: {
                location: "querystring",
                locationName: "clientId"
              },
              policyNamesToAdd: {
                shape: "Sud"
              },
              policyNamesToSkip: {
                shape: "Sud"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              authResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    authInfo: {
                      shape: "Su9"
                    },
                    allowed: {
                      type: "structure",
                      members: {
                        policies: {
                          shape: "Sn2"
                        }
                      }
                    },
                    denied: {
                      type: "structure",
                      members: {
                        implicitDeny: {
                          type: "structure",
                          members: {
                            policies: {
                              shape: "Sn2"
                            }
                          }
                        },
                        explicitDeny: {
                          type: "structure",
                          members: {
                            policies: {
                              shape: "Sn2"
                            }
                          }
                        }
                      }
                    },
                    authDecision: {},
                    missingContextValues: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        TestInvokeAuthorizer: {
          http: {
            requestUri: "/authorizer/{authorizerName}/test"
          },
          input: {
            type: "structure",
            required: [
              "authorizerName"
            ],
            members: {
              authorizerName: {
                location: "uri",
                locationName: "authorizerName"
              },
              token: {},
              tokenSignature: {},
              httpContext: {
                type: "structure",
                members: {
                  headers: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  queryString: {}
                }
              },
              mqttContext: {
                type: "structure",
                members: {
                  username: {},
                  password: {
                    type: "blob"
                  },
                  clientId: {}
                }
              },
              tlsContext: {
                type: "structure",
                members: {
                  serverName: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              isAuthenticated: {
                type: "boolean"
              },
              principalId: {},
              policyDocuments: {
                type: "list",
                member: {}
              },
              refreshAfterInSeconds: {
                type: "integer"
              },
              disconnectAfterInSeconds: {
                type: "integer"
              }
            }
          }
        },
        TransferCertificate: {
          http: {
            method: "PATCH",
            requestUri: "/transfer-certificate/{certificateId}"
          },
          input: {
            type: "structure",
            required: [
              "certificateId",
              "targetAwsAccount"
            ],
            members: {
              certificateId: {
                location: "uri",
                locationName: "certificateId"
              },
              targetAwsAccount: {
                location: "querystring",
                locationName: "targetAwsAccount"
              },
              transferMessage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              transferredCertificateArn: {}
            }
          }
        },
        UntagResource: {
          http: {
            requestUri: "/untag"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAccountAuditConfiguration: {
          http: {
            method: "PATCH",
            requestUri: "/audit/configuration"
          },
          input: {
            type: "structure",
            members: {
              roleArn: {},
              auditNotificationTargetConfigurations: {
                shape: "Sf2"
              },
              auditCheckConfigurations: {
                shape: "Sf5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAuditSuppression: {
          http: {
            method: "PATCH",
            requestUri: "/audit/suppressions/update"
          },
          input: {
            type: "structure",
            required: [
              "checkName",
              "resourceIdentifier"
            ],
            members: {
              checkName: {},
              resourceIdentifier: {
                shape: "S1o"
              },
              expirationDate: {
                type: "timestamp"
              },
              suppressIndefinitely: {
                type: "boolean"
              },
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAuthorizer: {
          http: {
            method: "PUT",
            requestUri: "/authorizer/{authorizerName}"
          },
          input: {
            type: "structure",
            required: [
              "authorizerName"
            ],
            members: {
              authorizerName: {
                location: "uri",
                locationName: "authorizerName"
              },
              authorizerFunctionArn: {},
              tokenKeyName: {},
              tokenSigningPublicKeys: {
                shape: "S25"
              },
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              authorizerName: {},
              authorizerArn: {}
            }
          }
        },
        UpdateBillingGroup: {
          http: {
            method: "PATCH",
            requestUri: "/billing-groups/{billingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "billingGroupName",
              "billingGroupProperties"
            ],
            members: {
              billingGroupName: {
                location: "uri",
                locationName: "billingGroupName"
              },
              billingGroupProperties: {
                shape: "S2h"
              },
              expectedVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              version: {
                type: "long"
              }
            }
          }
        },
        UpdateCACertificate: {
          http: {
            method: "PUT",
            requestUri: "/cacertificate/{caCertificateId}"
          },
          input: {
            type: "structure",
            required: [
              "certificateId"
            ],
            members: {
              certificateId: {
                location: "uri",
                locationName: "caCertificateId"
              },
              newStatus: {
                location: "querystring",
                locationName: "newStatus"
              },
              newAutoRegistrationStatus: {
                location: "querystring",
                locationName: "newAutoRegistrationStatus"
              },
              registrationConfig: {
                shape: "Sh5"
              },
              removeAutoRegistration: {
                type: "boolean"
              }
            }
          }
        },
        UpdateCertificate: {
          http: {
            method: "PUT",
            requestUri: "/certificates/{certificateId}"
          },
          input: {
            type: "structure",
            required: [
              "certificateId",
              "newStatus"
            ],
            members: {
              certificateId: {
                location: "uri",
                locationName: "certificateId"
              },
              newStatus: {
                location: "querystring",
                locationName: "newStatus"
              }
            }
          }
        },
        UpdateCustomMetric: {
          http: {
            method: "PATCH",
            requestUri: "/custom-metric/{metricName}"
          },
          input: {
            type: "structure",
            required: [
              "metricName",
              "displayName"
            ],
            members: {
              metricName: {
                location: "uri",
                locationName: "metricName"
              },
              displayName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              metricArn: {},
              metricType: {},
              displayName: {},
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateDimension: {
          http: {
            method: "PATCH",
            requestUri: "/dimensions/{name}"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "stringValues"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              stringValues: {
                shape: "S2z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              arn: {},
              type: {},
              stringValues: {
                shape: "S2z"
              },
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateDomainConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/domainConfigurations/{domainConfigurationName}"
          },
          input: {
            type: "structure",
            required: [
              "domainConfigurationName"
            ],
            members: {
              domainConfigurationName: {
                location: "uri",
                locationName: "domainConfigurationName"
              },
              authorizerConfig: {
                shape: "S38"
              },
              domainConfigurationStatus: {},
              removeAuthorizerConfig: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              domainConfigurationName: {},
              domainConfigurationArn: {}
            }
          }
        },
        UpdateDynamicThingGroup: {
          http: {
            method: "PATCH",
            requestUri: "/dynamic-thing-groups/{thingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "thingGroupName",
              "thingGroupProperties"
            ],
            members: {
              thingGroupName: {
                location: "uri",
                locationName: "thingGroupName"
              },
              thingGroupProperties: {
                shape: "S3e"
              },
              expectedVersion: {
                type: "long"
              },
              indexName: {},
              queryString: {},
              queryVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              version: {
                type: "long"
              }
            }
          }
        },
        UpdateEventConfigurations: {
          http: {
            method: "PATCH",
            requestUri: "/event-configurations"
          },
          input: {
            type: "structure",
            members: {
              eventConfigurations: {
                shape: "Si9"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateFleetMetric: {
          http: {
            method: "PATCH",
            requestUri: "/fleet-metric/{metricName}"
          },
          input: {
            type: "structure",
            required: [
              "metricName",
              "indexName"
            ],
            members: {
              metricName: {
                location: "uri",
                locationName: "metricName"
              },
              queryString: {},
              aggregationType: {
                shape: "S3s"
              },
              period: {
                type: "integer"
              },
              aggregationField: {},
              description: {},
              queryVersion: {},
              indexName: {},
              unit: {},
              expectedVersion: {
                type: "long"
              }
            }
          }
        },
        UpdateIndexingConfiguration: {
          http: {
            requestUri: "/indexing/config"
          },
          input: {
            type: "structure",
            members: {
              thingIndexingConfiguration: {
                shape: "Sl6"
              },
              thingGroupIndexingConfiguration: {
                shape: "Sld"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateJob: {
          http: {
            method: "PATCH",
            requestUri: "/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              description: {},
              presignedUrlConfig: {
                shape: "S45"
              },
              jobExecutionsRolloutConfig: {
                shape: "S48"
              },
              abortConfig: {
                shape: "S4f"
              },
              timeoutConfig: {
                shape: "S4m"
              },
              namespaceId: {
                location: "querystring",
                locationName: "namespaceId"
              }
            }
          }
        },
        UpdateMitigationAction: {
          http: {
            method: "PATCH",
            requestUri: "/mitigationactions/actions/{actionName}"
          },
          input: {
            type: "structure",
            required: [
              "actionName"
            ],
            members: {
              actionName: {
                location: "uri",
                locationName: "actionName"
              },
              roleArn: {},
              actionParams: {
                shape: "S50"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              actionArn: {},
              actionId: {}
            }
          }
        },
        UpdateProvisioningTemplate: {
          http: {
            method: "PATCH",
            requestUri: "/provisioning-templates/{templateName}"
          },
          input: {
            type: "structure",
            required: [
              "templateName"
            ],
            members: {
              templateName: {
                location: "uri",
                locationName: "templateName"
              },
              description: {},
              enabled: {
                type: "boolean"
              },
              defaultVersionId: {
                type: "integer"
              },
              provisioningRoleArn: {},
              preProvisioningHook: {
                shape: "S7p"
              },
              removePreProvisioningHook: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRoleAlias: {
          http: {
            method: "PUT",
            requestUri: "/role-aliases/{roleAlias}"
          },
          input: {
            type: "structure",
            required: [
              "roleAlias"
            ],
            members: {
              roleAlias: {
                location: "uri",
                locationName: "roleAlias"
              },
              roleArn: {},
              credentialDurationSeconds: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              roleAlias: {},
              roleAliasArn: {}
            }
          }
        },
        UpdateScheduledAudit: {
          http: {
            method: "PATCH",
            requestUri: "/audit/scheduledaudits/{scheduledAuditName}"
          },
          input: {
            type: "structure",
            required: [
              "scheduledAuditName"
            ],
            members: {
              frequency: {},
              dayOfMonth: {},
              dayOfWeek: {},
              targetCheckNames: {
                shape: "S84"
              },
              scheduledAuditName: {
                location: "uri",
                locationName: "scheduledAuditName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              scheduledAuditArn: {}
            }
          }
        },
        UpdateSecurityProfile: {
          http: {
            method: "PATCH",
            requestUri: "/security-profiles/{securityProfileName}"
          },
          input: {
            type: "structure",
            required: [
              "securityProfileName"
            ],
            members: {
              securityProfileName: {
                location: "uri",
                locationName: "securityProfileName"
              },
              securityProfileDescription: {},
              behaviors: {
                shape: "S8a"
              },
              alertTargets: {
                shape: "S90"
              },
              additionalMetricsToRetain: {
                shape: "S94",
                deprecated: true,
                deprecatedMessage: "Use additionalMetricsToRetainV2."
              },
              additionalMetricsToRetainV2: {
                shape: "S95"
              },
              deleteBehaviors: {
                type: "boolean"
              },
              deleteAlertTargets: {
                type: "boolean"
              },
              deleteAdditionalMetricsToRetain: {
                type: "boolean"
              },
              expectedVersion: {
                location: "querystring",
                locationName: "expectedVersion",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              securityProfileName: {},
              securityProfileArn: {},
              securityProfileDescription: {},
              behaviors: {
                shape: "S8a"
              },
              alertTargets: {
                shape: "S90"
              },
              additionalMetricsToRetain: {
                shape: "S94",
                deprecated: true,
                deprecatedMessage: "Use additionalMetricsToRetainV2."
              },
              additionalMetricsToRetainV2: {
                shape: "S95"
              },
              version: {
                type: "long"
              },
              creationDate: {
                type: "timestamp"
              },
              lastModifiedDate: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateStream: {
          http: {
            method: "PUT",
            requestUri: "/streams/{streamId}"
          },
          input: {
            type: "structure",
            required: [
              "streamId"
            ],
            members: {
              streamId: {
                location: "uri",
                locationName: "streamId"
              },
              description: {},
              files: {
                shape: "S9b"
              },
              roleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              streamId: {},
              streamArn: {},
              description: {},
              streamVersion: {
                type: "integer"
              }
            }
          }
        },
        UpdateThing: {
          http: {
            method: "PATCH",
            requestUri: "/things/{thingName}"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              thingTypeName: {},
              attributePayload: {
                shape: "S3g"
              },
              expectedVersion: {
                type: "long"
              },
              removeThingType: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateThingGroup: {
          http: {
            method: "PATCH",
            requestUri: "/thing-groups/{thingGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "thingGroupName",
              "thingGroupProperties"
            ],
            members: {
              thingGroupName: {
                location: "uri",
                locationName: "thingGroupName"
              },
              thingGroupProperties: {
                shape: "S3e"
              },
              expectedVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              version: {
                type: "long"
              }
            }
          }
        },
        UpdateThingGroupsForThing: {
          http: {
            method: "PUT",
            requestUri: "/thing-groups/updateThingGroupsForThing"
          },
          input: {
            type: "structure",
            members: {
              thingName: {},
              thingGroupsToAdd: {
                shape: "Swo"
              },
              thingGroupsToRemove: {
                shape: "Swo"
              },
              overrideDynamicGroups: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateTopicRuleDestination: {
          http: {
            method: "PATCH",
            requestUri: "/destinations"
          },
          input: {
            type: "structure",
            required: [
              "arn",
              "status"
            ],
            members: {
              arn: {},
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ValidateSecurityProfileBehaviors: {
          http: {
            requestUri: "/security-profile-behaviors/validate"
          },
          input: {
            type: "structure",
            required: [
              "behaviors"
            ],
            members: {
              behaviors: {
                shape: "S8a"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              valid: {
                type: "boolean"
              },
              validationErrors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    errorMessage: {}
                  }
                }
              }
            }
          }
        }
      },
      shapes: {
        Sg: {
          type: "list",
          member: {}
        },
        S1e: {
          type: "map",
          key: {},
          value: {}
        },
        S1o: {
          type: "structure",
          members: {
            deviceCertificateId: {},
            caCertificateId: {},
            cognitoIdentityPoolId: {},
            clientId: {},
            policyVersionIdentifier: {
              type: "structure",
              members: {
                policyName: {},
                policyVersionId: {}
              }
            },
            account: {},
            iamRoleArn: {},
            roleAliasArn: {}
          }
        },
        S25: {
          type: "map",
          key: {},
          value: {}
        },
        S29: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S2h: {
          type: "structure",
          members: {
            billingGroupDescription: {}
          }
        },
        S2z: {
          type: "list",
          member: {}
        },
        S38: {
          type: "structure",
          members: {
            defaultAuthorizerName: {},
            allowAuthorizerOverride: {
              type: "boolean"
            }
          }
        },
        S3e: {
          type: "structure",
          members: {
            thingGroupDescription: {},
            attributePayload: {
              shape: "S3g"
            }
          }
        },
        S3g: {
          type: "structure",
          members: {
            attributes: {
              shape: "S3h"
            },
            merge: {
              type: "boolean"
            }
          }
        },
        S3h: {
          type: "map",
          key: {},
          value: {}
        },
        S3s: {
          type: "structure",
          required: [
            "name"
          ],
          members: {
            name: {},
            values: {
              type: "list",
              member: {}
            }
          }
        },
        S45: {
          type: "structure",
          members: {
            roleArn: {},
            expiresInSec: {
              type: "long"
            }
          }
        },
        S48: {
          type: "structure",
          members: {
            maximumPerMinute: {
              type: "integer"
            },
            exponentialRate: {
              type: "structure",
              required: [
                "baseRatePerMinute",
                "incrementFactor",
                "rateIncreaseCriteria"
              ],
              members: {
                baseRatePerMinute: {
                  type: "integer"
                },
                incrementFactor: {
                  type: "double"
                },
                rateIncreaseCriteria: {
                  type: "structure",
                  members: {
                    numberOfNotifiedThings: {
                      type: "integer"
                    },
                    numberOfSucceededThings: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        S4f: {
          type: "structure",
          required: [
            "criteriaList"
          ],
          members: {
            criteriaList: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "failureType",
                  "action",
                  "thresholdPercentage",
                  "minNumberOfExecutedThings"
                ],
                members: {
                  failureType: {},
                  action: {},
                  thresholdPercentage: {
                    type: "double"
                  },
                  minNumberOfExecutedThings: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        S4m: {
          type: "structure",
          members: {
            inProgressTimeoutInMinutes: {
              type: "long"
            }
          }
        },
        S4v: {
          type: "structure",
          members: {
            PublicKey: {},
            PrivateKey: {
              type: "string",
              sensitive: true
            }
          }
        },
        S50: {
          type: "structure",
          members: {
            updateDeviceCertificateParams: {
              type: "structure",
              required: [
                "action"
              ],
              members: {
                action: {}
              }
            },
            updateCACertificateParams: {
              type: "structure",
              required: [
                "action"
              ],
              members: {
                action: {}
              }
            },
            addThingsToThingGroupParams: {
              type: "structure",
              required: [
                "thingGroupNames"
              ],
              members: {
                thingGroupNames: {
                  type: "list",
                  member: {}
                },
                overrideDynamicGroups: {
                  type: "boolean"
                }
              }
            },
            replaceDefaultPolicyVersionParams: {
              type: "structure",
              required: [
                "templateName"
              ],
              members: {
                templateName: {}
              }
            },
            enableIoTLoggingParams: {
              type: "structure",
              required: [
                "roleArnForLogging",
                "logLevel"
              ],
              members: {
                roleArnForLogging: {},
                logLevel: {}
              }
            },
            publishFindingToSnsParams: {
              type: "structure",
              required: [
                "topicArn"
              ],
              members: {
                topicArn: {}
              }
            }
          }
        },
        S5j: {
          type: "list",
          member: {}
        },
        S5l: {
          type: "list",
          member: {}
        },
        S5n: {
          type: "structure",
          members: {
            maximumPerMinute: {
              type: "integer"
            },
            exponentialRate: {
              type: "structure",
              required: [
                "baseRatePerMinute",
                "incrementFactor",
                "rateIncreaseCriteria"
              ],
              members: {
                baseRatePerMinute: {
                  type: "integer"
                },
                incrementFactor: {
                  type: "double"
                },
                rateIncreaseCriteria: {
                  type: "structure",
                  members: {
                    numberOfNotifiedThings: {
                      type: "integer"
                    },
                    numberOfSucceededThings: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        S5u: {
          type: "structure",
          members: {
            expiresInSec: {
              type: "long"
            }
          }
        },
        S65: {
          type: "list",
          member: {
            type: "structure",
            members: {
              fileName: {},
              fileType: {
                type: "integer"
              },
              fileVersion: {},
              fileLocation: {
                type: "structure",
                members: {
                  stream: {
                    type: "structure",
                    members: {
                      streamId: {},
                      fileId: {
                        type: "integer"
                      }
                    }
                  },
                  s3Location: {
                    shape: "S6e"
                  }
                }
              },
              codeSigning: {
                type: "structure",
                members: {
                  awsSignerJobId: {},
                  startSigningJobParameter: {
                    type: "structure",
                    members: {
                      signingProfileParameter: {
                        type: "structure",
                        members: {
                          certificateArn: {},
                          platform: {},
                          certificatePathOnDevice: {}
                        }
                      },
                      signingProfileName: {},
                      destination: {
                        type: "structure",
                        members: {
                          s3Destination: {
                            type: "structure",
                            members: {
                              bucket: {},
                              prefix: {}
                            }
                          }
                        }
                      }
                    }
                  },
                  customCodeSigning: {
                    type: "structure",
                    members: {
                      signature: {
                        type: "structure",
                        members: {
                          inlineDocument: {
                            type: "blob"
                          }
                        }
                      },
                      certificateChain: {
                        type: "structure",
                        members: {
                          certificateName: {},
                          inlineDocument: {}
                        }
                      },
                      hashAlgorithm: {},
                      signatureAlgorithm: {}
                    }
                  }
                }
              },
              attributes: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        S6e: {
          type: "structure",
          members: {
            bucket: {},
            key: {},
            version: {}
          }
        },
        S73: {
          type: "map",
          key: {},
          value: {}
        },
        S7p: {
          type: "structure",
          required: [
            "targetArn"
          ],
          members: {
            payloadVersion: {},
            targetArn: {}
          }
        },
        S84: {
          type: "list",
          member: {}
        },
        S8a: {
          type: "list",
          member: {
            shape: "S8b"
          }
        },
        S8b: {
          type: "structure",
          required: [
            "name"
          ],
          members: {
            name: {},
            metric: {},
            metricDimension: {
              shape: "S8e"
            },
            criteria: {
              type: "structure",
              members: {
                comparisonOperator: {},
                value: {
                  shape: "S8i"
                },
                durationSeconds: {
                  type: "integer"
                },
                consecutiveDatapointsToAlarm: {
                  type: "integer"
                },
                consecutiveDatapointsToClear: {
                  type: "integer"
                },
                statisticalThreshold: {
                  type: "structure",
                  members: {
                    statistic: {}
                  }
                },
                mlDetectionConfig: {
                  type: "structure",
                  required: [
                    "confidenceLevel"
                  ],
                  members: {
                    confidenceLevel: {}
                  }
                }
              }
            },
            suppressAlerts: {
              type: "boolean"
            }
          }
        },
        S8e: {
          type: "structure",
          required: [
            "dimensionName"
          ],
          members: {
            dimensionName: {},
            operator: {}
          }
        },
        S8i: {
          type: "structure",
          members: {
            count: {
              type: "long"
            },
            cidrs: {
              type: "list",
              member: {}
            },
            ports: {
              type: "list",
              member: {
                type: "integer"
              }
            },
            number: {
              type: "double"
            },
            numbers: {
              type: "list",
              member: {
                type: "double"
              }
            },
            strings: {
              type: "list",
              member: {}
            }
          }
        },
        S90: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "alertTargetArn",
              "roleArn"
            ],
            members: {
              alertTargetArn: {},
              roleArn: {}
            }
          }
        },
        S94: {
          type: "list",
          member: {}
        },
        S95: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "metric"
            ],
            members: {
              metric: {},
              metricDimension: {
                shape: "S8e"
              }
            }
          }
        },
        S9b: {
          type: "list",
          member: {
            type: "structure",
            members: {
              fileId: {
                type: "integer"
              },
              s3Location: {
                shape: "S6e"
              }
            }
          }
        },
        S9n: {
          type: "structure",
          members: {
            thingTypeDescription: {},
            searchableAttributes: {
              type: "list",
              member: {}
            }
          }
        },
        S9v: {
          type: "structure",
          required: [
            "sql",
            "actions"
          ],
          members: {
            sql: {},
            description: {},
            actions: {
              shape: "S9y"
            },
            ruleDisabled: {
              type: "boolean"
            },
            awsIotSqlVersion: {},
            errorAction: {
              shape: "S9z"
            }
          }
        },
        S9y: {
          type: "list",
          member: {
            shape: "S9z"
          }
        },
        S9z: {
          type: "structure",
          members: {
            dynamoDB: {
              type: "structure",
              required: [
                "tableName",
                "roleArn",
                "hashKeyField",
                "hashKeyValue"
              ],
              members: {
                tableName: {},
                roleArn: {},
                operation: {},
                hashKeyField: {},
                hashKeyValue: {},
                hashKeyType: {},
                rangeKeyField: {},
                rangeKeyValue: {},
                rangeKeyType: {},
                payloadField: {}
              }
            },
            dynamoDBv2: {
              type: "structure",
              required: [
                "roleArn",
                "putItem"
              ],
              members: {
                roleArn: {},
                putItem: {
                  type: "structure",
                  required: [
                    "tableName"
                  ],
                  members: {
                    tableName: {}
                  }
                }
              }
            },
            lambda: {
              type: "structure",
              required: [
                "functionArn"
              ],
              members: {
                functionArn: {}
              }
            },
            sns: {
              type: "structure",
              required: [
                "targetArn",
                "roleArn"
              ],
              members: {
                targetArn: {},
                roleArn: {},
                messageFormat: {}
              }
            },
            sqs: {
              type: "structure",
              required: [
                "roleArn",
                "queueUrl"
              ],
              members: {
                roleArn: {},
                queueUrl: {},
                useBase64: {
                  type: "boolean"
                }
              }
            },
            kinesis: {
              type: "structure",
              required: [
                "roleArn",
                "streamName"
              ],
              members: {
                roleArn: {},
                streamName: {},
                partitionKey: {}
              }
            },
            republish: {
              type: "structure",
              required: [
                "roleArn",
                "topic"
              ],
              members: {
                roleArn: {},
                topic: {},
                qos: {
                  type: "integer"
                }
              }
            },
            s3: {
              type: "structure",
              required: [
                "roleArn",
                "bucketName",
                "key"
              ],
              members: {
                roleArn: {},
                bucketName: {},
                key: {},
                cannedAcl: {}
              }
            },
            firehose: {
              type: "structure",
              required: [
                "roleArn",
                "deliveryStreamName"
              ],
              members: {
                roleArn: {},
                deliveryStreamName: {},
                separator: {},
                batchMode: {
                  type: "boolean"
                }
              }
            },
            cloudwatchMetric: {
              type: "structure",
              required: [
                "roleArn",
                "metricNamespace",
                "metricName",
                "metricValue",
                "metricUnit"
              ],
              members: {
                roleArn: {},
                metricNamespace: {},
                metricName: {},
                metricValue: {},
                metricUnit: {},
                metricTimestamp: {}
              }
            },
            cloudwatchAlarm: {
              type: "structure",
              required: [
                "roleArn",
                "alarmName",
                "stateReason",
                "stateValue"
              ],
              members: {
                roleArn: {},
                alarmName: {},
                stateReason: {},
                stateValue: {}
              }
            },
            cloudwatchLogs: {
              type: "structure",
              required: [
                "roleArn",
                "logGroupName"
              ],
              members: {
                roleArn: {},
                logGroupName: {}
              }
            },
            elasticsearch: {
              type: "structure",
              required: [
                "roleArn",
                "endpoint",
                "index",
                "type",
                "id"
              ],
              members: {
                roleArn: {},
                endpoint: {},
                index: {},
                type: {},
                id: {}
              }
            },
            salesforce: {
              type: "structure",
              required: [
                "token",
                "url"
              ],
              members: {
                token: {},
                url: {}
              }
            },
            iotAnalytics: {
              type: "structure",
              members: {
                channelArn: {},
                channelName: {},
                batchMode: {
                  type: "boolean"
                },
                roleArn: {}
              }
            },
            iotEvents: {
              type: "structure",
              required: [
                "inputName",
                "roleArn"
              ],
              members: {
                inputName: {},
                messageId: {},
                batchMode: {
                  type: "boolean"
                },
                roleArn: {}
              }
            },
            iotSiteWise: {
              type: "structure",
              required: [
                "putAssetPropertyValueEntries",
                "roleArn"
              ],
              members: {
                putAssetPropertyValueEntries: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "propertyValues"
                    ],
                    members: {
                      entryId: {},
                      assetId: {},
                      propertyId: {},
                      propertyAlias: {},
                      propertyValues: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "value",
                            "timestamp"
                          ],
                          members: {
                            value: {
                              type: "structure",
                              members: {
                                stringValue: {},
                                integerValue: {},
                                doubleValue: {},
                                booleanValue: {}
                              }
                            },
                            timestamp: {
                              type: "structure",
                              required: [
                                "timeInSeconds"
                              ],
                              members: {
                                timeInSeconds: {},
                                offsetInNanos: {}
                              }
                            },
                            quality: {}
                          }
                        }
                      }
                    }
                  }
                },
                roleArn: {}
              }
            },
            stepFunctions: {
              type: "structure",
              required: [
                "stateMachineName",
                "roleArn"
              ],
              members: {
                executionNamePrefix: {},
                stateMachineName: {},
                roleArn: {}
              }
            },
            timestream: {
              type: "structure",
              required: [
                "roleArn",
                "databaseName",
                "tableName",
                "dimensions"
              ],
              members: {
                roleArn: {},
                databaseName: {},
                tableName: {},
                dimensions: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "name",
                      "value"
                    ],
                    members: {
                      name: {},
                      value: {}
                    }
                  }
                },
                timestamp: {
                  type: "structure",
                  required: [
                    "value",
                    "unit"
                  ],
                  members: {
                    value: {},
                    unit: {}
                  }
                }
              }
            },
            http: {
              type: "structure",
              required: [
                "url"
              ],
              members: {
                url: {},
                confirmationUrl: {},
                headers: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "key",
                      "value"
                    ],
                    members: {
                      key: {},
                      value: {}
                    }
                  }
                },
                auth: {
                  type: "structure",
                  members: {
                    sigv4: {
                      type: "structure",
                      required: [
                        "signingRegion",
                        "serviceName",
                        "roleArn"
                      ],
                      members: {
                        signingRegion: {},
                        serviceName: {},
                        roleArn: {}
                      }
                    }
                  }
                }
              }
            },
            kafka: {
              type: "structure",
              required: [
                "destinationArn",
                "topic",
                "clientProperties"
              ],
              members: {
                destinationArn: {},
                topic: {},
                key: {},
                partition: {},
                clientProperties: {
                  type: "map",
                  key: {},
                  value: {}
                }
              }
            },
            openSearch: {
              type: "structure",
              required: [
                "roleArn",
                "endpoint",
                "index",
                "type",
                "id"
              ],
              members: {
                roleArn: {},
                endpoint: {},
                index: {},
                type: {},
                id: {}
              }
            }
          }
        },
        Scw: {
          type: "list",
          member: {}
        },
        Scy: {
          type: "list",
          member: {}
        },
        Sd2: {
          type: "structure",
          members: {
            arn: {},
            status: {},
            createdAt: {
              type: "timestamp"
            },
            lastUpdatedAt: {
              type: "timestamp"
            },
            statusReason: {},
            httpUrlProperties: {
              type: "structure",
              members: {
                confirmationUrl: {}
              }
            },
            vpcProperties: {
              type: "structure",
              members: {
                subnetIds: {
                  shape: "Scw"
                },
                securityGroups: {
                  shape: "Scy"
                },
                vpcId: {},
                roleArn: {}
              }
            }
          }
        },
        Sf2: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              targetArn: {},
              roleArn: {},
              enabled: {
                type: "boolean"
              }
            }
          }
        },
        Sf5: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              enabled: {
                type: "boolean"
              }
            }
          }
        },
        Sfa: {
          type: "structure",
          members: {
            findingId: {},
            taskId: {},
            checkName: {},
            taskStartTime: {
              type: "timestamp"
            },
            findingTime: {
              type: "timestamp"
            },
            severity: {},
            nonCompliantResource: {
              type: "structure",
              members: {
                resourceType: {},
                resourceIdentifier: {
                  shape: "S1o"
                },
                additionalInfo: {
                  shape: "Sfe"
                }
              }
            },
            relatedResources: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  resourceType: {},
                  resourceIdentifier: {
                    shape: "S1o"
                  },
                  additionalInfo: {
                    shape: "Sfe"
                  }
                }
              }
            },
            reasonForNonCompliance: {},
            reasonForNonComplianceCode: {},
            isSuppressed: {
              type: "boolean"
            }
          }
        },
        Sfe: {
          type: "map",
          key: {},
          value: {}
        },
        Sfu: {
          type: "structure",
          members: {
            auditTaskId: {},
            findingIds: {
              type: "list",
              member: {}
            },
            auditCheckToReasonCodeFilter: {
              type: "map",
              key: {},
              value: {
                type: "list",
                member: {}
              }
            }
          }
        },
        Sfy: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          }
        },
        Sg0: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              id: {},
              roleArn: {},
              actionParams: {
                shape: "S50"
              }
            }
          }
        },
        Sgr: {
          type: "structure",
          members: {
            authorizerName: {},
            authorizerArn: {},
            authorizerFunctionArn: {},
            tokenKeyName: {},
            tokenSigningPublicKeys: {
              shape: "S25"
            },
            status: {},
            creationDate: {
              type: "timestamp"
            },
            lastModifiedDate: {
              type: "timestamp"
            },
            signingDisabled: {
              type: "boolean"
            }
          }
        },
        Sh4: {
          type: "structure",
          members: {
            notBefore: {
              type: "timestamp"
            },
            notAfter: {
              type: "timestamp"
            }
          }
        },
        Sh5: {
          type: "structure",
          members: {
            templateBody: {},
            roleArn: {}
          }
        },
        Shj: {
          type: "structure",
          members: {
            taskId: {},
            taskStatus: {},
            taskStartTime: {
              type: "timestamp"
            },
            taskEndTime: {
              type: "timestamp"
            },
            target: {
              shape: "Shl"
            },
            violationEventOccurrenceRange: {
              shape: "Sho"
            },
            onlyActiveViolationsIncluded: {
              type: "boolean"
            },
            suppressedAlertsIncluded: {
              type: "boolean"
            },
            actionsDefinition: {
              shape: "Sg0"
            },
            taskStatistics: {
              type: "structure",
              members: {
                actionsExecuted: {
                  type: "long"
                },
                actionsSkipped: {
                  type: "long"
                },
                actionsFailed: {
                  type: "long"
                }
              }
            }
          }
        },
        Shl: {
          type: "structure",
          members: {
            violationIds: {
              type: "list",
              member: {}
            },
            securityProfileName: {},
            behaviorName: {}
          }
        },
        Sho: {
          type: "structure",
          required: [
            "startTime",
            "endTime"
          ],
          members: {
            startTime: {
              type: "timestamp"
            },
            endTime: {
              type: "timestamp"
            }
          }
        },
        Si9: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Enabled: {
                type: "boolean"
              }
            }
          }
        },
        Sju: {
          type: "list",
          member: {
            shape: "Sjv"
          }
        },
        Sjv: {
          type: "structure",
          members: {
            groupName: {},
            groupArn: {}
          }
        },
        Sk7: {
          type: "structure",
          members: {
            deprecated: {
              type: "boolean"
            },
            deprecationDate: {
              type: "timestamp"
            },
            creationDate: {
              type: "timestamp"
            }
          }
        },
        Sl6: {
          type: "structure",
          required: [
            "thingIndexingMode"
          ],
          members: {
            thingIndexingMode: {},
            thingConnectivityIndexingMode: {},
            managedFields: {
              shape: "Sl9"
            },
            customFields: {
              shape: "Sl9"
            }
          }
        },
        Sl9: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              type: {}
            }
          }
        },
        Sld: {
          type: "structure",
          required: [
            "thingGroupIndexingMode"
          ],
          members: {
            thingGroupIndexingMode: {},
            managedFields: {
              shape: "Sl9"
            },
            customFields: {
              shape: "Sl9"
            }
          }
        },
        Smv: {
          type: "structure",
          members: {
            confidenceLevel: {}
          }
        },
        Sn2: {
          type: "list",
          member: {
            type: "structure",
            members: {
              policyName: {},
              policyArn: {}
            }
          }
        },
        So4: {
          type: "list",
          member: {
            type: "structure",
            members: {
              certificateArn: {},
              certificateId: {},
              status: {},
              certificateMode: {},
              creationDate: {
                type: "timestamp"
              }
            }
          }
        },
        Sp4: {
          type: "structure",
          members: {
            status: {},
            queuedAt: {
              type: "timestamp"
            },
            startedAt: {
              type: "timestamp"
            },
            lastUpdatedAt: {
              type: "timestamp"
            },
            executionNumber: {
              type: "long"
            }
          }
        },
        Spx: {
          type: "list",
          member: {}
        },
        Sq7: {
          type: "list",
          member: {}
        },
        Sqq: {
          type: "structure",
          required: [
            "name",
            "arn"
          ],
          members: {
            name: {},
            arn: {}
          }
        },
        Sqv: {
          type: "structure",
          required: [
            "arn"
          ],
          members: {
            arn: {}
          }
        },
        Ssj: {
          type: "structure",
          required: [
            "targetType"
          ],
          members: {
            targetType: {},
            targetName: {}
          }
        },
        Stf: {
          type: "list",
          member: {}
        },
        Su9: {
          type: "structure",
          required: [
            "resources"
          ],
          members: {
            actionType: {},
            resources: {
              type: "list",
              member: {}
            }
          }
        },
        Sud: {
          type: "list",
          member: {}
        },
        Swo: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iot-2015-05-28.paginators.json
var require_iot_2015_05_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iot-2015-05-28.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetBehaviorModelTrainingSummaries: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "summaries"
        },
        ListActiveViolations: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "activeViolations"
        },
        ListAttachedPolicies: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "policies"
        },
        ListAuditFindings: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "findings"
        },
        ListAuditMitigationActionsExecutions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "actionsExecutions"
        },
        ListAuditMitigationActionsTasks: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "tasks"
        },
        ListAuditSuppressions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "suppressions"
        },
        ListAuditTasks: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "tasks"
        },
        ListAuthorizers: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "authorizers"
        },
        ListBillingGroups: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "billingGroups"
        },
        ListCACertificates: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "certificates"
        },
        ListCertificates: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "certificates"
        },
        ListCertificatesByCA: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "certificates"
        },
        ListCustomMetrics: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "metricNames"
        },
        ListDetectMitigationActionsExecutions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "actionsExecutions"
        },
        ListDetectMitigationActionsTasks: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "tasks"
        },
        ListDimensions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "dimensionNames"
        },
        ListDomainConfigurations: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "domainConfigurations"
        },
        ListFleetMetrics: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "fleetMetrics"
        },
        ListIndices: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "indexNames"
        },
        ListJobExecutionsForJob: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "executionSummaries"
        },
        ListJobExecutionsForThing: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "executionSummaries"
        },
        ListJobTemplates: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "jobTemplates"
        },
        ListJobs: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "jobs"
        },
        ListMitigationActions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "actionIdentifiers"
        },
        ListOTAUpdates: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "otaUpdates"
        },
        ListOutgoingCertificates: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "outgoingCertificates"
        },
        ListPolicies: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "policies"
        },
        ListPolicyPrincipals: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "principals"
        },
        ListPrincipalPolicies: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "policies"
        },
        ListPrincipalThings: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "things"
        },
        ListProvisioningTemplateVersions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "versions"
        },
        ListProvisioningTemplates: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "templates"
        },
        ListRoleAliases: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "roleAliases"
        },
        ListScheduledAudits: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "scheduledAudits"
        },
        ListSecurityProfiles: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "securityProfileIdentifiers"
        },
        ListSecurityProfilesForTarget: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "securityProfileTargetMappings"
        },
        ListStreams: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "streams"
        },
        ListTagsForResource: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "tags"
        },
        ListTargetsForPolicy: {
          input_token: "marker",
          limit_key: "pageSize",
          output_token: "nextMarker",
          result_key: "targets"
        },
        ListTargetsForSecurityProfile: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "securityProfileTargets"
        },
        ListThingGroups: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "thingGroups"
        },
        ListThingGroupsForThing: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "thingGroups"
        },
        ListThingPrincipals: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "principals"
        },
        ListThingRegistrationTaskReports: {
          input_token: "nextToken",
          limit_key: "maxResults",
          non_aggregate_keys: [
            "reportType"
          ],
          output_token: "nextToken",
          result_key: "resourceLinks"
        },
        ListThingRegistrationTasks: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "taskIds"
        },
        ListThingTypes: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "thingTypes"
        },
        ListThings: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "things"
        },
        ListThingsInBillingGroup: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "things"
        },
        ListThingsInThingGroup: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "things"
        },
        ListTopicRuleDestinations: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "destinationSummaries"
        },
        ListTopicRules: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "rules"
        },
        ListV2LoggingLevels: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "logTargetConfigurations"
        },
        ListViolationEvents: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "violationEvents"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iot.js
var require_iot = __commonJS({
  "node_modules/aws-sdk/clients/iot.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["iot"] = {};
    AWS3.Iot = Service.defineService("iot", ["2015-05-28"]);
    Object.defineProperty(apiLoader.services["iot"], "2015-05-28", {
      get: function get() {
        var model = require_iot_2015_05_28_min();
        model.paginators = require_iot_2015_05_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Iot;
  }
});

// node_modules/aws-sdk/lib/services/iotdata.js
var require_iotdata = __commonJS({
  "node_modules/aws-sdk/lib/services/iotdata.js"() {
    var AWS3 = require_core();
    var blobPayloadOutputOps = [
      "deleteThingShadow",
      "getThingShadow",
      "updateThingShadow"
    ];
    AWS3.util.update(AWS3.IotData.prototype, {
      validateService: function validateService() {
        if (!this.config.endpoint || this.config.endpoint.indexOf("{") >= 0) {
          var msg = "AWS.IotData requires an explicit `endpoint' configuration option.";
          throw AWS3.util.error(new Error(), { name: "InvalidEndpoint", message: msg });
        }
      },
      setupRequestListeners: function setupRequestListeners(request) {
        request.addListener("validateResponse", this.validateResponseBody);
        if (blobPayloadOutputOps.indexOf(request.operation) > -1) {
          request.addListener("extractData", AWS3.util.convertPayloadToString);
        }
      },
      validateResponseBody: function validateResponseBody(resp) {
        var body = resp.httpResponse.body.toString() || "{}";
        var bodyCheck = body.trim();
        if (!bodyCheck || bodyCheck.charAt(0) !== "{") {
          resp.httpResponse.body = "";
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/iot-data-2015-05-28.min.json
var require_iot_data_2015_05_28_min = __commonJS({
  "node_modules/aws-sdk/apis/iot-data-2015-05-28.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-05-28",
        endpointPrefix: "data.iot",
        protocol: "rest-json",
        serviceFullName: "AWS IoT Data Plane",
        serviceId: "IoT Data Plane",
        signatureVersion: "v4",
        signingName: "iotdata",
        uid: "iot-data-2015-05-28"
      },
      operations: {
        DeleteThingShadow: {
          http: {
            method: "DELETE",
            requestUri: "/things/{thingName}/shadow"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              shadowName: {
                location: "querystring",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "payload"
            ],
            members: {
              payload: {
                type: "blob"
              }
            },
            payload: "payload"
          }
        },
        GetRetainedMessage: {
          http: {
            method: "GET",
            requestUri: "/retainedMessage/{topic}"
          },
          input: {
            type: "structure",
            required: [
              "topic"
            ],
            members: {
              topic: {
                location: "uri",
                locationName: "topic"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              topic: {},
              payload: {
                type: "blob"
              },
              qos: {
                type: "integer"
              },
              lastModifiedTime: {
                type: "long"
              }
            }
          }
        },
        GetThingShadow: {
          http: {
            method: "GET",
            requestUri: "/things/{thingName}/shadow"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              shadowName: {
                location: "querystring",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              payload: {
                type: "blob"
              }
            },
            payload: "payload"
          }
        },
        ListNamedShadowsForThing: {
          http: {
            method: "GET",
            requestUri: "/api/things/shadow/ListNamedShadowsForThing/{thingName}"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              pageSize: {
                location: "querystring",
                locationName: "pageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              results: {
                type: "list",
                member: {}
              },
              nextToken: {},
              timestamp: {
                type: "long"
              }
            }
          }
        },
        ListRetainedMessages: {
          http: {
            method: "GET",
            requestUri: "/retainedMessage"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              retainedTopics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    topic: {},
                    payloadSize: {
                      type: "long"
                    },
                    qos: {
                      type: "integer"
                    },
                    lastModifiedTime: {
                      type: "long"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        Publish: {
          http: {
            requestUri: "/topics/{topic}"
          },
          input: {
            type: "structure",
            required: [
              "topic"
            ],
            members: {
              topic: {
                location: "uri",
                locationName: "topic"
              },
              qos: {
                location: "querystring",
                locationName: "qos",
                type: "integer"
              },
              retain: {
                location: "querystring",
                locationName: "retain",
                type: "boolean"
              },
              payload: {
                type: "blob"
              }
            },
            payload: "payload"
          }
        },
        UpdateThingShadow: {
          http: {
            requestUri: "/things/{thingName}/shadow"
          },
          input: {
            type: "structure",
            required: [
              "thingName",
              "payload"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              shadowName: {
                location: "querystring",
                locationName: "name"
              },
              payload: {
                type: "blob"
              }
            },
            payload: "payload"
          },
          output: {
            type: "structure",
            members: {
              payload: {
                type: "blob"
              }
            },
            payload: "payload"
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/iot-data-2015-05-28.paginators.json
var require_iot_data_2015_05_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iot-data-2015-05-28.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListRetainedMessages: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "retainedTopics"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iotdata.js
var require_iotdata2 = __commonJS({
  "node_modules/aws-sdk/clients/iotdata.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["iotdata"] = {};
    AWS3.IotData = Service.defineService("iotdata", ["2015-05-28"]);
    require_iotdata();
    Object.defineProperty(apiLoader.services["iotdata"], "2015-05-28", {
      get: function get() {
        var model = require_iot_data_2015_05_28_min();
        model.paginators = require_iot_data_2015_05_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.IotData;
  }
});

// node_modules/aws-sdk/apis/kinesis-2013-12-02.min.json
var require_kinesis_2013_12_02_min = __commonJS({
  "node_modules/aws-sdk/apis/kinesis-2013-12-02.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-12-02",
        endpointPrefix: "kinesis",
        jsonVersion: "1.1",
        protocol: "json",
        protocolSettings: {
          h2: "eventstream"
        },
        serviceAbbreviation: "Kinesis",
        serviceFullName: "Amazon Kinesis",
        serviceId: "Kinesis",
        signatureVersion: "v4",
        targetPrefix: "Kinesis_20131202",
        uid: "kinesis-2013-12-02"
      },
      operations: {
        AddTagsToStream: {
          input: {
            type: "structure",
            required: [
              "StreamName",
              "Tags"
            ],
            members: {
              StreamName: {},
              Tags: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        CreateStream: {
          input: {
            type: "structure",
            required: [
              "StreamName",
              "ShardCount"
            ],
            members: {
              StreamName: {},
              ShardCount: {
                type: "integer"
              }
            }
          }
        },
        DecreaseStreamRetentionPeriod: {
          input: {
            type: "structure",
            required: [
              "StreamName",
              "RetentionPeriodHours"
            ],
            members: {
              StreamName: {},
              RetentionPeriodHours: {
                type: "integer"
              }
            }
          }
        },
        DeleteStream: {
          input: {
            type: "structure",
            required: [
              "StreamName"
            ],
            members: {
              StreamName: {},
              EnforceConsumerDeletion: {
                type: "boolean"
              }
            }
          }
        },
        DeregisterStreamConsumer: {
          input: {
            type: "structure",
            members: {
              StreamARN: {},
              ConsumerName: {},
              ConsumerARN: {}
            }
          }
        },
        DescribeLimits: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "ShardLimit",
              "OpenShardCount"
            ],
            members: {
              ShardLimit: {
                type: "integer"
              },
              OpenShardCount: {
                type: "integer"
              }
            }
          }
        },
        DescribeStream: {
          input: {
            type: "structure",
            required: [
              "StreamName"
            ],
            members: {
              StreamName: {},
              Limit: {
                type: "integer"
              },
              ExclusiveStartShardId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "StreamDescription"
            ],
            members: {
              StreamDescription: {
                type: "structure",
                required: [
                  "StreamName",
                  "StreamARN",
                  "StreamStatus",
                  "Shards",
                  "HasMoreShards",
                  "RetentionPeriodHours",
                  "StreamCreationTimestamp",
                  "EnhancedMonitoring"
                ],
                members: {
                  StreamName: {},
                  StreamARN: {},
                  StreamStatus: {},
                  Shards: {
                    shape: "Sp"
                  },
                  HasMoreShards: {
                    type: "boolean"
                  },
                  RetentionPeriodHours: {
                    type: "integer"
                  },
                  StreamCreationTimestamp: {
                    type: "timestamp"
                  },
                  EnhancedMonitoring: {
                    shape: "Sw"
                  },
                  EncryptionType: {},
                  KeyId: {}
                }
              }
            }
          }
        },
        DescribeStreamConsumer: {
          input: {
            type: "structure",
            members: {
              StreamARN: {},
              ConsumerName: {},
              ConsumerARN: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ConsumerDescription"
            ],
            members: {
              ConsumerDescription: {
                type: "structure",
                required: [
                  "ConsumerName",
                  "ConsumerARN",
                  "ConsumerStatus",
                  "ConsumerCreationTimestamp",
                  "StreamARN"
                ],
                members: {
                  ConsumerName: {},
                  ConsumerARN: {},
                  ConsumerStatus: {},
                  ConsumerCreationTimestamp: {
                    type: "timestamp"
                  },
                  StreamARN: {}
                }
              }
            }
          }
        },
        DescribeStreamSummary: {
          input: {
            type: "structure",
            required: [
              "StreamName"
            ],
            members: {
              StreamName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "StreamDescriptionSummary"
            ],
            members: {
              StreamDescriptionSummary: {
                type: "structure",
                required: [
                  "StreamName",
                  "StreamARN",
                  "StreamStatus",
                  "RetentionPeriodHours",
                  "StreamCreationTimestamp",
                  "EnhancedMonitoring",
                  "OpenShardCount"
                ],
                members: {
                  StreamName: {},
                  StreamARN: {},
                  StreamStatus: {},
                  RetentionPeriodHours: {
                    type: "integer"
                  },
                  StreamCreationTimestamp: {
                    type: "timestamp"
                  },
                  EnhancedMonitoring: {
                    shape: "Sw"
                  },
                  EncryptionType: {},
                  KeyId: {},
                  OpenShardCount: {
                    type: "integer"
                  },
                  ConsumerCount: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        DisableEnhancedMonitoring: {
          input: {
            type: "structure",
            required: [
              "StreamName",
              "ShardLevelMetrics"
            ],
            members: {
              StreamName: {},
              ShardLevelMetrics: {
                shape: "Sy"
              }
            }
          },
          output: {
            shape: "S1b"
          }
        },
        EnableEnhancedMonitoring: {
          input: {
            type: "structure",
            required: [
              "StreamName",
              "ShardLevelMetrics"
            ],
            members: {
              StreamName: {},
              ShardLevelMetrics: {
                shape: "Sy"
              }
            }
          },
          output: {
            shape: "S1b"
          }
        },
        GetRecords: {
          input: {
            type: "structure",
            required: [
              "ShardIterator"
            ],
            members: {
              ShardIterator: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Records"
            ],
            members: {
              Records: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SequenceNumber",
                    "Data",
                    "PartitionKey"
                  ],
                  members: {
                    SequenceNumber: {},
                    ApproximateArrivalTimestamp: {
                      type: "timestamp"
                    },
                    Data: {
                      type: "blob"
                    },
                    PartitionKey: {},
                    EncryptionType: {}
                  }
                }
              },
              NextShardIterator: {},
              MillisBehindLatest: {
                type: "long"
              },
              ChildShards: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ShardId",
                    "ParentShards",
                    "HashKeyRange"
                  ],
                  members: {
                    ShardId: {},
                    ParentShards: {
                      type: "list",
                      member: {}
                    },
                    HashKeyRange: {
                      shape: "Sr"
                    }
                  }
                }
              }
            }
          }
        },
        GetShardIterator: {
          input: {
            type: "structure",
            required: [
              "StreamName",
              "ShardId",
              "ShardIteratorType"
            ],
            members: {
              StreamName: {},
              ShardId: {},
              ShardIteratorType: {},
              StartingSequenceNumber: {},
              Timestamp: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ShardIterator: {}
            }
          }
        },
        IncreaseStreamRetentionPeriod: {
          input: {
            type: "structure",
            required: [
              "StreamName",
              "RetentionPeriodHours"
            ],
            members: {
              StreamName: {},
              RetentionPeriodHours: {
                type: "integer"
              }
            }
          }
        },
        ListShards: {
          input: {
            type: "structure",
            members: {
              StreamName: {},
              NextToken: {},
              ExclusiveStartShardId: {},
              MaxResults: {
                type: "integer"
              },
              StreamCreationTimestamp: {
                type: "timestamp"
              },
              ShardFilter: {
                type: "structure",
                required: [
                  "Type"
                ],
                members: {
                  Type: {},
                  ShardId: {},
                  Timestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Shards: {
                shape: "Sp"
              },
              NextToken: {}
            }
          }
        },
        ListStreamConsumers: {
          input: {
            type: "structure",
            required: [
              "StreamARN"
            ],
            members: {
              StreamARN: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              StreamCreationTimestamp: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Consumers: {
                type: "list",
                member: {
                  shape: "S23"
                }
              },
              NextToken: {}
            }
          }
        },
        ListStreams: {
          input: {
            type: "structure",
            members: {
              Limit: {
                type: "integer"
              },
              ExclusiveStartStreamName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "StreamNames",
              "HasMoreStreams"
            ],
            members: {
              StreamNames: {
                type: "list",
                member: {}
              },
              HasMoreStreams: {
                type: "boolean"
              }
            }
          }
        },
        ListTagsForStream: {
          input: {
            type: "structure",
            required: [
              "StreamName"
            ],
            members: {
              StreamName: {},
              ExclusiveStartTagKey: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags",
              "HasMoreTags"
            ],
            members: {
              Tags: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key"
                  ],
                  members: {
                    Key: {},
                    Value: {}
                  }
                }
              },
              HasMoreTags: {
                type: "boolean"
              }
            }
          }
        },
        MergeShards: {
          input: {
            type: "structure",
            required: [
              "StreamName",
              "ShardToMerge",
              "AdjacentShardToMerge"
            ],
            members: {
              StreamName: {},
              ShardToMerge: {},
              AdjacentShardToMerge: {}
            }
          }
        },
        PutRecord: {
          input: {
            type: "structure",
            required: [
              "StreamName",
              "Data",
              "PartitionKey"
            ],
            members: {
              StreamName: {},
              Data: {
                type: "blob"
              },
              PartitionKey: {},
              ExplicitHashKey: {},
              SequenceNumberForOrdering: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ShardId",
              "SequenceNumber"
            ],
            members: {
              ShardId: {},
              SequenceNumber: {},
              EncryptionType: {}
            }
          }
        },
        PutRecords: {
          input: {
            type: "structure",
            required: [
              "Records",
              "StreamName"
            ],
            members: {
              Records: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Data",
                    "PartitionKey"
                  ],
                  members: {
                    Data: {
                      type: "blob"
                    },
                    ExplicitHashKey: {},
                    PartitionKey: {}
                  }
                }
              },
              StreamName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Records"
            ],
            members: {
              FailedRecordCount: {
                type: "integer"
              },
              Records: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SequenceNumber: {},
                    ShardId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              },
              EncryptionType: {}
            }
          }
        },
        RegisterStreamConsumer: {
          input: {
            type: "structure",
            required: [
              "StreamARN",
              "ConsumerName"
            ],
            members: {
              StreamARN: {},
              ConsumerName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Consumer"
            ],
            members: {
              Consumer: {
                shape: "S23"
              }
            }
          }
        },
        RemoveTagsFromStream: {
          input: {
            type: "structure",
            required: [
              "StreamName",
              "TagKeys"
            ],
            members: {
              StreamName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        SplitShard: {
          input: {
            type: "structure",
            required: [
              "StreamName",
              "ShardToSplit",
              "NewStartingHashKey"
            ],
            members: {
              StreamName: {},
              ShardToSplit: {},
              NewStartingHashKey: {}
            }
          }
        },
        StartStreamEncryption: {
          input: {
            type: "structure",
            required: [
              "StreamName",
              "EncryptionType",
              "KeyId"
            ],
            members: {
              StreamName: {},
              EncryptionType: {},
              KeyId: {}
            }
          }
        },
        StopStreamEncryption: {
          input: {
            type: "structure",
            required: [
              "StreamName",
              "EncryptionType",
              "KeyId"
            ],
            members: {
              StreamName: {},
              EncryptionType: {},
              KeyId: {}
            }
          }
        },
        UpdateShardCount: {
          input: {
            type: "structure",
            required: [
              "StreamName",
              "TargetShardCount",
              "ScalingType"
            ],
            members: {
              StreamName: {},
              TargetShardCount: {
                type: "integer"
              },
              ScalingType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StreamName: {},
              CurrentShardCount: {
                type: "integer"
              },
              TargetShardCount: {
                type: "integer"
              }
            }
          }
        }
      },
      shapes: {
        Sp: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ShardId",
              "HashKeyRange",
              "SequenceNumberRange"
            ],
            members: {
              ShardId: {},
              ParentShardId: {},
              AdjacentParentShardId: {},
              HashKeyRange: {
                shape: "Sr"
              },
              SequenceNumberRange: {
                type: "structure",
                required: [
                  "StartingSequenceNumber"
                ],
                members: {
                  StartingSequenceNumber: {},
                  EndingSequenceNumber: {}
                }
              }
            }
          }
        },
        Sr: {
          type: "structure",
          required: [
            "StartingHashKey",
            "EndingHashKey"
          ],
          members: {
            StartingHashKey: {},
            EndingHashKey: {}
          }
        },
        Sw: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ShardLevelMetrics: {
                shape: "Sy"
              }
            }
          }
        },
        Sy: {
          type: "list",
          member: {}
        },
        S1b: {
          type: "structure",
          members: {
            StreamName: {},
            CurrentShardLevelMetrics: {
              shape: "Sy"
            },
            DesiredShardLevelMetrics: {
              shape: "Sy"
            }
          }
        },
        S23: {
          type: "structure",
          required: [
            "ConsumerName",
            "ConsumerARN",
            "ConsumerStatus",
            "ConsumerCreationTimestamp"
          ],
          members: {
            ConsumerName: {},
            ConsumerARN: {},
            ConsumerStatus: {},
            ConsumerCreationTimestamp: {
              type: "timestamp"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kinesis-2013-12-02.paginators.json
var require_kinesis_2013_12_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kinesis-2013-12-02.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeStream: {
          input_token: "ExclusiveStartShardId",
          limit_key: "Limit",
          more_results: "StreamDescription.HasMoreShards",
          output_token: "StreamDescription.Shards[-1].ShardId",
          result_key: "StreamDescription.Shards"
        },
        ListStreamConsumers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListStreams: {
          input_token: "ExclusiveStartStreamName",
          limit_key: "Limit",
          more_results: "HasMoreStreams",
          output_token: "StreamNames[-1]",
          result_key: "StreamNames"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kinesis-2013-12-02.waiters2.json
var require_kinesis_2013_12_02_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/kinesis-2013-12-02.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        StreamExists: {
          delay: 10,
          operation: "DescribeStream",
          maxAttempts: 18,
          acceptors: [
            {
              expected: "ACTIVE",
              matcher: "path",
              state: "success",
              argument: "StreamDescription.StreamStatus"
            }
          ]
        },
        StreamNotExists: {
          delay: 10,
          operation: "DescribeStream",
          maxAttempts: 18,
          acceptors: [
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "success"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/kinesis.js
var require_kinesis = __commonJS({
  "node_modules/aws-sdk/clients/kinesis.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["kinesis"] = {};
    AWS3.Kinesis = Service.defineService("kinesis", ["2013-12-02"]);
    Object.defineProperty(apiLoader.services["kinesis"], "2013-12-02", {
      get: function get() {
        var model = require_kinesis_2013_12_02_min();
        model.paginators = require_kinesis_2013_12_02_paginators().pagination;
        model.waiters = require_kinesis_2013_12_02_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Kinesis;
  }
});

// node_modules/aws-sdk/apis/kinesisanalytics-2015-08-14.min.json
var require_kinesisanalytics_2015_08_14_min = __commonJS({
  "node_modules/aws-sdk/apis/kinesisanalytics-2015-08-14.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-08-14",
        endpointPrefix: "kinesisanalytics",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Kinesis Analytics",
        serviceFullName: "Amazon Kinesis Analytics",
        serviceId: "Kinesis Analytics",
        signatureVersion: "v4",
        targetPrefix: "KinesisAnalytics_20150814",
        uid: "kinesisanalytics-2015-08-14"
      },
      operations: {
        AddApplicationCloudWatchLoggingOption: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "CloudWatchLoggingOption"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              CloudWatchLoggingOption: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AddApplicationInput: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "Input"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              Input: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AddApplicationInputProcessingConfiguration: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "InputId",
              "InputProcessingConfiguration"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              InputId: {},
              InputProcessingConfiguration: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AddApplicationOutput: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "Output"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              Output: {
                shape: "S12"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AddApplicationReferenceDataSource: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "ReferenceDataSource"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              ReferenceDataSource: {
                type: "structure",
                required: [
                  "TableName",
                  "ReferenceSchema"
                ],
                members: {
                  TableName: {},
                  S3ReferenceDataSource: {
                    type: "structure",
                    required: [
                      "BucketARN",
                      "FileKey",
                      "ReferenceRoleARN"
                    ],
                    members: {
                      BucketARN: {},
                      FileKey: {},
                      ReferenceRoleARN: {}
                    }
                  },
                  ReferenceSchema: {
                    shape: "Si"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              ApplicationDescription: {},
              Inputs: {
                type: "list",
                member: {
                  shape: "S9"
                }
              },
              Outputs: {
                type: "list",
                member: {
                  shape: "S12"
                }
              },
              CloudWatchLoggingOptions: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              ApplicationCode: {},
              Tags: {
                shape: "S1l"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ApplicationSummary"
            ],
            members: {
              ApplicationSummary: {
                shape: "S1q"
              }
            }
          }
        },
        DeleteApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CreateTimestamp"
            ],
            members: {
              ApplicationName: {},
              CreateTimestamp: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApplicationCloudWatchLoggingOption: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "CloudWatchLoggingOptionId"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              CloudWatchLoggingOptionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApplicationInputProcessingConfiguration: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "InputId"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              InputId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApplicationOutput: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "OutputId"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              OutputId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApplicationReferenceDataSource: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "ReferenceId"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              ReferenceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ApplicationDetail"
            ],
            members: {
              ApplicationDetail: {
                type: "structure",
                required: [
                  "ApplicationName",
                  "ApplicationARN",
                  "ApplicationStatus",
                  "ApplicationVersionId"
                ],
                members: {
                  ApplicationName: {},
                  ApplicationDescription: {},
                  ApplicationARN: {},
                  ApplicationStatus: {},
                  CreateTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdateTimestamp: {
                    type: "timestamp"
                  },
                  InputDescriptions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        InputId: {},
                        NamePrefix: {},
                        InAppStreamNames: {
                          type: "list",
                          member: {}
                        },
                        InputProcessingConfigurationDescription: {
                          type: "structure",
                          members: {
                            InputLambdaProcessorDescription: {
                              type: "structure",
                              members: {
                                ResourceARN: {},
                                RoleARN: {}
                              }
                            }
                          }
                        },
                        KinesisStreamsInputDescription: {
                          type: "structure",
                          members: {
                            ResourceARN: {},
                            RoleARN: {}
                          }
                        },
                        KinesisFirehoseInputDescription: {
                          type: "structure",
                          members: {
                            ResourceARN: {},
                            RoleARN: {}
                          }
                        },
                        InputSchema: {
                          shape: "Si"
                        },
                        InputParallelism: {
                          shape: "Sg"
                        },
                        InputStartingPositionConfiguration: {
                          shape: "S2d"
                        }
                      }
                    }
                  },
                  OutputDescriptions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        OutputId: {},
                        Name: {},
                        KinesisStreamsOutputDescription: {
                          type: "structure",
                          members: {
                            ResourceARN: {},
                            RoleARN: {}
                          }
                        },
                        KinesisFirehoseOutputDescription: {
                          type: "structure",
                          members: {
                            ResourceARN: {},
                            RoleARN: {}
                          }
                        },
                        LambdaOutputDescription: {
                          type: "structure",
                          members: {
                            ResourceARN: {},
                            RoleARN: {}
                          }
                        },
                        DestinationSchema: {
                          shape: "S16"
                        }
                      }
                    }
                  },
                  ReferenceDataSourceDescriptions: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "ReferenceId",
                        "TableName",
                        "S3ReferenceDataSourceDescription"
                      ],
                      members: {
                        ReferenceId: {},
                        TableName: {},
                        S3ReferenceDataSourceDescription: {
                          type: "structure",
                          required: [
                            "BucketARN",
                            "FileKey",
                            "ReferenceRoleARN"
                          ],
                          members: {
                            BucketARN: {},
                            FileKey: {},
                            ReferenceRoleARN: {}
                          }
                        },
                        ReferenceSchema: {
                          shape: "Si"
                        }
                      }
                    }
                  },
                  CloudWatchLoggingOptionDescriptions: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "LogStreamARN",
                        "RoleARN"
                      ],
                      members: {
                        CloudWatchLoggingOptionId: {},
                        LogStreamARN: {},
                        RoleARN: {}
                      }
                    }
                  },
                  ApplicationCode: {},
                  ApplicationVersionId: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        DiscoverInputSchema: {
          input: {
            type: "structure",
            members: {
              ResourceARN: {},
              RoleARN: {},
              InputStartingPositionConfiguration: {
                shape: "S2d"
              },
              S3Configuration: {
                type: "structure",
                required: [
                  "RoleARN",
                  "BucketARN",
                  "FileKey"
                ],
                members: {
                  RoleARN: {},
                  BucketARN: {},
                  FileKey: {}
                }
              },
              InputProcessingConfiguration: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InputSchema: {
                shape: "Si"
              },
              ParsedInputRecords: {
                type: "list",
                member: {
                  type: "list",
                  member: {}
                }
              },
              ProcessedInputRecords: {
                type: "list",
                member: {}
              },
              RawInputRecords: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListApplications: {
          input: {
            type: "structure",
            members: {
              Limit: {
                type: "integer"
              },
              ExclusiveStartApplicationName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ApplicationSummaries",
              "HasMoreApplications"
            ],
            members: {
              ApplicationSummaries: {
                type: "list",
                member: {
                  shape: "S1q"
                }
              },
              HasMoreApplications: {
                type: "boolean"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S1l"
              }
            }
          }
        },
        StartApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "InputConfigurations"
            ],
            members: {
              ApplicationName: {},
              InputConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id",
                    "InputStartingPositionConfiguration"
                  ],
                  members: {
                    Id: {},
                    InputStartingPositionConfiguration: {
                      shape: "S2d"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S1l"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "ApplicationUpdate"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              ApplicationUpdate: {
                type: "structure",
                members: {
                  InputUpdates: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "InputId"
                      ],
                      members: {
                        InputId: {},
                        NamePrefixUpdate: {},
                        InputProcessingConfigurationUpdate: {
                          type: "structure",
                          required: [
                            "InputLambdaProcessorUpdate"
                          ],
                          members: {
                            InputLambdaProcessorUpdate: {
                              type: "structure",
                              members: {
                                ResourceARNUpdate: {},
                                RoleARNUpdate: {}
                              }
                            }
                          }
                        },
                        KinesisStreamsInputUpdate: {
                          type: "structure",
                          members: {
                            ResourceARNUpdate: {},
                            RoleARNUpdate: {}
                          }
                        },
                        KinesisFirehoseInputUpdate: {
                          type: "structure",
                          members: {
                            ResourceARNUpdate: {},
                            RoleARNUpdate: {}
                          }
                        },
                        InputSchemaUpdate: {
                          type: "structure",
                          members: {
                            RecordFormatUpdate: {
                              shape: "Sj"
                            },
                            RecordEncodingUpdate: {},
                            RecordColumnUpdates: {
                              shape: "Ss"
                            }
                          }
                        },
                        InputParallelismUpdate: {
                          type: "structure",
                          members: {
                            CountUpdate: {
                              type: "integer"
                            }
                          }
                        }
                      }
                    }
                  },
                  ApplicationCodeUpdate: {},
                  OutputUpdates: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "OutputId"
                      ],
                      members: {
                        OutputId: {},
                        NameUpdate: {},
                        KinesisStreamsOutputUpdate: {
                          type: "structure",
                          members: {
                            ResourceARNUpdate: {},
                            RoleARNUpdate: {}
                          }
                        },
                        KinesisFirehoseOutputUpdate: {
                          type: "structure",
                          members: {
                            ResourceARNUpdate: {},
                            RoleARNUpdate: {}
                          }
                        },
                        LambdaOutputUpdate: {
                          type: "structure",
                          members: {
                            ResourceARNUpdate: {},
                            RoleARNUpdate: {}
                          }
                        },
                        DestinationSchemaUpdate: {
                          shape: "S16"
                        }
                      }
                    }
                  },
                  ReferenceDataSourceUpdates: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "ReferenceId"
                      ],
                      members: {
                        ReferenceId: {},
                        TableNameUpdate: {},
                        S3ReferenceDataSourceUpdate: {
                          type: "structure",
                          members: {
                            BucketARNUpdate: {},
                            FileKeyUpdate: {},
                            ReferenceRoleARNUpdate: {}
                          }
                        },
                        ReferenceSchemaUpdate: {
                          shape: "Si"
                        }
                      }
                    }
                  },
                  CloudWatchLoggingOptionUpdates: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "CloudWatchLoggingOptionId"
                      ],
                      members: {
                        CloudWatchLoggingOptionId: {},
                        LogStreamARNUpdate: {},
                        RoleARNUpdate: {}
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "LogStreamARN",
            "RoleARN"
          ],
          members: {
            LogStreamARN: {},
            RoleARN: {}
          }
        },
        S9: {
          type: "structure",
          required: [
            "NamePrefix",
            "InputSchema"
          ],
          members: {
            NamePrefix: {},
            InputProcessingConfiguration: {
              shape: "Sb"
            },
            KinesisStreamsInput: {
              type: "structure",
              required: [
                "ResourceARN",
                "RoleARN"
              ],
              members: {
                ResourceARN: {},
                RoleARN: {}
              }
            },
            KinesisFirehoseInput: {
              type: "structure",
              required: [
                "ResourceARN",
                "RoleARN"
              ],
              members: {
                ResourceARN: {},
                RoleARN: {}
              }
            },
            InputParallelism: {
              shape: "Sg"
            },
            InputSchema: {
              shape: "Si"
            }
          }
        },
        Sb: {
          type: "structure",
          required: [
            "InputLambdaProcessor"
          ],
          members: {
            InputLambdaProcessor: {
              type: "structure",
              required: [
                "ResourceARN",
                "RoleARN"
              ],
              members: {
                ResourceARN: {},
                RoleARN: {}
              }
            }
          }
        },
        Sg: {
          type: "structure",
          members: {
            Count: {
              type: "integer"
            }
          }
        },
        Si: {
          type: "structure",
          required: [
            "RecordFormat",
            "RecordColumns"
          ],
          members: {
            RecordFormat: {
              shape: "Sj"
            },
            RecordEncoding: {},
            RecordColumns: {
              shape: "Ss"
            }
          }
        },
        Sj: {
          type: "structure",
          required: [
            "RecordFormatType"
          ],
          members: {
            RecordFormatType: {},
            MappingParameters: {
              type: "structure",
              members: {
                JSONMappingParameters: {
                  type: "structure",
                  required: [
                    "RecordRowPath"
                  ],
                  members: {
                    RecordRowPath: {}
                  }
                },
                CSVMappingParameters: {
                  type: "structure",
                  required: [
                    "RecordRowDelimiter",
                    "RecordColumnDelimiter"
                  ],
                  members: {
                    RecordRowDelimiter: {},
                    RecordColumnDelimiter: {}
                  }
                }
              }
            }
          }
        },
        Ss: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "SqlType"
            ],
            members: {
              Name: {},
              Mapping: {},
              SqlType: {}
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "Name",
            "DestinationSchema"
          ],
          members: {
            Name: {},
            KinesisStreamsOutput: {
              type: "structure",
              required: [
                "ResourceARN",
                "RoleARN"
              ],
              members: {
                ResourceARN: {},
                RoleARN: {}
              }
            },
            KinesisFirehoseOutput: {
              type: "structure",
              required: [
                "ResourceARN",
                "RoleARN"
              ],
              members: {
                ResourceARN: {},
                RoleARN: {}
              }
            },
            LambdaOutput: {
              type: "structure",
              required: [
                "ResourceARN",
                "RoleARN"
              ],
              members: {
                ResourceARN: {},
                RoleARN: {}
              }
            },
            DestinationSchema: {
              shape: "S16"
            }
          }
        },
        S16: {
          type: "structure",
          required: [
            "RecordFormatType"
          ],
          members: {
            RecordFormatType: {}
          }
        },
        S1l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S1q: {
          type: "structure",
          required: [
            "ApplicationName",
            "ApplicationARN",
            "ApplicationStatus"
          ],
          members: {
            ApplicationName: {},
            ApplicationARN: {},
            ApplicationStatus: {}
          }
        },
        S2d: {
          type: "structure",
          members: {
            InputStartingPosition: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kinesisanalytics-2015-08-14.paginators.json
var require_kinesisanalytics_2015_08_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kinesisanalytics-2015-08-14.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/kinesisanalytics.js
var require_kinesisanalytics = __commonJS({
  "node_modules/aws-sdk/clients/kinesisanalytics.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["kinesisanalytics"] = {};
    AWS3.KinesisAnalytics = Service.defineService("kinesisanalytics", ["2015-08-14"]);
    Object.defineProperty(apiLoader.services["kinesisanalytics"], "2015-08-14", {
      get: function get() {
        var model = require_kinesisanalytics_2015_08_14_min();
        model.paginators = require_kinesisanalytics_2015_08_14_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.KinesisAnalytics;
  }
});

// node_modules/aws-sdk/apis/kms-2014-11-01.min.json
var require_kms_2014_11_01_min = __commonJS({
  "node_modules/aws-sdk/apis/kms-2014-11-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-11-01",
        endpointPrefix: "kms",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "KMS",
        serviceFullName: "AWS Key Management Service",
        serviceId: "KMS",
        signatureVersion: "v4",
        targetPrefix: "TrentService",
        uid: "kms-2014-11-01"
      },
      operations: {
        CancelKeyDeletion: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              KeyId: {}
            }
          }
        },
        ConnectCustomKeyStore: {
          input: {
            type: "structure",
            required: [
              "CustomKeyStoreId"
            ],
            members: {
              CustomKeyStoreId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateAlias: {
          input: {
            type: "structure",
            required: [
              "AliasName",
              "TargetKeyId"
            ],
            members: {
              AliasName: {},
              TargetKeyId: {}
            }
          }
        },
        CreateCustomKeyStore: {
          input: {
            type: "structure",
            required: [
              "CustomKeyStoreName",
              "CloudHsmClusterId",
              "TrustAnchorCertificate",
              "KeyStorePassword"
            ],
            members: {
              CustomKeyStoreName: {},
              CloudHsmClusterId: {},
              TrustAnchorCertificate: {},
              KeyStorePassword: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CustomKeyStoreId: {}
            }
          }
        },
        CreateGrant: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "GranteePrincipal",
              "Operations"
            ],
            members: {
              KeyId: {},
              GranteePrincipal: {},
              RetiringPrincipal: {},
              Operations: {
                shape: "Sh"
              },
              Constraints: {
                shape: "Sj"
              },
              GrantTokens: {
                shape: "Sn"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GrantToken: {},
              GrantId: {}
            }
          }
        },
        CreateKey: {
          input: {
            type: "structure",
            members: {
              Policy: {},
              Description: {},
              KeyUsage: {},
              CustomerMasterKeySpec: {
                shape: "Sw",
                deprecated: true,
                deprecatedMessage: "This parameter has been deprecated. Instead, use the KeySpec parameter."
              },
              KeySpec: {},
              Origin: {},
              CustomKeyStoreId: {},
              BypassPolicyLockoutSafetyCheck: {
                type: "boolean"
              },
              Tags: {
                shape: "S10"
              },
              MultiRegion: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyMetadata: {
                shape: "S16"
              }
            }
          }
        },
        Decrypt: {
          input: {
            type: "structure",
            required: [
              "CiphertextBlob"
            ],
            members: {
              CiphertextBlob: {
                type: "blob"
              },
              EncryptionContext: {
                shape: "Sk"
              },
              GrantTokens: {
                shape: "Sn"
              },
              KeyId: {},
              EncryptionAlgorithm: {}
            }
          },
          output: {
            type: "structure",
            members: {
              KeyId: {},
              Plaintext: {
                shape: "S1q"
              },
              EncryptionAlgorithm: {}
            }
          }
        },
        DeleteAlias: {
          input: {
            type: "structure",
            required: [
              "AliasName"
            ],
            members: {
              AliasName: {}
            }
          }
        },
        DeleteCustomKeyStore: {
          input: {
            type: "structure",
            required: [
              "CustomKeyStoreId"
            ],
            members: {
              CustomKeyStoreId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteImportedKeyMaterial: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {}
            }
          }
        },
        DescribeCustomKeyStores: {
          input: {
            type: "structure",
            members: {
              CustomKeyStoreId: {},
              CustomKeyStoreName: {},
              Limit: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CustomKeyStores: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CustomKeyStoreId: {},
                    CustomKeyStoreName: {},
                    CloudHsmClusterId: {},
                    TrustAnchorCertificate: {},
                    ConnectionState: {},
                    ConnectionErrorCode: {},
                    CreationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextMarker: {},
              Truncated: {
                type: "boolean"
              }
            }
          }
        },
        DescribeKey: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {},
              GrantTokens: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyMetadata: {
                shape: "S16"
              }
            }
          }
        },
        DisableKey: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {}
            }
          }
        },
        DisableKeyRotation: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {}
            }
          }
        },
        DisconnectCustomKeyStore: {
          input: {
            type: "structure",
            required: [
              "CustomKeyStoreId"
            ],
            members: {
              CustomKeyStoreId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableKey: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {}
            }
          }
        },
        EnableKeyRotation: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {}
            }
          }
        },
        Encrypt: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "Plaintext"
            ],
            members: {
              KeyId: {},
              Plaintext: {
                shape: "S1q"
              },
              EncryptionContext: {
                shape: "Sk"
              },
              GrantTokens: {
                shape: "Sn"
              },
              EncryptionAlgorithm: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CiphertextBlob: {
                type: "blob"
              },
              KeyId: {},
              EncryptionAlgorithm: {}
            }
          }
        },
        GenerateDataKey: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {},
              EncryptionContext: {
                shape: "Sk"
              },
              NumberOfBytes: {
                type: "integer"
              },
              KeySpec: {},
              GrantTokens: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CiphertextBlob: {
                type: "blob"
              },
              Plaintext: {
                shape: "S1q"
              },
              KeyId: {}
            }
          }
        },
        GenerateDataKeyPair: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "KeyPairSpec"
            ],
            members: {
              EncryptionContext: {
                shape: "Sk"
              },
              KeyId: {},
              KeyPairSpec: {},
              GrantTokens: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PrivateKeyCiphertextBlob: {
                type: "blob"
              },
              PrivateKeyPlaintext: {
                shape: "S1q"
              },
              PublicKey: {
                type: "blob"
              },
              KeyId: {},
              KeyPairSpec: {}
            }
          }
        },
        GenerateDataKeyPairWithoutPlaintext: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "KeyPairSpec"
            ],
            members: {
              EncryptionContext: {
                shape: "Sk"
              },
              KeyId: {},
              KeyPairSpec: {},
              GrantTokens: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PrivateKeyCiphertextBlob: {
                type: "blob"
              },
              PublicKey: {
                type: "blob"
              },
              KeyId: {},
              KeyPairSpec: {}
            }
          }
        },
        GenerateDataKeyWithoutPlaintext: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {},
              EncryptionContext: {
                shape: "Sk"
              },
              KeySpec: {},
              NumberOfBytes: {
                type: "integer"
              },
              GrantTokens: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CiphertextBlob: {
                type: "blob"
              },
              KeyId: {}
            }
          }
        },
        GenerateRandom: {
          input: {
            type: "structure",
            members: {
              NumberOfBytes: {
                type: "integer"
              },
              CustomKeyStoreId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Plaintext: {
                shape: "S1q"
              }
            }
          }
        },
        GetKeyPolicy: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "PolicyName"
            ],
            members: {
              KeyId: {},
              PolicyName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          }
        },
        GetKeyRotationStatus: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              KeyRotationEnabled: {
                type: "boolean"
              }
            }
          }
        },
        GetParametersForImport: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "WrappingAlgorithm",
              "WrappingKeySpec"
            ],
            members: {
              KeyId: {},
              WrappingAlgorithm: {},
              WrappingKeySpec: {}
            }
          },
          output: {
            type: "structure",
            members: {
              KeyId: {},
              ImportToken: {
                type: "blob"
              },
              PublicKey: {
                shape: "S1q"
              },
              ParametersValidTo: {
                type: "timestamp"
              }
            }
          }
        },
        GetPublicKey: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {},
              GrantTokens: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyId: {},
              PublicKey: {
                type: "blob"
              },
              CustomerMasterKeySpec: {
                shape: "Sw",
                deprecated: true,
                deprecatedMessage: "This field has been deprecated. Instead, use the KeySpec field."
              },
              KeySpec: {},
              KeyUsage: {},
              EncryptionAlgorithms: {
                shape: "S1d"
              },
              SigningAlgorithms: {
                shape: "S1f"
              }
            }
          }
        },
        ImportKeyMaterial: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "ImportToken",
              "EncryptedKeyMaterial"
            ],
            members: {
              KeyId: {},
              ImportToken: {
                type: "blob"
              },
              EncryptedKeyMaterial: {
                type: "blob"
              },
              ValidTo: {
                type: "timestamp"
              },
              ExpirationModel: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListAliases: {
          input: {
            type: "structure",
            members: {
              KeyId: {},
              Limit: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Aliases: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AliasName: {},
                    AliasArn: {},
                    TargetKeyId: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    LastUpdatedDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextMarker: {},
              Truncated: {
                type: "boolean"
              }
            }
          }
        },
        ListGrants: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              Limit: {
                type: "integer"
              },
              Marker: {},
              KeyId: {},
              GrantId: {},
              GranteePrincipal: {}
            }
          },
          output: {
            shape: "S39"
          }
        },
        ListKeyPolicies: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {},
              Limit: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyNames: {
                type: "list",
                member: {}
              },
              NextMarker: {},
              Truncated: {
                type: "boolean"
              }
            }
          }
        },
        ListKeys: {
          input: {
            type: "structure",
            members: {
              Limit: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Keys: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    KeyId: {},
                    KeyArn: {}
                  }
                }
              },
              NextMarker: {},
              Truncated: {
                type: "boolean"
              }
            }
          }
        },
        ListResourceTags: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {},
              Limit: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S10"
              },
              NextMarker: {},
              Truncated: {
                type: "boolean"
              }
            }
          }
        },
        ListRetirableGrants: {
          input: {
            type: "structure",
            required: [
              "RetiringPrincipal"
            ],
            members: {
              Limit: {
                type: "integer"
              },
              Marker: {},
              RetiringPrincipal: {}
            }
          },
          output: {
            shape: "S39"
          }
        },
        PutKeyPolicy: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "PolicyName",
              "Policy"
            ],
            members: {
              KeyId: {},
              PolicyName: {},
              Policy: {},
              BypassPolicyLockoutSafetyCheck: {
                type: "boolean"
              }
            }
          }
        },
        ReEncrypt: {
          input: {
            type: "structure",
            required: [
              "CiphertextBlob",
              "DestinationKeyId"
            ],
            members: {
              CiphertextBlob: {
                type: "blob"
              },
              SourceEncryptionContext: {
                shape: "Sk"
              },
              SourceKeyId: {},
              DestinationKeyId: {},
              DestinationEncryptionContext: {
                shape: "Sk"
              },
              SourceEncryptionAlgorithm: {},
              DestinationEncryptionAlgorithm: {},
              GrantTokens: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CiphertextBlob: {
                type: "blob"
              },
              SourceKeyId: {},
              KeyId: {},
              SourceEncryptionAlgorithm: {},
              DestinationEncryptionAlgorithm: {}
            }
          }
        },
        ReplicateKey: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "ReplicaRegion"
            ],
            members: {
              KeyId: {},
              ReplicaRegion: {},
              Policy: {},
              BypassPolicyLockoutSafetyCheck: {
                type: "boolean"
              },
              Description: {},
              Tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicaKeyMetadata: {
                shape: "S16"
              },
              ReplicaPolicy: {},
              ReplicaTags: {
                shape: "S10"
              }
            }
          }
        },
        RetireGrant: {
          input: {
            type: "structure",
            members: {
              GrantToken: {},
              KeyId: {},
              GrantId: {}
            }
          }
        },
        RevokeGrant: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "GrantId"
            ],
            members: {
              KeyId: {},
              GrantId: {}
            }
          }
        },
        ScheduleKeyDeletion: {
          input: {
            type: "structure",
            required: [
              "KeyId"
            ],
            members: {
              KeyId: {},
              PendingWindowInDays: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyId: {},
              DeletionDate: {
                type: "timestamp"
              },
              KeyState: {},
              PendingWindowInDays: {
                type: "integer"
              }
            }
          }
        },
        Sign: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "Message",
              "SigningAlgorithm"
            ],
            members: {
              KeyId: {},
              Message: {
                shape: "S1q"
              },
              MessageType: {},
              GrantTokens: {
                shape: "Sn"
              },
              SigningAlgorithm: {}
            }
          },
          output: {
            type: "structure",
            members: {
              KeyId: {},
              Signature: {
                type: "blob"
              },
              SigningAlgorithm: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "Tags"
            ],
            members: {
              KeyId: {},
              Tags: {
                shape: "S10"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "TagKeys"
            ],
            members: {
              KeyId: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateAlias: {
          input: {
            type: "structure",
            required: [
              "AliasName",
              "TargetKeyId"
            ],
            members: {
              AliasName: {},
              TargetKeyId: {}
            }
          }
        },
        UpdateCustomKeyStore: {
          input: {
            type: "structure",
            required: [
              "CustomKeyStoreId"
            ],
            members: {
              CustomKeyStoreId: {},
              NewCustomKeyStoreName: {},
              KeyStorePassword: {
                shape: "Sd"
              },
              CloudHsmClusterId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateKeyDescription: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "Description"
            ],
            members: {
              KeyId: {},
              Description: {}
            }
          }
        },
        UpdatePrimaryRegion: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "PrimaryRegion"
            ],
            members: {
              KeyId: {},
              PrimaryRegion: {}
            }
          }
        },
        Verify: {
          input: {
            type: "structure",
            required: [
              "KeyId",
              "Message",
              "Signature",
              "SigningAlgorithm"
            ],
            members: {
              KeyId: {},
              Message: {
                shape: "S1q"
              },
              MessageType: {},
              Signature: {
                type: "blob"
              },
              SigningAlgorithm: {},
              GrantTokens: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyId: {},
              SignatureValid: {
                type: "boolean"
              },
              SigningAlgorithm: {}
            }
          }
        }
      },
      shapes: {
        Sd: {
          type: "string",
          sensitive: true
        },
        Sh: {
          type: "list",
          member: {}
        },
        Sj: {
          type: "structure",
          members: {
            EncryptionContextSubset: {
              shape: "Sk"
            },
            EncryptionContextEquals: {
              shape: "Sk"
            }
          }
        },
        Sk: {
          type: "map",
          key: {},
          value: {}
        },
        Sn: {
          type: "list",
          member: {}
        },
        Sw: {
          type: "string",
          deprecated: true,
          deprecatedMessage: "This enum has been deprecated. Instead, use the KeySpec enum."
        },
        S10: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "TagKey",
              "TagValue"
            ],
            members: {
              TagKey: {},
              TagValue: {}
            }
          }
        },
        S16: {
          type: "structure",
          required: [
            "KeyId"
          ],
          members: {
            AWSAccountId: {},
            KeyId: {},
            Arn: {},
            CreationDate: {
              type: "timestamp"
            },
            Enabled: {
              type: "boolean"
            },
            Description: {},
            KeyUsage: {},
            KeyState: {},
            DeletionDate: {
              type: "timestamp"
            },
            ValidTo: {
              type: "timestamp"
            },
            Origin: {},
            CustomKeyStoreId: {},
            CloudHsmClusterId: {},
            ExpirationModel: {},
            KeyManager: {},
            CustomerMasterKeySpec: {
              shape: "Sw",
              deprecated: true,
              deprecatedMessage: "This field has been deprecated. Instead, use the KeySpec field."
            },
            KeySpec: {},
            EncryptionAlgorithms: {
              shape: "S1d"
            },
            SigningAlgorithms: {
              shape: "S1f"
            },
            MultiRegion: {
              type: "boolean"
            },
            MultiRegionConfiguration: {
              type: "structure",
              members: {
                MultiRegionKeyType: {},
                PrimaryKey: {
                  shape: "S1j"
                },
                ReplicaKeys: {
                  type: "list",
                  member: {
                    shape: "S1j"
                  }
                }
              }
            },
            PendingDeletionWindowInDays: {
              type: "integer"
            }
          }
        },
        S1d: {
          type: "list",
          member: {}
        },
        S1f: {
          type: "list",
          member: {}
        },
        S1j: {
          type: "structure",
          members: {
            Arn: {},
            Region: {}
          }
        },
        S1q: {
          type: "blob",
          sensitive: true
        },
        S39: {
          type: "structure",
          members: {
            Grants: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  KeyId: {},
                  GrantId: {},
                  Name: {},
                  CreationDate: {
                    type: "timestamp"
                  },
                  GranteePrincipal: {},
                  RetiringPrincipal: {},
                  IssuingAccount: {},
                  Operations: {
                    shape: "Sh"
                  },
                  Constraints: {
                    shape: "Sj"
                  }
                }
              }
            },
            NextMarker: {},
            Truncated: {
              type: "boolean"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kms-2014-11-01.paginators.json
var require_kms_2014_11_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kms-2014-11-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAliases: {
          input_token: "Marker",
          limit_key: "Limit",
          more_results: "Truncated",
          output_token: "NextMarker",
          result_key: "Aliases"
        },
        ListGrants: {
          input_token: "Marker",
          limit_key: "Limit",
          more_results: "Truncated",
          output_token: "NextMarker",
          result_key: "Grants"
        },
        ListKeyPolicies: {
          input_token: "Marker",
          limit_key: "Limit",
          more_results: "Truncated",
          output_token: "NextMarker",
          result_key: "PolicyNames"
        },
        ListKeys: {
          input_token: "Marker",
          limit_key: "Limit",
          more_results: "Truncated",
          output_token: "NextMarker",
          result_key: "Keys"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/kms.js
var require_kms = __commonJS({
  "node_modules/aws-sdk/clients/kms.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["kms"] = {};
    AWS3.KMS = Service.defineService("kms", ["2014-11-01"]);
    Object.defineProperty(apiLoader.services["kms"], "2014-11-01", {
      get: function get() {
        var model = require_kms_2014_11_01_min();
        model.paginators = require_kms_2014_11_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.KMS;
  }
});

// node_modules/aws-sdk/lib/services/lambda.js
var require_lambda = __commonJS({
  "node_modules/aws-sdk/lib/services/lambda.js"() {
    var AWS3 = require_core();
    AWS3.util.update(AWS3.Lambda.prototype, {
      setupRequestListeners: function setupRequestListeners(request) {
        if (request.operation === "invoke") {
          request.addListener("extractData", AWS3.util.convertPayloadToString);
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/lambda-2014-11-11.min.json
var require_lambda_2014_11_11_min = __commonJS({
  "node_modules/aws-sdk/apis/lambda-2014-11-11.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2014-11-11",
        endpointPrefix: "lambda",
        serviceFullName: "AWS Lambda",
        serviceId: "Lambda",
        signatureVersion: "v4",
        protocol: "rest-json"
      },
      operations: {
        AddEventSource: {
          http: {
            requestUri: "/2014-11-13/event-source-mappings/"
          },
          input: {
            type: "structure",
            required: [
              "EventSource",
              "FunctionName",
              "Role"
            ],
            members: {
              EventSource: {},
              FunctionName: {},
              Role: {},
              BatchSize: {
                type: "integer"
              },
              Parameters: {
                shape: "S6"
              }
            }
          },
          output: {
            shape: "S7"
          }
        },
        DeleteFunction: {
          http: {
            method: "DELETE",
            requestUri: "/2014-11-13/functions/{FunctionName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              }
            }
          }
        },
        GetEventSource: {
          http: {
            method: "GET",
            requestUri: "/2014-11-13/event-source-mappings/{UUID}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "UUID"
            ],
            members: {
              UUID: {
                location: "uri",
                locationName: "UUID"
              }
            }
          },
          output: {
            shape: "S7"
          }
        },
        GetFunction: {
          http: {
            method: "GET",
            requestUri: "/2014-11-13/functions/{FunctionName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Configuration: {
                shape: "Se"
              },
              Code: {
                type: "structure",
                members: {
                  RepositoryType: {},
                  Location: {}
                }
              }
            }
          }
        },
        GetFunctionConfiguration: {
          http: {
            method: "GET",
            requestUri: "/2014-11-13/functions/{FunctionName}/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              }
            }
          },
          output: {
            shape: "Se"
          }
        },
        InvokeAsync: {
          http: {
            requestUri: "/2014-11-13/functions/{FunctionName}/invoke-async/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "InvokeArgs"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              InvokeArgs: {
                shape: "Sq"
              }
            },
            payload: "InvokeArgs"
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListEventSources: {
          http: {
            method: "GET",
            requestUri: "/2014-11-13/event-source-mappings/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              EventSourceArn: {
                location: "querystring",
                locationName: "EventSource"
              },
              FunctionName: {
                location: "querystring",
                locationName: "FunctionName"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              EventSources: {
                type: "list",
                member: {
                  shape: "S7"
                }
              }
            }
          }
        },
        ListFunctions: {
          http: {
            method: "GET",
            requestUri: "/2014-11-13/functions/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              Functions: {
                type: "list",
                member: {
                  shape: "Se"
                }
              }
            }
          }
        },
        RemoveEventSource: {
          http: {
            method: "DELETE",
            requestUri: "/2014-11-13/event-source-mappings/{UUID}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "UUID"
            ],
            members: {
              UUID: {
                location: "uri",
                locationName: "UUID"
              }
            }
          }
        },
        UpdateFunctionConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/2014-11-13/functions/{FunctionName}/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Role: {
                location: "querystring",
                locationName: "Role"
              },
              Handler: {
                location: "querystring",
                locationName: "Handler"
              },
              Description: {
                location: "querystring",
                locationName: "Description"
              },
              Timeout: {
                location: "querystring",
                locationName: "Timeout",
                type: "integer"
              },
              MemorySize: {
                location: "querystring",
                locationName: "MemorySize",
                type: "integer"
              }
            }
          },
          output: {
            shape: "Se"
          }
        },
        UploadFunction: {
          http: {
            method: "PUT",
            requestUri: "/2014-11-13/functions/{FunctionName}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "FunctionZip",
              "Runtime",
              "Role",
              "Handler",
              "Mode"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              FunctionZip: {
                shape: "Sq"
              },
              Runtime: {
                location: "querystring",
                locationName: "Runtime"
              },
              Role: {
                location: "querystring",
                locationName: "Role"
              },
              Handler: {
                location: "querystring",
                locationName: "Handler"
              },
              Mode: {
                location: "querystring",
                locationName: "Mode"
              },
              Description: {
                location: "querystring",
                locationName: "Description"
              },
              Timeout: {
                location: "querystring",
                locationName: "Timeout",
                type: "integer"
              },
              MemorySize: {
                location: "querystring",
                locationName: "MemorySize",
                type: "integer"
              }
            },
            payload: "FunctionZip"
          },
          output: {
            shape: "Se"
          }
        }
      },
      shapes: {
        S6: {
          type: "map",
          key: {},
          value: {}
        },
        S7: {
          type: "structure",
          members: {
            UUID: {},
            BatchSize: {
              type: "integer"
            },
            EventSource: {},
            FunctionName: {},
            Parameters: {
              shape: "S6"
            },
            Role: {},
            LastModified: {
              type: "timestamp"
            },
            IsActive: {
              type: "boolean"
            },
            Status: {}
          }
        },
        Se: {
          type: "structure",
          members: {
            FunctionName: {},
            FunctionARN: {},
            ConfigurationId: {},
            Runtime: {},
            Role: {},
            Handler: {},
            Mode: {},
            CodeSize: {
              type: "long"
            },
            Description: {},
            Timeout: {
              type: "integer"
            },
            MemorySize: {
              type: "integer"
            },
            LastModified: {
              type: "timestamp"
            }
          }
        },
        Sq: {
          type: "blob",
          streaming: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/lambda-2014-11-11.paginators.json
var require_lambda_2014_11_11_paginators = __commonJS({
  "node_modules/aws-sdk/apis/lambda-2014-11-11.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListEventSources: {
          input_token: "Marker",
          output_token: "NextMarker",
          limit_key: "MaxItems",
          result_key: "EventSources"
        },
        ListFunctions: {
          input_token: "Marker",
          output_token: "NextMarker",
          limit_key: "MaxItems",
          result_key: "Functions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/lambda-2015-03-31.min.json
var require_lambda_2015_03_31_min = __commonJS({
  "node_modules/aws-sdk/apis/lambda-2015-03-31.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-03-31",
        endpointPrefix: "lambda",
        protocol: "rest-json",
        serviceFullName: "AWS Lambda",
        serviceId: "Lambda",
        signatureVersion: "v4",
        uid: "lambda-2015-03-31"
      },
      operations: {
        AddLayerVersionPermission: {
          http: {
            requestUri: "/2018-10-31/layers/{LayerName}/versions/{VersionNumber}/policy",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "LayerName",
              "VersionNumber",
              "StatementId",
              "Action",
              "Principal"
            ],
            members: {
              LayerName: {
                location: "uri",
                locationName: "LayerName"
              },
              VersionNumber: {
                location: "uri",
                locationName: "VersionNumber",
                type: "long"
              },
              StatementId: {},
              Action: {},
              Principal: {},
              OrganizationId: {},
              RevisionId: {
                location: "querystring",
                locationName: "RevisionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Statement: {},
              RevisionId: {}
            }
          }
        },
        AddPermission: {
          http: {
            requestUri: "/2015-03-31/functions/{FunctionName}/policy",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "StatementId",
              "Action",
              "Principal"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              StatementId: {},
              Action: {},
              Principal: {},
              SourceArn: {},
              SourceAccount: {},
              EventSourceToken: {},
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              },
              RevisionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Statement: {}
            }
          }
        },
        CreateAlias: {
          http: {
            requestUri: "/2015-03-31/functions/{FunctionName}/aliases",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "Name",
              "FunctionVersion"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Name: {},
              FunctionVersion: {},
              Description: {},
              RoutingConfig: {
                shape: "Sn"
              }
            }
          },
          output: {
            shape: "Sr"
          }
        },
        CreateCodeSigningConfig: {
          http: {
            requestUri: "/2020-04-22/code-signing-configs/",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AllowedPublishers"
            ],
            members: {
              Description: {},
              AllowedPublishers: {
                shape: "Su"
              },
              CodeSigningPolicies: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CodeSigningConfig"
            ],
            members: {
              CodeSigningConfig: {
                shape: "Sz"
              }
            }
          }
        },
        CreateEventSourceMapping: {
          http: {
            requestUri: "/2015-03-31/event-source-mappings/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              EventSourceArn: {},
              FunctionName: {},
              Enabled: {
                type: "boolean"
              },
              BatchSize: {
                type: "integer"
              },
              MaximumBatchingWindowInSeconds: {
                type: "integer"
              },
              ParallelizationFactor: {
                type: "integer"
              },
              StartingPosition: {},
              StartingPositionTimestamp: {
                type: "timestamp"
              },
              DestinationConfig: {
                shape: "S1a"
              },
              MaximumRecordAgeInSeconds: {
                type: "integer"
              },
              BisectBatchOnFunctionError: {
                type: "boolean"
              },
              MaximumRetryAttempts: {
                type: "integer"
              },
              TumblingWindowInSeconds: {
                type: "integer"
              },
              Topics: {
                shape: "S1i"
              },
              Queues: {
                shape: "S1k"
              },
              SourceAccessConfigurations: {
                shape: "S1m"
              },
              SelfManagedEventSource: {
                shape: "S1q"
              },
              FunctionResponseTypes: {
                shape: "S1v"
              }
            }
          },
          output: {
            shape: "S1x"
          }
        },
        CreateFunction: {
          http: {
            requestUri: "/2015-03-31/functions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "Role",
              "Code"
            ],
            members: {
              FunctionName: {},
              Runtime: {},
              Role: {},
              Handler: {},
              Code: {
                type: "structure",
                members: {
                  ZipFile: {
                    shape: "S23"
                  },
                  S3Bucket: {},
                  S3Key: {},
                  S3ObjectVersion: {},
                  ImageUri: {}
                }
              },
              Description: {},
              Timeout: {
                type: "integer"
              },
              MemorySize: {
                type: "integer"
              },
              Publish: {
                type: "boolean"
              },
              VpcConfig: {
                shape: "S2a"
              },
              PackageType: {},
              DeadLetterConfig: {
                shape: "S2g"
              },
              Environment: {
                shape: "S2i"
              },
              KMSKeyArn: {},
              TracingConfig: {
                shape: "S2n"
              },
              Tags: {
                shape: "S2p"
              },
              Layers: {
                shape: "S2s"
              },
              FileSystemConfigs: {
                shape: "S2u"
              },
              ImageConfig: {
                shape: "S2y"
              },
              CodeSigningConfigArn: {},
              Architectures: {
                shape: "S31"
              }
            }
          },
          output: {
            shape: "S33"
          }
        },
        DeleteAlias: {
          http: {
            method: "DELETE",
            requestUri: "/2015-03-31/functions/{FunctionName}/aliases/{Name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "Name"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          }
        },
        DeleteCodeSigningConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2020-04-22/code-signing-configs/{CodeSigningConfigArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "CodeSigningConfigArn"
            ],
            members: {
              CodeSigningConfigArn: {
                location: "uri",
                locationName: "CodeSigningConfigArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEventSourceMapping: {
          http: {
            method: "DELETE",
            requestUri: "/2015-03-31/event-source-mappings/{UUID}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "UUID"
            ],
            members: {
              UUID: {
                location: "uri",
                locationName: "UUID"
              }
            }
          },
          output: {
            shape: "S1x"
          }
        },
        DeleteFunction: {
          http: {
            method: "DELETE",
            requestUri: "/2015-03-31/functions/{FunctionName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            }
          }
        },
        DeleteFunctionCodeSigningConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2020-06-30/functions/{FunctionName}/code-signing-config",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              }
            }
          }
        },
        DeleteFunctionConcurrency: {
          http: {
            method: "DELETE",
            requestUri: "/2017-10-31/functions/{FunctionName}/concurrency",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              }
            }
          }
        },
        DeleteFunctionEventInvokeConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2019-09-25/functions/{FunctionName}/event-invoke-config",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            }
          }
        },
        DeleteLayerVersion: {
          http: {
            method: "DELETE",
            requestUri: "/2018-10-31/layers/{LayerName}/versions/{VersionNumber}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "LayerName",
              "VersionNumber"
            ],
            members: {
              LayerName: {
                location: "uri",
                locationName: "LayerName"
              },
              VersionNumber: {
                location: "uri",
                locationName: "VersionNumber",
                type: "long"
              }
            }
          }
        },
        DeleteProvisionedConcurrencyConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2019-09-30/functions/{FunctionName}/provisioned-concurrency",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "Qualifier"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            }
          }
        },
        GetAccountSettings: {
          http: {
            method: "GET",
            requestUri: "/2016-08-19/account-settings/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              AccountLimit: {
                type: "structure",
                members: {
                  TotalCodeSize: {
                    type: "long"
                  },
                  CodeSizeUnzipped: {
                    type: "long"
                  },
                  CodeSizeZipped: {
                    type: "long"
                  },
                  ConcurrentExecutions: {
                    type: "integer"
                  },
                  UnreservedConcurrentExecutions: {
                    type: "integer"
                  }
                }
              },
              AccountUsage: {
                type: "structure",
                members: {
                  TotalCodeSize: {
                    type: "long"
                  },
                  FunctionCount: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        GetAlias: {
          http: {
            method: "GET",
            requestUri: "/2015-03-31/functions/{FunctionName}/aliases/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "Name"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            shape: "Sr"
          }
        },
        GetCodeSigningConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-04-22/code-signing-configs/{CodeSigningConfigArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CodeSigningConfigArn"
            ],
            members: {
              CodeSigningConfigArn: {
                location: "uri",
                locationName: "CodeSigningConfigArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CodeSigningConfig"
            ],
            members: {
              CodeSigningConfig: {
                shape: "Sz"
              }
            }
          }
        },
        GetEventSourceMapping: {
          http: {
            method: "GET",
            requestUri: "/2015-03-31/event-source-mappings/{UUID}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "UUID"
            ],
            members: {
              UUID: {
                location: "uri",
                locationName: "UUID"
              }
            }
          },
          output: {
            shape: "S1x"
          }
        },
        GetFunction: {
          http: {
            method: "GET",
            requestUri: "/2015-03-31/functions/{FunctionName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Configuration: {
                shape: "S33"
              },
              Code: {
                type: "structure",
                members: {
                  RepositoryType: {},
                  Location: {},
                  ImageUri: {},
                  ResolvedImageUri: {}
                }
              },
              Tags: {
                shape: "S2p"
              },
              Concurrency: {
                shape: "S4a"
              }
            }
          }
        },
        GetFunctionCodeSigningConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-06-30/functions/{FunctionName}/code-signing-config",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CodeSigningConfigArn",
              "FunctionName"
            ],
            members: {
              CodeSigningConfigArn: {},
              FunctionName: {}
            }
          }
        },
        GetFunctionConcurrency: {
          http: {
            method: "GET",
            requestUri: "/2019-09-30/functions/{FunctionName}/concurrency",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedConcurrentExecutions: {
                type: "integer"
              }
            }
          }
        },
        GetFunctionConfiguration: {
          http: {
            method: "GET",
            requestUri: "/2015-03-31/functions/{FunctionName}/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            }
          },
          output: {
            shape: "S33"
          }
        },
        GetFunctionEventInvokeConfig: {
          http: {
            method: "GET",
            requestUri: "/2019-09-25/functions/{FunctionName}/event-invoke-config",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            }
          },
          output: {
            shape: "S4i"
          }
        },
        GetLayerVersion: {
          http: {
            method: "GET",
            requestUri: "/2018-10-31/layers/{LayerName}/versions/{VersionNumber}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "LayerName",
              "VersionNumber"
            ],
            members: {
              LayerName: {
                location: "uri",
                locationName: "LayerName"
              },
              VersionNumber: {
                location: "uri",
                locationName: "VersionNumber",
                type: "long"
              }
            }
          },
          output: {
            shape: "S4m"
          }
        },
        GetLayerVersionByArn: {
          http: {
            method: "GET",
            requestUri: "/2018-10-31/layers?find=LayerVersion",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {
                location: "querystring",
                locationName: "Arn"
              }
            }
          },
          output: {
            shape: "S4m"
          }
        },
        GetLayerVersionPolicy: {
          http: {
            method: "GET",
            requestUri: "/2018-10-31/layers/{LayerName}/versions/{VersionNumber}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "LayerName",
              "VersionNumber"
            ],
            members: {
              LayerName: {
                location: "uri",
                locationName: "LayerName"
              },
              VersionNumber: {
                location: "uri",
                locationName: "VersionNumber",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {},
              RevisionId: {}
            }
          }
        },
        GetPolicy: {
          http: {
            method: "GET",
            requestUri: "/2015-03-31/functions/{FunctionName}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {},
              RevisionId: {}
            }
          }
        },
        GetProvisionedConcurrencyConfig: {
          http: {
            method: "GET",
            requestUri: "/2019-09-30/functions/{FunctionName}/provisioned-concurrency",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "Qualifier"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestedProvisionedConcurrentExecutions: {
                type: "integer"
              },
              AvailableProvisionedConcurrentExecutions: {
                type: "integer"
              },
              AllocatedProvisionedConcurrentExecutions: {
                type: "integer"
              },
              Status: {},
              StatusReason: {},
              LastModified: {}
            }
          }
        },
        Invoke: {
          http: {
            requestUri: "/2015-03-31/functions/{FunctionName}/invocations"
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              InvocationType: {
                location: "header",
                locationName: "X-Amz-Invocation-Type"
              },
              LogType: {
                location: "header",
                locationName: "X-Amz-Log-Type"
              },
              ClientContext: {
                location: "header",
                locationName: "X-Amz-Client-Context"
              },
              Payload: {
                shape: "S23"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              }
            },
            payload: "Payload"
          },
          output: {
            type: "structure",
            members: {
              StatusCode: {
                location: "statusCode",
                type: "integer"
              },
              FunctionError: {
                location: "header",
                locationName: "X-Amz-Function-Error"
              },
              LogResult: {
                location: "header",
                locationName: "X-Amz-Log-Result"
              },
              Payload: {
                shape: "S23"
              },
              ExecutedVersion: {
                location: "header",
                locationName: "X-Amz-Executed-Version"
              }
            },
            payload: "Payload"
          }
        },
        InvokeAsync: {
          http: {
            requestUri: "/2014-11-13/functions/{FunctionName}/invoke-async/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "InvokeArgs"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              InvokeArgs: {
                type: "blob",
                streaming: true
              }
            },
            deprecated: true,
            payload: "InvokeArgs"
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              }
            },
            deprecated: true
          },
          deprecated: true
        },
        ListAliases: {
          http: {
            method: "GET",
            requestUri: "/2015-03-31/functions/{FunctionName}/aliases",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              FunctionVersion: {
                location: "querystring",
                locationName: "FunctionVersion"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              Aliases: {
                type: "list",
                member: {
                  shape: "Sr"
                }
              }
            }
          }
        },
        ListCodeSigningConfigs: {
          http: {
            method: "GET",
            requestUri: "/2020-04-22/code-signing-configs/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              CodeSigningConfigs: {
                type: "list",
                member: {
                  shape: "Sz"
                }
              }
            }
          }
        },
        ListEventSourceMappings: {
          http: {
            method: "GET",
            requestUri: "/2015-03-31/event-source-mappings/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              EventSourceArn: {
                location: "querystring",
                locationName: "EventSourceArn"
              },
              FunctionName: {
                location: "querystring",
                locationName: "FunctionName"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              EventSourceMappings: {
                type: "list",
                member: {
                  shape: "S1x"
                }
              }
            }
          }
        },
        ListFunctionEventInvokeConfigs: {
          http: {
            method: "GET",
            requestUri: "/2019-09-25/functions/{FunctionName}/event-invoke-config/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FunctionEventInvokeConfigs: {
                type: "list",
                member: {
                  shape: "S4i"
                }
              },
              NextMarker: {}
            }
          }
        },
        ListFunctions: {
          http: {
            method: "GET",
            requestUri: "/2015-03-31/functions/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MasterRegion: {
                location: "querystring",
                locationName: "MasterRegion"
              },
              FunctionVersion: {
                location: "querystring",
                locationName: "FunctionVersion"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              Functions: {
                shape: "S5s"
              }
            }
          }
        },
        ListFunctionsByCodeSigningConfig: {
          http: {
            method: "GET",
            requestUri: "/2020-04-22/code-signing-configs/{CodeSigningConfigArn}/functions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CodeSigningConfigArn"
            ],
            members: {
              CodeSigningConfigArn: {
                location: "uri",
                locationName: "CodeSigningConfigArn"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              FunctionArns: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListLayerVersions: {
          http: {
            method: "GET",
            requestUri: "/2018-10-31/layers/{LayerName}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "LayerName"
            ],
            members: {
              CompatibleRuntime: {
                location: "querystring",
                locationName: "CompatibleRuntime"
              },
              LayerName: {
                location: "uri",
                locationName: "LayerName"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              },
              CompatibleArchitecture: {
                location: "querystring",
                locationName: "CompatibleArchitecture"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              LayerVersions: {
                type: "list",
                member: {
                  shape: "S60"
                }
              }
            }
          }
        },
        ListLayers: {
          http: {
            method: "GET",
            requestUri: "/2018-10-31/layers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CompatibleRuntime: {
                location: "querystring",
                locationName: "CompatibleRuntime"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              },
              CompatibleArchitecture: {
                location: "querystring",
                locationName: "CompatibleArchitecture"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              Layers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LayerName: {},
                    LayerArn: {},
                    LatestMatchingVersion: {
                      shape: "S60"
                    }
                  }
                }
              }
            }
          }
        },
        ListProvisionedConcurrencyConfigs: {
          http: {
            method: "GET",
            requestUri: "/2019-09-30/functions/{FunctionName}/provisioned-concurrency?List=ALL",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisionedConcurrencyConfigs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FunctionArn: {},
                    RequestedProvisionedConcurrentExecutions: {
                      type: "integer"
                    },
                    AvailableProvisionedConcurrentExecutions: {
                      type: "integer"
                    },
                    AllocatedProvisionedConcurrentExecutions: {
                      type: "integer"
                    },
                    Status: {},
                    StatusReason: {},
                    LastModified: {}
                  }
                }
              },
              NextMarker: {}
            }
          }
        },
        ListTags: {
          http: {
            method: "GET",
            requestUri: "/2017-03-31/tags/{ARN}"
          },
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {
                location: "uri",
                locationName: "ARN"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S2p"
              }
            }
          }
        },
        ListVersionsByFunction: {
          http: {
            method: "GET",
            requestUri: "/2015-03-31/functions/{FunctionName}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Marker: {
                location: "querystring",
                locationName: "Marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "MaxItems",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              Versions: {
                shape: "S5s"
              }
            }
          }
        },
        PublishLayerVersion: {
          http: {
            requestUri: "/2018-10-31/layers/{LayerName}/versions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "LayerName",
              "Content"
            ],
            members: {
              LayerName: {
                location: "uri",
                locationName: "LayerName"
              },
              Description: {},
              Content: {
                type: "structure",
                members: {
                  S3Bucket: {},
                  S3Key: {},
                  S3ObjectVersion: {},
                  ZipFile: {
                    shape: "S23"
                  }
                }
              },
              CompatibleRuntimes: {
                shape: "S4p"
              },
              LicenseInfo: {},
              CompatibleArchitectures: {
                shape: "S4r"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Content: {
                shape: "S4n"
              },
              LayerArn: {},
              LayerVersionArn: {},
              Description: {},
              CreatedDate: {},
              Version: {
                type: "long"
              },
              CompatibleRuntimes: {
                shape: "S4p"
              },
              LicenseInfo: {},
              CompatibleArchitectures: {
                shape: "S4r"
              }
            }
          }
        },
        PublishVersion: {
          http: {
            requestUri: "/2015-03-31/functions/{FunctionName}/versions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              CodeSha256: {},
              Description: {},
              RevisionId: {}
            }
          },
          output: {
            shape: "S33"
          }
        },
        PutFunctionCodeSigningConfig: {
          http: {
            method: "PUT",
            requestUri: "/2020-06-30/functions/{FunctionName}/code-signing-config",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CodeSigningConfigArn",
              "FunctionName"
            ],
            members: {
              CodeSigningConfigArn: {},
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CodeSigningConfigArn",
              "FunctionName"
            ],
            members: {
              CodeSigningConfigArn: {},
              FunctionName: {}
            }
          }
        },
        PutFunctionConcurrency: {
          http: {
            method: "PUT",
            requestUri: "/2017-10-31/functions/{FunctionName}/concurrency",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "ReservedConcurrentExecutions"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              ReservedConcurrentExecutions: {
                type: "integer"
              }
            }
          },
          output: {
            shape: "S4a"
          }
        },
        PutFunctionEventInvokeConfig: {
          http: {
            method: "PUT",
            requestUri: "/2019-09-25/functions/{FunctionName}/event-invoke-config",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              },
              MaximumRetryAttempts: {
                type: "integer"
              },
              MaximumEventAgeInSeconds: {
                type: "integer"
              },
              DestinationConfig: {
                shape: "S1a"
              }
            }
          },
          output: {
            shape: "S4i"
          }
        },
        PutProvisionedConcurrencyConfig: {
          http: {
            method: "PUT",
            requestUri: "/2019-09-30/functions/{FunctionName}/provisioned-concurrency",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "Qualifier",
              "ProvisionedConcurrentExecutions"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              },
              ProvisionedConcurrentExecutions: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestedProvisionedConcurrentExecutions: {
                type: "integer"
              },
              AvailableProvisionedConcurrentExecutions: {
                type: "integer"
              },
              AllocatedProvisionedConcurrentExecutions: {
                type: "integer"
              },
              Status: {},
              StatusReason: {},
              LastModified: {}
            }
          }
        },
        RemoveLayerVersionPermission: {
          http: {
            method: "DELETE",
            requestUri: "/2018-10-31/layers/{LayerName}/versions/{VersionNumber}/policy/{StatementId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "LayerName",
              "VersionNumber",
              "StatementId"
            ],
            members: {
              LayerName: {
                location: "uri",
                locationName: "LayerName"
              },
              VersionNumber: {
                location: "uri",
                locationName: "VersionNumber",
                type: "long"
              },
              StatementId: {
                location: "uri",
                locationName: "StatementId"
              },
              RevisionId: {
                location: "querystring",
                locationName: "RevisionId"
              }
            }
          }
        },
        RemovePermission: {
          http: {
            method: "DELETE",
            requestUri: "/2015-03-31/functions/{FunctionName}/policy/{StatementId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "StatementId"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              StatementId: {
                location: "uri",
                locationName: "StatementId"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              },
              RevisionId: {
                location: "querystring",
                locationName: "RevisionId"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/2017-03-31/tags/{ARN}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "Tags"
            ],
            members: {
              Resource: {
                location: "uri",
                locationName: "ARN"
              },
              Tags: {
                shape: "S2p"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/2017-03-31/tags/{ARN}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Resource",
              "TagKeys"
            ],
            members: {
              Resource: {
                location: "uri",
                locationName: "ARN"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateAlias: {
          http: {
            method: "PUT",
            requestUri: "/2015-03-31/functions/{FunctionName}/aliases/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName",
              "Name"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              },
              FunctionVersion: {},
              Description: {},
              RoutingConfig: {
                shape: "Sn"
              },
              RevisionId: {}
            }
          },
          output: {
            shape: "Sr"
          }
        },
        UpdateCodeSigningConfig: {
          http: {
            method: "PUT",
            requestUri: "/2020-04-22/code-signing-configs/{CodeSigningConfigArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CodeSigningConfigArn"
            ],
            members: {
              CodeSigningConfigArn: {
                location: "uri",
                locationName: "CodeSigningConfigArn"
              },
              Description: {},
              AllowedPublishers: {
                shape: "Su"
              },
              CodeSigningPolicies: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CodeSigningConfig"
            ],
            members: {
              CodeSigningConfig: {
                shape: "Sz"
              }
            }
          }
        },
        UpdateEventSourceMapping: {
          http: {
            method: "PUT",
            requestUri: "/2015-03-31/event-source-mappings/{UUID}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "UUID"
            ],
            members: {
              UUID: {
                location: "uri",
                locationName: "UUID"
              },
              FunctionName: {},
              Enabled: {
                type: "boolean"
              },
              BatchSize: {
                type: "integer"
              },
              MaximumBatchingWindowInSeconds: {
                type: "integer"
              },
              DestinationConfig: {
                shape: "S1a"
              },
              MaximumRecordAgeInSeconds: {
                type: "integer"
              },
              BisectBatchOnFunctionError: {
                type: "boolean"
              },
              MaximumRetryAttempts: {
                type: "integer"
              },
              ParallelizationFactor: {
                type: "integer"
              },
              SourceAccessConfigurations: {
                shape: "S1m"
              },
              TumblingWindowInSeconds: {
                type: "integer"
              },
              FunctionResponseTypes: {
                shape: "S1v"
              }
            }
          },
          output: {
            shape: "S1x"
          }
        },
        UpdateFunctionCode: {
          http: {
            method: "PUT",
            requestUri: "/2015-03-31/functions/{FunctionName}/code",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              ZipFile: {
                shape: "S23"
              },
              S3Bucket: {},
              S3Key: {},
              S3ObjectVersion: {},
              ImageUri: {},
              Publish: {
                type: "boolean"
              },
              DryRun: {
                type: "boolean"
              },
              RevisionId: {},
              Architectures: {
                shape: "S31"
              }
            }
          },
          output: {
            shape: "S33"
          }
        },
        UpdateFunctionConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/2015-03-31/functions/{FunctionName}/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Role: {},
              Handler: {},
              Description: {},
              Timeout: {
                type: "integer"
              },
              MemorySize: {
                type: "integer"
              },
              VpcConfig: {
                shape: "S2a"
              },
              Environment: {
                shape: "S2i"
              },
              Runtime: {},
              DeadLetterConfig: {
                shape: "S2g"
              },
              KMSKeyArn: {},
              TracingConfig: {
                shape: "S2n"
              },
              RevisionId: {},
              Layers: {
                shape: "S2s"
              },
              FileSystemConfigs: {
                shape: "S2u"
              },
              ImageConfig: {
                shape: "S2y"
              }
            }
          },
          output: {
            shape: "S33"
          }
        },
        UpdateFunctionEventInvokeConfig: {
          http: {
            requestUri: "/2019-09-25/functions/{FunctionName}/event-invoke-config",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FunctionName"
            ],
            members: {
              FunctionName: {
                location: "uri",
                locationName: "FunctionName"
              },
              Qualifier: {
                location: "querystring",
                locationName: "Qualifier"
              },
              MaximumRetryAttempts: {
                type: "integer"
              },
              MaximumEventAgeInSeconds: {
                type: "integer"
              },
              DestinationConfig: {
                shape: "S1a"
              }
            }
          },
          output: {
            shape: "S4i"
          }
        }
      },
      shapes: {
        Sn: {
          type: "structure",
          members: {
            AdditionalVersionWeights: {
              type: "map",
              key: {},
              value: {
                type: "double"
              }
            }
          }
        },
        Sr: {
          type: "structure",
          members: {
            AliasArn: {},
            Name: {},
            FunctionVersion: {},
            Description: {},
            RoutingConfig: {
              shape: "Sn"
            },
            RevisionId: {}
          }
        },
        Su: {
          type: "structure",
          required: [
            "SigningProfileVersionArns"
          ],
          members: {
            SigningProfileVersionArns: {
              type: "list",
              member: {}
            }
          }
        },
        Sw: {
          type: "structure",
          members: {
            UntrustedArtifactOnDeployment: {}
          }
        },
        Sz: {
          type: "structure",
          required: [
            "CodeSigningConfigId",
            "CodeSigningConfigArn",
            "AllowedPublishers",
            "CodeSigningPolicies",
            "LastModified"
          ],
          members: {
            CodeSigningConfigId: {},
            CodeSigningConfigArn: {},
            Description: {},
            AllowedPublishers: {
              shape: "Su"
            },
            CodeSigningPolicies: {
              shape: "Sw"
            },
            LastModified: {}
          }
        },
        S1a: {
          type: "structure",
          members: {
            OnSuccess: {
              type: "structure",
              members: {
                Destination: {}
              }
            },
            OnFailure: {
              type: "structure",
              members: {
                Destination: {}
              }
            }
          }
        },
        S1i: {
          type: "list",
          member: {}
        },
        S1k: {
          type: "list",
          member: {}
        },
        S1m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              URI: {}
            }
          }
        },
        S1q: {
          type: "structure",
          members: {
            Endpoints: {
              type: "map",
              key: {},
              value: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S1v: {
          type: "list",
          member: {}
        },
        S1x: {
          type: "structure",
          members: {
            UUID: {},
            StartingPosition: {},
            StartingPositionTimestamp: {
              type: "timestamp"
            },
            BatchSize: {
              type: "integer"
            },
            MaximumBatchingWindowInSeconds: {
              type: "integer"
            },
            ParallelizationFactor: {
              type: "integer"
            },
            EventSourceArn: {},
            FunctionArn: {},
            LastModified: {
              type: "timestamp"
            },
            LastProcessingResult: {},
            State: {},
            StateTransitionReason: {},
            DestinationConfig: {
              shape: "S1a"
            },
            Topics: {
              shape: "S1i"
            },
            Queues: {
              shape: "S1k"
            },
            SourceAccessConfigurations: {
              shape: "S1m"
            },
            SelfManagedEventSource: {
              shape: "S1q"
            },
            MaximumRecordAgeInSeconds: {
              type: "integer"
            },
            BisectBatchOnFunctionError: {
              type: "boolean"
            },
            MaximumRetryAttempts: {
              type: "integer"
            },
            TumblingWindowInSeconds: {
              type: "integer"
            },
            FunctionResponseTypes: {
              shape: "S1v"
            }
          }
        },
        S23: {
          type: "blob",
          sensitive: true
        },
        S2a: {
          type: "structure",
          members: {
            SubnetIds: {
              shape: "S2b"
            },
            SecurityGroupIds: {
              shape: "S2d"
            }
          }
        },
        S2b: {
          type: "list",
          member: {}
        },
        S2d: {
          type: "list",
          member: {}
        },
        S2g: {
          type: "structure",
          members: {
            TargetArn: {}
          }
        },
        S2i: {
          type: "structure",
          members: {
            Variables: {
              shape: "S2j"
            }
          }
        },
        S2j: {
          type: "map",
          key: {
            type: "string",
            sensitive: true
          },
          value: {
            type: "string",
            sensitive: true
          },
          sensitive: true
        },
        S2n: {
          type: "structure",
          members: {
            Mode: {}
          }
        },
        S2p: {
          type: "map",
          key: {},
          value: {}
        },
        S2s: {
          type: "list",
          member: {}
        },
        S2u: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Arn",
              "LocalMountPath"
            ],
            members: {
              Arn: {},
              LocalMountPath: {}
            }
          }
        },
        S2y: {
          type: "structure",
          members: {
            EntryPoint: {
              shape: "S2z"
            },
            Command: {
              shape: "S2z"
            },
            WorkingDirectory: {}
          }
        },
        S2z: {
          type: "list",
          member: {}
        },
        S31: {
          type: "list",
          member: {}
        },
        S33: {
          type: "structure",
          members: {
            FunctionName: {},
            FunctionArn: {},
            Runtime: {},
            Role: {},
            Handler: {},
            CodeSize: {
              type: "long"
            },
            Description: {},
            Timeout: {
              type: "integer"
            },
            MemorySize: {
              type: "integer"
            },
            LastModified: {},
            CodeSha256: {},
            Version: {},
            VpcConfig: {
              type: "structure",
              members: {
                SubnetIds: {
                  shape: "S2b"
                },
                SecurityGroupIds: {
                  shape: "S2d"
                },
                VpcId: {}
              }
            },
            DeadLetterConfig: {
              shape: "S2g"
            },
            Environment: {
              type: "structure",
              members: {
                Variables: {
                  shape: "S2j"
                },
                Error: {
                  type: "structure",
                  members: {
                    ErrorCode: {},
                    Message: {
                      shape: "S3b"
                    }
                  }
                }
              }
            },
            KMSKeyArn: {},
            TracingConfig: {
              type: "structure",
              members: {
                Mode: {}
              }
            },
            MasterArn: {},
            RevisionId: {},
            Layers: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Arn: {},
                  CodeSize: {
                    type: "long"
                  },
                  SigningProfileVersionArn: {},
                  SigningJobArn: {}
                }
              }
            },
            State: {},
            StateReason: {},
            StateReasonCode: {},
            LastUpdateStatus: {},
            LastUpdateStatusReason: {},
            LastUpdateStatusReasonCode: {},
            FileSystemConfigs: {
              shape: "S2u"
            },
            PackageType: {},
            ImageConfigResponse: {
              type: "structure",
              members: {
                ImageConfig: {
                  shape: "S2y"
                },
                Error: {
                  type: "structure",
                  members: {
                    ErrorCode: {},
                    Message: {
                      shape: "S3b"
                    }
                  }
                }
              }
            },
            SigningProfileVersionArn: {},
            SigningJobArn: {},
            Architectures: {
              shape: "S31"
            }
          }
        },
        S3b: {
          type: "string",
          sensitive: true
        },
        S4a: {
          type: "structure",
          members: {
            ReservedConcurrentExecutions: {
              type: "integer"
            }
          }
        },
        S4i: {
          type: "structure",
          members: {
            LastModified: {
              type: "timestamp"
            },
            FunctionArn: {},
            MaximumRetryAttempts: {
              type: "integer"
            },
            MaximumEventAgeInSeconds: {
              type: "integer"
            },
            DestinationConfig: {
              shape: "S1a"
            }
          }
        },
        S4m: {
          type: "structure",
          members: {
            Content: {
              shape: "S4n"
            },
            LayerArn: {},
            LayerVersionArn: {},
            Description: {},
            CreatedDate: {},
            Version: {
              type: "long"
            },
            CompatibleRuntimes: {
              shape: "S4p"
            },
            LicenseInfo: {},
            CompatibleArchitectures: {
              shape: "S4r"
            }
          }
        },
        S4n: {
          type: "structure",
          members: {
            Location: {},
            CodeSha256: {},
            CodeSize: {
              type: "long"
            },
            SigningProfileVersionArn: {},
            SigningJobArn: {}
          }
        },
        S4p: {
          type: "list",
          member: {}
        },
        S4r: {
          type: "list",
          member: {}
        },
        S5s: {
          type: "list",
          member: {
            shape: "S33"
          }
        },
        S60: {
          type: "structure",
          members: {
            LayerVersionArn: {},
            Version: {
              type: "long"
            },
            Description: {},
            CreatedDate: {},
            CompatibleRuntimes: {
              shape: "S4p"
            },
            LicenseInfo: {},
            CompatibleArchitectures: {
              shape: "S4r"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/lambda-2015-03-31.paginators.json
var require_lambda_2015_03_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/lambda-2015-03-31.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAliases: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "Aliases"
        },
        ListCodeSigningConfigs: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "CodeSigningConfigs"
        },
        ListEventSourceMappings: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "EventSourceMappings"
        },
        ListFunctionEventInvokeConfigs: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "FunctionEventInvokeConfigs"
        },
        ListFunctions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "Functions"
        },
        ListFunctionsByCodeSigningConfig: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "FunctionArns"
        },
        ListLayerVersions: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "LayerVersions"
        },
        ListLayers: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "Layers"
        },
        ListProvisionedConcurrencyConfigs: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "ProvisionedConcurrencyConfigs"
        },
        ListVersionsByFunction: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextMarker",
          result_key: "Versions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/lambda-2015-03-31.waiters2.json
var require_lambda_2015_03_31_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/lambda-2015-03-31.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        FunctionExists: {
          delay: 1,
          operation: "GetFunction",
          maxAttempts: 20,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 200
            },
            {
              state: "retry",
              matcher: "error",
              expected: "ResourceNotFoundException"
            }
          ]
        },
        FunctionActive: {
          delay: 5,
          maxAttempts: 60,
          operation: "GetFunctionConfiguration",
          description: "Waits for the function's State to be Active.",
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "Active"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "State",
              expected: "Failed"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "Pending"
            }
          ]
        },
        FunctionUpdated: {
          delay: 5,
          maxAttempts: 60,
          operation: "GetFunctionConfiguration",
          description: "Waits for the function's LastUpdateStatus to be Successful.",
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "LastUpdateStatus",
              expected: "Successful"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "LastUpdateStatus",
              expected: "Failed"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "LastUpdateStatus",
              expected: "InProgress"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/lambda.js
var require_lambda2 = __commonJS({
  "node_modules/aws-sdk/clients/lambda.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["lambda"] = {};
    AWS3.Lambda = Service.defineService("lambda", ["2014-11-11", "2015-03-31"]);
    require_lambda();
    Object.defineProperty(apiLoader.services["lambda"], "2014-11-11", {
      get: function get() {
        var model = require_lambda_2014_11_11_min();
        model.paginators = require_lambda_2014_11_11_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["lambda"], "2015-03-31", {
      get: function get() {
        var model = require_lambda_2015_03_31_min();
        model.paginators = require_lambda_2015_03_31_paginators().pagination;
        model.waiters = require_lambda_2015_03_31_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Lambda;
  }
});

// node_modules/aws-sdk/apis/runtime.lex-2016-11-28.min.json
var require_runtime_lex_2016_11_28_min = __commonJS({
  "node_modules/aws-sdk/apis/runtime.lex-2016-11-28.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-11-28",
        endpointPrefix: "runtime.lex",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Lex Runtime Service",
        serviceId: "Lex Runtime Service",
        signatureVersion: "v4",
        signingName: "lex",
        uid: "runtime.lex-2016-11-28"
      },
      operations: {
        DeleteSession: {
          http: {
            method: "DELETE",
            requestUri: "/bot/{botName}/alias/{botAlias}/user/{userId}/session"
          },
          input: {
            type: "structure",
            required: [
              "botName",
              "botAlias",
              "userId"
            ],
            members: {
              botName: {
                location: "uri",
                locationName: "botName"
              },
              botAlias: {
                location: "uri",
                locationName: "botAlias"
              },
              userId: {
                location: "uri",
                locationName: "userId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botName: {},
              botAlias: {},
              userId: {},
              sessionId: {}
            }
          }
        },
        GetSession: {
          http: {
            method: "GET",
            requestUri: "/bot/{botName}/alias/{botAlias}/user/{userId}/session/"
          },
          input: {
            type: "structure",
            required: [
              "botName",
              "botAlias",
              "userId"
            ],
            members: {
              botName: {
                location: "uri",
                locationName: "botName"
              },
              botAlias: {
                location: "uri",
                locationName: "botAlias"
              },
              userId: {
                location: "uri",
                locationName: "userId"
              },
              checkpointLabelFilter: {
                location: "querystring",
                locationName: "checkpointLabelFilter"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              recentIntentSummaryView: {
                shape: "Sa"
              },
              sessionAttributes: {
                shape: "Sd"
              },
              sessionId: {},
              dialogAction: {
                shape: "Sh"
              },
              activeContexts: {
                shape: "Sk"
              }
            }
          }
        },
        PostContent: {
          http: {
            requestUri: "/bot/{botName}/alias/{botAlias}/user/{userId}/content"
          },
          input: {
            type: "structure",
            required: [
              "botName",
              "botAlias",
              "userId",
              "contentType",
              "inputStream"
            ],
            members: {
              botName: {
                location: "uri",
                locationName: "botName"
              },
              botAlias: {
                location: "uri",
                locationName: "botAlias"
              },
              userId: {
                location: "uri",
                locationName: "userId"
              },
              sessionAttributes: {
                shape: "St",
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-session-attributes"
              },
              requestAttributes: {
                shape: "St",
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-request-attributes"
              },
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              accept: {
                location: "header",
                locationName: "Accept"
              },
              inputStream: {
                shape: "Sw"
              },
              activeContexts: {
                shape: "Sx",
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-active-contexts"
              }
            },
            payload: "inputStream"
          },
          output: {
            type: "structure",
            members: {
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              intentName: {
                location: "header",
                locationName: "x-amz-lex-intent-name"
              },
              nluIntentConfidence: {
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-nlu-intent-confidence"
              },
              alternativeIntents: {
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-alternative-intents"
              },
              slots: {
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-slots"
              },
              sessionAttributes: {
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-session-attributes"
              },
              sentimentResponse: {
                location: "header",
                locationName: "x-amz-lex-sentiment"
              },
              message: {
                shape: "Si",
                deprecated: true,
                deprecatedMessage: "The message field is deprecated, use the encodedMessage field instead. The message field is available only in the de-DE, en-AU, en-GB, en-US, es-419, es-ES, es-US, fr-CA, fr-FR and it-IT locales.",
                location: "header",
                locationName: "x-amz-lex-message"
              },
              encodedMessage: {
                shape: "Sz",
                location: "header",
                locationName: "x-amz-lex-encoded-message"
              },
              messageFormat: {
                location: "header",
                locationName: "x-amz-lex-message-format"
              },
              dialogState: {
                location: "header",
                locationName: "x-amz-lex-dialog-state"
              },
              slotToElicit: {
                location: "header",
                locationName: "x-amz-lex-slot-to-elicit"
              },
              inputTranscript: {
                deprecated: true,
                deprecatedMessage: "The inputTranscript field is deprecated, use the encodedInputTranscript field instead. The inputTranscript field is available only in the de-DE, en-AU, en-GB, en-US, es-419, es-ES, es-US, fr-CA, fr-FR and it-IT locales.",
                location: "header",
                locationName: "x-amz-lex-input-transcript"
              },
              encodedInputTranscript: {
                location: "header",
                locationName: "x-amz-lex-encoded-input-transcript",
                type: "string",
                sensitive: true
              },
              audioStream: {
                shape: "Sw"
              },
              botVersion: {
                location: "header",
                locationName: "x-amz-lex-bot-version"
              },
              sessionId: {
                location: "header",
                locationName: "x-amz-lex-session-id"
              },
              activeContexts: {
                shape: "Sx",
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-active-contexts"
              }
            },
            payload: "audioStream"
          },
          authtype: "v4-unsigned-body"
        },
        PostText: {
          http: {
            requestUri: "/bot/{botName}/alias/{botAlias}/user/{userId}/text"
          },
          input: {
            type: "structure",
            required: [
              "botName",
              "botAlias",
              "userId",
              "inputText"
            ],
            members: {
              botName: {
                location: "uri",
                locationName: "botName"
              },
              botAlias: {
                location: "uri",
                locationName: "botAlias"
              },
              userId: {
                location: "uri",
                locationName: "userId"
              },
              sessionAttributes: {
                shape: "Sd"
              },
              requestAttributes: {
                shape: "Sd"
              },
              inputText: {
                shape: "Si"
              },
              activeContexts: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              intentName: {},
              nluIntentConfidence: {
                shape: "S15"
              },
              alternativeIntents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    intentName: {},
                    nluIntentConfidence: {
                      shape: "S15"
                    },
                    slots: {
                      shape: "Sd"
                    }
                  }
                }
              },
              slots: {
                shape: "Sd"
              },
              sessionAttributes: {
                shape: "Sd"
              },
              message: {
                shape: "Si"
              },
              sentimentResponse: {
                type: "structure",
                members: {
                  sentimentLabel: {},
                  sentimentScore: {}
                }
              },
              messageFormat: {},
              dialogState: {},
              slotToElicit: {},
              responseCard: {
                type: "structure",
                members: {
                  version: {},
                  contentType: {},
                  genericAttachments: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        title: {},
                        subTitle: {},
                        attachmentLinkUrl: {},
                        imageUrl: {},
                        buttons: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "text",
                              "value"
                            ],
                            members: {
                              text: {},
                              value: {}
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              sessionId: {},
              botVersion: {},
              activeContexts: {
                shape: "Sk"
              }
            }
          }
        },
        PutSession: {
          http: {
            requestUri: "/bot/{botName}/alias/{botAlias}/user/{userId}/session"
          },
          input: {
            type: "structure",
            required: [
              "botName",
              "botAlias",
              "userId"
            ],
            members: {
              botName: {
                location: "uri",
                locationName: "botName"
              },
              botAlias: {
                location: "uri",
                locationName: "botAlias"
              },
              userId: {
                location: "uri",
                locationName: "userId"
              },
              sessionAttributes: {
                shape: "Sd"
              },
              dialogAction: {
                shape: "Sh"
              },
              recentIntentSummaryView: {
                shape: "Sa"
              },
              accept: {
                location: "header",
                locationName: "Accept"
              },
              activeContexts: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              intentName: {
                location: "header",
                locationName: "x-amz-lex-intent-name"
              },
              slots: {
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-slots"
              },
              sessionAttributes: {
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-session-attributes"
              },
              message: {
                shape: "Si",
                deprecated: true,
                deprecatedMessage: "The message field is deprecated, use the encodedMessage field instead. The message field is available only in the de-DE, en-AU, en-GB, en-US, es-419, es-ES, es-US, fr-CA, fr-FR and it-IT locales.",
                location: "header",
                locationName: "x-amz-lex-message"
              },
              encodedMessage: {
                shape: "Sz",
                location: "header",
                locationName: "x-amz-lex-encoded-message"
              },
              messageFormat: {
                location: "header",
                locationName: "x-amz-lex-message-format"
              },
              dialogState: {
                location: "header",
                locationName: "x-amz-lex-dialog-state"
              },
              slotToElicit: {
                location: "header",
                locationName: "x-amz-lex-slot-to-elicit"
              },
              audioStream: {
                shape: "Sw"
              },
              sessionId: {
                location: "header",
                locationName: "x-amz-lex-session-id"
              },
              activeContexts: {
                shape: "Sx",
                jsonvalue: true,
                location: "header",
                locationName: "x-amz-lex-active-contexts"
              }
            },
            payload: "audioStream"
          }
        }
      },
      shapes: {
        Sa: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "dialogActionType"
            ],
            members: {
              intentName: {},
              checkpointLabel: {},
              slots: {
                shape: "Sd"
              },
              confirmationStatus: {},
              dialogActionType: {},
              fulfillmentState: {},
              slotToElicit: {}
            }
          }
        },
        Sd: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        Sh: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            intentName: {},
            slots: {
              shape: "Sd"
            },
            slotToElicit: {},
            fulfillmentState: {},
            message: {
              shape: "Si"
            },
            messageFormat: {}
          }
        },
        Si: {
          type: "string",
          sensitive: true
        },
        Sk: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "timeToLive",
              "parameters"
            ],
            members: {
              name: {},
              timeToLive: {
                type: "structure",
                members: {
                  timeToLiveInSeconds: {
                    type: "integer"
                  },
                  turnsToLive: {
                    type: "integer"
                  }
                }
              },
              parameters: {
                type: "map",
                key: {},
                value: {
                  shape: "Si"
                }
              }
            }
          },
          sensitive: true
        },
        St: {
          type: "string",
          sensitive: true
        },
        Sw: {
          type: "blob",
          streaming: true
        },
        Sx: {
          type: "string",
          sensitive: true
        },
        Sz: {
          type: "string",
          sensitive: true
        },
        S15: {
          type: "structure",
          members: {
            score: {
              type: "double"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/runtime.lex-2016-11-28.paginators.json
var require_runtime_lex_2016_11_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/runtime.lex-2016-11-28.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/lexruntime.js
var require_lexruntime = __commonJS({
  "node_modules/aws-sdk/clients/lexruntime.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["lexruntime"] = {};
    AWS3.LexRuntime = Service.defineService("lexruntime", ["2016-11-28"]);
    Object.defineProperty(apiLoader.services["lexruntime"], "2016-11-28", {
      get: function get() {
        var model = require_runtime_lex_2016_11_28_min();
        model.paginators = require_runtime_lex_2016_11_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.LexRuntime;
  }
});

// node_modules/aws-sdk/apis/lightsail-2016-11-28.min.json
var require_lightsail_2016_11_28_min = __commonJS({
  "node_modules/aws-sdk/apis/lightsail-2016-11-28.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-11-28",
        endpointPrefix: "lightsail",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Lightsail",
        serviceId: "Lightsail",
        signatureVersion: "v4",
        targetPrefix: "Lightsail_20161128",
        uid: "lightsail-2016-11-28"
      },
      operations: {
        AllocateStaticIp: {
          input: {
            type: "structure",
            required: [
              "staticIpName"
            ],
            members: {
              staticIpName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        AttachCertificateToDistribution: {
          input: {
            type: "structure",
            required: [
              "distributionName",
              "certificateName"
            ],
            members: {
              distributionName: {},
              certificateName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        AttachDisk: {
          input: {
            type: "structure",
            required: [
              "diskName",
              "instanceName",
              "diskPath"
            ],
            members: {
              diskName: {},
              instanceName: {},
              diskPath: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        AttachInstancesToLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName",
              "instanceNames"
            ],
            members: {
              loadBalancerName: {},
              instanceNames: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        AttachLoadBalancerTlsCertificate: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName",
              "certificateName"
            ],
            members: {
              loadBalancerName: {},
              certificateName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        AttachStaticIp: {
          input: {
            type: "structure",
            required: [
              "staticIpName",
              "instanceName"
            ],
            members: {
              staticIpName: {},
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CloseInstancePublicPorts: {
          input: {
            type: "structure",
            required: [
              "portInfo",
              "instanceName"
            ],
            members: {
              portInfo: {
                shape: "Sr"
              },
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        CopySnapshot: {
          input: {
            type: "structure",
            required: [
              "targetSnapshotName",
              "sourceRegion"
            ],
            members: {
              sourceSnapshotName: {},
              sourceResourceName: {},
              restoreDate: {},
              useLatestRestorableAutoSnapshot: {
                type: "boolean"
              },
              targetSnapshotName: {},
              sourceRegion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateBucket: {
          input: {
            type: "structure",
            required: [
              "bucketName",
              "bundleId"
            ],
            members: {
              bucketName: {},
              bundleId: {},
              tags: {
                shape: "S10"
              },
              enableObjectVersioning: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              bucket: {
                shape: "S15"
              },
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateBucketAccessKey: {
          input: {
            type: "structure",
            required: [
              "bucketName"
            ],
            members: {
              bucketName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              accessKey: {
                shape: "S1e"
              },
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateCertificate: {
          input: {
            type: "structure",
            required: [
              "certificateName",
              "domainName"
            ],
            members: {
              certificateName: {},
              domainName: {},
              subjectAlternativeNames: {
                shape: "S1l"
              },
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              certificate: {
                shape: "S1n"
              },
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateCloudFormationStack: {
          input: {
            type: "structure",
            required: [
              "instances"
            ],
            members: {
              instances: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "sourceName",
                    "instanceType",
                    "portInfoSource",
                    "availabilityZone"
                  ],
                  members: {
                    sourceName: {},
                    instanceType: {},
                    portInfoSource: {},
                    userData: {},
                    availabilityZone: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateContactMethod: {
          input: {
            type: "structure",
            required: [
              "protocol",
              "contactEndpoint"
            ],
            members: {
              protocol: {},
              contactEndpoint: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateContainerService: {
          input: {
            type: "structure",
            required: [
              "serviceName",
              "power",
              "scale"
            ],
            members: {
              serviceName: {},
              power: {},
              scale: {
                type: "integer"
              },
              tags: {
                shape: "S10"
              },
              publicDomainNames: {
                shape: "S2g"
              },
              deployment: {
                type: "structure",
                members: {
                  containers: {
                    shape: "S2j"
                  },
                  publicEndpoint: {
                    shape: "S2p"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              containerService: {
                shape: "S2t"
              }
            }
          }
        },
        CreateContainerServiceDeployment: {
          input: {
            type: "structure",
            required: [
              "serviceName"
            ],
            members: {
              serviceName: {},
              containers: {
                shape: "S2j"
              },
              publicEndpoint: {
                shape: "S2p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              containerService: {
                shape: "S2t"
              }
            }
          }
        },
        CreateContainerServiceRegistryLogin: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              registryLogin: {
                type: "structure",
                members: {
                  username: {},
                  password: {},
                  expiresAt: {
                    type: "timestamp"
                  },
                  registry: {}
                }
              }
            }
          }
        },
        CreateDisk: {
          input: {
            type: "structure",
            required: [
              "diskName",
              "availabilityZone",
              "sizeInGb"
            ],
            members: {
              diskName: {},
              availabilityZone: {},
              sizeInGb: {
                type: "integer"
              },
              tags: {
                shape: "S10"
              },
              addOns: {
                shape: "S36"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateDiskFromSnapshot: {
          input: {
            type: "structure",
            required: [
              "diskName",
              "availabilityZone",
              "sizeInGb"
            ],
            members: {
              diskName: {},
              diskSnapshotName: {},
              availabilityZone: {},
              sizeInGb: {
                type: "integer"
              },
              tags: {
                shape: "S10"
              },
              addOns: {
                shape: "S36"
              },
              sourceDiskName: {},
              restoreDate: {},
              useLatestRestorableAutoSnapshot: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateDiskSnapshot: {
          input: {
            type: "structure",
            required: [
              "diskSnapshotName"
            ],
            members: {
              diskName: {},
              diskSnapshotName: {},
              instanceName: {},
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateDistribution: {
          input: {
            type: "structure",
            required: [
              "distributionName",
              "origin",
              "defaultCacheBehavior",
              "bundleId"
            ],
            members: {
              distributionName: {},
              origin: {
                shape: "S3h"
              },
              defaultCacheBehavior: {
                shape: "S3j"
              },
              cacheBehaviorSettings: {
                shape: "S3l"
              },
              cacheBehaviors: {
                shape: "S3t"
              },
              bundleId: {},
              ipAddressType: {},
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              distribution: {
                shape: "S3x"
              },
              operation: {
                shape: "S5"
              }
            }
          }
        },
        CreateDomain: {
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {},
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        CreateDomainEntry: {
          input: {
            type: "structure",
            required: [
              "domainName",
              "domainEntry"
            ],
            members: {
              domainName: {},
              domainEntry: {
                shape: "S42"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        CreateInstanceSnapshot: {
          input: {
            type: "structure",
            required: [
              "instanceSnapshotName",
              "instanceName"
            ],
            members: {
              instanceSnapshotName: {},
              instanceName: {},
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateInstances: {
          input: {
            type: "structure",
            required: [
              "instanceNames",
              "availabilityZone",
              "blueprintId",
              "bundleId"
            ],
            members: {
              instanceNames: {
                shape: "Su"
              },
              availabilityZone: {},
              customImageName: {
                deprecated: true
              },
              blueprintId: {},
              bundleId: {},
              userData: {},
              keyPairName: {},
              tags: {
                shape: "S10"
              },
              addOns: {
                shape: "S36"
              },
              ipAddressType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateInstancesFromSnapshot: {
          input: {
            type: "structure",
            required: [
              "instanceNames",
              "availabilityZone",
              "bundleId"
            ],
            members: {
              instanceNames: {
                shape: "Su"
              },
              attachedDiskMapping: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      originalDiskPath: {},
                      newDiskName: {}
                    }
                  }
                }
              },
              availabilityZone: {},
              instanceSnapshotName: {},
              bundleId: {},
              userData: {},
              keyPairName: {},
              tags: {
                shape: "S10"
              },
              addOns: {
                shape: "S36"
              },
              ipAddressType: {},
              sourceInstanceName: {},
              restoreDate: {},
              useLatestRestorableAutoSnapshot: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateKeyPair: {
          input: {
            type: "structure",
            required: [
              "keyPairName"
            ],
            members: {
              keyPairName: {},
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              keyPair: {
                shape: "S4i"
              },
              publicKeyBase64: {},
              privateKeyBase64: {},
              operation: {
                shape: "S5"
              }
            }
          }
        },
        CreateLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName",
              "instancePort"
            ],
            members: {
              loadBalancerName: {},
              instancePort: {
                type: "integer"
              },
              healthCheckPath: {},
              certificateName: {},
              certificateDomainName: {},
              certificateAlternativeNames: {
                shape: "S4l"
              },
              tags: {
                shape: "S10"
              },
              ipAddressType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateLoadBalancerTlsCertificate: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName",
              "certificateName",
              "certificateDomainName"
            ],
            members: {
              loadBalancerName: {},
              certificateName: {},
              certificateDomainName: {},
              certificateAlternativeNames: {
                shape: "S4l"
              },
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateRelationalDatabase: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName",
              "relationalDatabaseBlueprintId",
              "relationalDatabaseBundleId",
              "masterDatabaseName",
              "masterUsername"
            ],
            members: {
              relationalDatabaseName: {},
              availabilityZone: {},
              relationalDatabaseBlueprintId: {},
              relationalDatabaseBundleId: {},
              masterDatabaseName: {},
              masterUsername: {},
              masterUserPassword: {
                shape: "S4q"
              },
              preferredBackupWindow: {},
              preferredMaintenanceWindow: {},
              publiclyAccessible: {
                type: "boolean"
              },
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateRelationalDatabaseFromSnapshot: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {},
              availabilityZone: {},
              publiclyAccessible: {
                type: "boolean"
              },
              relationalDatabaseSnapshotName: {},
              relationalDatabaseBundleId: {},
              sourceRelationalDatabaseName: {},
              restoreTime: {
                type: "timestamp"
              },
              useLatestRestorableTime: {
                type: "boolean"
              },
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        CreateRelationalDatabaseSnapshot: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName",
              "relationalDatabaseSnapshotName"
            ],
            members: {
              relationalDatabaseName: {},
              relationalDatabaseSnapshotName: {},
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteAlarm: {
          input: {
            type: "structure",
            required: [
              "alarmName"
            ],
            members: {
              alarmName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteAutoSnapshot: {
          input: {
            type: "structure",
            required: [
              "resourceName",
              "date"
            ],
            members: {
              resourceName: {},
              date: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteBucket: {
          input: {
            type: "structure",
            required: [
              "bucketName"
            ],
            members: {
              bucketName: {},
              forceDelete: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteBucketAccessKey: {
          input: {
            type: "structure",
            required: [
              "bucketName",
              "accessKeyId"
            ],
            members: {
              bucketName: {},
              accessKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteCertificate: {
          input: {
            type: "structure",
            required: [
              "certificateName"
            ],
            members: {
              certificateName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteContactMethod: {
          input: {
            type: "structure",
            required: [
              "protocol"
            ],
            members: {
              protocol: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteContainerImage: {
          input: {
            type: "structure",
            required: [
              "serviceName",
              "image"
            ],
            members: {
              serviceName: {},
              image: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteContainerService: {
          input: {
            type: "structure",
            required: [
              "serviceName"
            ],
            members: {
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDisk: {
          input: {
            type: "structure",
            required: [
              "diskName"
            ],
            members: {
              diskName: {},
              forceDeleteAddOns: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteDiskSnapshot: {
          input: {
            type: "structure",
            required: [
              "diskSnapshotName"
            ],
            members: {
              diskSnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteDistribution: {
          input: {
            type: "structure",
            members: {
              distributionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        DeleteDomain: {
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        DeleteDomainEntry: {
          input: {
            type: "structure",
            required: [
              "domainName",
              "domainEntry"
            ],
            members: {
              domainName: {},
              domainEntry: {
                shape: "S42"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        DeleteInstance: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {},
              forceDeleteAddOns: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteInstanceSnapshot: {
          input: {
            type: "structure",
            required: [
              "instanceSnapshotName"
            ],
            members: {
              instanceSnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteKeyPair: {
          input: {
            type: "structure",
            required: [
              "keyPairName"
            ],
            members: {
              keyPairName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        DeleteKnownHostKeys: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName"
            ],
            members: {
              loadBalancerName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteLoadBalancerTlsCertificate: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName",
              "certificateName"
            ],
            members: {
              loadBalancerName: {},
              certificateName: {},
              force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteRelationalDatabase: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {},
              skipFinalSnapshot: {
                type: "boolean"
              },
              finalRelationalDatabaseSnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DeleteRelationalDatabaseSnapshot: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseSnapshotName"
            ],
            members: {
              relationalDatabaseSnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DetachCertificateFromDistribution: {
          input: {
            type: "structure",
            required: [
              "distributionName"
            ],
            members: {
              distributionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        DetachDisk: {
          input: {
            type: "structure",
            required: [
              "diskName"
            ],
            members: {
              diskName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DetachInstancesFromLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName",
              "instanceNames"
            ],
            members: {
              loadBalancerName: {},
              instanceNames: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DetachStaticIp: {
          input: {
            type: "structure",
            required: [
              "staticIpName"
            ],
            members: {
              staticIpName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DisableAddOn: {
          input: {
            type: "structure",
            required: [
              "addOnType",
              "resourceName"
            ],
            members: {
              addOnType: {},
              resourceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        DownloadDefaultKeyPair: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              publicKeyBase64: {},
              privateKeyBase64: {}
            }
          }
        },
        EnableAddOn: {
          input: {
            type: "structure",
            required: [
              "resourceName",
              "addOnRequest"
            ],
            members: {
              resourceName: {},
              addOnRequest: {
                shape: "S37"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        ExportSnapshot: {
          input: {
            type: "structure",
            required: [
              "sourceSnapshotName"
            ],
            members: {
              sourceSnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        GetActiveNames: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              activeNames: {
                shape: "Su"
              },
              nextPageToken: {}
            }
          }
        },
        GetAlarms: {
          input: {
            type: "structure",
            members: {
              alarmName: {},
              pageToken: {},
              monitoredResourceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              alarms: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    location: {
                      shape: "S9"
                    },
                    resourceType: {},
                    supportCode: {},
                    monitoredResourceInfo: {
                      type: "structure",
                      members: {
                        arn: {},
                        name: {},
                        resourceType: {}
                      }
                    },
                    comparisonOperator: {},
                    evaluationPeriods: {
                      type: "integer"
                    },
                    period: {
                      type: "integer"
                    },
                    threshold: {
                      type: "double"
                    },
                    datapointsToAlarm: {
                      type: "integer"
                    },
                    treatMissingData: {},
                    statistic: {},
                    metricName: {},
                    state: {},
                    unit: {},
                    contactProtocols: {
                      shape: "S6z"
                    },
                    notificationTriggers: {
                      shape: "S70"
                    },
                    notificationEnabled: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetAutoSnapshots: {
          input: {
            type: "structure",
            required: [
              "resourceName"
            ],
            members: {
              resourceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceName: {},
              resourceType: {},
              autoSnapshots: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    date: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    status: {},
                    fromAttachedDisks: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          path: {},
                          sizeInGb: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetBlueprints: {
          input: {
            type: "structure",
            members: {
              includeInactive: {
                type: "boolean"
              },
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              blueprints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    blueprintId: {},
                    name: {},
                    group: {},
                    type: {},
                    description: {},
                    isActive: {
                      type: "boolean"
                    },
                    minPower: {
                      type: "integer"
                    },
                    version: {},
                    versionCode: {},
                    productUrl: {},
                    licenseUrl: {},
                    platform: {}
                  }
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetBucketAccessKeys: {
          input: {
            type: "structure",
            required: [
              "bucketName"
            ],
            members: {
              bucketName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              accessKeys: {
                type: "list",
                member: {
                  shape: "S1e"
                }
              }
            }
          }
        },
        GetBucketBundles: {
          input: {
            type: "structure",
            members: {
              includeInactive: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              bundles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    bundleId: {},
                    name: {},
                    price: {
                      type: "float"
                    },
                    storagePerMonthInGb: {
                      type: "integer"
                    },
                    transferPerMonthInGb: {
                      type: "integer"
                    },
                    isActive: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        GetBucketMetricData: {
          input: {
            type: "structure",
            required: [
              "bucketName",
              "metricName",
              "startTime",
              "endTime",
              "period",
              "statistics",
              "unit"
            ],
            members: {
              bucketName: {},
              metricName: {},
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              period: {
                type: "integer"
              },
              statistics: {
                shape: "S7o"
              },
              unit: {}
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              metricData: {
                shape: "S7q"
              }
            }
          }
        },
        GetBuckets: {
          input: {
            type: "structure",
            members: {
              bucketName: {},
              pageToken: {},
              includeConnectedResources: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              buckets: {
                type: "list",
                member: {
                  shape: "S15"
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetBundles: {
          input: {
            type: "structure",
            members: {
              includeInactive: {
                type: "boolean"
              },
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              bundles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    price: {
                      type: "float"
                    },
                    cpuCount: {
                      type: "integer"
                    },
                    diskSizeInGb: {
                      type: "integer"
                    },
                    bundleId: {},
                    instanceType: {},
                    isActive: {
                      type: "boolean"
                    },
                    name: {},
                    power: {
                      type: "integer"
                    },
                    ramSizeInGb: {
                      type: "float"
                    },
                    transferPerMonthInGb: {
                      type: "integer"
                    },
                    supportedPlatforms: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetCertificates: {
          input: {
            type: "structure",
            members: {
              certificateStatuses: {
                type: "list",
                member: {}
              },
              includeCertificateDetails: {
                type: "boolean"
              },
              certificateName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              certificates: {
                type: "list",
                member: {
                  shape: "S1n"
                }
              }
            }
          }
        },
        GetCloudFormationStackRecords: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              cloudFormationStackRecords: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    location: {
                      shape: "S9"
                    },
                    resourceType: {},
                    state: {},
                    sourceInfo: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          resourceType: {},
                          name: {},
                          arn: {}
                        }
                      }
                    },
                    destinationInfo: {
                      shape: "S8e"
                    }
                  }
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetContactMethods: {
          input: {
            type: "structure",
            members: {
              protocols: {
                shape: "S6z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contactMethods: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    contactEndpoint: {},
                    status: {},
                    protocol: {},
                    name: {},
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    location: {
                      shape: "S9"
                    },
                    resourceType: {},
                    supportCode: {}
                  }
                }
              }
            }
          }
        },
        GetContainerAPIMetadata: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              metadata: {
                type: "list",
                member: {
                  type: "map",
                  key: {},
                  value: {}
                }
              }
            }
          }
        },
        GetContainerImages: {
          input: {
            type: "structure",
            required: [
              "serviceName"
            ],
            members: {
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              containerImages: {
                type: "list",
                member: {
                  shape: "S8r"
                }
              }
            }
          }
        },
        GetContainerLog: {
          input: {
            type: "structure",
            required: [
              "serviceName",
              "containerName"
            ],
            members: {
              serviceName: {},
              containerName: {},
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              filterPattern: {},
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              logEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    createdAt: {
                      type: "timestamp"
                    },
                    message: {}
                  }
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetContainerServiceDeployments: {
          input: {
            type: "structure",
            required: [
              "serviceName"
            ],
            members: {
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deployments: {
                type: "list",
                member: {
                  shape: "S2x"
                }
              }
            }
          }
        },
        GetContainerServiceMetricData: {
          input: {
            type: "structure",
            required: [
              "serviceName",
              "metricName",
              "startTime",
              "endTime",
              "period",
              "statistics"
            ],
            members: {
              serviceName: {},
              metricName: {},
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              period: {
                type: "integer"
              },
              statistics: {
                shape: "S7o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              metricData: {
                shape: "S7q"
              }
            }
          }
        },
        GetContainerServicePowers: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              powers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    powerId: {},
                    price: {
                      type: "float"
                    },
                    cpuCount: {
                      type: "float"
                    },
                    ramSizeInGb: {
                      type: "float"
                    },
                    name: {},
                    isActive: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        GetContainerServices: {
          input: {
            type: "structure",
            members: {
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              containerServices: {
                type: "list",
                member: {
                  shape: "S2t"
                }
              }
            }
          }
        },
        GetDisk: {
          input: {
            type: "structure",
            required: [
              "diskName"
            ],
            members: {
              diskName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              disk: {
                shape: "S9b"
              }
            }
          }
        },
        GetDiskSnapshot: {
          input: {
            type: "structure",
            required: [
              "diskSnapshotName"
            ],
            members: {
              diskSnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              diskSnapshot: {
                shape: "S9h"
              }
            }
          }
        },
        GetDiskSnapshots: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              diskSnapshots: {
                type: "list",
                member: {
                  shape: "S9h"
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetDisks: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              disks: {
                shape: "S9o"
              },
              nextPageToken: {}
            }
          }
        },
        GetDistributionBundles: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              bundles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    bundleId: {},
                    name: {},
                    price: {
                      type: "float"
                    },
                    transferPerMonthInGb: {
                      type: "integer"
                    },
                    isActive: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        GetDistributionLatestCacheReset: {
          input: {
            type: "structure",
            members: {
              distributionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              status: {},
              createTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetDistributionMetricData: {
          input: {
            type: "structure",
            required: [
              "distributionName",
              "metricName",
              "startTime",
              "endTime",
              "period",
              "unit",
              "statistics"
            ],
            members: {
              distributionName: {},
              metricName: {},
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              period: {
                type: "integer"
              },
              unit: {},
              statistics: {
                shape: "S7o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              metricData: {
                shape: "S7q"
              }
            }
          }
        },
        GetDistributions: {
          input: {
            type: "structure",
            members: {
              distributionName: {},
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              distributions: {
                type: "list",
                member: {
                  shape: "S3x"
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetDomain: {
          input: {
            type: "structure",
            required: [
              "domainName"
            ],
            members: {
              domainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              domain: {
                shape: "Sa3"
              }
            }
          }
        },
        GetDomains: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              domains: {
                type: "list",
                member: {
                  shape: "Sa3"
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetExportSnapshotRecords: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              exportSnapshotRecords: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    location: {
                      shape: "S9"
                    },
                    resourceType: {},
                    state: {},
                    sourceInfo: {
                      type: "structure",
                      members: {
                        resourceType: {},
                        createdAt: {
                          type: "timestamp"
                        },
                        name: {},
                        arn: {},
                        fromResourceName: {},
                        fromResourceArn: {},
                        instanceSnapshotInfo: {
                          type: "structure",
                          members: {
                            fromBundleId: {},
                            fromBlueprintId: {},
                            fromDiskInfo: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  name: {},
                                  path: {},
                                  sizeInGb: {
                                    type: "integer"
                                  },
                                  isSystemDisk: {
                                    type: "boolean"
                                  }
                                }
                              }
                            }
                          }
                        },
                        diskSnapshotInfo: {
                          type: "structure",
                          members: {
                            sizeInGb: {
                              type: "integer"
                            }
                          }
                        }
                      }
                    },
                    destinationInfo: {
                      shape: "S8e"
                    }
                  }
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetInstance: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              instance: {
                shape: "Sak"
              }
            }
          }
        },
        GetInstanceAccessDetails: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {},
              protocol: {}
            }
          },
          output: {
            type: "structure",
            members: {
              accessDetails: {
                type: "structure",
                members: {
                  certKey: {},
                  expiresAt: {
                    type: "timestamp"
                  },
                  ipAddress: {},
                  password: {},
                  passwordData: {
                    type: "structure",
                    members: {
                      ciphertext: {},
                      keyPairName: {}
                    }
                  },
                  privateKey: {},
                  protocol: {},
                  instanceName: {},
                  username: {},
                  hostKeys: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        algorithm: {},
                        publicKey: {},
                        witnessedAt: {
                          type: "timestamp"
                        },
                        fingerprintSHA1: {},
                        fingerprintSHA256: {},
                        notValidBefore: {
                          type: "timestamp"
                        },
                        notValidAfter: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetInstanceMetricData: {
          input: {
            type: "structure",
            required: [
              "instanceName",
              "metricName",
              "period",
              "startTime",
              "endTime",
              "unit",
              "statistics"
            ],
            members: {
              instanceName: {},
              metricName: {},
              period: {
                type: "integer"
              },
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              unit: {},
              statistics: {
                shape: "S7o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              metricData: {
                shape: "S7q"
              }
            }
          }
        },
        GetInstancePortStates: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              portStates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    fromPort: {
                      type: "integer"
                    },
                    toPort: {
                      type: "integer"
                    },
                    protocol: {},
                    state: {},
                    cidrs: {
                      shape: "Su"
                    },
                    ipv6Cidrs: {
                      shape: "Su"
                    },
                    cidrListAliases: {
                      shape: "Su"
                    }
                  }
                }
              }
            }
          }
        },
        GetInstanceSnapshot: {
          input: {
            type: "structure",
            required: [
              "instanceSnapshotName"
            ],
            members: {
              instanceSnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              instanceSnapshot: {
                shape: "Sbd"
              }
            }
          }
        },
        GetInstanceSnapshots: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              instanceSnapshots: {
                type: "list",
                member: {
                  shape: "Sbd"
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetInstanceState: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              state: {
                shape: "Sav"
              }
            }
          }
        },
        GetInstances: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              instances: {
                type: "list",
                member: {
                  shape: "Sak"
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetKeyPair: {
          input: {
            type: "structure",
            required: [
              "keyPairName"
            ],
            members: {
              keyPairName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              keyPair: {
                shape: "S4i"
              }
            }
          }
        },
        GetKeyPairs: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              keyPairs: {
                type: "list",
                member: {
                  shape: "S4i"
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName"
            ],
            members: {
              loadBalancerName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              loadBalancer: {
                shape: "Sbu"
              }
            }
          }
        },
        GetLoadBalancerMetricData: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName",
              "metricName",
              "period",
              "startTime",
              "endTime",
              "unit",
              "statistics"
            ],
            members: {
              loadBalancerName: {},
              metricName: {},
              period: {
                type: "integer"
              },
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              unit: {},
              statistics: {
                shape: "S7o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              metricData: {
                shape: "S7q"
              }
            }
          }
        },
        GetLoadBalancerTlsCertificates: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName"
            ],
            members: {
              loadBalancerName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tlsCertificates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    arn: {},
                    supportCode: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    location: {
                      shape: "S9"
                    },
                    resourceType: {},
                    tags: {
                      shape: "S10"
                    },
                    loadBalancerName: {},
                    isAttached: {
                      type: "boolean"
                    },
                    status: {},
                    domainName: {},
                    domainValidationRecords: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          type: {},
                          value: {},
                          validationStatus: {},
                          domainName: {}
                        }
                      }
                    },
                    failureReason: {},
                    issuedAt: {
                      type: "timestamp"
                    },
                    issuer: {},
                    keyAlgorithm: {},
                    notAfter: {
                      type: "timestamp"
                    },
                    notBefore: {
                      type: "timestamp"
                    },
                    renewalSummary: {
                      type: "structure",
                      members: {
                        renewalStatus: {},
                        domainValidationOptions: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              domainName: {},
                              validationStatus: {}
                            }
                          }
                        }
                      }
                    },
                    revocationReason: {},
                    revokedAt: {
                      type: "timestamp"
                    },
                    serial: {},
                    signatureAlgorithm: {},
                    subject: {},
                    subjectAlternativeNames: {
                      shape: "Su"
                    }
                  }
                }
              }
            }
          }
        },
        GetLoadBalancers: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              loadBalancers: {
                type: "list",
                member: {
                  shape: "Sbu"
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetOperation: {
          input: {
            type: "structure",
            required: [
              "operationId"
            ],
            members: {
              operationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        GetOperations: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              },
              nextPageToken: {}
            }
          }
        },
        GetOperationsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceName"
            ],
            members: {
              resourceName: {},
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              },
              nextPageCount: {
                deprecated: true
              },
              nextPageToken: {}
            }
          }
        },
        GetRegions: {
          input: {
            type: "structure",
            members: {
              includeAvailabilityZones: {
                type: "boolean"
              },
              includeRelationalDatabaseAvailabilityZones: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              regions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    continentCode: {},
                    description: {},
                    displayName: {},
                    name: {},
                    availabilityZones: {
                      shape: "Sd0"
                    },
                    relationalDatabaseAvailabilityZones: {
                      shape: "Sd0"
                    }
                  }
                }
              }
            }
          }
        },
        GetRelationalDatabase: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              relationalDatabase: {
                shape: "Sd4"
              }
            }
          }
        },
        GetRelationalDatabaseBlueprints: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              blueprints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    blueprintId: {},
                    engine: {},
                    engineVersion: {},
                    engineDescription: {},
                    engineVersionDescription: {},
                    isEngineDefault: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetRelationalDatabaseBundles: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              bundles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    bundleId: {},
                    name: {},
                    price: {
                      type: "float"
                    },
                    ramSizeInGb: {
                      type: "float"
                    },
                    diskSizeInGb: {
                      type: "integer"
                    },
                    transferPerMonthInGb: {
                      type: "integer"
                    },
                    cpuCount: {
                      type: "integer"
                    },
                    isEncrypted: {
                      type: "boolean"
                    },
                    isActive: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetRelationalDatabaseEvents: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {},
              durationInMinutes: {
                type: "integer"
              },
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              relationalDatabaseEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    resource: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    message: {},
                    eventCategories: {
                      shape: "Su"
                    }
                  }
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetRelationalDatabaseLogEvents: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName",
              "logStreamName"
            ],
            members: {
              relationalDatabaseName: {},
              logStreamName: {},
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              startFromHead: {
                type: "boolean"
              },
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceLogEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    createdAt: {
                      type: "timestamp"
                    },
                    message: {}
                  }
                }
              },
              nextBackwardToken: {},
              nextForwardToken: {}
            }
          }
        },
        GetRelationalDatabaseLogStreams: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              logStreams: {
                shape: "Su"
              }
            }
          }
        },
        GetRelationalDatabaseMasterUserPassword: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {},
              passwordVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              masterUserPassword: {
                shape: "S4q"
              },
              createdAt: {
                type: "timestamp"
              }
            }
          }
        },
        GetRelationalDatabaseMetricData: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName",
              "metricName",
              "period",
              "startTime",
              "endTime",
              "unit",
              "statistics"
            ],
            members: {
              relationalDatabaseName: {},
              metricName: {},
              period: {
                type: "integer"
              },
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              unit: {},
              statistics: {
                shape: "S7o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              metricName: {},
              metricData: {
                shape: "S7q"
              }
            }
          }
        },
        GetRelationalDatabaseParameters: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {},
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              parameters: {
                shape: "Se1"
              },
              nextPageToken: {}
            }
          }
        },
        GetRelationalDatabaseSnapshot: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseSnapshotName"
            ],
            members: {
              relationalDatabaseSnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              relationalDatabaseSnapshot: {
                shape: "Se5"
              }
            }
          }
        },
        GetRelationalDatabaseSnapshots: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              relationalDatabaseSnapshots: {
                type: "list",
                member: {
                  shape: "Se5"
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetRelationalDatabases: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              relationalDatabases: {
                type: "list",
                member: {
                  shape: "Sd4"
                }
              },
              nextPageToken: {}
            }
          }
        },
        GetStaticIp: {
          input: {
            type: "structure",
            required: [
              "staticIpName"
            ],
            members: {
              staticIpName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              staticIp: {
                shape: "See"
              }
            }
          }
        },
        GetStaticIps: {
          input: {
            type: "structure",
            members: {
              pageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              staticIps: {
                type: "list",
                member: {
                  shape: "See"
                }
              },
              nextPageToken: {}
            }
          }
        },
        ImportKeyPair: {
          input: {
            type: "structure",
            required: [
              "keyPairName",
              "publicKeyBase64"
            ],
            members: {
              keyPairName: {},
              publicKeyBase64: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        IsVpcPeered: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              isPeered: {
                type: "boolean"
              }
            }
          }
        },
        OpenInstancePublicPorts: {
          input: {
            type: "structure",
            required: [
              "portInfo",
              "instanceName"
            ],
            members: {
              portInfo: {
                shape: "Sr"
              },
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        PeerVpc: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        PutAlarm: {
          input: {
            type: "structure",
            required: [
              "alarmName",
              "metricName",
              "monitoredResourceName",
              "comparisonOperator",
              "threshold",
              "evaluationPeriods"
            ],
            members: {
              alarmName: {},
              metricName: {},
              monitoredResourceName: {},
              comparisonOperator: {},
              threshold: {
                type: "double"
              },
              evaluationPeriods: {
                type: "integer"
              },
              datapointsToAlarm: {
                type: "integer"
              },
              treatMissingData: {},
              contactProtocols: {
                shape: "S6z"
              },
              notificationTriggers: {
                shape: "S70"
              },
              notificationEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        PutInstancePublicPorts: {
          input: {
            type: "structure",
            required: [
              "portInfos",
              "instanceName"
            ],
            members: {
              portInfos: {
                type: "list",
                member: {
                  shape: "Sr"
                }
              },
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        RebootInstance: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        RebootRelationalDatabase: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        RegisterContainerImage: {
          input: {
            type: "structure",
            required: [
              "serviceName",
              "label",
              "digest"
            ],
            members: {
              serviceName: {},
              label: {},
              digest: {}
            }
          },
          output: {
            type: "structure",
            members: {
              containerImage: {
                shape: "S8r"
              }
            }
          }
        },
        ReleaseStaticIp: {
          input: {
            type: "structure",
            required: [
              "staticIpName"
            ],
            members: {
              staticIpName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        ResetDistributionCache: {
          input: {
            type: "structure",
            members: {
              distributionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              status: {},
              createTime: {
                type: "timestamp"
              },
              operation: {
                shape: "S5"
              }
            }
          }
        },
        SendContactMethodVerification: {
          input: {
            type: "structure",
            required: [
              "protocol"
            ],
            members: {
              protocol: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        SetIpAddressType: {
          input: {
            type: "structure",
            required: [
              "resourceType",
              "resourceName",
              "ipAddressType"
            ],
            members: {
              resourceType: {},
              resourceName: {},
              ipAddressType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        SetResourceAccessForBucket: {
          input: {
            type: "structure",
            required: [
              "resourceName",
              "bucketName",
              "access"
            ],
            members: {
              resourceName: {},
              bucketName: {},
              access: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        StartInstance: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        StartRelationalDatabase: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        StopInstance: {
          input: {
            type: "structure",
            required: [
              "instanceName"
            ],
            members: {
              instanceName: {},
              force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        StopRelationalDatabase: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {},
              relationalDatabaseSnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceName",
              "tags"
            ],
            members: {
              resourceName: {},
              resourceArn: {},
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        TestAlarm: {
          input: {
            type: "structure",
            required: [
              "alarmName",
              "state"
            ],
            members: {
              alarmName: {},
              state: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        UnpeerVpc: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceName",
              "tagKeys"
            ],
            members: {
              resourceName: {},
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        UpdateBucket: {
          input: {
            type: "structure",
            required: [
              "bucketName"
            ],
            members: {
              bucketName: {},
              accessRules: {
                shape: "S16"
              },
              versioning: {},
              readonlyAccessAccounts: {
                shape: "S18"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              bucket: {
                shape: "S15"
              },
              operations: {
                shape: "S4"
              }
            }
          }
        },
        UpdateBucketBundle: {
          input: {
            type: "structure",
            required: [
              "bucketName",
              "bundleId"
            ],
            members: {
              bucketName: {},
              bundleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        UpdateContainerService: {
          input: {
            type: "structure",
            required: [
              "serviceName"
            ],
            members: {
              serviceName: {},
              power: {},
              scale: {
                type: "integer"
              },
              isDisabled: {
                type: "boolean"
              },
              publicDomainNames: {
                shape: "S2g"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              containerService: {
                shape: "S2t"
              }
            }
          }
        },
        UpdateDistribution: {
          input: {
            type: "structure",
            required: [
              "distributionName"
            ],
            members: {
              distributionName: {},
              origin: {
                shape: "S3h"
              },
              defaultCacheBehavior: {
                shape: "S3j"
              },
              cacheBehaviorSettings: {
                shape: "S3l"
              },
              cacheBehaviors: {
                shape: "S3t"
              },
              isEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        UpdateDistributionBundle: {
          input: {
            type: "structure",
            members: {
              distributionName: {},
              bundleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operation: {
                shape: "S5"
              }
            }
          }
        },
        UpdateDomainEntry: {
          input: {
            type: "structure",
            required: [
              "domainName",
              "domainEntry"
            ],
            members: {
              domainName: {},
              domainEntry: {
                shape: "S42"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        UpdateLoadBalancerAttribute: {
          input: {
            type: "structure",
            required: [
              "loadBalancerName",
              "attributeName",
              "attributeValue"
            ],
            members: {
              loadBalancerName: {},
              attributeName: {},
              attributeValue: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        UpdateRelationalDatabase: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName"
            ],
            members: {
              relationalDatabaseName: {},
              masterUserPassword: {
                shape: "S4q"
              },
              rotateMasterUserPassword: {
                type: "boolean"
              },
              preferredBackupWindow: {},
              preferredMaintenanceWindow: {},
              enableBackupRetention: {
                type: "boolean"
              },
              disableBackupRetention: {
                type: "boolean"
              },
              publiclyAccessible: {
                type: "boolean"
              },
              applyImmediately: {
                type: "boolean"
              },
              caCertificateIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        },
        UpdateRelationalDatabaseParameters: {
          input: {
            type: "structure",
            required: [
              "relationalDatabaseName",
              "parameters"
            ],
            members: {
              relationalDatabaseName: {},
              parameters: {
                shape: "Se1"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              operations: {
                shape: "S4"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {
            shape: "S5"
          }
        },
        S5: {
          type: "structure",
          members: {
            id: {},
            resourceName: {},
            resourceType: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            isTerminal: {
              type: "boolean"
            },
            operationDetails: {},
            operationType: {},
            status: {},
            statusChangedAt: {
              type: "timestamp"
            },
            errorCode: {},
            errorDetails: {}
          }
        },
        S9: {
          type: "structure",
          members: {
            availabilityZone: {},
            regionName: {}
          }
        },
        Sk: {
          type: "list",
          member: {}
        },
        Sr: {
          type: "structure",
          members: {
            fromPort: {
              type: "integer"
            },
            toPort: {
              type: "integer"
            },
            protocol: {},
            cidrs: {
              shape: "Su"
            },
            ipv6Cidrs: {
              shape: "Su"
            },
            cidrListAliases: {
              shape: "Su"
            }
          }
        },
        Su: {
          type: "list",
          member: {}
        },
        S10: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {}
            }
          }
        },
        S15: {
          type: "structure",
          members: {
            resourceType: {},
            accessRules: {
              shape: "S16"
            },
            arn: {},
            bundleId: {},
            createdAt: {
              type: "timestamp"
            },
            url: {},
            location: {
              shape: "S9"
            },
            name: {},
            supportCode: {},
            tags: {
              shape: "S10"
            },
            objectVersioning: {},
            ableToUpdateBundle: {
              type: "boolean"
            },
            readonlyAccessAccounts: {
              shape: "S18"
            },
            resourcesReceivingAccess: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  name: {},
                  resourceType: {}
                }
              }
            },
            state: {
              type: "structure",
              members: {
                code: {},
                message: {}
              }
            }
          }
        },
        S16: {
          type: "structure",
          members: {
            getObject: {},
            allowPublicOverrides: {
              type: "boolean"
            }
          }
        },
        S18: {
          type: "list",
          member: {}
        },
        S1e: {
          type: "structure",
          members: {
            accessKeyId: {
              type: "string",
              sensitive: true
            },
            secretAccessKey: {},
            status: {},
            createdAt: {
              type: "timestamp"
            },
            lastUsed: {
              type: "structure",
              members: {
                lastUsedDate: {
                  type: "timestamp"
                },
                region: {},
                serviceName: {}
              }
            }
          }
        },
        S1l: {
          type: "list",
          member: {}
        },
        S1n: {
          type: "structure",
          members: {
            certificateArn: {},
            certificateName: {},
            domainName: {},
            certificateDetail: {
              type: "structure",
              members: {
                arn: {},
                name: {},
                domainName: {},
                status: {},
                serialNumber: {},
                subjectAlternativeNames: {
                  shape: "S1l"
                },
                domainValidationRecords: {
                  shape: "S1r"
                },
                requestFailureReason: {},
                inUseResourceCount: {
                  type: "integer"
                },
                keyAlgorithm: {},
                createdAt: {
                  type: "timestamp"
                },
                issuedAt: {
                  type: "timestamp"
                },
                issuerCA: {},
                notBefore: {
                  type: "timestamp"
                },
                notAfter: {
                  type: "timestamp"
                },
                eligibleToRenew: {},
                renewalSummary: {
                  type: "structure",
                  members: {
                    domainValidationRecords: {
                      shape: "S1r"
                    },
                    renewalStatus: {},
                    renewalStatusReason: {},
                    updatedAt: {
                      type: "timestamp"
                    }
                  }
                },
                revokedAt: {
                  type: "timestamp"
                },
                revocationReason: {},
                tags: {
                  shape: "S10"
                },
                supportCode: {}
              }
            },
            tags: {
              shape: "S10"
            }
          }
        },
        S1r: {
          type: "list",
          member: {
            type: "structure",
            members: {
              domainName: {},
              resourceRecord: {
                type: "structure",
                members: {
                  name: {},
                  type: {},
                  value: {}
                }
              }
            }
          }
        },
        S2g: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          }
        },
        S2j: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              image: {},
              command: {
                shape: "Su"
              },
              environment: {
                type: "map",
                key: {},
                value: {}
              },
              ports: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        S2p: {
          type: "structure",
          required: [
            "containerName",
            "containerPort"
          ],
          members: {
            containerName: {},
            containerPort: {
              type: "integer"
            },
            healthCheck: {
              shape: "S2r"
            }
          }
        },
        S2r: {
          type: "structure",
          members: {
            healthyThreshold: {
              type: "integer"
            },
            unhealthyThreshold: {
              type: "integer"
            },
            timeoutSeconds: {
              type: "integer"
            },
            intervalSeconds: {
              type: "integer"
            },
            path: {},
            successCodes: {}
          }
        },
        S2t: {
          type: "structure",
          members: {
            containerServiceName: {},
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            tags: {
              shape: "S10"
            },
            power: {},
            powerId: {},
            state: {},
            stateDetail: {
              type: "structure",
              members: {
                code: {},
                message: {}
              }
            },
            scale: {
              type: "integer"
            },
            currentDeployment: {
              shape: "S2x"
            },
            nextDeployment: {
              shape: "S2x"
            },
            isDisabled: {
              type: "boolean"
            },
            principalArn: {},
            privateDomainName: {},
            publicDomainNames: {
              shape: "S2g"
            },
            url: {}
          }
        },
        S2x: {
          type: "structure",
          members: {
            version: {
              type: "integer"
            },
            state: {},
            containers: {
              shape: "S2j"
            },
            publicEndpoint: {
              type: "structure",
              members: {
                containerName: {},
                containerPort: {
                  type: "integer"
                },
                healthCheck: {
                  shape: "S2r"
                }
              }
            },
            createdAt: {
              type: "timestamp"
            }
          }
        },
        S36: {
          type: "list",
          member: {
            shape: "S37"
          }
        },
        S37: {
          type: "structure",
          required: [
            "addOnType"
          ],
          members: {
            addOnType: {},
            autoSnapshotAddOnRequest: {
              type: "structure",
              members: {
                snapshotTimeOfDay: {}
              }
            }
          }
        },
        S3h: {
          type: "structure",
          members: {
            name: {},
            regionName: {},
            protocolPolicy: {}
          }
        },
        S3j: {
          type: "structure",
          members: {
            behavior: {}
          }
        },
        S3l: {
          type: "structure",
          members: {
            defaultTTL: {
              type: "long"
            },
            minimumTTL: {
              type: "long"
            },
            maximumTTL: {
              type: "long"
            },
            allowedHTTPMethods: {},
            cachedHTTPMethods: {},
            forwardedCookies: {
              type: "structure",
              members: {
                option: {},
                cookiesAllowList: {
                  shape: "Su"
                }
              }
            },
            forwardedHeaders: {
              type: "structure",
              members: {
                option: {},
                headersAllowList: {
                  type: "list",
                  member: {}
                }
              }
            },
            forwardedQueryStrings: {
              type: "structure",
              members: {
                option: {
                  type: "boolean"
                },
                queryStringsAllowList: {
                  shape: "Su"
                }
              }
            }
          }
        },
        S3t: {
          type: "list",
          member: {
            type: "structure",
            members: {
              path: {},
              behavior: {}
            }
          }
        },
        S3x: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            alternativeDomainNames: {
              shape: "Su"
            },
            status: {},
            isEnabled: {
              type: "boolean"
            },
            domainName: {},
            bundleId: {},
            certificateName: {},
            origin: {
              type: "structure",
              members: {
                name: {},
                resourceType: {},
                regionName: {},
                protocolPolicy: {}
              }
            },
            originPublicDNS: {},
            defaultCacheBehavior: {
              shape: "S3j"
            },
            cacheBehaviorSettings: {
              shape: "S3l"
            },
            cacheBehaviors: {
              shape: "S3t"
            },
            ableToUpdateBundle: {
              type: "boolean"
            },
            ipAddressType: {},
            tags: {
              shape: "S10"
            }
          }
        },
        S42: {
          type: "structure",
          members: {
            id: {},
            name: {},
            target: {},
            isAlias: {
              type: "boolean"
            },
            type: {},
            options: {
              deprecated: true,
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        S4i: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            tags: {
              shape: "S10"
            },
            fingerprint: {}
          }
        },
        S4l: {
          type: "list",
          member: {}
        },
        S4q: {
          type: "string",
          sensitive: true
        },
        S6z: {
          type: "list",
          member: {}
        },
        S70: {
          type: "list",
          member: {}
        },
        S7o: {
          type: "list",
          member: {}
        },
        S7q: {
          type: "list",
          member: {
            type: "structure",
            members: {
              average: {
                type: "double"
              },
              maximum: {
                type: "double"
              },
              minimum: {
                type: "double"
              },
              sampleCount: {
                type: "double"
              },
              sum: {
                type: "double"
              },
              timestamp: {
                type: "timestamp"
              },
              unit: {}
            }
          }
        },
        S8e: {
          type: "structure",
          members: {
            id: {},
            service: {}
          }
        },
        S8r: {
          type: "structure",
          members: {
            image: {},
            digest: {},
            createdAt: {
              type: "timestamp"
            }
          }
        },
        S9b: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            tags: {
              shape: "S10"
            },
            addOns: {
              shape: "S9c"
            },
            sizeInGb: {
              type: "integer"
            },
            isSystemDisk: {
              type: "boolean"
            },
            iops: {
              type: "integer"
            },
            path: {},
            state: {},
            attachedTo: {},
            isAttached: {
              type: "boolean"
            },
            attachmentState: {
              deprecated: true
            },
            gbInUse: {
              deprecated: true,
              type: "integer"
            }
          }
        },
        S9c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              status: {},
              snapshotTimeOfDay: {},
              nextSnapshotTimeOfDay: {}
            }
          }
        },
        S9h: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            tags: {
              shape: "S10"
            },
            sizeInGb: {
              type: "integer"
            },
            state: {},
            progress: {},
            fromDiskName: {},
            fromDiskArn: {},
            fromInstanceName: {},
            fromInstanceArn: {},
            isFromAutoSnapshot: {
              type: "boolean"
            }
          }
        },
        S9o: {
          type: "list",
          member: {
            shape: "S9b"
          }
        },
        Sa3: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            tags: {
              shape: "S10"
            },
            domainEntries: {
              type: "list",
              member: {
                shape: "S42"
              }
            }
          }
        },
        Sak: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            tags: {
              shape: "S10"
            },
            blueprintId: {},
            blueprintName: {},
            bundleId: {},
            addOns: {
              shape: "S9c"
            },
            isStaticIp: {
              type: "boolean"
            },
            privateIpAddress: {},
            publicIpAddress: {},
            ipv6Addresses: {
              type: "list",
              member: {}
            },
            ipAddressType: {},
            hardware: {
              type: "structure",
              members: {
                cpuCount: {
                  type: "integer"
                },
                disks: {
                  shape: "S9o"
                },
                ramSizeInGb: {
                  type: "float"
                }
              }
            },
            networking: {
              type: "structure",
              members: {
                monthlyTransfer: {
                  type: "structure",
                  members: {
                    gbPerMonthAllocated: {
                      type: "integer"
                    }
                  }
                },
                ports: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      fromPort: {
                        type: "integer"
                      },
                      toPort: {
                        type: "integer"
                      },
                      protocol: {},
                      accessFrom: {},
                      accessType: {},
                      commonName: {},
                      accessDirection: {},
                      cidrs: {
                        shape: "Su"
                      },
                      ipv6Cidrs: {
                        shape: "Su"
                      },
                      cidrListAliases: {
                        shape: "Su"
                      }
                    }
                  }
                }
              }
            },
            state: {
              shape: "Sav"
            },
            username: {},
            sshKeyName: {}
          }
        },
        Sav: {
          type: "structure",
          members: {
            code: {
              type: "integer"
            },
            name: {}
          }
        },
        Sbd: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            tags: {
              shape: "S10"
            },
            state: {},
            progress: {},
            fromAttachedDisks: {
              shape: "S9o"
            },
            fromInstanceName: {},
            fromInstanceArn: {},
            fromBlueprintId: {},
            fromBundleId: {},
            isFromAutoSnapshot: {
              type: "boolean"
            },
            sizeInGb: {
              type: "integer"
            }
          }
        },
        Sbu: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            tags: {
              shape: "S10"
            },
            dnsName: {},
            state: {},
            protocol: {},
            publicPorts: {
              type: "list",
              member: {
                type: "integer"
              }
            },
            healthCheckPath: {},
            instancePort: {
              type: "integer"
            },
            instanceHealthSummary: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  instanceName: {},
                  instanceHealth: {},
                  instanceHealthReason: {}
                }
              }
            },
            tlsCertificateSummaries: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  name: {},
                  isAttached: {
                    type: "boolean"
                  }
                }
              }
            },
            configurationOptions: {
              type: "map",
              key: {},
              value: {}
            },
            ipAddressType: {}
          }
        },
        Sd0: {
          type: "list",
          member: {
            type: "structure",
            members: {
              zoneName: {},
              state: {}
            }
          }
        },
        Sd4: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            tags: {
              shape: "S10"
            },
            relationalDatabaseBlueprintId: {},
            relationalDatabaseBundleId: {},
            masterDatabaseName: {},
            hardware: {
              type: "structure",
              members: {
                cpuCount: {
                  type: "integer"
                },
                diskSizeInGb: {
                  type: "integer"
                },
                ramSizeInGb: {
                  type: "float"
                }
              }
            },
            state: {},
            secondaryAvailabilityZone: {},
            backupRetentionEnabled: {
              type: "boolean"
            },
            pendingModifiedValues: {
              type: "structure",
              members: {
                masterUserPassword: {},
                engineVersion: {},
                backupRetentionEnabled: {
                  type: "boolean"
                }
              }
            },
            engine: {},
            engineVersion: {},
            latestRestorableTime: {
              type: "timestamp"
            },
            masterUsername: {},
            parameterApplyStatus: {},
            preferredBackupWindow: {},
            preferredMaintenanceWindow: {},
            publiclyAccessible: {
              type: "boolean"
            },
            masterEndpoint: {
              type: "structure",
              members: {
                port: {
                  type: "integer"
                },
                address: {}
              }
            },
            pendingMaintenanceActions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  action: {},
                  description: {},
                  currentApplyDate: {
                    type: "timestamp"
                  }
                }
              }
            },
            caCertificateIdentifier: {}
          }
        },
        Se1: {
          type: "list",
          member: {
            type: "structure",
            members: {
              allowedValues: {},
              applyMethod: {},
              applyType: {},
              dataType: {},
              description: {},
              isModifiable: {
                type: "boolean"
              },
              parameterName: {},
              parameterValue: {}
            }
          }
        },
        Se5: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            tags: {
              shape: "S10"
            },
            engine: {},
            engineVersion: {},
            sizeInGb: {
              type: "integer"
            },
            state: {},
            fromRelationalDatabaseName: {},
            fromRelationalDatabaseArn: {},
            fromRelationalDatabaseBundleId: {},
            fromRelationalDatabaseBlueprintId: {}
          }
        },
        See: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            supportCode: {},
            createdAt: {
              type: "timestamp"
            },
            location: {
              shape: "S9"
            },
            resourceType: {},
            ipAddress: {},
            attachedTo: {},
            isAttached: {
              type: "boolean"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/lightsail-2016-11-28.paginators.json
var require_lightsail_2016_11_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/lightsail-2016-11-28.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/lightsail.js
var require_lightsail = __commonJS({
  "node_modules/aws-sdk/clients/lightsail.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["lightsail"] = {};
    AWS3.Lightsail = Service.defineService("lightsail", ["2016-11-28"]);
    Object.defineProperty(apiLoader.services["lightsail"], "2016-11-28", {
      get: function get() {
        var model = require_lightsail_2016_11_28_min();
        model.paginators = require_lightsail_2016_11_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Lightsail;
  }
});

// node_modules/aws-sdk/lib/services/machinelearning.js
var require_machinelearning = __commonJS({
  "node_modules/aws-sdk/lib/services/machinelearning.js"() {
    var AWS3 = require_core();
    AWS3.util.update(AWS3.MachineLearning.prototype, {
      setupRequestListeners: function setupRequestListeners(request) {
        if (request.operation === "predict") {
          request.addListener("build", this.buildEndpoint);
        }
      },
      buildEndpoint: function buildEndpoint(request) {
        var url = request.params.PredictEndpoint;
        if (url) {
          request.httpRequest.endpoint = new AWS3.Endpoint(url);
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/machinelearning-2014-12-12.min.json
var require_machinelearning_2014_12_12_min = __commonJS({
  "node_modules/aws-sdk/apis/machinelearning-2014-12-12.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-12-12",
        endpointPrefix: "machinelearning",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Machine Learning",
        serviceId: "Machine Learning",
        signatureVersion: "v4",
        targetPrefix: "AmazonML_20141212",
        uid: "machinelearning-2014-12-12"
      },
      operations: {
        AddTags: {
          input: {
            type: "structure",
            required: [
              "Tags",
              "ResourceId",
              "ResourceType"
            ],
            members: {
              Tags: {
                shape: "S2"
              },
              ResourceId: {},
              ResourceType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceId: {},
              ResourceType: {}
            }
          }
        },
        CreateBatchPrediction: {
          input: {
            type: "structure",
            required: [
              "BatchPredictionId",
              "MLModelId",
              "BatchPredictionDataSourceId",
              "OutputUri"
            ],
            members: {
              BatchPredictionId: {},
              BatchPredictionName: {},
              MLModelId: {},
              BatchPredictionDataSourceId: {},
              OutputUri: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BatchPredictionId: {}
            }
          }
        },
        CreateDataSourceFromRDS: {
          input: {
            type: "structure",
            required: [
              "DataSourceId",
              "RDSData",
              "RoleARN"
            ],
            members: {
              DataSourceId: {},
              DataSourceName: {},
              RDSData: {
                type: "structure",
                required: [
                  "DatabaseInformation",
                  "SelectSqlQuery",
                  "DatabaseCredentials",
                  "S3StagingLocation",
                  "ResourceRole",
                  "ServiceRole",
                  "SubnetId",
                  "SecurityGroupIds"
                ],
                members: {
                  DatabaseInformation: {
                    shape: "Sf"
                  },
                  SelectSqlQuery: {},
                  DatabaseCredentials: {
                    type: "structure",
                    required: [
                      "Username",
                      "Password"
                    ],
                    members: {
                      Username: {},
                      Password: {}
                    }
                  },
                  S3StagingLocation: {},
                  DataRearrangement: {},
                  DataSchema: {},
                  DataSchemaUri: {},
                  ResourceRole: {},
                  ServiceRole: {},
                  SubnetId: {},
                  SecurityGroupIds: {
                    type: "list",
                    member: {}
                  }
                }
              },
              RoleARN: {},
              ComputeStatistics: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSourceId: {}
            }
          }
        },
        CreateDataSourceFromRedshift: {
          input: {
            type: "structure",
            required: [
              "DataSourceId",
              "DataSpec",
              "RoleARN"
            ],
            members: {
              DataSourceId: {},
              DataSourceName: {},
              DataSpec: {
                type: "structure",
                required: [
                  "DatabaseInformation",
                  "SelectSqlQuery",
                  "DatabaseCredentials",
                  "S3StagingLocation"
                ],
                members: {
                  DatabaseInformation: {
                    shape: "Sy"
                  },
                  SelectSqlQuery: {},
                  DatabaseCredentials: {
                    type: "structure",
                    required: [
                      "Username",
                      "Password"
                    ],
                    members: {
                      Username: {},
                      Password: {}
                    }
                  },
                  S3StagingLocation: {},
                  DataRearrangement: {},
                  DataSchema: {},
                  DataSchemaUri: {}
                }
              },
              RoleARN: {},
              ComputeStatistics: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSourceId: {}
            }
          }
        },
        CreateDataSourceFromS3: {
          input: {
            type: "structure",
            required: [
              "DataSourceId",
              "DataSpec"
            ],
            members: {
              DataSourceId: {},
              DataSourceName: {},
              DataSpec: {
                type: "structure",
                required: [
                  "DataLocationS3"
                ],
                members: {
                  DataLocationS3: {},
                  DataRearrangement: {},
                  DataSchema: {},
                  DataSchemaLocationS3: {}
                }
              },
              ComputeStatistics: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSourceId: {}
            }
          }
        },
        CreateEvaluation: {
          input: {
            type: "structure",
            required: [
              "EvaluationId",
              "MLModelId",
              "EvaluationDataSourceId"
            ],
            members: {
              EvaluationId: {},
              EvaluationName: {},
              MLModelId: {},
              EvaluationDataSourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EvaluationId: {}
            }
          }
        },
        CreateMLModel: {
          input: {
            type: "structure",
            required: [
              "MLModelId",
              "MLModelType",
              "TrainingDataSourceId"
            ],
            members: {
              MLModelId: {},
              MLModelName: {},
              MLModelType: {},
              Parameters: {
                shape: "S1d"
              },
              TrainingDataSourceId: {},
              Recipe: {},
              RecipeUri: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MLModelId: {}
            }
          }
        },
        CreateRealtimeEndpoint: {
          input: {
            type: "structure",
            required: [
              "MLModelId"
            ],
            members: {
              MLModelId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MLModelId: {},
              RealtimeEndpointInfo: {
                shape: "S1j"
              }
            }
          }
        },
        DeleteBatchPrediction: {
          input: {
            type: "structure",
            required: [
              "BatchPredictionId"
            ],
            members: {
              BatchPredictionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BatchPredictionId: {}
            }
          }
        },
        DeleteDataSource: {
          input: {
            type: "structure",
            required: [
              "DataSourceId"
            ],
            members: {
              DataSourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DataSourceId: {}
            }
          }
        },
        DeleteEvaluation: {
          input: {
            type: "structure",
            required: [
              "EvaluationId"
            ],
            members: {
              EvaluationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EvaluationId: {}
            }
          }
        },
        DeleteMLModel: {
          input: {
            type: "structure",
            required: [
              "MLModelId"
            ],
            members: {
              MLModelId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MLModelId: {}
            }
          }
        },
        DeleteRealtimeEndpoint: {
          input: {
            type: "structure",
            required: [
              "MLModelId"
            ],
            members: {
              MLModelId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MLModelId: {},
              RealtimeEndpointInfo: {
                shape: "S1j"
              }
            }
          }
        },
        DeleteTags: {
          input: {
            type: "structure",
            required: [
              "TagKeys",
              "ResourceId",
              "ResourceType"
            ],
            members: {
              TagKeys: {
                type: "list",
                member: {}
              },
              ResourceId: {},
              ResourceType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceId: {},
              ResourceType: {}
            }
          }
        },
        DescribeBatchPredictions: {
          input: {
            type: "structure",
            members: {
              FilterVariable: {},
              EQ: {},
              GT: {},
              LT: {},
              GE: {},
              LE: {},
              NE: {},
              Prefix: {},
              SortOrder: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    BatchPredictionId: {},
                    MLModelId: {},
                    BatchPredictionDataSourceId: {},
                    InputDataLocationS3: {},
                    CreatedByIamUser: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    LastUpdatedAt: {
                      type: "timestamp"
                    },
                    Name: {},
                    Status: {},
                    OutputUri: {},
                    Message: {},
                    ComputeTime: {
                      type: "long"
                    },
                    FinishedAt: {
                      type: "timestamp"
                    },
                    StartedAt: {
                      type: "timestamp"
                    },
                    TotalRecordCount: {
                      type: "long"
                    },
                    InvalidRecordCount: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeDataSources: {
          input: {
            type: "structure",
            members: {
              FilterVariable: {},
              EQ: {},
              GT: {},
              LT: {},
              GE: {},
              LE: {},
              NE: {},
              Prefix: {},
              SortOrder: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DataSourceId: {},
                    DataLocationS3: {},
                    DataRearrangement: {},
                    CreatedByIamUser: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    LastUpdatedAt: {
                      type: "timestamp"
                    },
                    DataSizeInBytes: {
                      type: "long"
                    },
                    NumberOfFiles: {
                      type: "long"
                    },
                    Name: {},
                    Status: {},
                    Message: {},
                    RedshiftMetadata: {
                      shape: "S2i"
                    },
                    RDSMetadata: {
                      shape: "S2j"
                    },
                    RoleARN: {},
                    ComputeStatistics: {
                      type: "boolean"
                    },
                    ComputeTime: {
                      type: "long"
                    },
                    FinishedAt: {
                      type: "timestamp"
                    },
                    StartedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeEvaluations: {
          input: {
            type: "structure",
            members: {
              FilterVariable: {},
              EQ: {},
              GT: {},
              LT: {},
              GE: {},
              LE: {},
              NE: {},
              Prefix: {},
              SortOrder: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EvaluationId: {},
                    MLModelId: {},
                    EvaluationDataSourceId: {},
                    InputDataLocationS3: {},
                    CreatedByIamUser: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    LastUpdatedAt: {
                      type: "timestamp"
                    },
                    Name: {},
                    Status: {},
                    PerformanceMetrics: {
                      shape: "S2q"
                    },
                    Message: {},
                    ComputeTime: {
                      type: "long"
                    },
                    FinishedAt: {
                      type: "timestamp"
                    },
                    StartedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMLModels: {
          input: {
            type: "structure",
            members: {
              FilterVariable: {},
              EQ: {},
              GT: {},
              LT: {},
              GE: {},
              LE: {},
              NE: {},
              Prefix: {},
              SortOrder: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MLModelId: {},
                    TrainingDataSourceId: {},
                    CreatedByIamUser: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    LastUpdatedAt: {
                      type: "timestamp"
                    },
                    Name: {},
                    Status: {},
                    SizeInBytes: {
                      type: "long"
                    },
                    EndpointInfo: {
                      shape: "S1j"
                    },
                    TrainingParameters: {
                      shape: "S1d"
                    },
                    InputDataLocationS3: {},
                    Algorithm: {},
                    MLModelType: {},
                    ScoreThreshold: {
                      type: "float"
                    },
                    ScoreThresholdLastUpdatedAt: {
                      type: "timestamp"
                    },
                    Message: {},
                    ComputeTime: {
                      type: "long"
                    },
                    FinishedAt: {
                      type: "timestamp"
                    },
                    StartedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeTags: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "ResourceType"
            ],
            members: {
              ResourceId: {},
              ResourceType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceId: {},
              ResourceType: {},
              Tags: {
                shape: "S2"
              }
            }
          }
        },
        GetBatchPrediction: {
          input: {
            type: "structure",
            required: [
              "BatchPredictionId"
            ],
            members: {
              BatchPredictionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BatchPredictionId: {},
              MLModelId: {},
              BatchPredictionDataSourceId: {},
              InputDataLocationS3: {},
              CreatedByIamUser: {},
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Name: {},
              Status: {},
              OutputUri: {},
              LogUri: {},
              Message: {},
              ComputeTime: {
                type: "long"
              },
              FinishedAt: {
                type: "timestamp"
              },
              StartedAt: {
                type: "timestamp"
              },
              TotalRecordCount: {
                type: "long"
              },
              InvalidRecordCount: {
                type: "long"
              }
            }
          }
        },
        GetDataSource: {
          input: {
            type: "structure",
            required: [
              "DataSourceId"
            ],
            members: {
              DataSourceId: {},
              Verbose: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSourceId: {},
              DataLocationS3: {},
              DataRearrangement: {},
              CreatedByIamUser: {},
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              DataSizeInBytes: {
                type: "long"
              },
              NumberOfFiles: {
                type: "long"
              },
              Name: {},
              Status: {},
              LogUri: {},
              Message: {},
              RedshiftMetadata: {
                shape: "S2i"
              },
              RDSMetadata: {
                shape: "S2j"
              },
              RoleARN: {},
              ComputeStatistics: {
                type: "boolean"
              },
              ComputeTime: {
                type: "long"
              },
              FinishedAt: {
                type: "timestamp"
              },
              StartedAt: {
                type: "timestamp"
              },
              DataSourceSchema: {}
            }
          }
        },
        GetEvaluation: {
          input: {
            type: "structure",
            required: [
              "EvaluationId"
            ],
            members: {
              EvaluationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EvaluationId: {},
              MLModelId: {},
              EvaluationDataSourceId: {},
              InputDataLocationS3: {},
              CreatedByIamUser: {},
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Name: {},
              Status: {},
              PerformanceMetrics: {
                shape: "S2q"
              },
              LogUri: {},
              Message: {},
              ComputeTime: {
                type: "long"
              },
              FinishedAt: {
                type: "timestamp"
              },
              StartedAt: {
                type: "timestamp"
              }
            }
          }
        },
        GetMLModel: {
          input: {
            type: "structure",
            required: [
              "MLModelId"
            ],
            members: {
              MLModelId: {},
              Verbose: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MLModelId: {},
              TrainingDataSourceId: {},
              CreatedByIamUser: {},
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Name: {},
              Status: {},
              SizeInBytes: {
                type: "long"
              },
              EndpointInfo: {
                shape: "S1j"
              },
              TrainingParameters: {
                shape: "S1d"
              },
              InputDataLocationS3: {},
              MLModelType: {},
              ScoreThreshold: {
                type: "float"
              },
              ScoreThresholdLastUpdatedAt: {
                type: "timestamp"
              },
              LogUri: {},
              Message: {},
              ComputeTime: {
                type: "long"
              },
              FinishedAt: {
                type: "timestamp"
              },
              StartedAt: {
                type: "timestamp"
              },
              Recipe: {},
              Schema: {}
            }
          }
        },
        Predict: {
          input: {
            type: "structure",
            required: [
              "MLModelId",
              "Record",
              "PredictEndpoint"
            ],
            members: {
              MLModelId: {},
              Record: {
                type: "map",
                key: {},
                value: {}
              },
              PredictEndpoint: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Prediction: {
                type: "structure",
                members: {
                  predictedLabel: {},
                  predictedValue: {
                    type: "float"
                  },
                  predictedScores: {
                    type: "map",
                    key: {},
                    value: {
                      type: "float"
                    }
                  },
                  details: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            }
          }
        },
        UpdateBatchPrediction: {
          input: {
            type: "structure",
            required: [
              "BatchPredictionId",
              "BatchPredictionName"
            ],
            members: {
              BatchPredictionId: {},
              BatchPredictionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BatchPredictionId: {}
            }
          }
        },
        UpdateDataSource: {
          input: {
            type: "structure",
            required: [
              "DataSourceId",
              "DataSourceName"
            ],
            members: {
              DataSourceId: {},
              DataSourceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DataSourceId: {}
            }
          }
        },
        UpdateEvaluation: {
          input: {
            type: "structure",
            required: [
              "EvaluationId",
              "EvaluationName"
            ],
            members: {
              EvaluationId: {},
              EvaluationName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EvaluationId: {}
            }
          }
        },
        UpdateMLModel: {
          input: {
            type: "structure",
            required: [
              "MLModelId"
            ],
            members: {
              MLModelId: {},
              MLModelName: {},
              ScoreThreshold: {
                type: "float"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MLModelId: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sf: {
          type: "structure",
          required: [
            "InstanceIdentifier",
            "DatabaseName"
          ],
          members: {
            InstanceIdentifier: {},
            DatabaseName: {}
          }
        },
        Sy: {
          type: "structure",
          required: [
            "DatabaseName",
            "ClusterIdentifier"
          ],
          members: {
            DatabaseName: {},
            ClusterIdentifier: {}
          }
        },
        S1d: {
          type: "map",
          key: {},
          value: {}
        },
        S1j: {
          type: "structure",
          members: {
            PeakRequestsPerSecond: {
              type: "integer"
            },
            CreatedAt: {
              type: "timestamp"
            },
            EndpointUrl: {},
            EndpointStatus: {}
          }
        },
        S2i: {
          type: "structure",
          members: {
            RedshiftDatabase: {
              shape: "Sy"
            },
            DatabaseUserName: {},
            SelectSqlQuery: {}
          }
        },
        S2j: {
          type: "structure",
          members: {
            Database: {
              shape: "Sf"
            },
            DatabaseUserName: {},
            SelectSqlQuery: {},
            ResourceRole: {},
            ServiceRole: {},
            DataPipelineId: {}
          }
        },
        S2q: {
          type: "structure",
          members: {
            Properties: {
              type: "map",
              key: {},
              value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/machinelearning-2014-12-12.paginators.json
var require_machinelearning_2014_12_12_paginators = __commonJS({
  "node_modules/aws-sdk/apis/machinelearning-2014-12-12.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeBatchPredictions: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Results"
        },
        DescribeDataSources: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Results"
        },
        DescribeEvaluations: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Results"
        },
        DescribeMLModels: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Results"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/machinelearning-2014-12-12.waiters2.json
var require_machinelearning_2014_12_12_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/machinelearning-2014-12-12.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DataSourceAvailable: {
          delay: 30,
          operation: "DescribeDataSources",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "COMPLETED",
              matcher: "pathAll",
              state: "success",
              argument: "Results[].Status"
            },
            {
              expected: "FAILED",
              matcher: "pathAny",
              state: "failure",
              argument: "Results[].Status"
            }
          ]
        },
        MLModelAvailable: {
          delay: 30,
          operation: "DescribeMLModels",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "COMPLETED",
              matcher: "pathAll",
              state: "success",
              argument: "Results[].Status"
            },
            {
              expected: "FAILED",
              matcher: "pathAny",
              state: "failure",
              argument: "Results[].Status"
            }
          ]
        },
        EvaluationAvailable: {
          delay: 30,
          operation: "DescribeEvaluations",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "COMPLETED",
              matcher: "pathAll",
              state: "success",
              argument: "Results[].Status"
            },
            {
              expected: "FAILED",
              matcher: "pathAny",
              state: "failure",
              argument: "Results[].Status"
            }
          ]
        },
        BatchPredictionAvailable: {
          delay: 30,
          operation: "DescribeBatchPredictions",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "COMPLETED",
              matcher: "pathAll",
              state: "success",
              argument: "Results[].Status"
            },
            {
              expected: "FAILED",
              matcher: "pathAny",
              state: "failure",
              argument: "Results[].Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/machinelearning.js
var require_machinelearning2 = __commonJS({
  "node_modules/aws-sdk/clients/machinelearning.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["machinelearning"] = {};
    AWS3.MachineLearning = Service.defineService("machinelearning", ["2014-12-12"]);
    require_machinelearning();
    Object.defineProperty(apiLoader.services["machinelearning"], "2014-12-12", {
      get: function get() {
        var model = require_machinelearning_2014_12_12_min();
        model.paginators = require_machinelearning_2014_12_12_paginators().pagination;
        model.waiters = require_machinelearning_2014_12_12_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.MachineLearning;
  }
});

// node_modules/aws-sdk/apis/marketplacecommerceanalytics-2015-07-01.min.json
var require_marketplacecommerceanalytics_2015_07_01_min = __commonJS({
  "node_modules/aws-sdk/apis/marketplacecommerceanalytics-2015-07-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-07-01",
        endpointPrefix: "marketplacecommerceanalytics",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Marketplace Commerce Analytics",
        serviceId: "Marketplace Commerce Analytics",
        signatureVersion: "v4",
        signingName: "marketplacecommerceanalytics",
        targetPrefix: "MarketplaceCommerceAnalytics20150701",
        uid: "marketplacecommerceanalytics-2015-07-01"
      },
      operations: {
        GenerateDataSet: {
          input: {
            type: "structure",
            required: [
              "dataSetType",
              "dataSetPublicationDate",
              "roleNameArn",
              "destinationS3BucketName",
              "snsTopicArn"
            ],
            members: {
              dataSetType: {},
              dataSetPublicationDate: {
                type: "timestamp"
              },
              roleNameArn: {},
              destinationS3BucketName: {},
              destinationS3Prefix: {},
              snsTopicArn: {},
              customerDefinedValues: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataSetRequestId: {}
            }
          }
        },
        StartSupportDataExport: {
          input: {
            type: "structure",
            required: [
              "dataSetType",
              "fromDate",
              "roleNameArn",
              "destinationS3BucketName",
              "snsTopicArn"
            ],
            members: {
              dataSetType: {},
              fromDate: {
                type: "timestamp"
              },
              roleNameArn: {},
              destinationS3BucketName: {},
              destinationS3Prefix: {},
              snsTopicArn: {},
              customerDefinedValues: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataSetRequestId: {}
            }
          }
        }
      },
      shapes: {
        S8: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/marketplacecommerceanalytics-2015-07-01.paginators.json
var require_marketplacecommerceanalytics_2015_07_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/marketplacecommerceanalytics-2015-07-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/marketplacecommerceanalytics.js
var require_marketplacecommerceanalytics = __commonJS({
  "node_modules/aws-sdk/clients/marketplacecommerceanalytics.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["marketplacecommerceanalytics"] = {};
    AWS3.MarketplaceCommerceAnalytics = Service.defineService("marketplacecommerceanalytics", ["2015-07-01"]);
    Object.defineProperty(apiLoader.services["marketplacecommerceanalytics"], "2015-07-01", {
      get: function get() {
        var model = require_marketplacecommerceanalytics_2015_07_01_min();
        model.paginators = require_marketplacecommerceanalytics_2015_07_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.MarketplaceCommerceAnalytics;
  }
});

// node_modules/aws-sdk/apis/meteringmarketplace-2016-01-14.min.json
var require_meteringmarketplace_2016_01_14_min = __commonJS({
  "node_modules/aws-sdk/apis/meteringmarketplace-2016-01-14.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-01-14",
        endpointPrefix: "metering.marketplace",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWSMarketplace Metering",
        serviceId: "Marketplace Metering",
        signatureVersion: "v4",
        signingName: "aws-marketplace",
        targetPrefix: "AWSMPMeteringService",
        uid: "meteringmarketplace-2016-01-14"
      },
      operations: {
        BatchMeterUsage: {
          input: {
            type: "structure",
            required: [
              "UsageRecords",
              "ProductCode"
            ],
            members: {
              UsageRecords: {
                shape: "S2"
              },
              ProductCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UsageRecord: {
                      shape: "S3"
                    },
                    MeteringRecordId: {},
                    Status: {}
                  }
                }
              },
              UnprocessedRecords: {
                shape: "S2"
              }
            }
          }
        },
        MeterUsage: {
          input: {
            type: "structure",
            required: [
              "ProductCode",
              "Timestamp",
              "UsageDimension"
            ],
            members: {
              ProductCode: {},
              Timestamp: {
                type: "timestamp"
              },
              UsageDimension: {},
              UsageQuantity: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              },
              UsageAllocations: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MeteringRecordId: {}
            }
          }
        },
        RegisterUsage: {
          input: {
            type: "structure",
            required: [
              "ProductCode",
              "PublicKeyVersion"
            ],
            members: {
              ProductCode: {},
              PublicKeyVersion: {
                type: "integer"
              },
              Nonce: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PublicKeyRotationTimestamp: {
                type: "timestamp"
              },
              Signature: {}
            }
          }
        },
        ResolveCustomer: {
          input: {
            type: "structure",
            required: [
              "RegistrationToken"
            ],
            members: {
              RegistrationToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CustomerIdentifier: {},
              ProductCode: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {
            shape: "S3"
          }
        },
        S3: {
          type: "structure",
          required: [
            "Timestamp",
            "CustomerIdentifier",
            "Dimension"
          ],
          members: {
            Timestamp: {
              type: "timestamp"
            },
            CustomerIdentifier: {},
            Dimension: {},
            Quantity: {
              type: "integer"
            },
            UsageAllocations: {
              shape: "S8"
            }
          }
        },
        S8: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AllocatedUsageQuantity"
            ],
            members: {
              AllocatedUsageQuantity: {
                type: "integer"
              },
              Tags: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Value"
                  ],
                  members: {
                    Key: {},
                    Value: {}
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/meteringmarketplace-2016-01-14.paginators.json
var require_meteringmarketplace_2016_01_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/meteringmarketplace-2016-01-14.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/marketplacemetering.js
var require_marketplacemetering = __commonJS({
  "node_modules/aws-sdk/clients/marketplacemetering.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["marketplacemetering"] = {};
    AWS3.MarketplaceMetering = Service.defineService("marketplacemetering", ["2016-01-14"]);
    Object.defineProperty(apiLoader.services["marketplacemetering"], "2016-01-14", {
      get: function get() {
        var model = require_meteringmarketplace_2016_01_14_min();
        model.paginators = require_meteringmarketplace_2016_01_14_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.MarketplaceMetering;
  }
});

// node_modules/aws-sdk/apis/mturk-requester-2017-01-17.min.json
var require_mturk_requester_2017_01_17_min = __commonJS({
  "node_modules/aws-sdk/apis/mturk-requester-2017-01-17.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-01-17",
        endpointPrefix: "mturk-requester",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Amazon MTurk",
        serviceFullName: "Amazon Mechanical Turk",
        serviceId: "MTurk",
        signatureVersion: "v4",
        targetPrefix: "MTurkRequesterServiceV20170117",
        uid: "mturk-requester-2017-01-17"
      },
      operations: {
        AcceptQualificationRequest: {
          input: {
            type: "structure",
            required: [
              "QualificationRequestId"
            ],
            members: {
              QualificationRequestId: {},
              IntegerValue: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ApproveAssignment: {
          input: {
            type: "structure",
            required: [
              "AssignmentId"
            ],
            members: {
              AssignmentId: {},
              RequesterFeedback: {},
              OverrideRejection: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        AssociateQualificationWithWorker: {
          input: {
            type: "structure",
            required: [
              "QualificationTypeId",
              "WorkerId"
            ],
            members: {
              QualificationTypeId: {},
              WorkerId: {},
              IntegerValue: {
                type: "integer"
              },
              SendNotification: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateAdditionalAssignmentsForHIT: {
          input: {
            type: "structure",
            required: [
              "HITId",
              "NumberOfAdditionalAssignments"
            ],
            members: {
              HITId: {},
              NumberOfAdditionalAssignments: {
                type: "integer"
              },
              UniqueRequestToken: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateHIT: {
          input: {
            type: "structure",
            required: [
              "LifetimeInSeconds",
              "AssignmentDurationInSeconds",
              "Reward",
              "Title",
              "Description"
            ],
            members: {
              MaxAssignments: {
                type: "integer"
              },
              AutoApprovalDelayInSeconds: {
                type: "long"
              },
              LifetimeInSeconds: {
                type: "long"
              },
              AssignmentDurationInSeconds: {
                type: "long"
              },
              Reward: {},
              Title: {},
              Keywords: {},
              Description: {},
              Question: {},
              RequesterAnnotation: {},
              QualificationRequirements: {
                shape: "Si"
              },
              UniqueRequestToken: {},
              AssignmentReviewPolicy: {
                shape: "Sq"
              },
              HITReviewPolicy: {
                shape: "Sq"
              },
              HITLayoutId: {},
              HITLayoutParameters: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HIT: {
                shape: "Sz"
              }
            }
          }
        },
        CreateHITType: {
          input: {
            type: "structure",
            required: [
              "AssignmentDurationInSeconds",
              "Reward",
              "Title",
              "Description"
            ],
            members: {
              AutoApprovalDelayInSeconds: {
                type: "long"
              },
              AssignmentDurationInSeconds: {
                type: "long"
              },
              Reward: {},
              Title: {},
              Keywords: {},
              Description: {},
              QualificationRequirements: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HITTypeId: {}
            }
          },
          idempotent: true
        },
        CreateHITWithHITType: {
          input: {
            type: "structure",
            required: [
              "HITTypeId",
              "LifetimeInSeconds"
            ],
            members: {
              HITTypeId: {},
              MaxAssignments: {
                type: "integer"
              },
              LifetimeInSeconds: {
                type: "long"
              },
              Question: {},
              RequesterAnnotation: {},
              UniqueRequestToken: {},
              AssignmentReviewPolicy: {
                shape: "Sq"
              },
              HITReviewPolicy: {
                shape: "Sq"
              },
              HITLayoutId: {},
              HITLayoutParameters: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HIT: {
                shape: "Sz"
              }
            }
          }
        },
        CreateQualificationType: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Description",
              "QualificationTypeStatus"
            ],
            members: {
              Name: {},
              Keywords: {},
              Description: {},
              QualificationTypeStatus: {},
              RetryDelayInSeconds: {
                type: "long"
              },
              Test: {},
              AnswerKey: {},
              TestDurationInSeconds: {
                type: "long"
              },
              AutoGranted: {
                type: "boolean"
              },
              AutoGrantedValue: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QualificationType: {
                shape: "S1a"
              }
            }
          }
        },
        CreateWorkerBlock: {
          input: {
            type: "structure",
            required: [
              "WorkerId",
              "Reason"
            ],
            members: {
              WorkerId: {},
              Reason: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteHIT: {
          input: {
            type: "structure",
            required: [
              "HITId"
            ],
            members: {
              HITId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteQualificationType: {
          input: {
            type: "structure",
            required: [
              "QualificationTypeId"
            ],
            members: {
              QualificationTypeId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteWorkerBlock: {
          input: {
            type: "structure",
            required: [
              "WorkerId"
            ],
            members: {
              WorkerId: {},
              Reason: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DisassociateQualificationFromWorker: {
          input: {
            type: "structure",
            required: [
              "WorkerId",
              "QualificationTypeId"
            ],
            members: {
              WorkerId: {},
              QualificationTypeId: {},
              Reason: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAccountBalance: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              AvailableBalance: {},
              OnHoldBalance: {}
            }
          },
          idempotent: true
        },
        GetAssignment: {
          input: {
            type: "structure",
            required: [
              "AssignmentId"
            ],
            members: {
              AssignmentId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Assignment: {
                shape: "S1p"
              },
              HIT: {
                shape: "Sz"
              }
            }
          },
          idempotent: true
        },
        GetFileUploadURL: {
          input: {
            type: "structure",
            required: [
              "AssignmentId",
              "QuestionIdentifier"
            ],
            members: {
              AssignmentId: {},
              QuestionIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FileUploadURL: {}
            }
          },
          idempotent: true
        },
        GetHIT: {
          input: {
            type: "structure",
            required: [
              "HITId"
            ],
            members: {
              HITId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HIT: {
                shape: "Sz"
              }
            }
          },
          idempotent: true
        },
        GetQualificationScore: {
          input: {
            type: "structure",
            required: [
              "QualificationTypeId",
              "WorkerId"
            ],
            members: {
              QualificationTypeId: {},
              WorkerId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Qualification: {
                shape: "S1x"
              }
            }
          },
          idempotent: true
        },
        GetQualificationType: {
          input: {
            type: "structure",
            required: [
              "QualificationTypeId"
            ],
            members: {
              QualificationTypeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              QualificationType: {
                shape: "S1a"
              }
            }
          },
          idempotent: true
        },
        ListAssignmentsForHIT: {
          input: {
            type: "structure",
            required: [
              "HITId"
            ],
            members: {
              HITId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              AssignmentStatuses: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NumResults: {
                type: "integer"
              },
              Assignments: {
                type: "list",
                member: {
                  shape: "S1p"
                }
              }
            }
          },
          idempotent: true
        },
        ListBonusPayments: {
          input: {
            type: "structure",
            members: {
              HITId: {},
              AssignmentId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NumResults: {
                type: "integer"
              },
              NextToken: {},
              BonusPayments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WorkerId: {},
                    BonusAmount: {},
                    AssignmentId: {},
                    Reason: {},
                    GrantTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          },
          idempotent: true
        },
        ListHITs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NumResults: {
                type: "integer"
              },
              HITs: {
                shape: "S2d"
              }
            }
          },
          idempotent: true
        },
        ListHITsForQualificationType: {
          input: {
            type: "structure",
            required: [
              "QualificationTypeId"
            ],
            members: {
              QualificationTypeId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NumResults: {
                type: "integer"
              },
              HITs: {
                shape: "S2d"
              }
            }
          },
          idempotent: true
        },
        ListQualificationRequests: {
          input: {
            type: "structure",
            members: {
              QualificationTypeId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NumResults: {
                type: "integer"
              },
              NextToken: {},
              QualificationRequests: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    QualificationRequestId: {},
                    QualificationTypeId: {},
                    WorkerId: {},
                    Test: {},
                    Answer: {},
                    SubmitTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          },
          idempotent: true
        },
        ListQualificationTypes: {
          input: {
            type: "structure",
            required: [
              "MustBeRequestable"
            ],
            members: {
              Query: {},
              MustBeRequestable: {
                type: "boolean"
              },
              MustBeOwnedByCaller: {
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NumResults: {
                type: "integer"
              },
              NextToken: {},
              QualificationTypes: {
                type: "list",
                member: {
                  shape: "S1a"
                }
              }
            }
          },
          idempotent: true
        },
        ListReviewPolicyResultsForHIT: {
          input: {
            type: "structure",
            required: [
              "HITId"
            ],
            members: {
              HITId: {},
              PolicyLevels: {
                type: "list",
                member: {}
              },
              RetrieveActions: {
                type: "boolean"
              },
              RetrieveResults: {
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HITId: {},
              AssignmentReviewPolicy: {
                shape: "Sq"
              },
              HITReviewPolicy: {
                shape: "Sq"
              },
              AssignmentReviewReport: {
                shape: "S2r"
              },
              HITReviewReport: {
                shape: "S2r"
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListReviewableHITs: {
          input: {
            type: "structure",
            members: {
              HITTypeId: {},
              Status: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NumResults: {
                type: "integer"
              },
              HITs: {
                shape: "S2d"
              }
            }
          },
          idempotent: true
        },
        ListWorkerBlocks: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NumResults: {
                type: "integer"
              },
              WorkerBlocks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WorkerId: {},
                    Reason: {}
                  }
                }
              }
            }
          },
          idempotent: true
        },
        ListWorkersWithQualificationType: {
          input: {
            type: "structure",
            required: [
              "QualificationTypeId"
            ],
            members: {
              QualificationTypeId: {},
              Status: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NumResults: {
                type: "integer"
              },
              Qualifications: {
                type: "list",
                member: {
                  shape: "S1x"
                }
              }
            }
          },
          idempotent: true
        },
        NotifyWorkers: {
          input: {
            type: "structure",
            required: [
              "Subject",
              "MessageText",
              "WorkerIds"
            ],
            members: {
              Subject: {},
              MessageText: {},
              WorkerIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NotifyWorkersFailureStatuses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    NotifyWorkersFailureCode: {},
                    NotifyWorkersFailureMessage: {},
                    WorkerId: {}
                  }
                }
              }
            }
          }
        },
        RejectAssignment: {
          input: {
            type: "structure",
            required: [
              "AssignmentId",
              "RequesterFeedback"
            ],
            members: {
              AssignmentId: {},
              RequesterFeedback: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        RejectQualificationRequest: {
          input: {
            type: "structure",
            required: [
              "QualificationRequestId"
            ],
            members: {
              QualificationRequestId: {},
              Reason: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SendBonus: {
          input: {
            type: "structure",
            required: [
              "WorkerId",
              "BonusAmount",
              "AssignmentId",
              "Reason"
            ],
            members: {
              WorkerId: {},
              BonusAmount: {},
              AssignmentId: {},
              Reason: {},
              UniqueRequestToken: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SendTestEventNotification: {
          input: {
            type: "structure",
            required: [
              "Notification",
              "TestEventType"
            ],
            members: {
              Notification: {
                shape: "S3k"
              },
              TestEventType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateExpirationForHIT: {
          input: {
            type: "structure",
            required: [
              "HITId",
              "ExpireAt"
            ],
            members: {
              HITId: {},
              ExpireAt: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateHITReviewStatus: {
          input: {
            type: "structure",
            required: [
              "HITId"
            ],
            members: {
              HITId: {},
              Revert: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateHITTypeOfHIT: {
          input: {
            type: "structure",
            required: [
              "HITId",
              "HITTypeId"
            ],
            members: {
              HITId: {},
              HITTypeId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateNotificationSettings: {
          input: {
            type: "structure",
            required: [
              "HITTypeId"
            ],
            members: {
              HITTypeId: {},
              Notification: {
                shape: "S3k"
              },
              Active: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateQualificationType: {
          input: {
            type: "structure",
            required: [
              "QualificationTypeId"
            ],
            members: {
              QualificationTypeId: {},
              Description: {},
              QualificationTypeStatus: {},
              Test: {},
              AnswerKey: {},
              TestDurationInSeconds: {
                type: "long"
              },
              RetryDelayInSeconds: {
                type: "long"
              },
              AutoGranted: {
                type: "boolean"
              },
              AutoGrantedValue: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QualificationType: {
                shape: "S1a"
              }
            }
          }
        }
      },
      shapes: {
        Si: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "QualificationTypeId",
              "Comparator"
            ],
            members: {
              QualificationTypeId: {},
              Comparator: {},
              IntegerValues: {
                type: "list",
                member: {
                  type: "integer"
                }
              },
              LocaleValues: {
                type: "list",
                member: {
                  shape: "Sn"
                }
              },
              RequiredToPreview: {
                deprecated: true,
                type: "boolean"
              },
              ActionsGuarded: {}
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "Country"
          ],
          members: {
            Country: {},
            Subdivision: {}
          }
        },
        Sq: {
          type: "structure",
          required: [
            "PolicyName"
          ],
          members: {
            PolicyName: {},
            Parameters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Values: {
                    shape: "St"
                  },
                  MapEntries: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Key: {},
                        Values: {
                          shape: "St"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        St: {
          type: "list",
          member: {}
        },
        Sw: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        Sz: {
          type: "structure",
          members: {
            HITId: {},
            HITTypeId: {},
            HITGroupId: {},
            HITLayoutId: {},
            CreationTime: {
              type: "timestamp"
            },
            Title: {},
            Description: {},
            Question: {},
            Keywords: {},
            HITStatus: {},
            MaxAssignments: {
              type: "integer"
            },
            Reward: {},
            AutoApprovalDelayInSeconds: {
              type: "long"
            },
            Expiration: {
              type: "timestamp"
            },
            AssignmentDurationInSeconds: {
              type: "long"
            },
            RequesterAnnotation: {},
            QualificationRequirements: {
              shape: "Si"
            },
            HITReviewStatus: {},
            NumberOfAssignmentsPending: {
              type: "integer"
            },
            NumberOfAssignmentsAvailable: {
              type: "integer"
            },
            NumberOfAssignmentsCompleted: {
              type: "integer"
            }
          }
        },
        S1a: {
          type: "structure",
          members: {
            QualificationTypeId: {},
            CreationTime: {
              type: "timestamp"
            },
            Name: {},
            Description: {},
            Keywords: {},
            QualificationTypeStatus: {},
            Test: {},
            TestDurationInSeconds: {
              type: "long"
            },
            AnswerKey: {},
            RetryDelayInSeconds: {
              type: "long"
            },
            IsRequestable: {
              type: "boolean"
            },
            AutoGranted: {
              type: "boolean"
            },
            AutoGrantedValue: {
              type: "integer"
            }
          }
        },
        S1p: {
          type: "structure",
          members: {
            AssignmentId: {},
            WorkerId: {},
            HITId: {},
            AssignmentStatus: {},
            AutoApprovalTime: {
              type: "timestamp"
            },
            AcceptTime: {
              type: "timestamp"
            },
            SubmitTime: {
              type: "timestamp"
            },
            ApprovalTime: {
              type: "timestamp"
            },
            RejectionTime: {
              type: "timestamp"
            },
            Deadline: {
              type: "timestamp"
            },
            Answer: {},
            RequesterFeedback: {}
          }
        },
        S1x: {
          type: "structure",
          members: {
            QualificationTypeId: {},
            WorkerId: {},
            GrantTime: {
              type: "timestamp"
            },
            IntegerValue: {
              type: "integer"
            },
            LocaleValue: {
              shape: "Sn"
            },
            Status: {}
          }
        },
        S2d: {
          type: "list",
          member: {
            shape: "Sz"
          }
        },
        S2r: {
          type: "structure",
          members: {
            ReviewResults: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ActionId: {},
                  SubjectId: {},
                  SubjectType: {},
                  QuestionId: {},
                  Key: {},
                  Value: {}
                }
              }
            },
            ReviewActions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ActionId: {},
                  ActionName: {},
                  TargetId: {},
                  TargetType: {},
                  Status: {},
                  CompleteTime: {
                    type: "timestamp"
                  },
                  Result: {},
                  ErrorCode: {}
                }
              }
            }
          }
        },
        S3k: {
          type: "structure",
          required: [
            "Destination",
            "Transport",
            "Version",
            "EventTypes"
          ],
          members: {
            Destination: {},
            Transport: {},
            Version: {},
            EventTypes: {
              type: "list",
              member: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mturk-requester-2017-01-17.paginators.json
var require_mturk_requester_2017_01_17_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mturk-requester-2017-01-17.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAssignmentsForHIT: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListBonusPayments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListHITs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListHITsForQualificationType: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListQualificationRequests: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListQualificationTypes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListReviewPolicyResultsForHIT: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListReviewableHITs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListWorkerBlocks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListWorkersWithQualificationType: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mturk.js
var require_mturk = __commonJS({
  "node_modules/aws-sdk/clients/mturk.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["mturk"] = {};
    AWS3.MTurk = Service.defineService("mturk", ["2017-01-17"]);
    Object.defineProperty(apiLoader.services["mturk"], "2017-01-17", {
      get: function get() {
        var model = require_mturk_requester_2017_01_17_min();
        model.paginators = require_mturk_requester_2017_01_17_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.MTurk;
  }
});

// node_modules/aws-sdk/apis/mobileanalytics-2014-06-05.min.json
var require_mobileanalytics_2014_06_05_min = __commonJS({
  "node_modules/aws-sdk/apis/mobileanalytics-2014-06-05.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-06-05",
        endpointPrefix: "mobileanalytics",
        serviceFullName: "Amazon Mobile Analytics",
        serviceId: "Mobile Analytics",
        signatureVersion: "v4",
        protocol: "rest-json"
      },
      operations: {
        PutEvents: {
          http: {
            requestUri: "/2014-06-05/events",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "events",
              "clientContext"
            ],
            members: {
              events: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "eventType",
                    "timestamp"
                  ],
                  members: {
                    eventType: {},
                    timestamp: {},
                    session: {
                      type: "structure",
                      members: {
                        id: {},
                        duration: {
                          type: "long"
                        },
                        startTimestamp: {},
                        stopTimestamp: {}
                      }
                    },
                    version: {},
                    attributes: {
                      type: "map",
                      key: {},
                      value: {}
                    },
                    metrics: {
                      type: "map",
                      key: {},
                      value: {
                        type: "double"
                      }
                    }
                  }
                }
              },
              clientContext: {
                location: "header",
                locationName: "x-amz-Client-Context"
              },
              clientContextEncoding: {
                location: "header",
                locationName: "x-amz-Client-Context-Encoding"
              }
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/clients/mobileanalytics.js
var require_mobileanalytics = __commonJS({
  "node_modules/aws-sdk/clients/mobileanalytics.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["mobileanalytics"] = {};
    AWS3.MobileAnalytics = Service.defineService("mobileanalytics", ["2014-06-05"]);
    Object.defineProperty(apiLoader.services["mobileanalytics"], "2014-06-05", {
      get: function get() {
        var model = require_mobileanalytics_2014_06_05_min();
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.MobileAnalytics;
  }
});

// node_modules/aws-sdk/apis/opsworks-2013-02-18.min.json
var require_opsworks_2013_02_18_min = __commonJS({
  "node_modules/aws-sdk/apis/opsworks-2013-02-18.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-02-18",
        endpointPrefix: "opsworks",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS OpsWorks",
        serviceId: "OpsWorks",
        signatureVersion: "v4",
        targetPrefix: "OpsWorks_20130218",
        uid: "opsworks-2013-02-18"
      },
      operations: {
        AssignInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "LayerIds"
            ],
            members: {
              InstanceId: {},
              LayerIds: {
                shape: "S3"
              }
            }
          }
        },
        AssignVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              VolumeId: {},
              InstanceId: {}
            }
          }
        },
        AssociateElasticIp: {
          input: {
            type: "structure",
            required: [
              "ElasticIp"
            ],
            members: {
              ElasticIp: {},
              InstanceId: {}
            }
          }
        },
        AttachElasticLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "ElasticLoadBalancerName",
              "LayerId"
            ],
            members: {
              ElasticLoadBalancerName: {},
              LayerId: {}
            }
          }
        },
        CloneStack: {
          input: {
            type: "structure",
            required: [
              "SourceStackId",
              "ServiceRoleArn"
            ],
            members: {
              SourceStackId: {},
              Name: {},
              Region: {},
              VpcId: {},
              Attributes: {
                shape: "S8"
              },
              ServiceRoleArn: {},
              DefaultInstanceProfileArn: {},
              DefaultOs: {},
              HostnameTheme: {},
              DefaultAvailabilityZone: {},
              DefaultSubnetId: {},
              CustomJson: {},
              ConfigurationManager: {
                shape: "Sa"
              },
              ChefConfiguration: {
                shape: "Sb"
              },
              UseCustomCookbooks: {
                type: "boolean"
              },
              UseOpsworksSecurityGroups: {
                type: "boolean"
              },
              CustomCookbooksSource: {
                shape: "Sd"
              },
              DefaultSshKeyName: {},
              ClonePermissions: {
                type: "boolean"
              },
              CloneAppIds: {
                shape: "S3"
              },
              DefaultRootDeviceType: {},
              AgentVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StackId: {}
            }
          }
        },
        CreateApp: {
          input: {
            type: "structure",
            required: [
              "StackId",
              "Name",
              "Type"
            ],
            members: {
              StackId: {},
              Shortname: {},
              Name: {},
              Description: {},
              DataSources: {
                shape: "Si"
              },
              Type: {},
              AppSource: {
                shape: "Sd"
              },
              Domains: {
                shape: "S3"
              },
              EnableSsl: {
                type: "boolean"
              },
              SslConfiguration: {
                shape: "Sl"
              },
              Attributes: {
                shape: "Sm"
              },
              Environment: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppId: {}
            }
          }
        },
        CreateDeployment: {
          input: {
            type: "structure",
            required: [
              "StackId",
              "Command"
            ],
            members: {
              StackId: {},
              AppId: {},
              InstanceIds: {
                shape: "S3"
              },
              LayerIds: {
                shape: "S3"
              },
              Command: {
                shape: "Ss"
              },
              Comment: {},
              CustomJson: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DeploymentId: {}
            }
          }
        },
        CreateInstance: {
          input: {
            type: "structure",
            required: [
              "StackId",
              "LayerIds",
              "InstanceType"
            ],
            members: {
              StackId: {},
              LayerIds: {
                shape: "S3"
              },
              InstanceType: {},
              AutoScalingType: {},
              Hostname: {},
              Os: {},
              AmiId: {},
              SshKeyName: {},
              AvailabilityZone: {},
              VirtualizationType: {},
              SubnetId: {},
              Architecture: {},
              RootDeviceType: {},
              BlockDeviceMappings: {
                shape: "Sz"
              },
              InstallUpdatesOnBoot: {
                type: "boolean"
              },
              EbsOptimized: {
                type: "boolean"
              },
              AgentVersion: {},
              Tenancy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceId: {}
            }
          }
        },
        CreateLayer: {
          input: {
            type: "structure",
            required: [
              "StackId",
              "Type",
              "Name",
              "Shortname"
            ],
            members: {
              StackId: {},
              Type: {},
              Name: {},
              Shortname: {},
              Attributes: {
                shape: "S17"
              },
              CloudWatchLogsConfiguration: {
                shape: "S19"
              },
              CustomInstanceProfileArn: {},
              CustomJson: {},
              CustomSecurityGroupIds: {
                shape: "S3"
              },
              Packages: {
                shape: "S3"
              },
              VolumeConfigurations: {
                shape: "S1f"
              },
              EnableAutoHealing: {
                type: "boolean"
              },
              AutoAssignElasticIps: {
                type: "boolean"
              },
              AutoAssignPublicIps: {
                type: "boolean"
              },
              CustomRecipes: {
                shape: "S1h"
              },
              InstallUpdatesOnBoot: {
                type: "boolean"
              },
              UseEbsOptimizedInstances: {
                type: "boolean"
              },
              LifecycleEventConfiguration: {
                shape: "S1i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LayerId: {}
            }
          }
        },
        CreateStack: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Region",
              "ServiceRoleArn",
              "DefaultInstanceProfileArn"
            ],
            members: {
              Name: {},
              Region: {},
              VpcId: {},
              Attributes: {
                shape: "S8"
              },
              ServiceRoleArn: {},
              DefaultInstanceProfileArn: {},
              DefaultOs: {},
              HostnameTheme: {},
              DefaultAvailabilityZone: {},
              DefaultSubnetId: {},
              CustomJson: {},
              ConfigurationManager: {
                shape: "Sa"
              },
              ChefConfiguration: {
                shape: "Sb"
              },
              UseCustomCookbooks: {
                type: "boolean"
              },
              UseOpsworksSecurityGroups: {
                type: "boolean"
              },
              CustomCookbooksSource: {
                shape: "Sd"
              },
              DefaultSshKeyName: {},
              DefaultRootDeviceType: {},
              AgentVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StackId: {}
            }
          }
        },
        CreateUserProfile: {
          input: {
            type: "structure",
            required: [
              "IamUserArn"
            ],
            members: {
              IamUserArn: {},
              SshUsername: {},
              SshPublicKey: {},
              AllowSelfManagement: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IamUserArn: {}
            }
          }
        },
        DeleteApp: {
          input: {
            type: "structure",
            required: [
              "AppId"
            ],
            members: {
              AppId: {}
            }
          }
        },
        DeleteInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              DeleteElasticIp: {
                type: "boolean"
              },
              DeleteVolumes: {
                type: "boolean"
              }
            }
          }
        },
        DeleteLayer: {
          input: {
            type: "structure",
            required: [
              "LayerId"
            ],
            members: {
              LayerId: {}
            }
          }
        },
        DeleteStack: {
          input: {
            type: "structure",
            required: [
              "StackId"
            ],
            members: {
              StackId: {}
            }
          }
        },
        DeleteUserProfile: {
          input: {
            type: "structure",
            required: [
              "IamUserArn"
            ],
            members: {
              IamUserArn: {}
            }
          }
        },
        DeregisterEcsCluster: {
          input: {
            type: "structure",
            required: [
              "EcsClusterArn"
            ],
            members: {
              EcsClusterArn: {}
            }
          }
        },
        DeregisterElasticIp: {
          input: {
            type: "structure",
            required: [
              "ElasticIp"
            ],
            members: {
              ElasticIp: {}
            }
          }
        },
        DeregisterInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {}
            }
          }
        },
        DeregisterRdsDbInstance: {
          input: {
            type: "structure",
            required: [
              "RdsDbInstanceArn"
            ],
            members: {
              RdsDbInstanceArn: {}
            }
          }
        },
        DeregisterVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              VolumeId: {}
            }
          }
        },
        DescribeAgentVersions: {
          input: {
            type: "structure",
            members: {
              StackId: {},
              ConfigurationManager: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AgentVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Version: {},
                    ConfigurationManager: {
                      shape: "Sa"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeApps: {
          input: {
            type: "structure",
            members: {
              StackId: {},
              AppIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Apps: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AppId: {},
                    StackId: {},
                    Shortname: {},
                    Name: {},
                    Description: {},
                    DataSources: {
                      shape: "Si"
                    },
                    Type: {},
                    AppSource: {
                      shape: "Sd"
                    },
                    Domains: {
                      shape: "S3"
                    },
                    EnableSsl: {
                      type: "boolean"
                    },
                    SslConfiguration: {
                      shape: "Sl"
                    },
                    Attributes: {
                      shape: "Sm"
                    },
                    CreatedAt: {},
                    Environment: {
                      shape: "So"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeCommands: {
          input: {
            type: "structure",
            members: {
              DeploymentId: {},
              InstanceId: {},
              CommandIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Commands: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CommandId: {},
                    InstanceId: {},
                    DeploymentId: {},
                    CreatedAt: {},
                    AcknowledgedAt: {},
                    CompletedAt: {},
                    Status: {},
                    ExitCode: {
                      type: "integer"
                    },
                    LogUrl: {},
                    Type: {}
                  }
                }
              }
            }
          }
        },
        DescribeDeployments: {
          input: {
            type: "structure",
            members: {
              StackId: {},
              AppId: {},
              DeploymentIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Deployments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DeploymentId: {},
                    StackId: {},
                    AppId: {},
                    CreatedAt: {},
                    CompletedAt: {},
                    Duration: {
                      type: "integer"
                    },
                    IamUserArn: {},
                    Comment: {},
                    Command: {
                      shape: "Ss"
                    },
                    Status: {},
                    CustomJson: {},
                    InstanceIds: {
                      shape: "S3"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeEcsClusters: {
          input: {
            type: "structure",
            members: {
              EcsClusterArns: {
                shape: "S3"
              },
              StackId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EcsClusters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EcsClusterArn: {},
                    EcsClusterName: {},
                    StackId: {},
                    RegisteredAt: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeElasticIps: {
          input: {
            type: "structure",
            members: {
              InstanceId: {},
              StackId: {},
              Ips: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ElasticIps: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Ip: {},
                    Name: {},
                    Domain: {},
                    Region: {},
                    InstanceId: {}
                  }
                }
              }
            }
          }
        },
        DescribeElasticLoadBalancers: {
          input: {
            type: "structure",
            members: {
              StackId: {},
              LayerIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ElasticLoadBalancers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ElasticLoadBalancerName: {},
                    Region: {},
                    DnsName: {},
                    StackId: {},
                    LayerId: {},
                    VpcId: {},
                    AvailabilityZones: {
                      shape: "S3"
                    },
                    SubnetIds: {
                      shape: "S3"
                    },
                    Ec2InstanceIds: {
                      shape: "S3"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeInstances: {
          input: {
            type: "structure",
            members: {
              StackId: {},
              LayerId: {},
              InstanceIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Instances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AgentVersion: {},
                    AmiId: {},
                    Architecture: {},
                    Arn: {},
                    AutoScalingType: {},
                    AvailabilityZone: {},
                    BlockDeviceMappings: {
                      shape: "Sz"
                    },
                    CreatedAt: {},
                    EbsOptimized: {
                      type: "boolean"
                    },
                    Ec2InstanceId: {},
                    EcsClusterArn: {},
                    EcsContainerInstanceArn: {},
                    ElasticIp: {},
                    Hostname: {},
                    InfrastructureClass: {},
                    InstallUpdatesOnBoot: {
                      type: "boolean"
                    },
                    InstanceId: {},
                    InstanceProfileArn: {},
                    InstanceType: {},
                    LastServiceErrorId: {},
                    LayerIds: {
                      shape: "S3"
                    },
                    Os: {},
                    Platform: {},
                    PrivateDns: {},
                    PrivateIp: {},
                    PublicDns: {},
                    PublicIp: {},
                    RegisteredBy: {},
                    ReportedAgentVersion: {},
                    ReportedOs: {
                      type: "structure",
                      members: {
                        Family: {},
                        Name: {},
                        Version: {}
                      }
                    },
                    RootDeviceType: {},
                    RootDeviceVolumeId: {},
                    SecurityGroupIds: {
                      shape: "S3"
                    },
                    SshHostDsaKeyFingerprint: {},
                    SshHostRsaKeyFingerprint: {},
                    SshKeyName: {},
                    StackId: {},
                    Status: {},
                    SubnetId: {},
                    Tenancy: {},
                    VirtualizationType: {}
                  }
                }
              }
            }
          }
        },
        DescribeLayers: {
          input: {
            type: "structure",
            members: {
              StackId: {},
              LayerIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Layers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    StackId: {},
                    LayerId: {},
                    Type: {},
                    Name: {},
                    Shortname: {},
                    Attributes: {
                      shape: "S17"
                    },
                    CloudWatchLogsConfiguration: {
                      shape: "S19"
                    },
                    CustomInstanceProfileArn: {},
                    CustomJson: {},
                    CustomSecurityGroupIds: {
                      shape: "S3"
                    },
                    DefaultSecurityGroupNames: {
                      shape: "S3"
                    },
                    Packages: {
                      shape: "S3"
                    },
                    VolumeConfigurations: {
                      shape: "S1f"
                    },
                    EnableAutoHealing: {
                      type: "boolean"
                    },
                    AutoAssignElasticIps: {
                      type: "boolean"
                    },
                    AutoAssignPublicIps: {
                      type: "boolean"
                    },
                    DefaultRecipes: {
                      shape: "S1h"
                    },
                    CustomRecipes: {
                      shape: "S1h"
                    },
                    CreatedAt: {},
                    InstallUpdatesOnBoot: {
                      type: "boolean"
                    },
                    UseEbsOptimizedInstances: {
                      type: "boolean"
                    },
                    LifecycleEventConfiguration: {
                      shape: "S1i"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeLoadBasedAutoScaling: {
          input: {
            type: "structure",
            required: [
              "LayerIds"
            ],
            members: {
              LayerIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoadBasedAutoScalingConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LayerId: {},
                    Enable: {
                      type: "boolean"
                    },
                    UpScaling: {
                      shape: "S36"
                    },
                    DownScaling: {
                      shape: "S36"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeMyUserProfile: {
          output: {
            type: "structure",
            members: {
              UserProfile: {
                type: "structure",
                members: {
                  IamUserArn: {},
                  Name: {},
                  SshUsername: {},
                  SshPublicKey: {}
                }
              }
            }
          }
        },
        DescribeOperatingSystems: {
          output: {
            type: "structure",
            members: {
              OperatingSystems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Id: {},
                    Type: {},
                    ConfigurationManagers: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {},
                          Version: {}
                        }
                      }
                    },
                    ReportedName: {},
                    ReportedVersion: {},
                    Supported: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DescribePermissions: {
          input: {
            type: "structure",
            members: {
              IamUserArn: {},
              StackId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Permissions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StackId: {},
                    IamUserArn: {},
                    AllowSsh: {
                      type: "boolean"
                    },
                    AllowSudo: {
                      type: "boolean"
                    },
                    Level: {}
                  }
                }
              }
            }
          }
        },
        DescribeRaidArrays: {
          input: {
            type: "structure",
            members: {
              InstanceId: {},
              StackId: {},
              RaidArrayIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RaidArrays: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RaidArrayId: {},
                    InstanceId: {},
                    Name: {},
                    RaidLevel: {
                      type: "integer"
                    },
                    NumberOfDisks: {
                      type: "integer"
                    },
                    Size: {
                      type: "integer"
                    },
                    Device: {},
                    MountPoint: {},
                    AvailabilityZone: {},
                    CreatedAt: {},
                    StackId: {},
                    VolumeType: {},
                    Iops: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeRdsDbInstances: {
          input: {
            type: "structure",
            required: [
              "StackId"
            ],
            members: {
              StackId: {},
              RdsDbInstanceArns: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RdsDbInstances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RdsDbInstanceArn: {},
                    DbInstanceIdentifier: {},
                    DbUser: {},
                    DbPassword: {},
                    Region: {},
                    Address: {},
                    Engine: {},
                    StackId: {},
                    MissingOnRds: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeServiceErrors: {
          input: {
            type: "structure",
            members: {
              StackId: {},
              InstanceId: {},
              ServiceErrorIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceErrors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ServiceErrorId: {},
                    StackId: {},
                    InstanceId: {},
                    Type: {},
                    Message: {},
                    CreatedAt: {}
                  }
                }
              }
            }
          }
        },
        DescribeStackProvisioningParameters: {
          input: {
            type: "structure",
            required: [
              "StackId"
            ],
            members: {
              StackId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AgentInstallerUrl: {},
              Parameters: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        DescribeStackSummary: {
          input: {
            type: "structure",
            required: [
              "StackId"
            ],
            members: {
              StackId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StackSummary: {
                type: "structure",
                members: {
                  StackId: {},
                  Name: {},
                  Arn: {},
                  LayersCount: {
                    type: "integer"
                  },
                  AppsCount: {
                    type: "integer"
                  },
                  InstancesCount: {
                    type: "structure",
                    members: {
                      Assigning: {
                        type: "integer"
                      },
                      Booting: {
                        type: "integer"
                      },
                      ConnectionLost: {
                        type: "integer"
                      },
                      Deregistering: {
                        type: "integer"
                      },
                      Online: {
                        type: "integer"
                      },
                      Pending: {
                        type: "integer"
                      },
                      Rebooting: {
                        type: "integer"
                      },
                      Registered: {
                        type: "integer"
                      },
                      Registering: {
                        type: "integer"
                      },
                      Requested: {
                        type: "integer"
                      },
                      RunningSetup: {
                        type: "integer"
                      },
                      SetupFailed: {
                        type: "integer"
                      },
                      ShuttingDown: {
                        type: "integer"
                      },
                      StartFailed: {
                        type: "integer"
                      },
                      StopFailed: {
                        type: "integer"
                      },
                      Stopped: {
                        type: "integer"
                      },
                      Stopping: {
                        type: "integer"
                      },
                      Terminated: {
                        type: "integer"
                      },
                      Terminating: {
                        type: "integer"
                      },
                      Unassigning: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeStacks: {
          input: {
            type: "structure",
            members: {
              StackIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Stacks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StackId: {},
                    Name: {},
                    Arn: {},
                    Region: {},
                    VpcId: {},
                    Attributes: {
                      shape: "S8"
                    },
                    ServiceRoleArn: {},
                    DefaultInstanceProfileArn: {},
                    DefaultOs: {},
                    HostnameTheme: {},
                    DefaultAvailabilityZone: {},
                    DefaultSubnetId: {},
                    CustomJson: {},
                    ConfigurationManager: {
                      shape: "Sa"
                    },
                    ChefConfiguration: {
                      shape: "Sb"
                    },
                    UseCustomCookbooks: {
                      type: "boolean"
                    },
                    UseOpsworksSecurityGroups: {
                      type: "boolean"
                    },
                    CustomCookbooksSource: {
                      shape: "Sd"
                    },
                    DefaultSshKeyName: {},
                    CreatedAt: {},
                    DefaultRootDeviceType: {},
                    AgentVersion: {}
                  }
                }
              }
            }
          }
        },
        DescribeTimeBasedAutoScaling: {
          input: {
            type: "structure",
            required: [
              "InstanceIds"
            ],
            members: {
              InstanceIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TimeBasedAutoScalingConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InstanceId: {},
                    AutoScalingSchedule: {
                      shape: "S4b"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeUserProfiles: {
          input: {
            type: "structure",
            members: {
              IamUserArns: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserProfiles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IamUserArn: {},
                    Name: {},
                    SshUsername: {},
                    SshPublicKey: {},
                    AllowSelfManagement: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeVolumes: {
          input: {
            type: "structure",
            members: {
              InstanceId: {},
              StackId: {},
              RaidArrayId: {},
              VolumeIds: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Volumes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VolumeId: {},
                    Ec2VolumeId: {},
                    Name: {},
                    RaidArrayId: {},
                    InstanceId: {},
                    Status: {},
                    Size: {
                      type: "integer"
                    },
                    Device: {},
                    MountPoint: {},
                    Region: {},
                    AvailabilityZone: {},
                    VolumeType: {},
                    Iops: {
                      type: "integer"
                    },
                    Encrypted: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DetachElasticLoadBalancer: {
          input: {
            type: "structure",
            required: [
              "ElasticLoadBalancerName",
              "LayerId"
            ],
            members: {
              ElasticLoadBalancerName: {},
              LayerId: {}
            }
          }
        },
        DisassociateElasticIp: {
          input: {
            type: "structure",
            required: [
              "ElasticIp"
            ],
            members: {
              ElasticIp: {}
            }
          }
        },
        GetHostnameSuggestion: {
          input: {
            type: "structure",
            required: [
              "LayerId"
            ],
            members: {
              LayerId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LayerId: {},
              Hostname: {}
            }
          }
        },
        GrantAccess: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              ValidForInMinutes: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemporaryCredential: {
                type: "structure",
                members: {
                  Username: {},
                  Password: {},
                  ValidForInMinutes: {
                    type: "integer"
                  },
                  InstanceId: {}
                }
              }
            }
          }
        },
        ListTags: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S50"
              },
              NextToken: {}
            }
          }
        },
        RebootInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {}
            }
          }
        },
        RegisterEcsCluster: {
          input: {
            type: "structure",
            required: [
              "EcsClusterArn",
              "StackId"
            ],
            members: {
              EcsClusterArn: {},
              StackId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EcsClusterArn: {}
            }
          }
        },
        RegisterElasticIp: {
          input: {
            type: "structure",
            required: [
              "ElasticIp",
              "StackId"
            ],
            members: {
              ElasticIp: {},
              StackId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ElasticIp: {}
            }
          }
        },
        RegisterInstance: {
          input: {
            type: "structure",
            required: [
              "StackId"
            ],
            members: {
              StackId: {},
              Hostname: {},
              PublicIp: {},
              PrivateIp: {},
              RsaPublicKey: {},
              RsaPublicKeyFingerprint: {},
              InstanceIdentity: {
                type: "structure",
                members: {
                  Document: {},
                  Signature: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceId: {}
            }
          }
        },
        RegisterRdsDbInstance: {
          input: {
            type: "structure",
            required: [
              "StackId",
              "RdsDbInstanceArn",
              "DbUser",
              "DbPassword"
            ],
            members: {
              StackId: {},
              RdsDbInstanceArn: {},
              DbUser: {},
              DbPassword: {}
            }
          }
        },
        RegisterVolume: {
          input: {
            type: "structure",
            required: [
              "StackId"
            ],
            members: {
              Ec2VolumeId: {},
              StackId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeId: {}
            }
          }
        },
        SetLoadBasedAutoScaling: {
          input: {
            type: "structure",
            required: [
              "LayerId"
            ],
            members: {
              LayerId: {},
              Enable: {
                type: "boolean"
              },
              UpScaling: {
                shape: "S36"
              },
              DownScaling: {
                shape: "S36"
              }
            }
          }
        },
        SetPermission: {
          input: {
            type: "structure",
            required: [
              "StackId",
              "IamUserArn"
            ],
            members: {
              StackId: {},
              IamUserArn: {},
              AllowSsh: {
                type: "boolean"
              },
              AllowSudo: {
                type: "boolean"
              },
              Level: {}
            }
          }
        },
        SetTimeBasedAutoScaling: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              AutoScalingSchedule: {
                shape: "S4b"
              }
            }
          }
        },
        StartInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {}
            }
          }
        },
        StartStack: {
          input: {
            type: "structure",
            required: [
              "StackId"
            ],
            members: {
              StackId: {}
            }
          }
        },
        StopInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              Force: {
                type: "boolean"
              }
            }
          }
        },
        StopStack: {
          input: {
            type: "structure",
            required: [
              "StackId"
            ],
            members: {
              StackId: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S50"
              }
            }
          }
        },
        UnassignInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {}
            }
          }
        },
        UnassignVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              VolumeId: {}
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateApp: {
          input: {
            type: "structure",
            required: [
              "AppId"
            ],
            members: {
              AppId: {},
              Name: {},
              Description: {},
              DataSources: {
                shape: "Si"
              },
              Type: {},
              AppSource: {
                shape: "Sd"
              },
              Domains: {
                shape: "S3"
              },
              EnableSsl: {
                type: "boolean"
              },
              SslConfiguration: {
                shape: "Sl"
              },
              Attributes: {
                shape: "Sm"
              },
              Environment: {
                shape: "So"
              }
            }
          }
        },
        UpdateElasticIp: {
          input: {
            type: "structure",
            required: [
              "ElasticIp"
            ],
            members: {
              ElasticIp: {},
              Name: {}
            }
          }
        },
        UpdateInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              LayerIds: {
                shape: "S3"
              },
              InstanceType: {},
              AutoScalingType: {},
              Hostname: {},
              Os: {},
              AmiId: {},
              SshKeyName: {},
              Architecture: {},
              InstallUpdatesOnBoot: {
                type: "boolean"
              },
              EbsOptimized: {
                type: "boolean"
              },
              AgentVersion: {}
            }
          }
        },
        UpdateLayer: {
          input: {
            type: "structure",
            required: [
              "LayerId"
            ],
            members: {
              LayerId: {},
              Name: {},
              Shortname: {},
              Attributes: {
                shape: "S17"
              },
              CloudWatchLogsConfiguration: {
                shape: "S19"
              },
              CustomInstanceProfileArn: {},
              CustomJson: {},
              CustomSecurityGroupIds: {
                shape: "S3"
              },
              Packages: {
                shape: "S3"
              },
              VolumeConfigurations: {
                shape: "S1f"
              },
              EnableAutoHealing: {
                type: "boolean"
              },
              AutoAssignElasticIps: {
                type: "boolean"
              },
              AutoAssignPublicIps: {
                type: "boolean"
              },
              CustomRecipes: {
                shape: "S1h"
              },
              InstallUpdatesOnBoot: {
                type: "boolean"
              },
              UseEbsOptimizedInstances: {
                type: "boolean"
              },
              LifecycleEventConfiguration: {
                shape: "S1i"
              }
            }
          }
        },
        UpdateMyUserProfile: {
          input: {
            type: "structure",
            members: {
              SshPublicKey: {}
            }
          }
        },
        UpdateRdsDbInstance: {
          input: {
            type: "structure",
            required: [
              "RdsDbInstanceArn"
            ],
            members: {
              RdsDbInstanceArn: {},
              DbUser: {},
              DbPassword: {}
            }
          }
        },
        UpdateStack: {
          input: {
            type: "structure",
            required: [
              "StackId"
            ],
            members: {
              StackId: {},
              Name: {},
              Attributes: {
                shape: "S8"
              },
              ServiceRoleArn: {},
              DefaultInstanceProfileArn: {},
              DefaultOs: {},
              HostnameTheme: {},
              DefaultAvailabilityZone: {},
              DefaultSubnetId: {},
              CustomJson: {},
              ConfigurationManager: {
                shape: "Sa"
              },
              ChefConfiguration: {
                shape: "Sb"
              },
              UseCustomCookbooks: {
                type: "boolean"
              },
              CustomCookbooksSource: {
                shape: "Sd"
              },
              DefaultSshKeyName: {},
              DefaultRootDeviceType: {},
              UseOpsworksSecurityGroups: {
                type: "boolean"
              },
              AgentVersion: {}
            }
          }
        },
        UpdateUserProfile: {
          input: {
            type: "structure",
            required: [
              "IamUserArn"
            ],
            members: {
              IamUserArn: {},
              SshUsername: {},
              SshPublicKey: {},
              AllowSelfManagement: {
                type: "boolean"
              }
            }
          }
        },
        UpdateVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              VolumeId: {},
              Name: {},
              MountPoint: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        S8: {
          type: "map",
          key: {},
          value: {}
        },
        Sa: {
          type: "structure",
          members: {
            Name: {},
            Version: {}
          }
        },
        Sb: {
          type: "structure",
          members: {
            ManageBerkshelf: {
              type: "boolean"
            },
            BerkshelfVersion: {}
          }
        },
        Sd: {
          type: "structure",
          members: {
            Type: {},
            Url: {},
            Username: {},
            Password: {},
            SshKey: {},
            Revision: {}
          }
        },
        Si: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              Arn: {},
              DatabaseName: {}
            }
          }
        },
        Sl: {
          type: "structure",
          required: [
            "Certificate",
            "PrivateKey"
          ],
          members: {
            Certificate: {},
            PrivateKey: {},
            Chain: {}
          }
        },
        Sm: {
          type: "map",
          key: {},
          value: {}
        },
        So: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {},
              Secure: {
                type: "boolean"
              }
            }
          }
        },
        Ss: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            Args: {
              type: "map",
              key: {},
              value: {
                shape: "S3"
              }
            }
          }
        },
        Sz: {
          type: "list",
          member: {
            type: "structure",
            members: {
              DeviceName: {},
              NoDevice: {},
              VirtualName: {},
              Ebs: {
                type: "structure",
                members: {
                  SnapshotId: {},
                  Iops: {
                    type: "integer"
                  },
                  VolumeSize: {
                    type: "integer"
                  },
                  VolumeType: {},
                  DeleteOnTermination: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S17: {
          type: "map",
          key: {},
          value: {}
        },
        S19: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            LogStreams: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  LogGroupName: {},
                  DatetimeFormat: {},
                  TimeZone: {},
                  File: {},
                  FileFingerprintLines: {},
                  MultiLineStartPattern: {},
                  InitialPosition: {},
                  Encoding: {},
                  BufferDuration: {
                    type: "integer"
                  },
                  BatchCount: {
                    type: "integer"
                  },
                  BatchSize: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        S1f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "MountPoint",
              "NumberOfDisks",
              "Size"
            ],
            members: {
              MountPoint: {},
              RaidLevel: {
                type: "integer"
              },
              NumberOfDisks: {
                type: "integer"
              },
              Size: {
                type: "integer"
              },
              VolumeType: {},
              Iops: {
                type: "integer"
              },
              Encrypted: {
                type: "boolean"
              }
            }
          }
        },
        S1h: {
          type: "structure",
          members: {
            Setup: {
              shape: "S3"
            },
            Configure: {
              shape: "S3"
            },
            Deploy: {
              shape: "S3"
            },
            Undeploy: {
              shape: "S3"
            },
            Shutdown: {
              shape: "S3"
            }
          }
        },
        S1i: {
          type: "structure",
          members: {
            Shutdown: {
              type: "structure",
              members: {
                ExecutionTimeout: {
                  type: "integer"
                },
                DelayUntilElbConnectionsDrained: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S36: {
          type: "structure",
          members: {
            InstanceCount: {
              type: "integer"
            },
            ThresholdsWaitTime: {
              type: "integer"
            },
            IgnoreMetricsTime: {
              type: "integer"
            },
            CpuThreshold: {
              type: "double"
            },
            MemoryThreshold: {
              type: "double"
            },
            LoadThreshold: {
              type: "double"
            },
            Alarms: {
              shape: "S3"
            }
          }
        },
        S4b: {
          type: "structure",
          members: {
            Monday: {
              shape: "S4c"
            },
            Tuesday: {
              shape: "S4c"
            },
            Wednesday: {
              shape: "S4c"
            },
            Thursday: {
              shape: "S4c"
            },
            Friday: {
              shape: "S4c"
            },
            Saturday: {
              shape: "S4c"
            },
            Sunday: {
              shape: "S4c"
            }
          }
        },
        S4c: {
          type: "map",
          key: {},
          value: {}
        },
        S50: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/opsworks-2013-02-18.paginators.json
var require_opsworks_2013_02_18_paginators = __commonJS({
  "node_modules/aws-sdk/apis/opsworks-2013-02-18.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeApps: {
          result_key: "Apps"
        },
        DescribeCommands: {
          result_key: "Commands"
        },
        DescribeDeployments: {
          result_key: "Deployments"
        },
        DescribeEcsClusters: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "EcsClusters"
        },
        DescribeElasticIps: {
          result_key: "ElasticIps"
        },
        DescribeElasticLoadBalancers: {
          result_key: "ElasticLoadBalancers"
        },
        DescribeInstances: {
          result_key: "Instances"
        },
        DescribeLayers: {
          result_key: "Layers"
        },
        DescribeLoadBasedAutoScaling: {
          result_key: "LoadBasedAutoScalingConfigurations"
        },
        DescribePermissions: {
          result_key: "Permissions"
        },
        DescribeRaidArrays: {
          result_key: "RaidArrays"
        },
        DescribeServiceErrors: {
          result_key: "ServiceErrors"
        },
        DescribeStacks: {
          result_key: "Stacks"
        },
        DescribeTimeBasedAutoScaling: {
          result_key: "TimeBasedAutoScalingConfigurations"
        },
        DescribeUserProfiles: {
          result_key: "UserProfiles"
        },
        DescribeVolumes: {
          result_key: "Volumes"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/opsworks-2013-02-18.waiters2.json
var require_opsworks_2013_02_18_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/opsworks-2013-02-18.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        AppExists: {
          delay: 1,
          operation: "DescribeApps",
          maxAttempts: 40,
          acceptors: [
            {
              expected: 200,
              matcher: "status",
              state: "success"
            },
            {
              matcher: "status",
              expected: 400,
              state: "failure"
            }
          ]
        },
        DeploymentSuccessful: {
          delay: 15,
          operation: "DescribeDeployments",
          maxAttempts: 40,
          description: "Wait until a deployment has completed successfully.",
          acceptors: [
            {
              expected: "successful",
              matcher: "pathAll",
              state: "success",
              argument: "Deployments[].Status"
            },
            {
              expected: "failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Deployments[].Status"
            }
          ]
        },
        InstanceOnline: {
          delay: 15,
          operation: "DescribeInstances",
          maxAttempts: 40,
          description: "Wait until OpsWorks instance is online.",
          acceptors: [
            {
              expected: "online",
              matcher: "pathAll",
              state: "success",
              argument: "Instances[].Status"
            },
            {
              expected: "setup_failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "shutting_down",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "start_failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "stopped",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "stopping",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "terminating",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "terminated",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "stop_failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            }
          ]
        },
        InstanceRegistered: {
          delay: 15,
          operation: "DescribeInstances",
          maxAttempts: 40,
          description: "Wait until OpsWorks instance is registered.",
          acceptors: [
            {
              expected: "registered",
              matcher: "pathAll",
              state: "success",
              argument: "Instances[].Status"
            },
            {
              expected: "setup_failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "shutting_down",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "stopped",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "stopping",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "terminating",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "terminated",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "stop_failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            }
          ]
        },
        InstanceStopped: {
          delay: 15,
          operation: "DescribeInstances",
          maxAttempts: 40,
          description: "Wait until OpsWorks instance is stopped.",
          acceptors: [
            {
              expected: "stopped",
              matcher: "pathAll",
              state: "success",
              argument: "Instances[].Status"
            },
            {
              expected: "booting",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "pending",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "rebooting",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "requested",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "running_setup",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "setup_failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "start_failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "stop_failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            }
          ]
        },
        InstanceTerminated: {
          delay: 15,
          operation: "DescribeInstances",
          maxAttempts: 40,
          description: "Wait until OpsWorks instance is terminated.",
          acceptors: [
            {
              expected: "terminated",
              matcher: "pathAll",
              state: "success",
              argument: "Instances[].Status"
            },
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "success"
            },
            {
              expected: "booting",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "online",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "pending",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "rebooting",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "requested",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "running_setup",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "setup_failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            },
            {
              expected: "start_failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Instances[].Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/opsworks.js
var require_opsworks = __commonJS({
  "node_modules/aws-sdk/clients/opsworks.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["opsworks"] = {};
    AWS3.OpsWorks = Service.defineService("opsworks", ["2013-02-18"]);
    Object.defineProperty(apiLoader.services["opsworks"], "2013-02-18", {
      get: function get() {
        var model = require_opsworks_2013_02_18_min();
        model.paginators = require_opsworks_2013_02_18_paginators().pagination;
        model.waiters = require_opsworks_2013_02_18_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.OpsWorks;
  }
});

// node_modules/aws-sdk/apis/opsworkscm-2016-11-01.min.json
var require_opsworkscm_2016_11_01_min = __commonJS({
  "node_modules/aws-sdk/apis/opsworkscm-2016-11-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-11-01",
        endpointPrefix: "opsworks-cm",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "OpsWorksCM",
        serviceFullName: "AWS OpsWorks CM",
        serviceId: "OpsWorksCM",
        signatureVersion: "v4",
        signingName: "opsworks-cm",
        targetPrefix: "OpsWorksCM_V2016_11_01",
        uid: "opsworkscm-2016-11-01"
      },
      operations: {
        AssociateNode: {
          input: {
            type: "structure",
            required: [
              "ServerName",
              "NodeName",
              "EngineAttributes"
            ],
            members: {
              ServerName: {},
              NodeName: {},
              EngineAttributes: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NodeAssociationStatusToken: {}
            }
          }
        },
        CreateBackup: {
          input: {
            type: "structure",
            required: [
              "ServerName"
            ],
            members: {
              ServerName: {},
              Description: {},
              Tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Backup: {
                shape: "Sh"
              }
            }
          }
        },
        CreateServer: {
          input: {
            type: "structure",
            required: [
              "Engine",
              "ServerName",
              "InstanceProfileArn",
              "InstanceType",
              "ServiceRoleArn"
            ],
            members: {
              AssociatePublicIpAddress: {
                type: "boolean"
              },
              CustomDomain: {},
              CustomCertificate: {},
              CustomPrivateKey: {
                type: "string",
                sensitive: true
              },
              DisableAutomatedBackup: {
                type: "boolean"
              },
              Engine: {},
              EngineModel: {},
              EngineVersion: {},
              EngineAttributes: {
                shape: "S4"
              },
              BackupRetentionCount: {
                type: "integer"
              },
              ServerName: {},
              InstanceProfileArn: {},
              InstanceType: {},
              KeyPair: {},
              PreferredMaintenanceWindow: {},
              PreferredBackupWindow: {},
              SecurityGroupIds: {
                shape: "Sn"
              },
              ServiceRoleArn: {},
              SubnetIds: {
                shape: "Sn"
              },
              Tags: {
                shape: "Sc"
              },
              BackupId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Server: {
                shape: "Sz"
              }
            }
          }
        },
        DeleteBackup: {
          input: {
            type: "structure",
            required: [
              "BackupId"
            ],
            members: {
              BackupId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteServer: {
          input: {
            type: "structure",
            required: [
              "ServerName"
            ],
            members: {
              ServerName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeAccountAttributes: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Maximum: {
                      type: "integer"
                    },
                    Used: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeBackups: {
          input: {
            type: "structure",
            members: {
              BackupId: {},
              ServerName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Backups: {
                type: "list",
                member: {
                  shape: "Sh"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            required: [
              "ServerName"
            ],
            members: {
              ServerName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ServerEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedAt: {
                      type: "timestamp"
                    },
                    ServerName: {},
                    Message: {},
                    LogUrl: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeNodeAssociationStatus: {
          input: {
            type: "structure",
            required: [
              "NodeAssociationStatusToken",
              "ServerName"
            ],
            members: {
              NodeAssociationStatusToken: {},
              ServerName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NodeAssociationStatus: {},
              EngineAttributes: {
                shape: "S4"
              }
            }
          }
        },
        DescribeServers: {
          input: {
            type: "structure",
            members: {
              ServerName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Servers: {
                type: "list",
                member: {
                  shape: "Sz"
                }
              },
              NextToken: {}
            }
          }
        },
        DisassociateNode: {
          input: {
            type: "structure",
            required: [
              "ServerName",
              "NodeName"
            ],
            members: {
              ServerName: {},
              NodeName: {},
              EngineAttributes: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NodeAssociationStatusToken: {}
            }
          }
        },
        ExportServerEngineAttribute: {
          input: {
            type: "structure",
            required: [
              "ExportAttributeName",
              "ServerName"
            ],
            members: {
              ExportAttributeName: {},
              ServerName: {},
              InputAttributes: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EngineAttribute: {
                shape: "S5"
              },
              ServerName: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sc"
              },
              NextToken: {}
            }
          }
        },
        RestoreServer: {
          input: {
            type: "structure",
            required: [
              "BackupId",
              "ServerName"
            ],
            members: {
              BackupId: {},
              ServerName: {},
              InstanceType: {},
              KeyPair: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Server: {
                shape: "Sz"
              }
            }
          }
        },
        StartMaintenance: {
          input: {
            type: "structure",
            required: [
              "ServerName"
            ],
            members: {
              ServerName: {},
              EngineAttributes: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Server: {
                shape: "Sz"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateServer: {
          input: {
            type: "structure",
            required: [
              "ServerName"
            ],
            members: {
              DisableAutomatedBackup: {
                type: "boolean"
              },
              BackupRetentionCount: {
                type: "integer"
              },
              ServerName: {},
              PreferredMaintenanceWindow: {},
              PreferredBackupWindow: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Server: {
                shape: "Sz"
              }
            }
          }
        },
        UpdateServerEngineAttributes: {
          input: {
            type: "structure",
            required: [
              "ServerName",
              "AttributeName"
            ],
            members: {
              ServerName: {},
              AttributeName: {},
              AttributeValue: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Server: {
                shape: "Sz"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {
            shape: "S5"
          }
        },
        S5: {
          type: "structure",
          members: {
            Name: {},
            Value: {
              type: "string",
              sensitive: true
            }
          }
        },
        Sc: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sh: {
          type: "structure",
          members: {
            BackupArn: {},
            BackupId: {},
            BackupType: {},
            CreatedAt: {
              type: "timestamp"
            },
            Description: {},
            Engine: {},
            EngineModel: {},
            EngineVersion: {},
            InstanceProfileArn: {},
            InstanceType: {},
            KeyPair: {},
            PreferredBackupWindow: {},
            PreferredMaintenanceWindow: {},
            S3DataSize: {
              deprecated: true,
              type: "integer"
            },
            S3DataUrl: {
              deprecated: true
            },
            S3LogUrl: {},
            SecurityGroupIds: {
              shape: "Sn"
            },
            ServerName: {},
            ServiceRoleArn: {},
            Status: {},
            StatusDescription: {},
            SubnetIds: {
              shape: "Sn"
            },
            ToolsVersion: {},
            UserArn: {}
          }
        },
        Sn: {
          type: "list",
          member: {}
        },
        Sz: {
          type: "structure",
          members: {
            AssociatePublicIpAddress: {
              type: "boolean"
            },
            BackupRetentionCount: {
              type: "integer"
            },
            ServerName: {},
            CreatedAt: {
              type: "timestamp"
            },
            CloudFormationStackArn: {},
            CustomDomain: {},
            DisableAutomatedBackup: {
              type: "boolean"
            },
            Endpoint: {},
            Engine: {},
            EngineModel: {},
            EngineAttributes: {
              shape: "S4"
            },
            EngineVersion: {},
            InstanceProfileArn: {},
            InstanceType: {},
            KeyPair: {},
            MaintenanceStatus: {},
            PreferredMaintenanceWindow: {},
            PreferredBackupWindow: {},
            SecurityGroupIds: {
              shape: "Sn"
            },
            ServiceRoleArn: {},
            Status: {},
            StatusReason: {},
            SubnetIds: {
              shape: "Sn"
            },
            ServerArn: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/opsworkscm-2016-11-01.paginators.json
var require_opsworkscm_2016_11_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/opsworkscm-2016-11-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeBackups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Backups"
        },
        DescribeEvents: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ServerEvents"
        },
        DescribeServers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Servers"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Tags"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/opsworkscm-2016-11-01.waiters2.json
var require_opsworkscm_2016_11_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/opsworkscm-2016-11-01.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        NodeAssociated: {
          delay: 15,
          maxAttempts: 15,
          operation: "DescribeNodeAssociationStatus",
          description: "Wait until node is associated or disassociated.",
          acceptors: [
            {
              expected: "SUCCESS",
              state: "success",
              matcher: "path",
              argument: "NodeAssociationStatus"
            },
            {
              expected: "FAILED",
              state: "failure",
              matcher: "path",
              argument: "NodeAssociationStatus"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/opsworkscm.js
var require_opsworkscm = __commonJS({
  "node_modules/aws-sdk/clients/opsworkscm.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["opsworkscm"] = {};
    AWS3.OpsWorksCM = Service.defineService("opsworkscm", ["2016-11-01"]);
    Object.defineProperty(apiLoader.services["opsworkscm"], "2016-11-01", {
      get: function get() {
        var model = require_opsworkscm_2016_11_01_min();
        model.paginators = require_opsworkscm_2016_11_01_paginators().pagination;
        model.waiters = require_opsworkscm_2016_11_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.OpsWorksCM;
  }
});

// node_modules/aws-sdk/apis/organizations-2016-11-28.min.json
var require_organizations_2016_11_28_min = __commonJS({
  "node_modules/aws-sdk/apis/organizations-2016-11-28.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-11-28",
        endpointPrefix: "organizations",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Organizations",
        serviceFullName: "AWS Organizations",
        serviceId: "Organizations",
        signatureVersion: "v4",
        targetPrefix: "AWSOrganizationsV20161128",
        uid: "organizations-2016-11-28"
      },
      operations: {
        AcceptHandshake: {
          input: {
            type: "structure",
            required: [
              "HandshakeId"
            ],
            members: {
              HandshakeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Handshake: {
                shape: "S4"
              }
            }
          }
        },
        AttachPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyId",
              "TargetId"
            ],
            members: {
              PolicyId: {},
              TargetId: {}
            }
          }
        },
        CancelHandshake: {
          input: {
            type: "structure",
            required: [
              "HandshakeId"
            ],
            members: {
              HandshakeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Handshake: {
                shape: "S4"
              }
            }
          }
        },
        CreateAccount: {
          input: {
            type: "structure",
            required: [
              "Email",
              "AccountName"
            ],
            members: {
              Email: {
                shape: "Sn"
              },
              AccountName: {
                shape: "So"
              },
              RoleName: {},
              IamUserAccessToBilling: {},
              Tags: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CreateAccountStatus: {
                shape: "Sw"
              }
            }
          }
        },
        CreateGovCloudAccount: {
          input: {
            type: "structure",
            required: [
              "Email",
              "AccountName"
            ],
            members: {
              Email: {
                shape: "Sn"
              },
              AccountName: {
                shape: "So"
              },
              RoleName: {},
              IamUserAccessToBilling: {},
              Tags: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CreateAccountStatus: {
                shape: "Sw"
              }
            }
          }
        },
        CreateOrganization: {
          input: {
            type: "structure",
            members: {
              FeatureSet: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Organization: {
                shape: "S16"
              }
            }
          }
        },
        CreateOrganizationalUnit: {
          input: {
            type: "structure",
            required: [
              "ParentId",
              "Name"
            ],
            members: {
              ParentId: {},
              Name: {},
              Tags: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationalUnit: {
                shape: "S1i"
              }
            }
          }
        },
        CreatePolicy: {
          input: {
            type: "structure",
            required: [
              "Content",
              "Description",
              "Name",
              "Type"
            ],
            members: {
              Content: {},
              Description: {},
              Name: {},
              Type: {},
              Tags: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                shape: "S1q"
              }
            }
          }
        },
        DeclineHandshake: {
          input: {
            type: "structure",
            required: [
              "HandshakeId"
            ],
            members: {
              HandshakeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Handshake: {
                shape: "S4"
              }
            }
          }
        },
        DeleteOrganization: {},
        DeleteOrganizationalUnit: {
          input: {
            type: "structure",
            required: [
              "OrganizationalUnitId"
            ],
            members: {
              OrganizationalUnitId: {}
            }
          }
        },
        DeletePolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {}
            }
          }
        },
        DeregisterDelegatedAdministrator: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "ServicePrincipal"
            ],
            members: {
              AccountId: {},
              ServicePrincipal: {}
            }
          }
        },
        DescribeAccount: {
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Account: {
                shape: "S22"
              }
            }
          }
        },
        DescribeCreateAccountStatus: {
          input: {
            type: "structure",
            required: [
              "CreateAccountRequestId"
            ],
            members: {
              CreateAccountRequestId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CreateAccountStatus: {
                shape: "Sw"
              }
            }
          }
        },
        DescribeEffectivePolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyType"
            ],
            members: {
              PolicyType: {},
              TargetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EffectivePolicy: {
                type: "structure",
                members: {
                  PolicyContent: {},
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  },
                  TargetId: {},
                  PolicyType: {}
                }
              }
            }
          }
        },
        DescribeHandshake: {
          input: {
            type: "structure",
            required: [
              "HandshakeId"
            ],
            members: {
              HandshakeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Handshake: {
                shape: "S4"
              }
            }
          }
        },
        DescribeOrganization: {
          output: {
            type: "structure",
            members: {
              Organization: {
                shape: "S16"
              }
            }
          }
        },
        DescribeOrganizationalUnit: {
          input: {
            type: "structure",
            required: [
              "OrganizationalUnitId"
            ],
            members: {
              OrganizationalUnitId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationalUnit: {
                shape: "S1i"
              }
            }
          }
        },
        DescribePolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                shape: "S1q"
              }
            }
          }
        },
        DetachPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyId",
              "TargetId"
            ],
            members: {
              PolicyId: {},
              TargetId: {}
            }
          }
        },
        DisableAWSServiceAccess: {
          input: {
            type: "structure",
            required: [
              "ServicePrincipal"
            ],
            members: {
              ServicePrincipal: {}
            }
          }
        },
        DisablePolicyType: {
          input: {
            type: "structure",
            required: [
              "RootId",
              "PolicyType"
            ],
            members: {
              RootId: {},
              PolicyType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Root: {
                shape: "S2n"
              }
            }
          }
        },
        EnableAWSServiceAccess: {
          input: {
            type: "structure",
            required: [
              "ServicePrincipal"
            ],
            members: {
              ServicePrincipal: {}
            }
          }
        },
        EnableAllFeatures: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Handshake: {
                shape: "S4"
              }
            }
          }
        },
        EnablePolicyType: {
          input: {
            type: "structure",
            required: [
              "RootId",
              "PolicyType"
            ],
            members: {
              RootId: {},
              PolicyType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Root: {
                shape: "S2n"
              }
            }
          }
        },
        InviteAccountToOrganization: {
          input: {
            type: "structure",
            required: [
              "Target"
            ],
            members: {
              Target: {
                shape: "S7"
              },
              Notes: {
                type: "string",
                sensitive: true
              },
              Tags: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Handshake: {
                shape: "S4"
              }
            }
          }
        },
        LeaveOrganization: {},
        ListAWSServiceAccessForOrganization: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EnabledServicePrincipals: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ServicePrincipal: {},
                    DateEnabled: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAccounts: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Accounts: {
                shape: "S36"
              },
              NextToken: {}
            }
          }
        },
        ListAccountsForParent: {
          input: {
            type: "structure",
            required: [
              "ParentId"
            ],
            members: {
              ParentId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Accounts: {
                shape: "S36"
              },
              NextToken: {}
            }
          }
        },
        ListChildren: {
          input: {
            type: "structure",
            required: [
              "ParentId",
              "ChildType"
            ],
            members: {
              ParentId: {},
              ChildType: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Children: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Type: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCreateAccountStatus: {
          input: {
            type: "structure",
            members: {
              States: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CreateAccountStatuses: {
                type: "list",
                member: {
                  shape: "Sw"
                }
              },
              NextToken: {}
            }
          }
        },
        ListDelegatedAdministrators: {
          input: {
            type: "structure",
            members: {
              ServicePrincipal: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DelegatedAdministrators: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Email: {
                      shape: "Sn"
                    },
                    Name: {
                      shape: "So"
                    },
                    Status: {},
                    JoinedMethod: {},
                    JoinedTimestamp: {
                      type: "timestamp"
                    },
                    DelegationEnabledDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDelegatedServicesForAccount: {
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DelegatedServices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ServicePrincipal: {},
                    DelegationEnabledDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListHandshakesForAccount: {
          input: {
            type: "structure",
            members: {
              Filter: {
                shape: "S3s"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Handshakes: {
                shape: "S3u"
              },
              NextToken: {}
            }
          }
        },
        ListHandshakesForOrganization: {
          input: {
            type: "structure",
            members: {
              Filter: {
                shape: "S3s"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Handshakes: {
                shape: "S3u"
              },
              NextToken: {}
            }
          }
        },
        ListOrganizationalUnitsForParent: {
          input: {
            type: "structure",
            required: [
              "ParentId"
            ],
            members: {
              ParentId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationalUnits: {
                type: "list",
                member: {
                  shape: "S1i"
                }
              },
              NextToken: {}
            }
          }
        },
        ListParents: {
          input: {
            type: "structure",
            required: [
              "ChildId"
            ],
            members: {
              ChildId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Parents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Type: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPolicies: {
          input: {
            type: "structure",
            required: [
              "Filter"
            ],
            members: {
              Filter: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policies: {
                shape: "S47"
              },
              NextToken: {}
            }
          }
        },
        ListPoliciesForTarget: {
          input: {
            type: "structure",
            required: [
              "TargetId",
              "Filter"
            ],
            members: {
              TargetId: {},
              Filter: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policies: {
                shape: "S47"
              },
              NextToken: {}
            }
          }
        },
        ListRoots: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Roots: {
                type: "list",
                member: {
                  shape: "S2n"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sr"
              },
              NextToken: {}
            }
          }
        },
        ListTargetsForPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Targets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TargetId: {},
                    Arn: {},
                    Name: {},
                    Type: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        MoveAccount: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "SourceParentId",
              "DestinationParentId"
            ],
            members: {
              AccountId: {},
              SourceParentId: {},
              DestinationParentId: {}
            }
          }
        },
        RegisterDelegatedAdministrator: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "ServicePrincipal"
            ],
            members: {
              AccountId: {},
              ServicePrincipal: {}
            }
          }
        },
        RemoveAccountFromOrganization: {
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "Tags"
            ],
            members: {
              ResourceId: {},
              Tags: {
                shape: "Sr"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "TagKeys"
            ],
            members: {
              ResourceId: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateOrganizationalUnit: {
          input: {
            type: "structure",
            required: [
              "OrganizationalUnitId"
            ],
            members: {
              OrganizationalUnitId: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationalUnit: {
                shape: "S1i"
              }
            }
          }
        },
        UpdatePolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {},
              Name: {},
              Description: {},
              Content: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                shape: "S1q"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Parties: {
              type: "list",
              member: {
                shape: "S7"
              }
            },
            State: {},
            RequestedTimestamp: {
              type: "timestamp"
            },
            ExpirationTimestamp: {
              type: "timestamp"
            },
            Action: {},
            Resources: {
              shape: "Sd"
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "Id",
            "Type"
          ],
          members: {
            Id: {
              type: "string",
              sensitive: true
            },
            Type: {}
          }
        },
        Sd: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Value: {
                type: "string",
                sensitive: true
              },
              Type: {},
              Resources: {
                shape: "Sd"
              }
            }
          }
        },
        Sn: {
          type: "string",
          sensitive: true
        },
        So: {
          type: "string",
          sensitive: true
        },
        Sr: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sw: {
          type: "structure",
          members: {
            Id: {},
            AccountName: {
              shape: "So"
            },
            State: {},
            RequestedTimestamp: {
              type: "timestamp"
            },
            CompletedTimestamp: {
              type: "timestamp"
            },
            AccountId: {},
            GovCloudAccountId: {},
            FailureReason: {}
          }
        },
        S16: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            FeatureSet: {},
            MasterAccountArn: {},
            MasterAccountId: {},
            MasterAccountEmail: {
              shape: "Sn"
            },
            AvailablePolicyTypes: {
              shape: "S1a"
            }
          }
        },
        S1a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              Status: {}
            }
          }
        },
        S1i: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {}
          }
        },
        S1q: {
          type: "structure",
          members: {
            PolicySummary: {
              shape: "S1r"
            },
            Content: {}
          }
        },
        S1r: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {},
            Description: {},
            Type: {},
            AwsManaged: {
              type: "boolean"
            }
          }
        },
        S22: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Email: {
              shape: "Sn"
            },
            Name: {
              shape: "So"
            },
            Status: {},
            JoinedMethod: {},
            JoinedTimestamp: {
              type: "timestamp"
            }
          }
        },
        S2n: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {},
            PolicyTypes: {
              shape: "S1a"
            }
          }
        },
        S36: {
          type: "list",
          member: {
            shape: "S22"
          }
        },
        S3s: {
          type: "structure",
          members: {
            ActionType: {},
            ParentHandshakeId: {}
          }
        },
        S3u: {
          type: "list",
          member: {
            shape: "S4"
          }
        },
        S47: {
          type: "list",
          member: {
            shape: "S1r"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/organizations-2016-11-28.paginators.json
var require_organizations_2016_11_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/organizations-2016-11-28.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAWSServiceAccessForOrganization: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListAccounts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListAccountsForParent: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListChildren: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListCreateAccountStatus: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListDelegatedAdministrators: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DelegatedAdministrators"
        },
        ListDelegatedServicesForAccount: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DelegatedServices"
        },
        ListHandshakesForAccount: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListHandshakesForOrganization: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListOrganizationalUnitsForParent: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListParents: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListPolicies: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListPoliciesForTarget: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListRoots: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Tags"
        },
        ListTargetsForPolicy: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/organizations.js
var require_organizations = __commonJS({
  "node_modules/aws-sdk/clients/organizations.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["organizations"] = {};
    AWS3.Organizations = Service.defineService("organizations", ["2016-11-28"]);
    Object.defineProperty(apiLoader.services["organizations"], "2016-11-28", {
      get: function get() {
        var model = require_organizations_2016_11_28_min();
        model.paginators = require_organizations_2016_11_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Organizations;
  }
});

// node_modules/aws-sdk/apis/pinpoint-2016-12-01.min.json
var require_pinpoint_2016_12_01_min = __commonJS({
  "node_modules/aws-sdk/apis/pinpoint-2016-12-01.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2016-12-01",
        endpointPrefix: "pinpoint",
        signingName: "mobiletargeting",
        serviceFullName: "Amazon Pinpoint",
        serviceId: "Pinpoint",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "pinpoint-2016-12-01",
        signatureVersion: "v4"
      },
      operations: {
        CreateApp: {
          http: {
            requestUri: "/v1/apps",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              CreateApplicationRequest: {
                type: "structure",
                members: {
                  Name: {},
                  tags: {
                    shape: "S4",
                    locationName: "tags"
                  }
                },
                required: [
                  "Name"
                ]
              }
            },
            required: [
              "CreateApplicationRequest"
            ],
            payload: "CreateApplicationRequest"
          },
          output: {
            type: "structure",
            members: {
              ApplicationResponse: {
                shape: "S6"
              }
            },
            required: [
              "ApplicationResponse"
            ],
            payload: "ApplicationResponse"
          }
        },
        CreateCampaign: {
          http: {
            requestUri: "/v1/apps/{application-id}/campaigns",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              WriteCampaignRequest: {
                shape: "S8"
              }
            },
            required: [
              "ApplicationId",
              "WriteCampaignRequest"
            ],
            payload: "WriteCampaignRequest"
          },
          output: {
            type: "structure",
            members: {
              CampaignResponse: {
                shape: "S1j"
              }
            },
            required: [
              "CampaignResponse"
            ],
            payload: "CampaignResponse"
          }
        },
        CreateEmailTemplate: {
          http: {
            requestUri: "/v1/templates/{template-name}/email",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              EmailTemplateRequest: {
                shape: "S1p"
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              }
            },
            required: [
              "TemplateName",
              "EmailTemplateRequest"
            ],
            payload: "EmailTemplateRequest"
          },
          output: {
            type: "structure",
            members: {
              CreateTemplateMessageBody: {
                shape: "S1r"
              }
            },
            required: [
              "CreateTemplateMessageBody"
            ],
            payload: "CreateTemplateMessageBody"
          }
        },
        CreateExportJob: {
          http: {
            requestUri: "/v1/apps/{application-id}/jobs/export",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              ExportJobRequest: {
                type: "structure",
                members: {
                  RoleArn: {},
                  S3UrlPrefix: {},
                  SegmentId: {},
                  SegmentVersion: {
                    type: "integer"
                  }
                },
                required: [
                  "S3UrlPrefix",
                  "RoleArn"
                ]
              }
            },
            required: [
              "ApplicationId",
              "ExportJobRequest"
            ],
            payload: "ExportJobRequest"
          },
          output: {
            type: "structure",
            members: {
              ExportJobResponse: {
                shape: "S1v"
              }
            },
            required: [
              "ExportJobResponse"
            ],
            payload: "ExportJobResponse"
          }
        },
        CreateImportJob: {
          http: {
            requestUri: "/v1/apps/{application-id}/jobs/import",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              ImportJobRequest: {
                type: "structure",
                members: {
                  DefineSegment: {
                    type: "boolean"
                  },
                  ExternalId: {},
                  Format: {},
                  RegisterEndpoints: {
                    type: "boolean"
                  },
                  RoleArn: {},
                  S3Url: {},
                  SegmentId: {},
                  SegmentName: {}
                },
                required: [
                  "Format",
                  "S3Url",
                  "RoleArn"
                ]
              }
            },
            required: [
              "ApplicationId",
              "ImportJobRequest"
            ],
            payload: "ImportJobRequest"
          },
          output: {
            type: "structure",
            members: {
              ImportJobResponse: {
                shape: "S22"
              }
            },
            required: [
              "ImportJobResponse"
            ],
            payload: "ImportJobResponse"
          }
        },
        CreateInAppTemplate: {
          http: {
            requestUri: "/v1/templates/{template-name}/inapp",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              InAppTemplateRequest: {
                shape: "S25"
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              }
            },
            required: [
              "TemplateName",
              "InAppTemplateRequest"
            ],
            payload: "InAppTemplateRequest"
          },
          output: {
            type: "structure",
            members: {
              TemplateCreateMessageBody: {
                type: "structure",
                members: {
                  Arn: {},
                  Message: {},
                  RequestID: {}
                }
              }
            },
            required: [
              "TemplateCreateMessageBody"
            ],
            payload: "TemplateCreateMessageBody"
          }
        },
        CreateJourney: {
          http: {
            requestUri: "/v1/apps/{application-id}/journeys",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              WriteJourneyRequest: {
                shape: "S29"
              }
            },
            required: [
              "ApplicationId",
              "WriteJourneyRequest"
            ],
            payload: "WriteJourneyRequest"
          },
          output: {
            type: "structure",
            members: {
              JourneyResponse: {
                shape: "S3i"
              }
            },
            required: [
              "JourneyResponse"
            ],
            payload: "JourneyResponse"
          }
        },
        CreatePushTemplate: {
          http: {
            requestUri: "/v1/templates/{template-name}/push",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              PushNotificationTemplateRequest: {
                shape: "S3l"
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              }
            },
            required: [
              "TemplateName",
              "PushNotificationTemplateRequest"
            ],
            payload: "PushNotificationTemplateRequest"
          },
          output: {
            type: "structure",
            members: {
              CreateTemplateMessageBody: {
                shape: "S1r"
              }
            },
            required: [
              "CreateTemplateMessageBody"
            ],
            payload: "CreateTemplateMessageBody"
          }
        },
        CreateRecommenderConfiguration: {
          http: {
            requestUri: "/v1/recommenders",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              CreateRecommenderConfiguration: {
                type: "structure",
                members: {
                  Attributes: {
                    shape: "S4"
                  },
                  Description: {},
                  Name: {},
                  RecommendationProviderIdType: {},
                  RecommendationProviderRoleArn: {},
                  RecommendationProviderUri: {},
                  RecommendationTransformerUri: {},
                  RecommendationsDisplayName: {},
                  RecommendationsPerMessage: {
                    type: "integer"
                  }
                },
                required: [
                  "RecommendationProviderUri",
                  "RecommendationProviderRoleArn"
                ]
              }
            },
            required: [
              "CreateRecommenderConfiguration"
            ],
            payload: "CreateRecommenderConfiguration"
          },
          output: {
            type: "structure",
            members: {
              RecommenderConfigurationResponse: {
                shape: "S3t"
              }
            },
            required: [
              "RecommenderConfigurationResponse"
            ],
            payload: "RecommenderConfigurationResponse"
          }
        },
        CreateSegment: {
          http: {
            requestUri: "/v1/apps/{application-id}/segments",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              WriteSegmentRequest: {
                shape: "S3v"
              }
            },
            required: [
              "ApplicationId",
              "WriteSegmentRequest"
            ],
            payload: "WriteSegmentRequest"
          },
          output: {
            type: "structure",
            members: {
              SegmentResponse: {
                shape: "S46"
              }
            },
            required: [
              "SegmentResponse"
            ],
            payload: "SegmentResponse"
          }
        },
        CreateSmsTemplate: {
          http: {
            requestUri: "/v1/templates/{template-name}/sms",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              SMSTemplateRequest: {
                shape: "S4b"
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              }
            },
            required: [
              "TemplateName",
              "SMSTemplateRequest"
            ],
            payload: "SMSTemplateRequest"
          },
          output: {
            type: "structure",
            members: {
              CreateTemplateMessageBody: {
                shape: "S1r"
              }
            },
            required: [
              "CreateTemplateMessageBody"
            ],
            payload: "CreateTemplateMessageBody"
          }
        },
        CreateVoiceTemplate: {
          http: {
            requestUri: "/v1/templates/{template-name}/voice",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              VoiceTemplateRequest: {
                shape: "S4e"
              }
            },
            required: [
              "TemplateName",
              "VoiceTemplateRequest"
            ],
            payload: "VoiceTemplateRequest"
          },
          output: {
            type: "structure",
            members: {
              CreateTemplateMessageBody: {
                shape: "S1r"
              }
            },
            required: [
              "CreateTemplateMessageBody"
            ],
            payload: "CreateTemplateMessageBody"
          }
        },
        DeleteAdmChannel: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/channels/adm",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ADMChannelResponse: {
                shape: "S4i"
              }
            },
            required: [
              "ADMChannelResponse"
            ],
            payload: "ADMChannelResponse"
          }
        },
        DeleteApnsChannel: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/channels/apns",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              APNSChannelResponse: {
                shape: "S4l"
              }
            },
            required: [
              "APNSChannelResponse"
            ],
            payload: "APNSChannelResponse"
          }
        },
        DeleteApnsSandboxChannel: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/channels/apns_sandbox",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              APNSSandboxChannelResponse: {
                shape: "S4o"
              }
            },
            required: [
              "APNSSandboxChannelResponse"
            ],
            payload: "APNSSandboxChannelResponse"
          }
        },
        DeleteApnsVoipChannel: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/channels/apns_voip",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              APNSVoipChannelResponse: {
                shape: "S4r"
              }
            },
            required: [
              "APNSVoipChannelResponse"
            ],
            payload: "APNSVoipChannelResponse"
          }
        },
        DeleteApnsVoipSandboxChannel: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/channels/apns_voip_sandbox",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              APNSVoipSandboxChannelResponse: {
                shape: "S4u"
              }
            },
            required: [
              "APNSVoipSandboxChannelResponse"
            ],
            payload: "APNSVoipSandboxChannelResponse"
          }
        },
        DeleteApp: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationResponse: {
                shape: "S6"
              }
            },
            required: [
              "ApplicationResponse"
            ],
            payload: "ApplicationResponse"
          }
        },
        DeleteBaiduChannel: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/channels/baidu",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              BaiduChannelResponse: {
                shape: "S4z"
              }
            },
            required: [
              "BaiduChannelResponse"
            ],
            payload: "BaiduChannelResponse"
          }
        },
        DeleteCampaign: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/campaigns/{campaign-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              CampaignId: {
                location: "uri",
                locationName: "campaign-id"
              }
            },
            required: [
              "CampaignId",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              CampaignResponse: {
                shape: "S1j"
              }
            },
            required: [
              "CampaignResponse"
            ],
            payload: "CampaignResponse"
          }
        },
        DeleteEmailChannel: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/channels/email",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              EmailChannelResponse: {
                shape: "S54"
              }
            },
            required: [
              "EmailChannelResponse"
            ],
            payload: "EmailChannelResponse"
          }
        },
        DeleteEmailTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/v1/templates/{template-name}/email",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName"
            ]
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S57"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        DeleteEndpoint: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/endpoints/{endpoint-id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              EndpointId: {
                location: "uri",
                locationName: "endpoint-id"
              }
            },
            required: [
              "ApplicationId",
              "EndpointId"
            ]
          },
          output: {
            type: "structure",
            members: {
              EndpointResponse: {
                shape: "S5a"
              }
            },
            required: [
              "EndpointResponse"
            ],
            payload: "EndpointResponse"
          }
        },
        DeleteEventStream: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/eventstream",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              EventStream: {
                shape: "S5j"
              }
            },
            required: [
              "EventStream"
            ],
            payload: "EventStream"
          }
        },
        DeleteGcmChannel: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/channels/gcm",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              GCMChannelResponse: {
                shape: "S5m"
              }
            },
            required: [
              "GCMChannelResponse"
            ],
            payload: "GCMChannelResponse"
          }
        },
        DeleteInAppTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/v1/templates/{template-name}/inapp",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName"
            ]
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S57"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        DeleteJourney: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/journeys/{journey-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              JourneyId: {
                location: "uri",
                locationName: "journey-id"
              }
            },
            required: [
              "JourneyId",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              JourneyResponse: {
                shape: "S3i"
              }
            },
            required: [
              "JourneyResponse"
            ],
            payload: "JourneyResponse"
          }
        },
        DeletePushTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/v1/templates/{template-name}/push",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName"
            ]
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S57"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        DeleteRecommenderConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/v1/recommenders/{recommender-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RecommenderId: {
                location: "uri",
                locationName: "recommender-id"
              }
            },
            required: [
              "RecommenderId"
            ]
          },
          output: {
            type: "structure",
            members: {
              RecommenderConfigurationResponse: {
                shape: "S3t"
              }
            },
            required: [
              "RecommenderConfigurationResponse"
            ],
            payload: "RecommenderConfigurationResponse"
          }
        },
        DeleteSegment: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/segments/{segment-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              SegmentId: {
                location: "uri",
                locationName: "segment-id"
              }
            },
            required: [
              "SegmentId",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              SegmentResponse: {
                shape: "S46"
              }
            },
            required: [
              "SegmentResponse"
            ],
            payload: "SegmentResponse"
          }
        },
        DeleteSmsChannel: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/channels/sms",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              SMSChannelResponse: {
                shape: "S5z"
              }
            },
            required: [
              "SMSChannelResponse"
            ],
            payload: "SMSChannelResponse"
          }
        },
        DeleteSmsTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/v1/templates/{template-name}/sms",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName"
            ]
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S57"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        DeleteUserEndpoints: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/users/{user-id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              UserId: {
                location: "uri",
                locationName: "user-id"
              }
            },
            required: [
              "ApplicationId",
              "UserId"
            ]
          },
          output: {
            type: "structure",
            members: {
              EndpointsResponse: {
                shape: "S64"
              }
            },
            required: [
              "EndpointsResponse"
            ],
            payload: "EndpointsResponse"
          }
        },
        DeleteVoiceChannel: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apps/{application-id}/channels/voice",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              VoiceChannelResponse: {
                shape: "S68"
              }
            },
            required: [
              "VoiceChannelResponse"
            ],
            payload: "VoiceChannelResponse"
          }
        },
        DeleteVoiceTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/v1/templates/{template-name}/voice",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName"
            ]
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S57"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        GetAdmChannel: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels/adm",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ADMChannelResponse: {
                shape: "S4i"
              }
            },
            required: [
              "ADMChannelResponse"
            ],
            payload: "ADMChannelResponse"
          }
        },
        GetApnsChannel: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels/apns",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              APNSChannelResponse: {
                shape: "S4l"
              }
            },
            required: [
              "APNSChannelResponse"
            ],
            payload: "APNSChannelResponse"
          }
        },
        GetApnsSandboxChannel: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels/apns_sandbox",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              APNSSandboxChannelResponse: {
                shape: "S4o"
              }
            },
            required: [
              "APNSSandboxChannelResponse"
            ],
            payload: "APNSSandboxChannelResponse"
          }
        },
        GetApnsVoipChannel: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels/apns_voip",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              APNSVoipChannelResponse: {
                shape: "S4r"
              }
            },
            required: [
              "APNSVoipChannelResponse"
            ],
            payload: "APNSVoipChannelResponse"
          }
        },
        GetApnsVoipSandboxChannel: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels/apns_voip_sandbox",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              APNSVoipSandboxChannelResponse: {
                shape: "S4u"
              }
            },
            required: [
              "APNSVoipSandboxChannelResponse"
            ],
            payload: "APNSVoipSandboxChannelResponse"
          }
        },
        GetApp: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationResponse: {
                shape: "S6"
              }
            },
            required: [
              "ApplicationResponse"
            ],
            payload: "ApplicationResponse"
          }
        },
        GetApplicationDateRangeKpi: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/kpis/daterange/{kpi-name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              EndTime: {
                shape: "S3c",
                location: "querystring",
                locationName: "end-time"
              },
              KpiName: {
                location: "uri",
                locationName: "kpi-name"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              StartTime: {
                shape: "S3c",
                location: "querystring",
                locationName: "start-time"
              }
            },
            required: [
              "ApplicationId",
              "KpiName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationDateRangeKpiResponse: {
                type: "structure",
                members: {
                  ApplicationId: {},
                  EndTime: {
                    shape: "S3c"
                  },
                  KpiName: {},
                  KpiResult: {
                    shape: "S6q"
                  },
                  NextToken: {},
                  StartTime: {
                    shape: "S3c"
                  }
                },
                required: [
                  "KpiResult",
                  "KpiName",
                  "EndTime",
                  "StartTime",
                  "ApplicationId"
                ]
              }
            },
            required: [
              "ApplicationDateRangeKpiResponse"
            ],
            payload: "ApplicationDateRangeKpiResponse"
          }
        },
        GetApplicationSettings: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationSettingsResource: {
                shape: "S6x"
              }
            },
            required: [
              "ApplicationSettingsResource"
            ],
            payload: "ApplicationSettingsResource"
          }
        },
        GetApps: {
          http: {
            method: "GET",
            requestUri: "/v1/apps",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationsResponse: {
                type: "structure",
                members: {
                  Item: {
                    type: "list",
                    member: {
                      shape: "S6"
                    }
                  },
                  NextToken: {}
                }
              }
            },
            required: [
              "ApplicationsResponse"
            ],
            payload: "ApplicationsResponse"
          }
        },
        GetBaiduChannel: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels/baidu",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              BaiduChannelResponse: {
                shape: "S4z"
              }
            },
            required: [
              "BaiduChannelResponse"
            ],
            payload: "BaiduChannelResponse"
          }
        },
        GetCampaign: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/campaigns/{campaign-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              CampaignId: {
                location: "uri",
                locationName: "campaign-id"
              }
            },
            required: [
              "CampaignId",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              CampaignResponse: {
                shape: "S1j"
              }
            },
            required: [
              "CampaignResponse"
            ],
            payload: "CampaignResponse"
          }
        },
        GetCampaignActivities: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/campaigns/{campaign-id}/activities",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              CampaignId: {
                location: "uri",
                locationName: "campaign-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "ApplicationId",
              "CampaignId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ActivitiesResponse: {
                type: "structure",
                members: {
                  Item: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ApplicationId: {},
                        CampaignId: {},
                        End: {},
                        Id: {},
                        Result: {},
                        ScheduledStart: {},
                        Start: {},
                        State: {},
                        SuccessfulEndpointCount: {
                          type: "integer"
                        },
                        TimezonesCompletedCount: {
                          type: "integer"
                        },
                        TimezonesTotalCount: {
                          type: "integer"
                        },
                        TotalEndpointCount: {
                          type: "integer"
                        },
                        TreatmentId: {}
                      },
                      required: [
                        "CampaignId",
                        "Id",
                        "ApplicationId"
                      ]
                    }
                  },
                  NextToken: {}
                },
                required: [
                  "Item"
                ]
              }
            },
            required: [
              "ActivitiesResponse"
            ],
            payload: "ActivitiesResponse"
          }
        },
        GetCampaignDateRangeKpi: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/campaigns/{campaign-id}/kpis/daterange/{kpi-name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              CampaignId: {
                location: "uri",
                locationName: "campaign-id"
              },
              EndTime: {
                shape: "S3c",
                location: "querystring",
                locationName: "end-time"
              },
              KpiName: {
                location: "uri",
                locationName: "kpi-name"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              StartTime: {
                shape: "S3c",
                location: "querystring",
                locationName: "start-time"
              }
            },
            required: [
              "ApplicationId",
              "KpiName",
              "CampaignId"
            ]
          },
          output: {
            type: "structure",
            members: {
              CampaignDateRangeKpiResponse: {
                type: "structure",
                members: {
                  ApplicationId: {},
                  CampaignId: {},
                  EndTime: {
                    shape: "S3c"
                  },
                  KpiName: {},
                  KpiResult: {
                    shape: "S6q"
                  },
                  NextToken: {},
                  StartTime: {
                    shape: "S3c"
                  }
                },
                required: [
                  "KpiResult",
                  "KpiName",
                  "EndTime",
                  "CampaignId",
                  "StartTime",
                  "ApplicationId"
                ]
              }
            },
            required: [
              "CampaignDateRangeKpiResponse"
            ],
            payload: "CampaignDateRangeKpiResponse"
          }
        },
        GetCampaignVersion: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/campaigns/{campaign-id}/versions/{version}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              CampaignId: {
                location: "uri",
                locationName: "campaign-id"
              },
              Version: {
                location: "uri",
                locationName: "version"
              }
            },
            required: [
              "Version",
              "ApplicationId",
              "CampaignId"
            ]
          },
          output: {
            type: "structure",
            members: {
              CampaignResponse: {
                shape: "S1j"
              }
            },
            required: [
              "CampaignResponse"
            ],
            payload: "CampaignResponse"
          }
        },
        GetCampaignVersions: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/campaigns/{campaign-id}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              CampaignId: {
                location: "uri",
                locationName: "campaign-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "ApplicationId",
              "CampaignId"
            ]
          },
          output: {
            type: "structure",
            members: {
              CampaignsResponse: {
                shape: "S7i"
              }
            },
            required: [
              "CampaignsResponse"
            ],
            payload: "CampaignsResponse"
          }
        },
        GetCampaigns: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/campaigns",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              CampaignsResponse: {
                shape: "S7i"
              }
            },
            required: [
              "CampaignsResponse"
            ],
            payload: "CampaignsResponse"
          }
        },
        GetChannels: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ChannelsResponse: {
                type: "structure",
                members: {
                  Channels: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        ApplicationId: {},
                        CreationDate: {},
                        Enabled: {
                          type: "boolean"
                        },
                        HasCredential: {
                          type: "boolean"
                        },
                        Id: {},
                        IsArchived: {
                          type: "boolean"
                        },
                        LastModifiedBy: {},
                        LastModifiedDate: {},
                        Version: {
                          type: "integer"
                        }
                      }
                    }
                  }
                },
                required: [
                  "Channels"
                ]
              }
            },
            required: [
              "ChannelsResponse"
            ],
            payload: "ChannelsResponse"
          }
        },
        GetEmailChannel: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels/email",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              EmailChannelResponse: {
                shape: "S54"
              }
            },
            required: [
              "EmailChannelResponse"
            ],
            payload: "EmailChannelResponse"
          }
        },
        GetEmailTemplate: {
          http: {
            method: "GET",
            requestUri: "/v1/templates/{template-name}/email",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName"
            ]
          },
          output: {
            type: "structure",
            members: {
              EmailTemplateResponse: {
                type: "structure",
                members: {
                  Arn: {},
                  CreationDate: {},
                  DefaultSubstitutions: {},
                  HtmlPart: {},
                  LastModifiedDate: {},
                  RecommenderId: {},
                  Subject: {},
                  tags: {
                    shape: "S4",
                    locationName: "tags"
                  },
                  TemplateDescription: {},
                  TemplateName: {},
                  TemplateType: {},
                  TextPart: {},
                  Version: {}
                },
                required: [
                  "LastModifiedDate",
                  "CreationDate",
                  "TemplateName",
                  "TemplateType"
                ]
              }
            },
            required: [
              "EmailTemplateResponse"
            ],
            payload: "EmailTemplateResponse"
          }
        },
        GetEndpoint: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/endpoints/{endpoint-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              EndpointId: {
                location: "uri",
                locationName: "endpoint-id"
              }
            },
            required: [
              "ApplicationId",
              "EndpointId"
            ]
          },
          output: {
            type: "structure",
            members: {
              EndpointResponse: {
                shape: "S5a"
              }
            },
            required: [
              "EndpointResponse"
            ],
            payload: "EndpointResponse"
          }
        },
        GetEventStream: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/eventstream",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              EventStream: {
                shape: "S5j"
              }
            },
            required: [
              "EventStream"
            ],
            payload: "EventStream"
          }
        },
        GetExportJob: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/jobs/export/{job-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              JobId: {
                location: "uri",
                locationName: "job-id"
              }
            },
            required: [
              "ApplicationId",
              "JobId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ExportJobResponse: {
                shape: "S1v"
              }
            },
            required: [
              "ExportJobResponse"
            ],
            payload: "ExportJobResponse"
          }
        },
        GetExportJobs: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/jobs/export",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ExportJobsResponse: {
                shape: "S85"
              }
            },
            required: [
              "ExportJobsResponse"
            ],
            payload: "ExportJobsResponse"
          }
        },
        GetGcmChannel: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels/gcm",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              GCMChannelResponse: {
                shape: "S5m"
              }
            },
            required: [
              "GCMChannelResponse"
            ],
            payload: "GCMChannelResponse"
          }
        },
        GetImportJob: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/jobs/import/{job-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              JobId: {
                location: "uri",
                locationName: "job-id"
              }
            },
            required: [
              "ApplicationId",
              "JobId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ImportJobResponse: {
                shape: "S22"
              }
            },
            required: [
              "ImportJobResponse"
            ],
            payload: "ImportJobResponse"
          }
        },
        GetImportJobs: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/jobs/import",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ImportJobsResponse: {
                shape: "S8d"
              }
            },
            required: [
              "ImportJobsResponse"
            ],
            payload: "ImportJobsResponse"
          }
        },
        GetInAppMessages: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/endpoints/{endpoint-id}/inappmessages",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              EndpointId: {
                location: "uri",
                locationName: "endpoint-id"
              }
            },
            required: [
              "ApplicationId",
              "EndpointId"
            ]
          },
          output: {
            type: "structure",
            members: {
              InAppMessagesResponse: {
                type: "structure",
                members: {
                  InAppMessageCampaigns: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        CampaignId: {},
                        DailyCap: {
                          type: "integer"
                        },
                        InAppMessage: {
                          type: "structure",
                          members: {
                            Content: {
                              shape: "So"
                            },
                            CustomConfig: {
                              shape: "S4"
                            },
                            Layout: {}
                          }
                        },
                        Priority: {
                          type: "integer"
                        },
                        Schedule: {
                          type: "structure",
                          members: {
                            EndDate: {},
                            EventFilter: {
                              shape: "Sz"
                            },
                            QuietTime: {
                              shape: "S1c"
                            }
                          }
                        },
                        SessionCap: {
                          type: "integer"
                        },
                        TotalCap: {
                          type: "integer"
                        },
                        TreatmentId: {}
                      }
                    }
                  }
                }
              }
            },
            required: [
              "InAppMessagesResponse"
            ],
            payload: "InAppMessagesResponse"
          }
        },
        GetInAppTemplate: {
          http: {
            method: "GET",
            requestUri: "/v1/templates/{template-name}/inapp",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName"
            ]
          },
          output: {
            type: "structure",
            members: {
              InAppTemplateResponse: {
                type: "structure",
                members: {
                  Arn: {},
                  Content: {
                    shape: "So"
                  },
                  CreationDate: {},
                  CustomConfig: {
                    shape: "S4"
                  },
                  LastModifiedDate: {},
                  Layout: {},
                  tags: {
                    shape: "S4",
                    locationName: "tags"
                  },
                  TemplateDescription: {},
                  TemplateName: {},
                  TemplateType: {},
                  Version: {}
                },
                required: [
                  "LastModifiedDate",
                  "CreationDate",
                  "TemplateName",
                  "TemplateType"
                ]
              }
            },
            required: [
              "InAppTemplateResponse"
            ],
            payload: "InAppTemplateResponse"
          }
        },
        GetJourney: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/journeys/{journey-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              JourneyId: {
                location: "uri",
                locationName: "journey-id"
              }
            },
            required: [
              "JourneyId",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              JourneyResponse: {
                shape: "S3i"
              }
            },
            required: [
              "JourneyResponse"
            ],
            payload: "JourneyResponse"
          }
        },
        GetJourneyDateRangeKpi: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/journeys/{journey-id}/kpis/daterange/{kpi-name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              EndTime: {
                shape: "S3c",
                location: "querystring",
                locationName: "end-time"
              },
              JourneyId: {
                location: "uri",
                locationName: "journey-id"
              },
              KpiName: {
                location: "uri",
                locationName: "kpi-name"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              StartTime: {
                shape: "S3c",
                location: "querystring",
                locationName: "start-time"
              }
            },
            required: [
              "JourneyId",
              "ApplicationId",
              "KpiName"
            ]
          },
          output: {
            type: "structure",
            members: {
              JourneyDateRangeKpiResponse: {
                type: "structure",
                members: {
                  ApplicationId: {},
                  EndTime: {
                    shape: "S3c"
                  },
                  JourneyId: {},
                  KpiName: {},
                  KpiResult: {
                    shape: "S6q"
                  },
                  NextToken: {},
                  StartTime: {
                    shape: "S3c"
                  }
                },
                required: [
                  "KpiResult",
                  "KpiName",
                  "JourneyId",
                  "EndTime",
                  "StartTime",
                  "ApplicationId"
                ]
              }
            },
            required: [
              "JourneyDateRangeKpiResponse"
            ],
            payload: "JourneyDateRangeKpiResponse"
          }
        },
        GetJourneyExecutionActivityMetrics: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/journeys/{journey-id}/activities/{journey-activity-id}/execution-metrics",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              JourneyActivityId: {
                location: "uri",
                locationName: "journey-activity-id"
              },
              JourneyId: {
                location: "uri",
                locationName: "journey-id"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              }
            },
            required: [
              "JourneyActivityId",
              "ApplicationId",
              "JourneyId"
            ]
          },
          output: {
            type: "structure",
            members: {
              JourneyExecutionActivityMetricsResponse: {
                type: "structure",
                members: {
                  ActivityType: {},
                  ApplicationId: {},
                  JourneyActivityId: {},
                  JourneyId: {},
                  LastEvaluatedTime: {},
                  Metrics: {
                    shape: "S4"
                  }
                },
                required: [
                  "Metrics",
                  "JourneyId",
                  "LastEvaluatedTime",
                  "JourneyActivityId",
                  "ActivityType",
                  "ApplicationId"
                ]
              }
            },
            required: [
              "JourneyExecutionActivityMetricsResponse"
            ],
            payload: "JourneyExecutionActivityMetricsResponse"
          }
        },
        GetJourneyExecutionMetrics: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/journeys/{journey-id}/execution-metrics",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              JourneyId: {
                location: "uri",
                locationName: "journey-id"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              }
            },
            required: [
              "ApplicationId",
              "JourneyId"
            ]
          },
          output: {
            type: "structure",
            members: {
              JourneyExecutionMetricsResponse: {
                type: "structure",
                members: {
                  ApplicationId: {},
                  JourneyId: {},
                  LastEvaluatedTime: {},
                  Metrics: {
                    shape: "S4"
                  }
                },
                required: [
                  "Metrics",
                  "JourneyId",
                  "LastEvaluatedTime",
                  "ApplicationId"
                ]
              }
            },
            required: [
              "JourneyExecutionMetricsResponse"
            ],
            payload: "JourneyExecutionMetricsResponse"
          }
        },
        GetPushTemplate: {
          http: {
            method: "GET",
            requestUri: "/v1/templates/{template-name}/push",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName"
            ]
          },
          output: {
            type: "structure",
            members: {
              PushNotificationTemplateResponse: {
                type: "structure",
                members: {
                  ADM: {
                    shape: "S3m"
                  },
                  APNS: {
                    shape: "S3n"
                  },
                  Arn: {},
                  Baidu: {
                    shape: "S3m"
                  },
                  CreationDate: {},
                  Default: {
                    shape: "S3o"
                  },
                  DefaultSubstitutions: {},
                  GCM: {
                    shape: "S3m"
                  },
                  LastModifiedDate: {},
                  RecommenderId: {},
                  tags: {
                    shape: "S4",
                    locationName: "tags"
                  },
                  TemplateDescription: {},
                  TemplateName: {},
                  TemplateType: {},
                  Version: {}
                },
                required: [
                  "LastModifiedDate",
                  "CreationDate",
                  "TemplateType",
                  "TemplateName"
                ]
              }
            },
            required: [
              "PushNotificationTemplateResponse"
            ],
            payload: "PushNotificationTemplateResponse"
          }
        },
        GetRecommenderConfiguration: {
          http: {
            method: "GET",
            requestUri: "/v1/recommenders/{recommender-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RecommenderId: {
                location: "uri",
                locationName: "recommender-id"
              }
            },
            required: [
              "RecommenderId"
            ]
          },
          output: {
            type: "structure",
            members: {
              RecommenderConfigurationResponse: {
                shape: "S3t"
              }
            },
            required: [
              "RecommenderConfigurationResponse"
            ],
            payload: "RecommenderConfigurationResponse"
          }
        },
        GetRecommenderConfigurations: {
          http: {
            method: "GET",
            requestUri: "/v1/recommenders",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ListRecommenderConfigurationsResponse: {
                type: "structure",
                members: {
                  Item: {
                    type: "list",
                    member: {
                      shape: "S3t"
                    }
                  },
                  NextToken: {}
                },
                required: [
                  "Item"
                ]
              }
            },
            required: [
              "ListRecommenderConfigurationsResponse"
            ],
            payload: "ListRecommenderConfigurationsResponse"
          }
        },
        GetSegment: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/segments/{segment-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              SegmentId: {
                location: "uri",
                locationName: "segment-id"
              }
            },
            required: [
              "SegmentId",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              SegmentResponse: {
                shape: "S46"
              }
            },
            required: [
              "SegmentResponse"
            ],
            payload: "SegmentResponse"
          }
        },
        GetSegmentExportJobs: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/segments/{segment-id}/jobs/export",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              SegmentId: {
                location: "uri",
                locationName: "segment-id"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "SegmentId",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ExportJobsResponse: {
                shape: "S85"
              }
            },
            required: [
              "ExportJobsResponse"
            ],
            payload: "ExportJobsResponse"
          }
        },
        GetSegmentImportJobs: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/segments/{segment-id}/jobs/import",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              SegmentId: {
                location: "uri",
                locationName: "segment-id"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "SegmentId",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ImportJobsResponse: {
                shape: "S8d"
              }
            },
            required: [
              "ImportJobsResponse"
            ],
            payload: "ImportJobsResponse"
          }
        },
        GetSegmentVersion: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/segments/{segment-id}/versions/{version}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              SegmentId: {
                location: "uri",
                locationName: "segment-id"
              },
              Version: {
                location: "uri",
                locationName: "version"
              }
            },
            required: [
              "SegmentId",
              "Version",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              SegmentResponse: {
                shape: "S46"
              }
            },
            required: [
              "SegmentResponse"
            ],
            payload: "SegmentResponse"
          }
        },
        GetSegmentVersions: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/segments/{segment-id}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              SegmentId: {
                location: "uri",
                locationName: "segment-id"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "SegmentId",
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              SegmentsResponse: {
                shape: "S9j"
              }
            },
            required: [
              "SegmentsResponse"
            ],
            payload: "SegmentsResponse"
          }
        },
        GetSegments: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/segments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              SegmentsResponse: {
                shape: "S9j"
              }
            },
            required: [
              "SegmentsResponse"
            ],
            payload: "SegmentsResponse"
          }
        },
        GetSmsChannel: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels/sms",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              SMSChannelResponse: {
                shape: "S5z"
              }
            },
            required: [
              "SMSChannelResponse"
            ],
            payload: "SMSChannelResponse"
          }
        },
        GetSmsTemplate: {
          http: {
            method: "GET",
            requestUri: "/v1/templates/{template-name}/sms",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName"
            ]
          },
          output: {
            type: "structure",
            members: {
              SMSTemplateResponse: {
                type: "structure",
                members: {
                  Arn: {},
                  Body: {},
                  CreationDate: {},
                  DefaultSubstitutions: {},
                  LastModifiedDate: {},
                  RecommenderId: {},
                  tags: {
                    shape: "S4",
                    locationName: "tags"
                  },
                  TemplateDescription: {},
                  TemplateName: {},
                  TemplateType: {},
                  Version: {}
                },
                required: [
                  "LastModifiedDate",
                  "CreationDate",
                  "TemplateName",
                  "TemplateType"
                ]
              }
            },
            required: [
              "SMSTemplateResponse"
            ],
            payload: "SMSTemplateResponse"
          }
        },
        GetUserEndpoints: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/users/{user-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              UserId: {
                location: "uri",
                locationName: "user-id"
              }
            },
            required: [
              "ApplicationId",
              "UserId"
            ]
          },
          output: {
            type: "structure",
            members: {
              EndpointsResponse: {
                shape: "S64"
              }
            },
            required: [
              "EndpointsResponse"
            ],
            payload: "EndpointsResponse"
          }
        },
        GetVoiceChannel: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/channels/voice",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              VoiceChannelResponse: {
                shape: "S68"
              }
            },
            required: [
              "VoiceChannelResponse"
            ],
            payload: "VoiceChannelResponse"
          }
        },
        GetVoiceTemplate: {
          http: {
            method: "GET",
            requestUri: "/v1/templates/{template-name}/voice",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName"
            ]
          },
          output: {
            type: "structure",
            members: {
              VoiceTemplateResponse: {
                type: "structure",
                members: {
                  Arn: {},
                  Body: {},
                  CreationDate: {},
                  DefaultSubstitutions: {},
                  LanguageCode: {},
                  LastModifiedDate: {},
                  tags: {
                    shape: "S4",
                    locationName: "tags"
                  },
                  TemplateDescription: {},
                  TemplateName: {},
                  TemplateType: {},
                  Version: {},
                  VoiceId: {}
                },
                required: [
                  "LastModifiedDate",
                  "CreationDate",
                  "TemplateName",
                  "TemplateType"
                ]
              }
            },
            required: [
              "VoiceTemplateResponse"
            ],
            payload: "VoiceTemplateResponse"
          }
        },
        ListJourneys: {
          http: {
            method: "GET",
            requestUri: "/v1/apps/{application-id}/journeys",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Token: {
                location: "querystring",
                locationName: "token"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              JourneysResponse: {
                type: "structure",
                members: {
                  Item: {
                    type: "list",
                    member: {
                      shape: "S3i"
                    }
                  },
                  NextToken: {}
                },
                required: [
                  "Item"
                ]
              }
            },
            required: [
              "JourneysResponse"
            ],
            payload: "JourneysResponse"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/v1/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              TagsModel: {
                shape: "Sa5"
              }
            },
            required: [
              "TagsModel"
            ],
            payload: "TagsModel"
          }
        },
        ListTemplateVersions: {
          http: {
            method: "GET",
            requestUri: "/v1/templates/{template-name}/{template-type}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              TemplateType: {
                location: "uri",
                locationName: "template-type"
              }
            },
            required: [
              "TemplateName",
              "TemplateType"
            ]
          },
          output: {
            type: "structure",
            members: {
              TemplateVersionsResponse: {
                type: "structure",
                members: {
                  Item: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        CreationDate: {},
                        DefaultSubstitutions: {},
                        LastModifiedDate: {},
                        TemplateDescription: {},
                        TemplateName: {},
                        TemplateType: {},
                        Version: {}
                      },
                      required: [
                        "LastModifiedDate",
                        "CreationDate",
                        "TemplateName",
                        "TemplateType"
                      ]
                    }
                  },
                  Message: {},
                  NextToken: {},
                  RequestID: {}
                },
                required: [
                  "Item"
                ]
              }
            },
            required: [
              "TemplateVersionsResponse"
            ],
            payload: "TemplateVersionsResponse"
          }
        },
        ListTemplates: {
          http: {
            method: "GET",
            requestUri: "/v1/templates",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              PageSize: {
                location: "querystring",
                locationName: "page-size"
              },
              Prefix: {
                location: "querystring",
                locationName: "prefix"
              },
              TemplateType: {
                location: "querystring",
                locationName: "template-type"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplatesResponse: {
                type: "structure",
                members: {
                  Item: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Arn: {},
                        CreationDate: {},
                        DefaultSubstitutions: {},
                        LastModifiedDate: {},
                        tags: {
                          shape: "S4",
                          locationName: "tags"
                        },
                        TemplateDescription: {},
                        TemplateName: {},
                        TemplateType: {},
                        Version: {}
                      },
                      required: [
                        "LastModifiedDate",
                        "CreationDate",
                        "TemplateName",
                        "TemplateType"
                      ]
                    }
                  },
                  NextToken: {}
                },
                required: [
                  "Item"
                ]
              }
            },
            required: [
              "TemplatesResponse"
            ],
            payload: "TemplatesResponse"
          }
        },
        PhoneNumberValidate: {
          http: {
            requestUri: "/v1/phone/number/validate",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NumberValidateRequest: {
                type: "structure",
                members: {
                  IsoCountryCode: {},
                  PhoneNumber: {}
                }
              }
            },
            required: [
              "NumberValidateRequest"
            ],
            payload: "NumberValidateRequest"
          },
          output: {
            type: "structure",
            members: {
              NumberValidateResponse: {
                type: "structure",
                members: {
                  Carrier: {},
                  City: {},
                  CleansedPhoneNumberE164: {},
                  CleansedPhoneNumberNational: {},
                  Country: {},
                  CountryCodeIso2: {},
                  CountryCodeNumeric: {},
                  County: {},
                  OriginalCountryCodeIso2: {},
                  OriginalPhoneNumber: {},
                  PhoneType: {},
                  PhoneTypeCode: {
                    type: "integer"
                  },
                  Timezone: {},
                  ZipCode: {}
                }
              }
            },
            required: [
              "NumberValidateResponse"
            ],
            payload: "NumberValidateResponse"
          }
        },
        PutEventStream: {
          http: {
            requestUri: "/v1/apps/{application-id}/eventstream",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              WriteEventStream: {
                type: "structure",
                members: {
                  DestinationStreamArn: {},
                  RoleArn: {}
                },
                required: [
                  "RoleArn",
                  "DestinationStreamArn"
                ]
              }
            },
            required: [
              "ApplicationId",
              "WriteEventStream"
            ],
            payload: "WriteEventStream"
          },
          output: {
            type: "structure",
            members: {
              EventStream: {
                shape: "S5j"
              }
            },
            required: [
              "EventStream"
            ],
            payload: "EventStream"
          }
        },
        PutEvents: {
          http: {
            requestUri: "/v1/apps/{application-id}/events",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              EventsRequest: {
                type: "structure",
                members: {
                  BatchItem: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        Endpoint: {
                          type: "structure",
                          members: {
                            Address: {},
                            Attributes: {
                              shape: "S5b"
                            },
                            ChannelType: {},
                            Demographic: {
                              shape: "S5d"
                            },
                            EffectiveDate: {},
                            EndpointStatus: {},
                            Location: {
                              shape: "S5e"
                            },
                            Metrics: {
                              shape: "S5f"
                            },
                            OptOut: {},
                            RequestId: {},
                            User: {
                              shape: "S5g"
                            }
                          }
                        },
                        Events: {
                          type: "map",
                          key: {},
                          value: {
                            type: "structure",
                            members: {
                              AppPackageName: {},
                              AppTitle: {},
                              AppVersionCode: {},
                              Attributes: {
                                shape: "S4"
                              },
                              ClientSdkVersion: {},
                              EventType: {},
                              Metrics: {
                                shape: "S5f"
                              },
                              SdkName: {},
                              Session: {
                                type: "structure",
                                members: {
                                  Duration: {
                                    type: "integer"
                                  },
                                  Id: {},
                                  StartTimestamp: {},
                                  StopTimestamp: {}
                                },
                                required: [
                                  "StartTimestamp",
                                  "Id"
                                ]
                              },
                              Timestamp: {}
                            },
                            required: [
                              "EventType",
                              "Timestamp"
                            ]
                          }
                        }
                      },
                      required: [
                        "Endpoint",
                        "Events"
                      ]
                    }
                  }
                },
                required: [
                  "BatchItem"
                ]
              }
            },
            required: [
              "ApplicationId",
              "EventsRequest"
            ],
            payload: "EventsRequest"
          },
          output: {
            type: "structure",
            members: {
              EventsResponse: {
                type: "structure",
                members: {
                  Results: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        EndpointItemResponse: {
                          type: "structure",
                          members: {
                            Message: {},
                            StatusCode: {
                              type: "integer"
                            }
                          }
                        },
                        EventsItemResponse: {
                          type: "map",
                          key: {},
                          value: {
                            type: "structure",
                            members: {
                              Message: {},
                              StatusCode: {
                                type: "integer"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            required: [
              "EventsResponse"
            ],
            payload: "EventsResponse"
          }
        },
        RemoveAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/attributes/{attribute-type}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              AttributeType: {
                location: "uri",
                locationName: "attribute-type"
              },
              UpdateAttributesRequest: {
                type: "structure",
                members: {
                  Blacklist: {
                    shape: "S14"
                  }
                }
              }
            },
            required: [
              "AttributeType",
              "ApplicationId",
              "UpdateAttributesRequest"
            ],
            payload: "UpdateAttributesRequest"
          },
          output: {
            type: "structure",
            members: {
              AttributesResource: {
                type: "structure",
                members: {
                  ApplicationId: {},
                  AttributeType: {},
                  Attributes: {
                    shape: "S14"
                  }
                },
                required: [
                  "AttributeType",
                  "ApplicationId"
                ]
              }
            },
            required: [
              "AttributesResource"
            ],
            payload: "AttributesResource"
          }
        },
        SendMessages: {
          http: {
            requestUri: "/v1/apps/{application-id}/messages",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              MessageRequest: {
                type: "structure",
                members: {
                  Addresses: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        BodyOverride: {},
                        ChannelType: {},
                        Context: {
                          shape: "S4"
                        },
                        RawContent: {},
                        Substitutions: {
                          shape: "S5b"
                        },
                        TitleOverride: {}
                      }
                    }
                  },
                  Context: {
                    shape: "S4"
                  },
                  Endpoints: {
                    shape: "Sba"
                  },
                  MessageConfiguration: {
                    shape: "Sbc"
                  },
                  TemplateConfiguration: {
                    shape: "S1d"
                  },
                  TraceId: {}
                },
                required: [
                  "MessageConfiguration"
                ]
              }
            },
            required: [
              "ApplicationId",
              "MessageRequest"
            ],
            payload: "MessageRequest"
          },
          output: {
            type: "structure",
            members: {
              MessageResponse: {
                type: "structure",
                members: {
                  ApplicationId: {},
                  EndpointResult: {
                    shape: "Sbs"
                  },
                  RequestId: {},
                  Result: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        DeliveryStatus: {},
                        MessageId: {},
                        StatusCode: {
                          type: "integer"
                        },
                        StatusMessage: {},
                        UpdatedToken: {}
                      },
                      required: [
                        "DeliveryStatus",
                        "StatusCode"
                      ]
                    }
                  }
                },
                required: [
                  "ApplicationId"
                ]
              }
            },
            required: [
              "MessageResponse"
            ],
            payload: "MessageResponse"
          }
        },
        SendUsersMessages: {
          http: {
            requestUri: "/v1/apps/{application-id}/users-messages",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              SendUsersMessageRequest: {
                type: "structure",
                members: {
                  Context: {
                    shape: "S4"
                  },
                  MessageConfiguration: {
                    shape: "Sbc"
                  },
                  TemplateConfiguration: {
                    shape: "S1d"
                  },
                  TraceId: {},
                  Users: {
                    shape: "Sba"
                  }
                },
                required: [
                  "MessageConfiguration",
                  "Users"
                ]
              }
            },
            required: [
              "ApplicationId",
              "SendUsersMessageRequest"
            ],
            payload: "SendUsersMessageRequest"
          },
          output: {
            type: "structure",
            members: {
              SendUsersMessageResponse: {
                type: "structure",
                members: {
                  ApplicationId: {},
                  RequestId: {},
                  Result: {
                    type: "map",
                    key: {},
                    value: {
                      shape: "Sbs"
                    }
                  }
                },
                required: [
                  "ApplicationId"
                ]
              }
            },
            required: [
              "SendUsersMessageResponse"
            ],
            payload: "SendUsersMessageResponse"
          }
        },
        TagResource: {
          http: {
            requestUri: "/v1/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagsModel: {
                shape: "Sa5"
              }
            },
            required: [
              "ResourceArn",
              "TagsModel"
            ],
            payload: "TagsModel"
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/v1/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                shape: "S14",
                location: "querystring",
                locationName: "tagKeys"
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ]
          }
        },
        UpdateAdmChannel: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/channels/adm",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ADMChannelRequest: {
                type: "structure",
                members: {
                  ClientId: {},
                  ClientSecret: {},
                  Enabled: {
                    type: "boolean"
                  }
                },
                required: [
                  "ClientSecret",
                  "ClientId"
                ]
              },
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId",
              "ADMChannelRequest"
            ],
            payload: "ADMChannelRequest"
          },
          output: {
            type: "structure",
            members: {
              ADMChannelResponse: {
                shape: "S4i"
              }
            },
            required: [
              "ADMChannelResponse"
            ],
            payload: "ADMChannelResponse"
          }
        },
        UpdateApnsChannel: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/channels/apns",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              APNSChannelRequest: {
                type: "structure",
                members: {
                  BundleId: {},
                  Certificate: {},
                  DefaultAuthenticationMethod: {},
                  Enabled: {
                    type: "boolean"
                  },
                  PrivateKey: {},
                  TeamId: {},
                  TokenKey: {},
                  TokenKeyId: {}
                }
              },
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId",
              "APNSChannelRequest"
            ],
            payload: "APNSChannelRequest"
          },
          output: {
            type: "structure",
            members: {
              APNSChannelResponse: {
                shape: "S4l"
              }
            },
            required: [
              "APNSChannelResponse"
            ],
            payload: "APNSChannelResponse"
          }
        },
        UpdateApnsSandboxChannel: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/channels/apns_sandbox",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              APNSSandboxChannelRequest: {
                type: "structure",
                members: {
                  BundleId: {},
                  Certificate: {},
                  DefaultAuthenticationMethod: {},
                  Enabled: {
                    type: "boolean"
                  },
                  PrivateKey: {},
                  TeamId: {},
                  TokenKey: {},
                  TokenKeyId: {}
                }
              },
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId",
              "APNSSandboxChannelRequest"
            ],
            payload: "APNSSandboxChannelRequest"
          },
          output: {
            type: "structure",
            members: {
              APNSSandboxChannelResponse: {
                shape: "S4o"
              }
            },
            required: [
              "APNSSandboxChannelResponse"
            ],
            payload: "APNSSandboxChannelResponse"
          }
        },
        UpdateApnsVoipChannel: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/channels/apns_voip",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              APNSVoipChannelRequest: {
                type: "structure",
                members: {
                  BundleId: {},
                  Certificate: {},
                  DefaultAuthenticationMethod: {},
                  Enabled: {
                    type: "boolean"
                  },
                  PrivateKey: {},
                  TeamId: {},
                  TokenKey: {},
                  TokenKeyId: {}
                }
              },
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId",
              "APNSVoipChannelRequest"
            ],
            payload: "APNSVoipChannelRequest"
          },
          output: {
            type: "structure",
            members: {
              APNSVoipChannelResponse: {
                shape: "S4r"
              }
            },
            required: [
              "APNSVoipChannelResponse"
            ],
            payload: "APNSVoipChannelResponse"
          }
        },
        UpdateApnsVoipSandboxChannel: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/channels/apns_voip_sandbox",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              APNSVoipSandboxChannelRequest: {
                type: "structure",
                members: {
                  BundleId: {},
                  Certificate: {},
                  DefaultAuthenticationMethod: {},
                  Enabled: {
                    type: "boolean"
                  },
                  PrivateKey: {},
                  TeamId: {},
                  TokenKey: {},
                  TokenKeyId: {}
                }
              },
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              }
            },
            required: [
              "ApplicationId",
              "APNSVoipSandboxChannelRequest"
            ],
            payload: "APNSVoipSandboxChannelRequest"
          },
          output: {
            type: "structure",
            members: {
              APNSVoipSandboxChannelResponse: {
                shape: "S4u"
              }
            },
            required: [
              "APNSVoipSandboxChannelResponse"
            ],
            payload: "APNSVoipSandboxChannelResponse"
          }
        },
        UpdateApplicationSettings: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              WriteApplicationSettingsRequest: {
                type: "structure",
                members: {
                  CampaignHook: {
                    shape: "S1f"
                  },
                  CloudWatchMetricsEnabled: {
                    type: "boolean"
                  },
                  EventTaggingEnabled: {
                    type: "boolean"
                  },
                  Limits: {
                    shape: "S1h"
                  },
                  QuietTime: {
                    shape: "S1c"
                  }
                }
              }
            },
            required: [
              "ApplicationId",
              "WriteApplicationSettingsRequest"
            ],
            payload: "WriteApplicationSettingsRequest"
          },
          output: {
            type: "structure",
            members: {
              ApplicationSettingsResource: {
                shape: "S6x"
              }
            },
            required: [
              "ApplicationSettingsResource"
            ],
            payload: "ApplicationSettingsResource"
          }
        },
        UpdateBaiduChannel: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/channels/baidu",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              BaiduChannelRequest: {
                type: "structure",
                members: {
                  ApiKey: {},
                  Enabled: {
                    type: "boolean"
                  },
                  SecretKey: {}
                },
                required: [
                  "SecretKey",
                  "ApiKey"
                ]
              }
            },
            required: [
              "ApplicationId",
              "BaiduChannelRequest"
            ],
            payload: "BaiduChannelRequest"
          },
          output: {
            type: "structure",
            members: {
              BaiduChannelResponse: {
                shape: "S4z"
              }
            },
            required: [
              "BaiduChannelResponse"
            ],
            payload: "BaiduChannelResponse"
          }
        },
        UpdateCampaign: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/campaigns/{campaign-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              CampaignId: {
                location: "uri",
                locationName: "campaign-id"
              },
              WriteCampaignRequest: {
                shape: "S8"
              }
            },
            required: [
              "CampaignId",
              "ApplicationId",
              "WriteCampaignRequest"
            ],
            payload: "WriteCampaignRequest"
          },
          output: {
            type: "structure",
            members: {
              CampaignResponse: {
                shape: "S1j"
              }
            },
            required: [
              "CampaignResponse"
            ],
            payload: "CampaignResponse"
          }
        },
        UpdateEmailChannel: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/channels/email",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              EmailChannelRequest: {
                type: "structure",
                members: {
                  ConfigurationSet: {},
                  Enabled: {
                    type: "boolean"
                  },
                  FromAddress: {},
                  Identity: {},
                  RoleArn: {}
                },
                required: [
                  "FromAddress",
                  "Identity"
                ]
              }
            },
            required: [
              "ApplicationId",
              "EmailChannelRequest"
            ],
            payload: "EmailChannelRequest"
          },
          output: {
            type: "structure",
            members: {
              EmailChannelResponse: {
                shape: "S54"
              }
            },
            required: [
              "EmailChannelResponse"
            ],
            payload: "EmailChannelResponse"
          }
        },
        UpdateEmailTemplate: {
          http: {
            method: "PUT",
            requestUri: "/v1/templates/{template-name}/email",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              CreateNewVersion: {
                location: "querystring",
                locationName: "create-new-version",
                type: "boolean"
              },
              EmailTemplateRequest: {
                shape: "S1p"
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName",
              "EmailTemplateRequest"
            ],
            payload: "EmailTemplateRequest"
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S57"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        UpdateEndpoint: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/endpoints/{endpoint-id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              EndpointId: {
                location: "uri",
                locationName: "endpoint-id"
              },
              EndpointRequest: {
                type: "structure",
                members: {
                  Address: {},
                  Attributes: {
                    shape: "S5b"
                  },
                  ChannelType: {},
                  Demographic: {
                    shape: "S5d"
                  },
                  EffectiveDate: {},
                  EndpointStatus: {},
                  Location: {
                    shape: "S5e"
                  },
                  Metrics: {
                    shape: "S5f"
                  },
                  OptOut: {},
                  RequestId: {},
                  User: {
                    shape: "S5g"
                  }
                }
              }
            },
            required: [
              "ApplicationId",
              "EndpointId",
              "EndpointRequest"
            ],
            payload: "EndpointRequest"
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S57"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        UpdateEndpointsBatch: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/endpoints",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              EndpointBatchRequest: {
                type: "structure",
                members: {
                  Item: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Address: {},
                        Attributes: {
                          shape: "S5b"
                        },
                        ChannelType: {},
                        Demographic: {
                          shape: "S5d"
                        },
                        EffectiveDate: {},
                        EndpointStatus: {},
                        Id: {},
                        Location: {
                          shape: "S5e"
                        },
                        Metrics: {
                          shape: "S5f"
                        },
                        OptOut: {},
                        RequestId: {},
                        User: {
                          shape: "S5g"
                        }
                      }
                    }
                  }
                },
                required: [
                  "Item"
                ]
              }
            },
            required: [
              "ApplicationId",
              "EndpointBatchRequest"
            ],
            payload: "EndpointBatchRequest"
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S57"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        UpdateGcmChannel: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/channels/gcm",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              GCMChannelRequest: {
                type: "structure",
                members: {
                  ApiKey: {},
                  Enabled: {
                    type: "boolean"
                  }
                },
                required: [
                  "ApiKey"
                ]
              }
            },
            required: [
              "ApplicationId",
              "GCMChannelRequest"
            ],
            payload: "GCMChannelRequest"
          },
          output: {
            type: "structure",
            members: {
              GCMChannelResponse: {
                shape: "S5m"
              }
            },
            required: [
              "GCMChannelResponse"
            ],
            payload: "GCMChannelResponse"
          }
        },
        UpdateInAppTemplate: {
          http: {
            method: "PUT",
            requestUri: "/v1/templates/{template-name}/inapp",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              CreateNewVersion: {
                location: "querystring",
                locationName: "create-new-version",
                type: "boolean"
              },
              InAppTemplateRequest: {
                shape: "S25"
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName",
              "InAppTemplateRequest"
            ],
            payload: "InAppTemplateRequest"
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S57"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        UpdateJourney: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/journeys/{journey-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              JourneyId: {
                location: "uri",
                locationName: "journey-id"
              },
              WriteJourneyRequest: {
                shape: "S29"
              }
            },
            required: [
              "JourneyId",
              "ApplicationId",
              "WriteJourneyRequest"
            ],
            payload: "WriteJourneyRequest"
          },
          output: {
            type: "structure",
            members: {
              JourneyResponse: {
                shape: "S3i"
              }
            },
            required: [
              "JourneyResponse"
            ],
            payload: "JourneyResponse"
          }
        },
        UpdateJourneyState: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/journeys/{journey-id}/state",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              JourneyId: {
                location: "uri",
                locationName: "journey-id"
              },
              JourneyStateRequest: {
                type: "structure",
                members: {
                  State: {}
                }
              }
            },
            required: [
              "JourneyId",
              "ApplicationId",
              "JourneyStateRequest"
            ],
            payload: "JourneyStateRequest"
          },
          output: {
            type: "structure",
            members: {
              JourneyResponse: {
                shape: "S3i"
              }
            },
            required: [
              "JourneyResponse"
            ],
            payload: "JourneyResponse"
          }
        },
        UpdatePushTemplate: {
          http: {
            method: "PUT",
            requestUri: "/v1/templates/{template-name}/push",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              CreateNewVersion: {
                location: "querystring",
                locationName: "create-new-version",
                type: "boolean"
              },
              PushNotificationTemplateRequest: {
                shape: "S3l"
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName",
              "PushNotificationTemplateRequest"
            ],
            payload: "PushNotificationTemplateRequest"
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S57"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        UpdateRecommenderConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/v1/recommenders/{recommender-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RecommenderId: {
                location: "uri",
                locationName: "recommender-id"
              },
              UpdateRecommenderConfiguration: {
                type: "structure",
                members: {
                  Attributes: {
                    shape: "S4"
                  },
                  Description: {},
                  Name: {},
                  RecommendationProviderIdType: {},
                  RecommendationProviderRoleArn: {},
                  RecommendationProviderUri: {},
                  RecommendationTransformerUri: {},
                  RecommendationsDisplayName: {},
                  RecommendationsPerMessage: {
                    type: "integer"
                  }
                },
                required: [
                  "RecommendationProviderUri",
                  "RecommendationProviderRoleArn"
                ]
              }
            },
            required: [
              "RecommenderId",
              "UpdateRecommenderConfiguration"
            ],
            payload: "UpdateRecommenderConfiguration"
          },
          output: {
            type: "structure",
            members: {
              RecommenderConfigurationResponse: {
                shape: "S3t"
              }
            },
            required: [
              "RecommenderConfigurationResponse"
            ],
            payload: "RecommenderConfigurationResponse"
          }
        },
        UpdateSegment: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/segments/{segment-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              SegmentId: {
                location: "uri",
                locationName: "segment-id"
              },
              WriteSegmentRequest: {
                shape: "S3v"
              }
            },
            required: [
              "SegmentId",
              "ApplicationId",
              "WriteSegmentRequest"
            ],
            payload: "WriteSegmentRequest"
          },
          output: {
            type: "structure",
            members: {
              SegmentResponse: {
                shape: "S46"
              }
            },
            required: [
              "SegmentResponse"
            ],
            payload: "SegmentResponse"
          }
        },
        UpdateSmsChannel: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/channels/sms",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              SMSChannelRequest: {
                type: "structure",
                members: {
                  Enabled: {
                    type: "boolean"
                  },
                  SenderId: {},
                  ShortCode: {}
                }
              }
            },
            required: [
              "ApplicationId",
              "SMSChannelRequest"
            ],
            payload: "SMSChannelRequest"
          },
          output: {
            type: "structure",
            members: {
              SMSChannelResponse: {
                shape: "S5z"
              }
            },
            required: [
              "SMSChannelResponse"
            ],
            payload: "SMSChannelResponse"
          }
        },
        UpdateSmsTemplate: {
          http: {
            method: "PUT",
            requestUri: "/v1/templates/{template-name}/sms",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              CreateNewVersion: {
                location: "querystring",
                locationName: "create-new-version",
                type: "boolean"
              },
              SMSTemplateRequest: {
                shape: "S4b"
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              }
            },
            required: [
              "TemplateName",
              "SMSTemplateRequest"
            ],
            payload: "SMSTemplateRequest"
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S57"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        UpdateTemplateActiveVersion: {
          http: {
            method: "PUT",
            requestUri: "/v1/templates/{template-name}/{template-type}/active-version",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              TemplateActiveVersionRequest: {
                type: "structure",
                members: {
                  Version: {}
                }
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              TemplateType: {
                location: "uri",
                locationName: "template-type"
              }
            },
            required: [
              "TemplateName",
              "TemplateType",
              "TemplateActiveVersionRequest"
            ],
            payload: "TemplateActiveVersionRequest"
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S57"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        },
        UpdateVoiceChannel: {
          http: {
            method: "PUT",
            requestUri: "/v1/apps/{application-id}/channels/voice",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "application-id"
              },
              VoiceChannelRequest: {
                type: "structure",
                members: {
                  Enabled: {
                    type: "boolean"
                  }
                }
              }
            },
            required: [
              "ApplicationId",
              "VoiceChannelRequest"
            ],
            payload: "VoiceChannelRequest"
          },
          output: {
            type: "structure",
            members: {
              VoiceChannelResponse: {
                shape: "S68"
              }
            },
            required: [
              "VoiceChannelResponse"
            ],
            payload: "VoiceChannelResponse"
          }
        },
        UpdateVoiceTemplate: {
          http: {
            method: "PUT",
            requestUri: "/v1/templates/{template-name}/voice",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              CreateNewVersion: {
                location: "querystring",
                locationName: "create-new-version",
                type: "boolean"
              },
              TemplateName: {
                location: "uri",
                locationName: "template-name"
              },
              Version: {
                location: "querystring",
                locationName: "version"
              },
              VoiceTemplateRequest: {
                shape: "S4e"
              }
            },
            required: [
              "TemplateName",
              "VoiceTemplateRequest"
            ],
            payload: "VoiceTemplateRequest"
          },
          output: {
            type: "structure",
            members: {
              MessageBody: {
                shape: "S57"
              }
            },
            required: [
              "MessageBody"
            ],
            payload: "MessageBody"
          }
        }
      },
      shapes: {
        S4: {
          type: "map",
          key: {},
          value: {}
        },
        S6: {
          type: "structure",
          members: {
            Arn: {},
            Id: {},
            Name: {},
            tags: {
              shape: "S4",
              locationName: "tags"
            }
          },
          required: [
            "Id",
            "Arn",
            "Name"
          ]
        },
        S8: {
          type: "structure",
          members: {
            AdditionalTreatments: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  CustomDeliveryConfiguration: {
                    shape: "Sb"
                  },
                  MessageConfiguration: {
                    shape: "Se"
                  },
                  Schedule: {
                    shape: "Sy"
                  },
                  SizePercent: {
                    type: "integer"
                  },
                  TemplateConfiguration: {
                    shape: "S1d"
                  },
                  TreatmentDescription: {},
                  TreatmentName: {}
                },
                required: [
                  "SizePercent"
                ]
              }
            },
            CustomDeliveryConfiguration: {
              shape: "Sb"
            },
            Description: {},
            HoldoutPercent: {
              type: "integer"
            },
            Hook: {
              shape: "S1f"
            },
            IsPaused: {
              type: "boolean"
            },
            Limits: {
              shape: "S1h"
            },
            MessageConfiguration: {
              shape: "Se"
            },
            Name: {},
            Schedule: {
              shape: "Sy"
            },
            SegmentId: {},
            SegmentVersion: {
              type: "integer"
            },
            tags: {
              shape: "S4",
              locationName: "tags"
            },
            TemplateConfiguration: {
              shape: "S1d"
            },
            TreatmentDescription: {},
            TreatmentName: {},
            Priority: {
              type: "integer"
            }
          }
        },
        Sb: {
          type: "structure",
          members: {
            DeliveryUri: {},
            EndpointTypes: {
              shape: "Sc"
            }
          },
          required: [
            "DeliveryUri"
          ]
        },
        Sc: {
          type: "list",
          member: {}
        },
        Se: {
          type: "structure",
          members: {
            ADMMessage: {
              shape: "Sf"
            },
            APNSMessage: {
              shape: "Sf"
            },
            BaiduMessage: {
              shape: "Sf"
            },
            CustomMessage: {
              type: "structure",
              members: {
                Data: {}
              }
            },
            DefaultMessage: {
              shape: "Sf"
            },
            EmailMessage: {
              type: "structure",
              members: {
                Body: {},
                FromAddress: {},
                HtmlBody: {},
                Title: {}
              }
            },
            GCMMessage: {
              shape: "Sf"
            },
            SMSMessage: {
              type: "structure",
              members: {
                Body: {},
                MessageType: {},
                OriginationNumber: {},
                SenderId: {},
                EntityId: {},
                TemplateId: {}
              }
            },
            InAppMessage: {
              type: "structure",
              members: {
                Body: {},
                Content: {
                  shape: "So"
                },
                CustomConfig: {
                  shape: "S4"
                },
                Layout: {}
              }
            }
          }
        },
        Sf: {
          type: "structure",
          members: {
            Action: {},
            Body: {},
            ImageIconUrl: {},
            ImageSmallIconUrl: {},
            ImageUrl: {},
            JsonBody: {},
            MediaUrl: {},
            RawContent: {},
            SilentPush: {
              type: "boolean"
            },
            TimeToLive: {
              type: "integer"
            },
            Title: {},
            Url: {}
          }
        },
        So: {
          type: "list",
          member: {
            type: "structure",
            members: {
              BackgroundColor: {},
              BodyConfig: {
                type: "structure",
                members: {
                  Alignment: {},
                  Body: {},
                  TextColor: {}
                },
                required: [
                  "Alignment",
                  "TextColor",
                  "Body"
                ]
              },
              HeaderConfig: {
                type: "structure",
                members: {
                  Alignment: {},
                  Header: {},
                  TextColor: {}
                },
                required: [
                  "Alignment",
                  "Header",
                  "TextColor"
                ]
              },
              ImageUrl: {},
              PrimaryBtn: {
                shape: "St"
              },
              SecondaryBtn: {
                shape: "St"
              }
            }
          }
        },
        St: {
          type: "structure",
          members: {
            Android: {
              shape: "Su"
            },
            DefaultConfig: {
              type: "structure",
              members: {
                BackgroundColor: {},
                BorderRadius: {
                  type: "integer"
                },
                ButtonAction: {},
                Link: {},
                Text: {},
                TextColor: {}
              },
              required: [
                "ButtonAction",
                "Text"
              ]
            },
            IOS: {
              shape: "Su"
            },
            Web: {
              shape: "Su"
            }
          }
        },
        Su: {
          type: "structure",
          members: {
            ButtonAction: {},
            Link: {}
          },
          required: [
            "ButtonAction"
          ]
        },
        Sy: {
          type: "structure",
          members: {
            EndTime: {},
            EventFilter: {
              shape: "Sz"
            },
            Frequency: {},
            IsLocalTime: {
              type: "boolean"
            },
            QuietTime: {
              shape: "S1c"
            },
            StartTime: {},
            Timezone: {}
          },
          required: [
            "StartTime"
          ]
        },
        Sz: {
          type: "structure",
          members: {
            Dimensions: {
              shape: "S10"
            },
            FilterType: {}
          },
          required: [
            "FilterType",
            "Dimensions"
          ]
        },
        S10: {
          type: "structure",
          members: {
            Attributes: {
              shape: "S11"
            },
            EventType: {
              shape: "S15"
            },
            Metrics: {
              shape: "S17"
            }
          }
        },
        S11: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              AttributeType: {},
              Values: {
                shape: "S14"
              }
            },
            required: [
              "Values"
            ]
          }
        },
        S14: {
          type: "list",
          member: {}
        },
        S15: {
          type: "structure",
          members: {
            DimensionType: {},
            Values: {
              shape: "S14"
            }
          },
          required: [
            "Values"
          ]
        },
        S17: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              ComparisonOperator: {},
              Value: {
                type: "double"
              }
            },
            required: [
              "ComparisonOperator",
              "Value"
            ]
          }
        },
        S1c: {
          type: "structure",
          members: {
            End: {},
            Start: {}
          }
        },
        S1d: {
          type: "structure",
          members: {
            EmailTemplate: {
              shape: "S1e"
            },
            PushTemplate: {
              shape: "S1e"
            },
            SMSTemplate: {
              shape: "S1e"
            },
            VoiceTemplate: {
              shape: "S1e"
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            Name: {},
            Version: {}
          }
        },
        S1f: {
          type: "structure",
          members: {
            LambdaFunctionName: {},
            Mode: {},
            WebUrl: {}
          }
        },
        S1h: {
          type: "structure",
          members: {
            Daily: {
              type: "integer"
            },
            MaximumDuration: {
              type: "integer"
            },
            MessagesPerSecond: {
              type: "integer"
            },
            Total: {
              type: "integer"
            },
            Session: {
              type: "integer"
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            AdditionalTreatments: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  CustomDeliveryConfiguration: {
                    shape: "Sb"
                  },
                  Id: {},
                  MessageConfiguration: {
                    shape: "Se"
                  },
                  Schedule: {
                    shape: "Sy"
                  },
                  SizePercent: {
                    type: "integer"
                  },
                  State: {
                    shape: "S1m"
                  },
                  TemplateConfiguration: {
                    shape: "S1d"
                  },
                  TreatmentDescription: {},
                  TreatmentName: {}
                },
                required: [
                  "Id",
                  "SizePercent"
                ]
              }
            },
            ApplicationId: {},
            Arn: {},
            CreationDate: {},
            CustomDeliveryConfiguration: {
              shape: "Sb"
            },
            DefaultState: {
              shape: "S1m"
            },
            Description: {},
            HoldoutPercent: {
              type: "integer"
            },
            Hook: {
              shape: "S1f"
            },
            Id: {},
            IsPaused: {
              type: "boolean"
            },
            LastModifiedDate: {},
            Limits: {
              shape: "S1h"
            },
            MessageConfiguration: {
              shape: "Se"
            },
            Name: {},
            Schedule: {
              shape: "Sy"
            },
            SegmentId: {},
            SegmentVersion: {
              type: "integer"
            },
            State: {
              shape: "S1m"
            },
            tags: {
              shape: "S4",
              locationName: "tags"
            },
            TemplateConfiguration: {
              shape: "S1d"
            },
            TreatmentDescription: {},
            TreatmentName: {},
            Version: {
              type: "integer"
            },
            Priority: {
              type: "integer"
            }
          },
          required: [
            "LastModifiedDate",
            "CreationDate",
            "SegmentId",
            "SegmentVersion",
            "Id",
            "Arn",
            "ApplicationId"
          ]
        },
        S1m: {
          type: "structure",
          members: {
            CampaignStatus: {}
          }
        },
        S1p: {
          type: "structure",
          members: {
            DefaultSubstitutions: {},
            HtmlPart: {},
            RecommenderId: {},
            Subject: {},
            tags: {
              shape: "S4",
              locationName: "tags"
            },
            TemplateDescription: {},
            TextPart: {}
          }
        },
        S1r: {
          type: "structure",
          members: {
            Arn: {},
            Message: {},
            RequestID: {}
          }
        },
        S1v: {
          type: "structure",
          members: {
            ApplicationId: {},
            CompletedPieces: {
              type: "integer"
            },
            CompletionDate: {},
            CreationDate: {},
            Definition: {
              type: "structure",
              members: {
                RoleArn: {},
                S3UrlPrefix: {},
                SegmentId: {},
                SegmentVersion: {
                  type: "integer"
                }
              },
              required: [
                "S3UrlPrefix",
                "RoleArn"
              ]
            },
            FailedPieces: {
              type: "integer"
            },
            Failures: {
              shape: "S14"
            },
            Id: {},
            JobStatus: {},
            TotalFailures: {
              type: "integer"
            },
            TotalPieces: {
              type: "integer"
            },
            TotalProcessed: {
              type: "integer"
            },
            Type: {}
          },
          required: [
            "JobStatus",
            "CreationDate",
            "Type",
            "Definition",
            "Id",
            "ApplicationId"
          ]
        },
        S22: {
          type: "structure",
          members: {
            ApplicationId: {},
            CompletedPieces: {
              type: "integer"
            },
            CompletionDate: {},
            CreationDate: {},
            Definition: {
              type: "structure",
              members: {
                DefineSegment: {
                  type: "boolean"
                },
                ExternalId: {},
                Format: {},
                RegisterEndpoints: {
                  type: "boolean"
                },
                RoleArn: {},
                S3Url: {},
                SegmentId: {},
                SegmentName: {}
              },
              required: [
                "Format",
                "S3Url",
                "RoleArn"
              ]
            },
            FailedPieces: {
              type: "integer"
            },
            Failures: {
              shape: "S14"
            },
            Id: {},
            JobStatus: {},
            TotalFailures: {
              type: "integer"
            },
            TotalPieces: {
              type: "integer"
            },
            TotalProcessed: {
              type: "integer"
            },
            Type: {}
          },
          required: [
            "JobStatus",
            "CreationDate",
            "Type",
            "Definition",
            "Id",
            "ApplicationId"
          ]
        },
        S25: {
          type: "structure",
          members: {
            Content: {
              shape: "So"
            },
            CustomConfig: {
              shape: "S4"
            },
            Layout: {},
            tags: {
              shape: "S4",
              locationName: "tags"
            },
            TemplateDescription: {}
          }
        },
        S29: {
          type: "structure",
          members: {
            Activities: {
              shape: "S2a"
            },
            CreationDate: {},
            LastModifiedDate: {},
            Limits: {
              shape: "S3a"
            },
            LocalTime: {
              type: "boolean"
            },
            Name: {},
            QuietTime: {
              shape: "S1c"
            },
            RefreshFrequency: {},
            Schedule: {
              shape: "S3b"
            },
            StartActivity: {},
            StartCondition: {
              shape: "S3d"
            },
            State: {},
            WaitForQuietTime: {
              type: "boolean"
            },
            RefreshOnSegmentUpdate: {
              type: "boolean"
            }
          },
          required: [
            "Name"
          ]
        },
        S2a: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              CUSTOM: {
                type: "structure",
                members: {
                  DeliveryUri: {},
                  EndpointTypes: {
                    shape: "Sc"
                  },
                  MessageConfig: {
                    type: "structure",
                    members: {
                      Data: {}
                    }
                  },
                  NextActivity: {},
                  TemplateName: {},
                  TemplateVersion: {}
                }
              },
              ConditionalSplit: {
                type: "structure",
                members: {
                  Condition: {
                    type: "structure",
                    members: {
                      Conditions: {
                        type: "list",
                        member: {
                          shape: "S2h"
                        }
                      },
                      Operator: {}
                    }
                  },
                  EvaluationWaitTime: {
                    shape: "S2u"
                  },
                  FalseActivity: {},
                  TrueActivity: {}
                }
              },
              Description: {},
              EMAIL: {
                type: "structure",
                members: {
                  MessageConfig: {
                    type: "structure",
                    members: {
                      FromAddress: {}
                    }
                  },
                  NextActivity: {},
                  TemplateName: {},
                  TemplateVersion: {}
                }
              },
              Holdout: {
                type: "structure",
                members: {
                  NextActivity: {},
                  Percentage: {
                    type: "integer"
                  }
                },
                required: [
                  "Percentage"
                ]
              },
              MultiCondition: {
                type: "structure",
                members: {
                  Branches: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Condition: {
                          shape: "S2h"
                        },
                        NextActivity: {}
                      }
                    }
                  },
                  DefaultActivity: {},
                  EvaluationWaitTime: {
                    shape: "S2u"
                  }
                }
              },
              PUSH: {
                type: "structure",
                members: {
                  MessageConfig: {
                    type: "structure",
                    members: {
                      TimeToLive: {}
                    }
                  },
                  NextActivity: {},
                  TemplateName: {},
                  TemplateVersion: {}
                }
              },
              RandomSplit: {
                type: "structure",
                members: {
                  Branches: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        NextActivity: {},
                        Percentage: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              },
              SMS: {
                type: "structure",
                members: {
                  MessageConfig: {
                    type: "structure",
                    members: {
                      MessageType: {},
                      OriginationNumber: {},
                      SenderId: {},
                      EntityId: {},
                      TemplateId: {}
                    }
                  },
                  NextActivity: {},
                  TemplateName: {},
                  TemplateVersion: {}
                }
              },
              Wait: {
                type: "structure",
                members: {
                  NextActivity: {},
                  WaitTime: {
                    shape: "S2u"
                  }
                }
              },
              ContactCenter: {
                type: "structure",
                members: {
                  NextActivity: {}
                }
              }
            }
          }
        },
        S2h: {
          type: "structure",
          members: {
            EventCondition: {
              type: "structure",
              members: {
                Dimensions: {
                  shape: "S10"
                },
                MessageActivity: {}
              }
            },
            SegmentCondition: {
              shape: "S2j"
            },
            SegmentDimensions: {
              shape: "S2k",
              locationName: "segmentDimensions"
            }
          }
        },
        S2j: {
          type: "structure",
          members: {
            SegmentId: {}
          },
          required: [
            "SegmentId"
          ]
        },
        S2k: {
          type: "structure",
          members: {
            Attributes: {
              shape: "S11"
            },
            Behavior: {
              type: "structure",
              members: {
                Recency: {
                  type: "structure",
                  members: {
                    Duration: {},
                    RecencyType: {}
                  },
                  required: [
                    "Duration",
                    "RecencyType"
                  ]
                }
              }
            },
            Demographic: {
              type: "structure",
              members: {
                AppVersion: {
                  shape: "S15"
                },
                Channel: {
                  shape: "S15"
                },
                DeviceType: {
                  shape: "S15"
                },
                Make: {
                  shape: "S15"
                },
                Model: {
                  shape: "S15"
                },
                Platform: {
                  shape: "S15"
                }
              }
            },
            Location: {
              type: "structure",
              members: {
                Country: {
                  shape: "S15"
                },
                GPSPoint: {
                  type: "structure",
                  members: {
                    Coordinates: {
                      type: "structure",
                      members: {
                        Latitude: {
                          type: "double"
                        },
                        Longitude: {
                          type: "double"
                        }
                      },
                      required: [
                        "Latitude",
                        "Longitude"
                      ]
                    },
                    RangeInKilometers: {
                      type: "double"
                    }
                  },
                  required: [
                    "Coordinates"
                  ]
                }
              }
            },
            Metrics: {
              shape: "S17"
            },
            UserAttributes: {
              shape: "S11"
            }
          }
        },
        S2u: {
          type: "structure",
          members: {
            WaitFor: {},
            WaitUntil: {}
          }
        },
        S3a: {
          type: "structure",
          members: {
            DailyCap: {
              type: "integer"
            },
            EndpointReentryCap: {
              type: "integer"
            },
            MessagesPerSecond: {
              type: "integer"
            },
            EndpointReentryInterval: {}
          }
        },
        S3b: {
          type: "structure",
          members: {
            EndTime: {
              shape: "S3c"
            },
            StartTime: {
              shape: "S3c"
            },
            Timezone: {}
          }
        },
        S3c: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S3d: {
          type: "structure",
          members: {
            Description: {},
            EventStartCondition: {
              type: "structure",
              members: {
                EventFilter: {
                  type: "structure",
                  members: {
                    Dimensions: {
                      shape: "S10"
                    },
                    FilterType: {}
                  },
                  required: [
                    "FilterType",
                    "Dimensions"
                  ]
                },
                SegmentId: {}
              }
            },
            SegmentStartCondition: {
              shape: "S2j"
            }
          }
        },
        S3i: {
          type: "structure",
          members: {
            Activities: {
              shape: "S2a"
            },
            ApplicationId: {},
            CreationDate: {},
            Id: {},
            LastModifiedDate: {},
            Limits: {
              shape: "S3a"
            },
            LocalTime: {
              type: "boolean"
            },
            Name: {},
            QuietTime: {
              shape: "S1c"
            },
            RefreshFrequency: {},
            Schedule: {
              shape: "S3b"
            },
            StartActivity: {},
            StartCondition: {
              shape: "S3d"
            },
            State: {},
            tags: {
              shape: "S4",
              locationName: "tags"
            },
            WaitForQuietTime: {
              type: "boolean"
            },
            RefreshOnSegmentUpdate: {
              type: "boolean"
            },
            JourneyChannelSettings: {
              type: "structure",
              members: {
                ConnectCampaignArn: {},
                ConnectCampaignExecutionRoleArn: {}
              }
            }
          },
          required: [
            "Name",
            "Id",
            "ApplicationId"
          ]
        },
        S3l: {
          type: "structure",
          members: {
            ADM: {
              shape: "S3m"
            },
            APNS: {
              shape: "S3n"
            },
            Baidu: {
              shape: "S3m"
            },
            Default: {
              shape: "S3o"
            },
            DefaultSubstitutions: {},
            GCM: {
              shape: "S3m"
            },
            RecommenderId: {},
            tags: {
              shape: "S4",
              locationName: "tags"
            },
            TemplateDescription: {}
          }
        },
        S3m: {
          type: "structure",
          members: {
            Action: {},
            Body: {},
            ImageIconUrl: {},
            ImageUrl: {},
            RawContent: {},
            SmallImageIconUrl: {},
            Sound: {},
            Title: {},
            Url: {}
          }
        },
        S3n: {
          type: "structure",
          members: {
            Action: {},
            Body: {},
            MediaUrl: {},
            RawContent: {},
            Sound: {},
            Title: {},
            Url: {}
          }
        },
        S3o: {
          type: "structure",
          members: {
            Action: {},
            Body: {},
            Sound: {},
            Title: {},
            Url: {}
          }
        },
        S3t: {
          type: "structure",
          members: {
            Attributes: {
              shape: "S4"
            },
            CreationDate: {},
            Description: {},
            Id: {},
            LastModifiedDate: {},
            Name: {},
            RecommendationProviderIdType: {},
            RecommendationProviderRoleArn: {},
            RecommendationProviderUri: {},
            RecommendationTransformerUri: {},
            RecommendationsDisplayName: {},
            RecommendationsPerMessage: {
              type: "integer"
            }
          },
          required: [
            "RecommendationProviderUri",
            "LastModifiedDate",
            "CreationDate",
            "RecommendationProviderRoleArn",
            "Id"
          ]
        },
        S3v: {
          type: "structure",
          members: {
            Dimensions: {
              shape: "S2k"
            },
            Name: {},
            SegmentGroups: {
              shape: "S3w"
            },
            tags: {
              shape: "S4",
              locationName: "tags"
            }
          }
        },
        S3w: {
          type: "structure",
          members: {
            Groups: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Dimensions: {
                    type: "list",
                    member: {
                      shape: "S2k"
                    }
                  },
                  SourceSegments: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Id: {},
                        Version: {
                          type: "integer"
                        }
                      },
                      required: [
                        "Id"
                      ]
                    }
                  },
                  SourceType: {},
                  Type: {}
                }
              }
            },
            Include: {}
          }
        },
        S46: {
          type: "structure",
          members: {
            ApplicationId: {},
            Arn: {},
            CreationDate: {},
            Dimensions: {
              shape: "S2k"
            },
            Id: {},
            ImportDefinition: {
              type: "structure",
              members: {
                ChannelCounts: {
                  type: "map",
                  key: {},
                  value: {
                    type: "integer"
                  }
                },
                ExternalId: {},
                Format: {},
                RoleArn: {},
                S3Url: {},
                Size: {
                  type: "integer"
                }
              },
              required: [
                "Format",
                "S3Url",
                "Size",
                "ExternalId",
                "RoleArn"
              ]
            },
            LastModifiedDate: {},
            Name: {},
            SegmentGroups: {
              shape: "S3w"
            },
            SegmentType: {},
            tags: {
              shape: "S4",
              locationName: "tags"
            },
            Version: {
              type: "integer"
            }
          },
          required: [
            "SegmentType",
            "CreationDate",
            "Id",
            "Arn",
            "ApplicationId"
          ]
        },
        S4b: {
          type: "structure",
          members: {
            Body: {},
            DefaultSubstitutions: {},
            RecommenderId: {},
            tags: {
              shape: "S4",
              locationName: "tags"
            },
            TemplateDescription: {}
          }
        },
        S4e: {
          type: "structure",
          members: {
            Body: {},
            DefaultSubstitutions: {},
            LanguageCode: {},
            tags: {
              shape: "S4",
              locationName: "tags"
            },
            TemplateDescription: {},
            VoiceId: {}
          }
        },
        S4i: {
          type: "structure",
          members: {
            ApplicationId: {},
            CreationDate: {},
            Enabled: {
              type: "boolean"
            },
            HasCredential: {
              type: "boolean"
            },
            Id: {},
            IsArchived: {
              type: "boolean"
            },
            LastModifiedBy: {},
            LastModifiedDate: {},
            Platform: {},
            Version: {
              type: "integer"
            }
          },
          required: [
            "Platform"
          ]
        },
        S4l: {
          type: "structure",
          members: {
            ApplicationId: {},
            CreationDate: {},
            DefaultAuthenticationMethod: {},
            Enabled: {
              type: "boolean"
            },
            HasCredential: {
              type: "boolean"
            },
            HasTokenKey: {
              type: "boolean"
            },
            Id: {},
            IsArchived: {
              type: "boolean"
            },
            LastModifiedBy: {},
            LastModifiedDate: {},
            Platform: {},
            Version: {
              type: "integer"
            }
          },
          required: [
            "Platform"
          ]
        },
        S4o: {
          type: "structure",
          members: {
            ApplicationId: {},
            CreationDate: {},
            DefaultAuthenticationMethod: {},
            Enabled: {
              type: "boolean"
            },
            HasCredential: {
              type: "boolean"
            },
            HasTokenKey: {
              type: "boolean"
            },
            Id: {},
            IsArchived: {
              type: "boolean"
            },
            LastModifiedBy: {},
            LastModifiedDate: {},
            Platform: {},
            Version: {
              type: "integer"
            }
          },
          required: [
            "Platform"
          ]
        },
        S4r: {
          type: "structure",
          members: {
            ApplicationId: {},
            CreationDate: {},
            DefaultAuthenticationMethod: {},
            Enabled: {
              type: "boolean"
            },
            HasCredential: {
              type: "boolean"
            },
            HasTokenKey: {
              type: "boolean"
            },
            Id: {},
            IsArchived: {
              type: "boolean"
            },
            LastModifiedBy: {},
            LastModifiedDate: {},
            Platform: {},
            Version: {
              type: "integer"
            }
          },
          required: [
            "Platform"
          ]
        },
        S4u: {
          type: "structure",
          members: {
            ApplicationId: {},
            CreationDate: {},
            DefaultAuthenticationMethod: {},
            Enabled: {
              type: "boolean"
            },
            HasCredential: {
              type: "boolean"
            },
            HasTokenKey: {
              type: "boolean"
            },
            Id: {},
            IsArchived: {
              type: "boolean"
            },
            LastModifiedBy: {},
            LastModifiedDate: {},
            Platform: {},
            Version: {
              type: "integer"
            }
          },
          required: [
            "Platform"
          ]
        },
        S4z: {
          type: "structure",
          members: {
            ApplicationId: {},
            CreationDate: {},
            Credential: {},
            Enabled: {
              type: "boolean"
            },
            HasCredential: {
              type: "boolean"
            },
            Id: {},
            IsArchived: {
              type: "boolean"
            },
            LastModifiedBy: {},
            LastModifiedDate: {},
            Platform: {},
            Version: {
              type: "integer"
            }
          },
          required: [
            "Credential",
            "Platform"
          ]
        },
        S54: {
          type: "structure",
          members: {
            ApplicationId: {},
            ConfigurationSet: {},
            CreationDate: {},
            Enabled: {
              type: "boolean"
            },
            FromAddress: {},
            HasCredential: {
              type: "boolean"
            },
            Id: {},
            Identity: {},
            IsArchived: {
              type: "boolean"
            },
            LastModifiedBy: {},
            LastModifiedDate: {},
            MessagesPerSecond: {
              type: "integer"
            },
            Platform: {},
            RoleArn: {},
            Version: {
              type: "integer"
            }
          },
          required: [
            "Platform"
          ]
        },
        S57: {
          type: "structure",
          members: {
            Message: {},
            RequestID: {}
          }
        },
        S5a: {
          type: "structure",
          members: {
            Address: {},
            ApplicationId: {},
            Attributes: {
              shape: "S5b"
            },
            ChannelType: {},
            CohortId: {},
            CreationDate: {},
            Demographic: {
              shape: "S5d"
            },
            EffectiveDate: {},
            EndpointStatus: {},
            Id: {},
            Location: {
              shape: "S5e"
            },
            Metrics: {
              shape: "S5f"
            },
            OptOut: {},
            RequestId: {},
            User: {
              shape: "S5g"
            }
          }
        },
        S5b: {
          type: "map",
          key: {},
          value: {
            shape: "S14"
          }
        },
        S5d: {
          type: "structure",
          members: {
            AppVersion: {},
            Locale: {},
            Make: {},
            Model: {},
            ModelVersion: {},
            Platform: {},
            PlatformVersion: {},
            Timezone: {}
          }
        },
        S5e: {
          type: "structure",
          members: {
            City: {},
            Country: {},
            Latitude: {
              type: "double"
            },
            Longitude: {
              type: "double"
            },
            PostalCode: {},
            Region: {}
          }
        },
        S5f: {
          type: "map",
          key: {},
          value: {
            type: "double"
          }
        },
        S5g: {
          type: "structure",
          members: {
            UserAttributes: {
              shape: "S5b"
            },
            UserId: {}
          }
        },
        S5j: {
          type: "structure",
          members: {
            ApplicationId: {},
            DestinationStreamArn: {},
            ExternalId: {},
            LastModifiedDate: {},
            LastUpdatedBy: {},
            RoleArn: {}
          },
          required: [
            "ApplicationId",
            "RoleArn",
            "DestinationStreamArn"
          ]
        },
        S5m: {
          type: "structure",
          members: {
            ApplicationId: {},
            CreationDate: {},
            Credential: {},
            Enabled: {
              type: "boolean"
            },
            HasCredential: {
              type: "boolean"
            },
            Id: {},
            IsArchived: {
              type: "boolean"
            },
            LastModifiedBy: {},
            LastModifiedDate: {},
            Platform: {},
            Version: {
              type: "integer"
            }
          },
          required: [
            "Credential",
            "Platform"
          ]
        },
        S5z: {
          type: "structure",
          members: {
            ApplicationId: {},
            CreationDate: {},
            Enabled: {
              type: "boolean"
            },
            HasCredential: {
              type: "boolean"
            },
            Id: {},
            IsArchived: {
              type: "boolean"
            },
            LastModifiedBy: {},
            LastModifiedDate: {},
            Platform: {},
            PromotionalMessagesPerSecond: {
              type: "integer"
            },
            SenderId: {},
            ShortCode: {},
            TransactionalMessagesPerSecond: {
              type: "integer"
            },
            Version: {
              type: "integer"
            }
          },
          required: [
            "Platform"
          ]
        },
        S64: {
          type: "structure",
          members: {
            Item: {
              type: "list",
              member: {
                shape: "S5a"
              }
            }
          },
          required: [
            "Item"
          ]
        },
        S68: {
          type: "structure",
          members: {
            ApplicationId: {},
            CreationDate: {},
            Enabled: {
              type: "boolean"
            },
            HasCredential: {
              type: "boolean"
            },
            Id: {},
            IsArchived: {
              type: "boolean"
            },
            LastModifiedBy: {},
            LastModifiedDate: {},
            Platform: {},
            Version: {
              type: "integer"
            }
          },
          required: [
            "Platform"
          ]
        },
        S6q: {
          type: "structure",
          members: {
            Rows: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  GroupedBys: {
                    shape: "S6t"
                  },
                  Values: {
                    shape: "S6t"
                  }
                },
                required: [
                  "GroupedBys",
                  "Values"
                ]
              }
            }
          },
          required: [
            "Rows"
          ]
        },
        S6t: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Type: {},
              Value: {}
            },
            required: [
              "Type",
              "Value",
              "Key"
            ]
          }
        },
        S6x: {
          type: "structure",
          members: {
            ApplicationId: {},
            CampaignHook: {
              shape: "S1f"
            },
            LastModifiedDate: {},
            Limits: {
              shape: "S1h"
            },
            QuietTime: {
              shape: "S1c"
            }
          },
          required: [
            "ApplicationId"
          ]
        },
        S7i: {
          type: "structure",
          members: {
            Item: {
              type: "list",
              member: {
                shape: "S1j"
              }
            },
            NextToken: {}
          },
          required: [
            "Item"
          ]
        },
        S85: {
          type: "structure",
          members: {
            Item: {
              type: "list",
              member: {
                shape: "S1v"
              }
            },
            NextToken: {}
          },
          required: [
            "Item"
          ]
        },
        S8d: {
          type: "structure",
          members: {
            Item: {
              type: "list",
              member: {
                shape: "S22"
              }
            },
            NextToken: {}
          },
          required: [
            "Item"
          ]
        },
        S9j: {
          type: "structure",
          members: {
            Item: {
              type: "list",
              member: {
                shape: "S46"
              }
            },
            NextToken: {}
          },
          required: [
            "Item"
          ]
        },
        Sa5: {
          type: "structure",
          members: {
            tags: {
              shape: "S4",
              locationName: "tags"
            }
          },
          required: [
            "tags"
          ]
        },
        Sba: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              BodyOverride: {},
              Context: {
                shape: "S4"
              },
              RawContent: {},
              Substitutions: {
                shape: "S5b"
              },
              TitleOverride: {}
            }
          }
        },
        Sbc: {
          type: "structure",
          members: {
            ADMMessage: {
              type: "structure",
              members: {
                Action: {},
                Body: {},
                ConsolidationKey: {},
                Data: {
                  shape: "S4"
                },
                ExpiresAfter: {},
                IconReference: {},
                ImageIconUrl: {},
                ImageUrl: {},
                MD5: {},
                RawContent: {},
                SilentPush: {
                  type: "boolean"
                },
                SmallImageIconUrl: {},
                Sound: {},
                Substitutions: {
                  shape: "S5b"
                },
                Title: {},
                Url: {}
              }
            },
            APNSMessage: {
              type: "structure",
              members: {
                APNSPushType: {},
                Action: {},
                Badge: {
                  type: "integer"
                },
                Body: {},
                Category: {},
                CollapseId: {},
                Data: {
                  shape: "S4"
                },
                MediaUrl: {},
                PreferredAuthenticationMethod: {},
                Priority: {},
                RawContent: {},
                SilentPush: {
                  type: "boolean"
                },
                Sound: {},
                Substitutions: {
                  shape: "S5b"
                },
                ThreadId: {},
                TimeToLive: {
                  type: "integer"
                },
                Title: {},
                Url: {}
              }
            },
            BaiduMessage: {
              type: "structure",
              members: {
                Action: {},
                Body: {},
                Data: {
                  shape: "S4"
                },
                IconReference: {},
                ImageIconUrl: {},
                ImageUrl: {},
                RawContent: {},
                SilentPush: {
                  type: "boolean"
                },
                SmallImageIconUrl: {},
                Sound: {},
                Substitutions: {
                  shape: "S5b"
                },
                TimeToLive: {
                  type: "integer"
                },
                Title: {},
                Url: {}
              }
            },
            DefaultMessage: {
              type: "structure",
              members: {
                Body: {},
                Substitutions: {
                  shape: "S5b"
                }
              }
            },
            DefaultPushNotificationMessage: {
              type: "structure",
              members: {
                Action: {},
                Body: {},
                Data: {
                  shape: "S4"
                },
                SilentPush: {
                  type: "boolean"
                },
                Substitutions: {
                  shape: "S5b"
                },
                Title: {},
                Url: {}
              }
            },
            EmailMessage: {
              type: "structure",
              members: {
                Body: {},
                FeedbackForwardingAddress: {},
                FromAddress: {},
                RawEmail: {
                  type: "structure",
                  members: {
                    Data: {
                      type: "blob"
                    }
                  }
                },
                ReplyToAddresses: {
                  shape: "S14"
                },
                SimpleEmail: {
                  type: "structure",
                  members: {
                    HtmlPart: {
                      shape: "Sbm"
                    },
                    Subject: {
                      shape: "Sbm"
                    },
                    TextPart: {
                      shape: "Sbm"
                    }
                  }
                },
                Substitutions: {
                  shape: "S5b"
                }
              }
            },
            GCMMessage: {
              type: "structure",
              members: {
                Action: {},
                Body: {},
                CollapseKey: {},
                Data: {
                  shape: "S4"
                },
                IconReference: {},
                ImageIconUrl: {},
                ImageUrl: {},
                Priority: {},
                RawContent: {},
                RestrictedPackageName: {},
                SilentPush: {
                  type: "boolean"
                },
                SmallImageIconUrl: {},
                Sound: {},
                Substitutions: {
                  shape: "S5b"
                },
                TimeToLive: {
                  type: "integer"
                },
                Title: {},
                Url: {}
              }
            },
            SMSMessage: {
              type: "structure",
              members: {
                Body: {},
                Keyword: {},
                MediaUrl: {},
                MessageType: {},
                OriginationNumber: {},
                SenderId: {},
                Substitutions: {
                  shape: "S5b"
                },
                EntityId: {},
                TemplateId: {}
              }
            },
            VoiceMessage: {
              type: "structure",
              members: {
                Body: {},
                LanguageCode: {},
                OriginationNumber: {},
                Substitutions: {
                  shape: "S5b"
                },
                VoiceId: {}
              }
            }
          }
        },
        Sbm: {
          type: "structure",
          members: {
            Charset: {},
            Data: {}
          }
        },
        Sbs: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Address: {},
              DeliveryStatus: {},
              MessageId: {},
              StatusCode: {
                type: "integer"
              },
              StatusMessage: {},
              UpdatedToken: {}
            },
            required: [
              "DeliveryStatus",
              "StatusCode"
            ]
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/pinpoint.js
var require_pinpoint = __commonJS({
  "node_modules/aws-sdk/clients/pinpoint.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["pinpoint"] = {};
    AWS3.Pinpoint = Service.defineService("pinpoint", ["2016-12-01"]);
    Object.defineProperty(apiLoader.services["pinpoint"], "2016-12-01", {
      get: function get() {
        var model = require_pinpoint_2016_12_01_min();
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Pinpoint;
  }
});

// node_modules/aws-sdk/lib/polly/presigner.js
var require_presigner = __commonJS({
  "node_modules/aws-sdk/lib/polly/presigner.js"() {
    var AWS3 = require_core();
    var rest = AWS3.Protocol.Rest;
    AWS3.Polly.Presigner = AWS3.util.inherit({
      constructor: function Signer(options) {
        options = options || {};
        this.options = options;
        this.service = options.service;
        this.bindServiceObject(options);
        this._operations = {};
      },
      bindServiceObject: function bindServiceObject(options) {
        options = options || {};
        if (!this.service) {
          this.service = new AWS3.Polly(options);
        } else {
          var config = AWS3.util.copy(this.service.config);
          this.service = new this.service.constructor.__super__(config);
          this.service.config.params = AWS3.util.merge(this.service.config.params || {}, options.params);
        }
      },
      modifyInputMembers: function modifyInputMembers(input) {
        var modifiedInput = AWS3.util.copy(input);
        modifiedInput.members = AWS3.util.copy(input.members);
        AWS3.util.each(input.members, function(name, member) {
          modifiedInput.members[name] = AWS3.util.copy(member);
          if (!member.location || member.location === "body") {
            modifiedInput.members[name].location = "querystring";
            modifiedInput.members[name].locationName = name;
          }
        });
        return modifiedInput;
      },
      convertPostToGet: function convertPostToGet(req) {
        req.httpRequest.method = "GET";
        var operation = req.service.api.operations[req.operation];
        var input = this._operations[req.operation];
        if (!input) {
          this._operations[req.operation] = input = this.modifyInputMembers(operation.input);
        }
        var uri = rest.generateURI(req.httpRequest.endpoint.path, operation.httpPath, input, req.params);
        req.httpRequest.path = uri;
        req.httpRequest.body = "";
        delete req.httpRequest.headers["Content-Length"];
        delete req.httpRequest.headers["Content-Type"];
      },
      getSynthesizeSpeechUrl: function getSynthesizeSpeechUrl(params, expires, callback) {
        var self2 = this;
        var request = this.service.makeRequest("synthesizeSpeech", params);
        request.removeAllListeners("build");
        request.on("build", function(req) {
          self2.convertPostToGet(req);
        });
        return request.presign(expires, callback);
      }
    });
  }
});

// node_modules/aws-sdk/lib/services/polly.js
var require_polly = __commonJS({
  "node_modules/aws-sdk/lib/services/polly.js"() {
    require_presigner();
  }
});

// node_modules/aws-sdk/apis/polly-2016-06-10.min.json
var require_polly_2016_06_10_min = __commonJS({
  "node_modules/aws-sdk/apis/polly-2016-06-10.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-06-10",
        endpointPrefix: "polly",
        protocol: "rest-json",
        serviceFullName: "Amazon Polly",
        serviceId: "Polly",
        signatureVersion: "v4",
        uid: "polly-2016-06-10"
      },
      operations: {
        DeleteLexicon: {
          http: {
            method: "DELETE",
            requestUri: "/v1/lexicons/{LexiconName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "LexiconName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeVoices: {
          http: {
            method: "GET",
            requestUri: "/v1/voices",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Engine: {
                location: "querystring",
                locationName: "Engine"
              },
              LanguageCode: {
                location: "querystring",
                locationName: "LanguageCode"
              },
              IncludeAdditionalLanguageCodes: {
                location: "querystring",
                locationName: "IncludeAdditionalLanguageCodes",
                type: "boolean"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Voices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Gender: {},
                    Id: {},
                    LanguageCode: {},
                    LanguageName: {},
                    Name: {},
                    AdditionalLanguageCodes: {
                      type: "list",
                      member: {}
                    },
                    SupportedEngines: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetLexicon: {
          http: {
            method: "GET",
            requestUri: "/v1/lexicons/{LexiconName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "LexiconName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Lexicon: {
                type: "structure",
                members: {
                  Content: {
                    shape: "Sl"
                  },
                  Name: {}
                }
              },
              LexiconAttributes: {
                shape: "Sm"
              }
            }
          }
        },
        GetSpeechSynthesisTask: {
          http: {
            method: "GET",
            requestUri: "/v1/synthesisTasks/{TaskId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TaskId"
            ],
            members: {
              TaskId: {
                location: "uri",
                locationName: "TaskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SynthesisTask: {
                shape: "Sv"
              }
            }
          }
        },
        ListLexicons: {
          http: {
            method: "GET",
            requestUri: "/v1/lexicons",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Lexicons: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Attributes: {
                      shape: "Sm"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSpeechSynthesisTasks: {
          http: {
            method: "GET",
            requestUri: "/v1/synthesisTasks",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              Status: {
                location: "querystring",
                locationName: "Status"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              SynthesisTasks: {
                type: "list",
                member: {
                  shape: "Sv"
                }
              }
            }
          }
        },
        PutLexicon: {
          http: {
            method: "PUT",
            requestUri: "/v1/lexicons/{LexiconName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Content"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "LexiconName"
              },
              Content: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartSpeechSynthesisTask: {
          http: {
            requestUri: "/v1/synthesisTasks",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "OutputFormat",
              "OutputS3BucketName",
              "Text",
              "VoiceId"
            ],
            members: {
              Engine: {},
              LanguageCode: {},
              LexiconNames: {
                shape: "S12"
              },
              OutputFormat: {},
              OutputS3BucketName: {},
              OutputS3KeyPrefix: {},
              SampleRate: {},
              SnsTopicArn: {},
              SpeechMarkTypes: {
                shape: "S15"
              },
              Text: {},
              TextType: {},
              VoiceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SynthesisTask: {
                shape: "Sv"
              }
            }
          }
        },
        SynthesizeSpeech: {
          http: {
            requestUri: "/v1/speech",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "OutputFormat",
              "Text",
              "VoiceId"
            ],
            members: {
              Engine: {},
              LanguageCode: {},
              LexiconNames: {
                shape: "S12"
              },
              OutputFormat: {},
              SampleRate: {},
              SpeechMarkTypes: {
                shape: "S15"
              },
              Text: {},
              TextType: {},
              VoiceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AudioStream: {
                type: "blob",
                streaming: true
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              RequestCharacters: {
                location: "header",
                locationName: "x-amzn-RequestCharacters",
                type: "integer"
              }
            },
            payload: "AudioStream"
          }
        }
      },
      shapes: {
        Sl: {
          type: "string",
          sensitive: true
        },
        Sm: {
          type: "structure",
          members: {
            Alphabet: {},
            LanguageCode: {},
            LastModified: {
              type: "timestamp"
            },
            LexiconArn: {},
            LexemesCount: {
              type: "integer"
            },
            Size: {
              type: "integer"
            }
          }
        },
        Sv: {
          type: "structure",
          members: {
            Engine: {},
            TaskId: {},
            TaskStatus: {},
            TaskStatusReason: {},
            OutputUri: {},
            CreationTime: {
              type: "timestamp"
            },
            RequestCharacters: {
              type: "integer"
            },
            SnsTopicArn: {},
            LexiconNames: {
              shape: "S12"
            },
            OutputFormat: {},
            SampleRate: {},
            SpeechMarkTypes: {
              shape: "S15"
            },
            TextType: {},
            VoiceId: {},
            LanguageCode: {}
          }
        },
        S12: {
          type: "list",
          member: {}
        },
        S15: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/polly-2016-06-10.paginators.json
var require_polly_2016_06_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/polly-2016-06-10.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListSpeechSynthesisTasks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/polly.js
var require_polly2 = __commonJS({
  "node_modules/aws-sdk/clients/polly.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["polly"] = {};
    AWS3.Polly = Service.defineService("polly", ["2016-06-10"]);
    require_polly();
    Object.defineProperty(apiLoader.services["polly"], "2016-06-10", {
      get: function get() {
        var model = require_polly_2016_06_10_min();
        model.paginators = require_polly_2016_06_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Polly;
  }
});

// node_modules/aws-sdk/lib/services/rdsutil.js
var require_rdsutil = __commonJS({
  "node_modules/aws-sdk/lib/services/rdsutil.js"(exports, module2) {
    var AWS3 = require_core();
    var rdsutil = {
      setupRequestListeners: function setupRequestListeners(service, request, crossRegionOperations) {
        if (crossRegionOperations.indexOf(request.operation) !== -1 && request.params.SourceRegion) {
          request.params = AWS3.util.copy(request.params);
          if (request.params.PreSignedUrl || request.params.SourceRegion === service.config.region) {
            delete request.params.SourceRegion;
          } else {
            var doesParamValidation = !!service.config.paramValidation;
            if (doesParamValidation) {
              request.removeListener("validate", AWS3.EventListeners.Core.VALIDATE_PARAMETERS);
            }
            request.onAsync("validate", rdsutil.buildCrossRegionPresignedUrl);
            if (doesParamValidation) {
              request.addListener("validate", AWS3.EventListeners.Core.VALIDATE_PARAMETERS);
            }
          }
        }
      },
      buildCrossRegionPresignedUrl: function buildCrossRegionPresignedUrl(req, done) {
        var config = AWS3.util.copy(req.service.config);
        config.region = req.params.SourceRegion;
        delete req.params.SourceRegion;
        delete config.endpoint;
        delete config.params;
        config.signatureVersion = "v4";
        var destinationRegion = req.service.config.region;
        var svc = new req.service.constructor(config);
        var newReq = svc[req.operation](AWS3.util.copy(req.params));
        newReq.on("build", function addDestinationRegionParam(request) {
          var httpRequest = request.httpRequest;
          httpRequest.params.DestinationRegion = destinationRegion;
          httpRequest.body = AWS3.util.queryParamsToString(httpRequest.params);
        });
        newReq.presign(function(err, url) {
          if (err)
            done(err);
          else {
            req.params.PreSignedUrl = url;
            done();
          }
        });
      }
    };
    module2.exports = rdsutil;
  }
});

// node_modules/aws-sdk/lib/rds/signer.js
var require_signer2 = __commonJS({
  "node_modules/aws-sdk/lib/rds/signer.js"() {
    var AWS3 = require_core();
    var service = null;
    var api = {
      signatureVersion: "v4",
      signingName: "rds-db",
      operations: {}
    };
    var requiredAuthTokenOptions = {
      region: "string",
      hostname: "string",
      port: "number",
      username: "string"
    };
    AWS3.RDS.Signer = AWS3.util.inherit({
      constructor: function Signer(options) {
        this.options = options || {};
      },
      convertUrlToAuthToken: function convertUrlToAuthToken(url) {
        var protocol = "https://";
        if (url.indexOf(protocol) === 0) {
          return url.substring(protocol.length);
        }
      },
      getAuthToken: function getAuthToken(options, callback) {
        if (typeof options === "function" && callback === void 0) {
          callback = options;
          options = {};
        }
        var self2 = this;
        var hasCallback = typeof callback === "function";
        options = AWS3.util.merge(this.options, options);
        var optionsValidation = this.validateAuthTokenOptions(options);
        if (optionsValidation !== true) {
          if (hasCallback) {
            return callback(optionsValidation, null);
          }
          throw optionsValidation;
        }
        var expires = 900;
        var serviceOptions = {
          region: options.region,
          endpoint: new AWS3.Endpoint(options.hostname + ":" + options.port),
          paramValidation: false,
          signatureVersion: "v4"
        };
        if (options.credentials) {
          serviceOptions.credentials = options.credentials;
        }
        service = new AWS3.Service(serviceOptions);
        service.api = api;
        var request = service.makeRequest();
        this.modifyRequestForAuthToken(request, options);
        if (hasCallback) {
          request.presign(expires, function(err, url2) {
            if (url2) {
              url2 = self2.convertUrlToAuthToken(url2);
            }
            callback(err, url2);
          });
        } else {
          var url = request.presign(expires);
          return this.convertUrlToAuthToken(url);
        }
      },
      modifyRequestForAuthToken: function modifyRequestForAuthToken(request, options) {
        request.on("build", request.buildAsGet);
        var httpRequest = request.httpRequest;
        httpRequest.body = AWS3.util.queryParamsToString({
          Action: "connect",
          DBUser: options.username
        });
      },
      validateAuthTokenOptions: function validateAuthTokenOptions(options) {
        var message = "";
        options = options || {};
        for (var key in requiredAuthTokenOptions) {
          if (!Object.prototype.hasOwnProperty.call(requiredAuthTokenOptions, key)) {
            continue;
          }
          if (typeof options[key] !== requiredAuthTokenOptions[key]) {
            message += "option '" + key + "' should have been type '" + requiredAuthTokenOptions[key] + "', was '" + typeof options[key] + "'.\n";
          }
        }
        if (message.length) {
          return AWS3.util.error(new Error(), {
            code: "InvalidParameter",
            message
          });
        }
        return true;
      }
    });
  }
});

// node_modules/aws-sdk/lib/services/rds.js
var require_rds = __commonJS({
  "node_modules/aws-sdk/lib/services/rds.js"() {
    var AWS3 = require_core();
    var rdsutil = require_rdsutil();
    require_signer2();
    var crossRegionOperations = ["copyDBSnapshot", "createDBInstanceReadReplica", "createDBCluster", "copyDBClusterSnapshot", "startDBInstanceAutomatedBackupsReplication"];
    AWS3.util.update(AWS3.RDS.prototype, {
      setupRequestListeners: function setupRequestListeners(request) {
        rdsutil.setupRequestListeners(this, request, crossRegionOperations);
      }
    });
  }
});

// node_modules/aws-sdk/apis/rds-2013-01-10.min.json
var require_rds_2013_01_10_min = __commonJS({
  "node_modules/aws-sdk/apis/rds-2013-01-10.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-01-10",
        endpointPrefix: "rds",
        protocol: "query",
        serviceAbbreviation: "Amazon RDS",
        serviceFullName: "Amazon Relational Database Service",
        serviceId: "RDS",
        signatureVersion: "v4",
        uid: "rds-2013-01-10",
        xmlNamespace: "http://rds.amazonaws.com/doc/2013-01-10/"
      },
      operations: {
        AddSourceIdentifierToSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "AddSourceIdentifierToSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "Tags"
            ],
            members: {
              ResourceName: {},
              Tags: {
                shape: "S9"
              }
            }
          }
        },
        AuthorizeDBSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupId: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "AuthorizeDBSecurityGroupIngressResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        },
        CopyDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceDBSnapshotIdentifier",
              "TargetDBSnapshotIdentifier"
            ],
            members: {
              SourceDBSnapshotIdentifier: {},
              TargetDBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "CopyDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sk"
              }
            }
          }
        },
        CreateDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "AllocatedStorage",
              "DBInstanceClass",
              "Engine",
              "MasterUsername",
              "MasterUserPassword"
            ],
            members: {
              DBName: {},
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              Engine: {},
              MasterUsername: {},
              MasterUserPassword: {},
              DBSecurityGroups: {
                shape: "Sp"
              },
              VpcSecurityGroupIds: {
                shape: "Sq"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              PreferredMaintenanceWindow: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              Port: {
                type: "integer"
              },
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              CharacterSetName: {},
              PubliclyAccessible: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        CreateDBInstanceReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "SourceDBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SourceDBInstanceIdentifier: {},
              DBInstanceClass: {},
              AvailabilityZone: {},
              Port: {
                type: "integer"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              PubliclyAccessible: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        CreateDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "DBParameterGroupFamily",
              "Description"
            ],
            members: {
              DBParameterGroupName: {},
              DBParameterGroupFamily: {},
              Description: {}
            }
          },
          output: {
            resultWrapper: "CreateDBParameterGroupResult",
            type: "structure",
            members: {
              DBParameterGroup: {
                shape: "S1c"
              }
            }
          }
        },
        CreateDBSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName",
              "DBSecurityGroupDescription"
            ],
            members: {
              DBSecurityGroupName: {},
              DBSecurityGroupDescription: {}
            }
          },
          output: {
            resultWrapper: "CreateDBSecurityGroupResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        },
        CreateDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier",
              "DBInstanceIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {},
              DBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "CreateDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sk"
              }
            }
          }
        },
        CreateDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "DBSubnetGroupDescription",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S1i"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S11"
              }
            }
          }
        },
        CreateEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SnsTopicArn"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S6"
              },
              SourceIds: {
                shape: "S5"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        CreateOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName",
              "EngineName",
              "MajorEngineVersion",
              "OptionGroupDescription"
            ],
            members: {
              OptionGroupName: {},
              EngineName: {},
              MajorEngineVersion: {},
              OptionGroupDescription: {}
            }
          },
          output: {
            resultWrapper: "CreateOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "S1o"
              }
            }
          }
        },
        DeleteDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SkipFinalSnapshot: {
                type: "boolean"
              },
              FinalDBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        DeleteDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {}
            }
          }
        },
        DeleteDBSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {}
            }
          }
        },
        DeleteDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sk"
              }
            }
          }
        },
        DeleteDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName"
            ],
            members: {
              DBSubnetGroupName: {}
            }
          }
        },
        DeleteEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {}
            }
          },
          output: {
            resultWrapper: "DeleteEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        DeleteOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName"
            ],
            members: {
              OptionGroupName: {}
            }
          }
        },
        DescribeDBEngineVersions: {
          input: {
            type: "structure",
            members: {
              Engine: {},
              EngineVersion: {},
              DBParameterGroupFamily: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              DefaultOnly: {
                type: "boolean"
              },
              ListSupportedCharacterSets: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBEngineVersionsResult",
            type: "structure",
            members: {
              Marker: {},
              DBEngineVersions: {
                type: "list",
                member: {
                  locationName: "DBEngineVersion",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBParameterGroupFamily: {},
                    DBEngineDescription: {},
                    DBEngineVersionDescription: {},
                    DefaultCharacterSet: {
                      shape: "S25"
                    },
                    SupportedCharacterSets: {
                      type: "list",
                      member: {
                        shape: "S25",
                        locationName: "CharacterSet"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeDBInstances: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              DBInstances: {
                type: "list",
                member: {
                  shape: "St",
                  locationName: "DBInstance"
                }
              }
            }
          }
        },
        DescribeDBParameterGroups: {
          input: {
            type: "structure",
            members: {
              DBParameterGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBParameterGroups: {
                type: "list",
                member: {
                  shape: "S1c",
                  locationName: "DBParameterGroup"
                }
              }
            }
          }
        },
        DescribeDBParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              Source: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParametersResult",
            type: "structure",
            members: {
              Parameters: {
                shape: "S2f"
              },
              Marker: {}
            }
          }
        },
        DescribeDBSecurityGroups: {
          input: {
            type: "structure",
            members: {
              DBSecurityGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSecurityGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSecurityGroups: {
                type: "list",
                member: {
                  shape: "Sd",
                  locationName: "DBSecurityGroup"
                }
              }
            }
          }
        },
        DescribeDBSnapshots: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              SnapshotType: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSnapshotsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSnapshots: {
                type: "list",
                member: {
                  shape: "Sk",
                  locationName: "DBSnapshot"
                }
              }
            }
          }
        },
        DescribeDBSubnetGroups: {
          input: {
            type: "structure",
            members: {
              DBSubnetGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSubnetGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSubnetGroups: {
                type: "list",
                member: {
                  shape: "S11",
                  locationName: "DBSubnetGroup"
                }
              }
            }
          }
        },
        DescribeEngineDefaultParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupFamily"
            ],
            members: {
              DBParameterGroupFamily: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEngineDefaultParametersResult",
            type: "structure",
            members: {
              EngineDefaults: {
                type: "structure",
                members: {
                  DBParameterGroupFamily: {},
                  Marker: {},
                  Parameters: {
                    shape: "S2f"
                  }
                },
                wrapper: true
              }
            }
          }
        },
        DescribeEventCategories: {
          input: {
            type: "structure",
            members: {
              SourceType: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventCategoriesResult",
            type: "structure",
            members: {
              EventCategoriesMapList: {
                type: "list",
                member: {
                  locationName: "EventCategoriesMap",
                  type: "structure",
                  members: {
                    SourceType: {},
                    EventCategories: {
                      shape: "S6"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeEventSubscriptions: {
          input: {
            type: "structure",
            members: {
              SubscriptionName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventSubscriptionsResult",
            type: "structure",
            members: {
              Marker: {},
              EventSubscriptionsList: {
                type: "list",
                member: {
                  shape: "S4",
                  locationName: "EventSubscription"
                }
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceIdentifier: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              EventCategories: {
                shape: "S6"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventsResult",
            type: "structure",
            members: {
              Marker: {},
              Events: {
                type: "list",
                member: {
                  locationName: "Event",
                  type: "structure",
                  members: {
                    SourceIdentifier: {},
                    SourceType: {},
                    Message: {},
                    EventCategories: {
                      shape: "S6"
                    },
                    Date: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeOptionGroupOptions: {
          input: {
            type: "structure",
            required: [
              "EngineName"
            ],
            members: {
              EngineName: {},
              MajorEngineVersion: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOptionGroupOptionsResult",
            type: "structure",
            members: {
              OptionGroupOptions: {
                type: "list",
                member: {
                  locationName: "OptionGroupOption",
                  type: "structure",
                  members: {
                    Name: {},
                    Description: {},
                    EngineName: {},
                    MajorEngineVersion: {},
                    MinimumRequiredMinorEngineVersion: {},
                    PortRequired: {
                      type: "boolean"
                    },
                    DefaultPort: {
                      type: "integer"
                    },
                    OptionsDependedOn: {
                      type: "list",
                      member: {
                        locationName: "OptionName"
                      }
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOptionGroups: {
          input: {
            type: "structure",
            members: {
              OptionGroupName: {},
              Marker: {},
              MaxRecords: {
                type: "integer"
              },
              EngineName: {},
              MajorEngineVersion: {}
            }
          },
          output: {
            resultWrapper: "DescribeOptionGroupsResult",
            type: "structure",
            members: {
              OptionGroupsList: {
                type: "list",
                member: {
                  shape: "S1o",
                  locationName: "OptionGroup"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOrderableDBInstanceOptions: {
          input: {
            type: "structure",
            required: [
              "Engine"
            ],
            members: {
              Engine: {},
              EngineVersion: {},
              DBInstanceClass: {},
              LicenseModel: {},
              Vpc: {
                type: "boolean"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOrderableDBInstanceOptionsResult",
            type: "structure",
            members: {
              OrderableDBInstanceOptions: {
                type: "list",
                member: {
                  locationName: "OrderableDBInstanceOption",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBInstanceClass: {},
                    LicenseModel: {},
                    AvailabilityZones: {
                      type: "list",
                      member: {
                        shape: "S14",
                        locationName: "AvailabilityZone"
                      }
                    },
                    MultiAZCapable: {
                      type: "boolean"
                    },
                    ReadReplicaCapable: {
                      type: "boolean"
                    },
                    Vpc: {
                      type: "boolean"
                    }
                  },
                  wrapper: true
                }
              },
              Marker: {}
            }
          }
        },
        DescribeReservedDBInstances: {
          input: {
            type: "structure",
            members: {
              ReservedDBInstanceId: {},
              ReservedDBInstancesOfferingId: {},
              DBInstanceClass: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MultiAZ: {
                type: "boolean"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedDBInstances: {
                type: "list",
                member: {
                  shape: "S3m",
                  locationName: "ReservedDBInstance"
                }
              }
            }
          }
        },
        DescribeReservedDBInstancesOfferings: {
          input: {
            type: "structure",
            members: {
              ReservedDBInstancesOfferingId: {},
              DBInstanceClass: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MultiAZ: {
                type: "boolean"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedDBInstancesOfferingsResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedDBInstancesOfferings: {
                type: "list",
                member: {
                  locationName: "ReservedDBInstancesOffering",
                  type: "structure",
                  members: {
                    ReservedDBInstancesOfferingId: {},
                    DBInstanceClass: {},
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    UsagePrice: {
                      type: "double"
                    },
                    CurrencyCode: {},
                    ProductDescription: {},
                    OfferingType: {},
                    MultiAZ: {
                      type: "boolean"
                    },
                    RecurringCharges: {
                      shape: "S3o"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName"
            ],
            members: {
              ResourceName: {}
            }
          },
          output: {
            resultWrapper: "ListTagsForResourceResult",
            type: "structure",
            members: {
              TagList: {
                shape: "S9"
              }
            }
          }
        },
        ModifyDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              DBSecurityGroups: {
                shape: "Sp"
              },
              VpcSecurityGroupIds: {
                shape: "Sq"
              },
              ApplyImmediately: {
                type: "boolean"
              },
              MasterUserPassword: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              NewDBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "ModifyDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        ModifyDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "Parameters"
            ],
            members: {
              DBParameterGroupName: {},
              Parameters: {
                shape: "S2f"
              }
            }
          },
          output: {
            shape: "S3z",
            resultWrapper: "ModifyDBParameterGroupResult"
          }
        },
        ModifyDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S1i"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S11"
              }
            }
          }
        },
        ModifyEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S6"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        ModifyOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName"
            ],
            members: {
              OptionGroupName: {},
              OptionsToInclude: {
                type: "list",
                member: {
                  locationName: "OptionConfiguration",
                  type: "structure",
                  required: [
                    "OptionName"
                  ],
                  members: {
                    OptionName: {},
                    Port: {
                      type: "integer"
                    },
                    DBSecurityGroupMemberships: {
                      shape: "Sp"
                    },
                    VpcSecurityGroupMemberships: {
                      shape: "Sq"
                    }
                  }
                }
              },
              OptionsToRemove: {
                type: "list",
                member: {}
              },
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "S1o"
              }
            }
          }
        },
        PromoteReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {}
            }
          },
          output: {
            resultWrapper: "PromoteReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        PurchaseReservedDBInstancesOffering: {
          input: {
            type: "structure",
            required: [
              "ReservedDBInstancesOfferingId"
            ],
            members: {
              ReservedDBInstancesOfferingId: {},
              ReservedDBInstanceId: {},
              DBInstanceCount: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "PurchaseReservedDBInstancesOfferingResult",
            type: "structure",
            members: {
              ReservedDBInstance: {
                shape: "S3m"
              }
            }
          }
        },
        RebootDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              ForceFailover: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RebootDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        RemoveSourceIdentifierFromSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RemoveSourceIdentifierFromSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "TagKeys"
            ],
            members: {
              ResourceName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ResetDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              Parameters: {
                shape: "S2f"
              }
            }
          },
          output: {
            shape: "S3z",
            resultWrapper: "ResetDBParameterGroupResult"
          }
        },
        RestoreDBInstanceFromDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "DBSnapshotIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              DBInstanceClass: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              MultiAZ: {
                type: "boolean"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              DBName: {},
              Engine: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {}
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceFromDBSnapshotResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        RestoreDBInstanceToPointInTime: {
          input: {
            type: "structure",
            required: [
              "SourceDBInstanceIdentifier",
              "TargetDBInstanceIdentifier"
            ],
            members: {
              SourceDBInstanceIdentifier: {},
              TargetDBInstanceIdentifier: {},
              RestoreTime: {
                type: "timestamp"
              },
              UseLatestRestorableTime: {
                type: "boolean"
              },
              DBInstanceClass: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              MultiAZ: {
                type: "boolean"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              DBName: {},
              Engine: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {}
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceToPointInTimeResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        RevokeDBSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupId: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "RevokeDBSecurityGroupIngressResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            Id: {},
            CustomerAwsId: {},
            CustSubscriptionId: {},
            SnsTopicArn: {},
            Status: {},
            SubscriptionCreationTime: {},
            SourceType: {},
            SourceIdsList: {
              shape: "S5"
            },
            EventCategoriesList: {
              shape: "S6"
            },
            Enabled: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S5: {
          type: "list",
          member: {
            locationName: "SourceId"
          }
        },
        S6: {
          type: "list",
          member: {
            locationName: "EventCategory"
          }
        },
        S9: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            OwnerId: {},
            DBSecurityGroupName: {},
            DBSecurityGroupDescription: {},
            VpcId: {},
            EC2SecurityGroups: {
              type: "list",
              member: {
                locationName: "EC2SecurityGroup",
                type: "structure",
                members: {
                  Status: {},
                  EC2SecurityGroupName: {},
                  EC2SecurityGroupId: {},
                  EC2SecurityGroupOwnerId: {}
                }
              }
            },
            IPRanges: {
              type: "list",
              member: {
                locationName: "IPRange",
                type: "structure",
                members: {
                  Status: {},
                  CIDRIP: {}
                }
              }
            }
          },
          wrapper: true
        },
        Sk: {
          type: "structure",
          members: {
            DBSnapshotIdentifier: {},
            DBInstanceIdentifier: {},
            SnapshotCreateTime: {
              type: "timestamp"
            },
            Engine: {},
            AllocatedStorage: {
              type: "integer"
            },
            Status: {},
            Port: {
              type: "integer"
            },
            AvailabilityZone: {},
            VpcId: {},
            InstanceCreateTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            EngineVersion: {},
            LicenseModel: {},
            SnapshotType: {},
            Iops: {
              type: "integer"
            }
          },
          wrapper: true
        },
        Sp: {
          type: "list",
          member: {
            locationName: "DBSecurityGroupName"
          }
        },
        Sq: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupId"
          }
        },
        St: {
          type: "structure",
          members: {
            DBInstanceIdentifier: {},
            DBInstanceClass: {},
            Engine: {},
            DBInstanceStatus: {},
            MasterUsername: {},
            DBName: {},
            Endpoint: {
              type: "structure",
              members: {
                Address: {},
                Port: {
                  type: "integer"
                }
              }
            },
            AllocatedStorage: {
              type: "integer"
            },
            InstanceCreateTime: {
              type: "timestamp"
            },
            PreferredBackupWindow: {},
            BackupRetentionPeriod: {
              type: "integer"
            },
            DBSecurityGroups: {
              shape: "Sv"
            },
            VpcSecurityGroups: {
              shape: "Sx"
            },
            DBParameterGroups: {
              type: "list",
              member: {
                locationName: "DBParameterGroup",
                type: "structure",
                members: {
                  DBParameterGroupName: {},
                  ParameterApplyStatus: {}
                }
              }
            },
            AvailabilityZone: {},
            DBSubnetGroup: {
              shape: "S11"
            },
            PreferredMaintenanceWindow: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                DBInstanceClass: {},
                AllocatedStorage: {
                  type: "integer"
                },
                MasterUserPassword: {},
                Port: {
                  type: "integer"
                },
                BackupRetentionPeriod: {
                  type: "integer"
                },
                MultiAZ: {
                  type: "boolean"
                },
                EngineVersion: {},
                Iops: {
                  type: "integer"
                },
                DBInstanceIdentifier: {}
              }
            },
            LatestRestorableTime: {
              type: "timestamp"
            },
            MultiAZ: {
              type: "boolean"
            },
            EngineVersion: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            ReadReplicaSourceDBInstanceIdentifier: {},
            ReadReplicaDBInstanceIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaDBInstanceIdentifier"
              }
            },
            LicenseModel: {},
            Iops: {
              type: "integer"
            },
            OptionGroupMembership: {
              type: "structure",
              members: {
                OptionGroupName: {},
                Status: {}
              }
            },
            CharacterSetName: {},
            SecondaryAvailabilityZone: {},
            PubliclyAccessible: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        Sv: {
          type: "list",
          member: {
            locationName: "DBSecurityGroup",
            type: "structure",
            members: {
              DBSecurityGroupName: {},
              Status: {}
            }
          }
        },
        Sx: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupMembership",
            type: "structure",
            members: {
              VpcSecurityGroupId: {},
              Status: {}
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            DBSubnetGroupName: {},
            DBSubnetGroupDescription: {},
            VpcId: {},
            SubnetGroupStatus: {},
            Subnets: {
              type: "list",
              member: {
                locationName: "Subnet",
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {
                    shape: "S14"
                  },
                  SubnetStatus: {}
                }
              }
            }
          },
          wrapper: true
        },
        S14: {
          type: "structure",
          members: {
            Name: {},
            ProvisionedIopsCapable: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S1c: {
          type: "structure",
          members: {
            DBParameterGroupName: {},
            DBParameterGroupFamily: {},
            Description: {}
          },
          wrapper: true
        },
        S1i: {
          type: "list",
          member: {
            locationName: "SubnetIdentifier"
          }
        },
        S1o: {
          type: "structure",
          members: {
            OptionGroupName: {},
            OptionGroupDescription: {},
            EngineName: {},
            MajorEngineVersion: {},
            Options: {
              type: "list",
              member: {
                locationName: "Option",
                type: "structure",
                members: {
                  OptionName: {},
                  OptionDescription: {},
                  Port: {
                    type: "integer"
                  },
                  DBSecurityGroupMemberships: {
                    shape: "Sv"
                  },
                  VpcSecurityGroupMemberships: {
                    shape: "Sx"
                  }
                }
              }
            },
            AllowsVpcAndNonVpcInstanceMemberships: {
              type: "boolean"
            },
            VpcId: {}
          },
          wrapper: true
        },
        S25: {
          type: "structure",
          members: {
            CharacterSetName: {},
            CharacterSetDescription: {}
          }
        },
        S2f: {
          type: "list",
          member: {
            locationName: "Parameter",
            type: "structure",
            members: {
              ParameterName: {},
              ParameterValue: {},
              Description: {},
              Source: {},
              ApplyType: {},
              DataType: {},
              AllowedValues: {},
              IsModifiable: {
                type: "boolean"
              },
              MinimumEngineVersion: {},
              ApplyMethod: {}
            }
          }
        },
        S3m: {
          type: "structure",
          members: {
            ReservedDBInstanceId: {},
            ReservedDBInstancesOfferingId: {},
            DBInstanceClass: {},
            StartTime: {
              type: "timestamp"
            },
            Duration: {
              type: "integer"
            },
            FixedPrice: {
              type: "double"
            },
            UsagePrice: {
              type: "double"
            },
            CurrencyCode: {},
            DBInstanceCount: {
              type: "integer"
            },
            ProductDescription: {},
            OfferingType: {},
            MultiAZ: {
              type: "boolean"
            },
            State: {},
            RecurringCharges: {
              shape: "S3o"
            }
          },
          wrapper: true
        },
        S3o: {
          type: "list",
          member: {
            locationName: "RecurringCharge",
            type: "structure",
            members: {
              RecurringChargeAmount: {
                type: "double"
              },
              RecurringChargeFrequency: {}
            },
            wrapper: true
          }
        },
        S3z: {
          type: "structure",
          members: {
            DBParameterGroupName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-2013-01-10.paginators.json
var require_rds_2013_01_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/rds-2013-01-10.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeDBEngineVersions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBEngineVersions"
        },
        DescribeDBInstances: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBInstances"
        },
        DescribeDBParameterGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBParameterGroups"
        },
        DescribeDBParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Parameters"
        },
        DescribeDBSecurityGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSecurityGroups"
        },
        DescribeDBSnapshots: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSnapshots"
        },
        DescribeDBSubnetGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSubnetGroups"
        },
        DescribeEngineDefaultParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "EngineDefaults.Marker",
          result_key: "EngineDefaults.Parameters"
        },
        DescribeEventSubscriptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "EventSubscriptionsList"
        },
        DescribeEvents: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Events"
        },
        DescribeOptionGroupOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OptionGroupOptions"
        },
        DescribeOptionGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OptionGroupsList"
        },
        DescribeOrderableDBInstanceOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OrderableDBInstanceOptions"
        },
        DescribeReservedDBInstances: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedDBInstances"
        },
        DescribeReservedDBInstancesOfferings: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedDBInstancesOfferings"
        },
        ListTagsForResource: {
          result_key: "TagList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-2013-02-12.min.json
var require_rds_2013_02_12_min = __commonJS({
  "node_modules/aws-sdk/apis/rds-2013-02-12.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-02-12",
        endpointPrefix: "rds",
        protocol: "query",
        serviceAbbreviation: "Amazon RDS",
        serviceFullName: "Amazon Relational Database Service",
        serviceId: "RDS",
        signatureVersion: "v4",
        uid: "rds-2013-02-12",
        xmlNamespace: "http://rds.amazonaws.com/doc/2013-02-12/"
      },
      operations: {
        AddSourceIdentifierToSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "AddSourceIdentifierToSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "Tags"
            ],
            members: {
              ResourceName: {},
              Tags: {
                shape: "S9"
              }
            }
          }
        },
        AuthorizeDBSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupId: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "AuthorizeDBSecurityGroupIngressResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        },
        CopyDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceDBSnapshotIdentifier",
              "TargetDBSnapshotIdentifier"
            ],
            members: {
              SourceDBSnapshotIdentifier: {},
              TargetDBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "CopyDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sk"
              }
            }
          }
        },
        CreateDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "AllocatedStorage",
              "DBInstanceClass",
              "Engine",
              "MasterUsername",
              "MasterUserPassword"
            ],
            members: {
              DBName: {},
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              Engine: {},
              MasterUsername: {},
              MasterUserPassword: {},
              DBSecurityGroups: {
                shape: "Sp"
              },
              VpcSecurityGroupIds: {
                shape: "Sq"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              PreferredMaintenanceWindow: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              Port: {
                type: "integer"
              },
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              CharacterSetName: {},
              PubliclyAccessible: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        CreateDBInstanceReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "SourceDBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SourceDBInstanceIdentifier: {},
              DBInstanceClass: {},
              AvailabilityZone: {},
              Port: {
                type: "integer"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              PubliclyAccessible: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        CreateDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "DBParameterGroupFamily",
              "Description"
            ],
            members: {
              DBParameterGroupName: {},
              DBParameterGroupFamily: {},
              Description: {}
            }
          },
          output: {
            resultWrapper: "CreateDBParameterGroupResult",
            type: "structure",
            members: {
              DBParameterGroup: {
                shape: "S1d"
              }
            }
          }
        },
        CreateDBSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName",
              "DBSecurityGroupDescription"
            ],
            members: {
              DBSecurityGroupName: {},
              DBSecurityGroupDescription: {}
            }
          },
          output: {
            resultWrapper: "CreateDBSecurityGroupResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        },
        CreateDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier",
              "DBInstanceIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {},
              DBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "CreateDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sk"
              }
            }
          }
        },
        CreateDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "DBSubnetGroupDescription",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S1j"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S11"
              }
            }
          }
        },
        CreateEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SnsTopicArn"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S6"
              },
              SourceIds: {
                shape: "S5"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        CreateOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName",
              "EngineName",
              "MajorEngineVersion",
              "OptionGroupDescription"
            ],
            members: {
              OptionGroupName: {},
              EngineName: {},
              MajorEngineVersion: {},
              OptionGroupDescription: {}
            }
          },
          output: {
            resultWrapper: "CreateOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "S1p"
              }
            }
          }
        },
        DeleteDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SkipFinalSnapshot: {
                type: "boolean"
              },
              FinalDBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        DeleteDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {}
            }
          }
        },
        DeleteDBSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {}
            }
          }
        },
        DeleteDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sk"
              }
            }
          }
        },
        DeleteDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName"
            ],
            members: {
              DBSubnetGroupName: {}
            }
          }
        },
        DeleteEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {}
            }
          },
          output: {
            resultWrapper: "DeleteEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        DeleteOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName"
            ],
            members: {
              OptionGroupName: {}
            }
          }
        },
        DescribeDBEngineVersions: {
          input: {
            type: "structure",
            members: {
              Engine: {},
              EngineVersion: {},
              DBParameterGroupFamily: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              DefaultOnly: {
                type: "boolean"
              },
              ListSupportedCharacterSets: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBEngineVersionsResult",
            type: "structure",
            members: {
              Marker: {},
              DBEngineVersions: {
                type: "list",
                member: {
                  locationName: "DBEngineVersion",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBParameterGroupFamily: {},
                    DBEngineDescription: {},
                    DBEngineVersionDescription: {},
                    DefaultCharacterSet: {
                      shape: "S28"
                    },
                    SupportedCharacterSets: {
                      type: "list",
                      member: {
                        shape: "S28",
                        locationName: "CharacterSet"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeDBInstances: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              DBInstances: {
                type: "list",
                member: {
                  shape: "St",
                  locationName: "DBInstance"
                }
              }
            }
          }
        },
        DescribeDBLogFiles: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              FilenameContains: {},
              FileLastWritten: {
                type: "long"
              },
              FileSize: {
                type: "long"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBLogFilesResult",
            type: "structure",
            members: {
              DescribeDBLogFiles: {
                type: "list",
                member: {
                  locationName: "DescribeDBLogFilesDetails",
                  type: "structure",
                  members: {
                    LogFileName: {},
                    LastWritten: {
                      type: "long"
                    },
                    Size: {
                      type: "long"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeDBParameterGroups: {
          input: {
            type: "structure",
            members: {
              DBParameterGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBParameterGroups: {
                type: "list",
                member: {
                  shape: "S1d",
                  locationName: "DBParameterGroup"
                }
              }
            }
          }
        },
        DescribeDBParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              Source: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParametersResult",
            type: "structure",
            members: {
              Parameters: {
                shape: "S2n"
              },
              Marker: {}
            }
          }
        },
        DescribeDBSecurityGroups: {
          input: {
            type: "structure",
            members: {
              DBSecurityGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSecurityGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSecurityGroups: {
                type: "list",
                member: {
                  shape: "Sd",
                  locationName: "DBSecurityGroup"
                }
              }
            }
          }
        },
        DescribeDBSnapshots: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              SnapshotType: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSnapshotsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSnapshots: {
                type: "list",
                member: {
                  shape: "Sk",
                  locationName: "DBSnapshot"
                }
              }
            }
          }
        },
        DescribeDBSubnetGroups: {
          input: {
            type: "structure",
            members: {
              DBSubnetGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSubnetGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSubnetGroups: {
                type: "list",
                member: {
                  shape: "S11",
                  locationName: "DBSubnetGroup"
                }
              }
            }
          }
        },
        DescribeEngineDefaultParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupFamily"
            ],
            members: {
              DBParameterGroupFamily: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEngineDefaultParametersResult",
            type: "structure",
            members: {
              EngineDefaults: {
                type: "structure",
                members: {
                  DBParameterGroupFamily: {},
                  Marker: {},
                  Parameters: {
                    shape: "S2n"
                  }
                },
                wrapper: true
              }
            }
          }
        },
        DescribeEventCategories: {
          input: {
            type: "structure",
            members: {
              SourceType: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventCategoriesResult",
            type: "structure",
            members: {
              EventCategoriesMapList: {
                type: "list",
                member: {
                  locationName: "EventCategoriesMap",
                  type: "structure",
                  members: {
                    SourceType: {},
                    EventCategories: {
                      shape: "S6"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeEventSubscriptions: {
          input: {
            type: "structure",
            members: {
              SubscriptionName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventSubscriptionsResult",
            type: "structure",
            members: {
              Marker: {},
              EventSubscriptionsList: {
                type: "list",
                member: {
                  shape: "S4",
                  locationName: "EventSubscription"
                }
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceIdentifier: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              EventCategories: {
                shape: "S6"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventsResult",
            type: "structure",
            members: {
              Marker: {},
              Events: {
                type: "list",
                member: {
                  locationName: "Event",
                  type: "structure",
                  members: {
                    SourceIdentifier: {},
                    SourceType: {},
                    Message: {},
                    EventCategories: {
                      shape: "S6"
                    },
                    Date: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeOptionGroupOptions: {
          input: {
            type: "structure",
            required: [
              "EngineName"
            ],
            members: {
              EngineName: {},
              MajorEngineVersion: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOptionGroupOptionsResult",
            type: "structure",
            members: {
              OptionGroupOptions: {
                type: "list",
                member: {
                  locationName: "OptionGroupOption",
                  type: "structure",
                  members: {
                    Name: {},
                    Description: {},
                    EngineName: {},
                    MajorEngineVersion: {},
                    MinimumRequiredMinorEngineVersion: {},
                    PortRequired: {
                      type: "boolean"
                    },
                    DefaultPort: {
                      type: "integer"
                    },
                    OptionsDependedOn: {
                      type: "list",
                      member: {
                        locationName: "OptionName"
                      }
                    },
                    Persistent: {
                      type: "boolean"
                    },
                    OptionGroupOptionSettings: {
                      type: "list",
                      member: {
                        locationName: "OptionGroupOptionSetting",
                        type: "structure",
                        members: {
                          SettingName: {},
                          SettingDescription: {},
                          DefaultValue: {},
                          ApplyType: {},
                          AllowedValues: {},
                          IsModifiable: {
                            type: "boolean"
                          }
                        }
                      }
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOptionGroups: {
          input: {
            type: "structure",
            members: {
              OptionGroupName: {},
              Marker: {},
              MaxRecords: {
                type: "integer"
              },
              EngineName: {},
              MajorEngineVersion: {}
            }
          },
          output: {
            resultWrapper: "DescribeOptionGroupsResult",
            type: "structure",
            members: {
              OptionGroupsList: {
                type: "list",
                member: {
                  shape: "S1p",
                  locationName: "OptionGroup"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOrderableDBInstanceOptions: {
          input: {
            type: "structure",
            required: [
              "Engine"
            ],
            members: {
              Engine: {},
              EngineVersion: {},
              DBInstanceClass: {},
              LicenseModel: {},
              Vpc: {
                type: "boolean"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOrderableDBInstanceOptionsResult",
            type: "structure",
            members: {
              OrderableDBInstanceOptions: {
                type: "list",
                member: {
                  locationName: "OrderableDBInstanceOption",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBInstanceClass: {},
                    LicenseModel: {},
                    AvailabilityZones: {
                      type: "list",
                      member: {
                        shape: "S14",
                        locationName: "AvailabilityZone"
                      }
                    },
                    MultiAZCapable: {
                      type: "boolean"
                    },
                    ReadReplicaCapable: {
                      type: "boolean"
                    },
                    Vpc: {
                      type: "boolean"
                    }
                  },
                  wrapper: true
                }
              },
              Marker: {}
            }
          }
        },
        DescribeReservedDBInstances: {
          input: {
            type: "structure",
            members: {
              ReservedDBInstanceId: {},
              ReservedDBInstancesOfferingId: {},
              DBInstanceClass: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MultiAZ: {
                type: "boolean"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedDBInstances: {
                type: "list",
                member: {
                  shape: "S3w",
                  locationName: "ReservedDBInstance"
                }
              }
            }
          }
        },
        DescribeReservedDBInstancesOfferings: {
          input: {
            type: "structure",
            members: {
              ReservedDBInstancesOfferingId: {},
              DBInstanceClass: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MultiAZ: {
                type: "boolean"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedDBInstancesOfferingsResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedDBInstancesOfferings: {
                type: "list",
                member: {
                  locationName: "ReservedDBInstancesOffering",
                  type: "structure",
                  members: {
                    ReservedDBInstancesOfferingId: {},
                    DBInstanceClass: {},
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    UsagePrice: {
                      type: "double"
                    },
                    CurrencyCode: {},
                    ProductDescription: {},
                    OfferingType: {},
                    MultiAZ: {
                      type: "boolean"
                    },
                    RecurringCharges: {
                      shape: "S3y"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DownloadDBLogFilePortion: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "LogFileName"
            ],
            members: {
              DBInstanceIdentifier: {},
              LogFileName: {},
              Marker: {},
              NumberOfLines: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DownloadDBLogFilePortionResult",
            type: "structure",
            members: {
              LogFileData: {},
              Marker: {},
              AdditionalDataPending: {
                type: "boolean"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName"
            ],
            members: {
              ResourceName: {}
            }
          },
          output: {
            resultWrapper: "ListTagsForResourceResult",
            type: "structure",
            members: {
              TagList: {
                shape: "S9"
              }
            }
          }
        },
        ModifyDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              DBSecurityGroups: {
                shape: "Sp"
              },
              VpcSecurityGroupIds: {
                shape: "Sq"
              },
              ApplyImmediately: {
                type: "boolean"
              },
              MasterUserPassword: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              NewDBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "ModifyDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        ModifyDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "Parameters"
            ],
            members: {
              DBParameterGroupName: {},
              Parameters: {
                shape: "S2n"
              }
            }
          },
          output: {
            shape: "S4b",
            resultWrapper: "ModifyDBParameterGroupResult"
          }
        },
        ModifyDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S1j"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S11"
              }
            }
          }
        },
        ModifyEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S6"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        ModifyOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName"
            ],
            members: {
              OptionGroupName: {},
              OptionsToInclude: {
                type: "list",
                member: {
                  locationName: "OptionConfiguration",
                  type: "structure",
                  required: [
                    "OptionName"
                  ],
                  members: {
                    OptionName: {},
                    Port: {
                      type: "integer"
                    },
                    DBSecurityGroupMemberships: {
                      shape: "Sp"
                    },
                    VpcSecurityGroupMemberships: {
                      shape: "Sq"
                    },
                    OptionSettings: {
                      type: "list",
                      member: {
                        shape: "S1t",
                        locationName: "OptionSetting"
                      }
                    }
                  }
                }
              },
              OptionsToRemove: {
                type: "list",
                member: {}
              },
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "S1p"
              }
            }
          }
        },
        PromoteReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {}
            }
          },
          output: {
            resultWrapper: "PromoteReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        PurchaseReservedDBInstancesOffering: {
          input: {
            type: "structure",
            required: [
              "ReservedDBInstancesOfferingId"
            ],
            members: {
              ReservedDBInstancesOfferingId: {},
              ReservedDBInstanceId: {},
              DBInstanceCount: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "PurchaseReservedDBInstancesOfferingResult",
            type: "structure",
            members: {
              ReservedDBInstance: {
                shape: "S3w"
              }
            }
          }
        },
        RebootDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              ForceFailover: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RebootDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        RemoveSourceIdentifierFromSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RemoveSourceIdentifierFromSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "TagKeys"
            ],
            members: {
              ResourceName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ResetDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              Parameters: {
                shape: "S2n"
              }
            }
          },
          output: {
            shape: "S4b",
            resultWrapper: "ResetDBParameterGroupResult"
          }
        },
        RestoreDBInstanceFromDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "DBSnapshotIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              DBInstanceClass: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              MultiAZ: {
                type: "boolean"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              DBName: {},
              Engine: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {}
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceFromDBSnapshotResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        RestoreDBInstanceToPointInTime: {
          input: {
            type: "structure",
            required: [
              "SourceDBInstanceIdentifier",
              "TargetDBInstanceIdentifier"
            ],
            members: {
              SourceDBInstanceIdentifier: {},
              TargetDBInstanceIdentifier: {},
              RestoreTime: {
                type: "timestamp"
              },
              UseLatestRestorableTime: {
                type: "boolean"
              },
              DBInstanceClass: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              MultiAZ: {
                type: "boolean"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              DBName: {},
              Engine: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {}
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceToPointInTimeResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        RevokeDBSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupId: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "RevokeDBSecurityGroupIngressResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            CustomerAwsId: {},
            CustSubscriptionId: {},
            SnsTopicArn: {},
            Status: {},
            SubscriptionCreationTime: {},
            SourceType: {},
            SourceIdsList: {
              shape: "S5"
            },
            EventCategoriesList: {
              shape: "S6"
            },
            Enabled: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S5: {
          type: "list",
          member: {
            locationName: "SourceId"
          }
        },
        S6: {
          type: "list",
          member: {
            locationName: "EventCategory"
          }
        },
        S9: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            OwnerId: {},
            DBSecurityGroupName: {},
            DBSecurityGroupDescription: {},
            VpcId: {},
            EC2SecurityGroups: {
              type: "list",
              member: {
                locationName: "EC2SecurityGroup",
                type: "structure",
                members: {
                  Status: {},
                  EC2SecurityGroupName: {},
                  EC2SecurityGroupId: {},
                  EC2SecurityGroupOwnerId: {}
                }
              }
            },
            IPRanges: {
              type: "list",
              member: {
                locationName: "IPRange",
                type: "structure",
                members: {
                  Status: {},
                  CIDRIP: {}
                }
              }
            }
          },
          wrapper: true
        },
        Sk: {
          type: "structure",
          members: {
            DBSnapshotIdentifier: {},
            DBInstanceIdentifier: {},
            SnapshotCreateTime: {
              type: "timestamp"
            },
            Engine: {},
            AllocatedStorage: {
              type: "integer"
            },
            Status: {},
            Port: {
              type: "integer"
            },
            AvailabilityZone: {},
            VpcId: {},
            InstanceCreateTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            EngineVersion: {},
            LicenseModel: {},
            SnapshotType: {},
            Iops: {
              type: "integer"
            },
            OptionGroupName: {}
          },
          wrapper: true
        },
        Sp: {
          type: "list",
          member: {
            locationName: "DBSecurityGroupName"
          }
        },
        Sq: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupId"
          }
        },
        St: {
          type: "structure",
          members: {
            DBInstanceIdentifier: {},
            DBInstanceClass: {},
            Engine: {},
            DBInstanceStatus: {},
            MasterUsername: {},
            DBName: {},
            Endpoint: {
              type: "structure",
              members: {
                Address: {},
                Port: {
                  type: "integer"
                }
              }
            },
            AllocatedStorage: {
              type: "integer"
            },
            InstanceCreateTime: {
              type: "timestamp"
            },
            PreferredBackupWindow: {},
            BackupRetentionPeriod: {
              type: "integer"
            },
            DBSecurityGroups: {
              shape: "Sv"
            },
            VpcSecurityGroups: {
              shape: "Sx"
            },
            DBParameterGroups: {
              type: "list",
              member: {
                locationName: "DBParameterGroup",
                type: "structure",
                members: {
                  DBParameterGroupName: {},
                  ParameterApplyStatus: {}
                }
              }
            },
            AvailabilityZone: {},
            DBSubnetGroup: {
              shape: "S11"
            },
            PreferredMaintenanceWindow: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                DBInstanceClass: {},
                AllocatedStorage: {
                  type: "integer"
                },
                MasterUserPassword: {},
                Port: {
                  type: "integer"
                },
                BackupRetentionPeriod: {
                  type: "integer"
                },
                MultiAZ: {
                  type: "boolean"
                },
                EngineVersion: {},
                Iops: {
                  type: "integer"
                },
                DBInstanceIdentifier: {}
              }
            },
            LatestRestorableTime: {
              type: "timestamp"
            },
            MultiAZ: {
              type: "boolean"
            },
            EngineVersion: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            ReadReplicaSourceDBInstanceIdentifier: {},
            ReadReplicaDBInstanceIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaDBInstanceIdentifier"
              }
            },
            LicenseModel: {},
            Iops: {
              type: "integer"
            },
            OptionGroupMemberships: {
              type: "list",
              member: {
                locationName: "OptionGroupMembership",
                type: "structure",
                members: {
                  OptionGroupName: {},
                  Status: {}
                }
              }
            },
            CharacterSetName: {},
            SecondaryAvailabilityZone: {},
            PubliclyAccessible: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        Sv: {
          type: "list",
          member: {
            locationName: "DBSecurityGroup",
            type: "structure",
            members: {
              DBSecurityGroupName: {},
              Status: {}
            }
          }
        },
        Sx: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupMembership",
            type: "structure",
            members: {
              VpcSecurityGroupId: {},
              Status: {}
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            DBSubnetGroupName: {},
            DBSubnetGroupDescription: {},
            VpcId: {},
            SubnetGroupStatus: {},
            Subnets: {
              type: "list",
              member: {
                locationName: "Subnet",
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {
                    shape: "S14"
                  },
                  SubnetStatus: {}
                }
              }
            }
          },
          wrapper: true
        },
        S14: {
          type: "structure",
          members: {
            Name: {},
            ProvisionedIopsCapable: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S1d: {
          type: "structure",
          members: {
            DBParameterGroupName: {},
            DBParameterGroupFamily: {},
            Description: {}
          },
          wrapper: true
        },
        S1j: {
          type: "list",
          member: {
            locationName: "SubnetIdentifier"
          }
        },
        S1p: {
          type: "structure",
          members: {
            OptionGroupName: {},
            OptionGroupDescription: {},
            EngineName: {},
            MajorEngineVersion: {},
            Options: {
              type: "list",
              member: {
                locationName: "Option",
                type: "structure",
                members: {
                  OptionName: {},
                  OptionDescription: {},
                  Persistent: {
                    type: "boolean"
                  },
                  Port: {
                    type: "integer"
                  },
                  OptionSettings: {
                    type: "list",
                    member: {
                      shape: "S1t",
                      locationName: "OptionSetting"
                    }
                  },
                  DBSecurityGroupMemberships: {
                    shape: "Sv"
                  },
                  VpcSecurityGroupMemberships: {
                    shape: "Sx"
                  }
                }
              }
            },
            AllowsVpcAndNonVpcInstanceMemberships: {
              type: "boolean"
            },
            VpcId: {}
          },
          wrapper: true
        },
        S1t: {
          type: "structure",
          members: {
            Name: {},
            Value: {},
            DefaultValue: {},
            Description: {},
            ApplyType: {},
            DataType: {},
            AllowedValues: {},
            IsModifiable: {
              type: "boolean"
            },
            IsCollection: {
              type: "boolean"
            }
          }
        },
        S28: {
          type: "structure",
          members: {
            CharacterSetName: {},
            CharacterSetDescription: {}
          }
        },
        S2n: {
          type: "list",
          member: {
            locationName: "Parameter",
            type: "structure",
            members: {
              ParameterName: {},
              ParameterValue: {},
              Description: {},
              Source: {},
              ApplyType: {},
              DataType: {},
              AllowedValues: {},
              IsModifiable: {
                type: "boolean"
              },
              MinimumEngineVersion: {},
              ApplyMethod: {}
            }
          }
        },
        S3w: {
          type: "structure",
          members: {
            ReservedDBInstanceId: {},
            ReservedDBInstancesOfferingId: {},
            DBInstanceClass: {},
            StartTime: {
              type: "timestamp"
            },
            Duration: {
              type: "integer"
            },
            FixedPrice: {
              type: "double"
            },
            UsagePrice: {
              type: "double"
            },
            CurrencyCode: {},
            DBInstanceCount: {
              type: "integer"
            },
            ProductDescription: {},
            OfferingType: {},
            MultiAZ: {
              type: "boolean"
            },
            State: {},
            RecurringCharges: {
              shape: "S3y"
            }
          },
          wrapper: true
        },
        S3y: {
          type: "list",
          member: {
            locationName: "RecurringCharge",
            type: "structure",
            members: {
              RecurringChargeAmount: {
                type: "double"
              },
              RecurringChargeFrequency: {}
            },
            wrapper: true
          }
        },
        S4b: {
          type: "structure",
          members: {
            DBParameterGroupName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-2013-02-12.paginators.json
var require_rds_2013_02_12_paginators = __commonJS({
  "node_modules/aws-sdk/apis/rds-2013-02-12.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeDBEngineVersions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBEngineVersions"
        },
        DescribeDBInstances: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBInstances"
        },
        DescribeDBLogFiles: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DescribeDBLogFiles"
        },
        DescribeDBParameterGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBParameterGroups"
        },
        DescribeDBParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Parameters"
        },
        DescribeDBSecurityGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSecurityGroups"
        },
        DescribeDBSnapshots: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSnapshots"
        },
        DescribeDBSubnetGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSubnetGroups"
        },
        DescribeEngineDefaultParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "EngineDefaults.Marker",
          result_key: "EngineDefaults.Parameters"
        },
        DescribeEventSubscriptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "EventSubscriptionsList"
        },
        DescribeEvents: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Events"
        },
        DescribeOptionGroupOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OptionGroupOptions"
        },
        DescribeOptionGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OptionGroupsList"
        },
        DescribeOrderableDBInstanceOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OrderableDBInstanceOptions"
        },
        DescribeReservedDBInstances: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedDBInstances"
        },
        DescribeReservedDBInstancesOfferings: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedDBInstancesOfferings"
        },
        DownloadDBLogFilePortion: {
          input_token: "Marker",
          limit_key: "NumberOfLines",
          more_results: "AdditionalDataPending",
          output_token: "Marker",
          result_key: "LogFileData"
        },
        ListTagsForResource: {
          result_key: "TagList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-2013-09-09.min.json
var require_rds_2013_09_09_min = __commonJS({
  "node_modules/aws-sdk/apis/rds-2013-09-09.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-09-09",
        endpointPrefix: "rds",
        protocol: "query",
        serviceAbbreviation: "Amazon RDS",
        serviceFullName: "Amazon Relational Database Service",
        serviceId: "RDS",
        signatureVersion: "v4",
        uid: "rds-2013-09-09",
        xmlNamespace: "http://rds.amazonaws.com/doc/2013-09-09/"
      },
      operations: {
        AddSourceIdentifierToSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "AddSourceIdentifierToSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "Tags"
            ],
            members: {
              ResourceName: {},
              Tags: {
                shape: "S9"
              }
            }
          }
        },
        AuthorizeDBSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupId: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "AuthorizeDBSecurityGroupIngressResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        },
        CopyDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceDBSnapshotIdentifier",
              "TargetDBSnapshotIdentifier"
            ],
            members: {
              SourceDBSnapshotIdentifier: {},
              TargetDBSnapshotIdentifier: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CopyDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sk"
              }
            }
          }
        },
        CreateDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "AllocatedStorage",
              "DBInstanceClass",
              "Engine",
              "MasterUsername",
              "MasterUserPassword"
            ],
            members: {
              DBName: {},
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              Engine: {},
              MasterUsername: {},
              MasterUserPassword: {},
              DBSecurityGroups: {
                shape: "Sp"
              },
              VpcSecurityGroupIds: {
                shape: "Sq"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              PreferredMaintenanceWindow: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              Port: {
                type: "integer"
              },
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              CharacterSetName: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        CreateDBInstanceReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "SourceDBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SourceDBInstanceIdentifier: {},
              DBInstanceClass: {},
              AvailabilityZone: {},
              Port: {
                type: "integer"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              },
              DBSubnetGroupName: {}
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        CreateDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "DBParameterGroupFamily",
              "Description"
            ],
            members: {
              DBParameterGroupName: {},
              DBParameterGroupFamily: {},
              Description: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBParameterGroupResult",
            type: "structure",
            members: {
              DBParameterGroup: {
                shape: "S1f"
              }
            }
          }
        },
        CreateDBSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName",
              "DBSecurityGroupDescription"
            ],
            members: {
              DBSecurityGroupName: {},
              DBSecurityGroupDescription: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSecurityGroupResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        },
        CreateDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier",
              "DBInstanceIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {},
              DBInstanceIdentifier: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sk"
              }
            }
          }
        },
        CreateDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "DBSubnetGroupDescription",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S1l"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S11"
              }
            }
          }
        },
        CreateEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SnsTopicArn"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S6"
              },
              SourceIds: {
                shape: "S5"
              },
              Enabled: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        CreateOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName",
              "EngineName",
              "MajorEngineVersion",
              "OptionGroupDescription"
            ],
            members: {
              OptionGroupName: {},
              EngineName: {},
              MajorEngineVersion: {},
              OptionGroupDescription: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "S1r"
              }
            }
          }
        },
        DeleteDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SkipFinalSnapshot: {
                type: "boolean"
              },
              FinalDBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        DeleteDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {}
            }
          }
        },
        DeleteDBSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {}
            }
          }
        },
        DeleteDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sk"
              }
            }
          }
        },
        DeleteDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName"
            ],
            members: {
              DBSubnetGroupName: {}
            }
          }
        },
        DeleteEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {}
            }
          },
          output: {
            resultWrapper: "DeleteEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        DeleteOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName"
            ],
            members: {
              OptionGroupName: {}
            }
          }
        },
        DescribeDBEngineVersions: {
          input: {
            type: "structure",
            members: {
              Engine: {},
              EngineVersion: {},
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              DefaultOnly: {
                type: "boolean"
              },
              ListSupportedCharacterSets: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBEngineVersionsResult",
            type: "structure",
            members: {
              Marker: {},
              DBEngineVersions: {
                type: "list",
                member: {
                  locationName: "DBEngineVersion",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBParameterGroupFamily: {},
                    DBEngineDescription: {},
                    DBEngineVersionDescription: {},
                    DefaultCharacterSet: {
                      shape: "S2d"
                    },
                    SupportedCharacterSets: {
                      type: "list",
                      member: {
                        shape: "S2d",
                        locationName: "CharacterSet"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeDBInstances: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              DBInstances: {
                type: "list",
                member: {
                  shape: "St",
                  locationName: "DBInstance"
                }
              }
            }
          }
        },
        DescribeDBLogFiles: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              FilenameContains: {},
              FileLastWritten: {
                type: "long"
              },
              FileSize: {
                type: "long"
              },
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBLogFilesResult",
            type: "structure",
            members: {
              DescribeDBLogFiles: {
                type: "list",
                member: {
                  locationName: "DescribeDBLogFilesDetails",
                  type: "structure",
                  members: {
                    LogFileName: {},
                    LastWritten: {
                      type: "long"
                    },
                    Size: {
                      type: "long"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeDBParameterGroups: {
          input: {
            type: "structure",
            members: {
              DBParameterGroupName: {},
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBParameterGroups: {
                type: "list",
                member: {
                  shape: "S1f",
                  locationName: "DBParameterGroup"
                }
              }
            }
          }
        },
        DescribeDBParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              Source: {},
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParametersResult",
            type: "structure",
            members: {
              Parameters: {
                shape: "S2s"
              },
              Marker: {}
            }
          }
        },
        DescribeDBSecurityGroups: {
          input: {
            type: "structure",
            members: {
              DBSecurityGroupName: {},
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSecurityGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSecurityGroups: {
                type: "list",
                member: {
                  shape: "Sd",
                  locationName: "DBSecurityGroup"
                }
              }
            }
          }
        },
        DescribeDBSnapshots: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              SnapshotType: {},
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSnapshotsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSnapshots: {
                type: "list",
                member: {
                  shape: "Sk",
                  locationName: "DBSnapshot"
                }
              }
            }
          }
        },
        DescribeDBSubnetGroups: {
          input: {
            type: "structure",
            members: {
              DBSubnetGroupName: {},
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSubnetGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSubnetGroups: {
                type: "list",
                member: {
                  shape: "S11",
                  locationName: "DBSubnetGroup"
                }
              }
            }
          }
        },
        DescribeEngineDefaultParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupFamily"
            ],
            members: {
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEngineDefaultParametersResult",
            type: "structure",
            members: {
              EngineDefaults: {
                type: "structure",
                members: {
                  DBParameterGroupFamily: {},
                  Marker: {},
                  Parameters: {
                    shape: "S2s"
                  }
                },
                wrapper: true
              }
            }
          }
        },
        DescribeEventCategories: {
          input: {
            type: "structure",
            members: {
              SourceType: {},
              Filters: {
                shape: "S27"
              }
            }
          },
          output: {
            resultWrapper: "DescribeEventCategoriesResult",
            type: "structure",
            members: {
              EventCategoriesMapList: {
                type: "list",
                member: {
                  locationName: "EventCategoriesMap",
                  type: "structure",
                  members: {
                    SourceType: {},
                    EventCategories: {
                      shape: "S6"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeEventSubscriptions: {
          input: {
            type: "structure",
            members: {
              SubscriptionName: {},
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventSubscriptionsResult",
            type: "structure",
            members: {
              Marker: {},
              EventSubscriptionsList: {
                type: "list",
                member: {
                  shape: "S4",
                  locationName: "EventSubscription"
                }
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceIdentifier: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              EventCategories: {
                shape: "S6"
              },
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventsResult",
            type: "structure",
            members: {
              Marker: {},
              Events: {
                type: "list",
                member: {
                  locationName: "Event",
                  type: "structure",
                  members: {
                    SourceIdentifier: {},
                    SourceType: {},
                    Message: {},
                    EventCategories: {
                      shape: "S6"
                    },
                    Date: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeOptionGroupOptions: {
          input: {
            type: "structure",
            required: [
              "EngineName"
            ],
            members: {
              EngineName: {},
              MajorEngineVersion: {},
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOptionGroupOptionsResult",
            type: "structure",
            members: {
              OptionGroupOptions: {
                type: "list",
                member: {
                  locationName: "OptionGroupOption",
                  type: "structure",
                  members: {
                    Name: {},
                    Description: {},
                    EngineName: {},
                    MajorEngineVersion: {},
                    MinimumRequiredMinorEngineVersion: {},
                    PortRequired: {
                      type: "boolean"
                    },
                    DefaultPort: {
                      type: "integer"
                    },
                    OptionsDependedOn: {
                      type: "list",
                      member: {
                        locationName: "OptionName"
                      }
                    },
                    Persistent: {
                      type: "boolean"
                    },
                    Permanent: {
                      type: "boolean"
                    },
                    OptionGroupOptionSettings: {
                      type: "list",
                      member: {
                        locationName: "OptionGroupOptionSetting",
                        type: "structure",
                        members: {
                          SettingName: {},
                          SettingDescription: {},
                          DefaultValue: {},
                          ApplyType: {},
                          AllowedValues: {},
                          IsModifiable: {
                            type: "boolean"
                          }
                        }
                      }
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOptionGroups: {
          input: {
            type: "structure",
            members: {
              OptionGroupName: {},
              Filters: {
                shape: "S27"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              },
              EngineName: {},
              MajorEngineVersion: {}
            }
          },
          output: {
            resultWrapper: "DescribeOptionGroupsResult",
            type: "structure",
            members: {
              OptionGroupsList: {
                type: "list",
                member: {
                  shape: "S1r",
                  locationName: "OptionGroup"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOrderableDBInstanceOptions: {
          input: {
            type: "structure",
            required: [
              "Engine"
            ],
            members: {
              Engine: {},
              EngineVersion: {},
              DBInstanceClass: {},
              LicenseModel: {},
              Vpc: {
                type: "boolean"
              },
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOrderableDBInstanceOptionsResult",
            type: "structure",
            members: {
              OrderableDBInstanceOptions: {
                type: "list",
                member: {
                  locationName: "OrderableDBInstanceOption",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBInstanceClass: {},
                    LicenseModel: {},
                    AvailabilityZones: {
                      type: "list",
                      member: {
                        shape: "S14",
                        locationName: "AvailabilityZone"
                      }
                    },
                    MultiAZCapable: {
                      type: "boolean"
                    },
                    ReadReplicaCapable: {
                      type: "boolean"
                    },
                    Vpc: {
                      type: "boolean"
                    }
                  },
                  wrapper: true
                }
              },
              Marker: {}
            }
          }
        },
        DescribeReservedDBInstances: {
          input: {
            type: "structure",
            members: {
              ReservedDBInstanceId: {},
              ReservedDBInstancesOfferingId: {},
              DBInstanceClass: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MultiAZ: {
                type: "boolean"
              },
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedDBInstances: {
                type: "list",
                member: {
                  shape: "S41",
                  locationName: "ReservedDBInstance"
                }
              }
            }
          }
        },
        DescribeReservedDBInstancesOfferings: {
          input: {
            type: "structure",
            members: {
              ReservedDBInstancesOfferingId: {},
              DBInstanceClass: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MultiAZ: {
                type: "boolean"
              },
              Filters: {
                shape: "S27"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedDBInstancesOfferingsResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedDBInstancesOfferings: {
                type: "list",
                member: {
                  locationName: "ReservedDBInstancesOffering",
                  type: "structure",
                  members: {
                    ReservedDBInstancesOfferingId: {},
                    DBInstanceClass: {},
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    UsagePrice: {
                      type: "double"
                    },
                    CurrencyCode: {},
                    ProductDescription: {},
                    OfferingType: {},
                    MultiAZ: {
                      type: "boolean"
                    },
                    RecurringCharges: {
                      shape: "S43"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DownloadDBLogFilePortion: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "LogFileName"
            ],
            members: {
              DBInstanceIdentifier: {},
              LogFileName: {},
              Marker: {},
              NumberOfLines: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DownloadDBLogFilePortionResult",
            type: "structure",
            members: {
              LogFileData: {},
              Marker: {},
              AdditionalDataPending: {
                type: "boolean"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName"
            ],
            members: {
              ResourceName: {},
              Filters: {
                shape: "S27"
              }
            }
          },
          output: {
            resultWrapper: "ListTagsForResourceResult",
            type: "structure",
            members: {
              TagList: {
                shape: "S9"
              }
            }
          }
        },
        ModifyDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              DBSecurityGroups: {
                shape: "Sp"
              },
              VpcSecurityGroupIds: {
                shape: "Sq"
              },
              ApplyImmediately: {
                type: "boolean"
              },
              MasterUserPassword: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              NewDBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "ModifyDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        ModifyDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "Parameters"
            ],
            members: {
              DBParameterGroupName: {},
              Parameters: {
                shape: "S2s"
              }
            }
          },
          output: {
            shape: "S4g",
            resultWrapper: "ModifyDBParameterGroupResult"
          }
        },
        ModifyDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S1l"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S11"
              }
            }
          }
        },
        ModifyEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S6"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        ModifyOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName"
            ],
            members: {
              OptionGroupName: {},
              OptionsToInclude: {
                type: "list",
                member: {
                  locationName: "OptionConfiguration",
                  type: "structure",
                  required: [
                    "OptionName"
                  ],
                  members: {
                    OptionName: {},
                    Port: {
                      type: "integer"
                    },
                    DBSecurityGroupMemberships: {
                      shape: "Sp"
                    },
                    VpcSecurityGroupMemberships: {
                      shape: "Sq"
                    },
                    OptionSettings: {
                      type: "list",
                      member: {
                        shape: "S1v",
                        locationName: "OptionSetting"
                      }
                    }
                  }
                }
              },
              OptionsToRemove: {
                type: "list",
                member: {}
              },
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "S1r"
              }
            }
          }
        },
        PromoteReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {}
            }
          },
          output: {
            resultWrapper: "PromoteReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        PurchaseReservedDBInstancesOffering: {
          input: {
            type: "structure",
            required: [
              "ReservedDBInstancesOfferingId"
            ],
            members: {
              ReservedDBInstancesOfferingId: {},
              ReservedDBInstanceId: {},
              DBInstanceCount: {
                type: "integer"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "PurchaseReservedDBInstancesOfferingResult",
            type: "structure",
            members: {
              ReservedDBInstance: {
                shape: "S41"
              }
            }
          }
        },
        RebootDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              ForceFailover: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RebootDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        RemoveSourceIdentifierFromSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RemoveSourceIdentifierFromSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "TagKeys"
            ],
            members: {
              ResourceName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ResetDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              Parameters: {
                shape: "S2s"
              }
            }
          },
          output: {
            shape: "S4g",
            resultWrapper: "ResetDBParameterGroupResult"
          }
        },
        RestoreDBInstanceFromDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "DBSnapshotIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              DBInstanceClass: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              MultiAZ: {
                type: "boolean"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              DBName: {},
              Engine: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceFromDBSnapshotResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        RestoreDBInstanceToPointInTime: {
          input: {
            type: "structure",
            required: [
              "SourceDBInstanceIdentifier",
              "TargetDBInstanceIdentifier"
            ],
            members: {
              SourceDBInstanceIdentifier: {},
              TargetDBInstanceIdentifier: {},
              RestoreTime: {
                type: "timestamp"
              },
              UseLatestRestorableTime: {
                type: "boolean"
              },
              DBInstanceClass: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              MultiAZ: {
                type: "boolean"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              DBName: {},
              Engine: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceToPointInTimeResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "St"
              }
            }
          }
        },
        RevokeDBSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupId: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "RevokeDBSecurityGroupIngressResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            CustomerAwsId: {},
            CustSubscriptionId: {},
            SnsTopicArn: {},
            Status: {},
            SubscriptionCreationTime: {},
            SourceType: {},
            SourceIdsList: {
              shape: "S5"
            },
            EventCategoriesList: {
              shape: "S6"
            },
            Enabled: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S5: {
          type: "list",
          member: {
            locationName: "SourceId"
          }
        },
        S6: {
          type: "list",
          member: {
            locationName: "EventCategory"
          }
        },
        S9: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            OwnerId: {},
            DBSecurityGroupName: {},
            DBSecurityGroupDescription: {},
            VpcId: {},
            EC2SecurityGroups: {
              type: "list",
              member: {
                locationName: "EC2SecurityGroup",
                type: "structure",
                members: {
                  Status: {},
                  EC2SecurityGroupName: {},
                  EC2SecurityGroupId: {},
                  EC2SecurityGroupOwnerId: {}
                }
              }
            },
            IPRanges: {
              type: "list",
              member: {
                locationName: "IPRange",
                type: "structure",
                members: {
                  Status: {},
                  CIDRIP: {}
                }
              }
            }
          },
          wrapper: true
        },
        Sk: {
          type: "structure",
          members: {
            DBSnapshotIdentifier: {},
            DBInstanceIdentifier: {},
            SnapshotCreateTime: {
              type: "timestamp"
            },
            Engine: {},
            AllocatedStorage: {
              type: "integer"
            },
            Status: {},
            Port: {
              type: "integer"
            },
            AvailabilityZone: {},
            VpcId: {},
            InstanceCreateTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            EngineVersion: {},
            LicenseModel: {},
            SnapshotType: {},
            Iops: {
              type: "integer"
            },
            OptionGroupName: {},
            PercentProgress: {
              type: "integer"
            },
            SourceRegion: {}
          },
          wrapper: true
        },
        Sp: {
          type: "list",
          member: {
            locationName: "DBSecurityGroupName"
          }
        },
        Sq: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupId"
          }
        },
        St: {
          type: "structure",
          members: {
            DBInstanceIdentifier: {},
            DBInstanceClass: {},
            Engine: {},
            DBInstanceStatus: {},
            MasterUsername: {},
            DBName: {},
            Endpoint: {
              type: "structure",
              members: {
                Address: {},
                Port: {
                  type: "integer"
                }
              }
            },
            AllocatedStorage: {
              type: "integer"
            },
            InstanceCreateTime: {
              type: "timestamp"
            },
            PreferredBackupWindow: {},
            BackupRetentionPeriod: {
              type: "integer"
            },
            DBSecurityGroups: {
              shape: "Sv"
            },
            VpcSecurityGroups: {
              shape: "Sx"
            },
            DBParameterGroups: {
              type: "list",
              member: {
                locationName: "DBParameterGroup",
                type: "structure",
                members: {
                  DBParameterGroupName: {},
                  ParameterApplyStatus: {}
                }
              }
            },
            AvailabilityZone: {},
            DBSubnetGroup: {
              shape: "S11"
            },
            PreferredMaintenanceWindow: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                DBInstanceClass: {},
                AllocatedStorage: {
                  type: "integer"
                },
                MasterUserPassword: {},
                Port: {
                  type: "integer"
                },
                BackupRetentionPeriod: {
                  type: "integer"
                },
                MultiAZ: {
                  type: "boolean"
                },
                EngineVersion: {},
                Iops: {
                  type: "integer"
                },
                DBInstanceIdentifier: {}
              }
            },
            LatestRestorableTime: {
              type: "timestamp"
            },
            MultiAZ: {
              type: "boolean"
            },
            EngineVersion: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            ReadReplicaSourceDBInstanceIdentifier: {},
            ReadReplicaDBInstanceIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaDBInstanceIdentifier"
              }
            },
            LicenseModel: {},
            Iops: {
              type: "integer"
            },
            OptionGroupMemberships: {
              type: "list",
              member: {
                locationName: "OptionGroupMembership",
                type: "structure",
                members: {
                  OptionGroupName: {},
                  Status: {}
                }
              }
            },
            CharacterSetName: {},
            SecondaryAvailabilityZone: {},
            PubliclyAccessible: {
              type: "boolean"
            },
            StatusInfos: {
              type: "list",
              member: {
                locationName: "DBInstanceStatusInfo",
                type: "structure",
                members: {
                  StatusType: {},
                  Normal: {
                    type: "boolean"
                  },
                  Status: {},
                  Message: {}
                }
              }
            }
          },
          wrapper: true
        },
        Sv: {
          type: "list",
          member: {
            locationName: "DBSecurityGroup",
            type: "structure",
            members: {
              DBSecurityGroupName: {},
              Status: {}
            }
          }
        },
        Sx: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupMembership",
            type: "structure",
            members: {
              VpcSecurityGroupId: {},
              Status: {}
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            DBSubnetGroupName: {},
            DBSubnetGroupDescription: {},
            VpcId: {},
            SubnetGroupStatus: {},
            Subnets: {
              type: "list",
              member: {
                locationName: "Subnet",
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {
                    shape: "S14"
                  },
                  SubnetStatus: {}
                }
              }
            }
          },
          wrapper: true
        },
        S14: {
          type: "structure",
          members: {
            Name: {},
            ProvisionedIopsCapable: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S1f: {
          type: "structure",
          members: {
            DBParameterGroupName: {},
            DBParameterGroupFamily: {},
            Description: {}
          },
          wrapper: true
        },
        S1l: {
          type: "list",
          member: {
            locationName: "SubnetIdentifier"
          }
        },
        S1r: {
          type: "structure",
          members: {
            OptionGroupName: {},
            OptionGroupDescription: {},
            EngineName: {},
            MajorEngineVersion: {},
            Options: {
              type: "list",
              member: {
                locationName: "Option",
                type: "structure",
                members: {
                  OptionName: {},
                  OptionDescription: {},
                  Persistent: {
                    type: "boolean"
                  },
                  Permanent: {
                    type: "boolean"
                  },
                  Port: {
                    type: "integer"
                  },
                  OptionSettings: {
                    type: "list",
                    member: {
                      shape: "S1v",
                      locationName: "OptionSetting"
                    }
                  },
                  DBSecurityGroupMemberships: {
                    shape: "Sv"
                  },
                  VpcSecurityGroupMemberships: {
                    shape: "Sx"
                  }
                }
              }
            },
            AllowsVpcAndNonVpcInstanceMemberships: {
              type: "boolean"
            },
            VpcId: {}
          },
          wrapper: true
        },
        S1v: {
          type: "structure",
          members: {
            Name: {},
            Value: {},
            DefaultValue: {},
            Description: {},
            ApplyType: {},
            DataType: {},
            AllowedValues: {},
            IsModifiable: {
              type: "boolean"
            },
            IsCollection: {
              type: "boolean"
            }
          }
        },
        S27: {
          type: "list",
          member: {
            locationName: "Filter",
            type: "structure",
            required: [
              "Name",
              "Values"
            ],
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {
                  locationName: "Value"
                }
              }
            }
          }
        },
        S2d: {
          type: "structure",
          members: {
            CharacterSetName: {},
            CharacterSetDescription: {}
          }
        },
        S2s: {
          type: "list",
          member: {
            locationName: "Parameter",
            type: "structure",
            members: {
              ParameterName: {},
              ParameterValue: {},
              Description: {},
              Source: {},
              ApplyType: {},
              DataType: {},
              AllowedValues: {},
              IsModifiable: {
                type: "boolean"
              },
              MinimumEngineVersion: {},
              ApplyMethod: {}
            }
          }
        },
        S41: {
          type: "structure",
          members: {
            ReservedDBInstanceId: {},
            ReservedDBInstancesOfferingId: {},
            DBInstanceClass: {},
            StartTime: {
              type: "timestamp"
            },
            Duration: {
              type: "integer"
            },
            FixedPrice: {
              type: "double"
            },
            UsagePrice: {
              type: "double"
            },
            CurrencyCode: {},
            DBInstanceCount: {
              type: "integer"
            },
            ProductDescription: {},
            OfferingType: {},
            MultiAZ: {
              type: "boolean"
            },
            State: {},
            RecurringCharges: {
              shape: "S43"
            }
          },
          wrapper: true
        },
        S43: {
          type: "list",
          member: {
            locationName: "RecurringCharge",
            type: "structure",
            members: {
              RecurringChargeAmount: {
                type: "double"
              },
              RecurringChargeFrequency: {}
            },
            wrapper: true
          }
        },
        S4g: {
          type: "structure",
          members: {
            DBParameterGroupName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-2013-09-09.paginators.json
var require_rds_2013_09_09_paginators = __commonJS({
  "node_modules/aws-sdk/apis/rds-2013-09-09.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeDBEngineVersions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBEngineVersions"
        },
        DescribeDBInstances: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBInstances"
        },
        DescribeDBLogFiles: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DescribeDBLogFiles"
        },
        DescribeDBParameterGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBParameterGroups"
        },
        DescribeDBParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Parameters"
        },
        DescribeDBSecurityGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSecurityGroups"
        },
        DescribeDBSnapshots: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSnapshots"
        },
        DescribeDBSubnetGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSubnetGroups"
        },
        DescribeEngineDefaultParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "EngineDefaults.Marker",
          result_key: "EngineDefaults.Parameters"
        },
        DescribeEventSubscriptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "EventSubscriptionsList"
        },
        DescribeEvents: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Events"
        },
        DescribeOptionGroupOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OptionGroupOptions"
        },
        DescribeOptionGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OptionGroupsList"
        },
        DescribeOrderableDBInstanceOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OrderableDBInstanceOptions"
        },
        DescribeReservedDBInstances: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedDBInstances"
        },
        DescribeReservedDBInstancesOfferings: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedDBInstancesOfferings"
        },
        DownloadDBLogFilePortion: {
          input_token: "Marker",
          limit_key: "NumberOfLines",
          more_results: "AdditionalDataPending",
          output_token: "Marker",
          result_key: "LogFileData"
        },
        ListTagsForResource: {
          result_key: "TagList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-2013-09-09.waiters2.json
var require_rds_2013_09_09_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/rds-2013-09-09.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DBInstanceAvailable: {
          delay: 30,
          operation: "DescribeDBInstances",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "deleting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "failed",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "incompatible-restore",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "incompatible-parameters",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "incompatible-parameters",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "incompatible-restore",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            }
          ]
        },
        DBInstanceDeleted: {
          delay: 30,
          operation: "DescribeDBInstances",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "deleted",
              matcher: "pathAll",
              state: "success",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "creating",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "modifying",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "rebooting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "resetting-master-credentials",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-2014-09-01.min.json
var require_rds_2014_09_01_min = __commonJS({
  "node_modules/aws-sdk/apis/rds-2014-09-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-09-01",
        endpointPrefix: "rds",
        protocol: "query",
        serviceAbbreviation: "Amazon RDS",
        serviceFullName: "Amazon Relational Database Service",
        serviceId: "RDS",
        signatureVersion: "v4",
        uid: "rds-2014-09-01",
        xmlNamespace: "http://rds.amazonaws.com/doc/2014-09-01/"
      },
      operations: {
        AddSourceIdentifierToSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "AddSourceIdentifierToSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "Tags"
            ],
            members: {
              ResourceName: {},
              Tags: {
                shape: "S9"
              }
            }
          }
        },
        AuthorizeDBSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupId: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "AuthorizeDBSecurityGroupIngressResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        },
        CopyDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "SourceDBParameterGroupIdentifier",
              "TargetDBParameterGroupIdentifier",
              "TargetDBParameterGroupDescription"
            ],
            members: {
              SourceDBParameterGroupIdentifier: {},
              TargetDBParameterGroupIdentifier: {},
              TargetDBParameterGroupDescription: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CopyDBParameterGroupResult",
            type: "structure",
            members: {
              DBParameterGroup: {
                shape: "Sk"
              }
            }
          }
        },
        CopyDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceDBSnapshotIdentifier",
              "TargetDBSnapshotIdentifier"
            ],
            members: {
              SourceDBSnapshotIdentifier: {},
              TargetDBSnapshotIdentifier: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CopyDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sn"
              }
            }
          }
        },
        CopyOptionGroup: {
          input: {
            type: "structure",
            required: [
              "SourceOptionGroupIdentifier",
              "TargetOptionGroupIdentifier",
              "TargetOptionGroupDescription"
            ],
            members: {
              SourceOptionGroupIdentifier: {},
              TargetOptionGroupIdentifier: {},
              TargetOptionGroupDescription: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CopyOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "St"
              }
            }
          }
        },
        CreateDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "AllocatedStorage",
              "DBInstanceClass",
              "Engine",
              "MasterUsername",
              "MasterUserPassword"
            ],
            members: {
              DBName: {},
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              Engine: {},
              MasterUsername: {},
              MasterUserPassword: {},
              DBSecurityGroups: {
                shape: "S13"
              },
              VpcSecurityGroupIds: {
                shape: "S14"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              PreferredMaintenanceWindow: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              Port: {
                type: "integer"
              },
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              CharacterSetName: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              },
              StorageType: {},
              TdeCredentialArn: {},
              TdeCredentialPassword: {}
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S17"
              }
            }
          }
        },
        CreateDBInstanceReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "SourceDBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SourceDBInstanceIdentifier: {},
              DBInstanceClass: {},
              AvailabilityZone: {},
              Port: {
                type: "integer"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              },
              DBSubnetGroupName: {},
              StorageType: {}
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S17"
              }
            }
          }
        },
        CreateDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "DBParameterGroupFamily",
              "Description"
            ],
            members: {
              DBParameterGroupName: {},
              DBParameterGroupFamily: {},
              Description: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBParameterGroupResult",
            type: "structure",
            members: {
              DBParameterGroup: {
                shape: "Sk"
              }
            }
          }
        },
        CreateDBSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName",
              "DBSecurityGroupDescription"
            ],
            members: {
              DBSecurityGroupName: {},
              DBSecurityGroupDescription: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSecurityGroupResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        },
        CreateDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier",
              "DBInstanceIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {},
              DBInstanceIdentifier: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sn"
              }
            }
          }
        },
        CreateDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "DBSubnetGroupDescription",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S1u"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S1b"
              }
            }
          }
        },
        CreateEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SnsTopicArn"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S6"
              },
              SourceIds: {
                shape: "S5"
              },
              Enabled: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        CreateOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName",
              "EngineName",
              "MajorEngineVersion",
              "OptionGroupDescription"
            ],
            members: {
              OptionGroupName: {},
              EngineName: {},
              MajorEngineVersion: {},
              OptionGroupDescription: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "St"
              }
            }
          }
        },
        DeleteDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SkipFinalSnapshot: {
                type: "boolean"
              },
              FinalDBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S17"
              }
            }
          }
        },
        DeleteDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {}
            }
          }
        },
        DeleteDBSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {}
            }
          }
        },
        DeleteDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "Sn"
              }
            }
          }
        },
        DeleteDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName"
            ],
            members: {
              DBSubnetGroupName: {}
            }
          }
        },
        DeleteEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {}
            }
          },
          output: {
            resultWrapper: "DeleteEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        DeleteOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName"
            ],
            members: {
              OptionGroupName: {}
            }
          }
        },
        DescribeDBEngineVersions: {
          input: {
            type: "structure",
            members: {
              Engine: {},
              EngineVersion: {},
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              DefaultOnly: {
                type: "boolean"
              },
              ListSupportedCharacterSets: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBEngineVersionsResult",
            type: "structure",
            members: {
              Marker: {},
              DBEngineVersions: {
                type: "list",
                member: {
                  locationName: "DBEngineVersion",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBParameterGroupFamily: {},
                    DBEngineDescription: {},
                    DBEngineVersionDescription: {},
                    DefaultCharacterSet: {
                      shape: "S2h"
                    },
                    SupportedCharacterSets: {
                      type: "list",
                      member: {
                        shape: "S2h",
                        locationName: "CharacterSet"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeDBInstances: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              DBInstances: {
                type: "list",
                member: {
                  shape: "S17",
                  locationName: "DBInstance"
                }
              }
            }
          }
        },
        DescribeDBLogFiles: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              FilenameContains: {},
              FileLastWritten: {
                type: "long"
              },
              FileSize: {
                type: "long"
              },
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBLogFilesResult",
            type: "structure",
            members: {
              DescribeDBLogFiles: {
                type: "list",
                member: {
                  locationName: "DescribeDBLogFilesDetails",
                  type: "structure",
                  members: {
                    LogFileName: {},
                    LastWritten: {
                      type: "long"
                    },
                    Size: {
                      type: "long"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeDBParameterGroups: {
          input: {
            type: "structure",
            members: {
              DBParameterGroupName: {},
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBParameterGroups: {
                type: "list",
                member: {
                  shape: "Sk",
                  locationName: "DBParameterGroup"
                }
              }
            }
          }
        },
        DescribeDBParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              Source: {},
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParametersResult",
            type: "structure",
            members: {
              Parameters: {
                shape: "S2w"
              },
              Marker: {}
            }
          }
        },
        DescribeDBSecurityGroups: {
          input: {
            type: "structure",
            members: {
              DBSecurityGroupName: {},
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSecurityGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSecurityGroups: {
                type: "list",
                member: {
                  shape: "Sd",
                  locationName: "DBSecurityGroup"
                }
              }
            }
          }
        },
        DescribeDBSnapshots: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              SnapshotType: {},
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSnapshotsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSnapshots: {
                type: "list",
                member: {
                  shape: "Sn",
                  locationName: "DBSnapshot"
                }
              }
            }
          }
        },
        DescribeDBSubnetGroups: {
          input: {
            type: "structure",
            members: {
              DBSubnetGroupName: {},
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSubnetGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSubnetGroups: {
                type: "list",
                member: {
                  shape: "S1b",
                  locationName: "DBSubnetGroup"
                }
              }
            }
          }
        },
        DescribeEngineDefaultParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupFamily"
            ],
            members: {
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEngineDefaultParametersResult",
            type: "structure",
            members: {
              EngineDefaults: {
                type: "structure",
                members: {
                  DBParameterGroupFamily: {},
                  Marker: {},
                  Parameters: {
                    shape: "S2w"
                  }
                },
                wrapper: true
              }
            }
          }
        },
        DescribeEventCategories: {
          input: {
            type: "structure",
            members: {
              SourceType: {},
              Filters: {
                shape: "S2b"
              }
            }
          },
          output: {
            resultWrapper: "DescribeEventCategoriesResult",
            type: "structure",
            members: {
              EventCategoriesMapList: {
                type: "list",
                member: {
                  locationName: "EventCategoriesMap",
                  type: "structure",
                  members: {
                    SourceType: {},
                    EventCategories: {
                      shape: "S6"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeEventSubscriptions: {
          input: {
            type: "structure",
            members: {
              SubscriptionName: {},
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventSubscriptionsResult",
            type: "structure",
            members: {
              Marker: {},
              EventSubscriptionsList: {
                type: "list",
                member: {
                  shape: "S4",
                  locationName: "EventSubscription"
                }
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceIdentifier: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              EventCategories: {
                shape: "S6"
              },
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventsResult",
            type: "structure",
            members: {
              Marker: {},
              Events: {
                type: "list",
                member: {
                  locationName: "Event",
                  type: "structure",
                  members: {
                    SourceIdentifier: {},
                    SourceType: {},
                    Message: {},
                    EventCategories: {
                      shape: "S6"
                    },
                    Date: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeOptionGroupOptions: {
          input: {
            type: "structure",
            required: [
              "EngineName"
            ],
            members: {
              EngineName: {},
              MajorEngineVersion: {},
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOptionGroupOptionsResult",
            type: "structure",
            members: {
              OptionGroupOptions: {
                type: "list",
                member: {
                  locationName: "OptionGroupOption",
                  type: "structure",
                  members: {
                    Name: {},
                    Description: {},
                    EngineName: {},
                    MajorEngineVersion: {},
                    MinimumRequiredMinorEngineVersion: {},
                    PortRequired: {
                      type: "boolean"
                    },
                    DefaultPort: {
                      type: "integer"
                    },
                    OptionsDependedOn: {
                      type: "list",
                      member: {
                        locationName: "OptionName"
                      }
                    },
                    Persistent: {
                      type: "boolean"
                    },
                    Permanent: {
                      type: "boolean"
                    },
                    OptionGroupOptionSettings: {
                      type: "list",
                      member: {
                        locationName: "OptionGroupOptionSetting",
                        type: "structure",
                        members: {
                          SettingName: {},
                          SettingDescription: {},
                          DefaultValue: {},
                          ApplyType: {},
                          AllowedValues: {},
                          IsModifiable: {
                            type: "boolean"
                          }
                        }
                      }
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOptionGroups: {
          input: {
            type: "structure",
            members: {
              OptionGroupName: {},
              Filters: {
                shape: "S2b"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              },
              EngineName: {},
              MajorEngineVersion: {}
            }
          },
          output: {
            resultWrapper: "DescribeOptionGroupsResult",
            type: "structure",
            members: {
              OptionGroupsList: {
                type: "list",
                member: {
                  shape: "St",
                  locationName: "OptionGroup"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOrderableDBInstanceOptions: {
          input: {
            type: "structure",
            required: [
              "Engine"
            ],
            members: {
              Engine: {},
              EngineVersion: {},
              DBInstanceClass: {},
              LicenseModel: {},
              Vpc: {
                type: "boolean"
              },
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOrderableDBInstanceOptionsResult",
            type: "structure",
            members: {
              OrderableDBInstanceOptions: {
                type: "list",
                member: {
                  locationName: "OrderableDBInstanceOption",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBInstanceClass: {},
                    LicenseModel: {},
                    AvailabilityZones: {
                      type: "list",
                      member: {
                        shape: "S1e",
                        locationName: "AvailabilityZone"
                      }
                    },
                    MultiAZCapable: {
                      type: "boolean"
                    },
                    ReadReplicaCapable: {
                      type: "boolean"
                    },
                    Vpc: {
                      type: "boolean"
                    },
                    StorageType: {},
                    SupportsIops: {
                      type: "boolean"
                    }
                  },
                  wrapper: true
                }
              },
              Marker: {}
            }
          }
        },
        DescribeReservedDBInstances: {
          input: {
            type: "structure",
            members: {
              ReservedDBInstanceId: {},
              ReservedDBInstancesOfferingId: {},
              DBInstanceClass: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MultiAZ: {
                type: "boolean"
              },
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedDBInstances: {
                type: "list",
                member: {
                  shape: "S45",
                  locationName: "ReservedDBInstance"
                }
              }
            }
          }
        },
        DescribeReservedDBInstancesOfferings: {
          input: {
            type: "structure",
            members: {
              ReservedDBInstancesOfferingId: {},
              DBInstanceClass: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MultiAZ: {
                type: "boolean"
              },
              Filters: {
                shape: "S2b"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedDBInstancesOfferingsResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedDBInstancesOfferings: {
                type: "list",
                member: {
                  locationName: "ReservedDBInstancesOffering",
                  type: "structure",
                  members: {
                    ReservedDBInstancesOfferingId: {},
                    DBInstanceClass: {},
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    UsagePrice: {
                      type: "double"
                    },
                    CurrencyCode: {},
                    ProductDescription: {},
                    OfferingType: {},
                    MultiAZ: {
                      type: "boolean"
                    },
                    RecurringCharges: {
                      shape: "S47"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DownloadDBLogFilePortion: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "LogFileName"
            ],
            members: {
              DBInstanceIdentifier: {},
              LogFileName: {},
              Marker: {},
              NumberOfLines: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DownloadDBLogFilePortionResult",
            type: "structure",
            members: {
              LogFileData: {},
              Marker: {},
              AdditionalDataPending: {
                type: "boolean"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName"
            ],
            members: {
              ResourceName: {},
              Filters: {
                shape: "S2b"
              }
            }
          },
          output: {
            resultWrapper: "ListTagsForResourceResult",
            type: "structure",
            members: {
              TagList: {
                shape: "S9"
              }
            }
          }
        },
        ModifyDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              DBSecurityGroups: {
                shape: "S13"
              },
              VpcSecurityGroupIds: {
                shape: "S14"
              },
              ApplyImmediately: {
                type: "boolean"
              },
              MasterUserPassword: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              NewDBInstanceIdentifier: {},
              StorageType: {},
              TdeCredentialArn: {},
              TdeCredentialPassword: {}
            }
          },
          output: {
            resultWrapper: "ModifyDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S17"
              }
            }
          }
        },
        ModifyDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "Parameters"
            ],
            members: {
              DBParameterGroupName: {},
              Parameters: {
                shape: "S2w"
              }
            }
          },
          output: {
            shape: "S4k",
            resultWrapper: "ModifyDBParameterGroupResult"
          }
        },
        ModifyDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S1u"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S1b"
              }
            }
          }
        },
        ModifyEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S6"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        ModifyOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName"
            ],
            members: {
              OptionGroupName: {},
              OptionsToInclude: {
                type: "list",
                member: {
                  locationName: "OptionConfiguration",
                  type: "structure",
                  required: [
                    "OptionName"
                  ],
                  members: {
                    OptionName: {},
                    Port: {
                      type: "integer"
                    },
                    DBSecurityGroupMemberships: {
                      shape: "S13"
                    },
                    VpcSecurityGroupMemberships: {
                      shape: "S14"
                    },
                    OptionSettings: {
                      type: "list",
                      member: {
                        shape: "Sx",
                        locationName: "OptionSetting"
                      }
                    }
                  }
                }
              },
              OptionsToRemove: {
                type: "list",
                member: {}
              },
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "St"
              }
            }
          }
        },
        PromoteReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {}
            }
          },
          output: {
            resultWrapper: "PromoteReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S17"
              }
            }
          }
        },
        PurchaseReservedDBInstancesOffering: {
          input: {
            type: "structure",
            required: [
              "ReservedDBInstancesOfferingId"
            ],
            members: {
              ReservedDBInstancesOfferingId: {},
              ReservedDBInstanceId: {},
              DBInstanceCount: {
                type: "integer"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "PurchaseReservedDBInstancesOfferingResult",
            type: "structure",
            members: {
              ReservedDBInstance: {
                shape: "S45"
              }
            }
          }
        },
        RebootDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              ForceFailover: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RebootDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S17"
              }
            }
          }
        },
        RemoveSourceIdentifierFromSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RemoveSourceIdentifierFromSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "TagKeys"
            ],
            members: {
              ResourceName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ResetDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              Parameters: {
                shape: "S2w"
              }
            }
          },
          output: {
            shape: "S4k",
            resultWrapper: "ResetDBParameterGroupResult"
          }
        },
        RestoreDBInstanceFromDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "DBSnapshotIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              DBInstanceClass: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              MultiAZ: {
                type: "boolean"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              DBName: {},
              Engine: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              Tags: {
                shape: "S9"
              },
              StorageType: {},
              TdeCredentialArn: {},
              TdeCredentialPassword: {}
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceFromDBSnapshotResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S17"
              }
            }
          }
        },
        RestoreDBInstanceToPointInTime: {
          input: {
            type: "structure",
            required: [
              "SourceDBInstanceIdentifier",
              "TargetDBInstanceIdentifier"
            ],
            members: {
              SourceDBInstanceIdentifier: {},
              TargetDBInstanceIdentifier: {},
              RestoreTime: {
                type: "timestamp"
              },
              UseLatestRestorableTime: {
                type: "boolean"
              },
              DBInstanceClass: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              MultiAZ: {
                type: "boolean"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              DBName: {},
              Engine: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              Tags: {
                shape: "S9"
              },
              StorageType: {},
              TdeCredentialArn: {},
              TdeCredentialPassword: {}
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceToPointInTimeResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S17"
              }
            }
          }
        },
        RevokeDBSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupId: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "RevokeDBSecurityGroupIngressResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sd"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            CustomerAwsId: {},
            CustSubscriptionId: {},
            SnsTopicArn: {},
            Status: {},
            SubscriptionCreationTime: {},
            SourceType: {},
            SourceIdsList: {
              shape: "S5"
            },
            EventCategoriesList: {
              shape: "S6"
            },
            Enabled: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S5: {
          type: "list",
          member: {
            locationName: "SourceId"
          }
        },
        S6: {
          type: "list",
          member: {
            locationName: "EventCategory"
          }
        },
        S9: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            OwnerId: {},
            DBSecurityGroupName: {},
            DBSecurityGroupDescription: {},
            VpcId: {},
            EC2SecurityGroups: {
              type: "list",
              member: {
                locationName: "EC2SecurityGroup",
                type: "structure",
                members: {
                  Status: {},
                  EC2SecurityGroupName: {},
                  EC2SecurityGroupId: {},
                  EC2SecurityGroupOwnerId: {}
                }
              }
            },
            IPRanges: {
              type: "list",
              member: {
                locationName: "IPRange",
                type: "structure",
                members: {
                  Status: {},
                  CIDRIP: {}
                }
              }
            }
          },
          wrapper: true
        },
        Sk: {
          type: "structure",
          members: {
            DBParameterGroupName: {},
            DBParameterGroupFamily: {},
            Description: {}
          },
          wrapper: true
        },
        Sn: {
          type: "structure",
          members: {
            DBSnapshotIdentifier: {},
            DBInstanceIdentifier: {},
            SnapshotCreateTime: {
              type: "timestamp"
            },
            Engine: {},
            AllocatedStorage: {
              type: "integer"
            },
            Status: {},
            Port: {
              type: "integer"
            },
            AvailabilityZone: {},
            VpcId: {},
            InstanceCreateTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            EngineVersion: {},
            LicenseModel: {},
            SnapshotType: {},
            Iops: {
              type: "integer"
            },
            OptionGroupName: {},
            PercentProgress: {
              type: "integer"
            },
            SourceRegion: {},
            StorageType: {},
            TdeCredentialArn: {}
          },
          wrapper: true
        },
        St: {
          type: "structure",
          members: {
            OptionGroupName: {},
            OptionGroupDescription: {},
            EngineName: {},
            MajorEngineVersion: {},
            Options: {
              type: "list",
              member: {
                locationName: "Option",
                type: "structure",
                members: {
                  OptionName: {},
                  OptionDescription: {},
                  Persistent: {
                    type: "boolean"
                  },
                  Permanent: {
                    type: "boolean"
                  },
                  Port: {
                    type: "integer"
                  },
                  OptionSettings: {
                    type: "list",
                    member: {
                      shape: "Sx",
                      locationName: "OptionSetting"
                    }
                  },
                  DBSecurityGroupMemberships: {
                    shape: "Sy"
                  },
                  VpcSecurityGroupMemberships: {
                    shape: "S10"
                  }
                }
              }
            },
            AllowsVpcAndNonVpcInstanceMemberships: {
              type: "boolean"
            },
            VpcId: {}
          },
          wrapper: true
        },
        Sx: {
          type: "structure",
          members: {
            Name: {},
            Value: {},
            DefaultValue: {},
            Description: {},
            ApplyType: {},
            DataType: {},
            AllowedValues: {},
            IsModifiable: {
              type: "boolean"
            },
            IsCollection: {
              type: "boolean"
            }
          }
        },
        Sy: {
          type: "list",
          member: {
            locationName: "DBSecurityGroup",
            type: "structure",
            members: {
              DBSecurityGroupName: {},
              Status: {}
            }
          }
        },
        S10: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupMembership",
            type: "structure",
            members: {
              VpcSecurityGroupId: {},
              Status: {}
            }
          }
        },
        S13: {
          type: "list",
          member: {
            locationName: "DBSecurityGroupName"
          }
        },
        S14: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupId"
          }
        },
        S17: {
          type: "structure",
          members: {
            DBInstanceIdentifier: {},
            DBInstanceClass: {},
            Engine: {},
            DBInstanceStatus: {},
            MasterUsername: {},
            DBName: {},
            Endpoint: {
              type: "structure",
              members: {
                Address: {},
                Port: {
                  type: "integer"
                }
              }
            },
            AllocatedStorage: {
              type: "integer"
            },
            InstanceCreateTime: {
              type: "timestamp"
            },
            PreferredBackupWindow: {},
            BackupRetentionPeriod: {
              type: "integer"
            },
            DBSecurityGroups: {
              shape: "Sy"
            },
            VpcSecurityGroups: {
              shape: "S10"
            },
            DBParameterGroups: {
              type: "list",
              member: {
                locationName: "DBParameterGroup",
                type: "structure",
                members: {
                  DBParameterGroupName: {},
                  ParameterApplyStatus: {}
                }
              }
            },
            AvailabilityZone: {},
            DBSubnetGroup: {
              shape: "S1b"
            },
            PreferredMaintenanceWindow: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                DBInstanceClass: {},
                AllocatedStorage: {
                  type: "integer"
                },
                MasterUserPassword: {},
                Port: {
                  type: "integer"
                },
                BackupRetentionPeriod: {
                  type: "integer"
                },
                MultiAZ: {
                  type: "boolean"
                },
                EngineVersion: {},
                Iops: {
                  type: "integer"
                },
                DBInstanceIdentifier: {},
                StorageType: {}
              }
            },
            LatestRestorableTime: {
              type: "timestamp"
            },
            MultiAZ: {
              type: "boolean"
            },
            EngineVersion: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            ReadReplicaSourceDBInstanceIdentifier: {},
            ReadReplicaDBInstanceIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaDBInstanceIdentifier"
              }
            },
            LicenseModel: {},
            Iops: {
              type: "integer"
            },
            OptionGroupMemberships: {
              type: "list",
              member: {
                locationName: "OptionGroupMembership",
                type: "structure",
                members: {
                  OptionGroupName: {},
                  Status: {}
                }
              }
            },
            CharacterSetName: {},
            SecondaryAvailabilityZone: {},
            PubliclyAccessible: {
              type: "boolean"
            },
            StatusInfos: {
              type: "list",
              member: {
                locationName: "DBInstanceStatusInfo",
                type: "structure",
                members: {
                  StatusType: {},
                  Normal: {
                    type: "boolean"
                  },
                  Status: {},
                  Message: {}
                }
              }
            },
            StorageType: {},
            TdeCredentialArn: {}
          },
          wrapper: true
        },
        S1b: {
          type: "structure",
          members: {
            DBSubnetGroupName: {},
            DBSubnetGroupDescription: {},
            VpcId: {},
            SubnetGroupStatus: {},
            Subnets: {
              type: "list",
              member: {
                locationName: "Subnet",
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {
                    shape: "S1e"
                  },
                  SubnetStatus: {}
                }
              }
            }
          },
          wrapper: true
        },
        S1e: {
          type: "structure",
          members: {
            Name: {}
          },
          wrapper: true
        },
        S1u: {
          type: "list",
          member: {
            locationName: "SubnetIdentifier"
          }
        },
        S2b: {
          type: "list",
          member: {
            locationName: "Filter",
            type: "structure",
            required: [
              "Name",
              "Values"
            ],
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {
                  locationName: "Value"
                }
              }
            }
          }
        },
        S2h: {
          type: "structure",
          members: {
            CharacterSetName: {},
            CharacterSetDescription: {}
          }
        },
        S2w: {
          type: "list",
          member: {
            locationName: "Parameter",
            type: "structure",
            members: {
              ParameterName: {},
              ParameterValue: {},
              Description: {},
              Source: {},
              ApplyType: {},
              DataType: {},
              AllowedValues: {},
              IsModifiable: {
                type: "boolean"
              },
              MinimumEngineVersion: {},
              ApplyMethod: {}
            }
          }
        },
        S45: {
          type: "structure",
          members: {
            ReservedDBInstanceId: {},
            ReservedDBInstancesOfferingId: {},
            DBInstanceClass: {},
            StartTime: {
              type: "timestamp"
            },
            Duration: {
              type: "integer"
            },
            FixedPrice: {
              type: "double"
            },
            UsagePrice: {
              type: "double"
            },
            CurrencyCode: {},
            DBInstanceCount: {
              type: "integer"
            },
            ProductDescription: {},
            OfferingType: {},
            MultiAZ: {
              type: "boolean"
            },
            State: {},
            RecurringCharges: {
              shape: "S47"
            }
          },
          wrapper: true
        },
        S47: {
          type: "list",
          member: {
            locationName: "RecurringCharge",
            type: "structure",
            members: {
              RecurringChargeAmount: {
                type: "double"
              },
              RecurringChargeFrequency: {}
            },
            wrapper: true
          }
        },
        S4k: {
          type: "structure",
          members: {
            DBParameterGroupName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-2014-09-01.paginators.json
var require_rds_2014_09_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/rds-2014-09-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/apis/rds-2014-10-31.min.json
var require_rds_2014_10_31_min = __commonJS({
  "node_modules/aws-sdk/apis/rds-2014-10-31.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-10-31",
        endpointPrefix: "rds",
        protocol: "query",
        serviceAbbreviation: "Amazon RDS",
        serviceFullName: "Amazon Relational Database Service",
        serviceId: "RDS",
        signatureVersion: "v4",
        uid: "rds-2014-10-31",
        xmlNamespace: "http://rds.amazonaws.com/doc/2014-10-31/"
      },
      operations: {
        AddRoleToDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "RoleArn"
            ],
            members: {
              DBClusterIdentifier: {},
              RoleArn: {},
              FeatureName: {}
            }
          }
        },
        AddRoleToDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "RoleArn",
              "FeatureName"
            ],
            members: {
              DBInstanceIdentifier: {},
              RoleArn: {},
              FeatureName: {}
            }
          }
        },
        AddSourceIdentifierToSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "AddSourceIdentifierToSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S6"
              }
            }
          }
        },
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "Tags"
            ],
            members: {
              ResourceName: {},
              Tags: {
                shape: "Sb"
              }
            }
          }
        },
        ApplyPendingMaintenanceAction: {
          input: {
            type: "structure",
            required: [
              "ResourceIdentifier",
              "ApplyAction",
              "OptInType"
            ],
            members: {
              ResourceIdentifier: {},
              ApplyAction: {},
              OptInType: {}
            }
          },
          output: {
            resultWrapper: "ApplyPendingMaintenanceActionResult",
            type: "structure",
            members: {
              ResourcePendingMaintenanceActions: {
                shape: "Sf"
              }
            }
          }
        },
        AuthorizeDBSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupId: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "AuthorizeDBSecurityGroupIngressResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sl"
              }
            }
          }
        },
        BacktrackDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "BacktrackTo"
            ],
            members: {
              DBClusterIdentifier: {},
              BacktrackTo: {
                type: "timestamp"
              },
              Force: {
                type: "boolean"
              },
              UseEarliestTimeOnPointInTimeUnavailable: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "Ss",
            resultWrapper: "BacktrackDBClusterResult"
          }
        },
        CancelExportTask: {
          input: {
            type: "structure",
            required: [
              "ExportTaskIdentifier"
            ],
            members: {
              ExportTaskIdentifier: {}
            }
          },
          output: {
            shape: "Su",
            resultWrapper: "CancelExportTaskResult"
          }
        },
        CopyDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "SourceDBClusterParameterGroupIdentifier",
              "TargetDBClusterParameterGroupIdentifier",
              "TargetDBClusterParameterGroupDescription"
            ],
            members: {
              SourceDBClusterParameterGroupIdentifier: {},
              TargetDBClusterParameterGroupIdentifier: {},
              TargetDBClusterParameterGroupDescription: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CopyDBClusterParameterGroupResult",
            type: "structure",
            members: {
              DBClusterParameterGroup: {
                shape: "Sz"
              }
            }
          }
        },
        CopyDBClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceDBClusterSnapshotIdentifier",
              "TargetDBClusterSnapshotIdentifier"
            ],
            members: {
              SourceDBClusterSnapshotIdentifier: {},
              TargetDBClusterSnapshotIdentifier: {},
              KmsKeyId: {},
              PreSignedUrl: {},
              CopyTags: {
                type: "boolean"
              },
              Tags: {
                shape: "Sb"
              },
              SourceRegion: {}
            }
          },
          output: {
            resultWrapper: "CopyDBClusterSnapshotResult",
            type: "structure",
            members: {
              DBClusterSnapshot: {
                shape: "S12"
              }
            }
          }
        },
        CopyDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "SourceDBParameterGroupIdentifier",
              "TargetDBParameterGroupIdentifier",
              "TargetDBParameterGroupDescription"
            ],
            members: {
              SourceDBParameterGroupIdentifier: {},
              TargetDBParameterGroupIdentifier: {},
              TargetDBParameterGroupDescription: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CopyDBParameterGroupResult",
            type: "structure",
            members: {
              DBParameterGroup: {
                shape: "S16"
              }
            }
          }
        },
        CopyDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceDBSnapshotIdentifier",
              "TargetDBSnapshotIdentifier"
            ],
            members: {
              SourceDBSnapshotIdentifier: {},
              TargetDBSnapshotIdentifier: {},
              KmsKeyId: {},
              Tags: {
                shape: "Sb"
              },
              CopyTags: {
                type: "boolean"
              },
              PreSignedUrl: {},
              OptionGroupName: {},
              TargetCustomAvailabilityZone: {},
              SourceRegion: {}
            }
          },
          output: {
            resultWrapper: "CopyDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "S19"
              }
            }
          }
        },
        CopyOptionGroup: {
          input: {
            type: "structure",
            required: [
              "SourceOptionGroupIdentifier",
              "TargetOptionGroupIdentifier",
              "TargetOptionGroupDescription"
            ],
            members: {
              SourceOptionGroupIdentifier: {},
              TargetOptionGroupIdentifier: {},
              TargetOptionGroupDescription: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CopyOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "S1f"
              }
            }
          }
        },
        CreateCustomAvailabilityZone: {
          input: {
            type: "structure",
            required: [
              "CustomAvailabilityZoneName"
            ],
            members: {
              CustomAvailabilityZoneName: {},
              ExistingVpnId: {},
              NewVpnTunnelName: {},
              VpnTunnelOriginatorIP: {}
            }
          },
          output: {
            resultWrapper: "CreateCustomAvailabilityZoneResult",
            type: "structure",
            members: {
              CustomAvailabilityZone: {
                shape: "S1q"
              }
            }
          }
        },
        CreateDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "Engine"
            ],
            members: {
              AvailabilityZones: {
                shape: "S13"
              },
              BackupRetentionPeriod: {
                type: "integer"
              },
              CharacterSetName: {},
              DatabaseName: {},
              DBClusterIdentifier: {},
              DBClusterParameterGroupName: {},
              VpcSecurityGroupIds: {
                shape: "S1u"
              },
              DBSubnetGroupName: {},
              Engine: {},
              EngineVersion: {},
              Port: {
                type: "integer"
              },
              MasterUsername: {},
              MasterUserPassword: {},
              OptionGroupName: {},
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              ReplicationSourceIdentifier: {},
              Tags: {
                shape: "Sb"
              },
              StorageEncrypted: {
                type: "boolean"
              },
              KmsKeyId: {},
              PreSignedUrl: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              BacktrackWindow: {
                type: "long"
              },
              EnableCloudwatchLogsExports: {
                shape: "S1w"
              },
              EngineMode: {},
              ScalingConfiguration: {
                shape: "S1x"
              },
              DeletionProtection: {
                type: "boolean"
              },
              GlobalClusterIdentifier: {},
              EnableHttpEndpoint: {
                type: "boolean"
              },
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              Domain: {},
              DomainIAMRoleName: {},
              EnableGlobalWriteForwarding: {
                type: "boolean"
              },
              SourceRegion: {}
            }
          },
          output: {
            resultWrapper: "CreateDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S1z"
              }
            }
          }
        },
        CreateDBClusterEndpoint: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "DBClusterEndpointIdentifier",
              "EndpointType"
            ],
            members: {
              DBClusterIdentifier: {},
              DBClusterEndpointIdentifier: {},
              EndpointType: {},
              StaticMembers: {
                shape: "Sv"
              },
              ExcludedMembers: {
                shape: "Sv"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            shape: "S2g",
            resultWrapper: "CreateDBClusterEndpointResult"
          }
        },
        CreateDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName",
              "DBParameterGroupFamily",
              "Description"
            ],
            members: {
              DBClusterParameterGroupName: {},
              DBParameterGroupFamily: {},
              Description: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBClusterParameterGroupResult",
            type: "structure",
            members: {
              DBClusterParameterGroup: {
                shape: "Sz"
              }
            }
          }
        },
        CreateDBClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier",
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterSnapshotIdentifier: {},
              DBClusterIdentifier: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBClusterSnapshotResult",
            type: "structure",
            members: {
              DBClusterSnapshot: {
                shape: "S12"
              }
            }
          }
        },
        CreateDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "DBInstanceClass",
              "Engine"
            ],
            members: {
              DBName: {},
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              Engine: {},
              MasterUsername: {},
              MasterUserPassword: {},
              DBSecurityGroups: {
                shape: "S2m"
              },
              VpcSecurityGroupIds: {
                shape: "S1u"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              PreferredMaintenanceWindow: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              Port: {
                type: "integer"
              },
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              CharacterSetName: {},
              NcharCharacterSetName: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              Tags: {
                shape: "Sb"
              },
              DBClusterIdentifier: {},
              StorageType: {},
              TdeCredentialArn: {},
              TdeCredentialPassword: {},
              StorageEncrypted: {
                type: "boolean"
              },
              KmsKeyId: {},
              Domain: {},
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              MonitoringInterval: {
                type: "integer"
              },
              MonitoringRoleArn: {},
              DomainIAMRoleName: {},
              PromotionTier: {
                type: "integer"
              },
              Timezone: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              EnablePerformanceInsights: {
                type: "boolean"
              },
              PerformanceInsightsKMSKeyId: {},
              PerformanceInsightsRetentionPeriod: {
                type: "integer"
              },
              EnableCloudwatchLogsExports: {
                shape: "S1w"
              },
              ProcessorFeatures: {
                shape: "S1b"
              },
              DeletionProtection: {
                type: "boolean"
              },
              MaxAllocatedStorage: {
                type: "integer"
              },
              EnableCustomerOwnedIp: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S2o"
              }
            }
          }
        },
        CreateDBInstanceReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "SourceDBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SourceDBInstanceIdentifier: {},
              DBInstanceClass: {},
              AvailabilityZone: {},
              Port: {
                type: "integer"
              },
              MultiAZ: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              DBParameterGroupName: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              Tags: {
                shape: "Sb"
              },
              DBSubnetGroupName: {},
              VpcSecurityGroupIds: {
                shape: "S1u"
              },
              StorageType: {},
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              MonitoringInterval: {
                type: "integer"
              },
              MonitoringRoleArn: {},
              KmsKeyId: {},
              PreSignedUrl: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              EnablePerformanceInsights: {
                type: "boolean"
              },
              PerformanceInsightsKMSKeyId: {},
              PerformanceInsightsRetentionPeriod: {
                type: "integer"
              },
              EnableCloudwatchLogsExports: {
                shape: "S1w"
              },
              ProcessorFeatures: {
                shape: "S1b"
              },
              UseDefaultProcessorFeatures: {
                type: "boolean"
              },
              DeletionProtection: {
                type: "boolean"
              },
              Domain: {},
              DomainIAMRoleName: {},
              ReplicaMode: {},
              MaxAllocatedStorage: {
                type: "integer"
              },
              SourceRegion: {}
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S2o"
              }
            }
          }
        },
        CreateDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "DBParameterGroupFamily",
              "Description"
            ],
            members: {
              DBParameterGroupName: {},
              DBParameterGroupFamily: {},
              Description: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBParameterGroupResult",
            type: "structure",
            members: {
              DBParameterGroup: {
                shape: "S16"
              }
            }
          }
        },
        CreateDBProxy: {
          input: {
            type: "structure",
            required: [
              "DBProxyName",
              "EngineFamily",
              "Auth",
              "RoleArn",
              "VpcSubnetIds"
            ],
            members: {
              DBProxyName: {},
              EngineFamily: {},
              Auth: {
                shape: "S3f"
              },
              RoleArn: {},
              VpcSubnetIds: {
                shape: "Sv"
              },
              VpcSecurityGroupIds: {
                shape: "Sv"
              },
              RequireTLS: {
                type: "boolean"
              },
              IdleClientTimeout: {
                type: "integer"
              },
              DebugLogging: {
                type: "boolean"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBProxyResult",
            type: "structure",
            members: {
              DBProxy: {
                shape: "S3k"
              }
            }
          }
        },
        CreateDBProxyEndpoint: {
          input: {
            type: "structure",
            required: [
              "DBProxyName",
              "DBProxyEndpointName",
              "VpcSubnetIds"
            ],
            members: {
              DBProxyName: {},
              DBProxyEndpointName: {},
              VpcSubnetIds: {
                shape: "Sv"
              },
              VpcSecurityGroupIds: {
                shape: "Sv"
              },
              TargetRole: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBProxyEndpointResult",
            type: "structure",
            members: {
              DBProxyEndpoint: {
                shape: "S3t"
              }
            }
          }
        },
        CreateDBSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName",
              "DBSecurityGroupDescription"
            ],
            members: {
              DBSecurityGroupName: {},
              DBSecurityGroupDescription: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSecurityGroupResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sl"
              }
            }
          }
        },
        CreateDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier",
              "DBInstanceIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {},
              DBInstanceIdentifier: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "S19"
              }
            }
          }
        },
        CreateDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "DBSubnetGroupDescription",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S40"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S2s"
              }
            }
          }
        },
        CreateEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SnsTopicArn"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S8"
              },
              SourceIds: {
                shape: "S7"
              },
              Enabled: {
                type: "boolean"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S6"
              }
            }
          }
        },
        CreateGlobalCluster: {
          input: {
            type: "structure",
            members: {
              GlobalClusterIdentifier: {},
              SourceDBClusterIdentifier: {},
              Engine: {},
              EngineVersion: {},
              DeletionProtection: {
                type: "boolean"
              },
              DatabaseName: {},
              StorageEncrypted: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S46"
              }
            }
          }
        },
        CreateOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName",
              "EngineName",
              "MajorEngineVersion",
              "OptionGroupDescription"
            ],
            members: {
              OptionGroupName: {},
              EngineName: {},
              MajorEngineVersion: {},
              OptionGroupDescription: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "CreateOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "S1f"
              }
            }
          }
        },
        DeleteCustomAvailabilityZone: {
          input: {
            type: "structure",
            required: [
              "CustomAvailabilityZoneId"
            ],
            members: {
              CustomAvailabilityZoneId: {}
            }
          },
          output: {
            resultWrapper: "DeleteCustomAvailabilityZoneResult",
            type: "structure",
            members: {
              CustomAvailabilityZone: {
                shape: "S1q"
              }
            }
          }
        },
        DeleteDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              SkipFinalSnapshot: {
                type: "boolean"
              },
              FinalDBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S1z"
              }
            }
          }
        },
        DeleteDBClusterEndpoint: {
          input: {
            type: "structure",
            required: [
              "DBClusterEndpointIdentifier"
            ],
            members: {
              DBClusterEndpointIdentifier: {}
            }
          },
          output: {
            shape: "S2g",
            resultWrapper: "DeleteDBClusterEndpointResult"
          }
        },
        DeleteDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName"
            ],
            members: {
              DBClusterParameterGroupName: {}
            }
          }
        },
        DeleteDBClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier"
            ],
            members: {
              DBClusterSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBClusterSnapshotResult",
            type: "structure",
            members: {
              DBClusterSnapshot: {
                shape: "S12"
              }
            }
          }
        },
        DeleteDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SkipFinalSnapshot: {
                type: "boolean"
              },
              FinalDBSnapshotIdentifier: {},
              DeleteAutomatedBackups: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DeleteDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S2o"
              }
            }
          }
        },
        DeleteDBInstanceAutomatedBackup: {
          input: {
            type: "structure",
            members: {
              DbiResourceId: {},
              DBInstanceAutomatedBackupsArn: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBInstanceAutomatedBackupResult",
            type: "structure",
            members: {
              DBInstanceAutomatedBackup: {
                shape: "S4q"
              }
            }
          }
        },
        DeleteDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {}
            }
          }
        },
        DeleteDBProxy: {
          input: {
            type: "structure",
            required: [
              "DBProxyName"
            ],
            members: {
              DBProxyName: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBProxyResult",
            type: "structure",
            members: {
              DBProxy: {
                shape: "S3k"
              }
            }
          }
        },
        DeleteDBProxyEndpoint: {
          input: {
            type: "structure",
            required: [
              "DBProxyEndpointName"
            ],
            members: {
              DBProxyEndpointName: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBProxyEndpointResult",
            type: "structure",
            members: {
              DBProxyEndpoint: {
                shape: "S3t"
              }
            }
          }
        },
        DeleteDBSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {}
            }
          }
        },
        DeleteDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "S19"
              }
            }
          }
        },
        DeleteDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName"
            ],
            members: {
              DBSubnetGroupName: {}
            }
          }
        },
        DeleteEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {}
            }
          },
          output: {
            resultWrapper: "DeleteEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S6"
              }
            }
          }
        },
        DeleteGlobalCluster: {
          input: {
            type: "structure",
            required: [
              "GlobalClusterIdentifier"
            ],
            members: {
              GlobalClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S46"
              }
            }
          }
        },
        DeleteInstallationMedia: {
          input: {
            type: "structure",
            required: [
              "InstallationMediaId"
            ],
            members: {
              InstallationMediaId: {}
            }
          },
          output: {
            shape: "S56",
            resultWrapper: "DeleteInstallationMediaResult"
          }
        },
        DeleteOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName"
            ],
            members: {
              OptionGroupName: {}
            }
          }
        },
        DeregisterDBProxyTargets: {
          input: {
            type: "structure",
            required: [
              "DBProxyName"
            ],
            members: {
              DBProxyName: {},
              TargetGroupName: {},
              DBInstanceIdentifiers: {
                shape: "Sv"
              },
              DBClusterIdentifiers: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "DeregisterDBProxyTargetsResult",
            type: "structure",
            members: {}
          }
        },
        DescribeAccountAttributes: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            resultWrapper: "DescribeAccountAttributesResult",
            type: "structure",
            members: {
              AccountQuotas: {
                type: "list",
                member: {
                  locationName: "AccountQuota",
                  type: "structure",
                  members: {
                    AccountQuotaName: {},
                    Used: {
                      type: "long"
                    },
                    Max: {
                      type: "long"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeCertificates: {
          input: {
            type: "structure",
            members: {
              CertificateIdentifier: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeCertificatesResult",
            type: "structure",
            members: {
              Certificates: {
                type: "list",
                member: {
                  shape: "S5m",
                  locationName: "Certificate"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeCustomAvailabilityZones: {
          input: {
            type: "structure",
            members: {
              CustomAvailabilityZoneId: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeCustomAvailabilityZonesResult",
            type: "structure",
            members: {
              Marker: {},
              CustomAvailabilityZones: {
                type: "list",
                member: {
                  shape: "S1q",
                  locationName: "CustomAvailabilityZone"
                }
              }
            }
          }
        },
        DescribeDBClusterBacktracks: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              BacktrackIdentifier: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterBacktracksResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusterBacktracks: {
                type: "list",
                member: {
                  shape: "Ss",
                  locationName: "DBClusterBacktrack"
                }
              }
            }
          }
        },
        DescribeDBClusterEndpoints: {
          input: {
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              DBClusterEndpointIdentifier: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterEndpointsResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusterEndpoints: {
                type: "list",
                member: {
                  shape: "S2g",
                  locationName: "DBClusterEndpointList"
                }
              }
            }
          }
        },
        DescribeDBClusterParameterGroups: {
          input: {
            type: "structure",
            members: {
              DBClusterParameterGroupName: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusterParameterGroups: {
                type: "list",
                member: {
                  shape: "Sz",
                  locationName: "DBClusterParameterGroup"
                }
              }
            }
          }
        },
        DescribeDBClusterParameters: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName"
            ],
            members: {
              DBClusterParameterGroupName: {},
              Source: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterParametersResult",
            type: "structure",
            members: {
              Parameters: {
                shape: "S61"
              },
              Marker: {}
            }
          }
        },
        DescribeDBClusterSnapshotAttributes: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier"
            ],
            members: {
              DBClusterSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterSnapshotAttributesResult",
            type: "structure",
            members: {
              DBClusterSnapshotAttributesResult: {
                shape: "S67"
              }
            }
          }
        },
        DescribeDBClusterSnapshots: {
          input: {
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              DBClusterSnapshotIdentifier: {},
              SnapshotType: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              IncludeShared: {
                type: "boolean"
              },
              IncludePublic: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterSnapshotsResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusterSnapshots: {
                type: "list",
                member: {
                  shape: "S12",
                  locationName: "DBClusterSnapshot"
                }
              }
            }
          }
        },
        DescribeDBClusters: {
          input: {
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              IncludeShared: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBClustersResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusters: {
                type: "list",
                member: {
                  shape: "S1z",
                  locationName: "DBCluster"
                }
              }
            }
          }
        },
        DescribeDBEngineVersions: {
          input: {
            type: "structure",
            members: {
              Engine: {},
              EngineVersion: {},
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              DefaultOnly: {
                type: "boolean"
              },
              ListSupportedCharacterSets: {
                type: "boolean"
              },
              ListSupportedTimezones: {
                type: "boolean"
              },
              IncludeAll: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBEngineVersionsResult",
            type: "structure",
            members: {
              Marker: {},
              DBEngineVersions: {
                type: "list",
                member: {
                  locationName: "DBEngineVersion",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBParameterGroupFamily: {},
                    DBEngineDescription: {},
                    DBEngineVersionDescription: {},
                    DefaultCharacterSet: {
                      shape: "S6l"
                    },
                    SupportedCharacterSets: {
                      shape: "S6m"
                    },
                    SupportedNcharCharacterSets: {
                      shape: "S6m"
                    },
                    ValidUpgradeTarget: {
                      type: "list",
                      member: {
                        locationName: "UpgradeTarget",
                        type: "structure",
                        members: {
                          Engine: {},
                          EngineVersion: {},
                          Description: {},
                          AutoUpgrade: {
                            type: "boolean"
                          },
                          IsMajorVersionUpgrade: {
                            type: "boolean"
                          },
                          SupportedEngineModes: {
                            shape: "S64"
                          },
                          SupportsParallelQuery: {
                            type: "boolean"
                          },
                          SupportsGlobalDatabases: {
                            type: "boolean"
                          }
                        }
                      }
                    },
                    SupportedTimezones: {
                      type: "list",
                      member: {
                        locationName: "Timezone",
                        type: "structure",
                        members: {
                          TimezoneName: {}
                        }
                      }
                    },
                    ExportableLogTypes: {
                      shape: "S1w"
                    },
                    SupportsLogExportsToCloudwatchLogs: {
                      type: "boolean"
                    },
                    SupportsReadReplica: {
                      type: "boolean"
                    },
                    SupportedEngineModes: {
                      shape: "S64"
                    },
                    SupportedFeatureNames: {
                      type: "list",
                      member: {}
                    },
                    Status: {},
                    SupportsParallelQuery: {
                      type: "boolean"
                    },
                    SupportsGlobalDatabases: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeDBInstanceAutomatedBackups: {
          input: {
            type: "structure",
            members: {
              DbiResourceId: {},
              DBInstanceIdentifier: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              DBInstanceAutomatedBackupsArn: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBInstanceAutomatedBackupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBInstanceAutomatedBackups: {
                type: "list",
                member: {
                  shape: "S4q",
                  locationName: "DBInstanceAutomatedBackup"
                }
              }
            }
          }
        },
        DescribeDBInstances: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              DBInstances: {
                type: "list",
                member: {
                  shape: "S2o",
                  locationName: "DBInstance"
                }
              }
            }
          }
        },
        DescribeDBLogFiles: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              FilenameContains: {},
              FileLastWritten: {
                type: "long"
              },
              FileSize: {
                type: "long"
              },
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBLogFilesResult",
            type: "structure",
            members: {
              DescribeDBLogFiles: {
                type: "list",
                member: {
                  locationName: "DescribeDBLogFilesDetails",
                  type: "structure",
                  members: {
                    LogFileName: {},
                    LastWritten: {
                      type: "long"
                    },
                    Size: {
                      type: "long"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeDBParameterGroups: {
          input: {
            type: "structure",
            members: {
              DBParameterGroupName: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBParameterGroups: {
                type: "list",
                member: {
                  shape: "S16",
                  locationName: "DBParameterGroup"
                }
              }
            }
          }
        },
        DescribeDBParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              Source: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParametersResult",
            type: "structure",
            members: {
              Parameters: {
                shape: "S61"
              },
              Marker: {}
            }
          }
        },
        DescribeDBProxies: {
          input: {
            type: "structure",
            members: {
              DBProxyName: {},
              Filters: {
                shape: "S5h"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBProxiesResult",
            type: "structure",
            members: {
              DBProxies: {
                type: "list",
                member: {
                  shape: "S3k"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeDBProxyEndpoints: {
          input: {
            type: "structure",
            members: {
              DBProxyName: {},
              DBProxyEndpointName: {},
              Filters: {
                shape: "S5h"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBProxyEndpointsResult",
            type: "structure",
            members: {
              DBProxyEndpoints: {
                type: "list",
                member: {
                  shape: "S3t"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeDBProxyTargetGroups: {
          input: {
            type: "structure",
            required: [
              "DBProxyName"
            ],
            members: {
              DBProxyName: {},
              TargetGroupName: {},
              Filters: {
                shape: "S5h"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBProxyTargetGroupsResult",
            type: "structure",
            members: {
              TargetGroups: {
                type: "list",
                member: {
                  shape: "S7h"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeDBProxyTargets: {
          input: {
            type: "structure",
            required: [
              "DBProxyName"
            ],
            members: {
              DBProxyName: {},
              TargetGroupName: {},
              Filters: {
                shape: "S5h"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBProxyTargetsResult",
            type: "structure",
            members: {
              Targets: {
                shape: "S7l"
              },
              Marker: {}
            }
          }
        },
        DescribeDBSecurityGroups: {
          input: {
            type: "structure",
            members: {
              DBSecurityGroupName: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSecurityGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSecurityGroups: {
                type: "list",
                member: {
                  shape: "Sl",
                  locationName: "DBSecurityGroup"
                }
              }
            }
          }
        },
        DescribeDBSnapshotAttributes: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSnapshotAttributesResult",
            type: "structure",
            members: {
              DBSnapshotAttributesResult: {
                shape: "S7x"
              }
            }
          }
        },
        DescribeDBSnapshots: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              SnapshotType: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              IncludeShared: {
                type: "boolean"
              },
              IncludePublic: {
                type: "boolean"
              },
              DbiResourceId: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSnapshotsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSnapshots: {
                type: "list",
                member: {
                  shape: "S19",
                  locationName: "DBSnapshot"
                }
              }
            }
          }
        },
        DescribeDBSubnetGroups: {
          input: {
            type: "structure",
            members: {
              DBSubnetGroupName: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSubnetGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSubnetGroups: {
                type: "list",
                member: {
                  shape: "S2s",
                  locationName: "DBSubnetGroup"
                }
              }
            }
          }
        },
        DescribeEngineDefaultClusterParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupFamily"
            ],
            members: {
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEngineDefaultClusterParametersResult",
            type: "structure",
            members: {
              EngineDefaults: {
                shape: "S88"
              }
            }
          }
        },
        DescribeEngineDefaultParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupFamily"
            ],
            members: {
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEngineDefaultParametersResult",
            type: "structure",
            members: {
              EngineDefaults: {
                shape: "S88"
              }
            }
          }
        },
        DescribeEventCategories: {
          input: {
            type: "structure",
            members: {
              SourceType: {},
              Filters: {
                shape: "S5h"
              }
            }
          },
          output: {
            resultWrapper: "DescribeEventCategoriesResult",
            type: "structure",
            members: {
              EventCategoriesMapList: {
                type: "list",
                member: {
                  locationName: "EventCategoriesMap",
                  type: "structure",
                  members: {
                    SourceType: {},
                    EventCategories: {
                      shape: "S8"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeEventSubscriptions: {
          input: {
            type: "structure",
            members: {
              SubscriptionName: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventSubscriptionsResult",
            type: "structure",
            members: {
              Marker: {},
              EventSubscriptionsList: {
                type: "list",
                member: {
                  shape: "S6",
                  locationName: "EventSubscription"
                }
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceIdentifier: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              EventCategories: {
                shape: "S8"
              },
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventsResult",
            type: "structure",
            members: {
              Marker: {},
              Events: {
                type: "list",
                member: {
                  locationName: "Event",
                  type: "structure",
                  members: {
                    SourceIdentifier: {},
                    SourceType: {},
                    Message: {},
                    EventCategories: {
                      shape: "S8"
                    },
                    Date: {
                      type: "timestamp"
                    },
                    SourceArn: {}
                  }
                }
              }
            }
          }
        },
        DescribeExportTasks: {
          input: {
            type: "structure",
            members: {
              ExportTaskIdentifier: {},
              SourceArn: {},
              Filters: {
                shape: "S5h"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeExportTasksResult",
            type: "structure",
            members: {
              Marker: {},
              ExportTasks: {
                type: "list",
                member: {
                  shape: "Su",
                  locationName: "ExportTask"
                }
              }
            }
          }
        },
        DescribeGlobalClusters: {
          input: {
            type: "structure",
            members: {
              GlobalClusterIdentifier: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeGlobalClustersResult",
            type: "structure",
            members: {
              Marker: {},
              GlobalClusters: {
                type: "list",
                member: {
                  shape: "S46",
                  locationName: "GlobalClusterMember"
                }
              }
            }
          }
        },
        DescribeInstallationMedia: {
          input: {
            type: "structure",
            members: {
              InstallationMediaId: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeInstallationMediaResult",
            type: "structure",
            members: {
              Marker: {},
              InstallationMedia: {
                type: "list",
                member: {
                  shape: "S56",
                  locationName: "InstallationMedia"
                }
              }
            }
          }
        },
        DescribeOptionGroupOptions: {
          input: {
            type: "structure",
            required: [
              "EngineName"
            ],
            members: {
              EngineName: {},
              MajorEngineVersion: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOptionGroupOptionsResult",
            type: "structure",
            members: {
              OptionGroupOptions: {
                type: "list",
                member: {
                  locationName: "OptionGroupOption",
                  type: "structure",
                  members: {
                    Name: {},
                    Description: {},
                    EngineName: {},
                    MajorEngineVersion: {},
                    MinimumRequiredMinorEngineVersion: {},
                    PortRequired: {
                      type: "boolean"
                    },
                    DefaultPort: {
                      type: "integer"
                    },
                    OptionsDependedOn: {
                      type: "list",
                      member: {
                        locationName: "OptionName"
                      }
                    },
                    OptionsConflictsWith: {
                      type: "list",
                      member: {
                        locationName: "OptionConflictName"
                      }
                    },
                    Persistent: {
                      type: "boolean"
                    },
                    Permanent: {
                      type: "boolean"
                    },
                    RequiresAutoMinorEngineVersionUpgrade: {
                      type: "boolean"
                    },
                    VpcOnly: {
                      type: "boolean"
                    },
                    SupportsOptionVersionDowngrade: {
                      type: "boolean"
                    },
                    OptionGroupOptionSettings: {
                      type: "list",
                      member: {
                        locationName: "OptionGroupOptionSetting",
                        type: "structure",
                        members: {
                          SettingName: {},
                          SettingDescription: {},
                          DefaultValue: {},
                          ApplyType: {},
                          AllowedValues: {},
                          IsModifiable: {
                            type: "boolean"
                          },
                          IsRequired: {
                            type: "boolean"
                          },
                          MinimumEngineVersionPerAllowedValue: {
                            type: "list",
                            member: {
                              locationName: "MinimumEngineVersionPerAllowedValue",
                              type: "structure",
                              members: {
                                AllowedValue: {},
                                MinimumEngineVersion: {}
                              }
                            }
                          }
                        }
                      }
                    },
                    OptionGroupOptionVersions: {
                      type: "list",
                      member: {
                        locationName: "OptionVersion",
                        type: "structure",
                        members: {
                          Version: {},
                          IsDefault: {
                            type: "boolean"
                          }
                        }
                      }
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOptionGroups: {
          input: {
            type: "structure",
            members: {
              OptionGroupName: {},
              Filters: {
                shape: "S5h"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              },
              EngineName: {},
              MajorEngineVersion: {}
            }
          },
          output: {
            resultWrapper: "DescribeOptionGroupsResult",
            type: "structure",
            members: {
              OptionGroupsList: {
                type: "list",
                member: {
                  shape: "S1f",
                  locationName: "OptionGroup"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOrderableDBInstanceOptions: {
          input: {
            type: "structure",
            required: [
              "Engine"
            ],
            members: {
              Engine: {},
              EngineVersion: {},
              DBInstanceClass: {},
              LicenseModel: {},
              AvailabilityZoneGroup: {},
              Vpc: {
                type: "boolean"
              },
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOrderableDBInstanceOptionsResult",
            type: "structure",
            members: {
              OrderableDBInstanceOptions: {
                type: "list",
                member: {
                  locationName: "OrderableDBInstanceOption",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBInstanceClass: {},
                    LicenseModel: {},
                    AvailabilityZoneGroup: {},
                    AvailabilityZones: {
                      type: "list",
                      member: {
                        shape: "S2v",
                        locationName: "AvailabilityZone"
                      }
                    },
                    MultiAZCapable: {
                      type: "boolean"
                    },
                    ReadReplicaCapable: {
                      type: "boolean"
                    },
                    Vpc: {
                      type: "boolean"
                    },
                    SupportsStorageEncryption: {
                      type: "boolean"
                    },
                    StorageType: {},
                    SupportsIops: {
                      type: "boolean"
                    },
                    SupportsEnhancedMonitoring: {
                      type: "boolean"
                    },
                    SupportsIAMDatabaseAuthentication: {
                      type: "boolean"
                    },
                    SupportsPerformanceInsights: {
                      type: "boolean"
                    },
                    MinStorageSize: {
                      type: "integer"
                    },
                    MaxStorageSize: {
                      type: "integer"
                    },
                    MinIopsPerDbInstance: {
                      type: "integer"
                    },
                    MaxIopsPerDbInstance: {
                      type: "integer"
                    },
                    MinIopsPerGib: {
                      type: "double"
                    },
                    MaxIopsPerGib: {
                      type: "double"
                    },
                    AvailableProcessorFeatures: {
                      shape: "S9h"
                    },
                    SupportedEngineModes: {
                      shape: "S64"
                    },
                    SupportsStorageAutoscaling: {
                      type: "boolean"
                    },
                    SupportsKerberosAuthentication: {
                      type: "boolean"
                    },
                    OutpostCapable: {
                      type: "boolean"
                    },
                    SupportedActivityStreamModes: {
                      type: "list",
                      member: {}
                    },
                    SupportsGlobalDatabases: {
                      type: "boolean"
                    }
                  },
                  wrapper: true
                }
              },
              Marker: {}
            }
          }
        },
        DescribePendingMaintenanceActions: {
          input: {
            type: "structure",
            members: {
              ResourceIdentifier: {},
              Filters: {
                shape: "S5h"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribePendingMaintenanceActionsResult",
            type: "structure",
            members: {
              PendingMaintenanceActions: {
                type: "list",
                member: {
                  shape: "Sf",
                  locationName: "ResourcePendingMaintenanceActions"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeReservedDBInstances: {
          input: {
            type: "structure",
            members: {
              ReservedDBInstanceId: {},
              ReservedDBInstancesOfferingId: {},
              DBInstanceClass: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MultiAZ: {
                type: "boolean"
              },
              LeaseId: {},
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedDBInstances: {
                type: "list",
                member: {
                  shape: "S9q",
                  locationName: "ReservedDBInstance"
                }
              }
            }
          }
        },
        DescribeReservedDBInstancesOfferings: {
          input: {
            type: "structure",
            members: {
              ReservedDBInstancesOfferingId: {},
              DBInstanceClass: {},
              Duration: {},
              ProductDescription: {},
              OfferingType: {},
              MultiAZ: {
                type: "boolean"
              },
              Filters: {
                shape: "S5h"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedDBInstancesOfferingsResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedDBInstancesOfferings: {
                type: "list",
                member: {
                  locationName: "ReservedDBInstancesOffering",
                  type: "structure",
                  members: {
                    ReservedDBInstancesOfferingId: {},
                    DBInstanceClass: {},
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    UsagePrice: {
                      type: "double"
                    },
                    CurrencyCode: {},
                    ProductDescription: {},
                    OfferingType: {},
                    MultiAZ: {
                      type: "boolean"
                    },
                    RecurringCharges: {
                      shape: "S9s"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeSourceRegions: {
          input: {
            type: "structure",
            members: {
              RegionName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              Filters: {
                shape: "S5h"
              }
            }
          },
          output: {
            resultWrapper: "DescribeSourceRegionsResult",
            type: "structure",
            members: {
              Marker: {},
              SourceRegions: {
                type: "list",
                member: {
                  locationName: "SourceRegion",
                  type: "structure",
                  members: {
                    RegionName: {},
                    Endpoint: {},
                    Status: {},
                    SupportsDBInstanceAutomatedBackupsReplication: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeValidDBInstanceModifications: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DescribeValidDBInstanceModificationsResult",
            type: "structure",
            members: {
              ValidDBInstanceModificationsMessage: {
                type: "structure",
                members: {
                  Storage: {
                    type: "list",
                    member: {
                      locationName: "ValidStorageOptions",
                      type: "structure",
                      members: {
                        StorageType: {},
                        StorageSize: {
                          shape: "Sa7"
                        },
                        ProvisionedIops: {
                          shape: "Sa7"
                        },
                        IopsToStorageRatio: {
                          type: "list",
                          member: {
                            locationName: "DoubleRange",
                            type: "structure",
                            members: {
                              From: {
                                type: "double"
                              },
                              To: {
                                type: "double"
                              }
                            }
                          }
                        },
                        SupportsStorageAutoscaling: {
                          type: "boolean"
                        }
                      }
                    }
                  },
                  ValidProcessorFeatures: {
                    shape: "S9h"
                  }
                },
                wrapper: true
              }
            }
          }
        },
        DownloadDBLogFilePortion: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "LogFileName"
            ],
            members: {
              DBInstanceIdentifier: {},
              LogFileName: {},
              Marker: {},
              NumberOfLines: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DownloadDBLogFilePortionResult",
            type: "structure",
            members: {
              LogFileData: {},
              Marker: {},
              AdditionalDataPending: {
                type: "boolean"
              }
            }
          }
        },
        FailoverDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              TargetDBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "FailoverDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S1z"
              }
            }
          }
        },
        FailoverGlobalCluster: {
          input: {
            type: "structure",
            required: [
              "GlobalClusterIdentifier",
              "TargetDbClusterIdentifier"
            ],
            members: {
              GlobalClusterIdentifier: {},
              TargetDbClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "FailoverGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S46"
              }
            }
          }
        },
        ImportInstallationMedia: {
          input: {
            type: "structure",
            required: [
              "CustomAvailabilityZoneId",
              "Engine",
              "EngineVersion",
              "EngineInstallationMediaPath",
              "OSInstallationMediaPath"
            ],
            members: {
              CustomAvailabilityZoneId: {},
              Engine: {},
              EngineVersion: {},
              EngineInstallationMediaPath: {},
              OSInstallationMediaPath: {}
            }
          },
          output: {
            shape: "S56",
            resultWrapper: "ImportInstallationMediaResult"
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName"
            ],
            members: {
              ResourceName: {},
              Filters: {
                shape: "S5h"
              }
            }
          },
          output: {
            resultWrapper: "ListTagsForResourceResult",
            type: "structure",
            members: {
              TagList: {
                shape: "Sb"
              }
            }
          }
        },
        ModifyCertificates: {
          input: {
            type: "structure",
            members: {
              CertificateIdentifier: {},
              RemoveCustomerOverride: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyCertificatesResult",
            type: "structure",
            members: {
              Certificate: {
                shape: "S5m"
              }
            }
          }
        },
        ModifyCurrentDBClusterCapacity: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              Capacity: {
                type: "integer"
              },
              SecondsBeforeTimeout: {
                type: "integer"
              },
              TimeoutAction: {}
            }
          },
          output: {
            resultWrapper: "ModifyCurrentDBClusterCapacityResult",
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              PendingCapacity: {
                type: "integer"
              },
              CurrentCapacity: {
                type: "integer"
              },
              SecondsBeforeTimeout: {
                type: "integer"
              },
              TimeoutAction: {}
            }
          }
        },
        ModifyDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              NewDBClusterIdentifier: {},
              ApplyImmediately: {
                type: "boolean"
              },
              BackupRetentionPeriod: {
                type: "integer"
              },
              DBClusterParameterGroupName: {},
              VpcSecurityGroupIds: {
                shape: "S1u"
              },
              Port: {
                type: "integer"
              },
              MasterUserPassword: {},
              OptionGroupName: {},
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              BacktrackWindow: {
                type: "long"
              },
              CloudwatchLogsExportConfiguration: {
                shape: "Sar"
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              },
              DBInstanceParameterGroupName: {},
              Domain: {},
              DomainIAMRoleName: {},
              ScalingConfiguration: {
                shape: "S1x"
              },
              DeletionProtection: {
                type: "boolean"
              },
              EnableHttpEndpoint: {
                type: "boolean"
              },
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              EnableGlobalWriteForwarding: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S1z"
              }
            }
          }
        },
        ModifyDBClusterEndpoint: {
          input: {
            type: "structure",
            required: [
              "DBClusterEndpointIdentifier"
            ],
            members: {
              DBClusterEndpointIdentifier: {},
              EndpointType: {},
              StaticMembers: {
                shape: "Sv"
              },
              ExcludedMembers: {
                shape: "Sv"
              }
            }
          },
          output: {
            shape: "S2g",
            resultWrapper: "ModifyDBClusterEndpointResult"
          }
        },
        ModifyDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName",
              "Parameters"
            ],
            members: {
              DBClusterParameterGroupName: {},
              Parameters: {
                shape: "S61"
              }
            }
          },
          output: {
            shape: "Sav",
            resultWrapper: "ModifyDBClusterParameterGroupResult"
          }
        },
        ModifyDBClusterSnapshotAttribute: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier",
              "AttributeName"
            ],
            members: {
              DBClusterSnapshotIdentifier: {},
              AttributeName: {},
              ValuesToAdd: {
                shape: "S6a"
              },
              ValuesToRemove: {
                shape: "S6a"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBClusterSnapshotAttributeResult",
            type: "structure",
            members: {
              DBClusterSnapshotAttributesResult: {
                shape: "S67"
              }
            }
          }
        },
        ModifyDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              DBSubnetGroupName: {},
              DBSecurityGroups: {
                shape: "S2m"
              },
              VpcSecurityGroupIds: {
                shape: "S1u"
              },
              ApplyImmediately: {
                type: "boolean"
              },
              MasterUserPassword: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              NewDBInstanceIdentifier: {},
              StorageType: {},
              TdeCredentialArn: {},
              TdeCredentialPassword: {},
              CACertificateIdentifier: {},
              Domain: {},
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              MonitoringInterval: {
                type: "integer"
              },
              DBPortNumber: {
                type: "integer"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              MonitoringRoleArn: {},
              DomainIAMRoleName: {},
              PromotionTier: {
                type: "integer"
              },
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              EnablePerformanceInsights: {
                type: "boolean"
              },
              PerformanceInsightsKMSKeyId: {},
              PerformanceInsightsRetentionPeriod: {
                type: "integer"
              },
              CloudwatchLogsExportConfiguration: {
                shape: "Sar"
              },
              ProcessorFeatures: {
                shape: "S1b"
              },
              UseDefaultProcessorFeatures: {
                type: "boolean"
              },
              DeletionProtection: {
                type: "boolean"
              },
              MaxAllocatedStorage: {
                type: "integer"
              },
              CertificateRotationRestart: {
                type: "boolean"
              },
              ReplicaMode: {},
              EnableCustomerOwnedIp: {
                type: "boolean"
              },
              AwsBackupRecoveryPointArn: {}
            }
          },
          output: {
            resultWrapper: "ModifyDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S2o"
              }
            }
          }
        },
        ModifyDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "Parameters"
            ],
            members: {
              DBParameterGroupName: {},
              Parameters: {
                shape: "S61"
              }
            }
          },
          output: {
            shape: "Sb2",
            resultWrapper: "ModifyDBParameterGroupResult"
          }
        },
        ModifyDBProxy: {
          input: {
            type: "structure",
            required: [
              "DBProxyName"
            ],
            members: {
              DBProxyName: {},
              NewDBProxyName: {},
              Auth: {
                shape: "S3f"
              },
              RequireTLS: {
                type: "boolean"
              },
              IdleClientTimeout: {
                type: "integer"
              },
              DebugLogging: {
                type: "boolean"
              },
              RoleArn: {},
              SecurityGroups: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBProxyResult",
            type: "structure",
            members: {
              DBProxy: {
                shape: "S3k"
              }
            }
          }
        },
        ModifyDBProxyEndpoint: {
          input: {
            type: "structure",
            required: [
              "DBProxyEndpointName"
            ],
            members: {
              DBProxyEndpointName: {},
              NewDBProxyEndpointName: {},
              VpcSecurityGroupIds: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBProxyEndpointResult",
            type: "structure",
            members: {
              DBProxyEndpoint: {
                shape: "S3t"
              }
            }
          }
        },
        ModifyDBProxyTargetGroup: {
          input: {
            type: "structure",
            required: [
              "TargetGroupName",
              "DBProxyName"
            ],
            members: {
              TargetGroupName: {},
              DBProxyName: {},
              ConnectionPoolConfig: {
                type: "structure",
                members: {
                  MaxConnectionsPercent: {
                    type: "integer"
                  },
                  MaxIdleConnectionsPercent: {
                    type: "integer"
                  },
                  ConnectionBorrowTimeout: {
                    type: "integer"
                  },
                  SessionPinningFilters: {
                    shape: "Sv"
                  },
                  InitQuery: {}
                }
              },
              NewName: {}
            }
          },
          output: {
            resultWrapper: "ModifyDBProxyTargetGroupResult",
            type: "structure",
            members: {
              DBProxyTargetGroup: {
                shape: "S7h"
              }
            }
          }
        },
        ModifyDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier"
            ],
            members: {
              DBSnapshotIdentifier: {},
              EngineVersion: {},
              OptionGroupName: {}
            }
          },
          output: {
            resultWrapper: "ModifyDBSnapshotResult",
            type: "structure",
            members: {
              DBSnapshot: {
                shape: "S19"
              }
            }
          }
        },
        ModifyDBSnapshotAttribute: {
          input: {
            type: "structure",
            required: [
              "DBSnapshotIdentifier",
              "AttributeName"
            ],
            members: {
              DBSnapshotIdentifier: {},
              AttributeName: {},
              ValuesToAdd: {
                shape: "S6a"
              },
              ValuesToRemove: {
                shape: "S6a"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBSnapshotAttributeResult",
            type: "structure",
            members: {
              DBSnapshotAttributesResult: {
                shape: "S7x"
              }
            }
          }
        },
        ModifyDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S40"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S2s"
              }
            }
          }
        },
        ModifyEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S8"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S6"
              }
            }
          }
        },
        ModifyGlobalCluster: {
          input: {
            type: "structure",
            members: {
              GlobalClusterIdentifier: {},
              NewGlobalClusterIdentifier: {},
              DeletionProtection: {
                type: "boolean"
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S46"
              }
            }
          }
        },
        ModifyOptionGroup: {
          input: {
            type: "structure",
            required: [
              "OptionGroupName"
            ],
            members: {
              OptionGroupName: {},
              OptionsToInclude: {
                type: "list",
                member: {
                  locationName: "OptionConfiguration",
                  type: "structure",
                  required: [
                    "OptionName"
                  ],
                  members: {
                    OptionName: {},
                    Port: {
                      type: "integer"
                    },
                    OptionVersion: {},
                    DBSecurityGroupMemberships: {
                      shape: "S2m"
                    },
                    VpcSecurityGroupMemberships: {
                      shape: "S1u"
                    },
                    OptionSettings: {
                      type: "list",
                      member: {
                        shape: "S1j",
                        locationName: "OptionSetting"
                      }
                    }
                  }
                }
              },
              OptionsToRemove: {
                type: "list",
                member: {}
              },
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyOptionGroupResult",
            type: "structure",
            members: {
              OptionGroup: {
                shape: "S1f"
              }
            }
          }
        },
        PromoteReadReplica: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {}
            }
          },
          output: {
            resultWrapper: "PromoteReadReplicaResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S2o"
              }
            }
          }
        },
        PromoteReadReplicaDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "PromoteReadReplicaDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S1z"
              }
            }
          }
        },
        PurchaseReservedDBInstancesOffering: {
          input: {
            type: "structure",
            required: [
              "ReservedDBInstancesOfferingId"
            ],
            members: {
              ReservedDBInstancesOfferingId: {},
              ReservedDBInstanceId: {},
              DBInstanceCount: {
                type: "integer"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            resultWrapper: "PurchaseReservedDBInstancesOfferingResult",
            type: "structure",
            members: {
              ReservedDBInstance: {
                shape: "S9q"
              }
            }
          }
        },
        RebootDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              ForceFailover: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RebootDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S2o"
              }
            }
          }
        },
        RegisterDBProxyTargets: {
          input: {
            type: "structure",
            required: [
              "DBProxyName"
            ],
            members: {
              DBProxyName: {},
              TargetGroupName: {},
              DBInstanceIdentifiers: {
                shape: "Sv"
              },
              DBClusterIdentifiers: {
                shape: "Sv"
              }
            }
          },
          output: {
            resultWrapper: "RegisterDBProxyTargetsResult",
            type: "structure",
            members: {
              DBProxyTargets: {
                shape: "S7l"
              }
            }
          }
        },
        RemoveFromGlobalCluster: {
          input: {
            type: "structure",
            members: {
              GlobalClusterIdentifier: {},
              DbClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RemoveFromGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S46"
              }
            }
          }
        },
        RemoveRoleFromDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "RoleArn"
            ],
            members: {
              DBClusterIdentifier: {},
              RoleArn: {},
              FeatureName: {}
            }
          }
        },
        RemoveRoleFromDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "RoleArn",
              "FeatureName"
            ],
            members: {
              DBInstanceIdentifier: {},
              RoleArn: {},
              FeatureName: {}
            }
          }
        },
        RemoveSourceIdentifierFromSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RemoveSourceIdentifierFromSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S6"
              }
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "TagKeys"
            ],
            members: {
              ResourceName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ResetDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName"
            ],
            members: {
              DBClusterParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              Parameters: {
                shape: "S61"
              }
            }
          },
          output: {
            shape: "Sav",
            resultWrapper: "ResetDBClusterParameterGroupResult"
          }
        },
        ResetDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              Parameters: {
                shape: "S61"
              }
            }
          },
          output: {
            shape: "Sb2",
            resultWrapper: "ResetDBParameterGroupResult"
          }
        },
        RestoreDBClusterFromS3: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "Engine",
              "MasterUsername",
              "MasterUserPassword",
              "SourceEngine",
              "SourceEngineVersion",
              "S3BucketName",
              "S3IngestionRoleArn"
            ],
            members: {
              AvailabilityZones: {
                shape: "S13"
              },
              BackupRetentionPeriod: {
                type: "integer"
              },
              CharacterSetName: {},
              DatabaseName: {},
              DBClusterIdentifier: {},
              DBClusterParameterGroupName: {},
              VpcSecurityGroupIds: {
                shape: "S1u"
              },
              DBSubnetGroupName: {},
              Engine: {},
              EngineVersion: {},
              Port: {
                type: "integer"
              },
              MasterUsername: {},
              MasterUserPassword: {},
              OptionGroupName: {},
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              Tags: {
                shape: "Sb"
              },
              StorageEncrypted: {
                type: "boolean"
              },
              KmsKeyId: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              SourceEngine: {},
              SourceEngineVersion: {},
              S3BucketName: {},
              S3Prefix: {},
              S3IngestionRoleArn: {},
              BacktrackWindow: {
                type: "long"
              },
              EnableCloudwatchLogsExports: {
                shape: "S1w"
              },
              DeletionProtection: {
                type: "boolean"
              },
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              Domain: {},
              DomainIAMRoleName: {}
            }
          },
          output: {
            resultWrapper: "RestoreDBClusterFromS3Result",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S1z"
              }
            }
          }
        },
        RestoreDBClusterFromSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "SnapshotIdentifier",
              "Engine"
            ],
            members: {
              AvailabilityZones: {
                shape: "S13"
              },
              DBClusterIdentifier: {},
              SnapshotIdentifier: {},
              Engine: {},
              EngineVersion: {},
              Port: {
                type: "integer"
              },
              DBSubnetGroupName: {},
              DatabaseName: {},
              OptionGroupName: {},
              VpcSecurityGroupIds: {
                shape: "S1u"
              },
              Tags: {
                shape: "Sb"
              },
              KmsKeyId: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              BacktrackWindow: {
                type: "long"
              },
              EnableCloudwatchLogsExports: {
                shape: "S1w"
              },
              EngineMode: {},
              ScalingConfiguration: {
                shape: "S1x"
              },
              DBClusterParameterGroupName: {},
              DeletionProtection: {
                type: "boolean"
              },
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              Domain: {},
              DomainIAMRoleName: {}
            }
          },
          output: {
            resultWrapper: "RestoreDBClusterFromSnapshotResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S1z"
              }
            }
          }
        },
        RestoreDBClusterToPointInTime: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "SourceDBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              RestoreType: {},
              SourceDBClusterIdentifier: {},
              RestoreToTime: {
                type: "timestamp"
              },
              UseLatestRestorableTime: {
                type: "boolean"
              },
              Port: {
                type: "integer"
              },
              DBSubnetGroupName: {},
              OptionGroupName: {},
              VpcSecurityGroupIds: {
                shape: "S1u"
              },
              Tags: {
                shape: "Sb"
              },
              KmsKeyId: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              BacktrackWindow: {
                type: "long"
              },
              EnableCloudwatchLogsExports: {
                shape: "S1w"
              },
              DBClusterParameterGroupName: {},
              DeletionProtection: {
                type: "boolean"
              },
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              Domain: {},
              DomainIAMRoleName: {},
              ScalingConfiguration: {
                shape: "S1x"
              },
              EngineMode: {}
            }
          },
          output: {
            resultWrapper: "RestoreDBClusterToPointInTimeResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S1z"
              }
            }
          }
        },
        RestoreDBInstanceFromDBSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "DBSnapshotIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {},
              DBInstanceClass: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              MultiAZ: {
                type: "boolean"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              DBName: {},
              Engine: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              Tags: {
                shape: "Sb"
              },
              StorageType: {},
              TdeCredentialArn: {},
              TdeCredentialPassword: {},
              VpcSecurityGroupIds: {
                shape: "S1u"
              },
              Domain: {},
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              DomainIAMRoleName: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              EnableCloudwatchLogsExports: {
                shape: "S1w"
              },
              ProcessorFeatures: {
                shape: "S1b"
              },
              UseDefaultProcessorFeatures: {
                type: "boolean"
              },
              DBParameterGroupName: {},
              DeletionProtection: {
                type: "boolean"
              },
              EnableCustomerOwnedIp: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceFromDBSnapshotResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S2o"
              }
            }
          }
        },
        RestoreDBInstanceFromS3: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "DBInstanceClass",
              "Engine",
              "SourceEngine",
              "SourceEngineVersion",
              "S3BucketName",
              "S3IngestionRoleArn"
            ],
            members: {
              DBName: {},
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              Engine: {},
              MasterUsername: {},
              MasterUserPassword: {},
              DBSecurityGroups: {
                shape: "S2m"
              },
              VpcSecurityGroupIds: {
                shape: "S1u"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              PreferredMaintenanceWindow: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              Port: {
                type: "integer"
              },
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              Tags: {
                shape: "Sb"
              },
              StorageType: {},
              StorageEncrypted: {
                type: "boolean"
              },
              KmsKeyId: {},
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              MonitoringInterval: {
                type: "integer"
              },
              MonitoringRoleArn: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              SourceEngine: {},
              SourceEngineVersion: {},
              S3BucketName: {},
              S3Prefix: {},
              S3IngestionRoleArn: {},
              EnablePerformanceInsights: {
                type: "boolean"
              },
              PerformanceInsightsKMSKeyId: {},
              PerformanceInsightsRetentionPeriod: {
                type: "integer"
              },
              EnableCloudwatchLogsExports: {
                shape: "S1w"
              },
              ProcessorFeatures: {
                shape: "S1b"
              },
              UseDefaultProcessorFeatures: {
                type: "boolean"
              },
              DeletionProtection: {
                type: "boolean"
              },
              MaxAllocatedStorage: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceFromS3Result",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S2o"
              }
            }
          }
        },
        RestoreDBInstanceToPointInTime: {
          input: {
            type: "structure",
            required: [
              "TargetDBInstanceIdentifier"
            ],
            members: {
              SourceDBInstanceIdentifier: {},
              TargetDBInstanceIdentifier: {},
              RestoreTime: {
                type: "timestamp"
              },
              UseLatestRestorableTime: {
                type: "boolean"
              },
              DBInstanceClass: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              MultiAZ: {
                type: "boolean"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              DBName: {},
              Engine: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              Tags: {
                shape: "Sb"
              },
              StorageType: {},
              TdeCredentialArn: {},
              TdeCredentialPassword: {},
              VpcSecurityGroupIds: {
                shape: "S1u"
              },
              Domain: {},
              DomainIAMRoleName: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              EnableCloudwatchLogsExports: {
                shape: "S1w"
              },
              ProcessorFeatures: {
                shape: "S1b"
              },
              UseDefaultProcessorFeatures: {
                type: "boolean"
              },
              DBParameterGroupName: {},
              DeletionProtection: {
                type: "boolean"
              },
              SourceDbiResourceId: {},
              MaxAllocatedStorage: {
                type: "integer"
              },
              SourceDBInstanceAutomatedBackupsArn: {},
              EnableCustomerOwnedIp: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RestoreDBInstanceToPointInTimeResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S2o"
              }
            }
          }
        },
        RevokeDBSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "DBSecurityGroupName"
            ],
            members: {
              DBSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupId: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "RevokeDBSecurityGroupIngressResult",
            type: "structure",
            members: {
              DBSecurityGroup: {
                shape: "Sl"
              }
            }
          }
        },
        StartActivityStream: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Mode",
              "KmsKeyId"
            ],
            members: {
              ResourceArn: {},
              Mode: {},
              KmsKeyId: {},
              ApplyImmediately: {
                type: "boolean"
              },
              EngineNativeAuditFieldsIncluded: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "StartActivityStreamResult",
            type: "structure",
            members: {
              KmsKeyId: {},
              KinesisStreamName: {},
              Status: {},
              Mode: {},
              ApplyImmediately: {
                type: "boolean"
              },
              EngineNativeAuditFieldsIncluded: {
                type: "boolean"
              }
            }
          }
        },
        StartDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "StartDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S1z"
              }
            }
          }
        },
        StartDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "StartDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S2o"
              }
            }
          }
        },
        StartDBInstanceAutomatedBackupsReplication: {
          input: {
            type: "structure",
            required: [
              "SourceDBInstanceArn"
            ],
            members: {
              SourceDBInstanceArn: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              KmsKeyId: {},
              PreSignedUrl: {}
            }
          },
          output: {
            resultWrapper: "StartDBInstanceAutomatedBackupsReplicationResult",
            type: "structure",
            members: {
              DBInstanceAutomatedBackup: {
                shape: "S4q"
              }
            }
          }
        },
        StartExportTask: {
          input: {
            type: "structure",
            required: [
              "ExportTaskIdentifier",
              "SourceArn",
              "S3BucketName",
              "IamRoleArn",
              "KmsKeyId"
            ],
            members: {
              ExportTaskIdentifier: {},
              SourceArn: {},
              S3BucketName: {},
              IamRoleArn: {},
              KmsKeyId: {},
              S3Prefix: {},
              ExportOnly: {
                shape: "Sv"
              }
            }
          },
          output: {
            shape: "Su",
            resultWrapper: "StartExportTaskResult"
          }
        },
        StopActivityStream: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              ApplyImmediately: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "StopActivityStreamResult",
            type: "structure",
            members: {
              KmsKeyId: {},
              KinesisStreamName: {},
              Status: {}
            }
          }
        },
        StopDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "StopDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "S1z"
              }
            }
          }
        },
        StopDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              DBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "StopDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S2o"
              }
            }
          }
        },
        StopDBInstanceAutomatedBackupsReplication: {
          input: {
            type: "structure",
            required: [
              "SourceDBInstanceArn"
            ],
            members: {
              SourceDBInstanceArn: {}
            }
          },
          output: {
            resultWrapper: "StopDBInstanceAutomatedBackupsReplicationResult",
            type: "structure",
            members: {
              DBInstanceAutomatedBackup: {
                shape: "S4q"
              }
            }
          }
        }
      },
      shapes: {
        S6: {
          type: "structure",
          members: {
            CustomerAwsId: {},
            CustSubscriptionId: {},
            SnsTopicArn: {},
            Status: {},
            SubscriptionCreationTime: {},
            SourceType: {},
            SourceIdsList: {
              shape: "S7"
            },
            EventCategoriesList: {
              shape: "S8"
            },
            Enabled: {
              type: "boolean"
            },
            EventSubscriptionArn: {}
          },
          wrapper: true
        },
        S7: {
          type: "list",
          member: {
            locationName: "SourceId"
          }
        },
        S8: {
          type: "list",
          member: {
            locationName: "EventCategory"
          }
        },
        Sb: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sf: {
          type: "structure",
          members: {
            ResourceIdentifier: {},
            PendingMaintenanceActionDetails: {
              type: "list",
              member: {
                locationName: "PendingMaintenanceAction",
                type: "structure",
                members: {
                  Action: {},
                  AutoAppliedAfterDate: {
                    type: "timestamp"
                  },
                  ForcedApplyDate: {
                    type: "timestamp"
                  },
                  OptInStatus: {},
                  CurrentApplyDate: {
                    type: "timestamp"
                  },
                  Description: {}
                }
              }
            }
          },
          wrapper: true
        },
        Sl: {
          type: "structure",
          members: {
            OwnerId: {},
            DBSecurityGroupName: {},
            DBSecurityGroupDescription: {},
            VpcId: {},
            EC2SecurityGroups: {
              type: "list",
              member: {
                locationName: "EC2SecurityGroup",
                type: "structure",
                members: {
                  Status: {},
                  EC2SecurityGroupName: {},
                  EC2SecurityGroupId: {},
                  EC2SecurityGroupOwnerId: {}
                }
              }
            },
            IPRanges: {
              type: "list",
              member: {
                locationName: "IPRange",
                type: "structure",
                members: {
                  Status: {},
                  CIDRIP: {}
                }
              }
            },
            DBSecurityGroupArn: {}
          },
          wrapper: true
        },
        Ss: {
          type: "structure",
          members: {
            DBClusterIdentifier: {},
            BacktrackIdentifier: {},
            BacktrackTo: {
              type: "timestamp"
            },
            BacktrackedFrom: {
              type: "timestamp"
            },
            BacktrackRequestCreationTime: {
              type: "timestamp"
            },
            Status: {}
          }
        },
        Su: {
          type: "structure",
          members: {
            ExportTaskIdentifier: {},
            SourceArn: {},
            ExportOnly: {
              shape: "Sv"
            },
            SnapshotTime: {
              type: "timestamp"
            },
            TaskStartTime: {
              type: "timestamp"
            },
            TaskEndTime: {
              type: "timestamp"
            },
            S3Bucket: {},
            S3Prefix: {},
            IamRoleArn: {},
            KmsKeyId: {},
            Status: {},
            PercentProgress: {
              type: "integer"
            },
            TotalExtractedDataInGB: {
              type: "integer"
            },
            FailureCause: {},
            WarningMessage: {}
          }
        },
        Sv: {
          type: "list",
          member: {}
        },
        Sz: {
          type: "structure",
          members: {
            DBClusterParameterGroupName: {},
            DBParameterGroupFamily: {},
            Description: {},
            DBClusterParameterGroupArn: {}
          },
          wrapper: true
        },
        S12: {
          type: "structure",
          members: {
            AvailabilityZones: {
              shape: "S13"
            },
            DBClusterSnapshotIdentifier: {},
            DBClusterIdentifier: {},
            SnapshotCreateTime: {
              type: "timestamp"
            },
            Engine: {},
            EngineMode: {},
            AllocatedStorage: {
              type: "integer"
            },
            Status: {},
            Port: {
              type: "integer"
            },
            VpcId: {},
            ClusterCreateTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            EngineVersion: {},
            LicenseModel: {},
            SnapshotType: {},
            PercentProgress: {
              type: "integer"
            },
            StorageEncrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            DBClusterSnapshotArn: {},
            SourceDBClusterSnapshotArn: {},
            IAMDatabaseAuthenticationEnabled: {
              type: "boolean"
            },
            TagList: {
              shape: "Sb"
            }
          },
          wrapper: true
        },
        S13: {
          type: "list",
          member: {
            locationName: "AvailabilityZone"
          }
        },
        S16: {
          type: "structure",
          members: {
            DBParameterGroupName: {},
            DBParameterGroupFamily: {},
            Description: {},
            DBParameterGroupArn: {}
          },
          wrapper: true
        },
        S19: {
          type: "structure",
          members: {
            DBSnapshotIdentifier: {},
            DBInstanceIdentifier: {},
            SnapshotCreateTime: {
              type: "timestamp"
            },
            Engine: {},
            AllocatedStorage: {
              type: "integer"
            },
            Status: {},
            Port: {
              type: "integer"
            },
            AvailabilityZone: {},
            VpcId: {},
            InstanceCreateTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            EngineVersion: {},
            LicenseModel: {},
            SnapshotType: {},
            Iops: {
              type: "integer"
            },
            OptionGroupName: {},
            PercentProgress: {
              type: "integer"
            },
            SourceRegion: {},
            SourceDBSnapshotIdentifier: {},
            StorageType: {},
            TdeCredentialArn: {},
            Encrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            DBSnapshotArn: {},
            Timezone: {},
            IAMDatabaseAuthenticationEnabled: {
              type: "boolean"
            },
            ProcessorFeatures: {
              shape: "S1b"
            },
            DbiResourceId: {},
            TagList: {
              shape: "Sb"
            },
            OriginalSnapshotCreateTime: {
              type: "timestamp"
            }
          },
          wrapper: true
        },
        S1b: {
          type: "list",
          member: {
            locationName: "ProcessorFeature",
            type: "structure",
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        S1f: {
          type: "structure",
          members: {
            OptionGroupName: {},
            OptionGroupDescription: {},
            EngineName: {},
            MajorEngineVersion: {},
            Options: {
              type: "list",
              member: {
                locationName: "Option",
                type: "structure",
                members: {
                  OptionName: {},
                  OptionDescription: {},
                  Persistent: {
                    type: "boolean"
                  },
                  Permanent: {
                    type: "boolean"
                  },
                  Port: {
                    type: "integer"
                  },
                  OptionVersion: {},
                  OptionSettings: {
                    type: "list",
                    member: {
                      shape: "S1j",
                      locationName: "OptionSetting"
                    }
                  },
                  DBSecurityGroupMemberships: {
                    shape: "S1k"
                  },
                  VpcSecurityGroupMemberships: {
                    shape: "S1m"
                  }
                }
              }
            },
            AllowsVpcAndNonVpcInstanceMemberships: {
              type: "boolean"
            },
            VpcId: {},
            OptionGroupArn: {}
          },
          wrapper: true
        },
        S1j: {
          type: "structure",
          members: {
            Name: {},
            Value: {},
            DefaultValue: {},
            Description: {},
            ApplyType: {},
            DataType: {},
            AllowedValues: {},
            IsModifiable: {
              type: "boolean"
            },
            IsCollection: {
              type: "boolean"
            }
          }
        },
        S1k: {
          type: "list",
          member: {
            locationName: "DBSecurityGroup",
            type: "structure",
            members: {
              DBSecurityGroupName: {},
              Status: {}
            }
          }
        },
        S1m: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupMembership",
            type: "structure",
            members: {
              VpcSecurityGroupId: {},
              Status: {}
            }
          }
        },
        S1q: {
          type: "structure",
          members: {
            CustomAvailabilityZoneId: {},
            CustomAvailabilityZoneName: {},
            CustomAvailabilityZoneStatus: {},
            VpnDetails: {
              type: "structure",
              members: {
                VpnId: {},
                VpnTunnelOriginatorIP: {},
                VpnGatewayIp: {},
                VpnPSK: {
                  type: "string",
                  sensitive: true
                },
                VpnName: {},
                VpnState: {}
              }
            }
          },
          wrapper: true
        },
        S1u: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupId"
          }
        },
        S1w: {
          type: "list",
          member: {}
        },
        S1x: {
          type: "structure",
          members: {
            MinCapacity: {
              type: "integer"
            },
            MaxCapacity: {
              type: "integer"
            },
            AutoPause: {
              type: "boolean"
            },
            SecondsUntilAutoPause: {
              type: "integer"
            },
            TimeoutAction: {},
            SecondsBeforeTimeout: {
              type: "integer"
            }
          }
        },
        S1z: {
          type: "structure",
          members: {
            AllocatedStorage: {
              type: "integer"
            },
            AvailabilityZones: {
              shape: "S13"
            },
            BackupRetentionPeriod: {
              type: "integer"
            },
            CharacterSetName: {},
            DatabaseName: {},
            DBClusterIdentifier: {},
            DBClusterParameterGroup: {},
            DBSubnetGroup: {},
            Status: {},
            AutomaticRestartTime: {
              type: "timestamp"
            },
            PercentProgress: {},
            EarliestRestorableTime: {
              type: "timestamp"
            },
            Endpoint: {},
            ReaderEndpoint: {},
            CustomEndpoints: {
              shape: "Sv"
            },
            MultiAZ: {
              type: "boolean"
            },
            Engine: {},
            EngineVersion: {},
            LatestRestorableTime: {
              type: "timestamp"
            },
            Port: {
              type: "integer"
            },
            MasterUsername: {},
            DBClusterOptionGroupMemberships: {
              type: "list",
              member: {
                locationName: "DBClusterOptionGroup",
                type: "structure",
                members: {
                  DBClusterOptionGroupName: {},
                  Status: {}
                }
              }
            },
            PreferredBackupWindow: {},
            PreferredMaintenanceWindow: {},
            ReplicationSourceIdentifier: {},
            ReadReplicaIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaIdentifier"
              }
            },
            DBClusterMembers: {
              type: "list",
              member: {
                locationName: "DBClusterMember",
                type: "structure",
                members: {
                  DBInstanceIdentifier: {},
                  IsClusterWriter: {
                    type: "boolean"
                  },
                  DBClusterParameterGroupStatus: {},
                  PromotionTier: {
                    type: "integer"
                  }
                },
                wrapper: true
              }
            },
            VpcSecurityGroups: {
              shape: "S1m"
            },
            HostedZoneId: {},
            StorageEncrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            DbClusterResourceId: {},
            DBClusterArn: {},
            AssociatedRoles: {
              type: "list",
              member: {
                locationName: "DBClusterRole",
                type: "structure",
                members: {
                  RoleArn: {},
                  Status: {},
                  FeatureName: {}
                }
              }
            },
            IAMDatabaseAuthenticationEnabled: {
              type: "boolean"
            },
            CloneGroupId: {},
            ClusterCreateTime: {
              type: "timestamp"
            },
            EarliestBacktrackTime: {
              type: "timestamp"
            },
            BacktrackWindow: {
              type: "long"
            },
            BacktrackConsumedChangeRecords: {
              type: "long"
            },
            EnabledCloudwatchLogsExports: {
              shape: "S1w"
            },
            Capacity: {
              type: "integer"
            },
            EngineMode: {},
            ScalingConfigurationInfo: {
              type: "structure",
              members: {
                MinCapacity: {
                  type: "integer"
                },
                MaxCapacity: {
                  type: "integer"
                },
                AutoPause: {
                  type: "boolean"
                },
                SecondsUntilAutoPause: {
                  type: "integer"
                },
                TimeoutAction: {},
                SecondsBeforeTimeout: {
                  type: "integer"
                }
              }
            },
            DeletionProtection: {
              type: "boolean"
            },
            HttpEndpointEnabled: {
              type: "boolean"
            },
            ActivityStreamMode: {},
            ActivityStreamStatus: {},
            ActivityStreamKmsKeyId: {},
            ActivityStreamKinesisStreamName: {},
            CopyTagsToSnapshot: {
              type: "boolean"
            },
            CrossAccountClone: {
              type: "boolean"
            },
            DomainMemberships: {
              shape: "S2a"
            },
            TagList: {
              shape: "Sb"
            },
            GlobalWriteForwardingStatus: {},
            GlobalWriteForwardingRequested: {
              type: "boolean"
            },
            PendingModifiedValues: {
              type: "structure",
              members: {
                PendingCloudwatchLogsExports: {
                  shape: "S2e"
                },
                DBClusterIdentifier: {},
                MasterUserPassword: {},
                IAMDatabaseAuthenticationEnabled: {
                  type: "boolean"
                },
                EngineVersion: {}
              }
            }
          },
          wrapper: true
        },
        S2a: {
          type: "list",
          member: {
            locationName: "DomainMembership",
            type: "structure",
            members: {
              Domain: {},
              Status: {},
              FQDN: {},
              IAMRoleName: {}
            }
          }
        },
        S2e: {
          type: "structure",
          members: {
            LogTypesToEnable: {
              shape: "S1w"
            },
            LogTypesToDisable: {
              shape: "S1w"
            }
          }
        },
        S2g: {
          type: "structure",
          members: {
            DBClusterEndpointIdentifier: {},
            DBClusterIdentifier: {},
            DBClusterEndpointResourceIdentifier: {},
            Endpoint: {},
            Status: {},
            EndpointType: {},
            CustomEndpointType: {},
            StaticMembers: {
              shape: "Sv"
            },
            ExcludedMembers: {
              shape: "Sv"
            },
            DBClusterEndpointArn: {}
          }
        },
        S2m: {
          type: "list",
          member: {
            locationName: "DBSecurityGroupName"
          }
        },
        S2o: {
          type: "structure",
          members: {
            DBInstanceIdentifier: {},
            DBInstanceClass: {},
            Engine: {},
            DBInstanceStatus: {},
            AutomaticRestartTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            DBName: {},
            Endpoint: {
              shape: "S2p"
            },
            AllocatedStorage: {
              type: "integer"
            },
            InstanceCreateTime: {
              type: "timestamp"
            },
            PreferredBackupWindow: {},
            BackupRetentionPeriod: {
              type: "integer"
            },
            DBSecurityGroups: {
              shape: "S1k"
            },
            VpcSecurityGroups: {
              shape: "S1m"
            },
            DBParameterGroups: {
              type: "list",
              member: {
                locationName: "DBParameterGroup",
                type: "structure",
                members: {
                  DBParameterGroupName: {},
                  ParameterApplyStatus: {}
                }
              }
            },
            AvailabilityZone: {},
            DBSubnetGroup: {
              shape: "S2s"
            },
            PreferredMaintenanceWindow: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                DBInstanceClass: {},
                AllocatedStorage: {
                  type: "integer"
                },
                MasterUserPassword: {},
                Port: {
                  type: "integer"
                },
                BackupRetentionPeriod: {
                  type: "integer"
                },
                MultiAZ: {
                  type: "boolean"
                },
                EngineVersion: {},
                LicenseModel: {},
                Iops: {
                  type: "integer"
                },
                DBInstanceIdentifier: {},
                StorageType: {},
                CACertificateIdentifier: {},
                DBSubnetGroupName: {},
                PendingCloudwatchLogsExports: {
                  shape: "S2e"
                },
                ProcessorFeatures: {
                  shape: "S1b"
                },
                IAMDatabaseAuthenticationEnabled: {
                  type: "boolean"
                }
              }
            },
            LatestRestorableTime: {
              type: "timestamp"
            },
            MultiAZ: {
              type: "boolean"
            },
            EngineVersion: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            ReadReplicaSourceDBInstanceIdentifier: {},
            ReadReplicaDBInstanceIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaDBInstanceIdentifier"
              }
            },
            ReadReplicaDBClusterIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaDBClusterIdentifier"
              }
            },
            ReplicaMode: {},
            LicenseModel: {},
            Iops: {
              type: "integer"
            },
            OptionGroupMemberships: {
              type: "list",
              member: {
                locationName: "OptionGroupMembership",
                type: "structure",
                members: {
                  OptionGroupName: {},
                  Status: {}
                }
              }
            },
            CharacterSetName: {},
            NcharCharacterSetName: {},
            SecondaryAvailabilityZone: {},
            PubliclyAccessible: {
              type: "boolean"
            },
            StatusInfos: {
              type: "list",
              member: {
                locationName: "DBInstanceStatusInfo",
                type: "structure",
                members: {
                  StatusType: {},
                  Normal: {
                    type: "boolean"
                  },
                  Status: {},
                  Message: {}
                }
              }
            },
            StorageType: {},
            TdeCredentialArn: {},
            DbInstancePort: {
              type: "integer"
            },
            DBClusterIdentifier: {},
            StorageEncrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            DbiResourceId: {},
            CACertificateIdentifier: {},
            DomainMemberships: {
              shape: "S2a"
            },
            CopyTagsToSnapshot: {
              type: "boolean"
            },
            MonitoringInterval: {
              type: "integer"
            },
            EnhancedMonitoringResourceArn: {},
            MonitoringRoleArn: {},
            PromotionTier: {
              type: "integer"
            },
            DBInstanceArn: {},
            Timezone: {},
            IAMDatabaseAuthenticationEnabled: {
              type: "boolean"
            },
            PerformanceInsightsEnabled: {
              type: "boolean"
            },
            PerformanceInsightsKMSKeyId: {},
            PerformanceInsightsRetentionPeriod: {
              type: "integer"
            },
            EnabledCloudwatchLogsExports: {
              shape: "S1w"
            },
            ProcessorFeatures: {
              shape: "S1b"
            },
            DeletionProtection: {
              type: "boolean"
            },
            AssociatedRoles: {
              type: "list",
              member: {
                locationName: "DBInstanceRole",
                type: "structure",
                members: {
                  RoleArn: {},
                  FeatureName: {},
                  Status: {}
                }
              }
            },
            ListenerEndpoint: {
              shape: "S2p"
            },
            MaxAllocatedStorage: {
              type: "integer"
            },
            TagList: {
              shape: "Sb"
            },
            DBInstanceAutomatedBackupsReplications: {
              shape: "S37"
            },
            CustomerOwnedIpEnabled: {
              type: "boolean"
            },
            AwsBackupRecoveryPointArn: {},
            ActivityStreamStatus: {},
            ActivityStreamKmsKeyId: {},
            ActivityStreamKinesisStreamName: {},
            ActivityStreamMode: {},
            ActivityStreamEngineNativeAuditFieldsIncluded: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S2p: {
          type: "structure",
          members: {
            Address: {},
            Port: {
              type: "integer"
            },
            HostedZoneId: {}
          }
        },
        S2s: {
          type: "structure",
          members: {
            DBSubnetGroupName: {},
            DBSubnetGroupDescription: {},
            VpcId: {},
            SubnetGroupStatus: {},
            Subnets: {
              type: "list",
              member: {
                locationName: "Subnet",
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {
                    shape: "S2v"
                  },
                  SubnetOutpost: {
                    type: "structure",
                    members: {
                      Arn: {}
                    }
                  },
                  SubnetStatus: {}
                }
              }
            },
            DBSubnetGroupArn: {}
          },
          wrapper: true
        },
        S2v: {
          type: "structure",
          members: {
            Name: {}
          },
          wrapper: true
        },
        S37: {
          type: "list",
          member: {
            locationName: "DBInstanceAutomatedBackupsReplication",
            type: "structure",
            members: {
              DBInstanceAutomatedBackupsArn: {}
            }
          }
        },
        S3f: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Description: {},
              UserName: {},
              AuthScheme: {},
              SecretArn: {},
              IAMAuth: {}
            }
          }
        },
        S3k: {
          type: "structure",
          members: {
            DBProxyName: {},
            DBProxyArn: {},
            Status: {},
            EngineFamily: {},
            VpcId: {},
            VpcSecurityGroupIds: {
              shape: "Sv"
            },
            VpcSubnetIds: {
              shape: "Sv"
            },
            Auth: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Description: {},
                  UserName: {},
                  AuthScheme: {},
                  SecretArn: {},
                  IAMAuth: {}
                }
              }
            },
            RoleArn: {},
            Endpoint: {},
            RequireTLS: {
              type: "boolean"
            },
            IdleClientTimeout: {
              type: "integer"
            },
            DebugLogging: {
              type: "boolean"
            },
            CreatedDate: {
              type: "timestamp"
            },
            UpdatedDate: {
              type: "timestamp"
            }
          }
        },
        S3t: {
          type: "structure",
          members: {
            DBProxyEndpointName: {},
            DBProxyEndpointArn: {},
            DBProxyName: {},
            Status: {},
            VpcId: {},
            VpcSecurityGroupIds: {
              shape: "Sv"
            },
            VpcSubnetIds: {
              shape: "Sv"
            },
            Endpoint: {},
            CreatedDate: {
              type: "timestamp"
            },
            TargetRole: {},
            IsDefault: {
              type: "boolean"
            }
          }
        },
        S40: {
          type: "list",
          member: {
            locationName: "SubnetIdentifier"
          }
        },
        S46: {
          type: "structure",
          members: {
            GlobalClusterIdentifier: {},
            GlobalClusterResourceId: {},
            GlobalClusterArn: {},
            Status: {},
            Engine: {},
            EngineVersion: {},
            DatabaseName: {},
            StorageEncrypted: {
              type: "boolean"
            },
            DeletionProtection: {
              type: "boolean"
            },
            GlobalClusterMembers: {
              type: "list",
              member: {
                locationName: "GlobalClusterMember",
                type: "structure",
                members: {
                  DBClusterArn: {},
                  Readers: {
                    type: "list",
                    member: {}
                  },
                  IsWriter: {
                    type: "boolean"
                  },
                  GlobalWriteForwardingStatus: {}
                },
                wrapper: true
              }
            },
            FailoverState: {
              type: "structure",
              members: {
                Status: {},
                FromDbClusterArn: {},
                ToDbClusterArn: {}
              },
              wrapper: true
            }
          },
          wrapper: true
        },
        S4q: {
          type: "structure",
          members: {
            DBInstanceArn: {},
            DbiResourceId: {},
            Region: {},
            DBInstanceIdentifier: {},
            RestoreWindow: {
              type: "structure",
              members: {
                EarliestTime: {
                  type: "timestamp"
                },
                LatestTime: {
                  type: "timestamp"
                }
              }
            },
            AllocatedStorage: {
              type: "integer"
            },
            Status: {},
            Port: {
              type: "integer"
            },
            AvailabilityZone: {},
            VpcId: {},
            InstanceCreateTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            Engine: {},
            EngineVersion: {},
            LicenseModel: {},
            Iops: {
              type: "integer"
            },
            OptionGroupName: {},
            TdeCredentialArn: {},
            Encrypted: {
              type: "boolean"
            },
            StorageType: {},
            KmsKeyId: {},
            Timezone: {},
            IAMDatabaseAuthenticationEnabled: {
              type: "boolean"
            },
            BackupRetentionPeriod: {
              type: "integer"
            },
            DBInstanceAutomatedBackupsArn: {},
            DBInstanceAutomatedBackupsReplications: {
              shape: "S37"
            }
          },
          wrapper: true
        },
        S56: {
          type: "structure",
          members: {
            InstallationMediaId: {},
            CustomAvailabilityZoneId: {},
            Engine: {},
            EngineVersion: {},
            EngineInstallationMediaPath: {},
            OSInstallationMediaPath: {},
            Status: {},
            FailureCause: {
              type: "structure",
              members: {
                Message: {}
              }
            }
          }
        },
        S5h: {
          type: "list",
          member: {
            locationName: "Filter",
            type: "structure",
            required: [
              "Name",
              "Values"
            ],
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {
                  locationName: "Value"
                }
              }
            }
          }
        },
        S5m: {
          type: "structure",
          members: {
            CertificateIdentifier: {},
            CertificateType: {},
            Thumbprint: {},
            ValidFrom: {
              type: "timestamp"
            },
            ValidTill: {
              type: "timestamp"
            },
            CertificateArn: {},
            CustomerOverride: {
              type: "boolean"
            },
            CustomerOverrideValidTill: {
              type: "timestamp"
            }
          },
          wrapper: true
        },
        S61: {
          type: "list",
          member: {
            locationName: "Parameter",
            type: "structure",
            members: {
              ParameterName: {},
              ParameterValue: {},
              Description: {},
              Source: {},
              ApplyType: {},
              DataType: {},
              AllowedValues: {},
              IsModifiable: {
                type: "boolean"
              },
              MinimumEngineVersion: {},
              ApplyMethod: {},
              SupportedEngineModes: {
                shape: "S64"
              }
            }
          }
        },
        S64: {
          type: "list",
          member: {}
        },
        S67: {
          type: "structure",
          members: {
            DBClusterSnapshotIdentifier: {},
            DBClusterSnapshotAttributes: {
              type: "list",
              member: {
                locationName: "DBClusterSnapshotAttribute",
                type: "structure",
                members: {
                  AttributeName: {},
                  AttributeValues: {
                    shape: "S6a"
                  }
                }
              }
            }
          },
          wrapper: true
        },
        S6a: {
          type: "list",
          member: {
            locationName: "AttributeValue"
          }
        },
        S6l: {
          type: "structure",
          members: {
            CharacterSetName: {},
            CharacterSetDescription: {}
          }
        },
        S6m: {
          type: "list",
          member: {
            shape: "S6l",
            locationName: "CharacterSet"
          }
        },
        S7h: {
          type: "structure",
          members: {
            DBProxyName: {},
            TargetGroupName: {},
            TargetGroupArn: {},
            IsDefault: {
              type: "boolean"
            },
            Status: {},
            ConnectionPoolConfig: {
              type: "structure",
              members: {
                MaxConnectionsPercent: {
                  type: "integer"
                },
                MaxIdleConnectionsPercent: {
                  type: "integer"
                },
                ConnectionBorrowTimeout: {
                  type: "integer"
                },
                SessionPinningFilters: {
                  shape: "Sv"
                },
                InitQuery: {}
              }
            },
            CreatedDate: {
              type: "timestamp"
            },
            UpdatedDate: {
              type: "timestamp"
            }
          }
        },
        S7l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              TargetArn: {},
              Endpoint: {},
              TrackedClusterId: {},
              RdsResourceId: {},
              Port: {
                type: "integer"
              },
              Type: {},
              Role: {},
              TargetHealth: {
                type: "structure",
                members: {
                  State: {},
                  Reason: {},
                  Description: {}
                }
              }
            }
          }
        },
        S7x: {
          type: "structure",
          members: {
            DBSnapshotIdentifier: {},
            DBSnapshotAttributes: {
              type: "list",
              member: {
                locationName: "DBSnapshotAttribute",
                type: "structure",
                members: {
                  AttributeName: {},
                  AttributeValues: {
                    shape: "S6a"
                  }
                },
                wrapper: true
              }
            }
          },
          wrapper: true
        },
        S88: {
          type: "structure",
          members: {
            DBParameterGroupFamily: {},
            Marker: {},
            Parameters: {
              shape: "S61"
            }
          },
          wrapper: true
        },
        S9h: {
          type: "list",
          member: {
            locationName: "AvailableProcessorFeature",
            type: "structure",
            members: {
              Name: {},
              DefaultValue: {},
              AllowedValues: {}
            }
          }
        },
        S9q: {
          type: "structure",
          members: {
            ReservedDBInstanceId: {},
            ReservedDBInstancesOfferingId: {},
            DBInstanceClass: {},
            StartTime: {
              type: "timestamp"
            },
            Duration: {
              type: "integer"
            },
            FixedPrice: {
              type: "double"
            },
            UsagePrice: {
              type: "double"
            },
            CurrencyCode: {},
            DBInstanceCount: {
              type: "integer"
            },
            ProductDescription: {},
            OfferingType: {},
            MultiAZ: {
              type: "boolean"
            },
            State: {},
            RecurringCharges: {
              shape: "S9s"
            },
            ReservedDBInstanceArn: {},
            LeaseId: {}
          },
          wrapper: true
        },
        S9s: {
          type: "list",
          member: {
            locationName: "RecurringCharge",
            type: "structure",
            members: {
              RecurringChargeAmount: {
                type: "double"
              },
              RecurringChargeFrequency: {}
            },
            wrapper: true
          }
        },
        Sa7: {
          type: "list",
          member: {
            locationName: "Range",
            type: "structure",
            members: {
              From: {
                type: "integer"
              },
              To: {
                type: "integer"
              },
              Step: {
                type: "integer"
              }
            }
          }
        },
        Sar: {
          type: "structure",
          members: {
            EnableLogTypes: {
              shape: "S1w"
            },
            DisableLogTypes: {
              shape: "S1w"
            }
          }
        },
        Sav: {
          type: "structure",
          members: {
            DBClusterParameterGroupName: {}
          }
        },
        Sb2: {
          type: "structure",
          members: {
            DBParameterGroupName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-2014-10-31.paginators.json
var require_rds_2014_10_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/rds-2014-10-31.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeCertificates: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Certificates"
        },
        DescribeCustomAvailabilityZones: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "CustomAvailabilityZones"
        },
        DescribeDBClusterBacktracks: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusterBacktracks"
        },
        DescribeDBClusterEndpoints: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusterEndpoints"
        },
        DescribeDBClusterParameterGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusterParameterGroups"
        },
        DescribeDBClusterParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Parameters"
        },
        DescribeDBClusterSnapshots: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusterSnapshots"
        },
        DescribeDBClusters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusters"
        },
        DescribeDBEngineVersions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBEngineVersions"
        },
        DescribeDBInstanceAutomatedBackups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBInstanceAutomatedBackups"
        },
        DescribeDBInstances: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBInstances"
        },
        DescribeDBLogFiles: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DescribeDBLogFiles"
        },
        DescribeDBParameterGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBParameterGroups"
        },
        DescribeDBParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Parameters"
        },
        DescribeDBProxies: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBProxies"
        },
        DescribeDBProxyEndpoints: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBProxyEndpoints"
        },
        DescribeDBProxyTargetGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "TargetGroups"
        },
        DescribeDBProxyTargets: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Targets"
        },
        DescribeDBSecurityGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSecurityGroups"
        },
        DescribeDBSnapshots: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSnapshots"
        },
        DescribeDBSubnetGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSubnetGroups"
        },
        DescribeEngineDefaultParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "EngineDefaults.Marker",
          result_key: "EngineDefaults.Parameters"
        },
        DescribeEventSubscriptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "EventSubscriptionsList"
        },
        DescribeEvents: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Events"
        },
        DescribeExportTasks: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ExportTasks"
        },
        DescribeGlobalClusters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "GlobalClusters"
        },
        DescribeInstallationMedia: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "InstallationMedia"
        },
        DescribeOptionGroupOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OptionGroupOptions"
        },
        DescribeOptionGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OptionGroupsList"
        },
        DescribeOrderableDBInstanceOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OrderableDBInstanceOptions"
        },
        DescribePendingMaintenanceActions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "PendingMaintenanceActions"
        },
        DescribeReservedDBInstances: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedDBInstances"
        },
        DescribeReservedDBInstancesOfferings: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedDBInstancesOfferings"
        },
        DescribeSourceRegions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "SourceRegions"
        },
        DownloadDBLogFilePortion: {
          input_token: "Marker",
          limit_key: "NumberOfLines",
          more_results: "AdditionalDataPending",
          output_token: "Marker",
          result_key: "LogFileData"
        },
        ListTagsForResource: {
          result_key: "TagList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-2014-10-31.waiters2.json
var require_rds_2014_10_31_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/rds-2014-10-31.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DBInstanceAvailable: {
          delay: 30,
          operation: "DescribeDBInstances",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "deleting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "failed",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "incompatible-restore",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "incompatible-parameters",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            }
          ]
        },
        DBInstanceDeleted: {
          delay: 30,
          operation: "DescribeDBInstances",
          maxAttempts: 60,
          acceptors: [
            {
              expected: true,
              matcher: "path",
              state: "success",
              argument: "length(DBInstances) == `0`"
            },
            {
              expected: "DBInstanceNotFound",
              matcher: "error",
              state: "success"
            },
            {
              expected: "creating",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "modifying",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "rebooting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "resetting-master-credentials",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            }
          ]
        },
        DBSnapshotAvailable: {
          delay: 30,
          operation: "DescribeDBSnapshots",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "DBSnapshots[].Status"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "DBSnapshots[].Status"
            },
            {
              expected: "deleting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBSnapshots[].Status"
            },
            {
              expected: "failed",
              matcher: "pathAny",
              state: "failure",
              argument: "DBSnapshots[].Status"
            },
            {
              expected: "incompatible-restore",
              matcher: "pathAny",
              state: "failure",
              argument: "DBSnapshots[].Status"
            },
            {
              expected: "incompatible-parameters",
              matcher: "pathAny",
              state: "failure",
              argument: "DBSnapshots[].Status"
            }
          ]
        },
        DBSnapshotDeleted: {
          delay: 30,
          operation: "DescribeDBSnapshots",
          maxAttempts: 60,
          acceptors: [
            {
              expected: true,
              matcher: "path",
              state: "success",
              argument: "length(DBSnapshots) == `0`"
            },
            {
              expected: "DBSnapshotNotFound",
              matcher: "error",
              state: "success"
            },
            {
              expected: "creating",
              matcher: "pathAny",
              state: "failure",
              argument: "DBSnapshots[].Status"
            },
            {
              expected: "modifying",
              matcher: "pathAny",
              state: "failure",
              argument: "DBSnapshots[].Status"
            },
            {
              expected: "rebooting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBSnapshots[].Status"
            },
            {
              expected: "resetting-master-credentials",
              matcher: "pathAny",
              state: "failure",
              argument: "DBSnapshots[].Status"
            }
          ]
        },
        DBClusterSnapshotAvailable: {
          delay: 30,
          operation: "DescribeDBClusterSnapshots",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "DBClusterSnapshots[].Status"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusterSnapshots[].Status"
            },
            {
              expected: "deleting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusterSnapshots[].Status"
            },
            {
              expected: "failed",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusterSnapshots[].Status"
            },
            {
              expected: "incompatible-restore",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusterSnapshots[].Status"
            },
            {
              expected: "incompatible-parameters",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusterSnapshots[].Status"
            }
          ]
        },
        DBClusterSnapshotDeleted: {
          delay: 30,
          operation: "DescribeDBClusterSnapshots",
          maxAttempts: 60,
          acceptors: [
            {
              expected: true,
              matcher: "path",
              state: "success",
              argument: "length(DBClusterSnapshots) == `0`"
            },
            {
              expected: "DBClusterSnapshotNotFoundFault",
              matcher: "error",
              state: "success"
            },
            {
              expected: "creating",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusterSnapshots[].Status"
            },
            {
              expected: "modifying",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusterSnapshots[].Status"
            },
            {
              expected: "rebooting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusterSnapshots[].Status"
            },
            {
              expected: "resetting-master-credentials",
              matcher: "pathAny",
              state: "failure",
              argument: "DBClusterSnapshots[].Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/rds.js
var require_rds2 = __commonJS({
  "node_modules/aws-sdk/clients/rds.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["rds"] = {};
    AWS3.RDS = Service.defineService("rds", ["2013-01-10", "2013-02-12", "2013-09-09", "2014-09-01", "2014-09-01*", "2014-10-31"]);
    require_rds();
    Object.defineProperty(apiLoader.services["rds"], "2013-01-10", {
      get: function get() {
        var model = require_rds_2013_01_10_min();
        model.paginators = require_rds_2013_01_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["rds"], "2013-02-12", {
      get: function get() {
        var model = require_rds_2013_02_12_min();
        model.paginators = require_rds_2013_02_12_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["rds"], "2013-09-09", {
      get: function get() {
        var model = require_rds_2013_09_09_min();
        model.paginators = require_rds_2013_09_09_paginators().pagination;
        model.waiters = require_rds_2013_09_09_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["rds"], "2014-09-01", {
      get: function get() {
        var model = require_rds_2014_09_01_min();
        model.paginators = require_rds_2014_09_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["rds"], "2014-10-31", {
      get: function get() {
        var model = require_rds_2014_10_31_min();
        model.paginators = require_rds_2014_10_31_paginators().pagination;
        model.waiters = require_rds_2014_10_31_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.RDS;
  }
});

// node_modules/aws-sdk/apis/redshift-2012-12-01.min.json
var require_redshift_2012_12_01_min = __commonJS({
  "node_modules/aws-sdk/apis/redshift-2012-12-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2012-12-01",
        endpointPrefix: "redshift",
        protocol: "query",
        serviceFullName: "Amazon Redshift",
        serviceId: "Redshift",
        signatureVersion: "v4",
        uid: "redshift-2012-12-01",
        xmlNamespace: "http://redshift.amazonaws.com/doc/2012-12-01/"
      },
      operations: {
        AcceptReservedNodeExchange: {
          input: {
            type: "structure",
            required: [
              "ReservedNodeId",
              "TargetReservedNodeOfferingId"
            ],
            members: {
              ReservedNodeId: {},
              TargetReservedNodeOfferingId: {}
            }
          },
          output: {
            resultWrapper: "AcceptReservedNodeExchangeResult",
            type: "structure",
            members: {
              ExchangedReservedNode: {
                shape: "S4"
              }
            }
          }
        },
        AddPartner: {
          input: {
            shape: "Sb"
          },
          output: {
            shape: "Sg",
            resultWrapper: "AddPartnerResult"
          }
        },
        AssociateDataShareConsumer: {
          input: {
            type: "structure",
            required: [
              "DataShareArn"
            ],
            members: {
              DataShareArn: {},
              AssociateEntireAccount: {
                type: "boolean"
              },
              ConsumerArn: {}
            }
          },
          output: {
            shape: "Sj",
            resultWrapper: "AssociateDataShareConsumerResult"
          }
        },
        AuthorizeClusterSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "ClusterSecurityGroupName"
            ],
            members: {
              ClusterSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "AuthorizeClusterSecurityGroupIngressResult",
            type: "structure",
            members: {
              ClusterSecurityGroup: {
                shape: "Sq"
              }
            }
          }
        },
        AuthorizeDataShare: {
          input: {
            type: "structure",
            required: [
              "DataShareArn",
              "ConsumerIdentifier"
            ],
            members: {
              DataShareArn: {},
              ConsumerIdentifier: {}
            }
          },
          output: {
            shape: "Sj",
            resultWrapper: "AuthorizeDataShareResult"
          }
        },
        AuthorizeEndpointAccess: {
          input: {
            type: "structure",
            required: [
              "Account"
            ],
            members: {
              ClusterIdentifier: {},
              Account: {},
              VpcIds: {
                shape: "Sz"
              }
            }
          },
          output: {
            shape: "S10",
            resultWrapper: "AuthorizeEndpointAccessResult"
          }
        },
        AuthorizeSnapshotAccess: {
          input: {
            type: "structure",
            required: [
              "SnapshotIdentifier",
              "AccountWithRestoreAccess"
            ],
            members: {
              SnapshotIdentifier: {},
              SnapshotClusterIdentifier: {},
              AccountWithRestoreAccess: {}
            }
          },
          output: {
            resultWrapper: "AuthorizeSnapshotAccessResult",
            type: "structure",
            members: {
              Snapshot: {
                shape: "S14"
              }
            }
          }
        },
        BatchDeleteClusterSnapshots: {
          input: {
            type: "structure",
            required: [
              "Identifiers"
            ],
            members: {
              Identifiers: {
                type: "list",
                member: {
                  shape: "S1c",
                  locationName: "DeleteClusterSnapshotMessage"
                }
              }
            }
          },
          output: {
            resultWrapper: "BatchDeleteClusterSnapshotsResult",
            type: "structure",
            members: {
              Resources: {
                shape: "S1e"
              },
              Errors: {
                type: "list",
                member: {
                  shape: "S1g",
                  locationName: "SnapshotErrorMessage"
                }
              }
            }
          }
        },
        BatchModifyClusterSnapshots: {
          input: {
            type: "structure",
            required: [
              "SnapshotIdentifierList"
            ],
            members: {
              SnapshotIdentifierList: {
                shape: "S1e"
              },
              ManualSnapshotRetentionPeriod: {
                type: "integer"
              },
              Force: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "BatchModifyClusterSnapshotsResult",
            type: "structure",
            members: {
              Resources: {
                shape: "S1e"
              },
              Errors: {
                type: "list",
                member: {
                  shape: "S1g",
                  locationName: "SnapshotErrorMessage"
                }
              }
            }
          }
        },
        CancelResize: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {}
            }
          },
          output: {
            shape: "S1l",
            resultWrapper: "CancelResizeResult"
          }
        },
        CopyClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceSnapshotIdentifier",
              "TargetSnapshotIdentifier"
            ],
            members: {
              SourceSnapshotIdentifier: {},
              SourceSnapshotClusterIdentifier: {},
              TargetSnapshotIdentifier: {},
              ManualSnapshotRetentionPeriod: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "CopyClusterSnapshotResult",
            type: "structure",
            members: {
              Snapshot: {
                shape: "S14"
              }
            }
          }
        },
        CreateAuthenticationProfile: {
          input: {
            type: "structure",
            required: [
              "AuthenticationProfileName",
              "AuthenticationProfileContent"
            ],
            members: {
              AuthenticationProfileName: {},
              AuthenticationProfileContent: {}
            }
          },
          output: {
            resultWrapper: "CreateAuthenticationProfileResult",
            type: "structure",
            members: {
              AuthenticationProfileName: {},
              AuthenticationProfileContent: {}
            }
          }
        },
        CreateCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "NodeType",
              "MasterUsername",
              "MasterUserPassword"
            ],
            members: {
              DBName: {},
              ClusterIdentifier: {},
              ClusterType: {},
              NodeType: {},
              MasterUsername: {},
              MasterUserPassword: {},
              ClusterSecurityGroups: {
                shape: "S1x"
              },
              VpcSecurityGroupIds: {
                shape: "S1y"
              },
              ClusterSubnetGroupName: {},
              AvailabilityZone: {},
              PreferredMaintenanceWindow: {},
              ClusterParameterGroupName: {},
              AutomatedSnapshotRetentionPeriod: {
                type: "integer"
              },
              ManualSnapshotRetentionPeriod: {
                type: "integer"
              },
              Port: {
                type: "integer"
              },
              ClusterVersion: {},
              AllowVersionUpgrade: {
                type: "boolean"
              },
              NumberOfNodes: {
                type: "integer"
              },
              PubliclyAccessible: {
                type: "boolean"
              },
              Encrypted: {
                type: "boolean"
              },
              HsmClientCertificateIdentifier: {},
              HsmConfigurationIdentifier: {},
              ElasticIp: {},
              Tags: {
                shape: "St"
              },
              KmsKeyId: {},
              EnhancedVpcRouting: {
                type: "boolean"
              },
              AdditionalInfo: {},
              IamRoles: {
                shape: "S1z"
              },
              MaintenanceTrackName: {},
              SnapshotScheduleIdentifier: {},
              AvailabilityZoneRelocation: {
                type: "boolean"
              },
              AquaConfigurationStatus: {}
            }
          },
          output: {
            resultWrapper: "CreateClusterResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S22"
              }
            }
          }
        },
        CreateClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName",
              "ParameterGroupFamily",
              "Description"
            ],
            members: {
              ParameterGroupName: {},
              ParameterGroupFamily: {},
              Description: {},
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            resultWrapper: "CreateClusterParameterGroupResult",
            type: "structure",
            members: {
              ClusterParameterGroup: {
                shape: "S2z"
              }
            }
          }
        },
        CreateClusterSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "ClusterSecurityGroupName",
              "Description"
            ],
            members: {
              ClusterSecurityGroupName: {},
              Description: {},
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            resultWrapper: "CreateClusterSecurityGroupResult",
            type: "structure",
            members: {
              ClusterSecurityGroup: {
                shape: "Sq"
              }
            }
          }
        },
        CreateClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "SnapshotIdentifier",
              "ClusterIdentifier"
            ],
            members: {
              SnapshotIdentifier: {},
              ClusterIdentifier: {},
              ManualSnapshotRetentionPeriod: {
                type: "integer"
              },
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            resultWrapper: "CreateClusterSnapshotResult",
            type: "structure",
            members: {
              Snapshot: {
                shape: "S14"
              }
            }
          }
        },
        CreateClusterSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "ClusterSubnetGroupName",
              "Description",
              "SubnetIds"
            ],
            members: {
              ClusterSubnetGroupName: {},
              Description: {},
              SubnetIds: {
                shape: "S35"
              },
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            resultWrapper: "CreateClusterSubnetGroupResult",
            type: "structure",
            members: {
              ClusterSubnetGroup: {
                shape: "S37"
              }
            }
          }
        },
        CreateEndpointAccess: {
          input: {
            type: "structure",
            required: [
              "EndpointName",
              "SubnetGroupName"
            ],
            members: {
              ClusterIdentifier: {},
              ResourceOwner: {},
              EndpointName: {},
              SubnetGroupName: {},
              VpcSecurityGroupIds: {
                shape: "S1y"
              }
            }
          },
          output: {
            shape: "S3e",
            resultWrapper: "CreateEndpointAccessResult"
          }
        },
        CreateEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SnsTopicArn"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              SourceIds: {
                shape: "S3g"
              },
              EventCategories: {
                shape: "S3h"
              },
              Severity: {},
              Enabled: {
                type: "boolean"
              },
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            resultWrapper: "CreateEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S3j"
              }
            }
          }
        },
        CreateHsmClientCertificate: {
          input: {
            type: "structure",
            required: [
              "HsmClientCertificateIdentifier"
            ],
            members: {
              HsmClientCertificateIdentifier: {},
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            resultWrapper: "CreateHsmClientCertificateResult",
            type: "structure",
            members: {
              HsmClientCertificate: {
                shape: "S3m"
              }
            }
          }
        },
        CreateHsmConfiguration: {
          input: {
            type: "structure",
            required: [
              "HsmConfigurationIdentifier",
              "Description",
              "HsmIpAddress",
              "HsmPartitionName",
              "HsmPartitionPassword",
              "HsmServerPublicCertificate"
            ],
            members: {
              HsmConfigurationIdentifier: {},
              Description: {},
              HsmIpAddress: {},
              HsmPartitionName: {},
              HsmPartitionPassword: {},
              HsmServerPublicCertificate: {},
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            resultWrapper: "CreateHsmConfigurationResult",
            type: "structure",
            members: {
              HsmConfiguration: {
                shape: "S3p"
              }
            }
          }
        },
        CreateScheduledAction: {
          input: {
            type: "structure",
            required: [
              "ScheduledActionName",
              "TargetAction",
              "Schedule",
              "IamRole"
            ],
            members: {
              ScheduledActionName: {},
              TargetAction: {
                shape: "S3r"
              },
              Schedule: {},
              IamRole: {},
              ScheduledActionDescription: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Enable: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S3v",
            resultWrapper: "CreateScheduledActionResult"
          }
        },
        CreateSnapshotCopyGrant: {
          input: {
            type: "structure",
            required: [
              "SnapshotCopyGrantName"
            ],
            members: {
              SnapshotCopyGrantName: {},
              KmsKeyId: {},
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            resultWrapper: "CreateSnapshotCopyGrantResult",
            type: "structure",
            members: {
              SnapshotCopyGrant: {
                shape: "S40"
              }
            }
          }
        },
        CreateSnapshotSchedule: {
          input: {
            type: "structure",
            members: {
              ScheduleDefinitions: {
                shape: "S42"
              },
              ScheduleIdentifier: {},
              ScheduleDescription: {},
              Tags: {
                shape: "St"
              },
              DryRun: {
                type: "boolean"
              },
              NextInvocations: {
                type: "integer"
              }
            }
          },
          output: {
            shape: "S43",
            resultWrapper: "CreateSnapshotScheduleResult"
          }
        },
        CreateTags: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "Tags"
            ],
            members: {
              ResourceName: {},
              Tags: {
                shape: "St"
              }
            }
          }
        },
        CreateUsageLimit: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "FeatureType",
              "LimitType",
              "Amount"
            ],
            members: {
              ClusterIdentifier: {},
              FeatureType: {},
              LimitType: {},
              Amount: {
                type: "long"
              },
              Period: {},
              BreachAction: {},
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            shape: "S4d",
            resultWrapper: "CreateUsageLimitResult"
          }
        },
        DeauthorizeDataShare: {
          input: {
            type: "structure",
            required: [
              "DataShareArn",
              "ConsumerIdentifier"
            ],
            members: {
              DataShareArn: {},
              ConsumerIdentifier: {}
            }
          },
          output: {
            shape: "Sj",
            resultWrapper: "DeauthorizeDataShareResult"
          }
        },
        DeleteAuthenticationProfile: {
          input: {
            type: "structure",
            required: [
              "AuthenticationProfileName"
            ],
            members: {
              AuthenticationProfileName: {}
            }
          },
          output: {
            resultWrapper: "DeleteAuthenticationProfileResult",
            type: "structure",
            members: {
              AuthenticationProfileName: {}
            }
          }
        },
        DeleteCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {},
              SkipFinalClusterSnapshot: {
                type: "boolean"
              },
              FinalClusterSnapshotIdentifier: {},
              FinalClusterSnapshotRetentionPeriod: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DeleteClusterResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S22"
              }
            }
          }
        },
        DeleteClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName"
            ],
            members: {
              ParameterGroupName: {}
            }
          }
        },
        DeleteClusterSecurityGroup: {
          input: {
            type: "structure",
            required: [
              "ClusterSecurityGroupName"
            ],
            members: {
              ClusterSecurityGroupName: {}
            }
          }
        },
        DeleteClusterSnapshot: {
          input: {
            shape: "S1c"
          },
          output: {
            resultWrapper: "DeleteClusterSnapshotResult",
            type: "structure",
            members: {
              Snapshot: {
                shape: "S14"
              }
            }
          }
        },
        DeleteClusterSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "ClusterSubnetGroupName"
            ],
            members: {
              ClusterSubnetGroupName: {}
            }
          }
        },
        DeleteEndpointAccess: {
          input: {
            type: "structure",
            required: [
              "EndpointName"
            ],
            members: {
              EndpointName: {}
            }
          },
          output: {
            shape: "S3e",
            resultWrapper: "DeleteEndpointAccessResult"
          }
        },
        DeleteEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {}
            }
          }
        },
        DeleteHsmClientCertificate: {
          input: {
            type: "structure",
            required: [
              "HsmClientCertificateIdentifier"
            ],
            members: {
              HsmClientCertificateIdentifier: {}
            }
          }
        },
        DeleteHsmConfiguration: {
          input: {
            type: "structure",
            required: [
              "HsmConfigurationIdentifier"
            ],
            members: {
              HsmConfigurationIdentifier: {}
            }
          }
        },
        DeletePartner: {
          input: {
            shape: "Sb"
          },
          output: {
            shape: "Sg",
            resultWrapper: "DeletePartnerResult"
          }
        },
        DeleteScheduledAction: {
          input: {
            type: "structure",
            required: [
              "ScheduledActionName"
            ],
            members: {
              ScheduledActionName: {}
            }
          }
        },
        DeleteSnapshotCopyGrant: {
          input: {
            type: "structure",
            required: [
              "SnapshotCopyGrantName"
            ],
            members: {
              SnapshotCopyGrantName: {}
            }
          }
        },
        DeleteSnapshotSchedule: {
          input: {
            type: "structure",
            required: [
              "ScheduleIdentifier"
            ],
            members: {
              ScheduleIdentifier: {}
            }
          }
        },
        DeleteTags: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "TagKeys"
            ],
            members: {
              ResourceName: {},
              TagKeys: {
                shape: "S4v"
              }
            }
          }
        },
        DeleteUsageLimit: {
          input: {
            type: "structure",
            required: [
              "UsageLimitId"
            ],
            members: {
              UsageLimitId: {}
            }
          }
        },
        DescribeAccountAttributes: {
          input: {
            type: "structure",
            members: {
              AttributeNames: {
                type: "list",
                member: {
                  locationName: "AttributeName"
                }
              }
            }
          },
          output: {
            resultWrapper: "DescribeAccountAttributesResult",
            type: "structure",
            members: {
              AccountAttributes: {
                type: "list",
                member: {
                  locationName: "AccountAttribute",
                  type: "structure",
                  members: {
                    AttributeName: {},
                    AttributeValues: {
                      type: "list",
                      member: {
                        locationName: "AttributeValueTarget",
                        type: "structure",
                        members: {
                          AttributeValue: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeAuthenticationProfiles: {
          input: {
            type: "structure",
            members: {
              AuthenticationProfileName: {}
            }
          },
          output: {
            resultWrapper: "DescribeAuthenticationProfilesResult",
            type: "structure",
            members: {
              AuthenticationProfiles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AuthenticationProfileName: {},
                    AuthenticationProfileContent: {}
                  }
                }
              }
            }
          }
        },
        DescribeClusterDbRevisions: {
          input: {
            type: "structure",
            members: {
              ClusterIdentifier: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeClusterDbRevisionsResult",
            type: "structure",
            members: {
              Marker: {},
              ClusterDbRevisions: {
                type: "list",
                member: {
                  locationName: "ClusterDbRevision",
                  type: "structure",
                  members: {
                    ClusterIdentifier: {},
                    CurrentDatabaseRevision: {},
                    DatabaseRevisionReleaseDate: {
                      type: "timestamp"
                    },
                    RevisionTargets: {
                      type: "list",
                      member: {
                        locationName: "RevisionTarget",
                        type: "structure",
                        members: {
                          DatabaseRevision: {},
                          Description: {},
                          DatabaseRevisionReleaseDate: {
                            type: "timestamp"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeClusterParameterGroups: {
          input: {
            type: "structure",
            members: {
              ParameterGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              TagKeys: {
                shape: "S4v"
              },
              TagValues: {
                shape: "S5f"
              }
            }
          },
          output: {
            resultWrapper: "DescribeClusterParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              ParameterGroups: {
                type: "list",
                member: {
                  shape: "S2z",
                  locationName: "ClusterParameterGroup"
                }
              }
            }
          }
        },
        DescribeClusterParameters: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName"
            ],
            members: {
              ParameterGroupName: {},
              Source: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeClusterParametersResult",
            type: "structure",
            members: {
              Parameters: {
                shape: "S5k"
              },
              Marker: {}
            }
          }
        },
        DescribeClusterSecurityGroups: {
          input: {
            type: "structure",
            members: {
              ClusterSecurityGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              TagKeys: {
                shape: "S4v"
              },
              TagValues: {
                shape: "S5f"
              }
            }
          },
          output: {
            resultWrapper: "DescribeClusterSecurityGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              ClusterSecurityGroups: {
                type: "list",
                member: {
                  shape: "Sq",
                  locationName: "ClusterSecurityGroup"
                }
              }
            }
          }
        },
        DescribeClusterSnapshots: {
          input: {
            type: "structure",
            members: {
              ClusterIdentifier: {},
              SnapshotIdentifier: {},
              SnapshotType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              OwnerAccount: {},
              TagKeys: {
                shape: "S4v"
              },
              TagValues: {
                shape: "S5f"
              },
              ClusterExists: {
                type: "boolean"
              },
              SortingEntities: {
                type: "list",
                member: {
                  locationName: "SnapshotSortingEntity",
                  type: "structure",
                  required: [
                    "Attribute"
                  ],
                  members: {
                    Attribute: {},
                    SortOrder: {}
                  }
                }
              }
            }
          },
          output: {
            resultWrapper: "DescribeClusterSnapshotsResult",
            type: "structure",
            members: {
              Marker: {},
              Snapshots: {
                type: "list",
                member: {
                  shape: "S14",
                  locationName: "Snapshot"
                }
              }
            }
          }
        },
        DescribeClusterSubnetGroups: {
          input: {
            type: "structure",
            members: {
              ClusterSubnetGroupName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              TagKeys: {
                shape: "S4v"
              },
              TagValues: {
                shape: "S5f"
              }
            }
          },
          output: {
            resultWrapper: "DescribeClusterSubnetGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              ClusterSubnetGroups: {
                type: "list",
                member: {
                  shape: "S37",
                  locationName: "ClusterSubnetGroup"
                }
              }
            }
          }
        },
        DescribeClusterTracks: {
          input: {
            type: "structure",
            members: {
              MaintenanceTrackName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeClusterTracksResult",
            type: "structure",
            members: {
              MaintenanceTracks: {
                type: "list",
                member: {
                  locationName: "MaintenanceTrack",
                  type: "structure",
                  members: {
                    MaintenanceTrackName: {},
                    DatabaseVersion: {},
                    UpdateTargets: {
                      type: "list",
                      member: {
                        locationName: "UpdateTarget",
                        type: "structure",
                        members: {
                          MaintenanceTrackName: {},
                          DatabaseVersion: {},
                          SupportedOperations: {
                            type: "list",
                            member: {
                              locationName: "SupportedOperation",
                              type: "structure",
                              members: {
                                OperationName: {}
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeClusterVersions: {
          input: {
            type: "structure",
            members: {
              ClusterVersion: {},
              ClusterParameterGroupFamily: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeClusterVersionsResult",
            type: "structure",
            members: {
              Marker: {},
              ClusterVersions: {
                type: "list",
                member: {
                  locationName: "ClusterVersion",
                  type: "structure",
                  members: {
                    ClusterVersion: {},
                    ClusterParameterGroupFamily: {},
                    Description: {}
                  }
                }
              }
            }
          }
        },
        DescribeClusters: {
          input: {
            type: "structure",
            members: {
              ClusterIdentifier: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              TagKeys: {
                shape: "S4v"
              },
              TagValues: {
                shape: "S5f"
              }
            }
          },
          output: {
            resultWrapper: "DescribeClustersResult",
            type: "structure",
            members: {
              Marker: {},
              Clusters: {
                type: "list",
                member: {
                  shape: "S22",
                  locationName: "Cluster"
                }
              }
            }
          }
        },
        DescribeDataShares: {
          input: {
            type: "structure",
            members: {
              DataShareArn: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDataSharesResult",
            type: "structure",
            members: {
              DataShares: {
                shape: "S6h"
              },
              Marker: {}
            }
          }
        },
        DescribeDataSharesForConsumer: {
          input: {
            type: "structure",
            members: {
              ConsumerArn: {},
              Status: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDataSharesForConsumerResult",
            type: "structure",
            members: {
              DataShares: {
                shape: "S6h"
              },
              Marker: {}
            }
          }
        },
        DescribeDataSharesForProducer: {
          input: {
            type: "structure",
            members: {
              ProducerArn: {},
              Status: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDataSharesForProducerResult",
            type: "structure",
            members: {
              DataShares: {
                shape: "S6h"
              },
              Marker: {}
            }
          }
        },
        DescribeDefaultClusterParameters: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupFamily"
            ],
            members: {
              ParameterGroupFamily: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDefaultClusterParametersResult",
            type: "structure",
            members: {
              DefaultClusterParameters: {
                type: "structure",
                members: {
                  ParameterGroupFamily: {},
                  Marker: {},
                  Parameters: {
                    shape: "S5k"
                  }
                },
                wrapper: true
              }
            }
          }
        },
        DescribeEndpointAccess: {
          input: {
            type: "structure",
            members: {
              ClusterIdentifier: {},
              ResourceOwner: {},
              EndpointName: {},
              VpcId: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEndpointAccessResult",
            type: "structure",
            members: {
              EndpointAccessList: {
                type: "list",
                member: {
                  shape: "S3e"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeEndpointAuthorization: {
          input: {
            type: "structure",
            members: {
              ClusterIdentifier: {},
              Account: {},
              Grantee: {
                type: "boolean"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEndpointAuthorizationResult",
            type: "structure",
            members: {
              EndpointAuthorizationList: {
                type: "list",
                member: {
                  shape: "S10"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeEventCategories: {
          input: {
            type: "structure",
            members: {
              SourceType: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventCategoriesResult",
            type: "structure",
            members: {
              EventCategoriesMapList: {
                type: "list",
                member: {
                  locationName: "EventCategoriesMap",
                  type: "structure",
                  members: {
                    SourceType: {},
                    Events: {
                      type: "list",
                      member: {
                        locationName: "EventInfoMap",
                        type: "structure",
                        members: {
                          EventId: {},
                          EventCategories: {
                            shape: "S3h"
                          },
                          EventDescription: {},
                          Severity: {}
                        },
                        wrapper: true
                      }
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeEventSubscriptions: {
          input: {
            type: "structure",
            members: {
              SubscriptionName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              TagKeys: {
                shape: "S4v"
              },
              TagValues: {
                shape: "S5f"
              }
            }
          },
          output: {
            resultWrapper: "DescribeEventSubscriptionsResult",
            type: "structure",
            members: {
              Marker: {},
              EventSubscriptionsList: {
                type: "list",
                member: {
                  shape: "S3j",
                  locationName: "EventSubscription"
                }
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceIdentifier: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventsResult",
            type: "structure",
            members: {
              Marker: {},
              Events: {
                type: "list",
                member: {
                  locationName: "Event",
                  type: "structure",
                  members: {
                    SourceIdentifier: {},
                    SourceType: {},
                    Message: {},
                    EventCategories: {
                      shape: "S3h"
                    },
                    Severity: {},
                    Date: {
                      type: "timestamp"
                    },
                    EventId: {}
                  }
                }
              }
            }
          }
        },
        DescribeHsmClientCertificates: {
          input: {
            type: "structure",
            members: {
              HsmClientCertificateIdentifier: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              TagKeys: {
                shape: "S4v"
              },
              TagValues: {
                shape: "S5f"
              }
            }
          },
          output: {
            resultWrapper: "DescribeHsmClientCertificatesResult",
            type: "structure",
            members: {
              Marker: {},
              HsmClientCertificates: {
                type: "list",
                member: {
                  shape: "S3m",
                  locationName: "HsmClientCertificate"
                }
              }
            }
          }
        },
        DescribeHsmConfigurations: {
          input: {
            type: "structure",
            members: {
              HsmConfigurationIdentifier: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              TagKeys: {
                shape: "S4v"
              },
              TagValues: {
                shape: "S5f"
              }
            }
          },
          output: {
            resultWrapper: "DescribeHsmConfigurationsResult",
            type: "structure",
            members: {
              Marker: {},
              HsmConfigurations: {
                type: "list",
                member: {
                  shape: "S3p",
                  locationName: "HsmConfiguration"
                }
              }
            }
          }
        },
        DescribeLoggingStatus: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {}
            }
          },
          output: {
            shape: "S7i",
            resultWrapper: "DescribeLoggingStatusResult"
          }
        },
        DescribeNodeConfigurationOptions: {
          input: {
            type: "structure",
            required: [
              "ActionType"
            ],
            members: {
              ActionType: {},
              ClusterIdentifier: {},
              SnapshotIdentifier: {},
              OwnerAccount: {},
              Filters: {
                locationName: "Filter",
                type: "list",
                member: {
                  locationName: "NodeConfigurationOptionsFilter",
                  type: "structure",
                  members: {
                    Name: {},
                    Operator: {},
                    Values: {
                      shape: "S7p",
                      locationName: "Value"
                    }
                  }
                }
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeNodeConfigurationOptionsResult",
            type: "structure",
            members: {
              NodeConfigurationOptionList: {
                type: "list",
                member: {
                  locationName: "NodeConfigurationOption",
                  type: "structure",
                  members: {
                    NodeType: {},
                    NumberOfNodes: {
                      type: "integer"
                    },
                    EstimatedDiskUtilizationPercent: {
                      type: "double"
                    },
                    Mode: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeOrderableClusterOptions: {
          input: {
            type: "structure",
            members: {
              ClusterVersion: {},
              NodeType: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOrderableClusterOptionsResult",
            type: "structure",
            members: {
              OrderableClusterOptions: {
                type: "list",
                member: {
                  locationName: "OrderableClusterOption",
                  type: "structure",
                  members: {
                    ClusterVersion: {},
                    ClusterType: {},
                    NodeType: {},
                    AvailabilityZones: {
                      type: "list",
                      member: {
                        shape: "S3a",
                        locationName: "AvailabilityZone"
                      }
                    }
                  },
                  wrapper: true
                }
              },
              Marker: {}
            }
          }
        },
        DescribePartners: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "ClusterIdentifier"
            ],
            members: {
              AccountId: {},
              ClusterIdentifier: {},
              DatabaseName: {},
              PartnerName: {}
            }
          },
          output: {
            resultWrapper: "DescribePartnersResult",
            type: "structure",
            members: {
              PartnerIntegrationInfoList: {
                type: "list",
                member: {
                  locationName: "PartnerIntegrationInfo",
                  type: "structure",
                  members: {
                    DatabaseName: {},
                    PartnerName: {},
                    Status: {},
                    StatusMessage: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeReservedNodeOfferings: {
          input: {
            type: "structure",
            members: {
              ReservedNodeOfferingId: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedNodeOfferingsResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedNodeOfferings: {
                shape: "S87"
              }
            }
          }
        },
        DescribeReservedNodes: {
          input: {
            type: "structure",
            members: {
              ReservedNodeId: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeReservedNodesResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedNodes: {
                type: "list",
                member: {
                  shape: "S4",
                  locationName: "ReservedNode"
                }
              }
            }
          }
        },
        DescribeResize: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {}
            }
          },
          output: {
            shape: "S1l",
            resultWrapper: "DescribeResizeResult"
          }
        },
        DescribeScheduledActions: {
          input: {
            type: "structure",
            members: {
              ScheduledActionName: {},
              TargetActionType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Active: {
                type: "boolean"
              },
              Filters: {
                type: "list",
                member: {
                  locationName: "ScheduledActionFilter",
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S7p"
                    }
                  }
                }
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeScheduledActionsResult",
            type: "structure",
            members: {
              Marker: {},
              ScheduledActions: {
                type: "list",
                member: {
                  shape: "S3v",
                  locationName: "ScheduledAction"
                }
              }
            }
          }
        },
        DescribeSnapshotCopyGrants: {
          input: {
            type: "structure",
            members: {
              SnapshotCopyGrantName: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              TagKeys: {
                shape: "S4v"
              },
              TagValues: {
                shape: "S5f"
              }
            }
          },
          output: {
            resultWrapper: "DescribeSnapshotCopyGrantsResult",
            type: "structure",
            members: {
              Marker: {},
              SnapshotCopyGrants: {
                type: "list",
                member: {
                  shape: "S40",
                  locationName: "SnapshotCopyGrant"
                }
              }
            }
          }
        },
        DescribeSnapshotSchedules: {
          input: {
            type: "structure",
            members: {
              ClusterIdentifier: {},
              ScheduleIdentifier: {},
              TagKeys: {
                shape: "S4v"
              },
              TagValues: {
                shape: "S5f"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribeSnapshotSchedulesResult",
            type: "structure",
            members: {
              SnapshotSchedules: {
                type: "list",
                member: {
                  shape: "S43",
                  locationName: "SnapshotSchedule"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeStorage: {
          output: {
            resultWrapper: "DescribeStorageResult",
            type: "structure",
            members: {
              TotalBackupSizeInMegaBytes: {
                type: "double"
              },
              TotalProvisionedStorageInMegaBytes: {
                type: "double"
              }
            }
          }
        },
        DescribeTableRestoreStatus: {
          input: {
            type: "structure",
            members: {
              ClusterIdentifier: {},
              TableRestoreRequestId: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeTableRestoreStatusResult",
            type: "structure",
            members: {
              TableRestoreStatusDetails: {
                type: "list",
                member: {
                  shape: "S8u",
                  locationName: "TableRestoreStatus"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeTags: {
          input: {
            type: "structure",
            members: {
              ResourceName: {},
              ResourceType: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              TagKeys: {
                shape: "S4v"
              },
              TagValues: {
                shape: "S5f"
              }
            }
          },
          output: {
            resultWrapper: "DescribeTagsResult",
            type: "structure",
            members: {
              TaggedResources: {
                type: "list",
                member: {
                  locationName: "TaggedResource",
                  type: "structure",
                  members: {
                    Tag: {
                      shape: "Su"
                    },
                    ResourceName: {},
                    ResourceType: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeUsageLimits: {
          input: {
            type: "structure",
            members: {
              UsageLimitId: {},
              ClusterIdentifier: {},
              FeatureType: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              TagKeys: {
                shape: "S4v"
              },
              TagValues: {
                shape: "S5f"
              }
            }
          },
          output: {
            resultWrapper: "DescribeUsageLimitsResult",
            type: "structure",
            members: {
              UsageLimits: {
                type: "list",
                member: {
                  shape: "S4d"
                }
              },
              Marker: {}
            }
          }
        },
        DisableLogging: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {}
            }
          },
          output: {
            shape: "S7i",
            resultWrapper: "DisableLoggingResult"
          }
        },
        DisableSnapshotCopy: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DisableSnapshotCopyResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S22"
              }
            }
          }
        },
        DisassociateDataShareConsumer: {
          input: {
            type: "structure",
            required: [
              "DataShareArn"
            ],
            members: {
              DataShareArn: {},
              DisassociateEntireAccount: {
                type: "boolean"
              },
              ConsumerArn: {}
            }
          },
          output: {
            shape: "Sj",
            resultWrapper: "DisassociateDataShareConsumerResult"
          }
        },
        EnableLogging: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "BucketName"
            ],
            members: {
              ClusterIdentifier: {},
              BucketName: {},
              S3KeyPrefix: {}
            }
          },
          output: {
            shape: "S7i",
            resultWrapper: "EnableLoggingResult"
          }
        },
        EnableSnapshotCopy: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "DestinationRegion"
            ],
            members: {
              ClusterIdentifier: {},
              DestinationRegion: {},
              RetentionPeriod: {
                type: "integer"
              },
              SnapshotCopyGrantName: {},
              ManualSnapshotRetentionPeriod: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "EnableSnapshotCopyResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S22"
              }
            }
          }
        },
        GetClusterCredentials: {
          input: {
            type: "structure",
            required: [
              "DbUser",
              "ClusterIdentifier"
            ],
            members: {
              DbUser: {},
              DbName: {},
              ClusterIdentifier: {},
              DurationSeconds: {
                type: "integer"
              },
              AutoCreate: {
                type: "boolean"
              },
              DbGroups: {
                type: "list",
                member: {
                  locationName: "DbGroup"
                }
              }
            }
          },
          output: {
            resultWrapper: "GetClusterCredentialsResult",
            type: "structure",
            members: {
              DbUser: {},
              DbPassword: {
                type: "string",
                sensitive: true
              },
              Expiration: {
                type: "timestamp"
              }
            }
          }
        },
        GetReservedNodeExchangeOfferings: {
          input: {
            type: "structure",
            required: [
              "ReservedNodeId"
            ],
            members: {
              ReservedNodeId: {},
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "GetReservedNodeExchangeOfferingsResult",
            type: "structure",
            members: {
              Marker: {},
              ReservedNodeOfferings: {
                shape: "S87"
              }
            }
          }
        },
        ModifyAquaConfiguration: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {},
              AquaConfigurationStatus: {}
            }
          },
          output: {
            resultWrapper: "ModifyAquaConfigurationResult",
            type: "structure",
            members: {
              AquaConfiguration: {
                shape: "S2v"
              }
            }
          }
        },
        ModifyAuthenticationProfile: {
          input: {
            type: "structure",
            required: [
              "AuthenticationProfileName",
              "AuthenticationProfileContent"
            ],
            members: {
              AuthenticationProfileName: {},
              AuthenticationProfileContent: {}
            }
          },
          output: {
            resultWrapper: "ModifyAuthenticationProfileResult",
            type: "structure",
            members: {
              AuthenticationProfileName: {},
              AuthenticationProfileContent: {}
            }
          }
        },
        ModifyCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {},
              ClusterType: {},
              NodeType: {},
              NumberOfNodes: {
                type: "integer"
              },
              ClusterSecurityGroups: {
                shape: "S1x"
              },
              VpcSecurityGroupIds: {
                shape: "S1y"
              },
              MasterUserPassword: {},
              ClusterParameterGroupName: {},
              AutomatedSnapshotRetentionPeriod: {
                type: "integer"
              },
              ManualSnapshotRetentionPeriod: {
                type: "integer"
              },
              PreferredMaintenanceWindow: {},
              ClusterVersion: {},
              AllowVersionUpgrade: {
                type: "boolean"
              },
              HsmClientCertificateIdentifier: {},
              HsmConfigurationIdentifier: {},
              NewClusterIdentifier: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              ElasticIp: {},
              EnhancedVpcRouting: {
                type: "boolean"
              },
              MaintenanceTrackName: {},
              Encrypted: {
                type: "boolean"
              },
              KmsKeyId: {},
              AvailabilityZoneRelocation: {
                type: "boolean"
              },
              AvailabilityZone: {},
              Port: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ModifyClusterResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S22"
              }
            }
          }
        },
        ModifyClusterDbRevision: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "RevisionTarget"
            ],
            members: {
              ClusterIdentifier: {},
              RevisionTarget: {}
            }
          },
          output: {
            resultWrapper: "ModifyClusterDbRevisionResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S22"
              }
            }
          }
        },
        ModifyClusterIamRoles: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {},
              AddIamRoles: {
                shape: "S1z"
              },
              RemoveIamRoles: {
                shape: "S1z"
              }
            }
          },
          output: {
            resultWrapper: "ModifyClusterIamRolesResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S22"
              }
            }
          }
        },
        ModifyClusterMaintenance: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {},
              DeferMaintenance: {
                type: "boolean"
              },
              DeferMaintenanceIdentifier: {},
              DeferMaintenanceStartTime: {
                type: "timestamp"
              },
              DeferMaintenanceEndTime: {
                type: "timestamp"
              },
              DeferMaintenanceDuration: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ModifyClusterMaintenanceResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S22"
              }
            }
          }
        },
        ModifyClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName",
              "Parameters"
            ],
            members: {
              ParameterGroupName: {},
              Parameters: {
                shape: "S5k"
              }
            }
          },
          output: {
            shape: "S9t",
            resultWrapper: "ModifyClusterParameterGroupResult"
          }
        },
        ModifyClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "SnapshotIdentifier"
            ],
            members: {
              SnapshotIdentifier: {},
              ManualSnapshotRetentionPeriod: {
                type: "integer"
              },
              Force: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyClusterSnapshotResult",
            type: "structure",
            members: {
              Snapshot: {
                shape: "S14"
              }
            }
          }
        },
        ModifyClusterSnapshotSchedule: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {},
              ScheduleIdentifier: {},
              DisassociateSchedule: {
                type: "boolean"
              }
            }
          }
        },
        ModifyClusterSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "ClusterSubnetGroupName",
              "SubnetIds"
            ],
            members: {
              ClusterSubnetGroupName: {},
              Description: {},
              SubnetIds: {
                shape: "S35"
              }
            }
          },
          output: {
            resultWrapper: "ModifyClusterSubnetGroupResult",
            type: "structure",
            members: {
              ClusterSubnetGroup: {
                shape: "S37"
              }
            }
          }
        },
        ModifyEndpointAccess: {
          input: {
            type: "structure",
            required: [
              "EndpointName"
            ],
            members: {
              EndpointName: {},
              VpcSecurityGroupIds: {
                shape: "S1y"
              }
            }
          },
          output: {
            shape: "S3e",
            resultWrapper: "ModifyEndpointAccessResult"
          }
        },
        ModifyEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              SourceIds: {
                shape: "S3g"
              },
              EventCategories: {
                shape: "S3h"
              },
              Severity: {},
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S3j"
              }
            }
          }
        },
        ModifyScheduledAction: {
          input: {
            type: "structure",
            required: [
              "ScheduledActionName"
            ],
            members: {
              ScheduledActionName: {},
              TargetAction: {
                shape: "S3r"
              },
              Schedule: {},
              IamRole: {},
              ScheduledActionDescription: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Enable: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S3v",
            resultWrapper: "ModifyScheduledActionResult"
          }
        },
        ModifySnapshotCopyRetentionPeriod: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "RetentionPeriod"
            ],
            members: {
              ClusterIdentifier: {},
              RetentionPeriod: {
                type: "integer"
              },
              Manual: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifySnapshotCopyRetentionPeriodResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S22"
              }
            }
          }
        },
        ModifySnapshotSchedule: {
          input: {
            type: "structure",
            required: [
              "ScheduleIdentifier",
              "ScheduleDefinitions"
            ],
            members: {
              ScheduleIdentifier: {},
              ScheduleDefinitions: {
                shape: "S42"
              }
            }
          },
          output: {
            shape: "S43",
            resultWrapper: "ModifySnapshotScheduleResult"
          }
        },
        ModifyUsageLimit: {
          input: {
            type: "structure",
            required: [
              "UsageLimitId"
            ],
            members: {
              UsageLimitId: {},
              Amount: {
                type: "long"
              },
              BreachAction: {}
            }
          },
          output: {
            shape: "S4d",
            resultWrapper: "ModifyUsageLimitResult"
          }
        },
        PauseCluster: {
          input: {
            shape: "S3t"
          },
          output: {
            resultWrapper: "PauseClusterResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S22"
              }
            }
          }
        },
        PurchaseReservedNodeOffering: {
          input: {
            type: "structure",
            required: [
              "ReservedNodeOfferingId"
            ],
            members: {
              ReservedNodeOfferingId: {},
              NodeCount: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "PurchaseReservedNodeOfferingResult",
            type: "structure",
            members: {
              ReservedNode: {
                shape: "S4"
              }
            }
          }
        },
        RebootCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RebootClusterResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S22"
              }
            }
          }
        },
        RejectDataShare: {
          input: {
            type: "structure",
            required: [
              "DataShareArn"
            ],
            members: {
              DataShareArn: {}
            }
          },
          output: {
            shape: "Sj",
            resultWrapper: "RejectDataShareResult"
          }
        },
        ResetClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName"
            ],
            members: {
              ParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              Parameters: {
                shape: "S5k"
              }
            }
          },
          output: {
            shape: "S9t",
            resultWrapper: "ResetClusterParameterGroupResult"
          }
        },
        ResizeCluster: {
          input: {
            shape: "S3s"
          },
          output: {
            resultWrapper: "ResizeClusterResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S22"
              }
            }
          }
        },
        RestoreFromClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "SnapshotIdentifier"
            ],
            members: {
              ClusterIdentifier: {},
              SnapshotIdentifier: {},
              SnapshotClusterIdentifier: {},
              Port: {
                type: "integer"
              },
              AvailabilityZone: {},
              AllowVersionUpgrade: {
                type: "boolean"
              },
              ClusterSubnetGroupName: {},
              PubliclyAccessible: {
                type: "boolean"
              },
              OwnerAccount: {},
              HsmClientCertificateIdentifier: {},
              HsmConfigurationIdentifier: {},
              ElasticIp: {},
              ClusterParameterGroupName: {},
              ClusterSecurityGroups: {
                shape: "S1x"
              },
              VpcSecurityGroupIds: {
                shape: "S1y"
              },
              PreferredMaintenanceWindow: {},
              AutomatedSnapshotRetentionPeriod: {
                type: "integer"
              },
              ManualSnapshotRetentionPeriod: {
                type: "integer"
              },
              KmsKeyId: {},
              NodeType: {},
              EnhancedVpcRouting: {
                type: "boolean"
              },
              AdditionalInfo: {},
              IamRoles: {
                shape: "S1z"
              },
              MaintenanceTrackName: {},
              SnapshotScheduleIdentifier: {},
              NumberOfNodes: {
                type: "integer"
              },
              AvailabilityZoneRelocation: {
                type: "boolean"
              },
              AquaConfigurationStatus: {}
            }
          },
          output: {
            resultWrapper: "RestoreFromClusterSnapshotResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S22"
              }
            }
          }
        },
        RestoreTableFromClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "SnapshotIdentifier",
              "SourceDatabaseName",
              "SourceTableName",
              "NewTableName"
            ],
            members: {
              ClusterIdentifier: {},
              SnapshotIdentifier: {},
              SourceDatabaseName: {},
              SourceSchemaName: {},
              SourceTableName: {},
              TargetDatabaseName: {},
              TargetSchemaName: {},
              NewTableName: {},
              EnableCaseSensitiveIdentifier: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RestoreTableFromClusterSnapshotResult",
            type: "structure",
            members: {
              TableRestoreStatus: {
                shape: "S8u"
              }
            }
          }
        },
        ResumeCluster: {
          input: {
            shape: "S3u"
          },
          output: {
            resultWrapper: "ResumeClusterResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S22"
              }
            }
          }
        },
        RevokeClusterSecurityGroupIngress: {
          input: {
            type: "structure",
            required: [
              "ClusterSecurityGroupName"
            ],
            members: {
              ClusterSecurityGroupName: {},
              CIDRIP: {},
              EC2SecurityGroupName: {},
              EC2SecurityGroupOwnerId: {}
            }
          },
          output: {
            resultWrapper: "RevokeClusterSecurityGroupIngressResult",
            type: "structure",
            members: {
              ClusterSecurityGroup: {
                shape: "Sq"
              }
            }
          }
        },
        RevokeEndpointAccess: {
          input: {
            type: "structure",
            members: {
              ClusterIdentifier: {},
              Account: {},
              VpcIds: {
                shape: "Sz"
              },
              Force: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S10",
            resultWrapper: "RevokeEndpointAccessResult"
          }
        },
        RevokeSnapshotAccess: {
          input: {
            type: "structure",
            required: [
              "SnapshotIdentifier",
              "AccountWithRestoreAccess"
            ],
            members: {
              SnapshotIdentifier: {},
              SnapshotClusterIdentifier: {},
              AccountWithRestoreAccess: {}
            }
          },
          output: {
            resultWrapper: "RevokeSnapshotAccessResult",
            type: "structure",
            members: {
              Snapshot: {
                shape: "S14"
              }
            }
          }
        },
        RotateEncryptionKey: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier"
            ],
            members: {
              ClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RotateEncryptionKeyResult",
            type: "structure",
            members: {
              Cluster: {
                shape: "S22"
              }
            }
          }
        },
        UpdatePartnerStatus: {
          input: {
            type: "structure",
            required: [
              "AccountId",
              "ClusterIdentifier",
              "DatabaseName",
              "PartnerName",
              "Status"
            ],
            members: {
              AccountId: {},
              ClusterIdentifier: {},
              DatabaseName: {},
              PartnerName: {},
              Status: {},
              StatusMessage: {}
            }
          },
          output: {
            shape: "Sg",
            resultWrapper: "UpdatePartnerStatusResult"
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            ReservedNodeId: {},
            ReservedNodeOfferingId: {},
            NodeType: {},
            StartTime: {
              type: "timestamp"
            },
            Duration: {
              type: "integer"
            },
            FixedPrice: {
              type: "double"
            },
            UsagePrice: {
              type: "double"
            },
            CurrencyCode: {},
            NodeCount: {
              type: "integer"
            },
            State: {},
            OfferingType: {},
            RecurringCharges: {
              shape: "S8"
            },
            ReservedNodeOfferingType: {}
          },
          wrapper: true
        },
        S8: {
          type: "list",
          member: {
            locationName: "RecurringCharge",
            type: "structure",
            members: {
              RecurringChargeAmount: {
                type: "double"
              },
              RecurringChargeFrequency: {}
            },
            wrapper: true
          }
        },
        Sb: {
          type: "structure",
          required: [
            "AccountId",
            "ClusterIdentifier",
            "DatabaseName",
            "PartnerName"
          ],
          members: {
            AccountId: {},
            ClusterIdentifier: {},
            DatabaseName: {},
            PartnerName: {}
          }
        },
        Sg: {
          type: "structure",
          members: {
            DatabaseName: {},
            PartnerName: {}
          }
        },
        Sj: {
          type: "structure",
          members: {
            DataShareArn: {},
            ProducerArn: {},
            AllowPubliclyAccessibleConsumers: {
              type: "boolean"
            },
            DataShareAssociations: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ConsumerIdentifier: {},
                  Status: {},
                  CreatedDate: {
                    type: "timestamp"
                  },
                  StatusChangeDate: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        Sq: {
          type: "structure",
          members: {
            ClusterSecurityGroupName: {},
            Description: {},
            EC2SecurityGroups: {
              type: "list",
              member: {
                locationName: "EC2SecurityGroup",
                type: "structure",
                members: {
                  Status: {},
                  EC2SecurityGroupName: {},
                  EC2SecurityGroupOwnerId: {},
                  Tags: {
                    shape: "St"
                  }
                }
              }
            },
            IPRanges: {
              type: "list",
              member: {
                locationName: "IPRange",
                type: "structure",
                members: {
                  Status: {},
                  CIDRIP: {},
                  Tags: {
                    shape: "St"
                  }
                }
              }
            },
            Tags: {
              shape: "St"
            }
          },
          wrapper: true
        },
        St: {
          type: "list",
          member: {
            shape: "Su",
            locationName: "Tag"
          }
        },
        Su: {
          type: "structure",
          members: {
            Key: {},
            Value: {}
          }
        },
        Sz: {
          type: "list",
          member: {
            locationName: "VpcIdentifier"
          }
        },
        S10: {
          type: "structure",
          members: {
            Grantor: {},
            Grantee: {},
            ClusterIdentifier: {},
            AuthorizeTime: {
              type: "timestamp"
            },
            ClusterStatus: {},
            Status: {},
            AllowedAllVPCs: {
              type: "boolean"
            },
            AllowedVPCs: {
              shape: "Sz"
            },
            EndpointCount: {
              type: "integer"
            }
          }
        },
        S14: {
          type: "structure",
          members: {
            SnapshotIdentifier: {},
            ClusterIdentifier: {},
            SnapshotCreateTime: {
              type: "timestamp"
            },
            Status: {},
            Port: {
              type: "integer"
            },
            AvailabilityZone: {},
            ClusterCreateTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            ClusterVersion: {},
            EngineFullVersion: {},
            SnapshotType: {},
            NodeType: {},
            NumberOfNodes: {
              type: "integer"
            },
            DBName: {},
            VpcId: {},
            Encrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            EncryptedWithHSM: {
              type: "boolean"
            },
            AccountsWithRestoreAccess: {
              type: "list",
              member: {
                locationName: "AccountWithRestoreAccess",
                type: "structure",
                members: {
                  AccountId: {},
                  AccountAlias: {}
                }
              }
            },
            OwnerAccount: {},
            TotalBackupSizeInMegaBytes: {
              type: "double"
            },
            ActualIncrementalBackupSizeInMegaBytes: {
              type: "double"
            },
            BackupProgressInMegaBytes: {
              type: "double"
            },
            CurrentBackupRateInMegaBytesPerSecond: {
              type: "double"
            },
            EstimatedSecondsToCompletion: {
              type: "long"
            },
            ElapsedTimeInSeconds: {
              type: "long"
            },
            SourceRegion: {},
            Tags: {
              shape: "St"
            },
            RestorableNodeTypes: {
              type: "list",
              member: {
                locationName: "NodeType"
              }
            },
            EnhancedVpcRouting: {
              type: "boolean"
            },
            MaintenanceTrackName: {},
            ManualSnapshotRetentionPeriod: {
              type: "integer"
            },
            ManualSnapshotRemainingDays: {
              type: "integer"
            },
            SnapshotRetentionStartTime: {
              type: "timestamp"
            }
          },
          wrapper: true
        },
        S1c: {
          type: "structure",
          required: [
            "SnapshotIdentifier"
          ],
          members: {
            SnapshotIdentifier: {},
            SnapshotClusterIdentifier: {}
          }
        },
        S1e: {
          type: "list",
          member: {
            locationName: "String"
          }
        },
        S1g: {
          type: "structure",
          members: {
            SnapshotIdentifier: {},
            SnapshotClusterIdentifier: {},
            FailureCode: {},
            FailureReason: {}
          }
        },
        S1l: {
          type: "structure",
          members: {
            TargetNodeType: {},
            TargetNumberOfNodes: {
              type: "integer"
            },
            TargetClusterType: {},
            Status: {},
            ImportTablesCompleted: {
              type: "list",
              member: {}
            },
            ImportTablesInProgress: {
              type: "list",
              member: {}
            },
            ImportTablesNotStarted: {
              type: "list",
              member: {}
            },
            AvgResizeRateInMegaBytesPerSecond: {
              type: "double"
            },
            TotalResizeDataInMegaBytes: {
              type: "long"
            },
            ProgressInMegaBytes: {
              type: "long"
            },
            ElapsedTimeInSeconds: {
              type: "long"
            },
            EstimatedTimeToCompletionInSeconds: {
              type: "long"
            },
            ResizeType: {},
            Message: {},
            TargetEncryptionType: {},
            DataTransferProgressPercent: {
              type: "double"
            }
          }
        },
        S1x: {
          type: "list",
          member: {
            locationName: "ClusterSecurityGroupName"
          }
        },
        S1y: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupId"
          }
        },
        S1z: {
          type: "list",
          member: {
            locationName: "IamRoleArn"
          }
        },
        S22: {
          type: "structure",
          members: {
            ClusterIdentifier: {},
            NodeType: {},
            ClusterStatus: {},
            ClusterAvailabilityStatus: {},
            ModifyStatus: {},
            MasterUsername: {},
            DBName: {},
            Endpoint: {
              type: "structure",
              members: {
                Address: {},
                Port: {
                  type: "integer"
                },
                VpcEndpoints: {
                  type: "list",
                  member: {
                    shape: "S25",
                    locationName: "VpcEndpoint"
                  }
                }
              }
            },
            ClusterCreateTime: {
              type: "timestamp"
            },
            AutomatedSnapshotRetentionPeriod: {
              type: "integer"
            },
            ManualSnapshotRetentionPeriod: {
              type: "integer"
            },
            ClusterSecurityGroups: {
              type: "list",
              member: {
                locationName: "ClusterSecurityGroup",
                type: "structure",
                members: {
                  ClusterSecurityGroupName: {},
                  Status: {}
                }
              }
            },
            VpcSecurityGroups: {
              shape: "S2a"
            },
            ClusterParameterGroups: {
              type: "list",
              member: {
                locationName: "ClusterParameterGroup",
                type: "structure",
                members: {
                  ParameterGroupName: {},
                  ParameterApplyStatus: {},
                  ClusterParameterStatusList: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ParameterName: {},
                        ParameterApplyStatus: {},
                        ParameterApplyErrorDescription: {}
                      }
                    }
                  }
                }
              }
            },
            ClusterSubnetGroupName: {},
            VpcId: {},
            AvailabilityZone: {},
            PreferredMaintenanceWindow: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                MasterUserPassword: {},
                NodeType: {},
                NumberOfNodes: {
                  type: "integer"
                },
                ClusterType: {},
                ClusterVersion: {},
                AutomatedSnapshotRetentionPeriod: {
                  type: "integer"
                },
                ClusterIdentifier: {},
                PubliclyAccessible: {
                  type: "boolean"
                },
                EnhancedVpcRouting: {
                  type: "boolean"
                },
                MaintenanceTrackName: {},
                EncryptionType: {}
              }
            },
            ClusterVersion: {},
            AllowVersionUpgrade: {
              type: "boolean"
            },
            NumberOfNodes: {
              type: "integer"
            },
            PubliclyAccessible: {
              type: "boolean"
            },
            Encrypted: {
              type: "boolean"
            },
            RestoreStatus: {
              type: "structure",
              members: {
                Status: {},
                CurrentRestoreRateInMegaBytesPerSecond: {
                  type: "double"
                },
                SnapshotSizeInMegaBytes: {
                  type: "long"
                },
                ProgressInMegaBytes: {
                  type: "long"
                },
                ElapsedTimeInSeconds: {
                  type: "long"
                },
                EstimatedTimeToCompletionInSeconds: {
                  type: "long"
                }
              }
            },
            DataTransferProgress: {
              type: "structure",
              members: {
                Status: {},
                CurrentRateInMegaBytesPerSecond: {
                  type: "double"
                },
                TotalDataInMegaBytes: {
                  type: "long"
                },
                DataTransferredInMegaBytes: {
                  type: "long"
                },
                EstimatedTimeToCompletionInSeconds: {
                  type: "long"
                },
                ElapsedTimeInSeconds: {
                  type: "long"
                }
              }
            },
            HsmStatus: {
              type: "structure",
              members: {
                HsmClientCertificateIdentifier: {},
                HsmConfigurationIdentifier: {},
                Status: {}
              }
            },
            ClusterSnapshotCopyStatus: {
              type: "structure",
              members: {
                DestinationRegion: {},
                RetentionPeriod: {
                  type: "long"
                },
                ManualSnapshotRetentionPeriod: {
                  type: "integer"
                },
                SnapshotCopyGrantName: {}
              }
            },
            ClusterPublicKey: {},
            ClusterNodes: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  NodeRole: {},
                  PrivateIPAddress: {},
                  PublicIPAddress: {}
                }
              }
            },
            ElasticIpStatus: {
              type: "structure",
              members: {
                ElasticIp: {},
                Status: {}
              }
            },
            ClusterRevisionNumber: {},
            Tags: {
              shape: "St"
            },
            KmsKeyId: {},
            EnhancedVpcRouting: {
              type: "boolean"
            },
            IamRoles: {
              type: "list",
              member: {
                locationName: "ClusterIamRole",
                type: "structure",
                members: {
                  IamRoleArn: {},
                  ApplyStatus: {}
                }
              }
            },
            PendingActions: {
              type: "list",
              member: {}
            },
            MaintenanceTrackName: {},
            ElasticResizeNumberOfNodeOptions: {},
            DeferredMaintenanceWindows: {
              type: "list",
              member: {
                locationName: "DeferredMaintenanceWindow",
                type: "structure",
                members: {
                  DeferMaintenanceIdentifier: {},
                  DeferMaintenanceStartTime: {
                    type: "timestamp"
                  },
                  DeferMaintenanceEndTime: {
                    type: "timestamp"
                  }
                }
              }
            },
            SnapshotScheduleIdentifier: {},
            SnapshotScheduleState: {},
            ExpectedNextSnapshotScheduleTime: {
              type: "timestamp"
            },
            ExpectedNextSnapshotScheduleTimeStatus: {},
            NextMaintenanceWindowStartTime: {
              type: "timestamp"
            },
            ResizeInfo: {
              type: "structure",
              members: {
                ResizeType: {},
                AllowCancelResize: {
                  type: "boolean"
                }
              }
            },
            AvailabilityZoneRelocationStatus: {},
            ClusterNamespaceArn: {},
            TotalStorageCapacityInMegaBytes: {
              type: "long"
            },
            AquaConfiguration: {
              shape: "S2v"
            }
          },
          wrapper: true
        },
        S25: {
          type: "structure",
          members: {
            VpcEndpointId: {},
            VpcId: {},
            NetworkInterfaces: {
              type: "list",
              member: {
                locationName: "NetworkInterface",
                type: "structure",
                members: {
                  NetworkInterfaceId: {},
                  SubnetId: {},
                  PrivateIpAddress: {},
                  AvailabilityZone: {}
                }
              }
            }
          }
        },
        S2a: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroup",
            type: "structure",
            members: {
              VpcSecurityGroupId: {},
              Status: {}
            }
          }
        },
        S2v: {
          type: "structure",
          members: {
            AquaStatus: {},
            AquaConfigurationStatus: {}
          }
        },
        S2z: {
          type: "structure",
          members: {
            ParameterGroupName: {},
            ParameterGroupFamily: {},
            Description: {},
            Tags: {
              shape: "St"
            }
          },
          wrapper: true
        },
        S35: {
          type: "list",
          member: {
            locationName: "SubnetIdentifier"
          }
        },
        S37: {
          type: "structure",
          members: {
            ClusterSubnetGroupName: {},
            Description: {},
            VpcId: {},
            SubnetGroupStatus: {},
            Subnets: {
              type: "list",
              member: {
                locationName: "Subnet",
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {
                    shape: "S3a"
                  },
                  SubnetStatus: {}
                }
              }
            },
            Tags: {
              shape: "St"
            }
          },
          wrapper: true
        },
        S3a: {
          type: "structure",
          members: {
            Name: {},
            SupportedPlatforms: {
              type: "list",
              member: {
                locationName: "SupportedPlatform",
                type: "structure",
                members: {
                  Name: {}
                },
                wrapper: true
              }
            }
          },
          wrapper: true
        },
        S3e: {
          type: "structure",
          members: {
            ClusterIdentifier: {},
            ResourceOwner: {},
            SubnetGroupName: {},
            EndpointStatus: {},
            EndpointName: {},
            EndpointCreateTime: {
              type: "timestamp"
            },
            Port: {
              type: "integer"
            },
            Address: {},
            VpcSecurityGroups: {
              shape: "S2a"
            },
            VpcEndpoint: {
              shape: "S25"
            }
          }
        },
        S3g: {
          type: "list",
          member: {
            locationName: "SourceId"
          }
        },
        S3h: {
          type: "list",
          member: {
            locationName: "EventCategory"
          }
        },
        S3j: {
          type: "structure",
          members: {
            CustomerAwsId: {},
            CustSubscriptionId: {},
            SnsTopicArn: {},
            Status: {},
            SubscriptionCreationTime: {
              type: "timestamp"
            },
            SourceType: {},
            SourceIdsList: {
              shape: "S3g"
            },
            EventCategoriesList: {
              shape: "S3h"
            },
            Severity: {},
            Enabled: {
              type: "boolean"
            },
            Tags: {
              shape: "St"
            }
          },
          wrapper: true
        },
        S3m: {
          type: "structure",
          members: {
            HsmClientCertificateIdentifier: {},
            HsmClientCertificatePublicKey: {},
            Tags: {
              shape: "St"
            }
          },
          wrapper: true
        },
        S3p: {
          type: "structure",
          members: {
            HsmConfigurationIdentifier: {},
            Description: {},
            HsmIpAddress: {},
            HsmPartitionName: {},
            Tags: {
              shape: "St"
            }
          },
          wrapper: true
        },
        S3r: {
          type: "structure",
          members: {
            ResizeCluster: {
              shape: "S3s"
            },
            PauseCluster: {
              shape: "S3t"
            },
            ResumeCluster: {
              shape: "S3u"
            }
          }
        },
        S3s: {
          type: "structure",
          required: [
            "ClusterIdentifier"
          ],
          members: {
            ClusterIdentifier: {},
            ClusterType: {},
            NodeType: {},
            NumberOfNodes: {
              type: "integer"
            },
            Classic: {
              type: "boolean"
            }
          }
        },
        S3t: {
          type: "structure",
          required: [
            "ClusterIdentifier"
          ],
          members: {
            ClusterIdentifier: {}
          }
        },
        S3u: {
          type: "structure",
          required: [
            "ClusterIdentifier"
          ],
          members: {
            ClusterIdentifier: {}
          }
        },
        S3v: {
          type: "structure",
          members: {
            ScheduledActionName: {},
            TargetAction: {
              shape: "S3r"
            },
            Schedule: {},
            IamRole: {},
            ScheduledActionDescription: {},
            State: {},
            NextInvocations: {
              type: "list",
              member: {
                locationName: "ScheduledActionTime",
                type: "timestamp"
              }
            },
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            }
          }
        },
        S40: {
          type: "structure",
          members: {
            SnapshotCopyGrantName: {},
            KmsKeyId: {},
            Tags: {
              shape: "St"
            }
          },
          wrapper: true
        },
        S42: {
          type: "list",
          member: {
            locationName: "ScheduleDefinition"
          }
        },
        S43: {
          type: "structure",
          members: {
            ScheduleDefinitions: {
              shape: "S42"
            },
            ScheduleIdentifier: {},
            ScheduleDescription: {},
            Tags: {
              shape: "St"
            },
            NextInvocations: {
              type: "list",
              member: {
                locationName: "SnapshotTime",
                type: "timestamp"
              }
            },
            AssociatedClusterCount: {
              type: "integer"
            },
            AssociatedClusters: {
              type: "list",
              member: {
                locationName: "ClusterAssociatedToSchedule",
                type: "structure",
                members: {
                  ClusterIdentifier: {},
                  ScheduleAssociationState: {}
                }
              }
            }
          }
        },
        S4d: {
          type: "structure",
          members: {
            UsageLimitId: {},
            ClusterIdentifier: {},
            FeatureType: {},
            LimitType: {},
            Amount: {
              type: "long"
            },
            Period: {},
            BreachAction: {},
            Tags: {
              shape: "St"
            }
          }
        },
        S4v: {
          type: "list",
          member: {
            locationName: "TagKey"
          }
        },
        S5f: {
          type: "list",
          member: {
            locationName: "TagValue"
          }
        },
        S5k: {
          type: "list",
          member: {
            locationName: "Parameter",
            type: "structure",
            members: {
              ParameterName: {},
              ParameterValue: {},
              Description: {},
              Source: {},
              DataType: {},
              AllowedValues: {},
              ApplyType: {},
              IsModifiable: {
                type: "boolean"
              },
              MinimumEngineVersion: {}
            }
          }
        },
        S6h: {
          type: "list",
          member: {
            shape: "Sj"
          }
        },
        S7i: {
          type: "structure",
          members: {
            LoggingEnabled: {
              type: "boolean"
            },
            BucketName: {},
            S3KeyPrefix: {},
            LastSuccessfulDeliveryTime: {
              type: "timestamp"
            },
            LastFailureTime: {
              type: "timestamp"
            },
            LastFailureMessage: {}
          }
        },
        S7p: {
          type: "list",
          member: {
            locationName: "item"
          }
        },
        S87: {
          type: "list",
          member: {
            locationName: "ReservedNodeOffering",
            type: "structure",
            members: {
              ReservedNodeOfferingId: {},
              NodeType: {},
              Duration: {
                type: "integer"
              },
              FixedPrice: {
                type: "double"
              },
              UsagePrice: {
                type: "double"
              },
              CurrencyCode: {},
              OfferingType: {},
              RecurringCharges: {
                shape: "S8"
              },
              ReservedNodeOfferingType: {}
            },
            wrapper: true
          }
        },
        S8u: {
          type: "structure",
          members: {
            TableRestoreRequestId: {},
            Status: {},
            Message: {},
            RequestTime: {
              type: "timestamp"
            },
            ProgressInMegaBytes: {
              type: "long"
            },
            TotalDataInMegaBytes: {
              type: "long"
            },
            ClusterIdentifier: {},
            SnapshotIdentifier: {},
            SourceDatabaseName: {},
            SourceSchemaName: {},
            SourceTableName: {},
            TargetDatabaseName: {},
            TargetSchemaName: {},
            NewTableName: {}
          },
          wrapper: true
        },
        S9t: {
          type: "structure",
          members: {
            ParameterGroupName: {},
            ParameterGroupStatus: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/redshift-2012-12-01.paginators.json
var require_redshift_2012_12_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/redshift-2012-12-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeClusterDbRevisions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ClusterDbRevisions"
        },
        DescribeClusterParameterGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ParameterGroups"
        },
        DescribeClusterParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Parameters"
        },
        DescribeClusterSecurityGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ClusterSecurityGroups"
        },
        DescribeClusterSnapshots: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Snapshots"
        },
        DescribeClusterSubnetGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ClusterSubnetGroups"
        },
        DescribeClusterTracks: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "MaintenanceTracks"
        },
        DescribeClusterVersions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ClusterVersions"
        },
        DescribeClusters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Clusters"
        },
        DescribeDefaultClusterParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "DefaultClusterParameters.Marker",
          result_key: "DefaultClusterParameters.Parameters"
        },
        DescribeEndpointAccess: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "EndpointAccessList"
        },
        DescribeEndpointAuthorization: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "EndpointAuthorizationList"
        },
        DescribeEventSubscriptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "EventSubscriptionsList"
        },
        DescribeEvents: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Events"
        },
        DescribeHsmClientCertificates: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "HsmClientCertificates"
        },
        DescribeHsmConfigurations: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "HsmConfigurations"
        },
        DescribeNodeConfigurationOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "NodeConfigurationOptionList"
        },
        DescribeOrderableClusterOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OrderableClusterOptions"
        },
        DescribeReservedNodeOfferings: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedNodeOfferings"
        },
        DescribeReservedNodes: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedNodes"
        },
        DescribeScheduledActions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ScheduledActions"
        },
        DescribeSnapshotCopyGrants: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "SnapshotCopyGrants"
        },
        DescribeSnapshotSchedules: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "SnapshotSchedules"
        },
        DescribeTableRestoreStatus: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "TableRestoreStatusDetails"
        },
        DescribeTags: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "TaggedResources"
        },
        DescribeUsageLimits: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "UsageLimits"
        },
        GetReservedNodeExchangeOfferings: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "ReservedNodeOfferings"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/redshift-2012-12-01.waiters2.json
var require_redshift_2012_12_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/redshift-2012-12-01.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ClusterAvailable: {
          delay: 60,
          operation: "DescribeClusters",
          maxAttempts: 30,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "Clusters[].ClusterStatus"
            },
            {
              expected: "deleting",
              matcher: "pathAny",
              state: "failure",
              argument: "Clusters[].ClusterStatus"
            },
            {
              expected: "ClusterNotFound",
              matcher: "error",
              state: "retry"
            }
          ]
        },
        ClusterDeleted: {
          delay: 60,
          operation: "DescribeClusters",
          maxAttempts: 30,
          acceptors: [
            {
              expected: "ClusterNotFound",
              matcher: "error",
              state: "success"
            },
            {
              expected: "creating",
              matcher: "pathAny",
              state: "failure",
              argument: "Clusters[].ClusterStatus"
            },
            {
              expected: "modifying",
              matcher: "pathAny",
              state: "failure",
              argument: "Clusters[].ClusterStatus"
            }
          ]
        },
        ClusterRestored: {
          operation: "DescribeClusters",
          maxAttempts: 30,
          delay: 60,
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "Clusters[].RestoreStatus.Status",
              expected: "completed"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "Clusters[].ClusterStatus",
              expected: "deleting"
            }
          ]
        },
        SnapshotAvailable: {
          delay: 15,
          operation: "DescribeClusterSnapshots",
          maxAttempts: 20,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "Snapshots[].Status"
            },
            {
              expected: "failed",
              matcher: "pathAny",
              state: "failure",
              argument: "Snapshots[].Status"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "Snapshots[].Status"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/redshift.js
var require_redshift = __commonJS({
  "node_modules/aws-sdk/clients/redshift.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["redshift"] = {};
    AWS3.Redshift = Service.defineService("redshift", ["2012-12-01"]);
    Object.defineProperty(apiLoader.services["redshift"], "2012-12-01", {
      get: function get() {
        var model = require_redshift_2012_12_01_min();
        model.paginators = require_redshift_2012_12_01_paginators().pagination;
        model.waiters = require_redshift_2012_12_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Redshift;
  }
});

// node_modules/aws-sdk/apis/rekognition-2016-06-27.min.json
var require_rekognition_2016_06_27_min = __commonJS({
  "node_modules/aws-sdk/apis/rekognition-2016-06-27.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-06-27",
        endpointPrefix: "rekognition",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Rekognition",
        serviceId: "Rekognition",
        signatureVersion: "v4",
        targetPrefix: "RekognitionService",
        uid: "rekognition-2016-06-27"
      },
      operations: {
        CompareFaces: {
          input: {
            type: "structure",
            required: [
              "SourceImage",
              "TargetImage"
            ],
            members: {
              SourceImage: {
                shape: "S2"
              },
              TargetImage: {
                shape: "S2"
              },
              SimilarityThreshold: {
                type: "float"
              },
              QualityFilter: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SourceImageFace: {
                type: "structure",
                members: {
                  BoundingBox: {
                    shape: "Sc"
                  },
                  Confidence: {
                    type: "float"
                  }
                }
              },
              FaceMatches: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Similarity: {
                      type: "float"
                    },
                    Face: {
                      shape: "Sg"
                    }
                  }
                }
              },
              UnmatchedFaces: {
                type: "list",
                member: {
                  shape: "Sg"
                }
              },
              SourceImageOrientationCorrection: {},
              TargetImageOrientationCorrection: {}
            }
          }
        },
        CreateCollection: {
          input: {
            type: "structure",
            required: [
              "CollectionId"
            ],
            members: {
              CollectionId: {},
              Tags: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StatusCode: {
                type: "integer"
              },
              CollectionArn: {},
              FaceModelVersion: {}
            }
          }
        },
        CreateProject: {
          input: {
            type: "structure",
            required: [
              "ProjectName"
            ],
            members: {
              ProjectName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProjectArn: {}
            }
          }
        },
        CreateProjectVersion: {
          input: {
            type: "structure",
            required: [
              "ProjectArn",
              "VersionName",
              "OutputConfig",
              "TrainingData",
              "TestingData"
            ],
            members: {
              ProjectArn: {},
              VersionName: {},
              OutputConfig: {
                shape: "S18"
              },
              TrainingData: {
                shape: "S1a"
              },
              TestingData: {
                shape: "S1e"
              },
              Tags: {
                shape: "Sw"
              },
              KmsKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProjectVersionArn: {}
            }
          }
        },
        CreateStreamProcessor: {
          input: {
            type: "structure",
            required: [
              "Input",
              "Output",
              "Name",
              "Settings",
              "RoleArn"
            ],
            members: {
              Input: {
                shape: "S1j"
              },
              Output: {
                shape: "S1m"
              },
              Name: {},
              Settings: {
                shape: "S1q"
              },
              RoleArn: {},
              Tags: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamProcessorArn: {}
            }
          }
        },
        DeleteCollection: {
          input: {
            type: "structure",
            required: [
              "CollectionId"
            ],
            members: {
              CollectionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StatusCode: {
                type: "integer"
              }
            }
          }
        },
        DeleteFaces: {
          input: {
            type: "structure",
            required: [
              "CollectionId",
              "FaceIds"
            ],
            members: {
              CollectionId: {},
              FaceIds: {
                shape: "S1y"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeletedFaces: {
                shape: "S1y"
              }
            }
          }
        },
        DeleteProject: {
          input: {
            type: "structure",
            required: [
              "ProjectArn"
            ],
            members: {
              ProjectArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        },
        DeleteProjectVersion: {
          input: {
            type: "structure",
            required: [
              "ProjectVersionArn"
            ],
            members: {
              ProjectVersionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        },
        DeleteStreamProcessor: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeCollection: {
          input: {
            type: "structure",
            required: [
              "CollectionId"
            ],
            members: {
              CollectionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FaceCount: {
                type: "long"
              },
              FaceModelVersion: {},
              CollectionARN: {},
              CreationTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeProjectVersions: {
          input: {
            type: "structure",
            required: [
              "ProjectArn"
            ],
            members: {
              ProjectArn: {},
              VersionNames: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProjectVersionDescriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProjectVersionArn: {},
                    CreationTimestamp: {
                      type: "timestamp"
                    },
                    MinInferenceUnits: {
                      type: "integer"
                    },
                    Status: {},
                    StatusMessage: {},
                    BillableTrainingTimeInSeconds: {
                      type: "long"
                    },
                    TrainingEndTimestamp: {
                      type: "timestamp"
                    },
                    OutputConfig: {
                      shape: "S18"
                    },
                    TrainingDataResult: {
                      type: "structure",
                      members: {
                        Input: {
                          shape: "S1a"
                        },
                        Output: {
                          shape: "S1a"
                        },
                        Validation: {
                          shape: "S2n"
                        }
                      }
                    },
                    TestingDataResult: {
                      type: "structure",
                      members: {
                        Input: {
                          shape: "S1e"
                        },
                        Output: {
                          shape: "S1e"
                        },
                        Validation: {
                          shape: "S2n"
                        }
                      }
                    },
                    EvaluationResult: {
                      type: "structure",
                      members: {
                        F1Score: {
                          type: "float"
                        },
                        Summary: {
                          type: "structure",
                          members: {
                            S3Object: {
                              shape: "S4"
                            }
                          }
                        }
                      }
                    },
                    ManifestSummary: {
                      shape: "S1d"
                    },
                    KmsKeyId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeProjects: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProjectDescriptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProjectArn: {},
                    CreationTimestamp: {
                      type: "timestamp"
                    },
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeStreamProcessor: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              StreamProcessorArn: {},
              Status: {},
              StatusMessage: {},
              CreationTimestamp: {
                type: "timestamp"
              },
              LastUpdateTimestamp: {
                type: "timestamp"
              },
              Input: {
                shape: "S1j"
              },
              Output: {
                shape: "S1m"
              },
              RoleArn: {},
              Settings: {
                shape: "S1q"
              }
            }
          }
        },
        DetectCustomLabels: {
          input: {
            type: "structure",
            required: [
              "ProjectVersionArn",
              "Image"
            ],
            members: {
              ProjectVersionArn: {},
              Image: {
                shape: "S2"
              },
              MaxResults: {
                type: "integer"
              },
              MinConfidence: {
                type: "float"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CustomLabels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Confidence: {
                      type: "float"
                    },
                    Geometry: {
                      shape: "S33"
                    }
                  }
                }
              }
            }
          }
        },
        DetectFaces: {
          input: {
            type: "structure",
            required: [
              "Image"
            ],
            members: {
              Image: {
                shape: "S2"
              },
              Attributes: {
                shape: "S37"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FaceDetails: {
                type: "list",
                member: {
                  shape: "S3b"
                }
              },
              OrientationCorrection: {}
            }
          }
        },
        DetectLabels: {
          input: {
            type: "structure",
            required: [
              "Image"
            ],
            members: {
              Image: {
                shape: "S2"
              },
              MaxLabels: {
                type: "integer"
              },
              MinConfidence: {
                type: "float"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Labels: {
                type: "list",
                member: {
                  shape: "S3o"
                }
              },
              OrientationCorrection: {},
              LabelModelVersion: {}
            }
          }
        },
        DetectModerationLabels: {
          input: {
            type: "structure",
            required: [
              "Image"
            ],
            members: {
              Image: {
                shape: "S2"
              },
              MinConfidence: {
                type: "float"
              },
              HumanLoopConfig: {
                type: "structure",
                required: [
                  "HumanLoopName",
                  "FlowDefinitionArn"
                ],
                members: {
                  HumanLoopName: {},
                  FlowDefinitionArn: {},
                  DataAttributes: {
                    type: "structure",
                    members: {
                      ContentClassifiers: {
                        type: "list",
                        member: {}
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ModerationLabels: {
                type: "list",
                member: {
                  shape: "S42"
                }
              },
              ModerationModelVersion: {},
              HumanLoopActivationOutput: {
                type: "structure",
                members: {
                  HumanLoopArn: {},
                  HumanLoopActivationReasons: {
                    type: "list",
                    member: {}
                  },
                  HumanLoopActivationConditionsEvaluationResults: {
                    jsonvalue: true
                  }
                }
              }
            }
          }
        },
        DetectProtectiveEquipment: {
          input: {
            type: "structure",
            required: [
              "Image"
            ],
            members: {
              Image: {
                shape: "S2"
              },
              SummarizationAttributes: {
                type: "structure",
                required: [
                  "MinConfidence",
                  "RequiredEquipmentTypes"
                ],
                members: {
                  MinConfidence: {
                    type: "float"
                  },
                  RequiredEquipmentTypes: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProtectiveEquipmentModelVersion: {},
              Persons: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    BodyParts: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {},
                          Confidence: {
                            type: "float"
                          },
                          EquipmentDetections: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                BoundingBox: {
                                  shape: "Sc"
                                },
                                Confidence: {
                                  type: "float"
                                },
                                Type: {},
                                CoversBodyPart: {
                                  type: "structure",
                                  members: {
                                    Confidence: {
                                      type: "float"
                                    },
                                    Value: {
                                      type: "boolean"
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    BoundingBox: {
                      shape: "Sc"
                    },
                    Confidence: {
                      type: "float"
                    },
                    Id: {
                      type: "integer"
                    }
                  }
                }
              },
              Summary: {
                type: "structure",
                members: {
                  PersonsWithRequiredEquipment: {
                    shape: "S4m"
                  },
                  PersonsWithoutRequiredEquipment: {
                    shape: "S4m"
                  },
                  PersonsIndeterminate: {
                    shape: "S4m"
                  }
                }
              }
            }
          }
        },
        DetectText: {
          input: {
            type: "structure",
            required: [
              "Image"
            ],
            members: {
              Image: {
                shape: "S2"
              },
              Filters: {
                type: "structure",
                members: {
                  WordFilter: {
                    shape: "S4p"
                  },
                  RegionsOfInterest: {
                    shape: "S4s"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TextDetections: {
                type: "list",
                member: {
                  shape: "S4w"
                }
              },
              TextModelVersion: {}
            }
          }
        },
        GetCelebrityInfo: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Urls: {
                shape: "S51"
              },
              Name: {},
              KnownGender: {
                shape: "S53"
              }
            }
          }
        },
        GetCelebrityRecognition: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SortBy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobStatus: {},
              StatusMessage: {},
              VideoMetadata: {
                shape: "S5c"
              },
              NextToken: {},
              Celebrities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "long"
                    },
                    Celebrity: {
                      type: "structure",
                      members: {
                        Urls: {
                          shape: "S51"
                        },
                        Name: {},
                        Id: {},
                        Confidence: {
                          type: "float"
                        },
                        BoundingBox: {
                          shape: "Sc"
                        },
                        Face: {
                          shape: "S3b"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetContentModeration: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SortBy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobStatus: {},
              StatusMessage: {},
              VideoMetadata: {
                shape: "S5c"
              },
              ModerationLabels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "long"
                    },
                    ModerationLabel: {
                      shape: "S42"
                    }
                  }
                }
              },
              NextToken: {},
              ModerationModelVersion: {}
            }
          }
        },
        GetFaceDetection: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobStatus: {},
              StatusMessage: {},
              VideoMetadata: {
                shape: "S5c"
              },
              NextToken: {},
              Faces: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "long"
                    },
                    Face: {
                      shape: "S3b"
                    }
                  }
                }
              }
            }
          }
        },
        GetFaceSearch: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SortBy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobStatus: {},
              StatusMessage: {},
              NextToken: {},
              VideoMetadata: {
                shape: "S5c"
              },
              Persons: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "long"
                    },
                    Person: {
                      shape: "S5w"
                    },
                    FaceMatches: {
                      shape: "S5y"
                    }
                  }
                }
              }
            }
          }
        },
        GetLabelDetection: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SortBy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobStatus: {},
              StatusMessage: {},
              VideoMetadata: {
                shape: "S5c"
              },
              NextToken: {},
              Labels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "long"
                    },
                    Label: {
                      shape: "S3o"
                    }
                  }
                }
              },
              LabelModelVersion: {}
            }
          }
        },
        GetPersonTracking: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SortBy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobStatus: {},
              StatusMessage: {},
              VideoMetadata: {
                shape: "S5c"
              },
              NextToken: {},
              Persons: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "long"
                    },
                    Person: {
                      shape: "S5w"
                    }
                  }
                }
              }
            }
          }
        },
        GetSegmentDetection: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobStatus: {},
              StatusMessage: {},
              VideoMetadata: {
                type: "list",
                member: {
                  shape: "S5c"
                }
              },
              AudioMetadata: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Codec: {},
                    DurationMillis: {
                      type: "long"
                    },
                    SampleRate: {
                      type: "long"
                    },
                    NumberOfChannels: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {},
              Segments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    StartTimestampMillis: {
                      type: "long"
                    },
                    EndTimestampMillis: {
                      type: "long"
                    },
                    DurationMillis: {
                      type: "long"
                    },
                    StartTimecodeSMPTE: {},
                    EndTimecodeSMPTE: {},
                    DurationSMPTE: {},
                    TechnicalCueSegment: {
                      type: "structure",
                      members: {
                        Type: {},
                        Confidence: {
                          type: "float"
                        }
                      }
                    },
                    ShotSegment: {
                      type: "structure",
                      members: {
                        Index: {
                          type: "long"
                        },
                        Confidence: {
                          type: "float"
                        }
                      }
                    },
                    StartFrameNumber: {
                      type: "long"
                    },
                    EndFrameNumber: {
                      type: "long"
                    },
                    DurationFrames: {
                      type: "long"
                    }
                  }
                }
              },
              SelectedSegmentTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    ModelVersion: {}
                  }
                }
              }
            }
          }
        },
        GetTextDetection: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobStatus: {},
              StatusMessage: {},
              VideoMetadata: {
                shape: "S5c"
              },
              TextDetections: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "long"
                    },
                    TextDetection: {
                      shape: "S4w"
                    }
                  }
                }
              },
              NextToken: {},
              TextModelVersion: {}
            }
          }
        },
        IndexFaces: {
          input: {
            type: "structure",
            required: [
              "CollectionId",
              "Image"
            ],
            members: {
              CollectionId: {},
              Image: {
                shape: "S2"
              },
              ExternalImageId: {},
              DetectionAttributes: {
                shape: "S37"
              },
              MaxFaces: {
                type: "integer"
              },
              QualityFilter: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FaceRecords: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Face: {
                      shape: "S60"
                    },
                    FaceDetail: {
                      shape: "S3b"
                    }
                  }
                }
              },
              OrientationCorrection: {},
              FaceModelVersion: {},
              UnindexedFaces: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Reasons: {
                      type: "list",
                      member: {}
                    },
                    FaceDetail: {
                      shape: "S3b"
                    }
                  }
                }
              }
            }
          }
        },
        ListCollections: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CollectionIds: {
                type: "list",
                member: {}
              },
              NextToken: {},
              FaceModelVersions: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListFaces: {
          input: {
            type: "structure",
            required: [
              "CollectionId"
            ],
            members: {
              CollectionId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Faces: {
                type: "list",
                member: {
                  shape: "S60"
                }
              },
              NextToken: {},
              FaceModelVersion: {}
            }
          }
        },
        ListStreamProcessors: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              StreamProcessors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Status: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sw"
              }
            }
          }
        },
        RecognizeCelebrities: {
          input: {
            type: "structure",
            required: [
              "Image"
            ],
            members: {
              Image: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CelebrityFaces: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Urls: {
                      shape: "S51"
                    },
                    Name: {},
                    Id: {},
                    Face: {
                      shape: "Sg"
                    },
                    MatchConfidence: {
                      type: "float"
                    },
                    KnownGender: {
                      shape: "S53"
                    }
                  }
                }
              },
              UnrecognizedFaces: {
                type: "list",
                member: {
                  shape: "Sg"
                }
              },
              OrientationCorrection: {}
            }
          }
        },
        SearchFaces: {
          input: {
            type: "structure",
            required: [
              "CollectionId",
              "FaceId"
            ],
            members: {
              CollectionId: {},
              FaceId: {},
              MaxFaces: {
                type: "integer"
              },
              FaceMatchThreshold: {
                type: "float"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SearchedFaceId: {},
              FaceMatches: {
                shape: "S5y"
              },
              FaceModelVersion: {}
            }
          }
        },
        SearchFacesByImage: {
          input: {
            type: "structure",
            required: [
              "CollectionId",
              "Image"
            ],
            members: {
              CollectionId: {},
              Image: {
                shape: "S2"
              },
              MaxFaces: {
                type: "integer"
              },
              FaceMatchThreshold: {
                type: "float"
              },
              QualityFilter: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SearchedFaceBoundingBox: {
                shape: "Sc"
              },
              SearchedFaceConfidence: {
                type: "float"
              },
              FaceMatches: {
                shape: "S5y"
              },
              FaceModelVersion: {}
            }
          }
        },
        StartCelebrityRecognition: {
          input: {
            type: "structure",
            required: [
              "Video"
            ],
            members: {
              Video: {
                shape: "S7v"
              },
              ClientRequestToken: {},
              NotificationChannel: {
                shape: "S7x"
              },
              JobTag: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          },
          idempotent: true
        },
        StartContentModeration: {
          input: {
            type: "structure",
            required: [
              "Video"
            ],
            members: {
              Video: {
                shape: "S7v"
              },
              MinConfidence: {
                type: "float"
              },
              ClientRequestToken: {},
              NotificationChannel: {
                shape: "S7x"
              },
              JobTag: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          },
          idempotent: true
        },
        StartFaceDetection: {
          input: {
            type: "structure",
            required: [
              "Video"
            ],
            members: {
              Video: {
                shape: "S7v"
              },
              ClientRequestToken: {},
              NotificationChannel: {
                shape: "S7x"
              },
              FaceAttributes: {},
              JobTag: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          },
          idempotent: true
        },
        StartFaceSearch: {
          input: {
            type: "structure",
            required: [
              "Video",
              "CollectionId"
            ],
            members: {
              Video: {
                shape: "S7v"
              },
              ClientRequestToken: {},
              FaceMatchThreshold: {
                type: "float"
              },
              CollectionId: {},
              NotificationChannel: {
                shape: "S7x"
              },
              JobTag: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          },
          idempotent: true
        },
        StartLabelDetection: {
          input: {
            type: "structure",
            required: [
              "Video"
            ],
            members: {
              Video: {
                shape: "S7v"
              },
              ClientRequestToken: {},
              MinConfidence: {
                type: "float"
              },
              NotificationChannel: {
                shape: "S7x"
              },
              JobTag: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          },
          idempotent: true
        },
        StartPersonTracking: {
          input: {
            type: "structure",
            required: [
              "Video"
            ],
            members: {
              Video: {
                shape: "S7v"
              },
              ClientRequestToken: {},
              NotificationChannel: {
                shape: "S7x"
              },
              JobTag: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          },
          idempotent: true
        },
        StartProjectVersion: {
          input: {
            type: "structure",
            required: [
              "ProjectVersionArn",
              "MinInferenceUnits"
            ],
            members: {
              ProjectVersionArn: {},
              MinInferenceUnits: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        },
        StartSegmentDetection: {
          input: {
            type: "structure",
            required: [
              "Video",
              "SegmentTypes"
            ],
            members: {
              Video: {
                shape: "S7v"
              },
              ClientRequestToken: {},
              NotificationChannel: {
                shape: "S7x"
              },
              JobTag: {},
              Filters: {
                type: "structure",
                members: {
                  TechnicalCueFilter: {
                    type: "structure",
                    members: {
                      MinSegmentConfidence: {
                        type: "float"
                      },
                      BlackFrame: {
                        type: "structure",
                        members: {
                          MaxPixelThreshold: {
                            type: "float"
                          },
                          MinCoveragePercentage: {
                            type: "float"
                          }
                        }
                      }
                    }
                  },
                  ShotFilter: {
                    type: "structure",
                    members: {
                      MinSegmentConfidence: {
                        type: "float"
                      }
                    }
                  }
                }
              },
              SegmentTypes: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          },
          idempotent: true
        },
        StartStreamProcessor: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartTextDetection: {
          input: {
            type: "structure",
            required: [
              "Video"
            ],
            members: {
              Video: {
                shape: "S7v"
              },
              ClientRequestToken: {},
              NotificationChannel: {
                shape: "S7x"
              },
              JobTag: {},
              Filters: {
                type: "structure",
                members: {
                  WordFilter: {
                    shape: "S4p"
                  },
                  RegionsOfInterest: {
                    shape: "S4s"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          },
          idempotent: true
        },
        StopProjectVersion: {
          input: {
            type: "structure",
            required: [
              "ProjectVersionArn"
            ],
            members: {
              ProjectVersionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        },
        StopStreamProcessor: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          members: {
            Bytes: {
              type: "blob"
            },
            S3Object: {
              shape: "S4"
            }
          }
        },
        S4: {
          type: "structure",
          members: {
            Bucket: {},
            Name: {},
            Version: {}
          }
        },
        Sc: {
          type: "structure",
          members: {
            Width: {
              type: "float"
            },
            Height: {
              type: "float"
            },
            Left: {
              type: "float"
            },
            Top: {
              type: "float"
            }
          }
        },
        Sg: {
          type: "structure",
          members: {
            BoundingBox: {
              shape: "Sc"
            },
            Confidence: {
              type: "float"
            },
            Landmarks: {
              shape: "Sh"
            },
            Pose: {
              shape: "Sk"
            },
            Quality: {
              shape: "Sm"
            },
            Emotions: {
              shape: "Sn"
            },
            Smile: {
              shape: "Sq"
            }
          }
        },
        Sh: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              X: {
                type: "float"
              },
              Y: {
                type: "float"
              }
            }
          }
        },
        Sk: {
          type: "structure",
          members: {
            Roll: {
              type: "float"
            },
            Yaw: {
              type: "float"
            },
            Pitch: {
              type: "float"
            }
          }
        },
        Sm: {
          type: "structure",
          members: {
            Brightness: {
              type: "float"
            },
            Sharpness: {
              type: "float"
            }
          }
        },
        Sn: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              Confidence: {
                type: "float"
              }
            }
          }
        },
        Sq: {
          type: "structure",
          members: {
            Value: {
              type: "boolean"
            },
            Confidence: {
              type: "float"
            }
          }
        },
        Sw: {
          type: "map",
          key: {},
          value: {}
        },
        S18: {
          type: "structure",
          members: {
            S3Bucket: {},
            S3KeyPrefix: {}
          }
        },
        S1a: {
          type: "structure",
          members: {
            Assets: {
              shape: "S1b"
            }
          }
        },
        S1b: {
          type: "list",
          member: {
            type: "structure",
            members: {
              GroundTruthManifest: {
                shape: "S1d"
              }
            }
          }
        },
        S1d: {
          type: "structure",
          members: {
            S3Object: {
              shape: "S4"
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            Assets: {
              shape: "S1b"
            },
            AutoCreate: {
              type: "boolean"
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            KinesisVideoStream: {
              type: "structure",
              members: {
                Arn: {}
              }
            }
          }
        },
        S1m: {
          type: "structure",
          members: {
            KinesisDataStream: {
              type: "structure",
              members: {
                Arn: {}
              }
            }
          }
        },
        S1q: {
          type: "structure",
          members: {
            FaceSearch: {
              type: "structure",
              members: {
                CollectionId: {},
                FaceMatchThreshold: {
                  type: "float"
                }
              }
            }
          }
        },
        S1y: {
          type: "list",
          member: {}
        },
        S2n: {
          type: "structure",
          members: {
            Assets: {
              shape: "S1b"
            }
          }
        },
        S33: {
          type: "structure",
          members: {
            BoundingBox: {
              shape: "Sc"
            },
            Polygon: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  X: {
                    type: "float"
                  },
                  Y: {
                    type: "float"
                  }
                }
              }
            }
          }
        },
        S37: {
          type: "list",
          member: {}
        },
        S3b: {
          type: "structure",
          members: {
            BoundingBox: {
              shape: "Sc"
            },
            AgeRange: {
              type: "structure",
              members: {
                Low: {
                  type: "integer"
                },
                High: {
                  type: "integer"
                }
              }
            },
            Smile: {
              shape: "Sq"
            },
            Eyeglasses: {
              type: "structure",
              members: {
                Value: {
                  type: "boolean"
                },
                Confidence: {
                  type: "float"
                }
              }
            },
            Sunglasses: {
              type: "structure",
              members: {
                Value: {
                  type: "boolean"
                },
                Confidence: {
                  type: "float"
                }
              }
            },
            Gender: {
              type: "structure",
              members: {
                Value: {},
                Confidence: {
                  type: "float"
                }
              }
            },
            Beard: {
              type: "structure",
              members: {
                Value: {
                  type: "boolean"
                },
                Confidence: {
                  type: "float"
                }
              }
            },
            Mustache: {
              type: "structure",
              members: {
                Value: {
                  type: "boolean"
                },
                Confidence: {
                  type: "float"
                }
              }
            },
            EyesOpen: {
              type: "structure",
              members: {
                Value: {
                  type: "boolean"
                },
                Confidence: {
                  type: "float"
                }
              }
            },
            MouthOpen: {
              type: "structure",
              members: {
                Value: {
                  type: "boolean"
                },
                Confidence: {
                  type: "float"
                }
              }
            },
            Emotions: {
              shape: "Sn"
            },
            Landmarks: {
              shape: "Sh"
            },
            Pose: {
              shape: "Sk"
            },
            Quality: {
              shape: "Sm"
            },
            Confidence: {
              type: "float"
            }
          }
        },
        S3o: {
          type: "structure",
          members: {
            Name: {},
            Confidence: {
              type: "float"
            },
            Instances: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  BoundingBox: {
                    shape: "Sc"
                  },
                  Confidence: {
                    type: "float"
                  }
                }
              }
            },
            Parents: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {}
                }
              }
            }
          }
        },
        S42: {
          type: "structure",
          members: {
            Confidence: {
              type: "float"
            },
            Name: {},
            ParentName: {}
          }
        },
        S4m: {
          type: "list",
          member: {
            type: "integer"
          }
        },
        S4p: {
          type: "structure",
          members: {
            MinConfidence: {
              type: "float"
            },
            MinBoundingBoxHeight: {
              type: "float"
            },
            MinBoundingBoxWidth: {
              type: "float"
            }
          }
        },
        S4s: {
          type: "list",
          member: {
            type: "structure",
            members: {
              BoundingBox: {
                shape: "Sc"
              }
            }
          }
        },
        S4w: {
          type: "structure",
          members: {
            DetectedText: {},
            Type: {},
            Id: {
              type: "integer"
            },
            ParentId: {
              type: "integer"
            },
            Confidence: {
              type: "float"
            },
            Geometry: {
              shape: "S33"
            }
          }
        },
        S51: {
          type: "list",
          member: {}
        },
        S53: {
          type: "structure",
          members: {
            Type: {}
          }
        },
        S5c: {
          type: "structure",
          members: {
            Codec: {},
            DurationMillis: {
              type: "long"
            },
            Format: {},
            FrameRate: {
              type: "float"
            },
            FrameHeight: {
              type: "long"
            },
            FrameWidth: {
              type: "long"
            },
            ColorRange: {}
          }
        },
        S5w: {
          type: "structure",
          members: {
            Index: {
              type: "long"
            },
            BoundingBox: {
              shape: "Sc"
            },
            Face: {
              shape: "S3b"
            }
          }
        },
        S5y: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Similarity: {
                type: "float"
              },
              Face: {
                shape: "S60"
              }
            }
          }
        },
        S60: {
          type: "structure",
          members: {
            FaceId: {},
            BoundingBox: {
              shape: "Sc"
            },
            ImageId: {},
            ExternalImageId: {},
            Confidence: {
              type: "float"
            }
          }
        },
        S7v: {
          type: "structure",
          members: {
            S3Object: {
              shape: "S4"
            }
          }
        },
        S7x: {
          type: "structure",
          required: [
            "SNSTopicArn",
            "RoleArn"
          ],
          members: {
            SNSTopicArn: {},
            RoleArn: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rekognition-2016-06-27.paginators.json
var require_rekognition_2016_06_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/rekognition-2016-06-27.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeProjectVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ProjectVersionDescriptions"
        },
        DescribeProjects: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ProjectDescriptions"
        },
        GetCelebrityRecognition: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetContentModeration: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetFaceDetection: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetFaceSearch: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetLabelDetection: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetPersonTracking: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetSegmentDetection: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetTextDetection: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListCollections: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CollectionIds"
        },
        ListFaces: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Faces"
        },
        ListStreamProcessors: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rekognition-2016-06-27.waiters2.json
var require_rekognition_2016_06_27_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/rekognition-2016-06-27.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ProjectVersionTrainingCompleted: {
          description: "Wait until the ProjectVersion training completes.",
          operation: "DescribeProjectVersions",
          delay: 120,
          maxAttempts: 360,
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "ProjectVersionDescriptions[].Status",
              expected: "TRAINING_COMPLETED"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "ProjectVersionDescriptions[].Status",
              expected: "TRAINING_FAILED"
            }
          ]
        },
        ProjectVersionRunning: {
          description: "Wait until the ProjectVersion is running.",
          delay: 30,
          maxAttempts: 40,
          operation: "DescribeProjectVersions",
          acceptors: [
            {
              state: "success",
              matcher: "pathAll",
              argument: "ProjectVersionDescriptions[].Status",
              expected: "RUNNING"
            },
            {
              state: "failure",
              matcher: "pathAny",
              argument: "ProjectVersionDescriptions[].Status",
              expected: "FAILED"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/rekognition.js
var require_rekognition = __commonJS({
  "node_modules/aws-sdk/clients/rekognition.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["rekognition"] = {};
    AWS3.Rekognition = Service.defineService("rekognition", ["2016-06-27"]);
    Object.defineProperty(apiLoader.services["rekognition"], "2016-06-27", {
      get: function get() {
        var model = require_rekognition_2016_06_27_min();
        model.paginators = require_rekognition_2016_06_27_paginators().pagination;
        model.waiters = require_rekognition_2016_06_27_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Rekognition;
  }
});

// node_modules/aws-sdk/apis/resourcegroupstaggingapi-2017-01-26.min.json
var require_resourcegroupstaggingapi_2017_01_26_min = __commonJS({
  "node_modules/aws-sdk/apis/resourcegroupstaggingapi-2017-01-26.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-01-26",
        endpointPrefix: "tagging",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Resource Groups Tagging API",
        serviceId: "Resource Groups Tagging API",
        signatureVersion: "v4",
        targetPrefix: "ResourceGroupsTaggingAPI_20170126",
        uid: "resourcegroupstaggingapi-2017-01-26"
      },
      operations: {
        DescribeReportCreation: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              S3Location: {},
              ErrorMessage: {}
            }
          }
        },
        GetComplianceSummary: {
          input: {
            type: "structure",
            members: {
              TargetIdFilters: {
                type: "list",
                member: {}
              },
              RegionFilters: {
                type: "list",
                member: {}
              },
              ResourceTypeFilters: {
                shape: "Sb"
              },
              TagKeyFilters: {
                type: "list",
                member: {}
              },
              GroupBy: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              },
              PaginationToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LastUpdated: {},
                    TargetId: {},
                    TargetIdType: {},
                    Region: {},
                    ResourceType: {},
                    NonCompliantResources: {
                      type: "long"
                    }
                  }
                }
              },
              PaginationToken: {}
            }
          }
        },
        GetResources: {
          input: {
            type: "structure",
            members: {
              PaginationToken: {},
              TagFilters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              ResourcesPerPage: {
                type: "integer"
              },
              TagsPerPage: {
                type: "integer"
              },
              ResourceTypeFilters: {
                shape: "Sb"
              },
              IncludeComplianceDetails: {
                type: "boolean"
              },
              ExcludeCompliantResources: {
                type: "boolean"
              },
              ResourceARNList: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PaginationToken: {},
              ResourceTagMappingList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceARN: {},
                    Tags: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Key",
                          "Value"
                        ],
                        members: {
                          Key: {},
                          Value: {}
                        }
                      }
                    },
                    ComplianceDetails: {
                      type: "structure",
                      members: {
                        NoncompliantKeys: {
                          shape: "S16"
                        },
                        KeysWithNoncompliantValues: {
                          shape: "S16"
                        },
                        ComplianceStatus: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetTagKeys: {
          input: {
            type: "structure",
            members: {
              PaginationToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PaginationToken: {},
              TagKeys: {
                shape: "S16"
              }
            }
          }
        },
        GetTagValues: {
          input: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              PaginationToken: {},
              Key: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PaginationToken: {},
              TagValues: {
                type: "list",
                member: {}
              }
            }
          }
        },
        StartReportCreation: {
          input: {
            type: "structure",
            required: [
              "S3Bucket"
            ],
            members: {
              S3Bucket: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResources: {
          input: {
            type: "structure",
            required: [
              "ResourceARNList",
              "Tags"
            ],
            members: {
              ResourceARNList: {
                shape: "S1h"
              },
              Tags: {
                type: "map",
                key: {},
                value: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedResourcesMap: {
                shape: "S1k"
              }
            }
          }
        },
        UntagResources: {
          input: {
            type: "structure",
            required: [
              "ResourceARNList",
              "TagKeys"
            ],
            members: {
              ResourceARNList: {
                shape: "S1h"
              },
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedResourcesMap: {
                shape: "S1k"
              }
            }
          }
        }
      },
      shapes: {
        Sb: {
          type: "list",
          member: {}
        },
        S16: {
          type: "list",
          member: {}
        },
        S1h: {
          type: "list",
          member: {}
        },
        S1k: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              StatusCode: {
                type: "integer"
              },
              ErrorCode: {},
              ErrorMessage: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/resourcegroupstaggingapi-2017-01-26.paginators.json
var require_resourcegroupstaggingapi_2017_01_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/resourcegroupstaggingapi-2017-01-26.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetComplianceSummary: {
          input_token: "PaginationToken",
          limit_key: "MaxResults",
          output_token: "PaginationToken",
          result_key: "SummaryList"
        },
        GetResources: {
          input_token: "PaginationToken",
          limit_key: "ResourcesPerPage",
          output_token: "PaginationToken",
          result_key: "ResourceTagMappingList"
        },
        GetTagKeys: {
          input_token: "PaginationToken",
          output_token: "PaginationToken",
          result_key: "TagKeys"
        },
        GetTagValues: {
          input_token: "PaginationToken",
          output_token: "PaginationToken",
          result_key: "TagValues"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/resourcegroupstaggingapi.js
var require_resourcegroupstaggingapi = __commonJS({
  "node_modules/aws-sdk/clients/resourcegroupstaggingapi.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["resourcegroupstaggingapi"] = {};
    AWS3.ResourceGroupsTaggingAPI = Service.defineService("resourcegroupstaggingapi", ["2017-01-26"]);
    Object.defineProperty(apiLoader.services["resourcegroupstaggingapi"], "2017-01-26", {
      get: function get() {
        var model = require_resourcegroupstaggingapi_2017_01_26_min();
        model.paginators = require_resourcegroupstaggingapi_2017_01_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ResourceGroupsTaggingAPI;
  }
});

// node_modules/aws-sdk/lib/services/route53.js
var require_route53 = __commonJS({
  "node_modules/aws-sdk/lib/services/route53.js"() {
    var AWS3 = require_core();
    AWS3.util.update(AWS3.Route53.prototype, {
      setupRequestListeners: function setupRequestListeners(request) {
        request.on("build", this.sanitizeUrl);
      },
      sanitizeUrl: function sanitizeUrl(request) {
        var path2 = request.httpRequest.path;
        request.httpRequest.path = path2.replace(/\/%2F\w+%2F/, "/");
      },
      retryableError: function retryableError(error) {
        if (error.code === "PriorRequestNotComplete" && error.statusCode === 400) {
          return true;
        } else {
          var _super = AWS3.Service.prototype.retryableError;
          return _super.call(this, error);
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/route53-2013-04-01.min.json
var require_route53_2013_04_01_min = __commonJS({
  "node_modules/aws-sdk/apis/route53-2013-04-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-04-01",
        endpointPrefix: "route53",
        globalEndpoint: "route53.amazonaws.com",
        protocol: "rest-xml",
        serviceAbbreviation: "Route 53",
        serviceFullName: "Amazon Route 53",
        serviceId: "Route 53",
        signatureVersion: "v4",
        uid: "route53-2013-04-01"
      },
      operations: {
        ActivateKeySigningKey: {
          http: {
            requestUri: "/2013-04-01/keysigningkey/{HostedZoneId}/{Name}/activate"
          },
          input: {
            type: "structure",
            required: [
              "HostedZoneId",
              "Name"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "HostedZoneId"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              }
            }
          }
        },
        AssociateVPCWithHostedZone: {
          http: {
            requestUri: "/2013-04-01/hostedzone/{Id}/associatevpc"
          },
          input: {
            locationName: "AssociateVPCWithHostedZoneRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "HostedZoneId",
              "VPC"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              },
              VPC: {
                shape: "Sa"
              },
              Comment: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              }
            }
          }
        },
        ChangeResourceRecordSets: {
          http: {
            requestUri: "/2013-04-01/hostedzone/{Id}/rrset/"
          },
          input: {
            locationName: "ChangeResourceRecordSetsRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "HostedZoneId",
              "ChangeBatch"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              },
              ChangeBatch: {
                type: "structure",
                required: [
                  "Changes"
                ],
                members: {
                  Comment: {},
                  Changes: {
                    type: "list",
                    member: {
                      locationName: "Change",
                      type: "structure",
                      required: [
                        "Action",
                        "ResourceRecordSet"
                      ],
                      members: {
                        Action: {},
                        ResourceRecordSet: {
                          shape: "Sk"
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              }
            }
          }
        },
        ChangeTagsForResource: {
          http: {
            requestUri: "/2013-04-01/tags/{ResourceType}/{ResourceId}"
          },
          input: {
            locationName: "ChangeTagsForResourceRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "ResourceType",
              "ResourceId"
            ],
            members: {
              ResourceType: {
                location: "uri",
                locationName: "ResourceType"
              },
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              AddTags: {
                shape: "S18"
              },
              RemoveTagKeys: {
                type: "list",
                member: {
                  locationName: "Key"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateHealthCheck: {
          http: {
            requestUri: "/2013-04-01/healthcheck",
            responseCode: 201
          },
          input: {
            locationName: "CreateHealthCheckRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "CallerReference",
              "HealthCheckConfig"
            ],
            members: {
              CallerReference: {},
              HealthCheckConfig: {
                shape: "S1g"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HealthCheck",
              "Location"
            ],
            members: {
              HealthCheck: {
                shape: "S23"
              },
              Location: {
                location: "header",
                locationName: "Location"
              }
            }
          }
        },
        CreateHostedZone: {
          http: {
            requestUri: "/2013-04-01/hostedzone",
            responseCode: 201
          },
          input: {
            locationName: "CreateHostedZoneRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "Name",
              "CallerReference"
            ],
            members: {
              Name: {},
              VPC: {
                shape: "Sa"
              },
              CallerReference: {},
              HostedZoneConfig: {
                shape: "S2l"
              },
              DelegationSetId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "HostedZone",
              "ChangeInfo",
              "DelegationSet",
              "Location"
            ],
            members: {
              HostedZone: {
                shape: "S2o"
              },
              ChangeInfo: {
                shape: "S5"
              },
              DelegationSet: {
                shape: "S2q"
              },
              VPC: {
                shape: "Sa"
              },
              Location: {
                location: "header",
                locationName: "Location"
              }
            }
          }
        },
        CreateKeySigningKey: {
          http: {
            requestUri: "/2013-04-01/keysigningkey",
            responseCode: 201
          },
          input: {
            locationName: "CreateKeySigningKeyRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "CallerReference",
              "HostedZoneId",
              "KeyManagementServiceArn",
              "Name",
              "Status"
            ],
            members: {
              CallerReference: {},
              HostedZoneId: {},
              KeyManagementServiceArn: {},
              Name: {},
              Status: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo",
              "KeySigningKey",
              "Location"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              },
              KeySigningKey: {
                shape: "S2w"
              },
              Location: {
                location: "header",
                locationName: "Location"
              }
            }
          }
        },
        CreateQueryLoggingConfig: {
          http: {
            requestUri: "/2013-04-01/queryloggingconfig",
            responseCode: 201
          },
          input: {
            locationName: "CreateQueryLoggingConfigRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "HostedZoneId",
              "CloudWatchLogsLogGroupArn"
            ],
            members: {
              HostedZoneId: {},
              CloudWatchLogsLogGroupArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "QueryLoggingConfig",
              "Location"
            ],
            members: {
              QueryLoggingConfig: {
                shape: "S33"
              },
              Location: {
                location: "header",
                locationName: "Location"
              }
            }
          }
        },
        CreateReusableDelegationSet: {
          http: {
            requestUri: "/2013-04-01/delegationset",
            responseCode: 201
          },
          input: {
            locationName: "CreateReusableDelegationSetRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "CallerReference"
            ],
            members: {
              CallerReference: {},
              HostedZoneId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DelegationSet",
              "Location"
            ],
            members: {
              DelegationSet: {
                shape: "S2q"
              },
              Location: {
                location: "header",
                locationName: "Location"
              }
            }
          }
        },
        CreateTrafficPolicy: {
          http: {
            requestUri: "/2013-04-01/trafficpolicy",
            responseCode: 201
          },
          input: {
            locationName: "CreateTrafficPolicyRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "Name",
              "Document"
            ],
            members: {
              Name: {},
              Document: {},
              Comment: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicy",
              "Location"
            ],
            members: {
              TrafficPolicy: {
                shape: "S3c"
              },
              Location: {
                location: "header",
                locationName: "Location"
              }
            }
          }
        },
        CreateTrafficPolicyInstance: {
          http: {
            requestUri: "/2013-04-01/trafficpolicyinstance",
            responseCode: 201
          },
          input: {
            locationName: "CreateTrafficPolicyInstanceRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "HostedZoneId",
              "Name",
              "TTL",
              "TrafficPolicyId",
              "TrafficPolicyVersion"
            ],
            members: {
              HostedZoneId: {},
              Name: {},
              TTL: {
                type: "long"
              },
              TrafficPolicyId: {},
              TrafficPolicyVersion: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicyInstance",
              "Location"
            ],
            members: {
              TrafficPolicyInstance: {
                shape: "S3h"
              },
              Location: {
                location: "header",
                locationName: "Location"
              }
            }
          }
        },
        CreateTrafficPolicyVersion: {
          http: {
            requestUri: "/2013-04-01/trafficpolicy/{Id}",
            responseCode: 201
          },
          input: {
            locationName: "CreateTrafficPolicyVersionRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "Id",
              "Document"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Document: {},
              Comment: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicy",
              "Location"
            ],
            members: {
              TrafficPolicy: {
                shape: "S3c"
              },
              Location: {
                location: "header",
                locationName: "Location"
              }
            }
          }
        },
        CreateVPCAssociationAuthorization: {
          http: {
            requestUri: "/2013-04-01/hostedzone/{Id}/authorizevpcassociation"
          },
          input: {
            locationName: "CreateVPCAssociationAuthorizationRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "HostedZoneId",
              "VPC"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              },
              VPC: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HostedZoneId",
              "VPC"
            ],
            members: {
              HostedZoneId: {},
              VPC: {
                shape: "Sa"
              }
            }
          }
        },
        DeactivateKeySigningKey: {
          http: {
            requestUri: "/2013-04-01/keysigningkey/{HostedZoneId}/{Name}/deactivate"
          },
          input: {
            type: "structure",
            required: [
              "HostedZoneId",
              "Name"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "HostedZoneId"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              }
            }
          }
        },
        DeleteHealthCheck: {
          http: {
            method: "DELETE",
            requestUri: "/2013-04-01/healthcheck/{HealthCheckId}"
          },
          input: {
            type: "structure",
            required: [
              "HealthCheckId"
            ],
            members: {
              HealthCheckId: {
                location: "uri",
                locationName: "HealthCheckId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteHostedZone: {
          http: {
            method: "DELETE",
            requestUri: "/2013-04-01/hostedzone/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              }
            }
          }
        },
        DeleteKeySigningKey: {
          http: {
            method: "DELETE",
            requestUri: "/2013-04-01/keysigningkey/{HostedZoneId}/{Name}"
          },
          input: {
            type: "structure",
            required: [
              "HostedZoneId",
              "Name"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "HostedZoneId"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              }
            }
          }
        },
        DeleteQueryLoggingConfig: {
          http: {
            method: "DELETE",
            requestUri: "/2013-04-01/queryloggingconfig/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteReusableDelegationSet: {
          http: {
            method: "DELETE",
            requestUri: "/2013-04-01/delegationset/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTrafficPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/2013-04-01/trafficpolicy/{Id}/{Version}"
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "Version"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Version: {
                location: "uri",
                locationName: "Version",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTrafficPolicyInstance: {
          http: {
            method: "DELETE",
            requestUri: "/2013-04-01/trafficpolicyinstance/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteVPCAssociationAuthorization: {
          http: {
            requestUri: "/2013-04-01/hostedzone/{Id}/deauthorizevpcassociation"
          },
          input: {
            locationName: "DeleteVPCAssociationAuthorizationRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "HostedZoneId",
              "VPC"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              },
              VPC: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableHostedZoneDNSSEC: {
          http: {
            requestUri: "/2013-04-01/hostedzone/{Id}/disable-dnssec"
          },
          input: {
            type: "structure",
            required: [
              "HostedZoneId"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              }
            }
          }
        },
        DisassociateVPCFromHostedZone: {
          http: {
            requestUri: "/2013-04-01/hostedzone/{Id}/disassociatevpc"
          },
          input: {
            locationName: "DisassociateVPCFromHostedZoneRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "HostedZoneId",
              "VPC"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              },
              VPC: {
                shape: "Sa"
              },
              Comment: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              }
            }
          }
        },
        EnableHostedZoneDNSSEC: {
          http: {
            requestUri: "/2013-04-01/hostedzone/{Id}/enable-dnssec"
          },
          input: {
            type: "structure",
            required: [
              "HostedZoneId"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              }
            }
          }
        },
        GetAccountLimit: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/accountlimit/{Type}"
          },
          input: {
            type: "structure",
            required: [
              "Type"
            ],
            members: {
              Type: {
                location: "uri",
                locationName: "Type"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Limit",
              "Count"
            ],
            members: {
              Limit: {
                type: "structure",
                required: [
                  "Type",
                  "Value"
                ],
                members: {
                  Type: {},
                  Value: {
                    type: "long"
                  }
                }
              },
              Count: {
                type: "long"
              }
            }
          }
        },
        GetChange: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/change/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ChangeInfo"
            ],
            members: {
              ChangeInfo: {
                shape: "S5"
              }
            }
          }
        },
        GetCheckerIpRanges: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/checkeripranges"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "CheckerIpRanges"
            ],
            members: {
              CheckerIpRanges: {
                type: "list",
                member: {}
              }
            }
          }
        },
        GetDNSSEC: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/hostedzone/{Id}/dnssec"
          },
          input: {
            type: "structure",
            required: [
              "HostedZoneId"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Status",
              "KeySigningKeys"
            ],
            members: {
              Status: {
                type: "structure",
                members: {
                  ServeSignature: {},
                  StatusMessage: {}
                }
              },
              KeySigningKeys: {
                type: "list",
                member: {
                  shape: "S2w"
                }
              }
            }
          }
        },
        GetGeoLocation: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/geolocation"
          },
          input: {
            type: "structure",
            members: {
              ContinentCode: {
                location: "querystring",
                locationName: "continentcode"
              },
              CountryCode: {
                location: "querystring",
                locationName: "countrycode"
              },
              SubdivisionCode: {
                location: "querystring",
                locationName: "subdivisioncode"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "GeoLocationDetails"
            ],
            members: {
              GeoLocationDetails: {
                shape: "S4w"
              }
            }
          }
        },
        GetHealthCheck: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/healthcheck/{HealthCheckId}"
          },
          input: {
            type: "structure",
            required: [
              "HealthCheckId"
            ],
            members: {
              HealthCheckId: {
                location: "uri",
                locationName: "HealthCheckId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HealthCheck"
            ],
            members: {
              HealthCheck: {
                shape: "S23"
              }
            }
          }
        },
        GetHealthCheckCount: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/healthcheckcount"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "HealthCheckCount"
            ],
            members: {
              HealthCheckCount: {
                type: "long"
              }
            }
          }
        },
        GetHealthCheckLastFailureReason: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/healthcheck/{HealthCheckId}/lastfailurereason"
          },
          input: {
            type: "structure",
            required: [
              "HealthCheckId"
            ],
            members: {
              HealthCheckId: {
                location: "uri",
                locationName: "HealthCheckId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HealthCheckObservations"
            ],
            members: {
              HealthCheckObservations: {
                shape: "S57"
              }
            }
          }
        },
        GetHealthCheckStatus: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/healthcheck/{HealthCheckId}/status"
          },
          input: {
            type: "structure",
            required: [
              "HealthCheckId"
            ],
            members: {
              HealthCheckId: {
                location: "uri",
                locationName: "HealthCheckId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HealthCheckObservations"
            ],
            members: {
              HealthCheckObservations: {
                shape: "S57"
              }
            }
          }
        },
        GetHostedZone: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/hostedzone/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HostedZone"
            ],
            members: {
              HostedZone: {
                shape: "S2o"
              },
              DelegationSet: {
                shape: "S2q"
              },
              VPCs: {
                shape: "S5f"
              }
            }
          }
        },
        GetHostedZoneCount: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/hostedzonecount"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "HostedZoneCount"
            ],
            members: {
              HostedZoneCount: {
                type: "long"
              }
            }
          }
        },
        GetHostedZoneLimit: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/hostedzonelimit/{Id}/{Type}"
          },
          input: {
            type: "structure",
            required: [
              "Type",
              "HostedZoneId"
            ],
            members: {
              Type: {
                location: "uri",
                locationName: "Type"
              },
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Limit",
              "Count"
            ],
            members: {
              Limit: {
                type: "structure",
                required: [
                  "Type",
                  "Value"
                ],
                members: {
                  Type: {},
                  Value: {
                    type: "long"
                  }
                }
              },
              Count: {
                type: "long"
              }
            }
          }
        },
        GetQueryLoggingConfig: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/queryloggingconfig/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "QueryLoggingConfig"
            ],
            members: {
              QueryLoggingConfig: {
                shape: "S33"
              }
            }
          }
        },
        GetReusableDelegationSet: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/delegationset/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DelegationSet"
            ],
            members: {
              DelegationSet: {
                shape: "S2q"
              }
            }
          }
        },
        GetReusableDelegationSetLimit: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/reusabledelegationsetlimit/{Id}/{Type}"
          },
          input: {
            type: "structure",
            required: [
              "Type",
              "DelegationSetId"
            ],
            members: {
              Type: {
                location: "uri",
                locationName: "Type"
              },
              DelegationSetId: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Limit",
              "Count"
            ],
            members: {
              Limit: {
                type: "structure",
                required: [
                  "Type",
                  "Value"
                ],
                members: {
                  Type: {},
                  Value: {
                    type: "long"
                  }
                }
              },
              Count: {
                type: "long"
              }
            }
          }
        },
        GetTrafficPolicy: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/trafficpolicy/{Id}/{Version}"
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "Version"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Version: {
                location: "uri",
                locationName: "Version",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicy"
            ],
            members: {
              TrafficPolicy: {
                shape: "S3c"
              }
            }
          }
        },
        GetTrafficPolicyInstance: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/trafficpolicyinstance/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicyInstance"
            ],
            members: {
              TrafficPolicyInstance: {
                shape: "S3h"
              }
            }
          }
        },
        GetTrafficPolicyInstanceCount: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/trafficpolicyinstancecount"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicyInstanceCount"
            ],
            members: {
              TrafficPolicyInstanceCount: {
                type: "integer"
              }
            }
          }
        },
        ListGeoLocations: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/geolocations"
          },
          input: {
            type: "structure",
            members: {
              StartContinentCode: {
                location: "querystring",
                locationName: "startcontinentcode"
              },
              StartCountryCode: {
                location: "querystring",
                locationName: "startcountrycode"
              },
              StartSubdivisionCode: {
                location: "querystring",
                locationName: "startsubdivisioncode"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "GeoLocationDetailsList",
              "IsTruncated",
              "MaxItems"
            ],
            members: {
              GeoLocationDetailsList: {
                type: "list",
                member: {
                  shape: "S4w",
                  locationName: "GeoLocationDetails"
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              NextContinentCode: {},
              NextCountryCode: {},
              NextSubdivisionCode: {},
              MaxItems: {}
            }
          }
        },
        ListHealthChecks: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/healthcheck"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HealthChecks",
              "Marker",
              "IsTruncated",
              "MaxItems"
            ],
            members: {
              HealthChecks: {
                type: "list",
                member: {
                  shape: "S23",
                  locationName: "HealthCheck"
                }
              },
              Marker: {},
              IsTruncated: {
                type: "boolean"
              },
              NextMarker: {},
              MaxItems: {}
            }
          }
        },
        ListHostedZones: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/hostedzone"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              },
              DelegationSetId: {
                location: "querystring",
                locationName: "delegationsetid"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HostedZones",
              "Marker",
              "IsTruncated",
              "MaxItems"
            ],
            members: {
              HostedZones: {
                shape: "S6d"
              },
              Marker: {},
              IsTruncated: {
                type: "boolean"
              },
              NextMarker: {},
              MaxItems: {}
            }
          }
        },
        ListHostedZonesByName: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/hostedzonesbyname"
          },
          input: {
            type: "structure",
            members: {
              DNSName: {
                location: "querystring",
                locationName: "dnsname"
              },
              HostedZoneId: {
                location: "querystring",
                locationName: "hostedzoneid"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HostedZones",
              "IsTruncated",
              "MaxItems"
            ],
            members: {
              HostedZones: {
                shape: "S6d"
              },
              DNSName: {},
              HostedZoneId: {},
              IsTruncated: {
                type: "boolean"
              },
              NextDNSName: {},
              NextHostedZoneId: {},
              MaxItems: {}
            }
          }
        },
        ListHostedZonesByVPC: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/hostedzonesbyvpc"
          },
          input: {
            type: "structure",
            required: [
              "VPCId",
              "VPCRegion"
            ],
            members: {
              VPCId: {
                location: "querystring",
                locationName: "vpcid"
              },
              VPCRegion: {
                location: "querystring",
                locationName: "vpcregion"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              },
              NextToken: {
                location: "querystring",
                locationName: "nexttoken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HostedZoneSummaries",
              "MaxItems"
            ],
            members: {
              HostedZoneSummaries: {
                type: "list",
                member: {
                  locationName: "HostedZoneSummary",
                  type: "structure",
                  required: [
                    "HostedZoneId",
                    "Name",
                    "Owner"
                  ],
                  members: {
                    HostedZoneId: {},
                    Name: {},
                    Owner: {
                      type: "structure",
                      members: {
                        OwningAccount: {},
                        OwningService: {}
                      }
                    }
                  }
                }
              },
              MaxItems: {},
              NextToken: {}
            }
          }
        },
        ListQueryLoggingConfigs: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/queryloggingconfig"
          },
          input: {
            type: "structure",
            members: {
              HostedZoneId: {
                location: "querystring",
                locationName: "hostedzoneid"
              },
              NextToken: {
                location: "querystring",
                locationName: "nexttoken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxresults"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "QueryLoggingConfigs"
            ],
            members: {
              QueryLoggingConfigs: {
                type: "list",
                member: {
                  shape: "S33",
                  locationName: "QueryLoggingConfig"
                }
              },
              NextToken: {}
            }
          }
        },
        ListResourceRecordSets: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/hostedzone/{Id}/rrset"
          },
          input: {
            type: "structure",
            required: [
              "HostedZoneId"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              },
              StartRecordName: {
                location: "querystring",
                locationName: "name"
              },
              StartRecordType: {
                location: "querystring",
                locationName: "type"
              },
              StartRecordIdentifier: {
                location: "querystring",
                locationName: "identifier"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceRecordSets",
              "IsTruncated",
              "MaxItems"
            ],
            members: {
              ResourceRecordSets: {
                type: "list",
                member: {
                  shape: "Sk",
                  locationName: "ResourceRecordSet"
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              NextRecordName: {},
              NextRecordType: {},
              NextRecordIdentifier: {},
              MaxItems: {}
            }
          }
        },
        ListReusableDelegationSets: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/delegationset"
          },
          input: {
            type: "structure",
            members: {
              Marker: {
                location: "querystring",
                locationName: "marker"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DelegationSets",
              "Marker",
              "IsTruncated",
              "MaxItems"
            ],
            members: {
              DelegationSets: {
                type: "list",
                member: {
                  shape: "S2q",
                  locationName: "DelegationSet"
                }
              },
              Marker: {},
              IsTruncated: {
                type: "boolean"
              },
              NextMarker: {},
              MaxItems: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/tags/{ResourceType}/{ResourceId}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceType",
              "ResourceId"
            ],
            members: {
              ResourceType: {
                location: "uri",
                locationName: "ResourceType"
              },
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceTagSet"
            ],
            members: {
              ResourceTagSet: {
                shape: "S70"
              }
            }
          }
        },
        ListTagsForResources: {
          http: {
            requestUri: "/2013-04-01/tags/{ResourceType}"
          },
          input: {
            locationName: "ListTagsForResourcesRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "ResourceType",
              "ResourceIds"
            ],
            members: {
              ResourceType: {
                location: "uri",
                locationName: "ResourceType"
              },
              ResourceIds: {
                type: "list",
                member: {
                  locationName: "ResourceId"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceTagSets"
            ],
            members: {
              ResourceTagSets: {
                type: "list",
                member: {
                  shape: "S70",
                  locationName: "ResourceTagSet"
                }
              }
            }
          }
        },
        ListTrafficPolicies: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/trafficpolicies"
          },
          input: {
            type: "structure",
            members: {
              TrafficPolicyIdMarker: {
                location: "querystring",
                locationName: "trafficpolicyid"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicySummaries",
              "IsTruncated",
              "TrafficPolicyIdMarker",
              "MaxItems"
            ],
            members: {
              TrafficPolicySummaries: {
                type: "list",
                member: {
                  locationName: "TrafficPolicySummary",
                  type: "structure",
                  required: [
                    "Id",
                    "Name",
                    "Type",
                    "LatestVersion",
                    "TrafficPolicyCount"
                  ],
                  members: {
                    Id: {},
                    Name: {},
                    Type: {},
                    LatestVersion: {
                      type: "integer"
                    },
                    TrafficPolicyCount: {
                      type: "integer"
                    }
                  }
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              TrafficPolicyIdMarker: {},
              MaxItems: {}
            }
          }
        },
        ListTrafficPolicyInstances: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/trafficpolicyinstances"
          },
          input: {
            type: "structure",
            members: {
              HostedZoneIdMarker: {
                location: "querystring",
                locationName: "hostedzoneid"
              },
              TrafficPolicyInstanceNameMarker: {
                location: "querystring",
                locationName: "trafficpolicyinstancename"
              },
              TrafficPolicyInstanceTypeMarker: {
                location: "querystring",
                locationName: "trafficpolicyinstancetype"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicyInstances",
              "IsTruncated",
              "MaxItems"
            ],
            members: {
              TrafficPolicyInstances: {
                shape: "S7b"
              },
              HostedZoneIdMarker: {},
              TrafficPolicyInstanceNameMarker: {},
              TrafficPolicyInstanceTypeMarker: {},
              IsTruncated: {
                type: "boolean"
              },
              MaxItems: {}
            }
          }
        },
        ListTrafficPolicyInstancesByHostedZone: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/trafficpolicyinstances/hostedzone"
          },
          input: {
            type: "structure",
            required: [
              "HostedZoneId"
            ],
            members: {
              HostedZoneId: {
                location: "querystring",
                locationName: "id"
              },
              TrafficPolicyInstanceNameMarker: {
                location: "querystring",
                locationName: "trafficpolicyinstancename"
              },
              TrafficPolicyInstanceTypeMarker: {
                location: "querystring",
                locationName: "trafficpolicyinstancetype"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicyInstances",
              "IsTruncated",
              "MaxItems"
            ],
            members: {
              TrafficPolicyInstances: {
                shape: "S7b"
              },
              TrafficPolicyInstanceNameMarker: {},
              TrafficPolicyInstanceTypeMarker: {},
              IsTruncated: {
                type: "boolean"
              },
              MaxItems: {}
            }
          }
        },
        ListTrafficPolicyInstancesByPolicy: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/trafficpolicyinstances/trafficpolicy"
          },
          input: {
            type: "structure",
            required: [
              "TrafficPolicyId",
              "TrafficPolicyVersion"
            ],
            members: {
              TrafficPolicyId: {
                location: "querystring",
                locationName: "id"
              },
              TrafficPolicyVersion: {
                location: "querystring",
                locationName: "version",
                type: "integer"
              },
              HostedZoneIdMarker: {
                location: "querystring",
                locationName: "hostedzoneid"
              },
              TrafficPolicyInstanceNameMarker: {
                location: "querystring",
                locationName: "trafficpolicyinstancename"
              },
              TrafficPolicyInstanceTypeMarker: {
                location: "querystring",
                locationName: "trafficpolicyinstancetype"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicyInstances",
              "IsTruncated",
              "MaxItems"
            ],
            members: {
              TrafficPolicyInstances: {
                shape: "S7b"
              },
              HostedZoneIdMarker: {},
              TrafficPolicyInstanceNameMarker: {},
              TrafficPolicyInstanceTypeMarker: {},
              IsTruncated: {
                type: "boolean"
              },
              MaxItems: {}
            }
          }
        },
        ListTrafficPolicyVersions: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/trafficpolicies/{Id}/versions"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              TrafficPolicyVersionMarker: {
                location: "querystring",
                locationName: "trafficpolicyversion"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxitems"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicies",
              "IsTruncated",
              "TrafficPolicyVersionMarker",
              "MaxItems"
            ],
            members: {
              TrafficPolicies: {
                type: "list",
                member: {
                  shape: "S3c",
                  locationName: "TrafficPolicy"
                }
              },
              IsTruncated: {
                type: "boolean"
              },
              TrafficPolicyVersionMarker: {},
              MaxItems: {}
            }
          }
        },
        ListVPCAssociationAuthorizations: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/hostedzone/{Id}/authorizevpcassociation"
          },
          input: {
            type: "structure",
            required: [
              "HostedZoneId"
            ],
            members: {
              HostedZoneId: {
                location: "uri",
                locationName: "Id"
              },
              NextToken: {
                location: "querystring",
                locationName: "nexttoken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxresults"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HostedZoneId",
              "VPCs"
            ],
            members: {
              HostedZoneId: {},
              NextToken: {},
              VPCs: {
                shape: "S5f"
              }
            }
          }
        },
        TestDNSAnswer: {
          http: {
            method: "GET",
            requestUri: "/2013-04-01/testdnsanswer"
          },
          input: {
            type: "structure",
            required: [
              "HostedZoneId",
              "RecordName",
              "RecordType"
            ],
            members: {
              HostedZoneId: {
                location: "querystring",
                locationName: "hostedzoneid"
              },
              RecordName: {
                location: "querystring",
                locationName: "recordname"
              },
              RecordType: {
                location: "querystring",
                locationName: "recordtype"
              },
              ResolverIP: {
                location: "querystring",
                locationName: "resolverip"
              },
              EDNS0ClientSubnetIP: {
                location: "querystring",
                locationName: "edns0clientsubnetip"
              },
              EDNS0ClientSubnetMask: {
                location: "querystring",
                locationName: "edns0clientsubnetmask"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Nameserver",
              "RecordName",
              "RecordType",
              "RecordData",
              "ResponseCode",
              "Protocol"
            ],
            members: {
              Nameserver: {},
              RecordName: {},
              RecordType: {},
              RecordData: {
                type: "list",
                member: {
                  locationName: "RecordDataEntry"
                }
              },
              ResponseCode: {},
              Protocol: {}
            }
          }
        },
        UpdateHealthCheck: {
          http: {
            requestUri: "/2013-04-01/healthcheck/{HealthCheckId}"
          },
          input: {
            locationName: "UpdateHealthCheckRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "HealthCheckId"
            ],
            members: {
              HealthCheckId: {
                location: "uri",
                locationName: "HealthCheckId"
              },
              HealthCheckVersion: {
                type: "long"
              },
              IPAddress: {},
              Port: {
                type: "integer"
              },
              ResourcePath: {},
              FullyQualifiedDomainName: {},
              SearchString: {},
              FailureThreshold: {
                type: "integer"
              },
              Inverted: {
                type: "boolean"
              },
              Disabled: {
                type: "boolean"
              },
              HealthThreshold: {
                type: "integer"
              },
              ChildHealthChecks: {
                shape: "S1t"
              },
              EnableSNI: {
                type: "boolean"
              },
              Regions: {
                shape: "S1v"
              },
              AlarmIdentifier: {
                shape: "S1x"
              },
              InsufficientDataHealthStatus: {},
              ResetElements: {
                type: "list",
                member: {
                  locationName: "ResettableElementName"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HealthCheck"
            ],
            members: {
              HealthCheck: {
                shape: "S23"
              }
            }
          }
        },
        UpdateHostedZoneComment: {
          http: {
            requestUri: "/2013-04-01/hostedzone/{Id}"
          },
          input: {
            locationName: "UpdateHostedZoneCommentRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Comment: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "HostedZone"
            ],
            members: {
              HostedZone: {
                shape: "S2o"
              }
            }
          }
        },
        UpdateTrafficPolicyComment: {
          http: {
            requestUri: "/2013-04-01/trafficpolicy/{Id}/{Version}"
          },
          input: {
            locationName: "UpdateTrafficPolicyCommentRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "Id",
              "Version",
              "Comment"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Version: {
                location: "uri",
                locationName: "Version",
                type: "integer"
              },
              Comment: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicy"
            ],
            members: {
              TrafficPolicy: {
                shape: "S3c"
              }
            }
          }
        },
        UpdateTrafficPolicyInstance: {
          http: {
            requestUri: "/2013-04-01/trafficpolicyinstance/{Id}"
          },
          input: {
            locationName: "UpdateTrafficPolicyInstanceRequest",
            xmlNamespace: {
              uri: "https://route53.amazonaws.com/doc/2013-04-01/"
            },
            type: "structure",
            required: [
              "Id",
              "TTL",
              "TrafficPolicyId",
              "TrafficPolicyVersion"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              TTL: {
                type: "long"
              },
              TrafficPolicyId: {},
              TrafficPolicyVersion: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrafficPolicyInstance"
            ],
            members: {
              TrafficPolicyInstance: {
                shape: "S3h"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          required: [
            "Id",
            "Status",
            "SubmittedAt"
          ],
          members: {
            Id: {},
            Status: {},
            SubmittedAt: {
              type: "timestamp"
            },
            Comment: {}
          }
        },
        Sa: {
          type: "structure",
          members: {
            VPCRegion: {},
            VPCId: {}
          }
        },
        Sk: {
          type: "structure",
          required: [
            "Name",
            "Type"
          ],
          members: {
            Name: {},
            Type: {},
            SetIdentifier: {},
            Weight: {
              type: "long"
            },
            Region: {},
            GeoLocation: {
              type: "structure",
              members: {
                ContinentCode: {},
                CountryCode: {},
                SubdivisionCode: {}
              }
            },
            Failover: {},
            MultiValueAnswer: {
              type: "boolean"
            },
            TTL: {
              type: "long"
            },
            ResourceRecords: {
              type: "list",
              member: {
                locationName: "ResourceRecord",
                type: "structure",
                required: [
                  "Value"
                ],
                members: {
                  Value: {}
                }
              }
            },
            AliasTarget: {
              type: "structure",
              required: [
                "HostedZoneId",
                "DNSName",
                "EvaluateTargetHealth"
              ],
              members: {
                HostedZoneId: {},
                DNSName: {},
                EvaluateTargetHealth: {
                  type: "boolean"
                }
              }
            },
            HealthCheckId: {},
            TrafficPolicyInstanceId: {}
          }
        },
        S18: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S1g: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            IPAddress: {},
            Port: {
              type: "integer"
            },
            Type: {},
            ResourcePath: {},
            FullyQualifiedDomainName: {},
            SearchString: {},
            RequestInterval: {
              type: "integer"
            },
            FailureThreshold: {
              type: "integer"
            },
            MeasureLatency: {
              type: "boolean"
            },
            Inverted: {
              type: "boolean"
            },
            Disabled: {
              type: "boolean"
            },
            HealthThreshold: {
              type: "integer"
            },
            ChildHealthChecks: {
              shape: "S1t"
            },
            EnableSNI: {
              type: "boolean"
            },
            Regions: {
              shape: "S1v"
            },
            AlarmIdentifier: {
              shape: "S1x"
            },
            InsufficientDataHealthStatus: {},
            RoutingControlArn: {}
          }
        },
        S1t: {
          type: "list",
          member: {
            locationName: "ChildHealthCheck"
          }
        },
        S1v: {
          type: "list",
          member: {
            locationName: "Region"
          }
        },
        S1x: {
          type: "structure",
          required: [
            "Region",
            "Name"
          ],
          members: {
            Region: {},
            Name: {}
          }
        },
        S23: {
          type: "structure",
          required: [
            "Id",
            "CallerReference",
            "HealthCheckConfig",
            "HealthCheckVersion"
          ],
          members: {
            Id: {},
            CallerReference: {},
            LinkedService: {
              shape: "S24"
            },
            HealthCheckConfig: {
              shape: "S1g"
            },
            HealthCheckVersion: {
              type: "long"
            },
            CloudWatchAlarmConfiguration: {
              type: "structure",
              required: [
                "EvaluationPeriods",
                "Threshold",
                "ComparisonOperator",
                "Period",
                "MetricName",
                "Namespace",
                "Statistic"
              ],
              members: {
                EvaluationPeriods: {
                  type: "integer"
                },
                Threshold: {
                  type: "double"
                },
                ComparisonOperator: {},
                Period: {
                  type: "integer"
                },
                MetricName: {},
                Namespace: {},
                Statistic: {},
                Dimensions: {
                  type: "list",
                  member: {
                    locationName: "Dimension",
                    type: "structure",
                    required: [
                      "Name",
                      "Value"
                    ],
                    members: {
                      Name: {},
                      Value: {}
                    }
                  }
                }
              }
            }
          }
        },
        S24: {
          type: "structure",
          members: {
            ServicePrincipal: {},
            Description: {}
          }
        },
        S2l: {
          type: "structure",
          members: {
            Comment: {},
            PrivateZone: {
              type: "boolean"
            }
          }
        },
        S2o: {
          type: "structure",
          required: [
            "Id",
            "Name",
            "CallerReference"
          ],
          members: {
            Id: {},
            Name: {},
            CallerReference: {},
            Config: {
              shape: "S2l"
            },
            ResourceRecordSetCount: {
              type: "long"
            },
            LinkedService: {
              shape: "S24"
            }
          }
        },
        S2q: {
          type: "structure",
          required: [
            "NameServers"
          ],
          members: {
            Id: {},
            CallerReference: {},
            NameServers: {
              type: "list",
              member: {
                locationName: "NameServer"
              }
            }
          }
        },
        S2w: {
          type: "structure",
          members: {
            Name: {},
            KmsArn: {},
            Flag: {
              type: "integer"
            },
            SigningAlgorithmMnemonic: {},
            SigningAlgorithmType: {
              type: "integer"
            },
            DigestAlgorithmMnemonic: {},
            DigestAlgorithmType: {
              type: "integer"
            },
            KeyTag: {
              type: "integer"
            },
            DigestValue: {},
            PublicKey: {},
            DSRecord: {},
            DNSKEYRecord: {},
            Status: {},
            StatusMessage: {},
            CreatedDate: {
              type: "timestamp"
            },
            LastModifiedDate: {
              type: "timestamp"
            }
          }
        },
        S33: {
          type: "structure",
          required: [
            "Id",
            "HostedZoneId",
            "CloudWatchLogsLogGroupArn"
          ],
          members: {
            Id: {},
            HostedZoneId: {},
            CloudWatchLogsLogGroupArn: {}
          }
        },
        S3c: {
          type: "structure",
          required: [
            "Id",
            "Version",
            "Name",
            "Type",
            "Document"
          ],
          members: {
            Id: {},
            Version: {
              type: "integer"
            },
            Name: {},
            Type: {},
            Document: {},
            Comment: {}
          }
        },
        S3h: {
          type: "structure",
          required: [
            "Id",
            "HostedZoneId",
            "Name",
            "TTL",
            "State",
            "Message",
            "TrafficPolicyId",
            "TrafficPolicyVersion",
            "TrafficPolicyType"
          ],
          members: {
            Id: {},
            HostedZoneId: {},
            Name: {},
            TTL: {
              type: "long"
            },
            State: {},
            Message: {},
            TrafficPolicyId: {},
            TrafficPolicyVersion: {
              type: "integer"
            },
            TrafficPolicyType: {}
          }
        },
        S4w: {
          type: "structure",
          members: {
            ContinentCode: {},
            ContinentName: {},
            CountryCode: {},
            CountryName: {},
            SubdivisionCode: {},
            SubdivisionName: {}
          }
        },
        S57: {
          type: "list",
          member: {
            locationName: "HealthCheckObservation",
            type: "structure",
            members: {
              Region: {},
              IPAddress: {},
              StatusReport: {
                type: "structure",
                members: {
                  Status: {},
                  CheckedTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        S5f: {
          type: "list",
          member: {
            shape: "Sa",
            locationName: "VPC"
          }
        },
        S6d: {
          type: "list",
          member: {
            shape: "S2o",
            locationName: "HostedZone"
          }
        },
        S70: {
          type: "structure",
          members: {
            ResourceType: {},
            ResourceId: {},
            Tags: {
              shape: "S18"
            }
          }
        },
        S7b: {
          type: "list",
          member: {
            shape: "S3h",
            locationName: "TrafficPolicyInstance"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/route53-2013-04-01.paginators.json
var require_route53_2013_04_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/route53-2013-04-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListHealthChecks: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "NextMarker",
          result_key: "HealthChecks"
        },
        ListHostedZones: {
          input_token: "Marker",
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: "NextMarker",
          result_key: "HostedZones"
        },
        ListQueryLoggingConfigs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "QueryLoggingConfigs"
        },
        ListResourceRecordSets: {
          input_token: [
            "StartRecordName",
            "StartRecordType",
            "StartRecordIdentifier"
          ],
          limit_key: "MaxItems",
          more_results: "IsTruncated",
          output_token: [
            "NextRecordName",
            "NextRecordType",
            "NextRecordIdentifier"
          ],
          result_key: "ResourceRecordSets"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/route53-2013-04-01.waiters2.json
var require_route53_2013_04_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/route53-2013-04-01.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ResourceRecordSetsChanged: {
          delay: 30,
          maxAttempts: 60,
          operation: "GetChange",
          acceptors: [
            {
              matcher: "path",
              expected: "INSYNC",
              argument: "ChangeInfo.Status",
              state: "success"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/route53.js
var require_route532 = __commonJS({
  "node_modules/aws-sdk/clients/route53.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["route53"] = {};
    AWS3.Route53 = Service.defineService("route53", ["2013-04-01"]);
    require_route53();
    Object.defineProperty(apiLoader.services["route53"], "2013-04-01", {
      get: function get() {
        var model = require_route53_2013_04_01_min();
        model.paginators = require_route53_2013_04_01_paginators().pagination;
        model.waiters = require_route53_2013_04_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Route53;
  }
});

// node_modules/aws-sdk/apis/route53domains-2014-05-15.min.json
var require_route53domains_2014_05_15_min = __commonJS({
  "node_modules/aws-sdk/apis/route53domains-2014-05-15.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-05-15",
        endpointPrefix: "route53domains",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Route 53 Domains",
        serviceId: "Route 53 Domains",
        signatureVersion: "v4",
        targetPrefix: "Route53Domains_v20140515",
        uid: "route53domains-2014-05-15"
      },
      operations: {
        AcceptDomainTransferFromAnotherAwsAccount: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Password"
            ],
            members: {
              DomainName: {},
              Password: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        CancelDomainTransferToAnotherAwsAccount: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        CheckDomainAvailability: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              IdnLangCode: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Availability"
            ],
            members: {
              Availability: {}
            }
          }
        },
        CheckDomainTransferability: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              AuthCode: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Transferability"
            ],
            members: {
              Transferability: {
                type: "structure",
                members: {
                  Transferable: {}
                }
              }
            }
          }
        },
        DeleteTagsForDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "TagsToDelete"
            ],
            members: {
              DomainName: {},
              TagsToDelete: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableDomainAutoRenew: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableDomainTransferLock: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "OperationId"
            ],
            members: {
              OperationId: {}
            }
          }
        },
        EnableDomainAutoRenew: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableDomainTransferLock: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "OperationId"
            ],
            members: {
              OperationId: {}
            }
          }
        },
        GetContactReachabilityStatus: {
          input: {
            type: "structure",
            members: {
              domainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              domainName: {},
              status: {}
            }
          }
        },
        GetDomainDetail: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainName",
              "Nameservers",
              "AdminContact",
              "RegistrantContact",
              "TechContact"
            ],
            members: {
              DomainName: {},
              Nameservers: {
                shape: "Sy"
              },
              AutoRenew: {
                type: "boolean"
              },
              AdminContact: {
                shape: "S14"
              },
              RegistrantContact: {
                shape: "S14"
              },
              TechContact: {
                shape: "S14"
              },
              AdminPrivacy: {
                type: "boolean"
              },
              RegistrantPrivacy: {
                type: "boolean"
              },
              TechPrivacy: {
                type: "boolean"
              },
              RegistrarName: {},
              WhoIsServer: {},
              RegistrarUrl: {},
              AbuseContactEmail: {},
              AbuseContactPhone: {},
              RegistryDomainId: {},
              CreationDate: {
                type: "timestamp"
              },
              UpdatedDate: {
                type: "timestamp"
              },
              ExpirationDate: {
                type: "timestamp"
              },
              Reseller: {},
              DnsSec: {},
              StatusList: {
                type: "list",
                member: {}
              }
            }
          }
        },
        GetDomainSuggestions: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "SuggestionCount",
              "OnlyAvailable"
            ],
            members: {
              DomainName: {},
              SuggestionCount: {
                type: "integer"
              },
              OnlyAvailable: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuggestionsList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainName: {},
                    Availability: {}
                  }
                }
              }
            }
          }
        },
        GetOperationDetail: {
          input: {
            type: "structure",
            required: [
              "OperationId"
            ],
            members: {
              OperationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {},
              Status: {},
              Message: {},
              DomainName: {},
              Type: {},
              SubmittedDate: {
                type: "timestamp"
              }
            }
          }
        },
        ListDomains: {
          input: {
            type: "structure",
            members: {
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Domains"
            ],
            members: {
              Domains: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DomainName"
                  ],
                  members: {
                    DomainName: {},
                    AutoRenew: {
                      type: "boolean"
                    },
                    TransferLock: {
                      type: "boolean"
                    },
                    Expiry: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextPageMarker: {}
            }
          }
        },
        ListOperations: {
          input: {
            type: "structure",
            members: {
              SubmittedSince: {
                type: "timestamp"
              },
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Operations"
            ],
            members: {
              Operations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "OperationId",
                    "Status",
                    "Type",
                    "SubmittedDate"
                  ],
                  members: {
                    OperationId: {},
                    Status: {},
                    Type: {},
                    SubmittedDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextPageMarker: {}
            }
          }
        },
        ListTagsForDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TagList"
            ],
            members: {
              TagList: {
                shape: "S2d"
              }
            }
          }
        },
        RegisterDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "DurationInYears",
              "AdminContact",
              "RegistrantContact",
              "TechContact"
            ],
            members: {
              DomainName: {},
              IdnLangCode: {},
              DurationInYears: {
                type: "integer"
              },
              AutoRenew: {
                type: "boolean"
              },
              AdminContact: {
                shape: "S14"
              },
              RegistrantContact: {
                shape: "S14"
              },
              TechContact: {
                shape: "S14"
              },
              PrivacyProtectAdminContact: {
                type: "boolean"
              },
              PrivacyProtectRegistrantContact: {
                type: "boolean"
              },
              PrivacyProtectTechContact: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "OperationId"
            ],
            members: {
              OperationId: {}
            }
          }
        },
        RejectDomainTransferFromAnotherAwsAccount: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        RenewDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "CurrentExpiryYear"
            ],
            members: {
              DomainName: {},
              DurationInYears: {
                type: "integer"
              },
              CurrentExpiryYear: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "OperationId"
            ],
            members: {
              OperationId: {}
            }
          }
        },
        ResendContactReachabilityEmail: {
          input: {
            type: "structure",
            members: {
              domainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              domainName: {},
              emailAddress: {},
              isAlreadyVerified: {
                type: "boolean"
              }
            }
          }
        },
        RetrieveDomainAuthCode: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AuthCode"
            ],
            members: {
              AuthCode: {
                shape: "Sd"
              }
            }
          }
        },
        TransferDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "DurationInYears",
              "AdminContact",
              "RegistrantContact",
              "TechContact"
            ],
            members: {
              DomainName: {},
              IdnLangCode: {},
              DurationInYears: {
                type: "integer"
              },
              Nameservers: {
                shape: "Sy"
              },
              AuthCode: {
                shape: "Sd"
              },
              AutoRenew: {
                type: "boolean"
              },
              AdminContact: {
                shape: "S14"
              },
              RegistrantContact: {
                shape: "S14"
              },
              TechContact: {
                shape: "S14"
              },
              PrivacyProtectAdminContact: {
                type: "boolean"
              },
              PrivacyProtectRegistrantContact: {
                type: "boolean"
              },
              PrivacyProtectTechContact: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "OperationId"
            ],
            members: {
              OperationId: {}
            }
          }
        },
        TransferDomainToAnotherAwsAccount: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "AccountId"
            ],
            members: {
              DomainName: {},
              AccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {},
              Password: {}
            }
          }
        },
        UpdateDomainContact: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              AdminContact: {
                shape: "S14"
              },
              RegistrantContact: {
                shape: "S14"
              },
              TechContact: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "OperationId"
            ],
            members: {
              OperationId: {}
            }
          }
        },
        UpdateDomainContactPrivacy: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              AdminPrivacy: {
                type: "boolean"
              },
              RegistrantPrivacy: {
                type: "boolean"
              },
              TechPrivacy: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "OperationId"
            ],
            members: {
              OperationId: {}
            }
          }
        },
        UpdateDomainNameservers: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Nameservers"
            ],
            members: {
              DomainName: {},
              FIAuthKey: {
                deprecated: true
              },
              Nameservers: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "OperationId"
            ],
            members: {
              OperationId: {}
            }
          }
        },
        UpdateTagsForDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              TagsToUpdate: {
                shape: "S2d"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ViewBilling: {
          input: {
            type: "structure",
            members: {
              Start: {
                type: "timestamp"
              },
              End: {
                type: "timestamp"
              },
              Marker: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextPageMarker: {},
              BillingRecords: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainName: {},
                    Operation: {},
                    InvoiceId: {},
                    BillDate: {
                      type: "timestamp"
                    },
                    Price: {
                      type: "double"
                    }
                  }
                }
              }
            }
          }
        }
      },
      shapes: {
        Sd: {
          type: "string",
          sensitive: true
        },
        Sy: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              GlueIps: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S14: {
          type: "structure",
          members: {
            FirstName: {},
            LastName: {},
            ContactType: {},
            OrganizationName: {},
            AddressLine1: {},
            AddressLine2: {},
            City: {},
            State: {},
            CountryCode: {},
            ZipCode: {},
            PhoneNumber: {},
            Email: {},
            Fax: {},
            ExtraParams: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "Value"
                ],
                members: {
                  Name: {},
                  Value: {}
                }
              }
            }
          },
          sensitive: true
        },
        S2d: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/route53domains-2014-05-15.paginators.json
var require_route53domains_2014_05_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/route53domains-2014-05-15.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListDomains: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextPageMarker",
          result_key: "Domains"
        },
        ListOperations: {
          input_token: "Marker",
          limit_key: "MaxItems",
          output_token: "NextPageMarker",
          result_key: "Operations"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/route53domains.js
var require_route53domains = __commonJS({
  "node_modules/aws-sdk/clients/route53domains.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["route53domains"] = {};
    AWS3.Route53Domains = Service.defineService("route53domains", ["2014-05-15"]);
    Object.defineProperty(apiLoader.services["route53domains"], "2014-05-15", {
      get: function get() {
        var model = require_route53domains_2014_05_15_min();
        model.paginators = require_route53domains_2014_05_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Route53Domains;
  }
});

// node_modules/aws-sdk/lib/services/s3util.js
var require_s3util = __commonJS({
  "node_modules/aws-sdk/lib/services/s3util.js"(exports, module2) {
    var AWS3 = require_core();
    var regionUtil = require_region_config();
    var s3util = {
      isArnInParam: function isArnInParam(req, paramName) {
        var inputShape = (req.service.api.operations[req.operation] || {}).input || {};
        var inputMembers = inputShape.members || {};
        if (!req.params[paramName] || !inputMembers[paramName])
          return false;
        return AWS3.util.ARN.validate(req.params[paramName]);
      },
      validateArnService: function validateArnService(req) {
        var parsedArn = req._parsedArn;
        if (parsedArn.service !== "s3" && parsedArn.service !== "s3-outposts" && parsedArn.service !== "s3-object-lambda") {
          throw AWS3.util.error(new Error(), {
            code: "InvalidARN",
            message: "expect 's3' or 's3-outposts' or 's3-object-lambda' in ARN service component"
          });
        }
      },
      validateArnAccount: function validateArnAccount(req) {
        var parsedArn = req._parsedArn;
        if (!/[0-9]{12}/.exec(parsedArn.accountId)) {
          throw AWS3.util.error(new Error(), {
            code: "InvalidARN",
            message: 'ARN accountID does not match regex "[0-9]{12}"'
          });
        }
      },
      validateS3AccessPointArn: function validateS3AccessPointArn(req) {
        var parsedArn = req._parsedArn;
        var delimiter = parsedArn.resource["accesspoint".length];
        if (parsedArn.resource.split(delimiter).length !== 2) {
          throw AWS3.util.error(new Error(), {
            code: "InvalidARN",
            message: "Access Point ARN should have one resource accesspoint/{accesspointName}"
          });
        }
        var accessPoint = parsedArn.resource.split(delimiter)[1];
        var accessPointPrefix = accessPoint + "-" + parsedArn.accountId;
        if (!s3util.dnsCompatibleBucketName(accessPointPrefix) || accessPointPrefix.match(/\./)) {
          throw AWS3.util.error(new Error(), {
            code: "InvalidARN",
            message: "Access point resource in ARN is not DNS compatible. Got " + accessPoint
          });
        }
        req._parsedArn.accessPoint = accessPoint;
      },
      validateOutpostsArn: function validateOutpostsArn(req) {
        var parsedArn = req._parsedArn;
        if (parsedArn.resource.indexOf("outpost:") !== 0 && parsedArn.resource.indexOf("outpost/") !== 0) {
          throw AWS3.util.error(new Error(), {
            code: "InvalidARN",
            message: "ARN resource should begin with 'outpost/'"
          });
        }
        var delimiter = parsedArn.resource["outpost".length];
        var outpostId = parsedArn.resource.split(delimiter)[1];
        var dnsHostRegex = new RegExp(/^([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9-]{0,61}[a-zA-Z0-9])$/);
        if (!dnsHostRegex.test(outpostId)) {
          throw AWS3.util.error(new Error(), {
            code: "InvalidARN",
            message: "Outpost resource in ARN is not DNS compatible. Got " + outpostId
          });
        }
        req._parsedArn.outpostId = outpostId;
      },
      validateOutpostsAccessPointArn: function validateOutpostsAccessPointArn(req) {
        var parsedArn = req._parsedArn;
        var delimiter = parsedArn.resource["outpost".length];
        if (parsedArn.resource.split(delimiter).length !== 4) {
          throw AWS3.util.error(new Error(), {
            code: "InvalidARN",
            message: "Outposts ARN should have two resources outpost/{outpostId}/accesspoint/{accesspointName}"
          });
        }
        var accessPoint = parsedArn.resource.split(delimiter)[3];
        var accessPointPrefix = accessPoint + "-" + parsedArn.accountId;
        if (!s3util.dnsCompatibleBucketName(accessPointPrefix) || accessPointPrefix.match(/\./)) {
          throw AWS3.util.error(new Error(), {
            code: "InvalidARN",
            message: "Access point resource in ARN is not DNS compatible. Got " + accessPoint
          });
        }
        req._parsedArn.accessPoint = accessPoint;
      },
      validateArnRegion: function validateArnRegion(req) {
        var useArnRegion = s3util.loadUseArnRegionConfig(req);
        var regionFromArn = req._parsedArn.region;
        var clientRegion = req.service.config.region;
        if (!regionFromArn) {
          throw AWS3.util.error(new Error(), {
            code: "InvalidARN",
            message: "ARN region is empty"
          });
        }
        if (clientRegion.indexOf("fips") >= 0 || regionFromArn.indexOf("fips") >= 0) {
          throw AWS3.util.error(new Error(), {
            code: "InvalidConfiguration",
            message: "ARN endpoint is not compatible with FIPS region"
          });
        }
        if (!useArnRegion && regionFromArn !== clientRegion) {
          throw AWS3.util.error(new Error(), {
            code: "InvalidConfiguration",
            message: "Configured region conflicts with access point region"
          });
        } else if (useArnRegion && regionUtil.getEndpointSuffix(regionFromArn) !== regionUtil.getEndpointSuffix(clientRegion)) {
          throw AWS3.util.error(new Error(), {
            code: "InvalidConfiguration",
            message: "Configured region and access point region not in same partition"
          });
        }
        if (req.service.config.useAccelerateEndpoint) {
          throw AWS3.util.error(new Error(), {
            code: "InvalidConfiguration",
            message: "useAccelerateEndpoint config is not supported with access point ARN"
          });
        }
        if (req._parsedArn.service === "s3-outposts" && req.service.config.useDualstack) {
          throw AWS3.util.error(new Error(), {
            code: "InvalidConfiguration",
            message: "useDualstack config is not supported with outposts access point ARN"
          });
        }
      },
      loadUseArnRegionConfig: function loadUseArnRegionConfig(req) {
        var envName = "AWS_S3_USE_ARN_REGION";
        var configName = "s3_use_arn_region";
        var useArnRegion = true;
        var originalConfig = req.service._originalConfig || {};
        if (req.service.config.s3UseArnRegion !== void 0) {
          return req.service.config.s3UseArnRegion;
        } else if (originalConfig.s3UseArnRegion !== void 0) {
          useArnRegion = originalConfig.s3UseArnRegion === true;
        } else if (AWS3.util.isNode()) {
          if (process.env[envName]) {
            var value = process.env[envName].trim().toLowerCase();
            if (["false", "true"].indexOf(value) < 0) {
              throw AWS3.util.error(new Error(), {
                code: "InvalidConfiguration",
                message: envName + " only accepts true or false. Got " + process.env[envName],
                retryable: false
              });
            }
            useArnRegion = value === "true";
          } else {
            var profiles = {};
            var profile = {};
            try {
              profiles = AWS3.util.getProfilesFromSharedConfig(AWS3.util.iniLoader);
              profile = profiles[process.env.AWS_PROFILE || AWS3.util.defaultProfile];
            } catch (e) {
            }
            if (profile[configName]) {
              if (["false", "true"].indexOf(profile[configName].trim().toLowerCase()) < 0) {
                throw AWS3.util.error(new Error(), {
                  code: "InvalidConfiguration",
                  message: configName + " only accepts true or false. Got " + profile[configName],
                  retryable: false
                });
              }
              useArnRegion = profile[configName].trim().toLowerCase() === "true";
            }
          }
        }
        req.service.config.s3UseArnRegion = useArnRegion;
        return useArnRegion;
      },
      validatePopulateUriFromArn: function validatePopulateUriFromArn(req) {
        if (req.service._originalConfig && req.service._originalConfig.endpoint) {
          throw AWS3.util.error(new Error(), {
            code: "InvalidConfiguration",
            message: "Custom endpoint is not compatible with access point ARN"
          });
        }
        if (req.service.config.s3ForcePathStyle) {
          throw AWS3.util.error(new Error(), {
            code: "InvalidConfiguration",
            message: "Cannot construct path-style endpoint with access point"
          });
        }
      },
      dnsCompatibleBucketName: function dnsCompatibleBucketName(bucketName) {
        var b = bucketName;
        var domain = new RegExp(/^[a-z0-9][a-z0-9\.\-]{1,61}[a-z0-9]$/);
        var ipAddress = new RegExp(/(\d+\.){3}\d+/);
        var dots = new RegExp(/\.\./);
        return b.match(domain) && !b.match(ipAddress) && !b.match(dots) ? true : false;
      }
    };
    module2.exports = s3util;
  }
});

// node_modules/aws-sdk/lib/s3/managed_upload.js
var require_managed_upload = __commonJS({
  "node_modules/aws-sdk/lib/s3/managed_upload.js"(exports, module2) {
    var AWS3 = require_core();
    var byteLength = AWS3.util.string.byteLength;
    var Buffer2 = AWS3.util.Buffer;
    AWS3.S3.ManagedUpload = AWS3.util.inherit({
      constructor: function ManagedUpload(options) {
        var self2 = this;
        AWS3.SequentialExecutor.call(self2);
        self2.body = null;
        self2.sliceFn = null;
        self2.callback = null;
        self2.parts = {};
        self2.completeInfo = [];
        self2.fillQueue = function() {
          self2.callback(new Error("Unsupported body payload " + typeof self2.body));
        };
        self2.configure(options);
      },
      configure: function configure(options) {
        options = options || {};
        this.partSize = this.minPartSize;
        if (options.queueSize)
          this.queueSize = options.queueSize;
        if (options.partSize)
          this.partSize = options.partSize;
        if (options.leavePartsOnError)
          this.leavePartsOnError = true;
        if (options.tags) {
          if (!Array.isArray(options.tags)) {
            throw new Error("Tags must be specified as an array; " + typeof options.tags + " provided.");
          }
          this.tags = options.tags;
        }
        if (this.partSize < this.minPartSize) {
          throw new Error("partSize must be greater than " + this.minPartSize);
        }
        this.service = options.service;
        this.bindServiceObject(options.params);
        this.validateBody();
        this.adjustTotalBytes();
      },
      leavePartsOnError: false,
      queueSize: 4,
      partSize: null,
      minPartSize: 1024 * 1024 * 5,
      maxTotalParts: 1e4,
      send: function(callback) {
        var self2 = this;
        self2.failed = false;
        self2.callback = callback || function(err) {
          if (err)
            throw err;
        };
        var runFill = true;
        if (self2.sliceFn) {
          self2.fillQueue = self2.fillBuffer;
        } else if (AWS3.util.isNode()) {
          var Stream = AWS3.util.stream.Stream;
          if (self2.body instanceof Stream) {
            runFill = false;
            self2.fillQueue = self2.fillStream;
            self2.partBuffers = [];
            self2.body.on("error", function(err) {
              self2.cleanup(err);
            }).on("readable", function() {
              self2.fillQueue();
            }).on("end", function() {
              self2.isDoneChunking = true;
              self2.numParts = self2.totalPartNumbers;
              self2.fillQueue.call(self2);
              if (self2.isDoneChunking && self2.totalPartNumbers >= 1 && self2.doneParts === self2.numParts) {
                self2.finishMultiPart();
              }
            });
          }
        }
        if (runFill)
          self2.fillQueue.call(self2);
      },
      abort: function() {
        var self2 = this;
        if (self2.isDoneChunking === true && self2.totalPartNumbers === 1 && self2.singlePart) {
          self2.singlePart.abort();
        } else {
          self2.cleanup(AWS3.util.error(new Error("Request aborted by user"), {
            code: "RequestAbortedError",
            retryable: false
          }));
        }
      },
      validateBody: function validateBody() {
        var self2 = this;
        self2.body = self2.service.config.params.Body;
        if (typeof self2.body === "string") {
          self2.body = AWS3.util.buffer.toBuffer(self2.body);
        } else if (!self2.body) {
          throw new Error("params.Body is required");
        }
        self2.sliceFn = AWS3.util.arraySliceFn(self2.body);
      },
      bindServiceObject: function bindServiceObject(params) {
        params = params || {};
        var self2 = this;
        if (!self2.service) {
          self2.service = new AWS3.S3({ params });
        } else {
          var service = self2.service;
          var config = AWS3.util.copy(service.config);
          config.signatureVersion = service.getSignatureVersion();
          self2.service = new service.constructor.__super__(config);
          self2.service.config.params = AWS3.util.merge(self2.service.config.params || {}, params);
          Object.defineProperty(self2.service, "_originalConfig", {
            get: function() {
              return service._originalConfig;
            },
            enumerable: false,
            configurable: true
          });
        }
      },
      adjustTotalBytes: function adjustTotalBytes() {
        var self2 = this;
        try {
          self2.totalBytes = byteLength(self2.body);
        } catch (e) {
        }
        if (self2.totalBytes) {
          var newPartSize = Math.ceil(self2.totalBytes / self2.maxTotalParts);
          if (newPartSize > self2.partSize)
            self2.partSize = newPartSize;
        } else {
          self2.totalBytes = void 0;
        }
      },
      isDoneChunking: false,
      partPos: 0,
      totalChunkedBytes: 0,
      totalUploadedBytes: 0,
      totalBytes: void 0,
      numParts: 0,
      totalPartNumbers: 0,
      activeParts: 0,
      doneParts: 0,
      parts: null,
      completeInfo: null,
      failed: false,
      multipartReq: null,
      partBuffers: null,
      partBufferLength: 0,
      fillBuffer: function fillBuffer() {
        var self2 = this;
        var bodyLen = byteLength(self2.body);
        if (bodyLen === 0) {
          self2.isDoneChunking = true;
          self2.numParts = 1;
          self2.nextChunk(self2.body);
          return;
        }
        while (self2.activeParts < self2.queueSize && self2.partPos < bodyLen) {
          var endPos = Math.min(self2.partPos + self2.partSize, bodyLen);
          var buf = self2.sliceFn.call(self2.body, self2.partPos, endPos);
          self2.partPos += self2.partSize;
          if (byteLength(buf) < self2.partSize || self2.partPos === bodyLen) {
            self2.isDoneChunking = true;
            self2.numParts = self2.totalPartNumbers + 1;
          }
          self2.nextChunk(buf);
        }
      },
      fillStream: function fillStream() {
        var self2 = this;
        if (self2.activeParts >= self2.queueSize)
          return;
        var buf = self2.body.read(self2.partSize - self2.partBufferLength) || self2.body.read();
        if (buf) {
          self2.partBuffers.push(buf);
          self2.partBufferLength += buf.length;
          self2.totalChunkedBytes += buf.length;
        }
        if (self2.partBufferLength >= self2.partSize) {
          var pbuf = self2.partBuffers.length === 1 ? self2.partBuffers[0] : Buffer2.concat(self2.partBuffers);
          self2.partBuffers = [];
          self2.partBufferLength = 0;
          if (pbuf.length > self2.partSize) {
            var rest = pbuf.slice(self2.partSize);
            self2.partBuffers.push(rest);
            self2.partBufferLength += rest.length;
            pbuf = pbuf.slice(0, self2.partSize);
          }
          self2.nextChunk(pbuf);
        }
        if (self2.isDoneChunking && !self2.isDoneSending) {
          pbuf = self2.partBuffers.length === 1 ? self2.partBuffers[0] : Buffer2.concat(self2.partBuffers);
          self2.partBuffers = [];
          self2.partBufferLength = 0;
          self2.totalBytes = self2.totalChunkedBytes;
          self2.isDoneSending = true;
          if (self2.numParts === 0 || pbuf.length > 0) {
            self2.numParts++;
            self2.nextChunk(pbuf);
          }
        }
        self2.body.read(0);
      },
      nextChunk: function nextChunk(chunk) {
        var self2 = this;
        if (self2.failed)
          return null;
        var partNumber = ++self2.totalPartNumbers;
        if (self2.isDoneChunking && partNumber === 1) {
          var params = { Body: chunk };
          if (this.tags) {
            params.Tagging = this.getTaggingHeader();
          }
          var req = self2.service.putObject(params);
          req._managedUpload = self2;
          req.on("httpUploadProgress", self2.progress).send(self2.finishSinglePart);
          self2.singlePart = req;
          return null;
        } else if (self2.service.config.params.ContentMD5) {
          var err = AWS3.util.error(new Error("The Content-MD5 you specified is invalid for multi-part uploads."), {
            code: "InvalidDigest",
            retryable: false
          });
          self2.cleanup(err);
          return null;
        }
        if (self2.completeInfo[partNumber] && self2.completeInfo[partNumber].ETag !== null) {
          return null;
        }
        self2.activeParts++;
        if (!self2.service.config.params.UploadId) {
          if (!self2.multipartReq) {
            self2.multipartReq = self2.service.createMultipartUpload();
            self2.multipartReq.on("success", function(resp) {
              self2.service.config.params.UploadId = resp.data.UploadId;
              self2.multipartReq = null;
            });
            self2.queueChunks(chunk, partNumber);
            self2.multipartReq.on("error", function(err2) {
              self2.cleanup(err2);
            });
            self2.multipartReq.send();
          } else {
            self2.queueChunks(chunk, partNumber);
          }
        } else {
          self2.uploadPart(chunk, partNumber);
        }
      },
      getTaggingHeader: function getTaggingHeader() {
        var kvPairStrings = [];
        for (var i = 0; i < this.tags.length; i++) {
          kvPairStrings.push(AWS3.util.uriEscape(this.tags[i].Key) + "=" + AWS3.util.uriEscape(this.tags[i].Value));
        }
        return kvPairStrings.join("&");
      },
      uploadPart: function uploadPart(chunk, partNumber) {
        var self2 = this;
        var partParams = {
          Body: chunk,
          ContentLength: AWS3.util.string.byteLength(chunk),
          PartNumber: partNumber
        };
        var partInfo = { ETag: null, PartNumber: partNumber };
        self2.completeInfo[partNumber] = partInfo;
        var req = self2.service.uploadPart(partParams);
        self2.parts[partNumber] = req;
        req._lastUploadedBytes = 0;
        req._managedUpload = self2;
        req.on("httpUploadProgress", self2.progress);
        req.send(function(err, data) {
          delete self2.parts[partParams.PartNumber];
          self2.activeParts--;
          if (!err && (!data || !data.ETag)) {
            var message = "No access to ETag property on response.";
            if (AWS3.util.isBrowser()) {
              message += " Check CORS configuration to expose ETag header.";
            }
            err = AWS3.util.error(new Error(message), {
              code: "ETagMissing",
              retryable: false
            });
          }
          if (err)
            return self2.cleanup(err);
          if (self2.completeInfo[partNumber] && self2.completeInfo[partNumber].ETag !== null)
            return null;
          partInfo.ETag = data.ETag;
          self2.doneParts++;
          if (self2.isDoneChunking && self2.doneParts === self2.numParts) {
            self2.finishMultiPart();
          } else {
            self2.fillQueue.call(self2);
          }
        });
      },
      queueChunks: function queueChunks(chunk, partNumber) {
        var self2 = this;
        self2.multipartReq.on("success", function() {
          self2.uploadPart(chunk, partNumber);
        });
      },
      cleanup: function cleanup(err) {
        var self2 = this;
        if (self2.failed)
          return;
        if (typeof self2.body.removeAllListeners === "function" && typeof self2.body.resume === "function") {
          self2.body.removeAllListeners("readable");
          self2.body.removeAllListeners("end");
          self2.body.resume();
        }
        if (self2.multipartReq) {
          self2.multipartReq.removeAllListeners("success");
          self2.multipartReq.removeAllListeners("error");
          self2.multipartReq.removeAllListeners("complete");
          delete self2.multipartReq;
        }
        if (self2.service.config.params.UploadId && !self2.leavePartsOnError) {
          self2.service.abortMultipartUpload().send();
        } else if (self2.leavePartsOnError) {
          self2.isDoneChunking = false;
        }
        AWS3.util.each(self2.parts, function(partNumber, part) {
          part.removeAllListeners("complete");
          part.abort();
        });
        self2.activeParts = 0;
        self2.partPos = 0;
        self2.numParts = 0;
        self2.totalPartNumbers = 0;
        self2.parts = {};
        self2.failed = true;
        self2.callback(err);
      },
      finishMultiPart: function finishMultiPart() {
        var self2 = this;
        var completeParams = { MultipartUpload: { Parts: self2.completeInfo.slice(1) } };
        self2.service.completeMultipartUpload(completeParams, function(err, data) {
          if (err) {
            return self2.cleanup(err);
          }
          if (data && typeof data.Location === "string") {
            data.Location = data.Location.replace(/%2F/g, "/");
          }
          if (Array.isArray(self2.tags)) {
            for (var i = 0; i < self2.tags.length; i++) {
              self2.tags[i].Value = String(self2.tags[i].Value);
            }
            self2.service.putObjectTagging({ Tagging: { TagSet: self2.tags } }, function(e, d) {
              if (e) {
                self2.callback(e);
              } else {
                self2.callback(e, data);
              }
            });
          } else {
            self2.callback(err, data);
          }
        });
      },
      finishSinglePart: function finishSinglePart(err, data) {
        var upload = this.request._managedUpload;
        var httpReq = this.request.httpRequest;
        var endpoint = httpReq.endpoint;
        if (err)
          return upload.callback(err);
        data.Location = [endpoint.protocol, "//", endpoint.host, httpReq.path].join("");
        data.key = this.request.params.Key;
        data.Key = this.request.params.Key;
        data.Bucket = this.request.params.Bucket;
        upload.callback(err, data);
      },
      progress: function progress(info) {
        var upload = this._managedUpload;
        if (this.operation === "putObject") {
          info.part = 1;
          info.key = this.params.Key;
        } else {
          upload.totalUploadedBytes += info.loaded - this._lastUploadedBytes;
          this._lastUploadedBytes = info.loaded;
          info = {
            loaded: upload.totalUploadedBytes,
            total: upload.totalBytes,
            part: this.params.PartNumber,
            key: this.params.Key
          };
        }
        upload.emit("httpUploadProgress", [info]);
      }
    });
    AWS3.util.mixin(AWS3.S3.ManagedUpload, AWS3.SequentialExecutor);
    AWS3.S3.ManagedUpload.addPromisesToClass = function addPromisesToClass(PromiseDependency) {
      this.prototype.promise = AWS3.util.promisifyMethod("send", PromiseDependency);
    };
    AWS3.S3.ManagedUpload.deletePromisesFromClass = function deletePromisesFromClass() {
      delete this.prototype.promise;
    };
    AWS3.util.addPromises(AWS3.S3.ManagedUpload);
    module2.exports = AWS3.S3.ManagedUpload;
  }
});

// node_modules/aws-sdk/lib/services/s3.js
var require_s32 = __commonJS({
  "node_modules/aws-sdk/lib/services/s3.js"() {
    var AWS3 = require_core();
    var v4Credentials = require_v4_credentials();
    var resolveRegionalEndpointsFlag = require_config_regional_endpoint();
    var s3util = require_s3util();
    var regionUtil = require_region_config();
    require_managed_upload();
    var operationsWith200StatusCodeError = {
      "completeMultipartUpload": true,
      "copyObject": true,
      "uploadPartCopy": true
    };
    var regionRedirectErrorCodes = [
      "AuthorizationHeaderMalformed",
      "BadRequest",
      "PermanentRedirect",
      301
    ];
    var OBJECT_LAMBDA_SERVICE = "s3-object-lambda";
    AWS3.util.update(AWS3.S3.prototype, {
      getSignatureVersion: function getSignatureVersion(request) {
        var defaultApiVersion = this.api.signatureVersion;
        var userDefinedVersion = this._originalConfig ? this._originalConfig.signatureVersion : null;
        var regionDefinedVersion = this.config.signatureVersion;
        var isPresigned = request ? request.isPresigned() : false;
        if (userDefinedVersion) {
          userDefinedVersion = userDefinedVersion === "v2" ? "s3" : userDefinedVersion;
          return userDefinedVersion;
        }
        if (isPresigned !== true) {
          defaultApiVersion = "v4";
        } else if (regionDefinedVersion) {
          defaultApiVersion = regionDefinedVersion;
        }
        return defaultApiVersion;
      },
      getSigningName: function getSigningName(req) {
        if (req && req.operation === "writeGetObjectResponse") {
          return OBJECT_LAMBDA_SERVICE;
        }
        var _super = AWS3.Service.prototype.getSigningName;
        return req && req._parsedArn && req._parsedArn.service ? req._parsedArn.service : _super.call(this);
      },
      getSignerClass: function getSignerClass(request) {
        var signatureVersion = this.getSignatureVersion(request);
        return AWS3.Signers.RequestSigner.getVersion(signatureVersion);
      },
      validateService: function validateService() {
        var msg;
        var messages = [];
        if (!this.config.region)
          this.config.region = "us-east-1";
        if (!this.config.endpoint && this.config.s3BucketEndpoint) {
          messages.push("An endpoint must be provided when configuring `s3BucketEndpoint` to true.");
        }
        if (messages.length === 1) {
          msg = messages[0];
        } else if (messages.length > 1) {
          msg = "Multiple configuration errors:\n" + messages.join("\n");
        }
        if (msg) {
          throw AWS3.util.error(new Error(), { name: "InvalidEndpoint", message: msg });
        }
      },
      shouldDisableBodySigning: function shouldDisableBodySigning(request) {
        var signerClass = this.getSignerClass();
        if (this.config.s3DisableBodySigning === true && signerClass === AWS3.Signers.V4 && request.httpRequest.endpoint.protocol === "https:") {
          return true;
        }
        return false;
      },
      setupRequestListeners: function setupRequestListeners(request) {
        var prependListener = true;
        request.addListener("validate", this.validateScheme);
        request.addListener("validate", this.validateBucketName, prependListener);
        request.addListener("validate", this.optInUsEast1RegionalEndpoint, prependListener);
        request.removeListener("validate", AWS3.EventListeners.Core.VALIDATE_REGION);
        request.addListener("build", this.addContentType);
        request.addListener("build", this.computeContentMd5);
        request.addListener("build", this.computeSseCustomerKeyMd5);
        request.addListener("build", this.populateURI);
        request.addListener("afterBuild", this.addExpect100Continue);
        request.addListener("extractError", this.extractError);
        request.addListener("extractData", AWS3.util.hoistPayloadMember);
        request.addListener("extractData", this.extractData);
        request.addListener("extractData", this.extractErrorFrom200Response);
        request.addListener("beforePresign", this.prepareSignedUrl);
        if (this.shouldDisableBodySigning(request)) {
          request.removeListener("afterBuild", AWS3.EventListeners.Core.COMPUTE_SHA256);
          request.addListener("afterBuild", this.disableBodySigning);
        }
        if (request.operation !== "createBucket" && s3util.isArnInParam(request, "Bucket")) {
          request._parsedArn = AWS3.util.ARN.parse(request.params.Bucket);
          request.removeListener("validate", this.validateBucketName);
          request.removeListener("build", this.populateURI);
          if (request._parsedArn.service === "s3") {
            request.addListener("validate", s3util.validateS3AccessPointArn);
            request.addListener("validate", this.validateArnResourceType);
          } else if (request._parsedArn.service === "s3-outposts") {
            request.addListener("validate", s3util.validateOutpostsAccessPointArn);
            request.addListener("validate", s3util.validateOutpostsArn);
          }
          request.addListener("validate", s3util.validateArnRegion);
          request.addListener("validate", s3util.validateArnAccount);
          request.addListener("validate", s3util.validateArnService);
          request.addListener("build", this.populateUriFromAccessPointArn);
          request.addListener("build", s3util.validatePopulateUriFromArn);
          return;
        }
        request.addListener("validate", this.validateBucketEndpoint);
        request.addListener("validate", this.correctBucketRegionFromCache);
        request.onAsync("extractError", this.requestBucketRegion);
        if (AWS3.util.isBrowser()) {
          request.onAsync("retry", this.reqRegionForNetworkingError);
        }
      },
      validateScheme: function(req) {
        var params = req.params, scheme = req.httpRequest.endpoint.protocol, sensitive = params.SSECustomerKey || params.CopySourceSSECustomerKey;
        if (sensitive && scheme !== "https:") {
          var msg = "Cannot send SSE keys over HTTP. Set 'sslEnabled'to 'true' in your configuration";
          throw AWS3.util.error(new Error(), { code: "ConfigError", message: msg });
        }
      },
      validateBucketEndpoint: function(req) {
        if (!req.params.Bucket && req.service.config.s3BucketEndpoint) {
          var msg = "Cannot send requests to root API with `s3BucketEndpoint` set.";
          throw AWS3.util.error(new Error(), { code: "ConfigError", message: msg });
        }
      },
      validateArnResourceType: function validateArnResourceType(req) {
        var resource = req._parsedArn.resource;
        if (resource.indexOf("accesspoint:") !== 0 && resource.indexOf("accesspoint/") !== 0) {
          throw AWS3.util.error(new Error(), {
            code: "InvalidARN",
            message: "ARN resource should begin with 'accesspoint/'"
          });
        }
      },
      validateBucketName: function validateBucketName(req) {
        var service = req.service;
        var signatureVersion = service.getSignatureVersion(req);
        var bucket = req.params && req.params.Bucket;
        var key = req.params && req.params.Key;
        var slashIndex = bucket && bucket.indexOf("/");
        if (bucket && slashIndex >= 0) {
          if (typeof key === "string" && slashIndex > 0) {
            req.params = AWS3.util.copy(req.params);
            var prefix = bucket.substr(slashIndex + 1) || "";
            req.params.Key = prefix + "/" + key;
            req.params.Bucket = bucket.substr(0, slashIndex);
          } else if (signatureVersion === "v4") {
            var msg = "Bucket names cannot contain forward slashes. Bucket: " + bucket;
            throw AWS3.util.error(new Error(), { code: "InvalidBucket", message: msg });
          }
        }
      },
      isValidAccelerateOperation: function isValidAccelerateOperation(operation) {
        var invalidOperations = [
          "createBucket",
          "deleteBucket",
          "listBuckets"
        ];
        return invalidOperations.indexOf(operation) === -1;
      },
      optInUsEast1RegionalEndpoint: function optInUsEast1RegionalEndpoint(req) {
        var service = req.service;
        var config = service.config;
        config.s3UsEast1RegionalEndpoint = resolveRegionalEndpointsFlag(service._originalConfig, {
          env: "AWS_S3_US_EAST_1_REGIONAL_ENDPOINT",
          sharedConfig: "s3_us_east_1_regional_endpoint",
          clientConfig: "s3UsEast1RegionalEndpoint"
        });
        if (!(service._originalConfig || {}).endpoint && req.httpRequest.region === "us-east-1" && config.s3UsEast1RegionalEndpoint === "regional" && req.httpRequest.endpoint.hostname.indexOf("s3.amazonaws.com") >= 0) {
          var insertPoint = config.endpoint.indexOf(".amazonaws.com");
          regionalEndpoint = config.endpoint.substring(0, insertPoint) + ".us-east-1" + config.endpoint.substring(insertPoint);
          req.httpRequest.updateEndpoint(regionalEndpoint);
        }
      },
      populateURI: function populateURI(req) {
        var httpRequest = req.httpRequest;
        var b = req.params.Bucket;
        var service = req.service;
        var endpoint = httpRequest.endpoint;
        if (b) {
          if (!service.pathStyleBucketName(b)) {
            if (service.config.useAccelerateEndpoint && service.isValidAccelerateOperation(req.operation)) {
              if (service.config.useDualstack) {
                endpoint.hostname = b + ".s3-accelerate.dualstack.amazonaws.com";
              } else {
                endpoint.hostname = b + ".s3-accelerate.amazonaws.com";
              }
            } else if (!service.config.s3BucketEndpoint) {
              endpoint.hostname = b + "." + endpoint.hostname;
            }
            var port = endpoint.port;
            if (port !== 80 && port !== 443) {
              endpoint.host = endpoint.hostname + ":" + endpoint.port;
            } else {
              endpoint.host = endpoint.hostname;
            }
            httpRequest.virtualHostedBucket = b;
            service.removeVirtualHostedBucketFromPath(req);
          }
        }
      },
      removeVirtualHostedBucketFromPath: function removeVirtualHostedBucketFromPath(req) {
        var httpRequest = req.httpRequest;
        var bucket = httpRequest.virtualHostedBucket;
        if (bucket && httpRequest.path) {
          if (req.params && req.params.Key) {
            var encodedS3Key = "/" + AWS3.util.uriEscapePath(req.params.Key);
            if (httpRequest.path.indexOf(encodedS3Key) === 0 && (httpRequest.path.length === encodedS3Key.length || httpRequest.path[encodedS3Key.length] === "?")) {
              return;
            }
          }
          httpRequest.path = httpRequest.path.replace(new RegExp("/" + bucket), "");
          if (httpRequest.path[0] !== "/") {
            httpRequest.path = "/" + httpRequest.path;
          }
        }
      },
      populateUriFromAccessPointArn: function populateUriFromAccessPointArn(req) {
        var accessPointArn = req._parsedArn;
        var isOutpostArn = accessPointArn.service === "s3-outposts";
        var isObjectLambdaArn = accessPointArn.service === "s3-object-lambda";
        var outpostsSuffix = isOutpostArn ? "." + accessPointArn.outpostId : "";
        var serviceName = isOutpostArn ? "s3-outposts" : "s3-accesspoint";
        var dualStackSuffix = !isOutpostArn && req.service.config.useDualstack ? ".dualstack" : "";
        var endpoint = req.httpRequest.endpoint;
        var dnsSuffix = regionUtil.getEndpointSuffix(accessPointArn.region);
        var useArnRegion = req.service.config.s3UseArnRegion;
        endpoint.hostname = [
          accessPointArn.accessPoint + "-" + accessPointArn.accountId + outpostsSuffix,
          serviceName + dualStackSuffix,
          useArnRegion ? accessPointArn.region : req.service.config.region,
          dnsSuffix
        ].join(".");
        if (isObjectLambdaArn) {
          var serviceName = "s3-object-lambda";
          var accesspointName = accessPointArn.resource.split("/")[1];
          endpoint.hostname = [
            accesspointName + "-" + accessPointArn.accountId,
            serviceName,
            useArnRegion ? accessPointArn.region : req.service.config.region,
            dnsSuffix
          ].join(".");
        }
        endpoint.host = endpoint.hostname;
        var encodedArn = AWS3.util.uriEscape(req.params.Bucket);
        var path2 = req.httpRequest.path;
        req.httpRequest.path = path2.replace(new RegExp("/" + encodedArn), "");
        if (req.httpRequest.path[0] !== "/") {
          req.httpRequest.path = "/" + req.httpRequest.path;
        }
        req.httpRequest.region = accessPointArn.region;
      },
      addExpect100Continue: function addExpect100Continue(req) {
        var len = req.httpRequest.headers["Content-Length"];
        if (AWS3.util.isNode() && (len >= 1024 * 1024 || req.params.Body instanceof AWS3.util.stream.Stream)) {
          req.httpRequest.headers["Expect"] = "100-continue";
        }
      },
      addContentType: function addContentType(req) {
        var httpRequest = req.httpRequest;
        if (httpRequest.method === "GET" || httpRequest.method === "HEAD") {
          delete httpRequest.headers["Content-Type"];
          return;
        }
        if (!httpRequest.headers["Content-Type"]) {
          httpRequest.headers["Content-Type"] = "application/octet-stream";
        }
        var contentType = httpRequest.headers["Content-Type"];
        if (AWS3.util.isBrowser()) {
          if (typeof httpRequest.body === "string" && !contentType.match(/;\s*charset=/)) {
            var charset = "; charset=UTF-8";
            httpRequest.headers["Content-Type"] += charset;
          } else {
            var replaceFn = function(_, prefix, charsetName) {
              return prefix + charsetName.toUpperCase();
            };
            httpRequest.headers["Content-Type"] = contentType.replace(/(;\s*charset=)(.+)$/, replaceFn);
          }
        }
      },
      willComputeChecksums: function willComputeChecksums(req) {
        var rules = req.service.api.operations[req.operation].input.members;
        var body = req.httpRequest.body;
        var needsContentMD5 = rules.ContentMD5 && !req.params.ContentMD5 && body && (AWS3.util.Buffer.isBuffer(req.httpRequest.body) || typeof req.httpRequest.body === "string");
        if (needsContentMD5 && req.service.shouldDisableBodySigning(req) && !req.isPresigned()) {
          return true;
        }
        if (needsContentMD5 && this.getSignatureVersion(req) === "s3" && req.isPresigned()) {
          return true;
        }
        return false;
      },
      computeContentMd5: function computeContentMd5(req) {
        if (req.service.willComputeChecksums(req)) {
          var md5 = AWS3.util.crypto.md5(req.httpRequest.body, "base64");
          req.httpRequest.headers["Content-MD5"] = md5;
        }
      },
      computeSseCustomerKeyMd5: function computeSseCustomerKeyMd5(req) {
        var keys = {
          SSECustomerKey: "x-amz-server-side-encryption-customer-key-MD5",
          CopySourceSSECustomerKey: "x-amz-copy-source-server-side-encryption-customer-key-MD5"
        };
        AWS3.util.each(keys, function(key, header) {
          if (req.params[key]) {
            var value = AWS3.util.crypto.md5(req.params[key], "base64");
            req.httpRequest.headers[header] = value;
          }
        });
      },
      pathStyleBucketName: function pathStyleBucketName(bucketName) {
        if (this.config.s3ForcePathStyle)
          return true;
        if (this.config.s3BucketEndpoint)
          return false;
        if (s3util.dnsCompatibleBucketName(bucketName)) {
          return this.config.sslEnabled && bucketName.match(/\./) ? true : false;
        } else {
          return true;
        }
      },
      extractErrorFrom200Response: function extractErrorFrom200Response(resp) {
        if (!operationsWith200StatusCodeError[resp.request.operation])
          return;
        var httpResponse = resp.httpResponse;
        if (httpResponse.body && httpResponse.body.toString().match("<Error>")) {
          resp.data = null;
          var service = this.service ? this.service : this;
          service.extractError(resp);
          throw resp.error;
        } else if (!httpResponse.body || !httpResponse.body.toString().match(/<[\w_]/)) {
          resp.data = null;
          throw AWS3.util.error(new Error(), {
            code: "InternalError",
            message: "S3 aborted request"
          });
        }
      },
      retryableError: function retryableError(error, request) {
        if (operationsWith200StatusCodeError[request.operation] && error.statusCode === 200) {
          return true;
        } else if (request._requestRegionForBucket && request.service.bucketRegionCache[request._requestRegionForBucket]) {
          return false;
        } else if (error && error.code === "RequestTimeout") {
          return true;
        } else if (error && regionRedirectErrorCodes.indexOf(error.code) != -1 && error.region && error.region != request.httpRequest.region) {
          request.httpRequest.region = error.region;
          if (error.statusCode === 301) {
            request.service.updateReqBucketRegion(request);
          }
          return true;
        } else {
          var _super = AWS3.Service.prototype.retryableError;
          return _super.call(this, error, request);
        }
      },
      updateReqBucketRegion: function updateReqBucketRegion(request, region) {
        var httpRequest = request.httpRequest;
        if (typeof region === "string" && region.length) {
          httpRequest.region = region;
        }
        if (!httpRequest.endpoint.host.match(/s3(?!-accelerate).*\.amazonaws\.com$/)) {
          return;
        }
        var service = request.service;
        var s3Config = service.config;
        var s3BucketEndpoint = s3Config.s3BucketEndpoint;
        if (s3BucketEndpoint) {
          delete s3Config.s3BucketEndpoint;
        }
        var newConfig = AWS3.util.copy(s3Config);
        delete newConfig.endpoint;
        newConfig.region = httpRequest.region;
        httpRequest.endpoint = new AWS3.S3(newConfig).endpoint;
        service.populateURI(request);
        s3Config.s3BucketEndpoint = s3BucketEndpoint;
        httpRequest.headers.Host = httpRequest.endpoint.host;
        if (request._asm.currentState === "validate") {
          request.removeListener("build", service.populateURI);
          request.addListener("build", service.removeVirtualHostedBucketFromPath);
        }
      },
      extractData: function extractData(resp) {
        var req = resp.request;
        if (req.operation === "getBucketLocation") {
          var match = resp.httpResponse.body.toString().match(/>(.+)<\/Location/);
          delete resp.data["_"];
          if (match) {
            resp.data.LocationConstraint = match[1];
          } else {
            resp.data.LocationConstraint = "";
          }
        }
        var bucket = req.params.Bucket || null;
        if (req.operation === "deleteBucket" && typeof bucket === "string" && !resp.error) {
          req.service.clearBucketRegionCache(bucket);
        } else {
          var headers = resp.httpResponse.headers || {};
          var region = headers["x-amz-bucket-region"] || null;
          if (!region && req.operation === "createBucket" && !resp.error) {
            var createBucketConfiguration = req.params.CreateBucketConfiguration;
            if (!createBucketConfiguration) {
              region = "us-east-1";
            } else if (createBucketConfiguration.LocationConstraint === "EU") {
              region = "eu-west-1";
            } else {
              region = createBucketConfiguration.LocationConstraint;
            }
          }
          if (region) {
            if (bucket && region !== req.service.bucketRegionCache[bucket]) {
              req.service.bucketRegionCache[bucket] = region;
            }
          }
        }
        req.service.extractRequestIds(resp);
      },
      extractError: function extractError(resp) {
        var codes = {
          304: "NotModified",
          403: "Forbidden",
          400: "BadRequest",
          404: "NotFound"
        };
        var req = resp.request;
        var code = resp.httpResponse.statusCode;
        var body = resp.httpResponse.body || "";
        var headers = resp.httpResponse.headers || {};
        var region = headers["x-amz-bucket-region"] || null;
        var bucket = req.params.Bucket || null;
        var bucketRegionCache = req.service.bucketRegionCache;
        if (region && bucket && region !== bucketRegionCache[bucket]) {
          bucketRegionCache[bucket] = region;
        }
        var cachedRegion;
        if (codes[code] && body.length === 0) {
          if (bucket && !region) {
            cachedRegion = bucketRegionCache[bucket] || null;
            if (cachedRegion !== req.httpRequest.region) {
              region = cachedRegion;
            }
          }
          resp.error = AWS3.util.error(new Error(), {
            code: codes[code],
            message: null,
            region
          });
        } else {
          var data = new AWS3.XML.Parser().parse(body.toString());
          if (data.Region && !region) {
            region = data.Region;
            if (bucket && region !== bucketRegionCache[bucket]) {
              bucketRegionCache[bucket] = region;
            }
          } else if (bucket && !region && !data.Region) {
            cachedRegion = bucketRegionCache[bucket] || null;
            if (cachedRegion !== req.httpRequest.region) {
              region = cachedRegion;
            }
          }
          resp.error = AWS3.util.error(new Error(), {
            code: data.Code || code,
            message: data.Message || null,
            region
          });
        }
        req.service.extractRequestIds(resp);
      },
      requestBucketRegion: function requestBucketRegion(resp, done) {
        var error = resp.error;
        var req = resp.request;
        var bucket = req.params.Bucket || null;
        if (!error || !bucket || error.region || req.operation === "listObjects" || AWS3.util.isNode() && req.operation === "headBucket" || error.statusCode === 400 && req.operation !== "headObject" || regionRedirectErrorCodes.indexOf(error.code) === -1) {
          return done();
        }
        var reqOperation = AWS3.util.isNode() ? "headBucket" : "listObjects";
        var reqParams = { Bucket: bucket };
        if (reqOperation === "listObjects")
          reqParams.MaxKeys = 0;
        var regionReq = req.service[reqOperation](reqParams);
        regionReq._requestRegionForBucket = bucket;
        regionReq.send(function() {
          var region = req.service.bucketRegionCache[bucket] || null;
          error.region = region;
          done();
        });
      },
      reqRegionForNetworkingError: function reqRegionForNetworkingError(resp, done) {
        if (!AWS3.util.isBrowser()) {
          return done();
        }
        var error = resp.error;
        var request = resp.request;
        var bucket = request.params.Bucket;
        if (!error || error.code !== "NetworkingError" || !bucket || request.httpRequest.region === "us-east-1") {
          return done();
        }
        var service = request.service;
        var bucketRegionCache = service.bucketRegionCache;
        var cachedRegion = bucketRegionCache[bucket] || null;
        if (cachedRegion && cachedRegion !== request.httpRequest.region) {
          service.updateReqBucketRegion(request, cachedRegion);
          done();
        } else if (!s3util.dnsCompatibleBucketName(bucket)) {
          service.updateReqBucketRegion(request, "us-east-1");
          if (bucketRegionCache[bucket] !== "us-east-1") {
            bucketRegionCache[bucket] = "us-east-1";
          }
          done();
        } else if (request.httpRequest.virtualHostedBucket) {
          var getRegionReq = service.listObjects({ Bucket: bucket, MaxKeys: 0 });
          service.updateReqBucketRegion(getRegionReq, "us-east-1");
          getRegionReq._requestRegionForBucket = bucket;
          getRegionReq.send(function() {
            var region = service.bucketRegionCache[bucket] || null;
            if (region && region !== request.httpRequest.region) {
              service.updateReqBucketRegion(request, region);
            }
            done();
          });
        } else {
          done();
        }
      },
      bucketRegionCache: {},
      clearBucketRegionCache: function(buckets) {
        var bucketRegionCache = this.bucketRegionCache;
        if (!buckets) {
          buckets = Object.keys(bucketRegionCache);
        } else if (typeof buckets === "string") {
          buckets = [buckets];
        }
        for (var i = 0; i < buckets.length; i++) {
          delete bucketRegionCache[buckets[i]];
        }
        return bucketRegionCache;
      },
      correctBucketRegionFromCache: function correctBucketRegionFromCache(req) {
        var bucket = req.params.Bucket || null;
        if (bucket) {
          var service = req.service;
          var requestRegion = req.httpRequest.region;
          var cachedRegion = service.bucketRegionCache[bucket];
          if (cachedRegion && cachedRegion !== requestRegion) {
            service.updateReqBucketRegion(req, cachedRegion);
          }
        }
      },
      extractRequestIds: function extractRequestIds(resp) {
        var extendedRequestId = resp.httpResponse.headers ? resp.httpResponse.headers["x-amz-id-2"] : null;
        var cfId = resp.httpResponse.headers ? resp.httpResponse.headers["x-amz-cf-id"] : null;
        resp.extendedRequestId = extendedRequestId;
        resp.cfId = cfId;
        if (resp.error) {
          resp.error.requestId = resp.requestId || null;
          resp.error.extendedRequestId = extendedRequestId;
          resp.error.cfId = cfId;
        }
      },
      getSignedUrl: function getSignedUrl(operation, params, callback) {
        params = AWS3.util.copy(params || {});
        var expires = params.Expires || 900;
        if (typeof expires !== "number") {
          throw AWS3.util.error(new Error(), { code: "InvalidParameterException", message: "The expiration must be a number, received " + typeof expires });
        }
        delete params.Expires;
        var request = this.makeRequest(operation, params);
        if (callback) {
          AWS3.util.defer(function() {
            request.presign(expires, callback);
          });
        } else {
          return request.presign(expires, callback);
        }
      },
      createPresignedPost: function createPresignedPost(params, callback) {
        if (typeof params === "function" && callback === void 0) {
          callback = params;
          params = null;
        }
        params = AWS3.util.copy(params || {});
        var boundParams = this.config.params || {};
        var bucket = params.Bucket || boundParams.Bucket, self2 = this, config = this.config, endpoint = AWS3.util.copy(this.endpoint);
        if (!config.s3BucketEndpoint) {
          endpoint.pathname = "/" + bucket;
        }
        function finalizePost() {
          return {
            url: AWS3.util.urlFormat(endpoint),
            fields: self2.preparePostFields(config.credentials, config.region, bucket, params.Fields, params.Conditions, params.Expires)
          };
        }
        if (callback) {
          config.getCredentials(function(err) {
            if (err) {
              callback(err);
            } else {
              try {
                callback(null, finalizePost());
              } catch (err2) {
                callback(err2);
              }
            }
          });
        } else {
          return finalizePost();
        }
      },
      preparePostFields: function preparePostFields(credentials, region, bucket, fields, conditions, expiresInSeconds) {
        var now = this.getSkewCorrectedDate();
        if (!credentials || !region || !bucket) {
          throw new Error("Unable to create a POST object policy without a bucket, region, and credentials");
        }
        fields = AWS3.util.copy(fields || {});
        conditions = (conditions || []).slice(0);
        expiresInSeconds = expiresInSeconds || 3600;
        var signingDate = AWS3.util.date.iso8601(now).replace(/[:\-]|\.\d{3}/g, "");
        var shortDate = signingDate.substr(0, 8);
        var scope = v4Credentials.createScope(shortDate, region, "s3");
        var credential = credentials.accessKeyId + "/" + scope;
        fields["bucket"] = bucket;
        fields["X-Amz-Algorithm"] = "AWS4-HMAC-SHA256";
        fields["X-Amz-Credential"] = credential;
        fields["X-Amz-Date"] = signingDate;
        if (credentials.sessionToken) {
          fields["X-Amz-Security-Token"] = credentials.sessionToken;
        }
        for (var field in fields) {
          if (fields.hasOwnProperty(field)) {
            var condition = {};
            condition[field] = fields[field];
            conditions.push(condition);
          }
        }
        fields.Policy = this.preparePostPolicy(new Date(now.valueOf() + expiresInSeconds * 1e3), conditions);
        fields["X-Amz-Signature"] = AWS3.util.crypto.hmac(v4Credentials.getSigningKey(credentials, shortDate, region, "s3", true), fields.Policy, "hex");
        return fields;
      },
      preparePostPolicy: function preparePostPolicy(expiration, conditions) {
        return AWS3.util.base64.encode(JSON.stringify({
          expiration: AWS3.util.date.iso8601(expiration),
          conditions
        }));
      },
      prepareSignedUrl: function prepareSignedUrl(request) {
        request.addListener("validate", request.service.noPresignedContentLength);
        request.removeListener("build", request.service.addContentType);
        if (!request.params.Body) {
          request.removeListener("build", request.service.computeContentMd5);
        } else {
          request.addListener("afterBuild", AWS3.EventListeners.Core.COMPUTE_SHA256);
        }
      },
      disableBodySigning: function disableBodySigning(request) {
        var headers = request.httpRequest.headers;
        if (!Object.prototype.hasOwnProperty.call(headers, "presigned-expires")) {
          headers["X-Amz-Content-Sha256"] = "UNSIGNED-PAYLOAD";
        }
      },
      noPresignedContentLength: function noPresignedContentLength(request) {
        if (request.params.ContentLength !== void 0) {
          throw AWS3.util.error(new Error(), {
            code: "UnexpectedParameter",
            message: "ContentLength is not supported in pre-signed URLs."
          });
        }
      },
      createBucket: function createBucket(params, callback) {
        if (typeof params === "function" || !params) {
          callback = callback || params;
          params = {};
        }
        var hostname = this.endpoint.hostname;
        var copiedParams = AWS3.util.copy(params);
        if (hostname !== this.api.globalEndpoint && !params.CreateBucketConfiguration) {
          copiedParams.CreateBucketConfiguration = { LocationConstraint: this.config.region };
        }
        return this.makeRequest("createBucket", copiedParams, callback);
      },
      writeGetObjectResponse: function writeGetObjectResponse(params, callback) {
        var request = this.makeRequest("writeGetObjectResponse", AWS3.util.copy(params), callback);
        var hostname = this.endpoint.hostname;
        if (hostname.indexOf(this.config.region) !== -1) {
          hostname = hostname.replace("s3.", OBJECT_LAMBDA_SERVICE + ".");
        } else {
          hostname = hostname.replace("s3.", OBJECT_LAMBDA_SERVICE + "." + this.config.region + ".");
        }
        request.httpRequest.endpoint = new AWS3.Endpoint(hostname, this.config);
        return request;
      },
      upload: function upload(params, options, callback) {
        if (typeof options === "function" && callback === void 0) {
          callback = options;
          options = null;
        }
        options = options || {};
        options = AWS3.util.merge(options || {}, { service: this, params });
        var uploader = new AWS3.S3.ManagedUpload(options);
        if (typeof callback === "function")
          uploader.send(callback);
        return uploader;
      }
    });
    AWS3.S3.addPromisesToClass = function addPromisesToClass(PromiseDependency) {
      this.prototype.getSignedUrlPromise = AWS3.util.promisifyMethod("getSignedUrl", PromiseDependency);
    };
    AWS3.S3.deletePromisesFromClass = function deletePromisesFromClass() {
      delete this.prototype.getSignedUrlPromise;
    };
    AWS3.util.addPromises(AWS3.S3);
  }
});

// node_modules/aws-sdk/apis/s3-2006-03-01.min.json
var require_s3_2006_03_01_min = __commonJS({
  "node_modules/aws-sdk/apis/s3-2006-03-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2006-03-01",
        checksumFormat: "md5",
        endpointPrefix: "s3",
        globalEndpoint: "s3.amazonaws.com",
        protocol: "rest-xml",
        serviceAbbreviation: "Amazon S3",
        serviceFullName: "Amazon Simple Storage Service",
        serviceId: "S3",
        signatureVersion: "s3",
        uid: "s3-2006-03-01"
      },
      operations: {
        AbortMultipartUpload: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}/{Key+}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key",
              "UploadId"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              UploadId: {
                location: "querystring",
                locationName: "uploadId"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          }
        },
        CompleteMultipartUpload: {
          http: {
            requestUri: "/{Bucket}/{Key+}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key",
              "UploadId"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              MultipartUpload: {
                locationName: "CompleteMultipartUpload",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                members: {
                  Parts: {
                    locationName: "Part",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ETag: {},
                        PartNumber: {
                          type: "integer"
                        }
                      }
                    },
                    flattened: true
                  }
                }
              },
              UploadId: {
                location: "querystring",
                locationName: "uploadId"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "MultipartUpload"
          },
          output: {
            type: "structure",
            members: {
              Location: {},
              Bucket: {},
              Key: {},
              Expiration: {
                location: "header",
                locationName: "x-amz-expiration"
              },
              ETag: {},
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              VersionId: {
                location: "header",
                locationName: "x-amz-version-id"
              },
              SSEKMSKeyId: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          }
        },
        CopyObject: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}/{Key+}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "CopySource",
              "Key"
            ],
            members: {
              ACL: {
                location: "header",
                locationName: "x-amz-acl"
              },
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              CacheControl: {
                location: "header",
                locationName: "Cache-Control"
              },
              ContentDisposition: {
                location: "header",
                locationName: "Content-Disposition"
              },
              ContentEncoding: {
                location: "header",
                locationName: "Content-Encoding"
              },
              ContentLanguage: {
                location: "header",
                locationName: "Content-Language"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              CopySource: {
                location: "header",
                locationName: "x-amz-copy-source"
              },
              CopySourceIfMatch: {
                location: "header",
                locationName: "x-amz-copy-source-if-match"
              },
              CopySourceIfModifiedSince: {
                location: "header",
                locationName: "x-amz-copy-source-if-modified-since",
                type: "timestamp"
              },
              CopySourceIfNoneMatch: {
                location: "header",
                locationName: "x-amz-copy-source-if-none-match"
              },
              CopySourceIfUnmodifiedSince: {
                location: "header",
                locationName: "x-amz-copy-source-if-unmodified-since",
                type: "timestamp"
              },
              Expires: {
                location: "header",
                locationName: "Expires",
                type: "timestamp"
              },
              GrantFullControl: {
                location: "header",
                locationName: "x-amz-grant-full-control"
              },
              GrantRead: {
                location: "header",
                locationName: "x-amz-grant-read"
              },
              GrantReadACP: {
                location: "header",
                locationName: "x-amz-grant-read-acp"
              },
              GrantWriteACP: {
                location: "header",
                locationName: "x-amz-grant-write-acp"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              Metadata: {
                shape: "S13",
                location: "headers",
                locationName: "x-amz-meta-"
              },
              MetadataDirective: {
                location: "header",
                locationName: "x-amz-metadata-directive"
              },
              TaggingDirective: {
                location: "header",
                locationName: "x-amz-tagging-directive"
              },
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              StorageClass: {
                location: "header",
                locationName: "x-amz-storage-class"
              },
              WebsiteRedirectLocation: {
                location: "header",
                locationName: "x-amz-website-redirect-location"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKey: {
                shape: "S1b",
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              SSEKMSKeyId: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              SSEKMSEncryptionContext: {
                shape: "S1d",
                location: "header",
                locationName: "x-amz-server-side-encryption-context"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              CopySourceSSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-copy-source-server-side-encryption-customer-algorithm"
              },
              CopySourceSSECustomerKey: {
                shape: "S1f",
                location: "header",
                locationName: "x-amz-copy-source-server-side-encryption-customer-key"
              },
              CopySourceSSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-copy-source-server-side-encryption-customer-key-MD5"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              Tagging: {
                location: "header",
                locationName: "x-amz-tagging"
              },
              ObjectLockMode: {
                location: "header",
                locationName: "x-amz-object-lock-mode"
              },
              ObjectLockRetainUntilDate: {
                shape: "S1j",
                location: "header",
                locationName: "x-amz-object-lock-retain-until-date"
              },
              ObjectLockLegalHoldStatus: {
                location: "header",
                locationName: "x-amz-object-lock-legal-hold"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              ExpectedSourceBucketOwner: {
                location: "header",
                locationName: "x-amz-source-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CopyObjectResult: {
                type: "structure",
                members: {
                  ETag: {},
                  LastModified: {
                    type: "timestamp"
                  }
                }
              },
              Expiration: {
                location: "header",
                locationName: "x-amz-expiration"
              },
              CopySourceVersionId: {
                location: "header",
                locationName: "x-amz-copy-source-version-id"
              },
              VersionId: {
                location: "header",
                locationName: "x-amz-version-id"
              },
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              SSEKMSKeyId: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              SSEKMSEncryptionContext: {
                shape: "S1d",
                location: "header",
                locationName: "x-amz-server-side-encryption-context"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            },
            payload: "CopyObjectResult"
          },
          alias: "PutObjectCopy"
        },
        CreateBucket: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              ACL: {
                location: "header",
                locationName: "x-amz-acl"
              },
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              CreateBucketConfiguration: {
                locationName: "CreateBucketConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                members: {
                  LocationConstraint: {}
                }
              },
              GrantFullControl: {
                location: "header",
                locationName: "x-amz-grant-full-control"
              },
              GrantRead: {
                location: "header",
                locationName: "x-amz-grant-read"
              },
              GrantReadACP: {
                location: "header",
                locationName: "x-amz-grant-read-acp"
              },
              GrantWrite: {
                location: "header",
                locationName: "x-amz-grant-write"
              },
              GrantWriteACP: {
                location: "header",
                locationName: "x-amz-grant-write-acp"
              },
              ObjectLockEnabledForBucket: {
                location: "header",
                locationName: "x-amz-bucket-object-lock-enabled",
                type: "boolean"
              }
            },
            payload: "CreateBucketConfiguration"
          },
          output: {
            type: "structure",
            members: {
              Location: {
                location: "header",
                locationName: "Location"
              }
            }
          },
          alias: "PutBucket"
        },
        CreateMultipartUpload: {
          http: {
            requestUri: "/{Bucket}/{Key+}?uploads"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              ACL: {
                location: "header",
                locationName: "x-amz-acl"
              },
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              CacheControl: {
                location: "header",
                locationName: "Cache-Control"
              },
              ContentDisposition: {
                location: "header",
                locationName: "Content-Disposition"
              },
              ContentEncoding: {
                location: "header",
                locationName: "Content-Encoding"
              },
              ContentLanguage: {
                location: "header",
                locationName: "Content-Language"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              Expires: {
                location: "header",
                locationName: "Expires",
                type: "timestamp"
              },
              GrantFullControl: {
                location: "header",
                locationName: "x-amz-grant-full-control"
              },
              GrantRead: {
                location: "header",
                locationName: "x-amz-grant-read"
              },
              GrantReadACP: {
                location: "header",
                locationName: "x-amz-grant-read-acp"
              },
              GrantWriteACP: {
                location: "header",
                locationName: "x-amz-grant-write-acp"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              Metadata: {
                shape: "S13",
                location: "headers",
                locationName: "x-amz-meta-"
              },
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              StorageClass: {
                location: "header",
                locationName: "x-amz-storage-class"
              },
              WebsiteRedirectLocation: {
                location: "header",
                locationName: "x-amz-website-redirect-location"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKey: {
                shape: "S1b",
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              SSEKMSKeyId: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              SSEKMSEncryptionContext: {
                shape: "S1d",
                location: "header",
                locationName: "x-amz-server-side-encryption-context"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              Tagging: {
                location: "header",
                locationName: "x-amz-tagging"
              },
              ObjectLockMode: {
                location: "header",
                locationName: "x-amz-object-lock-mode"
              },
              ObjectLockRetainUntilDate: {
                shape: "S1j",
                location: "header",
                locationName: "x-amz-object-lock-retain-until-date"
              },
              ObjectLockLegalHoldStatus: {
                location: "header",
                locationName: "x-amz-object-lock-legal-hold"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AbortDate: {
                location: "header",
                locationName: "x-amz-abort-date",
                type: "timestamp"
              },
              AbortRuleId: {
                location: "header",
                locationName: "x-amz-abort-rule-id"
              },
              Bucket: {
                locationName: "Bucket"
              },
              Key: {},
              UploadId: {},
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              SSEKMSKeyId: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              SSEKMSEncryptionContext: {
                shape: "S1d",
                location: "header",
                locationName: "x-amz-server-side-encryption-context"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          },
          alias: "InitiateMultipartUpload"
        },
        DeleteBucket: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          }
        },
        DeleteBucketAnalyticsConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?analytics",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          }
        },
        DeleteBucketCors: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?cors",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          }
        },
        DeleteBucketEncryption: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?encryption",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          }
        },
        DeleteBucketIntelligentTieringConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?intelligent-tiering",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              }
            }
          }
        },
        DeleteBucketInventoryConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?inventory",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          }
        },
        DeleteBucketLifecycle: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?lifecycle",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          }
        },
        DeleteBucketMetricsConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?metrics",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          }
        },
        DeleteBucketOwnershipControls: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?ownershipControls",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          }
        },
        DeleteBucketPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?policy",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          }
        },
        DeleteBucketReplication: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?replication",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          }
        },
        DeleteBucketTagging: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?tagging",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          }
        },
        DeleteBucketWebsite: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?website",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          }
        },
        DeleteObject: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}/{Key+}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              MFA: {
                location: "header",
                locationName: "x-amz-mfa"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              BypassGovernanceRetention: {
                location: "header",
                locationName: "x-amz-bypass-governance-retention",
                type: "boolean"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeleteMarker: {
                location: "header",
                locationName: "x-amz-delete-marker",
                type: "boolean"
              },
              VersionId: {
                location: "header",
                locationName: "x-amz-version-id"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          }
        },
        DeleteObjectTagging: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}/{Key+}?tagging",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VersionId: {
                location: "header",
                locationName: "x-amz-version-id"
              }
            }
          }
        },
        DeleteObjects: {
          http: {
            requestUri: "/{Bucket}?delete"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Delete"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Delete: {
                locationName: "Delete",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                required: [
                  "Objects"
                ],
                members: {
                  Objects: {
                    locationName: "Object",
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Key"
                      ],
                      members: {
                        Key: {},
                        VersionId: {}
                      }
                    },
                    flattened: true
                  },
                  Quiet: {
                    type: "boolean"
                  }
                }
              },
              MFA: {
                location: "header",
                locationName: "x-amz-mfa"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              BypassGovernanceRetention: {
                location: "header",
                locationName: "x-amz-bypass-governance-retention",
                type: "boolean"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "Delete"
          },
          output: {
            type: "structure",
            members: {
              Deleted: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {},
                    VersionId: {},
                    DeleteMarker: {
                      type: "boolean"
                    },
                    DeleteMarkerVersionId: {}
                  }
                },
                flattened: true
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              },
              Errors: {
                locationName: "Error",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {},
                    VersionId: {},
                    Code: {},
                    Message: {}
                  }
                },
                flattened: true
              }
            }
          },
          alias: "DeleteMultipleObjects",
          httpChecksumRequired: true
        },
        DeletePublicAccessBlock: {
          http: {
            method: "DELETE",
            requestUri: "/{Bucket}?publicAccessBlock",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          }
        },
        GetBucketAccelerateConfiguration: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?accelerate"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        },
        GetBucketAcl: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?acl"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Owner: {
                shape: "S37"
              },
              Grants: {
                shape: "S3a",
                locationName: "AccessControlList"
              }
            }
          }
        },
        GetBucketAnalyticsConfiguration: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?analytics"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AnalyticsConfiguration: {
                shape: "S3j"
              }
            },
            payload: "AnalyticsConfiguration"
          }
        },
        GetBucketCors: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?cors"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CORSRules: {
                shape: "S3y",
                locationName: "CORSRule"
              }
            }
          }
        },
        GetBucketEncryption: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?encryption"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ServerSideEncryptionConfiguration: {
                shape: "S4b"
              }
            },
            payload: "ServerSideEncryptionConfiguration"
          }
        },
        GetBucketIntelligentTieringConfiguration: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?intelligent-tiering"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IntelligentTieringConfiguration: {
                shape: "S4h"
              }
            },
            payload: "IntelligentTieringConfiguration"
          }
        },
        GetBucketInventoryConfiguration: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?inventory"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InventoryConfiguration: {
                shape: "S4r"
              }
            },
            payload: "InventoryConfiguration"
          }
        },
        GetBucketLifecycle: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?lifecycle"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rules: {
                shape: "S57",
                locationName: "Rule"
              }
            }
          },
          deprecated: true
        },
        GetBucketLifecycleConfiguration: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?lifecycle"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rules: {
                shape: "S5m",
                locationName: "Rule"
              }
            }
          }
        },
        GetBucketLocation: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?location"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocationConstraint: {}
            }
          }
        },
        GetBucketLogging: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?logging"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingEnabled: {
                shape: "S5w"
              }
            }
          }
        },
        GetBucketMetricsConfiguration: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?metrics"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MetricsConfiguration: {
                shape: "S64"
              }
            },
            payload: "MetricsConfiguration"
          }
        },
        GetBucketNotification: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?notification"
          },
          input: {
            shape: "S68"
          },
          output: {
            shape: "S69"
          },
          deprecated: true
        },
        GetBucketNotificationConfiguration: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?notification"
          },
          input: {
            shape: "S68"
          },
          output: {
            shape: "S6k"
          }
        },
        GetBucketOwnershipControls: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?ownershipControls"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OwnershipControls: {
                shape: "S70"
              }
            },
            payload: "OwnershipControls"
          }
        },
        GetBucketPolicy: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?policy"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            },
            payload: "Policy"
          }
        },
        GetBucketPolicyStatus: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?policyStatus"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyStatus: {
                type: "structure",
                members: {
                  IsPublic: {
                    locationName: "IsPublic",
                    type: "boolean"
                  }
                }
              }
            },
            payload: "PolicyStatus"
          }
        },
        GetBucketReplication: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?replication"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplicationConfiguration: {
                shape: "S7d"
              }
            },
            payload: "ReplicationConfiguration"
          }
        },
        GetBucketRequestPayment: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?requestPayment"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Payer: {}
            }
          }
        },
        GetBucketTagging: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?tagging"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TagSet"
            ],
            members: {
              TagSet: {
                shape: "S3p"
              }
            }
          }
        },
        GetBucketVersioning: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?versioning"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              MFADelete: {
                locationName: "MfaDelete"
              }
            }
          }
        },
        GetBucketWebsite: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?website"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RedirectAllRequestsTo: {
                shape: "S8g"
              },
              IndexDocument: {
                shape: "S8j"
              },
              ErrorDocument: {
                shape: "S8l"
              },
              RoutingRules: {
                shape: "S8m"
              }
            }
          }
        },
        GetObject: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}/{Key+}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              },
              IfModifiedSince: {
                location: "header",
                locationName: "If-Modified-Since",
                type: "timestamp"
              },
              IfNoneMatch: {
                location: "header",
                locationName: "If-None-Match"
              },
              IfUnmodifiedSince: {
                location: "header",
                locationName: "If-Unmodified-Since",
                type: "timestamp"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              Range: {
                location: "header",
                locationName: "Range"
              },
              ResponseCacheControl: {
                location: "querystring",
                locationName: "response-cache-control"
              },
              ResponseContentDisposition: {
                location: "querystring",
                locationName: "response-content-disposition"
              },
              ResponseContentEncoding: {
                location: "querystring",
                locationName: "response-content-encoding"
              },
              ResponseContentLanguage: {
                location: "querystring",
                locationName: "response-content-language"
              },
              ResponseContentType: {
                location: "querystring",
                locationName: "response-content-type"
              },
              ResponseExpires: {
                location: "querystring",
                locationName: "response-expires",
                type: "timestamp",
                timestampFormat: "rfc822"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKey: {
                shape: "S1b",
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              PartNumber: {
                location: "querystring",
                locationName: "partNumber",
                type: "integer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Body: {
                streaming: true,
                type: "blob"
              },
              DeleteMarker: {
                location: "header",
                locationName: "x-amz-delete-marker",
                type: "boolean"
              },
              AcceptRanges: {
                location: "header",
                locationName: "accept-ranges"
              },
              Expiration: {
                location: "header",
                locationName: "x-amz-expiration"
              },
              Restore: {
                location: "header",
                locationName: "x-amz-restore"
              },
              LastModified: {
                location: "header",
                locationName: "Last-Modified",
                type: "timestamp"
              },
              ContentLength: {
                location: "header",
                locationName: "Content-Length",
                type: "long"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              },
              MissingMeta: {
                location: "header",
                locationName: "x-amz-missing-meta",
                type: "integer"
              },
              VersionId: {
                location: "header",
                locationName: "x-amz-version-id"
              },
              CacheControl: {
                location: "header",
                locationName: "Cache-Control"
              },
              ContentDisposition: {
                location: "header",
                locationName: "Content-Disposition"
              },
              ContentEncoding: {
                location: "header",
                locationName: "Content-Encoding"
              },
              ContentLanguage: {
                location: "header",
                locationName: "Content-Language"
              },
              ContentRange: {
                location: "header",
                locationName: "Content-Range"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              Expires: {
                location: "header",
                locationName: "Expires",
                type: "timestamp"
              },
              WebsiteRedirectLocation: {
                location: "header",
                locationName: "x-amz-website-redirect-location"
              },
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              Metadata: {
                shape: "S13",
                location: "headers",
                locationName: "x-amz-meta-"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              SSEKMSKeyId: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              StorageClass: {
                location: "header",
                locationName: "x-amz-storage-class"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              },
              ReplicationStatus: {
                location: "header",
                locationName: "x-amz-replication-status"
              },
              PartsCount: {
                location: "header",
                locationName: "x-amz-mp-parts-count",
                type: "integer"
              },
              TagCount: {
                location: "header",
                locationName: "x-amz-tagging-count",
                type: "integer"
              },
              ObjectLockMode: {
                location: "header",
                locationName: "x-amz-object-lock-mode"
              },
              ObjectLockRetainUntilDate: {
                shape: "S1j",
                location: "header",
                locationName: "x-amz-object-lock-retain-until-date"
              },
              ObjectLockLegalHoldStatus: {
                location: "header",
                locationName: "x-amz-object-lock-legal-hold"
              }
            },
            payload: "Body"
          }
        },
        GetObjectAcl: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}/{Key+}?acl"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Owner: {
                shape: "S37"
              },
              Grants: {
                shape: "S3a",
                locationName: "AccessControlList"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          }
        },
        GetObjectLegalHold: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}/{Key+}?legal-hold"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LegalHold: {
                shape: "S9l"
              }
            },
            payload: "LegalHold"
          }
        },
        GetObjectLockConfiguration: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?object-lock"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectLockConfiguration: {
                shape: "S9o"
              }
            },
            payload: "ObjectLockConfiguration"
          }
        },
        GetObjectRetention: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}/{Key+}?retention"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Retention: {
                shape: "S9w"
              }
            },
            payload: "Retention"
          }
        },
        GetObjectTagging: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}/{Key+}?tagging"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TagSet"
            ],
            members: {
              VersionId: {
                location: "header",
                locationName: "x-amz-version-id"
              },
              TagSet: {
                shape: "S3p"
              }
            }
          }
        },
        GetObjectTorrent: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}/{Key+}?torrent"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Body: {
                streaming: true,
                type: "blob"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            },
            payload: "Body"
          }
        },
        GetPublicAccessBlock: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?publicAccessBlock"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicAccessBlockConfiguration: {
                shape: "Sa3"
              }
            },
            payload: "PublicAccessBlockConfiguration"
          }
        },
        HeadBucket: {
          http: {
            method: "HEAD",
            requestUri: "/{Bucket}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          }
        },
        HeadObject: {
          http: {
            method: "HEAD",
            requestUri: "/{Bucket}/{Key+}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              IfMatch: {
                location: "header",
                locationName: "If-Match"
              },
              IfModifiedSince: {
                location: "header",
                locationName: "If-Modified-Since",
                type: "timestamp"
              },
              IfNoneMatch: {
                location: "header",
                locationName: "If-None-Match"
              },
              IfUnmodifiedSince: {
                location: "header",
                locationName: "If-Unmodified-Since",
                type: "timestamp"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              Range: {
                location: "header",
                locationName: "Range"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKey: {
                shape: "S1b",
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              PartNumber: {
                location: "querystring",
                locationName: "partNumber",
                type: "integer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeleteMarker: {
                location: "header",
                locationName: "x-amz-delete-marker",
                type: "boolean"
              },
              AcceptRanges: {
                location: "header",
                locationName: "accept-ranges"
              },
              Expiration: {
                location: "header",
                locationName: "x-amz-expiration"
              },
              Restore: {
                location: "header",
                locationName: "x-amz-restore"
              },
              ArchiveStatus: {
                location: "header",
                locationName: "x-amz-archive-status"
              },
              LastModified: {
                location: "header",
                locationName: "Last-Modified",
                type: "timestamp"
              },
              ContentLength: {
                location: "header",
                locationName: "Content-Length",
                type: "long"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              },
              MissingMeta: {
                location: "header",
                locationName: "x-amz-missing-meta",
                type: "integer"
              },
              VersionId: {
                location: "header",
                locationName: "x-amz-version-id"
              },
              CacheControl: {
                location: "header",
                locationName: "Cache-Control"
              },
              ContentDisposition: {
                location: "header",
                locationName: "Content-Disposition"
              },
              ContentEncoding: {
                location: "header",
                locationName: "Content-Encoding"
              },
              ContentLanguage: {
                location: "header",
                locationName: "Content-Language"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              Expires: {
                location: "header",
                locationName: "Expires",
                type: "timestamp"
              },
              WebsiteRedirectLocation: {
                location: "header",
                locationName: "x-amz-website-redirect-location"
              },
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              Metadata: {
                shape: "S13",
                location: "headers",
                locationName: "x-amz-meta-"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              SSEKMSKeyId: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              StorageClass: {
                location: "header",
                locationName: "x-amz-storage-class"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              },
              ReplicationStatus: {
                location: "header",
                locationName: "x-amz-replication-status"
              },
              PartsCount: {
                location: "header",
                locationName: "x-amz-mp-parts-count",
                type: "integer"
              },
              ObjectLockMode: {
                location: "header",
                locationName: "x-amz-object-lock-mode"
              },
              ObjectLockRetainUntilDate: {
                shape: "S1j",
                location: "header",
                locationName: "x-amz-object-lock-retain-until-date"
              },
              ObjectLockLegalHoldStatus: {
                location: "header",
                locationName: "x-amz-object-lock-legal-hold"
              }
            }
          }
        },
        ListBucketAnalyticsConfigurations: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?analytics"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ContinuationToken: {
                location: "querystring",
                locationName: "continuation-token"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IsTruncated: {
                type: "boolean"
              },
              ContinuationToken: {},
              NextContinuationToken: {},
              AnalyticsConfigurationList: {
                locationName: "AnalyticsConfiguration",
                type: "list",
                member: {
                  shape: "S3j"
                },
                flattened: true
              }
            }
          }
        },
        ListBucketIntelligentTieringConfigurations: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?intelligent-tiering"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ContinuationToken: {
                location: "querystring",
                locationName: "continuation-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IsTruncated: {
                type: "boolean"
              },
              ContinuationToken: {},
              NextContinuationToken: {},
              IntelligentTieringConfigurationList: {
                locationName: "IntelligentTieringConfiguration",
                type: "list",
                member: {
                  shape: "S4h"
                },
                flattened: true
              }
            }
          }
        },
        ListBucketInventoryConfigurations: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?inventory"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ContinuationToken: {
                location: "querystring",
                locationName: "continuation-token"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContinuationToken: {},
              InventoryConfigurationList: {
                locationName: "InventoryConfiguration",
                type: "list",
                member: {
                  shape: "S4r"
                },
                flattened: true
              },
              IsTruncated: {
                type: "boolean"
              },
              NextContinuationToken: {}
            }
          }
        },
        ListBucketMetricsConfigurations: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?metrics"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ContinuationToken: {
                location: "querystring",
                locationName: "continuation-token"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IsTruncated: {
                type: "boolean"
              },
              ContinuationToken: {},
              NextContinuationToken: {},
              MetricsConfigurationList: {
                locationName: "MetricsConfiguration",
                type: "list",
                member: {
                  shape: "S64"
                },
                flattened: true
              }
            }
          }
        },
        ListBuckets: {
          http: {
            method: "GET"
          },
          output: {
            type: "structure",
            members: {
              Buckets: {
                type: "list",
                member: {
                  locationName: "Bucket",
                  type: "structure",
                  members: {
                    Name: {},
                    CreationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              Owner: {
                shape: "S37"
              }
            }
          },
          alias: "GetService"
        },
        ListMultipartUploads: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?uploads"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Delimiter: {
                location: "querystring",
                locationName: "delimiter"
              },
              EncodingType: {
                location: "querystring",
                locationName: "encoding-type"
              },
              KeyMarker: {
                location: "querystring",
                locationName: "key-marker"
              },
              MaxUploads: {
                location: "querystring",
                locationName: "max-uploads",
                type: "integer"
              },
              Prefix: {
                location: "querystring",
                locationName: "prefix"
              },
              UploadIdMarker: {
                location: "querystring",
                locationName: "upload-id-marker"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Bucket: {},
              KeyMarker: {},
              UploadIdMarker: {},
              NextKeyMarker: {},
              Prefix: {},
              Delimiter: {},
              NextUploadIdMarker: {},
              MaxUploads: {
                type: "integer"
              },
              IsTruncated: {
                type: "boolean"
              },
              Uploads: {
                locationName: "Upload",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UploadId: {},
                    Key: {},
                    Initiated: {
                      type: "timestamp"
                    },
                    StorageClass: {},
                    Owner: {
                      shape: "S37"
                    },
                    Initiator: {
                      shape: "Sb4"
                    }
                  }
                },
                flattened: true
              },
              CommonPrefixes: {
                shape: "Sb5"
              },
              EncodingType: {}
            }
          }
        },
        ListObjectVersions: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?versions"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Delimiter: {
                location: "querystring",
                locationName: "delimiter"
              },
              EncodingType: {
                location: "querystring",
                locationName: "encoding-type"
              },
              KeyMarker: {
                location: "querystring",
                locationName: "key-marker"
              },
              MaxKeys: {
                location: "querystring",
                locationName: "max-keys",
                type: "integer"
              },
              Prefix: {
                location: "querystring",
                locationName: "prefix"
              },
              VersionIdMarker: {
                location: "querystring",
                locationName: "version-id-marker"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IsTruncated: {
                type: "boolean"
              },
              KeyMarker: {},
              VersionIdMarker: {},
              NextKeyMarker: {},
              NextVersionIdMarker: {},
              Versions: {
                locationName: "Version",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ETag: {},
                    Size: {
                      type: "integer"
                    },
                    StorageClass: {},
                    Key: {},
                    VersionId: {},
                    IsLatest: {
                      type: "boolean"
                    },
                    LastModified: {
                      type: "timestamp"
                    },
                    Owner: {
                      shape: "S37"
                    }
                  }
                },
                flattened: true
              },
              DeleteMarkers: {
                locationName: "DeleteMarker",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Owner: {
                      shape: "S37"
                    },
                    Key: {},
                    VersionId: {},
                    IsLatest: {
                      type: "boolean"
                    },
                    LastModified: {
                      type: "timestamp"
                    }
                  }
                },
                flattened: true
              },
              Name: {},
              Prefix: {},
              Delimiter: {},
              MaxKeys: {
                type: "integer"
              },
              CommonPrefixes: {
                shape: "Sb5"
              },
              EncodingType: {}
            }
          },
          alias: "GetBucketObjectVersions"
        },
        ListObjects: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Delimiter: {
                location: "querystring",
                locationName: "delimiter"
              },
              EncodingType: {
                location: "querystring",
                locationName: "encoding-type"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              },
              MaxKeys: {
                location: "querystring",
                locationName: "max-keys",
                type: "integer"
              },
              Prefix: {
                location: "querystring",
                locationName: "prefix"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IsTruncated: {
                type: "boolean"
              },
              Marker: {},
              NextMarker: {},
              Contents: {
                shape: "Sbn"
              },
              Name: {},
              Prefix: {},
              Delimiter: {},
              MaxKeys: {
                type: "integer"
              },
              CommonPrefixes: {
                shape: "Sb5"
              },
              EncodingType: {}
            }
          },
          alias: "GetBucket"
        },
        ListObjectsV2: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}?list-type=2"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Delimiter: {
                location: "querystring",
                locationName: "delimiter"
              },
              EncodingType: {
                location: "querystring",
                locationName: "encoding-type"
              },
              MaxKeys: {
                location: "querystring",
                locationName: "max-keys",
                type: "integer"
              },
              Prefix: {
                location: "querystring",
                locationName: "prefix"
              },
              ContinuationToken: {
                location: "querystring",
                locationName: "continuation-token"
              },
              FetchOwner: {
                location: "querystring",
                locationName: "fetch-owner",
                type: "boolean"
              },
              StartAfter: {
                location: "querystring",
                locationName: "start-after"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IsTruncated: {
                type: "boolean"
              },
              Contents: {
                shape: "Sbn"
              },
              Name: {},
              Prefix: {},
              Delimiter: {},
              MaxKeys: {
                type: "integer"
              },
              CommonPrefixes: {
                shape: "Sb5"
              },
              EncodingType: {},
              KeyCount: {
                type: "integer"
              },
              ContinuationToken: {},
              NextContinuationToken: {},
              StartAfter: {}
            }
          }
        },
        ListParts: {
          http: {
            method: "GET",
            requestUri: "/{Bucket}/{Key+}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key",
              "UploadId"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              MaxParts: {
                location: "querystring",
                locationName: "max-parts",
                type: "integer"
              },
              PartNumberMarker: {
                location: "querystring",
                locationName: "part-number-marker",
                type: "integer"
              },
              UploadId: {
                location: "querystring",
                locationName: "uploadId"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AbortDate: {
                location: "header",
                locationName: "x-amz-abort-date",
                type: "timestamp"
              },
              AbortRuleId: {
                location: "header",
                locationName: "x-amz-abort-rule-id"
              },
              Bucket: {},
              Key: {},
              UploadId: {},
              PartNumberMarker: {
                type: "integer"
              },
              NextPartNumberMarker: {
                type: "integer"
              },
              MaxParts: {
                type: "integer"
              },
              IsTruncated: {
                type: "boolean"
              },
              Parts: {
                locationName: "Part",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PartNumber: {
                      type: "integer"
                    },
                    LastModified: {
                      type: "timestamp"
                    },
                    ETag: {},
                    Size: {
                      type: "integer"
                    }
                  }
                },
                flattened: true
              },
              Initiator: {
                shape: "Sb4"
              },
              Owner: {
                shape: "S37"
              },
              StorageClass: {},
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          }
        },
        PutBucketAccelerateConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?accelerate"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "AccelerateConfiguration"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              AccelerateConfiguration: {
                locationName: "AccelerateConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                members: {
                  Status: {}
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "AccelerateConfiguration"
          }
        },
        PutBucketAcl: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?acl"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              ACL: {
                location: "header",
                locationName: "x-amz-acl"
              },
              AccessControlPolicy: {
                shape: "Sc5",
                locationName: "AccessControlPolicy",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              GrantFullControl: {
                location: "header",
                locationName: "x-amz-grant-full-control"
              },
              GrantRead: {
                location: "header",
                locationName: "x-amz-grant-read"
              },
              GrantReadACP: {
                location: "header",
                locationName: "x-amz-grant-read-acp"
              },
              GrantWrite: {
                location: "header",
                locationName: "x-amz-grant-write"
              },
              GrantWriteACP: {
                location: "header",
                locationName: "x-amz-grant-write-acp"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "AccessControlPolicy"
          },
          httpChecksumRequired: true
        },
        PutBucketAnalyticsConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?analytics"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id",
              "AnalyticsConfiguration"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              },
              AnalyticsConfiguration: {
                shape: "S3j",
                locationName: "AnalyticsConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "AnalyticsConfiguration"
          }
        },
        PutBucketCors: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?cors"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "CORSConfiguration"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              CORSConfiguration: {
                locationName: "CORSConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                required: [
                  "CORSRules"
                ],
                members: {
                  CORSRules: {
                    shape: "S3y",
                    locationName: "CORSRule"
                  }
                }
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "CORSConfiguration"
          },
          httpChecksumRequired: true
        },
        PutBucketEncryption: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?encryption"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "ServerSideEncryptionConfiguration"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ServerSideEncryptionConfiguration: {
                shape: "S4b",
                locationName: "ServerSideEncryptionConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "ServerSideEncryptionConfiguration"
          },
          httpChecksumRequired: true
        },
        PutBucketIntelligentTieringConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?intelligent-tiering"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id",
              "IntelligentTieringConfiguration"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              },
              IntelligentTieringConfiguration: {
                shape: "S4h",
                locationName: "IntelligentTieringConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              }
            },
            payload: "IntelligentTieringConfiguration"
          }
        },
        PutBucketInventoryConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?inventory"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id",
              "InventoryConfiguration"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              },
              InventoryConfiguration: {
                shape: "S4r",
                locationName: "InventoryConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "InventoryConfiguration"
          }
        },
        PutBucketLifecycle: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?lifecycle"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              LifecycleConfiguration: {
                locationName: "LifecycleConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                required: [
                  "Rules"
                ],
                members: {
                  Rules: {
                    shape: "S57",
                    locationName: "Rule"
                  }
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "LifecycleConfiguration"
          },
          deprecated: true,
          httpChecksumRequired: true
        },
        PutBucketLifecycleConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?lifecycle"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              LifecycleConfiguration: {
                locationName: "LifecycleConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                required: [
                  "Rules"
                ],
                members: {
                  Rules: {
                    shape: "S5m",
                    locationName: "Rule"
                  }
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "LifecycleConfiguration"
          },
          httpChecksumRequired: true
        },
        PutBucketLogging: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?logging"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "BucketLoggingStatus"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              BucketLoggingStatus: {
                locationName: "BucketLoggingStatus",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                members: {
                  LoggingEnabled: {
                    shape: "S5w"
                  }
                }
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "BucketLoggingStatus"
          },
          httpChecksumRequired: true
        },
        PutBucketMetricsConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?metrics"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Id",
              "MetricsConfiguration"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Id: {
                location: "querystring",
                locationName: "id"
              },
              MetricsConfiguration: {
                shape: "S64",
                locationName: "MetricsConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "MetricsConfiguration"
          }
        },
        PutBucketNotification: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?notification"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "NotificationConfiguration"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              NotificationConfiguration: {
                shape: "S69",
                locationName: "NotificationConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "NotificationConfiguration"
          },
          deprecated: true,
          httpChecksumRequired: true
        },
        PutBucketNotificationConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?notification"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "NotificationConfiguration"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              NotificationConfiguration: {
                shape: "S6k",
                locationName: "NotificationConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "NotificationConfiguration"
          }
        },
        PutBucketOwnershipControls: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?ownershipControls"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "OwnershipControls"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              OwnershipControls: {
                shape: "S70",
                locationName: "OwnershipControls",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              }
            },
            payload: "OwnershipControls"
          },
          httpChecksumRequired: true
        },
        PutBucketPolicy: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?policy"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Policy"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ConfirmRemoveSelfBucketAccess: {
                location: "header",
                locationName: "x-amz-confirm-remove-self-bucket-access",
                type: "boolean"
              },
              Policy: {},
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "Policy"
          },
          httpChecksumRequired: true
        },
        PutBucketReplication: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?replication"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "ReplicationConfiguration"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ReplicationConfiguration: {
                shape: "S7d",
                locationName: "ReplicationConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              Token: {
                location: "header",
                locationName: "x-amz-bucket-object-lock-token"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "ReplicationConfiguration"
          },
          httpChecksumRequired: true
        },
        PutBucketRequestPayment: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?requestPayment"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "RequestPaymentConfiguration"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              RequestPaymentConfiguration: {
                locationName: "RequestPaymentConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                required: [
                  "Payer"
                ],
                members: {
                  Payer: {}
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "RequestPaymentConfiguration"
          },
          httpChecksumRequired: true
        },
        PutBucketTagging: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?tagging"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Tagging"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              Tagging: {
                shape: "Scu",
                locationName: "Tagging",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "Tagging"
          },
          httpChecksumRequired: true
        },
        PutBucketVersioning: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?versioning"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "VersioningConfiguration"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              MFA: {
                location: "header",
                locationName: "x-amz-mfa"
              },
              VersioningConfiguration: {
                locationName: "VersioningConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                members: {
                  MFADelete: {
                    locationName: "MfaDelete"
                  },
                  Status: {}
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "VersioningConfiguration"
          },
          httpChecksumRequired: true
        },
        PutBucketWebsite: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?website"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "WebsiteConfiguration"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              WebsiteConfiguration: {
                locationName: "WebsiteConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                members: {
                  ErrorDocument: {
                    shape: "S8l"
                  },
                  IndexDocument: {
                    shape: "S8j"
                  },
                  RedirectAllRequestsTo: {
                    shape: "S8g"
                  },
                  RoutingRules: {
                    shape: "S8m"
                  }
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "WebsiteConfiguration"
          },
          httpChecksumRequired: true
        },
        PutObject: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}/{Key+}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              ACL: {
                location: "header",
                locationName: "x-amz-acl"
              },
              Body: {
                streaming: true,
                type: "blob"
              },
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              CacheControl: {
                location: "header",
                locationName: "Cache-Control"
              },
              ContentDisposition: {
                location: "header",
                locationName: "Content-Disposition"
              },
              ContentEncoding: {
                location: "header",
                locationName: "Content-Encoding"
              },
              ContentLanguage: {
                location: "header",
                locationName: "Content-Language"
              },
              ContentLength: {
                location: "header",
                locationName: "Content-Length",
                type: "long"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              Expires: {
                location: "header",
                locationName: "Expires",
                type: "timestamp"
              },
              GrantFullControl: {
                location: "header",
                locationName: "x-amz-grant-full-control"
              },
              GrantRead: {
                location: "header",
                locationName: "x-amz-grant-read"
              },
              GrantReadACP: {
                location: "header",
                locationName: "x-amz-grant-read-acp"
              },
              GrantWriteACP: {
                location: "header",
                locationName: "x-amz-grant-write-acp"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              Metadata: {
                shape: "S13",
                location: "headers",
                locationName: "x-amz-meta-"
              },
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              StorageClass: {
                location: "header",
                locationName: "x-amz-storage-class"
              },
              WebsiteRedirectLocation: {
                location: "header",
                locationName: "x-amz-website-redirect-location"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKey: {
                shape: "S1b",
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              SSEKMSKeyId: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              SSEKMSEncryptionContext: {
                shape: "S1d",
                location: "header",
                locationName: "x-amz-server-side-encryption-context"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              Tagging: {
                location: "header",
                locationName: "x-amz-tagging"
              },
              ObjectLockMode: {
                location: "header",
                locationName: "x-amz-object-lock-mode"
              },
              ObjectLockRetainUntilDate: {
                shape: "S1j",
                location: "header",
                locationName: "x-amz-object-lock-retain-until-date"
              },
              ObjectLockLegalHoldStatus: {
                location: "header",
                locationName: "x-amz-object-lock-legal-hold"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "Body"
          },
          output: {
            type: "structure",
            members: {
              Expiration: {
                location: "header",
                locationName: "x-amz-expiration"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              },
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              VersionId: {
                location: "header",
                locationName: "x-amz-version-id"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              SSEKMSKeyId: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              SSEKMSEncryptionContext: {
                shape: "S1d",
                location: "header",
                locationName: "x-amz-server-side-encryption-context"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          }
        },
        PutObjectAcl: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}/{Key+}?acl"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              ACL: {
                location: "header",
                locationName: "x-amz-acl"
              },
              AccessControlPolicy: {
                shape: "Sc5",
                locationName: "AccessControlPolicy",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              GrantFullControl: {
                location: "header",
                locationName: "x-amz-grant-full-control"
              },
              GrantRead: {
                location: "header",
                locationName: "x-amz-grant-read"
              },
              GrantReadACP: {
                location: "header",
                locationName: "x-amz-grant-read-acp"
              },
              GrantWrite: {
                location: "header",
                locationName: "x-amz-grant-write"
              },
              GrantWriteACP: {
                location: "header",
                locationName: "x-amz-grant-write-acp"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "AccessControlPolicy"
          },
          output: {
            type: "structure",
            members: {
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          },
          httpChecksumRequired: true
        },
        PutObjectLegalHold: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}/{Key+}?legal-hold"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              LegalHold: {
                shape: "S9l",
                locationName: "LegalHold",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "LegalHold"
          },
          output: {
            type: "structure",
            members: {
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          },
          httpChecksumRequired: true
        },
        PutObjectLockConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?object-lock"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ObjectLockConfiguration: {
                shape: "S9o",
                locationName: "ObjectLockConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              Token: {
                location: "header",
                locationName: "x-amz-bucket-object-lock-token"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "ObjectLockConfiguration"
          },
          output: {
            type: "structure",
            members: {
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          },
          httpChecksumRequired: true
        },
        PutObjectRetention: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}/{Key+}?retention"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              Retention: {
                shape: "S9w",
                locationName: "Retention",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              BypassGovernanceRetention: {
                location: "header",
                locationName: "x-amz-bypass-governance-retention",
                type: "boolean"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "Retention"
          },
          output: {
            type: "structure",
            members: {
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          },
          httpChecksumRequired: true
        },
        PutObjectTagging: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}/{Key+}?tagging"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key",
              "Tagging"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              Tagging: {
                shape: "Scu",
                locationName: "Tagging",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              }
            },
            payload: "Tagging"
          },
          output: {
            type: "structure",
            members: {
              VersionId: {
                location: "header",
                locationName: "x-amz-version-id"
              }
            }
          },
          httpChecksumRequired: true
        },
        PutPublicAccessBlock: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}?publicAccessBlock"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "PublicAccessBlockConfiguration"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              PublicAccessBlockConfiguration: {
                shape: "Sa3",
                locationName: "PublicAccessBlockConfiguration",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "PublicAccessBlockConfiguration"
          },
          httpChecksumRequired: true
        },
        RestoreObject: {
          http: {
            requestUri: "/{Bucket}/{Key+}?restore"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              RestoreRequest: {
                locationName: "RestoreRequest",
                xmlNamespace: {
                  uri: "http://s3.amazonaws.com/doc/2006-03-01/"
                },
                type: "structure",
                members: {
                  Days: {
                    type: "integer"
                  },
                  GlacierJobParameters: {
                    type: "structure",
                    required: [
                      "Tier"
                    ],
                    members: {
                      Tier: {}
                    }
                  },
                  Type: {},
                  Tier: {},
                  Description: {},
                  SelectParameters: {
                    type: "structure",
                    required: [
                      "InputSerialization",
                      "ExpressionType",
                      "Expression",
                      "OutputSerialization"
                    ],
                    members: {
                      InputSerialization: {
                        shape: "Sdk"
                      },
                      ExpressionType: {},
                      Expression: {},
                      OutputSerialization: {
                        shape: "Sdz"
                      }
                    }
                  },
                  OutputLocation: {
                    type: "structure",
                    members: {
                      S3: {
                        type: "structure",
                        required: [
                          "BucketName",
                          "Prefix"
                        ],
                        members: {
                          BucketName: {},
                          Prefix: {},
                          Encryption: {
                            type: "structure",
                            required: [
                              "EncryptionType"
                            ],
                            members: {
                              EncryptionType: {},
                              KMSKeyId: {
                                shape: "Sk"
                              },
                              KMSContext: {}
                            }
                          },
                          CannedACL: {},
                          AccessControlList: {
                            shape: "S3a"
                          },
                          Tagging: {
                            shape: "Scu"
                          },
                          UserMetadata: {
                            type: "list",
                            member: {
                              locationName: "MetadataEntry",
                              type: "structure",
                              members: {
                                Name: {},
                                Value: {}
                              }
                            }
                          },
                          StorageClass: {}
                        }
                      }
                    }
                  }
                }
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "RestoreRequest"
          },
          output: {
            type: "structure",
            members: {
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              },
              RestoreOutputPath: {
                location: "header",
                locationName: "x-amz-restore-output-path"
              }
            }
          },
          alias: "PostObjectRestore"
        },
        SelectObjectContent: {
          http: {
            requestUri: "/{Bucket}/{Key+}?select&select-type=2"
          },
          input: {
            locationName: "SelectObjectContentRequest",
            xmlNamespace: {
              uri: "http://s3.amazonaws.com/doc/2006-03-01/"
            },
            type: "structure",
            required: [
              "Bucket",
              "Key",
              "Expression",
              "ExpressionType",
              "InputSerialization",
              "OutputSerialization"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKey: {
                shape: "S1b",
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              Expression: {},
              ExpressionType: {},
              RequestProgress: {
                type: "structure",
                members: {
                  Enabled: {
                    type: "boolean"
                  }
                }
              },
              InputSerialization: {
                shape: "Sdk"
              },
              OutputSerialization: {
                shape: "Sdz"
              },
              ScanRange: {
                type: "structure",
                members: {
                  Start: {
                    type: "long"
                  },
                  End: {
                    type: "long"
                  }
                }
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Payload: {
                type: "structure",
                members: {
                  Records: {
                    type: "structure",
                    members: {
                      Payload: {
                        eventpayload: true,
                        type: "blob"
                      }
                    },
                    event: true
                  },
                  Stats: {
                    type: "structure",
                    members: {
                      Details: {
                        eventpayload: true,
                        type: "structure",
                        members: {
                          BytesScanned: {
                            type: "long"
                          },
                          BytesProcessed: {
                            type: "long"
                          },
                          BytesReturned: {
                            type: "long"
                          }
                        }
                      }
                    },
                    event: true
                  },
                  Progress: {
                    type: "structure",
                    members: {
                      Details: {
                        eventpayload: true,
                        type: "structure",
                        members: {
                          BytesScanned: {
                            type: "long"
                          },
                          BytesProcessed: {
                            type: "long"
                          },
                          BytesReturned: {
                            type: "long"
                          }
                        }
                      }
                    },
                    event: true
                  },
                  Cont: {
                    type: "structure",
                    members: {},
                    event: true
                  },
                  End: {
                    type: "structure",
                    members: {},
                    event: true
                  }
                },
                eventstream: true
              }
            },
            payload: "Payload"
          }
        },
        UploadPart: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}/{Key+}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "Key",
              "PartNumber",
              "UploadId"
            ],
            members: {
              Body: {
                streaming: true,
                type: "blob"
              },
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              ContentLength: {
                location: "header",
                locationName: "Content-Length",
                type: "long"
              },
              ContentMD5: {
                location: "header",
                locationName: "Content-MD5"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              PartNumber: {
                location: "querystring",
                locationName: "partNumber",
                type: "integer"
              },
              UploadId: {
                location: "querystring",
                locationName: "uploadId"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKey: {
                shape: "S1b",
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              }
            },
            payload: "Body"
          },
          output: {
            type: "structure",
            members: {
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              SSEKMSKeyId: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            }
          }
        },
        UploadPartCopy: {
          http: {
            method: "PUT",
            requestUri: "/{Bucket}/{Key+}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket",
              "CopySource",
              "Key",
              "PartNumber",
              "UploadId"
            ],
            members: {
              Bucket: {
                location: "uri",
                locationName: "Bucket"
              },
              CopySource: {
                location: "header",
                locationName: "x-amz-copy-source"
              },
              CopySourceIfMatch: {
                location: "header",
                locationName: "x-amz-copy-source-if-match"
              },
              CopySourceIfModifiedSince: {
                location: "header",
                locationName: "x-amz-copy-source-if-modified-since",
                type: "timestamp"
              },
              CopySourceIfNoneMatch: {
                location: "header",
                locationName: "x-amz-copy-source-if-none-match"
              },
              CopySourceIfUnmodifiedSince: {
                location: "header",
                locationName: "x-amz-copy-source-if-unmodified-since",
                type: "timestamp"
              },
              CopySourceRange: {
                location: "header",
                locationName: "x-amz-copy-source-range"
              },
              Key: {
                location: "uri",
                locationName: "Key"
              },
              PartNumber: {
                location: "querystring",
                locationName: "partNumber",
                type: "integer"
              },
              UploadId: {
                location: "querystring",
                locationName: "uploadId"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKey: {
                shape: "S1b",
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              CopySourceSSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-copy-source-server-side-encryption-customer-algorithm"
              },
              CopySourceSSECustomerKey: {
                shape: "S1f",
                location: "header",
                locationName: "x-amz-copy-source-server-side-encryption-customer-key"
              },
              CopySourceSSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-copy-source-server-side-encryption-customer-key-MD5"
              },
              RequestPayer: {
                location: "header",
                locationName: "x-amz-request-payer"
              },
              ExpectedBucketOwner: {
                location: "header",
                locationName: "x-amz-expected-bucket-owner"
              },
              ExpectedSourceBucketOwner: {
                location: "header",
                locationName: "x-amz-source-expected-bucket-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CopySourceVersionId: {
                location: "header",
                locationName: "x-amz-copy-source-version-id"
              },
              CopyPartResult: {
                type: "structure",
                members: {
                  ETag: {},
                  LastModified: {
                    type: "timestamp"
                  }
                }
              },
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-server-side-encryption"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-algorithm"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-server-side-encryption-customer-key-MD5"
              },
              SSEKMSKeyId: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-server-side-encryption-aws-kms-key-id"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-request-charged"
              }
            },
            payload: "CopyPartResult"
          }
        },
        WriteGetObjectResponse: {
          http: {
            requestUri: "/WriteGetObjectResponse"
          },
          input: {
            type: "structure",
            required: [
              "RequestRoute",
              "RequestToken"
            ],
            members: {
              RequestRoute: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-request-route"
              },
              RequestToken: {
                location: "header",
                locationName: "x-amz-request-token"
              },
              Body: {
                streaming: true,
                type: "blob"
              },
              StatusCode: {
                location: "header",
                locationName: "x-amz-fwd-status",
                type: "integer"
              },
              ErrorCode: {
                location: "header",
                locationName: "x-amz-fwd-error-code"
              },
              ErrorMessage: {
                location: "header",
                locationName: "x-amz-fwd-error-message"
              },
              AcceptRanges: {
                location: "header",
                locationName: "x-amz-fwd-header-accept-ranges"
              },
              CacheControl: {
                location: "header",
                locationName: "x-amz-fwd-header-Cache-Control"
              },
              ContentDisposition: {
                location: "header",
                locationName: "x-amz-fwd-header-Content-Disposition"
              },
              ContentEncoding: {
                location: "header",
                locationName: "x-amz-fwd-header-Content-Encoding"
              },
              ContentLanguage: {
                location: "header",
                locationName: "x-amz-fwd-header-Content-Language"
              },
              ContentLength: {
                location: "header",
                locationName: "Content-Length",
                type: "long"
              },
              ContentRange: {
                location: "header",
                locationName: "x-amz-fwd-header-Content-Range"
              },
              ContentType: {
                location: "header",
                locationName: "x-amz-fwd-header-Content-Type"
              },
              DeleteMarker: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-delete-marker",
                type: "boolean"
              },
              ETag: {
                location: "header",
                locationName: "x-amz-fwd-header-ETag"
              },
              Expires: {
                location: "header",
                locationName: "x-amz-fwd-header-Expires",
                type: "timestamp"
              },
              Expiration: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-expiration"
              },
              LastModified: {
                location: "header",
                locationName: "x-amz-fwd-header-Last-Modified",
                type: "timestamp"
              },
              MissingMeta: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-missing-meta",
                type: "integer"
              },
              Metadata: {
                shape: "S13",
                location: "headers",
                locationName: "x-amz-meta-"
              },
              ObjectLockMode: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-object-lock-mode"
              },
              ObjectLockLegalHoldStatus: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-object-lock-legal-hold"
              },
              ObjectLockRetainUntilDate: {
                shape: "S1j",
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-object-lock-retain-until-date"
              },
              PartsCount: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-mp-parts-count",
                type: "integer"
              },
              ReplicationStatus: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-replication-status"
              },
              RequestCharged: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-request-charged"
              },
              Restore: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-restore"
              },
              ServerSideEncryption: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-server-side-encryption"
              },
              SSECustomerAlgorithm: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-server-side-encryption-customer-algorithm"
              },
              SSEKMSKeyId: {
                shape: "Sk",
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-server-side-encryption-aws-kms-key-id"
              },
              SSECustomerKeyMD5: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-server-side-encryption-customer-key-MD5"
              },
              StorageClass: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-storage-class"
              },
              TagCount: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-tagging-count",
                type: "integer"
              },
              VersionId: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-version-id"
              },
              BucketKeyEnabled: {
                location: "header",
                locationName: "x-amz-fwd-header-x-amz-server-side-encryption-bucket-key-enabled",
                type: "boolean"
              }
            },
            payload: "Body"
          },
          authtype: "v4-unsigned-body",
          endpoint: {
            hostPrefix: "{RequestRoute}."
          }
        }
      },
      shapes: {
        Sk: {
          type: "string",
          sensitive: true
        },
        S13: {
          type: "map",
          key: {},
          value: {}
        },
        S1b: {
          type: "blob",
          sensitive: true
        },
        S1d: {
          type: "string",
          sensitive: true
        },
        S1f: {
          type: "blob",
          sensitive: true
        },
        S1j: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S37: {
          type: "structure",
          members: {
            DisplayName: {},
            ID: {}
          }
        },
        S3a: {
          type: "list",
          member: {
            locationName: "Grant",
            type: "structure",
            members: {
              Grantee: {
                shape: "S3c"
              },
              Permission: {}
            }
          }
        },
        S3c: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            DisplayName: {},
            EmailAddress: {},
            ID: {},
            Type: {
              locationName: "xsi:type",
              xmlAttribute: true
            },
            URI: {}
          },
          xmlNamespace: {
            prefix: "xsi",
            uri: "http://www.w3.org/2001/XMLSchema-instance"
          }
        },
        S3j: {
          type: "structure",
          required: [
            "Id",
            "StorageClassAnalysis"
          ],
          members: {
            Id: {},
            Filter: {
              type: "structure",
              members: {
                Prefix: {},
                Tag: {
                  shape: "S3m"
                },
                And: {
                  type: "structure",
                  members: {
                    Prefix: {},
                    Tags: {
                      shape: "S3p",
                      flattened: true,
                      locationName: "Tag"
                    }
                  }
                }
              }
            },
            StorageClassAnalysis: {
              type: "structure",
              members: {
                DataExport: {
                  type: "structure",
                  required: [
                    "OutputSchemaVersion",
                    "Destination"
                  ],
                  members: {
                    OutputSchemaVersion: {},
                    Destination: {
                      type: "structure",
                      required: [
                        "S3BucketDestination"
                      ],
                      members: {
                        S3BucketDestination: {
                          type: "structure",
                          required: [
                            "Format",
                            "Bucket"
                          ],
                          members: {
                            Format: {},
                            BucketAccountId: {},
                            Bucket: {},
                            Prefix: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S3m: {
          type: "structure",
          required: [
            "Key",
            "Value"
          ],
          members: {
            Key: {},
            Value: {}
          }
        },
        S3p: {
          type: "list",
          member: {
            shape: "S3m",
            locationName: "Tag"
          }
        },
        S3y: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AllowedMethods",
              "AllowedOrigins"
            ],
            members: {
              ID: {},
              AllowedHeaders: {
                locationName: "AllowedHeader",
                type: "list",
                member: {},
                flattened: true
              },
              AllowedMethods: {
                locationName: "AllowedMethod",
                type: "list",
                member: {},
                flattened: true
              },
              AllowedOrigins: {
                locationName: "AllowedOrigin",
                type: "list",
                member: {},
                flattened: true
              },
              ExposeHeaders: {
                locationName: "ExposeHeader",
                type: "list",
                member: {},
                flattened: true
              },
              MaxAgeSeconds: {
                type: "integer"
              }
            }
          },
          flattened: true
        },
        S4b: {
          type: "structure",
          required: [
            "Rules"
          ],
          members: {
            Rules: {
              locationName: "Rule",
              type: "list",
              member: {
                type: "structure",
                members: {
                  ApplyServerSideEncryptionByDefault: {
                    type: "structure",
                    required: [
                      "SSEAlgorithm"
                    ],
                    members: {
                      SSEAlgorithm: {},
                      KMSMasterKeyID: {
                        shape: "Sk"
                      }
                    }
                  },
                  BucketKeyEnabled: {
                    type: "boolean"
                  }
                }
              },
              flattened: true
            }
          }
        },
        S4h: {
          type: "structure",
          required: [
            "Id",
            "Status",
            "Tierings"
          ],
          members: {
            Id: {},
            Filter: {
              type: "structure",
              members: {
                Prefix: {},
                Tag: {
                  shape: "S3m"
                },
                And: {
                  type: "structure",
                  members: {
                    Prefix: {},
                    Tags: {
                      shape: "S3p",
                      flattened: true,
                      locationName: "Tag"
                    }
                  }
                }
              }
            },
            Status: {},
            Tierings: {
              locationName: "Tiering",
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Days",
                  "AccessTier"
                ],
                members: {
                  Days: {
                    type: "integer"
                  },
                  AccessTier: {}
                }
              },
              flattened: true
            }
          }
        },
        S4r: {
          type: "structure",
          required: [
            "Destination",
            "IsEnabled",
            "Id",
            "IncludedObjectVersions",
            "Schedule"
          ],
          members: {
            Destination: {
              type: "structure",
              required: [
                "S3BucketDestination"
              ],
              members: {
                S3BucketDestination: {
                  type: "structure",
                  required: [
                    "Bucket",
                    "Format"
                  ],
                  members: {
                    AccountId: {},
                    Bucket: {},
                    Format: {},
                    Prefix: {},
                    Encryption: {
                      type: "structure",
                      members: {
                        SSES3: {
                          locationName: "SSE-S3",
                          type: "structure",
                          members: {}
                        },
                        SSEKMS: {
                          locationName: "SSE-KMS",
                          type: "structure",
                          required: [
                            "KeyId"
                          ],
                          members: {
                            KeyId: {
                              shape: "Sk"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            IsEnabled: {
              type: "boolean"
            },
            Filter: {
              type: "structure",
              required: [
                "Prefix"
              ],
              members: {
                Prefix: {}
              }
            },
            Id: {},
            IncludedObjectVersions: {},
            OptionalFields: {
              type: "list",
              member: {
                locationName: "Field"
              }
            },
            Schedule: {
              type: "structure",
              required: [
                "Frequency"
              ],
              members: {
                Frequency: {}
              }
            }
          }
        },
        S57: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Prefix",
              "Status"
            ],
            members: {
              Expiration: {
                shape: "S59"
              },
              ID: {},
              Prefix: {},
              Status: {},
              Transition: {
                shape: "S5e"
              },
              NoncurrentVersionTransition: {
                shape: "S5g"
              },
              NoncurrentVersionExpiration: {
                shape: "S5h"
              },
              AbortIncompleteMultipartUpload: {
                shape: "S5i"
              }
            }
          },
          flattened: true
        },
        S59: {
          type: "structure",
          members: {
            Date: {
              shape: "S5a"
            },
            Days: {
              type: "integer"
            },
            ExpiredObjectDeleteMarker: {
              type: "boolean"
            }
          }
        },
        S5a: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S5e: {
          type: "structure",
          members: {
            Date: {
              shape: "S5a"
            },
            Days: {
              type: "integer"
            },
            StorageClass: {}
          }
        },
        S5g: {
          type: "structure",
          members: {
            NoncurrentDays: {
              type: "integer"
            },
            StorageClass: {}
          }
        },
        S5h: {
          type: "structure",
          members: {
            NoncurrentDays: {
              type: "integer"
            }
          }
        },
        S5i: {
          type: "structure",
          members: {
            DaysAfterInitiation: {
              type: "integer"
            }
          }
        },
        S5m: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Expiration: {
                shape: "S59"
              },
              ID: {},
              Prefix: {
                deprecated: true
              },
              Filter: {
                type: "structure",
                members: {
                  Prefix: {},
                  Tag: {
                    shape: "S3m"
                  },
                  And: {
                    type: "structure",
                    members: {
                      Prefix: {},
                      Tags: {
                        shape: "S3p",
                        flattened: true,
                        locationName: "Tag"
                      }
                    }
                  }
                }
              },
              Status: {},
              Transitions: {
                locationName: "Transition",
                type: "list",
                member: {
                  shape: "S5e"
                },
                flattened: true
              },
              NoncurrentVersionTransitions: {
                locationName: "NoncurrentVersionTransition",
                type: "list",
                member: {
                  shape: "S5g"
                },
                flattened: true
              },
              NoncurrentVersionExpiration: {
                shape: "S5h"
              },
              AbortIncompleteMultipartUpload: {
                shape: "S5i"
              }
            }
          },
          flattened: true
        },
        S5w: {
          type: "structure",
          required: [
            "TargetBucket",
            "TargetPrefix"
          ],
          members: {
            TargetBucket: {},
            TargetGrants: {
              type: "list",
              member: {
                locationName: "Grant",
                type: "structure",
                members: {
                  Grantee: {
                    shape: "S3c"
                  },
                  Permission: {}
                }
              }
            },
            TargetPrefix: {}
          }
        },
        S64: {
          type: "structure",
          required: [
            "Id"
          ],
          members: {
            Id: {},
            Filter: {
              type: "structure",
              members: {
                Prefix: {},
                Tag: {
                  shape: "S3m"
                },
                AccessPointArn: {},
                And: {
                  type: "structure",
                  members: {
                    Prefix: {},
                    Tags: {
                      shape: "S3p",
                      flattened: true,
                      locationName: "Tag"
                    },
                    AccessPointArn: {}
                  }
                }
              }
            }
          }
        },
        S68: {
          type: "structure",
          required: [
            "Bucket"
          ],
          members: {
            Bucket: {
              location: "uri",
              locationName: "Bucket"
            },
            ExpectedBucketOwner: {
              location: "header",
              locationName: "x-amz-expected-bucket-owner"
            }
          }
        },
        S69: {
          type: "structure",
          members: {
            TopicConfiguration: {
              type: "structure",
              members: {
                Id: {},
                Events: {
                  shape: "S6c",
                  locationName: "Event"
                },
                Event: {
                  deprecated: true
                },
                Topic: {}
              }
            },
            QueueConfiguration: {
              type: "structure",
              members: {
                Id: {},
                Event: {
                  deprecated: true
                },
                Events: {
                  shape: "S6c",
                  locationName: "Event"
                },
                Queue: {}
              }
            },
            CloudFunctionConfiguration: {
              type: "structure",
              members: {
                Id: {},
                Event: {
                  deprecated: true
                },
                Events: {
                  shape: "S6c",
                  locationName: "Event"
                },
                CloudFunction: {},
                InvocationRole: {}
              }
            }
          }
        },
        S6c: {
          type: "list",
          member: {},
          flattened: true
        },
        S6k: {
          type: "structure",
          members: {
            TopicConfigurations: {
              locationName: "TopicConfiguration",
              type: "list",
              member: {
                type: "structure",
                required: [
                  "TopicArn",
                  "Events"
                ],
                members: {
                  Id: {},
                  TopicArn: {
                    locationName: "Topic"
                  },
                  Events: {
                    shape: "S6c",
                    locationName: "Event"
                  },
                  Filter: {
                    shape: "S6n"
                  }
                }
              },
              flattened: true
            },
            QueueConfigurations: {
              locationName: "QueueConfiguration",
              type: "list",
              member: {
                type: "structure",
                required: [
                  "QueueArn",
                  "Events"
                ],
                members: {
                  Id: {},
                  QueueArn: {
                    locationName: "Queue"
                  },
                  Events: {
                    shape: "S6c",
                    locationName: "Event"
                  },
                  Filter: {
                    shape: "S6n"
                  }
                }
              },
              flattened: true
            },
            LambdaFunctionConfigurations: {
              locationName: "CloudFunctionConfiguration",
              type: "list",
              member: {
                type: "structure",
                required: [
                  "LambdaFunctionArn",
                  "Events"
                ],
                members: {
                  Id: {},
                  LambdaFunctionArn: {
                    locationName: "CloudFunction"
                  },
                  Events: {
                    shape: "S6c",
                    locationName: "Event"
                  },
                  Filter: {
                    shape: "S6n"
                  }
                }
              },
              flattened: true
            }
          }
        },
        S6n: {
          type: "structure",
          members: {
            Key: {
              locationName: "S3Key",
              type: "structure",
              members: {
                FilterRules: {
                  locationName: "FilterRule",
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      Name: {},
                      Value: {}
                    }
                  },
                  flattened: true
                }
              }
            }
          }
        },
        S70: {
          type: "structure",
          required: [
            "Rules"
          ],
          members: {
            Rules: {
              locationName: "Rule",
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ObjectOwnership"
                ],
                members: {
                  ObjectOwnership: {}
                }
              },
              flattened: true
            }
          }
        },
        S7d: {
          type: "structure",
          required: [
            "Role",
            "Rules"
          ],
          members: {
            Role: {},
            Rules: {
              locationName: "Rule",
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Status",
                  "Destination"
                ],
                members: {
                  ID: {},
                  Priority: {
                    type: "integer"
                  },
                  Prefix: {
                    deprecated: true
                  },
                  Filter: {
                    type: "structure",
                    members: {
                      Prefix: {},
                      Tag: {
                        shape: "S3m"
                      },
                      And: {
                        type: "structure",
                        members: {
                          Prefix: {},
                          Tags: {
                            shape: "S3p",
                            flattened: true,
                            locationName: "Tag"
                          }
                        }
                      }
                    }
                  },
                  Status: {},
                  SourceSelectionCriteria: {
                    type: "structure",
                    members: {
                      SseKmsEncryptedObjects: {
                        type: "structure",
                        required: [
                          "Status"
                        ],
                        members: {
                          Status: {}
                        }
                      },
                      ReplicaModifications: {
                        type: "structure",
                        required: [
                          "Status"
                        ],
                        members: {
                          Status: {}
                        }
                      }
                    }
                  },
                  ExistingObjectReplication: {
                    type: "structure",
                    required: [
                      "Status"
                    ],
                    members: {
                      Status: {}
                    }
                  },
                  Destination: {
                    type: "structure",
                    required: [
                      "Bucket"
                    ],
                    members: {
                      Bucket: {},
                      Account: {},
                      StorageClass: {},
                      AccessControlTranslation: {
                        type: "structure",
                        required: [
                          "Owner"
                        ],
                        members: {
                          Owner: {}
                        }
                      },
                      EncryptionConfiguration: {
                        type: "structure",
                        members: {
                          ReplicaKmsKeyID: {}
                        }
                      },
                      ReplicationTime: {
                        type: "structure",
                        required: [
                          "Status",
                          "Time"
                        ],
                        members: {
                          Status: {},
                          Time: {
                            shape: "S7z"
                          }
                        }
                      },
                      Metrics: {
                        type: "structure",
                        required: [
                          "Status"
                        ],
                        members: {
                          Status: {},
                          EventThreshold: {
                            shape: "S7z"
                          }
                        }
                      }
                    }
                  },
                  DeleteMarkerReplication: {
                    type: "structure",
                    members: {
                      Status: {}
                    }
                  }
                }
              },
              flattened: true
            }
          }
        },
        S7z: {
          type: "structure",
          members: {
            Minutes: {
              type: "integer"
            }
          }
        },
        S8g: {
          type: "structure",
          required: [
            "HostName"
          ],
          members: {
            HostName: {},
            Protocol: {}
          }
        },
        S8j: {
          type: "structure",
          required: [
            "Suffix"
          ],
          members: {
            Suffix: {}
          }
        },
        S8l: {
          type: "structure",
          required: [
            "Key"
          ],
          members: {
            Key: {}
          }
        },
        S8m: {
          type: "list",
          member: {
            locationName: "RoutingRule",
            type: "structure",
            required: [
              "Redirect"
            ],
            members: {
              Condition: {
                type: "structure",
                members: {
                  HttpErrorCodeReturnedEquals: {},
                  KeyPrefixEquals: {}
                }
              },
              Redirect: {
                type: "structure",
                members: {
                  HostName: {},
                  HttpRedirectCode: {},
                  Protocol: {},
                  ReplaceKeyPrefixWith: {},
                  ReplaceKeyWith: {}
                }
              }
            }
          }
        },
        S9l: {
          type: "structure",
          members: {
            Status: {}
          }
        },
        S9o: {
          type: "structure",
          members: {
            ObjectLockEnabled: {},
            Rule: {
              type: "structure",
              members: {
                DefaultRetention: {
                  type: "structure",
                  members: {
                    Mode: {},
                    Days: {
                      type: "integer"
                    },
                    Years: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        S9w: {
          type: "structure",
          members: {
            Mode: {},
            RetainUntilDate: {
              shape: "S5a"
            }
          }
        },
        Sa3: {
          type: "structure",
          members: {
            BlockPublicAcls: {
              locationName: "BlockPublicAcls",
              type: "boolean"
            },
            IgnorePublicAcls: {
              locationName: "IgnorePublicAcls",
              type: "boolean"
            },
            BlockPublicPolicy: {
              locationName: "BlockPublicPolicy",
              type: "boolean"
            },
            RestrictPublicBuckets: {
              locationName: "RestrictPublicBuckets",
              type: "boolean"
            }
          }
        },
        Sb4: {
          type: "structure",
          members: {
            ID: {},
            DisplayName: {}
          }
        },
        Sb5: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Prefix: {}
            }
          },
          flattened: true
        },
        Sbn: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              LastModified: {
                type: "timestamp"
              },
              ETag: {},
              Size: {
                type: "integer"
              },
              StorageClass: {},
              Owner: {
                shape: "S37"
              }
            }
          },
          flattened: true
        },
        Sc5: {
          type: "structure",
          members: {
            Grants: {
              shape: "S3a",
              locationName: "AccessControlList"
            },
            Owner: {
              shape: "S37"
            }
          }
        },
        Scu: {
          type: "structure",
          required: [
            "TagSet"
          ],
          members: {
            TagSet: {
              shape: "S3p"
            }
          }
        },
        Sdk: {
          type: "structure",
          members: {
            CSV: {
              type: "structure",
              members: {
                FileHeaderInfo: {},
                Comments: {},
                QuoteEscapeCharacter: {},
                RecordDelimiter: {},
                FieldDelimiter: {},
                QuoteCharacter: {},
                AllowQuotedRecordDelimiter: {
                  type: "boolean"
                }
              }
            },
            CompressionType: {},
            JSON: {
              type: "structure",
              members: {
                Type: {}
              }
            },
            Parquet: {
              type: "structure",
              members: {}
            }
          }
        },
        Sdz: {
          type: "structure",
          members: {
            CSV: {
              type: "structure",
              members: {
                QuoteFields: {},
                QuoteEscapeCharacter: {},
                RecordDelimiter: {},
                FieldDelimiter: {},
                QuoteCharacter: {}
              }
            },
            JSON: {
              type: "structure",
              members: {
                RecordDelimiter: {}
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/s3-2006-03-01.paginators.json
var require_s3_2006_03_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/s3-2006-03-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListBuckets: {
          result_key: "Buckets"
        },
        ListMultipartUploads: {
          input_token: [
            "KeyMarker",
            "UploadIdMarker"
          ],
          limit_key: "MaxUploads",
          more_results: "IsTruncated",
          output_token: [
            "NextKeyMarker",
            "NextUploadIdMarker"
          ],
          result_key: [
            "Uploads",
            "CommonPrefixes"
          ]
        },
        ListObjectVersions: {
          input_token: [
            "KeyMarker",
            "VersionIdMarker"
          ],
          limit_key: "MaxKeys",
          more_results: "IsTruncated",
          output_token: [
            "NextKeyMarker",
            "NextVersionIdMarker"
          ],
          result_key: [
            "Versions",
            "DeleteMarkers",
            "CommonPrefixes"
          ]
        },
        ListObjects: {
          input_token: "Marker",
          limit_key: "MaxKeys",
          more_results: "IsTruncated",
          output_token: "NextMarker || Contents[-1].Key",
          result_key: [
            "Contents",
            "CommonPrefixes"
          ]
        },
        ListObjectsV2: {
          input_token: "ContinuationToken",
          limit_key: "MaxKeys",
          output_token: "NextContinuationToken",
          result_key: [
            "Contents",
            "CommonPrefixes"
          ]
        },
        ListParts: {
          input_token: "PartNumberMarker",
          limit_key: "MaxParts",
          more_results: "IsTruncated",
          output_token: "NextPartNumberMarker",
          result_key: "Parts"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/s3-2006-03-01.waiters2.json
var require_s3_2006_03_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/s3-2006-03-01.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        BucketExists: {
          delay: 5,
          operation: "HeadBucket",
          maxAttempts: 20,
          acceptors: [
            {
              expected: 200,
              matcher: "status",
              state: "success"
            },
            {
              expected: 301,
              matcher: "status",
              state: "success"
            },
            {
              expected: 403,
              matcher: "status",
              state: "success"
            },
            {
              expected: 404,
              matcher: "status",
              state: "retry"
            }
          ]
        },
        BucketNotExists: {
          delay: 5,
          operation: "HeadBucket",
          maxAttempts: 20,
          acceptors: [
            {
              expected: 404,
              matcher: "status",
              state: "success"
            }
          ]
        },
        ObjectExists: {
          delay: 5,
          operation: "HeadObject",
          maxAttempts: 20,
          acceptors: [
            {
              expected: 200,
              matcher: "status",
              state: "success"
            },
            {
              expected: 404,
              matcher: "status",
              state: "retry"
            }
          ]
        },
        ObjectNotExists: {
          delay: 5,
          operation: "HeadObject",
          maxAttempts: 20,
          acceptors: [
            {
              expected: 404,
              matcher: "status",
              state: "success"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/s3.js
var require_s33 = __commonJS({
  "node_modules/aws-sdk/clients/s3.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["s3"] = {};
    AWS3.S3 = Service.defineService("s3", ["2006-03-01"]);
    require_s32();
    Object.defineProperty(apiLoader.services["s3"], "2006-03-01", {
      get: function get() {
        var model = require_s3_2006_03_01_min();
        model.paginators = require_s3_2006_03_01_paginators().pagination;
        model.waiters = require_s3_2006_03_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.S3;
  }
});

// node_modules/aws-sdk/lib/services/s3control.js
var require_s3control = __commonJS({
  "node_modules/aws-sdk/lib/services/s3control.js"() {
    var AWS3 = require_core();
    var s3util = require_s3util();
    var regionUtil = require_region_config();
    AWS3.util.update(AWS3.S3Control.prototype, {
      setupRequestListeners: function setupRequestListeners(request) {
        request.addListener("extractError", this.extractHostId);
        request.addListener("extractData", this.extractHostId);
        request.addListener("validate", this.validateAccountId);
        var isArnInBucket = s3util.isArnInParam(request, "Bucket");
        var isArnInName = s3util.isArnInParam(request, "Name");
        if (isArnInBucket) {
          request._parsedArn = AWS3.util.ARN.parse(request.params["Bucket"]);
          request.addListener("validate", this.validateOutpostsBucketArn);
          request.addListener("validate", s3util.validateOutpostsArn);
          request.addListener("afterBuild", this.addOutpostIdHeader);
        } else if (isArnInName) {
          request._parsedArn = AWS3.util.ARN.parse(request.params["Name"]);
          request.addListener("validate", s3util.validateOutpostsAccessPointArn);
          request.addListener("validate", s3util.validateOutpostsArn);
          request.addListener("afterBuild", this.addOutpostIdHeader);
        }
        if (isArnInBucket || isArnInName) {
          request.addListener("validate", s3util.validateArnRegion);
          request.addListener("validate", this.validateArnAccountWithParams, true);
          request.addListener("validate", s3util.validateArnAccount);
          request.addListener("validate", s3util.validateArnService);
          request.addListener("build", this.populateParamFromArn, true);
          request.addListener("build", this.populateUriFromArn);
          request.addListener("build", s3util.validatePopulateUriFromArn);
        }
        if (request.params.OutpostId && (request.operation === "createBucket" || request.operation === "listRegionalBuckets")) {
          request.addListener("build", this.populateEndpointForOutpostId);
        }
      },
      addOutpostIdHeader: function addOutpostIdHeader(req) {
        req.httpRequest.headers["x-amz-outpost-id"] = req._parsedArn.outpostId;
      },
      validateOutpostsBucketArn: function validateOutpostsBucketArn(req) {
        var parsedArn = req._parsedArn;
        var delimiter = parsedArn.resource["outpost".length];
        if (parsedArn.resource.split(delimiter).length !== 4) {
          throw AWS3.util.error(new Error(), {
            code: "InvalidARN",
            message: "Bucket ARN should have two resources outpost/{outpostId}/bucket/{accesspointName}"
          });
        }
        var bucket = parsedArn.resource.split(delimiter)[3];
        if (!s3util.dnsCompatibleBucketName(bucket) || bucket.match(/\./)) {
          throw AWS3.util.error(new Error(), {
            code: "InvalidARN",
            message: "Bucket ARN is not DNS compatible. Got " + bucket
          });
        }
        req._parsedArn.bucket = bucket;
      },
      populateParamFromArn: function populateParamFromArn(req) {
        var parsedArn = req._parsedArn;
        if (s3util.isArnInParam(req, "Bucket")) {
          req.params.Bucket = parsedArn.bucket;
        } else if (s3util.isArnInParam(req, "Name")) {
          req.params.Name = parsedArn.accessPoint;
        }
      },
      populateUriFromArn: function populateUriFromArn(req) {
        var parsedArn = req._parsedArn;
        var endpoint = req.httpRequest.endpoint;
        var useArnRegion = req.service.config.s3UseArnRegion;
        endpoint.hostname = [
          "s3-outposts",
          useArnRegion ? parsedArn.region : req.service.config.region,
          "amazonaws.com"
        ].join(".");
        endpoint.host = endpoint.hostname;
      },
      populateEndpointForOutpostId: function populateEndpointForOutpostId(req) {
        var endpoint = req.httpRequest.endpoint;
        endpoint.hostname = [
          "s3-outposts",
          req.service.config.region,
          "amazonaws.com"
        ].join(".");
        endpoint.host = endpoint.hostname;
      },
      extractHostId: function(response) {
        var hostId = response.httpResponse.headers ? response.httpResponse.headers["x-amz-id-2"] : null;
        response.extendedRequestId = hostId;
        if (response.error) {
          response.error.extendedRequestId = hostId;
        }
      },
      validateArnAccountWithParams: function validateArnAccountWithParams(req) {
        var params = req.params;
        var inputModel = req.service.api.operations[req.operation].input;
        if (inputModel.members.AccountId) {
          var parsedArn = req._parsedArn;
          if (parsedArn.accountId) {
            if (params.AccountId) {
              if (params.AccountId !== parsedArn.accountId) {
                throw AWS3.util.error(new Error(), { code: "ValidationError", message: "AccountId in ARN and request params should be same." });
              }
            } else {
              params.AccountId = parsedArn.accountId;
            }
          }
        }
      },
      validateAccountId: function(request) {
        var params = request.params;
        if (!Object.prototype.hasOwnProperty.call(params, "AccountId"))
          return;
        var accountId = params.AccountId;
        if (typeof accountId !== "string") {
          throw AWS3.util.error(new Error(), { code: "ValidationError", message: "AccountId must be a string." });
        }
        if (accountId.length < 1 || accountId.length > 63) {
          throw AWS3.util.error(new Error(), { code: "ValidationError", message: "AccountId length should be between 1 to 63 characters, inclusive." });
        }
        var hostPattern = /^[a-zA-Z0-9]{1}$|^[a-zA-Z0-9][a-zA-Z0-9\-]*[a-zA-Z0-9]$/;
        if (!hostPattern.test(accountId)) {
          throw AWS3.util.error(new Error(), { code: "ValidationError", message: "AccountId should be hostname compatible. AccountId: " + accountId });
        }
      },
      getSigningName: function getSigningName(req) {
        var _super = AWS3.Service.prototype.getSigningName;
        if (req && req._parsedArn && req._parsedArn.service) {
          return req._parsedArn.service;
        } else if (req.params.OutpostId && (req.operation === "createBucket" || req.operation === "listRegionalBuckets")) {
          return "s3-outposts";
        } else {
          return _super.call(this, req);
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/s3control-2018-08-20.min.json
var require_s3control_2018_08_20_min = __commonJS({
  "node_modules/aws-sdk/apis/s3control-2018-08-20.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-08-20",
        endpointPrefix: "s3-control",
        protocol: "rest-xml",
        serviceFullName: "AWS S3 Control",
        serviceId: "S3 Control",
        signatureVersion: "s3v4",
        signingName: "s3",
        uid: "s3control-2018-08-20"
      },
      operations: {
        CreateAccessPoint: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/accesspoint/{name}"
          },
          input: {
            locationName: "CreateAccessPointRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "Name",
              "Bucket"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              },
              Bucket: {},
              VpcConfiguration: {
                shape: "S5"
              },
              PublicAccessBlockConfiguration: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessPointArn: {},
              Alias: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        CreateAccessPointForObjectLambda: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/accesspointforobjectlambda/{name}"
          },
          input: {
            locationName: "CreateAccessPointForObjectLambdaRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "Name",
              "Configuration"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              },
              Configuration: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectLambdaAccessPointArn: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        CreateBucket: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/bucket/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Bucket"
            ],
            members: {
              ACL: {
                location: "header",
                locationName: "x-amz-acl"
              },
              Bucket: {
                location: "uri",
                locationName: "name"
              },
              CreateBucketConfiguration: {
                locationName: "CreateBucketConfiguration",
                xmlNamespace: {
                  uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
                },
                type: "structure",
                members: {
                  LocationConstraint: {}
                }
              },
              GrantFullControl: {
                location: "header",
                locationName: "x-amz-grant-full-control"
              },
              GrantRead: {
                location: "header",
                locationName: "x-amz-grant-read"
              },
              GrantReadACP: {
                location: "header",
                locationName: "x-amz-grant-read-acp"
              },
              GrantWrite: {
                location: "header",
                locationName: "x-amz-grant-write"
              },
              GrantWriteACP: {
                location: "header",
                locationName: "x-amz-grant-write-acp"
              },
              ObjectLockEnabledForBucket: {
                location: "header",
                locationName: "x-amz-bucket-object-lock-enabled",
                type: "boolean"
              },
              OutpostId: {
                location: "header",
                locationName: "x-amz-outpost-id"
              }
            },
            payload: "CreateBucketConfiguration"
          },
          output: {
            type: "structure",
            members: {
              Location: {
                location: "header",
                locationName: "Location"
              },
              BucketArn: {}
            }
          },
          httpChecksumRequired: true
        },
        CreateJob: {
          http: {
            requestUri: "/v20180820/jobs"
          },
          input: {
            locationName: "CreateJobRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "Operation",
              "Report",
              "ClientRequestToken",
              "Manifest",
              "Priority",
              "RoleArn"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              ConfirmationRequired: {
                type: "boolean"
              },
              Operation: {
                shape: "S19"
              },
              Report: {
                shape: "S2e"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Manifest: {
                shape: "S2i"
              },
              Description: {},
              Priority: {
                type: "integer"
              },
              RoleArn: {},
              Tags: {
                shape: "S1r"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        CreateMultiRegionAccessPoint: {
          http: {
            requestUri: "/v20180820/async-requests/mrap/create"
          },
          input: {
            locationName: "CreateMultiRegionAccessPointRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "ClientToken",
              "Details"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Details: {
                shape: "S2x"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestTokenARN: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true
        },
        DeleteAccessPoint: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/accesspoint/{name}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        DeleteAccessPointForObjectLambda: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/accesspointforobjectlambda/{name}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        DeleteAccessPointPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/accesspoint/{name}/policy"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        DeleteAccessPointPolicyForObjectLambda: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/accesspointforobjectlambda/{name}/policy"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        DeleteBucket: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/bucket/{name}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        DeleteBucketLifecycleConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/bucket/{name}/lifecycleconfiguration"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        DeleteBucketPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/bucket/{name}/policy"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        DeleteBucketTagging: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/bucket/{name}/tagging",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        DeleteJobTagging: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/jobs/{id}/tagging"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "JobId"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              JobId: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        DeleteMultiRegionAccessPoint: {
          http: {
            requestUri: "/v20180820/async-requests/mrap/delete"
          },
          input: {
            locationName: "DeleteMultiRegionAccessPointRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "ClientToken",
              "Details"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Details: {
                shape: "S3e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestTokenARN: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true
        },
        DeletePublicAccessBlock: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/configuration/publicAccessBlock"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        DeleteStorageLensConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/storagelens/{storagelensid}"
          },
          input: {
            type: "structure",
            required: [
              "ConfigId",
              "AccountId"
            ],
            members: {
              ConfigId: {
                location: "uri",
                locationName: "storagelensid"
              },
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        DeleteStorageLensConfigurationTagging: {
          http: {
            method: "DELETE",
            requestUri: "/v20180820/storagelens/{storagelensid}/tagging"
          },
          input: {
            type: "structure",
            required: [
              "ConfigId",
              "AccountId"
            ],
            members: {
              ConfigId: {
                location: "uri",
                locationName: "storagelensid"
              },
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        DescribeJob: {
          http: {
            method: "GET",
            requestUri: "/v20180820/jobs/{id}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "JobId"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              JobId: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Job: {
                type: "structure",
                members: {
                  JobId: {},
                  ConfirmationRequired: {
                    type: "boolean"
                  },
                  Description: {},
                  JobArn: {},
                  Status: {},
                  Manifest: {
                    shape: "S2i"
                  },
                  Operation: {
                    shape: "S19"
                  },
                  Priority: {
                    type: "integer"
                  },
                  ProgressSummary: {
                    shape: "S3q"
                  },
                  StatusUpdateReason: {},
                  FailureReasons: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        FailureCode: {},
                        FailureReason: {}
                      }
                    }
                  },
                  Report: {
                    shape: "S2e"
                  },
                  CreationTime: {
                    type: "timestamp"
                  },
                  TerminationDate: {
                    type: "timestamp"
                  },
                  RoleArn: {},
                  SuspendedDate: {
                    type: "timestamp"
                  },
                  SuspendedCause: {}
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        DescribeMultiRegionAccessPointOperation: {
          http: {
            method: "GET",
            requestUri: "/v20180820/async-requests/mrap/{request_token+}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RequestTokenARN"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              RequestTokenARN: {
                location: "uri",
                locationName: "request_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AsyncOperation: {
                type: "structure",
                members: {
                  CreationTime: {
                    type: "timestamp"
                  },
                  Operation: {},
                  RequestTokenARN: {},
                  RequestParameters: {
                    type: "structure",
                    members: {
                      CreateMultiRegionAccessPointRequest: {
                        shape: "S2x"
                      },
                      DeleteMultiRegionAccessPointRequest: {
                        shape: "S3e"
                      },
                      PutMultiRegionAccessPointPolicyRequest: {
                        shape: "S49"
                      }
                    }
                  },
                  RequestStatus: {},
                  ResponseDetails: {
                    type: "structure",
                    members: {
                      MultiRegionAccessPointDetails: {
                        type: "structure",
                        members: {
                          Regions: {
                            type: "list",
                            member: {
                              locationName: "Region",
                              type: "structure",
                              members: {
                                Name: {},
                                RequestStatus: {}
                              }
                            }
                          }
                        }
                      },
                      ErrorDetails: {
                        type: "structure",
                        members: {
                          Code: {},
                          Message: {},
                          Resource: {},
                          RequestId: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true
        },
        GetAccessPoint: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accesspoint/{name}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Bucket: {},
              NetworkOrigin: {},
              VpcConfiguration: {
                shape: "S5"
              },
              PublicAccessBlockConfiguration: {
                shape: "S7"
              },
              CreationDate: {
                type: "timestamp"
              },
              Alias: {},
              AccessPointArn: {},
              Endpoints: {
                type: "map",
                key: {},
                value: {}
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        GetAccessPointConfigurationForObjectLambda: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accesspointforobjectlambda/{name}/configuration"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Configuration: {
                shape: "Se"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        GetAccessPointForObjectLambda: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accesspointforobjectlambda/{name}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              PublicAccessBlockConfiguration: {
                shape: "S7"
              },
              CreationDate: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        GetAccessPointPolicy: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accesspoint/{name}/policy"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        GetAccessPointPolicyForObjectLambda: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accesspointforobjectlambda/{name}/policy"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        GetAccessPointPolicyStatus: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accesspoint/{name}/policyStatus"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyStatus: {
                shape: "S4y"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        GetAccessPointPolicyStatusForObjectLambda: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accesspointforobjectlambda/{name}/policyStatus"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyStatus: {
                shape: "S4y"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        GetBucket: {
          http: {
            method: "GET",
            requestUri: "/v20180820/bucket/{name}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Bucket: {},
              PublicAccessBlockEnabled: {
                type: "boolean"
              },
              CreationDate: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        GetBucketLifecycleConfiguration: {
          http: {
            method: "GET",
            requestUri: "/v20180820/bucket/{name}/lifecycleconfiguration"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rules: {
                shape: "S57"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        GetBucketPolicy: {
          http: {
            method: "GET",
            requestUri: "/v20180820/bucket/{name}/policy"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        GetBucketTagging: {
          http: {
            method: "GET",
            requestUri: "/v20180820/bucket/{name}/tagging"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TagSet"
            ],
            members: {
              TagSet: {
                shape: "S1r"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        GetJobTagging: {
          http: {
            method: "GET",
            requestUri: "/v20180820/jobs/{id}/tagging"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "JobId"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              JobId: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S1r"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        GetMultiRegionAccessPoint: {
          http: {
            method: "GET",
            requestUri: "/v20180820/mrap/instances/{name}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessPoint: {
                shape: "S5y"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true
        },
        GetMultiRegionAccessPointPolicy: {
          http: {
            method: "GET",
            requestUri: "/v20180820/mrap/instances/{name}/policy"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                type: "structure",
                members: {
                  Established: {
                    type: "structure",
                    members: {
                      Policy: {}
                    }
                  },
                  Proposed: {
                    type: "structure",
                    members: {
                      Policy: {}
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true
        },
        GetMultiRegionAccessPointPolicyStatus: {
          http: {
            method: "GET",
            requestUri: "/v20180820/mrap/instances/{name}/policystatus"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Established: {
                shape: "S4y"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true
        },
        GetPublicAccessBlock: {
          http: {
            method: "GET",
            requestUri: "/v20180820/configuration/publicAccessBlock"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PublicAccessBlockConfiguration: {
                shape: "S7"
              }
            },
            payload: "PublicAccessBlockConfiguration"
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        GetStorageLensConfiguration: {
          http: {
            method: "GET",
            requestUri: "/v20180820/storagelens/{storagelensid}"
          },
          input: {
            type: "structure",
            required: [
              "ConfigId",
              "AccountId"
            ],
            members: {
              ConfigId: {
                location: "uri",
                locationName: "storagelensid"
              },
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StorageLensConfiguration: {
                shape: "S6f"
              }
            },
            payload: "StorageLensConfiguration"
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        GetStorageLensConfigurationTagging: {
          http: {
            method: "GET",
            requestUri: "/v20180820/storagelens/{storagelensid}/tagging"
          },
          input: {
            type: "structure",
            required: [
              "ConfigId",
              "AccountId"
            ],
            members: {
              ConfigId: {
                location: "uri",
                locationName: "storagelensid"
              },
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S78"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        ListAccessPoints: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accesspoint"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                location: "querystring",
                locationName: "bucket"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessPointList: {
                type: "list",
                member: {
                  locationName: "AccessPoint",
                  type: "structure",
                  required: [
                    "Name",
                    "NetworkOrigin",
                    "Bucket"
                  ],
                  members: {
                    Name: {},
                    NetworkOrigin: {},
                    VpcConfiguration: {
                      shape: "S5"
                    },
                    Bucket: {},
                    AccessPointArn: {},
                    Alias: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        ListAccessPointsForObjectLambda: {
          http: {
            method: "GET",
            requestUri: "/v20180820/accesspointforobjectlambda"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ObjectLambdaAccessPointList: {
                type: "list",
                member: {
                  locationName: "ObjectLambdaAccessPoint",
                  type: "structure",
                  required: [
                    "Name"
                  ],
                  members: {
                    Name: {},
                    ObjectLambdaAccessPointArn: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        ListJobs: {
          http: {
            method: "GET",
            requestUri: "/v20180820/jobs"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              JobStatuses: {
                location: "querystring",
                locationName: "jobStatuses",
                type: "list",
                member: {}
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Jobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    JobId: {},
                    Description: {},
                    Operation: {},
                    Priority: {
                      type: "integer"
                    },
                    Status: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    TerminationDate: {
                      type: "timestamp"
                    },
                    ProgressSummary: {
                      shape: "S3q"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        ListMultiRegionAccessPoints: {
          http: {
            method: "GET",
            requestUri: "/v20180820/mrap/instances"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessPoints: {
                type: "list",
                member: {
                  shape: "S5y",
                  locationName: "AccessPoint"
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true
        },
        ListRegionalBuckets: {
          http: {
            method: "GET",
            requestUri: "/v20180820/bucket"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              OutpostId: {
                location: "header",
                locationName: "x-amz-outpost-id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RegionalBucketList: {
                type: "list",
                member: {
                  locationName: "RegionalBucket",
                  type: "structure",
                  required: [
                    "Bucket",
                    "PublicAccessBlockEnabled",
                    "CreationDate"
                  ],
                  members: {
                    Bucket: {},
                    BucketArn: {},
                    PublicAccessBlockEnabled: {
                      type: "boolean"
                    },
                    CreationDate: {
                      type: "timestamp"
                    },
                    OutpostId: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        ListStorageLensConfigurations: {
          http: {
            method: "GET",
            requestUri: "/v20180820/storagelens"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              StorageLensConfigurationList: {
                type: "list",
                member: {
                  locationName: "StorageLensConfiguration",
                  type: "structure",
                  required: [
                    "Id",
                    "StorageLensArn",
                    "HomeRegion"
                  ],
                  members: {
                    Id: {},
                    StorageLensArn: {},
                    HomeRegion: {},
                    IsEnabled: {
                      type: "boolean"
                    }
                  }
                },
                flattened: true
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        PutAccessPointConfigurationForObjectLambda: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/accesspointforobjectlambda/{name}/configuration"
          },
          input: {
            locationName: "PutAccessPointConfigurationForObjectLambdaRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "Name",
              "Configuration"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              },
              Configuration: {
                shape: "Se"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        PutAccessPointPolicy: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/accesspoint/{name}/policy"
          },
          input: {
            locationName: "PutAccessPointPolicyRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "Name",
              "Policy"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              },
              Policy: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        PutAccessPointPolicyForObjectLambda: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/accesspointforobjectlambda/{name}/policy"
          },
          input: {
            locationName: "PutAccessPointPolicyForObjectLambdaRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "Name",
              "Policy"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Name: {
                location: "uri",
                locationName: "name"
              },
              Policy: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        PutBucketLifecycleConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/bucket/{name}/lifecycleconfiguration"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                location: "uri",
                locationName: "name"
              },
              LifecycleConfiguration: {
                locationName: "LifecycleConfiguration",
                xmlNamespace: {
                  uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
                },
                type: "structure",
                members: {
                  Rules: {
                    shape: "S57"
                  }
                }
              }
            },
            payload: "LifecycleConfiguration"
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true
        },
        PutBucketPolicy: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/bucket/{name}/policy"
          },
          input: {
            locationName: "PutBucketPolicyRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "Bucket",
              "Policy"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                location: "uri",
                locationName: "name"
              },
              ConfirmRemoveSelfBucketAccess: {
                location: "header",
                locationName: "x-amz-confirm-remove-self-bucket-access",
                type: "boolean"
              },
              Policy: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true
        },
        PutBucketTagging: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/bucket/{name}/tagging"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Bucket",
              "Tagging"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Bucket: {
                location: "uri",
                locationName: "name"
              },
              Tagging: {
                locationName: "Tagging",
                xmlNamespace: {
                  uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
                },
                type: "structure",
                required: [
                  "TagSet"
                ],
                members: {
                  TagSet: {
                    shape: "S1r"
                  }
                }
              }
            },
            payload: "Tagging"
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true
        },
        PutJobTagging: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/jobs/{id}/tagging"
          },
          input: {
            locationName: "PutJobTaggingRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "JobId",
              "Tags"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              JobId: {
                location: "uri",
                locationName: "id"
              },
              Tags: {
                shape: "S1r"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        PutMultiRegionAccessPointPolicy: {
          http: {
            requestUri: "/v20180820/async-requests/mrap/put-policy"
          },
          input: {
            locationName: "PutMultiRegionAccessPointPolicyRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "AccountId",
              "ClientToken",
              "Details"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Details: {
                shape: "S49"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestTokenARN: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          },
          httpChecksumRequired: true
        },
        PutPublicAccessBlock: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/configuration/publicAccessBlock"
          },
          input: {
            type: "structure",
            required: [
              "PublicAccessBlockConfiguration",
              "AccountId"
            ],
            members: {
              PublicAccessBlockConfiguration: {
                shape: "S7",
                locationName: "PublicAccessBlockConfiguration",
                xmlNamespace: {
                  uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
                }
              },
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              }
            },
            payload: "PublicAccessBlockConfiguration"
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        PutStorageLensConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/storagelens/{storagelensid}"
          },
          input: {
            locationName: "PutStorageLensConfigurationRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "ConfigId",
              "AccountId",
              "StorageLensConfiguration"
            ],
            members: {
              ConfigId: {
                location: "uri",
                locationName: "storagelensid"
              },
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              StorageLensConfiguration: {
                shape: "S6f"
              },
              Tags: {
                shape: "S78"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        PutStorageLensConfigurationTagging: {
          http: {
            method: "PUT",
            requestUri: "/v20180820/storagelens/{storagelensid}/tagging"
          },
          input: {
            locationName: "PutStorageLensConfigurationTaggingRequest",
            xmlNamespace: {
              uri: "http://awss3control.amazonaws.com/doc/2018-08-20/"
            },
            type: "structure",
            required: [
              "ConfigId",
              "AccountId",
              "Tags"
            ],
            members: {
              ConfigId: {
                location: "uri",
                locationName: "storagelensid"
              },
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              Tags: {
                shape: "S78"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        UpdateJobPriority: {
          http: {
            requestUri: "/v20180820/jobs/{id}/priority"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "JobId",
              "Priority"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              JobId: {
                location: "uri",
                locationName: "id"
              },
              Priority: {
                location: "querystring",
                locationName: "priority",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobId",
              "Priority"
            ],
            members: {
              JobId: {},
              Priority: {
                type: "integer"
              }
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        },
        UpdateJobStatus: {
          http: {
            requestUri: "/v20180820/jobs/{id}/status"
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "JobId",
              "RequestedJobStatus"
            ],
            members: {
              AccountId: {
                hostLabel: true,
                location: "header",
                locationName: "x-amz-account-id"
              },
              JobId: {
                location: "uri",
                locationName: "id"
              },
              RequestedJobStatus: {
                location: "querystring",
                locationName: "requestedJobStatus"
              },
              StatusUpdateReason: {
                location: "querystring",
                locationName: "statusUpdateReason"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              Status: {},
              StatusUpdateReason: {}
            }
          },
          endpoint: {
            hostPrefix: "{AccountId}."
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          required: [
            "VpcId"
          ],
          members: {
            VpcId: {}
          }
        },
        S7: {
          type: "structure",
          members: {
            BlockPublicAcls: {
              locationName: "BlockPublicAcls",
              type: "boolean"
            },
            IgnorePublicAcls: {
              locationName: "IgnorePublicAcls",
              type: "boolean"
            },
            BlockPublicPolicy: {
              locationName: "BlockPublicPolicy",
              type: "boolean"
            },
            RestrictPublicBuckets: {
              locationName: "RestrictPublicBuckets",
              type: "boolean"
            }
          }
        },
        Se: {
          type: "structure",
          required: [
            "SupportingAccessPoint",
            "TransformationConfigurations"
          ],
          members: {
            SupportingAccessPoint: {},
            CloudWatchMetricsEnabled: {
              type: "boolean"
            },
            AllowedFeatures: {
              type: "list",
              member: {
                locationName: "AllowedFeature"
              }
            },
            TransformationConfigurations: {
              type: "list",
              member: {
                locationName: "TransformationConfiguration",
                type: "structure",
                required: [
                  "Actions",
                  "ContentTransformation"
                ],
                members: {
                  Actions: {
                    type: "list",
                    member: {
                      locationName: "Action"
                    }
                  },
                  ContentTransformation: {
                    type: "structure",
                    members: {
                      AwsLambda: {
                        type: "structure",
                        required: [
                          "FunctionArn"
                        ],
                        members: {
                          FunctionArn: {},
                          FunctionPayload: {}
                        }
                      }
                    },
                    union: true
                  }
                }
              }
            }
          }
        },
        S19: {
          type: "structure",
          members: {
            LambdaInvoke: {
              type: "structure",
              members: {
                FunctionArn: {}
              }
            },
            S3PutObjectCopy: {
              type: "structure",
              members: {
                TargetResource: {},
                CannedAccessControlList: {},
                AccessControlGrants: {
                  shape: "S1e"
                },
                MetadataDirective: {},
                ModifiedSinceConstraint: {
                  type: "timestamp"
                },
                NewObjectMetadata: {
                  type: "structure",
                  members: {
                    CacheControl: {},
                    ContentDisposition: {},
                    ContentEncoding: {},
                    ContentLanguage: {},
                    UserMetadata: {
                      type: "map",
                      key: {},
                      value: {}
                    },
                    ContentLength: {
                      type: "long"
                    },
                    ContentMD5: {},
                    ContentType: {},
                    HttpExpiresDate: {
                      type: "timestamp"
                    },
                    RequesterCharged: {
                      type: "boolean"
                    },
                    SSEAlgorithm: {}
                  }
                },
                NewObjectTagging: {
                  shape: "S1r"
                },
                RedirectLocation: {},
                RequesterPays: {
                  type: "boolean"
                },
                StorageClass: {},
                UnModifiedSinceConstraint: {
                  type: "timestamp"
                },
                SSEAwsKmsKeyId: {},
                TargetKeyPrefix: {},
                ObjectLockLegalHoldStatus: {},
                ObjectLockMode: {},
                ObjectLockRetainUntilDate: {
                  type: "timestamp"
                },
                BucketKeyEnabled: {
                  type: "boolean"
                }
              }
            },
            S3PutObjectAcl: {
              type: "structure",
              members: {
                AccessControlPolicy: {
                  type: "structure",
                  members: {
                    AccessControlList: {
                      type: "structure",
                      required: [
                        "Owner"
                      ],
                      members: {
                        Owner: {
                          type: "structure",
                          members: {
                            ID: {},
                            DisplayName: {}
                          }
                        },
                        Grants: {
                          shape: "S1e"
                        }
                      }
                    },
                    CannedAccessControlList: {}
                  }
                }
              }
            },
            S3PutObjectTagging: {
              type: "structure",
              members: {
                TagSet: {
                  shape: "S1r"
                }
              }
            },
            S3DeleteObjectTagging: {
              type: "structure",
              members: {}
            },
            S3InitiateRestoreObject: {
              type: "structure",
              members: {
                ExpirationInDays: {
                  type: "integer"
                },
                GlacierJobTier: {}
              }
            },
            S3PutObjectLegalHold: {
              type: "structure",
              required: [
                "LegalHold"
              ],
              members: {
                LegalHold: {
                  type: "structure",
                  required: [
                    "Status"
                  ],
                  members: {
                    Status: {}
                  }
                }
              }
            },
            S3PutObjectRetention: {
              type: "structure",
              required: [
                "Retention"
              ],
              members: {
                BypassGovernanceRetention: {
                  type: "boolean"
                },
                Retention: {
                  type: "structure",
                  members: {
                    RetainUntilDate: {
                      type: "timestamp"
                    },
                    Mode: {}
                  }
                }
              }
            }
          }
        },
        S1e: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Grantee: {
                type: "structure",
                members: {
                  TypeIdentifier: {},
                  Identifier: {},
                  DisplayName: {}
                }
              },
              Permission: {}
            }
          }
        },
        S1r: {
          type: "list",
          member: {
            shape: "S1s"
          }
        },
        S1s: {
          type: "structure",
          required: [
            "Key",
            "Value"
          ],
          members: {
            Key: {},
            Value: {}
          }
        },
        S2e: {
          type: "structure",
          required: [
            "Enabled"
          ],
          members: {
            Bucket: {},
            Format: {},
            Enabled: {
              type: "boolean"
            },
            Prefix: {},
            ReportScope: {}
          }
        },
        S2i: {
          type: "structure",
          required: [
            "Spec",
            "Location"
          ],
          members: {
            Spec: {
              type: "structure",
              required: [
                "Format"
              ],
              members: {
                Format: {},
                Fields: {
                  type: "list",
                  member: {}
                }
              }
            },
            Location: {
              type: "structure",
              required: [
                "ObjectArn",
                "ETag"
              ],
              members: {
                ObjectArn: {},
                ObjectVersionId: {},
                ETag: {}
              }
            }
          }
        },
        S2x: {
          type: "structure",
          required: [
            "Name",
            "Regions"
          ],
          members: {
            Name: {},
            PublicAccessBlock: {
              shape: "S7"
            },
            Regions: {
              type: "list",
              member: {
                locationName: "Region",
                type: "structure",
                required: [
                  "Bucket"
                ],
                members: {
                  Bucket: {}
                }
              }
            }
          }
        },
        S3e: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {}
          }
        },
        S3q: {
          type: "structure",
          members: {
            TotalNumberOfTasks: {
              type: "long"
            },
            NumberOfTasksSucceeded: {
              type: "long"
            },
            NumberOfTasksFailed: {
              type: "long"
            }
          }
        },
        S49: {
          type: "structure",
          required: [
            "Name",
            "Policy"
          ],
          members: {
            Name: {},
            Policy: {}
          }
        },
        S4y: {
          type: "structure",
          members: {
            IsPublic: {
              locationName: "IsPublic",
              type: "boolean"
            }
          }
        },
        S57: {
          type: "list",
          member: {
            locationName: "Rule",
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Expiration: {
                type: "structure",
                members: {
                  Date: {
                    type: "timestamp"
                  },
                  Days: {
                    type: "integer"
                  },
                  ExpiredObjectDeleteMarker: {
                    type: "boolean"
                  }
                }
              },
              ID: {},
              Filter: {
                type: "structure",
                members: {
                  Prefix: {},
                  Tag: {
                    shape: "S1s"
                  },
                  And: {
                    type: "structure",
                    members: {
                      Prefix: {},
                      Tags: {
                        shape: "S1r"
                      }
                    }
                  }
                }
              },
              Status: {},
              Transitions: {
                type: "list",
                member: {
                  locationName: "Transition",
                  type: "structure",
                  members: {
                    Date: {
                      type: "timestamp"
                    },
                    Days: {
                      type: "integer"
                    },
                    StorageClass: {}
                  }
                }
              },
              NoncurrentVersionTransitions: {
                type: "list",
                member: {
                  locationName: "NoncurrentVersionTransition",
                  type: "structure",
                  members: {
                    NoncurrentDays: {
                      type: "integer"
                    },
                    StorageClass: {}
                  }
                }
              },
              NoncurrentVersionExpiration: {
                type: "structure",
                members: {
                  NoncurrentDays: {
                    type: "integer"
                  }
                }
              },
              AbortIncompleteMultipartUpload: {
                type: "structure",
                members: {
                  DaysAfterInitiation: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        S5y: {
          type: "structure",
          members: {
            Name: {},
            Alias: {},
            CreatedAt: {
              type: "timestamp"
            },
            PublicAccessBlock: {
              shape: "S7"
            },
            Status: {},
            Regions: {
              type: "list",
              member: {
                locationName: "Region",
                type: "structure",
                members: {
                  Bucket: {},
                  Region: {}
                }
              }
            }
          }
        },
        S6f: {
          type: "structure",
          required: [
            "Id",
            "AccountLevel",
            "IsEnabled"
          ],
          members: {
            Id: {},
            AccountLevel: {
              type: "structure",
              required: [
                "BucketLevel"
              ],
              members: {
                ActivityMetrics: {
                  shape: "S6h"
                },
                BucketLevel: {
                  type: "structure",
                  members: {
                    ActivityMetrics: {
                      shape: "S6h"
                    },
                    PrefixLevel: {
                      type: "structure",
                      required: [
                        "StorageMetrics"
                      ],
                      members: {
                        StorageMetrics: {
                          type: "structure",
                          members: {
                            IsEnabled: {
                              type: "boolean"
                            },
                            SelectionCriteria: {
                              type: "structure",
                              members: {
                                Delimiter: {},
                                MaxDepth: {
                                  type: "integer"
                                },
                                MinStorageBytesPercentage: {
                                  type: "double"
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            Include: {
              type: "structure",
              members: {
                Buckets: {
                  shape: "S6r"
                },
                Regions: {
                  shape: "S6s"
                }
              }
            },
            Exclude: {
              type: "structure",
              members: {
                Buckets: {
                  shape: "S6r"
                },
                Regions: {
                  shape: "S6s"
                }
              }
            },
            DataExport: {
              type: "structure",
              required: [
                "S3BucketDestination"
              ],
              members: {
                S3BucketDestination: {
                  type: "structure",
                  required: [
                    "Format",
                    "OutputSchemaVersion",
                    "AccountId",
                    "Arn"
                  ],
                  members: {
                    Format: {},
                    OutputSchemaVersion: {},
                    AccountId: {},
                    Arn: {},
                    Prefix: {},
                    Encryption: {
                      type: "structure",
                      members: {
                        SSES3: {
                          locationName: "SSE-S3",
                          type: "structure",
                          members: {}
                        },
                        SSEKMS: {
                          locationName: "SSE-KMS",
                          type: "structure",
                          required: [
                            "KeyId"
                          ],
                          members: {
                            KeyId: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            IsEnabled: {
              type: "boolean"
            },
            AwsOrg: {
              type: "structure",
              required: [
                "Arn"
              ],
              members: {
                Arn: {}
              }
            },
            StorageLensArn: {}
          }
        },
        S6h: {
          type: "structure",
          members: {
            IsEnabled: {
              type: "boolean"
            }
          }
        },
        S6r: {
          type: "list",
          member: {
            locationName: "Arn"
          }
        },
        S6s: {
          type: "list",
          member: {
            locationName: "Region"
          }
        },
        S78: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/s3control-2018-08-20.paginators.json
var require_s3control_2018_08_20_paginators = __commonJS({
  "node_modules/aws-sdk/apis/s3control-2018-08-20.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAccessPoints: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAccessPointsForObjectLambda: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ObjectLambdaAccessPointList"
        },
        ListJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMultiRegionAccessPoints: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListRegionalBuckets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListStorageLensConfigurations: {
          input_token: "NextToken",
          output_token: "NextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/s3control.js
var require_s3control2 = __commonJS({
  "node_modules/aws-sdk/clients/s3control.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["s3control"] = {};
    AWS3.S3Control = Service.defineService("s3control", ["2018-08-20"]);
    require_s3control();
    Object.defineProperty(apiLoader.services["s3control"], "2018-08-20", {
      get: function get() {
        var model = require_s3control_2018_08_20_min();
        model.paginators = require_s3control_2018_08_20_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.S3Control;
  }
});

// node_modules/aws-sdk/apis/servicecatalog-2015-12-10.min.json
var require_servicecatalog_2015_12_10_min = __commonJS({
  "node_modules/aws-sdk/apis/servicecatalog-2015-12-10.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-12-10",
        endpointPrefix: "servicecatalog",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Service Catalog",
        serviceId: "Service Catalog",
        signatureVersion: "v4",
        targetPrefix: "AWS242ServiceCatalogService",
        uid: "servicecatalog-2015-12-10"
      },
      operations: {
        AcceptPortfolioShare: {
          input: {
            type: "structure",
            required: [
              "PortfolioId"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              PortfolioShareType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateBudgetWithResource: {
          input: {
            type: "structure",
            required: [
              "BudgetName",
              "ResourceId"
            ],
            members: {
              BudgetName: {},
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociatePrincipalWithPortfolio: {
          input: {
            type: "structure",
            required: [
              "PortfolioId",
              "PrincipalARN",
              "PrincipalType"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              PrincipalARN: {},
              PrincipalType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateProductWithPortfolio: {
          input: {
            type: "structure",
            required: [
              "ProductId",
              "PortfolioId"
            ],
            members: {
              AcceptLanguage: {},
              ProductId: {},
              PortfolioId: {},
              SourcePortfolioId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateServiceActionWithProvisioningArtifact: {
          input: {
            type: "structure",
            required: [
              "ProductId",
              "ProvisioningArtifactId",
              "ServiceActionId"
            ],
            members: {
              ProductId: {},
              ProvisioningArtifactId: {},
              ServiceActionId: {},
              AcceptLanguage: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateTagOptionWithResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "TagOptionId"
            ],
            members: {
              ResourceId: {},
              TagOptionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        BatchAssociateServiceActionWithProvisioningArtifact: {
          input: {
            type: "structure",
            required: [
              "ServiceActionAssociations"
            ],
            members: {
              ServiceActionAssociations: {
                shape: "Sm"
              },
              AcceptLanguage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FailedServiceActionAssociations: {
                shape: "Sp"
              }
            }
          }
        },
        BatchDisassociateServiceActionFromProvisioningArtifact: {
          input: {
            type: "structure",
            required: [
              "ServiceActionAssociations"
            ],
            members: {
              ServiceActionAssociations: {
                shape: "Sm"
              },
              AcceptLanguage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FailedServiceActionAssociations: {
                shape: "Sp"
              }
            }
          }
        },
        CopyProduct: {
          input: {
            type: "structure",
            required: [
              "SourceProductArn",
              "IdempotencyToken"
            ],
            members: {
              AcceptLanguage: {},
              SourceProductArn: {},
              TargetProductId: {},
              TargetProductName: {},
              SourceProvisioningArtifactIdentifiers: {
                type: "list",
                member: {
                  type: "map",
                  key: {},
                  value: {}
                }
              },
              CopyOptions: {
                type: "list",
                member: {}
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CopyProductToken: {}
            }
          }
        },
        CreateConstraint: {
          input: {
            type: "structure",
            required: [
              "PortfolioId",
              "ProductId",
              "Parameters",
              "Type",
              "IdempotencyToken"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              ProductId: {},
              Parameters: {},
              Type: {},
              Description: {},
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConstraintDetail: {
                shape: "S1b"
              },
              ConstraintParameters: {},
              Status: {}
            }
          }
        },
        CreatePortfolio: {
          input: {
            type: "structure",
            required: [
              "DisplayName",
              "ProviderName",
              "IdempotencyToken"
            ],
            members: {
              AcceptLanguage: {},
              DisplayName: {},
              Description: {},
              ProviderName: {},
              Tags: {
                shape: "S1i"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PortfolioDetail: {
                shape: "S1n"
              },
              Tags: {
                shape: "S1q"
              }
            }
          }
        },
        CreatePortfolioShare: {
          input: {
            type: "structure",
            required: [
              "PortfolioId"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              AccountId: {},
              OrganizationNode: {
                shape: "S1s"
              },
              ShareTagOptions: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PortfolioShareToken: {}
            }
          }
        },
        CreateProduct: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Owner",
              "ProductType",
              "ProvisioningArtifactParameters",
              "IdempotencyToken"
            ],
            members: {
              AcceptLanguage: {},
              Name: {},
              Owner: {},
              Description: {},
              Distributor: {},
              SupportDescription: {},
              SupportEmail: {},
              SupportUrl: {},
              ProductType: {},
              Tags: {
                shape: "S1i"
              },
              ProvisioningArtifactParameters: {
                shape: "S24"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProductViewDetail: {
                shape: "S2d"
              },
              ProvisioningArtifactDetail: {
                shape: "S2i"
              },
              Tags: {
                shape: "S1q"
              }
            }
          }
        },
        CreateProvisionedProductPlan: {
          input: {
            type: "structure",
            required: [
              "PlanName",
              "PlanType",
              "ProductId",
              "ProvisionedProductName",
              "ProvisioningArtifactId",
              "IdempotencyToken"
            ],
            members: {
              AcceptLanguage: {},
              PlanName: {},
              PlanType: {},
              NotificationArns: {
                shape: "S2o"
              },
              PathId: {},
              ProductId: {},
              ProvisionedProductName: {},
              ProvisioningArtifactId: {},
              ProvisioningParameters: {
                shape: "S2r"
              },
              IdempotencyToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S1q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PlanName: {},
              PlanId: {},
              ProvisionProductId: {},
              ProvisionedProductName: {},
              ProvisioningArtifactId: {}
            }
          }
        },
        CreateProvisioningArtifact: {
          input: {
            type: "structure",
            required: [
              "ProductId",
              "Parameters",
              "IdempotencyToken"
            ],
            members: {
              AcceptLanguage: {},
              ProductId: {},
              Parameters: {
                shape: "S24"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisioningArtifactDetail: {
                shape: "S2i"
              },
              Info: {
                shape: "S27"
              },
              Status: {}
            }
          }
        },
        CreateServiceAction: {
          input: {
            type: "structure",
            required: [
              "Name",
              "DefinitionType",
              "Definition",
              "IdempotencyToken"
            ],
            members: {
              Name: {},
              DefinitionType: {},
              Definition: {
                shape: "S32"
              },
              Description: {},
              AcceptLanguage: {},
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceActionDetail: {
                shape: "S37"
              }
            }
          }
        },
        CreateTagOption: {
          input: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TagOptionDetail: {
                shape: "S3d"
              }
            }
          }
        },
        DeleteConstraint: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              AcceptLanguage: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePortfolio: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              AcceptLanguage: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePortfolioShare: {
          input: {
            type: "structure",
            required: [
              "PortfolioId"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              AccountId: {},
              OrganizationNode: {
                shape: "S1s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PortfolioShareToken: {}
            }
          }
        },
        DeleteProduct: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              AcceptLanguage: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteProvisionedProductPlan: {
          input: {
            type: "structure",
            required: [
              "PlanId"
            ],
            members: {
              AcceptLanguage: {},
              PlanId: {},
              IgnoreErrors: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteProvisioningArtifact: {
          input: {
            type: "structure",
            required: [
              "ProductId",
              "ProvisioningArtifactId"
            ],
            members: {
              AcceptLanguage: {},
              ProductId: {},
              ProvisioningArtifactId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteServiceAction: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {},
              AcceptLanguage: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTagOption: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeConstraint: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              AcceptLanguage: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConstraintDetail: {
                shape: "S1b"
              },
              ConstraintParameters: {},
              Status: {}
            }
          }
        },
        DescribeCopyProductStatus: {
          input: {
            type: "structure",
            required: [
              "CopyProductToken"
            ],
            members: {
              AcceptLanguage: {},
              CopyProductToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CopyProductStatus: {},
              TargetProductId: {},
              StatusDetail: {}
            }
          }
        },
        DescribePortfolio: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              AcceptLanguage: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PortfolioDetail: {
                shape: "S1n"
              },
              Tags: {
                shape: "S1q"
              },
              TagOptions: {
                shape: "S45"
              },
              Budgets: {
                shape: "S46"
              }
            }
          }
        },
        DescribePortfolioShareStatus: {
          input: {
            type: "structure",
            required: [
              "PortfolioShareToken"
            ],
            members: {
              PortfolioShareToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PortfolioShareToken: {},
              PortfolioId: {},
              OrganizationNodeValue: {},
              Status: {},
              ShareDetails: {
                type: "structure",
                members: {
                  SuccessfulShares: {
                    type: "list",
                    member: {}
                  },
                  ShareErrors: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Accounts: {
                          type: "list",
                          member: {}
                        },
                        Message: {},
                        Error: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribePortfolioShares: {
          input: {
            type: "structure",
            required: [
              "PortfolioId",
              "Type"
            ],
            members: {
              PortfolioId: {},
              Type: {},
              PageToken: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextPageToken: {},
              PortfolioShareDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PrincipalId: {},
                    Type: {},
                    Accepted: {
                      type: "boolean"
                    },
                    ShareTagOptions: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeProduct: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              Id: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProductViewSummary: {
                shape: "S2e"
              },
              ProvisioningArtifacts: {
                shape: "S4r"
              },
              Budgets: {
                shape: "S46"
              },
              LaunchPaths: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        DescribeProductAsAdmin: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              Id: {},
              Name: {},
              SourcePortfolioId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProductViewDetail: {
                shape: "S2d"
              },
              ProvisioningArtifactSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Description: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    ProvisioningArtifactMetadata: {
                      shape: "S27"
                    }
                  }
                }
              },
              Tags: {
                shape: "S1q"
              },
              TagOptions: {
                shape: "S45"
              },
              Budgets: {
                shape: "S46"
              }
            }
          }
        },
        DescribeProductView: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              AcceptLanguage: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProductViewSummary: {
                shape: "S2e"
              },
              ProvisioningArtifacts: {
                shape: "S4r"
              }
            }
          }
        },
        DescribeProvisionedProduct: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              Id: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisionedProductDetail: {
                shape: "S55"
              },
              CloudWatchDashboards: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {}
                  }
                }
              }
            }
          }
        },
        DescribeProvisionedProductPlan: {
          input: {
            type: "structure",
            required: [
              "PlanId"
            ],
            members: {
              AcceptLanguage: {},
              PlanId: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisionedProductPlanDetails: {
                type: "structure",
                members: {
                  CreatedTime: {
                    type: "timestamp"
                  },
                  PathId: {},
                  ProductId: {},
                  PlanName: {},
                  PlanId: {},
                  ProvisionProductId: {},
                  ProvisionProductName: {},
                  PlanType: {},
                  ProvisioningArtifactId: {},
                  Status: {},
                  UpdatedTime: {
                    type: "timestamp"
                  },
                  NotificationArns: {
                    shape: "S2o"
                  },
                  ProvisioningParameters: {
                    shape: "S2r"
                  },
                  Tags: {
                    shape: "S1q"
                  },
                  StatusMessage: {}
                }
              },
              ResourceChanges: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Action: {},
                    LogicalResourceId: {},
                    PhysicalResourceId: {},
                    ResourceType: {},
                    Replacement: {},
                    Scope: {
                      type: "list",
                      member: {}
                    },
                    Details: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Target: {
                            type: "structure",
                            members: {
                              Attribute: {},
                              Name: {},
                              RequiresRecreation: {}
                            }
                          },
                          Evaluation: {},
                          CausingEntity: {}
                        }
                      }
                    }
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        DescribeProvisioningArtifact: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              ProvisioningArtifactId: {},
              ProductId: {},
              ProvisioningArtifactName: {},
              ProductName: {},
              Verbose: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisioningArtifactDetail: {
                shape: "S2i"
              },
              Info: {
                shape: "S27"
              },
              Status: {}
            }
          }
        },
        DescribeProvisioningParameters: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              ProductId: {},
              ProductName: {},
              ProvisioningArtifactId: {},
              ProvisioningArtifactName: {},
              PathId: {},
              PathName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisioningArtifactParameters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ParameterKey: {},
                    DefaultValue: {},
                    ParameterType: {},
                    IsNoEcho: {
                      type: "boolean"
                    },
                    Description: {},
                    ParameterConstraints: {
                      type: "structure",
                      members: {
                        AllowedValues: {
                          type: "list",
                          member: {}
                        },
                        AllowedPattern: {},
                        ConstraintDescription: {},
                        MaxLength: {},
                        MinLength: {},
                        MaxValue: {},
                        MinValue: {}
                      }
                    }
                  }
                }
              },
              ConstraintSummaries: {
                shape: "S6h"
              },
              UsageInstructions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    Value: {}
                  }
                }
              },
              TagOptions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              ProvisioningArtifactPreferences: {
                type: "structure",
                members: {
                  StackSetAccounts: {
                    shape: "S6r"
                  },
                  StackSetRegions: {
                    shape: "S6s"
                  }
                }
              },
              ProvisioningArtifactOutputs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {},
                    Description: {}
                  }
                }
              }
            }
          }
        },
        DescribeRecord: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              AcceptLanguage: {},
              Id: {},
              PageToken: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecordDetail: {
                shape: "S70"
              },
              RecordOutputs: {
                shape: "S7b"
              },
              NextPageToken: {}
            }
          }
        },
        DescribeServiceAction: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {},
              AcceptLanguage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceActionDetail: {
                shape: "S37"
              }
            }
          }
        },
        DescribeServiceActionExecutionParameters: {
          input: {
            type: "structure",
            required: [
              "ProvisionedProductId",
              "ServiceActionId"
            ],
            members: {
              ProvisionedProductId: {},
              ServiceActionId: {},
              AcceptLanguage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceActionParameters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Type: {},
                    DefaultValues: {
                      shape: "S7n"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeTagOption: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TagOptionDetail: {
                shape: "S3d"
              }
            }
          }
        },
        DisableAWSOrganizationsAccess: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateBudgetFromResource: {
          input: {
            type: "structure",
            required: [
              "BudgetName",
              "ResourceId"
            ],
            members: {
              BudgetName: {},
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociatePrincipalFromPortfolio: {
          input: {
            type: "structure",
            required: [
              "PortfolioId",
              "PrincipalARN"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              PrincipalARN: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateProductFromPortfolio: {
          input: {
            type: "structure",
            required: [
              "ProductId",
              "PortfolioId"
            ],
            members: {
              AcceptLanguage: {},
              ProductId: {},
              PortfolioId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateServiceActionFromProvisioningArtifact: {
          input: {
            type: "structure",
            required: [
              "ProductId",
              "ProvisioningArtifactId",
              "ServiceActionId"
            ],
            members: {
              ProductId: {},
              ProvisioningArtifactId: {},
              ServiceActionId: {},
              AcceptLanguage: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateTagOptionFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "TagOptionId"
            ],
            members: {
              ResourceId: {},
              TagOptionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableAWSOrganizationsAccess: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ExecuteProvisionedProductPlan: {
          input: {
            type: "structure",
            required: [
              "PlanId",
              "IdempotencyToken"
            ],
            members: {
              AcceptLanguage: {},
              PlanId: {},
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecordDetail: {
                shape: "S70"
              }
            }
          }
        },
        ExecuteProvisionedProductServiceAction: {
          input: {
            type: "structure",
            required: [
              "ProvisionedProductId",
              "ServiceActionId",
              "ExecuteToken"
            ],
            members: {
              ProvisionedProductId: {},
              ServiceActionId: {},
              ExecuteToken: {
                idempotencyToken: true
              },
              AcceptLanguage: {},
              Parameters: {
                type: "map",
                key: {},
                value: {
                  shape: "S7n"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecordDetail: {
                shape: "S70"
              }
            }
          }
        },
        GetAWSOrganizationsAccessStatus: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              AccessStatus: {}
            }
          }
        },
        GetProvisionedProductOutputs: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              ProvisionedProductId: {},
              ProvisionedProductName: {},
              OutputKeys: {
                type: "list",
                member: {}
              },
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Outputs: {
                shape: "S7b"
              },
              NextPageToken: {}
            }
          }
        },
        ImportAsProvisionedProduct: {
          input: {
            type: "structure",
            required: [
              "ProductId",
              "ProvisioningArtifactId",
              "ProvisionedProductName",
              "PhysicalId",
              "IdempotencyToken"
            ],
            members: {
              AcceptLanguage: {},
              ProductId: {},
              ProvisioningArtifactId: {},
              ProvisionedProductName: {},
              PhysicalId: {},
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecordDetail: {
                shape: "S70"
              }
            }
          }
        },
        ListAcceptedPortfolioShares: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              PageToken: {},
              PageSize: {
                type: "integer"
              },
              PortfolioShareType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PortfolioDetails: {
                shape: "S8l"
              },
              NextPageToken: {}
            }
          }
        },
        ListBudgetsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              AcceptLanguage: {},
              ResourceId: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Budgets: {
                shape: "S46"
              },
              NextPageToken: {}
            }
          }
        },
        ListConstraintsForPortfolio: {
          input: {
            type: "structure",
            required: [
              "PortfolioId"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              ProductId: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConstraintDetails: {
                type: "list",
                member: {
                  shape: "S1b"
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListLaunchPaths: {
          input: {
            type: "structure",
            required: [
              "ProductId"
            ],
            members: {
              AcceptLanguage: {},
              ProductId: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LaunchPathSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    ConstraintSummaries: {
                      shape: "S6h"
                    },
                    Tags: {
                      shape: "S1q"
                    },
                    Name: {}
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListOrganizationPortfolioAccess: {
          input: {
            type: "structure",
            required: [
              "PortfolioId",
              "OrganizationNodeType"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              OrganizationNodeType: {},
              PageToken: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationNodes: {
                type: "list",
                member: {
                  shape: "S1s"
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListPortfolioAccess: {
          input: {
            type: "structure",
            required: [
              "PortfolioId"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              OrganizationParentId: {},
              PageToken: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccountIds: {
                type: "list",
                member: {}
              },
              NextPageToken: {}
            }
          }
        },
        ListPortfolios: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              PageToken: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PortfolioDetails: {
                shape: "S8l"
              },
              NextPageToken: {}
            }
          }
        },
        ListPortfoliosForProduct: {
          input: {
            type: "structure",
            required: [
              "ProductId"
            ],
            members: {
              AcceptLanguage: {},
              ProductId: {},
              PageToken: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PortfolioDetails: {
                shape: "S8l"
              },
              NextPageToken: {}
            }
          }
        },
        ListPrincipalsForPortfolio: {
          input: {
            type: "structure",
            required: [
              "PortfolioId"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Principals: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PrincipalARN: {},
                    PrincipalType: {}
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListProvisionedProductPlans: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              ProvisionProductId: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {},
              AccessLevelFilter: {
                shape: "S9a"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisionedProductPlans: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PlanName: {},
                    PlanId: {},
                    ProvisionProductId: {},
                    ProvisionProductName: {},
                    PlanType: {},
                    ProvisioningArtifactId: {}
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListProvisioningArtifacts: {
          input: {
            type: "structure",
            required: [
              "ProductId"
            ],
            members: {
              AcceptLanguage: {},
              ProductId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisioningArtifactDetails: {
                type: "list",
                member: {
                  shape: "S2i"
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListProvisioningArtifactsForServiceAction: {
          input: {
            type: "structure",
            required: [
              "ServiceActionId"
            ],
            members: {
              ServiceActionId: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {},
              AcceptLanguage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisioningArtifactViews: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProductViewSummary: {
                      shape: "S2e"
                    },
                    ProvisioningArtifact: {
                      shape: "S4s"
                    }
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListRecordHistory: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              AccessLevelFilter: {
                shape: "S9a"
              },
              SearchFilter: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {}
                }
              },
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RecordDetails: {
                type: "list",
                member: {
                  shape: "S70"
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListResourcesForTagOption: {
          input: {
            type: "structure",
            required: [
              "TagOptionId"
            ],
            members: {
              TagOptionId: {},
              ResourceType: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    ARN: {},
                    Name: {},
                    Description: {},
                    CreatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              PageToken: {}
            }
          }
        },
        ListServiceActions: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceActionSummaries: {
                shape: "Sa5"
              },
              NextPageToken: {}
            }
          }
        },
        ListServiceActionsForProvisioningArtifact: {
          input: {
            type: "structure",
            required: [
              "ProductId",
              "ProvisioningArtifactId"
            ],
            members: {
              ProductId: {},
              ProvisioningArtifactId: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {},
              AcceptLanguage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceActionSummaries: {
                shape: "Sa5"
              },
              NextPageToken: {}
            }
          }
        },
        ListStackInstancesForProvisionedProduct: {
          input: {
            type: "structure",
            required: [
              "ProvisionedProductId"
            ],
            members: {
              AcceptLanguage: {},
              ProvisionedProductId: {},
              PageToken: {},
              PageSize: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StackInstances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Account: {},
                    Region: {},
                    StackInstanceStatus: {}
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        ListTagOptions: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {},
                  Active: {
                    type: "boolean"
                  }
                }
              },
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TagOptionDetails: {
                shape: "S45"
              },
              PageToken: {}
            }
          }
        },
        ProvisionProduct: {
          input: {
            type: "structure",
            required: [
              "ProvisionedProductName",
              "ProvisionToken"
            ],
            members: {
              AcceptLanguage: {},
              ProductId: {},
              ProductName: {},
              ProvisioningArtifactId: {},
              ProvisioningArtifactName: {},
              PathId: {},
              PathName: {},
              ProvisionedProductName: {},
              ProvisioningParameters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {},
                    Value: {}
                  }
                }
              },
              ProvisioningPreferences: {
                type: "structure",
                members: {
                  StackSetAccounts: {
                    shape: "S6r"
                  },
                  StackSetRegions: {
                    shape: "S6s"
                  },
                  StackSetFailureToleranceCount: {
                    type: "integer"
                  },
                  StackSetFailureTolerancePercentage: {
                    type: "integer"
                  },
                  StackSetMaxConcurrencyCount: {
                    type: "integer"
                  },
                  StackSetMaxConcurrencyPercentage: {
                    type: "integer"
                  }
                }
              },
              Tags: {
                shape: "S1q"
              },
              NotificationArns: {
                shape: "S2o"
              },
              ProvisionToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecordDetail: {
                shape: "S70"
              }
            }
          }
        },
        RejectPortfolioShare: {
          input: {
            type: "structure",
            required: [
              "PortfolioId"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              PortfolioShareType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ScanProvisionedProducts: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              AccessLevelFilter: {
                shape: "S9a"
              },
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisionedProducts: {
                type: "list",
                member: {
                  shape: "S55"
                }
              },
              NextPageToken: {}
            }
          }
        },
        SearchProducts: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              Filters: {
                shape: "Sav"
              },
              PageSize: {
                type: "integer"
              },
              SortBy: {},
              SortOrder: {},
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProductViewSummaries: {
                type: "list",
                member: {
                  shape: "S2e"
                }
              },
              ProductViewAggregations: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      Value: {},
                      ApproximateCount: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        SearchProductsAsAdmin: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              Filters: {
                shape: "Sav"
              },
              SortBy: {},
              SortOrder: {},
              PageToken: {},
              PageSize: {
                type: "integer"
              },
              ProductSource: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProductViewDetails: {
                type: "list",
                member: {
                  shape: "S2d"
                }
              },
              NextPageToken: {}
            }
          }
        },
        SearchProvisionedProducts: {
          input: {
            type: "structure",
            members: {
              AcceptLanguage: {},
              AccessLevelFilter: {
                shape: "S9a"
              },
              Filters: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {}
                }
              },
              SortBy: {},
              SortOrder: {},
              PageSize: {
                type: "integer"
              },
              PageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisionedProducts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Arn: {},
                    Type: {},
                    Id: {},
                    Status: {},
                    StatusMessage: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    IdempotencyToken: {},
                    LastRecordId: {},
                    LastProvisioningRecordId: {},
                    LastSuccessfulProvisioningRecordId: {},
                    Tags: {
                      shape: "S1q"
                    },
                    PhysicalId: {},
                    ProductId: {},
                    ProductName: {},
                    ProvisioningArtifactId: {},
                    ProvisioningArtifactName: {},
                    UserArn: {},
                    UserArnSession: {}
                  }
                }
              },
              TotalResultsCount: {
                type: "integer"
              },
              NextPageToken: {}
            }
          }
        },
        TerminateProvisionedProduct: {
          input: {
            type: "structure",
            required: [
              "TerminateToken"
            ],
            members: {
              ProvisionedProductName: {},
              ProvisionedProductId: {},
              TerminateToken: {
                idempotencyToken: true
              },
              IgnoreErrors: {
                type: "boolean"
              },
              AcceptLanguage: {},
              RetainPhysicalResources: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecordDetail: {
                shape: "S70"
              }
            }
          }
        },
        UpdateConstraint: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              AcceptLanguage: {},
              Id: {},
              Description: {},
              Parameters: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConstraintDetail: {
                shape: "S1b"
              },
              ConstraintParameters: {},
              Status: {}
            }
          }
        },
        UpdatePortfolio: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              AcceptLanguage: {},
              Id: {},
              DisplayName: {},
              Description: {},
              ProviderName: {},
              AddTags: {
                shape: "S1i"
              },
              RemoveTags: {
                shape: "Sbw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PortfolioDetail: {
                shape: "S1n"
              },
              Tags: {
                shape: "S1q"
              }
            }
          }
        },
        UpdatePortfolioShare: {
          input: {
            type: "structure",
            required: [
              "PortfolioId"
            ],
            members: {
              AcceptLanguage: {},
              PortfolioId: {},
              AccountId: {},
              OrganizationNode: {
                shape: "S1s"
              },
              ShareTagOptions: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PortfolioShareToken: {},
              Status: {}
            }
          }
        },
        UpdateProduct: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              AcceptLanguage: {},
              Id: {},
              Name: {},
              Owner: {},
              Description: {},
              Distributor: {},
              SupportDescription: {},
              SupportEmail: {},
              SupportUrl: {},
              AddTags: {
                shape: "S1i"
              },
              RemoveTags: {
                shape: "Sbw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProductViewDetail: {
                shape: "S2d"
              },
              Tags: {
                shape: "S1q"
              }
            }
          }
        },
        UpdateProvisionedProduct: {
          input: {
            type: "structure",
            required: [
              "UpdateToken"
            ],
            members: {
              AcceptLanguage: {},
              ProvisionedProductName: {},
              ProvisionedProductId: {},
              ProductId: {},
              ProductName: {},
              ProvisioningArtifactId: {},
              ProvisioningArtifactName: {},
              PathId: {},
              PathName: {},
              ProvisioningParameters: {
                shape: "S2r"
              },
              ProvisioningPreferences: {
                type: "structure",
                members: {
                  StackSetAccounts: {
                    shape: "S6r"
                  },
                  StackSetRegions: {
                    shape: "S6s"
                  },
                  StackSetFailureToleranceCount: {
                    type: "integer"
                  },
                  StackSetFailureTolerancePercentage: {
                    type: "integer"
                  },
                  StackSetMaxConcurrencyCount: {
                    type: "integer"
                  },
                  StackSetMaxConcurrencyPercentage: {
                    type: "integer"
                  },
                  StackSetOperationType: {}
                }
              },
              Tags: {
                shape: "S1q"
              },
              UpdateToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecordDetail: {
                shape: "S70"
              }
            }
          }
        },
        UpdateProvisionedProductProperties: {
          input: {
            type: "structure",
            required: [
              "ProvisionedProductId",
              "ProvisionedProductProperties",
              "IdempotencyToken"
            ],
            members: {
              AcceptLanguage: {},
              ProvisionedProductId: {},
              ProvisionedProductProperties: {
                shape: "Sc8"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisionedProductId: {},
              ProvisionedProductProperties: {
                shape: "Sc8"
              },
              RecordId: {},
              Status: {}
            }
          }
        },
        UpdateProvisioningArtifact: {
          input: {
            type: "structure",
            required: [
              "ProductId",
              "ProvisioningArtifactId"
            ],
            members: {
              AcceptLanguage: {},
              ProductId: {},
              ProvisioningArtifactId: {},
              Name: {},
              Description: {},
              Active: {
                type: "boolean"
              },
              Guidance: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProvisioningArtifactDetail: {
                shape: "S2i"
              },
              Info: {
                shape: "S27"
              },
              Status: {}
            }
          }
        },
        UpdateServiceAction: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {},
              Name: {},
              Definition: {
                shape: "S32"
              },
              Description: {},
              AcceptLanguage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceActionDetail: {
                shape: "S37"
              }
            }
          }
        },
        UpdateTagOption: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {},
              Value: {},
              Active: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TagOptionDetail: {
                shape: "S3d"
              }
            }
          }
        }
      },
      shapes: {
        Sm: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ServiceActionId",
              "ProductId",
              "ProvisioningArtifactId"
            ],
            members: {
              ServiceActionId: {},
              ProductId: {},
              ProvisioningArtifactId: {}
            }
          }
        },
        Sp: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ServiceActionId: {},
              ProductId: {},
              ProvisioningArtifactId: {},
              ErrorCode: {},
              ErrorMessage: {}
            }
          }
        },
        S1b: {
          type: "structure",
          members: {
            ConstraintId: {},
            Type: {},
            Description: {},
            Owner: {},
            ProductId: {},
            PortfolioId: {}
          }
        },
        S1i: {
          type: "list",
          member: {
            shape: "S1j"
          }
        },
        S1j: {
          type: "structure",
          required: [
            "Key",
            "Value"
          ],
          members: {
            Key: {},
            Value: {}
          }
        },
        S1n: {
          type: "structure",
          members: {
            Id: {},
            ARN: {},
            DisplayName: {},
            Description: {},
            CreatedTime: {
              type: "timestamp"
            },
            ProviderName: {}
          }
        },
        S1q: {
          type: "list",
          member: {
            shape: "S1j"
          }
        },
        S1s: {
          type: "structure",
          members: {
            Type: {},
            Value: {}
          }
        },
        S24: {
          type: "structure",
          required: [
            "Info"
          ],
          members: {
            Name: {},
            Description: {},
            Info: {
              shape: "S27"
            },
            Type: {},
            DisableTemplateValidation: {
              type: "boolean"
            }
          }
        },
        S27: {
          type: "map",
          key: {},
          value: {}
        },
        S2d: {
          type: "structure",
          members: {
            ProductViewSummary: {
              shape: "S2e"
            },
            Status: {},
            ProductARN: {},
            CreatedTime: {
              type: "timestamp"
            }
          }
        },
        S2e: {
          type: "structure",
          members: {
            Id: {},
            ProductId: {},
            Name: {},
            Owner: {},
            ShortDescription: {},
            Type: {},
            Distributor: {},
            HasDefaultPath: {
              type: "boolean"
            },
            SupportEmail: {},
            SupportDescription: {},
            SupportUrl: {}
          }
        },
        S2i: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            Description: {},
            Type: {},
            CreatedTime: {
              type: "timestamp"
            },
            Active: {
              type: "boolean"
            },
            Guidance: {}
          }
        },
        S2o: {
          type: "list",
          member: {}
        },
        S2r: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {},
              UsePreviousValue: {
                type: "boolean"
              }
            }
          }
        },
        S32: {
          type: "map",
          key: {},
          value: {}
        },
        S37: {
          type: "structure",
          members: {
            ServiceActionSummary: {
              shape: "S38"
            },
            Definition: {
              shape: "S32"
            }
          }
        },
        S38: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            Description: {},
            DefinitionType: {}
          }
        },
        S3d: {
          type: "structure",
          members: {
            Key: {},
            Value: {},
            Active: {
              type: "boolean"
            },
            Id: {},
            Owner: {}
          }
        },
        S45: {
          type: "list",
          member: {
            shape: "S3d"
          }
        },
        S46: {
          type: "list",
          member: {
            type: "structure",
            members: {
              BudgetName: {}
            }
          }
        },
        S4r: {
          type: "list",
          member: {
            shape: "S4s"
          }
        },
        S4s: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            Description: {},
            CreatedTime: {
              type: "timestamp"
            },
            Guidance: {}
          }
        },
        S55: {
          type: "structure",
          members: {
            Name: {},
            Arn: {},
            Type: {},
            Id: {},
            Status: {},
            StatusMessage: {},
            CreatedTime: {
              type: "timestamp"
            },
            IdempotencyToken: {},
            LastRecordId: {},
            LastProvisioningRecordId: {},
            LastSuccessfulProvisioningRecordId: {},
            ProductId: {},
            ProvisioningArtifactId: {},
            LaunchRoleArn: {}
          }
        },
        S6h: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              Description: {}
            }
          }
        },
        S6r: {
          type: "list",
          member: {}
        },
        S6s: {
          type: "list",
          member: {}
        },
        S70: {
          type: "structure",
          members: {
            RecordId: {},
            ProvisionedProductName: {},
            Status: {},
            CreatedTime: {
              type: "timestamp"
            },
            UpdatedTime: {
              type: "timestamp"
            },
            ProvisionedProductType: {},
            RecordType: {},
            ProvisionedProductId: {},
            ProductId: {},
            ProvisioningArtifactId: {},
            PathId: {},
            RecordErrors: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Code: {},
                  Description: {}
                }
              }
            },
            RecordTags: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {}
                }
              }
            },
            LaunchRoleArn: {}
          }
        },
        S7b: {
          type: "list",
          member: {
            type: "structure",
            members: {
              OutputKey: {},
              OutputValue: {},
              Description: {}
            }
          }
        },
        S7n: {
          type: "list",
          member: {}
        },
        S8l: {
          type: "list",
          member: {
            shape: "S1n"
          }
        },
        S9a: {
          type: "structure",
          members: {
            Key: {},
            Value: {}
          }
        },
        Sa5: {
          type: "list",
          member: {
            shape: "S38"
          }
        },
        Sav: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          }
        },
        Sbw: {
          type: "list",
          member: {}
        },
        Sc8: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/servicecatalog-2015-12-10.paginators.json
var require_servicecatalog_2015_12_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/servicecatalog-2015-12-10.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribePortfolioShares: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        GetProvisionedProductOutputs: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListAcceptedPortfolioShares: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListBudgetsForResource: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListConstraintsForPortfolio: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListLaunchPaths: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListOrganizationPortfolioAccess: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListPortfolioAccess: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListPortfolios: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListPortfoliosForProduct: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListPrincipalsForPortfolio: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListProvisioningArtifactsForServiceAction: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListResourcesForTagOption: {
          input_token: "PageToken",
          output_token: "PageToken",
          limit_key: "PageSize"
        },
        ListServiceActions: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListServiceActionsForProvisioningArtifact: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        ListTagOptions: {
          input_token: "PageToken",
          output_token: "PageToken",
          limit_key: "PageSize"
        },
        SearchProducts: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        SearchProductsAsAdmin: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        },
        SearchProvisionedProducts: {
          input_token: "PageToken",
          output_token: "NextPageToken",
          limit_key: "PageSize"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/servicecatalog.js
var require_servicecatalog = __commonJS({
  "node_modules/aws-sdk/clients/servicecatalog.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["servicecatalog"] = {};
    AWS3.ServiceCatalog = Service.defineService("servicecatalog", ["2015-12-10"]);
    Object.defineProperty(apiLoader.services["servicecatalog"], "2015-12-10", {
      get: function get() {
        var model = require_servicecatalog_2015_12_10_min();
        model.paginators = require_servicecatalog_2015_12_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ServiceCatalog;
  }
});

// node_modules/aws-sdk/apis/email-2010-12-01.min.json
var require_email_2010_12_01_min = __commonJS({
  "node_modules/aws-sdk/apis/email-2010-12-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2010-12-01",
        endpointPrefix: "email",
        protocol: "query",
        serviceAbbreviation: "Amazon SES",
        serviceFullName: "Amazon Simple Email Service",
        serviceId: "SES",
        signatureVersion: "v4",
        signingName: "ses",
        uid: "email-2010-12-01",
        xmlNamespace: "http://ses.amazonaws.com/doc/2010-12-01/"
      },
      operations: {
        CloneReceiptRuleSet: {
          input: {
            type: "structure",
            required: [
              "RuleSetName",
              "OriginalRuleSetName"
            ],
            members: {
              RuleSetName: {},
              OriginalRuleSetName: {}
            }
          },
          output: {
            resultWrapper: "CloneReceiptRuleSetResult",
            type: "structure",
            members: {}
          }
        },
        CreateConfigurationSet: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSet"
            ],
            members: {
              ConfigurationSet: {
                shape: "S5"
              }
            }
          },
          output: {
            resultWrapper: "CreateConfigurationSetResult",
            type: "structure",
            members: {}
          }
        },
        CreateConfigurationSetEventDestination: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestination"
            ],
            members: {
              ConfigurationSetName: {},
              EventDestination: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateConfigurationSetEventDestinationResult",
            type: "structure",
            members: {}
          }
        },
        CreateConfigurationSetTrackingOptions: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "TrackingOptions"
            ],
            members: {
              ConfigurationSetName: {},
              TrackingOptions: {
                shape: "Sp"
              }
            }
          },
          output: {
            resultWrapper: "CreateConfigurationSetTrackingOptionsResult",
            type: "structure",
            members: {}
          }
        },
        CreateCustomVerificationEmailTemplate: {
          input: {
            type: "structure",
            required: [
              "TemplateName",
              "FromEmailAddress",
              "TemplateSubject",
              "TemplateContent",
              "SuccessRedirectionURL",
              "FailureRedirectionURL"
            ],
            members: {
              TemplateName: {},
              FromEmailAddress: {},
              TemplateSubject: {},
              TemplateContent: {},
              SuccessRedirectionURL: {},
              FailureRedirectionURL: {}
            }
          }
        },
        CreateReceiptFilter: {
          input: {
            type: "structure",
            required: [
              "Filter"
            ],
            members: {
              Filter: {
                shape: "S10"
              }
            }
          },
          output: {
            resultWrapper: "CreateReceiptFilterResult",
            type: "structure",
            members: {}
          }
        },
        CreateReceiptRule: {
          input: {
            type: "structure",
            required: [
              "RuleSetName",
              "Rule"
            ],
            members: {
              RuleSetName: {},
              After: {},
              Rule: {
                shape: "S18"
              }
            }
          },
          output: {
            resultWrapper: "CreateReceiptRuleResult",
            type: "structure",
            members: {}
          }
        },
        CreateReceiptRuleSet: {
          input: {
            type: "structure",
            required: [
              "RuleSetName"
            ],
            members: {
              RuleSetName: {}
            }
          },
          output: {
            resultWrapper: "CreateReceiptRuleSetResult",
            type: "structure",
            members: {}
          }
        },
        CreateTemplate: {
          input: {
            type: "structure",
            required: [
              "Template"
            ],
            members: {
              Template: {
                shape: "S20"
              }
            }
          },
          output: {
            resultWrapper: "CreateTemplateResult",
            type: "structure",
            members: {}
          }
        },
        DeleteConfigurationSet: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {}
            }
          },
          output: {
            resultWrapper: "DeleteConfigurationSetResult",
            type: "structure",
            members: {}
          }
        },
        DeleteConfigurationSetEventDestination: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestinationName"
            ],
            members: {
              ConfigurationSetName: {},
              EventDestinationName: {}
            }
          },
          output: {
            resultWrapper: "DeleteConfigurationSetEventDestinationResult",
            type: "structure",
            members: {}
          }
        },
        DeleteConfigurationSetTrackingOptions: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {}
            }
          },
          output: {
            resultWrapper: "DeleteConfigurationSetTrackingOptionsResult",
            type: "structure",
            members: {}
          }
        },
        DeleteCustomVerificationEmailTemplate: {
          input: {
            type: "structure",
            required: [
              "TemplateName"
            ],
            members: {
              TemplateName: {}
            }
          }
        },
        DeleteIdentity: {
          input: {
            type: "structure",
            required: [
              "Identity"
            ],
            members: {
              Identity: {}
            }
          },
          output: {
            resultWrapper: "DeleteIdentityResult",
            type: "structure",
            members: {}
          }
        },
        DeleteIdentityPolicy: {
          input: {
            type: "structure",
            required: [
              "Identity",
              "PolicyName"
            ],
            members: {
              Identity: {},
              PolicyName: {}
            }
          },
          output: {
            resultWrapper: "DeleteIdentityPolicyResult",
            type: "structure",
            members: {}
          }
        },
        DeleteReceiptFilter: {
          input: {
            type: "structure",
            required: [
              "FilterName"
            ],
            members: {
              FilterName: {}
            }
          },
          output: {
            resultWrapper: "DeleteReceiptFilterResult",
            type: "structure",
            members: {}
          }
        },
        DeleteReceiptRule: {
          input: {
            type: "structure",
            required: [
              "RuleSetName",
              "RuleName"
            ],
            members: {
              RuleSetName: {},
              RuleName: {}
            }
          },
          output: {
            resultWrapper: "DeleteReceiptRuleResult",
            type: "structure",
            members: {}
          }
        },
        DeleteReceiptRuleSet: {
          input: {
            type: "structure",
            required: [
              "RuleSetName"
            ],
            members: {
              RuleSetName: {}
            }
          },
          output: {
            resultWrapper: "DeleteReceiptRuleSetResult",
            type: "structure",
            members: {}
          }
        },
        DeleteTemplate: {
          input: {
            type: "structure",
            required: [
              "TemplateName"
            ],
            members: {
              TemplateName: {}
            }
          },
          output: {
            resultWrapper: "DeleteTemplateResult",
            type: "structure",
            members: {}
          }
        },
        DeleteVerifiedEmailAddress: {
          input: {
            type: "structure",
            required: [
              "EmailAddress"
            ],
            members: {
              EmailAddress: {}
            }
          }
        },
        DescribeActiveReceiptRuleSet: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            resultWrapper: "DescribeActiveReceiptRuleSetResult",
            type: "structure",
            members: {
              Metadata: {
                shape: "S2t"
              },
              Rules: {
                shape: "S2v"
              }
            }
          }
        },
        DescribeConfigurationSet: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {},
              ConfigurationSetAttributeNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "DescribeConfigurationSetResult",
            type: "structure",
            members: {
              ConfigurationSet: {
                shape: "S5"
              },
              EventDestinations: {
                type: "list",
                member: {
                  shape: "S9"
                }
              },
              TrackingOptions: {
                shape: "Sp"
              },
              DeliveryOptions: {
                shape: "S31"
              },
              ReputationOptions: {
                type: "structure",
                members: {
                  SendingEnabled: {
                    type: "boolean"
                  },
                  ReputationMetricsEnabled: {
                    type: "boolean"
                  },
                  LastFreshStart: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeReceiptRule: {
          input: {
            type: "structure",
            required: [
              "RuleSetName",
              "RuleName"
            ],
            members: {
              RuleSetName: {},
              RuleName: {}
            }
          },
          output: {
            resultWrapper: "DescribeReceiptRuleResult",
            type: "structure",
            members: {
              Rule: {
                shape: "S18"
              }
            }
          }
        },
        DescribeReceiptRuleSet: {
          input: {
            type: "structure",
            required: [
              "RuleSetName"
            ],
            members: {
              RuleSetName: {}
            }
          },
          output: {
            resultWrapper: "DescribeReceiptRuleSetResult",
            type: "structure",
            members: {
              Metadata: {
                shape: "S2t"
              },
              Rules: {
                shape: "S2v"
              }
            }
          }
        },
        GetAccountSendingEnabled: {
          output: {
            resultWrapper: "GetAccountSendingEnabledResult",
            type: "structure",
            members: {
              Enabled: {
                type: "boolean"
              }
            }
          }
        },
        GetCustomVerificationEmailTemplate: {
          input: {
            type: "structure",
            required: [
              "TemplateName"
            ],
            members: {
              TemplateName: {}
            }
          },
          output: {
            resultWrapper: "GetCustomVerificationEmailTemplateResult",
            type: "structure",
            members: {
              TemplateName: {},
              FromEmailAddress: {},
              TemplateSubject: {},
              TemplateContent: {},
              SuccessRedirectionURL: {},
              FailureRedirectionURL: {}
            }
          }
        },
        GetIdentityDkimAttributes: {
          input: {
            type: "structure",
            required: [
              "Identities"
            ],
            members: {
              Identities: {
                shape: "S3c"
              }
            }
          },
          output: {
            resultWrapper: "GetIdentityDkimAttributesResult",
            type: "structure",
            required: [
              "DkimAttributes"
            ],
            members: {
              DkimAttributes: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "DkimEnabled",
                    "DkimVerificationStatus"
                  ],
                  members: {
                    DkimEnabled: {
                      type: "boolean"
                    },
                    DkimVerificationStatus: {},
                    DkimTokens: {
                      shape: "S3h"
                    }
                  }
                }
              }
            }
          }
        },
        GetIdentityMailFromDomainAttributes: {
          input: {
            type: "structure",
            required: [
              "Identities"
            ],
            members: {
              Identities: {
                shape: "S3c"
              }
            }
          },
          output: {
            resultWrapper: "GetIdentityMailFromDomainAttributesResult",
            type: "structure",
            required: [
              "MailFromDomainAttributes"
            ],
            members: {
              MailFromDomainAttributes: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "MailFromDomain",
                    "MailFromDomainStatus",
                    "BehaviorOnMXFailure"
                  ],
                  members: {
                    MailFromDomain: {},
                    MailFromDomainStatus: {},
                    BehaviorOnMXFailure: {}
                  }
                }
              }
            }
          }
        },
        GetIdentityNotificationAttributes: {
          input: {
            type: "structure",
            required: [
              "Identities"
            ],
            members: {
              Identities: {
                shape: "S3c"
              }
            }
          },
          output: {
            resultWrapper: "GetIdentityNotificationAttributesResult",
            type: "structure",
            required: [
              "NotificationAttributes"
            ],
            members: {
              NotificationAttributes: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "BounceTopic",
                    "ComplaintTopic",
                    "DeliveryTopic",
                    "ForwardingEnabled"
                  ],
                  members: {
                    BounceTopic: {},
                    ComplaintTopic: {},
                    DeliveryTopic: {},
                    ForwardingEnabled: {
                      type: "boolean"
                    },
                    HeadersInBounceNotificationsEnabled: {
                      type: "boolean"
                    },
                    HeadersInComplaintNotificationsEnabled: {
                      type: "boolean"
                    },
                    HeadersInDeliveryNotificationsEnabled: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        GetIdentityPolicies: {
          input: {
            type: "structure",
            required: [
              "Identity",
              "PolicyNames"
            ],
            members: {
              Identity: {},
              PolicyNames: {
                shape: "S3w"
              }
            }
          },
          output: {
            resultWrapper: "GetIdentityPoliciesResult",
            type: "structure",
            required: [
              "Policies"
            ],
            members: {
              Policies: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        GetIdentityVerificationAttributes: {
          input: {
            type: "structure",
            required: [
              "Identities"
            ],
            members: {
              Identities: {
                shape: "S3c"
              }
            }
          },
          output: {
            resultWrapper: "GetIdentityVerificationAttributesResult",
            type: "structure",
            required: [
              "VerificationAttributes"
            ],
            members: {
              VerificationAttributes: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "VerificationStatus"
                  ],
                  members: {
                    VerificationStatus: {},
                    VerificationToken: {}
                  }
                }
              }
            }
          }
        },
        GetSendQuota: {
          output: {
            resultWrapper: "GetSendQuotaResult",
            type: "structure",
            members: {
              Max24HourSend: {
                type: "double"
              },
              MaxSendRate: {
                type: "double"
              },
              SentLast24Hours: {
                type: "double"
              }
            }
          }
        },
        GetSendStatistics: {
          output: {
            resultWrapper: "GetSendStatisticsResult",
            type: "structure",
            members: {
              SendDataPoints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "timestamp"
                    },
                    DeliveryAttempts: {
                      type: "long"
                    },
                    Bounces: {
                      type: "long"
                    },
                    Complaints: {
                      type: "long"
                    },
                    Rejects: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        GetTemplate: {
          input: {
            type: "structure",
            required: [
              "TemplateName"
            ],
            members: {
              TemplateName: {}
            }
          },
          output: {
            resultWrapper: "GetTemplateResult",
            type: "structure",
            members: {
              Template: {
                shape: "S20"
              }
            }
          }
        },
        ListConfigurationSets: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListConfigurationSetsResult",
            type: "structure",
            members: {
              ConfigurationSets: {
                type: "list",
                member: {
                  shape: "S5"
                }
              },
              NextToken: {}
            }
          }
        },
        ListCustomVerificationEmailTemplates: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListCustomVerificationEmailTemplatesResult",
            type: "structure",
            members: {
              CustomVerificationEmailTemplates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TemplateName: {},
                    FromEmailAddress: {},
                    TemplateSubject: {},
                    SuccessRedirectionURL: {},
                    FailureRedirectionURL: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListIdentities: {
          input: {
            type: "structure",
            members: {
              IdentityType: {},
              NextToken: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListIdentitiesResult",
            type: "structure",
            required: [
              "Identities"
            ],
            members: {
              Identities: {
                shape: "S3c"
              },
              NextToken: {}
            }
          }
        },
        ListIdentityPolicies: {
          input: {
            type: "structure",
            required: [
              "Identity"
            ],
            members: {
              Identity: {}
            }
          },
          output: {
            resultWrapper: "ListIdentityPoliciesResult",
            type: "structure",
            required: [
              "PolicyNames"
            ],
            members: {
              PolicyNames: {
                shape: "S3w"
              }
            }
          }
        },
        ListReceiptFilters: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            resultWrapper: "ListReceiptFiltersResult",
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  shape: "S10"
                }
              }
            }
          }
        },
        ListReceiptRuleSets: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListReceiptRuleSetsResult",
            type: "structure",
            members: {
              RuleSets: {
                type: "list",
                member: {
                  shape: "S2t"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTemplates: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxItems: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListTemplatesResult",
            type: "structure",
            members: {
              TemplatesMetadata: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    CreatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListVerifiedEmailAddresses: {
          output: {
            resultWrapper: "ListVerifiedEmailAddressesResult",
            type: "structure",
            members: {
              VerifiedEmailAddresses: {
                shape: "S54"
              }
            }
          }
        },
        PutConfigurationSetDeliveryOptions: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {},
              DeliveryOptions: {
                shape: "S31"
              }
            }
          },
          output: {
            resultWrapper: "PutConfigurationSetDeliveryOptionsResult",
            type: "structure",
            members: {}
          }
        },
        PutIdentityPolicy: {
          input: {
            type: "structure",
            required: [
              "Identity",
              "PolicyName",
              "Policy"
            ],
            members: {
              Identity: {},
              PolicyName: {},
              Policy: {}
            }
          },
          output: {
            resultWrapper: "PutIdentityPolicyResult",
            type: "structure",
            members: {}
          }
        },
        ReorderReceiptRuleSet: {
          input: {
            type: "structure",
            required: [
              "RuleSetName",
              "RuleNames"
            ],
            members: {
              RuleSetName: {},
              RuleNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "ReorderReceiptRuleSetResult",
            type: "structure",
            members: {}
          }
        },
        SendBounce: {
          input: {
            type: "structure",
            required: [
              "OriginalMessageId",
              "BounceSender",
              "BouncedRecipientInfoList"
            ],
            members: {
              OriginalMessageId: {},
              BounceSender: {},
              Explanation: {},
              MessageDsn: {
                type: "structure",
                required: [
                  "ReportingMta"
                ],
                members: {
                  ReportingMta: {},
                  ArrivalDate: {
                    type: "timestamp"
                  },
                  ExtensionFields: {
                    shape: "S5i"
                  }
                }
              },
              BouncedRecipientInfoList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Recipient"
                  ],
                  members: {
                    Recipient: {},
                    RecipientArn: {},
                    BounceType: {},
                    RecipientDsnFields: {
                      type: "structure",
                      required: [
                        "Action",
                        "Status"
                      ],
                      members: {
                        FinalRecipient: {},
                        Action: {},
                        RemoteMta: {},
                        Status: {},
                        DiagnosticCode: {},
                        LastAttemptDate: {
                          type: "timestamp"
                        },
                        ExtensionFields: {
                          shape: "S5i"
                        }
                      }
                    }
                  }
                }
              },
              BounceSenderArn: {}
            }
          },
          output: {
            resultWrapper: "SendBounceResult",
            type: "structure",
            members: {
              MessageId: {}
            }
          }
        },
        SendBulkTemplatedEmail: {
          input: {
            type: "structure",
            required: [
              "Source",
              "Template",
              "Destinations"
            ],
            members: {
              Source: {},
              SourceArn: {},
              ReplyToAddresses: {
                shape: "S54"
              },
              ReturnPath: {},
              ReturnPathArn: {},
              ConfigurationSetName: {},
              DefaultTags: {
                shape: "S5x"
              },
              Template: {},
              TemplateArn: {},
              DefaultTemplateData: {},
              Destinations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Destination"
                  ],
                  members: {
                    Destination: {
                      shape: "S64"
                    },
                    ReplacementTags: {
                      shape: "S5x"
                    },
                    ReplacementTemplateData: {}
                  }
                }
              }
            }
          },
          output: {
            resultWrapper: "SendBulkTemplatedEmailResult",
            type: "structure",
            required: [
              "Status"
            ],
            members: {
              Status: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Status: {},
                    Error: {},
                    MessageId: {}
                  }
                }
              }
            }
          }
        },
        SendCustomVerificationEmail: {
          input: {
            type: "structure",
            required: [
              "EmailAddress",
              "TemplateName"
            ],
            members: {
              EmailAddress: {},
              TemplateName: {},
              ConfigurationSetName: {}
            }
          },
          output: {
            resultWrapper: "SendCustomVerificationEmailResult",
            type: "structure",
            members: {
              MessageId: {}
            }
          }
        },
        SendEmail: {
          input: {
            type: "structure",
            required: [
              "Source",
              "Destination",
              "Message"
            ],
            members: {
              Source: {},
              Destination: {
                shape: "S64"
              },
              Message: {
                type: "structure",
                required: [
                  "Subject",
                  "Body"
                ],
                members: {
                  Subject: {
                    shape: "S6e"
                  },
                  Body: {
                    type: "structure",
                    members: {
                      Text: {
                        shape: "S6e"
                      },
                      Html: {
                        shape: "S6e"
                      }
                    }
                  }
                }
              },
              ReplyToAddresses: {
                shape: "S54"
              },
              ReturnPath: {},
              SourceArn: {},
              ReturnPathArn: {},
              Tags: {
                shape: "S5x"
              },
              ConfigurationSetName: {}
            }
          },
          output: {
            resultWrapper: "SendEmailResult",
            type: "structure",
            required: [
              "MessageId"
            ],
            members: {
              MessageId: {}
            }
          }
        },
        SendRawEmail: {
          input: {
            type: "structure",
            required: [
              "RawMessage"
            ],
            members: {
              Source: {},
              Destinations: {
                shape: "S54"
              },
              RawMessage: {
                type: "structure",
                required: [
                  "Data"
                ],
                members: {
                  Data: {
                    type: "blob"
                  }
                }
              },
              FromArn: {},
              SourceArn: {},
              ReturnPathArn: {},
              Tags: {
                shape: "S5x"
              },
              ConfigurationSetName: {}
            }
          },
          output: {
            resultWrapper: "SendRawEmailResult",
            type: "structure",
            required: [
              "MessageId"
            ],
            members: {
              MessageId: {}
            }
          }
        },
        SendTemplatedEmail: {
          input: {
            type: "structure",
            required: [
              "Source",
              "Destination",
              "Template",
              "TemplateData"
            ],
            members: {
              Source: {},
              Destination: {
                shape: "S64"
              },
              ReplyToAddresses: {
                shape: "S54"
              },
              ReturnPath: {},
              SourceArn: {},
              ReturnPathArn: {},
              Tags: {
                shape: "S5x"
              },
              ConfigurationSetName: {},
              Template: {},
              TemplateArn: {},
              TemplateData: {}
            }
          },
          output: {
            resultWrapper: "SendTemplatedEmailResult",
            type: "structure",
            required: [
              "MessageId"
            ],
            members: {
              MessageId: {}
            }
          }
        },
        SetActiveReceiptRuleSet: {
          input: {
            type: "structure",
            members: {
              RuleSetName: {}
            }
          },
          output: {
            resultWrapper: "SetActiveReceiptRuleSetResult",
            type: "structure",
            members: {}
          }
        },
        SetIdentityDkimEnabled: {
          input: {
            type: "structure",
            required: [
              "Identity",
              "DkimEnabled"
            ],
            members: {
              Identity: {},
              DkimEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "SetIdentityDkimEnabledResult",
            type: "structure",
            members: {}
          }
        },
        SetIdentityFeedbackForwardingEnabled: {
          input: {
            type: "structure",
            required: [
              "Identity",
              "ForwardingEnabled"
            ],
            members: {
              Identity: {},
              ForwardingEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "SetIdentityFeedbackForwardingEnabledResult",
            type: "structure",
            members: {}
          }
        },
        SetIdentityHeadersInNotificationsEnabled: {
          input: {
            type: "structure",
            required: [
              "Identity",
              "NotificationType",
              "Enabled"
            ],
            members: {
              Identity: {},
              NotificationType: {},
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "SetIdentityHeadersInNotificationsEnabledResult",
            type: "structure",
            members: {}
          }
        },
        SetIdentityMailFromDomain: {
          input: {
            type: "structure",
            required: [
              "Identity"
            ],
            members: {
              Identity: {},
              MailFromDomain: {},
              BehaviorOnMXFailure: {}
            }
          },
          output: {
            resultWrapper: "SetIdentityMailFromDomainResult",
            type: "structure",
            members: {}
          }
        },
        SetIdentityNotificationTopic: {
          input: {
            type: "structure",
            required: [
              "Identity",
              "NotificationType"
            ],
            members: {
              Identity: {},
              NotificationType: {},
              SnsTopic: {}
            }
          },
          output: {
            resultWrapper: "SetIdentityNotificationTopicResult",
            type: "structure",
            members: {}
          }
        },
        SetReceiptRulePosition: {
          input: {
            type: "structure",
            required: [
              "RuleSetName",
              "RuleName"
            ],
            members: {
              RuleSetName: {},
              RuleName: {},
              After: {}
            }
          },
          output: {
            resultWrapper: "SetReceiptRulePositionResult",
            type: "structure",
            members: {}
          }
        },
        TestRenderTemplate: {
          input: {
            type: "structure",
            required: [
              "TemplateName",
              "TemplateData"
            ],
            members: {
              TemplateName: {},
              TemplateData: {}
            }
          },
          output: {
            resultWrapper: "TestRenderTemplateResult",
            type: "structure",
            members: {
              RenderedTemplate: {}
            }
          }
        },
        UpdateAccountSendingEnabled: {
          input: {
            type: "structure",
            members: {
              Enabled: {
                type: "boolean"
              }
            }
          }
        },
        UpdateConfigurationSetEventDestination: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestination"
            ],
            members: {
              ConfigurationSetName: {},
              EventDestination: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "UpdateConfigurationSetEventDestinationResult",
            type: "structure",
            members: {}
          }
        },
        UpdateConfigurationSetReputationMetricsEnabled: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "Enabled"
            ],
            members: {
              ConfigurationSetName: {},
              Enabled: {
                type: "boolean"
              }
            }
          }
        },
        UpdateConfigurationSetSendingEnabled: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "Enabled"
            ],
            members: {
              ConfigurationSetName: {},
              Enabled: {
                type: "boolean"
              }
            }
          }
        },
        UpdateConfigurationSetTrackingOptions: {
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "TrackingOptions"
            ],
            members: {
              ConfigurationSetName: {},
              TrackingOptions: {
                shape: "Sp"
              }
            }
          },
          output: {
            resultWrapper: "UpdateConfigurationSetTrackingOptionsResult",
            type: "structure",
            members: {}
          }
        },
        UpdateCustomVerificationEmailTemplate: {
          input: {
            type: "structure",
            required: [
              "TemplateName"
            ],
            members: {
              TemplateName: {},
              FromEmailAddress: {},
              TemplateSubject: {},
              TemplateContent: {},
              SuccessRedirectionURL: {},
              FailureRedirectionURL: {}
            }
          }
        },
        UpdateReceiptRule: {
          input: {
            type: "structure",
            required: [
              "RuleSetName",
              "Rule"
            ],
            members: {
              RuleSetName: {},
              Rule: {
                shape: "S18"
              }
            }
          },
          output: {
            resultWrapper: "UpdateReceiptRuleResult",
            type: "structure",
            members: {}
          }
        },
        UpdateTemplate: {
          input: {
            type: "structure",
            required: [
              "Template"
            ],
            members: {
              Template: {
                shape: "S20"
              }
            }
          },
          output: {
            resultWrapper: "UpdateTemplateResult",
            type: "structure",
            members: {}
          }
        },
        VerifyDomainDkim: {
          input: {
            type: "structure",
            required: [
              "Domain"
            ],
            members: {
              Domain: {}
            }
          },
          output: {
            resultWrapper: "VerifyDomainDkimResult",
            type: "structure",
            required: [
              "DkimTokens"
            ],
            members: {
              DkimTokens: {
                shape: "S3h"
              }
            }
          }
        },
        VerifyDomainIdentity: {
          input: {
            type: "structure",
            required: [
              "Domain"
            ],
            members: {
              Domain: {}
            }
          },
          output: {
            resultWrapper: "VerifyDomainIdentityResult",
            type: "structure",
            required: [
              "VerificationToken"
            ],
            members: {
              VerificationToken: {}
            }
          }
        },
        VerifyEmailAddress: {
          input: {
            type: "structure",
            required: [
              "EmailAddress"
            ],
            members: {
              EmailAddress: {}
            }
          }
        },
        VerifyEmailIdentity: {
          input: {
            type: "structure",
            required: [
              "EmailAddress"
            ],
            members: {
              EmailAddress: {}
            }
          },
          output: {
            resultWrapper: "VerifyEmailIdentityResult",
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {}
          }
        },
        S9: {
          type: "structure",
          required: [
            "Name",
            "MatchingEventTypes"
          ],
          members: {
            Name: {},
            Enabled: {
              type: "boolean"
            },
            MatchingEventTypes: {
              type: "list",
              member: {}
            },
            KinesisFirehoseDestination: {
              type: "structure",
              required: [
                "IAMRoleARN",
                "DeliveryStreamARN"
              ],
              members: {
                IAMRoleARN: {},
                DeliveryStreamARN: {}
              }
            },
            CloudWatchDestination: {
              type: "structure",
              required: [
                "DimensionConfigurations"
              ],
              members: {
                DimensionConfigurations: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "DimensionName",
                      "DimensionValueSource",
                      "DefaultDimensionValue"
                    ],
                    members: {
                      DimensionName: {},
                      DimensionValueSource: {},
                      DefaultDimensionValue: {}
                    }
                  }
                }
              }
            },
            SNSDestination: {
              type: "structure",
              required: [
                "TopicARN"
              ],
              members: {
                TopicARN: {}
              }
            }
          }
        },
        Sp: {
          type: "structure",
          members: {
            CustomRedirectDomain: {}
          }
        },
        S10: {
          type: "structure",
          required: [
            "Name",
            "IpFilter"
          ],
          members: {
            Name: {},
            IpFilter: {
              type: "structure",
              required: [
                "Policy",
                "Cidr"
              ],
              members: {
                Policy: {},
                Cidr: {}
              }
            }
          }
        },
        S18: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            Enabled: {
              type: "boolean"
            },
            TlsPolicy: {},
            Recipients: {
              type: "list",
              member: {}
            },
            Actions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  S3Action: {
                    type: "structure",
                    required: [
                      "BucketName"
                    ],
                    members: {
                      TopicArn: {},
                      BucketName: {},
                      ObjectKeyPrefix: {},
                      KmsKeyArn: {}
                    }
                  },
                  BounceAction: {
                    type: "structure",
                    required: [
                      "SmtpReplyCode",
                      "Message",
                      "Sender"
                    ],
                    members: {
                      TopicArn: {},
                      SmtpReplyCode: {},
                      StatusCode: {},
                      Message: {},
                      Sender: {}
                    }
                  },
                  WorkmailAction: {
                    type: "structure",
                    required: [
                      "OrganizationArn"
                    ],
                    members: {
                      TopicArn: {},
                      OrganizationArn: {}
                    }
                  },
                  LambdaAction: {
                    type: "structure",
                    required: [
                      "FunctionArn"
                    ],
                    members: {
                      TopicArn: {},
                      FunctionArn: {},
                      InvocationType: {}
                    }
                  },
                  StopAction: {
                    type: "structure",
                    required: [
                      "Scope"
                    ],
                    members: {
                      Scope: {},
                      TopicArn: {}
                    }
                  },
                  AddHeaderAction: {
                    type: "structure",
                    required: [
                      "HeaderName",
                      "HeaderValue"
                    ],
                    members: {
                      HeaderName: {},
                      HeaderValue: {}
                    }
                  },
                  SNSAction: {
                    type: "structure",
                    required: [
                      "TopicArn"
                    ],
                    members: {
                      TopicArn: {},
                      Encoding: {}
                    }
                  }
                }
              }
            },
            ScanEnabled: {
              type: "boolean"
            }
          }
        },
        S20: {
          type: "structure",
          required: [
            "TemplateName"
          ],
          members: {
            TemplateName: {},
            SubjectPart: {},
            TextPart: {},
            HtmlPart: {}
          }
        },
        S2t: {
          type: "structure",
          members: {
            Name: {},
            CreatedTimestamp: {
              type: "timestamp"
            }
          }
        },
        S2v: {
          type: "list",
          member: {
            shape: "S18"
          }
        },
        S31: {
          type: "structure",
          members: {
            TlsPolicy: {}
          }
        },
        S3c: {
          type: "list",
          member: {}
        },
        S3h: {
          type: "list",
          member: {}
        },
        S3w: {
          type: "list",
          member: {}
        },
        S54: {
          type: "list",
          member: {}
        },
        S5i: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        S5x: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        S64: {
          type: "structure",
          members: {
            ToAddresses: {
              shape: "S54"
            },
            CcAddresses: {
              shape: "S54"
            },
            BccAddresses: {
              shape: "S54"
            }
          }
        },
        S6e: {
          type: "structure",
          required: [
            "Data"
          ],
          members: {
            Data: {},
            Charset: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/email-2010-12-01.paginators.json
var require_email_2010_12_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/email-2010-12-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListCustomVerificationEmailTemplates: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListIdentities: {
          input_token: "NextToken",
          limit_key: "MaxItems",
          output_token: "NextToken",
          result_key: "Identities"
        },
        ListVerifiedEmailAddresses: {
          result_key: "VerifiedEmailAddresses"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/email-2010-12-01.waiters2.json
var require_email_2010_12_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/email-2010-12-01.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        IdentityExists: {
          delay: 3,
          operation: "GetIdentityVerificationAttributes",
          maxAttempts: 20,
          acceptors: [
            {
              expected: "Success",
              matcher: "pathAll",
              state: "success",
              argument: "VerificationAttributes.*.VerificationStatus"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ses.js
var require_ses = __commonJS({
  "node_modules/aws-sdk/clients/ses.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["ses"] = {};
    AWS3.SES = Service.defineService("ses", ["2010-12-01"]);
    Object.defineProperty(apiLoader.services["ses"], "2010-12-01", {
      get: function get() {
        var model = require_email_2010_12_01_min();
        model.paginators = require_email_2010_12_01_paginators().pagination;
        model.waiters = require_email_2010_12_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SES;
  }
});

// node_modules/aws-sdk/apis/shield-2016-06-02.min.json
var require_shield_2016_06_02_min = __commonJS({
  "node_modules/aws-sdk/apis/shield-2016-06-02.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-06-02",
        endpointPrefix: "shield",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "AWS Shield",
        serviceFullName: "AWS Shield",
        serviceId: "Shield",
        signatureVersion: "v4",
        targetPrefix: "AWSShield_20160616",
        uid: "shield-2016-06-02"
      },
      operations: {
        AssociateDRTLogBucket: {
          input: {
            type: "structure",
            required: [
              "LogBucket"
            ],
            members: {
              LogBucket: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateDRTRole: {
          input: {
            type: "structure",
            required: [
              "RoleArn"
            ],
            members: {
              RoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateHealthCheck: {
          input: {
            type: "structure",
            required: [
              "ProtectionId",
              "HealthCheckArn"
            ],
            members: {
              ProtectionId: {},
              HealthCheckArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateProactiveEngagementDetails: {
          input: {
            type: "structure",
            required: [
              "EmergencyContactList"
            ],
            members: {
              EmergencyContactList: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateProtection: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ResourceArn"
            ],
            members: {
              Name: {},
              ResourceArn: {},
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProtectionId: {}
            }
          }
        },
        CreateProtectionGroup: {
          input: {
            type: "structure",
            required: [
              "ProtectionGroupId",
              "Aggregation",
              "Pattern"
            ],
            members: {
              ProtectionGroupId: {},
              Aggregation: {},
              Pattern: {},
              ResourceType: {},
              Members: {
                shape: "Sv"
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateSubscription: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteProtection: {
          input: {
            type: "structure",
            required: [
              "ProtectionId"
            ],
            members: {
              ProtectionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteProtectionGroup: {
          input: {
            type: "structure",
            required: [
              "ProtectionGroupId"
            ],
            members: {
              ProtectionGroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSubscription: {
          input: {
            type: "structure",
            members: {},
            deprecated: true
          },
          output: {
            type: "structure",
            members: {},
            deprecated: true
          },
          deprecated: true
        },
        DescribeAttack: {
          input: {
            type: "structure",
            required: [
              "AttackId"
            ],
            members: {
              AttackId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Attack: {
                type: "structure",
                members: {
                  AttackId: {},
                  ResourceArn: {},
                  SubResources: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Type: {},
                        Id: {},
                        AttackVectors: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "VectorType"
                            ],
                            members: {
                              VectorType: {},
                              VectorCounters: {
                                shape: "S1f"
                              }
                            }
                          }
                        },
                        Counters: {
                          shape: "S1f"
                        }
                      }
                    }
                  },
                  StartTime: {
                    type: "timestamp"
                  },
                  EndTime: {
                    type: "timestamp"
                  },
                  AttackCounters: {
                    shape: "S1f"
                  },
                  AttackProperties: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        AttackLayer: {},
                        AttackPropertyIdentifier: {},
                        TopContributors: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Name: {},
                              Value: {
                                type: "long"
                              }
                            }
                          }
                        },
                        Unit: {},
                        Total: {
                          type: "long"
                        }
                      }
                    }
                  },
                  Mitigations: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        MitigationName: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeAttackStatistics: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "TimeRange",
              "DataItems"
            ],
            members: {
              TimeRange: {
                shape: "S1w"
              },
              DataItems: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AttackCount"
                  ],
                  members: {
                    AttackVolume: {
                      type: "structure",
                      members: {
                        BitsPerSecond: {
                          shape: "S20"
                        },
                        PacketsPerSecond: {
                          shape: "S20"
                        },
                        RequestsPerSecond: {
                          shape: "S20"
                        }
                      }
                    },
                    AttackCount: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeDRTAccess: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              RoleArn: {},
              LogBucketList: {
                type: "list",
                member: {}
              }
            }
          }
        },
        DescribeEmergencyContactSettings: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              EmergencyContactList: {
                shape: "Sc"
              }
            }
          }
        },
        DescribeProtection: {
          input: {
            type: "structure",
            members: {
              ProtectionId: {},
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Protection: {
                shape: "S28"
              }
            }
          }
        },
        DescribeProtectionGroup: {
          input: {
            type: "structure",
            required: [
              "ProtectionGroupId"
            ],
            members: {
              ProtectionGroupId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ProtectionGroup"
            ],
            members: {
              ProtectionGroup: {
                shape: "S2d"
              }
            }
          }
        },
        DescribeSubscription: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Subscription: {
                type: "structure",
                required: [
                  "SubscriptionLimits"
                ],
                members: {
                  StartTime: {
                    type: "timestamp"
                  },
                  EndTime: {
                    type: "timestamp"
                  },
                  TimeCommitmentInSeconds: {
                    type: "long"
                  },
                  AutoRenew: {},
                  Limits: {
                    shape: "S2k"
                  },
                  ProactiveEngagementStatus: {},
                  SubscriptionLimits: {
                    type: "structure",
                    required: [
                      "ProtectionLimits",
                      "ProtectionGroupLimits"
                    ],
                    members: {
                      ProtectionLimits: {
                        type: "structure",
                        required: [
                          "ProtectedResourceTypeLimits"
                        ],
                        members: {
                          ProtectedResourceTypeLimits: {
                            shape: "S2k"
                          }
                        }
                      },
                      ProtectionGroupLimits: {
                        type: "structure",
                        required: [
                          "MaxProtectionGroups",
                          "PatternTypeLimits"
                        ],
                        members: {
                          MaxProtectionGroups: {
                            type: "long"
                          },
                          PatternTypeLimits: {
                            type: "structure",
                            required: [
                              "ArbitraryPatternLimits"
                            ],
                            members: {
                              ArbitraryPatternLimits: {
                                type: "structure",
                                required: [
                                  "MaxMembers"
                                ],
                                members: {
                                  MaxMembers: {
                                    type: "long"
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  SubscriptionArn: {}
                }
              }
            }
          }
        },
        DisableProactiveEngagement: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateDRTLogBucket: {
          input: {
            type: "structure",
            required: [
              "LogBucket"
            ],
            members: {
              LogBucket: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateDRTRole: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateHealthCheck: {
          input: {
            type: "structure",
            required: [
              "ProtectionId",
              "HealthCheckArn"
            ],
            members: {
              ProtectionId: {},
              HealthCheckArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableProactiveEngagement: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetSubscriptionState: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "SubscriptionState"
            ],
            members: {
              SubscriptionState: {}
            }
          }
        },
        ListAttacks: {
          input: {
            type: "structure",
            members: {
              ResourceArns: {
                type: "list",
                member: {}
              },
              StartTime: {
                shape: "S1w"
              },
              EndTime: {
                shape: "S1w"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AttackSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AttackId: {},
                    ResourceArn: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    AttackVectors: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "VectorType"
                        ],
                        members: {
                          VectorType: {}
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProtectionGroups: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ProtectionGroups"
            ],
            members: {
              ProtectionGroups: {
                type: "list",
                member: {
                  shape: "S2d"
                }
              },
              NextToken: {}
            }
          }
        },
        ListProtections: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Protections: {
                type: "list",
                member: {
                  shape: "S28"
                }
              },
              NextToken: {}
            }
          }
        },
        ListResourcesInProtectionGroup: {
          input: {
            type: "structure",
            required: [
              "ProtectionGroupId"
            ],
            members: {
              ProtectionGroupId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourceArns"
            ],
            members: {
              ResourceArns: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sl"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEmergencyContactSettings: {
          input: {
            type: "structure",
            members: {
              EmergencyContactList: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateProtectionGroup: {
          input: {
            type: "structure",
            required: [
              "ProtectionGroupId",
              "Aggregation",
              "Pattern"
            ],
            members: {
              ProtectionGroupId: {},
              Aggregation: {},
              Pattern: {},
              ResourceType: {},
              Members: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateSubscription: {
          input: {
            type: "structure",
            members: {
              AutoRenew: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sc: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "EmailAddress"
            ],
            members: {
              EmailAddress: {},
              PhoneNumber: {},
              ContactNotes: {}
            }
          }
        },
        Sl: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sv: {
          type: "list",
          member: {}
        },
        S1f: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Max: {
                type: "double"
              },
              Average: {
                type: "double"
              },
              Sum: {
                type: "double"
              },
              N: {
                type: "integer"
              },
              Unit: {}
            }
          }
        },
        S1w: {
          type: "structure",
          members: {
            FromInclusive: {
              type: "timestamp"
            },
            ToExclusive: {
              type: "timestamp"
            }
          }
        },
        S20: {
          type: "structure",
          required: [
            "Max"
          ],
          members: {
            Max: {
              type: "double"
            }
          }
        },
        S28: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            ResourceArn: {},
            HealthCheckIds: {
              type: "list",
              member: {}
            },
            ProtectionArn: {}
          }
        },
        S2d: {
          type: "structure",
          required: [
            "ProtectionGroupId",
            "Aggregation",
            "Pattern",
            "Members"
          ],
          members: {
            ProtectionGroupId: {},
            Aggregation: {},
            Pattern: {},
            ResourceType: {},
            Members: {
              shape: "Sv"
            },
            ProtectionGroupArn: {}
          }
        },
        S2k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              Max: {
                type: "long"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/shield-2016-06-02.paginators.json
var require_shield_2016_06_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/shield-2016-06-02.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAttacks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AttackSummaries"
        },
        ListProtectionGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListProtections: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Protections"
        },
        ListResourcesInProtectionGroup: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/shield.js
var require_shield = __commonJS({
  "node_modules/aws-sdk/clients/shield.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["shield"] = {};
    AWS3.Shield = Service.defineService("shield", ["2016-06-02"]);
    Object.defineProperty(apiLoader.services["shield"], "2016-06-02", {
      get: function get() {
        var model = require_shield_2016_06_02_min();
        model.paginators = require_shield_2016_06_02_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Shield;
  }
});

// node_modules/aws-sdk/apis/sdb-2009-04-15.min.json
var require_sdb_2009_04_15_min = __commonJS({
  "node_modules/aws-sdk/apis/sdb-2009-04-15.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2009-04-15",
        endpointPrefix: "sdb",
        serviceFullName: "Amazon SimpleDB",
        serviceId: "SimpleDB",
        signatureVersion: "v2",
        xmlNamespace: "http://sdb.amazonaws.com/doc/2009-04-15/",
        protocol: "query"
      },
      operations: {
        BatchDeleteAttributes: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Items"
            ],
            members: {
              DomainName: {},
              Items: {
                type: "list",
                member: {
                  locationName: "Item",
                  type: "structure",
                  required: [
                    "Name"
                  ],
                  members: {
                    Name: {
                      locationName: "ItemName"
                    },
                    Attributes: {
                      shape: "S5"
                    }
                  }
                },
                flattened: true
              }
            }
          }
        },
        BatchPutAttributes: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Items"
            ],
            members: {
              DomainName: {},
              Items: {
                type: "list",
                member: {
                  locationName: "Item",
                  type: "structure",
                  required: [
                    "Name",
                    "Attributes"
                  ],
                  members: {
                    Name: {
                      locationName: "ItemName"
                    },
                    Attributes: {
                      shape: "Sa"
                    }
                  }
                },
                flattened: true
              }
            }
          }
        },
        CreateDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          }
        },
        DeleteAttributes: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ItemName"
            ],
            members: {
              DomainName: {},
              ItemName: {},
              Attributes: {
                shape: "S5"
              },
              Expected: {
                shape: "Sf"
              }
            }
          }
        },
        DeleteDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          }
        },
        DomainMetadata: {
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            resultWrapper: "DomainMetadataResult",
            type: "structure",
            members: {
              ItemCount: {
                type: "integer"
              },
              ItemNamesSizeBytes: {
                type: "long"
              },
              AttributeNameCount: {
                type: "integer"
              },
              AttributeNamesSizeBytes: {
                type: "long"
              },
              AttributeValueCount: {
                type: "integer"
              },
              AttributeValuesSizeBytes: {
                type: "long"
              },
              Timestamp: {
                type: "integer"
              }
            }
          }
        },
        GetAttributes: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ItemName"
            ],
            members: {
              DomainName: {},
              ItemName: {},
              AttributeNames: {
                type: "list",
                member: {
                  locationName: "AttributeName"
                },
                flattened: true
              },
              ConsistentRead: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "GetAttributesResult",
            type: "structure",
            members: {
              Attributes: {
                shape: "So"
              }
            }
          }
        },
        ListDomains: {
          input: {
            type: "structure",
            members: {
              MaxNumberOfDomains: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListDomainsResult",
            type: "structure",
            members: {
              DomainNames: {
                type: "list",
                member: {
                  locationName: "DomainName"
                },
                flattened: true
              },
              NextToken: {}
            }
          }
        },
        PutAttributes: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ItemName",
              "Attributes"
            ],
            members: {
              DomainName: {},
              ItemName: {},
              Attributes: {
                shape: "Sa"
              },
              Expected: {
                shape: "Sf"
              }
            }
          }
        },
        Select: {
          input: {
            type: "structure",
            required: [
              "SelectExpression"
            ],
            members: {
              SelectExpression: {},
              NextToken: {},
              ConsistentRead: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "SelectResult",
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  locationName: "Item",
                  type: "structure",
                  required: [
                    "Name",
                    "Attributes"
                  ],
                  members: {
                    Name: {},
                    AlternateNameEncoding: {},
                    Attributes: {
                      shape: "So"
                    }
                  }
                },
                flattened: true
              },
              NextToken: {}
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {
            locationName: "Attribute",
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Value: {}
            }
          },
          flattened: true
        },
        Sa: {
          type: "list",
          member: {
            locationName: "Attribute",
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {},
              Replace: {
                type: "boolean"
              }
            }
          },
          flattened: true
        },
        Sf: {
          type: "structure",
          members: {
            Name: {},
            Value: {},
            Exists: {
              type: "boolean"
            }
          }
        },
        So: {
          type: "list",
          member: {
            locationName: "Attribute",
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              AlternateNameEncoding: {},
              Value: {},
              AlternateValueEncoding: {}
            }
          },
          flattened: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sdb-2009-04-15.paginators.json
var require_sdb_2009_04_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sdb-2009-04-15.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListDomains: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxNumberOfDomains",
          result_key: "DomainNames"
        },
        Select: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/simpledb.js
var require_simpledb = __commonJS({
  "node_modules/aws-sdk/clients/simpledb.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["simpledb"] = {};
    AWS3.SimpleDB = Service.defineService("simpledb", ["2009-04-15"]);
    Object.defineProperty(apiLoader.services["simpledb"], "2009-04-15", {
      get: function get() {
        var model = require_sdb_2009_04_15_min();
        model.paginators = require_sdb_2009_04_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SimpleDB;
  }
});

// node_modules/aws-sdk/apis/sms-2016-10-24.min.json
var require_sms_2016_10_24_min = __commonJS({
  "node_modules/aws-sdk/apis/sms-2016-10-24.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-10-24",
        endpointPrefix: "sms",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "SMS",
        serviceFullName: "AWS Server Migration Service",
        serviceId: "SMS",
        signatureVersion: "v4",
        targetPrefix: "AWSServerMigrationService_V2016_10_24",
        uid: "sms-2016-10-24"
      },
      operations: {
        CreateApp: {
          input: {
            type: "structure",
            members: {
              name: {},
              description: {},
              roleName: {},
              clientToken: {},
              serverGroups: {
                shape: "S6"
              },
              tags: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              appSummary: {
                shape: "St"
              },
              serverGroups: {
                shape: "S6"
              },
              tags: {
                shape: "So"
              }
            }
          }
        },
        CreateReplicationJob: {
          input: {
            type: "structure",
            required: [
              "serverId",
              "seedReplicationTime"
            ],
            members: {
              serverId: {},
              seedReplicationTime: {
                type: "timestamp"
              },
              frequency: {
                type: "integer"
              },
              runOnce: {
                type: "boolean"
              },
              licenseType: {},
              roleName: {},
              description: {},
              numberOfRecentAmisToKeep: {
                type: "integer"
              },
              encrypted: {
                type: "boolean"
              },
              kmsKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              replicationJobId: {}
            }
          }
        },
        DeleteApp: {
          input: {
            type: "structure",
            members: {
              appId: {},
              forceStopAppReplication: {
                type: "boolean"
              },
              forceTerminateApp: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAppLaunchConfiguration: {
          input: {
            type: "structure",
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAppReplicationConfiguration: {
          input: {
            type: "structure",
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAppValidationConfiguration: {
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteReplicationJob: {
          input: {
            type: "structure",
            required: [
              "replicationJobId"
            ],
            members: {
              replicationJobId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteServerCatalog: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateConnector: {
          input: {
            type: "structure",
            required: [
              "connectorId"
            ],
            members: {
              connectorId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GenerateChangeSet: {
          input: {
            type: "structure",
            members: {
              appId: {},
              changesetFormat: {}
            }
          },
          output: {
            type: "structure",
            members: {
              s3Location: {
                shape: "S24"
              }
            }
          }
        },
        GenerateTemplate: {
          input: {
            type: "structure",
            members: {
              appId: {},
              templateFormat: {}
            }
          },
          output: {
            type: "structure",
            members: {
              s3Location: {
                shape: "S24"
              }
            }
          }
        },
        GetApp: {
          input: {
            type: "structure",
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              appSummary: {
                shape: "St"
              },
              serverGroups: {
                shape: "S6"
              },
              tags: {
                shape: "So"
              }
            }
          }
        },
        GetAppLaunchConfiguration: {
          input: {
            type: "structure",
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              appId: {},
              roleName: {},
              autoLaunch: {
                type: "boolean"
              },
              serverGroupLaunchConfigurations: {
                shape: "S2e"
              }
            }
          }
        },
        GetAppReplicationConfiguration: {
          input: {
            type: "structure",
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              serverGroupReplicationConfigurations: {
                shape: "S2u"
              }
            }
          }
        },
        GetAppValidationConfiguration: {
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              appValidationConfigurations: {
                shape: "S31"
              },
              serverGroupValidationConfigurations: {
                shape: "S3c"
              }
            }
          }
        },
        GetAppValidationOutput: {
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              validationOutputList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    validationId: {},
                    name: {},
                    status: {},
                    statusMessage: {},
                    latestValidationTime: {
                      type: "timestamp"
                    },
                    appValidationOutput: {
                      type: "structure",
                      members: {
                        ssmOutput: {
                          type: "structure",
                          members: {
                            s3Location: {
                              shape: "S24"
                            }
                          }
                        }
                      }
                    },
                    serverValidationOutput: {
                      type: "structure",
                      members: {
                        server: {
                          shape: "Sb"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetConnectors: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              connectorList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    connectorId: {},
                    version: {},
                    status: {},
                    capabilityList: {
                      type: "list",
                      member: {}
                    },
                    vmManagerName: {},
                    vmManagerType: {},
                    vmManagerId: {},
                    ipAddress: {},
                    macAddress: {},
                    associatedOn: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetReplicationJobs: {
          input: {
            type: "structure",
            members: {
              replicationJobId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              replicationJobList: {
                type: "list",
                member: {
                  shape: "S46"
                }
              },
              nextToken: {}
            }
          }
        },
        GetReplicationRuns: {
          input: {
            type: "structure",
            required: [
              "replicationJobId"
            ],
            members: {
              replicationJobId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              replicationJob: {
                shape: "S46"
              },
              replicationRunList: {
                shape: "S4a"
              },
              nextToken: {}
            }
          }
        },
        GetServers: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              vmServerAddressList: {
                type: "list",
                member: {
                  shape: "Sf"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              lastModifiedOn: {
                type: "timestamp"
              },
              serverCatalogStatus: {},
              serverList: {
                shape: "Sa"
              },
              nextToken: {}
            }
          }
        },
        ImportAppCatalog: {
          input: {
            type: "structure",
            members: {
              roleName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ImportServerCatalog: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        LaunchApp: {
          input: {
            type: "structure",
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListApps: {
          input: {
            type: "structure",
            members: {
              appIds: {
                type: "list",
                member: {}
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              apps: {
                type: "list",
                member: {
                  shape: "St"
                }
              },
              nextToken: {}
            }
          }
        },
        NotifyAppValidationOutput: {
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {},
              notificationContext: {
                type: "structure",
                members: {
                  validationId: {},
                  status: {},
                  statusMessage: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutAppLaunchConfiguration: {
          input: {
            type: "structure",
            members: {
              appId: {},
              roleName: {},
              autoLaunch: {
                type: "boolean"
              },
              serverGroupLaunchConfigurations: {
                shape: "S2e"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutAppReplicationConfiguration: {
          input: {
            type: "structure",
            members: {
              appId: {},
              serverGroupReplicationConfigurations: {
                shape: "S2u"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutAppValidationConfiguration: {
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {},
              appValidationConfigurations: {
                shape: "S31"
              },
              serverGroupValidationConfigurations: {
                shape: "S3c"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartAppReplication: {
          input: {
            type: "structure",
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartOnDemandAppReplication: {
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartOnDemandReplicationRun: {
          input: {
            type: "structure",
            required: [
              "replicationJobId"
            ],
            members: {
              replicationJobId: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              replicationRunId: {}
            }
          }
        },
        StopAppReplication: {
          input: {
            type: "structure",
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TerminateApp: {
          input: {
            type: "structure",
            members: {
              appId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApp: {
          input: {
            type: "structure",
            members: {
              appId: {},
              name: {},
              description: {},
              roleName: {},
              serverGroups: {
                shape: "S6"
              },
              tags: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              appSummary: {
                shape: "St"
              },
              serverGroups: {
                shape: "S6"
              },
              tags: {
                shape: "So"
              }
            }
          }
        },
        UpdateReplicationJob: {
          input: {
            type: "structure",
            required: [
              "replicationJobId"
            ],
            members: {
              replicationJobId: {},
              frequency: {
                type: "integer"
              },
              nextReplicationRunStartTime: {
                type: "timestamp"
              },
              licenseType: {},
              roleName: {},
              description: {},
              numberOfRecentAmisToKeep: {
                type: "integer"
              },
              encrypted: {
                type: "boolean"
              },
              kmsKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S6: {
          type: "list",
          member: {
            type: "structure",
            members: {
              serverGroupId: {},
              name: {},
              serverList: {
                shape: "Sa"
              }
            }
          }
        },
        Sa: {
          type: "list",
          member: {
            shape: "Sb"
          }
        },
        Sb: {
          type: "structure",
          members: {
            serverId: {},
            serverType: {},
            vmServer: {
              shape: "Se"
            },
            replicationJobId: {},
            replicationJobTerminated: {
              type: "boolean"
            }
          }
        },
        Se: {
          type: "structure",
          members: {
            vmServerAddress: {
              shape: "Sf"
            },
            vmName: {},
            vmManagerName: {},
            vmManagerType: {},
            vmPath: {}
          }
        },
        Sf: {
          type: "structure",
          members: {
            vmManagerId: {},
            vmId: {}
          }
        },
        So: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {}
            }
          }
        },
        St: {
          type: "structure",
          members: {
            appId: {},
            importedAppId: {},
            name: {},
            description: {},
            status: {},
            statusMessage: {},
            replicationConfigurationStatus: {},
            replicationStatus: {},
            replicationStatusMessage: {},
            latestReplicationTime: {
              type: "timestamp"
            },
            launchConfigurationStatus: {},
            launchStatus: {},
            launchStatusMessage: {},
            launchDetails: {
              type: "structure",
              members: {
                latestLaunchTime: {
                  type: "timestamp"
                },
                stackName: {},
                stackId: {}
              }
            },
            creationTime: {
              type: "timestamp"
            },
            lastModified: {
              type: "timestamp"
            },
            roleName: {},
            totalServerGroups: {
              type: "integer"
            },
            totalServers: {
              type: "integer"
            }
          }
        },
        S24: {
          type: "structure",
          members: {
            bucket: {},
            key: {}
          }
        },
        S2e: {
          type: "list",
          member: {
            type: "structure",
            members: {
              serverGroupId: {},
              launchOrder: {
                type: "integer"
              },
              serverLaunchConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    server: {
                      shape: "Sb"
                    },
                    logicalId: {},
                    vpc: {},
                    subnet: {},
                    securityGroup: {},
                    ec2KeyName: {},
                    userData: {
                      type: "structure",
                      members: {
                        s3Location: {
                          shape: "S24"
                        }
                      }
                    },
                    instanceType: {},
                    associatePublicIpAddress: {
                      type: "boolean"
                    },
                    iamInstanceProfileName: {},
                    configureScript: {
                      shape: "S24"
                    },
                    configureScriptType: {}
                  }
                }
              }
            }
          }
        },
        S2u: {
          type: "list",
          member: {
            type: "structure",
            members: {
              serverGroupId: {},
              serverReplicationConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    server: {
                      shape: "Sb"
                    },
                    serverReplicationParameters: {
                      type: "structure",
                      members: {
                        seedTime: {
                          type: "timestamp"
                        },
                        frequency: {
                          type: "integer"
                        },
                        runOnce: {
                          type: "boolean"
                        },
                        licenseType: {},
                        numberOfRecentAmisToKeep: {
                          type: "integer"
                        },
                        encrypted: {
                          type: "boolean"
                        },
                        kmsKeyId: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S31: {
          type: "list",
          member: {
            type: "structure",
            members: {
              validationId: {},
              name: {},
              appValidationStrategy: {},
              ssmValidationParameters: {
                type: "structure",
                members: {
                  source: {
                    shape: "S37"
                  },
                  instanceId: {},
                  scriptType: {},
                  command: {},
                  executionTimeoutSeconds: {
                    type: "integer"
                  },
                  outputS3BucketName: {}
                }
              }
            }
          }
        },
        S37: {
          type: "structure",
          members: {
            s3Location: {
              shape: "S24"
            }
          }
        },
        S3c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              serverGroupId: {},
              serverValidationConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    server: {
                      shape: "Sb"
                    },
                    validationId: {},
                    name: {},
                    serverValidationStrategy: {},
                    userDataValidationParameters: {
                      type: "structure",
                      members: {
                        source: {
                          shape: "S37"
                        },
                        scriptType: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S46: {
          type: "structure",
          members: {
            replicationJobId: {},
            serverId: {},
            serverType: {},
            vmServer: {
              shape: "Se"
            },
            seedReplicationTime: {
              type: "timestamp"
            },
            frequency: {
              type: "integer"
            },
            runOnce: {
              type: "boolean"
            },
            nextReplicationRunStartTime: {
              type: "timestamp"
            },
            licenseType: {},
            roleName: {},
            latestAmiId: {},
            state: {},
            statusMessage: {},
            description: {},
            numberOfRecentAmisToKeep: {
              type: "integer"
            },
            encrypted: {
              type: "boolean"
            },
            kmsKeyId: {},
            replicationRunList: {
              shape: "S4a"
            }
          }
        },
        S4a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              replicationRunId: {},
              state: {},
              type: {},
              stageDetails: {
                type: "structure",
                members: {
                  stage: {},
                  stageProgress: {}
                }
              },
              statusMessage: {},
              amiId: {},
              scheduledStartTime: {
                type: "timestamp"
              },
              completedTime: {
                type: "timestamp"
              },
              description: {},
              encrypted: {
                type: "boolean"
              },
              kmsKeyId: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sms-2016-10-24.paginators.json
var require_sms_2016_10_24_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sms-2016-10-24.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetConnectors: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "connectorList"
        },
        GetReplicationJobs: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "replicationJobList"
        },
        GetReplicationRuns: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "replicationRunList"
        },
        GetServers: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "serverList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/sms.js
var require_sms = __commonJS({
  "node_modules/aws-sdk/clients/sms.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["sms"] = {};
    AWS3.SMS = Service.defineService("sms", ["2016-10-24"]);
    Object.defineProperty(apiLoader.services["sms"], "2016-10-24", {
      get: function get() {
        var model = require_sms_2016_10_24_min();
        model.paginators = require_sms_2016_10_24_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SMS;
  }
});

// node_modules/aws-sdk/apis/snowball-2016-06-30.min.json
var require_snowball_2016_06_30_min = __commonJS({
  "node_modules/aws-sdk/apis/snowball-2016-06-30.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-06-30",
        endpointPrefix: "snowball",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Amazon Snowball",
        serviceFullName: "Amazon Import/Export Snowball",
        serviceId: "Snowball",
        signatureVersion: "v4",
        targetPrefix: "AWSIESnowballJobManagementService",
        uid: "snowball-2016-06-30"
      },
      operations: {
        CancelCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateAddress: {
          input: {
            type: "structure",
            required: [
              "Address"
            ],
            members: {
              Address: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AddressId: {}
            }
          }
        },
        CreateCluster: {
          input: {
            type: "structure",
            required: [
              "JobType",
              "Resources",
              "AddressId",
              "RoleARN",
              "SnowballType",
              "ShippingOption"
            ],
            members: {
              JobType: {},
              Resources: {
                shape: "Sf"
              },
              OnDeviceServiceConfiguration: {
                shape: "Sv"
              },
              Description: {},
              AddressId: {},
              KmsKeyARN: {},
              RoleARN: {},
              SnowballType: {},
              ShippingOption: {},
              Notification: {
                shape: "S13"
              },
              ForwardingAddressId: {},
              TaxDocuments: {
                shape: "S17"
              },
              RemoteManagement: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ClusterId: {}
            }
          }
        },
        CreateJob: {
          input: {
            type: "structure",
            members: {
              JobType: {},
              Resources: {
                shape: "Sf"
              },
              OnDeviceServiceConfiguration: {
                shape: "Sv"
              },
              Description: {},
              AddressId: {},
              KmsKeyARN: {},
              RoleARN: {},
              SnowballCapacityPreference: {},
              ShippingOption: {},
              Notification: {
                shape: "S13"
              },
              ClusterId: {},
              SnowballType: {},
              ForwardingAddressId: {},
              TaxDocuments: {
                shape: "S17"
              },
              DeviceConfiguration: {
                shape: "S1e"
              },
              RemoteManagement: {},
              LongTermPricingId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        CreateLongTermPricing: {
          input: {
            type: "structure",
            required: [
              "LongTermPricingType"
            ],
            members: {
              LongTermPricingType: {},
              IsLongTermPricingAutoRenew: {
                type: "boolean"
              },
              SnowballType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LongTermPricingId: {}
            }
          }
        },
        CreateReturnShippingLabel: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              ShippingOption: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        },
        DescribeAddress: {
          input: {
            type: "structure",
            required: [
              "AddressId"
            ],
            members: {
              AddressId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Address: {
                shape: "S8"
              }
            }
          }
        },
        DescribeAddresses: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Addresses: {
                type: "list",
                member: {
                  shape: "S8"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ClusterMetadata: {
                type: "structure",
                members: {
                  ClusterId: {},
                  Description: {},
                  KmsKeyARN: {},
                  RoleARN: {},
                  ClusterState: {},
                  JobType: {},
                  SnowballType: {},
                  CreationDate: {
                    type: "timestamp"
                  },
                  Resources: {
                    shape: "Sf"
                  },
                  AddressId: {},
                  ShippingOption: {},
                  Notification: {
                    shape: "S13"
                  },
                  ForwardingAddressId: {},
                  TaxDocuments: {
                    shape: "S17"
                  },
                  OnDeviceServiceConfiguration: {
                    shape: "Sv"
                  }
                }
              }
            }
          }
        },
        DescribeJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobMetadata: {
                shape: "S23"
              },
              SubJobMetadata: {
                type: "list",
                member: {
                  shape: "S23"
                }
              }
            }
          }
        },
        DescribeReturnShippingLabel: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              ExpirationDate: {
                type: "timestamp"
              }
            }
          }
        },
        GetJobManifest: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ManifestURI: {}
            }
          }
        },
        GetJobUnlockCode: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UnlockCode: {}
            }
          }
        },
        GetSnowballUsage: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              SnowballLimit: {
                type: "integer"
              },
              SnowballsInUse: {
                type: "integer"
              }
            }
          }
        },
        GetSoftwareUpdates: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UpdatesURI: {}
            }
          }
        },
        ListClusterJobs: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobListEntries: {
                shape: "S2n"
              },
              NextToken: {}
            }
          }
        },
        ListClusters: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ClusterListEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ClusterId: {},
                    ClusterState: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    Description: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCompatibleImages: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CompatibleImages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AmiId: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListJobs: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobListEntries: {
                shape: "S2n"
              },
              NextToken: {}
            }
          }
        },
        ListLongTermPricing: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LongTermPricingEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LongTermPricingId: {},
                    LongTermPricingEndDate: {
                      type: "timestamp"
                    },
                    LongTermPricingStartDate: {
                      type: "timestamp"
                    },
                    LongTermPricingType: {},
                    CurrentActiveJob: {},
                    ReplacementJob: {},
                    IsLongTermPricingAutoRenew: {
                      type: "boolean"
                    },
                    LongTermPricingStatus: {},
                    SnowballType: {},
                    JobIds: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        UpdateCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              RoleARN: {},
              Description: {},
              Resources: {
                shape: "Sf"
              },
              OnDeviceServiceConfiguration: {
                shape: "Sv"
              },
              AddressId: {},
              ShippingOption: {},
              Notification: {
                shape: "S13"
              },
              ForwardingAddressId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              RoleARN: {},
              Notification: {
                shape: "S13"
              },
              Resources: {
                shape: "Sf"
              },
              OnDeviceServiceConfiguration: {
                shape: "Sv"
              },
              AddressId: {},
              ShippingOption: {},
              Description: {},
              SnowballCapacityPreference: {},
              ForwardingAddressId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateJobShipmentState: {
          input: {
            type: "structure",
            required: [
              "JobId",
              "ShipmentState"
            ],
            members: {
              JobId: {},
              ShipmentState: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLongTermPricing: {
          input: {
            type: "structure",
            required: [
              "LongTermPricingId"
            ],
            members: {
              LongTermPricingId: {},
              ReplacementJob: {},
              IsLongTermPricingAutoRenew: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S8: {
          type: "structure",
          members: {
            AddressId: {},
            Name: {},
            Company: {},
            Street1: {},
            Street2: {},
            Street3: {},
            City: {},
            StateOrProvince: {},
            PrefectureOrDistrict: {},
            Landmark: {},
            Country: {},
            PostalCode: {},
            PhoneNumber: {},
            IsRestricted: {
              type: "boolean"
            }
          }
        },
        Sf: {
          type: "structure",
          members: {
            S3Resources: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  BucketArn: {},
                  KeyRange: {
                    type: "structure",
                    members: {
                      BeginMarker: {},
                      EndMarker: {}
                    }
                  },
                  TargetOnDeviceServices: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ServiceName: {},
                        TransferOption: {}
                      }
                    }
                  }
                }
              }
            },
            LambdaResources: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  LambdaArn: {},
                  EventTriggers: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        EventResourceARN: {}
                      }
                    }
                  }
                }
              }
            },
            Ec2AmiResources: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "AmiId"
                ],
                members: {
                  AmiId: {},
                  SnowballAmiId: {}
                }
              }
            }
          }
        },
        Sv: {
          type: "structure",
          members: {
            NFSOnDeviceService: {
              type: "structure",
              members: {
                StorageLimit: {
                  type: "integer"
                },
                StorageUnit: {}
              }
            }
          }
        },
        S13: {
          type: "structure",
          members: {
            SnsTopicARN: {},
            JobStatesToNotify: {
              type: "list",
              member: {}
            },
            NotifyAll: {
              type: "boolean"
            }
          }
        },
        S17: {
          type: "structure",
          members: {
            IND: {
              type: "structure",
              members: {
                GSTIN: {}
              }
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            SnowconeDeviceConfiguration: {
              type: "structure",
              members: {
                WirelessConnection: {
                  type: "structure",
                  members: {
                    IsWifiEnabled: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        S23: {
          type: "structure",
          members: {
            JobId: {},
            JobState: {},
            JobType: {},
            SnowballType: {},
            CreationDate: {
              type: "timestamp"
            },
            Resources: {
              shape: "Sf"
            },
            Description: {},
            KmsKeyARN: {},
            RoleARN: {},
            AddressId: {},
            ShippingDetails: {
              type: "structure",
              members: {
                ShippingOption: {},
                InboundShipment: {
                  shape: "S25"
                },
                OutboundShipment: {
                  shape: "S25"
                }
              }
            },
            SnowballCapacityPreference: {},
            Notification: {
              shape: "S13"
            },
            DataTransferProgress: {
              type: "structure",
              members: {
                BytesTransferred: {
                  type: "long"
                },
                ObjectsTransferred: {
                  type: "long"
                },
                TotalBytes: {
                  type: "long"
                },
                TotalObjects: {
                  type: "long"
                }
              }
            },
            JobLogInfo: {
              type: "structure",
              members: {
                JobCompletionReportURI: {},
                JobSuccessLogURI: {},
                JobFailureLogURI: {}
              }
            },
            ClusterId: {},
            ForwardingAddressId: {},
            TaxDocuments: {
              shape: "S17"
            },
            DeviceConfiguration: {
              shape: "S1e"
            },
            RemoteManagement: {},
            LongTermPricingId: {},
            OnDeviceServiceConfiguration: {
              shape: "Sv"
            }
          }
        },
        S25: {
          type: "structure",
          members: {
            Status: {},
            TrackingNumber: {}
          }
        },
        S2n: {
          type: "list",
          member: {
            type: "structure",
            members: {
              JobId: {},
              JobState: {},
              IsMaster: {
                type: "boolean"
              },
              JobType: {},
              SnowballType: {},
              CreationDate: {
                type: "timestamp"
              },
              Description: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/snowball-2016-06-30.paginators.json
var require_snowball_2016_06_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/snowball-2016-06-30.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeAddresses: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Addresses"
        },
        ListJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "JobListEntries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/snowball.js
var require_snowball = __commonJS({
  "node_modules/aws-sdk/clients/snowball.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["snowball"] = {};
    AWS3.Snowball = Service.defineService("snowball", ["2016-06-30"]);
    Object.defineProperty(apiLoader.services["snowball"], "2016-06-30", {
      get: function get() {
        var model = require_snowball_2016_06_30_min();
        model.paginators = require_snowball_2016_06_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Snowball;
  }
});

// node_modules/aws-sdk/apis/sns-2010-03-31.min.json
var require_sns_2010_03_31_min = __commonJS({
  "node_modules/aws-sdk/apis/sns-2010-03-31.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2010-03-31",
        endpointPrefix: "sns",
        protocol: "query",
        serviceAbbreviation: "Amazon SNS",
        serviceFullName: "Amazon Simple Notification Service",
        serviceId: "SNS",
        signatureVersion: "v4",
        uid: "sns-2010-03-31",
        xmlNamespace: "http://sns.amazonaws.com/doc/2010-03-31/"
      },
      operations: {
        AddPermission: {
          input: {
            type: "structure",
            required: [
              "TopicArn",
              "Label",
              "AWSAccountId",
              "ActionName"
            ],
            members: {
              TopicArn: {},
              Label: {},
              AWSAccountId: {
                type: "list",
                member: {}
              },
              ActionName: {
                type: "list",
                member: {}
              }
            }
          }
        },
        CheckIfPhoneNumberIsOptedOut: {
          input: {
            type: "structure",
            required: [
              "phoneNumber"
            ],
            members: {
              phoneNumber: {}
            }
          },
          output: {
            resultWrapper: "CheckIfPhoneNumberIsOptedOutResult",
            type: "structure",
            members: {
              isOptedOut: {
                type: "boolean"
              }
            }
          }
        },
        ConfirmSubscription: {
          input: {
            type: "structure",
            required: [
              "TopicArn",
              "Token"
            ],
            members: {
              TopicArn: {},
              Token: {},
              AuthenticateOnUnsubscribe: {}
            }
          },
          output: {
            resultWrapper: "ConfirmSubscriptionResult",
            type: "structure",
            members: {
              SubscriptionArn: {}
            }
          }
        },
        CreatePlatformApplication: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Platform",
              "Attributes"
            ],
            members: {
              Name: {},
              Platform: {},
              Attributes: {
                shape: "Sj"
              }
            }
          },
          output: {
            resultWrapper: "CreatePlatformApplicationResult",
            type: "structure",
            members: {
              PlatformApplicationArn: {}
            }
          }
        },
        CreatePlatformEndpoint: {
          input: {
            type: "structure",
            required: [
              "PlatformApplicationArn",
              "Token"
            ],
            members: {
              PlatformApplicationArn: {},
              Token: {},
              CustomUserData: {},
              Attributes: {
                shape: "Sj"
              }
            }
          },
          output: {
            resultWrapper: "CreatePlatformEndpointResult",
            type: "structure",
            members: {
              EndpointArn: {}
            }
          }
        },
        CreateSMSSandboxPhoneNumber: {
          input: {
            type: "structure",
            required: [
              "PhoneNumber"
            ],
            members: {
              PhoneNumber: {},
              LanguageCode: {}
            }
          },
          output: {
            resultWrapper: "CreateSMSSandboxPhoneNumberResult",
            type: "structure",
            members: {}
          }
        },
        CreateTopic: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Attributes: {
                shape: "St"
              },
              Tags: {
                shape: "Sw"
              }
            }
          },
          output: {
            resultWrapper: "CreateTopicResult",
            type: "structure",
            members: {
              TopicArn: {}
            }
          }
        },
        DeleteEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {}
            }
          }
        },
        DeletePlatformApplication: {
          input: {
            type: "structure",
            required: [
              "PlatformApplicationArn"
            ],
            members: {
              PlatformApplicationArn: {}
            }
          }
        },
        DeleteSMSSandboxPhoneNumber: {
          input: {
            type: "structure",
            required: [
              "PhoneNumber"
            ],
            members: {
              PhoneNumber: {}
            }
          },
          output: {
            resultWrapper: "DeleteSMSSandboxPhoneNumberResult",
            type: "structure",
            members: {}
          }
        },
        DeleteTopic: {
          input: {
            type: "structure",
            required: [
              "TopicArn"
            ],
            members: {
              TopicArn: {}
            }
          }
        },
        GetEndpointAttributes: {
          input: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {}
            }
          },
          output: {
            resultWrapper: "GetEndpointAttributesResult",
            type: "structure",
            members: {
              Attributes: {
                shape: "Sj"
              }
            }
          }
        },
        GetPlatformApplicationAttributes: {
          input: {
            type: "structure",
            required: [
              "PlatformApplicationArn"
            ],
            members: {
              PlatformApplicationArn: {}
            }
          },
          output: {
            resultWrapper: "GetPlatformApplicationAttributesResult",
            type: "structure",
            members: {
              Attributes: {
                shape: "Sj"
              }
            }
          }
        },
        GetSMSAttributes: {
          input: {
            type: "structure",
            members: {
              attributes: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "GetSMSAttributesResult",
            type: "structure",
            members: {
              attributes: {
                shape: "Sj"
              }
            }
          }
        },
        GetSMSSandboxAccountStatus: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            resultWrapper: "GetSMSSandboxAccountStatusResult",
            type: "structure",
            required: [
              "IsInSandbox"
            ],
            members: {
              IsInSandbox: {
                type: "boolean"
              }
            }
          }
        },
        GetSubscriptionAttributes: {
          input: {
            type: "structure",
            required: [
              "SubscriptionArn"
            ],
            members: {
              SubscriptionArn: {}
            }
          },
          output: {
            resultWrapper: "GetSubscriptionAttributesResult",
            type: "structure",
            members: {
              Attributes: {
                shape: "S1h"
              }
            }
          }
        },
        GetTopicAttributes: {
          input: {
            type: "structure",
            required: [
              "TopicArn"
            ],
            members: {
              TopicArn: {}
            }
          },
          output: {
            resultWrapper: "GetTopicAttributesResult",
            type: "structure",
            members: {
              Attributes: {
                shape: "St"
              }
            }
          }
        },
        ListEndpointsByPlatformApplication: {
          input: {
            type: "structure",
            required: [
              "PlatformApplicationArn"
            ],
            members: {
              PlatformApplicationArn: {},
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListEndpointsByPlatformApplicationResult",
            type: "structure",
            members: {
              Endpoints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EndpointArn: {},
                    Attributes: {
                      shape: "Sj"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListOriginationNumbers: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListOriginationNumbersResult",
            type: "structure",
            members: {
              NextToken: {},
              PhoneNumbers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedAt: {
                      type: "timestamp"
                    },
                    PhoneNumber: {},
                    Status: {},
                    Iso2CountryCode: {},
                    RouteType: {},
                    NumberCapabilities: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        ListPhoneNumbersOptedOut: {
          input: {
            type: "structure",
            members: {
              nextToken: {}
            }
          },
          output: {
            resultWrapper: "ListPhoneNumbersOptedOutResult",
            type: "structure",
            members: {
              phoneNumbers: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        ListPlatformApplications: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListPlatformApplicationsResult",
            type: "structure",
            members: {
              PlatformApplications: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PlatformApplicationArn: {},
                    Attributes: {
                      shape: "Sj"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSMSSandboxPhoneNumbers: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListSMSSandboxPhoneNumbersResult",
            type: "structure",
            required: [
              "PhoneNumbers"
            ],
            members: {
              PhoneNumbers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PhoneNumber: {},
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSubscriptions: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListSubscriptionsResult",
            type: "structure",
            members: {
              Subscriptions: {
                shape: "S2f"
              },
              NextToken: {}
            }
          }
        },
        ListSubscriptionsByTopic: {
          input: {
            type: "structure",
            required: [
              "TopicArn"
            ],
            members: {
              TopicArn: {},
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListSubscriptionsByTopicResult",
            type: "structure",
            members: {
              Subscriptions: {
                shape: "S2f"
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            resultWrapper: "ListTagsForResourceResult",
            type: "structure",
            members: {
              Tags: {
                shape: "Sw"
              }
            }
          }
        },
        ListTopics: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            resultWrapper: "ListTopicsResult",
            type: "structure",
            members: {
              Topics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TopicArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        OptInPhoneNumber: {
          input: {
            type: "structure",
            required: [
              "phoneNumber"
            ],
            members: {
              phoneNumber: {}
            }
          },
          output: {
            resultWrapper: "OptInPhoneNumberResult",
            type: "structure",
            members: {}
          }
        },
        Publish: {
          input: {
            type: "structure",
            required: [
              "Message"
            ],
            members: {
              TopicArn: {},
              TargetArn: {},
              PhoneNumber: {},
              Message: {},
              Subject: {},
              MessageStructure: {},
              MessageAttributes: {
                type: "map",
                key: {
                  locationName: "Name"
                },
                value: {
                  locationName: "Value",
                  type: "structure",
                  required: [
                    "DataType"
                  ],
                  members: {
                    DataType: {},
                    StringValue: {},
                    BinaryValue: {
                      type: "blob"
                    }
                  }
                }
              },
              MessageDeduplicationId: {},
              MessageGroupId: {}
            }
          },
          output: {
            resultWrapper: "PublishResult",
            type: "structure",
            members: {
              MessageId: {},
              SequenceNumber: {}
            }
          }
        },
        RemovePermission: {
          input: {
            type: "structure",
            required: [
              "TopicArn",
              "Label"
            ],
            members: {
              TopicArn: {},
              Label: {}
            }
          }
        },
        SetEndpointAttributes: {
          input: {
            type: "structure",
            required: [
              "EndpointArn",
              "Attributes"
            ],
            members: {
              EndpointArn: {},
              Attributes: {
                shape: "Sj"
              }
            }
          }
        },
        SetPlatformApplicationAttributes: {
          input: {
            type: "structure",
            required: [
              "PlatformApplicationArn",
              "Attributes"
            ],
            members: {
              PlatformApplicationArn: {},
              Attributes: {
                shape: "Sj"
              }
            }
          }
        },
        SetSMSAttributes: {
          input: {
            type: "structure",
            required: [
              "attributes"
            ],
            members: {
              attributes: {
                shape: "Sj"
              }
            }
          },
          output: {
            resultWrapper: "SetSMSAttributesResult",
            type: "structure",
            members: {}
          }
        },
        SetSubscriptionAttributes: {
          input: {
            type: "structure",
            required: [
              "SubscriptionArn",
              "AttributeName"
            ],
            members: {
              SubscriptionArn: {},
              AttributeName: {},
              AttributeValue: {}
            }
          }
        },
        SetTopicAttributes: {
          input: {
            type: "structure",
            required: [
              "TopicArn",
              "AttributeName"
            ],
            members: {
              TopicArn: {},
              AttributeName: {},
              AttributeValue: {}
            }
          }
        },
        Subscribe: {
          input: {
            type: "structure",
            required: [
              "TopicArn",
              "Protocol"
            ],
            members: {
              TopicArn: {},
              Protocol: {},
              Endpoint: {},
              Attributes: {
                shape: "S1h"
              },
              ReturnSubscriptionArn: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "SubscribeResult",
            type: "structure",
            members: {
              SubscriptionArn: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sw"
              }
            }
          },
          output: {
            resultWrapper: "TagResourceResult",
            type: "structure",
            members: {}
          }
        },
        Unsubscribe: {
          input: {
            type: "structure",
            required: [
              "SubscriptionArn"
            ],
            members: {
              SubscriptionArn: {}
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            resultWrapper: "UntagResourceResult",
            type: "structure",
            members: {}
          }
        },
        VerifySMSSandboxPhoneNumber: {
          input: {
            type: "structure",
            required: [
              "PhoneNumber",
              "OneTimePassword"
            ],
            members: {
              PhoneNumber: {},
              OneTimePassword: {}
            }
          },
          output: {
            resultWrapper: "VerifySMSSandboxPhoneNumberResult",
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sj: {
          type: "map",
          key: {},
          value: {}
        },
        St: {
          type: "map",
          key: {},
          value: {}
        },
        Sw: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S1h: {
          type: "map",
          key: {},
          value: {}
        },
        S2f: {
          type: "list",
          member: {
            type: "structure",
            members: {
              SubscriptionArn: {},
              Owner: {},
              Protocol: {},
              Endpoint: {},
              TopicArn: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sns-2010-03-31.paginators.json
var require_sns_2010_03_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sns-2010-03-31.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListEndpointsByPlatformApplication: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Endpoints"
        },
        ListOriginationNumbers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PhoneNumbers"
        },
        ListPhoneNumbersOptedOut: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "phoneNumbers"
        },
        ListPlatformApplications: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "PlatformApplications"
        },
        ListSMSSandboxPhoneNumbers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PhoneNumbers"
        },
        ListSubscriptions: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Subscriptions"
        },
        ListSubscriptionsByTopic: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Subscriptions"
        },
        ListTopics: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Topics"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/sns.js
var require_sns = __commonJS({
  "node_modules/aws-sdk/clients/sns.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["sns"] = {};
    AWS3.SNS = Service.defineService("sns", ["2010-03-31"]);
    Object.defineProperty(apiLoader.services["sns"], "2010-03-31", {
      get: function get() {
        var model = require_sns_2010_03_31_min();
        model.paginators = require_sns_2010_03_31_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SNS;
  }
});

// node_modules/aws-sdk/lib/services/sqs.js
var require_sqs = __commonJS({
  "node_modules/aws-sdk/lib/services/sqs.js"() {
    var AWS3 = require_core();
    AWS3.util.update(AWS3.SQS.prototype, {
      setupRequestListeners: function setupRequestListeners(request) {
        request.addListener("build", this.buildEndpoint);
        if (request.service.config.computeChecksums) {
          if (request.operation === "sendMessage") {
            request.addListener("extractData", this.verifySendMessageChecksum);
          } else if (request.operation === "sendMessageBatch") {
            request.addListener("extractData", this.verifySendMessageBatchChecksum);
          } else if (request.operation === "receiveMessage") {
            request.addListener("extractData", this.verifyReceiveMessageChecksum);
          }
        }
      },
      verifySendMessageChecksum: function verifySendMessageChecksum(response) {
        if (!response.data)
          return;
        var md5 = response.data.MD5OfMessageBody;
        var body = this.params.MessageBody;
        var calculatedMd5 = this.service.calculateChecksum(body);
        if (calculatedMd5 !== md5) {
          var msg = 'Got "' + response.data.MD5OfMessageBody + '", expecting "' + calculatedMd5 + '".';
          this.service.throwInvalidChecksumError(response, [response.data.MessageId], msg);
        }
      },
      verifySendMessageBatchChecksum: function verifySendMessageBatchChecksum(response) {
        if (!response.data)
          return;
        var service = this.service;
        var entries = {};
        var errors = [];
        var messageIds = [];
        AWS3.util.arrayEach(response.data.Successful, function(entry) {
          entries[entry.Id] = entry;
        });
        AWS3.util.arrayEach(this.params.Entries, function(entry) {
          if (entries[entry.Id]) {
            var md5 = entries[entry.Id].MD5OfMessageBody;
            var body = entry.MessageBody;
            if (!service.isChecksumValid(md5, body)) {
              errors.push(entry.Id);
              messageIds.push(entries[entry.Id].MessageId);
            }
          }
        });
        if (errors.length > 0) {
          service.throwInvalidChecksumError(response, messageIds, "Invalid messages: " + errors.join(", "));
        }
      },
      verifyReceiveMessageChecksum: function verifyReceiveMessageChecksum(response) {
        if (!response.data)
          return;
        var service = this.service;
        var messageIds = [];
        AWS3.util.arrayEach(response.data.Messages, function(message) {
          var md5 = message.MD5OfBody;
          var body = message.Body;
          if (!service.isChecksumValid(md5, body)) {
            messageIds.push(message.MessageId);
          }
        });
        if (messageIds.length > 0) {
          service.throwInvalidChecksumError(response, messageIds, "Invalid messages: " + messageIds.join(", "));
        }
      },
      throwInvalidChecksumError: function throwInvalidChecksumError(response, ids, message) {
        response.error = AWS3.util.error(new Error(), {
          retryable: true,
          code: "InvalidChecksum",
          messageIds: ids,
          message: response.request.operation + " returned an invalid MD5 response. " + message
        });
      },
      isChecksumValid: function isChecksumValid(checksum, data) {
        return this.calculateChecksum(data) === checksum;
      },
      calculateChecksum: function calculateChecksum(data) {
        return AWS3.util.crypto.md5(data, "hex");
      },
      buildEndpoint: function buildEndpoint(request) {
        var url = request.httpRequest.params.QueueUrl;
        if (url) {
          request.httpRequest.endpoint = new AWS3.Endpoint(url);
          var matches = request.httpRequest.endpoint.host.match(/^sqs\.(.+?)\./);
          if (matches)
            request.httpRequest.region = matches[1];
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/sqs-2012-11-05.min.json
var require_sqs_2012_11_05_min = __commonJS({
  "node_modules/aws-sdk/apis/sqs-2012-11-05.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2012-11-05",
        endpointPrefix: "sqs",
        protocol: "query",
        serviceAbbreviation: "Amazon SQS",
        serviceFullName: "Amazon Simple Queue Service",
        serviceId: "SQS",
        signatureVersion: "v4",
        uid: "sqs-2012-11-05",
        xmlNamespace: "http://queue.amazonaws.com/doc/2012-11-05/"
      },
      operations: {
        AddPermission: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "Label",
              "AWSAccountIds",
              "Actions"
            ],
            members: {
              QueueUrl: {},
              Label: {},
              AWSAccountIds: {
                type: "list",
                member: {
                  locationName: "AWSAccountId"
                },
                flattened: true
              },
              Actions: {
                type: "list",
                member: {
                  locationName: "ActionName"
                },
                flattened: true
              }
            }
          }
        },
        ChangeMessageVisibility: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "ReceiptHandle",
              "VisibilityTimeout"
            ],
            members: {
              QueueUrl: {},
              ReceiptHandle: {},
              VisibilityTimeout: {
                type: "integer"
              }
            }
          }
        },
        ChangeMessageVisibilityBatch: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "Entries"
            ],
            members: {
              QueueUrl: {},
              Entries: {
                type: "list",
                member: {
                  locationName: "ChangeMessageVisibilityBatchRequestEntry",
                  type: "structure",
                  required: [
                    "Id",
                    "ReceiptHandle"
                  ],
                  members: {
                    Id: {},
                    ReceiptHandle: {},
                    VisibilityTimeout: {
                      type: "integer"
                    }
                  }
                },
                flattened: true
              }
            }
          },
          output: {
            resultWrapper: "ChangeMessageVisibilityBatchResult",
            type: "structure",
            required: [
              "Successful",
              "Failed"
            ],
            members: {
              Successful: {
                type: "list",
                member: {
                  locationName: "ChangeMessageVisibilityBatchResultEntry",
                  type: "structure",
                  required: [
                    "Id"
                  ],
                  members: {
                    Id: {}
                  }
                },
                flattened: true
              },
              Failed: {
                shape: "Sd"
              }
            }
          }
        },
        CreateQueue: {
          input: {
            type: "structure",
            required: [
              "QueueName"
            ],
            members: {
              QueueName: {},
              Attributes: {
                shape: "Sh",
                locationName: "Attribute"
              },
              tags: {
                shape: "Sj",
                locationName: "Tag"
              }
            }
          },
          output: {
            resultWrapper: "CreateQueueResult",
            type: "structure",
            members: {
              QueueUrl: {}
            }
          }
        },
        DeleteMessage: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "ReceiptHandle"
            ],
            members: {
              QueueUrl: {},
              ReceiptHandle: {}
            }
          }
        },
        DeleteMessageBatch: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "Entries"
            ],
            members: {
              QueueUrl: {},
              Entries: {
                type: "list",
                member: {
                  locationName: "DeleteMessageBatchRequestEntry",
                  type: "structure",
                  required: [
                    "Id",
                    "ReceiptHandle"
                  ],
                  members: {
                    Id: {},
                    ReceiptHandle: {}
                  }
                },
                flattened: true
              }
            }
          },
          output: {
            resultWrapper: "DeleteMessageBatchResult",
            type: "structure",
            required: [
              "Successful",
              "Failed"
            ],
            members: {
              Successful: {
                type: "list",
                member: {
                  locationName: "DeleteMessageBatchResultEntry",
                  type: "structure",
                  required: [
                    "Id"
                  ],
                  members: {
                    Id: {}
                  }
                },
                flattened: true
              },
              Failed: {
                shape: "Sd"
              }
            }
          }
        },
        DeleteQueue: {
          input: {
            type: "structure",
            required: [
              "QueueUrl"
            ],
            members: {
              QueueUrl: {}
            }
          }
        },
        GetQueueAttributes: {
          input: {
            type: "structure",
            required: [
              "QueueUrl"
            ],
            members: {
              QueueUrl: {},
              AttributeNames: {
                shape: "Sw"
              }
            }
          },
          output: {
            resultWrapper: "GetQueueAttributesResult",
            type: "structure",
            members: {
              Attributes: {
                shape: "Sh",
                locationName: "Attribute"
              }
            }
          }
        },
        GetQueueUrl: {
          input: {
            type: "structure",
            required: [
              "QueueName"
            ],
            members: {
              QueueName: {},
              QueueOwnerAWSAccountId: {}
            }
          },
          output: {
            resultWrapper: "GetQueueUrlResult",
            type: "structure",
            members: {
              QueueUrl: {}
            }
          }
        },
        ListDeadLetterSourceQueues: {
          input: {
            type: "structure",
            required: [
              "QueueUrl"
            ],
            members: {
              QueueUrl: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListDeadLetterSourceQueuesResult",
            type: "structure",
            required: [
              "queueUrls"
            ],
            members: {
              queueUrls: {
                shape: "S14"
              },
              NextToken: {}
            }
          }
        },
        ListQueueTags: {
          input: {
            type: "structure",
            required: [
              "QueueUrl"
            ],
            members: {
              QueueUrl: {}
            }
          },
          output: {
            resultWrapper: "ListQueueTagsResult",
            type: "structure",
            members: {
              Tags: {
                shape: "Sj",
                locationName: "Tag"
              }
            }
          }
        },
        ListQueues: {
          input: {
            type: "structure",
            members: {
              QueueNamePrefix: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ListQueuesResult",
            type: "structure",
            members: {
              QueueUrls: {
                shape: "S14"
              },
              NextToken: {}
            }
          }
        },
        PurgeQueue: {
          input: {
            type: "structure",
            required: [
              "QueueUrl"
            ],
            members: {
              QueueUrl: {}
            }
          }
        },
        ReceiveMessage: {
          input: {
            type: "structure",
            required: [
              "QueueUrl"
            ],
            members: {
              QueueUrl: {},
              AttributeNames: {
                shape: "Sw"
              },
              MessageAttributeNames: {
                type: "list",
                member: {
                  locationName: "MessageAttributeName"
                },
                flattened: true
              },
              MaxNumberOfMessages: {
                type: "integer"
              },
              VisibilityTimeout: {
                type: "integer"
              },
              WaitTimeSeconds: {
                type: "integer"
              },
              ReceiveRequestAttemptId: {}
            }
          },
          output: {
            resultWrapper: "ReceiveMessageResult",
            type: "structure",
            members: {
              Messages: {
                type: "list",
                member: {
                  locationName: "Message",
                  type: "structure",
                  members: {
                    MessageId: {},
                    ReceiptHandle: {},
                    MD5OfBody: {},
                    Body: {},
                    Attributes: {
                      locationName: "Attribute",
                      type: "map",
                      key: {
                        locationName: "Name"
                      },
                      value: {
                        locationName: "Value"
                      },
                      flattened: true
                    },
                    MD5OfMessageAttributes: {},
                    MessageAttributes: {
                      shape: "S1i",
                      locationName: "MessageAttribute"
                    }
                  }
                },
                flattened: true
              }
            }
          }
        },
        RemovePermission: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "Label"
            ],
            members: {
              QueueUrl: {},
              Label: {}
            }
          }
        },
        SendMessage: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "MessageBody"
            ],
            members: {
              QueueUrl: {},
              MessageBody: {},
              DelaySeconds: {
                type: "integer"
              },
              MessageAttributes: {
                shape: "S1i",
                locationName: "MessageAttribute"
              },
              MessageSystemAttributes: {
                shape: "S1p",
                locationName: "MessageSystemAttribute"
              },
              MessageDeduplicationId: {},
              MessageGroupId: {}
            }
          },
          output: {
            resultWrapper: "SendMessageResult",
            type: "structure",
            members: {
              MD5OfMessageBody: {},
              MD5OfMessageAttributes: {},
              MD5OfMessageSystemAttributes: {},
              MessageId: {},
              SequenceNumber: {}
            }
          }
        },
        SendMessageBatch: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "Entries"
            ],
            members: {
              QueueUrl: {},
              Entries: {
                type: "list",
                member: {
                  locationName: "SendMessageBatchRequestEntry",
                  type: "structure",
                  required: [
                    "Id",
                    "MessageBody"
                  ],
                  members: {
                    Id: {},
                    MessageBody: {},
                    DelaySeconds: {
                      type: "integer"
                    },
                    MessageAttributes: {
                      shape: "S1i",
                      locationName: "MessageAttribute"
                    },
                    MessageSystemAttributes: {
                      shape: "S1p",
                      locationName: "MessageSystemAttribute"
                    },
                    MessageDeduplicationId: {},
                    MessageGroupId: {}
                  }
                },
                flattened: true
              }
            }
          },
          output: {
            resultWrapper: "SendMessageBatchResult",
            type: "structure",
            required: [
              "Successful",
              "Failed"
            ],
            members: {
              Successful: {
                type: "list",
                member: {
                  locationName: "SendMessageBatchResultEntry",
                  type: "structure",
                  required: [
                    "Id",
                    "MessageId",
                    "MD5OfMessageBody"
                  ],
                  members: {
                    Id: {},
                    MessageId: {},
                    MD5OfMessageBody: {},
                    MD5OfMessageAttributes: {},
                    MD5OfMessageSystemAttributes: {},
                    SequenceNumber: {}
                  }
                },
                flattened: true
              },
              Failed: {
                shape: "Sd"
              }
            }
          }
        },
        SetQueueAttributes: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "Attributes"
            ],
            members: {
              QueueUrl: {},
              Attributes: {
                shape: "Sh",
                locationName: "Attribute"
              }
            }
          }
        },
        TagQueue: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "Tags"
            ],
            members: {
              QueueUrl: {},
              Tags: {
                shape: "Sj"
              }
            }
          }
        },
        UntagQueue: {
          input: {
            type: "structure",
            required: [
              "QueueUrl",
              "TagKeys"
            ],
            members: {
              QueueUrl: {},
              TagKeys: {
                type: "list",
                member: {
                  locationName: "TagKey"
                },
                flattened: true
              }
            }
          }
        }
      },
      shapes: {
        Sd: {
          type: "list",
          member: {
            locationName: "BatchResultErrorEntry",
            type: "structure",
            required: [
              "Id",
              "SenderFault",
              "Code"
            ],
            members: {
              Id: {},
              SenderFault: {
                type: "boolean"
              },
              Code: {},
              Message: {}
            }
          },
          flattened: true
        },
        Sh: {
          type: "map",
          key: {
            locationName: "Name"
          },
          value: {
            locationName: "Value"
          },
          flattened: true,
          locationName: "Attribute"
        },
        Sj: {
          type: "map",
          key: {
            locationName: "Key"
          },
          value: {
            locationName: "Value"
          },
          flattened: true,
          locationName: "Tag"
        },
        Sw: {
          type: "list",
          member: {
            locationName: "AttributeName"
          },
          flattened: true
        },
        S14: {
          type: "list",
          member: {
            locationName: "QueueUrl"
          },
          flattened: true
        },
        S1i: {
          type: "map",
          key: {
            locationName: "Name"
          },
          value: {
            locationName: "Value",
            type: "structure",
            required: [
              "DataType"
            ],
            members: {
              StringValue: {},
              BinaryValue: {
                type: "blob"
              },
              StringListValues: {
                shape: "S1l",
                flattened: true,
                locationName: "StringListValue"
              },
              BinaryListValues: {
                shape: "S1m",
                flattened: true,
                locationName: "BinaryListValue"
              },
              DataType: {}
            }
          },
          flattened: true
        },
        S1l: {
          type: "list",
          member: {
            locationName: "StringListValue"
          }
        },
        S1m: {
          type: "list",
          member: {
            locationName: "BinaryListValue",
            type: "blob"
          }
        },
        S1p: {
          type: "map",
          key: {
            locationName: "Name"
          },
          value: {
            locationName: "Value",
            type: "structure",
            required: [
              "DataType"
            ],
            members: {
              StringValue: {},
              BinaryValue: {
                type: "blob"
              },
              StringListValues: {
                shape: "S1l",
                flattened: true,
                locationName: "StringListValue"
              },
              BinaryListValues: {
                shape: "S1m",
                flattened: true,
                locationName: "BinaryListValue"
              },
              DataType: {}
            }
          },
          flattened: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sqs-2012-11-05.paginators.json
var require_sqs_2012_11_05_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sqs-2012-11-05.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListDeadLetterSourceQueues: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "queueUrls"
        },
        ListQueues: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "QueueUrls"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/sqs.js
var require_sqs2 = __commonJS({
  "node_modules/aws-sdk/clients/sqs.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["sqs"] = {};
    AWS3.SQS = Service.defineService("sqs", ["2012-11-05"]);
    require_sqs();
    Object.defineProperty(apiLoader.services["sqs"], "2012-11-05", {
      get: function get() {
        var model = require_sqs_2012_11_05_min();
        model.paginators = require_sqs_2012_11_05_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SQS;
  }
});

// node_modules/aws-sdk/apis/ssm-2014-11-06.min.json
var require_ssm_2014_11_06_min = __commonJS({
  "node_modules/aws-sdk/apis/ssm-2014-11-06.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-11-06",
        endpointPrefix: "ssm",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Amazon SSM",
        serviceFullName: "Amazon Simple Systems Manager (SSM)",
        serviceId: "SSM",
        signatureVersion: "v4",
        targetPrefix: "AmazonSSM",
        uid: "ssm-2014-11-06"
      },
      operations: {
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceType",
              "ResourceId",
              "Tags"
            ],
            members: {
              ResourceType: {},
              ResourceId: {},
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateOpsItemRelatedItem: {
          input: {
            type: "structure",
            required: [
              "OpsItemId",
              "AssociationType",
              "ResourceType",
              "ResourceUri"
            ],
            members: {
              OpsItemId: {},
              AssociationType: {},
              ResourceType: {},
              ResourceUri: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationId: {}
            }
          }
        },
        CancelCommand: {
          input: {
            type: "structure",
            required: [
              "CommandId"
            ],
            members: {
              CommandId: {},
              InstanceIds: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelMaintenanceWindowExecution: {
          input: {
            type: "structure",
            required: [
              "WindowExecutionId"
            ],
            members: {
              WindowExecutionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowExecutionId: {}
            }
          }
        },
        CreateActivation: {
          input: {
            type: "structure",
            required: [
              "IamRole"
            ],
            members: {
              Description: {},
              DefaultInstanceName: {},
              IamRole: {},
              RegistrationLimit: {
                type: "integer"
              },
              ExpirationDate: {
                type: "timestamp"
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ActivationId: {},
              ActivationCode: {}
            }
          }
        },
        CreateAssociation: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              DocumentVersion: {},
              InstanceId: {},
              Parameters: {
                shape: "S10"
              },
              Targets: {
                shape: "S14"
              },
              ScheduleExpression: {},
              OutputLocation: {
                shape: "S1a"
              },
              AssociationName: {},
              AutomationTargetParameterName: {},
              MaxErrors: {},
              MaxConcurrency: {},
              ComplianceSeverity: {},
              SyncCompliance: {},
              ApplyOnlyAtCronInterval: {
                type: "boolean"
              },
              CalendarNames: {
                shape: "S1m"
              },
              TargetLocations: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationDescription: {
                shape: "S1w"
              }
            }
          }
        },
        CreateAssociationBatch: {
          input: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  shape: "S2a"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Successful: {
                type: "list",
                member: {
                  shape: "S1w"
                }
              },
              Failed: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Entry: {
                      shape: "S2a"
                    },
                    Message: {},
                    Fault: {}
                  }
                }
              }
            }
          }
        },
        CreateDocument: {
          input: {
            type: "structure",
            required: [
              "Content",
              "Name"
            ],
            members: {
              Content: {},
              Requires: {
                shape: "S2j"
              },
              Attachments: {
                shape: "S2l"
              },
              Name: {},
              DisplayName: {},
              VersionName: {},
              DocumentType: {},
              DocumentFormat: {},
              TargetType: {},
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentDescription: {
                shape: "S2y"
              }
            }
          }
        },
        CreateMaintenanceWindow: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Schedule",
              "Duration",
              "Cutoff",
              "AllowUnassociatedTargets"
            ],
            members: {
              Name: {},
              Description: {
                shape: "S3p"
              },
              StartDate: {},
              EndDate: {},
              Schedule: {},
              ScheduleTimezone: {},
              ScheduleOffset: {
                type: "integer"
              },
              Duration: {
                type: "integer"
              },
              Cutoff: {
                type: "integer"
              },
              AllowUnassociatedTargets: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WindowId: {}
            }
          }
        },
        CreateOpsItem: {
          input: {
            type: "structure",
            required: [
              "Description",
              "Source",
              "Title"
            ],
            members: {
              Description: {},
              OpsItemType: {},
              OperationalData: {
                shape: "S43"
              },
              Notifications: {
                shape: "S48"
              },
              Priority: {
                type: "integer"
              },
              RelatedOpsItems: {
                shape: "S4c"
              },
              Source: {},
              Title: {},
              Tags: {
                shape: "S4"
              },
              Category: {},
              Severity: {},
              ActualStartTime: {
                type: "timestamp"
              },
              ActualEndTime: {
                type: "timestamp"
              },
              PlannedStartTime: {
                type: "timestamp"
              },
              PlannedEndTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OpsItemId: {}
            }
          }
        },
        CreateOpsMetadata: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {},
              Metadata: {
                shape: "S4l"
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OpsMetadataArn: {}
            }
          }
        },
        CreatePatchBaseline: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              OperatingSystem: {},
              Name: {},
              GlobalFilters: {
                shape: "S4u"
              },
              ApprovalRules: {
                shape: "S50"
              },
              ApprovedPatches: {
                shape: "S57"
              },
              ApprovedPatchesComplianceLevel: {},
              ApprovedPatchesEnableNonSecurity: {
                type: "boolean"
              },
              RejectedPatches: {
                shape: "S57"
              },
              RejectedPatchesAction: {},
              Description: {},
              Sources: {
                shape: "S5b"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BaselineId: {}
            }
          }
        },
        CreateResourceDataSync: {
          input: {
            type: "structure",
            required: [
              "SyncName"
            ],
            members: {
              SyncName: {},
              S3Destination: {
                shape: "S5l"
              },
              SyncType: {},
              SyncSource: {
                shape: "S5u"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteActivation: {
          input: {
            type: "structure",
            required: [
              "ActivationId"
            ],
            members: {
              ActivationId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAssociation: {
          input: {
            type: "structure",
            members: {
              Name: {},
              InstanceId: {},
              AssociationId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDocument: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              DocumentVersion: {},
              VersionName: {},
              Force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteInventory: {
          input: {
            type: "structure",
            required: [
              "TypeName"
            ],
            members: {
              TypeName: {},
              SchemaDeleteOption: {},
              DryRun: {
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeletionId: {},
              TypeName: {},
              DeletionSummary: {
                shape: "S6i"
              }
            }
          }
        },
        DeleteMaintenanceWindow: {
          input: {
            type: "structure",
            required: [
              "WindowId"
            ],
            members: {
              WindowId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowId: {}
            }
          }
        },
        DeleteOpsMetadata: {
          input: {
            type: "structure",
            required: [
              "OpsMetadataArn"
            ],
            members: {
              OpsMetadataArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteParameter: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteParameters: {
          input: {
            type: "structure",
            required: [
              "Names"
            ],
            members: {
              Names: {
                shape: "S6x"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeletedParameters: {
                shape: "S6x"
              },
              InvalidParameters: {
                shape: "S6x"
              }
            }
          }
        },
        DeletePatchBaseline: {
          input: {
            type: "structure",
            required: [
              "BaselineId"
            ],
            members: {
              BaselineId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BaselineId: {}
            }
          }
        },
        DeleteResourceDataSync: {
          input: {
            type: "structure",
            required: [
              "SyncName"
            ],
            members: {
              SyncName: {},
              SyncType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterManagedInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterPatchBaselineForPatchGroup: {
          input: {
            type: "structure",
            required: [
              "BaselineId",
              "PatchGroup"
            ],
            members: {
              BaselineId: {},
              PatchGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BaselineId: {},
              PatchGroup: {}
            }
          }
        },
        DeregisterTargetFromMaintenanceWindow: {
          input: {
            type: "structure",
            required: [
              "WindowId",
              "WindowTargetId"
            ],
            members: {
              WindowId: {},
              WindowTargetId: {},
              Safe: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WindowId: {},
              WindowTargetId: {}
            }
          }
        },
        DeregisterTaskFromMaintenanceWindow: {
          input: {
            type: "structure",
            required: [
              "WindowId",
              "WindowTaskId"
            ],
            members: {
              WindowId: {},
              WindowTaskId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowId: {},
              WindowTaskId: {}
            }
          }
        },
        DescribeActivations: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FilterKey: {},
                    FilterValues: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ActivationList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ActivationId: {},
                    Description: {},
                    DefaultInstanceName: {},
                    IamRole: {},
                    RegistrationLimit: {
                      type: "integer"
                    },
                    RegistrationsCount: {
                      type: "integer"
                    },
                    ExpirationDate: {
                      type: "timestamp"
                    },
                    Expired: {
                      type: "boolean"
                    },
                    CreatedDate: {
                      type: "timestamp"
                    },
                    Tags: {
                      shape: "S4"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAssociation: {
          input: {
            type: "structure",
            members: {
              Name: {},
              InstanceId: {},
              AssociationId: {},
              AssociationVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationDescription: {
                shape: "S1w"
              }
            }
          }
        },
        DescribeAssociationExecutionTargets: {
          input: {
            type: "structure",
            required: [
              "AssociationId",
              "ExecutionId"
            ],
            members: {
              AssociationId: {},
              ExecutionId: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Value"
                  ],
                  members: {
                    Key: {},
                    Value: {}
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationExecutionTargets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssociationId: {},
                    AssociationVersion: {},
                    ExecutionId: {},
                    ResourceId: {},
                    ResourceType: {},
                    Status: {},
                    DetailedStatus: {},
                    LastExecutionDate: {
                      type: "timestamp"
                    },
                    OutputSource: {
                      type: "structure",
                      members: {
                        OutputSourceId: {},
                        OutputSourceType: {}
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAssociationExecutions: {
          input: {
            type: "structure",
            required: [
              "AssociationId"
            ],
            members: {
              AssociationId: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Value",
                    "Type"
                  ],
                  members: {
                    Key: {},
                    Value: {},
                    Type: {}
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssociationId: {},
                    AssociationVersion: {},
                    ExecutionId: {},
                    Status: {},
                    DetailedStatus: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    LastExecutionDate: {
                      type: "timestamp"
                    },
                    ResourceCountByStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAutomationExecutions: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Values"
                  ],
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AutomationExecutionMetadataList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AutomationExecutionId: {},
                    DocumentName: {},
                    DocumentVersion: {},
                    AutomationExecutionStatus: {},
                    ExecutionStartTime: {
                      type: "timestamp"
                    },
                    ExecutionEndTime: {
                      type: "timestamp"
                    },
                    ExecutedBy: {},
                    LogFile: {},
                    Outputs: {
                      shape: "S8s"
                    },
                    Mode: {},
                    ParentAutomationExecutionId: {},
                    CurrentStepName: {},
                    CurrentAction: {},
                    FailureMessage: {},
                    TargetParameterName: {},
                    Targets: {
                      shape: "S14"
                    },
                    TargetMaps: {
                      shape: "S8x"
                    },
                    ResolvedTargets: {
                      shape: "S92"
                    },
                    MaxConcurrency: {},
                    MaxErrors: {},
                    Target: {},
                    AutomationType: {},
                    AutomationSubtype: {},
                    ScheduledTime: {
                      type: "timestamp"
                    },
                    Runbooks: {
                      shape: "S96"
                    },
                    OpsItemId: {},
                    AssociationId: {},
                    ChangeRequestName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAutomationStepExecutions: {
          input: {
            type: "structure",
            required: [
              "AutomationExecutionId"
            ],
            members: {
              AutomationExecutionId: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Values"
                  ],
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ReverseOrder: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StepExecutions: {
                shape: "S9g"
              },
              NextToken: {}
            }
          }
        },
        DescribeAvailablePatches: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S9q"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Patches: {
                type: "list",
                member: {
                  shape: "S9y"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeDocument: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              DocumentVersion: {},
              VersionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Document: {
                shape: "S2y"
              }
            }
          }
        },
        DescribeDocumentPermission: {
          input: {
            type: "structure",
            required: [
              "Name",
              "PermissionType"
            ],
            members: {
              Name: {},
              PermissionType: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccountIds: {
                shape: "Sat"
              },
              AccountSharingInfoList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountId: {},
                    SharedDocumentVersion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeEffectiveInstanceAssociations: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Associations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssociationId: {},
                    InstanceId: {},
                    Content: {},
                    AssociationVersion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeEffectivePatchesForPatchBaseline: {
          input: {
            type: "structure",
            required: [
              "BaselineId"
            ],
            members: {
              BaselineId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EffectivePatches: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Patch: {
                      shape: "S9y"
                    },
                    PatchStatus: {
                      type: "structure",
                      members: {
                        DeploymentStatus: {},
                        ComplianceLevel: {},
                        ApprovalDate: {
                          type: "timestamp"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeInstanceAssociationsStatus: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceAssociationStatusInfos: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssociationId: {},
                    Name: {},
                    DocumentVersion: {},
                    AssociationVersion: {},
                    InstanceId: {},
                    ExecutionDate: {
                      type: "timestamp"
                    },
                    Status: {},
                    DetailedStatus: {},
                    ExecutionSummary: {},
                    ErrorCode: {},
                    OutputUrl: {
                      type: "structure",
                      members: {
                        S3OutputUrl: {
                          type: "structure",
                          members: {
                            OutputUrl: {}
                          }
                        }
                      }
                    },
                    AssociationName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeInstanceInformation: {
          input: {
            type: "structure",
            members: {
              InstanceInformationFilterList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "key",
                    "valueSet"
                  ],
                  members: {
                    key: {},
                    valueSet: {
                      shape: "Sbm"
                    }
                  }
                }
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Values"
                  ],
                  members: {
                    Key: {},
                    Values: {
                      shape: "Sbm"
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceInformationList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InstanceId: {},
                    PingStatus: {},
                    LastPingDateTime: {
                      type: "timestamp"
                    },
                    AgentVersion: {},
                    IsLatestVersion: {
                      type: "boolean"
                    },
                    PlatformType: {},
                    PlatformName: {},
                    PlatformVersion: {},
                    ActivationId: {},
                    IamRole: {},
                    RegistrationDate: {
                      type: "timestamp"
                    },
                    ResourceType: {},
                    Name: {},
                    IPAddress: {},
                    ComputerName: {},
                    AssociationStatus: {},
                    LastAssociationExecutionDate: {
                      type: "timestamp"
                    },
                    LastSuccessfulAssociationExecutionDate: {
                      type: "timestamp"
                    },
                    AssociationOverview: {
                      type: "structure",
                      members: {
                        DetailedStatus: {},
                        InstanceAssociationStatusAggregatedCount: {
                          type: "map",
                          key: {},
                          value: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeInstancePatchStates: {
          input: {
            type: "structure",
            required: [
              "InstanceIds"
            ],
            members: {
              InstanceIds: {
                shape: "Si"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstancePatchStates: {
                type: "list",
                member: {
                  shape: "Sc6"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeInstancePatchStatesForPatchGroup: {
          input: {
            type: "structure",
            required: [
              "PatchGroup"
            ],
            members: {
              PatchGroup: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Values",
                    "Type"
                  ],
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    },
                    Type: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstancePatchStates: {
                type: "list",
                member: {
                  shape: "Sc6"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeInstancePatches: {
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {},
              Filters: {
                shape: "S9q"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Patches: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Title",
                    "KBId",
                    "Classification",
                    "Severity",
                    "State",
                    "InstalledTime"
                  ],
                  members: {
                    Title: {},
                    KBId: {},
                    Classification: {},
                    Severity: {},
                    State: {},
                    InstalledTime: {
                      type: "timestamp"
                    },
                    CVEIds: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeInventoryDeletions: {
          input: {
            type: "structure",
            members: {
              DeletionId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InventoryDeletions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DeletionId: {},
                    TypeName: {},
                    DeletionStartTime: {
                      type: "timestamp"
                    },
                    LastStatus: {},
                    LastStatusMessage: {},
                    DeletionSummary: {
                      shape: "S6i"
                    },
                    LastStatusUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMaintenanceWindowExecutionTaskInvocations: {
          input: {
            type: "structure",
            required: [
              "WindowExecutionId",
              "TaskId"
            ],
            members: {
              WindowExecutionId: {},
              TaskId: {},
              Filters: {
                shape: "Sdc"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowExecutionTaskInvocationIdentities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WindowExecutionId: {},
                    TaskExecutionId: {},
                    InvocationId: {},
                    ExecutionId: {},
                    TaskType: {},
                    Parameters: {
                      shape: "Sdo"
                    },
                    Status: {},
                    StatusDetails: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    OwnerInformation: {
                      shape: "Sc9"
                    },
                    WindowTargetId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMaintenanceWindowExecutionTasks: {
          input: {
            type: "structure",
            required: [
              "WindowExecutionId"
            ],
            members: {
              WindowExecutionId: {},
              Filters: {
                shape: "Sdc"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowExecutionTaskIdentities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WindowExecutionId: {},
                    TaskExecutionId: {},
                    Status: {},
                    StatusDetails: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    TaskArn: {},
                    TaskType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMaintenanceWindowExecutions: {
          input: {
            type: "structure",
            required: [
              "WindowId"
            ],
            members: {
              WindowId: {},
              Filters: {
                shape: "Sdc"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WindowId: {},
                    WindowExecutionId: {},
                    Status: {},
                    StatusDetails: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMaintenanceWindowSchedule: {
          input: {
            type: "structure",
            members: {
              WindowId: {},
              Targets: {
                shape: "S14"
              },
              ResourceType: {},
              Filters: {
                shape: "S9q"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ScheduledWindowExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WindowId: {},
                    Name: {},
                    ExecutionTime: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMaintenanceWindowTargets: {
          input: {
            type: "structure",
            required: [
              "WindowId"
            ],
            members: {
              WindowId: {},
              Filters: {
                shape: "Sdc"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Targets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WindowId: {},
                    WindowTargetId: {},
                    ResourceType: {},
                    Targets: {
                      shape: "S14"
                    },
                    OwnerInformation: {
                      shape: "Sc9"
                    },
                    Name: {},
                    Description: {
                      shape: "S3p"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMaintenanceWindowTasks: {
          input: {
            type: "structure",
            required: [
              "WindowId"
            ],
            members: {
              WindowId: {},
              Filters: {
                shape: "Sdc"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tasks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WindowId: {},
                    WindowTaskId: {},
                    TaskArn: {},
                    Type: {},
                    Targets: {
                      shape: "S14"
                    },
                    TaskParameters: {
                      shape: "Sef"
                    },
                    Priority: {
                      type: "integer"
                    },
                    LoggingInfo: {
                      shape: "Sel"
                    },
                    ServiceRoleArn: {},
                    MaxConcurrency: {},
                    MaxErrors: {},
                    Name: {},
                    Description: {
                      shape: "S3p"
                    },
                    CutoffBehavior: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMaintenanceWindows: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Sdc"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowIdentities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WindowId: {},
                    Name: {},
                    Description: {
                      shape: "S3p"
                    },
                    Enabled: {
                      type: "boolean"
                    },
                    Duration: {
                      type: "integer"
                    },
                    Cutoff: {
                      type: "integer"
                    },
                    Schedule: {},
                    ScheduleTimezone: {},
                    ScheduleOffset: {
                      type: "integer"
                    },
                    EndDate: {},
                    StartDate: {},
                    NextExecutionTime: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeMaintenanceWindowsForTarget: {
          input: {
            type: "structure",
            required: [
              "Targets",
              "ResourceType"
            ],
            members: {
              Targets: {
                shape: "S14"
              },
              ResourceType: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowIdentities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WindowId: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeOpsItems: {
          input: {
            type: "structure",
            members: {
              OpsItemFilters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Values",
                    "Operator"
                  ],
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    },
                    Operator: {}
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              OpsItemSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedBy: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    LastModifiedBy: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    Priority: {
                      type: "integer"
                    },
                    Source: {},
                    Status: {},
                    OpsItemId: {},
                    Title: {},
                    OperationalData: {
                      shape: "S43"
                    },
                    Category: {},
                    Severity: {},
                    OpsItemType: {},
                    ActualStartTime: {
                      type: "timestamp"
                    },
                    ActualEndTime: {
                      type: "timestamp"
                    },
                    PlannedStartTime: {
                      type: "timestamp"
                    },
                    PlannedEndTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeParameters: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Values"
                  ],
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              ParameterFilters: {
                shape: "Sff"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Parameters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Type: {},
                    KeyId: {},
                    LastModifiedDate: {
                      type: "timestamp"
                    },
                    LastModifiedUser: {},
                    Description: {},
                    AllowedPattern: {},
                    Version: {
                      type: "long"
                    },
                    Tier: {},
                    Policies: {
                      shape: "Sfu"
                    },
                    DataType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribePatchBaselines: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S9q"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BaselineIdentities: {
                type: "list",
                member: {
                  shape: "Sg0"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribePatchGroupState: {
          input: {
            type: "structure",
            required: [
              "PatchGroup"
            ],
            members: {
              PatchGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Instances: {
                type: "integer"
              },
              InstancesWithInstalledPatches: {
                type: "integer"
              },
              InstancesWithInstalledOtherPatches: {
                type: "integer"
              },
              InstancesWithInstalledPendingRebootPatches: {
                type: "integer"
              },
              InstancesWithInstalledRejectedPatches: {
                type: "integer"
              },
              InstancesWithMissingPatches: {
                type: "integer"
              },
              InstancesWithFailedPatches: {
                type: "integer"
              },
              InstancesWithNotApplicablePatches: {
                type: "integer"
              },
              InstancesWithUnreportedNotApplicablePatches: {
                type: "integer"
              },
              InstancesWithCriticalNonCompliantPatches: {
                type: "integer"
              },
              InstancesWithSecurityNonCompliantPatches: {
                type: "integer"
              },
              InstancesWithOtherNonCompliantPatches: {
                type: "integer"
              }
            }
          }
        },
        DescribePatchGroups: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S9q"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Mappings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PatchGroup: {},
                    BaselineIdentity: {
                      shape: "Sg0"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribePatchProperties: {
          input: {
            type: "structure",
            required: [
              "OperatingSystem",
              "Property"
            ],
            members: {
              OperatingSystem: {},
              Property: {},
              PatchSet: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Properties: {
                type: "list",
                member: {
                  type: "map",
                  key: {},
                  value: {}
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeSessions: {
          input: {
            type: "structure",
            required: [
              "State"
            ],
            members: {
              State: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "key",
                    "value"
                  ],
                  members: {
                    key: {},
                    value: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Sessions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SessionId: {},
                    Target: {},
                    Status: {},
                    StartDate: {
                      type: "timestamp"
                    },
                    EndDate: {
                      type: "timestamp"
                    },
                    DocumentName: {},
                    Owner: {},
                    Details: {},
                    OutputUrl: {
                      type: "structure",
                      members: {
                        S3OutputUrl: {},
                        CloudWatchOutputUrl: {}
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DisassociateOpsItemRelatedItem: {
          input: {
            type: "structure",
            required: [
              "OpsItemId",
              "AssociationId"
            ],
            members: {
              OpsItemId: {},
              AssociationId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAutomationExecution: {
          input: {
            type: "structure",
            required: [
              "AutomationExecutionId"
            ],
            members: {
              AutomationExecutionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AutomationExecution: {
                type: "structure",
                members: {
                  AutomationExecutionId: {},
                  DocumentName: {},
                  DocumentVersion: {},
                  ExecutionStartTime: {
                    type: "timestamp"
                  },
                  ExecutionEndTime: {
                    type: "timestamp"
                  },
                  AutomationExecutionStatus: {},
                  StepExecutions: {
                    shape: "S9g"
                  },
                  StepExecutionsTruncated: {
                    type: "boolean"
                  },
                  Parameters: {
                    shape: "S8s"
                  },
                  Outputs: {
                    shape: "S8s"
                  },
                  FailureMessage: {},
                  Mode: {},
                  ParentAutomationExecutionId: {},
                  ExecutedBy: {},
                  CurrentStepName: {},
                  CurrentAction: {},
                  TargetParameterName: {},
                  Targets: {
                    shape: "S14"
                  },
                  TargetMaps: {
                    shape: "S8x"
                  },
                  ResolvedTargets: {
                    shape: "S92"
                  },
                  MaxConcurrency: {},
                  MaxErrors: {},
                  Target: {},
                  TargetLocations: {
                    shape: "S1o"
                  },
                  ProgressCounters: {
                    type: "structure",
                    members: {
                      TotalSteps: {
                        type: "integer"
                      },
                      SuccessSteps: {
                        type: "integer"
                      },
                      FailedSteps: {
                        type: "integer"
                      },
                      CancelledSteps: {
                        type: "integer"
                      },
                      TimedOutSteps: {
                        type: "integer"
                      }
                    }
                  },
                  AutomationSubtype: {},
                  ScheduledTime: {
                    type: "timestamp"
                  },
                  Runbooks: {
                    shape: "S96"
                  },
                  OpsItemId: {},
                  AssociationId: {},
                  ChangeRequestName: {}
                }
              }
            }
          }
        },
        GetCalendarState: {
          input: {
            type: "structure",
            required: [
              "CalendarNames"
            ],
            members: {
              CalendarNames: {
                shape: "S1m"
              },
              AtTime: {}
            }
          },
          output: {
            type: "structure",
            members: {
              State: {},
              AtTime: {},
              NextTransitionTime: {}
            }
          }
        },
        GetCommandInvocation: {
          input: {
            type: "structure",
            required: [
              "CommandId",
              "InstanceId"
            ],
            members: {
              CommandId: {},
              InstanceId: {},
              PluginName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CommandId: {},
              InstanceId: {},
              Comment: {},
              DocumentName: {},
              DocumentVersion: {},
              PluginName: {},
              ResponseCode: {
                type: "integer"
              },
              ExecutionStartDateTime: {},
              ExecutionElapsedTime: {},
              ExecutionEndDateTime: {},
              Status: {},
              StatusDetails: {},
              StandardOutputContent: {},
              StandardOutputUrl: {},
              StandardErrorContent: {},
              StandardErrorUrl: {},
              CloudWatchOutputConfig: {
                shape: "Shj"
              }
            }
          }
        },
        GetConnectionStatus: {
          input: {
            type: "structure",
            required: [
              "Target"
            ],
            members: {
              Target: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Target: {},
              Status: {}
            }
          }
        },
        GetDefaultPatchBaseline: {
          input: {
            type: "structure",
            members: {
              OperatingSystem: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BaselineId: {},
              OperatingSystem: {}
            }
          }
        },
        GetDeployablePatchSnapshotForInstance: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "SnapshotId"
            ],
            members: {
              InstanceId: {},
              SnapshotId: {},
              BaselineOverride: {
                type: "structure",
                members: {
                  OperatingSystem: {},
                  GlobalFilters: {
                    shape: "S4u"
                  },
                  ApprovalRules: {
                    shape: "S50"
                  },
                  ApprovedPatches: {
                    shape: "S57"
                  },
                  ApprovedPatchesComplianceLevel: {},
                  RejectedPatches: {
                    shape: "S57"
                  },
                  RejectedPatchesAction: {},
                  ApprovedPatchesEnableNonSecurity: {
                    type: "boolean"
                  },
                  Sources: {
                    shape: "S5b"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceId: {},
              SnapshotId: {},
              SnapshotDownloadUrl: {},
              Product: {}
            }
          }
        },
        GetDocument: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              VersionName: {},
              DocumentVersion: {},
              DocumentFormat: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              CreatedDate: {
                type: "timestamp"
              },
              DisplayName: {},
              VersionName: {},
              DocumentVersion: {},
              Status: {},
              StatusInformation: {},
              Content: {},
              DocumentType: {},
              DocumentFormat: {},
              Requires: {
                shape: "S2j"
              },
              AttachmentsContent: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Size: {
                      type: "long"
                    },
                    Hash: {},
                    HashType: {},
                    Url: {}
                  }
                }
              },
              ReviewStatus: {}
            }
          }
        },
        GetInventory: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Si5"
              },
              Aggregators: {
                shape: "Sib"
              },
              ResultAttributes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "TypeName"
                  ],
                  members: {
                    TypeName: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Entities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Data: {
                      type: "map",
                      key: {},
                      value: {
                        type: "structure",
                        required: [
                          "TypeName",
                          "SchemaVersion",
                          "Content"
                        ],
                        members: {
                          TypeName: {},
                          SchemaVersion: {},
                          CaptureTime: {},
                          ContentHash: {},
                          Content: {
                            shape: "Sis"
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetInventorySchema: {
          input: {
            type: "structure",
            members: {
              TypeName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Aggregator: {
                type: "boolean"
              },
              SubType: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Schemas: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "TypeName",
                    "Attributes"
                  ],
                  members: {
                    TypeName: {},
                    Version: {},
                    Attributes: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Name",
                          "DataType"
                        ],
                        members: {
                          Name: {},
                          DataType: {}
                        }
                      }
                    },
                    DisplayName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetMaintenanceWindow: {
          input: {
            type: "structure",
            required: [
              "WindowId"
            ],
            members: {
              WindowId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowId: {},
              Name: {},
              Description: {
                shape: "S3p"
              },
              StartDate: {},
              EndDate: {},
              Schedule: {},
              ScheduleTimezone: {},
              ScheduleOffset: {
                type: "integer"
              },
              NextExecutionTime: {},
              Duration: {
                type: "integer"
              },
              Cutoff: {
                type: "integer"
              },
              AllowUnassociatedTargets: {
                type: "boolean"
              },
              Enabled: {
                type: "boolean"
              },
              CreatedDate: {
                type: "timestamp"
              },
              ModifiedDate: {
                type: "timestamp"
              }
            }
          }
        },
        GetMaintenanceWindowExecution: {
          input: {
            type: "structure",
            required: [
              "WindowExecutionId"
            ],
            members: {
              WindowExecutionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowExecutionId: {},
              TaskIds: {
                type: "list",
                member: {}
              },
              Status: {},
              StatusDetails: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetMaintenanceWindowExecutionTask: {
          input: {
            type: "structure",
            required: [
              "WindowExecutionId",
              "TaskId"
            ],
            members: {
              WindowExecutionId: {},
              TaskId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowExecutionId: {},
              TaskExecutionId: {},
              TaskArn: {},
              ServiceRole: {},
              Type: {},
              TaskParameters: {
                type: "list",
                member: {
                  shape: "Sef"
                },
                sensitive: true
              },
              Priority: {
                type: "integer"
              },
              MaxConcurrency: {},
              MaxErrors: {},
              Status: {},
              StatusDetails: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetMaintenanceWindowExecutionTaskInvocation: {
          input: {
            type: "structure",
            required: [
              "WindowExecutionId",
              "TaskId",
              "InvocationId"
            ],
            members: {
              WindowExecutionId: {},
              TaskId: {},
              InvocationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowExecutionId: {},
              TaskExecutionId: {},
              InvocationId: {},
              ExecutionId: {},
              TaskType: {},
              Parameters: {
                shape: "Sdo"
              },
              Status: {},
              StatusDetails: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              OwnerInformation: {
                shape: "Sc9"
              },
              WindowTargetId: {}
            }
          }
        },
        GetMaintenanceWindowTask: {
          input: {
            type: "structure",
            required: [
              "WindowId",
              "WindowTaskId"
            ],
            members: {
              WindowId: {},
              WindowTaskId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowId: {},
              WindowTaskId: {},
              Targets: {
                shape: "S14"
              },
              TaskArn: {},
              ServiceRoleArn: {},
              TaskType: {},
              TaskParameters: {
                shape: "Sef"
              },
              TaskInvocationParameters: {
                shape: "Sjj"
              },
              Priority: {
                type: "integer"
              },
              MaxConcurrency: {},
              MaxErrors: {},
              LoggingInfo: {
                shape: "Sel"
              },
              Name: {},
              Description: {
                shape: "S3p"
              },
              CutoffBehavior: {}
            }
          }
        },
        GetOpsItem: {
          input: {
            type: "structure",
            required: [
              "OpsItemId"
            ],
            members: {
              OpsItemId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OpsItem: {
                type: "structure",
                members: {
                  CreatedBy: {},
                  OpsItemType: {},
                  CreatedTime: {
                    type: "timestamp"
                  },
                  Description: {},
                  LastModifiedBy: {},
                  LastModifiedTime: {
                    type: "timestamp"
                  },
                  Notifications: {
                    shape: "S48"
                  },
                  Priority: {
                    type: "integer"
                  },
                  RelatedOpsItems: {
                    shape: "S4c"
                  },
                  Status: {},
                  OpsItemId: {},
                  Version: {},
                  Title: {},
                  Source: {},
                  OperationalData: {
                    shape: "S43"
                  },
                  Category: {},
                  Severity: {},
                  ActualStartTime: {
                    type: "timestamp"
                  },
                  ActualEndTime: {
                    type: "timestamp"
                  },
                  PlannedStartTime: {
                    type: "timestamp"
                  },
                  PlannedEndTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        GetOpsMetadata: {
          input: {
            type: "structure",
            required: [
              "OpsMetadataArn"
            ],
            members: {
              OpsMetadataArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceId: {},
              Metadata: {
                shape: "S4l"
              },
              NextToken: {}
            }
          }
        },
        GetOpsSummary: {
          input: {
            type: "structure",
            members: {
              SyncName: {},
              Filters: {
                shape: "Sk6"
              },
              Aggregators: {
                shape: "Skc"
              },
              ResultAttributes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "TypeName"
                  ],
                  members: {
                    TypeName: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Entities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Data: {
                      type: "map",
                      key: {},
                      value: {
                        type: "structure",
                        members: {
                          CaptureTime: {},
                          Content: {
                            type: "list",
                            member: {
                              type: "map",
                              key: {},
                              value: {}
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetParameter: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              WithDecryption: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Parameter: {
                shape: "Sky"
              }
            }
          }
        },
        GetParameterHistory: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              WithDecryption: {
                type: "boolean"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Parameters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Type: {},
                    KeyId: {},
                    LastModifiedDate: {
                      type: "timestamp"
                    },
                    LastModifiedUser: {},
                    Description: {},
                    Value: {
                      shape: "Skz"
                    },
                    AllowedPattern: {},
                    Version: {
                      type: "long"
                    },
                    Labels: {
                      shape: "Sl5"
                    },
                    Tier: {},
                    Policies: {
                      shape: "Sfu"
                    },
                    DataType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetParameters: {
          input: {
            type: "structure",
            required: [
              "Names"
            ],
            members: {
              Names: {
                shape: "S6x"
              },
              WithDecryption: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Parameters: {
                shape: "Sl9"
              },
              InvalidParameters: {
                shape: "S6x"
              }
            }
          }
        },
        GetParametersByPath: {
          input: {
            type: "structure",
            required: [
              "Path"
            ],
            members: {
              Path: {},
              Recursive: {
                type: "boolean"
              },
              ParameterFilters: {
                shape: "Sff"
              },
              WithDecryption: {
                type: "boolean"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Parameters: {
                shape: "Sl9"
              },
              NextToken: {}
            }
          }
        },
        GetPatchBaseline: {
          input: {
            type: "structure",
            required: [
              "BaselineId"
            ],
            members: {
              BaselineId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BaselineId: {},
              Name: {},
              OperatingSystem: {},
              GlobalFilters: {
                shape: "S4u"
              },
              ApprovalRules: {
                shape: "S50"
              },
              ApprovedPatches: {
                shape: "S57"
              },
              ApprovedPatchesComplianceLevel: {},
              ApprovedPatchesEnableNonSecurity: {
                type: "boolean"
              },
              RejectedPatches: {
                shape: "S57"
              },
              RejectedPatchesAction: {},
              PatchGroups: {
                type: "list",
                member: {}
              },
              CreatedDate: {
                type: "timestamp"
              },
              ModifiedDate: {
                type: "timestamp"
              },
              Description: {},
              Sources: {
                shape: "S5b"
              }
            }
          }
        },
        GetPatchBaselineForPatchGroup: {
          input: {
            type: "structure",
            required: [
              "PatchGroup"
            ],
            members: {
              PatchGroup: {},
              OperatingSystem: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BaselineId: {},
              PatchGroup: {},
              OperatingSystem: {}
            }
          }
        },
        GetServiceSetting: {
          input: {
            type: "structure",
            required: [
              "SettingId"
            ],
            members: {
              SettingId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceSetting: {
                shape: "Sll"
              }
            }
          }
        },
        LabelParameterVersion: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Labels"
            ],
            members: {
              Name: {},
              ParameterVersion: {
                type: "long"
              },
              Labels: {
                shape: "Sl5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InvalidLabels: {
                shape: "Sl5"
              },
              ParameterVersion: {
                type: "long"
              }
            }
          }
        },
        ListAssociationVersions: {
          input: {
            type: "structure",
            required: [
              "AssociationId"
            ],
            members: {
              AssociationId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssociationId: {},
                    AssociationVersion: {},
                    CreatedDate: {
                      type: "timestamp"
                    },
                    Name: {},
                    DocumentVersion: {},
                    Parameters: {
                      shape: "S10"
                    },
                    Targets: {
                      shape: "S14"
                    },
                    ScheduleExpression: {},
                    OutputLocation: {
                      shape: "S1a"
                    },
                    AssociationName: {},
                    MaxErrors: {},
                    MaxConcurrency: {},
                    ComplianceSeverity: {},
                    SyncCompliance: {},
                    ApplyOnlyAtCronInterval: {
                      type: "boolean"
                    },
                    CalendarNames: {
                      shape: "S1m"
                    },
                    TargetLocations: {
                      shape: "S1o"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAssociations: {
          input: {
            type: "structure",
            members: {
              AssociationFilterList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "key",
                    "value"
                  ],
                  members: {
                    key: {},
                    value: {}
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Associations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    InstanceId: {},
                    AssociationId: {},
                    AssociationVersion: {},
                    DocumentVersion: {},
                    Targets: {
                      shape: "S14"
                    },
                    LastExecutionDate: {
                      type: "timestamp"
                    },
                    Overview: {
                      shape: "S23"
                    },
                    ScheduleExpression: {},
                    AssociationName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCommandInvocations: {
          input: {
            type: "structure",
            members: {
              CommandId: {},
              InstanceId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "Sm3"
              },
              Details: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CommandInvocations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CommandId: {},
                    InstanceId: {},
                    InstanceName: {},
                    Comment: {},
                    DocumentName: {},
                    DocumentVersion: {},
                    RequestedDateTime: {
                      type: "timestamp"
                    },
                    Status: {},
                    StatusDetails: {},
                    TraceOutput: {},
                    StandardOutputUrl: {},
                    StandardErrorUrl: {},
                    CommandPlugins: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {},
                          Status: {},
                          StatusDetails: {},
                          ResponseCode: {
                            type: "integer"
                          },
                          ResponseStartDateTime: {
                            type: "timestamp"
                          },
                          ResponseFinishDateTime: {
                            type: "timestamp"
                          },
                          Output: {},
                          StandardOutputUrl: {},
                          StandardErrorUrl: {},
                          OutputS3Region: {},
                          OutputS3BucketName: {},
                          OutputS3KeyPrefix: {}
                        }
                      }
                    },
                    ServiceRole: {},
                    NotificationConfig: {
                      shape: "Sjl"
                    },
                    CloudWatchOutputConfig: {
                      shape: "Shj"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCommands: {
          input: {
            type: "structure",
            members: {
              CommandId: {},
              InstanceId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "Sm3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Commands: {
                type: "list",
                member: {
                  shape: "Smj"
                }
              },
              NextToken: {}
            }
          }
        },
        ListComplianceItems: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Smq"
              },
              ResourceIds: {
                type: "list",
                member: {}
              },
              ResourceTypes: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ComplianceItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ComplianceType: {},
                    ResourceType: {},
                    ResourceId: {},
                    Id: {},
                    Title: {},
                    Status: {},
                    Severity: {},
                    ExecutionSummary: {
                      shape: "Sn8"
                    },
                    Details: {
                      shape: "Snb"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListComplianceSummaries: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Smq"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ComplianceSummaryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ComplianceType: {},
                    CompliantSummary: {
                      shape: "Sng"
                    },
                    NonCompliantSummary: {
                      shape: "Snj"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDocumentMetadataHistory: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Metadata"
            ],
            members: {
              Name: {},
              DocumentVersion: {},
              Metadata: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              DocumentVersion: {},
              Author: {},
              Metadata: {
                type: "structure",
                members: {
                  ReviewerResponse: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        CreateTime: {
                          type: "timestamp"
                        },
                        UpdatedTime: {
                          type: "timestamp"
                        },
                        ReviewStatus: {},
                        Comment: {
                          shape: "Snq"
                        },
                        Reviewer: {}
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDocumentVersions: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    DisplayName: {},
                    DocumentVersion: {},
                    VersionName: {},
                    CreatedDate: {
                      type: "timestamp"
                    },
                    IsDefaultVersion: {
                      type: "boolean"
                    },
                    DocumentFormat: {},
                    Status: {},
                    StatusInformation: {},
                    ReviewStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDocuments: {
          input: {
            type: "structure",
            members: {
              DocumentFilterList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "key",
                    "value"
                  ],
                  members: {
                    key: {},
                    value: {}
                  }
                }
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentIdentifiers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    CreatedDate: {
                      type: "timestamp"
                    },
                    DisplayName: {},
                    Owner: {},
                    VersionName: {},
                    PlatformTypes: {
                      shape: "S3c"
                    },
                    DocumentVersion: {},
                    DocumentType: {},
                    SchemaVersion: {},
                    DocumentFormat: {},
                    TargetType: {},
                    Tags: {
                      shape: "S4"
                    },
                    Requires: {
                      shape: "S2j"
                    },
                    ReviewStatus: {},
                    Author: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListInventoryEntries: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "TypeName"
            ],
            members: {
              InstanceId: {},
              TypeName: {},
              Filters: {
                shape: "Si5"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TypeName: {},
              InstanceId: {},
              SchemaVersion: {},
              CaptureTime: {},
              Entries: {
                shape: "Sis"
              },
              NextToken: {}
            }
          }
        },
        ListOpsItemEvents: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Values",
                    "Operator"
                  ],
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    },
                    Operator: {}
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Summaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    OpsItemId: {},
                    EventId: {},
                    Source: {},
                    DetailType: {},
                    Detail: {},
                    CreatedBy: {
                      shape: "Soo"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListOpsItemRelatedItems: {
          input: {
            type: "structure",
            members: {
              OpsItemId: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Values",
                    "Operator"
                  ],
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    },
                    Operator: {}
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Summaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    OpsItemId: {},
                    AssociationId: {},
                    ResourceType: {},
                    AssociationType: {},
                    ResourceUri: {},
                    CreatedBy: {
                      shape: "Soo"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    },
                    LastModifiedBy: {
                      shape: "Soo"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListOpsMetadata: {
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Values"
                  ],
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OpsMetadataList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceId: {},
                    OpsMetadataArn: {},
                    LastModifiedDate: {
                      type: "timestamp"
                    },
                    LastModifiedUser: {},
                    CreationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListResourceComplianceSummaries: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Smq"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceComplianceSummaryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ComplianceType: {},
                    ResourceType: {},
                    ResourceId: {},
                    Status: {},
                    OverallSeverity: {},
                    ExecutionSummary: {
                      shape: "Sn8"
                    },
                    CompliantSummary: {
                      shape: "Sng"
                    },
                    NonCompliantSummary: {
                      shape: "Snj"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListResourceDataSync: {
          input: {
            type: "structure",
            members: {
              SyncType: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceDataSyncItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SyncName: {},
                    SyncType: {},
                    SyncSource: {
                      type: "structure",
                      members: {
                        SourceType: {},
                        AwsOrganizationsSource: {
                          shape: "S5w"
                        },
                        SourceRegions: {
                          shape: "S61"
                        },
                        IncludeFutureRegions: {
                          type: "boolean"
                        },
                        State: {},
                        EnableAllOpsDataSources: {
                          type: "boolean"
                        }
                      }
                    },
                    S3Destination: {
                      shape: "S5l"
                    },
                    LastSyncTime: {
                      type: "timestamp"
                    },
                    LastSuccessfulSyncTime: {
                      type: "timestamp"
                    },
                    SyncLastModifiedTime: {
                      type: "timestamp"
                    },
                    LastStatus: {},
                    SyncCreatedTime: {
                      type: "timestamp"
                    },
                    LastSyncStatusMessage: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceType",
              "ResourceId"
            ],
            members: {
              ResourceType: {},
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "S4"
              }
            }
          }
        },
        ModifyDocumentPermission: {
          input: {
            type: "structure",
            required: [
              "Name",
              "PermissionType"
            ],
            members: {
              Name: {},
              PermissionType: {},
              AccountIdsToAdd: {
                shape: "Sat"
              },
              AccountIdsToRemove: {
                shape: "Sat"
              },
              SharedDocumentVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutComplianceItems: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "ResourceType",
              "ComplianceType",
              "ExecutionSummary",
              "Items"
            ],
            members: {
              ResourceId: {},
              ResourceType: {},
              ComplianceType: {},
              ExecutionSummary: {
                shape: "Sn8"
              },
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Severity",
                    "Status"
                  ],
                  members: {
                    Id: {},
                    Title: {},
                    Severity: {},
                    Status: {},
                    Details: {
                      shape: "Snb"
                    }
                  }
                }
              },
              ItemContentHash: {},
              UploadType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutInventory: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Items"
            ],
            members: {
              InstanceId: {},
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "TypeName",
                    "SchemaVersion",
                    "CaptureTime"
                  ],
                  members: {
                    TypeName: {},
                    SchemaVersion: {},
                    CaptureTime: {},
                    ContentHash: {},
                    Content: {
                      shape: "Sis"
                    },
                    Context: {
                      type: "map",
                      key: {},
                      value: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Message: {}
            }
          }
        },
        PutParameter: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Description: {},
              Value: {
                shape: "Skz"
              },
              Type: {},
              KeyId: {},
              Overwrite: {
                type: "boolean"
              },
              AllowedPattern: {},
              Tags: {
                shape: "S4"
              },
              Tier: {},
              Policies: {},
              DataType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Version: {
                type: "long"
              },
              Tier: {}
            }
          }
        },
        RegisterDefaultPatchBaseline: {
          input: {
            type: "structure",
            required: [
              "BaselineId"
            ],
            members: {
              BaselineId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BaselineId: {}
            }
          }
        },
        RegisterPatchBaselineForPatchGroup: {
          input: {
            type: "structure",
            required: [
              "BaselineId",
              "PatchGroup"
            ],
            members: {
              BaselineId: {},
              PatchGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BaselineId: {},
              PatchGroup: {}
            }
          }
        },
        RegisterTargetWithMaintenanceWindow: {
          input: {
            type: "structure",
            required: [
              "WindowId",
              "ResourceType",
              "Targets"
            ],
            members: {
              WindowId: {},
              ResourceType: {},
              Targets: {
                shape: "S14"
              },
              OwnerInformation: {
                shape: "Sc9"
              },
              Name: {},
              Description: {
                shape: "S3p"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WindowTargetId: {}
            }
          }
        },
        RegisterTaskWithMaintenanceWindow: {
          input: {
            type: "structure",
            required: [
              "WindowId",
              "TaskArn",
              "TaskType"
            ],
            members: {
              WindowId: {},
              Targets: {
                shape: "S14"
              },
              TaskArn: {},
              ServiceRoleArn: {},
              TaskType: {},
              TaskParameters: {
                shape: "Sef"
              },
              TaskInvocationParameters: {
                shape: "Sjj"
              },
              Priority: {
                type: "integer"
              },
              MaxConcurrency: {},
              MaxErrors: {},
              LoggingInfo: {
                shape: "Sel"
              },
              Name: {},
              Description: {
                shape: "S3p"
              },
              ClientToken: {
                idempotencyToken: true
              },
              CutoffBehavior: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowTaskId: {}
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceType",
              "ResourceId",
              "TagKeys"
            ],
            members: {
              ResourceType: {},
              ResourceId: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ResetServiceSetting: {
          input: {
            type: "structure",
            required: [
              "SettingId"
            ],
            members: {
              SettingId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceSetting: {
                shape: "Sll"
              }
            }
          }
        },
        ResumeSession: {
          input: {
            type: "structure",
            required: [
              "SessionId"
            ],
            members: {
              SessionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SessionId: {},
              TokenValue: {},
              StreamUrl: {}
            }
          }
        },
        SendAutomationSignal: {
          input: {
            type: "structure",
            required: [
              "AutomationExecutionId",
              "SignalType"
            ],
            members: {
              AutomationExecutionId: {},
              SignalType: {},
              Payload: {
                shape: "S8s"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SendCommand: {
          input: {
            type: "structure",
            required: [
              "DocumentName"
            ],
            members: {
              InstanceIds: {
                shape: "Si"
              },
              Targets: {
                shape: "S14"
              },
              DocumentName: {},
              DocumentVersion: {},
              DocumentHash: {},
              DocumentHashType: {},
              TimeoutSeconds: {
                type: "integer"
              },
              Comment: {},
              Parameters: {
                shape: "S10"
              },
              OutputS3Region: {},
              OutputS3BucketName: {},
              OutputS3KeyPrefix: {},
              MaxConcurrency: {},
              MaxErrors: {},
              ServiceRoleArn: {},
              NotificationConfig: {
                shape: "Sjl"
              },
              CloudWatchOutputConfig: {
                shape: "Shj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Command: {
                shape: "Smj"
              }
            }
          }
        },
        StartAssociationsOnce: {
          input: {
            type: "structure",
            required: [
              "AssociationIds"
            ],
            members: {
              AssociationIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartAutomationExecution: {
          input: {
            type: "structure",
            required: [
              "DocumentName"
            ],
            members: {
              DocumentName: {},
              DocumentVersion: {},
              Parameters: {
                shape: "S8s"
              },
              ClientToken: {},
              Mode: {},
              TargetParameterName: {},
              Targets: {
                shape: "S14"
              },
              TargetMaps: {
                shape: "S8x"
              },
              MaxConcurrency: {},
              MaxErrors: {},
              TargetLocations: {
                shape: "S1o"
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AutomationExecutionId: {}
            }
          }
        },
        StartChangeRequestExecution: {
          input: {
            type: "structure",
            required: [
              "DocumentName",
              "Runbooks"
            ],
            members: {
              ScheduledTime: {
                type: "timestamp"
              },
              DocumentName: {},
              DocumentVersion: {},
              Parameters: {
                shape: "S8s"
              },
              ChangeRequestName: {},
              ClientToken: {},
              AutoApprove: {
                type: "boolean"
              },
              Runbooks: {
                shape: "S96"
              },
              Tags: {
                shape: "S4"
              },
              ScheduledEndTime: {
                type: "timestamp"
              },
              ChangeDetails: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AutomationExecutionId: {}
            }
          }
        },
        StartSession: {
          input: {
            type: "structure",
            required: [
              "Target"
            ],
            members: {
              Target: {},
              DocumentName: {},
              Parameters: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SessionId: {},
              TokenValue: {},
              StreamUrl: {}
            }
          }
        },
        StopAutomationExecution: {
          input: {
            type: "structure",
            required: [
              "AutomationExecutionId"
            ],
            members: {
              AutomationExecutionId: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TerminateSession: {
          input: {
            type: "structure",
            required: [
              "SessionId"
            ],
            members: {
              SessionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SessionId: {}
            }
          }
        },
        UnlabelParameterVersion: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ParameterVersion",
              "Labels"
            ],
            members: {
              Name: {},
              ParameterVersion: {
                type: "long"
              },
              Labels: {
                shape: "Sl5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RemovedLabels: {
                shape: "Sl5"
              },
              InvalidLabels: {
                shape: "Sl5"
              }
            }
          }
        },
        UpdateAssociation: {
          input: {
            type: "structure",
            required: [
              "AssociationId"
            ],
            members: {
              AssociationId: {},
              Parameters: {
                shape: "S10"
              },
              DocumentVersion: {},
              ScheduleExpression: {},
              OutputLocation: {
                shape: "S1a"
              },
              Name: {},
              Targets: {
                shape: "S14"
              },
              AssociationName: {},
              AssociationVersion: {},
              AutomationTargetParameterName: {},
              MaxErrors: {},
              MaxConcurrency: {},
              ComplianceSeverity: {},
              SyncCompliance: {},
              ApplyOnlyAtCronInterval: {
                type: "boolean"
              },
              CalendarNames: {
                shape: "S1m"
              },
              TargetLocations: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationDescription: {
                shape: "S1w"
              }
            }
          }
        },
        UpdateAssociationStatus: {
          input: {
            type: "structure",
            required: [
              "Name",
              "InstanceId",
              "AssociationStatus"
            ],
            members: {
              Name: {},
              InstanceId: {},
              AssociationStatus: {
                shape: "S1z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationDescription: {
                shape: "S1w"
              }
            }
          }
        },
        UpdateDocument: {
          input: {
            type: "structure",
            required: [
              "Content",
              "Name"
            ],
            members: {
              Content: {},
              Attachments: {
                shape: "S2l"
              },
              Name: {},
              DisplayName: {},
              VersionName: {},
              DocumentVersion: {},
              DocumentFormat: {},
              TargetType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentDescription: {
                shape: "S2y"
              }
            }
          }
        },
        UpdateDocumentDefaultVersion: {
          input: {
            type: "structure",
            required: [
              "Name",
              "DocumentVersion"
            ],
            members: {
              Name: {},
              DocumentVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Description: {
                type: "structure",
                members: {
                  Name: {},
                  DefaultVersion: {},
                  DefaultVersionName: {}
                }
              }
            }
          }
        },
        UpdateDocumentMetadata: {
          input: {
            type: "structure",
            required: [
              "Name",
              "DocumentReviews"
            ],
            members: {
              Name: {},
              DocumentVersion: {},
              DocumentReviews: {
                type: "structure",
                required: [
                  "Action"
                ],
                members: {
                  Action: {},
                  Comment: {
                    shape: "Snq"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateMaintenanceWindow: {
          input: {
            type: "structure",
            required: [
              "WindowId"
            ],
            members: {
              WindowId: {},
              Name: {},
              Description: {
                shape: "S3p"
              },
              StartDate: {},
              EndDate: {},
              Schedule: {},
              ScheduleTimezone: {},
              ScheduleOffset: {
                type: "integer"
              },
              Duration: {
                type: "integer"
              },
              Cutoff: {
                type: "integer"
              },
              AllowUnassociatedTargets: {
                type: "boolean"
              },
              Enabled: {
                type: "boolean"
              },
              Replace: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WindowId: {},
              Name: {},
              Description: {
                shape: "S3p"
              },
              StartDate: {},
              EndDate: {},
              Schedule: {},
              ScheduleTimezone: {},
              ScheduleOffset: {
                type: "integer"
              },
              Duration: {
                type: "integer"
              },
              Cutoff: {
                type: "integer"
              },
              AllowUnassociatedTargets: {
                type: "boolean"
              },
              Enabled: {
                type: "boolean"
              }
            }
          }
        },
        UpdateMaintenanceWindowTarget: {
          input: {
            type: "structure",
            required: [
              "WindowId",
              "WindowTargetId"
            ],
            members: {
              WindowId: {},
              WindowTargetId: {},
              Targets: {
                shape: "S14"
              },
              OwnerInformation: {
                shape: "Sc9"
              },
              Name: {},
              Description: {
                shape: "S3p"
              },
              Replace: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WindowId: {},
              WindowTargetId: {},
              Targets: {
                shape: "S14"
              },
              OwnerInformation: {
                shape: "Sc9"
              },
              Name: {},
              Description: {
                shape: "S3p"
              }
            }
          }
        },
        UpdateMaintenanceWindowTask: {
          input: {
            type: "structure",
            required: [
              "WindowId",
              "WindowTaskId"
            ],
            members: {
              WindowId: {},
              WindowTaskId: {},
              Targets: {
                shape: "S14"
              },
              TaskArn: {},
              ServiceRoleArn: {},
              TaskParameters: {
                shape: "Sef"
              },
              TaskInvocationParameters: {
                shape: "Sjj"
              },
              Priority: {
                type: "integer"
              },
              MaxConcurrency: {},
              MaxErrors: {},
              LoggingInfo: {
                shape: "Sel"
              },
              Name: {},
              Description: {
                shape: "S3p"
              },
              Replace: {
                type: "boolean"
              },
              CutoffBehavior: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WindowId: {},
              WindowTaskId: {},
              Targets: {
                shape: "S14"
              },
              TaskArn: {},
              ServiceRoleArn: {},
              TaskParameters: {
                shape: "Sef"
              },
              TaskInvocationParameters: {
                shape: "Sjj"
              },
              Priority: {
                type: "integer"
              },
              MaxConcurrency: {},
              MaxErrors: {},
              LoggingInfo: {
                shape: "Sel"
              },
              Name: {},
              Description: {
                shape: "S3p"
              },
              CutoffBehavior: {}
            }
          }
        },
        UpdateManagedInstanceRole: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "IamRole"
            ],
            members: {
              InstanceId: {},
              IamRole: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateOpsItem: {
          input: {
            type: "structure",
            required: [
              "OpsItemId"
            ],
            members: {
              Description: {},
              OperationalData: {
                shape: "S43"
              },
              OperationalDataToDelete: {
                type: "list",
                member: {}
              },
              Notifications: {
                shape: "S48"
              },
              Priority: {
                type: "integer"
              },
              RelatedOpsItems: {
                shape: "S4c"
              },
              Status: {},
              OpsItemId: {},
              Title: {},
              Category: {},
              Severity: {},
              ActualStartTime: {
                type: "timestamp"
              },
              ActualEndTime: {
                type: "timestamp"
              },
              PlannedStartTime: {
                type: "timestamp"
              },
              PlannedEndTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateOpsMetadata: {
          input: {
            type: "structure",
            required: [
              "OpsMetadataArn"
            ],
            members: {
              OpsMetadataArn: {},
              MetadataToUpdate: {
                shape: "S4l"
              },
              KeysToDelete: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OpsMetadataArn: {}
            }
          }
        },
        UpdatePatchBaseline: {
          input: {
            type: "structure",
            required: [
              "BaselineId"
            ],
            members: {
              BaselineId: {},
              Name: {},
              GlobalFilters: {
                shape: "S4u"
              },
              ApprovalRules: {
                shape: "S50"
              },
              ApprovedPatches: {
                shape: "S57"
              },
              ApprovedPatchesComplianceLevel: {},
              ApprovedPatchesEnableNonSecurity: {
                type: "boolean"
              },
              RejectedPatches: {
                shape: "S57"
              },
              RejectedPatchesAction: {},
              Description: {},
              Sources: {
                shape: "S5b"
              },
              Replace: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BaselineId: {},
              Name: {},
              OperatingSystem: {},
              GlobalFilters: {
                shape: "S4u"
              },
              ApprovalRules: {
                shape: "S50"
              },
              ApprovedPatches: {
                shape: "S57"
              },
              ApprovedPatchesComplianceLevel: {},
              ApprovedPatchesEnableNonSecurity: {
                type: "boolean"
              },
              RejectedPatches: {
                shape: "S57"
              },
              RejectedPatchesAction: {},
              CreatedDate: {
                type: "timestamp"
              },
              ModifiedDate: {
                type: "timestamp"
              },
              Description: {},
              Sources: {
                shape: "S5b"
              }
            }
          }
        },
        UpdateResourceDataSync: {
          input: {
            type: "structure",
            required: [
              "SyncName",
              "SyncType",
              "SyncSource"
            ],
            members: {
              SyncName: {},
              SyncType: {},
              SyncSource: {
                shape: "S5u"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateServiceSetting: {
          input: {
            type: "structure",
            required: [
              "SettingId",
              "SettingValue"
            ],
            members: {
              SettingId: {},
              SettingValue: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Si: {
          type: "list",
          member: {}
        },
        S10: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          }
        },
        S14: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S1a: {
          type: "structure",
          members: {
            S3Location: {
              type: "structure",
              members: {
                OutputS3Region: {},
                OutputS3BucketName: {},
                OutputS3KeyPrefix: {}
              }
            }
          }
        },
        S1m: {
          type: "list",
          member: {}
        },
        S1o: {
          type: "list",
          member: {
            shape: "S1p"
          }
        },
        S1p: {
          type: "structure",
          members: {
            Accounts: {
              type: "list",
              member: {}
            },
            Regions: {
              type: "list",
              member: {}
            },
            TargetLocationMaxConcurrency: {},
            TargetLocationMaxErrors: {},
            ExecutionRoleName: {}
          }
        },
        S1w: {
          type: "structure",
          members: {
            Name: {},
            InstanceId: {},
            AssociationVersion: {},
            Date: {
              type: "timestamp"
            },
            LastUpdateAssociationDate: {
              type: "timestamp"
            },
            Status: {
              shape: "S1z"
            },
            Overview: {
              shape: "S23"
            },
            DocumentVersion: {},
            AutomationTargetParameterName: {},
            Parameters: {
              shape: "S10"
            },
            AssociationId: {},
            Targets: {
              shape: "S14"
            },
            ScheduleExpression: {},
            OutputLocation: {
              shape: "S1a"
            },
            LastExecutionDate: {
              type: "timestamp"
            },
            LastSuccessfulExecutionDate: {
              type: "timestamp"
            },
            AssociationName: {},
            MaxErrors: {},
            MaxConcurrency: {},
            ComplianceSeverity: {},
            SyncCompliance: {},
            ApplyOnlyAtCronInterval: {
              type: "boolean"
            },
            CalendarNames: {
              shape: "S1m"
            },
            TargetLocations: {
              shape: "S1o"
            }
          }
        },
        S1z: {
          type: "structure",
          required: [
            "Date",
            "Name",
            "Message"
          ],
          members: {
            Date: {
              type: "timestamp"
            },
            Name: {},
            Message: {},
            AdditionalInfo: {}
          }
        },
        S23: {
          type: "structure",
          members: {
            Status: {},
            DetailedStatus: {},
            AssociationStatusAggregatedCount: {
              type: "map",
              key: {},
              value: {
                type: "integer"
              }
            }
          }
        },
        S2a: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            InstanceId: {},
            Parameters: {
              shape: "S10"
            },
            AutomationTargetParameterName: {},
            DocumentVersion: {},
            Targets: {
              shape: "S14"
            },
            ScheduleExpression: {},
            OutputLocation: {
              shape: "S1a"
            },
            AssociationName: {},
            MaxErrors: {},
            MaxConcurrency: {},
            ComplianceSeverity: {},
            SyncCompliance: {},
            ApplyOnlyAtCronInterval: {
              type: "boolean"
            },
            CalendarNames: {
              shape: "S1m"
            },
            TargetLocations: {
              shape: "S1o"
            }
          }
        },
        S2j: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Version: {}
            }
          }
        },
        S2l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Values: {
                type: "list",
                member: {}
              },
              Name: {}
            }
          }
        },
        S2y: {
          type: "structure",
          members: {
            Sha1: {},
            Hash: {},
            HashType: {},
            Name: {},
            DisplayName: {},
            VersionName: {},
            Owner: {},
            CreatedDate: {
              type: "timestamp"
            },
            Status: {},
            StatusInformation: {},
            DocumentVersion: {},
            Description: {},
            Parameters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {},
                  Type: {},
                  Description: {},
                  DefaultValue: {}
                }
              }
            },
            PlatformTypes: {
              shape: "S3c"
            },
            DocumentType: {},
            SchemaVersion: {},
            LatestVersion: {},
            DefaultVersion: {},
            DocumentFormat: {},
            TargetType: {},
            Tags: {
              shape: "S4"
            },
            AttachmentsInformation: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {}
                }
              }
            },
            Requires: {
              shape: "S2j"
            },
            Author: {},
            ReviewInformation: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ReviewedTime: {
                    type: "timestamp"
                  },
                  Status: {},
                  Reviewer: {}
                }
              }
            },
            ApprovedVersion: {},
            PendingReviewVersion: {},
            ReviewStatus: {}
          }
        },
        S3c: {
          type: "list",
          member: {}
        },
        S3p: {
          type: "string",
          sensitive: true
        },
        S43: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Value: {},
              Type: {}
            }
          }
        },
        S48: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Arn: {}
            }
          }
        },
        S4c: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "OpsItemId"
            ],
            members: {
              OpsItemId: {}
            }
          }
        },
        S4l: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Value: {}
            }
          }
        },
        S4u: {
          type: "structure",
          required: [
            "PatchFilters"
          ],
          members: {
            PatchFilters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Key",
                  "Values"
                ],
                members: {
                  Key: {},
                  Values: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        S50: {
          type: "structure",
          required: [
            "PatchRules"
          ],
          members: {
            PatchRules: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "PatchFilterGroup"
                ],
                members: {
                  PatchFilterGroup: {
                    shape: "S4u"
                  },
                  ComplianceLevel: {},
                  ApproveAfterDays: {
                    type: "integer"
                  },
                  ApproveUntilDate: {},
                  EnableNonSecurity: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S57: {
          type: "list",
          member: {}
        },
        S5b: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Products",
              "Configuration"
            ],
            members: {
              Name: {},
              Products: {
                type: "list",
                member: {}
              },
              Configuration: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        S5l: {
          type: "structure",
          required: [
            "BucketName",
            "SyncFormat",
            "Region"
          ],
          members: {
            BucketName: {},
            Prefix: {},
            SyncFormat: {},
            Region: {},
            AWSKMSKeyARN: {},
            DestinationDataSharing: {
              type: "structure",
              members: {
                DestinationDataSharingType: {}
              }
            }
          }
        },
        S5u: {
          type: "structure",
          required: [
            "SourceType",
            "SourceRegions"
          ],
          members: {
            SourceType: {},
            AwsOrganizationsSource: {
              shape: "S5w"
            },
            SourceRegions: {
              shape: "S61"
            },
            IncludeFutureRegions: {
              type: "boolean"
            },
            EnableAllOpsDataSources: {
              type: "boolean"
            }
          }
        },
        S5w: {
          type: "structure",
          required: [
            "OrganizationSourceType"
          ],
          members: {
            OrganizationSourceType: {},
            OrganizationalUnits: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  OrganizationalUnitId: {}
                }
              }
            }
          }
        },
        S61: {
          type: "list",
          member: {}
        },
        S6i: {
          type: "structure",
          members: {
            TotalCount: {
              type: "integer"
            },
            RemainingCount: {
              type: "integer"
            },
            SummaryItems: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Version: {},
                  Count: {
                    type: "integer"
                  },
                  RemainingCount: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        S6x: {
          type: "list",
          member: {}
        },
        S8s: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          }
        },
        S8x: {
          type: "list",
          member: {
            type: "map",
            key: {},
            value: {
              type: "list",
              member: {}
            }
          }
        },
        S92: {
          type: "structure",
          members: {
            ParameterValues: {
              type: "list",
              member: {}
            },
            Truncated: {
              type: "boolean"
            }
          }
        },
        S96: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DocumentName"
            ],
            members: {
              DocumentName: {},
              DocumentVersion: {},
              Parameters: {
                shape: "S8s"
              },
              TargetParameterName: {},
              Targets: {
                shape: "S14"
              },
              MaxConcurrency: {},
              MaxErrors: {},
              TargetLocations: {
                shape: "S1o"
              }
            }
          }
        },
        S9g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              StepName: {},
              Action: {},
              TimeoutSeconds: {
                type: "long"
              },
              OnFailure: {},
              MaxAttempts: {
                type: "integer"
              },
              ExecutionStartTime: {
                type: "timestamp"
              },
              ExecutionEndTime: {
                type: "timestamp"
              },
              StepStatus: {},
              ResponseCode: {},
              Inputs: {
                type: "map",
                key: {},
                value: {}
              },
              Outputs: {
                shape: "S8s"
              },
              Response: {},
              FailureMessage: {},
              FailureDetails: {
                type: "structure",
                members: {
                  FailureStage: {},
                  FailureType: {},
                  Details: {
                    shape: "S8s"
                  }
                }
              },
              StepExecutionId: {},
              OverriddenParameters: {
                shape: "S8s"
              },
              IsEnd: {
                type: "boolean"
              },
              NextStep: {},
              IsCritical: {
                type: "boolean"
              },
              ValidNextSteps: {
                type: "list",
                member: {}
              },
              Targets: {
                shape: "S14"
              },
              TargetLocation: {
                shape: "S1p"
              }
            }
          }
        },
        S9q: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S9y: {
          type: "structure",
          members: {
            Id: {},
            ReleaseDate: {
              type: "timestamp"
            },
            Title: {},
            Description: {},
            ContentUrl: {},
            Vendor: {},
            ProductFamily: {},
            Product: {},
            Classification: {},
            MsrcSeverity: {},
            KbNumber: {},
            MsrcNumber: {},
            Language: {},
            AdvisoryIds: {
              type: "list",
              member: {}
            },
            BugzillaIds: {
              type: "list",
              member: {}
            },
            CVEIds: {
              type: "list",
              member: {}
            },
            Name: {},
            Epoch: {
              type: "integer"
            },
            Version: {},
            Release: {},
            Arch: {},
            Severity: {},
            Repository: {}
          }
        },
        Sat: {
          type: "list",
          member: {}
        },
        Sbm: {
          type: "list",
          member: {}
        },
        Sc6: {
          type: "structure",
          required: [
            "InstanceId",
            "PatchGroup",
            "BaselineId",
            "OperationStartTime",
            "OperationEndTime",
            "Operation"
          ],
          members: {
            InstanceId: {},
            PatchGroup: {},
            BaselineId: {},
            SnapshotId: {},
            InstallOverrideList: {},
            OwnerInformation: {
              shape: "Sc9"
            },
            InstalledCount: {
              type: "integer"
            },
            InstalledOtherCount: {
              type: "integer"
            },
            InstalledPendingRebootCount: {
              type: "integer"
            },
            InstalledRejectedCount: {
              type: "integer"
            },
            MissingCount: {
              type: "integer"
            },
            FailedCount: {
              type: "integer"
            },
            UnreportedNotApplicableCount: {
              type: "integer"
            },
            NotApplicableCount: {
              type: "integer"
            },
            OperationStartTime: {
              type: "timestamp"
            },
            OperationEndTime: {
              type: "timestamp"
            },
            Operation: {},
            LastNoRebootInstallOperationTime: {
              type: "timestamp"
            },
            RebootOption: {},
            CriticalNonCompliantCount: {
              type: "integer"
            },
            SecurityNonCompliantCount: {
              type: "integer"
            },
            OtherNonCompliantCount: {
              type: "integer"
            }
          }
        },
        Sc9: {
          type: "string",
          sensitive: true
        },
        Sdc: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        Sdo: {
          type: "string",
          sensitive: true
        },
        Sef: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Values: {
                type: "list",
                member: {
                  type: "string",
                  sensitive: true
                },
                sensitive: true
              }
            },
            sensitive: true
          },
          sensitive: true
        },
        Sel: {
          type: "structure",
          required: [
            "S3BucketName",
            "S3Region"
          ],
          members: {
            S3BucketName: {},
            S3KeyPrefix: {},
            S3Region: {}
          }
        },
        Sff: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Option: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        Sfu: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PolicyText: {},
              PolicyType: {},
              PolicyStatus: {}
            }
          }
        },
        Sg0: {
          type: "structure",
          members: {
            BaselineId: {},
            BaselineName: {},
            OperatingSystem: {},
            BaselineDescription: {},
            DefaultBaseline: {
              type: "boolean"
            }
          }
        },
        Shj: {
          type: "structure",
          members: {
            CloudWatchLogGroupName: {},
            CloudWatchOutputEnabled: {
              type: "boolean"
            }
          }
        },
        Si5: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Values"
            ],
            members: {
              Key: {},
              Values: {
                type: "list",
                member: {}
              },
              Type: {}
            }
          }
        },
        Sib: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Expression: {},
              Aggregators: {
                shape: "Sib"
              },
              Groups: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Filters"
                  ],
                  members: {
                    Name: {},
                    Filters: {
                      shape: "Si5"
                    }
                  }
                }
              }
            }
          }
        },
        Sis: {
          type: "list",
          member: {
            type: "map",
            key: {},
            value: {}
          }
        },
        Sjj: {
          type: "structure",
          members: {
            RunCommand: {
              type: "structure",
              members: {
                Comment: {},
                CloudWatchOutputConfig: {
                  shape: "Shj"
                },
                DocumentHash: {},
                DocumentHashType: {},
                DocumentVersion: {},
                NotificationConfig: {
                  shape: "Sjl"
                },
                OutputS3BucketName: {},
                OutputS3KeyPrefix: {},
                Parameters: {
                  shape: "S10"
                },
                ServiceRoleArn: {},
                TimeoutSeconds: {
                  type: "integer"
                }
              }
            },
            Automation: {
              type: "structure",
              members: {
                DocumentVersion: {},
                Parameters: {
                  shape: "S8s"
                }
              }
            },
            StepFunctions: {
              type: "structure",
              members: {
                Input: {
                  type: "string",
                  sensitive: true
                },
                Name: {}
              }
            },
            Lambda: {
              type: "structure",
              members: {
                ClientContext: {},
                Qualifier: {},
                Payload: {
                  type: "blob",
                  sensitive: true
                }
              }
            }
          }
        },
        Sjl: {
          type: "structure",
          members: {
            NotificationArn: {},
            NotificationEvents: {
              type: "list",
              member: {}
            },
            NotificationType: {}
          }
        },
        Sk6: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Values"
            ],
            members: {
              Key: {},
              Values: {
                type: "list",
                member: {}
              },
              Type: {}
            }
          }
        },
        Skc: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AggregatorType: {},
              TypeName: {},
              AttributeName: {},
              Values: {
                type: "map",
                key: {},
                value: {}
              },
              Filters: {
                shape: "Sk6"
              },
              Aggregators: {
                shape: "Skc"
              }
            }
          }
        },
        Sky: {
          type: "structure",
          members: {
            Name: {},
            Type: {},
            Value: {
              shape: "Skz"
            },
            Version: {
              type: "long"
            },
            Selector: {},
            SourceResult: {},
            LastModifiedDate: {
              type: "timestamp"
            },
            ARN: {},
            DataType: {}
          }
        },
        Skz: {
          type: "string",
          sensitive: true
        },
        Sl5: {
          type: "list",
          member: {}
        },
        Sl9: {
          type: "list",
          member: {
            shape: "Sky"
          }
        },
        Sll: {
          type: "structure",
          members: {
            SettingId: {},
            SettingValue: {},
            LastModifiedDate: {
              type: "timestamp"
            },
            LastModifiedUser: {},
            ARN: {},
            Status: {}
          }
        },
        Sm3: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        Smj: {
          type: "structure",
          members: {
            CommandId: {},
            DocumentName: {},
            DocumentVersion: {},
            Comment: {},
            ExpiresAfter: {
              type: "timestamp"
            },
            Parameters: {
              shape: "S10"
            },
            InstanceIds: {
              shape: "Si"
            },
            Targets: {
              shape: "S14"
            },
            RequestedDateTime: {
              type: "timestamp"
            },
            Status: {},
            StatusDetails: {},
            OutputS3Region: {},
            OutputS3BucketName: {},
            OutputS3KeyPrefix: {},
            MaxConcurrency: {},
            MaxErrors: {},
            TargetCount: {
              type: "integer"
            },
            CompletedCount: {
              type: "integer"
            },
            ErrorCount: {
              type: "integer"
            },
            DeliveryTimedOutCount: {
              type: "integer"
            },
            ServiceRole: {},
            NotificationConfig: {
              shape: "Sjl"
            },
            CloudWatchOutputConfig: {
              shape: "Shj"
            },
            TimeoutSeconds: {
              type: "integer"
            }
          }
        },
        Smq: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Values: {
                type: "list",
                member: {}
              },
              Type: {}
            }
          }
        },
        Sn8: {
          type: "structure",
          required: [
            "ExecutionTime"
          ],
          members: {
            ExecutionTime: {
              type: "timestamp"
            },
            ExecutionId: {},
            ExecutionType: {}
          }
        },
        Snb: {
          type: "map",
          key: {},
          value: {}
        },
        Sng: {
          type: "structure",
          members: {
            CompliantCount: {
              type: "integer"
            },
            SeveritySummary: {
              shape: "Sni"
            }
          }
        },
        Sni: {
          type: "structure",
          members: {
            CriticalCount: {
              type: "integer"
            },
            HighCount: {
              type: "integer"
            },
            MediumCount: {
              type: "integer"
            },
            LowCount: {
              type: "integer"
            },
            InformationalCount: {
              type: "integer"
            },
            UnspecifiedCount: {
              type: "integer"
            }
          }
        },
        Snj: {
          type: "structure",
          members: {
            NonCompliantCount: {
              type: "integer"
            },
            SeveritySummary: {
              shape: "Sni"
            }
          }
        },
        Snq: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              Content: {}
            }
          }
        },
        Soo: {
          type: "structure",
          members: {
            Arn: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ssm-2014-11-06.paginators.json
var require_ssm_2014_11_06_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ssm-2014-11-06.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeActivations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ActivationList"
        },
        DescribeAssociationExecutionTargets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AssociationExecutionTargets"
        },
        DescribeAssociationExecutions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AssociationExecutions"
        },
        DescribeAutomationExecutions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AutomationExecutionMetadataList"
        },
        DescribeAutomationStepExecutions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "StepExecutions"
        },
        DescribeAvailablePatches: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Patches"
        },
        DescribeEffectiveInstanceAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Associations"
        },
        DescribeEffectivePatchesForPatchBaseline: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "EffectivePatches"
        },
        DescribeInstanceAssociationsStatus: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstanceAssociationStatusInfos"
        },
        DescribeInstanceInformation: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstanceInformationList"
        },
        DescribeInstancePatchStates: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstancePatchStates"
        },
        DescribeInstancePatchStatesForPatchGroup: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstancePatchStates"
        },
        DescribeInstancePatches: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Patches"
        },
        DescribeInventoryDeletions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InventoryDeletions"
        },
        DescribeMaintenanceWindowExecutionTaskInvocations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "WindowExecutionTaskInvocationIdentities"
        },
        DescribeMaintenanceWindowExecutionTasks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "WindowExecutionTaskIdentities"
        },
        DescribeMaintenanceWindowExecutions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "WindowExecutions"
        },
        DescribeMaintenanceWindowSchedule: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ScheduledWindowExecutions"
        },
        DescribeMaintenanceWindowTargets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Targets"
        },
        DescribeMaintenanceWindowTasks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Tasks"
        },
        DescribeMaintenanceWindows: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "WindowIdentities"
        },
        DescribeMaintenanceWindowsForTarget: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "WindowIdentities"
        },
        DescribeOpsItems: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "OpsItemSummaries"
        },
        DescribeParameters: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        DescribePatchBaselines: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "BaselineIdentities"
        },
        DescribePatchGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Mappings"
        },
        DescribePatchProperties: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Properties"
        },
        DescribeSessions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Sessions"
        },
        GetInventory: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Entities"
        },
        GetInventorySchema: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Schemas"
        },
        GetOpsSummary: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Entities"
        },
        GetParameterHistory: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetParametersByPath: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListAssociationVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AssociationVersions"
        },
        ListAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Associations"
        },
        ListCommandInvocations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CommandInvocations"
        },
        ListCommands: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Commands"
        },
        ListComplianceItems: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ComplianceItems"
        },
        ListComplianceSummaries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ComplianceSummaryItems"
        },
        ListDocumentVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DocumentVersions"
        },
        ListDocuments: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DocumentIdentifiers"
        },
        ListOpsItemEvents: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Summaries"
        },
        ListOpsItemRelatedItems: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Summaries"
        },
        ListOpsMetadata: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "OpsMetadataList"
        },
        ListResourceComplianceSummaries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ResourceComplianceSummaryItems"
        },
        ListResourceDataSync: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ResourceDataSyncItems"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ssm-2014-11-06.waiters2.json
var require_ssm_2014_11_06_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/ssm-2014-11-06.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        CommandExecuted: {
          delay: 5,
          operation: "GetCommandInvocation",
          maxAttempts: 20,
          acceptors: [
            {
              expected: "Pending",
              matcher: "path",
              state: "retry",
              argument: "Status"
            },
            {
              expected: "InProgress",
              matcher: "path",
              state: "retry",
              argument: "Status"
            },
            {
              expected: "Delayed",
              matcher: "path",
              state: "retry",
              argument: "Status"
            },
            {
              expected: "Success",
              matcher: "path",
              state: "success",
              argument: "Status"
            },
            {
              expected: "Cancelled",
              matcher: "path",
              state: "failure",
              argument: "Status"
            },
            {
              expected: "TimedOut",
              matcher: "path",
              state: "failure",
              argument: "Status"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "Status"
            },
            {
              expected: "Cancelling",
              matcher: "path",
              state: "failure",
              argument: "Status"
            },
            {
              state: "retry",
              matcher: "error",
              expected: "InvocationDoesNotExist"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ssm.js
var require_ssm = __commonJS({
  "node_modules/aws-sdk/clients/ssm.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["ssm"] = {};
    AWS3.SSM = Service.defineService("ssm", ["2014-11-06"]);
    Object.defineProperty(apiLoader.services["ssm"], "2014-11-06", {
      get: function get() {
        var model = require_ssm_2014_11_06_min();
        model.paginators = require_ssm_2014_11_06_paginators().pagination;
        model.waiters = require_ssm_2014_11_06_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SSM;
  }
});

// node_modules/aws-sdk/apis/storagegateway-2013-06-30.min.json
var require_storagegateway_2013_06_30_min = __commonJS({
  "node_modules/aws-sdk/apis/storagegateway-2013-06-30.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-06-30",
        endpointPrefix: "storagegateway",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Storage Gateway",
        serviceId: "Storage Gateway",
        signatureVersion: "v4",
        targetPrefix: "StorageGateway_20130630",
        uid: "storagegateway-2013-06-30"
      },
      operations: {
        ActivateGateway: {
          input: {
            type: "structure",
            required: [
              "ActivationKey",
              "GatewayName",
              "GatewayTimezone",
              "GatewayRegion"
            ],
            members: {
              ActivationKey: {},
              GatewayName: {},
              GatewayTimezone: {},
              GatewayRegion: {},
              GatewayType: {},
              TapeDriveType: {},
              MediumChangerType: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        AddCache: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "DiskIds"
            ],
            members: {
              GatewayARN: {},
              DiskIds: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceARN: {}
            }
          }
        },
        AddUploadBuffer: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "DiskIds"
            ],
            members: {
              GatewayARN: {},
              DiskIds: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        AddWorkingStorage: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "DiskIds"
            ],
            members: {
              GatewayARN: {},
              DiskIds: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        AssignTapePool: {
          input: {
            type: "structure",
            required: [
              "TapeARN",
              "PoolId"
            ],
            members: {
              TapeARN: {},
              PoolId: {},
              BypassGovernanceRetention: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TapeARN: {}
            }
          }
        },
        AssociateFileSystem: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "Password",
              "ClientToken",
              "GatewayARN",
              "LocationARN"
            ],
            members: {
              UserName: {},
              Password: {
                shape: "Sx"
              },
              ClientToken: {},
              GatewayARN: {},
              LocationARN: {},
              Tags: {
                shape: "S9"
              },
              AuditDestinationARN: {},
              CacheAttributes: {
                shape: "S11"
              },
              EndpointNetworkConfiguration: {
                shape: "S13"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileSystemAssociationARN: {}
            }
          }
        },
        AttachVolume: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "VolumeARN",
              "NetworkInterfaceId"
            ],
            members: {
              GatewayARN: {},
              TargetName: {},
              VolumeARN: {},
              NetworkInterfaceId: {},
              DiskId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeARN: {},
              TargetARN: {}
            }
          }
        },
        CancelArchival: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "TapeARN"
            ],
            members: {
              GatewayARN: {},
              TapeARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TapeARN: {}
            }
          }
        },
        CancelRetrieval: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "TapeARN"
            ],
            members: {
              GatewayARN: {},
              TapeARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TapeARN: {}
            }
          }
        },
        CreateCachediSCSIVolume: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "VolumeSizeInBytes",
              "TargetName",
              "NetworkInterfaceId",
              "ClientToken"
            ],
            members: {
              GatewayARN: {},
              VolumeSizeInBytes: {
                type: "long"
              },
              SnapshotId: {},
              TargetName: {},
              SourceVolumeARN: {},
              NetworkInterfaceId: {},
              ClientToken: {},
              KMSEncrypted: {
                type: "boolean"
              },
              KMSKey: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeARN: {},
              TargetARN: {}
            }
          }
        },
        CreateNFSFileShare: {
          input: {
            type: "structure",
            required: [
              "ClientToken",
              "GatewayARN",
              "Role",
              "LocationARN"
            ],
            members: {
              ClientToken: {},
              NFSFileShareDefaults: {
                shape: "S1p"
              },
              GatewayARN: {},
              KMSEncrypted: {
                type: "boolean"
              },
              KMSKey: {},
              Role: {},
              LocationARN: {},
              DefaultStorageClass: {},
              ObjectACL: {},
              ClientList: {
                shape: "S1w"
              },
              Squash: {},
              ReadOnly: {
                type: "boolean"
              },
              GuessMIMETypeEnabled: {
                type: "boolean"
              },
              RequesterPays: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              },
              FileShareName: {},
              CacheAttributes: {
                shape: "S11"
              },
              NotificationPolicy: {},
              VPCEndpointDNSName: {},
              BucketRegion: {},
              AuditDestinationARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FileShareARN: {}
            }
          }
        },
        CreateSMBFileShare: {
          input: {
            type: "structure",
            required: [
              "ClientToken",
              "GatewayARN",
              "Role",
              "LocationARN"
            ],
            members: {
              ClientToken: {},
              GatewayARN: {},
              KMSEncrypted: {
                type: "boolean"
              },
              KMSKey: {},
              Role: {},
              LocationARN: {},
              DefaultStorageClass: {},
              ObjectACL: {},
              ReadOnly: {
                type: "boolean"
              },
              GuessMIMETypeEnabled: {
                type: "boolean"
              },
              RequesterPays: {
                type: "boolean"
              },
              SMBACLEnabled: {
                type: "boolean"
              },
              AccessBasedEnumeration: {
                type: "boolean"
              },
              AdminUserList: {
                shape: "S25"
              },
              ValidUserList: {
                shape: "S25"
              },
              InvalidUserList: {
                shape: "S25"
              },
              AuditDestinationARN: {},
              Authentication: {},
              CaseSensitivity: {},
              Tags: {
                shape: "S9"
              },
              FileShareName: {},
              CacheAttributes: {
                shape: "S11"
              },
              NotificationPolicy: {},
              VPCEndpointDNSName: {},
              BucketRegion: {},
              OplocksEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileShareARN: {}
            }
          }
        },
        CreateSnapshot: {
          input: {
            type: "structure",
            required: [
              "VolumeARN",
              "SnapshotDescription"
            ],
            members: {
              VolumeARN: {},
              SnapshotDescription: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeARN: {},
              SnapshotId: {}
            }
          }
        },
        CreateSnapshotFromVolumeRecoveryPoint: {
          input: {
            type: "structure",
            required: [
              "VolumeARN",
              "SnapshotDescription"
            ],
            members: {
              VolumeARN: {},
              SnapshotDescription: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SnapshotId: {},
              VolumeARN: {},
              VolumeRecoveryPointTime: {}
            }
          }
        },
        CreateStorediSCSIVolume: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "DiskId",
              "PreserveExistingData",
              "TargetName",
              "NetworkInterfaceId"
            ],
            members: {
              GatewayARN: {},
              DiskId: {},
              SnapshotId: {},
              PreserveExistingData: {
                type: "boolean"
              },
              TargetName: {},
              NetworkInterfaceId: {},
              KMSEncrypted: {
                type: "boolean"
              },
              KMSKey: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeARN: {},
              VolumeSizeInBytes: {
                type: "long"
              },
              TargetARN: {}
            }
          }
        },
        CreateTapePool: {
          input: {
            type: "structure",
            required: [
              "PoolName",
              "StorageClass"
            ],
            members: {
              PoolName: {},
              StorageClass: {},
              RetentionLockType: {},
              RetentionLockTimeInDays: {
                type: "integer"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PoolARN: {}
            }
          }
        },
        CreateTapeWithBarcode: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "TapeSizeInBytes",
              "TapeBarcode"
            ],
            members: {
              GatewayARN: {},
              TapeSizeInBytes: {
                type: "long"
              },
              TapeBarcode: {},
              KMSEncrypted: {
                type: "boolean"
              },
              KMSKey: {},
              PoolId: {},
              Worm: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TapeARN: {}
            }
          }
        },
        CreateTapes: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "TapeSizeInBytes",
              "ClientToken",
              "NumTapesToCreate",
              "TapeBarcodePrefix"
            ],
            members: {
              GatewayARN: {},
              TapeSizeInBytes: {
                type: "long"
              },
              ClientToken: {},
              NumTapesToCreate: {
                type: "integer"
              },
              TapeBarcodePrefix: {},
              KMSEncrypted: {
                type: "boolean"
              },
              KMSKey: {},
              PoolId: {},
              Worm: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TapeARNs: {
                shape: "S2x"
              }
            }
          }
        },
        DeleteAutomaticTapeCreationPolicy: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        DeleteBandwidthRateLimit: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "BandwidthType"
            ],
            members: {
              GatewayARN: {},
              BandwidthType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        DeleteChapCredentials: {
          input: {
            type: "structure",
            required: [
              "TargetARN",
              "InitiatorName"
            ],
            members: {
              TargetARN: {},
              InitiatorName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TargetARN: {},
              InitiatorName: {}
            }
          }
        },
        DeleteFileShare: {
          input: {
            type: "structure",
            required: [
              "FileShareARN"
            ],
            members: {
              FileShareARN: {},
              ForceDelete: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileShareARN: {}
            }
          }
        },
        DeleteGateway: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        DeleteSnapshotSchedule: {
          input: {
            type: "structure",
            required: [
              "VolumeARN"
            ],
            members: {
              VolumeARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeARN: {}
            }
          }
        },
        DeleteTape: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "TapeARN"
            ],
            members: {
              GatewayARN: {},
              TapeARN: {},
              BypassGovernanceRetention: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TapeARN: {}
            }
          }
        },
        DeleteTapeArchive: {
          input: {
            type: "structure",
            required: [
              "TapeARN"
            ],
            members: {
              TapeARN: {},
              BypassGovernanceRetention: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TapeARN: {}
            }
          }
        },
        DeleteTapePool: {
          input: {
            type: "structure",
            required: [
              "PoolARN"
            ],
            members: {
              PoolARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PoolARN: {}
            }
          }
        },
        DeleteVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeARN"
            ],
            members: {
              VolumeARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeARN: {}
            }
          }
        },
        DescribeAvailabilityMonitorTest: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              Status: {},
              StartTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeBandwidthRateLimit: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              AverageUploadRateLimitInBitsPerSec: {
                type: "long"
              },
              AverageDownloadRateLimitInBitsPerSec: {
                type: "long"
              }
            }
          }
        },
        DescribeBandwidthRateLimitSchedule: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              BandwidthRateLimitIntervals: {
                shape: "S3u"
              }
            }
          }
        },
        DescribeCache: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              DiskIds: {
                shape: "Sg"
              },
              CacheAllocatedInBytes: {
                type: "long"
              },
              CacheUsedPercentage: {
                type: "double"
              },
              CacheDirtyPercentage: {
                type: "double"
              },
              CacheHitPercentage: {
                type: "double"
              },
              CacheMissPercentage: {
                type: "double"
              }
            }
          }
        },
        DescribeCachediSCSIVolumes: {
          input: {
            type: "structure",
            required: [
              "VolumeARNs"
            ],
            members: {
              VolumeARNs: {
                shape: "S44"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CachediSCSIVolumes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VolumeARN: {},
                    VolumeId: {},
                    VolumeType: {},
                    VolumeStatus: {},
                    VolumeAttachmentStatus: {},
                    VolumeSizeInBytes: {
                      type: "long"
                    },
                    VolumeProgress: {
                      type: "double"
                    },
                    SourceSnapshotId: {},
                    VolumeiSCSIAttributes: {
                      shape: "S4d"
                    },
                    CreatedDate: {
                      type: "timestamp"
                    },
                    VolumeUsedInBytes: {
                      type: "long"
                    },
                    KMSKey: {},
                    TargetName: {}
                  }
                }
              }
            }
          }
        },
        DescribeChapCredentials: {
          input: {
            type: "structure",
            required: [
              "TargetARN"
            ],
            members: {
              TargetARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChapCredentials: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TargetARN: {},
                    SecretToAuthenticateInitiator: {
                      shape: "S4m"
                    },
                    InitiatorName: {},
                    SecretToAuthenticateTarget: {
                      shape: "S4m"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeFileSystemAssociations: {
          input: {
            type: "structure",
            required: [
              "FileSystemAssociationARNList"
            ],
            members: {
              FileSystemAssociationARNList: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileSystemAssociationInfoList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FileSystemAssociationARN: {},
                    LocationARN: {},
                    FileSystemAssociationStatus: {},
                    AuditDestinationARN: {},
                    GatewayARN: {},
                    Tags: {
                      shape: "S9"
                    },
                    CacheAttributes: {
                      shape: "S11"
                    },
                    EndpointNetworkConfiguration: {
                      shape: "S13"
                    },
                    FileSystemAssociationStatusDetails: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ErrorCode: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeGatewayInformation: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              GatewayId: {},
              GatewayName: {},
              GatewayTimezone: {},
              GatewayState: {},
              GatewayNetworkInterfaces: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Ipv4Address: {},
                    MacAddress: {},
                    Ipv6Address: {}
                  }
                }
              },
              GatewayType: {},
              NextUpdateAvailabilityDate: {},
              LastSoftwareUpdate: {},
              Ec2InstanceId: {},
              Ec2InstanceRegion: {},
              Tags: {
                shape: "S9"
              },
              VPCEndpoint: {},
              CloudWatchLogGroupARN: {},
              HostEnvironment: {},
              EndpointType: {},
              SoftwareUpdatesEndDate: {},
              DeprecationDate: {},
              GatewayCapacity: {},
              SupportedGatewayCapacities: {
                type: "list",
                member: {}
              }
            }
          }
        },
        DescribeMaintenanceStartTime: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              HourOfDay: {
                type: "integer"
              },
              MinuteOfHour: {
                type: "integer"
              },
              DayOfWeek: {
                type: "integer"
              },
              DayOfMonth: {
                type: "integer"
              },
              Timezone: {}
            }
          }
        },
        DescribeNFSFileShares: {
          input: {
            type: "structure",
            required: [
              "FileShareARNList"
            ],
            members: {
              FileShareARNList: {
                shape: "S5h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NFSFileShareInfoList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    NFSFileShareDefaults: {
                      shape: "S1p"
                    },
                    FileShareARN: {},
                    FileShareId: {},
                    FileShareStatus: {},
                    GatewayARN: {},
                    KMSEncrypted: {
                      type: "boolean"
                    },
                    KMSKey: {},
                    Path: {},
                    Role: {},
                    LocationARN: {},
                    DefaultStorageClass: {},
                    ObjectACL: {},
                    ClientList: {
                      shape: "S1w"
                    },
                    Squash: {},
                    ReadOnly: {
                      type: "boolean"
                    },
                    GuessMIMETypeEnabled: {
                      type: "boolean"
                    },
                    RequesterPays: {
                      type: "boolean"
                    },
                    Tags: {
                      shape: "S9"
                    },
                    FileShareName: {},
                    CacheAttributes: {
                      shape: "S11"
                    },
                    NotificationPolicy: {},
                    VPCEndpointDNSName: {},
                    BucketRegion: {},
                    AuditDestinationARN: {}
                  }
                }
              }
            }
          }
        },
        DescribeSMBFileShares: {
          input: {
            type: "structure",
            required: [
              "FileShareARNList"
            ],
            members: {
              FileShareARNList: {
                shape: "S5h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SMBFileShareInfoList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FileShareARN: {},
                    FileShareId: {},
                    FileShareStatus: {},
                    GatewayARN: {},
                    KMSEncrypted: {
                      type: "boolean"
                    },
                    KMSKey: {},
                    Path: {},
                    Role: {},
                    LocationARN: {},
                    DefaultStorageClass: {},
                    ObjectACL: {},
                    ReadOnly: {
                      type: "boolean"
                    },
                    GuessMIMETypeEnabled: {
                      type: "boolean"
                    },
                    RequesterPays: {
                      type: "boolean"
                    },
                    SMBACLEnabled: {
                      type: "boolean"
                    },
                    AccessBasedEnumeration: {
                      type: "boolean"
                    },
                    AdminUserList: {
                      shape: "S25"
                    },
                    ValidUserList: {
                      shape: "S25"
                    },
                    InvalidUserList: {
                      shape: "S25"
                    },
                    AuditDestinationARN: {},
                    Authentication: {},
                    CaseSensitivity: {},
                    Tags: {
                      shape: "S9"
                    },
                    FileShareName: {},
                    CacheAttributes: {
                      shape: "S11"
                    },
                    NotificationPolicy: {},
                    VPCEndpointDNSName: {},
                    BucketRegion: {},
                    OplocksEnabled: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeSMBSettings: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              DomainName: {},
              ActiveDirectoryStatus: {},
              SMBGuestPasswordSet: {
                type: "boolean"
              },
              SMBSecurityStrategy: {},
              FileSharesVisible: {
                type: "boolean"
              },
              SMBLocalGroups: {
                shape: "S5x"
              }
            }
          }
        },
        DescribeSnapshotSchedule: {
          input: {
            type: "structure",
            required: [
              "VolumeARN"
            ],
            members: {
              VolumeARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeARN: {},
              StartAt: {
                type: "integer"
              },
              RecurrenceInHours: {
                type: "integer"
              },
              Description: {},
              Timezone: {},
              Tags: {
                shape: "S9"
              }
            }
          }
        },
        DescribeStorediSCSIVolumes: {
          input: {
            type: "structure",
            required: [
              "VolumeARNs"
            ],
            members: {
              VolumeARNs: {
                shape: "S44"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StorediSCSIVolumes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VolumeARN: {},
                    VolumeId: {},
                    VolumeType: {},
                    VolumeStatus: {},
                    VolumeAttachmentStatus: {},
                    VolumeSizeInBytes: {
                      type: "long"
                    },
                    VolumeProgress: {
                      type: "double"
                    },
                    VolumeDiskId: {},
                    SourceSnapshotId: {},
                    PreservedExistingData: {
                      type: "boolean"
                    },
                    VolumeiSCSIAttributes: {
                      shape: "S4d"
                    },
                    CreatedDate: {
                      type: "timestamp"
                    },
                    VolumeUsedInBytes: {
                      type: "long"
                    },
                    KMSKey: {},
                    TargetName: {}
                  }
                }
              }
            }
          }
        },
        DescribeTapeArchives: {
          input: {
            type: "structure",
            members: {
              TapeARNs: {
                shape: "S2x"
              },
              Marker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TapeArchives: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TapeARN: {},
                    TapeBarcode: {},
                    TapeCreatedDate: {
                      type: "timestamp"
                    },
                    TapeSizeInBytes: {
                      type: "long"
                    },
                    CompletionTime: {
                      type: "timestamp"
                    },
                    RetrievedTo: {},
                    TapeStatus: {},
                    TapeUsedInBytes: {
                      type: "long"
                    },
                    KMSKey: {},
                    PoolId: {},
                    Worm: {
                      type: "boolean"
                    },
                    RetentionStartDate: {
                      type: "timestamp"
                    },
                    PoolEntryDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeTapeRecoveryPoints: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {},
              Marker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              TapeRecoveryPointInfos: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TapeARN: {},
                    TapeRecoveryPointTime: {
                      type: "timestamp"
                    },
                    TapeSizeInBytes: {
                      type: "long"
                    },
                    TapeStatus: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeTapes: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {},
              TapeARNs: {
                shape: "S2x"
              },
              Marker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tapes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TapeARN: {},
                    TapeBarcode: {},
                    TapeCreatedDate: {
                      type: "timestamp"
                    },
                    TapeSizeInBytes: {
                      type: "long"
                    },
                    TapeStatus: {},
                    VTLDevice: {},
                    Progress: {
                      type: "double"
                    },
                    TapeUsedInBytes: {
                      type: "long"
                    },
                    KMSKey: {},
                    PoolId: {},
                    Worm: {
                      type: "boolean"
                    },
                    RetentionStartDate: {
                      type: "timestamp"
                    },
                    PoolEntryDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeUploadBuffer: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              DiskIds: {
                shape: "Sg"
              },
              UploadBufferUsedInBytes: {
                type: "long"
              },
              UploadBufferAllocatedInBytes: {
                type: "long"
              }
            }
          }
        },
        DescribeVTLDevices: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {},
              VTLDeviceARNs: {
                type: "list",
                member: {}
              },
              Marker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              VTLDevices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VTLDeviceARN: {},
                    VTLDeviceType: {},
                    VTLDeviceVendor: {},
                    VTLDeviceProductIdentifier: {},
                    DeviceiSCSIAttributes: {
                      type: "structure",
                      members: {
                        TargetARN: {},
                        NetworkInterfaceId: {},
                        NetworkInterfacePort: {
                          type: "integer"
                        },
                        ChapEnabled: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeWorkingStorage: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              DiskIds: {
                shape: "Sg"
              },
              WorkingStorageUsedInBytes: {
                type: "long"
              },
              WorkingStorageAllocatedInBytes: {
                type: "long"
              }
            }
          }
        },
        DetachVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeARN"
            ],
            members: {
              VolumeARN: {},
              ForceDetach: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeARN: {}
            }
          }
        },
        DisableGateway: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        DisassociateFileSystem: {
          input: {
            type: "structure",
            required: [
              "FileSystemAssociationARN"
            ],
            members: {
              FileSystemAssociationARN: {},
              ForceDelete: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileSystemAssociationARN: {}
            }
          }
        },
        JoinDomain: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "DomainName",
              "UserName",
              "Password"
            ],
            members: {
              GatewayARN: {},
              DomainName: {},
              OrganizationalUnit: {},
              DomainControllers: {
                type: "list",
                member: {}
              },
              TimeoutInSeconds: {
                type: "integer"
              },
              UserName: {},
              Password: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              ActiveDirectoryStatus: {}
            }
          }
        },
        ListAutomaticTapeCreationPolicies: {
          input: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AutomaticTapeCreationPolicyInfos: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AutomaticTapeCreationRules: {
                      shape: "S7h"
                    },
                    GatewayARN: {}
                  }
                }
              }
            }
          }
        },
        ListFileShares: {
          input: {
            type: "structure",
            members: {
              GatewayARN: {},
              Limit: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              NextMarker: {},
              FileShareInfoList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FileShareType: {},
                    FileShareARN: {},
                    FileShareId: {},
                    FileShareStatus: {},
                    GatewayARN: {}
                  }
                }
              }
            }
          }
        },
        ListFileSystemAssociations: {
          input: {
            type: "structure",
            members: {
              GatewayARN: {},
              Limit: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Marker: {},
              NextMarker: {},
              FileSystemAssociationSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FileSystemAssociationId: {},
                    FileSystemAssociationARN: {},
                    FileSystemAssociationStatus: {},
                    GatewayARN: {}
                  }
                }
              }
            }
          }
        },
        ListGateways: {
          input: {
            type: "structure",
            members: {
              Marker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Gateways: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GatewayId: {},
                    GatewayARN: {},
                    GatewayType: {},
                    GatewayOperationalState: {},
                    GatewayName: {},
                    Ec2InstanceId: {},
                    Ec2InstanceRegion: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListLocalDisks: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              Disks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DiskId: {},
                    DiskPath: {},
                    DiskNode: {},
                    DiskStatus: {},
                    DiskSizeInBytes: {
                      type: "long"
                    },
                    DiskAllocationType: {},
                    DiskAllocationResource: {},
                    DiskAttributeList: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {},
              Marker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceARN: {},
              Marker: {},
              Tags: {
                shape: "S9"
              }
            }
          }
        },
        ListTapePools: {
          input: {
            type: "structure",
            members: {
              PoolARNs: {
                type: "list",
                member: {}
              },
              Marker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PoolInfos: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PoolARN: {},
                    PoolName: {},
                    StorageClass: {},
                    RetentionLockType: {},
                    RetentionLockTimeInDays: {
                      type: "integer"
                    },
                    PoolStatus: {}
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListTapes: {
          input: {
            type: "structure",
            members: {
              TapeARNs: {
                shape: "S2x"
              },
              Marker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TapeInfos: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TapeARN: {},
                    TapeBarcode: {},
                    TapeSizeInBytes: {
                      type: "long"
                    },
                    TapeStatus: {},
                    GatewayARN: {},
                    PoolId: {},
                    RetentionStartDate: {
                      type: "timestamp"
                    },
                    PoolEntryDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        ListVolumeInitiators: {
          input: {
            type: "structure",
            required: [
              "VolumeARN"
            ],
            members: {
              VolumeARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Initiators: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListVolumeRecoveryPoints: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              VolumeRecoveryPointInfos: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VolumeARN: {},
                    VolumeSizeInBytes: {
                      type: "long"
                    },
                    VolumeUsageInBytes: {
                      type: "long"
                    },
                    VolumeRecoveryPointTime: {}
                  }
                }
              }
            }
          }
        },
        ListVolumes: {
          input: {
            type: "structure",
            members: {
              GatewayARN: {},
              Marker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              Marker: {},
              VolumeInfos: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VolumeARN: {},
                    VolumeId: {},
                    GatewayARN: {},
                    GatewayId: {},
                    VolumeType: {},
                    VolumeSizeInBytes: {
                      type: "long"
                    },
                    VolumeAttachmentStatus: {}
                  }
                }
              }
            }
          }
        },
        NotifyWhenUploaded: {
          input: {
            type: "structure",
            required: [
              "FileShareARN"
            ],
            members: {
              FileShareARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FileShareARN: {},
              NotificationId: {}
            }
          }
        },
        RefreshCache: {
          input: {
            type: "structure",
            required: [
              "FileShareARN"
            ],
            members: {
              FileShareARN: {},
              FolderList: {
                type: "list",
                member: {}
              },
              Recursive: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileShareARN: {},
              NotificationId: {}
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceARN: {}
            }
          }
        },
        ResetCache: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        RetrieveTapeArchive: {
          input: {
            type: "structure",
            required: [
              "TapeARN",
              "GatewayARN"
            ],
            members: {
              TapeARN: {},
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TapeARN: {}
            }
          }
        },
        RetrieveTapeRecoveryPoint: {
          input: {
            type: "structure",
            required: [
              "TapeARN",
              "GatewayARN"
            ],
            members: {
              TapeARN: {},
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TapeARN: {}
            }
          }
        },
        SetLocalConsolePassword: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "LocalConsolePassword"
            ],
            members: {
              GatewayARN: {},
              LocalConsolePassword: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        SetSMBGuestPassword: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "Password"
            ],
            members: {
              GatewayARN: {},
              Password: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        ShutdownGateway: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        StartAvailabilityMonitorTest: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        StartGateway: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        UpdateAutomaticTapeCreationPolicy: {
          input: {
            type: "structure",
            required: [
              "AutomaticTapeCreationRules",
              "GatewayARN"
            ],
            members: {
              AutomaticTapeCreationRules: {
                shape: "S7h"
              },
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        UpdateBandwidthRateLimit: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {},
              AverageUploadRateLimitInBitsPerSec: {
                type: "long"
              },
              AverageDownloadRateLimitInBitsPerSec: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        UpdateBandwidthRateLimitSchedule: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "BandwidthRateLimitIntervals"
            ],
            members: {
              GatewayARN: {},
              BandwidthRateLimitIntervals: {
                shape: "S3u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        UpdateChapCredentials: {
          input: {
            type: "structure",
            required: [
              "TargetARN",
              "SecretToAuthenticateInitiator",
              "InitiatorName"
            ],
            members: {
              TargetARN: {},
              SecretToAuthenticateInitiator: {
                shape: "S4m"
              },
              InitiatorName: {},
              SecretToAuthenticateTarget: {
                shape: "S4m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TargetARN: {},
              InitiatorName: {}
            }
          }
        },
        UpdateFileSystemAssociation: {
          input: {
            type: "structure",
            required: [
              "FileSystemAssociationARN"
            ],
            members: {
              FileSystemAssociationARN: {},
              UserName: {},
              Password: {
                shape: "Sx"
              },
              AuditDestinationARN: {},
              CacheAttributes: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileSystemAssociationARN: {}
            }
          }
        },
        UpdateGatewayInformation: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {},
              GatewayName: {},
              GatewayTimezone: {},
              CloudWatchLogGroupARN: {},
              GatewayCapacity: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {},
              GatewayName: {}
            }
          }
        },
        UpdateGatewaySoftwareNow: {
          input: {
            type: "structure",
            required: [
              "GatewayARN"
            ],
            members: {
              GatewayARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        UpdateMaintenanceStartTime: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "HourOfDay",
              "MinuteOfHour"
            ],
            members: {
              GatewayARN: {},
              HourOfDay: {
                type: "integer"
              },
              MinuteOfHour: {
                type: "integer"
              },
              DayOfWeek: {
                type: "integer"
              },
              DayOfMonth: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        UpdateNFSFileShare: {
          input: {
            type: "structure",
            required: [
              "FileShareARN"
            ],
            members: {
              FileShareARN: {},
              KMSEncrypted: {
                type: "boolean"
              },
              KMSKey: {},
              NFSFileShareDefaults: {
                shape: "S1p"
              },
              DefaultStorageClass: {},
              ObjectACL: {},
              ClientList: {
                shape: "S1w"
              },
              Squash: {},
              ReadOnly: {
                type: "boolean"
              },
              GuessMIMETypeEnabled: {
                type: "boolean"
              },
              RequesterPays: {
                type: "boolean"
              },
              FileShareName: {},
              CacheAttributes: {
                shape: "S11"
              },
              NotificationPolicy: {},
              AuditDestinationARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FileShareARN: {}
            }
          }
        },
        UpdateSMBFileShare: {
          input: {
            type: "structure",
            required: [
              "FileShareARN"
            ],
            members: {
              FileShareARN: {},
              KMSEncrypted: {
                type: "boolean"
              },
              KMSKey: {},
              DefaultStorageClass: {},
              ObjectACL: {},
              ReadOnly: {
                type: "boolean"
              },
              GuessMIMETypeEnabled: {
                type: "boolean"
              },
              RequesterPays: {
                type: "boolean"
              },
              SMBACLEnabled: {
                type: "boolean"
              },
              AccessBasedEnumeration: {
                type: "boolean"
              },
              AdminUserList: {
                shape: "S25"
              },
              ValidUserList: {
                shape: "S25"
              },
              InvalidUserList: {
                shape: "S25"
              },
              AuditDestinationARN: {},
              CaseSensitivity: {},
              FileShareName: {},
              CacheAttributes: {
                shape: "S11"
              },
              NotificationPolicy: {},
              OplocksEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileShareARN: {}
            }
          }
        },
        UpdateSMBFileShareVisibility: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "FileSharesVisible"
            ],
            members: {
              GatewayARN: {},
              FileSharesVisible: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        UpdateSMBLocalGroups: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "SMBLocalGroups"
            ],
            members: {
              GatewayARN: {},
              SMBLocalGroups: {
                shape: "S5x"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        UpdateSMBSecurityStrategy: {
          input: {
            type: "structure",
            required: [
              "GatewayARN",
              "SMBSecurityStrategy"
            ],
            members: {
              GatewayARN: {},
              SMBSecurityStrategy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayARN: {}
            }
          }
        },
        UpdateSnapshotSchedule: {
          input: {
            type: "structure",
            required: [
              "VolumeARN",
              "StartAt",
              "RecurrenceInHours"
            ],
            members: {
              VolumeARN: {},
              StartAt: {
                type: "integer"
              },
              RecurrenceInHours: {
                type: "integer"
              },
              Description: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeARN: {}
            }
          }
        },
        UpdateVTLDeviceType: {
          input: {
            type: "structure",
            required: [
              "VTLDeviceARN",
              "DeviceType"
            ],
            members: {
              VTLDeviceARN: {},
              DeviceType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VTLDeviceARN: {}
            }
          }
        }
      },
      shapes: {
        S9: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sg: {
          type: "list",
          member: {}
        },
        Sx: {
          type: "string",
          sensitive: true
        },
        S11: {
          type: "structure",
          members: {
            CacheStaleTimeoutInSeconds: {
              type: "integer"
            }
          }
        },
        S13: {
          type: "structure",
          members: {
            IpAddresses: {
              type: "list",
              member: {}
            }
          }
        },
        S1p: {
          type: "structure",
          members: {
            FileMode: {},
            DirectoryMode: {},
            GroupId: {
              type: "long"
            },
            OwnerId: {
              type: "long"
            }
          }
        },
        S1w: {
          type: "list",
          member: {}
        },
        S25: {
          type: "list",
          member: {}
        },
        S2x: {
          type: "list",
          member: {}
        },
        S3u: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "StartHourOfDay",
              "StartMinuteOfHour",
              "EndHourOfDay",
              "EndMinuteOfHour",
              "DaysOfWeek"
            ],
            members: {
              StartHourOfDay: {
                type: "integer"
              },
              StartMinuteOfHour: {
                type: "integer"
              },
              EndHourOfDay: {
                type: "integer"
              },
              EndMinuteOfHour: {
                type: "integer"
              },
              DaysOfWeek: {
                type: "list",
                member: {
                  type: "integer"
                }
              },
              AverageUploadRateLimitInBitsPerSec: {
                type: "long"
              },
              AverageDownloadRateLimitInBitsPerSec: {
                type: "long"
              }
            }
          }
        },
        S44: {
          type: "list",
          member: {}
        },
        S4d: {
          type: "structure",
          members: {
            TargetARN: {},
            NetworkInterfaceId: {},
            NetworkInterfacePort: {
              type: "integer"
            },
            LunNumber: {
              type: "integer"
            },
            ChapEnabled: {
              type: "boolean"
            }
          }
        },
        S4m: {
          type: "string",
          sensitive: true
        },
        S5h: {
          type: "list",
          member: {}
        },
        S5x: {
          type: "structure",
          members: {
            GatewayAdmins: {
              shape: "S25"
            }
          }
        },
        S7h: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "TapeBarcodePrefix",
              "PoolId",
              "TapeSizeInBytes",
              "MinimumNumTapes"
            ],
            members: {
              TapeBarcodePrefix: {},
              PoolId: {},
              TapeSizeInBytes: {
                type: "long"
              },
              MinimumNumTapes: {
                type: "integer"
              },
              Worm: {
                type: "boolean"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/storagegateway-2013-06-30.paginators.json
var require_storagegateway_2013_06_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/storagegateway-2013-06-30.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeCachediSCSIVolumes: {
          result_key: "CachediSCSIVolumes"
        },
        DescribeStorediSCSIVolumes: {
          result_key: "StorediSCSIVolumes"
        },
        DescribeTapeArchives: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "TapeArchives"
        },
        DescribeTapeRecoveryPoints: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "TapeRecoveryPointInfos"
        },
        DescribeTapes: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "Tapes"
        },
        DescribeVTLDevices: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "VTLDevices"
        },
        ListFileShares: {
          input_token: "Marker",
          limit_key: "Limit",
          non_aggregate_keys: [
            "Marker"
          ],
          output_token: "NextMarker",
          result_key: "FileShareInfoList"
        },
        ListFileSystemAssociations: {
          input_token: "Marker",
          limit_key: "Limit",
          non_aggregate_keys: [
            "Marker"
          ],
          output_token: "NextMarker",
          result_key: "FileSystemAssociationSummaryList"
        },
        ListGateways: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "Gateways"
        },
        ListLocalDisks: {
          result_key: "Disks"
        },
        ListTagsForResource: {
          input_token: "Marker",
          limit_key: "Limit",
          non_aggregate_keys: [
            "ResourceARN"
          ],
          output_token: "Marker",
          result_key: "Tags"
        },
        ListTapePools: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "PoolInfos"
        },
        ListTapes: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "TapeInfos"
        },
        ListVolumeRecoveryPoints: {
          result_key: "VolumeRecoveryPointInfos"
        },
        ListVolumes: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "VolumeInfos"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/storagegateway.js
var require_storagegateway = __commonJS({
  "node_modules/aws-sdk/clients/storagegateway.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["storagegateway"] = {};
    AWS3.StorageGateway = Service.defineService("storagegateway", ["2013-06-30"]);
    Object.defineProperty(apiLoader.services["storagegateway"], "2013-06-30", {
      get: function get() {
        var model = require_storagegateway_2013_06_30_min();
        model.paginators = require_storagegateway_2013_06_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.StorageGateway;
  }
});

// node_modules/aws-sdk/apis/states-2016-11-23.min.json
var require_states_2016_11_23_min = __commonJS({
  "node_modules/aws-sdk/apis/states-2016-11-23.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-11-23",
        endpointPrefix: "states",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "AWS SFN",
        serviceFullName: "AWS Step Functions",
        serviceId: "SFN",
        signatureVersion: "v4",
        targetPrefix: "AWSStepFunctions",
        uid: "states-2016-11-23"
      },
      operations: {
        CreateActivity: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "activityArn",
              "creationDate"
            ],
            members: {
              activityArn: {},
              creationDate: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        CreateStateMachine: {
          input: {
            type: "structure",
            required: [
              "name",
              "definition",
              "roleArn"
            ],
            members: {
              name: {},
              definition: {
                shape: "Sb"
              },
              roleArn: {},
              type: {},
              loggingConfiguration: {
                shape: "Sd"
              },
              tags: {
                shape: "S3"
              },
              tracingConfiguration: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "stateMachineArn",
              "creationDate"
            ],
            members: {
              stateMachineArn: {},
              creationDate: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DeleteActivity: {
          input: {
            type: "structure",
            required: [
              "activityArn"
            ],
            members: {
              activityArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteStateMachine: {
          input: {
            type: "structure",
            required: [
              "stateMachineArn"
            ],
            members: {
              stateMachineArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeActivity: {
          input: {
            type: "structure",
            required: [
              "activityArn"
            ],
            members: {
              activityArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "activityArn",
              "name",
              "creationDate"
            ],
            members: {
              activityArn: {},
              name: {},
              creationDate: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeExecution: {
          input: {
            type: "structure",
            required: [
              "executionArn"
            ],
            members: {
              executionArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "executionArn",
              "stateMachineArn",
              "status",
              "startDate"
            ],
            members: {
              executionArn: {},
              stateMachineArn: {},
              name: {},
              status: {},
              startDate: {
                type: "timestamp"
              },
              stopDate: {
                type: "timestamp"
              },
              input: {
                shape: "Sv"
              },
              inputDetails: {
                shape: "Sw"
              },
              output: {
                shape: "Sv"
              },
              outputDetails: {
                shape: "Sw"
              },
              traceHeader: {}
            }
          }
        },
        DescribeStateMachine: {
          input: {
            type: "structure",
            required: [
              "stateMachineArn"
            ],
            members: {
              stateMachineArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "stateMachineArn",
              "name",
              "definition",
              "roleArn",
              "type",
              "creationDate"
            ],
            members: {
              stateMachineArn: {},
              name: {},
              status: {},
              definition: {
                shape: "Sb"
              },
              roleArn: {},
              type: {},
              creationDate: {
                type: "timestamp"
              },
              loggingConfiguration: {
                shape: "Sd"
              },
              tracingConfiguration: {
                shape: "Sj"
              }
            }
          }
        },
        DescribeStateMachineForExecution: {
          input: {
            type: "structure",
            required: [
              "executionArn"
            ],
            members: {
              executionArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "stateMachineArn",
              "name",
              "definition",
              "roleArn",
              "updateDate"
            ],
            members: {
              stateMachineArn: {},
              name: {},
              definition: {
                shape: "Sb"
              },
              roleArn: {},
              updateDate: {
                type: "timestamp"
              },
              loggingConfiguration: {
                shape: "Sd"
              },
              tracingConfiguration: {
                shape: "Sj"
              }
            }
          }
        },
        GetActivityTask: {
          input: {
            type: "structure",
            required: [
              "activityArn"
            ],
            members: {
              activityArn: {},
              workerName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              taskToken: {},
              input: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        GetExecutionHistory: {
          input: {
            type: "structure",
            required: [
              "executionArn"
            ],
            members: {
              executionArn: {},
              maxResults: {
                type: "integer"
              },
              reverseOrder: {
                type: "boolean"
              },
              nextToken: {},
              includeExecutionData: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "events"
            ],
            members: {
              events: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "timestamp",
                    "type",
                    "id"
                  ],
                  members: {
                    timestamp: {
                      type: "timestamp"
                    },
                    type: {},
                    id: {
                      type: "long"
                    },
                    previousEventId: {
                      type: "long"
                    },
                    activityFailedEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1j"
                        },
                        cause: {
                          shape: "S1k"
                        }
                      }
                    },
                    activityScheduleFailedEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1j"
                        },
                        cause: {
                          shape: "S1k"
                        }
                      }
                    },
                    activityScheduledEventDetails: {
                      type: "structure",
                      required: [
                        "resource"
                      ],
                      members: {
                        resource: {},
                        input: {
                          shape: "Sv"
                        },
                        inputDetails: {
                          shape: "S1n"
                        },
                        timeoutInSeconds: {
                          type: "long"
                        },
                        heartbeatInSeconds: {
                          type: "long"
                        }
                      }
                    },
                    activityStartedEventDetails: {
                      type: "structure",
                      members: {
                        workerName: {}
                      }
                    },
                    activitySucceededEventDetails: {
                      type: "structure",
                      members: {
                        output: {
                          shape: "Sv"
                        },
                        outputDetails: {
                          shape: "S1n"
                        }
                      }
                    },
                    activityTimedOutEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1j"
                        },
                        cause: {
                          shape: "S1k"
                        }
                      }
                    },
                    taskFailedEventDetails: {
                      type: "structure",
                      required: [
                        "resourceType",
                        "resource"
                      ],
                      members: {
                        resourceType: {},
                        resource: {},
                        error: {
                          shape: "S1j"
                        },
                        cause: {
                          shape: "S1k"
                        }
                      }
                    },
                    taskScheduledEventDetails: {
                      type: "structure",
                      required: [
                        "resourceType",
                        "resource",
                        "region",
                        "parameters"
                      ],
                      members: {
                        resourceType: {},
                        resource: {},
                        region: {},
                        parameters: {
                          type: "string",
                          sensitive: true
                        },
                        timeoutInSeconds: {
                          type: "long"
                        },
                        heartbeatInSeconds: {
                          type: "long"
                        }
                      }
                    },
                    taskStartFailedEventDetails: {
                      type: "structure",
                      required: [
                        "resourceType",
                        "resource"
                      ],
                      members: {
                        resourceType: {},
                        resource: {},
                        error: {
                          shape: "S1j"
                        },
                        cause: {
                          shape: "S1k"
                        }
                      }
                    },
                    taskStartedEventDetails: {
                      type: "structure",
                      required: [
                        "resourceType",
                        "resource"
                      ],
                      members: {
                        resourceType: {},
                        resource: {}
                      }
                    },
                    taskSubmitFailedEventDetails: {
                      type: "structure",
                      required: [
                        "resourceType",
                        "resource"
                      ],
                      members: {
                        resourceType: {},
                        resource: {},
                        error: {
                          shape: "S1j"
                        },
                        cause: {
                          shape: "S1k"
                        }
                      }
                    },
                    taskSubmittedEventDetails: {
                      type: "structure",
                      required: [
                        "resourceType",
                        "resource"
                      ],
                      members: {
                        resourceType: {},
                        resource: {},
                        output: {
                          shape: "Sv"
                        },
                        outputDetails: {
                          shape: "S1n"
                        }
                      }
                    },
                    taskSucceededEventDetails: {
                      type: "structure",
                      required: [
                        "resourceType",
                        "resource"
                      ],
                      members: {
                        resourceType: {},
                        resource: {},
                        output: {
                          shape: "Sv"
                        },
                        outputDetails: {
                          shape: "S1n"
                        }
                      }
                    },
                    taskTimedOutEventDetails: {
                      type: "structure",
                      required: [
                        "resourceType",
                        "resource"
                      ],
                      members: {
                        resourceType: {},
                        resource: {},
                        error: {
                          shape: "S1j"
                        },
                        cause: {
                          shape: "S1k"
                        }
                      }
                    },
                    executionFailedEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1j"
                        },
                        cause: {
                          shape: "S1k"
                        }
                      }
                    },
                    executionStartedEventDetails: {
                      type: "structure",
                      members: {
                        input: {
                          shape: "Sv"
                        },
                        inputDetails: {
                          shape: "S1n"
                        },
                        roleArn: {}
                      }
                    },
                    executionSucceededEventDetails: {
                      type: "structure",
                      members: {
                        output: {
                          shape: "Sv"
                        },
                        outputDetails: {
                          shape: "S1n"
                        }
                      }
                    },
                    executionAbortedEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1j"
                        },
                        cause: {
                          shape: "S1k"
                        }
                      }
                    },
                    executionTimedOutEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1j"
                        },
                        cause: {
                          shape: "S1k"
                        }
                      }
                    },
                    mapStateStartedEventDetails: {
                      type: "structure",
                      members: {
                        length: {
                          type: "integer"
                        }
                      }
                    },
                    mapIterationStartedEventDetails: {
                      shape: "S2a"
                    },
                    mapIterationSucceededEventDetails: {
                      shape: "S2a"
                    },
                    mapIterationFailedEventDetails: {
                      shape: "S2a"
                    },
                    mapIterationAbortedEventDetails: {
                      shape: "S2a"
                    },
                    lambdaFunctionFailedEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1j"
                        },
                        cause: {
                          shape: "S1k"
                        }
                      }
                    },
                    lambdaFunctionScheduleFailedEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1j"
                        },
                        cause: {
                          shape: "S1k"
                        }
                      }
                    },
                    lambdaFunctionScheduledEventDetails: {
                      type: "structure",
                      required: [
                        "resource"
                      ],
                      members: {
                        resource: {},
                        input: {
                          shape: "Sv"
                        },
                        inputDetails: {
                          shape: "S1n"
                        },
                        timeoutInSeconds: {
                          type: "long"
                        }
                      }
                    },
                    lambdaFunctionStartFailedEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1j"
                        },
                        cause: {
                          shape: "S1k"
                        }
                      }
                    },
                    lambdaFunctionSucceededEventDetails: {
                      type: "structure",
                      members: {
                        output: {
                          shape: "Sv"
                        },
                        outputDetails: {
                          shape: "S1n"
                        }
                      }
                    },
                    lambdaFunctionTimedOutEventDetails: {
                      type: "structure",
                      members: {
                        error: {
                          shape: "S1j"
                        },
                        cause: {
                          shape: "S1k"
                        }
                      }
                    },
                    stateEnteredEventDetails: {
                      type: "structure",
                      required: [
                        "name"
                      ],
                      members: {
                        name: {},
                        input: {
                          shape: "Sv"
                        },
                        inputDetails: {
                          shape: "S1n"
                        }
                      }
                    },
                    stateExitedEventDetails: {
                      type: "structure",
                      required: [
                        "name"
                      ],
                      members: {
                        name: {},
                        output: {
                          shape: "Sv"
                        },
                        outputDetails: {
                          shape: "S1n"
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListActivities: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "activities"
            ],
            members: {
              activities: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "activityArn",
                    "name",
                    "creationDate"
                  ],
                  members: {
                    activityArn: {},
                    name: {},
                    creationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListExecutions: {
          input: {
            type: "structure",
            required: [
              "stateMachineArn"
            ],
            members: {
              stateMachineArn: {},
              statusFilter: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "executions"
            ],
            members: {
              executions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "executionArn",
                    "stateMachineArn",
                    "name",
                    "status",
                    "startDate"
                  ],
                  members: {
                    executionArn: {},
                    stateMachineArn: {},
                    name: {},
                    status: {},
                    startDate: {
                      type: "timestamp"
                    },
                    stopDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListStateMachines: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "stateMachines"
            ],
            members: {
              stateMachines: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "stateMachineArn",
                    "name",
                    "type",
                    "creationDate"
                  ],
                  members: {
                    stateMachineArn: {},
                    name: {},
                    type: {},
                    creationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S3"
              }
            }
          }
        },
        SendTaskFailure: {
          input: {
            type: "structure",
            required: [
              "taskToken"
            ],
            members: {
              taskToken: {},
              error: {
                shape: "S1j"
              },
              cause: {
                shape: "S1k"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SendTaskHeartbeat: {
          input: {
            type: "structure",
            required: [
              "taskToken"
            ],
            members: {
              taskToken: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SendTaskSuccess: {
          input: {
            type: "structure",
            required: [
              "taskToken",
              "output"
            ],
            members: {
              taskToken: {},
              output: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartExecution: {
          input: {
            type: "structure",
            required: [
              "stateMachineArn"
            ],
            members: {
              stateMachineArn: {},
              name: {},
              input: {
                shape: "Sv"
              },
              traceHeader: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "executionArn",
              "startDate"
            ],
            members: {
              executionArn: {},
              startDate: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        StartSyncExecution: {
          input: {
            type: "structure",
            required: [
              "stateMachineArn"
            ],
            members: {
              stateMachineArn: {},
              name: {},
              input: {
                shape: "Sv"
              },
              traceHeader: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "executionArn",
              "startDate",
              "stopDate",
              "status"
            ],
            members: {
              executionArn: {},
              stateMachineArn: {},
              name: {},
              startDate: {
                type: "timestamp"
              },
              stopDate: {
                type: "timestamp"
              },
              status: {},
              error: {
                shape: "S1j"
              },
              cause: {
                shape: "S1k"
              },
              input: {
                shape: "Sv"
              },
              inputDetails: {
                shape: "Sw"
              },
              output: {
                shape: "Sv"
              },
              outputDetails: {
                shape: "Sw"
              },
              traceHeader: {},
              billingDetails: {
                type: "structure",
                members: {
                  billedMemoryUsedInMB: {
                    type: "long"
                  },
                  billedDurationInMilliseconds: {
                    type: "long"
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "sync-"
          }
        },
        StopExecution: {
          input: {
            type: "structure",
            required: [
              "executionArn"
            ],
            members: {
              executionArn: {},
              error: {
                shape: "S1j"
              },
              cause: {
                shape: "S1k"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "stopDate"
            ],
            members: {
              stopDate: {
                type: "timestamp"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateStateMachine: {
          input: {
            type: "structure",
            required: [
              "stateMachineArn"
            ],
            members: {
              stateMachineArn: {},
              definition: {
                shape: "Sb"
              },
              roleArn: {},
              loggingConfiguration: {
                shape: "Sd"
              },
              tracingConfiguration: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "updateDate"
            ],
            members: {
              updateDate: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sb: {
          type: "string",
          sensitive: true
        },
        Sd: {
          type: "structure",
          members: {
            level: {},
            includeExecutionData: {
              type: "boolean"
            },
            destinations: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  cloudWatchLogsLogGroup: {
                    type: "structure",
                    members: {
                      logGroupArn: {}
                    }
                  }
                }
              }
            }
          }
        },
        Sj: {
          type: "structure",
          members: {
            enabled: {
              type: "boolean"
            }
          }
        },
        Sv: {
          type: "string",
          sensitive: true
        },
        Sw: {
          type: "structure",
          members: {
            included: {
              type: "boolean"
            }
          }
        },
        S1j: {
          type: "string",
          sensitive: true
        },
        S1k: {
          type: "string",
          sensitive: true
        },
        S1n: {
          type: "structure",
          members: {
            truncated: {
              type: "boolean"
            }
          }
        },
        S2a: {
          type: "structure",
          members: {
            name: {},
            index: {
              type: "integer"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/states-2016-11-23.paginators.json
var require_states_2016_11_23_paginators = __commonJS({
  "node_modules/aws-sdk/apis/states-2016-11-23.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetExecutionHistory: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "events"
        },
        ListActivities: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "activities"
        },
        ListExecutions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "executions"
        },
        ListStateMachines: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "stateMachines"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/stepfunctions.js
var require_stepfunctions = __commonJS({
  "node_modules/aws-sdk/clients/stepfunctions.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["stepfunctions"] = {};
    AWS3.StepFunctions = Service.defineService("stepfunctions", ["2016-11-23"]);
    Object.defineProperty(apiLoader.services["stepfunctions"], "2016-11-23", {
      get: function get() {
        var model = require_states_2016_11_23_min();
        model.paginators = require_states_2016_11_23_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.StepFunctions;
  }
});

// node_modules/aws-sdk/apis/support-2013-04-15.min.json
var require_support_2013_04_15_min = __commonJS({
  "node_modules/aws-sdk/apis/support-2013-04-15.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2013-04-15",
        endpointPrefix: "support",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Support",
        serviceId: "Support",
        signatureVersion: "v4",
        targetPrefix: "AWSSupport_20130415",
        uid: "support-2013-04-15"
      },
      operations: {
        AddAttachmentsToSet: {
          input: {
            type: "structure",
            required: [
              "attachments"
            ],
            members: {
              attachmentSetId: {},
              attachments: {
                type: "list",
                member: {
                  shape: "S4"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              attachmentSetId: {},
              expiryTime: {}
            }
          }
        },
        AddCommunicationToCase: {
          input: {
            type: "structure",
            required: [
              "communicationBody"
            ],
            members: {
              caseId: {},
              communicationBody: {},
              ccEmailAddresses: {
                shape: "Sc"
              },
              attachmentSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              result: {
                type: "boolean"
              }
            }
          }
        },
        CreateCase: {
          input: {
            type: "structure",
            required: [
              "subject",
              "communicationBody"
            ],
            members: {
              subject: {},
              serviceCode: {},
              severityCode: {},
              categoryCode: {},
              communicationBody: {},
              ccEmailAddresses: {
                shape: "Sc"
              },
              language: {},
              issueType: {},
              attachmentSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              caseId: {}
            }
          }
        },
        DescribeAttachment: {
          input: {
            type: "structure",
            required: [
              "attachmentId"
            ],
            members: {
              attachmentId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              attachment: {
                shape: "S4"
              }
            }
          }
        },
        DescribeCases: {
          input: {
            type: "structure",
            members: {
              caseIdList: {
                type: "list",
                member: {}
              },
              displayId: {},
              afterTime: {},
              beforeTime: {},
              includeResolvedCases: {
                type: "boolean"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              language: {},
              includeCommunications: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              cases: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    caseId: {},
                    displayId: {},
                    subject: {},
                    status: {},
                    serviceCode: {},
                    categoryCode: {},
                    severityCode: {},
                    submittedBy: {},
                    timeCreated: {},
                    recentCommunications: {
                      type: "structure",
                      members: {
                        communications: {
                          shape: "S17"
                        },
                        nextToken: {}
                      }
                    },
                    ccEmailAddresses: {
                      shape: "Sc"
                    },
                    language: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeCommunications: {
          input: {
            type: "structure",
            required: [
              "caseId"
            ],
            members: {
              caseId: {},
              beforeTime: {},
              afterTime: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              communications: {
                shape: "S17"
              },
              nextToken: {}
            }
          }
        },
        DescribeServices: {
          input: {
            type: "structure",
            members: {
              serviceCodeList: {
                type: "list",
                member: {}
              },
              language: {}
            }
          },
          output: {
            type: "structure",
            members: {
              services: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    code: {},
                    name: {},
                    categories: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          code: {},
                          name: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeSeverityLevels: {
          input: {
            type: "structure",
            members: {
              language: {}
            }
          },
          output: {
            type: "structure",
            members: {
              severityLevels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    code: {},
                    name: {}
                  }
                }
              }
            }
          }
        },
        DescribeTrustedAdvisorCheckRefreshStatuses: {
          input: {
            type: "structure",
            required: [
              "checkIds"
            ],
            members: {
              checkIds: {
                shape: "S1t"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "statuses"
            ],
            members: {
              statuses: {
                type: "list",
                member: {
                  shape: "S1x"
                }
              }
            }
          }
        },
        DescribeTrustedAdvisorCheckResult: {
          input: {
            type: "structure",
            required: [
              "checkId"
            ],
            members: {
              checkId: {},
              language: {}
            }
          },
          output: {
            type: "structure",
            members: {
              result: {
                type: "structure",
                required: [
                  "checkId",
                  "timestamp",
                  "status",
                  "resourcesSummary",
                  "categorySpecificSummary",
                  "flaggedResources"
                ],
                members: {
                  checkId: {},
                  timestamp: {},
                  status: {},
                  resourcesSummary: {
                    shape: "S22"
                  },
                  categorySpecificSummary: {
                    shape: "S23"
                  },
                  flaggedResources: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "status",
                        "resourceId",
                        "metadata"
                      ],
                      members: {
                        status: {},
                        region: {},
                        resourceId: {},
                        isSuppressed: {
                          type: "boolean"
                        },
                        metadata: {
                          shape: "S1t"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeTrustedAdvisorCheckSummaries: {
          input: {
            type: "structure",
            required: [
              "checkIds"
            ],
            members: {
              checkIds: {
                shape: "S1t"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "summaries"
            ],
            members: {
              summaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "checkId",
                    "timestamp",
                    "status",
                    "resourcesSummary",
                    "categorySpecificSummary"
                  ],
                  members: {
                    checkId: {},
                    timestamp: {},
                    status: {},
                    hasFlaggedResources: {
                      type: "boolean"
                    },
                    resourcesSummary: {
                      shape: "S22"
                    },
                    categorySpecificSummary: {
                      shape: "S23"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeTrustedAdvisorChecks: {
          input: {
            type: "structure",
            required: [
              "language"
            ],
            members: {
              language: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "checks"
            ],
            members: {
              checks: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "name",
                    "description",
                    "category",
                    "metadata"
                  ],
                  members: {
                    id: {},
                    name: {},
                    description: {},
                    category: {},
                    metadata: {
                      shape: "S1t"
                    }
                  }
                }
              }
            }
          }
        },
        RefreshTrustedAdvisorCheck: {
          input: {
            type: "structure",
            required: [
              "checkId"
            ],
            members: {
              checkId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "status"
            ],
            members: {
              status: {
                shape: "S1x"
              }
            }
          }
        },
        ResolveCase: {
          input: {
            type: "structure",
            members: {
              caseId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              initialCaseStatus: {},
              finalCaseStatus: {}
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            fileName: {},
            data: {
              type: "blob"
            }
          }
        },
        Sc: {
          type: "list",
          member: {}
        },
        S17: {
          type: "list",
          member: {
            type: "structure",
            members: {
              caseId: {},
              body: {},
              submittedBy: {},
              timeCreated: {},
              attachmentSet: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    attachmentId: {},
                    fileName: {}
                  }
                }
              }
            }
          }
        },
        S1t: {
          type: "list",
          member: {}
        },
        S1x: {
          type: "structure",
          required: [
            "checkId",
            "status",
            "millisUntilNextRefreshable"
          ],
          members: {
            checkId: {},
            status: {},
            millisUntilNextRefreshable: {
              type: "long"
            }
          }
        },
        S22: {
          type: "structure",
          required: [
            "resourcesProcessed",
            "resourcesFlagged",
            "resourcesIgnored",
            "resourcesSuppressed"
          ],
          members: {
            resourcesProcessed: {
              type: "long"
            },
            resourcesFlagged: {
              type: "long"
            },
            resourcesIgnored: {
              type: "long"
            },
            resourcesSuppressed: {
              type: "long"
            }
          }
        },
        S23: {
          type: "structure",
          members: {
            costOptimizing: {
              type: "structure",
              required: [
                "estimatedMonthlySavings",
                "estimatedPercentMonthlySavings"
              ],
              members: {
                estimatedMonthlySavings: {
                  type: "double"
                },
                estimatedPercentMonthlySavings: {
                  type: "double"
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/support-2013-04-15.paginators.json
var require_support_2013_04_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/support-2013-04-15.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeCases: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "cases"
        },
        DescribeCommunications: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "communications"
        },
        DescribeServices: {
          result_key: "services"
        },
        DescribeTrustedAdvisorCheckRefreshStatuses: {
          result_key: "statuses"
        },
        DescribeTrustedAdvisorCheckSummaries: {
          result_key: "summaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/support.js
var require_support = __commonJS({
  "node_modules/aws-sdk/clients/support.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["support"] = {};
    AWS3.Support = Service.defineService("support", ["2013-04-15"]);
    Object.defineProperty(apiLoader.services["support"], "2013-04-15", {
      get: function get() {
        var model = require_support_2013_04_15_min();
        model.paginators = require_support_2013_04_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Support;
  }
});

// node_modules/aws-sdk/lib/services/swf.js
var require_swf = __commonJS({
  "node_modules/aws-sdk/lib/services/swf.js"() {
    var AWS3 = require_core();
    AWS3.util.hideProperties(AWS3, ["SimpleWorkflow"]);
    AWS3.SimpleWorkflow = AWS3.SWF;
  }
});

// node_modules/aws-sdk/apis/swf-2012-01-25.min.json
var require_swf_2012_01_25_min = __commonJS({
  "node_modules/aws-sdk/apis/swf-2012-01-25.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2012-01-25",
        endpointPrefix: "swf",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "Amazon SWF",
        serviceFullName: "Amazon Simple Workflow Service",
        serviceId: "SWF",
        signatureVersion: "v4",
        targetPrefix: "SimpleWorkflowService",
        uid: "swf-2012-01-25"
      },
      operations: {
        CountClosedWorkflowExecutions: {
          input: {
            type: "structure",
            required: [
              "domain"
            ],
            members: {
              domain: {},
              startTimeFilter: {
                shape: "S3"
              },
              closeTimeFilter: {
                shape: "S3"
              },
              executionFilter: {
                shape: "S5"
              },
              typeFilter: {
                shape: "S7"
              },
              tagFilter: {
                shape: "Sa"
              },
              closeStatusFilter: {
                shape: "Sc"
              }
            }
          },
          output: {
            shape: "Se"
          }
        },
        CountOpenWorkflowExecutions: {
          input: {
            type: "structure",
            required: [
              "domain",
              "startTimeFilter"
            ],
            members: {
              domain: {},
              startTimeFilter: {
                shape: "S3"
              },
              typeFilter: {
                shape: "S7"
              },
              tagFilter: {
                shape: "Sa"
              },
              executionFilter: {
                shape: "S5"
              }
            }
          },
          output: {
            shape: "Se"
          }
        },
        CountPendingActivityTasks: {
          input: {
            type: "structure",
            required: [
              "domain",
              "taskList"
            ],
            members: {
              domain: {},
              taskList: {
                shape: "Sj"
              }
            }
          },
          output: {
            shape: "Sk"
          }
        },
        CountPendingDecisionTasks: {
          input: {
            type: "structure",
            required: [
              "domain",
              "taskList"
            ],
            members: {
              domain: {},
              taskList: {
                shape: "Sj"
              }
            }
          },
          output: {
            shape: "Sk"
          }
        },
        DeprecateActivityType: {
          input: {
            type: "structure",
            required: [
              "domain",
              "activityType"
            ],
            members: {
              domain: {},
              activityType: {
                shape: "Sn"
              }
            }
          }
        },
        DeprecateDomain: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          }
        },
        DeprecateWorkflowType: {
          input: {
            type: "structure",
            required: [
              "domain",
              "workflowType"
            ],
            members: {
              domain: {},
              workflowType: {
                shape: "Sr"
              }
            }
          }
        },
        DescribeActivityType: {
          input: {
            type: "structure",
            required: [
              "domain",
              "activityType"
            ],
            members: {
              domain: {},
              activityType: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "typeInfo",
              "configuration"
            ],
            members: {
              typeInfo: {
                shape: "Su"
              },
              configuration: {
                type: "structure",
                members: {
                  defaultTaskStartToCloseTimeout: {},
                  defaultTaskHeartbeatTimeout: {},
                  defaultTaskList: {
                    shape: "Sj"
                  },
                  defaultTaskPriority: {},
                  defaultTaskScheduleToStartTimeout: {},
                  defaultTaskScheduleToCloseTimeout: {}
                }
              }
            }
          }
        },
        DescribeDomain: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "domainInfo",
              "configuration"
            ],
            members: {
              domainInfo: {
                shape: "S12"
              },
              configuration: {
                type: "structure",
                required: [
                  "workflowExecutionRetentionPeriodInDays"
                ],
                members: {
                  workflowExecutionRetentionPeriodInDays: {}
                }
              }
            }
          }
        },
        DescribeWorkflowExecution: {
          input: {
            type: "structure",
            required: [
              "domain",
              "execution"
            ],
            members: {
              domain: {},
              execution: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "executionInfo",
              "executionConfiguration",
              "openCounts"
            ],
            members: {
              executionInfo: {
                shape: "S1a"
              },
              executionConfiguration: {
                type: "structure",
                required: [
                  "taskStartToCloseTimeout",
                  "executionStartToCloseTimeout",
                  "taskList",
                  "childPolicy"
                ],
                members: {
                  taskStartToCloseTimeout: {},
                  executionStartToCloseTimeout: {},
                  taskList: {
                    shape: "Sj"
                  },
                  taskPriority: {},
                  childPolicy: {},
                  lambdaRole: {}
                }
              },
              openCounts: {
                type: "structure",
                required: [
                  "openActivityTasks",
                  "openDecisionTasks",
                  "openTimers",
                  "openChildWorkflowExecutions"
                ],
                members: {
                  openActivityTasks: {
                    type: "integer"
                  },
                  openDecisionTasks: {
                    type: "integer"
                  },
                  openTimers: {
                    type: "integer"
                  },
                  openChildWorkflowExecutions: {
                    type: "integer"
                  },
                  openLambdaFunctions: {
                    type: "integer"
                  }
                }
              },
              latestActivityTaskTimestamp: {
                type: "timestamp"
              },
              latestExecutionContext: {}
            }
          }
        },
        DescribeWorkflowType: {
          input: {
            type: "structure",
            required: [
              "domain",
              "workflowType"
            ],
            members: {
              domain: {},
              workflowType: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "typeInfo",
              "configuration"
            ],
            members: {
              typeInfo: {
                shape: "S1m"
              },
              configuration: {
                type: "structure",
                members: {
                  defaultTaskStartToCloseTimeout: {},
                  defaultExecutionStartToCloseTimeout: {},
                  defaultTaskList: {
                    shape: "Sj"
                  },
                  defaultTaskPriority: {},
                  defaultChildPolicy: {},
                  defaultLambdaRole: {}
                }
              }
            }
          }
        },
        GetWorkflowExecutionHistory: {
          input: {
            type: "structure",
            required: [
              "domain",
              "execution"
            ],
            members: {
              domain: {},
              execution: {
                shape: "S17"
              },
              nextPageToken: {},
              maximumPageSize: {
                type: "integer"
              },
              reverseOrder: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "events"
            ],
            members: {
              events: {
                shape: "S1t"
              },
              nextPageToken: {}
            }
          }
        },
        ListActivityTypes: {
          input: {
            type: "structure",
            required: [
              "domain",
              "registrationStatus"
            ],
            members: {
              domain: {},
              name: {},
              registrationStatus: {},
              nextPageToken: {},
              maximumPageSize: {
                type: "integer"
              },
              reverseOrder: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "typeInfos"
            ],
            members: {
              typeInfos: {
                type: "list",
                member: {
                  shape: "Su"
                }
              },
              nextPageToken: {}
            }
          }
        },
        ListClosedWorkflowExecutions: {
          input: {
            type: "structure",
            required: [
              "domain"
            ],
            members: {
              domain: {},
              startTimeFilter: {
                shape: "S3"
              },
              closeTimeFilter: {
                shape: "S3"
              },
              executionFilter: {
                shape: "S5"
              },
              closeStatusFilter: {
                shape: "Sc"
              },
              typeFilter: {
                shape: "S7"
              },
              tagFilter: {
                shape: "Sa"
              },
              nextPageToken: {},
              maximumPageSize: {
                type: "integer"
              },
              reverseOrder: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S4g"
          }
        },
        ListDomains: {
          input: {
            type: "structure",
            required: [
              "registrationStatus"
            ],
            members: {
              nextPageToken: {},
              registrationStatus: {},
              maximumPageSize: {
                type: "integer"
              },
              reverseOrder: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainInfos"
            ],
            members: {
              domainInfos: {
                type: "list",
                member: {
                  shape: "S12"
                }
              },
              nextPageToken: {}
            }
          }
        },
        ListOpenWorkflowExecutions: {
          input: {
            type: "structure",
            required: [
              "domain",
              "startTimeFilter"
            ],
            members: {
              domain: {},
              startTimeFilter: {
                shape: "S3"
              },
              typeFilter: {
                shape: "S7"
              },
              tagFilter: {
                shape: "Sa"
              },
              nextPageToken: {},
              maximumPageSize: {
                type: "integer"
              },
              reverseOrder: {
                type: "boolean"
              },
              executionFilter: {
                shape: "S5"
              }
            }
          },
          output: {
            shape: "S4g"
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S4o"
              }
            }
          }
        },
        ListWorkflowTypes: {
          input: {
            type: "structure",
            required: [
              "domain",
              "registrationStatus"
            ],
            members: {
              domain: {},
              name: {},
              registrationStatus: {},
              nextPageToken: {},
              maximumPageSize: {
                type: "integer"
              },
              reverseOrder: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "typeInfos"
            ],
            members: {
              typeInfos: {
                type: "list",
                member: {
                  shape: "S1m"
                }
              },
              nextPageToken: {}
            }
          }
        },
        PollForActivityTask: {
          input: {
            type: "structure",
            required: [
              "domain",
              "taskList"
            ],
            members: {
              domain: {},
              taskList: {
                shape: "Sj"
              },
              identity: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "taskToken",
              "activityId",
              "startedEventId",
              "workflowExecution",
              "activityType"
            ],
            members: {
              taskToken: {},
              activityId: {},
              startedEventId: {
                type: "long"
              },
              workflowExecution: {
                shape: "S17"
              },
              activityType: {
                shape: "Sn"
              },
              input: {}
            }
          }
        },
        PollForDecisionTask: {
          input: {
            type: "structure",
            required: [
              "domain",
              "taskList"
            ],
            members: {
              domain: {},
              taskList: {
                shape: "Sj"
              },
              identity: {},
              nextPageToken: {},
              maximumPageSize: {
                type: "integer"
              },
              reverseOrder: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "taskToken",
              "startedEventId",
              "workflowExecution",
              "workflowType",
              "events"
            ],
            members: {
              taskToken: {},
              startedEventId: {
                type: "long"
              },
              workflowExecution: {
                shape: "S17"
              },
              workflowType: {
                shape: "Sr"
              },
              events: {
                shape: "S1t"
              },
              nextPageToken: {},
              previousStartedEventId: {
                type: "long"
              }
            }
          }
        },
        RecordActivityTaskHeartbeat: {
          input: {
            type: "structure",
            required: [
              "taskToken"
            ],
            members: {
              taskToken: {},
              details: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "cancelRequested"
            ],
            members: {
              cancelRequested: {
                type: "boolean"
              }
            }
          }
        },
        RegisterActivityType: {
          input: {
            type: "structure",
            required: [
              "domain",
              "name",
              "version"
            ],
            members: {
              domain: {},
              name: {},
              version: {},
              description: {},
              defaultTaskStartToCloseTimeout: {},
              defaultTaskHeartbeatTimeout: {},
              defaultTaskList: {
                shape: "Sj"
              },
              defaultTaskPriority: {},
              defaultTaskScheduleToStartTimeout: {},
              defaultTaskScheduleToCloseTimeout: {}
            }
          }
        },
        RegisterDomain: {
          input: {
            type: "structure",
            required: [
              "name",
              "workflowExecutionRetentionPeriodInDays"
            ],
            members: {
              name: {},
              description: {},
              workflowExecutionRetentionPeriodInDays: {},
              tags: {
                shape: "S4o"
              }
            }
          }
        },
        RegisterWorkflowType: {
          input: {
            type: "structure",
            required: [
              "domain",
              "name",
              "version"
            ],
            members: {
              domain: {},
              name: {},
              version: {},
              description: {},
              defaultTaskStartToCloseTimeout: {},
              defaultExecutionStartToCloseTimeout: {},
              defaultTaskList: {
                shape: "Sj"
              },
              defaultTaskPriority: {},
              defaultChildPolicy: {},
              defaultLambdaRole: {}
            }
          }
        },
        RequestCancelWorkflowExecution: {
          input: {
            type: "structure",
            required: [
              "domain",
              "workflowId"
            ],
            members: {
              domain: {},
              workflowId: {},
              runId: {}
            }
          }
        },
        RespondActivityTaskCanceled: {
          input: {
            type: "structure",
            required: [
              "taskToken"
            ],
            members: {
              taskToken: {},
              details: {}
            }
          }
        },
        RespondActivityTaskCompleted: {
          input: {
            type: "structure",
            required: [
              "taskToken"
            ],
            members: {
              taskToken: {},
              result: {}
            }
          }
        },
        RespondActivityTaskFailed: {
          input: {
            type: "structure",
            required: [
              "taskToken"
            ],
            members: {
              taskToken: {},
              reason: {},
              details: {}
            }
          }
        },
        RespondDecisionTaskCompleted: {
          input: {
            type: "structure",
            required: [
              "taskToken"
            ],
            members: {
              taskToken: {},
              decisions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "decisionType"
                  ],
                  members: {
                    decisionType: {},
                    scheduleActivityTaskDecisionAttributes: {
                      type: "structure",
                      required: [
                        "activityType",
                        "activityId"
                      ],
                      members: {
                        activityType: {
                          shape: "Sn"
                        },
                        activityId: {},
                        control: {},
                        input: {},
                        scheduleToCloseTimeout: {},
                        taskList: {
                          shape: "Sj"
                        },
                        taskPriority: {},
                        scheduleToStartTimeout: {},
                        startToCloseTimeout: {},
                        heartbeatTimeout: {}
                      }
                    },
                    requestCancelActivityTaskDecisionAttributes: {
                      type: "structure",
                      required: [
                        "activityId"
                      ],
                      members: {
                        activityId: {}
                      }
                    },
                    completeWorkflowExecutionDecisionAttributes: {
                      type: "structure",
                      members: {
                        result: {}
                      }
                    },
                    failWorkflowExecutionDecisionAttributes: {
                      type: "structure",
                      members: {
                        reason: {},
                        details: {}
                      }
                    },
                    cancelWorkflowExecutionDecisionAttributes: {
                      type: "structure",
                      members: {
                        details: {}
                      }
                    },
                    continueAsNewWorkflowExecutionDecisionAttributes: {
                      type: "structure",
                      members: {
                        input: {},
                        executionStartToCloseTimeout: {},
                        taskList: {
                          shape: "Sj"
                        },
                        taskPriority: {},
                        taskStartToCloseTimeout: {},
                        childPolicy: {},
                        tagList: {
                          shape: "S1c"
                        },
                        workflowTypeVersion: {},
                        lambdaRole: {}
                      }
                    },
                    recordMarkerDecisionAttributes: {
                      type: "structure",
                      required: [
                        "markerName"
                      ],
                      members: {
                        markerName: {},
                        details: {}
                      }
                    },
                    startTimerDecisionAttributes: {
                      type: "structure",
                      required: [
                        "timerId",
                        "startToFireTimeout"
                      ],
                      members: {
                        timerId: {},
                        control: {},
                        startToFireTimeout: {}
                      }
                    },
                    cancelTimerDecisionAttributes: {
                      type: "structure",
                      required: [
                        "timerId"
                      ],
                      members: {
                        timerId: {}
                      }
                    },
                    signalExternalWorkflowExecutionDecisionAttributes: {
                      type: "structure",
                      required: [
                        "workflowId",
                        "signalName"
                      ],
                      members: {
                        workflowId: {},
                        runId: {},
                        signalName: {},
                        input: {},
                        control: {}
                      }
                    },
                    requestCancelExternalWorkflowExecutionDecisionAttributes: {
                      type: "structure",
                      required: [
                        "workflowId"
                      ],
                      members: {
                        workflowId: {},
                        runId: {},
                        control: {}
                      }
                    },
                    startChildWorkflowExecutionDecisionAttributes: {
                      type: "structure",
                      required: [
                        "workflowType",
                        "workflowId"
                      ],
                      members: {
                        workflowType: {
                          shape: "Sr"
                        },
                        workflowId: {},
                        control: {},
                        input: {},
                        executionStartToCloseTimeout: {},
                        taskList: {
                          shape: "Sj"
                        },
                        taskPriority: {},
                        taskStartToCloseTimeout: {},
                        childPolicy: {},
                        tagList: {
                          shape: "S1c"
                        },
                        lambdaRole: {}
                      }
                    },
                    scheduleLambdaFunctionDecisionAttributes: {
                      type: "structure",
                      required: [
                        "id",
                        "name"
                      ],
                      members: {
                        id: {},
                        name: {},
                        control: {},
                        input: {},
                        startToCloseTimeout: {}
                      }
                    }
                  }
                }
              },
              executionContext: {}
            }
          }
        },
        SignalWorkflowExecution: {
          input: {
            type: "structure",
            required: [
              "domain",
              "workflowId",
              "signalName"
            ],
            members: {
              domain: {},
              workflowId: {},
              runId: {},
              signalName: {},
              input: {}
            }
          }
        },
        StartWorkflowExecution: {
          input: {
            type: "structure",
            required: [
              "domain",
              "workflowId",
              "workflowType"
            ],
            members: {
              domain: {},
              workflowId: {},
              workflowType: {
                shape: "Sr"
              },
              taskList: {
                shape: "Sj"
              },
              taskPriority: {},
              input: {},
              executionStartToCloseTimeout: {},
              tagList: {
                shape: "S1c"
              },
              taskStartToCloseTimeout: {},
              childPolicy: {},
              lambdaRole: {}
            }
          },
          output: {
            type: "structure",
            members: {
              runId: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S4o"
              }
            }
          }
        },
        TerminateWorkflowExecution: {
          input: {
            type: "structure",
            required: [
              "domain",
              "workflowId"
            ],
            members: {
              domain: {},
              workflowId: {},
              runId: {},
              reason: {},
              details: {},
              childPolicy: {}
            }
          }
        },
        UndeprecateActivityType: {
          input: {
            type: "structure",
            required: [
              "domain",
              "activityType"
            ],
            members: {
              domain: {},
              activityType: {
                shape: "Sn"
              }
            }
          }
        },
        UndeprecateDomain: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          }
        },
        UndeprecateWorkflowType: {
          input: {
            type: "structure",
            required: [
              "domain",
              "workflowType"
            ],
            members: {
              domain: {},
              workflowType: {
                shape: "Sr"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          required: [
            "oldestDate"
          ],
          members: {
            oldestDate: {
              type: "timestamp"
            },
            latestDate: {
              type: "timestamp"
            }
          }
        },
        S5: {
          type: "structure",
          required: [
            "workflowId"
          ],
          members: {
            workflowId: {}
          }
        },
        S7: {
          type: "structure",
          required: [
            "name"
          ],
          members: {
            name: {},
            version: {}
          }
        },
        Sa: {
          type: "structure",
          required: [
            "tag"
          ],
          members: {
            tag: {}
          }
        },
        Sc: {
          type: "structure",
          required: [
            "status"
          ],
          members: {
            status: {}
          }
        },
        Se: {
          type: "structure",
          required: [
            "count"
          ],
          members: {
            count: {
              type: "integer"
            },
            truncated: {
              type: "boolean"
            }
          }
        },
        Sj: {
          type: "structure",
          required: [
            "name"
          ],
          members: {
            name: {}
          }
        },
        Sk: {
          type: "structure",
          required: [
            "count"
          ],
          members: {
            count: {
              type: "integer"
            },
            truncated: {
              type: "boolean"
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "name",
            "version"
          ],
          members: {
            name: {},
            version: {}
          }
        },
        Sr: {
          type: "structure",
          required: [
            "name",
            "version"
          ],
          members: {
            name: {},
            version: {}
          }
        },
        Su: {
          type: "structure",
          required: [
            "activityType",
            "status",
            "creationDate"
          ],
          members: {
            activityType: {
              shape: "Sn"
            },
            status: {},
            description: {},
            creationDate: {
              type: "timestamp"
            },
            deprecationDate: {
              type: "timestamp"
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "name",
            "status"
          ],
          members: {
            name: {},
            status: {},
            description: {},
            arn: {}
          }
        },
        S17: {
          type: "structure",
          required: [
            "workflowId",
            "runId"
          ],
          members: {
            workflowId: {},
            runId: {}
          }
        },
        S1a: {
          type: "structure",
          required: [
            "execution",
            "workflowType",
            "startTimestamp",
            "executionStatus"
          ],
          members: {
            execution: {
              shape: "S17"
            },
            workflowType: {
              shape: "Sr"
            },
            startTimestamp: {
              type: "timestamp"
            },
            closeTimestamp: {
              type: "timestamp"
            },
            executionStatus: {},
            closeStatus: {},
            parent: {
              shape: "S17"
            },
            tagList: {
              shape: "S1c"
            },
            cancelRequested: {
              type: "boolean"
            }
          }
        },
        S1c: {
          type: "list",
          member: {}
        },
        S1m: {
          type: "structure",
          required: [
            "workflowType",
            "status",
            "creationDate"
          ],
          members: {
            workflowType: {
              shape: "Sr"
            },
            status: {},
            description: {},
            creationDate: {
              type: "timestamp"
            },
            deprecationDate: {
              type: "timestamp"
            }
          }
        },
        S1t: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "eventTimestamp",
              "eventType",
              "eventId"
            ],
            members: {
              eventTimestamp: {
                type: "timestamp"
              },
              eventType: {},
              eventId: {
                type: "long"
              },
              workflowExecutionStartedEventAttributes: {
                type: "structure",
                required: [
                  "childPolicy",
                  "taskList",
                  "workflowType"
                ],
                members: {
                  input: {},
                  executionStartToCloseTimeout: {},
                  taskStartToCloseTimeout: {},
                  childPolicy: {},
                  taskList: {
                    shape: "Sj"
                  },
                  taskPriority: {},
                  workflowType: {
                    shape: "Sr"
                  },
                  tagList: {
                    shape: "S1c"
                  },
                  continuedExecutionRunId: {},
                  parentWorkflowExecution: {
                    shape: "S17"
                  },
                  parentInitiatedEventId: {
                    type: "long"
                  },
                  lambdaRole: {}
                }
              },
              workflowExecutionCompletedEventAttributes: {
                type: "structure",
                required: [
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  result: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              completeWorkflowExecutionFailedEventAttributes: {
                type: "structure",
                required: [
                  "cause",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  cause: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              workflowExecutionFailedEventAttributes: {
                type: "structure",
                required: [
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  reason: {},
                  details: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              failWorkflowExecutionFailedEventAttributes: {
                type: "structure",
                required: [
                  "cause",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  cause: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              workflowExecutionTimedOutEventAttributes: {
                type: "structure",
                required: [
                  "timeoutType",
                  "childPolicy"
                ],
                members: {
                  timeoutType: {},
                  childPolicy: {}
                }
              },
              workflowExecutionCanceledEventAttributes: {
                type: "structure",
                required: [
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  details: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              cancelWorkflowExecutionFailedEventAttributes: {
                type: "structure",
                required: [
                  "cause",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  cause: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              workflowExecutionContinuedAsNewEventAttributes: {
                type: "structure",
                required: [
                  "decisionTaskCompletedEventId",
                  "newExecutionRunId",
                  "taskList",
                  "childPolicy",
                  "workflowType"
                ],
                members: {
                  input: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  },
                  newExecutionRunId: {},
                  executionStartToCloseTimeout: {},
                  taskList: {
                    shape: "Sj"
                  },
                  taskPriority: {},
                  taskStartToCloseTimeout: {},
                  childPolicy: {},
                  tagList: {
                    shape: "S1c"
                  },
                  workflowType: {
                    shape: "Sr"
                  },
                  lambdaRole: {}
                }
              },
              continueAsNewWorkflowExecutionFailedEventAttributes: {
                type: "structure",
                required: [
                  "cause",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  cause: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              workflowExecutionTerminatedEventAttributes: {
                type: "structure",
                required: [
                  "childPolicy"
                ],
                members: {
                  reason: {},
                  details: {},
                  childPolicy: {},
                  cause: {}
                }
              },
              workflowExecutionCancelRequestedEventAttributes: {
                type: "structure",
                members: {
                  externalWorkflowExecution: {
                    shape: "S17"
                  },
                  externalInitiatedEventId: {
                    type: "long"
                  },
                  cause: {}
                }
              },
              decisionTaskScheduledEventAttributes: {
                type: "structure",
                required: [
                  "taskList"
                ],
                members: {
                  taskList: {
                    shape: "Sj"
                  },
                  taskPriority: {},
                  startToCloseTimeout: {}
                }
              },
              decisionTaskStartedEventAttributes: {
                type: "structure",
                required: [
                  "scheduledEventId"
                ],
                members: {
                  identity: {},
                  scheduledEventId: {
                    type: "long"
                  }
                }
              },
              decisionTaskCompletedEventAttributes: {
                type: "structure",
                required: [
                  "scheduledEventId",
                  "startedEventId"
                ],
                members: {
                  executionContext: {},
                  scheduledEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  }
                }
              },
              decisionTaskTimedOutEventAttributes: {
                type: "structure",
                required: [
                  "timeoutType",
                  "scheduledEventId",
                  "startedEventId"
                ],
                members: {
                  timeoutType: {},
                  scheduledEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  }
                }
              },
              activityTaskScheduledEventAttributes: {
                type: "structure",
                required: [
                  "activityType",
                  "activityId",
                  "taskList",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  activityType: {
                    shape: "Sn"
                  },
                  activityId: {},
                  input: {},
                  control: {},
                  scheduleToStartTimeout: {},
                  scheduleToCloseTimeout: {},
                  startToCloseTimeout: {},
                  taskList: {
                    shape: "Sj"
                  },
                  taskPriority: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  },
                  heartbeatTimeout: {}
                }
              },
              activityTaskStartedEventAttributes: {
                type: "structure",
                required: [
                  "scheduledEventId"
                ],
                members: {
                  identity: {},
                  scheduledEventId: {
                    type: "long"
                  }
                }
              },
              activityTaskCompletedEventAttributes: {
                type: "structure",
                required: [
                  "scheduledEventId",
                  "startedEventId"
                ],
                members: {
                  result: {},
                  scheduledEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  }
                }
              },
              activityTaskFailedEventAttributes: {
                type: "structure",
                required: [
                  "scheduledEventId",
                  "startedEventId"
                ],
                members: {
                  reason: {},
                  details: {},
                  scheduledEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  }
                }
              },
              activityTaskTimedOutEventAttributes: {
                type: "structure",
                required: [
                  "timeoutType",
                  "scheduledEventId",
                  "startedEventId"
                ],
                members: {
                  timeoutType: {},
                  scheduledEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  },
                  details: {}
                }
              },
              activityTaskCanceledEventAttributes: {
                type: "structure",
                required: [
                  "scheduledEventId",
                  "startedEventId"
                ],
                members: {
                  details: {},
                  scheduledEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  },
                  latestCancelRequestedEventId: {
                    type: "long"
                  }
                }
              },
              activityTaskCancelRequestedEventAttributes: {
                type: "structure",
                required: [
                  "decisionTaskCompletedEventId",
                  "activityId"
                ],
                members: {
                  decisionTaskCompletedEventId: {
                    type: "long"
                  },
                  activityId: {}
                }
              },
              workflowExecutionSignaledEventAttributes: {
                type: "structure",
                required: [
                  "signalName"
                ],
                members: {
                  signalName: {},
                  input: {},
                  externalWorkflowExecution: {
                    shape: "S17"
                  },
                  externalInitiatedEventId: {
                    type: "long"
                  }
                }
              },
              markerRecordedEventAttributes: {
                type: "structure",
                required: [
                  "markerName",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  markerName: {},
                  details: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              recordMarkerFailedEventAttributes: {
                type: "structure",
                required: [
                  "markerName",
                  "cause",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  markerName: {},
                  cause: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              timerStartedEventAttributes: {
                type: "structure",
                required: [
                  "timerId",
                  "startToFireTimeout",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  timerId: {},
                  control: {},
                  startToFireTimeout: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              timerFiredEventAttributes: {
                type: "structure",
                required: [
                  "timerId",
                  "startedEventId"
                ],
                members: {
                  timerId: {},
                  startedEventId: {
                    type: "long"
                  }
                }
              },
              timerCanceledEventAttributes: {
                type: "structure",
                required: [
                  "timerId",
                  "startedEventId",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  timerId: {},
                  startedEventId: {
                    type: "long"
                  },
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              startChildWorkflowExecutionInitiatedEventAttributes: {
                type: "structure",
                required: [
                  "workflowId",
                  "workflowType",
                  "taskList",
                  "decisionTaskCompletedEventId",
                  "childPolicy"
                ],
                members: {
                  workflowId: {},
                  workflowType: {
                    shape: "Sr"
                  },
                  control: {},
                  input: {},
                  executionStartToCloseTimeout: {},
                  taskList: {
                    shape: "Sj"
                  },
                  taskPriority: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  },
                  childPolicy: {},
                  taskStartToCloseTimeout: {},
                  tagList: {
                    shape: "S1c"
                  },
                  lambdaRole: {}
                }
              },
              childWorkflowExecutionStartedEventAttributes: {
                type: "structure",
                required: [
                  "workflowExecution",
                  "workflowType",
                  "initiatedEventId"
                ],
                members: {
                  workflowExecution: {
                    shape: "S17"
                  },
                  workflowType: {
                    shape: "Sr"
                  },
                  initiatedEventId: {
                    type: "long"
                  }
                }
              },
              childWorkflowExecutionCompletedEventAttributes: {
                type: "structure",
                required: [
                  "workflowExecution",
                  "workflowType",
                  "initiatedEventId",
                  "startedEventId"
                ],
                members: {
                  workflowExecution: {
                    shape: "S17"
                  },
                  workflowType: {
                    shape: "Sr"
                  },
                  result: {},
                  initiatedEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  }
                }
              },
              childWorkflowExecutionFailedEventAttributes: {
                type: "structure",
                required: [
                  "workflowExecution",
                  "workflowType",
                  "initiatedEventId",
                  "startedEventId"
                ],
                members: {
                  workflowExecution: {
                    shape: "S17"
                  },
                  workflowType: {
                    shape: "Sr"
                  },
                  reason: {},
                  details: {},
                  initiatedEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  }
                }
              },
              childWorkflowExecutionTimedOutEventAttributes: {
                type: "structure",
                required: [
                  "workflowExecution",
                  "workflowType",
                  "timeoutType",
                  "initiatedEventId",
                  "startedEventId"
                ],
                members: {
                  workflowExecution: {
                    shape: "S17"
                  },
                  workflowType: {
                    shape: "Sr"
                  },
                  timeoutType: {},
                  initiatedEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  }
                }
              },
              childWorkflowExecutionCanceledEventAttributes: {
                type: "structure",
                required: [
                  "workflowExecution",
                  "workflowType",
                  "initiatedEventId",
                  "startedEventId"
                ],
                members: {
                  workflowExecution: {
                    shape: "S17"
                  },
                  workflowType: {
                    shape: "Sr"
                  },
                  details: {},
                  initiatedEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  }
                }
              },
              childWorkflowExecutionTerminatedEventAttributes: {
                type: "structure",
                required: [
                  "workflowExecution",
                  "workflowType",
                  "initiatedEventId",
                  "startedEventId"
                ],
                members: {
                  workflowExecution: {
                    shape: "S17"
                  },
                  workflowType: {
                    shape: "Sr"
                  },
                  initiatedEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  }
                }
              },
              signalExternalWorkflowExecutionInitiatedEventAttributes: {
                type: "structure",
                required: [
                  "workflowId",
                  "signalName",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  workflowId: {},
                  runId: {},
                  signalName: {},
                  input: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  },
                  control: {}
                }
              },
              externalWorkflowExecutionSignaledEventAttributes: {
                type: "structure",
                required: [
                  "workflowExecution",
                  "initiatedEventId"
                ],
                members: {
                  workflowExecution: {
                    shape: "S17"
                  },
                  initiatedEventId: {
                    type: "long"
                  }
                }
              },
              signalExternalWorkflowExecutionFailedEventAttributes: {
                type: "structure",
                required: [
                  "workflowId",
                  "cause",
                  "initiatedEventId",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  workflowId: {},
                  runId: {},
                  cause: {},
                  initiatedEventId: {
                    type: "long"
                  },
                  decisionTaskCompletedEventId: {
                    type: "long"
                  },
                  control: {}
                }
              },
              externalWorkflowExecutionCancelRequestedEventAttributes: {
                type: "structure",
                required: [
                  "workflowExecution",
                  "initiatedEventId"
                ],
                members: {
                  workflowExecution: {
                    shape: "S17"
                  },
                  initiatedEventId: {
                    type: "long"
                  }
                }
              },
              requestCancelExternalWorkflowExecutionInitiatedEventAttributes: {
                type: "structure",
                required: [
                  "workflowId",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  workflowId: {},
                  runId: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  },
                  control: {}
                }
              },
              requestCancelExternalWorkflowExecutionFailedEventAttributes: {
                type: "structure",
                required: [
                  "workflowId",
                  "cause",
                  "initiatedEventId",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  workflowId: {},
                  runId: {},
                  cause: {},
                  initiatedEventId: {
                    type: "long"
                  },
                  decisionTaskCompletedEventId: {
                    type: "long"
                  },
                  control: {}
                }
              },
              scheduleActivityTaskFailedEventAttributes: {
                type: "structure",
                required: [
                  "activityType",
                  "activityId",
                  "cause",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  activityType: {
                    shape: "Sn"
                  },
                  activityId: {},
                  cause: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              requestCancelActivityTaskFailedEventAttributes: {
                type: "structure",
                required: [
                  "activityId",
                  "cause",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  activityId: {},
                  cause: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              startTimerFailedEventAttributes: {
                type: "structure",
                required: [
                  "timerId",
                  "cause",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  timerId: {},
                  cause: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              cancelTimerFailedEventAttributes: {
                type: "structure",
                required: [
                  "timerId",
                  "cause",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  timerId: {},
                  cause: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              startChildWorkflowExecutionFailedEventAttributes: {
                type: "structure",
                required: [
                  "workflowType",
                  "cause",
                  "workflowId",
                  "initiatedEventId",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  workflowType: {
                    shape: "Sr"
                  },
                  cause: {},
                  workflowId: {},
                  initiatedEventId: {
                    type: "long"
                  },
                  decisionTaskCompletedEventId: {
                    type: "long"
                  },
                  control: {}
                }
              },
              lambdaFunctionScheduledEventAttributes: {
                type: "structure",
                required: [
                  "id",
                  "name",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  id: {},
                  name: {},
                  control: {},
                  input: {},
                  startToCloseTimeout: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              lambdaFunctionStartedEventAttributes: {
                type: "structure",
                required: [
                  "scheduledEventId"
                ],
                members: {
                  scheduledEventId: {
                    type: "long"
                  }
                }
              },
              lambdaFunctionCompletedEventAttributes: {
                type: "structure",
                required: [
                  "scheduledEventId",
                  "startedEventId"
                ],
                members: {
                  scheduledEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  },
                  result: {}
                }
              },
              lambdaFunctionFailedEventAttributes: {
                type: "structure",
                required: [
                  "scheduledEventId",
                  "startedEventId"
                ],
                members: {
                  scheduledEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  },
                  reason: {},
                  details: {}
                }
              },
              lambdaFunctionTimedOutEventAttributes: {
                type: "structure",
                required: [
                  "scheduledEventId",
                  "startedEventId"
                ],
                members: {
                  scheduledEventId: {
                    type: "long"
                  },
                  startedEventId: {
                    type: "long"
                  },
                  timeoutType: {}
                }
              },
              scheduleLambdaFunctionFailedEventAttributes: {
                type: "structure",
                required: [
                  "id",
                  "name",
                  "cause",
                  "decisionTaskCompletedEventId"
                ],
                members: {
                  id: {},
                  name: {},
                  cause: {},
                  decisionTaskCompletedEventId: {
                    type: "long"
                  }
                }
              },
              startLambdaFunctionFailedEventAttributes: {
                type: "structure",
                members: {
                  scheduledEventId: {
                    type: "long"
                  },
                  cause: {},
                  message: {}
                }
              }
            }
          }
        },
        S4g: {
          type: "structure",
          required: [
            "executionInfos"
          ],
          members: {
            executionInfos: {
              type: "list",
              member: {
                shape: "S1a"
              }
            },
            nextPageToken: {}
          }
        },
        S4o: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/swf-2012-01-25.paginators.json
var require_swf_2012_01_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/swf-2012-01-25.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetWorkflowExecutionHistory: {
          input_token: "nextPageToken",
          limit_key: "maximumPageSize",
          output_token: "nextPageToken",
          result_key: "events"
        },
        ListActivityTypes: {
          input_token: "nextPageToken",
          limit_key: "maximumPageSize",
          output_token: "nextPageToken",
          result_key: "typeInfos"
        },
        ListClosedWorkflowExecutions: {
          input_token: "nextPageToken",
          limit_key: "maximumPageSize",
          output_token: "nextPageToken",
          result_key: "executionInfos"
        },
        ListDomains: {
          input_token: "nextPageToken",
          limit_key: "maximumPageSize",
          output_token: "nextPageToken",
          result_key: "domainInfos"
        },
        ListOpenWorkflowExecutions: {
          input_token: "nextPageToken",
          limit_key: "maximumPageSize",
          output_token: "nextPageToken",
          result_key: "executionInfos"
        },
        ListWorkflowTypes: {
          input_token: "nextPageToken",
          limit_key: "maximumPageSize",
          output_token: "nextPageToken",
          result_key: "typeInfos"
        },
        PollForDecisionTask: {
          input_token: "nextPageToken",
          limit_key: "maximumPageSize",
          output_token: "nextPageToken",
          result_key: "events"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/swf.js
var require_swf2 = __commonJS({
  "node_modules/aws-sdk/clients/swf.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["swf"] = {};
    AWS3.SWF = Service.defineService("swf", ["2012-01-25"]);
    require_swf();
    Object.defineProperty(apiLoader.services["swf"], "2012-01-25", {
      get: function get() {
        var model = require_swf_2012_01_25_min();
        model.paginators = require_swf_2012_01_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SWF;
  }
});

// node_modules/aws-sdk/apis/xray-2016-04-12.min.json
var require_xray_2016_04_12_min = __commonJS({
  "node_modules/aws-sdk/apis/xray-2016-04-12.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-04-12",
        endpointPrefix: "xray",
        protocol: "rest-json",
        serviceFullName: "AWS X-Ray",
        serviceId: "XRay",
        signatureVersion: "v4",
        uid: "xray-2016-04-12"
      },
      operations: {
        BatchGetTraces: {
          http: {
            requestUri: "/Traces"
          },
          input: {
            type: "structure",
            required: [
              "TraceIds"
            ],
            members: {
              TraceIds: {
                shape: "S2"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Traces: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Duration: {
                      type: "double"
                    },
                    LimitExceeded: {
                      type: "boolean"
                    },
                    Segments: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Id: {},
                          Document: {}
                        }
                      }
                    }
                  }
                }
              },
              UnprocessedTraceIds: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        CreateGroup: {
          http: {
            requestUri: "/CreateGroup"
          },
          input: {
            type: "structure",
            required: [
              "GroupName"
            ],
            members: {
              GroupName: {},
              FilterExpression: {},
              InsightsConfiguration: {
                shape: "Si"
              },
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "So"
              }
            }
          }
        },
        CreateSamplingRule: {
          http: {
            requestUri: "/CreateSamplingRule"
          },
          input: {
            type: "structure",
            required: [
              "SamplingRule"
            ],
            members: {
              SamplingRule: {
                shape: "Sq"
              },
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SamplingRuleRecord: {
                shape: "S16"
              }
            }
          }
        },
        DeleteGroup: {
          http: {
            requestUri: "/DeleteGroup"
          },
          input: {
            type: "structure",
            members: {
              GroupName: {},
              GroupARN: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSamplingRule: {
          http: {
            requestUri: "/DeleteSamplingRule"
          },
          input: {
            type: "structure",
            members: {
              RuleName: {},
              RuleARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SamplingRuleRecord: {
                shape: "S16"
              }
            }
          }
        },
        GetEncryptionConfig: {
          http: {
            requestUri: "/EncryptionConfig"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              EncryptionConfig: {
                shape: "S1f"
              }
            }
          }
        },
        GetGroup: {
          http: {
            requestUri: "/GetGroup"
          },
          input: {
            type: "structure",
            members: {
              GroupName: {},
              GroupARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "So"
              }
            }
          }
        },
        GetGroups: {
          http: {
            requestUri: "/Groups"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Groups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GroupName: {},
                    GroupARN: {},
                    FilterExpression: {},
                    InsightsConfiguration: {
                      shape: "Si"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetInsight: {
          http: {
            requestUri: "/Insight"
          },
          input: {
            type: "structure",
            required: [
              "InsightId"
            ],
            members: {
              InsightId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Insight: {
                type: "structure",
                members: {
                  InsightId: {},
                  GroupARN: {},
                  GroupName: {},
                  RootCauseServiceId: {
                    shape: "S1t"
                  },
                  Categories: {
                    shape: "S1v"
                  },
                  State: {},
                  StartTime: {
                    type: "timestamp"
                  },
                  EndTime: {
                    type: "timestamp"
                  },
                  Summary: {},
                  ClientRequestImpactStatistics: {
                    shape: "S1z"
                  },
                  RootCauseServiceRequestImpactStatistics: {
                    shape: "S1z"
                  },
                  TopAnomalousServices: {
                    shape: "S21"
                  }
                }
              }
            }
          }
        },
        GetInsightEvents: {
          http: {
            requestUri: "/InsightEvents"
          },
          input: {
            type: "structure",
            required: [
              "InsightId"
            ],
            members: {
              InsightId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InsightEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Summary: {},
                    EventTime: {
                      type: "timestamp"
                    },
                    ClientRequestImpactStatistics: {
                      shape: "S1z"
                    },
                    RootCauseServiceRequestImpactStatistics: {
                      shape: "S1z"
                    },
                    TopAnomalousServices: {
                      shape: "S21"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetInsightImpactGraph: {
          http: {
            requestUri: "/InsightImpactGraph"
          },
          input: {
            type: "structure",
            required: [
              "InsightId",
              "StartTime",
              "EndTime"
            ],
            members: {
              InsightId: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InsightId: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              ServiceGraphStartTime: {
                type: "timestamp"
              },
              ServiceGraphEndTime: {
                type: "timestamp"
              },
              Services: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReferenceId: {
                      type: "integer"
                    },
                    Type: {},
                    Name: {},
                    Names: {
                      shape: "S1u"
                    },
                    AccountId: {},
                    Edges: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ReferenceId: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetInsightSummaries: {
          http: {
            requestUri: "/InsightSummaries"
          },
          input: {
            type: "structure",
            required: [
              "StartTime",
              "EndTime"
            ],
            members: {
              States: {
                type: "list",
                member: {}
              },
              GroupARN: {},
              GroupName: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InsightSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InsightId: {},
                    GroupARN: {},
                    GroupName: {},
                    RootCauseServiceId: {
                      shape: "S1t"
                    },
                    Categories: {
                      shape: "S1v"
                    },
                    State: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    Summary: {},
                    ClientRequestImpactStatistics: {
                      shape: "S1z"
                    },
                    RootCauseServiceRequestImpactStatistics: {
                      shape: "S1z"
                    },
                    TopAnomalousServices: {
                      shape: "S21"
                    },
                    LastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetSamplingRules: {
          http: {
            requestUri: "/GetSamplingRules"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SamplingRuleRecords: {
                type: "list",
                member: {
                  shape: "S16"
                }
              },
              NextToken: {}
            }
          }
        },
        GetSamplingStatisticSummaries: {
          http: {
            requestUri: "/SamplingStatisticSummaries"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SamplingStatisticSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RuleName: {},
                    Timestamp: {
                      type: "timestamp"
                    },
                    RequestCount: {
                      type: "integer"
                    },
                    BorrowCount: {
                      type: "integer"
                    },
                    SampledCount: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetSamplingTargets: {
          http: {
            requestUri: "/SamplingTargets"
          },
          input: {
            type: "structure",
            required: [
              "SamplingStatisticsDocuments"
            ],
            members: {
              SamplingStatisticsDocuments: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RuleName",
                    "ClientID",
                    "Timestamp",
                    "RequestCount",
                    "SampledCount"
                  ],
                  members: {
                    RuleName: {},
                    ClientID: {},
                    Timestamp: {
                      type: "timestamp"
                    },
                    RequestCount: {
                      type: "integer"
                    },
                    SampledCount: {
                      type: "integer"
                    },
                    BorrowCount: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SamplingTargetDocuments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RuleName: {},
                    FixedRate: {
                      type: "double"
                    },
                    ReservoirQuota: {
                      type: "integer"
                    },
                    ReservoirQuotaTTL: {
                      type: "timestamp"
                    },
                    Interval: {
                      type: "integer"
                    }
                  }
                }
              },
              LastRuleModification: {
                type: "timestamp"
              },
              UnprocessedStatistics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RuleName: {},
                    ErrorCode: {},
                    Message: {}
                  }
                }
              }
            }
          }
        },
        GetServiceGraph: {
          http: {
            requestUri: "/ServiceGraph"
          },
          input: {
            type: "structure",
            required: [
              "StartTime",
              "EndTime"
            ],
            members: {
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              GroupName: {},
              GroupARN: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Services: {
                shape: "S3a"
              },
              ContainsOldGroupVersions: {
                type: "boolean"
              },
              NextToken: {}
            }
          }
        },
        GetTimeSeriesServiceStatistics: {
          http: {
            requestUri: "/TimeSeriesServiceStatistics"
          },
          input: {
            type: "structure",
            required: [
              "StartTime",
              "EndTime"
            ],
            members: {
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              GroupName: {},
              GroupARN: {},
              EntitySelectorExpression: {},
              Period: {
                type: "integer"
              },
              ForecastStatistics: {
                type: "boolean"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TimeSeriesServiceStatistics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "timestamp"
                    },
                    EdgeSummaryStatistics: {
                      shape: "S3e"
                    },
                    ServiceSummaryStatistics: {
                      shape: "S3m"
                    },
                    ServiceForecastStatistics: {
                      type: "structure",
                      members: {
                        FaultCountHigh: {
                          type: "long"
                        },
                        FaultCountLow: {
                          type: "long"
                        }
                      }
                    },
                    ResponseTimeHistogram: {
                      shape: "S3h"
                    }
                  }
                }
              },
              ContainsOldGroupVersions: {
                type: "boolean"
              },
              NextToken: {}
            }
          }
        },
        GetTraceGraph: {
          http: {
            requestUri: "/TraceGraph"
          },
          input: {
            type: "structure",
            required: [
              "TraceIds"
            ],
            members: {
              TraceIds: {
                shape: "S2"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Services: {
                shape: "S3a"
              },
              NextToken: {}
            }
          }
        },
        GetTraceSummaries: {
          http: {
            requestUri: "/TraceSummaries"
          },
          input: {
            type: "structure",
            required: [
              "StartTime",
              "EndTime"
            ],
            members: {
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              TimeRangeType: {},
              Sampling: {
                type: "boolean"
              },
              SamplingStrategy: {
                type: "structure",
                members: {
                  Name: {},
                  Value: {
                    type: "double"
                  }
                }
              },
              FilterExpression: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TraceSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Duration: {
                      type: "double"
                    },
                    ResponseTime: {
                      type: "double"
                    },
                    HasFault: {
                      type: "boolean"
                    },
                    HasError: {
                      type: "boolean"
                    },
                    HasThrottle: {
                      type: "boolean"
                    },
                    IsPartial: {
                      type: "boolean"
                    },
                    Http: {
                      type: "structure",
                      members: {
                        HttpURL: {},
                        HttpStatus: {
                          type: "integer"
                        },
                        HttpMethod: {},
                        UserAgent: {},
                        ClientIp: {}
                      }
                    },
                    Annotations: {
                      type: "map",
                      key: {},
                      value: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            AnnotationValue: {
                              type: "structure",
                              members: {
                                NumberValue: {
                                  type: "double"
                                },
                                BooleanValue: {
                                  type: "boolean"
                                },
                                StringValue: {}
                              }
                            },
                            ServiceIds: {
                              shape: "S49"
                            }
                          }
                        }
                      }
                    },
                    Users: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          UserName: {},
                          ServiceIds: {
                            shape: "S49"
                          }
                        }
                      }
                    },
                    ServiceIds: {
                      shape: "S49"
                    },
                    ResourceARNs: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ARN: {}
                        }
                      }
                    },
                    InstanceIds: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Id: {}
                        }
                      }
                    },
                    AvailabilityZones: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {}
                        }
                      }
                    },
                    EntryPoint: {
                      shape: "S1t"
                    },
                    FaultRootCauses: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Services: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {},
                                Names: {
                                  shape: "S1u"
                                },
                                Type: {},
                                AccountId: {},
                                EntityPath: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Name: {},
                                      Exceptions: {
                                        shape: "S4o"
                                      },
                                      Remote: {
                                        type: "boolean"
                                      }
                                    }
                                  }
                                },
                                Inferred: {
                                  type: "boolean"
                                }
                              }
                            }
                          },
                          ClientImpacting: {
                            type: "boolean"
                          }
                        }
                      }
                    },
                    ErrorRootCauses: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Services: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {},
                                Names: {
                                  shape: "S1u"
                                },
                                Type: {},
                                AccountId: {},
                                EntityPath: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Name: {},
                                      Exceptions: {
                                        shape: "S4o"
                                      },
                                      Remote: {
                                        type: "boolean"
                                      }
                                    }
                                  }
                                },
                                Inferred: {
                                  type: "boolean"
                                }
                              }
                            }
                          },
                          ClientImpacting: {
                            type: "boolean"
                          }
                        }
                      }
                    },
                    ResponseTimeRootCauses: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Services: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {},
                                Names: {
                                  shape: "S1u"
                                },
                                Type: {},
                                AccountId: {},
                                EntityPath: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Name: {},
                                      Coverage: {
                                        type: "double"
                                      },
                                      Remote: {
                                        type: "boolean"
                                      }
                                    }
                                  }
                                },
                                Inferred: {
                                  type: "boolean"
                                }
                              }
                            }
                          },
                          ClientImpacting: {
                            type: "boolean"
                          }
                        }
                      }
                    },
                    Revision: {
                      type: "integer"
                    },
                    MatchedEventTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              ApproximateTime: {
                type: "timestamp"
              },
              TracesProcessedCount: {
                type: "long"
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            requestUri: "/ListTagsForResource"
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sj"
              },
              NextToken: {}
            }
          }
        },
        PutEncryptionConfig: {
          http: {
            requestUri: "/PutEncryptionConfig"
          },
          input: {
            type: "structure",
            required: [
              "Type"
            ],
            members: {
              KeyId: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EncryptionConfig: {
                shape: "S1f"
              }
            }
          }
        },
        PutTelemetryRecords: {
          http: {
            requestUri: "/TelemetryRecords"
          },
          input: {
            type: "structure",
            required: [
              "TelemetryRecords"
            ],
            members: {
              TelemetryRecords: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Timestamp"
                  ],
                  members: {
                    Timestamp: {
                      type: "timestamp"
                    },
                    SegmentsReceivedCount: {
                      type: "integer"
                    },
                    SegmentsSentCount: {
                      type: "integer"
                    },
                    SegmentsSpilloverCount: {
                      type: "integer"
                    },
                    SegmentsRejectedCount: {
                      type: "integer"
                    },
                    BackendConnectionErrors: {
                      type: "structure",
                      members: {
                        TimeoutCount: {
                          type: "integer"
                        },
                        ConnectionRefusedCount: {
                          type: "integer"
                        },
                        HTTPCode4XXCount: {
                          type: "integer"
                        },
                        HTTPCode5XXCount: {
                          type: "integer"
                        },
                        UnknownHostCount: {
                          type: "integer"
                        },
                        OtherCount: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              },
              EC2InstanceId: {},
              Hostname: {},
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutTraceSegments: {
          http: {
            requestUri: "/TraceSegments"
          },
          input: {
            type: "structure",
            required: [
              "TraceSegmentDocuments"
            ],
            members: {
              TraceSegmentDocuments: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UnprocessedTraceSegments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    ErrorCode: {},
                    Message: {}
                  }
                }
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/TagResource"
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            requestUri: "/UntagResource"
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateGroup: {
          http: {
            requestUri: "/UpdateGroup"
          },
          input: {
            type: "structure",
            members: {
              GroupName: {},
              GroupARN: {},
              FilterExpression: {},
              InsightsConfiguration: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "So"
              }
            }
          }
        },
        UpdateSamplingRule: {
          http: {
            requestUri: "/UpdateSamplingRule"
          },
          input: {
            type: "structure",
            required: [
              "SamplingRuleUpdate"
            ],
            members: {
              SamplingRuleUpdate: {
                type: "structure",
                members: {
                  RuleName: {},
                  RuleARN: {},
                  ResourceARN: {},
                  Priority: {
                    type: "integer"
                  },
                  FixedRate: {
                    type: "double"
                  },
                  ReservoirSize: {
                    type: "integer"
                  },
                  Host: {},
                  ServiceName: {},
                  ServiceType: {},
                  HTTPMethod: {},
                  URLPath: {},
                  Attributes: {
                    shape: "S12"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SamplingRuleRecord: {
                shape: "S16"
              }
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {}
        },
        Si: {
          type: "structure",
          members: {
            InsightsEnabled: {
              type: "boolean"
            },
            NotificationsEnabled: {
              type: "boolean"
            }
          }
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        So: {
          type: "structure",
          members: {
            GroupName: {},
            GroupARN: {},
            FilterExpression: {},
            InsightsConfiguration: {
              shape: "Si"
            }
          }
        },
        Sq: {
          type: "structure",
          required: [
            "ResourceARN",
            "Priority",
            "FixedRate",
            "ReservoirSize",
            "ServiceName",
            "ServiceType",
            "Host",
            "HTTPMethod",
            "URLPath",
            "Version"
          ],
          members: {
            RuleName: {},
            RuleARN: {},
            ResourceARN: {},
            Priority: {
              type: "integer"
            },
            FixedRate: {
              type: "double"
            },
            ReservoirSize: {
              type: "integer"
            },
            ServiceName: {},
            ServiceType: {},
            Host: {},
            HTTPMethod: {},
            URLPath: {},
            Version: {
              type: "integer"
            },
            Attributes: {
              shape: "S12"
            }
          }
        },
        S12: {
          type: "map",
          key: {},
          value: {}
        },
        S16: {
          type: "structure",
          members: {
            SamplingRule: {
              shape: "Sq"
            },
            CreatedAt: {
              type: "timestamp"
            },
            ModifiedAt: {
              type: "timestamp"
            }
          }
        },
        S1f: {
          type: "structure",
          members: {
            KeyId: {},
            Status: {},
            Type: {}
          }
        },
        S1t: {
          type: "structure",
          members: {
            Name: {},
            Names: {
              shape: "S1u"
            },
            AccountId: {},
            Type: {}
          }
        },
        S1u: {
          type: "list",
          member: {}
        },
        S1v: {
          type: "list",
          member: {}
        },
        S1z: {
          type: "structure",
          members: {
            FaultCount: {
              type: "long"
            },
            OkCount: {
              type: "long"
            },
            TotalCount: {
              type: "long"
            }
          }
        },
        S21: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ServiceId: {
                shape: "S1t"
              }
            }
          }
        },
        S3a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ReferenceId: {
                type: "integer"
              },
              Name: {},
              Names: {
                shape: "S1u"
              },
              Root: {
                type: "boolean"
              },
              AccountId: {},
              Type: {},
              State: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Edges: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReferenceId: {
                      type: "integer"
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    SummaryStatistics: {
                      shape: "S3e"
                    },
                    ResponseTimeHistogram: {
                      shape: "S3h"
                    },
                    Aliases: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {},
                          Names: {
                            type: "list",
                            member: {}
                          },
                          Type: {}
                        }
                      }
                    }
                  }
                }
              },
              SummaryStatistics: {
                shape: "S3m"
              },
              DurationHistogram: {
                shape: "S3h"
              },
              ResponseTimeHistogram: {
                shape: "S3h"
              }
            }
          }
        },
        S3e: {
          type: "structure",
          members: {
            OkCount: {
              type: "long"
            },
            ErrorStatistics: {
              shape: "S3f"
            },
            FaultStatistics: {
              shape: "S3g"
            },
            TotalCount: {
              type: "long"
            },
            TotalResponseTime: {
              type: "double"
            }
          }
        },
        S3f: {
          type: "structure",
          members: {
            ThrottleCount: {
              type: "long"
            },
            OtherCount: {
              type: "long"
            },
            TotalCount: {
              type: "long"
            }
          }
        },
        S3g: {
          type: "structure",
          members: {
            OtherCount: {
              type: "long"
            },
            TotalCount: {
              type: "long"
            }
          }
        },
        S3h: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Value: {
                type: "double"
              },
              Count: {
                type: "integer"
              }
            }
          }
        },
        S3m: {
          type: "structure",
          members: {
            OkCount: {
              type: "long"
            },
            ErrorStatistics: {
              shape: "S3f"
            },
            FaultStatistics: {
              shape: "S3g"
            },
            TotalCount: {
              type: "long"
            },
            TotalResponseTime: {
              type: "double"
            }
          }
        },
        S49: {
          type: "list",
          member: {
            shape: "S1t"
          }
        },
        S4o: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Message: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/xray-2016-04-12.paginators.json
var require_xray_2016_04_12_paginators = __commonJS({
  "node_modules/aws-sdk/apis/xray-2016-04-12.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        BatchGetTraces: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Traces"
        },
        GetGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Groups"
        },
        GetInsightEvents: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetInsightSummaries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetSamplingRules: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "SamplingRuleRecords"
        },
        GetSamplingStatisticSummaries: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "SamplingStatisticSummaries"
        },
        GetServiceGraph: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Services"
        },
        GetTimeSeriesServiceStatistics: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "TimeSeriesServiceStatistics"
        },
        GetTraceGraph: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Services"
        },
        GetTraceSummaries: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "TraceSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/xray.js
var require_xray = __commonJS({
  "node_modules/aws-sdk/clients/xray.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["xray"] = {};
    AWS3.XRay = Service.defineService("xray", ["2016-04-12"]);
    Object.defineProperty(apiLoader.services["xray"], "2016-04-12", {
      get: function get() {
        var model = require_xray_2016_04_12_min();
        model.paginators = require_xray_2016_04_12_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.XRay;
  }
});

// node_modules/aws-sdk/apis/waf-2015-08-24.min.json
var require_waf_2015_08_24_min = __commonJS({
  "node_modules/aws-sdk/apis/waf-2015-08-24.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-08-24",
        endpointPrefix: "waf",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "WAF",
        serviceFullName: "AWS WAF",
        serviceId: "WAF",
        signatureVersion: "v4",
        targetPrefix: "AWSWAF_20150824",
        uid: "waf-2015-08-24"
      },
      operations: {
        CreateByteMatchSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByteMatchSet: {
                shape: "S5"
              },
              ChangeToken: {}
            }
          }
        },
        CreateGeoMatchSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GeoMatchSet: {
                shape: "Sh"
              },
              ChangeToken: {}
            }
          }
        },
        CreateIPSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IPSet: {
                shape: "So"
              },
              ChangeToken: {}
            }
          }
        },
        CreateRateBasedRule: {
          input: {
            type: "structure",
            required: [
              "Name",
              "MetricName",
              "RateKey",
              "RateLimit",
              "ChangeToken"
            ],
            members: {
              Name: {},
              MetricName: {},
              RateKey: {},
              RateLimit: {
                type: "long"
              },
              ChangeToken: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rule: {
                shape: "S12"
              },
              ChangeToken: {}
            }
          }
        },
        CreateRegexMatchSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegexMatchSet: {
                shape: "S19"
              },
              ChangeToken: {}
            }
          }
        },
        CreateRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegexPatternSet: {
                shape: "S1e"
              },
              ChangeToken: {}
            }
          }
        },
        CreateRule: {
          input: {
            type: "structure",
            required: [
              "Name",
              "MetricName",
              "ChangeToken"
            ],
            members: {
              Name: {},
              MetricName: {},
              ChangeToken: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rule: {
                shape: "S1j"
              },
              ChangeToken: {}
            }
          }
        },
        CreateRuleGroup: {
          input: {
            type: "structure",
            required: [
              "Name",
              "MetricName",
              "ChangeToken"
            ],
            members: {
              Name: {},
              MetricName: {},
              ChangeToken: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RuleGroup: {
                shape: "S1m"
              },
              ChangeToken: {}
            }
          }
        },
        CreateSizeConstraintSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SizeConstraintSet: {
                shape: "S1p"
              },
              ChangeToken: {}
            }
          }
        },
        CreateSqlInjectionMatchSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SqlInjectionMatchSet: {
                shape: "S1w"
              },
              ChangeToken: {}
            }
          }
        },
        CreateWebACL: {
          input: {
            type: "structure",
            required: [
              "Name",
              "MetricName",
              "DefaultAction",
              "ChangeToken"
            ],
            members: {
              Name: {},
              MetricName: {},
              DefaultAction: {
                shape: "S20"
              },
              ChangeToken: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WebACL: {
                shape: "S23"
              },
              ChangeToken: {}
            }
          }
        },
        CreateWebACLMigrationStack: {
          input: {
            type: "structure",
            required: [
              "WebACLId",
              "S3BucketName",
              "IgnoreUnsupportedType"
            ],
            members: {
              WebACLId: {},
              S3BucketName: {},
              IgnoreUnsupportedType: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "S3ObjectUrl"
            ],
            members: {
              S3ObjectUrl: {}
            }
          }
        },
        CreateXssMatchSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              XssMatchSet: {
                shape: "S2k"
              },
              ChangeToken: {}
            }
          }
        },
        DeleteByteMatchSet: {
          input: {
            type: "structure",
            required: [
              "ByteMatchSetId",
              "ChangeToken"
            ],
            members: {
              ByteMatchSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteGeoMatchSet: {
          input: {
            type: "structure",
            required: [
              "GeoMatchSetId",
              "ChangeToken"
            ],
            members: {
              GeoMatchSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteIPSet: {
          input: {
            type: "structure",
            required: [
              "IPSetId",
              "ChangeToken"
            ],
            members: {
              IPSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteLoggingConfiguration: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePermissionPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRateBasedRule: {
          input: {
            type: "structure",
            required: [
              "RuleId",
              "ChangeToken"
            ],
            members: {
              RuleId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteRegexMatchSet: {
          input: {
            type: "structure",
            required: [
              "RegexMatchSetId",
              "ChangeToken"
            ],
            members: {
              RegexMatchSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "RegexPatternSetId",
              "ChangeToken"
            ],
            members: {
              RegexPatternSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteRule: {
          input: {
            type: "structure",
            required: [
              "RuleId",
              "ChangeToken"
            ],
            members: {
              RuleId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteRuleGroup: {
          input: {
            type: "structure",
            required: [
              "RuleGroupId",
              "ChangeToken"
            ],
            members: {
              RuleGroupId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteSizeConstraintSet: {
          input: {
            type: "structure",
            required: [
              "SizeConstraintSetId",
              "ChangeToken"
            ],
            members: {
              SizeConstraintSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteSqlInjectionMatchSet: {
          input: {
            type: "structure",
            required: [
              "SqlInjectionMatchSetId",
              "ChangeToken"
            ],
            members: {
              SqlInjectionMatchSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteWebACL: {
          input: {
            type: "structure",
            required: [
              "WebACLId",
              "ChangeToken"
            ],
            members: {
              WebACLId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteXssMatchSet: {
          input: {
            type: "structure",
            required: [
              "XssMatchSetId",
              "ChangeToken"
            ],
            members: {
              XssMatchSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        GetByteMatchSet: {
          input: {
            type: "structure",
            required: [
              "ByteMatchSetId"
            ],
            members: {
              ByteMatchSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByteMatchSet: {
                shape: "S5"
              }
            }
          }
        },
        GetChangeToken: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        GetChangeTokenStatus: {
          input: {
            type: "structure",
            required: [
              "ChangeToken"
            ],
            members: {
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeTokenStatus: {}
            }
          }
        },
        GetGeoMatchSet: {
          input: {
            type: "structure",
            required: [
              "GeoMatchSetId"
            ],
            members: {
              GeoMatchSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GeoMatchSet: {
                shape: "Sh"
              }
            }
          }
        },
        GetIPSet: {
          input: {
            type: "structure",
            required: [
              "IPSetId"
            ],
            members: {
              IPSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IPSet: {
                shape: "So"
              }
            }
          }
        },
        GetLoggingConfiguration: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfiguration: {
                shape: "S3s"
              }
            }
          }
        },
        GetPermissionPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          }
        },
        GetRateBasedRule: {
          input: {
            type: "structure",
            required: [
              "RuleId"
            ],
            members: {
              RuleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Rule: {
                shape: "S12"
              }
            }
          }
        },
        GetRateBasedRuleManagedKeys: {
          input: {
            type: "structure",
            required: [
              "RuleId"
            ],
            members: {
              RuleId: {},
              NextMarker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ManagedKeys: {
                type: "list",
                member: {}
              },
              NextMarker: {}
            }
          }
        },
        GetRegexMatchSet: {
          input: {
            type: "structure",
            required: [
              "RegexMatchSetId"
            ],
            members: {
              RegexMatchSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegexMatchSet: {
                shape: "S19"
              }
            }
          }
        },
        GetRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "RegexPatternSetId"
            ],
            members: {
              RegexPatternSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegexPatternSet: {
                shape: "S1e"
              }
            }
          }
        },
        GetRule: {
          input: {
            type: "structure",
            required: [
              "RuleId"
            ],
            members: {
              RuleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Rule: {
                shape: "S1j"
              }
            }
          }
        },
        GetRuleGroup: {
          input: {
            type: "structure",
            required: [
              "RuleGroupId"
            ],
            members: {
              RuleGroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RuleGroup: {
                shape: "S1m"
              }
            }
          }
        },
        GetSampledRequests: {
          input: {
            type: "structure",
            required: [
              "WebAclId",
              "RuleId",
              "TimeWindow",
              "MaxItems"
            ],
            members: {
              WebAclId: {},
              RuleId: {},
              TimeWindow: {
                shape: "S4e"
              },
              MaxItems: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SampledRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Request",
                    "Weight"
                  ],
                  members: {
                    Request: {
                      type: "structure",
                      members: {
                        ClientIP: {},
                        Country: {},
                        URI: {},
                        Method: {},
                        HTTPVersion: {},
                        Headers: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Name: {},
                              Value: {}
                            }
                          }
                        }
                      }
                    },
                    Weight: {
                      type: "long"
                    },
                    Timestamp: {
                      type: "timestamp"
                    },
                    Action: {},
                    RuleWithinRuleGroup: {}
                  }
                }
              },
              PopulationSize: {
                type: "long"
              },
              TimeWindow: {
                shape: "S4e"
              }
            }
          }
        },
        GetSizeConstraintSet: {
          input: {
            type: "structure",
            required: [
              "SizeConstraintSetId"
            ],
            members: {
              SizeConstraintSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SizeConstraintSet: {
                shape: "S1p"
              }
            }
          }
        },
        GetSqlInjectionMatchSet: {
          input: {
            type: "structure",
            required: [
              "SqlInjectionMatchSetId"
            ],
            members: {
              SqlInjectionMatchSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SqlInjectionMatchSet: {
                shape: "S1w"
              }
            }
          }
        },
        GetWebACL: {
          input: {
            type: "structure",
            required: [
              "WebACLId"
            ],
            members: {
              WebACLId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WebACL: {
                shape: "S23"
              }
            }
          }
        },
        GetXssMatchSet: {
          input: {
            type: "structure",
            required: [
              "XssMatchSetId"
            ],
            members: {
              XssMatchSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              XssMatchSet: {
                shape: "S2k"
              }
            }
          }
        },
        ListActivatedRulesInRuleGroup: {
          input: {
            type: "structure",
            members: {
              RuleGroupId: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              ActivatedRules: {
                shape: "S24"
              }
            }
          }
        },
        ListByteMatchSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              ByteMatchSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ByteMatchSetId",
                    "Name"
                  ],
                  members: {
                    ByteMatchSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListGeoMatchSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              GeoMatchSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "GeoMatchSetId",
                    "Name"
                  ],
                  members: {
                    GeoMatchSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListIPSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              IPSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "IPSetId",
                    "Name"
                  ],
                  members: {
                    IPSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListLoggingConfigurations: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfigurations: {
                type: "list",
                member: {
                  shape: "S3s"
                }
              },
              NextMarker: {}
            }
          }
        },
        ListRateBasedRules: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              Rules: {
                shape: "S5p"
              }
            }
          }
        },
        ListRegexMatchSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              RegexMatchSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RegexMatchSetId",
                    "Name"
                  ],
                  members: {
                    RegexMatchSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListRegexPatternSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              RegexPatternSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RegexPatternSetId",
                    "Name"
                  ],
                  members: {
                    RegexPatternSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListRuleGroups: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              RuleGroups: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RuleGroupId",
                    "Name"
                  ],
                  members: {
                    RuleGroupId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListRules: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              Rules: {
                shape: "S5p"
              }
            }
          }
        },
        ListSizeConstraintSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              SizeConstraintSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SizeConstraintSetId",
                    "Name"
                  ],
                  members: {
                    SizeConstraintSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListSqlInjectionMatchSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              SqlInjectionMatchSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SqlInjectionMatchSetId",
                    "Name"
                  ],
                  members: {
                    SqlInjectionMatchSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListSubscribedRuleGroups: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              RuleGroups: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RuleGroupId",
                    "Name",
                    "MetricName"
                  ],
                  members: {
                    RuleGroupId: {},
                    Name: {},
                    MetricName: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              },
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              TagInfoForResource: {
                type: "structure",
                members: {
                  ResourceARN: {},
                  TagList: {
                    shape: "Sx"
                  }
                }
              }
            }
          }
        },
        ListWebACLs: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              WebACLs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "WebACLId",
                    "Name"
                  ],
                  members: {
                    WebACLId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListXssMatchSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              XssMatchSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "XssMatchSetId",
                    "Name"
                  ],
                  members: {
                    XssMatchSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        PutLoggingConfiguration: {
          input: {
            type: "structure",
            required: [
              "LoggingConfiguration"
            ],
            members: {
              LoggingConfiguration: {
                shape: "S3s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfiguration: {
                shape: "S3s"
              }
            }
          }
        },
        PutPermissionPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Policy"
            ],
            members: {
              ResourceArn: {},
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateByteMatchSet: {
          input: {
            type: "structure",
            required: [
              "ByteMatchSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              ByteMatchSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "ByteMatchTuple"
                  ],
                  members: {
                    Action: {},
                    ByteMatchTuple: {
                      shape: "S8"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateGeoMatchSet: {
          input: {
            type: "structure",
            required: [
              "GeoMatchSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              GeoMatchSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "GeoMatchConstraint"
                  ],
                  members: {
                    Action: {},
                    GeoMatchConstraint: {
                      shape: "Sj"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateIPSet: {
          input: {
            type: "structure",
            required: [
              "IPSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              IPSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "IPSetDescriptor"
                  ],
                  members: {
                    Action: {},
                    IPSetDescriptor: {
                      shape: "Sq"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateRateBasedRule: {
          input: {
            type: "structure",
            required: [
              "RuleId",
              "ChangeToken",
              "Updates",
              "RateLimit"
            ],
            members: {
              RuleId: {},
              ChangeToken: {},
              Updates: {
                shape: "S7f"
              },
              RateLimit: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateRegexMatchSet: {
          input: {
            type: "structure",
            required: [
              "RegexMatchSetId",
              "Updates",
              "ChangeToken"
            ],
            members: {
              RegexMatchSetId: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "RegexMatchTuple"
                  ],
                  members: {
                    Action: {},
                    RegexMatchTuple: {
                      shape: "S1b"
                    }
                  }
                }
              },
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "RegexPatternSetId",
              "Updates",
              "ChangeToken"
            ],
            members: {
              RegexPatternSetId: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "RegexPatternString"
                  ],
                  members: {
                    Action: {},
                    RegexPatternString: {}
                  }
                }
              },
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateRule: {
          input: {
            type: "structure",
            required: [
              "RuleId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              RuleId: {},
              ChangeToken: {},
              Updates: {
                shape: "S7f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateRuleGroup: {
          input: {
            type: "structure",
            required: [
              "RuleGroupId",
              "Updates",
              "ChangeToken"
            ],
            members: {
              RuleGroupId: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "ActivatedRule"
                  ],
                  members: {
                    Action: {},
                    ActivatedRule: {
                      shape: "S25"
                    }
                  }
                }
              },
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateSizeConstraintSet: {
          input: {
            type: "structure",
            required: [
              "SizeConstraintSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              SizeConstraintSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "SizeConstraint"
                  ],
                  members: {
                    Action: {},
                    SizeConstraint: {
                      shape: "S1r"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateSqlInjectionMatchSet: {
          input: {
            type: "structure",
            required: [
              "SqlInjectionMatchSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              SqlInjectionMatchSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "SqlInjectionMatchTuple"
                  ],
                  members: {
                    Action: {},
                    SqlInjectionMatchTuple: {
                      shape: "S1y"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateWebACL: {
          input: {
            type: "structure",
            required: [
              "WebACLId",
              "ChangeToken"
            ],
            members: {
              WebACLId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "ActivatedRule"
                  ],
                  members: {
                    Action: {},
                    ActivatedRule: {
                      shape: "S25"
                    }
                  }
                }
              },
              DefaultAction: {
                shape: "S20"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateXssMatchSet: {
          input: {
            type: "structure",
            required: [
              "XssMatchSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              XssMatchSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "XssMatchTuple"
                  ],
                  members: {
                    Action: {},
                    XssMatchTuple: {
                      shape: "S2m"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          required: [
            "ByteMatchSetId",
            "ByteMatchTuples"
          ],
          members: {
            ByteMatchSetId: {},
            Name: {},
            ByteMatchTuples: {
              type: "list",
              member: {
                shape: "S8"
              }
            }
          }
        },
        S8: {
          type: "structure",
          required: [
            "FieldToMatch",
            "TargetString",
            "TextTransformation",
            "PositionalConstraint"
          ],
          members: {
            FieldToMatch: {
              shape: "S9"
            },
            TargetString: {
              type: "blob"
            },
            TextTransformation: {},
            PositionalConstraint: {}
          }
        },
        S9: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Type: {},
            Data: {}
          }
        },
        Sh: {
          type: "structure",
          required: [
            "GeoMatchSetId",
            "GeoMatchConstraints"
          ],
          members: {
            GeoMatchSetId: {},
            Name: {},
            GeoMatchConstraints: {
              type: "list",
              member: {
                shape: "Sj"
              }
            }
          }
        },
        Sj: {
          type: "structure",
          required: [
            "Type",
            "Value"
          ],
          members: {
            Type: {},
            Value: {}
          }
        },
        So: {
          type: "structure",
          required: [
            "IPSetId",
            "IPSetDescriptors"
          ],
          members: {
            IPSetId: {},
            Name: {},
            IPSetDescriptors: {
              type: "list",
              member: {
                shape: "Sq"
              }
            }
          }
        },
        Sq: {
          type: "structure",
          required: [
            "Type",
            "Value"
          ],
          members: {
            Type: {},
            Value: {}
          }
        },
        Sx: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "RuleId",
            "MatchPredicates",
            "RateKey",
            "RateLimit"
          ],
          members: {
            RuleId: {},
            Name: {},
            MetricName: {},
            MatchPredicates: {
              shape: "S13"
            },
            RateKey: {},
            RateLimit: {
              type: "long"
            }
          }
        },
        S13: {
          type: "list",
          member: {
            shape: "S14"
          }
        },
        S14: {
          type: "structure",
          required: [
            "Negated",
            "Type",
            "DataId"
          ],
          members: {
            Negated: {
              type: "boolean"
            },
            Type: {},
            DataId: {}
          }
        },
        S19: {
          type: "structure",
          members: {
            RegexMatchSetId: {},
            Name: {},
            RegexMatchTuples: {
              type: "list",
              member: {
                shape: "S1b"
              }
            }
          }
        },
        S1b: {
          type: "structure",
          required: [
            "FieldToMatch",
            "TextTransformation",
            "RegexPatternSetId"
          ],
          members: {
            FieldToMatch: {
              shape: "S9"
            },
            TextTransformation: {},
            RegexPatternSetId: {}
          }
        },
        S1e: {
          type: "structure",
          required: [
            "RegexPatternSetId",
            "RegexPatternStrings"
          ],
          members: {
            RegexPatternSetId: {},
            Name: {},
            RegexPatternStrings: {
              type: "list",
              member: {}
            }
          }
        },
        S1j: {
          type: "structure",
          required: [
            "RuleId",
            "Predicates"
          ],
          members: {
            RuleId: {},
            Name: {},
            MetricName: {},
            Predicates: {
              shape: "S13"
            }
          }
        },
        S1m: {
          type: "structure",
          required: [
            "RuleGroupId"
          ],
          members: {
            RuleGroupId: {},
            Name: {},
            MetricName: {}
          }
        },
        S1p: {
          type: "structure",
          required: [
            "SizeConstraintSetId",
            "SizeConstraints"
          ],
          members: {
            SizeConstraintSetId: {},
            Name: {},
            SizeConstraints: {
              type: "list",
              member: {
                shape: "S1r"
              }
            }
          }
        },
        S1r: {
          type: "structure",
          required: [
            "FieldToMatch",
            "TextTransformation",
            "ComparisonOperator",
            "Size"
          ],
          members: {
            FieldToMatch: {
              shape: "S9"
            },
            TextTransformation: {},
            ComparisonOperator: {},
            Size: {
              type: "long"
            }
          }
        },
        S1w: {
          type: "structure",
          required: [
            "SqlInjectionMatchSetId",
            "SqlInjectionMatchTuples"
          ],
          members: {
            SqlInjectionMatchSetId: {},
            Name: {},
            SqlInjectionMatchTuples: {
              type: "list",
              member: {
                shape: "S1y"
              }
            }
          }
        },
        S1y: {
          type: "structure",
          required: [
            "FieldToMatch",
            "TextTransformation"
          ],
          members: {
            FieldToMatch: {
              shape: "S9"
            },
            TextTransformation: {}
          }
        },
        S20: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Type: {}
          }
        },
        S23: {
          type: "structure",
          required: [
            "WebACLId",
            "DefaultAction",
            "Rules"
          ],
          members: {
            WebACLId: {},
            Name: {},
            MetricName: {},
            DefaultAction: {
              shape: "S20"
            },
            Rules: {
              shape: "S24"
            },
            WebACLArn: {}
          }
        },
        S24: {
          type: "list",
          member: {
            shape: "S25"
          }
        },
        S25: {
          type: "structure",
          required: [
            "Priority",
            "RuleId"
          ],
          members: {
            Priority: {
              type: "integer"
            },
            RuleId: {},
            Action: {
              shape: "S20"
            },
            OverrideAction: {
              type: "structure",
              required: [
                "Type"
              ],
              members: {
                Type: {}
              }
            },
            Type: {},
            ExcludedRules: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "RuleId"
                ],
                members: {
                  RuleId: {}
                }
              }
            }
          }
        },
        S2k: {
          type: "structure",
          required: [
            "XssMatchSetId",
            "XssMatchTuples"
          ],
          members: {
            XssMatchSetId: {},
            Name: {},
            XssMatchTuples: {
              type: "list",
              member: {
                shape: "S2m"
              }
            }
          }
        },
        S2m: {
          type: "structure",
          required: [
            "FieldToMatch",
            "TextTransformation"
          ],
          members: {
            FieldToMatch: {
              shape: "S9"
            },
            TextTransformation: {}
          }
        },
        S3s: {
          type: "structure",
          required: [
            "ResourceArn",
            "LogDestinationConfigs"
          ],
          members: {
            ResourceArn: {},
            LogDestinationConfigs: {
              type: "list",
              member: {}
            },
            RedactedFields: {
              type: "list",
              member: {
                shape: "S9"
              }
            }
          }
        },
        S4e: {
          type: "structure",
          required: [
            "StartTime",
            "EndTime"
          ],
          members: {
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            }
          }
        },
        S5p: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "RuleId",
              "Name"
            ],
            members: {
              RuleId: {},
              Name: {}
            }
          }
        },
        S7f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Action",
              "Predicate"
            ],
            members: {
              Action: {},
              Predicate: {
                shape: "S14"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/waf-2015-08-24.paginators.json
var require_waf_2015_08_24_paginators = __commonJS({
  "node_modules/aws-sdk/apis/waf-2015-08-24.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/waf.js
var require_waf = __commonJS({
  "node_modules/aws-sdk/clients/waf.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["waf"] = {};
    AWS3.WAF = Service.defineService("waf", ["2015-08-24"]);
    Object.defineProperty(apiLoader.services["waf"], "2015-08-24", {
      get: function get() {
        var model = require_waf_2015_08_24_min();
        model.paginators = require_waf_2015_08_24_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.WAF;
  }
});

// node_modules/aws-sdk/apis/waf-regional-2016-11-28.min.json
var require_waf_regional_2016_11_28_min = __commonJS({
  "node_modules/aws-sdk/apis/waf-regional-2016-11-28.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-11-28",
        endpointPrefix: "waf-regional",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "WAF Regional",
        serviceFullName: "AWS WAF Regional",
        serviceId: "WAF Regional",
        signatureVersion: "v4",
        targetPrefix: "AWSWAF_Regional_20161128",
        uid: "waf-regional-2016-11-28"
      },
      operations: {
        AssociateWebACL: {
          input: {
            type: "structure",
            required: [
              "WebACLId",
              "ResourceArn"
            ],
            members: {
              WebACLId: {},
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateByteMatchSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByteMatchSet: {
                shape: "S9"
              },
              ChangeToken: {}
            }
          }
        },
        CreateGeoMatchSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GeoMatchSet: {
                shape: "Sk"
              },
              ChangeToken: {}
            }
          }
        },
        CreateIPSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IPSet: {
                shape: "Sr"
              },
              ChangeToken: {}
            }
          }
        },
        CreateRateBasedRule: {
          input: {
            type: "structure",
            required: [
              "Name",
              "MetricName",
              "RateKey",
              "RateLimit",
              "ChangeToken"
            ],
            members: {
              Name: {},
              MetricName: {},
              RateKey: {},
              RateLimit: {
                type: "long"
              },
              ChangeToken: {},
              Tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rule: {
                shape: "S15"
              },
              ChangeToken: {}
            }
          }
        },
        CreateRegexMatchSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegexMatchSet: {
                shape: "S1c"
              },
              ChangeToken: {}
            }
          }
        },
        CreateRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegexPatternSet: {
                shape: "S1h"
              },
              ChangeToken: {}
            }
          }
        },
        CreateRule: {
          input: {
            type: "structure",
            required: [
              "Name",
              "MetricName",
              "ChangeToken"
            ],
            members: {
              Name: {},
              MetricName: {},
              ChangeToken: {},
              Tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rule: {
                shape: "S1m"
              },
              ChangeToken: {}
            }
          }
        },
        CreateRuleGroup: {
          input: {
            type: "structure",
            required: [
              "Name",
              "MetricName",
              "ChangeToken"
            ],
            members: {
              Name: {},
              MetricName: {},
              ChangeToken: {},
              Tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RuleGroup: {
                shape: "S1p"
              },
              ChangeToken: {}
            }
          }
        },
        CreateSizeConstraintSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SizeConstraintSet: {
                shape: "S1s"
              },
              ChangeToken: {}
            }
          }
        },
        CreateSqlInjectionMatchSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SqlInjectionMatchSet: {
                shape: "S1z"
              },
              ChangeToken: {}
            }
          }
        },
        CreateWebACL: {
          input: {
            type: "structure",
            required: [
              "Name",
              "MetricName",
              "DefaultAction",
              "ChangeToken"
            ],
            members: {
              Name: {},
              MetricName: {},
              DefaultAction: {
                shape: "S23"
              },
              ChangeToken: {},
              Tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WebACL: {
                shape: "S26"
              },
              ChangeToken: {}
            }
          }
        },
        CreateWebACLMigrationStack: {
          input: {
            type: "structure",
            required: [
              "WebACLId",
              "S3BucketName",
              "IgnoreUnsupportedType"
            ],
            members: {
              WebACLId: {},
              S3BucketName: {},
              IgnoreUnsupportedType: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "S3ObjectUrl"
            ],
            members: {
              S3ObjectUrl: {}
            }
          }
        },
        CreateXssMatchSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ChangeToken"
            ],
            members: {
              Name: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              XssMatchSet: {
                shape: "S2m"
              },
              ChangeToken: {}
            }
          }
        },
        DeleteByteMatchSet: {
          input: {
            type: "structure",
            required: [
              "ByteMatchSetId",
              "ChangeToken"
            ],
            members: {
              ByteMatchSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteGeoMatchSet: {
          input: {
            type: "structure",
            required: [
              "GeoMatchSetId",
              "ChangeToken"
            ],
            members: {
              GeoMatchSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteIPSet: {
          input: {
            type: "structure",
            required: [
              "IPSetId",
              "ChangeToken"
            ],
            members: {
              IPSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteLoggingConfiguration: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePermissionPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRateBasedRule: {
          input: {
            type: "structure",
            required: [
              "RuleId",
              "ChangeToken"
            ],
            members: {
              RuleId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteRegexMatchSet: {
          input: {
            type: "structure",
            required: [
              "RegexMatchSetId",
              "ChangeToken"
            ],
            members: {
              RegexMatchSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "RegexPatternSetId",
              "ChangeToken"
            ],
            members: {
              RegexPatternSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteRule: {
          input: {
            type: "structure",
            required: [
              "RuleId",
              "ChangeToken"
            ],
            members: {
              RuleId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteRuleGroup: {
          input: {
            type: "structure",
            required: [
              "RuleGroupId",
              "ChangeToken"
            ],
            members: {
              RuleGroupId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteSizeConstraintSet: {
          input: {
            type: "structure",
            required: [
              "SizeConstraintSetId",
              "ChangeToken"
            ],
            members: {
              SizeConstraintSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteSqlInjectionMatchSet: {
          input: {
            type: "structure",
            required: [
              "SqlInjectionMatchSetId",
              "ChangeToken"
            ],
            members: {
              SqlInjectionMatchSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteWebACL: {
          input: {
            type: "structure",
            required: [
              "WebACLId",
              "ChangeToken"
            ],
            members: {
              WebACLId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DeleteXssMatchSet: {
          input: {
            type: "structure",
            required: [
              "XssMatchSetId",
              "ChangeToken"
            ],
            members: {
              XssMatchSetId: {},
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        DisassociateWebACL: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetByteMatchSet: {
          input: {
            type: "structure",
            required: [
              "ByteMatchSetId"
            ],
            members: {
              ByteMatchSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByteMatchSet: {
                shape: "S9"
              }
            }
          }
        },
        GetChangeToken: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        GetChangeTokenStatus: {
          input: {
            type: "structure",
            required: [
              "ChangeToken"
            ],
            members: {
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeTokenStatus: {}
            }
          }
        },
        GetGeoMatchSet: {
          input: {
            type: "structure",
            required: [
              "GeoMatchSetId"
            ],
            members: {
              GeoMatchSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GeoMatchSet: {
                shape: "Sk"
              }
            }
          }
        },
        GetIPSet: {
          input: {
            type: "structure",
            required: [
              "IPSetId"
            ],
            members: {
              IPSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IPSet: {
                shape: "Sr"
              }
            }
          }
        },
        GetLoggingConfiguration: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfiguration: {
                shape: "S3w"
              }
            }
          }
        },
        GetPermissionPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          }
        },
        GetRateBasedRule: {
          input: {
            type: "structure",
            required: [
              "RuleId"
            ],
            members: {
              RuleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Rule: {
                shape: "S15"
              }
            }
          }
        },
        GetRateBasedRuleManagedKeys: {
          input: {
            type: "structure",
            required: [
              "RuleId"
            ],
            members: {
              RuleId: {},
              NextMarker: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ManagedKeys: {
                type: "list",
                member: {}
              },
              NextMarker: {}
            }
          }
        },
        GetRegexMatchSet: {
          input: {
            type: "structure",
            required: [
              "RegexMatchSetId"
            ],
            members: {
              RegexMatchSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegexMatchSet: {
                shape: "S1c"
              }
            }
          }
        },
        GetRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "RegexPatternSetId"
            ],
            members: {
              RegexPatternSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegexPatternSet: {
                shape: "S1h"
              }
            }
          }
        },
        GetRule: {
          input: {
            type: "structure",
            required: [
              "RuleId"
            ],
            members: {
              RuleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Rule: {
                shape: "S1m"
              }
            }
          }
        },
        GetRuleGroup: {
          input: {
            type: "structure",
            required: [
              "RuleGroupId"
            ],
            members: {
              RuleGroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RuleGroup: {
                shape: "S1p"
              }
            }
          }
        },
        GetSampledRequests: {
          input: {
            type: "structure",
            required: [
              "WebAclId",
              "RuleId",
              "TimeWindow",
              "MaxItems"
            ],
            members: {
              WebAclId: {},
              RuleId: {},
              TimeWindow: {
                shape: "S4i"
              },
              MaxItems: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SampledRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Request",
                    "Weight"
                  ],
                  members: {
                    Request: {
                      type: "structure",
                      members: {
                        ClientIP: {},
                        Country: {},
                        URI: {},
                        Method: {},
                        HTTPVersion: {},
                        Headers: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Name: {},
                              Value: {}
                            }
                          }
                        }
                      }
                    },
                    Weight: {
                      type: "long"
                    },
                    Timestamp: {
                      type: "timestamp"
                    },
                    Action: {},
                    RuleWithinRuleGroup: {}
                  }
                }
              },
              PopulationSize: {
                type: "long"
              },
              TimeWindow: {
                shape: "S4i"
              }
            }
          }
        },
        GetSizeConstraintSet: {
          input: {
            type: "structure",
            required: [
              "SizeConstraintSetId"
            ],
            members: {
              SizeConstraintSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SizeConstraintSet: {
                shape: "S1s"
              }
            }
          }
        },
        GetSqlInjectionMatchSet: {
          input: {
            type: "structure",
            required: [
              "SqlInjectionMatchSetId"
            ],
            members: {
              SqlInjectionMatchSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SqlInjectionMatchSet: {
                shape: "S1z"
              }
            }
          }
        },
        GetWebACL: {
          input: {
            type: "structure",
            required: [
              "WebACLId"
            ],
            members: {
              WebACLId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WebACL: {
                shape: "S26"
              }
            }
          }
        },
        GetWebACLForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WebACLSummary: {
                shape: "S59"
              }
            }
          }
        },
        GetXssMatchSet: {
          input: {
            type: "structure",
            required: [
              "XssMatchSetId"
            ],
            members: {
              XssMatchSetId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              XssMatchSet: {
                shape: "S2m"
              }
            }
          }
        },
        ListActivatedRulesInRuleGroup: {
          input: {
            type: "structure",
            members: {
              RuleGroupId: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              ActivatedRules: {
                shape: "S27"
              }
            }
          }
        },
        ListByteMatchSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              ByteMatchSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ByteMatchSetId",
                    "Name"
                  ],
                  members: {
                    ByteMatchSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListGeoMatchSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              GeoMatchSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "GeoMatchSetId",
                    "Name"
                  ],
                  members: {
                    GeoMatchSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListIPSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              IPSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "IPSetId",
                    "Name"
                  ],
                  members: {
                    IPSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListLoggingConfigurations: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfigurations: {
                type: "list",
                member: {
                  shape: "S3w"
                }
              },
              NextMarker: {}
            }
          }
        },
        ListRateBasedRules: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              Rules: {
                shape: "S5w"
              }
            }
          }
        },
        ListRegexMatchSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              RegexMatchSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RegexMatchSetId",
                    "Name"
                  ],
                  members: {
                    RegexMatchSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListRegexPatternSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              RegexPatternSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RegexPatternSetId",
                    "Name"
                  ],
                  members: {
                    RegexPatternSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListResourcesForWebACL: {
          input: {
            type: "structure",
            required: [
              "WebACLId"
            ],
            members: {
              WebACLId: {},
              ResourceType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceArns: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListRuleGroups: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              RuleGroups: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RuleGroupId",
                    "Name"
                  ],
                  members: {
                    RuleGroupId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListRules: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              Rules: {
                shape: "S5w"
              }
            }
          }
        },
        ListSizeConstraintSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              SizeConstraintSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SizeConstraintSetId",
                    "Name"
                  ],
                  members: {
                    SizeConstraintSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListSqlInjectionMatchSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              SqlInjectionMatchSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SqlInjectionMatchSetId",
                    "Name"
                  ],
                  members: {
                    SqlInjectionMatchSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        ListSubscribedRuleGroups: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              RuleGroups: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RuleGroupId",
                    "Name",
                    "MetricName"
                  ],
                  members: {
                    RuleGroupId: {},
                    Name: {},
                    MetricName: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              },
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              TagInfoForResource: {
                type: "structure",
                members: {
                  ResourceARN: {},
                  TagList: {
                    shape: "S10"
                  }
                }
              }
            }
          }
        },
        ListWebACLs: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              WebACLs: {
                type: "list",
                member: {
                  shape: "S59"
                }
              }
            }
          }
        },
        ListXssMatchSets: {
          input: {
            type: "structure",
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              XssMatchSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "XssMatchSetId",
                    "Name"
                  ],
                  members: {
                    XssMatchSetId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        PutLoggingConfiguration: {
          input: {
            type: "structure",
            required: [
              "LoggingConfiguration"
            ],
            members: {
              LoggingConfiguration: {
                shape: "S3w"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfiguration: {
                shape: "S3w"
              }
            }
          }
        },
        PutPermissionPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Policy"
            ],
            members: {
              ResourceArn: {},
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateByteMatchSet: {
          input: {
            type: "structure",
            required: [
              "ByteMatchSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              ByteMatchSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "ByteMatchTuple"
                  ],
                  members: {
                    Action: {},
                    ByteMatchTuple: {
                      shape: "Sb"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateGeoMatchSet: {
          input: {
            type: "structure",
            required: [
              "GeoMatchSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              GeoMatchSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "GeoMatchConstraint"
                  ],
                  members: {
                    Action: {},
                    GeoMatchConstraint: {
                      shape: "Sm"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateIPSet: {
          input: {
            type: "structure",
            required: [
              "IPSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              IPSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "IPSetDescriptor"
                  ],
                  members: {
                    Action: {},
                    IPSetDescriptor: {
                      shape: "St"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateRateBasedRule: {
          input: {
            type: "structure",
            required: [
              "RuleId",
              "ChangeToken",
              "Updates",
              "RateLimit"
            ],
            members: {
              RuleId: {},
              ChangeToken: {},
              Updates: {
                shape: "S7p"
              },
              RateLimit: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateRegexMatchSet: {
          input: {
            type: "structure",
            required: [
              "RegexMatchSetId",
              "Updates",
              "ChangeToken"
            ],
            members: {
              RegexMatchSetId: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "RegexMatchTuple"
                  ],
                  members: {
                    Action: {},
                    RegexMatchTuple: {
                      shape: "S1e"
                    }
                  }
                }
              },
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "RegexPatternSetId",
              "Updates",
              "ChangeToken"
            ],
            members: {
              RegexPatternSetId: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "RegexPatternString"
                  ],
                  members: {
                    Action: {},
                    RegexPatternString: {}
                  }
                }
              },
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateRule: {
          input: {
            type: "structure",
            required: [
              "RuleId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              RuleId: {},
              ChangeToken: {},
              Updates: {
                shape: "S7p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateRuleGroup: {
          input: {
            type: "structure",
            required: [
              "RuleGroupId",
              "Updates",
              "ChangeToken"
            ],
            members: {
              RuleGroupId: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "ActivatedRule"
                  ],
                  members: {
                    Action: {},
                    ActivatedRule: {
                      shape: "S28"
                    }
                  }
                }
              },
              ChangeToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateSizeConstraintSet: {
          input: {
            type: "structure",
            required: [
              "SizeConstraintSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              SizeConstraintSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "SizeConstraint"
                  ],
                  members: {
                    Action: {},
                    SizeConstraint: {
                      shape: "S1u"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateSqlInjectionMatchSet: {
          input: {
            type: "structure",
            required: [
              "SqlInjectionMatchSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              SqlInjectionMatchSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "SqlInjectionMatchTuple"
                  ],
                  members: {
                    Action: {},
                    SqlInjectionMatchTuple: {
                      shape: "S21"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateWebACL: {
          input: {
            type: "structure",
            required: [
              "WebACLId",
              "ChangeToken"
            ],
            members: {
              WebACLId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "ActivatedRule"
                  ],
                  members: {
                    Action: {},
                    ActivatedRule: {
                      shape: "S28"
                    }
                  }
                }
              },
              DefaultAction: {
                shape: "S23"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        },
        UpdateXssMatchSet: {
          input: {
            type: "structure",
            required: [
              "XssMatchSetId",
              "ChangeToken",
              "Updates"
            ],
            members: {
              XssMatchSetId: {},
              ChangeToken: {},
              Updates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Action",
                    "XssMatchTuple"
                  ],
                  members: {
                    Action: {},
                    XssMatchTuple: {
                      shape: "S2o"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeToken: {}
            }
          }
        }
      },
      shapes: {
        S9: {
          type: "structure",
          required: [
            "ByteMatchSetId",
            "ByteMatchTuples"
          ],
          members: {
            ByteMatchSetId: {},
            Name: {},
            ByteMatchTuples: {
              type: "list",
              member: {
                shape: "Sb"
              }
            }
          }
        },
        Sb: {
          type: "structure",
          required: [
            "FieldToMatch",
            "TargetString",
            "TextTransformation",
            "PositionalConstraint"
          ],
          members: {
            FieldToMatch: {
              shape: "Sc"
            },
            TargetString: {
              type: "blob"
            },
            TextTransformation: {},
            PositionalConstraint: {}
          }
        },
        Sc: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Type: {},
            Data: {}
          }
        },
        Sk: {
          type: "structure",
          required: [
            "GeoMatchSetId",
            "GeoMatchConstraints"
          ],
          members: {
            GeoMatchSetId: {},
            Name: {},
            GeoMatchConstraints: {
              type: "list",
              member: {
                shape: "Sm"
              }
            }
          }
        },
        Sm: {
          type: "structure",
          required: [
            "Type",
            "Value"
          ],
          members: {
            Type: {},
            Value: {}
          }
        },
        Sr: {
          type: "structure",
          required: [
            "IPSetId",
            "IPSetDescriptors"
          ],
          members: {
            IPSetId: {},
            Name: {},
            IPSetDescriptors: {
              type: "list",
              member: {
                shape: "St"
              }
            }
          }
        },
        St: {
          type: "structure",
          required: [
            "Type",
            "Value"
          ],
          members: {
            Type: {},
            Value: {}
          }
        },
        S10: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S15: {
          type: "structure",
          required: [
            "RuleId",
            "MatchPredicates",
            "RateKey",
            "RateLimit"
          ],
          members: {
            RuleId: {},
            Name: {},
            MetricName: {},
            MatchPredicates: {
              shape: "S16"
            },
            RateKey: {},
            RateLimit: {
              type: "long"
            }
          }
        },
        S16: {
          type: "list",
          member: {
            shape: "S17"
          }
        },
        S17: {
          type: "structure",
          required: [
            "Negated",
            "Type",
            "DataId"
          ],
          members: {
            Negated: {
              type: "boolean"
            },
            Type: {},
            DataId: {}
          }
        },
        S1c: {
          type: "structure",
          members: {
            RegexMatchSetId: {},
            Name: {},
            RegexMatchTuples: {
              type: "list",
              member: {
                shape: "S1e"
              }
            }
          }
        },
        S1e: {
          type: "structure",
          required: [
            "FieldToMatch",
            "TextTransformation",
            "RegexPatternSetId"
          ],
          members: {
            FieldToMatch: {
              shape: "Sc"
            },
            TextTransformation: {},
            RegexPatternSetId: {}
          }
        },
        S1h: {
          type: "structure",
          required: [
            "RegexPatternSetId",
            "RegexPatternStrings"
          ],
          members: {
            RegexPatternSetId: {},
            Name: {},
            RegexPatternStrings: {
              type: "list",
              member: {}
            }
          }
        },
        S1m: {
          type: "structure",
          required: [
            "RuleId",
            "Predicates"
          ],
          members: {
            RuleId: {},
            Name: {},
            MetricName: {},
            Predicates: {
              shape: "S16"
            }
          }
        },
        S1p: {
          type: "structure",
          required: [
            "RuleGroupId"
          ],
          members: {
            RuleGroupId: {},
            Name: {},
            MetricName: {}
          }
        },
        S1s: {
          type: "structure",
          required: [
            "SizeConstraintSetId",
            "SizeConstraints"
          ],
          members: {
            SizeConstraintSetId: {},
            Name: {},
            SizeConstraints: {
              type: "list",
              member: {
                shape: "S1u"
              }
            }
          }
        },
        S1u: {
          type: "structure",
          required: [
            "FieldToMatch",
            "TextTransformation",
            "ComparisonOperator",
            "Size"
          ],
          members: {
            FieldToMatch: {
              shape: "Sc"
            },
            TextTransformation: {},
            ComparisonOperator: {},
            Size: {
              type: "long"
            }
          }
        },
        S1z: {
          type: "structure",
          required: [
            "SqlInjectionMatchSetId",
            "SqlInjectionMatchTuples"
          ],
          members: {
            SqlInjectionMatchSetId: {},
            Name: {},
            SqlInjectionMatchTuples: {
              type: "list",
              member: {
                shape: "S21"
              }
            }
          }
        },
        S21: {
          type: "structure",
          required: [
            "FieldToMatch",
            "TextTransformation"
          ],
          members: {
            FieldToMatch: {
              shape: "Sc"
            },
            TextTransformation: {}
          }
        },
        S23: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Type: {}
          }
        },
        S26: {
          type: "structure",
          required: [
            "WebACLId",
            "DefaultAction",
            "Rules"
          ],
          members: {
            WebACLId: {},
            Name: {},
            MetricName: {},
            DefaultAction: {
              shape: "S23"
            },
            Rules: {
              shape: "S27"
            },
            WebACLArn: {}
          }
        },
        S27: {
          type: "list",
          member: {
            shape: "S28"
          }
        },
        S28: {
          type: "structure",
          required: [
            "Priority",
            "RuleId"
          ],
          members: {
            Priority: {
              type: "integer"
            },
            RuleId: {},
            Action: {
              shape: "S23"
            },
            OverrideAction: {
              type: "structure",
              required: [
                "Type"
              ],
              members: {
                Type: {}
              }
            },
            Type: {},
            ExcludedRules: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "RuleId"
                ],
                members: {
                  RuleId: {}
                }
              }
            }
          }
        },
        S2m: {
          type: "structure",
          required: [
            "XssMatchSetId",
            "XssMatchTuples"
          ],
          members: {
            XssMatchSetId: {},
            Name: {},
            XssMatchTuples: {
              type: "list",
              member: {
                shape: "S2o"
              }
            }
          }
        },
        S2o: {
          type: "structure",
          required: [
            "FieldToMatch",
            "TextTransformation"
          ],
          members: {
            FieldToMatch: {
              shape: "Sc"
            },
            TextTransformation: {}
          }
        },
        S3w: {
          type: "structure",
          required: [
            "ResourceArn",
            "LogDestinationConfigs"
          ],
          members: {
            ResourceArn: {},
            LogDestinationConfigs: {
              type: "list",
              member: {}
            },
            RedactedFields: {
              type: "list",
              member: {
                shape: "Sc"
              }
            }
          }
        },
        S4i: {
          type: "structure",
          required: [
            "StartTime",
            "EndTime"
          ],
          members: {
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            }
          }
        },
        S59: {
          type: "structure",
          required: [
            "WebACLId",
            "Name"
          ],
          members: {
            WebACLId: {},
            Name: {}
          }
        },
        S5w: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "RuleId",
              "Name"
            ],
            members: {
              RuleId: {},
              Name: {}
            }
          }
        },
        S7p: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Action",
              "Predicate"
            ],
            members: {
              Action: {},
              Predicate: {
                shape: "S17"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/waf-regional-2016-11-28.paginators.json
var require_waf_regional_2016_11_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/waf-regional-2016-11-28.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/wafregional.js
var require_wafregional = __commonJS({
  "node_modules/aws-sdk/clients/wafregional.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["wafregional"] = {};
    AWS3.WAFRegional = Service.defineService("wafregional", ["2016-11-28"]);
    Object.defineProperty(apiLoader.services["wafregional"], "2016-11-28", {
      get: function get() {
        var model = require_waf_regional_2016_11_28_min();
        model.paginators = require_waf_regional_2016_11_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.WAFRegional;
  }
});

// node_modules/aws-sdk/apis/workdocs-2016-05-01.min.json
var require_workdocs_2016_05_01_min = __commonJS({
  "node_modules/aws-sdk/apis/workdocs-2016-05-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2016-05-01",
        endpointPrefix: "workdocs",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon WorkDocs",
        serviceId: "WorkDocs",
        signatureVersion: "v4",
        uid: "workdocs-2016-05-01"
      },
      operations: {
        AbortDocumentVersionUpload: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/documents/{DocumentId}/versions/{VersionId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "DocumentId",
              "VersionId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              VersionId: {
                location: "uri",
                locationName: "VersionId"
              }
            }
          }
        },
        ActivateUser: {
          http: {
            requestUri: "/api/v1/users/{UserId}/activation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "UserId"
            ],
            members: {
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S8"
              }
            }
          }
        },
        AddResourcePermissions: {
          http: {
            requestUri: "/api/v1/resources/{ResourceId}/permissions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "Principals"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              Principals: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id",
                    "Type",
                    "Role"
                  ],
                  members: {
                    Id: {},
                    Type: {},
                    Role: {}
                  }
                }
              },
              NotificationOptions: {
                type: "structure",
                members: {
                  SendEmail: {
                    type: "boolean"
                  },
                  EmailMessage: {
                    shape: "St"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ShareResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PrincipalId: {},
                    InviteePrincipalId: {},
                    Role: {},
                    Status: {},
                    ShareId: {},
                    StatusMessage: {
                      shape: "St"
                    }
                  }
                }
              }
            }
          }
        },
        CreateComment: {
          http: {
            requestUri: "/api/v1/documents/{DocumentId}/versions/{VersionId}/comment",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DocumentId",
              "VersionId",
              "Text"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              VersionId: {
                location: "uri",
                locationName: "VersionId"
              },
              ParentId: {},
              ThreadId: {},
              Text: {
                shape: "S10"
              },
              Visibility: {},
              NotifyCollaborators: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Comment: {
                shape: "S13"
              }
            }
          }
        },
        CreateCustomMetadata: {
          http: {
            method: "PUT",
            requestUri: "/api/v1/resources/{ResourceId}/customMetadata",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "CustomMetadata"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionid"
              },
              CustomMetadata: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateFolder: {
          http: {
            requestUri: "/api/v1/folders",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ParentFolderId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              Name: {},
              ParentFolderId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Metadata: {
                shape: "S1d"
              }
            }
          }
        },
        CreateLabels: {
          http: {
            method: "PUT",
            requestUri: "/api/v1/resources/{ResourceId}/labels",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "Labels"
            ],
            members: {
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              Labels: {
                shape: "S1g"
              },
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateNotificationSubscription: {
          http: {
            requestUri: "/api/v1/organizations/{OrganizationId}/subscriptions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "Endpoint",
              "Protocol",
              "SubscriptionType"
            ],
            members: {
              OrganizationId: {
                location: "uri",
                locationName: "OrganizationId"
              },
              Endpoint: {},
              Protocol: {},
              SubscriptionType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Subscription: {
                shape: "S1p"
              }
            }
          }
        },
        CreateUser: {
          http: {
            requestUri: "/api/v1/users",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Username",
              "GivenName",
              "Surname",
              "Password"
            ],
            members: {
              OrganizationId: {},
              Username: {},
              EmailAddress: {},
              GivenName: {},
              Surname: {},
              Password: {
                type: "string",
                sensitive: true
              },
              TimeZoneId: {},
              StorageRule: {
                shape: "Sj"
              },
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S8"
              }
            }
          }
        },
        DeactivateUser: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/users/{UserId}/activation",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "UserId"
            ],
            members: {
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              }
            }
          }
        },
        DeleteComment: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/documents/{DocumentId}/versions/{VersionId}/comment/{CommentId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "DocumentId",
              "VersionId",
              "CommentId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              VersionId: {
                location: "uri",
                locationName: "VersionId"
              },
              CommentId: {
                location: "uri",
                locationName: "CommentId"
              }
            }
          }
        },
        DeleteCustomMetadata: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/resources/{ResourceId}/customMetadata",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              },
              Keys: {
                location: "querystring",
                locationName: "keys",
                type: "list",
                member: {}
              },
              DeleteAll: {
                location: "querystring",
                locationName: "deleteAll",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDocument: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/documents/{DocumentId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "DocumentId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              }
            }
          }
        },
        DeleteFolder: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/folders/{FolderId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FolderId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              }
            }
          }
        },
        DeleteFolderContents: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/folders/{FolderId}/contents",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "FolderId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              }
            }
          }
        },
        DeleteLabels: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/resources/{ResourceId}/labels",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              Labels: {
                shape: "S1g",
                location: "querystring",
                locationName: "labels"
              },
              DeleteAll: {
                location: "querystring",
                locationName: "deleteAll",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteNotificationSubscription: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/organizations/{OrganizationId}/subscriptions/{SubscriptionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SubscriptionId",
              "OrganizationId"
            ],
            members: {
              SubscriptionId: {
                location: "uri",
                locationName: "SubscriptionId"
              },
              OrganizationId: {
                location: "uri",
                locationName: "OrganizationId"
              }
            }
          }
        },
        DeleteUser: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/users/{UserId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "UserId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              UserId: {
                location: "uri",
                locationName: "UserId"
              }
            }
          }
        },
        DescribeActivities: {
          http: {
            method: "GET",
            requestUri: "/api/v1/activities",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              StartTime: {
                location: "querystring",
                locationName: "startTime",
                type: "timestamp"
              },
              EndTime: {
                location: "querystring",
                locationName: "endTime",
                type: "timestamp"
              },
              OrganizationId: {
                location: "querystring",
                locationName: "organizationId"
              },
              ActivityTypes: {
                location: "querystring",
                locationName: "activityTypes"
              },
              ResourceId: {
                location: "querystring",
                locationName: "resourceId"
              },
              UserId: {
                location: "querystring",
                locationName: "userId"
              },
              IncludeIndirectActivities: {
                location: "querystring",
                locationName: "includeIndirectActivities",
                type: "boolean"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserActivities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    TimeStamp: {
                      type: "timestamp"
                    },
                    IsIndirectActivity: {
                      type: "boolean"
                    },
                    OrganizationId: {},
                    Initiator: {
                      shape: "S2d"
                    },
                    Participants: {
                      type: "structure",
                      members: {
                        Users: {
                          type: "list",
                          member: {
                            shape: "S2d"
                          }
                        },
                        Groups: {
                          shape: "S2g"
                        }
                      }
                    },
                    ResourceMetadata: {
                      shape: "S2j"
                    },
                    OriginalParent: {
                      shape: "S2j"
                    },
                    CommentMetadata: {
                      type: "structure",
                      members: {
                        CommentId: {},
                        Contributor: {
                          shape: "S8"
                        },
                        CreatedTimestamp: {
                          type: "timestamp"
                        },
                        CommentStatus: {},
                        RecipientId: {}
                      }
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeComments: {
          http: {
            method: "GET",
            requestUri: "/api/v1/documents/{DocumentId}/versions/{VersionId}/comments",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DocumentId",
              "VersionId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              VersionId: {
                location: "uri",
                locationName: "VersionId"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Comments: {
                type: "list",
                member: {
                  shape: "S13"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeDocumentVersions: {
          http: {
            method: "GET",
            requestUri: "/api/v1/documents/{DocumentId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DocumentId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              Include: {
                location: "querystring",
                locationName: "include"
              },
              Fields: {
                location: "querystring",
                locationName: "fields"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentVersions: {
                type: "list",
                member: {
                  shape: "S2u"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeFolderContents: {
          http: {
            method: "GET",
            requestUri: "/api/v1/folders/{FolderId}/contents",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FolderId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              Sort: {
                location: "querystring",
                locationName: "sort"
              },
              Order: {
                location: "querystring",
                locationName: "order"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              },
              Type: {
                location: "querystring",
                locationName: "type"
              },
              Include: {
                location: "querystring",
                locationName: "include"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Folders: {
                shape: "S37"
              },
              Documents: {
                shape: "S38"
              },
              Marker: {}
            }
          }
        },
        DescribeGroups: {
          http: {
            method: "GET",
            requestUri: "/api/v1/groups",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SearchQuery"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              SearchQuery: {
                shape: "S3b",
                location: "querystring",
                locationName: "searchQuery"
              },
              OrganizationId: {
                location: "querystring",
                locationName: "organizationId"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Groups: {
                shape: "S2g"
              },
              Marker: {}
            }
          }
        },
        DescribeNotificationSubscriptions: {
          http: {
            method: "GET",
            requestUri: "/api/v1/organizations/{OrganizationId}/subscriptions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {
                location: "uri",
                locationName: "OrganizationId"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Subscriptions: {
                type: "list",
                member: {
                  shape: "S1p"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeResourcePermissions: {
          http: {
            method: "GET",
            requestUri: "/api/v1/resources/{ResourceId}/permissions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              PrincipalId: {
                location: "querystring",
                locationName: "principalId"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Principals: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Type: {},
                    Roles: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Role: {},
                          Type: {}
                        }
                      }
                    }
                  }
                }
              },
              Marker: {}
            }
          }
        },
        DescribeRootFolders: {
          http: {
            method: "GET",
            requestUri: "/api/v1/me/root",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AuthenticationToken"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Folders: {
                shape: "S37"
              },
              Marker: {}
            }
          }
        },
        DescribeUsers: {
          http: {
            method: "GET",
            requestUri: "/api/v1/users",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              OrganizationId: {
                location: "querystring",
                locationName: "organizationId"
              },
              UserIds: {
                location: "querystring",
                locationName: "userIds"
              },
              Query: {
                shape: "S3b",
                location: "querystring",
                locationName: "query"
              },
              Include: {
                location: "querystring",
                locationName: "include"
              },
              Order: {
                location: "querystring",
                locationName: "order"
              },
              Sort: {
                location: "querystring",
                locationName: "sort"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              Fields: {
                location: "querystring",
                locationName: "fields"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Users: {
                type: "list",
                member: {
                  shape: "S8"
                }
              },
              TotalNumberOfUsers: {
                deprecated: true,
                type: "long"
              },
              Marker: {}
            }
          }
        },
        GetCurrentUser: {
          http: {
            method: "GET",
            requestUri: "/api/v1/me",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AuthenticationToken"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S8"
              }
            }
          }
        },
        GetDocument: {
          http: {
            method: "GET",
            requestUri: "/api/v1/documents/{DocumentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DocumentId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              IncludeCustomMetadata: {
                location: "querystring",
                locationName: "includeCustomMetadata",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Metadata: {
                shape: "S39"
              },
              CustomMetadata: {
                shape: "S16"
              }
            }
          }
        },
        GetDocumentPath: {
          http: {
            method: "GET",
            requestUri: "/api/v1/documents/{DocumentId}/path",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DocumentId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              Fields: {
                location: "querystring",
                locationName: "fields"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Path: {
                shape: "S42"
              }
            }
          }
        },
        GetDocumentVersion: {
          http: {
            method: "GET",
            requestUri: "/api/v1/documents/{DocumentId}/versions/{VersionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DocumentId",
              "VersionId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              VersionId: {
                location: "uri",
                locationName: "VersionId"
              },
              Fields: {
                location: "querystring",
                locationName: "fields"
              },
              IncludeCustomMetadata: {
                location: "querystring",
                locationName: "includeCustomMetadata",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Metadata: {
                shape: "S2u"
              },
              CustomMetadata: {
                shape: "S16"
              }
            }
          }
        },
        GetFolder: {
          http: {
            method: "GET",
            requestUri: "/api/v1/folders/{FolderId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FolderId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              IncludeCustomMetadata: {
                location: "querystring",
                locationName: "includeCustomMetadata",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Metadata: {
                shape: "S1d"
              },
              CustomMetadata: {
                shape: "S16"
              }
            }
          }
        },
        GetFolderPath: {
          http: {
            method: "GET",
            requestUri: "/api/v1/folders/{FolderId}/path",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FolderId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              Fields: {
                location: "querystring",
                locationName: "fields"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Path: {
                shape: "S42"
              }
            }
          }
        },
        GetResources: {
          http: {
            method: "GET",
            requestUri: "/api/v1/resources",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              UserId: {
                location: "querystring",
                locationName: "userId"
              },
              CollectionType: {
                location: "querystring",
                locationName: "collectionType"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              Marker: {
                location: "querystring",
                locationName: "marker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Folders: {
                shape: "S37"
              },
              Documents: {
                shape: "S38"
              },
              Marker: {}
            }
          }
        },
        InitiateDocumentVersionUpload: {
          http: {
            requestUri: "/api/v1/documents",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ParentFolderId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              Id: {},
              Name: {},
              ContentCreatedTimestamp: {
                type: "timestamp"
              },
              ContentModifiedTimestamp: {
                type: "timestamp"
              },
              ContentType: {},
              DocumentSizeInBytes: {
                type: "long"
              },
              ParentFolderId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Metadata: {
                shape: "S39"
              },
              UploadMetadata: {
                type: "structure",
                members: {
                  UploadUrl: {
                    shape: "S2z"
                  },
                  SignedHeaders: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            }
          }
        },
        RemoveAllResourcePermissions: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/resources/{ResourceId}/permissions",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              }
            }
          }
        },
        RemoveResourcePermission: {
          http: {
            method: "DELETE",
            requestUri: "/api/v1/resources/{ResourceId}/permissions/{PrincipalId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "PrincipalId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              ResourceId: {
                location: "uri",
                locationName: "ResourceId"
              },
              PrincipalId: {
                location: "uri",
                locationName: "PrincipalId"
              },
              PrincipalType: {
                location: "querystring",
                locationName: "type"
              }
            }
          }
        },
        UpdateDocument: {
          http: {
            method: "PATCH",
            requestUri: "/api/v1/documents/{DocumentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DocumentId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              Name: {},
              ParentFolderId: {},
              ResourceState: {}
            }
          }
        },
        UpdateDocumentVersion: {
          http: {
            method: "PATCH",
            requestUri: "/api/v1/documents/{DocumentId}/versions/{VersionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DocumentId",
              "VersionId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              DocumentId: {
                location: "uri",
                locationName: "DocumentId"
              },
              VersionId: {
                location: "uri",
                locationName: "VersionId"
              },
              VersionStatus: {}
            }
          }
        },
        UpdateFolder: {
          http: {
            method: "PATCH",
            requestUri: "/api/v1/folders/{FolderId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FolderId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              Name: {},
              ParentFolderId: {},
              ResourceState: {}
            }
          }
        },
        UpdateUser: {
          http: {
            method: "PATCH",
            requestUri: "/api/v1/users/{UserId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "UserId"
            ],
            members: {
              AuthenticationToken: {
                shape: "S2",
                location: "header",
                locationName: "Authentication"
              },
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              GivenName: {},
              Surname: {},
              Type: {},
              StorageRule: {
                shape: "Sj"
              },
              TimeZoneId: {},
              Locale: {},
              GrantPoweruserPrivileges: {}
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S8"
              }
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "string",
          sensitive: true
        },
        S8: {
          type: "structure",
          members: {
            Id: {},
            Username: {},
            EmailAddress: {},
            GivenName: {},
            Surname: {},
            OrganizationId: {},
            RootFolderId: {},
            RecycleBinFolderId: {},
            Status: {},
            Type: {},
            CreatedTimestamp: {
              type: "timestamp"
            },
            ModifiedTimestamp: {
              type: "timestamp"
            },
            TimeZoneId: {},
            Locale: {},
            Storage: {
              type: "structure",
              members: {
                StorageUtilizedInBytes: {
                  type: "long"
                },
                StorageRule: {
                  shape: "Sj"
                }
              }
            }
          }
        },
        Sj: {
          type: "structure",
          members: {
            StorageAllocatedInBytes: {
              type: "long"
            },
            StorageType: {}
          }
        },
        St: {
          type: "string",
          sensitive: true
        },
        S10: {
          type: "string",
          sensitive: true
        },
        S13: {
          type: "structure",
          required: [
            "CommentId"
          ],
          members: {
            CommentId: {},
            ParentId: {},
            ThreadId: {},
            Text: {
              shape: "S10"
            },
            Contributor: {
              shape: "S8"
            },
            CreatedTimestamp: {
              type: "timestamp"
            },
            Status: {},
            Visibility: {},
            RecipientId: {}
          }
        },
        S16: {
          type: "map",
          key: {},
          value: {}
        },
        S1d: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            CreatorId: {},
            ParentFolderId: {},
            CreatedTimestamp: {
              type: "timestamp"
            },
            ModifiedTimestamp: {
              type: "timestamp"
            },
            ResourceState: {},
            Signature: {},
            Labels: {
              shape: "S1g"
            },
            Size: {
              type: "long"
            },
            LatestVersionSize: {
              type: "long"
            }
          }
        },
        S1g: {
          type: "list",
          member: {}
        },
        S1p: {
          type: "structure",
          members: {
            SubscriptionId: {},
            EndPoint: {},
            Protocol: {}
          }
        },
        S2d: {
          type: "structure",
          members: {
            Id: {},
            Username: {},
            GivenName: {},
            Surname: {},
            EmailAddress: {}
          }
        },
        S2g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {},
              Name: {}
            }
          }
        },
        S2j: {
          type: "structure",
          members: {
            Type: {},
            Name: {},
            OriginalName: {},
            Id: {},
            VersionId: {},
            Owner: {
              shape: "S2d"
            },
            ParentId: {}
          }
        },
        S2u: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            ContentType: {},
            Size: {
              type: "long"
            },
            Signature: {},
            Status: {},
            CreatedTimestamp: {
              type: "timestamp"
            },
            ModifiedTimestamp: {
              type: "timestamp"
            },
            ContentCreatedTimestamp: {
              type: "timestamp"
            },
            ContentModifiedTimestamp: {
              type: "timestamp"
            },
            CreatorId: {},
            Thumbnail: {
              type: "map",
              key: {},
              value: {
                shape: "S2z"
              }
            },
            Source: {
              type: "map",
              key: {},
              value: {
                shape: "S2z"
              }
            }
          }
        },
        S2z: {
          type: "string",
          sensitive: true
        },
        S37: {
          type: "list",
          member: {
            shape: "S1d"
          }
        },
        S38: {
          type: "list",
          member: {
            shape: "S39"
          }
        },
        S39: {
          type: "structure",
          members: {
            Id: {},
            CreatorId: {},
            ParentFolderId: {},
            CreatedTimestamp: {
              type: "timestamp"
            },
            ModifiedTimestamp: {
              type: "timestamp"
            },
            LatestVersionMetadata: {
              shape: "S2u"
            },
            ResourceState: {},
            Labels: {
              shape: "S1g"
            }
          }
        },
        S3b: {
          type: "string",
          sensitive: true
        },
        S42: {
          type: "structure",
          members: {
            Components: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Id: {},
                  Name: {}
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/workdocs-2016-05-01.paginators.json
var require_workdocs_2016_05_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/workdocs-2016-05-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeDocumentVersions: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "DocumentVersions"
        },
        DescribeFolderContents: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: [
            "Folders",
            "Documents"
          ]
        },
        DescribeUsers: {
          input_token: "Marker",
          limit_key: "Limit",
          output_token: "Marker",
          result_key: "Users"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/workdocs.js
var require_workdocs = __commonJS({
  "node_modules/aws-sdk/clients/workdocs.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["workdocs"] = {};
    AWS3.WorkDocs = Service.defineService("workdocs", ["2016-05-01"]);
    Object.defineProperty(apiLoader.services["workdocs"], "2016-05-01", {
      get: function get() {
        var model = require_workdocs_2016_05_01_min();
        model.paginators = require_workdocs_2016_05_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.WorkDocs;
  }
});

// node_modules/aws-sdk/apis/workspaces-2015-04-08.min.json
var require_workspaces_2015_04_08_min = __commonJS({
  "node_modules/aws-sdk/apis/workspaces-2015-04-08.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-04-08",
        endpointPrefix: "workspaces",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon WorkSpaces",
        serviceId: "WorkSpaces",
        signatureVersion: "v4",
        targetPrefix: "WorkspacesService",
        uid: "workspaces-2015-04-08"
      },
      operations: {
        AssociateConnectionAlias: {
          input: {
            type: "structure",
            required: [
              "AliasId",
              "ResourceId"
            ],
            members: {
              AliasId: {},
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionIdentifier: {}
            }
          }
        },
        AssociateIpGroups: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "GroupIds"
            ],
            members: {
              DirectoryId: {},
              GroupIds: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AuthorizeIpRules: {
          input: {
            type: "structure",
            required: [
              "GroupId",
              "UserRules"
            ],
            members: {
              GroupId: {},
              UserRules: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CopyWorkspaceImage: {
          input: {
            type: "structure",
            required: [
              "Name",
              "SourceImageId",
              "SourceRegion"
            ],
            members: {
              Name: {},
              Description: {},
              SourceImageId: {},
              SourceRegion: {},
              Tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageId: {}
            }
          }
        },
        CreateConnectionAlias: {
          input: {
            type: "structure",
            required: [
              "ConnectionString"
            ],
            members: {
              ConnectionString: {},
              Tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AliasId: {}
            }
          }
        },
        CreateIpGroup: {
          input: {
            type: "structure",
            required: [
              "GroupName"
            ],
            members: {
              GroupName: {},
              GroupDesc: {},
              UserRules: {
                shape: "Sc"
              },
              Tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupId: {}
            }
          }
        },
        CreateTags: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "Tags"
            ],
            members: {
              ResourceId: {},
              Tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateUpdatedWorkspaceImage: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Description",
              "SourceImageId"
            ],
            members: {
              Name: {},
              Description: {},
              SourceImageId: {},
              Tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageId: {}
            }
          }
        },
        CreateWorkspaceBundle: {
          input: {
            type: "structure",
            required: [
              "BundleName",
              "BundleDescription",
              "ImageId",
              "ComputeType",
              "UserStorage"
            ],
            members: {
              BundleName: {},
              BundleDescription: {},
              ImageId: {},
              ComputeType: {
                shape: "S15"
              },
              UserStorage: {
                shape: "S17"
              },
              RootStorage: {
                shape: "S18"
              },
              Tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkspaceBundle: {
                shape: "S1a"
              }
            }
          }
        },
        CreateWorkspaces: {
          input: {
            type: "structure",
            required: [
              "Workspaces"
            ],
            members: {
              Workspaces: {
                type: "list",
                member: {
                  shape: "S1h"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedRequests: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WorkspaceRequest: {
                      shape: "S1h"
                    },
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              },
              PendingRequests: {
                shape: "S1u"
              }
            }
          }
        },
        DeleteConnectionAlias: {
          input: {
            type: "structure",
            required: [
              "AliasId"
            ],
            members: {
              AliasId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteIpGroup: {
          input: {
            type: "structure",
            required: [
              "GroupId"
            ],
            members: {
              GroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTags: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "TagKeys"
            ],
            members: {
              ResourceId: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWorkspaceBundle: {
          input: {
            type: "structure",
            members: {
              BundleId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWorkspaceImage: {
          input: {
            type: "structure",
            required: [
              "ImageId"
            ],
            members: {
              ImageId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterWorkspaceDirectory: {
          input: {
            type: "structure",
            required: [
              "DirectoryId"
            ],
            members: {
              DirectoryId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeAccount: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              DedicatedTenancySupport: {},
              DedicatedTenancyManagementCidrRange: {}
            }
          }
        },
        DescribeAccountModifications: {
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccountModifications: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ModificationState: {},
                    DedicatedTenancySupport: {},
                    DedicatedTenancyManagementCidrRange: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeClientProperties: {
          input: {
            type: "structure",
            required: [
              "ResourceIds"
            ],
            members: {
              ResourceIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClientPropertiesList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceId: {},
                    ClientProperties: {
                      shape: "S2y"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeConnectionAliasPermissions: {
          input: {
            type: "structure",
            required: [
              "AliasId"
            ],
            members: {
              AliasId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AliasId: {},
              ConnectionAliasPermissions: {
                type: "list",
                member: {
                  shape: "S34"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeConnectionAliases: {
          input: {
            type: "structure",
            members: {
              AliasIds: {
                type: "list",
                member: {}
              },
              ResourceId: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionAliases: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConnectionString: {},
                    AliasId: {},
                    State: {},
                    OwnerAccountId: {},
                    Associations: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          AssociationStatus: {},
                          AssociatedAccountId: {},
                          ResourceId: {},
                          ConnectionIdentifier: {}
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeIpGroups: {
          input: {
            type: "structure",
            members: {
              GroupIds: {
                shape: "S8"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Result: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    groupId: {},
                    groupName: {},
                    groupDesc: {},
                    userRules: {
                      shape: "Sc"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeTags: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "Sm"
              }
            }
          }
        },
        DescribeWorkspaceBundles: {
          input: {
            type: "structure",
            members: {
              BundleIds: {
                type: "list",
                member: {}
              },
              Owner: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Bundles: {
                type: "list",
                member: {
                  shape: "S1a"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeWorkspaceDirectories: {
          input: {
            type: "structure",
            members: {
              DirectoryIds: {
                type: "list",
                member: {}
              },
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Directories: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DirectoryId: {},
                    Alias: {},
                    DirectoryName: {},
                    RegistrationCode: {},
                    SubnetIds: {
                      shape: "S3x"
                    },
                    DnsIpAddresses: {
                      type: "list",
                      member: {}
                    },
                    CustomerUserName: {},
                    IamRoleId: {},
                    DirectoryType: {},
                    WorkspaceSecurityGroupId: {},
                    State: {},
                    WorkspaceCreationProperties: {
                      type: "structure",
                      members: {
                        EnableWorkDocs: {
                          type: "boolean"
                        },
                        EnableInternetAccess: {
                          type: "boolean"
                        },
                        DefaultOu: {},
                        CustomSecurityGroupId: {},
                        UserEnabledAsLocalAdministrator: {
                          type: "boolean"
                        },
                        EnableMaintenanceMode: {
                          type: "boolean"
                        }
                      }
                    },
                    ipGroupIds: {
                      shape: "S8"
                    },
                    WorkspaceAccessProperties: {
                      shape: "S45"
                    },
                    Tenancy: {},
                    SelfservicePermissions: {
                      shape: "S48"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeWorkspaceImagePermissions: {
          input: {
            type: "structure",
            required: [
              "ImageId"
            ],
            members: {
              ImageId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageId: {},
              ImagePermissions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SharedAccountId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeWorkspaceImages: {
          input: {
            type: "structure",
            members: {
              ImageIds: {
                type: "list",
                member: {}
              },
              ImageType: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Images: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ImageId: {},
                    Name: {},
                    Description: {},
                    OperatingSystem: {
                      type: "structure",
                      members: {
                        Type: {}
                      }
                    },
                    State: {},
                    RequiredTenancy: {},
                    ErrorCode: {},
                    ErrorMessage: {},
                    Created: {
                      type: "timestamp"
                    },
                    OwnerAccountId: {},
                    Updates: {
                      type: "structure",
                      members: {
                        UpdateAvailable: {
                          type: "boolean"
                        },
                        Description: {}
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeWorkspaceSnapshots: {
          input: {
            type: "structure",
            required: [
              "WorkspaceId"
            ],
            members: {
              WorkspaceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RebuildSnapshots: {
                shape: "S4s"
              },
              RestoreSnapshots: {
                shape: "S4s"
              }
            }
          }
        },
        DescribeWorkspaces: {
          input: {
            type: "structure",
            members: {
              WorkspaceIds: {
                shape: "S4v"
              },
              DirectoryId: {},
              UserName: {},
              BundleId: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Workspaces: {
                shape: "S1u"
              },
              NextToken: {}
            }
          }
        },
        DescribeWorkspacesConnectionStatus: {
          input: {
            type: "structure",
            members: {
              WorkspaceIds: {
                shape: "S4v"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WorkspacesConnectionStatus: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WorkspaceId: {},
                    ConnectionState: {},
                    ConnectionStateCheckTimestamp: {
                      type: "timestamp"
                    },
                    LastKnownUserConnectionTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DisassociateConnectionAlias: {
          input: {
            type: "structure",
            required: [
              "AliasId"
            ],
            members: {
              AliasId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateIpGroups: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "GroupIds"
            ],
            members: {
              DirectoryId: {},
              GroupIds: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ImportWorkspaceImage: {
          input: {
            type: "structure",
            required: [
              "Ec2ImageId",
              "IngestionProcess",
              "ImageName",
              "ImageDescription"
            ],
            members: {
              Ec2ImageId: {},
              IngestionProcess: {},
              ImageName: {},
              ImageDescription: {},
              Tags: {
                shape: "Sm"
              },
              Applications: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageId: {}
            }
          }
        },
        ListAvailableManagementCidrRanges: {
          input: {
            type: "structure",
            required: [
              "ManagementCidrRangeConstraint"
            ],
            members: {
              ManagementCidrRangeConstraint: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ManagementCidrRanges: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        MigrateWorkspace: {
          input: {
            type: "structure",
            required: [
              "SourceWorkspaceId",
              "BundleId"
            ],
            members: {
              SourceWorkspaceId: {},
              BundleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SourceWorkspaceId: {},
              TargetWorkspaceId: {}
            }
          }
        },
        ModifyAccount: {
          input: {
            type: "structure",
            members: {
              DedicatedTenancySupport: {},
              DedicatedTenancyManagementCidrRange: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ModifyClientProperties: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "ClientProperties"
            ],
            members: {
              ResourceId: {},
              ClientProperties: {
                shape: "S2y"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ModifySelfservicePermissions: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "SelfservicePermissions"
            ],
            members: {
              ResourceId: {},
              SelfservicePermissions: {
                shape: "S48"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ModifyWorkspaceAccessProperties: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "WorkspaceAccessProperties"
            ],
            members: {
              ResourceId: {},
              WorkspaceAccessProperties: {
                shape: "S45"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ModifyWorkspaceCreationProperties: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "WorkspaceCreationProperties"
            ],
            members: {
              ResourceId: {},
              WorkspaceCreationProperties: {
                type: "structure",
                members: {
                  EnableWorkDocs: {
                    type: "boolean"
                  },
                  EnableInternetAccess: {
                    type: "boolean"
                  },
                  DefaultOu: {},
                  CustomSecurityGroupId: {},
                  UserEnabledAsLocalAdministrator: {
                    type: "boolean"
                  },
                  EnableMaintenanceMode: {
                    type: "boolean"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ModifyWorkspaceProperties: {
          input: {
            type: "structure",
            required: [
              "WorkspaceId",
              "WorkspaceProperties"
            ],
            members: {
              WorkspaceId: {},
              WorkspaceProperties: {
                shape: "S1l"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ModifyWorkspaceState: {
          input: {
            type: "structure",
            required: [
              "WorkspaceId",
              "WorkspaceState"
            ],
            members: {
              WorkspaceId: {},
              WorkspaceState: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RebootWorkspaces: {
          input: {
            type: "structure",
            required: [
              "RebootWorkspaceRequests"
            ],
            members: {
              RebootWorkspaceRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "WorkspaceId"
                  ],
                  members: {
                    WorkspaceId: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedRequests: {
                type: "list",
                member: {
                  shape: "S65"
                }
              }
            }
          }
        },
        RebuildWorkspaces: {
          input: {
            type: "structure",
            required: [
              "RebuildWorkspaceRequests"
            ],
            members: {
              RebuildWorkspaceRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "WorkspaceId"
                  ],
                  members: {
                    WorkspaceId: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedRequests: {
                type: "list",
                member: {
                  shape: "S65"
                }
              }
            }
          }
        },
        RegisterWorkspaceDirectory: {
          input: {
            type: "structure",
            required: [
              "DirectoryId",
              "EnableWorkDocs"
            ],
            members: {
              DirectoryId: {},
              SubnetIds: {
                shape: "S3x"
              },
              EnableWorkDocs: {
                type: "boolean"
              },
              EnableSelfService: {
                type: "boolean"
              },
              Tenancy: {},
              Tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RestoreWorkspace: {
          input: {
            type: "structure",
            required: [
              "WorkspaceId"
            ],
            members: {
              WorkspaceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RevokeIpRules: {
          input: {
            type: "structure",
            required: [
              "GroupId",
              "UserRules"
            ],
            members: {
              GroupId: {},
              UserRules: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartWorkspaces: {
          input: {
            type: "structure",
            required: [
              "StartWorkspaceRequests"
            ],
            members: {
              StartWorkspaceRequests: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WorkspaceId: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedRequests: {
                type: "list",
                member: {
                  shape: "S65"
                }
              }
            }
          }
        },
        StopWorkspaces: {
          input: {
            type: "structure",
            required: [
              "StopWorkspaceRequests"
            ],
            members: {
              StopWorkspaceRequests: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WorkspaceId: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedRequests: {
                type: "list",
                member: {
                  shape: "S65"
                }
              }
            }
          }
        },
        TerminateWorkspaces: {
          input: {
            type: "structure",
            required: [
              "TerminateWorkspaceRequests"
            ],
            members: {
              TerminateWorkspaceRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "WorkspaceId"
                  ],
                  members: {
                    WorkspaceId: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedRequests: {
                type: "list",
                member: {
                  shape: "S65"
                }
              }
            }
          }
        },
        UpdateConnectionAliasPermission: {
          input: {
            type: "structure",
            required: [
              "AliasId",
              "ConnectionAliasPermission"
            ],
            members: {
              AliasId: {},
              ConnectionAliasPermission: {
                shape: "S34"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRulesOfIpGroup: {
          input: {
            type: "structure",
            required: [
              "GroupId",
              "UserRules"
            ],
            members: {
              GroupId: {},
              UserRules: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateWorkspaceBundle: {
          input: {
            type: "structure",
            members: {
              BundleId: {},
              ImageId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateWorkspaceImagePermission: {
          input: {
            type: "structure",
            required: [
              "ImageId",
              "AllowCopyImage",
              "SharedAccountId"
            ],
            members: {
              ImageId: {},
              AllowCopyImage: {
                type: "boolean"
              },
              SharedAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S8: {
          type: "list",
          member: {}
        },
        Sc: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ipRule: {},
              ruleDesc: {}
            }
          }
        },
        Sm: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S15: {
          type: "structure",
          members: {
            Name: {}
          }
        },
        S17: {
          type: "structure",
          members: {
            Capacity: {}
          }
        },
        S18: {
          type: "structure",
          members: {
            Capacity: {}
          }
        },
        S1a: {
          type: "structure",
          members: {
            BundleId: {},
            Name: {},
            Owner: {},
            Description: {},
            ImageId: {},
            RootStorage: {
              shape: "S18"
            },
            UserStorage: {
              shape: "S17"
            },
            ComputeType: {
              shape: "S15"
            },
            LastUpdatedTime: {
              type: "timestamp"
            },
            CreationTime: {
              type: "timestamp"
            }
          }
        },
        S1h: {
          type: "structure",
          required: [
            "DirectoryId",
            "UserName",
            "BundleId"
          ],
          members: {
            DirectoryId: {},
            UserName: {},
            BundleId: {},
            VolumeEncryptionKey: {},
            UserVolumeEncryptionEnabled: {
              type: "boolean"
            },
            RootVolumeEncryptionEnabled: {
              type: "boolean"
            },
            WorkspaceProperties: {
              shape: "S1l"
            },
            Tags: {
              shape: "Sm"
            }
          }
        },
        S1l: {
          type: "structure",
          members: {
            RunningMode: {},
            RunningModeAutoStopTimeoutInMinutes: {
              type: "integer"
            },
            RootVolumeSizeGib: {
              type: "integer"
            },
            UserVolumeSizeGib: {
              type: "integer"
            },
            ComputeTypeName: {}
          }
        },
        S1u: {
          type: "list",
          member: {
            type: "structure",
            members: {
              WorkspaceId: {},
              DirectoryId: {},
              UserName: {},
              IpAddress: {},
              State: {},
              BundleId: {},
              SubnetId: {},
              ErrorMessage: {},
              ErrorCode: {},
              ComputerName: {},
              VolumeEncryptionKey: {},
              UserVolumeEncryptionEnabled: {
                type: "boolean"
              },
              RootVolumeEncryptionEnabled: {
                type: "boolean"
              },
              WorkspaceProperties: {
                shape: "S1l"
              },
              ModificationStates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Resource: {},
                    State: {}
                  }
                }
              }
            }
          }
        },
        S2y: {
          type: "structure",
          members: {
            ReconnectEnabled: {}
          }
        },
        S34: {
          type: "structure",
          required: [
            "SharedAccountId",
            "AllowAssociation"
          ],
          members: {
            SharedAccountId: {},
            AllowAssociation: {
              type: "boolean"
            }
          }
        },
        S3x: {
          type: "list",
          member: {}
        },
        S45: {
          type: "structure",
          members: {
            DeviceTypeWindows: {},
            DeviceTypeOsx: {},
            DeviceTypeWeb: {},
            DeviceTypeIos: {},
            DeviceTypeAndroid: {},
            DeviceTypeChromeOs: {},
            DeviceTypeZeroClient: {},
            DeviceTypeLinux: {}
          }
        },
        S48: {
          type: "structure",
          members: {
            RestartWorkspace: {},
            IncreaseVolumeSize: {},
            ChangeComputeType: {},
            SwitchRunningMode: {},
            RebuildWorkspace: {}
          }
        },
        S4s: {
          type: "list",
          member: {
            type: "structure",
            members: {
              SnapshotTime: {
                type: "timestamp"
              }
            }
          }
        },
        S4v: {
          type: "list",
          member: {}
        },
        S65: {
          type: "structure",
          members: {
            WorkspaceId: {},
            ErrorCode: {},
            ErrorMessage: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/workspaces-2015-04-08.paginators.json
var require_workspaces_2015_04_08_paginators = __commonJS({
  "node_modules/aws-sdk/apis/workspaces-2015-04-08.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeWorkspaceBundles: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Bundles"
        },
        DescribeWorkspaceDirectories: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Directories"
        },
        DescribeWorkspaces: {
          input_token: "NextToken",
          limit_key: "Limit",
          output_token: "NextToken",
          result_key: "Workspaces"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/workspaces.js
var require_workspaces = __commonJS({
  "node_modules/aws-sdk/clients/workspaces.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["workspaces"] = {};
    AWS3.WorkSpaces = Service.defineService("workspaces", ["2015-04-08"]);
    Object.defineProperty(apiLoader.services["workspaces"], "2015-04-08", {
      get: function get() {
        var model = require_workspaces_2015_04_08_min();
        model.paginators = require_workspaces_2015_04_08_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.WorkSpaces;
  }
});

// node_modules/aws-sdk/apis/codestar-2017-04-19.min.json
var require_codestar_2017_04_19_min = __commonJS({
  "node_modules/aws-sdk/apis/codestar-2017-04-19.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-04-19",
        endpointPrefix: "codestar",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "CodeStar",
        serviceFullName: "AWS CodeStar",
        serviceId: "CodeStar",
        signatureVersion: "v4",
        targetPrefix: "CodeStar_20170419",
        uid: "codestar-2017-04-19"
      },
      operations: {
        AssociateTeamMember: {
          input: {
            type: "structure",
            required: [
              "projectId",
              "userArn",
              "projectRole"
            ],
            members: {
              projectId: {},
              clientRequestToken: {},
              userArn: {},
              projectRole: {},
              remoteAccessAllowed: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              clientRequestToken: {}
            }
          }
        },
        CreateProject: {
          input: {
            type: "structure",
            required: [
              "name",
              "id"
            ],
            members: {
              name: {
                shape: "S9"
              },
              id: {},
              description: {
                shape: "Sa"
              },
              clientRequestToken: {},
              sourceCode: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "source",
                    "destination"
                  ],
                  members: {
                    source: {
                      type: "structure",
                      required: [
                        "s3"
                      ],
                      members: {
                        s3: {
                          shape: "Se"
                        }
                      }
                    },
                    destination: {
                      type: "structure",
                      members: {
                        codeCommit: {
                          type: "structure",
                          required: [
                            "name"
                          ],
                          members: {
                            name: {}
                          }
                        },
                        gitHub: {
                          type: "structure",
                          required: [
                            "name",
                            "type",
                            "owner",
                            "privateRepository",
                            "issuesEnabled",
                            "token"
                          ],
                          members: {
                            name: {},
                            description: {},
                            type: {},
                            owner: {},
                            privateRepository: {
                              type: "boolean"
                            },
                            issuesEnabled: {
                              type: "boolean"
                            },
                            token: {
                              type: "string",
                              sensitive: true
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              toolchain: {
                type: "structure",
                required: [
                  "source"
                ],
                members: {
                  source: {
                    type: "structure",
                    required: [
                      "s3"
                    ],
                    members: {
                      s3: {
                        shape: "Se"
                      }
                    }
                  },
                  roleArn: {},
                  stackParameters: {
                    type: "map",
                    key: {},
                    value: {
                      type: "string",
                      sensitive: true
                    }
                  }
                }
              },
              tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id",
              "arn"
            ],
            members: {
              id: {},
              arn: {},
              clientRequestToken: {},
              projectTemplateId: {}
            }
          }
        },
        CreateUserProfile: {
          input: {
            type: "structure",
            required: [
              "userArn",
              "displayName",
              "emailAddress"
            ],
            members: {
              userArn: {},
              displayName: {
                shape: "S14"
              },
              emailAddress: {
                shape: "S15"
              },
              sshPublicKey: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "userArn"
            ],
            members: {
              userArn: {},
              displayName: {
                shape: "S14"
              },
              emailAddress: {
                shape: "S15"
              },
              sshPublicKey: {},
              createdTimestamp: {
                type: "timestamp"
              },
              lastModifiedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteProject: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {},
              clientRequestToken: {},
              deleteStack: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              stackId: {},
              projectArn: {}
            }
          }
        },
        DeleteUserProfile: {
          input: {
            type: "structure",
            required: [
              "userArn"
            ],
            members: {
              userArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "userArn"
            ],
            members: {
              userArn: {}
            }
          }
        },
        DescribeProject: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              name: {
                shape: "S9"
              },
              id: {},
              arn: {},
              description: {
                shape: "Sa"
              },
              clientRequestToken: {},
              createdTimeStamp: {
                type: "timestamp"
              },
              stackId: {},
              projectTemplateId: {},
              status: {
                type: "structure",
                required: [
                  "state"
                ],
                members: {
                  state: {},
                  reason: {}
                }
              }
            }
          }
        },
        DescribeUserProfile: {
          input: {
            type: "structure",
            required: [
              "userArn"
            ],
            members: {
              userArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "userArn",
              "createdTimestamp",
              "lastModifiedTimestamp"
            ],
            members: {
              userArn: {},
              displayName: {
                shape: "S14"
              },
              emailAddress: {
                shape: "S15"
              },
              sshPublicKey: {},
              createdTimestamp: {
                type: "timestamp"
              },
              lastModifiedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        DisassociateTeamMember: {
          input: {
            type: "structure",
            required: [
              "projectId",
              "userArn"
            ],
            members: {
              projectId: {},
              userArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListProjects: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "projects"
            ],
            members: {
              projects: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    projectId: {},
                    projectArn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListResources: {
          input: {
            type: "structure",
            required: [
              "projectId"
            ],
            members: {
              projectId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resources: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id"
                  ],
                  members: {
                    id: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForProject: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sx"
              },
              nextToken: {}
            }
          }
        },
        ListTeamMembers: {
          input: {
            type: "structure",
            required: [
              "projectId"
            ],
            members: {
              projectId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "teamMembers"
            ],
            members: {
              teamMembers: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "userArn",
                    "projectRole"
                  ],
                  members: {
                    userArn: {},
                    projectRole: {},
                    remoteAccessAllowed: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListUserProfiles: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "userProfiles"
            ],
            members: {
              userProfiles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    userArn: {},
                    displayName: {
                      shape: "S14"
                    },
                    emailAddress: {
                      shape: "S15"
                    },
                    sshPublicKey: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        TagProject: {
          input: {
            type: "structure",
            required: [
              "id",
              "tags"
            ],
            members: {
              id: {},
              tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sx"
              }
            }
          }
        },
        UntagProject: {
          input: {
            type: "structure",
            required: [
              "id",
              "tags"
            ],
            members: {
              id: {},
              tags: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateProject: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {},
              name: {
                shape: "S9"
              },
              description: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateTeamMember: {
          input: {
            type: "structure",
            required: [
              "projectId",
              "userArn"
            ],
            members: {
              projectId: {},
              userArn: {},
              projectRole: {},
              remoteAccessAllowed: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              userArn: {},
              projectRole: {},
              remoteAccessAllowed: {
                type: "boolean"
              }
            }
          }
        },
        UpdateUserProfile: {
          input: {
            type: "structure",
            required: [
              "userArn"
            ],
            members: {
              userArn: {},
              displayName: {
                shape: "S14"
              },
              emailAddress: {
                shape: "S15"
              },
              sshPublicKey: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "userArn"
            ],
            members: {
              userArn: {},
              displayName: {
                shape: "S14"
              },
              emailAddress: {
                shape: "S15"
              },
              sshPublicKey: {},
              createdTimestamp: {
                type: "timestamp"
              },
              lastModifiedTimestamp: {
                type: "timestamp"
              }
            }
          }
        }
      },
      shapes: {
        S9: {
          type: "string",
          sensitive: true
        },
        Sa: {
          type: "string",
          sensitive: true
        },
        Se: {
          type: "structure",
          members: {
            bucketName: {},
            bucketKey: {}
          }
        },
        Sx: {
          type: "map",
          key: {},
          value: {}
        },
        S14: {
          type: "string",
          sensitive: true
        },
        S15: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codestar-2017-04-19.paginators.json
var require_codestar_2017_04_19_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codestar-2017-04-19.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/codestar.js
var require_codestar = __commonJS({
  "node_modules/aws-sdk/clients/codestar.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["codestar"] = {};
    AWS3.CodeStar = Service.defineService("codestar", ["2017-04-19"]);
    Object.defineProperty(apiLoader.services["codestar"], "2017-04-19", {
      get: function get() {
        var model = require_codestar_2017_04_19_min();
        model.paginators = require_codestar_2017_04_19_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CodeStar;
  }
});

// node_modules/aws-sdk/apis/lex-models-2017-04-19.min.json
var require_lex_models_2017_04_19_min = __commonJS({
  "node_modules/aws-sdk/apis/lex-models-2017-04-19.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-04-19",
        endpointPrefix: "models.lex",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Lex Model Building Service",
        serviceId: "Lex Model Building Service",
        signatureVersion: "v4",
        signingName: "lex",
        uid: "lex-models-2017-04-19"
      },
      operations: {
        CreateBotVersion: {
          http: {
            requestUri: "/bots/{name}/versions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              checksum: {}
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              intents: {
                shape: "S6"
              },
              clarificationPrompt: {
                shape: "Sa"
              },
              abortStatement: {
                shape: "Si"
              },
              status: {},
              failureReason: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              voiceId: {},
              checksum: {},
              version: {},
              locale: {},
              childDirected: {
                type: "boolean"
              },
              enableModelImprovements: {
                type: "boolean"
              },
              detectSentiment: {
                type: "boolean"
              }
            }
          }
        },
        CreateIntentVersion: {
          http: {
            requestUri: "/intents/{name}/versions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              checksum: {}
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              slots: {
                shape: "Sq"
              },
              sampleUtterances: {
                shape: "S13"
              },
              confirmationPrompt: {
                shape: "Sa"
              },
              rejectionStatement: {
                shape: "Si"
              },
              followUpPrompt: {
                shape: "S14"
              },
              conclusionStatement: {
                shape: "Si"
              },
              dialogCodeHook: {
                shape: "S15"
              },
              fulfillmentActivity: {
                shape: "S18"
              },
              parentIntentSignature: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              version: {},
              checksum: {},
              kendraConfiguration: {
                shape: "S1b"
              },
              inputContexts: {
                shape: "S1f"
              },
              outputContexts: {
                shape: "S1i"
              }
            }
          }
        },
        CreateSlotTypeVersion: {
          http: {
            requestUri: "/slottypes/{name}/versions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              checksum: {}
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              enumerationValues: {
                shape: "S1q"
              },
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              version: {},
              checksum: {},
              valueSelectionStrategy: {},
              parentSlotTypeSignature: {},
              slotTypeConfigurations: {
                shape: "S1v"
              }
            }
          }
        },
        DeleteBot: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          }
        },
        DeleteBotAlias: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botName}/aliases/{name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "name",
              "botName"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              botName: {
                location: "uri",
                locationName: "botName"
              }
            }
          }
        },
        DeleteBotChannelAssociation: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botName}/aliases/{aliasName}/channels/{name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "name",
              "botName",
              "botAlias"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              botName: {
                location: "uri",
                locationName: "botName"
              },
              botAlias: {
                location: "uri",
                locationName: "aliasName"
              }
            }
          }
        },
        DeleteBotVersion: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{name}/versions/{version}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "name",
              "version"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              version: {
                location: "uri",
                locationName: "version"
              }
            }
          }
        },
        DeleteIntent: {
          http: {
            method: "DELETE",
            requestUri: "/intents/{name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          }
        },
        DeleteIntentVersion: {
          http: {
            method: "DELETE",
            requestUri: "/intents/{name}/versions/{version}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "name",
              "version"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              version: {
                location: "uri",
                locationName: "version"
              }
            }
          }
        },
        DeleteSlotType: {
          http: {
            method: "DELETE",
            requestUri: "/slottypes/{name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          }
        },
        DeleteSlotTypeVersion: {
          http: {
            method: "DELETE",
            requestUri: "/slottypes/{name}/version/{version}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "name",
              "version"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              version: {
                location: "uri",
                locationName: "version"
              }
            }
          }
        },
        DeleteUtterances: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botName}/utterances/{userId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "botName",
              "userId"
            ],
            members: {
              botName: {
                location: "uri",
                locationName: "botName"
              },
              userId: {
                location: "uri",
                locationName: "userId"
              }
            }
          }
        },
        GetBot: {
          http: {
            method: "GET",
            requestUri: "/bots/{name}/versions/{versionoralias}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "versionOrAlias"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              versionOrAlias: {
                location: "uri",
                locationName: "versionoralias"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              intents: {
                shape: "S6"
              },
              enableModelImprovements: {
                type: "boolean"
              },
              nluIntentConfidenceThreshold: {
                type: "double"
              },
              clarificationPrompt: {
                shape: "Sa"
              },
              abortStatement: {
                shape: "Si"
              },
              status: {},
              failureReason: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              voiceId: {},
              checksum: {},
              version: {},
              locale: {},
              childDirected: {
                type: "boolean"
              },
              detectSentiment: {
                type: "boolean"
              }
            }
          }
        },
        GetBotAlias: {
          http: {
            method: "GET",
            requestUri: "/bots/{botName}/aliases/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "botName"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              botName: {
                location: "uri",
                locationName: "botName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              botVersion: {},
              botName: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              checksum: {},
              conversationLogs: {
                shape: "S2h"
              }
            }
          }
        },
        GetBotAliases: {
          http: {
            method: "GET",
            requestUri: "/bots/{botName}/aliases/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botName"
            ],
            members: {
              botName: {
                location: "uri",
                locationName: "botName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nameContains: {
                location: "querystring",
                locationName: "nameContains"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BotAliases: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    description: {},
                    botVersion: {},
                    botName: {},
                    lastUpdatedDate: {
                      type: "timestamp"
                    },
                    createdDate: {
                      type: "timestamp"
                    },
                    checksum: {},
                    conversationLogs: {
                      shape: "S2h"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetBotChannelAssociation: {
          http: {
            method: "GET",
            requestUri: "/bots/{botName}/aliases/{aliasName}/channels/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "botName",
              "botAlias"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              botName: {
                location: "uri",
                locationName: "botName"
              },
              botAlias: {
                location: "uri",
                locationName: "aliasName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              botAlias: {},
              botName: {},
              createdDate: {
                type: "timestamp"
              },
              type: {},
              botConfiguration: {
                shape: "S2z"
              },
              status: {},
              failureReason: {}
            }
          }
        },
        GetBotChannelAssociations: {
          http: {
            method: "GET",
            requestUri: "/bots/{botName}/aliases/{aliasName}/channels/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botName",
              "botAlias"
            ],
            members: {
              botName: {
                location: "uri",
                locationName: "botName"
              },
              botAlias: {
                location: "uri",
                locationName: "aliasName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nameContains: {
                location: "querystring",
                locationName: "nameContains"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botChannelAssociations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    description: {},
                    botAlias: {},
                    botName: {},
                    createdDate: {
                      type: "timestamp"
                    },
                    type: {},
                    botConfiguration: {
                      shape: "S2z"
                    },
                    status: {},
                    failureReason: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetBotVersions: {
          http: {
            method: "GET",
            requestUri: "/bots/{name}/versions/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              bots: {
                shape: "S38"
              },
              nextToken: {}
            }
          }
        },
        GetBots: {
          http: {
            method: "GET",
            requestUri: "/bots/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nameContains: {
                location: "querystring",
                locationName: "nameContains"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              bots: {
                shape: "S38"
              },
              nextToken: {}
            }
          }
        },
        GetBuiltinIntent: {
          http: {
            method: "GET",
            requestUri: "/builtins/intents/{signature}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "signature"
            ],
            members: {
              signature: {
                location: "uri",
                locationName: "signature"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              signature: {},
              supportedLocales: {
                shape: "S3e"
              },
              slots: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {}
                  }
                }
              }
            }
          }
        },
        GetBuiltinIntents: {
          http: {
            method: "GET",
            requestUri: "/builtins/intents/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              locale: {
                location: "querystring",
                locationName: "locale"
              },
              signatureContains: {
                location: "querystring",
                locationName: "signatureContains"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              intents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    signature: {},
                    supportedLocales: {
                      shape: "S3e"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetBuiltinSlotTypes: {
          http: {
            method: "GET",
            requestUri: "/builtins/slottypes/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              locale: {
                location: "querystring",
                locationName: "locale"
              },
              signatureContains: {
                location: "querystring",
                locationName: "signatureContains"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              slotTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    signature: {},
                    supportedLocales: {
                      shape: "S3e"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetExport: {
          http: {
            method: "GET",
            requestUri: "/exports/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "version",
              "resourceType",
              "exportType"
            ],
            members: {
              name: {
                location: "querystring",
                locationName: "name"
              },
              version: {
                location: "querystring",
                locationName: "version"
              },
              resourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              exportType: {
                location: "querystring",
                locationName: "exportType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              version: {},
              resourceType: {},
              exportType: {},
              exportStatus: {},
              failureReason: {},
              url: {}
            }
          }
        },
        GetImport: {
          http: {
            method: "GET",
            requestUri: "/imports/{importId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "importId"
            ],
            members: {
              importId: {
                location: "uri",
                locationName: "importId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              resourceType: {},
              mergeStrategy: {},
              importId: {},
              importStatus: {},
              failureReason: {
                type: "list",
                member: {}
              },
              createdDate: {
                type: "timestamp"
              }
            }
          }
        },
        GetIntent: {
          http: {
            method: "GET",
            requestUri: "/intents/{name}/versions/{version}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "version"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              version: {
                location: "uri",
                locationName: "version"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              slots: {
                shape: "Sq"
              },
              sampleUtterances: {
                shape: "S13"
              },
              confirmationPrompt: {
                shape: "Sa"
              },
              rejectionStatement: {
                shape: "Si"
              },
              followUpPrompt: {
                shape: "S14"
              },
              conclusionStatement: {
                shape: "Si"
              },
              dialogCodeHook: {
                shape: "S15"
              },
              fulfillmentActivity: {
                shape: "S18"
              },
              parentIntentSignature: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              version: {},
              checksum: {},
              kendraConfiguration: {
                shape: "S1b"
              },
              inputContexts: {
                shape: "S1f"
              },
              outputContexts: {
                shape: "S1i"
              }
            }
          }
        },
        GetIntentVersions: {
          http: {
            method: "GET",
            requestUri: "/intents/{name}/versions/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              intents: {
                shape: "S45"
              },
              nextToken: {}
            }
          }
        },
        GetIntents: {
          http: {
            method: "GET",
            requestUri: "/intents/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nameContains: {
                location: "querystring",
                locationName: "nameContains"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              intents: {
                shape: "S45"
              },
              nextToken: {}
            }
          }
        },
        GetMigration: {
          http: {
            method: "GET",
            requestUri: "/migrations/{migrationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "migrationId"
            ],
            members: {
              migrationId: {
                location: "uri",
                locationName: "migrationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              migrationId: {},
              v1BotName: {},
              v1BotVersion: {},
              v1BotLocale: {},
              v2BotId: {},
              v2BotRole: {},
              migrationStatus: {},
              migrationStrategy: {},
              migrationTimestamp: {
                type: "timestamp"
              },
              alerts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    type: {},
                    message: {},
                    details: {
                      type: "list",
                      member: {}
                    },
                    referenceURLs: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        GetMigrations: {
          http: {
            method: "GET",
            requestUri: "/migrations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              sortByAttribute: {
                location: "querystring",
                locationName: "sortByAttribute"
              },
              sortByOrder: {
                location: "querystring",
                locationName: "sortByOrder"
              },
              v1BotNameContains: {
                location: "querystring",
                locationName: "v1BotNameContains"
              },
              migrationStatusEquals: {
                location: "querystring",
                locationName: "migrationStatusEquals"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              migrationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    migrationId: {},
                    v1BotName: {},
                    v1BotVersion: {},
                    v1BotLocale: {},
                    v2BotId: {},
                    v2BotRole: {},
                    migrationStatus: {},
                    migrationStrategy: {},
                    migrationTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetSlotType: {
          http: {
            method: "GET",
            requestUri: "/slottypes/{name}/versions/{version}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "version"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              version: {
                location: "uri",
                locationName: "version"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              enumerationValues: {
                shape: "S1q"
              },
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              version: {},
              checksum: {},
              valueSelectionStrategy: {},
              parentSlotTypeSignature: {},
              slotTypeConfigurations: {
                shape: "S1v"
              }
            }
          }
        },
        GetSlotTypeVersions: {
          http: {
            method: "GET",
            requestUri: "/slottypes/{name}/versions/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              slotTypes: {
                shape: "S4x"
              },
              nextToken: {}
            }
          }
        },
        GetSlotTypes: {
          http: {
            method: "GET",
            requestUri: "/slottypes/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nameContains: {
                location: "querystring",
                locationName: "nameContains"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              slotTypes: {
                shape: "S4x"
              },
              nextToken: {}
            }
          }
        },
        GetUtterancesView: {
          http: {
            method: "GET",
            requestUri: "/bots/{botname}/utterances?view=aggregation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botName",
              "botVersions",
              "statusType"
            ],
            members: {
              botName: {
                location: "uri",
                locationName: "botname"
              },
              botVersions: {
                location: "querystring",
                locationName: "bot_versions",
                type: "list",
                member: {}
              },
              statusType: {
                location: "querystring",
                locationName: "status_type"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botName: {},
              utterances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    botVersion: {},
                    utterances: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          utteranceString: {},
                          count: {
                            type: "integer"
                          },
                          distinctUsers: {
                            type: "integer"
                          },
                          firstUtteredDate: {
                            type: "timestamp"
                          },
                          lastUtteredDate: {
                            type: "timestamp"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S5e"
              }
            }
          }
        },
        PutBot: {
          http: {
            method: "PUT",
            requestUri: "/bots/{name}/versions/$LATEST",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "locale",
              "childDirected"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              description: {},
              intents: {
                shape: "S6"
              },
              enableModelImprovements: {
                type: "boolean"
              },
              nluIntentConfidenceThreshold: {
                type: "double"
              },
              clarificationPrompt: {
                shape: "Sa"
              },
              abortStatement: {
                shape: "Si"
              },
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              voiceId: {},
              checksum: {},
              processBehavior: {},
              locale: {},
              childDirected: {
                type: "boolean"
              },
              detectSentiment: {
                type: "boolean"
              },
              createVersion: {
                type: "boolean"
              },
              tags: {
                shape: "S5e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              intents: {
                shape: "S6"
              },
              enableModelImprovements: {
                type: "boolean"
              },
              nluIntentConfidenceThreshold: {
                type: "double"
              },
              clarificationPrompt: {
                shape: "Sa"
              },
              abortStatement: {
                shape: "Si"
              },
              status: {},
              failureReason: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              voiceId: {},
              checksum: {},
              version: {},
              locale: {},
              childDirected: {
                type: "boolean"
              },
              createVersion: {
                type: "boolean"
              },
              detectSentiment: {
                type: "boolean"
              },
              tags: {
                shape: "S5e"
              }
            }
          }
        },
        PutBotAlias: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botName}/aliases/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "botVersion",
              "botName"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              description: {},
              botVersion: {},
              botName: {
                location: "uri",
                locationName: "botName"
              },
              checksum: {},
              conversationLogs: {
                type: "structure",
                required: [
                  "logSettings",
                  "iamRoleArn"
                ],
                members: {
                  logSettings: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "logType",
                        "destination",
                        "resourceArn"
                      ],
                      members: {
                        logType: {},
                        destination: {},
                        kmsKeyArn: {},
                        resourceArn: {}
                      }
                    }
                  },
                  iamRoleArn: {}
                }
              },
              tags: {
                shape: "S5e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              botVersion: {},
              botName: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              checksum: {},
              conversationLogs: {
                shape: "S2h"
              },
              tags: {
                shape: "S5e"
              }
            }
          }
        },
        PutIntent: {
          http: {
            method: "PUT",
            requestUri: "/intents/{name}/versions/$LATEST",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              description: {},
              slots: {
                shape: "Sq"
              },
              sampleUtterances: {
                shape: "S13"
              },
              confirmationPrompt: {
                shape: "Sa"
              },
              rejectionStatement: {
                shape: "Si"
              },
              followUpPrompt: {
                shape: "S14"
              },
              conclusionStatement: {
                shape: "Si"
              },
              dialogCodeHook: {
                shape: "S15"
              },
              fulfillmentActivity: {
                shape: "S18"
              },
              parentIntentSignature: {},
              checksum: {},
              createVersion: {
                type: "boolean"
              },
              kendraConfiguration: {
                shape: "S1b"
              },
              inputContexts: {
                shape: "S1f"
              },
              outputContexts: {
                shape: "S1i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              slots: {
                shape: "Sq"
              },
              sampleUtterances: {
                shape: "S13"
              },
              confirmationPrompt: {
                shape: "Sa"
              },
              rejectionStatement: {
                shape: "Si"
              },
              followUpPrompt: {
                shape: "S14"
              },
              conclusionStatement: {
                shape: "Si"
              },
              dialogCodeHook: {
                shape: "S15"
              },
              fulfillmentActivity: {
                shape: "S18"
              },
              parentIntentSignature: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              version: {},
              checksum: {},
              createVersion: {
                type: "boolean"
              },
              kendraConfiguration: {
                shape: "S1b"
              },
              inputContexts: {
                shape: "S1f"
              },
              outputContexts: {
                shape: "S1i"
              }
            }
          }
        },
        PutSlotType: {
          http: {
            method: "PUT",
            requestUri: "/slottypes/{name}/versions/$LATEST",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              description: {},
              enumerationValues: {
                shape: "S1q"
              },
              checksum: {},
              valueSelectionStrategy: {},
              createVersion: {
                type: "boolean"
              },
              parentSlotTypeSignature: {},
              slotTypeConfigurations: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              description: {},
              enumerationValues: {
                shape: "S1q"
              },
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              version: {},
              checksum: {},
              valueSelectionStrategy: {},
              createVersion: {
                type: "boolean"
              },
              parentSlotTypeSignature: {},
              slotTypeConfigurations: {
                shape: "S1v"
              }
            }
          }
        },
        StartImport: {
          http: {
            requestUri: "/imports/",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "payload",
              "resourceType",
              "mergeStrategy"
            ],
            members: {
              payload: {
                type: "blob"
              },
              resourceType: {},
              mergeStrategy: {},
              tags: {
                shape: "S5e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              resourceType: {},
              mergeStrategy: {},
              importId: {},
              importStatus: {},
              tags: {
                shape: "S5e"
              },
              createdDate: {
                type: "timestamp"
              }
            }
          }
        },
        StartMigration: {
          http: {
            requestUri: "/migrations",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "v1BotName",
              "v1BotVersion",
              "v2BotName",
              "v2BotRole",
              "migrationStrategy"
            ],
            members: {
              v1BotName: {},
              v1BotVersion: {},
              v2BotName: {},
              v2BotRole: {},
              migrationStrategy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              v1BotName: {},
              v1BotVersion: {},
              v1BotLocale: {},
              v2BotId: {},
              v2BotRole: {},
              migrationId: {},
              migrationStrategy: {},
              migrationTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S5e"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S6: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "intentName",
              "intentVersion"
            ],
            members: {
              intentName: {},
              intentVersion: {}
            }
          }
        },
        Sa: {
          type: "structure",
          required: [
            "messages",
            "maxAttempts"
          ],
          members: {
            messages: {
              shape: "Sb"
            },
            maxAttempts: {
              type: "integer"
            },
            responseCard: {}
          }
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "contentType",
              "content"
            ],
            members: {
              contentType: {},
              content: {},
              groupNumber: {
                type: "integer"
              }
            }
          }
        },
        Si: {
          type: "structure",
          required: [
            "messages"
          ],
          members: {
            messages: {
              shape: "Sb"
            },
            responseCard: {}
          }
        },
        Sq: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "slotConstraint"
            ],
            members: {
              name: {},
              description: {},
              slotConstraint: {},
              slotType: {},
              slotTypeVersion: {},
              valueElicitationPrompt: {
                shape: "Sa"
              },
              priority: {
                type: "integer"
              },
              sampleUtterances: {
                type: "list",
                member: {}
              },
              responseCard: {},
              obfuscationSetting: {},
              defaultValueSpec: {
                type: "structure",
                required: [
                  "defaultValueList"
                ],
                members: {
                  defaultValueList: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "defaultValue"
                      ],
                      members: {
                        defaultValue: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S13: {
          type: "list",
          member: {}
        },
        S14: {
          type: "structure",
          required: [
            "prompt",
            "rejectionStatement"
          ],
          members: {
            prompt: {
              shape: "Sa"
            },
            rejectionStatement: {
              shape: "Si"
            }
          }
        },
        S15: {
          type: "structure",
          required: [
            "uri",
            "messageVersion"
          ],
          members: {
            uri: {},
            messageVersion: {}
          }
        },
        S18: {
          type: "structure",
          required: [
            "type"
          ],
          members: {
            type: {},
            codeHook: {
              shape: "S15"
            }
          }
        },
        S1b: {
          type: "structure",
          required: [
            "kendraIndex",
            "role"
          ],
          members: {
            kendraIndex: {},
            queryFilterString: {},
            role: {}
          }
        },
        S1f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          }
        },
        S1i: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "timeToLiveInSeconds",
              "turnsToLive"
            ],
            members: {
              name: {},
              timeToLiveInSeconds: {
                type: "integer"
              },
              turnsToLive: {
                type: "integer"
              }
            }
          }
        },
        S1q: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "value"
            ],
            members: {
              value: {},
              synonyms: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S1v: {
          type: "list",
          member: {
            type: "structure",
            members: {
              regexConfiguration: {
                type: "structure",
                required: [
                  "pattern"
                ],
                members: {
                  pattern: {}
                }
              }
            }
          }
        },
        S2h: {
          type: "structure",
          members: {
            logSettings: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  logType: {},
                  destination: {},
                  kmsKeyArn: {},
                  resourceArn: {},
                  resourcePrefix: {}
                }
              }
            },
            iamRoleArn: {}
          }
        },
        S2z: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        S38: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              description: {},
              status: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              version: {}
            }
          }
        },
        S3e: {
          type: "list",
          member: {}
        },
        S45: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              description: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              version: {}
            }
          }
        },
        S4x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              description: {},
              lastUpdatedDate: {
                type: "timestamp"
              },
              createdDate: {
                type: "timestamp"
              },
              version: {}
            }
          }
        },
        S5e: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/lex-models-2017-04-19.paginators.json
var require_lex_models_2017_04_19_paginators = __commonJS({
  "node_modules/aws-sdk/apis/lex-models-2017-04-19.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetBotAliases: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetBotChannelAssociations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetBotVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetBots: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetBuiltinIntents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetBuiltinSlotTypes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetIntentVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetIntents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetMigrations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetSlotTypeVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetSlotTypes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/lexmodelbuildingservice.js
var require_lexmodelbuildingservice = __commonJS({
  "node_modules/aws-sdk/clients/lexmodelbuildingservice.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["lexmodelbuildingservice"] = {};
    AWS3.LexModelBuildingService = Service.defineService("lexmodelbuildingservice", ["2017-04-19"]);
    Object.defineProperty(apiLoader.services["lexmodelbuildingservice"], "2017-04-19", {
      get: function get() {
        var model = require_lex_models_2017_04_19_min();
        model.paginators = require_lex_models_2017_04_19_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.LexModelBuildingService;
  }
});

// node_modules/aws-sdk/apis/entitlement.marketplace-2017-01-11.min.json
var require_entitlement_marketplace_2017_01_11_min = __commonJS({
  "node_modules/aws-sdk/apis/entitlement.marketplace-2017-01-11.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-01-11",
        endpointPrefix: "entitlement.marketplace",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Marketplace Entitlement Service",
        serviceId: "Marketplace Entitlement Service",
        signatureVersion: "v4",
        signingName: "aws-marketplace",
        targetPrefix: "AWSMPEntitlementService",
        uid: "entitlement.marketplace-2017-01-11"
      },
      operations: {
        GetEntitlements: {
          input: {
            type: "structure",
            required: [
              "ProductCode"
            ],
            members: {
              ProductCode: {},
              Filter: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {}
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Entitlements: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProductCode: {},
                    Dimension: {},
                    CustomerIdentifier: {},
                    Value: {
                      type: "structure",
                      members: {
                        IntegerValue: {
                          type: "integer"
                        },
                        DoubleValue: {
                          type: "double"
                        },
                        BooleanValue: {
                          type: "boolean"
                        },
                        StringValue: {}
                      }
                    },
                    ExpirationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/entitlement.marketplace-2017-01-11.paginators.json
var require_entitlement_marketplace_2017_01_11_paginators = __commonJS({
  "node_modules/aws-sdk/apis/entitlement.marketplace-2017-01-11.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/marketplaceentitlementservice.js
var require_marketplaceentitlementservice = __commonJS({
  "node_modules/aws-sdk/clients/marketplaceentitlementservice.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["marketplaceentitlementservice"] = {};
    AWS3.MarketplaceEntitlementService = Service.defineService("marketplaceentitlementservice", ["2017-01-11"]);
    Object.defineProperty(apiLoader.services["marketplaceentitlementservice"], "2017-01-11", {
      get: function get() {
        var model = require_entitlement_marketplace_2017_01_11_min();
        model.paginators = require_entitlement_marketplace_2017_01_11_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.MarketplaceEntitlementService;
  }
});

// node_modules/aws-sdk/apis/athena-2017-05-18.min.json
var require_athena_2017_05_18_min = __commonJS({
  "node_modules/aws-sdk/apis/athena-2017-05-18.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-05-18",
        endpointPrefix: "athena",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Athena",
        serviceId: "Athena",
        signatureVersion: "v4",
        targetPrefix: "AmazonAthena",
        uid: "athena-2017-05-18"
      },
      operations: {
        BatchGetNamedQuery: {
          input: {
            type: "structure",
            required: [
              "NamedQueryIds"
            ],
            members: {
              NamedQueryIds: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NamedQueries: {
                type: "list",
                member: {
                  shape: "S6"
                }
              },
              UnprocessedNamedQueryIds: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    NamedQueryId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchGetQueryExecution: {
          input: {
            type: "structure",
            required: [
              "QueryExecutionIds"
            ],
            members: {
              QueryExecutionIds: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QueryExecutions: {
                type: "list",
                member: {
                  shape: "Sl"
                }
              },
              UnprocessedQueryExecutionIds: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    QueryExecutionId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        CreateDataCatalog: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Type"
            ],
            members: {
              Name: {},
              Type: {},
              Description: {},
              Parameters: {
                shape: "S13"
              },
              Tags: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateNamedQuery: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Database",
              "QueryString"
            ],
            members: {
              Name: {},
              Description: {},
              Database: {},
              QueryString: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NamedQueryId: {}
            }
          },
          idempotent: true
        },
        CreatePreparedStatement: {
          input: {
            type: "structure",
            required: [
              "StatementName",
              "WorkGroup",
              "QueryStatement"
            ],
            members: {
              StatementName: {},
              WorkGroup: {},
              QueryStatement: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateWorkGroup: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Configuration: {
                shape: "S1i"
              },
              Description: {},
              Tags: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDataCatalog: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteNamedQuery: {
          input: {
            type: "structure",
            required: [
              "NamedQueryId"
            ],
            members: {
              NamedQueryId: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeletePreparedStatement: {
          input: {
            type: "structure",
            required: [
              "StatementName",
              "WorkGroup"
            ],
            members: {
              StatementName: {},
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWorkGroup: {
          input: {
            type: "structure",
            required: [
              "WorkGroup"
            ],
            members: {
              WorkGroup: {},
              RecursiveDeleteOption: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetDataCatalog: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DataCatalog: {
                type: "structure",
                required: [
                  "Name",
                  "Type"
                ],
                members: {
                  Name: {},
                  Description: {},
                  Type: {},
                  Parameters: {
                    shape: "S13"
                  }
                }
              }
            }
          }
        },
        GetDatabase: {
          input: {
            type: "structure",
            required: [
              "CatalogName",
              "DatabaseName"
            ],
            members: {
              CatalogName: {},
              DatabaseName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Database: {
                shape: "S20"
              }
            }
          }
        },
        GetNamedQuery: {
          input: {
            type: "structure",
            required: [
              "NamedQueryId"
            ],
            members: {
              NamedQueryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NamedQuery: {
                shape: "S6"
              }
            }
          }
        },
        GetPreparedStatement: {
          input: {
            type: "structure",
            required: [
              "StatementName",
              "WorkGroup"
            ],
            members: {
              StatementName: {},
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PreparedStatement: {
                type: "structure",
                members: {
                  StatementName: {},
                  QueryStatement: {},
                  WorkGroupName: {},
                  Description: {},
                  LastModifiedTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        GetQueryExecution: {
          input: {
            type: "structure",
            required: [
              "QueryExecutionId"
            ],
            members: {
              QueryExecutionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              QueryExecution: {
                shape: "Sl"
              }
            }
          }
        },
        GetQueryResults: {
          input: {
            type: "structure",
            required: [
              "QueryExecutionId"
            ],
            members: {
              QueryExecutionId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpdateCount: {
                type: "long"
              },
              ResultSet: {
                type: "structure",
                members: {
                  Rows: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Data: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              VarCharValue: {}
                            }
                          }
                        }
                      }
                    }
                  },
                  ResultSetMetadata: {
                    type: "structure",
                    members: {
                      ColumnInfo: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "Name",
                            "Type"
                          ],
                          members: {
                            CatalogName: {},
                            SchemaName: {},
                            TableName: {},
                            Name: {},
                            Label: {},
                            Type: {},
                            Precision: {
                              type: "integer"
                            },
                            Scale: {
                              type: "integer"
                            },
                            Nullable: {},
                            CaseSensitive: {
                              type: "boolean"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetTableMetadata: {
          input: {
            type: "structure",
            required: [
              "CatalogName",
              "DatabaseName",
              "TableName"
            ],
            members: {
              CatalogName: {},
              DatabaseName: {},
              TableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TableMetadata: {
                shape: "S2q"
              }
            }
          }
        },
        GetWorkGroup: {
          input: {
            type: "structure",
            required: [
              "WorkGroup"
            ],
            members: {
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WorkGroup: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {},
                  State: {},
                  Configuration: {
                    shape: "S1i"
                  },
                  Description: {},
                  CreationTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        ListDataCatalogs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataCatalogsSummary: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CatalogName: {},
                    Type: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDatabases: {
          input: {
            type: "structure",
            required: [
              "CatalogName"
            ],
            members: {
              CatalogName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatabaseList: {
                type: "list",
                member: {
                  shape: "S20"
                }
              },
              NextToken: {}
            }
          }
        },
        ListEngineVersions: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EngineVersions: {
                type: "list",
                member: {
                  shape: "Sy"
                }
              },
              NextToken: {}
            }
          }
        },
        ListNamedQueries: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NamedQueryIds: {
                shape: "S2"
              },
              NextToken: {}
            }
          }
        },
        ListPreparedStatements: {
          input: {
            type: "structure",
            required: [
              "WorkGroup"
            ],
            members: {
              WorkGroup: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PreparedStatements: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StatementName: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListQueryExecutions: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              QueryExecutionIds: {
                shape: "Sh"
              },
              NextToken: {}
            }
          }
        },
        ListTableMetadata: {
          input: {
            type: "structure",
            required: [
              "CatalogName",
              "DatabaseName"
            ],
            members: {
              CatalogName: {},
              DatabaseName: {},
              Expression: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableMetadataList: {
                type: "list",
                member: {
                  shape: "S2q"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S16"
              },
              NextToken: {}
            }
          }
        },
        ListWorkGroups: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    State: {},
                    Description: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    EngineVersion: {
                      shape: "Sy"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        StartQueryExecution: {
          input: {
            type: "structure",
            required: [
              "QueryString"
            ],
            members: {
              QueryString: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              QueryExecutionContext: {
                shape: "Sr"
              },
              ResultConfiguration: {
                shape: "Sn"
              },
              WorkGroup: {}
            }
          },
          output: {
            type: "structure",
            members: {
              QueryExecutionId: {}
            }
          },
          idempotent: true
        },
        StopQueryExecution: {
          input: {
            type: "structure",
            required: [
              "QueryExecutionId"
            ],
            members: {
              QueryExecutionId: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDataCatalog: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Type"
            ],
            members: {
              Name: {},
              Type: {},
              Description: {},
              Parameters: {
                shape: "S13"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdatePreparedStatement: {
          input: {
            type: "structure",
            required: [
              "StatementName",
              "WorkGroup",
              "QueryStatement"
            ],
            members: {
              StatementName: {},
              WorkGroup: {},
              QueryStatement: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateWorkGroup: {
          input: {
            type: "structure",
            required: [
              "WorkGroup"
            ],
            members: {
              WorkGroup: {},
              Description: {},
              ConfigurationUpdates: {
                type: "structure",
                members: {
                  EnforceWorkGroupConfiguration: {
                    type: "boolean"
                  },
                  ResultConfigurationUpdates: {
                    type: "structure",
                    members: {
                      OutputLocation: {},
                      RemoveOutputLocation: {
                        type: "boolean"
                      },
                      EncryptionConfiguration: {
                        shape: "Sp"
                      },
                      RemoveEncryptionConfiguration: {
                        type: "boolean"
                      }
                    }
                  },
                  PublishCloudWatchMetricsEnabled: {
                    type: "boolean"
                  },
                  BytesScannedCutoffPerQuery: {
                    type: "long"
                  },
                  RemoveBytesScannedCutoffPerQuery: {
                    type: "boolean"
                  },
                  RequesterPaysEnabled: {
                    type: "boolean"
                  },
                  EngineVersion: {
                    shape: "Sy"
                  }
                }
              },
              State: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {}
        },
        S6: {
          type: "structure",
          required: [
            "Name",
            "Database",
            "QueryString"
          ],
          members: {
            Name: {},
            Description: {},
            Database: {},
            QueryString: {},
            NamedQueryId: {},
            WorkGroup: {}
          }
        },
        Sh: {
          type: "list",
          member: {}
        },
        Sl: {
          type: "structure",
          members: {
            QueryExecutionId: {},
            Query: {},
            StatementType: {},
            ResultConfiguration: {
              shape: "Sn"
            },
            QueryExecutionContext: {
              shape: "Sr"
            },
            Status: {
              type: "structure",
              members: {
                State: {},
                StateChangeReason: {},
                SubmissionDateTime: {
                  type: "timestamp"
                },
                CompletionDateTime: {
                  type: "timestamp"
                }
              }
            },
            Statistics: {
              type: "structure",
              members: {
                EngineExecutionTimeInMillis: {
                  type: "long"
                },
                DataScannedInBytes: {
                  type: "long"
                },
                DataManifestLocation: {},
                TotalExecutionTimeInMillis: {
                  type: "long"
                },
                QueryQueueTimeInMillis: {
                  type: "long"
                },
                QueryPlanningTimeInMillis: {
                  type: "long"
                },
                ServiceProcessingTimeInMillis: {
                  type: "long"
                }
              }
            },
            WorkGroup: {},
            EngineVersion: {
              shape: "Sy"
            }
          }
        },
        Sn: {
          type: "structure",
          members: {
            OutputLocation: {},
            EncryptionConfiguration: {
              shape: "Sp"
            }
          }
        },
        Sp: {
          type: "structure",
          required: [
            "EncryptionOption"
          ],
          members: {
            EncryptionOption: {},
            KmsKey: {}
          }
        },
        Sr: {
          type: "structure",
          members: {
            Database: {},
            Catalog: {}
          }
        },
        Sy: {
          type: "structure",
          members: {
            SelectedEngineVersion: {},
            EffectiveEngineVersion: {}
          }
        },
        S13: {
          type: "map",
          key: {},
          value: {}
        },
        S16: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S1i: {
          type: "structure",
          members: {
            ResultConfiguration: {
              shape: "Sn"
            },
            EnforceWorkGroupConfiguration: {
              type: "boolean"
            },
            PublishCloudWatchMetricsEnabled: {
              type: "boolean"
            },
            BytesScannedCutoffPerQuery: {
              type: "long"
            },
            RequesterPaysEnabled: {
              type: "boolean"
            },
            EngineVersion: {
              shape: "Sy"
            }
          }
        },
        S20: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            Description: {},
            Parameters: {
              shape: "S13"
            }
          }
        },
        S2q: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            CreateTime: {
              type: "timestamp"
            },
            LastAccessTime: {
              type: "timestamp"
            },
            TableType: {},
            Columns: {
              shape: "S2t"
            },
            PartitionKeys: {
              shape: "S2t"
            },
            Parameters: {
              shape: "S13"
            }
          }
        },
        S2t: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Type: {},
              Comment: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/athena-2017-05-18.paginators.json
var require_athena_2017_05_18_paginators = __commonJS({
  "node_modules/aws-sdk/apis/athena-2017-05-18.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetQueryResults: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListDataCatalogs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DataCatalogsSummary"
        },
        ListDatabases: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DatabaseList"
        },
        ListNamedQueries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListPreparedStatements: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListQueryExecutions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTableMetadata: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "TableMetadataList"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Tags"
        },
        ListWorkGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/athena.js
var require_athena = __commonJS({
  "node_modules/aws-sdk/clients/athena.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["athena"] = {};
    AWS3.Athena = Service.defineService("athena", ["2017-05-18"]);
    Object.defineProperty(apiLoader.services["athena"], "2017-05-18", {
      get: function get() {
        var model = require_athena_2017_05_18_min();
        model.paginators = require_athena_2017_05_18_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Athena;
  }
});

// node_modules/aws-sdk/apis/greengrass-2017-06-07.min.json
var require_greengrass_2017_06_07_min = __commonJS({
  "node_modules/aws-sdk/apis/greengrass-2017-06-07.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2017-06-07",
        endpointPrefix: "greengrass",
        signingName: "greengrass",
        serviceFullName: "AWS Greengrass",
        serviceId: "Greengrass",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "greengrass-2017-06-07",
        signatureVersion: "v4"
      },
      operations: {
        AssociateRoleToGroup: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/groups/{GroupId}/role",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              },
              RoleArn: {}
            },
            required: [
              "GroupId",
              "RoleArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              AssociatedAt: {}
            }
          }
        },
        AssociateServiceRoleToAccount: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/servicerole",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RoleArn: {}
            },
            required: [
              "RoleArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              AssociatedAt: {}
            }
          }
        },
        CreateConnectorDefinition: {
          http: {
            requestUri: "/greengrass/definition/connectors",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              InitialVersion: {
                shape: "S7"
              },
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {}
            }
          }
        },
        CreateConnectorDefinitionVersion: {
          http: {
            requestUri: "/greengrass/definition/connectors/{ConnectorDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              ConnectorDefinitionId: {
                location: "uri",
                locationName: "ConnectorDefinitionId"
              },
              Connectors: {
                shape: "S8"
              }
            },
            required: [
              "ConnectorDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              Version: {}
            }
          }
        },
        CreateCoreDefinition: {
          http: {
            requestUri: "/greengrass/definition/cores",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              InitialVersion: {
                shape: "Sg"
              },
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {}
            }
          }
        },
        CreateCoreDefinitionVersion: {
          http: {
            requestUri: "/greengrass/definition/cores/{CoreDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              CoreDefinitionId: {
                location: "uri",
                locationName: "CoreDefinitionId"
              },
              Cores: {
                shape: "Sh"
              }
            },
            required: [
              "CoreDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              Version: {}
            }
          }
        },
        CreateDeployment: {
          http: {
            requestUri: "/greengrass/groups/{GroupId}/deployments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              DeploymentId: {},
              DeploymentType: {},
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              },
              GroupVersionId: {}
            },
            required: [
              "GroupId",
              "DeploymentType"
            ]
          },
          output: {
            type: "structure",
            members: {
              DeploymentArn: {},
              DeploymentId: {}
            }
          }
        },
        CreateDeviceDefinition: {
          http: {
            requestUri: "/greengrass/definition/devices",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              InitialVersion: {
                shape: "Sr"
              },
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {}
            }
          }
        },
        CreateDeviceDefinitionVersion: {
          http: {
            requestUri: "/greengrass/definition/devices/{DeviceDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              DeviceDefinitionId: {
                location: "uri",
                locationName: "DeviceDefinitionId"
              },
              Devices: {
                shape: "Ss"
              }
            },
            required: [
              "DeviceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              Version: {}
            }
          }
        },
        CreateFunctionDefinition: {
          http: {
            requestUri: "/greengrass/definition/functions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              InitialVersion: {
                shape: "Sy"
              },
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {}
            }
          }
        },
        CreateFunctionDefinitionVersion: {
          http: {
            requestUri: "/greengrass/definition/functions/{FunctionDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              DefaultConfig: {
                shape: "Sz"
              },
              FunctionDefinitionId: {
                location: "uri",
                locationName: "FunctionDefinitionId"
              },
              Functions: {
                shape: "S14"
              }
            },
            required: [
              "FunctionDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              Version: {}
            }
          }
        },
        CreateGroup: {
          http: {
            requestUri: "/greengrass/groups",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              InitialVersion: {
                shape: "S1h"
              },
              Name: {},
              tags: {
                shape: "Sb"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {}
            }
          }
        },
        CreateGroupCertificateAuthority: {
          http: {
            requestUri: "/greengrass/groups/{GroupId}/certificateauthorities",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              GroupCertificateAuthorityArn: {}
            }
          }
        },
        CreateGroupVersion: {
          http: {
            requestUri: "/greengrass/groups/{GroupId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              ConnectorDefinitionVersionArn: {},
              CoreDefinitionVersionArn: {},
              DeviceDefinitionVersionArn: {},
              FunctionDefinitionVersionArn: {},
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              },
              LoggerDefinitionVersionArn: {},
              ResourceDefinitionVersionArn: {},
              SubscriptionDefinitionVersionArn: {}
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              Version: {}
            }
          }
        },
        CreateLoggerDefinition: {
          http: {
            requestUri: "/greengrass/definition/loggers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              InitialVersion: {
                shape: "S1o"
              },
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {}
            }
          }
        },
        CreateLoggerDefinitionVersion: {
          http: {
            requestUri: "/greengrass/definition/loggers/{LoggerDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              LoggerDefinitionId: {
                location: "uri",
                locationName: "LoggerDefinitionId"
              },
              Loggers: {
                shape: "S1p"
              }
            },
            required: [
              "LoggerDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              Version: {}
            }
          }
        },
        CreateResourceDefinition: {
          http: {
            requestUri: "/greengrass/definition/resources",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              InitialVersion: {
                shape: "S1y"
              },
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {}
            }
          }
        },
        CreateResourceDefinitionVersion: {
          http: {
            requestUri: "/greengrass/definition/resources/{ResourceDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              ResourceDefinitionId: {
                location: "uri",
                locationName: "ResourceDefinitionId"
              },
              Resources: {
                shape: "S1z"
              }
            },
            required: [
              "ResourceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              Version: {}
            }
          }
        },
        CreateSoftwareUpdateJob: {
          http: {
            requestUri: "/greengrass/updates",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              S3UrlSignerRole: {},
              SoftwareToUpdate: {},
              UpdateAgentLogLevel: {},
              UpdateTargets: {
                type: "list",
                member: {}
              },
              UpdateTargetsArchitecture: {},
              UpdateTargetsOperatingSystem: {}
            },
            required: [
              "S3UrlSignerRole",
              "UpdateTargetsArchitecture",
              "SoftwareToUpdate",
              "UpdateTargets",
              "UpdateTargetsOperatingSystem"
            ]
          },
          output: {
            type: "structure",
            members: {
              IotJobArn: {},
              IotJobId: {},
              PlatformSoftwareVersion: {}
            }
          }
        },
        CreateSubscriptionDefinition: {
          http: {
            requestUri: "/greengrass/definition/subscriptions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              InitialVersion: {
                shape: "S2m"
              },
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {}
            }
          }
        },
        CreateSubscriptionDefinitionVersion: {
          http: {
            requestUri: "/greengrass/definition/subscriptions/{SubscriptionDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              SubscriptionDefinitionId: {
                location: "uri",
                locationName: "SubscriptionDefinitionId"
              },
              Subscriptions: {
                shape: "S2n"
              }
            },
            required: [
              "SubscriptionDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              Version: {}
            }
          }
        },
        DeleteConnectorDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/definition/connectors/{ConnectorDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConnectorDefinitionId: {
                location: "uri",
                locationName: "ConnectorDefinitionId"
              }
            },
            required: [
              "ConnectorDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCoreDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/definition/cores/{CoreDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CoreDefinitionId: {
                location: "uri",
                locationName: "CoreDefinitionId"
              }
            },
            required: [
              "CoreDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDeviceDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/definition/devices/{DeviceDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceDefinitionId: {
                location: "uri",
                locationName: "DeviceDefinitionId"
              }
            },
            required: [
              "DeviceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteFunctionDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/definition/functions/{FunctionDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              FunctionDefinitionId: {
                location: "uri",
                locationName: "FunctionDefinitionId"
              }
            },
            required: [
              "FunctionDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteGroup: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/groups/{GroupId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLoggerDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/definition/loggers/{LoggerDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              LoggerDefinitionId: {
                location: "uri",
                locationName: "LoggerDefinitionId"
              }
            },
            required: [
              "LoggerDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteResourceDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/definition/resources/{ResourceDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceDefinitionId: {
                location: "uri",
                locationName: "ResourceDefinitionId"
              }
            },
            required: [
              "ResourceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSubscriptionDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/definition/subscriptions/{SubscriptionDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              SubscriptionDefinitionId: {
                location: "uri",
                locationName: "SubscriptionDefinitionId"
              }
            },
            required: [
              "SubscriptionDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateRoleFromGroup: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/groups/{GroupId}/role",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              DisassociatedAt: {}
            }
          }
        },
        DisassociateServiceRoleFromAccount: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/servicerole",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              DisassociatedAt: {}
            }
          }
        },
        GetAssociatedRole: {
          http: {
            method: "GET",
            requestUri: "/greengrass/groups/{GroupId}/role",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AssociatedAt: {},
              RoleArn: {}
            }
          }
        },
        GetBulkDeploymentStatus: {
          http: {
            method: "GET",
            requestUri: "/greengrass/bulk/deployments/{BulkDeploymentId}/status",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BulkDeploymentId: {
                location: "uri",
                locationName: "BulkDeploymentId"
              }
            },
            required: [
              "BulkDeploymentId"
            ]
          },
          output: {
            type: "structure",
            members: {
              BulkDeploymentMetrics: {
                type: "structure",
                members: {
                  InvalidInputRecords: {
                    type: "integer"
                  },
                  RecordsProcessed: {
                    type: "integer"
                  },
                  RetryAttempts: {
                    type: "integer"
                  }
                }
              },
              BulkDeploymentStatus: {},
              CreatedAt: {},
              ErrorDetails: {
                shape: "S3i"
              },
              ErrorMessage: {},
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        GetConnectivityInfo: {
          http: {
            method: "GET",
            requestUri: "/greengrass/things/{ThingName}/connectivityInfo",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ThingName: {
                location: "uri",
                locationName: "ThingName"
              }
            },
            required: [
              "ThingName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ConnectivityInfo: {
                shape: "S3m"
              },
              Message: {
                locationName: "message"
              }
            }
          }
        },
        GetConnectorDefinition: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/connectors/{ConnectorDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConnectorDefinitionId: {
                location: "uri",
                locationName: "ConnectorDefinitionId"
              }
            },
            required: [
              "ConnectorDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        GetConnectorDefinitionVersion: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/connectors/{ConnectorDefinitionId}/versions/{ConnectorDefinitionVersionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConnectorDefinitionId: {
                location: "uri",
                locationName: "ConnectorDefinitionId"
              },
              ConnectorDefinitionVersionId: {
                location: "uri",
                locationName: "ConnectorDefinitionVersionId"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "ConnectorDefinitionId",
              "ConnectorDefinitionVersionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Definition: {
                shape: "S7"
              },
              Id: {},
              NextToken: {},
              Version: {}
            }
          }
        },
        GetCoreDefinition: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/cores/{CoreDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CoreDefinitionId: {
                location: "uri",
                locationName: "CoreDefinitionId"
              }
            },
            required: [
              "CoreDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        GetCoreDefinitionVersion: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/cores/{CoreDefinitionId}/versions/{CoreDefinitionVersionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CoreDefinitionId: {
                location: "uri",
                locationName: "CoreDefinitionId"
              },
              CoreDefinitionVersionId: {
                location: "uri",
                locationName: "CoreDefinitionVersionId"
              }
            },
            required: [
              "CoreDefinitionId",
              "CoreDefinitionVersionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Definition: {
                shape: "Sg"
              },
              Id: {},
              NextToken: {},
              Version: {}
            }
          }
        },
        GetDeploymentStatus: {
          http: {
            method: "GET",
            requestUri: "/greengrass/groups/{GroupId}/deployments/{DeploymentId}/status",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeploymentId: {
                location: "uri",
                locationName: "DeploymentId"
              },
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "GroupId",
              "DeploymentId"
            ]
          },
          output: {
            type: "structure",
            members: {
              DeploymentStatus: {},
              DeploymentType: {},
              ErrorDetails: {
                shape: "S3i"
              },
              ErrorMessage: {},
              UpdatedAt: {}
            }
          }
        },
        GetDeviceDefinition: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/devices/{DeviceDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceDefinitionId: {
                location: "uri",
                locationName: "DeviceDefinitionId"
              }
            },
            required: [
              "DeviceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        GetDeviceDefinitionVersion: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/devices/{DeviceDefinitionId}/versions/{DeviceDefinitionVersionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceDefinitionId: {
                location: "uri",
                locationName: "DeviceDefinitionId"
              },
              DeviceDefinitionVersionId: {
                location: "uri",
                locationName: "DeviceDefinitionVersionId"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "DeviceDefinitionVersionId",
              "DeviceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Definition: {
                shape: "Sr"
              },
              Id: {},
              NextToken: {},
              Version: {}
            }
          }
        },
        GetFunctionDefinition: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/functions/{FunctionDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              FunctionDefinitionId: {
                location: "uri",
                locationName: "FunctionDefinitionId"
              }
            },
            required: [
              "FunctionDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        GetFunctionDefinitionVersion: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/functions/{FunctionDefinitionId}/versions/{FunctionDefinitionVersionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              FunctionDefinitionId: {
                location: "uri",
                locationName: "FunctionDefinitionId"
              },
              FunctionDefinitionVersionId: {
                location: "uri",
                locationName: "FunctionDefinitionVersionId"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "FunctionDefinitionId",
              "FunctionDefinitionVersionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Definition: {
                shape: "Sy"
              },
              Id: {},
              NextToken: {},
              Version: {}
            }
          }
        },
        GetGroup: {
          http: {
            method: "GET",
            requestUri: "/greengrass/groups/{GroupId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        GetGroupCertificateAuthority: {
          http: {
            method: "GET",
            requestUri: "/greengrass/groups/{GroupId}/certificateauthorities/{CertificateAuthorityId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CertificateAuthorityId: {
                location: "uri",
                locationName: "CertificateAuthorityId"
              },
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "CertificateAuthorityId",
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              GroupCertificateAuthorityArn: {},
              GroupCertificateAuthorityId: {},
              PemEncodedCertificate: {}
            }
          }
        },
        GetGroupCertificateConfiguration: {
          http: {
            method: "GET",
            requestUri: "/greengrass/groups/{GroupId}/certificateauthorities/configuration/expiry",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              CertificateAuthorityExpiryInMilliseconds: {},
              CertificateExpiryInMilliseconds: {},
              GroupId: {}
            }
          }
        },
        GetGroupVersion: {
          http: {
            method: "GET",
            requestUri: "/greengrass/groups/{GroupId}/versions/{GroupVersionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              },
              GroupVersionId: {
                location: "uri",
                locationName: "GroupVersionId"
              }
            },
            required: [
              "GroupVersionId",
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Definition: {
                shape: "S1h"
              },
              Id: {},
              Version: {}
            }
          }
        },
        GetLoggerDefinition: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/loggers/{LoggerDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              LoggerDefinitionId: {
                location: "uri",
                locationName: "LoggerDefinitionId"
              }
            },
            required: [
              "LoggerDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        GetLoggerDefinitionVersion: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/loggers/{LoggerDefinitionId}/versions/{LoggerDefinitionVersionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              LoggerDefinitionId: {
                location: "uri",
                locationName: "LoggerDefinitionId"
              },
              LoggerDefinitionVersionId: {
                location: "uri",
                locationName: "LoggerDefinitionVersionId"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "LoggerDefinitionVersionId",
              "LoggerDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Definition: {
                shape: "S1o"
              },
              Id: {},
              Version: {}
            }
          }
        },
        GetResourceDefinition: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/resources/{ResourceDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceDefinitionId: {
                location: "uri",
                locationName: "ResourceDefinitionId"
              }
            },
            required: [
              "ResourceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        GetResourceDefinitionVersion: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/resources/{ResourceDefinitionId}/versions/{ResourceDefinitionVersionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceDefinitionId: {
                location: "uri",
                locationName: "ResourceDefinitionId"
              },
              ResourceDefinitionVersionId: {
                location: "uri",
                locationName: "ResourceDefinitionVersionId"
              }
            },
            required: [
              "ResourceDefinitionVersionId",
              "ResourceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Definition: {
                shape: "S1y"
              },
              Id: {},
              Version: {}
            }
          }
        },
        GetServiceRoleForAccount: {
          http: {
            method: "GET",
            requestUri: "/greengrass/servicerole",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              AssociatedAt: {},
              RoleArn: {}
            }
          }
        },
        GetSubscriptionDefinition: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/subscriptions/{SubscriptionDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              SubscriptionDefinitionId: {
                location: "uri",
                locationName: "SubscriptionDefinitionId"
              }
            },
            required: [
              "SubscriptionDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {},
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        GetSubscriptionDefinitionVersion: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/subscriptions/{SubscriptionDefinitionId}/versions/{SubscriptionDefinitionVersionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              SubscriptionDefinitionId: {
                location: "uri",
                locationName: "SubscriptionDefinitionId"
              },
              SubscriptionDefinitionVersionId: {
                location: "uri",
                locationName: "SubscriptionDefinitionVersionId"
              }
            },
            required: [
              "SubscriptionDefinitionId",
              "SubscriptionDefinitionVersionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Definition: {
                shape: "S2m"
              },
              Id: {},
              NextToken: {},
              Version: {}
            }
          }
        },
        GetThingRuntimeConfiguration: {
          http: {
            method: "GET",
            requestUri: "/greengrass/things/{ThingName}/runtimeconfig",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ThingName: {
                location: "uri",
                locationName: "ThingName"
              }
            },
            required: [
              "ThingName"
            ]
          },
          output: {
            type: "structure",
            members: {
              RuntimeConfiguration: {
                type: "structure",
                members: {
                  TelemetryConfiguration: {
                    type: "structure",
                    members: {
                      ConfigurationSyncStatus: {},
                      Telemetry: {}
                    },
                    required: [
                      "Telemetry"
                    ]
                  }
                }
              }
            }
          }
        },
        ListBulkDeploymentDetailedReports: {
          http: {
            method: "GET",
            requestUri: "/greengrass/bulk/deployments/{BulkDeploymentId}/detailed-reports",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BulkDeploymentId: {
                location: "uri",
                locationName: "BulkDeploymentId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "BulkDeploymentId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Deployments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedAt: {},
                    DeploymentArn: {},
                    DeploymentId: {},
                    DeploymentStatus: {},
                    DeploymentType: {},
                    ErrorDetails: {
                      shape: "S3i"
                    },
                    ErrorMessage: {},
                    GroupArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListBulkDeployments: {
          http: {
            method: "GET",
            requestUri: "/greengrass/bulk/deployments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BulkDeployments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    BulkDeploymentArn: {},
                    BulkDeploymentId: {},
                    CreatedAt: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListConnectorDefinitionVersions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/connectors/{ConnectorDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConnectorDefinitionId: {
                location: "uri",
                locationName: "ConnectorDefinitionId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "ConnectorDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Versions: {
                shape: "S58"
              }
            }
          }
        },
        ListConnectorDefinitions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/connectors",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Definitions: {
                shape: "S5c"
              },
              NextToken: {}
            }
          }
        },
        ListCoreDefinitionVersions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/cores/{CoreDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CoreDefinitionId: {
                location: "uri",
                locationName: "CoreDefinitionId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "CoreDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Versions: {
                shape: "S58"
              }
            }
          }
        },
        ListCoreDefinitions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/cores",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Definitions: {
                shape: "S5c"
              },
              NextToken: {}
            }
          }
        },
        ListDeployments: {
          http: {
            method: "GET",
            requestUri: "/greengrass/groups/{GroupId}/deployments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Deployments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedAt: {},
                    DeploymentArn: {},
                    DeploymentId: {},
                    DeploymentType: {},
                    GroupArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDeviceDefinitionVersions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/devices/{DeviceDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceDefinitionId: {
                location: "uri",
                locationName: "DeviceDefinitionId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "DeviceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Versions: {
                shape: "S58"
              }
            }
          }
        },
        ListDeviceDefinitions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/devices",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Definitions: {
                shape: "S5c"
              },
              NextToken: {}
            }
          }
        },
        ListFunctionDefinitionVersions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/functions/{FunctionDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              FunctionDefinitionId: {
                location: "uri",
                locationName: "FunctionDefinitionId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "FunctionDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Versions: {
                shape: "S58"
              }
            }
          }
        },
        ListFunctionDefinitions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/functions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Definitions: {
                shape: "S5c"
              },
              NextToken: {}
            }
          }
        },
        ListGroupCertificateAuthorities: {
          http: {
            method: "GET",
            requestUri: "/greengrass/groups/{GroupId}/certificateauthorities",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              GroupCertificateAuthorities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GroupCertificateAuthorityArn: {},
                    GroupCertificateAuthorityId: {}
                  }
                }
              }
            }
          }
        },
        ListGroupVersions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/groups/{GroupId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Versions: {
                shape: "S58"
              }
            }
          }
        },
        ListGroups: {
          http: {
            method: "GET",
            requestUri: "/greengrass/groups",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Groups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreationTimestamp: {},
                    Id: {},
                    LastUpdatedTimestamp: {},
                    LatestVersion: {},
                    LatestVersionArn: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLoggerDefinitionVersions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/loggers/{LoggerDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              LoggerDefinitionId: {
                location: "uri",
                locationName: "LoggerDefinitionId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "LoggerDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Versions: {
                shape: "S58"
              }
            }
          }
        },
        ListLoggerDefinitions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/loggers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Definitions: {
                shape: "S5c"
              },
              NextToken: {}
            }
          }
        },
        ListResourceDefinitionVersions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/resources/{ResourceDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              ResourceDefinitionId: {
                location: "uri",
                locationName: "ResourceDefinitionId"
              }
            },
            required: [
              "ResourceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Versions: {
                shape: "S58"
              }
            }
          }
        },
        ListResourceDefinitions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/resources",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Definitions: {
                shape: "S5c"
              },
              NextToken: {}
            }
          }
        },
        ListSubscriptionDefinitionVersions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/subscriptions/{SubscriptionDefinitionId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              SubscriptionDefinitionId: {
                location: "uri",
                locationName: "SubscriptionDefinitionId"
              }
            },
            required: [
              "SubscriptionDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Versions: {
                shape: "S58"
              }
            }
          }
        },
        ListSubscriptionDefinitions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/definition/subscriptions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Definitions: {
                shape: "S5c"
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        ResetDeployments: {
          http: {
            requestUri: "/greengrass/groups/{GroupId}/deployments/$reset",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              Force: {
                type: "boolean"
              },
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              DeploymentArn: {},
              DeploymentId: {}
            }
          }
        },
        StartBulkDeployment: {
          http: {
            requestUri: "/greengrass/bulk/deployments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AmznClientToken: {
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              ExecutionRoleArn: {},
              InputFileUri: {},
              tags: {
                shape: "Sb"
              }
            },
            required: [
              "ExecutionRoleArn",
              "InputFileUri"
            ]
          },
          output: {
            type: "structure",
            members: {
              BulkDeploymentArn: {},
              BulkDeploymentId: {}
            }
          }
        },
        StopBulkDeployment: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/bulk/deployments/{BulkDeploymentId}/$stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BulkDeploymentId: {
                location: "uri",
                locationName: "BulkDeploymentId"
              }
            },
            required: [
              "BulkDeploymentId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              tags: {
                shape: "Sb"
              }
            },
            required: [
              "ResourceArn"
            ]
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                shape: "S29",
                location: "querystring",
                locationName: "tagKeys"
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ]
          }
        },
        UpdateConnectivityInfo: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/things/{ThingName}/connectivityInfo",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConnectivityInfo: {
                shape: "S3m"
              },
              ThingName: {
                location: "uri",
                locationName: "ThingName"
              }
            },
            required: [
              "ThingName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Message: {
                locationName: "message"
              },
              Version: {}
            }
          }
        },
        UpdateConnectorDefinition: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/definition/connectors/{ConnectorDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConnectorDefinitionId: {
                location: "uri",
                locationName: "ConnectorDefinitionId"
              },
              Name: {}
            },
            required: [
              "ConnectorDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateCoreDefinition: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/definition/cores/{CoreDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CoreDefinitionId: {
                location: "uri",
                locationName: "CoreDefinitionId"
              },
              Name: {}
            },
            required: [
              "CoreDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDeviceDefinition: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/definition/devices/{DeviceDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceDefinitionId: {
                location: "uri",
                locationName: "DeviceDefinitionId"
              },
              Name: {}
            },
            required: [
              "DeviceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateFunctionDefinition: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/definition/functions/{FunctionDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              FunctionDefinitionId: {
                location: "uri",
                locationName: "FunctionDefinitionId"
              },
              Name: {}
            },
            required: [
              "FunctionDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateGroup: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/groups/{GroupId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              },
              Name: {}
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateGroupCertificateConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/groups/{GroupId}/certificateauthorities/configuration/expiry",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CertificateExpiryInMilliseconds: {},
              GroupId: {
                location: "uri",
                locationName: "GroupId"
              }
            },
            required: [
              "GroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              CertificateAuthorityExpiryInMilliseconds: {},
              CertificateExpiryInMilliseconds: {},
              GroupId: {}
            }
          }
        },
        UpdateLoggerDefinition: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/definition/loggers/{LoggerDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              LoggerDefinitionId: {
                location: "uri",
                locationName: "LoggerDefinitionId"
              },
              Name: {}
            },
            required: [
              "LoggerDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateResourceDefinition: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/definition/resources/{ResourceDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Name: {},
              ResourceDefinitionId: {
                location: "uri",
                locationName: "ResourceDefinitionId"
              }
            },
            required: [
              "ResourceDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateSubscriptionDefinition: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/definition/subscriptions/{SubscriptionDefinitionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Name: {},
              SubscriptionDefinitionId: {
                location: "uri",
                locationName: "SubscriptionDefinitionId"
              }
            },
            required: [
              "SubscriptionDefinitionId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateThingRuntimeConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/greengrass/things/{ThingName}/runtimeconfig",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              TelemetryConfiguration: {
                type: "structure",
                members: {
                  Telemetry: {}
                },
                required: [
                  "Telemetry"
                ]
              },
              ThingName: {
                location: "uri",
                locationName: "ThingName"
              }
            },
            required: [
              "ThingName"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S7: {
          type: "structure",
          members: {
            Connectors: {
              shape: "S8"
            }
          }
        },
        S8: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ConnectorArn: {},
              Id: {},
              Parameters: {
                shape: "Sa"
              }
            },
            required: [
              "ConnectorArn",
              "Id"
            ]
          }
        },
        Sa: {
          type: "map",
          key: {},
          value: {}
        },
        Sb: {
          type: "map",
          key: {},
          value: {}
        },
        Sg: {
          type: "structure",
          members: {
            Cores: {
              shape: "Sh"
            }
          }
        },
        Sh: {
          type: "list",
          member: {
            type: "structure",
            members: {
              CertificateArn: {},
              Id: {},
              SyncShadow: {
                type: "boolean"
              },
              ThingArn: {}
            },
            required: [
              "ThingArn",
              "Id",
              "CertificateArn"
            ]
          }
        },
        Sr: {
          type: "structure",
          members: {
            Devices: {
              shape: "Ss"
            }
          }
        },
        Ss: {
          type: "list",
          member: {
            type: "structure",
            members: {
              CertificateArn: {},
              Id: {},
              SyncShadow: {
                type: "boolean"
              },
              ThingArn: {}
            },
            required: [
              "ThingArn",
              "Id",
              "CertificateArn"
            ]
          }
        },
        Sy: {
          type: "structure",
          members: {
            DefaultConfig: {
              shape: "Sz"
            },
            Functions: {
              shape: "S14"
            }
          }
        },
        Sz: {
          type: "structure",
          members: {
            Execution: {
              type: "structure",
              members: {
                IsolationMode: {},
                RunAs: {
                  shape: "S12"
                }
              }
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            Gid: {
              type: "integer"
            },
            Uid: {
              type: "integer"
            }
          }
        },
        S14: {
          type: "list",
          member: {
            type: "structure",
            members: {
              FunctionArn: {},
              FunctionConfiguration: {
                type: "structure",
                members: {
                  EncodingType: {},
                  Environment: {
                    type: "structure",
                    members: {
                      AccessSysfs: {
                        type: "boolean"
                      },
                      Execution: {
                        type: "structure",
                        members: {
                          IsolationMode: {},
                          RunAs: {
                            shape: "S12"
                          }
                        }
                      },
                      ResourceAccessPolicies: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            Permission: {},
                            ResourceId: {}
                          },
                          required: [
                            "ResourceId"
                          ]
                        }
                      },
                      Variables: {
                        shape: "Sa"
                      }
                    }
                  },
                  ExecArgs: {},
                  Executable: {},
                  MemorySize: {
                    type: "integer"
                  },
                  Pinned: {
                    type: "boolean"
                  },
                  Timeout: {
                    type: "integer"
                  }
                }
              },
              Id: {}
            },
            required: [
              "Id"
            ]
          }
        },
        S1h: {
          type: "structure",
          members: {
            ConnectorDefinitionVersionArn: {},
            CoreDefinitionVersionArn: {},
            DeviceDefinitionVersionArn: {},
            FunctionDefinitionVersionArn: {},
            LoggerDefinitionVersionArn: {},
            ResourceDefinitionVersionArn: {},
            SubscriptionDefinitionVersionArn: {}
          }
        },
        S1o: {
          type: "structure",
          members: {
            Loggers: {
              shape: "S1p"
            }
          }
        },
        S1p: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Component: {},
              Id: {},
              Level: {},
              Space: {
                type: "integer"
              },
              Type: {}
            },
            required: [
              "Type",
              "Level",
              "Id",
              "Component"
            ]
          }
        },
        S1y: {
          type: "structure",
          members: {
            Resources: {
              shape: "S1z"
            }
          }
        },
        S1z: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {},
              Name: {},
              ResourceDataContainer: {
                type: "structure",
                members: {
                  LocalDeviceResourceData: {
                    type: "structure",
                    members: {
                      GroupOwnerSetting: {
                        shape: "S23"
                      },
                      SourcePath: {}
                    }
                  },
                  LocalVolumeResourceData: {
                    type: "structure",
                    members: {
                      DestinationPath: {},
                      GroupOwnerSetting: {
                        shape: "S23"
                      },
                      SourcePath: {}
                    }
                  },
                  S3MachineLearningModelResourceData: {
                    type: "structure",
                    members: {
                      DestinationPath: {},
                      OwnerSetting: {
                        shape: "S26"
                      },
                      S3Uri: {}
                    }
                  },
                  SageMakerMachineLearningModelResourceData: {
                    type: "structure",
                    members: {
                      DestinationPath: {},
                      OwnerSetting: {
                        shape: "S26"
                      },
                      SageMakerJobArn: {}
                    }
                  },
                  SecretsManagerSecretResourceData: {
                    type: "structure",
                    members: {
                      ARN: {},
                      AdditionalStagingLabelsToDownload: {
                        shape: "S29"
                      }
                    }
                  }
                }
              }
            },
            required: [
              "ResourceDataContainer",
              "Id",
              "Name"
            ]
          }
        },
        S23: {
          type: "structure",
          members: {
            AutoAddGroupOwner: {
              type: "boolean"
            },
            GroupOwner: {}
          }
        },
        S26: {
          type: "structure",
          members: {
            GroupOwner: {},
            GroupPermission: {}
          },
          required: [
            "GroupOwner",
            "GroupPermission"
          ]
        },
        S29: {
          type: "list",
          member: {}
        },
        S2m: {
          type: "structure",
          members: {
            Subscriptions: {
              shape: "S2n"
            }
          }
        },
        S2n: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {},
              Source: {},
              Subject: {},
              Target: {}
            },
            required: [
              "Target",
              "Id",
              "Subject",
              "Source"
            ]
          }
        },
        S3i: {
          type: "list",
          member: {
            type: "structure",
            members: {
              DetailedErrorCode: {},
              DetailedErrorMessage: {}
            }
          }
        },
        S3m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              HostAddress: {},
              Id: {},
              Metadata: {},
              PortNumber: {
                type: "integer"
              }
            }
          }
        },
        S58: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              Version: {}
            }
          }
        },
        S5c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Arn: {},
              CreationTimestamp: {},
              Id: {},
              LastUpdatedTimestamp: {},
              LatestVersion: {},
              LatestVersionArn: {},
              Name: {},
              Tags: {
                shape: "Sb",
                locationName: "tags"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/greengrass.js
var require_greengrass = __commonJS({
  "node_modules/aws-sdk/clients/greengrass.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["greengrass"] = {};
    AWS3.Greengrass = Service.defineService("greengrass", ["2017-06-07"]);
    Object.defineProperty(apiLoader.services["greengrass"], "2017-06-07", {
      get: function get() {
        var model = require_greengrass_2017_06_07_min();
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Greengrass;
  }
});

// node_modules/aws-sdk/apis/dax-2017-04-19.min.json
var require_dax_2017_04_19_min = __commonJS({
  "node_modules/aws-sdk/apis/dax-2017-04-19.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-04-19",
        endpointPrefix: "dax",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Amazon DAX",
        serviceFullName: "Amazon DynamoDB Accelerator (DAX)",
        serviceId: "DAX",
        signatureVersion: "v4",
        targetPrefix: "AmazonDAXV3",
        uid: "dax-2017-04-19"
      },
      operations: {
        CreateCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterName",
              "NodeType",
              "ReplicationFactor",
              "IamRoleArn"
            ],
            members: {
              ClusterName: {},
              NodeType: {},
              Description: {},
              ReplicationFactor: {
                type: "integer"
              },
              AvailabilityZones: {
                shape: "S4"
              },
              SubnetGroupName: {},
              SecurityGroupIds: {
                shape: "S5"
              },
              PreferredMaintenanceWindow: {},
              NotificationTopicArn: {},
              IamRoleArn: {},
              ParameterGroupName: {},
              Tags: {
                shape: "S6"
              },
              SSESpecification: {
                type: "structure",
                required: [
                  "Enabled"
                ],
                members: {
                  Enabled: {
                    type: "boolean"
                  }
                }
              },
              ClusterEndpointEncryptionType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "Sc"
              }
            }
          }
        },
        CreateParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName"
            ],
            members: {
              ParameterGroupName: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ParameterGroup: {
                shape: "Sr"
              }
            }
          }
        },
        CreateSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "SubnetGroupName",
              "SubnetIds"
            ],
            members: {
              SubnetGroupName: {},
              Description: {},
              SubnetIds: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SubnetGroup: {
                shape: "Sv"
              }
            }
          }
        },
        DecreaseReplicationFactor: {
          input: {
            type: "structure",
            required: [
              "ClusterName",
              "NewReplicationFactor"
            ],
            members: {
              ClusterName: {},
              NewReplicationFactor: {
                type: "integer"
              },
              AvailabilityZones: {
                shape: "S4"
              },
              NodeIdsToRemove: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "Sc"
              }
            }
          }
        },
        DeleteCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterName"
            ],
            members: {
              ClusterName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "Sc"
              }
            }
          }
        },
        DeleteParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName"
            ],
            members: {
              ParameterGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DeletionMessage: {}
            }
          }
        },
        DeleteSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "SubnetGroupName"
            ],
            members: {
              SubnetGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DeletionMessage: {}
            }
          }
        },
        DescribeClusters: {
          input: {
            type: "structure",
            members: {
              ClusterNames: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Clusters: {
                type: "list",
                member: {
                  shape: "Sc"
                }
              }
            }
          }
        },
        DescribeDefaultParameters: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Parameters: {
                shape: "S1c"
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceName: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceName: {},
                    SourceType: {},
                    Message: {},
                    Date: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeParameterGroups: {
          input: {
            type: "structure",
            members: {
              ParameterGroupNames: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ParameterGroups: {
                type: "list",
                member: {
                  shape: "Sr"
                }
              }
            }
          }
        },
        DescribeParameters: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName"
            ],
            members: {
              ParameterGroupName: {},
              Source: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Parameters: {
                shape: "S1c"
              }
            }
          }
        },
        DescribeSubnetGroups: {
          input: {
            type: "structure",
            members: {
              SubnetGroupNames: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              SubnetGroups: {
                type: "list",
                member: {
                  shape: "Sv"
                }
              }
            }
          }
        },
        IncreaseReplicationFactor: {
          input: {
            type: "structure",
            required: [
              "ClusterName",
              "NewReplicationFactor"
            ],
            members: {
              ClusterName: {},
              NewReplicationFactor: {
                type: "integer"
              },
              AvailabilityZones: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "Sc"
              }
            }
          }
        },
        ListTags: {
          input: {
            type: "structure",
            required: [
              "ResourceName"
            ],
            members: {
              ResourceName: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S6"
              },
              NextToken: {}
            }
          }
        },
        RebootNode: {
          input: {
            type: "structure",
            required: [
              "ClusterName",
              "NodeId"
            ],
            members: {
              ClusterName: {},
              NodeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "Sc"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "Tags"
            ],
            members: {
              ResourceName: {},
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S6"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "TagKeys"
            ],
            members: {
              ResourceName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S6"
              }
            }
          }
        },
        UpdateCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterName"
            ],
            members: {
              ClusterName: {},
              Description: {},
              PreferredMaintenanceWindow: {},
              NotificationTopicArn: {},
              NotificationTopicStatus: {},
              ParameterGroupName: {},
              SecurityGroupIds: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "Sc"
              }
            }
          }
        },
        UpdateParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName",
              "ParameterNameValues"
            ],
            members: {
              ParameterGroupName: {},
              ParameterNameValues: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ParameterName: {},
                    ParameterValue: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ParameterGroup: {
                shape: "Sr"
              }
            }
          }
        },
        UpdateSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "SubnetGroupName"
            ],
            members: {
              SubnetGroupName: {},
              Description: {},
              SubnetIds: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SubnetGroup: {
                shape: "Sv"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {}
        },
        S5: {
          type: "list",
          member: {}
        },
        S6: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sc: {
          type: "structure",
          members: {
            ClusterName: {},
            Description: {},
            ClusterArn: {},
            TotalNodes: {
              type: "integer"
            },
            ActiveNodes: {
              type: "integer"
            },
            NodeType: {},
            Status: {},
            ClusterDiscoveryEndpoint: {
              shape: "Se"
            },
            NodeIdsToRemove: {
              shape: "Sf"
            },
            Nodes: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  NodeId: {},
                  Endpoint: {
                    shape: "Se"
                  },
                  NodeCreateTime: {
                    type: "timestamp"
                  },
                  AvailabilityZone: {},
                  NodeStatus: {},
                  ParameterGroupStatus: {}
                }
              }
            },
            PreferredMaintenanceWindow: {},
            NotificationConfiguration: {
              type: "structure",
              members: {
                TopicArn: {},
                TopicStatus: {}
              }
            },
            SubnetGroup: {},
            SecurityGroups: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  SecurityGroupIdentifier: {},
                  Status: {}
                }
              }
            },
            IamRoleArn: {},
            ParameterGroup: {
              type: "structure",
              members: {
                ParameterGroupName: {},
                ParameterApplyStatus: {},
                NodeIdsToReboot: {
                  shape: "Sf"
                }
              }
            },
            SSEDescription: {
              type: "structure",
              members: {
                Status: {}
              }
            },
            ClusterEndpointEncryptionType: {}
          }
        },
        Se: {
          type: "structure",
          members: {
            Address: {},
            Port: {
              type: "integer"
            },
            URL: {}
          }
        },
        Sf: {
          type: "list",
          member: {}
        },
        Sr: {
          type: "structure",
          members: {
            ParameterGroupName: {},
            Description: {}
          }
        },
        St: {
          type: "list",
          member: {}
        },
        Sv: {
          type: "structure",
          members: {
            SubnetGroupName: {},
            Description: {},
            VpcId: {},
            Subnets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {}
                }
              }
            }
          }
        },
        S1c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ParameterName: {},
              ParameterType: {},
              ParameterValue: {},
              NodeTypeSpecificValues: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    NodeType: {},
                    Value: {}
                  }
                }
              },
              Description: {},
              Source: {},
              DataType: {},
              AllowedValues: {},
              IsModifiable: {},
              ChangeType: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dax-2017-04-19.paginators.json
var require_dax_2017_04_19_paginators = __commonJS({
  "node_modules/aws-sdk/apis/dax-2017-04-19.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/dax.js
var require_dax = __commonJS({
  "node_modules/aws-sdk/clients/dax.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["dax"] = {};
    AWS3.DAX = Service.defineService("dax", ["2017-04-19"]);
    Object.defineProperty(apiLoader.services["dax"], "2017-04-19", {
      get: function get() {
        var model = require_dax_2017_04_19_min();
        model.paginators = require_dax_2017_04_19_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.DAX;
  }
});

// node_modules/aws-sdk/apis/AWSMigrationHub-2017-05-31.min.json
var require_AWSMigrationHub_2017_05_31_min = __commonJS({
  "node_modules/aws-sdk/apis/AWSMigrationHub-2017-05-31.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-05-31",
        endpointPrefix: "mgh",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Migration Hub",
        serviceId: "Migration Hub",
        signatureVersion: "v4",
        targetPrefix: "AWSMigrationHub",
        uid: "AWSMigrationHub-2017-05-31"
      },
      operations: {
        AssociateCreatedArtifact: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStream",
              "MigrationTaskName",
              "CreatedArtifact"
            ],
            members: {
              ProgressUpdateStream: {},
              MigrationTaskName: {},
              CreatedArtifact: {
                shape: "S4"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateDiscoveredResource: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStream",
              "MigrationTaskName",
              "DiscoveredResource"
            ],
            members: {
              ProgressUpdateStream: {},
              MigrationTaskName: {},
              DiscoveredResource: {
                shape: "Sa"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateProgressUpdateStream: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStreamName"
            ],
            members: {
              ProgressUpdateStreamName: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteProgressUpdateStream: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStreamName"
            ],
            members: {
              ProgressUpdateStreamName: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeApplicationState: {
          input: {
            type: "structure",
            required: [
              "ApplicationId"
            ],
            members: {
              ApplicationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationStatus: {},
              LastUpdatedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeMigrationTask: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStream",
              "MigrationTaskName"
            ],
            members: {
              ProgressUpdateStream: {},
              MigrationTaskName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MigrationTask: {
                type: "structure",
                members: {
                  ProgressUpdateStream: {},
                  MigrationTaskName: {},
                  Task: {
                    shape: "Sq"
                  },
                  UpdateDateTime: {
                    type: "timestamp"
                  },
                  ResourceAttributeList: {
                    type: "list",
                    member: {
                      shape: "Sv"
                    }
                  }
                }
              }
            }
          }
        },
        DisassociateCreatedArtifact: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStream",
              "MigrationTaskName",
              "CreatedArtifactName"
            ],
            members: {
              ProgressUpdateStream: {},
              MigrationTaskName: {},
              CreatedArtifactName: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateDiscoveredResource: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStream",
              "MigrationTaskName",
              "ConfigurationId"
            ],
            members: {
              ProgressUpdateStream: {},
              MigrationTaskName: {},
              ConfigurationId: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ImportMigrationTask: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStream",
              "MigrationTaskName"
            ],
            members: {
              ProgressUpdateStream: {},
              MigrationTaskName: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListApplicationStates: {
          input: {
            type: "structure",
            members: {
              ApplicationIds: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationStateList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationId: {},
                    ApplicationStatus: {},
                    LastUpdatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCreatedArtifacts: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStream",
              "MigrationTaskName"
            ],
            members: {
              ProgressUpdateStream: {},
              MigrationTaskName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              CreatedArtifactList: {
                type: "list",
                member: {
                  shape: "S4"
                }
              }
            }
          }
        },
        ListDiscoveredResources: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStream",
              "MigrationTaskName"
            ],
            members: {
              ProgressUpdateStream: {},
              MigrationTaskName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              DiscoveredResourceList: {
                type: "list",
                member: {
                  shape: "Sa"
                }
              }
            }
          }
        },
        ListMigrationTasks: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ResourceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              MigrationTaskSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProgressUpdateStream: {},
                    MigrationTaskName: {},
                    Status: {},
                    ProgressPercent: {
                      type: "integer"
                    },
                    StatusDetail: {},
                    UpdateDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListProgressUpdateStreams: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProgressUpdateStreamSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProgressUpdateStreamName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        NotifyApplicationState: {
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "Status"
            ],
            members: {
              ApplicationId: {},
              Status: {},
              UpdateDateTime: {
                type: "timestamp"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        NotifyMigrationTaskState: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStream",
              "MigrationTaskName",
              "Task",
              "UpdateDateTime",
              "NextUpdateSeconds"
            ],
            members: {
              ProgressUpdateStream: {},
              MigrationTaskName: {},
              Task: {
                shape: "Sq"
              },
              UpdateDateTime: {
                type: "timestamp"
              },
              NextUpdateSeconds: {
                type: "integer"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutResourceAttributes: {
          input: {
            type: "structure",
            required: [
              "ProgressUpdateStream",
              "MigrationTaskName",
              "ResourceAttributeList"
            ],
            members: {
              ProgressUpdateStream: {},
              MigrationTaskName: {},
              ResourceAttributeList: {
                type: "list",
                member: {
                  shape: "Sv"
                }
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            Description: {}
          }
        },
        Sa: {
          type: "structure",
          required: [
            "ConfigurationId"
          ],
          members: {
            ConfigurationId: {},
            Description: {}
          }
        },
        Sq: {
          type: "structure",
          required: [
            "Status"
          ],
          members: {
            Status: {},
            StatusDetail: {},
            ProgressPercent: {
              type: "integer"
            }
          }
        },
        Sv: {
          type: "structure",
          required: [
            "Type",
            "Value"
          ],
          members: {
            Type: {},
            Value: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/AWSMigrationHub-2017-05-31.paginators.json
var require_AWSMigrationHub_2017_05_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/AWSMigrationHub-2017-05-31.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListApplicationStates: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ApplicationStateList"
        },
        ListCreatedArtifacts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CreatedArtifactList"
        },
        ListDiscoveredResources: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DiscoveredResourceList"
        },
        ListMigrationTasks: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "MigrationTaskSummaryList"
        },
        ListProgressUpdateStreams: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ProgressUpdateStreamSummaryList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/migrationhub.js
var require_migrationhub = __commonJS({
  "node_modules/aws-sdk/clients/migrationhub.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["migrationhub"] = {};
    AWS3.MigrationHub = Service.defineService("migrationhub", ["2017-05-31"]);
    Object.defineProperty(apiLoader.services["migrationhub"], "2017-05-31", {
      get: function get() {
        var model = require_AWSMigrationHub_2017_05_31_min();
        model.paginators = require_AWSMigrationHub_2017_05_31_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.MigrationHub;
  }
});

// node_modules/aws-sdk/apis/cloudhsmv2-2017-04-28.min.json
var require_cloudhsmv2_2017_04_28_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudhsmv2-2017-04-28.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-04-28",
        endpointPrefix: "cloudhsmv2",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "CloudHSM V2",
        serviceFullName: "AWS CloudHSM V2",
        serviceId: "CloudHSM V2",
        signatureVersion: "v4",
        signingName: "cloudhsm",
        targetPrefix: "BaldrApiService",
        uid: "cloudhsmv2-2017-04-28"
      },
      operations: {
        CopyBackupToRegion: {
          input: {
            type: "structure",
            required: [
              "DestinationRegion",
              "BackupId"
            ],
            members: {
              DestinationRegion: {},
              BackupId: {},
              TagList: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DestinationBackup: {
                type: "structure",
                members: {
                  CreateTimestamp: {
                    type: "timestamp"
                  },
                  SourceRegion: {},
                  SourceBackup: {},
                  SourceCluster: {}
                }
              }
            }
          }
        },
        CreateCluster: {
          input: {
            type: "structure",
            required: [
              "HsmType",
              "SubnetIds"
            ],
            members: {
              BackupRetentionPolicy: {
                shape: "Sd"
              },
              HsmType: {},
              SourceBackupId: {},
              SubnetIds: {
                type: "list",
                member: {}
              },
              TagList: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "Sk"
              }
            }
          }
        },
        CreateHsm: {
          input: {
            type: "structure",
            required: [
              "ClusterId",
              "AvailabilityZone"
            ],
            members: {
              ClusterId: {},
              AvailabilityZone: {},
              IpAddress: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Hsm: {
                shape: "Sn"
              }
            }
          }
        },
        DeleteBackup: {
          input: {
            type: "structure",
            required: [
              "BackupId"
            ],
            members: {
              BackupId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Backup: {
                shape: "S16"
              }
            }
          }
        },
        DeleteCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "Sk"
              }
            }
          }
        },
        DeleteHsm: {
          input: {
            type: "structure",
            required: [
              "ClusterId"
            ],
            members: {
              ClusterId: {},
              HsmId: {},
              EniId: {},
              EniIp: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HsmId: {}
            }
          }
        },
        DescribeBackups: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S1g"
              },
              SortAscending: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Backups: {
                type: "list",
                member: {
                  shape: "S16"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeClusters: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S1g"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Clusters: {
                type: "list",
                member: {
                  shape: "Sk"
                }
              },
              NextToken: {}
            }
          }
        },
        InitializeCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterId",
              "SignedCert",
              "TrustAnchor"
            ],
            members: {
              ClusterId: {},
              SignedCert: {},
              TrustAnchor: {}
            }
          },
          output: {
            type: "structure",
            members: {
              State: {},
              StateMessage: {}
            }
          }
        },
        ListTags: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TagList"
            ],
            members: {
              TagList: {
                shape: "S4"
              },
              NextToken: {}
            }
          }
        },
        ModifyBackupAttributes: {
          input: {
            type: "structure",
            required: [
              "BackupId",
              "NeverExpires"
            ],
            members: {
              BackupId: {},
              NeverExpires: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Backup: {
                shape: "S16"
              }
            }
          }
        },
        ModifyCluster: {
          input: {
            type: "structure",
            required: [
              "BackupRetentionPolicy",
              "ClusterId"
            ],
            members: {
              BackupRetentionPolicy: {
                shape: "Sd"
              },
              ClusterId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "Sk"
              }
            }
          }
        },
        RestoreBackup: {
          input: {
            type: "structure",
            required: [
              "BackupId"
            ],
            members: {
              BackupId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Backup: {
                shape: "S16"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "TagList"
            ],
            members: {
              ResourceId: {},
              TagList: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "TagKeyList"
            ],
            members: {
              ResourceId: {},
              TagKeyList: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            Type: {},
            Value: {}
          }
        },
        Sk: {
          type: "structure",
          members: {
            BackupPolicy: {},
            BackupRetentionPolicy: {
              shape: "Sd"
            },
            ClusterId: {},
            CreateTimestamp: {
              type: "timestamp"
            },
            Hsms: {
              type: "list",
              member: {
                shape: "Sn"
              }
            },
            HsmType: {},
            PreCoPassword: {},
            SecurityGroup: {},
            SourceBackupId: {},
            State: {},
            StateMessage: {},
            SubnetMapping: {
              type: "map",
              key: {},
              value: {}
            },
            VpcId: {},
            Certificates: {
              type: "structure",
              members: {
                ClusterCsr: {},
                HsmCertificate: {},
                AwsHardwareCertificate: {},
                ManufacturerHardwareCertificate: {},
                ClusterCertificate: {}
              }
            },
            TagList: {
              shape: "S4"
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "HsmId"
          ],
          members: {
            AvailabilityZone: {},
            ClusterId: {},
            SubnetId: {},
            EniId: {},
            EniIp: {},
            HsmId: {},
            State: {},
            StateMessage: {}
          }
        },
        S16: {
          type: "structure",
          required: [
            "BackupId"
          ],
          members: {
            BackupId: {},
            BackupState: {},
            ClusterId: {},
            CreateTimestamp: {
              type: "timestamp"
            },
            CopyTimestamp: {
              type: "timestamp"
            },
            NeverExpires: {
              type: "boolean"
            },
            SourceRegion: {},
            SourceBackup: {},
            SourceCluster: {},
            DeleteTimestamp: {
              type: "timestamp"
            },
            TagList: {
              shape: "S4"
            }
          }
        },
        S1g: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudhsmv2-2017-04-28.paginators.json
var require_cloudhsmv2_2017_04_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudhsmv2-2017-04-28.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeBackups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeClusters: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTags: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cloudhsmv2.js
var require_cloudhsmv2 = __commonJS({
  "node_modules/aws-sdk/clients/cloudhsmv2.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["cloudhsmv2"] = {};
    AWS3.CloudHSMV2 = Service.defineService("cloudhsmv2", ["2017-04-28"]);
    Object.defineProperty(apiLoader.services["cloudhsmv2"], "2017-04-28", {
      get: function get() {
        var model = require_cloudhsmv2_2017_04_28_min();
        model.paginators = require_cloudhsmv2_2017_04_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CloudHSMV2;
  }
});

// node_modules/aws-sdk/apis/glue-2017-03-31.min.json
var require_glue_2017_03_31_min = __commonJS({
  "node_modules/aws-sdk/apis/glue-2017-03-31.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-03-31",
        endpointPrefix: "glue",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Glue",
        serviceId: "Glue",
        signatureVersion: "v4",
        targetPrefix: "AWSGlue",
        uid: "glue-2017-03-31"
      },
      operations: {
        BatchCreatePartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionInputList"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionInputList: {
                type: "list",
                member: {
                  shape: "S5"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                shape: "S11"
              }
            }
          }
        },
        BatchDeleteConnection: {
          input: {
            type: "structure",
            required: [
              "ConnectionNameList"
            ],
            members: {
              CatalogId: {},
              ConnectionNameList: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Succeeded: {
                shape: "Sm"
              },
              Errors: {
                type: "map",
                key: {},
                value: {
                  shape: "S13"
                }
              }
            }
          }
        },
        BatchDeletePartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionsToDelete"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionsToDelete: {
                type: "list",
                member: {
                  shape: "S1b"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                shape: "S11"
              }
            }
          }
        },
        BatchDeleteTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TablesToDelete"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TablesToDelete: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TableName: {},
                    ErrorDetail: {
                      shape: "S13"
                    }
                  }
                }
              }
            }
          }
        },
        BatchDeleteTableVersion: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "VersionIds"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              VersionIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TableName: {},
                    VersionId: {},
                    ErrorDetail: {
                      shape: "S13"
                    }
                  }
                }
              }
            }
          }
        },
        BatchGetBlueprints: {
          input: {
            type: "structure",
            required: [
              "Names"
            ],
            members: {
              Names: {
                type: "list",
                member: {}
              },
              IncludeBlueprint: {
                type: "boolean"
              },
              IncludeParameterSpec: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Blueprints: {
                type: "list",
                member: {
                  shape: "S1u"
                }
              },
              MissingBlueprints: {
                shape: "S22"
              }
            }
          }
        },
        BatchGetCrawlers: {
          input: {
            type: "structure",
            required: [
              "CrawlerNames"
            ],
            members: {
              CrawlerNames: {
                shape: "S24"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Crawlers: {
                shape: "S26"
              },
              CrawlersNotFound: {
                shape: "S24"
              }
            }
          }
        },
        BatchGetDevEndpoints: {
          input: {
            type: "structure",
            required: [
              "DevEndpointNames"
            ],
            members: {
              DevEndpointNames: {
                shape: "S3f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DevEndpoints: {
                shape: "S3h"
              },
              DevEndpointsNotFound: {
                shape: "S3f"
              }
            }
          }
        },
        BatchGetJobs: {
          input: {
            type: "structure",
            required: [
              "JobNames"
            ],
            members: {
              JobNames: {
                shape: "S3r"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Jobs: {
                shape: "S3t"
              },
              JobsNotFound: {
                shape: "S3r"
              }
            }
          }
        },
        BatchGetPartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionsToGet"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionsToGet: {
                shape: "S4a"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Partitions: {
                shape: "S4c"
              },
              UnprocessedKeys: {
                shape: "S4a"
              }
            }
          }
        },
        BatchGetTriggers: {
          input: {
            type: "structure",
            required: [
              "TriggerNames"
            ],
            members: {
              TriggerNames: {
                shape: "S4f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Triggers: {
                shape: "S4h"
              },
              TriggersNotFound: {
                shape: "S4f"
              }
            }
          }
        },
        BatchGetWorkflows: {
          input: {
            type: "structure",
            required: [
              "Names"
            ],
            members: {
              Names: {
                shape: "S4z"
              },
              IncludeGraph: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Workflows: {
                type: "list",
                member: {
                  shape: "S52"
                }
              },
              MissingWorkflows: {
                shape: "S4z"
              }
            }
          }
        },
        BatchStopJobRun: {
          input: {
            type: "structure",
            required: [
              "JobName",
              "JobRunIds"
            ],
            members: {
              JobName: {},
              JobRunIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuccessfulSubmissions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    JobName: {},
                    JobRunId: {}
                  }
                }
              },
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    JobName: {},
                    JobRunId: {},
                    ErrorDetail: {
                      shape: "S13"
                    }
                  }
                }
              }
            }
          }
        },
        BatchUpdatePartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "Entries"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "PartitionValueList",
                    "PartitionInput"
                  ],
                  members: {
                    PartitionValueList: {
                      shape: "S60"
                    },
                    PartitionInput: {
                      shape: "S5"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PartitionValueList: {
                      shape: "S60"
                    },
                    ErrorDetail: {
                      shape: "S13"
                    }
                  }
                }
              }
            }
          }
        },
        CancelMLTaskRun: {
          input: {
            type: "structure",
            required: [
              "TransformId",
              "TaskRunId"
            ],
            members: {
              TransformId: {},
              TaskRunId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TransformId: {},
              TaskRunId: {},
              Status: {}
            }
          }
        },
        CheckSchemaVersionValidity: {
          input: {
            type: "structure",
            required: [
              "DataFormat",
              "SchemaDefinition"
            ],
            members: {
              DataFormat: {},
              SchemaDefinition: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Valid: {
                type: "boolean"
              },
              Error: {}
            }
          }
        },
        CreateBlueprint: {
          input: {
            type: "structure",
            required: [
              "Name",
              "BlueprintLocation"
            ],
            members: {
              Name: {},
              Description: {},
              BlueprintLocation: {},
              Tags: {
                shape: "S6g"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        CreateClassifier: {
          input: {
            type: "structure",
            members: {
              GrokClassifier: {
                type: "structure",
                required: [
                  "Classification",
                  "Name",
                  "GrokPattern"
                ],
                members: {
                  Classification: {},
                  Name: {},
                  GrokPattern: {},
                  CustomPatterns: {}
                }
              },
              XMLClassifier: {
                type: "structure",
                required: [
                  "Classification",
                  "Name"
                ],
                members: {
                  Classification: {},
                  Name: {},
                  RowTag: {}
                }
              },
              JsonClassifier: {
                type: "structure",
                required: [
                  "Name",
                  "JsonPath"
                ],
                members: {
                  Name: {},
                  JsonPath: {}
                }
              },
              CsvClassifier: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {},
                  Delimiter: {},
                  QuoteSymbol: {},
                  ContainsHeader: {},
                  Header: {
                    shape: "S6x"
                  },
                  DisableValueTrimming: {
                    type: "boolean"
                  },
                  AllowSingleColumn: {
                    type: "boolean"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateConnection: {
          input: {
            type: "structure",
            required: [
              "ConnectionInput"
            ],
            members: {
              CatalogId: {},
              ConnectionInput: {
                shape: "S70"
              },
              Tags: {
                shape: "S6g"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateCrawler: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Role",
              "Targets"
            ],
            members: {
              Name: {},
              Role: {},
              DatabaseName: {},
              Description: {},
              Targets: {
                shape: "S29"
              },
              Schedule: {},
              Classifiers: {
                shape: "S2s"
              },
              TablePrefix: {},
              SchemaChangePolicy: {
                shape: "S2v"
              },
              RecrawlPolicy: {
                shape: "S2t"
              },
              LineageConfiguration: {
                shape: "S2y"
              },
              Configuration: {},
              CrawlerSecurityConfiguration: {},
              Tags: {
                shape: "S6g"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDatabase: {
          input: {
            type: "structure",
            required: [
              "DatabaseInput"
            ],
            members: {
              CatalogId: {},
              DatabaseInput: {
                shape: "S7b"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDevEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointName",
              "RoleArn"
            ],
            members: {
              EndpointName: {},
              RoleArn: {},
              SecurityGroupIds: {
                shape: "S3k"
              },
              SubnetId: {},
              PublicKey: {},
              PublicKeys: {
                shape: "S3o"
              },
              NumberOfNodes: {
                type: "integer"
              },
              WorkerType: {},
              GlueVersion: {},
              NumberOfWorkers: {
                type: "integer"
              },
              ExtraPythonLibsS3Path: {},
              ExtraJarsS3Path: {},
              SecurityConfiguration: {},
              Tags: {
                shape: "S6g"
              },
              Arguments: {
                shape: "S3p"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointName: {},
              Status: {},
              SecurityGroupIds: {
                shape: "S3k"
              },
              SubnetId: {},
              RoleArn: {},
              YarnEndpointAddress: {},
              ZeppelinRemoteSparkInterpreterPort: {
                type: "integer"
              },
              NumberOfNodes: {
                type: "integer"
              },
              WorkerType: {},
              GlueVersion: {},
              NumberOfWorkers: {
                type: "integer"
              },
              AvailabilityZone: {},
              VpcId: {},
              ExtraPythonLibsS3Path: {},
              ExtraJarsS3Path: {},
              FailureReason: {},
              SecurityConfiguration: {},
              CreatedTimestamp: {
                type: "timestamp"
              },
              Arguments: {
                shape: "S3p"
              }
            }
          }
        },
        CreateJob: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Role",
              "Command"
            ],
            members: {
              Name: {},
              Description: {},
              LogUri: {},
              Role: {},
              ExecutionProperty: {
                shape: "S3x"
              },
              Command: {
                shape: "S3z"
              },
              DefaultArguments: {
                shape: "S42"
              },
              NonOverridableArguments: {
                shape: "S42"
              },
              Connections: {
                shape: "S43"
              },
              MaxRetries: {
                type: "integer"
              },
              AllocatedCapacity: {
                deprecated: true,
                deprecatedMessage: "This property is deprecated, use MaxCapacity instead.",
                type: "integer"
              },
              Timeout: {
                type: "integer"
              },
              MaxCapacity: {
                type: "double"
              },
              SecurityConfiguration: {},
              Tags: {
                shape: "S6g"
              },
              NotificationProperty: {
                shape: "S47"
              },
              GlueVersion: {},
              NumberOfWorkers: {
                type: "integer"
              },
              WorkerType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        CreateMLTransform: {
          input: {
            type: "structure",
            required: [
              "Name",
              "InputRecordTables",
              "Parameters",
              "Role"
            ],
            members: {
              Name: {},
              Description: {},
              InputRecordTables: {
                shape: "S7q"
              },
              Parameters: {
                shape: "S7s"
              },
              Role: {},
              GlueVersion: {},
              MaxCapacity: {
                type: "double"
              },
              WorkerType: {},
              NumberOfWorkers: {
                type: "integer"
              },
              Timeout: {
                type: "integer"
              },
              MaxRetries: {
                type: "integer"
              },
              Tags: {
                shape: "S6g"
              },
              TransformEncryption: {
                shape: "S7x"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransformId: {}
            }
          }
        },
        CreatePartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionInput"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionInput: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreatePartitionIndex: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionIndex"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionIndex: {
                shape: "S84"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateRegistry: {
          input: {
            type: "structure",
            required: [
              "RegistryName"
            ],
            members: {
              RegistryName: {},
              Description: {},
              Tags: {
                shape: "S6g"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RegistryArn: {},
              RegistryName: {},
              Description: {},
              Tags: {
                shape: "S6g"
              }
            }
          }
        },
        CreateSchema: {
          input: {
            type: "structure",
            required: [
              "SchemaName",
              "DataFormat"
            ],
            members: {
              RegistryId: {
                shape: "S8a"
              },
              SchemaName: {},
              DataFormat: {},
              Compatibility: {},
              Description: {},
              Tags: {
                shape: "S6g"
              },
              SchemaDefinition: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegistryName: {},
              RegistryArn: {},
              SchemaName: {},
              SchemaArn: {},
              Description: {},
              DataFormat: {},
              Compatibility: {},
              SchemaCheckpoint: {
                type: "long"
              },
              LatestSchemaVersion: {
                type: "long"
              },
              NextSchemaVersion: {
                type: "long"
              },
              SchemaStatus: {},
              Tags: {
                shape: "S6g"
              },
              SchemaVersionId: {},
              SchemaVersionStatus: {}
            }
          }
        },
        CreateScript: {
          input: {
            type: "structure",
            members: {
              DagNodes: {
                shape: "S8h"
              },
              DagEdges: {
                shape: "S8p"
              },
              Language: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PythonScript: {},
              ScalaCode: {}
            }
          }
        },
        CreateSecurityConfiguration: {
          input: {
            type: "structure",
            required: [
              "Name",
              "EncryptionConfiguration"
            ],
            members: {
              Name: {},
              EncryptionConfiguration: {
                shape: "S8w"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              CreatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        CreateTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableInput"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableInput: {
                shape: "S97"
              },
              PartitionIndexes: {
                type: "list",
                member: {
                  shape: "S84"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateTrigger: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Type",
              "Actions"
            ],
            members: {
              Name: {},
              WorkflowName: {},
              Type: {},
              Schedule: {},
              Predicate: {
                shape: "S4o"
              },
              Actions: {
                shape: "S4m"
              },
              Description: {},
              StartOnCreation: {
                type: "boolean"
              },
              Tags: {
                shape: "S6g"
              },
              EventBatchingCondition: {
                shape: "S4v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        CreateUserDefinedFunction: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "FunctionInput"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              FunctionInput: {
                shape: "S9i"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateWorkflow: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              DefaultRunProperties: {
                shape: "S53"
              },
              Tags: {
                shape: "S6g"
              },
              MaxConcurrentRuns: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        DeleteBlueprint: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        DeleteClassifier: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteColumnStatisticsForPartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionValues",
              "ColumnName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionValues: {
                shape: "S6"
              },
              ColumnName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteColumnStatisticsForTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "ColumnName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              ColumnName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteConnection: {
          input: {
            type: "structure",
            required: [
              "ConnectionName"
            ],
            members: {
              CatalogId: {},
              ConnectionName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCrawler: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDatabase: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              CatalogId: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDevEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointName"
            ],
            members: {
              EndpointName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteJob: {
          input: {
            type: "structure",
            required: [
              "JobName"
            ],
            members: {
              JobName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobName: {}
            }
          }
        },
        DeleteMLTransform: {
          input: {
            type: "structure",
            required: [
              "TransformId"
            ],
            members: {
              TransformId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TransformId: {}
            }
          }
        },
        DeletePartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionValues"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionValues: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePartitionIndex: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "IndexName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              IndexName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRegistry: {
          input: {
            type: "structure",
            required: [
              "RegistryId"
            ],
            members: {
              RegistryId: {
                shape: "S8a"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RegistryName: {},
              RegistryArn: {},
              Status: {}
            }
          }
        },
        DeleteResourcePolicy: {
          input: {
            type: "structure",
            members: {
              PolicyHashCondition: {},
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSchema: {
          input: {
            type: "structure",
            required: [
              "SchemaId"
            ],
            members: {
              SchemaId: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArn: {},
              SchemaName: {},
              Status: {}
            }
          }
        },
        DeleteSchemaVersions: {
          input: {
            type: "structure",
            required: [
              "SchemaId",
              "Versions"
            ],
            members: {
              SchemaId: {
                shape: "Sv"
              },
              Versions: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaVersionErrors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VersionNumber: {
                      type: "long"
                    },
                    ErrorDetails: {
                      type: "structure",
                      members: {
                        ErrorCode: {},
                        ErrorMessage: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DeleteSecurityConfiguration: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "Name"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTableVersion: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "VersionId"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              VersionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTrigger: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        DeleteUserDefinedFunction: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "FunctionName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              FunctionName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWorkflow: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        GetBlueprint: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              IncludeBlueprint: {
                type: "boolean"
              },
              IncludeParameterSpec: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Blueprint: {
                shape: "S1u"
              }
            }
          }
        },
        GetBlueprintRun: {
          input: {
            type: "structure",
            required: [
              "BlueprintName",
              "RunId"
            ],
            members: {
              BlueprintName: {},
              RunId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BlueprintRun: {
                shape: "Sb9"
              }
            }
          }
        },
        GetBlueprintRuns: {
          input: {
            type: "structure",
            required: [
              "BlueprintName"
            ],
            members: {
              BlueprintName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BlueprintRuns: {
                type: "list",
                member: {
                  shape: "Sb9"
                }
              },
              NextToken: {}
            }
          }
        },
        GetCatalogImportStatus: {
          input: {
            type: "structure",
            members: {
              CatalogId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImportStatus: {
                type: "structure",
                members: {
                  ImportCompleted: {
                    type: "boolean"
                  },
                  ImportTime: {
                    type: "timestamp"
                  },
                  ImportedBy: {}
                }
              }
            }
          }
        },
        GetClassifier: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Classifier: {
                shape: "Sbn"
              }
            }
          }
        },
        GetClassifiers: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Classifiers: {
                type: "list",
                member: {
                  shape: "Sbn"
                }
              },
              NextToken: {}
            }
          }
        },
        GetColumnStatisticsForPartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionValues",
              "ColumnNames"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionValues: {
                shape: "S6"
              },
              ColumnNames: {
                shape: "Sbx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ColumnStatisticsList: {
                shape: "Sbz"
              },
              Errors: {
                shape: "Sch"
              }
            }
          }
        },
        GetColumnStatisticsForTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "ColumnNames"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              ColumnNames: {
                shape: "Sbx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ColumnStatisticsList: {
                shape: "Sbz"
              },
              Errors: {
                shape: "Sch"
              }
            }
          }
        },
        GetConnection: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              CatalogId: {},
              Name: {},
              HidePassword: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "Scn"
              }
            }
          }
        },
        GetConnections: {
          input: {
            type: "structure",
            members: {
              CatalogId: {},
              Filter: {
                type: "structure",
                members: {
                  MatchCriteria: {
                    shape: "S72"
                  },
                  ConnectionType: {}
                }
              },
              HidePassword: {
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionList: {
                type: "list",
                member: {
                  shape: "Scn"
                }
              },
              NextToken: {}
            }
          }
        },
        GetCrawler: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Crawler: {
                shape: "S27"
              }
            }
          }
        },
        GetCrawlerMetrics: {
          input: {
            type: "structure",
            members: {
              CrawlerNameList: {
                shape: "S24"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CrawlerMetricsList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CrawlerName: {},
                    TimeLeftSeconds: {
                      type: "double"
                    },
                    StillEstimating: {
                      type: "boolean"
                    },
                    LastRuntimeSeconds: {
                      type: "double"
                    },
                    MedianRuntimeSeconds: {
                      type: "double"
                    },
                    TablesCreated: {
                      type: "integer"
                    },
                    TablesUpdated: {
                      type: "integer"
                    },
                    TablesDeleted: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetCrawlers: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Crawlers: {
                shape: "S26"
              },
              NextToken: {}
            }
          }
        },
        GetDataCatalogEncryptionSettings: {
          input: {
            type: "structure",
            members: {
              CatalogId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DataCatalogEncryptionSettings: {
                shape: "Sd2"
              }
            }
          }
        },
        GetDatabase: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              CatalogId: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Database: {
                shape: "Sd8"
              }
            }
          }
        },
        GetDatabases: {
          input: {
            type: "structure",
            members: {
              CatalogId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ResourceShareType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DatabaseList"
            ],
            members: {
              DatabaseList: {
                type: "list",
                member: {
                  shape: "Sd8"
                }
              },
              NextToken: {}
            }
          }
        },
        GetDataflowGraph: {
          input: {
            type: "structure",
            members: {
              PythonScript: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DagNodes: {
                shape: "S8h"
              },
              DagEdges: {
                shape: "S8p"
              }
            }
          }
        },
        GetDevEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointName"
            ],
            members: {
              EndpointName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DevEndpoint: {
                shape: "S3i"
              }
            }
          }
        },
        GetDevEndpoints: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DevEndpoints: {
                shape: "S3h"
              },
              NextToken: {}
            }
          }
        },
        GetJob: {
          input: {
            type: "structure",
            required: [
              "JobName"
            ],
            members: {
              JobName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Job: {
                shape: "S3u"
              }
            }
          }
        },
        GetJobBookmark: {
          input: {
            type: "structure",
            required: [
              "JobName"
            ],
            members: {
              JobName: {},
              RunId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobBookmarkEntry: {
                shape: "Sdq"
              }
            }
          }
        },
        GetJobRun: {
          input: {
            type: "structure",
            required: [
              "JobName",
              "RunId"
            ],
            members: {
              JobName: {},
              RunId: {},
              PredecessorsIncluded: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobRun: {
                shape: "S5e"
              }
            }
          }
        },
        GetJobRuns: {
          input: {
            type: "structure",
            required: [
              "JobName"
            ],
            members: {
              JobName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobRuns: {
                shape: "S5d"
              },
              NextToken: {}
            }
          }
        },
        GetJobs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Jobs: {
                shape: "S3t"
              },
              NextToken: {}
            }
          }
        },
        GetMLTaskRun: {
          input: {
            type: "structure",
            required: [
              "TransformId",
              "TaskRunId"
            ],
            members: {
              TransformId: {},
              TaskRunId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TransformId: {},
              TaskRunId: {},
              Status: {},
              LogGroupName: {},
              Properties: {
                shape: "Se0"
              },
              ErrorString: {},
              StartedOn: {
                type: "timestamp"
              },
              LastModifiedOn: {
                type: "timestamp"
              },
              CompletedOn: {
                type: "timestamp"
              },
              ExecutionTime: {
                type: "integer"
              }
            }
          }
        },
        GetMLTaskRuns: {
          input: {
            type: "structure",
            required: [
              "TransformId"
            ],
            members: {
              TransformId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filter: {
                type: "structure",
                members: {
                  TaskRunType: {},
                  Status: {},
                  StartedBefore: {
                    type: "timestamp"
                  },
                  StartedAfter: {
                    type: "timestamp"
                  }
                }
              },
              Sort: {
                type: "structure",
                required: [
                  "Column",
                  "SortDirection"
                ],
                members: {
                  Column: {},
                  SortDirection: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TaskRuns: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TransformId: {},
                    TaskRunId: {},
                    Status: {},
                    LogGroupName: {},
                    Properties: {
                      shape: "Se0"
                    },
                    ErrorString: {},
                    StartedOn: {
                      type: "timestamp"
                    },
                    LastModifiedOn: {
                      type: "timestamp"
                    },
                    CompletedOn: {
                      type: "timestamp"
                    },
                    ExecutionTime: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetMLTransform: {
          input: {
            type: "structure",
            required: [
              "TransformId"
            ],
            members: {
              TransformId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TransformId: {},
              Name: {},
              Description: {},
              Status: {},
              CreatedOn: {
                type: "timestamp"
              },
              LastModifiedOn: {
                type: "timestamp"
              },
              InputRecordTables: {
                shape: "S7q"
              },
              Parameters: {
                shape: "S7s"
              },
              EvaluationMetrics: {
                shape: "Sej"
              },
              LabelCount: {
                type: "integer"
              },
              Schema: {
                shape: "Seq"
              },
              Role: {},
              GlueVersion: {},
              MaxCapacity: {
                type: "double"
              },
              WorkerType: {},
              NumberOfWorkers: {
                type: "integer"
              },
              Timeout: {
                type: "integer"
              },
              MaxRetries: {
                type: "integer"
              },
              TransformEncryption: {
                shape: "S7x"
              }
            }
          }
        },
        GetMLTransforms: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filter: {
                shape: "Set"
              },
              Sort: {
                shape: "Seu"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Transforms"
            ],
            members: {
              Transforms: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TransformId: {},
                    Name: {},
                    Description: {},
                    Status: {},
                    CreatedOn: {
                      type: "timestamp"
                    },
                    LastModifiedOn: {
                      type: "timestamp"
                    },
                    InputRecordTables: {
                      shape: "S7q"
                    },
                    Parameters: {
                      shape: "S7s"
                    },
                    EvaluationMetrics: {
                      shape: "Sej"
                    },
                    LabelCount: {
                      type: "integer"
                    },
                    Schema: {
                      shape: "Seq"
                    },
                    Role: {},
                    GlueVersion: {},
                    MaxCapacity: {
                      type: "double"
                    },
                    WorkerType: {},
                    NumberOfWorkers: {
                      type: "integer"
                    },
                    Timeout: {
                      type: "integer"
                    },
                    MaxRetries: {
                      type: "integer"
                    },
                    TransformEncryption: {
                      shape: "S7x"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetMapping: {
          input: {
            type: "structure",
            required: [
              "Source"
            ],
            members: {
              Source: {
                shape: "Sf0"
              },
              Sinks: {
                shape: "Sf1"
              },
              Location: {
                shape: "Sf2"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Mapping"
            ],
            members: {
              Mapping: {
                shape: "Sf4"
              }
            }
          }
        },
        GetPartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionValues"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionValues: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Partition: {
                shape: "S4d"
              }
            }
          }
        },
        GetPartitionIndexes: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PartitionIndexDescriptorList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "IndexName",
                    "Keys",
                    "IndexStatus"
                  ],
                  members: {
                    IndexName: {},
                    Keys: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Name",
                          "Type"
                        ],
                        members: {
                          Name: {},
                          Type: {}
                        }
                      }
                    },
                    IndexStatus: {},
                    BackfillErrors: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Code: {},
                          Partitions: {
                            type: "list",
                            member: {
                              shape: "S1b"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetPartitions: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              Expression: {},
              NextToken: {},
              Segment: {
                type: "structure",
                required: [
                  "SegmentNumber",
                  "TotalSegments"
                ],
                members: {
                  SegmentNumber: {
                    type: "integer"
                  },
                  TotalSegments: {
                    type: "integer"
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              ExcludeColumnSchema: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Partitions: {
                shape: "S4c"
              },
              NextToken: {}
            }
          }
        },
        GetPlan: {
          input: {
            type: "structure",
            required: [
              "Mapping",
              "Source"
            ],
            members: {
              Mapping: {
                shape: "Sf4"
              },
              Source: {
                shape: "Sf0"
              },
              Sinks: {
                shape: "Sf1"
              },
              Location: {
                shape: "Sf2"
              },
              Language: {},
              AdditionalPlanOptionsMap: {
                type: "map",
                key: {},
                value: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PythonScript: {},
              ScalaCode: {}
            }
          }
        },
        GetRegistry: {
          input: {
            type: "structure",
            required: [
              "RegistryId"
            ],
            members: {
              RegistryId: {
                shape: "S8a"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RegistryName: {},
              RegistryArn: {},
              Description: {},
              Status: {},
              CreatedTime: {},
              UpdatedTime: {}
            }
          }
        },
        GetResourcePolicies: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GetResourcePoliciesResponseList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PolicyInJson: {},
                    PolicyHash: {},
                    CreateTime: {
                      type: "timestamp"
                    },
                    UpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetResourcePolicy: {
          input: {
            type: "structure",
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyInJson: {},
              PolicyHash: {},
              CreateTime: {
                type: "timestamp"
              },
              UpdateTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetSchema: {
          input: {
            type: "structure",
            required: [
              "SchemaId"
            ],
            members: {
              SchemaId: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RegistryName: {},
              RegistryArn: {},
              SchemaName: {},
              SchemaArn: {},
              Description: {},
              DataFormat: {},
              Compatibility: {},
              SchemaCheckpoint: {
                type: "long"
              },
              LatestSchemaVersion: {
                type: "long"
              },
              NextSchemaVersion: {
                type: "long"
              },
              SchemaStatus: {},
              CreatedTime: {},
              UpdatedTime: {}
            }
          }
        },
        GetSchemaByDefinition: {
          input: {
            type: "structure",
            required: [
              "SchemaId",
              "SchemaDefinition"
            ],
            members: {
              SchemaId: {
                shape: "Sv"
              },
              SchemaDefinition: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaVersionId: {},
              SchemaArn: {},
              DataFormat: {},
              Status: {},
              CreatedTime: {}
            }
          }
        },
        GetSchemaVersion: {
          input: {
            type: "structure",
            members: {
              SchemaId: {
                shape: "Sv"
              },
              SchemaVersionId: {},
              SchemaVersionNumber: {
                shape: "Sgb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaVersionId: {},
              SchemaDefinition: {},
              DataFormat: {},
              SchemaArn: {},
              VersionNumber: {
                type: "long"
              },
              Status: {},
              CreatedTime: {}
            }
          }
        },
        GetSchemaVersionsDiff: {
          input: {
            type: "structure",
            required: [
              "SchemaId",
              "FirstSchemaVersionNumber",
              "SecondSchemaVersionNumber",
              "SchemaDiffType"
            ],
            members: {
              SchemaId: {
                shape: "Sv"
              },
              FirstSchemaVersionNumber: {
                shape: "Sgb"
              },
              SecondSchemaVersionNumber: {
                shape: "Sgb"
              },
              SchemaDiffType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Diff: {}
            }
          }
        },
        GetSecurityConfiguration: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityConfiguration: {
                shape: "Sgk"
              }
            }
          }
        },
        GetSecurityConfigurations: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityConfigurations: {
                type: "list",
                member: {
                  shape: "Sgk"
                }
              },
              NextToken: {}
            }
          }
        },
        GetTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "Name"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Table: {
                shape: "Sgq"
              }
            }
          }
        },
        GetTableVersion: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              VersionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TableVersion: {
                shape: "Sgt"
              }
            }
          }
        },
        GetTableVersions: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableVersions: {
                type: "list",
                member: {
                  shape: "Sgt"
                }
              },
              NextToken: {}
            }
          }
        },
        GetTables: {
          input: {
            type: "structure",
            required: [
              "DatabaseName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              Expression: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TableList: {
                shape: "Sh0"
              },
              NextToken: {}
            }
          }
        },
        GetTags: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S6g"
              }
            }
          }
        },
        GetTrigger: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Trigger: {
                shape: "S4i"
              }
            }
          }
        },
        GetTriggers: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              DependentJobName: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Triggers: {
                shape: "S4h"
              },
              NextToken: {}
            }
          }
        },
        GetUserDefinedFunction: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "FunctionName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              FunctionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserDefinedFunction: {
                shape: "Sh9"
              }
            }
          }
        },
        GetUserDefinedFunctions: {
          input: {
            type: "structure",
            required: [
              "Pattern"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              Pattern: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserDefinedFunctions: {
                type: "list",
                member: {
                  shape: "Sh9"
                }
              },
              NextToken: {}
            }
          }
        },
        GetWorkflow: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              IncludeGraph: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Workflow: {
                shape: "S52"
              }
            }
          }
        },
        GetWorkflowRun: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RunId"
            ],
            members: {
              Name: {},
              RunId: {},
              IncludeGraph: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Run: {
                shape: "S54"
              }
            }
          }
        },
        GetWorkflowRunProperties: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RunId"
            ],
            members: {
              Name: {},
              RunId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RunProperties: {
                shape: "S53"
              }
            }
          }
        },
        GetWorkflowRuns: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              IncludeGraph: {
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Runs: {
                type: "list",
                member: {
                  shape: "S54"
                }
              },
              NextToken: {}
            }
          }
        },
        ImportCatalogToGlue: {
          input: {
            type: "structure",
            members: {
              CatalogId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListBlueprints: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Tags: {
                shape: "S6g"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Blueprints: {
                shape: "S22"
              },
              NextToken: {}
            }
          }
        },
        ListCrawlers: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Tags: {
                shape: "S6g"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CrawlerNames: {
                shape: "S24"
              },
              NextToken: {}
            }
          }
        },
        ListDevEndpoints: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Tags: {
                shape: "S6g"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DevEndpointNames: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListJobs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Tags: {
                shape: "S6g"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobNames: {
                shape: "S3r"
              },
              NextToken: {}
            }
          }
        },
        ListMLTransforms: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filter: {
                shape: "Set"
              },
              Sort: {
                shape: "Seu"
              },
              Tags: {
                shape: "S6g"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TransformIds"
            ],
            members: {
              TransformIds: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListRegistries: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Registries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RegistryName: {},
                    RegistryArn: {},
                    Description: {},
                    Status: {},
                    CreatedTime: {},
                    UpdatedTime: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSchemaVersions: {
          input: {
            type: "structure",
            required: [
              "SchemaId"
            ],
            members: {
              SchemaId: {
                shape: "Sv"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Schemas: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SchemaArn: {},
                    SchemaVersionId: {},
                    VersionNumber: {
                      type: "long"
                    },
                    Status: {},
                    CreatedTime: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSchemas: {
          input: {
            type: "structure",
            members: {
              RegistryId: {
                shape: "S8a"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Schemas: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RegistryName: {},
                    SchemaName: {},
                    SchemaArn: {},
                    Description: {},
                    SchemaStatus: {},
                    CreatedTime: {},
                    UpdatedTime: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTriggers: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              DependentJobName: {},
              MaxResults: {
                type: "integer"
              },
              Tags: {
                shape: "S6g"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TriggerNames: {
                shape: "S4f"
              },
              NextToken: {}
            }
          }
        },
        ListWorkflows: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Workflows: {
                shape: "S4z"
              },
              NextToken: {}
            }
          }
        },
        PutDataCatalogEncryptionSettings: {
          input: {
            type: "structure",
            required: [
              "DataCatalogEncryptionSettings"
            ],
            members: {
              CatalogId: {},
              DataCatalogEncryptionSettings: {
                shape: "Sd2"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyInJson"
            ],
            members: {
              PolicyInJson: {},
              ResourceArn: {},
              PolicyHashCondition: {},
              PolicyExistsCondition: {},
              EnableHybrid: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyHash: {}
            }
          }
        },
        PutSchemaVersionMetadata: {
          input: {
            type: "structure",
            required: [
              "MetadataKeyValue"
            ],
            members: {
              SchemaId: {
                shape: "Sv"
              },
              SchemaVersionNumber: {
                shape: "Sgb"
              },
              SchemaVersionId: {},
              MetadataKeyValue: {
                shape: "Sip"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArn: {},
              SchemaName: {},
              RegistryName: {},
              LatestVersion: {
                type: "boolean"
              },
              VersionNumber: {
                type: "long"
              },
              SchemaVersionId: {},
              MetadataKey: {},
              MetadataValue: {}
            }
          }
        },
        PutWorkflowRunProperties: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RunId",
              "RunProperties"
            ],
            members: {
              Name: {},
              RunId: {},
              RunProperties: {
                shape: "S53"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        QuerySchemaVersionMetadata: {
          input: {
            type: "structure",
            members: {
              SchemaId: {
                shape: "Sv"
              },
              SchemaVersionNumber: {
                shape: "Sgb"
              },
              SchemaVersionId: {},
              MetadataList: {
                type: "list",
                member: {
                  shape: "Sip"
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MetadataInfoMap: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    MetadataValue: {},
                    CreatedTime: {},
                    OtherMetadataValueList: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          MetadataValue: {},
                          CreatedTime: {}
                        }
                      }
                    }
                  }
                }
              },
              SchemaVersionId: {},
              NextToken: {}
            }
          }
        },
        RegisterSchemaVersion: {
          input: {
            type: "structure",
            required: [
              "SchemaId",
              "SchemaDefinition"
            ],
            members: {
              SchemaId: {
                shape: "Sv"
              },
              SchemaDefinition: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaVersionId: {},
              VersionNumber: {
                type: "long"
              },
              Status: {}
            }
          }
        },
        RemoveSchemaVersionMetadata: {
          input: {
            type: "structure",
            required: [
              "MetadataKeyValue"
            ],
            members: {
              SchemaId: {
                shape: "Sv"
              },
              SchemaVersionNumber: {
                shape: "Sgb"
              },
              SchemaVersionId: {},
              MetadataKeyValue: {
                shape: "Sip"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArn: {},
              SchemaName: {},
              RegistryName: {},
              LatestVersion: {
                type: "boolean"
              },
              VersionNumber: {
                type: "long"
              },
              SchemaVersionId: {},
              MetadataKey: {},
              MetadataValue: {}
            }
          }
        },
        ResetJobBookmark: {
          input: {
            type: "structure",
            required: [
              "JobName"
            ],
            members: {
              JobName: {},
              RunId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobBookmarkEntry: {
                shape: "Sdq"
              }
            }
          }
        },
        ResumeWorkflowRun: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RunId",
              "NodeIds"
            ],
            members: {
              Name: {},
              RunId: {},
              NodeIds: {
                shape: "Sja"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RunId: {},
              NodeIds: {
                shape: "Sja"
              }
            }
          }
        },
        SearchTables: {
          input: {
            type: "structure",
            members: {
              CatalogId: {},
              NextToken: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {},
                    Value: {},
                    Comparator: {}
                  }
                }
              },
              SearchText: {},
              SortCriteria: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FieldName: {},
                    Sort: {}
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              ResourceShareType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              TableList: {
                shape: "Sh0"
              }
            }
          }
        },
        StartBlueprintRun: {
          input: {
            type: "structure",
            required: [
              "BlueprintName",
              "RoleArn"
            ],
            members: {
              BlueprintName: {},
              Parameters: {},
              RoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RunId: {}
            }
          }
        },
        StartCrawler: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartCrawlerSchedule: {
          input: {
            type: "structure",
            required: [
              "CrawlerName"
            ],
            members: {
              CrawlerName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartExportLabelsTaskRun: {
          input: {
            type: "structure",
            required: [
              "TransformId",
              "OutputS3Path"
            ],
            members: {
              TransformId: {},
              OutputS3Path: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TaskRunId: {}
            }
          }
        },
        StartImportLabelsTaskRun: {
          input: {
            type: "structure",
            required: [
              "TransformId",
              "InputS3Path"
            ],
            members: {
              TransformId: {},
              InputS3Path: {},
              ReplaceAllLabels: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TaskRunId: {}
            }
          }
        },
        StartJobRun: {
          input: {
            type: "structure",
            required: [
              "JobName"
            ],
            members: {
              JobName: {},
              JobRunId: {},
              Arguments: {
                shape: "S42"
              },
              AllocatedCapacity: {
                deprecated: true,
                deprecatedMessage: "This property is deprecated, use MaxCapacity instead.",
                type: "integer"
              },
              Timeout: {
                type: "integer"
              },
              MaxCapacity: {
                type: "double"
              },
              SecurityConfiguration: {},
              NotificationProperty: {
                shape: "S47"
              },
              WorkerType: {},
              NumberOfWorkers: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobRunId: {}
            }
          }
        },
        StartMLEvaluationTaskRun: {
          input: {
            type: "structure",
            required: [
              "TransformId"
            ],
            members: {
              TransformId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TaskRunId: {}
            }
          }
        },
        StartMLLabelingSetGenerationTaskRun: {
          input: {
            type: "structure",
            required: [
              "TransformId",
              "OutputS3Path"
            ],
            members: {
              TransformId: {},
              OutputS3Path: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TaskRunId: {}
            }
          }
        },
        StartTrigger: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        StartWorkflowRun: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RunId: {}
            }
          }
        },
        StopCrawler: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopCrawlerSchedule: {
          input: {
            type: "structure",
            required: [
              "CrawlerName"
            ],
            members: {
              CrawlerName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopTrigger: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        StopWorkflowRun: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RunId"
            ],
            members: {
              Name: {},
              RunId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagsToAdd"
            ],
            members: {
              ResourceArn: {},
              TagsToAdd: {
                shape: "S6g"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagsToRemove"
            ],
            members: {
              ResourceArn: {},
              TagsToRemove: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateBlueprint: {
          input: {
            type: "structure",
            required: [
              "Name",
              "BlueprintLocation"
            ],
            members: {
              Name: {},
              Description: {},
              BlueprintLocation: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        UpdateClassifier: {
          input: {
            type: "structure",
            members: {
              GrokClassifier: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {},
                  Classification: {},
                  GrokPattern: {},
                  CustomPatterns: {}
                }
              },
              XMLClassifier: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {},
                  Classification: {},
                  RowTag: {}
                }
              },
              JsonClassifier: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {},
                  JsonPath: {}
                }
              },
              CsvClassifier: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {},
                  Delimiter: {},
                  QuoteSymbol: {},
                  ContainsHeader: {},
                  Header: {
                    shape: "S6x"
                  },
                  DisableValueTrimming: {
                    type: "boolean"
                  },
                  AllowSingleColumn: {
                    type: "boolean"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateColumnStatisticsForPartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionValues",
              "ColumnStatisticsList"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionValues: {
                shape: "S6"
              },
              ColumnStatisticsList: {
                shape: "Skq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                shape: "Sks"
              }
            }
          }
        },
        UpdateColumnStatisticsForTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "ColumnStatisticsList"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              ColumnStatisticsList: {
                shape: "Skq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                shape: "Sks"
              }
            }
          }
        },
        UpdateConnection: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ConnectionInput"
            ],
            members: {
              CatalogId: {},
              Name: {},
              ConnectionInput: {
                shape: "S70"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateCrawler: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Role: {},
              DatabaseName: {},
              Description: {},
              Targets: {
                shape: "S29"
              },
              Schedule: {},
              Classifiers: {
                shape: "S2s"
              },
              TablePrefix: {},
              SchemaChangePolicy: {
                shape: "S2v"
              },
              RecrawlPolicy: {
                shape: "S2t"
              },
              LineageConfiguration: {
                shape: "S2y"
              },
              Configuration: {},
              CrawlerSecurityConfiguration: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateCrawlerSchedule: {
          input: {
            type: "structure",
            required: [
              "CrawlerName"
            ],
            members: {
              CrawlerName: {},
              Schedule: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDatabase: {
          input: {
            type: "structure",
            required: [
              "Name",
              "DatabaseInput"
            ],
            members: {
              CatalogId: {},
              Name: {},
              DatabaseInput: {
                shape: "S7b"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDevEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointName"
            ],
            members: {
              EndpointName: {},
              PublicKey: {},
              AddPublicKeys: {
                shape: "S3o"
              },
              DeletePublicKeys: {
                shape: "S3o"
              },
              CustomLibraries: {
                type: "structure",
                members: {
                  ExtraPythonLibsS3Path: {},
                  ExtraJarsS3Path: {}
                }
              },
              UpdateEtlLibraries: {
                type: "boolean"
              },
              DeleteArguments: {
                shape: "S3k"
              },
              AddArguments: {
                shape: "S3p"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateJob: {
          input: {
            type: "structure",
            required: [
              "JobName",
              "JobUpdate"
            ],
            members: {
              JobName: {},
              JobUpdate: {
                type: "structure",
                members: {
                  Description: {},
                  LogUri: {},
                  Role: {},
                  ExecutionProperty: {
                    shape: "S3x"
                  },
                  Command: {
                    shape: "S3z"
                  },
                  DefaultArguments: {
                    shape: "S42"
                  },
                  NonOverridableArguments: {
                    shape: "S42"
                  },
                  Connections: {
                    shape: "S43"
                  },
                  MaxRetries: {
                    type: "integer"
                  },
                  AllocatedCapacity: {
                    deprecated: true,
                    deprecatedMessage: "This property is deprecated, use MaxCapacity instead.",
                    type: "integer"
                  },
                  Timeout: {
                    type: "integer"
                  },
                  MaxCapacity: {
                    type: "double"
                  },
                  WorkerType: {},
                  NumberOfWorkers: {
                    type: "integer"
                  },
                  SecurityConfiguration: {},
                  NotificationProperty: {
                    shape: "S47"
                  },
                  GlueVersion: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobName: {}
            }
          }
        },
        UpdateMLTransform: {
          input: {
            type: "structure",
            required: [
              "TransformId"
            ],
            members: {
              TransformId: {},
              Name: {},
              Description: {},
              Parameters: {
                shape: "S7s"
              },
              Role: {},
              GlueVersion: {},
              MaxCapacity: {
                type: "double"
              },
              WorkerType: {},
              NumberOfWorkers: {
                type: "integer"
              },
              Timeout: {
                type: "integer"
              },
              MaxRetries: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransformId: {}
            }
          }
        },
        UpdatePartition: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "PartitionValueList",
              "PartitionInput"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              PartitionValueList: {
                shape: "S60"
              },
              PartitionInput: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRegistry: {
          input: {
            type: "structure",
            required: [
              "RegistryId",
              "Description"
            ],
            members: {
              RegistryId: {
                shape: "S8a"
              },
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegistryName: {},
              RegistryArn: {}
            }
          }
        },
        UpdateSchema: {
          input: {
            type: "structure",
            required: [
              "SchemaId"
            ],
            members: {
              SchemaId: {
                shape: "Sv"
              },
              SchemaVersionNumber: {
                shape: "Sgb"
              },
              Compatibility: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SchemaArn: {},
              SchemaName: {},
              RegistryName: {}
            }
          }
        },
        UpdateTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableInput"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableInput: {
                shape: "S97"
              },
              SkipArchive: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateTrigger: {
          input: {
            type: "structure",
            required: [
              "Name",
              "TriggerUpdate"
            ],
            members: {
              Name: {},
              TriggerUpdate: {
                type: "structure",
                members: {
                  Name: {},
                  Description: {},
                  Schedule: {},
                  Actions: {
                    shape: "S4m"
                  },
                  Predicate: {
                    shape: "S4o"
                  },
                  EventBatchingCondition: {
                    shape: "S4v"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Trigger: {
                shape: "S4i"
              }
            }
          }
        },
        UpdateUserDefinedFunction: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "FunctionName",
              "FunctionInput"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              FunctionName: {},
              FunctionInput: {
                shape: "S9i"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateWorkflow: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              DefaultRunProperties: {
                shape: "S53"
              },
              MaxConcurrentRuns: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            Values: {
              shape: "S6"
            },
            LastAccessTime: {
              type: "timestamp"
            },
            StorageDescriptor: {
              shape: "S9"
            },
            Parameters: {
              shape: "Se"
            },
            LastAnalyzedTime: {
              type: "timestamp"
            }
          }
        },
        S6: {
          type: "list",
          member: {}
        },
        S9: {
          type: "structure",
          members: {
            Columns: {
              shape: "Sa"
            },
            Location: {},
            InputFormat: {},
            OutputFormat: {},
            Compressed: {
              type: "boolean"
            },
            NumberOfBuckets: {
              type: "integer"
            },
            SerdeInfo: {
              type: "structure",
              members: {
                Name: {},
                SerializationLibrary: {},
                Parameters: {
                  shape: "Se"
                }
              }
            },
            BucketColumns: {
              shape: "Sm"
            },
            SortColumns: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Column",
                  "SortOrder"
                ],
                members: {
                  Column: {},
                  SortOrder: {
                    type: "integer"
                  }
                }
              }
            },
            Parameters: {
              shape: "Se"
            },
            SkewedInfo: {
              type: "structure",
              members: {
                SkewedColumnNames: {
                  shape: "Sm"
                },
                SkewedColumnValues: {
                  type: "list",
                  member: {}
                },
                SkewedColumnValueLocationMaps: {
                  type: "map",
                  key: {},
                  value: {}
                }
              }
            },
            StoredAsSubDirectories: {
              type: "boolean"
            },
            SchemaReference: {
              type: "structure",
              members: {
                SchemaId: {
                  shape: "Sv"
                },
                SchemaVersionId: {},
                SchemaVersionNumber: {
                  type: "long"
                }
              }
            }
          }
        },
        Sa: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Type: {},
              Comment: {},
              Parameters: {
                shape: "Se"
              }
            }
          }
        },
        Se: {
          type: "map",
          key: {},
          value: {}
        },
        Sm: {
          type: "list",
          member: {}
        },
        Sv: {
          type: "structure",
          members: {
            SchemaArn: {},
            SchemaName: {},
            RegistryName: {}
          }
        },
        S11: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PartitionValues: {
                shape: "S6"
              },
              ErrorDetail: {
                shape: "S13"
              }
            }
          }
        },
        S13: {
          type: "structure",
          members: {
            ErrorCode: {},
            ErrorMessage: {}
          }
        },
        S1b: {
          type: "structure",
          required: [
            "Values"
          ],
          members: {
            Values: {
              shape: "S6"
            }
          }
        },
        S1u: {
          type: "structure",
          members: {
            Name: {},
            Description: {},
            CreatedOn: {
              type: "timestamp"
            },
            LastModifiedOn: {
              type: "timestamp"
            },
            ParameterSpec: {},
            BlueprintLocation: {},
            BlueprintServiceLocation: {},
            Status: {},
            ErrorMessage: {},
            LastActiveDefinition: {
              type: "structure",
              members: {
                Description: {},
                LastModifiedOn: {
                  type: "timestamp"
                },
                ParameterSpec: {},
                BlueprintLocation: {},
                BlueprintServiceLocation: {}
              }
            }
          }
        },
        S22: {
          type: "list",
          member: {}
        },
        S24: {
          type: "list",
          member: {}
        },
        S26: {
          type: "list",
          member: {
            shape: "S27"
          }
        },
        S27: {
          type: "structure",
          members: {
            Name: {},
            Role: {},
            Targets: {
              shape: "S29"
            },
            DatabaseName: {},
            Description: {},
            Classifiers: {
              shape: "S2s"
            },
            RecrawlPolicy: {
              shape: "S2t"
            },
            SchemaChangePolicy: {
              shape: "S2v"
            },
            LineageConfiguration: {
              shape: "S2y"
            },
            State: {},
            TablePrefix: {},
            Schedule: {
              type: "structure",
              members: {
                ScheduleExpression: {},
                State: {}
              }
            },
            CrawlElapsedTime: {
              type: "long"
            },
            CreationTime: {
              type: "timestamp"
            },
            LastUpdated: {
              type: "timestamp"
            },
            LastCrawl: {
              type: "structure",
              members: {
                Status: {},
                ErrorMessage: {},
                LogGroup: {},
                LogStream: {},
                MessagePrefix: {},
                StartTime: {
                  type: "timestamp"
                }
              }
            },
            Version: {
              type: "long"
            },
            Configuration: {},
            CrawlerSecurityConfiguration: {}
          }
        },
        S29: {
          type: "structure",
          members: {
            S3Targets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Path: {},
                  Exclusions: {
                    shape: "S2d"
                  },
                  ConnectionName: {},
                  SampleSize: {
                    type: "integer"
                  },
                  EventQueueArn: {},
                  DlqEventQueueArn: {}
                }
              }
            },
            JdbcTargets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ConnectionName: {},
                  Path: {},
                  Exclusions: {
                    shape: "S2d"
                  }
                }
              }
            },
            MongoDBTargets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ConnectionName: {},
                  Path: {},
                  ScanAll: {
                    type: "boolean"
                  }
                }
              }
            },
            DynamoDBTargets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Path: {},
                  scanAll: {
                    type: "boolean"
                  },
                  scanRate: {
                    type: "double"
                  }
                }
              }
            },
            CatalogTargets: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DatabaseName",
                  "Tables"
                ],
                members: {
                  DatabaseName: {},
                  Tables: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        S2d: {
          type: "list",
          member: {}
        },
        S2s: {
          type: "list",
          member: {}
        },
        S2t: {
          type: "structure",
          members: {
            RecrawlBehavior: {}
          }
        },
        S2v: {
          type: "structure",
          members: {
            UpdateBehavior: {},
            DeleteBehavior: {}
          }
        },
        S2y: {
          type: "structure",
          members: {
            CrawlerLineageSettings: {}
          }
        },
        S3f: {
          type: "list",
          member: {}
        },
        S3h: {
          type: "list",
          member: {
            shape: "S3i"
          }
        },
        S3i: {
          type: "structure",
          members: {
            EndpointName: {},
            RoleArn: {},
            SecurityGroupIds: {
              shape: "S3k"
            },
            SubnetId: {},
            YarnEndpointAddress: {},
            PrivateAddress: {},
            ZeppelinRemoteSparkInterpreterPort: {
              type: "integer"
            },
            PublicAddress: {},
            Status: {},
            WorkerType: {},
            GlueVersion: {},
            NumberOfWorkers: {
              type: "integer"
            },
            NumberOfNodes: {
              type: "integer"
            },
            AvailabilityZone: {},
            VpcId: {},
            ExtraPythonLibsS3Path: {},
            ExtraJarsS3Path: {},
            FailureReason: {},
            LastUpdateStatus: {},
            CreatedTimestamp: {
              type: "timestamp"
            },
            LastModifiedTimestamp: {
              type: "timestamp"
            },
            PublicKey: {},
            PublicKeys: {
              shape: "S3o"
            },
            SecurityConfiguration: {},
            Arguments: {
              shape: "S3p"
            }
          }
        },
        S3k: {
          type: "list",
          member: {}
        },
        S3o: {
          type: "list",
          member: {}
        },
        S3p: {
          type: "map",
          key: {},
          value: {}
        },
        S3r: {
          type: "list",
          member: {}
        },
        S3t: {
          type: "list",
          member: {
            shape: "S3u"
          }
        },
        S3u: {
          type: "structure",
          members: {
            Name: {},
            Description: {},
            LogUri: {},
            Role: {},
            CreatedOn: {
              type: "timestamp"
            },
            LastModifiedOn: {
              type: "timestamp"
            },
            ExecutionProperty: {
              shape: "S3x"
            },
            Command: {
              shape: "S3z"
            },
            DefaultArguments: {
              shape: "S42"
            },
            NonOverridableArguments: {
              shape: "S42"
            },
            Connections: {
              shape: "S43"
            },
            MaxRetries: {
              type: "integer"
            },
            AllocatedCapacity: {
              deprecated: true,
              deprecatedMessage: "This property is deprecated, use MaxCapacity instead.",
              type: "integer"
            },
            Timeout: {
              type: "integer"
            },
            MaxCapacity: {
              type: "double"
            },
            WorkerType: {},
            NumberOfWorkers: {
              type: "integer"
            },
            SecurityConfiguration: {},
            NotificationProperty: {
              shape: "S47"
            },
            GlueVersion: {}
          }
        },
        S3x: {
          type: "structure",
          members: {
            MaxConcurrentRuns: {
              type: "integer"
            }
          }
        },
        S3z: {
          type: "structure",
          members: {
            Name: {},
            ScriptLocation: {},
            PythonVersion: {}
          }
        },
        S42: {
          type: "map",
          key: {},
          value: {}
        },
        S43: {
          type: "structure",
          members: {
            Connections: {
              type: "list",
              member: {}
            }
          }
        },
        S47: {
          type: "structure",
          members: {
            NotifyDelayAfter: {
              type: "integer"
            }
          }
        },
        S4a: {
          type: "list",
          member: {
            shape: "S1b"
          }
        },
        S4c: {
          type: "list",
          member: {
            shape: "S4d"
          }
        },
        S4d: {
          type: "structure",
          members: {
            Values: {
              shape: "S6"
            },
            DatabaseName: {},
            TableName: {},
            CreationTime: {
              type: "timestamp"
            },
            LastAccessTime: {
              type: "timestamp"
            },
            StorageDescriptor: {
              shape: "S9"
            },
            Parameters: {
              shape: "Se"
            },
            LastAnalyzedTime: {
              type: "timestamp"
            },
            CatalogId: {}
          }
        },
        S4f: {
          type: "list",
          member: {}
        },
        S4h: {
          type: "list",
          member: {
            shape: "S4i"
          }
        },
        S4i: {
          type: "structure",
          members: {
            Name: {},
            WorkflowName: {},
            Id: {},
            Type: {},
            State: {},
            Description: {},
            Schedule: {},
            Actions: {
              shape: "S4m"
            },
            Predicate: {
              shape: "S4o"
            },
            EventBatchingCondition: {
              shape: "S4v"
            }
          }
        },
        S4m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              JobName: {},
              Arguments: {
                shape: "S42"
              },
              Timeout: {
                type: "integer"
              },
              SecurityConfiguration: {},
              NotificationProperty: {
                shape: "S47"
              },
              CrawlerName: {}
            }
          }
        },
        S4o: {
          type: "structure",
          members: {
            Logical: {},
            Conditions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  LogicalOperator: {},
                  JobName: {},
                  State: {},
                  CrawlerName: {},
                  CrawlState: {}
                }
              }
            }
          }
        },
        S4v: {
          type: "structure",
          required: [
            "BatchSize"
          ],
          members: {
            BatchSize: {
              type: "integer"
            },
            BatchWindow: {
              type: "integer"
            }
          }
        },
        S4z: {
          type: "list",
          member: {}
        },
        S52: {
          type: "structure",
          members: {
            Name: {},
            Description: {},
            DefaultRunProperties: {
              shape: "S53"
            },
            CreatedOn: {
              type: "timestamp"
            },
            LastModifiedOn: {
              type: "timestamp"
            },
            LastRun: {
              shape: "S54"
            },
            Graph: {
              shape: "S57"
            },
            MaxConcurrentRuns: {
              type: "integer"
            },
            BlueprintDetails: {
              type: "structure",
              members: {
                BlueprintName: {},
                RunId: {}
              }
            }
          }
        },
        S53: {
          type: "map",
          key: {},
          value: {}
        },
        S54: {
          type: "structure",
          members: {
            Name: {},
            WorkflowRunId: {},
            PreviousRunId: {},
            WorkflowRunProperties: {
              shape: "S53"
            },
            StartedOn: {
              type: "timestamp"
            },
            CompletedOn: {
              type: "timestamp"
            },
            Status: {},
            ErrorMessage: {},
            Statistics: {
              type: "structure",
              members: {
                TotalActions: {
                  type: "integer"
                },
                TimeoutActions: {
                  type: "integer"
                },
                FailedActions: {
                  type: "integer"
                },
                StoppedActions: {
                  type: "integer"
                },
                SucceededActions: {
                  type: "integer"
                },
                RunningActions: {
                  type: "integer"
                }
              }
            },
            Graph: {
              shape: "S57"
            },
            StartingEventBatchCondition: {
              type: "structure",
              members: {
                BatchSize: {
                  type: "integer"
                },
                BatchWindow: {
                  type: "integer"
                }
              }
            }
          }
        },
        S57: {
          type: "structure",
          members: {
            Nodes: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Type: {},
                  Name: {},
                  UniqueId: {},
                  TriggerDetails: {
                    type: "structure",
                    members: {
                      Trigger: {
                        shape: "S4i"
                      }
                    }
                  },
                  JobDetails: {
                    type: "structure",
                    members: {
                      JobRuns: {
                        shape: "S5d"
                      }
                    }
                  },
                  CrawlerDetails: {
                    type: "structure",
                    members: {
                      Crawls: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            State: {},
                            StartedOn: {
                              type: "timestamp"
                            },
                            CompletedOn: {
                              type: "timestamp"
                            },
                            ErrorMessage: {},
                            LogGroup: {},
                            LogStream: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            Edges: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  SourceId: {},
                  DestinationId: {}
                }
              }
            }
          }
        },
        S5d: {
          type: "list",
          member: {
            shape: "S5e"
          }
        },
        S5e: {
          type: "structure",
          members: {
            Id: {},
            Attempt: {
              type: "integer"
            },
            PreviousRunId: {},
            TriggerName: {},
            JobName: {},
            StartedOn: {
              type: "timestamp"
            },
            LastModifiedOn: {
              type: "timestamp"
            },
            CompletedOn: {
              type: "timestamp"
            },
            JobRunState: {},
            Arguments: {
              shape: "S42"
            },
            ErrorMessage: {},
            PredecessorRuns: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  JobName: {},
                  RunId: {}
                }
              }
            },
            AllocatedCapacity: {
              deprecated: true,
              deprecatedMessage: "This property is deprecated, use MaxCapacity instead.",
              type: "integer"
            },
            ExecutionTime: {
              type: "integer"
            },
            Timeout: {
              type: "integer"
            },
            MaxCapacity: {
              type: "double"
            },
            WorkerType: {},
            NumberOfWorkers: {
              type: "integer"
            },
            SecurityConfiguration: {},
            LogGroupName: {},
            NotificationProperty: {
              shape: "S47"
            },
            GlueVersion: {}
          }
        },
        S60: {
          type: "list",
          member: {}
        },
        S6g: {
          type: "map",
          key: {},
          value: {}
        },
        S6x: {
          type: "list",
          member: {}
        },
        S70: {
          type: "structure",
          required: [
            "Name",
            "ConnectionType",
            "ConnectionProperties"
          ],
          members: {
            Name: {},
            Description: {},
            ConnectionType: {},
            MatchCriteria: {
              shape: "S72"
            },
            ConnectionProperties: {
              shape: "S73"
            },
            PhysicalConnectionRequirements: {
              shape: "S75"
            }
          }
        },
        S72: {
          type: "list",
          member: {}
        },
        S73: {
          type: "map",
          key: {},
          value: {}
        },
        S75: {
          type: "structure",
          members: {
            SubnetId: {},
            SecurityGroupIdList: {
              type: "list",
              member: {}
            },
            AvailabilityZone: {}
          }
        },
        S7b: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            Description: {},
            LocationUri: {},
            Parameters: {
              shape: "Se"
            },
            CreateTableDefaultPermissions: {
              shape: "S7d"
            },
            TargetDatabase: {
              shape: "S7j"
            }
          }
        },
        S7d: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Principal: {
                type: "structure",
                members: {
                  DataLakePrincipalIdentifier: {}
                }
              },
              Permissions: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S7j: {
          type: "structure",
          members: {
            CatalogId: {},
            DatabaseName: {}
          }
        },
        S7q: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              DatabaseName: {},
              TableName: {},
              CatalogId: {},
              ConnectionName: {}
            }
          }
        },
        S7s: {
          type: "structure",
          required: [
            "TransformType"
          ],
          members: {
            TransformType: {},
            FindMatchesParameters: {
              type: "structure",
              members: {
                PrimaryKeyColumnName: {},
                PrecisionRecallTradeoff: {
                  type: "double"
                },
                AccuracyCostTradeoff: {
                  type: "double"
                },
                EnforceProvidedLabels: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S7x: {
          type: "structure",
          members: {
            MlUserDataEncryption: {
              type: "structure",
              required: [
                "MlUserDataEncryptionMode"
              ],
              members: {
                MlUserDataEncryptionMode: {},
                KmsKeyId: {}
              }
            },
            TaskRunSecurityConfigurationName: {}
          }
        },
        S84: {
          type: "structure",
          required: [
            "Keys",
            "IndexName"
          ],
          members: {
            Keys: {
              type: "list",
              member: {}
            },
            IndexName: {}
          }
        },
        S8a: {
          type: "structure",
          members: {
            RegistryName: {},
            RegistryArn: {}
          }
        },
        S8h: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Id",
              "NodeType",
              "Args"
            ],
            members: {
              Id: {},
              NodeType: {},
              Args: {
                shape: "S8l"
              },
              LineNumber: {
                type: "integer"
              }
            }
          }
        },
        S8l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {},
              Param: {
                type: "boolean"
              }
            }
          }
        },
        S8p: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Source",
              "Target"
            ],
            members: {
              Source: {},
              Target: {},
              TargetParameter: {}
            }
          }
        },
        S8w: {
          type: "structure",
          members: {
            S3Encryption: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  S3EncryptionMode: {},
                  KmsKeyArn: {}
                }
              }
            },
            CloudWatchEncryption: {
              type: "structure",
              members: {
                CloudWatchEncryptionMode: {},
                KmsKeyArn: {}
              }
            },
            JobBookmarksEncryption: {
              type: "structure",
              members: {
                JobBookmarksEncryptionMode: {},
                KmsKeyArn: {}
              }
            }
          }
        },
        S97: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            Description: {},
            Owner: {},
            LastAccessTime: {
              type: "timestamp"
            },
            LastAnalyzedTime: {
              type: "timestamp"
            },
            Retention: {
              type: "integer"
            },
            StorageDescriptor: {
              shape: "S9"
            },
            PartitionKeys: {
              shape: "Sa"
            },
            ViewOriginalText: {},
            ViewExpandedText: {},
            TableType: {},
            Parameters: {
              shape: "Se"
            },
            TargetTable: {
              shape: "S9b"
            }
          }
        },
        S9b: {
          type: "structure",
          members: {
            CatalogId: {},
            DatabaseName: {},
            Name: {}
          }
        },
        S9i: {
          type: "structure",
          members: {
            FunctionName: {},
            ClassName: {},
            OwnerName: {},
            OwnerType: {},
            ResourceUris: {
              shape: "S9k"
            }
          }
        },
        S9k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceType: {},
              Uri: {}
            }
          }
        },
        Sb9: {
          type: "structure",
          members: {
            BlueprintName: {},
            RunId: {},
            WorkflowName: {},
            State: {},
            StartedOn: {
              type: "timestamp"
            },
            CompletedOn: {
              type: "timestamp"
            },
            ErrorMessage: {},
            RollbackErrorMessage: {},
            Parameters: {},
            RoleArn: {}
          }
        },
        Sbn: {
          type: "structure",
          members: {
            GrokClassifier: {
              type: "structure",
              required: [
                "Name",
                "Classification",
                "GrokPattern"
              ],
              members: {
                Name: {},
                Classification: {},
                CreationTime: {
                  type: "timestamp"
                },
                LastUpdated: {
                  type: "timestamp"
                },
                Version: {
                  type: "long"
                },
                GrokPattern: {},
                CustomPatterns: {}
              }
            },
            XMLClassifier: {
              type: "structure",
              required: [
                "Name",
                "Classification"
              ],
              members: {
                Name: {},
                Classification: {},
                CreationTime: {
                  type: "timestamp"
                },
                LastUpdated: {
                  type: "timestamp"
                },
                Version: {
                  type: "long"
                },
                RowTag: {}
              }
            },
            JsonClassifier: {
              type: "structure",
              required: [
                "Name",
                "JsonPath"
              ],
              members: {
                Name: {},
                CreationTime: {
                  type: "timestamp"
                },
                LastUpdated: {
                  type: "timestamp"
                },
                Version: {
                  type: "long"
                },
                JsonPath: {}
              }
            },
            CsvClassifier: {
              type: "structure",
              required: [
                "Name"
              ],
              members: {
                Name: {},
                CreationTime: {
                  type: "timestamp"
                },
                LastUpdated: {
                  type: "timestamp"
                },
                Version: {
                  type: "long"
                },
                Delimiter: {},
                QuoteSymbol: {},
                ContainsHeader: {},
                Header: {
                  shape: "S6x"
                },
                DisableValueTrimming: {
                  type: "boolean"
                },
                AllowSingleColumn: {
                  type: "boolean"
                }
              }
            }
          }
        },
        Sbx: {
          type: "list",
          member: {}
        },
        Sbz: {
          type: "list",
          member: {
            shape: "Sc0"
          }
        },
        Sc0: {
          type: "structure",
          required: [
            "ColumnName",
            "ColumnType",
            "AnalyzedTime",
            "StatisticsData"
          ],
          members: {
            ColumnName: {},
            ColumnType: {},
            AnalyzedTime: {
              type: "timestamp"
            },
            StatisticsData: {
              type: "structure",
              required: [
                "Type"
              ],
              members: {
                Type: {},
                BooleanColumnStatisticsData: {
                  type: "structure",
                  required: [
                    "NumberOfTrues",
                    "NumberOfFalses",
                    "NumberOfNulls"
                  ],
                  members: {
                    NumberOfTrues: {
                      type: "long"
                    },
                    NumberOfFalses: {
                      type: "long"
                    },
                    NumberOfNulls: {
                      type: "long"
                    }
                  }
                },
                DateColumnStatisticsData: {
                  type: "structure",
                  required: [
                    "NumberOfNulls",
                    "NumberOfDistinctValues"
                  ],
                  members: {
                    MinimumValue: {
                      type: "timestamp"
                    },
                    MaximumValue: {
                      type: "timestamp"
                    },
                    NumberOfNulls: {
                      type: "long"
                    },
                    NumberOfDistinctValues: {
                      type: "long"
                    }
                  }
                },
                DecimalColumnStatisticsData: {
                  type: "structure",
                  required: [
                    "NumberOfNulls",
                    "NumberOfDistinctValues"
                  ],
                  members: {
                    MinimumValue: {
                      shape: "Sc8"
                    },
                    MaximumValue: {
                      shape: "Sc8"
                    },
                    NumberOfNulls: {
                      type: "long"
                    },
                    NumberOfDistinctValues: {
                      type: "long"
                    }
                  }
                },
                DoubleColumnStatisticsData: {
                  type: "structure",
                  required: [
                    "NumberOfNulls",
                    "NumberOfDistinctValues"
                  ],
                  members: {
                    MinimumValue: {
                      type: "double"
                    },
                    MaximumValue: {
                      type: "double"
                    },
                    NumberOfNulls: {
                      type: "long"
                    },
                    NumberOfDistinctValues: {
                      type: "long"
                    }
                  }
                },
                LongColumnStatisticsData: {
                  type: "structure",
                  required: [
                    "NumberOfNulls",
                    "NumberOfDistinctValues"
                  ],
                  members: {
                    MinimumValue: {
                      type: "long"
                    },
                    MaximumValue: {
                      type: "long"
                    },
                    NumberOfNulls: {
                      type: "long"
                    },
                    NumberOfDistinctValues: {
                      type: "long"
                    }
                  }
                },
                StringColumnStatisticsData: {
                  type: "structure",
                  required: [
                    "MaximumLength",
                    "AverageLength",
                    "NumberOfNulls",
                    "NumberOfDistinctValues"
                  ],
                  members: {
                    MaximumLength: {
                      type: "long"
                    },
                    AverageLength: {
                      type: "double"
                    },
                    NumberOfNulls: {
                      type: "long"
                    },
                    NumberOfDistinctValues: {
                      type: "long"
                    }
                  }
                },
                BinaryColumnStatisticsData: {
                  type: "structure",
                  required: [
                    "MaximumLength",
                    "AverageLength",
                    "NumberOfNulls"
                  ],
                  members: {
                    MaximumLength: {
                      type: "long"
                    },
                    AverageLength: {
                      type: "double"
                    },
                    NumberOfNulls: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        Sc8: {
          type: "structure",
          required: [
            "UnscaledValue",
            "Scale"
          ],
          members: {
            UnscaledValue: {
              type: "blob"
            },
            Scale: {
              type: "integer"
            }
          }
        },
        Sch: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ColumnName: {},
              Error: {
                shape: "S13"
              }
            }
          }
        },
        Scn: {
          type: "structure",
          members: {
            Name: {},
            Description: {},
            ConnectionType: {},
            MatchCriteria: {
              shape: "S72"
            },
            ConnectionProperties: {
              shape: "S73"
            },
            PhysicalConnectionRequirements: {
              shape: "S75"
            },
            CreationTime: {
              type: "timestamp"
            },
            LastUpdatedTime: {
              type: "timestamp"
            },
            LastUpdatedBy: {}
          }
        },
        Sd2: {
          type: "structure",
          members: {
            EncryptionAtRest: {
              type: "structure",
              required: [
                "CatalogEncryptionMode"
              ],
              members: {
                CatalogEncryptionMode: {},
                SseAwsKmsKeyId: {}
              }
            },
            ConnectionPasswordEncryption: {
              type: "structure",
              required: [
                "ReturnConnectionPasswordEncrypted"
              ],
              members: {
                ReturnConnectionPasswordEncrypted: {
                  type: "boolean"
                },
                AwsKmsKeyId: {}
              }
            }
          }
        },
        Sd8: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            Description: {},
            LocationUri: {},
            Parameters: {
              shape: "Se"
            },
            CreateTime: {
              type: "timestamp"
            },
            CreateTableDefaultPermissions: {
              shape: "S7d"
            },
            TargetDatabase: {
              shape: "S7j"
            },
            CatalogId: {}
          }
        },
        Sdq: {
          type: "structure",
          members: {
            JobName: {},
            Version: {
              type: "integer"
            },
            Run: {
              type: "integer"
            },
            Attempt: {
              type: "integer"
            },
            PreviousRunId: {},
            RunId: {},
            JobBookmark: {}
          }
        },
        Se0: {
          type: "structure",
          members: {
            TaskType: {},
            ImportLabelsTaskRunProperties: {
              type: "structure",
              members: {
                InputS3Path: {},
                Replace: {
                  type: "boolean"
                }
              }
            },
            ExportLabelsTaskRunProperties: {
              type: "structure",
              members: {
                OutputS3Path: {}
              }
            },
            LabelingSetGenerationTaskRunProperties: {
              type: "structure",
              members: {
                OutputS3Path: {}
              }
            },
            FindMatchesTaskRunProperties: {
              type: "structure",
              members: {
                JobId: {},
                JobName: {},
                JobRunId: {}
              }
            }
          }
        },
        Sej: {
          type: "structure",
          required: [
            "TransformType"
          ],
          members: {
            TransformType: {},
            FindMatchesMetrics: {
              type: "structure",
              members: {
                AreaUnderPRCurve: {
                  type: "double"
                },
                Precision: {
                  type: "double"
                },
                Recall: {
                  type: "double"
                },
                F1: {
                  type: "double"
                },
                ConfusionMatrix: {
                  type: "structure",
                  members: {
                    NumTruePositives: {
                      type: "long"
                    },
                    NumFalsePositives: {
                      type: "long"
                    },
                    NumTrueNegatives: {
                      type: "long"
                    },
                    NumFalseNegatives: {
                      type: "long"
                    }
                  }
                },
                ColumnImportances: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      ColumnName: {},
                      Importance: {
                        type: "double"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Seq: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              DataType: {}
            }
          }
        },
        Set: {
          type: "structure",
          members: {
            Name: {},
            TransformType: {},
            Status: {},
            GlueVersion: {},
            CreatedBefore: {
              type: "timestamp"
            },
            CreatedAfter: {
              type: "timestamp"
            },
            LastModifiedBefore: {
              type: "timestamp"
            },
            LastModifiedAfter: {
              type: "timestamp"
            },
            Schema: {
              shape: "Seq"
            }
          }
        },
        Seu: {
          type: "structure",
          required: [
            "Column",
            "SortDirection"
          ],
          members: {
            Column: {},
            SortDirection: {}
          }
        },
        Sf0: {
          type: "structure",
          required: [
            "DatabaseName",
            "TableName"
          ],
          members: {
            DatabaseName: {},
            TableName: {}
          }
        },
        Sf1: {
          type: "list",
          member: {
            shape: "Sf0"
          }
        },
        Sf2: {
          type: "structure",
          members: {
            Jdbc: {
              shape: "S8l"
            },
            S3: {
              shape: "S8l"
            },
            DynamoDB: {
              shape: "S8l"
            }
          }
        },
        Sf4: {
          type: "list",
          member: {
            type: "structure",
            members: {
              SourceTable: {},
              SourcePath: {},
              SourceType: {},
              TargetTable: {},
              TargetPath: {},
              TargetType: {}
            }
          }
        },
        Sgb: {
          type: "structure",
          members: {
            LatestVersion: {
              type: "boolean"
            },
            VersionNumber: {
              type: "long"
            }
          }
        },
        Sgk: {
          type: "structure",
          members: {
            Name: {},
            CreatedTimeStamp: {
              type: "timestamp"
            },
            EncryptionConfiguration: {
              shape: "S8w"
            }
          }
        },
        Sgq: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            DatabaseName: {},
            Description: {},
            Owner: {},
            CreateTime: {
              type: "timestamp"
            },
            UpdateTime: {
              type: "timestamp"
            },
            LastAccessTime: {
              type: "timestamp"
            },
            LastAnalyzedTime: {
              type: "timestamp"
            },
            Retention: {
              type: "integer"
            },
            StorageDescriptor: {
              shape: "S9"
            },
            PartitionKeys: {
              shape: "Sa"
            },
            ViewOriginalText: {},
            ViewExpandedText: {},
            TableType: {},
            Parameters: {
              shape: "Se"
            },
            CreatedBy: {},
            IsRegisteredWithLakeFormation: {
              type: "boolean"
            },
            TargetTable: {
              shape: "S9b"
            },
            CatalogId: {}
          }
        },
        Sgt: {
          type: "structure",
          members: {
            Table: {
              shape: "Sgq"
            },
            VersionId: {}
          }
        },
        Sh0: {
          type: "list",
          member: {
            shape: "Sgq"
          }
        },
        Sh9: {
          type: "structure",
          members: {
            FunctionName: {},
            DatabaseName: {},
            ClassName: {},
            OwnerName: {},
            OwnerType: {},
            CreateTime: {
              type: "timestamp"
            },
            ResourceUris: {
              shape: "S9k"
            },
            CatalogId: {}
          }
        },
        Sip: {
          type: "structure",
          members: {
            MetadataKey: {},
            MetadataValue: {}
          }
        },
        Sja: {
          type: "list",
          member: {}
        },
        Skq: {
          type: "list",
          member: {
            shape: "Sc0"
          }
        },
        Sks: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ColumnStatistics: {
                shape: "Sc0"
              },
              Error: {
                shape: "S13"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/glue-2017-03-31.paginators.json
var require_glue_2017_03_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/glue-2017-03-31.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetBlueprintRuns: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetClassifiers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetConnections: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetCrawlerMetrics: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetCrawlers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetDatabases: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetDevEndpoints: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetJobRuns: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetMLTaskRuns: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetMLTransforms: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetPartitionIndexes: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "PartitionIndexDescriptorList"
        },
        GetPartitions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetResourcePolicies: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "GetResourcePoliciesResponseList"
        },
        GetSecurityConfigurations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "SecurityConfigurations"
        },
        GetTableVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetTables: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetTriggers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetUserDefinedFunctions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetWorkflowRuns: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListBlueprints: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListCrawlers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListDevEndpoints: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListMLTransforms: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListRegistries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Registries"
        },
        ListSchemaVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Schemas"
        },
        ListSchemas: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Schemas"
        },
        ListTriggers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListWorkflows: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        SearchTables: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/glue.js
var require_glue = __commonJS({
  "node_modules/aws-sdk/clients/glue.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["glue"] = {};
    AWS3.Glue = Service.defineService("glue", ["2017-03-31"]);
    Object.defineProperty(apiLoader.services["glue"], "2017-03-31", {
      get: function get() {
        var model = require_glue_2017_03_31_min();
        model.paginators = require_glue_2017_03_31_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Glue;
  }
});

// node_modules/aws-sdk/apis/mobile-2017-07-01.min.json
var require_mobile_2017_07_01_min = __commonJS({
  "node_modules/aws-sdk/apis/mobile-2017-07-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-01",
        endpointPrefix: "mobile",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Mobile",
        serviceId: "Mobile",
        signatureVersion: "v4",
        signingName: "AWSMobileHubService",
        uid: "mobile-2017-07-01"
      },
      operations: {
        CreateProject: {
          http: {
            requestUri: "/projects"
          },
          input: {
            type: "structure",
            members: {
              name: {
                location: "querystring",
                locationName: "name"
              },
              region: {
                location: "querystring",
                locationName: "region"
              },
              contents: {
                type: "blob"
              },
              snapshotId: {
                location: "querystring",
                locationName: "snapshotId"
              }
            },
            payload: "contents"
          },
          output: {
            type: "structure",
            members: {
              details: {
                shape: "S7"
              }
            }
          }
        },
        DeleteProject: {
          http: {
            method: "DELETE",
            requestUri: "/projects/{projectId}"
          },
          input: {
            type: "structure",
            required: [
              "projectId"
            ],
            members: {
              projectId: {
                location: "uri",
                locationName: "projectId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deletedResources: {
                shape: "Sc"
              },
              orphanedResources: {
                shape: "Sc"
              }
            }
          }
        },
        DescribeBundle: {
          http: {
            method: "GET",
            requestUri: "/bundles/{bundleId}"
          },
          input: {
            type: "structure",
            required: [
              "bundleId"
            ],
            members: {
              bundleId: {
                location: "uri",
                locationName: "bundleId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              details: {
                shape: "Sq"
              }
            }
          }
        },
        DescribeProject: {
          http: {
            method: "GET",
            requestUri: "/project"
          },
          input: {
            type: "structure",
            required: [
              "projectId"
            ],
            members: {
              projectId: {
                location: "querystring",
                locationName: "projectId"
              },
              syncFromResources: {
                location: "querystring",
                locationName: "syncFromResources",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              details: {
                shape: "S7"
              }
            }
          }
        },
        ExportBundle: {
          http: {
            requestUri: "/bundles/{bundleId}"
          },
          input: {
            type: "structure",
            required: [
              "bundleId"
            ],
            members: {
              bundleId: {
                location: "uri",
                locationName: "bundleId"
              },
              projectId: {
                location: "querystring",
                locationName: "projectId"
              },
              platform: {
                location: "querystring",
                locationName: "platform"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              downloadUrl: {}
            }
          }
        },
        ExportProject: {
          http: {
            requestUri: "/exports/{projectId}"
          },
          input: {
            type: "structure",
            required: [
              "projectId"
            ],
            members: {
              projectId: {
                location: "uri",
                locationName: "projectId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              downloadUrl: {},
              shareUrl: {},
              snapshotId: {}
            }
          }
        },
        ListBundles: {
          http: {
            method: "GET",
            requestUri: "/bundles"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              bundleList: {
                type: "list",
                member: {
                  shape: "Sq"
                }
              },
              nextToken: {}
            }
          }
        },
        ListProjects: {
          http: {
            method: "GET",
            requestUri: "/projects"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              projects: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    projectId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        UpdateProject: {
          http: {
            requestUri: "/update"
          },
          input: {
            type: "structure",
            required: [
              "projectId"
            ],
            members: {
              contents: {
                type: "blob"
              },
              projectId: {
                location: "querystring",
                locationName: "projectId"
              }
            },
            payload: "contents"
          },
          output: {
            type: "structure",
            members: {
              details: {
                shape: "S7"
              }
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "structure",
          members: {
            name: {},
            projectId: {},
            region: {},
            state: {},
            createdDate: {
              type: "timestamp"
            },
            lastUpdatedDate: {
              type: "timestamp"
            },
            consoleUrl: {},
            resources: {
              shape: "Sc"
            }
          }
        },
        Sc: {
          type: "list",
          member: {
            type: "structure",
            members: {
              type: {},
              name: {},
              arn: {},
              feature: {},
              attributes: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        Sq: {
          type: "structure",
          members: {
            bundleId: {},
            title: {},
            version: {},
            description: {},
            iconUrl: {},
            availablePlatforms: {
              type: "list",
              member: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mobile-2017-07-01.paginators.json
var require_mobile_2017_07_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mobile-2017-07-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListBundles: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListProjects: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mobile.js
var require_mobile = __commonJS({
  "node_modules/aws-sdk/clients/mobile.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["mobile"] = {};
    AWS3.Mobile = Service.defineService("mobile", ["2017-07-01"]);
    Object.defineProperty(apiLoader.services["mobile"], "2017-07-01", {
      get: function get() {
        var model = require_mobile_2017_07_01_min();
        model.paginators = require_mobile_2017_07_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Mobile;
  }
});

// node_modules/aws-sdk/apis/pricing-2017-10-15.min.json
var require_pricing_2017_10_15_min = __commonJS({
  "node_modules/aws-sdk/apis/pricing-2017-10-15.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-10-15",
        endpointPrefix: "api.pricing",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "AWS Pricing",
        serviceFullName: "AWS Price List Service",
        serviceId: "Pricing",
        signatureVersion: "v4",
        signingName: "pricing",
        targetPrefix: "AWSPriceListService",
        uid: "pricing-2017-10-15"
      },
      operations: {
        DescribeServices: {
          input: {
            type: "structure",
            members: {
              ServiceCode: {},
              FormatVersion: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Services: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ServiceCode: {},
                    AttributeNames: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              FormatVersion: {},
              NextToken: {}
            }
          }
        },
        GetAttributeValues: {
          input: {
            type: "structure",
            required: [
              "ServiceCode",
              "AttributeName"
            ],
            members: {
              ServiceCode: {},
              AttributeName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AttributeValues: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Value: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetProducts: {
          input: {
            type: "structure",
            members: {
              ServiceCode: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Type",
                    "Field",
                    "Value"
                  ],
                  members: {
                    Type: {},
                    Field: {},
                    Value: {}
                  }
                }
              },
              FormatVersion: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FormatVersion: {},
              PriceList: {
                type: "list",
                member: {
                  jsonvalue: true
                }
              },
              NextToken: {}
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/pricing-2017-10-15.paginators.json
var require_pricing_2017_10_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/pricing-2017-10-15.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeServices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        GetAttributeValues: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        GetProducts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/pricing.js
var require_pricing = __commonJS({
  "node_modules/aws-sdk/clients/pricing.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["pricing"] = {};
    AWS3.Pricing = Service.defineService("pricing", ["2017-10-15"]);
    Object.defineProperty(apiLoader.services["pricing"], "2017-10-15", {
      get: function get() {
        var model = require_pricing_2017_10_15_min();
        model.paginators = require_pricing_2017_10_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Pricing;
  }
});

// node_modules/aws-sdk/apis/ce-2017-10-25.min.json
var require_ce_2017_10_25_min = __commonJS({
  "node_modules/aws-sdk/apis/ce-2017-10-25.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-10-25",
        endpointPrefix: "ce",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "AWS Cost Explorer",
        serviceFullName: "AWS Cost Explorer Service",
        serviceId: "Cost Explorer",
        signatureVersion: "v4",
        signingName: "ce",
        targetPrefix: "AWSInsightsIndexService",
        uid: "ce-2017-10-25"
      },
      operations: {
        CreateAnomalyMonitor: {
          input: {
            type: "structure",
            required: [
              "AnomalyMonitor"
            ],
            members: {
              AnomalyMonitor: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "MonitorArn"
            ],
            members: {
              MonitorArn: {}
            }
          }
        },
        CreateAnomalySubscription: {
          input: {
            type: "structure",
            required: [
              "AnomalySubscription"
            ],
            members: {
              AnomalySubscription: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "SubscriptionArn"
            ],
            members: {
              SubscriptionArn: {}
            }
          }
        },
        CreateCostCategoryDefinition: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RuleVersion",
              "Rules"
            ],
            members: {
              Name: {},
              RuleVersion: {},
              Rules: {
                shape: "Sz"
              },
              DefaultValue: {},
              SplitChargeRules: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CostCategoryArn: {},
              EffectiveStart: {}
            }
          }
        },
        DeleteAnomalyMonitor: {
          input: {
            type: "structure",
            required: [
              "MonitorArn"
            ],
            members: {
              MonitorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAnomalySubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionArn"
            ],
            members: {
              SubscriptionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCostCategoryDefinition: {
          input: {
            type: "structure",
            required: [
              "CostCategoryArn"
            ],
            members: {
              CostCategoryArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CostCategoryArn: {},
              EffectiveEnd: {}
            }
          }
        },
        DescribeCostCategoryDefinition: {
          input: {
            type: "structure",
            required: [
              "CostCategoryArn"
            ],
            members: {
              CostCategoryArn: {},
              EffectiveOn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CostCategory: {
                type: "structure",
                required: [
                  "CostCategoryArn",
                  "EffectiveStart",
                  "Name",
                  "RuleVersion",
                  "Rules"
                ],
                members: {
                  CostCategoryArn: {},
                  EffectiveStart: {},
                  EffectiveEnd: {},
                  Name: {},
                  RuleVersion: {},
                  Rules: {
                    shape: "Sz"
                  },
                  SplitChargeRules: {
                    shape: "S15"
                  },
                  ProcessingStatus: {
                    shape: "S1o"
                  },
                  DefaultValue: {}
                }
              }
            }
          }
        },
        GetAnomalies: {
          input: {
            type: "structure",
            required: [
              "DateInterval"
            ],
            members: {
              MonitorArn: {},
              DateInterval: {
                type: "structure",
                required: [
                  "StartDate"
                ],
                members: {
                  StartDate: {},
                  EndDate: {}
                }
              },
              Feedback: {},
              TotalImpact: {
                type: "structure",
                required: [
                  "NumericOperator",
                  "StartValue"
                ],
                members: {
                  NumericOperator: {},
                  StartValue: {
                    type: "double"
                  },
                  EndValue: {
                    type: "double"
                  }
                }
              },
              NextPageToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Anomalies"
            ],
            members: {
              Anomalies: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AnomalyId",
                    "AnomalyScore",
                    "Impact",
                    "MonitorArn"
                  ],
                  members: {
                    AnomalyId: {},
                    AnomalyStartDate: {},
                    AnomalyEndDate: {},
                    DimensionValue: {},
                    RootCauses: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Service: {},
                          Region: {},
                          LinkedAccount: {},
                          UsageType: {}
                        }
                      }
                    },
                    AnomalyScore: {
                      type: "structure",
                      required: [
                        "MaxScore",
                        "CurrentScore"
                      ],
                      members: {
                        MaxScore: {
                          type: "double"
                        },
                        CurrentScore: {
                          type: "double"
                        }
                      }
                    },
                    Impact: {
                      type: "structure",
                      required: [
                        "MaxImpact"
                      ],
                      members: {
                        MaxImpact: {
                          type: "double"
                        },
                        TotalImpact: {
                          type: "double"
                        }
                      }
                    },
                    MonitorArn: {},
                    Feedback: {}
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        GetAnomalyMonitors: {
          input: {
            type: "structure",
            members: {
              MonitorArnList: {
                shape: "Sb"
              },
              NextPageToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AnomalyMonitors"
            ],
            members: {
              AnomalyMonitors: {
                type: "list",
                member: {
                  shape: "S2"
                }
              },
              NextPageToken: {}
            }
          }
        },
        GetAnomalySubscriptions: {
          input: {
            type: "structure",
            members: {
              SubscriptionArnList: {
                shape: "Sb"
              },
              MonitorArn: {},
              NextPageToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AnomalySubscriptions"
            ],
            members: {
              AnomalySubscriptions: {
                type: "list",
                member: {
                  shape: "Sm"
                }
              },
              NextPageToken: {}
            }
          }
        },
        GetCostAndUsage: {
          input: {
            type: "structure",
            required: [
              "TimePeriod",
              "Granularity",
              "Metrics"
            ],
            members: {
              TimePeriod: {
                shape: "S2e"
              },
              Granularity: {},
              Filter: {
                shape: "S7"
              },
              Metrics: {
                shape: "S2g"
              },
              GroupBy: {
                shape: "S2i"
              },
              NextPageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextPageToken: {},
              GroupDefinitions: {
                shape: "S2i"
              },
              ResultsByTime: {
                shape: "S2n"
              },
              DimensionValueAttributes: {
                shape: "S2y"
              }
            }
          }
        },
        GetCostAndUsageWithResources: {
          input: {
            type: "structure",
            required: [
              "TimePeriod",
              "Granularity",
              "Filter"
            ],
            members: {
              TimePeriod: {
                shape: "S2e"
              },
              Granularity: {},
              Filter: {
                shape: "S7"
              },
              Metrics: {
                shape: "S2g"
              },
              GroupBy: {
                shape: "S2i"
              },
              NextPageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextPageToken: {},
              GroupDefinitions: {
                shape: "S2i"
              },
              ResultsByTime: {
                shape: "S2n"
              },
              DimensionValueAttributes: {
                shape: "S2y"
              }
            }
          }
        },
        GetCostCategories: {
          input: {
            type: "structure",
            required: [
              "TimePeriod"
            ],
            members: {
              SearchString: {},
              TimePeriod: {
                shape: "S2e"
              },
              CostCategoryName: {},
              Filter: {
                shape: "S7"
              },
              SortBy: {
                shape: "S37"
              },
              MaxResults: {
                type: "integer"
              },
              NextPageToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ReturnSize",
              "TotalSize"
            ],
            members: {
              NextPageToken: {},
              CostCategoryNames: {
                type: "list",
                member: {}
              },
              CostCategoryValues: {
                shape: "S3e"
              },
              ReturnSize: {
                type: "integer"
              },
              TotalSize: {
                type: "integer"
              }
            }
          }
        },
        GetCostForecast: {
          input: {
            type: "structure",
            required: [
              "TimePeriod",
              "Metric",
              "Granularity"
            ],
            members: {
              TimePeriod: {
                shape: "S2e"
              },
              Metric: {},
              Granularity: {},
              Filter: {
                shape: "S7"
              },
              PredictionIntervalLevel: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Total: {
                shape: "S2q"
              },
              ForecastResultsByTime: {
                shape: "S3j"
              }
            }
          }
        },
        GetDimensionValues: {
          input: {
            type: "structure",
            required: [
              "TimePeriod",
              "Dimension"
            ],
            members: {
              SearchString: {},
              TimePeriod: {
                shape: "S2e"
              },
              Dimension: {},
              Context: {},
              Filter: {
                shape: "S7"
              },
              SortBy: {
                shape: "S37"
              },
              MaxResults: {
                type: "integer"
              },
              NextPageToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DimensionValues",
              "ReturnSize",
              "TotalSize"
            ],
            members: {
              DimensionValues: {
                shape: "S2y"
              },
              ReturnSize: {
                type: "integer"
              },
              TotalSize: {
                type: "integer"
              },
              NextPageToken: {}
            }
          }
        },
        GetReservationCoverage: {
          input: {
            type: "structure",
            required: [
              "TimePeriod"
            ],
            members: {
              TimePeriod: {
                shape: "S2e"
              },
              GroupBy: {
                shape: "S2i"
              },
              Granularity: {},
              Filter: {
                shape: "S7"
              },
              Metrics: {
                shape: "S2g"
              },
              NextPageToken: {},
              SortBy: {
                shape: "S38"
              },
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CoveragesByTime"
            ],
            members: {
              CoveragesByTime: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TimePeriod: {
                      shape: "S2e"
                    },
                    Groups: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Attributes: {
                            shape: "S30"
                          },
                          Coverage: {
                            shape: "S3u"
                          }
                        }
                      }
                    },
                    Total: {
                      shape: "S3u"
                    }
                  }
                }
              },
              Total: {
                shape: "S3u"
              },
              NextPageToken: {}
            }
          }
        },
        GetReservationPurchaseRecommendation: {
          input: {
            type: "structure",
            required: [
              "Service"
            ],
            members: {
              AccountId: {},
              Service: {},
              Filter: {
                shape: "S7"
              },
              AccountScope: {},
              LookbackPeriodInDays: {},
              TermInYears: {},
              PaymentOption: {},
              ServiceSpecification: {
                shape: "S4c"
              },
              PageSize: {
                type: "integer"
              },
              NextPageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Metadata: {
                type: "structure",
                members: {
                  RecommendationId: {},
                  GenerationTimestamp: {}
                }
              },
              Recommendations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountScope: {},
                    LookbackPeriodInDays: {},
                    TermInYears: {},
                    PaymentOption: {},
                    ServiceSpecification: {
                      shape: "S4c"
                    },
                    RecommendationDetails: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          AccountId: {},
                          InstanceDetails: {
                            type: "structure",
                            members: {
                              EC2InstanceDetails: {
                                type: "structure",
                                members: {
                                  Family: {},
                                  InstanceType: {},
                                  Region: {},
                                  AvailabilityZone: {},
                                  Platform: {},
                                  Tenancy: {},
                                  CurrentGeneration: {
                                    type: "boolean"
                                  },
                                  SizeFlexEligible: {
                                    type: "boolean"
                                  }
                                }
                              },
                              RDSInstanceDetails: {
                                type: "structure",
                                members: {
                                  Family: {},
                                  InstanceType: {},
                                  Region: {},
                                  DatabaseEngine: {},
                                  DatabaseEdition: {},
                                  DeploymentOption: {},
                                  LicenseModel: {},
                                  CurrentGeneration: {
                                    type: "boolean"
                                  },
                                  SizeFlexEligible: {
                                    type: "boolean"
                                  }
                                }
                              },
                              RedshiftInstanceDetails: {
                                type: "structure",
                                members: {
                                  Family: {},
                                  NodeType: {},
                                  Region: {},
                                  CurrentGeneration: {
                                    type: "boolean"
                                  },
                                  SizeFlexEligible: {
                                    type: "boolean"
                                  }
                                }
                              },
                              ElastiCacheInstanceDetails: {
                                type: "structure",
                                members: {
                                  Family: {},
                                  NodeType: {},
                                  Region: {},
                                  ProductDescription: {},
                                  CurrentGeneration: {
                                    type: "boolean"
                                  },
                                  SizeFlexEligible: {
                                    type: "boolean"
                                  }
                                }
                              },
                              ESInstanceDetails: {
                                type: "structure",
                                members: {
                                  InstanceClass: {},
                                  InstanceSize: {},
                                  Region: {},
                                  CurrentGeneration: {
                                    type: "boolean"
                                  },
                                  SizeFlexEligible: {
                                    type: "boolean"
                                  }
                                }
                              }
                            }
                          },
                          RecommendedNumberOfInstancesToPurchase: {},
                          RecommendedNormalizedUnitsToPurchase: {},
                          MinimumNumberOfInstancesUsedPerHour: {},
                          MinimumNormalizedUnitsUsedPerHour: {},
                          MaximumNumberOfInstancesUsedPerHour: {},
                          MaximumNormalizedUnitsUsedPerHour: {},
                          AverageNumberOfInstancesUsedPerHour: {},
                          AverageNormalizedUnitsUsedPerHour: {},
                          AverageUtilization: {},
                          EstimatedBreakEvenInMonths: {},
                          CurrencyCode: {},
                          EstimatedMonthlySavingsAmount: {},
                          EstimatedMonthlySavingsPercentage: {},
                          EstimatedMonthlyOnDemandCost: {},
                          EstimatedReservationCostForLookbackPeriod: {},
                          UpfrontCost: {},
                          RecurringStandardMonthlyCost: {}
                        }
                      }
                    },
                    RecommendationSummary: {
                      type: "structure",
                      members: {
                        TotalEstimatedMonthlySavingsAmount: {},
                        TotalEstimatedMonthlySavingsPercentage: {},
                        CurrencyCode: {}
                      }
                    }
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        GetReservationUtilization: {
          input: {
            type: "structure",
            required: [
              "TimePeriod"
            ],
            members: {
              TimePeriod: {
                shape: "S2e"
              },
              GroupBy: {
                shape: "S2i"
              },
              Granularity: {},
              Filter: {
                shape: "S7"
              },
              SortBy: {
                shape: "S38"
              },
              NextPageToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UtilizationsByTime"
            ],
            members: {
              UtilizationsByTime: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TimePeriod: {
                      shape: "S2e"
                    },
                    Groups: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Key: {},
                          Value: {},
                          Attributes: {
                            shape: "S30"
                          },
                          Utilization: {
                            shape: "S51"
                          }
                        }
                      }
                    },
                    Total: {
                      shape: "S51"
                    }
                  }
                }
              },
              Total: {
                shape: "S51"
              },
              NextPageToken: {}
            }
          }
        },
        GetRightsizingRecommendation: {
          input: {
            type: "structure",
            required: [
              "Service"
            ],
            members: {
              Filter: {
                shape: "S7"
              },
              Configuration: {
                shape: "S5k"
              },
              Service: {},
              PageSize: {
                type: "integer"
              },
              NextPageToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Metadata: {
                type: "structure",
                members: {
                  RecommendationId: {},
                  GenerationTimestamp: {},
                  LookbackPeriodInDays: {},
                  AdditionalMetadata: {}
                }
              },
              Summary: {
                type: "structure",
                members: {
                  TotalRecommendationCount: {},
                  EstimatedTotalMonthlySavingsAmount: {},
                  SavingsCurrencyCode: {},
                  SavingsPercentage: {}
                }
              },
              RightsizingRecommendations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountId: {},
                    CurrentInstance: {
                      type: "structure",
                      members: {
                        ResourceId: {},
                        InstanceName: {},
                        Tags: {
                          type: "list",
                          member: {
                            shape: "Sf"
                          }
                        },
                        ResourceDetails: {
                          shape: "S5t"
                        },
                        ResourceUtilization: {
                          shape: "S5v"
                        },
                        ReservationCoveredHoursInLookbackPeriod: {},
                        SavingsPlansCoveredHoursInLookbackPeriod: {},
                        OnDemandHoursInLookbackPeriod: {},
                        TotalRunningHoursInLookbackPeriod: {},
                        MonthlyCost: {},
                        CurrencyCode: {}
                      }
                    },
                    RightsizingType: {},
                    ModifyRecommendationDetail: {
                      type: "structure",
                      members: {
                        TargetInstances: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              EstimatedMonthlyCost: {},
                              EstimatedMonthlySavings: {},
                              CurrencyCode: {},
                              DefaultTargetInstance: {
                                type: "boolean"
                              },
                              ResourceDetails: {
                                shape: "S5t"
                              },
                              ExpectedResourceUtilization: {
                                shape: "S5v"
                              },
                              PlatformDifferences: {
                                type: "list",
                                member: {}
                              }
                            }
                          }
                        }
                      }
                    },
                    TerminateRecommendationDetail: {
                      type: "structure",
                      members: {
                        EstimatedMonthlySavings: {},
                        CurrencyCode: {}
                      }
                    },
                    FindingReasonCodes: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              NextPageToken: {},
              Configuration: {
                shape: "S5k"
              }
            }
          }
        },
        GetSavingsPlansCoverage: {
          input: {
            type: "structure",
            required: [
              "TimePeriod"
            ],
            members: {
              TimePeriod: {
                shape: "S2e"
              },
              GroupBy: {
                shape: "S2i"
              },
              Granularity: {},
              Filter: {
                shape: "S7"
              },
              Metrics: {
                shape: "S2g"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SortBy: {
                shape: "S38"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "SavingsPlansCoverages"
            ],
            members: {
              SavingsPlansCoverages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Attributes: {
                      shape: "S30"
                    },
                    Coverage: {
                      type: "structure",
                      members: {
                        SpendCoveredBySavingsPlans: {},
                        OnDemandCost: {},
                        TotalCost: {},
                        CoveragePercentage: {}
                      }
                    },
                    TimePeriod: {
                      shape: "S2e"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetSavingsPlansPurchaseRecommendation: {
          input: {
            type: "structure",
            required: [
              "SavingsPlansType",
              "TermInYears",
              "PaymentOption",
              "LookbackPeriodInDays"
            ],
            members: {
              SavingsPlansType: {},
              TermInYears: {},
              PaymentOption: {},
              AccountScope: {},
              NextPageToken: {},
              PageSize: {
                type: "integer"
              },
              LookbackPeriodInDays: {},
              Filter: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Metadata: {
                type: "structure",
                members: {
                  RecommendationId: {},
                  GenerationTimestamp: {},
                  AdditionalMetadata: {}
                }
              },
              SavingsPlansPurchaseRecommendation: {
                type: "structure",
                members: {
                  AccountScope: {},
                  SavingsPlansType: {},
                  TermInYears: {},
                  PaymentOption: {},
                  LookbackPeriodInDays: {},
                  SavingsPlansPurchaseRecommendationDetails: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        SavingsPlansDetails: {
                          type: "structure",
                          members: {
                            Region: {},
                            InstanceFamily: {},
                            OfferingId: {}
                          }
                        },
                        AccountId: {},
                        UpfrontCost: {},
                        EstimatedROI: {},
                        CurrencyCode: {},
                        EstimatedSPCost: {},
                        EstimatedOnDemandCost: {},
                        EstimatedOnDemandCostWithCurrentCommitment: {},
                        EstimatedSavingsAmount: {},
                        EstimatedSavingsPercentage: {},
                        HourlyCommitmentToPurchase: {},
                        EstimatedAverageUtilization: {},
                        EstimatedMonthlySavingsAmount: {},
                        CurrentMinimumHourlyOnDemandSpend: {},
                        CurrentMaximumHourlyOnDemandSpend: {},
                        CurrentAverageHourlyOnDemandSpend: {}
                      }
                    }
                  },
                  SavingsPlansPurchaseRecommendationSummary: {
                    type: "structure",
                    members: {
                      EstimatedROI: {},
                      CurrencyCode: {},
                      EstimatedTotalCost: {},
                      CurrentOnDemandSpend: {},
                      EstimatedSavingsAmount: {},
                      TotalRecommendationCount: {},
                      DailyCommitmentToPurchase: {},
                      HourlyCommitmentToPurchase: {},
                      EstimatedSavingsPercentage: {},
                      EstimatedMonthlySavingsAmount: {},
                      EstimatedOnDemandCostWithCurrentCommitment: {}
                    }
                  }
                }
              },
              NextPageToken: {}
            }
          }
        },
        GetSavingsPlansUtilization: {
          input: {
            type: "structure",
            required: [
              "TimePeriod"
            ],
            members: {
              TimePeriod: {
                shape: "S2e"
              },
              Granularity: {},
              Filter: {
                shape: "S7"
              },
              SortBy: {
                shape: "S38"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Total"
            ],
            members: {
              SavingsPlansUtilizationsByTime: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "TimePeriod",
                    "Utilization"
                  ],
                  members: {
                    TimePeriod: {
                      shape: "S2e"
                    },
                    Utilization: {
                      shape: "S6r"
                    },
                    Savings: {
                      shape: "S6s"
                    },
                    AmortizedCommitment: {
                      shape: "S6t"
                    }
                  }
                }
              },
              Total: {
                shape: "S6u"
              }
            }
          }
        },
        GetSavingsPlansUtilizationDetails: {
          input: {
            type: "structure",
            required: [
              "TimePeriod"
            ],
            members: {
              TimePeriod: {
                shape: "S2e"
              },
              Filter: {
                shape: "S7"
              },
              DataType: {
                type: "list",
                member: {}
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SortBy: {
                shape: "S38"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "SavingsPlansUtilizationDetails",
              "TimePeriod"
            ],
            members: {
              SavingsPlansUtilizationDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SavingsPlanArn: {},
                    Attributes: {
                      shape: "S30"
                    },
                    Utilization: {
                      shape: "S6r"
                    },
                    Savings: {
                      shape: "S6s"
                    },
                    AmortizedCommitment: {
                      shape: "S6t"
                    }
                  }
                }
              },
              Total: {
                shape: "S6u"
              },
              TimePeriod: {
                shape: "S2e"
              },
              NextToken: {}
            }
          }
        },
        GetTags: {
          input: {
            type: "structure",
            required: [
              "TimePeriod"
            ],
            members: {
              SearchString: {},
              TimePeriod: {
                shape: "S2e"
              },
              TagKey: {},
              Filter: {
                shape: "S7"
              },
              SortBy: {
                shape: "S37"
              },
              MaxResults: {
                type: "integer"
              },
              NextPageToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags",
              "ReturnSize",
              "TotalSize"
            ],
            members: {
              NextPageToken: {},
              Tags: {
                type: "list",
                member: {}
              },
              ReturnSize: {
                type: "integer"
              },
              TotalSize: {
                type: "integer"
              }
            }
          }
        },
        GetUsageForecast: {
          input: {
            type: "structure",
            required: [
              "TimePeriod",
              "Metric",
              "Granularity"
            ],
            members: {
              TimePeriod: {
                shape: "S2e"
              },
              Metric: {},
              Granularity: {},
              Filter: {
                shape: "S7"
              },
              PredictionIntervalLevel: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Total: {
                shape: "S2q"
              },
              ForecastResultsByTime: {
                shape: "S3j"
              }
            }
          }
        },
        ListCostCategoryDefinitions: {
          input: {
            type: "structure",
            members: {
              EffectiveOn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CostCategoryReferences: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CostCategoryArn: {},
                    Name: {},
                    EffectiveStart: {},
                    EffectiveEnd: {},
                    NumberOfRules: {
                      type: "integer"
                    },
                    ProcessingStatus: {
                      shape: "S1o"
                    },
                    Values: {
                      shape: "S3e"
                    },
                    DefaultValue: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ProvideAnomalyFeedback: {
          input: {
            type: "structure",
            required: [
              "AnomalyId",
              "Feedback"
            ],
            members: {
              AnomalyId: {},
              Feedback: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AnomalyId"
            ],
            members: {
              AnomalyId: {}
            }
          }
        },
        UpdateAnomalyMonitor: {
          input: {
            type: "structure",
            required: [
              "MonitorArn"
            ],
            members: {
              MonitorArn: {},
              MonitorName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "MonitorArn"
            ],
            members: {
              MonitorArn: {}
            }
          }
        },
        UpdateAnomalySubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionArn"
            ],
            members: {
              SubscriptionArn: {},
              Threshold: {
                type: "double"
              },
              Frequency: {},
              MonitorArnList: {
                shape: "Sn"
              },
              Subscribers: {
                shape: "Sp"
              },
              SubscriptionName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "SubscriptionArn"
            ],
            members: {
              SubscriptionArn: {}
            }
          }
        },
        UpdateCostCategoryDefinition: {
          input: {
            type: "structure",
            required: [
              "CostCategoryArn",
              "RuleVersion",
              "Rules"
            ],
            members: {
              CostCategoryArn: {},
              RuleVersion: {},
              Rules: {
                shape: "Sz"
              },
              DefaultValue: {},
              SplitChargeRules: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CostCategoryArn: {},
              EffectiveStart: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "MonitorName",
            "MonitorType"
          ],
          members: {
            MonitorArn: {},
            MonitorName: {},
            CreationDate: {},
            LastUpdatedDate: {},
            LastEvaluatedDate: {},
            MonitorType: {},
            MonitorDimension: {},
            MonitorSpecification: {
              shape: "S7"
            },
            DimensionalValueCount: {
              type: "integer"
            }
          }
        },
        S7: {
          type: "structure",
          members: {
            Or: {
              shape: "S8"
            },
            And: {
              shape: "S8"
            },
            Not: {
              shape: "S7"
            },
            Dimensions: {
              type: "structure",
              members: {
                Key: {},
                Values: {
                  shape: "Sb"
                },
                MatchOptions: {
                  shape: "Sd"
                }
              }
            },
            Tags: {
              shape: "Sf"
            },
            CostCategories: {
              type: "structure",
              members: {
                Key: {},
                Values: {
                  shape: "Sb"
                },
                MatchOptions: {
                  shape: "Sd"
                }
              }
            }
          }
        },
        S8: {
          type: "list",
          member: {
            shape: "S7"
          }
        },
        Sb: {
          type: "list",
          member: {}
        },
        Sd: {
          type: "list",
          member: {}
        },
        Sf: {
          type: "structure",
          members: {
            Key: {},
            Values: {
              shape: "Sb"
            },
            MatchOptions: {
              shape: "Sd"
            }
          }
        },
        Sm: {
          type: "structure",
          required: [
            "MonitorArnList",
            "Subscribers",
            "Threshold",
            "Frequency",
            "SubscriptionName"
          ],
          members: {
            SubscriptionArn: {},
            AccountId: {},
            MonitorArnList: {
              shape: "Sn"
            },
            Subscribers: {
              shape: "Sp"
            },
            Threshold: {
              type: "double"
            },
            Frequency: {},
            SubscriptionName: {}
          }
        },
        Sn: {
          type: "list",
          member: {}
        },
        Sp: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Address: {},
              Type: {},
              Status: {}
            }
          }
        },
        Sz: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Value: {},
              Rule: {
                shape: "S7"
              },
              InheritedValue: {
                type: "structure",
                members: {
                  DimensionName: {},
                  DimensionKey: {}
                }
              },
              Type: {}
            }
          }
        },
        S15: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Source",
              "Targets",
              "Method"
            ],
            members: {
              Source: {},
              Targets: {
                type: "list",
                member: {}
              },
              Method: {},
              Parameters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Type",
                    "Values"
                  ],
                  members: {
                    Type: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        S1o: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Component: {},
              Status: {}
            }
          }
        },
        S2e: {
          type: "structure",
          required: [
            "Start",
            "End"
          ],
          members: {
            Start: {},
            End: {}
          }
        },
        S2g: {
          type: "list",
          member: {}
        },
        S2i: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              Key: {}
            }
          }
        },
        S2n: {
          type: "list",
          member: {
            type: "structure",
            members: {
              TimePeriod: {
                shape: "S2e"
              },
              Total: {
                shape: "S2p"
              },
              Groups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Keys: {
                      type: "list",
                      member: {}
                    },
                    Metrics: {
                      shape: "S2p"
                    }
                  }
                }
              },
              Estimated: {
                type: "boolean"
              }
            }
          }
        },
        S2p: {
          type: "map",
          key: {},
          value: {
            shape: "S2q"
          }
        },
        S2q: {
          type: "structure",
          members: {
            Amount: {},
            Unit: {}
          }
        },
        S2y: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Value: {},
              Attributes: {
                shape: "S30"
              }
            }
          }
        },
        S30: {
          type: "map",
          key: {},
          value: {}
        },
        S37: {
          type: "list",
          member: {
            shape: "S38"
          }
        },
        S38: {
          type: "structure",
          required: [
            "Key"
          ],
          members: {
            Key: {},
            SortOrder: {}
          }
        },
        S3e: {
          type: "list",
          member: {}
        },
        S3j: {
          type: "list",
          member: {
            type: "structure",
            members: {
              TimePeriod: {
                shape: "S2e"
              },
              MeanValue: {},
              PredictionIntervalLowerBound: {},
              PredictionIntervalUpperBound: {}
            }
          }
        },
        S3u: {
          type: "structure",
          members: {
            CoverageHours: {
              type: "structure",
              members: {
                OnDemandHours: {},
                ReservedHours: {},
                TotalRunningHours: {},
                CoverageHoursPercentage: {}
              }
            },
            CoverageNormalizedUnits: {
              type: "structure",
              members: {
                OnDemandNormalizedUnits: {},
                ReservedNormalizedUnits: {},
                TotalRunningNormalizedUnits: {},
                CoverageNormalizedUnitsPercentage: {}
              }
            },
            CoverageCost: {
              type: "structure",
              members: {
                OnDemandCost: {}
              }
            }
          }
        },
        S4c: {
          type: "structure",
          members: {
            EC2Specification: {
              type: "structure",
              members: {
                OfferingClass: {}
              }
            }
          }
        },
        S51: {
          type: "structure",
          members: {
            UtilizationPercentage: {},
            UtilizationPercentageInUnits: {},
            PurchasedHours: {},
            PurchasedUnits: {},
            TotalActualHours: {},
            TotalActualUnits: {},
            UnusedHours: {},
            UnusedUnits: {},
            OnDemandCostOfRIHoursUsed: {},
            NetRISavings: {},
            TotalPotentialRISavings: {},
            AmortizedUpfrontFee: {},
            AmortizedRecurringFee: {},
            TotalAmortizedFee: {},
            RICostForUnusedHours: {},
            RealizedSavings: {},
            UnrealizedSavings: {}
          }
        },
        S5k: {
          type: "structure",
          required: [
            "RecommendationTarget",
            "BenefitsConsidered"
          ],
          members: {
            RecommendationTarget: {},
            BenefitsConsidered: {
              type: "boolean"
            }
          }
        },
        S5t: {
          type: "structure",
          members: {
            EC2ResourceDetails: {
              type: "structure",
              members: {
                HourlyOnDemandRate: {},
                InstanceType: {},
                Platform: {},
                Region: {},
                Sku: {},
                Memory: {},
                NetworkPerformance: {},
                Storage: {},
                Vcpu: {}
              }
            }
          }
        },
        S5v: {
          type: "structure",
          members: {
            EC2ResourceUtilization: {
              type: "structure",
              members: {
                MaxCpuUtilizationPercentage: {},
                MaxMemoryUtilizationPercentage: {},
                MaxStorageUtilizationPercentage: {},
                EBSResourceUtilization: {
                  type: "structure",
                  members: {
                    EbsReadOpsPerSecond: {},
                    EbsWriteOpsPerSecond: {},
                    EbsReadBytesPerSecond: {},
                    EbsWriteBytesPerSecond: {}
                  }
                },
                DiskResourceUtilization: {
                  type: "structure",
                  members: {
                    DiskReadOpsPerSecond: {},
                    DiskWriteOpsPerSecond: {},
                    DiskReadBytesPerSecond: {},
                    DiskWriteBytesPerSecond: {}
                  }
                },
                NetworkResourceUtilization: {
                  type: "structure",
                  members: {
                    NetworkInBytesPerSecond: {},
                    NetworkOutBytesPerSecond: {},
                    NetworkPacketsInPerSecond: {},
                    NetworkPacketsOutPerSecond: {}
                  }
                }
              }
            }
          }
        },
        S6r: {
          type: "structure",
          members: {
            TotalCommitment: {},
            UsedCommitment: {},
            UnusedCommitment: {},
            UtilizationPercentage: {}
          }
        },
        S6s: {
          type: "structure",
          members: {
            NetSavings: {},
            OnDemandCostEquivalent: {}
          }
        },
        S6t: {
          type: "structure",
          members: {
            AmortizedRecurringCommitment: {},
            AmortizedUpfrontCommitment: {},
            TotalAmortizedCommitment: {}
          }
        },
        S6u: {
          type: "structure",
          required: [
            "Utilization"
          ],
          members: {
            Utilization: {
              shape: "S6r"
            },
            Savings: {
              shape: "S6s"
            },
            AmortizedCommitment: {
              shape: "S6t"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ce-2017-10-25.paginators.json
var require_ce_2017_10_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ce-2017-10-25.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetSavingsPlansCoverage: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        GetSavingsPlansUtilizationDetails: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListCostCategoryDefinitions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/costexplorer.js
var require_costexplorer = __commonJS({
  "node_modules/aws-sdk/clients/costexplorer.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["costexplorer"] = {};
    AWS3.CostExplorer = Service.defineService("costexplorer", ["2017-10-25"]);
    Object.defineProperty(apiLoader.services["costexplorer"], "2017-10-25", {
      get: function get() {
        var model = require_ce_2017_10_25_min();
        model.paginators = require_ce_2017_10_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CostExplorer;
  }
});

// node_modules/aws-sdk/apis/mediaconvert-2017-08-29.min.json
var require_mediaconvert_2017_08_29_min = __commonJS({
  "node_modules/aws-sdk/apis/mediaconvert-2017-08-29.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2017-08-29",
        endpointPrefix: "mediaconvert",
        signingName: "mediaconvert",
        serviceFullName: "AWS Elemental MediaConvert",
        serviceId: "MediaConvert",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "mediaconvert-2017-08-29",
        signatureVersion: "v4",
        serviceAbbreviation: "MediaConvert"
      },
      operations: {
        AssociateCertificate: {
          http: {
            requestUri: "/2017-08-29/certificates",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              }
            },
            required: [
              "Arn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelJob: {
          http: {
            method: "DELETE",
            requestUri: "/2017-08-29/jobs/{id}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Id: {
                locationName: "id",
                location: "uri"
              }
            },
            required: [
              "Id"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateJob: {
          http: {
            requestUri: "/2017-08-29/jobs",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              AccelerationSettings: {
                shape: "S7",
                locationName: "accelerationSettings"
              },
              BillingTagsSource: {
                locationName: "billingTagsSource"
              },
              ClientRequestToken: {
                locationName: "clientRequestToken",
                idempotencyToken: true
              },
              HopDestinations: {
                shape: "Sa",
                locationName: "hopDestinations"
              },
              JobTemplate: {
                locationName: "jobTemplate"
              },
              Priority: {
                locationName: "priority",
                type: "integer"
              },
              Queue: {
                locationName: "queue"
              },
              Role: {
                locationName: "role"
              },
              Settings: {
                shape: "Se",
                locationName: "settings"
              },
              SimulateReservedQueue: {
                locationName: "simulateReservedQueue"
              },
              StatusUpdateInterval: {
                locationName: "statusUpdateInterval"
              },
              Tags: {
                shape: "Sj0",
                locationName: "tags"
              },
              UserMetadata: {
                shape: "Sj0",
                locationName: "userMetadata"
              }
            },
            required: [
              "Role",
              "Settings"
            ]
          },
          output: {
            type: "structure",
            members: {
              Job: {
                shape: "Sj2",
                locationName: "job"
              }
            }
          }
        },
        CreateJobTemplate: {
          http: {
            requestUri: "/2017-08-29/jobTemplates",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              AccelerationSettings: {
                shape: "S7",
                locationName: "accelerationSettings"
              },
              Category: {
                locationName: "category"
              },
              Description: {
                locationName: "description"
              },
              HopDestinations: {
                shape: "Sa",
                locationName: "hopDestinations"
              },
              Name: {
                locationName: "name"
              },
              Priority: {
                locationName: "priority",
                type: "integer"
              },
              Queue: {
                locationName: "queue"
              },
              Settings: {
                shape: "Sji",
                locationName: "settings"
              },
              StatusUpdateInterval: {
                locationName: "statusUpdateInterval"
              },
              Tags: {
                shape: "Sj0",
                locationName: "tags"
              }
            },
            required: [
              "Settings",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              JobTemplate: {
                shape: "Sjm",
                locationName: "jobTemplate"
              }
            }
          }
        },
        CreatePreset: {
          http: {
            requestUri: "/2017-08-29/presets",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Category: {
                locationName: "category"
              },
              Description: {
                locationName: "description"
              },
              Name: {
                locationName: "name"
              },
              Settings: {
                shape: "Sjp",
                locationName: "settings"
              },
              Tags: {
                shape: "Sj0",
                locationName: "tags"
              }
            },
            required: [
              "Settings",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Preset: {
                shape: "Sjt",
                locationName: "preset"
              }
            }
          }
        },
        CreateQueue: {
          http: {
            requestUri: "/2017-08-29/queues",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Description: {
                locationName: "description"
              },
              Name: {
                locationName: "name"
              },
              PricingPlan: {
                locationName: "pricingPlan"
              },
              ReservationPlanSettings: {
                shape: "Sjw",
                locationName: "reservationPlanSettings"
              },
              Status: {
                locationName: "status"
              },
              Tags: {
                shape: "Sj0",
                locationName: "tags"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Queue: {
                shape: "Sk1",
                locationName: "queue"
              }
            }
          }
        },
        DeleteJobTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/2017-08-29/jobTemplates/{name}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Name: {
                locationName: "name",
                location: "uri"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePolicy: {
          http: {
            method: "DELETE",
            requestUri: "/2017-08-29/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePreset: {
          http: {
            method: "DELETE",
            requestUri: "/2017-08-29/presets/{name}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Name: {
                locationName: "name",
                location: "uri"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteQueue: {
          http: {
            method: "DELETE",
            requestUri: "/2017-08-29/queues/{name}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Name: {
                locationName: "name",
                location: "uri"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeEndpoints: {
          http: {
            requestUri: "/2017-08-29/endpoints",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              Mode: {
                locationName: "mode"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Endpoints: {
                locationName: "endpoints",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Url: {
                      locationName: "url"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DisassociateCertificate: {
          http: {
            method: "DELETE",
            requestUri: "/2017-08-29/certificates/{arn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn",
                location: "uri"
              }
            },
            required: [
              "Arn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetJob: {
          http: {
            method: "GET",
            requestUri: "/2017-08-29/jobs/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Id: {
                locationName: "id",
                location: "uri"
              }
            },
            required: [
              "Id"
            ]
          },
          output: {
            type: "structure",
            members: {
              Job: {
                shape: "Sj2",
                locationName: "job"
              }
            }
          }
        },
        GetJobTemplate: {
          http: {
            method: "GET",
            requestUri: "/2017-08-29/jobTemplates/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Name: {
                locationName: "name",
                location: "uri"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              JobTemplate: {
                shape: "Sjm",
                locationName: "jobTemplate"
              }
            }
          }
        },
        GetPolicy: {
          http: {
            method: "GET",
            requestUri: "/2017-08-29/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                shape: "Skp",
                locationName: "policy"
              }
            }
          }
        },
        GetPreset: {
          http: {
            method: "GET",
            requestUri: "/2017-08-29/presets/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Name: {
                locationName: "name",
                location: "uri"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Preset: {
                shape: "Sjt",
                locationName: "preset"
              }
            }
          }
        },
        GetQueue: {
          http: {
            method: "GET",
            requestUri: "/2017-08-29/queues/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Name: {
                locationName: "name",
                location: "uri"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Queue: {
                shape: "Sk1",
                locationName: "queue"
              }
            }
          }
        },
        ListJobTemplates: {
          http: {
            method: "GET",
            requestUri: "/2017-08-29/jobTemplates",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Category: {
                locationName: "category",
                location: "querystring"
              },
              ListBy: {
                locationName: "listBy",
                location: "querystring"
              },
              MaxResults: {
                locationName: "maxResults",
                location: "querystring",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken",
                location: "querystring"
              },
              Order: {
                locationName: "order",
                location: "querystring"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobTemplates: {
                locationName: "jobTemplates",
                type: "list",
                member: {
                  shape: "Sjm"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListJobs: {
          http: {
            method: "GET",
            requestUri: "/2017-08-29/jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                locationName: "maxResults",
                location: "querystring",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken",
                location: "querystring"
              },
              Order: {
                locationName: "order",
                location: "querystring"
              },
              Queue: {
                locationName: "queue",
                location: "querystring"
              },
              Status: {
                locationName: "status",
                location: "querystring"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Jobs: {
                locationName: "jobs",
                type: "list",
                member: {
                  shape: "Sj2"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListPresets: {
          http: {
            method: "GET",
            requestUri: "/2017-08-29/presets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Category: {
                locationName: "category",
                location: "querystring"
              },
              ListBy: {
                locationName: "listBy",
                location: "querystring"
              },
              MaxResults: {
                locationName: "maxResults",
                location: "querystring",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken",
                location: "querystring"
              },
              Order: {
                locationName: "order",
                location: "querystring"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Presets: {
                locationName: "presets",
                type: "list",
                member: {
                  shape: "Sjt"
                }
              }
            }
          }
        },
        ListQueues: {
          http: {
            method: "GET",
            requestUri: "/2017-08-29/queues",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ListBy: {
                locationName: "listBy",
                location: "querystring"
              },
              MaxResults: {
                locationName: "maxResults",
                location: "querystring",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken",
                location: "querystring"
              },
              Order: {
                locationName: "order",
                location: "querystring"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Queues: {
                locationName: "queues",
                type: "list",
                member: {
                  shape: "Sk1"
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2017-08-29/tags/{arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn",
                location: "uri"
              }
            },
            required: [
              "Arn"
            ]
          },
          output: {
            type: "structure",
            members: {
              ResourceTags: {
                locationName: "resourceTags",
                type: "structure",
                members: {
                  Arn: {
                    locationName: "arn"
                  },
                  Tags: {
                    shape: "Sj0",
                    locationName: "tags"
                  }
                }
              }
            }
          }
        },
        PutPolicy: {
          http: {
            method: "PUT",
            requestUri: "/2017-08-29/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Policy: {
                shape: "Skp",
                locationName: "policy"
              }
            },
            required: [
              "Policy"
            ]
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                shape: "Skp",
                locationName: "policy"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/2017-08-29/tags",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              Tags: {
                shape: "Sj0",
                locationName: "tags"
              }
            },
            required: [
              "Arn",
              "Tags"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "PUT",
            requestUri: "/2017-08-29/tags/{arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn",
                location: "uri"
              },
              TagKeys: {
                shape: "Sj7",
                locationName: "tagKeys"
              }
            },
            required: [
              "Arn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateJobTemplate: {
          http: {
            method: "PUT",
            requestUri: "/2017-08-29/jobTemplates/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AccelerationSettings: {
                shape: "S7",
                locationName: "accelerationSettings"
              },
              Category: {
                locationName: "category"
              },
              Description: {
                locationName: "description"
              },
              HopDestinations: {
                shape: "Sa",
                locationName: "hopDestinations"
              },
              Name: {
                locationName: "name",
                location: "uri"
              },
              Priority: {
                locationName: "priority",
                type: "integer"
              },
              Queue: {
                locationName: "queue"
              },
              Settings: {
                shape: "Sji",
                locationName: "settings"
              },
              StatusUpdateInterval: {
                locationName: "statusUpdateInterval"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              JobTemplate: {
                shape: "Sjm",
                locationName: "jobTemplate"
              }
            }
          }
        },
        UpdatePreset: {
          http: {
            method: "PUT",
            requestUri: "/2017-08-29/presets/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Category: {
                locationName: "category"
              },
              Description: {
                locationName: "description"
              },
              Name: {
                locationName: "name",
                location: "uri"
              },
              Settings: {
                shape: "Sjp",
                locationName: "settings"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Preset: {
                shape: "Sjt",
                locationName: "preset"
              }
            }
          }
        },
        UpdateQueue: {
          http: {
            method: "PUT",
            requestUri: "/2017-08-29/queues/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Description: {
                locationName: "description"
              },
              Name: {
                locationName: "name",
                location: "uri"
              },
              ReservationPlanSettings: {
                shape: "Sjw",
                locationName: "reservationPlanSettings"
              },
              Status: {
                locationName: "status"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Queue: {
                shape: "Sk1",
                locationName: "queue"
              }
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "structure",
          members: {
            Mode: {
              locationName: "mode"
            }
          },
          required: [
            "Mode"
          ]
        },
        Sa: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Priority: {
                locationName: "priority",
                type: "integer"
              },
              Queue: {
                locationName: "queue"
              },
              WaitMinutes: {
                locationName: "waitMinutes",
                type: "integer"
              }
            }
          }
        },
        Se: {
          type: "structure",
          members: {
            AdAvailOffset: {
              locationName: "adAvailOffset",
              type: "integer"
            },
            AvailBlanking: {
              shape: "Sg",
              locationName: "availBlanking"
            },
            Esam: {
              shape: "Si",
              locationName: "esam"
            },
            ExtendedDataServices: {
              shape: "So",
              locationName: "extendedDataServices"
            },
            Inputs: {
              locationName: "inputs",
              type: "list",
              member: {
                type: "structure",
                members: {
                  AudioSelectorGroups: {
                    shape: "St",
                    locationName: "audioSelectorGroups"
                  },
                  AudioSelectors: {
                    shape: "Sx",
                    locationName: "audioSelectors"
                  },
                  CaptionSelectors: {
                    shape: "S1i",
                    locationName: "captionSelectors"
                  },
                  Crop: {
                    shape: "S25",
                    locationName: "crop"
                  },
                  DeblockFilter: {
                    locationName: "deblockFilter"
                  },
                  DecryptionSettings: {
                    locationName: "decryptionSettings",
                    type: "structure",
                    members: {
                      DecryptionMode: {
                        locationName: "decryptionMode"
                      },
                      EncryptedDecryptionKey: {
                        locationName: "encryptedDecryptionKey"
                      },
                      InitializationVector: {
                        locationName: "initializationVector"
                      },
                      KmsKeyRegion: {
                        locationName: "kmsKeyRegion"
                      }
                    }
                  },
                  DenoiseFilter: {
                    locationName: "denoiseFilter"
                  },
                  FileInput: {
                    locationName: "fileInput"
                  },
                  FilterEnable: {
                    locationName: "filterEnable"
                  },
                  FilterStrength: {
                    locationName: "filterStrength",
                    type: "integer"
                  },
                  ImageInserter: {
                    shape: "S2i",
                    locationName: "imageInserter"
                  },
                  InputClippings: {
                    shape: "S2p",
                    locationName: "inputClippings"
                  },
                  InputScanType: {
                    locationName: "inputScanType"
                  },
                  Position: {
                    shape: "S25",
                    locationName: "position"
                  },
                  ProgramNumber: {
                    locationName: "programNumber",
                    type: "integer"
                  },
                  PsiControl: {
                    locationName: "psiControl"
                  },
                  SupplementalImps: {
                    locationName: "supplementalImps",
                    type: "list",
                    member: {}
                  },
                  TimecodeSource: {
                    locationName: "timecodeSource"
                  },
                  TimecodeStart: {
                    locationName: "timecodeStart"
                  },
                  VideoSelector: {
                    shape: "S2y",
                    locationName: "videoSelector"
                  }
                }
              }
            },
            KantarWatermark: {
              shape: "S37",
              locationName: "kantarWatermark"
            },
            MotionImageInserter: {
              shape: "S3f",
              locationName: "motionImageInserter"
            },
            NielsenConfiguration: {
              shape: "S3n",
              locationName: "nielsenConfiguration"
            },
            NielsenNonLinearWatermark: {
              shape: "S3p",
              locationName: "nielsenNonLinearWatermark"
            },
            OutputGroups: {
              shape: "S3w",
              locationName: "outputGroups"
            },
            TimecodeConfig: {
              shape: "Sis",
              locationName: "timecodeConfig"
            },
            TimedMetadataInsertion: {
              shape: "Siv",
              locationName: "timedMetadataInsertion"
            }
          }
        },
        Sg: {
          type: "structure",
          members: {
            AvailBlankingImage: {
              locationName: "availBlankingImage"
            }
          }
        },
        Si: {
          type: "structure",
          members: {
            ManifestConfirmConditionNotification: {
              locationName: "manifestConfirmConditionNotification",
              type: "structure",
              members: {
                MccXml: {
                  locationName: "mccXml"
                }
              }
            },
            ResponseSignalPreroll: {
              locationName: "responseSignalPreroll",
              type: "integer"
            },
            SignalProcessingNotification: {
              locationName: "signalProcessingNotification",
              type: "structure",
              members: {
                SccXml: {
                  locationName: "sccXml"
                }
              }
            }
          }
        },
        So: {
          type: "structure",
          members: {
            CopyProtectionAction: {
              locationName: "copyProtectionAction"
            },
            VchipAction: {
              locationName: "vchipAction"
            }
          }
        },
        St: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              AudioSelectorNames: {
                shape: "Sv",
                locationName: "audioSelectorNames"
              }
            }
          }
        },
        Sv: {
          type: "list",
          member: {}
        },
        Sx: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              CustomLanguageCode: {
                locationName: "customLanguageCode"
              },
              DefaultSelection: {
                locationName: "defaultSelection"
              },
              ExternalAudioFileInput: {
                locationName: "externalAudioFileInput"
              },
              HlsRenditionGroupSettings: {
                locationName: "hlsRenditionGroupSettings",
                type: "structure",
                members: {
                  RenditionGroupId: {
                    locationName: "renditionGroupId"
                  },
                  RenditionLanguageCode: {
                    locationName: "renditionLanguageCode"
                  },
                  RenditionName: {
                    locationName: "renditionName"
                  }
                }
              },
              LanguageCode: {
                locationName: "languageCode"
              },
              Offset: {
                locationName: "offset",
                type: "integer"
              },
              Pids: {
                shape: "S15",
                locationName: "pids"
              },
              ProgramSelection: {
                locationName: "programSelection",
                type: "integer"
              },
              RemixSettings: {
                shape: "S18",
                locationName: "remixSettings"
              },
              SelectorType: {
                locationName: "selectorType"
              },
              Tracks: {
                shape: "S15",
                locationName: "tracks"
              }
            }
          }
        },
        S15: {
          type: "list",
          member: {
            type: "integer"
          }
        },
        S18: {
          type: "structure",
          members: {
            ChannelMapping: {
              locationName: "channelMapping",
              type: "structure",
              members: {
                OutputChannels: {
                  locationName: "outputChannels",
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      InputChannels: {
                        locationName: "inputChannels",
                        type: "list",
                        member: {
                          type: "integer"
                        }
                      },
                      InputChannelsFineTune: {
                        locationName: "inputChannelsFineTune",
                        type: "list",
                        member: {
                          type: "double"
                        }
                      }
                    }
                  }
                }
              }
            },
            ChannelsIn: {
              locationName: "channelsIn",
              type: "integer"
            },
            ChannelsOut: {
              locationName: "channelsOut",
              type: "integer"
            }
          }
        },
        S1i: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              CustomLanguageCode: {
                locationName: "customLanguageCode"
              },
              LanguageCode: {
                locationName: "languageCode"
              },
              SourceSettings: {
                locationName: "sourceSettings",
                type: "structure",
                members: {
                  AncillarySourceSettings: {
                    locationName: "ancillarySourceSettings",
                    type: "structure",
                    members: {
                      Convert608To708: {
                        locationName: "convert608To708"
                      },
                      SourceAncillaryChannelNumber: {
                        locationName: "sourceAncillaryChannelNumber",
                        type: "integer"
                      },
                      TerminateCaptions: {
                        locationName: "terminateCaptions"
                      }
                    }
                  },
                  DvbSubSourceSettings: {
                    locationName: "dvbSubSourceSettings",
                    type: "structure",
                    members: {
                      Pid: {
                        locationName: "pid",
                        type: "integer"
                      }
                    }
                  },
                  EmbeddedSourceSettings: {
                    locationName: "embeddedSourceSettings",
                    type: "structure",
                    members: {
                      Convert608To708: {
                        locationName: "convert608To708"
                      },
                      Source608ChannelNumber: {
                        locationName: "source608ChannelNumber",
                        type: "integer"
                      },
                      Source608TrackNumber: {
                        locationName: "source608TrackNumber",
                        type: "integer"
                      },
                      TerminateCaptions: {
                        locationName: "terminateCaptions"
                      }
                    }
                  },
                  FileSourceSettings: {
                    locationName: "fileSourceSettings",
                    type: "structure",
                    members: {
                      Convert608To708: {
                        locationName: "convert608To708"
                      },
                      Framerate: {
                        locationName: "framerate",
                        type: "structure",
                        members: {
                          FramerateDenominator: {
                            locationName: "framerateDenominator",
                            type: "integer"
                          },
                          FramerateNumerator: {
                            locationName: "framerateNumerator",
                            type: "integer"
                          }
                        }
                      },
                      SourceFile: {
                        locationName: "sourceFile"
                      },
                      TimeDelta: {
                        locationName: "timeDelta",
                        type: "integer"
                      }
                    }
                  },
                  SourceType: {
                    locationName: "sourceType"
                  },
                  TeletextSourceSettings: {
                    locationName: "teletextSourceSettings",
                    type: "structure",
                    members: {
                      PageNumber: {
                        locationName: "pageNumber"
                      }
                    }
                  },
                  TrackSourceSettings: {
                    locationName: "trackSourceSettings",
                    type: "structure",
                    members: {
                      TrackNumber: {
                        locationName: "trackNumber",
                        type: "integer"
                      }
                    }
                  },
                  WebvttHlsSourceSettings: {
                    locationName: "webvttHlsSourceSettings",
                    type: "structure",
                    members: {
                      RenditionGroupId: {
                        locationName: "renditionGroupId"
                      },
                      RenditionLanguageCode: {
                        locationName: "renditionLanguageCode"
                      },
                      RenditionName: {
                        locationName: "renditionName"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S25: {
          type: "structure",
          members: {
            Height: {
              locationName: "height",
              type: "integer"
            },
            Width: {
              locationName: "width",
              type: "integer"
            },
            X: {
              locationName: "x",
              type: "integer"
            },
            Y: {
              locationName: "y",
              type: "integer"
            }
          }
        },
        S2i: {
          type: "structure",
          members: {
            InsertableImages: {
              locationName: "insertableImages",
              type: "list",
              member: {
                type: "structure",
                members: {
                  Duration: {
                    locationName: "duration",
                    type: "integer"
                  },
                  FadeIn: {
                    locationName: "fadeIn",
                    type: "integer"
                  },
                  FadeOut: {
                    locationName: "fadeOut",
                    type: "integer"
                  },
                  Height: {
                    locationName: "height",
                    type: "integer"
                  },
                  ImageInserterInput: {
                    locationName: "imageInserterInput"
                  },
                  ImageX: {
                    locationName: "imageX",
                    type: "integer"
                  },
                  ImageY: {
                    locationName: "imageY",
                    type: "integer"
                  },
                  Layer: {
                    locationName: "layer",
                    type: "integer"
                  },
                  Opacity: {
                    locationName: "opacity",
                    type: "integer"
                  },
                  StartTime: {
                    locationName: "startTime"
                  },
                  Width: {
                    locationName: "width",
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        S2p: {
          type: "list",
          member: {
            type: "structure",
            members: {
              EndTimecode: {
                locationName: "endTimecode"
              },
              StartTimecode: {
                locationName: "startTimecode"
              }
            }
          }
        },
        S2y: {
          type: "structure",
          members: {
            AlphaBehavior: {
              locationName: "alphaBehavior"
            },
            ColorSpace: {
              locationName: "colorSpace"
            },
            ColorSpaceUsage: {
              locationName: "colorSpaceUsage"
            },
            Hdr10Metadata: {
              shape: "S32",
              locationName: "hdr10Metadata"
            },
            Pid: {
              locationName: "pid",
              type: "integer"
            },
            ProgramNumber: {
              locationName: "programNumber",
              type: "integer"
            },
            Rotate: {
              locationName: "rotate"
            },
            SampleRange: {
              locationName: "sampleRange"
            }
          }
        },
        S32: {
          type: "structure",
          members: {
            BluePrimaryX: {
              locationName: "bluePrimaryX",
              type: "integer"
            },
            BluePrimaryY: {
              locationName: "bluePrimaryY",
              type: "integer"
            },
            GreenPrimaryX: {
              locationName: "greenPrimaryX",
              type: "integer"
            },
            GreenPrimaryY: {
              locationName: "greenPrimaryY",
              type: "integer"
            },
            MaxContentLightLevel: {
              locationName: "maxContentLightLevel",
              type: "integer"
            },
            MaxFrameAverageLightLevel: {
              locationName: "maxFrameAverageLightLevel",
              type: "integer"
            },
            MaxLuminance: {
              locationName: "maxLuminance",
              type: "integer"
            },
            MinLuminance: {
              locationName: "minLuminance",
              type: "integer"
            },
            RedPrimaryX: {
              locationName: "redPrimaryX",
              type: "integer"
            },
            RedPrimaryY: {
              locationName: "redPrimaryY",
              type: "integer"
            },
            WhitePointX: {
              locationName: "whitePointX",
              type: "integer"
            },
            WhitePointY: {
              locationName: "whitePointY",
              type: "integer"
            }
          }
        },
        S37: {
          type: "structure",
          members: {
            ChannelName: {
              locationName: "channelName"
            },
            ContentReference: {
              locationName: "contentReference"
            },
            CredentialsSecretName: {
              locationName: "credentialsSecretName"
            },
            FileOffset: {
              locationName: "fileOffset",
              type: "double"
            },
            KantarLicenseId: {
              locationName: "kantarLicenseId",
              type: "integer"
            },
            KantarServerUrl: {
              locationName: "kantarServerUrl"
            },
            LogDestination: {
              locationName: "logDestination"
            },
            Metadata3: {
              locationName: "metadata3"
            },
            Metadata4: {
              locationName: "metadata4"
            },
            Metadata5: {
              locationName: "metadata5"
            },
            Metadata6: {
              locationName: "metadata6"
            },
            Metadata7: {
              locationName: "metadata7"
            },
            Metadata8: {
              locationName: "metadata8"
            }
          }
        },
        S3f: {
          type: "structure",
          members: {
            Framerate: {
              locationName: "framerate",
              type: "structure",
              members: {
                FramerateDenominator: {
                  locationName: "framerateDenominator",
                  type: "integer"
                },
                FramerateNumerator: {
                  locationName: "framerateNumerator",
                  type: "integer"
                }
              }
            },
            Input: {
              locationName: "input"
            },
            InsertionMode: {
              locationName: "insertionMode"
            },
            Offset: {
              locationName: "offset",
              type: "structure",
              members: {
                ImageX: {
                  locationName: "imageX",
                  type: "integer"
                },
                ImageY: {
                  locationName: "imageY",
                  type: "integer"
                }
              }
            },
            Playback: {
              locationName: "playback"
            },
            StartTime: {
              locationName: "startTime"
            }
          }
        },
        S3n: {
          type: "structure",
          members: {
            BreakoutCode: {
              locationName: "breakoutCode",
              type: "integer"
            },
            DistributorId: {
              locationName: "distributorId"
            }
          }
        },
        S3p: {
          type: "structure",
          members: {
            ActiveWatermarkProcess: {
              locationName: "activeWatermarkProcess"
            },
            AdiFilename: {
              locationName: "adiFilename"
            },
            AssetId: {
              locationName: "assetId"
            },
            AssetName: {
              locationName: "assetName"
            },
            CbetSourceId: {
              locationName: "cbetSourceId"
            },
            EpisodeId: {
              locationName: "episodeId"
            },
            MetadataDestination: {
              locationName: "metadataDestination"
            },
            SourceId: {
              locationName: "sourceId",
              type: "integer"
            },
            SourceWatermarkStatus: {
              locationName: "sourceWatermarkStatus"
            },
            TicServerUrl: {
              locationName: "ticServerUrl"
            },
            UniqueTicPerAudioTrack: {
              locationName: "uniqueTicPerAudioTrack"
            }
          }
        },
        S3w: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AutomatedEncodingSettings: {
                locationName: "automatedEncodingSettings",
                type: "structure",
                members: {
                  AbrSettings: {
                    locationName: "abrSettings",
                    type: "structure",
                    members: {
                      MaxAbrBitrate: {
                        locationName: "maxAbrBitrate",
                        type: "integer"
                      },
                      MaxRenditions: {
                        locationName: "maxRenditions",
                        type: "integer"
                      },
                      MinAbrBitrate: {
                        locationName: "minAbrBitrate",
                        type: "integer"
                      }
                    }
                  }
                }
              },
              CustomName: {
                locationName: "customName"
              },
              Name: {
                locationName: "name"
              },
              OutputGroupSettings: {
                locationName: "outputGroupSettings",
                type: "structure",
                members: {
                  CmafGroupSettings: {
                    locationName: "cmafGroupSettings",
                    type: "structure",
                    members: {
                      AdditionalManifests: {
                        locationName: "additionalManifests",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            ManifestNameModifier: {
                              locationName: "manifestNameModifier"
                            },
                            SelectedOutputs: {
                              shape: "Sv",
                              locationName: "selectedOutputs"
                            }
                          }
                        }
                      },
                      BaseUrl: {
                        locationName: "baseUrl"
                      },
                      ClientCache: {
                        locationName: "clientCache"
                      },
                      CodecSpecification: {
                        locationName: "codecSpecification"
                      },
                      Destination: {
                        locationName: "destination"
                      },
                      DestinationSettings: {
                        shape: "S48",
                        locationName: "destinationSettings"
                      },
                      Encryption: {
                        locationName: "encryption",
                        type: "structure",
                        members: {
                          ConstantInitializationVector: {
                            locationName: "constantInitializationVector"
                          },
                          EncryptionMethod: {
                            locationName: "encryptionMethod"
                          },
                          InitializationVectorInManifest: {
                            locationName: "initializationVectorInManifest"
                          },
                          SpekeKeyProvider: {
                            locationName: "spekeKeyProvider",
                            type: "structure",
                            members: {
                              CertificateArn: {
                                locationName: "certificateArn"
                              },
                              DashSignaledSystemIds: {
                                shape: "S4m",
                                locationName: "dashSignaledSystemIds"
                              },
                              HlsSignaledSystemIds: {
                                shape: "S4m",
                                locationName: "hlsSignaledSystemIds"
                              },
                              ResourceId: {
                                locationName: "resourceId"
                              },
                              Url: {
                                locationName: "url"
                              }
                            }
                          },
                          StaticKeyProvider: {
                            shape: "S4p",
                            locationName: "staticKeyProvider"
                          },
                          Type: {
                            locationName: "type"
                          }
                        }
                      },
                      FragmentLength: {
                        locationName: "fragmentLength",
                        type: "integer"
                      },
                      ImageBasedTrickPlay: {
                        locationName: "imageBasedTrickPlay"
                      },
                      ImageBasedTrickPlaySettings: {
                        locationName: "imageBasedTrickPlaySettings",
                        type: "structure",
                        members: {
                          IntervalCadence: {
                            locationName: "intervalCadence"
                          },
                          ThumbnailHeight: {
                            locationName: "thumbnailHeight",
                            type: "integer"
                          },
                          ThumbnailInterval: {
                            locationName: "thumbnailInterval",
                            type: "double"
                          },
                          ThumbnailWidth: {
                            locationName: "thumbnailWidth",
                            type: "integer"
                          },
                          TileHeight: {
                            locationName: "tileHeight",
                            type: "integer"
                          },
                          TileWidth: {
                            locationName: "tileWidth",
                            type: "integer"
                          }
                        }
                      },
                      ManifestCompression: {
                        locationName: "manifestCompression"
                      },
                      ManifestDurationFormat: {
                        locationName: "manifestDurationFormat"
                      },
                      MinBufferTime: {
                        locationName: "minBufferTime",
                        type: "integer"
                      },
                      MinFinalSegmentLength: {
                        locationName: "minFinalSegmentLength",
                        type: "double"
                      },
                      MpdProfile: {
                        locationName: "mpdProfile"
                      },
                      PtsOffsetHandlingForBFrames: {
                        locationName: "ptsOffsetHandlingForBFrames"
                      },
                      SegmentControl: {
                        locationName: "segmentControl"
                      },
                      SegmentLength: {
                        locationName: "segmentLength",
                        type: "integer"
                      },
                      SegmentLengthControl: {
                        locationName: "segmentLengthControl"
                      },
                      StreamInfResolution: {
                        locationName: "streamInfResolution"
                      },
                      TargetDurationCompatibilityMode: {
                        locationName: "targetDurationCompatibilityMode"
                      },
                      WriteDashManifest: {
                        locationName: "writeDashManifest"
                      },
                      WriteHlsManifest: {
                        locationName: "writeHlsManifest"
                      },
                      WriteSegmentTimelineInRepresentation: {
                        locationName: "writeSegmentTimelineInRepresentation"
                      }
                    }
                  },
                  DashIsoGroupSettings: {
                    locationName: "dashIsoGroupSettings",
                    type: "structure",
                    members: {
                      AdditionalManifests: {
                        locationName: "additionalManifests",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            ManifestNameModifier: {
                              locationName: "manifestNameModifier"
                            },
                            SelectedOutputs: {
                              shape: "Sv",
                              locationName: "selectedOutputs"
                            }
                          }
                        }
                      },
                      AudioChannelConfigSchemeIdUri: {
                        locationName: "audioChannelConfigSchemeIdUri"
                      },
                      BaseUrl: {
                        locationName: "baseUrl"
                      },
                      Destination: {
                        locationName: "destination"
                      },
                      DestinationSettings: {
                        shape: "S48",
                        locationName: "destinationSettings"
                      },
                      Encryption: {
                        locationName: "encryption",
                        type: "structure",
                        members: {
                          PlaybackDeviceCompatibility: {
                            locationName: "playbackDeviceCompatibility"
                          },
                          SpekeKeyProvider: {
                            shape: "S5j",
                            locationName: "spekeKeyProvider"
                          }
                        }
                      },
                      FragmentLength: {
                        locationName: "fragmentLength",
                        type: "integer"
                      },
                      HbbtvCompliance: {
                        locationName: "hbbtvCompliance"
                      },
                      ImageBasedTrickPlay: {
                        locationName: "imageBasedTrickPlay"
                      },
                      ImageBasedTrickPlaySettings: {
                        locationName: "imageBasedTrickPlaySettings",
                        type: "structure",
                        members: {
                          IntervalCadence: {
                            locationName: "intervalCadence"
                          },
                          ThumbnailHeight: {
                            locationName: "thumbnailHeight",
                            type: "integer"
                          },
                          ThumbnailInterval: {
                            locationName: "thumbnailInterval",
                            type: "double"
                          },
                          ThumbnailWidth: {
                            locationName: "thumbnailWidth",
                            type: "integer"
                          },
                          TileHeight: {
                            locationName: "tileHeight",
                            type: "integer"
                          },
                          TileWidth: {
                            locationName: "tileWidth",
                            type: "integer"
                          }
                        }
                      },
                      MinBufferTime: {
                        locationName: "minBufferTime",
                        type: "integer"
                      },
                      MinFinalSegmentLength: {
                        locationName: "minFinalSegmentLength",
                        type: "double"
                      },
                      MpdProfile: {
                        locationName: "mpdProfile"
                      },
                      PtsOffsetHandlingForBFrames: {
                        locationName: "ptsOffsetHandlingForBFrames"
                      },
                      SegmentControl: {
                        locationName: "segmentControl"
                      },
                      SegmentLength: {
                        locationName: "segmentLength",
                        type: "integer"
                      },
                      SegmentLengthControl: {
                        locationName: "segmentLengthControl"
                      },
                      WriteSegmentTimelineInRepresentation: {
                        locationName: "writeSegmentTimelineInRepresentation"
                      }
                    }
                  },
                  FileGroupSettings: {
                    locationName: "fileGroupSettings",
                    type: "structure",
                    members: {
                      Destination: {
                        locationName: "destination"
                      },
                      DestinationSettings: {
                        shape: "S48",
                        locationName: "destinationSettings"
                      }
                    }
                  },
                  HlsGroupSettings: {
                    locationName: "hlsGroupSettings",
                    type: "structure",
                    members: {
                      AdMarkers: {
                        locationName: "adMarkers",
                        type: "list",
                        member: {}
                      },
                      AdditionalManifests: {
                        locationName: "additionalManifests",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            ManifestNameModifier: {
                              locationName: "manifestNameModifier"
                            },
                            SelectedOutputs: {
                              shape: "Sv",
                              locationName: "selectedOutputs"
                            }
                          }
                        }
                      },
                      AudioOnlyHeader: {
                        locationName: "audioOnlyHeader"
                      },
                      BaseUrl: {
                        locationName: "baseUrl"
                      },
                      CaptionLanguageMappings: {
                        locationName: "captionLanguageMappings",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            CaptionChannel: {
                              locationName: "captionChannel",
                              type: "integer"
                            },
                            CustomLanguageCode: {
                              locationName: "customLanguageCode"
                            },
                            LanguageCode: {
                              locationName: "languageCode"
                            },
                            LanguageDescription: {
                              locationName: "languageDescription"
                            }
                          }
                        }
                      },
                      CaptionLanguageSetting: {
                        locationName: "captionLanguageSetting"
                      },
                      ClientCache: {
                        locationName: "clientCache"
                      },
                      CodecSpecification: {
                        locationName: "codecSpecification"
                      },
                      Destination: {
                        locationName: "destination"
                      },
                      DestinationSettings: {
                        shape: "S48",
                        locationName: "destinationSettings"
                      },
                      DirectoryStructure: {
                        locationName: "directoryStructure"
                      },
                      Encryption: {
                        locationName: "encryption",
                        type: "structure",
                        members: {
                          ConstantInitializationVector: {
                            locationName: "constantInitializationVector"
                          },
                          EncryptionMethod: {
                            locationName: "encryptionMethod"
                          },
                          InitializationVectorInManifest: {
                            locationName: "initializationVectorInManifest"
                          },
                          OfflineEncrypted: {
                            locationName: "offlineEncrypted"
                          },
                          SpekeKeyProvider: {
                            shape: "S5j",
                            locationName: "spekeKeyProvider"
                          },
                          StaticKeyProvider: {
                            shape: "S4p",
                            locationName: "staticKeyProvider"
                          },
                          Type: {
                            locationName: "type"
                          }
                        }
                      },
                      ImageBasedTrickPlay: {
                        locationName: "imageBasedTrickPlay"
                      },
                      ImageBasedTrickPlaySettings: {
                        locationName: "imageBasedTrickPlaySettings",
                        type: "structure",
                        members: {
                          IntervalCadence: {
                            locationName: "intervalCadence"
                          },
                          ThumbnailHeight: {
                            locationName: "thumbnailHeight",
                            type: "integer"
                          },
                          ThumbnailInterval: {
                            locationName: "thumbnailInterval",
                            type: "double"
                          },
                          ThumbnailWidth: {
                            locationName: "thumbnailWidth",
                            type: "integer"
                          },
                          TileHeight: {
                            locationName: "tileHeight",
                            type: "integer"
                          },
                          TileWidth: {
                            locationName: "tileWidth",
                            type: "integer"
                          }
                        }
                      },
                      ManifestCompression: {
                        locationName: "manifestCompression"
                      },
                      ManifestDurationFormat: {
                        locationName: "manifestDurationFormat"
                      },
                      MinFinalSegmentLength: {
                        locationName: "minFinalSegmentLength",
                        type: "double"
                      },
                      MinSegmentLength: {
                        locationName: "minSegmentLength",
                        type: "integer"
                      },
                      OutputSelection: {
                        locationName: "outputSelection"
                      },
                      ProgramDateTime: {
                        locationName: "programDateTime"
                      },
                      ProgramDateTimePeriod: {
                        locationName: "programDateTimePeriod",
                        type: "integer"
                      },
                      SegmentControl: {
                        locationName: "segmentControl"
                      },
                      SegmentLength: {
                        locationName: "segmentLength",
                        type: "integer"
                      },
                      SegmentLengthControl: {
                        locationName: "segmentLengthControl"
                      },
                      SegmentsPerSubdirectory: {
                        locationName: "segmentsPerSubdirectory",
                        type: "integer"
                      },
                      StreamInfResolution: {
                        locationName: "streamInfResolution"
                      },
                      TargetDurationCompatibilityMode: {
                        locationName: "targetDurationCompatibilityMode"
                      },
                      TimedMetadataId3Frame: {
                        locationName: "timedMetadataId3Frame"
                      },
                      TimedMetadataId3Period: {
                        locationName: "timedMetadataId3Period",
                        type: "integer"
                      },
                      TimestampDeltaMilliseconds: {
                        locationName: "timestampDeltaMilliseconds",
                        type: "integer"
                      }
                    }
                  },
                  MsSmoothGroupSettings: {
                    locationName: "msSmoothGroupSettings",
                    type: "structure",
                    members: {
                      AdditionalManifests: {
                        locationName: "additionalManifests",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            ManifestNameModifier: {
                              locationName: "manifestNameModifier"
                            },
                            SelectedOutputs: {
                              shape: "Sv",
                              locationName: "selectedOutputs"
                            }
                          }
                        }
                      },
                      AudioDeduplication: {
                        locationName: "audioDeduplication"
                      },
                      Destination: {
                        locationName: "destination"
                      },
                      DestinationSettings: {
                        shape: "S48",
                        locationName: "destinationSettings"
                      },
                      Encryption: {
                        locationName: "encryption",
                        type: "structure",
                        members: {
                          SpekeKeyProvider: {
                            shape: "S5j",
                            locationName: "spekeKeyProvider"
                          }
                        }
                      },
                      FragmentLength: {
                        locationName: "fragmentLength",
                        type: "integer"
                      },
                      FragmentLengthControl: {
                        locationName: "fragmentLengthControl"
                      },
                      ManifestEncoding: {
                        locationName: "manifestEncoding"
                      }
                    }
                  },
                  Type: {
                    locationName: "type"
                  }
                }
              },
              Outputs: {
                locationName: "outputs",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AudioDescriptions: {
                      shape: "S71",
                      locationName: "audioDescriptions"
                    },
                    CaptionDescriptions: {
                      locationName: "captionDescriptions",
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          CaptionSelectorName: {
                            locationName: "captionSelectorName"
                          },
                          CustomLanguageCode: {
                            locationName: "customLanguageCode"
                          },
                          DestinationSettings: {
                            shape: "S9j",
                            locationName: "destinationSettings"
                          },
                          LanguageCode: {
                            locationName: "languageCode"
                          },
                          LanguageDescription: {
                            locationName: "languageDescription"
                          }
                        }
                      }
                    },
                    ContainerSettings: {
                      shape: "Sar",
                      locationName: "containerSettings"
                    },
                    Extension: {
                      locationName: "extension"
                    },
                    NameModifier: {
                      locationName: "nameModifier"
                    },
                    OutputSettings: {
                      locationName: "outputSettings",
                      type: "structure",
                      members: {
                        HlsSettings: {
                          locationName: "hlsSettings",
                          type: "structure",
                          members: {
                            AudioGroupId: {
                              locationName: "audioGroupId"
                            },
                            AudioOnlyContainer: {
                              locationName: "audioOnlyContainer"
                            },
                            AudioRenditionSets: {
                              locationName: "audioRenditionSets"
                            },
                            AudioTrackType: {
                              locationName: "audioTrackType"
                            },
                            DescriptiveVideoServiceFlag: {
                              locationName: "descriptiveVideoServiceFlag"
                            },
                            IFrameOnlyManifest: {
                              locationName: "iFrameOnlyManifest"
                            },
                            SegmentModifier: {
                              locationName: "segmentModifier"
                            }
                          }
                        }
                      }
                    },
                    Preset: {
                      locationName: "preset"
                    },
                    VideoDescription: {
                      shape: "Scv",
                      locationName: "videoDescription"
                    }
                  }
                }
              }
            }
          }
        },
        S48: {
          type: "structure",
          members: {
            S3Settings: {
              locationName: "s3Settings",
              type: "structure",
              members: {
                AccessControl: {
                  locationName: "accessControl",
                  type: "structure",
                  members: {
                    CannedAcl: {
                      locationName: "cannedAcl"
                    }
                  }
                },
                Encryption: {
                  locationName: "encryption",
                  type: "structure",
                  members: {
                    EncryptionType: {
                      locationName: "encryptionType"
                    },
                    KmsEncryptionContext: {
                      locationName: "kmsEncryptionContext"
                    },
                    KmsKeyArn: {
                      locationName: "kmsKeyArn"
                    }
                  }
                }
              }
            }
          }
        },
        S4m: {
          type: "list",
          member: {}
        },
        S4p: {
          type: "structure",
          members: {
            KeyFormat: {
              locationName: "keyFormat"
            },
            KeyFormatVersions: {
              locationName: "keyFormatVersions"
            },
            StaticKeyValue: {
              locationName: "staticKeyValue"
            },
            Url: {
              locationName: "url"
            }
          }
        },
        S5j: {
          type: "structure",
          members: {
            CertificateArn: {
              locationName: "certificateArn"
            },
            ResourceId: {
              locationName: "resourceId"
            },
            SystemIds: {
              locationName: "systemIds",
              type: "list",
              member: {}
            },
            Url: {
              locationName: "url"
            }
          }
        },
        S71: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AudioChannelTaggingSettings: {
                locationName: "audioChannelTaggingSettings",
                type: "structure",
                members: {
                  ChannelTag: {
                    locationName: "channelTag"
                  }
                }
              },
              AudioNormalizationSettings: {
                locationName: "audioNormalizationSettings",
                type: "structure",
                members: {
                  Algorithm: {
                    locationName: "algorithm"
                  },
                  AlgorithmControl: {
                    locationName: "algorithmControl"
                  },
                  CorrectionGateLevel: {
                    locationName: "correctionGateLevel",
                    type: "integer"
                  },
                  LoudnessLogging: {
                    locationName: "loudnessLogging"
                  },
                  PeakCalculation: {
                    locationName: "peakCalculation"
                  },
                  TargetLkfs: {
                    locationName: "targetLkfs",
                    type: "double"
                  }
                }
              },
              AudioSourceName: {
                locationName: "audioSourceName"
              },
              AudioType: {
                locationName: "audioType",
                type: "integer"
              },
              AudioTypeControl: {
                locationName: "audioTypeControl"
              },
              CodecSettings: {
                locationName: "codecSettings",
                type: "structure",
                members: {
                  AacSettings: {
                    locationName: "aacSettings",
                    type: "structure",
                    members: {
                      AudioDescriptionBroadcasterMix: {
                        locationName: "audioDescriptionBroadcasterMix"
                      },
                      Bitrate: {
                        locationName: "bitrate",
                        type: "integer"
                      },
                      CodecProfile: {
                        locationName: "codecProfile"
                      },
                      CodingMode: {
                        locationName: "codingMode"
                      },
                      RateControlMode: {
                        locationName: "rateControlMode"
                      },
                      RawFormat: {
                        locationName: "rawFormat"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      },
                      Specification: {
                        locationName: "specification"
                      },
                      VbrQuality: {
                        locationName: "vbrQuality"
                      }
                    }
                  },
                  Ac3Settings: {
                    locationName: "ac3Settings",
                    type: "structure",
                    members: {
                      Bitrate: {
                        locationName: "bitrate",
                        type: "integer"
                      },
                      BitstreamMode: {
                        locationName: "bitstreamMode"
                      },
                      CodingMode: {
                        locationName: "codingMode"
                      },
                      Dialnorm: {
                        locationName: "dialnorm",
                        type: "integer"
                      },
                      DynamicRangeCompressionLine: {
                        locationName: "dynamicRangeCompressionLine"
                      },
                      DynamicRangeCompressionProfile: {
                        locationName: "dynamicRangeCompressionProfile"
                      },
                      DynamicRangeCompressionRf: {
                        locationName: "dynamicRangeCompressionRf"
                      },
                      LfeFilter: {
                        locationName: "lfeFilter"
                      },
                      MetadataControl: {
                        locationName: "metadataControl"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      }
                    }
                  },
                  AiffSettings: {
                    locationName: "aiffSettings",
                    type: "structure",
                    members: {
                      BitDepth: {
                        locationName: "bitDepth",
                        type: "integer"
                      },
                      Channels: {
                        locationName: "channels",
                        type: "integer"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      }
                    }
                  },
                  Codec: {
                    locationName: "codec"
                  },
                  Eac3AtmosSettings: {
                    locationName: "eac3AtmosSettings",
                    type: "structure",
                    members: {
                      Bitrate: {
                        locationName: "bitrate",
                        type: "integer"
                      },
                      BitstreamMode: {
                        locationName: "bitstreamMode"
                      },
                      CodingMode: {
                        locationName: "codingMode"
                      },
                      DialogueIntelligence: {
                        locationName: "dialogueIntelligence"
                      },
                      DownmixControl: {
                        locationName: "downmixControl"
                      },
                      DynamicRangeCompressionLine: {
                        locationName: "dynamicRangeCompressionLine"
                      },
                      DynamicRangeCompressionRf: {
                        locationName: "dynamicRangeCompressionRf"
                      },
                      DynamicRangeControl: {
                        locationName: "dynamicRangeControl"
                      },
                      LoRoCenterMixLevel: {
                        locationName: "loRoCenterMixLevel",
                        type: "double"
                      },
                      LoRoSurroundMixLevel: {
                        locationName: "loRoSurroundMixLevel",
                        type: "double"
                      },
                      LtRtCenterMixLevel: {
                        locationName: "ltRtCenterMixLevel",
                        type: "double"
                      },
                      LtRtSurroundMixLevel: {
                        locationName: "ltRtSurroundMixLevel",
                        type: "double"
                      },
                      MeteringMode: {
                        locationName: "meteringMode"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      },
                      SpeechThreshold: {
                        locationName: "speechThreshold",
                        type: "integer"
                      },
                      StereoDownmix: {
                        locationName: "stereoDownmix"
                      },
                      SurroundExMode: {
                        locationName: "surroundExMode"
                      }
                    }
                  },
                  Eac3Settings: {
                    locationName: "eac3Settings",
                    type: "structure",
                    members: {
                      AttenuationControl: {
                        locationName: "attenuationControl"
                      },
                      Bitrate: {
                        locationName: "bitrate",
                        type: "integer"
                      },
                      BitstreamMode: {
                        locationName: "bitstreamMode"
                      },
                      CodingMode: {
                        locationName: "codingMode"
                      },
                      DcFilter: {
                        locationName: "dcFilter"
                      },
                      Dialnorm: {
                        locationName: "dialnorm",
                        type: "integer"
                      },
                      DynamicRangeCompressionLine: {
                        locationName: "dynamicRangeCompressionLine"
                      },
                      DynamicRangeCompressionRf: {
                        locationName: "dynamicRangeCompressionRf"
                      },
                      LfeControl: {
                        locationName: "lfeControl"
                      },
                      LfeFilter: {
                        locationName: "lfeFilter"
                      },
                      LoRoCenterMixLevel: {
                        locationName: "loRoCenterMixLevel",
                        type: "double"
                      },
                      LoRoSurroundMixLevel: {
                        locationName: "loRoSurroundMixLevel",
                        type: "double"
                      },
                      LtRtCenterMixLevel: {
                        locationName: "ltRtCenterMixLevel",
                        type: "double"
                      },
                      LtRtSurroundMixLevel: {
                        locationName: "ltRtSurroundMixLevel",
                        type: "double"
                      },
                      MetadataControl: {
                        locationName: "metadataControl"
                      },
                      PassthroughControl: {
                        locationName: "passthroughControl"
                      },
                      PhaseControl: {
                        locationName: "phaseControl"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      },
                      StereoDownmix: {
                        locationName: "stereoDownmix"
                      },
                      SurroundExMode: {
                        locationName: "surroundExMode"
                      },
                      SurroundMode: {
                        locationName: "surroundMode"
                      }
                    }
                  },
                  Mp2Settings: {
                    locationName: "mp2Settings",
                    type: "structure",
                    members: {
                      Bitrate: {
                        locationName: "bitrate",
                        type: "integer"
                      },
                      Channels: {
                        locationName: "channels",
                        type: "integer"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      }
                    }
                  },
                  Mp3Settings: {
                    locationName: "mp3Settings",
                    type: "structure",
                    members: {
                      Bitrate: {
                        locationName: "bitrate",
                        type: "integer"
                      },
                      Channels: {
                        locationName: "channels",
                        type: "integer"
                      },
                      RateControlMode: {
                        locationName: "rateControlMode"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      },
                      VbrQuality: {
                        locationName: "vbrQuality",
                        type: "integer"
                      }
                    }
                  },
                  OpusSettings: {
                    locationName: "opusSettings",
                    type: "structure",
                    members: {
                      Bitrate: {
                        locationName: "bitrate",
                        type: "integer"
                      },
                      Channels: {
                        locationName: "channels",
                        type: "integer"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      }
                    }
                  },
                  VorbisSettings: {
                    locationName: "vorbisSettings",
                    type: "structure",
                    members: {
                      Channels: {
                        locationName: "channels",
                        type: "integer"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      },
                      VbrQuality: {
                        locationName: "vbrQuality",
                        type: "integer"
                      }
                    }
                  },
                  WavSettings: {
                    locationName: "wavSettings",
                    type: "structure",
                    members: {
                      BitDepth: {
                        locationName: "bitDepth",
                        type: "integer"
                      },
                      Channels: {
                        locationName: "channels",
                        type: "integer"
                      },
                      Format: {
                        locationName: "format"
                      },
                      SampleRate: {
                        locationName: "sampleRate",
                        type: "integer"
                      }
                    }
                  }
                }
              },
              CustomLanguageCode: {
                locationName: "customLanguageCode"
              },
              LanguageCode: {
                locationName: "languageCode"
              },
              LanguageCodeControl: {
                locationName: "languageCodeControl"
              },
              RemixSettings: {
                shape: "S18",
                locationName: "remixSettings"
              },
              StreamName: {
                locationName: "streamName"
              }
            }
          }
        },
        S9j: {
          type: "structure",
          members: {
            BurninDestinationSettings: {
              locationName: "burninDestinationSettings",
              type: "structure",
              members: {
                Alignment: {
                  locationName: "alignment"
                },
                ApplyFontColor: {
                  locationName: "applyFontColor"
                },
                BackgroundColor: {
                  locationName: "backgroundColor"
                },
                BackgroundOpacity: {
                  locationName: "backgroundOpacity",
                  type: "integer"
                },
                FallbackFont: {
                  locationName: "fallbackFont"
                },
                FontColor: {
                  locationName: "fontColor"
                },
                FontOpacity: {
                  locationName: "fontOpacity",
                  type: "integer"
                },
                FontResolution: {
                  locationName: "fontResolution",
                  type: "integer"
                },
                FontScript: {
                  locationName: "fontScript"
                },
                FontSize: {
                  locationName: "fontSize",
                  type: "integer"
                },
                HexFontColor: {
                  locationName: "hexFontColor"
                },
                OutlineColor: {
                  locationName: "outlineColor"
                },
                OutlineSize: {
                  locationName: "outlineSize",
                  type: "integer"
                },
                ShadowColor: {
                  locationName: "shadowColor"
                },
                ShadowOpacity: {
                  locationName: "shadowOpacity",
                  type: "integer"
                },
                ShadowXOffset: {
                  locationName: "shadowXOffset",
                  type: "integer"
                },
                ShadowYOffset: {
                  locationName: "shadowYOffset",
                  type: "integer"
                },
                StylePassthrough: {
                  locationName: "stylePassthrough"
                },
                TeletextSpacing: {
                  locationName: "teletextSpacing"
                },
                XPosition: {
                  locationName: "xPosition",
                  type: "integer"
                },
                YPosition: {
                  locationName: "yPosition",
                  type: "integer"
                }
              }
            },
            DestinationType: {
              locationName: "destinationType"
            },
            DvbSubDestinationSettings: {
              locationName: "dvbSubDestinationSettings",
              type: "structure",
              members: {
                Alignment: {
                  locationName: "alignment"
                },
                ApplyFontColor: {
                  locationName: "applyFontColor"
                },
                BackgroundColor: {
                  locationName: "backgroundColor"
                },
                BackgroundOpacity: {
                  locationName: "backgroundOpacity",
                  type: "integer"
                },
                DdsHandling: {
                  locationName: "ddsHandling"
                },
                DdsXCoordinate: {
                  locationName: "ddsXCoordinate",
                  type: "integer"
                },
                DdsYCoordinate: {
                  locationName: "ddsYCoordinate",
                  type: "integer"
                },
                FallbackFont: {
                  locationName: "fallbackFont"
                },
                FontColor: {
                  locationName: "fontColor"
                },
                FontOpacity: {
                  locationName: "fontOpacity",
                  type: "integer"
                },
                FontResolution: {
                  locationName: "fontResolution",
                  type: "integer"
                },
                FontScript: {
                  locationName: "fontScript"
                },
                FontSize: {
                  locationName: "fontSize",
                  type: "integer"
                },
                Height: {
                  locationName: "height",
                  type: "integer"
                },
                HexFontColor: {
                  locationName: "hexFontColor"
                },
                OutlineColor: {
                  locationName: "outlineColor"
                },
                OutlineSize: {
                  locationName: "outlineSize",
                  type: "integer"
                },
                ShadowColor: {
                  locationName: "shadowColor"
                },
                ShadowOpacity: {
                  locationName: "shadowOpacity",
                  type: "integer"
                },
                ShadowXOffset: {
                  locationName: "shadowXOffset",
                  type: "integer"
                },
                ShadowYOffset: {
                  locationName: "shadowYOffset",
                  type: "integer"
                },
                StylePassthrough: {
                  locationName: "stylePassthrough"
                },
                SubtitlingType: {
                  locationName: "subtitlingType"
                },
                TeletextSpacing: {
                  locationName: "teletextSpacing"
                },
                Width: {
                  locationName: "width",
                  type: "integer"
                },
                XPosition: {
                  locationName: "xPosition",
                  type: "integer"
                },
                YPosition: {
                  locationName: "yPosition",
                  type: "integer"
                }
              }
            },
            EmbeddedDestinationSettings: {
              locationName: "embeddedDestinationSettings",
              type: "structure",
              members: {
                Destination608ChannelNumber: {
                  locationName: "destination608ChannelNumber",
                  type: "integer"
                },
                Destination708ServiceNumber: {
                  locationName: "destination708ServiceNumber",
                  type: "integer"
                }
              }
            },
            ImscDestinationSettings: {
              locationName: "imscDestinationSettings",
              type: "structure",
              members: {
                StylePassthrough: {
                  locationName: "stylePassthrough"
                }
              }
            },
            SccDestinationSettings: {
              locationName: "sccDestinationSettings",
              type: "structure",
              members: {
                Framerate: {
                  locationName: "framerate"
                }
              }
            },
            SrtDestinationSettings: {
              locationName: "srtDestinationSettings",
              type: "structure",
              members: {
                StylePassthrough: {
                  locationName: "stylePassthrough"
                }
              }
            },
            TeletextDestinationSettings: {
              locationName: "teletextDestinationSettings",
              type: "structure",
              members: {
                PageNumber: {
                  locationName: "pageNumber"
                },
                PageTypes: {
                  locationName: "pageTypes",
                  type: "list",
                  member: {}
                }
              }
            },
            TtmlDestinationSettings: {
              locationName: "ttmlDestinationSettings",
              type: "structure",
              members: {
                StylePassthrough: {
                  locationName: "stylePassthrough"
                }
              }
            },
            WebvttDestinationSettings: {
              locationName: "webvttDestinationSettings",
              type: "structure",
              members: {
                StylePassthrough: {
                  locationName: "stylePassthrough"
                }
              }
            }
          }
        },
        Sar: {
          type: "structure",
          members: {
            CmfcSettings: {
              locationName: "cmfcSettings",
              type: "structure",
              members: {
                AudioDuration: {
                  locationName: "audioDuration"
                },
                AudioGroupId: {
                  locationName: "audioGroupId"
                },
                AudioRenditionSets: {
                  locationName: "audioRenditionSets"
                },
                AudioTrackType: {
                  locationName: "audioTrackType"
                },
                DescriptiveVideoServiceFlag: {
                  locationName: "descriptiveVideoServiceFlag"
                },
                IFrameOnlyManifest: {
                  locationName: "iFrameOnlyManifest"
                },
                Scte35Esam: {
                  locationName: "scte35Esam"
                },
                Scte35Source: {
                  locationName: "scte35Source"
                }
              }
            },
            Container: {
              locationName: "container"
            },
            F4vSettings: {
              locationName: "f4vSettings",
              type: "structure",
              members: {
                MoovPlacement: {
                  locationName: "moovPlacement"
                }
              }
            },
            M2tsSettings: {
              locationName: "m2tsSettings",
              type: "structure",
              members: {
                AudioBufferModel: {
                  locationName: "audioBufferModel"
                },
                AudioDuration: {
                  locationName: "audioDuration"
                },
                AudioFramesPerPes: {
                  locationName: "audioFramesPerPes",
                  type: "integer"
                },
                AudioPids: {
                  shape: "Sb5",
                  locationName: "audioPids"
                },
                Bitrate: {
                  locationName: "bitrate",
                  type: "integer"
                },
                BufferModel: {
                  locationName: "bufferModel"
                },
                DataPTSControl: {
                  locationName: "dataPTSControl"
                },
                DvbNitSettings: {
                  locationName: "dvbNitSettings",
                  type: "structure",
                  members: {
                    NetworkId: {
                      locationName: "networkId",
                      type: "integer"
                    },
                    NetworkName: {
                      locationName: "networkName"
                    },
                    NitInterval: {
                      locationName: "nitInterval",
                      type: "integer"
                    }
                  }
                },
                DvbSdtSettings: {
                  locationName: "dvbSdtSettings",
                  type: "structure",
                  members: {
                    OutputSdt: {
                      locationName: "outputSdt"
                    },
                    SdtInterval: {
                      locationName: "sdtInterval",
                      type: "integer"
                    },
                    ServiceName: {
                      locationName: "serviceName"
                    },
                    ServiceProviderName: {
                      locationName: "serviceProviderName"
                    }
                  }
                },
                DvbSubPids: {
                  shape: "Sb5",
                  locationName: "dvbSubPids"
                },
                DvbTdtSettings: {
                  locationName: "dvbTdtSettings",
                  type: "structure",
                  members: {
                    TdtInterval: {
                      locationName: "tdtInterval",
                      type: "integer"
                    }
                  }
                },
                DvbTeletextPid: {
                  locationName: "dvbTeletextPid",
                  type: "integer"
                },
                EbpAudioInterval: {
                  locationName: "ebpAudioInterval"
                },
                EbpPlacement: {
                  locationName: "ebpPlacement"
                },
                EsRateInPes: {
                  locationName: "esRateInPes"
                },
                ForceTsVideoEbpOrder: {
                  locationName: "forceTsVideoEbpOrder"
                },
                FragmentTime: {
                  locationName: "fragmentTime",
                  type: "double"
                },
                MaxPcrInterval: {
                  locationName: "maxPcrInterval",
                  type: "integer"
                },
                MinEbpInterval: {
                  locationName: "minEbpInterval",
                  type: "integer"
                },
                NielsenId3: {
                  locationName: "nielsenId3"
                },
                NullPacketBitrate: {
                  locationName: "nullPacketBitrate",
                  type: "double"
                },
                PatInterval: {
                  locationName: "patInterval",
                  type: "integer"
                },
                PcrControl: {
                  locationName: "pcrControl"
                },
                PcrPid: {
                  locationName: "pcrPid",
                  type: "integer"
                },
                PmtInterval: {
                  locationName: "pmtInterval",
                  type: "integer"
                },
                PmtPid: {
                  locationName: "pmtPid",
                  type: "integer"
                },
                PrivateMetadataPid: {
                  locationName: "privateMetadataPid",
                  type: "integer"
                },
                ProgramNumber: {
                  locationName: "programNumber",
                  type: "integer"
                },
                RateMode: {
                  locationName: "rateMode"
                },
                Scte35Esam: {
                  locationName: "scte35Esam",
                  type: "structure",
                  members: {
                    Scte35EsamPid: {
                      locationName: "scte35EsamPid",
                      type: "integer"
                    }
                  }
                },
                Scte35Pid: {
                  locationName: "scte35Pid",
                  type: "integer"
                },
                Scte35Source: {
                  locationName: "scte35Source"
                },
                SegmentationMarkers: {
                  locationName: "segmentationMarkers"
                },
                SegmentationStyle: {
                  locationName: "segmentationStyle"
                },
                SegmentationTime: {
                  locationName: "segmentationTime",
                  type: "double"
                },
                TimedMetadataPid: {
                  locationName: "timedMetadataPid",
                  type: "integer"
                },
                TransportStreamId: {
                  locationName: "transportStreamId",
                  type: "integer"
                },
                VideoPid: {
                  locationName: "videoPid",
                  type: "integer"
                }
              }
            },
            M3u8Settings: {
              locationName: "m3u8Settings",
              type: "structure",
              members: {
                AudioDuration: {
                  locationName: "audioDuration"
                },
                AudioFramesPerPes: {
                  locationName: "audioFramesPerPes",
                  type: "integer"
                },
                AudioPids: {
                  shape: "Sb5",
                  locationName: "audioPids"
                },
                DataPTSControl: {
                  locationName: "dataPTSControl"
                },
                MaxPcrInterval: {
                  locationName: "maxPcrInterval",
                  type: "integer"
                },
                NielsenId3: {
                  locationName: "nielsenId3"
                },
                PatInterval: {
                  locationName: "patInterval",
                  type: "integer"
                },
                PcrControl: {
                  locationName: "pcrControl"
                },
                PcrPid: {
                  locationName: "pcrPid",
                  type: "integer"
                },
                PmtInterval: {
                  locationName: "pmtInterval",
                  type: "integer"
                },
                PmtPid: {
                  locationName: "pmtPid",
                  type: "integer"
                },
                PrivateMetadataPid: {
                  locationName: "privateMetadataPid",
                  type: "integer"
                },
                ProgramNumber: {
                  locationName: "programNumber",
                  type: "integer"
                },
                Scte35Pid: {
                  locationName: "scte35Pid",
                  type: "integer"
                },
                Scte35Source: {
                  locationName: "scte35Source"
                },
                TimedMetadata: {
                  locationName: "timedMetadata"
                },
                TimedMetadataPid: {
                  locationName: "timedMetadataPid",
                  type: "integer"
                },
                TransportStreamId: {
                  locationName: "transportStreamId",
                  type: "integer"
                },
                VideoPid: {
                  locationName: "videoPid",
                  type: "integer"
                }
              }
            },
            MovSettings: {
              locationName: "movSettings",
              type: "structure",
              members: {
                ClapAtom: {
                  locationName: "clapAtom"
                },
                CslgAtom: {
                  locationName: "cslgAtom"
                },
                Mpeg2FourCCControl: {
                  locationName: "mpeg2FourCCControl"
                },
                PaddingControl: {
                  locationName: "paddingControl"
                },
                Reference: {
                  locationName: "reference"
                }
              }
            },
            Mp4Settings: {
              locationName: "mp4Settings",
              type: "structure",
              members: {
                AudioDuration: {
                  locationName: "audioDuration"
                },
                CslgAtom: {
                  locationName: "cslgAtom"
                },
                CttsVersion: {
                  locationName: "cttsVersion",
                  type: "integer"
                },
                FreeSpaceBox: {
                  locationName: "freeSpaceBox"
                },
                MoovPlacement: {
                  locationName: "moovPlacement"
                },
                Mp4MajorBrand: {
                  locationName: "mp4MajorBrand"
                }
              }
            },
            MpdSettings: {
              locationName: "mpdSettings",
              type: "structure",
              members: {
                AccessibilityCaptionHints: {
                  locationName: "accessibilityCaptionHints"
                },
                AudioDuration: {
                  locationName: "audioDuration"
                },
                CaptionContainerType: {
                  locationName: "captionContainerType"
                },
                Scte35Esam: {
                  locationName: "scte35Esam"
                },
                Scte35Source: {
                  locationName: "scte35Source"
                }
              }
            },
            MxfSettings: {
              locationName: "mxfSettings",
              type: "structure",
              members: {
                AfdSignaling: {
                  locationName: "afdSignaling"
                },
                Profile: {
                  locationName: "profile"
                },
                XavcProfileSettings: {
                  locationName: "xavcProfileSettings",
                  type: "structure",
                  members: {
                    DurationMode: {
                      locationName: "durationMode"
                    },
                    MaxAncDataSize: {
                      locationName: "maxAncDataSize",
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        Sb5: {
          type: "list",
          member: {
            type: "integer"
          }
        },
        Scv: {
          type: "structure",
          members: {
            AfdSignaling: {
              locationName: "afdSignaling"
            },
            AntiAlias: {
              locationName: "antiAlias"
            },
            CodecSettings: {
              locationName: "codecSettings",
              type: "structure",
              members: {
                Av1Settings: {
                  locationName: "av1Settings",
                  type: "structure",
                  members: {
                    AdaptiveQuantization: {
                      locationName: "adaptiveQuantization"
                    },
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    GopSize: {
                      locationName: "gopSize",
                      type: "double"
                    },
                    MaxBitrate: {
                      locationName: "maxBitrate",
                      type: "integer"
                    },
                    NumberBFramesBetweenReferenceFrames: {
                      locationName: "numberBFramesBetweenReferenceFrames",
                      type: "integer"
                    },
                    QvbrSettings: {
                      locationName: "qvbrSettings",
                      type: "structure",
                      members: {
                        QvbrQualityLevel: {
                          locationName: "qvbrQualityLevel",
                          type: "integer"
                        },
                        QvbrQualityLevelFineTune: {
                          locationName: "qvbrQualityLevelFineTune",
                          type: "double"
                        }
                      }
                    },
                    RateControlMode: {
                      locationName: "rateControlMode"
                    },
                    Slices: {
                      locationName: "slices",
                      type: "integer"
                    },
                    SpatialAdaptiveQuantization: {
                      locationName: "spatialAdaptiveQuantization"
                    }
                  }
                },
                AvcIntraSettings: {
                  locationName: "avcIntraSettings",
                  type: "structure",
                  members: {
                    AvcIntraClass: {
                      locationName: "avcIntraClass"
                    },
                    AvcIntraUhdSettings: {
                      locationName: "avcIntraUhdSettings",
                      type: "structure",
                      members: {
                        QualityTuningLevel: {
                          locationName: "qualityTuningLevel"
                        }
                      }
                    },
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    InterlaceMode: {
                      locationName: "interlaceMode"
                    },
                    ScanTypeConversionMode: {
                      locationName: "scanTypeConversionMode"
                    },
                    SlowPal: {
                      locationName: "slowPal"
                    },
                    Telecine: {
                      locationName: "telecine"
                    }
                  }
                },
                Codec: {
                  locationName: "codec"
                },
                FrameCaptureSettings: {
                  locationName: "frameCaptureSettings",
                  type: "structure",
                  members: {
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    MaxCaptures: {
                      locationName: "maxCaptures",
                      type: "integer"
                    },
                    Quality: {
                      locationName: "quality",
                      type: "integer"
                    }
                  }
                },
                H264Settings: {
                  locationName: "h264Settings",
                  type: "structure",
                  members: {
                    AdaptiveQuantization: {
                      locationName: "adaptiveQuantization"
                    },
                    Bitrate: {
                      locationName: "bitrate",
                      type: "integer"
                    },
                    CodecLevel: {
                      locationName: "codecLevel"
                    },
                    CodecProfile: {
                      locationName: "codecProfile"
                    },
                    DynamicSubGop: {
                      locationName: "dynamicSubGop"
                    },
                    EntropyEncoding: {
                      locationName: "entropyEncoding"
                    },
                    FieldEncoding: {
                      locationName: "fieldEncoding"
                    },
                    FlickerAdaptiveQuantization: {
                      locationName: "flickerAdaptiveQuantization"
                    },
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    GopBReference: {
                      locationName: "gopBReference"
                    },
                    GopClosedCadence: {
                      locationName: "gopClosedCadence",
                      type: "integer"
                    },
                    GopSize: {
                      locationName: "gopSize",
                      type: "double"
                    },
                    GopSizeUnits: {
                      locationName: "gopSizeUnits"
                    },
                    HrdBufferInitialFillPercentage: {
                      locationName: "hrdBufferInitialFillPercentage",
                      type: "integer"
                    },
                    HrdBufferSize: {
                      locationName: "hrdBufferSize",
                      type: "integer"
                    },
                    InterlaceMode: {
                      locationName: "interlaceMode"
                    },
                    MaxBitrate: {
                      locationName: "maxBitrate",
                      type: "integer"
                    },
                    MinIInterval: {
                      locationName: "minIInterval",
                      type: "integer"
                    },
                    NumberBFramesBetweenReferenceFrames: {
                      locationName: "numberBFramesBetweenReferenceFrames",
                      type: "integer"
                    },
                    NumberReferenceFrames: {
                      locationName: "numberReferenceFrames",
                      type: "integer"
                    },
                    ParControl: {
                      locationName: "parControl"
                    },
                    ParDenominator: {
                      locationName: "parDenominator",
                      type: "integer"
                    },
                    ParNumerator: {
                      locationName: "parNumerator",
                      type: "integer"
                    },
                    QualityTuningLevel: {
                      locationName: "qualityTuningLevel"
                    },
                    QvbrSettings: {
                      locationName: "qvbrSettings",
                      type: "structure",
                      members: {
                        MaxAverageBitrate: {
                          locationName: "maxAverageBitrate",
                          type: "integer"
                        },
                        QvbrQualityLevel: {
                          locationName: "qvbrQualityLevel",
                          type: "integer"
                        },
                        QvbrQualityLevelFineTune: {
                          locationName: "qvbrQualityLevelFineTune",
                          type: "double"
                        }
                      }
                    },
                    RateControlMode: {
                      locationName: "rateControlMode"
                    },
                    RepeatPps: {
                      locationName: "repeatPps"
                    },
                    ScanTypeConversionMode: {
                      locationName: "scanTypeConversionMode"
                    },
                    SceneChangeDetect: {
                      locationName: "sceneChangeDetect"
                    },
                    Slices: {
                      locationName: "slices",
                      type: "integer"
                    },
                    SlowPal: {
                      locationName: "slowPal"
                    },
                    Softness: {
                      locationName: "softness",
                      type: "integer"
                    },
                    SpatialAdaptiveQuantization: {
                      locationName: "spatialAdaptiveQuantization"
                    },
                    Syntax: {
                      locationName: "syntax"
                    },
                    Telecine: {
                      locationName: "telecine"
                    },
                    TemporalAdaptiveQuantization: {
                      locationName: "temporalAdaptiveQuantization"
                    },
                    UnregisteredSeiTimecode: {
                      locationName: "unregisteredSeiTimecode"
                    }
                  }
                },
                H265Settings: {
                  locationName: "h265Settings",
                  type: "structure",
                  members: {
                    AdaptiveQuantization: {
                      locationName: "adaptiveQuantization"
                    },
                    AlternateTransferFunctionSei: {
                      locationName: "alternateTransferFunctionSei"
                    },
                    Bitrate: {
                      locationName: "bitrate",
                      type: "integer"
                    },
                    CodecLevel: {
                      locationName: "codecLevel"
                    },
                    CodecProfile: {
                      locationName: "codecProfile"
                    },
                    DynamicSubGop: {
                      locationName: "dynamicSubGop"
                    },
                    FlickerAdaptiveQuantization: {
                      locationName: "flickerAdaptiveQuantization"
                    },
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    GopBReference: {
                      locationName: "gopBReference"
                    },
                    GopClosedCadence: {
                      locationName: "gopClosedCadence",
                      type: "integer"
                    },
                    GopSize: {
                      locationName: "gopSize",
                      type: "double"
                    },
                    GopSizeUnits: {
                      locationName: "gopSizeUnits"
                    },
                    HrdBufferInitialFillPercentage: {
                      locationName: "hrdBufferInitialFillPercentage",
                      type: "integer"
                    },
                    HrdBufferSize: {
                      locationName: "hrdBufferSize",
                      type: "integer"
                    },
                    InterlaceMode: {
                      locationName: "interlaceMode"
                    },
                    MaxBitrate: {
                      locationName: "maxBitrate",
                      type: "integer"
                    },
                    MinIInterval: {
                      locationName: "minIInterval",
                      type: "integer"
                    },
                    NumberBFramesBetweenReferenceFrames: {
                      locationName: "numberBFramesBetweenReferenceFrames",
                      type: "integer"
                    },
                    NumberReferenceFrames: {
                      locationName: "numberReferenceFrames",
                      type: "integer"
                    },
                    ParControl: {
                      locationName: "parControl"
                    },
                    ParDenominator: {
                      locationName: "parDenominator",
                      type: "integer"
                    },
                    ParNumerator: {
                      locationName: "parNumerator",
                      type: "integer"
                    },
                    QualityTuningLevel: {
                      locationName: "qualityTuningLevel"
                    },
                    QvbrSettings: {
                      locationName: "qvbrSettings",
                      type: "structure",
                      members: {
                        MaxAverageBitrate: {
                          locationName: "maxAverageBitrate",
                          type: "integer"
                        },
                        QvbrQualityLevel: {
                          locationName: "qvbrQualityLevel",
                          type: "integer"
                        },
                        QvbrQualityLevelFineTune: {
                          locationName: "qvbrQualityLevelFineTune",
                          type: "double"
                        }
                      }
                    },
                    RateControlMode: {
                      locationName: "rateControlMode"
                    },
                    SampleAdaptiveOffsetFilterMode: {
                      locationName: "sampleAdaptiveOffsetFilterMode"
                    },
                    ScanTypeConversionMode: {
                      locationName: "scanTypeConversionMode"
                    },
                    SceneChangeDetect: {
                      locationName: "sceneChangeDetect"
                    },
                    Slices: {
                      locationName: "slices",
                      type: "integer"
                    },
                    SlowPal: {
                      locationName: "slowPal"
                    },
                    SpatialAdaptiveQuantization: {
                      locationName: "spatialAdaptiveQuantization"
                    },
                    Telecine: {
                      locationName: "telecine"
                    },
                    TemporalAdaptiveQuantization: {
                      locationName: "temporalAdaptiveQuantization"
                    },
                    TemporalIds: {
                      locationName: "temporalIds"
                    },
                    Tiles: {
                      locationName: "tiles"
                    },
                    UnregisteredSeiTimecode: {
                      locationName: "unregisteredSeiTimecode"
                    },
                    WriteMp4PackagingType: {
                      locationName: "writeMp4PackagingType"
                    }
                  }
                },
                Mpeg2Settings: {
                  locationName: "mpeg2Settings",
                  type: "structure",
                  members: {
                    AdaptiveQuantization: {
                      locationName: "adaptiveQuantization"
                    },
                    Bitrate: {
                      locationName: "bitrate",
                      type: "integer"
                    },
                    CodecLevel: {
                      locationName: "codecLevel"
                    },
                    CodecProfile: {
                      locationName: "codecProfile"
                    },
                    DynamicSubGop: {
                      locationName: "dynamicSubGop"
                    },
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    GopClosedCadence: {
                      locationName: "gopClosedCadence",
                      type: "integer"
                    },
                    GopSize: {
                      locationName: "gopSize",
                      type: "double"
                    },
                    GopSizeUnits: {
                      locationName: "gopSizeUnits"
                    },
                    HrdBufferInitialFillPercentage: {
                      locationName: "hrdBufferInitialFillPercentage",
                      type: "integer"
                    },
                    HrdBufferSize: {
                      locationName: "hrdBufferSize",
                      type: "integer"
                    },
                    InterlaceMode: {
                      locationName: "interlaceMode"
                    },
                    IntraDcPrecision: {
                      locationName: "intraDcPrecision"
                    },
                    MaxBitrate: {
                      locationName: "maxBitrate",
                      type: "integer"
                    },
                    MinIInterval: {
                      locationName: "minIInterval",
                      type: "integer"
                    },
                    NumberBFramesBetweenReferenceFrames: {
                      locationName: "numberBFramesBetweenReferenceFrames",
                      type: "integer"
                    },
                    ParControl: {
                      locationName: "parControl"
                    },
                    ParDenominator: {
                      locationName: "parDenominator",
                      type: "integer"
                    },
                    ParNumerator: {
                      locationName: "parNumerator",
                      type: "integer"
                    },
                    QualityTuningLevel: {
                      locationName: "qualityTuningLevel"
                    },
                    RateControlMode: {
                      locationName: "rateControlMode"
                    },
                    ScanTypeConversionMode: {
                      locationName: "scanTypeConversionMode"
                    },
                    SceneChangeDetect: {
                      locationName: "sceneChangeDetect"
                    },
                    SlowPal: {
                      locationName: "slowPal"
                    },
                    Softness: {
                      locationName: "softness",
                      type: "integer"
                    },
                    SpatialAdaptiveQuantization: {
                      locationName: "spatialAdaptiveQuantization"
                    },
                    Syntax: {
                      locationName: "syntax"
                    },
                    Telecine: {
                      locationName: "telecine"
                    },
                    TemporalAdaptiveQuantization: {
                      locationName: "temporalAdaptiveQuantization"
                    }
                  }
                },
                ProresSettings: {
                  locationName: "proresSettings",
                  type: "structure",
                  members: {
                    ChromaSampling: {
                      locationName: "chromaSampling"
                    },
                    CodecProfile: {
                      locationName: "codecProfile"
                    },
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    InterlaceMode: {
                      locationName: "interlaceMode"
                    },
                    ParControl: {
                      locationName: "parControl"
                    },
                    ParDenominator: {
                      locationName: "parDenominator",
                      type: "integer"
                    },
                    ParNumerator: {
                      locationName: "parNumerator",
                      type: "integer"
                    },
                    ScanTypeConversionMode: {
                      locationName: "scanTypeConversionMode"
                    },
                    SlowPal: {
                      locationName: "slowPal"
                    },
                    Telecine: {
                      locationName: "telecine"
                    }
                  }
                },
                Vc3Settings: {
                  locationName: "vc3Settings",
                  type: "structure",
                  members: {
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    InterlaceMode: {
                      locationName: "interlaceMode"
                    },
                    ScanTypeConversionMode: {
                      locationName: "scanTypeConversionMode"
                    },
                    SlowPal: {
                      locationName: "slowPal"
                    },
                    Telecine: {
                      locationName: "telecine"
                    },
                    Vc3Class: {
                      locationName: "vc3Class"
                    }
                  }
                },
                Vp8Settings: {
                  locationName: "vp8Settings",
                  type: "structure",
                  members: {
                    Bitrate: {
                      locationName: "bitrate",
                      type: "integer"
                    },
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    GopSize: {
                      locationName: "gopSize",
                      type: "double"
                    },
                    HrdBufferSize: {
                      locationName: "hrdBufferSize",
                      type: "integer"
                    },
                    MaxBitrate: {
                      locationName: "maxBitrate",
                      type: "integer"
                    },
                    ParControl: {
                      locationName: "parControl"
                    },
                    ParDenominator: {
                      locationName: "parDenominator",
                      type: "integer"
                    },
                    ParNumerator: {
                      locationName: "parNumerator",
                      type: "integer"
                    },
                    QualityTuningLevel: {
                      locationName: "qualityTuningLevel"
                    },
                    RateControlMode: {
                      locationName: "rateControlMode"
                    }
                  }
                },
                Vp9Settings: {
                  locationName: "vp9Settings",
                  type: "structure",
                  members: {
                    Bitrate: {
                      locationName: "bitrate",
                      type: "integer"
                    },
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    GopSize: {
                      locationName: "gopSize",
                      type: "double"
                    },
                    HrdBufferSize: {
                      locationName: "hrdBufferSize",
                      type: "integer"
                    },
                    MaxBitrate: {
                      locationName: "maxBitrate",
                      type: "integer"
                    },
                    ParControl: {
                      locationName: "parControl"
                    },
                    ParDenominator: {
                      locationName: "parDenominator",
                      type: "integer"
                    },
                    ParNumerator: {
                      locationName: "parNumerator",
                      type: "integer"
                    },
                    QualityTuningLevel: {
                      locationName: "qualityTuningLevel"
                    },
                    RateControlMode: {
                      locationName: "rateControlMode"
                    }
                  }
                },
                XavcSettings: {
                  locationName: "xavcSettings",
                  type: "structure",
                  members: {
                    AdaptiveQuantization: {
                      locationName: "adaptiveQuantization"
                    },
                    EntropyEncoding: {
                      locationName: "entropyEncoding"
                    },
                    FramerateControl: {
                      locationName: "framerateControl"
                    },
                    FramerateConversionAlgorithm: {
                      locationName: "framerateConversionAlgorithm"
                    },
                    FramerateDenominator: {
                      locationName: "framerateDenominator",
                      type: "integer"
                    },
                    FramerateNumerator: {
                      locationName: "framerateNumerator",
                      type: "integer"
                    },
                    Profile: {
                      locationName: "profile"
                    },
                    SlowPal: {
                      locationName: "slowPal"
                    },
                    Softness: {
                      locationName: "softness",
                      type: "integer"
                    },
                    SpatialAdaptiveQuantization: {
                      locationName: "spatialAdaptiveQuantization"
                    },
                    TemporalAdaptiveQuantization: {
                      locationName: "temporalAdaptiveQuantization"
                    },
                    Xavc4kIntraCbgProfileSettings: {
                      locationName: "xavc4kIntraCbgProfileSettings",
                      type: "structure",
                      members: {
                        XavcClass: {
                          locationName: "xavcClass"
                        }
                      }
                    },
                    Xavc4kIntraVbrProfileSettings: {
                      locationName: "xavc4kIntraVbrProfileSettings",
                      type: "structure",
                      members: {
                        XavcClass: {
                          locationName: "xavcClass"
                        }
                      }
                    },
                    Xavc4kProfileSettings: {
                      locationName: "xavc4kProfileSettings",
                      type: "structure",
                      members: {
                        BitrateClass: {
                          locationName: "bitrateClass"
                        },
                        CodecProfile: {
                          locationName: "codecProfile"
                        },
                        FlickerAdaptiveQuantization: {
                          locationName: "flickerAdaptiveQuantization"
                        },
                        GopBReference: {
                          locationName: "gopBReference"
                        },
                        GopClosedCadence: {
                          locationName: "gopClosedCadence",
                          type: "integer"
                        },
                        HrdBufferSize: {
                          locationName: "hrdBufferSize",
                          type: "integer"
                        },
                        QualityTuningLevel: {
                          locationName: "qualityTuningLevel"
                        },
                        Slices: {
                          locationName: "slices",
                          type: "integer"
                        }
                      }
                    },
                    XavcHdIntraCbgProfileSettings: {
                      locationName: "xavcHdIntraCbgProfileSettings",
                      type: "structure",
                      members: {
                        XavcClass: {
                          locationName: "xavcClass"
                        }
                      }
                    },
                    XavcHdProfileSettings: {
                      locationName: "xavcHdProfileSettings",
                      type: "structure",
                      members: {
                        BitrateClass: {
                          locationName: "bitrateClass"
                        },
                        FlickerAdaptiveQuantization: {
                          locationName: "flickerAdaptiveQuantization"
                        },
                        GopBReference: {
                          locationName: "gopBReference"
                        },
                        GopClosedCadence: {
                          locationName: "gopClosedCadence",
                          type: "integer"
                        },
                        HrdBufferSize: {
                          locationName: "hrdBufferSize",
                          type: "integer"
                        },
                        InterlaceMode: {
                          locationName: "interlaceMode"
                        },
                        QualityTuningLevel: {
                          locationName: "qualityTuningLevel"
                        },
                        Slices: {
                          locationName: "slices",
                          type: "integer"
                        },
                        Telecine: {
                          locationName: "telecine"
                        }
                      }
                    }
                  }
                }
              }
            },
            ColorMetadata: {
              locationName: "colorMetadata"
            },
            Crop: {
              shape: "S25",
              locationName: "crop"
            },
            DropFrameTimecode: {
              locationName: "dropFrameTimecode"
            },
            FixedAfd: {
              locationName: "fixedAfd",
              type: "integer"
            },
            Height: {
              locationName: "height",
              type: "integer"
            },
            Position: {
              shape: "S25",
              locationName: "position"
            },
            RespondToAfd: {
              locationName: "respondToAfd"
            },
            ScalingBehavior: {
              locationName: "scalingBehavior"
            },
            Sharpness: {
              locationName: "sharpness",
              type: "integer"
            },
            TimecodeInsertion: {
              locationName: "timecodeInsertion"
            },
            VideoPreprocessors: {
              locationName: "videoPreprocessors",
              type: "structure",
              members: {
                ColorCorrector: {
                  locationName: "colorCorrector",
                  type: "structure",
                  members: {
                    Brightness: {
                      locationName: "brightness",
                      type: "integer"
                    },
                    ColorSpaceConversion: {
                      locationName: "colorSpaceConversion"
                    },
                    Contrast: {
                      locationName: "contrast",
                      type: "integer"
                    },
                    Hdr10Metadata: {
                      shape: "S32",
                      locationName: "hdr10Metadata"
                    },
                    Hue: {
                      locationName: "hue",
                      type: "integer"
                    },
                    SampleRangeConversion: {
                      locationName: "sampleRangeConversion"
                    },
                    Saturation: {
                      locationName: "saturation",
                      type: "integer"
                    }
                  }
                },
                Deinterlacer: {
                  locationName: "deinterlacer",
                  type: "structure",
                  members: {
                    Algorithm: {
                      locationName: "algorithm"
                    },
                    Control: {
                      locationName: "control"
                    },
                    Mode: {
                      locationName: "mode"
                    }
                  }
                },
                DolbyVision: {
                  locationName: "dolbyVision",
                  type: "structure",
                  members: {
                    L6Metadata: {
                      locationName: "l6Metadata",
                      type: "structure",
                      members: {
                        MaxCll: {
                          locationName: "maxCll",
                          type: "integer"
                        },
                        MaxFall: {
                          locationName: "maxFall",
                          type: "integer"
                        }
                      }
                    },
                    L6Mode: {
                      locationName: "l6Mode"
                    },
                    Profile: {
                      locationName: "profile"
                    }
                  }
                },
                Hdr10Plus: {
                  locationName: "hdr10Plus",
                  type: "structure",
                  members: {
                    MasteringMonitorNits: {
                      locationName: "masteringMonitorNits",
                      type: "integer"
                    },
                    TargetMonitorNits: {
                      locationName: "targetMonitorNits",
                      type: "integer"
                    }
                  }
                },
                ImageInserter: {
                  shape: "S2i",
                  locationName: "imageInserter"
                },
                NoiseReducer: {
                  locationName: "noiseReducer",
                  type: "structure",
                  members: {
                    Filter: {
                      locationName: "filter"
                    },
                    FilterSettings: {
                      locationName: "filterSettings",
                      type: "structure",
                      members: {
                        Strength: {
                          locationName: "strength",
                          type: "integer"
                        }
                      }
                    },
                    SpatialFilterSettings: {
                      locationName: "spatialFilterSettings",
                      type: "structure",
                      members: {
                        PostFilterSharpenStrength: {
                          locationName: "postFilterSharpenStrength",
                          type: "integer"
                        },
                        Speed: {
                          locationName: "speed",
                          type: "integer"
                        },
                        Strength: {
                          locationName: "strength",
                          type: "integer"
                        }
                      }
                    },
                    TemporalFilterSettings: {
                      locationName: "temporalFilterSettings",
                      type: "structure",
                      members: {
                        AggressiveMode: {
                          locationName: "aggressiveMode",
                          type: "integer"
                        },
                        PostTemporalSharpening: {
                          locationName: "postTemporalSharpening"
                        },
                        Speed: {
                          locationName: "speed",
                          type: "integer"
                        },
                        Strength: {
                          locationName: "strength",
                          type: "integer"
                        }
                      }
                    }
                  }
                },
                PartnerWatermarking: {
                  locationName: "partnerWatermarking",
                  type: "structure",
                  members: {
                    NexguardFileMarkerSettings: {
                      locationName: "nexguardFileMarkerSettings",
                      type: "structure",
                      members: {
                        License: {
                          locationName: "license"
                        },
                        Payload: {
                          locationName: "payload",
                          type: "integer"
                        },
                        Preset: {
                          locationName: "preset"
                        },
                        Strength: {
                          locationName: "strength"
                        }
                      }
                    }
                  }
                },
                TimecodeBurnin: {
                  locationName: "timecodeBurnin",
                  type: "structure",
                  members: {
                    FontSize: {
                      locationName: "fontSize",
                      type: "integer"
                    },
                    Position: {
                      locationName: "position"
                    },
                    Prefix: {
                      locationName: "prefix"
                    }
                  }
                }
              }
            },
            Width: {
              locationName: "width",
              type: "integer"
            }
          }
        },
        Sis: {
          type: "structure",
          members: {
            Anchor: {
              locationName: "anchor"
            },
            Source: {
              locationName: "source"
            },
            Start: {
              locationName: "start"
            },
            TimestampOffset: {
              locationName: "timestampOffset"
            }
          }
        },
        Siv: {
          type: "structure",
          members: {
            Id3Insertions: {
              locationName: "id3Insertions",
              type: "list",
              member: {
                type: "structure",
                members: {
                  Id3: {
                    locationName: "id3"
                  },
                  Timecode: {
                    locationName: "timecode"
                  }
                }
              }
            }
          }
        },
        Sj0: {
          type: "map",
          key: {},
          value: {}
        },
        Sj2: {
          type: "structure",
          members: {
            AccelerationSettings: {
              shape: "S7",
              locationName: "accelerationSettings"
            },
            AccelerationStatus: {
              locationName: "accelerationStatus"
            },
            Arn: {
              locationName: "arn"
            },
            BillingTagsSource: {
              locationName: "billingTagsSource"
            },
            CreatedAt: {
              shape: "Sj4",
              locationName: "createdAt"
            },
            CurrentPhase: {
              locationName: "currentPhase"
            },
            ErrorCode: {
              locationName: "errorCode",
              type: "integer"
            },
            ErrorMessage: {
              locationName: "errorMessage"
            },
            HopDestinations: {
              shape: "Sa",
              locationName: "hopDestinations"
            },
            Id: {
              locationName: "id"
            },
            JobPercentComplete: {
              locationName: "jobPercentComplete",
              type: "integer"
            },
            JobTemplate: {
              locationName: "jobTemplate"
            },
            Messages: {
              locationName: "messages",
              type: "structure",
              members: {
                Info: {
                  shape: "Sj7",
                  locationName: "info"
                },
                Warning: {
                  shape: "Sj7",
                  locationName: "warning"
                }
              }
            },
            OutputGroupDetails: {
              locationName: "outputGroupDetails",
              type: "list",
              member: {
                type: "structure",
                members: {
                  OutputDetails: {
                    locationName: "outputDetails",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        DurationInMs: {
                          locationName: "durationInMs",
                          type: "integer"
                        },
                        VideoDetails: {
                          locationName: "videoDetails",
                          type: "structure",
                          members: {
                            HeightInPx: {
                              locationName: "heightInPx",
                              type: "integer"
                            },
                            WidthInPx: {
                              locationName: "widthInPx",
                              type: "integer"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            Priority: {
              locationName: "priority",
              type: "integer"
            },
            Queue: {
              locationName: "queue"
            },
            QueueTransitions: {
              locationName: "queueTransitions",
              type: "list",
              member: {
                type: "structure",
                members: {
                  DestinationQueue: {
                    locationName: "destinationQueue"
                  },
                  SourceQueue: {
                    locationName: "sourceQueue"
                  },
                  Timestamp: {
                    shape: "Sj4",
                    locationName: "timestamp"
                  }
                }
              }
            },
            RetryCount: {
              locationName: "retryCount",
              type: "integer"
            },
            Role: {
              locationName: "role"
            },
            Settings: {
              shape: "Se",
              locationName: "settings"
            },
            SimulateReservedQueue: {
              locationName: "simulateReservedQueue"
            },
            Status: {
              locationName: "status"
            },
            StatusUpdateInterval: {
              locationName: "statusUpdateInterval"
            },
            Timing: {
              locationName: "timing",
              type: "structure",
              members: {
                FinishTime: {
                  shape: "Sj4",
                  locationName: "finishTime"
                },
                StartTime: {
                  shape: "Sj4",
                  locationName: "startTime"
                },
                SubmitTime: {
                  shape: "Sj4",
                  locationName: "submitTime"
                }
              }
            },
            UserMetadata: {
              shape: "Sj0",
              locationName: "userMetadata"
            }
          },
          required: [
            "Role",
            "Settings"
          ]
        },
        Sj4: {
          type: "timestamp",
          timestampFormat: "unixTimestamp"
        },
        Sj7: {
          type: "list",
          member: {}
        },
        Sji: {
          type: "structure",
          members: {
            AdAvailOffset: {
              locationName: "adAvailOffset",
              type: "integer"
            },
            AvailBlanking: {
              shape: "Sg",
              locationName: "availBlanking"
            },
            Esam: {
              shape: "Si",
              locationName: "esam"
            },
            ExtendedDataServices: {
              shape: "So",
              locationName: "extendedDataServices"
            },
            Inputs: {
              locationName: "inputs",
              type: "list",
              member: {
                type: "structure",
                members: {
                  AudioSelectorGroups: {
                    shape: "St",
                    locationName: "audioSelectorGroups"
                  },
                  AudioSelectors: {
                    shape: "Sx",
                    locationName: "audioSelectors"
                  },
                  CaptionSelectors: {
                    shape: "S1i",
                    locationName: "captionSelectors"
                  },
                  Crop: {
                    shape: "S25",
                    locationName: "crop"
                  },
                  DeblockFilter: {
                    locationName: "deblockFilter"
                  },
                  DenoiseFilter: {
                    locationName: "denoiseFilter"
                  },
                  FilterEnable: {
                    locationName: "filterEnable"
                  },
                  FilterStrength: {
                    locationName: "filterStrength",
                    type: "integer"
                  },
                  ImageInserter: {
                    shape: "S2i",
                    locationName: "imageInserter"
                  },
                  InputClippings: {
                    shape: "S2p",
                    locationName: "inputClippings"
                  },
                  InputScanType: {
                    locationName: "inputScanType"
                  },
                  Position: {
                    shape: "S25",
                    locationName: "position"
                  },
                  ProgramNumber: {
                    locationName: "programNumber",
                    type: "integer"
                  },
                  PsiControl: {
                    locationName: "psiControl"
                  },
                  TimecodeSource: {
                    locationName: "timecodeSource"
                  },
                  TimecodeStart: {
                    locationName: "timecodeStart"
                  },
                  VideoSelector: {
                    shape: "S2y",
                    locationName: "videoSelector"
                  }
                }
              }
            },
            KantarWatermark: {
              shape: "S37",
              locationName: "kantarWatermark"
            },
            MotionImageInserter: {
              shape: "S3f",
              locationName: "motionImageInserter"
            },
            NielsenConfiguration: {
              shape: "S3n",
              locationName: "nielsenConfiguration"
            },
            NielsenNonLinearWatermark: {
              shape: "S3p",
              locationName: "nielsenNonLinearWatermark"
            },
            OutputGroups: {
              shape: "S3w",
              locationName: "outputGroups"
            },
            TimecodeConfig: {
              shape: "Sis",
              locationName: "timecodeConfig"
            },
            TimedMetadataInsertion: {
              shape: "Siv",
              locationName: "timedMetadataInsertion"
            }
          }
        },
        Sjm: {
          type: "structure",
          members: {
            AccelerationSettings: {
              shape: "S7",
              locationName: "accelerationSettings"
            },
            Arn: {
              locationName: "arn"
            },
            Category: {
              locationName: "category"
            },
            CreatedAt: {
              shape: "Sj4",
              locationName: "createdAt"
            },
            Description: {
              locationName: "description"
            },
            HopDestinations: {
              shape: "Sa",
              locationName: "hopDestinations"
            },
            LastUpdated: {
              shape: "Sj4",
              locationName: "lastUpdated"
            },
            Name: {
              locationName: "name"
            },
            Priority: {
              locationName: "priority",
              type: "integer"
            },
            Queue: {
              locationName: "queue"
            },
            Settings: {
              shape: "Sji",
              locationName: "settings"
            },
            StatusUpdateInterval: {
              locationName: "statusUpdateInterval"
            },
            Type: {
              locationName: "type"
            }
          },
          required: [
            "Settings",
            "Name"
          ]
        },
        Sjp: {
          type: "structure",
          members: {
            AudioDescriptions: {
              shape: "S71",
              locationName: "audioDescriptions"
            },
            CaptionDescriptions: {
              locationName: "captionDescriptions",
              type: "list",
              member: {
                type: "structure",
                members: {
                  CustomLanguageCode: {
                    locationName: "customLanguageCode"
                  },
                  DestinationSettings: {
                    shape: "S9j",
                    locationName: "destinationSettings"
                  },
                  LanguageCode: {
                    locationName: "languageCode"
                  },
                  LanguageDescription: {
                    locationName: "languageDescription"
                  }
                }
              }
            },
            ContainerSettings: {
              shape: "Sar",
              locationName: "containerSettings"
            },
            VideoDescription: {
              shape: "Scv",
              locationName: "videoDescription"
            }
          }
        },
        Sjt: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            Category: {
              locationName: "category"
            },
            CreatedAt: {
              shape: "Sj4",
              locationName: "createdAt"
            },
            Description: {
              locationName: "description"
            },
            LastUpdated: {
              shape: "Sj4",
              locationName: "lastUpdated"
            },
            Name: {
              locationName: "name"
            },
            Settings: {
              shape: "Sjp",
              locationName: "settings"
            },
            Type: {
              locationName: "type"
            }
          },
          required: [
            "Settings",
            "Name"
          ]
        },
        Sjw: {
          type: "structure",
          members: {
            Commitment: {
              locationName: "commitment"
            },
            RenewalType: {
              locationName: "renewalType"
            },
            ReservedSlots: {
              locationName: "reservedSlots",
              type: "integer"
            }
          },
          required: [
            "Commitment",
            "ReservedSlots",
            "RenewalType"
          ]
        },
        Sk1: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            CreatedAt: {
              shape: "Sj4",
              locationName: "createdAt"
            },
            Description: {
              locationName: "description"
            },
            LastUpdated: {
              shape: "Sj4",
              locationName: "lastUpdated"
            },
            Name: {
              locationName: "name"
            },
            PricingPlan: {
              locationName: "pricingPlan"
            },
            ProgressingJobsCount: {
              locationName: "progressingJobsCount",
              type: "integer"
            },
            ReservationPlan: {
              locationName: "reservationPlan",
              type: "structure",
              members: {
                Commitment: {
                  locationName: "commitment"
                },
                ExpiresAt: {
                  shape: "Sj4",
                  locationName: "expiresAt"
                },
                PurchasedAt: {
                  shape: "Sj4",
                  locationName: "purchasedAt"
                },
                RenewalType: {
                  locationName: "renewalType"
                },
                ReservedSlots: {
                  locationName: "reservedSlots",
                  type: "integer"
                },
                Status: {
                  locationName: "status"
                }
              }
            },
            Status: {
              locationName: "status"
            },
            SubmittedJobsCount: {
              locationName: "submittedJobsCount",
              type: "integer"
            },
            Type: {
              locationName: "type"
            }
          },
          required: [
            "Name"
          ]
        },
        Skp: {
          type: "structure",
          members: {
            HttpInputs: {
              locationName: "httpInputs"
            },
            HttpsInputs: {
              locationName: "httpsInputs"
            },
            S3Inputs: {
              locationName: "s3Inputs"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mediaconvert-2017-08-29.paginators.json
var require_mediaconvert_2017_08_29_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mediaconvert-2017-08-29.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeEndpoints: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Endpoints"
        },
        ListJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Jobs"
        },
        ListPresets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Presets"
        },
        ListJobTemplates: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "JobTemplates"
        },
        ListQueues: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Queues"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mediaconvert.js
var require_mediaconvert = __commonJS({
  "node_modules/aws-sdk/clients/mediaconvert.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["mediaconvert"] = {};
    AWS3.MediaConvert = Service.defineService("mediaconvert", ["2017-08-29"]);
    Object.defineProperty(apiLoader.services["mediaconvert"], "2017-08-29", {
      get: function get() {
        var model = require_mediaconvert_2017_08_29_min();
        model.paginators = require_mediaconvert_2017_08_29_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.MediaConvert;
  }
});

// node_modules/aws-sdk/apis/medialive-2017-10-14.min.json
var require_medialive_2017_10_14_min = __commonJS({
  "node_modules/aws-sdk/apis/medialive-2017-10-14.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2017-10-14",
        endpointPrefix: "medialive",
        signingName: "medialive",
        serviceFullName: "AWS Elemental MediaLive",
        serviceId: "MediaLive",
        protocol: "rest-json",
        uid: "medialive-2017-10-14",
        signatureVersion: "v4",
        serviceAbbreviation: "MediaLive",
        jsonVersion: "1.1"
      },
      operations: {
        AcceptInputDeviceTransfer: {
          http: {
            requestUri: "/prod/inputDevices/{inputDeviceId}/accept",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputDeviceId: {
                location: "uri",
                locationName: "inputDeviceId"
              }
            },
            required: [
              "InputDeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        BatchDelete: {
          http: {
            requestUri: "/prod/batch/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelIds: {
                shape: "S5",
                locationName: "channelIds"
              },
              InputIds: {
                shape: "S5",
                locationName: "inputIds"
              },
              InputSecurityGroupIds: {
                shape: "S5",
                locationName: "inputSecurityGroupIds"
              },
              MultiplexIds: {
                shape: "S5",
                locationName: "multiplexIds"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Failed: {
                shape: "S7",
                locationName: "failed"
              },
              Successful: {
                shape: "S9",
                locationName: "successful"
              }
            }
          }
        },
        BatchStart: {
          http: {
            requestUri: "/prod/batch/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelIds: {
                shape: "S5",
                locationName: "channelIds"
              },
              MultiplexIds: {
                shape: "S5",
                locationName: "multiplexIds"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Failed: {
                shape: "S7",
                locationName: "failed"
              },
              Successful: {
                shape: "S9",
                locationName: "successful"
              }
            }
          }
        },
        BatchStop: {
          http: {
            requestUri: "/prod/batch/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelIds: {
                shape: "S5",
                locationName: "channelIds"
              },
              MultiplexIds: {
                shape: "S5",
                locationName: "multiplexIds"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Failed: {
                shape: "S7",
                locationName: "failed"
              },
              Successful: {
                shape: "S9",
                locationName: "successful"
              }
            }
          }
        },
        BatchUpdateSchedule: {
          http: {
            method: "PUT",
            requestUri: "/prod/channels/{channelId}/schedule",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelId: {
                location: "uri",
                locationName: "channelId"
              },
              Creates: {
                locationName: "creates",
                type: "structure",
                members: {
                  ScheduleActions: {
                    shape: "Sh",
                    locationName: "scheduleActions"
                  }
                },
                required: [
                  "ScheduleActions"
                ]
              },
              Deletes: {
                locationName: "deletes",
                type: "structure",
                members: {
                  ActionNames: {
                    shape: "S5",
                    locationName: "actionNames"
                  }
                },
                required: [
                  "ActionNames"
                ]
              }
            },
            required: [
              "ChannelId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Creates: {
                locationName: "creates",
                type: "structure",
                members: {
                  ScheduleActions: {
                    shape: "Sh",
                    locationName: "scheduleActions"
                  }
                },
                required: [
                  "ScheduleActions"
                ]
              },
              Deletes: {
                locationName: "deletes",
                type: "structure",
                members: {
                  ScheduleActions: {
                    shape: "Sh",
                    locationName: "scheduleActions"
                  }
                },
                required: [
                  "ScheduleActions"
                ]
              }
            }
          }
        },
        CancelInputDeviceTransfer: {
          http: {
            requestUri: "/prod/inputDevices/{inputDeviceId}/cancel",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputDeviceId: {
                location: "uri",
                locationName: "inputDeviceId"
              }
            },
            required: [
              "InputDeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ClaimDevice: {
          http: {
            requestUri: "/prod/claimDevice",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Id: {
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateChannel: {
          http: {
            requestUri: "/prod/channels",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              CdiInputSpecification: {
                shape: "S22",
                locationName: "cdiInputSpecification"
              },
              ChannelClass: {
                locationName: "channelClass"
              },
              Destinations: {
                shape: "S25",
                locationName: "destinations"
              },
              EncoderSettings: {
                shape: "S2d",
                locationName: "encoderSettings"
              },
              InputAttachments: {
                shape: "Sci",
                locationName: "inputAttachments"
              },
              InputSpecification: {
                shape: "Se4",
                locationName: "inputSpecification"
              },
              LogLevel: {
                locationName: "logLevel"
              },
              Name: {
                locationName: "name"
              },
              RequestId: {
                locationName: "requestId",
                idempotencyToken: true
              },
              Reserved: {
                locationName: "reserved",
                deprecated: true
              },
              RoleArn: {
                locationName: "roleArn"
              },
              Tags: {
                shape: "Se9",
                locationName: "tags"
              },
              Vpc: {
                locationName: "vpc",
                type: "structure",
                members: {
                  PublicAddressAllocationIds: {
                    shape: "S5",
                    locationName: "publicAddressAllocationIds"
                  },
                  SecurityGroupIds: {
                    shape: "S5",
                    locationName: "securityGroupIds"
                  },
                  SubnetIds: {
                    shape: "S5",
                    locationName: "subnetIds"
                  }
                },
                required: [
                  "SubnetIds"
                ]
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channel: {
                shape: "Sec",
                locationName: "channel"
              }
            }
          }
        },
        CreateInput: {
          http: {
            requestUri: "/prod/inputs",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Destinations: {
                shape: "Sek",
                locationName: "destinations"
              },
              InputDevices: {
                shape: "Sem",
                locationName: "inputDevices"
              },
              InputSecurityGroups: {
                shape: "S5",
                locationName: "inputSecurityGroups"
              },
              MediaConnectFlows: {
                shape: "Seo",
                locationName: "mediaConnectFlows"
              },
              Name: {
                locationName: "name"
              },
              RequestId: {
                locationName: "requestId",
                idempotencyToken: true
              },
              RoleArn: {
                locationName: "roleArn"
              },
              Sources: {
                shape: "Seq",
                locationName: "sources"
              },
              Tags: {
                shape: "Se9",
                locationName: "tags"
              },
              Type: {
                locationName: "type"
              },
              Vpc: {
                locationName: "vpc",
                type: "structure",
                members: {
                  SecurityGroupIds: {
                    shape: "S5",
                    locationName: "securityGroupIds"
                  },
                  SubnetIds: {
                    shape: "S5",
                    locationName: "subnetIds"
                  }
                },
                required: [
                  "SubnetIds"
                ]
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Input: {
                shape: "Sev",
                locationName: "input"
              }
            }
          }
        },
        CreateInputSecurityGroup: {
          http: {
            requestUri: "/prod/inputSecurityGroups",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Tags: {
                shape: "Se9",
                locationName: "tags"
              },
              WhitelistRules: {
                shape: "Sf7",
                locationName: "whitelistRules"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityGroup: {
                shape: "Sfa",
                locationName: "securityGroup"
              }
            }
          }
        },
        CreateMultiplex: {
          http: {
            requestUri: "/prod/multiplexes",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              AvailabilityZones: {
                shape: "S5",
                locationName: "availabilityZones"
              },
              MultiplexSettings: {
                shape: "Sff",
                locationName: "multiplexSettings"
              },
              Name: {
                locationName: "name"
              },
              RequestId: {
                locationName: "requestId",
                idempotencyToken: true
              },
              Tags: {
                shape: "Se9",
                locationName: "tags"
              }
            },
            required: [
              "RequestId",
              "MultiplexSettings",
              "AvailabilityZones",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Multiplex: {
                shape: "Sfk",
                locationName: "multiplex"
              }
            }
          }
        },
        CreateMultiplexProgram: {
          http: {
            requestUri: "/prod/multiplexes/{multiplexId}/programs",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              MultiplexId: {
                location: "uri",
                locationName: "multiplexId"
              },
              MultiplexProgramSettings: {
                shape: "Sfq",
                locationName: "multiplexProgramSettings"
              },
              ProgramName: {
                locationName: "programName"
              },
              RequestId: {
                locationName: "requestId",
                idempotencyToken: true
              }
            },
            required: [
              "MultiplexId",
              "RequestId",
              "MultiplexProgramSettings",
              "ProgramName"
            ]
          },
          output: {
            type: "structure",
            members: {
              MultiplexProgram: {
                shape: "Sfz",
                locationName: "multiplexProgram"
              }
            }
          }
        },
        CreatePartnerInput: {
          http: {
            requestUri: "/prod/inputs/{inputId}/partners",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              InputId: {
                location: "uri",
                locationName: "inputId"
              },
              RequestId: {
                locationName: "requestId",
                idempotencyToken: true
              },
              Tags: {
                shape: "Se9",
                locationName: "tags"
              }
            },
            required: [
              "InputId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Input: {
                shape: "Sev",
                locationName: "input"
              }
            }
          }
        },
        CreateTags: {
          http: {
            requestUri: "/prod/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              Tags: {
                shape: "Se9",
                locationName: "tags"
              }
            },
            required: [
              "ResourceArn"
            ]
          }
        },
        DeleteChannel: {
          http: {
            method: "DELETE",
            requestUri: "/prod/channels/{channelId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelId: {
                location: "uri",
                locationName: "channelId"
              }
            },
            required: [
              "ChannelId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              CdiInputSpecification: {
                shape: "S22",
                locationName: "cdiInputSpecification"
              },
              ChannelClass: {
                locationName: "channelClass"
              },
              Destinations: {
                shape: "S25",
                locationName: "destinations"
              },
              EgressEndpoints: {
                shape: "Sed",
                locationName: "egressEndpoints"
              },
              EncoderSettings: {
                shape: "S2d",
                locationName: "encoderSettings"
              },
              Id: {
                locationName: "id"
              },
              InputAttachments: {
                shape: "Sci",
                locationName: "inputAttachments"
              },
              InputSpecification: {
                shape: "Se4",
                locationName: "inputSpecification"
              },
              LogLevel: {
                locationName: "logLevel"
              },
              Name: {
                locationName: "name"
              },
              PipelineDetails: {
                shape: "Sef",
                locationName: "pipelineDetails"
              },
              PipelinesRunningCount: {
                locationName: "pipelinesRunningCount",
                type: "integer"
              },
              RoleArn: {
                locationName: "roleArn"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Se9",
                locationName: "tags"
              },
              Vpc: {
                shape: "Sei",
                locationName: "vpc"
              }
            }
          }
        },
        DeleteInput: {
          http: {
            method: "DELETE",
            requestUri: "/prod/inputs/{inputId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputId: {
                location: "uri",
                locationName: "inputId"
              }
            },
            required: [
              "InputId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteInputSecurityGroup: {
          http: {
            method: "DELETE",
            requestUri: "/prod/inputSecurityGroups/{inputSecurityGroupId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputSecurityGroupId: {
                location: "uri",
                locationName: "inputSecurityGroupId"
              }
            },
            required: [
              "InputSecurityGroupId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteMultiplex: {
          http: {
            method: "DELETE",
            requestUri: "/prod/multiplexes/{multiplexId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              MultiplexId: {
                location: "uri",
                locationName: "multiplexId"
              }
            },
            required: [
              "MultiplexId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              AvailabilityZones: {
                shape: "S5",
                locationName: "availabilityZones"
              },
              Destinations: {
                shape: "Sfl",
                locationName: "destinations"
              },
              Id: {
                locationName: "id"
              },
              MultiplexSettings: {
                shape: "Sff",
                locationName: "multiplexSettings"
              },
              Name: {
                locationName: "name"
              },
              PipelinesRunningCount: {
                locationName: "pipelinesRunningCount",
                type: "integer"
              },
              ProgramCount: {
                locationName: "programCount",
                type: "integer"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Se9",
                locationName: "tags"
              }
            }
          }
        },
        DeleteMultiplexProgram: {
          http: {
            method: "DELETE",
            requestUri: "/prod/multiplexes/{multiplexId}/programs/{programName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MultiplexId: {
                location: "uri",
                locationName: "multiplexId"
              },
              ProgramName: {
                location: "uri",
                locationName: "programName"
              }
            },
            required: [
              "MultiplexId",
              "ProgramName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ChannelId: {
                locationName: "channelId"
              },
              MultiplexProgramSettings: {
                shape: "Sfq",
                locationName: "multiplexProgramSettings"
              },
              PacketIdentifiersMap: {
                shape: "Sg0",
                locationName: "packetIdentifiersMap"
              },
              PipelineDetails: {
                shape: "Sg2",
                locationName: "pipelineDetails"
              },
              ProgramName: {
                locationName: "programName"
              }
            }
          }
        },
        DeleteReservation: {
          http: {
            method: "DELETE",
            requestUri: "/prod/reservations/{reservationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ReservationId: {
                location: "uri",
                locationName: "reservationId"
              }
            },
            required: [
              "ReservationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              Count: {
                locationName: "count",
                type: "integer"
              },
              CurrencyCode: {
                locationName: "currencyCode"
              },
              Duration: {
                locationName: "duration",
                type: "integer"
              },
              DurationUnits: {
                locationName: "durationUnits"
              },
              End: {
                locationName: "end"
              },
              FixedPrice: {
                locationName: "fixedPrice",
                type: "double"
              },
              Name: {
                locationName: "name"
              },
              OfferingDescription: {
                locationName: "offeringDescription"
              },
              OfferingId: {
                locationName: "offeringId"
              },
              OfferingType: {
                locationName: "offeringType"
              },
              Region: {
                locationName: "region"
              },
              ReservationId: {
                locationName: "reservationId"
              },
              ResourceSpecification: {
                shape: "Sgl",
                locationName: "resourceSpecification"
              },
              Start: {
                locationName: "start"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Se9",
                locationName: "tags"
              },
              UsagePrice: {
                locationName: "usagePrice",
                type: "double"
              }
            }
          }
        },
        DeleteSchedule: {
          http: {
            method: "DELETE",
            requestUri: "/prod/channels/{channelId}/schedule",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelId: {
                location: "uri",
                locationName: "channelId"
              }
            },
            required: [
              "ChannelId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTags: {
          http: {
            method: "DELETE",
            requestUri: "/prod/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                shape: "S5",
                location: "querystring",
                locationName: "tagKeys"
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ]
          }
        },
        DescribeChannel: {
          http: {
            method: "GET",
            requestUri: "/prod/channels/{channelId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelId: {
                location: "uri",
                locationName: "channelId"
              }
            },
            required: [
              "ChannelId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              CdiInputSpecification: {
                shape: "S22",
                locationName: "cdiInputSpecification"
              },
              ChannelClass: {
                locationName: "channelClass"
              },
              Destinations: {
                shape: "S25",
                locationName: "destinations"
              },
              EgressEndpoints: {
                shape: "Sed",
                locationName: "egressEndpoints"
              },
              EncoderSettings: {
                shape: "S2d",
                locationName: "encoderSettings"
              },
              Id: {
                locationName: "id"
              },
              InputAttachments: {
                shape: "Sci",
                locationName: "inputAttachments"
              },
              InputSpecification: {
                shape: "Se4",
                locationName: "inputSpecification"
              },
              LogLevel: {
                locationName: "logLevel"
              },
              Name: {
                locationName: "name"
              },
              PipelineDetails: {
                shape: "Sef",
                locationName: "pipelineDetails"
              },
              PipelinesRunningCount: {
                locationName: "pipelinesRunningCount",
                type: "integer"
              },
              RoleArn: {
                locationName: "roleArn"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Se9",
                locationName: "tags"
              },
              Vpc: {
                shape: "Sei",
                locationName: "vpc"
              }
            }
          }
        },
        DescribeInput: {
          http: {
            method: "GET",
            requestUri: "/prod/inputs/{inputId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputId: {
                location: "uri",
                locationName: "inputId"
              }
            },
            required: [
              "InputId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              AttachedChannels: {
                shape: "S5",
                locationName: "attachedChannels"
              },
              Destinations: {
                shape: "Sew",
                locationName: "destinations"
              },
              Id: {
                locationName: "id"
              },
              InputClass: {
                locationName: "inputClass"
              },
              InputDevices: {
                shape: "Sem",
                locationName: "inputDevices"
              },
              InputPartnerIds: {
                shape: "S5",
                locationName: "inputPartnerIds"
              },
              InputSourceType: {
                locationName: "inputSourceType"
              },
              MediaConnectFlows: {
                shape: "Sf1",
                locationName: "mediaConnectFlows"
              },
              Name: {
                locationName: "name"
              },
              RoleArn: {
                locationName: "roleArn"
              },
              SecurityGroups: {
                shape: "S5",
                locationName: "securityGroups"
              },
              Sources: {
                shape: "Sf3",
                locationName: "sources"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Se9",
                locationName: "tags"
              },
              Type: {
                locationName: "type"
              }
            }
          }
        },
        DescribeInputDevice: {
          http: {
            method: "GET",
            requestUri: "/prod/inputDevices/{inputDeviceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputDeviceId: {
                location: "uri",
                locationName: "inputDeviceId"
              }
            },
            required: [
              "InputDeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              ConnectionState: {
                locationName: "connectionState"
              },
              DeviceSettingsSyncState: {
                locationName: "deviceSettingsSyncState"
              },
              DeviceUpdateStatus: {
                locationName: "deviceUpdateStatus"
              },
              HdDeviceSettings: {
                shape: "Sh6",
                locationName: "hdDeviceSettings"
              },
              Id: {
                locationName: "id"
              },
              MacAddress: {
                locationName: "macAddress"
              },
              Name: {
                locationName: "name"
              },
              NetworkSettings: {
                shape: "Shb",
                locationName: "networkSettings"
              },
              SerialNumber: {
                locationName: "serialNumber"
              },
              Type: {
                locationName: "type"
              },
              UhdDeviceSettings: {
                shape: "She",
                locationName: "uhdDeviceSettings"
              }
            }
          }
        },
        DescribeInputDeviceThumbnail: {
          http: {
            method: "GET",
            requestUri: "/prod/inputDevices/{inputDeviceId}/thumbnailData",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputDeviceId: {
                location: "uri",
                locationName: "inputDeviceId"
              },
              Accept: {
                location: "header",
                locationName: "accept"
              }
            },
            required: [
              "InputDeviceId",
              "Accept"
            ]
          },
          output: {
            type: "structure",
            members: {
              Body: {
                locationName: "body",
                type: "blob",
                streaming: true
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              ContentLength: {
                location: "header",
                locationName: "Content-Length",
                type: "long"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              },
              LastModified: {
                location: "header",
                locationName: "Last-Modified",
                type: "timestamp"
              }
            },
            payload: "Body"
          }
        },
        DescribeInputSecurityGroup: {
          http: {
            method: "GET",
            requestUri: "/prod/inputSecurityGroups/{inputSecurityGroupId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputSecurityGroupId: {
                location: "uri",
                locationName: "inputSecurityGroupId"
              }
            },
            required: [
              "InputSecurityGroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              Id: {
                locationName: "id"
              },
              Inputs: {
                shape: "S5",
                locationName: "inputs"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Se9",
                locationName: "tags"
              },
              WhitelistRules: {
                shape: "Sfc",
                locationName: "whitelistRules"
              }
            }
          }
        },
        DescribeMultiplex: {
          http: {
            method: "GET",
            requestUri: "/prod/multiplexes/{multiplexId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MultiplexId: {
                location: "uri",
                locationName: "multiplexId"
              }
            },
            required: [
              "MultiplexId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              AvailabilityZones: {
                shape: "S5",
                locationName: "availabilityZones"
              },
              Destinations: {
                shape: "Sfl",
                locationName: "destinations"
              },
              Id: {
                locationName: "id"
              },
              MultiplexSettings: {
                shape: "Sff",
                locationName: "multiplexSettings"
              },
              Name: {
                locationName: "name"
              },
              PipelinesRunningCount: {
                locationName: "pipelinesRunningCount",
                type: "integer"
              },
              ProgramCount: {
                locationName: "programCount",
                type: "integer"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Se9",
                locationName: "tags"
              }
            }
          }
        },
        DescribeMultiplexProgram: {
          http: {
            method: "GET",
            requestUri: "/prod/multiplexes/{multiplexId}/programs/{programName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MultiplexId: {
                location: "uri",
                locationName: "multiplexId"
              },
              ProgramName: {
                location: "uri",
                locationName: "programName"
              }
            },
            required: [
              "MultiplexId",
              "ProgramName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ChannelId: {
                locationName: "channelId"
              },
              MultiplexProgramSettings: {
                shape: "Sfq",
                locationName: "multiplexProgramSettings"
              },
              PacketIdentifiersMap: {
                shape: "Sg0",
                locationName: "packetIdentifiersMap"
              },
              PipelineDetails: {
                shape: "Sg2",
                locationName: "pipelineDetails"
              },
              ProgramName: {
                locationName: "programName"
              }
            }
          }
        },
        DescribeOffering: {
          http: {
            method: "GET",
            requestUri: "/prod/offerings/{offeringId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              OfferingId: {
                location: "uri",
                locationName: "offeringId"
              }
            },
            required: [
              "OfferingId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              CurrencyCode: {
                locationName: "currencyCode"
              },
              Duration: {
                locationName: "duration",
                type: "integer"
              },
              DurationUnits: {
                locationName: "durationUnits"
              },
              FixedPrice: {
                locationName: "fixedPrice",
                type: "double"
              },
              OfferingDescription: {
                locationName: "offeringDescription"
              },
              OfferingId: {
                locationName: "offeringId"
              },
              OfferingType: {
                locationName: "offeringType"
              },
              Region: {
                locationName: "region"
              },
              ResourceSpecification: {
                shape: "Sgl",
                locationName: "resourceSpecification"
              },
              UsagePrice: {
                locationName: "usagePrice",
                type: "double"
              }
            }
          }
        },
        DescribeReservation: {
          http: {
            method: "GET",
            requestUri: "/prod/reservations/{reservationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ReservationId: {
                location: "uri",
                locationName: "reservationId"
              }
            },
            required: [
              "ReservationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              Count: {
                locationName: "count",
                type: "integer"
              },
              CurrencyCode: {
                locationName: "currencyCode"
              },
              Duration: {
                locationName: "duration",
                type: "integer"
              },
              DurationUnits: {
                locationName: "durationUnits"
              },
              End: {
                locationName: "end"
              },
              FixedPrice: {
                locationName: "fixedPrice",
                type: "double"
              },
              Name: {
                locationName: "name"
              },
              OfferingDescription: {
                locationName: "offeringDescription"
              },
              OfferingId: {
                locationName: "offeringId"
              },
              OfferingType: {
                locationName: "offeringType"
              },
              Region: {
                locationName: "region"
              },
              ReservationId: {
                locationName: "reservationId"
              },
              ResourceSpecification: {
                shape: "Sgl",
                locationName: "resourceSpecification"
              },
              Start: {
                locationName: "start"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Se9",
                locationName: "tags"
              },
              UsagePrice: {
                locationName: "usagePrice",
                type: "double"
              }
            }
          }
        },
        DescribeSchedule: {
          http: {
            method: "GET",
            requestUri: "/prod/channels/{channelId}/schedule",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelId: {
                location: "uri",
                locationName: "channelId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ChannelId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              ScheduleActions: {
                shape: "Sh",
                locationName: "scheduleActions"
              }
            }
          }
        },
        ListChannels: {
          http: {
            method: "GET",
            requestUri: "/prod/channels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channels: {
                locationName: "channels",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    CdiInputSpecification: {
                      shape: "S22",
                      locationName: "cdiInputSpecification"
                    },
                    ChannelClass: {
                      locationName: "channelClass"
                    },
                    Destinations: {
                      shape: "S25",
                      locationName: "destinations"
                    },
                    EgressEndpoints: {
                      shape: "Sed",
                      locationName: "egressEndpoints"
                    },
                    Id: {
                      locationName: "id"
                    },
                    InputAttachments: {
                      shape: "Sci",
                      locationName: "inputAttachments"
                    },
                    InputSpecification: {
                      shape: "Se4",
                      locationName: "inputSpecification"
                    },
                    LogLevel: {
                      locationName: "logLevel"
                    },
                    Name: {
                      locationName: "name"
                    },
                    PipelinesRunningCount: {
                      locationName: "pipelinesRunningCount",
                      type: "integer"
                    },
                    RoleArn: {
                      locationName: "roleArn"
                    },
                    State: {
                      locationName: "state"
                    },
                    Tags: {
                      shape: "Se9",
                      locationName: "tags"
                    },
                    Vpc: {
                      shape: "Sei",
                      locationName: "vpc"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListInputDeviceTransfers: {
          http: {
            method: "GET",
            requestUri: "/prod/inputDeviceTransfers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              TransferType: {
                location: "querystring",
                locationName: "transferType"
              }
            },
            required: [
              "TransferType"
            ]
          },
          output: {
            type: "structure",
            members: {
              InputDeviceTransfers: {
                locationName: "inputDeviceTransfers",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {
                      locationName: "id"
                    },
                    Message: {
                      locationName: "message"
                    },
                    TargetCustomerId: {
                      locationName: "targetCustomerId"
                    },
                    TransferType: {
                      locationName: "transferType"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListInputDevices: {
          http: {
            method: "GET",
            requestUri: "/prod/inputDevices",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InputDevices: {
                locationName: "inputDevices",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    ConnectionState: {
                      locationName: "connectionState"
                    },
                    DeviceSettingsSyncState: {
                      locationName: "deviceSettingsSyncState"
                    },
                    DeviceUpdateStatus: {
                      locationName: "deviceUpdateStatus"
                    },
                    HdDeviceSettings: {
                      shape: "Sh6",
                      locationName: "hdDeviceSettings"
                    },
                    Id: {
                      locationName: "id"
                    },
                    MacAddress: {
                      locationName: "macAddress"
                    },
                    Name: {
                      locationName: "name"
                    },
                    NetworkSettings: {
                      shape: "Shb",
                      locationName: "networkSettings"
                    },
                    SerialNumber: {
                      locationName: "serialNumber"
                    },
                    Type: {
                      locationName: "type"
                    },
                    UhdDeviceSettings: {
                      shape: "She",
                      locationName: "uhdDeviceSettings"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListInputSecurityGroups: {
          http: {
            method: "GET",
            requestUri: "/prod/inputSecurityGroups",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InputSecurityGroups: {
                locationName: "inputSecurityGroups",
                type: "list",
                member: {
                  shape: "Sfa"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListInputs: {
          http: {
            method: "GET",
            requestUri: "/prod/inputs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Inputs: {
                locationName: "inputs",
                type: "list",
                member: {
                  shape: "Sev"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListMultiplexPrograms: {
          http: {
            method: "GET",
            requestUri: "/prod/multiplexes/{multiplexId}/programs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              MultiplexId: {
                location: "uri",
                locationName: "multiplexId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "MultiplexId"
            ]
          },
          output: {
            type: "structure",
            members: {
              MultiplexPrograms: {
                locationName: "multiplexPrograms",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ChannelId: {
                      locationName: "channelId"
                    },
                    ProgramName: {
                      locationName: "programName"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListMultiplexes: {
          http: {
            method: "GET",
            requestUri: "/prod/multiplexes",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Multiplexes: {
                locationName: "multiplexes",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    AvailabilityZones: {
                      shape: "S5",
                      locationName: "availabilityZones"
                    },
                    Id: {
                      locationName: "id"
                    },
                    MultiplexSettings: {
                      locationName: "multiplexSettings",
                      type: "structure",
                      members: {
                        TransportStreamBitrate: {
                          locationName: "transportStreamBitrate",
                          type: "integer"
                        }
                      }
                    },
                    Name: {
                      locationName: "name"
                    },
                    PipelinesRunningCount: {
                      locationName: "pipelinesRunningCount",
                      type: "integer"
                    },
                    ProgramCount: {
                      locationName: "programCount",
                      type: "integer"
                    },
                    State: {
                      locationName: "state"
                    },
                    Tags: {
                      shape: "Se9",
                      locationName: "tags"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListOfferings: {
          http: {
            method: "GET",
            requestUri: "/prod/offerings",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelClass: {
                location: "querystring",
                locationName: "channelClass"
              },
              ChannelConfiguration: {
                location: "querystring",
                locationName: "channelConfiguration"
              },
              Codec: {
                location: "querystring",
                locationName: "codec"
              },
              Duration: {
                location: "querystring",
                locationName: "duration"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              MaximumBitrate: {
                location: "querystring",
                locationName: "maximumBitrate"
              },
              MaximumFramerate: {
                location: "querystring",
                locationName: "maximumFramerate"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              Resolution: {
                location: "querystring",
                locationName: "resolution"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              SpecialFeature: {
                location: "querystring",
                locationName: "specialFeature"
              },
              VideoQuality: {
                location: "querystring",
                locationName: "videoQuality"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Offerings: {
                locationName: "offerings",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    CurrencyCode: {
                      locationName: "currencyCode"
                    },
                    Duration: {
                      locationName: "duration",
                      type: "integer"
                    },
                    DurationUnits: {
                      locationName: "durationUnits"
                    },
                    FixedPrice: {
                      locationName: "fixedPrice",
                      type: "double"
                    },
                    OfferingDescription: {
                      locationName: "offeringDescription"
                    },
                    OfferingId: {
                      locationName: "offeringId"
                    },
                    OfferingType: {
                      locationName: "offeringType"
                    },
                    Region: {
                      locationName: "region"
                    },
                    ResourceSpecification: {
                      shape: "Sgl",
                      locationName: "resourceSpecification"
                    },
                    UsagePrice: {
                      locationName: "usagePrice",
                      type: "double"
                    }
                  }
                }
              }
            }
          }
        },
        ListReservations: {
          http: {
            method: "GET",
            requestUri: "/prod/reservations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelClass: {
                location: "querystring",
                locationName: "channelClass"
              },
              Codec: {
                location: "querystring",
                locationName: "codec"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              MaximumBitrate: {
                location: "querystring",
                locationName: "maximumBitrate"
              },
              MaximumFramerate: {
                location: "querystring",
                locationName: "maximumFramerate"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              Resolution: {
                location: "querystring",
                locationName: "resolution"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              SpecialFeature: {
                location: "querystring",
                locationName: "specialFeature"
              },
              VideoQuality: {
                location: "querystring",
                locationName: "videoQuality"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Reservations: {
                locationName: "reservations",
                type: "list",
                member: {
                  shape: "Siy"
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/prod/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Se9",
                locationName: "tags"
              }
            }
          }
        },
        PurchaseOffering: {
          http: {
            requestUri: "/prod/offerings/{offeringId}/purchase",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Count: {
                locationName: "count",
                type: "integer"
              },
              Name: {
                locationName: "name"
              },
              OfferingId: {
                location: "uri",
                locationName: "offeringId"
              },
              RequestId: {
                locationName: "requestId",
                idempotencyToken: true
              },
              Start: {
                locationName: "start"
              },
              Tags: {
                shape: "Se9",
                locationName: "tags"
              }
            },
            required: [
              "OfferingId",
              "Count"
            ]
          },
          output: {
            type: "structure",
            members: {
              Reservation: {
                shape: "Siy",
                locationName: "reservation"
              }
            }
          }
        },
        RejectInputDeviceTransfer: {
          http: {
            requestUri: "/prod/inputDevices/{inputDeviceId}/reject",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputDeviceId: {
                location: "uri",
                locationName: "inputDeviceId"
              }
            },
            required: [
              "InputDeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartChannel: {
          http: {
            requestUri: "/prod/channels/{channelId}/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelId: {
                location: "uri",
                locationName: "channelId"
              }
            },
            required: [
              "ChannelId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              CdiInputSpecification: {
                shape: "S22",
                locationName: "cdiInputSpecification"
              },
              ChannelClass: {
                locationName: "channelClass"
              },
              Destinations: {
                shape: "S25",
                locationName: "destinations"
              },
              EgressEndpoints: {
                shape: "Sed",
                locationName: "egressEndpoints"
              },
              EncoderSettings: {
                shape: "S2d",
                locationName: "encoderSettings"
              },
              Id: {
                locationName: "id"
              },
              InputAttachments: {
                shape: "Sci",
                locationName: "inputAttachments"
              },
              InputSpecification: {
                shape: "Se4",
                locationName: "inputSpecification"
              },
              LogLevel: {
                locationName: "logLevel"
              },
              Name: {
                locationName: "name"
              },
              PipelineDetails: {
                shape: "Sef",
                locationName: "pipelineDetails"
              },
              PipelinesRunningCount: {
                locationName: "pipelinesRunningCount",
                type: "integer"
              },
              RoleArn: {
                locationName: "roleArn"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Se9",
                locationName: "tags"
              },
              Vpc: {
                shape: "Sei",
                locationName: "vpc"
              }
            }
          }
        },
        StartMultiplex: {
          http: {
            requestUri: "/prod/multiplexes/{multiplexId}/start",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              MultiplexId: {
                location: "uri",
                locationName: "multiplexId"
              }
            },
            required: [
              "MultiplexId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              AvailabilityZones: {
                shape: "S5",
                locationName: "availabilityZones"
              },
              Destinations: {
                shape: "Sfl",
                locationName: "destinations"
              },
              Id: {
                locationName: "id"
              },
              MultiplexSettings: {
                shape: "Sff",
                locationName: "multiplexSettings"
              },
              Name: {
                locationName: "name"
              },
              PipelinesRunningCount: {
                locationName: "pipelinesRunningCount",
                type: "integer"
              },
              ProgramCount: {
                locationName: "programCount",
                type: "integer"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Se9",
                locationName: "tags"
              }
            }
          }
        },
        StopChannel: {
          http: {
            requestUri: "/prod/channels/{channelId}/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelId: {
                location: "uri",
                locationName: "channelId"
              }
            },
            required: [
              "ChannelId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              CdiInputSpecification: {
                shape: "S22",
                locationName: "cdiInputSpecification"
              },
              ChannelClass: {
                locationName: "channelClass"
              },
              Destinations: {
                shape: "S25",
                locationName: "destinations"
              },
              EgressEndpoints: {
                shape: "Sed",
                locationName: "egressEndpoints"
              },
              EncoderSettings: {
                shape: "S2d",
                locationName: "encoderSettings"
              },
              Id: {
                locationName: "id"
              },
              InputAttachments: {
                shape: "Sci",
                locationName: "inputAttachments"
              },
              InputSpecification: {
                shape: "Se4",
                locationName: "inputSpecification"
              },
              LogLevel: {
                locationName: "logLevel"
              },
              Name: {
                locationName: "name"
              },
              PipelineDetails: {
                shape: "Sef",
                locationName: "pipelineDetails"
              },
              PipelinesRunningCount: {
                locationName: "pipelinesRunningCount",
                type: "integer"
              },
              RoleArn: {
                locationName: "roleArn"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Se9",
                locationName: "tags"
              },
              Vpc: {
                shape: "Sei",
                locationName: "vpc"
              }
            }
          }
        },
        StopMultiplex: {
          http: {
            requestUri: "/prod/multiplexes/{multiplexId}/stop",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              MultiplexId: {
                location: "uri",
                locationName: "multiplexId"
              }
            },
            required: [
              "MultiplexId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              AvailabilityZones: {
                shape: "S5",
                locationName: "availabilityZones"
              },
              Destinations: {
                shape: "Sfl",
                locationName: "destinations"
              },
              Id: {
                locationName: "id"
              },
              MultiplexSettings: {
                shape: "Sff",
                locationName: "multiplexSettings"
              },
              Name: {
                locationName: "name"
              },
              PipelinesRunningCount: {
                locationName: "pipelinesRunningCount",
                type: "integer"
              },
              ProgramCount: {
                locationName: "programCount",
                type: "integer"
              },
              State: {
                locationName: "state"
              },
              Tags: {
                shape: "Se9",
                locationName: "tags"
              }
            }
          }
        },
        TransferInputDevice: {
          http: {
            requestUri: "/prod/inputDevices/{inputDeviceId}/transfer",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputDeviceId: {
                location: "uri",
                locationName: "inputDeviceId"
              },
              TargetCustomerId: {
                locationName: "targetCustomerId"
              },
              TargetRegion: {
                locationName: "targetRegion"
              },
              TransferMessage: {
                locationName: "transferMessage"
              }
            },
            required: [
              "InputDeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateChannel: {
          http: {
            method: "PUT",
            requestUri: "/prod/channels/{channelId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CdiInputSpecification: {
                shape: "S22",
                locationName: "cdiInputSpecification"
              },
              ChannelId: {
                location: "uri",
                locationName: "channelId"
              },
              Destinations: {
                shape: "S25",
                locationName: "destinations"
              },
              EncoderSettings: {
                shape: "S2d",
                locationName: "encoderSettings"
              },
              InputAttachments: {
                shape: "Sci",
                locationName: "inputAttachments"
              },
              InputSpecification: {
                shape: "Se4",
                locationName: "inputSpecification"
              },
              LogLevel: {
                locationName: "logLevel"
              },
              Name: {
                locationName: "name"
              },
              RoleArn: {
                locationName: "roleArn"
              }
            },
            required: [
              "ChannelId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Channel: {
                shape: "Sec",
                locationName: "channel"
              }
            }
          }
        },
        UpdateChannelClass: {
          http: {
            method: "PUT",
            requestUri: "/prod/channels/{channelId}/channelClass",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ChannelClass: {
                locationName: "channelClass"
              },
              ChannelId: {
                location: "uri",
                locationName: "channelId"
              },
              Destinations: {
                shape: "S25",
                locationName: "destinations"
              }
            },
            required: [
              "ChannelId",
              "ChannelClass"
            ]
          },
          output: {
            type: "structure",
            members: {
              Channel: {
                shape: "Sec",
                locationName: "channel"
              }
            }
          }
        },
        UpdateInput: {
          http: {
            method: "PUT",
            requestUri: "/prod/inputs/{inputId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Destinations: {
                shape: "Sek",
                locationName: "destinations"
              },
              InputDevices: {
                locationName: "inputDevices",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {
                      locationName: "id"
                    }
                  }
                }
              },
              InputId: {
                location: "uri",
                locationName: "inputId"
              },
              InputSecurityGroups: {
                shape: "S5",
                locationName: "inputSecurityGroups"
              },
              MediaConnectFlows: {
                shape: "Seo",
                locationName: "mediaConnectFlows"
              },
              Name: {
                locationName: "name"
              },
              RoleArn: {
                locationName: "roleArn"
              },
              Sources: {
                shape: "Seq",
                locationName: "sources"
              }
            },
            required: [
              "InputId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Input: {
                shape: "Sev",
                locationName: "input"
              }
            }
          }
        },
        UpdateInputDevice: {
          http: {
            method: "PUT",
            requestUri: "/prod/inputDevices/{inputDeviceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              HdDeviceSettings: {
                shape: "Sjo",
                locationName: "hdDeviceSettings"
              },
              InputDeviceId: {
                location: "uri",
                locationName: "inputDeviceId"
              },
              Name: {
                locationName: "name"
              },
              UhdDeviceSettings: {
                shape: "Sjo",
                locationName: "uhdDeviceSettings"
              }
            },
            required: [
              "InputDeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              ConnectionState: {
                locationName: "connectionState"
              },
              DeviceSettingsSyncState: {
                locationName: "deviceSettingsSyncState"
              },
              DeviceUpdateStatus: {
                locationName: "deviceUpdateStatus"
              },
              HdDeviceSettings: {
                shape: "Sh6",
                locationName: "hdDeviceSettings"
              },
              Id: {
                locationName: "id"
              },
              MacAddress: {
                locationName: "macAddress"
              },
              Name: {
                locationName: "name"
              },
              NetworkSettings: {
                shape: "Shb",
                locationName: "networkSettings"
              },
              SerialNumber: {
                locationName: "serialNumber"
              },
              Type: {
                locationName: "type"
              },
              UhdDeviceSettings: {
                shape: "She",
                locationName: "uhdDeviceSettings"
              }
            }
          }
        },
        UpdateInputSecurityGroup: {
          http: {
            method: "PUT",
            requestUri: "/prod/inputSecurityGroups/{inputSecurityGroupId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InputSecurityGroupId: {
                location: "uri",
                locationName: "inputSecurityGroupId"
              },
              Tags: {
                shape: "Se9",
                locationName: "tags"
              },
              WhitelistRules: {
                shape: "Sf7",
                locationName: "whitelistRules"
              }
            },
            required: [
              "InputSecurityGroupId"
            ]
          },
          output: {
            type: "structure",
            members: {
              SecurityGroup: {
                shape: "Sfa",
                locationName: "securityGroup"
              }
            }
          }
        },
        UpdateMultiplex: {
          http: {
            method: "PUT",
            requestUri: "/prod/multiplexes/{multiplexId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MultiplexId: {
                location: "uri",
                locationName: "multiplexId"
              },
              MultiplexSettings: {
                shape: "Sff",
                locationName: "multiplexSettings"
              },
              Name: {
                locationName: "name"
              }
            },
            required: [
              "MultiplexId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Multiplex: {
                shape: "Sfk",
                locationName: "multiplex"
              }
            }
          }
        },
        UpdateMultiplexProgram: {
          http: {
            method: "PUT",
            requestUri: "/prod/multiplexes/{multiplexId}/programs/{programName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MultiplexId: {
                location: "uri",
                locationName: "multiplexId"
              },
              MultiplexProgramSettings: {
                shape: "Sfq",
                locationName: "multiplexProgramSettings"
              },
              ProgramName: {
                location: "uri",
                locationName: "programName"
              }
            },
            required: [
              "MultiplexId",
              "ProgramName"
            ]
          },
          output: {
            type: "structure",
            members: {
              MultiplexProgram: {
                shape: "Sfz",
                locationName: "multiplexProgram"
              }
            }
          }
        },
        UpdateReservation: {
          http: {
            method: "PUT",
            requestUri: "/prod/reservations/{reservationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Name: {
                locationName: "name"
              },
              ReservationId: {
                location: "uri",
                locationName: "reservationId"
              }
            },
            required: [
              "ReservationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Reservation: {
                shape: "Siy",
                locationName: "reservation"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {}
        },
        S7: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              Code: {
                locationName: "code"
              },
              Id: {
                locationName: "id"
              },
              Message: {
                locationName: "message"
              }
            }
          }
        },
        S9: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              Id: {
                locationName: "id"
              },
              State: {
                locationName: "state"
              }
            }
          }
        },
        Sh: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ActionName: {
                locationName: "actionName"
              },
              ScheduleActionSettings: {
                locationName: "scheduleActionSettings",
                type: "structure",
                members: {
                  HlsId3SegmentTaggingSettings: {
                    locationName: "hlsId3SegmentTaggingSettings",
                    type: "structure",
                    members: {
                      Tag: {
                        locationName: "tag"
                      }
                    },
                    required: [
                      "Tag"
                    ]
                  },
                  HlsTimedMetadataSettings: {
                    locationName: "hlsTimedMetadataSettings",
                    type: "structure",
                    members: {
                      Id3: {
                        locationName: "id3"
                      }
                    },
                    required: [
                      "Id3"
                    ]
                  },
                  InputPrepareSettings: {
                    locationName: "inputPrepareSettings",
                    type: "structure",
                    members: {
                      InputAttachmentNameReference: {
                        locationName: "inputAttachmentNameReference"
                      },
                      InputClippingSettings: {
                        shape: "Sn",
                        locationName: "inputClippingSettings"
                      },
                      UrlPath: {
                        shape: "S5",
                        locationName: "urlPath"
                      }
                    }
                  },
                  InputSwitchSettings: {
                    locationName: "inputSwitchSettings",
                    type: "structure",
                    members: {
                      InputAttachmentNameReference: {
                        locationName: "inputAttachmentNameReference"
                      },
                      InputClippingSettings: {
                        shape: "Sn",
                        locationName: "inputClippingSettings"
                      },
                      UrlPath: {
                        shape: "S5",
                        locationName: "urlPath"
                      }
                    },
                    required: [
                      "InputAttachmentNameReference"
                    ]
                  },
                  MotionGraphicsImageActivateSettings: {
                    locationName: "motionGraphicsImageActivateSettings",
                    type: "structure",
                    members: {
                      Duration: {
                        locationName: "duration",
                        type: "long"
                      },
                      PasswordParam: {
                        locationName: "passwordParam"
                      },
                      Url: {
                        locationName: "url"
                      },
                      Username: {
                        locationName: "username"
                      }
                    }
                  },
                  MotionGraphicsImageDeactivateSettings: {
                    locationName: "motionGraphicsImageDeactivateSettings",
                    type: "structure",
                    members: {}
                  },
                  PauseStateSettings: {
                    locationName: "pauseStateSettings",
                    type: "structure",
                    members: {
                      Pipelines: {
                        locationName: "pipelines",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            PipelineId: {
                              locationName: "pipelineId"
                            }
                          },
                          required: [
                            "PipelineId"
                          ]
                        }
                      }
                    }
                  },
                  Scte35ReturnToNetworkSettings: {
                    locationName: "scte35ReturnToNetworkSettings",
                    type: "structure",
                    members: {
                      SpliceEventId: {
                        locationName: "spliceEventId",
                        type: "long"
                      }
                    },
                    required: [
                      "SpliceEventId"
                    ]
                  },
                  Scte35SpliceInsertSettings: {
                    locationName: "scte35SpliceInsertSettings",
                    type: "structure",
                    members: {
                      Duration: {
                        locationName: "duration",
                        type: "long"
                      },
                      SpliceEventId: {
                        locationName: "spliceEventId",
                        type: "long"
                      }
                    },
                    required: [
                      "SpliceEventId"
                    ]
                  },
                  Scte35TimeSignalSettings: {
                    locationName: "scte35TimeSignalSettings",
                    type: "structure",
                    members: {
                      Scte35Descriptors: {
                        locationName: "scte35Descriptors",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            Scte35DescriptorSettings: {
                              locationName: "scte35DescriptorSettings",
                              type: "structure",
                              members: {
                                SegmentationDescriptorScte35DescriptorSettings: {
                                  locationName: "segmentationDescriptorScte35DescriptorSettings",
                                  type: "structure",
                                  members: {
                                    DeliveryRestrictions: {
                                      locationName: "deliveryRestrictions",
                                      type: "structure",
                                      members: {
                                        ArchiveAllowedFlag: {
                                          locationName: "archiveAllowedFlag"
                                        },
                                        DeviceRestrictions: {
                                          locationName: "deviceRestrictions"
                                        },
                                        NoRegionalBlackoutFlag: {
                                          locationName: "noRegionalBlackoutFlag"
                                        },
                                        WebDeliveryAllowedFlag: {
                                          locationName: "webDeliveryAllowedFlag"
                                        }
                                      },
                                      required: [
                                        "DeviceRestrictions",
                                        "ArchiveAllowedFlag",
                                        "WebDeliveryAllowedFlag",
                                        "NoRegionalBlackoutFlag"
                                      ]
                                    },
                                    SegmentNum: {
                                      locationName: "segmentNum",
                                      type: "integer"
                                    },
                                    SegmentationCancelIndicator: {
                                      locationName: "segmentationCancelIndicator"
                                    },
                                    SegmentationDuration: {
                                      locationName: "segmentationDuration",
                                      type: "long"
                                    },
                                    SegmentationEventId: {
                                      locationName: "segmentationEventId",
                                      type: "long"
                                    },
                                    SegmentationTypeId: {
                                      locationName: "segmentationTypeId",
                                      type: "integer"
                                    },
                                    SegmentationUpid: {
                                      locationName: "segmentationUpid"
                                    },
                                    SegmentationUpidType: {
                                      locationName: "segmentationUpidType",
                                      type: "integer"
                                    },
                                    SegmentsExpected: {
                                      locationName: "segmentsExpected",
                                      type: "integer"
                                    },
                                    SubSegmentNum: {
                                      locationName: "subSegmentNum",
                                      type: "integer"
                                    },
                                    SubSegmentsExpected: {
                                      locationName: "subSegmentsExpected",
                                      type: "integer"
                                    }
                                  },
                                  required: [
                                    "SegmentationEventId",
                                    "SegmentationCancelIndicator"
                                  ]
                                }
                              },
                              required: [
                                "SegmentationDescriptorScte35DescriptorSettings"
                              ]
                            }
                          },
                          required: [
                            "Scte35DescriptorSettings"
                          ]
                        }
                      }
                    },
                    required: [
                      "Scte35Descriptors"
                    ]
                  },
                  StaticImageActivateSettings: {
                    locationName: "staticImageActivateSettings",
                    type: "structure",
                    members: {
                      Duration: {
                        locationName: "duration",
                        type: "integer"
                      },
                      FadeIn: {
                        locationName: "fadeIn",
                        type: "integer"
                      },
                      FadeOut: {
                        locationName: "fadeOut",
                        type: "integer"
                      },
                      Height: {
                        locationName: "height",
                        type: "integer"
                      },
                      Image: {
                        shape: "S1k",
                        locationName: "image"
                      },
                      ImageX: {
                        locationName: "imageX",
                        type: "integer"
                      },
                      ImageY: {
                        locationName: "imageY",
                        type: "integer"
                      },
                      Layer: {
                        locationName: "layer",
                        type: "integer"
                      },
                      Opacity: {
                        locationName: "opacity",
                        type: "integer"
                      },
                      Width: {
                        locationName: "width",
                        type: "integer"
                      }
                    },
                    required: [
                      "Image"
                    ]
                  },
                  StaticImageDeactivateSettings: {
                    locationName: "staticImageDeactivateSettings",
                    type: "structure",
                    members: {
                      FadeOut: {
                        locationName: "fadeOut",
                        type: "integer"
                      },
                      Layer: {
                        locationName: "layer",
                        type: "integer"
                      }
                    }
                  }
                }
              },
              ScheduleActionStartSettings: {
                locationName: "scheduleActionStartSettings",
                type: "structure",
                members: {
                  FixedModeScheduleActionStartSettings: {
                    locationName: "fixedModeScheduleActionStartSettings",
                    type: "structure",
                    members: {
                      Time: {
                        locationName: "time"
                      }
                    },
                    required: [
                      "Time"
                    ]
                  },
                  FollowModeScheduleActionStartSettings: {
                    locationName: "followModeScheduleActionStartSettings",
                    type: "structure",
                    members: {
                      FollowPoint: {
                        locationName: "followPoint"
                      },
                      ReferenceActionName: {
                        locationName: "referenceActionName"
                      }
                    },
                    required: [
                      "ReferenceActionName",
                      "FollowPoint"
                    ]
                  },
                  ImmediateModeScheduleActionStartSettings: {
                    locationName: "immediateModeScheduleActionStartSettings",
                    type: "structure",
                    members: {}
                  }
                }
              }
            },
            required: [
              "ActionName",
              "ScheduleActionStartSettings",
              "ScheduleActionSettings"
            ]
          }
        },
        Sn: {
          type: "structure",
          members: {
            InputTimecodeSource: {
              locationName: "inputTimecodeSource"
            },
            StartTimecode: {
              locationName: "startTimecode",
              type: "structure",
              members: {
                Timecode: {
                  locationName: "timecode"
                }
              }
            },
            StopTimecode: {
              locationName: "stopTimecode",
              type: "structure",
              members: {
                LastFrameClippingBehavior: {
                  locationName: "lastFrameClippingBehavior"
                },
                Timecode: {
                  locationName: "timecode"
                }
              }
            }
          },
          required: [
            "InputTimecodeSource"
          ]
        },
        S1k: {
          type: "structure",
          members: {
            PasswordParam: {
              locationName: "passwordParam"
            },
            Uri: {
              locationName: "uri"
            },
            Username: {
              locationName: "username"
            }
          },
          required: [
            "Uri"
          ]
        },
        S22: {
          type: "structure",
          members: {
            Resolution: {
              locationName: "resolution"
            }
          }
        },
        S25: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {
                locationName: "id"
              },
              MediaPackageSettings: {
                locationName: "mediaPackageSettings",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ChannelId: {
                      locationName: "channelId"
                    }
                  }
                }
              },
              MultiplexSettings: {
                locationName: "multiplexSettings",
                type: "structure",
                members: {
                  MultiplexId: {
                    locationName: "multiplexId"
                  },
                  ProgramName: {
                    locationName: "programName"
                  }
                }
              },
              Settings: {
                locationName: "settings",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PasswordParam: {
                      locationName: "passwordParam"
                    },
                    StreamName: {
                      locationName: "streamName"
                    },
                    Url: {
                      locationName: "url"
                    },
                    Username: {
                      locationName: "username"
                    }
                  }
                }
              }
            }
          }
        },
        S2d: {
          type: "structure",
          members: {
            AudioDescriptions: {
              locationName: "audioDescriptions",
              type: "list",
              member: {
                type: "structure",
                members: {
                  AudioNormalizationSettings: {
                    locationName: "audioNormalizationSettings",
                    type: "structure",
                    members: {
                      Algorithm: {
                        locationName: "algorithm"
                      },
                      AlgorithmControl: {
                        locationName: "algorithmControl"
                      },
                      TargetLkfs: {
                        locationName: "targetLkfs",
                        type: "double"
                      }
                    }
                  },
                  AudioSelectorName: {
                    locationName: "audioSelectorName"
                  },
                  AudioType: {
                    locationName: "audioType"
                  },
                  AudioTypeControl: {
                    locationName: "audioTypeControl"
                  },
                  AudioWatermarkingSettings: {
                    locationName: "audioWatermarkingSettings",
                    type: "structure",
                    members: {
                      NielsenWatermarksSettings: {
                        locationName: "nielsenWatermarksSettings",
                        type: "structure",
                        members: {
                          NielsenCbetSettings: {
                            locationName: "nielsenCbetSettings",
                            type: "structure",
                            members: {
                              CbetCheckDigitString: {
                                locationName: "cbetCheckDigitString"
                              },
                              CbetStepaside: {
                                locationName: "cbetStepaside"
                              },
                              Csid: {
                                locationName: "csid"
                              }
                            },
                            required: [
                              "CbetCheckDigitString",
                              "CbetStepaside",
                              "Csid"
                            ]
                          },
                          NielsenDistributionType: {
                            locationName: "nielsenDistributionType"
                          },
                          NielsenNaesIiNwSettings: {
                            locationName: "nielsenNaesIiNwSettings",
                            type: "structure",
                            members: {
                              CheckDigitString: {
                                locationName: "checkDigitString"
                              },
                              Sid: {
                                locationName: "sid",
                                type: "double"
                              }
                            },
                            required: [
                              "CheckDigitString",
                              "Sid"
                            ]
                          }
                        }
                      }
                    }
                  },
                  CodecSettings: {
                    locationName: "codecSettings",
                    type: "structure",
                    members: {
                      AacSettings: {
                        locationName: "aacSettings",
                        type: "structure",
                        members: {
                          Bitrate: {
                            locationName: "bitrate",
                            type: "double"
                          },
                          CodingMode: {
                            locationName: "codingMode"
                          },
                          InputType: {
                            locationName: "inputType"
                          },
                          Profile: {
                            locationName: "profile"
                          },
                          RateControlMode: {
                            locationName: "rateControlMode"
                          },
                          RawFormat: {
                            locationName: "rawFormat"
                          },
                          SampleRate: {
                            locationName: "sampleRate",
                            type: "double"
                          },
                          Spec: {
                            locationName: "spec"
                          },
                          VbrQuality: {
                            locationName: "vbrQuality"
                          }
                        }
                      },
                      Ac3Settings: {
                        locationName: "ac3Settings",
                        type: "structure",
                        members: {
                          Bitrate: {
                            locationName: "bitrate",
                            type: "double"
                          },
                          BitstreamMode: {
                            locationName: "bitstreamMode"
                          },
                          CodingMode: {
                            locationName: "codingMode"
                          },
                          Dialnorm: {
                            locationName: "dialnorm",
                            type: "integer"
                          },
                          DrcProfile: {
                            locationName: "drcProfile"
                          },
                          LfeFilter: {
                            locationName: "lfeFilter"
                          },
                          MetadataControl: {
                            locationName: "metadataControl"
                          }
                        }
                      },
                      Eac3Settings: {
                        locationName: "eac3Settings",
                        type: "structure",
                        members: {
                          AttenuationControl: {
                            locationName: "attenuationControl"
                          },
                          Bitrate: {
                            locationName: "bitrate",
                            type: "double"
                          },
                          BitstreamMode: {
                            locationName: "bitstreamMode"
                          },
                          CodingMode: {
                            locationName: "codingMode"
                          },
                          DcFilter: {
                            locationName: "dcFilter"
                          },
                          Dialnorm: {
                            locationName: "dialnorm",
                            type: "integer"
                          },
                          DrcLine: {
                            locationName: "drcLine"
                          },
                          DrcRf: {
                            locationName: "drcRf"
                          },
                          LfeControl: {
                            locationName: "lfeControl"
                          },
                          LfeFilter: {
                            locationName: "lfeFilter"
                          },
                          LoRoCenterMixLevel: {
                            locationName: "loRoCenterMixLevel",
                            type: "double"
                          },
                          LoRoSurroundMixLevel: {
                            locationName: "loRoSurroundMixLevel",
                            type: "double"
                          },
                          LtRtCenterMixLevel: {
                            locationName: "ltRtCenterMixLevel",
                            type: "double"
                          },
                          LtRtSurroundMixLevel: {
                            locationName: "ltRtSurroundMixLevel",
                            type: "double"
                          },
                          MetadataControl: {
                            locationName: "metadataControl"
                          },
                          PassthroughControl: {
                            locationName: "passthroughControl"
                          },
                          PhaseControl: {
                            locationName: "phaseControl"
                          },
                          StereoDownmix: {
                            locationName: "stereoDownmix"
                          },
                          SurroundExMode: {
                            locationName: "surroundExMode"
                          },
                          SurroundMode: {
                            locationName: "surroundMode"
                          }
                        }
                      },
                      Mp2Settings: {
                        locationName: "mp2Settings",
                        type: "structure",
                        members: {
                          Bitrate: {
                            locationName: "bitrate",
                            type: "double"
                          },
                          CodingMode: {
                            locationName: "codingMode"
                          },
                          SampleRate: {
                            locationName: "sampleRate",
                            type: "double"
                          }
                        }
                      },
                      PassThroughSettings: {
                        locationName: "passThroughSettings",
                        type: "structure",
                        members: {}
                      },
                      WavSettings: {
                        locationName: "wavSettings",
                        type: "structure",
                        members: {
                          BitDepth: {
                            locationName: "bitDepth",
                            type: "double"
                          },
                          CodingMode: {
                            locationName: "codingMode"
                          },
                          SampleRate: {
                            locationName: "sampleRate",
                            type: "double"
                          }
                        }
                      }
                    }
                  },
                  LanguageCode: {
                    locationName: "languageCode"
                  },
                  LanguageCodeControl: {
                    locationName: "languageCodeControl"
                  },
                  Name: {
                    locationName: "name"
                  },
                  RemixSettings: {
                    locationName: "remixSettings",
                    type: "structure",
                    members: {
                      ChannelMappings: {
                        locationName: "channelMappings",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            InputChannelLevels: {
                              locationName: "inputChannelLevels",
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  Gain: {
                                    locationName: "gain",
                                    type: "integer"
                                  },
                                  InputChannel: {
                                    locationName: "inputChannel",
                                    type: "integer"
                                  }
                                },
                                required: [
                                  "InputChannel",
                                  "Gain"
                                ]
                              }
                            },
                            OutputChannel: {
                              locationName: "outputChannel",
                              type: "integer"
                            }
                          },
                          required: [
                            "OutputChannel",
                            "InputChannelLevels"
                          ]
                        }
                      },
                      ChannelsIn: {
                        locationName: "channelsIn",
                        type: "integer"
                      },
                      ChannelsOut: {
                        locationName: "channelsOut",
                        type: "integer"
                      }
                    },
                    required: [
                      "ChannelMappings"
                    ]
                  },
                  StreamName: {
                    locationName: "streamName"
                  }
                },
                required: [
                  "AudioSelectorName",
                  "Name"
                ]
              }
            },
            AvailBlanking: {
              locationName: "availBlanking",
              type: "structure",
              members: {
                AvailBlankingImage: {
                  shape: "S1k",
                  locationName: "availBlankingImage"
                },
                State: {
                  locationName: "state"
                }
              }
            },
            AvailConfiguration: {
              locationName: "availConfiguration",
              type: "structure",
              members: {
                AvailSettings: {
                  locationName: "availSettings",
                  type: "structure",
                  members: {
                    Scte35SpliceInsert: {
                      locationName: "scte35SpliceInsert",
                      type: "structure",
                      members: {
                        AdAvailOffset: {
                          locationName: "adAvailOffset",
                          type: "integer"
                        },
                        NoRegionalBlackoutFlag: {
                          locationName: "noRegionalBlackoutFlag"
                        },
                        WebDeliveryAllowedFlag: {
                          locationName: "webDeliveryAllowedFlag"
                        }
                      }
                    },
                    Scte35TimeSignalApos: {
                      locationName: "scte35TimeSignalApos",
                      type: "structure",
                      members: {
                        AdAvailOffset: {
                          locationName: "adAvailOffset",
                          type: "integer"
                        },
                        NoRegionalBlackoutFlag: {
                          locationName: "noRegionalBlackoutFlag"
                        },
                        WebDeliveryAllowedFlag: {
                          locationName: "webDeliveryAllowedFlag"
                        }
                      }
                    }
                  }
                }
              }
            },
            BlackoutSlate: {
              locationName: "blackoutSlate",
              type: "structure",
              members: {
                BlackoutSlateImage: {
                  shape: "S1k",
                  locationName: "blackoutSlateImage"
                },
                NetworkEndBlackout: {
                  locationName: "networkEndBlackout"
                },
                NetworkEndBlackoutImage: {
                  shape: "S1k",
                  locationName: "networkEndBlackoutImage"
                },
                NetworkId: {
                  locationName: "networkId"
                },
                State: {
                  locationName: "state"
                }
              }
            },
            CaptionDescriptions: {
              locationName: "captionDescriptions",
              type: "list",
              member: {
                type: "structure",
                members: {
                  CaptionSelectorName: {
                    locationName: "captionSelectorName"
                  },
                  DestinationSettings: {
                    locationName: "destinationSettings",
                    type: "structure",
                    members: {
                      AribDestinationSettings: {
                        locationName: "aribDestinationSettings",
                        type: "structure",
                        members: {}
                      },
                      BurnInDestinationSettings: {
                        locationName: "burnInDestinationSettings",
                        type: "structure",
                        members: {
                          Alignment: {
                            locationName: "alignment"
                          },
                          BackgroundColor: {
                            locationName: "backgroundColor"
                          },
                          BackgroundOpacity: {
                            locationName: "backgroundOpacity",
                            type: "integer"
                          },
                          Font: {
                            shape: "S1k",
                            locationName: "font"
                          },
                          FontColor: {
                            locationName: "fontColor"
                          },
                          FontOpacity: {
                            locationName: "fontOpacity",
                            type: "integer"
                          },
                          FontResolution: {
                            locationName: "fontResolution",
                            type: "integer"
                          },
                          FontSize: {
                            locationName: "fontSize"
                          },
                          OutlineColor: {
                            locationName: "outlineColor"
                          },
                          OutlineSize: {
                            locationName: "outlineSize",
                            type: "integer"
                          },
                          ShadowColor: {
                            locationName: "shadowColor"
                          },
                          ShadowOpacity: {
                            locationName: "shadowOpacity",
                            type: "integer"
                          },
                          ShadowXOffset: {
                            locationName: "shadowXOffset",
                            type: "integer"
                          },
                          ShadowYOffset: {
                            locationName: "shadowYOffset",
                            type: "integer"
                          },
                          TeletextGridControl: {
                            locationName: "teletextGridControl"
                          },
                          XPosition: {
                            locationName: "xPosition",
                            type: "integer"
                          },
                          YPosition: {
                            locationName: "yPosition",
                            type: "integer"
                          }
                        }
                      },
                      DvbSubDestinationSettings: {
                        locationName: "dvbSubDestinationSettings",
                        type: "structure",
                        members: {
                          Alignment: {
                            locationName: "alignment"
                          },
                          BackgroundColor: {
                            locationName: "backgroundColor"
                          },
                          BackgroundOpacity: {
                            locationName: "backgroundOpacity",
                            type: "integer"
                          },
                          Font: {
                            shape: "S1k",
                            locationName: "font"
                          },
                          FontColor: {
                            locationName: "fontColor"
                          },
                          FontOpacity: {
                            locationName: "fontOpacity",
                            type: "integer"
                          },
                          FontResolution: {
                            locationName: "fontResolution",
                            type: "integer"
                          },
                          FontSize: {
                            locationName: "fontSize"
                          },
                          OutlineColor: {
                            locationName: "outlineColor"
                          },
                          OutlineSize: {
                            locationName: "outlineSize",
                            type: "integer"
                          },
                          ShadowColor: {
                            locationName: "shadowColor"
                          },
                          ShadowOpacity: {
                            locationName: "shadowOpacity",
                            type: "integer"
                          },
                          ShadowXOffset: {
                            locationName: "shadowXOffset",
                            type: "integer"
                          },
                          ShadowYOffset: {
                            locationName: "shadowYOffset",
                            type: "integer"
                          },
                          TeletextGridControl: {
                            locationName: "teletextGridControl"
                          },
                          XPosition: {
                            locationName: "xPosition",
                            type: "integer"
                          },
                          YPosition: {
                            locationName: "yPosition",
                            type: "integer"
                          }
                        }
                      },
                      EbuTtDDestinationSettings: {
                        locationName: "ebuTtDDestinationSettings",
                        type: "structure",
                        members: {
                          CopyrightHolder: {
                            locationName: "copyrightHolder"
                          },
                          FillLineGap: {
                            locationName: "fillLineGap"
                          },
                          FontFamily: {
                            locationName: "fontFamily"
                          },
                          StyleControl: {
                            locationName: "styleControl"
                          }
                        }
                      },
                      EmbeddedDestinationSettings: {
                        locationName: "embeddedDestinationSettings",
                        type: "structure",
                        members: {}
                      },
                      EmbeddedPlusScte20DestinationSettings: {
                        locationName: "embeddedPlusScte20DestinationSettings",
                        type: "structure",
                        members: {}
                      },
                      RtmpCaptionInfoDestinationSettings: {
                        locationName: "rtmpCaptionInfoDestinationSettings",
                        type: "structure",
                        members: {}
                      },
                      Scte20PlusEmbeddedDestinationSettings: {
                        locationName: "scte20PlusEmbeddedDestinationSettings",
                        type: "structure",
                        members: {}
                      },
                      Scte27DestinationSettings: {
                        locationName: "scte27DestinationSettings",
                        type: "structure",
                        members: {}
                      },
                      SmpteTtDestinationSettings: {
                        locationName: "smpteTtDestinationSettings",
                        type: "structure",
                        members: {}
                      },
                      TeletextDestinationSettings: {
                        locationName: "teletextDestinationSettings",
                        type: "structure",
                        members: {}
                      },
                      TtmlDestinationSettings: {
                        locationName: "ttmlDestinationSettings",
                        type: "structure",
                        members: {
                          StyleControl: {
                            locationName: "styleControl"
                          }
                        }
                      },
                      WebvttDestinationSettings: {
                        locationName: "webvttDestinationSettings",
                        type: "structure",
                        members: {
                          StyleControl: {
                            locationName: "styleControl"
                          }
                        }
                      }
                    }
                  },
                  LanguageCode: {
                    locationName: "languageCode"
                  },
                  LanguageDescription: {
                    locationName: "languageDescription"
                  },
                  Name: {
                    locationName: "name"
                  }
                },
                required: [
                  "CaptionSelectorName",
                  "Name"
                ]
              }
            },
            FeatureActivations: {
              locationName: "featureActivations",
              type: "structure",
              members: {
                InputPrepareScheduleActions: {
                  locationName: "inputPrepareScheduleActions"
                }
              }
            },
            GlobalConfiguration: {
              locationName: "globalConfiguration",
              type: "structure",
              members: {
                InitialAudioGain: {
                  locationName: "initialAudioGain",
                  type: "integer"
                },
                InputEndAction: {
                  locationName: "inputEndAction"
                },
                InputLossBehavior: {
                  locationName: "inputLossBehavior",
                  type: "structure",
                  members: {
                    BlackFrameMsec: {
                      locationName: "blackFrameMsec",
                      type: "integer"
                    },
                    InputLossImageColor: {
                      locationName: "inputLossImageColor"
                    },
                    InputLossImageSlate: {
                      shape: "S1k",
                      locationName: "inputLossImageSlate"
                    },
                    InputLossImageType: {
                      locationName: "inputLossImageType"
                    },
                    RepeatFrameMsec: {
                      locationName: "repeatFrameMsec",
                      type: "integer"
                    }
                  }
                },
                OutputLockingMode: {
                  locationName: "outputLockingMode"
                },
                OutputTimingSource: {
                  locationName: "outputTimingSource"
                },
                SupportLowFramerateInputs: {
                  locationName: "supportLowFramerateInputs"
                }
              }
            },
            MotionGraphicsConfiguration: {
              locationName: "motionGraphicsConfiguration",
              type: "structure",
              members: {
                MotionGraphicsInsertion: {
                  locationName: "motionGraphicsInsertion"
                },
                MotionGraphicsSettings: {
                  locationName: "motionGraphicsSettings",
                  type: "structure",
                  members: {
                    HtmlMotionGraphicsSettings: {
                      locationName: "htmlMotionGraphicsSettings",
                      type: "structure",
                      members: {}
                    }
                  }
                }
              },
              required: [
                "MotionGraphicsSettings"
              ]
            },
            NielsenConfiguration: {
              locationName: "nielsenConfiguration",
              type: "structure",
              members: {
                DistributorId: {
                  locationName: "distributorId"
                },
                NielsenPcmToId3Tagging: {
                  locationName: "nielsenPcmToId3Tagging"
                }
              }
            },
            OutputGroups: {
              locationName: "outputGroups",
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {
                    locationName: "name"
                  },
                  OutputGroupSettings: {
                    locationName: "outputGroupSettings",
                    type: "structure",
                    members: {
                      ArchiveGroupSettings: {
                        locationName: "archiveGroupSettings",
                        type: "structure",
                        members: {
                          ArchiveCdnSettings: {
                            locationName: "archiveCdnSettings",
                            type: "structure",
                            members: {
                              ArchiveS3Settings: {
                                locationName: "archiveS3Settings",
                                type: "structure",
                                members: {
                                  CannedAcl: {
                                    locationName: "cannedAcl"
                                  }
                                }
                              }
                            }
                          },
                          Destination: {
                            shape: "S6c",
                            locationName: "destination"
                          },
                          RolloverInterval: {
                            locationName: "rolloverInterval",
                            type: "integer"
                          }
                        },
                        required: [
                          "Destination"
                        ]
                      },
                      FrameCaptureGroupSettings: {
                        locationName: "frameCaptureGroupSettings",
                        type: "structure",
                        members: {
                          Destination: {
                            shape: "S6c",
                            locationName: "destination"
                          },
                          FrameCaptureCdnSettings: {
                            locationName: "frameCaptureCdnSettings",
                            type: "structure",
                            members: {
                              FrameCaptureS3Settings: {
                                locationName: "frameCaptureS3Settings",
                                type: "structure",
                                members: {
                                  CannedAcl: {
                                    locationName: "cannedAcl"
                                  }
                                }
                              }
                            }
                          }
                        },
                        required: [
                          "Destination"
                        ]
                      },
                      HlsGroupSettings: {
                        locationName: "hlsGroupSettings",
                        type: "structure",
                        members: {
                          AdMarkers: {
                            locationName: "adMarkers",
                            type: "list",
                            member: {}
                          },
                          BaseUrlContent: {
                            locationName: "baseUrlContent"
                          },
                          BaseUrlContent1: {
                            locationName: "baseUrlContent1"
                          },
                          BaseUrlManifest: {
                            locationName: "baseUrlManifest"
                          },
                          BaseUrlManifest1: {
                            locationName: "baseUrlManifest1"
                          },
                          CaptionLanguageMappings: {
                            locationName: "captionLanguageMappings",
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                CaptionChannel: {
                                  locationName: "captionChannel",
                                  type: "integer"
                                },
                                LanguageCode: {
                                  locationName: "languageCode"
                                },
                                LanguageDescription: {
                                  locationName: "languageDescription"
                                }
                              },
                              required: [
                                "LanguageCode",
                                "LanguageDescription",
                                "CaptionChannel"
                              ]
                            }
                          },
                          CaptionLanguageSetting: {
                            locationName: "captionLanguageSetting"
                          },
                          ClientCache: {
                            locationName: "clientCache"
                          },
                          CodecSpecification: {
                            locationName: "codecSpecification"
                          },
                          ConstantIv: {
                            locationName: "constantIv"
                          },
                          Destination: {
                            shape: "S6c",
                            locationName: "destination"
                          },
                          DirectoryStructure: {
                            locationName: "directoryStructure"
                          },
                          DiscontinuityTags: {
                            locationName: "discontinuityTags"
                          },
                          EncryptionType: {
                            locationName: "encryptionType"
                          },
                          HlsCdnSettings: {
                            locationName: "hlsCdnSettings",
                            type: "structure",
                            members: {
                              HlsAkamaiSettings: {
                                locationName: "hlsAkamaiSettings",
                                type: "structure",
                                members: {
                                  ConnectionRetryInterval: {
                                    locationName: "connectionRetryInterval",
                                    type: "integer"
                                  },
                                  FilecacheDuration: {
                                    locationName: "filecacheDuration",
                                    type: "integer"
                                  },
                                  HttpTransferMode: {
                                    locationName: "httpTransferMode"
                                  },
                                  NumRetries: {
                                    locationName: "numRetries",
                                    type: "integer"
                                  },
                                  RestartDelay: {
                                    locationName: "restartDelay",
                                    type: "integer"
                                  },
                                  Salt: {
                                    locationName: "salt"
                                  },
                                  Token: {
                                    locationName: "token"
                                  }
                                }
                              },
                              HlsBasicPutSettings: {
                                locationName: "hlsBasicPutSettings",
                                type: "structure",
                                members: {
                                  ConnectionRetryInterval: {
                                    locationName: "connectionRetryInterval",
                                    type: "integer"
                                  },
                                  FilecacheDuration: {
                                    locationName: "filecacheDuration",
                                    type: "integer"
                                  },
                                  NumRetries: {
                                    locationName: "numRetries",
                                    type: "integer"
                                  },
                                  RestartDelay: {
                                    locationName: "restartDelay",
                                    type: "integer"
                                  }
                                }
                              },
                              HlsMediaStoreSettings: {
                                locationName: "hlsMediaStoreSettings",
                                type: "structure",
                                members: {
                                  ConnectionRetryInterval: {
                                    locationName: "connectionRetryInterval",
                                    type: "integer"
                                  },
                                  FilecacheDuration: {
                                    locationName: "filecacheDuration",
                                    type: "integer"
                                  },
                                  MediaStoreStorageClass: {
                                    locationName: "mediaStoreStorageClass"
                                  },
                                  NumRetries: {
                                    locationName: "numRetries",
                                    type: "integer"
                                  },
                                  RestartDelay: {
                                    locationName: "restartDelay",
                                    type: "integer"
                                  }
                                }
                              },
                              HlsS3Settings: {
                                locationName: "hlsS3Settings",
                                type: "structure",
                                members: {
                                  CannedAcl: {
                                    locationName: "cannedAcl"
                                  }
                                }
                              },
                              HlsWebdavSettings: {
                                locationName: "hlsWebdavSettings",
                                type: "structure",
                                members: {
                                  ConnectionRetryInterval: {
                                    locationName: "connectionRetryInterval",
                                    type: "integer"
                                  },
                                  FilecacheDuration: {
                                    locationName: "filecacheDuration",
                                    type: "integer"
                                  },
                                  HttpTransferMode: {
                                    locationName: "httpTransferMode"
                                  },
                                  NumRetries: {
                                    locationName: "numRetries",
                                    type: "integer"
                                  },
                                  RestartDelay: {
                                    locationName: "restartDelay",
                                    type: "integer"
                                  }
                                }
                              }
                            }
                          },
                          HlsId3SegmentTagging: {
                            locationName: "hlsId3SegmentTagging"
                          },
                          IFrameOnlyPlaylists: {
                            locationName: "iFrameOnlyPlaylists"
                          },
                          IncompleteSegmentBehavior: {
                            locationName: "incompleteSegmentBehavior"
                          },
                          IndexNSegments: {
                            locationName: "indexNSegments",
                            type: "integer"
                          },
                          InputLossAction: {
                            locationName: "inputLossAction"
                          },
                          IvInManifest: {
                            locationName: "ivInManifest"
                          },
                          IvSource: {
                            locationName: "ivSource"
                          },
                          KeepSegments: {
                            locationName: "keepSegments",
                            type: "integer"
                          },
                          KeyFormat: {
                            locationName: "keyFormat"
                          },
                          KeyFormatVersions: {
                            locationName: "keyFormatVersions"
                          },
                          KeyProviderSettings: {
                            locationName: "keyProviderSettings",
                            type: "structure",
                            members: {
                              StaticKeySettings: {
                                locationName: "staticKeySettings",
                                type: "structure",
                                members: {
                                  KeyProviderServer: {
                                    shape: "S1k",
                                    locationName: "keyProviderServer"
                                  },
                                  StaticKeyValue: {
                                    locationName: "staticKeyValue"
                                  }
                                },
                                required: [
                                  "StaticKeyValue"
                                ]
                              }
                            }
                          },
                          ManifestCompression: {
                            locationName: "manifestCompression"
                          },
                          ManifestDurationFormat: {
                            locationName: "manifestDurationFormat"
                          },
                          MinSegmentLength: {
                            locationName: "minSegmentLength",
                            type: "integer"
                          },
                          Mode: {
                            locationName: "mode"
                          },
                          OutputSelection: {
                            locationName: "outputSelection"
                          },
                          ProgramDateTime: {
                            locationName: "programDateTime"
                          },
                          ProgramDateTimePeriod: {
                            locationName: "programDateTimePeriod",
                            type: "integer"
                          },
                          RedundantManifest: {
                            locationName: "redundantManifest"
                          },
                          SegmentLength: {
                            locationName: "segmentLength",
                            type: "integer"
                          },
                          SegmentationMode: {
                            locationName: "segmentationMode"
                          },
                          SegmentsPerSubdirectory: {
                            locationName: "segmentsPerSubdirectory",
                            type: "integer"
                          },
                          StreamInfResolution: {
                            locationName: "streamInfResolution"
                          },
                          TimedMetadataId3Frame: {
                            locationName: "timedMetadataId3Frame"
                          },
                          TimedMetadataId3Period: {
                            locationName: "timedMetadataId3Period",
                            type: "integer"
                          },
                          TimestampDeltaMilliseconds: {
                            locationName: "timestampDeltaMilliseconds",
                            type: "integer"
                          },
                          TsFileMode: {
                            locationName: "tsFileMode"
                          }
                        },
                        required: [
                          "Destination"
                        ]
                      },
                      MediaPackageGroupSettings: {
                        locationName: "mediaPackageGroupSettings",
                        type: "structure",
                        members: {
                          Destination: {
                            shape: "S6c",
                            locationName: "destination"
                          }
                        },
                        required: [
                          "Destination"
                        ]
                      },
                      MsSmoothGroupSettings: {
                        locationName: "msSmoothGroupSettings",
                        type: "structure",
                        members: {
                          AcquisitionPointId: {
                            locationName: "acquisitionPointId"
                          },
                          AudioOnlyTimecodeControl: {
                            locationName: "audioOnlyTimecodeControl"
                          },
                          CertificateMode: {
                            locationName: "certificateMode"
                          },
                          ConnectionRetryInterval: {
                            locationName: "connectionRetryInterval",
                            type: "integer"
                          },
                          Destination: {
                            shape: "S6c",
                            locationName: "destination"
                          },
                          EventId: {
                            locationName: "eventId"
                          },
                          EventIdMode: {
                            locationName: "eventIdMode"
                          },
                          EventStopBehavior: {
                            locationName: "eventStopBehavior"
                          },
                          FilecacheDuration: {
                            locationName: "filecacheDuration",
                            type: "integer"
                          },
                          FragmentLength: {
                            locationName: "fragmentLength",
                            type: "integer"
                          },
                          InputLossAction: {
                            locationName: "inputLossAction"
                          },
                          NumRetries: {
                            locationName: "numRetries",
                            type: "integer"
                          },
                          RestartDelay: {
                            locationName: "restartDelay",
                            type: "integer"
                          },
                          SegmentationMode: {
                            locationName: "segmentationMode"
                          },
                          SendDelayMs: {
                            locationName: "sendDelayMs",
                            type: "integer"
                          },
                          SparseTrackType: {
                            locationName: "sparseTrackType"
                          },
                          StreamManifestBehavior: {
                            locationName: "streamManifestBehavior"
                          },
                          TimestampOffset: {
                            locationName: "timestampOffset"
                          },
                          TimestampOffsetMode: {
                            locationName: "timestampOffsetMode"
                          }
                        },
                        required: [
                          "Destination"
                        ]
                      },
                      MultiplexGroupSettings: {
                        locationName: "multiplexGroupSettings",
                        type: "structure",
                        members: {}
                      },
                      RtmpGroupSettings: {
                        locationName: "rtmpGroupSettings",
                        type: "structure",
                        members: {
                          AdMarkers: {
                            locationName: "adMarkers",
                            type: "list",
                            member: {}
                          },
                          AuthenticationScheme: {
                            locationName: "authenticationScheme"
                          },
                          CacheFullBehavior: {
                            locationName: "cacheFullBehavior"
                          },
                          CacheLength: {
                            locationName: "cacheLength",
                            type: "integer"
                          },
                          CaptionData: {
                            locationName: "captionData"
                          },
                          InputLossAction: {
                            locationName: "inputLossAction"
                          },
                          RestartDelay: {
                            locationName: "restartDelay",
                            type: "integer"
                          }
                        }
                      },
                      UdpGroupSettings: {
                        locationName: "udpGroupSettings",
                        type: "structure",
                        members: {
                          InputLossAction: {
                            locationName: "inputLossAction"
                          },
                          TimedMetadataId3Frame: {
                            locationName: "timedMetadataId3Frame"
                          },
                          TimedMetadataId3Period: {
                            locationName: "timedMetadataId3Period",
                            type: "integer"
                          }
                        }
                      }
                    }
                  },
                  Outputs: {
                    locationName: "outputs",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        AudioDescriptionNames: {
                          shape: "S5",
                          locationName: "audioDescriptionNames"
                        },
                        CaptionDescriptionNames: {
                          shape: "S5",
                          locationName: "captionDescriptionNames"
                        },
                        OutputName: {
                          locationName: "outputName"
                        },
                        OutputSettings: {
                          locationName: "outputSettings",
                          type: "structure",
                          members: {
                            ArchiveOutputSettings: {
                              locationName: "archiveOutputSettings",
                              type: "structure",
                              members: {
                                ContainerSettings: {
                                  locationName: "containerSettings",
                                  type: "structure",
                                  members: {
                                    M2tsSettings: {
                                      shape: "S8i",
                                      locationName: "m2tsSettings"
                                    },
                                    RawSettings: {
                                      locationName: "rawSettings",
                                      type: "structure",
                                      members: {}
                                    }
                                  }
                                },
                                Extension: {
                                  locationName: "extension"
                                },
                                NameModifier: {
                                  locationName: "nameModifier"
                                }
                              },
                              required: [
                                "ContainerSettings"
                              ]
                            },
                            FrameCaptureOutputSettings: {
                              locationName: "frameCaptureOutputSettings",
                              type: "structure",
                              members: {
                                NameModifier: {
                                  locationName: "nameModifier"
                                }
                              }
                            },
                            HlsOutputSettings: {
                              locationName: "hlsOutputSettings",
                              type: "structure",
                              members: {
                                H265PackagingType: {
                                  locationName: "h265PackagingType"
                                },
                                HlsSettings: {
                                  locationName: "hlsSettings",
                                  type: "structure",
                                  members: {
                                    AudioOnlyHlsSettings: {
                                      locationName: "audioOnlyHlsSettings",
                                      type: "structure",
                                      members: {
                                        AudioGroupId: {
                                          locationName: "audioGroupId"
                                        },
                                        AudioOnlyImage: {
                                          shape: "S1k",
                                          locationName: "audioOnlyImage"
                                        },
                                        AudioTrackType: {
                                          locationName: "audioTrackType"
                                        },
                                        SegmentType: {
                                          locationName: "segmentType"
                                        }
                                      }
                                    },
                                    Fmp4HlsSettings: {
                                      locationName: "fmp4HlsSettings",
                                      type: "structure",
                                      members: {
                                        AudioRenditionSets: {
                                          locationName: "audioRenditionSets"
                                        },
                                        NielsenId3Behavior: {
                                          locationName: "nielsenId3Behavior"
                                        },
                                        TimedMetadataBehavior: {
                                          locationName: "timedMetadataBehavior"
                                        }
                                      }
                                    },
                                    FrameCaptureHlsSettings: {
                                      locationName: "frameCaptureHlsSettings",
                                      type: "structure",
                                      members: {}
                                    },
                                    StandardHlsSettings: {
                                      locationName: "standardHlsSettings",
                                      type: "structure",
                                      members: {
                                        AudioRenditionSets: {
                                          locationName: "audioRenditionSets"
                                        },
                                        M3u8Settings: {
                                          locationName: "m3u8Settings",
                                          type: "structure",
                                          members: {
                                            AudioFramesPerPes: {
                                              locationName: "audioFramesPerPes",
                                              type: "integer"
                                            },
                                            AudioPids: {
                                              locationName: "audioPids"
                                            },
                                            EcmPid: {
                                              locationName: "ecmPid"
                                            },
                                            NielsenId3Behavior: {
                                              locationName: "nielsenId3Behavior"
                                            },
                                            PatInterval: {
                                              locationName: "patInterval",
                                              type: "integer"
                                            },
                                            PcrControl: {
                                              locationName: "pcrControl"
                                            },
                                            PcrPeriod: {
                                              locationName: "pcrPeriod",
                                              type: "integer"
                                            },
                                            PcrPid: {
                                              locationName: "pcrPid"
                                            },
                                            PmtInterval: {
                                              locationName: "pmtInterval",
                                              type: "integer"
                                            },
                                            PmtPid: {
                                              locationName: "pmtPid"
                                            },
                                            ProgramNum: {
                                              locationName: "programNum",
                                              type: "integer"
                                            },
                                            Scte35Behavior: {
                                              locationName: "scte35Behavior"
                                            },
                                            Scte35Pid: {
                                              locationName: "scte35Pid"
                                            },
                                            TimedMetadataBehavior: {
                                              locationName: "timedMetadataBehavior"
                                            },
                                            TimedMetadataPid: {
                                              locationName: "timedMetadataPid"
                                            },
                                            TransportStreamId: {
                                              locationName: "transportStreamId",
                                              type: "integer"
                                            },
                                            VideoPid: {
                                              locationName: "videoPid"
                                            }
                                          }
                                        }
                                      },
                                      required: [
                                        "M3u8Settings"
                                      ]
                                    }
                                  }
                                },
                                NameModifier: {
                                  locationName: "nameModifier"
                                },
                                SegmentModifier: {
                                  locationName: "segmentModifier"
                                }
                              },
                              required: [
                                "HlsSettings"
                              ]
                            },
                            MediaPackageOutputSettings: {
                              locationName: "mediaPackageOutputSettings",
                              type: "structure",
                              members: {}
                            },
                            MsSmoothOutputSettings: {
                              locationName: "msSmoothOutputSettings",
                              type: "structure",
                              members: {
                                H265PackagingType: {
                                  locationName: "h265PackagingType"
                                },
                                NameModifier: {
                                  locationName: "nameModifier"
                                }
                              }
                            },
                            MultiplexOutputSettings: {
                              locationName: "multiplexOutputSettings",
                              type: "structure",
                              members: {
                                Destination: {
                                  shape: "S6c",
                                  locationName: "destination"
                                }
                              },
                              required: [
                                "Destination"
                              ]
                            },
                            RtmpOutputSettings: {
                              locationName: "rtmpOutputSettings",
                              type: "structure",
                              members: {
                                CertificateMode: {
                                  locationName: "certificateMode"
                                },
                                ConnectionRetryInterval: {
                                  locationName: "connectionRetryInterval",
                                  type: "integer"
                                },
                                Destination: {
                                  shape: "S6c",
                                  locationName: "destination"
                                },
                                NumRetries: {
                                  locationName: "numRetries",
                                  type: "integer"
                                }
                              },
                              required: [
                                "Destination"
                              ]
                            },
                            UdpOutputSettings: {
                              locationName: "udpOutputSettings",
                              type: "structure",
                              members: {
                                BufferMsec: {
                                  locationName: "bufferMsec",
                                  type: "integer"
                                },
                                ContainerSettings: {
                                  locationName: "containerSettings",
                                  type: "structure",
                                  members: {
                                    M2tsSettings: {
                                      shape: "S8i",
                                      locationName: "m2tsSettings"
                                    }
                                  }
                                },
                                Destination: {
                                  shape: "S6c",
                                  locationName: "destination"
                                },
                                FecOutputSettings: {
                                  locationName: "fecOutputSettings",
                                  type: "structure",
                                  members: {
                                    ColumnDepth: {
                                      locationName: "columnDepth",
                                      type: "integer"
                                    },
                                    IncludeFec: {
                                      locationName: "includeFec"
                                    },
                                    RowLength: {
                                      locationName: "rowLength",
                                      type: "integer"
                                    }
                                  }
                                }
                              },
                              required: [
                                "Destination",
                                "ContainerSettings"
                              ]
                            }
                          }
                        },
                        VideoDescriptionName: {
                          locationName: "videoDescriptionName"
                        }
                      },
                      required: [
                        "OutputSettings"
                      ]
                    }
                  }
                },
                required: [
                  "Outputs",
                  "OutputGroupSettings"
                ]
              }
            },
            TimecodeConfig: {
              locationName: "timecodeConfig",
              type: "structure",
              members: {
                Source: {
                  locationName: "source"
                },
                SyncThreshold: {
                  locationName: "syncThreshold",
                  type: "integer"
                }
              },
              required: [
                "Source"
              ]
            },
            VideoDescriptions: {
              locationName: "videoDescriptions",
              type: "list",
              member: {
                type: "structure",
                members: {
                  CodecSettings: {
                    locationName: "codecSettings",
                    type: "structure",
                    members: {
                      FrameCaptureSettings: {
                        locationName: "frameCaptureSettings",
                        type: "structure",
                        members: {
                          CaptureInterval: {
                            locationName: "captureInterval",
                            type: "integer"
                          },
                          CaptureIntervalUnits: {
                            locationName: "captureIntervalUnits"
                          }
                        }
                      },
                      H264Settings: {
                        locationName: "h264Settings",
                        type: "structure",
                        members: {
                          AdaptiveQuantization: {
                            locationName: "adaptiveQuantization"
                          },
                          AfdSignaling: {
                            locationName: "afdSignaling"
                          },
                          Bitrate: {
                            locationName: "bitrate",
                            type: "integer"
                          },
                          BufFillPct: {
                            locationName: "bufFillPct",
                            type: "integer"
                          },
                          BufSize: {
                            locationName: "bufSize",
                            type: "integer"
                          },
                          ColorMetadata: {
                            locationName: "colorMetadata"
                          },
                          ColorSpaceSettings: {
                            locationName: "colorSpaceSettings",
                            type: "structure",
                            members: {
                              ColorSpacePassthroughSettings: {
                                shape: "Sap",
                                locationName: "colorSpacePassthroughSettings"
                              },
                              Rec601Settings: {
                                shape: "Saq",
                                locationName: "rec601Settings"
                              },
                              Rec709Settings: {
                                shape: "Sar",
                                locationName: "rec709Settings"
                              }
                            }
                          },
                          EntropyEncoding: {
                            locationName: "entropyEncoding"
                          },
                          FilterSettings: {
                            locationName: "filterSettings",
                            type: "structure",
                            members: {
                              TemporalFilterSettings: {
                                shape: "Sau",
                                locationName: "temporalFilterSettings"
                              }
                            }
                          },
                          FixedAfd: {
                            locationName: "fixedAfd"
                          },
                          FlickerAq: {
                            locationName: "flickerAq"
                          },
                          ForceFieldPictures: {
                            locationName: "forceFieldPictures"
                          },
                          FramerateControl: {
                            locationName: "framerateControl"
                          },
                          FramerateDenominator: {
                            locationName: "framerateDenominator",
                            type: "integer"
                          },
                          FramerateNumerator: {
                            locationName: "framerateNumerator",
                            type: "integer"
                          },
                          GopBReference: {
                            locationName: "gopBReference"
                          },
                          GopClosedCadence: {
                            locationName: "gopClosedCadence",
                            type: "integer"
                          },
                          GopNumBFrames: {
                            locationName: "gopNumBFrames",
                            type: "integer"
                          },
                          GopSize: {
                            locationName: "gopSize",
                            type: "double"
                          },
                          GopSizeUnits: {
                            locationName: "gopSizeUnits"
                          },
                          Level: {
                            locationName: "level"
                          },
                          LookAheadRateControl: {
                            locationName: "lookAheadRateControl"
                          },
                          MaxBitrate: {
                            locationName: "maxBitrate",
                            type: "integer"
                          },
                          MinIInterval: {
                            locationName: "minIInterval",
                            type: "integer"
                          },
                          NumRefFrames: {
                            locationName: "numRefFrames",
                            type: "integer"
                          },
                          ParControl: {
                            locationName: "parControl"
                          },
                          ParDenominator: {
                            locationName: "parDenominator",
                            type: "integer"
                          },
                          ParNumerator: {
                            locationName: "parNumerator",
                            type: "integer"
                          },
                          Profile: {
                            locationName: "profile"
                          },
                          QualityLevel: {
                            locationName: "qualityLevel"
                          },
                          QvbrQualityLevel: {
                            locationName: "qvbrQualityLevel",
                            type: "integer"
                          },
                          RateControlMode: {
                            locationName: "rateControlMode"
                          },
                          ScanType: {
                            locationName: "scanType"
                          },
                          SceneChangeDetect: {
                            locationName: "sceneChangeDetect"
                          },
                          Slices: {
                            locationName: "slices",
                            type: "integer"
                          },
                          Softness: {
                            locationName: "softness",
                            type: "integer"
                          },
                          SpatialAq: {
                            locationName: "spatialAq"
                          },
                          SubgopLength: {
                            locationName: "subgopLength"
                          },
                          Syntax: {
                            locationName: "syntax"
                          },
                          TemporalAq: {
                            locationName: "temporalAq"
                          },
                          TimecodeInsertion: {
                            locationName: "timecodeInsertion"
                          }
                        }
                      },
                      H265Settings: {
                        locationName: "h265Settings",
                        type: "structure",
                        members: {
                          AdaptiveQuantization: {
                            locationName: "adaptiveQuantization"
                          },
                          AfdSignaling: {
                            locationName: "afdSignaling"
                          },
                          AlternativeTransferFunction: {
                            locationName: "alternativeTransferFunction"
                          },
                          Bitrate: {
                            locationName: "bitrate",
                            type: "integer"
                          },
                          BufSize: {
                            locationName: "bufSize",
                            type: "integer"
                          },
                          ColorMetadata: {
                            locationName: "colorMetadata"
                          },
                          ColorSpaceSettings: {
                            locationName: "colorSpaceSettings",
                            type: "structure",
                            members: {
                              ColorSpacePassthroughSettings: {
                                shape: "Sap",
                                locationName: "colorSpacePassthroughSettings"
                              },
                              Hdr10Settings: {
                                shape: "Sbs",
                                locationName: "hdr10Settings"
                              },
                              Rec601Settings: {
                                shape: "Saq",
                                locationName: "rec601Settings"
                              },
                              Rec709Settings: {
                                shape: "Sar",
                                locationName: "rec709Settings"
                              }
                            }
                          },
                          FilterSettings: {
                            locationName: "filterSettings",
                            type: "structure",
                            members: {
                              TemporalFilterSettings: {
                                shape: "Sau",
                                locationName: "temporalFilterSettings"
                              }
                            }
                          },
                          FixedAfd: {
                            locationName: "fixedAfd"
                          },
                          FlickerAq: {
                            locationName: "flickerAq"
                          },
                          FramerateDenominator: {
                            locationName: "framerateDenominator",
                            type: "integer"
                          },
                          FramerateNumerator: {
                            locationName: "framerateNumerator",
                            type: "integer"
                          },
                          GopClosedCadence: {
                            locationName: "gopClosedCadence",
                            type: "integer"
                          },
                          GopSize: {
                            locationName: "gopSize",
                            type: "double"
                          },
                          GopSizeUnits: {
                            locationName: "gopSizeUnits"
                          },
                          Level: {
                            locationName: "level"
                          },
                          LookAheadRateControl: {
                            locationName: "lookAheadRateControl"
                          },
                          MaxBitrate: {
                            locationName: "maxBitrate",
                            type: "integer"
                          },
                          MinIInterval: {
                            locationName: "minIInterval",
                            type: "integer"
                          },
                          ParDenominator: {
                            locationName: "parDenominator",
                            type: "integer"
                          },
                          ParNumerator: {
                            locationName: "parNumerator",
                            type: "integer"
                          },
                          Profile: {
                            locationName: "profile"
                          },
                          QvbrQualityLevel: {
                            locationName: "qvbrQualityLevel",
                            type: "integer"
                          },
                          RateControlMode: {
                            locationName: "rateControlMode"
                          },
                          ScanType: {
                            locationName: "scanType"
                          },
                          SceneChangeDetect: {
                            locationName: "sceneChangeDetect"
                          },
                          Slices: {
                            locationName: "slices",
                            type: "integer"
                          },
                          Tier: {
                            locationName: "tier"
                          },
                          TimecodeInsertion: {
                            locationName: "timecodeInsertion"
                          }
                        },
                        required: [
                          "FramerateNumerator",
                          "FramerateDenominator"
                        ]
                      },
                      Mpeg2Settings: {
                        locationName: "mpeg2Settings",
                        type: "structure",
                        members: {
                          AdaptiveQuantization: {
                            locationName: "adaptiveQuantization"
                          },
                          AfdSignaling: {
                            locationName: "afdSignaling"
                          },
                          ColorMetadata: {
                            locationName: "colorMetadata"
                          },
                          ColorSpace: {
                            locationName: "colorSpace"
                          },
                          DisplayAspectRatio: {
                            locationName: "displayAspectRatio"
                          },
                          FilterSettings: {
                            locationName: "filterSettings",
                            type: "structure",
                            members: {
                              TemporalFilterSettings: {
                                shape: "Sau",
                                locationName: "temporalFilterSettings"
                              }
                            }
                          },
                          FixedAfd: {
                            locationName: "fixedAfd"
                          },
                          FramerateDenominator: {
                            locationName: "framerateDenominator",
                            type: "integer"
                          },
                          FramerateNumerator: {
                            locationName: "framerateNumerator",
                            type: "integer"
                          },
                          GopClosedCadence: {
                            locationName: "gopClosedCadence",
                            type: "integer"
                          },
                          GopNumBFrames: {
                            locationName: "gopNumBFrames",
                            type: "integer"
                          },
                          GopSize: {
                            locationName: "gopSize",
                            type: "double"
                          },
                          GopSizeUnits: {
                            locationName: "gopSizeUnits"
                          },
                          ScanType: {
                            locationName: "scanType"
                          },
                          SubgopLength: {
                            locationName: "subgopLength"
                          },
                          TimecodeInsertion: {
                            locationName: "timecodeInsertion"
                          }
                        },
                        required: [
                          "FramerateNumerator",
                          "FramerateDenominator"
                        ]
                      }
                    }
                  },
                  Height: {
                    locationName: "height",
                    type: "integer"
                  },
                  Name: {
                    locationName: "name"
                  },
                  RespondToAfd: {
                    locationName: "respondToAfd"
                  },
                  ScalingBehavior: {
                    locationName: "scalingBehavior"
                  },
                  Sharpness: {
                    locationName: "sharpness",
                    type: "integer"
                  },
                  Width: {
                    locationName: "width",
                    type: "integer"
                  }
                },
                required: [
                  "Name"
                ]
              }
            }
          },
          required: [
            "VideoDescriptions",
            "AudioDescriptions",
            "OutputGroups",
            "TimecodeConfig"
          ]
        },
        S6c: {
          type: "structure",
          members: {
            DestinationRefId: {
              locationName: "destinationRefId"
            }
          }
        },
        S8i: {
          type: "structure",
          members: {
            AbsentInputAudioBehavior: {
              locationName: "absentInputAudioBehavior"
            },
            Arib: {
              locationName: "arib"
            },
            AribCaptionsPid: {
              locationName: "aribCaptionsPid"
            },
            AribCaptionsPidControl: {
              locationName: "aribCaptionsPidControl"
            },
            AudioBufferModel: {
              locationName: "audioBufferModel"
            },
            AudioFramesPerPes: {
              locationName: "audioFramesPerPes",
              type: "integer"
            },
            AudioPids: {
              locationName: "audioPids"
            },
            AudioStreamType: {
              locationName: "audioStreamType"
            },
            Bitrate: {
              locationName: "bitrate",
              type: "integer"
            },
            BufferModel: {
              locationName: "bufferModel"
            },
            CcDescriptor: {
              locationName: "ccDescriptor"
            },
            DvbNitSettings: {
              locationName: "dvbNitSettings",
              type: "structure",
              members: {
                NetworkId: {
                  locationName: "networkId",
                  type: "integer"
                },
                NetworkName: {
                  locationName: "networkName"
                },
                RepInterval: {
                  locationName: "repInterval",
                  type: "integer"
                }
              },
              required: [
                "NetworkName",
                "NetworkId"
              ]
            },
            DvbSdtSettings: {
              locationName: "dvbSdtSettings",
              type: "structure",
              members: {
                OutputSdt: {
                  locationName: "outputSdt"
                },
                RepInterval: {
                  locationName: "repInterval",
                  type: "integer"
                },
                ServiceName: {
                  locationName: "serviceName"
                },
                ServiceProviderName: {
                  locationName: "serviceProviderName"
                }
              }
            },
            DvbSubPids: {
              locationName: "dvbSubPids"
            },
            DvbTdtSettings: {
              locationName: "dvbTdtSettings",
              type: "structure",
              members: {
                RepInterval: {
                  locationName: "repInterval",
                  type: "integer"
                }
              }
            },
            DvbTeletextPid: {
              locationName: "dvbTeletextPid"
            },
            Ebif: {
              locationName: "ebif"
            },
            EbpAudioInterval: {
              locationName: "ebpAudioInterval"
            },
            EbpLookaheadMs: {
              locationName: "ebpLookaheadMs",
              type: "integer"
            },
            EbpPlacement: {
              locationName: "ebpPlacement"
            },
            EcmPid: {
              locationName: "ecmPid"
            },
            EsRateInPes: {
              locationName: "esRateInPes"
            },
            EtvPlatformPid: {
              locationName: "etvPlatformPid"
            },
            EtvSignalPid: {
              locationName: "etvSignalPid"
            },
            FragmentTime: {
              locationName: "fragmentTime",
              type: "double"
            },
            Klv: {
              locationName: "klv"
            },
            KlvDataPids: {
              locationName: "klvDataPids"
            },
            NielsenId3Behavior: {
              locationName: "nielsenId3Behavior"
            },
            NullPacketBitrate: {
              locationName: "nullPacketBitrate",
              type: "double"
            },
            PatInterval: {
              locationName: "patInterval",
              type: "integer"
            },
            PcrControl: {
              locationName: "pcrControl"
            },
            PcrPeriod: {
              locationName: "pcrPeriod",
              type: "integer"
            },
            PcrPid: {
              locationName: "pcrPid"
            },
            PmtInterval: {
              locationName: "pmtInterval",
              type: "integer"
            },
            PmtPid: {
              locationName: "pmtPid"
            },
            ProgramNum: {
              locationName: "programNum",
              type: "integer"
            },
            RateMode: {
              locationName: "rateMode"
            },
            Scte27Pids: {
              locationName: "scte27Pids"
            },
            Scte35Control: {
              locationName: "scte35Control"
            },
            Scte35Pid: {
              locationName: "scte35Pid"
            },
            SegmentationMarkers: {
              locationName: "segmentationMarkers"
            },
            SegmentationStyle: {
              locationName: "segmentationStyle"
            },
            SegmentationTime: {
              locationName: "segmentationTime",
              type: "double"
            },
            TimedMetadataBehavior: {
              locationName: "timedMetadataBehavior"
            },
            TimedMetadataPid: {
              locationName: "timedMetadataPid"
            },
            TransportStreamId: {
              locationName: "transportStreamId",
              type: "integer"
            },
            VideoPid: {
              locationName: "videoPid"
            }
          }
        },
        Sap: {
          type: "structure",
          members: {}
        },
        Saq: {
          type: "structure",
          members: {}
        },
        Sar: {
          type: "structure",
          members: {}
        },
        Sau: {
          type: "structure",
          members: {
            PostFilterSharpening: {
              locationName: "postFilterSharpening"
            },
            Strength: {
              locationName: "strength"
            }
          }
        },
        Sbs: {
          type: "structure",
          members: {
            MaxCll: {
              locationName: "maxCll",
              type: "integer"
            },
            MaxFall: {
              locationName: "maxFall",
              type: "integer"
            }
          }
        },
        Sci: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AutomaticInputFailoverSettings: {
                locationName: "automaticInputFailoverSettings",
                type: "structure",
                members: {
                  ErrorClearTimeMsec: {
                    locationName: "errorClearTimeMsec",
                    type: "integer"
                  },
                  FailoverConditions: {
                    locationName: "failoverConditions",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        FailoverConditionSettings: {
                          locationName: "failoverConditionSettings",
                          type: "structure",
                          members: {
                            AudioSilenceSettings: {
                              locationName: "audioSilenceSettings",
                              type: "structure",
                              members: {
                                AudioSelectorName: {
                                  locationName: "audioSelectorName"
                                },
                                AudioSilenceThresholdMsec: {
                                  locationName: "audioSilenceThresholdMsec",
                                  type: "integer"
                                }
                              },
                              required: [
                                "AudioSelectorName"
                              ]
                            },
                            InputLossSettings: {
                              locationName: "inputLossSettings",
                              type: "structure",
                              members: {
                                InputLossThresholdMsec: {
                                  locationName: "inputLossThresholdMsec",
                                  type: "integer"
                                }
                              }
                            },
                            VideoBlackSettings: {
                              locationName: "videoBlackSettings",
                              type: "structure",
                              members: {
                                BlackDetectThreshold: {
                                  locationName: "blackDetectThreshold",
                                  type: "double"
                                },
                                VideoBlackThresholdMsec: {
                                  locationName: "videoBlackThresholdMsec",
                                  type: "integer"
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  InputPreference: {
                    locationName: "inputPreference"
                  },
                  SecondaryInputId: {
                    locationName: "secondaryInputId"
                  }
                },
                required: [
                  "SecondaryInputId"
                ]
              },
              InputAttachmentName: {
                locationName: "inputAttachmentName"
              },
              InputId: {
                locationName: "inputId"
              },
              InputSettings: {
                locationName: "inputSettings",
                type: "structure",
                members: {
                  AudioSelectors: {
                    locationName: "audioSelectors",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {
                          locationName: "name"
                        },
                        SelectorSettings: {
                          locationName: "selectorSettings",
                          type: "structure",
                          members: {
                            AudioHlsRenditionSelection: {
                              locationName: "audioHlsRenditionSelection",
                              type: "structure",
                              members: {
                                GroupId: {
                                  locationName: "groupId"
                                },
                                Name: {
                                  locationName: "name"
                                }
                              },
                              required: [
                                "Name",
                                "GroupId"
                              ]
                            },
                            AudioLanguageSelection: {
                              locationName: "audioLanguageSelection",
                              type: "structure",
                              members: {
                                LanguageCode: {
                                  locationName: "languageCode"
                                },
                                LanguageSelectionPolicy: {
                                  locationName: "languageSelectionPolicy"
                                }
                              },
                              required: [
                                "LanguageCode"
                              ]
                            },
                            AudioPidSelection: {
                              locationName: "audioPidSelection",
                              type: "structure",
                              members: {
                                Pid: {
                                  locationName: "pid",
                                  type: "integer"
                                }
                              },
                              required: [
                                "Pid"
                              ]
                            },
                            AudioTrackSelection: {
                              locationName: "audioTrackSelection",
                              type: "structure",
                              members: {
                                Tracks: {
                                  locationName: "tracks",
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Track: {
                                        locationName: "track",
                                        type: "integer"
                                      }
                                    },
                                    required: [
                                      "Track"
                                    ]
                                  }
                                }
                              },
                              required: [
                                "Tracks"
                              ]
                            }
                          }
                        }
                      },
                      required: [
                        "Name"
                      ]
                    }
                  },
                  CaptionSelectors: {
                    locationName: "captionSelectors",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        LanguageCode: {
                          locationName: "languageCode"
                        },
                        Name: {
                          locationName: "name"
                        },
                        SelectorSettings: {
                          locationName: "selectorSettings",
                          type: "structure",
                          members: {
                            AncillarySourceSettings: {
                              locationName: "ancillarySourceSettings",
                              type: "structure",
                              members: {
                                SourceAncillaryChannelNumber: {
                                  locationName: "sourceAncillaryChannelNumber",
                                  type: "integer"
                                }
                              }
                            },
                            AribSourceSettings: {
                              locationName: "aribSourceSettings",
                              type: "structure",
                              members: {}
                            },
                            DvbSubSourceSettings: {
                              locationName: "dvbSubSourceSettings",
                              type: "structure",
                              members: {
                                OcrLanguage: {
                                  locationName: "ocrLanguage"
                                },
                                Pid: {
                                  locationName: "pid",
                                  type: "integer"
                                }
                              }
                            },
                            EmbeddedSourceSettings: {
                              locationName: "embeddedSourceSettings",
                              type: "structure",
                              members: {
                                Convert608To708: {
                                  locationName: "convert608To708"
                                },
                                Scte20Detection: {
                                  locationName: "scte20Detection"
                                },
                                Source608ChannelNumber: {
                                  locationName: "source608ChannelNumber",
                                  type: "integer"
                                },
                                Source608TrackNumber: {
                                  locationName: "source608TrackNumber",
                                  type: "integer"
                                }
                              }
                            },
                            Scte20SourceSettings: {
                              locationName: "scte20SourceSettings",
                              type: "structure",
                              members: {
                                Convert608To708: {
                                  locationName: "convert608To708"
                                },
                                Source608ChannelNumber: {
                                  locationName: "source608ChannelNumber",
                                  type: "integer"
                                }
                              }
                            },
                            Scte27SourceSettings: {
                              locationName: "scte27SourceSettings",
                              type: "structure",
                              members: {
                                OcrLanguage: {
                                  locationName: "ocrLanguage"
                                },
                                Pid: {
                                  locationName: "pid",
                                  type: "integer"
                                }
                              }
                            },
                            TeletextSourceSettings: {
                              locationName: "teletextSourceSettings",
                              type: "structure",
                              members: {
                                OutputRectangle: {
                                  locationName: "outputRectangle",
                                  type: "structure",
                                  members: {
                                    Height: {
                                      locationName: "height",
                                      type: "double"
                                    },
                                    LeftOffset: {
                                      locationName: "leftOffset",
                                      type: "double"
                                    },
                                    TopOffset: {
                                      locationName: "topOffset",
                                      type: "double"
                                    },
                                    Width: {
                                      locationName: "width",
                                      type: "double"
                                    }
                                  },
                                  required: [
                                    "TopOffset",
                                    "Height",
                                    "Width",
                                    "LeftOffset"
                                  ]
                                },
                                PageNumber: {
                                  locationName: "pageNumber"
                                }
                              }
                            }
                          }
                        }
                      },
                      required: [
                        "Name"
                      ]
                    }
                  },
                  DeblockFilter: {
                    locationName: "deblockFilter"
                  },
                  DenoiseFilter: {
                    locationName: "denoiseFilter"
                  },
                  FilterStrength: {
                    locationName: "filterStrength",
                    type: "integer"
                  },
                  InputFilter: {
                    locationName: "inputFilter"
                  },
                  NetworkInputSettings: {
                    locationName: "networkInputSettings",
                    type: "structure",
                    members: {
                      HlsInputSettings: {
                        locationName: "hlsInputSettings",
                        type: "structure",
                        members: {
                          Bandwidth: {
                            locationName: "bandwidth",
                            type: "integer"
                          },
                          BufferSegments: {
                            locationName: "bufferSegments",
                            type: "integer"
                          },
                          Retries: {
                            locationName: "retries",
                            type: "integer"
                          },
                          RetryInterval: {
                            locationName: "retryInterval",
                            type: "integer"
                          },
                          Scte35Source: {
                            locationName: "scte35Source"
                          }
                        }
                      },
                      ServerValidation: {
                        locationName: "serverValidation"
                      }
                    }
                  },
                  Smpte2038DataPreference: {
                    locationName: "smpte2038DataPreference"
                  },
                  SourceEndBehavior: {
                    locationName: "sourceEndBehavior"
                  },
                  VideoSelector: {
                    locationName: "videoSelector",
                    type: "structure",
                    members: {
                      ColorSpace: {
                        locationName: "colorSpace"
                      },
                      ColorSpaceSettings: {
                        locationName: "colorSpaceSettings",
                        type: "structure",
                        members: {
                          Hdr10Settings: {
                            shape: "Sbs",
                            locationName: "hdr10Settings"
                          }
                        }
                      },
                      ColorSpaceUsage: {
                        locationName: "colorSpaceUsage"
                      },
                      SelectorSettings: {
                        locationName: "selectorSettings",
                        type: "structure",
                        members: {
                          VideoSelectorPid: {
                            locationName: "videoSelectorPid",
                            type: "structure",
                            members: {
                              Pid: {
                                locationName: "pid",
                                type: "integer"
                              }
                            }
                          },
                          VideoSelectorProgramId: {
                            locationName: "videoSelectorProgramId",
                            type: "structure",
                            members: {
                              ProgramId: {
                                locationName: "programId",
                                type: "integer"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Se4: {
          type: "structure",
          members: {
            Codec: {
              locationName: "codec"
            },
            MaximumBitrate: {
              locationName: "maximumBitrate"
            },
            Resolution: {
              locationName: "resolution"
            }
          }
        },
        Se9: {
          type: "map",
          key: {},
          value: {}
        },
        Sec: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            CdiInputSpecification: {
              shape: "S22",
              locationName: "cdiInputSpecification"
            },
            ChannelClass: {
              locationName: "channelClass"
            },
            Destinations: {
              shape: "S25",
              locationName: "destinations"
            },
            EgressEndpoints: {
              shape: "Sed",
              locationName: "egressEndpoints"
            },
            EncoderSettings: {
              shape: "S2d",
              locationName: "encoderSettings"
            },
            Id: {
              locationName: "id"
            },
            InputAttachments: {
              shape: "Sci",
              locationName: "inputAttachments"
            },
            InputSpecification: {
              shape: "Se4",
              locationName: "inputSpecification"
            },
            LogLevel: {
              locationName: "logLevel"
            },
            Name: {
              locationName: "name"
            },
            PipelineDetails: {
              shape: "Sef",
              locationName: "pipelineDetails"
            },
            PipelinesRunningCount: {
              locationName: "pipelinesRunningCount",
              type: "integer"
            },
            RoleArn: {
              locationName: "roleArn"
            },
            State: {
              locationName: "state"
            },
            Tags: {
              shape: "Se9",
              locationName: "tags"
            },
            Vpc: {
              shape: "Sei",
              locationName: "vpc"
            }
          }
        },
        Sed: {
          type: "list",
          member: {
            type: "structure",
            members: {
              SourceIp: {
                locationName: "sourceIp"
              }
            }
          }
        },
        Sef: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ActiveInputAttachmentName: {
                locationName: "activeInputAttachmentName"
              },
              ActiveInputSwitchActionName: {
                locationName: "activeInputSwitchActionName"
              },
              ActiveMotionGraphicsActionName: {
                locationName: "activeMotionGraphicsActionName"
              },
              ActiveMotionGraphicsUri: {
                locationName: "activeMotionGraphicsUri"
              },
              PipelineId: {
                locationName: "pipelineId"
              }
            }
          }
        },
        Sei: {
          type: "structure",
          members: {
            AvailabilityZones: {
              shape: "S5",
              locationName: "availabilityZones"
            },
            NetworkInterfaceIds: {
              shape: "S5",
              locationName: "networkInterfaceIds"
            },
            SecurityGroupIds: {
              shape: "S5",
              locationName: "securityGroupIds"
            },
            SubnetIds: {
              shape: "S5",
              locationName: "subnetIds"
            }
          }
        },
        Sek: {
          type: "list",
          member: {
            type: "structure",
            members: {
              StreamName: {
                locationName: "streamName"
              }
            }
          }
        },
        Sem: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {
                locationName: "id"
              }
            }
          }
        },
        Seo: {
          type: "list",
          member: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              }
            }
          }
        },
        Seq: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PasswordParam: {
                locationName: "passwordParam"
              },
              Url: {
                locationName: "url"
              },
              Username: {
                locationName: "username"
              }
            }
          }
        },
        Sev: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            AttachedChannels: {
              shape: "S5",
              locationName: "attachedChannels"
            },
            Destinations: {
              shape: "Sew",
              locationName: "destinations"
            },
            Id: {
              locationName: "id"
            },
            InputClass: {
              locationName: "inputClass"
            },
            InputDevices: {
              shape: "Sem",
              locationName: "inputDevices"
            },
            InputPartnerIds: {
              shape: "S5",
              locationName: "inputPartnerIds"
            },
            InputSourceType: {
              locationName: "inputSourceType"
            },
            MediaConnectFlows: {
              shape: "Sf1",
              locationName: "mediaConnectFlows"
            },
            Name: {
              locationName: "name"
            },
            RoleArn: {
              locationName: "roleArn"
            },
            SecurityGroups: {
              shape: "S5",
              locationName: "securityGroups"
            },
            Sources: {
              shape: "Sf3",
              locationName: "sources"
            },
            State: {
              locationName: "state"
            },
            Tags: {
              shape: "Se9",
              locationName: "tags"
            },
            Type: {
              locationName: "type"
            }
          }
        },
        Sew: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Ip: {
                locationName: "ip"
              },
              Port: {
                locationName: "port"
              },
              Url: {
                locationName: "url"
              },
              Vpc: {
                locationName: "vpc",
                type: "structure",
                members: {
                  AvailabilityZone: {
                    locationName: "availabilityZone"
                  },
                  NetworkInterfaceId: {
                    locationName: "networkInterfaceId"
                  }
                }
              }
            }
          }
        },
        Sf1: {
          type: "list",
          member: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              }
            }
          }
        },
        Sf3: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PasswordParam: {
                locationName: "passwordParam"
              },
              Url: {
                locationName: "url"
              },
              Username: {
                locationName: "username"
              }
            }
          }
        },
        Sf7: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Cidr: {
                locationName: "cidr"
              }
            }
          }
        },
        Sfa: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            Id: {
              locationName: "id"
            },
            Inputs: {
              shape: "S5",
              locationName: "inputs"
            },
            State: {
              locationName: "state"
            },
            Tags: {
              shape: "Se9",
              locationName: "tags"
            },
            WhitelistRules: {
              shape: "Sfc",
              locationName: "whitelistRules"
            }
          }
        },
        Sfc: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Cidr: {
                locationName: "cidr"
              }
            }
          }
        },
        Sff: {
          type: "structure",
          members: {
            MaximumVideoBufferDelayMilliseconds: {
              locationName: "maximumVideoBufferDelayMilliseconds",
              type: "integer"
            },
            TransportStreamBitrate: {
              locationName: "transportStreamBitrate",
              type: "integer"
            },
            TransportStreamId: {
              locationName: "transportStreamId",
              type: "integer"
            },
            TransportStreamReservedBitrate: {
              locationName: "transportStreamReservedBitrate",
              type: "integer"
            }
          },
          required: [
            "TransportStreamBitrate",
            "TransportStreamId"
          ]
        },
        Sfk: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            AvailabilityZones: {
              shape: "S5",
              locationName: "availabilityZones"
            },
            Destinations: {
              shape: "Sfl",
              locationName: "destinations"
            },
            Id: {
              locationName: "id"
            },
            MultiplexSettings: {
              shape: "Sff",
              locationName: "multiplexSettings"
            },
            Name: {
              locationName: "name"
            },
            PipelinesRunningCount: {
              locationName: "pipelinesRunningCount",
              type: "integer"
            },
            ProgramCount: {
              locationName: "programCount",
              type: "integer"
            },
            State: {
              locationName: "state"
            },
            Tags: {
              shape: "Se9",
              locationName: "tags"
            }
          }
        },
        Sfl: {
          type: "list",
          member: {
            type: "structure",
            members: {
              MediaConnectSettings: {
                locationName: "mediaConnectSettings",
                type: "structure",
                members: {
                  EntitlementArn: {
                    locationName: "entitlementArn"
                  }
                }
              }
            }
          }
        },
        Sfq: {
          type: "structure",
          members: {
            PreferredChannelPipeline: {
              locationName: "preferredChannelPipeline"
            },
            ProgramNumber: {
              locationName: "programNumber",
              type: "integer"
            },
            ServiceDescriptor: {
              locationName: "serviceDescriptor",
              type: "structure",
              members: {
                ProviderName: {
                  locationName: "providerName"
                },
                ServiceName: {
                  locationName: "serviceName"
                }
              },
              required: [
                "ProviderName",
                "ServiceName"
              ]
            },
            VideoSettings: {
              locationName: "videoSettings",
              type: "structure",
              members: {
                ConstantBitrate: {
                  locationName: "constantBitrate",
                  type: "integer"
                },
                StatmuxSettings: {
                  locationName: "statmuxSettings",
                  type: "structure",
                  members: {
                    MaximumBitrate: {
                      locationName: "maximumBitrate",
                      type: "integer"
                    },
                    MinimumBitrate: {
                      locationName: "minimumBitrate",
                      type: "integer"
                    },
                    Priority: {
                      locationName: "priority",
                      type: "integer"
                    }
                  }
                }
              }
            }
          },
          required: [
            "ProgramNumber"
          ]
        },
        Sfz: {
          type: "structure",
          members: {
            ChannelId: {
              locationName: "channelId"
            },
            MultiplexProgramSettings: {
              shape: "Sfq",
              locationName: "multiplexProgramSettings"
            },
            PacketIdentifiersMap: {
              shape: "Sg0",
              locationName: "packetIdentifiersMap"
            },
            PipelineDetails: {
              shape: "Sg2",
              locationName: "pipelineDetails"
            },
            ProgramName: {
              locationName: "programName"
            }
          }
        },
        Sg0: {
          type: "structure",
          members: {
            AudioPids: {
              shape: "Sg1",
              locationName: "audioPids"
            },
            DvbSubPids: {
              shape: "Sg1",
              locationName: "dvbSubPids"
            },
            DvbTeletextPid: {
              locationName: "dvbTeletextPid",
              type: "integer"
            },
            EtvPlatformPid: {
              locationName: "etvPlatformPid",
              type: "integer"
            },
            EtvSignalPid: {
              locationName: "etvSignalPid",
              type: "integer"
            },
            KlvDataPids: {
              shape: "Sg1",
              locationName: "klvDataPids"
            },
            PcrPid: {
              locationName: "pcrPid",
              type: "integer"
            },
            PmtPid: {
              locationName: "pmtPid",
              type: "integer"
            },
            PrivateMetadataPid: {
              locationName: "privateMetadataPid",
              type: "integer"
            },
            Scte27Pids: {
              shape: "Sg1",
              locationName: "scte27Pids"
            },
            Scte35Pid: {
              locationName: "scte35Pid",
              type: "integer"
            },
            TimedMetadataPid: {
              locationName: "timedMetadataPid",
              type: "integer"
            },
            VideoPid: {
              locationName: "videoPid",
              type: "integer"
            }
          }
        },
        Sg1: {
          type: "list",
          member: {
            type: "integer"
          }
        },
        Sg2: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ActiveChannelPipeline: {
                locationName: "activeChannelPipeline"
              },
              PipelineId: {
                locationName: "pipelineId"
              }
            }
          }
        },
        Sgl: {
          type: "structure",
          members: {
            ChannelClass: {
              locationName: "channelClass"
            },
            Codec: {
              locationName: "codec"
            },
            MaximumBitrate: {
              locationName: "maximumBitrate"
            },
            MaximumFramerate: {
              locationName: "maximumFramerate"
            },
            Resolution: {
              locationName: "resolution"
            },
            ResourceType: {
              locationName: "resourceType"
            },
            SpecialFeature: {
              locationName: "specialFeature"
            },
            VideoQuality: {
              locationName: "videoQuality"
            }
          }
        },
        Sh6: {
          type: "structure",
          members: {
            ActiveInput: {
              locationName: "activeInput"
            },
            ConfiguredInput: {
              locationName: "configuredInput"
            },
            DeviceState: {
              locationName: "deviceState"
            },
            Framerate: {
              locationName: "framerate",
              type: "double"
            },
            Height: {
              locationName: "height",
              type: "integer"
            },
            MaxBitrate: {
              locationName: "maxBitrate",
              type: "integer"
            },
            ScanType: {
              locationName: "scanType"
            },
            Width: {
              locationName: "width",
              type: "integer"
            }
          }
        },
        Shb: {
          type: "structure",
          members: {
            DnsAddresses: {
              shape: "S5",
              locationName: "dnsAddresses"
            },
            Gateway: {
              locationName: "gateway"
            },
            IpAddress: {
              locationName: "ipAddress"
            },
            IpScheme: {
              locationName: "ipScheme"
            },
            SubnetMask: {
              locationName: "subnetMask"
            }
          }
        },
        She: {
          type: "structure",
          members: {
            ActiveInput: {
              locationName: "activeInput"
            },
            ConfiguredInput: {
              locationName: "configuredInput"
            },
            DeviceState: {
              locationName: "deviceState"
            },
            Framerate: {
              locationName: "framerate",
              type: "double"
            },
            Height: {
              locationName: "height",
              type: "integer"
            },
            MaxBitrate: {
              locationName: "maxBitrate",
              type: "integer"
            },
            ScanType: {
              locationName: "scanType"
            },
            Width: {
              locationName: "width",
              type: "integer"
            }
          }
        },
        Siy: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            Count: {
              locationName: "count",
              type: "integer"
            },
            CurrencyCode: {
              locationName: "currencyCode"
            },
            Duration: {
              locationName: "duration",
              type: "integer"
            },
            DurationUnits: {
              locationName: "durationUnits"
            },
            End: {
              locationName: "end"
            },
            FixedPrice: {
              locationName: "fixedPrice",
              type: "double"
            },
            Name: {
              locationName: "name"
            },
            OfferingDescription: {
              locationName: "offeringDescription"
            },
            OfferingId: {
              locationName: "offeringId"
            },
            OfferingType: {
              locationName: "offeringType"
            },
            Region: {
              locationName: "region"
            },
            ReservationId: {
              locationName: "reservationId"
            },
            ResourceSpecification: {
              shape: "Sgl",
              locationName: "resourceSpecification"
            },
            Start: {
              locationName: "start"
            },
            State: {
              locationName: "state"
            },
            Tags: {
              shape: "Se9",
              locationName: "tags"
            },
            UsagePrice: {
              locationName: "usagePrice",
              type: "double"
            }
          }
        },
        Sjo: {
          type: "structure",
          members: {
            ConfiguredInput: {
              locationName: "configuredInput"
            },
            MaxBitrate: {
              locationName: "maxBitrate",
              type: "integer"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/medialive-2017-10-14.paginators.json
var require_medialive_2017_10_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/medialive-2017-10-14.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeSchedule: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ScheduleActions"
        },
        ListChannels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Channels"
        },
        ListInputSecurityGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "InputSecurityGroups"
        },
        ListInputs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Inputs"
        },
        ListOfferings: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Offerings"
        },
        ListReservations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Reservations"
        },
        ListMultiplexPrograms: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "MultiplexPrograms"
        },
        ListMultiplexes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Multiplexes"
        },
        ListInputDevices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "InputDevices"
        },
        ListInputDeviceTransfers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "InputDeviceTransfers"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/medialive-2017-10-14.waiters2.json
var require_medialive_2017_10_14_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/medialive-2017-10-14.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ChannelCreated: {
          description: "Wait until a channel has been created",
          operation: "DescribeChannel",
          delay: 3,
          maxAttempts: 5,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "IDLE"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "CREATING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            },
            {
              state: "failure",
              matcher: "path",
              argument: "State",
              expected: "CREATE_FAILED"
            }
          ]
        },
        ChannelRunning: {
          description: "Wait until a channel is running",
          operation: "DescribeChannel",
          delay: 5,
          maxAttempts: 120,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "RUNNING"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "STARTING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        ChannelStopped: {
          description: "Wait until a channel has is stopped",
          operation: "DescribeChannel",
          delay: 5,
          maxAttempts: 60,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "IDLE"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "STOPPING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        ChannelDeleted: {
          description: "Wait until a channel has been deleted",
          operation: "DescribeChannel",
          delay: 5,
          maxAttempts: 84,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "DELETED"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "DELETING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        InputAttached: {
          description: "Wait until an input has been attached",
          operation: "DescribeInput",
          delay: 5,
          maxAttempts: 20,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "ATTACHED"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "DETACHED"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        InputDetached: {
          description: "Wait until an input has been detached",
          operation: "DescribeInput",
          delay: 5,
          maxAttempts: 84,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "DETACHED"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "CREATING"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "ATTACHED"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        InputDeleted: {
          description: "Wait until an input has been deleted",
          operation: "DescribeInput",
          delay: 5,
          maxAttempts: 20,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "DELETED"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "DELETING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        MultiplexCreated: {
          description: "Wait until a multiplex has been created",
          operation: "DescribeMultiplex",
          delay: 3,
          maxAttempts: 5,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "IDLE"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "CREATING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            },
            {
              state: "failure",
              matcher: "path",
              argument: "State",
              expected: "CREATE_FAILED"
            }
          ]
        },
        MultiplexRunning: {
          description: "Wait until a multiplex is running",
          operation: "DescribeMultiplex",
          delay: 5,
          maxAttempts: 120,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "RUNNING"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "STARTING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        MultiplexStopped: {
          description: "Wait until a multiplex has is stopped",
          operation: "DescribeMultiplex",
          delay: 5,
          maxAttempts: 28,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "IDLE"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "STOPPING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        MultiplexDeleted: {
          description: "Wait until a multiplex has been deleted",
          operation: "DescribeMultiplex",
          delay: 5,
          maxAttempts: 20,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "State",
              expected: "DELETED"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "State",
              expected: "DELETING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/medialive.js
var require_medialive = __commonJS({
  "node_modules/aws-sdk/clients/medialive.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["medialive"] = {};
    AWS3.MediaLive = Service.defineService("medialive", ["2017-10-14"]);
    Object.defineProperty(apiLoader.services["medialive"], "2017-10-14", {
      get: function get() {
        var model = require_medialive_2017_10_14_min();
        model.paginators = require_medialive_2017_10_14_paginators().pagination;
        model.waiters = require_medialive_2017_10_14_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.MediaLive;
  }
});

// node_modules/aws-sdk/apis/mediapackage-2017-10-12.min.json
var require_mediapackage_2017_10_12_min = __commonJS({
  "node_modules/aws-sdk/apis/mediapackage-2017-10-12.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2017-10-12",
        endpointPrefix: "mediapackage",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "MediaPackage",
        serviceFullName: "AWS Elemental MediaPackage",
        serviceId: "MediaPackage",
        signatureVersion: "v4",
        signingName: "mediapackage",
        uid: "mediapackage-2017-10-12"
      },
      operations: {
        ConfigureLogs: {
          http: {
            method: "PUT",
            requestUri: "/channels/{id}/configure_logs",
            responseCode: 200
          },
          input: {
            members: {
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              Id: {
                location: "uri",
                locationName: "id"
              },
              IngressAccessLogs: {
                locationName: "ingressAccessLogs",
                shape: "S4"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              Description: {
                locationName: "description"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              HlsIngest: {
                locationName: "hlsIngest",
                shape: "S6"
              },
              Id: {
                locationName: "id"
              },
              IngressAccessLogs: {
                locationName: "ingressAccessLogs",
                shape: "S4"
              },
              Tags: {
                locationName: "tags",
                shape: "S9"
              }
            },
            type: "structure"
          }
        },
        CreateChannel: {
          http: {
            requestUri: "/channels",
            responseCode: 200
          },
          input: {
            members: {
              Description: {
                locationName: "description"
              },
              Id: {
                locationName: "id"
              },
              Tags: {
                locationName: "tags",
                shape: "S9"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              Description: {
                locationName: "description"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              HlsIngest: {
                locationName: "hlsIngest",
                shape: "S6"
              },
              Id: {
                locationName: "id"
              },
              IngressAccessLogs: {
                locationName: "ingressAccessLogs",
                shape: "S4"
              },
              Tags: {
                locationName: "tags",
                shape: "S9"
              }
            },
            type: "structure"
          }
        },
        CreateHarvestJob: {
          http: {
            requestUri: "/harvest_jobs",
            responseCode: 200
          },
          input: {
            members: {
              EndTime: {
                locationName: "endTime"
              },
              Id: {
                locationName: "id"
              },
              OriginEndpointId: {
                locationName: "originEndpointId"
              },
              S3Destination: {
                locationName: "s3Destination",
                shape: "Sd"
              },
              StartTime: {
                locationName: "startTime"
              }
            },
            required: [
              "S3Destination",
              "EndTime",
              "OriginEndpointId",
              "StartTime",
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              ChannelId: {
                locationName: "channelId"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              EndTime: {
                locationName: "endTime"
              },
              Id: {
                locationName: "id"
              },
              OriginEndpointId: {
                locationName: "originEndpointId"
              },
              S3Destination: {
                locationName: "s3Destination",
                shape: "Sd"
              },
              StartTime: {
                locationName: "startTime"
              },
              Status: {
                locationName: "status"
              }
            },
            type: "structure"
          }
        },
        CreateOriginEndpoint: {
          http: {
            requestUri: "/origin_endpoints",
            responseCode: 200
          },
          input: {
            members: {
              Authorization: {
                locationName: "authorization",
                shape: "Sh"
              },
              ChannelId: {
                locationName: "channelId"
              },
              CmafPackage: {
                locationName: "cmafPackage",
                shape: "Si"
              },
              DashPackage: {
                locationName: "dashPackage",
                shape: "S10"
              },
              Description: {
                locationName: "description"
              },
              HlsPackage: {
                locationName: "hlsPackage",
                shape: "S18"
              },
              Id: {
                locationName: "id"
              },
              ManifestName: {
                locationName: "manifestName"
              },
              MssPackage: {
                locationName: "mssPackage",
                shape: "S1b"
              },
              Origination: {
                locationName: "origination"
              },
              StartoverWindowSeconds: {
                locationName: "startoverWindowSeconds",
                type: "integer"
              },
              Tags: {
                locationName: "tags",
                shape: "S9"
              },
              TimeDelaySeconds: {
                locationName: "timeDelaySeconds",
                type: "integer"
              },
              Whitelist: {
                locationName: "whitelist",
                shape: "Sp"
              }
            },
            required: [
              "ChannelId",
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              Authorization: {
                locationName: "authorization",
                shape: "Sh"
              },
              ChannelId: {
                locationName: "channelId"
              },
              CmafPackage: {
                locationName: "cmafPackage",
                shape: "S1f"
              },
              DashPackage: {
                locationName: "dashPackage",
                shape: "S10"
              },
              Description: {
                locationName: "description"
              },
              HlsPackage: {
                locationName: "hlsPackage",
                shape: "S18"
              },
              Id: {
                locationName: "id"
              },
              ManifestName: {
                locationName: "manifestName"
              },
              MssPackage: {
                locationName: "mssPackage",
                shape: "S1b"
              },
              Origination: {
                locationName: "origination"
              },
              StartoverWindowSeconds: {
                locationName: "startoverWindowSeconds",
                type: "integer"
              },
              Tags: {
                locationName: "tags",
                shape: "S9"
              },
              TimeDelaySeconds: {
                locationName: "timeDelaySeconds",
                type: "integer"
              },
              Url: {
                locationName: "url"
              },
              Whitelist: {
                locationName: "whitelist",
                shape: "Sp"
              }
            },
            type: "structure"
          }
        },
        DeleteChannel: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{id}",
            responseCode: 202
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {},
            type: "structure"
          }
        },
        DeleteOriginEndpoint: {
          http: {
            method: "DELETE",
            requestUri: "/origin_endpoints/{id}",
            responseCode: 202
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {},
            type: "structure"
          }
        },
        DescribeChannel: {
          http: {
            method: "GET",
            requestUri: "/channels/{id}",
            responseCode: 200
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              Description: {
                locationName: "description"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              HlsIngest: {
                locationName: "hlsIngest",
                shape: "S6"
              },
              Id: {
                locationName: "id"
              },
              IngressAccessLogs: {
                locationName: "ingressAccessLogs",
                shape: "S4"
              },
              Tags: {
                locationName: "tags",
                shape: "S9"
              }
            },
            type: "structure"
          }
        },
        DescribeHarvestJob: {
          http: {
            method: "GET",
            requestUri: "/harvest_jobs/{id}",
            responseCode: 200
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              ChannelId: {
                locationName: "channelId"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              EndTime: {
                locationName: "endTime"
              },
              Id: {
                locationName: "id"
              },
              OriginEndpointId: {
                locationName: "originEndpointId"
              },
              S3Destination: {
                locationName: "s3Destination",
                shape: "Sd"
              },
              StartTime: {
                locationName: "startTime"
              },
              Status: {
                locationName: "status"
              }
            },
            type: "structure"
          }
        },
        DescribeOriginEndpoint: {
          http: {
            method: "GET",
            requestUri: "/origin_endpoints/{id}",
            responseCode: 200
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              Authorization: {
                locationName: "authorization",
                shape: "Sh"
              },
              ChannelId: {
                locationName: "channelId"
              },
              CmafPackage: {
                locationName: "cmafPackage",
                shape: "S1f"
              },
              DashPackage: {
                locationName: "dashPackage",
                shape: "S10"
              },
              Description: {
                locationName: "description"
              },
              HlsPackage: {
                locationName: "hlsPackage",
                shape: "S18"
              },
              Id: {
                locationName: "id"
              },
              ManifestName: {
                locationName: "manifestName"
              },
              MssPackage: {
                locationName: "mssPackage",
                shape: "S1b"
              },
              Origination: {
                locationName: "origination"
              },
              StartoverWindowSeconds: {
                locationName: "startoverWindowSeconds",
                type: "integer"
              },
              Tags: {
                locationName: "tags",
                shape: "S9"
              },
              TimeDelaySeconds: {
                locationName: "timeDelaySeconds",
                type: "integer"
              },
              Url: {
                locationName: "url"
              },
              Whitelist: {
                locationName: "whitelist",
                shape: "Sp"
              }
            },
            type: "structure"
          }
        },
        ListChannels: {
          http: {
            method: "GET",
            requestUri: "/channels",
            responseCode: 200
          },
          input: {
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            type: "structure"
          },
          output: {
            members: {
              Channels: {
                locationName: "channels",
                member: {
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    Description: {
                      locationName: "description"
                    },
                    EgressAccessLogs: {
                      locationName: "egressAccessLogs",
                      shape: "S2"
                    },
                    HlsIngest: {
                      locationName: "hlsIngest",
                      shape: "S6"
                    },
                    Id: {
                      locationName: "id"
                    },
                    IngressAccessLogs: {
                      locationName: "ingressAccessLogs",
                      shape: "S4"
                    },
                    Tags: {
                      locationName: "tags",
                      shape: "S9"
                    }
                  },
                  type: "structure"
                },
                type: "list"
              },
              NextToken: {
                locationName: "nextToken"
              }
            },
            type: "structure"
          }
        },
        ListHarvestJobs: {
          http: {
            method: "GET",
            requestUri: "/harvest_jobs",
            responseCode: 200
          },
          input: {
            members: {
              IncludeChannelId: {
                location: "querystring",
                locationName: "includeChannelId"
              },
              IncludeStatus: {
                location: "querystring",
                locationName: "includeStatus"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            type: "structure"
          },
          output: {
            members: {
              HarvestJobs: {
                locationName: "harvestJobs",
                member: {
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    ChannelId: {
                      locationName: "channelId"
                    },
                    CreatedAt: {
                      locationName: "createdAt"
                    },
                    EndTime: {
                      locationName: "endTime"
                    },
                    Id: {
                      locationName: "id"
                    },
                    OriginEndpointId: {
                      locationName: "originEndpointId"
                    },
                    S3Destination: {
                      locationName: "s3Destination",
                      shape: "Sd"
                    },
                    StartTime: {
                      locationName: "startTime"
                    },
                    Status: {
                      locationName: "status"
                    }
                  },
                  type: "structure"
                },
                type: "list"
              },
              NextToken: {
                locationName: "nextToken"
              }
            },
            type: "structure"
          }
        },
        ListOriginEndpoints: {
          http: {
            method: "GET",
            requestUri: "/origin_endpoints",
            responseCode: 200
          },
          input: {
            members: {
              ChannelId: {
                location: "querystring",
                locationName: "channelId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            type: "structure"
          },
          output: {
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              OriginEndpoints: {
                locationName: "originEndpoints",
                member: {
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    Authorization: {
                      locationName: "authorization",
                      shape: "Sh"
                    },
                    ChannelId: {
                      locationName: "channelId"
                    },
                    CmafPackage: {
                      locationName: "cmafPackage",
                      shape: "S1f"
                    },
                    DashPackage: {
                      locationName: "dashPackage",
                      shape: "S10"
                    },
                    Description: {
                      locationName: "description"
                    },
                    HlsPackage: {
                      locationName: "hlsPackage",
                      shape: "S18"
                    },
                    Id: {
                      locationName: "id"
                    },
                    ManifestName: {
                      locationName: "manifestName"
                    },
                    MssPackage: {
                      locationName: "mssPackage",
                      shape: "S1b"
                    },
                    Origination: {
                      locationName: "origination"
                    },
                    StartoverWindowSeconds: {
                      locationName: "startoverWindowSeconds",
                      type: "integer"
                    },
                    Tags: {
                      locationName: "tags",
                      shape: "S9"
                    },
                    TimeDelaySeconds: {
                      locationName: "timeDelaySeconds",
                      type: "integer"
                    },
                    Url: {
                      locationName: "url"
                    },
                    Whitelist: {
                      locationName: "whitelist",
                      shape: "Sp"
                    }
                  },
                  type: "structure"
                },
                type: "list"
              }
            },
            type: "structure"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ],
            type: "structure"
          },
          output: {
            members: {
              Tags: {
                locationName: "tags",
                shape: "S27"
              }
            },
            type: "structure"
          }
        },
        RotateChannelCredentials: {
          deprecated: true,
          deprecatedMessage: "This API is deprecated. Please use RotateIngestEndpointCredentials instead",
          http: {
            method: "PUT",
            requestUri: "/channels/{id}/credentials",
            responseCode: 200
          },
          input: {
            deprecated: true,
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            deprecated: true,
            members: {
              Arn: {
                locationName: "arn"
              },
              Description: {
                locationName: "description"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              HlsIngest: {
                locationName: "hlsIngest",
                shape: "S6"
              },
              Id: {
                locationName: "id"
              },
              IngressAccessLogs: {
                locationName: "ingressAccessLogs",
                shape: "S4"
              },
              Tags: {
                locationName: "tags",
                shape: "S9"
              }
            },
            type: "structure"
          }
        },
        RotateIngestEndpointCredentials: {
          http: {
            method: "PUT",
            requestUri: "/channels/{id}/ingest_endpoints/{ingest_endpoint_id}/credentials",
            responseCode: 200
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              },
              IngestEndpointId: {
                location: "uri",
                locationName: "ingest_endpoint_id"
              }
            },
            required: [
              "IngestEndpointId",
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              Description: {
                locationName: "description"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              HlsIngest: {
                locationName: "hlsIngest",
                shape: "S6"
              },
              Id: {
                locationName: "id"
              },
              IngressAccessLogs: {
                locationName: "ingressAccessLogs",
                shape: "S4"
              },
              Tags: {
                locationName: "tags",
                shape: "S9"
              }
            },
            type: "structure"
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              Tags: {
                locationName: "tags",
                shape: "S27"
              }
            },
            required: [
              "ResourceArn",
              "Tags"
            ],
            type: "structure"
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                shape: "Sp"
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ],
            type: "structure"
          }
        },
        UpdateChannel: {
          http: {
            method: "PUT",
            requestUri: "/channels/{id}",
            responseCode: 200
          },
          input: {
            members: {
              Description: {
                locationName: "description"
              },
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              Description: {
                locationName: "description"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              HlsIngest: {
                locationName: "hlsIngest",
                shape: "S6"
              },
              Id: {
                locationName: "id"
              },
              IngressAccessLogs: {
                locationName: "ingressAccessLogs",
                shape: "S4"
              },
              Tags: {
                locationName: "tags",
                shape: "S9"
              }
            },
            type: "structure"
          }
        },
        UpdateOriginEndpoint: {
          http: {
            method: "PUT",
            requestUri: "/origin_endpoints/{id}",
            responseCode: 200
          },
          input: {
            members: {
              Authorization: {
                locationName: "authorization",
                shape: "Sh"
              },
              CmafPackage: {
                locationName: "cmafPackage",
                shape: "Si"
              },
              DashPackage: {
                locationName: "dashPackage",
                shape: "S10"
              },
              Description: {
                locationName: "description"
              },
              HlsPackage: {
                locationName: "hlsPackage",
                shape: "S18"
              },
              Id: {
                location: "uri",
                locationName: "id"
              },
              ManifestName: {
                locationName: "manifestName"
              },
              MssPackage: {
                locationName: "mssPackage",
                shape: "S1b"
              },
              Origination: {
                locationName: "origination"
              },
              StartoverWindowSeconds: {
                locationName: "startoverWindowSeconds",
                type: "integer"
              },
              TimeDelaySeconds: {
                locationName: "timeDelaySeconds",
                type: "integer"
              },
              Whitelist: {
                locationName: "whitelist",
                shape: "Sp"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              Authorization: {
                locationName: "authorization",
                shape: "Sh"
              },
              ChannelId: {
                locationName: "channelId"
              },
              CmafPackage: {
                locationName: "cmafPackage",
                shape: "S1f"
              },
              DashPackage: {
                locationName: "dashPackage",
                shape: "S10"
              },
              Description: {
                locationName: "description"
              },
              HlsPackage: {
                locationName: "hlsPackage",
                shape: "S18"
              },
              Id: {
                locationName: "id"
              },
              ManifestName: {
                locationName: "manifestName"
              },
              MssPackage: {
                locationName: "mssPackage",
                shape: "S1b"
              },
              Origination: {
                locationName: "origination"
              },
              StartoverWindowSeconds: {
                locationName: "startoverWindowSeconds",
                type: "integer"
              },
              Tags: {
                locationName: "tags",
                shape: "S9"
              },
              TimeDelaySeconds: {
                locationName: "timeDelaySeconds",
                type: "integer"
              },
              Url: {
                locationName: "url"
              },
              Whitelist: {
                locationName: "whitelist",
                shape: "Sp"
              }
            },
            type: "structure"
          }
        }
      },
      shapes: {
        S2: {
          members: {
            LogGroupName: {
              locationName: "logGroupName"
            }
          },
          type: "structure"
        },
        S4: {
          members: {
            LogGroupName: {
              locationName: "logGroupName"
            }
          },
          type: "structure"
        },
        S6: {
          members: {
            IngestEndpoints: {
              locationName: "ingestEndpoints",
              member: {
                members: {
                  Id: {
                    locationName: "id"
                  },
                  Password: {
                    locationName: "password"
                  },
                  Url: {
                    locationName: "url"
                  },
                  Username: {
                    locationName: "username"
                  }
                },
                type: "structure"
              },
              type: "list"
            }
          },
          type: "structure"
        },
        S9: {
          key: {},
          type: "map",
          value: {}
        },
        Sd: {
          members: {
            BucketName: {
              locationName: "bucketName"
            },
            ManifestKey: {
              locationName: "manifestKey"
            },
            RoleArn: {
              locationName: "roleArn"
            }
          },
          required: [
            "ManifestKey",
            "BucketName",
            "RoleArn"
          ],
          type: "structure"
        },
        Sh: {
          members: {
            CdnIdentifierSecret: {
              locationName: "cdnIdentifierSecret"
            },
            SecretsRoleArn: {
              locationName: "secretsRoleArn"
            }
          },
          required: [
            "SecretsRoleArn",
            "CdnIdentifierSecret"
          ],
          type: "structure"
        },
        Si: {
          members: {
            Encryption: {
              locationName: "encryption",
              shape: "Sj"
            },
            HlsManifests: {
              locationName: "hlsManifests",
              member: {
                members: {
                  AdMarkers: {
                    locationName: "adMarkers"
                  },
                  AdTriggers: {
                    locationName: "adTriggers",
                    shape: "St"
                  },
                  AdsOnDeliveryRestrictions: {
                    locationName: "adsOnDeliveryRestrictions"
                  },
                  Id: {
                    locationName: "id"
                  },
                  IncludeIframeOnlyStream: {
                    locationName: "includeIframeOnlyStream",
                    type: "boolean"
                  },
                  ManifestName: {
                    locationName: "manifestName"
                  },
                  PlaylistType: {
                    locationName: "playlistType"
                  },
                  PlaylistWindowSeconds: {
                    locationName: "playlistWindowSeconds",
                    type: "integer"
                  },
                  ProgramDateTimeIntervalSeconds: {
                    locationName: "programDateTimeIntervalSeconds",
                    type: "integer"
                  }
                },
                required: [
                  "Id"
                ],
                type: "structure"
              },
              type: "list"
            },
            SegmentDurationSeconds: {
              locationName: "segmentDurationSeconds",
              type: "integer"
            },
            SegmentPrefix: {
              locationName: "segmentPrefix"
            },
            StreamSelection: {
              locationName: "streamSelection",
              shape: "Sy"
            }
          },
          type: "structure"
        },
        Sj: {
          members: {
            ConstantInitializationVector: {
              locationName: "constantInitializationVector"
            },
            KeyRotationIntervalSeconds: {
              locationName: "keyRotationIntervalSeconds",
              type: "integer"
            },
            SpekeKeyProvider: {
              locationName: "spekeKeyProvider",
              shape: "Sl"
            }
          },
          required: [
            "SpekeKeyProvider"
          ],
          type: "structure"
        },
        Sl: {
          members: {
            CertificateArn: {
              locationName: "certificateArn"
            },
            EncryptionContractConfiguration: {
              locationName: "encryptionContractConfiguration",
              members: {
                PresetSpeke20Audio: {
                  locationName: "presetSpeke20Audio"
                },
                PresetSpeke20Video: {
                  locationName: "presetSpeke20Video"
                }
              },
              required: [
                "PresetSpeke20Audio",
                "PresetSpeke20Video"
              ],
              type: "structure"
            },
            ResourceId: {
              locationName: "resourceId"
            },
            RoleArn: {
              locationName: "roleArn"
            },
            SystemIds: {
              locationName: "systemIds",
              shape: "Sp"
            },
            Url: {
              locationName: "url"
            }
          },
          required: [
            "ResourceId",
            "SystemIds",
            "Url",
            "RoleArn"
          ],
          type: "structure"
        },
        Sp: {
          member: {},
          type: "list"
        },
        St: {
          member: {},
          type: "list"
        },
        Sy: {
          members: {
            MaxVideoBitsPerSecond: {
              locationName: "maxVideoBitsPerSecond",
              type: "integer"
            },
            MinVideoBitsPerSecond: {
              locationName: "minVideoBitsPerSecond",
              type: "integer"
            },
            StreamOrder: {
              locationName: "streamOrder"
            }
          },
          type: "structure"
        },
        S10: {
          members: {
            AdTriggers: {
              locationName: "adTriggers",
              shape: "St"
            },
            AdsOnDeliveryRestrictions: {
              locationName: "adsOnDeliveryRestrictions"
            },
            Encryption: {
              locationName: "encryption",
              members: {
                KeyRotationIntervalSeconds: {
                  locationName: "keyRotationIntervalSeconds",
                  type: "integer"
                },
                SpekeKeyProvider: {
                  locationName: "spekeKeyProvider",
                  shape: "Sl"
                }
              },
              required: [
                "SpekeKeyProvider"
              ],
              type: "structure"
            },
            ManifestLayout: {
              locationName: "manifestLayout"
            },
            ManifestWindowSeconds: {
              locationName: "manifestWindowSeconds",
              type: "integer"
            },
            MinBufferTimeSeconds: {
              locationName: "minBufferTimeSeconds",
              type: "integer"
            },
            MinUpdatePeriodSeconds: {
              locationName: "minUpdatePeriodSeconds",
              type: "integer"
            },
            PeriodTriggers: {
              locationName: "periodTriggers",
              member: {},
              type: "list"
            },
            Profile: {
              locationName: "profile"
            },
            SegmentDurationSeconds: {
              locationName: "segmentDurationSeconds",
              type: "integer"
            },
            SegmentTemplateFormat: {
              locationName: "segmentTemplateFormat"
            },
            StreamSelection: {
              locationName: "streamSelection",
              shape: "Sy"
            },
            SuggestedPresentationDelaySeconds: {
              locationName: "suggestedPresentationDelaySeconds",
              type: "integer"
            },
            UtcTiming: {
              locationName: "utcTiming"
            },
            UtcTimingUri: {
              locationName: "utcTimingUri"
            }
          },
          type: "structure"
        },
        S18: {
          members: {
            AdMarkers: {
              locationName: "adMarkers"
            },
            AdTriggers: {
              locationName: "adTriggers",
              shape: "St"
            },
            AdsOnDeliveryRestrictions: {
              locationName: "adsOnDeliveryRestrictions"
            },
            Encryption: {
              locationName: "encryption",
              members: {
                ConstantInitializationVector: {
                  locationName: "constantInitializationVector"
                },
                EncryptionMethod: {
                  locationName: "encryptionMethod"
                },
                KeyRotationIntervalSeconds: {
                  locationName: "keyRotationIntervalSeconds",
                  type: "integer"
                },
                RepeatExtXKey: {
                  locationName: "repeatExtXKey",
                  type: "boolean"
                },
                SpekeKeyProvider: {
                  locationName: "spekeKeyProvider",
                  shape: "Sl"
                }
              },
              required: [
                "SpekeKeyProvider"
              ],
              type: "structure"
            },
            IncludeIframeOnlyStream: {
              locationName: "includeIframeOnlyStream",
              type: "boolean"
            },
            PlaylistType: {
              locationName: "playlistType"
            },
            PlaylistWindowSeconds: {
              locationName: "playlistWindowSeconds",
              type: "integer"
            },
            ProgramDateTimeIntervalSeconds: {
              locationName: "programDateTimeIntervalSeconds",
              type: "integer"
            },
            SegmentDurationSeconds: {
              locationName: "segmentDurationSeconds",
              type: "integer"
            },
            StreamSelection: {
              locationName: "streamSelection",
              shape: "Sy"
            },
            UseAudioRenditionGroup: {
              locationName: "useAudioRenditionGroup",
              type: "boolean"
            }
          },
          type: "structure"
        },
        S1b: {
          members: {
            Encryption: {
              locationName: "encryption",
              members: {
                SpekeKeyProvider: {
                  locationName: "spekeKeyProvider",
                  shape: "Sl"
                }
              },
              required: [
                "SpekeKeyProvider"
              ],
              type: "structure"
            },
            ManifestWindowSeconds: {
              locationName: "manifestWindowSeconds",
              type: "integer"
            },
            SegmentDurationSeconds: {
              locationName: "segmentDurationSeconds",
              type: "integer"
            },
            StreamSelection: {
              locationName: "streamSelection",
              shape: "Sy"
            }
          },
          type: "structure"
        },
        S1f: {
          members: {
            Encryption: {
              locationName: "encryption",
              shape: "Sj"
            },
            HlsManifests: {
              locationName: "hlsManifests",
              member: {
                members: {
                  AdMarkers: {
                    locationName: "adMarkers"
                  },
                  Id: {
                    locationName: "id"
                  },
                  IncludeIframeOnlyStream: {
                    locationName: "includeIframeOnlyStream",
                    type: "boolean"
                  },
                  ManifestName: {
                    locationName: "manifestName"
                  },
                  PlaylistType: {
                    locationName: "playlistType"
                  },
                  PlaylistWindowSeconds: {
                    locationName: "playlistWindowSeconds",
                    type: "integer"
                  },
                  ProgramDateTimeIntervalSeconds: {
                    locationName: "programDateTimeIntervalSeconds",
                    type: "integer"
                  },
                  Url: {
                    locationName: "url"
                  }
                },
                required: [
                  "Id"
                ],
                type: "structure"
              },
              type: "list"
            },
            SegmentDurationSeconds: {
              locationName: "segmentDurationSeconds",
              type: "integer"
            },
            SegmentPrefix: {
              locationName: "segmentPrefix"
            },
            StreamSelection: {
              locationName: "streamSelection",
              shape: "Sy"
            }
          },
          type: "structure"
        },
        S27: {
          key: {},
          type: "map",
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mediapackage-2017-10-12.paginators.json
var require_mediapackage_2017_10_12_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mediapackage-2017-10-12.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListChannels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Channels"
        },
        ListOriginEndpoints: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "OriginEndpoints"
        },
        ListHarvestJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "HarvestJobs"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mediapackage.js
var require_mediapackage = __commonJS({
  "node_modules/aws-sdk/clients/mediapackage.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["mediapackage"] = {};
    AWS3.MediaPackage = Service.defineService("mediapackage", ["2017-10-12"]);
    Object.defineProperty(apiLoader.services["mediapackage"], "2017-10-12", {
      get: function get() {
        var model = require_mediapackage_2017_10_12_min();
        model.paginators = require_mediapackage_2017_10_12_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.MediaPackage;
  }
});

// node_modules/aws-sdk/apis/mediastore-2017-09-01.min.json
var require_mediastore_2017_09_01_min = __commonJS({
  "node_modules/aws-sdk/apis/mediastore-2017-09-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-09-01",
        endpointPrefix: "mediastore",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "MediaStore",
        serviceFullName: "AWS Elemental MediaStore",
        serviceId: "MediaStore",
        signatureVersion: "v4",
        signingName: "mediastore",
        targetPrefix: "MediaStore_20170901",
        uid: "mediastore-2017-09-01"
      },
      operations: {
        CreateContainer: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {},
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Container"
            ],
            members: {
              Container: {
                shape: "S8"
              }
            }
          }
        },
        DeleteContainer: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteContainerPolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCorsPolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLifecyclePolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteMetricPolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeContainer: {
          input: {
            type: "structure",
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Container: {
                shape: "S8"
              }
            }
          }
        },
        GetContainerPolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Policy"
            ],
            members: {
              Policy: {}
            }
          }
        },
        GetCorsPolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "CorsPolicy"
            ],
            members: {
              CorsPolicy: {
                shape: "Sv"
              }
            }
          }
        },
        GetLifecyclePolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "LifecyclePolicy"
            ],
            members: {
              LifecyclePolicy: {}
            }
          }
        },
        GetMetricPolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "MetricPolicy"
            ],
            members: {
              MetricPolicy: {
                shape: "S1a"
              }
            }
          }
        },
        ListContainers: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Containers"
            ],
            members: {
              Containers: {
                type: "list",
                member: {
                  shape: "S8"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S3"
              }
            }
          }
        },
        PutContainerPolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName",
              "Policy"
            ],
            members: {
              ContainerName: {},
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutCorsPolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName",
              "CorsPolicy"
            ],
            members: {
              ContainerName: {},
              CorsPolicy: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutLifecyclePolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName",
              "LifecyclePolicy"
            ],
            members: {
              ContainerName: {},
              LifecyclePolicy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutMetricPolicy: {
          input: {
            type: "structure",
            required: [
              "ContainerName",
              "MetricPolicy"
            ],
            members: {
              ContainerName: {},
              MetricPolicy: {
                shape: "S1a"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartAccessLogging: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopAccessLogging: {
          input: {
            type: "structure",
            required: [
              "ContainerName"
            ],
            members: {
              ContainerName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "Resource",
              "Tags"
            ],
            members: {
              Resource: {},
              Tags: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "Resource",
              "TagKeys"
            ],
            members: {
              Resource: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S8: {
          type: "structure",
          members: {
            Endpoint: {},
            CreationTime: {
              type: "timestamp"
            },
            ARN: {},
            Name: {},
            Status: {},
            AccessLoggingEnabled: {
              type: "boolean"
            }
          }
        },
        Sv: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AllowedOrigins",
              "AllowedHeaders"
            ],
            members: {
              AllowedOrigins: {
                type: "list",
                member: {}
              },
              AllowedMethods: {
                type: "list",
                member: {}
              },
              AllowedHeaders: {
                type: "list",
                member: {}
              },
              MaxAgeSeconds: {
                type: "integer"
              },
              ExposeHeaders: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S1a: {
          type: "structure",
          required: [
            "ContainerLevelMetrics"
          ],
          members: {
            ContainerLevelMetrics: {},
            MetricPolicyRules: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ObjectGroup",
                  "ObjectGroupName"
                ],
                members: {
                  ObjectGroup: {},
                  ObjectGroupName: {}
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mediastore-2017-09-01.paginators.json
var require_mediastore_2017_09_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mediastore-2017-09-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListContainers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mediastore.js
var require_mediastore = __commonJS({
  "node_modules/aws-sdk/clients/mediastore.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["mediastore"] = {};
    AWS3.MediaStore = Service.defineService("mediastore", ["2017-09-01"]);
    Object.defineProperty(apiLoader.services["mediastore"], "2017-09-01", {
      get: function get() {
        var model = require_mediastore_2017_09_01_min();
        model.paginators = require_mediastore_2017_09_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.MediaStore;
  }
});

// node_modules/aws-sdk/apis/mediastore-data-2017-09-01.min.json
var require_mediastore_data_2017_09_01_min = __commonJS({
  "node_modules/aws-sdk/apis/mediastore-data-2017-09-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-09-01",
        endpointPrefix: "data.mediastore",
        protocol: "rest-json",
        serviceAbbreviation: "MediaStore Data",
        serviceFullName: "AWS Elemental MediaStore Data Plane",
        serviceId: "MediaStore Data",
        signatureVersion: "v4",
        signingName: "mediastore",
        uid: "mediastore-data-2017-09-01"
      },
      operations: {
        DeleteObject: {
          http: {
            method: "DELETE",
            requestUri: "/{Path+}"
          },
          input: {
            type: "structure",
            required: [
              "Path"
            ],
            members: {
              Path: {
                location: "uri",
                locationName: "Path"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeObject: {
          http: {
            method: "HEAD",
            requestUri: "/{Path+}"
          },
          input: {
            type: "structure",
            required: [
              "Path"
            ],
            members: {
              Path: {
                location: "uri",
                locationName: "Path"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ETag: {
                location: "header",
                locationName: "ETag"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              ContentLength: {
                location: "header",
                locationName: "Content-Length",
                type: "long"
              },
              CacheControl: {
                location: "header",
                locationName: "Cache-Control"
              },
              LastModified: {
                location: "header",
                locationName: "Last-Modified",
                type: "timestamp"
              }
            }
          }
        },
        GetObject: {
          http: {
            method: "GET",
            requestUri: "/{Path+}"
          },
          input: {
            type: "structure",
            required: [
              "Path"
            ],
            members: {
              Path: {
                location: "uri",
                locationName: "Path"
              },
              Range: {
                location: "header",
                locationName: "Range"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "StatusCode"
            ],
            members: {
              Body: {
                shape: "Se"
              },
              CacheControl: {
                location: "header",
                locationName: "Cache-Control"
              },
              ContentRange: {
                location: "header",
                locationName: "Content-Range"
              },
              ContentLength: {
                location: "header",
                locationName: "Content-Length",
                type: "long"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              ETag: {
                location: "header",
                locationName: "ETag"
              },
              LastModified: {
                location: "header",
                locationName: "Last-Modified",
                type: "timestamp"
              },
              StatusCode: {
                location: "statusCode",
                type: "integer"
              }
            },
            payload: "Body"
          }
        },
        ListItems: {
          http: {
            method: "GET"
          },
          input: {
            type: "structure",
            members: {
              Path: {
                location: "querystring",
                locationName: "Path"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Type: {},
                    ETag: {},
                    LastModified: {
                      type: "timestamp"
                    },
                    ContentType: {},
                    ContentLength: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        PutObject: {
          http: {
            method: "PUT",
            requestUri: "/{Path+}"
          },
          input: {
            type: "structure",
            required: [
              "Body",
              "Path"
            ],
            members: {
              Body: {
                shape: "Se"
              },
              Path: {
                location: "uri",
                locationName: "Path"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              CacheControl: {
                location: "header",
                locationName: "Cache-Control"
              },
              StorageClass: {
                location: "header",
                locationName: "x-amz-storage-class"
              },
              UploadAvailability: {
                location: "header",
                locationName: "x-amz-upload-availability"
              }
            },
            payload: "Body"
          },
          output: {
            type: "structure",
            members: {
              ContentSHA256: {},
              ETag: {},
              StorageClass: {}
            }
          },
          authtype: "v4-unsigned-body"
        }
      },
      shapes: {
        Se: {
          type: "blob",
          streaming: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mediastore-data-2017-09-01.paginators.json
var require_mediastore_data_2017_09_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mediastore-data-2017-09-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListItems: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mediastoredata.js
var require_mediastoredata = __commonJS({
  "node_modules/aws-sdk/clients/mediastoredata.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["mediastoredata"] = {};
    AWS3.MediaStoreData = Service.defineService("mediastoredata", ["2017-09-01"]);
    Object.defineProperty(apiLoader.services["mediastoredata"], "2017-09-01", {
      get: function get() {
        var model = require_mediastore_data_2017_09_01_min();
        model.paginators = require_mediastore_data_2017_09_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.MediaStoreData;
  }
});

// node_modules/aws-sdk/apis/appsync-2017-07-25.min.json
var require_appsync_2017_07_25_min = __commonJS({
  "node_modules/aws-sdk/apis/appsync-2017-07-25.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-25",
        endpointPrefix: "appsync",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "AWSAppSync",
        serviceFullName: "AWS AppSync",
        serviceId: "AppSync",
        signatureVersion: "v4",
        signingName: "appsync",
        uid: "appsync-2017-07-25"
      },
      operations: {
        CreateApiCache: {
          http: {
            requestUri: "/v1/apis/{apiId}/ApiCaches"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "ttl",
              "apiCachingBehavior",
              "type"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              ttl: {
                type: "long"
              },
              transitEncryptionEnabled: {
                type: "boolean"
              },
              atRestEncryptionEnabled: {
                type: "boolean"
              },
              apiCachingBehavior: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              apiCache: {
                shape: "S8"
              }
            }
          }
        },
        CreateApiKey: {
          http: {
            requestUri: "/v1/apis/{apiId}/apikeys"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              description: {},
              expires: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              apiKey: {
                shape: "Sc"
              }
            }
          }
        },
        CreateDataSource: {
          http: {
            requestUri: "/v1/apis/{apiId}/datasources"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "name",
              "type"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              name: {},
              description: {},
              type: {},
              serviceRoleArn: {},
              dynamodbConfig: {
                shape: "Sg"
              },
              lambdaConfig: {
                shape: "Si"
              },
              elasticsearchConfig: {
                shape: "Sj"
              },
              openSearchServiceConfig: {
                shape: "Sk"
              },
              httpConfig: {
                shape: "Sl"
              },
              relationalDatabaseConfig: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataSource: {
                shape: "St"
              }
            }
          }
        },
        CreateFunction: {
          http: {
            requestUri: "/v1/apis/{apiId}/functions"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "name",
              "dataSourceName",
              "functionVersion"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              name: {},
              description: {},
              dataSourceName: {},
              requestMappingTemplate: {},
              responseMappingTemplate: {},
              functionVersion: {},
              syncConfig: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              functionConfiguration: {
                shape: "S11"
              }
            }
          }
        },
        CreateGraphqlApi: {
          http: {
            requestUri: "/v1/apis"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "authenticationType"
            ],
            members: {
              name: {},
              logConfig: {
                shape: "S13"
              },
              authenticationType: {},
              userPoolConfig: {
                shape: "S16"
              },
              openIDConnectConfig: {
                shape: "S18"
              },
              tags: {
                shape: "S19"
              },
              additionalAuthenticationProviders: {
                shape: "S1c"
              },
              xrayEnabled: {
                type: "boolean"
              },
              lambdaAuthorizerConfig: {
                shape: "S1f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              graphqlApi: {
                shape: "S1i"
              }
            }
          }
        },
        CreateResolver: {
          http: {
            requestUri: "/v1/apis/{apiId}/types/{typeName}/resolvers"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "typeName",
              "fieldName"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              typeName: {
                location: "uri",
                locationName: "typeName"
              },
              fieldName: {},
              dataSourceName: {},
              requestMappingTemplate: {},
              responseMappingTemplate: {},
              kind: {},
              pipelineConfig: {
                shape: "S1m"
              },
              syncConfig: {
                shape: "Sw"
              },
              cachingConfig: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resolver: {
                shape: "S1r"
              }
            }
          }
        },
        CreateType: {
          http: {
            requestUri: "/v1/apis/{apiId}/types"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "definition",
              "format"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              definition: {},
              format: {}
            }
          },
          output: {
            type: "structure",
            members: {
              type: {
                shape: "S1v"
              }
            }
          }
        },
        DeleteApiCache: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apis/{apiId}/ApiCaches"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApiKey: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apis/{apiId}/apikeys/{id}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "id"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDataSource: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apis/{apiId}/datasources/{name}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "name"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteFunction: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apis/{apiId}/functions/{functionId}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "functionId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              functionId: {
                location: "uri",
                locationName: "functionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteGraphqlApi: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apis/{apiId}"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteResolver: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apis/{apiId}/types/{typeName}/resolvers/{fieldName}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "typeName",
              "fieldName"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              typeName: {
                location: "uri",
                locationName: "typeName"
              },
              fieldName: {
                location: "uri",
                locationName: "fieldName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteType: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apis/{apiId}/types/{typeName}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "typeName"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              typeName: {
                location: "uri",
                locationName: "typeName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        FlushApiCache: {
          http: {
            method: "DELETE",
            requestUri: "/v1/apis/{apiId}/FlushCache"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetApiCache: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/ApiCaches"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              apiCache: {
                shape: "S8"
              }
            }
          }
        },
        GetDataSource: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/datasources/{name}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "name"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataSource: {
                shape: "St"
              }
            }
          }
        },
        GetFunction: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/functions/{functionId}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "functionId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              functionId: {
                location: "uri",
                locationName: "functionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              functionConfiguration: {
                shape: "S11"
              }
            }
          }
        },
        GetGraphqlApi: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              graphqlApi: {
                shape: "S1i"
              }
            }
          }
        },
        GetIntrospectionSchema: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/schema"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "format"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              includeDirectives: {
                location: "querystring",
                locationName: "includeDirectives",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              schema: {
                type: "blob"
              }
            },
            payload: "schema"
          }
        },
        GetResolver: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/types/{typeName}/resolvers/{fieldName}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "typeName",
              "fieldName"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              typeName: {
                location: "uri",
                locationName: "typeName"
              },
              fieldName: {
                location: "uri",
                locationName: "fieldName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resolver: {
                shape: "S1r"
              }
            }
          }
        },
        GetSchemaCreationStatus: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/schemacreation"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {},
              details: {}
            }
          }
        },
        GetType: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/types/{typeName}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "typeName",
              "format"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              typeName: {
                location: "uri",
                locationName: "typeName"
              },
              format: {
                location: "querystring",
                locationName: "format"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              type: {
                shape: "S1v"
              }
            }
          }
        },
        ListApiKeys: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/apikeys"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              apiKeys: {
                type: "list",
                member: {
                  shape: "Sc"
                }
              },
              nextToken: {}
            }
          }
        },
        ListDataSources: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/datasources"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataSources: {
                type: "list",
                member: {
                  shape: "St"
                }
              },
              nextToken: {}
            }
          }
        },
        ListFunctions: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/functions"
          },
          input: {
            type: "structure",
            required: [
              "apiId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              functions: {
                type: "list",
                member: {
                  shape: "S11"
                }
              },
              nextToken: {}
            }
          }
        },
        ListGraphqlApis: {
          http: {
            method: "GET",
            requestUri: "/v1/apis"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              graphqlApis: {
                type: "list",
                member: {
                  shape: "S1i"
                }
              },
              nextToken: {}
            }
          }
        },
        ListResolvers: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/types/{typeName}/resolvers"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "typeName"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              typeName: {
                location: "uri",
                locationName: "typeName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resolvers: {
                shape: "S3c"
              },
              nextToken: {}
            }
          }
        },
        ListResolversByFunction: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/functions/{functionId}/resolvers"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "functionId"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              functionId: {
                location: "uri",
                locationName: "functionId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resolvers: {
                shape: "S3c"
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/v1/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S19"
              }
            }
          }
        },
        ListTypes: {
          http: {
            method: "GET",
            requestUri: "/v1/apis/{apiId}/types"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "format"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              types: {
                type: "list",
                member: {
                  shape: "S1v"
                }
              },
              nextToken: {}
            }
          }
        },
        StartSchemaCreation: {
          http: {
            requestUri: "/v1/apis/{apiId}/schemacreation"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "definition"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              definition: {
                type: "blob"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/v1/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/v1/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApiCache: {
          http: {
            requestUri: "/v1/apis/{apiId}/ApiCaches/update"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "ttl",
              "apiCachingBehavior",
              "type"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              ttl: {
                type: "long"
              },
              apiCachingBehavior: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              apiCache: {
                shape: "S8"
              }
            }
          }
        },
        UpdateApiKey: {
          http: {
            requestUri: "/v1/apis/{apiId}/apikeys/{id}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "id"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              id: {
                location: "uri",
                locationName: "id"
              },
              description: {},
              expires: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              apiKey: {
                shape: "Sc"
              }
            }
          }
        },
        UpdateDataSource: {
          http: {
            requestUri: "/v1/apis/{apiId}/datasources/{name}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "name",
              "type"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              name: {
                location: "uri",
                locationName: "name"
              },
              description: {},
              type: {},
              serviceRoleArn: {},
              dynamodbConfig: {
                shape: "Sg"
              },
              lambdaConfig: {
                shape: "Si"
              },
              elasticsearchConfig: {
                shape: "Sj"
              },
              openSearchServiceConfig: {
                shape: "Sk"
              },
              httpConfig: {
                shape: "Sl"
              },
              relationalDatabaseConfig: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataSource: {
                shape: "St"
              }
            }
          }
        },
        UpdateFunction: {
          http: {
            requestUri: "/v1/apis/{apiId}/functions/{functionId}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "name",
              "functionId",
              "dataSourceName",
              "functionVersion"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              name: {},
              description: {},
              functionId: {
                location: "uri",
                locationName: "functionId"
              },
              dataSourceName: {},
              requestMappingTemplate: {},
              responseMappingTemplate: {},
              functionVersion: {},
              syncConfig: {
                shape: "Sw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              functionConfiguration: {
                shape: "S11"
              }
            }
          }
        },
        UpdateGraphqlApi: {
          http: {
            requestUri: "/v1/apis/{apiId}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "name"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              name: {},
              logConfig: {
                shape: "S13"
              },
              authenticationType: {},
              userPoolConfig: {
                shape: "S16"
              },
              openIDConnectConfig: {
                shape: "S18"
              },
              additionalAuthenticationProviders: {
                shape: "S1c"
              },
              xrayEnabled: {
                type: "boolean"
              },
              lambdaAuthorizerConfig: {
                shape: "S1f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              graphqlApi: {
                shape: "S1i"
              }
            }
          }
        },
        UpdateResolver: {
          http: {
            requestUri: "/v1/apis/{apiId}/types/{typeName}/resolvers/{fieldName}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "typeName",
              "fieldName"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              typeName: {
                location: "uri",
                locationName: "typeName"
              },
              fieldName: {
                location: "uri",
                locationName: "fieldName"
              },
              dataSourceName: {},
              requestMappingTemplate: {},
              responseMappingTemplate: {},
              kind: {},
              pipelineConfig: {
                shape: "S1m"
              },
              syncConfig: {
                shape: "Sw"
              },
              cachingConfig: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resolver: {
                shape: "S1r"
              }
            }
          }
        },
        UpdateType: {
          http: {
            requestUri: "/v1/apis/{apiId}/types/{typeName}"
          },
          input: {
            type: "structure",
            required: [
              "apiId",
              "typeName",
              "format"
            ],
            members: {
              apiId: {
                location: "uri",
                locationName: "apiId"
              },
              typeName: {
                location: "uri",
                locationName: "typeName"
              },
              definition: {},
              format: {}
            }
          },
          output: {
            type: "structure",
            members: {
              type: {
                shape: "S1v"
              }
            }
          }
        }
      },
      shapes: {
        S8: {
          type: "structure",
          members: {
            ttl: {
              type: "long"
            },
            apiCachingBehavior: {},
            transitEncryptionEnabled: {
              type: "boolean"
            },
            atRestEncryptionEnabled: {
              type: "boolean"
            },
            type: {},
            status: {}
          }
        },
        Sc: {
          type: "structure",
          members: {
            id: {},
            description: {},
            expires: {
              type: "long"
            },
            deletes: {
              type: "long"
            }
          }
        },
        Sg: {
          type: "structure",
          required: [
            "tableName",
            "awsRegion"
          ],
          members: {
            tableName: {},
            awsRegion: {},
            useCallerCredentials: {
              type: "boolean"
            },
            deltaSyncConfig: {
              type: "structure",
              members: {
                baseTableTTL: {
                  type: "long"
                },
                deltaSyncTableName: {},
                deltaSyncTableTTL: {
                  type: "long"
                }
              }
            },
            versioned: {
              type: "boolean"
            }
          }
        },
        Si: {
          type: "structure",
          required: [
            "lambdaFunctionArn"
          ],
          members: {
            lambdaFunctionArn: {}
          }
        },
        Sj: {
          type: "structure",
          required: [
            "endpoint",
            "awsRegion"
          ],
          members: {
            endpoint: {},
            awsRegion: {}
          }
        },
        Sk: {
          type: "structure",
          required: [
            "endpoint",
            "awsRegion"
          ],
          members: {
            endpoint: {},
            awsRegion: {}
          }
        },
        Sl: {
          type: "structure",
          members: {
            endpoint: {},
            authorizationConfig: {
              type: "structure",
              required: [
                "authorizationType"
              ],
              members: {
                authorizationType: {},
                awsIamConfig: {
                  type: "structure",
                  members: {
                    signingRegion: {},
                    signingServiceName: {}
                  }
                }
              }
            }
          }
        },
        Sp: {
          type: "structure",
          members: {
            relationalDatabaseSourceType: {},
            rdsHttpEndpointConfig: {
              type: "structure",
              members: {
                awsRegion: {},
                dbClusterIdentifier: {},
                databaseName: {},
                schema: {},
                awsSecretStoreArn: {}
              }
            }
          }
        },
        St: {
          type: "structure",
          members: {
            dataSourceArn: {},
            name: {},
            description: {},
            type: {},
            serviceRoleArn: {},
            dynamodbConfig: {
              shape: "Sg"
            },
            lambdaConfig: {
              shape: "Si"
            },
            elasticsearchConfig: {
              shape: "Sj"
            },
            openSearchServiceConfig: {
              shape: "Sk"
            },
            httpConfig: {
              shape: "Sl"
            },
            relationalDatabaseConfig: {
              shape: "Sp"
            }
          }
        },
        Sw: {
          type: "structure",
          members: {
            conflictHandler: {},
            conflictDetection: {},
            lambdaConflictHandlerConfig: {
              type: "structure",
              members: {
                lambdaConflictHandlerArn: {}
              }
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            functionId: {},
            functionArn: {},
            name: {},
            description: {},
            dataSourceName: {},
            requestMappingTemplate: {},
            responseMappingTemplate: {},
            functionVersion: {},
            syncConfig: {
              shape: "Sw"
            }
          }
        },
        S13: {
          type: "structure",
          required: [
            "fieldLogLevel",
            "cloudWatchLogsRoleArn"
          ],
          members: {
            fieldLogLevel: {},
            cloudWatchLogsRoleArn: {},
            excludeVerboseContent: {
              type: "boolean"
            }
          }
        },
        S16: {
          type: "structure",
          required: [
            "userPoolId",
            "awsRegion",
            "defaultAction"
          ],
          members: {
            userPoolId: {},
            awsRegion: {},
            defaultAction: {},
            appIdClientRegex: {}
          }
        },
        S18: {
          type: "structure",
          required: [
            "issuer"
          ],
          members: {
            issuer: {},
            clientId: {},
            iatTTL: {
              type: "long"
            },
            authTTL: {
              type: "long"
            }
          }
        },
        S19: {
          type: "map",
          key: {},
          value: {}
        },
        S1c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              authenticationType: {},
              openIDConnectConfig: {
                shape: "S18"
              },
              userPoolConfig: {
                type: "structure",
                required: [
                  "userPoolId",
                  "awsRegion"
                ],
                members: {
                  userPoolId: {},
                  awsRegion: {},
                  appIdClientRegex: {}
                }
              },
              lambdaAuthorizerConfig: {
                shape: "S1f"
              }
            }
          }
        },
        S1f: {
          type: "structure",
          required: [
            "authorizerUri"
          ],
          members: {
            authorizerResultTtlInSeconds: {
              type: "integer"
            },
            authorizerUri: {},
            identityValidationExpression: {}
          }
        },
        S1i: {
          type: "structure",
          members: {
            name: {},
            apiId: {},
            authenticationType: {},
            logConfig: {
              shape: "S13"
            },
            userPoolConfig: {
              shape: "S16"
            },
            openIDConnectConfig: {
              shape: "S18"
            },
            arn: {},
            uris: {
              type: "map",
              key: {},
              value: {}
            },
            tags: {
              shape: "S19"
            },
            additionalAuthenticationProviders: {
              shape: "S1c"
            },
            xrayEnabled: {
              type: "boolean"
            },
            wafWebAclArn: {},
            lambdaAuthorizerConfig: {
              shape: "S1f"
            }
          }
        },
        S1m: {
          type: "structure",
          members: {
            functions: {
              type: "list",
              member: {}
            }
          }
        },
        S1o: {
          type: "structure",
          members: {
            ttl: {
              type: "long"
            },
            cachingKeys: {
              type: "list",
              member: {}
            }
          }
        },
        S1r: {
          type: "structure",
          members: {
            typeName: {},
            fieldName: {},
            dataSourceName: {},
            resolverArn: {},
            requestMappingTemplate: {},
            responseMappingTemplate: {},
            kind: {},
            pipelineConfig: {
              shape: "S1m"
            },
            syncConfig: {
              shape: "Sw"
            },
            cachingConfig: {
              shape: "S1o"
            }
          }
        },
        S1v: {
          type: "structure",
          members: {
            name: {},
            description: {},
            arn: {},
            definition: {},
            format: {}
          }
        },
        S3c: {
          type: "list",
          member: {
            shape: "S1r"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/appsync-2017-07-25.paginators.json
var require_appsync_2017_07_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/appsync-2017-07-25.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/appsync.js
var require_appsync = __commonJS({
  "node_modules/aws-sdk/clients/appsync.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["appsync"] = {};
    AWS3.AppSync = Service.defineService("appsync", ["2017-07-25"]);
    Object.defineProperty(apiLoader.services["appsync"], "2017-07-25", {
      get: function get() {
        var model = require_appsync_2017_07_25_min();
        model.paginators = require_appsync_2017_07_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.AppSync;
  }
});

// node_modules/aws-sdk/apis/guardduty-2017-11-28.min.json
var require_guardduty_2017_11_28_min = __commonJS({
  "node_modules/aws-sdk/apis/guardduty-2017-11-28.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-11-28",
        endpointPrefix: "guardduty",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon GuardDuty",
        serviceId: "GuardDuty",
        signatureVersion: "v4",
        signingName: "guardduty",
        uid: "guardduty-2017-11-28"
      },
      operations: {
        AcceptInvitation: {
          http: {
            requestUri: "/detector/{detectorId}/master",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "MasterId",
              "InvitationId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              MasterId: {
                locationName: "masterId"
              },
              InvitationId: {
                locationName: "invitationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ArchiveFindings: {
          http: {
            requestUri: "/detector/{detectorId}/findings/archive",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "FindingIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FindingIds: {
                shape: "S6",
                locationName: "findingIds"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDetector: {
          http: {
            requestUri: "/detector",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Enable"
            ],
            members: {
              Enable: {
                locationName: "enable",
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true,
                locationName: "clientToken"
              },
              FindingPublishingFrequency: {
                locationName: "findingPublishingFrequency"
              },
              DataSources: {
                shape: "Sd",
                locationName: "dataSources"
              },
              Tags: {
                shape: "Sf",
                locationName: "tags"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DetectorId: {
                locationName: "detectorId"
              }
            }
          }
        },
        CreateFilter: {
          http: {
            requestUri: "/detector/{detectorId}/filter",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "Name",
              "FindingCriteria"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              Name: {
                locationName: "name"
              },
              Description: {
                locationName: "description"
              },
              Action: {
                locationName: "action"
              },
              Rank: {
                locationName: "rank",
                type: "integer"
              },
              FindingCriteria: {
                shape: "So",
                locationName: "findingCriteria"
              },
              ClientToken: {
                idempotencyToken: true,
                locationName: "clientToken"
              },
              Tags: {
                shape: "Sf",
                locationName: "tags"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                locationName: "name"
              }
            }
          }
        },
        CreateIPSet: {
          http: {
            requestUri: "/detector/{detectorId}/ipset",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "Name",
              "Format",
              "Location",
              "Activate"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              Name: {
                locationName: "name"
              },
              Format: {
                locationName: "format"
              },
              Location: {
                locationName: "location"
              },
              Activate: {
                locationName: "activate",
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true,
                locationName: "clientToken"
              },
              Tags: {
                shape: "Sf",
                locationName: "tags"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "IpSetId"
            ],
            members: {
              IpSetId: {
                locationName: "ipSetId"
              }
            }
          }
        },
        CreateMembers: {
          http: {
            requestUri: "/detector/{detectorId}/member",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "AccountDetails"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AccountDetails: {
                locationName: "accountDetails",
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AccountId",
                    "Email"
                  ],
                  members: {
                    AccountId: {
                      locationName: "accountId"
                    },
                    Email: {
                      locationName: "email"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UnprocessedAccounts"
            ],
            members: {
              UnprocessedAccounts: {
                shape: "S19",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        CreatePublishingDestination: {
          http: {
            requestUri: "/detector/{detectorId}/publishingDestination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "DestinationType",
              "DestinationProperties"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              DestinationType: {
                locationName: "destinationType"
              },
              DestinationProperties: {
                shape: "S1d",
                locationName: "destinationProperties"
              },
              ClientToken: {
                idempotencyToken: true,
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DestinationId"
            ],
            members: {
              DestinationId: {
                locationName: "destinationId"
              }
            }
          }
        },
        CreateSampleFindings: {
          http: {
            requestUri: "/detector/{detectorId}/findings/create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FindingTypes: {
                locationName: "findingTypes",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateThreatIntelSet: {
          http: {
            requestUri: "/detector/{detectorId}/threatintelset",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "Name",
              "Format",
              "Location",
              "Activate"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              Name: {
                locationName: "name"
              },
              Format: {
                locationName: "format"
              },
              Location: {
                locationName: "location"
              },
              Activate: {
                locationName: "activate",
                type: "boolean"
              },
              ClientToken: {
                idempotencyToken: true,
                locationName: "clientToken"
              },
              Tags: {
                shape: "Sf",
                locationName: "tags"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ThreatIntelSetId"
            ],
            members: {
              ThreatIntelSetId: {
                locationName: "threatIntelSetId"
              }
            }
          }
        },
        DeclineInvitations: {
          http: {
            requestUri: "/invitation/decline",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountIds"
            ],
            members: {
              AccountIds: {
                shape: "S1n",
                locationName: "accountIds"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UnprocessedAccounts"
            ],
            members: {
              UnprocessedAccounts: {
                shape: "S19",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        DeleteDetector: {
          http: {
            method: "DELETE",
            requestUri: "/detector/{detectorId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteFilter: {
          http: {
            method: "DELETE",
            requestUri: "/detector/{detectorId}/filter/{filterName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "FilterName"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FilterName: {
                location: "uri",
                locationName: "filterName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteIPSet: {
          http: {
            method: "DELETE",
            requestUri: "/detector/{detectorId}/ipset/{ipSetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "IpSetId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              IpSetId: {
                location: "uri",
                locationName: "ipSetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteInvitations: {
          http: {
            requestUri: "/invitation/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountIds"
            ],
            members: {
              AccountIds: {
                shape: "S1n",
                locationName: "accountIds"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UnprocessedAccounts"
            ],
            members: {
              UnprocessedAccounts: {
                shape: "S19",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        DeleteMembers: {
          http: {
            requestUri: "/detector/{detectorId}/member/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "AccountIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AccountIds: {
                shape: "S1n",
                locationName: "accountIds"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UnprocessedAccounts"
            ],
            members: {
              UnprocessedAccounts: {
                shape: "S19",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        DeletePublishingDestination: {
          http: {
            method: "DELETE",
            requestUri: "/detector/{detectorId}/publishingDestination/{destinationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "DestinationId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              DestinationId: {
                location: "uri",
                locationName: "destinationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteThreatIntelSet: {
          http: {
            method: "DELETE",
            requestUri: "/detector/{detectorId}/threatintelset/{threatIntelSetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "ThreatIntelSetId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              ThreatIntelSetId: {
                location: "uri",
                locationName: "threatIntelSetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeOrganizationConfiguration: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/admin",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AutoEnable",
              "MemberAccountLimitReached"
            ],
            members: {
              AutoEnable: {
                locationName: "autoEnable",
                type: "boolean"
              },
              MemberAccountLimitReached: {
                locationName: "memberAccountLimitReached",
                type: "boolean"
              },
              DataSources: {
                locationName: "dataSources",
                type: "structure",
                required: [
                  "S3Logs"
                ],
                members: {
                  S3Logs: {
                    locationName: "s3Logs",
                    type: "structure",
                    required: [
                      "AutoEnable"
                    ],
                    members: {
                      AutoEnable: {
                        locationName: "autoEnable",
                        type: "boolean"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribePublishingDestination: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/publishingDestination/{destinationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "DestinationId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              DestinationId: {
                location: "uri",
                locationName: "destinationId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DestinationId",
              "DestinationType",
              "Status",
              "PublishingFailureStartTimestamp",
              "DestinationProperties"
            ],
            members: {
              DestinationId: {
                locationName: "destinationId"
              },
              DestinationType: {
                locationName: "destinationType"
              },
              Status: {
                locationName: "status"
              },
              PublishingFailureStartTimestamp: {
                locationName: "publishingFailureStartTimestamp",
                type: "long"
              },
              DestinationProperties: {
                shape: "S1d",
                locationName: "destinationProperties"
              }
            }
          }
        },
        DisableOrganizationAdminAccount: {
          http: {
            requestUri: "/admin/disable",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AdminAccountId"
            ],
            members: {
              AdminAccountId: {
                locationName: "adminAccountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateFromMasterAccount: {
          http: {
            requestUri: "/detector/{detectorId}/master/disassociate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateMembers: {
          http: {
            requestUri: "/detector/{detectorId}/member/disassociate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "AccountIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AccountIds: {
                shape: "S1n",
                locationName: "accountIds"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UnprocessedAccounts"
            ],
            members: {
              UnprocessedAccounts: {
                shape: "S19",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        EnableOrganizationAdminAccount: {
          http: {
            requestUri: "/admin/enable",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AdminAccountId"
            ],
            members: {
              AdminAccountId: {
                locationName: "adminAccountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetDetector: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ServiceRole",
              "Status"
            ],
            members: {
              CreatedAt: {
                locationName: "createdAt"
              },
              FindingPublishingFrequency: {
                locationName: "findingPublishingFrequency"
              },
              ServiceRole: {
                locationName: "serviceRole"
              },
              Status: {
                locationName: "status"
              },
              UpdatedAt: {
                locationName: "updatedAt"
              },
              DataSources: {
                shape: "S2l",
                locationName: "dataSources"
              },
              Tags: {
                shape: "Sf",
                locationName: "tags"
              }
            }
          }
        },
        GetFilter: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/filter/{filterName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "FilterName"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FilterName: {
                location: "uri",
                locationName: "filterName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name",
              "Action",
              "FindingCriteria"
            ],
            members: {
              Name: {
                locationName: "name"
              },
              Description: {
                locationName: "description"
              },
              Action: {
                locationName: "action"
              },
              Rank: {
                locationName: "rank",
                type: "integer"
              },
              FindingCriteria: {
                shape: "So",
                locationName: "findingCriteria"
              },
              Tags: {
                shape: "Sf",
                locationName: "tags"
              }
            }
          }
        },
        GetFindings: {
          http: {
            requestUri: "/detector/{detectorId}/findings/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "FindingIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FindingIds: {
                shape: "S6",
                locationName: "findingIds"
              },
              SortCriteria: {
                shape: "S2u",
                locationName: "sortCriteria"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Findings"
            ],
            members: {
              Findings: {
                locationName: "findings",
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AccountId",
                    "Arn",
                    "CreatedAt",
                    "Id",
                    "Region",
                    "Resource",
                    "SchemaVersion",
                    "Severity",
                    "Type",
                    "UpdatedAt"
                  ],
                  members: {
                    AccountId: {
                      locationName: "accountId"
                    },
                    Arn: {
                      locationName: "arn"
                    },
                    Confidence: {
                      locationName: "confidence",
                      type: "double"
                    },
                    CreatedAt: {
                      locationName: "createdAt"
                    },
                    Description: {
                      locationName: "description"
                    },
                    Id: {
                      locationName: "id"
                    },
                    Partition: {
                      locationName: "partition"
                    },
                    Region: {
                      locationName: "region"
                    },
                    Resource: {
                      locationName: "resource",
                      type: "structure",
                      members: {
                        AccessKeyDetails: {
                          locationName: "accessKeyDetails",
                          type: "structure",
                          members: {
                            AccessKeyId: {
                              locationName: "accessKeyId"
                            },
                            PrincipalId: {
                              locationName: "principalId"
                            },
                            UserName: {
                              locationName: "userName"
                            },
                            UserType: {
                              locationName: "userType"
                            }
                          }
                        },
                        S3BucketDetails: {
                          locationName: "s3BucketDetails",
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Arn: {
                                locationName: "arn"
                              },
                              Name: {
                                locationName: "name"
                              },
                              Type: {
                                locationName: "type"
                              },
                              CreatedAt: {
                                locationName: "createdAt",
                                type: "timestamp"
                              },
                              Owner: {
                                locationName: "owner",
                                type: "structure",
                                members: {
                                  Id: {
                                    locationName: "id"
                                  }
                                }
                              },
                              Tags: {
                                shape: "S36",
                                locationName: "tags"
                              },
                              DefaultServerSideEncryption: {
                                locationName: "defaultServerSideEncryption",
                                type: "structure",
                                members: {
                                  EncryptionType: {
                                    locationName: "encryptionType"
                                  },
                                  KmsMasterKeyArn: {
                                    locationName: "kmsMasterKeyArn"
                                  }
                                }
                              },
                              PublicAccess: {
                                locationName: "publicAccess",
                                type: "structure",
                                members: {
                                  PermissionConfiguration: {
                                    locationName: "permissionConfiguration",
                                    type: "structure",
                                    members: {
                                      BucketLevelPermissions: {
                                        locationName: "bucketLevelPermissions",
                                        type: "structure",
                                        members: {
                                          AccessControlList: {
                                            locationName: "accessControlList",
                                            type: "structure",
                                            members: {
                                              AllowsPublicReadAccess: {
                                                locationName: "allowsPublicReadAccess",
                                                type: "boolean"
                                              },
                                              AllowsPublicWriteAccess: {
                                                locationName: "allowsPublicWriteAccess",
                                                type: "boolean"
                                              }
                                            }
                                          },
                                          BucketPolicy: {
                                            locationName: "bucketPolicy",
                                            type: "structure",
                                            members: {
                                              AllowsPublicReadAccess: {
                                                locationName: "allowsPublicReadAccess",
                                                type: "boolean"
                                              },
                                              AllowsPublicWriteAccess: {
                                                locationName: "allowsPublicWriteAccess",
                                                type: "boolean"
                                              }
                                            }
                                          },
                                          BlockPublicAccess: {
                                            shape: "S3e",
                                            locationName: "blockPublicAccess"
                                          }
                                        }
                                      },
                                      AccountLevelPermissions: {
                                        locationName: "accountLevelPermissions",
                                        type: "structure",
                                        members: {
                                          BlockPublicAccess: {
                                            shape: "S3e",
                                            locationName: "blockPublicAccess"
                                          }
                                        }
                                      }
                                    }
                                  },
                                  EffectivePermission: {
                                    locationName: "effectivePermission"
                                  }
                                }
                              }
                            }
                          }
                        },
                        InstanceDetails: {
                          locationName: "instanceDetails",
                          type: "structure",
                          members: {
                            AvailabilityZone: {
                              locationName: "availabilityZone"
                            },
                            IamInstanceProfile: {
                              locationName: "iamInstanceProfile",
                              type: "structure",
                              members: {
                                Arn: {
                                  locationName: "arn"
                                },
                                Id: {
                                  locationName: "id"
                                }
                              }
                            },
                            ImageDescription: {
                              locationName: "imageDescription"
                            },
                            ImageId: {
                              locationName: "imageId"
                            },
                            InstanceId: {
                              locationName: "instanceId"
                            },
                            InstanceState: {
                              locationName: "instanceState"
                            },
                            InstanceType: {
                              locationName: "instanceType"
                            },
                            OutpostArn: {
                              locationName: "outpostArn"
                            },
                            LaunchTime: {
                              locationName: "launchTime"
                            },
                            NetworkInterfaces: {
                              locationName: "networkInterfaces",
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  Ipv6Addresses: {
                                    locationName: "ipv6Addresses",
                                    type: "list",
                                    member: {}
                                  },
                                  NetworkInterfaceId: {
                                    locationName: "networkInterfaceId"
                                  },
                                  PrivateDnsName: {
                                    locationName: "privateDnsName"
                                  },
                                  PrivateIpAddress: {
                                    locationName: "privateIpAddress"
                                  },
                                  PrivateIpAddresses: {
                                    locationName: "privateIpAddresses",
                                    type: "list",
                                    member: {
                                      type: "structure",
                                      members: {
                                        PrivateDnsName: {
                                          locationName: "privateDnsName"
                                        },
                                        PrivateIpAddress: {
                                          locationName: "privateIpAddress"
                                        }
                                      }
                                    }
                                  },
                                  PublicDnsName: {
                                    locationName: "publicDnsName"
                                  },
                                  PublicIp: {
                                    locationName: "publicIp"
                                  },
                                  SecurityGroups: {
                                    locationName: "securityGroups",
                                    type: "list",
                                    member: {
                                      type: "structure",
                                      members: {
                                        GroupId: {
                                          locationName: "groupId"
                                        },
                                        GroupName: {
                                          locationName: "groupName"
                                        }
                                      }
                                    }
                                  },
                                  SubnetId: {
                                    locationName: "subnetId"
                                  },
                                  VpcId: {
                                    locationName: "vpcId"
                                  }
                                }
                              }
                            },
                            Platform: {
                              locationName: "platform"
                            },
                            ProductCodes: {
                              locationName: "productCodes",
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  Code: {
                                    locationName: "code"
                                  },
                                  ProductType: {
                                    locationName: "productType"
                                  }
                                }
                              }
                            },
                            Tags: {
                              shape: "S36",
                              locationName: "tags"
                            }
                          }
                        },
                        ResourceType: {
                          locationName: "resourceType"
                        }
                      }
                    },
                    SchemaVersion: {
                      locationName: "schemaVersion"
                    },
                    Service: {
                      locationName: "service",
                      type: "structure",
                      members: {
                        Action: {
                          locationName: "action",
                          type: "structure",
                          members: {
                            ActionType: {
                              locationName: "actionType"
                            },
                            AwsApiCallAction: {
                              locationName: "awsApiCallAction",
                              type: "structure",
                              members: {
                                Api: {
                                  locationName: "api"
                                },
                                CallerType: {
                                  locationName: "callerType"
                                },
                                DomainDetails: {
                                  locationName: "domainDetails",
                                  type: "structure",
                                  members: {
                                    Domain: {
                                      locationName: "domain"
                                    }
                                  }
                                },
                                ErrorCode: {
                                  locationName: "errorCode"
                                },
                                RemoteIpDetails: {
                                  shape: "S3v",
                                  locationName: "remoteIpDetails"
                                },
                                ServiceName: {
                                  locationName: "serviceName"
                                }
                              }
                            },
                            DnsRequestAction: {
                              locationName: "dnsRequestAction",
                              type: "structure",
                              members: {
                                Domain: {
                                  locationName: "domain"
                                }
                              }
                            },
                            NetworkConnectionAction: {
                              locationName: "networkConnectionAction",
                              type: "structure",
                              members: {
                                Blocked: {
                                  locationName: "blocked",
                                  type: "boolean"
                                },
                                ConnectionDirection: {
                                  locationName: "connectionDirection"
                                },
                                LocalPortDetails: {
                                  shape: "S42",
                                  locationName: "localPortDetails"
                                },
                                Protocol: {
                                  locationName: "protocol"
                                },
                                LocalIpDetails: {
                                  shape: "S43",
                                  locationName: "localIpDetails"
                                },
                                RemoteIpDetails: {
                                  shape: "S3v",
                                  locationName: "remoteIpDetails"
                                },
                                RemotePortDetails: {
                                  locationName: "remotePortDetails",
                                  type: "structure",
                                  members: {
                                    Port: {
                                      locationName: "port",
                                      type: "integer"
                                    },
                                    PortName: {
                                      locationName: "portName"
                                    }
                                  }
                                }
                              }
                            },
                            PortProbeAction: {
                              locationName: "portProbeAction",
                              type: "structure",
                              members: {
                                Blocked: {
                                  locationName: "blocked",
                                  type: "boolean"
                                },
                                PortProbeDetails: {
                                  locationName: "portProbeDetails",
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      LocalPortDetails: {
                                        shape: "S42",
                                        locationName: "localPortDetails"
                                      },
                                      LocalIpDetails: {
                                        shape: "S43",
                                        locationName: "localIpDetails"
                                      },
                                      RemoteIpDetails: {
                                        shape: "S3v",
                                        locationName: "remoteIpDetails"
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        },
                        Evidence: {
                          locationName: "evidence",
                          type: "structure",
                          members: {
                            ThreatIntelligenceDetails: {
                              locationName: "threatIntelligenceDetails",
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  ThreatListName: {
                                    locationName: "threatListName"
                                  },
                                  ThreatNames: {
                                    locationName: "threatNames",
                                    type: "list",
                                    member: {}
                                  }
                                }
                              }
                            }
                          }
                        },
                        Archived: {
                          locationName: "archived",
                          type: "boolean"
                        },
                        Count: {
                          locationName: "count",
                          type: "integer"
                        },
                        DetectorId: {
                          locationName: "detectorId"
                        },
                        EventFirstSeen: {
                          locationName: "eventFirstSeen"
                        },
                        EventLastSeen: {
                          locationName: "eventLastSeen"
                        },
                        ResourceRole: {
                          locationName: "resourceRole"
                        },
                        ServiceName: {
                          locationName: "serviceName"
                        },
                        UserFeedback: {
                          locationName: "userFeedback"
                        }
                      }
                    },
                    Severity: {
                      locationName: "severity",
                      type: "double"
                    },
                    Title: {
                      locationName: "title"
                    },
                    Type: {
                      locationName: "type"
                    },
                    UpdatedAt: {
                      locationName: "updatedAt"
                    }
                  }
                }
              }
            }
          }
        },
        GetFindingsStatistics: {
          http: {
            requestUri: "/detector/{detectorId}/findings/statistics",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "FindingStatisticTypes"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FindingStatisticTypes: {
                locationName: "findingStatisticTypes",
                type: "list",
                member: {}
              },
              FindingCriteria: {
                shape: "So",
                locationName: "findingCriteria"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "FindingStatistics"
            ],
            members: {
              FindingStatistics: {
                locationName: "findingStatistics",
                type: "structure",
                members: {
                  CountBySeverity: {
                    locationName: "countBySeverity",
                    type: "map",
                    key: {},
                    value: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        GetIPSet: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/ipset/{ipSetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "IpSetId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              IpSetId: {
                location: "uri",
                locationName: "ipSetId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name",
              "Format",
              "Location",
              "Status"
            ],
            members: {
              Name: {
                locationName: "name"
              },
              Format: {
                locationName: "format"
              },
              Location: {
                locationName: "location"
              },
              Status: {
                locationName: "status"
              },
              Tags: {
                shape: "Sf",
                locationName: "tags"
              }
            }
          }
        },
        GetInvitationsCount: {
          http: {
            method: "GET",
            requestUri: "/invitation/count",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              InvitationsCount: {
                locationName: "invitationsCount",
                type: "integer"
              }
            }
          }
        },
        GetMasterAccount: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/master",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Master"
            ],
            members: {
              Master: {
                locationName: "master",
                type: "structure",
                members: {
                  AccountId: {
                    locationName: "accountId"
                  },
                  InvitationId: {
                    locationName: "invitationId"
                  },
                  RelationshipStatus: {
                    locationName: "relationshipStatus"
                  },
                  InvitedAt: {
                    locationName: "invitedAt"
                  }
                }
              }
            }
          }
        },
        GetMemberDetectors: {
          http: {
            requestUri: "/detector/{detectorId}/member/detector/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "AccountIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AccountIds: {
                shape: "S1n",
                locationName: "accountIds"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "MemberDataSourceConfigurations",
              "UnprocessedAccounts"
            ],
            members: {
              MemberDataSourceConfigurations: {
                locationName: "members",
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AccountId",
                    "DataSources"
                  ],
                  members: {
                    AccountId: {
                      locationName: "accountId"
                    },
                    DataSources: {
                      shape: "S2l",
                      locationName: "dataSources"
                    }
                  }
                }
              },
              UnprocessedAccounts: {
                shape: "S19",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        GetMembers: {
          http: {
            requestUri: "/detector/{detectorId}/member/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "AccountIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AccountIds: {
                shape: "S1n",
                locationName: "accountIds"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Members",
              "UnprocessedAccounts"
            ],
            members: {
              Members: {
                shape: "S4w",
                locationName: "members"
              },
              UnprocessedAccounts: {
                shape: "S19",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        GetThreatIntelSet: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/threatintelset/{threatIntelSetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "ThreatIntelSetId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              ThreatIntelSetId: {
                location: "uri",
                locationName: "threatIntelSetId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name",
              "Format",
              "Location",
              "Status"
            ],
            members: {
              Name: {
                locationName: "name"
              },
              Format: {
                locationName: "format"
              },
              Location: {
                locationName: "location"
              },
              Status: {
                locationName: "status"
              },
              Tags: {
                shape: "Sf",
                locationName: "tags"
              }
            }
          }
        },
        GetUsageStatistics: {
          http: {
            requestUri: "/detector/{detectorId}/usage/statistics",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "UsageStatisticType",
              "UsageCriteria"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              UsageStatisticType: {
                locationName: "usageStatisticsType"
              },
              UsageCriteria: {
                locationName: "usageCriteria",
                type: "structure",
                required: [
                  "DataSources"
                ],
                members: {
                  AccountIds: {
                    shape: "S1n",
                    locationName: "accountIds"
                  },
                  DataSources: {
                    locationName: "dataSources",
                    type: "list",
                    member: {}
                  },
                  Resources: {
                    locationName: "resources",
                    type: "list",
                    member: {}
                  }
                }
              },
              Unit: {
                locationName: "unit"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UsageStatistics: {
                locationName: "usageStatistics",
                type: "structure",
                members: {
                  SumByAccount: {
                    locationName: "sumByAccount",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        AccountId: {
                          locationName: "accountId"
                        },
                        Total: {
                          shape: "S5c",
                          locationName: "total"
                        }
                      }
                    }
                  },
                  SumByDataSource: {
                    locationName: "sumByDataSource",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        DataSource: {
                          locationName: "dataSource"
                        },
                        Total: {
                          shape: "S5c",
                          locationName: "total"
                        }
                      }
                    }
                  },
                  SumByResource: {
                    shape: "S5f",
                    locationName: "sumByResource"
                  },
                  TopResources: {
                    shape: "S5f",
                    locationName: "topResources"
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        InviteMembers: {
          http: {
            requestUri: "/detector/{detectorId}/member/invite",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "AccountIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AccountIds: {
                shape: "S1n",
                locationName: "accountIds"
              },
              DisableEmailNotification: {
                locationName: "disableEmailNotification",
                type: "boolean"
              },
              Message: {
                locationName: "message"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UnprocessedAccounts"
            ],
            members: {
              UnprocessedAccounts: {
                shape: "S19",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        ListDetectors: {
          http: {
            method: "GET",
            requestUri: "/detector",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DetectorIds"
            ],
            members: {
              DetectorIds: {
                locationName: "detectorIds",
                type: "list",
                member: {}
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListFilters: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/filter",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "FilterNames"
            ],
            members: {
              FilterNames: {
                locationName: "filterNames",
                type: "list",
                member: {}
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListFindings: {
          http: {
            requestUri: "/detector/{detectorId}/findings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FindingCriteria: {
                shape: "So",
                locationName: "findingCriteria"
              },
              SortCriteria: {
                shape: "S2u",
                locationName: "sortCriteria"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "FindingIds"
            ],
            members: {
              FindingIds: {
                shape: "S6",
                locationName: "findingIds"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListIPSets: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/ipset",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "IpSetIds"
            ],
            members: {
              IpSetIds: {
                locationName: "ipSetIds",
                type: "list",
                member: {}
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListInvitations: {
          http: {
            method: "GET",
            requestUri: "/invitation",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invitations: {
                locationName: "invitations",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountId: {
                      locationName: "accountId"
                    },
                    InvitationId: {
                      locationName: "invitationId"
                    },
                    RelationshipStatus: {
                      locationName: "relationshipStatus"
                    },
                    InvitedAt: {
                      locationName: "invitedAt"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListMembers: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/member",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              OnlyAssociated: {
                location: "querystring",
                locationName: "onlyAssociated"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Members: {
                shape: "S4w",
                locationName: "members"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListOrganizationAdminAccounts: {
          http: {
            method: "GET",
            requestUri: "/admin",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AdminAccounts: {
                locationName: "adminAccounts",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AdminAccountId: {
                      locationName: "adminAccountId"
                    },
                    AdminStatus: {
                      locationName: "adminStatus"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListPublishingDestinations: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/publishingDestination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Destinations"
            ],
            members: {
              Destinations: {
                locationName: "destinations",
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DestinationId",
                    "DestinationType",
                    "Status"
                  ],
                  members: {
                    DestinationId: {
                      locationName: "destinationId"
                    },
                    DestinationType: {
                      locationName: "destinationType"
                    },
                    Status: {
                      locationName: "status"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sf",
                locationName: "tags"
              }
            }
          }
        },
        ListThreatIntelSets: {
          http: {
            method: "GET",
            requestUri: "/detector/{detectorId}/threatintelset",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ThreatIntelSetIds"
            ],
            members: {
              ThreatIntelSetIds: {
                locationName: "threatIntelSetIds",
                type: "list",
                member: {}
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        StartMonitoringMembers: {
          http: {
            requestUri: "/detector/{detectorId}/member/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "AccountIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AccountIds: {
                shape: "S1n",
                locationName: "accountIds"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UnprocessedAccounts"
            ],
            members: {
              UnprocessedAccounts: {
                shape: "S19",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        StopMonitoringMembers: {
          http: {
            requestUri: "/detector/{detectorId}/member/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "AccountIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AccountIds: {
                shape: "S1n",
                locationName: "accountIds"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UnprocessedAccounts"
            ],
            members: {
              UnprocessedAccounts: {
                shape: "S19",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "Sf",
                locationName: "tags"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UnarchiveFindings: {
          http: {
            requestUri: "/detector/{detectorId}/findings/unarchive",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "FindingIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FindingIds: {
                shape: "S6",
                locationName: "findingIds"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDetector: {
          http: {
            requestUri: "/detector/{detectorId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              Enable: {
                locationName: "enable",
                type: "boolean"
              },
              FindingPublishingFrequency: {
                locationName: "findingPublishingFrequency"
              },
              DataSources: {
                shape: "Sd",
                locationName: "dataSources"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateFilter: {
          http: {
            requestUri: "/detector/{detectorId}/filter/{filterName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "FilterName"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FilterName: {
                location: "uri",
                locationName: "filterName"
              },
              Description: {
                locationName: "description"
              },
              Action: {
                locationName: "action"
              },
              Rank: {
                locationName: "rank",
                type: "integer"
              },
              FindingCriteria: {
                shape: "So",
                locationName: "findingCriteria"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                locationName: "name"
              }
            }
          }
        },
        UpdateFindingsFeedback: {
          http: {
            requestUri: "/detector/{detectorId}/findings/feedback",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "FindingIds",
              "Feedback"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              FindingIds: {
                shape: "S6",
                locationName: "findingIds"
              },
              Feedback: {
                locationName: "feedback"
              },
              Comments: {
                locationName: "comments"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateIPSet: {
          http: {
            requestUri: "/detector/{detectorId}/ipset/{ipSetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "IpSetId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              IpSetId: {
                location: "uri",
                locationName: "ipSetId"
              },
              Name: {
                locationName: "name"
              },
              Location: {
                locationName: "location"
              },
              Activate: {
                locationName: "activate",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateMemberDetectors: {
          http: {
            requestUri: "/detector/{detectorId}/member/detector/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "AccountIds"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AccountIds: {
                shape: "S1n",
                locationName: "accountIds"
              },
              DataSources: {
                shape: "Sd",
                locationName: "dataSources"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UnprocessedAccounts"
            ],
            members: {
              UnprocessedAccounts: {
                shape: "S19",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        UpdateOrganizationConfiguration: {
          http: {
            requestUri: "/detector/{detectorId}/admin",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "AutoEnable"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              AutoEnable: {
                locationName: "autoEnable",
                type: "boolean"
              },
              DataSources: {
                locationName: "dataSources",
                type: "structure",
                members: {
                  S3Logs: {
                    locationName: "s3Logs",
                    type: "structure",
                    required: [
                      "AutoEnable"
                    ],
                    members: {
                      AutoEnable: {
                        locationName: "autoEnable",
                        type: "boolean"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdatePublishingDestination: {
          http: {
            requestUri: "/detector/{detectorId}/publishingDestination/{destinationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "DestinationId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              DestinationId: {
                location: "uri",
                locationName: "destinationId"
              },
              DestinationProperties: {
                shape: "S1d",
                locationName: "destinationProperties"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateThreatIntelSet: {
          http: {
            requestUri: "/detector/{detectorId}/threatintelset/{threatIntelSetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DetectorId",
              "ThreatIntelSetId"
            ],
            members: {
              DetectorId: {
                location: "uri",
                locationName: "detectorId"
              },
              ThreatIntelSetId: {
                location: "uri",
                locationName: "threatIntelSetId"
              },
              Name: {
                locationName: "name"
              },
              Location: {
                locationName: "location"
              },
              Activate: {
                locationName: "activate",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S6: {
          type: "list",
          member: {}
        },
        Sd: {
          type: "structure",
          members: {
            S3Logs: {
              locationName: "s3Logs",
              type: "structure",
              required: [
                "Enable"
              ],
              members: {
                Enable: {
                  locationName: "enable",
                  type: "boolean"
                }
              }
            }
          }
        },
        Sf: {
          type: "map",
          key: {},
          value: {}
        },
        So: {
          type: "structure",
          members: {
            Criterion: {
              locationName: "criterion",
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  Eq: {
                    deprecated: true,
                    locationName: "eq",
                    type: "list",
                    member: {}
                  },
                  Neq: {
                    deprecated: true,
                    locationName: "neq",
                    type: "list",
                    member: {}
                  },
                  Gt: {
                    deprecated: true,
                    locationName: "gt",
                    type: "integer"
                  },
                  Gte: {
                    deprecated: true,
                    locationName: "gte",
                    type: "integer"
                  },
                  Lt: {
                    deprecated: true,
                    locationName: "lt",
                    type: "integer"
                  },
                  Lte: {
                    deprecated: true,
                    locationName: "lte",
                    type: "integer"
                  },
                  Equals: {
                    locationName: "equals",
                    type: "list",
                    member: {}
                  },
                  NotEquals: {
                    locationName: "notEquals",
                    type: "list",
                    member: {}
                  },
                  GreaterThan: {
                    locationName: "greaterThan",
                    type: "long"
                  },
                  GreaterThanOrEqual: {
                    locationName: "greaterThanOrEqual",
                    type: "long"
                  },
                  LessThan: {
                    locationName: "lessThan",
                    type: "long"
                  },
                  LessThanOrEqual: {
                    locationName: "lessThanOrEqual",
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S19: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AccountId",
              "Result"
            ],
            members: {
              AccountId: {
                locationName: "accountId"
              },
              Result: {
                locationName: "result"
              }
            }
          }
        },
        S1d: {
          type: "structure",
          members: {
            DestinationArn: {
              locationName: "destinationArn"
            },
            KmsKeyArn: {
              locationName: "kmsKeyArn"
            }
          }
        },
        S1n: {
          type: "list",
          member: {}
        },
        S2l: {
          type: "structure",
          required: [
            "CloudTrail",
            "DNSLogs",
            "FlowLogs",
            "S3Logs"
          ],
          members: {
            CloudTrail: {
              locationName: "cloudTrail",
              type: "structure",
              required: [
                "Status"
              ],
              members: {
                Status: {
                  locationName: "status"
                }
              }
            },
            DNSLogs: {
              locationName: "dnsLogs",
              type: "structure",
              required: [
                "Status"
              ],
              members: {
                Status: {
                  locationName: "status"
                }
              }
            },
            FlowLogs: {
              locationName: "flowLogs",
              type: "structure",
              required: [
                "Status"
              ],
              members: {
                Status: {
                  locationName: "status"
                }
              }
            },
            S3Logs: {
              locationName: "s3Logs",
              type: "structure",
              required: [
                "Status"
              ],
              members: {
                Status: {
                  locationName: "status"
                }
              }
            }
          }
        },
        S2u: {
          type: "structure",
          members: {
            AttributeName: {
              locationName: "attributeName"
            },
            OrderBy: {
              locationName: "orderBy"
            }
          }
        },
        S36: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {
                locationName: "key"
              },
              Value: {
                locationName: "value"
              }
            }
          }
        },
        S3e: {
          type: "structure",
          members: {
            IgnorePublicAcls: {
              locationName: "ignorePublicAcls",
              type: "boolean"
            },
            RestrictPublicBuckets: {
              locationName: "restrictPublicBuckets",
              type: "boolean"
            },
            BlockPublicAcls: {
              locationName: "blockPublicAcls",
              type: "boolean"
            },
            BlockPublicPolicy: {
              locationName: "blockPublicPolicy",
              type: "boolean"
            }
          }
        },
        S3v: {
          type: "structure",
          members: {
            City: {
              locationName: "city",
              type: "structure",
              members: {
                CityName: {
                  locationName: "cityName"
                }
              }
            },
            Country: {
              locationName: "country",
              type: "structure",
              members: {
                CountryCode: {
                  locationName: "countryCode"
                },
                CountryName: {
                  locationName: "countryName"
                }
              }
            },
            GeoLocation: {
              locationName: "geoLocation",
              type: "structure",
              members: {
                Lat: {
                  locationName: "lat",
                  type: "double"
                },
                Lon: {
                  locationName: "lon",
                  type: "double"
                }
              }
            },
            IpAddressV4: {
              locationName: "ipAddressV4"
            },
            Organization: {
              locationName: "organization",
              type: "structure",
              members: {
                Asn: {
                  locationName: "asn"
                },
                AsnOrg: {
                  locationName: "asnOrg"
                },
                Isp: {
                  locationName: "isp"
                },
                Org: {
                  locationName: "org"
                }
              }
            }
          }
        },
        S42: {
          type: "structure",
          members: {
            Port: {
              locationName: "port",
              type: "integer"
            },
            PortName: {
              locationName: "portName"
            }
          }
        },
        S43: {
          type: "structure",
          members: {
            IpAddressV4: {
              locationName: "ipAddressV4"
            }
          }
        },
        S4w: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AccountId",
              "MasterId",
              "Email",
              "RelationshipStatus",
              "UpdatedAt"
            ],
            members: {
              AccountId: {
                locationName: "accountId"
              },
              DetectorId: {
                locationName: "detectorId"
              },
              MasterId: {
                locationName: "masterId"
              },
              Email: {
                locationName: "email"
              },
              RelationshipStatus: {
                locationName: "relationshipStatus"
              },
              InvitedAt: {
                locationName: "invitedAt"
              },
              UpdatedAt: {
                locationName: "updatedAt"
              }
            }
          }
        },
        S5c: {
          type: "structure",
          members: {
            Amount: {
              locationName: "amount"
            },
            Unit: {
              locationName: "unit"
            }
          }
        },
        S5f: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Resource: {
                locationName: "resource"
              },
              Total: {
                shape: "S5c",
                locationName: "total"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/guardduty-2017-11-28.paginators.json
var require_guardduty_2017_11_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/guardduty-2017-11-28.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetUsageStatistics: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDetectors: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DetectorIds"
        },
        ListFilters: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FilterNames"
        },
        ListFindings: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FindingIds"
        },
        ListIPSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "IpSetIds"
        },
        ListInvitations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Invitations"
        },
        ListMembers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Members"
        },
        ListOrganizationAdminAccounts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AdminAccounts"
        },
        ListPublishingDestinations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListThreatIntelSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ThreatIntelSetIds"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/guardduty.js
var require_guardduty = __commonJS({
  "node_modules/aws-sdk/clients/guardduty.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["guardduty"] = {};
    AWS3.GuardDuty = Service.defineService("guardduty", ["2017-11-28"]);
    Object.defineProperty(apiLoader.services["guardduty"], "2017-11-28", {
      get: function get() {
        var model = require_guardduty_2017_11_28_min();
        model.paginators = require_guardduty_2017_11_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.GuardDuty;
  }
});

// node_modules/aws-sdk/apis/mq-2017-11-27.min.json
var require_mq_2017_11_27_min = __commonJS({
  "node_modules/aws-sdk/apis/mq-2017-11-27.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2017-11-27",
        endpointPrefix: "mq",
        signingName: "mq",
        serviceFullName: "AmazonMQ",
        serviceId: "mq",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "mq-2017-11-27",
        signatureVersion: "v4"
      },
      operations: {
        CreateBroker: {
          http: {
            requestUri: "/v1/brokers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AuthenticationStrategy: {
                locationName: "authenticationStrategy"
              },
              AutoMinorVersionUpgrade: {
                locationName: "autoMinorVersionUpgrade",
                type: "boolean"
              },
              BrokerName: {
                locationName: "brokerName"
              },
              Configuration: {
                shape: "S5",
                locationName: "configuration"
              },
              CreatorRequestId: {
                locationName: "creatorRequestId",
                idempotencyToken: true
              },
              DeploymentMode: {
                locationName: "deploymentMode"
              },
              EncryptionOptions: {
                shape: "S8",
                locationName: "encryptionOptions"
              },
              EngineType: {
                locationName: "engineType"
              },
              EngineVersion: {
                locationName: "engineVersion"
              },
              HostInstanceType: {
                locationName: "hostInstanceType"
              },
              LdapServerMetadata: {
                shape: "Sa",
                locationName: "ldapServerMetadata"
              },
              Logs: {
                shape: "Sc",
                locationName: "logs"
              },
              MaintenanceWindowStartTime: {
                shape: "Sd",
                locationName: "maintenanceWindowStartTime"
              },
              PubliclyAccessible: {
                locationName: "publiclyAccessible",
                type: "boolean"
              },
              SecurityGroups: {
                shape: "Sb",
                locationName: "securityGroups"
              },
              StorageType: {
                locationName: "storageType"
              },
              SubnetIds: {
                shape: "Sb",
                locationName: "subnetIds"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              Users: {
                locationName: "users",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConsoleAccess: {
                      locationName: "consoleAccess",
                      type: "boolean"
                    },
                    Groups: {
                      shape: "Sb",
                      locationName: "groups"
                    },
                    Password: {
                      locationName: "password"
                    },
                    Username: {
                      locationName: "username"
                    }
                  },
                  required: [
                    "Username",
                    "Password"
                  ]
                }
              }
            },
            required: [
              "EngineVersion",
              "HostInstanceType",
              "AutoMinorVersionUpgrade",
              "Users",
              "BrokerName",
              "DeploymentMode",
              "EngineType",
              "PubliclyAccessible"
            ]
          },
          output: {
            type: "structure",
            members: {
              BrokerArn: {
                locationName: "brokerArn"
              },
              BrokerId: {
                locationName: "brokerId"
              }
            }
          }
        },
        CreateConfiguration: {
          http: {
            requestUri: "/v1/configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AuthenticationStrategy: {
                locationName: "authenticationStrategy"
              },
              EngineType: {
                locationName: "engineType"
              },
              EngineVersion: {
                locationName: "engineVersion"
              },
              Name: {
                locationName: "name"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            },
            required: [
              "EngineVersion",
              "EngineType",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              AuthenticationStrategy: {
                locationName: "authenticationStrategy"
              },
              Created: {
                shape: "Sm",
                locationName: "created"
              },
              Id: {
                locationName: "id"
              },
              LatestRevision: {
                shape: "Sn",
                locationName: "latestRevision"
              },
              Name: {
                locationName: "name"
              }
            }
          }
        },
        CreateTags: {
          http: {
            requestUri: "/v1/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            },
            required: [
              "ResourceArn"
            ]
          }
        },
        CreateUser: {
          http: {
            requestUri: "/v1/brokers/{broker-id}/users/{username}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerId: {
                location: "uri",
                locationName: "broker-id"
              },
              ConsoleAccess: {
                locationName: "consoleAccess",
                type: "boolean"
              },
              Groups: {
                shape: "Sb",
                locationName: "groups"
              },
              Password: {
                locationName: "password"
              },
              Username: {
                location: "uri",
                locationName: "username"
              }
            },
            required: [
              "Username",
              "BrokerId",
              "Password"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteBroker: {
          http: {
            method: "DELETE",
            requestUri: "/v1/brokers/{broker-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerId: {
                location: "uri",
                locationName: "broker-id"
              }
            },
            required: [
              "BrokerId"
            ]
          },
          output: {
            type: "structure",
            members: {
              BrokerId: {
                locationName: "brokerId"
              }
            }
          }
        },
        DeleteTags: {
          http: {
            method: "DELETE",
            requestUri: "/v1/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                shape: "Sb",
                location: "querystring",
                locationName: "tagKeys"
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ]
          }
        },
        DeleteUser: {
          http: {
            method: "DELETE",
            requestUri: "/v1/brokers/{broker-id}/users/{username}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerId: {
                location: "uri",
                locationName: "broker-id"
              },
              Username: {
                location: "uri",
                locationName: "username"
              }
            },
            required: [
              "Username",
              "BrokerId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeBroker: {
          http: {
            method: "GET",
            requestUri: "/v1/brokers/{broker-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerId: {
                location: "uri",
                locationName: "broker-id"
              }
            },
            required: [
              "BrokerId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AuthenticationStrategy: {
                locationName: "authenticationStrategy"
              },
              AutoMinorVersionUpgrade: {
                locationName: "autoMinorVersionUpgrade",
                type: "boolean"
              },
              BrokerArn: {
                locationName: "brokerArn"
              },
              BrokerId: {
                locationName: "brokerId"
              },
              BrokerInstances: {
                locationName: "brokerInstances",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConsoleURL: {
                      locationName: "consoleURL"
                    },
                    Endpoints: {
                      shape: "Sb",
                      locationName: "endpoints"
                    },
                    IpAddress: {
                      locationName: "ipAddress"
                    }
                  }
                }
              },
              BrokerName: {
                locationName: "brokerName"
              },
              BrokerState: {
                locationName: "brokerState"
              },
              Configurations: {
                locationName: "configurations",
                type: "structure",
                members: {
                  Current: {
                    shape: "S5",
                    locationName: "current"
                  },
                  History: {
                    locationName: "history",
                    type: "list",
                    member: {
                      shape: "S5"
                    }
                  },
                  Pending: {
                    shape: "S5",
                    locationName: "pending"
                  }
                }
              },
              Created: {
                shape: "Sm",
                locationName: "created"
              },
              DeploymentMode: {
                locationName: "deploymentMode"
              },
              EncryptionOptions: {
                shape: "S8",
                locationName: "encryptionOptions"
              },
              EngineType: {
                locationName: "engineType"
              },
              EngineVersion: {
                locationName: "engineVersion"
              },
              HostInstanceType: {
                locationName: "hostInstanceType"
              },
              LdapServerMetadata: {
                shape: "S13",
                locationName: "ldapServerMetadata"
              },
              Logs: {
                locationName: "logs",
                type: "structure",
                members: {
                  Audit: {
                    locationName: "audit",
                    type: "boolean"
                  },
                  AuditLogGroup: {
                    locationName: "auditLogGroup"
                  },
                  General: {
                    locationName: "general",
                    type: "boolean"
                  },
                  GeneralLogGroup: {
                    locationName: "generalLogGroup"
                  },
                  Pending: {
                    locationName: "pending",
                    type: "structure",
                    members: {
                      Audit: {
                        locationName: "audit",
                        type: "boolean"
                      },
                      General: {
                        locationName: "general",
                        type: "boolean"
                      }
                    }
                  }
                },
                required: [
                  "GeneralLogGroup",
                  "General"
                ]
              },
              MaintenanceWindowStartTime: {
                shape: "Sd",
                locationName: "maintenanceWindowStartTime"
              },
              PendingAuthenticationStrategy: {
                locationName: "pendingAuthenticationStrategy"
              },
              PendingEngineVersion: {
                locationName: "pendingEngineVersion"
              },
              PendingHostInstanceType: {
                locationName: "pendingHostInstanceType"
              },
              PendingLdapServerMetadata: {
                shape: "S13",
                locationName: "pendingLdapServerMetadata"
              },
              PendingSecurityGroups: {
                shape: "Sb",
                locationName: "pendingSecurityGroups"
              },
              PubliclyAccessible: {
                locationName: "publiclyAccessible",
                type: "boolean"
              },
              SecurityGroups: {
                shape: "Sb",
                locationName: "securityGroups"
              },
              StorageType: {
                locationName: "storageType"
              },
              SubnetIds: {
                shape: "Sb",
                locationName: "subnetIds"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              Users: {
                shape: "S16",
                locationName: "users"
              }
            }
          }
        },
        DescribeBrokerEngineTypes: {
          http: {
            method: "GET",
            requestUri: "/v1/broker-engine-types",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              EngineType: {
                location: "querystring",
                locationName: "engineType"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BrokerEngineTypes: {
                locationName: "brokerEngineTypes",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EngineType: {
                      locationName: "engineType"
                    },
                    EngineVersions: {
                      locationName: "engineVersions",
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {
                            locationName: "name"
                          }
                        }
                      }
                    }
                  }
                }
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeBrokerInstanceOptions: {
          http: {
            method: "GET",
            requestUri: "/v1/broker-instance-options",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              EngineType: {
                location: "querystring",
                locationName: "engineType"
              },
              HostInstanceType: {
                location: "querystring",
                locationName: "hostInstanceType"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              StorageType: {
                location: "querystring",
                locationName: "storageType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BrokerInstanceOptions: {
                locationName: "brokerInstanceOptions",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AvailabilityZones: {
                      locationName: "availabilityZones",
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {
                            locationName: "name"
                          }
                        }
                      }
                    },
                    EngineType: {
                      locationName: "engineType"
                    },
                    HostInstanceType: {
                      locationName: "hostInstanceType"
                    },
                    StorageType: {
                      locationName: "storageType"
                    },
                    SupportedDeploymentModes: {
                      locationName: "supportedDeploymentModes",
                      type: "list",
                      member: {}
                    },
                    SupportedEngineVersions: {
                      shape: "Sb",
                      locationName: "supportedEngineVersions"
                    }
                  }
                }
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeConfiguration: {
          http: {
            method: "GET",
            requestUri: "/v1/configurations/{configuration-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConfigurationId: {
                location: "uri",
                locationName: "configuration-id"
              }
            },
            required: [
              "ConfigurationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              AuthenticationStrategy: {
                locationName: "authenticationStrategy"
              },
              Created: {
                shape: "Sm",
                locationName: "created"
              },
              Description: {
                locationName: "description"
              },
              EngineType: {
                locationName: "engineType"
              },
              EngineVersion: {
                locationName: "engineVersion"
              },
              Id: {
                locationName: "id"
              },
              LatestRevision: {
                shape: "Sn",
                locationName: "latestRevision"
              },
              Name: {
                locationName: "name"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            }
          }
        },
        DescribeConfigurationRevision: {
          http: {
            method: "GET",
            requestUri: "/v1/configurations/{configuration-id}/revisions/{configuration-revision}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConfigurationId: {
                location: "uri",
                locationName: "configuration-id"
              },
              ConfigurationRevision: {
                location: "uri",
                locationName: "configuration-revision"
              }
            },
            required: [
              "ConfigurationRevision",
              "ConfigurationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ConfigurationId: {
                locationName: "configurationId"
              },
              Created: {
                shape: "Sm",
                locationName: "created"
              },
              Data: {
                locationName: "data"
              },
              Description: {
                locationName: "description"
              }
            }
          }
        },
        DescribeUser: {
          http: {
            method: "GET",
            requestUri: "/v1/brokers/{broker-id}/users/{username}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerId: {
                location: "uri",
                locationName: "broker-id"
              },
              Username: {
                location: "uri",
                locationName: "username"
              }
            },
            required: [
              "Username",
              "BrokerId"
            ]
          },
          output: {
            type: "structure",
            members: {
              BrokerId: {
                locationName: "brokerId"
              },
              ConsoleAccess: {
                locationName: "consoleAccess",
                type: "boolean"
              },
              Groups: {
                shape: "Sb",
                locationName: "groups"
              },
              Pending: {
                locationName: "pending",
                type: "structure",
                members: {
                  ConsoleAccess: {
                    locationName: "consoleAccess",
                    type: "boolean"
                  },
                  Groups: {
                    shape: "Sb",
                    locationName: "groups"
                  },
                  PendingChange: {
                    locationName: "pendingChange"
                  }
                },
                required: [
                  "PendingChange"
                ]
              },
              Username: {
                locationName: "username"
              }
            }
          }
        },
        ListBrokers: {
          http: {
            method: "GET",
            requestUri: "/v1/brokers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BrokerSummaries: {
                locationName: "brokerSummaries",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    BrokerArn: {
                      locationName: "brokerArn"
                    },
                    BrokerId: {
                      locationName: "brokerId"
                    },
                    BrokerName: {
                      locationName: "brokerName"
                    },
                    BrokerState: {
                      locationName: "brokerState"
                    },
                    Created: {
                      shape: "Sm",
                      locationName: "created"
                    },
                    DeploymentMode: {
                      locationName: "deploymentMode"
                    },
                    EngineType: {
                      locationName: "engineType"
                    },
                    HostInstanceType: {
                      locationName: "hostInstanceType"
                    }
                  },
                  required: [
                    "DeploymentMode",
                    "EngineType"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListConfigurationRevisions: {
          http: {
            method: "GET",
            requestUri: "/v1/configurations/{configuration-id}/revisions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConfigurationId: {
                location: "uri",
                locationName: "configuration-id"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ConfigurationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ConfigurationId: {
                locationName: "configurationId"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              },
              Revisions: {
                locationName: "revisions",
                type: "list",
                member: {
                  shape: "Sn"
                }
              }
            }
          }
        },
        ListConfigurations: {
          http: {
            method: "GET",
            requestUri: "/v1/configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Configurations: {
                locationName: "configurations",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    AuthenticationStrategy: {
                      locationName: "authenticationStrategy"
                    },
                    Created: {
                      shape: "Sm",
                      locationName: "created"
                    },
                    Description: {
                      locationName: "description"
                    },
                    EngineType: {
                      locationName: "engineType"
                    },
                    EngineVersion: {
                      locationName: "engineVersion"
                    },
                    Id: {
                      locationName: "id"
                    },
                    LatestRevision: {
                      shape: "Sn",
                      locationName: "latestRevision"
                    },
                    Name: {
                      locationName: "name"
                    },
                    Tags: {
                      shape: "Sg",
                      locationName: "tags"
                    }
                  },
                  required: [
                    "Description",
                    "EngineVersion",
                    "LatestRevision",
                    "AuthenticationStrategy",
                    "EngineType",
                    "Id",
                    "Arn",
                    "Name",
                    "Created"
                  ]
                }
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListTags: {
          http: {
            method: "GET",
            requestUri: "/v1/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            }
          }
        },
        ListUsers: {
          http: {
            method: "GET",
            requestUri: "/v1/brokers/{broker-id}/users",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerId: {
                location: "uri",
                locationName: "broker-id"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "BrokerId"
            ]
          },
          output: {
            type: "structure",
            members: {
              BrokerId: {
                locationName: "brokerId"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              },
              Users: {
                shape: "S16",
                locationName: "users"
              }
            }
          }
        },
        RebootBroker: {
          http: {
            requestUri: "/v1/brokers/{broker-id}/reboot",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerId: {
                location: "uri",
                locationName: "broker-id"
              }
            },
            required: [
              "BrokerId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateBroker: {
          http: {
            method: "PUT",
            requestUri: "/v1/brokers/{broker-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AuthenticationStrategy: {
                locationName: "authenticationStrategy"
              },
              AutoMinorVersionUpgrade: {
                locationName: "autoMinorVersionUpgrade",
                type: "boolean"
              },
              BrokerId: {
                location: "uri",
                locationName: "broker-id"
              },
              Configuration: {
                shape: "S5",
                locationName: "configuration"
              },
              EngineVersion: {
                locationName: "engineVersion"
              },
              HostInstanceType: {
                locationName: "hostInstanceType"
              },
              LdapServerMetadata: {
                shape: "Sa",
                locationName: "ldapServerMetadata"
              },
              Logs: {
                shape: "Sc",
                locationName: "logs"
              },
              MaintenanceWindowStartTime: {
                shape: "Sd",
                locationName: "maintenanceWindowStartTime"
              },
              SecurityGroups: {
                shape: "Sb",
                locationName: "securityGroups"
              }
            },
            required: [
              "BrokerId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AuthenticationStrategy: {
                locationName: "authenticationStrategy"
              },
              AutoMinorVersionUpgrade: {
                locationName: "autoMinorVersionUpgrade",
                type: "boolean"
              },
              BrokerId: {
                locationName: "brokerId"
              },
              Configuration: {
                shape: "S5",
                locationName: "configuration"
              },
              EngineVersion: {
                locationName: "engineVersion"
              },
              HostInstanceType: {
                locationName: "hostInstanceType"
              },
              LdapServerMetadata: {
                shape: "S13",
                locationName: "ldapServerMetadata"
              },
              Logs: {
                shape: "Sc",
                locationName: "logs"
              },
              MaintenanceWindowStartTime: {
                shape: "Sd",
                locationName: "maintenanceWindowStartTime"
              },
              SecurityGroups: {
                shape: "Sb",
                locationName: "securityGroups"
              }
            }
          }
        },
        UpdateConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/v1/configurations/{configuration-id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConfigurationId: {
                location: "uri",
                locationName: "configuration-id"
              },
              Data: {
                locationName: "data"
              },
              Description: {
                locationName: "description"
              }
            },
            required: [
              "ConfigurationId",
              "Data"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              Created: {
                shape: "Sm",
                locationName: "created"
              },
              Id: {
                locationName: "id"
              },
              LatestRevision: {
                shape: "Sn",
                locationName: "latestRevision"
              },
              Name: {
                locationName: "name"
              },
              Warnings: {
                locationName: "warnings",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AttributeName: {
                      locationName: "attributeName"
                    },
                    ElementName: {
                      locationName: "elementName"
                    },
                    Reason: {
                      locationName: "reason"
                    }
                  },
                  required: [
                    "Reason"
                  ]
                }
              }
            }
          }
        },
        UpdateUser: {
          http: {
            method: "PUT",
            requestUri: "/v1/brokers/{broker-id}/users/{username}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerId: {
                location: "uri",
                locationName: "broker-id"
              },
              ConsoleAccess: {
                locationName: "consoleAccess",
                type: "boolean"
              },
              Groups: {
                shape: "Sb",
                locationName: "groups"
              },
              Password: {
                locationName: "password"
              },
              Username: {
                location: "uri",
                locationName: "username"
              }
            },
            required: [
              "Username",
              "BrokerId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            Id: {
              locationName: "id"
            },
            Revision: {
              locationName: "revision",
              type: "integer"
            }
          },
          required: [
            "Id"
          ]
        },
        S8: {
          type: "structure",
          members: {
            KmsKeyId: {
              locationName: "kmsKeyId"
            },
            UseAwsOwnedKey: {
              locationName: "useAwsOwnedKey",
              type: "boolean"
            }
          },
          required: [
            "UseAwsOwnedKey"
          ]
        },
        Sa: {
          type: "structure",
          members: {
            Hosts: {
              shape: "Sb",
              locationName: "hosts"
            },
            RoleBase: {
              locationName: "roleBase"
            },
            RoleName: {
              locationName: "roleName"
            },
            RoleSearchMatching: {
              locationName: "roleSearchMatching"
            },
            RoleSearchSubtree: {
              locationName: "roleSearchSubtree",
              type: "boolean"
            },
            ServiceAccountPassword: {
              locationName: "serviceAccountPassword"
            },
            ServiceAccountUsername: {
              locationName: "serviceAccountUsername"
            },
            UserBase: {
              locationName: "userBase"
            },
            UserRoleName: {
              locationName: "userRoleName"
            },
            UserSearchMatching: {
              locationName: "userSearchMatching"
            },
            UserSearchSubtree: {
              locationName: "userSearchSubtree",
              type: "boolean"
            }
          },
          required: [
            "Hosts",
            "UserSearchMatching",
            "UserBase",
            "RoleSearchMatching",
            "ServiceAccountUsername",
            "RoleBase",
            "ServiceAccountPassword"
          ]
        },
        Sb: {
          type: "list",
          member: {}
        },
        Sc: {
          type: "structure",
          members: {
            Audit: {
              locationName: "audit",
              type: "boolean"
            },
            General: {
              locationName: "general",
              type: "boolean"
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            DayOfWeek: {
              locationName: "dayOfWeek"
            },
            TimeOfDay: {
              locationName: "timeOfDay"
            },
            TimeZone: {
              locationName: "timeZone"
            }
          },
          required: [
            "TimeOfDay",
            "DayOfWeek"
          ]
        },
        Sg: {
          type: "map",
          key: {},
          value: {}
        },
        Sm: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sn: {
          type: "structure",
          members: {
            Created: {
              shape: "Sm",
              locationName: "created"
            },
            Description: {
              locationName: "description"
            },
            Revision: {
              locationName: "revision",
              type: "integer"
            }
          },
          required: [
            "Revision",
            "Created"
          ]
        },
        S13: {
          type: "structure",
          members: {
            Hosts: {
              shape: "Sb",
              locationName: "hosts"
            },
            RoleBase: {
              locationName: "roleBase"
            },
            RoleName: {
              locationName: "roleName"
            },
            RoleSearchMatching: {
              locationName: "roleSearchMatching"
            },
            RoleSearchSubtree: {
              locationName: "roleSearchSubtree",
              type: "boolean"
            },
            ServiceAccountUsername: {
              locationName: "serviceAccountUsername"
            },
            UserBase: {
              locationName: "userBase"
            },
            UserRoleName: {
              locationName: "userRoleName"
            },
            UserSearchMatching: {
              locationName: "userSearchMatching"
            },
            UserSearchSubtree: {
              locationName: "userSearchSubtree",
              type: "boolean"
            }
          },
          required: [
            "Hosts",
            "UserSearchMatching",
            "UserBase",
            "RoleSearchMatching",
            "ServiceAccountUsername",
            "RoleBase"
          ]
        },
        S16: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PendingChange: {
                locationName: "pendingChange"
              },
              Username: {
                locationName: "username"
              }
            },
            required: [
              "Username"
            ]
          }
        }
      },
      authorizers: {
        authorization_strategy: {
          name: "authorization_strategy",
          type: "provided",
          placement: {
            location: "header",
            name: "Authorization"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mq-2017-11-27.paginators.json
var require_mq_2017_11_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mq-2017-11-27.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListBrokers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "BrokerSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mq.js
var require_mq = __commonJS({
  "node_modules/aws-sdk/clients/mq.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["mq"] = {};
    AWS3.MQ = Service.defineService("mq", ["2017-11-27"]);
    Object.defineProperty(apiLoader.services["mq"], "2017-11-27", {
      get: function get() {
        var model = require_mq_2017_11_27_min();
        model.paginators = require_mq_2017_11_27_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.MQ;
  }
});

// node_modules/aws-sdk/apis/comprehend-2017-11-27.min.json
var require_comprehend_2017_11_27_min = __commonJS({
  "node_modules/aws-sdk/apis/comprehend-2017-11-27.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-11-27",
        endpointPrefix: "comprehend",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Comprehend",
        serviceId: "Comprehend",
        signatureVersion: "v4",
        signingName: "comprehend",
        targetPrefix: "Comprehend_20171127",
        uid: "comprehend-2017-11-27"
      },
      operations: {
        BatchDetectDominantLanguage: {
          input: {
            type: "structure",
            required: [
              "TextList"
            ],
            members: {
              TextList: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ResultList",
              "ErrorList"
            ],
            members: {
              ResultList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Index: {
                      type: "integer"
                    },
                    Languages: {
                      shape: "S8"
                    }
                  }
                }
              },
              ErrorList: {
                shape: "Sc"
              }
            },
            sensitive: true
          }
        },
        BatchDetectEntities: {
          input: {
            type: "structure",
            required: [
              "TextList",
              "LanguageCode"
            ],
            members: {
              TextList: {
                shape: "S2"
              },
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ResultList",
              "ErrorList"
            ],
            members: {
              ResultList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Index: {
                      type: "integer"
                    },
                    Entities: {
                      shape: "Sj"
                    }
                  }
                }
              },
              ErrorList: {
                shape: "Sc"
              }
            },
            sensitive: true
          }
        },
        BatchDetectKeyPhrases: {
          input: {
            type: "structure",
            required: [
              "TextList",
              "LanguageCode"
            ],
            members: {
              TextList: {
                shape: "S2"
              },
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ResultList",
              "ErrorList"
            ],
            members: {
              ResultList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Index: {
                      type: "integer"
                    },
                    KeyPhrases: {
                      shape: "Sq"
                    }
                  }
                }
              },
              ErrorList: {
                shape: "Sc"
              }
            },
            sensitive: true
          }
        },
        BatchDetectSentiment: {
          input: {
            type: "structure",
            required: [
              "TextList",
              "LanguageCode"
            ],
            members: {
              TextList: {
                shape: "S2"
              },
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ResultList",
              "ErrorList"
            ],
            members: {
              ResultList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Index: {
                      type: "integer"
                    },
                    Sentiment: {},
                    SentimentScore: {
                      shape: "Sx"
                    }
                  }
                }
              },
              ErrorList: {
                shape: "Sc"
              }
            },
            sensitive: true
          }
        },
        BatchDetectSyntax: {
          input: {
            type: "structure",
            required: [
              "TextList",
              "LanguageCode"
            ],
            members: {
              TextList: {
                shape: "S2"
              },
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ResultList",
              "ErrorList"
            ],
            members: {
              ResultList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Index: {
                      type: "integer"
                    },
                    SyntaxTokens: {
                      shape: "S13"
                    }
                  }
                }
              },
              ErrorList: {
                shape: "Sc"
              }
            },
            sensitive: true
          }
        },
        ClassifyDocument: {
          input: {
            type: "structure",
            required: [
              "Text",
              "EndpointArn"
            ],
            members: {
              Text: {
                shape: "S3"
              },
              EndpointArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Classes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Score: {
                      type: "float"
                    }
                  }
                }
              },
              Labels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Score: {
                      type: "float"
                    }
                  }
                }
              }
            },
            sensitive: true
          }
        },
        ContainsPiiEntities: {
          input: {
            type: "structure",
            required: [
              "Text",
              "LanguageCode"
            ],
            members: {
              Text: {},
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Labels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Score: {
                      type: "float"
                    }
                  }
                }
              }
            }
          }
        },
        CreateDocumentClassifier: {
          input: {
            type: "structure",
            required: [
              "DocumentClassifierName",
              "DataAccessRoleArn",
              "InputDataConfig",
              "LanguageCode"
            ],
            members: {
              DocumentClassifierName: {},
              VersionName: {},
              DataAccessRoleArn: {},
              Tags: {
                shape: "S1n"
              },
              InputDataConfig: {
                shape: "S1r"
              },
              OutputDataConfig: {
                shape: "S21"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              LanguageCode: {},
              VolumeKmsKeyId: {},
              VpcConfig: {
                shape: "S24"
              },
              Mode: {},
              ModelKmsKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentClassifierArn: {}
            }
          }
        },
        CreateEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointName",
              "ModelArn",
              "DesiredInferenceUnits"
            ],
            members: {
              EndpointName: {},
              ModelArn: {},
              DesiredInferenceUnits: {
                type: "integer"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S1n"
              },
              DataAccessRoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointArn: {}
            }
          }
        },
        CreateEntityRecognizer: {
          input: {
            type: "structure",
            required: [
              "RecognizerName",
              "DataAccessRoleArn",
              "InputDataConfig",
              "LanguageCode"
            ],
            members: {
              RecognizerName: {},
              VersionName: {},
              DataAccessRoleArn: {},
              Tags: {
                shape: "S1n"
              },
              InputDataConfig: {
                shape: "S2j"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              LanguageCode: {},
              VolumeKmsKeyId: {},
              VpcConfig: {
                shape: "S24"
              },
              ModelKmsKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EntityRecognizerArn: {}
            }
          }
        },
        DeleteDocumentClassifier: {
          input: {
            type: "structure",
            required: [
              "DocumentClassifierArn"
            ],
            members: {
              DocumentClassifierArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEntityRecognizer: {
          input: {
            type: "structure",
            required: [
              "EntityRecognizerArn"
            ],
            members: {
              EntityRecognizerArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeDocumentClassificationJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentClassificationJobProperties: {
                shape: "S34"
              }
            }
          }
        },
        DescribeDocumentClassifier: {
          input: {
            type: "structure",
            required: [
              "DocumentClassifierArn"
            ],
            members: {
              DocumentClassifierArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentClassifierProperties: {
                shape: "S3j"
              }
            }
          }
        },
        DescribeDominantLanguageDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DominantLanguageDetectionJobProperties: {
                shape: "S3q"
              }
            }
          }
        },
        DescribeEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointProperties: {
                shape: "S3t"
              }
            }
          }
        },
        DescribeEntitiesDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EntitiesDetectionJobProperties: {
                shape: "S3x"
              }
            }
          }
        },
        DescribeEntityRecognizer: {
          input: {
            type: "structure",
            required: [
              "EntityRecognizerArn"
            ],
            members: {
              EntityRecognizerArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EntityRecognizerProperties: {
                shape: "S40"
              }
            }
          }
        },
        DescribeEventsDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EventsDetectionJobProperties: {
                shape: "S48"
              }
            }
          }
        },
        DescribeKeyPhrasesDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              KeyPhrasesDetectionJobProperties: {
                shape: "S4d"
              }
            }
          }
        },
        DescribePiiEntitiesDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PiiEntitiesDetectionJobProperties: {
                shape: "S4g"
              }
            }
          }
        },
        DescribeSentimentDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SentimentDetectionJobProperties: {
                shape: "S4p"
              }
            }
          }
        },
        DescribeTopicsDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TopicsDetectionJobProperties: {
                shape: "S4s"
              }
            }
          }
        },
        DetectDominantLanguage: {
          input: {
            type: "structure",
            required: [
              "Text"
            ],
            members: {
              Text: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Languages: {
                shape: "S8"
              }
            },
            sensitive: true
          }
        },
        DetectEntities: {
          input: {
            type: "structure",
            required: [
              "Text"
            ],
            members: {
              Text: {
                shape: "S3"
              },
              LanguageCode: {},
              EndpointArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Entities: {
                shape: "Sj"
              }
            },
            sensitive: true
          }
        },
        DetectKeyPhrases: {
          input: {
            type: "structure",
            required: [
              "Text",
              "LanguageCode"
            ],
            members: {
              Text: {
                shape: "S3"
              },
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              KeyPhrases: {
                shape: "Sq"
              }
            },
            sensitive: true
          }
        },
        DetectPiiEntities: {
          input: {
            type: "structure",
            required: [
              "Text",
              "LanguageCode"
            ],
            members: {
              Text: {},
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Entities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Score: {
                      type: "float"
                    },
                    Type: {},
                    BeginOffset: {
                      type: "integer"
                    },
                    EndOffset: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        DetectSentiment: {
          input: {
            type: "structure",
            required: [
              "Text",
              "LanguageCode"
            ],
            members: {
              Text: {
                shape: "S3"
              },
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Sentiment: {},
              SentimentScore: {
                shape: "Sx"
              }
            },
            sensitive: true
          }
        },
        DetectSyntax: {
          input: {
            type: "structure",
            required: [
              "Text",
              "LanguageCode"
            ],
            members: {
              Text: {
                shape: "S3"
              },
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SyntaxTokens: {
                shape: "S13"
              }
            },
            sensitive: true
          }
        },
        ListDocumentClassificationJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  JobName: {},
                  JobStatus: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentClassificationJobPropertiesList: {
                type: "list",
                member: {
                  shape: "S34"
                }
              },
              NextToken: {}
            }
          }
        },
        ListDocumentClassifierSummaries: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentClassifierSummariesList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DocumentClassifierName: {},
                    NumberOfVersions: {
                      type: "integer"
                    },
                    LatestVersionCreatedAt: {
                      type: "timestamp"
                    },
                    LatestVersionName: {},
                    LatestVersionStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDocumentClassifiers: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  Status: {},
                  DocumentClassifierName: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentClassifierPropertiesList: {
                type: "list",
                member: {
                  shape: "S3j"
                }
              },
              NextToken: {}
            }
          }
        },
        ListDominantLanguageDetectionJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  JobName: {},
                  JobStatus: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DominantLanguageDetectionJobPropertiesList: {
                type: "list",
                member: {
                  shape: "S3q"
                }
              },
              NextToken: {}
            }
          }
        },
        ListEndpoints: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  ModelArn: {},
                  Status: {},
                  CreationTimeBefore: {
                    type: "timestamp"
                  },
                  CreationTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointPropertiesList: {
                type: "list",
                member: {
                  shape: "S3t"
                }
              },
              NextToken: {}
            }
          }
        },
        ListEntitiesDetectionJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  JobName: {},
                  JobStatus: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EntitiesDetectionJobPropertiesList: {
                type: "list",
                member: {
                  shape: "S3x"
                }
              },
              NextToken: {}
            }
          }
        },
        ListEntityRecognizerSummaries: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EntityRecognizerSummariesList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RecognizerName: {},
                    NumberOfVersions: {
                      type: "integer"
                    },
                    LatestVersionCreatedAt: {
                      type: "timestamp"
                    },
                    LatestVersionName: {},
                    LatestVersionStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEntityRecognizers: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  Status: {},
                  RecognizerName: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EntityRecognizerPropertiesList: {
                type: "list",
                member: {
                  shape: "S40"
                }
              },
              NextToken: {}
            }
          }
        },
        ListEventsDetectionJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  JobName: {},
                  JobStatus: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventsDetectionJobPropertiesList: {
                type: "list",
                member: {
                  shape: "S48"
                }
              },
              NextToken: {}
            }
          }
        },
        ListKeyPhrasesDetectionJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  JobName: {},
                  JobStatus: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyPhrasesDetectionJobPropertiesList: {
                type: "list",
                member: {
                  shape: "S4d"
                }
              },
              NextToken: {}
            }
          }
        },
        ListPiiEntitiesDetectionJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  JobName: {},
                  JobStatus: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PiiEntitiesDetectionJobPropertiesList: {
                type: "list",
                member: {
                  shape: "S4g"
                }
              },
              NextToken: {}
            }
          }
        },
        ListSentimentDetectionJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  JobName: {},
                  JobStatus: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SentimentDetectionJobPropertiesList: {
                type: "list",
                member: {
                  shape: "S4p"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S1n"
              }
            }
          }
        },
        ListTopicsDetectionJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  JobName: {},
                  JobStatus: {},
                  SubmitTimeBefore: {
                    type: "timestamp"
                  },
                  SubmitTimeAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TopicsDetectionJobPropertiesList: {
                type: "list",
                member: {
                  shape: "S4s"
                }
              },
              NextToken: {}
            }
          }
        },
        StartDocumentClassificationJob: {
          input: {
            type: "structure",
            required: [
              "DocumentClassifierArn",
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn"
            ],
            members: {
              JobName: {},
              DocumentClassifierArn: {},
              InputDataConfig: {
                shape: "S3a"
              },
              OutputDataConfig: {
                shape: "S3g"
              },
              DataAccessRoleArn: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeKmsKeyId: {},
              VpcConfig: {
                shape: "S24"
              },
              Tags: {
                shape: "S1n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobArn: {},
              JobStatus: {}
            }
          }
        },
        StartDominantLanguageDetectionJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn"
            ],
            members: {
              InputDataConfig: {
                shape: "S3a"
              },
              OutputDataConfig: {
                shape: "S3g"
              },
              DataAccessRoleArn: {},
              JobName: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeKmsKeyId: {},
              VpcConfig: {
                shape: "S24"
              },
              Tags: {
                shape: "S1n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobArn: {},
              JobStatus: {}
            }
          }
        },
        StartEntitiesDetectionJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn",
              "LanguageCode"
            ],
            members: {
              InputDataConfig: {
                shape: "S3a"
              },
              OutputDataConfig: {
                shape: "S3g"
              },
              DataAccessRoleArn: {},
              JobName: {},
              EntityRecognizerArn: {},
              LanguageCode: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeKmsKeyId: {},
              VpcConfig: {
                shape: "S24"
              },
              Tags: {
                shape: "S1n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobArn: {},
              JobStatus: {}
            }
          }
        },
        StartEventsDetectionJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn",
              "LanguageCode",
              "TargetEventTypes"
            ],
            members: {
              InputDataConfig: {
                shape: "S3a"
              },
              OutputDataConfig: {
                shape: "S3g"
              },
              DataAccessRoleArn: {},
              JobName: {},
              LanguageCode: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              TargetEventTypes: {
                shape: "S49"
              },
              Tags: {
                shape: "S1n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobArn: {},
              JobStatus: {}
            }
          }
        },
        StartKeyPhrasesDetectionJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn",
              "LanguageCode"
            ],
            members: {
              InputDataConfig: {
                shape: "S3a"
              },
              OutputDataConfig: {
                shape: "S3g"
              },
              DataAccessRoleArn: {},
              JobName: {},
              LanguageCode: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeKmsKeyId: {},
              VpcConfig: {
                shape: "S24"
              },
              Tags: {
                shape: "S1n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobArn: {},
              JobStatus: {}
            }
          }
        },
        StartPiiEntitiesDetectionJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "Mode",
              "DataAccessRoleArn",
              "LanguageCode"
            ],
            members: {
              InputDataConfig: {
                shape: "S3a"
              },
              OutputDataConfig: {
                shape: "S3g"
              },
              Mode: {},
              RedactionConfig: {
                shape: "S4i"
              },
              DataAccessRoleArn: {},
              JobName: {},
              LanguageCode: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S1n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobArn: {},
              JobStatus: {}
            }
          }
        },
        StartSentimentDetectionJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn",
              "LanguageCode"
            ],
            members: {
              InputDataConfig: {
                shape: "S3a"
              },
              OutputDataConfig: {
                shape: "S3g"
              },
              DataAccessRoleArn: {},
              JobName: {},
              LanguageCode: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeKmsKeyId: {},
              VpcConfig: {
                shape: "S24"
              },
              Tags: {
                shape: "S1n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobArn: {},
              JobStatus: {}
            }
          }
        },
        StartTopicsDetectionJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn"
            ],
            members: {
              InputDataConfig: {
                shape: "S3a"
              },
              OutputDataConfig: {
                shape: "S3g"
              },
              DataAccessRoleArn: {},
              JobName: {},
              NumberOfTopics: {
                type: "integer"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeKmsKeyId: {},
              VpcConfig: {
                shape: "S24"
              },
              Tags: {
                shape: "S1n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobArn: {},
              JobStatus: {}
            }
          }
        },
        StopDominantLanguageDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobStatus: {}
            }
          }
        },
        StopEntitiesDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobStatus: {}
            }
          }
        },
        StopEventsDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobStatus: {}
            }
          }
        },
        StopKeyPhrasesDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobStatus: {}
            }
          }
        },
        StopPiiEntitiesDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobStatus: {}
            }
          }
        },
        StopSentimentDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobStatus: {}
            }
          }
        },
        StopTrainingDocumentClassifier: {
          input: {
            type: "structure",
            required: [
              "DocumentClassifierArn"
            ],
            members: {
              DocumentClassifierArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopTrainingEntityRecognizer: {
          input: {
            type: "structure",
            required: [
              "EntityRecognizerArn"
            ],
            members: {
              EntityRecognizerArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S1n"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {},
              DesiredModelArn: {},
              DesiredInferenceUnits: {
                type: "integer"
              },
              DesiredDataAccessRoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {
            shape: "S3"
          },
          sensitive: true
        },
        S3: {
          type: "string",
          sensitive: true
        },
        S8: {
          type: "list",
          member: {
            type: "structure",
            members: {
              LanguageCode: {},
              Score: {
                type: "float"
              }
            }
          }
        },
        Sc: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Index: {
                type: "integer"
              },
              ErrorCode: {},
              ErrorMessage: {}
            }
          }
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Score: {
                type: "float"
              },
              Type: {},
              Text: {},
              BeginOffset: {
                type: "integer"
              },
              EndOffset: {
                type: "integer"
              }
            }
          }
        },
        Sq: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Score: {
                type: "float"
              },
              Text: {},
              BeginOffset: {
                type: "integer"
              },
              EndOffset: {
                type: "integer"
              }
            }
          }
        },
        Sx: {
          type: "structure",
          members: {
            Positive: {
              type: "float"
            },
            Negative: {
              type: "float"
            },
            Neutral: {
              type: "float"
            },
            Mixed: {
              type: "float"
            }
          }
        },
        S13: {
          type: "list",
          member: {
            type: "structure",
            members: {
              TokenId: {
                type: "integer"
              },
              Text: {},
              BeginOffset: {
                type: "integer"
              },
              EndOffset: {
                type: "integer"
              },
              PartOfSpeech: {
                type: "structure",
                members: {
                  Tag: {},
                  Score: {
                    type: "float"
                  }
                }
              }
            }
          }
        },
        S1n: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S1r: {
          type: "structure",
          members: {
            DataFormat: {},
            S3Uri: {},
            TestS3Uri: {},
            LabelDelimiter: {},
            AugmentedManifests: {
              type: "list",
              member: {
                shape: "S1w"
              }
            }
          }
        },
        S1w: {
          type: "structure",
          required: [
            "S3Uri",
            "AttributeNames"
          ],
          members: {
            S3Uri: {},
            Split: {},
            AttributeNames: {
              type: "list",
              member: {}
            },
            AnnotationDataS3Uri: {},
            SourceDocumentsS3Uri: {},
            DocumentType: {}
          }
        },
        S21: {
          type: "structure",
          members: {
            S3Uri: {},
            KmsKeyId: {}
          }
        },
        S24: {
          type: "structure",
          required: [
            "SecurityGroupIds",
            "Subnets"
          ],
          members: {
            SecurityGroupIds: {
              type: "list",
              member: {}
            },
            Subnets: {
              type: "list",
              member: {}
            }
          }
        },
        S2j: {
          type: "structure",
          required: [
            "EntityTypes"
          ],
          members: {
            DataFormat: {},
            EntityTypes: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Type"
                ],
                members: {
                  Type: {}
                }
              }
            },
            Documents: {
              type: "structure",
              required: [
                "S3Uri"
              ],
              members: {
                S3Uri: {},
                TestS3Uri: {},
                InputFormat: {}
              }
            },
            Annotations: {
              type: "structure",
              required: [
                "S3Uri"
              ],
              members: {
                S3Uri: {},
                TestS3Uri: {}
              }
            },
            EntityList: {
              type: "structure",
              required: [
                "S3Uri"
              ],
              members: {
                S3Uri: {}
              }
            },
            AugmentedManifests: {
              type: "list",
              member: {
                shape: "S1w"
              }
            }
          }
        },
        S34: {
          type: "structure",
          members: {
            JobId: {},
            JobArn: {},
            JobName: {},
            JobStatus: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            DocumentClassifierArn: {},
            InputDataConfig: {
              shape: "S3a"
            },
            OutputDataConfig: {
              shape: "S3g"
            },
            DataAccessRoleArn: {},
            VolumeKmsKeyId: {},
            VpcConfig: {
              shape: "S24"
            }
          }
        },
        S3a: {
          type: "structure",
          required: [
            "S3Uri"
          ],
          members: {
            S3Uri: {},
            InputFormat: {},
            DocumentReaderConfig: {
              type: "structure",
              required: [
                "DocumentReadAction"
              ],
              members: {
                DocumentReadAction: {},
                DocumentReadMode: {},
                FeatureTypes: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        S3g: {
          type: "structure",
          required: [
            "S3Uri"
          ],
          members: {
            S3Uri: {},
            KmsKeyId: {}
          }
        },
        S3j: {
          type: "structure",
          members: {
            DocumentClassifierArn: {},
            LanguageCode: {},
            Status: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            TrainingStartTime: {
              type: "timestamp"
            },
            TrainingEndTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "S1r"
            },
            OutputDataConfig: {
              shape: "S21"
            },
            ClassifierMetadata: {
              type: "structure",
              members: {
                NumberOfLabels: {
                  type: "integer"
                },
                NumberOfTrainedDocuments: {
                  type: "integer"
                },
                NumberOfTestDocuments: {
                  type: "integer"
                },
                EvaluationMetrics: {
                  type: "structure",
                  members: {
                    Accuracy: {
                      type: "double"
                    },
                    Precision: {
                      type: "double"
                    },
                    Recall: {
                      type: "double"
                    },
                    F1Score: {
                      type: "double"
                    },
                    MicroPrecision: {
                      type: "double"
                    },
                    MicroRecall: {
                      type: "double"
                    },
                    MicroF1Score: {
                      type: "double"
                    },
                    HammingLoss: {
                      type: "double"
                    }
                  }
                }
              },
              sensitive: true
            },
            DataAccessRoleArn: {},
            VolumeKmsKeyId: {},
            VpcConfig: {
              shape: "S24"
            },
            Mode: {},
            ModelKmsKeyId: {},
            VersionName: {}
          }
        },
        S3q: {
          type: "structure",
          members: {
            JobId: {},
            JobArn: {},
            JobName: {},
            JobStatus: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "S3a"
            },
            OutputDataConfig: {
              shape: "S3g"
            },
            DataAccessRoleArn: {},
            VolumeKmsKeyId: {},
            VpcConfig: {
              shape: "S24"
            }
          }
        },
        S3t: {
          type: "structure",
          members: {
            EndpointArn: {},
            Status: {},
            Message: {},
            ModelArn: {},
            DesiredModelArn: {},
            DesiredInferenceUnits: {
              type: "integer"
            },
            CurrentInferenceUnits: {
              type: "integer"
            },
            CreationTime: {
              type: "timestamp"
            },
            LastModifiedTime: {
              type: "timestamp"
            },
            DataAccessRoleArn: {},
            DesiredDataAccessRoleArn: {}
          }
        },
        S3x: {
          type: "structure",
          members: {
            JobId: {},
            JobArn: {},
            JobName: {},
            JobStatus: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            EntityRecognizerArn: {},
            InputDataConfig: {
              shape: "S3a"
            },
            OutputDataConfig: {
              shape: "S3g"
            },
            LanguageCode: {},
            DataAccessRoleArn: {},
            VolumeKmsKeyId: {},
            VpcConfig: {
              shape: "S24"
            }
          }
        },
        S40: {
          type: "structure",
          members: {
            EntityRecognizerArn: {},
            LanguageCode: {},
            Status: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            TrainingStartTime: {
              type: "timestamp"
            },
            TrainingEndTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "S2j"
            },
            RecognizerMetadata: {
              type: "structure",
              members: {
                NumberOfTrainedDocuments: {
                  type: "integer"
                },
                NumberOfTestDocuments: {
                  type: "integer"
                },
                EvaluationMetrics: {
                  type: "structure",
                  members: {
                    Precision: {
                      type: "double"
                    },
                    Recall: {
                      type: "double"
                    },
                    F1Score: {
                      type: "double"
                    }
                  }
                },
                EntityTypes: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      Type: {},
                      EvaluationMetrics: {
                        type: "structure",
                        members: {
                          Precision: {
                            type: "double"
                          },
                          Recall: {
                            type: "double"
                          },
                          F1Score: {
                            type: "double"
                          }
                        }
                      },
                      NumberOfTrainMentions: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              sensitive: true
            },
            DataAccessRoleArn: {},
            VolumeKmsKeyId: {},
            VpcConfig: {
              shape: "S24"
            },
            ModelKmsKeyId: {},
            VersionName: {}
          }
        },
        S48: {
          type: "structure",
          members: {
            JobId: {},
            JobArn: {},
            JobName: {},
            JobStatus: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "S3a"
            },
            OutputDataConfig: {
              shape: "S3g"
            },
            LanguageCode: {},
            DataAccessRoleArn: {},
            TargetEventTypes: {
              shape: "S49"
            }
          }
        },
        S49: {
          type: "list",
          member: {}
        },
        S4d: {
          type: "structure",
          members: {
            JobId: {},
            JobArn: {},
            JobName: {},
            JobStatus: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "S3a"
            },
            OutputDataConfig: {
              shape: "S3g"
            },
            LanguageCode: {},
            DataAccessRoleArn: {},
            VolumeKmsKeyId: {},
            VpcConfig: {
              shape: "S24"
            }
          }
        },
        S4g: {
          type: "structure",
          members: {
            JobId: {},
            JobArn: {},
            JobName: {},
            JobStatus: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "S3a"
            },
            OutputDataConfig: {
              type: "structure",
              required: [
                "S3Uri"
              ],
              members: {
                S3Uri: {},
                KmsKeyId: {}
              }
            },
            RedactionConfig: {
              shape: "S4i"
            },
            LanguageCode: {},
            DataAccessRoleArn: {},
            Mode: {}
          }
        },
        S4i: {
          type: "structure",
          members: {
            PiiEntityTypes: {
              type: "list",
              member: {}
            },
            MaskMode: {},
            MaskCharacter: {}
          }
        },
        S4p: {
          type: "structure",
          members: {
            JobId: {},
            JobArn: {},
            JobName: {},
            JobStatus: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "S3a"
            },
            OutputDataConfig: {
              shape: "S3g"
            },
            LanguageCode: {},
            DataAccessRoleArn: {},
            VolumeKmsKeyId: {},
            VpcConfig: {
              shape: "S24"
            }
          }
        },
        S4s: {
          type: "structure",
          members: {
            JobId: {},
            JobArn: {},
            JobName: {},
            JobStatus: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "S3a"
            },
            OutputDataConfig: {
              shape: "S3g"
            },
            NumberOfTopics: {
              type: "integer"
            },
            DataAccessRoleArn: {},
            VolumeKmsKeyId: {},
            VpcConfig: {
              shape: "S24"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/comprehend-2017-11-27.paginators.json
var require_comprehend_2017_11_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/comprehend-2017-11-27.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListDocumentClassificationJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDocumentClassifierSummaries: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDocumentClassifiers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDominantLanguageDetectionJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListEntitiesDetectionJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListEntityRecognizerSummaries: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListEntityRecognizers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListEventsDetectionJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListKeyPhrasesDetectionJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSentimentDetectionJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTopicsDetectionJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/comprehend.js
var require_comprehend = __commonJS({
  "node_modules/aws-sdk/clients/comprehend.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["comprehend"] = {};
    AWS3.Comprehend = Service.defineService("comprehend", ["2017-11-27"]);
    Object.defineProperty(apiLoader.services["comprehend"], "2017-11-27", {
      get: function get() {
        var model = require_comprehend_2017_11_27_min();
        model.paginators = require_comprehend_2017_11_27_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Comprehend;
  }
});

// node_modules/aws-sdk/apis/iot-jobs-data-2017-09-29.min.json
var require_iot_jobs_data_2017_09_29_min = __commonJS({
  "node_modules/aws-sdk/apis/iot-jobs-data-2017-09-29.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-09-29",
        endpointPrefix: "data.jobs.iot",
        protocol: "rest-json",
        serviceFullName: "AWS IoT Jobs Data Plane",
        serviceId: "IoT Jobs Data Plane",
        signatureVersion: "v4",
        signingName: "iot-jobs-data",
        uid: "iot-jobs-data-2017-09-29"
      },
      operations: {
        DescribeJobExecution: {
          http: {
            method: "GET",
            requestUri: "/things/{thingName}/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "jobId",
              "thingName"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              includeJobDocument: {
                location: "querystring",
                locationName: "includeJobDocument",
                type: "boolean"
              },
              executionNumber: {
                location: "querystring",
                locationName: "executionNumber",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              execution: {
                shape: "S7"
              }
            }
          }
        },
        GetPendingJobExecutions: {
          http: {
            method: "GET",
            requestUri: "/things/{thingName}/jobs"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              inProgressJobs: {
                shape: "Sl"
              },
              queuedJobs: {
                shape: "Sl"
              }
            }
          }
        },
        StartNextPendingJobExecution: {
          http: {
            method: "PUT",
            requestUri: "/things/{thingName}/jobs/$next"
          },
          input: {
            type: "structure",
            required: [
              "thingName"
            ],
            members: {
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              statusDetails: {
                shape: "Sa"
              },
              stepTimeoutInMinutes: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              execution: {
                shape: "S7"
              }
            }
          }
        },
        UpdateJobExecution: {
          http: {
            requestUri: "/things/{thingName}/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "jobId",
              "thingName",
              "status"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              thingName: {
                location: "uri",
                locationName: "thingName"
              },
              status: {},
              statusDetails: {
                shape: "Sa"
              },
              stepTimeoutInMinutes: {
                type: "long"
              },
              expectedVersion: {
                type: "long"
              },
              includeJobExecutionState: {
                type: "boolean"
              },
              includeJobDocument: {
                type: "boolean"
              },
              executionNumber: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              executionState: {
                type: "structure",
                members: {
                  status: {},
                  statusDetails: {
                    shape: "Sa"
                  },
                  versionNumber: {
                    type: "long"
                  }
                }
              },
              jobDocument: {}
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "structure",
          members: {
            jobId: {},
            thingName: {},
            status: {},
            statusDetails: {
              shape: "Sa"
            },
            queuedAt: {
              type: "long"
            },
            startedAt: {
              type: "long"
            },
            lastUpdatedAt: {
              type: "long"
            },
            approximateSecondsBeforeTimedOut: {
              type: "long"
            },
            versionNumber: {
              type: "long"
            },
            executionNumber: {
              type: "long"
            },
            jobDocument: {}
          }
        },
        Sa: {
          type: "map",
          key: {},
          value: {}
        },
        Sl: {
          type: "list",
          member: {
            type: "structure",
            members: {
              jobId: {},
              queuedAt: {
                type: "long"
              },
              startedAt: {
                type: "long"
              },
              lastUpdatedAt: {
                type: "long"
              },
              versionNumber: {
                type: "long"
              },
              executionNumber: {
                type: "long"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iot-jobs-data-2017-09-29.paginators.json
var require_iot_jobs_data_2017_09_29_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iot-jobs-data-2017-09-29.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/iotjobsdataplane.js
var require_iotjobsdataplane = __commonJS({
  "node_modules/aws-sdk/clients/iotjobsdataplane.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["iotjobsdataplane"] = {};
    AWS3.IoTJobsDataPlane = Service.defineService("iotjobsdataplane", ["2017-09-29"]);
    Object.defineProperty(apiLoader.services["iotjobsdataplane"], "2017-09-29", {
      get: function get() {
        var model = require_iot_jobs_data_2017_09_29_min();
        model.paginators = require_iot_jobs_data_2017_09_29_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.IoTJobsDataPlane;
  }
});

// node_modules/aws-sdk/apis/kinesis-video-archived-media-2017-09-30.min.json
var require_kinesis_video_archived_media_2017_09_30_min = __commonJS({
  "node_modules/aws-sdk/apis/kinesis-video-archived-media-2017-09-30.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-09-30",
        endpointPrefix: "kinesisvideo",
        protocol: "rest-json",
        serviceAbbreviation: "Kinesis Video Archived Media",
        serviceFullName: "Amazon Kinesis Video Streams Archived Media",
        serviceId: "Kinesis Video Archived Media",
        signatureVersion: "v4",
        uid: "kinesis-video-archived-media-2017-09-30"
      },
      operations: {
        GetClip: {
          http: {
            requestUri: "/getClip"
          },
          input: {
            type: "structure",
            required: [
              "ClipFragmentSelector"
            ],
            members: {
              StreamName: {},
              StreamARN: {},
              ClipFragmentSelector: {
                type: "structure",
                required: [
                  "FragmentSelectorType",
                  "TimestampRange"
                ],
                members: {
                  FragmentSelectorType: {},
                  TimestampRange: {
                    type: "structure",
                    required: [
                      "StartTimestamp",
                      "EndTimestamp"
                    ],
                    members: {
                      StartTimestamp: {
                        type: "timestamp"
                      },
                      EndTimestamp: {
                        type: "timestamp"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              Payload: {
                shape: "Sa"
              }
            },
            payload: "Payload"
          }
        },
        GetDASHStreamingSessionURL: {
          http: {
            requestUri: "/getDASHStreamingSessionURL"
          },
          input: {
            type: "structure",
            members: {
              StreamName: {},
              StreamARN: {},
              PlaybackMode: {},
              DisplayFragmentTimestamp: {},
              DisplayFragmentNumber: {},
              DASHFragmentSelector: {
                type: "structure",
                members: {
                  FragmentSelectorType: {},
                  TimestampRange: {
                    type: "structure",
                    members: {
                      StartTimestamp: {
                        type: "timestamp"
                      },
                      EndTimestamp: {
                        type: "timestamp"
                      }
                    }
                  }
                }
              },
              Expires: {
                type: "integer"
              },
              MaxManifestFragmentResults: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DASHStreamingSessionURL: {}
            }
          }
        },
        GetHLSStreamingSessionURL: {
          http: {
            requestUri: "/getHLSStreamingSessionURL"
          },
          input: {
            type: "structure",
            members: {
              StreamName: {},
              StreamARN: {},
              PlaybackMode: {},
              HLSFragmentSelector: {
                type: "structure",
                members: {
                  FragmentSelectorType: {},
                  TimestampRange: {
                    type: "structure",
                    members: {
                      StartTimestamp: {
                        type: "timestamp"
                      },
                      EndTimestamp: {
                        type: "timestamp"
                      }
                    }
                  }
                }
              },
              ContainerFormat: {},
              DiscontinuityMode: {},
              DisplayFragmentTimestamp: {},
              Expires: {
                type: "integer"
              },
              MaxMediaPlaylistFragmentResults: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HLSStreamingSessionURL: {}
            }
          }
        },
        GetMediaForFragmentList: {
          http: {
            requestUri: "/getMediaForFragmentList"
          },
          input: {
            type: "structure",
            required: [
              "Fragments"
            ],
            members: {
              StreamName: {},
              StreamARN: {},
              Fragments: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              Payload: {
                shape: "Sa"
              }
            },
            payload: "Payload"
          }
        },
        ListFragments: {
          http: {
            requestUri: "/listFragments"
          },
          input: {
            type: "structure",
            members: {
              StreamName: {},
              StreamARN: {},
              MaxResults: {
                type: "long"
              },
              NextToken: {},
              FragmentSelector: {
                type: "structure",
                required: [
                  "FragmentSelectorType",
                  "TimestampRange"
                ],
                members: {
                  FragmentSelectorType: {},
                  TimestampRange: {
                    type: "structure",
                    required: [
                      "StartTimestamp",
                      "EndTimestamp"
                    ],
                    members: {
                      StartTimestamp: {
                        type: "timestamp"
                      },
                      EndTimestamp: {
                        type: "timestamp"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Fragments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FragmentNumber: {},
                    FragmentSizeInBytes: {
                      type: "long"
                    },
                    ProducerTimestamp: {
                      type: "timestamp"
                    },
                    ServerTimestamp: {
                      type: "timestamp"
                    },
                    FragmentLengthInMilliseconds: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        }
      },
      shapes: {
        Sa: {
          type: "blob",
          streaming: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kinesis-video-archived-media-2017-09-30.paginators.json
var require_kinesis_video_archived_media_2017_09_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kinesis-video-archived-media-2017-09-30.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListFragments: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Fragments"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/kinesisvideoarchivedmedia.js
var require_kinesisvideoarchivedmedia = __commonJS({
  "node_modules/aws-sdk/clients/kinesisvideoarchivedmedia.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["kinesisvideoarchivedmedia"] = {};
    AWS3.KinesisVideoArchivedMedia = Service.defineService("kinesisvideoarchivedmedia", ["2017-09-30"]);
    Object.defineProperty(apiLoader.services["kinesisvideoarchivedmedia"], "2017-09-30", {
      get: function get() {
        var model = require_kinesis_video_archived_media_2017_09_30_min();
        model.paginators = require_kinesis_video_archived_media_2017_09_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.KinesisVideoArchivedMedia;
  }
});

// node_modules/aws-sdk/apis/kinesis-video-media-2017-09-30.min.json
var require_kinesis_video_media_2017_09_30_min = __commonJS({
  "node_modules/aws-sdk/apis/kinesis-video-media-2017-09-30.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-09-30",
        endpointPrefix: "kinesisvideo",
        protocol: "rest-json",
        serviceAbbreviation: "Kinesis Video Media",
        serviceFullName: "Amazon Kinesis Video Streams Media",
        serviceId: "Kinesis Video Media",
        signatureVersion: "v4",
        uid: "kinesis-video-media-2017-09-30"
      },
      operations: {
        GetMedia: {
          http: {
            requestUri: "/getMedia"
          },
          input: {
            type: "structure",
            required: [
              "StartSelector"
            ],
            members: {
              StreamName: {},
              StreamARN: {},
              StartSelector: {
                type: "structure",
                required: [
                  "StartSelectorType"
                ],
                members: {
                  StartSelectorType: {},
                  AfterFragmentNumber: {},
                  StartTimestamp: {
                    type: "timestamp"
                  },
                  ContinuationToken: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              Payload: {
                type: "blob",
                streaming: true
              }
            },
            payload: "Payload"
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/kinesis-video-media-2017-09-30.paginators.json
var require_kinesis_video_media_2017_09_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kinesis-video-media-2017-09-30.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/kinesisvideomedia.js
var require_kinesisvideomedia = __commonJS({
  "node_modules/aws-sdk/clients/kinesisvideomedia.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["kinesisvideomedia"] = {};
    AWS3.KinesisVideoMedia = Service.defineService("kinesisvideomedia", ["2017-09-30"]);
    Object.defineProperty(apiLoader.services["kinesisvideomedia"], "2017-09-30", {
      get: function get() {
        var model = require_kinesis_video_media_2017_09_30_min();
        model.paginators = require_kinesis_video_media_2017_09_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.KinesisVideoMedia;
  }
});

// node_modules/aws-sdk/apis/kinesisvideo-2017-09-30.min.json
var require_kinesisvideo_2017_09_30_min = __commonJS({
  "node_modules/aws-sdk/apis/kinesisvideo-2017-09-30.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-09-30",
        endpointPrefix: "kinesisvideo",
        protocol: "rest-json",
        serviceAbbreviation: "Kinesis Video",
        serviceFullName: "Amazon Kinesis Video Streams",
        serviceId: "Kinesis Video",
        signatureVersion: "v4",
        uid: "kinesisvideo-2017-09-30"
      },
      operations: {
        CreateSignalingChannel: {
          http: {
            requestUri: "/createSignalingChannel"
          },
          input: {
            type: "structure",
            required: [
              "ChannelName"
            ],
            members: {
              ChannelName: {},
              ChannelType: {},
              SingleMasterConfiguration: {
                shape: "S4"
              },
              Tags: {
                type: "list",
                member: {
                  shape: "S7"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelARN: {}
            }
          }
        },
        CreateStream: {
          http: {
            requestUri: "/createStream"
          },
          input: {
            type: "structure",
            required: [
              "StreamName"
            ],
            members: {
              DeviceName: {},
              StreamName: {},
              MediaType: {},
              KmsKeyId: {},
              DataRetentionInHours: {
                type: "integer"
              },
              Tags: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamARN: {}
            }
          }
        },
        DeleteSignalingChannel: {
          http: {
            requestUri: "/deleteSignalingChannel"
          },
          input: {
            type: "structure",
            required: [
              "ChannelARN"
            ],
            members: {
              ChannelARN: {},
              CurrentVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteStream: {
          http: {
            requestUri: "/deleteStream"
          },
          input: {
            type: "structure",
            required: [
              "StreamARN"
            ],
            members: {
              StreamARN: {},
              CurrentVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeSignalingChannel: {
          http: {
            requestUri: "/describeSignalingChannel"
          },
          input: {
            type: "structure",
            members: {
              ChannelName: {},
              ChannelARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelInfo: {
                shape: "Sr"
              }
            }
          }
        },
        DescribeStream: {
          http: {
            requestUri: "/describeStream"
          },
          input: {
            type: "structure",
            members: {
              StreamName: {},
              StreamARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StreamInfo: {
                shape: "Sw"
              }
            }
          }
        },
        GetDataEndpoint: {
          http: {
            requestUri: "/getDataEndpoint"
          },
          input: {
            type: "structure",
            required: [
              "APIName"
            ],
            members: {
              StreamName: {},
              StreamARN: {},
              APIName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DataEndpoint: {}
            }
          }
        },
        GetSignalingChannelEndpoint: {
          http: {
            requestUri: "/getSignalingChannelEndpoint"
          },
          input: {
            type: "structure",
            required: [
              "ChannelARN"
            ],
            members: {
              ChannelARN: {},
              SingleMasterChannelEndpointConfiguration: {
                type: "structure",
                members: {
                  Protocols: {
                    type: "list",
                    member: {}
                  },
                  Role: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceEndpointList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Protocol: {},
                    ResourceEndpoint: {}
                  }
                }
              }
            }
          }
        },
        ListSignalingChannels: {
          http: {
            requestUri: "/listSignalingChannels"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ChannelNameCondition: {
                type: "structure",
                members: {
                  ComparisonOperator: {},
                  ComparisonValue: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelInfoList: {
                type: "list",
                member: {
                  shape: "Sr"
                }
              },
              NextToken: {}
            }
          }
        },
        ListStreams: {
          http: {
            requestUri: "/listStreams"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              StreamNameCondition: {
                type: "structure",
                members: {
                  ComparisonOperator: {},
                  ComparisonValue: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamInfoList: {
                type: "list",
                member: {
                  shape: "Sw"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            requestUri: "/ListTagsForResource"
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              NextToken: {},
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Tags: {
                shape: "Si"
              }
            }
          }
        },
        ListTagsForStream: {
          http: {
            requestUri: "/listTagsForStream"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              StreamARN: {},
              StreamName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Tags: {
                shape: "Si"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/TagResource"
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                type: "list",
                member: {
                  shape: "S7"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagStream: {
          http: {
            requestUri: "/tagStream"
          },
          input: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              StreamARN: {},
              StreamName: {},
              Tags: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            requestUri: "/UntagResource"
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeyList"
            ],
            members: {
              ResourceARN: {},
              TagKeyList: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagStream: {
          http: {
            requestUri: "/untagStream"
          },
          input: {
            type: "structure",
            required: [
              "TagKeyList"
            ],
            members: {
              StreamARN: {},
              StreamName: {},
              TagKeyList: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDataRetention: {
          http: {
            requestUri: "/updateDataRetention"
          },
          input: {
            type: "structure",
            required: [
              "CurrentVersion",
              "Operation",
              "DataRetentionChangeInHours"
            ],
            members: {
              StreamName: {},
              StreamARN: {},
              CurrentVersion: {},
              Operation: {},
              DataRetentionChangeInHours: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateSignalingChannel: {
          http: {
            requestUri: "/updateSignalingChannel"
          },
          input: {
            type: "structure",
            required: [
              "ChannelARN",
              "CurrentVersion"
            ],
            members: {
              ChannelARN: {},
              CurrentVersion: {},
              SingleMasterConfiguration: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateStream: {
          http: {
            requestUri: "/updateStream"
          },
          input: {
            type: "structure",
            required: [
              "CurrentVersion"
            ],
            members: {
              StreamName: {},
              StreamARN: {},
              CurrentVersion: {},
              DeviceName: {},
              MediaType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            MessageTtlSeconds: {
              type: "integer"
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "Key",
            "Value"
          ],
          members: {
            Key: {},
            Value: {}
          }
        },
        Si: {
          type: "map",
          key: {},
          value: {}
        },
        Sr: {
          type: "structure",
          members: {
            ChannelName: {},
            ChannelARN: {},
            ChannelType: {},
            ChannelStatus: {},
            CreationTime: {
              type: "timestamp"
            },
            SingleMasterConfiguration: {
              shape: "S4"
            },
            Version: {}
          }
        },
        Sw: {
          type: "structure",
          members: {
            DeviceName: {},
            StreamName: {},
            StreamARN: {},
            MediaType: {},
            KmsKeyId: {},
            Version: {},
            Status: {},
            CreationTime: {
              type: "timestamp"
            },
            DataRetentionInHours: {
              type: "integer"
            }
          }
        },
        S1v: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kinesisvideo-2017-09-30.paginators.json
var require_kinesisvideo_2017_09_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kinesisvideo-2017-09-30.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListSignalingChannels: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ChannelInfoList"
        },
        ListStreams: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "StreamInfoList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/kinesisvideo.js
var require_kinesisvideo = __commonJS({
  "node_modules/aws-sdk/clients/kinesisvideo.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["kinesisvideo"] = {};
    AWS3.KinesisVideo = Service.defineService("kinesisvideo", ["2017-09-30"]);
    Object.defineProperty(apiLoader.services["kinesisvideo"], "2017-09-30", {
      get: function get() {
        var model = require_kinesisvideo_2017_09_30_min();
        model.paginators = require_kinesisvideo_2017_09_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.KinesisVideo;
  }
});

// node_modules/aws-sdk/apis/runtime.sagemaker-2017-05-13.min.json
var require_runtime_sagemaker_2017_05_13_min = __commonJS({
  "node_modules/aws-sdk/apis/runtime.sagemaker-2017-05-13.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-05-13",
        endpointPrefix: "runtime.sagemaker",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon SageMaker Runtime",
        serviceId: "SageMaker Runtime",
        signatureVersion: "v4",
        signingName: "sagemaker",
        uid: "runtime.sagemaker-2017-05-13"
      },
      operations: {
        InvokeEndpoint: {
          http: {
            requestUri: "/endpoints/{EndpointName}/invocations"
          },
          input: {
            type: "structure",
            required: [
              "EndpointName",
              "Body"
            ],
            members: {
              EndpointName: {
                location: "uri",
                locationName: "EndpointName"
              },
              Body: {
                shape: "S3"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              Accept: {
                location: "header",
                locationName: "Accept"
              },
              CustomAttributes: {
                shape: "S5",
                location: "header",
                locationName: "X-Amzn-SageMaker-Custom-Attributes"
              },
              TargetModel: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Target-Model"
              },
              TargetVariant: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Target-Variant"
              },
              TargetContainerHostname: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Target-Container-Hostname"
              },
              InferenceId: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Inference-Id"
              }
            },
            payload: "Body"
          },
          output: {
            type: "structure",
            required: [
              "Body"
            ],
            members: {
              Body: {
                shape: "S3"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              InvokedProductionVariant: {
                location: "header",
                locationName: "x-Amzn-Invoked-Production-Variant"
              },
              CustomAttributes: {
                shape: "S5",
                location: "header",
                locationName: "X-Amzn-SageMaker-Custom-Attributes"
              }
            },
            payload: "Body"
          }
        },
        InvokeEndpointAsync: {
          http: {
            requestUri: "/endpoints/{EndpointName}/async-invocations",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "EndpointName",
              "InputLocation"
            ],
            members: {
              EndpointName: {
                location: "uri",
                locationName: "EndpointName"
              },
              ContentType: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Content-Type"
              },
              Accept: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Accept"
              },
              CustomAttributes: {
                shape: "S5",
                location: "header",
                locationName: "X-Amzn-SageMaker-Custom-Attributes"
              },
              InferenceId: {
                location: "header",
                locationName: "X-Amzn-SageMaker-Inference-Id"
              },
              InputLocation: {
                location: "header",
                locationName: "X-Amzn-SageMaker-InputLocation"
              },
              RequestTTLSeconds: {
                location: "header",
                locationName: "X-Amzn-SageMaker-RequestTTLSeconds",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InferenceId: {},
              OutputLocation: {
                location: "header",
                locationName: "X-Amzn-SageMaker-OutputLocation"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "blob",
          sensitive: true
        },
        S5: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/runtime.sagemaker-2017-05-13.paginators.json
var require_runtime_sagemaker_2017_05_13_paginators = __commonJS({
  "node_modules/aws-sdk/apis/runtime.sagemaker-2017-05-13.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/sagemakerruntime.js
var require_sagemakerruntime = __commonJS({
  "node_modules/aws-sdk/clients/sagemakerruntime.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["sagemakerruntime"] = {};
    AWS3.SageMakerRuntime = Service.defineService("sagemakerruntime", ["2017-05-13"]);
    Object.defineProperty(apiLoader.services["sagemakerruntime"], "2017-05-13", {
      get: function get() {
        var model = require_runtime_sagemaker_2017_05_13_min();
        model.paginators = require_runtime_sagemaker_2017_05_13_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SageMakerRuntime;
  }
});

// node_modules/aws-sdk/apis/sagemaker-2017-07-24.min.json
var require_sagemaker_2017_07_24_min = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-2017-07-24.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-24",
        endpointPrefix: "api.sagemaker",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "SageMaker",
        serviceFullName: "Amazon SageMaker Service",
        serviceId: "SageMaker",
        signatureVersion: "v4",
        signingName: "sagemaker",
        targetPrefix: "SageMaker",
        uid: "sagemaker-2017-07-24"
      },
      operations: {
        AddAssociation: {
          input: {
            type: "structure",
            required: [
              "SourceArn",
              "DestinationArn"
            ],
            members: {
              SourceArn: {},
              DestinationArn: {},
              AssociationType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SourceArn: {},
              DestinationArn: {}
            }
          }
        },
        AddTags: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S7"
              }
            }
          }
        },
        AssociateTrialComponent: {
          input: {
            type: "structure",
            required: [
              "TrialComponentName",
              "TrialName"
            ],
            members: {
              TrialComponentName: {},
              TrialName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrialComponentArn: {},
              TrialArn: {}
            }
          }
        },
        CreateAction: {
          input: {
            type: "structure",
            required: [
              "ActionName",
              "Source",
              "ActionType"
            ],
            members: {
              ActionName: {},
              Source: {
                shape: "Si"
              },
              ActionType: {},
              Description: {},
              Status: {},
              Properties: {
                shape: "Sn"
              },
              MetadataProperties: {
                shape: "Sp"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ActionArn: {}
            }
          }
        },
        CreateAlgorithm: {
          input: {
            type: "structure",
            required: [
              "AlgorithmName",
              "TrainingSpecification"
            ],
            members: {
              AlgorithmName: {},
              AlgorithmDescription: {},
              TrainingSpecification: {
                shape: "Sw"
              },
              InferenceSpecification: {
                shape: "S1t"
              },
              ValidationSpecification: {
                shape: "S28"
              },
              CertifyForMarketplace: {
                type: "boolean"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AlgorithmArn"
            ],
            members: {
              AlgorithmArn: {}
            }
          }
        },
        CreateApp: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "UserProfileName",
              "AppType",
              "AppName"
            ],
            members: {
              DomainId: {},
              UserProfileName: {},
              AppType: {},
              AppName: {},
              Tags: {
                shape: "S7"
              },
              ResourceSpec: {
                shape: "S3s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppArn: {}
            }
          }
        },
        CreateAppImageConfig: {
          input: {
            type: "structure",
            required: [
              "AppImageConfigName"
            ],
            members: {
              AppImageConfigName: {},
              Tags: {
                shape: "S7"
              },
              KernelGatewayImageConfig: {
                shape: "S41"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppImageConfigArn: {}
            }
          }
        },
        CreateArtifact: {
          input: {
            type: "structure",
            required: [
              "Source",
              "ArtifactType"
            ],
            members: {
              ArtifactName: {},
              Source: {
                shape: "S4d"
              },
              ArtifactType: {},
              Properties: {
                shape: "Sn"
              },
              MetadataProperties: {
                shape: "Sp"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ArtifactArn: {}
            }
          }
        },
        CreateAutoMLJob: {
          input: {
            type: "structure",
            required: [
              "AutoMLJobName",
              "InputDataConfig",
              "OutputDataConfig",
              "RoleArn"
            ],
            members: {
              AutoMLJobName: {},
              InputDataConfig: {
                shape: "S4l"
              },
              OutputDataConfig: {
                shape: "S4r"
              },
              ProblemType: {},
              AutoMLJobObjective: {
                shape: "S4t"
              },
              AutoMLJobConfig: {
                shape: "S4v"
              },
              RoleArn: {},
              GenerateCandidateDefinitionsOnly: {
                type: "boolean"
              },
              Tags: {
                shape: "S7"
              },
              ModelDeployConfig: {
                shape: "S57"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AutoMLJobArn"
            ],
            members: {
              AutoMLJobArn: {}
            }
          }
        },
        CreateCodeRepository: {
          input: {
            type: "structure",
            required: [
              "CodeRepositoryName",
              "GitConfig"
            ],
            members: {
              CodeRepositoryName: {},
              GitConfig: {
                shape: "S5d"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CodeRepositoryArn"
            ],
            members: {
              CodeRepositoryArn: {}
            }
          }
        },
        CreateCompilationJob: {
          input: {
            type: "structure",
            required: [
              "CompilationJobName",
              "RoleArn",
              "InputConfig",
              "OutputConfig",
              "StoppingCondition"
            ],
            members: {
              CompilationJobName: {},
              RoleArn: {},
              InputConfig: {
                shape: "S5k"
              },
              OutputConfig: {
                shape: "S5o"
              },
              VpcConfig: {
                shape: "S5v"
              },
              StoppingCondition: {
                shape: "S31"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CompilationJobArn"
            ],
            members: {
              CompilationJobArn: {}
            }
          }
        },
        CreateContext: {
          input: {
            type: "structure",
            required: [
              "ContextName",
              "Source",
              "ContextType"
            ],
            members: {
              ContextName: {},
              Source: {
                shape: "S63"
              },
              ContextType: {},
              Description: {},
              Properties: {
                shape: "Sn"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContextArn: {}
            }
          }
        },
        CreateDataQualityJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName",
              "DataQualityAppSpecification",
              "DataQualityJobInput",
              "DataQualityJobOutputConfig",
              "JobResources",
              "RoleArn"
            ],
            members: {
              JobDefinitionName: {},
              DataQualityBaselineConfig: {
                shape: "S68"
              },
              DataQualityAppSpecification: {
                shape: "S6c"
              },
              DataQualityJobInput: {
                shape: "S6l"
              },
              DataQualityJobOutputConfig: {
                shape: "S6t"
              },
              JobResources: {
                shape: "S6z"
              },
              NetworkConfig: {
                shape: "S74"
              },
              RoleArn: {},
              StoppingCondition: {
                shape: "S75"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionArn"
            ],
            members: {
              JobDefinitionArn: {}
            }
          }
        },
        CreateDeviceFleet: {
          input: {
            type: "structure",
            required: [
              "DeviceFleetName",
              "OutputConfig"
            ],
            members: {
              DeviceFleetName: {},
              RoleArn: {},
              Description: {},
              OutputConfig: {
                shape: "S7b"
              },
              Tags: {
                shape: "S7"
              },
              EnableIotRoleAlias: {
                type: "boolean"
              }
            }
          }
        },
        CreateDomain: {
          input: {
            type: "structure",
            required: [
              "DomainName",
              "AuthMode",
              "DefaultUserSettings",
              "SubnetIds",
              "VpcId"
            ],
            members: {
              DomainName: {},
              AuthMode: {},
              DefaultUserSettings: {
                shape: "S7h"
              },
              SubnetIds: {
                shape: "S54"
              },
              VpcId: {},
              Tags: {
                shape: "S7"
              },
              AppNetworkAccessType: {},
              HomeEfsFileSystemKmsKeyId: {
                deprecated: true,
                deprecatedMessage: "This property is deprecated, use KmsKeyId instead."
              },
              KmsKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DomainArn: {},
              Url: {}
            }
          }
        },
        CreateEdgePackagingJob: {
          input: {
            type: "structure",
            required: [
              "EdgePackagingJobName",
              "CompilationJobName",
              "ModelName",
              "ModelVersion",
              "RoleArn",
              "OutputConfig"
            ],
            members: {
              EdgePackagingJobName: {},
              CompilationJobName: {},
              ModelName: {},
              ModelVersion: {},
              RoleArn: {},
              OutputConfig: {
                shape: "S7b"
              },
              ResourceKey: {},
              Tags: {
                shape: "S7"
              }
            }
          }
        },
        CreateEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointName",
              "EndpointConfigName"
            ],
            members: {
              EndpointName: {},
              EndpointConfigName: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {}
            }
          }
        },
        CreateEndpointConfig: {
          input: {
            type: "structure",
            required: [
              "EndpointConfigName",
              "ProductionVariants"
            ],
            members: {
              EndpointConfigName: {},
              ProductionVariants: {
                shape: "S85"
              },
              DataCaptureConfig: {
                shape: "S8e"
              },
              Tags: {
                shape: "S7"
              },
              KmsKeyId: {},
              AsyncInferenceConfig: {
                shape: "S8p"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EndpointConfigArn"
            ],
            members: {
              EndpointConfigArn: {}
            }
          }
        },
        CreateExperiment: {
          input: {
            type: "structure",
            required: [
              "ExperimentName"
            ],
            members: {
              ExperimentName: {},
              DisplayName: {},
              Description: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ExperimentArn: {}
            }
          }
        },
        CreateFeatureGroup: {
          input: {
            type: "structure",
            required: [
              "FeatureGroupName",
              "RecordIdentifierFeatureName",
              "EventTimeFeatureName",
              "FeatureDefinitions"
            ],
            members: {
              FeatureGroupName: {},
              RecordIdentifierFeatureName: {},
              EventTimeFeatureName: {},
              FeatureDefinitions: {
                shape: "S93"
              },
              OnlineStoreConfig: {
                shape: "S96"
              },
              OfflineStoreConfig: {
                shape: "S98"
              },
              RoleArn: {},
              Description: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "FeatureGroupArn"
            ],
            members: {
              FeatureGroupArn: {}
            }
          }
        },
        CreateFlowDefinition: {
          input: {
            type: "structure",
            required: [
              "FlowDefinitionName",
              "HumanLoopConfig",
              "OutputConfig",
              "RoleArn"
            ],
            members: {
              FlowDefinitionName: {},
              HumanLoopRequestSource: {
                shape: "S9j"
              },
              HumanLoopActivationConfig: {
                shape: "S9l"
              },
              HumanLoopConfig: {
                shape: "S9o"
              },
              OutputConfig: {
                shape: "Sa3"
              },
              RoleArn: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "FlowDefinitionArn"
            ],
            members: {
              FlowDefinitionArn: {}
            }
          }
        },
        CreateHumanTaskUi: {
          input: {
            type: "structure",
            required: [
              "HumanTaskUiName",
              "UiTemplate"
            ],
            members: {
              HumanTaskUiName: {},
              UiTemplate: {
                shape: "Sa8"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HumanTaskUiArn"
            ],
            members: {
              HumanTaskUiArn: {}
            }
          }
        },
        CreateHyperParameterTuningJob: {
          input: {
            type: "structure",
            required: [
              "HyperParameterTuningJobName",
              "HyperParameterTuningJobConfig"
            ],
            members: {
              HyperParameterTuningJobName: {},
              HyperParameterTuningJobConfig: {
                shape: "Sad"
              },
              TrainingJobDefinition: {
                shape: "Sau"
              },
              TrainingJobDefinitions: {
                shape: "Sb2"
              },
              WarmStartConfig: {
                shape: "Sb3"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HyperParameterTuningJobArn"
            ],
            members: {
              HyperParameterTuningJobArn: {}
            }
          }
        },
        CreateImage: {
          input: {
            type: "structure",
            required: [
              "ImageName",
              "RoleArn"
            ],
            members: {
              Description: {},
              DisplayName: {},
              ImageName: {},
              RoleArn: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImageArn: {}
            }
          }
        },
        CreateImageVersion: {
          input: {
            type: "structure",
            required: [
              "BaseImage",
              "ClientToken",
              "ImageName"
            ],
            members: {
              BaseImage: {},
              ClientToken: {
                idempotencyToken: true
              },
              ImageName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImageVersionArn: {}
            }
          }
        },
        CreateLabelingJob: {
          input: {
            type: "structure",
            required: [
              "LabelingJobName",
              "LabelAttributeName",
              "InputConfig",
              "OutputConfig",
              "RoleArn",
              "HumanTaskConfig"
            ],
            members: {
              LabelingJobName: {},
              LabelAttributeName: {},
              InputConfig: {
                shape: "Sbk"
              },
              OutputConfig: {
                shape: "Sbr"
              },
              RoleArn: {},
              LabelCategoryConfigS3Uri: {},
              StoppingConditions: {
                shape: "Sbs"
              },
              LabelingJobAlgorithmsConfig: {
                shape: "Sbv"
              },
              HumanTaskConfig: {
                shape: "Sbz"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "LabelingJobArn"
            ],
            members: {
              LabelingJobArn: {}
            }
          }
        },
        CreateModel: {
          input: {
            type: "structure",
            required: [
              "ModelName",
              "ExecutionRoleArn"
            ],
            members: {
              ModelName: {},
              PrimaryContainer: {
                shape: "Sce"
              },
              Containers: {
                shape: "Scn"
              },
              InferenceExecutionConfig: {
                shape: "Sco"
              },
              ExecutionRoleArn: {},
              Tags: {
                shape: "S7"
              },
              VpcConfig: {
                shape: "S51"
              },
              EnableNetworkIsolation: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelArn"
            ],
            members: {
              ModelArn: {}
            }
          }
        },
        CreateModelBiasJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName",
              "ModelBiasAppSpecification",
              "ModelBiasJobInput",
              "ModelBiasJobOutputConfig",
              "JobResources",
              "RoleArn"
            ],
            members: {
              JobDefinitionName: {},
              ModelBiasBaselineConfig: {
                shape: "Scs"
              },
              ModelBiasAppSpecification: {
                shape: "Sct"
              },
              ModelBiasJobInput: {
                shape: "Scu"
              },
              ModelBiasJobOutputConfig: {
                shape: "S6t"
              },
              JobResources: {
                shape: "S6z"
              },
              NetworkConfig: {
                shape: "S74"
              },
              RoleArn: {},
              StoppingCondition: {
                shape: "S75"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionArn"
            ],
            members: {
              JobDefinitionArn: {}
            }
          }
        },
        CreateModelExplainabilityJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName",
              "ModelExplainabilityAppSpecification",
              "ModelExplainabilityJobInput",
              "ModelExplainabilityJobOutputConfig",
              "JobResources",
              "RoleArn"
            ],
            members: {
              JobDefinitionName: {},
              ModelExplainabilityBaselineConfig: {
                shape: "Scy"
              },
              ModelExplainabilityAppSpecification: {
                shape: "Scz"
              },
              ModelExplainabilityJobInput: {
                shape: "Sd0"
              },
              ModelExplainabilityJobOutputConfig: {
                shape: "S6t"
              },
              JobResources: {
                shape: "S6z"
              },
              NetworkConfig: {
                shape: "S74"
              },
              RoleArn: {},
              StoppingCondition: {
                shape: "S75"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionArn"
            ],
            members: {
              JobDefinitionArn: {}
            }
          }
        },
        CreateModelPackage: {
          input: {
            type: "structure",
            members: {
              ModelPackageName: {},
              ModelPackageGroupName: {},
              ModelPackageDescription: {},
              InferenceSpecification: {
                shape: "S1t"
              },
              ValidationSpecification: {
                shape: "Sd3"
              },
              SourceAlgorithmSpecification: {
                shape: "Sd6"
              },
              CertifyForMarketplace: {
                type: "boolean"
              },
              Tags: {
                shape: "S7"
              },
              ModelApprovalStatus: {},
              MetadataProperties: {
                shape: "Sp"
              },
              ModelMetrics: {
                shape: "Sda"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelPackageArn"
            ],
            members: {
              ModelPackageArn: {}
            }
          }
        },
        CreateModelPackageGroup: {
          input: {
            type: "structure",
            required: [
              "ModelPackageGroupName"
            ],
            members: {
              ModelPackageGroupName: {},
              ModelPackageGroupDescription: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelPackageGroupArn"
            ],
            members: {
              ModelPackageGroupArn: {}
            }
          }
        },
        CreateModelQualityJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName",
              "ModelQualityAppSpecification",
              "ModelQualityJobInput",
              "ModelQualityJobOutputConfig",
              "JobResources",
              "RoleArn"
            ],
            members: {
              JobDefinitionName: {},
              ModelQualityBaselineConfig: {
                shape: "Sdn"
              },
              ModelQualityAppSpecification: {
                shape: "Sdo"
              },
              ModelQualityJobInput: {
                shape: "Sdq"
              },
              ModelQualityJobOutputConfig: {
                shape: "S6t"
              },
              JobResources: {
                shape: "S6z"
              },
              NetworkConfig: {
                shape: "S74"
              },
              RoleArn: {},
              StoppingCondition: {
                shape: "S75"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionArn"
            ],
            members: {
              JobDefinitionArn: {}
            }
          }
        },
        CreateMonitoringSchedule: {
          input: {
            type: "structure",
            required: [
              "MonitoringScheduleName",
              "MonitoringScheduleConfig"
            ],
            members: {
              MonitoringScheduleName: {},
              MonitoringScheduleConfig: {
                shape: "Sdu"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "MonitoringScheduleArn"
            ],
            members: {
              MonitoringScheduleArn: {}
            }
          }
        },
        CreateNotebookInstance: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceName",
              "InstanceType",
              "RoleArn"
            ],
            members: {
              NotebookInstanceName: {},
              InstanceType: {},
              SubnetId: {},
              SecurityGroupIds: {
                shape: "S7i"
              },
              RoleArn: {},
              KmsKeyId: {},
              Tags: {
                shape: "S7"
              },
              LifecycleConfigName: {},
              DirectInternetAccess: {},
              VolumeSizeInGB: {
                type: "integer"
              },
              AcceleratorTypes: {
                shape: "Sec"
              },
              DefaultCodeRepository: {},
              AdditionalCodeRepositories: {
                shape: "Sef"
              },
              RootAccess: {},
              PlatformIdentifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NotebookInstanceArn: {}
            }
          }
        },
        CreateNotebookInstanceLifecycleConfig: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceLifecycleConfigName"
            ],
            members: {
              NotebookInstanceLifecycleConfigName: {},
              OnCreate: {
                shape: "Sel"
              },
              OnStart: {
                shape: "Sel"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NotebookInstanceLifecycleConfigArn: {}
            }
          }
        },
        CreatePipeline: {
          input: {
            type: "structure",
            required: [
              "PipelineName",
              "PipelineDefinition",
              "ClientRequestToken",
              "RoleArn"
            ],
            members: {
              PipelineName: {},
              PipelineDisplayName: {},
              PipelineDefinition: {},
              PipelineDescription: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              RoleArn: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineArn: {}
            }
          }
        },
        CreatePresignedDomainUrl: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "UserProfileName"
            ],
            members: {
              DomainId: {},
              UserProfileName: {},
              SessionExpirationDurationInSeconds: {
                type: "integer"
              },
              ExpiresInSeconds: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AuthorizedUrl: {}
            }
          }
        },
        CreatePresignedNotebookInstanceUrl: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceName"
            ],
            members: {
              NotebookInstanceName: {},
              SessionExpirationDurationInSeconds: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AuthorizedUrl: {}
            }
          }
        },
        CreateProcessingJob: {
          input: {
            type: "structure",
            required: [
              "ProcessingJobName",
              "ProcessingResources",
              "AppSpecification",
              "RoleArn"
            ],
            members: {
              ProcessingInputs: {
                shape: "Sf6"
              },
              ProcessingOutputConfig: {
                shape: "Sft"
              },
              ProcessingJobName: {},
              ProcessingResources: {
                shape: "Sfy"
              },
              StoppingCondition: {
                shape: "Sg0"
              },
              AppSpecification: {
                shape: "Sg2"
              },
              Environment: {
                shape: "Sg4"
              },
              NetworkConfig: {
                shape: "Se2"
              },
              RoleArn: {},
              Tags: {
                shape: "S7"
              },
              ExperimentConfig: {
                shape: "Sg5"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ProcessingJobArn"
            ],
            members: {
              ProcessingJobArn: {}
            }
          }
        },
        CreateProject: {
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "ServiceCatalogProvisioningDetails"
            ],
            members: {
              ProjectName: {},
              ProjectDescription: {},
              ServiceCatalogProvisioningDetails: {
                shape: "Sga"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ProjectArn",
              "ProjectId"
            ],
            members: {
              ProjectArn: {},
              ProjectId: {}
            }
          }
        },
        CreateStudioLifecycleConfig: {
          input: {
            type: "structure",
            required: [
              "StudioLifecycleConfigName",
              "StudioLifecycleConfigContent",
              "StudioLifecycleConfigAppType"
            ],
            members: {
              StudioLifecycleConfigName: {},
              StudioLifecycleConfigContent: {},
              StudioLifecycleConfigAppType: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StudioLifecycleConfigArn: {}
            }
          }
        },
        CreateTrainingJob: {
          input: {
            type: "structure",
            required: [
              "TrainingJobName",
              "AlgorithmSpecification",
              "RoleArn",
              "OutputDataConfig",
              "ResourceConfig",
              "StoppingCondition"
            ],
            members: {
              TrainingJobName: {},
              HyperParameters: {
                shape: "S2d"
              },
              AlgorithmSpecification: {
                shape: "Sgq"
              },
              RoleArn: {},
              InputDataConfig: {
                shape: "S2f"
              },
              OutputDataConfig: {
                shape: "S2w"
              },
              ResourceConfig: {
                shape: "S2y"
              },
              VpcConfig: {
                shape: "S51"
              },
              StoppingCondition: {
                shape: "S31"
              },
              Tags: {
                shape: "S7"
              },
              EnableNetworkIsolation: {
                type: "boolean"
              },
              EnableInterContainerTrafficEncryption: {
                type: "boolean"
              },
              EnableManagedSpotTraining: {
                type: "boolean"
              },
              CheckpointConfig: {
                shape: "Saz"
              },
              DebugHookConfig: {
                shape: "Sgr"
              },
              DebugRuleConfigurations: {
                shape: "Sgz"
              },
              TensorBoardOutputConfig: {
                shape: "Sh4"
              },
              ExperimentConfig: {
                shape: "Sg5"
              },
              ProfilerConfig: {
                shape: "Sh5"
              },
              ProfilerRuleConfigurations: {
                shape: "Sh8"
              },
              Environment: {
                shape: "Sha"
              },
              RetryStrategy: {
                shape: "Sb0"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrainingJobArn"
            ],
            members: {
              TrainingJobArn: {}
            }
          }
        },
        CreateTransformJob: {
          input: {
            type: "structure",
            required: [
              "TransformJobName",
              "ModelName",
              "TransformInput",
              "TransformOutput",
              "TransformResources"
            ],
            members: {
              TransformJobName: {},
              ModelName: {},
              MaxConcurrentTransforms: {
                type: "integer"
              },
              ModelClientConfig: {
                shape: "Shh"
              },
              MaxPayloadInMB: {
                type: "integer"
              },
              BatchStrategy: {},
              Environment: {
                shape: "S38"
              },
              TransformInput: {
                shape: "S3b"
              },
              TransformOutput: {
                shape: "S3f"
              },
              TransformResources: {
                shape: "S3i"
              },
              DataProcessing: {
                shape: "Shk"
              },
              Tags: {
                shape: "S7"
              },
              ExperimentConfig: {
                shape: "Sg5"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TransformJobArn"
            ],
            members: {
              TransformJobArn: {}
            }
          }
        },
        CreateTrial: {
          input: {
            type: "structure",
            required: [
              "TrialName",
              "ExperimentName"
            ],
            members: {
              TrialName: {},
              DisplayName: {},
              ExperimentName: {},
              MetadataProperties: {
                shape: "Sp"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrialArn: {}
            }
          }
        },
        CreateTrialComponent: {
          input: {
            type: "structure",
            required: [
              "TrialComponentName"
            ],
            members: {
              TrialComponentName: {},
              DisplayName: {},
              Status: {
                shape: "Shs"
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Parameters: {
                shape: "Shw"
              },
              InputArtifacts: {
                shape: "Si0"
              },
              OutputArtifacts: {
                shape: "Si0"
              },
              MetadataProperties: {
                shape: "Sp"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrialComponentArn: {}
            }
          }
        },
        CreateUserProfile: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "UserProfileName"
            ],
            members: {
              DomainId: {},
              UserProfileName: {},
              SingleSignOnUserIdentifier: {},
              SingleSignOnUserValue: {},
              Tags: {
                shape: "S7"
              },
              UserSettings: {
                shape: "S7h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserProfileArn: {}
            }
          }
        },
        CreateWorkforce: {
          input: {
            type: "structure",
            required: [
              "WorkforceName"
            ],
            members: {
              CognitoConfig: {
                shape: "Sib"
              },
              OidcConfig: {
                shape: "Sie"
              },
              SourceIpConfig: {
                shape: "Sih"
              },
              WorkforceName: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "WorkforceArn"
            ],
            members: {
              WorkforceArn: {}
            }
          }
        },
        CreateWorkteam: {
          input: {
            type: "structure",
            required: [
              "WorkteamName",
              "MemberDefinitions",
              "Description"
            ],
            members: {
              WorkteamName: {},
              WorkforceName: {},
              MemberDefinitions: {
                shape: "Sip"
              },
              Description: {},
              NotificationConfiguration: {
                shape: "Six"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkteamArn: {}
            }
          }
        },
        DeleteAction: {
          input: {
            type: "structure",
            required: [
              "ActionName"
            ],
            members: {
              ActionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ActionArn: {}
            }
          }
        },
        DeleteAlgorithm: {
          input: {
            type: "structure",
            required: [
              "AlgorithmName"
            ],
            members: {
              AlgorithmName: {}
            }
          }
        },
        DeleteApp: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "UserProfileName",
              "AppType",
              "AppName"
            ],
            members: {
              DomainId: {},
              UserProfileName: {},
              AppType: {},
              AppName: {}
            }
          }
        },
        DeleteAppImageConfig: {
          input: {
            type: "structure",
            required: [
              "AppImageConfigName"
            ],
            members: {
              AppImageConfigName: {}
            }
          }
        },
        DeleteArtifact: {
          input: {
            type: "structure",
            members: {
              ArtifactArn: {},
              Source: {
                shape: "S4d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ArtifactArn: {}
            }
          }
        },
        DeleteAssociation: {
          input: {
            type: "structure",
            required: [
              "SourceArn",
              "DestinationArn"
            ],
            members: {
              SourceArn: {},
              DestinationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SourceArn: {},
              DestinationArn: {}
            }
          }
        },
        DeleteCodeRepository: {
          input: {
            type: "structure",
            required: [
              "CodeRepositoryName"
            ],
            members: {
              CodeRepositoryName: {}
            }
          }
        },
        DeleteContext: {
          input: {
            type: "structure",
            required: [
              "ContextName"
            ],
            members: {
              ContextName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ContextArn: {}
            }
          }
        },
        DeleteDataQualityJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName"
            ],
            members: {
              JobDefinitionName: {}
            }
          }
        },
        DeleteDeviceFleet: {
          input: {
            type: "structure",
            required: [
              "DeviceFleetName"
            ],
            members: {
              DeviceFleetName: {}
            }
          }
        },
        DeleteDomain: {
          input: {
            type: "structure",
            required: [
              "DomainId"
            ],
            members: {
              DomainId: {},
              RetentionPolicy: {
                type: "structure",
                members: {
                  HomeEfsFileSystem: {}
                }
              }
            }
          }
        },
        DeleteEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointName"
            ],
            members: {
              EndpointName: {}
            }
          }
        },
        DeleteEndpointConfig: {
          input: {
            type: "structure",
            required: [
              "EndpointConfigName"
            ],
            members: {
              EndpointConfigName: {}
            }
          }
        },
        DeleteExperiment: {
          input: {
            type: "structure",
            required: [
              "ExperimentName"
            ],
            members: {
              ExperimentName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExperimentArn: {}
            }
          }
        },
        DeleteFeatureGroup: {
          input: {
            type: "structure",
            required: [
              "FeatureGroupName"
            ],
            members: {
              FeatureGroupName: {}
            }
          }
        },
        DeleteFlowDefinition: {
          input: {
            type: "structure",
            required: [
              "FlowDefinitionName"
            ],
            members: {
              FlowDefinitionName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteHumanTaskUi: {
          input: {
            type: "structure",
            required: [
              "HumanTaskUiName"
            ],
            members: {
              HumanTaskUiName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteImage: {
          input: {
            type: "structure",
            required: [
              "ImageName"
            ],
            members: {
              ImageName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteImageVersion: {
          input: {
            type: "structure",
            required: [
              "ImageName",
              "Version"
            ],
            members: {
              ImageName: {},
              Version: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteModel: {
          input: {
            type: "structure",
            required: [
              "ModelName"
            ],
            members: {
              ModelName: {}
            }
          }
        },
        DeleteModelBiasJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName"
            ],
            members: {
              JobDefinitionName: {}
            }
          }
        },
        DeleteModelExplainabilityJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName"
            ],
            members: {
              JobDefinitionName: {}
            }
          }
        },
        DeleteModelPackage: {
          input: {
            type: "structure",
            required: [
              "ModelPackageName"
            ],
            members: {
              ModelPackageName: {}
            }
          }
        },
        DeleteModelPackageGroup: {
          input: {
            type: "structure",
            required: [
              "ModelPackageGroupName"
            ],
            members: {
              ModelPackageGroupName: {}
            }
          }
        },
        DeleteModelPackageGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "ModelPackageGroupName"
            ],
            members: {
              ModelPackageGroupName: {}
            }
          }
        },
        DeleteModelQualityJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName"
            ],
            members: {
              JobDefinitionName: {}
            }
          }
        },
        DeleteMonitoringSchedule: {
          input: {
            type: "structure",
            required: [
              "MonitoringScheduleName"
            ],
            members: {
              MonitoringScheduleName: {}
            }
          }
        },
        DeleteNotebookInstance: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceName"
            ],
            members: {
              NotebookInstanceName: {}
            }
          }
        },
        DeleteNotebookInstanceLifecycleConfig: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceLifecycleConfigName"
            ],
            members: {
              NotebookInstanceLifecycleConfigName: {}
            }
          }
        },
        DeletePipeline: {
          input: {
            type: "structure",
            required: [
              "PipelineName",
              "ClientRequestToken"
            ],
            members: {
              PipelineName: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineArn: {}
            }
          }
        },
        DeleteProject: {
          input: {
            type: "structure",
            required: [
              "ProjectName"
            ],
            members: {
              ProjectName: {}
            }
          }
        },
        DeleteStudioLifecycleConfig: {
          input: {
            type: "structure",
            required: [
              "StudioLifecycleConfigName"
            ],
            members: {
              StudioLifecycleConfigName: {}
            }
          }
        },
        DeleteTags: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTrial: {
          input: {
            type: "structure",
            required: [
              "TrialName"
            ],
            members: {
              TrialName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrialArn: {}
            }
          }
        },
        DeleteTrialComponent: {
          input: {
            type: "structure",
            required: [
              "TrialComponentName"
            ],
            members: {
              TrialComponentName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrialComponentArn: {}
            }
          }
        },
        DeleteUserProfile: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "UserProfileName"
            ],
            members: {
              DomainId: {},
              UserProfileName: {}
            }
          }
        },
        DeleteWorkforce: {
          input: {
            type: "structure",
            required: [
              "WorkforceName"
            ],
            members: {
              WorkforceName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWorkteam: {
          input: {
            type: "structure",
            required: [
              "WorkteamName"
            ],
            members: {
              WorkteamName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Success"
            ],
            members: {
              Success: {
                type: "boolean"
              }
            }
          }
        },
        DeregisterDevices: {
          input: {
            type: "structure",
            required: [
              "DeviceFleetName",
              "DeviceNames"
            ],
            members: {
              DeviceFleetName: {},
              DeviceNames: {
                type: "list",
                member: {}
              }
            }
          }
        },
        DescribeAction: {
          input: {
            type: "structure",
            required: [
              "ActionName"
            ],
            members: {
              ActionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ActionName: {},
              ActionArn: {},
              Source: {
                shape: "Si"
              },
              ActionType: {},
              Description: {},
              Status: {},
              Properties: {
                shape: "Sn"
              },
              CreationTime: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "Skq"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedBy: {
                shape: "Skq"
              },
              MetadataProperties: {
                shape: "Sp"
              }
            }
          }
        },
        DescribeAlgorithm: {
          input: {
            type: "structure",
            required: [
              "AlgorithmName"
            ],
            members: {
              AlgorithmName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AlgorithmName",
              "AlgorithmArn",
              "CreationTime",
              "TrainingSpecification",
              "AlgorithmStatus",
              "AlgorithmStatusDetails"
            ],
            members: {
              AlgorithmName: {},
              AlgorithmArn: {},
              AlgorithmDescription: {},
              CreationTime: {
                type: "timestamp"
              },
              TrainingSpecification: {
                shape: "Sw"
              },
              InferenceSpecification: {
                shape: "S1t"
              },
              ValidationSpecification: {
                shape: "S28"
              },
              AlgorithmStatus: {},
              AlgorithmStatusDetails: {
                type: "structure",
                members: {
                  ValidationStatuses: {
                    shape: "Skw"
                  },
                  ImageScanStatuses: {
                    shape: "Skw"
                  }
                }
              },
              ProductId: {},
              CertifyForMarketplace: {
                type: "boolean"
              }
            }
          }
        },
        DescribeApp: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "UserProfileName",
              "AppType",
              "AppName"
            ],
            members: {
              DomainId: {},
              UserProfileName: {},
              AppType: {},
              AppName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AppArn: {},
              AppType: {},
              AppName: {},
              DomainId: {},
              UserProfileName: {},
              Status: {},
              LastHealthCheckTimestamp: {
                type: "timestamp"
              },
              LastUserActivityTimestamp: {
                type: "timestamp"
              },
              CreationTime: {
                type: "timestamp"
              },
              FailureReason: {},
              ResourceSpec: {
                shape: "S3s"
              }
            }
          }
        },
        DescribeAppImageConfig: {
          input: {
            type: "structure",
            required: [
              "AppImageConfigName"
            ],
            members: {
              AppImageConfigName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AppImageConfigArn: {},
              AppImageConfigName: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              KernelGatewayImageConfig: {
                shape: "S41"
              }
            }
          }
        },
        DescribeArtifact: {
          input: {
            type: "structure",
            required: [
              "ArtifactArn"
            ],
            members: {
              ArtifactArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ArtifactName: {},
              ArtifactArn: {},
              Source: {
                shape: "S4d"
              },
              ArtifactType: {},
              Properties: {
                shape: "Sn"
              },
              CreationTime: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "Skq"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedBy: {
                shape: "Skq"
              },
              MetadataProperties: {
                shape: "Sp"
              }
            }
          }
        },
        DescribeAutoMLJob: {
          input: {
            type: "structure",
            required: [
              "AutoMLJobName"
            ],
            members: {
              AutoMLJobName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AutoMLJobName",
              "AutoMLJobArn",
              "InputDataConfig",
              "OutputDataConfig",
              "RoleArn",
              "CreationTime",
              "LastModifiedTime",
              "AutoMLJobStatus",
              "AutoMLJobSecondaryStatus"
            ],
            members: {
              AutoMLJobName: {},
              AutoMLJobArn: {},
              InputDataConfig: {
                shape: "S4l"
              },
              OutputDataConfig: {
                shape: "S4r"
              },
              RoleArn: {},
              AutoMLJobObjective: {
                shape: "S4t"
              },
              ProblemType: {},
              AutoMLJobConfig: {
                shape: "S4v"
              },
              CreationTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              FailureReason: {},
              PartialFailureReasons: {
                shape: "Sla"
              },
              BestCandidate: {
                shape: "Slc"
              },
              AutoMLJobStatus: {},
              AutoMLJobSecondaryStatus: {},
              GenerateCandidateDefinitionsOnly: {
                type: "boolean"
              },
              AutoMLJobArtifacts: {
                type: "structure",
                members: {
                  CandidateDefinitionNotebookLocation: {},
                  DataExplorationNotebookLocation: {}
                }
              },
              ResolvedAttributes: {
                type: "structure",
                members: {
                  AutoMLJobObjective: {
                    shape: "S4t"
                  },
                  ProblemType: {},
                  CompletionCriteria: {
                    shape: "S4w"
                  }
                }
              },
              ModelDeployConfig: {
                shape: "S57"
              },
              ModelDeployResult: {
                type: "structure",
                members: {
                  EndpointName: {}
                }
              }
            }
          }
        },
        DescribeCodeRepository: {
          input: {
            type: "structure",
            required: [
              "CodeRepositoryName"
            ],
            members: {
              CodeRepositoryName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "CodeRepositoryName",
              "CodeRepositoryArn",
              "CreationTime",
              "LastModifiedTime"
            ],
            members: {
              CodeRepositoryName: {},
              CodeRepositoryArn: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              GitConfig: {
                shape: "S5d"
              }
            }
          }
        },
        DescribeCompilationJob: {
          input: {
            type: "structure",
            required: [
              "CompilationJobName"
            ],
            members: {
              CompilationJobName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "CompilationJobName",
              "CompilationJobArn",
              "CompilationJobStatus",
              "StoppingCondition",
              "CreationTime",
              "LastModifiedTime",
              "FailureReason",
              "ModelArtifacts",
              "RoleArn",
              "InputConfig",
              "OutputConfig"
            ],
            members: {
              CompilationJobName: {},
              CompilationJobArn: {},
              CompilationJobStatus: {},
              CompilationStartTime: {
                type: "timestamp"
              },
              CompilationEndTime: {
                type: "timestamp"
              },
              StoppingCondition: {
                shape: "S31"
              },
              InferenceImage: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              FailureReason: {},
              ModelArtifacts: {
                shape: "Smb"
              },
              ModelDigests: {
                type: "structure",
                members: {
                  ArtifactDigest: {}
                }
              },
              RoleArn: {},
              InputConfig: {
                shape: "S5k"
              },
              OutputConfig: {
                shape: "S5o"
              },
              VpcConfig: {
                shape: "S5v"
              }
            }
          }
        },
        DescribeContext: {
          input: {
            type: "structure",
            required: [
              "ContextName"
            ],
            members: {
              ContextName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ContextName: {},
              ContextArn: {},
              Source: {
                shape: "S63"
              },
              ContextType: {},
              Description: {},
              Properties: {
                shape: "Sn"
              },
              CreationTime: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "Skq"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedBy: {
                shape: "Skq"
              }
            }
          }
        },
        DescribeDataQualityJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName"
            ],
            members: {
              JobDefinitionName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionArn",
              "JobDefinitionName",
              "CreationTime",
              "DataQualityAppSpecification",
              "DataQualityJobInput",
              "DataQualityJobOutputConfig",
              "JobResources",
              "RoleArn"
            ],
            members: {
              JobDefinitionArn: {},
              JobDefinitionName: {},
              CreationTime: {
                type: "timestamp"
              },
              DataQualityBaselineConfig: {
                shape: "S68"
              },
              DataQualityAppSpecification: {
                shape: "S6c"
              },
              DataQualityJobInput: {
                shape: "S6l"
              },
              DataQualityJobOutputConfig: {
                shape: "S6t"
              },
              JobResources: {
                shape: "S6z"
              },
              NetworkConfig: {
                shape: "S74"
              },
              RoleArn: {},
              StoppingCondition: {
                shape: "S75"
              }
            }
          }
        },
        DescribeDevice: {
          input: {
            type: "structure",
            required: [
              "DeviceName",
              "DeviceFleetName"
            ],
            members: {
              NextToken: {},
              DeviceName: {},
              DeviceFleetName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DeviceName",
              "DeviceFleetName",
              "RegistrationTime"
            ],
            members: {
              DeviceArn: {},
              DeviceName: {},
              Description: {},
              DeviceFleetName: {},
              IotThingName: {},
              RegistrationTime: {
                type: "timestamp"
              },
              LatestHeartbeat: {
                type: "timestamp"
              },
              Models: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ModelName",
                    "ModelVersion"
                  ],
                  members: {
                    ModelName: {},
                    ModelVersion: {},
                    LatestSampleTime: {
                      type: "timestamp"
                    },
                    LatestInference: {
                      type: "timestamp"
                    }
                  }
                }
              },
              MaxModels: {
                type: "integer"
              },
              NextToken: {}
            }
          }
        },
        DescribeDeviceFleet: {
          input: {
            type: "structure",
            required: [
              "DeviceFleetName"
            ],
            members: {
              DeviceFleetName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DeviceFleetName",
              "DeviceFleetArn",
              "OutputConfig",
              "CreationTime",
              "LastModifiedTime"
            ],
            members: {
              DeviceFleetName: {},
              DeviceFleetArn: {},
              OutputConfig: {
                shape: "S7b"
              },
              Description: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              RoleArn: {},
              IotRoleAlias: {}
            }
          }
        },
        DescribeDomain: {
          input: {
            type: "structure",
            required: [
              "DomainId"
            ],
            members: {
              DomainId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DomainArn: {},
              DomainId: {},
              DomainName: {},
              HomeEfsFileSystemId: {},
              SingleSignOnManagedApplicationInstanceId: {},
              Status: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              FailureReason: {},
              AuthMode: {},
              DefaultUserSettings: {
                shape: "S7h"
              },
              AppNetworkAccessType: {},
              HomeEfsFileSystemKmsKeyId: {
                deprecated: true,
                deprecatedMessage: "This property is deprecated, use KmsKeyId instead."
              },
              SubnetIds: {
                shape: "S54"
              },
              Url: {},
              VpcId: {},
              KmsKeyId: {}
            }
          }
        },
        DescribeEdgePackagingJob: {
          input: {
            type: "structure",
            required: [
              "EdgePackagingJobName"
            ],
            members: {
              EdgePackagingJobName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "EdgePackagingJobArn",
              "EdgePackagingJobName",
              "EdgePackagingJobStatus"
            ],
            members: {
              EdgePackagingJobArn: {},
              EdgePackagingJobName: {},
              CompilationJobName: {},
              ModelName: {},
              ModelVersion: {},
              RoleArn: {},
              OutputConfig: {
                shape: "S7b"
              },
              ResourceKey: {},
              EdgePackagingJobStatus: {},
              EdgePackagingJobStatusMessage: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              ModelArtifact: {},
              ModelSignature: {},
              PresetDeploymentOutput: {
                type: "structure",
                required: [
                  "Type"
                ],
                members: {
                  Type: {},
                  Artifact: {},
                  Status: {},
                  StatusMessage: {}
                }
              }
            }
          }
        },
        DescribeEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointName"
            ],
            members: {
              EndpointName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "EndpointName",
              "EndpointArn",
              "EndpointConfigName",
              "EndpointStatus",
              "CreationTime",
              "LastModifiedTime"
            ],
            members: {
              EndpointName: {},
              EndpointArn: {},
              EndpointConfigName: {},
              ProductionVariants: {
                shape: "Sn8"
              },
              DataCaptureConfig: {
                shape: "Snd"
              },
              EndpointStatus: {},
              FailureReason: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastDeploymentConfig: {
                shape: "Sng"
              },
              AsyncInferenceConfig: {
                shape: "S8p"
              }
            }
          }
        },
        DescribeEndpointConfig: {
          input: {
            type: "structure",
            required: [
              "EndpointConfigName"
            ],
            members: {
              EndpointConfigName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "EndpointConfigName",
              "EndpointConfigArn",
              "ProductionVariants",
              "CreationTime"
            ],
            members: {
              EndpointConfigName: {},
              EndpointConfigArn: {},
              ProductionVariants: {
                shape: "S85"
              },
              DataCaptureConfig: {
                shape: "S8e"
              },
              KmsKeyId: {},
              CreationTime: {
                type: "timestamp"
              },
              AsyncInferenceConfig: {
                shape: "S8p"
              }
            }
          }
        },
        DescribeExperiment: {
          input: {
            type: "structure",
            required: [
              "ExperimentName"
            ],
            members: {
              ExperimentName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExperimentName: {},
              ExperimentArn: {},
              DisplayName: {},
              Source: {
                shape: "Sny"
              },
              Description: {},
              CreationTime: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "Skq"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedBy: {
                shape: "Skq"
              }
            }
          }
        },
        DescribeFeatureGroup: {
          input: {
            type: "structure",
            required: [
              "FeatureGroupName"
            ],
            members: {
              FeatureGroupName: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "FeatureGroupArn",
              "FeatureGroupName",
              "RecordIdentifierFeatureName",
              "EventTimeFeatureName",
              "FeatureDefinitions",
              "CreationTime",
              "NextToken"
            ],
            members: {
              FeatureGroupArn: {},
              FeatureGroupName: {},
              RecordIdentifierFeatureName: {},
              EventTimeFeatureName: {},
              FeatureDefinitions: {
                shape: "S93"
              },
              CreationTime: {
                type: "timestamp"
              },
              OnlineStoreConfig: {
                shape: "S96"
              },
              OfflineStoreConfig: {
                shape: "S98"
              },
              RoleArn: {},
              FeatureGroupStatus: {},
              OfflineStoreStatus: {
                shape: "So4"
              },
              FailureReason: {},
              Description: {},
              NextToken: {}
            }
          }
        },
        DescribeFlowDefinition: {
          input: {
            type: "structure",
            required: [
              "FlowDefinitionName"
            ],
            members: {
              FlowDefinitionName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "FlowDefinitionArn",
              "FlowDefinitionName",
              "FlowDefinitionStatus",
              "CreationTime",
              "HumanLoopConfig",
              "OutputConfig",
              "RoleArn"
            ],
            members: {
              FlowDefinitionArn: {},
              FlowDefinitionName: {},
              FlowDefinitionStatus: {},
              CreationTime: {
                type: "timestamp"
              },
              HumanLoopRequestSource: {
                shape: "S9j"
              },
              HumanLoopActivationConfig: {
                shape: "S9l"
              },
              HumanLoopConfig: {
                shape: "S9o"
              },
              OutputConfig: {
                shape: "Sa3"
              },
              RoleArn: {},
              FailureReason: {}
            }
          }
        },
        DescribeHumanTaskUi: {
          input: {
            type: "structure",
            required: [
              "HumanTaskUiName"
            ],
            members: {
              HumanTaskUiName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "HumanTaskUiArn",
              "HumanTaskUiName",
              "CreationTime",
              "UiTemplate"
            ],
            members: {
              HumanTaskUiArn: {},
              HumanTaskUiName: {},
              HumanTaskUiStatus: {},
              CreationTime: {
                type: "timestamp"
              },
              UiTemplate: {
                type: "structure",
                members: {
                  Url: {},
                  ContentSha256: {}
                }
              }
            }
          }
        },
        DescribeHyperParameterTuningJob: {
          input: {
            type: "structure",
            required: [
              "HyperParameterTuningJobName"
            ],
            members: {
              HyperParameterTuningJobName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "HyperParameterTuningJobName",
              "HyperParameterTuningJobArn",
              "HyperParameterTuningJobConfig",
              "HyperParameterTuningJobStatus",
              "CreationTime",
              "TrainingJobStatusCounters",
              "ObjectiveStatusCounters"
            ],
            members: {
              HyperParameterTuningJobName: {},
              HyperParameterTuningJobArn: {},
              HyperParameterTuningJobConfig: {
                shape: "Sad"
              },
              TrainingJobDefinition: {
                shape: "Sau"
              },
              TrainingJobDefinitions: {
                shape: "Sb2"
              },
              HyperParameterTuningJobStatus: {},
              CreationTime: {
                type: "timestamp"
              },
              HyperParameterTuningEndTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              TrainingJobStatusCounters: {
                shape: "Soj"
              },
              ObjectiveStatusCounters: {
                shape: "Sol"
              },
              BestTrainingJob: {
                shape: "Son"
              },
              OverallBestTrainingJob: {
                shape: "Son"
              },
              WarmStartConfig: {
                shape: "Sb3"
              },
              FailureReason: {}
            }
          }
        },
        DescribeImage: {
          input: {
            type: "structure",
            required: [
              "ImageName"
            ],
            members: {
              ImageName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CreationTime: {
                type: "timestamp"
              },
              Description: {},
              DisplayName: {},
              FailureReason: {},
              ImageArn: {},
              ImageName: {},
              ImageStatus: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              RoleArn: {}
            }
          }
        },
        DescribeImageVersion: {
          input: {
            type: "structure",
            required: [
              "ImageName"
            ],
            members: {
              ImageName: {},
              Version: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BaseImage: {},
              ContainerImage: {},
              CreationTime: {
                type: "timestamp"
              },
              FailureReason: {},
              ImageArn: {},
              ImageVersionArn: {},
              ImageVersionStatus: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              Version: {
                type: "integer"
              }
            }
          }
        },
        DescribeLabelingJob: {
          input: {
            type: "structure",
            required: [
              "LabelingJobName"
            ],
            members: {
              LabelingJobName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "LabelingJobStatus",
              "LabelCounters",
              "CreationTime",
              "LastModifiedTime",
              "JobReferenceCode",
              "LabelingJobName",
              "LabelingJobArn",
              "InputConfig",
              "OutputConfig",
              "RoleArn",
              "HumanTaskConfig"
            ],
            members: {
              LabelingJobStatus: {},
              LabelCounters: {
                shape: "Sp0"
              },
              FailureReason: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              JobReferenceCode: {},
              LabelingJobName: {},
              LabelingJobArn: {},
              LabelAttributeName: {},
              InputConfig: {
                shape: "Sbk"
              },
              OutputConfig: {
                shape: "Sbr"
              },
              RoleArn: {},
              LabelCategoryConfigS3Uri: {},
              StoppingConditions: {
                shape: "Sbs"
              },
              LabelingJobAlgorithmsConfig: {
                shape: "Sbv"
              },
              HumanTaskConfig: {
                shape: "Sbz"
              },
              Tags: {
                shape: "S7"
              },
              LabelingJobOutput: {
                shape: "Sp3"
              }
            }
          }
        },
        DescribeModel: {
          input: {
            type: "structure",
            required: [
              "ModelName"
            ],
            members: {
              ModelName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelName",
              "ExecutionRoleArn",
              "CreationTime",
              "ModelArn"
            ],
            members: {
              ModelName: {},
              PrimaryContainer: {
                shape: "Sce"
              },
              Containers: {
                shape: "Scn"
              },
              InferenceExecutionConfig: {
                shape: "Sco"
              },
              ExecutionRoleArn: {},
              VpcConfig: {
                shape: "S51"
              },
              CreationTime: {
                type: "timestamp"
              },
              ModelArn: {},
              EnableNetworkIsolation: {
                type: "boolean"
              }
            }
          }
        },
        DescribeModelBiasJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName"
            ],
            members: {
              JobDefinitionName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionArn",
              "JobDefinitionName",
              "CreationTime",
              "ModelBiasAppSpecification",
              "ModelBiasJobInput",
              "ModelBiasJobOutputConfig",
              "JobResources",
              "RoleArn"
            ],
            members: {
              JobDefinitionArn: {},
              JobDefinitionName: {},
              CreationTime: {
                type: "timestamp"
              },
              ModelBiasBaselineConfig: {
                shape: "Scs"
              },
              ModelBiasAppSpecification: {
                shape: "Sct"
              },
              ModelBiasJobInput: {
                shape: "Scu"
              },
              ModelBiasJobOutputConfig: {
                shape: "S6t"
              },
              JobResources: {
                shape: "S6z"
              },
              NetworkConfig: {
                shape: "S74"
              },
              RoleArn: {},
              StoppingCondition: {
                shape: "S75"
              }
            }
          }
        },
        DescribeModelExplainabilityJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName"
            ],
            members: {
              JobDefinitionName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionArn",
              "JobDefinitionName",
              "CreationTime",
              "ModelExplainabilityAppSpecification",
              "ModelExplainabilityJobInput",
              "ModelExplainabilityJobOutputConfig",
              "JobResources",
              "RoleArn"
            ],
            members: {
              JobDefinitionArn: {},
              JobDefinitionName: {},
              CreationTime: {
                type: "timestamp"
              },
              ModelExplainabilityBaselineConfig: {
                shape: "Scy"
              },
              ModelExplainabilityAppSpecification: {
                shape: "Scz"
              },
              ModelExplainabilityJobInput: {
                shape: "Sd0"
              },
              ModelExplainabilityJobOutputConfig: {
                shape: "S6t"
              },
              JobResources: {
                shape: "S6z"
              },
              NetworkConfig: {
                shape: "S74"
              },
              RoleArn: {},
              StoppingCondition: {
                shape: "S75"
              }
            }
          }
        },
        DescribeModelPackage: {
          input: {
            type: "structure",
            required: [
              "ModelPackageName"
            ],
            members: {
              ModelPackageName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelPackageName",
              "ModelPackageArn",
              "CreationTime",
              "ModelPackageStatus",
              "ModelPackageStatusDetails"
            ],
            members: {
              ModelPackageName: {},
              ModelPackageGroupName: {},
              ModelPackageVersion: {
                type: "integer"
              },
              ModelPackageArn: {},
              ModelPackageDescription: {},
              CreationTime: {
                type: "timestamp"
              },
              InferenceSpecification: {
                shape: "S1t"
              },
              SourceAlgorithmSpecification: {
                shape: "Sd6"
              },
              ValidationSpecification: {
                shape: "Sd3"
              },
              ModelPackageStatus: {},
              ModelPackageStatusDetails: {
                shape: "Spe"
              },
              CertifyForMarketplace: {
                type: "boolean"
              },
              ModelApprovalStatus: {},
              CreatedBy: {
                shape: "Skq"
              },
              MetadataProperties: {
                shape: "Sp"
              },
              ModelMetrics: {
                shape: "Sda"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedBy: {
                shape: "Skq"
              },
              ApprovalDescription: {}
            }
          }
        },
        DescribeModelPackageGroup: {
          input: {
            type: "structure",
            required: [
              "ModelPackageGroupName"
            ],
            members: {
              ModelPackageGroupName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelPackageGroupName",
              "ModelPackageGroupArn",
              "CreationTime",
              "CreatedBy",
              "ModelPackageGroupStatus"
            ],
            members: {
              ModelPackageGroupName: {},
              ModelPackageGroupArn: {},
              ModelPackageGroupDescription: {},
              CreationTime: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "Skq"
              },
              ModelPackageGroupStatus: {}
            }
          }
        },
        DescribeModelQualityJobDefinition: {
          input: {
            type: "structure",
            required: [
              "JobDefinitionName"
            ],
            members: {
              JobDefinitionName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionArn",
              "JobDefinitionName",
              "CreationTime",
              "ModelQualityAppSpecification",
              "ModelQualityJobInput",
              "ModelQualityJobOutputConfig",
              "JobResources",
              "RoleArn"
            ],
            members: {
              JobDefinitionArn: {},
              JobDefinitionName: {},
              CreationTime: {
                type: "timestamp"
              },
              ModelQualityBaselineConfig: {
                shape: "Sdn"
              },
              ModelQualityAppSpecification: {
                shape: "Sdo"
              },
              ModelQualityJobInput: {
                shape: "Sdq"
              },
              ModelQualityJobOutputConfig: {
                shape: "S6t"
              },
              JobResources: {
                shape: "S6z"
              },
              NetworkConfig: {
                shape: "S74"
              },
              RoleArn: {},
              StoppingCondition: {
                shape: "S75"
              }
            }
          }
        },
        DescribeMonitoringSchedule: {
          input: {
            type: "structure",
            required: [
              "MonitoringScheduleName"
            ],
            members: {
              MonitoringScheduleName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "MonitoringScheduleArn",
              "MonitoringScheduleName",
              "MonitoringScheduleStatus",
              "CreationTime",
              "LastModifiedTime",
              "MonitoringScheduleConfig"
            ],
            members: {
              MonitoringScheduleArn: {},
              MonitoringScheduleName: {},
              MonitoringScheduleStatus: {},
              MonitoringType: {},
              FailureReason: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              MonitoringScheduleConfig: {
                shape: "Sdu"
              },
              EndpointName: {},
              LastMonitoringExecutionSummary: {
                shape: "Spr"
              }
            }
          }
        },
        DescribeNotebookInstance: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceName"
            ],
            members: {
              NotebookInstanceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NotebookInstanceArn: {},
              NotebookInstanceName: {},
              NotebookInstanceStatus: {},
              FailureReason: {},
              Url: {},
              InstanceType: {},
              SubnetId: {},
              SecurityGroups: {
                shape: "S7i"
              },
              RoleArn: {},
              KmsKeyId: {},
              NetworkInterfaceId: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              CreationTime: {
                type: "timestamp"
              },
              NotebookInstanceLifecycleConfigName: {},
              DirectInternetAccess: {},
              VolumeSizeInGB: {
                type: "integer"
              },
              AcceleratorTypes: {
                shape: "Sec"
              },
              DefaultCodeRepository: {},
              AdditionalCodeRepositories: {
                shape: "Sef"
              },
              RootAccess: {},
              PlatformIdentifier: {}
            }
          }
        },
        DescribeNotebookInstanceLifecycleConfig: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceLifecycleConfigName"
            ],
            members: {
              NotebookInstanceLifecycleConfigName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NotebookInstanceLifecycleConfigArn: {},
              NotebookInstanceLifecycleConfigName: {},
              OnCreate: {
                shape: "Sel"
              },
              OnStart: {
                shape: "Sel"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribePipeline: {
          input: {
            type: "structure",
            required: [
              "PipelineName"
            ],
            members: {
              PipelineName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineArn: {},
              PipelineName: {},
              PipelineDisplayName: {},
              PipelineDefinition: {},
              PipelineDescription: {},
              RoleArn: {},
              PipelineStatus: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastRunTime: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "Skq"
              },
              LastModifiedBy: {
                shape: "Skq"
              }
            }
          }
        },
        DescribePipelineDefinitionForExecution: {
          input: {
            type: "structure",
            required: [
              "PipelineExecutionArn"
            ],
            members: {
              PipelineExecutionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineDefinition: {},
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribePipelineExecution: {
          input: {
            type: "structure",
            required: [
              "PipelineExecutionArn"
            ],
            members: {
              PipelineExecutionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineArn: {},
              PipelineExecutionArn: {},
              PipelineExecutionDisplayName: {},
              PipelineExecutionStatus: {},
              PipelineExecutionDescription: {},
              PipelineExperimentConfig: {
                shape: "Sqa"
              },
              FailureReason: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "Skq"
              },
              LastModifiedBy: {
                shape: "Skq"
              }
            }
          }
        },
        DescribeProcessingJob: {
          input: {
            type: "structure",
            required: [
              "ProcessingJobName"
            ],
            members: {
              ProcessingJobName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ProcessingJobName",
              "ProcessingResources",
              "AppSpecification",
              "ProcessingJobArn",
              "ProcessingJobStatus",
              "CreationTime"
            ],
            members: {
              ProcessingInputs: {
                shape: "Sf6"
              },
              ProcessingOutputConfig: {
                shape: "Sft"
              },
              ProcessingJobName: {},
              ProcessingResources: {
                shape: "Sfy"
              },
              StoppingCondition: {
                shape: "Sg0"
              },
              AppSpecification: {
                shape: "Sg2"
              },
              Environment: {
                shape: "Sg4"
              },
              NetworkConfig: {
                shape: "Se2"
              },
              RoleArn: {},
              ExperimentConfig: {
                shape: "Sg5"
              },
              ProcessingJobArn: {},
              ProcessingJobStatus: {},
              ExitMessage: {},
              FailureReason: {},
              ProcessingEndTime: {
                type: "timestamp"
              },
              ProcessingStartTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              CreationTime: {
                type: "timestamp"
              },
              MonitoringScheduleArn: {},
              AutoMLJobArn: {},
              TrainingJobArn: {}
            }
          }
        },
        DescribeProject: {
          input: {
            type: "structure",
            required: [
              "ProjectName"
            ],
            members: {
              ProjectName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ProjectArn",
              "ProjectName",
              "ProjectId",
              "ServiceCatalogProvisioningDetails",
              "ProjectStatus",
              "CreationTime"
            ],
            members: {
              ProjectArn: {},
              ProjectName: {},
              ProjectId: {},
              ProjectDescription: {},
              ServiceCatalogProvisioningDetails: {
                shape: "Sga"
              },
              ServiceCatalogProvisionedProductDetails: {
                shape: "Sqi"
              },
              ProjectStatus: {},
              CreatedBy: {
                shape: "Skq"
              },
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeStudioLifecycleConfig: {
          input: {
            type: "structure",
            required: [
              "StudioLifecycleConfigName"
            ],
            members: {
              StudioLifecycleConfigName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StudioLifecycleConfigArn: {},
              StudioLifecycleConfigName: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              StudioLifecycleConfigContent: {},
              StudioLifecycleConfigAppType: {}
            }
          }
        },
        DescribeSubscribedWorkteam: {
          input: {
            type: "structure",
            required: [
              "WorkteamArn"
            ],
            members: {
              WorkteamArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "SubscribedWorkteam"
            ],
            members: {
              SubscribedWorkteam: {
                shape: "Sqp"
              }
            }
          }
        },
        DescribeTrainingJob: {
          input: {
            type: "structure",
            required: [
              "TrainingJobName"
            ],
            members: {
              TrainingJobName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TrainingJobName",
              "TrainingJobArn",
              "ModelArtifacts",
              "TrainingJobStatus",
              "SecondaryStatus",
              "AlgorithmSpecification",
              "ResourceConfig",
              "StoppingCondition",
              "CreationTime"
            ],
            members: {
              TrainingJobName: {},
              TrainingJobArn: {},
              TuningJobArn: {},
              LabelingJobArn: {},
              AutoMLJobArn: {},
              ModelArtifacts: {
                shape: "Smb"
              },
              TrainingJobStatus: {},
              SecondaryStatus: {},
              FailureReason: {},
              HyperParameters: {
                shape: "S2d"
              },
              AlgorithmSpecification: {
                shape: "Sgq"
              },
              RoleArn: {},
              InputDataConfig: {
                shape: "S2f"
              },
              OutputDataConfig: {
                shape: "S2w"
              },
              ResourceConfig: {
                shape: "S2y"
              },
              VpcConfig: {
                shape: "S51"
              },
              StoppingCondition: {
                shape: "S31"
              },
              CreationTime: {
                type: "timestamp"
              },
              TrainingStartTime: {
                type: "timestamp"
              },
              TrainingEndTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              SecondaryStatusTransitions: {
                shape: "Sqt"
              },
              FinalMetricDataList: {
                shape: "Sqw"
              },
              EnableNetworkIsolation: {
                type: "boolean"
              },
              EnableInterContainerTrafficEncryption: {
                type: "boolean"
              },
              EnableManagedSpotTraining: {
                type: "boolean"
              },
              CheckpointConfig: {
                shape: "Saz"
              },
              TrainingTimeInSeconds: {
                type: "integer"
              },
              BillableTimeInSeconds: {
                type: "integer"
              },
              DebugHookConfig: {
                shape: "Sgr"
              },
              ExperimentConfig: {
                shape: "Sg5"
              },
              DebugRuleConfigurations: {
                shape: "Sgz"
              },
              TensorBoardOutputConfig: {
                shape: "Sh4"
              },
              DebugRuleEvaluationStatuses: {
                shape: "Sr0"
              },
              ProfilerConfig: {
                shape: "Sh5"
              },
              ProfilerRuleConfigurations: {
                shape: "Sh8"
              },
              ProfilerRuleEvaluationStatuses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RuleConfigurationName: {},
                    RuleEvaluationJobArn: {},
                    RuleEvaluationStatus: {},
                    StatusDetails: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              ProfilingStatus: {},
              RetryStrategy: {
                shape: "Sb0"
              },
              Environment: {
                shape: "Sha"
              }
            }
          }
        },
        DescribeTransformJob: {
          input: {
            type: "structure",
            required: [
              "TransformJobName"
            ],
            members: {
              TransformJobName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TransformJobName",
              "TransformJobArn",
              "TransformJobStatus",
              "ModelName",
              "TransformInput",
              "TransformResources",
              "CreationTime"
            ],
            members: {
              TransformJobName: {},
              TransformJobArn: {},
              TransformJobStatus: {},
              FailureReason: {},
              ModelName: {},
              MaxConcurrentTransforms: {
                type: "integer"
              },
              ModelClientConfig: {
                shape: "Shh"
              },
              MaxPayloadInMB: {
                type: "integer"
              },
              BatchStrategy: {},
              Environment: {
                shape: "S38"
              },
              TransformInput: {
                shape: "S3b"
              },
              TransformOutput: {
                shape: "S3f"
              },
              TransformResources: {
                shape: "S3i"
              },
              CreationTime: {
                type: "timestamp"
              },
              TransformStartTime: {
                type: "timestamp"
              },
              TransformEndTime: {
                type: "timestamp"
              },
              LabelingJobArn: {},
              AutoMLJobArn: {},
              DataProcessing: {
                shape: "Shk"
              },
              ExperimentConfig: {
                shape: "Sg5"
              }
            }
          }
        },
        DescribeTrial: {
          input: {
            type: "structure",
            required: [
              "TrialName"
            ],
            members: {
              TrialName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrialName: {},
              TrialArn: {},
              DisplayName: {},
              ExperimentName: {},
              Source: {
                shape: "Src"
              },
              CreationTime: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "Skq"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedBy: {
                shape: "Skq"
              },
              MetadataProperties: {
                shape: "Sp"
              }
            }
          }
        },
        DescribeTrialComponent: {
          input: {
            type: "structure",
            required: [
              "TrialComponentName"
            ],
            members: {
              TrialComponentName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrialComponentName: {},
              TrialComponentArn: {},
              DisplayName: {},
              Source: {
                shape: "Srg"
              },
              Status: {
                shape: "Shs"
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              CreationTime: {
                type: "timestamp"
              },
              CreatedBy: {
                shape: "Skq"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastModifiedBy: {
                shape: "Skq"
              },
              Parameters: {
                shape: "Shw"
              },
              InputArtifacts: {
                shape: "Si0"
              },
              OutputArtifacts: {
                shape: "Si0"
              },
              MetadataProperties: {
                shape: "Sp"
              },
              Metrics: {
                shape: "Sri"
              }
            }
          }
        },
        DescribeUserProfile: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "UserProfileName"
            ],
            members: {
              DomainId: {},
              UserProfileName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DomainId: {},
              UserProfileArn: {},
              UserProfileName: {},
              HomeEfsFileSystemUid: {},
              Status: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              CreationTime: {
                type: "timestamp"
              },
              FailureReason: {},
              SingleSignOnUserIdentifier: {},
              SingleSignOnUserValue: {},
              UserSettings: {
                shape: "S7h"
              }
            }
          }
        },
        DescribeWorkforce: {
          input: {
            type: "structure",
            required: [
              "WorkforceName"
            ],
            members: {
              WorkforceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Workforce"
            ],
            members: {
              Workforce: {
                shape: "Srs"
              }
            }
          }
        },
        DescribeWorkteam: {
          input: {
            type: "structure",
            required: [
              "WorkteamName"
            ],
            members: {
              WorkteamName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Workteam"
            ],
            members: {
              Workteam: {
                shape: "Srw"
              }
            }
          }
        },
        DisableSagemakerServicecatalogPortfolio: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateTrialComponent: {
          input: {
            type: "structure",
            required: [
              "TrialComponentName",
              "TrialName"
            ],
            members: {
              TrialComponentName: {},
              TrialName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrialComponentArn: {},
              TrialArn: {}
            }
          }
        },
        EnableSagemakerServicecatalogPortfolio: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetDeviceFleetReport: {
          input: {
            type: "structure",
            required: [
              "DeviceFleetName"
            ],
            members: {
              DeviceFleetName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DeviceFleetArn",
              "DeviceFleetName"
            ],
            members: {
              DeviceFleetArn: {},
              DeviceFleetName: {},
              OutputConfig: {
                shape: "S7b"
              },
              Description: {},
              ReportGenerated: {
                type: "timestamp"
              },
              DeviceStats: {
                type: "structure",
                required: [
                  "ConnectedDeviceCount",
                  "RegisteredDeviceCount"
                ],
                members: {
                  ConnectedDeviceCount: {
                    type: "long"
                  },
                  RegisteredDeviceCount: {
                    type: "long"
                  }
                }
              },
              AgentVersions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Version",
                    "AgentCount"
                  ],
                  members: {
                    Version: {},
                    AgentCount: {
                      type: "long"
                    }
                  }
                }
              },
              ModelStats: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ModelName",
                    "ModelVersion",
                    "OfflineDeviceCount",
                    "ConnectedDeviceCount",
                    "ActiveDeviceCount",
                    "SamplingDeviceCount"
                  ],
                  members: {
                    ModelName: {},
                    ModelVersion: {},
                    OfflineDeviceCount: {
                      type: "long"
                    },
                    ConnectedDeviceCount: {
                      type: "long"
                    },
                    ActiveDeviceCount: {
                      type: "long"
                    },
                    SamplingDeviceCount: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        GetModelPackageGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "ModelPackageGroupName"
            ],
            members: {
              ModelPackageGroupName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ResourcePolicy"
            ],
            members: {
              ResourcePolicy: {}
            }
          }
        },
        GetSagemakerServicecatalogPortfolioStatus: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        },
        GetSearchSuggestions: {
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {},
              SuggestionQuery: {
                type: "structure",
                members: {
                  PropertyNameQuery: {
                    type: "structure",
                    required: [
                      "PropertyNameHint"
                    ],
                    members: {
                      PropertyNameHint: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PropertyNameSuggestions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PropertyName: {}
                  }
                }
              }
            }
          }
        },
        ListActions: {
          input: {
            type: "structure",
            members: {
              SourceUri: {},
              ActionType: {},
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ActionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ActionArn: {},
                    ActionName: {},
                    Source: {
                      shape: "Si"
                    },
                    ActionType: {},
                    Status: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAlgorithms: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              NextToken: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AlgorithmSummaryList"
            ],
            members: {
              AlgorithmSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AlgorithmName",
                    "AlgorithmArn",
                    "CreationTime",
                    "AlgorithmStatus"
                  ],
                  members: {
                    AlgorithmName: {},
                    AlgorithmArn: {},
                    AlgorithmDescription: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    AlgorithmStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAppImageConfigs: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              ModifiedTimeBefore: {
                type: "timestamp"
              },
              ModifiedTimeAfter: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              AppImageConfigs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AppImageConfigArn: {},
                    AppImageConfigName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    KernelGatewayImageConfig: {
                      shape: "S41"
                    }
                  }
                }
              }
            }
          }
        },
        ListApps: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SortOrder: {},
              SortBy: {},
              DomainIdEquals: {},
              UserProfileNameEquals: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Apps: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainId: {},
                    UserProfileName: {},
                    AppType: {},
                    AppName: {},
                    Status: {},
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListArtifacts: {
          input: {
            type: "structure",
            members: {
              SourceUri: {},
              ArtifactType: {},
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ArtifactSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ArtifactArn: {},
                    ArtifactName: {},
                    Source: {
                      shape: "S4d"
                    },
                    ArtifactType: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAssociations: {
          input: {
            type: "structure",
            members: {
              SourceArn: {},
              DestinationArn: {},
              SourceType: {},
              DestinationType: {},
              AssociationType: {},
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceArn: {},
                    DestinationArn: {},
                    SourceType: {},
                    DestinationType: {},
                    AssociationType: {},
                    SourceName: {},
                    DestinationName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    CreatedBy: {
                      shape: "Skq"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAutoMLJobs: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              NameContains: {},
              StatusEquals: {},
              SortOrder: {},
              SortBy: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AutoMLJobSummaries"
            ],
            members: {
              AutoMLJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AutoMLJobName",
                    "AutoMLJobArn",
                    "AutoMLJobStatus",
                    "AutoMLJobSecondaryStatus",
                    "CreationTime",
                    "LastModifiedTime"
                  ],
                  members: {
                    AutoMLJobName: {},
                    AutoMLJobArn: {},
                    AutoMLJobStatus: {},
                    AutoMLJobSecondaryStatus: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    FailureReason: {},
                    PartialFailureReasons: {
                      shape: "Sla"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCandidatesForAutoMLJob: {
          input: {
            type: "structure",
            required: [
              "AutoMLJobName"
            ],
            members: {
              AutoMLJobName: {},
              StatusEquals: {},
              CandidateNameEquals: {},
              SortOrder: {},
              SortBy: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Candidates"
            ],
            members: {
              Candidates: {
                type: "list",
                member: {
                  shape: "Slc"
                }
              },
              NextToken: {}
            }
          }
        },
        ListCodeRepositories: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              NextToken: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "CodeRepositorySummaryList"
            ],
            members: {
              CodeRepositorySummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CodeRepositoryName",
                    "CodeRepositoryArn",
                    "CreationTime",
                    "LastModifiedTime"
                  ],
                  members: {
                    CodeRepositoryName: {},
                    CodeRepositoryArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    GitConfig: {
                      shape: "S5d"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCompilationJobs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              NameContains: {},
              StatusEquals: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "CompilationJobSummaries"
            ],
            members: {
              CompilationJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CompilationJobName",
                    "CompilationJobArn",
                    "CreationTime",
                    "CompilationJobStatus"
                  ],
                  members: {
                    CompilationJobName: {},
                    CompilationJobArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    CompilationStartTime: {
                      type: "timestamp"
                    },
                    CompilationEndTime: {
                      type: "timestamp"
                    },
                    CompilationTargetDevice: {},
                    CompilationTargetPlatformOs: {},
                    CompilationTargetPlatformArch: {},
                    CompilationTargetPlatformAccelerator: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    CompilationJobStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListContexts: {
          input: {
            type: "structure",
            members: {
              SourceUri: {},
              ContextType: {},
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContextSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ContextArn: {},
                    ContextName: {},
                    Source: {
                      shape: "S63"
                    },
                    ContextType: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDataQualityJobDefinitions: {
          input: {
            type: "structure",
            members: {
              EndpointName: {},
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionSummaries"
            ],
            members: {
              JobDefinitionSummaries: {
                shape: "Sum"
              },
              NextToken: {}
            }
          }
        },
        ListDeviceFleets: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              NameContains: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DeviceFleetSummaries"
            ],
            members: {
              DeviceFleetSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DeviceFleetArn",
                    "DeviceFleetName"
                  ],
                  members: {
                    DeviceFleetArn: {},
                    DeviceFleetName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDevices: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              LatestHeartbeatAfter: {
                type: "timestamp"
              },
              ModelName: {},
              DeviceFleetName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DeviceSummaries"
            ],
            members: {
              DeviceSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DeviceName",
                    "DeviceArn"
                  ],
                  members: {
                    DeviceName: {},
                    DeviceArn: {},
                    Description: {},
                    DeviceFleetName: {},
                    IotThingName: {},
                    RegistrationTime: {
                      type: "timestamp"
                    },
                    LatestHeartbeat: {
                      type: "timestamp"
                    },
                    Models: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "ModelName",
                          "ModelVersion"
                        ],
                        members: {
                          ModelName: {},
                          ModelVersion: {}
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDomains: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Domains: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainArn: {},
                    DomainId: {},
                    DomainName: {},
                    Status: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    Url: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEdgePackagingJobs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              NameContains: {},
              ModelNameContains: {},
              StatusEquals: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "EdgePackagingJobSummaries"
            ],
            members: {
              EdgePackagingJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "EdgePackagingJobArn",
                    "EdgePackagingJobName",
                    "EdgePackagingJobStatus"
                  ],
                  members: {
                    EdgePackagingJobArn: {},
                    EdgePackagingJobName: {},
                    EdgePackagingJobStatus: {},
                    CompilationJobName: {},
                    ModelName: {},
                    ModelVersion: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEndpointConfigs: {
          input: {
            type: "structure",
            members: {
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EndpointConfigs"
            ],
            members: {
              EndpointConfigs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "EndpointConfigName",
                    "EndpointConfigArn",
                    "CreationTime"
                  ],
                  members: {
                    EndpointConfigName: {},
                    EndpointConfigArn: {},
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEndpoints: {
          input: {
            type: "structure",
            members: {
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              StatusEquals: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Endpoints"
            ],
            members: {
              Endpoints: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "EndpointName",
                    "EndpointArn",
                    "CreationTime",
                    "LastModifiedTime",
                    "EndpointStatus"
                  ],
                  members: {
                    EndpointName: {},
                    EndpointArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    EndpointStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListExperiments: {
          input: {
            type: "structure",
            members: {
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ExperimentSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ExperimentArn: {},
                    ExperimentName: {},
                    DisplayName: {},
                    ExperimentSource: {
                      shape: "Sny"
                    },
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListFeatureGroups: {
          input: {
            type: "structure",
            members: {
              NameContains: {},
              FeatureGroupStatusEquals: {},
              OfflineStoreStatusEquals: {},
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              SortOrder: {},
              SortBy: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "FeatureGroupSummaries",
              "NextToken"
            ],
            members: {
              FeatureGroupSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "FeatureGroupName",
                    "FeatureGroupArn",
                    "CreationTime"
                  ],
                  members: {
                    FeatureGroupName: {},
                    FeatureGroupArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    FeatureGroupStatus: {},
                    OfflineStoreStatus: {
                      shape: "So4"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListFlowDefinitions: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "FlowDefinitionSummaries"
            ],
            members: {
              FlowDefinitionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "FlowDefinitionName",
                    "FlowDefinitionArn",
                    "FlowDefinitionStatus",
                    "CreationTime"
                  ],
                  members: {
                    FlowDefinitionName: {},
                    FlowDefinitionArn: {},
                    FlowDefinitionStatus: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    FailureReason: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListHumanTaskUis: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HumanTaskUiSummaries"
            ],
            members: {
              HumanTaskUiSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "HumanTaskUiName",
                    "HumanTaskUiArn",
                    "CreationTime"
                  ],
                  members: {
                    HumanTaskUiName: {},
                    HumanTaskUiArn: {},
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListHyperParameterTuningJobs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SortBy: {},
              SortOrder: {},
              NameContains: {},
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              StatusEquals: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "HyperParameterTuningJobSummaries"
            ],
            members: {
              HyperParameterTuningJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "HyperParameterTuningJobName",
                    "HyperParameterTuningJobArn",
                    "HyperParameterTuningJobStatus",
                    "Strategy",
                    "CreationTime",
                    "TrainingJobStatusCounters",
                    "ObjectiveStatusCounters"
                  ],
                  members: {
                    HyperParameterTuningJobName: {},
                    HyperParameterTuningJobArn: {},
                    HyperParameterTuningJobStatus: {},
                    Strategy: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    HyperParameterTuningEndTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    TrainingJobStatusCounters: {
                      shape: "Soj"
                    },
                    ObjectiveStatusCounters: {
                      shape: "Sol"
                    },
                    ResourceLimits: {
                      shape: "Saf"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListImageVersions: {
          input: {
            type: "structure",
            required: [
              "ImageName"
            ],
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              ImageName: {},
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImageVersions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CreationTime",
                    "ImageArn",
                    "ImageVersionArn",
                    "ImageVersionStatus",
                    "LastModifiedTime",
                    "Version"
                  ],
                  members: {
                    CreationTime: {
                      type: "timestamp"
                    },
                    FailureReason: {},
                    ImageArn: {},
                    ImageVersionArn: {},
                    ImageVersionStatus: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    Version: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListImages: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              NextToken: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Images: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CreationTime",
                    "ImageArn",
                    "ImageName",
                    "ImageStatus",
                    "LastModifiedTime"
                  ],
                  members: {
                    CreationTime: {
                      type: "timestamp"
                    },
                    Description: {},
                    DisplayName: {},
                    FailureReason: {},
                    ImageArn: {},
                    ImageName: {},
                    ImageStatus: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLabelingJobs: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              NameContains: {},
              SortBy: {},
              SortOrder: {},
              StatusEquals: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LabelingJobSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "LabelingJobName",
                    "LabelingJobArn",
                    "CreationTime",
                    "LastModifiedTime",
                    "LabelingJobStatus",
                    "LabelCounters",
                    "WorkteamArn",
                    "PreHumanTaskLambdaArn"
                  ],
                  members: {
                    LabelingJobName: {},
                    LabelingJobArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LabelingJobStatus: {},
                    LabelCounters: {
                      shape: "Sp0"
                    },
                    WorkteamArn: {},
                    PreHumanTaskLambdaArn: {},
                    AnnotationConsolidationLambdaArn: {},
                    FailureReason: {},
                    LabelingJobOutput: {
                      shape: "Sp3"
                    },
                    InputConfig: {
                      shape: "Sbk"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLabelingJobsForWorkteam: {
          input: {
            type: "structure",
            required: [
              "WorkteamArn"
            ],
            members: {
              WorkteamArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              JobReferenceCodeContains: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "LabelingJobSummaryList"
            ],
            members: {
              LabelingJobSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "JobReferenceCode",
                    "WorkRequesterAccountId",
                    "CreationTime"
                  ],
                  members: {
                    LabelingJobName: {},
                    JobReferenceCode: {},
                    WorkRequesterAccountId: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LabelCounters: {
                      type: "structure",
                      members: {
                        HumanLabeled: {
                          type: "integer"
                        },
                        PendingHuman: {
                          type: "integer"
                        },
                        Total: {
                          type: "integer"
                        }
                      }
                    },
                    NumberOfHumanWorkersPerDataObject: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListModelBiasJobDefinitions: {
          input: {
            type: "structure",
            members: {
              EndpointName: {},
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionSummaries"
            ],
            members: {
              JobDefinitionSummaries: {
                shape: "Sum"
              },
              NextToken: {}
            }
          }
        },
        ListModelExplainabilityJobDefinitions: {
          input: {
            type: "structure",
            members: {
              EndpointName: {},
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionSummaries"
            ],
            members: {
              JobDefinitionSummaries: {
                shape: "Sum"
              },
              NextToken: {}
            }
          }
        },
        ListModelPackageGroups: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              NextToken: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelPackageGroupSummaryList"
            ],
            members: {
              ModelPackageGroupSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ModelPackageGroupName",
                    "ModelPackageGroupArn",
                    "CreationTime",
                    "ModelPackageGroupStatus"
                  ],
                  members: {
                    ModelPackageGroupName: {},
                    ModelPackageGroupArn: {},
                    ModelPackageGroupDescription: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    ModelPackageGroupStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListModelPackages: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              ModelApprovalStatus: {},
              ModelPackageGroupName: {},
              ModelPackageType: {},
              NextToken: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelPackageSummaryList"
            ],
            members: {
              ModelPackageSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ModelPackageName",
                    "ModelPackageArn",
                    "CreationTime",
                    "ModelPackageStatus"
                  ],
                  members: {
                    ModelPackageName: {},
                    ModelPackageGroupName: {},
                    ModelPackageVersion: {
                      type: "integer"
                    },
                    ModelPackageArn: {},
                    ModelPackageDescription: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    ModelPackageStatus: {},
                    ModelApprovalStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListModelQualityJobDefinitions: {
          input: {
            type: "structure",
            members: {
              EndpointName: {},
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobDefinitionSummaries"
            ],
            members: {
              JobDefinitionSummaries: {
                shape: "Sum"
              },
              NextToken: {}
            }
          }
        },
        ListModels: {
          input: {
            type: "structure",
            members: {
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Models"
            ],
            members: {
              Models: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ModelName",
                    "ModelArn",
                    "CreationTime"
                  ],
                  members: {
                    ModelName: {},
                    ModelArn: {},
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListMonitoringExecutions: {
          input: {
            type: "structure",
            members: {
              MonitoringScheduleName: {},
              EndpointName: {},
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ScheduledTimeBefore: {
                type: "timestamp"
              },
              ScheduledTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              StatusEquals: {},
              MonitoringJobDefinitionName: {},
              MonitoringTypeEquals: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "MonitoringExecutionSummaries"
            ],
            members: {
              MonitoringExecutionSummaries: {
                type: "list",
                member: {
                  shape: "Spr"
                }
              },
              NextToken: {}
            }
          }
        },
        ListMonitoringSchedules: {
          input: {
            type: "structure",
            members: {
              EndpointName: {},
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              StatusEquals: {},
              MonitoringJobDefinitionName: {},
              MonitoringTypeEquals: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "MonitoringScheduleSummaries"
            ],
            members: {
              MonitoringScheduleSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "MonitoringScheduleName",
                    "MonitoringScheduleArn",
                    "CreationTime",
                    "LastModifiedTime",
                    "MonitoringScheduleStatus"
                  ],
                  members: {
                    MonitoringScheduleName: {},
                    MonitoringScheduleArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    MonitoringScheduleStatus: {},
                    EndpointName: {},
                    MonitoringJobDefinitionName: {},
                    MonitoringType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListNotebookInstanceLifecycleConfigs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SortBy: {},
              SortOrder: {},
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NotebookInstanceLifecycleConfigs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "NotebookInstanceLifecycleConfigName",
                    "NotebookInstanceLifecycleConfigArn"
                  ],
                  members: {
                    NotebookInstanceLifecycleConfigName: {},
                    NotebookInstanceLifecycleConfigArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListNotebookInstances: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SortBy: {},
              SortOrder: {},
              NameContains: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              StatusEquals: {},
              NotebookInstanceLifecycleConfigNameContains: {},
              DefaultCodeRepositoryContains: {},
              AdditionalCodeRepositoryEquals: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NotebookInstances: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "NotebookInstanceName",
                    "NotebookInstanceArn"
                  ],
                  members: {
                    NotebookInstanceName: {},
                    NotebookInstanceArn: {},
                    NotebookInstanceStatus: {},
                    Url: {},
                    InstanceType: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    NotebookInstanceLifecycleConfigName: {},
                    DefaultCodeRepository: {},
                    AdditionalCodeRepositories: {
                      shape: "Sef"
                    }
                  }
                }
              }
            }
          }
        },
        ListPipelineExecutionSteps: {
          input: {
            type: "structure",
            members: {
              PipelineExecutionArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineExecutionSteps: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StepName: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    StepStatus: {},
                    CacheHitResult: {
                      type: "structure",
                      members: {
                        SourcePipelineExecutionArn: {}
                      }
                    },
                    FailureReason: {},
                    Metadata: {
                      type: "structure",
                      members: {
                        TrainingJob: {
                          type: "structure",
                          members: {
                            Arn: {}
                          }
                        },
                        ProcessingJob: {
                          type: "structure",
                          members: {
                            Arn: {}
                          }
                        },
                        TransformJob: {
                          type: "structure",
                          members: {
                            Arn: {}
                          }
                        },
                        TuningJob: {
                          type: "structure",
                          members: {
                            Arn: {}
                          }
                        },
                        Model: {
                          type: "structure",
                          members: {
                            Arn: {}
                          }
                        },
                        RegisterModel: {
                          type: "structure",
                          members: {
                            Arn: {}
                          }
                        },
                        Condition: {
                          type: "structure",
                          members: {
                            Outcome: {}
                          }
                        },
                        Callback: {
                          type: "structure",
                          members: {
                            CallbackToken: {},
                            SqsQueueUrl: {},
                            OutputParameters: {
                              shape: "Syw"
                            }
                          }
                        },
                        Lambda: {
                          type: "structure",
                          members: {
                            Arn: {},
                            OutputParameters: {
                              shape: "Syw"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPipelineExecutions: {
          input: {
            type: "structure",
            required: [
              "PipelineName"
            ],
            members: {
              PipelineName: {},
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineExecutionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PipelineExecutionArn: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    PipelineExecutionStatus: {},
                    PipelineExecutionDescription: {},
                    PipelineExecutionDisplayName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPipelineParametersForExecution: {
          input: {
            type: "structure",
            required: [
              "PipelineExecutionArn"
            ],
            members: {
              PipelineExecutionArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineParameters: {
                shape: "Sz6"
              },
              NextToken: {}
            }
          }
        },
        ListPipelines: {
          input: {
            type: "structure",
            members: {
              PipelineNamePrefix: {},
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PipelineArn: {},
                    PipelineName: {},
                    PipelineDisplayName: {},
                    PipelineDescription: {},
                    RoleArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LastExecutionTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProcessingJobs: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              NameContains: {},
              StatusEquals: {},
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ProcessingJobSummaries"
            ],
            members: {
              ProcessingJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ProcessingJobName",
                    "ProcessingJobArn",
                    "CreationTime",
                    "ProcessingJobStatus"
                  ],
                  members: {
                    ProcessingJobName: {},
                    ProcessingJobArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    ProcessingEndTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    ProcessingJobStatus: {},
                    FailureReason: {},
                    ExitMessage: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProjects: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NameContains: {},
              NextToken: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ProjectSummaryList"
            ],
            members: {
              ProjectSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ProjectName",
                    "ProjectArn",
                    "ProjectId",
                    "CreationTime",
                    "ProjectStatus"
                  ],
                  members: {
                    ProjectName: {},
                    ProjectDescription: {},
                    ProjectArn: {},
                    ProjectId: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    ProjectStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListStudioLifecycleConfigs: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              NameContains: {},
              AppTypeEquals: {},
              CreationTimeBefore: {
                type: "timestamp"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              ModifiedTimeBefore: {
                type: "timestamp"
              },
              ModifiedTimeAfter: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              StudioLifecycleConfigs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StudioLifecycleConfigArn: {},
                    StudioLifecycleConfigName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    StudioLifecycleConfigAppType: {}
                  }
                }
              }
            }
          }
        },
        ListSubscribedWorkteams: {
          input: {
            type: "structure",
            members: {
              NameContains: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "SubscribedWorkteams"
            ],
            members: {
              SubscribedWorkteams: {
                type: "list",
                member: {
                  shape: "Sqp"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTags: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S7"
              },
              NextToken: {}
            }
          }
        },
        ListTrainingJobs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              NameContains: {},
              StatusEquals: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TrainingJobSummaries"
            ],
            members: {
              TrainingJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "TrainingJobName",
                    "TrainingJobArn",
                    "CreationTime",
                    "TrainingJobStatus"
                  ],
                  members: {
                    TrainingJobName: {},
                    TrainingJobArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    TrainingEndTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    TrainingJobStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTrainingJobsForHyperParameterTuningJob: {
          input: {
            type: "structure",
            required: [
              "HyperParameterTuningJobName"
            ],
            members: {
              HyperParameterTuningJobName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              StatusEquals: {},
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TrainingJobSummaries"
            ],
            members: {
              TrainingJobSummaries: {
                type: "list",
                member: {
                  shape: "Son"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTransformJobs: {
          input: {
            type: "structure",
            members: {
              CreationTimeAfter: {
                type: "timestamp"
              },
              CreationTimeBefore: {
                type: "timestamp"
              },
              LastModifiedTimeAfter: {
                type: "timestamp"
              },
              LastModifiedTimeBefore: {
                type: "timestamp"
              },
              NameContains: {},
              StatusEquals: {},
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TransformJobSummaries"
            ],
            members: {
              TransformJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "TransformJobName",
                    "TransformJobArn",
                    "CreationTime",
                    "TransformJobStatus"
                  ],
                  members: {
                    TransformJobName: {},
                    TransformJobArn: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    TransformEndTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    TransformJobStatus: {},
                    FailureReason: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTrialComponents: {
          input: {
            type: "structure",
            members: {
              ExperimentName: {},
              TrialName: {},
              SourceArn: {},
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrialComponentSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TrialComponentName: {},
                    TrialComponentArn: {},
                    DisplayName: {},
                    TrialComponentSource: {
                      shape: "Srg"
                    },
                    Status: {
                      shape: "Shs"
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    CreationTime: {
                      type: "timestamp"
                    },
                    CreatedBy: {
                      shape: "Skq"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LastModifiedBy: {
                      shape: "Skq"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTrials: {
          input: {
            type: "structure",
            members: {
              ExperimentName: {},
              TrialComponentName: {},
              CreatedAfter: {
                type: "timestamp"
              },
              CreatedBefore: {
                type: "timestamp"
              },
              SortBy: {},
              SortOrder: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrialSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TrialArn: {},
                    TrialName: {},
                    DisplayName: {},
                    TrialSource: {
                      shape: "Src"
                    },
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListUserProfiles: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              SortOrder: {},
              SortBy: {},
              DomainIdEquals: {},
              UserProfileNameContains: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserProfiles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainId: {},
                    UserProfileName: {},
                    Status: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListWorkforces: {
          input: {
            type: "structure",
            members: {
              SortBy: {},
              SortOrder: {},
              NameContains: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Workforces"
            ],
            members: {
              Workforces: {
                type: "list",
                member: {
                  shape: "Srs"
                }
              },
              NextToken: {}
            }
          }
        },
        ListWorkteams: {
          input: {
            type: "structure",
            members: {
              SortBy: {},
              SortOrder: {},
              NameContains: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Workteams"
            ],
            members: {
              Workteams: {
                type: "list",
                member: {
                  shape: "Srw"
                }
              },
              NextToken: {}
            }
          }
        },
        PutModelPackageGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "ModelPackageGroupName",
              "ResourcePolicy"
            ],
            members: {
              ModelPackageGroupName: {},
              ResourcePolicy: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelPackageGroupArn"
            ],
            members: {
              ModelPackageGroupArn: {}
            }
          }
        },
        RegisterDevices: {
          input: {
            type: "structure",
            required: [
              "DeviceFleetName",
              "Devices"
            ],
            members: {
              DeviceFleetName: {},
              Devices: {
                shape: "S111"
              },
              Tags: {
                shape: "S7"
              }
            }
          }
        },
        RenderUiTemplate: {
          input: {
            type: "structure",
            required: [
              "Task",
              "RoleArn"
            ],
            members: {
              UiTemplate: {
                shape: "Sa8"
              },
              Task: {
                type: "structure",
                required: [
                  "Input"
                ],
                members: {
                  Input: {}
                }
              },
              RoleArn: {},
              HumanTaskUiArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RenderedContent",
              "Errors"
            ],
            members: {
              RenderedContent: {},
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Code",
                    "Message"
                  ],
                  members: {
                    Code: {},
                    Message: {}
                  }
                }
              }
            }
          }
        },
        RetryPipelineExecution: {
          input: {
            type: "structure",
            required: [
              "PipelineExecutionArn",
              "ClientRequestToken"
            ],
            members: {
              PipelineExecutionArn: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineExecutionArn: {}
            }
          }
        },
        Search: {
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              Resource: {},
              SearchExpression: {
                shape: "S11c"
              },
              SortBy: {},
              SortOrder: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TrainingJob: {
                      shape: "S11p"
                    },
                    Experiment: {
                      type: "structure",
                      members: {
                        ExperimentName: {},
                        ExperimentArn: {},
                        DisplayName: {},
                        Source: {
                          shape: "Sny"
                        },
                        Description: {},
                        CreationTime: {
                          type: "timestamp"
                        },
                        CreatedBy: {
                          shape: "Skq"
                        },
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        LastModifiedBy: {
                          shape: "Skq"
                        },
                        Tags: {
                          shape: "S7"
                        }
                      }
                    },
                    Trial: {
                      type: "structure",
                      members: {
                        TrialName: {},
                        TrialArn: {},
                        DisplayName: {},
                        ExperimentName: {},
                        Source: {
                          shape: "Src"
                        },
                        CreationTime: {
                          type: "timestamp"
                        },
                        CreatedBy: {
                          shape: "Skq"
                        },
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        LastModifiedBy: {
                          shape: "Skq"
                        },
                        MetadataProperties: {
                          shape: "Sp"
                        },
                        Tags: {
                          shape: "S7"
                        },
                        TrialComponentSummaries: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              TrialComponentName: {},
                              TrialComponentArn: {},
                              TrialComponentSource: {
                                shape: "Srg"
                              },
                              CreationTime: {
                                type: "timestamp"
                              },
                              CreatedBy: {
                                shape: "Skq"
                              }
                            }
                          }
                        }
                      }
                    },
                    TrialComponent: {
                      type: "structure",
                      members: {
                        TrialComponentName: {},
                        DisplayName: {},
                        TrialComponentArn: {},
                        Source: {
                          shape: "Srg"
                        },
                        Status: {
                          shape: "Shs"
                        },
                        StartTime: {
                          type: "timestamp"
                        },
                        EndTime: {
                          type: "timestamp"
                        },
                        CreationTime: {
                          type: "timestamp"
                        },
                        CreatedBy: {
                          shape: "Skq"
                        },
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        LastModifiedBy: {
                          shape: "Skq"
                        },
                        Parameters: {
                          shape: "Shw"
                        },
                        InputArtifacts: {
                          shape: "Si0"
                        },
                        OutputArtifacts: {
                          shape: "Si0"
                        },
                        Metrics: {
                          shape: "Sri"
                        },
                        MetadataProperties: {
                          shape: "Sp"
                        },
                        SourceDetail: {
                          type: "structure",
                          members: {
                            SourceArn: {},
                            TrainingJob: {
                              shape: "S11p"
                            },
                            ProcessingJob: {
                              type: "structure",
                              members: {
                                ProcessingInputs: {
                                  shape: "Sf6"
                                },
                                ProcessingOutputConfig: {
                                  shape: "Sft"
                                },
                                ProcessingJobName: {},
                                ProcessingResources: {
                                  shape: "Sfy"
                                },
                                StoppingCondition: {
                                  shape: "Sg0"
                                },
                                AppSpecification: {
                                  shape: "Sg2"
                                },
                                Environment: {
                                  shape: "Sg4"
                                },
                                NetworkConfig: {
                                  shape: "Se2"
                                },
                                RoleArn: {},
                                ExperimentConfig: {
                                  shape: "Sg5"
                                },
                                ProcessingJobArn: {},
                                ProcessingJobStatus: {},
                                ExitMessage: {},
                                FailureReason: {},
                                ProcessingEndTime: {
                                  type: "timestamp"
                                },
                                ProcessingStartTime: {
                                  type: "timestamp"
                                },
                                LastModifiedTime: {
                                  type: "timestamp"
                                },
                                CreationTime: {
                                  type: "timestamp"
                                },
                                MonitoringScheduleArn: {},
                                AutoMLJobArn: {},
                                TrainingJobArn: {},
                                Tags: {
                                  shape: "S7"
                                }
                              }
                            },
                            TransformJob: {
                              type: "structure",
                              members: {
                                TransformJobName: {},
                                TransformJobArn: {},
                                TransformJobStatus: {},
                                FailureReason: {},
                                ModelName: {},
                                MaxConcurrentTransforms: {
                                  type: "integer"
                                },
                                ModelClientConfig: {
                                  shape: "Shh"
                                },
                                MaxPayloadInMB: {
                                  type: "integer"
                                },
                                BatchStrategy: {},
                                Environment: {
                                  shape: "S38"
                                },
                                TransformInput: {
                                  shape: "S3b"
                                },
                                TransformOutput: {
                                  shape: "S3f"
                                },
                                TransformResources: {
                                  shape: "S3i"
                                },
                                CreationTime: {
                                  type: "timestamp"
                                },
                                TransformStartTime: {
                                  type: "timestamp"
                                },
                                TransformEndTime: {
                                  type: "timestamp"
                                },
                                LabelingJobArn: {},
                                AutoMLJobArn: {},
                                DataProcessing: {
                                  shape: "Shk"
                                },
                                ExperimentConfig: {
                                  shape: "Sg5"
                                },
                                Tags: {
                                  shape: "S7"
                                }
                              }
                            }
                          }
                        },
                        Tags: {
                          shape: "S7"
                        },
                        Parents: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              TrialName: {},
                              ExperimentName: {}
                            }
                          }
                        }
                      }
                    },
                    Endpoint: {
                      type: "structure",
                      required: [
                        "EndpointName",
                        "EndpointArn",
                        "EndpointConfigName",
                        "EndpointStatus",
                        "CreationTime",
                        "LastModifiedTime"
                      ],
                      members: {
                        EndpointName: {},
                        EndpointArn: {},
                        EndpointConfigName: {},
                        ProductionVariants: {
                          shape: "Sn8"
                        },
                        DataCaptureConfig: {
                          shape: "Snd"
                        },
                        EndpointStatus: {},
                        FailureReason: {},
                        CreationTime: {
                          type: "timestamp"
                        },
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        MonitoringSchedules: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              MonitoringScheduleArn: {},
                              MonitoringScheduleName: {},
                              MonitoringScheduleStatus: {},
                              MonitoringType: {},
                              FailureReason: {},
                              CreationTime: {
                                type: "timestamp"
                              },
                              LastModifiedTime: {
                                type: "timestamp"
                              },
                              MonitoringScheduleConfig: {
                                shape: "Sdu"
                              },
                              EndpointName: {},
                              LastMonitoringExecutionSummary: {
                                shape: "Spr"
                              },
                              Tags: {
                                shape: "S7"
                              }
                            }
                          }
                        },
                        Tags: {
                          shape: "S7"
                        }
                      }
                    },
                    ModelPackage: {
                      type: "structure",
                      members: {
                        ModelPackageName: {},
                        ModelPackageGroupName: {},
                        ModelPackageVersion: {
                          type: "integer"
                        },
                        ModelPackageArn: {},
                        ModelPackageDescription: {},
                        CreationTime: {
                          type: "timestamp"
                        },
                        InferenceSpecification: {
                          shape: "S1t"
                        },
                        SourceAlgorithmSpecification: {
                          shape: "Sd6"
                        },
                        ValidationSpecification: {
                          shape: "Sd3"
                        },
                        ModelPackageStatus: {},
                        ModelPackageStatusDetails: {
                          shape: "Spe"
                        },
                        CertifyForMarketplace: {
                          type: "boolean"
                        },
                        ModelApprovalStatus: {},
                        CreatedBy: {
                          shape: "Skq"
                        },
                        MetadataProperties: {
                          shape: "Sp"
                        },
                        ModelMetrics: {
                          shape: "Sda"
                        },
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        LastModifiedBy: {
                          shape: "Skq"
                        },
                        ApprovalDescription: {},
                        Tags: {
                          shape: "S7"
                        }
                      }
                    },
                    ModelPackageGroup: {
                      type: "structure",
                      members: {
                        ModelPackageGroupName: {},
                        ModelPackageGroupArn: {},
                        ModelPackageGroupDescription: {},
                        CreationTime: {
                          type: "timestamp"
                        },
                        CreatedBy: {
                          shape: "Skq"
                        },
                        ModelPackageGroupStatus: {},
                        Tags: {
                          shape: "S7"
                        }
                      }
                    },
                    Pipeline: {
                      type: "structure",
                      members: {
                        PipelineArn: {},
                        PipelineName: {},
                        PipelineDisplayName: {},
                        PipelineDescription: {},
                        RoleArn: {},
                        PipelineStatus: {},
                        CreationTime: {
                          type: "timestamp"
                        },
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        LastRunTime: {
                          type: "timestamp"
                        },
                        CreatedBy: {
                          shape: "Skq"
                        },
                        LastModifiedBy: {
                          shape: "Skq"
                        },
                        Tags: {
                          shape: "S7"
                        }
                      }
                    },
                    PipelineExecution: {
                      type: "structure",
                      members: {
                        PipelineArn: {},
                        PipelineExecutionArn: {},
                        PipelineExecutionDisplayName: {},
                        PipelineExecutionStatus: {},
                        PipelineExecutionDescription: {},
                        PipelineExperimentConfig: {
                          shape: "Sqa"
                        },
                        FailureReason: {},
                        CreationTime: {
                          type: "timestamp"
                        },
                        LastModifiedTime: {
                          type: "timestamp"
                        },
                        CreatedBy: {
                          shape: "Skq"
                        },
                        LastModifiedBy: {
                          shape: "Skq"
                        },
                        PipelineParameters: {
                          shape: "Sz6"
                        }
                      }
                    },
                    FeatureGroup: {
                      type: "structure",
                      members: {
                        FeatureGroupArn: {},
                        FeatureGroupName: {},
                        RecordIdentifierFeatureName: {},
                        EventTimeFeatureName: {},
                        FeatureDefinitions: {
                          shape: "S93"
                        },
                        CreationTime: {
                          type: "timestamp"
                        },
                        OnlineStoreConfig: {
                          shape: "S96"
                        },
                        OfflineStoreConfig: {
                          shape: "S98"
                        },
                        RoleArn: {},
                        FeatureGroupStatus: {},
                        OfflineStoreStatus: {
                          shape: "So4"
                        },
                        FailureReason: {},
                        Description: {},
                        Tags: {
                          shape: "S7"
                        }
                      }
                    },
                    Project: {
                      type: "structure",
                      members: {
                        ProjectArn: {},
                        ProjectName: {},
                        ProjectId: {},
                        ProjectDescription: {},
                        ServiceCatalogProvisioningDetails: {
                          shape: "Sga"
                        },
                        ServiceCatalogProvisionedProductDetails: {
                          shape: "Sqi"
                        },
                        ProjectStatus: {},
                        CreatedBy: {
                          shape: "Skq"
                        },
                        CreationTime: {
                          type: "timestamp"
                        },
                        Tags: {
                          shape: "S7"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        SendPipelineExecutionStepFailure: {
          input: {
            type: "structure",
            required: [
              "CallbackToken"
            ],
            members: {
              CallbackToken: {},
              FailureReason: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineExecutionArn: {}
            }
          }
        },
        SendPipelineExecutionStepSuccess: {
          input: {
            type: "structure",
            required: [
              "CallbackToken"
            ],
            members: {
              CallbackToken: {},
              OutputParameters: {
                shape: "Syw"
              },
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineExecutionArn: {}
            }
          }
        },
        StartMonitoringSchedule: {
          input: {
            type: "structure",
            required: [
              "MonitoringScheduleName"
            ],
            members: {
              MonitoringScheduleName: {}
            }
          }
        },
        StartNotebookInstance: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceName"
            ],
            members: {
              NotebookInstanceName: {}
            }
          }
        },
        StartPipelineExecution: {
          input: {
            type: "structure",
            required: [
              "PipelineName",
              "ClientRequestToken"
            ],
            members: {
              PipelineName: {},
              PipelineExecutionDisplayName: {},
              PipelineParameters: {
                shape: "Sz6"
              },
              PipelineExecutionDescription: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineExecutionArn: {}
            }
          }
        },
        StopAutoMLJob: {
          input: {
            type: "structure",
            required: [
              "AutoMLJobName"
            ],
            members: {
              AutoMLJobName: {}
            }
          }
        },
        StopCompilationJob: {
          input: {
            type: "structure",
            required: [
              "CompilationJobName"
            ],
            members: {
              CompilationJobName: {}
            }
          }
        },
        StopEdgePackagingJob: {
          input: {
            type: "structure",
            required: [
              "EdgePackagingJobName"
            ],
            members: {
              EdgePackagingJobName: {}
            }
          }
        },
        StopHyperParameterTuningJob: {
          input: {
            type: "structure",
            required: [
              "HyperParameterTuningJobName"
            ],
            members: {
              HyperParameterTuningJobName: {}
            }
          }
        },
        StopLabelingJob: {
          input: {
            type: "structure",
            required: [
              "LabelingJobName"
            ],
            members: {
              LabelingJobName: {}
            }
          }
        },
        StopMonitoringSchedule: {
          input: {
            type: "structure",
            required: [
              "MonitoringScheduleName"
            ],
            members: {
              MonitoringScheduleName: {}
            }
          }
        },
        StopNotebookInstance: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceName"
            ],
            members: {
              NotebookInstanceName: {}
            }
          }
        },
        StopPipelineExecution: {
          input: {
            type: "structure",
            required: [
              "PipelineExecutionArn",
              "ClientRequestToken"
            ],
            members: {
              PipelineExecutionArn: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineExecutionArn: {}
            }
          }
        },
        StopProcessingJob: {
          input: {
            type: "structure",
            required: [
              "ProcessingJobName"
            ],
            members: {
              ProcessingJobName: {}
            }
          }
        },
        StopTrainingJob: {
          input: {
            type: "structure",
            required: [
              "TrainingJobName"
            ],
            members: {
              TrainingJobName: {}
            }
          }
        },
        StopTransformJob: {
          input: {
            type: "structure",
            required: [
              "TransformJobName"
            ],
            members: {
              TransformJobName: {}
            }
          }
        },
        UpdateAction: {
          input: {
            type: "structure",
            required: [
              "ActionName"
            ],
            members: {
              ActionName: {},
              Description: {},
              Status: {},
              Properties: {
                shape: "Sn"
              },
              PropertiesToRemove: {
                shape: "S12u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ActionArn: {}
            }
          }
        },
        UpdateAppImageConfig: {
          input: {
            type: "structure",
            required: [
              "AppImageConfigName"
            ],
            members: {
              AppImageConfigName: {},
              KernelGatewayImageConfig: {
                shape: "S41"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppImageConfigArn: {}
            }
          }
        },
        UpdateArtifact: {
          input: {
            type: "structure",
            required: [
              "ArtifactArn"
            ],
            members: {
              ArtifactArn: {},
              ArtifactName: {},
              Properties: {
                shape: "Sn"
              },
              PropertiesToRemove: {
                shape: "S12u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ArtifactArn: {}
            }
          }
        },
        UpdateCodeRepository: {
          input: {
            type: "structure",
            required: [
              "CodeRepositoryName"
            ],
            members: {
              CodeRepositoryName: {},
              GitConfig: {
                type: "structure",
                members: {
                  SecretArn: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CodeRepositoryArn"
            ],
            members: {
              CodeRepositoryArn: {}
            }
          }
        },
        UpdateContext: {
          input: {
            type: "structure",
            required: [
              "ContextName"
            ],
            members: {
              ContextName: {},
              Description: {},
              Properties: {
                shape: "Sn"
              },
              PropertiesToRemove: {
                shape: "S12u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContextArn: {}
            }
          }
        },
        UpdateDeviceFleet: {
          input: {
            type: "structure",
            required: [
              "DeviceFleetName",
              "OutputConfig"
            ],
            members: {
              DeviceFleetName: {},
              RoleArn: {},
              Description: {},
              OutputConfig: {
                shape: "S7b"
              },
              EnableIotRoleAlias: {
                type: "boolean"
              }
            }
          }
        },
        UpdateDevices: {
          input: {
            type: "structure",
            required: [
              "DeviceFleetName",
              "Devices"
            ],
            members: {
              DeviceFleetName: {},
              Devices: {
                shape: "S111"
              }
            }
          }
        },
        UpdateDomain: {
          input: {
            type: "structure",
            required: [
              "DomainId"
            ],
            members: {
              DomainId: {},
              DefaultUserSettings: {
                shape: "S7h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainArn: {}
            }
          }
        },
        UpdateEndpoint: {
          input: {
            type: "structure",
            required: [
              "EndpointName",
              "EndpointConfigName"
            ],
            members: {
              EndpointName: {},
              EndpointConfigName: {},
              RetainAllVariantProperties: {
                type: "boolean"
              },
              ExcludeRetainedVariantProperties: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "VariantPropertyType"
                  ],
                  members: {
                    VariantPropertyType: {}
                  }
                }
              },
              DeploymentConfig: {
                shape: "Sng"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {}
            }
          }
        },
        UpdateEndpointWeightsAndCapacities: {
          input: {
            type: "structure",
            required: [
              "EndpointName",
              "DesiredWeightsAndCapacities"
            ],
            members: {
              EndpointName: {},
              DesiredWeightsAndCapacities: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "VariantName"
                  ],
                  members: {
                    VariantName: {},
                    DesiredWeight: {
                      type: "float"
                    },
                    DesiredInstanceCount: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EndpointArn"
            ],
            members: {
              EndpointArn: {}
            }
          }
        },
        UpdateExperiment: {
          input: {
            type: "structure",
            required: [
              "ExperimentName"
            ],
            members: {
              ExperimentName: {},
              DisplayName: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExperimentArn: {}
            }
          }
        },
        UpdateImage: {
          input: {
            type: "structure",
            required: [
              "ImageName"
            ],
            members: {
              DeleteProperties: {
                type: "list",
                member: {}
              },
              Description: {},
              DisplayName: {},
              ImageName: {},
              RoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ImageArn: {}
            }
          }
        },
        UpdateModelPackage: {
          input: {
            type: "structure",
            required: [
              "ModelPackageArn",
              "ModelApprovalStatus"
            ],
            members: {
              ModelPackageArn: {},
              ModelApprovalStatus: {},
              ApprovalDescription: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ModelPackageArn"
            ],
            members: {
              ModelPackageArn: {}
            }
          }
        },
        UpdateMonitoringSchedule: {
          input: {
            type: "structure",
            required: [
              "MonitoringScheduleName",
              "MonitoringScheduleConfig"
            ],
            members: {
              MonitoringScheduleName: {},
              MonitoringScheduleConfig: {
                shape: "Sdu"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "MonitoringScheduleArn"
            ],
            members: {
              MonitoringScheduleArn: {}
            }
          }
        },
        UpdateNotebookInstance: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceName"
            ],
            members: {
              NotebookInstanceName: {},
              InstanceType: {},
              RoleArn: {},
              LifecycleConfigName: {},
              DisassociateLifecycleConfig: {
                type: "boolean"
              },
              VolumeSizeInGB: {
                type: "integer"
              },
              DefaultCodeRepository: {},
              AdditionalCodeRepositories: {
                shape: "Sef"
              },
              AcceleratorTypes: {
                shape: "Sec"
              },
              DisassociateAcceleratorTypes: {
                type: "boolean"
              },
              DisassociateDefaultCodeRepository: {
                type: "boolean"
              },
              DisassociateAdditionalCodeRepositories: {
                type: "boolean"
              },
              RootAccess: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateNotebookInstanceLifecycleConfig: {
          input: {
            type: "structure",
            required: [
              "NotebookInstanceLifecycleConfigName"
            ],
            members: {
              NotebookInstanceLifecycleConfigName: {},
              OnCreate: {
                shape: "Sel"
              },
              OnStart: {
                shape: "Sel"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdatePipeline: {
          input: {
            type: "structure",
            required: [
              "PipelineName"
            ],
            members: {
              PipelineName: {},
              PipelineDisplayName: {},
              PipelineDefinition: {},
              PipelineDescription: {},
              RoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineArn: {}
            }
          }
        },
        UpdatePipelineExecution: {
          input: {
            type: "structure",
            required: [
              "PipelineExecutionArn"
            ],
            members: {
              PipelineExecutionArn: {},
              PipelineExecutionDescription: {},
              PipelineExecutionDisplayName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PipelineExecutionArn: {}
            }
          }
        },
        UpdateTrainingJob: {
          input: {
            type: "structure",
            required: [
              "TrainingJobName"
            ],
            members: {
              TrainingJobName: {},
              ProfilerConfig: {
                type: "structure",
                members: {
                  S3OutputPath: {},
                  ProfilingIntervalInMilliseconds: {
                    type: "long"
                  },
                  ProfilingParameters: {
                    shape: "Sh7"
                  },
                  DisableProfiler: {
                    type: "boolean"
                  }
                }
              },
              ProfilerRuleConfigurations: {
                shape: "Sh8"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrainingJobArn"
            ],
            members: {
              TrainingJobArn: {}
            }
          }
        },
        UpdateTrial: {
          input: {
            type: "structure",
            required: [
              "TrialName"
            ],
            members: {
              TrialName: {},
              DisplayName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TrialArn: {}
            }
          }
        },
        UpdateTrialComponent: {
          input: {
            type: "structure",
            required: [
              "TrialComponentName"
            ],
            members: {
              TrialComponentName: {},
              DisplayName: {},
              Status: {
                shape: "Shs"
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Parameters: {
                shape: "Shw"
              },
              ParametersToRemove: {
                shape: "S14b"
              },
              InputArtifacts: {
                shape: "Si0"
              },
              InputArtifactsToRemove: {
                shape: "S14b"
              },
              OutputArtifacts: {
                shape: "Si0"
              },
              OutputArtifactsToRemove: {
                shape: "S14b"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TrialComponentArn: {}
            }
          }
        },
        UpdateUserProfile: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "UserProfileName"
            ],
            members: {
              DomainId: {},
              UserProfileName: {},
              UserSettings: {
                shape: "S7h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserProfileArn: {}
            }
          }
        },
        UpdateWorkforce: {
          input: {
            type: "structure",
            required: [
              "WorkforceName"
            ],
            members: {
              WorkforceName: {},
              SourceIpConfig: {
                shape: "Sih"
              },
              OidcConfig: {
                shape: "Sie"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Workforce"
            ],
            members: {
              Workforce: {
                shape: "Srs"
              }
            }
          }
        },
        UpdateWorkteam: {
          input: {
            type: "structure",
            required: [
              "WorkteamName"
            ],
            members: {
              WorkteamName: {},
              MemberDefinitions: {
                shape: "Sip"
              },
              Description: {},
              NotificationConfiguration: {
                shape: "Six"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Workteam"
            ],
            members: {
              Workteam: {
                shape: "Srw"
              }
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Si: {
          type: "structure",
          required: [
            "SourceUri"
          ],
          members: {
            SourceUri: {},
            SourceType: {},
            SourceId: {}
          }
        },
        Sn: {
          type: "map",
          key: {},
          value: {}
        },
        Sp: {
          type: "structure",
          members: {
            CommitId: {},
            Repository: {},
            GeneratedBy: {},
            ProjectId: {}
          }
        },
        Sw: {
          type: "structure",
          required: [
            "TrainingImage",
            "SupportedTrainingInstanceTypes",
            "TrainingChannels"
          ],
          members: {
            TrainingImage: {},
            TrainingImageDigest: {},
            SupportedHyperParameters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "Type"
                ],
                members: {
                  Name: {},
                  Description: {},
                  Type: {},
                  Range: {
                    type: "structure",
                    members: {
                      IntegerParameterRangeSpecification: {
                        type: "structure",
                        required: [
                          "MinValue",
                          "MaxValue"
                        ],
                        members: {
                          MinValue: {},
                          MaxValue: {}
                        }
                      },
                      ContinuousParameterRangeSpecification: {
                        type: "structure",
                        required: [
                          "MinValue",
                          "MaxValue"
                        ],
                        members: {
                          MinValue: {},
                          MaxValue: {}
                        }
                      },
                      CategoricalParameterRangeSpecification: {
                        type: "structure",
                        required: [
                          "Values"
                        ],
                        members: {
                          Values: {
                            shape: "S18"
                          }
                        }
                      }
                    }
                  },
                  IsTunable: {
                    type: "boolean"
                  },
                  IsRequired: {
                    type: "boolean"
                  },
                  DefaultValue: {}
                }
              }
            },
            SupportedTrainingInstanceTypes: {
              type: "list",
              member: {}
            },
            SupportsDistributedTraining: {
              type: "boolean"
            },
            MetricDefinitions: {
              shape: "S1d"
            },
            TrainingChannels: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "SupportedContentTypes",
                  "SupportedInputModes"
                ],
                members: {
                  Name: {},
                  Description: {},
                  IsRequired: {
                    type: "boolean"
                  },
                  SupportedContentTypes: {
                    shape: "S1k"
                  },
                  SupportedCompressionTypes: {
                    type: "list",
                    member: {}
                  },
                  SupportedInputModes: {
                    type: "list",
                    member: {}
                  }
                }
              }
            },
            SupportedTuningJobObjectiveMetrics: {
              type: "list",
              member: {
                shape: "S1r"
              }
            }
          }
        },
        S18: {
          type: "list",
          member: {}
        },
        S1d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Regex"
            ],
            members: {
              Name: {},
              Regex: {}
            }
          }
        },
        S1k: {
          type: "list",
          member: {}
        },
        S1r: {
          type: "structure",
          required: [
            "Type",
            "MetricName"
          ],
          members: {
            Type: {},
            MetricName: {}
          }
        },
        S1t: {
          type: "structure",
          required: [
            "Containers",
            "SupportedContentTypes",
            "SupportedResponseMIMETypes"
          ],
          members: {
            Containers: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Image"
                ],
                members: {
                  ContainerHostname: {},
                  Image: {},
                  ImageDigest: {},
                  ModelDataUrl: {},
                  ProductId: {},
                  Environment: {
                    shape: "S1z"
                  }
                }
              }
            },
            SupportedTransformInstanceTypes: {
              type: "list",
              member: {}
            },
            SupportedRealtimeInferenceInstanceTypes: {
              type: "list",
              member: {}
            },
            SupportedContentTypes: {
              shape: "S1k"
            },
            SupportedResponseMIMETypes: {
              type: "list",
              member: {}
            }
          }
        },
        S1z: {
          type: "map",
          key: {},
          value: {}
        },
        S28: {
          type: "structure",
          required: [
            "ValidationRole",
            "ValidationProfiles"
          ],
          members: {
            ValidationRole: {},
            ValidationProfiles: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ProfileName",
                  "TrainingJobDefinition"
                ],
                members: {
                  ProfileName: {},
                  TrainingJobDefinition: {
                    type: "structure",
                    required: [
                      "TrainingInputMode",
                      "InputDataConfig",
                      "OutputDataConfig",
                      "ResourceConfig",
                      "StoppingCondition"
                    ],
                    members: {
                      TrainingInputMode: {},
                      HyperParameters: {
                        shape: "S2d"
                      },
                      InputDataConfig: {
                        shape: "S2f"
                      },
                      OutputDataConfig: {
                        shape: "S2w"
                      },
                      ResourceConfig: {
                        shape: "S2y"
                      },
                      StoppingCondition: {
                        shape: "S31"
                      }
                    }
                  },
                  TransformJobDefinition: {
                    shape: "S34"
                  }
                }
              }
            }
          }
        },
        S2d: {
          type: "map",
          key: {},
          value: {}
        },
        S2f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ChannelName",
              "DataSource"
            ],
            members: {
              ChannelName: {},
              DataSource: {
                type: "structure",
                members: {
                  S3DataSource: {
                    type: "structure",
                    required: [
                      "S3DataType",
                      "S3Uri"
                    ],
                    members: {
                      S3DataType: {},
                      S3Uri: {},
                      S3DataDistributionType: {},
                      AttributeNames: {
                        type: "list",
                        member: {}
                      }
                    }
                  },
                  FileSystemDataSource: {
                    type: "structure",
                    required: [
                      "FileSystemId",
                      "FileSystemAccessMode",
                      "FileSystemType",
                      "DirectoryPath"
                    ],
                    members: {
                      FileSystemId: {},
                      FileSystemAccessMode: {},
                      FileSystemType: {},
                      DirectoryPath: {}
                    }
                  }
                }
              },
              ContentType: {},
              CompressionType: {},
              RecordWrapperType: {},
              InputMode: {},
              ShuffleConfig: {
                type: "structure",
                required: [
                  "Seed"
                ],
                members: {
                  Seed: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S2w: {
          type: "structure",
          required: [
            "S3OutputPath"
          ],
          members: {
            KmsKeyId: {},
            S3OutputPath: {}
          }
        },
        S2y: {
          type: "structure",
          required: [
            "InstanceType",
            "InstanceCount",
            "VolumeSizeInGB"
          ],
          members: {
            InstanceType: {},
            InstanceCount: {
              type: "integer"
            },
            VolumeSizeInGB: {
              type: "integer"
            },
            VolumeKmsKeyId: {}
          }
        },
        S31: {
          type: "structure",
          members: {
            MaxRuntimeInSeconds: {
              type: "integer"
            },
            MaxWaitTimeInSeconds: {
              type: "integer"
            }
          }
        },
        S34: {
          type: "structure",
          required: [
            "TransformInput",
            "TransformOutput",
            "TransformResources"
          ],
          members: {
            MaxConcurrentTransforms: {
              type: "integer"
            },
            MaxPayloadInMB: {
              type: "integer"
            },
            BatchStrategy: {},
            Environment: {
              shape: "S38"
            },
            TransformInput: {
              shape: "S3b"
            },
            TransformOutput: {
              shape: "S3f"
            },
            TransformResources: {
              shape: "S3i"
            }
          }
        },
        S38: {
          type: "map",
          key: {},
          value: {}
        },
        S3b: {
          type: "structure",
          required: [
            "DataSource"
          ],
          members: {
            DataSource: {
              type: "structure",
              required: [
                "S3DataSource"
              ],
              members: {
                S3DataSource: {
                  type: "structure",
                  required: [
                    "S3DataType",
                    "S3Uri"
                  ],
                  members: {
                    S3DataType: {},
                    S3Uri: {}
                  }
                }
              }
            },
            ContentType: {},
            CompressionType: {},
            SplitType: {}
          }
        },
        S3f: {
          type: "structure",
          required: [
            "S3OutputPath"
          ],
          members: {
            S3OutputPath: {},
            Accept: {},
            AssembleWith: {},
            KmsKeyId: {}
          }
        },
        S3i: {
          type: "structure",
          required: [
            "InstanceType",
            "InstanceCount"
          ],
          members: {
            InstanceType: {},
            InstanceCount: {
              type: "integer"
            },
            VolumeKmsKeyId: {}
          }
        },
        S3s: {
          type: "structure",
          members: {
            SageMakerImageArn: {},
            SageMakerImageVersionArn: {},
            InstanceType: {},
            LifecycleConfigArn: {}
          }
        },
        S41: {
          type: "structure",
          required: [
            "KernelSpecs"
          ],
          members: {
            KernelSpecs: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {},
                  DisplayName: {}
                }
              }
            },
            FileSystemConfig: {
              type: "structure",
              members: {
                MountPath: {},
                DefaultUid: {
                  type: "integer"
                },
                DefaultGid: {
                  type: "integer"
                }
              }
            }
          }
        },
        S4d: {
          type: "structure",
          required: [
            "SourceUri"
          ],
          members: {
            SourceUri: {},
            SourceTypes: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "SourceIdType",
                  "Value"
                ],
                members: {
                  SourceIdType: {},
                  Value: {}
                }
              }
            }
          }
        },
        S4l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DataSource",
              "TargetAttributeName"
            ],
            members: {
              DataSource: {
                type: "structure",
                required: [
                  "S3DataSource"
                ],
                members: {
                  S3DataSource: {
                    type: "structure",
                    required: [
                      "S3DataType",
                      "S3Uri"
                    ],
                    members: {
                      S3DataType: {},
                      S3Uri: {}
                    }
                  }
                }
              },
              CompressionType: {},
              TargetAttributeName: {}
            }
          }
        },
        S4r: {
          type: "structure",
          required: [
            "S3OutputPath"
          ],
          members: {
            KmsKeyId: {},
            S3OutputPath: {}
          }
        },
        S4t: {
          type: "structure",
          required: [
            "MetricName"
          ],
          members: {
            MetricName: {}
          }
        },
        S4v: {
          type: "structure",
          members: {
            CompletionCriteria: {
              shape: "S4w"
            },
            SecurityConfig: {
              type: "structure",
              members: {
                VolumeKmsKeyId: {},
                EnableInterContainerTrafficEncryption: {
                  type: "boolean"
                },
                VpcConfig: {
                  shape: "S51"
                }
              }
            }
          }
        },
        S4w: {
          type: "structure",
          members: {
            MaxCandidates: {
              type: "integer"
            },
            MaxRuntimePerTrainingJobInSeconds: {
              type: "integer"
            },
            MaxAutoMLJobRuntimeInSeconds: {
              type: "integer"
            }
          }
        },
        S51: {
          type: "structure",
          required: [
            "SecurityGroupIds",
            "Subnets"
          ],
          members: {
            SecurityGroupIds: {
              type: "list",
              member: {}
            },
            Subnets: {
              shape: "S54"
            }
          }
        },
        S54: {
          type: "list",
          member: {}
        },
        S57: {
          type: "structure",
          members: {
            AutoGenerateEndpointName: {
              type: "boolean"
            },
            EndpointName: {}
          }
        },
        S5d: {
          type: "structure",
          required: [
            "RepositoryUrl"
          ],
          members: {
            RepositoryUrl: {},
            Branch: {},
            SecretArn: {}
          }
        },
        S5k: {
          type: "structure",
          required: [
            "S3Uri",
            "DataInputConfig",
            "Framework"
          ],
          members: {
            S3Uri: {},
            DataInputConfig: {},
            Framework: {},
            FrameworkVersion: {}
          }
        },
        S5o: {
          type: "structure",
          required: [
            "S3OutputLocation"
          ],
          members: {
            S3OutputLocation: {},
            TargetDevice: {},
            TargetPlatform: {
              type: "structure",
              required: [
                "Os",
                "Arch"
              ],
              members: {
                Os: {},
                Arch: {},
                Accelerator: {}
              }
            },
            CompilerOptions: {},
            KmsKeyId: {}
          }
        },
        S5v: {
          type: "structure",
          required: [
            "SecurityGroupIds",
            "Subnets"
          ],
          members: {
            SecurityGroupIds: {
              type: "list",
              member: {}
            },
            Subnets: {
              type: "list",
              member: {}
            }
          }
        },
        S63: {
          type: "structure",
          required: [
            "SourceUri"
          ],
          members: {
            SourceUri: {},
            SourceType: {},
            SourceId: {}
          }
        },
        S68: {
          type: "structure",
          members: {
            BaseliningJobName: {},
            ConstraintsResource: {
              shape: "S6a"
            },
            StatisticsResource: {
              shape: "S6b"
            }
          }
        },
        S6a: {
          type: "structure",
          members: {
            S3Uri: {}
          }
        },
        S6b: {
          type: "structure",
          members: {
            S3Uri: {}
          }
        },
        S6c: {
          type: "structure",
          required: [
            "ImageUri"
          ],
          members: {
            ImageUri: {},
            ContainerEntrypoint: {
              shape: "S6e"
            },
            ContainerArguments: {
              shape: "S6g"
            },
            RecordPreprocessorSourceUri: {},
            PostAnalyticsProcessorSourceUri: {},
            Environment: {
              shape: "S6i"
            }
          }
        },
        S6e: {
          type: "list",
          member: {}
        },
        S6g: {
          type: "list",
          member: {}
        },
        S6i: {
          type: "map",
          key: {},
          value: {}
        },
        S6l: {
          type: "structure",
          required: [
            "EndpointInput"
          ],
          members: {
            EndpointInput: {
              shape: "S6m"
            }
          }
        },
        S6m: {
          type: "structure",
          required: [
            "EndpointName",
            "LocalPath"
          ],
          members: {
            EndpointName: {},
            LocalPath: {},
            S3InputMode: {},
            S3DataDistributionType: {},
            FeaturesAttribute: {},
            InferenceAttribute: {},
            ProbabilityAttribute: {},
            ProbabilityThresholdAttribute: {
              type: "double"
            },
            StartTimeOffset: {},
            EndTimeOffset: {}
          }
        },
        S6t: {
          type: "structure",
          required: [
            "MonitoringOutputs"
          ],
          members: {
            MonitoringOutputs: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "S3Output"
                ],
                members: {
                  S3Output: {
                    type: "structure",
                    required: [
                      "S3Uri",
                      "LocalPath"
                    ],
                    members: {
                      S3Uri: {},
                      LocalPath: {},
                      S3UploadMode: {}
                    }
                  }
                }
              }
            },
            KmsKeyId: {}
          }
        },
        S6z: {
          type: "structure",
          required: [
            "ClusterConfig"
          ],
          members: {
            ClusterConfig: {
              type: "structure",
              required: [
                "InstanceCount",
                "InstanceType",
                "VolumeSizeInGB"
              ],
              members: {
                InstanceCount: {
                  type: "integer"
                },
                InstanceType: {},
                VolumeSizeInGB: {
                  type: "integer"
                },
                VolumeKmsKeyId: {}
              }
            }
          }
        },
        S74: {
          type: "structure",
          members: {
            EnableInterContainerTrafficEncryption: {
              type: "boolean"
            },
            EnableNetworkIsolation: {
              type: "boolean"
            },
            VpcConfig: {
              shape: "S51"
            }
          }
        },
        S75: {
          type: "structure",
          required: [
            "MaxRuntimeInSeconds"
          ],
          members: {
            MaxRuntimeInSeconds: {
              type: "integer"
            }
          }
        },
        S7b: {
          type: "structure",
          required: [
            "S3OutputLocation"
          ],
          members: {
            S3OutputLocation: {},
            KmsKeyId: {},
            PresetDeploymentType: {},
            PresetDeploymentConfig: {}
          }
        },
        S7h: {
          type: "structure",
          members: {
            ExecutionRole: {},
            SecurityGroups: {
              shape: "S7i"
            },
            SharingSettings: {
              type: "structure",
              members: {
                NotebookOutputOption: {},
                S3OutputPath: {},
                S3KmsKeyId: {}
              }
            },
            JupyterServerAppSettings: {
              type: "structure",
              members: {
                DefaultResourceSpec: {
                  shape: "S3s"
                },
                LifecycleConfigArns: {
                  shape: "S7m"
                }
              }
            },
            KernelGatewayAppSettings: {
              type: "structure",
              members: {
                DefaultResourceSpec: {
                  shape: "S3s"
                },
                CustomImages: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "ImageName",
                      "AppImageConfigName"
                    ],
                    members: {
                      ImageName: {},
                      ImageVersionNumber: {
                        type: "integer"
                      },
                      AppImageConfigName: {}
                    }
                  }
                },
                LifecycleConfigArns: {
                  shape: "S7m"
                }
              }
            },
            TensorBoardAppSettings: {
              type: "structure",
              members: {
                DefaultResourceSpec: {
                  shape: "S3s"
                }
              }
            }
          }
        },
        S7i: {
          type: "list",
          member: {}
        },
        S7m: {
          type: "list",
          member: {}
        },
        S85: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "VariantName",
              "ModelName",
              "InitialInstanceCount",
              "InstanceType"
            ],
            members: {
              VariantName: {},
              ModelName: {},
              InitialInstanceCount: {
                type: "integer"
              },
              InstanceType: {},
              InitialVariantWeight: {
                type: "float"
              },
              AcceleratorType: {},
              CoreDumpConfig: {
                type: "structure",
                required: [
                  "DestinationS3Uri"
                ],
                members: {
                  DestinationS3Uri: {},
                  KmsKeyId: {}
                }
              }
            }
          }
        },
        S8e: {
          type: "structure",
          required: [
            "InitialSamplingPercentage",
            "DestinationS3Uri",
            "CaptureOptions"
          ],
          members: {
            EnableCapture: {
              type: "boolean"
            },
            InitialSamplingPercentage: {
              type: "integer"
            },
            DestinationS3Uri: {},
            KmsKeyId: {},
            CaptureOptions: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "CaptureMode"
                ],
                members: {
                  CaptureMode: {}
                }
              }
            },
            CaptureContentTypeHeader: {
              type: "structure",
              members: {
                CsvContentTypes: {
                  type: "list",
                  member: {}
                },
                JsonContentTypes: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        S8p: {
          type: "structure",
          required: [
            "OutputConfig"
          ],
          members: {
            ClientConfig: {
              type: "structure",
              members: {
                MaxConcurrentInvocationsPerInstance: {
                  type: "integer"
                }
              }
            },
            OutputConfig: {
              type: "structure",
              required: [
                "S3OutputPath"
              ],
              members: {
                KmsKeyId: {},
                S3OutputPath: {},
                NotificationConfig: {
                  type: "structure",
                  members: {
                    SuccessTopic: {},
                    ErrorTopic: {}
                  }
                }
              }
            }
          }
        },
        S93: {
          type: "list",
          member: {
            type: "structure",
            members: {
              FeatureName: {},
              FeatureType: {}
            }
          }
        },
        S96: {
          type: "structure",
          members: {
            SecurityConfig: {
              type: "structure",
              members: {
                KmsKeyId: {}
              }
            },
            EnableOnlineStore: {
              type: "boolean"
            }
          }
        },
        S98: {
          type: "structure",
          required: [
            "S3StorageConfig"
          ],
          members: {
            S3StorageConfig: {
              type: "structure",
              required: [
                "S3Uri"
              ],
              members: {
                S3Uri: {},
                KmsKeyId: {},
                ResolvedOutputS3Uri: {}
              }
            },
            DisableGlueTableCreation: {
              type: "boolean"
            },
            DataCatalogConfig: {
              type: "structure",
              required: [
                "TableName",
                "Catalog",
                "Database"
              ],
              members: {
                TableName: {},
                Catalog: {},
                Database: {}
              }
            }
          }
        },
        S9j: {
          type: "structure",
          required: [
            "AwsManagedHumanLoopRequestSource"
          ],
          members: {
            AwsManagedHumanLoopRequestSource: {}
          }
        },
        S9l: {
          type: "structure",
          required: [
            "HumanLoopActivationConditionsConfig"
          ],
          members: {
            HumanLoopActivationConditionsConfig: {
              type: "structure",
              required: [
                "HumanLoopActivationConditions"
              ],
              members: {
                HumanLoopActivationConditions: {
                  jsonvalue: true
                }
              }
            }
          }
        },
        S9o: {
          type: "structure",
          required: [
            "WorkteamArn",
            "HumanTaskUiArn",
            "TaskTitle",
            "TaskDescription",
            "TaskCount"
          ],
          members: {
            WorkteamArn: {},
            HumanTaskUiArn: {},
            TaskTitle: {},
            TaskDescription: {},
            TaskCount: {
              type: "integer"
            },
            TaskAvailabilityLifetimeInSeconds: {
              type: "integer"
            },
            TaskTimeLimitInSeconds: {
              type: "integer"
            },
            TaskKeywords: {
              type: "list",
              member: {}
            },
            PublicWorkforceTaskPrice: {
              shape: "S9y"
            }
          }
        },
        S9y: {
          type: "structure",
          members: {
            AmountInUsd: {
              type: "structure",
              members: {
                Dollars: {
                  type: "integer"
                },
                Cents: {
                  type: "integer"
                },
                TenthFractionsOfACent: {
                  type: "integer"
                }
              }
            }
          }
        },
        Sa3: {
          type: "structure",
          required: [
            "S3OutputPath"
          ],
          members: {
            S3OutputPath: {},
            KmsKeyId: {}
          }
        },
        Sa8: {
          type: "structure",
          required: [
            "Content"
          ],
          members: {
            Content: {}
          }
        },
        Sad: {
          type: "structure",
          required: [
            "Strategy",
            "ResourceLimits"
          ],
          members: {
            Strategy: {},
            HyperParameterTuningJobObjective: {
              shape: "S1r"
            },
            ResourceLimits: {
              shape: "Saf"
            },
            ParameterRanges: {
              shape: "Sai"
            },
            TrainingJobEarlyStoppingType: {},
            TuningJobCompletionCriteria: {
              type: "structure",
              required: [
                "TargetObjectiveMetricValue"
              ],
              members: {
                TargetObjectiveMetricValue: {
                  type: "float"
                }
              }
            }
          }
        },
        Saf: {
          type: "structure",
          required: [
            "MaxNumberOfTrainingJobs",
            "MaxParallelTrainingJobs"
          ],
          members: {
            MaxNumberOfTrainingJobs: {
              type: "integer"
            },
            MaxParallelTrainingJobs: {
              type: "integer"
            }
          }
        },
        Sai: {
          type: "structure",
          members: {
            IntegerParameterRanges: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "MinValue",
                  "MaxValue"
                ],
                members: {
                  Name: {},
                  MinValue: {},
                  MaxValue: {},
                  ScalingType: {}
                }
              }
            },
            ContinuousParameterRanges: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "MinValue",
                  "MaxValue"
                ],
                members: {
                  Name: {},
                  MinValue: {},
                  MaxValue: {},
                  ScalingType: {}
                }
              }
            },
            CategoricalParameterRanges: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "Values"
                ],
                members: {
                  Name: {},
                  Values: {
                    shape: "S18"
                  }
                }
              }
            }
          }
        },
        Sau: {
          type: "structure",
          required: [
            "AlgorithmSpecification",
            "RoleArn",
            "OutputDataConfig",
            "ResourceConfig",
            "StoppingCondition"
          ],
          members: {
            DefinitionName: {},
            TuningObjective: {
              shape: "S1r"
            },
            HyperParameterRanges: {
              shape: "Sai"
            },
            StaticHyperParameters: {
              shape: "S2d"
            },
            AlgorithmSpecification: {
              type: "structure",
              required: [
                "TrainingInputMode"
              ],
              members: {
                TrainingImage: {},
                TrainingInputMode: {},
                AlgorithmName: {},
                MetricDefinitions: {
                  shape: "S1d"
                }
              }
            },
            RoleArn: {},
            InputDataConfig: {
              shape: "S2f"
            },
            VpcConfig: {
              shape: "S51"
            },
            OutputDataConfig: {
              shape: "S2w"
            },
            ResourceConfig: {
              shape: "S2y"
            },
            StoppingCondition: {
              shape: "S31"
            },
            EnableNetworkIsolation: {
              type: "boolean"
            },
            EnableInterContainerTrafficEncryption: {
              type: "boolean"
            },
            EnableManagedSpotTraining: {
              type: "boolean"
            },
            CheckpointConfig: {
              shape: "Saz"
            },
            RetryStrategy: {
              shape: "Sb0"
            }
          }
        },
        Saz: {
          type: "structure",
          required: [
            "S3Uri"
          ],
          members: {
            S3Uri: {},
            LocalPath: {}
          }
        },
        Sb0: {
          type: "structure",
          required: [
            "MaximumRetryAttempts"
          ],
          members: {
            MaximumRetryAttempts: {
              type: "integer"
            }
          }
        },
        Sb2: {
          type: "list",
          member: {
            shape: "Sau"
          }
        },
        Sb3: {
          type: "structure",
          required: [
            "ParentHyperParameterTuningJobs",
            "WarmStartType"
          ],
          members: {
            ParentHyperParameterTuningJobs: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  HyperParameterTuningJobName: {}
                }
              }
            },
            WarmStartType: {}
          }
        },
        Sbk: {
          type: "structure",
          required: [
            "DataSource"
          ],
          members: {
            DataSource: {
              type: "structure",
              members: {
                S3DataSource: {
                  type: "structure",
                  required: [
                    "ManifestS3Uri"
                  ],
                  members: {
                    ManifestS3Uri: {}
                  }
                },
                SnsDataSource: {
                  type: "structure",
                  required: [
                    "SnsTopicArn"
                  ],
                  members: {
                    SnsTopicArn: {}
                  }
                }
              }
            },
            DataAttributes: {
              type: "structure",
              members: {
                ContentClassifiers: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        Sbr: {
          type: "structure",
          required: [
            "S3OutputPath"
          ],
          members: {
            S3OutputPath: {},
            KmsKeyId: {},
            SnsTopicArn: {}
          }
        },
        Sbs: {
          type: "structure",
          members: {
            MaxHumanLabeledObjectCount: {
              type: "integer"
            },
            MaxPercentageOfInputDatasetLabeled: {
              type: "integer"
            }
          }
        },
        Sbv: {
          type: "structure",
          required: [
            "LabelingJobAlgorithmSpecificationArn"
          ],
          members: {
            LabelingJobAlgorithmSpecificationArn: {},
            InitialActiveLearningModelArn: {},
            LabelingJobResourceConfig: {
              type: "structure",
              members: {
                VolumeKmsKeyId: {}
              }
            }
          }
        },
        Sbz: {
          type: "structure",
          required: [
            "WorkteamArn",
            "UiConfig",
            "PreHumanTaskLambdaArn",
            "TaskTitle",
            "TaskDescription",
            "NumberOfHumanWorkersPerDataObject",
            "TaskTimeLimitInSeconds",
            "AnnotationConsolidationConfig"
          ],
          members: {
            WorkteamArn: {},
            UiConfig: {
              type: "structure",
              members: {
                UiTemplateS3Uri: {},
                HumanTaskUiArn: {}
              }
            },
            PreHumanTaskLambdaArn: {},
            TaskKeywords: {
              type: "list",
              member: {}
            },
            TaskTitle: {},
            TaskDescription: {},
            NumberOfHumanWorkersPerDataObject: {
              type: "integer"
            },
            TaskTimeLimitInSeconds: {
              type: "integer"
            },
            TaskAvailabilityLifetimeInSeconds: {
              type: "integer"
            },
            MaxConcurrentTaskCount: {
              type: "integer"
            },
            AnnotationConsolidationConfig: {
              type: "structure",
              required: [
                "AnnotationConsolidationLambdaArn"
              ],
              members: {
                AnnotationConsolidationLambdaArn: {}
              }
            },
            PublicWorkforceTaskPrice: {
              shape: "S9y"
            }
          }
        },
        Sce: {
          type: "structure",
          members: {
            ContainerHostname: {},
            Image: {},
            ImageConfig: {
              type: "structure",
              required: [
                "RepositoryAccessMode"
              ],
              members: {
                RepositoryAccessMode: {},
                RepositoryAuthConfig: {
                  type: "structure",
                  required: [
                    "RepositoryCredentialsProviderArn"
                  ],
                  members: {
                    RepositoryCredentialsProviderArn: {}
                  }
                }
              }
            },
            Mode: {},
            ModelDataUrl: {},
            Environment: {
              shape: "S1z"
            },
            ModelPackageName: {},
            MultiModelConfig: {
              type: "structure",
              members: {
                ModelCacheSetting: {}
              }
            }
          }
        },
        Scn: {
          type: "list",
          member: {
            shape: "Sce"
          }
        },
        Sco: {
          type: "structure",
          required: [
            "Mode"
          ],
          members: {
            Mode: {}
          }
        },
        Scs: {
          type: "structure",
          members: {
            BaseliningJobName: {},
            ConstraintsResource: {
              shape: "S6a"
            }
          }
        },
        Sct: {
          type: "structure",
          required: [
            "ImageUri",
            "ConfigUri"
          ],
          members: {
            ImageUri: {},
            ConfigUri: {},
            Environment: {
              shape: "S6i"
            }
          }
        },
        Scu: {
          type: "structure",
          required: [
            "EndpointInput",
            "GroundTruthS3Input"
          ],
          members: {
            EndpointInput: {
              shape: "S6m"
            },
            GroundTruthS3Input: {
              shape: "Scv"
            }
          }
        },
        Scv: {
          type: "structure",
          members: {
            S3Uri: {}
          }
        },
        Scy: {
          type: "structure",
          members: {
            BaseliningJobName: {},
            ConstraintsResource: {
              shape: "S6a"
            }
          }
        },
        Scz: {
          type: "structure",
          required: [
            "ImageUri",
            "ConfigUri"
          ],
          members: {
            ImageUri: {},
            ConfigUri: {},
            Environment: {
              shape: "S6i"
            }
          }
        },
        Sd0: {
          type: "structure",
          required: [
            "EndpointInput"
          ],
          members: {
            EndpointInput: {
              shape: "S6m"
            }
          }
        },
        Sd3: {
          type: "structure",
          required: [
            "ValidationRole",
            "ValidationProfiles"
          ],
          members: {
            ValidationRole: {},
            ValidationProfiles: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ProfileName",
                  "TransformJobDefinition"
                ],
                members: {
                  ProfileName: {},
                  TransformJobDefinition: {
                    shape: "S34"
                  }
                }
              }
            }
          }
        },
        Sd6: {
          type: "structure",
          required: [
            "SourceAlgorithms"
          ],
          members: {
            SourceAlgorithms: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "AlgorithmName"
                ],
                members: {
                  ModelDataUrl: {},
                  AlgorithmName: {}
                }
              }
            }
          }
        },
        Sda: {
          type: "structure",
          members: {
            ModelQuality: {
              type: "structure",
              members: {
                Statistics: {
                  shape: "Sdc"
                },
                Constraints: {
                  shape: "Sdc"
                }
              }
            },
            ModelDataQuality: {
              type: "structure",
              members: {
                Statistics: {
                  shape: "Sdc"
                },
                Constraints: {
                  shape: "Sdc"
                }
              }
            },
            Bias: {
              type: "structure",
              members: {
                Report: {
                  shape: "Sdc"
                }
              }
            },
            Explainability: {
              type: "structure",
              members: {
                Report: {
                  shape: "Sdc"
                }
              }
            }
          }
        },
        Sdc: {
          type: "structure",
          required: [
            "ContentType",
            "S3Uri"
          ],
          members: {
            ContentType: {},
            ContentDigest: {},
            S3Uri: {}
          }
        },
        Sdn: {
          type: "structure",
          members: {
            BaseliningJobName: {},
            ConstraintsResource: {
              shape: "S6a"
            }
          }
        },
        Sdo: {
          type: "structure",
          required: [
            "ImageUri"
          ],
          members: {
            ImageUri: {},
            ContainerEntrypoint: {
              shape: "S6e"
            },
            ContainerArguments: {
              shape: "S6g"
            },
            RecordPreprocessorSourceUri: {},
            PostAnalyticsProcessorSourceUri: {},
            ProblemType: {},
            Environment: {
              shape: "S6i"
            }
          }
        },
        Sdq: {
          type: "structure",
          required: [
            "EndpointInput",
            "GroundTruthS3Input"
          ],
          members: {
            EndpointInput: {
              shape: "S6m"
            },
            GroundTruthS3Input: {
              shape: "Scv"
            }
          }
        },
        Sdu: {
          type: "structure",
          members: {
            ScheduleConfig: {
              type: "structure",
              required: [
                "ScheduleExpression"
              ],
              members: {
                ScheduleExpression: {}
              }
            },
            MonitoringJobDefinition: {
              type: "structure",
              required: [
                "MonitoringInputs",
                "MonitoringOutputConfig",
                "MonitoringResources",
                "MonitoringAppSpecification",
                "RoleArn"
              ],
              members: {
                BaselineConfig: {
                  type: "structure",
                  members: {
                    BaseliningJobName: {},
                    ConstraintsResource: {
                      shape: "S6a"
                    },
                    StatisticsResource: {
                      shape: "S6b"
                    }
                  }
                },
                MonitoringInputs: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "EndpointInput"
                    ],
                    members: {
                      EndpointInput: {
                        shape: "S6m"
                      }
                    }
                  }
                },
                MonitoringOutputConfig: {
                  shape: "S6t"
                },
                MonitoringResources: {
                  shape: "S6z"
                },
                MonitoringAppSpecification: {
                  type: "structure",
                  required: [
                    "ImageUri"
                  ],
                  members: {
                    ImageUri: {},
                    ContainerEntrypoint: {
                      shape: "S6e"
                    },
                    ContainerArguments: {
                      shape: "S6g"
                    },
                    RecordPreprocessorSourceUri: {},
                    PostAnalyticsProcessorSourceUri: {}
                  }
                },
                StoppingCondition: {
                  shape: "S75"
                },
                Environment: {
                  shape: "S6i"
                },
                NetworkConfig: {
                  shape: "Se2"
                },
                RoleArn: {}
              }
            },
            MonitoringJobDefinitionName: {},
            MonitoringType: {}
          }
        },
        Se2: {
          type: "structure",
          members: {
            EnableInterContainerTrafficEncryption: {
              type: "boolean"
            },
            EnableNetworkIsolation: {
              type: "boolean"
            },
            VpcConfig: {
              shape: "S51"
            }
          }
        },
        Sec: {
          type: "list",
          member: {}
        },
        Sef: {
          type: "list",
          member: {}
        },
        Sel: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Content: {}
            }
          }
        },
        Sf6: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "InputName"
            ],
            members: {
              InputName: {},
              AppManaged: {
                type: "boolean"
              },
              S3Input: {
                type: "structure",
                required: [
                  "S3Uri",
                  "S3DataType"
                ],
                members: {
                  S3Uri: {},
                  LocalPath: {},
                  S3DataType: {},
                  S3InputMode: {},
                  S3DataDistributionType: {},
                  S3CompressionType: {}
                }
              },
              DatasetDefinition: {
                type: "structure",
                members: {
                  AthenaDatasetDefinition: {
                    type: "structure",
                    required: [
                      "Catalog",
                      "Database",
                      "QueryString",
                      "OutputS3Uri",
                      "OutputFormat"
                    ],
                    members: {
                      Catalog: {},
                      Database: {},
                      QueryString: {},
                      WorkGroup: {},
                      OutputS3Uri: {},
                      KmsKeyId: {},
                      OutputFormat: {},
                      OutputCompression: {}
                    }
                  },
                  RedshiftDatasetDefinition: {
                    type: "structure",
                    required: [
                      "ClusterId",
                      "Database",
                      "DbUser",
                      "QueryString",
                      "ClusterRoleArn",
                      "OutputS3Uri",
                      "OutputFormat"
                    ],
                    members: {
                      ClusterId: {},
                      Database: {},
                      DbUser: {},
                      QueryString: {},
                      ClusterRoleArn: {},
                      OutputS3Uri: {},
                      KmsKeyId: {},
                      OutputFormat: {},
                      OutputCompression: {}
                    }
                  },
                  LocalPath: {},
                  DataDistributionType: {},
                  InputMode: {}
                }
              }
            }
          }
        },
        Sft: {
          type: "structure",
          required: [
            "Outputs"
          ],
          members: {
            Outputs: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "OutputName"
                ],
                members: {
                  OutputName: {},
                  S3Output: {
                    type: "structure",
                    required: [
                      "S3Uri",
                      "LocalPath",
                      "S3UploadMode"
                    ],
                    members: {
                      S3Uri: {},
                      LocalPath: {},
                      S3UploadMode: {}
                    }
                  },
                  FeatureStoreOutput: {
                    type: "structure",
                    required: [
                      "FeatureGroupName"
                    ],
                    members: {
                      FeatureGroupName: {}
                    }
                  },
                  AppManaged: {
                    type: "boolean"
                  }
                }
              }
            },
            KmsKeyId: {}
          }
        },
        Sfy: {
          type: "structure",
          required: [
            "ClusterConfig"
          ],
          members: {
            ClusterConfig: {
              type: "structure",
              required: [
                "InstanceCount",
                "InstanceType",
                "VolumeSizeInGB"
              ],
              members: {
                InstanceCount: {
                  type: "integer"
                },
                InstanceType: {},
                VolumeSizeInGB: {
                  type: "integer"
                },
                VolumeKmsKeyId: {}
              }
            }
          }
        },
        Sg0: {
          type: "structure",
          required: [
            "MaxRuntimeInSeconds"
          ],
          members: {
            MaxRuntimeInSeconds: {
              type: "integer"
            }
          }
        },
        Sg2: {
          type: "structure",
          required: [
            "ImageUri"
          ],
          members: {
            ImageUri: {},
            ContainerEntrypoint: {
              shape: "S6e"
            },
            ContainerArguments: {
              type: "list",
              member: {}
            }
          }
        },
        Sg4: {
          type: "map",
          key: {},
          value: {}
        },
        Sg5: {
          type: "structure",
          members: {
            ExperimentName: {},
            TrialName: {},
            TrialComponentDisplayName: {}
          }
        },
        Sga: {
          type: "structure",
          required: [
            "ProductId"
          ],
          members: {
            ProductId: {},
            ProvisioningArtifactId: {},
            PathId: {},
            ProvisioningParameters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {}
                }
              }
            }
          }
        },
        Sgq: {
          type: "structure",
          required: [
            "TrainingInputMode"
          ],
          members: {
            TrainingImage: {},
            AlgorithmName: {},
            TrainingInputMode: {},
            MetricDefinitions: {
              shape: "S1d"
            },
            EnableSageMakerMetricsTimeSeries: {
              type: "boolean"
            }
          }
        },
        Sgr: {
          type: "structure",
          required: [
            "S3OutputPath"
          ],
          members: {
            LocalPath: {},
            S3OutputPath: {},
            HookParameters: {
              type: "map",
              key: {},
              value: {}
            },
            CollectionConfigurations: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  CollectionName: {},
                  CollectionParameters: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            }
          }
        },
        Sgz: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "RuleConfigurationName",
              "RuleEvaluatorImage"
            ],
            members: {
              RuleConfigurationName: {},
              LocalPath: {},
              S3OutputPath: {},
              RuleEvaluatorImage: {},
              InstanceType: {},
              VolumeSizeInGB: {
                type: "integer"
              },
              RuleParameters: {
                shape: "Sh3"
              }
            }
          }
        },
        Sh3: {
          type: "map",
          key: {},
          value: {}
        },
        Sh4: {
          type: "structure",
          required: [
            "S3OutputPath"
          ],
          members: {
            LocalPath: {},
            S3OutputPath: {}
          }
        },
        Sh5: {
          type: "structure",
          required: [
            "S3OutputPath"
          ],
          members: {
            S3OutputPath: {},
            ProfilingIntervalInMilliseconds: {
              type: "long"
            },
            ProfilingParameters: {
              shape: "Sh7"
            }
          }
        },
        Sh7: {
          type: "map",
          key: {},
          value: {}
        },
        Sh8: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "RuleConfigurationName",
              "RuleEvaluatorImage"
            ],
            members: {
              RuleConfigurationName: {},
              LocalPath: {},
              S3OutputPath: {},
              RuleEvaluatorImage: {},
              InstanceType: {},
              VolumeSizeInGB: {
                type: "integer"
              },
              RuleParameters: {
                shape: "Sh3"
              }
            }
          }
        },
        Sha: {
          type: "map",
          key: {},
          value: {}
        },
        Shh: {
          type: "structure",
          members: {
            InvocationsTimeoutInSeconds: {
              type: "integer"
            },
            InvocationsMaxRetries: {
              type: "integer"
            }
          }
        },
        Shk: {
          type: "structure",
          members: {
            InputFilter: {},
            OutputFilter: {},
            JoinSource: {}
          }
        },
        Shs: {
          type: "structure",
          members: {
            PrimaryStatus: {},
            Message: {}
          }
        },
        Shw: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              StringValue: {},
              NumberValue: {
                type: "double"
              }
            }
          }
        },
        Si0: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "Value"
            ],
            members: {
              MediaType: {},
              Value: {}
            }
          }
        },
        Sib: {
          type: "structure",
          required: [
            "UserPool",
            "ClientId"
          ],
          members: {
            UserPool: {},
            ClientId: {}
          }
        },
        Sie: {
          type: "structure",
          required: [
            "ClientId",
            "ClientSecret",
            "Issuer",
            "AuthorizationEndpoint",
            "TokenEndpoint",
            "UserInfoEndpoint",
            "LogoutEndpoint",
            "JwksUri"
          ],
          members: {
            ClientId: {},
            ClientSecret: {
              type: "string",
              sensitive: true
            },
            Issuer: {},
            AuthorizationEndpoint: {},
            TokenEndpoint: {},
            UserInfoEndpoint: {},
            LogoutEndpoint: {},
            JwksUri: {}
          }
        },
        Sih: {
          type: "structure",
          required: [
            "Cidrs"
          ],
          members: {
            Cidrs: {
              type: "list",
              member: {}
            }
          }
        },
        Sip: {
          type: "list",
          member: {
            type: "structure",
            members: {
              CognitoMemberDefinition: {
                type: "structure",
                required: [
                  "UserPool",
                  "UserGroup",
                  "ClientId"
                ],
                members: {
                  UserPool: {},
                  UserGroup: {},
                  ClientId: {}
                }
              },
              OidcMemberDefinition: {
                type: "structure",
                required: [
                  "Groups"
                ],
                members: {
                  Groups: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        Six: {
          type: "structure",
          members: {
            NotificationTopicArn: {}
          }
        },
        Skq: {
          type: "structure",
          members: {
            UserProfileArn: {},
            UserProfileName: {},
            DomainId: {}
          }
        },
        Skw: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Status"
            ],
            members: {
              Name: {},
              Status: {},
              FailureReason: {}
            }
          }
        },
        Sla: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PartialFailureMessage: {}
            }
          }
        },
        Slc: {
          type: "structure",
          required: [
            "CandidateName",
            "ObjectiveStatus",
            "CandidateSteps",
            "CandidateStatus",
            "CreationTime",
            "LastModifiedTime"
          ],
          members: {
            CandidateName: {},
            FinalAutoMLJobObjectiveMetric: {
              type: "structure",
              required: [
                "MetricName",
                "Value"
              ],
              members: {
                Type: {},
                MetricName: {},
                Value: {
                  type: "float"
                }
              }
            },
            ObjectiveStatus: {},
            CandidateSteps: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "CandidateStepType",
                  "CandidateStepArn",
                  "CandidateStepName"
                ],
                members: {
                  CandidateStepType: {},
                  CandidateStepArn: {},
                  CandidateStepName: {}
                }
              }
            },
            CandidateStatus: {},
            InferenceContainers: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Image",
                  "ModelDataUrl"
                ],
                members: {
                  Image: {},
                  ModelDataUrl: {},
                  Environment: {
                    shape: "S1z"
                  }
                }
              }
            },
            CreationTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            LastModifiedTime: {
              type: "timestamp"
            },
            FailureReason: {},
            CandidateProperties: {
              type: "structure",
              members: {
                CandidateArtifactLocations: {
                  type: "structure",
                  required: [
                    "Explainability"
                  ],
                  members: {
                    Explainability: {}
                  }
                },
                CandidateMetrics: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      MetricName: {},
                      Value: {
                        type: "float"
                      },
                      Set: {}
                    }
                  }
                }
              }
            }
          }
        },
        Smb: {
          type: "structure",
          required: [
            "S3ModelArtifacts"
          ],
          members: {
            S3ModelArtifacts: {}
          }
        },
        Sn8: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "VariantName"
            ],
            members: {
              VariantName: {},
              DeployedImages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SpecifiedImage: {},
                    ResolvedImage: {},
                    ResolutionTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              CurrentWeight: {
                type: "float"
              },
              DesiredWeight: {
                type: "float"
              },
              CurrentInstanceCount: {
                type: "integer"
              },
              DesiredInstanceCount: {
                type: "integer"
              }
            }
          }
        },
        Snd: {
          type: "structure",
          required: [
            "EnableCapture",
            "CaptureStatus",
            "CurrentSamplingPercentage",
            "DestinationS3Uri",
            "KmsKeyId"
          ],
          members: {
            EnableCapture: {
              type: "boolean"
            },
            CaptureStatus: {},
            CurrentSamplingPercentage: {
              type: "integer"
            },
            DestinationS3Uri: {},
            KmsKeyId: {}
          }
        },
        Sng: {
          type: "structure",
          required: [
            "BlueGreenUpdatePolicy"
          ],
          members: {
            BlueGreenUpdatePolicy: {
              type: "structure",
              required: [
                "TrafficRoutingConfiguration"
              ],
              members: {
                TrafficRoutingConfiguration: {
                  type: "structure",
                  required: [
                    "Type",
                    "WaitIntervalInSeconds"
                  ],
                  members: {
                    Type: {},
                    WaitIntervalInSeconds: {
                      type: "integer"
                    },
                    CanarySize: {
                      type: "structure",
                      required: [
                        "Type",
                        "Value"
                      ],
                      members: {
                        Type: {},
                        Value: {
                          type: "integer"
                        }
                      }
                    }
                  }
                },
                TerminationWaitInSeconds: {
                  type: "integer"
                },
                MaximumExecutionTimeoutInSeconds: {
                  type: "integer"
                }
              }
            },
            AutoRollbackConfiguration: {
              type: "structure",
              members: {
                Alarms: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      AlarmName: {}
                    }
                  }
                }
              }
            }
          }
        },
        Sny: {
          type: "structure",
          required: [
            "SourceArn"
          ],
          members: {
            SourceArn: {},
            SourceType: {}
          }
        },
        So4: {
          type: "structure",
          required: [
            "Status"
          ],
          members: {
            Status: {},
            BlockedReason: {}
          }
        },
        Soj: {
          type: "structure",
          members: {
            Completed: {
              type: "integer"
            },
            InProgress: {
              type: "integer"
            },
            RetryableError: {
              type: "integer"
            },
            NonRetryableError: {
              type: "integer"
            },
            Stopped: {
              type: "integer"
            }
          }
        },
        Sol: {
          type: "structure",
          members: {
            Succeeded: {
              type: "integer"
            },
            Pending: {
              type: "integer"
            },
            Failed: {
              type: "integer"
            }
          }
        },
        Son: {
          type: "structure",
          required: [
            "TrainingJobName",
            "TrainingJobArn",
            "CreationTime",
            "TrainingJobStatus",
            "TunedHyperParameters"
          ],
          members: {
            TrainingJobDefinitionName: {},
            TrainingJobName: {},
            TrainingJobArn: {},
            TuningJobName: {},
            CreationTime: {
              type: "timestamp"
            },
            TrainingStartTime: {
              type: "timestamp"
            },
            TrainingEndTime: {
              type: "timestamp"
            },
            TrainingJobStatus: {},
            TunedHyperParameters: {
              shape: "S2d"
            },
            FailureReason: {},
            FinalHyperParameterTuningJobObjectiveMetric: {
              type: "structure",
              required: [
                "MetricName",
                "Value"
              ],
              members: {
                Type: {},
                MetricName: {},
                Value: {
                  type: "float"
                }
              }
            },
            ObjectiveStatus: {}
          }
        },
        Sp0: {
          type: "structure",
          members: {
            TotalLabeled: {
              type: "integer"
            },
            HumanLabeled: {
              type: "integer"
            },
            MachineLabeled: {
              type: "integer"
            },
            FailedNonRetryableError: {
              type: "integer"
            },
            Unlabeled: {
              type: "integer"
            }
          }
        },
        Sp3: {
          type: "structure",
          required: [
            "OutputDatasetS3Uri"
          ],
          members: {
            OutputDatasetS3Uri: {},
            FinalActiveLearningModelArn: {}
          }
        },
        Spe: {
          type: "structure",
          required: [
            "ValidationStatuses"
          ],
          members: {
            ValidationStatuses: {
              shape: "Spf"
            },
            ImageScanStatuses: {
              shape: "Spf"
            }
          }
        },
        Spf: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Status"
            ],
            members: {
              Name: {},
              Status: {},
              FailureReason: {}
            }
          }
        },
        Spr: {
          type: "structure",
          required: [
            "MonitoringScheduleName",
            "ScheduledTime",
            "CreationTime",
            "LastModifiedTime",
            "MonitoringExecutionStatus"
          ],
          members: {
            MonitoringScheduleName: {},
            ScheduledTime: {
              type: "timestamp"
            },
            CreationTime: {
              type: "timestamp"
            },
            LastModifiedTime: {
              type: "timestamp"
            },
            MonitoringExecutionStatus: {},
            ProcessingJobArn: {},
            EndpointName: {},
            FailureReason: {},
            MonitoringJobDefinitionName: {},
            MonitoringType: {}
          }
        },
        Sqa: {
          type: "structure",
          members: {
            ExperimentName: {},
            TrialName: {}
          }
        },
        Sqi: {
          type: "structure",
          members: {
            ProvisionedProductId: {},
            ProvisionedProductStatusMessage: {}
          }
        },
        Sqp: {
          type: "structure",
          required: [
            "WorkteamArn"
          ],
          members: {
            WorkteamArn: {},
            MarketplaceTitle: {},
            SellerName: {},
            MarketplaceDescription: {},
            ListingId: {}
          }
        },
        Sqt: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Status",
              "StartTime"
            ],
            members: {
              Status: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              StatusMessage: {}
            }
          }
        },
        Sqw: {
          type: "list",
          member: {
            type: "structure",
            members: {
              MetricName: {},
              Value: {
                type: "float"
              },
              Timestamp: {
                type: "timestamp"
              }
            }
          }
        },
        Sr0: {
          type: "list",
          member: {
            type: "structure",
            members: {
              RuleConfigurationName: {},
              RuleEvaluationJobArn: {},
              RuleEvaluationStatus: {},
              StatusDetails: {},
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        Src: {
          type: "structure",
          required: [
            "SourceArn"
          ],
          members: {
            SourceArn: {},
            SourceType: {}
          }
        },
        Srg: {
          type: "structure",
          required: [
            "SourceArn"
          ],
          members: {
            SourceArn: {},
            SourceType: {}
          }
        },
        Sri: {
          type: "list",
          member: {
            type: "structure",
            members: {
              MetricName: {},
              SourceArn: {},
              TimeStamp: {
                type: "timestamp"
              },
              Max: {
                type: "double"
              },
              Min: {
                type: "double"
              },
              Last: {
                type: "double"
              },
              Count: {
                type: "integer"
              },
              Avg: {
                type: "double"
              },
              StdDev: {
                type: "double"
              }
            }
          }
        },
        Srs: {
          type: "structure",
          required: [
            "WorkforceName",
            "WorkforceArn"
          ],
          members: {
            WorkforceName: {},
            WorkforceArn: {},
            LastUpdatedDate: {
              type: "timestamp"
            },
            SourceIpConfig: {
              shape: "Sih"
            },
            SubDomain: {},
            CognitoConfig: {
              shape: "Sib"
            },
            OidcConfig: {
              type: "structure",
              members: {
                ClientId: {},
                Issuer: {},
                AuthorizationEndpoint: {},
                TokenEndpoint: {},
                UserInfoEndpoint: {},
                LogoutEndpoint: {},
                JwksUri: {}
              }
            },
            CreateDate: {
              type: "timestamp"
            }
          }
        },
        Srw: {
          type: "structure",
          required: [
            "WorkteamName",
            "MemberDefinitions",
            "WorkteamArn",
            "Description"
          ],
          members: {
            WorkteamName: {},
            MemberDefinitions: {
              shape: "Sip"
            },
            WorkteamArn: {},
            WorkforceArn: {},
            ProductListingIds: {
              type: "list",
              member: {}
            },
            Description: {},
            SubDomain: {},
            CreateDate: {
              type: "timestamp"
            },
            LastUpdatedDate: {
              type: "timestamp"
            },
            NotificationConfiguration: {
              shape: "Six"
            }
          }
        },
        Sum: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "MonitoringJobDefinitionName",
              "MonitoringJobDefinitionArn",
              "CreationTime",
              "EndpointName"
            ],
            members: {
              MonitoringJobDefinitionName: {},
              MonitoringJobDefinitionArn: {},
              CreationTime: {
                type: "timestamp"
              },
              EndpointName: {}
            }
          }
        },
        Syw: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        Sz6: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        S111: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DeviceName"
            ],
            members: {
              DeviceName: {},
              Description: {},
              IotThingName: {}
            }
          }
        },
        S11c: {
          type: "structure",
          members: {
            Filters: {
              shape: "S11d"
            },
            NestedFilters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "NestedPropertyName",
                  "Filters"
                ],
                members: {
                  NestedPropertyName: {},
                  Filters: {
                    shape: "S11d"
                  }
                }
              }
            },
            SubExpressions: {
              type: "list",
              member: {
                shape: "S11c"
              }
            },
            Operator: {}
          }
        },
        S11d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Operator: {},
              Value: {}
            }
          }
        },
        S11p: {
          type: "structure",
          members: {
            TrainingJobName: {},
            TrainingJobArn: {},
            TuningJobArn: {},
            LabelingJobArn: {},
            AutoMLJobArn: {},
            ModelArtifacts: {
              shape: "Smb"
            },
            TrainingJobStatus: {},
            SecondaryStatus: {},
            FailureReason: {},
            HyperParameters: {
              shape: "S2d"
            },
            AlgorithmSpecification: {
              shape: "Sgq"
            },
            RoleArn: {},
            InputDataConfig: {
              shape: "S2f"
            },
            OutputDataConfig: {
              shape: "S2w"
            },
            ResourceConfig: {
              shape: "S2y"
            },
            VpcConfig: {
              shape: "S51"
            },
            StoppingCondition: {
              shape: "S31"
            },
            CreationTime: {
              type: "timestamp"
            },
            TrainingStartTime: {
              type: "timestamp"
            },
            TrainingEndTime: {
              type: "timestamp"
            },
            LastModifiedTime: {
              type: "timestamp"
            },
            SecondaryStatusTransitions: {
              shape: "Sqt"
            },
            FinalMetricDataList: {
              shape: "Sqw"
            },
            EnableNetworkIsolation: {
              type: "boolean"
            },
            EnableInterContainerTrafficEncryption: {
              type: "boolean"
            },
            EnableManagedSpotTraining: {
              type: "boolean"
            },
            CheckpointConfig: {
              shape: "Saz"
            },
            TrainingTimeInSeconds: {
              type: "integer"
            },
            BillableTimeInSeconds: {
              type: "integer"
            },
            DebugHookConfig: {
              shape: "Sgr"
            },
            ExperimentConfig: {
              shape: "Sg5"
            },
            DebugRuleConfigurations: {
              shape: "Sgz"
            },
            TensorBoardOutputConfig: {
              shape: "Sh4"
            },
            DebugRuleEvaluationStatuses: {
              shape: "Sr0"
            },
            Environment: {
              shape: "Sha"
            },
            RetryStrategy: {
              shape: "Sb0"
            },
            Tags: {
              shape: "S7"
            }
          }
        },
        S12u: {
          type: "list",
          member: {}
        },
        S14b: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sagemaker-2017-07-24.paginators.json
var require_sagemaker_2017_07_24_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-2017-07-24.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListActions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ActionSummaries"
        },
        ListAlgorithms: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AlgorithmSummaryList"
        },
        ListAppImageConfigs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AppImageConfigs"
        },
        ListApps: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Apps"
        },
        ListArtifacts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ArtifactSummaries"
        },
        ListAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AssociationSummaries"
        },
        ListAutoMLJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AutoMLJobSummaries"
        },
        ListCandidatesForAutoMLJob: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Candidates"
        },
        ListCodeRepositories: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "CodeRepositorySummaryList"
        },
        ListCompilationJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "CompilationJobSummaries"
        },
        ListContexts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ContextSummaries"
        },
        ListDataQualityJobDefinitions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "JobDefinitionSummaries"
        },
        ListDeviceFleets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DeviceFleetSummaries"
        },
        ListDevices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DeviceSummaries"
        },
        ListDomains: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Domains"
        },
        ListEdgePackagingJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "EdgePackagingJobSummaries"
        },
        ListEndpointConfigs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "EndpointConfigs"
        },
        ListEndpoints: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Endpoints"
        },
        ListExperiments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ExperimentSummaries"
        },
        ListFeatureGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FeatureGroupSummaries"
        },
        ListFlowDefinitions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FlowDefinitionSummaries"
        },
        ListHumanTaskUis: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "HumanTaskUiSummaries"
        },
        ListHyperParameterTuningJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "HyperParameterTuningJobSummaries"
        },
        ListImageVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ImageVersions"
        },
        ListImages: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Images"
        },
        ListLabelingJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "LabelingJobSummaryList"
        },
        ListLabelingJobsForWorkteam: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "LabelingJobSummaryList"
        },
        ListModelBiasJobDefinitions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "JobDefinitionSummaries"
        },
        ListModelExplainabilityJobDefinitions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "JobDefinitionSummaries"
        },
        ListModelPackageGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ModelPackageGroupSummaryList"
        },
        ListModelPackages: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ModelPackageSummaryList"
        },
        ListModelQualityJobDefinitions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "JobDefinitionSummaries"
        },
        ListModels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Models"
        },
        ListMonitoringExecutions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "MonitoringExecutionSummaries"
        },
        ListMonitoringSchedules: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "MonitoringScheduleSummaries"
        },
        ListNotebookInstanceLifecycleConfigs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "NotebookInstanceLifecycleConfigs"
        },
        ListNotebookInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "NotebookInstances"
        },
        ListPipelineExecutionSteps: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "PipelineExecutionSteps"
        },
        ListPipelineExecutions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "PipelineExecutionSummaries"
        },
        ListPipelineParametersForExecution: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "PipelineParameters"
        },
        ListPipelines: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "PipelineSummaries"
        },
        ListProcessingJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ProcessingJobSummaries"
        },
        ListProjects: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListStudioLifecycleConfigs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "StudioLifecycleConfigs"
        },
        ListSubscribedWorkteams: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "SubscribedWorkteams"
        },
        ListTags: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Tags"
        },
        ListTrainingJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TrainingJobSummaries"
        },
        ListTrainingJobsForHyperParameterTuningJob: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TrainingJobSummaries"
        },
        ListTransformJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TransformJobSummaries"
        },
        ListTrialComponents: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TrialComponentSummaries"
        },
        ListTrials: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TrialSummaries"
        },
        ListUserProfiles: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "UserProfiles"
        },
        ListWorkforces: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Workforces"
        },
        ListWorkteams: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Workteams"
        },
        Search: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Results"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sagemaker-2017-07-24.waiters2.json
var require_sagemaker_2017_07_24_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-2017-07-24.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        NotebookInstanceInService: {
          delay: 30,
          maxAttempts: 60,
          operation: "DescribeNotebookInstance",
          acceptors: [
            {
              expected: "InService",
              matcher: "path",
              state: "success",
              argument: "NotebookInstanceStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "NotebookInstanceStatus"
            }
          ]
        },
        NotebookInstanceStopped: {
          delay: 30,
          operation: "DescribeNotebookInstance",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "Stopped",
              matcher: "path",
              state: "success",
              argument: "NotebookInstanceStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "NotebookInstanceStatus"
            }
          ]
        },
        NotebookInstanceDeleted: {
          delay: 30,
          maxAttempts: 60,
          operation: "DescribeNotebookInstance",
          acceptors: [
            {
              expected: "ValidationException",
              matcher: "error",
              state: "success"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "NotebookInstanceStatus"
            }
          ]
        },
        TrainingJobCompletedOrStopped: {
          delay: 120,
          maxAttempts: 180,
          operation: "DescribeTrainingJob",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "TrainingJobStatus"
            },
            {
              expected: "Stopped",
              matcher: "path",
              state: "success",
              argument: "TrainingJobStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "TrainingJobStatus"
            },
            {
              expected: "ValidationException",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        EndpointInService: {
          delay: 30,
          maxAttempts: 120,
          operation: "DescribeEndpoint",
          acceptors: [
            {
              expected: "InService",
              matcher: "path",
              state: "success",
              argument: "EndpointStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "EndpointStatus"
            },
            {
              expected: "ValidationException",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        EndpointDeleted: {
          delay: 30,
          maxAttempts: 60,
          operation: "DescribeEndpoint",
          acceptors: [
            {
              expected: "ValidationException",
              matcher: "error",
              state: "success"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "EndpointStatus"
            }
          ]
        },
        TransformJobCompletedOrStopped: {
          delay: 60,
          maxAttempts: 60,
          operation: "DescribeTransformJob",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "TransformJobStatus"
            },
            {
              expected: "Stopped",
              matcher: "path",
              state: "success",
              argument: "TransformJobStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "TransformJobStatus"
            },
            {
              expected: "ValidationException",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        ProcessingJobCompletedOrStopped: {
          delay: 60,
          maxAttempts: 60,
          operation: "DescribeProcessingJob",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "ProcessingJobStatus"
            },
            {
              expected: "Stopped",
              matcher: "path",
              state: "success",
              argument: "ProcessingJobStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "ProcessingJobStatus"
            },
            {
              expected: "ValidationException",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        ImageCreated: {
          delay: 60,
          maxAttempts: 60,
          operation: "DescribeImage",
          acceptors: [
            {
              expected: "CREATED",
              matcher: "path",
              state: "success",
              argument: "ImageStatus"
            },
            {
              expected: "CREATE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "ImageStatus"
            },
            {
              expected: "ValidationException",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        ImageUpdated: {
          delay: 60,
          maxAttempts: 60,
          operation: "DescribeImage",
          acceptors: [
            {
              expected: "CREATED",
              matcher: "path",
              state: "success",
              argument: "ImageStatus"
            },
            {
              expected: "UPDATE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "ImageStatus"
            },
            {
              expected: "ValidationException",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        ImageDeleted: {
          delay: 60,
          maxAttempts: 60,
          operation: "DescribeImage",
          acceptors: [
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "success"
            },
            {
              expected: "DELETE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "ImageStatus"
            },
            {
              expected: "ValidationException",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        ImageVersionCreated: {
          delay: 60,
          maxAttempts: 60,
          operation: "DescribeImageVersion",
          acceptors: [
            {
              expected: "CREATED",
              matcher: "path",
              state: "success",
              argument: "ImageVersionStatus"
            },
            {
              expected: "CREATE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "ImageVersionStatus"
            },
            {
              expected: "ValidationException",
              matcher: "error",
              state: "failure"
            }
          ]
        },
        ImageVersionDeleted: {
          delay: 60,
          maxAttempts: 60,
          operation: "DescribeImageVersion",
          acceptors: [
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "success"
            },
            {
              expected: "DELETE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "ImageVersionStatus"
            },
            {
              expected: "ValidationException",
              matcher: "error",
              state: "failure"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/sagemaker.js
var require_sagemaker = __commonJS({
  "node_modules/aws-sdk/clients/sagemaker.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["sagemaker"] = {};
    AWS3.SageMaker = Service.defineService("sagemaker", ["2017-07-24"]);
    Object.defineProperty(apiLoader.services["sagemaker"], "2017-07-24", {
      get: function get() {
        var model = require_sagemaker_2017_07_24_min();
        model.paginators = require_sagemaker_2017_07_24_paginators().pagination;
        model.waiters = require_sagemaker_2017_07_24_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SageMaker;
  }
});

// node_modules/aws-sdk/apis/translate-2017-07-01.min.json
var require_translate_2017_07_01_min = __commonJS({
  "node_modules/aws-sdk/apis/translate-2017-07-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-01",
        endpointPrefix: "translate",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Translate",
        serviceId: "Translate",
        signatureVersion: "v4",
        signingName: "translate",
        targetPrefix: "AWSShineFrontendService_20170701",
        uid: "translate-2017-07-01"
      },
      operations: {
        CreateParallelData: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ParallelDataConfig",
              "ClientToken"
            ],
            members: {
              Name: {},
              Description: {},
              ParallelDataConfig: {
                shape: "S4"
              },
              EncryptionKey: {
                shape: "S7"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Status: {}
            }
          }
        },
        DeleteParallelData: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Status: {}
            }
          }
        },
        DeleteTerminology: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DescribeTextTranslationJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TextTranslationJobProperties: {
                shape: "Sj"
              }
            }
          }
        },
        GetParallelData: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ParallelDataProperties: {
                shape: "Sz"
              },
              DataLocation: {
                shape: "S13"
              },
              AuxiliaryDataLocation: {
                shape: "S13"
              },
              LatestUpdateAttemptAuxiliaryDataLocation: {
                shape: "S13"
              }
            }
          }
        },
        GetTerminology: {
          input: {
            type: "structure",
            required: [
              "Name",
              "TerminologyDataFormat"
            ],
            members: {
              Name: {},
              TerminologyDataFormat: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TerminologyProperties: {
                shape: "S18"
              },
              TerminologyDataLocation: {
                type: "structure",
                required: [
                  "RepositoryType",
                  "Location"
                ],
                members: {
                  RepositoryType: {},
                  Location: {}
                }
              }
            }
          }
        },
        ImportTerminology: {
          input: {
            type: "structure",
            required: [
              "Name",
              "MergeStrategy",
              "TerminologyData"
            ],
            members: {
              Name: {},
              MergeStrategy: {},
              Description: {},
              TerminologyData: {
                type: "structure",
                required: [
                  "File",
                  "Format"
                ],
                members: {
                  File: {
                    type: "blob",
                    sensitive: true
                  },
                  Format: {}
                }
              },
              EncryptionKey: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TerminologyProperties: {
                shape: "S18"
              }
            }
          }
        },
        ListParallelData: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ParallelDataPropertiesList: {
                type: "list",
                member: {
                  shape: "Sz"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTerminologies: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TerminologyPropertiesList: {
                type: "list",
                member: {
                  shape: "S18"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTextTranslationJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  JobName: {},
                  JobStatus: {},
                  SubmittedBeforeTime: {
                    type: "timestamp"
                  },
                  SubmittedAfterTime: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TextTranslationJobPropertiesList: {
                type: "list",
                member: {
                  shape: "Sj"
                }
              },
              NextToken: {}
            }
          }
        },
        StartTextTranslationJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn",
              "SourceLanguageCode",
              "TargetLanguageCodes",
              "ClientToken"
            ],
            members: {
              JobName: {},
              InputDataConfig: {
                shape: "St"
              },
              OutputDataConfig: {
                shape: "Sv"
              },
              DataAccessRoleArn: {},
              SourceLanguageCode: {},
              TargetLanguageCodes: {
                shape: "Sp"
              },
              TerminologyNames: {
                shape: "Sq"
              },
              ParallelDataNames: {
                shape: "Sq"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobStatus: {}
            }
          }
        },
        StopTextTranslationJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              JobStatus: {}
            }
          }
        },
        TranslateText: {
          input: {
            type: "structure",
            required: [
              "Text",
              "SourceLanguageCode",
              "TargetLanguageCode"
            ],
            members: {
              Text: {},
              TerminologyNames: {
                shape: "Sq"
              },
              SourceLanguageCode: {},
              TargetLanguageCode: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "TranslatedText",
              "SourceLanguageCode",
              "TargetLanguageCode"
            ],
            members: {
              TranslatedText: {},
              SourceLanguageCode: {},
              TargetLanguageCode: {},
              AppliedTerminologies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Terms: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          SourceText: {},
                          TargetText: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        UpdateParallelData: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ParallelDataConfig",
              "ClientToken"
            ],
            members: {
              Name: {},
              Description: {},
              ParallelDataConfig: {
                shape: "S4"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Status: {},
              LatestUpdateAttemptStatus: {},
              LatestUpdateAttemptAt: {
                type: "timestamp"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "S3Uri",
            "Format"
          ],
          members: {
            S3Uri: {},
            Format: {}
          }
        },
        S7: {
          type: "structure",
          required: [
            "Type",
            "Id"
          ],
          members: {
            Type: {},
            Id: {}
          }
        },
        Sj: {
          type: "structure",
          members: {
            JobId: {},
            JobName: {},
            JobStatus: {},
            JobDetails: {
              type: "structure",
              members: {
                TranslatedDocumentsCount: {
                  type: "integer"
                },
                DocumentsWithErrorsCount: {
                  type: "integer"
                },
                InputDocumentsCount: {
                  type: "integer"
                }
              }
            },
            SourceLanguageCode: {},
            TargetLanguageCodes: {
              shape: "Sp"
            },
            TerminologyNames: {
              shape: "Sq"
            },
            ParallelDataNames: {
              shape: "Sq"
            },
            Message: {},
            SubmittedTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "St"
            },
            OutputDataConfig: {
              shape: "Sv"
            },
            DataAccessRoleArn: {}
          }
        },
        Sp: {
          type: "list",
          member: {}
        },
        Sq: {
          type: "list",
          member: {}
        },
        St: {
          type: "structure",
          required: [
            "S3Uri",
            "ContentType"
          ],
          members: {
            S3Uri: {},
            ContentType: {}
          }
        },
        Sv: {
          type: "structure",
          required: [
            "S3Uri"
          ],
          members: {
            S3Uri: {}
          }
        },
        Sz: {
          type: "structure",
          members: {
            Name: {},
            Arn: {},
            Description: {},
            Status: {},
            SourceLanguageCode: {},
            TargetLanguageCodes: {
              shape: "S11"
            },
            ParallelDataConfig: {
              shape: "S4"
            },
            Message: {},
            ImportedDataSize: {
              type: "long"
            },
            ImportedRecordCount: {
              type: "long"
            },
            FailedRecordCount: {
              type: "long"
            },
            SkippedRecordCount: {
              type: "long"
            },
            EncryptionKey: {
              shape: "S7"
            },
            CreatedAt: {
              type: "timestamp"
            },
            LastUpdatedAt: {
              type: "timestamp"
            },
            LatestUpdateAttemptStatus: {},
            LatestUpdateAttemptAt: {
              type: "timestamp"
            }
          }
        },
        S11: {
          type: "list",
          member: {}
        },
        S13: {
          type: "structure",
          required: [
            "RepositoryType",
            "Location"
          ],
          members: {
            RepositoryType: {},
            Location: {}
          }
        },
        S18: {
          type: "structure",
          members: {
            Name: {},
            Description: {},
            Arn: {},
            SourceLanguageCode: {},
            TargetLanguageCodes: {
              shape: "S11"
            },
            EncryptionKey: {
              shape: "S7"
            },
            SizeBytes: {
              type: "integer"
            },
            TermCount: {
              type: "integer"
            },
            CreatedAt: {
              type: "timestamp"
            },
            LastUpdatedAt: {
              type: "timestamp"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/translate-2017-07-01.paginators.json
var require_translate_2017_07_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/translate-2017-07-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListParallelData: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTerminologies: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListTextTranslationJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/translate.js
var require_translate2 = __commonJS({
  "node_modules/aws-sdk/clients/translate.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["translate"] = {};
    AWS3.Translate = Service.defineService("translate", ["2017-07-01"]);
    Object.defineProperty(apiLoader.services["translate"], "2017-07-01", {
      get: function get() {
        var model = require_translate_2017_07_01_min();
        model.paginators = require_translate_2017_07_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Translate;
  }
});

// node_modules/aws-sdk/apis/resource-groups-2017-11-27.min.json
var require_resource_groups_2017_11_27_min = __commonJS({
  "node_modules/aws-sdk/apis/resource-groups-2017-11-27.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-11-27",
        endpointPrefix: "resource-groups",
        protocol: "rest-json",
        serviceAbbreviation: "Resource Groups",
        serviceFullName: "AWS Resource Groups",
        serviceId: "Resource Groups",
        signatureVersion: "v4",
        signingName: "resource-groups",
        uid: "resource-groups-2017-11-27"
      },
      operations: {
        CreateGroup: {
          http: {
            requestUri: "/groups"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              ResourceQuery: {
                shape: "S4"
              },
              Tags: {
                shape: "S7"
              },
              Configuration: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "Sj"
              },
              ResourceQuery: {
                shape: "S4"
              },
              Tags: {
                shape: "S7"
              },
              GroupConfiguration: {
                shape: "Sl"
              }
            }
          }
        },
        DeleteGroup: {
          http: {
            requestUri: "/delete-group"
          },
          input: {
            type: "structure",
            members: {
              GroupName: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated, use Group instead."
              },
              Group: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "Sj"
              }
            }
          }
        },
        GetGroup: {
          http: {
            requestUri: "/get-group"
          },
          input: {
            type: "structure",
            members: {
              GroupName: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated, use Group instead."
              },
              Group: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "Sj"
              }
            }
          }
        },
        GetGroupConfiguration: {
          http: {
            requestUri: "/get-group-configuration"
          },
          input: {
            type: "structure",
            members: {
              Group: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GroupConfiguration: {
                shape: "Sl"
              }
            }
          }
        },
        GetGroupQuery: {
          http: {
            requestUri: "/get-group-query"
          },
          input: {
            type: "structure",
            members: {
              GroupName: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated, use Group instead."
              },
              Group: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GroupQuery: {
                shape: "Sx"
              }
            }
          }
        },
        GetTags: {
          http: {
            method: "GET",
            requestUri: "/resources/{Arn}/tags"
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {
                location: "uri",
                locationName: "Arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Tags: {
                shape: "S7"
              }
            }
          }
        },
        GroupResources: {
          http: {
            requestUri: "/group-resources"
          },
          input: {
            type: "structure",
            required: [
              "Group",
              "ResourceArns"
            ],
            members: {
              Group: {},
              ResourceArns: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Succeeded: {
                shape: "S11"
              },
              Failed: {
                shape: "S14"
              },
              Pending: {
                shape: "S18"
              }
            }
          }
        },
        ListGroupResources: {
          http: {
            requestUri: "/list-group-resources"
          },
          input: {
            type: "structure",
            members: {
              GroupName: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated, use Group instead."
              },
              Group: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Resources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Identifier: {
                      shape: "S1l"
                    },
                    Status: {
                      type: "structure",
                      members: {
                        Name: {}
                      }
                    }
                  }
                }
              },
              ResourceIdentifiers: {
                shape: "S1p",
                deprecated: true,
                deprecatedMessage: "This field is deprecated, use Resources instead."
              },
              NextToken: {},
              QueryErrors: {
                shape: "S1q"
              }
            }
          }
        },
        ListGroups: {
          http: {
            requestUri: "/groups-list"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupIdentifiers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GroupName: {},
                    GroupArn: {}
                  }
                }
              },
              Groups: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated, use GroupIdentifiers instead.",
                type: "list",
                member: {
                  shape: "Sj"
                }
              },
              NextToken: {}
            }
          }
        },
        PutGroupConfiguration: {
          http: {
            requestUri: "/put-group-configuration",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Group: {},
              Configuration: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SearchResources: {
          http: {
            requestUri: "/resources/search"
          },
          input: {
            type: "structure",
            required: [
              "ResourceQuery"
            ],
            members: {
              ResourceQuery: {
                shape: "S4"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceIdentifiers: {
                shape: "S1p"
              },
              NextToken: {},
              QueryErrors: {
                shape: "S1q"
              }
            }
          }
        },
        Tag: {
          http: {
            method: "PUT",
            requestUri: "/resources/{Arn}/tags"
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "Tags"
            ],
            members: {
              Arn: {
                location: "uri",
                locationName: "Arn"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Tags: {
                shape: "S7"
              }
            }
          }
        },
        UngroupResources: {
          http: {
            requestUri: "/ungroup-resources"
          },
          input: {
            type: "structure",
            required: [
              "Group",
              "ResourceArns"
            ],
            members: {
              Group: {},
              ResourceArns: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Succeeded: {
                shape: "S11"
              },
              Failed: {
                shape: "S14"
              },
              Pending: {
                shape: "S18"
              }
            }
          }
        },
        Untag: {
          http: {
            method: "PATCH",
            requestUri: "/resources/{Arn}/tags"
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "Keys"
            ],
            members: {
              Arn: {
                location: "uri",
                locationName: "Arn"
              },
              Keys: {
                shape: "S2d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Keys: {
                shape: "S2d"
              }
            }
          }
        },
        UpdateGroup: {
          http: {
            requestUri: "/update-group"
          },
          input: {
            type: "structure",
            members: {
              GroupName: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated, use Group instead."
              },
              Group: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "Sj"
              }
            }
          }
        },
        UpdateGroupQuery: {
          http: {
            requestUri: "/update-group-query"
          },
          input: {
            type: "structure",
            required: [
              "ResourceQuery"
            ],
            members: {
              GroupName: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated, use Group instead."
              },
              Group: {},
              ResourceQuery: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupQuery: {
                shape: "Sx"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "Type",
            "Query"
          ],
          members: {
            Type: {},
            Query: {}
          }
        },
        S7: {
          type: "map",
          key: {},
          value: {}
        },
        Sa: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Type"
            ],
            members: {
              Type: {},
              Parameters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        Sj: {
          type: "structure",
          required: [
            "GroupArn",
            "Name"
          ],
          members: {
            GroupArn: {},
            Name: {},
            Description: {}
          }
        },
        Sl: {
          type: "structure",
          members: {
            Configuration: {
              shape: "Sa"
            },
            ProposedConfiguration: {
              shape: "Sa"
            },
            Status: {},
            FailureReason: {}
          }
        },
        Sx: {
          type: "structure",
          required: [
            "GroupName",
            "ResourceQuery"
          ],
          members: {
            GroupName: {},
            ResourceQuery: {
              shape: "S4"
            }
          }
        },
        S11: {
          type: "list",
          member: {}
        },
        S14: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceArn: {},
              ErrorMessage: {},
              ErrorCode: {}
            }
          }
        },
        S18: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceArn: {}
            }
          }
        },
        S1l: {
          type: "structure",
          members: {
            ResourceArn: {},
            ResourceType: {}
          }
        },
        S1p: {
          type: "list",
          member: {
            shape: "S1l"
          }
        },
        S1q: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ErrorCode: {},
              Message: {}
            }
          }
        },
        S2d: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/resource-groups-2017-11-27.paginators.json
var require_resource_groups_2017_11_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/resource-groups-2017-11-27.paginators.json"(exports, module2) {
    module2.exports = { pagination: { ListGroupResources: { input_token: "NextToken", output_token: "NextToken", limit_key: "MaxResults", result_key: ["ResourceIdentifiers", "Resources"] }, ListGroups: { input_token: "NextToken", output_token: "NextToken", limit_key: "MaxResults", result_key: "GroupIdentifiers" }, SearchResources: { input_token: "NextToken", output_token: "NextToken", limit_key: "MaxResults", result_key: "ResourceIdentifiers" } } };
  }
});

// node_modules/aws-sdk/clients/resourcegroups.js
var require_resourcegroups = __commonJS({
  "node_modules/aws-sdk/clients/resourcegroups.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["resourcegroups"] = {};
    AWS3.ResourceGroups = Service.defineService("resourcegroups", ["2017-11-27"]);
    Object.defineProperty(apiLoader.services["resourcegroups"], "2017-11-27", {
      get: function get() {
        var model = require_resource_groups_2017_11_27_min();
        model.paginators = require_resource_groups_2017_11_27_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ResourceGroups;
  }
});

// node_modules/aws-sdk/apis/alexaforbusiness-2017-11-09.min.json
var require_alexaforbusiness_2017_11_09_min = __commonJS({
  "node_modules/aws-sdk/apis/alexaforbusiness-2017-11-09.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-11-09",
        endpointPrefix: "a4b",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Alexa For Business",
        serviceId: "Alexa For Business",
        signatureVersion: "v4",
        targetPrefix: "AlexaForBusiness",
        uid: "alexaforbusiness-2017-11-09"
      },
      operations: {
        ApproveSkill: {
          input: {
            type: "structure",
            required: [
              "SkillId"
            ],
            members: {
              SkillId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateContactWithAddressBook: {
          input: {
            type: "structure",
            required: [
              "ContactArn",
              "AddressBookArn"
            ],
            members: {
              ContactArn: {},
              AddressBookArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateDeviceWithNetworkProfile: {
          input: {
            type: "structure",
            required: [
              "DeviceArn",
              "NetworkProfileArn"
            ],
            members: {
              DeviceArn: {},
              NetworkProfileArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateDeviceWithRoom: {
          input: {
            type: "structure",
            members: {
              DeviceArn: {},
              RoomArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateSkillGroupWithRoom: {
          input: {
            type: "structure",
            members: {
              SkillGroupArn: {},
              RoomArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateSkillWithSkillGroup: {
          input: {
            type: "structure",
            required: [
              "SkillId"
            ],
            members: {
              SkillGroupArn: {},
              SkillId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateSkillWithUsers: {
          input: {
            type: "structure",
            required: [
              "SkillId"
            ],
            members: {
              SkillId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateAddressBook: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AddressBookArn: {}
            }
          }
        },
        CreateBusinessReportSchedule: {
          input: {
            type: "structure",
            required: [
              "Format",
              "ContentRange"
            ],
            members: {
              ScheduleName: {},
              S3BucketName: {},
              S3KeyPrefix: {},
              Format: {},
              ContentRange: {
                shape: "Sv"
              },
              Recurrence: {
                shape: "Sx"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ScheduleArn: {}
            }
          }
        },
        CreateConferenceProvider: {
          input: {
            type: "structure",
            required: [
              "ConferenceProviderName",
              "ConferenceProviderType",
              "MeetingSetting"
            ],
            members: {
              ConferenceProviderName: {},
              ConferenceProviderType: {},
              IPDialIn: {
                shape: "S13"
              },
              PSTNDialIn: {
                shape: "S16"
              },
              MeetingSetting: {
                shape: "S1b"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConferenceProviderArn: {}
            }
          }
        },
        CreateContact: {
          input: {
            type: "structure",
            required: [
              "FirstName"
            ],
            members: {
              DisplayName: {},
              FirstName: {},
              LastName: {},
              PhoneNumber: {
                shape: "S1g"
              },
              PhoneNumbers: {
                shape: "S1h"
              },
              SipAddresses: {
                shape: "S1k"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactArn: {}
            }
          }
        },
        CreateGatewayGroup: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ClientRequestToken"
            ],
            members: {
              Name: {},
              Description: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayGroupArn: {}
            }
          }
        },
        CreateNetworkProfile: {
          input: {
            type: "structure",
            required: [
              "NetworkProfileName",
              "Ssid",
              "SecurityType",
              "ClientRequestToken"
            ],
            members: {
              NetworkProfileName: {},
              Description: {},
              Ssid: {},
              SecurityType: {},
              EapMethod: {},
              CurrentPassword: {
                shape: "S1z"
              },
              NextPassword: {
                shape: "S20"
              },
              CertificateAuthorityArn: {},
              TrustAnchors: {
                shape: "S21"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkProfileArn: {}
            }
          }
        },
        CreateProfile: {
          input: {
            type: "structure",
            required: [
              "ProfileName",
              "Timezone",
              "Address",
              "DistanceUnit",
              "TemperatureUnit",
              "WakeWord"
            ],
            members: {
              ProfileName: {},
              Timezone: {},
              Address: {},
              DistanceUnit: {},
              TemperatureUnit: {},
              WakeWord: {},
              Locale: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              SetupModeDisabled: {
                type: "boolean"
              },
              MaxVolumeLimit: {
                type: "integer"
              },
              PSTNEnabled: {
                type: "boolean"
              },
              DataRetentionOptIn: {
                type: "boolean"
              },
              MeetingRoomConfiguration: {
                type: "structure",
                members: {
                  RoomUtilizationMetricsEnabled: {
                    type: "boolean"
                  },
                  EndOfMeetingReminder: {
                    type: "structure",
                    required: [
                      "ReminderAtMinutes",
                      "ReminderType",
                      "Enabled"
                    ],
                    members: {
                      ReminderAtMinutes: {
                        shape: "S2g"
                      },
                      ReminderType: {},
                      Enabled: {
                        type: "boolean"
                      }
                    }
                  },
                  InstantBooking: {
                    type: "structure",
                    required: [
                      "DurationInMinutes",
                      "Enabled"
                    ],
                    members: {
                      DurationInMinutes: {
                        type: "integer"
                      },
                      Enabled: {
                        type: "boolean"
                      }
                    }
                  },
                  RequireCheckIn: {
                    type: "structure",
                    required: [
                      "ReleaseAfterMinutes",
                      "Enabled"
                    ],
                    members: {
                      ReleaseAfterMinutes: {
                        type: "integer"
                      },
                      Enabled: {
                        type: "boolean"
                      }
                    }
                  }
                }
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProfileArn: {}
            }
          }
        },
        CreateRoom: {
          input: {
            type: "structure",
            required: [
              "RoomName"
            ],
            members: {
              RoomName: {},
              Description: {},
              ProfileArn: {},
              ProviderCalendarId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RoomArn: {}
            }
          }
        },
        CreateSkillGroup: {
          input: {
            type: "structure",
            required: [
              "SkillGroupName"
            ],
            members: {
              SkillGroupName: {},
              Description: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SkillGroupArn: {}
            }
          }
        },
        CreateUser: {
          input: {
            type: "structure",
            required: [
              "UserId"
            ],
            members: {
              UserId: {},
              FirstName: {},
              LastName: {},
              Email: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserArn: {}
            }
          }
        },
        DeleteAddressBook: {
          input: {
            type: "structure",
            required: [
              "AddressBookArn"
            ],
            members: {
              AddressBookArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteBusinessReportSchedule: {
          input: {
            type: "structure",
            required: [
              "ScheduleArn"
            ],
            members: {
              ScheduleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteConferenceProvider: {
          input: {
            type: "structure",
            required: [
              "ConferenceProviderArn"
            ],
            members: {
              ConferenceProviderArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteContact: {
          input: {
            type: "structure",
            required: [
              "ContactArn"
            ],
            members: {
              ContactArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDevice: {
          input: {
            type: "structure",
            required: [
              "DeviceArn"
            ],
            members: {
              DeviceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDeviceUsageData: {
          input: {
            type: "structure",
            required: [
              "DeviceArn",
              "DeviceUsageType"
            ],
            members: {
              DeviceArn: {},
              DeviceUsageType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteGatewayGroup: {
          input: {
            type: "structure",
            required: [
              "GatewayGroupArn"
            ],
            members: {
              GatewayGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteNetworkProfile: {
          input: {
            type: "structure",
            required: [
              "NetworkProfileArn"
            ],
            members: {
              NetworkProfileArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteProfile: {
          input: {
            type: "structure",
            members: {
              ProfileArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRoom: {
          input: {
            type: "structure",
            members: {
              RoomArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRoomSkillParameter: {
          input: {
            type: "structure",
            required: [
              "SkillId",
              "ParameterKey"
            ],
            members: {
              RoomArn: {},
              SkillId: {},
              ParameterKey: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSkillAuthorization: {
          input: {
            type: "structure",
            required: [
              "SkillId"
            ],
            members: {
              SkillId: {},
              RoomArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSkillGroup: {
          input: {
            type: "structure",
            members: {
              SkillGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteUser: {
          input: {
            type: "structure",
            required: [
              "EnrollmentId"
            ],
            members: {
              UserArn: {},
              EnrollmentId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateContactFromAddressBook: {
          input: {
            type: "structure",
            required: [
              "ContactArn",
              "AddressBookArn"
            ],
            members: {
              ContactArn: {},
              AddressBookArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateDeviceFromRoom: {
          input: {
            type: "structure",
            members: {
              DeviceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateSkillFromSkillGroup: {
          input: {
            type: "structure",
            required: [
              "SkillId"
            ],
            members: {
              SkillGroupArn: {},
              SkillId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateSkillFromUsers: {
          input: {
            type: "structure",
            required: [
              "SkillId"
            ],
            members: {
              SkillId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateSkillGroupFromRoom: {
          input: {
            type: "structure",
            members: {
              SkillGroupArn: {},
              RoomArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ForgetSmartHomeAppliances: {
          input: {
            type: "structure",
            required: [
              "RoomArn"
            ],
            members: {
              RoomArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAddressBook: {
          input: {
            type: "structure",
            required: [
              "AddressBookArn"
            ],
            members: {
              AddressBookArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AddressBook: {
                type: "structure",
                members: {
                  AddressBookArn: {},
                  Name: {},
                  Description: {}
                }
              }
            }
          }
        },
        GetConferencePreference: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Preference: {
                shape: "S4d"
              }
            }
          }
        },
        GetConferenceProvider: {
          input: {
            type: "structure",
            required: [
              "ConferenceProviderArn"
            ],
            members: {
              ConferenceProviderArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConferenceProvider: {
                shape: "S4g"
              }
            }
          }
        },
        GetContact: {
          input: {
            type: "structure",
            required: [
              "ContactArn"
            ],
            members: {
              ContactArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Contact: {
                type: "structure",
                members: {
                  ContactArn: {},
                  DisplayName: {},
                  FirstName: {},
                  LastName: {},
                  PhoneNumber: {
                    shape: "S1g"
                  },
                  PhoneNumbers: {
                    shape: "S1h"
                  },
                  SipAddresses: {
                    shape: "S1k"
                  }
                }
              }
            }
          }
        },
        GetDevice: {
          input: {
            type: "structure",
            members: {
              DeviceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Device: {
                type: "structure",
                members: {
                  DeviceArn: {},
                  DeviceSerialNumber: {},
                  DeviceType: {},
                  DeviceName: {},
                  SoftwareVersion: {},
                  MacAddress: {},
                  RoomArn: {},
                  DeviceStatus: {},
                  DeviceStatusInfo: {
                    shape: "S4t"
                  },
                  NetworkProfileInfo: {
                    type: "structure",
                    members: {
                      NetworkProfileArn: {},
                      CertificateArn: {},
                      CertificateExpirationTime: {
                        type: "timestamp"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetGateway: {
          input: {
            type: "structure",
            required: [
              "GatewayArn"
            ],
            members: {
              GatewayArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Gateway: {
                type: "structure",
                members: {
                  Arn: {},
                  Name: {},
                  Description: {},
                  GatewayGroupArn: {},
                  SoftwareVersion: {}
                }
              }
            }
          }
        },
        GetGatewayGroup: {
          input: {
            type: "structure",
            required: [
              "GatewayGroupArn"
            ],
            members: {
              GatewayGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayGroup: {
                type: "structure",
                members: {
                  Arn: {},
                  Name: {},
                  Description: {}
                }
              }
            }
          }
        },
        GetInvitationConfiguration: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              OrganizationName: {},
              ContactEmail: {},
              PrivateSkillIds: {
                shape: "S5e"
              }
            }
          }
        },
        GetNetworkProfile: {
          input: {
            type: "structure",
            required: [
              "NetworkProfileArn"
            ],
            members: {
              NetworkProfileArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkProfile: {
                type: "structure",
                members: {
                  NetworkProfileArn: {},
                  NetworkProfileName: {},
                  Description: {},
                  Ssid: {},
                  SecurityType: {},
                  EapMethod: {},
                  CurrentPassword: {
                    shape: "S1z"
                  },
                  NextPassword: {
                    shape: "S20"
                  },
                  CertificateAuthorityArn: {},
                  TrustAnchors: {
                    shape: "S21"
                  }
                }
              }
            }
          }
        },
        GetProfile: {
          input: {
            type: "structure",
            members: {
              ProfileArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Profile: {
                type: "structure",
                members: {
                  ProfileArn: {},
                  ProfileName: {},
                  IsDefault: {
                    type: "boolean"
                  },
                  Address: {},
                  Timezone: {},
                  DistanceUnit: {},
                  TemperatureUnit: {},
                  WakeWord: {},
                  Locale: {},
                  SetupModeDisabled: {
                    type: "boolean"
                  },
                  MaxVolumeLimit: {
                    type: "integer"
                  },
                  PSTNEnabled: {
                    type: "boolean"
                  },
                  DataRetentionOptIn: {
                    type: "boolean"
                  },
                  AddressBookArn: {},
                  MeetingRoomConfiguration: {
                    type: "structure",
                    members: {
                      RoomUtilizationMetricsEnabled: {
                        type: "boolean"
                      },
                      EndOfMeetingReminder: {
                        type: "structure",
                        members: {
                          ReminderAtMinutes: {
                            shape: "S2g"
                          },
                          ReminderType: {},
                          Enabled: {
                            type: "boolean"
                          }
                        }
                      },
                      InstantBooking: {
                        type: "structure",
                        members: {
                          DurationInMinutes: {
                            type: "integer"
                          },
                          Enabled: {
                            type: "boolean"
                          }
                        }
                      },
                      RequireCheckIn: {
                        type: "structure",
                        members: {
                          ReleaseAfterMinutes: {
                            type: "integer"
                          },
                          Enabled: {
                            type: "boolean"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetRoom: {
          input: {
            type: "structure",
            members: {
              RoomArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Room: {
                type: "structure",
                members: {
                  RoomArn: {},
                  RoomName: {},
                  Description: {},
                  ProviderCalendarId: {},
                  ProfileArn: {}
                }
              }
            }
          }
        },
        GetRoomSkillParameter: {
          input: {
            type: "structure",
            required: [
              "SkillId",
              "ParameterKey"
            ],
            members: {
              RoomArn: {},
              SkillId: {},
              ParameterKey: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RoomSkillParameter: {
                shape: "S5u"
              }
            }
          }
        },
        GetSkillGroup: {
          input: {
            type: "structure",
            members: {
              SkillGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SkillGroup: {
                type: "structure",
                members: {
                  SkillGroupArn: {},
                  SkillGroupName: {},
                  Description: {}
                }
              }
            }
          }
        },
        ListBusinessReportSchedules: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BusinessReportSchedules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ScheduleArn: {},
                    ScheduleName: {},
                    S3BucketName: {},
                    S3KeyPrefix: {},
                    Format: {},
                    ContentRange: {
                      shape: "Sv"
                    },
                    Recurrence: {
                      shape: "Sx"
                    },
                    LastBusinessReport: {
                      type: "structure",
                      members: {
                        Status: {},
                        FailureCode: {},
                        S3Location: {
                          type: "structure",
                          members: {
                            Path: {},
                            BucketName: {}
                          }
                        },
                        DeliveryTime: {
                          type: "timestamp"
                        },
                        DownloadUrl: {}
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListConferenceProviders: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConferenceProviders: {
                type: "list",
                member: {
                  shape: "S4g"
                }
              },
              NextToken: {}
            }
          }
        },
        ListDeviceEvents: {
          input: {
            type: "structure",
            required: [
              "DeviceArn"
            ],
            members: {
              DeviceArn: {},
              EventType: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeviceEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    Value: {},
                    Timestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListGatewayGroups: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GatewayGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {},
                    Description: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListGateways: {
          input: {
            type: "structure",
            members: {
              GatewayGroupArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Gateways: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {},
                    Description: {},
                    GatewayGroupArn: {},
                    SoftwareVersion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSkills: {
          input: {
            type: "structure",
            members: {
              SkillGroupArn: {},
              EnablementType: {},
              SkillType: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SkillSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SkillId: {},
                    SkillName: {},
                    SupportsLinking: {
                      type: "boolean"
                    },
                    EnablementType: {},
                    SkillType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSkillsStoreCategories: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CategoryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CategoryId: {
                      type: "long"
                    },
                    CategoryName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSkillsStoreSkillsByCategory: {
          input: {
            type: "structure",
            required: [
              "CategoryId"
            ],
            members: {
              CategoryId: {
                type: "long"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SkillsStoreSkills: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SkillId: {},
                    SkillName: {},
                    ShortDescription: {},
                    IconUrl: {},
                    SampleUtterances: {
                      type: "list",
                      member: {}
                    },
                    SkillDetails: {
                      type: "structure",
                      members: {
                        ProductDescription: {},
                        InvocationPhrase: {},
                        ReleaseDate: {},
                        EndUserLicenseAgreement: {},
                        GenericKeywords: {
                          type: "list",
                          member: {}
                        },
                        BulletPoints: {
                          type: "list",
                          member: {}
                        },
                        NewInThisVersionBulletPoints: {
                          type: "list",
                          member: {}
                        },
                        SkillTypes: {
                          type: "list",
                          member: {}
                        },
                        Reviews: {
                          type: "map",
                          key: {},
                          value: {}
                        },
                        DeveloperInfo: {
                          type: "structure",
                          members: {
                            DeveloperName: {},
                            PrivacyPolicy: {},
                            Email: {},
                            Url: {}
                          }
                        }
                      }
                    },
                    SupportsLinking: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSmartHomeAppliances: {
          input: {
            type: "structure",
            required: [
              "RoomArn"
            ],
            members: {
              RoomArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SmartHomeAppliances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FriendlyName: {},
                    Description: {},
                    ManufacturerName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTags: {
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sl"
              },
              NextToken: {}
            }
          }
        },
        PutConferencePreference: {
          input: {
            type: "structure",
            required: [
              "ConferencePreference"
            ],
            members: {
              ConferencePreference: {
                shape: "S4d"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutInvitationConfiguration: {
          input: {
            type: "structure",
            required: [
              "OrganizationName"
            ],
            members: {
              OrganizationName: {},
              ContactEmail: {},
              PrivateSkillIds: {
                shape: "S5e"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutRoomSkillParameter: {
          input: {
            type: "structure",
            required: [
              "SkillId",
              "RoomSkillParameter"
            ],
            members: {
              RoomArn: {},
              SkillId: {},
              RoomSkillParameter: {
                shape: "S5u"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutSkillAuthorization: {
          input: {
            type: "structure",
            required: [
              "AuthorizationResult",
              "SkillId"
            ],
            members: {
              AuthorizationResult: {
                type: "map",
                key: {},
                value: {},
                sensitive: true
              },
              SkillId: {},
              RoomArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RegisterAVSDevice: {
          input: {
            type: "structure",
            required: [
              "ClientId",
              "UserCode",
              "ProductId",
              "AmazonId"
            ],
            members: {
              ClientId: {},
              UserCode: {},
              ProductId: {},
              DeviceSerialNumber: {},
              AmazonId: {},
              RoomArn: {},
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DeviceArn: {}
            }
          }
        },
        RejectSkill: {
          input: {
            type: "structure",
            required: [
              "SkillId"
            ],
            members: {
              SkillId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ResolveRoom: {
          input: {
            type: "structure",
            required: [
              "UserId",
              "SkillId"
            ],
            members: {
              UserId: {},
              SkillId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RoomArn: {},
              RoomName: {},
              RoomSkillParameters: {
                type: "list",
                member: {
                  shape: "S5u"
                }
              }
            }
          }
        },
        RevokeInvitation: {
          input: {
            type: "structure",
            members: {
              UserArn: {},
              EnrollmentId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SearchAddressBooks: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S92"
              },
              SortCriteria: {
                shape: "S97"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AddressBooks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AddressBookArn: {},
                    Name: {},
                    Description: {}
                  }
                }
              },
              NextToken: {},
              TotalCount: {
                type: "integer"
              }
            }
          }
        },
        SearchContacts: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S92"
              },
              SortCriteria: {
                shape: "S97"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Contacts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ContactArn: {},
                    DisplayName: {},
                    FirstName: {},
                    LastName: {},
                    PhoneNumber: {
                      shape: "S1g"
                    },
                    PhoneNumbers: {
                      shape: "S1h"
                    },
                    SipAddresses: {
                      shape: "S1k"
                    }
                  }
                }
              },
              NextToken: {},
              TotalCount: {
                type: "integer"
              }
            }
          }
        },
        SearchDevices: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S92"
              },
              SortCriteria: {
                shape: "S97"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Devices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DeviceArn: {},
                    DeviceSerialNumber: {},
                    DeviceType: {},
                    DeviceName: {},
                    SoftwareVersion: {},
                    MacAddress: {},
                    DeviceStatus: {},
                    NetworkProfileArn: {},
                    NetworkProfileName: {},
                    RoomArn: {},
                    RoomName: {},
                    DeviceStatusInfo: {
                      shape: "S4t"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {},
              TotalCount: {
                type: "integer"
              }
            }
          }
        },
        SearchNetworkProfiles: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S92"
              },
              SortCriteria: {
                shape: "S97"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkProfiles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    NetworkProfileArn: {},
                    NetworkProfileName: {},
                    Description: {},
                    Ssid: {},
                    SecurityType: {},
                    EapMethod: {},
                    CertificateAuthorityArn: {}
                  }
                }
              },
              NextToken: {},
              TotalCount: {
                type: "integer"
              }
            }
          }
        },
        SearchProfiles: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S92"
              },
              SortCriteria: {
                shape: "S97"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Profiles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProfileArn: {},
                    ProfileName: {},
                    IsDefault: {
                      type: "boolean"
                    },
                    Address: {},
                    Timezone: {},
                    DistanceUnit: {},
                    TemperatureUnit: {},
                    WakeWord: {},
                    Locale: {}
                  }
                }
              },
              NextToken: {},
              TotalCount: {
                type: "integer"
              }
            }
          }
        },
        SearchRooms: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S92"
              },
              SortCriteria: {
                shape: "S97"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rooms: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RoomArn: {},
                    RoomName: {},
                    Description: {},
                    ProviderCalendarId: {},
                    ProfileArn: {},
                    ProfileName: {}
                  }
                }
              },
              NextToken: {},
              TotalCount: {
                type: "integer"
              }
            }
          }
        },
        SearchSkillGroups: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S92"
              },
              SortCriteria: {
                shape: "S97"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SkillGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SkillGroupArn: {},
                    SkillGroupName: {},
                    Description: {}
                  }
                }
              },
              NextToken: {},
              TotalCount: {
                type: "integer"
              }
            }
          }
        },
        SearchUsers: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S92"
              },
              SortCriteria: {
                shape: "S97"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Users: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UserArn: {},
                    FirstName: {},
                    LastName: {},
                    Email: {},
                    EnrollmentStatus: {},
                    EnrollmentId: {}
                  }
                }
              },
              NextToken: {},
              TotalCount: {
                type: "integer"
              }
            }
          }
        },
        SendAnnouncement: {
          input: {
            type: "structure",
            required: [
              "RoomFilters",
              "Content",
              "ClientRequestToken"
            ],
            members: {
              RoomFilters: {
                shape: "S92"
              },
              Content: {
                type: "structure",
                members: {
                  TextList: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Locale",
                        "Value"
                      ],
                      members: {
                        Locale: {},
                        Value: {}
                      }
                    }
                  },
                  SsmlList: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Locale",
                        "Value"
                      ],
                      members: {
                        Locale: {},
                        Value: {}
                      }
                    }
                  },
                  AudioList: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Locale",
                        "Location"
                      ],
                      members: {
                        Locale: {},
                        Location: {}
                      }
                    }
                  }
                }
              },
              TimeToLiveInSeconds: {
                type: "integer"
              },
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AnnouncementArn: {}
            }
          }
        },
        SendInvitation: {
          input: {
            type: "structure",
            members: {
              UserArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartDeviceSync: {
          input: {
            type: "structure",
            required: [
              "Features"
            ],
            members: {
              RoomArn: {},
              DeviceArn: {},
              Features: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartSmartHomeApplianceDiscovery: {
          input: {
            type: "structure",
            required: [
              "RoomArn"
            ],
            members: {
              RoomArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "Arn",
              "Tags"
            ],
            members: {
              Arn: {},
              Tags: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "Arn",
              "TagKeys"
            ],
            members: {
              Arn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAddressBook: {
          input: {
            type: "structure",
            required: [
              "AddressBookArn"
            ],
            members: {
              AddressBookArn: {},
              Name: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateBusinessReportSchedule: {
          input: {
            type: "structure",
            required: [
              "ScheduleArn"
            ],
            members: {
              ScheduleArn: {},
              S3BucketName: {},
              S3KeyPrefix: {},
              Format: {},
              ScheduleName: {},
              Recurrence: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateConferenceProvider: {
          input: {
            type: "structure",
            required: [
              "ConferenceProviderArn",
              "ConferenceProviderType",
              "MeetingSetting"
            ],
            members: {
              ConferenceProviderArn: {},
              ConferenceProviderType: {},
              IPDialIn: {
                shape: "S13"
              },
              PSTNDialIn: {
                shape: "S16"
              },
              MeetingSetting: {
                shape: "S1b"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateContact: {
          input: {
            type: "structure",
            required: [
              "ContactArn"
            ],
            members: {
              ContactArn: {},
              DisplayName: {},
              FirstName: {},
              LastName: {},
              PhoneNumber: {
                shape: "S1g"
              },
              PhoneNumbers: {
                shape: "S1h"
              },
              SipAddresses: {
                shape: "S1k"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDevice: {
          input: {
            type: "structure",
            members: {
              DeviceArn: {},
              DeviceName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateGateway: {
          input: {
            type: "structure",
            required: [
              "GatewayArn"
            ],
            members: {
              GatewayArn: {},
              Name: {},
              Description: {},
              SoftwareVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateGatewayGroup: {
          input: {
            type: "structure",
            required: [
              "GatewayGroupArn"
            ],
            members: {
              GatewayGroupArn: {},
              Name: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateNetworkProfile: {
          input: {
            type: "structure",
            required: [
              "NetworkProfileArn"
            ],
            members: {
              NetworkProfileArn: {},
              NetworkProfileName: {},
              Description: {},
              CurrentPassword: {
                shape: "S1z"
              },
              NextPassword: {
                shape: "S20"
              },
              CertificateAuthorityArn: {},
              TrustAnchors: {
                shape: "S21"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateProfile: {
          input: {
            type: "structure",
            members: {
              ProfileArn: {},
              ProfileName: {},
              IsDefault: {
                type: "boolean"
              },
              Timezone: {},
              Address: {},
              DistanceUnit: {},
              TemperatureUnit: {},
              WakeWord: {},
              Locale: {},
              SetupModeDisabled: {
                type: "boolean"
              },
              MaxVolumeLimit: {
                type: "integer"
              },
              PSTNEnabled: {
                type: "boolean"
              },
              DataRetentionOptIn: {
                type: "boolean"
              },
              MeetingRoomConfiguration: {
                type: "structure",
                members: {
                  RoomUtilizationMetricsEnabled: {
                    type: "boolean"
                  },
                  EndOfMeetingReminder: {
                    type: "structure",
                    members: {
                      ReminderAtMinutes: {
                        shape: "S2g"
                      },
                      ReminderType: {},
                      Enabled: {
                        type: "boolean"
                      }
                    }
                  },
                  InstantBooking: {
                    type: "structure",
                    members: {
                      DurationInMinutes: {
                        type: "integer"
                      },
                      Enabled: {
                        type: "boolean"
                      }
                    }
                  },
                  RequireCheckIn: {
                    type: "structure",
                    members: {
                      ReleaseAfterMinutes: {
                        type: "integer"
                      },
                      Enabled: {
                        type: "boolean"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRoom: {
          input: {
            type: "structure",
            members: {
              RoomArn: {},
              RoomName: {},
              Description: {},
              ProviderCalendarId: {},
              ProfileArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateSkillGroup: {
          input: {
            type: "structure",
            members: {
              SkillGroupArn: {},
              SkillGroupName: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sl: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sv: {
          type: "structure",
          required: [
            "Interval"
          ],
          members: {
            Interval: {}
          }
        },
        Sx: {
          type: "structure",
          members: {
            StartDate: {}
          }
        },
        S13: {
          type: "structure",
          required: [
            "Endpoint",
            "CommsProtocol"
          ],
          members: {
            Endpoint: {},
            CommsProtocol: {}
          }
        },
        S16: {
          type: "structure",
          required: [
            "CountryCode",
            "PhoneNumber",
            "OneClickIdDelay",
            "OneClickPinDelay"
          ],
          members: {
            CountryCode: {},
            PhoneNumber: {},
            OneClickIdDelay: {},
            OneClickPinDelay: {}
          }
        },
        S1b: {
          type: "structure",
          required: [
            "RequirePin"
          ],
          members: {
            RequirePin: {}
          }
        },
        S1g: {
          type: "string",
          sensitive: true
        },
        S1h: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Number",
              "Type"
            ],
            members: {
              Number: {
                shape: "S1g"
              },
              Type: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        S1k: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Uri",
              "Type"
            ],
            members: {
              Uri: {
                type: "string",
                sensitive: true
              },
              Type: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        S1z: {
          type: "string",
          sensitive: true
        },
        S20: {
          type: "string",
          sensitive: true
        },
        S21: {
          type: "list",
          member: {}
        },
        S2g: {
          type: "list",
          member: {
            type: "integer"
          }
        },
        S4d: {
          type: "structure",
          members: {
            DefaultConferenceProviderArn: {}
          }
        },
        S4g: {
          type: "structure",
          members: {
            Arn: {},
            Name: {},
            Type: {},
            IPDialIn: {
              shape: "S13"
            },
            PSTNDialIn: {
              shape: "S16"
            },
            MeetingSetting: {
              shape: "S1b"
            }
          }
        },
        S4t: {
          type: "structure",
          members: {
            DeviceStatusDetails: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Feature: {},
                  Code: {}
                }
              }
            },
            ConnectionStatus: {},
            ConnectionStatusUpdatedTime: {
              type: "timestamp"
            }
          }
        },
        S5e: {
          type: "list",
          member: {}
        },
        S5u: {
          type: "structure",
          required: [
            "ParameterKey",
            "ParameterValue"
          ],
          members: {
            ParameterKey: {},
            ParameterValue: {}
          }
        },
        S92: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Values"
            ],
            members: {
              Key: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S97: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/alexaforbusiness-2017-11-09.paginators.json
var require_alexaforbusiness_2017_11_09_paginators = __commonJS({
  "node_modules/aws-sdk/apis/alexaforbusiness-2017-11-09.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListBusinessReportSchedules: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListConferenceProviders: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDeviceEvents: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListGatewayGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListGateways: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSkills: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSkillsStoreCategories: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSkillsStoreSkillsByCategory: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSmartHomeAppliances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTags: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchAddressBooks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchContacts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchDevices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchNetworkProfiles: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchProfiles: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchRooms: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchSkillGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchUsers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/alexaforbusiness.js
var require_alexaforbusiness = __commonJS({
  "node_modules/aws-sdk/clients/alexaforbusiness.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["alexaforbusiness"] = {};
    AWS3.AlexaForBusiness = Service.defineService("alexaforbusiness", ["2017-11-09"]);
    Object.defineProperty(apiLoader.services["alexaforbusiness"], "2017-11-09", {
      get: function get() {
        var model = require_alexaforbusiness_2017_11_09_min();
        model.paginators = require_alexaforbusiness_2017_11_09_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.AlexaForBusiness;
  }
});

// node_modules/aws-sdk/apis/cloud9-2017-09-23.min.json
var require_cloud9_2017_09_23_min = __commonJS({
  "node_modules/aws-sdk/apis/cloud9-2017-09-23.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-09-23",
        endpointPrefix: "cloud9",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Cloud9",
        serviceId: "Cloud9",
        signatureVersion: "v4",
        targetPrefix: "AWSCloud9WorkspaceManagementService",
        uid: "cloud9-2017-09-23"
      },
      operations: {
        CreateEnvironmentEC2: {
          input: {
            type: "structure",
            required: [
              "name",
              "instanceType"
            ],
            members: {
              name: {},
              description: {
                shape: "S3"
              },
              clientRequestToken: {},
              instanceType: {},
              subnetId: {},
              imageId: {},
              automaticStopTimeMinutes: {
                type: "integer"
              },
              ownerArn: {},
              tags: {
                shape: "Sa"
              },
              connectionType: {},
              dryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environmentId: {}
            }
          },
          idempotent: true
        },
        CreateEnvironmentMembership: {
          input: {
            type: "structure",
            required: [
              "environmentId",
              "userArn",
              "permissions"
            ],
            members: {
              environmentId: {},
              userArn: {},
              permissions: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "membership"
            ],
            members: {
              membership: {
                shape: "Sl"
              }
            }
          },
          idempotent: true
        },
        DeleteEnvironment: {
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteEnvironmentMembership: {
          input: {
            type: "structure",
            required: [
              "environmentId",
              "userArn"
            ],
            members: {
              environmentId: {},
              userArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DescribeEnvironmentMemberships: {
          input: {
            type: "structure",
            members: {
              userArn: {},
              environmentId: {},
              permissions: {
                type: "list",
                member: {}
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              memberships: {
                type: "list",
                member: {
                  shape: "Sl"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeEnvironmentStatus: {
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "status",
              "message"
            ],
            members: {
              status: {},
              message: {}
            }
          }
        },
        DescribeEnvironments: {
          input: {
            type: "structure",
            required: [
              "environmentIds"
            ],
            members: {
              environmentIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environments: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "type",
                    "arn",
                    "ownerArn"
                  ],
                  members: {
                    id: {},
                    name: {},
                    description: {
                      shape: "S3"
                    },
                    type: {},
                    connectionType: {},
                    arn: {},
                    ownerArn: {},
                    lifecycle: {
                      type: "structure",
                      members: {
                        status: {},
                        reason: {},
                        failureResource: {}
                      }
                    },
                    managedCredentialsStatus: {}
                  }
                }
              }
            }
          }
        },
        ListEnvironments: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              environmentIds: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sa"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {
                  shape: "Sc"
                },
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEnvironment: {
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {},
              name: {},
              description: {
                shape: "S3"
              },
              managedCredentialsAction: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateEnvironmentMembership: {
          input: {
            type: "structure",
            required: [
              "environmentId",
              "userArn",
              "permissions"
            ],
            members: {
              environmentId: {},
              userArn: {},
              permissions: {}
            }
          },
          output: {
            type: "structure",
            members: {
              membership: {
                shape: "Sl"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S3: {
          type: "string",
          sensitive: true
        },
        Sa: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {
                shape: "Sc"
              },
              Value: {
                type: "string",
                sensitive: true
              }
            },
            sensitive: true
          },
          sensitive: true
        },
        Sc: {
          type: "string",
          sensitive: true
        },
        Sl: {
          type: "structure",
          required: [
            "permissions",
            "userId",
            "userArn",
            "environmentId"
          ],
          members: {
            permissions: {},
            userId: {},
            userArn: {},
            environmentId: {},
            lastAccess: {
              type: "timestamp"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloud9-2017-09-23.paginators.json
var require_cloud9_2017_09_23_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloud9-2017-09-23.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeEnvironmentMemberships: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListEnvironments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cloud9.js
var require_cloud9 = __commonJS({
  "node_modules/aws-sdk/clients/cloud9.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["cloud9"] = {};
    AWS3.Cloud9 = Service.defineService("cloud9", ["2017-09-23"]);
    Object.defineProperty(apiLoader.services["cloud9"], "2017-09-23", {
      get: function get() {
        var model = require_cloud9_2017_09_23_min();
        model.paginators = require_cloud9_2017_09_23_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Cloud9;
  }
});

// node_modules/aws-sdk/apis/serverlessrepo-2017-09-08.min.json
var require_serverlessrepo_2017_09_08_min = __commonJS({
  "node_modules/aws-sdk/apis/serverlessrepo-2017-09-08.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2017-09-08",
        endpointPrefix: "serverlessrepo",
        signingName: "serverlessrepo",
        serviceFullName: "AWSServerlessApplicationRepository",
        serviceId: "ServerlessApplicationRepository",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "serverlessrepo-2017-09-08",
        signatureVersion: "v4"
      },
      operations: {
        CreateApplication: {
          http: {
            requestUri: "/applications",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Author: {
                locationName: "author"
              },
              Description: {
                locationName: "description"
              },
              HomePageUrl: {
                locationName: "homePageUrl"
              },
              Labels: {
                shape: "S3",
                locationName: "labels"
              },
              LicenseBody: {
                locationName: "licenseBody"
              },
              LicenseUrl: {
                locationName: "licenseUrl"
              },
              Name: {
                locationName: "name"
              },
              ReadmeBody: {
                locationName: "readmeBody"
              },
              ReadmeUrl: {
                locationName: "readmeUrl"
              },
              SemanticVersion: {
                locationName: "semanticVersion"
              },
              SourceCodeArchiveUrl: {
                locationName: "sourceCodeArchiveUrl"
              },
              SourceCodeUrl: {
                locationName: "sourceCodeUrl"
              },
              SpdxLicenseId: {
                locationName: "spdxLicenseId"
              },
              TemplateBody: {
                locationName: "templateBody"
              },
              TemplateUrl: {
                locationName: "templateUrl"
              }
            },
            required: [
              "Description",
              "Name",
              "Author"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {
                locationName: "applicationId"
              },
              Author: {
                locationName: "author"
              },
              CreationTime: {
                locationName: "creationTime"
              },
              Description: {
                locationName: "description"
              },
              HomePageUrl: {
                locationName: "homePageUrl"
              },
              IsVerifiedAuthor: {
                locationName: "isVerifiedAuthor",
                type: "boolean"
              },
              Labels: {
                shape: "S3",
                locationName: "labels"
              },
              LicenseUrl: {
                locationName: "licenseUrl"
              },
              Name: {
                locationName: "name"
              },
              ReadmeUrl: {
                locationName: "readmeUrl"
              },
              SpdxLicenseId: {
                locationName: "spdxLicenseId"
              },
              VerifiedAuthorUrl: {
                locationName: "verifiedAuthorUrl"
              },
              Version: {
                shape: "S6",
                locationName: "version"
              }
            }
          }
        },
        CreateApplicationVersion: {
          http: {
            method: "PUT",
            requestUri: "/applications/{applicationId}/versions/{semanticVersion}",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              SemanticVersion: {
                location: "uri",
                locationName: "semanticVersion"
              },
              SourceCodeArchiveUrl: {
                locationName: "sourceCodeArchiveUrl"
              },
              SourceCodeUrl: {
                locationName: "sourceCodeUrl"
              },
              TemplateBody: {
                locationName: "templateBody"
              },
              TemplateUrl: {
                locationName: "templateUrl"
              }
            },
            required: [
              "ApplicationId",
              "SemanticVersion"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {
                locationName: "applicationId"
              },
              CreationTime: {
                locationName: "creationTime"
              },
              ParameterDefinitions: {
                shape: "S7",
                locationName: "parameterDefinitions"
              },
              RequiredCapabilities: {
                shape: "Sa",
                locationName: "requiredCapabilities"
              },
              ResourcesSupported: {
                locationName: "resourcesSupported",
                type: "boolean"
              },
              SemanticVersion: {
                locationName: "semanticVersion"
              },
              SourceCodeArchiveUrl: {
                locationName: "sourceCodeArchiveUrl"
              },
              SourceCodeUrl: {
                locationName: "sourceCodeUrl"
              },
              TemplateUrl: {
                locationName: "templateUrl"
              }
            }
          }
        },
        CreateCloudFormationChangeSet: {
          http: {
            requestUri: "/applications/{applicationId}/changesets",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              Capabilities: {
                shape: "S3",
                locationName: "capabilities"
              },
              ChangeSetName: {
                locationName: "changeSetName"
              },
              ClientToken: {
                locationName: "clientToken"
              },
              Description: {
                locationName: "description"
              },
              NotificationArns: {
                shape: "S3",
                locationName: "notificationArns"
              },
              ParameterOverrides: {
                locationName: "parameterOverrides",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {
                      locationName: "name"
                    },
                    Value: {
                      locationName: "value"
                    }
                  },
                  required: [
                    "Value",
                    "Name"
                  ]
                }
              },
              ResourceTypes: {
                shape: "S3",
                locationName: "resourceTypes"
              },
              RollbackConfiguration: {
                locationName: "rollbackConfiguration",
                type: "structure",
                members: {
                  MonitoringTimeInMinutes: {
                    locationName: "monitoringTimeInMinutes",
                    type: "integer"
                  },
                  RollbackTriggers: {
                    locationName: "rollbackTriggers",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Arn: {
                          locationName: "arn"
                        },
                        Type: {
                          locationName: "type"
                        }
                      },
                      required: [
                        "Type",
                        "Arn"
                      ]
                    }
                  }
                }
              },
              SemanticVersion: {
                locationName: "semanticVersion"
              },
              StackName: {
                locationName: "stackName"
              },
              Tags: {
                locationName: "tags",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {
                      locationName: "key"
                    },
                    Value: {
                      locationName: "value"
                    }
                  },
                  required: [
                    "Value",
                    "Key"
                  ]
                }
              },
              TemplateId: {
                locationName: "templateId"
              }
            },
            required: [
              "ApplicationId",
              "StackName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {
                locationName: "applicationId"
              },
              ChangeSetId: {
                locationName: "changeSetId"
              },
              SemanticVersion: {
                locationName: "semanticVersion"
              },
              StackId: {
                locationName: "stackId"
              }
            }
          }
        },
        CreateCloudFormationTemplate: {
          http: {
            requestUri: "/applications/{applicationId}/templates",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              SemanticVersion: {
                locationName: "semanticVersion"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {
                locationName: "applicationId"
              },
              CreationTime: {
                locationName: "creationTime"
              },
              ExpirationTime: {
                locationName: "expirationTime"
              },
              SemanticVersion: {
                locationName: "semanticVersion"
              },
              Status: {
                locationName: "status"
              },
              TemplateId: {
                locationName: "templateId"
              },
              TemplateUrl: {
                locationName: "templateUrl"
              }
            }
          }
        },
        DeleteApplication: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{applicationId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              }
            },
            required: [
              "ApplicationId"
            ]
          }
        },
        GetApplication: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              SemanticVersion: {
                location: "querystring",
                locationName: "semanticVersion"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {
                locationName: "applicationId"
              },
              Author: {
                locationName: "author"
              },
              CreationTime: {
                locationName: "creationTime"
              },
              Description: {
                locationName: "description"
              },
              HomePageUrl: {
                locationName: "homePageUrl"
              },
              IsVerifiedAuthor: {
                locationName: "isVerifiedAuthor",
                type: "boolean"
              },
              Labels: {
                shape: "S3",
                locationName: "labels"
              },
              LicenseUrl: {
                locationName: "licenseUrl"
              },
              Name: {
                locationName: "name"
              },
              ReadmeUrl: {
                locationName: "readmeUrl"
              },
              SpdxLicenseId: {
                locationName: "spdxLicenseId"
              },
              VerifiedAuthorUrl: {
                locationName: "verifiedAuthorUrl"
              },
              Version: {
                shape: "S6",
                locationName: "version"
              }
            }
          }
        },
        GetApplicationPolicy: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Statements: {
                shape: "Sv",
                locationName: "statements"
              }
            }
          }
        },
        GetCloudFormationTemplate: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/templates/{templateId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              TemplateId: {
                location: "uri",
                locationName: "templateId"
              }
            },
            required: [
              "ApplicationId",
              "TemplateId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {
                locationName: "applicationId"
              },
              CreationTime: {
                locationName: "creationTime"
              },
              ExpirationTime: {
                locationName: "expirationTime"
              },
              SemanticVersion: {
                locationName: "semanticVersion"
              },
              Status: {
                locationName: "status"
              },
              TemplateId: {
                locationName: "templateId"
              },
              TemplateUrl: {
                locationName: "templateUrl"
              }
            }
          }
        },
        ListApplicationDependencies: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/dependencies",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxItems",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              SemanticVersion: {
                location: "querystring",
                locationName: "semanticVersion"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Dependencies: {
                locationName: "dependencies",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationId: {
                      locationName: "applicationId"
                    },
                    SemanticVersion: {
                      locationName: "semanticVersion"
                    }
                  },
                  required: [
                    "ApplicationId",
                    "SemanticVersion"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListApplicationVersions: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              MaxItems: {
                location: "querystring",
                locationName: "maxItems",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Versions: {
                locationName: "versions",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationId: {
                      locationName: "applicationId"
                    },
                    CreationTime: {
                      locationName: "creationTime"
                    },
                    SemanticVersion: {
                      locationName: "semanticVersion"
                    },
                    SourceCodeUrl: {
                      locationName: "sourceCodeUrl"
                    }
                  },
                  required: [
                    "CreationTime",
                    "ApplicationId",
                    "SemanticVersion"
                  ]
                }
              }
            }
          }
        },
        ListApplications: {
          http: {
            method: "GET",
            requestUri: "/applications",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxItems: {
                location: "querystring",
                locationName: "maxItems",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Applications: {
                locationName: "applications",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationId: {
                      locationName: "applicationId"
                    },
                    Author: {
                      locationName: "author"
                    },
                    CreationTime: {
                      locationName: "creationTime"
                    },
                    Description: {
                      locationName: "description"
                    },
                    HomePageUrl: {
                      locationName: "homePageUrl"
                    },
                    Labels: {
                      shape: "S3",
                      locationName: "labels"
                    },
                    Name: {
                      locationName: "name"
                    },
                    SpdxLicenseId: {
                      locationName: "spdxLicenseId"
                    }
                  },
                  required: [
                    "Description",
                    "Author",
                    "ApplicationId",
                    "Name"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        PutApplicationPolicy: {
          http: {
            method: "PUT",
            requestUri: "/applications/{applicationId}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              Statements: {
                shape: "Sv",
                locationName: "statements"
              }
            },
            required: [
              "ApplicationId",
              "Statements"
            ]
          },
          output: {
            type: "structure",
            members: {
              Statements: {
                shape: "Sv",
                locationName: "statements"
              }
            }
          }
        },
        UnshareApplication: {
          http: {
            requestUri: "/applications/{applicationId}/unshare",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              OrganizationId: {
                locationName: "organizationId"
              }
            },
            required: [
              "ApplicationId",
              "OrganizationId"
            ]
          }
        },
        UpdateApplication: {
          http: {
            method: "PATCH",
            requestUri: "/applications/{applicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              Author: {
                locationName: "author"
              },
              Description: {
                locationName: "description"
              },
              HomePageUrl: {
                locationName: "homePageUrl"
              },
              Labels: {
                shape: "S3",
                locationName: "labels"
              },
              ReadmeBody: {
                locationName: "readmeBody"
              },
              ReadmeUrl: {
                locationName: "readmeUrl"
              }
            },
            required: [
              "ApplicationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApplicationId: {
                locationName: "applicationId"
              },
              Author: {
                locationName: "author"
              },
              CreationTime: {
                locationName: "creationTime"
              },
              Description: {
                locationName: "description"
              },
              HomePageUrl: {
                locationName: "homePageUrl"
              },
              IsVerifiedAuthor: {
                locationName: "isVerifiedAuthor",
                type: "boolean"
              },
              Labels: {
                shape: "S3",
                locationName: "labels"
              },
              LicenseUrl: {
                locationName: "licenseUrl"
              },
              Name: {
                locationName: "name"
              },
              ReadmeUrl: {
                locationName: "readmeUrl"
              },
              SpdxLicenseId: {
                locationName: "spdxLicenseId"
              },
              VerifiedAuthorUrl: {
                locationName: "verifiedAuthorUrl"
              },
              Version: {
                shape: "S6",
                locationName: "version"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        S6: {
          type: "structure",
          members: {
            ApplicationId: {
              locationName: "applicationId"
            },
            CreationTime: {
              locationName: "creationTime"
            },
            ParameterDefinitions: {
              shape: "S7",
              locationName: "parameterDefinitions"
            },
            RequiredCapabilities: {
              shape: "Sa",
              locationName: "requiredCapabilities"
            },
            ResourcesSupported: {
              locationName: "resourcesSupported",
              type: "boolean"
            },
            SemanticVersion: {
              locationName: "semanticVersion"
            },
            SourceCodeArchiveUrl: {
              locationName: "sourceCodeArchiveUrl"
            },
            SourceCodeUrl: {
              locationName: "sourceCodeUrl"
            },
            TemplateUrl: {
              locationName: "templateUrl"
            }
          },
          required: [
            "TemplateUrl",
            "ParameterDefinitions",
            "ResourcesSupported",
            "CreationTime",
            "RequiredCapabilities",
            "ApplicationId",
            "SemanticVersion"
          ]
        },
        S7: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AllowedPattern: {
                locationName: "allowedPattern"
              },
              AllowedValues: {
                shape: "S3",
                locationName: "allowedValues"
              },
              ConstraintDescription: {
                locationName: "constraintDescription"
              },
              DefaultValue: {
                locationName: "defaultValue"
              },
              Description: {
                locationName: "description"
              },
              MaxLength: {
                locationName: "maxLength",
                type: "integer"
              },
              MaxValue: {
                locationName: "maxValue",
                type: "integer"
              },
              MinLength: {
                locationName: "minLength",
                type: "integer"
              },
              MinValue: {
                locationName: "minValue",
                type: "integer"
              },
              Name: {
                locationName: "name"
              },
              NoEcho: {
                locationName: "noEcho",
                type: "boolean"
              },
              ReferencedByResources: {
                shape: "S3",
                locationName: "referencedByResources"
              },
              Type: {
                locationName: "type"
              }
            },
            required: [
              "ReferencedByResources",
              "Name"
            ]
          }
        },
        Sa: {
          type: "list",
          member: {}
        },
        Sv: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Actions: {
                shape: "S3",
                locationName: "actions"
              },
              PrincipalOrgIDs: {
                shape: "S3",
                locationName: "principalOrgIDs"
              },
              Principals: {
                shape: "S3",
                locationName: "principals"
              },
              StatementId: {
                locationName: "statementId"
              }
            },
            required: [
              "Principals",
              "Actions"
            ]
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/serverlessrepo-2017-09-08.paginators.json
var require_serverlessrepo_2017_09_08_paginators = __commonJS({
  "node_modules/aws-sdk/apis/serverlessrepo-2017-09-08.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListApplicationVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxItems"
        },
        ListApplications: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxItems"
        },
        ListApplicationDependencies: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxItems"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/serverlessapplicationrepository.js
var require_serverlessapplicationrepository = __commonJS({
  "node_modules/aws-sdk/clients/serverlessapplicationrepository.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["serverlessapplicationrepository"] = {};
    AWS3.ServerlessApplicationRepository = Service.defineService("serverlessapplicationrepository", ["2017-09-08"]);
    Object.defineProperty(apiLoader.services["serverlessapplicationrepository"], "2017-09-08", {
      get: function get() {
        var model = require_serverlessrepo_2017_09_08_min();
        model.paginators = require_serverlessrepo_2017_09_08_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ServerlessApplicationRepository;
  }
});

// node_modules/aws-sdk/apis/servicediscovery-2017-03-14.min.json
var require_servicediscovery_2017_03_14_min = __commonJS({
  "node_modules/aws-sdk/apis/servicediscovery-2017-03-14.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-03-14",
        endpointPrefix: "servicediscovery",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "ServiceDiscovery",
        serviceFullName: "AWS Cloud Map",
        serviceId: "ServiceDiscovery",
        signatureVersion: "v4",
        targetPrefix: "Route53AutoNaming_v20170314",
        uid: "servicediscovery-2017-03-14"
      },
      operations: {
        CreateHttpNamespace: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              CreatorRequestId: {
                idempotencyToken: true
              },
              Description: {},
              Tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        CreatePrivateDnsNamespace: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Vpc"
            ],
            members: {
              Name: {},
              CreatorRequestId: {
                idempotencyToken: true
              },
              Description: {},
              Vpc: {},
              Tags: {
                shape: "S5"
              },
              Properties: {
                type: "structure",
                required: [
                  "DnsProperties"
                ],
                members: {
                  DnsProperties: {
                    type: "structure",
                    required: [
                      "SOA"
                    ],
                    members: {
                      SOA: {
                        shape: "Sf"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        CreatePublicDnsNamespace: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              CreatorRequestId: {
                idempotencyToken: true
              },
              Description: {},
              Tags: {
                shape: "S5"
              },
              Properties: {
                type: "structure",
                required: [
                  "DnsProperties"
                ],
                members: {
                  DnsProperties: {
                    type: "structure",
                    required: [
                      "SOA"
                    ],
                    members: {
                      SOA: {
                        shape: "Sf"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        CreateService: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              NamespaceId: {},
              CreatorRequestId: {
                idempotencyToken: true
              },
              Description: {},
              DnsConfig: {
                shape: "Sp"
              },
              HealthCheckConfig: {
                shape: "Su"
              },
              HealthCheckCustomConfig: {
                shape: "Sy"
              },
              Tags: {
                shape: "S5"
              },
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Service: {
                shape: "S11"
              }
            }
          }
        },
        DeleteNamespace: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        DeleteService: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterInstance: {
          input: {
            type: "structure",
            required: [
              "ServiceId",
              "InstanceId"
            ],
            members: {
              ServiceId: {},
              InstanceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        DiscoverInstances: {
          input: {
            type: "structure",
            required: [
              "NamespaceName",
              "ServiceName"
            ],
            members: {
              NamespaceName: {},
              ServiceName: {},
              MaxResults: {
                type: "integer"
              },
              QueryParameters: {
                shape: "S1f"
              },
              OptionalParameters: {
                shape: "S1f"
              },
              HealthStatus: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Instances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InstanceId: {},
                    NamespaceName: {},
                    ServiceName: {},
                    HealthStatus: {},
                    Attributes: {
                      shape: "S1f"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "data-"
          }
        },
        GetInstance: {
          input: {
            type: "structure",
            required: [
              "ServiceId",
              "InstanceId"
            ],
            members: {
              ServiceId: {},
              InstanceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Instance: {
                type: "structure",
                required: [
                  "Id"
                ],
                members: {
                  Id: {},
                  CreatorRequestId: {},
                  Attributes: {
                    shape: "S1f"
                  }
                }
              }
            }
          }
        },
        GetInstancesHealthStatus: {
          input: {
            type: "structure",
            required: [
              "ServiceId"
            ],
            members: {
              ServiceId: {},
              Instances: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                type: "map",
                key: {},
                value: {}
              },
              NextToken: {}
            }
          }
        },
        GetNamespace: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Namespace: {
                type: "structure",
                members: {
                  Id: {},
                  Arn: {},
                  Name: {},
                  Type: {},
                  Description: {},
                  ServiceCount: {
                    type: "integer"
                  },
                  Properties: {
                    shape: "S20"
                  },
                  CreateDate: {
                    type: "timestamp"
                  },
                  CreatorRequestId: {}
                }
              }
            }
          }
        },
        GetOperation: {
          input: {
            type: "structure",
            required: [
              "OperationId"
            ],
            members: {
              OperationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Operation: {
                type: "structure",
                members: {
                  Id: {},
                  Type: {},
                  Status: {},
                  ErrorMessage: {},
                  ErrorCode: {},
                  CreateDate: {
                    type: "timestamp"
                  },
                  UpdateDate: {
                    type: "timestamp"
                  },
                  Targets: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            }
          }
        },
        GetService: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Service: {
                shape: "S11"
              }
            }
          }
        },
        ListInstances: {
          input: {
            type: "structure",
            required: [
              "ServiceId"
            ],
            members: {
              ServiceId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Instances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Attributes: {
                      shape: "S1f"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListNamespaces: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S2m"
                    },
                    Condition: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Namespaces: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    Type: {},
                    Description: {},
                    ServiceCount: {
                      type: "integer"
                    },
                    Properties: {
                      shape: "S20"
                    },
                    CreateDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListOperations: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S2m"
                    },
                    Condition: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Operations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListServices: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S2m"
                    },
                    Condition: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Services: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    Type: {},
                    Description: {},
                    InstanceCount: {
                      type: "integer"
                    },
                    DnsConfig: {
                      shape: "Sp"
                    },
                    HealthCheckConfig: {
                      shape: "Su"
                    },
                    HealthCheckCustomConfig: {
                      shape: "Sy"
                    },
                    CreateDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S5"
              }
            }
          }
        },
        RegisterInstance: {
          input: {
            type: "structure",
            required: [
              "ServiceId",
              "InstanceId",
              "Attributes"
            ],
            members: {
              ServiceId: {},
              InstanceId: {},
              CreatorRequestId: {
                idempotencyToken: true
              },
              Attributes: {
                shape: "S1f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateHttpNamespace: {
          input: {
            type: "structure",
            required: [
              "Id",
              "Namespace"
            ],
            members: {
              Id: {},
              UpdaterRequestId: {
                idempotencyToken: true
              },
              Namespace: {
                type: "structure",
                required: [
                  "Description"
                ],
                members: {
                  Description: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        UpdateInstanceCustomHealthStatus: {
          input: {
            type: "structure",
            required: [
              "ServiceId",
              "InstanceId",
              "Status"
            ],
            members: {
              ServiceId: {},
              InstanceId: {},
              Status: {}
            }
          }
        },
        UpdatePrivateDnsNamespace: {
          input: {
            type: "structure",
            required: [
              "Id",
              "Namespace"
            ],
            members: {
              Id: {},
              UpdaterRequestId: {
                idempotencyToken: true
              },
              Namespace: {
                type: "structure",
                members: {
                  Description: {},
                  Properties: {
                    type: "structure",
                    required: [
                      "DnsProperties"
                    ],
                    members: {
                      DnsProperties: {
                        type: "structure",
                        required: [
                          "SOA"
                        ],
                        members: {
                          SOA: {
                            shape: "S3q"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        UpdatePublicDnsNamespace: {
          input: {
            type: "structure",
            required: [
              "Id",
              "Namespace"
            ],
            members: {
              Id: {},
              UpdaterRequestId: {
                idempotencyToken: true
              },
              Namespace: {
                type: "structure",
                members: {
                  Description: {},
                  Properties: {
                    type: "structure",
                    required: [
                      "DnsProperties"
                    ],
                    members: {
                      DnsProperties: {
                        type: "structure",
                        required: [
                          "SOA"
                        ],
                        members: {
                          SOA: {
                            shape: "S3q"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        },
        UpdateService: {
          input: {
            type: "structure",
            required: [
              "Id",
              "Service"
            ],
            members: {
              Id: {},
              Service: {
                type: "structure",
                members: {
                  Description: {},
                  DnsConfig: {
                    type: "structure",
                    required: [
                      "DnsRecords"
                    ],
                    members: {
                      DnsRecords: {
                        shape: "Sr"
                      }
                    }
                  },
                  HealthCheckConfig: {
                    shape: "Su"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationId: {}
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sf: {
          type: "structure",
          required: [
            "TTL"
          ],
          members: {
            TTL: {
              type: "long"
            }
          }
        },
        Sp: {
          type: "structure",
          required: [
            "DnsRecords"
          ],
          members: {
            NamespaceId: {
              deprecated: true,
              deprecatedMessage: "Top level attribute in request should be used to reference namespace-id"
            },
            RoutingPolicy: {},
            DnsRecords: {
              shape: "Sr"
            }
          }
        },
        Sr: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Type",
              "TTL"
            ],
            members: {
              Type: {},
              TTL: {
                type: "long"
              }
            }
          }
        },
        Su: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Type: {},
            ResourcePath: {},
            FailureThreshold: {
              type: "integer"
            }
          }
        },
        Sy: {
          type: "structure",
          members: {
            FailureThreshold: {
              deprecated: true,
              deprecatedMessage: "Configurable FailureThreshold of HealthCheckCustomConfig is deprecated.  It will always have value 1.",
              type: "integer"
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {},
            NamespaceId: {},
            Description: {},
            InstanceCount: {
              type: "integer"
            },
            DnsConfig: {
              shape: "Sp"
            },
            Type: {},
            HealthCheckConfig: {
              shape: "Su"
            },
            HealthCheckCustomConfig: {
              shape: "Sy"
            },
            CreateDate: {
              type: "timestamp"
            },
            CreatorRequestId: {}
          }
        },
        S1f: {
          type: "map",
          key: {},
          value: {}
        },
        S20: {
          type: "structure",
          members: {
            DnsProperties: {
              type: "structure",
              members: {
                HostedZoneId: {},
                SOA: {
                  shape: "Sf"
                }
              }
            },
            HttpProperties: {
              type: "structure",
              members: {
                HttpName: {}
              }
            }
          }
        },
        S2m: {
          type: "list",
          member: {}
        },
        S3q: {
          type: "structure",
          required: [
            "TTL"
          ],
          members: {
            TTL: {
              type: "long"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/servicediscovery-2017-03-14.paginators.json
var require_servicediscovery_2017_03_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/servicediscovery-2017-03-14.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetInstancesHealthStatus: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListNamespaces: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListOperations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListServices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/servicediscovery.js
var require_servicediscovery = __commonJS({
  "node_modules/aws-sdk/clients/servicediscovery.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["servicediscovery"] = {};
    AWS3.ServiceDiscovery = Service.defineService("servicediscovery", ["2017-03-14"]);
    Object.defineProperty(apiLoader.services["servicediscovery"], "2017-03-14", {
      get: function get() {
        var model = require_servicediscovery_2017_03_14_min();
        model.paginators = require_servicediscovery_2017_03_14_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ServiceDiscovery;
  }
});

// node_modules/aws-sdk/apis/workmail-2017-10-01.min.json
var require_workmail_2017_10_01_min = __commonJS({
  "node_modules/aws-sdk/apis/workmail-2017-10-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-10-01",
        endpointPrefix: "workmail",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon WorkMail",
        serviceId: "WorkMail",
        signatureVersion: "v4",
        targetPrefix: "WorkMailService",
        uid: "workmail-2017-10-01"
      },
      operations: {
        AssociateDelegateToResource: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "ResourceId",
              "EntityId"
            ],
            members: {
              OrganizationId: {},
              ResourceId: {},
              EntityId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        AssociateMemberToGroup: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "GroupId",
              "MemberId"
            ],
            members: {
              OrganizationId: {},
              GroupId: {},
              MemberId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        CancelMailboxExportJob: {
          input: {
            type: "structure",
            required: [
              "ClientToken",
              "JobId",
              "OrganizationId"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              JobId: {},
              OrganizationId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        CreateAlias: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "EntityId",
              "Alias"
            ],
            members: {
              OrganizationId: {},
              EntityId: {},
              Alias: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        CreateGroup: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "Name"
            ],
            members: {
              OrganizationId: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GroupId: {}
            }
          },
          idempotent: true
        },
        CreateMobileDeviceAccessRule: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "Name",
              "Effect"
            ],
            members: {
              OrganizationId: {},
              ClientToken: {
                idempotencyToken: true
              },
              Name: {},
              Description: {},
              Effect: {},
              DeviceTypes: {
                shape: "Sm"
              },
              NotDeviceTypes: {
                shape: "Sm"
              },
              DeviceModels: {
                shape: "So"
              },
              NotDeviceModels: {
                shape: "So"
              },
              DeviceOperatingSystems: {
                shape: "Sq"
              },
              NotDeviceOperatingSystems: {
                shape: "Sq"
              },
              DeviceUserAgents: {
                shape: "Ss"
              },
              NotDeviceUserAgents: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MobileDeviceAccessRuleId: {}
            }
          }
        },
        CreateOrganization: {
          input: {
            type: "structure",
            required: [
              "Alias"
            ],
            members: {
              DirectoryId: {},
              Alias: {},
              ClientToken: {
                idempotencyToken: true
              },
              Domains: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainName: {},
                    HostedZoneId: {}
                  }
                }
              },
              KmsKeyArn: {},
              EnableInteroperability: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationId: {}
            }
          },
          idempotent: true
        },
        CreateResource: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "Name",
              "Type"
            ],
            members: {
              OrganizationId: {},
              Name: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceId: {}
            }
          },
          idempotent: true
        },
        CreateUser: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "Name",
              "DisplayName",
              "Password"
            ],
            members: {
              OrganizationId: {},
              Name: {},
              DisplayName: {},
              Password: {
                shape: "S1d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserId: {}
            }
          },
          idempotent: true
        },
        DeleteAccessControlRule: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "Name"
            ],
            members: {
              OrganizationId: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAlias: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "EntityId",
              "Alias"
            ],
            members: {
              OrganizationId: {},
              EntityId: {},
              Alias: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteGroup: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "GroupId"
            ],
            members: {
              OrganizationId: {},
              GroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteMailboxPermissions: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "EntityId",
              "GranteeId"
            ],
            members: {
              OrganizationId: {},
              EntityId: {},
              GranteeId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteMobileDeviceAccessOverride: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "UserId",
              "DeviceId"
            ],
            members: {
              OrganizationId: {},
              UserId: {},
              DeviceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteMobileDeviceAccessRule: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "MobileDeviceAccessRuleId"
            ],
            members: {
              OrganizationId: {},
              MobileDeviceAccessRuleId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteOrganization: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "DeleteDirectory"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              OrganizationId: {},
              DeleteDirectory: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationId: {},
              State: {}
            }
          },
          idempotent: true
        },
        DeleteResource: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "ResourceId"
            ],
            members: {
              OrganizationId: {},
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteRetentionPolicy: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "Id"
            ],
            members: {
              OrganizationId: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteUser: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "UserId"
            ],
            members: {
              OrganizationId: {},
              UserId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeregisterFromWorkMail: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "EntityId"
            ],
            members: {
              OrganizationId: {},
              EntityId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeregisterMailDomain: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "DomainName"
            ],
            members: {
              OrganizationId: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DescribeGroup: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "GroupId"
            ],
            members: {
              OrganizationId: {},
              GroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GroupId: {},
              Name: {},
              Email: {},
              State: {},
              EnabledDate: {
                type: "timestamp"
              },
              DisabledDate: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DescribeInboundDmarcSettings: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Enforced: {
                type: "boolean"
              }
            }
          },
          idempotent: true
        },
        DescribeMailboxExportJob: {
          input: {
            type: "structure",
            required: [
              "JobId",
              "OrganizationId"
            ],
            members: {
              JobId: {},
              OrganizationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EntityId: {},
              Description: {},
              RoleArn: {},
              KmsKeyArn: {},
              S3BucketName: {},
              S3Prefix: {},
              S3Path: {},
              EstimatedProgress: {
                type: "integer"
              },
              State: {},
              ErrorInfo: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DescribeOrganization: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationId: {},
              Alias: {},
              State: {},
              DirectoryId: {},
              DirectoryType: {},
              DefaultMailDomain: {},
              CompletedDate: {
                type: "timestamp"
              },
              ErrorMessage: {},
              ARN: {}
            }
          },
          idempotent: true
        },
        DescribeResource: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "ResourceId"
            ],
            members: {
              OrganizationId: {},
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceId: {},
              Email: {},
              Name: {},
              Type: {},
              BookingOptions: {
                shape: "S2s"
              },
              State: {},
              EnabledDate: {
                type: "timestamp"
              },
              DisabledDate: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DescribeUser: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "UserId"
            ],
            members: {
              OrganizationId: {},
              UserId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserId: {},
              Name: {},
              Email: {},
              DisplayName: {},
              State: {},
              UserRole: {},
              EnabledDate: {
                type: "timestamp"
              },
              DisabledDate: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DisassociateDelegateFromResource: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "ResourceId",
              "EntityId"
            ],
            members: {
              OrganizationId: {},
              ResourceId: {},
              EntityId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DisassociateMemberFromGroup: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "GroupId",
              "MemberId"
            ],
            members: {
              OrganizationId: {},
              GroupId: {},
              MemberId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetAccessControlEffect: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "IpAddress",
              "Action",
              "UserId"
            ],
            members: {
              OrganizationId: {},
              IpAddress: {},
              Action: {},
              UserId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Effect: {},
              MatchedRules: {
                type: "list",
                member: {}
              }
            }
          }
        },
        GetDefaultRetentionPolicy: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              Name: {},
              Description: {},
              FolderConfigurations: {
                shape: "S38"
              }
            }
          },
          idempotent: true
        },
        GetMailDomain: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "DomainName"
            ],
            members: {
              OrganizationId: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Records: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    Hostname: {},
                    Value: {}
                  }
                }
              },
              IsTestDomain: {
                type: "boolean"
              },
              IsDefault: {
                type: "boolean"
              },
              OwnershipVerificationStatus: {},
              DkimVerificationStatus: {}
            }
          },
          idempotent: true
        },
        GetMailboxDetails: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "UserId"
            ],
            members: {
              OrganizationId: {},
              UserId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MailboxQuota: {
                type: "integer"
              },
              MailboxSize: {
                type: "double"
              }
            }
          },
          idempotent: true
        },
        GetMobileDeviceAccessEffect: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {},
              DeviceType: {},
              DeviceModel: {},
              DeviceOperatingSystem: {},
              DeviceUserAgent: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Effect: {},
              MatchedRules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MobileDeviceAccessRuleId: {},
                    Name: {}
                  }
                }
              }
            }
          }
        },
        GetMobileDeviceAccessOverride: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "UserId",
              "DeviceId"
            ],
            members: {
              OrganizationId: {},
              UserId: {},
              DeviceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UserId: {},
              DeviceId: {},
              Effect: {},
              Description: {},
              DateCreated: {
                type: "timestamp"
              },
              DateModified: {
                type: "timestamp"
              }
            }
          }
        },
        ListAccessControlRules: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Rules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Effect: {},
                    Description: {},
                    IpRanges: {
                      shape: "S3x"
                    },
                    NotIpRanges: {
                      shape: "S3x"
                    },
                    Actions: {
                      shape: "S3z"
                    },
                    NotActions: {
                      shape: "S3z"
                    },
                    UserIds: {
                      shape: "S40"
                    },
                    NotUserIds: {
                      shape: "S40"
                    },
                    DateCreated: {
                      type: "timestamp"
                    },
                    DateModified: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListAliases: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "EntityId"
            ],
            members: {
              OrganizationId: {},
              EntityId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Aliases: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListGroupMembers: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "GroupId"
            ],
            members: {
              OrganizationId: {},
              GroupId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Members: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Type: {},
                    State: {},
                    EnabledDate: {
                      type: "timestamp"
                    },
                    DisabledDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListGroups: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Groups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Email: {},
                    Name: {},
                    State: {},
                    EnabledDate: {
                      type: "timestamp"
                    },
                    DisabledDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListMailDomains: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MailDomains: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainName: {},
                    DefaultDomain: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListMailboxExportJobs: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Jobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    JobId: {},
                    EntityId: {},
                    Description: {},
                    S3BucketName: {},
                    S3Path: {},
                    EstimatedProgress: {
                      type: "integer"
                    },
                    State: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListMailboxPermissions: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "EntityId"
            ],
            members: {
              OrganizationId: {},
              EntityId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Permissions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "GranteeId",
                    "GranteeType",
                    "PermissionValues"
                  ],
                  members: {
                    GranteeId: {},
                    GranteeType: {},
                    PermissionValues: {
                      shape: "S4r"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListMobileDeviceAccessOverrides: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {},
              UserId: {},
              DeviceId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Overrides: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UserId: {},
                    DeviceId: {},
                    Effect: {},
                    Description: {},
                    DateCreated: {
                      type: "timestamp"
                    },
                    DateModified: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListMobileDeviceAccessRules: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Rules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MobileDeviceAccessRuleId: {},
                    Name: {},
                    Description: {},
                    Effect: {},
                    DeviceTypes: {
                      shape: "Sm"
                    },
                    NotDeviceTypes: {
                      shape: "Sm"
                    },
                    DeviceModels: {
                      shape: "So"
                    },
                    NotDeviceModels: {
                      shape: "So"
                    },
                    DeviceOperatingSystems: {
                      shape: "Sq"
                    },
                    NotDeviceOperatingSystems: {
                      shape: "Sq"
                    },
                    DeviceUserAgents: {
                      shape: "Ss"
                    },
                    NotDeviceUserAgents: {
                      shape: "Ss"
                    },
                    DateCreated: {
                      type: "timestamp"
                    },
                    DateModified: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListOrganizations: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OrganizationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    OrganizationId: {},
                    Alias: {},
                    DefaultMailDomain: {},
                    ErrorMessage: {},
                    State: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListResourceDelegates: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "ResourceId"
            ],
            members: {
              OrganizationId: {},
              ResourceId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Delegates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id",
                    "Type"
                  ],
                  members: {
                    Id: {},
                    Type: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListResources: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Resources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Email: {},
                    Name: {},
                    Type: {},
                    State: {},
                    EnabledDate: {
                      type: "timestamp"
                    },
                    DisabledDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S5f"
              }
            }
          }
        },
        ListUsers: {
          input: {
            type: "structure",
            required: [
              "OrganizationId"
            ],
            members: {
              OrganizationId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Users: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Email: {},
                    Name: {},
                    DisplayName: {},
                    State: {},
                    UserRole: {},
                    EnabledDate: {
                      type: "timestamp"
                    },
                    DisabledDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        PutAccessControlRule: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Effect",
              "Description",
              "OrganizationId"
            ],
            members: {
              Name: {},
              Effect: {},
              Description: {},
              IpRanges: {
                shape: "S3x"
              },
              NotIpRanges: {
                shape: "S3x"
              },
              Actions: {
                shape: "S3z"
              },
              NotActions: {
                shape: "S3z"
              },
              UserIds: {
                shape: "S40"
              },
              NotUserIds: {
                shape: "S40"
              },
              OrganizationId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutInboundDmarcSettings: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "Enforced"
            ],
            members: {
              OrganizationId: {},
              Enforced: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        PutMailboxPermissions: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "EntityId",
              "GranteeId",
              "PermissionValues"
            ],
            members: {
              OrganizationId: {},
              EntityId: {},
              GranteeId: {},
              PermissionValues: {
                shape: "S4r"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        PutMobileDeviceAccessOverride: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "UserId",
              "DeviceId",
              "Effect"
            ],
            members: {
              OrganizationId: {},
              UserId: {},
              DeviceId: {},
              Effect: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutRetentionPolicy: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "Name",
              "FolderConfigurations"
            ],
            members: {
              OrganizationId: {},
              Id: {},
              Name: {},
              Description: {
                type: "string",
                sensitive: true
              },
              FolderConfigurations: {
                shape: "S38"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        RegisterMailDomain: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "DomainName"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              OrganizationId: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        RegisterToWorkMail: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "EntityId",
              "Email"
            ],
            members: {
              OrganizationId: {},
              EntityId: {},
              Email: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        ResetPassword: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "UserId",
              "Password"
            ],
            members: {
              OrganizationId: {},
              UserId: {},
              Password: {
                shape: "S1d"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        StartMailboxExportJob: {
          input: {
            type: "structure",
            required: [
              "ClientToken",
              "OrganizationId",
              "EntityId",
              "RoleArn",
              "KmsKeyArn",
              "S3BucketName",
              "S3Prefix"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              OrganizationId: {},
              EntityId: {},
              Description: {},
              RoleArn: {},
              KmsKeyArn: {},
              S3BucketName: {},
              S3Prefix: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          },
          idempotent: true
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S5f"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDefaultMailDomain: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "DomainName"
            ],
            members: {
              OrganizationId: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateMailboxQuota: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "UserId",
              "MailboxQuota"
            ],
            members: {
              OrganizationId: {},
              UserId: {},
              MailboxQuota: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateMobileDeviceAccessRule: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "MobileDeviceAccessRuleId",
              "Name",
              "Effect"
            ],
            members: {
              OrganizationId: {},
              MobileDeviceAccessRuleId: {},
              Name: {},
              Description: {},
              Effect: {},
              DeviceTypes: {
                shape: "Sm"
              },
              NotDeviceTypes: {
                shape: "Sm"
              },
              DeviceModels: {
                shape: "So"
              },
              NotDeviceModels: {
                shape: "So"
              },
              DeviceOperatingSystems: {
                shape: "Sq"
              },
              NotDeviceOperatingSystems: {
                shape: "Sq"
              },
              DeviceUserAgents: {
                shape: "Ss"
              },
              NotDeviceUserAgents: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdatePrimaryEmailAddress: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "EntityId",
              "Email"
            ],
            members: {
              OrganizationId: {},
              EntityId: {},
              Email: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateResource: {
          input: {
            type: "structure",
            required: [
              "OrganizationId",
              "ResourceId"
            ],
            members: {
              OrganizationId: {},
              ResourceId: {},
              Name: {},
              BookingOptions: {
                shape: "S2s"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        }
      },
      shapes: {
        Sm: {
          type: "list",
          member: {}
        },
        So: {
          type: "list",
          member: {}
        },
        Sq: {
          type: "list",
          member: {}
        },
        Ss: {
          type: "list",
          member: {}
        },
        S1d: {
          type: "string",
          sensitive: true
        },
        S2s: {
          type: "structure",
          members: {
            AutoAcceptRequests: {
              type: "boolean"
            },
            AutoDeclineRecurringRequests: {
              type: "boolean"
            },
            AutoDeclineConflictingRequests: {
              type: "boolean"
            }
          }
        },
        S38: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Action"
            ],
            members: {
              Name: {},
              Action: {},
              Period: {
                type: "integer"
              }
            }
          }
        },
        S3x: {
          type: "list",
          member: {}
        },
        S3z: {
          type: "list",
          member: {}
        },
        S40: {
          type: "list",
          member: {}
        },
        S4r: {
          type: "list",
          member: {}
        },
        S5f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/workmail-2017-10-01.paginators.json
var require_workmail_2017_10_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/workmail-2017-10-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAliases: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListGroupMembers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMailDomains: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMailboxExportJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMailboxPermissions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMobileDeviceAccessOverrides: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListOrganizations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListResourceDelegates: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListResources: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListUsers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/workmail.js
var require_workmail = __commonJS({
  "node_modules/aws-sdk/clients/workmail.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["workmail"] = {};
    AWS3.WorkMail = Service.defineService("workmail", ["2017-10-01"]);
    Object.defineProperty(apiLoader.services["workmail"], "2017-10-01", {
      get: function get() {
        var model = require_workmail_2017_10_01_min();
        model.paginators = require_workmail_2017_10_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.WorkMail;
  }
});

// node_modules/aws-sdk/apis/autoscaling-plans-2018-01-06.min.json
var require_autoscaling_plans_2018_01_06_min = __commonJS({
  "node_modules/aws-sdk/apis/autoscaling-plans-2018-01-06.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-01-06",
        endpointPrefix: "autoscaling-plans",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Auto Scaling Plans",
        serviceId: "Auto Scaling Plans",
        signatureVersion: "v4",
        signingName: "autoscaling-plans",
        targetPrefix: "AnyScaleScalingPlannerFrontendService",
        uid: "autoscaling-plans-2018-01-06"
      },
      operations: {
        CreateScalingPlan: {
          input: {
            type: "structure",
            required: [
              "ScalingPlanName",
              "ApplicationSource",
              "ScalingInstructions"
            ],
            members: {
              ScalingPlanName: {},
              ApplicationSource: {
                shape: "S3"
              },
              ScalingInstructions: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ScalingPlanVersion"
            ],
            members: {
              ScalingPlanVersion: {
                type: "long"
              }
            }
          }
        },
        DeleteScalingPlan: {
          input: {
            type: "structure",
            required: [
              "ScalingPlanName",
              "ScalingPlanVersion"
            ],
            members: {
              ScalingPlanName: {},
              ScalingPlanVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeScalingPlanResources: {
          input: {
            type: "structure",
            required: [
              "ScalingPlanName",
              "ScalingPlanVersion"
            ],
            members: {
              ScalingPlanName: {},
              ScalingPlanVersion: {
                type: "long"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ScalingPlanResources: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ScalingPlanName",
                    "ScalingPlanVersion",
                    "ServiceNamespace",
                    "ResourceId",
                    "ScalableDimension",
                    "ScalingStatusCode"
                  ],
                  members: {
                    ScalingPlanName: {},
                    ScalingPlanVersion: {
                      type: "long"
                    },
                    ServiceNamespace: {},
                    ResourceId: {},
                    ScalableDimension: {},
                    ScalingPolicies: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "PolicyName",
                          "PolicyType"
                        ],
                        members: {
                          PolicyName: {},
                          PolicyType: {},
                          TargetTrackingConfiguration: {
                            shape: "Sh"
                          }
                        }
                      }
                    },
                    ScalingStatusCode: {},
                    ScalingStatusMessage: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeScalingPlans: {
          input: {
            type: "structure",
            members: {
              ScalingPlanNames: {
                type: "list",
                member: {}
              },
              ScalingPlanVersion: {
                type: "long"
              },
              ApplicationSources: {
                type: "list",
                member: {
                  shape: "S3"
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ScalingPlans: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ScalingPlanName",
                    "ScalingPlanVersion",
                    "ApplicationSource",
                    "ScalingInstructions",
                    "StatusCode"
                  ],
                  members: {
                    ScalingPlanName: {},
                    ScalingPlanVersion: {
                      type: "long"
                    },
                    ApplicationSource: {
                      shape: "S3"
                    },
                    ScalingInstructions: {
                      shape: "Sa"
                    },
                    StatusCode: {},
                    StatusMessage: {},
                    StatusStartTime: {
                      type: "timestamp"
                    },
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetScalingPlanResourceForecastData: {
          input: {
            type: "structure",
            required: [
              "ScalingPlanName",
              "ScalingPlanVersion",
              "ServiceNamespace",
              "ResourceId",
              "ScalableDimension",
              "ForecastDataType",
              "StartTime",
              "EndTime"
            ],
            members: {
              ScalingPlanName: {},
              ScalingPlanVersion: {
                type: "long"
              },
              ServiceNamespace: {},
              ResourceId: {},
              ScalableDimension: {},
              ForecastDataType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Datapoints"
            ],
            members: {
              Datapoints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {
                      type: "timestamp"
                    },
                    Value: {
                      type: "double"
                    }
                  }
                }
              }
            }
          }
        },
        UpdateScalingPlan: {
          input: {
            type: "structure",
            required: [
              "ScalingPlanName",
              "ScalingPlanVersion"
            ],
            members: {
              ScalingPlanName: {},
              ScalingPlanVersion: {
                type: "long"
              },
              ApplicationSource: {
                shape: "S3"
              },
              ScalingInstructions: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          members: {
            CloudFormationStackARN: {},
            TagFilters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Values: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        Sa: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ServiceNamespace",
              "ResourceId",
              "ScalableDimension",
              "MinCapacity",
              "MaxCapacity",
              "TargetTrackingConfigurations"
            ],
            members: {
              ServiceNamespace: {},
              ResourceId: {},
              ScalableDimension: {},
              MinCapacity: {
                type: "integer"
              },
              MaxCapacity: {
                type: "integer"
              },
              TargetTrackingConfigurations: {
                type: "list",
                member: {
                  shape: "Sh"
                }
              },
              PredefinedLoadMetricSpecification: {
                type: "structure",
                required: [
                  "PredefinedLoadMetricType"
                ],
                members: {
                  PredefinedLoadMetricType: {},
                  ResourceLabel: {}
                }
              },
              CustomizedLoadMetricSpecification: {
                type: "structure",
                required: [
                  "MetricName",
                  "Namespace",
                  "Statistic"
                ],
                members: {
                  MetricName: {},
                  Namespace: {},
                  Dimensions: {
                    shape: "So"
                  },
                  Statistic: {},
                  Unit: {}
                }
              },
              ScheduledActionBufferTime: {
                type: "integer"
              },
              PredictiveScalingMaxCapacityBehavior: {},
              PredictiveScalingMaxCapacityBuffer: {
                type: "integer"
              },
              PredictiveScalingMode: {},
              ScalingPolicyUpdateBehavior: {},
              DisableDynamicScaling: {
                type: "boolean"
              }
            }
          }
        },
        Sh: {
          type: "structure",
          required: [
            "TargetValue"
          ],
          members: {
            PredefinedScalingMetricSpecification: {
              type: "structure",
              required: [
                "PredefinedScalingMetricType"
              ],
              members: {
                PredefinedScalingMetricType: {},
                ResourceLabel: {}
              }
            },
            CustomizedScalingMetricSpecification: {
              type: "structure",
              required: [
                "MetricName",
                "Namespace",
                "Statistic"
              ],
              members: {
                MetricName: {},
                Namespace: {},
                Dimensions: {
                  shape: "So"
                },
                Statistic: {},
                Unit: {}
              }
            },
            TargetValue: {
              type: "double"
            },
            DisableScaleIn: {
              type: "boolean"
            },
            ScaleOutCooldown: {
              type: "integer"
            },
            ScaleInCooldown: {
              type: "integer"
            },
            EstimatedInstanceWarmup: {
              type: "integer"
            }
          }
        },
        So: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/autoscaling-plans-2018-01-06.paginators.json
var require_autoscaling_plans_2018_01_06_paginators = __commonJS({
  "node_modules/aws-sdk/apis/autoscaling-plans-2018-01-06.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/autoscalingplans.js
var require_autoscalingplans = __commonJS({
  "node_modules/aws-sdk/clients/autoscalingplans.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["autoscalingplans"] = {};
    AWS3.AutoScalingPlans = Service.defineService("autoscalingplans", ["2018-01-06"]);
    Object.defineProperty(apiLoader.services["autoscalingplans"], "2018-01-06", {
      get: function get() {
        var model = require_autoscaling_plans_2018_01_06_min();
        model.paginators = require_autoscaling_plans_2018_01_06_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.AutoScalingPlans;
  }
});

// node_modules/aws-sdk/apis/transcribe-2017-10-26.min.json
var require_transcribe_2017_10_26_min = __commonJS({
  "node_modules/aws-sdk/apis/transcribe-2017-10-26.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-10-26",
        endpointPrefix: "transcribe",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Transcribe Service",
        serviceId: "Transcribe",
        signatureVersion: "v4",
        signingName: "transcribe",
        targetPrefix: "Transcribe",
        uid: "transcribe-2017-10-26"
      },
      operations: {
        CreateCallAnalyticsCategory: {
          input: {
            type: "structure",
            required: [
              "CategoryName",
              "Rules"
            ],
            members: {
              CategoryName: {},
              Rules: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CategoryProperties: {
                shape: "Sl"
              }
            }
          }
        },
        CreateLanguageModel: {
          input: {
            type: "structure",
            required: [
              "LanguageCode",
              "BaseModelName",
              "ModelName",
              "InputDataConfig"
            ],
            members: {
              LanguageCode: {},
              BaseModelName: {},
              ModelName: {},
              InputDataConfig: {
                shape: "Sr"
              },
              Tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LanguageCode: {},
              BaseModelName: {},
              ModelName: {},
              InputDataConfig: {
                shape: "Sr"
              },
              ModelStatus: {}
            }
          }
        },
        CreateMedicalVocabulary: {
          input: {
            type: "structure",
            required: [
              "VocabularyName",
              "LanguageCode",
              "VocabularyFileUri"
            ],
            members: {
              VocabularyName: {},
              LanguageCode: {},
              VocabularyFileUri: {},
              Tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VocabularyName: {},
              LanguageCode: {},
              VocabularyState: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              FailureReason: {}
            }
          }
        },
        CreateVocabulary: {
          input: {
            type: "structure",
            required: [
              "VocabularyName",
              "LanguageCode"
            ],
            members: {
              VocabularyName: {},
              LanguageCode: {},
              Phrases: {
                shape: "S17"
              },
              VocabularyFileUri: {},
              Tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VocabularyName: {},
              LanguageCode: {},
              VocabularyState: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              FailureReason: {}
            }
          }
        },
        CreateVocabularyFilter: {
          input: {
            type: "structure",
            required: [
              "VocabularyFilterName",
              "LanguageCode"
            ],
            members: {
              VocabularyFilterName: {},
              LanguageCode: {},
              Words: {
                shape: "S1c"
              },
              VocabularyFilterFileUri: {},
              Tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VocabularyFilterName: {},
              LanguageCode: {},
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteCallAnalyticsCategory: {
          input: {
            type: "structure",
            required: [
              "CategoryName"
            ],
            members: {
              CategoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCallAnalyticsJob: {
          input: {
            type: "structure",
            required: [
              "CallAnalyticsJobName"
            ],
            members: {
              CallAnalyticsJobName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLanguageModel: {
          input: {
            type: "structure",
            required: [
              "ModelName"
            ],
            members: {
              ModelName: {}
            }
          }
        },
        DeleteMedicalTranscriptionJob: {
          input: {
            type: "structure",
            required: [
              "MedicalTranscriptionJobName"
            ],
            members: {
              MedicalTranscriptionJobName: {}
            }
          }
        },
        DeleteMedicalVocabulary: {
          input: {
            type: "structure",
            required: [
              "VocabularyName"
            ],
            members: {
              VocabularyName: {}
            }
          }
        },
        DeleteTranscriptionJob: {
          input: {
            type: "structure",
            required: [
              "TranscriptionJobName"
            ],
            members: {
              TranscriptionJobName: {}
            }
          }
        },
        DeleteVocabulary: {
          input: {
            type: "structure",
            required: [
              "VocabularyName"
            ],
            members: {
              VocabularyName: {}
            }
          }
        },
        DeleteVocabularyFilter: {
          input: {
            type: "structure",
            required: [
              "VocabularyFilterName"
            ],
            members: {
              VocabularyFilterName: {}
            }
          }
        },
        DescribeLanguageModel: {
          input: {
            type: "structure",
            required: [
              "ModelName"
            ],
            members: {
              ModelName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LanguageModel: {
                shape: "S1t"
              }
            }
          }
        },
        GetCallAnalyticsCategory: {
          input: {
            type: "structure",
            required: [
              "CategoryName"
            ],
            members: {
              CategoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CategoryProperties: {
                shape: "Sl"
              }
            }
          }
        },
        GetCallAnalyticsJob: {
          input: {
            type: "structure",
            required: [
              "CallAnalyticsJobName"
            ],
            members: {
              CallAnalyticsJobName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CallAnalyticsJob: {
                shape: "S1y"
              }
            }
          }
        },
        GetMedicalTranscriptionJob: {
          input: {
            type: "structure",
            required: [
              "MedicalTranscriptionJobName"
            ],
            members: {
              MedicalTranscriptionJobName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MedicalTranscriptionJob: {
                shape: "S2g"
              }
            }
          }
        },
        GetMedicalVocabulary: {
          input: {
            type: "structure",
            required: [
              "VocabularyName"
            ],
            members: {
              VocabularyName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VocabularyName: {},
              LanguageCode: {},
              VocabularyState: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              FailureReason: {},
              DownloadUri: {}
            }
          }
        },
        GetTranscriptionJob: {
          input: {
            type: "structure",
            required: [
              "TranscriptionJobName"
            ],
            members: {
              TranscriptionJobName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TranscriptionJob: {
                shape: "S2t"
              }
            }
          }
        },
        GetVocabulary: {
          input: {
            type: "structure",
            required: [
              "VocabularyName"
            ],
            members: {
              VocabularyName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VocabularyName: {},
              LanguageCode: {},
              VocabularyState: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              FailureReason: {},
              DownloadUri: {}
            }
          }
        },
        GetVocabularyFilter: {
          input: {
            type: "structure",
            required: [
              "VocabularyFilterName"
            ],
            members: {
              VocabularyFilterName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VocabularyFilterName: {},
              LanguageCode: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              DownloadUri: {}
            }
          }
        },
        ListCallAnalyticsCategories: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Categories: {
                type: "list",
                member: {
                  shape: "Sl"
                }
              }
            }
          }
        },
        ListCallAnalyticsJobs: {
          input: {
            type: "structure",
            members: {
              Status: {},
              JobNameContains: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              NextToken: {},
              CallAnalyticsJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CallAnalyticsJobName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    CompletionTime: {
                      type: "timestamp"
                    },
                    LanguageCode: {},
                    CallAnalyticsJobStatus: {},
                    FailureReason: {}
                  }
                }
              }
            }
          }
        },
        ListLanguageModels: {
          input: {
            type: "structure",
            members: {
              StatusEquals: {},
              NameContains: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Models: {
                type: "list",
                member: {
                  shape: "S1t"
                }
              }
            }
          }
        },
        ListMedicalTranscriptionJobs: {
          input: {
            type: "structure",
            members: {
              Status: {},
              JobNameContains: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              NextToken: {},
              MedicalTranscriptionJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MedicalTranscriptionJobName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    CompletionTime: {
                      type: "timestamp"
                    },
                    LanguageCode: {},
                    TranscriptionJobStatus: {},
                    FailureReason: {},
                    OutputLocationType: {},
                    Specialty: {},
                    ContentIdentificationType: {},
                    Type: {}
                  }
                }
              }
            }
          }
        },
        ListMedicalVocabularies: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              StateEquals: {},
              NameContains: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              NextToken: {},
              Vocabularies: {
                shape: "S3o"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Su"
              }
            }
          }
        },
        ListTranscriptionJobs: {
          input: {
            type: "structure",
            members: {
              Status: {},
              JobNameContains: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              NextToken: {},
              TranscriptionJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TranscriptionJobName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    StartTime: {
                      type: "timestamp"
                    },
                    CompletionTime: {
                      type: "timestamp"
                    },
                    LanguageCode: {},
                    TranscriptionJobStatus: {},
                    FailureReason: {},
                    OutputLocationType: {},
                    ContentRedaction: {
                      shape: "S27"
                    },
                    ModelSettings: {
                      shape: "S2v"
                    },
                    IdentifyLanguage: {
                      type: "boolean"
                    },
                    IdentifiedLanguageScore: {
                      type: "float"
                    }
                  }
                }
              }
            }
          }
        },
        ListVocabularies: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              StateEquals: {},
              NameContains: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              NextToken: {},
              Vocabularies: {
                shape: "S3o"
              }
            }
          }
        },
        ListVocabularyFilters: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              NameContains: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              VocabularyFilters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VocabularyFilterName: {},
                    LanguageCode: {},
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        StartCallAnalyticsJob: {
          input: {
            type: "structure",
            required: [
              "CallAnalyticsJobName",
              "Media",
              "DataAccessRoleArn"
            ],
            members: {
              CallAnalyticsJobName: {},
              Media: {
                shape: "S22"
              },
              OutputLocation: {},
              OutputEncryptionKMSKeyId: {},
              DataAccessRoleArn: {},
              Settings: {
                shape: "S25"
              },
              ChannelDefinitions: {
                shape: "S2b"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CallAnalyticsJob: {
                shape: "S1y"
              }
            }
          }
        },
        StartMedicalTranscriptionJob: {
          input: {
            type: "structure",
            required: [
              "MedicalTranscriptionJobName",
              "LanguageCode",
              "Media",
              "OutputBucketName",
              "Specialty",
              "Type"
            ],
            members: {
              MedicalTranscriptionJobName: {},
              LanguageCode: {},
              MediaSampleRateHertz: {
                type: "integer"
              },
              MediaFormat: {},
              Media: {
                shape: "S22"
              },
              OutputBucketName: {},
              OutputKey: {},
              OutputEncryptionKMSKeyId: {},
              KMSEncryptionContext: {
                shape: "S49"
              },
              Settings: {
                shape: "S2j"
              },
              ContentIdentificationType: {},
              Specialty: {},
              Type: {},
              Tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MedicalTranscriptionJob: {
                shape: "S2g"
              }
            }
          }
        },
        StartTranscriptionJob: {
          input: {
            type: "structure",
            required: [
              "TranscriptionJobName",
              "Media"
            ],
            members: {
              TranscriptionJobName: {},
              LanguageCode: {},
              MediaSampleRateHertz: {
                type: "integer"
              },
              MediaFormat: {},
              Media: {
                shape: "S22"
              },
              OutputBucketName: {},
              OutputKey: {},
              OutputEncryptionKMSKeyId: {},
              KMSEncryptionContext: {
                shape: "S49"
              },
              Settings: {
                shape: "S2u"
              },
              ModelSettings: {
                shape: "S2v"
              },
              JobExecutionSettings: {
                shape: "S2w"
              },
              ContentRedaction: {
                shape: "S27"
              },
              IdentifyLanguage: {
                type: "boolean"
              },
              LanguageOptions: {
                shape: "S2a"
              },
              Subtitles: {
                type: "structure",
                members: {
                  Formats: {
                    shape: "S2y"
                  }
                }
              },
              Tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TranscriptionJob: {
                shape: "S2t"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateCallAnalyticsCategory: {
          input: {
            type: "structure",
            required: [
              "CategoryName",
              "Rules"
            ],
            members: {
              CategoryName: {},
              Rules: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CategoryProperties: {
                shape: "Sl"
              }
            }
          }
        },
        UpdateMedicalVocabulary: {
          input: {
            type: "structure",
            required: [
              "VocabularyName",
              "LanguageCode"
            ],
            members: {
              VocabularyName: {},
              LanguageCode: {},
              VocabularyFileUri: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VocabularyName: {},
              LanguageCode: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              VocabularyState: {}
            }
          }
        },
        UpdateVocabulary: {
          input: {
            type: "structure",
            required: [
              "VocabularyName",
              "LanguageCode"
            ],
            members: {
              VocabularyName: {},
              LanguageCode: {},
              Phrases: {
                shape: "S17"
              },
              VocabularyFileUri: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VocabularyName: {},
              LanguageCode: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              VocabularyState: {}
            }
          }
        },
        UpdateVocabularyFilter: {
          input: {
            type: "structure",
            required: [
              "VocabularyFilterName"
            ],
            members: {
              VocabularyFilterName: {},
              Words: {
                shape: "S1c"
              },
              VocabularyFilterFileUri: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VocabularyFilterName: {},
              LanguageCode: {},
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            members: {
              NonTalkTimeFilter: {
                type: "structure",
                members: {
                  Threshold: {
                    type: "long"
                  },
                  AbsoluteTimeRange: {
                    shape: "S7"
                  },
                  RelativeTimeRange: {
                    shape: "S8"
                  },
                  Negate: {
                    type: "boolean"
                  }
                }
              },
              InterruptionFilter: {
                type: "structure",
                members: {
                  Threshold: {
                    type: "long"
                  },
                  ParticipantRole: {},
                  AbsoluteTimeRange: {
                    shape: "S7"
                  },
                  RelativeTimeRange: {
                    shape: "S8"
                  },
                  Negate: {
                    type: "boolean"
                  }
                }
              },
              TranscriptFilter: {
                type: "structure",
                required: [
                  "TranscriptFilterType",
                  "Targets"
                ],
                members: {
                  TranscriptFilterType: {},
                  AbsoluteTimeRange: {
                    shape: "S7"
                  },
                  RelativeTimeRange: {
                    shape: "S8"
                  },
                  ParticipantRole: {},
                  Negate: {
                    type: "boolean"
                  },
                  Targets: {
                    type: "list",
                    member: {}
                  }
                }
              },
              SentimentFilter: {
                type: "structure",
                required: [
                  "Sentiments"
                ],
                members: {
                  Sentiments: {
                    type: "list",
                    member: {}
                  },
                  AbsoluteTimeRange: {
                    shape: "S7"
                  },
                  RelativeTimeRange: {
                    shape: "S8"
                  },
                  ParticipantRole: {},
                  Negate: {
                    type: "boolean"
                  }
                }
              }
            },
            union: true
          }
        },
        S7: {
          type: "structure",
          members: {
            StartTime: {
              type: "long"
            },
            EndTime: {
              type: "long"
            },
            First: {
              type: "long"
            },
            Last: {
              type: "long"
            }
          }
        },
        S8: {
          type: "structure",
          members: {
            StartPercentage: {
              type: "integer"
            },
            EndPercentage: {
              type: "integer"
            },
            First: {
              type: "integer"
            },
            Last: {
              type: "integer"
            }
          }
        },
        Sl: {
          type: "structure",
          members: {
            CategoryName: {},
            Rules: {
              shape: "S3"
            },
            CreateTime: {
              type: "timestamp"
            },
            LastUpdateTime: {
              type: "timestamp"
            }
          }
        },
        Sr: {
          type: "structure",
          required: [
            "S3Uri",
            "DataAccessRoleArn"
          ],
          members: {
            S3Uri: {},
            TuningDataS3Uri: {},
            DataAccessRoleArn: {}
          }
        },
        Su: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S17: {
          type: "list",
          member: {}
        },
        S1c: {
          type: "list",
          member: {}
        },
        S1t: {
          type: "structure",
          members: {
            ModelName: {},
            CreateTime: {
              type: "timestamp"
            },
            LastModifiedTime: {
              type: "timestamp"
            },
            LanguageCode: {},
            BaseModelName: {},
            ModelStatus: {},
            UpgradeAvailability: {
              type: "boolean"
            },
            FailureReason: {},
            InputDataConfig: {
              shape: "Sr"
            }
          }
        },
        S1y: {
          type: "structure",
          members: {
            CallAnalyticsJobName: {},
            CallAnalyticsJobStatus: {},
            LanguageCode: {},
            MediaSampleRateHertz: {
              type: "integer"
            },
            MediaFormat: {},
            Media: {
              shape: "S22"
            },
            Transcript: {
              shape: "S23"
            },
            StartTime: {
              type: "timestamp"
            },
            CreationTime: {
              type: "timestamp"
            },
            CompletionTime: {
              type: "timestamp"
            },
            FailureReason: {},
            DataAccessRoleArn: {},
            IdentifiedLanguageScore: {
              type: "float"
            },
            Settings: {
              shape: "S25"
            },
            ChannelDefinitions: {
              shape: "S2b"
            }
          }
        },
        S22: {
          type: "structure",
          members: {
            MediaFileUri: {},
            RedactedMediaFileUri: {}
          }
        },
        S23: {
          type: "structure",
          members: {
            TranscriptFileUri: {},
            RedactedTranscriptFileUri: {}
          }
        },
        S25: {
          type: "structure",
          members: {
            VocabularyName: {},
            VocabularyFilterName: {},
            VocabularyFilterMethod: {},
            LanguageModelName: {},
            ContentRedaction: {
              shape: "S27"
            },
            LanguageOptions: {
              shape: "S2a"
            }
          }
        },
        S27: {
          type: "structure",
          required: [
            "RedactionType",
            "RedactionOutput"
          ],
          members: {
            RedactionType: {},
            RedactionOutput: {}
          }
        },
        S2a: {
          type: "list",
          member: {}
        },
        S2b: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ChannelId: {
                type: "integer"
              },
              ParticipantRole: {}
            }
          }
        },
        S2g: {
          type: "structure",
          members: {
            MedicalTranscriptionJobName: {},
            TranscriptionJobStatus: {},
            LanguageCode: {},
            MediaSampleRateHertz: {
              type: "integer"
            },
            MediaFormat: {},
            Media: {
              shape: "S22"
            },
            Transcript: {
              type: "structure",
              members: {
                TranscriptFileUri: {}
              }
            },
            StartTime: {
              type: "timestamp"
            },
            CreationTime: {
              type: "timestamp"
            },
            CompletionTime: {
              type: "timestamp"
            },
            FailureReason: {},
            Settings: {
              shape: "S2j"
            },
            ContentIdentificationType: {},
            Specialty: {},
            Type: {},
            Tags: {
              shape: "Su"
            }
          }
        },
        S2j: {
          type: "structure",
          members: {
            ShowSpeakerLabels: {
              type: "boolean"
            },
            MaxSpeakerLabels: {
              type: "integer"
            },
            ChannelIdentification: {
              type: "boolean"
            },
            ShowAlternatives: {
              type: "boolean"
            },
            MaxAlternatives: {
              type: "integer"
            },
            VocabularyName: {}
          }
        },
        S2t: {
          type: "structure",
          members: {
            TranscriptionJobName: {},
            TranscriptionJobStatus: {},
            LanguageCode: {},
            MediaSampleRateHertz: {
              type: "integer"
            },
            MediaFormat: {},
            Media: {
              shape: "S22"
            },
            Transcript: {
              shape: "S23"
            },
            StartTime: {
              type: "timestamp"
            },
            CreationTime: {
              type: "timestamp"
            },
            CompletionTime: {
              type: "timestamp"
            },
            FailureReason: {},
            Settings: {
              shape: "S2u"
            },
            ModelSettings: {
              shape: "S2v"
            },
            JobExecutionSettings: {
              shape: "S2w"
            },
            ContentRedaction: {
              shape: "S27"
            },
            IdentifyLanguage: {
              type: "boolean"
            },
            LanguageOptions: {
              shape: "S2a"
            },
            IdentifiedLanguageScore: {
              type: "float"
            },
            Tags: {
              shape: "Su"
            },
            Subtitles: {
              type: "structure",
              members: {
                Formats: {
                  shape: "S2y"
                },
                SubtitleFileUris: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        S2u: {
          type: "structure",
          members: {
            VocabularyName: {},
            ShowSpeakerLabels: {
              type: "boolean"
            },
            MaxSpeakerLabels: {
              type: "integer"
            },
            ChannelIdentification: {
              type: "boolean"
            },
            ShowAlternatives: {
              type: "boolean"
            },
            MaxAlternatives: {
              type: "integer"
            },
            VocabularyFilterName: {},
            VocabularyFilterMethod: {}
          }
        },
        S2v: {
          type: "structure",
          members: {
            LanguageModelName: {}
          }
        },
        S2w: {
          type: "structure",
          members: {
            AllowDeferredExecution: {
              type: "boolean"
            },
            DataAccessRoleArn: {}
          }
        },
        S2y: {
          type: "list",
          member: {}
        },
        S3o: {
          type: "list",
          member: {
            type: "structure",
            members: {
              VocabularyName: {},
              LanguageCode: {},
              LastModifiedTime: {
                type: "timestamp"
              },
              VocabularyState: {}
            }
          }
        },
        S49: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/transcribe-2017-10-26.paginators.json
var require_transcribe_2017_10_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/transcribe-2017-10-26.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListCallAnalyticsCategories: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListCallAnalyticsJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListLanguageModels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMedicalTranscriptionJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMedicalVocabularies: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTranscriptionJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListVocabularies: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListVocabularyFilters: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/transcribeservice.js
var require_transcribeservice = __commonJS({
  "node_modules/aws-sdk/clients/transcribeservice.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["transcribeservice"] = {};
    AWS3.TranscribeService = Service.defineService("transcribeservice", ["2017-10-26"]);
    Object.defineProperty(apiLoader.services["transcribeservice"], "2017-10-26", {
      get: function get() {
        var model = require_transcribe_2017_10_26_min();
        model.paginators = require_transcribe_2017_10_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.TranscribeService;
  }
});

// node_modules/aws-sdk/apis/connect-2017-08-08.min.json
var require_connect_2017_08_08_min = __commonJS({
  "node_modules/aws-sdk/apis/connect-2017-08-08.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-08-08",
        endpointPrefix: "connect",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon Connect",
        serviceFullName: "Amazon Connect Service",
        serviceId: "Connect",
        signatureVersion: "v4",
        signingName: "connect",
        uid: "connect-2017-08-08"
      },
      operations: {
        AssociateApprovedOrigin: {
          http: {
            method: "PUT",
            requestUri: "/instance/{InstanceId}/approved-origin"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Origin"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Origin: {}
            }
          }
        },
        AssociateBot: {
          http: {
            method: "PUT",
            requestUri: "/instance/{InstanceId}/bot"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              LexBot: {
                shape: "S5"
              },
              LexV2Bot: {
                shape: "S8"
              }
            }
          }
        },
        AssociateInstanceStorageConfig: {
          http: {
            method: "PUT",
            requestUri: "/instance/{InstanceId}/storage-config"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ResourceType",
              "StorageConfig"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ResourceType: {},
              StorageConfig: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationId: {}
            }
          }
        },
        AssociateLambdaFunction: {
          http: {
            method: "PUT",
            requestUri: "/instance/{InstanceId}/lambda-function"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "FunctionArn"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              FunctionArn: {}
            }
          }
        },
        AssociateLexBot: {
          http: {
            method: "PUT",
            requestUri: "/instance/{InstanceId}/lex-bot"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "LexBot"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              LexBot: {
                shape: "S5"
              }
            }
          }
        },
        AssociateQueueQuickConnects: {
          http: {
            requestUri: "/queues/{InstanceId}/{QueueId}/associate-quick-connects"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QueueId",
              "QuickConnectIds"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueId: {
                location: "uri",
                locationName: "QueueId"
              },
              QuickConnectIds: {
                shape: "Sw"
              }
            }
          }
        },
        AssociateRoutingProfileQueues: {
          http: {
            requestUri: "/routing-profiles/{InstanceId}/{RoutingProfileId}/associate-queues"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "RoutingProfileId",
              "QueueConfigs"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              RoutingProfileId: {
                location: "uri",
                locationName: "RoutingProfileId"
              },
              QueueConfigs: {
                shape: "S10"
              }
            }
          }
        },
        AssociateSecurityKey: {
          http: {
            method: "PUT",
            requestUri: "/instance/{InstanceId}/security-key"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Key"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Key: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AssociationId: {}
            }
          }
        },
        CreateAgentStatus: {
          http: {
            method: "PUT",
            requestUri: "/agent-status/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name",
              "State"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {},
              Description: {},
              State: {},
              DisplayOrder: {
                type: "integer"
              },
              Tags: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AgentStatusARN: {},
              AgentStatusId: {}
            }
          }
        },
        CreateContactFlow: {
          http: {
            method: "PUT",
            requestUri: "/contact-flows/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name",
              "Type",
              "Content"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {},
              Type: {},
              Description: {},
              Content: {},
              Tags: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactFlowId: {},
              ContactFlowArn: {}
            }
          }
        },
        CreateHoursOfOperation: {
          http: {
            method: "PUT",
            requestUri: "/hours-of-operations/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name",
              "TimeZone",
              "Config"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {},
              Description: {},
              TimeZone: {},
              Config: {
                shape: "S1u"
              },
              Tags: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HoursOfOperationId: {},
              HoursOfOperationArn: {}
            }
          }
        },
        CreateInstance: {
          http: {
            method: "PUT",
            requestUri: "/instance"
          },
          input: {
            type: "structure",
            required: [
              "IdentityManagementType",
              "InboundCallsEnabled",
              "OutboundCallsEnabled"
            ],
            members: {
              ClientToken: {},
              IdentityManagementType: {},
              InstanceAlias: {
                shape: "S25"
              },
              DirectoryId: {},
              InboundCallsEnabled: {
                type: "boolean"
              },
              OutboundCallsEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              Arn: {}
            }
          }
        },
        CreateIntegrationAssociation: {
          http: {
            method: "PUT",
            requestUri: "/instance/{InstanceId}/integration-associations"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "IntegrationType",
              "IntegrationArn"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              IntegrationType: {},
              IntegrationArn: {},
              SourceApplicationUrl: {},
              SourceApplicationName: {},
              SourceType: {},
              Tags: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IntegrationAssociationId: {},
              IntegrationAssociationArn: {}
            }
          }
        },
        CreateQueue: {
          http: {
            method: "PUT",
            requestUri: "/queues/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name",
              "HoursOfOperationId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {},
              Description: {},
              OutboundCallerConfig: {
                shape: "S2j"
              },
              HoursOfOperationId: {},
              MaxContacts: {
                type: "integer"
              },
              QuickConnectIds: {
                shape: "Sw"
              },
              Tags: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QueueArn: {},
              QueueId: {}
            }
          }
        },
        CreateQuickConnect: {
          http: {
            method: "PUT",
            requestUri: "/quick-connects/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name",
              "QuickConnectConfig"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {},
              Description: {},
              QuickConnectConfig: {
                shape: "S2r"
              },
              Tags: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QuickConnectARN: {},
              QuickConnectId: {}
            }
          }
        },
        CreateRoutingProfile: {
          http: {
            method: "PUT",
            requestUri: "/routing-profiles/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Name",
              "Description",
              "DefaultOutboundQueueId",
              "MediaConcurrencies"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Name: {},
              Description: {},
              DefaultOutboundQueueId: {},
              QueueConfigs: {
                shape: "S10"
              },
              MediaConcurrencies: {
                shape: "S32"
              },
              Tags: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RoutingProfileArn: {},
              RoutingProfileId: {}
            }
          }
        },
        CreateUseCase: {
          http: {
            method: "PUT",
            requestUri: "/instance/{InstanceId}/integration-associations/{IntegrationAssociationId}/use-cases"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "IntegrationAssociationId",
              "UseCaseType"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              IntegrationAssociationId: {
                location: "uri",
                locationName: "IntegrationAssociationId"
              },
              UseCaseType: {},
              Tags: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UseCaseId: {},
              UseCaseArn: {}
            }
          }
        },
        CreateUser: {
          http: {
            method: "PUT",
            requestUri: "/users/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "Username",
              "PhoneConfig",
              "SecurityProfileIds",
              "RoutingProfileId",
              "InstanceId"
            ],
            members: {
              Username: {},
              Password: {},
              IdentityInfo: {
                shape: "S3d"
              },
              PhoneConfig: {
                shape: "S3h"
              },
              DirectoryUserId: {},
              SecurityProfileIds: {
                shape: "S3m"
              },
              RoutingProfileId: {},
              HierarchyGroupId: {},
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Tags: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserId: {},
              UserArn: {}
            }
          }
        },
        CreateUserHierarchyGroup: {
          http: {
            method: "PUT",
            requestUri: "/user-hierarchy-groups/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "InstanceId"
            ],
            members: {
              Name: {},
              ParentGroupId: {},
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HierarchyGroupId: {},
              HierarchyGroupArn: {}
            }
          }
        },
        DeleteHoursOfOperation: {
          http: {
            method: "DELETE",
            requestUri: "/hours-of-operations/{InstanceId}/{HoursOfOperationId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "HoursOfOperationId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              HoursOfOperationId: {
                location: "uri",
                locationName: "HoursOfOperationId"
              }
            }
          }
        },
        DeleteInstance: {
          http: {
            method: "DELETE",
            requestUri: "/instance/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          }
        },
        DeleteIntegrationAssociation: {
          http: {
            method: "DELETE",
            requestUri: "/instance/{InstanceId}/integration-associations/{IntegrationAssociationId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "IntegrationAssociationId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              IntegrationAssociationId: {
                location: "uri",
                locationName: "IntegrationAssociationId"
              }
            }
          }
        },
        DeleteQuickConnect: {
          http: {
            method: "DELETE",
            requestUri: "/quick-connects/{InstanceId}/{QuickConnectId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QuickConnectId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QuickConnectId: {
                location: "uri",
                locationName: "QuickConnectId"
              }
            }
          }
        },
        DeleteUseCase: {
          http: {
            method: "DELETE",
            requestUri: "/instance/{InstanceId}/integration-associations/{IntegrationAssociationId}/use-cases/{UseCaseId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "IntegrationAssociationId",
              "UseCaseId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              IntegrationAssociationId: {
                location: "uri",
                locationName: "IntegrationAssociationId"
              },
              UseCaseId: {
                location: "uri",
                locationName: "UseCaseId"
              }
            }
          }
        },
        DeleteUser: {
          http: {
            method: "DELETE",
            requestUri: "/users/{InstanceId}/{UserId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "UserId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              UserId: {
                location: "uri",
                locationName: "UserId"
              }
            }
          }
        },
        DeleteUserHierarchyGroup: {
          http: {
            method: "DELETE",
            requestUri: "/user-hierarchy-groups/{InstanceId}/{HierarchyGroupId}"
          },
          input: {
            type: "structure",
            required: [
              "HierarchyGroupId",
              "InstanceId"
            ],
            members: {
              HierarchyGroupId: {
                location: "uri",
                locationName: "HierarchyGroupId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          }
        },
        DescribeAgentStatus: {
          http: {
            method: "GET",
            requestUri: "/agent-status/{InstanceId}/{AgentStatusId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "AgentStatusId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              AgentStatusId: {
                location: "uri",
                locationName: "AgentStatusId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AgentStatus: {
                type: "structure",
                members: {
                  AgentStatusARN: {},
                  AgentStatusId: {},
                  Name: {},
                  Description: {},
                  Type: {},
                  DisplayOrder: {
                    type: "integer"
                  },
                  State: {},
                  Tags: {
                    shape: "S1e"
                  }
                }
              }
            }
          }
        },
        DescribeContactFlow: {
          http: {
            method: "GET",
            requestUri: "/contact-flows/{InstanceId}/{ContactFlowId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactFlowId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactFlowId: {
                location: "uri",
                locationName: "ContactFlowId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactFlow: {
                type: "structure",
                members: {
                  Arn: {},
                  Id: {},
                  Name: {},
                  Type: {},
                  Description: {},
                  Content: {},
                  Tags: {
                    shape: "S1e"
                  }
                }
              }
            }
          }
        },
        DescribeHoursOfOperation: {
          http: {
            method: "GET",
            requestUri: "/hours-of-operations/{InstanceId}/{HoursOfOperationId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "HoursOfOperationId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              HoursOfOperationId: {
                location: "uri",
                locationName: "HoursOfOperationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HoursOfOperation: {
                type: "structure",
                members: {
                  HoursOfOperationId: {},
                  HoursOfOperationArn: {},
                  Name: {},
                  Description: {},
                  TimeZone: {},
                  Config: {
                    shape: "S1u"
                  },
                  Tags: {
                    shape: "S1e"
                  }
                }
              }
            }
          }
        },
        DescribeInstance: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Instance: {
                type: "structure",
                members: {
                  Id: {},
                  Arn: {},
                  IdentityManagementType: {},
                  InstanceAlias: {
                    shape: "S25"
                  },
                  CreatedTime: {
                    type: "timestamp"
                  },
                  ServiceRole: {},
                  InstanceStatus: {},
                  StatusReason: {
                    type: "structure",
                    members: {
                      Message: {}
                    }
                  },
                  InboundCallsEnabled: {
                    type: "boolean"
                  },
                  OutboundCallsEnabled: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        DescribeInstanceAttribute: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/attribute/{AttributeType}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "AttributeType"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              AttributeType: {
                location: "uri",
                locationName: "AttributeType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attribute: {
                shape: "S4k"
              }
            }
          }
        },
        DescribeInstanceStorageConfig: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/storage-config/{AssociationId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "AssociationId",
              "ResourceType"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              AssociationId: {
                location: "uri",
                locationName: "AssociationId"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StorageConfig: {
                shape: "Sc"
              }
            }
          }
        },
        DescribeQueue: {
          http: {
            method: "GET",
            requestUri: "/queues/{InstanceId}/{QueueId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QueueId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueId: {
                location: "uri",
                locationName: "QueueId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Queue: {
                type: "structure",
                members: {
                  Name: {},
                  QueueArn: {},
                  QueueId: {},
                  Description: {},
                  OutboundCallerConfig: {
                    shape: "S2j"
                  },
                  HoursOfOperationId: {},
                  MaxContacts: {
                    type: "integer"
                  },
                  Status: {},
                  Tags: {
                    shape: "S1e"
                  }
                }
              }
            }
          }
        },
        DescribeQuickConnect: {
          http: {
            method: "GET",
            requestUri: "/quick-connects/{InstanceId}/{QuickConnectId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QuickConnectId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QuickConnectId: {
                location: "uri",
                locationName: "QuickConnectId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QuickConnect: {
                type: "structure",
                members: {
                  QuickConnectARN: {},
                  QuickConnectId: {},
                  Name: {},
                  Description: {},
                  QuickConnectConfig: {
                    shape: "S2r"
                  },
                  Tags: {
                    shape: "S1e"
                  }
                }
              }
            }
          }
        },
        DescribeRoutingProfile: {
          http: {
            method: "GET",
            requestUri: "/routing-profiles/{InstanceId}/{RoutingProfileId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "RoutingProfileId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              RoutingProfileId: {
                location: "uri",
                locationName: "RoutingProfileId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RoutingProfile: {
                type: "structure",
                members: {
                  InstanceId: {},
                  Name: {},
                  RoutingProfileArn: {},
                  RoutingProfileId: {},
                  Description: {},
                  MediaConcurrencies: {
                    shape: "S32"
                  },
                  DefaultOutboundQueueId: {},
                  Tags: {
                    shape: "S1e"
                  }
                }
              }
            }
          }
        },
        DescribeUser: {
          http: {
            method: "GET",
            requestUri: "/users/{InstanceId}/{UserId}"
          },
          input: {
            type: "structure",
            required: [
              "UserId",
              "InstanceId"
            ],
            members: {
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                type: "structure",
                members: {
                  Id: {},
                  Arn: {},
                  Username: {},
                  IdentityInfo: {
                    shape: "S3d"
                  },
                  PhoneConfig: {
                    shape: "S3h"
                  },
                  DirectoryUserId: {},
                  SecurityProfileIds: {
                    shape: "S3m"
                  },
                  RoutingProfileId: {},
                  HierarchyGroupId: {},
                  Tags: {
                    shape: "S1e"
                  }
                }
              }
            }
          }
        },
        DescribeUserHierarchyGroup: {
          http: {
            method: "GET",
            requestUri: "/user-hierarchy-groups/{InstanceId}/{HierarchyGroupId}"
          },
          input: {
            type: "structure",
            required: [
              "HierarchyGroupId",
              "InstanceId"
            ],
            members: {
              HierarchyGroupId: {
                location: "uri",
                locationName: "HierarchyGroupId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HierarchyGroup: {
                type: "structure",
                members: {
                  Id: {},
                  Arn: {},
                  Name: {},
                  LevelId: {},
                  HierarchyPath: {
                    type: "structure",
                    members: {
                      LevelOne: {
                        shape: "S56"
                      },
                      LevelTwo: {
                        shape: "S56"
                      },
                      LevelThree: {
                        shape: "S56"
                      },
                      LevelFour: {
                        shape: "S56"
                      },
                      LevelFive: {
                        shape: "S56"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeUserHierarchyStructure: {
          http: {
            method: "GET",
            requestUri: "/user-hierarchy-structure/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HierarchyStructure: {
                type: "structure",
                members: {
                  LevelOne: {
                    shape: "S5a"
                  },
                  LevelTwo: {
                    shape: "S5a"
                  },
                  LevelThree: {
                    shape: "S5a"
                  },
                  LevelFour: {
                    shape: "S5a"
                  },
                  LevelFive: {
                    shape: "S5a"
                  }
                }
              }
            }
          }
        },
        DisassociateApprovedOrigin: {
          http: {
            method: "DELETE",
            requestUri: "/instance/{InstanceId}/approved-origin"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Origin"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Origin: {
                location: "querystring",
                locationName: "origin"
              }
            }
          }
        },
        DisassociateBot: {
          http: {
            requestUri: "/instance/{InstanceId}/bot"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              LexBot: {
                shape: "S5"
              },
              LexV2Bot: {
                shape: "S8"
              }
            }
          }
        },
        DisassociateInstanceStorageConfig: {
          http: {
            method: "DELETE",
            requestUri: "/instance/{InstanceId}/storage-config/{AssociationId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "AssociationId",
              "ResourceType"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              AssociationId: {
                location: "uri",
                locationName: "AssociationId"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              }
            }
          }
        },
        DisassociateLambdaFunction: {
          http: {
            method: "DELETE",
            requestUri: "/instance/{InstanceId}/lambda-function"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "FunctionArn"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              FunctionArn: {
                location: "querystring",
                locationName: "functionArn"
              }
            }
          }
        },
        DisassociateLexBot: {
          http: {
            method: "DELETE",
            requestUri: "/instance/{InstanceId}/lex-bot"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "BotName",
              "LexRegion"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              BotName: {
                location: "querystring",
                locationName: "botName"
              },
              LexRegion: {
                location: "querystring",
                locationName: "lexRegion"
              }
            }
          }
        },
        DisassociateQueueQuickConnects: {
          http: {
            requestUri: "/queues/{InstanceId}/{QueueId}/disassociate-quick-connects"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QueueId",
              "QuickConnectIds"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueId: {
                location: "uri",
                locationName: "QueueId"
              },
              QuickConnectIds: {
                shape: "Sw"
              }
            }
          }
        },
        DisassociateRoutingProfileQueues: {
          http: {
            requestUri: "/routing-profiles/{InstanceId}/{RoutingProfileId}/disassociate-queues"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "RoutingProfileId",
              "QueueReferences"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              RoutingProfileId: {
                location: "uri",
                locationName: "RoutingProfileId"
              },
              QueueReferences: {
                type: "list",
                member: {
                  shape: "S12"
                }
              }
            }
          }
        },
        DisassociateSecurityKey: {
          http: {
            method: "DELETE",
            requestUri: "/instance/{InstanceId}/security-key/{AssociationId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "AssociationId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              AssociationId: {
                location: "uri",
                locationName: "AssociationId"
              }
            }
          }
        },
        GetContactAttributes: {
          http: {
            method: "GET",
            requestUri: "/contact/attributes/{InstanceId}/{InitialContactId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "InitialContactId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              InitialContactId: {
                location: "uri",
                locationName: "InitialContactId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S5o"
              }
            }
          }
        },
        GetCurrentMetricData: {
          http: {
            requestUri: "/metrics/current/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "Filters",
              "CurrentMetrics"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              Filters: {
                shape: "S5s"
              },
              Groupings: {
                shape: "S5v"
              },
              CurrentMetrics: {
                type: "list",
                member: {
                  shape: "S5y"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              MetricResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Dimensions: {
                      shape: "S66"
                    },
                    Collections: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Metric: {
                            shape: "S5y"
                          },
                          Value: {
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                }
              },
              DataSnapshotTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetFederationToken: {
          http: {
            method: "GET",
            requestUri: "/user/federate/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Credentials: {
                type: "structure",
                members: {
                  AccessToken: {
                    shape: "S6f"
                  },
                  AccessTokenExpiration: {
                    type: "timestamp"
                  },
                  RefreshToken: {
                    shape: "S6f"
                  },
                  RefreshTokenExpiration: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        GetMetricData: {
          http: {
            requestUri: "/metrics/historical/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "StartTime",
              "EndTime",
              "Filters",
              "HistoricalMetrics"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Filters: {
                shape: "S5s"
              },
              Groupings: {
                shape: "S5v"
              },
              HistoricalMetrics: {
                type: "list",
                member: {
                  shape: "S6i"
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              MetricResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Dimensions: {
                      shape: "S66"
                    },
                    Collections: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Metric: {
                            shape: "S6i"
                          },
                          Value: {
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListAgentStatuses: {
          http: {
            method: "GET",
            requestUri: "/agent-status/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              AgentStatusTypes: {
                location: "querystring",
                locationName: "AgentStatusTypes",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              AgentStatusSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    Type: {}
                  }
                }
              }
            }
          }
        },
        ListApprovedOrigins: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/approved-origins"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Origins: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListBots: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/bots"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "LexVersion"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              LexVersion: {
                location: "querystring",
                locationName: "lexVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LexBots: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LexBot: {
                      shape: "S5"
                    },
                    LexV2Bot: {
                      shape: "S8"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListContactFlows: {
          http: {
            method: "GET",
            requestUri: "/contact-flows-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactFlowTypes: {
                location: "querystring",
                locationName: "contactFlowTypes",
                type: "list",
                member: {}
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactFlowSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    ContactFlowType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListHoursOfOperations: {
          http: {
            method: "GET",
            requestUri: "/hours-of-operations-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HoursOfOperationSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListInstanceAttributes: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/attributes"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attributes: {
                type: "list",
                member: {
                  shape: "S4k"
                }
              },
              NextToken: {}
            }
          }
        },
        ListInstanceStorageConfigs: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/storage-configs"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ResourceType"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StorageConfigs: {
                type: "list",
                member: {
                  shape: "Sc"
                }
              },
              NextToken: {}
            }
          }
        },
        ListInstances: {
          http: {
            method: "GET",
            requestUri: "/instance"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    IdentityManagementType: {},
                    InstanceAlias: {
                      shape: "S25"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    },
                    ServiceRole: {},
                    InstanceStatus: {},
                    InboundCallsEnabled: {
                      type: "boolean"
                    },
                    OutboundCallsEnabled: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListIntegrationAssociations: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/integration-associations"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              IntegrationType: {
                location: "querystring",
                locationName: "integrationType"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IntegrationAssociationSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IntegrationAssociationId: {},
                    IntegrationAssociationArn: {},
                    InstanceId: {},
                    IntegrationType: {},
                    IntegrationArn: {},
                    SourceApplicationUrl: {},
                    SourceApplicationName: {},
                    SourceType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLambdaFunctions: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/lambda-functions"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LambdaFunctions: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListLexBots: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/lex-bots"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LexBots: {
                type: "list",
                member: {
                  shape: "S5"
                }
              },
              NextToken: {}
            }
          }
        },
        ListPhoneNumbers: {
          http: {
            method: "GET",
            requestUri: "/phone-numbers-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              PhoneNumberTypes: {
                location: "querystring",
                locationName: "phoneNumberTypes",
                type: "list",
                member: {}
              },
              PhoneNumberCountryCodes: {
                location: "querystring",
                locationName: "phoneNumberCountryCodes",
                type: "list",
                member: {}
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    PhoneNumber: {},
                    PhoneNumberType: {},
                    PhoneNumberCountryCode: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPrompts: {
          http: {
            method: "GET",
            requestUri: "/prompts-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PromptSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListQueueQuickConnects: {
          http: {
            method: "GET",
            requestUri: "/queues/{InstanceId}/{QueueId}/quick-connects"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QueueId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueId: {
                location: "uri",
                locationName: "QueueId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              QuickConnectSummaryList: {
                shape: "S8k"
              }
            }
          }
        },
        ListQueues: {
          http: {
            method: "GET",
            requestUri: "/queues-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueTypes: {
                location: "querystring",
                locationName: "queueTypes",
                type: "list",
                member: {}
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QueueSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    QueueType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListQuickConnects: {
          http: {
            method: "GET",
            requestUri: "/quick-connects/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              QuickConnectTypes: {
                location: "querystring",
                locationName: "QuickConnectTypes",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QuickConnectSummaryList: {
                shape: "S8k"
              },
              NextToken: {}
            }
          }
        },
        ListRoutingProfileQueues: {
          http: {
            method: "GET",
            requestUri: "/routing-profiles/{InstanceId}/{RoutingProfileId}/queues"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "RoutingProfileId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              RoutingProfileId: {
                location: "uri",
                locationName: "RoutingProfileId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              RoutingProfileQueueConfigSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "QueueId",
                    "QueueArn",
                    "QueueName",
                    "Priority",
                    "Delay",
                    "Channel"
                  ],
                  members: {
                    QueueId: {},
                    QueueArn: {},
                    QueueName: {},
                    Priority: {
                      type: "integer"
                    },
                    Delay: {
                      type: "integer"
                    },
                    Channel: {}
                  }
                }
              }
            }
          }
        },
        ListRoutingProfiles: {
          http: {
            method: "GET",
            requestUri: "/routing-profiles-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RoutingProfileSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSecurityKeys: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/security-keys"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityKeys: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssociationId: {},
                    Key: {},
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSecurityProfiles: {
          http: {
            method: "GET",
            requestUri: "/security-profiles-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SecurityProfileSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S1e"
              }
            }
          }
        },
        ListUseCases: {
          http: {
            method: "GET",
            requestUri: "/instance/{InstanceId}/integration-associations/{IntegrationAssociationId}/use-cases"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "IntegrationAssociationId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              IntegrationAssociationId: {
                location: "uri",
                locationName: "IntegrationAssociationId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UseCaseSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UseCaseId: {},
                    UseCaseArn: {},
                    UseCaseType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListUserHierarchyGroups: {
          http: {
            method: "GET",
            requestUri: "/user-hierarchy-groups-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserHierarchyGroupSummaryList: {
                type: "list",
                member: {
                  shape: "S56"
                }
              },
              NextToken: {}
            }
          }
        },
        ListUsers: {
          http: {
            method: "GET",
            requestUri: "/users-summary/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Username: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ResumeContactRecording: {
          http: {
            requestUri: "/contact/resume-recording"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId",
              "InitialContactId"
            ],
            members: {
              InstanceId: {},
              ContactId: {},
              InitialContactId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartChatContact: {
          http: {
            method: "PUT",
            requestUri: "/contact/chat"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactFlowId",
              "ParticipantDetails"
            ],
            members: {
              InstanceId: {},
              ContactFlowId: {},
              Attributes: {
                shape: "S5o"
              },
              ParticipantDetails: {
                type: "structure",
                required: [
                  "DisplayName"
                ],
                members: {
                  DisplayName: {}
                }
              },
              InitialMessage: {
                type: "structure",
                required: [
                  "ContentType",
                  "Content"
                ],
                members: {
                  ContentType: {},
                  Content: {}
                }
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactId: {},
              ParticipantId: {},
              ParticipantToken: {}
            }
          }
        },
        StartContactRecording: {
          http: {
            requestUri: "/contact/start-recording"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId",
              "InitialContactId",
              "VoiceRecordingConfiguration"
            ],
            members: {
              InstanceId: {},
              ContactId: {},
              InitialContactId: {},
              VoiceRecordingConfiguration: {
                type: "structure",
                members: {
                  VoiceRecordingTrack: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartOutboundVoiceContact: {
          http: {
            method: "PUT",
            requestUri: "/contact/outbound-voice"
          },
          input: {
            type: "structure",
            required: [
              "DestinationPhoneNumber",
              "ContactFlowId",
              "InstanceId"
            ],
            members: {
              DestinationPhoneNumber: {},
              ContactFlowId: {},
              InstanceId: {},
              ClientToken: {
                idempotencyToken: true
              },
              SourcePhoneNumber: {},
              QueueId: {},
              Attributes: {
                shape: "S5o"
              },
              AnswerMachineDetectionConfig: {
                type: "structure",
                members: {
                  EnableAnswerMachineDetection: {
                    type: "boolean"
                  },
                  AwaitAnswerMachinePrompt: {
                    type: "boolean"
                  }
                }
              },
              CampaignId: {},
              TrafficType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ContactId: {}
            }
          }
        },
        StartTaskContact: {
          http: {
            method: "PUT",
            requestUri: "/contact/task"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactFlowId",
              "Name"
            ],
            members: {
              InstanceId: {},
              PreviousContactId: {},
              ContactFlowId: {},
              Attributes: {
                shape: "S5o"
              },
              Name: {},
              References: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "Value",
                    "Type"
                  ],
                  members: {
                    Value: {},
                    Type: {}
                  }
                }
              },
              Description: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactId: {}
            }
          }
        },
        StopContact: {
          http: {
            requestUri: "/contact/stop"
          },
          input: {
            type: "structure",
            required: [
              "ContactId",
              "InstanceId"
            ],
            members: {
              ContactId: {},
              InstanceId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopContactRecording: {
          http: {
            requestUri: "/contact/stop-recording"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId",
              "InitialContactId"
            ],
            members: {
              InstanceId: {},
              ContactId: {},
              InitialContactId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SuspendContactRecording: {
          http: {
            requestUri: "/contact/suspend-recording"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId",
              "InitialContactId"
            ],
            members: {
              InstanceId: {},
              ContactId: {},
              InitialContactId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S1e"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateAgentStatus: {
          http: {
            requestUri: "/agent-status/{InstanceId}/{AgentStatusId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "AgentStatusId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              AgentStatusId: {
                location: "uri",
                locationName: "AgentStatusId"
              },
              Name: {},
              Description: {},
              State: {},
              DisplayOrder: {
                type: "integer"
              },
              ResetOrderNumber: {
                type: "boolean"
              }
            }
          }
        },
        UpdateContactAttributes: {
          http: {
            requestUri: "/contact/attributes"
          },
          input: {
            type: "structure",
            required: [
              "InitialContactId",
              "InstanceId",
              "Attributes"
            ],
            members: {
              InitialContactId: {},
              InstanceId: {},
              Attributes: {
                shape: "S5o"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateContactFlowContent: {
          http: {
            requestUri: "/contact-flows/{InstanceId}/{ContactFlowId}/content"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactFlowId",
              "Content"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactFlowId: {
                location: "uri",
                locationName: "ContactFlowId"
              },
              Content: {}
            }
          }
        },
        UpdateContactFlowName: {
          http: {
            requestUri: "/contact-flows/{InstanceId}/{ContactFlowId}/name"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactFlowId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              ContactFlowId: {
                location: "uri",
                locationName: "ContactFlowId"
              },
              Name: {},
              Description: {}
            }
          }
        },
        UpdateHoursOfOperation: {
          http: {
            requestUri: "/hours-of-operations/{InstanceId}/{HoursOfOperationId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "HoursOfOperationId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              HoursOfOperationId: {
                location: "uri",
                locationName: "HoursOfOperationId"
              },
              Name: {},
              Description: {},
              TimeZone: {},
              Config: {
                shape: "S1u"
              }
            }
          }
        },
        UpdateInstanceAttribute: {
          http: {
            requestUri: "/instance/{InstanceId}/attribute/{AttributeType}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "AttributeType",
              "Value"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              AttributeType: {
                location: "uri",
                locationName: "AttributeType"
              },
              Value: {}
            }
          }
        },
        UpdateInstanceStorageConfig: {
          http: {
            requestUri: "/instance/{InstanceId}/storage-config/{AssociationId}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "AssociationId",
              "ResourceType",
              "StorageConfig"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              AssociationId: {
                location: "uri",
                locationName: "AssociationId"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              StorageConfig: {
                shape: "Sc"
              }
            }
          }
        },
        UpdateQueueHoursOfOperation: {
          http: {
            requestUri: "/queues/{InstanceId}/{QueueId}/hours-of-operation"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QueueId",
              "HoursOfOperationId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueId: {
                location: "uri",
                locationName: "QueueId"
              },
              HoursOfOperationId: {}
            }
          }
        },
        UpdateQueueMaxContacts: {
          http: {
            requestUri: "/queues/{InstanceId}/{QueueId}/max-contacts"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QueueId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueId: {
                location: "uri",
                locationName: "QueueId"
              },
              MaxContacts: {
                type: "integer"
              }
            }
          }
        },
        UpdateQueueName: {
          http: {
            requestUri: "/queues/{InstanceId}/{QueueId}/name"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QueueId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueId: {
                location: "uri",
                locationName: "QueueId"
              },
              Name: {},
              Description: {}
            }
          }
        },
        UpdateQueueOutboundCallerConfig: {
          http: {
            requestUri: "/queues/{InstanceId}/{QueueId}/outbound-caller-config"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QueueId",
              "OutboundCallerConfig"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueId: {
                location: "uri",
                locationName: "QueueId"
              },
              OutboundCallerConfig: {
                shape: "S2j"
              }
            }
          }
        },
        UpdateQueueStatus: {
          http: {
            requestUri: "/queues/{InstanceId}/{QueueId}/status"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QueueId",
              "Status"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QueueId: {
                location: "uri",
                locationName: "QueueId"
              },
              Status: {}
            }
          }
        },
        UpdateQuickConnectConfig: {
          http: {
            requestUri: "/quick-connects/{InstanceId}/{QuickConnectId}/config"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QuickConnectId",
              "QuickConnectConfig"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QuickConnectId: {
                location: "uri",
                locationName: "QuickConnectId"
              },
              QuickConnectConfig: {
                shape: "S2r"
              }
            }
          }
        },
        UpdateQuickConnectName: {
          http: {
            requestUri: "/quick-connects/{InstanceId}/{QuickConnectId}/name"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "QuickConnectId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              QuickConnectId: {
                location: "uri",
                locationName: "QuickConnectId"
              },
              Name: {},
              Description: {}
            }
          }
        },
        UpdateRoutingProfileConcurrency: {
          http: {
            requestUri: "/routing-profiles/{InstanceId}/{RoutingProfileId}/concurrency"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "RoutingProfileId",
              "MediaConcurrencies"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              RoutingProfileId: {
                location: "uri",
                locationName: "RoutingProfileId"
              },
              MediaConcurrencies: {
                shape: "S32"
              }
            }
          }
        },
        UpdateRoutingProfileDefaultOutboundQueue: {
          http: {
            requestUri: "/routing-profiles/{InstanceId}/{RoutingProfileId}/default-outbound-queue"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "RoutingProfileId",
              "DefaultOutboundQueueId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              RoutingProfileId: {
                location: "uri",
                locationName: "RoutingProfileId"
              },
              DefaultOutboundQueueId: {}
            }
          }
        },
        UpdateRoutingProfileName: {
          http: {
            requestUri: "/routing-profiles/{InstanceId}/{RoutingProfileId}/name"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "RoutingProfileId"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              RoutingProfileId: {
                location: "uri",
                locationName: "RoutingProfileId"
              },
              Name: {},
              Description: {}
            }
          }
        },
        UpdateRoutingProfileQueues: {
          http: {
            requestUri: "/routing-profiles/{InstanceId}/{RoutingProfileId}/queues"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "RoutingProfileId",
              "QueueConfigs"
            ],
            members: {
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              },
              RoutingProfileId: {
                location: "uri",
                locationName: "RoutingProfileId"
              },
              QueueConfigs: {
                shape: "S10"
              }
            }
          }
        },
        UpdateUserHierarchy: {
          http: {
            requestUri: "/users/{InstanceId}/{UserId}/hierarchy"
          },
          input: {
            type: "structure",
            required: [
              "UserId",
              "InstanceId"
            ],
            members: {
              HierarchyGroupId: {},
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          }
        },
        UpdateUserHierarchyGroupName: {
          http: {
            requestUri: "/user-hierarchy-groups/{InstanceId}/{HierarchyGroupId}/name"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "HierarchyGroupId",
              "InstanceId"
            ],
            members: {
              Name: {},
              HierarchyGroupId: {
                location: "uri",
                locationName: "HierarchyGroupId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          }
        },
        UpdateUserHierarchyStructure: {
          http: {
            requestUri: "/user-hierarchy-structure/{InstanceId}"
          },
          input: {
            type: "structure",
            required: [
              "HierarchyStructure",
              "InstanceId"
            ],
            members: {
              HierarchyStructure: {
                type: "structure",
                members: {
                  LevelOne: {
                    shape: "Sbk"
                  },
                  LevelTwo: {
                    shape: "Sbk"
                  },
                  LevelThree: {
                    shape: "Sbk"
                  },
                  LevelFour: {
                    shape: "Sbk"
                  },
                  LevelFive: {
                    shape: "Sbk"
                  }
                }
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          }
        },
        UpdateUserIdentityInfo: {
          http: {
            requestUri: "/users/{InstanceId}/{UserId}/identity-info"
          },
          input: {
            type: "structure",
            required: [
              "IdentityInfo",
              "UserId",
              "InstanceId"
            ],
            members: {
              IdentityInfo: {
                shape: "S3d"
              },
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          }
        },
        UpdateUserPhoneConfig: {
          http: {
            requestUri: "/users/{InstanceId}/{UserId}/phone-config"
          },
          input: {
            type: "structure",
            required: [
              "PhoneConfig",
              "UserId",
              "InstanceId"
            ],
            members: {
              PhoneConfig: {
                shape: "S3h"
              },
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          }
        },
        UpdateUserRoutingProfile: {
          http: {
            requestUri: "/users/{InstanceId}/{UserId}/routing-profile"
          },
          input: {
            type: "structure",
            required: [
              "RoutingProfileId",
              "UserId",
              "InstanceId"
            ],
            members: {
              RoutingProfileId: {},
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          }
        },
        UpdateUserSecurityProfiles: {
          http: {
            requestUri: "/users/{InstanceId}/{UserId}/security-profiles"
          },
          input: {
            type: "structure",
            required: [
              "SecurityProfileIds",
              "UserId",
              "InstanceId"
            ],
            members: {
              SecurityProfileIds: {
                shape: "S3m"
              },
              UserId: {
                location: "uri",
                locationName: "UserId"
              },
              InstanceId: {
                location: "uri",
                locationName: "InstanceId"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            Name: {},
            LexRegion: {}
          }
        },
        S8: {
          type: "structure",
          members: {
            AliasArn: {}
          }
        },
        Sc: {
          type: "structure",
          required: [
            "StorageType"
          ],
          members: {
            AssociationId: {},
            StorageType: {},
            S3Config: {
              type: "structure",
              required: [
                "BucketName",
                "BucketPrefix"
              ],
              members: {
                BucketName: {},
                BucketPrefix: {},
                EncryptionConfig: {
                  shape: "Si"
                }
              }
            },
            KinesisVideoStreamConfig: {
              type: "structure",
              required: [
                "Prefix",
                "RetentionPeriodHours",
                "EncryptionConfig"
              ],
              members: {
                Prefix: {},
                RetentionPeriodHours: {
                  type: "integer"
                },
                EncryptionConfig: {
                  shape: "Si"
                }
              }
            },
            KinesisStreamConfig: {
              type: "structure",
              required: [
                "StreamArn"
              ],
              members: {
                StreamArn: {}
              }
            },
            KinesisFirehoseConfig: {
              type: "structure",
              required: [
                "FirehoseArn"
              ],
              members: {
                FirehoseArn: {}
              }
            }
          }
        },
        Si: {
          type: "structure",
          required: [
            "EncryptionType",
            "KeyId"
          ],
          members: {
            EncryptionType: {},
            KeyId: {}
          }
        },
        Sw: {
          type: "list",
          member: {}
        },
        S10: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "QueueReference",
              "Priority",
              "Delay"
            ],
            members: {
              QueueReference: {
                shape: "S12"
              },
              Priority: {
                type: "integer"
              },
              Delay: {
                type: "integer"
              }
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "QueueId",
            "Channel"
          ],
          members: {
            QueueId: {},
            Channel: {}
          }
        },
        S1e: {
          type: "map",
          key: {},
          value: {}
        },
        S1u: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Day",
              "StartTime",
              "EndTime"
            ],
            members: {
              Day: {},
              StartTime: {
                shape: "S1x"
              },
              EndTime: {
                shape: "S1x"
              }
            }
          }
        },
        S1x: {
          type: "structure",
          required: [
            "Hours",
            "Minutes"
          ],
          members: {
            Hours: {
              type: "integer"
            },
            Minutes: {
              type: "integer"
            }
          }
        },
        S25: {
          type: "string",
          sensitive: true
        },
        S2j: {
          type: "structure",
          members: {
            OutboundCallerIdName: {},
            OutboundCallerIdNumberId: {},
            OutboundFlowId: {}
          }
        },
        S2r: {
          type: "structure",
          required: [
            "QuickConnectType"
          ],
          members: {
            QuickConnectType: {},
            UserConfig: {
              type: "structure",
              required: [
                "UserId",
                "ContactFlowId"
              ],
              members: {
                UserId: {},
                ContactFlowId: {}
              }
            },
            QueueConfig: {
              type: "structure",
              required: [
                "QueueId",
                "ContactFlowId"
              ],
              members: {
                QueueId: {},
                ContactFlowId: {}
              }
            },
            PhoneConfig: {
              type: "structure",
              required: [
                "PhoneNumber"
              ],
              members: {
                PhoneNumber: {}
              }
            }
          }
        },
        S32: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Channel",
              "Concurrency"
            ],
            members: {
              Channel: {},
              Concurrency: {
                type: "integer"
              }
            }
          }
        },
        S3d: {
          type: "structure",
          members: {
            FirstName: {},
            LastName: {},
            Email: {}
          }
        },
        S3h: {
          type: "structure",
          required: [
            "PhoneType"
          ],
          members: {
            PhoneType: {},
            AutoAccept: {
              type: "boolean"
            },
            AfterContactWorkTimeLimit: {
              type: "integer"
            },
            DeskPhoneNumber: {}
          }
        },
        S3m: {
          type: "list",
          member: {}
        },
        S4k: {
          type: "structure",
          members: {
            AttributeType: {},
            Value: {}
          }
        },
        S56: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {}
          }
        },
        S5a: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {}
          }
        },
        S5o: {
          type: "map",
          key: {},
          value: {}
        },
        S5s: {
          type: "structure",
          members: {
            Queues: {
              type: "list",
              member: {}
            },
            Channels: {
              type: "list",
              member: {}
            }
          }
        },
        S5v: {
          type: "list",
          member: {}
        },
        S5y: {
          type: "structure",
          members: {
            Name: {},
            Unit: {}
          }
        },
        S66: {
          type: "structure",
          members: {
            Queue: {
              type: "structure",
              members: {
                Id: {},
                Arn: {}
              }
            },
            Channel: {}
          }
        },
        S6f: {
          type: "string",
          sensitive: true
        },
        S6i: {
          type: "structure",
          members: {
            Name: {},
            Threshold: {
              type: "structure",
              members: {
                Comparison: {},
                ThresholdValue: {
                  type: "double"
                }
              }
            },
            Statistic: {},
            Unit: {}
          }
        },
        S8k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {},
              Arn: {},
              Name: {},
              QuickConnectType: {}
            }
          }
        },
        Sbk: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/connect-2017-08-08.paginators.json
var require_connect_2017_08_08_paginators = __commonJS({
  "node_modules/aws-sdk/apis/connect-2017-08-08.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetCurrentMetricData: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetMetricData: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        ListAgentStatuses: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AgentStatusSummaryList"
        },
        ListApprovedOrigins: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Origins"
        },
        ListBots: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LexBots"
        },
        ListContactFlows: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ContactFlowSummaryList"
        },
        ListHoursOfOperations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "HoursOfOperationSummaryList"
        },
        ListInstanceAttributes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Attributes"
        },
        ListInstanceStorageConfigs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "StorageConfigs"
        },
        ListInstances: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "InstanceSummaryList"
        },
        ListIntegrationAssociations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "IntegrationAssociationSummaryList"
        },
        ListLambdaFunctions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LambdaFunctions"
        },
        ListLexBots: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "LexBots"
        },
        ListPhoneNumbers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PhoneNumberSummaryList"
        },
        ListPrompts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PromptSummaryList"
        },
        ListQueueQuickConnects: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "QuickConnectSummaryList"
        },
        ListQueues: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "QueueSummaryList"
        },
        ListQuickConnects: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "QuickConnectSummaryList"
        },
        ListRoutingProfileQueues: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "RoutingProfileQueueConfigSummaryList"
        },
        ListRoutingProfiles: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "RoutingProfileSummaryList"
        },
        ListSecurityKeys: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "SecurityKeys"
        },
        ListSecurityProfiles: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "SecurityProfileSummaryList"
        },
        ListUseCases: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "UseCaseSummaryList"
        },
        ListUserHierarchyGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "UserHierarchyGroupSummaryList"
        },
        ListUsers: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "UserSummaryList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/connect.js
var require_connect = __commonJS({
  "node_modules/aws-sdk/clients/connect.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["connect"] = {};
    AWS3.Connect = Service.defineService("connect", ["2017-08-08"]);
    Object.defineProperty(apiLoader.services["connect"], "2017-08-08", {
      get: function get() {
        var model = require_connect_2017_08_08_min();
        model.paginators = require_connect_2017_08_08_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Connect;
  }
});

// node_modules/aws-sdk/apis/acm-pca-2017-08-22.min.json
var require_acm_pca_2017_08_22_min = __commonJS({
  "node_modules/aws-sdk/apis/acm-pca-2017-08-22.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-08-22",
        endpointPrefix: "acm-pca",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "ACM-PCA",
        serviceFullName: "AWS Certificate Manager Private Certificate Authority",
        serviceId: "ACM PCA",
        signatureVersion: "v4",
        targetPrefix: "ACMPrivateCA",
        uid: "acm-pca-2017-08-22"
      },
      operations: {
        CreateCertificateAuthority: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityConfiguration",
              "CertificateAuthorityType"
            ],
            members: {
              CertificateAuthorityConfiguration: {
                shape: "S2"
              },
              RevocationConfiguration: {
                shape: "Ss"
              },
              CertificateAuthorityType: {},
              IdempotencyToken: {},
              KeyStorageSecurityStandard: {},
              Tags: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CertificateAuthorityArn: {}
            }
          },
          idempotent: true
        },
        CreateCertificateAuthorityAuditReport: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "S3BucketName",
              "AuditReportResponseFormat"
            ],
            members: {
              CertificateAuthorityArn: {},
              S3BucketName: {},
              AuditReportResponseFormat: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AuditReportId: {},
              S3Key: {}
            }
          },
          idempotent: true
        },
        CreatePermission: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "Principal",
              "Actions"
            ],
            members: {
              CertificateAuthorityArn: {},
              Principal: {},
              SourceAccount: {},
              Actions: {
                shape: "S1g"
              }
            }
          }
        },
        DeleteCertificateAuthority: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn"
            ],
            members: {
              CertificateAuthorityArn: {},
              PermanentDeletionTimeInDays: {
                type: "integer"
              }
            }
          }
        },
        DeletePermission: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "Principal"
            ],
            members: {
              CertificateAuthorityArn: {},
              Principal: {},
              SourceAccount: {}
            }
          }
        },
        DeletePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          }
        },
        DescribeCertificateAuthority: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn"
            ],
            members: {
              CertificateAuthorityArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CertificateAuthority: {
                shape: "S1o"
              }
            }
          }
        },
        DescribeCertificateAuthorityAuditReport: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "AuditReportId"
            ],
            members: {
              CertificateAuthorityArn: {},
              AuditReportId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AuditReportStatus: {},
              S3BucketName: {},
              S3Key: {},
              CreatedAt: {
                type: "timestamp"
              }
            }
          }
        },
        GetCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "CertificateArn"
            ],
            members: {
              CertificateAuthorityArn: {},
              CertificateArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Certificate: {},
              CertificateChain: {}
            }
          }
        },
        GetCertificateAuthorityCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn"
            ],
            members: {
              CertificateAuthorityArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Certificate: {},
              CertificateChain: {}
            }
          }
        },
        GetCertificateAuthorityCsr: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn"
            ],
            members: {
              CertificateAuthorityArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Csr: {}
            }
          }
        },
        GetPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          }
        },
        ImportCertificateAuthorityCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "Certificate"
            ],
            members: {
              CertificateAuthorityArn: {},
              Certificate: {
                type: "blob"
              },
              CertificateChain: {
                type: "blob"
              }
            }
          }
        },
        IssueCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "Csr",
              "SigningAlgorithm",
              "Validity"
            ],
            members: {
              ApiPassthrough: {
                type: "structure",
                members: {
                  Extensions: {
                    type: "structure",
                    members: {
                      CertificatePolicies: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "CertPolicyId"
                          ],
                          members: {
                            CertPolicyId: {},
                            PolicyQualifiers: {
                              type: "list",
                              member: {
                                type: "structure",
                                required: [
                                  "PolicyQualifierId",
                                  "Qualifier"
                                ],
                                members: {
                                  PolicyQualifierId: {},
                                  Qualifier: {
                                    type: "structure",
                                    required: [
                                      "CpsUri"
                                    ],
                                    members: {
                                      CpsUri: {}
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      },
                      ExtendedKeyUsage: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            ExtendedKeyUsageType: {},
                            ExtendedKeyUsageObjectIdentifier: {}
                          }
                        }
                      },
                      KeyUsage: {
                        shape: "Sf"
                      },
                      SubjectAlternativeNames: {
                        type: "list",
                        member: {
                          shape: "Sm"
                        }
                      }
                    }
                  },
                  Subject: {
                    shape: "S5"
                  }
                }
              },
              CertificateAuthorityArn: {},
              Csr: {
                type: "blob"
              },
              SigningAlgorithm: {},
              TemplateArn: {},
              Validity: {
                shape: "S2p"
              },
              ValidityNotBefore: {
                shape: "S2p"
              },
              IdempotencyToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CertificateArn: {}
            }
          },
          idempotent: true
        },
        ListCertificateAuthorities: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ResourceOwner: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CertificateAuthorities: {
                type: "list",
                member: {
                  shape: "S1o"
                }
              },
              NextToken: {}
            }
          }
        },
        ListPermissions: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn"
            ],
            members: {
              CertificateAuthorityArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Permissions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CertificateAuthorityArn: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    Principal: {},
                    SourceAccount: {},
                    Actions: {
                      shape: "S1g"
                    },
                    Policy: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTags: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn"
            ],
            members: {
              CertificateAuthorityArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S11"
              },
              NextToken: {}
            }
          }
        },
        PutPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Policy"
            ],
            members: {
              ResourceArn: {},
              Policy: {}
            }
          }
        },
        RestoreCertificateAuthority: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn"
            ],
            members: {
              CertificateAuthorityArn: {}
            }
          }
        },
        RevokeCertificate: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "CertificateSerial",
              "RevocationReason"
            ],
            members: {
              CertificateAuthorityArn: {},
              CertificateSerial: {},
              RevocationReason: {}
            }
          }
        },
        TagCertificateAuthority: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "Tags"
            ],
            members: {
              CertificateAuthorityArn: {},
              Tags: {
                shape: "S11"
              }
            }
          }
        },
        UntagCertificateAuthority: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn",
              "Tags"
            ],
            members: {
              CertificateAuthorityArn: {},
              Tags: {
                shape: "S11"
              }
            }
          }
        },
        UpdateCertificateAuthority: {
          input: {
            type: "structure",
            required: [
              "CertificateAuthorityArn"
            ],
            members: {
              CertificateAuthorityArn: {},
              RevocationConfiguration: {
                shape: "Ss"
              },
              Status: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "KeyAlgorithm",
            "SigningAlgorithm",
            "Subject"
          ],
          members: {
            KeyAlgorithm: {},
            SigningAlgorithm: {},
            Subject: {
              shape: "S5"
            },
            CsrExtensions: {
              type: "structure",
              members: {
                KeyUsage: {
                  shape: "Sf"
                },
                SubjectInformationAccess: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "AccessMethod",
                      "AccessLocation"
                    ],
                    members: {
                      AccessMethod: {
                        type: "structure",
                        members: {
                          CustomObjectIdentifier: {},
                          AccessMethodType: {}
                        }
                      },
                      AccessLocation: {
                        shape: "Sm"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S5: {
          type: "structure",
          members: {
            Country: {},
            Organization: {},
            OrganizationalUnit: {},
            DistinguishedNameQualifier: {},
            State: {},
            CommonName: {},
            SerialNumber: {},
            Locality: {},
            Title: {},
            Surname: {},
            GivenName: {},
            Initials: {},
            Pseudonym: {},
            GenerationQualifier: {}
          }
        },
        Sf: {
          type: "structure",
          members: {
            DigitalSignature: {
              type: "boolean"
            },
            NonRepudiation: {
              type: "boolean"
            },
            KeyEncipherment: {
              type: "boolean"
            },
            DataEncipherment: {
              type: "boolean"
            },
            KeyAgreement: {
              type: "boolean"
            },
            KeyCertSign: {
              type: "boolean"
            },
            CRLSign: {
              type: "boolean"
            },
            EncipherOnly: {
              type: "boolean"
            },
            DecipherOnly: {
              type: "boolean"
            }
          }
        },
        Sm: {
          type: "structure",
          members: {
            OtherName: {
              type: "structure",
              required: [
                "TypeId",
                "Value"
              ],
              members: {
                TypeId: {},
                Value: {}
              }
            },
            Rfc822Name: {},
            DnsName: {},
            DirectoryName: {
              shape: "S5"
            },
            EdiPartyName: {
              type: "structure",
              required: [
                "PartyName"
              ],
              members: {
                PartyName: {},
                NameAssigner: {}
              }
            },
            UniformResourceIdentifier: {},
            IpAddress: {},
            RegisteredId: {}
          }
        },
        Ss: {
          type: "structure",
          members: {
            CrlConfiguration: {
              type: "structure",
              required: [
                "Enabled"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                ExpirationInDays: {
                  type: "integer"
                },
                CustomCname: {},
                S3BucketName: {},
                S3ObjectAcl: {}
              }
            },
            OcspConfiguration: {
              type: "structure",
              required: [
                "Enabled"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                },
                OcspCustomCname: {}
              }
            }
          }
        },
        S11: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S1g: {
          type: "list",
          member: {}
        },
        S1o: {
          type: "structure",
          members: {
            Arn: {},
            OwnerAccount: {},
            CreatedAt: {
              type: "timestamp"
            },
            LastStateChangeAt: {
              type: "timestamp"
            },
            Type: {},
            Serial: {},
            Status: {},
            NotBefore: {
              type: "timestamp"
            },
            NotAfter: {
              type: "timestamp"
            },
            FailureReason: {},
            CertificateAuthorityConfiguration: {
              shape: "S2"
            },
            RevocationConfiguration: {
              shape: "Ss"
            },
            RestorableUntil: {
              type: "timestamp"
            },
            KeyStorageSecurityStandard: {}
          }
        },
        S2p: {
          type: "structure",
          required: [
            "Value",
            "Type"
          ],
          members: {
            Value: {
              type: "long"
            },
            Type: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/acm-pca-2017-08-22.paginators.json
var require_acm_pca_2017_08_22_paginators = __commonJS({
  "node_modules/aws-sdk/apis/acm-pca-2017-08-22.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListCertificateAuthorities: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "CertificateAuthorities"
        },
        ListPermissions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Permissions"
        },
        ListTags: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Tags"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/acm-pca-2017-08-22.waiters2.json
var require_acm_pca_2017_08_22_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/acm-pca-2017-08-22.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        CertificateAuthorityCSRCreated: {
          description: "Wait until a Certificate Authority CSR is created",
          operation: "GetCertificateAuthorityCsr",
          delay: 3,
          maxAttempts: 60,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 200
            },
            {
              state: "retry",
              matcher: "error",
              expected: "RequestInProgressException"
            }
          ]
        },
        CertificateIssued: {
          description: "Wait until a certificate is issued",
          operation: "GetCertificate",
          delay: 3,
          maxAttempts: 60,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 200
            },
            {
              state: "retry",
              matcher: "error",
              expected: "RequestInProgressException"
            }
          ]
        },
        AuditReportCreated: {
          description: "Wait until a Audit Report is created",
          operation: "DescribeCertificateAuthorityAuditReport",
          delay: 3,
          maxAttempts: 60,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "AuditReportStatus",
              expected: "SUCCESS"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "AuditReportStatus",
              expected: "FAILED"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/acmpca.js
var require_acmpca = __commonJS({
  "node_modules/aws-sdk/clients/acmpca.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["acmpca"] = {};
    AWS3.ACMPCA = Service.defineService("acmpca", ["2017-08-22"]);
    Object.defineProperty(apiLoader.services["acmpca"], "2017-08-22", {
      get: function get() {
        var model = require_acm_pca_2017_08_22_min();
        model.paginators = require_acm_pca_2017_08_22_paginators().pagination;
        model.waiters = require_acm_pca_2017_08_22_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ACMPCA;
  }
});

// node_modules/aws-sdk/apis/fms-2018-01-01.min.json
var require_fms_2018_01_01_min = __commonJS({
  "node_modules/aws-sdk/apis/fms-2018-01-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-01-01",
        endpointPrefix: "fms",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "FMS",
        serviceFullName: "Firewall Management Service",
        serviceId: "FMS",
        signatureVersion: "v4",
        targetPrefix: "AWSFMS_20180101",
        uid: "fms-2018-01-01"
      },
      operations: {
        AssociateAdminAccount: {
          input: {
            type: "structure",
            required: [
              "AdminAccount"
            ],
            members: {
              AdminAccount: {}
            }
          }
        },
        DeleteAppsList: {
          input: {
            type: "structure",
            required: [
              "ListId"
            ],
            members: {
              ListId: {}
            }
          }
        },
        DeleteNotificationChannel: {
          input: {
            type: "structure",
            members: {}
          }
        },
        DeletePolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {},
              DeleteAllPolicyResources: {
                type: "boolean"
              }
            }
          }
        },
        DeleteProtocolsList: {
          input: {
            type: "structure",
            required: [
              "ListId"
            ],
            members: {
              ListId: {}
            }
          }
        },
        DisassociateAdminAccount: {
          input: {
            type: "structure",
            members: {}
          }
        },
        GetAdminAccount: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              AdminAccount: {},
              RoleStatus: {}
            }
          }
        },
        GetAppsList: {
          input: {
            type: "structure",
            required: [
              "ListId"
            ],
            members: {
              ListId: {},
              DefaultList: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppsList: {
                shape: "Sg"
              },
              AppsListArn: {}
            }
          }
        },
        GetComplianceDetail: {
          input: {
            type: "structure",
            required: [
              "PolicyId",
              "MemberAccount"
            ],
            members: {
              PolicyId: {},
              MemberAccount: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyComplianceDetail: {
                type: "structure",
                members: {
                  PolicyOwner: {},
                  PolicyId: {},
                  MemberAccount: {},
                  Violators: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ResourceId: {},
                        ViolationReason: {},
                        ResourceType: {}
                      }
                    }
                  },
                  EvaluationLimitExceeded: {
                    type: "boolean"
                  },
                  ExpiredAt: {
                    type: "timestamp"
                  },
                  IssueInfoMap: {
                    shape: "Sz"
                  }
                }
              }
            }
          }
        },
        GetNotificationChannel: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              SnsTopicArn: {},
              SnsRoleName: {}
            }
          }
        },
        GetPolicy: {
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                shape: "S16"
              },
              PolicyArn: {}
            }
          }
        },
        GetProtectionStatus: {
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {},
              MemberAccountId: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AdminAccountId: {},
              ServiceType: {},
              Data: {},
              NextToken: {}
            }
          }
        },
        GetProtocolsList: {
          input: {
            type: "structure",
            required: [
              "ListId"
            ],
            members: {
              ListId: {},
              DefaultList: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProtocolsList: {
                shape: "S1r"
              },
              ProtocolsListArn: {}
            }
          }
        },
        GetViolationDetails: {
          input: {
            type: "structure",
            required: [
              "PolicyId",
              "MemberAccount",
              "ResourceId",
              "ResourceType"
            ],
            members: {
              PolicyId: {},
              MemberAccount: {},
              ResourceId: {},
              ResourceType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ViolationDetail: {
                type: "structure",
                required: [
                  "PolicyId",
                  "MemberAccount",
                  "ResourceId",
                  "ResourceType",
                  "ResourceViolations"
                ],
                members: {
                  PolicyId: {},
                  MemberAccount: {},
                  ResourceId: {},
                  ResourceType: {},
                  ResourceViolations: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        AwsVPCSecurityGroupViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            ViolationTargetDescription: {},
                            PartialMatches: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  Reference: {},
                                  TargetViolationReasons: {
                                    type: "list",
                                    member: {}
                                  }
                                }
                              }
                            },
                            PossibleSecurityGroupRemediationActions: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  RemediationActionType: {},
                                  Description: {},
                                  RemediationResult: {
                                    type: "structure",
                                    members: {
                                      IPV4Range: {},
                                      IPV6Range: {},
                                      PrefixListId: {},
                                      Protocol: {},
                                      FromPort: {
                                        type: "long"
                                      },
                                      ToPort: {
                                        type: "long"
                                      }
                                    }
                                  },
                                  IsDefaultAction: {
                                    type: "boolean"
                                  }
                                }
                              }
                            }
                          }
                        },
                        AwsEc2NetworkInterfaceViolation: {
                          shape: "S2d"
                        },
                        AwsEc2InstanceViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            AwsEc2NetworkInterfaceViolations: {
                              type: "list",
                              member: {
                                shape: "S2d"
                              }
                            }
                          }
                        },
                        NetworkFirewallMissingFirewallViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            VPC: {},
                            AvailabilityZone: {},
                            TargetViolationReason: {}
                          }
                        },
                        NetworkFirewallMissingSubnetViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            VPC: {},
                            AvailabilityZone: {},
                            TargetViolationReason: {}
                          }
                        },
                        NetworkFirewallMissingExpectedRTViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            VPC: {},
                            AvailabilityZone: {},
                            CurrentRouteTable: {},
                            ExpectedRouteTable: {}
                          }
                        },
                        NetworkFirewallPolicyModifiedViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            CurrentPolicyDescription: {
                              shape: "S2l"
                            },
                            ExpectedPolicyDescription: {
                              shape: "S2l"
                            }
                          }
                        },
                        NetworkFirewallInternetTrafficNotInspectedViolation: {
                          type: "structure",
                          members: {
                            SubnetId: {},
                            SubnetAvailabilityZone: {},
                            RouteTableId: {},
                            ViolatingRoutes: {
                              shape: "S2v"
                            },
                            IsRouteTableUsedInDifferentAZ: {
                              type: "boolean"
                            },
                            CurrentFirewallSubnetRouteTable: {},
                            ExpectedFirewallEndpoint: {},
                            FirewallSubnetId: {},
                            ExpectedFirewallSubnetRoutes: {
                              shape: "S2z"
                            },
                            ActualFirewallSubnetRoutes: {
                              shape: "S2v"
                            },
                            InternetGatewayId: {},
                            CurrentInternetGatewayRouteTable: {},
                            ExpectedInternetGatewayRoutes: {
                              shape: "S2z"
                            },
                            ActualInternetGatewayRoutes: {
                              shape: "S2v"
                            },
                            VpcId: {}
                          }
                        },
                        NetworkFirewallInvalidRouteConfigurationViolation: {
                          type: "structure",
                          members: {
                            AffectedSubnets: {
                              shape: "S2e"
                            },
                            RouteTableId: {},
                            IsRouteTableUsedInDifferentAZ: {
                              type: "boolean"
                            },
                            ViolatingRoute: {
                              shape: "S2w"
                            },
                            CurrentFirewallSubnetRouteTable: {},
                            ExpectedFirewallEndpoint: {},
                            ActualFirewallEndpoint: {},
                            ExpectedFirewallSubnetId: {},
                            ActualFirewallSubnetId: {},
                            ExpectedFirewallSubnetRoutes: {
                              shape: "S2z"
                            },
                            ActualFirewallSubnetRoutes: {
                              shape: "S2v"
                            },
                            InternetGatewayId: {},
                            CurrentInternetGatewayRouteTable: {},
                            ExpectedInternetGatewayRoutes: {
                              shape: "S2z"
                            },
                            ActualInternetGatewayRoutes: {
                              shape: "S2v"
                            },
                            VpcId: {}
                          }
                        },
                        NetworkFirewallBlackHoleRouteDetectedViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            RouteTableId: {},
                            VpcId: {},
                            ViolatingRoutes: {
                              shape: "S2v"
                            }
                          }
                        },
                        NetworkFirewallUnexpectedFirewallRoutesViolation: {
                          type: "structure",
                          members: {
                            FirewallSubnetId: {},
                            ViolatingRoutes: {
                              shape: "S2v"
                            },
                            RouteTableId: {},
                            FirewallEndpoint: {},
                            VpcId: {}
                          }
                        },
                        NetworkFirewallUnexpectedGatewayRoutesViolation: {
                          type: "structure",
                          members: {
                            GatewayId: {},
                            ViolatingRoutes: {
                              shape: "S2v"
                            },
                            RouteTableId: {},
                            VpcId: {}
                          }
                        },
                        NetworkFirewallMissingExpectedRoutesViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            ExpectedRoutes: {
                              shape: "S2z"
                            },
                            VpcId: {}
                          }
                        },
                        DnsRuleGroupPriorityConflictViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            ViolationTargetDescription: {},
                            ConflictingPriority: {
                              type: "integer"
                            },
                            ConflictingPolicyId: {},
                            UnavailablePriorities: {
                              type: "list",
                              member: {
                                type: "integer"
                              }
                            }
                          }
                        },
                        DnsDuplicateRuleGroupViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            ViolationTargetDescription: {}
                          }
                        },
                        DnsRuleGroupLimitExceededViolation: {
                          type: "structure",
                          members: {
                            ViolationTarget: {},
                            ViolationTargetDescription: {},
                            NumberOfRuleGroupsAlreadyAssociated: {
                              type: "integer"
                            }
                          }
                        },
                        PossibleRemediationActions: {
                          type: "structure",
                          members: {
                            Description: {},
                            Actions: {
                              type: "list",
                              member: {
                                type: "structure",
                                required: [
                                  "OrderedRemediationActions"
                                ],
                                members: {
                                  Description: {},
                                  OrderedRemediationActions: {
                                    type: "list",
                                    member: {
                                      type: "structure",
                                      members: {
                                        RemediationAction: {
                                          type: "structure",
                                          members: {
                                            Description: {},
                                            EC2CreateRouteAction: {
                                              type: "structure",
                                              required: [
                                                "RouteTableId"
                                              ],
                                              members: {
                                                Description: {},
                                                DestinationCidrBlock: {},
                                                DestinationPrefixListId: {},
                                                DestinationIpv6CidrBlock: {},
                                                VpcEndpointId: {
                                                  shape: "S3k"
                                                },
                                                GatewayId: {
                                                  shape: "S3k"
                                                },
                                                RouteTableId: {
                                                  shape: "S3k"
                                                }
                                              }
                                            },
                                            EC2ReplaceRouteAction: {
                                              type: "structure",
                                              required: [
                                                "RouteTableId"
                                              ],
                                              members: {
                                                Description: {},
                                                DestinationCidrBlock: {},
                                                DestinationPrefixListId: {},
                                                DestinationIpv6CidrBlock: {},
                                                GatewayId: {
                                                  shape: "S3k"
                                                },
                                                RouteTableId: {
                                                  shape: "S3k"
                                                }
                                              }
                                            },
                                            EC2DeleteRouteAction: {
                                              type: "structure",
                                              required: [
                                                "RouteTableId"
                                              ],
                                              members: {
                                                Description: {},
                                                DestinationCidrBlock: {},
                                                DestinationPrefixListId: {},
                                                DestinationIpv6CidrBlock: {},
                                                RouteTableId: {
                                                  shape: "S3k"
                                                }
                                              }
                                            },
                                            EC2CopyRouteTableAction: {
                                              type: "structure",
                                              required: [
                                                "VpcId",
                                                "RouteTableId"
                                              ],
                                              members: {
                                                Description: {},
                                                VpcId: {
                                                  shape: "S3k"
                                                },
                                                RouteTableId: {
                                                  shape: "S3k"
                                                }
                                              }
                                            },
                                            EC2ReplaceRouteTableAssociationAction: {
                                              type: "structure",
                                              required: [
                                                "AssociationId",
                                                "RouteTableId"
                                              ],
                                              members: {
                                                Description: {},
                                                AssociationId: {
                                                  shape: "S3k"
                                                },
                                                RouteTableId: {
                                                  shape: "S3k"
                                                }
                                              }
                                            },
                                            EC2AssociateRouteTableAction: {
                                              type: "structure",
                                              required: [
                                                "RouteTableId"
                                              ],
                                              members: {
                                                Description: {},
                                                RouteTableId: {
                                                  shape: "S3k"
                                                },
                                                SubnetId: {
                                                  shape: "S3k"
                                                },
                                                GatewayId: {
                                                  shape: "S3k"
                                                }
                                              }
                                            },
                                            EC2CreateRouteTableAction: {
                                              type: "structure",
                                              required: [
                                                "VpcId"
                                              ],
                                              members: {
                                                Description: {},
                                                VpcId: {
                                                  shape: "S3k"
                                                }
                                              }
                                            }
                                          }
                                        },
                                        Order: {
                                          type: "integer"
                                        }
                                      }
                                    }
                                  },
                                  IsDefaultAction: {
                                    type: "boolean"
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  ResourceTags: {
                    shape: "S3r"
                  },
                  ResourceDescription: {}
                }
              }
            }
          }
        },
        ListAppsLists: {
          input: {
            type: "structure",
            required: [
              "MaxResults"
            ],
            members: {
              DefaultLists: {
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppsLists: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ListArn: {},
                    ListId: {},
                    ListName: {},
                    AppsList: {
                      shape: "Sk"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListComplianceStatus: {
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyComplianceStatusList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PolicyOwner: {},
                    PolicyId: {},
                    PolicyName: {},
                    MemberAccount: {},
                    EvaluationResults: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ComplianceStatus: {},
                          ViolatorCount: {
                            type: "long"
                          },
                          EvaluationLimitExceeded: {
                            type: "boolean"
                          }
                        }
                      }
                    },
                    LastUpdated: {
                      type: "timestamp"
                    },
                    IssueInfoMap: {
                      shape: "Sz"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListMemberAccounts: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MemberAccounts: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListPolicies: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PolicyArn: {},
                    PolicyId: {},
                    PolicyName: {},
                    ResourceType: {},
                    SecurityServiceType: {},
                    RemediationEnabled: {
                      type: "boolean"
                    },
                    DeleteUnusedFMManagedResources: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProtocolsLists: {
          input: {
            type: "structure",
            required: [
              "MaxResults"
            ],
            members: {
              DefaultLists: {
                type: "boolean"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProtocolsLists: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ListArn: {},
                    ListId: {},
                    ListName: {},
                    ProtocolsList: {
                      shape: "S1s"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "S3r"
              }
            }
          }
        },
        PutAppsList: {
          input: {
            type: "structure",
            required: [
              "AppsList"
            ],
            members: {
              AppsList: {
                shape: "Sg"
              },
              TagList: {
                shape: "S3r"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppsList: {
                shape: "Sg"
              },
              AppsListArn: {}
            }
          }
        },
        PutNotificationChannel: {
          input: {
            type: "structure",
            required: [
              "SnsTopicArn",
              "SnsRoleName"
            ],
            members: {
              SnsTopicArn: {},
              SnsRoleName: {}
            }
          }
        },
        PutPolicy: {
          input: {
            type: "structure",
            required: [
              "Policy"
            ],
            members: {
              Policy: {
                shape: "S16"
              },
              TagList: {
                shape: "S3r"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                shape: "S16"
              },
              PolicyArn: {}
            }
          }
        },
        PutProtocolsList: {
          input: {
            type: "structure",
            required: [
              "ProtocolsList"
            ],
            members: {
              ProtocolsList: {
                shape: "S1r"
              },
              TagList: {
                shape: "S3r"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProtocolsList: {
                shape: "S1r"
              },
              ProtocolsListArn: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagList"
            ],
            members: {
              ResourceArn: {},
              TagList: {
                shape: "S3r"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sg: {
          type: "structure",
          required: [
            "ListName",
            "AppsList"
          ],
          members: {
            ListId: {},
            ListName: {},
            ListUpdateToken: {},
            CreateTime: {
              type: "timestamp"
            },
            LastUpdateTime: {
              type: "timestamp"
            },
            AppsList: {
              shape: "Sk"
            },
            PreviousAppsList: {
              type: "map",
              key: {},
              value: {
                shape: "Sk"
              }
            }
          }
        },
        Sk: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AppName",
              "Protocol",
              "Port"
            ],
            members: {
              AppName: {},
              Protocol: {},
              Port: {
                type: "long"
              }
            }
          }
        },
        Sz: {
          type: "map",
          key: {},
          value: {}
        },
        S16: {
          type: "structure",
          required: [
            "PolicyName",
            "SecurityServicePolicyData",
            "ResourceType",
            "ExcludeResourceTags",
            "RemediationEnabled"
          ],
          members: {
            PolicyId: {},
            PolicyName: {},
            PolicyUpdateToken: {},
            SecurityServicePolicyData: {
              type: "structure",
              required: [
                "Type"
              ],
              members: {
                Type: {},
                ManagedServiceData: {}
              }
            },
            ResourceType: {},
            ResourceTypeList: {
              type: "list",
              member: {}
            },
            ResourceTags: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Key"
                ],
                members: {
                  Key: {},
                  Value: {}
                }
              }
            },
            ExcludeResourceTags: {
              type: "boolean"
            },
            RemediationEnabled: {
              type: "boolean"
            },
            DeleteUnusedFMManagedResources: {
              type: "boolean"
            },
            IncludeMap: {
              shape: "S1g"
            },
            ExcludeMap: {
              shape: "S1g"
            }
          }
        },
        S1g: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          }
        },
        S1r: {
          type: "structure",
          required: [
            "ListName",
            "ProtocolsList"
          ],
          members: {
            ListId: {},
            ListName: {},
            ListUpdateToken: {},
            CreateTime: {
              type: "timestamp"
            },
            LastUpdateTime: {
              type: "timestamp"
            },
            ProtocolsList: {
              shape: "S1s"
            },
            PreviousProtocolsList: {
              type: "map",
              key: {},
              value: {
                shape: "S1s"
              }
            }
          }
        },
        S1s: {
          type: "list",
          member: {}
        },
        S2d: {
          type: "structure",
          members: {
            ViolationTarget: {},
            ViolatingSecurityGroups: {
              shape: "S2e"
            }
          }
        },
        S2e: {
          type: "list",
          member: {}
        },
        S2l: {
          type: "structure",
          members: {
            StatelessRuleGroups: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  RuleGroupName: {},
                  ResourceId: {},
                  Priority: {
                    type: "integer"
                  }
                }
              }
            },
            StatelessDefaultActions: {
              shape: "S2q"
            },
            StatelessFragmentDefaultActions: {
              shape: "S2q"
            },
            StatelessCustomActions: {
              shape: "S2q"
            },
            StatefulRuleGroups: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  RuleGroupName: {},
                  ResourceId: {}
                }
              }
            }
          }
        },
        S2q: {
          type: "list",
          member: {}
        },
        S2v: {
          type: "list",
          member: {
            shape: "S2w"
          }
        },
        S2w: {
          type: "structure",
          members: {
            DestinationType: {},
            TargetType: {},
            Destination: {},
            Target: {}
          }
        },
        S2z: {
          type: "list",
          member: {
            type: "structure",
            members: {
              IpV4Cidr: {},
              PrefixListId: {},
              IpV6Cidr: {},
              ContributingSubnets: {
                shape: "S2e"
              },
              AllowedTargets: {
                type: "list",
                member: {}
              },
              RouteTableId: {}
            }
          }
        },
        S3k: {
          type: "structure",
          members: {
            ResourceId: {},
            Description: {}
          }
        },
        S3r: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/fms-2018-01-01.paginators.json
var require_fms_2018_01_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/fms-2018-01-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAppsLists: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AppsLists"
        },
        ListComplianceStatus: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PolicyComplianceStatusList"
        },
        ListMemberAccounts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "MemberAccounts"
        },
        ListPolicies: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PolicyList"
        },
        ListProtocolsLists: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ProtocolsLists"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/fms.js
var require_fms = __commonJS({
  "node_modules/aws-sdk/clients/fms.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["fms"] = {};
    AWS3.FMS = Service.defineService("fms", ["2018-01-01"]);
    Object.defineProperty(apiLoader.services["fms"], "2018-01-01", {
      get: function get() {
        var model = require_fms_2018_01_01_min();
        model.paginators = require_fms_2018_01_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.FMS;
  }
});

// node_modules/aws-sdk/apis/secretsmanager-2017-10-17.min.json
var require_secretsmanager_2017_10_17_min = __commonJS({
  "node_modules/aws-sdk/apis/secretsmanager-2017-10-17.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-10-17",
        endpointPrefix: "secretsmanager",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Secrets Manager",
        serviceId: "Secrets Manager",
        signatureVersion: "v4",
        signingName: "secretsmanager",
        targetPrefix: "secretsmanager",
        uid: "secretsmanager-2017-10-17"
      },
      operations: {
        CancelRotateSecret: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {},
              VersionId: {}
            }
          }
        },
        CreateSecret: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Description: {},
              KmsKeyId: {},
              SecretBinary: {
                shape: "Sc"
              },
              SecretString: {
                shape: "Sd"
              },
              Tags: {
                shape: "Se"
              },
              AddReplicaRegions: {
                shape: "Si"
              },
              ForceOverwriteReplicaSecret: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {},
              VersionId: {},
              ReplicationStatus: {
                shape: "Sn"
              }
            }
          }
        },
        DeleteResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {}
            }
          }
        },
        DeleteSecret: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {},
              RecoveryWindowInDays: {
                type: "long"
              },
              ForceDeleteWithoutRecovery: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {},
              DeletionDate: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeSecret: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {},
              Description: {},
              KmsKeyId: {},
              RotationEnabled: {
                type: "boolean"
              },
              RotationLambdaARN: {},
              RotationRules: {
                shape: "S12"
              },
              LastRotatedDate: {
                type: "timestamp"
              },
              LastChangedDate: {
                type: "timestamp"
              },
              LastAccessedDate: {
                type: "timestamp"
              },
              DeletedDate: {
                type: "timestamp"
              },
              Tags: {
                shape: "Se"
              },
              VersionIdsToStages: {
                shape: "S17"
              },
              OwningService: {},
              CreatedDate: {
                type: "timestamp"
              },
              PrimaryRegion: {},
              ReplicationStatus: {
                shape: "Sn"
              }
            }
          }
        },
        GetRandomPassword: {
          input: {
            type: "structure",
            members: {
              PasswordLength: {
                type: "long"
              },
              ExcludeCharacters: {},
              ExcludeNumbers: {
                type: "boolean"
              },
              ExcludePunctuation: {
                type: "boolean"
              },
              ExcludeUppercase: {
                type: "boolean"
              },
              ExcludeLowercase: {
                type: "boolean"
              },
              IncludeSpace: {
                type: "boolean"
              },
              RequireEachIncludedType: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RandomPassword: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        GetResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {},
              ResourcePolicy: {}
            }
          }
        },
        GetSecretValue: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {},
              VersionId: {},
              VersionStage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {},
              VersionId: {},
              SecretBinary: {
                shape: "Sc"
              },
              SecretString: {
                shape: "Sd"
              },
              VersionStages: {
                shape: "S18"
              },
              CreatedDate: {
                type: "timestamp"
              }
            }
          }
        },
        ListSecretVersionIds: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              IncludeDeprecated: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Versions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VersionId: {},
                    VersionStages: {
                      shape: "S18"
                    },
                    LastAccessedDate: {
                      type: "timestamp"
                    },
                    CreatedDate: {
                      type: "timestamp"
                    },
                    KmsKeyIds: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              NextToken: {},
              ARN: {},
              Name: {}
            }
          }
        },
        ListSecrets: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SecretList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ARN: {},
                    Name: {},
                    Description: {},
                    KmsKeyId: {},
                    RotationEnabled: {
                      type: "boolean"
                    },
                    RotationLambdaARN: {},
                    RotationRules: {
                      shape: "S12"
                    },
                    LastRotatedDate: {
                      type: "timestamp"
                    },
                    LastChangedDate: {
                      type: "timestamp"
                    },
                    LastAccessedDate: {
                      type: "timestamp"
                    },
                    DeletedDate: {
                      type: "timestamp"
                    },
                    Tags: {
                      shape: "Se"
                    },
                    SecretVersionsToStages: {
                      shape: "S17"
                    },
                    OwningService: {},
                    CreatedDate: {
                      type: "timestamp"
                    },
                    PrimaryRegion: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        PutResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "SecretId",
              "ResourcePolicy"
            ],
            members: {
              SecretId: {},
              ResourcePolicy: {},
              BlockPublicPolicy: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {}
            }
          }
        },
        PutSecretValue: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              SecretBinary: {
                shape: "Sc"
              },
              SecretString: {
                shape: "Sd"
              },
              VersionStages: {
                shape: "S18"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {},
              VersionId: {},
              VersionStages: {
                shape: "S18"
              }
            }
          }
        },
        RemoveRegionsFromReplication: {
          input: {
            type: "structure",
            required: [
              "SecretId",
              "RemoveReplicaRegions"
            ],
            members: {
              SecretId: {},
              RemoveReplicaRegions: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              ReplicationStatus: {
                shape: "Sn"
              }
            }
          }
        },
        ReplicateSecretToRegions: {
          input: {
            type: "structure",
            required: [
              "SecretId",
              "AddReplicaRegions"
            ],
            members: {
              SecretId: {},
              AddReplicaRegions: {
                shape: "Si"
              },
              ForceOverwriteReplicaSecret: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              ReplicationStatus: {
                shape: "Sn"
              }
            }
          }
        },
        RestoreSecret: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {}
            }
          }
        },
        RotateSecret: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              RotationLambdaARN: {},
              RotationRules: {
                shape: "S12"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {},
              VersionId: {}
            }
          }
        },
        StopReplicationToReplica: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "SecretId",
              "Tags"
            ],
            members: {
              SecretId: {},
              Tags: {
                shape: "Se"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "SecretId",
              "TagKeys"
            ],
            members: {
              SecretId: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateSecret: {
          input: {
            type: "structure",
            required: [
              "SecretId"
            ],
            members: {
              SecretId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Description: {},
              KmsKeyId: {},
              SecretBinary: {
                shape: "Sc"
              },
              SecretString: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {},
              VersionId: {}
            }
          }
        },
        UpdateSecretVersionStage: {
          input: {
            type: "structure",
            required: [
              "SecretId",
              "VersionStage"
            ],
            members: {
              SecretId: {},
              VersionStage: {},
              RemoveFromVersionId: {},
              MoveToVersionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ARN: {},
              Name: {}
            }
          }
        },
        ValidateResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourcePolicy"
            ],
            members: {
              SecretId: {},
              ResourcePolicy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyValidationPassed: {
                type: "boolean"
              },
              ValidationErrors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CheckName: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        }
      },
      shapes: {
        Sc: {
          type: "blob",
          sensitive: true
        },
        Sd: {
          type: "string",
          sensitive: true
        },
        Se: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Si: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Region: {},
              KmsKeyId: {}
            }
          }
        },
        Sn: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Region: {},
              KmsKeyId: {},
              Status: {},
              StatusMessage: {},
              LastAccessedDate: {
                type: "timestamp"
              }
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            AutomaticallyAfterDays: {
              type: "long"
            }
          }
        },
        S17: {
          type: "map",
          key: {},
          value: {
            shape: "S18"
          }
        },
        S18: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/secretsmanager-2017-10-17.paginators.json
var require_secretsmanager_2017_10_17_paginators = __commonJS({
  "node_modules/aws-sdk/apis/secretsmanager-2017-10-17.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListSecretVersionIds: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSecrets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/secretsmanager.js
var require_secretsmanager = __commonJS({
  "node_modules/aws-sdk/clients/secretsmanager.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["secretsmanager"] = {};
    AWS3.SecretsManager = Service.defineService("secretsmanager", ["2017-10-17"]);
    Object.defineProperty(apiLoader.services["secretsmanager"], "2017-10-17", {
      get: function get() {
        var model = require_secretsmanager_2017_10_17_min();
        model.paginators = require_secretsmanager_2017_10_17_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SecretsManager;
  }
});

// node_modules/aws-sdk/apis/iotanalytics-2017-11-27.min.json
var require_iotanalytics_2017_11_27_min = __commonJS({
  "node_modules/aws-sdk/apis/iotanalytics-2017-11-27.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-11-27",
        endpointPrefix: "iotanalytics",
        protocol: "rest-json",
        serviceFullName: "AWS IoT Analytics",
        serviceId: "IoTAnalytics",
        signatureVersion: "v4",
        signingName: "iotanalytics",
        uid: "iotanalytics-2017-11-27"
      },
      operations: {
        BatchPutMessage: {
          http: {
            requestUri: "/messages/batch",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channelName",
              "messages"
            ],
            members: {
              channelName: {},
              messages: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "messageId",
                    "payload"
                  ],
                  members: {
                    messageId: {},
                    payload: {
                      type: "blob"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              batchPutMessageErrorEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    messageId: {},
                    errorCode: {},
                    errorMessage: {}
                  }
                }
              }
            }
          }
        },
        CancelPipelineReprocessing: {
          http: {
            method: "DELETE",
            requestUri: "/pipelines/{pipelineName}/reprocessing/{reprocessingId}"
          },
          input: {
            type: "structure",
            required: [
              "pipelineName",
              "reprocessingId"
            ],
            members: {
              pipelineName: {
                location: "uri",
                locationName: "pipelineName"
              },
              reprocessingId: {
                location: "uri",
                locationName: "reprocessingId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateChannel: {
          http: {
            requestUri: "/channels",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "channelName"
            ],
            members: {
              channelName: {},
              channelStorage: {
                shape: "Sh"
              },
              retentionPeriod: {
                shape: "Sn"
              },
              tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              channelName: {},
              channelArn: {},
              retentionPeriod: {
                shape: "Sn"
              }
            }
          }
        },
        CreateDataset: {
          http: {
            requestUri: "/datasets",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "datasetName",
              "actions"
            ],
            members: {
              datasetName: {},
              actions: {
                shape: "Sy"
              },
              triggers: {
                shape: "S1l"
              },
              contentDeliveryRules: {
                shape: "S1q"
              },
              retentionPeriod: {
                shape: "Sn"
              },
              versioningConfiguration: {
                shape: "S21"
              },
              tags: {
                shape: "Sq"
              },
              lateDataRules: {
                shape: "S24"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetName: {},
              datasetArn: {},
              retentionPeriod: {
                shape: "Sn"
              }
            }
          }
        },
        CreateDatasetContent: {
          http: {
            requestUri: "/datasets/{datasetName}/content"
          },
          input: {
            type: "structure",
            required: [
              "datasetName"
            ],
            members: {
              datasetName: {
                location: "uri",
                locationName: "datasetName"
              },
              versionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              versionId: {}
            }
          }
        },
        CreateDatastore: {
          http: {
            requestUri: "/datastores",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "datastoreName"
            ],
            members: {
              datastoreName: {},
              datastoreStorage: {
                shape: "S2h"
              },
              retentionPeriod: {
                shape: "Sn"
              },
              tags: {
                shape: "Sq"
              },
              fileFormatConfiguration: {
                shape: "S2m"
              },
              datastorePartitions: {
                shape: "S2u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datastoreName: {},
              datastoreArn: {},
              retentionPeriod: {
                shape: "Sn"
              }
            }
          }
        },
        CreatePipeline: {
          http: {
            requestUri: "/pipelines",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "pipelineName",
              "pipelineActivities"
            ],
            members: {
              pipelineName: {},
              pipelineActivities: {
                shape: "S34"
              },
              tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pipelineName: {},
              pipelineArn: {}
            }
          }
        },
        DeleteChannel: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "channelName"
            ],
            members: {
              channelName: {
                location: "uri",
                locationName: "channelName"
              }
            }
          }
        },
        DeleteDataset: {
          http: {
            method: "DELETE",
            requestUri: "/datasets/{datasetName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "datasetName"
            ],
            members: {
              datasetName: {
                location: "uri",
                locationName: "datasetName"
              }
            }
          }
        },
        DeleteDatasetContent: {
          http: {
            method: "DELETE",
            requestUri: "/datasets/{datasetName}/content",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "datasetName"
            ],
            members: {
              datasetName: {
                location: "uri",
                locationName: "datasetName"
              },
              versionId: {
                location: "querystring",
                locationName: "versionId"
              }
            }
          }
        },
        DeleteDatastore: {
          http: {
            method: "DELETE",
            requestUri: "/datastores/{datastoreName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "datastoreName"
            ],
            members: {
              datastoreName: {
                location: "uri",
                locationName: "datastoreName"
              }
            }
          }
        },
        DeletePipeline: {
          http: {
            method: "DELETE",
            requestUri: "/pipelines/{pipelineName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "pipelineName"
            ],
            members: {
              pipelineName: {
                location: "uri",
                locationName: "pipelineName"
              }
            }
          }
        },
        DescribeChannel: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelName}"
          },
          input: {
            type: "structure",
            required: [
              "channelName"
            ],
            members: {
              channelName: {
                location: "uri",
                locationName: "channelName"
              },
              includeStatistics: {
                location: "querystring",
                locationName: "includeStatistics",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              channel: {
                type: "structure",
                members: {
                  name: {},
                  storage: {
                    shape: "Sh"
                  },
                  arn: {},
                  status: {},
                  retentionPeriod: {
                    shape: "Sn"
                  },
                  creationTime: {
                    type: "timestamp"
                  },
                  lastUpdateTime: {
                    type: "timestamp"
                  },
                  lastMessageArrivalTime: {
                    type: "timestamp"
                  }
                }
              },
              statistics: {
                type: "structure",
                members: {
                  size: {
                    shape: "S42"
                  }
                }
              }
            }
          }
        },
        DescribeDataset: {
          http: {
            method: "GET",
            requestUri: "/datasets/{datasetName}"
          },
          input: {
            type: "structure",
            required: [
              "datasetName"
            ],
            members: {
              datasetName: {
                location: "uri",
                locationName: "datasetName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataset: {
                type: "structure",
                members: {
                  name: {},
                  arn: {},
                  actions: {
                    shape: "Sy"
                  },
                  triggers: {
                    shape: "S1l"
                  },
                  contentDeliveryRules: {
                    shape: "S1q"
                  },
                  status: {},
                  creationTime: {
                    type: "timestamp"
                  },
                  lastUpdateTime: {
                    type: "timestamp"
                  },
                  retentionPeriod: {
                    shape: "Sn"
                  },
                  versioningConfiguration: {
                    shape: "S21"
                  },
                  lateDataRules: {
                    shape: "S24"
                  }
                }
              }
            }
          }
        },
        DescribeDatastore: {
          http: {
            method: "GET",
            requestUri: "/datastores/{datastoreName}"
          },
          input: {
            type: "structure",
            required: [
              "datastoreName"
            ],
            members: {
              datastoreName: {
                location: "uri",
                locationName: "datastoreName"
              },
              includeStatistics: {
                location: "querystring",
                locationName: "includeStatistics",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datastore: {
                type: "structure",
                members: {
                  name: {},
                  storage: {
                    shape: "S2h"
                  },
                  arn: {},
                  status: {},
                  retentionPeriod: {
                    shape: "Sn"
                  },
                  creationTime: {
                    type: "timestamp"
                  },
                  lastUpdateTime: {
                    type: "timestamp"
                  },
                  lastMessageArrivalTime: {
                    type: "timestamp"
                  },
                  fileFormatConfiguration: {
                    shape: "S2m"
                  },
                  datastorePartitions: {
                    shape: "S2u"
                  }
                }
              },
              statistics: {
                type: "structure",
                members: {
                  size: {
                    shape: "S42"
                  }
                }
              }
            }
          }
        },
        DescribeLoggingOptions: {
          http: {
            method: "GET",
            requestUri: "/logging"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              loggingOptions: {
                shape: "S4f"
              }
            }
          }
        },
        DescribePipeline: {
          http: {
            method: "GET",
            requestUri: "/pipelines/{pipelineName}"
          },
          input: {
            type: "structure",
            required: [
              "pipelineName"
            ],
            members: {
              pipelineName: {
                location: "uri",
                locationName: "pipelineName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pipeline: {
                type: "structure",
                members: {
                  name: {},
                  arn: {},
                  activities: {
                    shape: "S34"
                  },
                  reprocessingSummaries: {
                    shape: "S4l"
                  },
                  creationTime: {
                    type: "timestamp"
                  },
                  lastUpdateTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        GetDatasetContent: {
          http: {
            method: "GET",
            requestUri: "/datasets/{datasetName}/content"
          },
          input: {
            type: "structure",
            required: [
              "datasetName"
            ],
            members: {
              datasetName: {
                location: "uri",
                locationName: "datasetName"
              },
              versionId: {
                location: "querystring",
                locationName: "versionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    entryName: {},
                    dataURI: {}
                  }
                }
              },
              timestamp: {
                type: "timestamp"
              },
              status: {
                shape: "S4t"
              }
            }
          }
        },
        ListChannels: {
          http: {
            method: "GET",
            requestUri: "/channels"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              channelSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    channelName: {},
                    channelStorage: {
                      type: "structure",
                      members: {
                        serviceManagedS3: {
                          type: "structure",
                          members: {}
                        },
                        customerManagedS3: {
                          type: "structure",
                          members: {
                            bucket: {},
                            keyPrefix: {},
                            roleArn: {}
                          }
                        }
                      }
                    },
                    status: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    },
                    lastMessageArrivalTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDatasetContents: {
          http: {
            method: "GET",
            requestUri: "/datasets/{datasetName}/contents"
          },
          input: {
            type: "structure",
            required: [
              "datasetName"
            ],
            members: {
              datasetName: {
                location: "uri",
                locationName: "datasetName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              scheduledOnOrAfter: {
                location: "querystring",
                locationName: "scheduledOnOrAfter",
                type: "timestamp"
              },
              scheduledBefore: {
                location: "querystring",
                locationName: "scheduledBefore",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetContentSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    version: {},
                    status: {
                      shape: "S4t"
                    },
                    creationTime: {
                      type: "timestamp"
                    },
                    scheduleTime: {
                      type: "timestamp"
                    },
                    completionTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDatasets: {
          http: {
            method: "GET",
            requestUri: "/datasets"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    datasetName: {},
                    status: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    },
                    triggers: {
                      shape: "S1l"
                    },
                    actions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          actionName: {},
                          actionType: {}
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDatastores: {
          http: {
            method: "GET",
            requestUri: "/datastores"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datastoreSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    datastoreName: {},
                    datastoreStorage: {
                      type: "structure",
                      members: {
                        serviceManagedS3: {
                          type: "structure",
                          members: {}
                        },
                        customerManagedS3: {
                          type: "structure",
                          members: {
                            bucket: {},
                            keyPrefix: {},
                            roleArn: {}
                          }
                        },
                        iotSiteWiseMultiLayerStorage: {
                          type: "structure",
                          members: {
                            customerManagedS3Storage: {
                              type: "structure",
                              members: {
                                bucket: {},
                                keyPrefix: {}
                              }
                            }
                          }
                        }
                      }
                    },
                    status: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    },
                    lastMessageArrivalTime: {
                      type: "timestamp"
                    },
                    fileFormatType: {},
                    datastorePartitions: {
                      shape: "S2u"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListPipelines: {
          http: {
            method: "GET",
            requestUri: "/pipelines"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              pipelineSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    pipelineName: {},
                    reprocessingSummaries: {
                      shape: "S4l"
                    },
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sq"
              }
            }
          }
        },
        PutLoggingOptions: {
          http: {
            method: "PUT",
            requestUri: "/logging"
          },
          input: {
            type: "structure",
            required: [
              "loggingOptions"
            ],
            members: {
              loggingOptions: {
                shape: "S4f"
              }
            }
          }
        },
        RunPipelineActivity: {
          http: {
            requestUri: "/pipelineactivities/run"
          },
          input: {
            type: "structure",
            required: [
              "pipelineActivity",
              "payloads"
            ],
            members: {
              pipelineActivity: {
                shape: "S35"
              },
              payloads: {
                shape: "S5z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              payloads: {
                shape: "S5z"
              },
              logResult: {}
            }
          }
        },
        SampleChannelData: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelName}/sample"
          },
          input: {
            type: "structure",
            required: [
              "channelName"
            ],
            members: {
              channelName: {
                location: "uri",
                locationName: "channelName"
              },
              maxMessages: {
                location: "querystring",
                locationName: "maxMessages",
                type: "integer"
              },
              startTime: {
                location: "querystring",
                locationName: "startTime",
                type: "timestamp"
              },
              endTime: {
                location: "querystring",
                locationName: "endTime",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              payloads: {
                shape: "S5z"
              }
            }
          }
        },
        StartPipelineReprocessing: {
          http: {
            requestUri: "/pipelines/{pipelineName}/reprocessing"
          },
          input: {
            type: "structure",
            required: [
              "pipelineName"
            ],
            members: {
              pipelineName: {
                location: "uri",
                locationName: "pipelineName"
              },
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              channelMessages: {
                type: "structure",
                members: {
                  s3Paths: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              reprocessingId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sq"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateChannel: {
          http: {
            method: "PUT",
            requestUri: "/channels/{channelName}"
          },
          input: {
            type: "structure",
            required: [
              "channelName"
            ],
            members: {
              channelName: {
                location: "uri",
                locationName: "channelName"
              },
              channelStorage: {
                shape: "Sh"
              },
              retentionPeriod: {
                shape: "Sn"
              }
            }
          }
        },
        UpdateDataset: {
          http: {
            method: "PUT",
            requestUri: "/datasets/{datasetName}"
          },
          input: {
            type: "structure",
            required: [
              "datasetName",
              "actions"
            ],
            members: {
              datasetName: {
                location: "uri",
                locationName: "datasetName"
              },
              actions: {
                shape: "Sy"
              },
              triggers: {
                shape: "S1l"
              },
              contentDeliveryRules: {
                shape: "S1q"
              },
              retentionPeriod: {
                shape: "Sn"
              },
              versioningConfiguration: {
                shape: "S21"
              },
              lateDataRules: {
                shape: "S24"
              }
            }
          }
        },
        UpdateDatastore: {
          http: {
            method: "PUT",
            requestUri: "/datastores/{datastoreName}"
          },
          input: {
            type: "structure",
            required: [
              "datastoreName"
            ],
            members: {
              datastoreName: {
                location: "uri",
                locationName: "datastoreName"
              },
              retentionPeriod: {
                shape: "Sn"
              },
              datastoreStorage: {
                shape: "S2h"
              },
              fileFormatConfiguration: {
                shape: "S2m"
              }
            }
          }
        },
        UpdatePipeline: {
          http: {
            method: "PUT",
            requestUri: "/pipelines/{pipelineName}"
          },
          input: {
            type: "structure",
            required: [
              "pipelineName",
              "pipelineActivities"
            ],
            members: {
              pipelineName: {
                location: "uri",
                locationName: "pipelineName"
              },
              pipelineActivities: {
                shape: "S34"
              }
            }
          }
        }
      },
      shapes: {
        Sh: {
          type: "structure",
          members: {
            serviceManagedS3: {
              type: "structure",
              members: {}
            },
            customerManagedS3: {
              type: "structure",
              required: [
                "bucket",
                "roleArn"
              ],
              members: {
                bucket: {},
                keyPrefix: {},
                roleArn: {}
              }
            }
          }
        },
        Sn: {
          type: "structure",
          members: {
            unlimited: {
              type: "boolean"
            },
            numberOfDays: {
              type: "integer"
            }
          }
        },
        Sq: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sy: {
          type: "list",
          member: {
            type: "structure",
            members: {
              actionName: {},
              queryAction: {
                type: "structure",
                required: [
                  "sqlQuery"
                ],
                members: {
                  sqlQuery: {},
                  filters: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        deltaTime: {
                          type: "structure",
                          required: [
                            "offsetSeconds",
                            "timeExpression"
                          ],
                          members: {
                            offsetSeconds: {
                              type: "integer"
                            },
                            timeExpression: {}
                          }
                        }
                      }
                    }
                  }
                }
              },
              containerAction: {
                type: "structure",
                required: [
                  "image",
                  "executionRoleArn",
                  "resourceConfiguration"
                ],
                members: {
                  image: {},
                  executionRoleArn: {},
                  resourceConfiguration: {
                    type: "structure",
                    required: [
                      "computeType",
                      "volumeSizeInGB"
                    ],
                    members: {
                      computeType: {},
                      volumeSizeInGB: {
                        type: "integer"
                      }
                    }
                  },
                  variables: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "name"
                      ],
                      members: {
                        name: {},
                        stringValue: {},
                        doubleValue: {
                          type: "double"
                        },
                        datasetContentVersionValue: {
                          type: "structure",
                          required: [
                            "datasetName"
                          ],
                          members: {
                            datasetName: {}
                          }
                        },
                        outputFileUriValue: {
                          type: "structure",
                          required: [
                            "fileName"
                          ],
                          members: {
                            fileName: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S1l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              schedule: {
                type: "structure",
                members: {
                  expression: {}
                }
              },
              dataset: {
                type: "structure",
                required: [
                  "name"
                ],
                members: {
                  name: {}
                }
              }
            }
          }
        },
        S1q: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "destination"
            ],
            members: {
              entryName: {},
              destination: {
                type: "structure",
                members: {
                  iotEventsDestinationConfiguration: {
                    type: "structure",
                    required: [
                      "inputName",
                      "roleArn"
                    ],
                    members: {
                      inputName: {},
                      roleArn: {}
                    }
                  },
                  s3DestinationConfiguration: {
                    type: "structure",
                    required: [
                      "bucket",
                      "key",
                      "roleArn"
                    ],
                    members: {
                      bucket: {},
                      key: {},
                      glueConfiguration: {
                        type: "structure",
                        required: [
                          "tableName",
                          "databaseName"
                        ],
                        members: {
                          tableName: {},
                          databaseName: {}
                        }
                      },
                      roleArn: {}
                    }
                  }
                }
              }
            }
          }
        },
        S21: {
          type: "structure",
          members: {
            unlimited: {
              type: "boolean"
            },
            maxVersions: {
              type: "integer"
            }
          }
        },
        S24: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ruleConfiguration"
            ],
            members: {
              ruleName: {},
              ruleConfiguration: {
                type: "structure",
                members: {
                  deltaTimeSessionWindowConfiguration: {
                    type: "structure",
                    required: [
                      "timeoutInMinutes"
                    ],
                    members: {
                      timeoutInMinutes: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S2h: {
          type: "structure",
          members: {
            serviceManagedS3: {
              type: "structure",
              members: {}
            },
            customerManagedS3: {
              type: "structure",
              required: [
                "bucket",
                "roleArn"
              ],
              members: {
                bucket: {},
                keyPrefix: {},
                roleArn: {}
              }
            },
            iotSiteWiseMultiLayerStorage: {
              type: "structure",
              required: [
                "customerManagedS3Storage"
              ],
              members: {
                customerManagedS3Storage: {
                  type: "structure",
                  required: [
                    "bucket"
                  ],
                  members: {
                    bucket: {},
                    keyPrefix: {}
                  }
                }
              }
            }
          }
        },
        S2m: {
          type: "structure",
          members: {
            jsonConfiguration: {
              type: "structure",
              members: {}
            },
            parquetConfiguration: {
              type: "structure",
              members: {
                schemaDefinition: {
                  type: "structure",
                  members: {
                    columns: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "name",
                          "type"
                        ],
                        members: {
                          name: {},
                          type: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S2u: {
          type: "structure",
          members: {
            partitions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  attributePartition: {
                    type: "structure",
                    required: [
                      "attributeName"
                    ],
                    members: {
                      attributeName: {}
                    }
                  },
                  timestampPartition: {
                    type: "structure",
                    required: [
                      "attributeName"
                    ],
                    members: {
                      attributeName: {},
                      timestampFormat: {}
                    }
                  }
                }
              }
            }
          }
        },
        S34: {
          type: "list",
          member: {
            shape: "S35"
          }
        },
        S35: {
          type: "structure",
          members: {
            channel: {
              type: "structure",
              required: [
                "name",
                "channelName"
              ],
              members: {
                name: {},
                channelName: {},
                next: {}
              }
            },
            lambda: {
              type: "structure",
              required: [
                "name",
                "lambdaName",
                "batchSize"
              ],
              members: {
                name: {},
                lambdaName: {},
                batchSize: {
                  type: "integer"
                },
                next: {}
              }
            },
            datastore: {
              type: "structure",
              required: [
                "name",
                "datastoreName"
              ],
              members: {
                name: {},
                datastoreName: {}
              }
            },
            addAttributes: {
              type: "structure",
              required: [
                "name",
                "attributes"
              ],
              members: {
                name: {},
                attributes: {
                  type: "map",
                  key: {},
                  value: {}
                },
                next: {}
              }
            },
            removeAttributes: {
              type: "structure",
              required: [
                "name",
                "attributes"
              ],
              members: {
                name: {},
                attributes: {
                  shape: "S3g"
                },
                next: {}
              }
            },
            selectAttributes: {
              type: "structure",
              required: [
                "name",
                "attributes"
              ],
              members: {
                name: {},
                attributes: {
                  shape: "S3g"
                },
                next: {}
              }
            },
            filter: {
              type: "structure",
              required: [
                "name",
                "filter"
              ],
              members: {
                name: {},
                filter: {},
                next: {}
              }
            },
            math: {
              type: "structure",
              required: [
                "name",
                "attribute",
                "math"
              ],
              members: {
                name: {},
                attribute: {},
                math: {},
                next: {}
              }
            },
            deviceRegistryEnrich: {
              type: "structure",
              required: [
                "name",
                "attribute",
                "thingName",
                "roleArn"
              ],
              members: {
                name: {},
                attribute: {},
                thingName: {},
                roleArn: {},
                next: {}
              }
            },
            deviceShadowEnrich: {
              type: "structure",
              required: [
                "name",
                "attribute",
                "thingName",
                "roleArn"
              ],
              members: {
                name: {},
                attribute: {},
                thingName: {},
                roleArn: {},
                next: {}
              }
            }
          }
        },
        S3g: {
          type: "list",
          member: {}
        },
        S42: {
          type: "structure",
          members: {
            estimatedSizeInBytes: {
              type: "double"
            },
            estimatedOn: {
              type: "timestamp"
            }
          }
        },
        S4f: {
          type: "structure",
          required: [
            "roleArn",
            "level",
            "enabled"
          ],
          members: {
            roleArn: {},
            level: {},
            enabled: {
              type: "boolean"
            }
          }
        },
        S4l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              status: {},
              creationTime: {
                type: "timestamp"
              }
            }
          }
        },
        S4t: {
          type: "structure",
          members: {
            state: {},
            reason: {}
          }
        },
        S5z: {
          type: "list",
          member: {
            type: "blob"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotanalytics-2017-11-27.paginators.json
var require_iotanalytics_2017_11_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iotanalytics-2017-11-27.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListChannels: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListDatasetContents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListDatasets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListDatastores: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListPipelines: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iotanalytics.js
var require_iotanalytics = __commonJS({
  "node_modules/aws-sdk/clients/iotanalytics.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["iotanalytics"] = {};
    AWS3.IoTAnalytics = Service.defineService("iotanalytics", ["2017-11-27"]);
    Object.defineProperty(apiLoader.services["iotanalytics"], "2017-11-27", {
      get: function get() {
        var model = require_iotanalytics_2017_11_27_min();
        model.paginators = require_iotanalytics_2017_11_27_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.IoTAnalytics;
  }
});

// node_modules/aws-sdk/apis/iot1click-devices-2018-05-14.min.json
var require_iot1click_devices_2018_05_14_min = __commonJS({
  "node_modules/aws-sdk/apis/iot1click-devices-2018-05-14.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2018-05-14",
        endpointPrefix: "devices.iot1click",
        signingName: "iot1click",
        serviceFullName: "AWS IoT 1-Click Devices Service",
        serviceId: "IoT 1Click Devices Service",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "devices-2018-05-14",
        signatureVersion: "v4"
      },
      operations: {
        ClaimDevicesByClaimCode: {
          http: {
            method: "PUT",
            requestUri: "/claims/{claimCode}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClaimCode: {
                location: "uri",
                locationName: "claimCode"
              }
            },
            required: [
              "ClaimCode"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClaimCode: {
                locationName: "claimCode"
              },
              Total: {
                locationName: "total",
                type: "integer"
              }
            }
          }
        },
        DescribeDevice: {
          http: {
            method: "GET",
            requestUri: "/devices/{deviceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceId: {
                location: "uri",
                locationName: "deviceId"
              }
            },
            required: [
              "DeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {
              DeviceDescription: {
                shape: "S8",
                locationName: "deviceDescription"
              }
            }
          }
        },
        FinalizeDeviceClaim: {
          http: {
            method: "PUT",
            requestUri: "/devices/{deviceId}/finalize-claim",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceId: {
                location: "uri",
                locationName: "deviceId"
              },
              Tags: {
                shape: "Sc",
                locationName: "tags"
              }
            },
            required: [
              "DeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {
              State: {
                locationName: "state"
              }
            }
          }
        },
        GetDeviceMethods: {
          http: {
            method: "GET",
            requestUri: "/devices/{deviceId}/methods",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceId: {
                location: "uri",
                locationName: "deviceId"
              }
            },
            required: [
              "DeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {
              DeviceMethods: {
                locationName: "deviceMethods",
                type: "list",
                member: {
                  shape: "Si"
                }
              }
            }
          }
        },
        InitiateDeviceClaim: {
          http: {
            method: "PUT",
            requestUri: "/devices/{deviceId}/initiate-claim",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceId: {
                location: "uri",
                locationName: "deviceId"
              }
            },
            required: [
              "DeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {
              State: {
                locationName: "state"
              }
            }
          }
        },
        InvokeDeviceMethod: {
          http: {
            requestUri: "/devices/{deviceId}/methods",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceId: {
                location: "uri",
                locationName: "deviceId"
              },
              DeviceMethod: {
                shape: "Si",
                locationName: "deviceMethod"
              },
              DeviceMethodParameters: {
                locationName: "deviceMethodParameters"
              }
            },
            required: [
              "DeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {
              DeviceMethodResponse: {
                locationName: "deviceMethodResponse"
              }
            }
          }
        },
        ListDeviceEvents: {
          http: {
            method: "GET",
            requestUri: "/devices/{deviceId}/events",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceId: {
                location: "uri",
                locationName: "deviceId"
              },
              FromTimeStamp: {
                shape: "So",
                location: "querystring",
                locationName: "fromTimeStamp"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ToTimeStamp: {
                shape: "So",
                location: "querystring",
                locationName: "toTimeStamp"
              }
            },
            required: [
              "DeviceId",
              "FromTimeStamp",
              "ToTimeStamp"
            ]
          },
          output: {
            type: "structure",
            members: {
              Events: {
                locationName: "events",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Device: {
                      locationName: "device",
                      type: "structure",
                      members: {
                        Attributes: {
                          locationName: "attributes",
                          type: "structure",
                          members: {}
                        },
                        DeviceId: {
                          locationName: "deviceId"
                        },
                        Type: {
                          locationName: "type"
                        }
                      }
                    },
                    StdEvent: {
                      locationName: "stdEvent"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListDevices: {
          http: {
            method: "GET",
            requestUri: "/devices",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceType: {
                location: "querystring",
                locationName: "deviceType"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Devices: {
                locationName: "devices",
                type: "list",
                member: {
                  shape: "S8"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sc",
                locationName: "tags"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              Tags: {
                shape: "Sc",
                locationName: "tags"
              }
            },
            required: [
              "ResourceArn",
              "Tags"
            ]
          }
        },
        UnclaimDevice: {
          http: {
            method: "PUT",
            requestUri: "/devices/{deviceId}/unclaim",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceId: {
                location: "uri",
                locationName: "deviceId"
              }
            },
            required: [
              "DeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {
              State: {
                locationName: "state"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ]
          }
        },
        UpdateDeviceState: {
          http: {
            method: "PUT",
            requestUri: "/devices/{deviceId}/state",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DeviceId: {
                location: "uri",
                locationName: "deviceId"
              },
              Enabled: {
                locationName: "enabled",
                type: "boolean"
              }
            },
            required: [
              "DeviceId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S8: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            Attributes: {
              locationName: "attributes",
              type: "map",
              key: {},
              value: {}
            },
            DeviceId: {
              locationName: "deviceId"
            },
            Enabled: {
              locationName: "enabled",
              type: "boolean"
            },
            RemainingLife: {
              locationName: "remainingLife",
              type: "double"
            },
            Type: {
              locationName: "type"
            },
            Tags: {
              shape: "Sc",
              locationName: "tags"
            }
          }
        },
        Sc: {
          type: "map",
          key: {},
          value: {}
        },
        Si: {
          type: "structure",
          members: {
            DeviceType: {
              locationName: "deviceType"
            },
            MethodName: {
              locationName: "methodName"
            }
          }
        },
        So: {
          type: "timestamp",
          timestampFormat: "iso8601"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iot1clickdevicesservice.js
var require_iot1clickdevicesservice = __commonJS({
  "node_modules/aws-sdk/clients/iot1clickdevicesservice.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["iot1clickdevicesservice"] = {};
    AWS3.IoT1ClickDevicesService = Service.defineService("iot1clickdevicesservice", ["2018-05-14"]);
    Object.defineProperty(apiLoader.services["iot1clickdevicesservice"], "2018-05-14", {
      get: function get() {
        var model = require_iot1click_devices_2018_05_14_min();
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.IoT1ClickDevicesService;
  }
});

// node_modules/aws-sdk/apis/iot1click-projects-2018-05-14.min.json
var require_iot1click_projects_2018_05_14_min = __commonJS({
  "node_modules/aws-sdk/apis/iot1click-projects-2018-05-14.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-14",
        endpointPrefix: "projects.iot1click",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "AWS IoT 1-Click Projects",
        serviceFullName: "AWS IoT 1-Click Projects Service",
        serviceId: "IoT 1Click Projects",
        signatureVersion: "v4",
        signingName: "iot1click",
        uid: "iot1click-projects-2018-05-14"
      },
      operations: {
        AssociateDeviceWithPlacement: {
          http: {
            method: "PUT",
            requestUri: "/projects/{projectName}/placements/{placementName}/devices/{deviceTemplateName}"
          },
          input: {
            type: "structure",
            required: [
              "projectName",
              "placementName",
              "deviceId",
              "deviceTemplateName"
            ],
            members: {
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              placementName: {
                location: "uri",
                locationName: "placementName"
              },
              deviceId: {},
              deviceTemplateName: {
                location: "uri",
                locationName: "deviceTemplateName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreatePlacement: {
          http: {
            requestUri: "/projects/{projectName}/placements"
          },
          input: {
            type: "structure",
            required: [
              "placementName",
              "projectName"
            ],
            members: {
              placementName: {},
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              attributes: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateProject: {
          http: {
            requestUri: "/projects"
          },
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {},
              description: {},
              placementTemplate: {
                shape: "Se"
              },
              tags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePlacement: {
          http: {
            method: "DELETE",
            requestUri: "/projects/{projectName}/placements/{placementName}"
          },
          input: {
            type: "structure",
            required: [
              "placementName",
              "projectName"
            ],
            members: {
              placementName: {
                location: "uri",
                locationName: "placementName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteProject: {
          http: {
            method: "DELETE",
            requestUri: "/projects/{projectName}"
          },
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {
                location: "uri",
                locationName: "projectName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribePlacement: {
          http: {
            method: "GET",
            requestUri: "/projects/{projectName}/placements/{placementName}"
          },
          input: {
            type: "structure",
            required: [
              "placementName",
              "projectName"
            ],
            members: {
              placementName: {
                location: "uri",
                locationName: "placementName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "placement"
            ],
            members: {
              placement: {
                type: "structure",
                required: [
                  "projectName",
                  "placementName",
                  "attributes",
                  "createdDate",
                  "updatedDate"
                ],
                members: {
                  projectName: {},
                  placementName: {},
                  attributes: {
                    shape: "S8"
                  },
                  createdDate: {
                    type: "timestamp"
                  },
                  updatedDate: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeProject: {
          http: {
            method: "GET",
            requestUri: "/projects/{projectName}"
          },
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {
                location: "uri",
                locationName: "projectName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "project"
            ],
            members: {
              project: {
                type: "structure",
                required: [
                  "projectName",
                  "createdDate",
                  "updatedDate"
                ],
                members: {
                  arn: {},
                  projectName: {},
                  description: {},
                  createdDate: {
                    type: "timestamp"
                  },
                  updatedDate: {
                    type: "timestamp"
                  },
                  placementTemplate: {
                    shape: "Se"
                  },
                  tags: {
                    shape: "Sn"
                  }
                }
              }
            }
          }
        },
        DisassociateDeviceFromPlacement: {
          http: {
            method: "DELETE",
            requestUri: "/projects/{projectName}/placements/{placementName}/devices/{deviceTemplateName}"
          },
          input: {
            type: "structure",
            required: [
              "projectName",
              "placementName",
              "deviceTemplateName"
            ],
            members: {
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              placementName: {
                location: "uri",
                locationName: "placementName"
              },
              deviceTemplateName: {
                location: "uri",
                locationName: "deviceTemplateName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetDevicesInPlacement: {
          http: {
            method: "GET",
            requestUri: "/projects/{projectName}/placements/{placementName}/devices"
          },
          input: {
            type: "structure",
            required: [
              "projectName",
              "placementName"
            ],
            members: {
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              placementName: {
                location: "uri",
                locationName: "placementName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "devices"
            ],
            members: {
              devices: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        ListPlacements: {
          http: {
            method: "GET",
            requestUri: "/projects/{projectName}/placements"
          },
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "placements"
            ],
            members: {
              placements: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "projectName",
                    "placementName",
                    "createdDate",
                    "updatedDate"
                  ],
                  members: {
                    projectName: {},
                    placementName: {},
                    createdDate: {
                      type: "timestamp"
                    },
                    updatedDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListProjects: {
          http: {
            method: "GET",
            requestUri: "/projects"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "projects"
            ],
            members: {
              projects: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "projectName",
                    "createdDate",
                    "updatedDate"
                  ],
                  members: {
                    arn: {},
                    projectName: {},
                    createdDate: {
                      type: "timestamp"
                    },
                    updatedDate: {
                      type: "timestamp"
                    },
                    tags: {
                      shape: "Sn"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sn"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdatePlacement: {
          http: {
            method: "PUT",
            requestUri: "/projects/{projectName}/placements/{placementName}"
          },
          input: {
            type: "structure",
            required: [
              "placementName",
              "projectName"
            ],
            members: {
              placementName: {
                location: "uri",
                locationName: "placementName"
              },
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              attributes: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateProject: {
          http: {
            method: "PUT",
            requestUri: "/projects/{projectName}"
          },
          input: {
            type: "structure",
            required: [
              "projectName"
            ],
            members: {
              projectName: {
                location: "uri",
                locationName: "projectName"
              },
              description: {},
              placementTemplate: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S8: {
          type: "map",
          key: {},
          value: {}
        },
        Se: {
          type: "structure",
          members: {
            defaultAttributes: {
              type: "map",
              key: {},
              value: {}
            },
            deviceTemplates: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  deviceType: {},
                  callbackOverrides: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            }
          }
        },
        Sn: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iot1click-projects-2018-05-14.paginators.json
var require_iot1click_projects_2018_05_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iot1click-projects-2018-05-14.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListPlacements: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "placements"
        },
        ListProjects: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "projects"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iot1clickprojects.js
var require_iot1clickprojects = __commonJS({
  "node_modules/aws-sdk/clients/iot1clickprojects.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["iot1clickprojects"] = {};
    AWS3.IoT1ClickProjects = Service.defineService("iot1clickprojects", ["2018-05-14"]);
    Object.defineProperty(apiLoader.services["iot1clickprojects"], "2018-05-14", {
      get: function get() {
        var model = require_iot1click_projects_2018_05_14_min();
        model.paginators = require_iot1click_projects_2018_05_14_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.IoT1ClickProjects;
  }
});

// node_modules/aws-sdk/apis/pi-2018-02-27.min.json
var require_pi_2018_02_27_min = __commonJS({
  "node_modules/aws-sdk/apis/pi-2018-02-27.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-02-27",
        endpointPrefix: "pi",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "AWS PI",
        serviceFullName: "AWS Performance Insights",
        serviceId: "PI",
        signatureVersion: "v4",
        signingName: "pi",
        targetPrefix: "PerformanceInsightsv20180227",
        uid: "pi-2018-02-27"
      },
      operations: {
        DescribeDimensionKeys: {
          input: {
            type: "structure",
            required: [
              "ServiceType",
              "Identifier",
              "StartTime",
              "EndTime",
              "Metric",
              "GroupBy"
            ],
            members: {
              ServiceType: {},
              Identifier: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Metric: {},
              PeriodInSeconds: {
                type: "integer"
              },
              GroupBy: {
                shape: "S6"
              },
              PartitionBy: {
                shape: "S6"
              },
              Filter: {
                shape: "S9"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AlignedStartTime: {
                type: "timestamp"
              },
              AlignedEndTime: {
                type: "timestamp"
              },
              PartitionKeys: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Dimensions"
                  ],
                  members: {
                    Dimensions: {
                      shape: "Sf"
                    }
                  }
                }
              },
              Keys: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Dimensions: {
                      shape: "Sf"
                    },
                    Total: {
                      type: "double"
                    },
                    Partitions: {
                      type: "list",
                      member: {
                        type: "double"
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetDimensionKeyDetails: {
          input: {
            type: "structure",
            required: [
              "ServiceType",
              "Identifier",
              "Group",
              "GroupIdentifier"
            ],
            members: {
              ServiceType: {},
              Identifier: {},
              Group: {},
              GroupIdentifier: {},
              RequestedDimensions: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Dimensions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Value: {},
                    Dimension: {},
                    Status: {}
                  }
                }
              }
            }
          }
        },
        GetResourceMetrics: {
          input: {
            type: "structure",
            required: [
              "ServiceType",
              "Identifier",
              "MetricQueries",
              "StartTime",
              "EndTime"
            ],
            members: {
              ServiceType: {},
              Identifier: {},
              MetricQueries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Metric"
                  ],
                  members: {
                    Metric: {},
                    GroupBy: {
                      shape: "S6"
                    },
                    Filter: {
                      shape: "S9"
                    }
                  }
                }
              },
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              PeriodInSeconds: {
                type: "integer"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AlignedStartTime: {
                type: "timestamp"
              },
              AlignedEndTime: {
                type: "timestamp"
              },
              Identifier: {},
              MetricList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Key: {
                      type: "structure",
                      required: [
                        "Metric"
                      ],
                      members: {
                        Metric: {},
                        Dimensions: {
                          shape: "Sf"
                        }
                      }
                    },
                    DataPoints: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Timestamp",
                          "Value"
                        ],
                        members: {
                          Timestamp: {
                            type: "timestamp"
                          },
                          Value: {
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        }
      },
      shapes: {
        S6: {
          type: "structure",
          required: [
            "Group"
          ],
          members: {
            Group: {},
            Dimensions: {
              type: "list",
              member: {}
            },
            Limit: {
              type: "integer"
            }
          }
        },
        S9: {
          type: "map",
          key: {},
          value: {}
        },
        Sf: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/pi-2018-02-27.paginators.json
var require_pi_2018_02_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/pi-2018-02-27.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/pi.js
var require_pi = __commonJS({
  "node_modules/aws-sdk/clients/pi.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["pi"] = {};
    AWS3.PI = Service.defineService("pi", ["2018-02-27"]);
    Object.defineProperty(apiLoader.services["pi"], "2018-02-27", {
      get: function get() {
        var model = require_pi_2018_02_27_min();
        model.paginators = require_pi_2018_02_27_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.PI;
  }
});

// node_modules/aws-sdk/lib/services/neptune.js
var require_neptune = __commonJS({
  "node_modules/aws-sdk/lib/services/neptune.js"() {
    var AWS3 = require_core();
    var rdsutil = require_rdsutil();
    var crossRegionOperations = ["createDBCluster", "copyDBClusterSnapshot"];
    AWS3.util.update(AWS3.Neptune.prototype, {
      setupRequestListeners: function setupRequestListeners(request) {
        if (crossRegionOperations.indexOf(request.operation) !== -1 && this.config.params && this.config.params.SourceRegion && request.params && !request.params.SourceRegion) {
          request.params.SourceRegion = this.config.params.SourceRegion;
        }
        rdsutil.setupRequestListeners(this, request, crossRegionOperations);
      }
    });
  }
});

// node_modules/aws-sdk/apis/neptune-2014-10-31.min.json
var require_neptune_2014_10_31_min = __commonJS({
  "node_modules/aws-sdk/apis/neptune-2014-10-31.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-10-31",
        endpointPrefix: "rds",
        protocol: "query",
        serviceAbbreviation: "Amazon Neptune",
        serviceFullName: "Amazon Neptune",
        serviceId: "Neptune",
        signatureVersion: "v4",
        signingName: "rds",
        uid: "neptune-2014-10-31",
        xmlNamespace: "http://rds.amazonaws.com/doc/2014-10-31/"
      },
      operations: {
        AddRoleToDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "RoleArn"
            ],
            members: {
              DBClusterIdentifier: {},
              RoleArn: {},
              FeatureName: {}
            }
          }
        },
        AddSourceIdentifierToSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "AddSourceIdentifierToSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S5"
              }
            }
          }
        },
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "Tags"
            ],
            members: {
              ResourceName: {},
              Tags: {
                shape: "Sa"
              }
            }
          }
        },
        ApplyPendingMaintenanceAction: {
          input: {
            type: "structure",
            required: [
              "ResourceIdentifier",
              "ApplyAction",
              "OptInType"
            ],
            members: {
              ResourceIdentifier: {},
              ApplyAction: {},
              OptInType: {}
            }
          },
          output: {
            resultWrapper: "ApplyPendingMaintenanceActionResult",
            type: "structure",
            members: {
              ResourcePendingMaintenanceActions: {
                shape: "Se"
              }
            }
          }
        },
        CopyDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "SourceDBClusterParameterGroupIdentifier",
              "TargetDBClusterParameterGroupIdentifier",
              "TargetDBClusterParameterGroupDescription"
            ],
            members: {
              SourceDBClusterParameterGroupIdentifier: {},
              TargetDBClusterParameterGroupIdentifier: {},
              TargetDBClusterParameterGroupDescription: {},
              Tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "CopyDBClusterParameterGroupResult",
            type: "structure",
            members: {
              DBClusterParameterGroup: {
                shape: "Sk"
              }
            }
          }
        },
        CopyDBClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceDBClusterSnapshotIdentifier",
              "TargetDBClusterSnapshotIdentifier"
            ],
            members: {
              SourceDBClusterSnapshotIdentifier: {},
              TargetDBClusterSnapshotIdentifier: {},
              KmsKeyId: {},
              PreSignedUrl: {},
              CopyTags: {
                type: "boolean"
              },
              Tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "CopyDBClusterSnapshotResult",
            type: "structure",
            members: {
              DBClusterSnapshot: {
                shape: "So"
              }
            }
          }
        },
        CopyDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "SourceDBParameterGroupIdentifier",
              "TargetDBParameterGroupIdentifier",
              "TargetDBParameterGroupDescription"
            ],
            members: {
              SourceDBParameterGroupIdentifier: {},
              TargetDBParameterGroupIdentifier: {},
              TargetDBParameterGroupDescription: {},
              Tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "CopyDBParameterGroupResult",
            type: "structure",
            members: {
              DBParameterGroup: {
                shape: "St"
              }
            }
          }
        },
        CreateDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "Engine"
            ],
            members: {
              AvailabilityZones: {
                shape: "Sp"
              },
              BackupRetentionPeriod: {
                type: "integer"
              },
              CharacterSetName: {},
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              DatabaseName: {},
              DBClusterIdentifier: {},
              DBClusterParameterGroupName: {},
              VpcSecurityGroupIds: {
                shape: "Sw"
              },
              DBSubnetGroupName: {},
              Engine: {},
              EngineVersion: {},
              Port: {
                type: "integer"
              },
              MasterUsername: {},
              MasterUserPassword: {},
              OptionGroupName: {},
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              ReplicationSourceIdentifier: {},
              Tags: {
                shape: "Sa"
              },
              StorageEncrypted: {
                type: "boolean"
              },
              KmsKeyId: {},
              PreSignedUrl: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              EnableCloudwatchLogsExports: {
                shape: "Sx"
              },
              DeletionProtection: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sz"
              }
            }
          }
        },
        CreateDBClusterEndpoint: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "DBClusterEndpointIdentifier",
              "EndpointType"
            ],
            members: {
              DBClusterIdentifier: {},
              DBClusterEndpointIdentifier: {},
              EndpointType: {},
              StaticMembers: {
                shape: "S1a"
              },
              ExcludedMembers: {
                shape: "S1a"
              },
              Tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBClusterEndpointResult",
            type: "structure",
            members: {
              DBClusterEndpointIdentifier: {},
              DBClusterIdentifier: {},
              DBClusterEndpointResourceIdentifier: {},
              Endpoint: {},
              Status: {},
              EndpointType: {},
              CustomEndpointType: {},
              StaticMembers: {
                shape: "S1a"
              },
              ExcludedMembers: {
                shape: "S1a"
              },
              DBClusterEndpointArn: {}
            }
          }
        },
        CreateDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName",
              "DBParameterGroupFamily",
              "Description"
            ],
            members: {
              DBClusterParameterGroupName: {},
              DBParameterGroupFamily: {},
              Description: {},
              Tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBClusterParameterGroupResult",
            type: "structure",
            members: {
              DBClusterParameterGroup: {
                shape: "Sk"
              }
            }
          }
        },
        CreateDBClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier",
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterSnapshotIdentifier: {},
              DBClusterIdentifier: {},
              Tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBClusterSnapshotResult",
            type: "structure",
            members: {
              DBClusterSnapshot: {
                shape: "So"
              }
            }
          }
        },
        CreateDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "DBInstanceClass",
              "Engine"
            ],
            members: {
              DBName: {},
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              Engine: {},
              MasterUsername: {},
              MasterUserPassword: {},
              DBSecurityGroups: {
                shape: "S1h"
              },
              VpcSecurityGroupIds: {
                shape: "Sw"
              },
              AvailabilityZone: {},
              DBSubnetGroupName: {},
              PreferredMaintenanceWindow: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              Port: {
                type: "integer"
              },
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              CharacterSetName: {},
              PubliclyAccessible: {
                deprecated: true,
                type: "boolean"
              },
              Tags: {
                shape: "Sa"
              },
              DBClusterIdentifier: {},
              StorageType: {},
              TdeCredentialArn: {},
              TdeCredentialPassword: {},
              StorageEncrypted: {
                type: "boolean"
              },
              KmsKeyId: {},
              Domain: {},
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              MonitoringInterval: {
                type: "integer"
              },
              MonitoringRoleArn: {},
              DomainIAMRoleName: {},
              PromotionTier: {
                type: "integer"
              },
              Timezone: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              EnablePerformanceInsights: {
                type: "boolean"
              },
              PerformanceInsightsKMSKeyId: {},
              EnableCloudwatchLogsExports: {
                shape: "Sx"
              },
              DeletionProtection: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S1j"
              }
            }
          }
        },
        CreateDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "DBParameterGroupFamily",
              "Description"
            ],
            members: {
              DBParameterGroupName: {},
              DBParameterGroupFamily: {},
              Description: {},
              Tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBParameterGroupResult",
            type: "structure",
            members: {
              DBParameterGroup: {
                shape: "St"
              }
            }
          }
        },
        CreateDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "DBSubnetGroupDescription",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S26"
              },
              Tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S1p"
              }
            }
          }
        },
        CreateEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SnsTopicArn"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S7"
              },
              SourceIds: {
                shape: "S6"
              },
              Enabled: {
                type: "boolean"
              },
              Tags: {
                shape: "Sa"
              }
            }
          },
          output: {
            resultWrapper: "CreateEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S5"
              }
            }
          }
        },
        DeleteDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              SkipFinalSnapshot: {
                type: "boolean"
              },
              FinalDBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sz"
              }
            }
          }
        },
        DeleteDBClusterEndpoint: {
          input: {
            type: "structure",
            required: [
              "DBClusterEndpointIdentifier"
            ],
            members: {
              DBClusterEndpointIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBClusterEndpointResult",
            type: "structure",
            members: {
              DBClusterEndpointIdentifier: {},
              DBClusterIdentifier: {},
              DBClusterEndpointResourceIdentifier: {},
              Endpoint: {},
              Status: {},
              EndpointType: {},
              CustomEndpointType: {},
              StaticMembers: {
                shape: "S1a"
              },
              ExcludedMembers: {
                shape: "S1a"
              },
              DBClusterEndpointArn: {}
            }
          }
        },
        DeleteDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName"
            ],
            members: {
              DBClusterParameterGroupName: {}
            }
          }
        },
        DeleteDBClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier"
            ],
            members: {
              DBClusterSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBClusterSnapshotResult",
            type: "structure",
            members: {
              DBClusterSnapshot: {
                shape: "So"
              }
            }
          }
        },
        DeleteDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              SkipFinalSnapshot: {
                type: "boolean"
              },
              FinalDBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S1j"
              }
            }
          }
        },
        DeleteDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {}
            }
          }
        },
        DeleteDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName"
            ],
            members: {
              DBSubnetGroupName: {}
            }
          }
        },
        DeleteEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {}
            }
          },
          output: {
            resultWrapper: "DeleteEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S5"
              }
            }
          }
        },
        DescribeDBClusterEndpoints: {
          input: {
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              DBClusterEndpointIdentifier: {},
              Filters: {
                shape: "S2o"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterEndpointsResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusterEndpoints: {
                type: "list",
                member: {
                  locationName: "DBClusterEndpointList",
                  type: "structure",
                  members: {
                    DBClusterEndpointIdentifier: {},
                    DBClusterIdentifier: {},
                    DBClusterEndpointResourceIdentifier: {},
                    Endpoint: {},
                    Status: {},
                    EndpointType: {},
                    CustomEndpointType: {},
                    StaticMembers: {
                      shape: "S1a"
                    },
                    ExcludedMembers: {
                      shape: "S1a"
                    },
                    DBClusterEndpointArn: {}
                  }
                }
              }
            }
          }
        },
        DescribeDBClusterParameterGroups: {
          input: {
            type: "structure",
            members: {
              DBClusterParameterGroupName: {},
              Filters: {
                shape: "S2o"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusterParameterGroups: {
                type: "list",
                member: {
                  shape: "Sk",
                  locationName: "DBClusterParameterGroup"
                }
              }
            }
          }
        },
        DescribeDBClusterParameters: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName"
            ],
            members: {
              DBClusterParameterGroupName: {},
              Source: {},
              Filters: {
                shape: "S2o"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterParametersResult",
            type: "structure",
            members: {
              Parameters: {
                shape: "S2z"
              },
              Marker: {}
            }
          }
        },
        DescribeDBClusterSnapshotAttributes: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier"
            ],
            members: {
              DBClusterSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterSnapshotAttributesResult",
            type: "structure",
            members: {
              DBClusterSnapshotAttributesResult: {
                shape: "S34"
              }
            }
          }
        },
        DescribeDBClusterSnapshots: {
          input: {
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              DBClusterSnapshotIdentifier: {},
              SnapshotType: {},
              Filters: {
                shape: "S2o"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              IncludeShared: {
                type: "boolean"
              },
              IncludePublic: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterSnapshotsResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusterSnapshots: {
                type: "list",
                member: {
                  shape: "So",
                  locationName: "DBClusterSnapshot"
                }
              }
            }
          }
        },
        DescribeDBClusters: {
          input: {
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              Filters: {
                shape: "S2o"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClustersResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusters: {
                type: "list",
                member: {
                  shape: "Sz",
                  locationName: "DBCluster"
                }
              }
            }
          }
        },
        DescribeDBEngineVersions: {
          input: {
            type: "structure",
            members: {
              Engine: {},
              EngineVersion: {},
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S2o"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              DefaultOnly: {
                type: "boolean"
              },
              ListSupportedCharacterSets: {
                type: "boolean"
              },
              ListSupportedTimezones: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBEngineVersionsResult",
            type: "structure",
            members: {
              Marker: {},
              DBEngineVersions: {
                type: "list",
                member: {
                  locationName: "DBEngineVersion",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBParameterGroupFamily: {},
                    DBEngineDescription: {},
                    DBEngineVersionDescription: {},
                    DefaultCharacterSet: {
                      shape: "S3i"
                    },
                    SupportedCharacterSets: {
                      type: "list",
                      member: {
                        shape: "S3i",
                        locationName: "CharacterSet"
                      }
                    },
                    ValidUpgradeTarget: {
                      type: "list",
                      member: {
                        locationName: "UpgradeTarget",
                        type: "structure",
                        members: {
                          Engine: {},
                          EngineVersion: {},
                          Description: {},
                          AutoUpgrade: {
                            type: "boolean"
                          },
                          IsMajorVersionUpgrade: {
                            type: "boolean"
                          }
                        }
                      }
                    },
                    SupportedTimezones: {
                      type: "list",
                      member: {
                        locationName: "Timezone",
                        type: "structure",
                        members: {
                          TimezoneName: {}
                        }
                      }
                    },
                    ExportableLogTypes: {
                      shape: "Sx"
                    },
                    SupportsLogExportsToCloudwatchLogs: {
                      type: "boolean"
                    },
                    SupportsReadReplica: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeDBInstances: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              Filters: {
                shape: "S2o"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              DBInstances: {
                type: "list",
                member: {
                  shape: "S1j",
                  locationName: "DBInstance"
                }
              }
            }
          }
        },
        DescribeDBParameterGroups: {
          input: {
            type: "structure",
            members: {
              DBParameterGroupName: {},
              Filters: {
                shape: "S2o"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBParameterGroups: {
                type: "list",
                member: {
                  shape: "St",
                  locationName: "DBParameterGroup"
                }
              }
            }
          }
        },
        DescribeDBParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              Source: {},
              Filters: {
                shape: "S2o"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBParametersResult",
            type: "structure",
            members: {
              Parameters: {
                shape: "S2z"
              },
              Marker: {}
            }
          }
        },
        DescribeDBSubnetGroups: {
          input: {
            type: "structure",
            members: {
              DBSubnetGroupName: {},
              Filters: {
                shape: "S2o"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSubnetGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSubnetGroups: {
                type: "list",
                member: {
                  shape: "S1p",
                  locationName: "DBSubnetGroup"
                }
              }
            }
          }
        },
        DescribeEngineDefaultClusterParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupFamily"
            ],
            members: {
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S2o"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEngineDefaultClusterParametersResult",
            type: "structure",
            members: {
              EngineDefaults: {
                shape: "S41"
              }
            }
          }
        },
        DescribeEngineDefaultParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupFamily"
            ],
            members: {
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S2o"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEngineDefaultParametersResult",
            type: "structure",
            members: {
              EngineDefaults: {
                shape: "S41"
              }
            }
          }
        },
        DescribeEventCategories: {
          input: {
            type: "structure",
            members: {
              SourceType: {},
              Filters: {
                shape: "S2o"
              }
            }
          },
          output: {
            resultWrapper: "DescribeEventCategoriesResult",
            type: "structure",
            members: {
              EventCategoriesMapList: {
                type: "list",
                member: {
                  locationName: "EventCategoriesMap",
                  type: "structure",
                  members: {
                    SourceType: {},
                    EventCategories: {
                      shape: "S7"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeEventSubscriptions: {
          input: {
            type: "structure",
            members: {
              SubscriptionName: {},
              Filters: {
                shape: "S2o"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventSubscriptionsResult",
            type: "structure",
            members: {
              Marker: {},
              EventSubscriptionsList: {
                type: "list",
                member: {
                  shape: "S5",
                  locationName: "EventSubscription"
                }
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceIdentifier: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              EventCategories: {
                shape: "S7"
              },
              Filters: {
                shape: "S2o"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventsResult",
            type: "structure",
            members: {
              Marker: {},
              Events: {
                type: "list",
                member: {
                  locationName: "Event",
                  type: "structure",
                  members: {
                    SourceIdentifier: {},
                    SourceType: {},
                    Message: {},
                    EventCategories: {
                      shape: "S7"
                    },
                    Date: {
                      type: "timestamp"
                    },
                    SourceArn: {}
                  }
                }
              }
            }
          }
        },
        DescribeOrderableDBInstanceOptions: {
          input: {
            type: "structure",
            required: [
              "Engine"
            ],
            members: {
              Engine: {},
              EngineVersion: {},
              DBInstanceClass: {},
              LicenseModel: {},
              Vpc: {
                type: "boolean"
              },
              Filters: {
                shape: "S2o"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOrderableDBInstanceOptionsResult",
            type: "structure",
            members: {
              OrderableDBInstanceOptions: {
                type: "list",
                member: {
                  locationName: "OrderableDBInstanceOption",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBInstanceClass: {},
                    LicenseModel: {},
                    AvailabilityZones: {
                      type: "list",
                      member: {
                        shape: "S1s",
                        locationName: "AvailabilityZone"
                      }
                    },
                    MultiAZCapable: {
                      type: "boolean"
                    },
                    ReadReplicaCapable: {
                      type: "boolean"
                    },
                    Vpc: {
                      type: "boolean"
                    },
                    SupportsStorageEncryption: {
                      type: "boolean"
                    },
                    StorageType: {},
                    SupportsIops: {
                      type: "boolean"
                    },
                    SupportsEnhancedMonitoring: {
                      type: "boolean"
                    },
                    SupportsIAMDatabaseAuthentication: {
                      type: "boolean"
                    },
                    SupportsPerformanceInsights: {
                      type: "boolean"
                    },
                    MinStorageSize: {
                      type: "integer"
                    },
                    MaxStorageSize: {
                      type: "integer"
                    },
                    MinIopsPerDbInstance: {
                      type: "integer"
                    },
                    MaxIopsPerDbInstance: {
                      type: "integer"
                    },
                    MinIopsPerGib: {
                      type: "double"
                    },
                    MaxIopsPerGib: {
                      type: "double"
                    }
                  },
                  wrapper: true
                }
              },
              Marker: {}
            }
          }
        },
        DescribePendingMaintenanceActions: {
          input: {
            type: "structure",
            members: {
              ResourceIdentifier: {},
              Filters: {
                shape: "S2o"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribePendingMaintenanceActionsResult",
            type: "structure",
            members: {
              PendingMaintenanceActions: {
                type: "list",
                member: {
                  shape: "Se",
                  locationName: "ResourcePendingMaintenanceActions"
                }
              },
              Marker: {}
            }
          }
        },
        DescribeValidDBInstanceModifications: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DescribeValidDBInstanceModificationsResult",
            type: "structure",
            members: {
              ValidDBInstanceModificationsMessage: {
                type: "structure",
                members: {
                  Storage: {
                    type: "list",
                    member: {
                      locationName: "ValidStorageOptions",
                      type: "structure",
                      members: {
                        StorageType: {},
                        StorageSize: {
                          shape: "S4u"
                        },
                        ProvisionedIops: {
                          shape: "S4u"
                        },
                        IopsToStorageRatio: {
                          type: "list",
                          member: {
                            locationName: "DoubleRange",
                            type: "structure",
                            members: {
                              From: {
                                type: "double"
                              },
                              To: {
                                type: "double"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                },
                wrapper: true
              }
            }
          }
        },
        FailoverDBCluster: {
          input: {
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              TargetDBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "FailoverDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sz"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName"
            ],
            members: {
              ResourceName: {},
              Filters: {
                shape: "S2o"
              }
            }
          },
          output: {
            resultWrapper: "ListTagsForResourceResult",
            type: "structure",
            members: {
              TagList: {
                shape: "Sa"
              }
            }
          }
        },
        ModifyDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              NewDBClusterIdentifier: {},
              ApplyImmediately: {
                type: "boolean"
              },
              BackupRetentionPeriod: {
                type: "integer"
              },
              DBClusterParameterGroupName: {},
              VpcSecurityGroupIds: {
                shape: "Sw"
              },
              Port: {
                type: "integer"
              },
              MasterUserPassword: {},
              OptionGroupName: {},
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              CloudwatchLogsExportConfiguration: {
                shape: "S54"
              },
              EngineVersion: {},
              DeletionProtection: {
                type: "boolean"
              },
              CopyTagsToSnapshot: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sz"
              }
            }
          }
        },
        ModifyDBClusterEndpoint: {
          input: {
            type: "structure",
            required: [
              "DBClusterEndpointIdentifier"
            ],
            members: {
              DBClusterEndpointIdentifier: {},
              EndpointType: {},
              StaticMembers: {
                shape: "S1a"
              },
              ExcludedMembers: {
                shape: "S1a"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBClusterEndpointResult",
            type: "structure",
            members: {
              DBClusterEndpointIdentifier: {},
              DBClusterIdentifier: {},
              DBClusterEndpointResourceIdentifier: {},
              Endpoint: {},
              Status: {},
              EndpointType: {},
              CustomEndpointType: {},
              StaticMembers: {
                shape: "S1a"
              },
              ExcludedMembers: {
                shape: "S1a"
              },
              DBClusterEndpointArn: {}
            }
          }
        },
        ModifyDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName",
              "Parameters"
            ],
            members: {
              DBClusterParameterGroupName: {},
              Parameters: {
                shape: "S2z"
              }
            }
          },
          output: {
            shape: "S59",
            resultWrapper: "ModifyDBClusterParameterGroupResult"
          }
        },
        ModifyDBClusterSnapshotAttribute: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier",
              "AttributeName"
            ],
            members: {
              DBClusterSnapshotIdentifier: {},
              AttributeName: {},
              ValuesToAdd: {
                shape: "S37"
              },
              ValuesToRemove: {
                shape: "S37"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBClusterSnapshotAttributeResult",
            type: "structure",
            members: {
              DBClusterSnapshotAttributesResult: {
                shape: "S34"
              }
            }
          }
        },
        ModifyDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              AllocatedStorage: {
                type: "integer"
              },
              DBInstanceClass: {},
              DBSubnetGroupName: {},
              DBSecurityGroups: {
                shape: "S1h"
              },
              VpcSecurityGroupIds: {
                shape: "Sw"
              },
              ApplyImmediately: {
                type: "boolean"
              },
              MasterUserPassword: {},
              DBParameterGroupName: {},
              BackupRetentionPeriod: {
                type: "integer"
              },
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              MultiAZ: {
                type: "boolean"
              },
              EngineVersion: {},
              AllowMajorVersionUpgrade: {
                type: "boolean"
              },
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              LicenseModel: {},
              Iops: {
                type: "integer"
              },
              OptionGroupName: {},
              NewDBInstanceIdentifier: {},
              StorageType: {},
              TdeCredentialArn: {},
              TdeCredentialPassword: {},
              CACertificateIdentifier: {},
              Domain: {},
              CopyTagsToSnapshot: {
                type: "boolean"
              },
              MonitoringInterval: {
                type: "integer"
              },
              DBPortNumber: {
                type: "integer"
              },
              PubliclyAccessible: {
                deprecated: true,
                type: "boolean"
              },
              MonitoringRoleArn: {},
              DomainIAMRoleName: {},
              PromotionTier: {
                type: "integer"
              },
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              EnablePerformanceInsights: {
                type: "boolean"
              },
              PerformanceInsightsKMSKeyId: {},
              CloudwatchLogsExportConfiguration: {
                shape: "S54"
              },
              DeletionProtection: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S1j"
              }
            }
          }
        },
        ModifyDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName",
              "Parameters"
            ],
            members: {
              DBParameterGroupName: {},
              Parameters: {
                shape: "S2z"
              }
            }
          },
          output: {
            shape: "S5f",
            resultWrapper: "ModifyDBParameterGroupResult"
          }
        },
        ModifyDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S26"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S1p"
              }
            }
          }
        },
        ModifyEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S7"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S5"
              }
            }
          }
        },
        PromoteReadReplicaDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "PromoteReadReplicaDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sz"
              }
            }
          }
        },
        RebootDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              ForceFailover: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RebootDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S1j"
              }
            }
          }
        },
        RemoveRoleFromDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "RoleArn"
            ],
            members: {
              DBClusterIdentifier: {},
              RoleArn: {},
              FeatureName: {}
            }
          }
        },
        RemoveSourceIdentifierFromSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RemoveSourceIdentifierFromSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S5"
              }
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "TagKeys"
            ],
            members: {
              ResourceName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ResetDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName"
            ],
            members: {
              DBClusterParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              Parameters: {
                shape: "S2z"
              }
            }
          },
          output: {
            shape: "S59",
            resultWrapper: "ResetDBClusterParameterGroupResult"
          }
        },
        ResetDBParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupName"
            ],
            members: {
              DBParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              Parameters: {
                shape: "S2z"
              }
            }
          },
          output: {
            shape: "S5f",
            resultWrapper: "ResetDBParameterGroupResult"
          }
        },
        RestoreDBClusterFromSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "SnapshotIdentifier",
              "Engine"
            ],
            members: {
              AvailabilityZones: {
                shape: "Sp"
              },
              DBClusterIdentifier: {},
              SnapshotIdentifier: {},
              Engine: {},
              EngineVersion: {},
              Port: {
                type: "integer"
              },
              DBSubnetGroupName: {},
              DatabaseName: {},
              OptionGroupName: {},
              VpcSecurityGroupIds: {
                shape: "Sw"
              },
              Tags: {
                shape: "Sa"
              },
              KmsKeyId: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              EnableCloudwatchLogsExports: {
                shape: "Sx"
              },
              DBClusterParameterGroupName: {},
              DeletionProtection: {
                type: "boolean"
              },
              CopyTagsToSnapshot: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RestoreDBClusterFromSnapshotResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sz"
              }
            }
          }
        },
        RestoreDBClusterToPointInTime: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "SourceDBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              RestoreType: {},
              SourceDBClusterIdentifier: {},
              RestoreToTime: {
                type: "timestamp"
              },
              UseLatestRestorableTime: {
                type: "boolean"
              },
              Port: {
                type: "integer"
              },
              DBSubnetGroupName: {},
              OptionGroupName: {},
              VpcSecurityGroupIds: {
                shape: "Sw"
              },
              Tags: {
                shape: "Sa"
              },
              KmsKeyId: {},
              EnableIAMDatabaseAuthentication: {
                type: "boolean"
              },
              EnableCloudwatchLogsExports: {
                shape: "Sx"
              },
              DBClusterParameterGroupName: {},
              DeletionProtection: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RestoreDBClusterToPointInTimeResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sz"
              }
            }
          }
        },
        StartDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "StartDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sz"
              }
            }
          }
        },
        StopDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "StopDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sz"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            CustomerAwsId: {},
            CustSubscriptionId: {},
            SnsTopicArn: {},
            Status: {},
            SubscriptionCreationTime: {},
            SourceType: {},
            SourceIdsList: {
              shape: "S6"
            },
            EventCategoriesList: {
              shape: "S7"
            },
            Enabled: {
              type: "boolean"
            },
            EventSubscriptionArn: {}
          },
          wrapper: true
        },
        S6: {
          type: "list",
          member: {
            locationName: "SourceId"
          }
        },
        S7: {
          type: "list",
          member: {
            locationName: "EventCategory"
          }
        },
        Sa: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Se: {
          type: "structure",
          members: {
            ResourceIdentifier: {},
            PendingMaintenanceActionDetails: {
              type: "list",
              member: {
                locationName: "PendingMaintenanceAction",
                type: "structure",
                members: {
                  Action: {},
                  AutoAppliedAfterDate: {
                    type: "timestamp"
                  },
                  ForcedApplyDate: {
                    type: "timestamp"
                  },
                  OptInStatus: {},
                  CurrentApplyDate: {
                    type: "timestamp"
                  },
                  Description: {}
                }
              }
            }
          },
          wrapper: true
        },
        Sk: {
          type: "structure",
          members: {
            DBClusterParameterGroupName: {},
            DBParameterGroupFamily: {},
            Description: {},
            DBClusterParameterGroupArn: {}
          },
          wrapper: true
        },
        So: {
          type: "structure",
          members: {
            AvailabilityZones: {
              shape: "Sp"
            },
            DBClusterSnapshotIdentifier: {},
            DBClusterIdentifier: {},
            SnapshotCreateTime: {
              type: "timestamp"
            },
            Engine: {},
            AllocatedStorage: {
              type: "integer"
            },
            Status: {},
            Port: {
              type: "integer"
            },
            VpcId: {},
            ClusterCreateTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            EngineVersion: {},
            LicenseModel: {},
            SnapshotType: {},
            PercentProgress: {
              type: "integer"
            },
            StorageEncrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            DBClusterSnapshotArn: {},
            SourceDBClusterSnapshotArn: {},
            IAMDatabaseAuthenticationEnabled: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        Sp: {
          type: "list",
          member: {
            locationName: "AvailabilityZone"
          }
        },
        St: {
          type: "structure",
          members: {
            DBParameterGroupName: {},
            DBParameterGroupFamily: {},
            Description: {},
            DBParameterGroupArn: {}
          },
          wrapper: true
        },
        Sw: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupId"
          }
        },
        Sx: {
          type: "list",
          member: {}
        },
        Sz: {
          type: "structure",
          members: {
            AllocatedStorage: {
              type: "integer"
            },
            AvailabilityZones: {
              shape: "Sp"
            },
            BackupRetentionPeriod: {
              type: "integer"
            },
            CharacterSetName: {},
            DatabaseName: {},
            DBClusterIdentifier: {},
            DBClusterParameterGroup: {},
            DBSubnetGroup: {},
            Status: {},
            PercentProgress: {},
            EarliestRestorableTime: {
              type: "timestamp"
            },
            Endpoint: {},
            ReaderEndpoint: {},
            MultiAZ: {
              type: "boolean"
            },
            Engine: {},
            EngineVersion: {},
            LatestRestorableTime: {
              type: "timestamp"
            },
            Port: {
              type: "integer"
            },
            MasterUsername: {},
            DBClusterOptionGroupMemberships: {
              type: "list",
              member: {
                locationName: "DBClusterOptionGroup",
                type: "structure",
                members: {
                  DBClusterOptionGroupName: {},
                  Status: {}
                }
              }
            },
            PreferredBackupWindow: {},
            PreferredMaintenanceWindow: {},
            ReplicationSourceIdentifier: {},
            ReadReplicaIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaIdentifier"
              }
            },
            DBClusterMembers: {
              type: "list",
              member: {
                locationName: "DBClusterMember",
                type: "structure",
                members: {
                  DBInstanceIdentifier: {},
                  IsClusterWriter: {
                    type: "boolean"
                  },
                  DBClusterParameterGroupStatus: {},
                  PromotionTier: {
                    type: "integer"
                  }
                },
                wrapper: true
              }
            },
            VpcSecurityGroups: {
              shape: "S15"
            },
            HostedZoneId: {},
            StorageEncrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            DbClusterResourceId: {},
            DBClusterArn: {},
            AssociatedRoles: {
              type: "list",
              member: {
                locationName: "DBClusterRole",
                type: "structure",
                members: {
                  RoleArn: {},
                  Status: {},
                  FeatureName: {}
                }
              }
            },
            IAMDatabaseAuthenticationEnabled: {
              type: "boolean"
            },
            CloneGroupId: {},
            ClusterCreateTime: {
              type: "timestamp"
            },
            CopyTagsToSnapshot: {
              type: "boolean"
            },
            EnabledCloudwatchLogsExports: {
              shape: "Sx"
            },
            DeletionProtection: {
              type: "boolean"
            },
            CrossAccountClone: {
              type: "boolean"
            },
            AutomaticRestartTime: {
              type: "timestamp"
            }
          },
          wrapper: true
        },
        S15: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupMembership",
            type: "structure",
            members: {
              VpcSecurityGroupId: {},
              Status: {}
            }
          }
        },
        S1a: {
          type: "list",
          member: {}
        },
        S1h: {
          type: "list",
          member: {
            locationName: "DBSecurityGroupName"
          }
        },
        S1j: {
          type: "structure",
          members: {
            DBInstanceIdentifier: {},
            DBInstanceClass: {},
            Engine: {},
            DBInstanceStatus: {},
            MasterUsername: {},
            DBName: {},
            Endpoint: {
              type: "structure",
              members: {
                Address: {},
                Port: {
                  type: "integer"
                },
                HostedZoneId: {}
              }
            },
            AllocatedStorage: {
              type: "integer"
            },
            InstanceCreateTime: {
              type: "timestamp"
            },
            PreferredBackupWindow: {},
            BackupRetentionPeriod: {
              type: "integer"
            },
            DBSecurityGroups: {
              type: "list",
              member: {
                locationName: "DBSecurityGroup",
                type: "structure",
                members: {
                  DBSecurityGroupName: {},
                  Status: {}
                }
              }
            },
            VpcSecurityGroups: {
              shape: "S15"
            },
            DBParameterGroups: {
              type: "list",
              member: {
                locationName: "DBParameterGroup",
                type: "structure",
                members: {
                  DBParameterGroupName: {},
                  ParameterApplyStatus: {}
                }
              }
            },
            AvailabilityZone: {},
            DBSubnetGroup: {
              shape: "S1p"
            },
            PreferredMaintenanceWindow: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                DBInstanceClass: {},
                AllocatedStorage: {
                  type: "integer"
                },
                MasterUserPassword: {},
                Port: {
                  type: "integer"
                },
                BackupRetentionPeriod: {
                  type: "integer"
                },
                MultiAZ: {
                  type: "boolean"
                },
                EngineVersion: {},
                LicenseModel: {},
                Iops: {
                  type: "integer"
                },
                DBInstanceIdentifier: {},
                StorageType: {},
                CACertificateIdentifier: {},
                DBSubnetGroupName: {},
                PendingCloudwatchLogsExports: {
                  type: "structure",
                  members: {
                    LogTypesToEnable: {
                      shape: "Sx"
                    },
                    LogTypesToDisable: {
                      shape: "Sx"
                    }
                  }
                }
              }
            },
            LatestRestorableTime: {
              type: "timestamp"
            },
            MultiAZ: {
              type: "boolean"
            },
            EngineVersion: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            ReadReplicaSourceDBInstanceIdentifier: {},
            ReadReplicaDBInstanceIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaDBInstanceIdentifier"
              }
            },
            ReadReplicaDBClusterIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaDBClusterIdentifier"
              }
            },
            LicenseModel: {},
            Iops: {
              type: "integer"
            },
            OptionGroupMemberships: {
              type: "list",
              member: {
                locationName: "OptionGroupMembership",
                type: "structure",
                members: {
                  OptionGroupName: {},
                  Status: {}
                }
              }
            },
            CharacterSetName: {},
            SecondaryAvailabilityZone: {},
            PubliclyAccessible: {
              deprecated: true,
              type: "boolean"
            },
            StatusInfos: {
              type: "list",
              member: {
                locationName: "DBInstanceStatusInfo",
                type: "structure",
                members: {
                  StatusType: {},
                  Normal: {
                    type: "boolean"
                  },
                  Status: {},
                  Message: {}
                }
              }
            },
            StorageType: {},
            TdeCredentialArn: {},
            DbInstancePort: {
              type: "integer"
            },
            DBClusterIdentifier: {},
            StorageEncrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            DbiResourceId: {},
            CACertificateIdentifier: {},
            DomainMemberships: {
              type: "list",
              member: {
                locationName: "DomainMembership",
                type: "structure",
                members: {
                  Domain: {},
                  Status: {},
                  FQDN: {},
                  IAMRoleName: {}
                }
              }
            },
            CopyTagsToSnapshot: {
              type: "boolean"
            },
            MonitoringInterval: {
              type: "integer"
            },
            EnhancedMonitoringResourceArn: {},
            MonitoringRoleArn: {},
            PromotionTier: {
              type: "integer"
            },
            DBInstanceArn: {},
            Timezone: {},
            IAMDatabaseAuthenticationEnabled: {
              type: "boolean"
            },
            PerformanceInsightsEnabled: {
              type: "boolean"
            },
            PerformanceInsightsKMSKeyId: {},
            EnabledCloudwatchLogsExports: {
              shape: "Sx"
            },
            DeletionProtection: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S1p: {
          type: "structure",
          members: {
            DBSubnetGroupName: {},
            DBSubnetGroupDescription: {},
            VpcId: {},
            SubnetGroupStatus: {},
            Subnets: {
              type: "list",
              member: {
                locationName: "Subnet",
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {
                    shape: "S1s"
                  },
                  SubnetStatus: {}
                }
              }
            },
            DBSubnetGroupArn: {}
          },
          wrapper: true
        },
        S1s: {
          type: "structure",
          members: {
            Name: {}
          },
          wrapper: true
        },
        S26: {
          type: "list",
          member: {
            locationName: "SubnetIdentifier"
          }
        },
        S2o: {
          type: "list",
          member: {
            locationName: "Filter",
            type: "structure",
            required: [
              "Name",
              "Values"
            ],
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {
                  locationName: "Value"
                }
              }
            }
          }
        },
        S2z: {
          type: "list",
          member: {
            locationName: "Parameter",
            type: "structure",
            members: {
              ParameterName: {},
              ParameterValue: {},
              Description: {},
              Source: {},
              ApplyType: {},
              DataType: {},
              AllowedValues: {},
              IsModifiable: {
                type: "boolean"
              },
              MinimumEngineVersion: {},
              ApplyMethod: {}
            }
          }
        },
        S34: {
          type: "structure",
          members: {
            DBClusterSnapshotIdentifier: {},
            DBClusterSnapshotAttributes: {
              type: "list",
              member: {
                locationName: "DBClusterSnapshotAttribute",
                type: "structure",
                members: {
                  AttributeName: {},
                  AttributeValues: {
                    shape: "S37"
                  }
                }
              }
            }
          },
          wrapper: true
        },
        S37: {
          type: "list",
          member: {
            locationName: "AttributeValue"
          }
        },
        S3i: {
          type: "structure",
          members: {
            CharacterSetName: {},
            CharacterSetDescription: {}
          }
        },
        S41: {
          type: "structure",
          members: {
            DBParameterGroupFamily: {},
            Marker: {},
            Parameters: {
              shape: "S2z"
            }
          },
          wrapper: true
        },
        S4u: {
          type: "list",
          member: {
            locationName: "Range",
            type: "structure",
            members: {
              From: {
                type: "integer"
              },
              To: {
                type: "integer"
              },
              Step: {
                type: "integer"
              }
            }
          }
        },
        S54: {
          type: "structure",
          members: {
            EnableLogTypes: {
              shape: "Sx"
            },
            DisableLogTypes: {
              shape: "Sx"
            }
          }
        },
        S59: {
          type: "structure",
          members: {
            DBClusterParameterGroupName: {}
          }
        },
        S5f: {
          type: "structure",
          members: {
            DBParameterGroupName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/neptune-2014-10-31.paginators.json
var require_neptune_2014_10_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/neptune-2014-10-31.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeDBClusterEndpoints: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusterEndpoints"
        },
        DescribeDBClusterParameterGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusterParameterGroups"
        },
        DescribeDBClusterParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Parameters"
        },
        DescribeDBClusterSnapshots: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusterSnapshots"
        },
        DescribeDBClusters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusters"
        },
        DescribeDBEngineVersions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBEngineVersions"
        },
        DescribeDBInstances: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBInstances"
        },
        DescribeDBParameterGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBParameterGroups"
        },
        DescribeDBParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Parameters"
        },
        DescribeDBSubnetGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSubnetGroups"
        },
        DescribeEngineDefaultParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "EngineDefaults.Marker",
          result_key: "EngineDefaults.Parameters"
        },
        DescribeEventSubscriptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "EventSubscriptionsList"
        },
        DescribeEvents: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Events"
        },
        DescribeOrderableDBInstanceOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OrderableDBInstanceOptions"
        },
        DescribePendingMaintenanceActions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "PendingMaintenanceActions"
        },
        ListTagsForResource: {
          result_key: "TagList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/neptune-2014-10-31.waiters2.json
var require_neptune_2014_10_31_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/neptune-2014-10-31.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DBInstanceAvailable: {
          delay: 30,
          operation: "DescribeDBInstances",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "deleting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "failed",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "incompatible-restore",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "incompatible-parameters",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            }
          ]
        },
        DBInstanceDeleted: {
          delay: 30,
          operation: "DescribeDBInstances",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "deleted",
              matcher: "pathAll",
              state: "success",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "DBInstanceNotFound",
              matcher: "error",
              state: "success"
            },
            {
              expected: "creating",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "modifying",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "rebooting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "resetting-master-credentials",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/neptune.js
var require_neptune2 = __commonJS({
  "node_modules/aws-sdk/clients/neptune.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["neptune"] = {};
    AWS3.Neptune = Service.defineService("neptune", ["2014-10-31"]);
    require_neptune();
    Object.defineProperty(apiLoader.services["neptune"], "2014-10-31", {
      get: function get() {
        var model = require_neptune_2014_10_31_min();
        model.paginators = require_neptune_2014_10_31_paginators().pagination;
        model.waiters = require_neptune_2014_10_31_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Neptune;
  }
});

// node_modules/aws-sdk/apis/mediatailor-2018-04-23.min.json
var require_mediatailor_2018_04_23_min = __commonJS({
  "node_modules/aws-sdk/apis/mediatailor-2018-04-23.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2018-04-23",
        endpointPrefix: "api.mediatailor",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "MediaTailor",
        serviceFullName: "AWS MediaTailor",
        serviceId: "MediaTailor",
        signatureVersion: "v4",
        signingName: "mediatailor",
        uid: "mediatailor-2018-04-23"
      },
      operations: {
        ConfigureLogsForPlaybackConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/configureLogs/playbackConfiguration",
            responseCode: 200
          },
          input: {
            members: {
              PercentEnabled: {
                type: "integer"
              },
              PlaybackConfigurationName: {}
            },
            required: [
              "PercentEnabled",
              "PlaybackConfigurationName"
            ],
            type: "structure"
          },
          output: {
            members: {
              PercentEnabled: {
                type: "integer"
              },
              PlaybackConfigurationName: {}
            },
            type: "structure"
          }
        },
        CreateChannel: {
          http: {
            requestUri: "/channel/{channelName}",
            responseCode: 200
          },
          input: {
            members: {
              ChannelName: {
                location: "uri",
                locationName: "channelName"
              },
              FillerSlate: {
                shape: "S6"
              },
              Outputs: {
                shape: "S7"
              },
              PlaybackMode: {},
              Tags: {
                locationName: "tags",
                shape: "Sc"
              }
            },
            required: [
              "ChannelName",
              "Outputs",
              "PlaybackMode"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {},
              ChannelName: {},
              ChannelState: {},
              CreationTime: {
                shape: "Sf"
              },
              FillerSlate: {
                shape: "S6"
              },
              LastModifiedTime: {
                shape: "Sf"
              },
              Outputs: {
                shape: "Sg"
              },
              PlaybackMode: {},
              Tags: {
                locationName: "tags",
                shape: "Sc"
              }
            },
            type: "structure"
          }
        },
        CreatePrefetchSchedule: {
          http: {
            requestUri: "/prefetchSchedule/{PlaybackConfigurationName}/{Name}",
            responseCode: 200
          },
          input: {
            members: {
              Consumption: {
                shape: "Sj"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              },
              PlaybackConfigurationName: {
                location: "uri",
                locationName: "PlaybackConfigurationName"
              },
              Retrieval: {
                shape: "Sn"
              },
              StreamId: {}
            },
            required: [
              "Name",
              "PlaybackConfigurationName",
              "Consumption",
              "Retrieval"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {},
              Consumption: {
                shape: "Sj"
              },
              Name: {},
              PlaybackConfigurationName: {},
              Retrieval: {
                shape: "Sn"
              },
              StreamId: {}
            },
            type: "structure"
          }
        },
        CreateProgram: {
          http: {
            requestUri: "/channel/{channelName}/program/{programName}",
            responseCode: 200
          },
          input: {
            members: {
              AdBreaks: {
                shape: "Sq"
              },
              ChannelName: {
                location: "uri",
                locationName: "channelName"
              },
              ProgramName: {
                location: "uri",
                locationName: "programName"
              },
              ScheduleConfiguration: {
                members: {
                  Transition: {
                    members: {
                      RelativePosition: {},
                      RelativeProgram: {},
                      ScheduledStartTimeMillis: {
                        type: "long"
                      },
                      Type: {}
                    },
                    required: [
                      "Type",
                      "RelativePosition"
                    ],
                    type: "structure"
                  }
                },
                required: [
                  "Transition"
                ],
                type: "structure"
              },
              SourceLocationName: {},
              VodSourceName: {}
            },
            required: [
              "ChannelName",
              "ProgramName",
              "VodSourceName",
              "ScheduleConfiguration",
              "SourceLocationName"
            ],
            type: "structure"
          },
          output: {
            members: {
              AdBreaks: {
                shape: "Sq"
              },
              Arn: {},
              ChannelName: {},
              CreationTime: {
                shape: "Sf"
              },
              ProgramName: {},
              ScheduledStartTime: {
                shape: "Sf"
              },
              SourceLocationName: {},
              VodSourceName: {}
            },
            type: "structure"
          }
        },
        CreateSourceLocation: {
          http: {
            requestUri: "/sourceLocation/{sourceLocationName}",
            responseCode: 200
          },
          input: {
            members: {
              AccessConfiguration: {
                shape: "S10"
              },
              DefaultSegmentDeliveryConfiguration: {
                shape: "S13"
              },
              HttpConfiguration: {
                shape: "S14"
              },
              SourceLocationName: {
                location: "uri",
                locationName: "sourceLocationName"
              },
              Tags: {
                locationName: "tags",
                shape: "Sc"
              }
            },
            required: [
              "SourceLocationName",
              "HttpConfiguration"
            ],
            type: "structure"
          },
          output: {
            members: {
              AccessConfiguration: {
                shape: "S10"
              },
              Arn: {},
              CreationTime: {
                shape: "Sf"
              },
              DefaultSegmentDeliveryConfiguration: {
                shape: "S13"
              },
              HttpConfiguration: {
                shape: "S14"
              },
              LastModifiedTime: {
                shape: "Sf"
              },
              SourceLocationName: {},
              Tags: {
                locationName: "tags",
                shape: "Sc"
              }
            },
            type: "structure"
          }
        },
        CreateVodSource: {
          http: {
            requestUri: "/sourceLocation/{sourceLocationName}/vodSource/{vodSourceName}",
            responseCode: 200
          },
          input: {
            members: {
              HttpPackageConfigurations: {
                shape: "S17"
              },
              SourceLocationName: {
                location: "uri",
                locationName: "sourceLocationName"
              },
              Tags: {
                locationName: "tags",
                shape: "Sc"
              },
              VodSourceName: {
                location: "uri",
                locationName: "vodSourceName"
              }
            },
            required: [
              "SourceLocationName",
              "VodSourceName",
              "HttpPackageConfigurations"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {},
              CreationTime: {
                shape: "Sf"
              },
              HttpPackageConfigurations: {
                shape: "S17"
              },
              LastModifiedTime: {
                shape: "Sf"
              },
              SourceLocationName: {},
              Tags: {
                locationName: "tags",
                shape: "Sc"
              },
              VodSourceName: {}
            },
            type: "structure"
          }
        },
        DeleteChannel: {
          http: {
            method: "DELETE",
            requestUri: "/channel/{channelName}",
            responseCode: 200
          },
          input: {
            members: {
              ChannelName: {
                location: "uri",
                locationName: "channelName"
              }
            },
            required: [
              "ChannelName"
            ],
            type: "structure"
          },
          output: {
            members: {},
            type: "structure"
          }
        },
        DeleteChannelPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/channel/{channelName}/policy",
            responseCode: 200
          },
          input: {
            members: {
              ChannelName: {
                location: "uri",
                locationName: "channelName"
              }
            },
            required: [
              "ChannelName"
            ],
            type: "structure"
          },
          output: {
            members: {},
            type: "structure"
          }
        },
        DeletePlaybackConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/playbackConfiguration/{Name}",
            responseCode: 204
          },
          input: {
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            },
            required: [
              "Name"
            ],
            type: "structure"
          },
          output: {
            members: {},
            type: "structure"
          }
        },
        DeletePrefetchSchedule: {
          http: {
            method: "DELETE",
            requestUri: "/prefetchSchedule/{PlaybackConfigurationName}/{Name}",
            responseCode: 204
          },
          input: {
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              PlaybackConfigurationName: {
                location: "uri",
                locationName: "PlaybackConfigurationName"
              }
            },
            required: [
              "Name",
              "PlaybackConfigurationName"
            ],
            type: "structure"
          },
          output: {
            members: {},
            type: "structure"
          }
        },
        DeleteProgram: {
          http: {
            method: "DELETE",
            requestUri: "/channel/{channelName}/program/{programName}",
            responseCode: 200
          },
          input: {
            members: {
              ChannelName: {
                location: "uri",
                locationName: "channelName"
              },
              ProgramName: {
                location: "uri",
                locationName: "programName"
              }
            },
            required: [
              "ChannelName",
              "ProgramName"
            ],
            type: "structure"
          },
          output: {
            members: {},
            type: "structure"
          }
        },
        DeleteSourceLocation: {
          http: {
            method: "DELETE",
            requestUri: "/sourceLocation/{sourceLocationName}",
            responseCode: 200
          },
          input: {
            members: {
              SourceLocationName: {
                location: "uri",
                locationName: "sourceLocationName"
              }
            },
            required: [
              "SourceLocationName"
            ],
            type: "structure"
          },
          output: {
            members: {},
            type: "structure"
          }
        },
        DeleteVodSource: {
          http: {
            method: "DELETE",
            requestUri: "/sourceLocation/{sourceLocationName}/vodSource/{vodSourceName}",
            responseCode: 200
          },
          input: {
            members: {
              SourceLocationName: {
                location: "uri",
                locationName: "sourceLocationName"
              },
              VodSourceName: {
                location: "uri",
                locationName: "vodSourceName"
              }
            },
            required: [
              "SourceLocationName",
              "VodSourceName"
            ],
            type: "structure"
          },
          output: {
            members: {},
            type: "structure"
          }
        },
        DescribeChannel: {
          http: {
            method: "GET",
            requestUri: "/channel/{channelName}",
            responseCode: 200
          },
          input: {
            members: {
              ChannelName: {
                location: "uri",
                locationName: "channelName"
              }
            },
            required: [
              "ChannelName"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {},
              ChannelName: {},
              ChannelState: {},
              CreationTime: {
                shape: "Sf"
              },
              FillerSlate: {
                shape: "S6"
              },
              LastModifiedTime: {
                shape: "Sf"
              },
              Outputs: {
                shape: "Sg"
              },
              PlaybackMode: {},
              Tags: {
                locationName: "tags",
                shape: "Sc"
              }
            },
            type: "structure"
          }
        },
        DescribeProgram: {
          http: {
            method: "GET",
            requestUri: "/channel/{channelName}/program/{programName}",
            responseCode: 200
          },
          input: {
            members: {
              ChannelName: {
                location: "uri",
                locationName: "channelName"
              },
              ProgramName: {
                location: "uri",
                locationName: "programName"
              }
            },
            required: [
              "ChannelName",
              "ProgramName"
            ],
            type: "structure"
          },
          output: {
            members: {
              AdBreaks: {
                shape: "Sq"
              },
              Arn: {},
              ChannelName: {},
              CreationTime: {
                shape: "Sf"
              },
              ProgramName: {},
              ScheduledStartTime: {
                shape: "Sf"
              },
              SourceLocationName: {},
              VodSourceName: {}
            },
            type: "structure"
          }
        },
        DescribeSourceLocation: {
          http: {
            method: "GET",
            requestUri: "/sourceLocation/{sourceLocationName}",
            responseCode: 200
          },
          input: {
            members: {
              SourceLocationName: {
                location: "uri",
                locationName: "sourceLocationName"
              }
            },
            required: [
              "SourceLocationName"
            ],
            type: "structure"
          },
          output: {
            members: {
              AccessConfiguration: {
                shape: "S10"
              },
              Arn: {},
              CreationTime: {
                shape: "Sf"
              },
              DefaultSegmentDeliveryConfiguration: {
                shape: "S13"
              },
              HttpConfiguration: {
                shape: "S14"
              },
              LastModifiedTime: {
                shape: "Sf"
              },
              SourceLocationName: {},
              Tags: {
                locationName: "tags",
                shape: "Sc"
              }
            },
            type: "structure"
          }
        },
        DescribeVodSource: {
          http: {
            method: "GET",
            requestUri: "/sourceLocation/{sourceLocationName}/vodSource/{vodSourceName}",
            responseCode: 200
          },
          input: {
            members: {
              SourceLocationName: {
                location: "uri",
                locationName: "sourceLocationName"
              },
              VodSourceName: {
                location: "uri",
                locationName: "vodSourceName"
              }
            },
            required: [
              "SourceLocationName",
              "VodSourceName"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {},
              CreationTime: {
                shape: "Sf"
              },
              HttpPackageConfigurations: {
                shape: "S17"
              },
              LastModifiedTime: {
                shape: "Sf"
              },
              SourceLocationName: {},
              Tags: {
                locationName: "tags",
                shape: "Sc"
              },
              VodSourceName: {}
            },
            type: "structure"
          }
        },
        GetChannelPolicy: {
          http: {
            method: "GET",
            requestUri: "/channel/{channelName}/policy",
            responseCode: 200
          },
          input: {
            members: {
              ChannelName: {
                location: "uri",
                locationName: "channelName"
              }
            },
            required: [
              "ChannelName"
            ],
            type: "structure"
          },
          output: {
            members: {
              Policy: {}
            },
            type: "structure"
          }
        },
        GetChannelSchedule: {
          http: {
            method: "GET",
            requestUri: "/channel/{channelName}/schedule",
            responseCode: 200
          },
          input: {
            members: {
              ChannelName: {
                location: "uri",
                locationName: "channelName"
              },
              DurationMinutes: {
                location: "querystring",
                locationName: "durationMinutes"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ChannelName"
            ],
            type: "structure"
          },
          output: {
            members: {
              Items: {
                member: {
                  members: {
                    ApproximateDurationSeconds: {
                      type: "long"
                    },
                    ApproximateStartTime: {
                      shape: "Sf"
                    },
                    Arn: {},
                    ChannelName: {},
                    ProgramName: {},
                    ScheduleAdBreaks: {
                      member: {
                        members: {
                          ApproximateDurationSeconds: {
                            type: "long"
                          },
                          ApproximateStartTime: {
                            shape: "Sf"
                          },
                          SourceLocationName: {},
                          VodSourceName: {}
                        },
                        type: "structure"
                      },
                      type: "list"
                    },
                    ScheduleEntryType: {},
                    SourceLocationName: {},
                    VodSourceName: {}
                  },
                  required: [
                    "VodSourceName",
                    "ChannelName",
                    "SourceLocationName",
                    "Arn",
                    "ProgramName"
                  ],
                  type: "structure"
                },
                type: "list"
              },
              NextToken: {}
            },
            type: "structure"
          }
        },
        GetPlaybackConfiguration: {
          http: {
            method: "GET",
            requestUri: "/playbackConfiguration/{Name}",
            responseCode: 200
          },
          input: {
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            },
            required: [
              "Name"
            ],
            type: "structure"
          },
          output: {
            members: {
              AdDecisionServerUrl: {},
              AvailSuppression: {
                shape: "S29"
              },
              Bumper: {
                shape: "S2b"
              },
              CdnConfiguration: {
                shape: "S2c"
              },
              ConfigurationAliases: {
                shape: "S2d"
              },
              DashConfiguration: {
                shape: "S2e"
              },
              HlsConfiguration: {
                shape: "S2g"
              },
              LivePreRollConfiguration: {
                shape: "S2h"
              },
              LogConfiguration: {
                shape: "S2i"
              },
              ManifestProcessingRules: {
                shape: "S2j"
              },
              Name: {},
              PersonalizationThresholdSeconds: {
                type: "integer"
              },
              PlaybackConfigurationArn: {},
              PlaybackEndpointPrefix: {},
              SessionInitializationEndpointPrefix: {},
              SlateAdUrl: {},
              Tags: {
                locationName: "tags",
                shape: "Sc"
              },
              TranscodeProfileName: {},
              VideoContentSourceUrl: {}
            },
            type: "structure"
          }
        },
        GetPrefetchSchedule: {
          http: {
            method: "GET",
            requestUri: "/prefetchSchedule/{PlaybackConfigurationName}/{Name}",
            responseCode: 200
          },
          input: {
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              PlaybackConfigurationName: {
                location: "uri",
                locationName: "PlaybackConfigurationName"
              }
            },
            required: [
              "Name",
              "PlaybackConfigurationName"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {},
              Consumption: {
                shape: "Sj"
              },
              Name: {},
              PlaybackConfigurationName: {},
              Retrieval: {
                shape: "Sn"
              },
              StreamId: {}
            },
            type: "structure"
          }
        },
        ListAlerts: {
          http: {
            method: "GET",
            requestUri: "/alerts",
            responseCode: 200
          },
          input: {
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ResourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            },
            required: [
              "ResourceArn"
            ],
            type: "structure"
          },
          output: {
            members: {
              Items: {
                member: {
                  members: {
                    AlertCode: {},
                    AlertMessage: {},
                    LastModifiedTime: {
                      shape: "Sf"
                    },
                    RelatedResourceArns: {
                      shape: "S2t"
                    },
                    ResourceArn: {}
                  },
                  required: [
                    "ResourceArn",
                    "AlertCode",
                    "LastModifiedTime",
                    "RelatedResourceArns",
                    "AlertMessage"
                  ],
                  type: "structure"
                },
                type: "list"
              },
              NextToken: {}
            },
            type: "structure"
          }
        },
        ListChannels: {
          http: {
            method: "GET",
            requestUri: "/channels",
            responseCode: 200
          },
          input: {
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            type: "structure"
          },
          output: {
            members: {
              Items: {
                member: {
                  members: {
                    Arn: {},
                    ChannelName: {},
                    ChannelState: {},
                    CreationTime: {
                      shape: "Sf"
                    },
                    FillerSlate: {
                      shape: "S6"
                    },
                    LastModifiedTime: {
                      shape: "Sf"
                    },
                    Outputs: {
                      shape: "Sg"
                    },
                    PlaybackMode: {},
                    Tags: {
                      locationName: "tags",
                      shape: "Sc"
                    }
                  },
                  required: [
                    "ChannelState",
                    "ChannelName",
                    "Outputs",
                    "Arn",
                    "PlaybackMode"
                  ],
                  type: "structure"
                },
                type: "list"
              },
              NextToken: {}
            },
            type: "structure"
          }
        },
        ListPlaybackConfigurations: {
          http: {
            method: "GET",
            requestUri: "/playbackConfigurations",
            responseCode: 200
          },
          input: {
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            type: "structure"
          },
          output: {
            members: {
              Items: {
                member: {
                  members: {
                    AdDecisionServerUrl: {},
                    AvailSuppression: {
                      shape: "S29"
                    },
                    Bumper: {
                      shape: "S2b"
                    },
                    CdnConfiguration: {
                      shape: "S2c"
                    },
                    ConfigurationAliases: {
                      shape: "S2d"
                    },
                    DashConfiguration: {
                      shape: "S2e"
                    },
                    HlsConfiguration: {
                      shape: "S2g"
                    },
                    LivePreRollConfiguration: {
                      shape: "S2h"
                    },
                    LogConfiguration: {
                      shape: "S2i"
                    },
                    ManifestProcessingRules: {
                      shape: "S2j"
                    },
                    Name: {},
                    PersonalizationThresholdSeconds: {
                      type: "integer"
                    },
                    PlaybackConfigurationArn: {},
                    PlaybackEndpointPrefix: {},
                    SessionInitializationEndpointPrefix: {},
                    SlateAdUrl: {},
                    Tags: {
                      locationName: "tags",
                      shape: "Sc"
                    },
                    TranscodeProfileName: {},
                    VideoContentSourceUrl: {}
                  },
                  type: "structure"
                },
                type: "list"
              },
              NextToken: {}
            },
            type: "structure"
          }
        },
        ListPrefetchSchedules: {
          http: {
            requestUri: "/prefetchSchedule/{PlaybackConfigurationName}",
            responseCode: 200
          },
          input: {
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              PlaybackConfigurationName: {
                location: "uri",
                locationName: "PlaybackConfigurationName"
              },
              StreamId: {}
            },
            required: [
              "PlaybackConfigurationName"
            ],
            type: "structure"
          },
          output: {
            members: {
              Items: {
                member: {
                  members: {
                    Arn: {},
                    Consumption: {
                      shape: "Sj"
                    },
                    Name: {},
                    PlaybackConfigurationName: {},
                    Retrieval: {
                      shape: "Sn"
                    },
                    StreamId: {}
                  },
                  required: [
                    "Retrieval",
                    "Consumption",
                    "Arn",
                    "PlaybackConfigurationName",
                    "Name"
                  ],
                  type: "structure"
                },
                type: "list"
              },
              NextToken: {}
            },
            type: "structure"
          }
        },
        ListSourceLocations: {
          http: {
            method: "GET",
            requestUri: "/sourceLocations",
            responseCode: 200
          },
          input: {
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            type: "structure"
          },
          output: {
            members: {
              Items: {
                member: {
                  members: {
                    AccessConfiguration: {
                      shape: "S10"
                    },
                    Arn: {},
                    CreationTime: {
                      shape: "Sf"
                    },
                    DefaultSegmentDeliveryConfiguration: {
                      shape: "S13"
                    },
                    HttpConfiguration: {
                      shape: "S14"
                    },
                    LastModifiedTime: {
                      shape: "Sf"
                    },
                    SourceLocationName: {},
                    Tags: {
                      locationName: "tags",
                      shape: "Sc"
                    }
                  },
                  required: [
                    "SourceLocationName",
                    "HttpConfiguration",
                    "Arn"
                  ],
                  type: "structure"
                },
                type: "list"
              },
              NextToken: {}
            },
            type: "structure"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            },
            required: [
              "ResourceArn"
            ],
            type: "structure"
          },
          output: {
            members: {
              Tags: {
                locationName: "tags",
                shape: "Sc"
              }
            },
            type: "structure"
          }
        },
        ListVodSources: {
          http: {
            method: "GET",
            requestUri: "/sourceLocation/{sourceLocationName}/vodSources",
            responseCode: 200
          },
          input: {
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              SourceLocationName: {
                location: "uri",
                locationName: "sourceLocationName"
              }
            },
            required: [
              "SourceLocationName"
            ],
            type: "structure"
          },
          output: {
            members: {
              Items: {
                member: {
                  members: {
                    Arn: {},
                    CreationTime: {
                      shape: "Sf"
                    },
                    HttpPackageConfigurations: {
                      shape: "S17"
                    },
                    LastModifiedTime: {
                      shape: "Sf"
                    },
                    SourceLocationName: {},
                    Tags: {
                      locationName: "tags",
                      shape: "Sc"
                    },
                    VodSourceName: {}
                  },
                  required: [
                    "VodSourceName",
                    "SourceLocationName",
                    "HttpPackageConfigurations",
                    "Arn"
                  ],
                  type: "structure"
                },
                type: "list"
              },
              NextToken: {}
            },
            type: "structure"
          }
        },
        PutChannelPolicy: {
          http: {
            method: "PUT",
            requestUri: "/channel/{channelName}/policy",
            responseCode: 200
          },
          input: {
            members: {
              ChannelName: {
                location: "uri",
                locationName: "channelName"
              },
              Policy: {}
            },
            required: [
              "ChannelName",
              "Policy"
            ],
            type: "structure"
          },
          output: {
            members: {},
            type: "structure"
          }
        },
        PutPlaybackConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/playbackConfiguration",
            responseCode: 200
          },
          input: {
            members: {
              AdDecisionServerUrl: {},
              AvailSuppression: {
                shape: "S29"
              },
              Bumper: {
                shape: "S2b"
              },
              CdnConfiguration: {
                shape: "S2c"
              },
              ConfigurationAliases: {
                key: {},
                type: "map",
                value: {
                  shape: "Sc"
                }
              },
              DashConfiguration: {
                members: {
                  MpdLocation: {},
                  OriginManifestType: {}
                },
                type: "structure"
              },
              LivePreRollConfiguration: {
                shape: "S2h"
              },
              ManifestProcessingRules: {
                shape: "S2j"
              },
              Name: {},
              PersonalizationThresholdSeconds: {
                type: "integer"
              },
              SlateAdUrl: {},
              Tags: {
                locationName: "tags",
                shape: "Sc"
              },
              TranscodeProfileName: {},
              VideoContentSourceUrl: {}
            },
            type: "structure"
          },
          output: {
            members: {
              AdDecisionServerUrl: {},
              AvailSuppression: {
                shape: "S29"
              },
              Bumper: {
                shape: "S2b"
              },
              CdnConfiguration: {
                shape: "S2c"
              },
              ConfigurationAliases: {
                shape: "S2d"
              },
              DashConfiguration: {
                shape: "S2e"
              },
              HlsConfiguration: {
                shape: "S2g"
              },
              LivePreRollConfiguration: {
                shape: "S2h"
              },
              LogConfiguration: {
                shape: "S2i"
              },
              ManifestProcessingRules: {
                shape: "S2j"
              },
              Name: {},
              PersonalizationThresholdSeconds: {
                type: "integer"
              },
              PlaybackConfigurationArn: {},
              PlaybackEndpointPrefix: {},
              SessionInitializationEndpointPrefix: {},
              SlateAdUrl: {},
              Tags: {
                locationName: "tags",
                shape: "Sc"
              },
              TranscodeProfileName: {},
              VideoContentSourceUrl: {}
            },
            type: "structure"
          }
        },
        StartChannel: {
          http: {
            method: "PUT",
            requestUri: "/channel/{channelName}/start",
            responseCode: 200
          },
          input: {
            members: {
              ChannelName: {
                location: "uri",
                locationName: "channelName"
              }
            },
            required: [
              "ChannelName"
            ],
            type: "structure"
          },
          output: {
            members: {},
            type: "structure"
          }
        },
        StopChannel: {
          http: {
            method: "PUT",
            requestUri: "/channel/{channelName}/stop",
            responseCode: 200
          },
          input: {
            members: {
              ChannelName: {
                location: "uri",
                locationName: "channelName"
              }
            },
            required: [
              "ChannelName"
            ],
            type: "structure"
          },
          output: {
            members: {},
            type: "structure"
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                locationName: "tags",
                shape: "Sc"
              }
            },
            required: [
              "ResourceArn",
              "Tags"
            ],
            type: "structure"
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                shape: "S2t"
              }
            },
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            type: "structure"
          }
        },
        UpdateChannel: {
          http: {
            method: "PUT",
            requestUri: "/channel/{channelName}",
            responseCode: 200
          },
          input: {
            members: {
              ChannelName: {
                location: "uri",
                locationName: "channelName"
              },
              Outputs: {
                shape: "S7"
              }
            },
            required: [
              "ChannelName",
              "Outputs"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {},
              ChannelName: {},
              ChannelState: {},
              CreationTime: {
                shape: "Sf"
              },
              FillerSlate: {
                shape: "S6"
              },
              LastModifiedTime: {
                shape: "Sf"
              },
              Outputs: {
                shape: "Sg"
              },
              PlaybackMode: {},
              Tags: {
                locationName: "tags",
                shape: "Sc"
              }
            },
            type: "structure"
          }
        },
        UpdateSourceLocation: {
          http: {
            method: "PUT",
            requestUri: "/sourceLocation/{sourceLocationName}",
            responseCode: 200
          },
          input: {
            members: {
              AccessConfiguration: {
                shape: "S10"
              },
              DefaultSegmentDeliveryConfiguration: {
                shape: "S13"
              },
              HttpConfiguration: {
                shape: "S14"
              },
              SourceLocationName: {
                location: "uri",
                locationName: "sourceLocationName"
              }
            },
            required: [
              "SourceLocationName",
              "HttpConfiguration"
            ],
            type: "structure"
          },
          output: {
            members: {
              AccessConfiguration: {
                shape: "S10"
              },
              Arn: {},
              CreationTime: {
                shape: "Sf"
              },
              DefaultSegmentDeliveryConfiguration: {
                shape: "S13"
              },
              HttpConfiguration: {
                shape: "S14"
              },
              LastModifiedTime: {
                shape: "Sf"
              },
              SourceLocationName: {},
              Tags: {
                locationName: "tags",
                shape: "Sc"
              }
            },
            type: "structure"
          }
        },
        UpdateVodSource: {
          http: {
            method: "PUT",
            requestUri: "/sourceLocation/{sourceLocationName}/vodSource/{vodSourceName}",
            responseCode: 200
          },
          input: {
            members: {
              HttpPackageConfigurations: {
                shape: "S17"
              },
              SourceLocationName: {
                location: "uri",
                locationName: "sourceLocationName"
              },
              VodSourceName: {
                location: "uri",
                locationName: "vodSourceName"
              }
            },
            required: [
              "SourceLocationName",
              "VodSourceName",
              "HttpPackageConfigurations"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {},
              CreationTime: {
                shape: "Sf"
              },
              HttpPackageConfigurations: {
                shape: "S17"
              },
              LastModifiedTime: {
                shape: "Sf"
              },
              SourceLocationName: {},
              Tags: {
                locationName: "tags",
                shape: "Sc"
              },
              VodSourceName: {}
            },
            type: "structure"
          }
        }
      },
      shapes: {
        S6: {
          members: {
            SourceLocationName: {},
            VodSourceName: {}
          },
          type: "structure"
        },
        S7: {
          member: {
            members: {
              DashPlaylistSettings: {
                shape: "S9"
              },
              HlsPlaylistSettings: {
                shape: "Sa"
              },
              ManifestName: {},
              SourceGroup: {}
            },
            required: [
              "ManifestName",
              "SourceGroup"
            ],
            type: "structure"
          },
          type: "list"
        },
        S9: {
          members: {
            ManifestWindowSeconds: {
              type: "integer"
            },
            MinBufferTimeSeconds: {
              type: "integer"
            },
            MinUpdatePeriodSeconds: {
              type: "integer"
            },
            SuggestedPresentationDelaySeconds: {
              type: "integer"
            }
          },
          type: "structure"
        },
        Sa: {
          members: {
            ManifestWindowSeconds: {
              type: "integer"
            }
          },
          type: "structure"
        },
        Sc: {
          key: {},
          type: "map",
          value: {}
        },
        Sf: {
          timestampFormat: "unixTimestamp",
          type: "timestamp"
        },
        Sg: {
          member: {
            members: {
              DashPlaylistSettings: {
                shape: "S9"
              },
              HlsPlaylistSettings: {
                shape: "Sa"
              },
              ManifestName: {},
              PlaybackUrl: {},
              SourceGroup: {}
            },
            required: [
              "ManifestName",
              "PlaybackUrl",
              "SourceGroup"
            ],
            type: "structure"
          },
          type: "list"
        },
        Sj: {
          members: {
            AvailMatchingCriteria: {
              member: {
                members: {
                  DynamicVariable: {},
                  Operator: {}
                },
                required: [
                  "Operator",
                  "DynamicVariable"
                ],
                type: "structure"
              },
              type: "list"
            },
            EndTime: {
              shape: "Sf"
            },
            StartTime: {
              shape: "Sf"
            }
          },
          required: [
            "EndTime"
          ],
          type: "structure"
        },
        Sn: {
          members: {
            DynamicVariables: {
              shape: "Sc"
            },
            EndTime: {
              shape: "Sf"
            },
            StartTime: {
              shape: "Sf"
            }
          },
          required: [
            "EndTime"
          ],
          type: "structure"
        },
        Sq: {
          member: {
            members: {
              MessageType: {},
              OffsetMillis: {
                type: "long"
              },
              Slate: {
                shape: "S6"
              },
              SpliceInsertMessage: {
                members: {
                  AvailNum: {
                    type: "integer"
                  },
                  AvailsExpected: {
                    type: "integer"
                  },
                  SpliceEventId: {
                    type: "integer"
                  },
                  UniqueProgramId: {
                    type: "integer"
                  }
                },
                type: "structure"
              }
            },
            type: "structure"
          },
          type: "list"
        },
        S10: {
          members: {
            AccessType: {},
            SecretsManagerAccessTokenConfiguration: {
              members: {
                HeaderName: {},
                SecretArn: {},
                SecretStringKey: {}
              },
              type: "structure"
            }
          },
          type: "structure"
        },
        S13: {
          members: {
            BaseUrl: {}
          },
          type: "structure"
        },
        S14: {
          members: {
            BaseUrl: {}
          },
          required: [
            "BaseUrl"
          ],
          type: "structure"
        },
        S17: {
          member: {
            members: {
              Path: {},
              SourceGroup: {},
              Type: {}
            },
            required: [
              "Path",
              "Type",
              "SourceGroup"
            ],
            type: "structure"
          },
          type: "list"
        },
        S29: {
          members: {
            Mode: {},
            Value: {}
          },
          type: "structure"
        },
        S2b: {
          members: {
            EndUrl: {},
            StartUrl: {}
          },
          type: "structure"
        },
        S2c: {
          members: {
            AdSegmentUrlPrefix: {},
            ContentSegmentUrlPrefix: {}
          },
          type: "structure"
        },
        S2d: {
          key: {},
          type: "map",
          value: {
            shape: "Sc"
          }
        },
        S2e: {
          members: {
            ManifestEndpointPrefix: {},
            MpdLocation: {},
            OriginManifestType: {}
          },
          type: "structure"
        },
        S2g: {
          members: {
            ManifestEndpointPrefix: {}
          },
          type: "structure"
        },
        S2h: {
          members: {
            AdDecisionServerUrl: {},
            MaxDurationSeconds: {
              type: "integer"
            }
          },
          type: "structure"
        },
        S2i: {
          members: {
            PercentEnabled: {
              type: "integer"
            }
          },
          required: [
            "PercentEnabled"
          ],
          type: "structure"
        },
        S2j: {
          members: {
            AdMarkerPassthrough: {
              members: {
                Enabled: {
                  type: "boolean"
                }
              },
              type: "structure"
            }
          },
          type: "structure"
        },
        S2t: {
          member: {},
          type: "list"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mediatailor-2018-04-23.paginators.json
var require_mediatailor_2018_04_23_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mediatailor-2018-04-23.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetChannelSchedule: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Items"
        },
        ListAlerts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Items"
        },
        ListChannels: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Items"
        },
        ListPlaybackConfigurations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Items"
        },
        ListPrefetchSchedules: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Items"
        },
        ListSourceLocations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Items"
        },
        ListVodSources: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mediatailor.js
var require_mediatailor = __commonJS({
  "node_modules/aws-sdk/clients/mediatailor.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["mediatailor"] = {};
    AWS3.MediaTailor = Service.defineService("mediatailor", ["2018-04-23"]);
    Object.defineProperty(apiLoader.services["mediatailor"], "2018-04-23", {
      get: function get() {
        var model = require_mediatailor_2018_04_23_min();
        model.paginators = require_mediatailor_2018_04_23_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.MediaTailor;
  }
});

// node_modules/aws-sdk/apis/eks-2017-11-01.min.json
var require_eks_2017_11_01_min = __commonJS({
  "node_modules/aws-sdk/apis/eks-2017-11-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-11-01",
        endpointPrefix: "eks",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon EKS",
        serviceFullName: "Amazon Elastic Kubernetes Service",
        serviceId: "EKS",
        signatureVersion: "v4",
        signingName: "eks",
        uid: "eks-2017-11-01"
      },
      operations: {
        AssociateEncryptionConfig: {
          http: {
            requestUri: "/clusters/{name}/encryption-config/associate"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "encryptionConfig"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              encryptionConfig: {
                shape: "S3"
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              update: {
                shape: "S8"
              }
            }
          }
        },
        AssociateIdentityProviderConfig: {
          http: {
            requestUri: "/clusters/{name}/identity-provider-configs/associate"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "oidc"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              oidc: {
                type: "structure",
                required: [
                  "identityProviderConfigName",
                  "issuerUrl",
                  "clientId"
                ],
                members: {
                  identityProviderConfigName: {},
                  issuerUrl: {},
                  clientId: {},
                  usernameClaim: {},
                  usernamePrefix: {},
                  groupsClaim: {},
                  groupsPrefix: {},
                  requiredClaims: {
                    shape: "Sk"
                  }
                }
              },
              tags: {
                shape: "Sn"
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              update: {
                shape: "S8"
              },
              tags: {
                shape: "Sn"
              }
            }
          }
        },
        CreateAddon: {
          http: {
            requestUri: "/clusters/{name}/addons"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "addonName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              addonName: {},
              addonVersion: {},
              serviceAccountRoleArn: {},
              resolveConflicts: {},
              clientRequestToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              addon: {
                shape: "Sw"
              }
            }
          }
        },
        CreateCluster: {
          http: {
            requestUri: "/clusters"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "roleArn",
              "resourcesVpcConfig"
            ],
            members: {
              name: {},
              version: {},
              roleArn: {},
              resourcesVpcConfig: {
                shape: "S13"
              },
              kubernetesNetworkConfig: {
                type: "structure",
                members: {
                  serviceIpv4Cidr: {}
                }
              },
              logging: {
                shape: "S16"
              },
              clientRequestToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Sn"
              },
              encryptionConfig: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              cluster: {
                shape: "S1c"
              }
            }
          }
        },
        CreateFargateProfile: {
          http: {
            requestUri: "/clusters/{name}/fargate-profiles"
          },
          input: {
            type: "structure",
            required: [
              "fargateProfileName",
              "clusterName",
              "podExecutionRoleArn"
            ],
            members: {
              fargateProfileName: {},
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              podExecutionRoleArn: {},
              subnets: {
                shape: "S5"
              },
              selectors: {
                shape: "S1m"
              },
              clientRequestToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              fargateProfile: {
                shape: "S1q"
              }
            }
          }
        },
        CreateNodegroup: {
          http: {
            requestUri: "/clusters/{name}/node-groups"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "nodegroupName",
              "subnets",
              "nodeRole"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              nodegroupName: {},
              scalingConfig: {
                shape: "S1t"
              },
              diskSize: {
                type: "integer"
              },
              subnets: {
                shape: "S5"
              },
              instanceTypes: {
                shape: "S5"
              },
              amiType: {},
              remoteAccess: {
                shape: "S1y"
              },
              nodeRole: {},
              labels: {
                shape: "S1z"
              },
              taints: {
                shape: "S22"
              },
              tags: {
                shape: "Sn"
              },
              clientRequestToken: {
                idempotencyToken: true
              },
              launchTemplate: {
                shape: "S27"
              },
              updateConfig: {
                shape: "S28"
              },
              capacityType: {},
              version: {},
              releaseVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              nodegroup: {
                shape: "S2d"
              }
            }
          }
        },
        DeleteAddon: {
          http: {
            method: "DELETE",
            requestUri: "/clusters/{name}/addons/{addonName}"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "addonName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              addonName: {
                location: "uri",
                locationName: "addonName"
              },
              preserve: {
                location: "querystring",
                locationName: "preserve",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              addon: {
                shape: "Sw"
              }
            }
          }
        },
        DeleteCluster: {
          http: {
            method: "DELETE",
            requestUri: "/clusters/{name}"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              cluster: {
                shape: "S1c"
              }
            }
          }
        },
        DeleteFargateProfile: {
          http: {
            method: "DELETE",
            requestUri: "/clusters/{name}/fargate-profiles/{fargateProfileName}"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "fargateProfileName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              fargateProfileName: {
                location: "uri",
                locationName: "fargateProfileName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              fargateProfile: {
                shape: "S1q"
              }
            }
          }
        },
        DeleteNodegroup: {
          http: {
            method: "DELETE",
            requestUri: "/clusters/{name}/node-groups/{nodegroupName}"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "nodegroupName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              nodegroupName: {
                location: "uri",
                locationName: "nodegroupName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nodegroup: {
                shape: "S2d"
              }
            }
          }
        },
        DeregisterCluster: {
          http: {
            method: "DELETE",
            requestUri: "/cluster-registrations/{name}"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              cluster: {
                shape: "S1c"
              }
            }
          }
        },
        DescribeAddon: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/addons/{addonName}"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "addonName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              addonName: {
                location: "uri",
                locationName: "addonName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              addon: {
                shape: "Sw"
              }
            }
          }
        },
        DescribeAddonVersions: {
          http: {
            method: "GET",
            requestUri: "/addons/supported-versions"
          },
          input: {
            type: "structure",
            members: {
              kubernetesVersion: {
                location: "querystring",
                locationName: "kubernetesVersion"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              addonName: {
                location: "querystring",
                locationName: "addonName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              addons: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    addonName: {},
                    type: {},
                    addonVersions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          addonVersion: {},
                          architecture: {
                            shape: "S5"
                          },
                          compatibilities: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                clusterVersion: {},
                                platformVersions: {
                                  shape: "S5"
                                },
                                defaultVersion: {
                                  type: "boolean"
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeCluster: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              cluster: {
                shape: "S1c"
              }
            }
          }
        },
        DescribeFargateProfile: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/fargate-profiles/{fargateProfileName}"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "fargateProfileName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              fargateProfileName: {
                location: "uri",
                locationName: "fargateProfileName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              fargateProfile: {
                shape: "S1q"
              }
            }
          }
        },
        DescribeIdentityProviderConfig: {
          http: {
            requestUri: "/clusters/{name}/identity-provider-configs/describe"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "identityProviderConfig"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              identityProviderConfig: {
                shape: "S3c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              identityProviderConfig: {
                type: "structure",
                members: {
                  oidc: {
                    type: "structure",
                    members: {
                      identityProviderConfigName: {},
                      identityProviderConfigArn: {},
                      clusterName: {},
                      issuerUrl: {},
                      clientId: {},
                      usernameClaim: {},
                      usernamePrefix: {},
                      groupsClaim: {},
                      groupsPrefix: {},
                      requiredClaims: {
                        shape: "Sk"
                      },
                      tags: {
                        shape: "Sn"
                      },
                      status: {}
                    }
                  }
                }
              }
            }
          }
        },
        DescribeNodegroup: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/node-groups/{nodegroupName}"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "nodegroupName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              nodegroupName: {
                location: "uri",
                locationName: "nodegroupName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nodegroup: {
                shape: "S2d"
              }
            }
          }
        },
        DescribeUpdate: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/updates/{updateId}"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "updateId"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              updateId: {
                location: "uri",
                locationName: "updateId"
              },
              nodegroupName: {
                location: "querystring",
                locationName: "nodegroupName"
              },
              addonName: {
                location: "querystring",
                locationName: "addonName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              update: {
                shape: "S8"
              }
            }
          }
        },
        DisassociateIdentityProviderConfig: {
          http: {
            requestUri: "/clusters/{name}/identity-provider-configs/disassociate"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "identityProviderConfig"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              identityProviderConfig: {
                shape: "S3c"
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              update: {
                shape: "S8"
              }
            }
          }
        },
        ListAddons: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/addons"
          },
          input: {
            type: "structure",
            required: [
              "clusterName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              addons: {
                shape: "S5"
              },
              nextToken: {}
            }
          }
        },
        ListClusters: {
          http: {
            method: "GET",
            requestUri: "/clusters"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              include: {
                location: "querystring",
                locationName: "include",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              clusters: {
                shape: "S5"
              },
              nextToken: {}
            }
          }
        },
        ListFargateProfiles: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/fargate-profiles"
          },
          input: {
            type: "structure",
            required: [
              "clusterName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              fargateProfileNames: {
                shape: "S5"
              },
              nextToken: {}
            }
          }
        },
        ListIdentityProviderConfigs: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/identity-provider-configs"
          },
          input: {
            type: "structure",
            required: [
              "clusterName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              identityProviderConfigs: {
                type: "list",
                member: {
                  shape: "S3c"
                }
              },
              nextToken: {}
            }
          }
        },
        ListNodegroups: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/node-groups"
          },
          input: {
            type: "structure",
            required: [
              "clusterName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nodegroups: {
                shape: "S5"
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sn"
              }
            }
          }
        },
        ListUpdates: {
          http: {
            method: "GET",
            requestUri: "/clusters/{name}/updates"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              nodegroupName: {
                location: "querystring",
                locationName: "nodegroupName"
              },
              addonName: {
                location: "querystring",
                locationName: "addonName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              updateIds: {
                shape: "S5"
              },
              nextToken: {}
            }
          }
        },
        RegisterCluster: {
          http: {
            requestUri: "/cluster-registrations"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "connectorConfig"
            ],
            members: {
              name: {},
              connectorConfig: {
                type: "structure",
                required: [
                  "roleArn",
                  "provider"
                ],
                members: {
                  roleArn: {},
                  provider: {}
                }
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              cluster: {
                shape: "S1c"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAddon: {
          http: {
            requestUri: "/clusters/{name}/addons/{addonName}/update"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "addonName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              addonName: {
                location: "uri",
                locationName: "addonName"
              },
              addonVersion: {},
              serviceAccountRoleArn: {},
              resolveConflicts: {},
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              update: {
                shape: "S8"
              }
            }
          }
        },
        UpdateClusterConfig: {
          http: {
            requestUri: "/clusters/{name}/update-config"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              resourcesVpcConfig: {
                shape: "S13"
              },
              logging: {
                shape: "S16"
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              update: {
                shape: "S8"
              }
            }
          }
        },
        UpdateClusterVersion: {
          http: {
            requestUri: "/clusters/{name}/updates"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "version"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              version: {},
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              update: {
                shape: "S8"
              }
            }
          }
        },
        UpdateNodegroupConfig: {
          http: {
            requestUri: "/clusters/{name}/node-groups/{nodegroupName}/update-config"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "nodegroupName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              nodegroupName: {
                location: "uri",
                locationName: "nodegroupName"
              },
              labels: {
                type: "structure",
                members: {
                  addOrUpdateLabels: {
                    shape: "S1z"
                  },
                  removeLabels: {
                    type: "list",
                    member: {}
                  }
                }
              },
              taints: {
                type: "structure",
                members: {
                  addOrUpdateTaints: {
                    shape: "S22"
                  },
                  removeTaints: {
                    shape: "S22"
                  }
                }
              },
              scalingConfig: {
                shape: "S1t"
              },
              updateConfig: {
                shape: "S28"
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              update: {
                shape: "S8"
              }
            }
          }
        },
        UpdateNodegroupVersion: {
          http: {
            requestUri: "/clusters/{name}/node-groups/{nodegroupName}/update-version"
          },
          input: {
            type: "structure",
            required: [
              "clusterName",
              "nodegroupName"
            ],
            members: {
              clusterName: {
                location: "uri",
                locationName: "name"
              },
              nodegroupName: {
                location: "uri",
                locationName: "nodegroupName"
              },
              version: {},
              releaseVersion: {},
              launchTemplate: {
                shape: "S27"
              },
              force: {
                type: "boolean"
              },
              clientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              update: {
                shape: "S8"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            members: {
              resources: {
                shape: "S5"
              },
              provider: {
                type: "structure",
                members: {
                  keyArn: {}
                }
              }
            }
          }
        },
        S5: {
          type: "list",
          member: {}
        },
        S8: {
          type: "structure",
          members: {
            id: {},
            status: {},
            type: {},
            params: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  type: {},
                  value: {}
                }
              }
            },
            createdAt: {
              type: "timestamp"
            },
            errors: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  errorCode: {},
                  errorMessage: {},
                  resourceIds: {
                    shape: "S5"
                  }
                }
              }
            }
          }
        },
        Sk: {
          type: "map",
          key: {},
          value: {}
        },
        Sn: {
          type: "map",
          key: {},
          value: {}
        },
        Sw: {
          type: "structure",
          members: {
            addonName: {},
            clusterName: {},
            status: {},
            addonVersion: {},
            health: {
              type: "structure",
              members: {
                issues: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      code: {},
                      message: {},
                      resourceIds: {
                        shape: "S5"
                      }
                    }
                  }
                }
              }
            },
            addonArn: {},
            createdAt: {
              type: "timestamp"
            },
            modifiedAt: {
              type: "timestamp"
            },
            serviceAccountRoleArn: {},
            tags: {
              shape: "Sn"
            }
          }
        },
        S13: {
          type: "structure",
          members: {
            subnetIds: {
              shape: "S5"
            },
            securityGroupIds: {
              shape: "S5"
            },
            endpointPublicAccess: {
              type: "boolean"
            },
            endpointPrivateAccess: {
              type: "boolean"
            },
            publicAccessCidrs: {
              shape: "S5"
            }
          }
        },
        S16: {
          type: "structure",
          members: {
            clusterLogging: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  types: {
                    type: "list",
                    member: {}
                  },
                  enabled: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S1c: {
          type: "structure",
          members: {
            name: {},
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            version: {},
            endpoint: {},
            roleArn: {},
            resourcesVpcConfig: {
              type: "structure",
              members: {
                subnetIds: {
                  shape: "S5"
                },
                securityGroupIds: {
                  shape: "S5"
                },
                clusterSecurityGroupId: {},
                vpcId: {},
                endpointPublicAccess: {
                  type: "boolean"
                },
                endpointPrivateAccess: {
                  type: "boolean"
                },
                publicAccessCidrs: {
                  shape: "S5"
                }
              }
            },
            kubernetesNetworkConfig: {
              type: "structure",
              members: {
                serviceIpv4Cidr: {}
              }
            },
            logging: {
              shape: "S16"
            },
            identity: {
              type: "structure",
              members: {
                oidc: {
                  type: "structure",
                  members: {
                    issuer: {}
                  }
                }
              }
            },
            status: {},
            certificateAuthority: {
              type: "structure",
              members: {
                data: {}
              }
            },
            clientRequestToken: {},
            platformVersion: {},
            tags: {
              shape: "Sn"
            },
            encryptionConfig: {
              shape: "S3"
            },
            connectorConfig: {
              type: "structure",
              members: {
                activationId: {},
                activationCode: {},
                activationExpiry: {
                  type: "timestamp"
                },
                provider: {},
                roleArn: {}
              }
            }
          }
        },
        S1m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              namespace: {},
              labels: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        S1q: {
          type: "structure",
          members: {
            fargateProfileName: {},
            fargateProfileArn: {},
            clusterName: {},
            createdAt: {
              type: "timestamp"
            },
            podExecutionRoleArn: {},
            subnets: {
              shape: "S5"
            },
            selectors: {
              shape: "S1m"
            },
            status: {},
            tags: {
              shape: "Sn"
            }
          }
        },
        S1t: {
          type: "structure",
          members: {
            minSize: {
              type: "integer"
            },
            maxSize: {
              type: "integer"
            },
            desiredSize: {
              type: "integer"
            }
          }
        },
        S1y: {
          type: "structure",
          members: {
            ec2SshKey: {},
            sourceSecurityGroups: {
              shape: "S5"
            }
          }
        },
        S1z: {
          type: "map",
          key: {},
          value: {}
        },
        S22: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {},
              effect: {}
            }
          }
        },
        S27: {
          type: "structure",
          members: {
            name: {},
            version: {},
            id: {}
          }
        },
        S28: {
          type: "structure",
          members: {
            maxUnavailable: {
              type: "integer"
            },
            maxUnavailablePercentage: {
              type: "integer"
            }
          }
        },
        S2d: {
          type: "structure",
          members: {
            nodegroupName: {},
            nodegroupArn: {},
            clusterName: {},
            version: {},
            releaseVersion: {},
            createdAt: {
              type: "timestamp"
            },
            modifiedAt: {
              type: "timestamp"
            },
            status: {},
            capacityType: {},
            scalingConfig: {
              shape: "S1t"
            },
            instanceTypes: {
              shape: "S5"
            },
            subnets: {
              shape: "S5"
            },
            remoteAccess: {
              shape: "S1y"
            },
            amiType: {},
            nodeRole: {},
            labels: {
              shape: "S1z"
            },
            taints: {
              shape: "S22"
            },
            resources: {
              type: "structure",
              members: {
                autoScalingGroups: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      name: {}
                    }
                  }
                },
                remoteAccessSecurityGroup: {}
              }
            },
            diskSize: {
              type: "integer"
            },
            health: {
              type: "structure",
              members: {
                issues: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      code: {},
                      message: {},
                      resourceIds: {
                        shape: "S5"
                      }
                    }
                  }
                }
              }
            },
            updateConfig: {
              shape: "S28"
            },
            launchTemplate: {
              shape: "S27"
            },
            tags: {
              shape: "Sn"
            }
          }
        },
        S3c: {
          type: "structure",
          required: [
            "type",
            "name"
          ],
          members: {
            type: {},
            name: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/eks-2017-11-01.paginators.json
var require_eks_2017_11_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/eks-2017-11-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeAddonVersions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "addons"
        },
        ListAddons: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "addons"
        },
        ListClusters: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "clusters"
        },
        ListFargateProfiles: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "fargateProfileNames"
        },
        ListIdentityProviderConfigs: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "identityProviderConfigs"
        },
        ListNodegroups: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "nodegroups"
        },
        ListUpdates: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "updateIds"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/eks-2017-11-01.waiters2.json
var require_eks_2017_11_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/eks-2017-11-01.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ClusterActive: {
          delay: 30,
          operation: "DescribeCluster",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "DELETING",
              matcher: "path",
              state: "failure",
              argument: "cluster.status"
            },
            {
              expected: "FAILED",
              matcher: "path",
              state: "failure",
              argument: "cluster.status"
            },
            {
              expected: "ACTIVE",
              matcher: "path",
              state: "success",
              argument: "cluster.status"
            }
          ]
        },
        ClusterDeleted: {
          delay: 30,
          operation: "DescribeCluster",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "ACTIVE",
              matcher: "path",
              state: "failure",
              argument: "cluster.status"
            },
            {
              expected: "CREATING",
              matcher: "path",
              state: "failure",
              argument: "cluster.status"
            },
            {
              expected: "PENDING",
              matcher: "path",
              state: "failure",
              argument: "cluster.status"
            },
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "success"
            }
          ]
        },
        NodegroupActive: {
          delay: 30,
          operation: "DescribeNodegroup",
          maxAttempts: 80,
          acceptors: [
            {
              expected: "CREATE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "nodegroup.status"
            },
            {
              expected: "ACTIVE",
              matcher: "path",
              state: "success",
              argument: "nodegroup.status"
            }
          ]
        },
        NodegroupDeleted: {
          delay: 30,
          operation: "DescribeNodegroup",
          maxAttempts: 40,
          acceptors: [
            {
              expected: "DELETE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "nodegroup.status"
            },
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "success"
            }
          ]
        },
        AddonActive: {
          delay: 10,
          operation: "DescribeAddon",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "CREATE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "addon.status"
            },
            {
              expected: "DEGRADED",
              matcher: "path",
              state: "failure",
              argument: "addon.status"
            },
            {
              expected: "ACTIVE",
              matcher: "path",
              state: "success",
              argument: "addon.status"
            }
          ]
        },
        AddonDeleted: {
          delay: 10,
          operation: "DescribeAddon",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "DELETE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "addon.status"
            },
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "success"
            }
          ]
        },
        FargateProfileActive: {
          delay: 10,
          operation: "DescribeFargateProfile",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "CREATE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "fargateProfile.status"
            },
            {
              expected: "ACTIVE",
              matcher: "path",
              state: "success",
              argument: "fargateProfile.status"
            }
          ]
        },
        FargateProfileDeleted: {
          delay: 30,
          operation: "DescribeFargateProfile",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "DELETE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "fargateProfile.status"
            },
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "success"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/eks.js
var require_eks = __commonJS({
  "node_modules/aws-sdk/clients/eks.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["eks"] = {};
    AWS3.EKS = Service.defineService("eks", ["2017-11-01"]);
    Object.defineProperty(apiLoader.services["eks"], "2017-11-01", {
      get: function get() {
        var model = require_eks_2017_11_01_min();
        model.paginators = require_eks_2017_11_01_paginators().pagination;
        model.waiters = require_eks_2017_11_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.EKS;
  }
});

// node_modules/aws-sdk/apis/macie-2017-12-19.min.json
var require_macie_2017_12_19_min = __commonJS({
  "node_modules/aws-sdk/apis/macie-2017-12-19.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-12-19",
        endpointPrefix: "macie",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Macie",
        serviceId: "Macie",
        signatureVersion: "v4",
        targetPrefix: "MacieService",
        uid: "macie-2017-12-19"
      },
      operations: {
        AssociateMemberAccount: {
          input: {
            type: "structure",
            required: [
              "memberAccountId"
            ],
            members: {
              memberAccountId: {}
            }
          }
        },
        AssociateS3Resources: {
          input: {
            type: "structure",
            required: [
              "s3Resources"
            ],
            members: {
              memberAccountId: {},
              s3Resources: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              failedS3Resources: {
                shape: "Sc"
              }
            }
          }
        },
        DisassociateMemberAccount: {
          input: {
            type: "structure",
            required: [
              "memberAccountId"
            ],
            members: {
              memberAccountId: {}
            }
          }
        },
        DisassociateS3Resources: {
          input: {
            type: "structure",
            required: [
              "associatedS3Resources"
            ],
            members: {
              memberAccountId: {},
              associatedS3Resources: {
                type: "list",
                member: {
                  shape: "Se"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              failedS3Resources: {
                shape: "Sc"
              }
            }
          }
        },
        ListMemberAccounts: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              memberAccounts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListS3Resources: {
          input: {
            type: "structure",
            members: {
              memberAccountId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              s3Resources: {
                shape: "S4"
              },
              nextToken: {}
            }
          }
        },
        UpdateS3Resources: {
          input: {
            type: "structure",
            required: [
              "s3ResourcesUpdate"
            ],
            members: {
              memberAccountId: {},
              s3ResourcesUpdate: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "bucketName",
                    "classificationTypeUpdate"
                  ],
                  members: {
                    bucketName: {},
                    prefix: {},
                    classificationTypeUpdate: {
                      type: "structure",
                      members: {
                        oneTime: {},
                        continuous: {}
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              failedS3Resources: {
                shape: "Sc"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "bucketName",
              "classificationType"
            ],
            members: {
              bucketName: {},
              prefix: {},
              classificationType: {
                type: "structure",
                required: [
                  "oneTime",
                  "continuous"
                ],
                members: {
                  oneTime: {},
                  continuous: {}
                }
              }
            }
          }
        },
        Sc: {
          type: "list",
          member: {
            type: "structure",
            members: {
              failedItem: {
                shape: "Se"
              },
              errorCode: {},
              errorMessage: {}
            }
          }
        },
        Se: {
          type: "structure",
          required: [
            "bucketName"
          ],
          members: {
            bucketName: {},
            prefix: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/macie-2017-12-19.paginators.json
var require_macie_2017_12_19_paginators = __commonJS({
  "node_modules/aws-sdk/apis/macie-2017-12-19.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListMemberAccounts: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListS3Resources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/macie.js
var require_macie = __commonJS({
  "node_modules/aws-sdk/clients/macie.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["macie"] = {};
    AWS3.Macie = Service.defineService("macie", ["2017-12-19"]);
    Object.defineProperty(apiLoader.services["macie"], "2017-12-19", {
      get: function get() {
        var model = require_macie_2017_12_19_min();
        model.paginators = require_macie_2017_12_19_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Macie;
  }
});

// node_modules/aws-sdk/apis/dlm-2018-01-12.min.json
var require_dlm_2018_01_12_min = __commonJS({
  "node_modules/aws-sdk/apis/dlm-2018-01-12.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-01-12",
        endpointPrefix: "dlm",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon DLM",
        serviceFullName: "Amazon Data Lifecycle Manager",
        serviceId: "DLM",
        signatureVersion: "v4",
        signingName: "dlm",
        uid: "dlm-2018-01-12"
      },
      operations: {
        CreateLifecyclePolicy: {
          http: {
            requestUri: "/policies"
          },
          input: {
            type: "structure",
            required: [
              "ExecutionRoleArn",
              "Description",
              "State",
              "PolicyDetails"
            ],
            members: {
              ExecutionRoleArn: {},
              Description: {},
              State: {},
              PolicyDetails: {
                shape: "S5"
              },
              Tags: {
                shape: "S1q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PolicyId: {}
            }
          }
        },
        DeleteLifecyclePolicy: {
          http: {
            method: "DELETE",
            requestUri: "/policies/{policyId}/"
          },
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {
                location: "uri",
                locationName: "policyId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetLifecyclePolicies: {
          http: {
            method: "GET",
            requestUri: "/policies"
          },
          input: {
            type: "structure",
            members: {
              PolicyIds: {
                location: "querystring",
                locationName: "policyIds",
                type: "list",
                member: {}
              },
              State: {
                location: "querystring",
                locationName: "state"
              },
              ResourceTypes: {
                shape: "S7",
                location: "querystring",
                locationName: "resourceTypes"
              },
              TargetTags: {
                location: "querystring",
                locationName: "targetTags",
                type: "list",
                member: {}
              },
              TagsToAdd: {
                location: "querystring",
                locationName: "tagsToAdd",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PolicyId: {},
                    Description: {},
                    State: {},
                    Tags: {
                      shape: "S1q"
                    },
                    PolicyType: {}
                  }
                }
              }
            }
          }
        },
        GetLifecyclePolicy: {
          http: {
            method: "GET",
            requestUri: "/policies/{policyId}/"
          },
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {
                location: "uri",
                locationName: "policyId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                type: "structure",
                members: {
                  PolicyId: {},
                  Description: {},
                  State: {},
                  StatusMessage: {},
                  ExecutionRoleArn: {},
                  DateCreated: {
                    shape: "S2a"
                  },
                  DateModified: {
                    shape: "S2a"
                  },
                  PolicyDetails: {
                    shape: "S5"
                  },
                  Tags: {
                    shape: "S1q"
                  },
                  PolicyArn: {}
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S1q"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "S1q"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLifecyclePolicy: {
          http: {
            method: "PATCH",
            requestUri: "/policies/{policyId}"
          },
          input: {
            type: "structure",
            required: [
              "PolicyId"
            ],
            members: {
              PolicyId: {
                location: "uri",
                locationName: "policyId"
              },
              ExecutionRoleArn: {},
              State: {},
              Description: {},
              PolicyDetails: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            PolicyType: {},
            ResourceTypes: {
              shape: "S7"
            },
            ResourceLocations: {
              type: "list",
              member: {}
            },
            TargetTags: {
              type: "list",
              member: {
                shape: "Sc"
              }
            },
            Schedules: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {},
                  CopyTags: {
                    type: "boolean"
                  },
                  TagsToAdd: {
                    type: "list",
                    member: {
                      shape: "Sc"
                    }
                  },
                  VariableTags: {
                    type: "list",
                    member: {
                      shape: "Sc"
                    }
                  },
                  CreateRule: {
                    type: "structure",
                    members: {
                      Location: {},
                      Interval: {
                        type: "integer"
                      },
                      IntervalUnit: {},
                      Times: {
                        type: "list",
                        member: {}
                      },
                      CronExpression: {}
                    }
                  },
                  RetainRule: {
                    type: "structure",
                    members: {
                      Count: {
                        type: "integer"
                      },
                      Interval: {
                        type: "integer"
                      },
                      IntervalUnit: {}
                    }
                  },
                  FastRestoreRule: {
                    type: "structure",
                    required: [
                      "AvailabilityZones"
                    ],
                    members: {
                      Count: {
                        type: "integer"
                      },
                      Interval: {
                        type: "integer"
                      },
                      IntervalUnit: {},
                      AvailabilityZones: {
                        type: "list",
                        member: {}
                      }
                    }
                  },
                  CrossRegionCopyRules: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Encrypted"
                      ],
                      members: {
                        TargetRegion: {},
                        Target: {},
                        Encrypted: {
                          type: "boolean"
                        },
                        CmkArn: {},
                        CopyTags: {
                          type: "boolean"
                        },
                        RetainRule: {
                          shape: "S14"
                        },
                        DeprecateRule: {
                          type: "structure",
                          members: {
                            Interval: {
                              type: "integer"
                            },
                            IntervalUnit: {}
                          }
                        }
                      }
                    }
                  },
                  ShareRules: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "TargetAccounts"
                      ],
                      members: {
                        TargetAccounts: {
                          type: "list",
                          member: {}
                        },
                        UnshareInterval: {
                          type: "integer"
                        },
                        UnshareIntervalUnit: {}
                      }
                    }
                  },
                  DeprecateRule: {
                    type: "structure",
                    members: {
                      Count: {
                        type: "integer"
                      },
                      Interval: {
                        type: "integer"
                      },
                      IntervalUnit: {}
                    }
                  }
                }
              }
            },
            Parameters: {
              type: "structure",
              members: {
                ExcludeBootVolume: {
                  type: "boolean"
                },
                NoReboot: {
                  type: "boolean"
                }
              }
            },
            EventSource: {
              type: "structure",
              required: [
                "Type"
              ],
              members: {
                Type: {},
                Parameters: {
                  type: "structure",
                  required: [
                    "EventType",
                    "SnapshotOwner",
                    "DescriptionRegex"
                  ],
                  members: {
                    EventType: {},
                    SnapshotOwner: {
                      type: "list",
                      member: {}
                    },
                    DescriptionRegex: {}
                  }
                }
              }
            },
            Actions: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "CrossRegionCopy"
                ],
                members: {
                  Name: {},
                  CrossRegionCopy: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Target",
                        "EncryptionConfiguration"
                      ],
                      members: {
                        Target: {},
                        EncryptionConfiguration: {
                          type: "structure",
                          required: [
                            "Encrypted"
                          ],
                          members: {
                            Encrypted: {
                              type: "boolean"
                            },
                            CmkArn: {}
                          }
                        },
                        RetainRule: {
                          shape: "S14"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S7: {
          type: "list",
          member: {}
        },
        Sc: {
          type: "structure",
          required: [
            "Key",
            "Value"
          ],
          members: {
            Key: {},
            Value: {}
          }
        },
        S14: {
          type: "structure",
          members: {
            Interval: {
              type: "integer"
            },
            IntervalUnit: {}
          }
        },
        S1q: {
          type: "map",
          key: {},
          value: {}
        },
        S2a: {
          type: "timestamp",
          timestampFormat: "iso8601"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dlm-2018-01-12.paginators.json
var require_dlm_2018_01_12_paginators = __commonJS({
  "node_modules/aws-sdk/apis/dlm-2018-01-12.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/dlm.js
var require_dlm = __commonJS({
  "node_modules/aws-sdk/clients/dlm.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["dlm"] = {};
    AWS3.DLM = Service.defineService("dlm", ["2018-01-12"]);
    Object.defineProperty(apiLoader.services["dlm"], "2018-01-12", {
      get: function get() {
        var model = require_dlm_2018_01_12_min();
        model.paginators = require_dlm_2018_01_12_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.DLM;
  }
});

// node_modules/aws-sdk/apis/signer-2017-08-25.min.json
var require_signer_2017_08_25_min = __commonJS({
  "node_modules/aws-sdk/apis/signer-2017-08-25.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-08-25",
        endpointPrefix: "signer",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "signer",
        serviceFullName: "AWS Signer",
        serviceId: "signer",
        signatureVersion: "v4",
        signingName: "signer",
        uid: "signer-2017-08-25"
      },
      operations: {
        AddProfilePermission: {
          http: {
            requestUri: "/signing-profiles/{profileName}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "action",
              "principal",
              "statementId",
              "profileName"
            ],
            members: {
              profileName: {
                location: "uri",
                locationName: "profileName"
              },
              profileVersion: {},
              action: {},
              principal: {},
              revisionId: {},
              statementId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              revisionId: {}
            }
          }
        },
        CancelSigningProfile: {
          http: {
            method: "DELETE",
            requestUri: "/signing-profiles/{profileName}"
          },
          input: {
            type: "structure",
            required: [
              "profileName"
            ],
            members: {
              profileName: {
                location: "uri",
                locationName: "profileName"
              }
            }
          }
        },
        DescribeSigningJob: {
          http: {
            method: "GET",
            requestUri: "/signing-jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobId: {},
              source: {
                shape: "Sa"
              },
              signingMaterial: {
                shape: "Sf"
              },
              platformId: {},
              platformDisplayName: {},
              profileName: {},
              profileVersion: {},
              overrides: {
                shape: "Sj"
              },
              signingParameters: {
                shape: "So"
              },
              createdAt: {
                type: "timestamp"
              },
              completedAt: {
                type: "timestamp"
              },
              signatureExpiresAt: {
                type: "timestamp"
              },
              requestedBy: {},
              status: {},
              statusReason: {},
              revocationRecord: {
                type: "structure",
                members: {
                  reason: {},
                  revokedAt: {
                    type: "timestamp"
                  },
                  revokedBy: {}
                }
              },
              signedObject: {
                shape: "Sw"
              },
              jobOwner: {},
              jobInvoker: {}
            }
          }
        },
        GetSigningPlatform: {
          http: {
            method: "GET",
            requestUri: "/signing-platforms/{platformId}"
          },
          input: {
            type: "structure",
            required: [
              "platformId"
            ],
            members: {
              platformId: {
                location: "uri",
                locationName: "platformId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              platformId: {},
              displayName: {},
              partner: {},
              target: {},
              category: {},
              signingConfiguration: {
                shape: "S12"
              },
              signingImageFormat: {
                shape: "S17"
              },
              maxSizeInMB: {
                type: "integer"
              },
              revocationSupported: {
                type: "boolean"
              }
            }
          }
        },
        GetSigningProfile: {
          http: {
            method: "GET",
            requestUri: "/signing-profiles/{profileName}"
          },
          input: {
            type: "structure",
            required: [
              "profileName"
            ],
            members: {
              profileName: {
                location: "uri",
                locationName: "profileName"
              },
              profileOwner: {
                location: "querystring",
                locationName: "profileOwner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              profileName: {},
              profileVersion: {},
              profileVersionArn: {},
              revocationRecord: {
                type: "structure",
                members: {
                  revocationEffectiveFrom: {
                    type: "timestamp"
                  },
                  revokedAt: {
                    type: "timestamp"
                  },
                  revokedBy: {}
                }
              },
              signingMaterial: {
                shape: "Sf"
              },
              platformId: {},
              platformDisplayName: {},
              signatureValidityPeriod: {
                shape: "S1f"
              },
              overrides: {
                shape: "Sj"
              },
              signingParameters: {
                shape: "So"
              },
              status: {},
              statusReason: {},
              arn: {},
              tags: {
                shape: "S1k"
              }
            }
          }
        },
        ListProfilePermissions: {
          http: {
            method: "GET",
            requestUri: "/signing-profiles/{profileName}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "profileName"
            ],
            members: {
              profileName: {
                location: "uri",
                locationName: "profileName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              revisionId: {},
              policySizeBytes: {
                type: "integer"
              },
              permissions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    action: {},
                    principal: {},
                    statementId: {},
                    profileVersion: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSigningJobs: {
          http: {
            method: "GET",
            requestUri: "/signing-jobs"
          },
          input: {
            type: "structure",
            members: {
              status: {
                location: "querystring",
                locationName: "status"
              },
              platformId: {
                location: "querystring",
                locationName: "platformId"
              },
              requestedBy: {
                location: "querystring",
                locationName: "requestedBy"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              isRevoked: {
                location: "querystring",
                locationName: "isRevoked",
                type: "boolean"
              },
              signatureExpiresBefore: {
                location: "querystring",
                locationName: "signatureExpiresBefore",
                type: "timestamp"
              },
              signatureExpiresAfter: {
                location: "querystring",
                locationName: "signatureExpiresAfter",
                type: "timestamp"
              },
              jobInvoker: {
                location: "querystring",
                locationName: "jobInvoker"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    jobId: {},
                    source: {
                      shape: "Sa"
                    },
                    signedObject: {
                      shape: "Sw"
                    },
                    signingMaterial: {
                      shape: "Sf"
                    },
                    createdAt: {
                      type: "timestamp"
                    },
                    status: {},
                    isRevoked: {
                      type: "boolean"
                    },
                    profileName: {},
                    profileVersion: {},
                    platformId: {},
                    platformDisplayName: {},
                    signatureExpiresAt: {
                      type: "timestamp"
                    },
                    jobOwner: {},
                    jobInvoker: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSigningPlatforms: {
          http: {
            method: "GET",
            requestUri: "/signing-platforms"
          },
          input: {
            type: "structure",
            members: {
              category: {
                location: "querystring",
                locationName: "category"
              },
              partner: {
                location: "querystring",
                locationName: "partner"
              },
              target: {
                location: "querystring",
                locationName: "target"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              platforms: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    platformId: {},
                    displayName: {},
                    partner: {},
                    target: {},
                    category: {},
                    signingConfiguration: {
                      shape: "S12"
                    },
                    signingImageFormat: {
                      shape: "S17"
                    },
                    maxSizeInMB: {
                      type: "integer"
                    },
                    revocationSupported: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSigningProfiles: {
          http: {
            method: "GET",
            requestUri: "/signing-profiles"
          },
          input: {
            type: "structure",
            members: {
              includeCanceled: {
                location: "querystring",
                locationName: "includeCanceled",
                type: "boolean"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              platformId: {
                location: "querystring",
                locationName: "platformId"
              },
              statuses: {
                location: "querystring",
                locationName: "statuses",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              profiles: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    profileName: {},
                    profileVersion: {},
                    profileVersionArn: {},
                    signingMaterial: {
                      shape: "Sf"
                    },
                    signatureValidityPeriod: {
                      shape: "S1f"
                    },
                    platformId: {},
                    platformDisplayName: {},
                    signingParameters: {
                      shape: "So"
                    },
                    status: {},
                    arn: {},
                    tags: {
                      shape: "S1k"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S1k"
              }
            }
          }
        },
        PutSigningProfile: {
          http: {
            method: "PUT",
            requestUri: "/signing-profiles/{profileName}"
          },
          input: {
            type: "structure",
            required: [
              "profileName",
              "platformId"
            ],
            members: {
              profileName: {
                location: "uri",
                locationName: "profileName"
              },
              signingMaterial: {
                shape: "Sf"
              },
              signatureValidityPeriod: {
                shape: "S1f"
              },
              platformId: {},
              overrides: {
                shape: "Sj"
              },
              signingParameters: {
                shape: "So"
              },
              tags: {
                shape: "S1k"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              profileVersion: {},
              profileVersionArn: {}
            }
          }
        },
        RemoveProfilePermission: {
          http: {
            method: "DELETE",
            requestUri: "/signing-profiles/{profileName}/permissions/{statementId}"
          },
          input: {
            type: "structure",
            required: [
              "revisionId",
              "profileName",
              "statementId"
            ],
            members: {
              profileName: {
                location: "uri",
                locationName: "profileName"
              },
              revisionId: {
                location: "querystring",
                locationName: "revisionId"
              },
              statementId: {
                location: "uri",
                locationName: "statementId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              revisionId: {}
            }
          }
        },
        RevokeSignature: {
          http: {
            method: "PUT",
            requestUri: "/signing-jobs/{jobId}/revoke"
          },
          input: {
            type: "structure",
            required: [
              "reason",
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              jobOwner: {},
              reason: {}
            }
          }
        },
        RevokeSigningProfile: {
          http: {
            method: "PUT",
            requestUri: "/signing-profiles/{profileName}/revoke"
          },
          input: {
            type: "structure",
            required: [
              "profileVersion",
              "reason",
              "effectiveTime",
              "profileName"
            ],
            members: {
              profileName: {
                location: "uri",
                locationName: "profileName"
              },
              profileVersion: {},
              reason: {},
              effectiveTime: {
                type: "timestamp"
              }
            }
          }
        },
        StartSigningJob: {
          http: {
            requestUri: "/signing-jobs"
          },
          input: {
            type: "structure",
            required: [
              "source",
              "destination",
              "profileName",
              "clientRequestToken"
            ],
            members: {
              source: {
                shape: "Sa"
              },
              destination: {
                type: "structure",
                members: {
                  s3: {
                    type: "structure",
                    members: {
                      bucketName: {},
                      prefix: {}
                    }
                  }
                }
              },
              profileName: {},
              clientRequestToken: {
                idempotencyToken: true
              },
              profileOwner: {}
            }
          },
          output: {
            type: "structure",
            members: {
              jobId: {},
              jobOwner: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S1k"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sa: {
          type: "structure",
          members: {
            s3: {
              type: "structure",
              required: [
                "bucketName",
                "key",
                "version"
              ],
              members: {
                bucketName: {},
                key: {},
                version: {}
              }
            }
          }
        },
        Sf: {
          type: "structure",
          required: [
            "certificateArn"
          ],
          members: {
            certificateArn: {}
          }
        },
        Sj: {
          type: "structure",
          members: {
            signingConfiguration: {
              type: "structure",
              members: {
                encryptionAlgorithm: {},
                hashAlgorithm: {}
              }
            },
            signingImageFormat: {}
          }
        },
        So: {
          type: "map",
          key: {},
          value: {}
        },
        Sw: {
          type: "structure",
          members: {
            s3: {
              type: "structure",
              members: {
                bucketName: {},
                key: {}
              }
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "encryptionAlgorithmOptions",
            "hashAlgorithmOptions"
          ],
          members: {
            encryptionAlgorithmOptions: {
              type: "structure",
              required: [
                "allowedValues",
                "defaultValue"
              ],
              members: {
                allowedValues: {
                  type: "list",
                  member: {}
                },
                defaultValue: {}
              }
            },
            hashAlgorithmOptions: {
              type: "structure",
              required: [
                "allowedValues",
                "defaultValue"
              ],
              members: {
                allowedValues: {
                  type: "list",
                  member: {}
                },
                defaultValue: {}
              }
            }
          }
        },
        S17: {
          type: "structure",
          required: [
            "supportedFormats",
            "defaultFormat"
          ],
          members: {
            supportedFormats: {
              type: "list",
              member: {}
            },
            defaultFormat: {}
          }
        },
        S1f: {
          type: "structure",
          members: {
            value: {
              type: "integer"
            },
            type: {}
          }
        },
        S1k: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/signer-2017-08-25.paginators.json
var require_signer_2017_08_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/signer-2017-08-25.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListSigningJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListSigningPlatforms: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListSigningProfiles: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/signer-2017-08-25.waiters2.json
var require_signer_2017_08_25_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/signer-2017-08-25.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        SuccessfulSigningJob: {
          delay: 20,
          operation: "DescribeSigningJob",
          maxAttempts: 25,
          acceptors: [
            {
              expected: "Succeeded",
              matcher: "path",
              state: "success",
              argument: "status"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "status"
            },
            {
              expected: "ResourceNotFoundException",
              matcher: "error",
              state: "failure"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/signer.js
var require_signer3 = __commonJS({
  "node_modules/aws-sdk/clients/signer.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["signer"] = {};
    AWS3.Signer = Service.defineService("signer", ["2017-08-25"]);
    Object.defineProperty(apiLoader.services["signer"], "2017-08-25", {
      get: function get() {
        var model = require_signer_2017_08_25_min();
        model.paginators = require_signer_2017_08_25_paginators().pagination;
        model.waiters = require_signer_2017_08_25_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Signer;
  }
});

// node_modules/aws-sdk/apis/chime-2018-05-01.min.json
var require_chime_2018_05_01_min = __commonJS({
  "node_modules/aws-sdk/apis/chime-2018-05-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-01",
        endpointPrefix: "chime",
        protocol: "rest-json",
        serviceFullName: "Amazon Chime",
        serviceId: "Chime",
        signatureVersion: "v4",
        uid: "chime-2018-05-01"
      },
      operations: {
        AssociatePhoneNumberWithUser: {
          http: {
            requestUri: "/accounts/{accountId}/users/{userId}?operation=associate-phone-number",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserId",
              "E164PhoneNumber"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserId: {
                location: "uri",
                locationName: "userId"
              },
              E164PhoneNumber: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociatePhoneNumbersWithVoiceConnector: {
          http: {
            requestUri: "/voice-connectors/{voiceConnectorId}?operation=associate-phone-numbers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "E164PhoneNumbers"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              E164PhoneNumbers: {
                shape: "S7"
              },
              ForceAssociate: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberErrors: {
                shape: "Sa"
              }
            }
          }
        },
        AssociatePhoneNumbersWithVoiceConnectorGroup: {
          http: {
            requestUri: "/voice-connector-groups/{voiceConnectorGroupId}?operation=associate-phone-numbers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorGroupId",
              "E164PhoneNumbers"
            ],
            members: {
              VoiceConnectorGroupId: {
                location: "uri",
                locationName: "voiceConnectorGroupId"
              },
              E164PhoneNumbers: {
                shape: "S7"
              },
              ForceAssociate: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberErrors: {
                shape: "Sa"
              }
            }
          }
        },
        AssociateSigninDelegateGroupsWithAccount: {
          http: {
            requestUri: "/accounts/{accountId}?operation=associate-signin-delegate-groups",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "SigninDelegateGroups"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              SigninDelegateGroups: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        BatchCreateAttendee: {
          http: {
            requestUri: "/meetings/{meetingId}/attendees?operation=batch-create",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "Attendees"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              Attendees: {
                type: "list",
                member: {
                  shape: "Sm"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attendees: {
                shape: "St"
              },
              Errors: {
                shape: "Sw"
              }
            }
          }
        },
        BatchCreateChannelMembership: {
          http: {
            requestUri: "/channels/{channelArn}/memberships?operation=batch-create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArns"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              Type: {},
              MemberArns: {
                type: "list",
                member: {}
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BatchChannelMemberships: {
                type: "structure",
                members: {
                  InvitedBy: {
                    shape: "S14"
                  },
                  Type: {},
                  Members: {
                    type: "list",
                    member: {
                      shape: "S14"
                    }
                  },
                  ChannelArn: {}
                }
              },
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MemberArn: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        BatchCreateRoomMembership: {
          http: {
            requestUri: "/accounts/{accountId}/rooms/{roomId}/memberships?operation=batch-create",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RoomId",
              "MembershipItemList"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              RoomId: {
                location: "uri",
                locationName: "roomId"
              },
              MembershipItemList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MemberId: {},
                    Role: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MemberId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchDeletePhoneNumber: {
          http: {
            requestUri: "/phone-numbers?operation=batch-delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberIds"
            ],
            members: {
              PhoneNumberIds: {
                shape: "S1h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberErrors: {
                shape: "Sa"
              }
            }
          }
        },
        BatchSuspendUser: {
          http: {
            requestUri: "/accounts/{accountId}/users?operation=suspend",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserIdList"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserIdList: {
                shape: "S1k"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserErrors: {
                shape: "S1m"
              }
            }
          }
        },
        BatchUnsuspendUser: {
          http: {
            requestUri: "/accounts/{accountId}/users?operation=unsuspend",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserIdList"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserIdList: {
                shape: "S1k"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserErrors: {
                shape: "S1m"
              }
            }
          }
        },
        BatchUpdatePhoneNumber: {
          http: {
            requestUri: "/phone-numbers?operation=batch-update",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "UpdatePhoneNumberRequestItems"
            ],
            members: {
              UpdatePhoneNumberRequestItems: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "PhoneNumberId"
                  ],
                  members: {
                    PhoneNumberId: {},
                    ProductType: {},
                    CallingName: {
                      shape: "S1u"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberErrors: {
                shape: "Sa"
              }
            }
          }
        },
        BatchUpdateUser: {
          http: {
            requestUri: "/accounts/{accountId}/users",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UpdateUserRequestItems"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UpdateUserRequestItems: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "UserId"
                  ],
                  members: {
                    UserId: {},
                    LicenseType: {},
                    UserType: {},
                    AlexaForBusinessMetadata: {
                      shape: "S21"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserErrors: {
                shape: "S1m"
              }
            }
          }
        },
        CreateAccount: {
          http: {
            requestUri: "/accounts",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Account: {
                shape: "S28"
              }
            }
          }
        },
        CreateAppInstance: {
          http: {
            requestUri: "/app-instances",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "ClientRequestToken"
            ],
            members: {
              Name: {
                shape: "S2e"
              },
              Metadata: {
                shape: "S2f"
              },
              ClientRequestToken: {
                shape: "S2g",
                idempotencyToken: true
              },
              Tags: {
                shape: "S2h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceArn: {}
            }
          },
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        CreateAppInstanceAdmin: {
          http: {
            requestUri: "/app-instances/{appInstanceArn}/admins",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceAdminArn",
              "AppInstanceArn"
            ],
            members: {
              AppInstanceAdminArn: {},
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceAdmin: {
                shape: "S14"
              },
              AppInstanceArn: {}
            }
          },
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        CreateAppInstanceUser: {
          http: {
            requestUri: "/app-instance-users",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "AppInstanceUserId",
              "Name",
              "ClientRequestToken"
            ],
            members: {
              AppInstanceArn: {},
              AppInstanceUserId: {
                type: "string",
                sensitive: true
              },
              Name: {
                shape: "S2n"
              },
              Metadata: {
                shape: "S2f"
              },
              ClientRequestToken: {
                shape: "S2g",
                idempotencyToken: true
              },
              Tags: {
                shape: "S2h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceUserArn: {}
            }
          },
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        CreateAttendee: {
          http: {
            requestUri: "/meetings/{meetingId}/attendees",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "ExternalUserId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              ExternalUserId: {
                shape: "Sn"
              },
              Tags: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attendee: {
                shape: "Su"
              }
            }
          }
        },
        CreateBot: {
          http: {
            requestUri: "/accounts/{accountId}/bots",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "DisplayName",
              "AccountId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              DisplayName: {
                shape: "S23"
              },
              Domain: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Bot: {
                shape: "S2t"
              }
            }
          }
        },
        CreateChannel: {
          http: {
            requestUri: "/channels",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "Name",
              "ClientRequestToken"
            ],
            members: {
              AppInstanceArn: {},
              Name: {
                shape: "S2e"
              },
              Mode: {},
              Privacy: {},
              Metadata: {
                shape: "S2f"
              },
              ClientRequestToken: {
                shape: "S2g",
                idempotencyToken: true
              },
              Tags: {
                shape: "S2h"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {}
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        CreateChannelBan: {
          http: {
            requestUri: "/channels/{channelArn}/bans",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {},
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              Member: {
                shape: "S14"
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        CreateChannelMembership: {
          http: {
            requestUri: "/channels/{channelArn}/memberships",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn",
              "Type"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {},
              Type: {},
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              Member: {
                shape: "S14"
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        CreateChannelModerator: {
          http: {
            requestUri: "/channels/{channelArn}/moderators",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChannelModeratorArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChannelModeratorArn: {},
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              ChannelModerator: {
                shape: "S14"
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        CreateMediaCapturePipeline: {
          http: {
            requestUri: "/media-capture-pipelines",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "SourceType",
              "SourceArn",
              "SinkType",
              "SinkArn"
            ],
            members: {
              SourceType: {},
              SourceArn: {
                shape: "S37"
              },
              SinkType: {},
              SinkArn: {
                shape: "S37"
              },
              ClientRequestToken: {
                shape: "S2g",
                idempotencyToken: true
              },
              ChimeSdkMeetingConfiguration: {
                shape: "S39"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MediaCapturePipeline: {
                shape: "S3n"
              }
            }
          }
        },
        CreateMeeting: {
          http: {
            requestUri: "/meetings",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ClientRequestToken"
            ],
            members: {
              ClientRequestToken: {
                shape: "S2g",
                idempotencyToken: true
              },
              ExternalMeetingId: {
                shape: "S3q"
              },
              MeetingHostId: {
                shape: "Sn"
              },
              MediaRegion: {},
              Tags: {
                shape: "S3r"
              },
              NotificationsConfiguration: {
                shape: "S3s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Meeting: {
                shape: "S3u"
              }
            }
          }
        },
        CreateMeetingDialOut: {
          http: {
            requestUri: "/meetings/{meetingId}/dial-outs",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "FromPhoneNumber",
              "ToPhoneNumber",
              "JoinToken"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              FromPhoneNumber: {
                shape: "S3"
              },
              ToPhoneNumber: {
                shape: "S3"
              },
              JoinToken: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransactionId: {}
            }
          }
        },
        CreateMeetingWithAttendees: {
          http: {
            requestUri: "/meetings?operation=create-attendees",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ClientRequestToken"
            ],
            members: {
              ClientRequestToken: {
                shape: "S2g",
                idempotencyToken: true
              },
              ExternalMeetingId: {
                shape: "S3q"
              },
              MeetingHostId: {
                shape: "Sn"
              },
              MediaRegion: {},
              Tags: {
                shape: "S3r"
              },
              NotificationsConfiguration: {
                shape: "S3s"
              },
              Attendees: {
                type: "list",
                member: {
                  shape: "Sm"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Meeting: {
                shape: "S3u"
              },
              Attendees: {
                shape: "St"
              },
              Errors: {
                shape: "Sw"
              }
            }
          }
        },
        CreatePhoneNumberOrder: {
          http: {
            requestUri: "/phone-number-orders",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ProductType",
              "E164PhoneNumbers"
            ],
            members: {
              ProductType: {},
              E164PhoneNumbers: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberOrder: {
                shape: "S44"
              }
            }
          }
        },
        CreateProxySession: {
          http: {
            requestUri: "/voice-connectors/{voiceConnectorId}/proxy-sessions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ParticipantPhoneNumbers",
              "Capabilities",
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              ParticipantPhoneNumbers: {
                type: "list",
                member: {
                  shape: "S3"
                }
              },
              Name: {
                type: "string",
                sensitive: true
              },
              ExpiryMinutes: {
                type: "integer"
              },
              Capabilities: {
                shape: "S4e"
              },
              NumberSelectionBehavior: {},
              GeoMatchLevel: {},
              GeoMatchParams: {
                shape: "S4i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProxySession: {
                shape: "S4m"
              }
            }
          }
        },
        CreateRoom: {
          http: {
            requestUri: "/accounts/{accountId}/rooms",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "Name"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              Name: {
                shape: "S23"
              },
              ClientRequestToken: {
                shape: "S2g",
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Room: {
                shape: "S4t"
              }
            }
          }
        },
        CreateRoomMembership: {
          http: {
            requestUri: "/accounts/{accountId}/rooms/{roomId}/memberships",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RoomId",
              "MemberId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              RoomId: {
                location: "uri",
                locationName: "roomId"
              },
              MemberId: {},
              Role: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RoomMembership: {
                shape: "S4w"
              }
            }
          }
        },
        CreateSipMediaApplication: {
          http: {
            requestUri: "/sip-media-applications",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AwsRegion",
              "Name",
              "Endpoints"
            ],
            members: {
              AwsRegion: {},
              Name: {},
              Endpoints: {
                shape: "S51"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplication: {
                shape: "S55"
              }
            }
          }
        },
        CreateSipMediaApplicationCall: {
          http: {
            requestUri: "/sip-media-applications/{sipMediaApplicationId}/calls",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "FromPhoneNumber",
              "ToPhoneNumber",
              "SipMediaApplicationId"
            ],
            members: {
              FromPhoneNumber: {
                shape: "S3"
              },
              ToPhoneNumber: {
                shape: "S3"
              },
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              },
              SipHeaders: {
                type: "map",
                key: {
                  shape: "S23"
                },
                value: {
                  shape: "S23"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplicationCall: {
                shape: "S59"
              }
            }
          }
        },
        CreateSipRule: {
          http: {
            requestUri: "/sip-rules",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "TriggerType",
              "TriggerValue",
              "TargetApplications"
            ],
            members: {
              Name: {},
              TriggerType: {},
              TriggerValue: {},
              Disabled: {
                type: "boolean"
              },
              TargetApplications: {
                shape: "S5d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipRule: {
                shape: "S5h"
              }
            }
          }
        },
        CreateUser: {
          http: {
            requestUri: "/accounts/{accountId}/users?operation=create",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              Username: {},
              Email: {
                shape: "S5j"
              },
              UserType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S5l"
              }
            }
          }
        },
        CreateVoiceConnector: {
          http: {
            requestUri: "/voice-connectors",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "RequireEncryption"
            ],
            members: {
              Name: {},
              AwsRegion: {},
              RequireEncryption: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnector: {
                shape: "S5s"
              }
            }
          }
        },
        CreateVoiceConnectorGroup: {
          http: {
            requestUri: "/voice-connector-groups",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              VoiceConnectorItems: {
                shape: "S5v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnectorGroup: {
                shape: "S5z"
              }
            }
          }
        },
        DeleteAccount: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{accountId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAppInstance: {
          http: {
            method: "DELETE",
            requestUri: "/app-instances/{appInstanceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        DeleteAppInstanceAdmin: {
          http: {
            method: "DELETE",
            requestUri: "/app-instances/{appInstanceArn}/admins/{appInstanceAdminArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceAdminArn",
              "AppInstanceArn"
            ],
            members: {
              AppInstanceAdminArn: {
                location: "uri",
                locationName: "appInstanceAdminArn"
              },
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        DeleteAppInstanceStreamingConfigurations: {
          http: {
            method: "DELETE",
            requestUri: "/app-instances/{appInstanceArn}/streaming-configurations",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          }
        },
        DeleteAppInstanceUser: {
          http: {
            method: "DELETE",
            requestUri: "/app-instance-users/{appInstanceUserArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceUserArn"
            ],
            members: {
              AppInstanceUserArn: {
                location: "uri",
                locationName: "appInstanceUserArn"
              }
            }
          },
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        DeleteAttendee: {
          http: {
            method: "DELETE",
            requestUri: "/meetings/{meetingId}/attendees/{attendeeId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "AttendeeId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              AttendeeId: {
                location: "uri",
                locationName: "attendeeId"
              }
            }
          }
        },
        DeleteChannel: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DeleteChannelBan: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}/bans/{memberArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {
                location: "uri",
                locationName: "memberArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DeleteChannelMembership: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}/memberships/{memberArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {
                location: "uri",
                locationName: "memberArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DeleteChannelMessage: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}/messages/{messageId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MessageId"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DeleteChannelModerator: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}/moderators/{channelModeratorArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChannelModeratorArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChannelModeratorArn: {
                location: "uri",
                locationName: "channelModeratorArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DeleteEventsConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{accountId}/bots/{botId}/events-configuration",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BotId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              BotId: {
                location: "uri",
                locationName: "botId"
              }
            }
          }
        },
        DeleteMediaCapturePipeline: {
          http: {
            method: "DELETE",
            requestUri: "/media-capture-pipelines/{mediaPipelineId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MediaPipelineId"
            ],
            members: {
              MediaPipelineId: {
                location: "uri",
                locationName: "mediaPipelineId"
              }
            }
          }
        },
        DeleteMeeting: {
          http: {
            method: "DELETE",
            requestUri: "/meetings/{meetingId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MeetingId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              }
            }
          }
        },
        DeletePhoneNumber: {
          http: {
            method: "DELETE",
            requestUri: "/phone-numbers/{phoneNumberId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberId"
            ],
            members: {
              PhoneNumberId: {
                location: "uri",
                locationName: "phoneNumberId"
              }
            }
          }
        },
        DeleteProxySession: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}/proxy-sessions/{proxySessionId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "ProxySessionId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              ProxySessionId: {
                location: "uri",
                locationName: "proxySessionId"
              }
            }
          }
        },
        DeleteRoom: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{accountId}/rooms/{roomId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RoomId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              RoomId: {
                location: "uri",
                locationName: "roomId"
              }
            }
          }
        },
        DeleteRoomMembership: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{accountId}/rooms/{roomId}/memberships/{memberId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RoomId",
              "MemberId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              RoomId: {
                location: "uri",
                locationName: "roomId"
              },
              MemberId: {
                location: "uri",
                locationName: "memberId"
              }
            }
          }
        },
        DeleteSipMediaApplication: {
          http: {
            method: "DELETE",
            requestUri: "/sip-media-applications/{sipMediaApplicationId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "SipMediaApplicationId"
            ],
            members: {
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              }
            }
          }
        },
        DeleteSipRule: {
          http: {
            method: "DELETE",
            requestUri: "/sip-rules/{sipRuleId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "SipRuleId"
            ],
            members: {
              SipRuleId: {
                location: "uri",
                locationName: "sipRuleId"
              }
            }
          }
        },
        DeleteVoiceConnector: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          }
        },
        DeleteVoiceConnectorEmergencyCallingConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}/emergency-calling-configuration",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          }
        },
        DeleteVoiceConnectorGroup: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connector-groups/{voiceConnectorGroupId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorGroupId"
            ],
            members: {
              VoiceConnectorGroupId: {
                location: "uri",
                locationName: "voiceConnectorGroupId"
              }
            }
          }
        },
        DeleteVoiceConnectorOrigination: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}/origination",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          }
        },
        DeleteVoiceConnectorProxy: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}/programmable-numbers/proxy",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          }
        },
        DeleteVoiceConnectorStreamingConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}/streaming-configuration",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          }
        },
        DeleteVoiceConnectorTermination: {
          http: {
            method: "DELETE",
            requestUri: "/voice-connectors/{voiceConnectorId}/termination",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          }
        },
        DeleteVoiceConnectorTerminationCredentials: {
          http: {
            requestUri: "/voice-connectors/{voiceConnectorId}/termination/credentials?operation=delete",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Usernames",
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              Usernames: {
                shape: "S6u"
              }
            }
          }
        },
        DescribeAppInstance: {
          http: {
            method: "GET",
            requestUri: "/app-instances/{appInstanceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstance: {
                type: "structure",
                members: {
                  AppInstanceArn: {},
                  Name: {
                    shape: "S2e"
                  },
                  Metadata: {
                    shape: "S2f"
                  },
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        DescribeAppInstanceAdmin: {
          http: {
            method: "GET",
            requestUri: "/app-instances/{appInstanceArn}/admins/{appInstanceAdminArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceAdminArn",
              "AppInstanceArn"
            ],
            members: {
              AppInstanceAdminArn: {
                location: "uri",
                locationName: "appInstanceAdminArn"
              },
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceAdmin: {
                type: "structure",
                members: {
                  Admin: {
                    shape: "S14"
                  },
                  AppInstanceArn: {},
                  CreatedTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        DescribeAppInstanceUser: {
          http: {
            method: "GET",
            requestUri: "/app-instance-users/{appInstanceUserArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceUserArn"
            ],
            members: {
              AppInstanceUserArn: {
                location: "uri",
                locationName: "appInstanceUserArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceUser: {
                type: "structure",
                members: {
                  AppInstanceUserArn: {},
                  Name: {
                    shape: "S2n"
                  },
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  Metadata: {
                    shape: "S2f"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        DescribeChannel: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channel: {
                type: "structure",
                members: {
                  Name: {
                    shape: "S2e"
                  },
                  ChannelArn: {},
                  Mode: {},
                  Privacy: {},
                  Metadata: {
                    shape: "S2f"
                  },
                  CreatedBy: {
                    shape: "S14"
                  },
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastMessageTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DescribeChannelBan: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/bans/{memberArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {
                location: "uri",
                locationName: "memberArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelBan: {
                type: "structure",
                members: {
                  Member: {
                    shape: "S14"
                  },
                  ChannelArn: {},
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  CreatedBy: {
                    shape: "S14"
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DescribeChannelMembership: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/memberships/{memberArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {
                location: "uri",
                locationName: "memberArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelMembership: {
                type: "structure",
                members: {
                  InvitedBy: {
                    shape: "S14"
                  },
                  Type: {},
                  Member: {
                    shape: "S14"
                  },
                  ChannelArn: {},
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DescribeChannelMembershipForAppInstanceUser: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}?scope=app-instance-user-membership",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "AppInstanceUserArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              AppInstanceUserArn: {
                location: "querystring",
                locationName: "app-instance-user-arn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelMembership: {
                shape: "S7g"
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DescribeChannelModeratedByAppInstanceUser: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}?scope=app-instance-user-moderated-channel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "AppInstanceUserArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              AppInstanceUserArn: {
                location: "querystring",
                locationName: "app-instance-user-arn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channel: {
                shape: "S7l"
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DescribeChannelModerator: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/moderators/{channelModeratorArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChannelModeratorArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChannelModeratorArn: {
                location: "uri",
                locationName: "channelModeratorArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelModerator: {
                type: "structure",
                members: {
                  Moderator: {
                    shape: "S14"
                  },
                  ChannelArn: {},
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  CreatedBy: {
                    shape: "S14"
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        DisassociatePhoneNumberFromUser: {
          http: {
            requestUri: "/accounts/{accountId}/users/{userId}?operation=disassociate-phone-number",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserId: {
                location: "uri",
                locationName: "userId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociatePhoneNumbersFromVoiceConnector: {
          http: {
            requestUri: "/voice-connectors/{voiceConnectorId}?operation=disassociate-phone-numbers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "E164PhoneNumbers"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              E164PhoneNumbers: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberErrors: {
                shape: "Sa"
              }
            }
          }
        },
        DisassociatePhoneNumbersFromVoiceConnectorGroup: {
          http: {
            requestUri: "/voice-connector-groups/{voiceConnectorGroupId}?operation=disassociate-phone-numbers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorGroupId",
              "E164PhoneNumbers"
            ],
            members: {
              VoiceConnectorGroupId: {
                location: "uri",
                locationName: "voiceConnectorGroupId"
              },
              E164PhoneNumbers: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberErrors: {
                shape: "Sa"
              }
            }
          }
        },
        DisassociateSigninDelegateGroupsFromAccount: {
          http: {
            requestUri: "/accounts/{accountId}?operation=disassociate-signin-delegate-groups",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "GroupNames"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              GroupNames: {
                shape: "S1h"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAccount: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Account: {
                shape: "S28"
              }
            }
          }
        },
        GetAccountSettings: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/settings"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccountSettings: {
                shape: "S81"
              }
            }
          }
        },
        GetAppInstanceRetentionSettings: {
          http: {
            method: "GET",
            requestUri: "/app-instances/{appInstanceArn}/retention-settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceRetentionSettings: {
                shape: "S84"
              },
              InitiateDeletionTimestamp: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        GetAppInstanceStreamingConfigurations: {
          http: {
            method: "GET",
            requestUri: "/app-instances/{appInstanceArn}/streaming-configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceStreamingConfigurations: {
                shape: "S89"
              }
            }
          }
        },
        GetAttendee: {
          http: {
            method: "GET",
            requestUri: "/meetings/{meetingId}/attendees/{attendeeId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "AttendeeId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              AttendeeId: {
                location: "uri",
                locationName: "attendeeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attendee: {
                shape: "Su"
              }
            }
          }
        },
        GetBot: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/bots/{botId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BotId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              BotId: {
                location: "uri",
                locationName: "botId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Bot: {
                shape: "S2t"
              }
            }
          }
        },
        GetChannelMessage: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/messages/{messageId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MessageId"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelMessage: {
                type: "structure",
                members: {
                  ChannelArn: {},
                  MessageId: {},
                  Content: {
                    shape: "S8j"
                  },
                  Metadata: {
                    shape: "S2f"
                  },
                  Type: {},
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastEditedTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  },
                  Sender: {
                    shape: "S14"
                  },
                  Redacted: {
                    type: "boolean"
                  },
                  Persistence: {}
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        GetEventsConfiguration: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/bots/{botId}/events-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BotId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              BotId: {
                location: "uri",
                locationName: "botId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventsConfiguration: {
                shape: "S8p"
              }
            }
          }
        },
        GetGlobalSettings: {
          http: {
            method: "GET",
            requestUri: "/settings",
            responseCode: 200
          },
          output: {
            type: "structure",
            members: {
              BusinessCalling: {
                shape: "S8r"
              },
              VoiceConnector: {
                shape: "S8s"
              }
            }
          }
        },
        GetMediaCapturePipeline: {
          http: {
            method: "GET",
            requestUri: "/media-capture-pipelines/{mediaPipelineId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MediaPipelineId"
            ],
            members: {
              MediaPipelineId: {
                location: "uri",
                locationName: "mediaPipelineId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MediaCapturePipeline: {
                shape: "S3n"
              }
            }
          }
        },
        GetMeeting: {
          http: {
            method: "GET",
            requestUri: "/meetings/{meetingId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MeetingId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Meeting: {
                shape: "S3u"
              }
            }
          }
        },
        GetMessagingSessionEndpoint: {
          http: {
            method: "GET",
            requestUri: "/endpoints/messaging-session",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Endpoint: {
                type: "structure",
                members: {
                  Url: {}
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        GetPhoneNumber: {
          http: {
            method: "GET",
            requestUri: "/phone-numbers/{phoneNumberId}"
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberId"
            ],
            members: {
              PhoneNumberId: {
                location: "uri",
                locationName: "phoneNumberId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumber: {
                shape: "S93"
              }
            }
          }
        },
        GetPhoneNumberOrder: {
          http: {
            method: "GET",
            requestUri: "/phone-number-orders/{phoneNumberOrderId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberOrderId"
            ],
            members: {
              PhoneNumberOrderId: {
                location: "uri",
                locationName: "phoneNumberOrderId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberOrder: {
                shape: "S44"
              }
            }
          }
        },
        GetPhoneNumberSettings: {
          http: {
            method: "GET",
            requestUri: "/settings/phone-number",
            responseCode: 200
          },
          output: {
            type: "structure",
            members: {
              CallingName: {
                shape: "S1u"
              },
              CallingNameUpdatedTimestamp: {
                shape: "S2a"
              }
            }
          }
        },
        GetProxySession: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/proxy-sessions/{proxySessionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "ProxySessionId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              ProxySessionId: {
                location: "uri",
                locationName: "proxySessionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProxySession: {
                shape: "S4m"
              }
            }
          }
        },
        GetRetentionSettings: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/retention-settings"
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RetentionSettings: {
                shape: "S9j"
              },
              InitiateDeletionTimestamp: {
                shape: "S2a"
              }
            }
          }
        },
        GetRoom: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/rooms/{roomId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RoomId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              RoomId: {
                location: "uri",
                locationName: "roomId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Room: {
                shape: "S4t"
              }
            }
          }
        },
        GetSipMediaApplication: {
          http: {
            method: "GET",
            requestUri: "/sip-media-applications/{sipMediaApplicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SipMediaApplicationId"
            ],
            members: {
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplication: {
                shape: "S55"
              }
            }
          }
        },
        GetSipMediaApplicationLoggingConfiguration: {
          http: {
            method: "GET",
            requestUri: "/sip-media-applications/{sipMediaApplicationId}/logging-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SipMediaApplicationId"
            ],
            members: {
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplicationLoggingConfiguration: {
                shape: "S9s"
              }
            }
          }
        },
        GetSipRule: {
          http: {
            method: "GET",
            requestUri: "/sip-rules/{sipRuleId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SipRuleId"
            ],
            members: {
              SipRuleId: {
                location: "uri",
                locationName: "sipRuleId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipRule: {
                shape: "S5h"
              }
            }
          }
        },
        GetUser: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/users/{userId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserId: {
                location: "uri",
                locationName: "userId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S5l"
              }
            }
          }
        },
        GetUserSettings: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/users/{userId}/settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserId: {
                location: "uri",
                locationName: "userId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserSettings: {
                shape: "S9z"
              }
            }
          }
        },
        GetVoiceConnector: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnector: {
                shape: "S5s"
              }
            }
          }
        },
        GetVoiceConnectorEmergencyCallingConfiguration: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/emergency-calling-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EmergencyCallingConfiguration: {
                shape: "Sa5"
              }
            }
          }
        },
        GetVoiceConnectorGroup: {
          http: {
            method: "GET",
            requestUri: "/voice-connector-groups/{voiceConnectorGroupId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorGroupId"
            ],
            members: {
              VoiceConnectorGroupId: {
                location: "uri",
                locationName: "voiceConnectorGroupId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnectorGroup: {
                shape: "S5z"
              }
            }
          }
        },
        GetVoiceConnectorLoggingConfiguration: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/logging-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfiguration: {
                shape: "Sac"
              }
            }
          }
        },
        GetVoiceConnectorOrigination: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/origination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Origination: {
                shape: "Saf"
              }
            }
          }
        },
        GetVoiceConnectorProxy: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/programmable-numbers/proxy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Proxy: {
                shape: "Sao"
              }
            }
          }
        },
        GetVoiceConnectorStreamingConfiguration: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/streaming-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingConfiguration: {
                shape: "Sat"
              }
            }
          }
        },
        GetVoiceConnectorTermination: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/termination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Termination: {
                shape: "Sb0"
              }
            }
          }
        },
        GetVoiceConnectorTerminationHealth: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/termination/health",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TerminationHealth: {
                type: "structure",
                members: {
                  Timestamp: {
                    shape: "S2a"
                  },
                  Source: {}
                }
              }
            }
          }
        },
        InviteUsers: {
          http: {
            requestUri: "/accounts/{accountId}/users?operation=add",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserEmailList"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserEmailList: {
                type: "list",
                member: {
                  shape: "S5j"
                }
              },
              UserType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Invites: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InviteId: {},
                    Status: {},
                    EmailAddress: {
                      shape: "S5j"
                    },
                    EmailStatus: {}
                  }
                }
              }
            }
          }
        },
        ListAccounts: {
          http: {
            method: "GET",
            requestUri: "/accounts"
          },
          input: {
            type: "structure",
            members: {
              Name: {
                location: "querystring",
                locationName: "name"
              },
              UserEmail: {
                shape: "S5j",
                location: "querystring",
                locationName: "user-email"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Accounts: {
                type: "list",
                member: {
                  shape: "S28"
                }
              },
              NextToken: {}
            }
          }
        },
        ListAppInstanceAdmins: {
          http: {
            method: "GET",
            requestUri: "/app-instances/{appInstanceArn}/admins",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "Sbj",
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceArn: {},
              AppInstanceAdmins: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Admin: {
                      shape: "S14"
                    }
                  }
                }
              },
              NextToken: {
                shape: "Sbj"
              }
            }
          },
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        ListAppInstanceUsers: {
          http: {
            method: "GET",
            requestUri: "/app-instance-users",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "querystring",
                locationName: "app-instance-arn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "Sbj",
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceArn: {},
              AppInstanceUsers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AppInstanceUserArn: {},
                    Name: {
                      shape: "S2n"
                    },
                    Metadata: {
                      shape: "S2f"
                    }
                  }
                }
              },
              NextToken: {
                shape: "Sbj"
              }
            }
          },
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        ListAppInstances: {
          http: {
            method: "GET",
            requestUri: "/app-instances",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "Sbj",
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AppInstanceArn: {},
                    Name: {
                      shape: "S2e"
                    },
                    Metadata: {
                      shape: "S2f"
                    }
                  }
                }
              },
              NextToken: {
                shape: "Sbj"
              }
            }
          },
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        ListAttendeeTags: {
          http: {
            method: "GET",
            requestUri: "/meetings/{meetingId}/attendees/{attendeeId}/tags",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "AttendeeId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              AttendeeId: {
                location: "uri",
                locationName: "attendeeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S2h"
              }
            }
          }
        },
        ListAttendees: {
          http: {
            method: "GET",
            requestUri: "/meetings/{meetingId}/attendees",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MeetingId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Attendees: {
                shape: "St"
              },
              NextToken: {}
            }
          }
        },
        ListBots: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/bots",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Bots: {
                type: "list",
                member: {
                  shape: "S2t"
                }
              },
              NextToken: {}
            }
          }
        },
        ListChannelBans: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/bans",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "Sbj",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              NextToken: {
                shape: "Sbj"
              },
              ChannelBans: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Member: {
                      shape: "S14"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        ListChannelMemberships: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/memberships",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              Type: {
                location: "querystring",
                locationName: "type"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "Sbj",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              ChannelMemberships: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Member: {
                      shape: "S14"
                    }
                  }
                }
              },
              NextToken: {
                shape: "Sbj"
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        ListChannelMembershipsForAppInstanceUser: {
          http: {
            method: "GET",
            requestUri: "/channels?scope=app-instance-user-memberships",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppInstanceUserArn: {
                location: "querystring",
                locationName: "app-instance-user-arn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "Sbj",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelMemberships: {
                type: "list",
                member: {
                  shape: "S7g"
                }
              },
              NextToken: {
                shape: "Sbj"
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        ListChannelMessages: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/messages",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              SortOrder: {
                location: "querystring",
                locationName: "sort-order"
              },
              NotBefore: {
                location: "querystring",
                locationName: "not-before",
                type: "timestamp"
              },
              NotAfter: {
                location: "querystring",
                locationName: "not-after",
                type: "timestamp"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "Sbj",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              NextToken: {
                shape: "Sbj"
              },
              ChannelMessages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MessageId: {},
                    Content: {
                      shape: "S8j"
                    },
                    Metadata: {
                      shape: "S2f"
                    },
                    Type: {},
                    CreatedTimestamp: {
                      type: "timestamp"
                    },
                    LastUpdatedTimestamp: {
                      type: "timestamp"
                    },
                    LastEditedTimestamp: {
                      type: "timestamp"
                    },
                    Sender: {
                      shape: "S14"
                    },
                    Redacted: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        ListChannelModerators: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/moderators",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "Sbj",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              NextToken: {
                shape: "Sbj"
              },
              ChannelModerators: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Moderator: {
                      shape: "S14"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        ListChannels: {
          http: {
            method: "GET",
            requestUri: "/channels",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "querystring",
                locationName: "app-instance-arn"
              },
              Privacy: {
                location: "querystring",
                locationName: "privacy"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "Sbj",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channels: {
                type: "list",
                member: {
                  shape: "S7h"
                }
              },
              NextToken: {
                shape: "Sbj"
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        ListChannelsModeratedByAppInstanceUser: {
          http: {
            method: "GET",
            requestUri: "/channels?scope=app-instance-user-moderated-channels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppInstanceUserArn: {
                location: "querystring",
                locationName: "app-instance-user-arn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "Sbj",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channels: {
                type: "list",
                member: {
                  shape: "S7l"
                }
              },
              NextToken: {
                shape: "Sbj"
              }
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        ListMediaCapturePipelines: {
          http: {
            method: "GET",
            requestUri: "/media-capture-pipelines",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MediaCapturePipelines: {
                type: "list",
                member: {
                  shape: "S3n"
                }
              },
              NextToken: {}
            }
          }
        },
        ListMeetingTags: {
          http: {
            method: "GET",
            requestUri: "/meetings/{meetingId}/tags",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MeetingId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S2h"
              }
            }
          }
        },
        ListMeetings: {
          http: {
            method: "GET",
            requestUri: "/meetings",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Meetings: {
                type: "list",
                member: {
                  shape: "S3u"
                }
              },
              NextToken: {}
            }
          }
        },
        ListPhoneNumberOrders: {
          http: {
            method: "GET",
            requestUri: "/phone-number-orders",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberOrders: {
                type: "list",
                member: {
                  shape: "S44"
                }
              },
              NextToken: {}
            }
          }
        },
        ListPhoneNumbers: {
          http: {
            method: "GET",
            requestUri: "/phone-numbers"
          },
          input: {
            type: "structure",
            members: {
              Status: {
                location: "querystring",
                locationName: "status"
              },
              ProductType: {
                location: "querystring",
                locationName: "product-type"
              },
              FilterName: {
                location: "querystring",
                locationName: "filter-name"
              },
              FilterValue: {
                location: "querystring",
                locationName: "filter-value"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumbers: {
                type: "list",
                member: {
                  shape: "S93"
                }
              },
              NextToken: {}
            }
          }
        },
        ListProxySessions: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/proxy-sessions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              Status: {
                location: "querystring",
                locationName: "status"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProxySessions: {
                type: "list",
                member: {
                  shape: "S4m"
                }
              },
              NextToken: {}
            }
          }
        },
        ListRoomMemberships: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/rooms/{roomId}/memberships",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RoomId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              RoomId: {
                location: "uri",
                locationName: "roomId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RoomMemberships: {
                type: "list",
                member: {
                  shape: "S4w"
                }
              },
              NextToken: {}
            }
          }
        },
        ListRooms: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/rooms",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              MemberId: {
                location: "querystring",
                locationName: "member-id"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rooms: {
                type: "list",
                member: {
                  shape: "S4t"
                }
              },
              NextToken: {}
            }
          }
        },
        ListSipMediaApplications: {
          http: {
            method: "GET",
            requestUri: "/sip-media-applications",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplications: {
                type: "list",
                member: {
                  shape: "S55"
                }
              },
              NextToken: {}
            }
          }
        },
        ListSipRules: {
          http: {
            method: "GET",
            requestUri: "/sip-rules",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              SipMediaApplicationId: {
                location: "querystring",
                locationName: "sip-media-application"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipRules: {
                type: "list",
                member: {
                  shape: "S5h"
                }
              },
              NextToken: {}
            }
          }
        },
        ListSupportedPhoneNumberCountries: {
          http: {
            method: "GET",
            requestUri: "/phone-number-countries",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ProductType"
            ],
            members: {
              ProductType: {
                location: "querystring",
                locationName: "product-type"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumberCountries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CountryCode: {},
                    SupportedPhoneNumberTypes: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {
                shape: "S37",
                location: "querystring",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S2h"
              }
            }
          }
        },
        ListUsers: {
          http: {
            method: "GET",
            requestUri: "/accounts/{accountId}/users",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserEmail: {
                shape: "S5j",
                location: "querystring",
                locationName: "user-email"
              },
              UserType: {
                location: "querystring",
                locationName: "user-type"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Users: {
                type: "list",
                member: {
                  shape: "S5l"
                }
              },
              NextToken: {}
            }
          }
        },
        ListVoiceConnectorGroups: {
          http: {
            method: "GET",
            requestUri: "/voice-connector-groups",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnectorGroups: {
                type: "list",
                member: {
                  shape: "S5z"
                }
              },
              NextToken: {}
            }
          }
        },
        ListVoiceConnectorTerminationCredentials: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors/{voiceConnectorId}/termination/credentials",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Usernames: {
                shape: "S6u"
              }
            }
          }
        },
        ListVoiceConnectors: {
          http: {
            method: "GET",
            requestUri: "/voice-connectors",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnectors: {
                type: "list",
                member: {
                  shape: "S5s"
                }
              },
              NextToken: {}
            }
          }
        },
        LogoutUser: {
          http: {
            requestUri: "/accounts/{accountId}/users/{userId}?operation=logout",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserId: {
                location: "uri",
                locationName: "userId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutAppInstanceRetentionSettings: {
          http: {
            method: "PUT",
            requestUri: "/app-instances/{appInstanceArn}/retention-settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "AppInstanceRetentionSettings"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              },
              AppInstanceRetentionSettings: {
                shape: "S84"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceRetentionSettings: {
                shape: "S84"
              },
              InitiateDeletionTimestamp: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        PutAppInstanceStreamingConfigurations: {
          http: {
            method: "PUT",
            requestUri: "/app-instances/{appInstanceArn}/streaming-configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "AppInstanceStreamingConfigurations"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              },
              AppInstanceStreamingConfigurations: {
                shape: "S89"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceStreamingConfigurations: {
                shape: "S89"
              }
            }
          }
        },
        PutEventsConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{accountId}/bots/{botId}/events-configuration",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BotId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              BotId: {
                location: "uri",
                locationName: "botId"
              },
              OutboundEventsHTTPSEndpoint: {
                shape: "S23"
              },
              LambdaFunctionArn: {
                shape: "S23"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventsConfiguration: {
                shape: "S8p"
              }
            }
          }
        },
        PutRetentionSettings: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{accountId}/retention-settings",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RetentionSettings"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              RetentionSettings: {
                shape: "S9j"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RetentionSettings: {
                shape: "S9j"
              },
              InitiateDeletionTimestamp: {
                shape: "S2a"
              }
            }
          }
        },
        PutSipMediaApplicationLoggingConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/sip-media-applications/{sipMediaApplicationId}/logging-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SipMediaApplicationId"
            ],
            members: {
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              },
              SipMediaApplicationLoggingConfiguration: {
                shape: "S9s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplicationLoggingConfiguration: {
                shape: "S9s"
              }
            }
          }
        },
        PutVoiceConnectorEmergencyCallingConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}/emergency-calling-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "EmergencyCallingConfiguration"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              EmergencyCallingConfiguration: {
                shape: "Sa5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EmergencyCallingConfiguration: {
                shape: "Sa5"
              }
            }
          }
        },
        PutVoiceConnectorLoggingConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}/logging-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "LoggingConfiguration"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              LoggingConfiguration: {
                shape: "Sac"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfiguration: {
                shape: "Sac"
              }
            }
          }
        },
        PutVoiceConnectorOrigination: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}/origination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "Origination"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              Origination: {
                shape: "Saf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Origination: {
                shape: "Saf"
              }
            }
          }
        },
        PutVoiceConnectorProxy: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}/programmable-numbers/proxy"
          },
          input: {
            type: "structure",
            required: [
              "DefaultSessionExpiryMinutes",
              "PhoneNumberPoolCountries",
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              DefaultSessionExpiryMinutes: {
                type: "integer"
              },
              PhoneNumberPoolCountries: {
                type: "list",
                member: {}
              },
              FallBackPhoneNumber: {
                shape: "S3"
              },
              Disabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Proxy: {
                shape: "Sao"
              }
            }
          }
        },
        PutVoiceConnectorStreamingConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}/streaming-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "StreamingConfiguration"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              StreamingConfiguration: {
                shape: "Sat"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamingConfiguration: {
                shape: "Sat"
              }
            }
          }
        },
        PutVoiceConnectorTermination: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}/termination",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "Termination"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              Termination: {
                shape: "Sb0"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Termination: {
                shape: "Sb0"
              }
            }
          }
        },
        PutVoiceConnectorTerminationCredentials: {
          http: {
            requestUri: "/voice-connectors/{voiceConnectorId}/termination/credentials?operation=put",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              Credentials: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Username: {
                      shape: "S23"
                    },
                    Password: {
                      shape: "S23"
                    }
                  }
                }
              }
            }
          }
        },
        RedactChannelMessage: {
          http: {
            requestUri: "/channels/{channelArn}/messages/{messageId}?operation=redact",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MessageId"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              MessageId: {}
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        RedactConversationMessage: {
          http: {
            requestUri: "/accounts/{accountId}/conversations/{conversationId}/messages/{messageId}?operation=redact",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "ConversationId",
              "MessageId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              ConversationId: {
                location: "uri",
                locationName: "conversationId"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RedactRoomMessage: {
          http: {
            requestUri: "/accounts/{accountId}/rooms/{roomId}/messages/{messageId}?operation=redact",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RoomId",
              "MessageId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              RoomId: {
                location: "uri",
                locationName: "roomId"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RegenerateSecurityToken: {
          http: {
            requestUri: "/accounts/{accountId}/bots/{botId}?operation=regenerate-security-token",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BotId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              BotId: {
                location: "uri",
                locationName: "botId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Bot: {
                shape: "S2t"
              }
            }
          }
        },
        ResetPersonalPIN: {
          http: {
            requestUri: "/accounts/{accountId}/users/{userId}?operation=reset-personal-pin",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserId: {
                location: "uri",
                locationName: "userId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S5l"
              }
            }
          }
        },
        RestorePhoneNumber: {
          http: {
            requestUri: "/phone-numbers/{phoneNumberId}?operation=restore",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberId"
            ],
            members: {
              PhoneNumberId: {
                location: "uri",
                locationName: "phoneNumberId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumber: {
                shape: "S93"
              }
            }
          }
        },
        SearchAvailablePhoneNumbers: {
          http: {
            method: "GET",
            requestUri: "/search?type=phone-numbers"
          },
          input: {
            type: "structure",
            members: {
              AreaCode: {
                location: "querystring",
                locationName: "area-code"
              },
              City: {
                location: "querystring",
                locationName: "city"
              },
              Country: {
                location: "querystring",
                locationName: "country"
              },
              State: {
                location: "querystring",
                locationName: "state"
              },
              TollFreePrefix: {
                location: "querystring",
                locationName: "toll-free-prefix"
              },
              PhoneNumberType: {
                location: "querystring",
                locationName: "phone-number-type"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              E164PhoneNumbers: {
                shape: "S7"
              },
              NextToken: {}
            }
          }
        },
        SendChannelMessage: {
          http: {
            requestUri: "/channels/{channelArn}/messages",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "Content",
              "Type",
              "Persistence",
              "ClientRequestToken"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              Content: {
                type: "string",
                sensitive: true
              },
              Type: {},
              Persistence: {},
              Metadata: {
                shape: "S2f"
              },
              ClientRequestToken: {
                shape: "S2g",
                idempotencyToken: true
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              MessageId: {}
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        StartMeetingTranscription: {
          http: {
            requestUri: "/meetings/{meetingId}/transcription?operation=start",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "TranscriptionConfiguration"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              TranscriptionConfiguration: {
                type: "structure",
                members: {
                  EngineTranscribeSettings: {
                    type: "structure",
                    required: [
                      "LanguageCode"
                    ],
                    members: {
                      LanguageCode: {},
                      VocabularyFilterMethod: {},
                      VocabularyFilterName: {},
                      VocabularyName: {},
                      Region: {}
                    }
                  },
                  EngineTranscribeMedicalSettings: {
                    type: "structure",
                    required: [
                      "LanguageCode",
                      "Specialty",
                      "Type"
                    ],
                    members: {
                      LanguageCode: {},
                      Specialty: {},
                      Type: {},
                      VocabularyName: {},
                      Region: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopMeetingTranscription: {
          http: {
            requestUri: "/meetings/{meetingId}/transcription?operation=stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MeetingId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagAttendee: {
          http: {
            requestUri: "/meetings/{meetingId}/attendees/{attendeeId}/tags?operation=add",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "AttendeeId",
              "Tags"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              AttendeeId: {
                location: "uri",
                locationName: "attendeeId"
              },
              Tags: {
                shape: "So"
              }
            }
          }
        },
        TagMeeting: {
          http: {
            requestUri: "/meetings/{meetingId}/tags?operation=add",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "Tags"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              Tags: {
                shape: "S3r"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags?operation=tag-resource",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {
                shape: "S37"
              },
              Tags: {
                shape: "S2h"
              }
            }
          }
        },
        UntagAttendee: {
          http: {
            requestUri: "/meetings/{meetingId}/attendees/{attendeeId}/tags?operation=delete",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "TagKeys",
              "AttendeeId"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              AttendeeId: {
                location: "uri",
                locationName: "attendeeId"
              },
              TagKeys: {
                type: "list",
                member: {
                  shape: "Sq"
                }
              }
            }
          }
        },
        UntagMeeting: {
          http: {
            requestUri: "/meetings/{meetingId}/tags?operation=delete",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "MeetingId",
              "TagKeys"
            ],
            members: {
              MeetingId: {
                location: "uri",
                locationName: "meetingId"
              },
              TagKeys: {
                type: "list",
                member: {
                  shape: "Sq"
                }
              }
            }
          }
        },
        UntagResource: {
          http: {
            requestUri: "/tags?operation=untag-resource",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {
                shape: "S37"
              },
              TagKeys: {
                type: "list",
                member: {
                  shape: "Sq"
                }
              }
            }
          }
        },
        UpdateAccount: {
          http: {
            requestUri: "/accounts/{accountId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              Name: {},
              DefaultLicense: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Account: {
                shape: "S28"
              }
            }
          }
        },
        UpdateAccountSettings: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{accountId}/settings",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "AccountSettings"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              AccountSettings: {
                shape: "S81"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAppInstance: {
          http: {
            method: "PUT",
            requestUri: "/app-instances/{appInstanceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "Name"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              },
              Name: {
                shape: "S2e"
              },
              Metadata: {
                shape: "S2f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceArn: {}
            }
          },
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        UpdateAppInstanceUser: {
          http: {
            method: "PUT",
            requestUri: "/app-instance-users/{appInstanceUserArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceUserArn",
              "Name"
            ],
            members: {
              AppInstanceUserArn: {
                location: "uri",
                locationName: "appInstanceUserArn"
              },
              Name: {
                shape: "S2n"
              },
              Metadata: {
                shape: "S2f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceUserArn: {}
            }
          },
          endpoint: {
            hostPrefix: "identity-"
          }
        },
        UpdateBot: {
          http: {
            requestUri: "/accounts/{accountId}/bots/{botId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "BotId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              BotId: {
                location: "uri",
                locationName: "botId"
              },
              Disabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Bot: {
                shape: "S2t"
              }
            }
          }
        },
        UpdateChannel: {
          http: {
            method: "PUT",
            requestUri: "/channels/{channelArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "Name",
              "Mode"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              Name: {
                shape: "S2e"
              },
              Mode: {},
              Metadata: {
                shape: "S2f"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {}
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        UpdateChannelMessage: {
          http: {
            method: "PUT",
            requestUri: "/channels/{channelArn}/messages/{messageId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MessageId"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              },
              Content: {
                shape: "S8j"
              },
              Metadata: {
                shape: "S2f"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              MessageId: {}
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        UpdateChannelReadMarker: {
          http: {
            method: "PUT",
            requestUri: "/channels/{channelArn}/readMarker",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {}
            }
          },
          endpoint: {
            hostPrefix: "messaging-"
          }
        },
        UpdateGlobalSettings: {
          http: {
            method: "PUT",
            requestUri: "/settings",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              BusinessCalling: {
                shape: "S8r"
              },
              VoiceConnector: {
                shape: "S8s"
              }
            }
          }
        },
        UpdatePhoneNumber: {
          http: {
            requestUri: "/phone-numbers/{phoneNumberId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PhoneNumberId"
            ],
            members: {
              PhoneNumberId: {
                location: "uri",
                locationName: "phoneNumberId"
              },
              ProductType: {},
              CallingName: {
                shape: "S1u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PhoneNumber: {
                shape: "S93"
              }
            }
          }
        },
        UpdatePhoneNumberSettings: {
          http: {
            method: "PUT",
            requestUri: "/settings/phone-number",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "CallingName"
            ],
            members: {
              CallingName: {
                shape: "S1u"
              }
            }
          }
        },
        UpdateProxySession: {
          http: {
            requestUri: "/voice-connectors/{voiceConnectorId}/proxy-sessions/{proxySessionId}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Capabilities",
              "VoiceConnectorId",
              "ProxySessionId"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              ProxySessionId: {
                location: "uri",
                locationName: "proxySessionId"
              },
              Capabilities: {
                shape: "S4e"
              },
              ExpiryMinutes: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProxySession: {
                shape: "S4m"
              }
            }
          }
        },
        UpdateRoom: {
          http: {
            requestUri: "/accounts/{accountId}/rooms/{roomId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RoomId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              RoomId: {
                location: "uri",
                locationName: "roomId"
              },
              Name: {
                shape: "S23"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Room: {
                shape: "S4t"
              }
            }
          }
        },
        UpdateRoomMembership: {
          http: {
            requestUri: "/accounts/{accountId}/rooms/{roomId}/memberships/{memberId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "RoomId",
              "MemberId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              RoomId: {
                location: "uri",
                locationName: "roomId"
              },
              MemberId: {
                location: "uri",
                locationName: "memberId"
              },
              Role: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RoomMembership: {
                shape: "S4w"
              }
            }
          }
        },
        UpdateSipMediaApplication: {
          http: {
            method: "PUT",
            requestUri: "/sip-media-applications/{sipMediaApplicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "SipMediaApplicationId"
            ],
            members: {
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              },
              Name: {},
              Endpoints: {
                shape: "S51"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplication: {
                shape: "S55"
              }
            }
          }
        },
        UpdateSipMediaApplicationCall: {
          http: {
            requestUri: "/sip-media-applications/{sipMediaApplicationId}/calls/{transactionId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "SipMediaApplicationId",
              "TransactionId",
              "Arguments"
            ],
            members: {
              SipMediaApplicationId: {
                location: "uri",
                locationName: "sipMediaApplicationId"
              },
              TransactionId: {
                location: "uri",
                locationName: "transactionId"
              },
              Arguments: {
                type: "map",
                key: {
                  shape: "S23"
                },
                value: {
                  shape: "S23"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipMediaApplicationCall: {
                shape: "S59"
              }
            }
          }
        },
        UpdateSipRule: {
          http: {
            method: "PUT",
            requestUri: "/sip-rules/{sipRuleId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "SipRuleId",
              "Name"
            ],
            members: {
              SipRuleId: {
                location: "uri",
                locationName: "sipRuleId"
              },
              Name: {},
              Disabled: {
                type: "boolean"
              },
              TargetApplications: {
                shape: "S5d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SipRule: {
                shape: "S5h"
              }
            }
          }
        },
        UpdateUser: {
          http: {
            requestUri: "/accounts/{accountId}/users/{userId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserId"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserId: {
                location: "uri",
                locationName: "userId"
              },
              LicenseType: {},
              UserType: {},
              AlexaForBusinessMetadata: {
                shape: "S21"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S5l"
              }
            }
          }
        },
        UpdateUserSettings: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{accountId}/users/{userId}/settings",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AccountId",
              "UserId",
              "UserSettings"
            ],
            members: {
              AccountId: {
                location: "uri",
                locationName: "accountId"
              },
              UserId: {
                location: "uri",
                locationName: "userId"
              },
              UserSettings: {
                shape: "S9z"
              }
            }
          }
        },
        UpdateVoiceConnector: {
          http: {
            method: "PUT",
            requestUri: "/voice-connectors/{voiceConnectorId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "Name",
              "RequireEncryption"
            ],
            members: {
              VoiceConnectorId: {
                location: "uri",
                locationName: "voiceConnectorId"
              },
              Name: {},
              RequireEncryption: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnector: {
                shape: "S5s"
              }
            }
          }
        },
        UpdateVoiceConnectorGroup: {
          http: {
            method: "PUT",
            requestUri: "/voice-connector-groups/{voiceConnectorGroupId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "VoiceConnectorGroupId",
              "Name",
              "VoiceConnectorItems"
            ],
            members: {
              VoiceConnectorGroupId: {
                location: "uri",
                locationName: "voiceConnectorGroupId"
              },
              Name: {},
              VoiceConnectorItems: {
                shape: "S5v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VoiceConnectorGroup: {
                shape: "S5z"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "string",
          sensitive: true
        },
        S7: {
          type: "list",
          member: {
            shape: "S3"
          }
        },
        Sa: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PhoneNumberId: {},
              ErrorCode: {},
              ErrorMessage: {}
            }
          }
        },
        Sg: {
          type: "list",
          member: {
            type: "structure",
            members: {
              GroupName: {}
            }
          }
        },
        Sm: {
          type: "structure",
          required: [
            "ExternalUserId"
          ],
          members: {
            ExternalUserId: {
              shape: "Sn"
            },
            Tags: {
              shape: "So"
            }
          }
        },
        Sn: {
          type: "string",
          sensitive: true
        },
        So: {
          type: "list",
          member: {
            shape: "Sp"
          }
        },
        Sp: {
          type: "structure",
          required: [
            "Key",
            "Value"
          ],
          members: {
            Key: {
              shape: "Sq"
            },
            Value: {
              type: "string",
              sensitive: true
            }
          }
        },
        Sq: {
          type: "string",
          sensitive: true
        },
        St: {
          type: "list",
          member: {
            shape: "Su"
          }
        },
        Su: {
          type: "structure",
          members: {
            ExternalUserId: {
              shape: "Sn"
            },
            AttendeeId: {},
            JoinToken: {
              shape: "Sv"
            }
          }
        },
        Sv: {
          type: "string",
          sensitive: true
        },
        Sw: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ExternalUserId: {
                shape: "Sn"
              },
              ErrorCode: {},
              ErrorMessage: {}
            }
          }
        },
        S14: {
          type: "structure",
          members: {
            Arn: {},
            Name: {
              type: "string",
              sensitive: true
            }
          }
        },
        S1h: {
          type: "list",
          member: {}
        },
        S1k: {
          type: "list",
          member: {}
        },
        S1m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              UserId: {},
              ErrorCode: {},
              ErrorMessage: {}
            }
          }
        },
        S1u: {
          type: "string",
          sensitive: true
        },
        S21: {
          type: "structure",
          members: {
            IsAlexaForBusinessEnabled: {
              type: "boolean"
            },
            AlexaForBusinessRoomArn: {
              shape: "S23"
            }
          }
        },
        S23: {
          type: "string",
          sensitive: true
        },
        S28: {
          type: "structure",
          required: [
            "AwsAccountId",
            "AccountId",
            "Name"
          ],
          members: {
            AwsAccountId: {},
            AccountId: {},
            Name: {},
            AccountType: {},
            CreatedTimestamp: {
              shape: "S2a"
            },
            DefaultLicense: {},
            SupportedLicenses: {
              type: "list",
              member: {}
            },
            AccountStatus: {},
            SigninDelegateGroups: {
              shape: "Sg"
            }
          }
        },
        S2a: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S2e: {
          type: "string",
          sensitive: true
        },
        S2f: {
          type: "string",
          sensitive: true
        },
        S2g: {
          type: "string",
          sensitive: true
        },
        S2h: {
          type: "list",
          member: {
            shape: "Sp"
          }
        },
        S2n: {
          type: "string",
          sensitive: true
        },
        S2t: {
          type: "structure",
          members: {
            BotId: {},
            UserId: {},
            DisplayName: {
              shape: "S23"
            },
            BotType: {},
            Disabled: {
              type: "boolean"
            },
            CreatedTimestamp: {
              shape: "S2a"
            },
            UpdatedTimestamp: {
              shape: "S2a"
            },
            BotEmail: {
              shape: "S23"
            },
            SecurityToken: {
              shape: "S23"
            }
          }
        },
        S37: {
          type: "string",
          sensitive: true
        },
        S39: {
          type: "structure",
          members: {
            SourceConfiguration: {
              type: "structure",
              members: {
                SelectedVideoStreams: {
                  type: "structure",
                  members: {
                    AttendeeIds: {
                      type: "list",
                      member: {}
                    },
                    ExternalUserIds: {
                      type: "list",
                      member: {
                        shape: "Sn"
                      }
                    }
                  }
                }
              }
            },
            ArtifactsConfiguration: {
              type: "structure",
              required: [
                "Audio",
                "Video",
                "Content"
              ],
              members: {
                Audio: {
                  type: "structure",
                  required: [
                    "MuxType"
                  ],
                  members: {
                    MuxType: {}
                  }
                },
                Video: {
                  type: "structure",
                  required: [
                    "State"
                  ],
                  members: {
                    State: {},
                    MuxType: {}
                  }
                },
                Content: {
                  type: "structure",
                  required: [
                    "State"
                  ],
                  members: {
                    State: {},
                    MuxType: {}
                  }
                }
              }
            }
          }
        },
        S3n: {
          type: "structure",
          members: {
            MediaPipelineId: {},
            SourceType: {},
            SourceArn: {
              shape: "S37"
            },
            Status: {},
            SinkType: {},
            SinkArn: {
              shape: "S37"
            },
            CreatedTimestamp: {
              shape: "S2a"
            },
            UpdatedTimestamp: {
              shape: "S2a"
            },
            ChimeSdkMeetingConfiguration: {
              shape: "S39"
            }
          }
        },
        S3q: {
          type: "string",
          sensitive: true
        },
        S3r: {
          type: "list",
          member: {
            shape: "Sp"
          }
        },
        S3s: {
          type: "structure",
          members: {
            SnsTopicArn: {
              shape: "S37"
            },
            SqsQueueArn: {
              shape: "S37"
            }
          }
        },
        S3u: {
          type: "structure",
          members: {
            MeetingId: {},
            ExternalMeetingId: {
              shape: "S3q"
            },
            MediaPlacement: {
              type: "structure",
              members: {
                AudioHostUrl: {},
                AudioFallbackUrl: {},
                ScreenDataUrl: {},
                ScreenSharingUrl: {},
                ScreenViewingUrl: {},
                SignalingUrl: {},
                TurnControlUrl: {},
                EventIngestionUrl: {}
              }
            },
            MediaRegion: {}
          }
        },
        S44: {
          type: "structure",
          members: {
            PhoneNumberOrderId: {},
            ProductType: {},
            Status: {},
            OrderedPhoneNumbers: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  E164PhoneNumber: {
                    shape: "S3"
                  },
                  Status: {}
                }
              }
            },
            CreatedTimestamp: {
              shape: "S2a"
            },
            UpdatedTimestamp: {
              shape: "S2a"
            }
          }
        },
        S4e: {
          type: "list",
          member: {}
        },
        S4i: {
          type: "structure",
          required: [
            "Country",
            "AreaCode"
          ],
          members: {
            Country: {},
            AreaCode: {}
          }
        },
        S4m: {
          type: "structure",
          members: {
            VoiceConnectorId: {},
            ProxySessionId: {},
            Name: {},
            Status: {},
            ExpiryMinutes: {
              type: "integer"
            },
            Capabilities: {
              shape: "S4e"
            },
            CreatedTimestamp: {
              shape: "S2a"
            },
            UpdatedTimestamp: {
              shape: "S2a"
            },
            EndedTimestamp: {
              shape: "S2a"
            },
            Participants: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  PhoneNumber: {
                    shape: "S3"
                  },
                  ProxyPhoneNumber: {
                    shape: "S3"
                  }
                }
              }
            },
            NumberSelectionBehavior: {},
            GeoMatchLevel: {},
            GeoMatchParams: {
              shape: "S4i"
            }
          }
        },
        S4t: {
          type: "structure",
          members: {
            RoomId: {},
            Name: {
              shape: "S23"
            },
            AccountId: {},
            CreatedBy: {},
            CreatedTimestamp: {
              shape: "S2a"
            },
            UpdatedTimestamp: {
              shape: "S2a"
            }
          }
        },
        S4w: {
          type: "structure",
          members: {
            RoomId: {},
            Member: {
              type: "structure",
              members: {
                MemberId: {},
                MemberType: {},
                Email: {
                  shape: "S23"
                },
                FullName: {
                  shape: "S23"
                },
                AccountId: {}
              }
            },
            Role: {},
            InvitedBy: {},
            UpdatedTimestamp: {
              shape: "S2a"
            }
          }
        },
        S51: {
          type: "list",
          member: {
            type: "structure",
            members: {
              LambdaArn: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        S55: {
          type: "structure",
          members: {
            SipMediaApplicationId: {},
            AwsRegion: {},
            Name: {},
            Endpoints: {
              shape: "S51"
            },
            CreatedTimestamp: {
              shape: "S2a"
            },
            UpdatedTimestamp: {
              shape: "S2a"
            }
          }
        },
        S59: {
          type: "structure",
          members: {
            TransactionId: {}
          }
        },
        S5d: {
          type: "list",
          member: {
            type: "structure",
            members: {
              SipMediaApplicationId: {},
              Priority: {
                type: "integer"
              },
              AwsRegion: {}
            }
          }
        },
        S5h: {
          type: "structure",
          members: {
            SipRuleId: {},
            Name: {},
            Disabled: {
              type: "boolean"
            },
            TriggerType: {},
            TriggerValue: {},
            TargetApplications: {
              shape: "S5d"
            },
            CreatedTimestamp: {
              shape: "S2a"
            },
            UpdatedTimestamp: {
              shape: "S2a"
            }
          }
        },
        S5j: {
          type: "string",
          sensitive: true
        },
        S5l: {
          type: "structure",
          required: [
            "UserId"
          ],
          members: {
            UserId: {},
            AccountId: {},
            PrimaryEmail: {
              shape: "S5j"
            },
            PrimaryProvisionedNumber: {
              shape: "S23"
            },
            DisplayName: {
              shape: "S23"
            },
            LicenseType: {},
            UserType: {},
            UserRegistrationStatus: {},
            UserInvitationStatus: {},
            RegisteredOn: {
              shape: "S2a"
            },
            InvitedOn: {
              shape: "S2a"
            },
            AlexaForBusinessMetadata: {
              shape: "S21"
            },
            PersonalPIN: {}
          }
        },
        S5s: {
          type: "structure",
          members: {
            VoiceConnectorId: {},
            AwsRegion: {},
            Name: {},
            OutboundHostName: {},
            RequireEncryption: {
              type: "boolean"
            },
            CreatedTimestamp: {
              shape: "S2a"
            },
            UpdatedTimestamp: {
              shape: "S2a"
            }
          }
        },
        S5v: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "VoiceConnectorId",
              "Priority"
            ],
            members: {
              VoiceConnectorId: {},
              Priority: {
                type: "integer"
              }
            }
          }
        },
        S5z: {
          type: "structure",
          members: {
            VoiceConnectorGroupId: {},
            Name: {},
            VoiceConnectorItems: {
              shape: "S5v"
            },
            CreatedTimestamp: {
              shape: "S2a"
            },
            UpdatedTimestamp: {
              shape: "S2a"
            }
          }
        },
        S6u: {
          type: "list",
          member: {
            shape: "S23"
          }
        },
        S7g: {
          type: "structure",
          members: {
            ChannelSummary: {
              shape: "S7h"
            },
            AppInstanceUserMembershipSummary: {
              type: "structure",
              members: {
                Type: {},
                ReadMarkerTimestamp: {
                  type: "timestamp"
                }
              }
            }
          }
        },
        S7h: {
          type: "structure",
          members: {
            Name: {
              shape: "S2e"
            },
            ChannelArn: {},
            Mode: {},
            Privacy: {},
            Metadata: {
              shape: "S2f"
            },
            LastMessageTimestamp: {
              type: "timestamp"
            }
          }
        },
        S7l: {
          type: "structure",
          members: {
            ChannelSummary: {
              shape: "S7h"
            }
          }
        },
        S81: {
          type: "structure",
          members: {
            DisableRemoteControl: {
              type: "boolean"
            },
            EnableDialOut: {
              type: "boolean"
            }
          }
        },
        S84: {
          type: "structure",
          members: {
            ChannelRetentionSettings: {
              type: "structure",
              members: {
                RetentionDays: {
                  type: "integer"
                }
              }
            }
          }
        },
        S89: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AppInstanceDataType",
              "ResourceArn"
            ],
            members: {
              AppInstanceDataType: {},
              ResourceArn: {
                shape: "S37"
              }
            }
          }
        },
        S8j: {
          type: "string",
          sensitive: true
        },
        S8p: {
          type: "structure",
          members: {
            BotId: {},
            OutboundEventsHTTPSEndpoint: {
              shape: "S23"
            },
            LambdaFunctionArn: {
              shape: "S23"
            }
          }
        },
        S8r: {
          type: "structure",
          members: {
            CdrBucket: {}
          }
        },
        S8s: {
          type: "structure",
          members: {
            CdrBucket: {}
          }
        },
        S93: {
          type: "structure",
          members: {
            PhoneNumberId: {},
            E164PhoneNumber: {
              shape: "S3"
            },
            Country: {},
            Type: {},
            ProductType: {},
            Status: {},
            Capabilities: {
              type: "structure",
              members: {
                InboundCall: {
                  type: "boolean"
                },
                OutboundCall: {
                  type: "boolean"
                },
                InboundSMS: {
                  type: "boolean"
                },
                OutboundSMS: {
                  type: "boolean"
                },
                InboundMMS: {
                  type: "boolean"
                },
                OutboundMMS: {
                  type: "boolean"
                }
              }
            },
            Associations: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Value: {},
                  Name: {},
                  AssociatedTimestamp: {
                    shape: "S2a"
                  }
                }
              }
            },
            CallingName: {
              shape: "S1u"
            },
            CallingNameStatus: {},
            CreatedTimestamp: {
              shape: "S2a"
            },
            UpdatedTimestamp: {
              shape: "S2a"
            },
            DeletionTimestamp: {
              shape: "S2a"
            }
          }
        },
        S9j: {
          type: "structure",
          members: {
            RoomRetentionSettings: {
              type: "structure",
              members: {
                RetentionDays: {
                  type: "integer"
                }
              }
            },
            ConversationRetentionSettings: {
              type: "structure",
              members: {
                RetentionDays: {
                  type: "integer"
                }
              }
            }
          }
        },
        S9s: {
          type: "structure",
          members: {
            EnableSipMediaApplicationMessageLogs: {
              type: "boolean"
            }
          }
        },
        S9z: {
          type: "structure",
          required: [
            "Telephony"
          ],
          members: {
            Telephony: {
              type: "structure",
              required: [
                "InboundCalling",
                "OutboundCalling",
                "SMS"
              ],
              members: {
                InboundCalling: {
                  type: "boolean"
                },
                OutboundCalling: {
                  type: "boolean"
                },
                SMS: {
                  type: "boolean"
                }
              }
            }
          }
        },
        Sa5: {
          type: "structure",
          members: {
            DNIS: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "EmergencyPhoneNumber",
                  "CallingCountry"
                ],
                members: {
                  EmergencyPhoneNumber: {
                    shape: "S3"
                  },
                  TestPhoneNumber: {
                    shape: "S3"
                  },
                  CallingCountry: {}
                }
              }
            }
          }
        },
        Sac: {
          type: "structure",
          members: {
            EnableSIPLogs: {
              type: "boolean"
            }
          }
        },
        Saf: {
          type: "structure",
          members: {
            Routes: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Host: {},
                  Port: {
                    type: "integer"
                  },
                  Protocol: {},
                  Priority: {
                    type: "integer"
                  },
                  Weight: {
                    type: "integer"
                  }
                }
              }
            },
            Disabled: {
              type: "boolean"
            }
          }
        },
        Sao: {
          type: "structure",
          members: {
            DefaultSessionExpiryMinutes: {
              type: "integer"
            },
            Disabled: {
              type: "boolean"
            },
            FallBackPhoneNumber: {
              shape: "S3"
            },
            PhoneNumberCountries: {
              shape: "Saq"
            }
          }
        },
        Saq: {
          type: "list",
          member: {}
        },
        Sat: {
          type: "structure",
          required: [
            "DataRetentionInHours"
          ],
          members: {
            DataRetentionInHours: {
              type: "integer"
            },
            Disabled: {
              type: "boolean"
            },
            StreamingNotificationTargets: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "NotificationTarget"
                ],
                members: {
                  NotificationTarget: {}
                }
              }
            }
          }
        },
        Sb0: {
          type: "structure",
          members: {
            CpsLimit: {
              type: "integer"
            },
            DefaultPhoneNumber: {
              shape: "S3"
            },
            CallingRegions: {
              type: "list",
              member: {}
            },
            CidrAllowedList: {
              shape: "Saq"
            },
            Disabled: {
              type: "boolean"
            }
          }
        },
        Sbj: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/chime-2018-05-01.paginators.json
var require_chime_2018_05_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/chime-2018-05-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAccounts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAppInstanceAdmins: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAppInstanceUsers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAppInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAttendees: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListBots: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelBans: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelMemberships: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelMembershipsForAppInstanceUser: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelMessages: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelModerators: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelsModeratedByAppInstanceUser: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMediaCapturePipelines: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMeetings: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPhoneNumberOrders: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPhoneNumbers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListProxySessions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListRoomMemberships: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListRooms: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSipMediaApplications: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSipRules: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListUsers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListVoiceConnectorGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListVoiceConnectors: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        SearchAvailablePhoneNumbers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/chime.js
var require_chime = __commonJS({
  "node_modules/aws-sdk/clients/chime.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["chime"] = {};
    AWS3.Chime = Service.defineService("chime", ["2018-05-01"]);
    Object.defineProperty(apiLoader.services["chime"], "2018-05-01", {
      get: function get() {
        var model = require_chime_2018_05_01_min();
        model.paginators = require_chime_2018_05_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Chime;
  }
});

// node_modules/aws-sdk/apis/pinpoint-email-2018-07-26.min.json
var require_pinpoint_email_2018_07_26_min = __commonJS({
  "node_modules/aws-sdk/apis/pinpoint-email-2018-07-26.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-07-26",
        endpointPrefix: "email",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Pinpoint Email",
        serviceFullName: "Amazon Pinpoint Email Service",
        serviceId: "Pinpoint Email",
        signatureVersion: "v4",
        signingName: "ses",
        uid: "pinpoint-email-2018-07-26"
      },
      operations: {
        CreateConfigurationSet: {
          http: {
            requestUri: "/v1/email/configuration-sets"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {},
              TrackingOptions: {
                shape: "S3"
              },
              DeliveryOptions: {
                shape: "S5"
              },
              ReputationOptions: {
                shape: "S8"
              },
              SendingOptions: {
                shape: "Sb"
              },
              Tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateConfigurationSetEventDestination: {
          http: {
            requestUri: "/v1/email/configuration-sets/{ConfigurationSetName}/event-destinations"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestinationName",
              "EventDestination"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              EventDestinationName: {},
              EventDestination: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDedicatedIpPool: {
          http: {
            requestUri: "/v1/email/dedicated-ip-pools"
          },
          input: {
            type: "structure",
            required: [
              "PoolName"
            ],
            members: {
              PoolName: {},
              Tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDeliverabilityTestReport: {
          http: {
            requestUri: "/v1/email/deliverability-dashboard/test"
          },
          input: {
            type: "structure",
            required: [
              "FromEmailAddress",
              "Content"
            ],
            members: {
              ReportName: {},
              FromEmailAddress: {},
              Content: {
                shape: "S12"
              },
              Tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ReportId",
              "DeliverabilityTestStatus"
            ],
            members: {
              ReportId: {},
              DeliverabilityTestStatus: {}
            }
          }
        },
        CreateEmailIdentity: {
          http: {
            requestUri: "/v1/email/identities"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {},
              Tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityType: {},
              VerifiedForSendingStatus: {
                type: "boolean"
              },
              DkimAttributes: {
                shape: "S1k"
              }
            }
          }
        },
        DeleteConfigurationSet: {
          http: {
            method: "DELETE",
            requestUri: "/v1/email/configuration-sets/{ConfigurationSetName}"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteConfigurationSetEventDestination: {
          http: {
            method: "DELETE",
            requestUri: "/v1/email/configuration-sets/{ConfigurationSetName}/event-destinations/{EventDestinationName}"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestinationName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              EventDestinationName: {
                location: "uri",
                locationName: "EventDestinationName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDedicatedIpPool: {
          http: {
            method: "DELETE",
            requestUri: "/v1/email/dedicated-ip-pools/{PoolName}"
          },
          input: {
            type: "structure",
            required: [
              "PoolName"
            ],
            members: {
              PoolName: {
                location: "uri",
                locationName: "PoolName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEmailIdentity: {
          http: {
            method: "DELETE",
            requestUri: "/v1/email/identities/{EmailIdentity}"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAccount: {
          http: {
            method: "GET",
            requestUri: "/v1/email/account"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              SendQuota: {
                type: "structure",
                members: {
                  Max24HourSend: {
                    type: "double"
                  },
                  MaxSendRate: {
                    type: "double"
                  },
                  SentLast24Hours: {
                    type: "double"
                  }
                }
              },
              SendingEnabled: {
                type: "boolean"
              },
              DedicatedIpAutoWarmupEnabled: {
                type: "boolean"
              },
              EnforcementStatus: {},
              ProductionAccessEnabled: {
                type: "boolean"
              }
            }
          }
        },
        GetBlacklistReports: {
          http: {
            method: "GET",
            requestUri: "/v1/email/deliverability-dashboard/blacklist-report"
          },
          input: {
            type: "structure",
            required: [
              "BlacklistItemNames"
            ],
            members: {
              BlacklistItemNames: {
                location: "querystring",
                locationName: "BlacklistItemNames",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "BlacklistReport"
            ],
            members: {
              BlacklistReport: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      RblName: {},
                      ListingTime: {
                        type: "timestamp"
                      },
                      Description: {}
                    }
                  }
                }
              }
            }
          }
        },
        GetConfigurationSet: {
          http: {
            method: "GET",
            requestUri: "/v1/email/configuration-sets/{ConfigurationSetName}"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationSetName: {},
              TrackingOptions: {
                shape: "S3"
              },
              DeliveryOptions: {
                shape: "S5"
              },
              ReputationOptions: {
                shape: "S8"
              },
              SendingOptions: {
                shape: "Sb"
              },
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        GetConfigurationSetEventDestinations: {
          http: {
            method: "GET",
            requestUri: "/v1/email/configuration-sets/{ConfigurationSetName}/event-destinations"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventDestinations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "MatchingEventTypes"
                  ],
                  members: {
                    Name: {},
                    Enabled: {
                      type: "boolean"
                    },
                    MatchingEventTypes: {
                      shape: "Sk"
                    },
                    KinesisFirehoseDestination: {
                      shape: "Sm"
                    },
                    CloudWatchDestination: {
                      shape: "So"
                    },
                    SnsDestination: {
                      shape: "Su"
                    },
                    PinpointDestination: {
                      shape: "Sv"
                    }
                  }
                }
              }
            }
          }
        },
        GetDedicatedIp: {
          http: {
            method: "GET",
            requestUri: "/v1/email/dedicated-ips/{IP}"
          },
          input: {
            type: "structure",
            required: [
              "Ip"
            ],
            members: {
              Ip: {
                location: "uri",
                locationName: "IP"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DedicatedIp: {
                shape: "S2m"
              }
            }
          }
        },
        GetDedicatedIps: {
          http: {
            method: "GET",
            requestUri: "/v1/email/dedicated-ips"
          },
          input: {
            type: "structure",
            members: {
              PoolName: {
                location: "querystring",
                locationName: "PoolName"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DedicatedIps: {
                type: "list",
                member: {
                  shape: "S2m"
                }
              },
              NextToken: {}
            }
          }
        },
        GetDeliverabilityDashboardOptions: {
          http: {
            method: "GET",
            requestUri: "/v1/email/deliverability-dashboard"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "DashboardEnabled"
            ],
            members: {
              DashboardEnabled: {
                type: "boolean"
              },
              SubscriptionExpiryDate: {
                type: "timestamp"
              },
              AccountStatus: {},
              ActiveSubscribedDomains: {
                shape: "S2x"
              },
              PendingExpirationSubscribedDomains: {
                shape: "S2x"
              }
            }
          }
        },
        GetDeliverabilityTestReport: {
          http: {
            method: "GET",
            requestUri: "/v1/email/deliverability-dashboard/test-reports/{ReportId}"
          },
          input: {
            type: "structure",
            required: [
              "ReportId"
            ],
            members: {
              ReportId: {
                location: "uri",
                locationName: "ReportId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DeliverabilityTestReport",
              "OverallPlacement",
              "IspPlacements"
            ],
            members: {
              DeliverabilityTestReport: {
                shape: "S35"
              },
              OverallPlacement: {
                shape: "S37"
              },
              IspPlacements: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IspName: {},
                    PlacementStatistics: {
                      shape: "S37"
                    }
                  }
                }
              },
              Message: {},
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        GetDomainDeliverabilityCampaign: {
          http: {
            method: "GET",
            requestUri: "/v1/email/deliverability-dashboard/campaigns/{CampaignId}"
          },
          input: {
            type: "structure",
            required: [
              "CampaignId"
            ],
            members: {
              CampaignId: {
                location: "uri",
                locationName: "CampaignId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainDeliverabilityCampaign"
            ],
            members: {
              DomainDeliverabilityCampaign: {
                shape: "S3f"
              }
            }
          }
        },
        GetDomainStatisticsReport: {
          http: {
            method: "GET",
            requestUri: "/v1/email/deliverability-dashboard/statistics-report/{Domain}"
          },
          input: {
            type: "structure",
            required: [
              "Domain",
              "StartDate",
              "EndDate"
            ],
            members: {
              Domain: {
                location: "uri",
                locationName: "Domain"
              },
              StartDate: {
                location: "querystring",
                locationName: "StartDate",
                type: "timestamp"
              },
              EndDate: {
                location: "querystring",
                locationName: "EndDate",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "OverallVolume",
              "DailyVolumes"
            ],
            members: {
              OverallVolume: {
                type: "structure",
                members: {
                  VolumeStatistics: {
                    shape: "S3p"
                  },
                  ReadRatePercent: {
                    type: "double"
                  },
                  DomainIspPlacements: {
                    shape: "S3q"
                  }
                }
              },
              DailyVolumes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StartDate: {
                      type: "timestamp"
                    },
                    VolumeStatistics: {
                      shape: "S3p"
                    },
                    DomainIspPlacements: {
                      shape: "S3q"
                    }
                  }
                }
              }
            }
          }
        },
        GetEmailIdentity: {
          http: {
            method: "GET",
            requestUri: "/v1/email/identities/{EmailIdentity}"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityType: {},
              FeedbackForwardingStatus: {
                type: "boolean"
              },
              VerifiedForSendingStatus: {
                type: "boolean"
              },
              DkimAttributes: {
                shape: "S1k"
              },
              MailFromAttributes: {
                type: "structure",
                required: [
                  "MailFromDomain",
                  "MailFromDomainStatus",
                  "BehaviorOnMxFailure"
                ],
                members: {
                  MailFromDomain: {},
                  MailFromDomainStatus: {},
                  BehaviorOnMxFailure: {}
                }
              },
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        ListConfigurationSets: {
          http: {
            method: "GET",
            requestUri: "/v1/email/configuration-sets"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationSets: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListDedicatedIpPools: {
          http: {
            method: "GET",
            requestUri: "/v1/email/dedicated-ip-pools"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DedicatedIpPools: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListDeliverabilityTestReports: {
          http: {
            method: "GET",
            requestUri: "/v1/email/deliverability-dashboard/test-reports"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DeliverabilityTestReports"
            ],
            members: {
              DeliverabilityTestReports: {
                type: "list",
                member: {
                  shape: "S35"
                }
              },
              NextToken: {}
            }
          }
        },
        ListDomainDeliverabilityCampaigns: {
          http: {
            method: "GET",
            requestUri: "/v1/email/deliverability-dashboard/domains/{SubscribedDomain}/campaigns"
          },
          input: {
            type: "structure",
            required: [
              "StartDate",
              "EndDate",
              "SubscribedDomain"
            ],
            members: {
              StartDate: {
                location: "querystring",
                locationName: "StartDate",
                type: "timestamp"
              },
              EndDate: {
                location: "querystring",
                locationName: "EndDate",
                type: "timestamp"
              },
              SubscribedDomain: {
                location: "uri",
                locationName: "SubscribedDomain"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainDeliverabilityCampaigns"
            ],
            members: {
              DomainDeliverabilityCampaigns: {
                type: "list",
                member: {
                  shape: "S3f"
                }
              },
              NextToken: {}
            }
          }
        },
        ListEmailIdentities: {
          http: {
            method: "GET",
            requestUri: "/v1/email/identities"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EmailIdentities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IdentityType: {},
                    IdentityName: {},
                    SendingEnabled: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/v1/email/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "querystring",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        PutAccountDedicatedIpWarmupAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/account/dedicated-ips/warmup"
          },
          input: {
            type: "structure",
            members: {
              AutoWarmupEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutAccountSendingAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/account/sending"
          },
          input: {
            type: "structure",
            members: {
              SendingEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutConfigurationSetDeliveryOptions: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/configuration-sets/{ConfigurationSetName}/delivery-options"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              TlsPolicy: {},
              SendingPoolName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutConfigurationSetReputationOptions: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/configuration-sets/{ConfigurationSetName}/reputation-options"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              ReputationMetricsEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutConfigurationSetSendingOptions: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/configuration-sets/{ConfigurationSetName}/sending"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              SendingEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutConfigurationSetTrackingOptions: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/configuration-sets/{ConfigurationSetName}/tracking-options"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              CustomRedirectDomain: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutDedicatedIpInPool: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/dedicated-ips/{IP}/pool"
          },
          input: {
            type: "structure",
            required: [
              "Ip",
              "DestinationPoolName"
            ],
            members: {
              Ip: {
                location: "uri",
                locationName: "IP"
              },
              DestinationPoolName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutDedicatedIpWarmupAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/dedicated-ips/{IP}/warmup"
          },
          input: {
            type: "structure",
            required: [
              "Ip",
              "WarmupPercentage"
            ],
            members: {
              Ip: {
                location: "uri",
                locationName: "IP"
              },
              WarmupPercentage: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutDeliverabilityDashboardOption: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/deliverability-dashboard"
          },
          input: {
            type: "structure",
            required: [
              "DashboardEnabled"
            ],
            members: {
              DashboardEnabled: {
                type: "boolean"
              },
              SubscribedDomains: {
                shape: "S2x"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutEmailIdentityDkimAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/identities/{EmailIdentity}/dkim"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              SigningEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutEmailIdentityFeedbackAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/identities/{EmailIdentity}/feedback"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              EmailForwardingEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutEmailIdentityMailFromAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/identities/{EmailIdentity}/mail-from"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              MailFromDomain: {},
              BehaviorOnMxFailure: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SendEmail: {
          http: {
            requestUri: "/v1/email/outbound-emails"
          },
          input: {
            type: "structure",
            required: [
              "Destination",
              "Content"
            ],
            members: {
              FromEmailAddress: {},
              Destination: {
                type: "structure",
                members: {
                  ToAddresses: {
                    shape: "S59"
                  },
                  CcAddresses: {
                    shape: "S59"
                  },
                  BccAddresses: {
                    shape: "S59"
                  }
                }
              },
              ReplyToAddresses: {
                shape: "S59"
              },
              FeedbackForwardingEmailAddress: {},
              Content: {
                shape: "S12"
              },
              EmailTags: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Value"
                  ],
                  members: {
                    Name: {},
                    Value: {}
                  }
                }
              },
              ConfigurationSetName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MessageId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/v1/email/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/v1/email/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "querystring",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "TagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateConfigurationSetEventDestination: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/configuration-sets/{ConfigurationSetName}/event-destinations/{EventDestinationName}"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestinationName",
              "EventDestination"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              EventDestinationName: {
                location: "uri",
                locationName: "EventDestinationName"
              },
              EventDestination: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          required: [
            "CustomRedirectDomain"
          ],
          members: {
            CustomRedirectDomain: {}
          }
        },
        S5: {
          type: "structure",
          members: {
            TlsPolicy: {},
            SendingPoolName: {}
          }
        },
        S8: {
          type: "structure",
          members: {
            ReputationMetricsEnabled: {
              type: "boolean"
            },
            LastFreshStart: {
              type: "timestamp"
            }
          }
        },
        Sb: {
          type: "structure",
          members: {
            SendingEnabled: {
              type: "boolean"
            }
          }
        },
        Sc: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sj: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            MatchingEventTypes: {
              shape: "Sk"
            },
            KinesisFirehoseDestination: {
              shape: "Sm"
            },
            CloudWatchDestination: {
              shape: "So"
            },
            SnsDestination: {
              shape: "Su"
            },
            PinpointDestination: {
              shape: "Sv"
            }
          }
        },
        Sk: {
          type: "list",
          member: {}
        },
        Sm: {
          type: "structure",
          required: [
            "IamRoleArn",
            "DeliveryStreamArn"
          ],
          members: {
            IamRoleArn: {},
            DeliveryStreamArn: {}
          }
        },
        So: {
          type: "structure",
          required: [
            "DimensionConfigurations"
          ],
          members: {
            DimensionConfigurations: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DimensionName",
                  "DimensionValueSource",
                  "DefaultDimensionValue"
                ],
                members: {
                  DimensionName: {},
                  DimensionValueSource: {},
                  DefaultDimensionValue: {}
                }
              }
            }
          }
        },
        Su: {
          type: "structure",
          required: [
            "TopicArn"
          ],
          members: {
            TopicArn: {}
          }
        },
        Sv: {
          type: "structure",
          members: {
            ApplicationArn: {}
          }
        },
        S12: {
          type: "structure",
          members: {
            Simple: {
              type: "structure",
              required: [
                "Subject",
                "Body"
              ],
              members: {
                Subject: {
                  shape: "S14"
                },
                Body: {
                  type: "structure",
                  members: {
                    Text: {
                      shape: "S14"
                    },
                    Html: {
                      shape: "S14"
                    }
                  }
                }
              }
            },
            Raw: {
              type: "structure",
              required: [
                "Data"
              ],
              members: {
                Data: {
                  type: "blob"
                }
              }
            },
            Template: {
              type: "structure",
              members: {
                TemplateArn: {},
                TemplateData: {}
              }
            }
          }
        },
        S14: {
          type: "structure",
          required: [
            "Data"
          ],
          members: {
            Data: {},
            Charset: {}
          }
        },
        S1k: {
          type: "structure",
          members: {
            SigningEnabled: {
              type: "boolean"
            },
            Status: {},
            Tokens: {
              type: "list",
              member: {}
            }
          }
        },
        S2m: {
          type: "structure",
          required: [
            "Ip",
            "WarmupStatus",
            "WarmupPercentage"
          ],
          members: {
            Ip: {},
            WarmupStatus: {},
            WarmupPercentage: {
              type: "integer"
            },
            PoolName: {}
          }
        },
        S2x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Domain: {},
              SubscriptionStartDate: {
                type: "timestamp"
              },
              InboxPlacementTrackingOption: {
                type: "structure",
                members: {
                  Global: {
                    type: "boolean"
                  },
                  TrackedIsps: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        S35: {
          type: "structure",
          members: {
            ReportId: {},
            ReportName: {},
            Subject: {},
            FromEmailAddress: {},
            CreateDate: {
              type: "timestamp"
            },
            DeliverabilityTestStatus: {}
          }
        },
        S37: {
          type: "structure",
          members: {
            InboxPercentage: {
              type: "double"
            },
            SpamPercentage: {
              type: "double"
            },
            MissingPercentage: {
              type: "double"
            },
            SpfPercentage: {
              type: "double"
            },
            DkimPercentage: {
              type: "double"
            }
          }
        },
        S3f: {
          type: "structure",
          members: {
            CampaignId: {},
            ImageUrl: {},
            Subject: {},
            FromAddress: {},
            SendingIps: {
              type: "list",
              member: {}
            },
            FirstSeenDateTime: {
              type: "timestamp"
            },
            LastSeenDateTime: {
              type: "timestamp"
            },
            InboxCount: {
              type: "long"
            },
            SpamCount: {
              type: "long"
            },
            ReadRate: {
              type: "double"
            },
            DeleteRate: {
              type: "double"
            },
            ReadDeleteRate: {
              type: "double"
            },
            ProjectedVolume: {
              type: "long"
            },
            Esps: {
              type: "list",
              member: {}
            }
          }
        },
        S3p: {
          type: "structure",
          members: {
            InboxRawCount: {
              type: "long"
            },
            SpamRawCount: {
              type: "long"
            },
            ProjectedInbox: {
              type: "long"
            },
            ProjectedSpam: {
              type: "long"
            }
          }
        },
        S3q: {
          type: "list",
          member: {
            type: "structure",
            members: {
              IspName: {},
              InboxRawCount: {
                type: "long"
              },
              SpamRawCount: {
                type: "long"
              },
              InboxPercentage: {
                type: "double"
              },
              SpamPercentage: {
                type: "double"
              }
            }
          }
        },
        S59: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/pinpoint-email-2018-07-26.paginators.json
var require_pinpoint_email_2018_07_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/pinpoint-email-2018-07-26.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetDedicatedIps: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListConfigurationSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListDedicatedIpPools: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListDeliverabilityTestReports: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListDomainDeliverabilityCampaigns: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListEmailIdentities: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/pinpointemail.js
var require_pinpointemail = __commonJS({
  "node_modules/aws-sdk/clients/pinpointemail.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["pinpointemail"] = {};
    AWS3.PinpointEmail = Service.defineService("pinpointemail", ["2018-07-26"]);
    Object.defineProperty(apiLoader.services["pinpointemail"], "2018-07-26", {
      get: function get() {
        var model = require_pinpoint_email_2018_07_26_min();
        model.paginators = require_pinpoint_email_2018_07_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.PinpointEmail;
  }
});

// node_modules/aws-sdk/apis/ram-2018-01-04.min.json
var require_ram_2018_01_04_min = __commonJS({
  "node_modules/aws-sdk/apis/ram-2018-01-04.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-01-04",
        endpointPrefix: "ram",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "RAM",
        serviceFullName: "AWS Resource Access Manager",
        serviceId: "RAM",
        signatureVersion: "v4",
        uid: "ram-2018-01-04"
      },
      operations: {
        AcceptResourceShareInvitation: {
          http: {
            requestUri: "/acceptresourceshareinvitation"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareInvitationArn"
            ],
            members: {
              resourceShareInvitationArn: {},
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceShareInvitation: {
                shape: "S4"
              },
              clientToken: {}
            }
          }
        },
        AssociateResourceShare: {
          http: {
            requestUri: "/associateresourceshare"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareArn"
            ],
            members: {
              resourceShareArn: {},
              resourceArns: {
                shape: "Sd"
              },
              principals: {
                shape: "Se"
              },
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceShareAssociations: {
                shape: "S7"
              },
              clientToken: {}
            }
          }
        },
        AssociateResourceSharePermission: {
          http: {
            requestUri: "/associateresourcesharepermission"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareArn",
              "permissionArn"
            ],
            members: {
              resourceShareArn: {},
              permissionArn: {},
              replace: {
                type: "boolean"
              },
              clientToken: {},
              permissionVersion: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              returnValue: {
                type: "boolean"
              },
              clientToken: {}
            }
          }
        },
        CreateResourceShare: {
          http: {
            requestUri: "/createresourceshare"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              resourceArns: {
                shape: "Sd"
              },
              principals: {
                shape: "Se"
              },
              tags: {
                shape: "Sk"
              },
              allowExternalPrincipals: {
                type: "boolean"
              },
              clientToken: {},
              permissionArns: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceShare: {
                shape: "Sq"
              },
              clientToken: {}
            }
          }
        },
        DeleteResourceShare: {
          http: {
            method: "DELETE",
            requestUri: "/deleteresourceshare"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareArn"
            ],
            members: {
              resourceShareArn: {
                location: "querystring",
                locationName: "resourceShareArn"
              },
              clientToken: {
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              returnValue: {
                type: "boolean"
              },
              clientToken: {}
            }
          }
        },
        DisassociateResourceShare: {
          http: {
            requestUri: "/disassociateresourceshare"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareArn"
            ],
            members: {
              resourceShareArn: {},
              resourceArns: {
                shape: "Sd"
              },
              principals: {
                shape: "Se"
              },
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceShareAssociations: {
                shape: "S7"
              },
              clientToken: {}
            }
          }
        },
        DisassociateResourceSharePermission: {
          http: {
            requestUri: "/disassociateresourcesharepermission"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareArn",
              "permissionArn"
            ],
            members: {
              resourceShareArn: {},
              permissionArn: {},
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              returnValue: {
                type: "boolean"
              },
              clientToken: {}
            }
          }
        },
        EnableSharingWithAwsOrganization: {
          http: {
            requestUri: "/enablesharingwithawsorganization"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              returnValue: {
                type: "boolean"
              }
            }
          }
        },
        GetPermission: {
          http: {
            requestUri: "/getpermission"
          },
          input: {
            type: "structure",
            required: [
              "permissionArn"
            ],
            members: {
              permissionArn: {},
              permissionVersion: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              permission: {
                type: "structure",
                members: {
                  arn: {},
                  version: {},
                  defaultVersion: {
                    type: "boolean"
                  },
                  name: {},
                  resourceType: {},
                  permission: {},
                  creationTime: {
                    type: "timestamp"
                  },
                  lastUpdatedTime: {
                    type: "timestamp"
                  },
                  isResourceTypeDefault: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        GetResourcePolicies: {
          http: {
            requestUri: "/getresourcepolicies"
          },
          input: {
            type: "structure",
            required: [
              "resourceArns"
            ],
            members: {
              resourceArns: {
                shape: "Sd"
              },
              principal: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policies: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        GetResourceShareAssociations: {
          http: {
            requestUri: "/getresourceshareassociations"
          },
          input: {
            type: "structure",
            required: [
              "associationType"
            ],
            members: {
              associationType: {},
              resourceShareArns: {
                shape: "S1a"
              },
              resourceArn: {},
              principal: {},
              associationStatus: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceShareAssociations: {
                shape: "S7"
              },
              nextToken: {}
            }
          }
        },
        GetResourceShareInvitations: {
          http: {
            requestUri: "/getresourceshareinvitations"
          },
          input: {
            type: "structure",
            members: {
              resourceShareInvitationArns: {
                type: "list",
                member: {}
              },
              resourceShareArns: {
                shape: "S1a"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceShareInvitations: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              nextToken: {}
            }
          }
        },
        GetResourceShares: {
          http: {
            requestUri: "/getresourceshares"
          },
          input: {
            type: "structure",
            required: [
              "resourceOwner"
            ],
            members: {
              resourceShareArns: {
                shape: "S1a"
              },
              resourceShareStatus: {},
              resourceOwner: {},
              name: {},
              tagFilters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    tagKey: {},
                    tagValues: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              permissionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceShares: {
                type: "list",
                member: {
                  shape: "Sq"
                }
              },
              nextToken: {}
            }
          }
        },
        ListPendingInvitationResources: {
          http: {
            requestUri: "/listpendinginvitationresources"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareInvitationArn"
            ],
            members: {
              resourceShareInvitationArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resources: {
                shape: "S1p"
              },
              nextToken: {}
            }
          }
        },
        ListPermissions: {
          http: {
            requestUri: "/listpermissions"
          },
          input: {
            type: "structure",
            members: {
              resourceType: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              permissions: {
                shape: "S1u"
              },
              nextToken: {}
            }
          }
        },
        ListPrincipals: {
          http: {
            requestUri: "/listprincipals"
          },
          input: {
            type: "structure",
            required: [
              "resourceOwner"
            ],
            members: {
              resourceOwner: {},
              resourceArn: {},
              principals: {
                shape: "Se"
              },
              resourceType: {},
              resourceShareArns: {
                shape: "S1a"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              principals: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    resourceShareArn: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdatedTime: {
                      type: "timestamp"
                    },
                    external: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListResourceSharePermissions: {
          http: {
            requestUri: "/listresourcesharepermissions"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareArn"
            ],
            members: {
              resourceShareArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              permissions: {
                shape: "S1u"
              },
              nextToken: {}
            }
          }
        },
        ListResourceTypes: {
          http: {
            requestUri: "/listresourcetypes"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    resourceType: {},
                    serviceName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListResources: {
          http: {
            requestUri: "/listresources"
          },
          input: {
            type: "structure",
            required: [
              "resourceOwner"
            ],
            members: {
              resourceOwner: {},
              principal: {},
              resourceType: {},
              resourceArns: {
                shape: "Sd"
              },
              resourceShareArns: {
                shape: "S1a"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resources: {
                shape: "S1p"
              },
              nextToken: {}
            }
          }
        },
        PromoteResourceShareCreatedFromPolicy: {
          http: {
            requestUri: "/promoteresourcesharecreatedfrompolicy"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareArn"
            ],
            members: {
              resourceShareArn: {
                location: "querystring",
                locationName: "resourceShareArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              returnValue: {
                type: "boolean"
              }
            }
          }
        },
        RejectResourceShareInvitation: {
          http: {
            requestUri: "/rejectresourceshareinvitation"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareInvitationArn"
            ],
            members: {
              resourceShareInvitationArn: {},
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceShareInvitation: {
                shape: "S4"
              },
              clientToken: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tagresource"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareArn",
              "tags"
            ],
            members: {
              resourceShareArn: {},
              tags: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            requestUri: "/untagresource"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareArn",
              "tagKeys"
            ],
            members: {
              resourceShareArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateResourceShare: {
          http: {
            requestUri: "/updateresourceshare"
          },
          input: {
            type: "structure",
            required: [
              "resourceShareArn"
            ],
            members: {
              resourceShareArn: {},
              name: {},
              allowExternalPrincipals: {
                type: "boolean"
              },
              clientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceShare: {
                shape: "Sq"
              },
              clientToken: {}
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            resourceShareInvitationArn: {},
            resourceShareName: {},
            resourceShareArn: {},
            senderAccountId: {},
            receiverAccountId: {},
            invitationTimestamp: {
              type: "timestamp"
            },
            status: {},
            resourceShareAssociations: {
              shape: "S7",
              deprecated: true,
              deprecatedMessage: "This member has been deprecated. Use ListPendingInvitationResources."
            },
            receiverArn: {}
          }
        },
        S7: {
          type: "list",
          member: {
            type: "structure",
            members: {
              resourceShareArn: {},
              resourceShareName: {},
              associatedEntity: {},
              associationType: {},
              status: {},
              statusMessage: {},
              creationTime: {
                type: "timestamp"
              },
              lastUpdatedTime: {
                type: "timestamp"
              },
              external: {
                type: "boolean"
              }
            }
          }
        },
        Sd: {
          type: "list",
          member: {}
        },
        Se: {
          type: "list",
          member: {}
        },
        Sk: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sq: {
          type: "structure",
          members: {
            resourceShareArn: {},
            name: {},
            owningAccountId: {},
            allowExternalPrincipals: {
              type: "boolean"
            },
            status: {},
            statusMessage: {},
            tags: {
              shape: "Sk"
            },
            creationTime: {
              type: "timestamp"
            },
            lastUpdatedTime: {
              type: "timestamp"
            },
            featureSet: {}
          }
        },
        S1a: {
          type: "list",
          member: {}
        },
        S1p: {
          type: "list",
          member: {
            type: "structure",
            members: {
              arn: {},
              type: {},
              resourceShareArn: {},
              resourceGroupArn: {},
              status: {},
              statusMessage: {},
              creationTime: {
                type: "timestamp"
              },
              lastUpdatedTime: {
                type: "timestamp"
              }
            }
          }
        },
        S1u: {
          type: "list",
          member: {
            type: "structure",
            members: {
              arn: {},
              version: {},
              defaultVersion: {
                type: "boolean"
              },
              name: {},
              resourceType: {},
              status: {},
              creationTime: {
                type: "timestamp"
              },
              lastUpdatedTime: {
                type: "timestamp"
              },
              isResourceTypeDefault: {
                type: "boolean"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ram-2018-01-04.paginators.json
var require_ram_2018_01_04_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ram-2018-01-04.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetResourcePolicies: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetResourceShareAssociations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetResourceShareInvitations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetResourceShares: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListPendingInvitationResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListPermissions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListPrincipals: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListResourceSharePermissions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListResourceTypes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ram.js
var require_ram = __commonJS({
  "node_modules/aws-sdk/clients/ram.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["ram"] = {};
    AWS3.RAM = Service.defineService("ram", ["2018-01-04"]);
    Object.defineProperty(apiLoader.services["ram"], "2018-01-04", {
      get: function get() {
        var model = require_ram_2018_01_04_min();
        model.paginators = require_ram_2018_01_04_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.RAM;
  }
});

// node_modules/aws-sdk/apis/route53resolver-2018-04-01.min.json
var require_route53resolver_2018_04_01_min = __commonJS({
  "node_modules/aws-sdk/apis/route53resolver-2018-04-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-04-01",
        endpointPrefix: "route53resolver",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Route53Resolver",
        serviceFullName: "Amazon Route 53 Resolver",
        serviceId: "Route53Resolver",
        signatureVersion: "v4",
        targetPrefix: "Route53Resolver",
        uid: "route53resolver-2018-04-01"
      },
      operations: {
        AssociateFirewallRuleGroup: {
          input: {
            type: "structure",
            required: [
              "CreatorRequestId",
              "FirewallRuleGroupId",
              "VpcId",
              "Priority",
              "Name"
            ],
            members: {
              CreatorRequestId: {
                idempotencyToken: true
              },
              FirewallRuleGroupId: {},
              VpcId: {},
              Priority: {
                type: "integer"
              },
              Name: {},
              MutationProtection: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRuleGroupAssociation: {
                shape: "Sc"
              }
            }
          }
        },
        AssociateResolverEndpointIpAddress: {
          input: {
            type: "structure",
            required: [
              "ResolverEndpointId",
              "IpAddress"
            ],
            members: {
              ResolverEndpointId: {},
              IpAddress: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverEndpoint: {
                shape: "Sn"
              }
            }
          }
        },
        AssociateResolverQueryLogConfig: {
          input: {
            type: "structure",
            required: [
              "ResolverQueryLogConfigId",
              "ResourceId"
            ],
            members: {
              ResolverQueryLogConfigId: {},
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverQueryLogConfigAssociation: {
                shape: "Su"
              }
            }
          }
        },
        AssociateResolverRule: {
          input: {
            type: "structure",
            required: [
              "ResolverRuleId",
              "VPCId"
            ],
            members: {
              ResolverRuleId: {},
              Name: {},
              VPCId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverRuleAssociation: {
                shape: "S10"
              }
            }
          }
        },
        CreateFirewallDomainList: {
          input: {
            type: "structure",
            required: [
              "CreatorRequestId",
              "Name"
            ],
            members: {
              CreatorRequestId: {
                idempotencyToken: true
              },
              Name: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallDomainList: {
                shape: "S14"
              }
            }
          }
        },
        CreateFirewallRule: {
          input: {
            type: "structure",
            required: [
              "CreatorRequestId",
              "FirewallRuleGroupId",
              "FirewallDomainListId",
              "Priority",
              "Action",
              "Name"
            ],
            members: {
              CreatorRequestId: {
                idempotencyToken: true
              },
              FirewallRuleGroupId: {},
              FirewallDomainListId: {},
              Priority: {
                type: "integer"
              },
              Action: {},
              BlockResponse: {},
              BlockOverrideDomain: {},
              BlockOverrideDnsType: {},
              BlockOverrideTtl: {
                type: "integer"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRule: {
                shape: "S1e"
              }
            }
          }
        },
        CreateFirewallRuleGroup: {
          input: {
            type: "structure",
            required: [
              "CreatorRequestId",
              "Name"
            ],
            members: {
              CreatorRequestId: {
                idempotencyToken: true
              },
              Name: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRuleGroup: {
                shape: "S1h"
              }
            }
          }
        },
        CreateResolverEndpoint: {
          input: {
            type: "structure",
            required: [
              "CreatorRequestId",
              "SecurityGroupIds",
              "Direction",
              "IpAddresses"
            ],
            members: {
              CreatorRequestId: {},
              Name: {},
              SecurityGroupIds: {
                shape: "So"
              },
              Direction: {},
              IpAddresses: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "SubnetId"
                  ],
                  members: {
                    SubnetId: {},
                    Ip: {}
                  }
                }
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverEndpoint: {
                shape: "Sn"
              }
            }
          }
        },
        CreateResolverQueryLogConfig: {
          input: {
            type: "structure",
            required: [
              "Name",
              "DestinationArn",
              "CreatorRequestId"
            ],
            members: {
              Name: {},
              DestinationArn: {},
              CreatorRequestId: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverQueryLogConfig: {
                shape: "S1t"
              }
            }
          }
        },
        CreateResolverRule: {
          input: {
            type: "structure",
            required: [
              "CreatorRequestId",
              "RuleType",
              "DomainName"
            ],
            members: {
              CreatorRequestId: {},
              Name: {},
              RuleType: {},
              DomainName: {},
              TargetIps: {
                shape: "S1z"
              },
              ResolverEndpointId: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverRule: {
                shape: "S23"
              }
            }
          }
        },
        DeleteFirewallDomainList: {
          input: {
            type: "structure",
            required: [
              "FirewallDomainListId"
            ],
            members: {
              FirewallDomainListId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallDomainList: {
                shape: "S14"
              }
            }
          }
        },
        DeleteFirewallRule: {
          input: {
            type: "structure",
            required: [
              "FirewallRuleGroupId",
              "FirewallDomainListId"
            ],
            members: {
              FirewallRuleGroupId: {},
              FirewallDomainListId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRule: {
                shape: "S1e"
              }
            }
          }
        },
        DeleteFirewallRuleGroup: {
          input: {
            type: "structure",
            required: [
              "FirewallRuleGroupId"
            ],
            members: {
              FirewallRuleGroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRuleGroup: {
                shape: "S1h"
              }
            }
          }
        },
        DeleteResolverEndpoint: {
          input: {
            type: "structure",
            required: [
              "ResolverEndpointId"
            ],
            members: {
              ResolverEndpointId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverEndpoint: {
                shape: "Sn"
              }
            }
          }
        },
        DeleteResolverQueryLogConfig: {
          input: {
            type: "structure",
            required: [
              "ResolverQueryLogConfigId"
            ],
            members: {
              ResolverQueryLogConfigId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverQueryLogConfig: {
                shape: "S1t"
              }
            }
          }
        },
        DeleteResolverRule: {
          input: {
            type: "structure",
            required: [
              "ResolverRuleId"
            ],
            members: {
              ResolverRuleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverRule: {
                shape: "S23"
              }
            }
          }
        },
        DisassociateFirewallRuleGroup: {
          input: {
            type: "structure",
            required: [
              "FirewallRuleGroupAssociationId"
            ],
            members: {
              FirewallRuleGroupAssociationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRuleGroupAssociation: {
                shape: "Sc"
              }
            }
          }
        },
        DisassociateResolverEndpointIpAddress: {
          input: {
            type: "structure",
            required: [
              "ResolverEndpointId",
              "IpAddress"
            ],
            members: {
              ResolverEndpointId: {},
              IpAddress: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverEndpoint: {
                shape: "Sn"
              }
            }
          }
        },
        DisassociateResolverQueryLogConfig: {
          input: {
            type: "structure",
            required: [
              "ResolverQueryLogConfigId",
              "ResourceId"
            ],
            members: {
              ResolverQueryLogConfigId: {},
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverQueryLogConfigAssociation: {
                shape: "Su"
              }
            }
          }
        },
        DisassociateResolverRule: {
          input: {
            type: "structure",
            required: [
              "VPCId",
              "ResolverRuleId"
            ],
            members: {
              VPCId: {},
              ResolverRuleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverRuleAssociation: {
                shape: "S10"
              }
            }
          }
        },
        GetFirewallConfig: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallConfig: {
                shape: "S2r"
              }
            }
          }
        },
        GetFirewallDomainList: {
          input: {
            type: "structure",
            required: [
              "FirewallDomainListId"
            ],
            members: {
              FirewallDomainListId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallDomainList: {
                shape: "S14"
              }
            }
          }
        },
        GetFirewallRuleGroup: {
          input: {
            type: "structure",
            required: [
              "FirewallRuleGroupId"
            ],
            members: {
              FirewallRuleGroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRuleGroup: {
                shape: "S1h"
              }
            }
          }
        },
        GetFirewallRuleGroupAssociation: {
          input: {
            type: "structure",
            required: [
              "FirewallRuleGroupAssociationId"
            ],
            members: {
              FirewallRuleGroupAssociationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRuleGroupAssociation: {
                shape: "Sc"
              }
            }
          }
        },
        GetFirewallRuleGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRuleGroupPolicy: {}
            }
          }
        },
        GetResolverDnssecConfig: {
          input: {
            type: "structure",
            required: [
              "ResourceId"
            ],
            members: {
              ResourceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverDNSSECConfig: {
                shape: "S34"
              }
            }
          }
        },
        GetResolverEndpoint: {
          input: {
            type: "structure",
            required: [
              "ResolverEndpointId"
            ],
            members: {
              ResolverEndpointId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverEndpoint: {
                shape: "Sn"
              }
            }
          }
        },
        GetResolverQueryLogConfig: {
          input: {
            type: "structure",
            required: [
              "ResolverQueryLogConfigId"
            ],
            members: {
              ResolverQueryLogConfigId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverQueryLogConfig: {
                shape: "S1t"
              }
            }
          }
        },
        GetResolverQueryLogConfigAssociation: {
          input: {
            type: "structure",
            required: [
              "ResolverQueryLogConfigAssociationId"
            ],
            members: {
              ResolverQueryLogConfigAssociationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverQueryLogConfigAssociation: {
                shape: "Su"
              }
            }
          }
        },
        GetResolverQueryLogConfigPolicy: {
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverQueryLogConfigPolicy: {}
            }
          }
        },
        GetResolverRule: {
          input: {
            type: "structure",
            required: [
              "ResolverRuleId"
            ],
            members: {
              ResolverRuleId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverRule: {
                shape: "S23"
              }
            }
          }
        },
        GetResolverRuleAssociation: {
          input: {
            type: "structure",
            required: [
              "ResolverRuleAssociationId"
            ],
            members: {
              ResolverRuleAssociationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverRuleAssociation: {
                shape: "S10"
              }
            }
          }
        },
        GetResolverRulePolicy: {
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverRulePolicy: {}
            }
          }
        },
        ImportFirewallDomains: {
          input: {
            type: "structure",
            required: [
              "FirewallDomainListId",
              "Operation",
              "DomainFileUrl"
            ],
            members: {
              FirewallDomainListId: {},
              Operation: {},
              DomainFileUrl: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              Name: {},
              Status: {},
              StatusMessage: {}
            }
          }
        },
        ListFirewallConfigs: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              FirewallConfigs: {
                type: "list",
                member: {
                  shape: "S2r"
                }
              }
            }
          }
        },
        ListFirewallDomainLists: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              FirewallDomainLists: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    CreatorRequestId: {},
                    ManagedOwnerName: {}
                  }
                }
              }
            }
          }
        },
        ListFirewallDomains: {
          input: {
            type: "structure",
            required: [
              "FirewallDomainListId"
            ],
            members: {
              FirewallDomainListId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Domains: {
                shape: "S43"
              }
            }
          }
        },
        ListFirewallRuleGroupAssociations: {
          input: {
            type: "structure",
            members: {
              FirewallRuleGroupId: {},
              VpcId: {},
              Priority: {
                type: "integer"
              },
              Status: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              FirewallRuleGroupAssociations: {
                type: "list",
                member: {
                  shape: "Sc"
                }
              }
            }
          }
        },
        ListFirewallRuleGroups: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              FirewallRuleGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {},
                    Name: {},
                    OwnerId: {},
                    CreatorRequestId: {},
                    ShareStatus: {}
                  }
                }
              }
            }
          }
        },
        ListFirewallRules: {
          input: {
            type: "structure",
            required: [
              "FirewallRuleGroupId"
            ],
            members: {
              FirewallRuleGroupId: {},
              Priority: {
                type: "integer"
              },
              Action: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              FirewallRules: {
                type: "list",
                member: {
                  shape: "S1e"
                }
              }
            }
          }
        },
        ListResolverDnssecConfigs: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S4g"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ResolverDnssecConfigs: {
                type: "list",
                member: {
                  shape: "S34"
                }
              }
            }
          }
        },
        ListResolverEndpointIpAddresses: {
          input: {
            type: "structure",
            required: [
              "ResolverEndpointId"
            ],
            members: {
              ResolverEndpointId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              IpAddresses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IpId: {},
                    SubnetId: {},
                    Ip: {},
                    Status: {},
                    StatusMessage: {},
                    CreationTime: {},
                    ModificationTime: {}
                  }
                }
              }
            }
          }
        },
        ListResolverEndpoints: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S4g"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ResolverEndpoints: {
                type: "list",
                member: {
                  shape: "Sn"
                }
              }
            }
          }
        },
        ListResolverQueryLogConfigAssociations: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S4g"
              },
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              TotalCount: {
                type: "integer"
              },
              TotalFilteredCount: {
                type: "integer"
              },
              ResolverQueryLogConfigAssociations: {
                type: "list",
                member: {
                  shape: "Su"
                }
              }
            }
          }
        },
        ListResolverQueryLogConfigs: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S4g"
              },
              SortBy: {},
              SortOrder: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              TotalCount: {
                type: "integer"
              },
              TotalFilteredCount: {
                type: "integer"
              },
              ResolverQueryLogConfigs: {
                type: "list",
                member: {
                  shape: "S1t"
                }
              }
            }
          }
        },
        ListResolverRuleAssociations: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S4g"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ResolverRuleAssociations: {
                type: "list",
                member: {
                  shape: "S10"
                }
              }
            }
          }
        },
        ListResolverRules: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S4g"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ResolverRules: {
                type: "list",
                member: {
                  shape: "S23"
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S7"
              },
              NextToken: {}
            }
          }
        },
        PutFirewallRuleGroupPolicy: {
          input: {
            type: "structure",
            required: [
              "Arn",
              "FirewallRuleGroupPolicy"
            ],
            members: {
              Arn: {},
              FirewallRuleGroupPolicy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReturnValue: {
                type: "boolean"
              }
            }
          }
        },
        PutResolverQueryLogConfigPolicy: {
          input: {
            type: "structure",
            required: [
              "Arn",
              "ResolverQueryLogConfigPolicy"
            ],
            members: {
              Arn: {},
              ResolverQueryLogConfigPolicy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReturnValue: {
                type: "boolean"
              }
            }
          }
        },
        PutResolverRulePolicy: {
          input: {
            type: "structure",
            required: [
              "Arn",
              "ResolverRulePolicy"
            ],
            members: {
              Arn: {},
              ResolverRulePolicy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReturnValue: {
                type: "boolean"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateFirewallConfig: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "FirewallFailOpen"
            ],
            members: {
              ResourceId: {},
              FirewallFailOpen: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallConfig: {
                shape: "S2r"
              }
            }
          }
        },
        UpdateFirewallDomains: {
          input: {
            type: "structure",
            required: [
              "FirewallDomainListId",
              "Operation",
              "Domains"
            ],
            members: {
              FirewallDomainListId: {},
              Operation: {},
              Domains: {
                shape: "S43"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              Name: {},
              Status: {},
              StatusMessage: {}
            }
          }
        },
        UpdateFirewallRule: {
          input: {
            type: "structure",
            required: [
              "FirewallRuleGroupId",
              "FirewallDomainListId"
            ],
            members: {
              FirewallRuleGroupId: {},
              FirewallDomainListId: {},
              Priority: {
                type: "integer"
              },
              Action: {},
              BlockResponse: {},
              BlockOverrideDomain: {},
              BlockOverrideDnsType: {},
              BlockOverrideTtl: {
                type: "integer"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRule: {
                shape: "S1e"
              }
            }
          }
        },
        UpdateFirewallRuleGroupAssociation: {
          input: {
            type: "structure",
            required: [
              "FirewallRuleGroupAssociationId"
            ],
            members: {
              FirewallRuleGroupAssociationId: {},
              Priority: {
                type: "integer"
              },
              MutationProtection: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallRuleGroupAssociation: {
                shape: "Sc"
              }
            }
          }
        },
        UpdateResolverDnssecConfig: {
          input: {
            type: "structure",
            required: [
              "ResourceId",
              "Validation"
            ],
            members: {
              ResourceId: {},
              Validation: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverDNSSECConfig: {
                shape: "S34"
              }
            }
          }
        },
        UpdateResolverEndpoint: {
          input: {
            type: "structure",
            required: [
              "ResolverEndpointId"
            ],
            members: {
              ResolverEndpointId: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverEndpoint: {
                shape: "Sn"
              }
            }
          }
        },
        UpdateResolverRule: {
          input: {
            type: "structure",
            required: [
              "ResolverRuleId",
              "Config"
            ],
            members: {
              ResolverRuleId: {},
              Config: {
                type: "structure",
                members: {
                  Name: {},
                  TargetIps: {
                    shape: "S1z"
                  },
                  ResolverEndpointId: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResolverRule: {
                shape: "S23"
              }
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sc: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            FirewallRuleGroupId: {},
            VpcId: {},
            Name: {},
            Priority: {
              type: "integer"
            },
            MutationProtection: {},
            ManagedOwnerName: {},
            Status: {},
            StatusMessage: {},
            CreatorRequestId: {},
            CreationTime: {},
            ModificationTime: {}
          }
        },
        Sj: {
          type: "structure",
          members: {
            IpId: {},
            SubnetId: {},
            Ip: {}
          }
        },
        Sn: {
          type: "structure",
          members: {
            Id: {},
            CreatorRequestId: {},
            Arn: {},
            Name: {},
            SecurityGroupIds: {
              shape: "So"
            },
            Direction: {},
            IpAddressCount: {
              type: "integer"
            },
            HostVPCId: {},
            Status: {},
            StatusMessage: {},
            CreationTime: {},
            ModificationTime: {}
          }
        },
        So: {
          type: "list",
          member: {}
        },
        Su: {
          type: "structure",
          members: {
            Id: {},
            ResolverQueryLogConfigId: {},
            ResourceId: {},
            Status: {},
            Error: {},
            ErrorMessage: {},
            CreationTime: {}
          }
        },
        S10: {
          type: "structure",
          members: {
            Id: {},
            ResolverRuleId: {},
            Name: {},
            VPCId: {},
            Status: {},
            StatusMessage: {}
          }
        },
        S14: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {},
            DomainCount: {
              type: "integer"
            },
            Status: {},
            StatusMessage: {},
            ManagedOwnerName: {},
            CreatorRequestId: {},
            CreationTime: {},
            ModificationTime: {}
          }
        },
        S1e: {
          type: "structure",
          members: {
            FirewallRuleGroupId: {},
            FirewallDomainListId: {},
            Name: {},
            Priority: {
              type: "integer"
            },
            Action: {},
            BlockResponse: {},
            BlockOverrideDomain: {},
            BlockOverrideDnsType: {},
            BlockOverrideTtl: {
              type: "integer"
            },
            CreatorRequestId: {},
            CreationTime: {},
            ModificationTime: {}
          }
        },
        S1h: {
          type: "structure",
          members: {
            Id: {},
            Arn: {},
            Name: {},
            RuleCount: {
              type: "integer"
            },
            Status: {},
            StatusMessage: {},
            OwnerId: {},
            CreatorRequestId: {},
            ShareStatus: {},
            CreationTime: {},
            ModificationTime: {}
          }
        },
        S1t: {
          type: "structure",
          members: {
            Id: {},
            OwnerId: {},
            Status: {},
            ShareStatus: {},
            AssociationCount: {
              type: "integer"
            },
            Arn: {},
            Name: {},
            DestinationArn: {},
            CreatorRequestId: {},
            CreationTime: {}
          }
        },
        S1z: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Ip"
            ],
            members: {
              Ip: {},
              Port: {
                type: "integer"
              }
            }
          }
        },
        S23: {
          type: "structure",
          members: {
            Id: {},
            CreatorRequestId: {},
            Arn: {},
            DomainName: {},
            Status: {},
            StatusMessage: {},
            RuleType: {},
            Name: {},
            TargetIps: {
              shape: "S1z"
            },
            ResolverEndpointId: {},
            OwnerId: {},
            ShareStatus: {},
            CreationTime: {},
            ModificationTime: {}
          }
        },
        S2r: {
          type: "structure",
          members: {
            Id: {},
            ResourceId: {},
            OwnerId: {},
            FirewallFailOpen: {}
          }
        },
        S34: {
          type: "structure",
          members: {
            Id: {},
            OwnerId: {},
            ResourceId: {},
            ValidationStatus: {}
          }
        },
        S43: {
          type: "list",
          member: {}
        },
        S4g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/route53resolver-2018-04-01.paginators.json
var require_route53resolver_2018_04_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/route53resolver-2018-04-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListFirewallConfigs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FirewallConfigs"
        },
        ListFirewallDomainLists: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FirewallDomainLists"
        },
        ListFirewallDomains: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Domains"
        },
        ListFirewallRuleGroupAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FirewallRuleGroupAssociations"
        },
        ListFirewallRuleGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FirewallRuleGroups"
        },
        ListFirewallRules: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FirewallRules"
        },
        ListResolverDnssecConfigs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ResolverDnssecConfigs"
        },
        ListResolverEndpointIpAddresses: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "IpAddresses"
        },
        ListResolverEndpoints: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ResolverEndpoints"
        },
        ListResolverQueryLogConfigAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ResolverQueryLogConfigAssociations"
        },
        ListResolverQueryLogConfigs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ResolverQueryLogConfigs"
        },
        ListResolverRuleAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ResolverRuleAssociations"
        },
        ListResolverRules: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ResolverRules"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Tags"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/route53resolver.js
var require_route53resolver = __commonJS({
  "node_modules/aws-sdk/clients/route53resolver.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["route53resolver"] = {};
    AWS3.Route53Resolver = Service.defineService("route53resolver", ["2018-04-01"]);
    Object.defineProperty(apiLoader.services["route53resolver"], "2018-04-01", {
      get: function get() {
        var model = require_route53resolver_2018_04_01_min();
        model.paginators = require_route53resolver_2018_04_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Route53Resolver;
  }
});

// node_modules/aws-sdk/apis/sms-voice-2018-09-05.min.json
var require_sms_voice_2018_09_05_min = __commonJS({
  "node_modules/aws-sdk/apis/sms-voice-2018-09-05.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2018-09-05",
        endpointPrefix: "sms-voice.pinpoint",
        signingName: "sms-voice",
        serviceAbbreviation: "Pinpoint SMS Voice",
        serviceFullName: "Amazon Pinpoint SMS and Voice Service",
        serviceId: "Pinpoint SMS Voice",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "pinpoint-sms-voice-2018-09-05",
        signatureVersion: "v4"
      },
      operations: {
        CreateConfigurationSet: {
          http: {
            requestUri: "/v1/sms-voice/configuration-sets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConfigurationSetName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateConfigurationSetEventDestination: {
          http: {
            requestUri: "/v1/sms-voice/configuration-sets/{ConfigurationSetName}/event-destinations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              EventDestination: {
                shape: "S6"
              },
              EventDestinationName: {}
            },
            required: [
              "ConfigurationSetName"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteConfigurationSet: {
          http: {
            method: "DELETE",
            requestUri: "/v1/sms-voice/configuration-sets/{ConfigurationSetName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              }
            },
            required: [
              "ConfigurationSetName"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteConfigurationSetEventDestination: {
          http: {
            method: "DELETE",
            requestUri: "/v1/sms-voice/configuration-sets/{ConfigurationSetName}/event-destinations/{EventDestinationName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              EventDestinationName: {
                location: "uri",
                locationName: "EventDestinationName"
              }
            },
            required: [
              "EventDestinationName",
              "ConfigurationSetName"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetConfigurationSetEventDestinations: {
          http: {
            method: "GET",
            requestUri: "/v1/sms-voice/configuration-sets/{ConfigurationSetName}/event-destinations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              }
            },
            required: [
              "ConfigurationSetName"
            ]
          },
          output: {
            type: "structure",
            members: {
              EventDestinations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CloudWatchLogsDestination: {
                      shape: "S7"
                    },
                    Enabled: {
                      type: "boolean"
                    },
                    KinesisFirehoseDestination: {
                      shape: "Sa"
                    },
                    MatchingEventTypes: {
                      shape: "Sb"
                    },
                    Name: {},
                    SnsDestination: {
                      shape: "Sd"
                    }
                  }
                }
              }
            }
          }
        },
        ListConfigurationSets: {
          http: {
            method: "GET",
            requestUri: "/v1/sms-voice/configuration-sets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationSets: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        SendVoiceMessage: {
          http: {
            requestUri: "/v1/sms-voice/voice/message",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CallerId: {},
              ConfigurationSetName: {},
              Content: {
                type: "structure",
                members: {
                  CallInstructionsMessage: {
                    type: "structure",
                    members: {
                      Text: {}
                    },
                    required: []
                  },
                  PlainTextMessage: {
                    type: "structure",
                    members: {
                      LanguageCode: {},
                      Text: {},
                      VoiceId: {}
                    },
                    required: []
                  },
                  SSMLMessage: {
                    type: "structure",
                    members: {
                      LanguageCode: {},
                      Text: {},
                      VoiceId: {}
                    },
                    required: []
                  }
                }
              },
              DestinationPhoneNumber: {},
              OriginationPhoneNumber: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MessageId: {}
            }
          }
        },
        UpdateConfigurationSetEventDestination: {
          http: {
            method: "PUT",
            requestUri: "/v1/sms-voice/configuration-sets/{ConfigurationSetName}/event-destinations/{EventDestinationName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              EventDestination: {
                shape: "S6"
              },
              EventDestinationName: {
                location: "uri",
                locationName: "EventDestinationName"
              }
            },
            required: [
              "EventDestinationName",
              "ConfigurationSetName"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S6: {
          type: "structure",
          members: {
            CloudWatchLogsDestination: {
              shape: "S7"
            },
            Enabled: {
              type: "boolean"
            },
            KinesisFirehoseDestination: {
              shape: "Sa"
            },
            MatchingEventTypes: {
              shape: "Sb"
            },
            SnsDestination: {
              shape: "Sd"
            }
          },
          required: []
        },
        S7: {
          type: "structure",
          members: {
            IamRoleArn: {},
            LogGroupArn: {}
          },
          required: []
        },
        Sa: {
          type: "structure",
          members: {
            DeliveryStreamArn: {},
            IamRoleArn: {}
          },
          required: []
        },
        Sb: {
          type: "list",
          member: {}
        },
        Sd: {
          type: "structure",
          members: {
            TopicArn: {}
          },
          required: []
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/pinpointsmsvoice.js
var require_pinpointsmsvoice = __commonJS({
  "node_modules/aws-sdk/clients/pinpointsmsvoice.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["pinpointsmsvoice"] = {};
    AWS3.PinpointSMSVoice = Service.defineService("pinpointsmsvoice", ["2018-09-05"]);
    Object.defineProperty(apiLoader.services["pinpointsmsvoice"], "2018-09-05", {
      get: function get() {
        var model = require_sms_voice_2018_09_05_min();
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.PinpointSMSVoice;
  }
});

// node_modules/aws-sdk/apis/quicksight-2018-04-01.min.json
var require_quicksight_2018_04_01_min = __commonJS({
  "node_modules/aws-sdk/apis/quicksight-2018-04-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-04-01",
        endpointPrefix: "quicksight",
        jsonVersion: "1.0",
        protocol: "rest-json",
        serviceFullName: "Amazon QuickSight",
        serviceId: "QuickSight",
        signatureVersion: "v4",
        uid: "quicksight-2018-04-01"
      },
      operations: {
        CancelIngestion: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}/ingestions/{IngestionId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId",
              "IngestionId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              IngestionId: {
                location: "uri",
                locationName: "IngestionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              IngestionId: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        CreateAccountCustomization: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/customizations"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AccountCustomization"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              AccountCustomization: {
                shape: "Sa"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AwsAccountId: {},
              Namespace: {},
              AccountCustomization: {
                shape: "Sa"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        CreateAnalysis: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/analyses/{AnalysisId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AnalysisId",
              "Name",
              "SourceEntity"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AnalysisId: {
                location: "uri",
                locationName: "AnalysisId"
              },
              Name: {},
              Parameters: {
                shape: "Sj"
              },
              Permissions: {
                shape: "S10"
              },
              SourceEntity: {
                shape: "S14"
              },
              ThemeArn: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AnalysisId: {},
              CreationStatus: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        CreateDashboard: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId",
              "Name",
              "SourceEntity"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              Name: {},
              Parameters: {
                shape: "Sj"
              },
              Permissions: {
                shape: "S10"
              },
              SourceEntity: {
                shape: "S1c"
              },
              Tags: {
                shape: "Sb"
              },
              VersionDescription: {},
              DashboardPublishOptions: {
                shape: "S1f"
              },
              ThemeArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              VersionArn: {},
              DashboardId: {},
              CreationStatus: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        CreateDataSet: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/data-sets"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId",
              "Name",
              "PhysicalTableMap",
              "ImportMode"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {},
              Name: {},
              PhysicalTableMap: {
                shape: "S1p"
              },
              LogicalTableMap: {
                shape: "S2a"
              },
              ImportMode: {},
              ColumnGroups: {
                shape: "S37"
              },
              FieldFolders: {
                shape: "S3d"
              },
              Permissions: {
                shape: "S10"
              },
              RowLevelPermissionDataSet: {
                shape: "S3i"
              },
              RowLevelPermissionTagConfiguration: {
                shape: "S3m"
              },
              ColumnLevelPermissionRules: {
                shape: "S3s"
              },
              Tags: {
                shape: "Sb"
              },
              DataSetUsageConfiguration: {
                shape: "S3w"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              DataSetId: {},
              IngestionArn: {},
              IngestionId: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        CreateDataSource: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/data-sources"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSourceId",
              "Name",
              "Type"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSourceId: {},
              Name: {},
              Type: {},
              DataSourceParameters: {
                shape: "S40"
              },
              Credentials: {
                shape: "S52"
              },
              Permissions: {
                shape: "S10"
              },
              VpcConnectionProperties: {
                shape: "S58"
              },
              SslProperties: {
                shape: "S59"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              DataSourceId: {},
              CreationStatus: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        CreateFolder: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/folders/{FolderId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "FolderId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              Name: {},
              FolderType: {},
              ParentFolderArn: {},
              Permissions: {
                shape: "S10"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              Arn: {},
              FolderId: {},
              RequestId: {}
            }
          }
        },
        CreateFolderMembership: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/folders/{FolderId}/members/{MemberType}/{MemberId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "FolderId",
              "MemberId",
              "MemberType"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              MemberId: {
                location: "uri",
                locationName: "MemberId"
              },
              MemberType: {
                location: "uri",
                locationName: "MemberType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                type: "integer"
              },
              FolderMember: {
                type: "structure",
                members: {
                  MemberId: {},
                  MemberType: {}
                }
              },
              RequestId: {}
            }
          }
        },
        CreateGroup: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/groups"
          },
          input: {
            type: "structure",
            required: [
              "GroupName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              GroupName: {},
              Description: {},
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "S5n"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        CreateGroupMembership: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/groups/{GroupName}/members/{MemberName}"
          },
          input: {
            type: "structure",
            required: [
              "MemberName",
              "GroupName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              MemberName: {
                location: "uri",
                locationName: "MemberName"
              },
              GroupName: {
                location: "uri",
                locationName: "GroupName"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupMember: {
                shape: "S5r"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        CreateIAMPolicyAssignment: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/iam-policy-assignments/"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AssignmentName",
              "AssignmentStatus",
              "Namespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AssignmentName: {},
              AssignmentStatus: {},
              PolicyArn: {},
              Identities: {
                shape: "S5v"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssignmentName: {},
              AssignmentId: {},
              AssignmentStatus: {},
              PolicyArn: {},
              Identities: {
                shape: "S5v"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        CreateIngestion: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}/ingestions/{IngestionId}"
          },
          input: {
            type: "structure",
            required: [
              "DataSetId",
              "IngestionId",
              "AwsAccountId"
            ],
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              IngestionId: {
                location: "uri",
                locationName: "IngestionId"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              IngestionType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              IngestionId: {},
              IngestionStatus: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        CreateNamespace: {
          http: {
            requestUri: "/accounts/{AwsAccountId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Namespace",
              "IdentityStore"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {},
              IdentityStore: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Name: {},
              CapacityRegion: {},
              CreationStatus: {},
              IdentityStore: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        CreateTemplate: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId",
              "SourceEntity"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              Name: {},
              Permissions: {
                shape: "S10"
              },
              SourceEntity: {
                shape: "S69"
              },
              Tags: {
                shape: "Sb"
              },
              VersionDescription: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              VersionArn: {},
              TemplateId: {},
              CreationStatus: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        CreateTemplateAlias: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}/aliases/{AliasName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId",
              "AliasName",
              "TemplateVersionNumber"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              AliasName: {
                location: "uri",
                locationName: "AliasName"
              },
              TemplateVersionNumber: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateAlias: {
                shape: "S6h"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        CreateTheme: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId",
              "Name",
              "BaseThemeId",
              "Configuration"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              Name: {},
              BaseThemeId: {},
              VersionDescription: {},
              Configuration: {
                shape: "S6k"
              },
              Permissions: {
                shape: "S10"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              VersionArn: {},
              ThemeId: {},
              CreationStatus: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        CreateThemeAlias: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}/aliases/{AliasName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId",
              "AliasName",
              "ThemeVersionNumber"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              AliasName: {
                location: "uri",
                locationName: "AliasName"
              },
              ThemeVersionNumber: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ThemeAlias: {
                shape: "S6z"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DeleteAccountCustomization: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/customizations"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "querystring",
                locationName: "namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteAnalysis: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/analyses/{AnalysisId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AnalysisId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AnalysisId: {
                location: "uri",
                locationName: "AnalysisId"
              },
              RecoveryWindowInDays: {
                location: "querystring",
                locationName: "recovery-window-in-days",
                type: "long"
              },
              ForceDeleteWithoutRecovery: {
                location: "querystring",
                locationName: "force-delete-without-recovery",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              Arn: {},
              AnalysisId: {},
              DeletionTime: {
                type: "timestamp"
              },
              RequestId: {}
            }
          }
        },
        DeleteDashboard: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              VersionNumber: {
                location: "querystring",
                locationName: "version-number",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              Arn: {},
              DashboardId: {},
              RequestId: {}
            }
          }
        },
        DeleteDataSet: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              DataSetId: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteDataSource: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/data-sources/{DataSourceId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSourceId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSourceId: {
                location: "uri",
                locationName: "DataSourceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              DataSourceId: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteFolder: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/folders/{FolderId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "FolderId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              Arn: {},
              FolderId: {},
              RequestId: {}
            }
          }
        },
        DeleteFolderMembership: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/folders/{FolderId}/members/{MemberType}/{MemberId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "FolderId",
              "MemberId",
              "MemberType"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              MemberId: {
                location: "uri",
                locationName: "MemberId"
              },
              MemberType: {
                location: "uri",
                locationName: "MemberType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DeleteGroup: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/groups/{GroupName}"
          },
          input: {
            type: "structure",
            required: [
              "GroupName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              GroupName: {
                location: "uri",
                locationName: "GroupName"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteGroupMembership: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/groups/{GroupName}/members/{MemberName}"
          },
          input: {
            type: "structure",
            required: [
              "MemberName",
              "GroupName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              MemberName: {
                location: "uri",
                locationName: "MemberName"
              },
              GroupName: {
                location: "uri",
                locationName: "GroupName"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteIAMPolicyAssignment: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/namespace/{Namespace}/iam-policy-assignments/{AssignmentName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AssignmentName",
              "Namespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AssignmentName: {
                location: "uri",
                locationName: "AssignmentName"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssignmentName: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteNamespace: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              VersionNumber: {
                location: "querystring",
                locationName: "version-number",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Arn: {},
              TemplateId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteTemplateAlias: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}/aliases/{AliasName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId",
              "AliasName"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              AliasName: {
                location: "uri",
                locationName: "AliasName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              TemplateId: {},
              AliasName: {},
              Arn: {},
              RequestId: {}
            }
          }
        },
        DeleteTheme: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              VersionNumber: {
                location: "querystring",
                locationName: "version-number",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              ThemeId: {}
            }
          }
        },
        DeleteThemeAlias: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}/aliases/{AliasName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId",
              "AliasName"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              AliasName: {
                location: "uri",
                locationName: "AliasName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AliasName: {},
              Arn: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              ThemeId: {}
            }
          }
        },
        DeleteUser: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/users/{UserName}"
          },
          input: {
            type: "structure",
            required: [
              "UserName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              UserName: {
                location: "uri",
                locationName: "UserName"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DeleteUserByPrincipalId: {
          http: {
            method: "DELETE",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/user-principals/{PrincipalId}"
          },
          input: {
            type: "structure",
            required: [
              "PrincipalId",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              PrincipalId: {
                location: "uri",
                locationName: "PrincipalId"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeAccountCustomization: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/customizations"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              Resolved: {
                location: "querystring",
                locationName: "resolved",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AwsAccountId: {},
              Namespace: {},
              AccountCustomization: {
                shape: "Sa"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeAccountSettings: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/settings"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccountSettings: {
                type: "structure",
                members: {
                  AccountName: {},
                  Edition: {},
                  DefaultNamespace: {},
                  NotificationEmail: {}
                }
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeAnalysis: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/analyses/{AnalysisId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AnalysisId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AnalysisId: {
                location: "uri",
                locationName: "AnalysisId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Analysis: {
                type: "structure",
                members: {
                  AnalysisId: {},
                  Arn: {},
                  Name: {},
                  Status: {},
                  Errors: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Type: {},
                        Message: {}
                      }
                    }
                  },
                  DataSetArns: {
                    shape: "S8c"
                  },
                  ThemeArn: {},
                  CreatedTime: {
                    type: "timestamp"
                  },
                  LastUpdatedTime: {
                    type: "timestamp"
                  },
                  Sheets: {
                    shape: "S8d"
                  }
                }
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DescribeAnalysisPermissions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/analyses/{AnalysisId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AnalysisId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AnalysisId: {
                location: "uri",
                locationName: "AnalysisId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AnalysisId: {},
              AnalysisArn: {},
              Permissions: {
                shape: "S10"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DescribeDashboard: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              VersionNumber: {
                location: "querystring",
                locationName: "version-number",
                type: "long"
              },
              AliasName: {
                location: "querystring",
                locationName: "alias-name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Dashboard: {
                type: "structure",
                members: {
                  DashboardId: {},
                  Arn: {},
                  Name: {},
                  Version: {
                    type: "structure",
                    members: {
                      CreatedTime: {
                        type: "timestamp"
                      },
                      Errors: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            Type: {},
                            Message: {}
                          }
                        }
                      },
                      VersionNumber: {
                        type: "long"
                      },
                      Status: {},
                      Arn: {},
                      SourceEntityArn: {},
                      DataSetArns: {
                        shape: "S8c"
                      },
                      Description: {},
                      ThemeArn: {},
                      Sheets: {
                        shape: "S8d"
                      }
                    }
                  },
                  CreatedTime: {
                    type: "timestamp"
                  },
                  LastPublishedTime: {
                    type: "timestamp"
                  },
                  LastUpdatedTime: {
                    type: "timestamp"
                  }
                }
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DescribeDashboardPermissions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DashboardId: {},
              DashboardArn: {},
              Permissions: {
                shape: "S10"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DescribeDataSet: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSet: {
                type: "structure",
                members: {
                  Arn: {},
                  DataSetId: {},
                  Name: {},
                  CreatedTime: {
                    type: "timestamp"
                  },
                  LastUpdatedTime: {
                    type: "timestamp"
                  },
                  PhysicalTableMap: {
                    shape: "S1p"
                  },
                  LogicalTableMap: {
                    shape: "S2a"
                  },
                  OutputColumns: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        Description: {},
                        Type: {}
                      }
                    }
                  },
                  ImportMode: {},
                  ConsumedSpiceCapacityInBytes: {
                    type: "long"
                  },
                  ColumnGroups: {
                    shape: "S37"
                  },
                  FieldFolders: {
                    shape: "S3d"
                  },
                  RowLevelPermissionDataSet: {
                    shape: "S3i"
                  },
                  RowLevelPermissionTagConfiguration: {
                    shape: "S3m"
                  },
                  ColumnLevelPermissionRules: {
                    shape: "S3s"
                  },
                  DataSetUsageConfiguration: {
                    shape: "S3w"
                  }
                }
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeDataSetPermissions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSetArn: {},
              DataSetId: {},
              Permissions: {
                shape: "S10"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeDataSource: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/data-sources/{DataSourceId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSourceId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSourceId: {
                location: "uri",
                locationName: "DataSourceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSource: {
                shape: "S8z"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeDataSourcePermissions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/data-sources/{DataSourceId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSourceId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSourceId: {
                location: "uri",
                locationName: "DataSourceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSourceArn: {},
              DataSourceId: {},
              Permissions: {
                shape: "S10"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeFolder: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/folders/{FolderId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "FolderId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              Folder: {
                type: "structure",
                members: {
                  FolderId: {},
                  Arn: {},
                  Name: {},
                  FolderType: {},
                  FolderPath: {
                    type: "list",
                    member: {}
                  },
                  CreatedTime: {
                    type: "timestamp"
                  },
                  LastUpdatedTime: {
                    type: "timestamp"
                  }
                }
              },
              RequestId: {}
            }
          }
        },
        DescribeFolderPermissions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/folders/{FolderId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "FolderId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              FolderId: {},
              Arn: {},
              Permissions: {
                shape: "S10"
              },
              RequestId: {}
            }
          }
        },
        DescribeFolderResolvedPermissions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/folders/{FolderId}/resolved-permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "FolderId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              FolderId: {},
              Arn: {},
              Permissions: {
                shape: "S10"
              },
              RequestId: {}
            }
          }
        },
        DescribeGroup: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/groups/{GroupName}"
          },
          input: {
            type: "structure",
            required: [
              "GroupName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              GroupName: {
                location: "uri",
                locationName: "GroupName"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "S5n"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeIAMPolicyAssignment: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/iam-policy-assignments/{AssignmentName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AssignmentName",
              "Namespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AssignmentName: {
                location: "uri",
                locationName: "AssignmentName"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IAMPolicyAssignment: {
                type: "structure",
                members: {
                  AwsAccountId: {},
                  AssignmentId: {},
                  AssignmentName: {},
                  PolicyArn: {},
                  Identities: {
                    shape: "S5v"
                  },
                  AssignmentStatus: {}
                }
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeIngestion: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}/ingestions/{IngestionId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId",
              "IngestionId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              IngestionId: {
                location: "uri",
                locationName: "IngestionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Ingestion: {
                shape: "S9j"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeIpRestriction: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/ip-restriction"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AwsAccountId: {},
              IpRestrictionRuleMap: {
                shape: "S9s"
              },
              Enabled: {
                type: "boolean"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeNamespace: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Namespace: {
                shape: "S9y"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeTemplate: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              VersionNumber: {
                location: "querystring",
                locationName: "version-number",
                type: "long"
              },
              AliasName: {
                location: "querystring",
                locationName: "alias-name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Template: {
                type: "structure",
                members: {
                  Arn: {},
                  Name: {},
                  Version: {
                    type: "structure",
                    members: {
                      CreatedTime: {
                        type: "timestamp"
                      },
                      Errors: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            Type: {},
                            Message: {}
                          }
                        }
                      },
                      VersionNumber: {
                        type: "long"
                      },
                      Status: {},
                      DataSetConfigurations: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            Placeholder: {},
                            DataSetSchema: {
                              type: "structure",
                              members: {
                                ColumnSchemaList: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Name: {},
                                      DataType: {},
                                      GeographicRole: {}
                                    }
                                  }
                                }
                              }
                            },
                            ColumnGroupSchemaList: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  Name: {},
                                  ColumnGroupColumnSchemaList: {
                                    type: "list",
                                    member: {
                                      type: "structure",
                                      members: {
                                        Name: {}
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      },
                      Description: {},
                      SourceEntityArn: {},
                      ThemeArn: {},
                      Sheets: {
                        shape: "S8d"
                      }
                    }
                  },
                  TemplateId: {},
                  LastUpdatedTime: {
                    type: "timestamp"
                  },
                  CreatedTime: {
                    type: "timestamp"
                  }
                }
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DescribeTemplateAlias: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}/aliases/{AliasName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId",
              "AliasName"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              AliasName: {
                location: "uri",
                locationName: "AliasName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateAlias: {
                shape: "S6h"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DescribeTemplatePermissions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateId: {},
              TemplateArn: {},
              Permissions: {
                shape: "S10"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeTheme: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              VersionNumber: {
                location: "querystring",
                locationName: "version-number",
                type: "long"
              },
              AliasName: {
                location: "querystring",
                locationName: "alias-name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Theme: {
                type: "structure",
                members: {
                  Arn: {},
                  Name: {},
                  ThemeId: {},
                  Version: {
                    type: "structure",
                    members: {
                      VersionNumber: {
                        type: "long"
                      },
                      Arn: {},
                      Description: {},
                      BaseThemeId: {},
                      CreatedTime: {
                        type: "timestamp"
                      },
                      Configuration: {
                        shape: "S6k"
                      },
                      Errors: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            Type: {},
                            Message: {}
                          }
                        }
                      },
                      Status: {}
                    }
                  },
                  CreatedTime: {
                    type: "timestamp"
                  },
                  LastUpdatedTime: {
                    type: "timestamp"
                  },
                  Type: {}
                }
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DescribeThemeAlias: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}/aliases/{AliasName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId",
              "AliasName"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              AliasName: {
                location: "uri",
                locationName: "AliasName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ThemeAlias: {
                shape: "S6z"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        DescribeThemePermissions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ThemeId: {},
              ThemeArn: {},
              Permissions: {
                shape: "S10"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        DescribeUser: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/users/{UserName}"
          },
          input: {
            type: "structure",
            required: [
              "UserName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              UserName: {
                location: "uri",
                locationName: "UserName"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "Sb0"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        GenerateEmbedUrlForAnonymousUser: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/embed-url/anonymous-user"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Namespace",
              "AuthorizedResourceArns",
              "ExperienceConfiguration"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              SessionLifetimeInMinutes: {
                type: "long"
              },
              Namespace: {},
              SessionTags: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Value"
                  ],
                  members: {
                    Key: {},
                    Value: {
                      shape: "S3r"
                    }
                  }
                }
              },
              AuthorizedResourceArns: {
                type: "list",
                member: {}
              },
              ExperienceConfiguration: {
                type: "structure",
                members: {
                  Dashboard: {
                    type: "structure",
                    required: [
                      "InitialDashboardId"
                    ],
                    members: {
                      InitialDashboardId: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EmbedUrl",
              "Status",
              "RequestId"
            ],
            members: {
              EmbedUrl: {
                shape: "Sbc"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        GenerateEmbedUrlForRegisteredUser: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/embed-url/registered-user"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "UserArn",
              "ExperienceConfiguration"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              SessionLifetimeInMinutes: {
                type: "long"
              },
              UserArn: {},
              ExperienceConfiguration: {
                type: "structure",
                members: {
                  Dashboard: {
                    type: "structure",
                    required: [
                      "InitialDashboardId"
                    ],
                    members: {
                      InitialDashboardId: {}
                    }
                  },
                  QuickSightConsole: {
                    type: "structure",
                    members: {
                      InitialPath: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EmbedUrl",
              "Status",
              "RequestId"
            ],
            members: {
              EmbedUrl: {
                shape: "Sbc"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        GetDashboardEmbedUrl: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}/embed-url"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId",
              "IdentityType"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              IdentityType: {
                location: "querystring",
                locationName: "creds-type"
              },
              SessionLifetimeInMinutes: {
                location: "querystring",
                locationName: "session-lifetime",
                type: "long"
              },
              UndoRedoDisabled: {
                location: "querystring",
                locationName: "undo-redo-disabled",
                type: "boolean"
              },
              ResetDisabled: {
                location: "querystring",
                locationName: "reset-disabled",
                type: "boolean"
              },
              StatePersistenceEnabled: {
                location: "querystring",
                locationName: "state-persistence-enabled",
                type: "boolean"
              },
              UserArn: {
                location: "querystring",
                locationName: "user-arn"
              },
              Namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              AdditionalDashboardIds: {
                location: "querystring",
                locationName: "additional-dashboard-ids",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EmbedUrl: {
                shape: "Sbc"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        GetSessionEmbedUrl: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/session-embed-url"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              EntryPoint: {
                location: "querystring",
                locationName: "entry-point"
              },
              SessionLifetimeInMinutes: {
                location: "querystring",
                locationName: "session-lifetime",
                type: "long"
              },
              UserArn: {
                location: "querystring",
                locationName: "user-arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EmbedUrl: {
                shape: "Sbc"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        ListAnalyses: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/analyses"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AnalysisSummaryList: {
                shape: "Sbt"
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        ListDashboardVersions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}/versions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DashboardVersionSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    VersionNumber: {
                      type: "long"
                    },
                    Status: {},
                    SourceEntityArn: {},
                    Description: {}
                  }
                }
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        ListDashboards: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/dashboards"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DashboardSummaryList: {
                shape: "Sc1"
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        ListDataSets: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/data-sets"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSetSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    DataSetId: {},
                    Name: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    },
                    ImportMode: {},
                    RowLevelPermissionDataSet: {
                      shape: "S3i"
                    },
                    RowLevelPermissionTagConfigurationApplied: {
                      type: "boolean"
                    },
                    ColumnLevelPermissionRulesApplied: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListDataSources: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/data-sources"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSources: {
                type: "list",
                member: {
                  shape: "S8z"
                }
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListFolderMembers: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/folders/{FolderId}/members"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "FolderId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              FolderMemberList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MemberId: {},
                    MemberArn: {}
                  }
                }
              },
              NextToken: {},
              RequestId: {}
            }
          }
        },
        ListFolders: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/folders"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              FolderSummaryList: {
                shape: "Scg"
              },
              NextToken: {},
              RequestId: {}
            }
          }
        },
        ListGroupMemberships: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/groups/{GroupName}/members"
          },
          input: {
            type: "structure",
            required: [
              "GroupName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              GroupName: {
                location: "uri",
                locationName: "GroupName"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupMemberList: {
                type: "list",
                member: {
                  shape: "S5r"
                }
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListGroups: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/groups"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupList: {
                shape: "Scn"
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListIAMPolicyAssignments: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/iam-policy-assignments"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AssignmentStatus: {},
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IAMPolicyAssignments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssignmentName: {},
                    AssignmentStatus: {}
                  }
                }
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListIAMPolicyAssignmentsForUser: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/users/{UserName}/iam-policy-assignments"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "UserName",
              "Namespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              UserName: {
                location: "uri",
                locationName: "UserName"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ActiveAssignments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssignmentName: {},
                    PolicyArn: {}
                  }
                }
              },
              RequestId: {},
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListIngestions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}/ingestions"
          },
          input: {
            type: "structure",
            required: [
              "DataSetId",
              "AwsAccountId"
            ],
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Ingestions: {
                type: "list",
                member: {
                  shape: "S9j"
                }
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListNamespaces: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Namespaces: {
                type: "list",
                member: {
                  shape: "S9y"
                }
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/resources/{ResourceArn}/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sb"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListTemplateAliases: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}/aliases"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-result",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateAliasList: {
                type: "list",
                member: {
                  shape: "S6h"
                }
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {},
              NextToken: {}
            }
          }
        },
        ListTemplateVersions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}/versions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateVersionSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    VersionNumber: {
                      type: "long"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    },
                    Status: {},
                    Description: {}
                  }
                }
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        ListTemplates: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/templates"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-result",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    TemplateId: {},
                    Name: {},
                    LatestVersionNumber: {
                      type: "long"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        ListThemeAliases: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}/aliases"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-result",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ThemeAliasList: {
                type: "list",
                member: {
                  shape: "S6z"
                }
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {},
              NextToken: {}
            }
          }
        },
        ListThemeVersions: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}/versions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ThemeVersionSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VersionNumber: {
                      type: "long"
                    },
                    Arn: {},
                    Description: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    Status: {}
                  }
                }
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        ListThemes: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/themes"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              Type: {
                location: "querystring",
                locationName: "type"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ThemeSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {},
                    ThemeId: {},
                    LatestVersionNumber: {
                      type: "long"
                    },
                    CreatedTime: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        ListUserGroups: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/users/{UserName}/groups"
          },
          input: {
            type: "structure",
            required: [
              "UserName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              UserName: {
                location: "uri",
                locationName: "UserName"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupList: {
                shape: "Scn"
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        ListUsers: {
          http: {
            method: "GET",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/users"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UserList: {
                type: "list",
                member: {
                  shape: "Sb0"
                }
              },
              NextToken: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        RegisterUser: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/users"
          },
          input: {
            type: "structure",
            required: [
              "IdentityType",
              "Email",
              "UserRole",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              IdentityType: {},
              Email: {},
              UserRole: {},
              IamArn: {},
              SessionName: {},
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              },
              UserName: {},
              CustomPermissionsName: {},
              ExternalLoginFederationProviderType: {},
              CustomFederationProviderUrl: {},
              ExternalLoginId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "Sb0"
              },
              UserInvitationUrl: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        RestoreAnalysis: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/restore/analyses/{AnalysisId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AnalysisId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AnalysisId: {
                location: "uri",
                locationName: "AnalysisId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              Arn: {},
              AnalysisId: {},
              RequestId: {}
            }
          }
        },
        SearchAnalyses: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/search/analyses"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Filters"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Operator: {},
                    Name: {},
                    Value: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AnalysisSummaryList: {
                shape: "Sbt"
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        SearchDashboards: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/search/dashboards"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Filters"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Operator"
                  ],
                  members: {
                    Operator: {},
                    Name: {},
                    Value: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DashboardSummaryList: {
                shape: "Sc1"
              },
              NextToken: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        SearchFolders: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/search/folders"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "Filters"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Operator: {},
                    Name: {},
                    Value: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              FolderSummaryList: {
                shape: "Scg"
              },
              NextToken: {},
              RequestId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/resources/{ResourceArn}/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/resources/{ResourceArn}/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "keys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateAccountCustomization: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/customizations"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AccountCustomization"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              AccountCustomization: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AwsAccountId: {},
              Namespace: {},
              AccountCustomization: {
                shape: "Sa"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateAccountSettings: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/settings"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DefaultNamespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DefaultNamespace: {},
              NotificationEmail: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateAnalysis: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/analyses/{AnalysisId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AnalysisId",
              "Name",
              "SourceEntity"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AnalysisId: {
                location: "uri",
                locationName: "AnalysisId"
              },
              Name: {},
              Parameters: {
                shape: "Sj"
              },
              SourceEntity: {
                shape: "S14"
              },
              ThemeArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AnalysisId: {},
              UpdateStatus: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        UpdateAnalysisPermissions: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/analyses/{AnalysisId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AnalysisId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AnalysisId: {
                location: "uri",
                locationName: "AnalysisId"
              },
              GrantPermissions: {
                shape: "Set"
              },
              RevokePermissions: {
                shape: "Set"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AnalysisArn: {},
              AnalysisId: {},
              Permissions: {
                shape: "S10"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateDashboard: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId",
              "Name",
              "SourceEntity"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              Name: {},
              SourceEntity: {
                shape: "S1c"
              },
              Parameters: {
                shape: "Sj"
              },
              VersionDescription: {},
              DashboardPublishOptions: {
                shape: "S1f"
              },
              ThemeArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              VersionArn: {},
              DashboardId: {},
              CreationStatus: {},
              Status: {
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        UpdateDashboardPermissions: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              GrantPermissions: {
                shape: "Set"
              },
              RevokePermissions: {
                shape: "Set"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DashboardArn: {},
              DashboardId: {},
              Permissions: {
                shape: "S10"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateDashboardPublishedVersion: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/dashboards/{DashboardId}/versions/{VersionNumber}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DashboardId",
              "VersionNumber"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DashboardId: {
                location: "uri",
                locationName: "DashboardId"
              },
              VersionNumber: {
                location: "uri",
                locationName: "VersionNumber",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DashboardId: {},
              DashboardArn: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        UpdateDataSet: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId",
              "Name",
              "PhysicalTableMap",
              "ImportMode"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              Name: {},
              PhysicalTableMap: {
                shape: "S1p"
              },
              LogicalTableMap: {
                shape: "S2a"
              },
              ImportMode: {},
              ColumnGroups: {
                shape: "S37"
              },
              FieldFolders: {
                shape: "S3d"
              },
              RowLevelPermissionDataSet: {
                shape: "S3i"
              },
              RowLevelPermissionTagConfiguration: {
                shape: "S3m"
              },
              ColumnLevelPermissionRules: {
                shape: "S3s"
              },
              DataSetUsageConfiguration: {
                shape: "S3w"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              DataSetId: {},
              IngestionArn: {},
              IngestionId: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateDataSetPermissions: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/data-sets/{DataSetId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSetId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              GrantPermissions: {
                shape: "S10"
              },
              RevokePermissions: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSetArn: {},
              DataSetId: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateDataSource: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/data-sources/{DataSourceId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSourceId",
              "Name"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSourceId: {
                location: "uri",
                locationName: "DataSourceId"
              },
              Name: {},
              DataSourceParameters: {
                shape: "S40"
              },
              Credentials: {
                shape: "S52"
              },
              VpcConnectionProperties: {
                shape: "S58"
              },
              SslProperties: {
                shape: "S59"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              DataSourceId: {},
              UpdateStatus: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateDataSourcePermissions: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/data-sources/{DataSourceId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "DataSourceId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              DataSourceId: {
                location: "uri",
                locationName: "DataSourceId"
              },
              GrantPermissions: {
                shape: "S10"
              },
              RevokePermissions: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSourceArn: {},
              DataSourceId: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateFolder: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/folders/{FolderId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "FolderId",
              "Name"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                location: "statusCode",
                type: "integer"
              },
              Arn: {},
              FolderId: {},
              RequestId: {}
            }
          }
        },
        UpdateFolderPermissions: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/folders/{FolderId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "FolderId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              FolderId: {
                location: "uri",
                locationName: "FolderId"
              },
              GrantPermissions: {
                shape: "S10"
              },
              RevokePermissions: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                type: "integer"
              },
              Arn: {},
              FolderId: {},
              Permissions: {
                shape: "S10"
              },
              RequestId: {}
            }
          }
        },
        UpdateGroup: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/groups/{GroupName}"
          },
          input: {
            type: "structure",
            required: [
              "GroupName",
              "AwsAccountId",
              "Namespace"
            ],
            members: {
              GroupName: {
                location: "uri",
                locationName: "GroupName"
              },
              Description: {},
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Group: {
                shape: "S5n"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateIAMPolicyAssignment: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/iam-policy-assignments/{AssignmentName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "AssignmentName",
              "Namespace"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              AssignmentName: {
                location: "uri",
                locationName: "AssignmentName"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              },
              AssignmentStatus: {},
              PolicyArn: {},
              Identities: {
                shape: "S5v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssignmentName: {},
              AssignmentId: {},
              PolicyArn: {},
              Identities: {
                shape: "S5v"
              },
              AssignmentStatus: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateIpRestriction: {
          http: {
            requestUri: "/accounts/{AwsAccountId}/ip-restriction"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              IpRestrictionRuleMap: {
                shape: "S9s"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AwsAccountId: {},
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateTemplate: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId",
              "SourceEntity"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              SourceEntity: {
                shape: "S69"
              },
              VersionDescription: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateId: {},
              Arn: {},
              VersionArn: {},
              CreationStatus: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        UpdateTemplateAlias: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}/aliases/{AliasName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId",
              "AliasName",
              "TemplateVersionNumber"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              AliasName: {
                location: "uri",
                locationName: "AliasName"
              },
              TemplateVersionNumber: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateAlias: {
                shape: "S6h"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        UpdateTemplatePermissions: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/templates/{TemplateId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "TemplateId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              },
              GrantPermissions: {
                shape: "Set"
              },
              RevokePermissions: {
                shape: "Set"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateId: {},
              TemplateArn: {},
              Permissions: {
                shape: "S10"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateTheme: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId",
              "BaseThemeId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              Name: {},
              BaseThemeId: {},
              VersionDescription: {},
              Configuration: {
                shape: "S6k"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ThemeId: {},
              Arn: {},
              VersionArn: {},
              CreationStatus: {},
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        UpdateThemeAlias: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}/aliases/{AliasName}"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId",
              "AliasName",
              "ThemeVersionNumber"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              AliasName: {
                location: "uri",
                locationName: "AliasName"
              },
              ThemeVersionNumber: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ThemeAlias: {
                shape: "S6z"
              },
              Status: {
                location: "statusCode",
                type: "integer"
              },
              RequestId: {}
            }
          }
        },
        UpdateThemePermissions: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/themes/{ThemeId}/permissions"
          },
          input: {
            type: "structure",
            required: [
              "AwsAccountId",
              "ThemeId"
            ],
            members: {
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              ThemeId: {
                location: "uri",
                locationName: "ThemeId"
              },
              GrantPermissions: {
                shape: "Set"
              },
              RevokePermissions: {
                shape: "Set"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ThemeId: {},
              ThemeArn: {},
              Permissions: {
                shape: "S10"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        },
        UpdateUser: {
          http: {
            method: "PUT",
            requestUri: "/accounts/{AwsAccountId}/namespaces/{Namespace}/users/{UserName}"
          },
          input: {
            type: "structure",
            required: [
              "UserName",
              "AwsAccountId",
              "Namespace",
              "Email",
              "Role"
            ],
            members: {
              UserName: {
                location: "uri",
                locationName: "UserName"
              },
              AwsAccountId: {
                location: "uri",
                locationName: "AwsAccountId"
              },
              Namespace: {
                location: "uri",
                locationName: "Namespace"
              },
              Email: {},
              Role: {},
              CustomPermissionsName: {},
              UnapplyCustomPermissions: {
                type: "boolean"
              },
              ExternalLoginFederationProviderType: {},
              CustomFederationProviderUrl: {},
              ExternalLoginId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "Sb0"
              },
              RequestId: {},
              Status: {
                location: "statusCode",
                type: "integer"
              }
            }
          }
        }
      },
      shapes: {
        Sa: {
          type: "structure",
          members: {
            DefaultTheme: {}
          }
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sj: {
          type: "structure",
          members: {
            StringParameters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "Values"
                ],
                members: {
                  Name: {},
                  Values: {
                    type: "list",
                    member: {}
                  }
                }
              }
            },
            IntegerParameters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "Values"
                ],
                members: {
                  Name: {},
                  Values: {
                    type: "list",
                    member: {
                      type: "long"
                    }
                  }
                }
              }
            },
            DecimalParameters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "Values"
                ],
                members: {
                  Name: {},
                  Values: {
                    type: "list",
                    member: {
                      type: "double"
                    }
                  }
                }
              }
            },
            DateTimeParameters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "Values"
                ],
                members: {
                  Name: {},
                  Values: {
                    type: "list",
                    member: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        S10: {
          type: "list",
          member: {
            shape: "S11"
          }
        },
        S11: {
          type: "structure",
          required: [
            "Principal",
            "Actions"
          ],
          members: {
            Principal: {},
            Actions: {
              type: "list",
              member: {}
            }
          }
        },
        S14: {
          type: "structure",
          members: {
            SourceTemplate: {
              type: "structure",
              required: [
                "DataSetReferences",
                "Arn"
              ],
              members: {
                DataSetReferences: {
                  shape: "S16"
                },
                Arn: {}
              }
            }
          }
        },
        S16: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DataSetPlaceholder",
              "DataSetArn"
            ],
            members: {
              DataSetPlaceholder: {},
              DataSetArn: {}
            }
          }
        },
        S1c: {
          type: "structure",
          members: {
            SourceTemplate: {
              type: "structure",
              required: [
                "DataSetReferences",
                "Arn"
              ],
              members: {
                DataSetReferences: {
                  shape: "S16"
                },
                Arn: {}
              }
            }
          }
        },
        S1f: {
          type: "structure",
          members: {
            AdHocFilteringOption: {
              type: "structure",
              members: {
                AvailabilityStatus: {}
              }
            },
            ExportToCSVOption: {
              type: "structure",
              members: {
                AvailabilityStatus: {}
              }
            },
            SheetControlsOption: {
              type: "structure",
              members: {
                VisibilityState: {}
              }
            }
          }
        },
        S1p: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              RelationalTable: {
                type: "structure",
                required: [
                  "DataSourceArn",
                  "Name",
                  "InputColumns"
                ],
                members: {
                  DataSourceArn: {},
                  Catalog: {},
                  Schema: {},
                  Name: {},
                  InputColumns: {
                    shape: "S1w"
                  }
                }
              },
              CustomSql: {
                type: "structure",
                required: [
                  "DataSourceArn",
                  "Name",
                  "SqlQuery"
                ],
                members: {
                  DataSourceArn: {},
                  Name: {},
                  SqlQuery: {},
                  Columns: {
                    shape: "S1w"
                  }
                }
              },
              S3Source: {
                type: "structure",
                required: [
                  "DataSourceArn",
                  "InputColumns"
                ],
                members: {
                  DataSourceArn: {},
                  UploadSettings: {
                    type: "structure",
                    members: {
                      Format: {},
                      StartFromRow: {
                        type: "integer"
                      },
                      ContainsHeader: {
                        type: "boolean"
                      },
                      TextQualifier: {},
                      Delimiter: {}
                    }
                  },
                  InputColumns: {
                    shape: "S1w"
                  }
                }
              }
            }
          }
        },
        S1w: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Type"
            ],
            members: {
              Name: {},
              Type: {}
            }
          }
        },
        S2a: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "Alias",
              "Source"
            ],
            members: {
              Alias: {},
              DataTransforms: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProjectOperation: {
                      type: "structure",
                      required: [
                        "ProjectedColumns"
                      ],
                      members: {
                        ProjectedColumns: {
                          type: "list",
                          member: {}
                        }
                      }
                    },
                    FilterOperation: {
                      type: "structure",
                      required: [
                        "ConditionExpression"
                      ],
                      members: {
                        ConditionExpression: {}
                      }
                    },
                    CreateColumnsOperation: {
                      type: "structure",
                      required: [
                        "Columns"
                      ],
                      members: {
                        Columns: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "ColumnName",
                              "ColumnId",
                              "Expression"
                            ],
                            members: {
                              ColumnName: {},
                              ColumnId: {},
                              Expression: {}
                            }
                          }
                        }
                      }
                    },
                    RenameColumnOperation: {
                      type: "structure",
                      required: [
                        "ColumnName",
                        "NewColumnName"
                      ],
                      members: {
                        ColumnName: {},
                        NewColumnName: {}
                      }
                    },
                    CastColumnTypeOperation: {
                      type: "structure",
                      required: [
                        "ColumnName",
                        "NewColumnType"
                      ],
                      members: {
                        ColumnName: {},
                        NewColumnType: {},
                        Format: {}
                      }
                    },
                    TagColumnOperation: {
                      type: "structure",
                      required: [
                        "ColumnName",
                        "Tags"
                      ],
                      members: {
                        ColumnName: {},
                        Tags: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              ColumnGeographicRole: {},
                              ColumnDescription: {
                                type: "structure",
                                members: {
                                  Text: {}
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    UntagColumnOperation: {
                      type: "structure",
                      required: [
                        "ColumnName",
                        "TagNames"
                      ],
                      members: {
                        ColumnName: {},
                        TagNames: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                }
              },
              Source: {
                type: "structure",
                members: {
                  JoinInstruction: {
                    type: "structure",
                    required: [
                      "LeftOperand",
                      "RightOperand",
                      "Type",
                      "OnClause"
                    ],
                    members: {
                      LeftOperand: {},
                      RightOperand: {},
                      LeftJoinKeyProperties: {
                        shape: "S33"
                      },
                      RightJoinKeyProperties: {
                        shape: "S33"
                      },
                      Type: {},
                      OnClause: {}
                    }
                  },
                  PhysicalTableId: {},
                  DataSetArn: {}
                }
              }
            }
          }
        },
        S33: {
          type: "structure",
          members: {
            UniqueKey: {
              type: "boolean"
            }
          }
        },
        S37: {
          type: "list",
          member: {
            type: "structure",
            members: {
              GeoSpatialColumnGroup: {
                type: "structure",
                required: [
                  "Name",
                  "CountryCode",
                  "Columns"
                ],
                members: {
                  Name: {},
                  CountryCode: {},
                  Columns: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        S3d: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              description: {},
              columns: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S3i: {
          type: "structure",
          required: [
            "Arn",
            "PermissionPolicy"
          ],
          members: {
            Namespace: {},
            Arn: {},
            PermissionPolicy: {},
            FormatVersion: {},
            Status: {}
          }
        },
        S3m: {
          type: "structure",
          required: [
            "TagRules"
          ],
          members: {
            Status: {},
            TagRules: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "TagKey",
                  "ColumnName"
                ],
                members: {
                  TagKey: {},
                  ColumnName: {},
                  TagMultiValueDelimiter: {},
                  MatchAllValue: {
                    shape: "S3r"
                  }
                }
              }
            }
          }
        },
        S3r: {
          type: "string",
          sensitive: true
        },
        S3s: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Principals: {
                type: "list",
                member: {}
              },
              ColumnNames: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S3w: {
          type: "structure",
          members: {
            DisableUseAsDirectQuerySource: {
              type: "boolean"
            },
            DisableUseAsImportedSource: {
              type: "boolean"
            }
          }
        },
        S40: {
          type: "structure",
          members: {
            AmazonElasticsearchParameters: {
              type: "structure",
              required: [
                "Domain"
              ],
              members: {
                Domain: {}
              }
            },
            AthenaParameters: {
              type: "structure",
              members: {
                WorkGroup: {}
              }
            },
            AuroraParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "Database"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Database: {}
              }
            },
            AuroraPostgreSqlParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "Database"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Database: {}
              }
            },
            AwsIotAnalyticsParameters: {
              type: "structure",
              required: [
                "DataSetName"
              ],
              members: {
                DataSetName: {}
              }
            },
            JiraParameters: {
              type: "structure",
              required: [
                "SiteBaseUrl"
              ],
              members: {
                SiteBaseUrl: {}
              }
            },
            MariaDbParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "Database"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Database: {}
              }
            },
            MySqlParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "Database"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Database: {}
              }
            },
            OracleParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "Database"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Database: {}
              }
            },
            PostgreSqlParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "Database"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Database: {}
              }
            },
            PrestoParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "Catalog"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Catalog: {}
              }
            },
            RdsParameters: {
              type: "structure",
              required: [
                "InstanceId",
                "Database"
              ],
              members: {
                InstanceId: {},
                Database: {}
              }
            },
            RedshiftParameters: {
              type: "structure",
              required: [
                "Database"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Database: {},
                ClusterId: {}
              }
            },
            S3Parameters: {
              type: "structure",
              required: [
                "ManifestFileLocation"
              ],
              members: {
                ManifestFileLocation: {
                  type: "structure",
                  required: [
                    "Bucket",
                    "Key"
                  ],
                  members: {
                    Bucket: {},
                    Key: {}
                  }
                }
              }
            },
            ServiceNowParameters: {
              type: "structure",
              required: [
                "SiteBaseUrl"
              ],
              members: {
                SiteBaseUrl: {}
              }
            },
            SnowflakeParameters: {
              type: "structure",
              required: [
                "Host",
                "Database",
                "Warehouse"
              ],
              members: {
                Host: {},
                Database: {},
                Warehouse: {}
              }
            },
            SparkParameters: {
              type: "structure",
              required: [
                "Host",
                "Port"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                }
              }
            },
            SqlServerParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "Database"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Database: {}
              }
            },
            TeradataParameters: {
              type: "structure",
              required: [
                "Host",
                "Port",
                "Database"
              ],
              members: {
                Host: {},
                Port: {
                  type: "integer"
                },
                Database: {}
              }
            },
            TwitterParameters: {
              type: "structure",
              required: [
                "Query",
                "MaxRows"
              ],
              members: {
                Query: {},
                MaxRows: {
                  type: "integer"
                }
              }
            },
            AmazonOpenSearchParameters: {
              type: "structure",
              required: [
                "Domain"
              ],
              members: {
                Domain: {}
              }
            }
          }
        },
        S52: {
          type: "structure",
          members: {
            CredentialPair: {
              type: "structure",
              required: [
                "Username",
                "Password"
              ],
              members: {
                Username: {},
                Password: {},
                AlternateDataSourceParameters: {
                  shape: "S56"
                }
              }
            },
            CopySourceArn: {}
          },
          sensitive: true
        },
        S56: {
          type: "list",
          member: {
            shape: "S40"
          }
        },
        S58: {
          type: "structure",
          required: [
            "VpcConnectionArn"
          ],
          members: {
            VpcConnectionArn: {}
          }
        },
        S59: {
          type: "structure",
          members: {
            DisableSsl: {
              type: "boolean"
            }
          }
        },
        S5n: {
          type: "structure",
          members: {
            Arn: {},
            GroupName: {},
            Description: {},
            PrincipalId: {}
          }
        },
        S5r: {
          type: "structure",
          members: {
            Arn: {},
            MemberName: {}
          }
        },
        S5v: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {}
          }
        },
        S69: {
          type: "structure",
          members: {
            SourceAnalysis: {
              type: "structure",
              required: [
                "Arn",
                "DataSetReferences"
              ],
              members: {
                Arn: {},
                DataSetReferences: {
                  shape: "S16"
                }
              }
            },
            SourceTemplate: {
              type: "structure",
              required: [
                "Arn"
              ],
              members: {
                Arn: {}
              }
            }
          }
        },
        S6h: {
          type: "structure",
          members: {
            AliasName: {},
            Arn: {},
            TemplateVersionNumber: {
              type: "long"
            }
          }
        },
        S6k: {
          type: "structure",
          members: {
            DataColorPalette: {
              type: "structure",
              members: {
                Colors: {
                  shape: "S6m"
                },
                MinMaxGradient: {
                  shape: "S6m"
                },
                EmptyFillColor: {}
              }
            },
            UIColorPalette: {
              type: "structure",
              members: {
                PrimaryForeground: {},
                PrimaryBackground: {},
                SecondaryForeground: {},
                SecondaryBackground: {},
                Accent: {},
                AccentForeground: {},
                Danger: {},
                DangerForeground: {},
                Warning: {},
                WarningForeground: {},
                Success: {},
                SuccessForeground: {},
                Dimension: {},
                DimensionForeground: {},
                Measure: {},
                MeasureForeground: {}
              }
            },
            Sheet: {
              type: "structure",
              members: {
                Tile: {
                  type: "structure",
                  members: {
                    Border: {
                      type: "structure",
                      members: {
                        Show: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                },
                TileLayout: {
                  type: "structure",
                  members: {
                    Gutter: {
                      type: "structure",
                      members: {
                        Show: {
                          type: "boolean"
                        }
                      }
                    },
                    Margin: {
                      type: "structure",
                      members: {
                        Show: {
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S6m: {
          type: "list",
          member: {}
        },
        S6z: {
          type: "structure",
          members: {
            Arn: {},
            AliasName: {},
            ThemeVersionNumber: {
              type: "long"
            }
          }
        },
        S8c: {
          type: "list",
          member: {}
        },
        S8d: {
          type: "list",
          member: {
            type: "structure",
            members: {
              SheetId: {},
              Name: {}
            }
          }
        },
        S8z: {
          type: "structure",
          members: {
            Arn: {},
            DataSourceId: {},
            Name: {},
            Type: {},
            Status: {},
            CreatedTime: {
              type: "timestamp"
            },
            LastUpdatedTime: {
              type: "timestamp"
            },
            DataSourceParameters: {
              shape: "S40"
            },
            AlternateDataSourceParameters: {
              shape: "S56"
            },
            VpcConnectionProperties: {
              shape: "S58"
            },
            SslProperties: {
              shape: "S59"
            },
            ErrorInfo: {
              type: "structure",
              members: {
                Type: {},
                Message: {}
              }
            }
          }
        },
        S9j: {
          type: "structure",
          required: [
            "Arn",
            "IngestionStatus",
            "CreatedTime"
          ],
          members: {
            Arn: {},
            IngestionId: {},
            IngestionStatus: {},
            ErrorInfo: {
              type: "structure",
              members: {
                Type: {},
                Message: {}
              }
            },
            RowInfo: {
              type: "structure",
              members: {
                RowsIngested: {
                  type: "long"
                },
                RowsDropped: {
                  type: "long"
                },
                TotalRowsInDataset: {
                  type: "long"
                }
              }
            },
            QueueInfo: {
              type: "structure",
              required: [
                "WaitingOnIngestion",
                "QueuedIngestion"
              ],
              members: {
                WaitingOnIngestion: {},
                QueuedIngestion: {}
              }
            },
            CreatedTime: {
              type: "timestamp"
            },
            IngestionTimeInSeconds: {
              type: "long"
            },
            IngestionSizeInBytes: {
              type: "long"
            },
            RequestSource: {},
            RequestType: {}
          }
        },
        S9s: {
          type: "map",
          key: {},
          value: {}
        },
        S9y: {
          type: "structure",
          members: {
            Name: {},
            Arn: {},
            CapacityRegion: {},
            CreationStatus: {},
            IdentityStore: {},
            NamespaceError: {
              type: "structure",
              members: {
                Type: {},
                Message: {}
              }
            }
          }
        },
        Sb0: {
          type: "structure",
          members: {
            Arn: {},
            UserName: {},
            Email: {},
            Role: {},
            IdentityType: {},
            Active: {
              type: "boolean"
            },
            PrincipalId: {},
            CustomPermissionsName: {},
            ExternalLoginFederationProviderType: {},
            ExternalLoginFederationProviderUrl: {},
            ExternalLoginId: {}
          }
        },
        Sbc: {
          type: "string",
          sensitive: true
        },
        Sbt: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Arn: {},
              AnalysisId: {},
              Name: {},
              Status: {},
              CreatedTime: {
                type: "timestamp"
              },
              LastUpdatedTime: {
                type: "timestamp"
              }
            }
          }
        },
        Sc1: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Arn: {},
              DashboardId: {},
              Name: {},
              CreatedTime: {
                type: "timestamp"
              },
              LastUpdatedTime: {
                type: "timestamp"
              },
              PublishedVersionNumber: {
                type: "long"
              },
              LastPublishedTime: {
                type: "timestamp"
              }
            }
          }
        },
        Scg: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Arn: {},
              FolderId: {},
              Name: {},
              FolderType: {},
              CreatedTime: {
                type: "timestamp"
              },
              LastUpdatedTime: {
                type: "timestamp"
              }
            }
          }
        },
        Scn: {
          type: "list",
          member: {
            shape: "S5n"
          }
        },
        Set: {
          type: "list",
          member: {
            shape: "S11"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/quicksight-2018-04-01.paginators.json
var require_quicksight_2018_04_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/quicksight-2018-04-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAnalyses: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AnalysisSummaryList"
        },
        ListDashboardVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DashboardVersionSummaryList"
        },
        ListDashboards: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DashboardSummaryList"
        },
        ListDataSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DataSetSummaries"
        },
        ListDataSources: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DataSources"
        },
        ListIngestions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Ingestions"
        },
        ListNamespaces: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Namespaces"
        },
        ListTemplateAliases: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TemplateAliasList"
        },
        ListTemplateVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TemplateVersionSummaryList"
        },
        ListTemplates: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TemplateSummaryList"
        },
        ListThemeVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ThemeVersionSummaryList"
        },
        ListThemes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ThemeSummaryList"
        },
        SearchAnalyses: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AnalysisSummaryList"
        },
        SearchDashboards: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DashboardSummaryList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/quicksight.js
var require_quicksight = __commonJS({
  "node_modules/aws-sdk/clients/quicksight.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["quicksight"] = {};
    AWS3.QuickSight = Service.defineService("quicksight", ["2018-04-01"]);
    Object.defineProperty(apiLoader.services["quicksight"], "2018-04-01", {
      get: function get() {
        var model = require_quicksight_2018_04_01_min();
        model.paginators = require_quicksight_2018_04_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.QuickSight;
  }
});

// node_modules/aws-sdk/lib/services/rdsdataservice.js
var require_rdsdataservice = __commonJS({
  "node_modules/aws-sdk/lib/services/rdsdataservice.js"() {
    var AWS3 = require_core();
    AWS3.util.update(AWS3.RDSDataService.prototype, {
      retryableError: function retryableError(error) {
        if (error.code === "BadRequestException" && error.message && error.message.match(/^Communications link failure/) && error.statusCode === 400) {
          return true;
        } else {
          var _super = AWS3.Service.prototype.retryableError;
          return _super.call(this, error);
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/rds-data-2018-08-01.min.json
var require_rds_data_2018_08_01_min = __commonJS({
  "node_modules/aws-sdk/apis/rds-data-2018-08-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-08-01",
        endpointPrefix: "rds-data",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS RDS DataService",
        serviceId: "RDS Data",
        signatureVersion: "v4",
        signingName: "rds-data",
        uid: "rds-data-2018-08-01"
      },
      operations: {
        BatchExecuteStatement: {
          http: {
            requestUri: "/BatchExecute",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "secretArn",
              "sql"
            ],
            members: {
              database: {},
              parameterSets: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              resourceArn: {},
              schema: {},
              secretArn: {},
              sql: {},
              transactionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              updateResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    generatedFields: {
                      shape: "Sq"
                    }
                  }
                }
              }
            }
          }
        },
        BeginTransaction: {
          http: {
            requestUri: "/BeginTransaction",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "secretArn"
            ],
            members: {
              database: {},
              resourceArn: {},
              schema: {},
              secretArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              transactionId: {}
            }
          }
        },
        CommitTransaction: {
          http: {
            requestUri: "/CommitTransaction",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "secretArn",
              "transactionId"
            ],
            members: {
              resourceArn: {},
              secretArn: {},
              transactionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              transactionStatus: {}
            }
          }
        },
        ExecuteSql: {
          http: {
            requestUri: "/ExecuteSql",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "awsSecretStoreArn",
              "dbClusterOrInstanceArn",
              "sqlStatements"
            ],
            members: {
              awsSecretStoreArn: {},
              database: {},
              dbClusterOrInstanceArn: {},
              schema: {},
              sqlStatements: {}
            }
          },
          output: {
            type: "structure",
            members: {
              sqlStatementResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    numberOfRecordsUpdated: {
                      type: "long"
                    },
                    resultFrame: {
                      type: "structure",
                      members: {
                        records: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              values: {
                                type: "list",
                                member: {
                                  shape: "S15"
                                }
                              }
                            }
                          }
                        },
                        resultSetMetadata: {
                          type: "structure",
                          members: {
                            columnCount: {
                              type: "long"
                            },
                            columnMetadata: {
                              shape: "S1c"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "The ExecuteSql API is deprecated, please use the ExecuteStatement API."
        },
        ExecuteStatement: {
          http: {
            requestUri: "/Execute",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "secretArn",
              "sql"
            ],
            members: {
              continueAfterTimeout: {
                type: "boolean"
              },
              database: {},
              includeResultMetadata: {
                type: "boolean"
              },
              parameters: {
                shape: "S4"
              },
              resourceArn: {},
              resultSetOptions: {
                type: "structure",
                members: {
                  decimalReturnType: {}
                }
              },
              schema: {},
              secretArn: {},
              sql: {},
              transactionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              columnMetadata: {
                shape: "S1c"
              },
              generatedFields: {
                shape: "Sq"
              },
              numberOfRecordsUpdated: {
                type: "long"
              },
              records: {
                type: "list",
                member: {
                  shape: "Sq"
                }
              }
            }
          }
        },
        RollbackTransaction: {
          http: {
            requestUri: "/RollbackTransaction",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "secretArn",
              "transactionId"
            ],
            members: {
              resourceArn: {},
              secretArn: {},
              transactionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              transactionStatus: {}
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              typeHint: {},
              value: {
                shape: "S8"
              }
            }
          }
        },
        S8: {
          type: "structure",
          members: {
            arrayValue: {
              shape: "S9"
            },
            blobValue: {
              type: "blob"
            },
            booleanValue: {
              type: "boolean"
            },
            doubleValue: {
              type: "double"
            },
            isNull: {
              type: "boolean"
            },
            longValue: {
              type: "long"
            },
            stringValue: {}
          },
          union: true
        },
        S9: {
          type: "structure",
          members: {
            arrayValues: {
              type: "list",
              member: {
                shape: "S9"
              }
            },
            booleanValues: {
              type: "list",
              member: {
                type: "boolean"
              }
            },
            doubleValues: {
              type: "list",
              member: {
                type: "double"
              }
            },
            longValues: {
              type: "list",
              member: {
                type: "long"
              }
            },
            stringValues: {
              type: "list",
              member: {}
            }
          },
          union: true
        },
        Sq: {
          type: "list",
          member: {
            shape: "S8"
          }
        },
        S15: {
          type: "structure",
          members: {
            arrayValues: {
              shape: "S16"
            },
            bigIntValue: {
              type: "long"
            },
            bitValue: {
              type: "boolean"
            },
            blobValue: {
              type: "blob"
            },
            doubleValue: {
              type: "double"
            },
            intValue: {
              type: "integer"
            },
            isNull: {
              type: "boolean"
            },
            realValue: {
              type: "float"
            },
            stringValue: {},
            structValue: {
              type: "structure",
              members: {
                attributes: {
                  shape: "S16"
                }
              }
            }
          },
          union: true
        },
        S16: {
          type: "list",
          member: {
            shape: "S15"
          }
        },
        S1c: {
          type: "list",
          member: {
            type: "structure",
            members: {
              arrayBaseColumnType: {
                type: "integer"
              },
              isAutoIncrement: {
                type: "boolean"
              },
              isCaseSensitive: {
                type: "boolean"
              },
              isCurrency: {
                type: "boolean"
              },
              isSigned: {
                type: "boolean"
              },
              label: {},
              name: {},
              nullable: {
                type: "integer"
              },
              precision: {
                type: "integer"
              },
              scale: {
                type: "integer"
              },
              schemaName: {},
              tableName: {},
              type: {
                type: "integer"
              },
              typeName: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/rds-data-2018-08-01.paginators.json
var require_rds_data_2018_08_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/rds-data-2018-08-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/rdsdataservice.js
var require_rdsdataservice2 = __commonJS({
  "node_modules/aws-sdk/clients/rdsdataservice.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["rdsdataservice"] = {};
    AWS3.RDSDataService = Service.defineService("rdsdataservice", ["2018-08-01"]);
    require_rdsdataservice();
    Object.defineProperty(apiLoader.services["rdsdataservice"], "2018-08-01", {
      get: function get() {
        var model = require_rds_data_2018_08_01_min();
        model.paginators = require_rds_data_2018_08_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.RDSDataService;
  }
});

// node_modules/aws-sdk/apis/amplify-2017-07-25.min.json
var require_amplify_2017_07_25_min = __commonJS({
  "node_modules/aws-sdk/apis/amplify-2017-07-25.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-25",
        endpointPrefix: "amplify",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amplify",
        serviceFullName: "AWS Amplify",
        serviceId: "Amplify",
        signatureVersion: "v4",
        signingName: "amplify",
        uid: "amplify-2017-07-25"
      },
      operations: {
        CreateApp: {
          http: {
            requestUri: "/apps"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              repository: {},
              platform: {},
              iamServiceRoleArn: {},
              oauthToken: {
                shape: "S7"
              },
              accessToken: {
                shape: "S8"
              },
              environmentVariables: {
                shape: "S9"
              },
              enableBranchAutoBuild: {
                type: "boolean"
              },
              enableBranchAutoDeletion: {
                type: "boolean"
              },
              enableBasicAuth: {
                type: "boolean"
              },
              basicAuthCredentials: {
                shape: "Sf"
              },
              customRules: {
                shape: "Sg"
              },
              tags: {
                shape: "Sm"
              },
              buildSpec: {},
              customHeaders: {},
              enableAutoBranchCreation: {
                type: "boolean"
              },
              autoBranchCreationPatterns: {
                shape: "Ss"
              },
              autoBranchCreationConfig: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "app"
            ],
            members: {
              app: {
                shape: "S12"
              }
            }
          }
        },
        CreateBackendEnvironment: {
          http: {
            requestUri: "/apps/{appId}/backendenvironments"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {},
              stackName: {},
              deploymentArtifacts: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "backendEnvironment"
            ],
            members: {
              backendEnvironment: {
                shape: "S1h"
              }
            }
          }
        },
        CreateBranch: {
          http: {
            requestUri: "/apps/{appId}/branches"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {},
              description: {},
              stage: {},
              framework: {},
              enableNotification: {
                type: "boolean"
              },
              enableAutoBuild: {
                type: "boolean"
              },
              environmentVariables: {
                shape: "S9"
              },
              basicAuthCredentials: {
                shape: "Sf"
              },
              enableBasicAuth: {
                type: "boolean"
              },
              enablePerformanceMode: {
                type: "boolean"
              },
              tags: {
                shape: "Sm"
              },
              buildSpec: {},
              ttl: {},
              displayName: {},
              enablePullRequestPreview: {
                type: "boolean"
              },
              pullRequestEnvironmentName: {},
              backendEnvironmentArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "branch"
            ],
            members: {
              branch: {
                shape: "S1o"
              }
            }
          }
        },
        CreateDeployment: {
          http: {
            requestUri: "/apps/{appId}/branches/{branchName}/deployments"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              },
              fileMap: {
                type: "map",
                key: {},
                value: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "fileUploadUrls",
              "zipUploadUrl"
            ],
            members: {
              jobId: {},
              fileUploadUrls: {
                type: "map",
                key: {},
                value: {}
              },
              zipUploadUrl: {}
            }
          }
        },
        CreateDomainAssociation: {
          http: {
            requestUri: "/apps/{appId}/domains"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "domainName",
              "subDomainSettings"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              domainName: {},
              enableAutoSubDomain: {
                type: "boolean"
              },
              subDomainSettings: {
                shape: "S27"
              },
              autoSubDomainCreationPatterns: {
                shape: "S2a"
              },
              autoSubDomainIAMRole: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "domainAssociation"
            ],
            members: {
              domainAssociation: {
                shape: "S2e"
              }
            }
          }
        },
        CreateWebhook: {
          http: {
            requestUri: "/apps/{appId}/webhooks"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "webhook"
            ],
            members: {
              webhook: {
                shape: "S2p"
              }
            }
          }
        },
        DeleteApp: {
          http: {
            method: "DELETE",
            requestUri: "/apps/{appId}"
          },
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "app"
            ],
            members: {
              app: {
                shape: "S12"
              }
            }
          }
        },
        DeleteBackendEnvironment: {
          http: {
            method: "DELETE",
            requestUri: "/apps/{appId}/backendenvironments/{environmentName}"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "backendEnvironment"
            ],
            members: {
              backendEnvironment: {
                shape: "S1h"
              }
            }
          }
        },
        DeleteBranch: {
          http: {
            method: "DELETE",
            requestUri: "/apps/{appId}/branches/{branchName}"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "branch"
            ],
            members: {
              branch: {
                shape: "S1o"
              }
            }
          }
        },
        DeleteDomainAssociation: {
          http: {
            method: "DELETE",
            requestUri: "/apps/{appId}/domains/{domainName}"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "domainName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              domainName: {
                location: "uri",
                locationName: "domainName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainAssociation"
            ],
            members: {
              domainAssociation: {
                shape: "S2e"
              }
            }
          }
        },
        DeleteJob: {
          http: {
            method: "DELETE",
            requestUri: "/apps/{appId}/branches/{branchName}/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName",
              "jobId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              },
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobSummary"
            ],
            members: {
              jobSummary: {
                shape: "S33"
              }
            }
          }
        },
        DeleteWebhook: {
          http: {
            method: "DELETE",
            requestUri: "/webhooks/{webhookId}"
          },
          input: {
            type: "structure",
            required: [
              "webhookId"
            ],
            members: {
              webhookId: {
                location: "uri",
                locationName: "webhookId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "webhook"
            ],
            members: {
              webhook: {
                shape: "S2p"
              }
            }
          }
        },
        GenerateAccessLogs: {
          http: {
            requestUri: "/apps/{appId}/accesslogs"
          },
          input: {
            type: "structure",
            required: [
              "domainName",
              "appId"
            ],
            members: {
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              domainName: {},
              appId: {
                location: "uri",
                locationName: "appId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              logUrl: {}
            }
          }
        },
        GetApp: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}"
          },
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "app"
            ],
            members: {
              app: {
                shape: "S12"
              }
            }
          }
        },
        GetArtifactUrl: {
          http: {
            method: "GET",
            requestUri: "/artifacts/{artifactId}"
          },
          input: {
            type: "structure",
            required: [
              "artifactId"
            ],
            members: {
              artifactId: {
                location: "uri",
                locationName: "artifactId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "artifactId",
              "artifactUrl"
            ],
            members: {
              artifactId: {},
              artifactUrl: {}
            }
          }
        },
        GetBackendEnvironment: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}/backendenvironments/{environmentName}"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "environmentName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "uri",
                locationName: "environmentName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "backendEnvironment"
            ],
            members: {
              backendEnvironment: {
                shape: "S1h"
              }
            }
          }
        },
        GetBranch: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}/branches/{branchName}"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "branch"
            ],
            members: {
              branch: {
                shape: "S1o"
              }
            }
          }
        },
        GetDomainAssociation: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}/domains/{domainName}"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "domainName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              domainName: {
                location: "uri",
                locationName: "domainName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainAssociation"
            ],
            members: {
              domainAssociation: {
                shape: "S2e"
              }
            }
          }
        },
        GetJob: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}/branches/{branchName}/jobs/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName",
              "jobId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              },
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "job"
            ],
            members: {
              job: {
                type: "structure",
                required: [
                  "summary",
                  "steps"
                ],
                members: {
                  summary: {
                    shape: "S33"
                  },
                  steps: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "stepName",
                        "startTime",
                        "status",
                        "endTime"
                      ],
                      members: {
                        stepName: {},
                        startTime: {
                          type: "timestamp"
                        },
                        status: {},
                        endTime: {
                          type: "timestamp"
                        },
                        logUrl: {},
                        artifactsUrl: {},
                        testArtifactsUrl: {},
                        testConfigUrl: {},
                        screenshots: {
                          type: "map",
                          key: {},
                          value: {}
                        },
                        statusReason: {},
                        context: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetWebhook: {
          http: {
            method: "GET",
            requestUri: "/webhooks/{webhookId}"
          },
          input: {
            type: "structure",
            required: [
              "webhookId"
            ],
            members: {
              webhookId: {
                location: "uri",
                locationName: "webhookId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "webhook"
            ],
            members: {
              webhook: {
                shape: "S2p"
              }
            }
          }
        },
        ListApps: {
          http: {
            method: "GET",
            requestUri: "/apps"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "apps"
            ],
            members: {
              apps: {
                type: "list",
                member: {
                  shape: "S12"
                }
              },
              nextToken: {}
            }
          }
        },
        ListArtifacts: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}/branches/{branchName}/jobs/{jobId}/artifacts"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName",
              "jobId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              },
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "artifacts"
            ],
            members: {
              artifacts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "artifactFileName",
                    "artifactId"
                  ],
                  members: {
                    artifactFileName: {},
                    artifactId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListBackendEnvironments: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}/backendenvironments"
          },
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              environmentName: {
                location: "querystring",
                locationName: "environmentName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "backendEnvironments"
            ],
            members: {
              backendEnvironments: {
                type: "list",
                member: {
                  shape: "S1h"
                }
              },
              nextToken: {}
            }
          }
        },
        ListBranches: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}/branches"
          },
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "branches"
            ],
            members: {
              branches: {
                type: "list",
                member: {
                  shape: "S1o"
                }
              },
              nextToken: {}
            }
          }
        },
        ListDomainAssociations: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}/domains"
          },
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "domainAssociations"
            ],
            members: {
              domainAssociations: {
                type: "list",
                member: {
                  shape: "S2e"
                }
              },
              nextToken: {}
            }
          }
        },
        ListJobs: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}/branches/{branchName}/jobs"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobSummaries"
            ],
            members: {
              jobSummaries: {
                type: "list",
                member: {
                  shape: "S33"
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sm"
              }
            }
          }
        },
        ListWebhooks: {
          http: {
            method: "GET",
            requestUri: "/apps/{appId}/webhooks"
          },
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "webhooks"
            ],
            members: {
              webhooks: {
                type: "list",
                member: {
                  shape: "S2p"
                }
              },
              nextToken: {}
            }
          }
        },
        StartDeployment: {
          http: {
            requestUri: "/apps/{appId}/branches/{branchName}/deployments/start"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              },
              jobId: {},
              sourceUrl: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "jobSummary"
            ],
            members: {
              jobSummary: {
                shape: "S33"
              }
            }
          }
        },
        StartJob: {
          http: {
            requestUri: "/apps/{appId}/branches/{branchName}/jobs"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName",
              "jobType"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              },
              jobId: {},
              jobType: {},
              jobReason: {},
              commitId: {},
              commitMessage: {},
              commitTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobSummary"
            ],
            members: {
              jobSummary: {
                shape: "S33"
              }
            }
          }
        },
        StopJob: {
          http: {
            method: "DELETE",
            requestUri: "/apps/{appId}/branches/{branchName}/jobs/{jobId}/stop"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName",
              "jobId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              },
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobSummary"
            ],
            members: {
              jobSummary: {
                shape: "S33"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApp: {
          http: {
            requestUri: "/apps/{appId}"
          },
          input: {
            type: "structure",
            required: [
              "appId"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              name: {},
              description: {},
              platform: {},
              iamServiceRoleArn: {},
              environmentVariables: {
                shape: "S9"
              },
              enableBranchAutoBuild: {
                type: "boolean"
              },
              enableBranchAutoDeletion: {
                type: "boolean"
              },
              enableBasicAuth: {
                type: "boolean"
              },
              basicAuthCredentials: {
                shape: "Sf"
              },
              customRules: {
                shape: "Sg"
              },
              buildSpec: {},
              customHeaders: {},
              enableAutoBranchCreation: {
                type: "boolean"
              },
              autoBranchCreationPatterns: {
                shape: "Ss"
              },
              autoBranchCreationConfig: {
                shape: "Su"
              },
              repository: {},
              oauthToken: {
                shape: "S7"
              },
              accessToken: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "app"
            ],
            members: {
              app: {
                shape: "S12"
              }
            }
          }
        },
        UpdateBranch: {
          http: {
            requestUri: "/apps/{appId}/branches/{branchName}"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "branchName"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              branchName: {
                location: "uri",
                locationName: "branchName"
              },
              description: {},
              framework: {},
              stage: {},
              enableNotification: {
                type: "boolean"
              },
              enableAutoBuild: {
                type: "boolean"
              },
              environmentVariables: {
                shape: "S9"
              },
              basicAuthCredentials: {
                shape: "Sf"
              },
              enableBasicAuth: {
                type: "boolean"
              },
              enablePerformanceMode: {
                type: "boolean"
              },
              buildSpec: {},
              ttl: {},
              displayName: {},
              enablePullRequestPreview: {
                type: "boolean"
              },
              pullRequestEnvironmentName: {},
              backendEnvironmentArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "branch"
            ],
            members: {
              branch: {
                shape: "S1o"
              }
            }
          }
        },
        UpdateDomainAssociation: {
          http: {
            requestUri: "/apps/{appId}/domains/{domainName}"
          },
          input: {
            type: "structure",
            required: [
              "appId",
              "domainName",
              "subDomainSettings"
            ],
            members: {
              appId: {
                location: "uri",
                locationName: "appId"
              },
              domainName: {
                location: "uri",
                locationName: "domainName"
              },
              enableAutoSubDomain: {
                type: "boolean"
              },
              subDomainSettings: {
                shape: "S27"
              },
              autoSubDomainCreationPatterns: {
                shape: "S2a"
              },
              autoSubDomainIAMRole: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "domainAssociation"
            ],
            members: {
              domainAssociation: {
                shape: "S2e"
              }
            }
          }
        },
        UpdateWebhook: {
          http: {
            requestUri: "/webhooks/{webhookId}"
          },
          input: {
            type: "structure",
            required: [
              "webhookId"
            ],
            members: {
              webhookId: {
                location: "uri",
                locationName: "webhookId"
              },
              branchName: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "webhook"
            ],
            members: {
              webhook: {
                shape: "S2p"
              }
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "string",
          sensitive: true
        },
        S8: {
          type: "string",
          sensitive: true
        },
        S9: {
          type: "map",
          key: {},
          value: {}
        },
        Sf: {
          type: "string",
          sensitive: true
        },
        Sg: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "source",
              "target"
            ],
            members: {
              source: {},
              target: {},
              status: {},
              condition: {}
            }
          }
        },
        Sm: {
          type: "map",
          key: {},
          value: {}
        },
        Ss: {
          type: "list",
          member: {}
        },
        Su: {
          type: "structure",
          members: {
            stage: {},
            framework: {},
            enableAutoBuild: {
              type: "boolean"
            },
            environmentVariables: {
              shape: "S9"
            },
            basicAuthCredentials: {
              shape: "Sf"
            },
            enableBasicAuth: {
              type: "boolean"
            },
            enablePerformanceMode: {
              type: "boolean"
            },
            buildSpec: {},
            enablePullRequestPreview: {
              type: "boolean"
            },
            pullRequestEnvironmentName: {}
          }
        },
        S12: {
          type: "structure",
          required: [
            "appId",
            "appArn",
            "name",
            "description",
            "repository",
            "platform",
            "createTime",
            "updateTime",
            "environmentVariables",
            "defaultDomain",
            "enableBranchAutoBuild",
            "enableBasicAuth"
          ],
          members: {
            appId: {},
            appArn: {},
            name: {},
            tags: {
              shape: "Sm"
            },
            description: {},
            repository: {},
            platform: {},
            createTime: {
              type: "timestamp"
            },
            updateTime: {
              type: "timestamp"
            },
            iamServiceRoleArn: {},
            environmentVariables: {
              shape: "S9"
            },
            defaultDomain: {},
            enableBranchAutoBuild: {
              type: "boolean"
            },
            enableBranchAutoDeletion: {
              type: "boolean"
            },
            enableBasicAuth: {
              type: "boolean"
            },
            basicAuthCredentials: {
              shape: "Sf"
            },
            customRules: {
              shape: "Sg"
            },
            productionBranch: {
              type: "structure",
              members: {
                lastDeployTime: {
                  type: "timestamp"
                },
                status: {},
                thumbnailUrl: {},
                branchName: {}
              }
            },
            buildSpec: {},
            customHeaders: {},
            enableAutoBranchCreation: {
              type: "boolean"
            },
            autoBranchCreationPatterns: {
              shape: "Ss"
            },
            autoBranchCreationConfig: {
              shape: "Su"
            }
          }
        },
        S1h: {
          type: "structure",
          required: [
            "backendEnvironmentArn",
            "environmentName",
            "createTime",
            "updateTime"
          ],
          members: {
            backendEnvironmentArn: {},
            environmentName: {},
            stackName: {},
            deploymentArtifacts: {},
            createTime: {
              type: "timestamp"
            },
            updateTime: {
              type: "timestamp"
            }
          }
        },
        S1o: {
          type: "structure",
          required: [
            "branchArn",
            "branchName",
            "description",
            "stage",
            "displayName",
            "enableNotification",
            "createTime",
            "updateTime",
            "environmentVariables",
            "enableAutoBuild",
            "customDomains",
            "framework",
            "activeJobId",
            "totalNumberOfJobs",
            "enableBasicAuth",
            "ttl",
            "enablePullRequestPreview"
          ],
          members: {
            branchArn: {},
            branchName: {},
            description: {},
            tags: {
              shape: "Sm"
            },
            stage: {},
            displayName: {},
            enableNotification: {
              type: "boolean"
            },
            createTime: {
              type: "timestamp"
            },
            updateTime: {
              type: "timestamp"
            },
            environmentVariables: {
              shape: "S9"
            },
            enableAutoBuild: {
              type: "boolean"
            },
            customDomains: {
              type: "list",
              member: {}
            },
            framework: {},
            activeJobId: {},
            totalNumberOfJobs: {},
            enableBasicAuth: {
              type: "boolean"
            },
            enablePerformanceMode: {
              type: "boolean"
            },
            thumbnailUrl: {},
            basicAuthCredentials: {
              shape: "Sf"
            },
            buildSpec: {},
            ttl: {},
            associatedResources: {
              type: "list",
              member: {}
            },
            enablePullRequestPreview: {
              type: "boolean"
            },
            pullRequestEnvironmentName: {},
            destinationBranch: {},
            sourceBranch: {},
            backendEnvironmentArn: {}
          }
        },
        S27: {
          type: "list",
          member: {
            shape: "S28"
          }
        },
        S28: {
          type: "structure",
          required: [
            "prefix",
            "branchName"
          ],
          members: {
            prefix: {},
            branchName: {}
          }
        },
        S2a: {
          type: "list",
          member: {}
        },
        S2e: {
          type: "structure",
          required: [
            "domainAssociationArn",
            "domainName",
            "enableAutoSubDomain",
            "domainStatus",
            "statusReason",
            "subDomains"
          ],
          members: {
            domainAssociationArn: {},
            domainName: {},
            enableAutoSubDomain: {
              type: "boolean"
            },
            autoSubDomainCreationPatterns: {
              shape: "S2a"
            },
            autoSubDomainIAMRole: {},
            domainStatus: {},
            statusReason: {},
            certificateVerificationDNSRecord: {},
            subDomains: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "subDomainSetting",
                  "verified",
                  "dnsRecord"
                ],
                members: {
                  subDomainSetting: {
                    shape: "S28"
                  },
                  verified: {
                    type: "boolean"
                  },
                  dnsRecord: {}
                }
              }
            }
          }
        },
        S2p: {
          type: "structure",
          required: [
            "webhookArn",
            "webhookId",
            "webhookUrl",
            "branchName",
            "description",
            "createTime",
            "updateTime"
          ],
          members: {
            webhookArn: {},
            webhookId: {},
            webhookUrl: {},
            branchName: {},
            description: {},
            createTime: {
              type: "timestamp"
            },
            updateTime: {
              type: "timestamp"
            }
          }
        },
        S33: {
          type: "structure",
          required: [
            "jobArn",
            "jobId",
            "commitId",
            "commitMessage",
            "commitTime",
            "startTime",
            "status",
            "jobType"
          ],
          members: {
            jobArn: {},
            jobId: {},
            commitId: {},
            commitMessage: {},
            commitTime: {
              type: "timestamp"
            },
            startTime: {
              type: "timestamp"
            },
            status: {},
            endTime: {
              type: "timestamp"
            },
            jobType: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/amplify-2017-07-25.paginators.json
var require_amplify_2017_07_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/amplify-2017-07-25.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/amplify.js
var require_amplify = __commonJS({
  "node_modules/aws-sdk/clients/amplify.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["amplify"] = {};
    AWS3.Amplify = Service.defineService("amplify", ["2017-07-25"]);
    Object.defineProperty(apiLoader.services["amplify"], "2017-07-25", {
      get: function get() {
        var model = require_amplify_2017_07_25_min();
        model.paginators = require_amplify_2017_07_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Amplify;
  }
});

// node_modules/aws-sdk/apis/datasync-2018-11-09.min.json
var require_datasync_2018_11_09_min = __commonJS({
  "node_modules/aws-sdk/apis/datasync-2018-11-09.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-11-09",
        endpointPrefix: "datasync",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "DataSync",
        serviceFullName: "AWS DataSync",
        serviceId: "DataSync",
        signatureVersion: "v4",
        signingName: "datasync",
        targetPrefix: "FmrsService",
        uid: "datasync-2018-11-09"
      },
      operations: {
        CancelTaskExecution: {
          input: {
            type: "structure",
            required: [
              "TaskExecutionArn"
            ],
            members: {
              TaskExecutionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateAgent: {
          input: {
            type: "structure",
            required: [
              "ActivationKey"
            ],
            members: {
              ActivationKey: {},
              AgentName: {},
              Tags: {
                shape: "S7"
              },
              VpcEndpointId: {},
              SubnetArns: {
                shape: "Sb"
              },
              SecurityGroupArns: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AgentArn: {}
            }
          }
        },
        CreateLocationEfs: {
          input: {
            type: "structure",
            required: [
              "EfsFilesystemArn",
              "Ec2Config"
            ],
            members: {
              Subdirectory: {},
              EfsFilesystemArn: {},
              Ec2Config: {
                shape: "Sk"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {}
            }
          }
        },
        CreateLocationFsxWindows: {
          input: {
            type: "structure",
            required: [
              "FsxFilesystemArn",
              "SecurityGroupArns",
              "User",
              "Password"
            ],
            members: {
              Subdirectory: {},
              FsxFilesystemArn: {},
              SecurityGroupArns: {
                shape: "Sl"
              },
              Tags: {
                shape: "S7"
              },
              User: {},
              Domain: {},
              Password: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {}
            }
          }
        },
        CreateLocationNfs: {
          input: {
            type: "structure",
            required: [
              "Subdirectory",
              "ServerHostname",
              "OnPremConfig"
            ],
            members: {
              Subdirectory: {},
              ServerHostname: {},
              OnPremConfig: {
                shape: "Sy"
              },
              MountOptions: {
                shape: "S10"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {}
            }
          }
        },
        CreateLocationObjectStorage: {
          input: {
            type: "structure",
            required: [
              "ServerHostname",
              "BucketName",
              "AgentArns"
            ],
            members: {
              ServerHostname: {},
              ServerPort: {
                type: "integer"
              },
              ServerProtocol: {},
              Subdirectory: {},
              BucketName: {},
              AccessKey: {},
              SecretKey: {
                shape: "S19"
              },
              AgentArns: {
                shape: "Sz"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {}
            }
          }
        },
        CreateLocationS3: {
          input: {
            type: "structure",
            required: [
              "S3BucketArn",
              "S3Config"
            ],
            members: {
              Subdirectory: {},
              S3BucketArn: {},
              S3StorageClass: {},
              S3Config: {
                shape: "S1e"
              },
              AgentArns: {
                shape: "Sz"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {}
            }
          }
        },
        CreateLocationSmb: {
          input: {
            type: "structure",
            required: [
              "Subdirectory",
              "ServerHostname",
              "User",
              "Password",
              "AgentArns"
            ],
            members: {
              Subdirectory: {},
              ServerHostname: {},
              User: {},
              Domain: {},
              Password: {
                shape: "St"
              },
              AgentArns: {
                shape: "Sz"
              },
              MountOptions: {
                shape: "S1j"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {}
            }
          }
        },
        CreateTask: {
          input: {
            type: "structure",
            required: [
              "SourceLocationArn",
              "DestinationLocationArn"
            ],
            members: {
              SourceLocationArn: {},
              DestinationLocationArn: {},
              CloudWatchLogGroupArn: {},
              Name: {},
              Options: {
                shape: "S1o"
              },
              Excludes: {
                shape: "S23"
              },
              Schedule: {
                shape: "S27"
              },
              Tags: {
                shape: "S7"
              },
              Includes: {
                shape: "S23"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TaskArn: {}
            }
          }
        },
        DeleteAgent: {
          input: {
            type: "structure",
            required: [
              "AgentArn"
            ],
            members: {
              AgentArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLocation: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteTask: {
          input: {
            type: "structure",
            required: [
              "TaskArn"
            ],
            members: {
              TaskArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeAgent: {
          input: {
            type: "structure",
            required: [
              "AgentArn"
            ],
            members: {
              AgentArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AgentArn: {},
              Name: {},
              Status: {},
              LastConnectionTime: {
                type: "timestamp"
              },
              CreationTime: {
                type: "timestamp"
              },
              EndpointType: {},
              PrivateLinkConfig: {
                type: "structure",
                members: {
                  VpcEndpointId: {},
                  PrivateLinkEndpoint: {},
                  SubnetArns: {
                    shape: "Sb"
                  },
                  SecurityGroupArns: {
                    shape: "Sd"
                  }
                }
              }
            }
          }
        },
        DescribeLocationEfs: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {},
              LocationUri: {},
              Ec2Config: {
                shape: "Sk"
              },
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeLocationFsxWindows: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {},
              LocationUri: {},
              SecurityGroupArns: {
                shape: "Sl"
              },
              CreationTime: {
                type: "timestamp"
              },
              User: {},
              Domain: {}
            }
          }
        },
        DescribeLocationNfs: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {},
              LocationUri: {},
              OnPremConfig: {
                shape: "Sy"
              },
              MountOptions: {
                shape: "S10"
              },
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeLocationObjectStorage: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {},
              LocationUri: {},
              AccessKey: {},
              ServerPort: {
                type: "integer"
              },
              ServerProtocol: {},
              AgentArns: {
                shape: "Sz"
              },
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeLocationS3: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {},
              LocationUri: {},
              S3StorageClass: {},
              S3Config: {
                shape: "S1e"
              },
              AgentArns: {
                shape: "Sz"
              },
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeLocationSmb: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LocationArn: {},
              LocationUri: {},
              AgentArns: {
                shape: "Sz"
              },
              User: {},
              Domain: {},
              MountOptions: {
                shape: "S1j"
              },
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeTask: {
          input: {
            type: "structure",
            required: [
              "TaskArn"
            ],
            members: {
              TaskArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TaskArn: {},
              Status: {},
              Name: {},
              CurrentTaskExecutionArn: {},
              SourceLocationArn: {},
              DestinationLocationArn: {},
              CloudWatchLogGroupArn: {},
              SourceNetworkInterfaceArns: {
                type: "list",
                member: {}
              },
              DestinationNetworkInterfaceArns: {
                type: "list",
                member: {}
              },
              Options: {
                shape: "S1o"
              },
              Excludes: {
                shape: "S23"
              },
              Schedule: {
                shape: "S27"
              },
              ErrorCode: {},
              ErrorDetail: {},
              CreationTime: {
                type: "timestamp"
              },
              Includes: {
                shape: "S23"
              }
            }
          }
        },
        DescribeTaskExecution: {
          input: {
            type: "structure",
            required: [
              "TaskExecutionArn"
            ],
            members: {
              TaskExecutionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TaskExecutionArn: {},
              Status: {},
              Options: {
                shape: "S1o"
              },
              Excludes: {
                shape: "S23"
              },
              Includes: {
                shape: "S23"
              },
              StartTime: {
                type: "timestamp"
              },
              EstimatedFilesToTransfer: {
                type: "long"
              },
              EstimatedBytesToTransfer: {
                type: "long"
              },
              FilesTransferred: {
                type: "long"
              },
              BytesWritten: {
                type: "long"
              },
              BytesTransferred: {
                type: "long"
              },
              Result: {
                type: "structure",
                members: {
                  PrepareDuration: {
                    type: "long"
                  },
                  PrepareStatus: {},
                  TotalDuration: {
                    type: "long"
                  },
                  TransferDuration: {
                    type: "long"
                  },
                  TransferStatus: {},
                  VerifyDuration: {
                    type: "long"
                  },
                  VerifyStatus: {},
                  ErrorCode: {},
                  ErrorDetail: {}
                }
              }
            }
          }
        },
        ListAgents: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Agents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AgentArn: {},
                    Name: {},
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLocations: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values",
                    "Operator"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S3p"
                    },
                    Operator: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Locations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LocationArn: {},
                    LocationUri: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                type: "list",
                member: {
                  shape: "S8"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTaskExecutions: {
          input: {
            type: "structure",
            members: {
              TaskArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TaskExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TaskExecutionArn: {},
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTasks: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values",
                    "Operator"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      shape: "S3p"
                    },
                    Operator: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tasks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TaskArn: {},
                    Status: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        StartTaskExecution: {
          input: {
            type: "structure",
            required: [
              "TaskArn"
            ],
            members: {
              TaskArn: {},
              OverrideOptions: {
                shape: "S1o"
              },
              Includes: {
                shape: "S23"
              },
              Excludes: {
                shape: "S23"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TaskExecutionArn: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Keys"
            ],
            members: {
              ResourceArn: {},
              Keys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAgent: {
          input: {
            type: "structure",
            required: [
              "AgentArn"
            ],
            members: {
              AgentArn: {},
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLocationNfs: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {},
              Subdirectory: {},
              OnPremConfig: {
                shape: "Sy"
              },
              MountOptions: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLocationObjectStorage: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {},
              ServerPort: {
                type: "integer"
              },
              ServerProtocol: {},
              Subdirectory: {},
              AccessKey: {},
              SecretKey: {
                shape: "S19"
              },
              AgentArns: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLocationSmb: {
          input: {
            type: "structure",
            required: [
              "LocationArn"
            ],
            members: {
              LocationArn: {},
              Subdirectory: {},
              User: {},
              Domain: {},
              Password: {
                shape: "St"
              },
              AgentArns: {
                shape: "Sz"
              },
              MountOptions: {
                shape: "S1j"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateTask: {
          input: {
            type: "structure",
            required: [
              "TaskArn"
            ],
            members: {
              TaskArn: {},
              Options: {
                shape: "S1o"
              },
              Excludes: {
                shape: "S23"
              },
              Schedule: {
                shape: "S27"
              },
              Name: {},
              CloudWatchLogGroupArn: {},
              Includes: {
                shape: "S23"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateTaskExecution: {
          input: {
            type: "structure",
            required: [
              "TaskExecutionArn",
              "Options"
            ],
            members: {
              TaskExecutionArn: {},
              Options: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S7: {
          type: "list",
          member: {
            shape: "S8"
          }
        },
        S8: {
          type: "structure",
          required: [
            "Key"
          ],
          members: {
            Key: {},
            Value: {}
          }
        },
        Sb: {
          type: "list",
          member: {}
        },
        Sd: {
          type: "list",
          member: {}
        },
        Sk: {
          type: "structure",
          required: [
            "SubnetArn",
            "SecurityGroupArns"
          ],
          members: {
            SubnetArn: {},
            SecurityGroupArns: {
              shape: "Sl"
            }
          }
        },
        Sl: {
          type: "list",
          member: {}
        },
        St: {
          type: "string",
          sensitive: true
        },
        Sy: {
          type: "structure",
          required: [
            "AgentArns"
          ],
          members: {
            AgentArns: {
              shape: "Sz"
            }
          }
        },
        Sz: {
          type: "list",
          member: {}
        },
        S10: {
          type: "structure",
          members: {
            Version: {}
          }
        },
        S19: {
          type: "string",
          sensitive: true
        },
        S1e: {
          type: "structure",
          required: [
            "BucketAccessRoleArn"
          ],
          members: {
            BucketAccessRoleArn: {}
          }
        },
        S1j: {
          type: "structure",
          members: {
            Version: {}
          }
        },
        S1o: {
          type: "structure",
          members: {
            VerifyMode: {},
            OverwriteMode: {},
            Atime: {},
            Mtime: {},
            Uid: {},
            Gid: {},
            PreserveDeletedFiles: {},
            PreserveDevices: {},
            PosixPermissions: {},
            BytesPerSecond: {
              type: "long"
            },
            TaskQueueing: {},
            LogLevel: {},
            TransferMode: {},
            SecurityDescriptorCopyFlags: {}
          }
        },
        S23: {
          type: "list",
          member: {
            type: "structure",
            members: {
              FilterType: {},
              Value: {}
            }
          }
        },
        S27: {
          type: "structure",
          required: [
            "ScheduleExpression"
          ],
          members: {
            ScheduleExpression: {}
          }
        },
        S3p: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/datasync-2018-11-09.paginators.json
var require_datasync_2018_11_09_paginators = __commonJS({
  "node_modules/aws-sdk/apis/datasync-2018-11-09.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAgents: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListLocations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTaskExecutions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTasks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/datasync.js
var require_datasync = __commonJS({
  "node_modules/aws-sdk/clients/datasync.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["datasync"] = {};
    AWS3.DataSync = Service.defineService("datasync", ["2018-11-09"]);
    Object.defineProperty(apiLoader.services["datasync"], "2018-11-09", {
      get: function get() {
        var model = require_datasync_2018_11_09_min();
        model.paginators = require_datasync_2018_11_09_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.DataSync;
  }
});

// node_modules/aws-sdk/apis/robomaker-2018-06-29.min.json
var require_robomaker_2018_06_29_min = __commonJS({
  "node_modules/aws-sdk/apis/robomaker-2018-06-29.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-06-29",
        endpointPrefix: "robomaker",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "RoboMaker",
        serviceFullName: "AWS RoboMaker",
        serviceId: "RoboMaker",
        signatureVersion: "v4",
        signingName: "robomaker",
        uid: "robomaker-2018-06-29"
      },
      operations: {
        BatchDeleteWorlds: {
          http: {
            requestUri: "/batchDeleteWorlds"
          },
          input: {
            type: "structure",
            required: [
              "worlds"
            ],
            members: {
              worlds: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              unprocessedWorlds: {
                shape: "S2"
              }
            }
          }
        },
        BatchDescribeSimulationJob: {
          http: {
            requestUri: "/batchDescribeSimulationJob"
          },
          input: {
            type: "structure",
            required: [
              "jobs"
            ],
            members: {
              jobs: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    status: {},
                    lastStartedAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    failureBehavior: {},
                    failureCode: {},
                    failureReason: {},
                    clientRequestToken: {},
                    outputLocation: {
                      shape: "Sh"
                    },
                    loggingConfig: {
                      shape: "Sk"
                    },
                    maxJobDurationInSeconds: {
                      type: "long"
                    },
                    simulationTimeMillis: {
                      type: "long"
                    },
                    iamRole: {},
                    robotApplications: {
                      shape: "Sp"
                    },
                    simulationApplications: {
                      shape: "S1d"
                    },
                    dataSources: {
                      shape: "S1h"
                    },
                    tags: {
                      shape: "S1o"
                    },
                    vpcConfig: {
                      shape: "S1r"
                    },
                    networkInterface: {
                      shape: "S1u"
                    },
                    compute: {
                      shape: "S1v"
                    }
                  }
                }
              },
              unprocessedJobs: {
                shape: "S2"
              }
            }
          }
        },
        CancelDeploymentJob: {
          http: {
            requestUri: "/cancelDeploymentJob"
          },
          input: {
            type: "structure",
            required: [
              "job"
            ],
            members: {
              job: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelSimulationJob: {
          http: {
            requestUri: "/cancelSimulationJob"
          },
          input: {
            type: "structure",
            required: [
              "job"
            ],
            members: {
              job: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelSimulationJobBatch: {
          http: {
            requestUri: "/cancelSimulationJobBatch"
          },
          input: {
            type: "structure",
            required: [
              "batch"
            ],
            members: {
              batch: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelWorldExportJob: {
          http: {
            requestUri: "/cancelWorldExportJob"
          },
          input: {
            type: "structure",
            required: [
              "job"
            ],
            members: {
              job: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelWorldGenerationJob: {
          http: {
            requestUri: "/cancelWorldGenerationJob"
          },
          input: {
            type: "structure",
            required: [
              "job"
            ],
            members: {
              job: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDeploymentJob: {
          http: {
            requestUri: "/createDeploymentJob"
          },
          input: {
            type: "structure",
            required: [
              "clientRequestToken",
              "fleet",
              "deploymentApplicationConfigs"
            ],
            members: {
              deploymentConfig: {
                shape: "S2a"
              },
              clientRequestToken: {
                idempotencyToken: true
              },
              fleet: {},
              deploymentApplicationConfigs: {
                shape: "S2e"
              },
              tags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              fleet: {},
              status: {},
              deploymentApplicationConfigs: {
                shape: "S2e"
              },
              failureReason: {},
              failureCode: {},
              createdAt: {
                type: "timestamp"
              },
              deploymentConfig: {
                shape: "S2a"
              },
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        CreateFleet: {
          http: {
            requestUri: "/createFleet"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              tags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              createdAt: {
                type: "timestamp"
              },
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        CreateRobot: {
          http: {
            requestUri: "/createRobot"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "architecture",
              "greengrassGroupId"
            ],
            members: {
              name: {},
              architecture: {},
              greengrassGroupId: {},
              tags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              createdAt: {
                type: "timestamp"
              },
              greengrassGroupId: {},
              architecture: {},
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        CreateRobotApplication: {
          http: {
            requestUri: "/createRobotApplication"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "robotSoftwareSuite"
            ],
            members: {
              name: {},
              sources: {
                shape: "S2t"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              tags: {
                shape: "S1o"
              },
              environment: {
                shape: "S2y"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              version: {},
              sources: {
                shape: "S31"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              revisionId: {},
              tags: {
                shape: "S1o"
              },
              environment: {
                shape: "S2y"
              }
            }
          }
        },
        CreateRobotApplicationVersion: {
          http: {
            requestUri: "/createRobotApplicationVersion"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {},
              currentRevisionId: {},
              s3Etags: {
                shape: "S35"
              },
              imageDigest: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              version: {},
              sources: {
                shape: "S31"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              revisionId: {},
              environment: {
                shape: "S2y"
              }
            }
          }
        },
        CreateSimulationApplication: {
          http: {
            requestUri: "/createSimulationApplication"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "simulationSoftwareSuite",
              "robotSoftwareSuite"
            ],
            members: {
              name: {},
              sources: {
                shape: "S2t"
              },
              simulationSoftwareSuite: {
                shape: "S39"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              renderingEngine: {
                shape: "S3c"
              },
              tags: {
                shape: "S1o"
              },
              environment: {
                shape: "S2y"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              version: {},
              sources: {
                shape: "S31"
              },
              simulationSoftwareSuite: {
                shape: "S39"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              renderingEngine: {
                shape: "S3c"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              revisionId: {},
              tags: {
                shape: "S1o"
              },
              environment: {
                shape: "S2y"
              }
            }
          }
        },
        CreateSimulationApplicationVersion: {
          http: {
            requestUri: "/createSimulationApplicationVersion"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {},
              currentRevisionId: {},
              s3Etags: {
                shape: "S35"
              },
              imageDigest: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              version: {},
              sources: {
                shape: "S31"
              },
              simulationSoftwareSuite: {
                shape: "S39"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              renderingEngine: {
                shape: "S3c"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              revisionId: {},
              environment: {
                shape: "S2y"
              }
            }
          }
        },
        CreateSimulationJob: {
          http: {
            requestUri: "/createSimulationJob"
          },
          input: {
            type: "structure",
            required: [
              "maxJobDurationInSeconds",
              "iamRole"
            ],
            members: {
              clientRequestToken: {
                idempotencyToken: true
              },
              outputLocation: {
                shape: "Sh"
              },
              loggingConfig: {
                shape: "Sk"
              },
              maxJobDurationInSeconds: {
                type: "long"
              },
              iamRole: {},
              failureBehavior: {},
              robotApplications: {
                shape: "Sp"
              },
              simulationApplications: {
                shape: "S1d"
              },
              dataSources: {
                shape: "S3j"
              },
              tags: {
                shape: "S1o"
              },
              vpcConfig: {
                shape: "S3m"
              },
              compute: {
                shape: "S3n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              status: {},
              lastStartedAt: {
                type: "timestamp"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              failureBehavior: {},
              failureCode: {},
              clientRequestToken: {},
              outputLocation: {
                shape: "Sh"
              },
              loggingConfig: {
                shape: "Sk"
              },
              maxJobDurationInSeconds: {
                type: "long"
              },
              simulationTimeMillis: {
                type: "long"
              },
              iamRole: {},
              robotApplications: {
                shape: "Sp"
              },
              simulationApplications: {
                shape: "S1d"
              },
              dataSources: {
                shape: "S1h"
              },
              tags: {
                shape: "S1o"
              },
              vpcConfig: {
                shape: "S1r"
              },
              compute: {
                shape: "S1v"
              }
            }
          }
        },
        CreateWorldExportJob: {
          http: {
            requestUri: "/createWorldExportJob"
          },
          input: {
            type: "structure",
            required: [
              "worlds",
              "outputLocation",
              "iamRole"
            ],
            members: {
              clientRequestToken: {
                idempotencyToken: true
              },
              worlds: {
                shape: "S2"
              },
              outputLocation: {
                shape: "Sh"
              },
              iamRole: {},
              tags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              status: {},
              createdAt: {
                type: "timestamp"
              },
              failureCode: {},
              clientRequestToken: {},
              outputLocation: {
                shape: "Sh"
              },
              iamRole: {},
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        CreateWorldGenerationJob: {
          http: {
            requestUri: "/createWorldGenerationJob"
          },
          input: {
            type: "structure",
            required: [
              "template",
              "worldCount"
            ],
            members: {
              clientRequestToken: {
                idempotencyToken: true
              },
              template: {},
              worldCount: {
                shape: "S3u"
              },
              tags: {
                shape: "S1o"
              },
              worldTags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              status: {},
              createdAt: {
                type: "timestamp"
              },
              failureCode: {},
              clientRequestToken: {},
              template: {},
              worldCount: {
                shape: "S3u"
              },
              tags: {
                shape: "S1o"
              },
              worldTags: {
                shape: "S1o"
              }
            }
          }
        },
        CreateWorldTemplate: {
          http: {
            requestUri: "/createWorldTemplate"
          },
          input: {
            type: "structure",
            members: {
              clientRequestToken: {},
              name: {},
              templateBody: {},
              templateLocation: {
                shape: "S43"
              },
              tags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              clientRequestToken: {},
              createdAt: {
                type: "timestamp"
              },
              name: {},
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        DeleteFleet: {
          http: {
            requestUri: "/deleteFleet"
          },
          input: {
            type: "structure",
            required: [
              "fleet"
            ],
            members: {
              fleet: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRobot: {
          http: {
            requestUri: "/deleteRobot"
          },
          input: {
            type: "structure",
            required: [
              "robot"
            ],
            members: {
              robot: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRobotApplication: {
          http: {
            requestUri: "/deleteRobotApplication"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {},
              applicationVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSimulationApplication: {
          http: {
            requestUri: "/deleteSimulationApplication"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {},
              applicationVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWorldTemplate: {
          http: {
            requestUri: "/deleteWorldTemplate"
          },
          input: {
            type: "structure",
            required: [
              "template"
            ],
            members: {
              template: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterRobot: {
          http: {
            requestUri: "/deregisterRobot"
          },
          input: {
            type: "structure",
            required: [
              "fleet",
              "robot"
            ],
            members: {
              fleet: {},
              robot: {}
            }
          },
          output: {
            type: "structure",
            members: {
              fleet: {},
              robot: {}
            }
          }
        },
        DescribeDeploymentJob: {
          http: {
            requestUri: "/describeDeploymentJob"
          },
          input: {
            type: "structure",
            required: [
              "job"
            ],
            members: {
              job: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              fleet: {},
              status: {},
              deploymentConfig: {
                shape: "S2a"
              },
              deploymentApplicationConfigs: {
                shape: "S2e"
              },
              failureReason: {},
              failureCode: {},
              createdAt: {
                type: "timestamp"
              },
              robotDeploymentSummary: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    deploymentStartTime: {
                      type: "timestamp"
                    },
                    deploymentFinishTime: {
                      type: "timestamp"
                    },
                    status: {},
                    progressDetail: {
                      type: "structure",
                      members: {
                        currentProgress: {},
                        percentDone: {
                          type: "float"
                        },
                        estimatedTimeRemainingSeconds: {
                          type: "integer"
                        },
                        targetResource: {}
                      }
                    },
                    failureReason: {},
                    failureCode: {}
                  }
                }
              },
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        DescribeFleet: {
          http: {
            requestUri: "/describeFleet"
          },
          input: {
            type: "structure",
            required: [
              "fleet"
            ],
            members: {
              fleet: {}
            }
          },
          output: {
            type: "structure",
            members: {
              name: {},
              arn: {},
              robots: {
                shape: "S4s"
              },
              createdAt: {
                type: "timestamp"
              },
              lastDeploymentStatus: {},
              lastDeploymentJob: {},
              lastDeploymentTime: {
                type: "timestamp"
              },
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        DescribeRobot: {
          http: {
            requestUri: "/describeRobot"
          },
          input: {
            type: "structure",
            required: [
              "robot"
            ],
            members: {
              robot: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              fleetArn: {},
              status: {},
              greengrassGroupId: {},
              createdAt: {
                type: "timestamp"
              },
              architecture: {},
              lastDeploymentJob: {},
              lastDeploymentTime: {
                type: "timestamp"
              },
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        DescribeRobotApplication: {
          http: {
            requestUri: "/describeRobotApplication"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {},
              applicationVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              version: {},
              sources: {
                shape: "S31"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              revisionId: {},
              lastUpdatedAt: {
                type: "timestamp"
              },
              tags: {
                shape: "S1o"
              },
              environment: {
                shape: "S2y"
              },
              imageDigest: {}
            }
          }
        },
        DescribeSimulationApplication: {
          http: {
            requestUri: "/describeSimulationApplication"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {},
              applicationVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              version: {},
              sources: {
                shape: "S31"
              },
              simulationSoftwareSuite: {
                shape: "S39"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              renderingEngine: {
                shape: "S3c"
              },
              revisionId: {},
              lastUpdatedAt: {
                type: "timestamp"
              },
              tags: {
                shape: "S1o"
              },
              environment: {
                shape: "S2y"
              },
              imageDigest: {}
            }
          }
        },
        DescribeSimulationJob: {
          http: {
            requestUri: "/describeSimulationJob"
          },
          input: {
            type: "structure",
            required: [
              "job"
            ],
            members: {
              job: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              status: {},
              lastStartedAt: {
                type: "timestamp"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              failureBehavior: {},
              failureCode: {},
              failureReason: {},
              clientRequestToken: {},
              outputLocation: {
                shape: "Sh"
              },
              loggingConfig: {
                shape: "Sk"
              },
              maxJobDurationInSeconds: {
                type: "long"
              },
              simulationTimeMillis: {
                type: "long"
              },
              iamRole: {},
              robotApplications: {
                shape: "Sp"
              },
              simulationApplications: {
                shape: "S1d"
              },
              dataSources: {
                shape: "S1h"
              },
              tags: {
                shape: "S1o"
              },
              vpcConfig: {
                shape: "S1r"
              },
              networkInterface: {
                shape: "S1u"
              },
              compute: {
                shape: "S1v"
              }
            }
          }
        },
        DescribeSimulationJobBatch: {
          http: {
            requestUri: "/describeSimulationJobBatch"
          },
          input: {
            type: "structure",
            required: [
              "batch"
            ],
            members: {
              batch: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              status: {},
              lastUpdatedAt: {
                type: "timestamp"
              },
              createdAt: {
                type: "timestamp"
              },
              clientRequestToken: {},
              batchPolicy: {
                shape: "S55"
              },
              failureCode: {},
              failureReason: {},
              failedRequests: {
                shape: "S59"
              },
              pendingRequests: {
                shape: "S5d"
              },
              createdRequests: {
                shape: "S5e"
              },
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        DescribeWorld: {
          http: {
            requestUri: "/describeWorld"
          },
          input: {
            type: "structure",
            required: [
              "world"
            ],
            members: {
              world: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              generationJob: {},
              template: {},
              createdAt: {
                type: "timestamp"
              },
              tags: {
                shape: "S1o"
              },
              worldDescriptionBody: {}
            }
          }
        },
        DescribeWorldExportJob: {
          http: {
            requestUri: "/describeWorldExportJob"
          },
          input: {
            type: "structure",
            required: [
              "job"
            ],
            members: {
              job: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              status: {},
              createdAt: {
                type: "timestamp"
              },
              failureCode: {},
              failureReason: {},
              clientRequestToken: {},
              worlds: {
                shape: "S2"
              },
              outputLocation: {
                shape: "Sh"
              },
              iamRole: {},
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        DescribeWorldGenerationJob: {
          http: {
            requestUri: "/describeWorldGenerationJob"
          },
          input: {
            type: "structure",
            required: [
              "job"
            ],
            members: {
              job: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              status: {},
              createdAt: {
                type: "timestamp"
              },
              failureCode: {},
              failureReason: {},
              clientRequestToken: {},
              template: {},
              worldCount: {
                shape: "S3u"
              },
              finishedWorldsSummary: {
                type: "structure",
                members: {
                  finishedCount: {
                    type: "integer"
                  },
                  succeededWorlds: {
                    shape: "S2"
                  },
                  failureSummary: {
                    type: "structure",
                    members: {
                      totalFailureCount: {
                        type: "integer"
                      },
                      failures: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            failureCode: {},
                            sampleFailureReason: {},
                            failureCount: {
                              type: "integer"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              tags: {
                shape: "S1o"
              },
              worldTags: {
                shape: "S1o"
              }
            }
          }
        },
        DescribeWorldTemplate: {
          http: {
            requestUri: "/describeWorldTemplate"
          },
          input: {
            type: "structure",
            required: [
              "template"
            ],
            members: {
              template: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              clientRequestToken: {},
              name: {},
              createdAt: {
                type: "timestamp"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              tags: {
                shape: "S1o"
              },
              version: {}
            }
          }
        },
        GetWorldTemplateBody: {
          http: {
            requestUri: "/getWorldTemplateBody"
          },
          input: {
            type: "structure",
            members: {
              template: {},
              generationJob: {}
            }
          },
          output: {
            type: "structure",
            members: {
              templateBody: {}
            }
          }
        },
        ListDeploymentJobs: {
          http: {
            requestUri: "/listDeploymentJobs"
          },
          input: {
            type: "structure",
            members: {
              filters: {
                shape: "S5z"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    fleet: {},
                    status: {},
                    deploymentApplicationConfigs: {
                      shape: "S2e"
                    },
                    deploymentConfig: {
                      shape: "S2a"
                    },
                    failureReason: {},
                    failureCode: {},
                    createdAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListFleets: {
          http: {
            requestUri: "/listFleets"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S5z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              fleetDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastDeploymentStatus: {},
                    lastDeploymentJob: {},
                    lastDeploymentTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRobotApplications: {
          http: {
            requestUri: "/listRobotApplications"
          },
          input: {
            type: "structure",
            members: {
              versionQualifier: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S5z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              robotApplicationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    arn: {},
                    version: {},
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    robotSoftwareSuite: {
                      shape: "S2v"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRobots: {
          http: {
            requestUri: "/listRobots"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S5z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              robots: {
                shape: "S4s"
              },
              nextToken: {}
            }
          }
        },
        ListSimulationApplications: {
          http: {
            requestUri: "/listSimulationApplications"
          },
          input: {
            type: "structure",
            members: {
              versionQualifier: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S5z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              simulationApplicationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    arn: {},
                    version: {},
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    robotSoftwareSuite: {
                      shape: "S2v"
                    },
                    simulationSoftwareSuite: {
                      shape: "S39"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSimulationJobBatches: {
          http: {
            requestUri: "/listSimulationJobBatches"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S5z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              simulationJobBatchSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    createdAt: {
                      type: "timestamp"
                    },
                    status: {},
                    failedRequestCount: {
                      type: "integer"
                    },
                    pendingRequestCount: {
                      type: "integer"
                    },
                    createdRequestCount: {
                      type: "integer"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSimulationJobs: {
          http: {
            requestUri: "/listSimulationJobs"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S5z"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "simulationJobSummaries"
            ],
            members: {
              simulationJobSummaries: {
                shape: "S5e"
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        ListWorldExportJobs: {
          http: {
            requestUri: "/listWorldExportJobs"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S5z"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "worldExportJobSummaries"
            ],
            members: {
              worldExportJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    status: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    worlds: {
                      shape: "S2"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListWorldGenerationJobs: {
          http: {
            requestUri: "/listWorldGenerationJobs"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S5z"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "worldGenerationJobSummaries"
            ],
            members: {
              worldGenerationJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    template: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    status: {},
                    worldCount: {
                      shape: "S3u"
                    },
                    succeededWorldCount: {
                      type: "integer"
                    },
                    failedWorldCount: {
                      type: "integer"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListWorldTemplates: {
          http: {
            requestUri: "/listWorldTemplates"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              templateSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    name: {},
                    version: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListWorlds: {
          http: {
            requestUri: "/listWorlds"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S5z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              worldSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    generationJob: {},
                    template: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        RegisterRobot: {
          http: {
            requestUri: "/registerRobot"
          },
          input: {
            type: "structure",
            required: [
              "fleet",
              "robot"
            ],
            members: {
              fleet: {},
              robot: {}
            }
          },
          output: {
            type: "structure",
            members: {
              fleet: {},
              robot: {}
            }
          }
        },
        RestartSimulationJob: {
          http: {
            requestUri: "/restartSimulationJob"
          },
          input: {
            type: "structure",
            required: [
              "job"
            ],
            members: {
              job: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartSimulationJobBatch: {
          http: {
            requestUri: "/startSimulationJobBatch"
          },
          input: {
            type: "structure",
            required: [
              "createSimulationJobRequests"
            ],
            members: {
              clientRequestToken: {
                idempotencyToken: true
              },
              batchPolicy: {
                shape: "S55"
              },
              createSimulationJobRequests: {
                shape: "S5d"
              },
              tags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              status: {},
              createdAt: {
                type: "timestamp"
              },
              clientRequestToken: {},
              batchPolicy: {
                shape: "S55"
              },
              failureCode: {},
              failureReason: {},
              failedRequests: {
                shape: "S59"
              },
              pendingRequests: {
                shape: "S5d"
              },
              createdRequests: {
                shape: "S5e"
              },
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        SyncDeploymentJob: {
          http: {
            requestUri: "/syncDeploymentJob"
          },
          input: {
            type: "structure",
            required: [
              "clientRequestToken",
              "fleet"
            ],
            members: {
              clientRequestToken: {
                idempotencyToken: true
              },
              fleet: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              fleet: {},
              status: {},
              deploymentConfig: {
                shape: "S2a"
              },
              deploymentApplicationConfigs: {
                shape: "S2e"
              },
              failureReason: {},
              failureCode: {},
              createdAt: {
                type: "timestamp"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRobotApplication: {
          http: {
            requestUri: "/updateRobotApplication"
          },
          input: {
            type: "structure",
            required: [
              "application",
              "robotSoftwareSuite"
            ],
            members: {
              application: {},
              sources: {
                shape: "S2t"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              currentRevisionId: {},
              environment: {
                shape: "S2y"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              version: {},
              sources: {
                shape: "S31"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              revisionId: {},
              environment: {
                shape: "S2y"
              }
            }
          }
        },
        UpdateSimulationApplication: {
          http: {
            requestUri: "/updateSimulationApplication"
          },
          input: {
            type: "structure",
            required: [
              "application",
              "simulationSoftwareSuite",
              "robotSoftwareSuite"
            ],
            members: {
              application: {},
              sources: {
                shape: "S2t"
              },
              simulationSoftwareSuite: {
                shape: "S39"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              renderingEngine: {
                shape: "S3c"
              },
              currentRevisionId: {},
              environment: {
                shape: "S2y"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              version: {},
              sources: {
                shape: "S31"
              },
              simulationSoftwareSuite: {
                shape: "S39"
              },
              robotSoftwareSuite: {
                shape: "S2v"
              },
              renderingEngine: {
                shape: "S3c"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              revisionId: {},
              environment: {
                shape: "S2y"
              }
            }
          }
        },
        UpdateWorldTemplate: {
          http: {
            requestUri: "/updateWorldTemplate"
          },
          input: {
            type: "structure",
            required: [
              "template"
            ],
            members: {
              template: {},
              name: {},
              templateBody: {},
              templateLocation: {
                shape: "S43"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              createdAt: {
                type: "timestamp"
              },
              lastUpdatedAt: {
                type: "timestamp"
              }
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {}
        },
        Sh: {
          type: "structure",
          members: {
            s3Bucket: {},
            s3Prefix: {}
          }
        },
        Sk: {
          type: "structure",
          required: [
            "recordAllRosTopics"
          ],
          members: {
            recordAllRosTopics: {
              type: "boolean"
            }
          }
        },
        Sp: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "application",
              "launchConfig"
            ],
            members: {
              application: {},
              applicationVersion: {},
              launchConfig: {
                shape: "Ss"
              },
              uploadConfigurations: {
                shape: "S15"
              },
              useDefaultUploadConfigurations: {
                type: "boolean"
              },
              tools: {
                shape: "S19"
              },
              useDefaultTools: {
                type: "boolean"
              }
            }
          }
        },
        Ss: {
          type: "structure",
          members: {
            packageName: {},
            launchFile: {},
            environmentVariables: {
              shape: "Su"
            },
            portForwardingConfig: {
              type: "structure",
              members: {
                portMappings: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "jobPort",
                      "applicationPort"
                    ],
                    members: {
                      jobPort: {
                        type: "integer"
                      },
                      applicationPort: {
                        type: "integer"
                      },
                      enableOnPublicIp: {
                        type: "boolean"
                      }
                    }
                  }
                }
              }
            },
            streamUI: {
              type: "boolean"
            },
            command: {
              type: "list",
              member: {}
            }
          }
        },
        Su: {
          type: "map",
          key: {},
          value: {}
        },
        S15: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "path",
              "uploadBehavior"
            ],
            members: {
              name: {},
              path: {},
              uploadBehavior: {}
            }
          }
        },
        S19: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "command"
            ],
            members: {
              streamUI: {
                type: "boolean"
              },
              name: {},
              command: {},
              streamOutputToCloudWatch: {
                type: "boolean"
              },
              exitBehavior: {}
            }
          }
        },
        S1d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "application",
              "launchConfig"
            ],
            members: {
              application: {},
              applicationVersion: {},
              launchConfig: {
                shape: "Ss"
              },
              uploadConfigurations: {
                shape: "S15"
              },
              worldConfigs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    world: {}
                  }
                }
              },
              useDefaultUploadConfigurations: {
                type: "boolean"
              },
              tools: {
                shape: "S19"
              },
              useDefaultTools: {
                type: "boolean"
              }
            }
          }
        },
        S1h: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              s3Bucket: {},
              s3Keys: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    s3Key: {},
                    etag: {}
                  }
                }
              },
              type: {},
              destination: {}
            }
          }
        },
        S1o: {
          type: "map",
          key: {},
          value: {}
        },
        S1r: {
          type: "structure",
          members: {
            subnets: {
              shape: "S1s"
            },
            securityGroups: {
              shape: "S1t"
            },
            vpcId: {},
            assignPublicIp: {
              type: "boolean"
            }
          }
        },
        S1s: {
          type: "list",
          member: {}
        },
        S1t: {
          type: "list",
          member: {}
        },
        S1u: {
          type: "structure",
          members: {
            networkInterfaceId: {},
            privateIpAddress: {},
            publicIpAddress: {}
          }
        },
        S1v: {
          type: "structure",
          members: {
            simulationUnitLimit: {
              type: "integer"
            },
            computeType: {},
            gpuUnitLimit: {
              type: "integer"
            }
          }
        },
        S2a: {
          type: "structure",
          members: {
            concurrentDeploymentPercentage: {
              type: "integer"
            },
            failureThresholdPercentage: {
              type: "integer"
            },
            robotDeploymentTimeoutInSeconds: {
              type: "long"
            },
            downloadConditionFile: {
              type: "structure",
              required: [
                "bucket",
                "key"
              ],
              members: {
                bucket: {},
                key: {},
                etag: {}
              }
            }
          }
        },
        S2e: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "application",
              "applicationVersion",
              "launchConfig"
            ],
            members: {
              application: {},
              applicationVersion: {},
              launchConfig: {
                type: "structure",
                required: [
                  "packageName",
                  "launchFile"
                ],
                members: {
                  packageName: {},
                  preLaunchFile: {},
                  launchFile: {},
                  postLaunchFile: {},
                  environmentVariables: {
                    shape: "Su"
                  }
                }
              }
            }
          }
        },
        S2t: {
          type: "list",
          member: {
            type: "structure",
            members: {
              s3Bucket: {},
              s3Key: {},
              architecture: {}
            }
          }
        },
        S2v: {
          type: "structure",
          members: {
            name: {},
            version: {}
          }
        },
        S2y: {
          type: "structure",
          members: {
            uri: {}
          }
        },
        S31: {
          type: "list",
          member: {
            type: "structure",
            members: {
              s3Bucket: {},
              s3Key: {},
              etag: {},
              architecture: {}
            }
          }
        },
        S35: {
          type: "list",
          member: {}
        },
        S39: {
          type: "structure",
          members: {
            name: {},
            version: {}
          }
        },
        S3c: {
          type: "structure",
          members: {
            name: {},
            version: {}
          }
        },
        S3j: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "s3Bucket",
              "s3Keys"
            ],
            members: {
              name: {},
              s3Bucket: {},
              s3Keys: {
                type: "list",
                member: {}
              },
              type: {},
              destination: {}
            }
          }
        },
        S3m: {
          type: "structure",
          required: [
            "subnets"
          ],
          members: {
            subnets: {
              shape: "S1s"
            },
            securityGroups: {
              shape: "S1t"
            },
            assignPublicIp: {
              type: "boolean"
            }
          }
        },
        S3n: {
          type: "structure",
          members: {
            simulationUnitLimit: {
              type: "integer"
            },
            computeType: {},
            gpuUnitLimit: {
              type: "integer"
            }
          }
        },
        S3u: {
          type: "structure",
          members: {
            floorplanCount: {
              type: "integer"
            },
            interiorCountPerFloorplan: {
              type: "integer"
            }
          }
        },
        S43: {
          type: "structure",
          required: [
            "s3Bucket",
            "s3Key"
          ],
          members: {
            s3Bucket: {},
            s3Key: {}
          }
        },
        S4s: {
          type: "list",
          member: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              fleetArn: {},
              status: {},
              greenGrassGroupId: {},
              createdAt: {
                type: "timestamp"
              },
              architecture: {},
              lastDeploymentJob: {},
              lastDeploymentTime: {
                type: "timestamp"
              }
            }
          }
        },
        S55: {
          type: "structure",
          members: {
            timeoutInSeconds: {
              type: "long"
            },
            maxConcurrency: {
              type: "integer"
            }
          }
        },
        S59: {
          type: "list",
          member: {
            type: "structure",
            members: {
              request: {
                shape: "S5b"
              },
              failureReason: {},
              failureCode: {},
              failedAt: {
                type: "timestamp"
              }
            }
          }
        },
        S5b: {
          type: "structure",
          required: [
            "maxJobDurationInSeconds"
          ],
          members: {
            outputLocation: {
              shape: "Sh"
            },
            loggingConfig: {
              shape: "Sk"
            },
            maxJobDurationInSeconds: {
              type: "long"
            },
            iamRole: {},
            failureBehavior: {},
            useDefaultApplications: {
              type: "boolean"
            },
            robotApplications: {
              shape: "Sp"
            },
            simulationApplications: {
              shape: "S1d"
            },
            dataSources: {
              shape: "S3j"
            },
            vpcConfig: {
              shape: "S3m"
            },
            compute: {
              shape: "S3n"
            },
            tags: {
              shape: "S1o"
            }
          }
        },
        S5d: {
          type: "list",
          member: {
            shape: "S5b"
          }
        },
        S5e: {
          type: "list",
          member: {
            type: "structure",
            members: {
              arn: {},
              lastUpdatedAt: {
                type: "timestamp"
              },
              name: {},
              status: {},
              simulationApplicationNames: {
                type: "list",
                member: {}
              },
              robotApplicationNames: {
                type: "list",
                member: {}
              },
              dataSourceNames: {
                type: "list",
                member: {}
              },
              computeType: {}
            }
          }
        },
        S5z: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              values: {
                type: "list",
                member: {}
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/robomaker-2018-06-29.paginators.json
var require_robomaker_2018_06_29_paginators = __commonJS({
  "node_modules/aws-sdk/apis/robomaker-2018-06-29.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListDeploymentJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "deploymentJobs"
        },
        ListFleets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "fleetDetails"
        },
        ListRobotApplications: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "robotApplicationSummaries"
        },
        ListRobots: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "robots"
        },
        ListSimulationApplications: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "simulationApplicationSummaries"
        },
        ListSimulationJobBatches: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "simulationJobBatchSummaries"
        },
        ListSimulationJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "simulationJobSummaries"
        },
        ListWorldExportJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "worldExportJobSummaries"
        },
        ListWorldGenerationJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "worldGenerationJobSummaries"
        },
        ListWorldTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "templateSummaries"
        },
        ListWorlds: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "worldSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/robomaker.js
var require_robomaker = __commonJS({
  "node_modules/aws-sdk/clients/robomaker.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["robomaker"] = {};
    AWS3.RoboMaker = Service.defineService("robomaker", ["2018-06-29"]);
    Object.defineProperty(apiLoader.services["robomaker"], "2018-06-29", {
      get: function get() {
        var model = require_robomaker_2018_06_29_min();
        model.paginators = require_robomaker_2018_06_29_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.RoboMaker;
  }
});

// node_modules/aws-sdk/apis/transfer-2018-11-05.min.json
var require_transfer_2018_11_05_min = __commonJS({
  "node_modules/aws-sdk/apis/transfer-2018-11-05.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-11-05",
        endpointPrefix: "transfer",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "AWS Transfer",
        serviceFullName: "AWS Transfer Family",
        serviceId: "Transfer",
        signatureVersion: "v4",
        signingName: "transfer",
        targetPrefix: "TransferService",
        uid: "transfer-2018-11-05"
      },
      operations: {
        CreateAccess: {
          input: {
            type: "structure",
            required: [
              "Role",
              "ServerId",
              "ExternalId"
            ],
            members: {
              HomeDirectory: {},
              HomeDirectoryType: {},
              HomeDirectoryMappings: {
                shape: "S4"
              },
              Policy: {},
              PosixProfile: {
                shape: "S9"
              },
              Role: {},
              ServerId: {},
              ExternalId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "ExternalId"
            ],
            members: {
              ServerId: {},
              ExternalId: {}
            }
          }
        },
        CreateServer: {
          input: {
            type: "structure",
            members: {
              Certificate: {},
              Domain: {},
              EndpointDetails: {
                shape: "Sj"
              },
              EndpointType: {},
              HostKey: {
                shape: "St"
              },
              IdentityProviderDetails: {
                shape: "Su"
              },
              IdentityProviderType: {},
              LoggingRole: {},
              Protocols: {
                shape: "Sy"
              },
              SecurityPolicyName: {},
              Tags: {
                shape: "S11"
              },
              WorkflowDetails: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId"
            ],
            members: {
              ServerId: {}
            }
          }
        },
        CreateUser: {
          input: {
            type: "structure",
            required: [
              "Role",
              "ServerId",
              "UserName"
            ],
            members: {
              HomeDirectory: {},
              HomeDirectoryType: {},
              HomeDirectoryMappings: {
                shape: "S4"
              },
              Policy: {},
              PosixProfile: {
                shape: "S9"
              },
              Role: {},
              ServerId: {},
              SshPublicKeyBody: {},
              Tags: {
                shape: "S11"
              },
              UserName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "UserName"
            ],
            members: {
              ServerId: {},
              UserName: {}
            }
          }
        },
        CreateWorkflow: {
          input: {
            type: "structure",
            required: [
              "Steps"
            ],
            members: {
              Description: {},
              Steps: {
                shape: "S1g"
              },
              OnExceptionSteps: {
                shape: "S1g"
              },
              Tags: {
                shape: "S11"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "WorkflowId"
            ],
            members: {
              WorkflowId: {}
            }
          }
        },
        DeleteAccess: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "ExternalId"
            ],
            members: {
              ServerId: {},
              ExternalId: {}
            }
          }
        },
        DeleteServer: {
          input: {
            type: "structure",
            required: [
              "ServerId"
            ],
            members: {
              ServerId: {}
            }
          }
        },
        DeleteSshPublicKey: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "SshPublicKeyId",
              "UserName"
            ],
            members: {
              ServerId: {},
              SshPublicKeyId: {},
              UserName: {}
            }
          }
        },
        DeleteUser: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "UserName"
            ],
            members: {
              ServerId: {},
              UserName: {}
            }
          }
        },
        DeleteWorkflow: {
          input: {
            type: "structure",
            required: [
              "WorkflowId"
            ],
            members: {
              WorkflowId: {}
            }
          }
        },
        DescribeAccess: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "ExternalId"
            ],
            members: {
              ServerId: {},
              ExternalId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "Access"
            ],
            members: {
              ServerId: {},
              Access: {
                type: "structure",
                members: {
                  HomeDirectory: {},
                  HomeDirectoryMappings: {
                    shape: "S4"
                  },
                  HomeDirectoryType: {},
                  Policy: {},
                  PosixProfile: {
                    shape: "S9"
                  },
                  Role: {},
                  ExternalId: {}
                }
              }
            }
          }
        },
        DescribeExecution: {
          input: {
            type: "structure",
            required: [
              "ExecutionId",
              "WorkflowId"
            ],
            members: {
              ExecutionId: {},
              WorkflowId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "WorkflowId",
              "Execution"
            ],
            members: {
              WorkflowId: {},
              Execution: {
                type: "structure",
                members: {
                  ExecutionId: {},
                  InitialFileLocation: {
                    shape: "S2g"
                  },
                  ServiceMetadata: {
                    shape: "S2k"
                  },
                  ExecutionRole: {},
                  LoggingConfiguration: {
                    type: "structure",
                    members: {
                      LoggingRole: {},
                      LogGroupName: {}
                    }
                  },
                  PosixProfile: {
                    shape: "S9"
                  },
                  Status: {},
                  Results: {
                    type: "structure",
                    members: {
                      Steps: {
                        shape: "S2r"
                      },
                      OnExceptionSteps: {
                        shape: "S2r"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeSecurityPolicy: {
          input: {
            type: "structure",
            required: [
              "SecurityPolicyName"
            ],
            members: {
              SecurityPolicyName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "SecurityPolicy"
            ],
            members: {
              SecurityPolicy: {
                type: "structure",
                required: [
                  "SecurityPolicyName"
                ],
                members: {
                  Fips: {
                    type: "boolean"
                  },
                  SecurityPolicyName: {},
                  SshCiphers: {
                    shape: "S31"
                  },
                  SshKexs: {
                    shape: "S31"
                  },
                  SshMacs: {
                    shape: "S31"
                  },
                  TlsCiphers: {
                    shape: "S31"
                  }
                }
              }
            }
          }
        },
        DescribeServer: {
          input: {
            type: "structure",
            required: [
              "ServerId"
            ],
            members: {
              ServerId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Server"
            ],
            members: {
              Server: {
                type: "structure",
                required: [
                  "Arn"
                ],
                members: {
                  Arn: {},
                  Certificate: {},
                  ProtocolDetails: {
                    shape: "S37"
                  },
                  Domain: {},
                  EndpointDetails: {
                    shape: "Sj"
                  },
                  EndpointType: {},
                  HostKeyFingerprint: {},
                  IdentityProviderDetails: {
                    shape: "Su"
                  },
                  IdentityProviderType: {},
                  LoggingRole: {},
                  Protocols: {
                    shape: "Sy"
                  },
                  SecurityPolicyName: {},
                  ServerId: {},
                  State: {},
                  Tags: {
                    shape: "S11"
                  },
                  UserCount: {
                    type: "integer"
                  },
                  WorkflowDetails: {
                    shape: "S15"
                  }
                }
              }
            }
          }
        },
        DescribeUser: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "UserName"
            ],
            members: {
              ServerId: {},
              UserName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "User"
            ],
            members: {
              ServerId: {},
              User: {
                type: "structure",
                required: [
                  "Arn"
                ],
                members: {
                  Arn: {},
                  HomeDirectory: {},
                  HomeDirectoryMappings: {
                    shape: "S4"
                  },
                  HomeDirectoryType: {},
                  Policy: {},
                  PosixProfile: {
                    shape: "S9"
                  },
                  Role: {},
                  SshPublicKeys: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "DateImported",
                        "SshPublicKeyBody",
                        "SshPublicKeyId"
                      ],
                      members: {
                        DateImported: {
                          type: "timestamp"
                        },
                        SshPublicKeyBody: {},
                        SshPublicKeyId: {}
                      }
                    }
                  },
                  Tags: {
                    shape: "S11"
                  },
                  UserName: {}
                }
              }
            }
          }
        },
        DescribeWorkflow: {
          input: {
            type: "structure",
            required: [
              "WorkflowId"
            ],
            members: {
              WorkflowId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Workflow"
            ],
            members: {
              Workflow: {
                type: "structure",
                required: [
                  "Arn"
                ],
                members: {
                  Arn: {},
                  Description: {},
                  Steps: {
                    shape: "S1g"
                  },
                  OnExceptionSteps: {
                    shape: "S1g"
                  },
                  WorkflowId: {},
                  Tags: {
                    shape: "S11"
                  }
                }
              }
            }
          }
        },
        ImportSshPublicKey: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "SshPublicKeyBody",
              "UserName"
            ],
            members: {
              ServerId: {},
              SshPublicKeyBody: {},
              UserName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "SshPublicKeyId",
              "UserName"
            ],
            members: {
              ServerId: {},
              SshPublicKeyId: {},
              UserName: {}
            }
          }
        },
        ListAccesses: {
          input: {
            type: "structure",
            required: [
              "ServerId"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ServerId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "Accesses"
            ],
            members: {
              NextToken: {},
              ServerId: {},
              Accesses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    HomeDirectory: {},
                    HomeDirectoryType: {},
                    Role: {},
                    ExternalId: {}
                  }
                }
              }
            }
          }
        },
        ListExecutions: {
          input: {
            type: "structure",
            required: [
              "WorkflowId"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              WorkflowId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "WorkflowId",
              "Executions"
            ],
            members: {
              NextToken: {},
              WorkflowId: {},
              Executions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ExecutionId: {},
                    InitialFileLocation: {
                      shape: "S2g"
                    },
                    ServiceMetadata: {
                      shape: "S2k"
                    },
                    Status: {}
                  }
                }
              }
            }
          }
        },
        ListSecurityPolicies: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "SecurityPolicyNames"
            ],
            members: {
              NextToken: {},
              SecurityPolicyNames: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListServers: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Servers"
            ],
            members: {
              NextToken: {},
              Servers: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn"
                  ],
                  members: {
                    Arn: {},
                    Domain: {},
                    IdentityProviderType: {},
                    EndpointType: {},
                    LoggingRole: {},
                    ServerId: {},
                    State: {},
                    UserCount: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              NextToken: {},
              Tags: {
                shape: "S11"
              }
            }
          }
        },
        ListUsers: {
          input: {
            type: "structure",
            required: [
              "ServerId"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ServerId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "Users"
            ],
            members: {
              NextToken: {},
              ServerId: {},
              Users: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Arn"
                  ],
                  members: {
                    Arn: {},
                    HomeDirectory: {},
                    HomeDirectoryType: {},
                    Role: {},
                    SshPublicKeyCount: {
                      type: "integer"
                    },
                    UserName: {}
                  }
                }
              }
            }
          }
        },
        ListWorkflows: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Workflows"
            ],
            members: {
              NextToken: {},
              Workflows: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WorkflowId: {},
                    Description: {},
                    Arn: {}
                  }
                }
              }
            }
          }
        },
        SendWorkflowStepState: {
          input: {
            type: "structure",
            required: [
              "WorkflowId",
              "ExecutionId",
              "Token",
              "Status"
            ],
            members: {
              WorkflowId: {},
              ExecutionId: {},
              Token: {},
              Status: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartServer: {
          input: {
            type: "structure",
            required: [
              "ServerId"
            ],
            members: {
              ServerId: {}
            }
          }
        },
        StopServer: {
          input: {
            type: "structure",
            required: [
              "ServerId"
            ],
            members: {
              ServerId: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "Arn",
              "Tags"
            ],
            members: {
              Arn: {},
              Tags: {
                shape: "S11"
              }
            }
          }
        },
        TestIdentityProvider: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "UserName"
            ],
            members: {
              ServerId: {},
              ServerProtocol: {},
              SourceIp: {},
              UserName: {},
              UserPassword: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "StatusCode",
              "Url"
            ],
            members: {
              Response: {},
              StatusCode: {
                type: "integer"
              },
              Message: {},
              Url: {}
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "Arn",
              "TagKeys"
            ],
            members: {
              Arn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateAccess: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "ExternalId"
            ],
            members: {
              HomeDirectory: {},
              HomeDirectoryType: {},
              HomeDirectoryMappings: {
                shape: "S4"
              },
              Policy: {},
              PosixProfile: {
                shape: "S9"
              },
              Role: {},
              ServerId: {},
              ExternalId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "ExternalId"
            ],
            members: {
              ServerId: {},
              ExternalId: {}
            }
          }
        },
        UpdateServer: {
          input: {
            type: "structure",
            required: [
              "ServerId"
            ],
            members: {
              Certificate: {},
              ProtocolDetails: {
                shape: "S37"
              },
              EndpointDetails: {
                shape: "Sj"
              },
              EndpointType: {},
              HostKey: {
                shape: "St"
              },
              IdentityProviderDetails: {
                shape: "Su"
              },
              LoggingRole: {},
              Protocols: {
                shape: "Sy"
              },
              SecurityPolicyName: {},
              ServerId: {},
              WorkflowDetails: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId"
            ],
            members: {
              ServerId: {}
            }
          }
        },
        UpdateUser: {
          input: {
            type: "structure",
            required: [
              "ServerId",
              "UserName"
            ],
            members: {
              HomeDirectory: {},
              HomeDirectoryType: {},
              HomeDirectoryMappings: {
                shape: "S4"
              },
              Policy: {},
              PosixProfile: {
                shape: "S9"
              },
              Role: {},
              ServerId: {},
              UserName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ServerId",
              "UserName"
            ],
            members: {
              ServerId: {},
              UserName: {}
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Entry",
              "Target"
            ],
            members: {
              Entry: {},
              Target: {}
            }
          }
        },
        S9: {
          type: "structure",
          required: [
            "Uid",
            "Gid"
          ],
          members: {
            Uid: {
              type: "long"
            },
            Gid: {
              type: "long"
            },
            SecondaryGids: {
              type: "list",
              member: {
                type: "long"
              }
            }
          }
        },
        Sj: {
          type: "structure",
          members: {
            AddressAllocationIds: {
              type: "list",
              member: {}
            },
            SubnetIds: {
              type: "list",
              member: {}
            },
            VpcEndpointId: {},
            VpcId: {},
            SecurityGroupIds: {
              type: "list",
              member: {}
            }
          }
        },
        St: {
          type: "string",
          sensitive: true
        },
        Su: {
          type: "structure",
          members: {
            Url: {},
            InvocationRole: {},
            DirectoryId: {}
          }
        },
        Sy: {
          type: "list",
          member: {}
        },
        S11: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S15: {
          type: "structure",
          required: [
            "OnUpload"
          ],
          members: {
            OnUpload: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "WorkflowId",
                  "ExecutionRole"
                ],
                members: {
                  WorkflowId: {},
                  ExecutionRole: {}
                }
              }
            }
          }
        },
        S1g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              CopyStepDetails: {
                type: "structure",
                members: {
                  Name: {},
                  DestinationFileLocation: {
                    type: "structure",
                    members: {
                      S3FileLocation: {
                        type: "structure",
                        members: {
                          Bucket: {},
                          Key: {}
                        }
                      },
                      EfsFileLocation: {
                        shape: "S1p"
                      }
                    }
                  },
                  OverwriteExisting: {}
                }
              },
              CustomStepDetails: {
                type: "structure",
                members: {
                  Name: {},
                  Target: {},
                  TimeoutSeconds: {
                    type: "integer"
                  }
                }
              },
              DeleteStepDetails: {
                type: "structure",
                members: {
                  Name: {}
                }
              },
              TagStepDetails: {
                type: "structure",
                members: {
                  Name: {},
                  Tags: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Key",
                        "Value"
                      ],
                      members: {
                        Key: {},
                        Value: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S1p: {
          type: "structure",
          members: {
            FileSystemId: {},
            Path: {}
          }
        },
        S2g: {
          type: "structure",
          members: {
            S3FileLocation: {
              type: "structure",
              members: {
                Bucket: {},
                Key: {},
                VersionId: {},
                Etag: {}
              }
            },
            EfsFileLocation: {
              shape: "S1p"
            }
          }
        },
        S2k: {
          type: "structure",
          required: [
            "UserDetails"
          ],
          members: {
            UserDetails: {
              type: "structure",
              required: [
                "UserName",
                "ServerId"
              ],
              members: {
                UserName: {},
                ServerId: {},
                SessionId: {}
              }
            }
          }
        },
        S2r: {
          type: "list",
          member: {
            type: "structure",
            members: {
              StepType: {},
              Outputs: {},
              Error: {
                type: "structure",
                required: [
                  "Type",
                  "Message"
                ],
                members: {
                  Type: {},
                  Message: {}
                }
              }
            }
          }
        },
        S31: {
          type: "list",
          member: {}
        },
        S37: {
          type: "structure",
          members: {
            PassiveIp: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/transfer-2018-11-05.paginators.json
var require_transfer_2018_11_05_paginators = __commonJS({
  "node_modules/aws-sdk/apis/transfer-2018-11-05.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAccesses: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListExecutions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSecurityPolicies: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListServers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListUsers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListWorkflows: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/transfer.js
var require_transfer = __commonJS({
  "node_modules/aws-sdk/clients/transfer.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["transfer"] = {};
    AWS3.Transfer = Service.defineService("transfer", ["2018-11-05"]);
    Object.defineProperty(apiLoader.services["transfer"], "2018-11-05", {
      get: function get() {
        var model = require_transfer_2018_11_05_min();
        model.paginators = require_transfer_2018_11_05_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Transfer;
  }
});

// node_modules/aws-sdk/apis/globalaccelerator-2018-08-08.min.json
var require_globalaccelerator_2018_08_08_min = __commonJS({
  "node_modules/aws-sdk/apis/globalaccelerator-2018-08-08.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-08-08",
        endpointPrefix: "globalaccelerator",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Global Accelerator",
        serviceId: "Global Accelerator",
        signatureVersion: "v4",
        signingName: "globalaccelerator",
        targetPrefix: "GlobalAccelerator_V20180706",
        uid: "globalaccelerator-2018-08-08"
      },
      operations: {
        AddCustomRoutingEndpoints: {
          input: {
            type: "structure",
            required: [
              "EndpointConfigurations",
              "EndpointGroupArn"
            ],
            members: {
              EndpointConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EndpointId: {}
                  }
                }
              },
              EndpointGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointDescriptions: {
                shape: "S6"
              },
              EndpointGroupArn: {}
            }
          }
        },
        AdvertiseByoipCidr: {
          input: {
            type: "structure",
            required: [
              "Cidr"
            ],
            members: {
              Cidr: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidr: {
                shape: "Sa"
              }
            }
          }
        },
        AllowCustomRoutingTraffic: {
          input: {
            type: "structure",
            required: [
              "EndpointGroupArn",
              "EndpointId"
            ],
            members: {
              EndpointGroupArn: {},
              EndpointId: {},
              DestinationAddresses: {
                shape: "Sg"
              },
              DestinationPorts: {
                shape: "Si"
              },
              AllowAllTrafficToEndpoint: {
                type: "boolean"
              }
            }
          }
        },
        CreateAccelerator: {
          input: {
            type: "structure",
            required: [
              "Name",
              "IdempotencyToken"
            ],
            members: {
              Name: {},
              IpAddressType: {},
              IpAddresses: {
                shape: "Sn"
              },
              Enabled: {
                type: "boolean"
              },
              IdempotencyToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Accelerator: {
                shape: "Su"
              }
            }
          }
        },
        CreateCustomRoutingAccelerator: {
          input: {
            type: "structure",
            required: [
              "Name",
              "IdempotencyToken"
            ],
            members: {
              Name: {},
              IpAddressType: {},
              IpAddresses: {
                shape: "Sn"
              },
              Enabled: {
                type: "boolean"
              },
              IdempotencyToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Accelerator: {
                shape: "S10"
              }
            }
          }
        },
        CreateCustomRoutingEndpointGroup: {
          input: {
            type: "structure",
            required: [
              "ListenerArn",
              "EndpointGroupRegion",
              "DestinationConfigurations",
              "IdempotencyToken"
            ],
            members: {
              ListenerArn: {},
              EndpointGroupRegion: {},
              DestinationConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "FromPort",
                    "ToPort",
                    "Protocols"
                  ],
                  members: {
                    FromPort: {
                      type: "integer"
                    },
                    ToPort: {
                      type: "integer"
                    },
                    Protocols: {
                      shape: "S15"
                    }
                  }
                }
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointGroup: {
                shape: "S18"
              }
            }
          }
        },
        CreateCustomRoutingListener: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn",
              "PortRanges",
              "IdempotencyToken"
            ],
            members: {
              AcceleratorArn: {},
              PortRanges: {
                shape: "S1e"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Listener: {
                shape: "S1h"
              }
            }
          }
        },
        CreateEndpointGroup: {
          input: {
            type: "structure",
            required: [
              "ListenerArn",
              "EndpointGroupRegion",
              "IdempotencyToken"
            ],
            members: {
              ListenerArn: {},
              EndpointGroupRegion: {},
              EndpointConfigurations: {
                shape: "S1j"
              },
              TrafficDialPercentage: {
                type: "float"
              },
              HealthCheckPort: {
                type: "integer"
              },
              HealthCheckProtocol: {},
              HealthCheckPath: {},
              HealthCheckIntervalSeconds: {
                type: "integer"
              },
              ThresholdCount: {
                type: "integer"
              },
              IdempotencyToken: {
                idempotencyToken: true
              },
              PortOverrides: {
                shape: "S1s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointGroup: {
                shape: "S1v"
              }
            }
          }
        },
        CreateListener: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn",
              "PortRanges",
              "Protocol",
              "IdempotencyToken"
            ],
            members: {
              AcceleratorArn: {},
              PortRanges: {
                shape: "S1e"
              },
              Protocol: {},
              ClientAffinity: {},
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Listener: {
                shape: "S22"
              }
            }
          }
        },
        DeleteAccelerator: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {}
            }
          }
        },
        DeleteCustomRoutingAccelerator: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {}
            }
          }
        },
        DeleteCustomRoutingEndpointGroup: {
          input: {
            type: "structure",
            required: [
              "EndpointGroupArn"
            ],
            members: {
              EndpointGroupArn: {}
            }
          }
        },
        DeleteCustomRoutingListener: {
          input: {
            type: "structure",
            required: [
              "ListenerArn"
            ],
            members: {
              ListenerArn: {}
            }
          }
        },
        DeleteEndpointGroup: {
          input: {
            type: "structure",
            required: [
              "EndpointGroupArn"
            ],
            members: {
              EndpointGroupArn: {}
            }
          }
        },
        DeleteListener: {
          input: {
            type: "structure",
            required: [
              "ListenerArn"
            ],
            members: {
              ListenerArn: {}
            }
          }
        },
        DenyCustomRoutingTraffic: {
          input: {
            type: "structure",
            required: [
              "EndpointGroupArn",
              "EndpointId"
            ],
            members: {
              EndpointGroupArn: {},
              EndpointId: {},
              DestinationAddresses: {
                shape: "Sg"
              },
              DestinationPorts: {
                shape: "Si"
              },
              DenyAllTrafficToEndpoint: {
                type: "boolean"
              }
            }
          }
        },
        DeprovisionByoipCidr: {
          input: {
            type: "structure",
            required: [
              "Cidr"
            ],
            members: {
              Cidr: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidr: {
                shape: "Sa"
              }
            }
          }
        },
        DescribeAccelerator: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Accelerator: {
                shape: "Su"
              }
            }
          }
        },
        DescribeAcceleratorAttributes: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AcceleratorAttributes: {
                shape: "S2g"
              }
            }
          }
        },
        DescribeCustomRoutingAccelerator: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Accelerator: {
                shape: "S10"
              }
            }
          }
        },
        DescribeCustomRoutingAcceleratorAttributes: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AcceleratorAttributes: {
                shape: "S2l"
              }
            }
          }
        },
        DescribeCustomRoutingEndpointGroup: {
          input: {
            type: "structure",
            required: [
              "EndpointGroupArn"
            ],
            members: {
              EndpointGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointGroup: {
                shape: "S18"
              }
            }
          }
        },
        DescribeCustomRoutingListener: {
          input: {
            type: "structure",
            required: [
              "ListenerArn"
            ],
            members: {
              ListenerArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Listener: {
                shape: "S1h"
              }
            }
          }
        },
        DescribeEndpointGroup: {
          input: {
            type: "structure",
            required: [
              "EndpointGroupArn"
            ],
            members: {
              EndpointGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointGroup: {
                shape: "S1v"
              }
            }
          }
        },
        DescribeListener: {
          input: {
            type: "structure",
            required: [
              "ListenerArn"
            ],
            members: {
              ListenerArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Listener: {
                shape: "S22"
              }
            }
          }
        },
        ListAccelerators: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Accelerators: {
                type: "list",
                member: {
                  shape: "Su"
                }
              },
              NextToken: {}
            }
          }
        },
        ListByoipCidrs: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidrs: {
                type: "list",
                member: {
                  shape: "Sa"
                }
              },
              NextToken: {}
            }
          }
        },
        ListCustomRoutingAccelerators: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Accelerators: {
                type: "list",
                member: {
                  shape: "S10"
                }
              },
              NextToken: {}
            }
          }
        },
        ListCustomRoutingEndpointGroups: {
          input: {
            type: "structure",
            required: [
              "ListenerArn"
            ],
            members: {
              ListenerArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointGroups: {
                type: "list",
                member: {
                  shape: "S18"
                }
              },
              NextToken: {}
            }
          }
        },
        ListCustomRoutingListeners: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Listeners: {
                type: "list",
                member: {
                  shape: "S1h"
                }
              },
              NextToken: {}
            }
          }
        },
        ListCustomRoutingPortMappings: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {},
              EndpointGroupArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PortMappings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AcceleratorPort: {
                      type: "integer"
                    },
                    EndpointGroupArn: {},
                    EndpointId: {},
                    DestinationSocketAddress: {
                      shape: "S3f"
                    },
                    Protocols: {
                      shape: "S15"
                    },
                    DestinationTrafficState: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCustomRoutingPortMappingsByDestination: {
          input: {
            type: "structure",
            required: [
              "EndpointId",
              "DestinationAddress"
            ],
            members: {
              EndpointId: {},
              DestinationAddress: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DestinationPortMappings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AcceleratorArn: {},
                    AcceleratorSocketAddresses: {
                      type: "list",
                      member: {
                        shape: "S3f"
                      }
                    },
                    EndpointGroupArn: {},
                    EndpointId: {},
                    EndpointGroupRegion: {},
                    DestinationSocketAddress: {
                      shape: "S3f"
                    },
                    IpAddressType: {},
                    DestinationTrafficState: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEndpointGroups: {
          input: {
            type: "structure",
            required: [
              "ListenerArn"
            ],
            members: {
              ListenerArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointGroups: {
                type: "list",
                member: {
                  shape: "S1v"
                }
              },
              NextToken: {}
            }
          }
        },
        ListListeners: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Listeners: {
                type: "list",
                member: {
                  shape: "S22"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sp"
              }
            }
          }
        },
        ProvisionByoipCidr: {
          input: {
            type: "structure",
            required: [
              "Cidr",
              "CidrAuthorizationContext"
            ],
            members: {
              Cidr: {},
              CidrAuthorizationContext: {
                type: "structure",
                required: [
                  "Message",
                  "Signature"
                ],
                members: {
                  Message: {},
                  Signature: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidr: {
                shape: "Sa"
              }
            }
          }
        },
        RemoveCustomRoutingEndpoints: {
          input: {
            type: "structure",
            required: [
              "EndpointIds",
              "EndpointGroupArn"
            ],
            members: {
              EndpointIds: {
                type: "list",
                member: {}
              },
              EndpointGroupArn: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAccelerator: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {},
              Name: {},
              IpAddressType: {},
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Accelerator: {
                shape: "Su"
              }
            }
          }
        },
        UpdateAcceleratorAttributes: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {},
              FlowLogsEnabled: {
                type: "boolean"
              },
              FlowLogsS3Bucket: {},
              FlowLogsS3Prefix: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AcceleratorAttributes: {
                shape: "S2g"
              }
            }
          }
        },
        UpdateCustomRoutingAccelerator: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {},
              Name: {},
              IpAddressType: {},
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Accelerator: {
                shape: "S10"
              }
            }
          }
        },
        UpdateCustomRoutingAcceleratorAttributes: {
          input: {
            type: "structure",
            required: [
              "AcceleratorArn"
            ],
            members: {
              AcceleratorArn: {},
              FlowLogsEnabled: {
                type: "boolean"
              },
              FlowLogsS3Bucket: {},
              FlowLogsS3Prefix: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AcceleratorAttributes: {
                shape: "S2l"
              }
            }
          }
        },
        UpdateCustomRoutingListener: {
          input: {
            type: "structure",
            required: [
              "ListenerArn",
              "PortRanges"
            ],
            members: {
              ListenerArn: {},
              PortRanges: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Listener: {
                shape: "S1h"
              }
            }
          }
        },
        UpdateEndpointGroup: {
          input: {
            type: "structure",
            required: [
              "EndpointGroupArn"
            ],
            members: {
              EndpointGroupArn: {},
              EndpointConfigurations: {
                shape: "S1j"
              },
              TrafficDialPercentage: {
                type: "float"
              },
              HealthCheckPort: {
                type: "integer"
              },
              HealthCheckProtocol: {},
              HealthCheckPath: {},
              HealthCheckIntervalSeconds: {
                type: "integer"
              },
              ThresholdCount: {
                type: "integer"
              },
              PortOverrides: {
                shape: "S1s"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointGroup: {
                shape: "S1v"
              }
            }
          }
        },
        UpdateListener: {
          input: {
            type: "structure",
            required: [
              "ListenerArn"
            ],
            members: {
              ListenerArn: {},
              PortRanges: {
                shape: "S1e"
              },
              Protocol: {},
              ClientAffinity: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Listener: {
                shape: "S22"
              }
            }
          }
        },
        WithdrawByoipCidr: {
          input: {
            type: "structure",
            required: [
              "Cidr"
            ],
            members: {
              Cidr: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ByoipCidr: {
                shape: "Sa"
              }
            }
          }
        }
      },
      shapes: {
        S6: {
          type: "list",
          member: {
            type: "structure",
            members: {
              EndpointId: {}
            }
          }
        },
        Sa: {
          type: "structure",
          members: {
            Cidr: {},
            State: {},
            Events: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Message: {},
                  Timestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        Sg: {
          type: "list",
          member: {}
        },
        Si: {
          type: "list",
          member: {
            type: "integer"
          }
        },
        Sn: {
          type: "list",
          member: {}
        },
        Sp: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Su: {
          type: "structure",
          members: {
            AcceleratorArn: {},
            Name: {},
            IpAddressType: {},
            Enabled: {
              type: "boolean"
            },
            IpSets: {
              shape: "Sv"
            },
            DnsName: {},
            Status: {},
            CreatedTime: {
              type: "timestamp"
            },
            LastModifiedTime: {
              type: "timestamp"
            }
          }
        },
        Sv: {
          type: "list",
          member: {
            type: "structure",
            members: {
              IpFamily: {},
              IpAddresses: {
                shape: "Sn"
              }
            }
          }
        },
        S10: {
          type: "structure",
          members: {
            AcceleratorArn: {},
            Name: {},
            IpAddressType: {},
            Enabled: {
              type: "boolean"
            },
            IpSets: {
              shape: "Sv"
            },
            DnsName: {},
            Status: {},
            CreatedTime: {
              type: "timestamp"
            },
            LastModifiedTime: {
              type: "timestamp"
            }
          }
        },
        S15: {
          type: "list",
          member: {}
        },
        S18: {
          type: "structure",
          members: {
            EndpointGroupArn: {},
            EndpointGroupRegion: {},
            DestinationDescriptions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  FromPort: {
                    type: "integer"
                  },
                  ToPort: {
                    type: "integer"
                  },
                  Protocols: {
                    type: "list",
                    member: {}
                  }
                }
              }
            },
            EndpointDescriptions: {
              shape: "S6"
            }
          }
        },
        S1e: {
          type: "list",
          member: {
            type: "structure",
            members: {
              FromPort: {
                type: "integer"
              },
              ToPort: {
                type: "integer"
              }
            }
          }
        },
        S1h: {
          type: "structure",
          members: {
            ListenerArn: {},
            PortRanges: {
              shape: "S1e"
            }
          }
        },
        S1j: {
          type: "list",
          member: {
            type: "structure",
            members: {
              EndpointId: {},
              Weight: {
                type: "integer"
              },
              ClientIPPreservationEnabled: {
                type: "boolean"
              }
            }
          }
        },
        S1s: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ListenerPort: {
                type: "integer"
              },
              EndpointPort: {
                type: "integer"
              }
            }
          }
        },
        S1v: {
          type: "structure",
          members: {
            EndpointGroupArn: {},
            EndpointGroupRegion: {},
            EndpointDescriptions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  EndpointId: {},
                  Weight: {
                    type: "integer"
                  },
                  HealthState: {},
                  HealthReason: {},
                  ClientIPPreservationEnabled: {
                    type: "boolean"
                  }
                }
              }
            },
            TrafficDialPercentage: {
              type: "float"
            },
            HealthCheckPort: {
              type: "integer"
            },
            HealthCheckProtocol: {},
            HealthCheckPath: {},
            HealthCheckIntervalSeconds: {
              type: "integer"
            },
            ThresholdCount: {
              type: "integer"
            },
            PortOverrides: {
              shape: "S1s"
            }
          }
        },
        S22: {
          type: "structure",
          members: {
            ListenerArn: {},
            PortRanges: {
              shape: "S1e"
            },
            Protocol: {},
            ClientAffinity: {}
          }
        },
        S2g: {
          type: "structure",
          members: {
            FlowLogsEnabled: {
              type: "boolean"
            },
            FlowLogsS3Bucket: {},
            FlowLogsS3Prefix: {}
          }
        },
        S2l: {
          type: "structure",
          members: {
            FlowLogsEnabled: {
              type: "boolean"
            },
            FlowLogsS3Bucket: {},
            FlowLogsS3Prefix: {}
          }
        },
        S3f: {
          type: "structure",
          members: {
            IpAddress: {},
            Port: {
              type: "integer"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/globalaccelerator-2018-08-08.paginators.json
var require_globalaccelerator_2018_08_08_paginators = __commonJS({
  "node_modules/aws-sdk/apis/globalaccelerator-2018-08-08.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAccelerators: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Accelerators"
        },
        ListByoipCidrs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ByoipCidrs"
        },
        ListCustomRoutingAccelerators: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Accelerators"
        },
        ListCustomRoutingEndpointGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListCustomRoutingListeners: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Listeners"
        },
        ListCustomRoutingPortMappings: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "PortMappings"
        },
        ListCustomRoutingPortMappingsByDestination: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DestinationPortMappings"
        },
        ListEndpointGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "EndpointGroups"
        },
        ListListeners: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Listeners"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/globalaccelerator.js
var require_globalaccelerator = __commonJS({
  "node_modules/aws-sdk/clients/globalaccelerator.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["globalaccelerator"] = {};
    AWS3.GlobalAccelerator = Service.defineService("globalaccelerator", ["2018-08-08"]);
    Object.defineProperty(apiLoader.services["globalaccelerator"], "2018-08-08", {
      get: function get() {
        var model = require_globalaccelerator_2018_08_08_min();
        model.paginators = require_globalaccelerator_2018_08_08_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.GlobalAccelerator;
  }
});

// node_modules/aws-sdk/apis/comprehendmedical-2018-10-30.min.json
var require_comprehendmedical_2018_10_30_min = __commonJS({
  "node_modules/aws-sdk/apis/comprehendmedical-2018-10-30.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-10-30",
        endpointPrefix: "comprehendmedical",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "ComprehendMedical",
        serviceFullName: "AWS Comprehend Medical",
        serviceId: "ComprehendMedical",
        signatureVersion: "v4",
        signingName: "comprehendmedical",
        targetPrefix: "ComprehendMedical_20181030",
        uid: "comprehendmedical-2018-10-30"
      },
      operations: {
        DescribeEntitiesDetectionV2Job: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ComprehendMedicalAsyncJobProperties: {
                shape: "S4"
              }
            }
          }
        },
        DescribeICD10CMInferenceJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ComprehendMedicalAsyncJobProperties: {
                shape: "S4"
              }
            }
          }
        },
        DescribePHIDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ComprehendMedicalAsyncJobProperties: {
                shape: "S4"
              }
            }
          }
        },
        DescribeRxNormInferenceJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ComprehendMedicalAsyncJobProperties: {
                shape: "S4"
              }
            }
          }
        },
        DetectEntities: {
          input: {
            type: "structure",
            required: [
              "Text"
            ],
            members: {
              Text: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entities",
              "ModelVersion"
            ],
            members: {
              Entities: {
                shape: "Sr"
              },
              UnmappedAttributes: {
                shape: "S14"
              },
              PaginationToken: {},
              ModelVersion: {}
            }
          },
          deprecated: true,
          deprecatedMessage: "This operation is deprecated, use DetectEntitiesV2 instead."
        },
        DetectEntitiesV2: {
          input: {
            type: "structure",
            required: [
              "Text"
            ],
            members: {
              Text: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entities",
              "ModelVersion"
            ],
            members: {
              Entities: {
                shape: "Sr"
              },
              UnmappedAttributes: {
                shape: "S14"
              },
              PaginationToken: {},
              ModelVersion: {}
            }
          }
        },
        DetectPHI: {
          input: {
            type: "structure",
            required: [
              "Text"
            ],
            members: {
              Text: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entities",
              "ModelVersion"
            ],
            members: {
              Entities: {
                shape: "Sr"
              },
              PaginationToken: {},
              ModelVersion: {}
            }
          }
        },
        InferICD10CM: {
          input: {
            type: "structure",
            required: [
              "Text"
            ],
            members: {
              Text: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entities"
            ],
            members: {
              Entities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {
                      type: "integer"
                    },
                    Text: {},
                    Category: {},
                    Type: {},
                    Score: {
                      type: "float"
                    },
                    BeginOffset: {
                      type: "integer"
                    },
                    EndOffset: {
                      type: "integer"
                    },
                    Attributes: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Type: {},
                          Score: {
                            type: "float"
                          },
                          RelationshipScore: {
                            type: "float"
                          },
                          Id: {
                            type: "integer"
                          },
                          BeginOffset: {
                            type: "integer"
                          },
                          EndOffset: {
                            type: "integer"
                          },
                          Text: {},
                          Traits: {
                            shape: "S1k"
                          },
                          Category: {},
                          RelationshipType: {}
                        }
                      }
                    },
                    Traits: {
                      shape: "S1k"
                    },
                    ICD10CMConcepts: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Description: {},
                          Code: {},
                          Score: {
                            type: "float"
                          }
                        }
                      }
                    }
                  }
                }
              },
              PaginationToken: {},
              ModelVersion: {}
            }
          }
        },
        InferRxNorm: {
          input: {
            type: "structure",
            required: [
              "Text"
            ],
            members: {
              Text: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entities"
            ],
            members: {
              Entities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {
                      type: "integer"
                    },
                    Text: {},
                    Category: {},
                    Type: {},
                    Score: {
                      type: "float"
                    },
                    BeginOffset: {
                      type: "integer"
                    },
                    EndOffset: {
                      type: "integer"
                    },
                    Attributes: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Type: {},
                          Score: {
                            type: "float"
                          },
                          RelationshipScore: {
                            type: "float"
                          },
                          Id: {
                            type: "integer"
                          },
                          BeginOffset: {
                            type: "integer"
                          },
                          EndOffset: {
                            type: "integer"
                          },
                          Text: {},
                          Traits: {
                            shape: "S1z"
                          }
                        }
                      }
                    },
                    Traits: {
                      shape: "S1z"
                    },
                    RxNormConcepts: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Description: {},
                          Code: {},
                          Score: {
                            type: "float"
                          }
                        }
                      }
                    }
                  }
                }
              },
              PaginationToken: {},
              ModelVersion: {}
            }
          }
        },
        ListEntitiesDetectionV2Jobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                shape: "S25"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ComprehendMedicalAsyncJobPropertiesList: {
                shape: "S28"
              },
              NextToken: {}
            }
          }
        },
        ListICD10CMInferenceJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                shape: "S25"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ComprehendMedicalAsyncJobPropertiesList: {
                shape: "S28"
              },
              NextToken: {}
            }
          }
        },
        ListPHIDetectionJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                shape: "S25"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ComprehendMedicalAsyncJobPropertiesList: {
                shape: "S28"
              },
              NextToken: {}
            }
          }
        },
        ListRxNormInferenceJobs: {
          input: {
            type: "structure",
            members: {
              Filter: {
                shape: "S25"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ComprehendMedicalAsyncJobPropertiesList: {
                shape: "S28"
              },
              NextToken: {}
            }
          }
        },
        StartEntitiesDetectionV2Job: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn",
              "LanguageCode"
            ],
            members: {
              InputDataConfig: {
                shape: "S9"
              },
              OutputDataConfig: {
                shape: "Sc"
              },
              DataAccessRoleArn: {},
              JobName: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              KMSKey: {},
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        StartICD10CMInferenceJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn",
              "LanguageCode"
            ],
            members: {
              InputDataConfig: {
                shape: "S9"
              },
              OutputDataConfig: {
                shape: "Sc"
              },
              DataAccessRoleArn: {},
              JobName: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              KMSKey: {},
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        StartPHIDetectionJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn",
              "LanguageCode"
            ],
            members: {
              InputDataConfig: {
                shape: "S9"
              },
              OutputDataConfig: {
                shape: "Sc"
              },
              DataAccessRoleArn: {},
              JobName: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              KMSKey: {},
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        StartRxNormInferenceJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "OutputDataConfig",
              "DataAccessRoleArn",
              "LanguageCode"
            ],
            members: {
              InputDataConfig: {
                shape: "S9"
              },
              OutputDataConfig: {
                shape: "Sc"
              },
              DataAccessRoleArn: {},
              JobName: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              KMSKey: {},
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        StopEntitiesDetectionV2Job: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        StopICD10CMInferenceJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        StopPHIDetectionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        StopRxNormInferenceJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            JobId: {},
            JobName: {},
            JobStatus: {},
            Message: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            ExpirationTime: {
              type: "timestamp"
            },
            InputDataConfig: {
              shape: "S9"
            },
            OutputDataConfig: {
              shape: "Sc"
            },
            LanguageCode: {},
            DataAccessRoleArn: {},
            ManifestFilePath: {},
            KMSKey: {},
            ModelVersion: {}
          }
        },
        S9: {
          type: "structure",
          required: [
            "S3Bucket"
          ],
          members: {
            S3Bucket: {},
            S3Key: {}
          }
        },
        Sc: {
          type: "structure",
          required: [
            "S3Bucket"
          ],
          members: {
            S3Bucket: {},
            S3Key: {}
          }
        },
        Sr: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {
                type: "integer"
              },
              BeginOffset: {
                type: "integer"
              },
              EndOffset: {
                type: "integer"
              },
              Score: {
                type: "float"
              },
              Text: {},
              Category: {},
              Type: {},
              Traits: {
                shape: "Sy"
              },
              Attributes: {
                type: "list",
                member: {
                  shape: "S12"
                }
              }
            }
          }
        },
        Sy: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Score: {
                type: "float"
              }
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            Type: {},
            Score: {
              type: "float"
            },
            RelationshipScore: {
              type: "float"
            },
            RelationshipType: {},
            Id: {
              type: "integer"
            },
            BeginOffset: {
              type: "integer"
            },
            EndOffset: {
              type: "integer"
            },
            Text: {},
            Category: {},
            Traits: {
              shape: "Sy"
            }
          }
        },
        S14: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {},
              Attribute: {
                shape: "S12"
              }
            }
          }
        },
        S1k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Score: {
                type: "float"
              }
            }
          }
        },
        S1z: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Score: {
                type: "float"
              }
            }
          }
        },
        S25: {
          type: "structure",
          members: {
            JobName: {},
            JobStatus: {},
            SubmitTimeBefore: {
              type: "timestamp"
            },
            SubmitTimeAfter: {
              type: "timestamp"
            }
          }
        },
        S28: {
          type: "list",
          member: {
            shape: "S4"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/comprehendmedical-2018-10-30.paginators.json
var require_comprehendmedical_2018_10_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/comprehendmedical-2018-10-30.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/comprehendmedical.js
var require_comprehendmedical = __commonJS({
  "node_modules/aws-sdk/clients/comprehendmedical.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["comprehendmedical"] = {};
    AWS3.ComprehendMedical = Service.defineService("comprehendmedical", ["2018-10-30"]);
    Object.defineProperty(apiLoader.services["comprehendmedical"], "2018-10-30", {
      get: function get() {
        var model = require_comprehendmedical_2018_10_30_min();
        model.paginators = require_comprehendmedical_2018_10_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ComprehendMedical;
  }
});

// node_modules/aws-sdk/apis/kinesisanalyticsv2-2018-05-23.min.json
var require_kinesisanalyticsv2_2018_05_23_min = __commonJS({
  "node_modules/aws-sdk/apis/kinesisanalyticsv2-2018-05-23.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-23",
        endpointPrefix: "kinesisanalytics",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Kinesis Analytics V2",
        serviceFullName: "Amazon Kinesis Analytics",
        serviceId: "Kinesis Analytics V2",
        signatureVersion: "v4",
        signingName: "kinesisanalytics",
        targetPrefix: "KinesisAnalytics_20180523",
        uid: "kinesisanalyticsv2-2018-05-23"
      },
      operations: {
        AddApplicationCloudWatchLoggingOption: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CloudWatchLoggingOption"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              CloudWatchLoggingOption: {
                shape: "S4"
              },
              ConditionalToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              },
              CloudWatchLoggingOptionDescriptions: {
                shape: "S9"
              }
            }
          }
        },
        AddApplicationInput: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "Input"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              Input: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              },
              InputDescriptions: {
                shape: "S12"
              }
            }
          }
        },
        AddApplicationInputProcessingConfiguration: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "InputId",
              "InputProcessingConfiguration"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              InputId: {},
              InputProcessingConfiguration: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              },
              InputId: {},
              InputProcessingConfigurationDescription: {
                shape: "S15"
              }
            }
          }
        },
        AddApplicationOutput: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "Output"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              Output: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              },
              OutputDescriptions: {
                shape: "S1k"
              }
            }
          }
        },
        AddApplicationReferenceDataSource: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "ReferenceDataSource"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              ReferenceDataSource: {
                shape: "S1q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              },
              ReferenceDataSourceDescriptions: {
                shape: "S1w"
              }
            }
          }
        },
        AddApplicationVpcConfiguration: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "VpcConfiguration"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              VpcConfiguration: {
                shape: "S20"
              },
              ConditionalToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              },
              VpcConfigurationDescription: {
                shape: "S26"
              }
            }
          }
        },
        CreateApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "RuntimeEnvironment",
              "ServiceExecutionRole"
            ],
            members: {
              ApplicationName: {},
              ApplicationDescription: {},
              RuntimeEnvironment: {},
              ServiceExecutionRole: {},
              ApplicationConfiguration: {
                type: "structure",
                members: {
                  SqlApplicationConfiguration: {
                    type: "structure",
                    members: {
                      Inputs: {
                        type: "list",
                        member: {
                          shape: "Se"
                        }
                      },
                      Outputs: {
                        type: "list",
                        member: {
                          shape: "S1e"
                        }
                      },
                      ReferenceDataSources: {
                        type: "list",
                        member: {
                          shape: "S1q"
                        }
                      }
                    }
                  },
                  FlinkApplicationConfiguration: {
                    type: "structure",
                    members: {
                      CheckpointConfiguration: {
                        type: "structure",
                        required: [
                          "ConfigurationType"
                        ],
                        members: {
                          ConfigurationType: {},
                          CheckpointingEnabled: {
                            type: "boolean"
                          },
                          CheckpointInterval: {
                            type: "long"
                          },
                          MinPauseBetweenCheckpoints: {
                            type: "long"
                          }
                        }
                      },
                      MonitoringConfiguration: {
                        type: "structure",
                        required: [
                          "ConfigurationType"
                        ],
                        members: {
                          ConfigurationType: {},
                          MetricsLevel: {},
                          LogLevel: {}
                        }
                      },
                      ParallelismConfiguration: {
                        type: "structure",
                        required: [
                          "ConfigurationType"
                        ],
                        members: {
                          ConfigurationType: {},
                          Parallelism: {
                            type: "integer"
                          },
                          ParallelismPerKPU: {
                            type: "integer"
                          },
                          AutoScalingEnabled: {
                            type: "boolean"
                          }
                        }
                      }
                    }
                  },
                  EnvironmentProperties: {
                    type: "structure",
                    required: [
                      "PropertyGroups"
                    ],
                    members: {
                      PropertyGroups: {
                        shape: "S2t"
                      }
                    }
                  },
                  ApplicationCodeConfiguration: {
                    type: "structure",
                    required: [
                      "CodeContentType"
                    ],
                    members: {
                      CodeContent: {
                        type: "structure",
                        members: {
                          TextContent: {},
                          ZipFileContent: {
                            type: "blob"
                          },
                          S3ContentLocation: {
                            shape: "S32"
                          }
                        }
                      },
                      CodeContentType: {}
                    }
                  },
                  ApplicationSnapshotConfiguration: {
                    type: "structure",
                    required: [
                      "SnapshotsEnabled"
                    ],
                    members: {
                      SnapshotsEnabled: {
                        type: "boolean"
                      }
                    }
                  },
                  VpcConfigurations: {
                    type: "list",
                    member: {
                      shape: "S20"
                    }
                  },
                  ZeppelinApplicationConfiguration: {
                    type: "structure",
                    members: {
                      MonitoringConfiguration: {
                        type: "structure",
                        required: [
                          "LogLevel"
                        ],
                        members: {
                          LogLevel: {}
                        }
                      },
                      CatalogConfiguration: {
                        type: "structure",
                        required: [
                          "GlueDataCatalogConfiguration"
                        ],
                        members: {
                          GlueDataCatalogConfiguration: {
                            type: "structure",
                            required: [
                              "DatabaseARN"
                            ],
                            members: {
                              DatabaseARN: {}
                            }
                          }
                        }
                      },
                      DeployAsApplicationConfiguration: {
                        type: "structure",
                        required: [
                          "S3ContentLocation"
                        ],
                        members: {
                          S3ContentLocation: {
                            type: "structure",
                            required: [
                              "BucketARN"
                            ],
                            members: {
                              BucketARN: {},
                              BasePath: {}
                            }
                          }
                        }
                      },
                      CustomArtifactsConfiguration: {
                        shape: "S3f"
                      }
                    }
                  }
                }
              },
              CloudWatchLoggingOptions: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              Tags: {
                shape: "S3n"
              },
              ApplicationMode: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ApplicationDetail"
            ],
            members: {
              ApplicationDetail: {
                shape: "S3t"
              }
            }
          }
        },
        CreateApplicationPresignedUrl: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "UrlType"
            ],
            members: {
              ApplicationName: {},
              UrlType: {},
              SessionExpirationDurationInSeconds: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AuthorizedUrl: {}
            }
          }
        },
        CreateApplicationSnapshot: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "SnapshotName"
            ],
            members: {
              ApplicationName: {},
              SnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CreateTimestamp"
            ],
            members: {
              ApplicationName: {},
              CreateTimestamp: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApplicationCloudWatchLoggingOption: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CloudWatchLoggingOptionId"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              CloudWatchLoggingOptionId: {},
              ConditionalToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              },
              CloudWatchLoggingOptionDescriptions: {
                shape: "S9"
              }
            }
          }
        },
        DeleteApplicationInputProcessingConfiguration: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "InputId"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              InputId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              }
            }
          }
        },
        DeleteApplicationOutput: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "OutputId"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              OutputId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              }
            }
          }
        },
        DeleteApplicationReferenceDataSource: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId",
              "ReferenceId"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              ReferenceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              }
            }
          }
        },
        DeleteApplicationSnapshot: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "SnapshotName",
              "SnapshotCreationTimestamp"
            ],
            members: {
              ApplicationName: {},
              SnapshotName: {},
              SnapshotCreationTimestamp: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteApplicationVpcConfiguration: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "VpcConfigurationId"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              VpcConfigurationId: {},
              ConditionalToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationVersionId: {
                type: "long"
              }
            }
          }
        },
        DescribeApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              IncludeAdditionalDetails: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ApplicationDetail"
            ],
            members: {
              ApplicationDetail: {
                shape: "S3t"
              }
            }
          }
        },
        DescribeApplicationSnapshot: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "SnapshotName"
            ],
            members: {
              ApplicationName: {},
              SnapshotName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "SnapshotDetails"
            ],
            members: {
              SnapshotDetails: {
                shape: "S5g"
              }
            }
          }
        },
        DescribeApplicationVersion: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "ApplicationVersionId"
            ],
            members: {
              ApplicationName: {},
              ApplicationVersionId: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationVersionDetail: {
                shape: "S3t"
              }
            }
          }
        },
        DiscoverInputSchema: {
          input: {
            type: "structure",
            required: [
              "ServiceExecutionRole"
            ],
            members: {
              ResourceARN: {},
              ServiceExecutionRole: {},
              InputStartingPositionConfiguration: {
                shape: "S19"
              },
              S3Configuration: {
                type: "structure",
                required: [
                  "BucketARN",
                  "FileKey"
                ],
                members: {
                  BucketARN: {},
                  FileKey: {}
                }
              },
              InputProcessingConfiguration: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InputSchema: {
                shape: "Sm"
              },
              ParsedInputRecords: {
                type: "list",
                member: {
                  type: "list",
                  member: {}
                }
              },
              ProcessedInputRecords: {
                type: "list",
                member: {}
              },
              RawInputRecords: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListApplicationSnapshots: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SnapshotSummaries: {
                type: "list",
                member: {
                  shape: "S5g"
                }
              },
              NextToken: {}
            }
          }
        },
        ListApplicationVersions: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationVersionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ApplicationVersionId",
                    "ApplicationStatus"
                  ],
                  members: {
                    ApplicationVersionId: {
                      type: "long"
                    },
                    ApplicationStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListApplications: {
          input: {
            type: "structure",
            members: {
              Limit: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ApplicationSummaries"
            ],
            members: {
              ApplicationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ApplicationName",
                    "ApplicationARN",
                    "ApplicationStatus",
                    "ApplicationVersionId",
                    "RuntimeEnvironment"
                  ],
                  members: {
                    ApplicationName: {},
                    ApplicationARN: {},
                    ApplicationStatus: {},
                    ApplicationVersionId: {
                      type: "long"
                    },
                    RuntimeEnvironment: {},
                    ApplicationMode: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S3n"
              }
            }
          }
        },
        RollbackApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "CurrentApplicationVersionId"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ApplicationDetail"
            ],
            members: {
              ApplicationDetail: {
                shape: "S3t"
              }
            }
          }
        },
        StartApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              RunConfiguration: {
                type: "structure",
                members: {
                  FlinkRunConfiguration: {
                    shape: "S47"
                  },
                  SqlRunConfigurations: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "InputId",
                        "InputStartingPositionConfiguration"
                      ],
                      members: {
                        InputId: {},
                        InputStartingPositionConfiguration: {
                          shape: "S19"
                        }
                      }
                    }
                  },
                  ApplicationRestoreConfiguration: {
                    shape: "S44"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              Force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S3n"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApplication: {
          input: {
            type: "structure",
            required: [
              "ApplicationName"
            ],
            members: {
              ApplicationName: {},
              CurrentApplicationVersionId: {
                type: "long"
              },
              ApplicationConfigurationUpdate: {
                type: "structure",
                members: {
                  SqlApplicationConfigurationUpdate: {
                    type: "structure",
                    members: {
                      InputUpdates: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "InputId"
                          ],
                          members: {
                            InputId: {},
                            NamePrefixUpdate: {},
                            InputProcessingConfigurationUpdate: {
                              type: "structure",
                              required: [
                                "InputLambdaProcessorUpdate"
                              ],
                              members: {
                                InputLambdaProcessorUpdate: {
                                  type: "structure",
                                  required: [
                                    "ResourceARNUpdate"
                                  ],
                                  members: {
                                    ResourceARNUpdate: {}
                                  }
                                }
                              }
                            },
                            KinesisStreamsInputUpdate: {
                              type: "structure",
                              required: [
                                "ResourceARNUpdate"
                              ],
                              members: {
                                ResourceARNUpdate: {}
                              }
                            },
                            KinesisFirehoseInputUpdate: {
                              type: "structure",
                              required: [
                                "ResourceARNUpdate"
                              ],
                              members: {
                                ResourceARNUpdate: {}
                              }
                            },
                            InputSchemaUpdate: {
                              type: "structure",
                              members: {
                                RecordFormatUpdate: {
                                  shape: "Sn"
                                },
                                RecordEncodingUpdate: {},
                                RecordColumnUpdates: {
                                  shape: "Sw"
                                }
                              }
                            },
                            InputParallelismUpdate: {
                              type: "structure",
                              required: [
                                "CountUpdate"
                              ],
                              members: {
                                CountUpdate: {
                                  type: "integer"
                                }
                              }
                            }
                          }
                        }
                      },
                      OutputUpdates: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "OutputId"
                          ],
                          members: {
                            OutputId: {},
                            NameUpdate: {},
                            KinesisStreamsOutputUpdate: {
                              type: "structure",
                              required: [
                                "ResourceARNUpdate"
                              ],
                              members: {
                                ResourceARNUpdate: {}
                              }
                            },
                            KinesisFirehoseOutputUpdate: {
                              type: "structure",
                              required: [
                                "ResourceARNUpdate"
                              ],
                              members: {
                                ResourceARNUpdate: {}
                              }
                            },
                            LambdaOutputUpdate: {
                              type: "structure",
                              required: [
                                "ResourceARNUpdate"
                              ],
                              members: {
                                ResourceARNUpdate: {}
                              }
                            },
                            DestinationSchemaUpdate: {
                              shape: "S1i"
                            }
                          }
                        }
                      },
                      ReferenceDataSourceUpdates: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "ReferenceId"
                          ],
                          members: {
                            ReferenceId: {},
                            TableNameUpdate: {},
                            S3ReferenceDataSourceUpdate: {
                              type: "structure",
                              members: {
                                BucketARNUpdate: {},
                                FileKeyUpdate: {}
                              }
                            },
                            ReferenceSchemaUpdate: {
                              shape: "Sm"
                            }
                          }
                        }
                      }
                    }
                  },
                  ApplicationCodeConfigurationUpdate: {
                    type: "structure",
                    members: {
                      CodeContentTypeUpdate: {},
                      CodeContentUpdate: {
                        type: "structure",
                        members: {
                          TextContentUpdate: {},
                          ZipFileContentUpdate: {
                            type: "blob"
                          },
                          S3ContentLocationUpdate: {
                            type: "structure",
                            members: {
                              BucketARNUpdate: {},
                              FileKeyUpdate: {},
                              ObjectVersionUpdate: {}
                            }
                          }
                        }
                      }
                    }
                  },
                  FlinkApplicationConfigurationUpdate: {
                    type: "structure",
                    members: {
                      CheckpointConfigurationUpdate: {
                        type: "structure",
                        members: {
                          ConfigurationTypeUpdate: {},
                          CheckpointingEnabledUpdate: {
                            type: "boolean"
                          },
                          CheckpointIntervalUpdate: {
                            type: "long"
                          },
                          MinPauseBetweenCheckpointsUpdate: {
                            type: "long"
                          }
                        }
                      },
                      MonitoringConfigurationUpdate: {
                        type: "structure",
                        members: {
                          ConfigurationTypeUpdate: {},
                          MetricsLevelUpdate: {},
                          LogLevelUpdate: {}
                        }
                      },
                      ParallelismConfigurationUpdate: {
                        type: "structure",
                        members: {
                          ConfigurationTypeUpdate: {},
                          ParallelismUpdate: {
                            type: "integer"
                          },
                          ParallelismPerKPUUpdate: {
                            type: "integer"
                          },
                          AutoScalingEnabledUpdate: {
                            type: "boolean"
                          }
                        }
                      }
                    }
                  },
                  EnvironmentPropertyUpdates: {
                    type: "structure",
                    required: [
                      "PropertyGroups"
                    ],
                    members: {
                      PropertyGroups: {
                        shape: "S2t"
                      }
                    }
                  },
                  ApplicationSnapshotConfigurationUpdate: {
                    type: "structure",
                    required: [
                      "SnapshotsEnabledUpdate"
                    ],
                    members: {
                      SnapshotsEnabledUpdate: {
                        type: "boolean"
                      }
                    }
                  },
                  VpcConfigurationUpdates: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "VpcConfigurationId"
                      ],
                      members: {
                        VpcConfigurationId: {},
                        SubnetIdUpdates: {
                          shape: "S21"
                        },
                        SecurityGroupIdUpdates: {
                          shape: "S23"
                        }
                      }
                    }
                  },
                  ZeppelinApplicationConfigurationUpdate: {
                    type: "structure",
                    members: {
                      MonitoringConfigurationUpdate: {
                        type: "structure",
                        required: [
                          "LogLevelUpdate"
                        ],
                        members: {
                          LogLevelUpdate: {}
                        }
                      },
                      CatalogConfigurationUpdate: {
                        type: "structure",
                        required: [
                          "GlueDataCatalogConfigurationUpdate"
                        ],
                        members: {
                          GlueDataCatalogConfigurationUpdate: {
                            type: "structure",
                            required: [
                              "DatabaseARNUpdate"
                            ],
                            members: {
                              DatabaseARNUpdate: {}
                            }
                          }
                        }
                      },
                      DeployAsApplicationConfigurationUpdate: {
                        type: "structure",
                        members: {
                          S3ContentLocationUpdate: {
                            type: "structure",
                            members: {
                              BucketARNUpdate: {},
                              BasePathUpdate: {}
                            }
                          }
                        }
                      },
                      CustomArtifactsConfigurationUpdate: {
                        shape: "S3f"
                      }
                    }
                  }
                }
              },
              ServiceExecutionRoleUpdate: {},
              RunConfigurationUpdate: {
                type: "structure",
                members: {
                  FlinkRunConfiguration: {
                    shape: "S47"
                  },
                  ApplicationRestoreConfiguration: {
                    shape: "S44"
                  }
                }
              },
              CloudWatchLoggingOptionUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CloudWatchLoggingOptionId"
                  ],
                  members: {
                    CloudWatchLoggingOptionId: {},
                    LogStreamARNUpdate: {}
                  }
                }
              },
              ConditionalToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ApplicationDetail"
            ],
            members: {
              ApplicationDetail: {
                shape: "S3t"
              }
            }
          }
        },
        UpdateApplicationMaintenanceConfiguration: {
          input: {
            type: "structure",
            required: [
              "ApplicationName",
              "ApplicationMaintenanceConfigurationUpdate"
            ],
            members: {
              ApplicationName: {},
              ApplicationMaintenanceConfigurationUpdate: {
                type: "structure",
                required: [
                  "ApplicationMaintenanceWindowStartTimeUpdate"
                ],
                members: {
                  ApplicationMaintenanceWindowStartTimeUpdate: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationARN: {},
              ApplicationMaintenanceConfigurationDescription: {
                shape: "S4o"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "LogStreamARN"
          ],
          members: {
            LogStreamARN: {}
          }
        },
        S9: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "LogStreamARN"
            ],
            members: {
              CloudWatchLoggingOptionId: {},
              LogStreamARN: {},
              RoleARN: {}
            }
          }
        },
        Se: {
          type: "structure",
          required: [
            "NamePrefix",
            "InputSchema"
          ],
          members: {
            NamePrefix: {},
            InputProcessingConfiguration: {
              shape: "Sg"
            },
            KinesisStreamsInput: {
              type: "structure",
              required: [
                "ResourceARN"
              ],
              members: {
                ResourceARN: {}
              }
            },
            KinesisFirehoseInput: {
              type: "structure",
              required: [
                "ResourceARN"
              ],
              members: {
                ResourceARN: {}
              }
            },
            InputParallelism: {
              shape: "Sk"
            },
            InputSchema: {
              shape: "Sm"
            }
          }
        },
        Sg: {
          type: "structure",
          required: [
            "InputLambdaProcessor"
          ],
          members: {
            InputLambdaProcessor: {
              type: "structure",
              required: [
                "ResourceARN"
              ],
              members: {
                ResourceARN: {}
              }
            }
          }
        },
        Sk: {
          type: "structure",
          members: {
            Count: {
              type: "integer"
            }
          }
        },
        Sm: {
          type: "structure",
          required: [
            "RecordFormat",
            "RecordColumns"
          ],
          members: {
            RecordFormat: {
              shape: "Sn"
            },
            RecordEncoding: {},
            RecordColumns: {
              shape: "Sw"
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "RecordFormatType"
          ],
          members: {
            RecordFormatType: {},
            MappingParameters: {
              type: "structure",
              members: {
                JSONMappingParameters: {
                  type: "structure",
                  required: [
                    "RecordRowPath"
                  ],
                  members: {
                    RecordRowPath: {}
                  }
                },
                CSVMappingParameters: {
                  type: "structure",
                  required: [
                    "RecordRowDelimiter",
                    "RecordColumnDelimiter"
                  ],
                  members: {
                    RecordRowDelimiter: {},
                    RecordColumnDelimiter: {}
                  }
                }
              }
            }
          }
        },
        Sw: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "SqlType"
            ],
            members: {
              Name: {},
              Mapping: {},
              SqlType: {}
            }
          }
        },
        S12: {
          type: "list",
          member: {
            type: "structure",
            members: {
              InputId: {},
              NamePrefix: {},
              InAppStreamNames: {
                type: "list",
                member: {}
              },
              InputProcessingConfigurationDescription: {
                shape: "S15"
              },
              KinesisStreamsInputDescription: {
                type: "structure",
                required: [
                  "ResourceARN"
                ],
                members: {
                  ResourceARN: {},
                  RoleARN: {}
                }
              },
              KinesisFirehoseInputDescription: {
                type: "structure",
                required: [
                  "ResourceARN"
                ],
                members: {
                  ResourceARN: {},
                  RoleARN: {}
                }
              },
              InputSchema: {
                shape: "Sm"
              },
              InputParallelism: {
                shape: "Sk"
              },
              InputStartingPositionConfiguration: {
                shape: "S19"
              }
            }
          }
        },
        S15: {
          type: "structure",
          members: {
            InputLambdaProcessorDescription: {
              type: "structure",
              required: [
                "ResourceARN"
              ],
              members: {
                ResourceARN: {},
                RoleARN: {}
              }
            }
          }
        },
        S19: {
          type: "structure",
          members: {
            InputStartingPosition: {}
          }
        },
        S1e: {
          type: "structure",
          required: [
            "Name",
            "DestinationSchema"
          ],
          members: {
            Name: {},
            KinesisStreamsOutput: {
              type: "structure",
              required: [
                "ResourceARN"
              ],
              members: {
                ResourceARN: {}
              }
            },
            KinesisFirehoseOutput: {
              type: "structure",
              required: [
                "ResourceARN"
              ],
              members: {
                ResourceARN: {}
              }
            },
            LambdaOutput: {
              type: "structure",
              required: [
                "ResourceARN"
              ],
              members: {
                ResourceARN: {}
              }
            },
            DestinationSchema: {
              shape: "S1i"
            }
          }
        },
        S1i: {
          type: "structure",
          required: [
            "RecordFormatType"
          ],
          members: {
            RecordFormatType: {}
          }
        },
        S1k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              OutputId: {},
              Name: {},
              KinesisStreamsOutputDescription: {
                type: "structure",
                required: [
                  "ResourceARN"
                ],
                members: {
                  ResourceARN: {},
                  RoleARN: {}
                }
              },
              KinesisFirehoseOutputDescription: {
                type: "structure",
                required: [
                  "ResourceARN"
                ],
                members: {
                  ResourceARN: {},
                  RoleARN: {}
                }
              },
              LambdaOutputDescription: {
                type: "structure",
                required: [
                  "ResourceARN"
                ],
                members: {
                  ResourceARN: {},
                  RoleARN: {}
                }
              },
              DestinationSchema: {
                shape: "S1i"
              }
            }
          }
        },
        S1q: {
          type: "structure",
          required: [
            "TableName",
            "ReferenceSchema"
          ],
          members: {
            TableName: {},
            S3ReferenceDataSource: {
              type: "structure",
              members: {
                BucketARN: {},
                FileKey: {}
              }
            },
            ReferenceSchema: {
              shape: "Sm"
            }
          }
        },
        S1w: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ReferenceId",
              "TableName",
              "S3ReferenceDataSourceDescription"
            ],
            members: {
              ReferenceId: {},
              TableName: {},
              S3ReferenceDataSourceDescription: {
                type: "structure",
                required: [
                  "BucketARN",
                  "FileKey"
                ],
                members: {
                  BucketARN: {},
                  FileKey: {},
                  ReferenceRoleARN: {}
                }
              },
              ReferenceSchema: {
                shape: "Sm"
              }
            }
          }
        },
        S20: {
          type: "structure",
          required: [
            "SubnetIds",
            "SecurityGroupIds"
          ],
          members: {
            SubnetIds: {
              shape: "S21"
            },
            SecurityGroupIds: {
              shape: "S23"
            }
          }
        },
        S21: {
          type: "list",
          member: {}
        },
        S23: {
          type: "list",
          member: {}
        },
        S26: {
          type: "structure",
          required: [
            "VpcConfigurationId",
            "VpcId",
            "SubnetIds",
            "SecurityGroupIds"
          ],
          members: {
            VpcConfigurationId: {},
            VpcId: {},
            SubnetIds: {
              shape: "S21"
            },
            SecurityGroupIds: {
              shape: "S23"
            }
          }
        },
        S2t: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "PropertyGroupId",
              "PropertyMap"
            ],
            members: {
              PropertyGroupId: {},
              PropertyMap: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        S32: {
          type: "structure",
          required: [
            "BucketARN",
            "FileKey"
          ],
          members: {
            BucketARN: {},
            FileKey: {},
            ObjectVersion: {}
          }
        },
        S3f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ArtifactType"
            ],
            members: {
              ArtifactType: {},
              S3ContentLocation: {
                shape: "S32"
              },
              MavenReference: {
                shape: "S3i"
              }
            }
          }
        },
        S3i: {
          type: "structure",
          required: [
            "GroupId",
            "ArtifactId",
            "Version"
          ],
          members: {
            GroupId: {},
            ArtifactId: {},
            Version: {}
          }
        },
        S3n: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S3t: {
          type: "structure",
          required: [
            "ApplicationARN",
            "ApplicationName",
            "RuntimeEnvironment",
            "ApplicationStatus",
            "ApplicationVersionId"
          ],
          members: {
            ApplicationARN: {},
            ApplicationDescription: {},
            ApplicationName: {},
            RuntimeEnvironment: {},
            ServiceExecutionRole: {},
            ApplicationStatus: {},
            ApplicationVersionId: {
              type: "long"
            },
            CreateTimestamp: {
              type: "timestamp"
            },
            LastUpdateTimestamp: {
              type: "timestamp"
            },
            ApplicationConfigurationDescription: {
              type: "structure",
              members: {
                SqlApplicationConfigurationDescription: {
                  type: "structure",
                  members: {
                    InputDescriptions: {
                      shape: "S12"
                    },
                    OutputDescriptions: {
                      shape: "S1k"
                    },
                    ReferenceDataSourceDescriptions: {
                      shape: "S1w"
                    }
                  }
                },
                ApplicationCodeConfigurationDescription: {
                  type: "structure",
                  required: [
                    "CodeContentType"
                  ],
                  members: {
                    CodeContentType: {},
                    CodeContentDescription: {
                      type: "structure",
                      members: {
                        TextContent: {},
                        CodeMD5: {},
                        CodeSize: {
                          type: "long"
                        },
                        S3ApplicationCodeLocationDescription: {
                          type: "structure",
                          required: [
                            "BucketARN",
                            "FileKey"
                          ],
                          members: {
                            BucketARN: {},
                            FileKey: {},
                            ObjectVersion: {}
                          }
                        }
                      }
                    }
                  }
                },
                RunConfigurationDescription: {
                  type: "structure",
                  members: {
                    ApplicationRestoreConfigurationDescription: {
                      shape: "S44"
                    },
                    FlinkRunConfigurationDescription: {
                      shape: "S47"
                    }
                  }
                },
                FlinkApplicationConfigurationDescription: {
                  type: "structure",
                  members: {
                    CheckpointConfigurationDescription: {
                      type: "structure",
                      members: {
                        ConfigurationType: {},
                        CheckpointingEnabled: {
                          type: "boolean"
                        },
                        CheckpointInterval: {
                          type: "long"
                        },
                        MinPauseBetweenCheckpoints: {
                          type: "long"
                        }
                      }
                    },
                    MonitoringConfigurationDescription: {
                      type: "structure",
                      members: {
                        ConfigurationType: {},
                        MetricsLevel: {},
                        LogLevel: {}
                      }
                    },
                    ParallelismConfigurationDescription: {
                      type: "structure",
                      members: {
                        ConfigurationType: {},
                        Parallelism: {
                          type: "integer"
                        },
                        ParallelismPerKPU: {
                          type: "integer"
                        },
                        CurrentParallelism: {
                          type: "integer"
                        },
                        AutoScalingEnabled: {
                          type: "boolean"
                        }
                      }
                    },
                    JobPlanDescription: {}
                  }
                },
                EnvironmentPropertyDescriptions: {
                  type: "structure",
                  members: {
                    PropertyGroupDescriptions: {
                      shape: "S2t"
                    }
                  }
                },
                ApplicationSnapshotConfigurationDescription: {
                  type: "structure",
                  required: [
                    "SnapshotsEnabled"
                  ],
                  members: {
                    SnapshotsEnabled: {
                      type: "boolean"
                    }
                  }
                },
                VpcConfigurationDescriptions: {
                  type: "list",
                  member: {
                    shape: "S26"
                  }
                },
                ZeppelinApplicationConfigurationDescription: {
                  type: "structure",
                  required: [
                    "MonitoringConfigurationDescription"
                  ],
                  members: {
                    MonitoringConfigurationDescription: {
                      type: "structure",
                      members: {
                        LogLevel: {}
                      }
                    },
                    CatalogConfigurationDescription: {
                      type: "structure",
                      required: [
                        "GlueDataCatalogConfigurationDescription"
                      ],
                      members: {
                        GlueDataCatalogConfigurationDescription: {
                          type: "structure",
                          required: [
                            "DatabaseARN"
                          ],
                          members: {
                            DatabaseARN: {}
                          }
                        }
                      }
                    },
                    DeployAsApplicationConfigurationDescription: {
                      type: "structure",
                      required: [
                        "S3ContentLocationDescription"
                      ],
                      members: {
                        S3ContentLocationDescription: {
                          type: "structure",
                          required: [
                            "BucketARN"
                          ],
                          members: {
                            BucketARN: {},
                            BasePath: {}
                          }
                        }
                      }
                    },
                    CustomArtifactsConfigurationDescription: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ArtifactType: {},
                          S3ContentLocationDescription: {
                            shape: "S32"
                          },
                          MavenReferenceDescription: {
                            shape: "S3i"
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            CloudWatchLoggingOptionDescriptions: {
              shape: "S9"
            },
            ApplicationMaintenanceConfigurationDescription: {
              shape: "S4o"
            },
            ApplicationVersionUpdatedFrom: {
              type: "long"
            },
            ApplicationVersionRolledBackFrom: {
              type: "long"
            },
            ConditionalToken: {},
            ApplicationVersionRolledBackTo: {
              type: "long"
            },
            ApplicationMode: {}
          }
        },
        S44: {
          type: "structure",
          required: [
            "ApplicationRestoreType"
          ],
          members: {
            ApplicationRestoreType: {},
            SnapshotName: {}
          }
        },
        S47: {
          type: "structure",
          members: {
            AllowNonRestoredState: {
              type: "boolean"
            }
          }
        },
        S4o: {
          type: "structure",
          required: [
            "ApplicationMaintenanceWindowStartTime",
            "ApplicationMaintenanceWindowEndTime"
          ],
          members: {
            ApplicationMaintenanceWindowStartTime: {},
            ApplicationMaintenanceWindowEndTime: {}
          }
        },
        S5g: {
          type: "structure",
          required: [
            "SnapshotName",
            "SnapshotStatus",
            "ApplicationVersionId"
          ],
          members: {
            SnapshotName: {},
            SnapshotStatus: {},
            ApplicationVersionId: {
              type: "long"
            },
            SnapshotCreationTimestamp: {
              type: "timestamp"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kinesisanalyticsv2-2018-05-23.paginators.json
var require_kinesisanalyticsv2_2018_05_23_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kinesisanalyticsv2-2018-05-23.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/kinesisanalyticsv2.js
var require_kinesisanalyticsv2 = __commonJS({
  "node_modules/aws-sdk/clients/kinesisanalyticsv2.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["kinesisanalyticsv2"] = {};
    AWS3.KinesisAnalyticsV2 = Service.defineService("kinesisanalyticsv2", ["2018-05-23"]);
    Object.defineProperty(apiLoader.services["kinesisanalyticsv2"], "2018-05-23", {
      get: function get() {
        var model = require_kinesisanalyticsv2_2018_05_23_min();
        model.paginators = require_kinesisanalyticsv2_2018_05_23_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.KinesisAnalyticsV2;
  }
});

// node_modules/aws-sdk/apis/mediaconnect-2018-11-14.min.json
var require_mediaconnect_2018_11_14_min = __commonJS({
  "node_modules/aws-sdk/apis/mediaconnect-2018-11-14.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2018-11-14",
        endpointPrefix: "mediaconnect",
        signingName: "mediaconnect",
        serviceFullName: "AWS MediaConnect",
        serviceId: "MediaConnect",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "mediaconnect-2018-11-14",
        signatureVersion: "v4"
      },
      operations: {
        AddFlowMediaStreams: {
          http: {
            requestUri: "/v1/flows/{flowArn}/mediaStreams",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              MediaStreams: {
                shape: "S3",
                locationName: "mediaStreams"
              }
            },
            required: [
              "FlowArn",
              "MediaStreams"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              MediaStreams: {
                shape: "Se",
                locationName: "mediaStreams"
              }
            }
          }
        },
        AddFlowOutputs: {
          http: {
            requestUri: "/v1/flows/{flowArn}/outputs",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              Outputs: {
                shape: "Sj",
                locationName: "outputs"
              }
            },
            required: [
              "FlowArn",
              "Outputs"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              Outputs: {
                shape: "S11",
                locationName: "outputs"
              }
            }
          }
        },
        AddFlowSources: {
          http: {
            requestUri: "/v1/flows/{flowArn}/source",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              Sources: {
                shape: "S1b",
                locationName: "sources"
              }
            },
            required: [
              "FlowArn",
              "Sources"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              Sources: {
                shape: "S1i",
                locationName: "sources"
              }
            }
          }
        },
        AddFlowVpcInterfaces: {
          http: {
            requestUri: "/v1/flows/{flowArn}/vpcInterfaces",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              VpcInterfaces: {
                shape: "S1p",
                locationName: "vpcInterfaces"
              }
            },
            required: [
              "FlowArn",
              "VpcInterfaces"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              VpcInterfaces: {
                shape: "S1t",
                locationName: "vpcInterfaces"
              }
            }
          }
        },
        CreateFlow: {
          http: {
            requestUri: "/v1/flows",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              AvailabilityZone: {
                locationName: "availabilityZone"
              },
              Entitlements: {
                shape: "S1w",
                locationName: "entitlements"
              },
              MediaStreams: {
                shape: "S3",
                locationName: "mediaStreams"
              },
              Name: {
                locationName: "name"
              },
              Outputs: {
                shape: "Sj",
                locationName: "outputs"
              },
              Source: {
                shape: "S1c",
                locationName: "source"
              },
              SourceFailoverConfig: {
                shape: "S1z",
                locationName: "sourceFailoverConfig"
              },
              Sources: {
                shape: "S1b",
                locationName: "sources"
              },
              VpcInterfaces: {
                shape: "S1p",
                locationName: "vpcInterfaces"
              }
            },
            required: [
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Flow: {
                shape: "S24",
                locationName: "flow"
              }
            }
          }
        },
        DeleteFlow: {
          http: {
            method: "DELETE",
            requestUri: "/v1/flows/{flowArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              }
            },
            required: [
              "FlowArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        DescribeFlow: {
          http: {
            method: "GET",
            requestUri: "/v1/flows/{flowArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              }
            },
            required: [
              "FlowArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Flow: {
                shape: "S24",
                locationName: "flow"
              },
              Messages: {
                locationName: "messages",
                type: "structure",
                members: {
                  Errors: {
                    shape: "Sl",
                    locationName: "errors"
                  }
                },
                required: [
                  "Errors"
                ]
              }
            }
          }
        },
        DescribeOffering: {
          http: {
            method: "GET",
            requestUri: "/v1/offerings/{offeringArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              OfferingArn: {
                location: "uri",
                locationName: "offeringArn"
              }
            },
            required: [
              "OfferingArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Offering: {
                shape: "S2f",
                locationName: "offering"
              }
            }
          }
        },
        DescribeReservation: {
          http: {
            method: "GET",
            requestUri: "/v1/reservations/{reservationArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ReservationArn: {
                location: "uri",
                locationName: "reservationArn"
              }
            },
            required: [
              "ReservationArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Reservation: {
                shape: "S2m",
                locationName: "reservation"
              }
            }
          }
        },
        GrantFlowEntitlements: {
          http: {
            requestUri: "/v1/flows/{flowArn}/entitlements",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Entitlements: {
                shape: "S1w",
                locationName: "entitlements"
              },
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              }
            },
            required: [
              "FlowArn",
              "Entitlements"
            ]
          },
          output: {
            type: "structure",
            members: {
              Entitlements: {
                shape: "S25",
                locationName: "entitlements"
              },
              FlowArn: {
                locationName: "flowArn"
              }
            }
          }
        },
        ListEntitlements: {
          http: {
            method: "GET",
            requestUri: "/v1/entitlements",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Entitlements: {
                locationName: "entitlements",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DataTransferSubscriberFeePercent: {
                      locationName: "dataTransferSubscriberFeePercent",
                      type: "integer"
                    },
                    EntitlementArn: {
                      locationName: "entitlementArn"
                    },
                    EntitlementName: {
                      locationName: "entitlementName"
                    }
                  },
                  required: [
                    "EntitlementArn",
                    "EntitlementName"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListFlows: {
          http: {
            method: "GET",
            requestUri: "/v1/flows",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Flows: {
                locationName: "flows",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AvailabilityZone: {
                      locationName: "availabilityZone"
                    },
                    Description: {
                      locationName: "description"
                    },
                    FlowArn: {
                      locationName: "flowArn"
                    },
                    Name: {
                      locationName: "name"
                    },
                    SourceType: {
                      locationName: "sourceType"
                    },
                    Status: {
                      locationName: "status"
                    }
                  },
                  required: [
                    "Status",
                    "Description",
                    "SourceType",
                    "AvailabilityZone",
                    "FlowArn",
                    "Name"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListOfferings: {
          http: {
            method: "GET",
            requestUri: "/v1/offerings",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Offerings: {
                locationName: "offerings",
                type: "list",
                member: {
                  shape: "S2f"
                }
              }
            }
          }
        },
        ListReservations: {
          http: {
            method: "GET",
            requestUri: "/v1/reservations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Reservations: {
                locationName: "reservations",
                type: "list",
                member: {
                  shape: "S2m"
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S38",
                locationName: "tags"
              }
            }
          }
        },
        PurchaseOffering: {
          http: {
            requestUri: "/v1/offerings/{offeringArn}",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              OfferingArn: {
                location: "uri",
                locationName: "offeringArn"
              },
              ReservationName: {
                locationName: "reservationName"
              },
              Start: {
                locationName: "start"
              }
            },
            required: [
              "OfferingArn",
              "Start",
              "ReservationName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Reservation: {
                shape: "S2m",
                locationName: "reservation"
              }
            }
          }
        },
        RemoveFlowMediaStream: {
          http: {
            method: "DELETE",
            requestUri: "/v1/flows/{flowArn}/mediaStreams/{mediaStreamName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              MediaStreamName: {
                location: "uri",
                locationName: "mediaStreamName"
              }
            },
            required: [
              "FlowArn",
              "MediaStreamName"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              MediaStreamName: {
                locationName: "mediaStreamName"
              }
            }
          }
        },
        RemoveFlowOutput: {
          http: {
            method: "DELETE",
            requestUri: "/v1/flows/{flowArn}/outputs/{outputArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              OutputArn: {
                location: "uri",
                locationName: "outputArn"
              }
            },
            required: [
              "FlowArn",
              "OutputArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              OutputArn: {
                locationName: "outputArn"
              }
            }
          }
        },
        RemoveFlowSource: {
          http: {
            method: "DELETE",
            requestUri: "/v1/flows/{flowArn}/source/{sourceArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              SourceArn: {
                location: "uri",
                locationName: "sourceArn"
              }
            },
            required: [
              "FlowArn",
              "SourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              SourceArn: {
                locationName: "sourceArn"
              }
            }
          }
        },
        RemoveFlowVpcInterface: {
          http: {
            method: "DELETE",
            requestUri: "/v1/flows/{flowArn}/vpcInterfaces/{vpcInterfaceName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              VpcInterfaceName: {
                location: "uri",
                locationName: "vpcInterfaceName"
              }
            },
            required: [
              "FlowArn",
              "VpcInterfaceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              NonDeletedNetworkInterfaceIds: {
                shape: "Sl",
                locationName: "nonDeletedNetworkInterfaceIds"
              },
              VpcInterfaceName: {
                locationName: "vpcInterfaceName"
              }
            }
          }
        },
        RevokeFlowEntitlement: {
          http: {
            method: "DELETE",
            requestUri: "/v1/flows/{flowArn}/entitlements/{entitlementArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              EntitlementArn: {
                location: "uri",
                locationName: "entitlementArn"
              },
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              }
            },
            required: [
              "FlowArn",
              "EntitlementArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              EntitlementArn: {
                locationName: "entitlementArn"
              },
              FlowArn: {
                locationName: "flowArn"
              }
            }
          }
        },
        StartFlow: {
          http: {
            requestUri: "/v1/flows/start/{flowArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              }
            },
            required: [
              "FlowArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        StopFlow: {
          http: {
            requestUri: "/v1/flows/stop/{flowArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              }
            },
            required: [
              "FlowArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "S38",
                locationName: "tags"
              }
            },
            required: [
              "ResourceArn",
              "Tags"
            ]
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                shape: "Sl",
                location: "querystring",
                locationName: "tagKeys"
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ]
          }
        },
        UpdateFlow: {
          http: {
            method: "PUT",
            requestUri: "/v1/flows/{flowArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              SourceFailoverConfig: {
                locationName: "sourceFailoverConfig",
                type: "structure",
                members: {
                  FailoverMode: {
                    locationName: "failoverMode"
                  },
                  RecoveryWindow: {
                    locationName: "recoveryWindow",
                    type: "integer"
                  },
                  SourcePriority: {
                    shape: "S21",
                    locationName: "sourcePriority"
                  },
                  State: {
                    locationName: "state"
                  }
                }
              }
            },
            required: [
              "FlowArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Flow: {
                shape: "S24",
                locationName: "flow"
              }
            }
          }
        },
        UpdateFlowEntitlement: {
          http: {
            method: "PUT",
            requestUri: "/v1/flows/{flowArn}/entitlements/{entitlementArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Description: {
                locationName: "description"
              },
              Encryption: {
                shape: "S3v",
                locationName: "encryption"
              },
              EntitlementArn: {
                location: "uri",
                locationName: "entitlementArn"
              },
              EntitlementStatus: {
                locationName: "entitlementStatus"
              },
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              Subscribers: {
                shape: "Sl",
                locationName: "subscribers"
              }
            },
            required: [
              "FlowArn",
              "EntitlementArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Entitlement: {
                shape: "S26",
                locationName: "entitlement"
              },
              FlowArn: {
                locationName: "flowArn"
              }
            }
          }
        },
        UpdateFlowMediaStream: {
          http: {
            method: "PUT",
            requestUri: "/v1/flows/{flowArn}/mediaStreams/{mediaStreamName}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S5",
                locationName: "attributes"
              },
              ClockRate: {
                locationName: "clockRate",
                type: "integer"
              },
              Description: {
                locationName: "description"
              },
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              MediaStreamName: {
                location: "uri",
                locationName: "mediaStreamName"
              },
              MediaStreamType: {
                locationName: "mediaStreamType"
              },
              VideoFormat: {
                locationName: "videoFormat"
              }
            },
            required: [
              "FlowArn",
              "MediaStreamName"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              MediaStream: {
                shape: "Sf",
                locationName: "mediaStream"
              }
            }
          }
        },
        UpdateFlowOutput: {
          http: {
            method: "PUT",
            requestUri: "/v1/flows/{flowArn}/outputs/{outputArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              CidrAllowList: {
                shape: "Sl",
                locationName: "cidrAllowList"
              },
              Description: {
                locationName: "description"
              },
              Destination: {
                locationName: "destination"
              },
              Encryption: {
                shape: "S3v",
                locationName: "encryption"
              },
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              MaxLatency: {
                locationName: "maxLatency",
                type: "integer"
              },
              MediaStreamOutputConfigurations: {
                shape: "Sp",
                locationName: "mediaStreamOutputConfigurations"
              },
              MinLatency: {
                locationName: "minLatency",
                type: "integer"
              },
              OutputArn: {
                location: "uri",
                locationName: "outputArn"
              },
              Port: {
                locationName: "port",
                type: "integer"
              },
              Protocol: {
                locationName: "protocol"
              },
              RemoteId: {
                locationName: "remoteId"
              },
              SmoothingLatency: {
                locationName: "smoothingLatency",
                type: "integer"
              },
              StreamId: {
                locationName: "streamId"
              },
              VpcInterfaceAttachment: {
                shape: "Sz",
                locationName: "vpcInterfaceAttachment"
              }
            },
            required: [
              "FlowArn",
              "OutputArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              Output: {
                shape: "S12",
                locationName: "output"
              }
            }
          }
        },
        UpdateFlowSource: {
          http: {
            method: "PUT",
            requestUri: "/v1/flows/{flowArn}/source/{sourceArn}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Decryption: {
                shape: "S3v",
                locationName: "decryption"
              },
              Description: {
                locationName: "description"
              },
              EntitlementArn: {
                locationName: "entitlementArn"
              },
              FlowArn: {
                location: "uri",
                locationName: "flowArn"
              },
              IngestPort: {
                locationName: "ingestPort",
                type: "integer"
              },
              MaxBitrate: {
                locationName: "maxBitrate",
                type: "integer"
              },
              MaxLatency: {
                locationName: "maxLatency",
                type: "integer"
              },
              MaxSyncBuffer: {
                locationName: "maxSyncBuffer",
                type: "integer"
              },
              MediaStreamSourceConfigurations: {
                shape: "S1d",
                locationName: "mediaStreamSourceConfigurations"
              },
              MinLatency: {
                locationName: "minLatency",
                type: "integer"
              },
              Protocol: {
                locationName: "protocol"
              },
              SourceArn: {
                location: "uri",
                locationName: "sourceArn"
              },
              StreamId: {
                locationName: "streamId"
              },
              VpcInterfaceName: {
                locationName: "vpcInterfaceName"
              },
              WhitelistCidr: {
                locationName: "whitelistCidr"
              }
            },
            required: [
              "FlowArn",
              "SourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              FlowArn: {
                locationName: "flowArn"
              },
              Source: {
                shape: "S1j",
                locationName: "source"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Attributes: {
                shape: "S5",
                locationName: "attributes"
              },
              ClockRate: {
                locationName: "clockRate",
                type: "integer"
              },
              Description: {
                locationName: "description"
              },
              MediaStreamId: {
                locationName: "mediaStreamId",
                type: "integer"
              },
              MediaStreamName: {
                locationName: "mediaStreamName"
              },
              MediaStreamType: {
                locationName: "mediaStreamType"
              },
              VideoFormat: {
                locationName: "videoFormat"
              }
            },
            required: [
              "MediaStreamType",
              "MediaStreamId",
              "MediaStreamName"
            ]
          }
        },
        S5: {
          type: "structure",
          members: {
            Fmtp: {
              locationName: "fmtp",
              type: "structure",
              members: {
                ChannelOrder: {
                  locationName: "channelOrder"
                },
                Colorimetry: {
                  locationName: "colorimetry"
                },
                ExactFramerate: {
                  locationName: "exactFramerate"
                },
                Par: {
                  locationName: "par"
                },
                Range: {
                  locationName: "range"
                },
                ScanMode: {
                  locationName: "scanMode"
                },
                Tcs: {
                  locationName: "tcs"
                }
              }
            },
            Lang: {
              locationName: "lang"
            }
          }
        },
        Se: {
          type: "list",
          member: {
            shape: "Sf"
          }
        },
        Sf: {
          type: "structure",
          members: {
            Attributes: {
              locationName: "attributes",
              type: "structure",
              members: {
                Fmtp: {
                  locationName: "fmtp",
                  type: "structure",
                  members: {
                    ChannelOrder: {
                      locationName: "channelOrder"
                    },
                    Colorimetry: {
                      locationName: "colorimetry"
                    },
                    ExactFramerate: {
                      locationName: "exactFramerate"
                    },
                    Par: {
                      locationName: "par"
                    },
                    Range: {
                      locationName: "range"
                    },
                    ScanMode: {
                      locationName: "scanMode"
                    },
                    Tcs: {
                      locationName: "tcs"
                    }
                  }
                },
                Lang: {
                  locationName: "lang"
                }
              },
              required: [
                "Fmtp"
              ]
            },
            ClockRate: {
              locationName: "clockRate",
              type: "integer"
            },
            Description: {
              locationName: "description"
            },
            Fmt: {
              locationName: "fmt",
              type: "integer"
            },
            MediaStreamId: {
              locationName: "mediaStreamId",
              type: "integer"
            },
            MediaStreamName: {
              locationName: "mediaStreamName"
            },
            MediaStreamType: {
              locationName: "mediaStreamType"
            },
            VideoFormat: {
              locationName: "videoFormat"
            }
          },
          required: [
            "MediaStreamType",
            "MediaStreamId",
            "MediaStreamName",
            "Fmt"
          ]
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            members: {
              CidrAllowList: {
                shape: "Sl",
                locationName: "cidrAllowList"
              },
              Description: {
                locationName: "description"
              },
              Destination: {
                locationName: "destination"
              },
              Encryption: {
                shape: "Sm",
                locationName: "encryption"
              },
              MaxLatency: {
                locationName: "maxLatency",
                type: "integer"
              },
              MediaStreamOutputConfigurations: {
                shape: "Sp",
                locationName: "mediaStreamOutputConfigurations"
              },
              MinLatency: {
                locationName: "minLatency",
                type: "integer"
              },
              Name: {
                locationName: "name"
              },
              Port: {
                locationName: "port",
                type: "integer"
              },
              Protocol: {
                locationName: "protocol"
              },
              RemoteId: {
                locationName: "remoteId"
              },
              SmoothingLatency: {
                locationName: "smoothingLatency",
                type: "integer"
              },
              StreamId: {
                locationName: "streamId"
              },
              VpcInterfaceAttachment: {
                shape: "Sz",
                locationName: "vpcInterfaceAttachment"
              }
            },
            required: [
              "Protocol"
            ]
          }
        },
        Sl: {
          type: "list",
          member: {}
        },
        Sm: {
          type: "structure",
          members: {
            Algorithm: {
              locationName: "algorithm"
            },
            ConstantInitializationVector: {
              locationName: "constantInitializationVector"
            },
            DeviceId: {
              locationName: "deviceId"
            },
            KeyType: {
              locationName: "keyType"
            },
            Region: {
              locationName: "region"
            },
            ResourceId: {
              locationName: "resourceId"
            },
            RoleArn: {
              locationName: "roleArn"
            },
            SecretArn: {
              locationName: "secretArn"
            },
            Url: {
              locationName: "url"
            }
          },
          required: [
            "RoleArn"
          ]
        },
        Sp: {
          type: "list",
          member: {
            type: "structure",
            members: {
              DestinationConfigurations: {
                locationName: "destinationConfigurations",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DestinationIp: {
                      locationName: "destinationIp"
                    },
                    DestinationPort: {
                      locationName: "destinationPort",
                      type: "integer"
                    },
                    Interface: {
                      shape: "St",
                      locationName: "interface"
                    }
                  },
                  required: [
                    "DestinationIp",
                    "DestinationPort",
                    "Interface"
                  ]
                }
              },
              EncodingName: {
                locationName: "encodingName"
              },
              EncodingParameters: {
                locationName: "encodingParameters",
                type: "structure",
                members: {
                  CompressionFactor: {
                    locationName: "compressionFactor",
                    type: "double"
                  },
                  EncoderProfile: {
                    locationName: "encoderProfile"
                  }
                },
                required: [
                  "EncoderProfile",
                  "CompressionFactor"
                ]
              },
              MediaStreamName: {
                locationName: "mediaStreamName"
              }
            },
            required: [
              "MediaStreamName",
              "EncodingName"
            ]
          }
        },
        St: {
          type: "structure",
          members: {
            Name: {
              locationName: "name"
            }
          },
          required: [
            "Name"
          ]
        },
        Sz: {
          type: "structure",
          members: {
            VpcInterfaceName: {
              locationName: "vpcInterfaceName"
            }
          }
        },
        S11: {
          type: "list",
          member: {
            shape: "S12"
          }
        },
        S12: {
          type: "structure",
          members: {
            DataTransferSubscriberFeePercent: {
              locationName: "dataTransferSubscriberFeePercent",
              type: "integer"
            },
            Description: {
              locationName: "description"
            },
            Destination: {
              locationName: "destination"
            },
            Encryption: {
              shape: "Sm",
              locationName: "encryption"
            },
            EntitlementArn: {
              locationName: "entitlementArn"
            },
            ListenerAddress: {
              locationName: "listenerAddress"
            },
            MediaLiveInputArn: {
              locationName: "mediaLiveInputArn"
            },
            MediaStreamOutputConfigurations: {
              locationName: "mediaStreamOutputConfigurations",
              type: "list",
              member: {
                type: "structure",
                members: {
                  DestinationConfigurations: {
                    locationName: "destinationConfigurations",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        DestinationIp: {
                          locationName: "destinationIp"
                        },
                        DestinationPort: {
                          locationName: "destinationPort",
                          type: "integer"
                        },
                        Interface: {
                          shape: "S17",
                          locationName: "interface"
                        },
                        OutboundIp: {
                          locationName: "outboundIp"
                        }
                      },
                      required: [
                        "DestinationIp",
                        "DestinationPort",
                        "Interface",
                        "OutboundIp"
                      ]
                    }
                  },
                  EncodingName: {
                    locationName: "encodingName"
                  },
                  EncodingParameters: {
                    locationName: "encodingParameters",
                    type: "structure",
                    members: {
                      CompressionFactor: {
                        locationName: "compressionFactor",
                        type: "double"
                      },
                      EncoderProfile: {
                        locationName: "encoderProfile"
                      }
                    },
                    required: [
                      "EncoderProfile",
                      "CompressionFactor"
                    ]
                  },
                  MediaStreamName: {
                    locationName: "mediaStreamName"
                  }
                },
                required: [
                  "MediaStreamName",
                  "EncodingName"
                ]
              }
            },
            Name: {
              locationName: "name"
            },
            OutputArn: {
              locationName: "outputArn"
            },
            Port: {
              locationName: "port",
              type: "integer"
            },
            Transport: {
              shape: "S19",
              locationName: "transport"
            },
            VpcInterfaceAttachment: {
              shape: "Sz",
              locationName: "vpcInterfaceAttachment"
            }
          },
          required: [
            "OutputArn",
            "Name"
          ]
        },
        S17: {
          type: "structure",
          members: {
            Name: {
              locationName: "name"
            }
          },
          required: [
            "Name"
          ]
        },
        S19: {
          type: "structure",
          members: {
            CidrAllowList: {
              shape: "Sl",
              locationName: "cidrAllowList"
            },
            MaxBitrate: {
              locationName: "maxBitrate",
              type: "integer"
            },
            MaxLatency: {
              locationName: "maxLatency",
              type: "integer"
            },
            MaxSyncBuffer: {
              locationName: "maxSyncBuffer",
              type: "integer"
            },
            MinLatency: {
              locationName: "minLatency",
              type: "integer"
            },
            Protocol: {
              locationName: "protocol"
            },
            RemoteId: {
              locationName: "remoteId"
            },
            SmoothingLatency: {
              locationName: "smoothingLatency",
              type: "integer"
            },
            StreamId: {
              locationName: "streamId"
            }
          },
          required: [
            "Protocol"
          ]
        },
        S1b: {
          type: "list",
          member: {
            shape: "S1c"
          }
        },
        S1c: {
          type: "structure",
          members: {
            Decryption: {
              shape: "Sm",
              locationName: "decryption"
            },
            Description: {
              locationName: "description"
            },
            EntitlementArn: {
              locationName: "entitlementArn"
            },
            IngestPort: {
              locationName: "ingestPort",
              type: "integer"
            },
            MaxBitrate: {
              locationName: "maxBitrate",
              type: "integer"
            },
            MaxLatency: {
              locationName: "maxLatency",
              type: "integer"
            },
            MaxSyncBuffer: {
              locationName: "maxSyncBuffer",
              type: "integer"
            },
            MediaStreamSourceConfigurations: {
              shape: "S1d",
              locationName: "mediaStreamSourceConfigurations"
            },
            MinLatency: {
              locationName: "minLatency",
              type: "integer"
            },
            Name: {
              locationName: "name"
            },
            Protocol: {
              locationName: "protocol"
            },
            StreamId: {
              locationName: "streamId"
            },
            VpcInterfaceName: {
              locationName: "vpcInterfaceName"
            },
            WhitelistCidr: {
              locationName: "whitelistCidr"
            }
          }
        },
        S1d: {
          type: "list",
          member: {
            type: "structure",
            members: {
              EncodingName: {
                locationName: "encodingName"
              },
              InputConfigurations: {
                locationName: "inputConfigurations",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InputPort: {
                      locationName: "inputPort",
                      type: "integer"
                    },
                    Interface: {
                      shape: "St",
                      locationName: "interface"
                    }
                  },
                  required: [
                    "InputPort",
                    "Interface"
                  ]
                }
              },
              MediaStreamName: {
                locationName: "mediaStreamName"
              }
            },
            required: [
              "MediaStreamName",
              "EncodingName"
            ]
          }
        },
        S1i: {
          type: "list",
          member: {
            shape: "S1j"
          }
        },
        S1j: {
          type: "structure",
          members: {
            DataTransferSubscriberFeePercent: {
              locationName: "dataTransferSubscriberFeePercent",
              type: "integer"
            },
            Decryption: {
              shape: "Sm",
              locationName: "decryption"
            },
            Description: {
              locationName: "description"
            },
            EntitlementArn: {
              locationName: "entitlementArn"
            },
            IngestIp: {
              locationName: "ingestIp"
            },
            IngestPort: {
              locationName: "ingestPort",
              type: "integer"
            },
            MediaStreamSourceConfigurations: {
              locationName: "mediaStreamSourceConfigurations",
              type: "list",
              member: {
                type: "structure",
                members: {
                  EncodingName: {
                    locationName: "encodingName"
                  },
                  InputConfigurations: {
                    locationName: "inputConfigurations",
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        InputIp: {
                          locationName: "inputIp"
                        },
                        InputPort: {
                          locationName: "inputPort",
                          type: "integer"
                        },
                        Interface: {
                          shape: "S17",
                          locationName: "interface"
                        }
                      },
                      required: [
                        "InputPort",
                        "InputIp",
                        "Interface"
                      ]
                    }
                  },
                  MediaStreamName: {
                    locationName: "mediaStreamName"
                  }
                },
                required: [
                  "MediaStreamName",
                  "EncodingName"
                ]
              }
            },
            Name: {
              locationName: "name"
            },
            SourceArn: {
              locationName: "sourceArn"
            },
            Transport: {
              shape: "S19",
              locationName: "transport"
            },
            VpcInterfaceName: {
              locationName: "vpcInterfaceName"
            },
            WhitelistCidr: {
              locationName: "whitelistCidr"
            }
          },
          required: [
            "SourceArn",
            "Name"
          ]
        },
        S1p: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {
                locationName: "name"
              },
              NetworkInterfaceType: {
                locationName: "networkInterfaceType"
              },
              RoleArn: {
                locationName: "roleArn"
              },
              SecurityGroupIds: {
                shape: "Sl",
                locationName: "securityGroupIds"
              },
              SubnetId: {
                locationName: "subnetId"
              }
            },
            required: [
              "SubnetId",
              "SecurityGroupIds",
              "RoleArn",
              "Name"
            ]
          }
        },
        S1t: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {
                locationName: "name"
              },
              NetworkInterfaceIds: {
                shape: "Sl",
                locationName: "networkInterfaceIds"
              },
              NetworkInterfaceType: {
                locationName: "networkInterfaceType"
              },
              RoleArn: {
                locationName: "roleArn"
              },
              SecurityGroupIds: {
                shape: "Sl",
                locationName: "securityGroupIds"
              },
              SubnetId: {
                locationName: "subnetId"
              }
            },
            required: [
              "NetworkInterfaceType",
              "NetworkInterfaceIds",
              "SubnetId",
              "SecurityGroupIds",
              "RoleArn",
              "Name"
            ]
          }
        },
        S1w: {
          type: "list",
          member: {
            type: "structure",
            members: {
              DataTransferSubscriberFeePercent: {
                locationName: "dataTransferSubscriberFeePercent",
                type: "integer"
              },
              Description: {
                locationName: "description"
              },
              Encryption: {
                shape: "Sm",
                locationName: "encryption"
              },
              EntitlementStatus: {
                locationName: "entitlementStatus"
              },
              Name: {
                locationName: "name"
              },
              Subscribers: {
                shape: "Sl",
                locationName: "subscribers"
              }
            },
            required: [
              "Subscribers"
            ]
          }
        },
        S1z: {
          type: "structure",
          members: {
            FailoverMode: {
              locationName: "failoverMode"
            },
            RecoveryWindow: {
              locationName: "recoveryWindow",
              type: "integer"
            },
            SourcePriority: {
              shape: "S21",
              locationName: "sourcePriority"
            },
            State: {
              locationName: "state"
            }
          }
        },
        S21: {
          type: "structure",
          members: {
            PrimarySource: {
              locationName: "primarySource"
            }
          }
        },
        S24: {
          type: "structure",
          members: {
            AvailabilityZone: {
              locationName: "availabilityZone"
            },
            Description: {
              locationName: "description"
            },
            EgressIp: {
              locationName: "egressIp"
            },
            Entitlements: {
              shape: "S25",
              locationName: "entitlements"
            },
            FlowArn: {
              locationName: "flowArn"
            },
            MediaStreams: {
              shape: "Se",
              locationName: "mediaStreams"
            },
            Name: {
              locationName: "name"
            },
            Outputs: {
              shape: "S11",
              locationName: "outputs"
            },
            Source: {
              shape: "S1j",
              locationName: "source"
            },
            SourceFailoverConfig: {
              shape: "S1z",
              locationName: "sourceFailoverConfig"
            },
            Sources: {
              shape: "S1i",
              locationName: "sources"
            },
            Status: {
              locationName: "status"
            },
            VpcInterfaces: {
              shape: "S1t",
              locationName: "vpcInterfaces"
            }
          },
          required: [
            "Status",
            "Entitlements",
            "Outputs",
            "AvailabilityZone",
            "FlowArn",
            "Source",
            "Name"
          ]
        },
        S25: {
          type: "list",
          member: {
            shape: "S26"
          }
        },
        S26: {
          type: "structure",
          members: {
            DataTransferSubscriberFeePercent: {
              locationName: "dataTransferSubscriberFeePercent",
              type: "integer"
            },
            Description: {
              locationName: "description"
            },
            Encryption: {
              shape: "Sm",
              locationName: "encryption"
            },
            EntitlementArn: {
              locationName: "entitlementArn"
            },
            EntitlementStatus: {
              locationName: "entitlementStatus"
            },
            Name: {
              locationName: "name"
            },
            Subscribers: {
              shape: "Sl",
              locationName: "subscribers"
            }
          },
          required: [
            "EntitlementArn",
            "Subscribers",
            "Name"
          ]
        },
        S2f: {
          type: "structure",
          members: {
            CurrencyCode: {
              locationName: "currencyCode"
            },
            Duration: {
              locationName: "duration",
              type: "integer"
            },
            DurationUnits: {
              locationName: "durationUnits"
            },
            OfferingArn: {
              locationName: "offeringArn"
            },
            OfferingDescription: {
              locationName: "offeringDescription"
            },
            PricePerUnit: {
              locationName: "pricePerUnit"
            },
            PriceUnits: {
              locationName: "priceUnits"
            },
            ResourceSpecification: {
              shape: "S2i",
              locationName: "resourceSpecification"
            }
          },
          required: [
            "CurrencyCode",
            "OfferingArn",
            "OfferingDescription",
            "DurationUnits",
            "Duration",
            "PricePerUnit",
            "ResourceSpecification",
            "PriceUnits"
          ]
        },
        S2i: {
          type: "structure",
          members: {
            ReservedBitrate: {
              locationName: "reservedBitrate",
              type: "integer"
            },
            ResourceType: {
              locationName: "resourceType"
            }
          },
          required: [
            "ResourceType"
          ]
        },
        S2m: {
          type: "structure",
          members: {
            CurrencyCode: {
              locationName: "currencyCode"
            },
            Duration: {
              locationName: "duration",
              type: "integer"
            },
            DurationUnits: {
              locationName: "durationUnits"
            },
            End: {
              locationName: "end"
            },
            OfferingArn: {
              locationName: "offeringArn"
            },
            OfferingDescription: {
              locationName: "offeringDescription"
            },
            PricePerUnit: {
              locationName: "pricePerUnit"
            },
            PriceUnits: {
              locationName: "priceUnits"
            },
            ReservationArn: {
              locationName: "reservationArn"
            },
            ReservationName: {
              locationName: "reservationName"
            },
            ReservationState: {
              locationName: "reservationState"
            },
            ResourceSpecification: {
              shape: "S2i",
              locationName: "resourceSpecification"
            },
            Start: {
              locationName: "start"
            }
          },
          required: [
            "CurrencyCode",
            "ReservationState",
            "OfferingArn",
            "ReservationArn",
            "Start",
            "OfferingDescription",
            "ReservationName",
            "End",
            "Duration",
            "DurationUnits",
            "PricePerUnit",
            "ResourceSpecification",
            "PriceUnits"
          ]
        },
        S38: {
          type: "map",
          key: {},
          value: {}
        },
        S3v: {
          type: "structure",
          members: {
            Algorithm: {
              locationName: "algorithm"
            },
            ConstantInitializationVector: {
              locationName: "constantInitializationVector"
            },
            DeviceId: {
              locationName: "deviceId"
            },
            KeyType: {
              locationName: "keyType"
            },
            Region: {
              locationName: "region"
            },
            ResourceId: {
              locationName: "resourceId"
            },
            RoleArn: {
              locationName: "roleArn"
            },
            SecretArn: {
              locationName: "secretArn"
            },
            Url: {
              locationName: "url"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mediaconnect-2018-11-14.paginators.json
var require_mediaconnect_2018_11_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mediaconnect-2018-11-14.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListEntitlements: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Entitlements"
        },
        ListFlows: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Flows"
        },
        ListOfferings: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Offerings"
        },
        ListReservations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Reservations"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mediaconnect-2018-11-14.waiters2.json
var require_mediaconnect_2018_11_14_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/mediaconnect-2018-11-14.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        FlowActive: {
          description: "Wait until a flow is active",
          operation: "DescribeFlow",
          delay: 3,
          maxAttempts: 40,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "Flow.Status",
              expected: "ACTIVE"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "Flow.Status",
              expected: "STARTING"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "Flow.Status",
              expected: "UPDATING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            },
            {
              state: "retry",
              matcher: "status",
              expected: 503
            },
            {
              state: "failure",
              matcher: "path",
              argument: "Flow.Status",
              expected: "ERROR"
            }
          ]
        },
        FlowStandby: {
          description: "Wait until a flow is in standby mode",
          operation: "DescribeFlow",
          delay: 3,
          maxAttempts: 40,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "Flow.Status",
              expected: "STANDBY"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "Flow.Status",
              expected: "STOPPING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            },
            {
              state: "retry",
              matcher: "status",
              expected: 503
            },
            {
              state: "failure",
              matcher: "path",
              argument: "Flow.Status",
              expected: "ERROR"
            }
          ]
        },
        FlowDeleted: {
          description: "Wait until a flow is deleted",
          operation: "DescribeFlow",
          delay: 3,
          maxAttempts: 40,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 404
            },
            {
              state: "retry",
              matcher: "path",
              argument: "Flow.Status",
              expected: "DELETING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            },
            {
              state: "retry",
              matcher: "status",
              expected: 503
            },
            {
              state: "failure",
              matcher: "path",
              argument: "Flow.Status",
              expected: "ERROR"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mediaconnect.js
var require_mediaconnect = __commonJS({
  "node_modules/aws-sdk/clients/mediaconnect.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["mediaconnect"] = {};
    AWS3.MediaConnect = Service.defineService("mediaconnect", ["2018-11-14"]);
    Object.defineProperty(apiLoader.services["mediaconnect"], "2018-11-14", {
      get: function get() {
        var model = require_mediaconnect_2018_11_14_min();
        model.paginators = require_mediaconnect_2018_11_14_paginators().pagination;
        model.waiters = require_mediaconnect_2018_11_14_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.MediaConnect;
  }
});

// node_modules/aws-sdk/apis/fsx-2018-03-01.min.json
var require_fsx_2018_03_01_min = __commonJS({
  "node_modules/aws-sdk/apis/fsx-2018-03-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-03-01",
        endpointPrefix: "fsx",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon FSx",
        serviceId: "FSx",
        signatureVersion: "v4",
        signingName: "fsx",
        targetPrefix: "AWSSimbaAPIService_v20180301",
        uid: "fsx-2018-03-01"
      },
      operations: {
        AssociateFileSystemAliases: {
          input: {
            type: "structure",
            required: [
              "FileSystemId",
              "Aliases"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              FileSystemId: {},
              Aliases: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Aliases: {
                shape: "S7"
              }
            }
          }
        },
        CancelDataRepositoryTask: {
          input: {
            type: "structure",
            required: [
              "TaskId"
            ],
            members: {
              TaskId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Lifecycle: {},
              TaskId: {}
            }
          },
          idempotent: true
        },
        CopyBackup: {
          input: {
            type: "structure",
            required: [
              "SourceBackupId"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              SourceBackupId: {},
              SourceRegion: {},
              KmsKeyId: {},
              CopyTags: {
                type: "boolean"
              },
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Backup: {
                shape: "So"
              }
            }
          },
          idempotent: true
        },
        CreateBackup: {
          input: {
            type: "structure",
            members: {
              FileSystemId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sj"
              },
              VolumeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Backup: {
                shape: "So"
              }
            }
          },
          idempotent: true
        },
        CreateDataRepositoryTask: {
          input: {
            type: "structure",
            required: [
              "Type",
              "FileSystemId",
              "Report"
            ],
            members: {
              Type: {},
              Paths: {
                shape: "S3a"
              },
              FileSystemId: {},
              Report: {
                shape: "S3c"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataRepositoryTask: {
                shape: "S3g"
              }
            }
          },
          idempotent: true
        },
        CreateFileSystem: {
          input: {
            type: "structure",
            required: [
              "FileSystemType",
              "StorageCapacity",
              "SubnetIds"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              FileSystemType: {},
              StorageCapacity: {
                type: "integer"
              },
              StorageType: {},
              SubnetIds: {
                shape: "S15"
              },
              SecurityGroupIds: {
                shape: "S3q"
              },
              Tags: {
                shape: "Sj"
              },
              KmsKeyId: {},
              WindowsConfiguration: {
                shape: "S3s"
              },
              LustreConfiguration: {
                shape: "S3w"
              },
              OntapConfiguration: {
                type: "structure",
                required: [
                  "DeploymentType",
                  "ThroughputCapacity"
                ],
                members: {
                  AutomaticBackupRetentionDays: {
                    type: "integer"
                  },
                  DailyAutomaticBackupStartTime: {},
                  DeploymentType: {},
                  EndpointIpAddressRange: {},
                  FsxAdminPassword: {
                    shape: "S3y"
                  },
                  DiskIopsConfiguration: {
                    shape: "S2y"
                  },
                  PreferredSubnetId: {},
                  RouteTableIds: {
                    shape: "S31"
                  },
                  ThroughputCapacity: {
                    type: "integer"
                  },
                  WeeklyMaintenanceStartTime: {}
                }
              },
              FileSystemTypeVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FileSystem: {
                shape: "Sx"
              }
            }
          }
        },
        CreateFileSystemFromBackup: {
          input: {
            type: "structure",
            required: [
              "BackupId",
              "SubnetIds"
            ],
            members: {
              BackupId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              SubnetIds: {
                shape: "S15"
              },
              SecurityGroupIds: {
                shape: "S3q"
              },
              Tags: {
                shape: "Sj"
              },
              WindowsConfiguration: {
                shape: "S3s"
              },
              LustreConfiguration: {
                shape: "S3w"
              },
              StorageType: {},
              KmsKeyId: {},
              FileSystemTypeVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FileSystem: {
                shape: "Sx"
              }
            }
          }
        },
        CreateStorageVirtualMachine: {
          input: {
            type: "structure",
            required: [
              "FileSystemId",
              "Name"
            ],
            members: {
              ActiveDirectoryConfiguration: {
                type: "structure",
                required: [
                  "NetBiosName"
                ],
                members: {
                  NetBiosName: {},
                  SelfManagedActiveDirectoryConfiguration: {
                    shape: "S3t"
                  }
                }
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              FileSystemId: {},
              Name: {},
              SvmAdminPassword: {
                shape: "S3y"
              },
              Tags: {
                shape: "Sj"
              },
              RootVolumeSecurityStyle: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StorageVirtualMachine: {
                shape: "S48"
              }
            }
          }
        },
        CreateVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeType",
              "Name"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeType: {},
              Name: {},
              OntapConfiguration: {
                shape: "S4f"
              },
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Volume: {
                shape: "S2b"
              }
            }
          }
        },
        CreateVolumeFromBackup: {
          input: {
            type: "structure",
            required: [
              "BackupId",
              "Name"
            ],
            members: {
              BackupId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Name: {},
              OntapConfiguration: {
                shape: "S4f"
              },
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Volume: {
                shape: "S2b"
              }
            }
          }
        },
        DeleteBackup: {
          input: {
            type: "structure",
            required: [
              "BackupId"
            ],
            members: {
              BackupId: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupId: {},
              Lifecycle: {}
            }
          },
          idempotent: true
        },
        DeleteFileSystem: {
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              FileSystemId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              WindowsConfiguration: {
                type: "structure",
                members: {
                  SkipFinalBackup: {
                    type: "boolean"
                  },
                  FinalBackupTags: {
                    shape: "Sj"
                  }
                }
              },
              LustreConfiguration: {
                type: "structure",
                members: {
                  SkipFinalBackup: {
                    type: "boolean"
                  },
                  FinalBackupTags: {
                    shape: "Sj"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileSystemId: {},
              Lifecycle: {},
              WindowsResponse: {
                type: "structure",
                members: {
                  FinalBackupId: {},
                  FinalBackupTags: {
                    shape: "Sj"
                  }
                }
              },
              LustreResponse: {
                type: "structure",
                members: {
                  FinalBackupId: {},
                  FinalBackupTags: {
                    shape: "Sj"
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DeleteStorageVirtualMachine: {
          input: {
            type: "structure",
            required: [
              "StorageVirtualMachineId"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              StorageVirtualMachineId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StorageVirtualMachineId: {},
              Lifecycle: {}
            }
          }
        },
        DeleteVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeId: {},
              OntapConfiguration: {
                type: "structure",
                members: {
                  SkipFinalBackup: {
                    type: "boolean"
                  },
                  FinalBackupTags: {
                    shape: "Sj"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              VolumeId: {},
              Lifecycle: {},
              OntapResponse: {
                type: "structure",
                members: {
                  FinalBackupId: {},
                  FinalBackupTags: {
                    shape: "Sj"
                  }
                }
              }
            }
          }
        },
        DescribeBackups: {
          input: {
            type: "structure",
            members: {
              BackupIds: {
                type: "list",
                member: {}
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Backups: {
                type: "list",
                member: {
                  shape: "So"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeDataRepositoryTasks: {
          input: {
            type: "structure",
            members: {
              TaskIds: {
                type: "list",
                member: {}
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DataRepositoryTasks: {
                type: "list",
                member: {
                  shape: "S3g"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeFileSystemAliases: {
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              FileSystemId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Aliases: {
                shape: "S7"
              },
              NextToken: {}
            }
          }
        },
        DescribeFileSystems: {
          input: {
            type: "structure",
            members: {
              FileSystemIds: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FileSystems: {
                type: "list",
                member: {
                  shape: "Sx"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeStorageVirtualMachines: {
          input: {
            type: "structure",
            members: {
              StorageVirtualMachineIds: {
                type: "list",
                member: {}
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StorageVirtualMachines: {
                type: "list",
                member: {
                  shape: "S48"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeVolumes: {
          input: {
            type: "structure",
            members: {
              VolumeIds: {
                type: "list",
                member: {}
              },
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Volumes: {
                type: "list",
                member: {
                  shape: "S2b"
                }
              },
              NextToken: {}
            }
          }
        },
        DisassociateFileSystemAliases: {
          input: {
            type: "structure",
            required: [
              "FileSystemId",
              "Aliases"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              FileSystemId: {},
              Aliases: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Aliases: {
                shape: "S7"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sj"
              },
              NextToken: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateFileSystem: {
          input: {
            type: "structure",
            required: [
              "FileSystemId"
            ],
            members: {
              FileSystemId: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              StorageCapacity: {
                type: "integer"
              },
              WindowsConfiguration: {
                type: "structure",
                members: {
                  WeeklyMaintenanceStartTime: {},
                  DailyAutomaticBackupStartTime: {},
                  AutomaticBackupRetentionDays: {
                    type: "integer"
                  },
                  ThroughputCapacity: {
                    type: "integer"
                  },
                  SelfManagedActiveDirectoryConfiguration: {
                    shape: "S6g"
                  },
                  AuditLogConfiguration: {
                    shape: "S3v"
                  }
                }
              },
              LustreConfiguration: {
                type: "structure",
                members: {
                  WeeklyMaintenanceStartTime: {},
                  DailyAutomaticBackupStartTime: {},
                  AutomaticBackupRetentionDays: {
                    type: "integer"
                  },
                  AutoImportPolicy: {},
                  DataCompressionType: {}
                }
              },
              OntapConfiguration: {
                type: "structure",
                members: {
                  AutomaticBackupRetentionDays: {
                    type: "integer"
                  },
                  DailyAutomaticBackupStartTime: {},
                  FsxAdminPassword: {
                    shape: "S3y"
                  },
                  WeeklyMaintenanceStartTime: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FileSystem: {
                shape: "Sx"
              }
            }
          }
        },
        UpdateStorageVirtualMachine: {
          input: {
            type: "structure",
            required: [
              "StorageVirtualMachineId"
            ],
            members: {
              ActiveDirectoryConfiguration: {
                type: "structure",
                members: {
                  SelfManagedActiveDirectoryConfiguration: {
                    shape: "S6g"
                  }
                }
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              StorageVirtualMachineId: {},
              SvmAdminPassword: {
                shape: "S3y"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StorageVirtualMachine: {
                shape: "S48"
              }
            }
          }
        },
        UpdateVolume: {
          input: {
            type: "structure",
            required: [
              "VolumeId"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              VolumeId: {},
              OntapConfiguration: {
                type: "structure",
                members: {
                  JunctionPath: {},
                  SecurityStyle: {},
                  SizeInMegabytes: {
                    type: "integer"
                  },
                  StorageEfficiencyEnabled: {
                    type: "boolean"
                  },
                  TieringPolicy: {
                    shape: "S2k"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Volume: {
                shape: "S2b"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {}
        },
        S7: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Lifecycle: {}
            }
          }
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        So: {
          type: "structure",
          required: [
            "BackupId",
            "Lifecycle",
            "Type",
            "CreationTime",
            "FileSystem"
          ],
          members: {
            BackupId: {},
            Lifecycle: {},
            FailureDetails: {
              type: "structure",
              members: {
                Message: {}
              }
            },
            Type: {},
            ProgressPercent: {
              type: "integer"
            },
            CreationTime: {
              type: "timestamp"
            },
            KmsKeyId: {},
            ResourceARN: {},
            Tags: {
              shape: "Sj"
            },
            FileSystem: {
              shape: "Sx"
            },
            DirectoryInformation: {
              type: "structure",
              members: {
                DomainName: {},
                ActiveDirectoryId: {},
                ResourceARN: {}
              }
            },
            OwnerId: {},
            SourceBackupId: {},
            SourceBackupRegion: {},
            ResourceType: {},
            Volume: {
              shape: "S2b"
            }
          }
        },
        Sx: {
          type: "structure",
          members: {
            OwnerId: {},
            CreationTime: {
              type: "timestamp"
            },
            FileSystemId: {},
            FileSystemType: {},
            Lifecycle: {},
            FailureDetails: {
              type: "structure",
              members: {
                Message: {}
              }
            },
            StorageCapacity: {
              type: "integer"
            },
            StorageType: {},
            VpcId: {},
            SubnetIds: {
              shape: "S15"
            },
            NetworkInterfaceIds: {
              type: "list",
              member: {}
            },
            DNSName: {},
            KmsKeyId: {},
            ResourceARN: {},
            Tags: {
              shape: "Sj"
            },
            WindowsConfiguration: {
              type: "structure",
              members: {
                ActiveDirectoryId: {},
                SelfManagedActiveDirectoryConfiguration: {
                  shape: "S1c"
                },
                DeploymentType: {},
                RemoteAdministrationEndpoint: {},
                PreferredSubnetId: {},
                PreferredFileServerIp: {},
                ThroughputCapacity: {
                  type: "integer"
                },
                MaintenanceOperationsInProgress: {
                  type: "list",
                  member: {}
                },
                WeeklyMaintenanceStartTime: {},
                DailyAutomaticBackupStartTime: {},
                AutomaticBackupRetentionDays: {
                  type: "integer"
                },
                CopyTagsToBackups: {
                  type: "boolean"
                },
                Aliases: {
                  shape: "S7"
                },
                AuditLogConfiguration: {
                  type: "structure",
                  required: [
                    "FileAccessAuditLogLevel",
                    "FileShareAccessAuditLogLevel"
                  ],
                  members: {
                    FileAccessAuditLogLevel: {},
                    FileShareAccessAuditLogLevel: {},
                    AuditLogDestination: {}
                  }
                }
              }
            },
            LustreConfiguration: {
              type: "structure",
              members: {
                WeeklyMaintenanceStartTime: {},
                DataRepositoryConfiguration: {
                  type: "structure",
                  members: {
                    Lifecycle: {},
                    ImportPath: {},
                    ExportPath: {},
                    ImportedFileChunkSize: {
                      type: "integer"
                    },
                    AutoImportPolicy: {},
                    FailureDetails: {
                      type: "structure",
                      members: {
                        Message: {}
                      }
                    }
                  }
                },
                DeploymentType: {},
                PerUnitStorageThroughput: {
                  type: "integer"
                },
                MountName: {},
                DailyAutomaticBackupStartTime: {},
                AutomaticBackupRetentionDays: {
                  type: "integer"
                },
                CopyTagsToBackups: {
                  type: "boolean"
                },
                DriveCacheType: {},
                DataCompressionType: {}
              }
            },
            AdministrativeActions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  AdministrativeActionType: {},
                  ProgressPercent: {
                    type: "integer"
                  },
                  RequestTime: {
                    type: "timestamp"
                  },
                  Status: {},
                  TargetFileSystemValues: {
                    shape: "Sx"
                  },
                  FailureDetails: {
                    type: "structure",
                    members: {
                      Message: {}
                    }
                  },
                  TargetVolumeValues: {
                    shape: "S2b"
                  }
                }
              }
            },
            OntapConfiguration: {
              type: "structure",
              members: {
                AutomaticBackupRetentionDays: {
                  type: "integer"
                },
                DailyAutomaticBackupStartTime: {},
                DeploymentType: {},
                EndpointIpAddressRange: {},
                Endpoints: {
                  type: "structure",
                  members: {
                    Intercluster: {
                      shape: "S2w"
                    },
                    Management: {
                      shape: "S2w"
                    }
                  }
                },
                DiskIopsConfiguration: {
                  shape: "S2y"
                },
                PreferredSubnetId: {},
                RouteTableIds: {
                  shape: "S31"
                },
                ThroughputCapacity: {
                  type: "integer"
                },
                WeeklyMaintenanceStartTime: {}
              }
            },
            FileSystemTypeVersion: {}
          }
        },
        S15: {
          type: "list",
          member: {}
        },
        S1c: {
          type: "structure",
          members: {
            DomainName: {},
            OrganizationalUnitDistinguishedName: {},
            FileSystemAdministratorsGroup: {},
            UserName: {},
            DnsIps: {
              shape: "S1h"
            }
          }
        },
        S1h: {
          type: "list",
          member: {}
        },
        S2b: {
          type: "structure",
          members: {
            CreationTime: {
              type: "timestamp"
            },
            FileSystemId: {},
            Lifecycle: {},
            Name: {},
            OntapConfiguration: {
              type: "structure",
              members: {
                FlexCacheEndpointType: {},
                JunctionPath: {},
                SecurityStyle: {},
                SizeInMegabytes: {
                  type: "integer"
                },
                StorageEfficiencyEnabled: {
                  type: "boolean"
                },
                StorageVirtualMachineId: {},
                StorageVirtualMachineRoot: {
                  type: "boolean"
                },
                TieringPolicy: {
                  shape: "S2k"
                },
                UUID: {},
                OntapVolumeType: {}
              }
            },
            ResourceARN: {},
            Tags: {
              shape: "Sj"
            },
            VolumeId: {},
            VolumeType: {},
            LifecycleTransitionReason: {
              shape: "S2r"
            }
          }
        },
        S2k: {
          type: "structure",
          members: {
            CoolingPeriod: {
              type: "integer"
            },
            Name: {}
          }
        },
        S2r: {
          type: "structure",
          members: {
            Message: {}
          }
        },
        S2w: {
          type: "structure",
          members: {
            DNSName: {},
            IpAddresses: {
              shape: "S2x"
            }
          }
        },
        S2x: {
          type: "list",
          member: {}
        },
        S2y: {
          type: "structure",
          members: {
            Mode: {},
            Iops: {
              type: "long"
            }
          }
        },
        S31: {
          type: "list",
          member: {}
        },
        S3a: {
          type: "list",
          member: {}
        },
        S3c: {
          type: "structure",
          required: [
            "Enabled"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            Path: {},
            Format: {},
            Scope: {}
          }
        },
        S3g: {
          type: "structure",
          required: [
            "TaskId",
            "Lifecycle",
            "Type",
            "CreationTime",
            "FileSystemId"
          ],
          members: {
            TaskId: {},
            Lifecycle: {},
            Type: {},
            CreationTime: {
              type: "timestamp"
            },
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            ResourceARN: {},
            Tags: {
              shape: "Sj"
            },
            FileSystemId: {},
            Paths: {
              shape: "S3a"
            },
            FailureDetails: {
              type: "structure",
              members: {
                Message: {}
              }
            },
            Status: {
              type: "structure",
              members: {
                TotalCount: {
                  type: "long"
                },
                SucceededCount: {
                  type: "long"
                },
                FailedCount: {
                  type: "long"
                },
                LastUpdatedTime: {
                  type: "timestamp"
                }
              }
            },
            Report: {
              shape: "S3c"
            }
          }
        },
        S3q: {
          type: "list",
          member: {}
        },
        S3s: {
          type: "structure",
          required: [
            "ThroughputCapacity"
          ],
          members: {
            ActiveDirectoryId: {},
            SelfManagedActiveDirectoryConfiguration: {
              shape: "S3t"
            },
            DeploymentType: {},
            PreferredSubnetId: {},
            ThroughputCapacity: {
              type: "integer"
            },
            WeeklyMaintenanceStartTime: {},
            DailyAutomaticBackupStartTime: {},
            AutomaticBackupRetentionDays: {
              type: "integer"
            },
            CopyTagsToBackups: {
              type: "boolean"
            },
            Aliases: {
              shape: "S4"
            },
            AuditLogConfiguration: {
              shape: "S3v"
            }
          }
        },
        S3t: {
          type: "structure",
          required: [
            "DomainName",
            "UserName",
            "Password",
            "DnsIps"
          ],
          members: {
            DomainName: {},
            OrganizationalUnitDistinguishedName: {},
            FileSystemAdministratorsGroup: {},
            UserName: {},
            Password: {
              shape: "S3u"
            },
            DnsIps: {
              shape: "S1h"
            }
          }
        },
        S3u: {
          type: "string",
          sensitive: true
        },
        S3v: {
          type: "structure",
          required: [
            "FileAccessAuditLogLevel",
            "FileShareAccessAuditLogLevel"
          ],
          members: {
            FileAccessAuditLogLevel: {},
            FileShareAccessAuditLogLevel: {},
            AuditLogDestination: {}
          }
        },
        S3w: {
          type: "structure",
          members: {
            WeeklyMaintenanceStartTime: {},
            ImportPath: {},
            ExportPath: {},
            ImportedFileChunkSize: {
              type: "integer"
            },
            DeploymentType: {},
            AutoImportPolicy: {},
            PerUnitStorageThroughput: {
              type: "integer"
            },
            DailyAutomaticBackupStartTime: {},
            AutomaticBackupRetentionDays: {
              type: "integer"
            },
            CopyTagsToBackups: {
              type: "boolean"
            },
            DriveCacheType: {},
            DataCompressionType: {}
          }
        },
        S3y: {
          type: "string",
          sensitive: true
        },
        S48: {
          type: "structure",
          members: {
            ActiveDirectoryConfiguration: {
              type: "structure",
              members: {
                NetBiosName: {},
                SelfManagedActiveDirectoryConfiguration: {
                  shape: "S1c"
                }
              }
            },
            CreationTime: {
              type: "timestamp"
            },
            Endpoints: {
              type: "structure",
              members: {
                Iscsi: {
                  shape: "S4b"
                },
                Management: {
                  shape: "S4b"
                },
                Nfs: {
                  shape: "S4b"
                },
                Smb: {
                  shape: "S4b"
                }
              }
            },
            FileSystemId: {},
            Lifecycle: {},
            Name: {},
            ResourceARN: {},
            StorageVirtualMachineId: {},
            Subtype: {},
            UUID: {},
            Tags: {
              shape: "Sj"
            },
            LifecycleTransitionReason: {
              shape: "S2r"
            },
            RootVolumeSecurityStyle: {}
          }
        },
        S4b: {
          type: "structure",
          members: {
            DNSName: {},
            IpAddresses: {
              shape: "S2x"
            }
          }
        },
        S4f: {
          type: "structure",
          required: [
            "JunctionPath",
            "SizeInMegabytes",
            "StorageEfficiencyEnabled",
            "StorageVirtualMachineId"
          ],
          members: {
            JunctionPath: {},
            SecurityStyle: {},
            SizeInMegabytes: {
              type: "integer"
            },
            StorageEfficiencyEnabled: {
              type: "boolean"
            },
            StorageVirtualMachineId: {},
            TieringPolicy: {
              shape: "S2k"
            }
          }
        },
        S6g: {
          type: "structure",
          members: {
            UserName: {},
            Password: {
              shape: "S3u"
            },
            DnsIps: {
              shape: "S1h"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/fsx-2018-03-01.paginators.json
var require_fsx_2018_03_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/fsx-2018-03-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeBackups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeDataRepositoryTasks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeFileSystemAliases: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeFileSystems: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeStorageVirtualMachines: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeVolumes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/fsx.js
var require_fsx = __commonJS({
  "node_modules/aws-sdk/clients/fsx.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["fsx"] = {};
    AWS3.FSx = Service.defineService("fsx", ["2018-03-01"]);
    Object.defineProperty(apiLoader.services["fsx"], "2018-03-01", {
      get: function get() {
        var model = require_fsx_2018_03_01_min();
        model.paginators = require_fsx_2018_03_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.FSx;
  }
});

// node_modules/aws-sdk/apis/securityhub-2018-10-26.min.json
var require_securityhub_2018_10_26_min = __commonJS({
  "node_modules/aws-sdk/apis/securityhub-2018-10-26.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-10-26",
        endpointPrefix: "securityhub",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS SecurityHub",
        serviceId: "SecurityHub",
        signatureVersion: "v4",
        signingName: "securityhub",
        uid: "securityhub-2018-10-26"
      },
      operations: {
        AcceptAdministratorInvitation: {
          http: {
            requestUri: "/administrator"
          },
          input: {
            type: "structure",
            required: [
              "AdministratorId",
              "InvitationId"
            ],
            members: {
              AdministratorId: {},
              InvitationId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AcceptInvitation: {
          http: {
            requestUri: "/master"
          },
          input: {
            type: "structure",
            required: [
              "MasterId",
              "InvitationId"
            ],
            members: {
              MasterId: {},
              InvitationId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "This API has been deprecated, use AcceptAdministratorInvitation API instead."
        },
        BatchDisableStandards: {
          http: {
            requestUri: "/standards/deregister"
          },
          input: {
            type: "structure",
            required: [
              "StandardsSubscriptionArns"
            ],
            members: {
              StandardsSubscriptionArns: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StandardsSubscriptions: {
                shape: "S9"
              }
            }
          }
        },
        BatchEnableStandards: {
          http: {
            requestUri: "/standards/register"
          },
          input: {
            type: "structure",
            required: [
              "StandardsSubscriptionRequests"
            ],
            members: {
              StandardsSubscriptionRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "StandardsArn"
                  ],
                  members: {
                    StandardsArn: {},
                    StandardsInput: {
                      shape: "Sb"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StandardsSubscriptions: {
                shape: "S9"
              }
            }
          }
        },
        BatchImportFindings: {
          http: {
            requestUri: "/findings/import"
          },
          input: {
            type: "structure",
            required: [
              "Findings"
            ],
            members: {
              Findings: {
                type: "list",
                member: {
                  shape: "Sj"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "FailedCount",
              "SuccessCount"
            ],
            members: {
              FailedCount: {
                type: "integer"
              },
              SuccessCount: {
                type: "integer"
              },
              FailedFindings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id",
                    "ErrorCode",
                    "ErrorMessage"
                  ],
                  members: {
                    Id: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchUpdateFindings: {
          http: {
            method: "PATCH",
            requestUri: "/findings/batchupdate"
          },
          input: {
            type: "structure",
            required: [
              "FindingIdentifiers"
            ],
            members: {
              FindingIdentifiers: {
                shape: "Sev"
              },
              Note: {
                shape: "Sex"
              },
              Severity: {
                type: "structure",
                members: {
                  Normalized: {
                    type: "integer"
                  },
                  Product: {
                    type: "double"
                  },
                  Label: {}
                }
              },
              VerificationState: {},
              Confidence: {
                type: "integer"
              },
              Criticality: {
                type: "integer"
              },
              Types: {
                shape: "Sk"
              },
              UserDefinedFields: {
                shape: "Sr"
              },
              Workflow: {
                type: "structure",
                members: {
                  Status: {}
                }
              },
              RelatedFindings: {
                shape: "Sdv"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ProcessedFindings",
              "UnprocessedFindings"
            ],
            members: {
              ProcessedFindings: {
                shape: "Sev"
              },
              UnprocessedFindings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "FindingIdentifier",
                    "ErrorCode",
                    "ErrorMessage"
                  ],
                  members: {
                    FindingIdentifier: {
                      shape: "Sew"
                    },
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        CreateActionTarget: {
          http: {
            requestUri: "/actionTargets"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Description",
              "Id"
            ],
            members: {
              Name: {},
              Description: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ActionTargetArn"
            ],
            members: {
              ActionTargetArn: {}
            }
          }
        },
        CreateInsight: {
          http: {
            requestUri: "/insights"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Filters",
              "GroupByAttribute"
            ],
            members: {
              Name: {},
              Filters: {
                shape: "Sf6"
              },
              GroupByAttribute: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "InsightArn"
            ],
            members: {
              InsightArn: {}
            }
          }
        },
        CreateMembers: {
          http: {
            requestUri: "/members"
          },
          input: {
            type: "structure",
            required: [
              "AccountDetails"
            ],
            members: {
              AccountDetails: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AccountId"
                  ],
                  members: {
                    AccountId: {},
                    Email: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UnprocessedAccounts: {
                shape: "Sft"
              }
            }
          }
        },
        DeclineInvitations: {
          http: {
            requestUri: "/invitations/decline"
          },
          input: {
            type: "structure",
            required: [
              "AccountIds"
            ],
            members: {
              AccountIds: {
                shape: "Sfw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UnprocessedAccounts: {
                shape: "Sft"
              }
            }
          }
        },
        DeleteActionTarget: {
          http: {
            method: "DELETE",
            requestUri: "/actionTargets/{ActionTargetArn+}"
          },
          input: {
            type: "structure",
            required: [
              "ActionTargetArn"
            ],
            members: {
              ActionTargetArn: {
                location: "uri",
                locationName: "ActionTargetArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ActionTargetArn"
            ],
            members: {
              ActionTargetArn: {}
            }
          }
        },
        DeleteInsight: {
          http: {
            method: "DELETE",
            requestUri: "/insights/{InsightArn+}"
          },
          input: {
            type: "structure",
            required: [
              "InsightArn"
            ],
            members: {
              InsightArn: {
                location: "uri",
                locationName: "InsightArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "InsightArn"
            ],
            members: {
              InsightArn: {}
            }
          }
        },
        DeleteInvitations: {
          http: {
            requestUri: "/invitations/delete"
          },
          input: {
            type: "structure",
            required: [
              "AccountIds"
            ],
            members: {
              AccountIds: {
                shape: "Sfw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UnprocessedAccounts: {
                shape: "Sft"
              }
            }
          }
        },
        DeleteMembers: {
          http: {
            requestUri: "/members/delete"
          },
          input: {
            type: "structure",
            required: [
              "AccountIds"
            ],
            members: {
              AccountIds: {
                shape: "Sfw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UnprocessedAccounts: {
                shape: "Sft"
              }
            }
          }
        },
        DescribeActionTargets: {
          http: {
            requestUri: "/actionTargets/get"
          },
          input: {
            type: "structure",
            members: {
              ActionTargetArns: {
                shape: "Sg7"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ActionTargets"
            ],
            members: {
              ActionTargets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ActionTargetArn",
                    "Name",
                    "Description"
                  ],
                  members: {
                    ActionTargetArn: {},
                    Name: {},
                    Description: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeHub: {
          http: {
            method: "GET",
            requestUri: "/accounts"
          },
          input: {
            type: "structure",
            members: {
              HubArn: {
                location: "querystring",
                locationName: "HubArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HubArn: {},
              SubscribedAt: {},
              AutoEnableControls: {
                type: "boolean"
              }
            }
          }
        },
        DescribeOrganizationConfiguration: {
          http: {
            method: "GET",
            requestUri: "/organization/configuration"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              AutoEnable: {
                type: "boolean"
              },
              MemberAccountLimitReached: {
                type: "boolean"
              }
            }
          }
        },
        DescribeProducts: {
          http: {
            method: "GET",
            requestUri: "/products"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              ProductArn: {
                location: "querystring",
                locationName: "ProductArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Products"
            ],
            members: {
              Products: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ProductArn"
                  ],
                  members: {
                    ProductArn: {},
                    ProductName: {},
                    CompanyName: {},
                    Description: {},
                    Categories: {
                      type: "list",
                      member: {}
                    },
                    IntegrationTypes: {
                      type: "list",
                      member: {}
                    },
                    MarketplaceUrl: {},
                    ActivationUrl: {},
                    ProductSubscriptionResourcePolicy: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeStandards: {
          http: {
            method: "GET",
            requestUri: "/standards"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Standards: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StandardsArn: {},
                    Name: {},
                    Description: {},
                    EnabledByDefault: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeStandardsControls: {
          http: {
            method: "GET",
            requestUri: "/standards/controls/{StandardsSubscriptionArn+}"
          },
          input: {
            type: "structure",
            required: [
              "StandardsSubscriptionArn"
            ],
            members: {
              StandardsSubscriptionArn: {
                location: "uri",
                locationName: "StandardsSubscriptionArn"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Controls: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StandardsControlArn: {},
                    ControlStatus: {},
                    DisabledReason: {},
                    ControlStatusUpdatedAt: {
                      shape: "Sgx"
                    },
                    ControlId: {},
                    Title: {},
                    Description: {},
                    RemediationUrl: {},
                    SeverityRating: {},
                    RelatedRequirements: {
                      shape: "Sdn"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DisableImportFindingsForProduct: {
          http: {
            method: "DELETE",
            requestUri: "/productSubscriptions/{ProductSubscriptionArn+}"
          },
          input: {
            type: "structure",
            required: [
              "ProductSubscriptionArn"
            ],
            members: {
              ProductSubscriptionArn: {
                location: "uri",
                locationName: "ProductSubscriptionArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableOrganizationAdminAccount: {
          http: {
            requestUri: "/organization/admin/disable"
          },
          input: {
            type: "structure",
            required: [
              "AdminAccountId"
            ],
            members: {
              AdminAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableSecurityHub: {
          http: {
            method: "DELETE",
            requestUri: "/accounts"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateFromAdministratorAccount: {
          http: {
            requestUri: "/administrator/disassociate"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateFromMasterAccount: {
          http: {
            requestUri: "/master/disassociate"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          },
          deprecated: true,
          deprecatedMessage: "This API has been deprecated, use DisassociateFromAdministratorAccount API instead."
        },
        DisassociateMembers: {
          http: {
            requestUri: "/members/disassociate"
          },
          input: {
            type: "structure",
            required: [
              "AccountIds"
            ],
            members: {
              AccountIds: {
                shape: "Sfw"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableImportFindingsForProduct: {
          http: {
            requestUri: "/productSubscriptions"
          },
          input: {
            type: "structure",
            required: [
              "ProductArn"
            ],
            members: {
              ProductArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProductSubscriptionArn: {}
            }
          }
        },
        EnableOrganizationAdminAccount: {
          http: {
            requestUri: "/organization/admin/enable"
          },
          input: {
            type: "structure",
            required: [
              "AdminAccountId"
            ],
            members: {
              AdminAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableSecurityHub: {
          http: {
            requestUri: "/accounts"
          },
          input: {
            type: "structure",
            members: {
              Tags: {
                shape: "Shg"
              },
              EnableDefaultStandards: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAdministratorAccount: {
          http: {
            method: "GET",
            requestUri: "/administrator"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Administrator: {
                shape: "Shm"
              }
            }
          }
        },
        GetEnabledStandards: {
          http: {
            requestUri: "/standards/get"
          },
          input: {
            type: "structure",
            members: {
              StandardsSubscriptionArns: {
                shape: "S7"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StandardsSubscriptions: {
                shape: "S9"
              },
              NextToken: {}
            }
          }
        },
        GetFindings: {
          http: {
            requestUri: "/findings"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "Sf6"
              },
              SortCriteria: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Field: {},
                    SortOrder: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Findings"
            ],
            members: {
              Findings: {
                type: "list",
                member: {
                  shape: "Sj"
                }
              },
              NextToken: {}
            }
          }
        },
        GetInsightResults: {
          http: {
            method: "GET",
            requestUri: "/insights/results/{InsightArn+}"
          },
          input: {
            type: "structure",
            required: [
              "InsightArn"
            ],
            members: {
              InsightArn: {
                location: "uri",
                locationName: "InsightArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "InsightResults"
            ],
            members: {
              InsightResults: {
                type: "structure",
                required: [
                  "InsightArn",
                  "GroupByAttribute",
                  "ResultValues"
                ],
                members: {
                  InsightArn: {},
                  GroupByAttribute: {},
                  ResultValues: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "GroupByAttributeValue",
                        "Count"
                      ],
                      members: {
                        GroupByAttributeValue: {},
                        Count: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetInsights: {
          http: {
            requestUri: "/insights/get"
          },
          input: {
            type: "structure",
            members: {
              InsightArns: {
                shape: "Sg7"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Insights"
            ],
            members: {
              Insights: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "InsightArn",
                    "Name",
                    "Filters",
                    "GroupByAttribute"
                  ],
                  members: {
                    InsightArn: {},
                    Name: {},
                    Filters: {
                      shape: "Sf6"
                    },
                    GroupByAttribute: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetInvitationsCount: {
          http: {
            method: "GET",
            requestUri: "/invitations/count"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              InvitationsCount: {
                type: "integer"
              }
            }
          }
        },
        GetMasterAccount: {
          http: {
            method: "GET",
            requestUri: "/master"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Master: {
                shape: "Shm"
              }
            }
          },
          deprecated: true,
          deprecatedMessage: "This API has been deprecated, use GetAdministratorAccount API instead."
        },
        GetMembers: {
          http: {
            requestUri: "/members/get"
          },
          input: {
            type: "structure",
            required: [
              "AccountIds"
            ],
            members: {
              AccountIds: {
                shape: "Sfw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Members: {
                shape: "Sia"
              },
              UnprocessedAccounts: {
                shape: "Sft"
              }
            }
          }
        },
        InviteMembers: {
          http: {
            requestUri: "/members/invite"
          },
          input: {
            type: "structure",
            required: [
              "AccountIds"
            ],
            members: {
              AccountIds: {
                shape: "Sfw"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UnprocessedAccounts: {
                shape: "Sft"
              }
            }
          }
        },
        ListEnabledProductsForImport: {
          http: {
            method: "GET",
            requestUri: "/productSubscriptions"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProductSubscriptions: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListInvitations: {
          http: {
            method: "GET",
            requestUri: "/invitations"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invitations: {
                type: "list",
                member: {
                  shape: "Shm"
                }
              },
              NextToken: {}
            }
          }
        },
        ListMembers: {
          http: {
            method: "GET",
            requestUri: "/members"
          },
          input: {
            type: "structure",
            members: {
              OnlyAssociated: {
                location: "querystring",
                locationName: "OnlyAssociated",
                type: "boolean"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Members: {
                shape: "Sia"
              },
              NextToken: {}
            }
          }
        },
        ListOrganizationAdminAccounts: {
          http: {
            method: "GET",
            requestUri: "/organization/admin"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AdminAccounts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountId: {},
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Shg"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "Shg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateActionTarget: {
          http: {
            method: "PATCH",
            requestUri: "/actionTargets/{ActionTargetArn+}"
          },
          input: {
            type: "structure",
            required: [
              "ActionTargetArn"
            ],
            members: {
              ActionTargetArn: {
                location: "uri",
                locationName: "ActionTargetArn"
              },
              Name: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateFindings: {
          http: {
            method: "PATCH",
            requestUri: "/findings"
          },
          input: {
            type: "structure",
            required: [
              "Filters"
            ],
            members: {
              Filters: {
                shape: "Sf6"
              },
              Note: {
                shape: "Sex"
              },
              RecordState: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateInsight: {
          http: {
            method: "PATCH",
            requestUri: "/insights/{InsightArn+}"
          },
          input: {
            type: "structure",
            required: [
              "InsightArn"
            ],
            members: {
              InsightArn: {
                location: "uri",
                locationName: "InsightArn"
              },
              Name: {},
              Filters: {
                shape: "Sf6"
              },
              GroupByAttribute: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateOrganizationConfiguration: {
          http: {
            requestUri: "/organization/configuration"
          },
          input: {
            type: "structure",
            required: [
              "AutoEnable"
            ],
            members: {
              AutoEnable: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateSecurityHubConfiguration: {
          http: {
            method: "PATCH",
            requestUri: "/accounts"
          },
          input: {
            type: "structure",
            members: {
              AutoEnableControls: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateStandardsControl: {
          http: {
            method: "PATCH",
            requestUri: "/standards/control/{StandardsControlArn+}"
          },
          input: {
            type: "structure",
            required: [
              "StandardsControlArn"
            ],
            members: {
              StandardsControlArn: {
                location: "uri",
                locationName: "StandardsControlArn"
              },
              ControlStatus: {},
              DisabledReason: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S7: {
          type: "list",
          member: {}
        },
        S9: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "StandardsSubscriptionArn",
              "StandardsArn",
              "StandardsInput",
              "StandardsStatus"
            ],
            members: {
              StandardsSubscriptionArn: {},
              StandardsArn: {},
              StandardsInput: {
                shape: "Sb"
              },
              StandardsStatus: {}
            }
          }
        },
        Sb: {
          type: "map",
          key: {},
          value: {}
        },
        Sj: {
          type: "structure",
          required: [
            "SchemaVersion",
            "Id",
            "ProductArn",
            "GeneratorId",
            "AwsAccountId",
            "CreatedAt",
            "UpdatedAt",
            "Title",
            "Description",
            "Resources"
          ],
          members: {
            SchemaVersion: {},
            Id: {},
            ProductArn: {},
            ProductName: {},
            CompanyName: {},
            Region: {},
            GeneratorId: {},
            AwsAccountId: {},
            Types: {
              shape: "Sk"
            },
            FirstObservedAt: {},
            LastObservedAt: {},
            CreatedAt: {},
            UpdatedAt: {},
            Severity: {
              type: "structure",
              members: {
                Product: {
                  type: "double"
                },
                Label: {},
                Normalized: {
                  type: "integer"
                },
                Original: {}
              }
            },
            Confidence: {
              type: "integer"
            },
            Criticality: {
              type: "integer"
            },
            Title: {},
            Description: {},
            Remediation: {
              type: "structure",
              members: {
                Recommendation: {
                  type: "structure",
                  members: {
                    Text: {},
                    Url: {}
                  }
                }
              }
            },
            SourceUrl: {},
            ProductFields: {
              shape: "Sr"
            },
            UserDefinedFields: {
              shape: "Sr"
            },
            Malware: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name"
                ],
                members: {
                  Name: {},
                  Type: {},
                  Path: {},
                  State: {}
                }
              }
            },
            Network: {
              type: "structure",
              members: {
                Direction: {},
                Protocol: {},
                OpenPortRange: {
                  shape: "Sy"
                },
                SourceIpV4: {},
                SourceIpV6: {},
                SourcePort: {
                  type: "integer"
                },
                SourceDomain: {},
                SourceMac: {},
                DestinationIpV4: {},
                DestinationIpV6: {},
                DestinationPort: {
                  type: "integer"
                },
                DestinationDomain: {}
              }
            },
            NetworkPath: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ComponentId: {},
                  ComponentType: {},
                  Egress: {
                    shape: "S11"
                  },
                  Ingress: {
                    shape: "S11"
                  }
                }
              }
            },
            Process: {
              type: "structure",
              members: {
                Name: {},
                Path: {},
                Pid: {
                  type: "integer"
                },
                ParentPid: {
                  type: "integer"
                },
                LaunchedAt: {},
                TerminatedAt: {}
              }
            },
            ThreatIntelIndicators: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Type: {},
                  Value: {},
                  Category: {},
                  LastObservedAt: {},
                  Source: {},
                  SourceUrl: {}
                }
              }
            },
            Resources: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Type",
                  "Id"
                ],
                members: {
                  Type: {},
                  Id: {},
                  Partition: {},
                  Region: {},
                  ResourceRole: {},
                  Tags: {
                    shape: "Sr"
                  },
                  DataClassification: {
                    type: "structure",
                    members: {
                      DetailedResultsLocation: {},
                      Result: {
                        type: "structure",
                        members: {
                          MimeType: {},
                          SizeClassified: {
                            type: "long"
                          },
                          AdditionalOccurrences: {
                            type: "boolean"
                          },
                          Status: {
                            type: "structure",
                            members: {
                              Code: {},
                              Reason: {}
                            }
                          },
                          SensitiveData: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Category: {},
                                Detections: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Count: {
                                        type: "long"
                                      },
                                      Type: {},
                                      Occurrences: {
                                        shape: "S1m"
                                      }
                                    }
                                  }
                                },
                                TotalCount: {
                                  type: "long"
                                }
                              }
                            }
                          },
                          CustomDataIdentifiers: {
                            type: "structure",
                            members: {
                              Detections: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Count: {
                                      type: "long"
                                    },
                                    Arn: {},
                                    Name: {},
                                    Occurrences: {
                                      shape: "S1m"
                                    }
                                  }
                                }
                              },
                              TotalCount: {
                                type: "long"
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  Details: {
                    type: "structure",
                    members: {
                      AwsAutoScalingAutoScalingGroup: {
                        type: "structure",
                        members: {
                          LaunchConfigurationName: {},
                          LoadBalancerNames: {
                            shape: "S13"
                          },
                          HealthCheckType: {},
                          HealthCheckGracePeriod: {
                            type: "integer"
                          },
                          CreatedTime: {}
                        }
                      },
                      AwsCodeBuildProject: {
                        type: "structure",
                        members: {
                          EncryptionKey: {},
                          Artifacts: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                ArtifactIdentifier: {},
                                EncryptionDisabled: {
                                  type: "boolean"
                                },
                                Location: {},
                                Name: {},
                                NamespaceType: {},
                                OverrideArtifactName: {
                                  type: "boolean"
                                },
                                Packaging: {},
                                Path: {},
                                Type: {}
                              }
                            }
                          },
                          Environment: {
                            type: "structure",
                            members: {
                              Certificate: {},
                              EnvironmentVariables: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Name: {},
                                    Type: {},
                                    Value: {}
                                  }
                                }
                              },
                              PrivilegedMode: {
                                type: "boolean"
                              },
                              ImagePullCredentialsType: {},
                              RegistryCredential: {
                                type: "structure",
                                members: {
                                  Credential: {},
                                  CredentialProvider: {}
                                }
                              },
                              Type: {}
                            }
                          },
                          Name: {},
                          Source: {
                            type: "structure",
                            members: {
                              Type: {},
                              Location: {},
                              GitCloneDepth: {
                                type: "integer"
                              },
                              InsecureSsl: {
                                type: "boolean"
                              }
                            }
                          },
                          ServiceRole: {},
                          LogsConfig: {
                            type: "structure",
                            members: {
                              CloudWatchLogs: {
                                type: "structure",
                                members: {
                                  GroupName: {},
                                  Status: {},
                                  StreamName: {}
                                }
                              },
                              S3Logs: {
                                type: "structure",
                                members: {
                                  EncryptionDisabled: {
                                    type: "boolean"
                                  },
                                  Location: {},
                                  Status: {}
                                }
                              }
                            }
                          },
                          VpcConfig: {
                            type: "structure",
                            members: {
                              VpcId: {},
                              Subnets: {
                                shape: "S2c"
                              },
                              SecurityGroupIds: {
                                shape: "S2c"
                              }
                            }
                          }
                        }
                      },
                      AwsCloudFrontDistribution: {
                        type: "structure",
                        members: {
                          CacheBehaviors: {
                            type: "structure",
                            members: {
                              Items: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    ViewerProtocolPolicy: {}
                                  }
                                }
                              }
                            }
                          },
                          DefaultCacheBehavior: {
                            type: "structure",
                            members: {
                              ViewerProtocolPolicy: {}
                            }
                          },
                          DefaultRootObject: {},
                          DomainName: {},
                          ETag: {},
                          LastModifiedTime: {},
                          Logging: {
                            type: "structure",
                            members: {
                              Bucket: {},
                              Enabled: {
                                type: "boolean"
                              },
                              IncludeCookies: {
                                type: "boolean"
                              },
                              Prefix: {}
                            }
                          },
                          Origins: {
                            type: "structure",
                            members: {
                              Items: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    DomainName: {},
                                    Id: {},
                                    OriginPath: {},
                                    S3OriginConfig: {
                                      type: "structure",
                                      members: {
                                        OriginAccessIdentity: {}
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          },
                          OriginGroups: {
                            type: "structure",
                            members: {
                              Items: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    FailoverCriteria: {
                                      type: "structure",
                                      members: {
                                        StatusCodes: {
                                          type: "structure",
                                          members: {
                                            Items: {
                                              type: "list",
                                              member: {
                                                type: "integer"
                                              }
                                            },
                                            Quantity: {
                                              type: "integer"
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          },
                          ViewerCertificate: {
                            type: "structure",
                            members: {
                              AcmCertificateArn: {},
                              Certificate: {},
                              CertificateSource: {},
                              CloudFrontDefaultCertificate: {
                                type: "boolean"
                              },
                              IamCertificateId: {},
                              MinimumProtocolVersion: {},
                              SslSupportMethod: {}
                            }
                          },
                          Status: {},
                          WebAclId: {}
                        }
                      },
                      AwsEc2Instance: {
                        type: "structure",
                        members: {
                          Type: {},
                          ImageId: {},
                          IpV4Addresses: {
                            shape: "S13"
                          },
                          IpV6Addresses: {
                            shape: "S13"
                          },
                          KeyName: {},
                          IamInstanceProfileArn: {},
                          VpcId: {},
                          SubnetId: {},
                          LaunchedAt: {},
                          NetworkInterfaces: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                NetworkInterfaceId: {}
                              }
                            }
                          }
                        }
                      },
                      AwsEc2NetworkInterface: {
                        type: "structure",
                        members: {
                          Attachment: {
                            type: "structure",
                            members: {
                              AttachTime: {},
                              AttachmentId: {},
                              DeleteOnTermination: {
                                type: "boolean"
                              },
                              DeviceIndex: {
                                type: "integer"
                              },
                              InstanceId: {},
                              InstanceOwnerId: {},
                              Status: {}
                            }
                          },
                          NetworkInterfaceId: {},
                          SecurityGroups: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                GroupName: {},
                                GroupId: {}
                              }
                            }
                          },
                          SourceDestCheck: {
                            type: "boolean"
                          },
                          IpV6Addresses: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                IpV6Address: {}
                              }
                            }
                          },
                          PrivateIpAddresses: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                PrivateIpAddress: {},
                                PrivateDnsName: {}
                              }
                            }
                          },
                          PublicDnsName: {},
                          PublicIp: {}
                        }
                      },
                      AwsEc2SecurityGroup: {
                        type: "structure",
                        members: {
                          GroupName: {},
                          GroupId: {},
                          OwnerId: {},
                          VpcId: {},
                          IpPermissions: {
                            shape: "S36"
                          },
                          IpPermissionsEgress: {
                            shape: "S36"
                          }
                        }
                      },
                      AwsEc2Volume: {
                        type: "structure",
                        members: {
                          CreateTime: {},
                          Encrypted: {
                            type: "boolean"
                          },
                          Size: {
                            type: "integer"
                          },
                          SnapshotId: {},
                          Status: {},
                          KmsKeyId: {},
                          Attachments: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                AttachTime: {},
                                DeleteOnTermination: {
                                  type: "boolean"
                                },
                                InstanceId: {},
                                Status: {}
                              }
                            }
                          }
                        }
                      },
                      AwsEc2Vpc: {
                        type: "structure",
                        members: {
                          CidrBlockAssociationSet: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                AssociationId: {},
                                CidrBlock: {},
                                CidrBlockState: {}
                              }
                            }
                          },
                          Ipv6CidrBlockAssociationSet: {
                            shape: "S3m"
                          },
                          DhcpOptionsId: {},
                          State: {}
                        }
                      },
                      AwsEc2Eip: {
                        type: "structure",
                        members: {
                          InstanceId: {},
                          PublicIp: {},
                          AllocationId: {},
                          AssociationId: {},
                          Domain: {},
                          PublicIpv4Pool: {},
                          NetworkBorderGroup: {},
                          NetworkInterfaceId: {},
                          NetworkInterfaceOwnerId: {},
                          PrivateIpAddress: {}
                        }
                      },
                      AwsEc2Subnet: {
                        type: "structure",
                        members: {
                          AssignIpv6AddressOnCreation: {
                            type: "boolean"
                          },
                          AvailabilityZone: {},
                          AvailabilityZoneId: {},
                          AvailableIpAddressCount: {
                            type: "integer"
                          },
                          CidrBlock: {},
                          DefaultForAz: {
                            type: "boolean"
                          },
                          MapPublicIpOnLaunch: {
                            type: "boolean"
                          },
                          OwnerId: {},
                          State: {},
                          SubnetArn: {},
                          SubnetId: {},
                          VpcId: {},
                          Ipv6CidrBlockAssociationSet: {
                            shape: "S3m"
                          }
                        }
                      },
                      AwsEc2NetworkAcl: {
                        type: "structure",
                        members: {
                          IsDefault: {
                            type: "boolean"
                          },
                          NetworkAclId: {},
                          OwnerId: {},
                          VpcId: {},
                          Associations: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                NetworkAclAssociationId: {},
                                NetworkAclId: {},
                                SubnetId: {}
                              }
                            }
                          },
                          Entries: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                CidrBlock: {},
                                Egress: {
                                  type: "boolean"
                                },
                                IcmpTypeCode: {
                                  type: "structure",
                                  members: {
                                    Code: {
                                      type: "integer"
                                    },
                                    Type: {
                                      type: "integer"
                                    }
                                  }
                                },
                                Ipv6CidrBlock: {},
                                PortRange: {
                                  type: "structure",
                                  members: {
                                    From: {
                                      type: "integer"
                                    },
                                    To: {
                                      type: "integer"
                                    }
                                  }
                                },
                                Protocol: {},
                                RuleAction: {},
                                RuleNumber: {
                                  type: "integer"
                                }
                              }
                            }
                          }
                        }
                      },
                      AwsElbv2LoadBalancer: {
                        type: "structure",
                        members: {
                          AvailabilityZones: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                ZoneName: {},
                                SubnetId: {}
                              }
                            }
                          },
                          CanonicalHostedZoneId: {},
                          CreatedTime: {},
                          DNSName: {},
                          IpAddressType: {},
                          Scheme: {},
                          SecurityGroups: {
                            type: "list",
                            member: {}
                          },
                          State: {
                            type: "structure",
                            members: {
                              Code: {},
                              Reason: {}
                            }
                          },
                          Type: {},
                          VpcId: {},
                          LoadBalancerAttributes: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Key: {},
                                Value: {}
                              }
                            }
                          }
                        }
                      },
                      AwsElasticBeanstalkEnvironment: {
                        type: "structure",
                        members: {
                          ApplicationName: {},
                          Cname: {},
                          DateCreated: {},
                          DateUpdated: {},
                          Description: {},
                          EndpointUrl: {},
                          EnvironmentArn: {},
                          EnvironmentId: {},
                          EnvironmentLinks: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                EnvironmentName: {},
                                LinkName: {}
                              }
                            }
                          },
                          EnvironmentName: {},
                          OptionSettings: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Namespace: {},
                                OptionName: {},
                                ResourceName: {},
                                Value: {}
                              }
                            }
                          },
                          PlatformArn: {},
                          SolutionStackName: {},
                          Status: {},
                          Tier: {
                            type: "structure",
                            members: {
                              Name: {},
                              Type: {},
                              Version: {}
                            }
                          },
                          VersionLabel: {}
                        }
                      },
                      AwsElasticsearchDomain: {
                        type: "structure",
                        members: {
                          AccessPolicies: {},
                          DomainEndpointOptions: {
                            type: "structure",
                            members: {
                              EnforceHTTPS: {
                                type: "boolean"
                              },
                              TLSSecurityPolicy: {}
                            }
                          },
                          DomainId: {},
                          DomainName: {},
                          Endpoint: {},
                          Endpoints: {
                            shape: "Sr"
                          },
                          ElasticsearchVersion: {},
                          ElasticsearchClusterConfig: {
                            type: "structure",
                            members: {
                              DedicatedMasterCount: {
                                type: "integer"
                              },
                              DedicatedMasterEnabled: {
                                type: "boolean"
                              },
                              DedicatedMasterType: {},
                              InstanceCount: {
                                type: "integer"
                              },
                              InstanceType: {},
                              ZoneAwarenessConfig: {
                                type: "structure",
                                members: {
                                  AvailabilityZoneCount: {
                                    type: "integer"
                                  }
                                }
                              },
                              ZoneAwarenessEnabled: {
                                type: "boolean"
                              }
                            }
                          },
                          EncryptionAtRestOptions: {
                            type: "structure",
                            members: {
                              Enabled: {
                                type: "boolean"
                              },
                              KmsKeyId: {}
                            }
                          },
                          LogPublishingOptions: {
                            type: "structure",
                            members: {
                              IndexSlowLogs: {
                                shape: "S4g"
                              },
                              SearchSlowLogs: {
                                shape: "S4g"
                              },
                              AuditLogs: {
                                shape: "S4g"
                              }
                            }
                          },
                          NodeToNodeEncryptionOptions: {
                            type: "structure",
                            members: {
                              Enabled: {
                                type: "boolean"
                              }
                            }
                          },
                          ServiceSoftwareOptions: {
                            type: "structure",
                            members: {
                              AutomatedUpdateDate: {},
                              Cancellable: {
                                type: "boolean"
                              },
                              CurrentVersion: {},
                              Description: {},
                              NewVersion: {},
                              UpdateAvailable: {
                                type: "boolean"
                              },
                              UpdateStatus: {}
                            }
                          },
                          VPCOptions: {
                            type: "structure",
                            members: {
                              AvailabilityZones: {
                                shape: "S2c"
                              },
                              SecurityGroupIds: {
                                shape: "S2c"
                              },
                              SubnetIds: {
                                shape: "S2c"
                              },
                              VPCId: {}
                            }
                          }
                        }
                      },
                      AwsS3Bucket: {
                        type: "structure",
                        members: {
                          OwnerId: {},
                          OwnerName: {},
                          OwnerAccountId: {},
                          CreatedAt: {},
                          ServerSideEncryptionConfiguration: {
                            type: "structure",
                            members: {
                              Rules: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    ApplyServerSideEncryptionByDefault: {
                                      type: "structure",
                                      members: {
                                        SSEAlgorithm: {},
                                        KMSMasterKeyID: {}
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          },
                          BucketLifecycleConfiguration: {
                            type: "structure",
                            members: {
                              Rules: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    AbortIncompleteMultipartUpload: {
                                      type: "structure",
                                      members: {
                                        DaysAfterInitiation: {
                                          type: "integer"
                                        }
                                      }
                                    },
                                    ExpirationDate: {},
                                    ExpirationInDays: {
                                      type: "integer"
                                    },
                                    ExpiredObjectDeleteMarker: {
                                      type: "boolean"
                                    },
                                    Filter: {
                                      type: "structure",
                                      members: {
                                        Predicate: {
                                          type: "structure",
                                          members: {
                                            Operands: {
                                              type: "list",
                                              member: {
                                                type: "structure",
                                                members: {
                                                  Prefix: {},
                                                  Tag: {
                                                    type: "structure",
                                                    members: {
                                                      Key: {},
                                                      Value: {}
                                                    }
                                                  },
                                                  Type: {}
                                                }
                                              }
                                            },
                                            Prefix: {},
                                            Tag: {
                                              type: "structure",
                                              members: {
                                                Key: {},
                                                Value: {}
                                              }
                                            },
                                            Type: {}
                                          }
                                        }
                                      }
                                    },
                                    ID: {},
                                    NoncurrentVersionExpirationInDays: {
                                      type: "integer"
                                    },
                                    NoncurrentVersionTransitions: {
                                      type: "list",
                                      member: {
                                        type: "structure",
                                        members: {
                                          Days: {
                                            type: "integer"
                                          },
                                          StorageClass: {}
                                        }
                                      }
                                    },
                                    Prefix: {},
                                    Status: {},
                                    Transitions: {
                                      type: "list",
                                      member: {
                                        type: "structure",
                                        members: {
                                          Date: {},
                                          Days: {
                                            type: "integer"
                                          },
                                          StorageClass: {}
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          },
                          PublicAccessBlockConfiguration: {
                            shape: "S53"
                          },
                          AccessControlList: {},
                          BucketLoggingConfiguration: {
                            type: "structure",
                            members: {
                              DestinationBucketName: {},
                              LogFilePrefix: {}
                            }
                          },
                          BucketWebsiteConfiguration: {
                            type: "structure",
                            members: {
                              ErrorDocument: {},
                              IndexDocumentSuffix: {},
                              RedirectAllRequestsTo: {
                                type: "structure",
                                members: {
                                  Hostname: {},
                                  Protocol: {}
                                }
                              },
                              RoutingRules: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Condition: {
                                      type: "structure",
                                      members: {
                                        HttpErrorCodeReturnedEquals: {},
                                        KeyPrefixEquals: {}
                                      }
                                    },
                                    Redirect: {
                                      type: "structure",
                                      members: {
                                        Hostname: {},
                                        HttpRedirectCode: {},
                                        Protocol: {},
                                        ReplaceKeyPrefixWith: {},
                                        ReplaceKeyWith: {}
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          },
                          BucketNotificationConfiguration: {
                            type: "structure",
                            members: {
                              Configurations: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Events: {
                                      type: "list",
                                      member: {}
                                    },
                                    Filter: {
                                      type: "structure",
                                      members: {
                                        S3KeyFilter: {
                                          type: "structure",
                                          members: {
                                            FilterRules: {
                                              type: "list",
                                              member: {
                                                type: "structure",
                                                members: {
                                                  Name: {},
                                                  Value: {}
                                                }
                                              }
                                            }
                                          }
                                        }
                                      }
                                    },
                                    Destination: {},
                                    Type: {}
                                  }
                                }
                              }
                            }
                          }
                        }
                      },
                      AwsS3AccountPublicAccessBlock: {
                        shape: "S53"
                      },
                      AwsS3Object: {
                        type: "structure",
                        members: {
                          LastModified: {},
                          ETag: {},
                          VersionId: {},
                          ContentType: {},
                          ServerSideEncryption: {},
                          SSEKMSKeyId: {}
                        }
                      },
                      AwsSecretsManagerSecret: {
                        type: "structure",
                        members: {
                          RotationRules: {
                            type: "structure",
                            members: {
                              AutomaticallyAfterDays: {
                                type: "integer"
                              }
                            }
                          },
                          RotationOccurredWithinFrequency: {
                            type: "boolean"
                          },
                          KmsKeyId: {},
                          RotationEnabled: {
                            type: "boolean"
                          },
                          RotationLambdaArn: {},
                          Deleted: {
                            type: "boolean"
                          },
                          Name: {},
                          Description: {}
                        }
                      },
                      AwsIamAccessKey: {
                        type: "structure",
                        members: {
                          UserName: {
                            deprecated: true,
                            deprecatedMessage: "This filter is deprecated. Instead, use PrincipalName."
                          },
                          Status: {},
                          CreatedAt: {},
                          PrincipalId: {},
                          PrincipalType: {},
                          PrincipalName: {},
                          AccountId: {},
                          AccessKeyId: {},
                          SessionContext: {
                            type: "structure",
                            members: {
                              Attributes: {
                                type: "structure",
                                members: {
                                  MfaAuthenticated: {
                                    type: "boolean"
                                  },
                                  CreationDate: {}
                                }
                              },
                              SessionIssuer: {
                                type: "structure",
                                members: {
                                  Type: {},
                                  PrincipalId: {},
                                  Arn: {},
                                  AccountId: {},
                                  UserName: {}
                                }
                              }
                            }
                          }
                        }
                      },
                      AwsIamUser: {
                        type: "structure",
                        members: {
                          AttachedManagedPolicies: {
                            shape: "S5t"
                          },
                          CreateDate: {},
                          GroupList: {
                            shape: "S13"
                          },
                          Path: {},
                          PermissionsBoundary: {
                            shape: "S5v"
                          },
                          UserId: {},
                          UserName: {},
                          UserPolicyList: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                PolicyName: {}
                              }
                            }
                          }
                        }
                      },
                      AwsIamPolicy: {
                        type: "structure",
                        members: {
                          AttachmentCount: {
                            type: "integer"
                          },
                          CreateDate: {},
                          DefaultVersionId: {},
                          Description: {},
                          IsAttachable: {
                            type: "boolean"
                          },
                          Path: {},
                          PermissionsBoundaryUsageCount: {
                            type: "integer"
                          },
                          PolicyId: {},
                          PolicyName: {},
                          PolicyVersionList: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                VersionId: {},
                                IsDefaultVersion: {
                                  type: "boolean"
                                },
                                CreateDate: {}
                              }
                            }
                          },
                          UpdateDate: {}
                        }
                      },
                      AwsApiGatewayV2Stage: {
                        type: "structure",
                        members: {
                          ClientCertificateId: {},
                          CreatedDate: {},
                          Description: {},
                          DefaultRouteSettings: {
                            shape: "S62"
                          },
                          DeploymentId: {},
                          LastUpdatedDate: {},
                          RouteSettings: {
                            shape: "S62"
                          },
                          StageName: {},
                          StageVariables: {
                            shape: "Sr"
                          },
                          AccessLogSettings: {
                            shape: "S63"
                          },
                          AutoDeploy: {
                            type: "boolean"
                          },
                          LastDeploymentStatusMessage: {},
                          ApiGatewayManaged: {
                            type: "boolean"
                          }
                        }
                      },
                      AwsApiGatewayV2Api: {
                        type: "structure",
                        members: {
                          ApiEndpoint: {},
                          ApiId: {},
                          ApiKeySelectionExpression: {},
                          CreatedDate: {},
                          Description: {},
                          Version: {},
                          Name: {},
                          ProtocolType: {},
                          RouteSelectionExpression: {},
                          CorsConfiguration: {
                            type: "structure",
                            members: {
                              AllowOrigins: {
                                shape: "S2c"
                              },
                              AllowCredentials: {
                                type: "boolean"
                              },
                              ExposeHeaders: {
                                shape: "S2c"
                              },
                              MaxAge: {
                                type: "integer"
                              },
                              AllowMethods: {
                                shape: "S2c"
                              },
                              AllowHeaders: {
                                shape: "S2c"
                              }
                            }
                          }
                        }
                      },
                      AwsDynamoDbTable: {
                        type: "structure",
                        members: {
                          AttributeDefinitions: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                AttributeName: {},
                                AttributeType: {}
                              }
                            }
                          },
                          BillingModeSummary: {
                            type: "structure",
                            members: {
                              BillingMode: {},
                              LastUpdateToPayPerRequestDateTime: {}
                            }
                          },
                          CreationDateTime: {},
                          GlobalSecondaryIndexes: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Backfilling: {
                                  type: "boolean"
                                },
                                IndexArn: {},
                                IndexName: {},
                                IndexSizeBytes: {
                                  type: "long"
                                },
                                IndexStatus: {},
                                ItemCount: {
                                  type: "integer"
                                },
                                KeySchema: {
                                  shape: "S6d"
                                },
                                Projection: {
                                  shape: "S6f"
                                },
                                ProvisionedThroughput: {
                                  shape: "S6g"
                                }
                              }
                            }
                          },
                          GlobalTableVersion: {},
                          ItemCount: {
                            type: "integer"
                          },
                          KeySchema: {
                            shape: "S6d"
                          },
                          LatestStreamArn: {},
                          LatestStreamLabel: {},
                          LocalSecondaryIndexes: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                IndexArn: {},
                                IndexName: {},
                                KeySchema: {
                                  shape: "S6d"
                                },
                                Projection: {
                                  shape: "S6f"
                                }
                              }
                            }
                          },
                          ProvisionedThroughput: {
                            shape: "S6g"
                          },
                          Replicas: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                GlobalSecondaryIndexes: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      IndexName: {},
                                      ProvisionedThroughputOverride: {
                                        shape: "S6n"
                                      }
                                    }
                                  }
                                },
                                KmsMasterKeyId: {},
                                ProvisionedThroughputOverride: {
                                  shape: "S6n"
                                },
                                RegionName: {},
                                ReplicaStatus: {},
                                ReplicaStatusDescription: {}
                              }
                            }
                          },
                          RestoreSummary: {
                            type: "structure",
                            members: {
                              SourceBackupArn: {},
                              SourceTableArn: {},
                              RestoreDateTime: {},
                              RestoreInProgress: {
                                type: "boolean"
                              }
                            }
                          },
                          SseDescription: {
                            type: "structure",
                            members: {
                              InaccessibleEncryptionDateTime: {},
                              Status: {},
                              SseType: {},
                              KmsMasterKeyArn: {}
                            }
                          },
                          StreamSpecification: {
                            type: "structure",
                            members: {
                              StreamEnabled: {
                                type: "boolean"
                              },
                              StreamViewType: {}
                            }
                          },
                          TableId: {},
                          TableName: {},
                          TableSizeBytes: {
                            type: "long"
                          },
                          TableStatus: {}
                        }
                      },
                      AwsApiGatewayStage: {
                        type: "structure",
                        members: {
                          DeploymentId: {},
                          ClientCertificateId: {},
                          StageName: {},
                          Description: {},
                          CacheClusterEnabled: {
                            type: "boolean"
                          },
                          CacheClusterSize: {},
                          CacheClusterStatus: {},
                          MethodSettings: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                MetricsEnabled: {
                                  type: "boolean"
                                },
                                LoggingLevel: {},
                                DataTraceEnabled: {
                                  type: "boolean"
                                },
                                ThrottlingBurstLimit: {
                                  type: "integer"
                                },
                                ThrottlingRateLimit: {
                                  type: "double"
                                },
                                CachingEnabled: {
                                  type: "boolean"
                                },
                                CacheTtlInSeconds: {
                                  type: "integer"
                                },
                                CacheDataEncrypted: {
                                  type: "boolean"
                                },
                                RequireAuthorizationForCacheControl: {
                                  type: "boolean"
                                },
                                UnauthorizedCacheControlHeaderStrategy: {},
                                HttpMethod: {},
                                ResourcePath: {}
                              }
                            }
                          },
                          Variables: {
                            shape: "Sr"
                          },
                          DocumentationVersion: {},
                          AccessLogSettings: {
                            shape: "S63"
                          },
                          CanarySettings: {
                            type: "structure",
                            members: {
                              PercentTraffic: {
                                type: "double"
                              },
                              DeploymentId: {},
                              StageVariableOverrides: {
                                shape: "Sr"
                              },
                              UseStageCache: {
                                type: "boolean"
                              }
                            }
                          },
                          TracingEnabled: {
                            type: "boolean"
                          },
                          CreatedDate: {},
                          LastUpdatedDate: {},
                          WebAclArn: {}
                        }
                      },
                      AwsApiGatewayRestApi: {
                        type: "structure",
                        members: {
                          Id: {},
                          Name: {},
                          Description: {},
                          CreatedDate: {},
                          Version: {},
                          BinaryMediaTypes: {
                            shape: "S2c"
                          },
                          MinimumCompressionSize: {
                            type: "integer"
                          },
                          ApiKeySource: {},
                          EndpointConfiguration: {
                            type: "structure",
                            members: {
                              Types: {
                                shape: "S2c"
                              }
                            }
                          }
                        }
                      },
                      AwsCloudTrailTrail: {
                        type: "structure",
                        members: {
                          CloudWatchLogsLogGroupArn: {},
                          CloudWatchLogsRoleArn: {},
                          HasCustomEventSelectors: {
                            type: "boolean"
                          },
                          HomeRegion: {},
                          IncludeGlobalServiceEvents: {
                            type: "boolean"
                          },
                          IsMultiRegionTrail: {
                            type: "boolean"
                          },
                          IsOrganizationTrail: {
                            type: "boolean"
                          },
                          KmsKeyId: {},
                          LogFileValidationEnabled: {
                            type: "boolean"
                          },
                          Name: {},
                          S3BucketName: {},
                          S3KeyPrefix: {},
                          SnsTopicArn: {},
                          SnsTopicName: {},
                          TrailArn: {}
                        }
                      },
                      AwsSsmPatchCompliance: {
                        type: "structure",
                        members: {
                          Patch: {
                            type: "structure",
                            members: {
                              ComplianceSummary: {
                                type: "structure",
                                members: {
                                  Status: {},
                                  CompliantCriticalCount: {
                                    type: "integer"
                                  },
                                  CompliantHighCount: {
                                    type: "integer"
                                  },
                                  CompliantMediumCount: {
                                    type: "integer"
                                  },
                                  ExecutionType: {},
                                  NonCompliantCriticalCount: {
                                    type: "integer"
                                  },
                                  CompliantInformationalCount: {
                                    type: "integer"
                                  },
                                  NonCompliantInformationalCount: {
                                    type: "integer"
                                  },
                                  CompliantUnspecifiedCount: {
                                    type: "integer"
                                  },
                                  NonCompliantLowCount: {
                                    type: "integer"
                                  },
                                  NonCompliantHighCount: {
                                    type: "integer"
                                  },
                                  CompliantLowCount: {
                                    type: "integer"
                                  },
                                  ComplianceType: {},
                                  PatchBaselineId: {},
                                  OverallSeverity: {},
                                  NonCompliantMediumCount: {
                                    type: "integer"
                                  },
                                  NonCompliantUnspecifiedCount: {
                                    type: "integer"
                                  },
                                  PatchGroup: {}
                                }
                              }
                            }
                          }
                        }
                      },
                      AwsCertificateManagerCertificate: {
                        type: "structure",
                        members: {
                          CertificateAuthorityArn: {},
                          CreatedAt: {},
                          DomainName: {},
                          DomainValidationOptions: {
                            shape: "S72"
                          },
                          ExtendedKeyUsages: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {},
                                OId: {}
                              }
                            }
                          },
                          FailureReason: {},
                          ImportedAt: {},
                          InUseBy: {
                            shape: "S13"
                          },
                          IssuedAt: {},
                          Issuer: {},
                          KeyAlgorithm: {},
                          KeyUsages: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {}
                              }
                            }
                          },
                          NotAfter: {},
                          NotBefore: {},
                          Options: {
                            type: "structure",
                            members: {
                              CertificateTransparencyLoggingPreference: {}
                            }
                          },
                          RenewalEligibility: {},
                          RenewalSummary: {
                            type: "structure",
                            members: {
                              DomainValidationOptions: {
                                shape: "S72"
                              },
                              RenewalStatus: {},
                              RenewalStatusReason: {},
                              UpdatedAt: {}
                            }
                          },
                          Serial: {},
                          SignatureAlgorithm: {},
                          Status: {},
                          Subject: {},
                          SubjectAlternativeNames: {
                            shape: "S13"
                          },
                          Type: {}
                        }
                      },
                      AwsRedshiftCluster: {
                        type: "structure",
                        members: {
                          AllowVersionUpgrade: {
                            type: "boolean"
                          },
                          AutomatedSnapshotRetentionPeriod: {
                            type: "integer"
                          },
                          AvailabilityZone: {},
                          ClusterAvailabilityStatus: {},
                          ClusterCreateTime: {},
                          ClusterIdentifier: {},
                          ClusterNodes: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                NodeRole: {},
                                PrivateIpAddress: {},
                                PublicIpAddress: {}
                              }
                            }
                          },
                          ClusterParameterGroups: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                ClusterParameterStatusList: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      ParameterName: {},
                                      ParameterApplyStatus: {},
                                      ParameterApplyErrorDescription: {}
                                    }
                                  }
                                },
                                ParameterApplyStatus: {},
                                ParameterGroupName: {}
                              }
                            }
                          },
                          ClusterPublicKey: {},
                          ClusterRevisionNumber: {},
                          ClusterSecurityGroups: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                ClusterSecurityGroupName: {},
                                Status: {}
                              }
                            }
                          },
                          ClusterSnapshotCopyStatus: {
                            type: "structure",
                            members: {
                              DestinationRegion: {},
                              ManualSnapshotRetentionPeriod: {
                                type: "integer"
                              },
                              RetentionPeriod: {
                                type: "integer"
                              },
                              SnapshotCopyGrantName: {}
                            }
                          },
                          ClusterStatus: {},
                          ClusterSubnetGroupName: {},
                          ClusterVersion: {},
                          DBName: {},
                          DeferredMaintenanceWindows: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                DeferMaintenanceEndTime: {},
                                DeferMaintenanceIdentifier: {},
                                DeferMaintenanceStartTime: {}
                              }
                            }
                          },
                          ElasticIpStatus: {
                            type: "structure",
                            members: {
                              ElasticIp: {},
                              Status: {}
                            }
                          },
                          ElasticResizeNumberOfNodeOptions: {},
                          Encrypted: {
                            type: "boolean"
                          },
                          Endpoint: {
                            type: "structure",
                            members: {
                              Address: {},
                              Port: {
                                type: "integer"
                              }
                            }
                          },
                          EnhancedVpcRouting: {
                            type: "boolean"
                          },
                          ExpectedNextSnapshotScheduleTime: {},
                          ExpectedNextSnapshotScheduleTimeStatus: {},
                          HsmStatus: {
                            type: "structure",
                            members: {
                              HsmClientCertificateIdentifier: {},
                              HsmConfigurationIdentifier: {},
                              Status: {}
                            }
                          },
                          IamRoles: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                ApplyStatus: {},
                                IamRoleArn: {}
                              }
                            }
                          },
                          KmsKeyId: {},
                          MaintenanceTrackName: {},
                          ManualSnapshotRetentionPeriod: {
                            type: "integer"
                          },
                          MasterUsername: {},
                          NextMaintenanceWindowStartTime: {},
                          NodeType: {},
                          NumberOfNodes: {
                            type: "integer"
                          },
                          PendingActions: {
                            shape: "S13"
                          },
                          PendingModifiedValues: {
                            type: "structure",
                            members: {
                              AutomatedSnapshotRetentionPeriod: {
                                type: "integer"
                              },
                              ClusterIdentifier: {},
                              ClusterType: {},
                              ClusterVersion: {},
                              EncryptionType: {},
                              EnhancedVpcRouting: {
                                type: "boolean"
                              },
                              MaintenanceTrackName: {},
                              MasterUserPassword: {},
                              NodeType: {},
                              NumberOfNodes: {
                                type: "integer"
                              },
                              PubliclyAccessible: {
                                type: "boolean"
                              }
                            }
                          },
                          PreferredMaintenanceWindow: {},
                          PubliclyAccessible: {
                            type: "boolean"
                          },
                          ResizeInfo: {
                            type: "structure",
                            members: {
                              AllowCancelResize: {
                                type: "boolean"
                              },
                              ResizeType: {}
                            }
                          },
                          RestoreStatus: {
                            type: "structure",
                            members: {
                              CurrentRestoreRateInMegaBytesPerSecond: {
                                type: "double"
                              },
                              ElapsedTimeInSeconds: {
                                type: "long"
                              },
                              EstimatedTimeToCompletionInSeconds: {
                                type: "long"
                              },
                              ProgressInMegaBytes: {
                                type: "long"
                              },
                              SnapshotSizeInMegaBytes: {
                                type: "long"
                              },
                              Status: {}
                            }
                          },
                          SnapshotScheduleIdentifier: {},
                          SnapshotScheduleState: {},
                          VpcId: {},
                          VpcSecurityGroups: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Status: {},
                                VpcSecurityGroupId: {}
                              }
                            }
                          }
                        }
                      },
                      AwsElbLoadBalancer: {
                        type: "structure",
                        members: {
                          AvailabilityZones: {
                            shape: "S13"
                          },
                          BackendServerDescriptions: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                InstancePort: {
                                  type: "integer"
                                },
                                PolicyNames: {
                                  shape: "S13"
                                }
                              }
                            }
                          },
                          CanonicalHostedZoneName: {},
                          CanonicalHostedZoneNameID: {},
                          CreatedTime: {},
                          DnsName: {},
                          HealthCheck: {
                            type: "structure",
                            members: {
                              HealthyThreshold: {
                                type: "integer"
                              },
                              Interval: {
                                type: "integer"
                              },
                              Target: {},
                              Timeout: {
                                type: "integer"
                              },
                              UnhealthyThreshold: {
                                type: "integer"
                              }
                            }
                          },
                          Instances: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                InstanceId: {}
                              }
                            }
                          },
                          ListenerDescriptions: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Listener: {
                                  type: "structure",
                                  members: {
                                    InstancePort: {
                                      type: "integer"
                                    },
                                    InstanceProtocol: {},
                                    LoadBalancerPort: {
                                      type: "integer"
                                    },
                                    Protocol: {},
                                    SslCertificateId: {}
                                  }
                                },
                                PolicyNames: {
                                  shape: "S13"
                                }
                              }
                            }
                          },
                          LoadBalancerAttributes: {
                            type: "structure",
                            members: {
                              AccessLog: {
                                type: "structure",
                                members: {
                                  EmitInterval: {
                                    type: "integer"
                                  },
                                  Enabled: {
                                    type: "boolean"
                                  },
                                  S3BucketName: {},
                                  S3BucketPrefix: {}
                                }
                              },
                              ConnectionDraining: {
                                type: "structure",
                                members: {
                                  Enabled: {
                                    type: "boolean"
                                  },
                                  Timeout: {
                                    type: "integer"
                                  }
                                }
                              },
                              ConnectionSettings: {
                                type: "structure",
                                members: {
                                  IdleTimeout: {
                                    type: "integer"
                                  }
                                }
                              },
                              CrossZoneLoadBalancing: {
                                type: "structure",
                                members: {
                                  Enabled: {
                                    type: "boolean"
                                  }
                                }
                              }
                            }
                          },
                          LoadBalancerName: {},
                          Policies: {
                            type: "structure",
                            members: {
                              AppCookieStickinessPolicies: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    CookieName: {},
                                    PolicyName: {}
                                  }
                                }
                              },
                              LbCookieStickinessPolicies: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    CookieExpirationPeriod: {
                                      type: "long"
                                    },
                                    PolicyName: {}
                                  }
                                }
                              },
                              OtherPolicies: {
                                shape: "S13"
                              }
                            }
                          },
                          Scheme: {},
                          SecurityGroups: {
                            shape: "S13"
                          },
                          SourceSecurityGroup: {
                            type: "structure",
                            members: {
                              GroupName: {},
                              OwnerAlias: {}
                            }
                          },
                          Subnets: {
                            shape: "S13"
                          },
                          VpcId: {}
                        }
                      },
                      AwsIamGroup: {
                        type: "structure",
                        members: {
                          AttachedManagedPolicies: {
                            shape: "S5t"
                          },
                          CreateDate: {},
                          GroupId: {},
                          GroupName: {},
                          GroupPolicyList: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                PolicyName: {}
                              }
                            }
                          },
                          Path: {}
                        }
                      },
                      AwsIamRole: {
                        type: "structure",
                        members: {
                          AssumeRolePolicyDocument: {},
                          AttachedManagedPolicies: {
                            shape: "S5t"
                          },
                          CreateDate: {},
                          InstanceProfileList: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Arn: {},
                                CreateDate: {},
                                InstanceProfileId: {},
                                InstanceProfileName: {},
                                Path: {},
                                Roles: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Arn: {},
                                      AssumeRolePolicyDocument: {},
                                      CreateDate: {},
                                      Path: {},
                                      RoleId: {},
                                      RoleName: {}
                                    }
                                  }
                                }
                              }
                            }
                          },
                          PermissionsBoundary: {
                            shape: "S5v"
                          },
                          RoleId: {},
                          RoleName: {},
                          RolePolicyList: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                PolicyName: {}
                              }
                            }
                          },
                          MaxSessionDuration: {
                            type: "integer"
                          },
                          Path: {}
                        }
                      },
                      AwsKmsKey: {
                        type: "structure",
                        members: {
                          AWSAccountId: {},
                          CreationDate: {
                            type: "double"
                          },
                          KeyId: {},
                          KeyManager: {},
                          KeyState: {},
                          Origin: {},
                          Description: {},
                          KeyRotationStatus: {
                            type: "boolean"
                          }
                        }
                      },
                      AwsLambdaFunction: {
                        type: "structure",
                        members: {
                          Code: {
                            type: "structure",
                            members: {
                              S3Bucket: {},
                              S3Key: {},
                              S3ObjectVersion: {},
                              ZipFile: {}
                            }
                          },
                          CodeSha256: {},
                          DeadLetterConfig: {
                            type: "structure",
                            members: {
                              TargetArn: {}
                            }
                          },
                          Environment: {
                            type: "structure",
                            members: {
                              Variables: {
                                shape: "Sr"
                              },
                              Error: {
                                type: "structure",
                                members: {
                                  ErrorCode: {},
                                  Message: {}
                                }
                              }
                            }
                          },
                          FunctionName: {},
                          Handler: {},
                          KmsKeyArn: {},
                          LastModified: {},
                          Layers: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Arn: {},
                                CodeSize: {
                                  type: "integer"
                                }
                              }
                            }
                          },
                          MasterArn: {},
                          MemorySize: {
                            type: "integer"
                          },
                          RevisionId: {},
                          Role: {},
                          Runtime: {},
                          Timeout: {
                            type: "integer"
                          },
                          TracingConfig: {
                            type: "structure",
                            members: {
                              Mode: {}
                            }
                          },
                          VpcConfig: {
                            type: "structure",
                            members: {
                              SecurityGroupIds: {
                                shape: "S2c"
                              },
                              SubnetIds: {
                                shape: "S2c"
                              },
                              VpcId: {}
                            }
                          },
                          Version: {}
                        }
                      },
                      AwsLambdaLayerVersion: {
                        type: "structure",
                        members: {
                          Version: {
                            type: "long"
                          },
                          CompatibleRuntimes: {
                            shape: "S2c"
                          },
                          CreatedDate: {}
                        }
                      },
                      AwsRdsDbInstance: {
                        type: "structure",
                        members: {
                          AssociatedRoles: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                RoleArn: {},
                                FeatureName: {},
                                Status: {}
                              }
                            }
                          },
                          CACertificateIdentifier: {},
                          DBClusterIdentifier: {},
                          DBInstanceIdentifier: {},
                          DBInstanceClass: {},
                          DbInstancePort: {
                            type: "integer"
                          },
                          DbiResourceId: {},
                          DBName: {},
                          DeletionProtection: {
                            type: "boolean"
                          },
                          Endpoint: {
                            shape: "S97"
                          },
                          Engine: {},
                          EngineVersion: {},
                          IAMDatabaseAuthenticationEnabled: {
                            type: "boolean"
                          },
                          InstanceCreateTime: {},
                          KmsKeyId: {},
                          PubliclyAccessible: {
                            type: "boolean"
                          },
                          StorageEncrypted: {
                            type: "boolean"
                          },
                          TdeCredentialArn: {},
                          VpcSecurityGroups: {
                            shape: "S98"
                          },
                          MultiAz: {
                            type: "boolean"
                          },
                          EnhancedMonitoringResourceArn: {},
                          DbInstanceStatus: {},
                          MasterUsername: {},
                          AllocatedStorage: {
                            type: "integer"
                          },
                          PreferredBackupWindow: {},
                          BackupRetentionPeriod: {
                            type: "integer"
                          },
                          DbSecurityGroups: {
                            shape: "S13"
                          },
                          DbParameterGroups: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                DbParameterGroupName: {},
                                ParameterApplyStatus: {}
                              }
                            }
                          },
                          AvailabilityZone: {},
                          DbSubnetGroup: {
                            type: "structure",
                            members: {
                              DbSubnetGroupName: {},
                              DbSubnetGroupDescription: {},
                              VpcId: {},
                              SubnetGroupStatus: {},
                              Subnets: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    SubnetIdentifier: {},
                                    SubnetAvailabilityZone: {
                                      type: "structure",
                                      members: {
                                        Name: {}
                                      }
                                    },
                                    SubnetStatus: {}
                                  }
                                }
                              },
                              DbSubnetGroupArn: {}
                            }
                          },
                          PreferredMaintenanceWindow: {},
                          PendingModifiedValues: {
                            type: "structure",
                            members: {
                              DbInstanceClass: {},
                              AllocatedStorage: {
                                type: "integer"
                              },
                              MasterUserPassword: {},
                              Port: {
                                type: "integer"
                              },
                              BackupRetentionPeriod: {
                                type: "integer"
                              },
                              MultiAZ: {
                                type: "boolean"
                              },
                              EngineVersion: {},
                              LicenseModel: {},
                              Iops: {
                                type: "integer"
                              },
                              DbInstanceIdentifier: {},
                              StorageType: {},
                              CaCertificateIdentifier: {},
                              DbSubnetGroupName: {},
                              PendingCloudWatchLogsExports: {
                                type: "structure",
                                members: {
                                  LogTypesToEnable: {
                                    shape: "S13"
                                  },
                                  LogTypesToDisable: {
                                    shape: "S13"
                                  }
                                }
                              },
                              ProcessorFeatures: {
                                shape: "S9i"
                              }
                            }
                          },
                          LatestRestorableTime: {},
                          AutoMinorVersionUpgrade: {
                            type: "boolean"
                          },
                          ReadReplicaSourceDBInstanceIdentifier: {},
                          ReadReplicaDBInstanceIdentifiers: {
                            shape: "S13"
                          },
                          ReadReplicaDBClusterIdentifiers: {
                            shape: "S13"
                          },
                          LicenseModel: {},
                          Iops: {
                            type: "integer"
                          },
                          OptionGroupMemberships: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                OptionGroupName: {},
                                Status: {}
                              }
                            }
                          },
                          CharacterSetName: {},
                          SecondaryAvailabilityZone: {},
                          StatusInfos: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                StatusType: {},
                                Normal: {
                                  type: "boolean"
                                },
                                Status: {},
                                Message: {}
                              }
                            }
                          },
                          StorageType: {},
                          DomainMemberships: {
                            shape: "S9o"
                          },
                          CopyTagsToSnapshot: {
                            type: "boolean"
                          },
                          MonitoringInterval: {
                            type: "integer"
                          },
                          MonitoringRoleArn: {},
                          PromotionTier: {
                            type: "integer"
                          },
                          Timezone: {},
                          PerformanceInsightsEnabled: {
                            type: "boolean"
                          },
                          PerformanceInsightsKmsKeyId: {},
                          PerformanceInsightsRetentionPeriod: {
                            type: "integer"
                          },
                          EnabledCloudWatchLogsExports: {
                            shape: "S13"
                          },
                          ProcessorFeatures: {
                            shape: "S9i"
                          },
                          ListenerEndpoint: {
                            shape: "S97"
                          },
                          MaxAllocatedStorage: {
                            type: "integer"
                          }
                        }
                      },
                      AwsSnsTopic: {
                        type: "structure",
                        members: {
                          KmsMasterKeyId: {},
                          Subscription: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Endpoint: {},
                                Protocol: {}
                              }
                            }
                          },
                          TopicName: {},
                          Owner: {}
                        }
                      },
                      AwsSqsQueue: {
                        type: "structure",
                        members: {
                          KmsDataKeyReusePeriodSeconds: {
                            type: "integer"
                          },
                          KmsMasterKeyId: {},
                          QueueName: {},
                          DeadLetterTargetArn: {}
                        }
                      },
                      AwsWafWebAcl: {
                        type: "structure",
                        members: {
                          Name: {},
                          DefaultAction: {},
                          Rules: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Action: {
                                  type: "structure",
                                  members: {
                                    Type: {}
                                  }
                                },
                                ExcludedRules: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      RuleId: {}
                                    }
                                  }
                                },
                                OverrideAction: {
                                  type: "structure",
                                  members: {
                                    Type: {}
                                  }
                                },
                                Priority: {
                                  type: "integer"
                                },
                                RuleId: {},
                                Type: {}
                              }
                            }
                          },
                          WebAclId: {}
                        }
                      },
                      AwsRdsDbSnapshot: {
                        type: "structure",
                        members: {
                          DbSnapshotIdentifier: {},
                          DbInstanceIdentifier: {},
                          SnapshotCreateTime: {},
                          Engine: {},
                          AllocatedStorage: {
                            type: "integer"
                          },
                          Status: {},
                          Port: {
                            type: "integer"
                          },
                          AvailabilityZone: {},
                          VpcId: {},
                          InstanceCreateTime: {},
                          MasterUsername: {},
                          EngineVersion: {},
                          LicenseModel: {},
                          SnapshotType: {},
                          Iops: {
                            type: "integer"
                          },
                          OptionGroupName: {},
                          PercentProgress: {
                            type: "integer"
                          },
                          SourceRegion: {},
                          SourceDbSnapshotIdentifier: {},
                          StorageType: {},
                          TdeCredentialArn: {},
                          Encrypted: {
                            type: "boolean"
                          },
                          KmsKeyId: {},
                          Timezone: {},
                          IamDatabaseAuthenticationEnabled: {
                            type: "boolean"
                          },
                          ProcessorFeatures: {
                            shape: "S9i"
                          },
                          DbiResourceId: {}
                        }
                      },
                      AwsRdsDbClusterSnapshot: {
                        type: "structure",
                        members: {
                          AvailabilityZones: {
                            shape: "S13"
                          },
                          SnapshotCreateTime: {},
                          Engine: {},
                          AllocatedStorage: {
                            type: "integer"
                          },
                          Status: {},
                          Port: {
                            type: "integer"
                          },
                          VpcId: {},
                          ClusterCreateTime: {},
                          MasterUsername: {},
                          EngineVersion: {},
                          LicenseModel: {},
                          SnapshotType: {},
                          PercentProgress: {
                            type: "integer"
                          },
                          StorageEncrypted: {
                            type: "boolean"
                          },
                          KmsKeyId: {},
                          DbClusterIdentifier: {},
                          DbClusterSnapshotIdentifier: {},
                          IamDatabaseAuthenticationEnabled: {
                            type: "boolean"
                          }
                        }
                      },
                      AwsRdsDbCluster: {
                        type: "structure",
                        members: {
                          AllocatedStorage: {
                            type: "integer"
                          },
                          AvailabilityZones: {
                            shape: "S13"
                          },
                          BackupRetentionPeriod: {
                            type: "integer"
                          },
                          DatabaseName: {},
                          Status: {},
                          Endpoint: {},
                          ReaderEndpoint: {},
                          CustomEndpoints: {
                            shape: "S13"
                          },
                          MultiAz: {
                            type: "boolean"
                          },
                          Engine: {},
                          EngineVersion: {},
                          Port: {
                            type: "integer"
                          },
                          MasterUsername: {},
                          PreferredBackupWindow: {},
                          PreferredMaintenanceWindow: {},
                          ReadReplicaIdentifiers: {
                            shape: "S13"
                          },
                          VpcSecurityGroups: {
                            shape: "S98"
                          },
                          HostedZoneId: {},
                          StorageEncrypted: {
                            type: "boolean"
                          },
                          KmsKeyId: {},
                          DbClusterResourceId: {},
                          AssociatedRoles: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                RoleArn: {},
                                Status: {}
                              }
                            }
                          },
                          ClusterCreateTime: {},
                          EnabledCloudWatchLogsExports: {
                            shape: "S13"
                          },
                          EngineMode: {},
                          DeletionProtection: {
                            type: "boolean"
                          },
                          HttpEndpointEnabled: {
                            type: "boolean"
                          },
                          ActivityStreamStatus: {},
                          CopyTagsToSnapshot: {
                            type: "boolean"
                          },
                          CrossAccountClone: {
                            type: "boolean"
                          },
                          DomainMemberships: {
                            shape: "S9o"
                          },
                          DbClusterParameterGroup: {},
                          DbSubnetGroup: {},
                          DbClusterOptionGroupMemberships: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                DbClusterOptionGroupName: {},
                                Status: {}
                              }
                            }
                          },
                          DbClusterIdentifier: {},
                          DbClusterMembers: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                IsClusterWriter: {
                                  type: "boolean"
                                },
                                PromotionTier: {
                                  type: "integer"
                                },
                                DbInstanceIdentifier: {},
                                DbClusterParameterGroupStatus: {}
                              }
                            }
                          },
                          IamDatabaseAuthenticationEnabled: {
                            type: "boolean"
                          }
                        }
                      },
                      AwsEcsCluster: {
                        type: "structure",
                        members: {
                          CapacityProviders: {
                            shape: "S2c"
                          },
                          ClusterSettings: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {},
                                Value: {}
                              }
                            }
                          },
                          Configuration: {
                            type: "structure",
                            members: {
                              ExecuteCommandConfiguration: {
                                type: "structure",
                                members: {
                                  KmsKeyId: {},
                                  LogConfiguration: {
                                    type: "structure",
                                    members: {
                                      CloudWatchEncryptionEnabled: {
                                        type: "boolean"
                                      },
                                      CloudWatchLogGroupName: {},
                                      S3BucketName: {},
                                      S3EncryptionEnabled: {
                                        type: "boolean"
                                      },
                                      S3KeyPrefix: {}
                                    }
                                  },
                                  Logging: {}
                                }
                              }
                            }
                          },
                          DefaultCapacityProviderStrategy: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Base: {
                                  type: "integer"
                                },
                                CapacityProvider: {},
                                Weight: {
                                  type: "integer"
                                }
                              }
                            }
                          }
                        }
                      },
                      AwsEcsTaskDefinition: {
                        type: "structure",
                        members: {
                          ContainerDefinitions: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Command: {
                                  shape: "S2c"
                                },
                                Cpu: {
                                  type: "integer"
                                },
                                DependsOn: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Condition: {},
                                      ContainerName: {}
                                    }
                                  }
                                },
                                DisableNetworking: {
                                  type: "boolean"
                                },
                                DnsSearchDomains: {
                                  shape: "S2c"
                                },
                                DnsServers: {
                                  shape: "S2c"
                                },
                                DockerLabels: {
                                  shape: "Sr"
                                },
                                DockerSecurityOptions: {
                                  shape: "S2c"
                                },
                                EntryPoint: {
                                  shape: "S2c"
                                },
                                Environment: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Name: {},
                                      Value: {}
                                    }
                                  }
                                },
                                EnvironmentFiles: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Type: {},
                                      Value: {}
                                    }
                                  }
                                },
                                Essential: {
                                  type: "boolean"
                                },
                                ExtraHosts: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Hostname: {},
                                      IpAddress: {}
                                    }
                                  }
                                },
                                FirelensConfiguration: {
                                  type: "structure",
                                  members: {
                                    Options: {
                                      shape: "Sr"
                                    },
                                    Type: {}
                                  }
                                },
                                HealthCheck: {
                                  type: "structure",
                                  members: {
                                    Command: {
                                      shape: "S2c"
                                    },
                                    Interval: {
                                      type: "integer"
                                    },
                                    Retries: {
                                      type: "integer"
                                    },
                                    StartPeriod: {
                                      type: "integer"
                                    },
                                    Timeout: {
                                      type: "integer"
                                    }
                                  }
                                },
                                Hostname: {},
                                Image: {},
                                Interactive: {
                                  type: "boolean"
                                },
                                Links: {
                                  shape: "S2c"
                                },
                                LinuxParameters: {
                                  type: "structure",
                                  members: {
                                    Capabilities: {
                                      type: "structure",
                                      members: {
                                        Add: {
                                          shape: "S2c"
                                        },
                                        Drop: {
                                          shape: "S2c"
                                        }
                                      }
                                    },
                                    Devices: {
                                      type: "list",
                                      member: {
                                        type: "structure",
                                        members: {
                                          ContainerPath: {},
                                          HostPath: {},
                                          Permissions: {
                                            shape: "S2c"
                                          }
                                        }
                                      }
                                    },
                                    InitProcessEnabled: {
                                      type: "boolean"
                                    },
                                    MaxSwap: {
                                      type: "integer"
                                    },
                                    SharedMemorySize: {
                                      type: "integer"
                                    },
                                    Swappiness: {
                                      type: "integer"
                                    },
                                    Tmpfs: {
                                      type: "list",
                                      member: {
                                        type: "structure",
                                        members: {
                                          ContainerPath: {},
                                          MountOptions: {
                                            shape: "S2c"
                                          },
                                          Size: {
                                            type: "integer"
                                          }
                                        }
                                      }
                                    }
                                  }
                                },
                                LogConfiguration: {
                                  type: "structure",
                                  members: {
                                    LogDriver: {},
                                    Options: {
                                      shape: "Sr"
                                    },
                                    SecretOptions: {
                                      type: "list",
                                      member: {
                                        type: "structure",
                                        members: {
                                          Name: {},
                                          ValueFrom: {}
                                        }
                                      }
                                    }
                                  }
                                },
                                Memory: {
                                  type: "integer"
                                },
                                MemoryReservation: {
                                  type: "integer"
                                },
                                MountPoints: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      ContainerPath: {},
                                      ReadOnly: {
                                        type: "boolean"
                                      },
                                      SourceVolume: {}
                                    }
                                  }
                                },
                                Name: {},
                                PortMappings: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      ContainerPort: {
                                        type: "integer"
                                      },
                                      HostPort: {
                                        type: "integer"
                                      },
                                      Protocol: {}
                                    }
                                  }
                                },
                                Privileged: {
                                  type: "boolean"
                                },
                                PseudoTerminal: {
                                  type: "boolean"
                                },
                                ReadonlyRootFilesystem: {
                                  type: "boolean"
                                },
                                RepositoryCredentials: {
                                  type: "structure",
                                  members: {
                                    CredentialsParameter: {}
                                  }
                                },
                                ResourceRequirements: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Type: {},
                                      Value: {}
                                    }
                                  }
                                },
                                Secrets: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Name: {},
                                      ValueFrom: {}
                                    }
                                  }
                                },
                                StartTimeout: {
                                  type: "integer"
                                },
                                StopTimeout: {
                                  type: "integer"
                                },
                                SystemControls: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      Namespace: {},
                                      Value: {}
                                    }
                                  }
                                },
                                Ulimits: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      HardLimit: {
                                        type: "integer"
                                      },
                                      Name: {},
                                      SoftLimit: {
                                        type: "integer"
                                      }
                                    }
                                  }
                                },
                                User: {},
                                VolumesFrom: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      ReadOnly: {
                                        type: "boolean"
                                      },
                                      SourceContainer: {}
                                    }
                                  }
                                },
                                WorkingDirectory: {}
                              }
                            }
                          },
                          Cpu: {},
                          ExecutionRoleArn: {},
                          Family: {},
                          InferenceAccelerators: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                DeviceName: {},
                                DeviceType: {}
                              }
                            }
                          },
                          IpcMode: {},
                          Memory: {},
                          NetworkMode: {},
                          PidMode: {},
                          PlacementConstraints: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Expression: {},
                                Type: {}
                              }
                            }
                          },
                          ProxyConfiguration: {
                            type: "structure",
                            members: {
                              ContainerName: {},
                              ProxyConfigurationProperties: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Name: {},
                                    Value: {}
                                  }
                                }
                              },
                              Type: {}
                            }
                          },
                          RequiresCompatibilities: {
                            shape: "S2c"
                          },
                          TaskRoleArn: {},
                          Volumes: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                DockerVolumeConfiguration: {
                                  type: "structure",
                                  members: {
                                    Autoprovision: {
                                      type: "boolean"
                                    },
                                    Driver: {},
                                    DriverOpts: {
                                      shape: "Sr"
                                    },
                                    Labels: {
                                      shape: "Sr"
                                    },
                                    Scope: {}
                                  }
                                },
                                EfsVolumeConfiguration: {
                                  type: "structure",
                                  members: {
                                    AuthorizationConfig: {
                                      type: "structure",
                                      members: {
                                        AccessPointId: {},
                                        Iam: {}
                                      }
                                    },
                                    FilesystemId: {},
                                    RootDirectory: {},
                                    TransitEncryption: {},
                                    TransitEncryptionPort: {
                                      type: "integer"
                                    }
                                  }
                                },
                                Host: {
                                  type: "structure",
                                  members: {
                                    SourcePath: {}
                                  }
                                },
                                Name: {}
                              }
                            }
                          }
                        }
                      },
                      Container: {
                        type: "structure",
                        members: {
                          Name: {},
                          ImageId: {},
                          ImageName: {},
                          LaunchedAt: {}
                        }
                      },
                      Other: {
                        shape: "Sr"
                      },
                      AwsRdsEventSubscription: {
                        type: "structure",
                        members: {
                          CustSubscriptionId: {},
                          CustomerAwsId: {},
                          Enabled: {
                            type: "boolean"
                          },
                          EventCategoriesList: {
                            shape: "S2c"
                          },
                          EventSubscriptionArn: {},
                          SnsTopicArn: {},
                          SourceIdsList: {
                            shape: "S2c"
                          },
                          SourceType: {},
                          Status: {},
                          SubscriptionCreationTime: {}
                        }
                      },
                      AwsEcsService: {
                        type: "structure",
                        members: {
                          CapacityProviderStrategy: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Base: {
                                  type: "integer"
                                },
                                CapacityProvider: {},
                                Weight: {
                                  type: "integer"
                                }
                              }
                            }
                          },
                          Cluster: {},
                          DeploymentConfiguration: {
                            type: "structure",
                            members: {
                              DeploymentCircuitBreaker: {
                                type: "structure",
                                members: {
                                  Enable: {
                                    type: "boolean"
                                  },
                                  Rollback: {
                                    type: "boolean"
                                  }
                                }
                              },
                              MaximumPercent: {
                                type: "integer"
                              },
                              MinimumHealthyPercent: {
                                type: "integer"
                              }
                            }
                          },
                          DeploymentController: {
                            type: "structure",
                            members: {
                              Type: {}
                            }
                          },
                          DesiredCount: {
                            type: "integer"
                          },
                          EnableEcsManagedTags: {
                            type: "boolean"
                          },
                          EnableExecuteCommand: {
                            type: "boolean"
                          },
                          HealthCheckGracePeriodSeconds: {
                            type: "integer"
                          },
                          LaunchType: {},
                          LoadBalancers: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                ContainerName: {},
                                ContainerPort: {
                                  type: "integer"
                                },
                                LoadBalancerName: {},
                                TargetGroupArn: {}
                              }
                            }
                          },
                          Name: {},
                          NetworkConfiguration: {
                            type: "structure",
                            members: {
                              AwsVpcConfiguration: {
                                type: "structure",
                                members: {
                                  AssignPublicIp: {},
                                  SecurityGroups: {
                                    shape: "S2c"
                                  },
                                  Subnets: {
                                    shape: "S2c"
                                  }
                                }
                              }
                            }
                          },
                          PlacementConstraints: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Expression: {},
                                Type: {}
                              }
                            }
                          },
                          PlacementStrategies: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Field: {},
                                Type: {}
                              }
                            }
                          },
                          PlatformVersion: {},
                          PropagateTags: {},
                          Role: {},
                          SchedulingStrategy: {},
                          ServiceArn: {},
                          ServiceName: {},
                          ServiceRegistries: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                ContainerName: {},
                                ContainerPort: {
                                  type: "integer"
                                },
                                Port: {
                                  type: "integer"
                                },
                                RegistryArn: {}
                              }
                            }
                          },
                          TaskDefinition: {}
                        }
                      },
                      AwsAutoScalingLaunchConfiguration: {
                        type: "structure",
                        members: {
                          AssociatePublicIpAddress: {
                            type: "boolean"
                          },
                          BlockDeviceMappings: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                DeviceName: {},
                                Ebs: {
                                  type: "structure",
                                  members: {
                                    DeleteOnTermination: {
                                      type: "boolean"
                                    },
                                    Encrypted: {
                                      type: "boolean"
                                    },
                                    Iops: {
                                      type: "integer"
                                    },
                                    SnapshotId: {},
                                    VolumeSize: {
                                      type: "integer"
                                    },
                                    VolumeType: {}
                                  }
                                },
                                NoDevice: {
                                  type: "boolean"
                                },
                                VirtualName: {}
                              }
                            }
                          },
                          ClassicLinkVpcId: {},
                          ClassicLinkVpcSecurityGroups: {
                            shape: "S2c"
                          },
                          CreatedTime: {},
                          EbsOptimized: {
                            type: "boolean"
                          },
                          IamInstanceProfile: {},
                          ImageId: {},
                          InstanceMonitoring: {
                            type: "structure",
                            members: {
                              Enabled: {
                                type: "boolean"
                              }
                            }
                          },
                          InstanceType: {},
                          KernelId: {},
                          KeyName: {},
                          LaunchConfigurationName: {},
                          PlacementTenancy: {},
                          RamdiskId: {},
                          SecurityGroups: {
                            shape: "S2c"
                          },
                          SpotPrice: {},
                          UserData: {}
                        }
                      },
                      AwsEc2VpnConnection: {
                        type: "structure",
                        members: {
                          VpnConnectionId: {},
                          State: {},
                          CustomerGatewayId: {},
                          CustomerGatewayConfiguration: {},
                          Type: {},
                          VpnGatewayId: {},
                          Category: {},
                          VgwTelemetry: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                AcceptedRouteCount: {
                                  type: "integer"
                                },
                                CertificateArn: {},
                                LastStatusChange: {},
                                OutsideIpAddress: {},
                                Status: {},
                                StatusMessage: {}
                              }
                            }
                          },
                          Options: {
                            type: "structure",
                            members: {
                              StaticRoutesOnly: {
                                type: "boolean"
                              },
                              TunnelOptions: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    DpdTimeoutSeconds: {
                                      type: "integer"
                                    },
                                    IkeVersions: {
                                      shape: "S2c"
                                    },
                                    OutsideIpAddress: {},
                                    Phase1DhGroupNumbers: {
                                      shape: "Scp"
                                    },
                                    Phase1EncryptionAlgorithms: {
                                      shape: "S2c"
                                    },
                                    Phase1IntegrityAlgorithms: {
                                      shape: "S2c"
                                    },
                                    Phase1LifetimeSeconds: {
                                      type: "integer"
                                    },
                                    Phase2DhGroupNumbers: {
                                      shape: "Scp"
                                    },
                                    Phase2EncryptionAlgorithms: {
                                      shape: "S2c"
                                    },
                                    Phase2IntegrityAlgorithms: {
                                      shape: "S2c"
                                    },
                                    Phase2LifetimeSeconds: {
                                      type: "integer"
                                    },
                                    PreSharedKey: {},
                                    RekeyFuzzPercentage: {
                                      type: "integer"
                                    },
                                    RekeyMarginTimeSeconds: {
                                      type: "integer"
                                    },
                                    ReplayWindowSize: {
                                      type: "integer"
                                    },
                                    TunnelInsideCidr: {}
                                  }
                                }
                              }
                            }
                          },
                          Routes: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                DestinationCidrBlock: {},
                                State: {}
                              }
                            }
                          },
                          TransitGatewayId: {}
                        }
                      },
                      AwsEcrContainerImage: {
                        type: "structure",
                        members: {
                          RegistryId: {},
                          RepositoryName: {},
                          Architecture: {},
                          ImageDigest: {},
                          ImageTags: {
                            shape: "S2c"
                          },
                          ImagePublishedAt: {}
                        }
                      },
                      AwsOpenSearchServiceDomain: {
                        type: "structure",
                        members: {
                          Arn: {},
                          AccessPolicies: {},
                          DomainName: {},
                          Id: {},
                          DomainEndpoint: {},
                          EngineVersion: {},
                          EncryptionAtRestOptions: {
                            type: "structure",
                            members: {
                              Enabled: {
                                type: "boolean"
                              },
                              KmsKeyId: {}
                            }
                          },
                          NodeToNodeEncryptionOptions: {
                            type: "structure",
                            members: {
                              Enabled: {
                                type: "boolean"
                              }
                            }
                          },
                          ServiceSoftwareOptions: {
                            type: "structure",
                            members: {
                              AutomatedUpdateDate: {},
                              Cancellable: {
                                type: "boolean"
                              },
                              CurrentVersion: {},
                              Description: {},
                              NewVersion: {},
                              UpdateAvailable: {
                                type: "boolean"
                              },
                              UpdateStatus: {},
                              OptionalDeployment: {
                                type: "boolean"
                              }
                            }
                          },
                          ClusterConfig: {
                            type: "structure",
                            members: {
                              InstanceCount: {
                                type: "integer"
                              },
                              WarmEnabled: {
                                type: "boolean"
                              },
                              WarmCount: {
                                type: "integer"
                              },
                              DedicatedMasterEnabled: {
                                type: "boolean"
                              },
                              ZoneAwarenessConfig: {
                                type: "structure",
                                members: {
                                  AvailabilityZoneCount: {
                                    type: "integer"
                                  }
                                }
                              },
                              DedicatedMasterCount: {
                                type: "integer"
                              },
                              InstanceType: {},
                              WarmType: {},
                              ZoneAwarenessEnabled: {
                                type: "boolean"
                              },
                              DedicatedMasterType: {}
                            }
                          },
                          DomainEndpointOptions: {
                            type: "structure",
                            members: {
                              CustomEndpointCertificateArn: {},
                              CustomEndpointEnabled: {
                                type: "boolean"
                              },
                              EnforceHTTPS: {
                                type: "boolean"
                              },
                              CustomEndpoint: {},
                              TLSSecurityPolicy: {}
                            }
                          },
                          VpcOptions: {
                            type: "structure",
                            members: {
                              SecurityGroupIds: {
                                shape: "S2c"
                              },
                              SubnetIds: {
                                shape: "S2c"
                              }
                            }
                          },
                          LogPublishingOptions: {
                            type: "structure",
                            members: {
                              IndexSlowLogs: {
                                shape: "Sd2"
                              },
                              SearchSlowLogs: {
                                shape: "Sd2"
                              },
                              AuditLogs: {
                                shape: "Sd2"
                              }
                            }
                          },
                          DomainEndpoints: {
                            shape: "Sr"
                          }
                        }
                      },
                      AwsEc2VpcEndpointService: {
                        type: "structure",
                        members: {
                          AcceptanceRequired: {
                            type: "boolean"
                          },
                          AvailabilityZones: {
                            shape: "S2c"
                          },
                          BaseEndpointDnsNames: {
                            shape: "S2c"
                          },
                          ManagesVpcEndpoints: {
                            type: "boolean"
                          },
                          GatewayLoadBalancerArns: {
                            shape: "S2c"
                          },
                          NetworkLoadBalancerArns: {
                            shape: "S2c"
                          },
                          PrivateDnsName: {},
                          ServiceId: {},
                          ServiceName: {},
                          ServiceState: {},
                          ServiceType: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                ServiceType: {}
                              }
                            }
                          }
                        }
                      },
                      AwsXrayEncryptionConfig: {
                        type: "structure",
                        members: {
                          KeyId: {},
                          Status: {},
                          Type: {}
                        }
                      },
                      AwsWafRateBasedRule: {
                        type: "structure",
                        members: {
                          MetricName: {},
                          Name: {},
                          RateKey: {},
                          RateLimit: {
                            type: "long"
                          },
                          RuleId: {},
                          MatchPredicates: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                DataId: {},
                                Negated: {
                                  type: "boolean"
                                },
                                Type: {}
                              }
                            }
                          }
                        }
                      },
                      AwsWafRegionalRateBasedRule: {
                        type: "structure",
                        members: {
                          MetricName: {},
                          Name: {},
                          RateKey: {},
                          RateLimit: {
                            type: "long"
                          },
                          RuleId: {},
                          MatchPredicates: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                DataId: {},
                                Negated: {
                                  type: "boolean"
                                },
                                Type: {}
                              }
                            }
                          }
                        }
                      },
                      AwsEcrRepository: {
                        type: "structure",
                        members: {
                          Arn: {},
                          ImageScanningConfiguration: {
                            type: "structure",
                            members: {
                              ScanOnPush: {
                                type: "boolean"
                              }
                            }
                          },
                          ImageTagMutability: {},
                          LifecyclePolicy: {
                            type: "structure",
                            members: {
                              LifecyclePolicyText: {},
                              RegistryId: {}
                            }
                          },
                          RepositoryName: {},
                          RepositoryPolicyText: {}
                        }
                      },
                      AwsEksCluster: {
                        type: "structure",
                        members: {
                          Arn: {},
                          CertificateAuthorityData: {},
                          ClusterStatus: {},
                          Endpoint: {},
                          Name: {},
                          ResourcesVpcConfig: {
                            type: "structure",
                            members: {
                              SecurityGroupIds: {
                                shape: "S2c"
                              },
                              SubnetIds: {
                                shape: "S2c"
                              }
                            }
                          },
                          RoleArn: {},
                          Version: {},
                          Logging: {
                            type: "structure",
                            members: {
                              ClusterLogging: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Enabled: {
                                      type: "boolean"
                                    },
                                    Types: {
                                      shape: "S2c"
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            Compliance: {
              type: "structure",
              members: {
                Status: {},
                RelatedRequirements: {
                  shape: "Sdn"
                },
                StatusReasons: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "ReasonCode"
                    ],
                    members: {
                      ReasonCode: {},
                      Description: {}
                    }
                  }
                }
              }
            },
            VerificationState: {},
            WorkflowState: {
              type: "string",
              deprecated: true,
              deprecatedMessage: "This filter is deprecated. Instead, use SeverityLabel or FindingProviderFieldsSeverityLabel."
            },
            Workflow: {
              type: "structure",
              members: {
                Status: {}
              }
            },
            RecordState: {},
            RelatedFindings: {
              shape: "Sdv"
            },
            Note: {
              type: "structure",
              required: [
                "Text",
                "UpdatedBy",
                "UpdatedAt"
              ],
              members: {
                Text: {},
                UpdatedBy: {},
                UpdatedAt: {}
              }
            },
            Vulnerabilities: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Id"
                ],
                members: {
                  Id: {},
                  VulnerablePackages: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        Version: {},
                        Epoch: {},
                        Release: {},
                        Architecture: {},
                        PackageManager: {},
                        FilePath: {}
                      }
                    }
                  },
                  Cvss: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Version: {},
                        BaseScore: {
                          type: "double"
                        },
                        BaseVector: {},
                        Source: {},
                        Adjustments: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              Metric: {},
                              Reason: {}
                            }
                          }
                        }
                      }
                    }
                  },
                  RelatedVulnerabilities: {
                    shape: "S13"
                  },
                  Vendor: {
                    type: "structure",
                    required: [
                      "Name"
                    ],
                    members: {
                      Name: {},
                      Url: {},
                      VendorSeverity: {},
                      VendorCreatedAt: {},
                      VendorUpdatedAt: {}
                    }
                  },
                  ReferenceUrls: {
                    shape: "S13"
                  }
                }
              }
            },
            PatchSummary: {
              type: "structure",
              required: [
                "Id"
              ],
              members: {
                Id: {},
                InstalledCount: {
                  type: "integer"
                },
                MissingCount: {
                  type: "integer"
                },
                FailedCount: {
                  type: "integer"
                },
                InstalledOtherCount: {
                  type: "integer"
                },
                InstalledRejectedCount: {
                  type: "integer"
                },
                InstalledPendingReboot: {
                  type: "integer"
                },
                OperationStartTime: {},
                OperationEndTime: {},
                RebootOption: {},
                Operation: {}
              }
            },
            Action: {
              type: "structure",
              members: {
                ActionType: {},
                NetworkConnectionAction: {
                  type: "structure",
                  members: {
                    ConnectionDirection: {},
                    RemoteIpDetails: {
                      shape: "Sea"
                    },
                    RemotePortDetails: {
                      type: "structure",
                      members: {
                        Port: {
                          type: "integer"
                        },
                        PortName: {}
                      }
                    },
                    LocalPortDetails: {
                      shape: "Seg"
                    },
                    Protocol: {},
                    Blocked: {
                      type: "boolean"
                    }
                  }
                },
                AwsApiCallAction: {
                  type: "structure",
                  members: {
                    Api: {},
                    ServiceName: {},
                    CallerType: {},
                    RemoteIpDetails: {
                      shape: "Sea"
                    },
                    DomainDetails: {
                      type: "structure",
                      members: {
                        Domain: {}
                      }
                    },
                    AffectedResources: {
                      shape: "Sr"
                    },
                    FirstSeen: {},
                    LastSeen: {}
                  }
                },
                DnsRequestAction: {
                  type: "structure",
                  members: {
                    Domain: {},
                    Protocol: {},
                    Blocked: {
                      type: "boolean"
                    }
                  }
                },
                PortProbeAction: {
                  type: "structure",
                  members: {
                    PortProbeDetails: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          LocalPortDetails: {
                            shape: "Seg"
                          },
                          LocalIpDetails: {
                            type: "structure",
                            members: {
                              IpAddressV4: {}
                            }
                          },
                          RemoteIpDetails: {
                            shape: "Sea"
                          }
                        }
                      }
                    },
                    Blocked: {
                      type: "boolean"
                    }
                  }
                }
              }
            },
            FindingProviderFields: {
              type: "structure",
              members: {
                Confidence: {
                  type: "integer"
                },
                Criticality: {
                  type: "integer"
                },
                RelatedFindings: {
                  shape: "Sdv"
                },
                Severity: {
                  type: "structure",
                  members: {
                    Label: {},
                    Original: {}
                  }
                },
                Types: {
                  shape: "Sk"
                }
              }
            }
          }
        },
        Sk: {
          type: "list",
          member: {}
        },
        Sr: {
          type: "map",
          key: {},
          value: {}
        },
        Sy: {
          type: "structure",
          members: {
            Begin: {
              type: "integer"
            },
            End: {
              type: "integer"
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            Protocol: {},
            Destination: {
              shape: "S12"
            },
            Source: {
              shape: "S12"
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            Address: {
              shape: "S13"
            },
            PortRanges: {
              type: "list",
              member: {
                shape: "Sy"
              }
            }
          }
        },
        S13: {
          type: "list",
          member: {}
        },
        S1m: {
          type: "structure",
          members: {
            LineRanges: {
              shape: "S1n"
            },
            OffsetRanges: {
              shape: "S1n"
            },
            Pages: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  PageNumber: {
                    type: "long"
                  },
                  LineRange: {
                    shape: "S1o"
                  },
                  OffsetRange: {
                    shape: "S1o"
                  }
                }
              }
            },
            Records: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  JsonPath: {},
                  RecordIndex: {
                    type: "long"
                  }
                }
              }
            },
            Cells: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Column: {
                    type: "long"
                  },
                  Row: {
                    type: "long"
                  },
                  ColumnName: {},
                  CellReference: {}
                }
              }
            }
          }
        },
        S1n: {
          type: "list",
          member: {
            shape: "S1o"
          }
        },
        S1o: {
          type: "structure",
          members: {
            Start: {
              type: "long"
            },
            End: {
              type: "long"
            },
            StartColumn: {
              type: "long"
            }
          }
        },
        S2c: {
          type: "list",
          member: {}
        },
        S36: {
          type: "list",
          member: {
            type: "structure",
            members: {
              IpProtocol: {},
              FromPort: {
                type: "integer"
              },
              ToPort: {
                type: "integer"
              },
              UserIdGroupPairs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GroupId: {},
                    GroupName: {},
                    PeeringStatus: {},
                    UserId: {},
                    VpcId: {},
                    VpcPeeringConnectionId: {}
                  }
                }
              },
              IpRanges: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CidrIp: {}
                  }
                }
              },
              Ipv6Ranges: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CidrIpv6: {}
                  }
                }
              },
              PrefixListIds: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PrefixListId: {}
                  }
                }
              }
            }
          }
        },
        S3m: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AssociationId: {},
              Ipv6CidrBlock: {},
              CidrBlockState: {}
            }
          }
        },
        S4g: {
          type: "structure",
          members: {
            CloudWatchLogsLogGroupArn: {},
            Enabled: {
              type: "boolean"
            }
          }
        },
        S53: {
          type: "structure",
          members: {
            BlockPublicAcls: {
              type: "boolean"
            },
            BlockPublicPolicy: {
              type: "boolean"
            },
            IgnorePublicAcls: {
              type: "boolean"
            },
            RestrictPublicBuckets: {
              type: "boolean"
            }
          }
        },
        S5t: {
          type: "list",
          member: {
            type: "structure",
            members: {
              PolicyName: {},
              PolicyArn: {}
            }
          }
        },
        S5v: {
          type: "structure",
          members: {
            PermissionsBoundaryArn: {},
            PermissionsBoundaryType: {}
          }
        },
        S62: {
          type: "structure",
          members: {
            DetailedMetricsEnabled: {
              type: "boolean"
            },
            LoggingLevel: {},
            DataTraceEnabled: {
              type: "boolean"
            },
            ThrottlingBurstLimit: {
              type: "integer"
            },
            ThrottlingRateLimit: {
              type: "double"
            }
          }
        },
        S63: {
          type: "structure",
          members: {
            Format: {},
            DestinationArn: {}
          }
        },
        S6d: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AttributeName: {},
              KeyType: {}
            }
          }
        },
        S6f: {
          type: "structure",
          members: {
            NonKeyAttributes: {
              shape: "S13"
            },
            ProjectionType: {}
          }
        },
        S6g: {
          type: "structure",
          members: {
            LastDecreaseDateTime: {},
            LastIncreaseDateTime: {},
            NumberOfDecreasesToday: {
              type: "integer"
            },
            ReadCapacityUnits: {
              type: "integer"
            },
            WriteCapacityUnits: {
              type: "integer"
            }
          }
        },
        S6n: {
          type: "structure",
          members: {
            ReadCapacityUnits: {
              type: "integer"
            }
          }
        },
        S72: {
          type: "list",
          member: {
            type: "structure",
            members: {
              DomainName: {},
              ResourceRecord: {
                type: "structure",
                members: {
                  Name: {},
                  Type: {},
                  Value: {}
                }
              },
              ValidationDomain: {},
              ValidationEmails: {
                shape: "S13"
              },
              ValidationMethod: {},
              ValidationStatus: {}
            }
          }
        },
        S97: {
          type: "structure",
          members: {
            Address: {},
            Port: {
              type: "integer"
            },
            HostedZoneId: {}
          }
        },
        S98: {
          type: "list",
          member: {
            type: "structure",
            members: {
              VpcSecurityGroupId: {},
              Status: {}
            }
          }
        },
        S9i: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        S9o: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Domain: {},
              Status: {},
              Fqdn: {},
              IamRoleName: {}
            }
          }
        },
        Scp: {
          type: "list",
          member: {
            type: "integer"
          }
        },
        Sd2: {
          type: "structure",
          members: {
            CloudWatchLogsLogGroupArn: {},
            Enabled: {
              type: "boolean"
            }
          }
        },
        Sdn: {
          type: "list",
          member: {}
        },
        Sdv: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ProductArn",
              "Id"
            ],
            members: {
              ProductArn: {},
              Id: {}
            }
          }
        },
        Sea: {
          type: "structure",
          members: {
            IpAddressV4: {},
            Organization: {
              type: "structure",
              members: {
                Asn: {
                  type: "integer"
                },
                AsnOrg: {},
                Isp: {},
                Org: {}
              }
            },
            Country: {
              type: "structure",
              members: {
                CountryCode: {},
                CountryName: {}
              }
            },
            City: {
              type: "structure",
              members: {
                CityName: {}
              }
            },
            GeoLocation: {
              type: "structure",
              members: {
                Lon: {
                  type: "double"
                },
                Lat: {
                  type: "double"
                }
              }
            }
          }
        },
        Seg: {
          type: "structure",
          members: {
            Port: {
              type: "integer"
            },
            PortName: {}
          }
        },
        Sev: {
          type: "list",
          member: {
            shape: "Sew"
          }
        },
        Sew: {
          type: "structure",
          required: [
            "Id",
            "ProductArn"
          ],
          members: {
            Id: {},
            ProductArn: {}
          }
        },
        Sex: {
          type: "structure",
          required: [
            "Text",
            "UpdatedBy"
          ],
          members: {
            Text: {},
            UpdatedBy: {}
          }
        },
        Sf6: {
          type: "structure",
          members: {
            ProductArn: {
              shape: "Sf7"
            },
            AwsAccountId: {
              shape: "Sf7"
            },
            Id: {
              shape: "Sf7"
            },
            GeneratorId: {
              shape: "Sf7"
            },
            Region: {
              shape: "Sf7"
            },
            Type: {
              shape: "Sf7"
            },
            FirstObservedAt: {
              shape: "Sfa"
            },
            LastObservedAt: {
              shape: "Sfa"
            },
            CreatedAt: {
              shape: "Sfa"
            },
            UpdatedAt: {
              shape: "Sfa"
            },
            SeverityProduct: {
              shape: "Sfe",
              deprecated: true,
              deprecatedMessage: "This filter is deprecated. Instead, use FindingProviderSeverityOriginal."
            },
            SeverityNormalized: {
              shape: "Sfe",
              deprecated: true,
              deprecatedMessage: "This filter is deprecated. Instead, use SeverityLabel or FindingProviderFieldsSeverityLabel."
            },
            SeverityLabel: {
              shape: "Sf7"
            },
            Confidence: {
              shape: "Sfe"
            },
            Criticality: {
              shape: "Sfe"
            },
            Title: {
              shape: "Sf7"
            },
            Description: {
              shape: "Sf7"
            },
            RecommendationText: {
              shape: "Sf7"
            },
            SourceUrl: {
              shape: "Sf7"
            },
            ProductFields: {
              shape: "Sfg"
            },
            ProductName: {
              shape: "Sf7"
            },
            CompanyName: {
              shape: "Sf7"
            },
            UserDefinedFields: {
              shape: "Sfg"
            },
            MalwareName: {
              shape: "Sf7"
            },
            MalwareType: {
              shape: "Sf7"
            },
            MalwarePath: {
              shape: "Sf7"
            },
            MalwareState: {
              shape: "Sf7"
            },
            NetworkDirection: {
              shape: "Sf7"
            },
            NetworkProtocol: {
              shape: "Sf7"
            },
            NetworkSourceIpV4: {
              shape: "Sfj"
            },
            NetworkSourceIpV6: {
              shape: "Sfj"
            },
            NetworkSourcePort: {
              shape: "Sfe"
            },
            NetworkSourceDomain: {
              shape: "Sf7"
            },
            NetworkSourceMac: {
              shape: "Sf7"
            },
            NetworkDestinationIpV4: {
              shape: "Sfj"
            },
            NetworkDestinationIpV6: {
              shape: "Sfj"
            },
            NetworkDestinationPort: {
              shape: "Sfe"
            },
            NetworkDestinationDomain: {
              shape: "Sf7"
            },
            ProcessName: {
              shape: "Sf7"
            },
            ProcessPath: {
              shape: "Sf7"
            },
            ProcessPid: {
              shape: "Sfe"
            },
            ProcessParentPid: {
              shape: "Sfe"
            },
            ProcessLaunchedAt: {
              shape: "Sfa"
            },
            ProcessTerminatedAt: {
              shape: "Sfa"
            },
            ThreatIntelIndicatorType: {
              shape: "Sf7"
            },
            ThreatIntelIndicatorValue: {
              shape: "Sf7"
            },
            ThreatIntelIndicatorCategory: {
              shape: "Sf7"
            },
            ThreatIntelIndicatorLastObservedAt: {
              shape: "Sfa"
            },
            ThreatIntelIndicatorSource: {
              shape: "Sf7"
            },
            ThreatIntelIndicatorSourceUrl: {
              shape: "Sf7"
            },
            ResourceType: {
              shape: "Sf7"
            },
            ResourceId: {
              shape: "Sf7"
            },
            ResourcePartition: {
              shape: "Sf7"
            },
            ResourceRegion: {
              shape: "Sf7"
            },
            ResourceTags: {
              shape: "Sfg"
            },
            ResourceAwsEc2InstanceType: {
              shape: "Sf7"
            },
            ResourceAwsEc2InstanceImageId: {
              shape: "Sf7"
            },
            ResourceAwsEc2InstanceIpV4Addresses: {
              shape: "Sfj"
            },
            ResourceAwsEc2InstanceIpV6Addresses: {
              shape: "Sfj"
            },
            ResourceAwsEc2InstanceKeyName: {
              shape: "Sf7"
            },
            ResourceAwsEc2InstanceIamInstanceProfileArn: {
              shape: "Sf7"
            },
            ResourceAwsEc2InstanceVpcId: {
              shape: "Sf7"
            },
            ResourceAwsEc2InstanceSubnetId: {
              shape: "Sf7"
            },
            ResourceAwsEc2InstanceLaunchedAt: {
              shape: "Sfa"
            },
            ResourceAwsS3BucketOwnerId: {
              shape: "Sf7"
            },
            ResourceAwsS3BucketOwnerName: {
              shape: "Sf7"
            },
            ResourceAwsIamAccessKeyUserName: {
              shape: "Sf7",
              deprecated: true,
              deprecatedMessage: "This filter is deprecated. Instead, use ResourceAwsIamAccessKeyPrincipalName."
            },
            ResourceAwsIamAccessKeyPrincipalName: {
              shape: "Sf7"
            },
            ResourceAwsIamAccessKeyStatus: {
              shape: "Sf7"
            },
            ResourceAwsIamAccessKeyCreatedAt: {
              shape: "Sfa"
            },
            ResourceAwsIamUserUserName: {
              shape: "Sf7"
            },
            ResourceContainerName: {
              shape: "Sf7"
            },
            ResourceContainerImageId: {
              shape: "Sf7"
            },
            ResourceContainerImageName: {
              shape: "Sf7"
            },
            ResourceContainerLaunchedAt: {
              shape: "Sfa"
            },
            ResourceDetailsOther: {
              shape: "Sfg"
            },
            ComplianceStatus: {
              shape: "Sf7"
            },
            VerificationState: {
              shape: "Sf7"
            },
            WorkflowState: {
              shape: "Sf7"
            },
            WorkflowStatus: {
              shape: "Sf7"
            },
            RecordState: {
              shape: "Sf7"
            },
            RelatedFindingsProductArn: {
              shape: "Sf7"
            },
            RelatedFindingsId: {
              shape: "Sf7"
            },
            NoteText: {
              shape: "Sf7"
            },
            NoteUpdatedAt: {
              shape: "Sfa"
            },
            NoteUpdatedBy: {
              shape: "Sf7"
            },
            Keyword: {
              deprecated: true,
              deprecatedMessage: "The Keyword property is deprecated.",
              type: "list",
              member: {
                type: "structure",
                members: {
                  Value: {}
                }
              }
            },
            FindingProviderFieldsConfidence: {
              shape: "Sfe"
            },
            FindingProviderFieldsCriticality: {
              shape: "Sfe"
            },
            FindingProviderFieldsRelatedFindingsId: {
              shape: "Sf7"
            },
            FindingProviderFieldsRelatedFindingsProductArn: {
              shape: "Sf7"
            },
            FindingProviderFieldsSeverityLabel: {
              shape: "Sf7"
            },
            FindingProviderFieldsSeverityOriginal: {
              shape: "Sf7"
            },
            FindingProviderFieldsTypes: {
              shape: "Sf7"
            }
          }
        },
        Sf7: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Value: {},
              Comparison: {}
            }
          }
        },
        Sfa: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Start: {},
              End: {},
              DateRange: {
                type: "structure",
                members: {
                  Value: {
                    type: "integer"
                  },
                  Unit: {}
                }
              }
            }
          }
        },
        Sfe: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Gte: {
                type: "double"
              },
              Lte: {
                type: "double"
              },
              Eq: {
                type: "double"
              }
            }
          }
        },
        Sfg: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {},
              Comparison: {}
            }
          }
        },
        Sfj: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Cidr: {}
            }
          }
        },
        Sft: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AccountId: {},
              ProcessingResult: {}
            }
          }
        },
        Sfw: {
          type: "list",
          member: {}
        },
        Sg7: {
          type: "list",
          member: {}
        },
        Sgx: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Shg: {
          type: "map",
          key: {},
          value: {}
        },
        Shm: {
          type: "structure",
          members: {
            AccountId: {},
            InvitationId: {},
            InvitedAt: {
              shape: "Sgx"
            },
            MemberStatus: {}
          }
        },
        Sia: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AccountId: {},
              Email: {},
              MasterId: {
                deprecated: true,
                deprecatedMessage: "This field is deprecated, use AdministratorId instead."
              },
              AdministratorId: {},
              MemberStatus: {},
              InvitedAt: {
                shape: "Sgx"
              },
              UpdatedAt: {
                shape: "Sgx"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/securityhub-2018-10-26.paginators.json
var require_securityhub_2018_10_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/securityhub-2018-10-26.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeActionTargets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ActionTargets"
        },
        DescribeProducts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Products"
        },
        DescribeStandards: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Standards"
        },
        DescribeStandardsControls: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Controls"
        },
        GetEnabledStandards: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "StandardsSubscriptions"
        },
        GetFindings: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Findings"
        },
        GetInsights: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Insights"
        },
        ListEnabledProductsForImport: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ProductSubscriptions"
        },
        ListInvitations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Invitations"
        },
        ListMembers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Members"
        },
        ListOrganizationAdminAccounts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "AdminAccounts"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/securityhub.js
var require_securityhub = __commonJS({
  "node_modules/aws-sdk/clients/securityhub.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["securityhub"] = {};
    AWS3.SecurityHub = Service.defineService("securityhub", ["2018-10-26"]);
    Object.defineProperty(apiLoader.services["securityhub"], "2018-10-26", {
      get: function get() {
        var model = require_securityhub_2018_10_26_min();
        model.paginators = require_securityhub_2018_10_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SecurityHub;
  }
});

// node_modules/aws-sdk/apis/appmesh-2018-10-01.min.json
var require_appmesh_2018_10_01_min = __commonJS({
  "node_modules/aws-sdk/apis/appmesh-2018-10-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-10-01",
        endpointPrefix: "appmesh",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS App Mesh",
        serviceId: "App Mesh",
        signatureVersion: "v4",
        signingName: "appmesh",
        uid: "appmesh-2018-10-01"
      },
      operations: {
        CreateMesh: {
          http: {
            method: "PUT",
            requestUri: "/meshes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              mesh: {
                shape: "S5"
              }
            },
            payload: "mesh"
          },
          idempotent: true
        },
        CreateRoute: {
          http: {
            method: "PUT",
            requestUri: "/meshes/{meshName}/virtualRouter/{virtualRouterName}/routes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "routeName",
              "spec",
              "virtualRouterName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              routeName: {},
              spec: {
                shape: "Sd"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              route: {
                shape: "Sl"
              }
            },
            payload: "route"
          },
          idempotent: true
        },
        CreateVirtualNode: {
          http: {
            method: "PUT",
            requestUri: "/meshes/{meshName}/virtualNodes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualNodeName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              spec: {
                shape: "Sp"
              },
              virtualNodeName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              virtualNode: {
                shape: "S14"
              }
            },
            payload: "virtualNode"
          },
          idempotent: true
        },
        CreateVirtualRouter: {
          http: {
            method: "PUT",
            requestUri: "/meshes/{meshName}/virtualRouters",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualRouterName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              spec: {
                shape: "S18"
              },
              virtualRouterName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              virtualRouter: {
                shape: "S1b"
              }
            },
            payload: "virtualRouter"
          },
          idempotent: true
        },
        DeleteMesh: {
          http: {
            method: "DELETE",
            requestUri: "/meshes/{meshName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              mesh: {
                shape: "S5"
              }
            },
            payload: "mesh"
          },
          idempotent: true
        },
        DeleteRoute: {
          http: {
            method: "DELETE",
            requestUri: "/meshes/{meshName}/virtualRouter/{virtualRouterName}/routes/{routeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "routeName",
              "virtualRouterName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              routeName: {
                location: "uri",
                locationName: "routeName"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              route: {
                shape: "Sl"
              }
            },
            payload: "route"
          },
          idempotent: true
        },
        DeleteVirtualNode: {
          http: {
            method: "DELETE",
            requestUri: "/meshes/{meshName}/virtualNodes/{virtualNodeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualNodeName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              virtualNodeName: {
                location: "uri",
                locationName: "virtualNodeName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualNode: {
                shape: "S14"
              }
            },
            payload: "virtualNode"
          },
          idempotent: true
        },
        DeleteVirtualRouter: {
          http: {
            method: "DELETE",
            requestUri: "/meshes/{meshName}/virtualRouters/{virtualRouterName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualRouterName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualRouter: {
                shape: "S1b"
              }
            },
            payload: "virtualRouter"
          },
          idempotent: true
        },
        DescribeMesh: {
          http: {
            method: "GET",
            requestUri: "/meshes/{meshName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              mesh: {
                shape: "S5"
              }
            },
            payload: "mesh"
          }
        },
        DescribeRoute: {
          http: {
            method: "GET",
            requestUri: "/meshes/{meshName}/virtualRouter/{virtualRouterName}/routes/{routeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "routeName",
              "virtualRouterName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              routeName: {
                location: "uri",
                locationName: "routeName"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              route: {
                shape: "Sl"
              }
            },
            payload: "route"
          }
        },
        DescribeVirtualNode: {
          http: {
            method: "GET",
            requestUri: "/meshes/{meshName}/virtualNodes/{virtualNodeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualNodeName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              virtualNodeName: {
                location: "uri",
                locationName: "virtualNodeName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualNode: {
                shape: "S14"
              }
            },
            payload: "virtualNode"
          }
        },
        DescribeVirtualRouter: {
          http: {
            method: "GET",
            requestUri: "/meshes/{meshName}/virtualRouters/{virtualRouterName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualRouterName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualRouter: {
                shape: "S1b"
              }
            },
            payload: "virtualRouter"
          }
        },
        ListMeshes: {
          http: {
            method: "GET",
            requestUri: "/meshes",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "meshes"
            ],
            members: {
              meshes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    meshName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRoutes: {
          http: {
            method: "GET",
            requestUri: "/meshes/{meshName}/virtualRouter/{virtualRouterName}/routes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualRouterName"
            ],
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "routes"
            ],
            members: {
              nextToken: {},
              routes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    meshName: {},
                    routeName: {},
                    virtualRouterName: {}
                  }
                }
              }
            }
          }
        },
        ListVirtualNodes: {
          http: {
            method: "GET",
            requestUri: "/meshes/{meshName}/virtualNodes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualNodes"
            ],
            members: {
              nextToken: {},
              virtualNodes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    meshName: {},
                    virtualNodeName: {}
                  }
                }
              }
            }
          }
        },
        ListVirtualRouters: {
          http: {
            method: "GET",
            requestUri: "/meshes/{meshName}/virtualRouters",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualRouters"
            ],
            members: {
              nextToken: {},
              virtualRouters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    meshName: {},
                    virtualRouterName: {}
                  }
                }
              }
            }
          }
        },
        UpdateRoute: {
          http: {
            method: "PUT",
            requestUri: "/meshes/{meshName}/virtualRouter/{virtualRouterName}/routes/{routeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "routeName",
              "spec",
              "virtualRouterName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              routeName: {
                location: "uri",
                locationName: "routeName"
              },
              spec: {
                shape: "Sd"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              route: {
                shape: "Sl"
              }
            },
            payload: "route"
          },
          idempotent: true
        },
        UpdateVirtualNode: {
          http: {
            method: "PUT",
            requestUri: "/meshes/{meshName}/virtualNodes/{virtualNodeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualNodeName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              spec: {
                shape: "Sp"
              },
              virtualNodeName: {
                location: "uri",
                locationName: "virtualNodeName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualNode: {
                shape: "S14"
              }
            },
            payload: "virtualNode"
          },
          idempotent: true
        },
        UpdateVirtualRouter: {
          http: {
            method: "PUT",
            requestUri: "/meshes/{meshName}/virtualRouters/{virtualRouterName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualRouterName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              spec: {
                shape: "S18"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualRouter: {
                shape: "S1b"
              }
            },
            payload: "virtualRouter"
          },
          idempotent: true
        }
      },
      shapes: {
        S5: {
          type: "structure",
          required: [
            "meshName",
            "metadata"
          ],
          members: {
            meshName: {},
            metadata: {
              shape: "S6"
            },
            status: {
              type: "structure",
              members: {
                status: {}
              }
            }
          }
        },
        S6: {
          type: "structure",
          members: {
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            lastUpdatedAt: {
              type: "timestamp"
            },
            uid: {},
            version: {
              type: "long"
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            httpRoute: {
              type: "structure",
              members: {
                action: {
                  type: "structure",
                  members: {
                    weightedTargets: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          virtualNode: {},
                          weight: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  }
                },
                match: {
                  type: "structure",
                  members: {
                    prefix: {}
                  }
                }
              }
            }
          }
        },
        Sl: {
          type: "structure",
          required: [
            "meshName",
            "routeName",
            "virtualRouterName"
          ],
          members: {
            meshName: {},
            metadata: {
              shape: "S6"
            },
            routeName: {},
            spec: {
              shape: "Sd"
            },
            status: {
              type: "structure",
              members: {
                status: {}
              }
            },
            virtualRouterName: {}
          }
        },
        Sp: {
          type: "structure",
          members: {
            backends: {
              type: "list",
              member: {}
            },
            listeners: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  healthCheck: {
                    type: "structure",
                    required: [
                      "healthyThreshold",
                      "intervalMillis",
                      "protocol",
                      "timeoutMillis",
                      "unhealthyThreshold"
                    ],
                    members: {
                      healthyThreshold: {
                        type: "integer"
                      },
                      intervalMillis: {
                        type: "long"
                      },
                      path: {},
                      port: {
                        type: "integer"
                      },
                      protocol: {},
                      timeoutMillis: {
                        type: "long"
                      },
                      unhealthyThreshold: {
                        type: "integer"
                      }
                    }
                  },
                  portMapping: {
                    type: "structure",
                    members: {
                      port: {
                        type: "integer"
                      },
                      protocol: {}
                    }
                  }
                }
              }
            },
            serviceDiscovery: {
              type: "structure",
              members: {
                dns: {
                  type: "structure",
                  members: {
                    serviceName: {}
                  }
                }
              }
            }
          }
        },
        S14: {
          type: "structure",
          required: [
            "meshName",
            "virtualNodeName"
          ],
          members: {
            meshName: {},
            metadata: {
              shape: "S6"
            },
            spec: {
              shape: "Sp"
            },
            status: {
              type: "structure",
              members: {
                status: {}
              }
            },
            virtualNodeName: {}
          }
        },
        S18: {
          type: "structure",
          members: {
            serviceNames: {
              type: "list",
              member: {}
            }
          }
        },
        S1b: {
          type: "structure",
          required: [
            "meshName",
            "virtualRouterName"
          ],
          members: {
            meshName: {},
            metadata: {
              shape: "S6"
            },
            spec: {
              shape: "S18"
            },
            status: {
              type: "structure",
              members: {
                status: {}
              }
            },
            virtualRouterName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/appmesh-2018-10-01.paginators.json
var require_appmesh_2018_10_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/appmesh-2018-10-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListMeshes: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "meshes"
        },
        ListRoutes: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "routes"
        },
        ListVirtualNodes: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "virtualNodes"
        },
        ListVirtualRouters: {
          input_token: "nextToken",
          limit_key: "limit",
          output_token: "nextToken",
          result_key: "virtualRouters"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/appmesh-2019-01-25.min.json
var require_appmesh_2019_01_25_min = __commonJS({
  "node_modules/aws-sdk/apis/appmesh-2019-01-25.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-01-25",
        endpointPrefix: "appmesh",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS App Mesh",
        serviceId: "App Mesh",
        signatureVersion: "v4",
        signingName: "appmesh",
        uid: "appmesh-2019-01-25"
      },
      operations: {
        CreateGatewayRoute: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualGateway/{virtualGatewayName}/gatewayRoutes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "gatewayRouteName",
              "meshName",
              "spec",
              "virtualGatewayName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              gatewayRouteName: {},
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              spec: {
                shape: "S5"
              },
              tags: {
                shape: "S19"
              },
              virtualGatewayName: {
                location: "uri",
                locationName: "virtualGatewayName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "gatewayRoute"
            ],
            members: {
              gatewayRoute: {
                shape: "S1e"
              }
            },
            payload: "gatewayRoute"
          },
          idempotent: true
        },
        CreateMesh: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {},
              spec: {
                shape: "S1l"
              },
              tags: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "mesh"
            ],
            members: {
              mesh: {
                shape: "S1p"
              }
            },
            payload: "mesh"
          },
          idempotent: true
        },
        CreateRoute: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualRouter/{virtualRouterName}/routes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "routeName",
              "spec",
              "virtualRouterName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              routeName: {},
              spec: {
                shape: "S1t"
              },
              tags: {
                shape: "S19"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "route"
            ],
            members: {
              route: {
                shape: "S2t"
              }
            },
            payload: "route"
          },
          idempotent: true
        },
        CreateVirtualGateway: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualGateways",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualGatewayName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              spec: {
                shape: "S2x"
              },
              tags: {
                shape: "S19"
              },
              virtualGatewayName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualGateway"
            ],
            members: {
              virtualGateway: {
                shape: "S47"
              }
            },
            payload: "virtualGateway"
          },
          idempotent: true
        },
        CreateVirtualNode: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualNodes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualNodeName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              spec: {
                shape: "S4b"
              },
              tags: {
                shape: "S19"
              },
              virtualNodeName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualNode"
            ],
            members: {
              virtualNode: {
                shape: "S5t"
              }
            },
            payload: "virtualNode"
          },
          idempotent: true
        },
        CreateVirtualRouter: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualRouters",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualRouterName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              spec: {
                shape: "S5x"
              },
              tags: {
                shape: "S19"
              },
              virtualRouterName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualRouter"
            ],
            members: {
              virtualRouter: {
                shape: "S61"
              }
            },
            payload: "virtualRouter"
          },
          idempotent: true
        },
        CreateVirtualService: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualServices",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualServiceName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              spec: {
                shape: "S65"
              },
              tags: {
                shape: "S19"
              },
              virtualServiceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualService"
            ],
            members: {
              virtualService: {
                shape: "S6a"
              }
            },
            payload: "virtualService"
          },
          idempotent: true
        },
        DeleteGatewayRoute: {
          http: {
            method: "DELETE",
            requestUri: "/v20190125/meshes/{meshName}/virtualGateway/{virtualGatewayName}/gatewayRoutes/{gatewayRouteName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "gatewayRouteName",
              "meshName",
              "virtualGatewayName"
            ],
            members: {
              gatewayRouteName: {
                location: "uri",
                locationName: "gatewayRouteName"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              virtualGatewayName: {
                location: "uri",
                locationName: "virtualGatewayName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "gatewayRoute"
            ],
            members: {
              gatewayRoute: {
                shape: "S1e"
              }
            },
            payload: "gatewayRoute"
          },
          idempotent: true
        },
        DeleteMesh: {
          http: {
            method: "DELETE",
            requestUri: "/v20190125/meshes/{meshName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "mesh"
            ],
            members: {
              mesh: {
                shape: "S1p"
              }
            },
            payload: "mesh"
          },
          idempotent: true
        },
        DeleteRoute: {
          http: {
            method: "DELETE",
            requestUri: "/v20190125/meshes/{meshName}/virtualRouter/{virtualRouterName}/routes/{routeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "routeName",
              "virtualRouterName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              routeName: {
                location: "uri",
                locationName: "routeName"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "route"
            ],
            members: {
              route: {
                shape: "S2t"
              }
            },
            payload: "route"
          },
          idempotent: true
        },
        DeleteVirtualGateway: {
          http: {
            method: "DELETE",
            requestUri: "/v20190125/meshes/{meshName}/virtualGateways/{virtualGatewayName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualGatewayName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              virtualGatewayName: {
                location: "uri",
                locationName: "virtualGatewayName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualGateway"
            ],
            members: {
              virtualGateway: {
                shape: "S47"
              }
            },
            payload: "virtualGateway"
          },
          idempotent: true
        },
        DeleteVirtualNode: {
          http: {
            method: "DELETE",
            requestUri: "/v20190125/meshes/{meshName}/virtualNodes/{virtualNodeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualNodeName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              virtualNodeName: {
                location: "uri",
                locationName: "virtualNodeName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualNode"
            ],
            members: {
              virtualNode: {
                shape: "S5t"
              }
            },
            payload: "virtualNode"
          },
          idempotent: true
        },
        DeleteVirtualRouter: {
          http: {
            method: "DELETE",
            requestUri: "/v20190125/meshes/{meshName}/virtualRouters/{virtualRouterName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualRouterName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualRouter"
            ],
            members: {
              virtualRouter: {
                shape: "S61"
              }
            },
            payload: "virtualRouter"
          },
          idempotent: true
        },
        DeleteVirtualService: {
          http: {
            method: "DELETE",
            requestUri: "/v20190125/meshes/{meshName}/virtualServices/{virtualServiceName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualServiceName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              virtualServiceName: {
                location: "uri",
                locationName: "virtualServiceName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualService"
            ],
            members: {
              virtualService: {
                shape: "S6a"
              }
            },
            payload: "virtualService"
          },
          idempotent: true
        },
        DescribeGatewayRoute: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualGateway/{virtualGatewayName}/gatewayRoutes/{gatewayRouteName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "gatewayRouteName",
              "meshName",
              "virtualGatewayName"
            ],
            members: {
              gatewayRouteName: {
                location: "uri",
                locationName: "gatewayRouteName"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              virtualGatewayName: {
                location: "uri",
                locationName: "virtualGatewayName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "gatewayRoute"
            ],
            members: {
              gatewayRoute: {
                shape: "S1e"
              }
            },
            payload: "gatewayRoute"
          }
        },
        DescribeMesh: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "mesh"
            ],
            members: {
              mesh: {
                shape: "S1p"
              }
            },
            payload: "mesh"
          }
        },
        DescribeRoute: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualRouter/{virtualRouterName}/routes/{routeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "routeName",
              "virtualRouterName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              routeName: {
                location: "uri",
                locationName: "routeName"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "route"
            ],
            members: {
              route: {
                shape: "S2t"
              }
            },
            payload: "route"
          }
        },
        DescribeVirtualGateway: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualGateways/{virtualGatewayName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualGatewayName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              virtualGatewayName: {
                location: "uri",
                locationName: "virtualGatewayName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualGateway"
            ],
            members: {
              virtualGateway: {
                shape: "S47"
              }
            },
            payload: "virtualGateway"
          }
        },
        DescribeVirtualNode: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualNodes/{virtualNodeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualNodeName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              virtualNodeName: {
                location: "uri",
                locationName: "virtualNodeName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualNode"
            ],
            members: {
              virtualNode: {
                shape: "S5t"
              }
            },
            payload: "virtualNode"
          }
        },
        DescribeVirtualRouter: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualRouters/{virtualRouterName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualRouterName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualRouter"
            ],
            members: {
              virtualRouter: {
                shape: "S61"
              }
            },
            payload: "virtualRouter"
          }
        },
        DescribeVirtualService: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualServices/{virtualServiceName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualServiceName"
            ],
            members: {
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              virtualServiceName: {
                location: "uri",
                locationName: "virtualServiceName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualService"
            ],
            members: {
              virtualService: {
                shape: "S6a"
              }
            },
            payload: "virtualService"
          }
        },
        ListGatewayRoutes: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualGateway/{virtualGatewayName}/gatewayRoutes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualGatewayName"
            ],
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              virtualGatewayName: {
                location: "uri",
                locationName: "virtualGatewayName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "gatewayRoutes"
            ],
            members: {
              gatewayRoutes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "gatewayRouteName",
                    "lastUpdatedAt",
                    "meshName",
                    "meshOwner",
                    "resourceOwner",
                    "version",
                    "virtualGatewayName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    gatewayRouteName: {},
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    meshName: {},
                    meshOwner: {},
                    resourceOwner: {},
                    version: {
                      type: "long"
                    },
                    virtualGatewayName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListMeshes: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "meshes"
            ],
            members: {
              meshes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastUpdatedAt",
                    "meshName",
                    "meshOwner",
                    "resourceOwner",
                    "version"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    meshName: {},
                    meshOwner: {},
                    resourceOwner: {},
                    version: {
                      type: "long"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRoutes: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualRouter/{virtualRouterName}/routes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "virtualRouterName"
            ],
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "routes"
            ],
            members: {
              nextToken: {},
              routes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastUpdatedAt",
                    "meshName",
                    "meshOwner",
                    "resourceOwner",
                    "routeName",
                    "version",
                    "virtualRouterName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    meshName: {},
                    meshOwner: {},
                    resourceOwner: {},
                    routeName: {},
                    version: {
                      type: "long"
                    },
                    virtualRouterName: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/v20190125/tags",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              nextToken: {},
              tags: {
                shape: "S19"
              }
            }
          }
        },
        ListVirtualGateways: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualGateways",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualGateways"
            ],
            members: {
              nextToken: {},
              virtualGateways: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastUpdatedAt",
                    "meshName",
                    "meshOwner",
                    "resourceOwner",
                    "version",
                    "virtualGatewayName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    meshName: {},
                    meshOwner: {},
                    resourceOwner: {},
                    version: {
                      type: "long"
                    },
                    virtualGatewayName: {}
                  }
                }
              }
            }
          }
        },
        ListVirtualNodes: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualNodes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualNodes"
            ],
            members: {
              nextToken: {},
              virtualNodes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastUpdatedAt",
                    "meshName",
                    "meshOwner",
                    "resourceOwner",
                    "version",
                    "virtualNodeName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    meshName: {},
                    meshOwner: {},
                    resourceOwner: {},
                    version: {
                      type: "long"
                    },
                    virtualNodeName: {}
                  }
                }
              }
            }
          }
        },
        ListVirtualRouters: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualRouters",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualRouters"
            ],
            members: {
              nextToken: {},
              virtualRouters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastUpdatedAt",
                    "meshName",
                    "meshOwner",
                    "resourceOwner",
                    "version",
                    "virtualRouterName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    meshName: {},
                    meshOwner: {},
                    resourceOwner: {},
                    version: {
                      type: "long"
                    },
                    virtualRouterName: {}
                  }
                }
              }
            }
          }
        },
        ListVirtualServices: {
          http: {
            method: "GET",
            requestUri: "/v20190125/meshes/{meshName}/virtualServices",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualServices"
            ],
            members: {
              nextToken: {},
              virtualServices: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastUpdatedAt",
                    "meshName",
                    "meshOwner",
                    "resourceOwner",
                    "version",
                    "virtualServiceName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    meshName: {},
                    meshOwner: {},
                    resourceOwner: {},
                    version: {
                      type: "long"
                    },
                    virtualServiceName: {}
                  }
                }
              }
            }
          }
        },
        TagResource: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/tag",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/untag",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateGatewayRoute: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualGateway/{virtualGatewayName}/gatewayRoutes/{gatewayRouteName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "gatewayRouteName",
              "meshName",
              "spec",
              "virtualGatewayName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              gatewayRouteName: {
                location: "uri",
                locationName: "gatewayRouteName"
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              spec: {
                shape: "S5"
              },
              virtualGatewayName: {
                location: "uri",
                locationName: "virtualGatewayName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "gatewayRoute"
            ],
            members: {
              gatewayRoute: {
                shape: "S1e"
              }
            },
            payload: "gatewayRoute"
          },
          idempotent: true
        },
        UpdateMesh: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              spec: {
                shape: "S1l"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "mesh"
            ],
            members: {
              mesh: {
                shape: "S1p"
              }
            },
            payload: "mesh"
          },
          idempotent: true
        },
        UpdateRoute: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualRouter/{virtualRouterName}/routes/{routeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "routeName",
              "spec",
              "virtualRouterName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              routeName: {
                location: "uri",
                locationName: "routeName"
              },
              spec: {
                shape: "S1t"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "route"
            ],
            members: {
              route: {
                shape: "S2t"
              }
            },
            payload: "route"
          },
          idempotent: true
        },
        UpdateVirtualGateway: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualGateways/{virtualGatewayName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualGatewayName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              spec: {
                shape: "S2x"
              },
              virtualGatewayName: {
                location: "uri",
                locationName: "virtualGatewayName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualGateway"
            ],
            members: {
              virtualGateway: {
                shape: "S47"
              }
            },
            payload: "virtualGateway"
          },
          idempotent: true
        },
        UpdateVirtualNode: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualNodes/{virtualNodeName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualNodeName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              spec: {
                shape: "S4b"
              },
              virtualNodeName: {
                location: "uri",
                locationName: "virtualNodeName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualNode"
            ],
            members: {
              virtualNode: {
                shape: "S5t"
              }
            },
            payload: "virtualNode"
          },
          idempotent: true
        },
        UpdateVirtualRouter: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualRouters/{virtualRouterName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualRouterName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              spec: {
                shape: "S5x"
              },
              virtualRouterName: {
                location: "uri",
                locationName: "virtualRouterName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualRouter"
            ],
            members: {
              virtualRouter: {
                shape: "S61"
              }
            },
            payload: "virtualRouter"
          },
          idempotent: true
        },
        UpdateVirtualService: {
          http: {
            method: "PUT",
            requestUri: "/v20190125/meshes/{meshName}/virtualServices/{virtualServiceName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "meshName",
              "spec",
              "virtualServiceName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              meshName: {
                location: "uri",
                locationName: "meshName"
              },
              meshOwner: {
                location: "querystring",
                locationName: "meshOwner"
              },
              spec: {
                shape: "S65"
              },
              virtualServiceName: {
                location: "uri",
                locationName: "virtualServiceName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "virtualService"
            ],
            members: {
              virtualService: {
                shape: "S6a"
              }
            },
            payload: "virtualService"
          },
          idempotent: true
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            grpcRoute: {
              type: "structure",
              required: [
                "action",
                "match"
              ],
              members: {
                action: {
                  type: "structure",
                  required: [
                    "target"
                  ],
                  members: {
                    rewrite: {
                      type: "structure",
                      members: {
                        hostname: {
                          shape: "S9"
                        }
                      }
                    },
                    target: {
                      shape: "Sb"
                    }
                  }
                },
                match: {
                  type: "structure",
                  members: {
                    hostname: {
                      shape: "Se"
                    },
                    metadata: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "name"
                        ],
                        members: {
                          invert: {
                            type: "boolean"
                          },
                          match: {
                            type: "structure",
                            members: {
                              exact: {},
                              prefix: {},
                              range: {
                                shape: "Sm"
                              },
                              regex: {},
                              suffix: {}
                            },
                            union: true
                          },
                          name: {}
                        }
                      }
                    },
                    serviceName: {}
                  }
                }
              }
            },
            http2Route: {
              shape: "Sq"
            },
            httpRoute: {
              shape: "Sq"
            },
            priority: {
              type: "integer"
            }
          }
        },
        S9: {
          type: "structure",
          members: {
            defaultTargetHostname: {}
          }
        },
        Sb: {
          type: "structure",
          required: [
            "virtualService"
          ],
          members: {
            virtualService: {
              type: "structure",
              required: [
                "virtualServiceName"
              ],
              members: {
                virtualServiceName: {}
              }
            }
          }
        },
        Se: {
          type: "structure",
          members: {
            exact: {},
            suffix: {}
          }
        },
        Sm: {
          type: "structure",
          required: [
            "end",
            "start"
          ],
          members: {
            end: {
              type: "long"
            },
            start: {
              type: "long"
            }
          }
        },
        Sq: {
          type: "structure",
          required: [
            "action",
            "match"
          ],
          members: {
            action: {
              type: "structure",
              required: [
                "target"
              ],
              members: {
                rewrite: {
                  type: "structure",
                  members: {
                    hostname: {
                      shape: "S9"
                    },
                    path: {
                      type: "structure",
                      members: {
                        exact: {}
                      }
                    },
                    prefix: {
                      type: "structure",
                      members: {
                        defaultPrefix: {},
                        value: {}
                      }
                    }
                  }
                },
                target: {
                  shape: "Sb"
                }
              }
            },
            match: {
              type: "structure",
              members: {
                headers: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "name"
                    ],
                    members: {
                      invert: {
                        type: "boolean"
                      },
                      match: {
                        shape: "S10"
                      },
                      name: {}
                    }
                  }
                },
                hostname: {
                  shape: "Se"
                },
                method: {},
                path: {
                  shape: "S12"
                },
                prefix: {},
                queryParameters: {
                  shape: "S14"
                }
              }
            }
          }
        },
        S10: {
          type: "structure",
          members: {
            exact: {},
            prefix: {},
            range: {
              shape: "Sm"
            },
            regex: {},
            suffix: {}
          },
          union: true
        },
        S12: {
          type: "structure",
          members: {
            exact: {},
            regex: {}
          }
        },
        S14: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              match: {
                type: "structure",
                members: {
                  exact: {}
                }
              },
              name: {}
            }
          }
        },
        S19: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        S1e: {
          type: "structure",
          required: [
            "gatewayRouteName",
            "meshName",
            "metadata",
            "spec",
            "status",
            "virtualGatewayName"
          ],
          members: {
            gatewayRouteName: {},
            meshName: {},
            metadata: {
              shape: "S1f"
            },
            spec: {
              shape: "S5"
            },
            status: {
              type: "structure",
              required: [
                "status"
              ],
              members: {
                status: {}
              }
            },
            virtualGatewayName: {}
          }
        },
        S1f: {
          type: "structure",
          required: [
            "arn",
            "createdAt",
            "lastUpdatedAt",
            "meshOwner",
            "resourceOwner",
            "uid",
            "version"
          ],
          members: {
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            lastUpdatedAt: {
              type: "timestamp"
            },
            meshOwner: {},
            resourceOwner: {},
            uid: {},
            version: {
              type: "long"
            }
          }
        },
        S1l: {
          type: "structure",
          members: {
            egressFilter: {
              type: "structure",
              required: [
                "type"
              ],
              members: {
                type: {}
              }
            }
          }
        },
        S1p: {
          type: "structure",
          required: [
            "meshName",
            "metadata",
            "spec",
            "status"
          ],
          members: {
            meshName: {},
            metadata: {
              shape: "S1f"
            },
            spec: {
              shape: "S1l"
            },
            status: {
              type: "structure",
              members: {
                status: {}
              }
            }
          }
        },
        S1t: {
          type: "structure",
          members: {
            grpcRoute: {
              type: "structure",
              required: [
                "action",
                "match"
              ],
              members: {
                action: {
                  type: "structure",
                  required: [
                    "weightedTargets"
                  ],
                  members: {
                    weightedTargets: {
                      shape: "S1w"
                    }
                  }
                },
                match: {
                  type: "structure",
                  members: {
                    metadata: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "name"
                        ],
                        members: {
                          invert: {
                            type: "boolean"
                          },
                          match: {
                            type: "structure",
                            members: {
                              exact: {},
                              prefix: {},
                              range: {
                                shape: "Sm"
                              },
                              regex: {},
                              suffix: {}
                            },
                            union: true
                          },
                          name: {}
                        }
                      }
                    },
                    methodName: {},
                    serviceName: {}
                  }
                },
                retryPolicy: {
                  type: "structure",
                  required: [
                    "maxRetries",
                    "perRetryTimeout"
                  ],
                  members: {
                    grpcRetryEvents: {
                      type: "list",
                      member: {}
                    },
                    httpRetryEvents: {
                      shape: "S27"
                    },
                    maxRetries: {
                      type: "long"
                    },
                    perRetryTimeout: {
                      shape: "S2a"
                    },
                    tcpRetryEvents: {
                      shape: "S2d"
                    }
                  }
                },
                timeout: {
                  shape: "S2f"
                }
              }
            },
            http2Route: {
              shape: "S2g"
            },
            httpRoute: {
              shape: "S2g"
            },
            priority: {
              type: "integer"
            },
            tcpRoute: {
              type: "structure",
              required: [
                "action"
              ],
              members: {
                action: {
                  type: "structure",
                  required: [
                    "weightedTargets"
                  ],
                  members: {
                    weightedTargets: {
                      shape: "S1w"
                    }
                  }
                },
                timeout: {
                  shape: "S2r"
                }
              }
            }
          }
        },
        S1w: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "virtualNode",
              "weight"
            ],
            members: {
              virtualNode: {},
              weight: {
                type: "integer"
              }
            }
          }
        },
        S27: {
          type: "list",
          member: {}
        },
        S2a: {
          type: "structure",
          members: {
            unit: {},
            value: {
              type: "long"
            }
          }
        },
        S2d: {
          type: "list",
          member: {}
        },
        S2f: {
          type: "structure",
          members: {
            idle: {
              shape: "S2a"
            },
            perRequest: {
              shape: "S2a"
            }
          }
        },
        S2g: {
          type: "structure",
          required: [
            "action",
            "match"
          ],
          members: {
            action: {
              type: "structure",
              required: [
                "weightedTargets"
              ],
              members: {
                weightedTargets: {
                  shape: "S1w"
                }
              }
            },
            match: {
              type: "structure",
              members: {
                headers: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "name"
                    ],
                    members: {
                      invert: {
                        type: "boolean"
                      },
                      match: {
                        shape: "S10"
                      },
                      name: {}
                    }
                  }
                },
                method: {},
                path: {
                  shape: "S12"
                },
                prefix: {},
                queryParameters: {
                  shape: "S14"
                },
                scheme: {}
              }
            },
            retryPolicy: {
              type: "structure",
              required: [
                "maxRetries",
                "perRetryTimeout"
              ],
              members: {
                httpRetryEvents: {
                  shape: "S27"
                },
                maxRetries: {
                  type: "long"
                },
                perRetryTimeout: {
                  shape: "S2a"
                },
                tcpRetryEvents: {
                  shape: "S2d"
                }
              }
            },
            timeout: {
              shape: "S2n"
            }
          }
        },
        S2n: {
          type: "structure",
          members: {
            idle: {
              shape: "S2a"
            },
            perRequest: {
              shape: "S2a"
            }
          }
        },
        S2r: {
          type: "structure",
          members: {
            idle: {
              shape: "S2a"
            }
          }
        },
        S2t: {
          type: "structure",
          required: [
            "meshName",
            "metadata",
            "routeName",
            "spec",
            "status",
            "virtualRouterName"
          ],
          members: {
            meshName: {},
            metadata: {
              shape: "S1f"
            },
            routeName: {},
            spec: {
              shape: "S1t"
            },
            status: {
              type: "structure",
              required: [
                "status"
              ],
              members: {
                status: {}
              }
            },
            virtualRouterName: {}
          }
        },
        S2x: {
          type: "structure",
          required: [
            "listeners"
          ],
          members: {
            backendDefaults: {
              type: "structure",
              members: {
                clientPolicy: {
                  type: "structure",
                  members: {
                    tls: {
                      type: "structure",
                      required: [
                        "validation"
                      ],
                      members: {
                        certificate: {
                          type: "structure",
                          members: {
                            file: {
                              shape: "S32"
                            },
                            sds: {
                              shape: "S34"
                            }
                          },
                          union: true
                        },
                        enforce: {
                          type: "boolean"
                        },
                        ports: {
                          shape: "S36"
                        },
                        validation: {
                          type: "structure",
                          required: [
                            "trust"
                          ],
                          members: {
                            subjectAlternativeNames: {
                              shape: "S39"
                            },
                            trust: {
                              type: "structure",
                              members: {
                                acm: {
                                  type: "structure",
                                  required: [
                                    "certificateAuthorityArns"
                                  ],
                                  members: {
                                    certificateAuthorityArns: {
                                      type: "list",
                                      member: {}
                                    }
                                  }
                                },
                                file: {
                                  shape: "S3g"
                                },
                                sds: {
                                  shape: "S3h"
                                }
                              },
                              union: true
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            listeners: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "portMapping"
                ],
                members: {
                  connectionPool: {
                    type: "structure",
                    members: {
                      grpc: {
                        type: "structure",
                        required: [
                          "maxRequests"
                        ],
                        members: {
                          maxRequests: {
                            type: "integer"
                          }
                        }
                      },
                      http: {
                        type: "structure",
                        required: [
                          "maxConnections"
                        ],
                        members: {
                          maxConnections: {
                            type: "integer"
                          },
                          maxPendingRequests: {
                            type: "integer"
                          }
                        }
                      },
                      http2: {
                        type: "structure",
                        required: [
                          "maxRequests"
                        ],
                        members: {
                          maxRequests: {
                            type: "integer"
                          }
                        }
                      }
                    },
                    union: true
                  },
                  healthCheck: {
                    type: "structure",
                    required: [
                      "healthyThreshold",
                      "intervalMillis",
                      "protocol",
                      "timeoutMillis",
                      "unhealthyThreshold"
                    ],
                    members: {
                      healthyThreshold: {
                        type: "integer"
                      },
                      intervalMillis: {
                        type: "long"
                      },
                      path: {},
                      port: {
                        type: "integer"
                      },
                      protocol: {},
                      timeoutMillis: {
                        type: "long"
                      },
                      unhealthyThreshold: {
                        type: "integer"
                      }
                    }
                  },
                  portMapping: {
                    type: "structure",
                    required: [
                      "port",
                      "protocol"
                    ],
                    members: {
                      port: {
                        type: "integer"
                      },
                      protocol: {}
                    }
                  },
                  tls: {
                    type: "structure",
                    required: [
                      "certificate",
                      "mode"
                    ],
                    members: {
                      certificate: {
                        type: "structure",
                        members: {
                          acm: {
                            type: "structure",
                            required: [
                              "certificateArn"
                            ],
                            members: {
                              certificateArn: {}
                            }
                          },
                          file: {
                            shape: "S32"
                          },
                          sds: {
                            shape: "S34"
                          }
                        },
                        union: true
                      },
                      mode: {},
                      validation: {
                        type: "structure",
                        required: [
                          "trust"
                        ],
                        members: {
                          subjectAlternativeNames: {
                            shape: "S39"
                          },
                          trust: {
                            type: "structure",
                            members: {
                              file: {
                                shape: "S3g"
                              },
                              sds: {
                                shape: "S3h"
                              }
                            },
                            union: true
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            logging: {
              type: "structure",
              members: {
                accessLog: {
                  type: "structure",
                  members: {
                    file: {
                      type: "structure",
                      required: [
                        "path"
                      ],
                      members: {
                        path: {}
                      }
                    }
                  },
                  union: true
                }
              }
            }
          }
        },
        S32: {
          type: "structure",
          required: [
            "certificateChain",
            "privateKey"
          ],
          members: {
            certificateChain: {},
            privateKey: {}
          }
        },
        S34: {
          type: "structure",
          required: [
            "secretName"
          ],
          members: {
            secretName: {}
          }
        },
        S36: {
          type: "list",
          member: {
            type: "integer"
          }
        },
        S39: {
          type: "structure",
          required: [
            "match"
          ],
          members: {
            match: {
              type: "structure",
              required: [
                "exact"
              ],
              members: {
                exact: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        S3g: {
          type: "structure",
          required: [
            "certificateChain"
          ],
          members: {
            certificateChain: {}
          }
        },
        S3h: {
          type: "structure",
          required: [
            "secretName"
          ],
          members: {
            secretName: {}
          }
        },
        S47: {
          type: "structure",
          required: [
            "meshName",
            "metadata",
            "spec",
            "status",
            "virtualGatewayName"
          ],
          members: {
            meshName: {},
            metadata: {
              shape: "S1f"
            },
            spec: {
              shape: "S2x"
            },
            status: {
              type: "structure",
              required: [
                "status"
              ],
              members: {
                status: {}
              }
            },
            virtualGatewayName: {}
          }
        },
        S4b: {
          type: "structure",
          members: {
            backendDefaults: {
              type: "structure",
              members: {
                clientPolicy: {
                  shape: "S4d"
                }
              }
            },
            backends: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  virtualService: {
                    type: "structure",
                    required: [
                      "virtualServiceName"
                    ],
                    members: {
                      clientPolicy: {
                        shape: "S4d"
                      },
                      virtualServiceName: {}
                    }
                  }
                },
                union: true
              }
            },
            listeners: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "portMapping"
                ],
                members: {
                  connectionPool: {
                    type: "structure",
                    members: {
                      grpc: {
                        type: "structure",
                        required: [
                          "maxRequests"
                        ],
                        members: {
                          maxRequests: {
                            type: "integer"
                          }
                        }
                      },
                      http: {
                        type: "structure",
                        required: [
                          "maxConnections"
                        ],
                        members: {
                          maxConnections: {
                            type: "integer"
                          },
                          maxPendingRequests: {
                            type: "integer"
                          }
                        }
                      },
                      http2: {
                        type: "structure",
                        required: [
                          "maxRequests"
                        ],
                        members: {
                          maxRequests: {
                            type: "integer"
                          }
                        }
                      },
                      tcp: {
                        type: "structure",
                        required: [
                          "maxConnections"
                        ],
                        members: {
                          maxConnections: {
                            type: "integer"
                          }
                        }
                      }
                    },
                    union: true
                  },
                  healthCheck: {
                    type: "structure",
                    required: [
                      "healthyThreshold",
                      "intervalMillis",
                      "protocol",
                      "timeoutMillis",
                      "unhealthyThreshold"
                    ],
                    members: {
                      healthyThreshold: {
                        type: "integer"
                      },
                      intervalMillis: {
                        type: "long"
                      },
                      path: {},
                      port: {
                        type: "integer"
                      },
                      protocol: {},
                      timeoutMillis: {
                        type: "long"
                      },
                      unhealthyThreshold: {
                        type: "integer"
                      }
                    }
                  },
                  outlierDetection: {
                    type: "structure",
                    required: [
                      "baseEjectionDuration",
                      "interval",
                      "maxEjectionPercent",
                      "maxServerErrors"
                    ],
                    members: {
                      baseEjectionDuration: {
                        shape: "S2a"
                      },
                      interval: {
                        shape: "S2a"
                      },
                      maxEjectionPercent: {
                        type: "integer"
                      },
                      maxServerErrors: {
                        type: "long"
                      }
                    }
                  },
                  portMapping: {
                    shape: "S57"
                  },
                  timeout: {
                    type: "structure",
                    members: {
                      grpc: {
                        shape: "S2f"
                      },
                      http: {
                        shape: "S2n"
                      },
                      http2: {
                        shape: "S2n"
                      },
                      tcp: {
                        shape: "S2r"
                      }
                    },
                    union: true
                  },
                  tls: {
                    type: "structure",
                    required: [
                      "certificate",
                      "mode"
                    ],
                    members: {
                      certificate: {
                        type: "structure",
                        members: {
                          acm: {
                            type: "structure",
                            required: [
                              "certificateArn"
                            ],
                            members: {
                              certificateArn: {}
                            }
                          },
                          file: {
                            shape: "S4g"
                          },
                          sds: {
                            shape: "S4h"
                          }
                        },
                        union: true
                      },
                      mode: {},
                      validation: {
                        type: "structure",
                        required: [
                          "trust"
                        ],
                        members: {
                          subjectAlternativeNames: {
                            shape: "S39"
                          },
                          trust: {
                            type: "structure",
                            members: {
                              file: {
                                shape: "S4n"
                              },
                              sds: {
                                shape: "S4o"
                              }
                            },
                            union: true
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            logging: {
              type: "structure",
              members: {
                accessLog: {
                  type: "structure",
                  members: {
                    file: {
                      type: "structure",
                      required: [
                        "path"
                      ],
                      members: {
                        path: {}
                      }
                    }
                  },
                  union: true
                }
              }
            },
            serviceDiscovery: {
              type: "structure",
              members: {
                awsCloudMap: {
                  type: "structure",
                  required: [
                    "namespaceName",
                    "serviceName"
                  ],
                  members: {
                    attributes: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "key",
                          "value"
                        ],
                        members: {
                          key: {},
                          value: {}
                        }
                      }
                    },
                    namespaceName: {},
                    serviceName: {}
                  }
                },
                dns: {
                  type: "structure",
                  required: [
                    "hostname"
                  ],
                  members: {
                    hostname: {},
                    responseType: {}
                  }
                }
              },
              union: true
            }
          }
        },
        S4d: {
          type: "structure",
          members: {
            tls: {
              type: "structure",
              required: [
                "validation"
              ],
              members: {
                certificate: {
                  type: "structure",
                  members: {
                    file: {
                      shape: "S4g"
                    },
                    sds: {
                      shape: "S4h"
                    }
                  },
                  union: true
                },
                enforce: {
                  type: "boolean"
                },
                ports: {
                  shape: "S36"
                },
                validation: {
                  type: "structure",
                  required: [
                    "trust"
                  ],
                  members: {
                    subjectAlternativeNames: {
                      shape: "S39"
                    },
                    trust: {
                      type: "structure",
                      members: {
                        acm: {
                          type: "structure",
                          required: [
                            "certificateAuthorityArns"
                          ],
                          members: {
                            certificateAuthorityArns: {
                              type: "list",
                              member: {}
                            }
                          }
                        },
                        file: {
                          shape: "S4n"
                        },
                        sds: {
                          shape: "S4o"
                        }
                      },
                      union: true
                    }
                  }
                }
              }
            }
          }
        },
        S4g: {
          type: "structure",
          required: [
            "certificateChain",
            "privateKey"
          ],
          members: {
            certificateChain: {},
            privateKey: {}
          }
        },
        S4h: {
          type: "structure",
          required: [
            "secretName"
          ],
          members: {
            secretName: {}
          }
        },
        S4n: {
          type: "structure",
          required: [
            "certificateChain"
          ],
          members: {
            certificateChain: {}
          }
        },
        S4o: {
          type: "structure",
          required: [
            "secretName"
          ],
          members: {
            secretName: {}
          }
        },
        S57: {
          type: "structure",
          required: [
            "port",
            "protocol"
          ],
          members: {
            port: {
              type: "integer"
            },
            protocol: {}
          }
        },
        S5t: {
          type: "structure",
          required: [
            "meshName",
            "metadata",
            "spec",
            "status",
            "virtualNodeName"
          ],
          members: {
            meshName: {},
            metadata: {
              shape: "S1f"
            },
            spec: {
              shape: "S4b"
            },
            status: {
              type: "structure",
              required: [
                "status"
              ],
              members: {
                status: {}
              }
            },
            virtualNodeName: {}
          }
        },
        S5x: {
          type: "structure",
          members: {
            listeners: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "portMapping"
                ],
                members: {
                  portMapping: {
                    shape: "S57"
                  }
                }
              }
            }
          }
        },
        S61: {
          type: "structure",
          required: [
            "meshName",
            "metadata",
            "spec",
            "status",
            "virtualRouterName"
          ],
          members: {
            meshName: {},
            metadata: {
              shape: "S1f"
            },
            spec: {
              shape: "S5x"
            },
            status: {
              type: "structure",
              required: [
                "status"
              ],
              members: {
                status: {}
              }
            },
            virtualRouterName: {}
          }
        },
        S65: {
          type: "structure",
          members: {
            provider: {
              type: "structure",
              members: {
                virtualNode: {
                  type: "structure",
                  required: [
                    "virtualNodeName"
                  ],
                  members: {
                    virtualNodeName: {}
                  }
                },
                virtualRouter: {
                  type: "structure",
                  required: [
                    "virtualRouterName"
                  ],
                  members: {
                    virtualRouterName: {}
                  }
                }
              },
              union: true
            }
          }
        },
        S6a: {
          type: "structure",
          required: [
            "meshName",
            "metadata",
            "spec",
            "status",
            "virtualServiceName"
          ],
          members: {
            meshName: {},
            metadata: {
              shape: "S1f"
            },
            spec: {
              shape: "S65"
            },
            status: {
              type: "structure",
              required: [
                "status"
              ],
              members: {
                status: {}
              }
            },
            virtualServiceName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/appmesh-2019-01-25.paginators.json
var require_appmesh_2019_01_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/appmesh-2019-01-25.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListGatewayRoutes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "limit",
          result_key: "gatewayRoutes"
        },
        ListMeshes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "limit",
          result_key: "meshes"
        },
        ListRoutes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "limit",
          result_key: "routes"
        },
        ListTagsForResource: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "limit",
          result_key: "tags"
        },
        ListVirtualGateways: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "limit",
          result_key: "virtualGateways"
        },
        ListVirtualNodes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "limit",
          result_key: "virtualNodes"
        },
        ListVirtualRouters: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "limit",
          result_key: "virtualRouters"
        },
        ListVirtualServices: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "limit",
          result_key: "virtualServices"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/appmesh.js
var require_appmesh = __commonJS({
  "node_modules/aws-sdk/clients/appmesh.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["appmesh"] = {};
    AWS3.AppMesh = Service.defineService("appmesh", ["2018-10-01", "2018-10-01*", "2019-01-25"]);
    Object.defineProperty(apiLoader.services["appmesh"], "2018-10-01", {
      get: function get() {
        var model = require_appmesh_2018_10_01_min();
        model.paginators = require_appmesh_2018_10_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(apiLoader.services["appmesh"], "2019-01-25", {
      get: function get() {
        var model = require_appmesh_2019_01_25_min();
        model.paginators = require_appmesh_2019_01_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.AppMesh;
  }
});

// node_modules/aws-sdk/apis/license-manager-2018-08-01.min.json
var require_license_manager_2018_08_01_min = __commonJS({
  "node_modules/aws-sdk/apis/license-manager-2018-08-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-08-01",
        endpointPrefix: "license-manager",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS License Manager",
        serviceId: "License Manager",
        signatureVersion: "v4",
        targetPrefix: "AWSLicenseManager",
        uid: "license-manager-2018-08-01"
      },
      operations: {
        AcceptGrant: {
          input: {
            type: "structure",
            required: [
              "GrantArn"
            ],
            members: {
              GrantArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GrantArn: {},
              Status: {},
              Version: {}
            }
          }
        },
        CheckInLicense: {
          input: {
            type: "structure",
            required: [
              "LicenseConsumptionToken"
            ],
            members: {
              LicenseConsumptionToken: {},
              Beneficiary: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CheckoutBorrowLicense: {
          input: {
            type: "structure",
            required: [
              "LicenseArn",
              "Entitlements",
              "DigitalSignatureMethod",
              "ClientToken"
            ],
            members: {
              LicenseArn: {},
              Entitlements: {
                shape: "S9"
              },
              DigitalSignatureMethod: {},
              NodeId: {},
              CheckoutMetadata: {
                shape: "Sd"
              },
              ClientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseArn: {},
              LicenseConsumptionToken: {},
              EntitlementsAllowed: {
                shape: "S9"
              },
              NodeId: {},
              SignedToken: {},
              IssuedAt: {},
              Expiration: {},
              CheckoutMetadata: {
                shape: "Sd"
              }
            }
          }
        },
        CheckoutLicense: {
          input: {
            type: "structure",
            required: [
              "ProductSKU",
              "CheckoutType",
              "KeyFingerprint",
              "Entitlements",
              "ClientToken"
            ],
            members: {
              ProductSKU: {},
              CheckoutType: {},
              KeyFingerprint: {},
              Entitlements: {
                shape: "S9"
              },
              ClientToken: {},
              Beneficiary: {},
              NodeId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CheckoutType: {},
              LicenseConsumptionToken: {},
              EntitlementsAllowed: {
                shape: "S9"
              },
              SignedToken: {},
              NodeId: {},
              IssuedAt: {},
              Expiration: {},
              LicenseArn: {}
            }
          }
        },
        CreateGrant: {
          input: {
            type: "structure",
            required: [
              "ClientToken",
              "GrantName",
              "LicenseArn",
              "Principals",
              "HomeRegion",
              "AllowedOperations"
            ],
            members: {
              ClientToken: {},
              GrantName: {},
              LicenseArn: {},
              Principals: {
                type: "list",
                member: {}
              },
              HomeRegion: {},
              AllowedOperations: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GrantArn: {},
              Status: {},
              Version: {}
            }
          }
        },
        CreateGrantVersion: {
          input: {
            type: "structure",
            required: [
              "ClientToken",
              "GrantArn"
            ],
            members: {
              ClientToken: {},
              GrantArn: {},
              GrantName: {},
              AllowedOperations: {
                shape: "So"
              },
              Status: {},
              StatusReason: {},
              SourceVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GrantArn: {},
              Status: {},
              Version: {}
            }
          }
        },
        CreateLicense: {
          input: {
            type: "structure",
            required: [
              "LicenseName",
              "ProductName",
              "ProductSKU",
              "Issuer",
              "HomeRegion",
              "Validity",
              "Entitlements",
              "Beneficiary",
              "ConsumptionConfiguration",
              "ClientToken"
            ],
            members: {
              LicenseName: {},
              ProductName: {},
              ProductSKU: {},
              Issuer: {
                shape: "Sv"
              },
              HomeRegion: {},
              Validity: {
                shape: "Sw"
              },
              Entitlements: {
                shape: "Sx"
              },
              Beneficiary: {},
              ConsumptionConfiguration: {
                shape: "S12"
              },
              LicenseMetadata: {
                shape: "Sd"
              },
              ClientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseArn: {},
              Status: {},
              Version: {}
            }
          }
        },
        CreateLicenseConfiguration: {
          input: {
            type: "structure",
            required: [
              "Name",
              "LicenseCountingType"
            ],
            members: {
              Name: {},
              Description: {},
              LicenseCountingType: {},
              LicenseCount: {
                type: "long"
              },
              LicenseCountHardLimit: {
                type: "boolean"
              },
              LicenseRules: {
                shape: "S1c"
              },
              Tags: {
                shape: "S1d"
              },
              DisassociateWhenNotFound: {
                type: "boolean"
              },
              ProductInformationList: {
                shape: "S1f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseConfigurationArn: {}
            }
          }
        },
        CreateLicenseConversionTaskForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "SourceLicenseContext",
              "DestinationLicenseContext"
            ],
            members: {
              ResourceArn: {},
              SourceLicenseContext: {
                shape: "S1l"
              },
              DestinationLicenseContext: {
                shape: "S1l"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseConversionTaskId: {}
            }
          }
        },
        CreateLicenseManagerReportGenerator: {
          input: {
            type: "structure",
            required: [
              "ReportGeneratorName",
              "Type",
              "ReportContext",
              "ReportFrequency",
              "ClientToken"
            ],
            members: {
              ReportGeneratorName: {},
              Type: {
                shape: "S1r"
              },
              ReportContext: {
                shape: "S1t"
              },
              ReportFrequency: {
                shape: "S1v"
              },
              ClientToken: {},
              Description: {},
              Tags: {
                shape: "S1d"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseManagerReportGeneratorArn: {}
            }
          }
        },
        CreateLicenseVersion: {
          input: {
            type: "structure",
            required: [
              "LicenseArn",
              "LicenseName",
              "ProductName",
              "Issuer",
              "HomeRegion",
              "Validity",
              "Entitlements",
              "ConsumptionConfiguration",
              "Status",
              "ClientToken"
            ],
            members: {
              LicenseArn: {},
              LicenseName: {},
              ProductName: {},
              Issuer: {
                shape: "Sv"
              },
              HomeRegion: {},
              Validity: {
                shape: "Sw"
              },
              LicenseMetadata: {
                shape: "Sd"
              },
              Entitlements: {
                shape: "Sx"
              },
              ConsumptionConfiguration: {
                shape: "S12"
              },
              Status: {},
              ClientToken: {},
              SourceVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseArn: {},
              Version: {},
              Status: {}
            }
          }
        },
        CreateToken: {
          input: {
            type: "structure",
            required: [
              "LicenseArn",
              "ClientToken"
            ],
            members: {
              LicenseArn: {},
              RoleArns: {
                shape: "S1u"
              },
              ExpirationInDays: {
                type: "integer"
              },
              TokenProperties: {
                shape: "S23"
              },
              ClientToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TokenId: {},
              TokenType: {},
              Token: {}
            }
          }
        },
        DeleteGrant: {
          input: {
            type: "structure",
            required: [
              "GrantArn",
              "Version"
            ],
            members: {
              GrantArn: {},
              StatusReason: {},
              Version: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GrantArn: {},
              Status: {},
              Version: {}
            }
          }
        },
        DeleteLicense: {
          input: {
            type: "structure",
            required: [
              "LicenseArn",
              "SourceVersion"
            ],
            members: {
              LicenseArn: {},
              SourceVersion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              DeletionDate: {}
            }
          }
        },
        DeleteLicenseConfiguration: {
          input: {
            type: "structure",
            required: [
              "LicenseConfigurationArn"
            ],
            members: {
              LicenseConfigurationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLicenseManagerReportGenerator: {
          input: {
            type: "structure",
            required: [
              "LicenseManagerReportGeneratorArn"
            ],
            members: {
              LicenseManagerReportGeneratorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteToken: {
          input: {
            type: "structure",
            required: [
              "TokenId"
            ],
            members: {
              TokenId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ExtendLicenseConsumption: {
          input: {
            type: "structure",
            required: [
              "LicenseConsumptionToken"
            ],
            members: {
              LicenseConsumptionToken: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseConsumptionToken: {},
              Expiration: {}
            }
          }
        },
        GetAccessToken: {
          input: {
            type: "structure",
            required: [
              "Token"
            ],
            members: {
              Token: {},
              TokenProperties: {
                shape: "S23"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccessToken: {}
            }
          }
        },
        GetGrant: {
          input: {
            type: "structure",
            required: [
              "GrantArn"
            ],
            members: {
              GrantArn: {},
              Version: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Grant: {
                shape: "S2p"
              }
            }
          }
        },
        GetLicense: {
          input: {
            type: "structure",
            required: [
              "LicenseArn"
            ],
            members: {
              LicenseArn: {},
              Version: {}
            }
          },
          output: {
            type: "structure",
            members: {
              License: {
                shape: "S2s"
              }
            }
          }
        },
        GetLicenseConfiguration: {
          input: {
            type: "structure",
            required: [
              "LicenseConfigurationArn"
            ],
            members: {
              LicenseConfigurationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseConfigurationId: {},
              LicenseConfigurationArn: {},
              Name: {},
              Description: {},
              LicenseCountingType: {},
              LicenseRules: {
                shape: "S1c"
              },
              LicenseCount: {
                type: "long"
              },
              LicenseCountHardLimit: {
                type: "boolean"
              },
              ConsumedLicenses: {
                type: "long"
              },
              Status: {},
              OwnerAccountId: {},
              ConsumedLicenseSummaryList: {
                shape: "S2w"
              },
              ManagedResourceSummaryList: {
                shape: "S2z"
              },
              Tags: {
                shape: "S1d"
              },
              ProductInformationList: {
                shape: "S1f"
              },
              AutomatedDiscoveryInformation: {
                shape: "S31"
              },
              DisassociateWhenNotFound: {
                type: "boolean"
              }
            }
          }
        },
        GetLicenseConversionTask: {
          input: {
            type: "structure",
            required: [
              "LicenseConversionTaskId"
            ],
            members: {
              LicenseConversionTaskId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseConversionTaskId: {},
              ResourceArn: {},
              SourceLicenseContext: {
                shape: "S1l"
              },
              DestinationLicenseContext: {
                shape: "S1l"
              },
              StatusMessage: {},
              Status: {},
              StartTime: {
                type: "timestamp"
              },
              LicenseConversionTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetLicenseManagerReportGenerator: {
          input: {
            type: "structure",
            required: [
              "LicenseManagerReportGeneratorArn"
            ],
            members: {
              LicenseManagerReportGeneratorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReportGenerator: {
                shape: "S38"
              }
            }
          }
        },
        GetLicenseUsage: {
          input: {
            type: "structure",
            required: [
              "LicenseArn"
            ],
            members: {
              LicenseArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseUsage: {
                type: "structure",
                members: {
                  EntitlementUsages: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Name",
                        "ConsumedValue",
                        "Unit"
                      ],
                      members: {
                        Name: {},
                        ConsumedValue: {},
                        MaxCount: {},
                        Unit: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetServiceSettings: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              S3BucketArn: {},
              SnsTopicArn: {},
              OrganizationConfiguration: {
                shape: "S3h"
              },
              EnableCrossAccountsDiscovery: {
                type: "boolean"
              },
              LicenseManagerResourceShareArn: {}
            }
          }
        },
        ListAssociationsForLicenseConfiguration: {
          input: {
            type: "structure",
            required: [
              "LicenseConfigurationArn"
            ],
            members: {
              LicenseConfigurationArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseConfigurationAssociations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceArn: {},
                    ResourceType: {},
                    ResourceOwnerId: {},
                    AssociationTime: {
                      type: "timestamp"
                    },
                    AmiAssociationScope: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDistributedGrants: {
          input: {
            type: "structure",
            members: {
              GrantArns: {
                shape: "S1u"
              },
              Filters: {
                shape: "S3n"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Grants: {
                shape: "S3u"
              },
              NextToken: {}
            }
          }
        },
        ListFailuresForLicenseConfigurationOperations: {
          input: {
            type: "structure",
            required: [
              "LicenseConfigurationArn"
            ],
            members: {
              LicenseConfigurationArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseOperationFailureList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceArn: {},
                    ResourceType: {},
                    ErrorMessage: {},
                    FailureTime: {
                      type: "timestamp"
                    },
                    OperationName: {},
                    ResourceOwnerId: {},
                    OperationRequestedBy: {},
                    MetadataList: {
                      shape: "Sd"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLicenseConfigurations: {
          input: {
            type: "structure",
            members: {
              LicenseConfigurationArns: {
                shape: "S1c"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S40"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LicenseConfigurationId: {},
                    LicenseConfigurationArn: {},
                    Name: {},
                    Description: {},
                    LicenseCountingType: {},
                    LicenseRules: {
                      shape: "S1c"
                    },
                    LicenseCount: {
                      type: "long"
                    },
                    LicenseCountHardLimit: {
                      type: "boolean"
                    },
                    DisassociateWhenNotFound: {
                      type: "boolean"
                    },
                    ConsumedLicenses: {
                      type: "long"
                    },
                    Status: {},
                    OwnerAccountId: {},
                    ConsumedLicenseSummaryList: {
                      shape: "S2w"
                    },
                    ManagedResourceSummaryList: {
                      shape: "S2z"
                    },
                    ProductInformationList: {
                      shape: "S1f"
                    },
                    AutomatedDiscoveryInformation: {
                      shape: "S31"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLicenseConversionTasks: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S40"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseConversionTasks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LicenseConversionTaskId: {},
                    ResourceArn: {},
                    SourceLicenseContext: {
                      shape: "S1l"
                    },
                    DestinationLicenseContext: {
                      shape: "S1l"
                    },
                    Status: {},
                    StatusMessage: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    LicenseConversionTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLicenseManagerReportGenerators: {
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S3n"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReportGenerators: {
                type: "list",
                member: {
                  shape: "S38"
                }
              },
              NextToken: {}
            }
          }
        },
        ListLicenseSpecificationsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseSpecifications: {
                shape: "S4d"
              },
              NextToken: {}
            }
          }
        },
        ListLicenseVersions: {
          input: {
            type: "structure",
            required: [
              "LicenseArn"
            ],
            members: {
              LicenseArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Licenses: {
                shape: "S4h"
              },
              NextToken: {}
            }
          }
        },
        ListLicenses: {
          input: {
            type: "structure",
            members: {
              LicenseArns: {
                shape: "S1u"
              },
              Filters: {
                shape: "S3n"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Licenses: {
                shape: "S4h"
              },
              NextToken: {}
            }
          }
        },
        ListReceivedGrants: {
          input: {
            type: "structure",
            members: {
              GrantArns: {
                shape: "S1u"
              },
              Filters: {
                shape: "S3n"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Grants: {
                shape: "S3u"
              },
              NextToken: {}
            }
          }
        },
        ListReceivedLicenses: {
          input: {
            type: "structure",
            members: {
              LicenseArns: {
                shape: "S1u"
              },
              Filters: {
                shape: "S3n"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Licenses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LicenseArn: {},
                    LicenseName: {},
                    ProductName: {},
                    ProductSKU: {},
                    Issuer: {
                      shape: "S2t"
                    },
                    HomeRegion: {},
                    Status: {},
                    Validity: {
                      shape: "Sw"
                    },
                    Beneficiary: {},
                    Entitlements: {
                      shape: "Sx"
                    },
                    ConsumptionConfiguration: {
                      shape: "S12"
                    },
                    LicenseMetadata: {
                      shape: "Sd"
                    },
                    CreateTime: {},
                    Version: {},
                    ReceivedMetadata: {
                      type: "structure",
                      members: {
                        ReceivedStatus: {},
                        ReceivedStatusReason: {},
                        AllowedOperations: {
                          shape: "So"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListResourceInventory: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Condition"
                  ],
                  members: {
                    Name: {},
                    Condition: {},
                    Value: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceInventoryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceId: {},
                    ResourceType: {},
                    ResourceArn: {},
                    Platform: {},
                    PlatformVersion: {},
                    ResourceOwningAccountId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S1d"
              }
            }
          }
        },
        ListTokens: {
          input: {
            type: "structure",
            members: {
              TokenIds: {
                shape: "S1c"
              },
              Filters: {
                shape: "S3n"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tokens: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TokenId: {},
                    TokenType: {},
                    LicenseArn: {},
                    ExpirationTime: {},
                    TokenProperties: {
                      shape: "S23"
                    },
                    RoleArns: {
                      shape: "S1u"
                    },
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListUsageForLicenseConfiguration: {
          input: {
            type: "structure",
            required: [
              "LicenseConfigurationArn"
            ],
            members: {
              LicenseConfigurationArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "S40"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LicenseConfigurationUsageList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceArn: {},
                    ResourceType: {},
                    ResourceStatus: {},
                    ResourceOwnerId: {},
                    AssociationTime: {
                      type: "timestamp"
                    },
                    ConsumedLicenses: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        RejectGrant: {
          input: {
            type: "structure",
            required: [
              "GrantArn"
            ],
            members: {
              GrantArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GrantArn: {},
              Status: {},
              Version: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S1d"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLicenseConfiguration: {
          input: {
            type: "structure",
            required: [
              "LicenseConfigurationArn"
            ],
            members: {
              LicenseConfigurationArn: {},
              LicenseConfigurationStatus: {},
              LicenseRules: {
                shape: "S1c"
              },
              LicenseCount: {
                type: "long"
              },
              LicenseCountHardLimit: {
                type: "boolean"
              },
              Name: {},
              Description: {},
              ProductInformationList: {
                shape: "S1f"
              },
              DisassociateWhenNotFound: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLicenseManagerReportGenerator: {
          input: {
            type: "structure",
            required: [
              "LicenseManagerReportGeneratorArn",
              "ReportGeneratorName",
              "Type",
              "ReportContext",
              "ReportFrequency",
              "ClientToken"
            ],
            members: {
              LicenseManagerReportGeneratorArn: {},
              ReportGeneratorName: {},
              Type: {
                shape: "S1r"
              },
              ReportContext: {
                shape: "S1t"
              },
              ReportFrequency: {
                shape: "S1v"
              },
              ClientToken: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLicenseSpecificationsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              AddLicenseSpecifications: {
                shape: "S4d"
              },
              RemoveLicenseSpecifications: {
                shape: "S4d"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateServiceSettings: {
          input: {
            type: "structure",
            members: {
              S3BucketArn: {},
              SnsTopicArn: {},
              OrganizationConfiguration: {
                shape: "S3h"
              },
              EnableCrossAccountsDiscovery: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S9: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Unit"
            ],
            members: {
              Name: {},
              Value: {},
              Unit: {}
            }
          }
        },
        Sd: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        So: {
          type: "list",
          member: {}
        },
        Sv: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            SignKey: {}
          }
        },
        Sw: {
          type: "structure",
          required: [
            "Begin"
          ],
          members: {
            Begin: {},
            End: {}
          }
        },
        Sx: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Unit"
            ],
            members: {
              Name: {},
              Value: {},
              MaxCount: {
                type: "long"
              },
              Overage: {
                type: "boolean"
              },
              Unit: {},
              AllowCheckIn: {
                type: "boolean"
              }
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            RenewType: {},
            ProvisionalConfiguration: {
              type: "structure",
              required: [
                "MaxTimeToLiveInMinutes"
              ],
              members: {
                MaxTimeToLiveInMinutes: {
                  type: "integer"
                }
              }
            },
            BorrowConfiguration: {
              type: "structure",
              required: [
                "AllowEarlyCheckIn",
                "MaxTimeToLiveInMinutes"
              ],
              members: {
                AllowEarlyCheckIn: {
                  type: "boolean"
                },
                MaxTimeToLiveInMinutes: {
                  type: "integer"
                }
              }
            }
          }
        },
        S1c: {
          type: "list",
          member: {}
        },
        S1d: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S1f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ResourceType",
              "ProductInformationFilterList"
            ],
            members: {
              ResourceType: {},
              ProductInformationFilterList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ProductInformationFilterName",
                    "ProductInformationFilterComparator"
                  ],
                  members: {
                    ProductInformationFilterName: {},
                    ProductInformationFilterValue: {
                      shape: "S1c"
                    },
                    ProductInformationFilterComparator: {}
                  }
                }
              }
            }
          }
        },
        S1l: {
          type: "structure",
          members: {
            UsageOperation: {}
          }
        },
        S1r: {
          type: "list",
          member: {}
        },
        S1t: {
          type: "structure",
          required: [
            "licenseConfigurationArns"
          ],
          members: {
            licenseConfigurationArns: {
              shape: "S1u"
            }
          }
        },
        S1u: {
          type: "list",
          member: {}
        },
        S1v: {
          type: "structure",
          members: {
            value: {
              type: "integer"
            },
            period: {}
          }
        },
        S23: {
          type: "list",
          member: {}
        },
        S2p: {
          type: "structure",
          required: [
            "GrantArn",
            "GrantName",
            "ParentArn",
            "LicenseArn",
            "GranteePrincipalArn",
            "HomeRegion",
            "GrantStatus",
            "Version",
            "GrantedOperations"
          ],
          members: {
            GrantArn: {},
            GrantName: {},
            ParentArn: {},
            LicenseArn: {},
            GranteePrincipalArn: {},
            HomeRegion: {},
            GrantStatus: {},
            StatusReason: {},
            Version: {},
            GrantedOperations: {
              shape: "So"
            }
          }
        },
        S2s: {
          type: "structure",
          members: {
            LicenseArn: {},
            LicenseName: {},
            ProductName: {},
            ProductSKU: {},
            Issuer: {
              shape: "S2t"
            },
            HomeRegion: {},
            Status: {},
            Validity: {
              shape: "Sw"
            },
            Beneficiary: {},
            Entitlements: {
              shape: "Sx"
            },
            ConsumptionConfiguration: {
              shape: "S12"
            },
            LicenseMetadata: {
              shape: "Sd"
            },
            CreateTime: {},
            Version: {}
          }
        },
        S2t: {
          type: "structure",
          members: {
            Name: {},
            SignKey: {},
            KeyFingerprint: {}
          }
        },
        S2w: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceType: {},
              ConsumedLicenses: {
                type: "long"
              }
            }
          }
        },
        S2z: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceType: {},
              AssociationCount: {
                type: "long"
              }
            }
          }
        },
        S31: {
          type: "structure",
          members: {
            LastRunTime: {
              type: "timestamp"
            }
          }
        },
        S38: {
          type: "structure",
          members: {
            ReportGeneratorName: {},
            ReportType: {
              shape: "S1r"
            },
            ReportContext: {
              shape: "S1t"
            },
            ReportFrequency: {
              shape: "S1v"
            },
            LicenseManagerReportGeneratorArn: {},
            LastRunStatus: {},
            LastRunFailureReason: {},
            LastReportGenerationTime: {},
            ReportCreatorAccount: {},
            Description: {},
            S3Location: {
              type: "structure",
              members: {
                bucket: {},
                keyPrefix: {}
              }
            },
            CreateTime: {},
            Tags: {
              shape: "S1d"
            }
          }
        },
        S3h: {
          type: "structure",
          required: [
            "EnableIntegration"
          ],
          members: {
            EnableIntegration: {
              type: "boolean"
            }
          }
        },
        S3n: {
          type: "list",
          member: {
            shape: "S3o"
          }
        },
        S3o: {
          type: "structure",
          members: {
            Name: {},
            Values: {
              type: "list",
              member: {}
            }
          }
        },
        S3u: {
          type: "list",
          member: {
            shape: "S2p"
          }
        },
        S40: {
          type: "list",
          member: {
            shape: "S3o"
          }
        },
        S4d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "LicenseConfigurationArn"
            ],
            members: {
              LicenseConfigurationArn: {},
              AmiAssociationScope: {}
            }
          }
        },
        S4h: {
          type: "list",
          member: {
            shape: "S2s"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/license-manager-2018-08-01.paginators.json
var require_license_manager_2018_08_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/license-manager-2018-08-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/licensemanager.js
var require_licensemanager = __commonJS({
  "node_modules/aws-sdk/clients/licensemanager.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["licensemanager"] = {};
    AWS3.LicenseManager = Service.defineService("licensemanager", ["2018-08-01"]);
    Object.defineProperty(apiLoader.services["licensemanager"], "2018-08-01", {
      get: function get() {
        var model = require_license_manager_2018_08_01_min();
        model.paginators = require_license_manager_2018_08_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.LicenseManager;
  }
});

// node_modules/aws-sdk/apis/kafka-2018-11-14.min.json
var require_kafka_2018_11_14_min = __commonJS({
  "node_modules/aws-sdk/apis/kafka-2018-11-14.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2018-11-14",
        endpointPrefix: "kafka",
        signingName: "kafka",
        serviceFullName: "Managed Streaming for Kafka",
        serviceAbbreviation: "Kafka",
        serviceId: "Kafka",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "kafka-2018-11-14",
        signatureVersion: "v4"
      },
      operations: {
        BatchAssociateScramSecret: {
          http: {
            requestUri: "/v1/clusters/{clusterArn}/scram-secrets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              SecretArnList: {
                shape: "S3",
                locationName: "secretArnList"
              }
            },
            required: [
              "ClusterArn",
              "SecretArnList"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              UnprocessedScramSecrets: {
                shape: "S5",
                locationName: "unprocessedScramSecrets"
              }
            }
          }
        },
        CreateCluster: {
          http: {
            requestUri: "/v1/clusters",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerNodeGroupInfo: {
                shape: "S8",
                locationName: "brokerNodeGroupInfo"
              },
              ClientAuthentication: {
                shape: "Se",
                locationName: "clientAuthentication"
              },
              ClusterName: {
                locationName: "clusterName"
              },
              ConfigurationInfo: {
                shape: "Sm",
                locationName: "configurationInfo"
              },
              EncryptionInfo: {
                shape: "So",
                locationName: "encryptionInfo"
              },
              EnhancedMonitoring: {
                locationName: "enhancedMonitoring"
              },
              OpenMonitoring: {
                shape: "St",
                locationName: "openMonitoring"
              },
              KafkaVersion: {
                locationName: "kafkaVersion"
              },
              LoggingInfo: {
                shape: "Sy",
                locationName: "loggingInfo"
              },
              NumberOfBrokerNodes: {
                locationName: "numberOfBrokerNodes",
                type: "integer"
              },
              Tags: {
                shape: "S14",
                locationName: "tags"
              }
            },
            required: [
              "BrokerNodeGroupInfo",
              "KafkaVersion",
              "NumberOfBrokerNodes",
              "ClusterName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterName: {
                locationName: "clusterName"
              },
              State: {
                locationName: "state"
              }
            }
          }
        },
        CreateConfiguration: {
          http: {
            requestUri: "/v1/configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Description: {
                locationName: "description"
              },
              KafkaVersions: {
                shape: "S3",
                locationName: "kafkaVersions"
              },
              Name: {
                locationName: "name"
              },
              ServerProperties: {
                locationName: "serverProperties",
                type: "blob"
              }
            },
            required: [
              "ServerProperties",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              CreationTime: {
                shape: "S1a",
                locationName: "creationTime"
              },
              LatestRevision: {
                shape: "S1b",
                locationName: "latestRevision"
              },
              Name: {
                locationName: "name"
              },
              State: {
                locationName: "state"
              }
            }
          }
        },
        DeleteCluster: {
          http: {
            method: "DELETE",
            requestUri: "/v1/clusters/{clusterArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              CurrentVersion: {
                location: "querystring",
                locationName: "currentVersion"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              State: {
                locationName: "state"
              }
            }
          }
        },
        DeleteConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/v1/configurations/{arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                location: "uri",
                locationName: "arn"
              }
            },
            required: [
              "Arn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              State: {
                locationName: "state"
              }
            }
          }
        },
        DescribeCluster: {
          http: {
            method: "GET",
            requestUri: "/v1/clusters/{clusterArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterInfo: {
                shape: "S1j",
                locationName: "clusterInfo"
              }
            }
          }
        },
        DescribeClusterOperation: {
          http: {
            method: "GET",
            requestUri: "/v1/operations/{clusterOperationArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterOperationArn: {
                location: "uri",
                locationName: "clusterOperationArn"
              }
            },
            required: [
              "ClusterOperationArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterOperationInfo: {
                shape: "S1t",
                locationName: "clusterOperationInfo"
              }
            }
          }
        },
        DescribeConfiguration: {
          http: {
            method: "GET",
            requestUri: "/v1/configurations/{arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                location: "uri",
                locationName: "arn"
              }
            },
            required: [
              "Arn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              CreationTime: {
                shape: "S1a",
                locationName: "creationTime"
              },
              Description: {
                locationName: "description"
              },
              KafkaVersions: {
                shape: "S3",
                locationName: "kafkaVersions"
              },
              LatestRevision: {
                shape: "S1b",
                locationName: "latestRevision"
              },
              Name: {
                locationName: "name"
              },
              State: {
                locationName: "state"
              }
            }
          }
        },
        DescribeConfigurationRevision: {
          http: {
            method: "GET",
            requestUri: "/v1/configurations/{arn}/revisions/{revision}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                location: "uri",
                locationName: "arn"
              },
              Revision: {
                location: "uri",
                locationName: "revision",
                type: "long"
              }
            },
            required: [
              "Revision",
              "Arn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              CreationTime: {
                shape: "S1a",
                locationName: "creationTime"
              },
              Description: {
                locationName: "description"
              },
              Revision: {
                locationName: "revision",
                type: "long"
              },
              ServerProperties: {
                locationName: "serverProperties",
                type: "blob"
              }
            }
          }
        },
        BatchDisassociateScramSecret: {
          http: {
            method: "PATCH",
            requestUri: "/v1/clusters/{clusterArn}/scram-secrets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              SecretArnList: {
                shape: "S3",
                locationName: "secretArnList"
              }
            },
            required: [
              "ClusterArn",
              "SecretArnList"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              UnprocessedScramSecrets: {
                shape: "S5",
                locationName: "unprocessedScramSecrets"
              }
            }
          }
        },
        GetBootstrapBrokers: {
          http: {
            method: "GET",
            requestUri: "/v1/clusters/{clusterArn}/bootstrap-brokers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              BootstrapBrokerString: {
                locationName: "bootstrapBrokerString"
              },
              BootstrapBrokerStringTls: {
                locationName: "bootstrapBrokerStringTls"
              },
              BootstrapBrokerStringSaslScram: {
                locationName: "bootstrapBrokerStringSaslScram"
              },
              BootstrapBrokerStringSaslIam: {
                locationName: "bootstrapBrokerStringSaslIam"
              }
            }
          }
        },
        GetCompatibleKafkaVersions: {
          http: {
            method: "GET",
            requestUri: "/v1/compatible-kafka-versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "querystring",
                locationName: "clusterArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CompatibleKafkaVersions: {
                locationName: "compatibleKafkaVersions",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceVersion: {
                      locationName: "sourceVersion"
                    },
                    TargetVersions: {
                      shape: "S3",
                      locationName: "targetVersions"
                    }
                  }
                }
              }
            }
          }
        },
        ListClusterOperations: {
          http: {
            method: "GET",
            requestUri: "/v1/clusters/{clusterArn}/operations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterOperationInfoList: {
                locationName: "clusterOperationInfoList",
                type: "list",
                member: {
                  shape: "S1t"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListClusters: {
          http: {
            method: "GET",
            requestUri: "/v1/clusters",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterNameFilter: {
                location: "querystring",
                locationName: "clusterNameFilter"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClusterInfoList: {
                locationName: "clusterInfoList",
                type: "list",
                member: {
                  shape: "S1j"
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListConfigurationRevisions: {
          http: {
            method: "GET",
            requestUri: "/v1/configurations/{arn}/revisions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                location: "uri",
                locationName: "arn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "Arn"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Revisions: {
                locationName: "revisions",
                type: "list",
                member: {
                  shape: "S1b"
                }
              }
            }
          }
        },
        ListConfigurations: {
          http: {
            method: "GET",
            requestUri: "/v1/configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Configurations: {
                locationName: "configurations",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    CreationTime: {
                      shape: "S1a",
                      locationName: "creationTime"
                    },
                    Description: {
                      locationName: "description"
                    },
                    KafkaVersions: {
                      shape: "S3",
                      locationName: "kafkaVersions"
                    },
                    LatestRevision: {
                      shape: "S1b",
                      locationName: "latestRevision"
                    },
                    Name: {
                      locationName: "name"
                    },
                    State: {
                      locationName: "state"
                    }
                  },
                  required: [
                    "Description",
                    "LatestRevision",
                    "CreationTime",
                    "KafkaVersions",
                    "Arn",
                    "Name",
                    "State"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListKafkaVersions: {
          http: {
            method: "GET",
            requestUri: "/v1/kafka-versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KafkaVersions: {
                locationName: "kafkaVersions",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Version: {
                      locationName: "version"
                    },
                    Status: {
                      locationName: "status"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListNodes: {
          http: {
            method: "GET",
            requestUri: "/v1/clusters/{clusterArn}/nodes",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              NodeInfoList: {
                locationName: "nodeInfoList",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AddedToClusterTime: {
                      locationName: "addedToClusterTime"
                    },
                    BrokerNodeInfo: {
                      locationName: "brokerNodeInfo",
                      type: "structure",
                      members: {
                        AttachedENIId: {
                          locationName: "attachedENIId"
                        },
                        BrokerId: {
                          locationName: "brokerId",
                          type: "double"
                        },
                        ClientSubnet: {
                          locationName: "clientSubnet"
                        },
                        ClientVpcIpAddress: {
                          locationName: "clientVpcIpAddress"
                        },
                        CurrentBrokerSoftwareInfo: {
                          shape: "S1k",
                          locationName: "currentBrokerSoftwareInfo"
                        },
                        Endpoints: {
                          shape: "S3",
                          locationName: "endpoints"
                        }
                      }
                    },
                    InstanceType: {
                      locationName: "instanceType"
                    },
                    NodeARN: {
                      locationName: "nodeARN"
                    },
                    NodeType: {
                      locationName: "nodeType"
                    },
                    ZookeeperNodeInfo: {
                      locationName: "zookeeperNodeInfo",
                      type: "structure",
                      members: {
                        AttachedENIId: {
                          locationName: "attachedENIId"
                        },
                        ClientVpcIpAddress: {
                          locationName: "clientVpcIpAddress"
                        },
                        Endpoints: {
                          shape: "S3",
                          locationName: "endpoints"
                        },
                        ZookeeperId: {
                          locationName: "zookeeperId",
                          type: "double"
                        },
                        ZookeeperVersion: {
                          locationName: "zookeeperVersion"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListScramSecrets: {
          http: {
            method: "GET",
            requestUri: "/v1/clusters/{clusterArn}/scram-secrets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              SecretArnList: {
                shape: "S3",
                locationName: "secretArnList"
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/v1/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S14",
                locationName: "tags"
              }
            }
          }
        },
        RebootBroker: {
          http: {
            method: "PUT",
            requestUri: "/v1/clusters/{clusterArn}/reboot-broker",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              BrokerIds: {
                shape: "S3",
                locationName: "brokerIds"
              },
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              }
            },
            required: [
              "ClusterArn",
              "BrokerIds"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterOperationArn: {
                locationName: "clusterOperationArn"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/v1/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "S14",
                locationName: "tags"
              }
            },
            required: [
              "ResourceArn",
              "Tags"
            ]
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/v1/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                shape: "S3",
                location: "querystring",
                locationName: "tagKeys"
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ]
          }
        },
        UpdateBrokerCount: {
          http: {
            method: "PUT",
            requestUri: "/v1/clusters/{clusterArn}/nodes/count",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              CurrentVersion: {
                locationName: "currentVersion"
              },
              TargetNumberOfBrokerNodes: {
                locationName: "targetNumberOfBrokerNodes",
                type: "integer"
              }
            },
            required: [
              "ClusterArn",
              "CurrentVersion",
              "TargetNumberOfBrokerNodes"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterOperationArn: {
                locationName: "clusterOperationArn"
              }
            }
          }
        },
        UpdateBrokerType: {
          http: {
            method: "PUT",
            requestUri: "/v1/clusters/{clusterArn}/nodes/type",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              CurrentVersion: {
                locationName: "currentVersion"
              },
              TargetInstanceType: {
                locationName: "targetInstanceType"
              }
            },
            required: [
              "ClusterArn",
              "CurrentVersion",
              "TargetInstanceType"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterOperationArn: {
                locationName: "clusterOperationArn"
              }
            }
          }
        },
        UpdateBrokerStorage: {
          http: {
            method: "PUT",
            requestUri: "/v1/clusters/{clusterArn}/nodes/storage",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              CurrentVersion: {
                locationName: "currentVersion"
              },
              TargetBrokerEBSVolumeInfo: {
                shape: "S1z",
                locationName: "targetBrokerEBSVolumeInfo"
              }
            },
            required: [
              "ClusterArn",
              "TargetBrokerEBSVolumeInfo",
              "CurrentVersion"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterOperationArn: {
                locationName: "clusterOperationArn"
              }
            }
          }
        },
        UpdateConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/v1/configurations/{arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Arn: {
                location: "uri",
                locationName: "arn"
              },
              Description: {
                locationName: "description"
              },
              ServerProperties: {
                locationName: "serverProperties",
                type: "blob"
              }
            },
            required: [
              "Arn",
              "ServerProperties"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {
                locationName: "arn"
              },
              LatestRevision: {
                shape: "S1b",
                locationName: "latestRevision"
              }
            }
          }
        },
        UpdateClusterConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/v1/clusters/{clusterArn}/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              ConfigurationInfo: {
                shape: "Sm",
                locationName: "configurationInfo"
              },
              CurrentVersion: {
                locationName: "currentVersion"
              }
            },
            required: [
              "ClusterArn",
              "CurrentVersion",
              "ConfigurationInfo"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterOperationArn: {
                locationName: "clusterOperationArn"
              }
            }
          }
        },
        UpdateClusterKafkaVersion: {
          http: {
            method: "PUT",
            requestUri: "/v1/clusters/{clusterArn}/version",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              ConfigurationInfo: {
                shape: "Sm",
                locationName: "configurationInfo"
              },
              CurrentVersion: {
                locationName: "currentVersion"
              },
              TargetKafkaVersion: {
                locationName: "targetKafkaVersion"
              }
            },
            required: [
              "ClusterArn",
              "TargetKafkaVersion",
              "CurrentVersion"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterOperationArn: {
                locationName: "clusterOperationArn"
              }
            }
          }
        },
        UpdateMonitoring: {
          http: {
            method: "PUT",
            requestUri: "/v1/clusters/{clusterArn}/monitoring",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              CurrentVersion: {
                locationName: "currentVersion"
              },
              EnhancedMonitoring: {
                locationName: "enhancedMonitoring"
              },
              OpenMonitoring: {
                shape: "St",
                locationName: "openMonitoring"
              },
              LoggingInfo: {
                shape: "Sy",
                locationName: "loggingInfo"
              }
            },
            required: [
              "ClusterArn",
              "CurrentVersion"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterOperationArn: {
                locationName: "clusterOperationArn"
              }
            }
          }
        },
        UpdateSecurity: {
          http: {
            method: "PATCH",
            requestUri: "/v1/clusters/{clusterArn}/security",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClientAuthentication: {
                shape: "Se",
                locationName: "clientAuthentication"
              },
              ClusterArn: {
                location: "uri",
                locationName: "clusterArn"
              },
              CurrentVersion: {
                locationName: "currentVersion"
              },
              EncryptionInfo: {
                shape: "So",
                locationName: "encryptionInfo"
              }
            },
            required: [
              "ClusterArn",
              "CurrentVersion"
            ]
          },
          output: {
            type: "structure",
            members: {
              ClusterArn: {
                locationName: "clusterArn"
              },
              ClusterOperationArn: {
                locationName: "clusterOperationArn"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        S5: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ErrorCode: {
                locationName: "errorCode"
              },
              ErrorMessage: {
                locationName: "errorMessage"
              },
              SecretArn: {
                locationName: "secretArn"
              }
            }
          }
        },
        S8: {
          type: "structure",
          members: {
            BrokerAZDistribution: {
              locationName: "brokerAZDistribution"
            },
            ClientSubnets: {
              shape: "S3",
              locationName: "clientSubnets"
            },
            InstanceType: {
              locationName: "instanceType"
            },
            SecurityGroups: {
              shape: "S3",
              locationName: "securityGroups"
            },
            StorageInfo: {
              locationName: "storageInfo",
              type: "structure",
              members: {
                EbsStorageInfo: {
                  locationName: "ebsStorageInfo",
                  type: "structure",
                  members: {
                    VolumeSize: {
                      locationName: "volumeSize",
                      type: "integer"
                    }
                  }
                }
              }
            }
          },
          required: [
            "ClientSubnets",
            "InstanceType"
          ]
        },
        Se: {
          type: "structure",
          members: {
            Sasl: {
              locationName: "sasl",
              type: "structure",
              members: {
                Scram: {
                  locationName: "scram",
                  type: "structure",
                  members: {
                    Enabled: {
                      locationName: "enabled",
                      type: "boolean"
                    }
                  }
                },
                Iam: {
                  locationName: "iam",
                  type: "structure",
                  members: {
                    Enabled: {
                      locationName: "enabled",
                      type: "boolean"
                    }
                  }
                }
              }
            },
            Tls: {
              locationName: "tls",
              type: "structure",
              members: {
                CertificateAuthorityArnList: {
                  shape: "S3",
                  locationName: "certificateAuthorityArnList"
                },
                Enabled: {
                  locationName: "enabled",
                  type: "boolean"
                }
              }
            },
            Unauthenticated: {
              locationName: "unauthenticated",
              type: "structure",
              members: {
                Enabled: {
                  locationName: "enabled",
                  type: "boolean"
                }
              }
            }
          }
        },
        Sm: {
          type: "structure",
          members: {
            Arn: {
              locationName: "arn"
            },
            Revision: {
              locationName: "revision",
              type: "long"
            }
          },
          required: [
            "Revision",
            "Arn"
          ]
        },
        So: {
          type: "structure",
          members: {
            EncryptionAtRest: {
              locationName: "encryptionAtRest",
              type: "structure",
              members: {
                DataVolumeKMSKeyId: {
                  locationName: "dataVolumeKMSKeyId"
                }
              },
              required: [
                "DataVolumeKMSKeyId"
              ]
            },
            EncryptionInTransit: {
              locationName: "encryptionInTransit",
              type: "structure",
              members: {
                ClientBroker: {
                  locationName: "clientBroker"
                },
                InCluster: {
                  locationName: "inCluster",
                  type: "boolean"
                }
              }
            }
          }
        },
        St: {
          type: "structure",
          members: {
            Prometheus: {
              locationName: "prometheus",
              type: "structure",
              members: {
                JmxExporter: {
                  locationName: "jmxExporter",
                  type: "structure",
                  members: {
                    EnabledInBroker: {
                      locationName: "enabledInBroker",
                      type: "boolean"
                    }
                  },
                  required: [
                    "EnabledInBroker"
                  ]
                },
                NodeExporter: {
                  locationName: "nodeExporter",
                  type: "structure",
                  members: {
                    EnabledInBroker: {
                      locationName: "enabledInBroker",
                      type: "boolean"
                    }
                  },
                  required: [
                    "EnabledInBroker"
                  ]
                }
              }
            }
          },
          required: [
            "Prometheus"
          ]
        },
        Sy: {
          type: "structure",
          members: {
            BrokerLogs: {
              locationName: "brokerLogs",
              type: "structure",
              members: {
                CloudWatchLogs: {
                  locationName: "cloudWatchLogs",
                  type: "structure",
                  members: {
                    Enabled: {
                      locationName: "enabled",
                      type: "boolean"
                    },
                    LogGroup: {
                      locationName: "logGroup"
                    }
                  },
                  required: [
                    "Enabled"
                  ]
                },
                Firehose: {
                  locationName: "firehose",
                  type: "structure",
                  members: {
                    DeliveryStream: {
                      locationName: "deliveryStream"
                    },
                    Enabled: {
                      locationName: "enabled",
                      type: "boolean"
                    }
                  },
                  required: [
                    "Enabled"
                  ]
                },
                S3: {
                  locationName: "s3",
                  type: "structure",
                  members: {
                    Bucket: {
                      locationName: "bucket"
                    },
                    Enabled: {
                      locationName: "enabled",
                      type: "boolean"
                    },
                    Prefix: {
                      locationName: "prefix"
                    }
                  },
                  required: [
                    "Enabled"
                  ]
                }
              }
            }
          },
          required: [
            "BrokerLogs"
          ]
        },
        S14: {
          type: "map",
          key: {},
          value: {}
        },
        S1a: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S1b: {
          type: "structure",
          members: {
            CreationTime: {
              shape: "S1a",
              locationName: "creationTime"
            },
            Description: {
              locationName: "description"
            },
            Revision: {
              locationName: "revision",
              type: "long"
            }
          },
          required: [
            "Revision",
            "CreationTime"
          ]
        },
        S1j: {
          type: "structure",
          members: {
            ActiveOperationArn: {
              locationName: "activeOperationArn"
            },
            BrokerNodeGroupInfo: {
              shape: "S8",
              locationName: "brokerNodeGroupInfo"
            },
            ClientAuthentication: {
              shape: "Se",
              locationName: "clientAuthentication"
            },
            ClusterArn: {
              locationName: "clusterArn"
            },
            ClusterName: {
              locationName: "clusterName"
            },
            CreationTime: {
              shape: "S1a",
              locationName: "creationTime"
            },
            CurrentBrokerSoftwareInfo: {
              shape: "S1k",
              locationName: "currentBrokerSoftwareInfo"
            },
            CurrentVersion: {
              locationName: "currentVersion"
            },
            EncryptionInfo: {
              shape: "So",
              locationName: "encryptionInfo"
            },
            EnhancedMonitoring: {
              locationName: "enhancedMonitoring"
            },
            OpenMonitoring: {
              shape: "S1l",
              locationName: "openMonitoring"
            },
            LoggingInfo: {
              shape: "Sy",
              locationName: "loggingInfo"
            },
            NumberOfBrokerNodes: {
              locationName: "numberOfBrokerNodes",
              type: "integer"
            },
            State: {
              locationName: "state"
            },
            StateInfo: {
              locationName: "stateInfo",
              type: "structure",
              members: {
                Code: {
                  locationName: "code"
                },
                Message: {
                  locationName: "message"
                }
              }
            },
            Tags: {
              shape: "S14",
              locationName: "tags"
            },
            ZookeeperConnectString: {
              locationName: "zookeeperConnectString"
            },
            ZookeeperConnectStringTls: {
              locationName: "zookeeperConnectStringTls"
            }
          }
        },
        S1k: {
          type: "structure",
          members: {
            ConfigurationArn: {
              locationName: "configurationArn"
            },
            ConfigurationRevision: {
              locationName: "configurationRevision",
              type: "long"
            },
            KafkaVersion: {
              locationName: "kafkaVersion"
            }
          }
        },
        S1l: {
          type: "structure",
          members: {
            Prometheus: {
              locationName: "prometheus",
              type: "structure",
              members: {
                JmxExporter: {
                  locationName: "jmxExporter",
                  type: "structure",
                  members: {
                    EnabledInBroker: {
                      locationName: "enabledInBroker",
                      type: "boolean"
                    }
                  },
                  required: [
                    "EnabledInBroker"
                  ]
                },
                NodeExporter: {
                  locationName: "nodeExporter",
                  type: "structure",
                  members: {
                    EnabledInBroker: {
                      locationName: "enabledInBroker",
                      type: "boolean"
                    }
                  },
                  required: [
                    "EnabledInBroker"
                  ]
                }
              }
            }
          },
          required: [
            "Prometheus"
          ]
        },
        S1t: {
          type: "structure",
          members: {
            ClientRequestId: {
              locationName: "clientRequestId"
            },
            ClusterArn: {
              locationName: "clusterArn"
            },
            CreationTime: {
              shape: "S1a",
              locationName: "creationTime"
            },
            EndTime: {
              shape: "S1a",
              locationName: "endTime"
            },
            ErrorInfo: {
              locationName: "errorInfo",
              type: "structure",
              members: {
                ErrorCode: {
                  locationName: "errorCode"
                },
                ErrorString: {
                  locationName: "errorString"
                }
              }
            },
            OperationArn: {
              locationName: "operationArn"
            },
            OperationState: {
              locationName: "operationState"
            },
            OperationSteps: {
              locationName: "operationSteps",
              type: "list",
              member: {
                type: "structure",
                members: {
                  StepInfo: {
                    locationName: "stepInfo",
                    type: "structure",
                    members: {
                      StepStatus: {
                        locationName: "stepStatus"
                      }
                    }
                  },
                  StepName: {
                    locationName: "stepName"
                  }
                }
              }
            },
            OperationType: {
              locationName: "operationType"
            },
            SourceClusterInfo: {
              shape: "S1y",
              locationName: "sourceClusterInfo"
            },
            TargetClusterInfo: {
              shape: "S1y",
              locationName: "targetClusterInfo"
            }
          }
        },
        S1y: {
          type: "structure",
          members: {
            BrokerEBSVolumeInfo: {
              shape: "S1z",
              locationName: "brokerEBSVolumeInfo"
            },
            ConfigurationInfo: {
              shape: "Sm",
              locationName: "configurationInfo"
            },
            NumberOfBrokerNodes: {
              locationName: "numberOfBrokerNodes",
              type: "integer"
            },
            EnhancedMonitoring: {
              locationName: "enhancedMonitoring"
            },
            OpenMonitoring: {
              shape: "S1l",
              locationName: "openMonitoring"
            },
            KafkaVersion: {
              locationName: "kafkaVersion"
            },
            LoggingInfo: {
              shape: "Sy",
              locationName: "loggingInfo"
            },
            InstanceType: {
              locationName: "instanceType"
            },
            ClientAuthentication: {
              shape: "Se",
              locationName: "clientAuthentication"
            },
            EncryptionInfo: {
              shape: "So",
              locationName: "encryptionInfo"
            }
          }
        },
        S1z: {
          type: "list",
          member: {
            type: "structure",
            members: {
              KafkaBrokerNodeId: {
                locationName: "kafkaBrokerNodeId"
              },
              VolumeSizeGB: {
                locationName: "volumeSizeGB",
                type: "integer"
              }
            },
            required: [
              "VolumeSizeGB",
              "KafkaBrokerNodeId"
            ]
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kafka-2018-11-14.paginators.json
var require_kafka_2018_11_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kafka-2018-11-14.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListClusters: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ClusterInfoList"
        },
        ListConfigurations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Configurations"
        },
        ListKafkaVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "KafkaVersions"
        },
        ListNodes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "NodeInfoList"
        },
        ListClusterOperations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ClusterOperationInfoList"
        },
        ListConfigurationRevisions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Revisions"
        },
        ListScramSecrets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "SecretArnList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/kafka.js
var require_kafka = __commonJS({
  "node_modules/aws-sdk/clients/kafka.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["kafka"] = {};
    AWS3.Kafka = Service.defineService("kafka", ["2018-11-14"]);
    Object.defineProperty(apiLoader.services["kafka"], "2018-11-14", {
      get: function get() {
        var model = require_kafka_2018_11_14_min();
        model.paginators = require_kafka_2018_11_14_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Kafka;
  }
});

// node_modules/aws-sdk/apis/apigatewaymanagementapi-2018-11-29.min.json
var require_apigatewaymanagementapi_2018_11_29_min = __commonJS({
  "node_modules/aws-sdk/apis/apigatewaymanagementapi-2018-11-29.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2018-11-29",
        endpointPrefix: "execute-api",
        signingName: "execute-api",
        serviceFullName: "AmazonApiGatewayManagementApi",
        serviceId: "ApiGatewayManagementApi",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "apigatewaymanagementapi-2018-11-29",
        signatureVersion: "v4"
      },
      operations: {
        DeleteConnection: {
          http: {
            method: "DELETE",
            requestUri: "/@connections/{connectionId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ConnectionId: {
                location: "uri",
                locationName: "connectionId"
              }
            },
            required: [
              "ConnectionId"
            ]
          }
        },
        GetConnection: {
          http: {
            method: "GET",
            requestUri: "/@connections/{connectionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ConnectionId: {
                location: "uri",
                locationName: "connectionId"
              }
            },
            required: [
              "ConnectionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ConnectedAt: {
                shape: "S5",
                locationName: "connectedAt"
              },
              Identity: {
                locationName: "identity",
                type: "structure",
                members: {
                  SourceIp: {
                    locationName: "sourceIp"
                  },
                  UserAgent: {
                    locationName: "userAgent"
                  }
                },
                required: [
                  "SourceIp",
                  "UserAgent"
                ]
              },
              LastActiveAt: {
                shape: "S5",
                locationName: "lastActiveAt"
              }
            }
          }
        },
        PostToConnection: {
          http: {
            requestUri: "/@connections/{connectionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Data: {
                type: "blob"
              },
              ConnectionId: {
                location: "uri",
                locationName: "connectionId"
              }
            },
            required: [
              "ConnectionId",
              "Data"
            ],
            payload: "Data"
          }
        }
      },
      shapes: {
        S5: {
          type: "timestamp",
          timestampFormat: "iso8601"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/apigatewaymanagementapi-2018-11-29.paginators.json
var require_apigatewaymanagementapi_2018_11_29_paginators = __commonJS({
  "node_modules/aws-sdk/apis/apigatewaymanagementapi-2018-11-29.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/apigatewaymanagementapi.js
var require_apigatewaymanagementapi = __commonJS({
  "node_modules/aws-sdk/clients/apigatewaymanagementapi.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["apigatewaymanagementapi"] = {};
    AWS3.ApiGatewayManagementApi = Service.defineService("apigatewaymanagementapi", ["2018-11-29"]);
    Object.defineProperty(apiLoader.services["apigatewaymanagementapi"], "2018-11-29", {
      get: function get() {
        var model = require_apigatewaymanagementapi_2018_11_29_min();
        model.paginators = require_apigatewaymanagementapi_2018_11_29_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ApiGatewayManagementApi;
  }
});

// node_modules/aws-sdk/apis/apigatewayv2-2018-11-29.min.json
var require_apigatewayv2_2018_11_29_min = __commonJS({
  "node_modules/aws-sdk/apis/apigatewayv2-2018-11-29.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2018-11-29",
        endpointPrefix: "apigateway",
        signingName: "apigateway",
        serviceFullName: "AmazonApiGatewayV2",
        serviceId: "ApiGatewayV2",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "apigatewayv2-2018-11-29",
        signatureVersion: "v4"
      },
      operations: {
        CreateApi: {
          http: {
            requestUri: "/v2/apis",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApiKeySelectionExpression: {
                locationName: "apiKeySelectionExpression"
              },
              CorsConfiguration: {
                shape: "S3",
                locationName: "corsConfiguration"
              },
              CredentialsArn: {
                locationName: "credentialsArn"
              },
              Description: {
                locationName: "description"
              },
              DisableSchemaValidation: {
                locationName: "disableSchemaValidation",
                type: "boolean"
              },
              DisableExecuteApiEndpoint: {
                locationName: "disableExecuteApiEndpoint",
                type: "boolean"
              },
              Name: {
                locationName: "name"
              },
              ProtocolType: {
                locationName: "protocolType"
              },
              RouteKey: {
                locationName: "routeKey"
              },
              RouteSelectionExpression: {
                locationName: "routeSelectionExpression"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              Target: {
                locationName: "target"
              },
              Version: {
                locationName: "version"
              }
            },
            required: [
              "ProtocolType",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiEndpoint: {
                locationName: "apiEndpoint"
              },
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ApiId: {
                locationName: "apiId"
              },
              ApiKeySelectionExpression: {
                locationName: "apiKeySelectionExpression"
              },
              CorsConfiguration: {
                shape: "S3",
                locationName: "corsConfiguration"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              Description: {
                locationName: "description"
              },
              DisableSchemaValidation: {
                locationName: "disableSchemaValidation",
                type: "boolean"
              },
              DisableExecuteApiEndpoint: {
                locationName: "disableExecuteApiEndpoint",
                type: "boolean"
              },
              ImportInfo: {
                shape: "Sm",
                locationName: "importInfo"
              },
              Name: {
                locationName: "name"
              },
              ProtocolType: {
                locationName: "protocolType"
              },
              RouteSelectionExpression: {
                locationName: "routeSelectionExpression"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              Version: {
                locationName: "version"
              },
              Warnings: {
                shape: "Sm",
                locationName: "warnings"
              }
            }
          }
        },
        CreateApiMapping: {
          http: {
            requestUri: "/v2/domainnames/{domainName}/apimappings",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                locationName: "apiId"
              },
              ApiMappingKey: {
                locationName: "apiMappingKey"
              },
              DomainName: {
                location: "uri",
                locationName: "domainName"
              },
              Stage: {
                locationName: "stage"
              }
            },
            required: [
              "DomainName",
              "Stage",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiId: {
                locationName: "apiId"
              },
              ApiMappingId: {
                locationName: "apiMappingId"
              },
              ApiMappingKey: {
                locationName: "apiMappingKey"
              },
              Stage: {
                locationName: "stage"
              }
            }
          }
        },
        CreateAuthorizer: {
          http: {
            requestUri: "/v2/apis/{apiId}/authorizers",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              AuthorizerCredentialsArn: {
                locationName: "authorizerCredentialsArn"
              },
              AuthorizerPayloadFormatVersion: {
                locationName: "authorizerPayloadFormatVersion"
              },
              AuthorizerResultTtlInSeconds: {
                locationName: "authorizerResultTtlInSeconds",
                type: "integer"
              },
              AuthorizerType: {
                locationName: "authorizerType"
              },
              AuthorizerUri: {
                locationName: "authorizerUri"
              },
              EnableSimpleResponses: {
                locationName: "enableSimpleResponses",
                type: "boolean"
              },
              IdentitySource: {
                shape: "Ss",
                locationName: "identitySource"
              },
              IdentityValidationExpression: {
                locationName: "identityValidationExpression"
              },
              JwtConfiguration: {
                shape: "St",
                locationName: "jwtConfiguration"
              },
              Name: {
                locationName: "name"
              }
            },
            required: [
              "ApiId",
              "AuthorizerType",
              "IdentitySource",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              AuthorizerCredentialsArn: {
                locationName: "authorizerCredentialsArn"
              },
              AuthorizerId: {
                locationName: "authorizerId"
              },
              AuthorizerPayloadFormatVersion: {
                locationName: "authorizerPayloadFormatVersion"
              },
              AuthorizerResultTtlInSeconds: {
                locationName: "authorizerResultTtlInSeconds",
                type: "integer"
              },
              AuthorizerType: {
                locationName: "authorizerType"
              },
              AuthorizerUri: {
                locationName: "authorizerUri"
              },
              EnableSimpleResponses: {
                locationName: "enableSimpleResponses",
                type: "boolean"
              },
              IdentitySource: {
                shape: "Ss",
                locationName: "identitySource"
              },
              IdentityValidationExpression: {
                locationName: "identityValidationExpression"
              },
              JwtConfiguration: {
                shape: "St",
                locationName: "jwtConfiguration"
              },
              Name: {
                locationName: "name"
              }
            }
          }
        },
        CreateDeployment: {
          http: {
            requestUri: "/v2/apis/{apiId}/deployments",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              Description: {
                locationName: "description"
              },
              StageName: {
                locationName: "stageName"
              }
            },
            required: [
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AutoDeployed: {
                locationName: "autoDeployed",
                type: "boolean"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              DeploymentId: {
                locationName: "deploymentId"
              },
              DeploymentStatus: {
                locationName: "deploymentStatus"
              },
              DeploymentStatusMessage: {
                locationName: "deploymentStatusMessage"
              },
              Description: {
                locationName: "description"
              }
            }
          }
        },
        CreateDomainName: {
          http: {
            requestUri: "/v2/domainnames",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              DomainName: {
                locationName: "domainName"
              },
              DomainNameConfigurations: {
                shape: "S10",
                locationName: "domainNameConfigurations"
              },
              MutualTlsAuthentication: {
                shape: "S15",
                locationName: "mutualTlsAuthentication"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            },
            required: [
              "DomainName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiMappingSelectionExpression: {
                locationName: "apiMappingSelectionExpression"
              },
              DomainName: {
                locationName: "domainName"
              },
              DomainNameConfigurations: {
                shape: "S10",
                locationName: "domainNameConfigurations"
              },
              MutualTlsAuthentication: {
                shape: "S17",
                locationName: "mutualTlsAuthentication"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            }
          }
        },
        CreateIntegration: {
          http: {
            requestUri: "/v2/apis/{apiId}/integrations",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ConnectionId: {
                locationName: "connectionId"
              },
              ConnectionType: {
                locationName: "connectionType"
              },
              ContentHandlingStrategy: {
                locationName: "contentHandlingStrategy"
              },
              CredentialsArn: {
                locationName: "credentialsArn"
              },
              Description: {
                locationName: "description"
              },
              IntegrationMethod: {
                locationName: "integrationMethod"
              },
              IntegrationSubtype: {
                locationName: "integrationSubtype"
              },
              IntegrationType: {
                locationName: "integrationType"
              },
              IntegrationUri: {
                locationName: "integrationUri"
              },
              PassthroughBehavior: {
                locationName: "passthroughBehavior"
              },
              PayloadFormatVersion: {
                locationName: "payloadFormatVersion"
              },
              RequestParameters: {
                shape: "S1e",
                locationName: "requestParameters"
              },
              RequestTemplates: {
                shape: "S1f",
                locationName: "requestTemplates"
              },
              ResponseParameters: {
                shape: "S1h",
                locationName: "responseParameters"
              },
              TemplateSelectionExpression: {
                locationName: "templateSelectionExpression"
              },
              TimeoutInMillis: {
                locationName: "timeoutInMillis",
                type: "integer"
              },
              TlsConfig: {
                shape: "S1j",
                locationName: "tlsConfig"
              }
            },
            required: [
              "ApiId",
              "IntegrationType"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ConnectionId: {
                locationName: "connectionId"
              },
              ConnectionType: {
                locationName: "connectionType"
              },
              ContentHandlingStrategy: {
                locationName: "contentHandlingStrategy"
              },
              CredentialsArn: {
                locationName: "credentialsArn"
              },
              Description: {
                locationName: "description"
              },
              IntegrationId: {
                locationName: "integrationId"
              },
              IntegrationMethod: {
                locationName: "integrationMethod"
              },
              IntegrationResponseSelectionExpression: {
                locationName: "integrationResponseSelectionExpression"
              },
              IntegrationSubtype: {
                locationName: "integrationSubtype"
              },
              IntegrationType: {
                locationName: "integrationType"
              },
              IntegrationUri: {
                locationName: "integrationUri"
              },
              PassthroughBehavior: {
                locationName: "passthroughBehavior"
              },
              PayloadFormatVersion: {
                locationName: "payloadFormatVersion"
              },
              RequestParameters: {
                shape: "S1e",
                locationName: "requestParameters"
              },
              RequestTemplates: {
                shape: "S1f",
                locationName: "requestTemplates"
              },
              ResponseParameters: {
                shape: "S1h",
                locationName: "responseParameters"
              },
              TemplateSelectionExpression: {
                locationName: "templateSelectionExpression"
              },
              TimeoutInMillis: {
                locationName: "timeoutInMillis",
                type: "integer"
              },
              TlsConfig: {
                shape: "S1l",
                locationName: "tlsConfig"
              }
            }
          }
        },
        CreateIntegrationResponse: {
          http: {
            requestUri: "/v2/apis/{apiId}/integrations/{integrationId}/integrationresponses",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ContentHandlingStrategy: {
                locationName: "contentHandlingStrategy"
              },
              IntegrationId: {
                location: "uri",
                locationName: "integrationId"
              },
              IntegrationResponseKey: {
                locationName: "integrationResponseKey"
              },
              ResponseParameters: {
                shape: "S1e",
                locationName: "responseParameters"
              },
              ResponseTemplates: {
                shape: "S1f",
                locationName: "responseTemplates"
              },
              TemplateSelectionExpression: {
                locationName: "templateSelectionExpression"
              }
            },
            required: [
              "ApiId",
              "IntegrationId",
              "IntegrationResponseKey"
            ]
          },
          output: {
            type: "structure",
            members: {
              ContentHandlingStrategy: {
                locationName: "contentHandlingStrategy"
              },
              IntegrationResponseId: {
                locationName: "integrationResponseId"
              },
              IntegrationResponseKey: {
                locationName: "integrationResponseKey"
              },
              ResponseParameters: {
                shape: "S1e",
                locationName: "responseParameters"
              },
              ResponseTemplates: {
                shape: "S1f",
                locationName: "responseTemplates"
              },
              TemplateSelectionExpression: {
                locationName: "templateSelectionExpression"
              }
            }
          }
        },
        CreateModel: {
          http: {
            requestUri: "/v2/apis/{apiId}/models",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ContentType: {
                locationName: "contentType"
              },
              Description: {
                locationName: "description"
              },
              Name: {
                locationName: "name"
              },
              Schema: {
                locationName: "schema"
              }
            },
            required: [
              "ApiId",
              "Schema",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              ContentType: {
                locationName: "contentType"
              },
              Description: {
                locationName: "description"
              },
              ModelId: {
                locationName: "modelId"
              },
              Name: {
                locationName: "name"
              },
              Schema: {
                locationName: "schema"
              }
            }
          }
        },
        CreateRoute: {
          http: {
            requestUri: "/v2/apis/{apiId}/routes",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ApiKeyRequired: {
                locationName: "apiKeyRequired",
                type: "boolean"
              },
              AuthorizationScopes: {
                shape: "S1s",
                locationName: "authorizationScopes"
              },
              AuthorizationType: {
                locationName: "authorizationType"
              },
              AuthorizerId: {
                locationName: "authorizerId"
              },
              ModelSelectionExpression: {
                locationName: "modelSelectionExpression"
              },
              OperationName: {
                locationName: "operationName"
              },
              RequestModels: {
                shape: "S1u",
                locationName: "requestModels"
              },
              RequestParameters: {
                shape: "S1v",
                locationName: "requestParameters"
              },
              RouteKey: {
                locationName: "routeKey"
              },
              RouteResponseSelectionExpression: {
                locationName: "routeResponseSelectionExpression"
              },
              Target: {
                locationName: "target"
              }
            },
            required: [
              "ApiId",
              "RouteKey"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ApiKeyRequired: {
                locationName: "apiKeyRequired",
                type: "boolean"
              },
              AuthorizationScopes: {
                shape: "S1s",
                locationName: "authorizationScopes"
              },
              AuthorizationType: {
                locationName: "authorizationType"
              },
              AuthorizerId: {
                locationName: "authorizerId"
              },
              ModelSelectionExpression: {
                locationName: "modelSelectionExpression"
              },
              OperationName: {
                locationName: "operationName"
              },
              RequestModels: {
                shape: "S1u",
                locationName: "requestModels"
              },
              RequestParameters: {
                shape: "S1v",
                locationName: "requestParameters"
              },
              RouteId: {
                locationName: "routeId"
              },
              RouteKey: {
                locationName: "routeKey"
              },
              RouteResponseSelectionExpression: {
                locationName: "routeResponseSelectionExpression"
              },
              Target: {
                locationName: "target"
              }
            }
          }
        },
        CreateRouteResponse: {
          http: {
            requestUri: "/v2/apis/{apiId}/routes/{routeId}/routeresponses",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ModelSelectionExpression: {
                locationName: "modelSelectionExpression"
              },
              ResponseModels: {
                shape: "S1u",
                locationName: "responseModels"
              },
              ResponseParameters: {
                shape: "S1v",
                locationName: "responseParameters"
              },
              RouteId: {
                location: "uri",
                locationName: "routeId"
              },
              RouteResponseKey: {
                locationName: "routeResponseKey"
              }
            },
            required: [
              "ApiId",
              "RouteId",
              "RouteResponseKey"
            ]
          },
          output: {
            type: "structure",
            members: {
              ModelSelectionExpression: {
                locationName: "modelSelectionExpression"
              },
              ResponseModels: {
                shape: "S1u",
                locationName: "responseModels"
              },
              ResponseParameters: {
                shape: "S1v",
                locationName: "responseParameters"
              },
              RouteResponseId: {
                locationName: "routeResponseId"
              },
              RouteResponseKey: {
                locationName: "routeResponseKey"
              }
            }
          }
        },
        CreateStage: {
          http: {
            requestUri: "/v2/apis/{apiId}/stages",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              AccessLogSettings: {
                shape: "S21",
                locationName: "accessLogSettings"
              },
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              AutoDeploy: {
                locationName: "autoDeploy",
                type: "boolean"
              },
              ClientCertificateId: {
                locationName: "clientCertificateId"
              },
              DefaultRouteSettings: {
                shape: "S22",
                locationName: "defaultRouteSettings"
              },
              DeploymentId: {
                locationName: "deploymentId"
              },
              Description: {
                locationName: "description"
              },
              RouteSettings: {
                shape: "S26",
                locationName: "routeSettings"
              },
              StageName: {
                locationName: "stageName"
              },
              StageVariables: {
                shape: "S27",
                locationName: "stageVariables"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            },
            required: [
              "ApiId",
              "StageName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AccessLogSettings: {
                shape: "S21",
                locationName: "accessLogSettings"
              },
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              AutoDeploy: {
                locationName: "autoDeploy",
                type: "boolean"
              },
              ClientCertificateId: {
                locationName: "clientCertificateId"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              DefaultRouteSettings: {
                shape: "S22",
                locationName: "defaultRouteSettings"
              },
              DeploymentId: {
                locationName: "deploymentId"
              },
              Description: {
                locationName: "description"
              },
              LastDeploymentStatusMessage: {
                locationName: "lastDeploymentStatusMessage"
              },
              LastUpdatedDate: {
                shape: "Sl",
                locationName: "lastUpdatedDate"
              },
              RouteSettings: {
                shape: "S26",
                locationName: "routeSettings"
              },
              StageName: {
                locationName: "stageName"
              },
              StageVariables: {
                shape: "S27",
                locationName: "stageVariables"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            }
          }
        },
        CreateVpcLink: {
          http: {
            requestUri: "/v2/vpclinks",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Name: {
                locationName: "name"
              },
              SecurityGroupIds: {
                shape: "S2b",
                locationName: "securityGroupIds"
              },
              SubnetIds: {
                shape: "S2c",
                locationName: "subnetIds"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            },
            required: [
              "SubnetIds",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              Name: {
                locationName: "name"
              },
              SecurityGroupIds: {
                shape: "S2b",
                locationName: "securityGroupIds"
              },
              SubnetIds: {
                shape: "S2c",
                locationName: "subnetIds"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              VpcLinkId: {
                locationName: "vpcLinkId"
              },
              VpcLinkStatus: {
                locationName: "vpcLinkStatus"
              },
              VpcLinkStatusMessage: {
                locationName: "vpcLinkStatusMessage"
              },
              VpcLinkVersion: {
                locationName: "vpcLinkVersion"
              }
            }
          }
        },
        DeleteAccessLogSettings: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/stages/{stageName}/accesslogsettings",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              StageName: {
                location: "uri",
                locationName: "stageName"
              }
            },
            required: [
              "StageName",
              "ApiId"
            ]
          }
        },
        DeleteApi: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              }
            },
            required: [
              "ApiId"
            ]
          }
        },
        DeleteApiMapping: {
          http: {
            method: "DELETE",
            requestUri: "/v2/domainnames/{domainName}/apimappings/{apiMappingId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiMappingId: {
                location: "uri",
                locationName: "apiMappingId"
              },
              DomainName: {
                location: "uri",
                locationName: "domainName"
              }
            },
            required: [
              "ApiMappingId",
              "DomainName"
            ]
          }
        },
        DeleteAuthorizer: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/authorizers/{authorizerId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              AuthorizerId: {
                location: "uri",
                locationName: "authorizerId"
              }
            },
            required: [
              "AuthorizerId",
              "ApiId"
            ]
          }
        },
        DeleteCorsConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/cors",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              }
            },
            required: [
              "ApiId"
            ]
          }
        },
        DeleteDeployment: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/deployments/{deploymentId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              DeploymentId: {
                location: "uri",
                locationName: "deploymentId"
              }
            },
            required: [
              "ApiId",
              "DeploymentId"
            ]
          }
        },
        DeleteDomainName: {
          http: {
            method: "DELETE",
            requestUri: "/v2/domainnames/{domainName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              DomainName: {
                location: "uri",
                locationName: "domainName"
              }
            },
            required: [
              "DomainName"
            ]
          }
        },
        DeleteIntegration: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/integrations/{integrationId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              IntegrationId: {
                location: "uri",
                locationName: "integrationId"
              }
            },
            required: [
              "ApiId",
              "IntegrationId"
            ]
          }
        },
        DeleteIntegrationResponse: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/integrations/{integrationId}/integrationresponses/{integrationResponseId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              IntegrationId: {
                location: "uri",
                locationName: "integrationId"
              },
              IntegrationResponseId: {
                location: "uri",
                locationName: "integrationResponseId"
              }
            },
            required: [
              "ApiId",
              "IntegrationResponseId",
              "IntegrationId"
            ]
          }
        },
        DeleteModel: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/models/{modelId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ModelId: {
                location: "uri",
                locationName: "modelId"
              }
            },
            required: [
              "ModelId",
              "ApiId"
            ]
          }
        },
        DeleteRoute: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/routes/{routeId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              RouteId: {
                location: "uri",
                locationName: "routeId"
              }
            },
            required: [
              "ApiId",
              "RouteId"
            ]
          }
        },
        DeleteRouteRequestParameter: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/routes/{routeId}/requestparameters/{requestParameterKey}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              RequestParameterKey: {
                location: "uri",
                locationName: "requestParameterKey"
              },
              RouteId: {
                location: "uri",
                locationName: "routeId"
              }
            },
            required: [
              "RequestParameterKey",
              "ApiId",
              "RouteId"
            ]
          }
        },
        DeleteRouteResponse: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/routes/{routeId}/routeresponses/{routeResponseId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              RouteId: {
                location: "uri",
                locationName: "routeId"
              },
              RouteResponseId: {
                location: "uri",
                locationName: "routeResponseId"
              }
            },
            required: [
              "RouteResponseId",
              "ApiId",
              "RouteId"
            ]
          }
        },
        DeleteRouteSettings: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/stages/{stageName}/routesettings/{routeKey}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              RouteKey: {
                location: "uri",
                locationName: "routeKey"
              },
              StageName: {
                location: "uri",
                locationName: "stageName"
              }
            },
            required: [
              "StageName",
              "RouteKey",
              "ApiId"
            ]
          }
        },
        DeleteStage: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/stages/{stageName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              StageName: {
                location: "uri",
                locationName: "stageName"
              }
            },
            required: [
              "StageName",
              "ApiId"
            ]
          }
        },
        DeleteVpcLink: {
          http: {
            method: "DELETE",
            requestUri: "/v2/vpclinks/{vpcLinkId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              VpcLinkId: {
                location: "uri",
                locationName: "vpcLinkId"
              }
            },
            required: [
              "VpcLinkId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ExportApi: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/exports/{specification}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ExportVersion: {
                location: "querystring",
                locationName: "exportVersion"
              },
              IncludeExtensions: {
                location: "querystring",
                locationName: "includeExtensions",
                type: "boolean"
              },
              OutputType: {
                location: "querystring",
                locationName: "outputType"
              },
              Specification: {
                location: "uri",
                locationName: "specification"
              },
              StageName: {
                location: "querystring",
                locationName: "stageName"
              }
            },
            required: [
              "Specification",
              "OutputType",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              body: {
                type: "blob"
              }
            },
            payload: "body"
          }
        },
        ResetAuthorizersCache: {
          http: {
            method: "DELETE",
            requestUri: "/v2/apis/{apiId}/stages/{stageName}/cache/authorizers",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              StageName: {
                location: "uri",
                locationName: "stageName"
              }
            },
            required: [
              "StageName",
              "ApiId"
            ]
          }
        },
        GetApi: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              }
            },
            required: [
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiEndpoint: {
                locationName: "apiEndpoint"
              },
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ApiId: {
                locationName: "apiId"
              },
              ApiKeySelectionExpression: {
                locationName: "apiKeySelectionExpression"
              },
              CorsConfiguration: {
                shape: "S3",
                locationName: "corsConfiguration"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              Description: {
                locationName: "description"
              },
              DisableSchemaValidation: {
                locationName: "disableSchemaValidation",
                type: "boolean"
              },
              DisableExecuteApiEndpoint: {
                locationName: "disableExecuteApiEndpoint",
                type: "boolean"
              },
              ImportInfo: {
                shape: "Sm",
                locationName: "importInfo"
              },
              Name: {
                locationName: "name"
              },
              ProtocolType: {
                locationName: "protocolType"
              },
              RouteSelectionExpression: {
                locationName: "routeSelectionExpression"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              Version: {
                locationName: "version"
              },
              Warnings: {
                shape: "Sm",
                locationName: "warnings"
              }
            }
          }
        },
        GetApiMapping: {
          http: {
            method: "GET",
            requestUri: "/v2/domainnames/{domainName}/apimappings/{apiMappingId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiMappingId: {
                location: "uri",
                locationName: "apiMappingId"
              },
              DomainName: {
                location: "uri",
                locationName: "domainName"
              }
            },
            required: [
              "ApiMappingId",
              "DomainName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiId: {
                locationName: "apiId"
              },
              ApiMappingId: {
                locationName: "apiMappingId"
              },
              ApiMappingKey: {
                locationName: "apiMappingKey"
              },
              Stage: {
                locationName: "stage"
              }
            }
          }
        },
        GetApiMappings: {
          http: {
            method: "GET",
            requestUri: "/v2/domainnames/{domainName}/apimappings",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DomainName: {
                location: "uri",
                locationName: "domainName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "DomainName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApiId: {
                      locationName: "apiId"
                    },
                    ApiMappingId: {
                      locationName: "apiMappingId"
                    },
                    ApiMappingKey: {
                      locationName: "apiMappingKey"
                    },
                    Stage: {
                      locationName: "stage"
                    }
                  },
                  required: [
                    "Stage",
                    "ApiId"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetApis: {
          http: {
            method: "GET",
            requestUri: "/v2/apis",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApiEndpoint: {
                      locationName: "apiEndpoint"
                    },
                    ApiGatewayManaged: {
                      locationName: "apiGatewayManaged",
                      type: "boolean"
                    },
                    ApiId: {
                      locationName: "apiId"
                    },
                    ApiKeySelectionExpression: {
                      locationName: "apiKeySelectionExpression"
                    },
                    CorsConfiguration: {
                      shape: "S3",
                      locationName: "corsConfiguration"
                    },
                    CreatedDate: {
                      shape: "Sl",
                      locationName: "createdDate"
                    },
                    Description: {
                      locationName: "description"
                    },
                    DisableSchemaValidation: {
                      locationName: "disableSchemaValidation",
                      type: "boolean"
                    },
                    DisableExecuteApiEndpoint: {
                      locationName: "disableExecuteApiEndpoint",
                      type: "boolean"
                    },
                    ImportInfo: {
                      shape: "Sm",
                      locationName: "importInfo"
                    },
                    Name: {
                      locationName: "name"
                    },
                    ProtocolType: {
                      locationName: "protocolType"
                    },
                    RouteSelectionExpression: {
                      locationName: "routeSelectionExpression"
                    },
                    Tags: {
                      shape: "Sg",
                      locationName: "tags"
                    },
                    Version: {
                      locationName: "version"
                    },
                    Warnings: {
                      shape: "Sm",
                      locationName: "warnings"
                    }
                  },
                  required: [
                    "RouteSelectionExpression",
                    "Name",
                    "ProtocolType"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetAuthorizer: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/authorizers/{authorizerId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              AuthorizerId: {
                location: "uri",
                locationName: "authorizerId"
              }
            },
            required: [
              "AuthorizerId",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AuthorizerCredentialsArn: {
                locationName: "authorizerCredentialsArn"
              },
              AuthorizerId: {
                locationName: "authorizerId"
              },
              AuthorizerPayloadFormatVersion: {
                locationName: "authorizerPayloadFormatVersion"
              },
              AuthorizerResultTtlInSeconds: {
                locationName: "authorizerResultTtlInSeconds",
                type: "integer"
              },
              AuthorizerType: {
                locationName: "authorizerType"
              },
              AuthorizerUri: {
                locationName: "authorizerUri"
              },
              EnableSimpleResponses: {
                locationName: "enableSimpleResponses",
                type: "boolean"
              },
              IdentitySource: {
                shape: "Ss",
                locationName: "identitySource"
              },
              IdentityValidationExpression: {
                locationName: "identityValidationExpression"
              },
              JwtConfiguration: {
                shape: "St",
                locationName: "jwtConfiguration"
              },
              Name: {
                locationName: "name"
              }
            }
          }
        },
        GetAuthorizers: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/authorizers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AuthorizerCredentialsArn: {
                      locationName: "authorizerCredentialsArn"
                    },
                    AuthorizerId: {
                      locationName: "authorizerId"
                    },
                    AuthorizerPayloadFormatVersion: {
                      locationName: "authorizerPayloadFormatVersion"
                    },
                    AuthorizerResultTtlInSeconds: {
                      locationName: "authorizerResultTtlInSeconds",
                      type: "integer"
                    },
                    AuthorizerType: {
                      locationName: "authorizerType"
                    },
                    AuthorizerUri: {
                      locationName: "authorizerUri"
                    },
                    EnableSimpleResponses: {
                      locationName: "enableSimpleResponses",
                      type: "boolean"
                    },
                    IdentitySource: {
                      shape: "Ss",
                      locationName: "identitySource"
                    },
                    IdentityValidationExpression: {
                      locationName: "identityValidationExpression"
                    },
                    JwtConfiguration: {
                      shape: "St",
                      locationName: "jwtConfiguration"
                    },
                    Name: {
                      locationName: "name"
                    }
                  },
                  required: [
                    "Name"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetDeployment: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/deployments/{deploymentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              DeploymentId: {
                location: "uri",
                locationName: "deploymentId"
              }
            },
            required: [
              "ApiId",
              "DeploymentId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AutoDeployed: {
                locationName: "autoDeployed",
                type: "boolean"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              DeploymentId: {
                locationName: "deploymentId"
              },
              DeploymentStatus: {
                locationName: "deploymentStatus"
              },
              DeploymentStatusMessage: {
                locationName: "deploymentStatusMessage"
              },
              Description: {
                locationName: "description"
              }
            }
          }
        },
        GetDeployments: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/deployments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AutoDeployed: {
                      locationName: "autoDeployed",
                      type: "boolean"
                    },
                    CreatedDate: {
                      shape: "Sl",
                      locationName: "createdDate"
                    },
                    DeploymentId: {
                      locationName: "deploymentId"
                    },
                    DeploymentStatus: {
                      locationName: "deploymentStatus"
                    },
                    DeploymentStatusMessage: {
                      locationName: "deploymentStatusMessage"
                    },
                    Description: {
                      locationName: "description"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetDomainName: {
          http: {
            method: "GET",
            requestUri: "/v2/domainnames/{domainName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DomainName: {
                location: "uri",
                locationName: "domainName"
              }
            },
            required: [
              "DomainName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiMappingSelectionExpression: {
                locationName: "apiMappingSelectionExpression"
              },
              DomainName: {
                locationName: "domainName"
              },
              DomainNameConfigurations: {
                shape: "S10",
                locationName: "domainNameConfigurations"
              },
              MutualTlsAuthentication: {
                shape: "S17",
                locationName: "mutualTlsAuthentication"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            }
          }
        },
        GetDomainNames: {
          http: {
            method: "GET",
            requestUri: "/v2/domainnames",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApiMappingSelectionExpression: {
                      locationName: "apiMappingSelectionExpression"
                    },
                    DomainName: {
                      locationName: "domainName"
                    },
                    DomainNameConfigurations: {
                      shape: "S10",
                      locationName: "domainNameConfigurations"
                    },
                    MutualTlsAuthentication: {
                      shape: "S17",
                      locationName: "mutualTlsAuthentication"
                    },
                    Tags: {
                      shape: "Sg",
                      locationName: "tags"
                    }
                  },
                  required: [
                    "DomainName"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetIntegration: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/integrations/{integrationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              IntegrationId: {
                location: "uri",
                locationName: "integrationId"
              }
            },
            required: [
              "ApiId",
              "IntegrationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ConnectionId: {
                locationName: "connectionId"
              },
              ConnectionType: {
                locationName: "connectionType"
              },
              ContentHandlingStrategy: {
                locationName: "contentHandlingStrategy"
              },
              CredentialsArn: {
                locationName: "credentialsArn"
              },
              Description: {
                locationName: "description"
              },
              IntegrationId: {
                locationName: "integrationId"
              },
              IntegrationMethod: {
                locationName: "integrationMethod"
              },
              IntegrationResponseSelectionExpression: {
                locationName: "integrationResponseSelectionExpression"
              },
              IntegrationSubtype: {
                locationName: "integrationSubtype"
              },
              IntegrationType: {
                locationName: "integrationType"
              },
              IntegrationUri: {
                locationName: "integrationUri"
              },
              PassthroughBehavior: {
                locationName: "passthroughBehavior"
              },
              PayloadFormatVersion: {
                locationName: "payloadFormatVersion"
              },
              RequestParameters: {
                shape: "S1e",
                locationName: "requestParameters"
              },
              RequestTemplates: {
                shape: "S1f",
                locationName: "requestTemplates"
              },
              ResponseParameters: {
                shape: "S1h",
                locationName: "responseParameters"
              },
              TemplateSelectionExpression: {
                locationName: "templateSelectionExpression"
              },
              TimeoutInMillis: {
                locationName: "timeoutInMillis",
                type: "integer"
              },
              TlsConfig: {
                shape: "S1l",
                locationName: "tlsConfig"
              }
            }
          }
        },
        GetIntegrationResponse: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/integrations/{integrationId}/integrationresponses/{integrationResponseId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              IntegrationId: {
                location: "uri",
                locationName: "integrationId"
              },
              IntegrationResponseId: {
                location: "uri",
                locationName: "integrationResponseId"
              }
            },
            required: [
              "ApiId",
              "IntegrationResponseId",
              "IntegrationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ContentHandlingStrategy: {
                locationName: "contentHandlingStrategy"
              },
              IntegrationResponseId: {
                locationName: "integrationResponseId"
              },
              IntegrationResponseKey: {
                locationName: "integrationResponseKey"
              },
              ResponseParameters: {
                shape: "S1e",
                locationName: "responseParameters"
              },
              ResponseTemplates: {
                shape: "S1f",
                locationName: "responseTemplates"
              },
              TemplateSelectionExpression: {
                locationName: "templateSelectionExpression"
              }
            }
          }
        },
        GetIntegrationResponses: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/integrations/{integrationId}/integrationresponses",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              IntegrationId: {
                location: "uri",
                locationName: "integrationId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "IntegrationId",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ContentHandlingStrategy: {
                      locationName: "contentHandlingStrategy"
                    },
                    IntegrationResponseId: {
                      locationName: "integrationResponseId"
                    },
                    IntegrationResponseKey: {
                      locationName: "integrationResponseKey"
                    },
                    ResponseParameters: {
                      shape: "S1e",
                      locationName: "responseParameters"
                    },
                    ResponseTemplates: {
                      shape: "S1f",
                      locationName: "responseTemplates"
                    },
                    TemplateSelectionExpression: {
                      locationName: "templateSelectionExpression"
                    }
                  },
                  required: [
                    "IntegrationResponseKey"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetIntegrations: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/integrations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApiGatewayManaged: {
                      locationName: "apiGatewayManaged",
                      type: "boolean"
                    },
                    ConnectionId: {
                      locationName: "connectionId"
                    },
                    ConnectionType: {
                      locationName: "connectionType"
                    },
                    ContentHandlingStrategy: {
                      locationName: "contentHandlingStrategy"
                    },
                    CredentialsArn: {
                      locationName: "credentialsArn"
                    },
                    Description: {
                      locationName: "description"
                    },
                    IntegrationId: {
                      locationName: "integrationId"
                    },
                    IntegrationMethod: {
                      locationName: "integrationMethod"
                    },
                    IntegrationResponseSelectionExpression: {
                      locationName: "integrationResponseSelectionExpression"
                    },
                    IntegrationSubtype: {
                      locationName: "integrationSubtype"
                    },
                    IntegrationType: {
                      locationName: "integrationType"
                    },
                    IntegrationUri: {
                      locationName: "integrationUri"
                    },
                    PassthroughBehavior: {
                      locationName: "passthroughBehavior"
                    },
                    PayloadFormatVersion: {
                      locationName: "payloadFormatVersion"
                    },
                    RequestParameters: {
                      shape: "S1e",
                      locationName: "requestParameters"
                    },
                    RequestTemplates: {
                      shape: "S1f",
                      locationName: "requestTemplates"
                    },
                    ResponseParameters: {
                      shape: "S1h",
                      locationName: "responseParameters"
                    },
                    TemplateSelectionExpression: {
                      locationName: "templateSelectionExpression"
                    },
                    TimeoutInMillis: {
                      locationName: "timeoutInMillis",
                      type: "integer"
                    },
                    TlsConfig: {
                      shape: "S1l",
                      locationName: "tlsConfig"
                    }
                  }
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetModel: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/models/{modelId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ModelId: {
                location: "uri",
                locationName: "modelId"
              }
            },
            required: [
              "ModelId",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ContentType: {
                locationName: "contentType"
              },
              Description: {
                locationName: "description"
              },
              ModelId: {
                locationName: "modelId"
              },
              Name: {
                locationName: "name"
              },
              Schema: {
                locationName: "schema"
              }
            }
          }
        },
        GetModelTemplate: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/models/{modelId}/template",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ModelId: {
                location: "uri",
                locationName: "modelId"
              }
            },
            required: [
              "ModelId",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Value: {
                locationName: "value"
              }
            }
          }
        },
        GetModels: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/models",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ContentType: {
                      locationName: "contentType"
                    },
                    Description: {
                      locationName: "description"
                    },
                    ModelId: {
                      locationName: "modelId"
                    },
                    Name: {
                      locationName: "name"
                    },
                    Schema: {
                      locationName: "schema"
                    }
                  },
                  required: [
                    "Name"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetRoute: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/routes/{routeId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              RouteId: {
                location: "uri",
                locationName: "routeId"
              }
            },
            required: [
              "ApiId",
              "RouteId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ApiKeyRequired: {
                locationName: "apiKeyRequired",
                type: "boolean"
              },
              AuthorizationScopes: {
                shape: "S1s",
                locationName: "authorizationScopes"
              },
              AuthorizationType: {
                locationName: "authorizationType"
              },
              AuthorizerId: {
                locationName: "authorizerId"
              },
              ModelSelectionExpression: {
                locationName: "modelSelectionExpression"
              },
              OperationName: {
                locationName: "operationName"
              },
              RequestModels: {
                shape: "S1u",
                locationName: "requestModels"
              },
              RequestParameters: {
                shape: "S1v",
                locationName: "requestParameters"
              },
              RouteId: {
                locationName: "routeId"
              },
              RouteKey: {
                locationName: "routeKey"
              },
              RouteResponseSelectionExpression: {
                locationName: "routeResponseSelectionExpression"
              },
              Target: {
                locationName: "target"
              }
            }
          }
        },
        GetRouteResponse: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/routes/{routeId}/routeresponses/{routeResponseId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              RouteId: {
                location: "uri",
                locationName: "routeId"
              },
              RouteResponseId: {
                location: "uri",
                locationName: "routeResponseId"
              }
            },
            required: [
              "RouteResponseId",
              "ApiId",
              "RouteId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ModelSelectionExpression: {
                locationName: "modelSelectionExpression"
              },
              ResponseModels: {
                shape: "S1u",
                locationName: "responseModels"
              },
              ResponseParameters: {
                shape: "S1v",
                locationName: "responseParameters"
              },
              RouteResponseId: {
                locationName: "routeResponseId"
              },
              RouteResponseKey: {
                locationName: "routeResponseKey"
              }
            }
          }
        },
        GetRouteResponses: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/routes/{routeId}/routeresponses",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RouteId: {
                location: "uri",
                locationName: "routeId"
              }
            },
            required: [
              "RouteId",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ModelSelectionExpression: {
                      locationName: "modelSelectionExpression"
                    },
                    ResponseModels: {
                      shape: "S1u",
                      locationName: "responseModels"
                    },
                    ResponseParameters: {
                      shape: "S1v",
                      locationName: "responseParameters"
                    },
                    RouteResponseId: {
                      locationName: "routeResponseId"
                    },
                    RouteResponseKey: {
                      locationName: "routeResponseKey"
                    }
                  },
                  required: [
                    "RouteResponseKey"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetRoutes: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/routes",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApiGatewayManaged: {
                      locationName: "apiGatewayManaged",
                      type: "boolean"
                    },
                    ApiKeyRequired: {
                      locationName: "apiKeyRequired",
                      type: "boolean"
                    },
                    AuthorizationScopes: {
                      shape: "S1s",
                      locationName: "authorizationScopes"
                    },
                    AuthorizationType: {
                      locationName: "authorizationType"
                    },
                    AuthorizerId: {
                      locationName: "authorizerId"
                    },
                    ModelSelectionExpression: {
                      locationName: "modelSelectionExpression"
                    },
                    OperationName: {
                      locationName: "operationName"
                    },
                    RequestModels: {
                      shape: "S1u",
                      locationName: "requestModels"
                    },
                    RequestParameters: {
                      shape: "S1v",
                      locationName: "requestParameters"
                    },
                    RouteId: {
                      locationName: "routeId"
                    },
                    RouteKey: {
                      locationName: "routeKey"
                    },
                    RouteResponseSelectionExpression: {
                      locationName: "routeResponseSelectionExpression"
                    },
                    Target: {
                      locationName: "target"
                    }
                  },
                  required: [
                    "RouteKey"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetStage: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/stages/{stageName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              StageName: {
                location: "uri",
                locationName: "stageName"
              }
            },
            required: [
              "StageName",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AccessLogSettings: {
                shape: "S21",
                locationName: "accessLogSettings"
              },
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              AutoDeploy: {
                locationName: "autoDeploy",
                type: "boolean"
              },
              ClientCertificateId: {
                locationName: "clientCertificateId"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              DefaultRouteSettings: {
                shape: "S22",
                locationName: "defaultRouteSettings"
              },
              DeploymentId: {
                locationName: "deploymentId"
              },
              Description: {
                locationName: "description"
              },
              LastDeploymentStatusMessage: {
                locationName: "lastDeploymentStatusMessage"
              },
              LastUpdatedDate: {
                shape: "Sl",
                locationName: "lastUpdatedDate"
              },
              RouteSettings: {
                shape: "S26",
                locationName: "routeSettings"
              },
              StageName: {
                locationName: "stageName"
              },
              StageVariables: {
                shape: "S27",
                locationName: "stageVariables"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            }
          }
        },
        GetStages: {
          http: {
            method: "GET",
            requestUri: "/v2/apis/{apiId}/stages",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccessLogSettings: {
                      shape: "S21",
                      locationName: "accessLogSettings"
                    },
                    ApiGatewayManaged: {
                      locationName: "apiGatewayManaged",
                      type: "boolean"
                    },
                    AutoDeploy: {
                      locationName: "autoDeploy",
                      type: "boolean"
                    },
                    ClientCertificateId: {
                      locationName: "clientCertificateId"
                    },
                    CreatedDate: {
                      shape: "Sl",
                      locationName: "createdDate"
                    },
                    DefaultRouteSettings: {
                      shape: "S22",
                      locationName: "defaultRouteSettings"
                    },
                    DeploymentId: {
                      locationName: "deploymentId"
                    },
                    Description: {
                      locationName: "description"
                    },
                    LastDeploymentStatusMessage: {
                      locationName: "lastDeploymentStatusMessage"
                    },
                    LastUpdatedDate: {
                      shape: "Sl",
                      locationName: "lastUpdatedDate"
                    },
                    RouteSettings: {
                      shape: "S26",
                      locationName: "routeSettings"
                    },
                    StageName: {
                      locationName: "stageName"
                    },
                    StageVariables: {
                      shape: "S27",
                      locationName: "stageVariables"
                    },
                    Tags: {
                      shape: "Sg",
                      locationName: "tags"
                    }
                  },
                  required: [
                    "StageName"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        GetTags: {
          http: {
            method: "GET",
            requestUri: "/v2/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            }
          }
        },
        GetVpcLink: {
          http: {
            method: "GET",
            requestUri: "/v2/vpclinks/{vpcLinkId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              VpcLinkId: {
                location: "uri",
                locationName: "vpcLinkId"
              }
            },
            required: [
              "VpcLinkId"
            ]
          },
          output: {
            type: "structure",
            members: {
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              Name: {
                locationName: "name"
              },
              SecurityGroupIds: {
                shape: "S2b",
                locationName: "securityGroupIds"
              },
              SubnetIds: {
                shape: "S2c",
                locationName: "subnetIds"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              VpcLinkId: {
                locationName: "vpcLinkId"
              },
              VpcLinkStatus: {
                locationName: "vpcLinkStatus"
              },
              VpcLinkStatusMessage: {
                locationName: "vpcLinkStatusMessage"
              },
              VpcLinkVersion: {
                locationName: "vpcLinkVersion"
              }
            }
          }
        },
        GetVpcLinks: {
          http: {
            method: "GET",
            requestUri: "/v2/vpclinks",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedDate: {
                      shape: "Sl",
                      locationName: "createdDate"
                    },
                    Name: {
                      locationName: "name"
                    },
                    SecurityGroupIds: {
                      shape: "S2b",
                      locationName: "securityGroupIds"
                    },
                    SubnetIds: {
                      shape: "S2c",
                      locationName: "subnetIds"
                    },
                    Tags: {
                      shape: "Sg",
                      locationName: "tags"
                    },
                    VpcLinkId: {
                      locationName: "vpcLinkId"
                    },
                    VpcLinkStatus: {
                      locationName: "vpcLinkStatus"
                    },
                    VpcLinkStatusMessage: {
                      locationName: "vpcLinkStatusMessage"
                    },
                    VpcLinkVersion: {
                      locationName: "vpcLinkVersion"
                    }
                  },
                  required: [
                    "VpcLinkId",
                    "SecurityGroupIds",
                    "SubnetIds",
                    "Name"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ImportApi: {
          http: {
            method: "PUT",
            requestUri: "/v2/apis",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Basepath: {
                location: "querystring",
                locationName: "basepath"
              },
              Body: {
                locationName: "body"
              },
              FailOnWarnings: {
                location: "querystring",
                locationName: "failOnWarnings",
                type: "boolean"
              }
            },
            required: [
              "Body"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiEndpoint: {
                locationName: "apiEndpoint"
              },
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ApiId: {
                locationName: "apiId"
              },
              ApiKeySelectionExpression: {
                locationName: "apiKeySelectionExpression"
              },
              CorsConfiguration: {
                shape: "S3",
                locationName: "corsConfiguration"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              Description: {
                locationName: "description"
              },
              DisableSchemaValidation: {
                locationName: "disableSchemaValidation",
                type: "boolean"
              },
              DisableExecuteApiEndpoint: {
                locationName: "disableExecuteApiEndpoint",
                type: "boolean"
              },
              ImportInfo: {
                shape: "Sm",
                locationName: "importInfo"
              },
              Name: {
                locationName: "name"
              },
              ProtocolType: {
                locationName: "protocolType"
              },
              RouteSelectionExpression: {
                locationName: "routeSelectionExpression"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              Version: {
                locationName: "version"
              },
              Warnings: {
                shape: "Sm",
                locationName: "warnings"
              }
            }
          }
        },
        ReimportApi: {
          http: {
            method: "PUT",
            requestUri: "/v2/apis/{apiId}",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              Basepath: {
                location: "querystring",
                locationName: "basepath"
              },
              Body: {
                locationName: "body"
              },
              FailOnWarnings: {
                location: "querystring",
                locationName: "failOnWarnings",
                type: "boolean"
              }
            },
            required: [
              "ApiId",
              "Body"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiEndpoint: {
                locationName: "apiEndpoint"
              },
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ApiId: {
                locationName: "apiId"
              },
              ApiKeySelectionExpression: {
                locationName: "apiKeySelectionExpression"
              },
              CorsConfiguration: {
                shape: "S3",
                locationName: "corsConfiguration"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              Description: {
                locationName: "description"
              },
              DisableSchemaValidation: {
                locationName: "disableSchemaValidation",
                type: "boolean"
              },
              DisableExecuteApiEndpoint: {
                locationName: "disableExecuteApiEndpoint",
                type: "boolean"
              },
              ImportInfo: {
                shape: "Sm",
                locationName: "importInfo"
              },
              Name: {
                locationName: "name"
              },
              ProtocolType: {
                locationName: "protocolType"
              },
              RouteSelectionExpression: {
                locationName: "routeSelectionExpression"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              Version: {
                locationName: "version"
              },
              Warnings: {
                shape: "Sm",
                locationName: "warnings"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/v2/tags/{resource-arn}",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/v2/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                shape: "Sm",
                location: "querystring",
                locationName: "tagKeys"
              }
            },
            required: [
              "ResourceArn",
              "TagKeys"
            ]
          }
        },
        UpdateApi: {
          http: {
            method: "PATCH",
            requestUri: "/v2/apis/{apiId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ApiKeySelectionExpression: {
                locationName: "apiKeySelectionExpression"
              },
              CorsConfiguration: {
                shape: "S3",
                locationName: "corsConfiguration"
              },
              CredentialsArn: {
                locationName: "credentialsArn"
              },
              Description: {
                locationName: "description"
              },
              DisableSchemaValidation: {
                locationName: "disableSchemaValidation",
                type: "boolean"
              },
              DisableExecuteApiEndpoint: {
                locationName: "disableExecuteApiEndpoint",
                type: "boolean"
              },
              Name: {
                locationName: "name"
              },
              RouteKey: {
                locationName: "routeKey"
              },
              RouteSelectionExpression: {
                locationName: "routeSelectionExpression"
              },
              Target: {
                locationName: "target"
              },
              Version: {
                locationName: "version"
              }
            },
            required: [
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiEndpoint: {
                locationName: "apiEndpoint"
              },
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ApiId: {
                locationName: "apiId"
              },
              ApiKeySelectionExpression: {
                locationName: "apiKeySelectionExpression"
              },
              CorsConfiguration: {
                shape: "S3",
                locationName: "corsConfiguration"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              Description: {
                locationName: "description"
              },
              DisableSchemaValidation: {
                locationName: "disableSchemaValidation",
                type: "boolean"
              },
              DisableExecuteApiEndpoint: {
                locationName: "disableExecuteApiEndpoint",
                type: "boolean"
              },
              ImportInfo: {
                shape: "Sm",
                locationName: "importInfo"
              },
              Name: {
                locationName: "name"
              },
              ProtocolType: {
                locationName: "protocolType"
              },
              RouteSelectionExpression: {
                locationName: "routeSelectionExpression"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              Version: {
                locationName: "version"
              },
              Warnings: {
                shape: "Sm",
                locationName: "warnings"
              }
            }
          }
        },
        UpdateApiMapping: {
          http: {
            method: "PATCH",
            requestUri: "/v2/domainnames/{domainName}/apimappings/{apiMappingId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                locationName: "apiId"
              },
              ApiMappingId: {
                location: "uri",
                locationName: "apiMappingId"
              },
              ApiMappingKey: {
                locationName: "apiMappingKey"
              },
              DomainName: {
                location: "uri",
                locationName: "domainName"
              },
              Stage: {
                locationName: "stage"
              }
            },
            required: [
              "ApiMappingId",
              "ApiId",
              "DomainName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiId: {
                locationName: "apiId"
              },
              ApiMappingId: {
                locationName: "apiMappingId"
              },
              ApiMappingKey: {
                locationName: "apiMappingKey"
              },
              Stage: {
                locationName: "stage"
              }
            }
          }
        },
        UpdateAuthorizer: {
          http: {
            method: "PATCH",
            requestUri: "/v2/apis/{apiId}/authorizers/{authorizerId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              AuthorizerCredentialsArn: {
                locationName: "authorizerCredentialsArn"
              },
              AuthorizerId: {
                location: "uri",
                locationName: "authorizerId"
              },
              AuthorizerPayloadFormatVersion: {
                locationName: "authorizerPayloadFormatVersion"
              },
              AuthorizerResultTtlInSeconds: {
                locationName: "authorizerResultTtlInSeconds",
                type: "integer"
              },
              AuthorizerType: {
                locationName: "authorizerType"
              },
              AuthorizerUri: {
                locationName: "authorizerUri"
              },
              EnableSimpleResponses: {
                locationName: "enableSimpleResponses",
                type: "boolean"
              },
              IdentitySource: {
                shape: "Ss",
                locationName: "identitySource"
              },
              IdentityValidationExpression: {
                locationName: "identityValidationExpression"
              },
              JwtConfiguration: {
                shape: "St",
                locationName: "jwtConfiguration"
              },
              Name: {
                locationName: "name"
              }
            },
            required: [
              "AuthorizerId",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AuthorizerCredentialsArn: {
                locationName: "authorizerCredentialsArn"
              },
              AuthorizerId: {
                locationName: "authorizerId"
              },
              AuthorizerPayloadFormatVersion: {
                locationName: "authorizerPayloadFormatVersion"
              },
              AuthorizerResultTtlInSeconds: {
                locationName: "authorizerResultTtlInSeconds",
                type: "integer"
              },
              AuthorizerType: {
                locationName: "authorizerType"
              },
              AuthorizerUri: {
                locationName: "authorizerUri"
              },
              EnableSimpleResponses: {
                locationName: "enableSimpleResponses",
                type: "boolean"
              },
              IdentitySource: {
                shape: "Ss",
                locationName: "identitySource"
              },
              IdentityValidationExpression: {
                locationName: "identityValidationExpression"
              },
              JwtConfiguration: {
                shape: "St",
                locationName: "jwtConfiguration"
              },
              Name: {
                locationName: "name"
              }
            }
          }
        },
        UpdateDeployment: {
          http: {
            method: "PATCH",
            requestUri: "/v2/apis/{apiId}/deployments/{deploymentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              DeploymentId: {
                location: "uri",
                locationName: "deploymentId"
              },
              Description: {
                locationName: "description"
              }
            },
            required: [
              "ApiId",
              "DeploymentId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AutoDeployed: {
                locationName: "autoDeployed",
                type: "boolean"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              DeploymentId: {
                locationName: "deploymentId"
              },
              DeploymentStatus: {
                locationName: "deploymentStatus"
              },
              DeploymentStatusMessage: {
                locationName: "deploymentStatusMessage"
              },
              Description: {
                locationName: "description"
              }
            }
          }
        },
        UpdateDomainName: {
          http: {
            method: "PATCH",
            requestUri: "/v2/domainnames/{domainName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DomainName: {
                location: "uri",
                locationName: "domainName"
              },
              DomainNameConfigurations: {
                shape: "S10",
                locationName: "domainNameConfigurations"
              },
              MutualTlsAuthentication: {
                shape: "S15",
                locationName: "mutualTlsAuthentication"
              }
            },
            required: [
              "DomainName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiMappingSelectionExpression: {
                locationName: "apiMappingSelectionExpression"
              },
              DomainName: {
                locationName: "domainName"
              },
              DomainNameConfigurations: {
                shape: "S10",
                locationName: "domainNameConfigurations"
              },
              MutualTlsAuthentication: {
                shape: "S17",
                locationName: "mutualTlsAuthentication"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            }
          }
        },
        UpdateIntegration: {
          http: {
            method: "PATCH",
            requestUri: "/v2/apis/{apiId}/integrations/{integrationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ConnectionId: {
                locationName: "connectionId"
              },
              ConnectionType: {
                locationName: "connectionType"
              },
              ContentHandlingStrategy: {
                locationName: "contentHandlingStrategy"
              },
              CredentialsArn: {
                locationName: "credentialsArn"
              },
              Description: {
                locationName: "description"
              },
              IntegrationId: {
                location: "uri",
                locationName: "integrationId"
              },
              IntegrationMethod: {
                locationName: "integrationMethod"
              },
              IntegrationSubtype: {
                locationName: "integrationSubtype"
              },
              IntegrationType: {
                locationName: "integrationType"
              },
              IntegrationUri: {
                locationName: "integrationUri"
              },
              PassthroughBehavior: {
                locationName: "passthroughBehavior"
              },
              PayloadFormatVersion: {
                locationName: "payloadFormatVersion"
              },
              RequestParameters: {
                shape: "S1e",
                locationName: "requestParameters"
              },
              RequestTemplates: {
                shape: "S1f",
                locationName: "requestTemplates"
              },
              ResponseParameters: {
                shape: "S1h",
                locationName: "responseParameters"
              },
              TemplateSelectionExpression: {
                locationName: "templateSelectionExpression"
              },
              TimeoutInMillis: {
                locationName: "timeoutInMillis",
                type: "integer"
              },
              TlsConfig: {
                shape: "S1j",
                locationName: "tlsConfig"
              }
            },
            required: [
              "ApiId",
              "IntegrationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ConnectionId: {
                locationName: "connectionId"
              },
              ConnectionType: {
                locationName: "connectionType"
              },
              ContentHandlingStrategy: {
                locationName: "contentHandlingStrategy"
              },
              CredentialsArn: {
                locationName: "credentialsArn"
              },
              Description: {
                locationName: "description"
              },
              IntegrationId: {
                locationName: "integrationId"
              },
              IntegrationMethod: {
                locationName: "integrationMethod"
              },
              IntegrationResponseSelectionExpression: {
                locationName: "integrationResponseSelectionExpression"
              },
              IntegrationSubtype: {
                locationName: "integrationSubtype"
              },
              IntegrationType: {
                locationName: "integrationType"
              },
              IntegrationUri: {
                locationName: "integrationUri"
              },
              PassthroughBehavior: {
                locationName: "passthroughBehavior"
              },
              PayloadFormatVersion: {
                locationName: "payloadFormatVersion"
              },
              RequestParameters: {
                shape: "S1e",
                locationName: "requestParameters"
              },
              RequestTemplates: {
                shape: "S1f",
                locationName: "requestTemplates"
              },
              ResponseParameters: {
                shape: "S1h",
                locationName: "responseParameters"
              },
              TemplateSelectionExpression: {
                locationName: "templateSelectionExpression"
              },
              TimeoutInMillis: {
                locationName: "timeoutInMillis",
                type: "integer"
              },
              TlsConfig: {
                shape: "S1l",
                locationName: "tlsConfig"
              }
            }
          }
        },
        UpdateIntegrationResponse: {
          http: {
            method: "PATCH",
            requestUri: "/v2/apis/{apiId}/integrations/{integrationId}/integrationresponses/{integrationResponseId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ContentHandlingStrategy: {
                locationName: "contentHandlingStrategy"
              },
              IntegrationId: {
                location: "uri",
                locationName: "integrationId"
              },
              IntegrationResponseId: {
                location: "uri",
                locationName: "integrationResponseId"
              },
              IntegrationResponseKey: {
                locationName: "integrationResponseKey"
              },
              ResponseParameters: {
                shape: "S1e",
                locationName: "responseParameters"
              },
              ResponseTemplates: {
                shape: "S1f",
                locationName: "responseTemplates"
              },
              TemplateSelectionExpression: {
                locationName: "templateSelectionExpression"
              }
            },
            required: [
              "ApiId",
              "IntegrationResponseId",
              "IntegrationId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ContentHandlingStrategy: {
                locationName: "contentHandlingStrategy"
              },
              IntegrationResponseId: {
                locationName: "integrationResponseId"
              },
              IntegrationResponseKey: {
                locationName: "integrationResponseKey"
              },
              ResponseParameters: {
                shape: "S1e",
                locationName: "responseParameters"
              },
              ResponseTemplates: {
                shape: "S1f",
                locationName: "responseTemplates"
              },
              TemplateSelectionExpression: {
                locationName: "templateSelectionExpression"
              }
            }
          }
        },
        UpdateModel: {
          http: {
            method: "PATCH",
            requestUri: "/v2/apis/{apiId}/models/{modelId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ContentType: {
                locationName: "contentType"
              },
              Description: {
                locationName: "description"
              },
              ModelId: {
                location: "uri",
                locationName: "modelId"
              },
              Name: {
                locationName: "name"
              },
              Schema: {
                locationName: "schema"
              }
            },
            required: [
              "ModelId",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ContentType: {
                locationName: "contentType"
              },
              Description: {
                locationName: "description"
              },
              ModelId: {
                locationName: "modelId"
              },
              Name: {
                locationName: "name"
              },
              Schema: {
                locationName: "schema"
              }
            }
          }
        },
        UpdateRoute: {
          http: {
            method: "PATCH",
            requestUri: "/v2/apis/{apiId}/routes/{routeId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ApiKeyRequired: {
                locationName: "apiKeyRequired",
                type: "boolean"
              },
              AuthorizationScopes: {
                shape: "S1s",
                locationName: "authorizationScopes"
              },
              AuthorizationType: {
                locationName: "authorizationType"
              },
              AuthorizerId: {
                locationName: "authorizerId"
              },
              ModelSelectionExpression: {
                locationName: "modelSelectionExpression"
              },
              OperationName: {
                locationName: "operationName"
              },
              RequestModels: {
                shape: "S1u",
                locationName: "requestModels"
              },
              RequestParameters: {
                shape: "S1v",
                locationName: "requestParameters"
              },
              RouteId: {
                location: "uri",
                locationName: "routeId"
              },
              RouteKey: {
                locationName: "routeKey"
              },
              RouteResponseSelectionExpression: {
                locationName: "routeResponseSelectionExpression"
              },
              Target: {
                locationName: "target"
              }
            },
            required: [
              "ApiId",
              "RouteId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              ApiKeyRequired: {
                locationName: "apiKeyRequired",
                type: "boolean"
              },
              AuthorizationScopes: {
                shape: "S1s",
                locationName: "authorizationScopes"
              },
              AuthorizationType: {
                locationName: "authorizationType"
              },
              AuthorizerId: {
                locationName: "authorizerId"
              },
              ModelSelectionExpression: {
                locationName: "modelSelectionExpression"
              },
              OperationName: {
                locationName: "operationName"
              },
              RequestModels: {
                shape: "S1u",
                locationName: "requestModels"
              },
              RequestParameters: {
                shape: "S1v",
                locationName: "requestParameters"
              },
              RouteId: {
                locationName: "routeId"
              },
              RouteKey: {
                locationName: "routeKey"
              },
              RouteResponseSelectionExpression: {
                locationName: "routeResponseSelectionExpression"
              },
              Target: {
                locationName: "target"
              }
            }
          }
        },
        UpdateRouteResponse: {
          http: {
            method: "PATCH",
            requestUri: "/v2/apis/{apiId}/routes/{routeId}/routeresponses/{routeResponseId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              ModelSelectionExpression: {
                locationName: "modelSelectionExpression"
              },
              ResponseModels: {
                shape: "S1u",
                locationName: "responseModels"
              },
              ResponseParameters: {
                shape: "S1v",
                locationName: "responseParameters"
              },
              RouteId: {
                location: "uri",
                locationName: "routeId"
              },
              RouteResponseId: {
                location: "uri",
                locationName: "routeResponseId"
              },
              RouteResponseKey: {
                locationName: "routeResponseKey"
              }
            },
            required: [
              "RouteResponseId",
              "ApiId",
              "RouteId"
            ]
          },
          output: {
            type: "structure",
            members: {
              ModelSelectionExpression: {
                locationName: "modelSelectionExpression"
              },
              ResponseModels: {
                shape: "S1u",
                locationName: "responseModels"
              },
              ResponseParameters: {
                shape: "S1v",
                locationName: "responseParameters"
              },
              RouteResponseId: {
                locationName: "routeResponseId"
              },
              RouteResponseKey: {
                locationName: "routeResponseKey"
              }
            }
          }
        },
        UpdateStage: {
          http: {
            method: "PATCH",
            requestUri: "/v2/apis/{apiId}/stages/{stageName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AccessLogSettings: {
                shape: "S21",
                locationName: "accessLogSettings"
              },
              ApiId: {
                location: "uri",
                locationName: "apiId"
              },
              AutoDeploy: {
                locationName: "autoDeploy",
                type: "boolean"
              },
              ClientCertificateId: {
                locationName: "clientCertificateId"
              },
              DefaultRouteSettings: {
                shape: "S22",
                locationName: "defaultRouteSettings"
              },
              DeploymentId: {
                locationName: "deploymentId"
              },
              Description: {
                locationName: "description"
              },
              RouteSettings: {
                shape: "S26",
                locationName: "routeSettings"
              },
              StageName: {
                location: "uri",
                locationName: "stageName"
              },
              StageVariables: {
                shape: "S27",
                locationName: "stageVariables"
              }
            },
            required: [
              "StageName",
              "ApiId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AccessLogSettings: {
                shape: "S21",
                locationName: "accessLogSettings"
              },
              ApiGatewayManaged: {
                locationName: "apiGatewayManaged",
                type: "boolean"
              },
              AutoDeploy: {
                locationName: "autoDeploy",
                type: "boolean"
              },
              ClientCertificateId: {
                locationName: "clientCertificateId"
              },
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              DefaultRouteSettings: {
                shape: "S22",
                locationName: "defaultRouteSettings"
              },
              DeploymentId: {
                locationName: "deploymentId"
              },
              Description: {
                locationName: "description"
              },
              LastDeploymentStatusMessage: {
                locationName: "lastDeploymentStatusMessage"
              },
              LastUpdatedDate: {
                shape: "Sl",
                locationName: "lastUpdatedDate"
              },
              RouteSettings: {
                shape: "S26",
                locationName: "routeSettings"
              },
              StageName: {
                locationName: "stageName"
              },
              StageVariables: {
                shape: "S27",
                locationName: "stageVariables"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              }
            }
          }
        },
        UpdateVpcLink: {
          http: {
            method: "PATCH",
            requestUri: "/v2/vpclinks/{vpcLinkId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Name: {
                locationName: "name"
              },
              VpcLinkId: {
                location: "uri",
                locationName: "vpcLinkId"
              }
            },
            required: [
              "VpcLinkId"
            ]
          },
          output: {
            type: "structure",
            members: {
              CreatedDate: {
                shape: "Sl",
                locationName: "createdDate"
              },
              Name: {
                locationName: "name"
              },
              SecurityGroupIds: {
                shape: "S2b",
                locationName: "securityGroupIds"
              },
              SubnetIds: {
                shape: "S2c",
                locationName: "subnetIds"
              },
              Tags: {
                shape: "Sg",
                locationName: "tags"
              },
              VpcLinkId: {
                locationName: "vpcLinkId"
              },
              VpcLinkStatus: {
                locationName: "vpcLinkStatus"
              },
              VpcLinkStatusMessage: {
                locationName: "vpcLinkStatusMessage"
              },
              VpcLinkVersion: {
                locationName: "vpcLinkVersion"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          members: {
            AllowCredentials: {
              locationName: "allowCredentials",
              type: "boolean"
            },
            AllowHeaders: {
              shape: "S5",
              locationName: "allowHeaders"
            },
            AllowMethods: {
              locationName: "allowMethods",
              type: "list",
              member: {}
            },
            AllowOrigins: {
              locationName: "allowOrigins",
              type: "list",
              member: {}
            },
            ExposeHeaders: {
              shape: "S5",
              locationName: "exposeHeaders"
            },
            MaxAge: {
              locationName: "maxAge",
              type: "integer"
            }
          }
        },
        S5: {
          type: "list",
          member: {}
        },
        Sg: {
          type: "map",
          key: {},
          value: {}
        },
        Sl: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sm: {
          type: "list",
          member: {}
        },
        Ss: {
          type: "list",
          member: {}
        },
        St: {
          type: "structure",
          members: {
            Audience: {
              shape: "Sm",
              locationName: "audience"
            },
            Issuer: {
              locationName: "issuer"
            }
          }
        },
        S10: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ApiGatewayDomainName: {
                locationName: "apiGatewayDomainName"
              },
              CertificateArn: {
                locationName: "certificateArn"
              },
              CertificateName: {
                locationName: "certificateName"
              },
              CertificateUploadDate: {
                shape: "Sl",
                locationName: "certificateUploadDate"
              },
              DomainNameStatus: {
                locationName: "domainNameStatus"
              },
              DomainNameStatusMessage: {
                locationName: "domainNameStatusMessage"
              },
              EndpointType: {
                locationName: "endpointType"
              },
              HostedZoneId: {
                locationName: "hostedZoneId"
              },
              SecurityPolicy: {
                locationName: "securityPolicy"
              },
              OwnershipVerificationCertificateArn: {
                locationName: "ownershipVerificationCertificateArn"
              }
            }
          }
        },
        S15: {
          type: "structure",
          members: {
            TruststoreUri: {
              locationName: "truststoreUri"
            },
            TruststoreVersion: {
              locationName: "truststoreVersion"
            }
          }
        },
        S17: {
          type: "structure",
          members: {
            TruststoreUri: {
              locationName: "truststoreUri"
            },
            TruststoreVersion: {
              locationName: "truststoreVersion"
            },
            TruststoreWarnings: {
              shape: "Sm",
              locationName: "truststoreWarnings"
            }
          }
        },
        S1e: {
          type: "map",
          key: {},
          value: {}
        },
        S1f: {
          type: "map",
          key: {},
          value: {}
        },
        S1h: {
          type: "map",
          key: {},
          value: {
            shape: "S1e"
          }
        },
        S1j: {
          type: "structure",
          members: {
            ServerNameToVerify: {
              locationName: "serverNameToVerify"
            }
          }
        },
        S1l: {
          type: "structure",
          members: {
            ServerNameToVerify: {
              locationName: "serverNameToVerify"
            }
          }
        },
        S1s: {
          type: "list",
          member: {}
        },
        S1u: {
          type: "map",
          key: {},
          value: {}
        },
        S1v: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Required: {
                locationName: "required",
                type: "boolean"
              }
            }
          }
        },
        S21: {
          type: "structure",
          members: {
            DestinationArn: {
              locationName: "destinationArn"
            },
            Format: {
              locationName: "format"
            }
          }
        },
        S22: {
          type: "structure",
          members: {
            DataTraceEnabled: {
              locationName: "dataTraceEnabled",
              type: "boolean"
            },
            DetailedMetricsEnabled: {
              locationName: "detailedMetricsEnabled",
              type: "boolean"
            },
            LoggingLevel: {
              locationName: "loggingLevel"
            },
            ThrottlingBurstLimit: {
              locationName: "throttlingBurstLimit",
              type: "integer"
            },
            ThrottlingRateLimit: {
              locationName: "throttlingRateLimit",
              type: "double"
            }
          }
        },
        S26: {
          type: "map",
          key: {},
          value: {
            shape: "S22"
          }
        },
        S27: {
          type: "map",
          key: {},
          value: {}
        },
        S2b: {
          type: "list",
          member: {}
        },
        S2c: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/apigatewayv2-2018-11-29.paginators.json
var require_apigatewayv2_2018_11_29_paginators = __commonJS({
  "node_modules/aws-sdk/apis/apigatewayv2-2018-11-29.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/apigatewayv2.js
var require_apigatewayv2 = __commonJS({
  "node_modules/aws-sdk/clients/apigatewayv2.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["apigatewayv2"] = {};
    AWS3.ApiGatewayV2 = Service.defineService("apigatewayv2", ["2018-11-29"]);
    Object.defineProperty(apiLoader.services["apigatewayv2"], "2018-11-29", {
      get: function get() {
        var model = require_apigatewayv2_2018_11_29_min();
        model.paginators = require_apigatewayv2_2018_11_29_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ApiGatewayV2;
  }
});

// node_modules/aws-sdk/lib/services/docdb.js
var require_docdb = __commonJS({
  "node_modules/aws-sdk/lib/services/docdb.js"() {
    var AWS3 = require_core();
    var rdsutil = require_rdsutil();
    var crossRegionOperations = ["createDBCluster", "copyDBClusterSnapshot"];
    AWS3.util.update(AWS3.DocDB.prototype, {
      setupRequestListeners: function setupRequestListeners(request) {
        if (crossRegionOperations.indexOf(request.operation) !== -1 && this.config.params && this.config.params.SourceRegion && request.params && !request.params.SourceRegion) {
          request.params.SourceRegion = this.config.params.SourceRegion;
        }
        rdsutil.setupRequestListeners(this, request, crossRegionOperations);
      }
    });
  }
});

// node_modules/aws-sdk/apis/docdb-2014-10-31.min.json
var require_docdb_2014_10_31_min = __commonJS({
  "node_modules/aws-sdk/apis/docdb-2014-10-31.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2014-10-31",
        endpointPrefix: "rds",
        protocol: "query",
        serviceAbbreviation: "Amazon DocDB",
        serviceFullName: "Amazon DocumentDB with MongoDB compatibility",
        serviceId: "DocDB",
        signatureVersion: "v4",
        signingName: "rds",
        uid: "docdb-2014-10-31",
        xmlNamespace: "http://rds.amazonaws.com/doc/2014-10-31/"
      },
      operations: {
        AddSourceIdentifierToSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "AddSourceIdentifierToSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        AddTagsToResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "Tags"
            ],
            members: {
              ResourceName: {},
              Tags: {
                shape: "S9"
              }
            }
          }
        },
        ApplyPendingMaintenanceAction: {
          input: {
            type: "structure",
            required: [
              "ResourceIdentifier",
              "ApplyAction",
              "OptInType"
            ],
            members: {
              ResourceIdentifier: {},
              ApplyAction: {},
              OptInType: {}
            }
          },
          output: {
            resultWrapper: "ApplyPendingMaintenanceActionResult",
            type: "structure",
            members: {
              ResourcePendingMaintenanceActions: {
                shape: "Sd"
              }
            }
          }
        },
        CopyDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "SourceDBClusterParameterGroupIdentifier",
              "TargetDBClusterParameterGroupIdentifier",
              "TargetDBClusterParameterGroupDescription"
            ],
            members: {
              SourceDBClusterParameterGroupIdentifier: {},
              TargetDBClusterParameterGroupIdentifier: {},
              TargetDBClusterParameterGroupDescription: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CopyDBClusterParameterGroupResult",
            type: "structure",
            members: {
              DBClusterParameterGroup: {
                shape: "Sj"
              }
            }
          }
        },
        CopyDBClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceDBClusterSnapshotIdentifier",
              "TargetDBClusterSnapshotIdentifier"
            ],
            members: {
              SourceDBClusterSnapshotIdentifier: {},
              TargetDBClusterSnapshotIdentifier: {},
              KmsKeyId: {},
              PreSignedUrl: {},
              CopyTags: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CopyDBClusterSnapshotResult",
            type: "structure",
            members: {
              DBClusterSnapshot: {
                shape: "Sn"
              }
            }
          }
        },
        CreateDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "Engine"
            ],
            members: {
              AvailabilityZones: {
                shape: "So"
              },
              BackupRetentionPeriod: {
                type: "integer"
              },
              DBClusterIdentifier: {},
              DBClusterParameterGroupName: {},
              VpcSecurityGroupIds: {
                shape: "Ss"
              },
              DBSubnetGroupName: {},
              Engine: {},
              EngineVersion: {},
              Port: {
                type: "integer"
              },
              MasterUsername: {},
              MasterUserPassword: {},
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              Tags: {
                shape: "S9"
              },
              StorageEncrypted: {
                type: "boolean"
              },
              KmsKeyId: {},
              PreSignedUrl: {},
              EnableCloudwatchLogsExports: {
                shape: "St"
              },
              DeletionProtection: {
                type: "boolean"
              },
              GlobalClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "CreateDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sw"
              }
            }
          }
        },
        CreateDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName",
              "DBParameterGroupFamily",
              "Description"
            ],
            members: {
              DBClusterParameterGroupName: {},
              DBParameterGroupFamily: {},
              Description: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBClusterParameterGroupResult",
            type: "structure",
            members: {
              DBClusterParameterGroup: {
                shape: "Sj"
              }
            }
          }
        },
        CreateDBClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier",
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterSnapshotIdentifier: {},
              DBClusterIdentifier: {},
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBClusterSnapshotResult",
            type: "structure",
            members: {
              DBClusterSnapshot: {
                shape: "Sn"
              }
            }
          }
        },
        CreateDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier",
              "DBInstanceClass",
              "Engine",
              "DBClusterIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              DBInstanceClass: {},
              Engine: {},
              AvailabilityZone: {},
              PreferredMaintenanceWindow: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              },
              DBClusterIdentifier: {},
              PromotionTier: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S1a"
              }
            }
          }
        },
        CreateDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "DBSubnetGroupDescription",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S1l"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S1c"
              }
            }
          }
        },
        CreateEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SnsTopicArn"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S6"
              },
              SourceIds: {
                shape: "S5"
              },
              Enabled: {
                type: "boolean"
              },
              Tags: {
                shape: "S9"
              }
            }
          },
          output: {
            resultWrapper: "CreateEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        CreateGlobalCluster: {
          input: {
            type: "structure",
            required: [
              "GlobalClusterIdentifier"
            ],
            members: {
              GlobalClusterIdentifier: {},
              SourceDBClusterIdentifier: {},
              Engine: {},
              EngineVersion: {},
              DeletionProtection: {
                type: "boolean"
              },
              DatabaseName: {},
              StorageEncrypted: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "CreateGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S1r"
              }
            }
          }
        },
        DeleteDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              SkipFinalSnapshot: {
                type: "boolean"
              },
              FinalDBSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sw"
              }
            }
          }
        },
        DeleteDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName"
            ],
            members: {
              DBClusterParameterGroupName: {}
            }
          }
        },
        DeleteDBClusterSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier"
            ],
            members: {
              DBClusterSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBClusterSnapshotResult",
            type: "structure",
            members: {
              DBClusterSnapshot: {
                shape: "Sn"
              }
            }
          }
        },
        DeleteDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S1a"
              }
            }
          }
        },
        DeleteDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName"
            ],
            members: {
              DBSubnetGroupName: {}
            }
          }
        },
        DeleteEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {}
            }
          },
          output: {
            resultWrapper: "DeleteEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        DeleteGlobalCluster: {
          input: {
            type: "structure",
            required: [
              "GlobalClusterIdentifier"
            ],
            members: {
              GlobalClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DeleteGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S1r"
              }
            }
          }
        },
        DescribeCertificates: {
          input: {
            type: "structure",
            members: {
              CertificateIdentifier: {},
              Filters: {
                shape: "S28"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeCertificatesResult",
            type: "structure",
            members: {
              Certificates: {
                type: "list",
                member: {
                  locationName: "Certificate",
                  type: "structure",
                  members: {
                    CertificateIdentifier: {},
                    CertificateType: {},
                    Thumbprint: {},
                    ValidFrom: {
                      type: "timestamp"
                    },
                    ValidTill: {
                      type: "timestamp"
                    },
                    CertificateArn: {}
                  },
                  wrapper: true
                }
              },
              Marker: {}
            }
          }
        },
        DescribeDBClusterParameterGroups: {
          input: {
            type: "structure",
            members: {
              DBClusterParameterGroupName: {},
              Filters: {
                shape: "S28"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterParameterGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusterParameterGroups: {
                type: "list",
                member: {
                  shape: "Sj",
                  locationName: "DBClusterParameterGroup"
                }
              }
            }
          }
        },
        DescribeDBClusterParameters: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName"
            ],
            members: {
              DBClusterParameterGroupName: {},
              Source: {},
              Filters: {
                shape: "S28"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterParametersResult",
            type: "structure",
            members: {
              Parameters: {
                shape: "S2j"
              },
              Marker: {}
            }
          }
        },
        DescribeDBClusterSnapshotAttributes: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier"
            ],
            members: {
              DBClusterSnapshotIdentifier: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterSnapshotAttributesResult",
            type: "structure",
            members: {
              DBClusterSnapshotAttributesResult: {
                shape: "S2o"
              }
            }
          }
        },
        DescribeDBClusterSnapshots: {
          input: {
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              DBClusterSnapshotIdentifier: {},
              SnapshotType: {},
              Filters: {
                shape: "S28"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              IncludeShared: {
                type: "boolean"
              },
              IncludePublic: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBClusterSnapshotsResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusterSnapshots: {
                type: "list",
                member: {
                  shape: "Sn",
                  locationName: "DBClusterSnapshot"
                }
              }
            }
          }
        },
        DescribeDBClusters: {
          input: {
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              Filters: {
                shape: "S28"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBClustersResult",
            type: "structure",
            members: {
              Marker: {},
              DBClusters: {
                type: "list",
                member: {
                  shape: "Sw",
                  locationName: "DBCluster"
                }
              }
            }
          }
        },
        DescribeDBEngineVersions: {
          input: {
            type: "structure",
            members: {
              Engine: {},
              EngineVersion: {},
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S28"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {},
              DefaultOnly: {
                type: "boolean"
              },
              ListSupportedCharacterSets: {
                type: "boolean"
              },
              ListSupportedTimezones: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "DescribeDBEngineVersionsResult",
            type: "structure",
            members: {
              Marker: {},
              DBEngineVersions: {
                type: "list",
                member: {
                  locationName: "DBEngineVersion",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBParameterGroupFamily: {},
                    DBEngineDescription: {},
                    DBEngineVersionDescription: {},
                    ValidUpgradeTarget: {
                      type: "list",
                      member: {
                        locationName: "UpgradeTarget",
                        type: "structure",
                        members: {
                          Engine: {},
                          EngineVersion: {},
                          Description: {},
                          AutoUpgrade: {
                            type: "boolean"
                          },
                          IsMajorVersionUpgrade: {
                            type: "boolean"
                          }
                        }
                      }
                    },
                    ExportableLogTypes: {
                      shape: "St"
                    },
                    SupportsLogExportsToCloudwatchLogs: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeDBInstances: {
          input: {
            type: "structure",
            members: {
              DBInstanceIdentifier: {},
              Filters: {
                shape: "S28"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBInstancesResult",
            type: "structure",
            members: {
              Marker: {},
              DBInstances: {
                type: "list",
                member: {
                  shape: "S1a",
                  locationName: "DBInstance"
                }
              }
            }
          }
        },
        DescribeDBSubnetGroups: {
          input: {
            type: "structure",
            members: {
              DBSubnetGroupName: {},
              Filters: {
                shape: "S28"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeDBSubnetGroupsResult",
            type: "structure",
            members: {
              Marker: {},
              DBSubnetGroups: {
                type: "list",
                member: {
                  shape: "S1c",
                  locationName: "DBSubnetGroup"
                }
              }
            }
          }
        },
        DescribeEngineDefaultClusterParameters: {
          input: {
            type: "structure",
            required: [
              "DBParameterGroupFamily"
            ],
            members: {
              DBParameterGroupFamily: {},
              Filters: {
                shape: "S28"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEngineDefaultClusterParametersResult",
            type: "structure",
            members: {
              EngineDefaults: {
                type: "structure",
                members: {
                  DBParameterGroupFamily: {},
                  Marker: {},
                  Parameters: {
                    shape: "S2j"
                  }
                },
                wrapper: true
              }
            }
          }
        },
        DescribeEventCategories: {
          input: {
            type: "structure",
            members: {
              SourceType: {},
              Filters: {
                shape: "S28"
              }
            }
          },
          output: {
            resultWrapper: "DescribeEventCategoriesResult",
            type: "structure",
            members: {
              EventCategoriesMapList: {
                type: "list",
                member: {
                  locationName: "EventCategoriesMap",
                  type: "structure",
                  members: {
                    SourceType: {},
                    EventCategories: {
                      shape: "S6"
                    }
                  },
                  wrapper: true
                }
              }
            }
          }
        },
        DescribeEventSubscriptions: {
          input: {
            type: "structure",
            members: {
              SubscriptionName: {},
              Filters: {
                shape: "S28"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventSubscriptionsResult",
            type: "structure",
            members: {
              Marker: {},
              EventSubscriptionsList: {
                type: "list",
                member: {
                  shape: "S4",
                  locationName: "EventSubscription"
                }
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceIdentifier: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              EventCategories: {
                shape: "S6"
              },
              Filters: {
                shape: "S28"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeEventsResult",
            type: "structure",
            members: {
              Marker: {},
              Events: {
                type: "list",
                member: {
                  locationName: "Event",
                  type: "structure",
                  members: {
                    SourceIdentifier: {},
                    SourceType: {},
                    Message: {},
                    EventCategories: {
                      shape: "S6"
                    },
                    Date: {
                      type: "timestamp"
                    },
                    SourceArn: {}
                  }
                }
              }
            }
          }
        },
        DescribeGlobalClusters: {
          input: {
            type: "structure",
            members: {
              GlobalClusterIdentifier: {},
              Filters: {
                shape: "S28"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeGlobalClustersResult",
            type: "structure",
            members: {
              Marker: {},
              GlobalClusters: {
                type: "list",
                member: {
                  shape: "S1r",
                  locationName: "GlobalClusterMember"
                }
              }
            }
          }
        },
        DescribeOrderableDBInstanceOptions: {
          input: {
            type: "structure",
            required: [
              "Engine"
            ],
            members: {
              Engine: {},
              EngineVersion: {},
              DBInstanceClass: {},
              LicenseModel: {},
              Vpc: {
                type: "boolean"
              },
              Filters: {
                shape: "S28"
              },
              MaxRecords: {
                type: "integer"
              },
              Marker: {}
            }
          },
          output: {
            resultWrapper: "DescribeOrderableDBInstanceOptionsResult",
            type: "structure",
            members: {
              OrderableDBInstanceOptions: {
                type: "list",
                member: {
                  locationName: "OrderableDBInstanceOption",
                  type: "structure",
                  members: {
                    Engine: {},
                    EngineVersion: {},
                    DBInstanceClass: {},
                    LicenseModel: {},
                    AvailabilityZones: {
                      type: "list",
                      member: {
                        shape: "S1f",
                        locationName: "AvailabilityZone"
                      }
                    },
                    Vpc: {
                      type: "boolean"
                    }
                  },
                  wrapper: true
                }
              },
              Marker: {}
            }
          }
        },
        DescribePendingMaintenanceActions: {
          input: {
            type: "structure",
            members: {
              ResourceIdentifier: {},
              Filters: {
                shape: "S28"
              },
              Marker: {},
              MaxRecords: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "DescribePendingMaintenanceActionsResult",
            type: "structure",
            members: {
              PendingMaintenanceActions: {
                type: "list",
                member: {
                  shape: "Sd",
                  locationName: "ResourcePendingMaintenanceActions"
                }
              },
              Marker: {}
            }
          }
        },
        FailoverDBCluster: {
          input: {
            type: "structure",
            members: {
              DBClusterIdentifier: {},
              TargetDBInstanceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "FailoverDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sw"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName"
            ],
            members: {
              ResourceName: {},
              Filters: {
                shape: "S28"
              }
            }
          },
          output: {
            resultWrapper: "ListTagsForResourceResult",
            type: "structure",
            members: {
              TagList: {
                shape: "S9"
              }
            }
          }
        },
        ModifyDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              NewDBClusterIdentifier: {},
              ApplyImmediately: {
                type: "boolean"
              },
              BackupRetentionPeriod: {
                type: "integer"
              },
              DBClusterParameterGroupName: {},
              VpcSecurityGroupIds: {
                shape: "Ss"
              },
              Port: {
                type: "integer"
              },
              MasterUserPassword: {},
              PreferredBackupWindow: {},
              PreferredMaintenanceWindow: {},
              CloudwatchLogsExportConfiguration: {
                type: "structure",
                members: {
                  EnableLogTypes: {
                    shape: "St"
                  },
                  DisableLogTypes: {
                    shape: "St"
                  }
                }
              },
              EngineVersion: {},
              DeletionProtection: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sw"
              }
            }
          }
        },
        ModifyDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName",
              "Parameters"
            ],
            members: {
              DBClusterParameterGroupName: {},
              Parameters: {
                shape: "S2j"
              }
            }
          },
          output: {
            shape: "S48",
            resultWrapper: "ModifyDBClusterParameterGroupResult"
          }
        },
        ModifyDBClusterSnapshotAttribute: {
          input: {
            type: "structure",
            required: [
              "DBClusterSnapshotIdentifier",
              "AttributeName"
            ],
            members: {
              DBClusterSnapshotIdentifier: {},
              AttributeName: {},
              ValuesToAdd: {
                shape: "S2r"
              },
              ValuesToRemove: {
                shape: "S2r"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBClusterSnapshotAttributeResult",
            type: "structure",
            members: {
              DBClusterSnapshotAttributesResult: {
                shape: "S2o"
              }
            }
          }
        },
        ModifyDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              DBInstanceClass: {},
              ApplyImmediately: {
                type: "boolean"
              },
              PreferredMaintenanceWindow: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              },
              NewDBInstanceIdentifier: {},
              CACertificateIdentifier: {},
              PromotionTier: {
                type: "integer"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S1a"
              }
            }
          }
        },
        ModifyDBSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "DBSubnetGroupName",
              "SubnetIds"
            ],
            members: {
              DBSubnetGroupName: {},
              DBSubnetGroupDescription: {},
              SubnetIds: {
                shape: "S1l"
              }
            }
          },
          output: {
            resultWrapper: "ModifyDBSubnetGroupResult",
            type: "structure",
            members: {
              DBSubnetGroup: {
                shape: "S1c"
              }
            }
          }
        },
        ModifyEventSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName"
            ],
            members: {
              SubscriptionName: {},
              SnsTopicArn: {},
              SourceType: {},
              EventCategories: {
                shape: "S6"
              },
              Enabled: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyEventSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        ModifyGlobalCluster: {
          input: {
            type: "structure",
            required: [
              "GlobalClusterIdentifier"
            ],
            members: {
              GlobalClusterIdentifier: {},
              NewGlobalClusterIdentifier: {},
              DeletionProtection: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "ModifyGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S1r"
              }
            }
          }
        },
        RebootDBInstance: {
          input: {
            type: "structure",
            required: [
              "DBInstanceIdentifier"
            ],
            members: {
              DBInstanceIdentifier: {},
              ForceFailover: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RebootDBInstanceResult",
            type: "structure",
            members: {
              DBInstance: {
                shape: "S1a"
              }
            }
          }
        },
        RemoveFromGlobalCluster: {
          input: {
            type: "structure",
            required: [
              "GlobalClusterIdentifier",
              "DbClusterIdentifier"
            ],
            members: {
              GlobalClusterIdentifier: {},
              DbClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RemoveFromGlobalClusterResult",
            type: "structure",
            members: {
              GlobalCluster: {
                shape: "S1r"
              }
            }
          }
        },
        RemoveSourceIdentifierFromSubscription: {
          input: {
            type: "structure",
            required: [
              "SubscriptionName",
              "SourceIdentifier"
            ],
            members: {
              SubscriptionName: {},
              SourceIdentifier: {}
            }
          },
          output: {
            resultWrapper: "RemoveSourceIdentifierFromSubscriptionResult",
            type: "structure",
            members: {
              EventSubscription: {
                shape: "S4"
              }
            }
          }
        },
        RemoveTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "ResourceName",
              "TagKeys"
            ],
            members: {
              ResourceName: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ResetDBClusterParameterGroup: {
          input: {
            type: "structure",
            required: [
              "DBClusterParameterGroupName"
            ],
            members: {
              DBClusterParameterGroupName: {},
              ResetAllParameters: {
                type: "boolean"
              },
              Parameters: {
                shape: "S2j"
              }
            }
          },
          output: {
            shape: "S48",
            resultWrapper: "ResetDBClusterParameterGroupResult"
          }
        },
        RestoreDBClusterFromSnapshot: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "SnapshotIdentifier",
              "Engine"
            ],
            members: {
              AvailabilityZones: {
                shape: "So"
              },
              DBClusterIdentifier: {},
              SnapshotIdentifier: {},
              Engine: {},
              EngineVersion: {},
              Port: {
                type: "integer"
              },
              DBSubnetGroupName: {},
              VpcSecurityGroupIds: {
                shape: "Ss"
              },
              Tags: {
                shape: "S9"
              },
              KmsKeyId: {},
              EnableCloudwatchLogsExports: {
                shape: "St"
              },
              DeletionProtection: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RestoreDBClusterFromSnapshotResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sw"
              }
            }
          }
        },
        RestoreDBClusterToPointInTime: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier",
              "SourceDBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {},
              SourceDBClusterIdentifier: {},
              RestoreToTime: {
                type: "timestamp"
              },
              UseLatestRestorableTime: {
                type: "boolean"
              },
              Port: {
                type: "integer"
              },
              DBSubnetGroupName: {},
              VpcSecurityGroupIds: {
                shape: "Ss"
              },
              Tags: {
                shape: "S9"
              },
              KmsKeyId: {},
              EnableCloudwatchLogsExports: {
                shape: "St"
              },
              DeletionProtection: {
                type: "boolean"
              }
            }
          },
          output: {
            resultWrapper: "RestoreDBClusterToPointInTimeResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sw"
              }
            }
          }
        },
        StartDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "StartDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sw"
              }
            }
          }
        },
        StopDBCluster: {
          input: {
            type: "structure",
            required: [
              "DBClusterIdentifier"
            ],
            members: {
              DBClusterIdentifier: {}
            }
          },
          output: {
            resultWrapper: "StopDBClusterResult",
            type: "structure",
            members: {
              DBCluster: {
                shape: "Sw"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            CustomerAwsId: {},
            CustSubscriptionId: {},
            SnsTopicArn: {},
            Status: {},
            SubscriptionCreationTime: {},
            SourceType: {},
            SourceIdsList: {
              shape: "S5"
            },
            EventCategoriesList: {
              shape: "S6"
            },
            Enabled: {
              type: "boolean"
            },
            EventSubscriptionArn: {}
          },
          wrapper: true
        },
        S5: {
          type: "list",
          member: {
            locationName: "SourceId"
          }
        },
        S6: {
          type: "list",
          member: {
            locationName: "EventCategory"
          }
        },
        S9: {
          type: "list",
          member: {
            locationName: "Tag",
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            ResourceIdentifier: {},
            PendingMaintenanceActionDetails: {
              type: "list",
              member: {
                locationName: "PendingMaintenanceAction",
                type: "structure",
                members: {
                  Action: {},
                  AutoAppliedAfterDate: {
                    type: "timestamp"
                  },
                  ForcedApplyDate: {
                    type: "timestamp"
                  },
                  OptInStatus: {},
                  CurrentApplyDate: {
                    type: "timestamp"
                  },
                  Description: {}
                }
              }
            }
          },
          wrapper: true
        },
        Sj: {
          type: "structure",
          members: {
            DBClusterParameterGroupName: {},
            DBParameterGroupFamily: {},
            Description: {},
            DBClusterParameterGroupArn: {}
          },
          wrapper: true
        },
        Sn: {
          type: "structure",
          members: {
            AvailabilityZones: {
              shape: "So"
            },
            DBClusterSnapshotIdentifier: {},
            DBClusterIdentifier: {},
            SnapshotCreateTime: {
              type: "timestamp"
            },
            Engine: {},
            Status: {},
            Port: {
              type: "integer"
            },
            VpcId: {},
            ClusterCreateTime: {
              type: "timestamp"
            },
            MasterUsername: {},
            EngineVersion: {},
            SnapshotType: {},
            PercentProgress: {
              type: "integer"
            },
            StorageEncrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            DBClusterSnapshotArn: {},
            SourceDBClusterSnapshotArn: {}
          },
          wrapper: true
        },
        So: {
          type: "list",
          member: {
            locationName: "AvailabilityZone"
          }
        },
        Ss: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupId"
          }
        },
        St: {
          type: "list",
          member: {}
        },
        Sw: {
          type: "structure",
          members: {
            AvailabilityZones: {
              shape: "So"
            },
            BackupRetentionPeriod: {
              type: "integer"
            },
            DBClusterIdentifier: {},
            DBClusterParameterGroup: {},
            DBSubnetGroup: {},
            Status: {},
            PercentProgress: {},
            EarliestRestorableTime: {
              type: "timestamp"
            },
            Endpoint: {},
            ReaderEndpoint: {},
            MultiAZ: {
              type: "boolean"
            },
            Engine: {},
            EngineVersion: {},
            LatestRestorableTime: {
              type: "timestamp"
            },
            Port: {
              type: "integer"
            },
            MasterUsername: {},
            PreferredBackupWindow: {},
            PreferredMaintenanceWindow: {},
            ReplicationSourceIdentifier: {},
            ReadReplicaIdentifiers: {
              type: "list",
              member: {
                locationName: "ReadReplicaIdentifier"
              }
            },
            DBClusterMembers: {
              type: "list",
              member: {
                locationName: "DBClusterMember",
                type: "structure",
                members: {
                  DBInstanceIdentifier: {},
                  IsClusterWriter: {
                    type: "boolean"
                  },
                  DBClusterParameterGroupStatus: {},
                  PromotionTier: {
                    type: "integer"
                  }
                },
                wrapper: true
              }
            },
            VpcSecurityGroups: {
              shape: "S10"
            },
            HostedZoneId: {},
            StorageEncrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            DbClusterResourceId: {},
            DBClusterArn: {},
            AssociatedRoles: {
              type: "list",
              member: {
                locationName: "DBClusterRole",
                type: "structure",
                members: {
                  RoleArn: {},
                  Status: {}
                }
              }
            },
            ClusterCreateTime: {
              type: "timestamp"
            },
            EnabledCloudwatchLogsExports: {
              shape: "St"
            },
            DeletionProtection: {
              type: "boolean"
            }
          },
          wrapper: true
        },
        S10: {
          type: "list",
          member: {
            locationName: "VpcSecurityGroupMembership",
            type: "structure",
            members: {
              VpcSecurityGroupId: {},
              Status: {}
            }
          }
        },
        S1a: {
          type: "structure",
          members: {
            DBInstanceIdentifier: {},
            DBInstanceClass: {},
            Engine: {},
            DBInstanceStatus: {},
            Endpoint: {
              type: "structure",
              members: {
                Address: {},
                Port: {
                  type: "integer"
                },
                HostedZoneId: {}
              }
            },
            InstanceCreateTime: {
              type: "timestamp"
            },
            PreferredBackupWindow: {},
            BackupRetentionPeriod: {
              type: "integer"
            },
            VpcSecurityGroups: {
              shape: "S10"
            },
            AvailabilityZone: {},
            DBSubnetGroup: {
              shape: "S1c"
            },
            PreferredMaintenanceWindow: {},
            PendingModifiedValues: {
              type: "structure",
              members: {
                DBInstanceClass: {},
                AllocatedStorage: {
                  type: "integer"
                },
                MasterUserPassword: {},
                Port: {
                  type: "integer"
                },
                BackupRetentionPeriod: {
                  type: "integer"
                },
                MultiAZ: {
                  type: "boolean"
                },
                EngineVersion: {},
                LicenseModel: {},
                Iops: {
                  type: "integer"
                },
                DBInstanceIdentifier: {},
                StorageType: {},
                CACertificateIdentifier: {},
                DBSubnetGroupName: {},
                PendingCloudwatchLogsExports: {
                  type: "structure",
                  members: {
                    LogTypesToEnable: {
                      shape: "St"
                    },
                    LogTypesToDisable: {
                      shape: "St"
                    }
                  }
                }
              }
            },
            LatestRestorableTime: {
              type: "timestamp"
            },
            EngineVersion: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            },
            PubliclyAccessible: {
              type: "boolean"
            },
            StatusInfos: {
              type: "list",
              member: {
                locationName: "DBInstanceStatusInfo",
                type: "structure",
                members: {
                  StatusType: {},
                  Normal: {
                    type: "boolean"
                  },
                  Status: {},
                  Message: {}
                }
              }
            },
            DBClusterIdentifier: {},
            StorageEncrypted: {
              type: "boolean"
            },
            KmsKeyId: {},
            DbiResourceId: {},
            CACertificateIdentifier: {},
            PromotionTier: {
              type: "integer"
            },
            DBInstanceArn: {},
            EnabledCloudwatchLogsExports: {
              shape: "St"
            }
          },
          wrapper: true
        },
        S1c: {
          type: "structure",
          members: {
            DBSubnetGroupName: {},
            DBSubnetGroupDescription: {},
            VpcId: {},
            SubnetGroupStatus: {},
            Subnets: {
              type: "list",
              member: {
                locationName: "Subnet",
                type: "structure",
                members: {
                  SubnetIdentifier: {},
                  SubnetAvailabilityZone: {
                    shape: "S1f"
                  },
                  SubnetStatus: {}
                }
              }
            },
            DBSubnetGroupArn: {}
          },
          wrapper: true
        },
        S1f: {
          type: "structure",
          members: {
            Name: {}
          },
          wrapper: true
        },
        S1l: {
          type: "list",
          member: {
            locationName: "SubnetIdentifier"
          }
        },
        S1r: {
          type: "structure",
          members: {
            GlobalClusterIdentifier: {},
            GlobalClusterResourceId: {},
            GlobalClusterArn: {},
            Status: {},
            Engine: {},
            EngineVersion: {},
            DatabaseName: {},
            StorageEncrypted: {
              type: "boolean"
            },
            DeletionProtection: {
              type: "boolean"
            },
            GlobalClusterMembers: {
              type: "list",
              member: {
                locationName: "GlobalClusterMember",
                type: "structure",
                members: {
                  DBClusterArn: {},
                  Readers: {
                    type: "list",
                    member: {}
                  },
                  IsWriter: {
                    type: "boolean"
                  }
                },
                wrapper: true
              }
            }
          },
          wrapper: true
        },
        S28: {
          type: "list",
          member: {
            locationName: "Filter",
            type: "structure",
            required: [
              "Name",
              "Values"
            ],
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {
                  locationName: "Value"
                }
              }
            }
          }
        },
        S2j: {
          type: "list",
          member: {
            locationName: "Parameter",
            type: "structure",
            members: {
              ParameterName: {},
              ParameterValue: {},
              Description: {},
              Source: {},
              ApplyType: {},
              DataType: {},
              AllowedValues: {},
              IsModifiable: {
                type: "boolean"
              },
              MinimumEngineVersion: {},
              ApplyMethod: {}
            }
          }
        },
        S2o: {
          type: "structure",
          members: {
            DBClusterSnapshotIdentifier: {},
            DBClusterSnapshotAttributes: {
              type: "list",
              member: {
                locationName: "DBClusterSnapshotAttribute",
                type: "structure",
                members: {
                  AttributeName: {},
                  AttributeValues: {
                    shape: "S2r"
                  }
                }
              }
            }
          },
          wrapper: true
        },
        S2r: {
          type: "list",
          member: {
            locationName: "AttributeValue"
          }
        },
        S48: {
          type: "structure",
          members: {
            DBClusterParameterGroupName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/docdb-2014-10-31.paginators.json
var require_docdb_2014_10_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/docdb-2014-10-31.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeCertificates: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Certificates"
        },
        DescribeDBClusterParameterGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusterParameterGroups"
        },
        DescribeDBClusterParameters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Parameters"
        },
        DescribeDBClusterSnapshots: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusterSnapshots"
        },
        DescribeDBClusters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBClusters"
        },
        DescribeDBEngineVersions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBEngineVersions"
        },
        DescribeDBInstances: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBInstances"
        },
        DescribeDBSubnetGroups: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "DBSubnetGroups"
        },
        DescribeEventSubscriptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "EventSubscriptionsList"
        },
        DescribeEvents: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "Events"
        },
        DescribeGlobalClusters: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "GlobalClusters"
        },
        DescribeOrderableDBInstanceOptions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "OrderableDBInstanceOptions"
        },
        DescribePendingMaintenanceActions: {
          input_token: "Marker",
          limit_key: "MaxRecords",
          output_token: "Marker",
          result_key: "PendingMaintenanceActions"
        },
        ListTagsForResource: {
          result_key: "TagList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/docdb-2014-10-31.waiters2.json
var require_docdb_2014_10_31_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/docdb-2014-10-31.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        DBInstanceAvailable: {
          delay: 30,
          operation: "DescribeDBInstances",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "available",
              matcher: "pathAll",
              state: "success",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "deleted",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "deleting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "failed",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "incompatible-restore",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "incompatible-parameters",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            }
          ]
        },
        DBInstanceDeleted: {
          delay: 30,
          operation: "DescribeDBInstances",
          maxAttempts: 60,
          acceptors: [
            {
              expected: "deleted",
              matcher: "pathAll",
              state: "success",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "DBInstanceNotFound",
              matcher: "error",
              state: "success"
            },
            {
              expected: "creating",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "modifying",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "rebooting",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            },
            {
              expected: "resetting-master-credentials",
              matcher: "pathAny",
              state: "failure",
              argument: "DBInstances[].DBInstanceStatus"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/docdb.js
var require_docdb2 = __commonJS({
  "node_modules/aws-sdk/clients/docdb.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["docdb"] = {};
    AWS3.DocDB = Service.defineService("docdb", ["2014-10-31"]);
    require_docdb();
    Object.defineProperty(apiLoader.services["docdb"], "2014-10-31", {
      get: function get() {
        var model = require_docdb_2014_10_31_min();
        model.paginators = require_docdb_2014_10_31_paginators().pagination;
        model.waiters = require_docdb_2014_10_31_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.DocDB;
  }
});

// node_modules/aws-sdk/apis/backup-2018-11-15.min.json
var require_backup_2018_11_15_min = __commonJS({
  "node_modules/aws-sdk/apis/backup-2018-11-15.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-11-15",
        endpointPrefix: "backup",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Backup",
        serviceId: "Backup",
        signatureVersion: "v4",
        uid: "backup-2018-11-15"
      },
      operations: {
        CreateBackupPlan: {
          http: {
            method: "PUT",
            requestUri: "/backup/plans/"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlan"
            ],
            members: {
              BackupPlan: {
                shape: "S2"
              },
              BackupPlanTags: {
                shape: "Sc"
              },
              CreatorRequestId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BackupPlanId: {},
              BackupPlanArn: {},
              CreationDate: {
                type: "timestamp"
              },
              VersionId: {},
              AdvancedBackupSettings: {
                shape: "Sj"
              }
            }
          },
          idempotent: true
        },
        CreateBackupSelection: {
          http: {
            method: "PUT",
            requestUri: "/backup/plans/{backupPlanId}/selections/"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanId",
              "BackupSelection"
            ],
            members: {
              BackupPlanId: {
                location: "uri",
                locationName: "backupPlanId"
              },
              BackupSelection: {
                shape: "St"
              },
              CreatorRequestId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SelectionId: {},
              BackupPlanId: {},
              CreationDate: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        CreateBackupVault: {
          http: {
            method: "PUT",
            requestUri: "/backup-vaults/{backupVaultName}"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              BackupVaultTags: {
                shape: "Sc"
              },
              EncryptionKeyArn: {},
              CreatorRequestId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BackupVaultName: {},
              BackupVaultArn: {},
              CreationDate: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        CreateFramework: {
          http: {
            requestUri: "/audit/frameworks"
          },
          input: {
            type: "structure",
            required: [
              "FrameworkName",
              "FrameworkControls"
            ],
            members: {
              FrameworkName: {},
              FrameworkDescription: {},
              FrameworkControls: {
                shape: "S18"
              },
              IdempotencyToken: {
                idempotencyToken: true
              },
              FrameworkTags: {
                shape: "S1i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FrameworkName: {},
              FrameworkArn: {}
            }
          },
          idempotent: true
        },
        CreateReportPlan: {
          http: {
            requestUri: "/audit/report-plans"
          },
          input: {
            type: "structure",
            required: [
              "ReportPlanName",
              "ReportDeliveryChannel",
              "ReportSetting"
            ],
            members: {
              ReportPlanName: {},
              ReportPlanDescription: {},
              ReportDeliveryChannel: {
                shape: "S1n"
              },
              ReportSetting: {
                shape: "S1p"
              },
              ReportPlanTags: {
                shape: "S1i"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReportPlanName: {},
              ReportPlanArn: {},
              CreationTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DeleteBackupPlan: {
          http: {
            method: "DELETE",
            requestUri: "/backup/plans/{backupPlanId}"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanId"
            ],
            members: {
              BackupPlanId: {
                location: "uri",
                locationName: "backupPlanId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupPlanId: {},
              BackupPlanArn: {},
              DeletionDate: {
                type: "timestamp"
              },
              VersionId: {}
            }
          }
        },
        DeleteBackupSelection: {
          http: {
            method: "DELETE",
            requestUri: "/backup/plans/{backupPlanId}/selections/{selectionId}"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanId",
              "SelectionId"
            ],
            members: {
              BackupPlanId: {
                location: "uri",
                locationName: "backupPlanId"
              },
              SelectionId: {
                location: "uri",
                locationName: "selectionId"
              }
            }
          }
        },
        DeleteBackupVault: {
          http: {
            method: "DELETE",
            requestUri: "/backup-vaults/{backupVaultName}"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              }
            }
          }
        },
        DeleteBackupVaultAccessPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/backup-vaults/{backupVaultName}/access-policy"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              }
            }
          },
          idempotent: true
        },
        DeleteBackupVaultLockConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/backup-vaults/{backupVaultName}/vault-lock"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              }
            }
          },
          idempotent: true
        },
        DeleteBackupVaultNotifications: {
          http: {
            method: "DELETE",
            requestUri: "/backup-vaults/{backupVaultName}/notification-configuration"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              }
            }
          },
          idempotent: true
        },
        DeleteFramework: {
          http: {
            method: "DELETE",
            requestUri: "/audit/frameworks/{frameworkName}"
          },
          input: {
            type: "structure",
            required: [
              "FrameworkName"
            ],
            members: {
              FrameworkName: {
                location: "uri",
                locationName: "frameworkName"
              }
            }
          }
        },
        DeleteRecoveryPoint: {
          http: {
            method: "DELETE",
            requestUri: "/backup-vaults/{backupVaultName}/recovery-points/{recoveryPointArn}"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName",
              "RecoveryPointArn"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              RecoveryPointArn: {
                location: "uri",
                locationName: "recoveryPointArn"
              }
            }
          },
          idempotent: true
        },
        DeleteReportPlan: {
          http: {
            method: "DELETE",
            requestUri: "/audit/report-plans/{reportPlanName}"
          },
          input: {
            type: "structure",
            required: [
              "ReportPlanName"
            ],
            members: {
              ReportPlanName: {
                location: "uri",
                locationName: "reportPlanName"
              }
            }
          },
          idempotent: true
        },
        DescribeBackupJob: {
          http: {
            method: "GET",
            requestUri: "/backup-jobs/{backupJobId}"
          },
          input: {
            type: "structure",
            required: [
              "BackupJobId"
            ],
            members: {
              BackupJobId: {
                location: "uri",
                locationName: "backupJobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccountId: {},
              BackupJobId: {},
              BackupVaultName: {},
              BackupVaultArn: {},
              RecoveryPointArn: {},
              ResourceArn: {},
              CreationDate: {
                type: "timestamp"
              },
              CompletionDate: {
                type: "timestamp"
              },
              State: {},
              StatusMessage: {},
              PercentDone: {},
              BackupSizeInBytes: {
                type: "long"
              },
              IamRoleArn: {},
              CreatedBy: {
                shape: "S27"
              },
              ResourceType: {},
              BytesTransferred: {
                type: "long"
              },
              ExpectedCompletionDate: {
                type: "timestamp"
              },
              StartBy: {
                type: "timestamp"
              },
              BackupOptions: {
                shape: "Sm"
              },
              BackupType: {}
            }
          },
          idempotent: true
        },
        DescribeBackupVault: {
          http: {
            method: "GET",
            requestUri: "/backup-vaults/{backupVaultName}"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupVaultName: {},
              BackupVaultArn: {},
              EncryptionKeyArn: {},
              CreationDate: {
                type: "timestamp"
              },
              CreatorRequestId: {},
              NumberOfRecoveryPoints: {
                type: "long"
              },
              Locked: {
                type: "boolean"
              },
              MinRetentionDays: {
                type: "long"
              },
              MaxRetentionDays: {
                type: "long"
              },
              LockDate: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DescribeCopyJob: {
          http: {
            method: "GET",
            requestUri: "/copy-jobs/{copyJobId}"
          },
          input: {
            type: "structure",
            required: [
              "CopyJobId"
            ],
            members: {
              CopyJobId: {
                location: "uri",
                locationName: "copyJobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CopyJob: {
                shape: "S2d"
              }
            }
          },
          idempotent: true
        },
        DescribeFramework: {
          http: {
            method: "GET",
            requestUri: "/audit/frameworks/{frameworkName}"
          },
          input: {
            type: "structure",
            required: [
              "FrameworkName"
            ],
            members: {
              FrameworkName: {
                location: "uri",
                locationName: "frameworkName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FrameworkName: {},
              FrameworkArn: {},
              FrameworkDescription: {},
              FrameworkControls: {
                shape: "S18"
              },
              CreationTime: {
                type: "timestamp"
              },
              DeploymentStatus: {},
              FrameworkStatus: {},
              IdempotencyToken: {}
            }
          }
        },
        DescribeGlobalSettings: {
          http: {
            method: "GET",
            requestUri: "/global-settings"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              GlobalSettings: {
                shape: "S2j"
              },
              LastUpdateTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeProtectedResource: {
          http: {
            method: "GET",
            requestUri: "/resources/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceArn: {},
              ResourceType: {},
              LastBackupTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DescribeRecoveryPoint: {
          http: {
            method: "GET",
            requestUri: "/backup-vaults/{backupVaultName}/recovery-points/{recoveryPointArn}"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName",
              "RecoveryPointArn"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              RecoveryPointArn: {
                location: "uri",
                locationName: "recoveryPointArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecoveryPointArn: {},
              BackupVaultName: {},
              BackupVaultArn: {},
              SourceBackupVaultArn: {},
              ResourceArn: {},
              ResourceType: {},
              CreatedBy: {
                shape: "S27"
              },
              IamRoleArn: {},
              Status: {},
              StatusMessage: {},
              CreationDate: {
                type: "timestamp"
              },
              CompletionDate: {
                type: "timestamp"
              },
              BackupSizeInBytes: {
                type: "long"
              },
              CalculatedLifecycle: {
                shape: "S2r"
              },
              Lifecycle: {
                shape: "Sa"
              },
              EncryptionKeyArn: {},
              IsEncrypted: {
                type: "boolean"
              },
              StorageClass: {},
              LastRestoreTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DescribeRegionSettings: {
          http: {
            method: "GET",
            requestUri: "/account-settings"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              ResourceTypeOptInPreference: {
                shape: "S2w"
              }
            }
          }
        },
        DescribeReportJob: {
          http: {
            method: "GET",
            requestUri: "/audit/report-jobs/{reportJobId}"
          },
          input: {
            type: "structure",
            required: [
              "ReportJobId"
            ],
            members: {
              ReportJobId: {
                location: "uri",
                locationName: "reportJobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReportJob: {
                shape: "S31"
              }
            }
          }
        },
        DescribeReportPlan: {
          http: {
            method: "GET",
            requestUri: "/audit/report-plans/{reportPlanName}"
          },
          input: {
            type: "structure",
            required: [
              "ReportPlanName"
            ],
            members: {
              ReportPlanName: {
                location: "uri",
                locationName: "reportPlanName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReportPlan: {
                shape: "S35"
              }
            }
          }
        },
        DescribeRestoreJob: {
          http: {
            method: "GET",
            requestUri: "/restore-jobs/{restoreJobId}"
          },
          input: {
            type: "structure",
            required: [
              "RestoreJobId"
            ],
            members: {
              RestoreJobId: {
                location: "uri",
                locationName: "restoreJobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccountId: {},
              RestoreJobId: {},
              RecoveryPointArn: {},
              CreationDate: {
                type: "timestamp"
              },
              CompletionDate: {
                type: "timestamp"
              },
              Status: {},
              StatusMessage: {},
              PercentDone: {},
              BackupSizeInBytes: {
                type: "long"
              },
              IamRoleArn: {},
              ExpectedCompletionTimeMinutes: {
                type: "long"
              },
              CreatedResourceArn: {},
              ResourceType: {}
            }
          },
          idempotent: true
        },
        DisassociateRecoveryPoint: {
          http: {
            requestUri: "/backup-vaults/{backupVaultName}/recovery-points/{recoveryPointArn}/disassociate"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName",
              "RecoveryPointArn"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              RecoveryPointArn: {
                location: "uri",
                locationName: "recoveryPointArn"
              }
            }
          }
        },
        ExportBackupPlanTemplate: {
          http: {
            method: "GET",
            requestUri: "/backup/plans/{backupPlanId}/toTemplate/"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanId"
            ],
            members: {
              BackupPlanId: {
                location: "uri",
                locationName: "backupPlanId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupPlanTemplateJson: {}
            }
          }
        },
        GetBackupPlan: {
          http: {
            method: "GET",
            requestUri: "/backup/plans/{backupPlanId}/"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanId"
            ],
            members: {
              BackupPlanId: {
                location: "uri",
                locationName: "backupPlanId"
              },
              VersionId: {
                location: "querystring",
                locationName: "versionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupPlan: {
                shape: "S3f"
              },
              BackupPlanId: {},
              BackupPlanArn: {},
              VersionId: {},
              CreatorRequestId: {},
              CreationDate: {
                type: "timestamp"
              },
              DeletionDate: {
                type: "timestamp"
              },
              LastExecutionDate: {
                type: "timestamp"
              },
              AdvancedBackupSettings: {
                shape: "Sj"
              }
            }
          },
          idempotent: true
        },
        GetBackupPlanFromJSON: {
          http: {
            requestUri: "/backup/template/json/toPlan"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanTemplateJson"
            ],
            members: {
              BackupPlanTemplateJson: {}
            }
          },
          output: {
            type: "structure",
            members: {
              BackupPlan: {
                shape: "S3f"
              }
            }
          }
        },
        GetBackupPlanFromTemplate: {
          http: {
            method: "GET",
            requestUri: "/backup/template/plans/{templateId}/toPlan"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanTemplateId"
            ],
            members: {
              BackupPlanTemplateId: {
                location: "uri",
                locationName: "templateId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupPlanDocument: {
                shape: "S3f"
              }
            }
          }
        },
        GetBackupSelection: {
          http: {
            method: "GET",
            requestUri: "/backup/plans/{backupPlanId}/selections/{selectionId}"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanId",
              "SelectionId"
            ],
            members: {
              BackupPlanId: {
                location: "uri",
                locationName: "backupPlanId"
              },
              SelectionId: {
                location: "uri",
                locationName: "selectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupSelection: {
                shape: "St"
              },
              SelectionId: {},
              BackupPlanId: {},
              CreationDate: {
                type: "timestamp"
              },
              CreatorRequestId: {}
            }
          },
          idempotent: true
        },
        GetBackupVaultAccessPolicy: {
          http: {
            method: "GET",
            requestUri: "/backup-vaults/{backupVaultName}/access-policy"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupVaultName: {},
              BackupVaultArn: {},
              Policy: {}
            }
          },
          idempotent: true
        },
        GetBackupVaultNotifications: {
          http: {
            method: "GET",
            requestUri: "/backup-vaults/{backupVaultName}/notification-configuration"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupVaultName: {},
              BackupVaultArn: {},
              SNSTopicArn: {},
              BackupVaultEvents: {
                shape: "S3t"
              }
            }
          },
          idempotent: true
        },
        GetRecoveryPointRestoreMetadata: {
          http: {
            method: "GET",
            requestUri: "/backup-vaults/{backupVaultName}/recovery-points/{recoveryPointArn}/restore-metadata"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName",
              "RecoveryPointArn"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              RecoveryPointArn: {
                location: "uri",
                locationName: "recoveryPointArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupVaultArn: {},
              RecoveryPointArn: {},
              RestoreMetadata: {
                shape: "S3x"
              }
            }
          },
          idempotent: true
        },
        GetSupportedResourceTypes: {
          http: {
            method: "GET",
            requestUri: "/supported-resource-types"
          },
          output: {
            type: "structure",
            members: {
              ResourceTypes: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListBackupJobs: {
          http: {
            method: "GET",
            requestUri: "/backup-jobs/"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              ByResourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              ByState: {
                location: "querystring",
                locationName: "state"
              },
              ByBackupVaultName: {
                location: "querystring",
                locationName: "backupVaultName"
              },
              ByCreatedBefore: {
                location: "querystring",
                locationName: "createdBefore",
                type: "timestamp"
              },
              ByCreatedAfter: {
                location: "querystring",
                locationName: "createdAfter",
                type: "timestamp"
              },
              ByResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              ByAccountId: {
                location: "querystring",
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountId: {},
                    BackupJobId: {},
                    BackupVaultName: {},
                    BackupVaultArn: {},
                    RecoveryPointArn: {},
                    ResourceArn: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    CompletionDate: {
                      type: "timestamp"
                    },
                    State: {},
                    StatusMessage: {},
                    PercentDone: {},
                    BackupSizeInBytes: {
                      type: "long"
                    },
                    IamRoleArn: {},
                    CreatedBy: {
                      shape: "S27"
                    },
                    ExpectedCompletionDate: {
                      type: "timestamp"
                    },
                    StartBy: {
                      type: "timestamp"
                    },
                    ResourceType: {},
                    BytesTransferred: {
                      type: "long"
                    },
                    BackupOptions: {
                      shape: "Sm"
                    },
                    BackupType: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListBackupPlanTemplates: {
          http: {
            method: "GET",
            requestUri: "/backup/template/plans"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              BackupPlanTemplatesList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    BackupPlanTemplateId: {},
                    BackupPlanTemplateName: {}
                  }
                }
              }
            }
          }
        },
        ListBackupPlanVersions: {
          http: {
            method: "GET",
            requestUri: "/backup/plans/{backupPlanId}/versions/"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanId"
            ],
            members: {
              BackupPlanId: {
                location: "uri",
                locationName: "backupPlanId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              BackupPlanVersionsList: {
                type: "list",
                member: {
                  shape: "S4e"
                }
              }
            }
          },
          idempotent: true
        },
        ListBackupPlans: {
          http: {
            method: "GET",
            requestUri: "/backup/plans/"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              IncludeDeleted: {
                location: "querystring",
                locationName: "includeDeleted",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              BackupPlansList: {
                type: "list",
                member: {
                  shape: "S4e"
                }
              }
            }
          },
          idempotent: true
        },
        ListBackupSelections: {
          http: {
            method: "GET",
            requestUri: "/backup/plans/{backupPlanId}/selections/"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanId"
            ],
            members: {
              BackupPlanId: {
                location: "uri",
                locationName: "backupPlanId"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              BackupSelectionsList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SelectionId: {},
                    SelectionName: {},
                    BackupPlanId: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    CreatorRequestId: {},
                    IamRoleArn: {}
                  }
                }
              }
            }
          },
          idempotent: true
        },
        ListBackupVaults: {
          http: {
            method: "GET",
            requestUri: "/backup-vaults/"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupVaultList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    BackupVaultName: {},
                    BackupVaultArn: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    EncryptionKeyArn: {},
                    CreatorRequestId: {},
                    NumberOfRecoveryPoints: {
                      type: "long"
                    },
                    Locked: {
                      type: "boolean"
                    },
                    MinRetentionDays: {
                      type: "long"
                    },
                    MaxRetentionDays: {
                      type: "long"
                    },
                    LockDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListCopyJobs: {
          http: {
            method: "GET",
            requestUri: "/copy-jobs/"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              ByResourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              ByState: {
                location: "querystring",
                locationName: "state"
              },
              ByCreatedBefore: {
                location: "querystring",
                locationName: "createdBefore",
                type: "timestamp"
              },
              ByCreatedAfter: {
                location: "querystring",
                locationName: "createdAfter",
                type: "timestamp"
              },
              ByResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              ByDestinationVaultArn: {
                location: "querystring",
                locationName: "destinationVaultArn"
              },
              ByAccountId: {
                location: "querystring",
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CopyJobs: {
                type: "list",
                member: {
                  shape: "S2d"
                }
              },
              NextToken: {}
            }
          }
        },
        ListFrameworks: {
          http: {
            method: "GET",
            requestUri: "/audit/frameworks"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Frameworks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FrameworkName: {},
                    FrameworkArn: {},
                    FrameworkDescription: {},
                    NumberOfControls: {
                      type: "integer"
                    },
                    CreationTime: {
                      type: "timestamp"
                    },
                    DeploymentStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProtectedResources: {
          http: {
            method: "GET",
            requestUri: "/resources/"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceArn: {},
                    ResourceType: {},
                    LastBackupTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListRecoveryPointsByBackupVault: {
          http: {
            method: "GET",
            requestUri: "/backup-vaults/{backupVaultName}/recovery-points/"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              ByResourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              ByResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              ByBackupPlanId: {
                location: "querystring",
                locationName: "backupPlanId"
              },
              ByCreatedBefore: {
                location: "querystring",
                locationName: "createdBefore",
                type: "timestamp"
              },
              ByCreatedAfter: {
                location: "querystring",
                locationName: "createdAfter",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              RecoveryPoints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RecoveryPointArn: {},
                    BackupVaultName: {},
                    BackupVaultArn: {},
                    SourceBackupVaultArn: {},
                    ResourceArn: {},
                    ResourceType: {},
                    CreatedBy: {
                      shape: "S27"
                    },
                    IamRoleArn: {},
                    Status: {},
                    StatusMessage: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    CompletionDate: {
                      type: "timestamp"
                    },
                    BackupSizeInBytes: {
                      type: "long"
                    },
                    CalculatedLifecycle: {
                      shape: "S2r"
                    },
                    Lifecycle: {
                      shape: "Sa"
                    },
                    EncryptionKeyArn: {},
                    IsEncrypted: {
                      type: "boolean"
                    },
                    LastRestoreTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          },
          idempotent: true
        },
        ListRecoveryPointsByResource: {
          http: {
            method: "GET",
            requestUri: "/resources/{resourceArn}/recovery-points/"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              RecoveryPoints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RecoveryPointArn: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    Status: {},
                    StatusMessage: {},
                    EncryptionKeyArn: {},
                    BackupSizeBytes: {
                      type: "long"
                    },
                    BackupVaultName: {}
                  }
                }
              }
            }
          },
          idempotent: true
        },
        ListReportJobs: {
          http: {
            method: "GET",
            requestUri: "/audit/report-jobs"
          },
          input: {
            type: "structure",
            members: {
              ByReportPlanName: {
                location: "querystring",
                locationName: "ReportPlanName"
              },
              ByCreationBefore: {
                location: "querystring",
                locationName: "CreationBefore",
                type: "timestamp"
              },
              ByCreationAfter: {
                location: "querystring",
                locationName: "CreationAfter",
                type: "timestamp"
              },
              ByStatus: {
                location: "querystring",
                locationName: "Status"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReportJobs: {
                type: "list",
                member: {
                  shape: "S31"
                }
              },
              NextToken: {}
            }
          }
        },
        ListReportPlans: {
          http: {
            method: "GET",
            requestUri: "/audit/report-plans"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReportPlans: {
                type: "list",
                member: {
                  shape: "S35"
                }
              },
              NextToken: {}
            }
          }
        },
        ListRestoreJobs: {
          http: {
            method: "GET",
            requestUri: "/restore-jobs/"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              ByAccountId: {
                location: "querystring",
                locationName: "accountId"
              },
              ByCreatedBefore: {
                location: "querystring",
                locationName: "createdBefore",
                type: "timestamp"
              },
              ByCreatedAfter: {
                location: "querystring",
                locationName: "createdAfter",
                type: "timestamp"
              },
              ByStatus: {
                location: "querystring",
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RestoreJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountId: {},
                    RestoreJobId: {},
                    RecoveryPointArn: {},
                    CreationDate: {
                      type: "timestamp"
                    },
                    CompletionDate: {
                      type: "timestamp"
                    },
                    Status: {},
                    StatusMessage: {},
                    PercentDone: {},
                    BackupSizeInBytes: {
                      type: "long"
                    },
                    IamRoleArn: {},
                    ExpectedCompletionTimeMinutes: {
                      type: "long"
                    },
                    CreatedResourceArn: {},
                    ResourceType: {}
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListTags: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}/"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Tags: {
                shape: "Sc"
              }
            }
          },
          idempotent: true
        },
        PutBackupVaultAccessPolicy: {
          http: {
            method: "PUT",
            requestUri: "/backup-vaults/{backupVaultName}/access-policy"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              Policy: {}
            }
          },
          idempotent: true
        },
        PutBackupVaultLockConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/backup-vaults/{backupVaultName}/vault-lock"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              MinRetentionDays: {
                type: "long"
              },
              MaxRetentionDays: {
                type: "long"
              },
              ChangeableForDays: {
                type: "long"
              }
            }
          },
          idempotent: true
        },
        PutBackupVaultNotifications: {
          http: {
            method: "PUT",
            requestUri: "/backup-vaults/{backupVaultName}/notification-configuration"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName",
              "SNSTopicArn",
              "BackupVaultEvents"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              SNSTopicArn: {},
              BackupVaultEvents: {
                shape: "S3t"
              }
            }
          },
          idempotent: true
        },
        StartBackupJob: {
          http: {
            method: "PUT",
            requestUri: "/backup-jobs"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName",
              "ResourceArn",
              "IamRoleArn"
            ],
            members: {
              BackupVaultName: {},
              ResourceArn: {},
              IamRoleArn: {},
              IdempotencyToken: {},
              StartWindowMinutes: {
                type: "long"
              },
              CompleteWindowMinutes: {
                type: "long"
              },
              Lifecycle: {
                shape: "Sa"
              },
              RecoveryPointTags: {
                shape: "Sc"
              },
              BackupOptions: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupJobId: {},
              RecoveryPointArn: {},
              CreationDate: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        StartCopyJob: {
          http: {
            method: "PUT",
            requestUri: "/copy-jobs"
          },
          input: {
            type: "structure",
            required: [
              "RecoveryPointArn",
              "SourceBackupVaultName",
              "DestinationBackupVaultArn",
              "IamRoleArn"
            ],
            members: {
              RecoveryPointArn: {},
              SourceBackupVaultName: {},
              DestinationBackupVaultArn: {},
              IamRoleArn: {},
              IdempotencyToken: {},
              Lifecycle: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CopyJobId: {},
              CreationDate: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        StartReportJob: {
          http: {
            requestUri: "/audit/report-jobs/{reportPlanName}"
          },
          input: {
            type: "structure",
            required: [
              "ReportPlanName"
            ],
            members: {
              ReportPlanName: {
                location: "uri",
                locationName: "reportPlanName"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReportJobId: {}
            }
          },
          idempotent: true
        },
        StartRestoreJob: {
          http: {
            method: "PUT",
            requestUri: "/restore-jobs"
          },
          input: {
            type: "structure",
            required: [
              "RecoveryPointArn",
              "Metadata",
              "IamRoleArn"
            ],
            members: {
              RecoveryPointArn: {},
              Metadata: {
                shape: "S3x"
              },
              IamRoleArn: {},
              IdempotencyToken: {},
              ResourceType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RestoreJobId: {}
            }
          },
          idempotent: true
        },
        StopBackupJob: {
          http: {
            requestUri: "/backup-jobs/{backupJobId}"
          },
          input: {
            type: "structure",
            required: [
              "BackupJobId"
            ],
            members: {
              BackupJobId: {
                location: "uri",
                locationName: "backupJobId"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "Sc"
              }
            }
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            requestUri: "/untag/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeyList"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeyList: {
                type: "list",
                member: {},
                sensitive: true
              }
            }
          },
          idempotent: true
        },
        UpdateBackupPlan: {
          http: {
            requestUri: "/backup/plans/{backupPlanId}"
          },
          input: {
            type: "structure",
            required: [
              "BackupPlanId",
              "BackupPlan"
            ],
            members: {
              BackupPlanId: {
                location: "uri",
                locationName: "backupPlanId"
              },
              BackupPlan: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupPlanId: {},
              BackupPlanArn: {},
              CreationDate: {
                type: "timestamp"
              },
              VersionId: {},
              AdvancedBackupSettings: {
                shape: "Sj"
              }
            }
          },
          idempotent: true
        },
        UpdateFramework: {
          http: {
            method: "PUT",
            requestUri: "/audit/frameworks/{frameworkName}"
          },
          input: {
            type: "structure",
            required: [
              "FrameworkName"
            ],
            members: {
              FrameworkName: {
                location: "uri",
                locationName: "frameworkName"
              },
              FrameworkDescription: {},
              FrameworkControls: {
                shape: "S18"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FrameworkName: {},
              FrameworkArn: {},
              CreationTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        UpdateGlobalSettings: {
          http: {
            method: "PUT",
            requestUri: "/global-settings"
          },
          input: {
            type: "structure",
            members: {
              GlobalSettings: {
                shape: "S2j"
              }
            }
          }
        },
        UpdateRecoveryPointLifecycle: {
          http: {
            requestUri: "/backup-vaults/{backupVaultName}/recovery-points/{recoveryPointArn}"
          },
          input: {
            type: "structure",
            required: [
              "BackupVaultName",
              "RecoveryPointArn"
            ],
            members: {
              BackupVaultName: {
                location: "uri",
                locationName: "backupVaultName"
              },
              RecoveryPointArn: {
                location: "uri",
                locationName: "recoveryPointArn"
              },
              Lifecycle: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BackupVaultArn: {},
              RecoveryPointArn: {},
              Lifecycle: {
                shape: "Sa"
              },
              CalculatedLifecycle: {
                shape: "S2r"
              }
            }
          },
          idempotent: true
        },
        UpdateRegionSettings: {
          http: {
            method: "PUT",
            requestUri: "/account-settings"
          },
          input: {
            type: "structure",
            members: {
              ResourceTypeOptInPreference: {
                shape: "S2w"
              }
            }
          }
        },
        UpdateReportPlan: {
          http: {
            method: "PUT",
            requestUri: "/audit/report-plans/{reportPlanName}"
          },
          input: {
            type: "structure",
            required: [
              "ReportPlanName"
            ],
            members: {
              ReportPlanName: {
                location: "uri",
                locationName: "reportPlanName"
              },
              ReportPlanDescription: {},
              ReportDeliveryChannel: {
                shape: "S1n"
              },
              ReportSetting: {
                shape: "S1p"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReportPlanName: {},
              ReportPlanArn: {},
              CreationTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "BackupPlanName",
            "Rules"
          ],
          members: {
            BackupPlanName: {},
            Rules: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "RuleName",
                  "TargetBackupVaultName"
                ],
                members: {
                  RuleName: {},
                  TargetBackupVaultName: {},
                  ScheduleExpression: {},
                  StartWindowMinutes: {
                    type: "long"
                  },
                  CompletionWindowMinutes: {
                    type: "long"
                  },
                  Lifecycle: {
                    shape: "Sa"
                  },
                  RecoveryPointTags: {
                    shape: "Sc"
                  },
                  CopyActions: {
                    shape: "Sf"
                  },
                  EnableContinuousBackup: {
                    type: "boolean"
                  }
                }
              }
            },
            AdvancedBackupSettings: {
              shape: "Sj"
            }
          }
        },
        Sa: {
          type: "structure",
          members: {
            MoveToColdStorageAfterDays: {
              type: "long"
            },
            DeleteAfterDays: {
              type: "long"
            }
          }
        },
        Sc: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        Sf: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DestinationBackupVaultArn"
            ],
            members: {
              Lifecycle: {
                shape: "Sa"
              },
              DestinationBackupVaultArn: {}
            }
          }
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ResourceType: {},
              BackupOptions: {
                shape: "Sm"
              }
            }
          }
        },
        Sm: {
          type: "map",
          key: {},
          value: {}
        },
        St: {
          type: "structure",
          required: [
            "SelectionName",
            "IamRoleArn"
          ],
          members: {
            SelectionName: {},
            IamRoleArn: {},
            Resources: {
              type: "list",
              member: {}
            },
            ListOfTags: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ConditionType",
                  "ConditionKey",
                  "ConditionValue"
                ],
                members: {
                  ConditionType: {},
                  ConditionKey: {},
                  ConditionValue: {}
                }
              }
            }
          }
        },
        S18: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ControlName"
            ],
            members: {
              ControlName: {},
              ControlInputParameters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ParameterName: {},
                    ParameterValue: {}
                  }
                }
              },
              ControlScope: {
                type: "structure",
                members: {
                  ComplianceResourceIds: {
                    type: "list",
                    member: {}
                  },
                  ComplianceResourceTypes: {
                    type: "list",
                    member: {}
                  },
                  Tags: {
                    shape: "S1i"
                  }
                }
              }
            }
          }
        },
        S1i: {
          type: "map",
          key: {},
          value: {}
        },
        S1n: {
          type: "structure",
          required: [
            "S3BucketName"
          ],
          members: {
            S3BucketName: {},
            S3KeyPrefix: {},
            Formats: {
              type: "list",
              member: {}
            }
          }
        },
        S1p: {
          type: "structure",
          required: [
            "ReportTemplate"
          ],
          members: {
            ReportTemplate: {},
            FrameworkArns: {
              shape: "S1q"
            },
            NumberOfFrameworks: {
              type: "integer"
            }
          }
        },
        S1q: {
          type: "list",
          member: {}
        },
        S27: {
          type: "structure",
          members: {
            BackupPlanId: {},
            BackupPlanArn: {},
            BackupPlanVersion: {},
            BackupRuleId: {}
          }
        },
        S2d: {
          type: "structure",
          members: {
            AccountId: {},
            CopyJobId: {},
            SourceBackupVaultArn: {},
            SourceRecoveryPointArn: {},
            DestinationBackupVaultArn: {},
            DestinationRecoveryPointArn: {},
            ResourceArn: {},
            CreationDate: {
              type: "timestamp"
            },
            CompletionDate: {
              type: "timestamp"
            },
            State: {},
            StatusMessage: {},
            BackupSizeInBytes: {
              type: "long"
            },
            IamRoleArn: {},
            CreatedBy: {
              shape: "S27"
            },
            ResourceType: {}
          }
        },
        S2j: {
          type: "map",
          key: {},
          value: {}
        },
        S2r: {
          type: "structure",
          members: {
            MoveToColdStorageAt: {
              type: "timestamp"
            },
            DeleteAt: {
              type: "timestamp"
            }
          }
        },
        S2w: {
          type: "map",
          key: {},
          value: {
            type: "boolean"
          }
        },
        S31: {
          type: "structure",
          members: {
            ReportJobId: {},
            ReportPlanArn: {},
            ReportTemplate: {},
            CreationTime: {
              type: "timestamp"
            },
            CompletionTime: {
              type: "timestamp"
            },
            Status: {},
            StatusMessage: {},
            ReportDestination: {
              type: "structure",
              members: {
                S3BucketName: {},
                S3Keys: {
                  shape: "S1q"
                }
              }
            }
          }
        },
        S35: {
          type: "structure",
          members: {
            ReportPlanArn: {},
            ReportPlanName: {},
            ReportPlanDescription: {},
            ReportSetting: {
              shape: "S1p"
            },
            ReportDeliveryChannel: {
              shape: "S1n"
            },
            DeploymentStatus: {},
            CreationTime: {
              type: "timestamp"
            },
            LastAttemptedExecutionTime: {
              type: "timestamp"
            },
            LastSuccessfulExecutionTime: {
              type: "timestamp"
            }
          }
        },
        S3f: {
          type: "structure",
          required: [
            "BackupPlanName",
            "Rules"
          ],
          members: {
            BackupPlanName: {},
            Rules: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "RuleName",
                  "TargetBackupVaultName"
                ],
                members: {
                  RuleName: {},
                  TargetBackupVaultName: {},
                  ScheduleExpression: {},
                  StartWindowMinutes: {
                    type: "long"
                  },
                  CompletionWindowMinutes: {
                    type: "long"
                  },
                  Lifecycle: {
                    shape: "Sa"
                  },
                  RecoveryPointTags: {
                    shape: "Sc"
                  },
                  RuleId: {},
                  CopyActions: {
                    shape: "Sf"
                  },
                  EnableContinuousBackup: {
                    type: "boolean"
                  }
                }
              }
            },
            AdvancedBackupSettings: {
              shape: "Sj"
            }
          }
        },
        S3t: {
          type: "list",
          member: {}
        },
        S3x: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        S4e: {
          type: "structure",
          members: {
            BackupPlanArn: {},
            BackupPlanId: {},
            CreationDate: {
              type: "timestamp"
            },
            DeletionDate: {
              type: "timestamp"
            },
            VersionId: {},
            BackupPlanName: {},
            CreatorRequestId: {},
            LastExecutionDate: {
              type: "timestamp"
            },
            AdvancedBackupSettings: {
              shape: "Sj"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/backup-2018-11-15.paginators.json
var require_backup_2018_11_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/backup-2018-11-15.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListBackupJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListBackupPlanTemplates: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListBackupPlanVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListBackupPlans: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListBackupSelections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListBackupVaults: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListCopyJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListFrameworks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListProtectedResources: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListRecoveryPointsByBackupVault: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListRecoveryPointsByResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListReportJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListReportPlans: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListRestoreJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTags: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/backup.js
var require_backup = __commonJS({
  "node_modules/aws-sdk/clients/backup.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["backup"] = {};
    AWS3.Backup = Service.defineService("backup", ["2018-11-15"]);
    Object.defineProperty(apiLoader.services["backup"], "2018-11-15", {
      get: function get() {
        var model = require_backup_2018_11_15_min();
        model.paginators = require_backup_2018_11_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Backup;
  }
});

// node_modules/aws-sdk/apis/worklink-2018-09-25.min.json
var require_worklink_2018_09_25_min = __commonJS({
  "node_modules/aws-sdk/apis/worklink-2018-09-25.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-09-25",
        endpointPrefix: "worklink",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "WorkLink",
        serviceFullName: "Amazon WorkLink",
        serviceId: "WorkLink",
        signatureVersion: "v4",
        signingName: "worklink",
        uid: "worklink-2018-09-25"
      },
      operations: {
        AssociateDomain: {
          http: {
            requestUri: "/associateDomain"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "DomainName",
              "AcmCertificateArn"
            ],
            members: {
              FleetArn: {},
              DomainName: {},
              DisplayName: {},
              AcmCertificateArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateWebsiteAuthorizationProvider: {
          http: {
            requestUri: "/associateWebsiteAuthorizationProvider"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "AuthorizationProviderType"
            ],
            members: {
              FleetArn: {},
              AuthorizationProviderType: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AuthorizationProviderId: {}
            }
          }
        },
        AssociateWebsiteCertificateAuthority: {
          http: {
            requestUri: "/associateWebsiteCertificateAuthority"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "Certificate"
            ],
            members: {
              FleetArn: {},
              Certificate: {},
              DisplayName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WebsiteCaId: {}
            }
          }
        },
        CreateFleet: {
          http: {
            requestUri: "/createFleet"
          },
          input: {
            type: "structure",
            required: [
              "FleetName"
            ],
            members: {
              FleetName: {},
              DisplayName: {},
              OptimizeForEndUserLocation: {
                type: "boolean"
              },
              Tags: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FleetArn: {}
            }
          }
        },
        DeleteFleet: {
          http: {
            requestUri: "/deleteFleet"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeAuditStreamConfiguration: {
          http: {
            requestUri: "/describeAuditStreamConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AuditStreamArn: {}
            }
          }
        },
        DescribeCompanyNetworkConfiguration: {
          http: {
            requestUri: "/describeCompanyNetworkConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VpcId: {},
              SubnetIds: {
                shape: "St"
              },
              SecurityGroupIds: {
                shape: "Sv"
              }
            }
          }
        },
        DescribeDevice: {
          http: {
            requestUri: "/describeDevice"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "DeviceId"
            ],
            members: {
              FleetArn: {},
              DeviceId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              Model: {},
              Manufacturer: {},
              OperatingSystem: {},
              OperatingSystemVersion: {},
              PatchLevel: {},
              FirstAccessedTime: {
                type: "timestamp"
              },
              LastAccessedTime: {
                type: "timestamp"
              },
              Username: {}
            }
          }
        },
        DescribeDevicePolicyConfiguration: {
          http: {
            requestUri: "/describeDevicePolicyConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DeviceCaCertificate: {}
            }
          }
        },
        DescribeDomain: {
          http: {
            requestUri: "/describeDomain"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "DomainName"
            ],
            members: {
              FleetArn: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DomainName: {},
              DisplayName: {},
              CreatedTime: {
                type: "timestamp"
              },
              DomainStatus: {},
              AcmCertificateArn: {}
            }
          }
        },
        DescribeFleetMetadata: {
          http: {
            requestUri: "/describeFleetMetadata"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CreatedTime: {
                type: "timestamp"
              },
              LastUpdatedTime: {
                type: "timestamp"
              },
              FleetName: {},
              DisplayName: {},
              OptimizeForEndUserLocation: {
                type: "boolean"
              },
              CompanyCode: {},
              FleetStatus: {},
              Tags: {
                shape: "Sh"
              }
            }
          }
        },
        DescribeIdentityProviderConfiguration: {
          http: {
            requestUri: "/describeIdentityProviderConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityProviderType: {},
              ServiceProviderSamlMetadata: {},
              IdentityProviderSamlMetadata: {}
            }
          }
        },
        DescribeWebsiteCertificateAuthority: {
          http: {
            requestUri: "/describeWebsiteCertificateAuthority"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "WebsiteCaId"
            ],
            members: {
              FleetArn: {},
              WebsiteCaId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Certificate: {},
              CreatedTime: {
                type: "timestamp"
              },
              DisplayName: {}
            }
          }
        },
        DisassociateDomain: {
          http: {
            requestUri: "/disassociateDomain"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "DomainName"
            ],
            members: {
              FleetArn: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateWebsiteAuthorizationProvider: {
          http: {
            requestUri: "/disassociateWebsiteAuthorizationProvider"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "AuthorizationProviderId"
            ],
            members: {
              FleetArn: {},
              AuthorizationProviderId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateWebsiteCertificateAuthority: {
          http: {
            requestUri: "/disassociateWebsiteCertificateAuthority"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "WebsiteCaId"
            ],
            members: {
              FleetArn: {},
              WebsiteCaId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListDevices: {
          http: {
            requestUri: "/listDevices"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Devices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DeviceId: {},
                    DeviceStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDomains: {
          http: {
            requestUri: "/listDomains"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Domains: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DomainName",
                    "CreatedTime",
                    "DomainStatus"
                  ],
                  members: {
                    DomainName: {},
                    DisplayName: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    DomainStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListFleets: {
          http: {
            requestUri: "/listFleets"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FleetSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FleetArn: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    LastUpdatedTime: {
                      type: "timestamp"
                    },
                    FleetName: {},
                    DisplayName: {},
                    CompanyCode: {},
                    FleetStatus: {},
                    Tags: {
                      shape: "Sh"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sh"
              }
            }
          }
        },
        ListWebsiteAuthorizationProviders: {
          http: {
            requestUri: "/listWebsiteAuthorizationProviders"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WebsiteAuthorizationProviders: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AuthorizationProviderType"
                  ],
                  members: {
                    AuthorizationProviderId: {},
                    AuthorizationProviderType: {},
                    DomainName: {},
                    CreatedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListWebsiteCertificateAuthorities: {
          http: {
            requestUri: "/listWebsiteCertificateAuthorities"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WebsiteCertificateAuthorities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    WebsiteCaId: {},
                    CreatedTime: {
                      type: "timestamp"
                    },
                    DisplayName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        RestoreDomainAccess: {
          http: {
            requestUri: "/restoreDomainAccess"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "DomainName"
            ],
            members: {
              FleetArn: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RevokeDomainAccess: {
          http: {
            requestUri: "/revokeDomainAccess"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "DomainName"
            ],
            members: {
              FleetArn: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SignOutUser: {
          http: {
            requestUri: "/signOutUser"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "Username"
            ],
            members: {
              FleetArn: {},
              Username: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAuditStreamConfiguration: {
          http: {
            requestUri: "/updateAuditStreamConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {},
              AuditStreamArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateCompanyNetworkConfiguration: {
          http: {
            requestUri: "/updateCompanyNetworkConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "VpcId",
              "SubnetIds",
              "SecurityGroupIds"
            ],
            members: {
              FleetArn: {},
              VpcId: {},
              SubnetIds: {
                shape: "St"
              },
              SecurityGroupIds: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDevicePolicyConfiguration: {
          http: {
            requestUri: "/updateDevicePolicyConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {},
              DeviceCaCertificate: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDomainMetadata: {
          http: {
            requestUri: "/updateDomainMetadata"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "DomainName"
            ],
            members: {
              FleetArn: {},
              DomainName: {},
              DisplayName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateFleetMetadata: {
          http: {
            requestUri: "/UpdateFleetMetadata"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn"
            ],
            members: {
              FleetArn: {},
              DisplayName: {},
              OptimizeForEndUserLocation: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateIdentityProviderConfiguration: {
          http: {
            requestUri: "/updateIdentityProviderConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "FleetArn",
              "IdentityProviderType"
            ],
            members: {
              FleetArn: {},
              IdentityProviderType: {},
              IdentityProviderSamlMetadata: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sh: {
          type: "map",
          key: {},
          value: {}
        },
        St: {
          type: "list",
          member: {}
        },
        Sv: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/worklink-2018-09-25.paginators.json
var require_worklink_2018_09_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/worklink-2018-09-25.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListDevices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDomains: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListFleets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListWebsiteAuthorizationProviders: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListWebsiteCertificateAuthorities: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/worklink.js
var require_worklink = __commonJS({
  "node_modules/aws-sdk/clients/worklink.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["worklink"] = {};
    AWS3.WorkLink = Service.defineService("worklink", ["2018-09-25"]);
    Object.defineProperty(apiLoader.services["worklink"], "2018-09-25", {
      get: function get() {
        var model = require_worklink_2018_09_25_min();
        model.paginators = require_worklink_2018_09_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.WorkLink;
  }
});

// node_modules/aws-sdk/apis/textract-2018-06-27.min.json
var require_textract_2018_06_27_min = __commonJS({
  "node_modules/aws-sdk/apis/textract-2018-06-27.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-06-27",
        endpointPrefix: "textract",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Textract",
        serviceId: "Textract",
        signatureVersion: "v4",
        targetPrefix: "Textract",
        uid: "textract-2018-06-27"
      },
      operations: {
        AnalyzeDocument: {
          input: {
            type: "structure",
            required: [
              "Document",
              "FeatureTypes"
            ],
            members: {
              Document: {
                shape: "S2"
              },
              FeatureTypes: {
                shape: "S8"
              },
              HumanLoopConfig: {
                type: "structure",
                required: [
                  "HumanLoopName",
                  "FlowDefinitionArn"
                ],
                members: {
                  HumanLoopName: {},
                  FlowDefinitionArn: {},
                  DataAttributes: {
                    type: "structure",
                    members: {
                      ContentClassifiers: {
                        type: "list",
                        member: {}
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentMetadata: {
                shape: "Sh"
              },
              Blocks: {
                shape: "Sj"
              },
              HumanLoopActivationOutput: {
                type: "structure",
                members: {
                  HumanLoopArn: {},
                  HumanLoopActivationReasons: {
                    type: "list",
                    member: {}
                  },
                  HumanLoopActivationConditionsEvaluationResults: {
                    jsonvalue: true
                  }
                }
              },
              AnalyzeDocumentModelVersion: {}
            }
          }
        },
        AnalyzeExpense: {
          input: {
            type: "structure",
            required: [
              "Document"
            ],
            members: {
              Document: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentMetadata: {
                shape: "Sh"
              },
              ExpenseDocuments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ExpenseIndex: {
                      type: "integer"
                    },
                    SummaryFields: {
                      shape: "S1b"
                    },
                    LineItemGroups: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          LineItemGroupIndex: {
                            type: "integer"
                          },
                          LineItems: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                LineItemExpenseFields: {
                                  shape: "S1b"
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DetectDocumentText: {
          input: {
            type: "structure",
            required: [
              "Document"
            ],
            members: {
              Document: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentMetadata: {
                shape: "Sh"
              },
              Blocks: {
                shape: "Sj"
              },
              DetectDocumentTextModelVersion: {}
            }
          }
        },
        GetDocumentAnalysis: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentMetadata: {
                shape: "Sh"
              },
              JobStatus: {},
              NextToken: {},
              Blocks: {
                shape: "Sj"
              },
              Warnings: {
                shape: "S1r"
              },
              StatusMessage: {},
              AnalyzeDocumentModelVersion: {}
            }
          }
        },
        GetDocumentTextDetection: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DocumentMetadata: {
                shape: "Sh"
              },
              JobStatus: {},
              NextToken: {},
              Blocks: {
                shape: "Sj"
              },
              Warnings: {
                shape: "S1r"
              },
              StatusMessage: {},
              DetectDocumentTextModelVersion: {}
            }
          }
        },
        StartDocumentAnalysis: {
          input: {
            type: "structure",
            required: [
              "DocumentLocation",
              "FeatureTypes"
            ],
            members: {
              DocumentLocation: {
                shape: "S1z"
              },
              FeatureTypes: {
                shape: "S8"
              },
              ClientRequestToken: {},
              JobTag: {},
              NotificationChannel: {
                shape: "S22"
              },
              OutputConfig: {
                shape: "S25"
              },
              KMSKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        StartDocumentTextDetection: {
          input: {
            type: "structure",
            required: [
              "DocumentLocation"
            ],
            members: {
              DocumentLocation: {
                shape: "S1z"
              },
              ClientRequestToken: {},
              JobTag: {},
              NotificationChannel: {
                shape: "S22"
              },
              OutputConfig: {
                shape: "S25"
              },
              KMSKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          members: {
            Bytes: {
              type: "blob"
            },
            S3Object: {
              shape: "S4"
            }
          }
        },
        S4: {
          type: "structure",
          members: {
            Bucket: {},
            Name: {},
            Version: {}
          }
        },
        S8: {
          type: "list",
          member: {}
        },
        Sh: {
          type: "structure",
          members: {
            Pages: {
              type: "integer"
            }
          }
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            members: {
              BlockType: {},
              Confidence: {
                type: "float"
              },
              Text: {},
              TextType: {},
              RowIndex: {
                type: "integer"
              },
              ColumnIndex: {
                type: "integer"
              },
              RowSpan: {
                type: "integer"
              },
              ColumnSpan: {
                type: "integer"
              },
              Geometry: {
                shape: "Sp"
              },
              Id: {},
              Relationships: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    Ids: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              EntityTypes: {
                type: "list",
                member: {}
              },
              SelectionStatus: {},
              Page: {
                type: "integer"
              }
            }
          }
        },
        Sp: {
          type: "structure",
          members: {
            BoundingBox: {
              type: "structure",
              members: {
                Width: {
                  type: "float"
                },
                Height: {
                  type: "float"
                },
                Left: {
                  type: "float"
                },
                Top: {
                  type: "float"
                }
              }
            },
            Polygon: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  X: {
                    type: "float"
                  },
                  Y: {
                    type: "float"
                  }
                }
              }
            }
          }
        },
        S1b: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Type: {
                type: "structure",
                members: {
                  Text: {},
                  Confidence: {
                    type: "float"
                  }
                }
              },
              LabelDetection: {
                shape: "S1e"
              },
              ValueDetection: {
                shape: "S1e"
              },
              PageNumber: {
                type: "integer"
              }
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            Text: {},
            Geometry: {
              shape: "Sp"
            },
            Confidence: {
              type: "float"
            }
          }
        },
        S1r: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ErrorCode: {},
              Pages: {
                type: "list",
                member: {
                  type: "integer"
                }
              }
            }
          }
        },
        S1z: {
          type: "structure",
          members: {
            S3Object: {
              shape: "S4"
            }
          }
        },
        S22: {
          type: "structure",
          required: [
            "SNSTopicArn",
            "RoleArn"
          ],
          members: {
            SNSTopicArn: {},
            RoleArn: {}
          }
        },
        S25: {
          type: "structure",
          required: [
            "S3Bucket"
          ],
          members: {
            S3Bucket: {},
            S3Prefix: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/textract-2018-06-27.paginators.json
var require_textract_2018_06_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/textract-2018-06-27.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/textract.js
var require_textract = __commonJS({
  "node_modules/aws-sdk/clients/textract.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["textract"] = {};
    AWS3.Textract = Service.defineService("textract", ["2018-06-27"]);
    Object.defineProperty(apiLoader.services["textract"], "2018-06-27", {
      get: function get() {
        var model = require_textract_2018_06_27_min();
        model.paginators = require_textract_2018_06_27_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Textract;
  }
});

// node_modules/aws-sdk/apis/managedblockchain-2018-09-24.min.json
var require_managedblockchain_2018_09_24_min = __commonJS({
  "node_modules/aws-sdk/apis/managedblockchain-2018-09-24.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-09-24",
        endpointPrefix: "managedblockchain",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "ManagedBlockchain",
        serviceFullName: "Amazon Managed Blockchain",
        serviceId: "ManagedBlockchain",
        signatureVersion: "v4",
        signingName: "managedblockchain",
        uid: "managedblockchain-2018-09-24"
      },
      operations: {
        CreateMember: {
          http: {
            requestUri: "/networks/{networkId}/members"
          },
          input: {
            type: "structure",
            required: [
              "ClientRequestToken",
              "InvitationId",
              "NetworkId",
              "MemberConfiguration"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              InvitationId: {},
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MemberConfiguration: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MemberId: {}
            }
          }
        },
        CreateNetwork: {
          http: {
            requestUri: "/networks"
          },
          input: {
            type: "structure",
            required: [
              "ClientRequestToken",
              "Name",
              "Framework",
              "FrameworkVersion",
              "VotingPolicy",
              "MemberConfiguration"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              Name: {},
              Description: {},
              Framework: {},
              FrameworkVersion: {},
              FrameworkConfiguration: {
                type: "structure",
                members: {
                  Fabric: {
                    type: "structure",
                    required: [
                      "Edition"
                    ],
                    members: {
                      Edition: {}
                    }
                  }
                }
              },
              VotingPolicy: {
                shape: "Ss"
              },
              MemberConfiguration: {
                shape: "S4"
              },
              Tags: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NetworkId: {},
              MemberId: {}
            }
          }
        },
        CreateNode: {
          http: {
            requestUri: "/networks/{networkId}/nodes"
          },
          input: {
            type: "structure",
            required: [
              "ClientRequestToken",
              "NetworkId",
              "NodeConfiguration"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MemberId: {},
              NodeConfiguration: {
                type: "structure",
                required: [
                  "InstanceType"
                ],
                members: {
                  InstanceType: {},
                  AvailabilityZone: {},
                  LogPublishingConfiguration: {
                    shape: "S12"
                  },
                  StateDB: {}
                }
              },
              Tags: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NodeId: {}
            }
          }
        },
        CreateProposal: {
          http: {
            requestUri: "/networks/{networkId}/proposals"
          },
          input: {
            type: "structure",
            required: [
              "ClientRequestToken",
              "NetworkId",
              "MemberId",
              "Actions"
            ],
            members: {
              ClientRequestToken: {
                idempotencyToken: true
              },
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MemberId: {},
              Actions: {
                shape: "S17"
              },
              Description: {},
              Tags: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProposalId: {}
            }
          }
        },
        DeleteMember: {
          http: {
            method: "DELETE",
            requestUri: "/networks/{networkId}/members/{memberId}"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId",
              "MemberId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MemberId: {
                location: "uri",
                locationName: "memberId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteNode: {
          http: {
            method: "DELETE",
            requestUri: "/networks/{networkId}/nodes/{nodeId}"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId",
              "NodeId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MemberId: {
                location: "querystring",
                locationName: "memberId"
              },
              NodeId: {
                location: "uri",
                locationName: "nodeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetMember: {
          http: {
            method: "GET",
            requestUri: "/networks/{networkId}/members/{memberId}"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId",
              "MemberId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MemberId: {
                location: "uri",
                locationName: "memberId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Member: {
                type: "structure",
                members: {
                  NetworkId: {},
                  Id: {},
                  Name: {},
                  Description: {},
                  FrameworkAttributes: {
                    type: "structure",
                    members: {
                      Fabric: {
                        type: "structure",
                        members: {
                          AdminUsername: {},
                          CaEndpoint: {}
                        }
                      }
                    }
                  },
                  LogPublishingConfiguration: {
                    shape: "Sb"
                  },
                  Status: {},
                  CreationDate: {
                    shape: "S1p"
                  },
                  Tags: {
                    shape: "S1q"
                  },
                  Arn: {},
                  KmsKeyArn: {}
                }
              }
            }
          }
        },
        GetNetwork: {
          http: {
            method: "GET",
            requestUri: "/networks/{networkId}"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Network: {
                type: "structure",
                members: {
                  Id: {},
                  Name: {},
                  Description: {},
                  Framework: {},
                  FrameworkVersion: {},
                  FrameworkAttributes: {
                    type: "structure",
                    members: {
                      Fabric: {
                        type: "structure",
                        members: {
                          OrderingServiceEndpoint: {},
                          Edition: {}
                        }
                      },
                      Ethereum: {
                        type: "structure",
                        members: {
                          ChainId: {}
                        }
                      }
                    }
                  },
                  VpcEndpointServiceName: {},
                  VotingPolicy: {
                    shape: "Ss"
                  },
                  Status: {},
                  CreationDate: {
                    shape: "S1p"
                  },
                  Tags: {
                    shape: "S1q"
                  },
                  Arn: {}
                }
              }
            }
          }
        },
        GetNode: {
          http: {
            method: "GET",
            requestUri: "/networks/{networkId}/nodes/{nodeId}"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId",
              "NodeId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MemberId: {
                location: "querystring",
                locationName: "memberId"
              },
              NodeId: {
                location: "uri",
                locationName: "nodeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Node: {
                type: "structure",
                members: {
                  NetworkId: {},
                  MemberId: {},
                  Id: {},
                  InstanceType: {},
                  AvailabilityZone: {},
                  FrameworkAttributes: {
                    type: "structure",
                    members: {
                      Fabric: {
                        type: "structure",
                        members: {
                          PeerEndpoint: {},
                          PeerEventEndpoint: {}
                        }
                      },
                      Ethereum: {
                        type: "structure",
                        members: {
                          HttpEndpoint: {},
                          WebSocketEndpoint: {}
                        }
                      }
                    }
                  },
                  LogPublishingConfiguration: {
                    shape: "S12"
                  },
                  StateDB: {},
                  Status: {},
                  CreationDate: {
                    shape: "S1p"
                  },
                  Tags: {
                    shape: "S1q"
                  },
                  Arn: {},
                  KmsKeyArn: {}
                }
              }
            }
          }
        },
        GetProposal: {
          http: {
            method: "GET",
            requestUri: "/networks/{networkId}/proposals/{proposalId}"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId",
              "ProposalId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              ProposalId: {
                location: "uri",
                locationName: "proposalId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Proposal: {
                type: "structure",
                members: {
                  ProposalId: {},
                  NetworkId: {},
                  Description: {},
                  Actions: {
                    shape: "S17"
                  },
                  ProposedByMemberId: {},
                  ProposedByMemberName: {},
                  Status: {},
                  CreationDate: {
                    shape: "S1p"
                  },
                  ExpirationDate: {
                    shape: "S1p"
                  },
                  YesVoteCount: {
                    type: "integer"
                  },
                  NoVoteCount: {
                    type: "integer"
                  },
                  OutstandingVoteCount: {
                    type: "integer"
                  },
                  Tags: {
                    shape: "S1q"
                  },
                  Arn: {}
                }
              }
            }
          }
        },
        ListInvitations: {
          http: {
            method: "GET",
            requestUri: "/invitations"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invitations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InvitationId: {},
                    CreationDate: {
                      shape: "S1p"
                    },
                    ExpirationDate: {
                      shape: "S1p"
                    },
                    Status: {},
                    NetworkSummary: {
                      shape: "S2h"
                    },
                    Arn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListMembers: {
          http: {
            method: "GET",
            requestUri: "/networks/{networkId}/members"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              Name: {
                location: "querystring",
                locationName: "name"
              },
              Status: {
                location: "querystring",
                locationName: "status"
              },
              IsOwned: {
                location: "querystring",
                locationName: "isOwned",
                type: "boolean"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Members: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Description: {},
                    Status: {},
                    CreationDate: {
                      shape: "S1p"
                    },
                    IsOwned: {
                      type: "boolean"
                    },
                    Arn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListNetworks: {
          http: {
            method: "GET",
            requestUri: "/networks"
          },
          input: {
            type: "structure",
            members: {
              Name: {
                location: "querystring",
                locationName: "name"
              },
              Framework: {
                location: "querystring",
                locationName: "framework"
              },
              Status: {
                location: "querystring",
                locationName: "status"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Networks: {
                type: "list",
                member: {
                  shape: "S2h"
                }
              },
              NextToken: {}
            }
          }
        },
        ListNodes: {
          http: {
            method: "GET",
            requestUri: "/networks/{networkId}/nodes"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MemberId: {
                location: "querystring",
                locationName: "memberId"
              },
              Status: {
                location: "querystring",
                locationName: "status"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Nodes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Status: {},
                    CreationDate: {
                      shape: "S1p"
                    },
                    AvailabilityZone: {},
                    InstanceType: {},
                    Arn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProposalVotes: {
          http: {
            method: "GET",
            requestUri: "/networks/{networkId}/proposals/{proposalId}/votes"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId",
              "ProposalId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              ProposalId: {
                location: "uri",
                locationName: "proposalId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProposalVotes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Vote: {},
                    MemberName: {},
                    MemberId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProposals: {
          http: {
            method: "GET",
            requestUri: "/networks/{networkId}/proposals"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Proposals: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProposalId: {},
                    Description: {},
                    ProposedByMemberId: {},
                    ProposedByMemberName: {},
                    Status: {},
                    CreationDate: {
                      shape: "S1p"
                    },
                    ExpirationDate: {
                      shape: "S1p"
                    },
                    Arn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S1q"
              }
            }
          }
        },
        RejectInvitation: {
          http: {
            method: "DELETE",
            requestUri: "/invitations/{invitationId}"
          },
          input: {
            type: "structure",
            required: [
              "InvitationId"
            ],
            members: {
              InvitationId: {
                location: "uri",
                locationName: "invitationId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateMember: {
          http: {
            method: "PATCH",
            requestUri: "/networks/{networkId}/members/{memberId}"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId",
              "MemberId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MemberId: {
                location: "uri",
                locationName: "memberId"
              },
              LogPublishingConfiguration: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateNode: {
          http: {
            method: "PATCH",
            requestUri: "/networks/{networkId}/nodes/{nodeId}"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId",
              "NodeId"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              MemberId: {},
              NodeId: {
                location: "uri",
                locationName: "nodeId"
              },
              LogPublishingConfiguration: {
                shape: "S12"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        VoteOnProposal: {
          http: {
            requestUri: "/networks/{networkId}/proposals/{proposalId}/votes"
          },
          input: {
            type: "structure",
            required: [
              "NetworkId",
              "ProposalId",
              "VoterMemberId",
              "Vote"
            ],
            members: {
              NetworkId: {
                location: "uri",
                locationName: "networkId"
              },
              ProposalId: {
                location: "uri",
                locationName: "proposalId"
              },
              VoterMemberId: {},
              Vote: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "Name",
            "FrameworkConfiguration"
          ],
          members: {
            Name: {},
            Description: {},
            FrameworkConfiguration: {
              type: "structure",
              members: {
                Fabric: {
                  type: "structure",
                  required: [
                    "AdminUsername",
                    "AdminPassword"
                  ],
                  members: {
                    AdminUsername: {},
                    AdminPassword: {
                      type: "string",
                      sensitive: true
                    }
                  }
                }
              }
            },
            LogPublishingConfiguration: {
              shape: "Sb"
            },
            Tags: {
              shape: "Sg"
            },
            KmsKeyArn: {}
          }
        },
        Sb: {
          type: "structure",
          members: {
            Fabric: {
              type: "structure",
              members: {
                CaLogs: {
                  shape: "Sd"
                }
              }
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            Cloudwatch: {
              type: "structure",
              members: {
                Enabled: {
                  type: "boolean"
                }
              }
            }
          }
        },
        Sg: {
          type: "map",
          key: {},
          value: {}
        },
        Ss: {
          type: "structure",
          members: {
            ApprovalThresholdPolicy: {
              type: "structure",
              members: {
                ThresholdPercentage: {
                  type: "integer"
                },
                ProposalDurationInHours: {
                  type: "integer"
                },
                ThresholdComparator: {}
              }
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            Fabric: {
              type: "structure",
              members: {
                ChaincodeLogs: {
                  shape: "Sd"
                },
                PeerLogs: {
                  shape: "Sd"
                }
              }
            }
          }
        },
        S17: {
          type: "structure",
          members: {
            Invitations: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Principal"
                ],
                members: {
                  Principal: {}
                }
              }
            },
            Removals: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "MemberId"
                ],
                members: {
                  MemberId: {}
                }
              }
            }
          }
        },
        S1p: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S1q: {
          type: "map",
          key: {},
          value: {}
        },
        S2h: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            Description: {},
            Framework: {},
            FrameworkVersion: {},
            Status: {},
            CreationDate: {
              shape: "S1p"
            },
            Arn: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/managedblockchain-2018-09-24.paginators.json
var require_managedblockchain_2018_09_24_paginators = __commonJS({
  "node_modules/aws-sdk/apis/managedblockchain-2018-09-24.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListInvitations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMembers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListNetworks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListNodes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListProposalVotes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListProposals: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/managedblockchain.js
var require_managedblockchain = __commonJS({
  "node_modules/aws-sdk/clients/managedblockchain.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["managedblockchain"] = {};
    AWS3.ManagedBlockchain = Service.defineService("managedblockchain", ["2018-09-24"]);
    Object.defineProperty(apiLoader.services["managedblockchain"], "2018-09-24", {
      get: function get() {
        var model = require_managedblockchain_2018_09_24_min();
        model.paginators = require_managedblockchain_2018_09_24_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ManagedBlockchain;
  }
});

// node_modules/aws-sdk/apis/mediapackage-vod-2018-11-07.min.json
var require_mediapackage_vod_2018_11_07_min = __commonJS({
  "node_modules/aws-sdk/apis/mediapackage-vod-2018-11-07.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2018-11-07",
        endpointPrefix: "mediapackage-vod",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "MediaPackage Vod",
        serviceFullName: "AWS Elemental MediaPackage VOD",
        serviceId: "MediaPackage Vod",
        signatureVersion: "v4",
        signingName: "mediapackage-vod",
        uid: "mediapackage-vod-2018-11-07"
      },
      operations: {
        ConfigureLogs: {
          http: {
            method: "PUT",
            requestUri: "/packaging_groups/{id}/configure_logs",
            responseCode: 200
          },
          input: {
            members: {
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              Authorization: {
                locationName: "authorization",
                shape: "S5"
              },
              DomainName: {
                locationName: "domainName"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              Id: {
                locationName: "id"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            type: "structure"
          }
        },
        CreateAsset: {
          http: {
            requestUri: "/assets",
            responseCode: 200
          },
          input: {
            members: {
              Id: {
                locationName: "id"
              },
              PackagingGroupId: {
                locationName: "packagingGroupId"
              },
              ResourceId: {
                locationName: "resourceId"
              },
              SourceArn: {
                locationName: "sourceArn"
              },
              SourceRoleArn: {
                locationName: "sourceRoleArn"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            required: [
              "SourceArn",
              "Id",
              "PackagingGroupId",
              "SourceRoleArn"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              EgressEndpoints: {
                locationName: "egressEndpoints",
                shape: "S9"
              },
              Id: {
                locationName: "id"
              },
              PackagingGroupId: {
                locationName: "packagingGroupId"
              },
              ResourceId: {
                locationName: "resourceId"
              },
              SourceArn: {
                locationName: "sourceArn"
              },
              SourceRoleArn: {
                locationName: "sourceRoleArn"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            type: "structure"
          }
        },
        CreatePackagingConfiguration: {
          http: {
            requestUri: "/packaging_configurations",
            responseCode: 200
          },
          input: {
            members: {
              CmafPackage: {
                locationName: "cmafPackage",
                shape: "Sc"
              },
              DashPackage: {
                locationName: "dashPackage",
                shape: "Sn"
              },
              HlsPackage: {
                locationName: "hlsPackage",
                shape: "Sw"
              },
              Id: {
                locationName: "id"
              },
              MssPackage: {
                locationName: "mssPackage",
                shape: "Sz"
              },
              PackagingGroupId: {
                locationName: "packagingGroupId"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            required: [
              "Id",
              "PackagingGroupId"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              CmafPackage: {
                locationName: "cmafPackage",
                shape: "Sc"
              },
              DashPackage: {
                locationName: "dashPackage",
                shape: "Sn"
              },
              HlsPackage: {
                locationName: "hlsPackage",
                shape: "Sw"
              },
              Id: {
                locationName: "id"
              },
              MssPackage: {
                locationName: "mssPackage",
                shape: "Sz"
              },
              PackagingGroupId: {
                locationName: "packagingGroupId"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            type: "structure"
          }
        },
        CreatePackagingGroup: {
          http: {
            requestUri: "/packaging_groups",
            responseCode: 200
          },
          input: {
            members: {
              Authorization: {
                locationName: "authorization",
                shape: "S5"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              Id: {
                locationName: "id"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              Authorization: {
                locationName: "authorization",
                shape: "S5"
              },
              DomainName: {
                locationName: "domainName"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              Id: {
                locationName: "id"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            type: "structure"
          }
        },
        DeleteAsset: {
          http: {
            method: "DELETE",
            requestUri: "/assets/{id}",
            responseCode: 202
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {},
            type: "structure"
          }
        },
        DeletePackagingConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/packaging_configurations/{id}",
            responseCode: 202
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {},
            type: "structure"
          }
        },
        DeletePackagingGroup: {
          http: {
            method: "DELETE",
            requestUri: "/packaging_groups/{id}",
            responseCode: 202
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {},
            type: "structure"
          }
        },
        DescribeAsset: {
          http: {
            method: "GET",
            requestUri: "/assets/{id}",
            responseCode: 200
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              CreatedAt: {
                locationName: "createdAt"
              },
              EgressEndpoints: {
                locationName: "egressEndpoints",
                shape: "S9"
              },
              Id: {
                locationName: "id"
              },
              PackagingGroupId: {
                locationName: "packagingGroupId"
              },
              ResourceId: {
                locationName: "resourceId"
              },
              SourceArn: {
                locationName: "sourceArn"
              },
              SourceRoleArn: {
                locationName: "sourceRoleArn"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            type: "structure"
          }
        },
        DescribePackagingConfiguration: {
          http: {
            method: "GET",
            requestUri: "/packaging_configurations/{id}",
            responseCode: 200
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              CmafPackage: {
                locationName: "cmafPackage",
                shape: "Sc"
              },
              DashPackage: {
                locationName: "dashPackage",
                shape: "Sn"
              },
              HlsPackage: {
                locationName: "hlsPackage",
                shape: "Sw"
              },
              Id: {
                locationName: "id"
              },
              MssPackage: {
                locationName: "mssPackage",
                shape: "Sz"
              },
              PackagingGroupId: {
                locationName: "packagingGroupId"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            type: "structure"
          }
        },
        DescribePackagingGroup: {
          http: {
            method: "GET",
            requestUri: "/packaging_groups/{id}",
            responseCode: 200
          },
          input: {
            members: {
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              Authorization: {
                locationName: "authorization",
                shape: "S5"
              },
              DomainName: {
                locationName: "domainName"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              Id: {
                locationName: "id"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            type: "structure"
          }
        },
        ListAssets: {
          http: {
            method: "GET",
            requestUri: "/assets",
            responseCode: 200
          },
          input: {
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              PackagingGroupId: {
                location: "querystring",
                locationName: "packagingGroupId"
              }
            },
            type: "structure"
          },
          output: {
            members: {
              Assets: {
                locationName: "assets",
                member: {
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    CreatedAt: {
                      locationName: "createdAt"
                    },
                    Id: {
                      locationName: "id"
                    },
                    PackagingGroupId: {
                      locationName: "packagingGroupId"
                    },
                    ResourceId: {
                      locationName: "resourceId"
                    },
                    SourceArn: {
                      locationName: "sourceArn"
                    },
                    SourceRoleArn: {
                      locationName: "sourceRoleArn"
                    },
                    Tags: {
                      locationName: "tags",
                      shape: "S6"
                    }
                  },
                  type: "structure"
                },
                type: "list"
              },
              NextToken: {
                locationName: "nextToken"
              }
            },
            type: "structure"
          }
        },
        ListPackagingConfigurations: {
          http: {
            method: "GET",
            requestUri: "/packaging_configurations",
            responseCode: 200
          },
          input: {
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              PackagingGroupId: {
                location: "querystring",
                locationName: "packagingGroupId"
              }
            },
            type: "structure"
          },
          output: {
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              PackagingConfigurations: {
                locationName: "packagingConfigurations",
                member: {
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    CmafPackage: {
                      locationName: "cmafPackage",
                      shape: "Sc"
                    },
                    DashPackage: {
                      locationName: "dashPackage",
                      shape: "Sn"
                    },
                    HlsPackage: {
                      locationName: "hlsPackage",
                      shape: "Sw"
                    },
                    Id: {
                      locationName: "id"
                    },
                    MssPackage: {
                      locationName: "mssPackage",
                      shape: "Sz"
                    },
                    PackagingGroupId: {
                      locationName: "packagingGroupId"
                    },
                    Tags: {
                      locationName: "tags",
                      shape: "S6"
                    }
                  },
                  type: "structure"
                },
                type: "list"
              }
            },
            type: "structure"
          }
        },
        ListPackagingGroups: {
          http: {
            method: "GET",
            requestUri: "/packaging_groups",
            responseCode: 200
          },
          input: {
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            type: "structure"
          },
          output: {
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              PackagingGroups: {
                locationName: "packagingGroups",
                member: {
                  members: {
                    Arn: {
                      locationName: "arn"
                    },
                    Authorization: {
                      locationName: "authorization",
                      shape: "S5"
                    },
                    DomainName: {
                      locationName: "domainName"
                    },
                    EgressAccessLogs: {
                      locationName: "egressAccessLogs",
                      shape: "S2"
                    },
                    Id: {
                      locationName: "id"
                    },
                    Tags: {
                      locationName: "tags",
                      shape: "S6"
                    }
                  },
                  type: "structure"
                },
                type: "list"
              }
            },
            type: "structure"
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ],
            type: "structure"
          },
          output: {
            members: {
              Tags: {
                locationName: "tags",
                shape: "S1x"
              }
            },
            type: "structure"
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              Tags: {
                locationName: "tags",
                shape: "S1x"
              }
            },
            required: [
              "ResourceArn",
              "Tags"
            ],
            type: "structure"
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                shape: "Sf"
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ],
            type: "structure"
          }
        },
        UpdatePackagingGroup: {
          http: {
            method: "PUT",
            requestUri: "/packaging_groups/{id}",
            responseCode: 200
          },
          input: {
            members: {
              Authorization: {
                locationName: "authorization",
                shape: "S5"
              },
              Id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "Id"
            ],
            type: "structure"
          },
          output: {
            members: {
              Arn: {
                locationName: "arn"
              },
              Authorization: {
                locationName: "authorization",
                shape: "S5"
              },
              DomainName: {
                locationName: "domainName"
              },
              EgressAccessLogs: {
                locationName: "egressAccessLogs",
                shape: "S2"
              },
              Id: {
                locationName: "id"
              },
              Tags: {
                locationName: "tags",
                shape: "S6"
              }
            },
            type: "structure"
          }
        }
      },
      shapes: {
        S2: {
          members: {
            LogGroupName: {
              locationName: "logGroupName"
            }
          },
          type: "structure"
        },
        S5: {
          members: {
            CdnIdentifierSecret: {
              locationName: "cdnIdentifierSecret"
            },
            SecretsRoleArn: {
              locationName: "secretsRoleArn"
            }
          },
          required: [
            "SecretsRoleArn",
            "CdnIdentifierSecret"
          ],
          type: "structure"
        },
        S6: {
          key: {},
          type: "map",
          value: {}
        },
        S9: {
          member: {
            members: {
              PackagingConfigurationId: {
                locationName: "packagingConfigurationId"
              },
              Status: {
                locationName: "status"
              },
              Url: {
                locationName: "url"
              }
            },
            type: "structure"
          },
          type: "list"
        },
        Sc: {
          members: {
            Encryption: {
              locationName: "encryption",
              members: {
                ConstantInitializationVector: {
                  locationName: "constantInitializationVector"
                },
                SpekeKeyProvider: {
                  locationName: "spekeKeyProvider",
                  shape: "Se"
                }
              },
              required: [
                "SpekeKeyProvider"
              ],
              type: "structure"
            },
            HlsManifests: {
              locationName: "hlsManifests",
              shape: "Sg"
            },
            IncludeEncoderConfigurationInSegments: {
              locationName: "includeEncoderConfigurationInSegments",
              type: "boolean"
            },
            SegmentDurationSeconds: {
              locationName: "segmentDurationSeconds",
              type: "integer"
            }
          },
          required: [
            "HlsManifests"
          ],
          type: "structure"
        },
        Se: {
          members: {
            RoleArn: {
              locationName: "roleArn"
            },
            SystemIds: {
              locationName: "systemIds",
              shape: "Sf"
            },
            Url: {
              locationName: "url"
            }
          },
          required: [
            "SystemIds",
            "Url",
            "RoleArn"
          ],
          type: "structure"
        },
        Sf: {
          member: {},
          type: "list"
        },
        Sg: {
          member: {
            members: {
              AdMarkers: {
                locationName: "adMarkers"
              },
              IncludeIframeOnlyStream: {
                locationName: "includeIframeOnlyStream",
                type: "boolean"
              },
              ManifestName: {
                locationName: "manifestName"
              },
              ProgramDateTimeIntervalSeconds: {
                locationName: "programDateTimeIntervalSeconds",
                type: "integer"
              },
              RepeatExtXKey: {
                locationName: "repeatExtXKey",
                type: "boolean"
              },
              StreamSelection: {
                locationName: "streamSelection",
                shape: "Sl"
              }
            },
            type: "structure"
          },
          type: "list"
        },
        Sl: {
          members: {
            MaxVideoBitsPerSecond: {
              locationName: "maxVideoBitsPerSecond",
              type: "integer"
            },
            MinVideoBitsPerSecond: {
              locationName: "minVideoBitsPerSecond",
              type: "integer"
            },
            StreamOrder: {
              locationName: "streamOrder"
            }
          },
          type: "structure"
        },
        Sn: {
          members: {
            DashManifests: {
              locationName: "dashManifests",
              member: {
                members: {
                  ManifestLayout: {
                    locationName: "manifestLayout"
                  },
                  ManifestName: {
                    locationName: "manifestName"
                  },
                  MinBufferTimeSeconds: {
                    locationName: "minBufferTimeSeconds",
                    type: "integer"
                  },
                  Profile: {
                    locationName: "profile"
                  },
                  StreamSelection: {
                    locationName: "streamSelection",
                    shape: "Sl"
                  }
                },
                type: "structure"
              },
              type: "list"
            },
            Encryption: {
              locationName: "encryption",
              members: {
                SpekeKeyProvider: {
                  locationName: "spekeKeyProvider",
                  shape: "Se"
                }
              },
              required: [
                "SpekeKeyProvider"
              ],
              type: "structure"
            },
            IncludeEncoderConfigurationInSegments: {
              locationName: "includeEncoderConfigurationInSegments",
              type: "boolean"
            },
            PeriodTriggers: {
              locationName: "periodTriggers",
              member: {},
              type: "list"
            },
            SegmentDurationSeconds: {
              locationName: "segmentDurationSeconds",
              type: "integer"
            },
            SegmentTemplateFormat: {
              locationName: "segmentTemplateFormat"
            }
          },
          required: [
            "DashManifests"
          ],
          type: "structure"
        },
        Sw: {
          members: {
            Encryption: {
              locationName: "encryption",
              members: {
                ConstantInitializationVector: {
                  locationName: "constantInitializationVector"
                },
                EncryptionMethod: {
                  locationName: "encryptionMethod"
                },
                SpekeKeyProvider: {
                  locationName: "spekeKeyProvider",
                  shape: "Se"
                }
              },
              required: [
                "SpekeKeyProvider"
              ],
              type: "structure"
            },
            HlsManifests: {
              locationName: "hlsManifests",
              shape: "Sg"
            },
            SegmentDurationSeconds: {
              locationName: "segmentDurationSeconds",
              type: "integer"
            },
            UseAudioRenditionGroup: {
              locationName: "useAudioRenditionGroup",
              type: "boolean"
            }
          },
          required: [
            "HlsManifests"
          ],
          type: "structure"
        },
        Sz: {
          members: {
            Encryption: {
              locationName: "encryption",
              members: {
                SpekeKeyProvider: {
                  locationName: "spekeKeyProvider",
                  shape: "Se"
                }
              },
              required: [
                "SpekeKeyProvider"
              ],
              type: "structure"
            },
            MssManifests: {
              locationName: "mssManifests",
              member: {
                members: {
                  ManifestName: {
                    locationName: "manifestName"
                  },
                  StreamSelection: {
                    locationName: "streamSelection",
                    shape: "Sl"
                  }
                },
                type: "structure"
              },
              type: "list"
            },
            SegmentDurationSeconds: {
              locationName: "segmentDurationSeconds",
              type: "integer"
            }
          },
          required: [
            "MssManifests"
          ],
          type: "structure"
        },
        S1x: {
          key: {},
          type: "map",
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mediapackage-vod-2018-11-07.paginators.json
var require_mediapackage_vod_2018_11_07_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mediapackage-vod-2018-11-07.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAssets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Assets"
        },
        ListPackagingConfigurations: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PackagingConfigurations"
        },
        ListPackagingGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PackagingGroups"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mediapackagevod.js
var require_mediapackagevod = __commonJS({
  "node_modules/aws-sdk/clients/mediapackagevod.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["mediapackagevod"] = {};
    AWS3.MediaPackageVod = Service.defineService("mediapackagevod", ["2018-11-07"]);
    Object.defineProperty(apiLoader.services["mediapackagevod"], "2018-11-07", {
      get: function get() {
        var model = require_mediapackage_vod_2018_11_07_min();
        model.paginators = require_mediapackage_vod_2018_11_07_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.MediaPackageVod;
  }
});

// node_modules/aws-sdk/apis/groundstation-2019-05-23.min.json
var require_groundstation_2019_05_23_min = __commonJS({
  "node_modules/aws-sdk/apis/groundstation-2019-05-23.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-05-23",
        endpointPrefix: "groundstation",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Ground Station",
        serviceId: "GroundStation",
        signatureVersion: "v4",
        signingName: "groundstation",
        uid: "groundstation-2019-05-23"
      },
      operations: {
        CancelContact: {
          http: {
            method: "DELETE",
            requestUri: "/contact/{contactId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contactId"
            ],
            members: {
              contactId: {
                location: "uri",
                locationName: "contactId"
              }
            }
          },
          output: {
            shape: "S3"
          },
          idempotent: true
        },
        CreateConfig: {
          http: {
            requestUri: "/config",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configData",
              "name"
            ],
            members: {
              configData: {
                shape: "S5"
              },
              name: {},
              tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            shape: "Sy"
          }
        },
        CreateDataflowEndpointGroup: {
          http: {
            requestUri: "/dataflowEndpointGroup",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "endpointDetails"
            ],
            members: {
              endpointDetails: {
                shape: "S11"
              },
              tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            shape: "S1b"
          }
        },
        CreateMissionProfile: {
          http: {
            requestUri: "/missionprofile",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "dataflowEdges",
              "minimumViableContactDurationSeconds",
              "name",
              "trackingConfigArn"
            ],
            members: {
              contactPostPassDurationSeconds: {
                type: "integer"
              },
              contactPrePassDurationSeconds: {
                type: "integer"
              },
              dataflowEdges: {
                shape: "S1e"
              },
              minimumViableContactDurationSeconds: {
                type: "integer"
              },
              name: {},
              tags: {
                shape: "Sx"
              },
              trackingConfigArn: {}
            }
          },
          output: {
            shape: "S1g"
          }
        },
        DeleteConfig: {
          http: {
            method: "DELETE",
            requestUri: "/config/{configType}/{configId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configId",
              "configType"
            ],
            members: {
              configId: {
                location: "uri",
                locationName: "configId"
              },
              configType: {
                location: "uri",
                locationName: "configType"
              }
            }
          },
          output: {
            shape: "Sy"
          },
          idempotent: true
        },
        DeleteDataflowEndpointGroup: {
          http: {
            method: "DELETE",
            requestUri: "/dataflowEndpointGroup/{dataflowEndpointGroupId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "dataflowEndpointGroupId"
            ],
            members: {
              dataflowEndpointGroupId: {
                location: "uri",
                locationName: "dataflowEndpointGroupId"
              }
            }
          },
          output: {
            shape: "S1b"
          },
          idempotent: true
        },
        DeleteMissionProfile: {
          http: {
            method: "DELETE",
            requestUri: "/missionprofile/{missionProfileId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "missionProfileId"
            ],
            members: {
              missionProfileId: {
                location: "uri",
                locationName: "missionProfileId"
              }
            }
          },
          output: {
            shape: "S1g"
          },
          idempotent: true
        },
        DescribeContact: {
          http: {
            method: "GET",
            requestUri: "/contact/{contactId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contactId"
            ],
            members: {
              contactId: {
                location: "uri",
                locationName: "contactId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contactId: {},
              contactStatus: {},
              dataflowList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    destination: {
                      type: "structure",
                      members: {
                        configDetails: {
                          shape: "S1q"
                        },
                        configId: {},
                        configType: {},
                        dataflowDestinationRegion: {}
                      }
                    },
                    errorMessage: {},
                    source: {
                      type: "structure",
                      members: {
                        configDetails: {
                          shape: "S1q"
                        },
                        configId: {},
                        configType: {},
                        dataflowSourceRegion: {}
                      }
                    }
                  }
                }
              },
              endTime: {
                type: "timestamp"
              },
              errorMessage: {},
              groundStation: {},
              maximumElevation: {
                shape: "S1v"
              },
              missionProfileArn: {},
              postPassEndTime: {
                type: "timestamp"
              },
              prePassStartTime: {
                type: "timestamp"
              },
              region: {},
              satelliteArn: {},
              startTime: {
                type: "timestamp"
              },
              tags: {
                shape: "Sx"
              }
            }
          }
        },
        GetConfig: {
          http: {
            method: "GET",
            requestUri: "/config/{configType}/{configId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configId",
              "configType"
            ],
            members: {
              configId: {
                location: "uri",
                locationName: "configId"
              },
              configType: {
                location: "uri",
                locationName: "configType"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "configArn",
              "configData",
              "configId",
              "name"
            ],
            members: {
              configArn: {},
              configData: {
                shape: "S5"
              },
              configId: {},
              configType: {},
              name: {},
              tags: {
                shape: "Sx"
              }
            }
          }
        },
        GetDataflowEndpointGroup: {
          http: {
            method: "GET",
            requestUri: "/dataflowEndpointGroup/{dataflowEndpointGroupId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "dataflowEndpointGroupId"
            ],
            members: {
              dataflowEndpointGroupId: {
                location: "uri",
                locationName: "dataflowEndpointGroupId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataflowEndpointGroupArn: {},
              dataflowEndpointGroupId: {},
              endpointsDetails: {
                shape: "S11"
              },
              tags: {
                shape: "Sx"
              }
            }
          }
        },
        GetMinuteUsage: {
          http: {
            requestUri: "/minute-usage",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "month",
              "year"
            ],
            members: {
              month: {
                type: "integer"
              },
              year: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              estimatedMinutesRemaining: {
                type: "integer"
              },
              isReservedMinutesCustomer: {
                type: "boolean"
              },
              totalReservedMinuteAllocation: {
                type: "integer"
              },
              totalScheduledMinutes: {
                type: "integer"
              },
              upcomingMinutesScheduled: {
                type: "integer"
              }
            }
          }
        },
        GetMissionProfile: {
          http: {
            method: "GET",
            requestUri: "/missionprofile/{missionProfileId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "missionProfileId"
            ],
            members: {
              missionProfileId: {
                location: "uri",
                locationName: "missionProfileId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contactPostPassDurationSeconds: {
                type: "integer"
              },
              contactPrePassDurationSeconds: {
                type: "integer"
              },
              dataflowEdges: {
                shape: "S1e"
              },
              minimumViableContactDurationSeconds: {
                type: "integer"
              },
              missionProfileArn: {},
              missionProfileId: {},
              name: {},
              region: {},
              tags: {
                shape: "Sx"
              },
              trackingConfigArn: {}
            }
          }
        },
        GetSatellite: {
          http: {
            method: "GET",
            requestUri: "/satellite/{satelliteId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "satelliteId"
            ],
            members: {
              satelliteId: {
                location: "uri",
                locationName: "satelliteId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              groundStations: {
                shape: "S2a"
              },
              noradSatelliteID: {
                type: "integer"
              },
              satelliteArn: {},
              satelliteId: {}
            }
          }
        },
        ListConfigs: {
          http: {
            method: "GET",
            requestUri: "/config",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              configList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    configArn: {},
                    configId: {},
                    configType: {},
                    name: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListContacts: {
          http: {
            requestUri: "/contacts",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "endTime",
              "startTime",
              "statusList"
            ],
            members: {
              endTime: {
                type: "timestamp"
              },
              groundStation: {},
              maxResults: {
                type: "integer"
              },
              missionProfileArn: {},
              nextToken: {},
              satelliteArn: {},
              startTime: {
                type: "timestamp"
              },
              statusList: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contactList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    contactId: {},
                    contactStatus: {},
                    endTime: {
                      type: "timestamp"
                    },
                    errorMessage: {},
                    groundStation: {},
                    maximumElevation: {
                      shape: "S1v"
                    },
                    missionProfileArn: {},
                    postPassEndTime: {
                      type: "timestamp"
                    },
                    prePassStartTime: {
                      type: "timestamp"
                    },
                    region: {},
                    satelliteArn: {},
                    startTime: {
                      type: "timestamp"
                    },
                    tags: {
                      shape: "Sx"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDataflowEndpointGroups: {
          http: {
            method: "GET",
            requestUri: "/dataflowEndpointGroup",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              dataflowEndpointGroupList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    dataflowEndpointGroupArn: {},
                    dataflowEndpointGroupId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListGroundStations: {
          http: {
            method: "GET",
            requestUri: "/groundstation",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              satelliteId: {
                location: "querystring",
                locationName: "satelliteId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              groundStationList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    groundStationId: {},
                    groundStationName: {},
                    region: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListMissionProfiles: {
          http: {
            method: "GET",
            requestUri: "/missionprofile",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              missionProfileList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    missionProfileArn: {},
                    missionProfileId: {},
                    name: {},
                    region: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSatellites: {
          http: {
            method: "GET",
            requestUri: "/satellite",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              satellites: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    groundStations: {
                      shape: "S2a"
                    },
                    noradSatelliteID: {
                      type: "integer"
                    },
                    satelliteArn: {},
                    satelliteId: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sx"
              }
            }
          }
        },
        ReserveContact: {
          http: {
            requestUri: "/contact",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "endTime",
              "groundStation",
              "missionProfileArn",
              "satelliteArn",
              "startTime"
            ],
            members: {
              endTime: {
                type: "timestamp"
              },
              groundStation: {},
              missionProfileArn: {},
              satelliteArn: {},
              startTime: {
                type: "timestamp"
              },
              tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            shape: "S3"
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateConfig: {
          http: {
            method: "PUT",
            requestUri: "/config/{configType}/{configId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "configData",
              "configId",
              "configType",
              "name"
            ],
            members: {
              configData: {
                shape: "S5"
              },
              configId: {
                location: "uri",
                locationName: "configId"
              },
              configType: {
                location: "uri",
                locationName: "configType"
              },
              name: {}
            }
          },
          output: {
            shape: "Sy"
          },
          idempotent: true
        },
        UpdateMissionProfile: {
          http: {
            method: "PUT",
            requestUri: "/missionprofile/{missionProfileId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "missionProfileId"
            ],
            members: {
              contactPostPassDurationSeconds: {
                type: "integer"
              },
              contactPrePassDurationSeconds: {
                type: "integer"
              },
              dataflowEdges: {
                shape: "S1e"
              },
              minimumViableContactDurationSeconds: {
                type: "integer"
              },
              missionProfileId: {
                location: "uri",
                locationName: "missionProfileId"
              },
              name: {},
              trackingConfigArn: {}
            }
          },
          output: {
            shape: "S1g"
          },
          idempotent: true
        }
      },
      shapes: {
        S3: {
          type: "structure",
          members: {
            contactId: {}
          }
        },
        S5: {
          type: "structure",
          members: {
            antennaDownlinkConfig: {
              type: "structure",
              required: [
                "spectrumConfig"
              ],
              members: {
                spectrumConfig: {
                  shape: "S7"
                }
              }
            },
            antennaDownlinkDemodDecodeConfig: {
              type: "structure",
              required: [
                "decodeConfig",
                "demodulationConfig",
                "spectrumConfig"
              ],
              members: {
                decodeConfig: {
                  type: "structure",
                  required: [
                    "unvalidatedJSON"
                  ],
                  members: {
                    unvalidatedJSON: {}
                  }
                },
                demodulationConfig: {
                  type: "structure",
                  required: [
                    "unvalidatedJSON"
                  ],
                  members: {
                    unvalidatedJSON: {}
                  }
                },
                spectrumConfig: {
                  shape: "S7"
                }
              }
            },
            antennaUplinkConfig: {
              type: "structure",
              required: [
                "spectrumConfig",
                "targetEirp"
              ],
              members: {
                spectrumConfig: {
                  type: "structure",
                  required: [
                    "centerFrequency"
                  ],
                  members: {
                    centerFrequency: {
                      shape: "Sb"
                    },
                    polarization: {}
                  }
                },
                targetEirp: {
                  type: "structure",
                  required: [
                    "units",
                    "value"
                  ],
                  members: {
                    units: {},
                    value: {
                      type: "double"
                    }
                  }
                },
                transmitDisabled: {
                  type: "boolean"
                }
              }
            },
            dataflowEndpointConfig: {
              type: "structure",
              required: [
                "dataflowEndpointName"
              ],
              members: {
                dataflowEndpointName: {},
                dataflowEndpointRegion: {}
              }
            },
            s3RecordingConfig: {
              type: "structure",
              required: [
                "bucketArn",
                "roleArn"
              ],
              members: {
                bucketArn: {},
                prefix: {},
                roleArn: {}
              }
            },
            trackingConfig: {
              type: "structure",
              required: [
                "autotrack"
              ],
              members: {
                autotrack: {}
              }
            },
            uplinkEchoConfig: {
              type: "structure",
              required: [
                "antennaUplinkConfigArn",
                "enabled"
              ],
              members: {
                antennaUplinkConfigArn: {},
                enabled: {
                  type: "boolean"
                }
              }
            }
          },
          union: true
        },
        S7: {
          type: "structure",
          required: [
            "bandwidth",
            "centerFrequency"
          ],
          members: {
            bandwidth: {
              type: "structure",
              required: [
                "units",
                "value"
              ],
              members: {
                units: {},
                value: {
                  type: "double"
                }
              }
            },
            centerFrequency: {
              shape: "Sb"
            },
            polarization: {}
          }
        },
        Sb: {
          type: "structure",
          required: [
            "units",
            "value"
          ],
          members: {
            units: {},
            value: {
              type: "double"
            }
          }
        },
        Sx: {
          type: "map",
          key: {},
          value: {}
        },
        Sy: {
          type: "structure",
          members: {
            configArn: {},
            configId: {},
            configType: {}
          }
        },
        S11: {
          type: "list",
          member: {
            shape: "S12"
          }
        },
        S12: {
          type: "structure",
          members: {
            endpoint: {
              type: "structure",
              members: {
                address: {
                  type: "structure",
                  required: [
                    "name",
                    "port"
                  ],
                  members: {
                    name: {},
                    port: {
                      type: "integer"
                    }
                  }
                },
                mtu: {
                  type: "integer"
                },
                name: {},
                status: {}
              }
            },
            securityDetails: {
              type: "structure",
              required: [
                "roleArn",
                "securityGroupIds",
                "subnetIds"
              ],
              members: {
                roleArn: {},
                securityGroupIds: {
                  type: "list",
                  member: {}
                },
                subnetIds: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        S1b: {
          type: "structure",
          members: {
            dataflowEndpointGroupId: {}
          }
        },
        S1e: {
          type: "list",
          member: {
            type: "list",
            member: {}
          }
        },
        S1g: {
          type: "structure",
          members: {
            missionProfileId: {}
          }
        },
        S1q: {
          type: "structure",
          members: {
            antennaDemodDecodeDetails: {
              type: "structure",
              members: {
                outputNode: {}
              }
            },
            endpointDetails: {
              shape: "S12"
            },
            s3RecordingDetails: {
              type: "structure",
              members: {
                bucketArn: {},
                keyTemplate: {}
              }
            }
          },
          union: true
        },
        S1v: {
          type: "structure",
          required: [
            "unit",
            "value"
          ],
          members: {
            unit: {},
            value: {
              type: "double"
            }
          }
        },
        S2a: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/groundstation-2019-05-23.paginators.json
var require_groundstation_2019_05_23_paginators = __commonJS({
  "node_modules/aws-sdk/apis/groundstation-2019-05-23.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListConfigs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "configList"
        },
        ListContacts: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "contactList"
        },
        ListDataflowEndpointGroups: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "dataflowEndpointGroupList"
        },
        ListGroundStations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "groundStationList"
        },
        ListMissionProfiles: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "missionProfileList"
        },
        ListSatellites: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "satellites"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/groundstation.js
var require_groundstation = __commonJS({
  "node_modules/aws-sdk/clients/groundstation.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["groundstation"] = {};
    AWS3.GroundStation = Service.defineService("groundstation", ["2019-05-23"]);
    Object.defineProperty(apiLoader.services["groundstation"], "2019-05-23", {
      get: function get() {
        var model = require_groundstation_2019_05_23_min();
        model.paginators = require_groundstation_2019_05_23_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.GroundStation;
  }
});

// node_modules/aws-sdk/apis/iotthingsgraph-2018-09-06.min.json
var require_iotthingsgraph_2018_09_06_min = __commonJS({
  "node_modules/aws-sdk/apis/iotthingsgraph-2018-09-06.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-09-06",
        endpointPrefix: "iotthingsgraph",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS IoT Things Graph",
        serviceId: "IoTThingsGraph",
        signatureVersion: "v4",
        signingName: "iotthingsgraph",
        targetPrefix: "IotThingsGraphFrontEndService",
        uid: "iotthingsgraph-2018-09-06"
      },
      operations: {
        AssociateEntityToThing: {
          input: {
            type: "structure",
            required: [
              "thingName",
              "entityId"
            ],
            members: {
              thingName: {},
              entityId: {},
              namespaceVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateFlowTemplate: {
          input: {
            type: "structure",
            required: [
              "definition"
            ],
            members: {
              definition: {
                shape: "S7"
              },
              compatibleNamespaceVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summary: {
                shape: "Sb"
              }
            }
          }
        },
        CreateSystemInstance: {
          input: {
            type: "structure",
            required: [
              "definition",
              "target"
            ],
            members: {
              tags: {
                shape: "Sf"
              },
              definition: {
                shape: "S7"
              },
              target: {},
              greengrassGroupName: {},
              s3BucketName: {},
              metricsConfiguration: {
                shape: "Sm"
              },
              flowActionsRoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              summary: {
                shape: "Sq"
              }
            }
          }
        },
        CreateSystemTemplate: {
          input: {
            type: "structure",
            required: [
              "definition"
            ],
            members: {
              definition: {
                shape: "S7"
              },
              compatibleNamespaceVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summary: {
                shape: "Sw"
              }
            }
          }
        },
        DeleteFlowTemplate: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteNamespace: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              namespaceArn: {},
              namespaceName: {}
            }
          }
        },
        DeleteSystemInstance: {
          input: {
            type: "structure",
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSystemTemplate: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeploySystemInstance: {
          input: {
            type: "structure",
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "summary"
            ],
            members: {
              summary: {
                shape: "Sq"
              },
              greengrassDeploymentId: {}
            }
          }
        },
        DeprecateFlowTemplate: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeprecateSystemTemplate: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeNamespace: {
          input: {
            type: "structure",
            members: {
              namespaceName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              namespaceArn: {},
              namespaceName: {},
              trackingNamespaceName: {},
              trackingNamespaceVersion: {
                type: "long"
              },
              namespaceVersion: {
                type: "long"
              }
            }
          }
        },
        DissociateEntityFromThing: {
          input: {
            type: "structure",
            required: [
              "thingName",
              "entityType"
            ],
            members: {
              thingName: {},
              entityType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetEntities: {
          input: {
            type: "structure",
            required: [
              "ids"
            ],
            members: {
              ids: {
                type: "list",
                member: {}
              },
              namespaceVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              descriptions: {
                shape: "S1l"
              }
            }
          }
        },
        GetFlowTemplate: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {},
              revisionNumber: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              description: {
                type: "structure",
                members: {
                  summary: {
                    shape: "Sb"
                  },
                  definition: {
                    shape: "S7"
                  },
                  validatedNamespaceVersion: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        GetFlowTemplateRevisions: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summaries: {
                shape: "S1u"
              },
              nextToken: {}
            }
          }
        },
        GetNamespaceDeletionStatus: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              namespaceArn: {},
              namespaceName: {},
              status: {},
              errorCode: {},
              errorMessage: {}
            }
          }
        },
        GetSystemInstance: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              description: {
                type: "structure",
                members: {
                  summary: {
                    shape: "Sq"
                  },
                  definition: {
                    shape: "S7"
                  },
                  s3BucketName: {},
                  metricsConfiguration: {
                    shape: "Sm"
                  },
                  validatedNamespaceVersion: {
                    type: "long"
                  },
                  validatedDependencyRevisions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        id: {},
                        revisionNumber: {
                          type: "long"
                        }
                      }
                    }
                  },
                  flowActionsRoleArn: {}
                }
              }
            }
          }
        },
        GetSystemTemplate: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {},
              revisionNumber: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              description: {
                type: "structure",
                members: {
                  summary: {
                    shape: "Sw"
                  },
                  definition: {
                    shape: "S7"
                  },
                  validatedNamespaceVersion: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        GetSystemTemplateRevisions: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summaries: {
                shape: "S2a"
              },
              nextToken: {}
            }
          }
        },
        GetUploadStatus: {
          input: {
            type: "structure",
            required: [
              "uploadId"
            ],
            members: {
              uploadId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "uploadId",
              "uploadStatus",
              "createdDate"
            ],
            members: {
              uploadId: {},
              uploadStatus: {},
              namespaceArn: {},
              namespaceName: {},
              namespaceVersion: {
                type: "long"
              },
              failureReason: {
                type: "list",
                member: {}
              },
              createdDate: {
                type: "timestamp"
              }
            }
          }
        },
        ListFlowExecutionMessages: {
          input: {
            type: "structure",
            required: [
              "flowExecutionId"
            ],
            members: {
              flowExecutionId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              messages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    messageId: {},
                    eventType: {},
                    timestamp: {
                      type: "timestamp"
                    },
                    payload: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              maxResults: {
                type: "integer"
              },
              resourceArn: {},
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sf"
              },
              nextToken: {}
            }
          }
        },
        SearchEntities: {
          input: {
            type: "structure",
            required: [
              "entityTypes"
            ],
            members: {
              entityTypes: {
                type: "list",
                member: {}
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    value: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              namespaceVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              descriptions: {
                shape: "S1l"
              },
              nextToken: {}
            }
          }
        },
        SearchFlowExecutions: {
          input: {
            type: "structure",
            required: [
              "systemInstanceId"
            ],
            members: {
              systemInstanceId: {},
              flowExecutionId: {},
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    flowExecutionId: {},
                    status: {},
                    systemInstanceId: {},
                    flowTemplateId: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    updatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        SearchFlowTemplates: {
          input: {
            type: "structure",
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "value"
                  ],
                  members: {
                    name: {},
                    value: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summaries: {
                shape: "S1u"
              },
              nextToken: {}
            }
          }
        },
        SearchSystemInstances: {
          input: {
            type: "structure",
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    value: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summaries: {
                type: "list",
                member: {
                  shape: "Sq"
                }
              },
              nextToken: {}
            }
          }
        },
        SearchSystemTemplates: {
          input: {
            type: "structure",
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "value"
                  ],
                  members: {
                    name: {},
                    value: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summaries: {
                shape: "S2a"
              },
              nextToken: {}
            }
          }
        },
        SearchThings: {
          input: {
            type: "structure",
            required: [
              "entityId"
            ],
            members: {
              entityId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              namespaceVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              things: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    thingArn: {},
                    thingName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UndeploySystemInstance: {
          input: {
            type: "structure",
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              summary: {
                shape: "Sq"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateFlowTemplate: {
          input: {
            type: "structure",
            required: [
              "id",
              "definition"
            ],
            members: {
              id: {},
              definition: {
                shape: "S7"
              },
              compatibleNamespaceVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summary: {
                shape: "Sb"
              }
            }
          }
        },
        UpdateSystemTemplate: {
          input: {
            type: "structure",
            required: [
              "id",
              "definition"
            ],
            members: {
              id: {},
              definition: {
                shape: "S7"
              },
              compatibleNamespaceVersion: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              summary: {
                shape: "Sw"
              }
            }
          }
        },
        UploadEntityDefinitions: {
          input: {
            type: "structure",
            members: {
              document: {
                shape: "S7"
              },
              syncWithPublicNamespace: {
                type: "boolean"
              },
              deprecateExistingEntities: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "uploadId"
            ],
            members: {
              uploadId: {}
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "structure",
          required: [
            "language",
            "text"
          ],
          members: {
            language: {},
            text: {}
          }
        },
        Sb: {
          type: "structure",
          members: {
            id: {},
            arn: {},
            revisionNumber: {
              type: "long"
            },
            createdAt: {
              type: "timestamp"
            }
          }
        },
        Sf: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sm: {
          type: "structure",
          members: {
            cloudMetricEnabled: {
              type: "boolean"
            },
            metricRuleRoleArn: {}
          }
        },
        Sq: {
          type: "structure",
          members: {
            id: {},
            arn: {},
            status: {},
            target: {},
            greengrassGroupName: {},
            createdAt: {
              type: "timestamp"
            },
            updatedAt: {
              type: "timestamp"
            },
            greengrassGroupId: {},
            greengrassGroupVersionId: {}
          }
        },
        Sw: {
          type: "structure",
          members: {
            id: {},
            arn: {},
            revisionNumber: {
              type: "long"
            },
            createdAt: {
              type: "timestamp"
            }
          }
        },
        S1l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              arn: {},
              type: {},
              createdAt: {
                type: "timestamp"
              },
              definition: {
                shape: "S7"
              }
            }
          }
        },
        S1u: {
          type: "list",
          member: {
            shape: "Sb"
          }
        },
        S2a: {
          type: "list",
          member: {
            shape: "Sw"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotthingsgraph-2018-09-06.paginators.json
var require_iotthingsgraph_2018_09_06_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iotthingsgraph-2018-09-06.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetFlowTemplateRevisions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "summaries"
        },
        GetSystemTemplateRevisions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "summaries"
        },
        ListFlowExecutionMessages: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "messages"
        },
        ListTagsForResource: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "tags"
        },
        SearchEntities: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "descriptions"
        },
        SearchFlowExecutions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "summaries"
        },
        SearchFlowTemplates: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "summaries"
        },
        SearchSystemInstances: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "summaries"
        },
        SearchSystemTemplates: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "summaries"
        },
        SearchThings: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "things"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iotthingsgraph.js
var require_iotthingsgraph = __commonJS({
  "node_modules/aws-sdk/clients/iotthingsgraph.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["iotthingsgraph"] = {};
    AWS3.IoTThingsGraph = Service.defineService("iotthingsgraph", ["2018-09-06"]);
    Object.defineProperty(apiLoader.services["iotthingsgraph"], "2018-09-06", {
      get: function get() {
        var model = require_iotthingsgraph_2018_09_06_min();
        model.paginators = require_iotthingsgraph_2018_09_06_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.IoTThingsGraph;
  }
});

// node_modules/aws-sdk/apis/iotevents-2018-07-27.min.json
var require_iotevents_2018_07_27_min = __commonJS({
  "node_modules/aws-sdk/apis/iotevents-2018-07-27.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-07-27",
        endpointPrefix: "iotevents",
        protocol: "rest-json",
        serviceFullName: "AWS IoT Events",
        serviceId: "IoT Events",
        signatureVersion: "v4",
        signingName: "iotevents",
        uid: "iotevents-2018-07-27"
      },
      operations: {
        CreateAlarmModel: {
          http: {
            requestUri: "/alarm-models"
          },
          input: {
            type: "structure",
            required: [
              "alarmModelName",
              "roleArn",
              "alarmRule"
            ],
            members: {
              alarmModelName: {},
              alarmModelDescription: {},
              roleArn: {},
              tags: {
                shape: "S5"
              },
              key: {},
              severity: {
                type: "integer"
              },
              alarmRule: {
                shape: "Sb"
              },
              alarmNotification: {
                shape: "Sg"
              },
              alarmEventActions: {
                shape: "S13"
              },
              alarmCapabilities: {
                shape: "S23"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              creationTime: {
                type: "timestamp"
              },
              alarmModelArn: {},
              alarmModelVersion: {},
              lastUpdateTime: {
                type: "timestamp"
              },
              status: {}
            }
          }
        },
        CreateDetectorModel: {
          http: {
            requestUri: "/detector-models"
          },
          input: {
            type: "structure",
            required: [
              "detectorModelName",
              "detectorModelDefinition",
              "roleArn"
            ],
            members: {
              detectorModelName: {},
              detectorModelDefinition: {
                shape: "S2f"
              },
              detectorModelDescription: {},
              key: {},
              roleArn: {},
              tags: {
                shape: "S5"
              },
              evaluationMethod: {}
            }
          },
          output: {
            type: "structure",
            members: {
              detectorModelConfiguration: {
                shape: "S35"
              }
            }
          }
        },
        CreateInput: {
          http: {
            requestUri: "/inputs",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "inputName",
              "inputDefinition"
            ],
            members: {
              inputName: {},
              inputDescription: {},
              inputDefinition: {
                shape: "S3b"
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              inputConfiguration: {
                shape: "S3f"
              }
            }
          }
        },
        DeleteAlarmModel: {
          http: {
            method: "DELETE",
            requestUri: "/alarm-models/{alarmModelName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "alarmModelName"
            ],
            members: {
              alarmModelName: {
                location: "uri",
                locationName: "alarmModelName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDetectorModel: {
          http: {
            method: "DELETE",
            requestUri: "/detector-models/{detectorModelName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "detectorModelName"
            ],
            members: {
              detectorModelName: {
                location: "uri",
                locationName: "detectorModelName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteInput: {
          http: {
            method: "DELETE",
            requestUri: "/inputs/{inputName}"
          },
          input: {
            type: "structure",
            required: [
              "inputName"
            ],
            members: {
              inputName: {
                location: "uri",
                locationName: "inputName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeAlarmModel: {
          http: {
            method: "GET",
            requestUri: "/alarm-models/{alarmModelName}"
          },
          input: {
            type: "structure",
            required: [
              "alarmModelName"
            ],
            members: {
              alarmModelName: {
                location: "uri",
                locationName: "alarmModelName"
              },
              alarmModelVersion: {
                location: "querystring",
                locationName: "version"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              creationTime: {
                type: "timestamp"
              },
              alarmModelArn: {},
              alarmModelVersion: {},
              lastUpdateTime: {
                type: "timestamp"
              },
              status: {},
              statusMessage: {},
              alarmModelName: {},
              alarmModelDescription: {},
              roleArn: {},
              key: {},
              severity: {
                type: "integer"
              },
              alarmRule: {
                shape: "Sb"
              },
              alarmNotification: {
                shape: "Sg"
              },
              alarmEventActions: {
                shape: "S13"
              },
              alarmCapabilities: {
                shape: "S23"
              }
            }
          }
        },
        DescribeDetectorModel: {
          http: {
            method: "GET",
            requestUri: "/detector-models/{detectorModelName}"
          },
          input: {
            type: "structure",
            required: [
              "detectorModelName"
            ],
            members: {
              detectorModelName: {
                location: "uri",
                locationName: "detectorModelName"
              },
              detectorModelVersion: {
                location: "querystring",
                locationName: "version"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              detectorModel: {
                type: "structure",
                members: {
                  detectorModelDefinition: {
                    shape: "S2f"
                  },
                  detectorModelConfiguration: {
                    shape: "S35"
                  }
                }
              }
            }
          }
        },
        DescribeDetectorModelAnalysis: {
          http: {
            method: "GET",
            requestUri: "/analysis/detector-models/{analysisId}"
          },
          input: {
            type: "structure",
            required: [
              "analysisId"
            ],
            members: {
              analysisId: {
                location: "uri",
                locationName: "analysisId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          }
        },
        DescribeInput: {
          http: {
            method: "GET",
            requestUri: "/inputs/{inputName}"
          },
          input: {
            type: "structure",
            required: [
              "inputName"
            ],
            members: {
              inputName: {
                location: "uri",
                locationName: "inputName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              input: {
                type: "structure",
                members: {
                  inputConfiguration: {
                    shape: "S3f"
                  },
                  inputDefinition: {
                    shape: "S3b"
                  }
                }
              }
            }
          }
        },
        DescribeLoggingOptions: {
          http: {
            method: "GET",
            requestUri: "/logging"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              loggingOptions: {
                shape: "S43"
              }
            }
          }
        },
        GetDetectorModelAnalysisResults: {
          http: {
            method: "GET",
            requestUri: "/analysis/detector-models/{analysisId}/results"
          },
          input: {
            type: "structure",
            required: [
              "analysisId"
            ],
            members: {
              analysisId: {
                location: "uri",
                locationName: "analysisId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              analysisResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    type: {},
                    level: {},
                    message: {},
                    locations: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          path: {}
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAlarmModelVersions: {
          http: {
            method: "GET",
            requestUri: "/alarm-models/{alarmModelName}/versions"
          },
          input: {
            type: "structure",
            required: [
              "alarmModelName"
            ],
            members: {
              alarmModelName: {
                location: "uri",
                locationName: "alarmModelName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              alarmModelVersionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    alarmModelName: {},
                    alarmModelArn: {},
                    alarmModelVersion: {},
                    roleArn: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    },
                    status: {},
                    statusMessage: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAlarmModels: {
          http: {
            method: "GET",
            requestUri: "/alarm-models"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              alarmModelSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    creationTime: {
                      type: "timestamp"
                    },
                    alarmModelDescription: {},
                    alarmModelName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDetectorModelVersions: {
          http: {
            method: "GET",
            requestUri: "/detector-models/{detectorModelName}/versions"
          },
          input: {
            type: "structure",
            required: [
              "detectorModelName"
            ],
            members: {
              detectorModelName: {
                location: "uri",
                locationName: "detectorModelName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              detectorModelVersionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    detectorModelName: {},
                    detectorModelVersion: {},
                    detectorModelArn: {},
                    roleArn: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    },
                    status: {},
                    evaluationMethod: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDetectorModels: {
          http: {
            method: "GET",
            requestUri: "/detector-models"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              detectorModelSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    detectorModelName: {},
                    detectorModelDescription: {},
                    creationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListInputRoutings: {
          http: {
            requestUri: "/input-routings"
          },
          input: {
            type: "structure",
            required: [
              "inputIdentifier"
            ],
            members: {
              inputIdentifier: {
                type: "structure",
                members: {
                  iotEventsInputIdentifier: {
                    type: "structure",
                    required: [
                      "inputName"
                    ],
                    members: {
                      inputName: {}
                    }
                  },
                  iotSiteWiseInputIdentifier: {
                    type: "structure",
                    members: {
                      iotSiteWiseAssetModelPropertyIdentifier: {
                        type: "structure",
                        required: [
                          "assetModelId",
                          "propertyId"
                        ],
                        members: {
                          assetModelId: {},
                          propertyId: {}
                        }
                      }
                    }
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              routedResources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListInputs: {
          http: {
            method: "GET",
            requestUri: "/inputs"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              inputSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    inputName: {},
                    inputDescription: {},
                    inputArn: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    },
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S5"
              }
            }
          }
        },
        PutLoggingOptions: {
          http: {
            method: "PUT",
            requestUri: "/logging"
          },
          input: {
            type: "structure",
            required: [
              "loggingOptions"
            ],
            members: {
              loggingOptions: {
                shape: "S43"
              }
            }
          }
        },
        StartDetectorModelAnalysis: {
          http: {
            requestUri: "/analysis/detector-models/"
          },
          input: {
            type: "structure",
            required: [
              "detectorModelDefinition"
            ],
            members: {
              detectorModelDefinition: {
                shape: "S2f"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              analysisId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAlarmModel: {
          http: {
            requestUri: "/alarm-models/{alarmModelName}"
          },
          input: {
            type: "structure",
            required: [
              "alarmModelName",
              "roleArn",
              "alarmRule"
            ],
            members: {
              alarmModelName: {
                location: "uri",
                locationName: "alarmModelName"
              },
              alarmModelDescription: {},
              roleArn: {},
              severity: {
                type: "integer"
              },
              alarmRule: {
                shape: "Sb"
              },
              alarmNotification: {
                shape: "Sg"
              },
              alarmEventActions: {
                shape: "S13"
              },
              alarmCapabilities: {
                shape: "S23"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              creationTime: {
                type: "timestamp"
              },
              alarmModelArn: {},
              alarmModelVersion: {},
              lastUpdateTime: {
                type: "timestamp"
              },
              status: {}
            }
          }
        },
        UpdateDetectorModel: {
          http: {
            requestUri: "/detector-models/{detectorModelName}"
          },
          input: {
            type: "structure",
            required: [
              "detectorModelName",
              "detectorModelDefinition",
              "roleArn"
            ],
            members: {
              detectorModelName: {
                location: "uri",
                locationName: "detectorModelName"
              },
              detectorModelDefinition: {
                shape: "S2f"
              },
              detectorModelDescription: {},
              roleArn: {},
              evaluationMethod: {}
            }
          },
          output: {
            type: "structure",
            members: {
              detectorModelConfiguration: {
                shape: "S35"
              }
            }
          }
        },
        UpdateInput: {
          http: {
            method: "PUT",
            requestUri: "/inputs/{inputName}"
          },
          input: {
            type: "structure",
            required: [
              "inputName",
              "inputDefinition"
            ],
            members: {
              inputName: {
                location: "uri",
                locationName: "inputName"
              },
              inputDescription: {},
              inputDefinition: {
                shape: "S3b"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              inputConfiguration: {
                shape: "S3f"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sb: {
          type: "structure",
          members: {
            simpleRule: {
              type: "structure",
              required: [
                "inputProperty",
                "comparisonOperator",
                "threshold"
              ],
              members: {
                inputProperty: {},
                comparisonOperator: {},
                threshold: {}
              }
            }
          }
        },
        Sg: {
          type: "structure",
          members: {
            notificationActions: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "action"
                ],
                members: {
                  action: {
                    type: "structure",
                    members: {
                      lambdaAction: {
                        shape: "Sk"
                      }
                    }
                  },
                  smsConfigurations: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "recipients"
                      ],
                      members: {
                        senderId: {},
                        additionalMessage: {},
                        recipients: {
                          shape: "Ss"
                        }
                      }
                    }
                  },
                  emailConfigurations: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "from",
                        "recipients"
                      ],
                      members: {
                        from: {},
                        content: {
                          type: "structure",
                          members: {
                            subject: {},
                            additionalMessage: {}
                          }
                        },
                        recipients: {
                          type: "structure",
                          members: {
                            to: {
                              shape: "Ss"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sk: {
          type: "structure",
          required: [
            "functionArn"
          ],
          members: {
            functionArn: {},
            payload: {
              shape: "Sl"
            }
          }
        },
        Sl: {
          type: "structure",
          required: [
            "contentExpression",
            "type"
          ],
          members: {
            contentExpression: {},
            type: {}
          }
        },
        Ss: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ssoIdentity: {
                type: "structure",
                required: [
                  "identityStoreId"
                ],
                members: {
                  identityStoreId: {},
                  userId: {}
                }
              }
            }
          }
        },
        S13: {
          type: "structure",
          members: {
            alarmActions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  sns: {
                    shape: "S16"
                  },
                  iotTopicPublish: {
                    shape: "S17"
                  },
                  lambda: {
                    shape: "Sk"
                  },
                  iotEvents: {
                    shape: "S19"
                  },
                  sqs: {
                    shape: "S1b"
                  },
                  firehose: {
                    shape: "S1e"
                  },
                  dynamoDB: {
                    shape: "S1h"
                  },
                  dynamoDBv2: {
                    shape: "S1n"
                  },
                  iotSiteWise: {
                    shape: "S1o"
                  }
                }
              }
            }
          }
        },
        S16: {
          type: "structure",
          required: [
            "targetArn"
          ],
          members: {
            targetArn: {},
            payload: {
              shape: "Sl"
            }
          }
        },
        S17: {
          type: "structure",
          required: [
            "mqttTopic"
          ],
          members: {
            mqttTopic: {},
            payload: {
              shape: "Sl"
            }
          }
        },
        S19: {
          type: "structure",
          required: [
            "inputName"
          ],
          members: {
            inputName: {},
            payload: {
              shape: "Sl"
            }
          }
        },
        S1b: {
          type: "structure",
          required: [
            "queueUrl"
          ],
          members: {
            queueUrl: {},
            useBase64: {
              type: "boolean"
            },
            payload: {
              shape: "Sl"
            }
          }
        },
        S1e: {
          type: "structure",
          required: [
            "deliveryStreamName"
          ],
          members: {
            deliveryStreamName: {},
            separator: {},
            payload: {
              shape: "Sl"
            }
          }
        },
        S1h: {
          type: "structure",
          required: [
            "hashKeyField",
            "hashKeyValue",
            "tableName"
          ],
          members: {
            hashKeyType: {},
            hashKeyField: {},
            hashKeyValue: {},
            rangeKeyType: {},
            rangeKeyField: {},
            rangeKeyValue: {},
            operation: {},
            payloadField: {},
            tableName: {},
            payload: {
              shape: "Sl"
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "tableName"
          ],
          members: {
            tableName: {},
            payload: {
              shape: "Sl"
            }
          }
        },
        S1o: {
          type: "structure",
          members: {
            entryId: {},
            assetId: {},
            propertyId: {},
            propertyAlias: {},
            propertyValue: {
              type: "structure",
              members: {
                value: {
                  type: "structure",
                  members: {
                    stringValue: {},
                    integerValue: {},
                    doubleValue: {},
                    booleanValue: {}
                  }
                },
                timestamp: {
                  type: "structure",
                  required: [
                    "timeInSeconds"
                  ],
                  members: {
                    timeInSeconds: {},
                    offsetInNanos: {}
                  }
                },
                quality: {}
              }
            }
          }
        },
        S23: {
          type: "structure",
          members: {
            initializationConfiguration: {
              type: "structure",
              required: [
                "disabledOnInitialization"
              ],
              members: {
                disabledOnInitialization: {
                  type: "boolean"
                }
              }
            },
            acknowledgeFlow: {
              type: "structure",
              required: [
                "enabled"
              ],
              members: {
                enabled: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S2f: {
          type: "structure",
          required: [
            "states",
            "initialStateName"
          ],
          members: {
            states: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "stateName"
                ],
                members: {
                  stateName: {},
                  onInput: {
                    type: "structure",
                    members: {
                      events: {
                        shape: "S2k"
                      },
                      transitionEvents: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "eventName",
                            "condition",
                            "nextState"
                          ],
                          members: {
                            eventName: {},
                            condition: {},
                            actions: {
                              shape: "S2o"
                            },
                            nextState: {}
                          }
                        }
                      }
                    }
                  },
                  onEnter: {
                    type: "structure",
                    members: {
                      events: {
                        shape: "S2k"
                      }
                    }
                  },
                  onExit: {
                    type: "structure",
                    members: {
                      events: {
                        shape: "S2k"
                      }
                    }
                  }
                }
              }
            },
            initialStateName: {}
          }
        },
        S2k: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "eventName"
            ],
            members: {
              eventName: {},
              condition: {},
              actions: {
                shape: "S2o"
              }
            }
          }
        },
        S2o: {
          type: "list",
          member: {
            type: "structure",
            members: {
              setVariable: {
                type: "structure",
                required: [
                  "variableName",
                  "value"
                ],
                members: {
                  variableName: {},
                  value: {}
                }
              },
              sns: {
                shape: "S16"
              },
              iotTopicPublish: {
                shape: "S17"
              },
              setTimer: {
                type: "structure",
                required: [
                  "timerName"
                ],
                members: {
                  timerName: {},
                  seconds: {
                    deprecated: true,
                    deprecatedMessage: "seconds is deprecated. You can use durationExpression for SetTimerAction. The value of seconds can be used as a string expression for durationExpression.",
                    type: "integer"
                  },
                  durationExpression: {}
                }
              },
              clearTimer: {
                type: "structure",
                required: [
                  "timerName"
                ],
                members: {
                  timerName: {}
                }
              },
              resetTimer: {
                type: "structure",
                required: [
                  "timerName"
                ],
                members: {
                  timerName: {}
                }
              },
              lambda: {
                shape: "Sk"
              },
              iotEvents: {
                shape: "S19"
              },
              sqs: {
                shape: "S1b"
              },
              firehose: {
                shape: "S1e"
              },
              dynamoDB: {
                shape: "S1h"
              },
              dynamoDBv2: {
                shape: "S1n"
              },
              iotSiteWise: {
                shape: "S1o"
              }
            }
          }
        },
        S35: {
          type: "structure",
          members: {
            detectorModelName: {},
            detectorModelVersion: {},
            detectorModelDescription: {},
            detectorModelArn: {},
            roleArn: {},
            creationTime: {
              type: "timestamp"
            },
            lastUpdateTime: {
              type: "timestamp"
            },
            status: {},
            key: {},
            evaluationMethod: {}
          }
        },
        S3b: {
          type: "structure",
          required: [
            "attributes"
          ],
          members: {
            attributes: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "jsonPath"
                ],
                members: {
                  jsonPath: {}
                }
              }
            }
          }
        },
        S3f: {
          type: "structure",
          required: [
            "inputName",
            "inputArn",
            "creationTime",
            "lastUpdateTime",
            "status"
          ],
          members: {
            inputName: {},
            inputDescription: {},
            inputArn: {},
            creationTime: {
              type: "timestamp"
            },
            lastUpdateTime: {
              type: "timestamp"
            },
            status: {}
          }
        },
        S43: {
          type: "structure",
          required: [
            "roleArn",
            "level",
            "enabled"
          ],
          members: {
            roleArn: {},
            level: {},
            enabled: {
              type: "boolean"
            },
            detectorDebugOptions: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "detectorModelName"
                ],
                members: {
                  detectorModelName: {},
                  keyValue: {}
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotevents-2018-07-27.paginators.json
var require_iotevents_2018_07_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iotevents-2018-07-27.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/iotevents.js
var require_iotevents = __commonJS({
  "node_modules/aws-sdk/clients/iotevents.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["iotevents"] = {};
    AWS3.IoTEvents = Service.defineService("iotevents", ["2018-07-27"]);
    Object.defineProperty(apiLoader.services["iotevents"], "2018-07-27", {
      get: function get() {
        var model = require_iotevents_2018_07_27_min();
        model.paginators = require_iotevents_2018_07_27_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.IoTEvents;
  }
});

// node_modules/aws-sdk/apis/iotevents-data-2018-10-23.min.json
var require_iotevents_data_2018_10_23_min = __commonJS({
  "node_modules/aws-sdk/apis/iotevents-data-2018-10-23.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-10-23",
        endpointPrefix: "data.iotevents",
        protocol: "rest-json",
        serviceFullName: "AWS IoT Events Data",
        serviceId: "IoT Events Data",
        signatureVersion: "v4",
        signingName: "ioteventsdata",
        uid: "iotevents-data-2018-10-23"
      },
      operations: {
        BatchAcknowledgeAlarm: {
          http: {
            requestUri: "/alarms/acknowledge",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "acknowledgeActionRequests"
            ],
            members: {
              acknowledgeActionRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "requestId",
                    "alarmModelName"
                  ],
                  members: {
                    requestId: {},
                    alarmModelName: {},
                    keyValue: {},
                    note: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errorEntries: {
                shape: "S9"
              }
            }
          }
        },
        BatchDisableAlarm: {
          http: {
            requestUri: "/alarms/disable",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "disableActionRequests"
            ],
            members: {
              disableActionRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "requestId",
                    "alarmModelName"
                  ],
                  members: {
                    requestId: {},
                    alarmModelName: {},
                    keyValue: {},
                    note: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errorEntries: {
                shape: "S9"
              }
            }
          }
        },
        BatchEnableAlarm: {
          http: {
            requestUri: "/alarms/enable",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "enableActionRequests"
            ],
            members: {
              enableActionRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "requestId",
                    "alarmModelName"
                  ],
                  members: {
                    requestId: {},
                    alarmModelName: {},
                    keyValue: {},
                    note: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errorEntries: {
                shape: "S9"
              }
            }
          }
        },
        BatchPutMessage: {
          http: {
            requestUri: "/inputs/messages",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "messages"
            ],
            members: {
              messages: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "messageId",
                    "inputName",
                    "payload"
                  ],
                  members: {
                    messageId: {},
                    inputName: {},
                    payload: {
                      type: "blob"
                    },
                    timestamp: {
                      type: "structure",
                      members: {
                        timeInMillis: {
                          type: "long"
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BatchPutMessageErrorEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    messageId: {},
                    errorCode: {},
                    errorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchResetAlarm: {
          http: {
            requestUri: "/alarms/reset",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "resetActionRequests"
            ],
            members: {
              resetActionRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "requestId",
                    "alarmModelName"
                  ],
                  members: {
                    requestId: {},
                    alarmModelName: {},
                    keyValue: {},
                    note: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errorEntries: {
                shape: "S9"
              }
            }
          }
        },
        BatchSnoozeAlarm: {
          http: {
            requestUri: "/alarms/snooze",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "snoozeActionRequests"
            ],
            members: {
              snoozeActionRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "requestId",
                    "alarmModelName",
                    "snoozeDuration"
                  ],
                  members: {
                    requestId: {},
                    alarmModelName: {},
                    keyValue: {},
                    note: {},
                    snoozeDuration: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errorEntries: {
                shape: "S9"
              }
            }
          }
        },
        BatchUpdateDetector: {
          http: {
            requestUri: "/detectors",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "detectors"
            ],
            members: {
              detectors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "messageId",
                    "detectorModelName",
                    "state"
                  ],
                  members: {
                    messageId: {},
                    detectorModelName: {},
                    keyValue: {},
                    state: {
                      type: "structure",
                      required: [
                        "stateName",
                        "variables",
                        "timers"
                      ],
                      members: {
                        stateName: {},
                        variables: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "name",
                              "value"
                            ],
                            members: {
                              name: {},
                              value: {}
                            }
                          }
                        },
                        timers: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "name",
                              "seconds"
                            ],
                            members: {
                              name: {},
                              seconds: {
                                type: "integer"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              batchUpdateDetectorErrorEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    messageId: {},
                    errorCode: {},
                    errorMessage: {}
                  }
                }
              }
            }
          }
        },
        DescribeAlarm: {
          http: {
            method: "GET",
            requestUri: "/alarms/{alarmModelName}/keyValues/"
          },
          input: {
            type: "structure",
            required: [
              "alarmModelName"
            ],
            members: {
              alarmModelName: {
                location: "uri",
                locationName: "alarmModelName"
              },
              keyValue: {
                location: "querystring",
                locationName: "keyValue"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              alarm: {
                type: "structure",
                members: {
                  alarmModelName: {},
                  alarmModelVersion: {},
                  keyValue: {},
                  alarmState: {
                    type: "structure",
                    members: {
                      stateName: {},
                      ruleEvaluation: {
                        type: "structure",
                        members: {
                          simpleRuleEvaluation: {
                            type: "structure",
                            members: {
                              inputPropertyValue: {},
                              operator: {},
                              thresholdValue: {}
                            }
                          }
                        }
                      },
                      customerAction: {
                        type: "structure",
                        members: {
                          actionName: {},
                          snoozeActionConfiguration: {
                            type: "structure",
                            members: {
                              snoozeDuration: {
                                type: "integer"
                              },
                              note: {}
                            }
                          },
                          enableActionConfiguration: {
                            type: "structure",
                            members: {
                              note: {}
                            }
                          },
                          disableActionConfiguration: {
                            type: "structure",
                            members: {
                              note: {}
                            }
                          },
                          acknowledgeActionConfiguration: {
                            type: "structure",
                            members: {
                              note: {}
                            }
                          },
                          resetActionConfiguration: {
                            type: "structure",
                            members: {
                              note: {}
                            }
                          }
                        }
                      },
                      systemEvent: {
                        type: "structure",
                        members: {
                          eventType: {},
                          stateChangeConfiguration: {
                            type: "structure",
                            members: {
                              triggerType: {}
                            }
                          }
                        }
                      }
                    }
                  },
                  severity: {
                    type: "integer"
                  },
                  creationTime: {
                    type: "timestamp"
                  },
                  lastUpdateTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeDetector: {
          http: {
            method: "GET",
            requestUri: "/detectors/{detectorModelName}/keyValues/"
          },
          input: {
            type: "structure",
            required: [
              "detectorModelName"
            ],
            members: {
              detectorModelName: {
                location: "uri",
                locationName: "detectorModelName"
              },
              keyValue: {
                location: "querystring",
                locationName: "keyValue"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              detector: {
                type: "structure",
                members: {
                  detectorModelName: {},
                  keyValue: {},
                  detectorModelVersion: {},
                  state: {
                    type: "structure",
                    required: [
                      "stateName",
                      "variables",
                      "timers"
                    ],
                    members: {
                      stateName: {},
                      variables: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "name",
                            "value"
                          ],
                          members: {
                            name: {},
                            value: {}
                          }
                        }
                      },
                      timers: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "name",
                            "timestamp"
                          ],
                          members: {
                            name: {},
                            timestamp: {
                              type: "timestamp"
                            }
                          }
                        }
                      }
                    }
                  },
                  creationTime: {
                    type: "timestamp"
                  },
                  lastUpdateTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        ListAlarms: {
          http: {
            method: "GET",
            requestUri: "/alarms/{alarmModelName}"
          },
          input: {
            type: "structure",
            required: [
              "alarmModelName"
            ],
            members: {
              alarmModelName: {
                location: "uri",
                locationName: "alarmModelName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              alarmSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    alarmModelName: {},
                    alarmModelVersion: {},
                    keyValue: {},
                    stateName: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDetectors: {
          http: {
            method: "GET",
            requestUri: "/detectors/{detectorModelName}"
          },
          input: {
            type: "structure",
            required: [
              "detectorModelName"
            ],
            members: {
              detectorModelName: {
                location: "uri",
                locationName: "detectorModelName"
              },
              stateName: {
                location: "querystring",
                locationName: "stateName"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              detectorSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    detectorModelName: {},
                    keyValue: {},
                    detectorModelVersion: {},
                    state: {
                      type: "structure",
                      members: {
                        stateName: {}
                      }
                    },
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        }
      },
      shapes: {
        S9: {
          type: "list",
          member: {
            type: "structure",
            members: {
              requestId: {},
              errorCode: {},
              errorMessage: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotevents-data-2018-10-23.paginators.json
var require_iotevents_data_2018_10_23_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iotevents-data-2018-10-23.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/ioteventsdata.js
var require_ioteventsdata = __commonJS({
  "node_modules/aws-sdk/clients/ioteventsdata.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["ioteventsdata"] = {};
    AWS3.IoTEventsData = Service.defineService("ioteventsdata", ["2018-10-23"]);
    Object.defineProperty(apiLoader.services["ioteventsdata"], "2018-10-23", {
      get: function get() {
        var model = require_iotevents_data_2018_10_23_min();
        model.paginators = require_iotevents_data_2018_10_23_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.IoTEventsData;
  }
});

// node_modules/aws-sdk/apis/personalize-2018-05-22.min.json
var require_personalize_2018_05_22_min = __commonJS({
  "node_modules/aws-sdk/apis/personalize-2018-05-22.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-22",
        endpointPrefix: "personalize",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Personalize",
        serviceId: "Personalize",
        signatureVersion: "v4",
        signingName: "personalize",
        targetPrefix: "AmazonPersonalize",
        uid: "personalize-2018-05-22"
      },
      operations: {
        CreateBatchInferenceJob: {
          input: {
            type: "structure",
            required: [
              "jobName",
              "solutionVersionArn",
              "jobInput",
              "jobOutput",
              "roleArn"
            ],
            members: {
              jobName: {},
              solutionVersionArn: {},
              filterArn: {},
              numResults: {
                type: "integer"
              },
              jobInput: {
                shape: "S5"
              },
              jobOutput: {
                shape: "S9"
              },
              roleArn: {},
              batchInferenceJobConfig: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              batchInferenceJobArn: {}
            }
          }
        },
        CreateCampaign: {
          input: {
            type: "structure",
            required: [
              "name",
              "solutionVersionArn"
            ],
            members: {
              name: {},
              solutionVersionArn: {},
              minProvisionedTPS: {
                type: "integer"
              },
              campaignConfig: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              campaignArn: {}
            }
          },
          idempotent: true
        },
        CreateDataset: {
          input: {
            type: "structure",
            required: [
              "name",
              "schemaArn",
              "datasetGroupArn",
              "datasetType"
            ],
            members: {
              name: {},
              schemaArn: {},
              datasetGroupArn: {},
              datasetType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              datasetArn: {}
            }
          },
          idempotent: true
        },
        CreateDatasetExportJob: {
          input: {
            type: "structure",
            required: [
              "jobName",
              "datasetArn",
              "roleArn",
              "jobOutput"
            ],
            members: {
              jobName: {},
              datasetArn: {},
              ingestionMode: {},
              roleArn: {},
              jobOutput: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetExportJobArn: {}
            }
          },
          idempotent: true
        },
        CreateDatasetGroup: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              roleArn: {},
              kmsKeyArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              datasetGroupArn: {}
            }
          }
        },
        CreateDatasetImportJob: {
          input: {
            type: "structure",
            required: [
              "jobName",
              "datasetArn",
              "dataSource",
              "roleArn"
            ],
            members: {
              jobName: {},
              datasetArn: {},
              dataSource: {
                shape: "Su"
              },
              roleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              datasetImportJobArn: {}
            }
          }
        },
        CreateEventTracker: {
          input: {
            type: "structure",
            required: [
              "name",
              "datasetGroupArn"
            ],
            members: {
              name: {},
              datasetGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              eventTrackerArn: {},
              trackingId: {}
            }
          },
          idempotent: true
        },
        CreateFilter: {
          input: {
            type: "structure",
            required: [
              "name",
              "datasetGroupArn",
              "filterExpression"
            ],
            members: {
              name: {},
              datasetGroupArn: {},
              filterExpression: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              filterArn: {}
            }
          }
        },
        CreateSchema: {
          input: {
            type: "structure",
            required: [
              "name",
              "schema"
            ],
            members: {
              name: {},
              schema: {}
            }
          },
          output: {
            type: "structure",
            members: {
              schemaArn: {}
            }
          },
          idempotent: true
        },
        CreateSolution: {
          input: {
            type: "structure",
            required: [
              "name",
              "datasetGroupArn"
            ],
            members: {
              name: {},
              performHPO: {
                type: "boolean"
              },
              performAutoML: {
                type: "boolean"
              },
              recipeArn: {},
              datasetGroupArn: {},
              eventType: {},
              solutionConfig: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              solutionArn: {}
            }
          }
        },
        CreateSolutionVersion: {
          input: {
            type: "structure",
            required: [
              "solutionArn"
            ],
            members: {
              solutionArn: {},
              trainingMode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              solutionVersionArn: {}
            }
          }
        },
        DeleteCampaign: {
          input: {
            type: "structure",
            required: [
              "campaignArn"
            ],
            members: {
              campaignArn: {}
            }
          },
          idempotent: true
        },
        DeleteDataset: {
          input: {
            type: "structure",
            required: [
              "datasetArn"
            ],
            members: {
              datasetArn: {}
            }
          },
          idempotent: true
        },
        DeleteDatasetGroup: {
          input: {
            type: "structure",
            required: [
              "datasetGroupArn"
            ],
            members: {
              datasetGroupArn: {}
            }
          },
          idempotent: true
        },
        DeleteEventTracker: {
          input: {
            type: "structure",
            required: [
              "eventTrackerArn"
            ],
            members: {
              eventTrackerArn: {}
            }
          },
          idempotent: true
        },
        DeleteFilter: {
          input: {
            type: "structure",
            required: [
              "filterArn"
            ],
            members: {
              filterArn: {}
            }
          }
        },
        DeleteSchema: {
          input: {
            type: "structure",
            required: [
              "schemaArn"
            ],
            members: {
              schemaArn: {}
            }
          },
          idempotent: true
        },
        DeleteSolution: {
          input: {
            type: "structure",
            required: [
              "solutionArn"
            ],
            members: {
              solutionArn: {}
            }
          },
          idempotent: true
        },
        DescribeAlgorithm: {
          input: {
            type: "structure",
            required: [
              "algorithmArn"
            ],
            members: {
              algorithmArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              algorithm: {
                type: "structure",
                members: {
                  name: {},
                  algorithmArn: {},
                  algorithmImage: {
                    type: "structure",
                    required: [
                      "dockerURI"
                    ],
                    members: {
                      name: {},
                      dockerURI: {}
                    }
                  },
                  defaultHyperParameters: {
                    shape: "Sc"
                  },
                  defaultHyperParameterRanges: {
                    type: "structure",
                    members: {
                      integerHyperParameterRanges: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            name: {},
                            minValue: {
                              type: "integer"
                            },
                            maxValue: {
                              type: "integer"
                            },
                            isTunable: {
                              type: "boolean"
                            }
                          }
                        }
                      },
                      continuousHyperParameterRanges: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            name: {},
                            minValue: {
                              type: "double"
                            },
                            maxValue: {
                              type: "double"
                            },
                            isTunable: {
                              type: "boolean"
                            }
                          }
                        }
                      },
                      categoricalHyperParameterRanges: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            name: {},
                            values: {
                              shape: "S1t"
                            },
                            isTunable: {
                              type: "boolean"
                            }
                          }
                        }
                      }
                    }
                  },
                  defaultResourceConfig: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  trainingInputMode: {},
                  roleArn: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeBatchInferenceJob: {
          input: {
            type: "structure",
            required: [
              "batchInferenceJobArn"
            ],
            members: {
              batchInferenceJobArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              batchInferenceJob: {
                type: "structure",
                members: {
                  jobName: {},
                  batchInferenceJobArn: {},
                  filterArn: {},
                  failureReason: {},
                  solutionVersionArn: {},
                  numResults: {
                    type: "integer"
                  },
                  jobInput: {
                    shape: "S5"
                  },
                  jobOutput: {
                    shape: "S9"
                  },
                  batchInferenceJobConfig: {
                    shape: "Sb"
                  },
                  roleArn: {},
                  status: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeCampaign: {
          input: {
            type: "structure",
            required: [
              "campaignArn"
            ],
            members: {
              campaignArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              campaign: {
                type: "structure",
                members: {
                  name: {},
                  campaignArn: {},
                  solutionVersionArn: {},
                  minProvisionedTPS: {
                    type: "integer"
                  },
                  campaignConfig: {
                    shape: "Si"
                  },
                  status: {},
                  failureReason: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  },
                  latestCampaignUpdate: {
                    type: "structure",
                    members: {
                      solutionVersionArn: {},
                      minProvisionedTPS: {
                        type: "integer"
                      },
                      campaignConfig: {
                        shape: "Si"
                      },
                      status: {},
                      failureReason: {},
                      creationDateTime: {
                        type: "timestamp"
                      },
                      lastUpdatedDateTime: {
                        type: "timestamp"
                      }
                    }
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeDataset: {
          input: {
            type: "structure",
            required: [
              "datasetArn"
            ],
            members: {
              datasetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              dataset: {
                type: "structure",
                members: {
                  name: {},
                  datasetArn: {},
                  datasetGroupArn: {},
                  datasetType: {},
                  schemaArn: {},
                  status: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeDatasetExportJob: {
          input: {
            type: "structure",
            required: [
              "datasetExportJobArn"
            ],
            members: {
              datasetExportJobArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              datasetExportJob: {
                type: "structure",
                members: {
                  jobName: {},
                  datasetExportJobArn: {},
                  datasetArn: {},
                  ingestionMode: {},
                  roleArn: {},
                  status: {},
                  jobOutput: {
                    shape: "Sp"
                  },
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  },
                  failureReason: {}
                }
              }
            }
          },
          idempotent: true
        },
        DescribeDatasetGroup: {
          input: {
            type: "structure",
            required: [
              "datasetGroupArn"
            ],
            members: {
              datasetGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              datasetGroup: {
                type: "structure",
                members: {
                  name: {},
                  datasetGroupArn: {},
                  status: {},
                  roleArn: {},
                  kmsKeyArn: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  },
                  failureReason: {}
                }
              }
            }
          },
          idempotent: true
        },
        DescribeDatasetImportJob: {
          input: {
            type: "structure",
            required: [
              "datasetImportJobArn"
            ],
            members: {
              datasetImportJobArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              datasetImportJob: {
                type: "structure",
                members: {
                  jobName: {},
                  datasetImportJobArn: {},
                  datasetArn: {},
                  dataSource: {
                    shape: "Su"
                  },
                  roleArn: {},
                  status: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  },
                  failureReason: {}
                }
              }
            }
          },
          idempotent: true
        },
        DescribeEventTracker: {
          input: {
            type: "structure",
            required: [
              "eventTrackerArn"
            ],
            members: {
              eventTrackerArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              eventTracker: {
                type: "structure",
                members: {
                  name: {},
                  eventTrackerArn: {},
                  accountId: {},
                  trackingId: {},
                  datasetGroupArn: {},
                  status: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeFeatureTransformation: {
          input: {
            type: "structure",
            required: [
              "featureTransformationArn"
            ],
            members: {
              featureTransformationArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              featureTransformation: {
                type: "structure",
                members: {
                  name: {},
                  featureTransformationArn: {},
                  defaultParameters: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  },
                  status: {}
                }
              }
            }
          },
          idempotent: true
        },
        DescribeFilter: {
          input: {
            type: "structure",
            required: [
              "filterArn"
            ],
            members: {
              filterArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              filter: {
                type: "structure",
                members: {
                  name: {},
                  filterArn: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  },
                  datasetGroupArn: {},
                  failureReason: {},
                  filterExpression: {
                    shape: "S10"
                  },
                  status: {}
                }
              }
            }
          },
          idempotent: true
        },
        DescribeRecipe: {
          input: {
            type: "structure",
            required: [
              "recipeArn"
            ],
            members: {
              recipeArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              recipe: {
                type: "structure",
                members: {
                  name: {},
                  recipeArn: {},
                  algorithmArn: {},
                  featureTransformationArn: {},
                  status: {},
                  description: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  recipeType: {},
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeSchema: {
          input: {
            type: "structure",
            required: [
              "schemaArn"
            ],
            members: {
              schemaArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              schema: {
                type: "structure",
                members: {
                  name: {},
                  schemaArn: {},
                  schema: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeSolution: {
          input: {
            type: "structure",
            required: [
              "solutionArn"
            ],
            members: {
              solutionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              solution: {
                type: "structure",
                members: {
                  name: {},
                  solutionArn: {},
                  performHPO: {
                    type: "boolean"
                  },
                  performAutoML: {
                    type: "boolean"
                  },
                  recipeArn: {},
                  datasetGroupArn: {},
                  eventType: {},
                  solutionConfig: {
                    shape: "S19"
                  },
                  autoMLResult: {
                    type: "structure",
                    members: {
                      bestRecipeArn: {}
                    }
                  },
                  status: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  },
                  latestSolutionVersion: {
                    shape: "S41"
                  }
                }
              }
            }
          },
          idempotent: true
        },
        DescribeSolutionVersion: {
          input: {
            type: "structure",
            required: [
              "solutionVersionArn"
            ],
            members: {
              solutionVersionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              solutionVersion: {
                type: "structure",
                members: {
                  solutionVersionArn: {},
                  solutionArn: {},
                  performHPO: {
                    type: "boolean"
                  },
                  performAutoML: {
                    type: "boolean"
                  },
                  recipeArn: {},
                  eventType: {},
                  datasetGroupArn: {},
                  solutionConfig: {
                    shape: "S19"
                  },
                  trainingHours: {
                    type: "double"
                  },
                  trainingMode: {},
                  tunedHPOParams: {
                    type: "structure",
                    members: {
                      algorithmHyperParameters: {
                        shape: "Sc"
                      }
                    }
                  },
                  status: {},
                  failureReason: {},
                  creationDateTime: {
                    type: "timestamp"
                  },
                  lastUpdatedDateTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          idempotent: true
        },
        GetSolutionMetrics: {
          input: {
            type: "structure",
            required: [
              "solutionVersionArn"
            ],
            members: {
              solutionVersionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              solutionVersionArn: {},
              metrics: {
                type: "map",
                key: {},
                value: {
                  type: "double"
                }
              }
            }
          }
        },
        ListBatchInferenceJobs: {
          input: {
            type: "structure",
            members: {
              solutionVersionArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              batchInferenceJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    batchInferenceJobArn: {},
                    jobName: {},
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    failureReason: {},
                    solutionVersionArn: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListCampaigns: {
          input: {
            type: "structure",
            members: {
              solutionArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              campaigns: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    campaignArn: {},
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    failureReason: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListDatasetExportJobs: {
          input: {
            type: "structure",
            members: {
              datasetArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetExportJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    datasetExportJobArn: {},
                    jobName: {},
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    failureReason: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListDatasetGroups: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    datasetGroupArn: {},
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    failureReason: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListDatasetImportJobs: {
          input: {
            type: "structure",
            members: {
              datasetArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasetImportJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    datasetImportJobArn: {},
                    jobName: {},
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    failureReason: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListDatasets: {
          input: {
            type: "structure",
            members: {
              datasetGroupArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              datasets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    datasetArn: {},
                    datasetType: {},
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListEventTrackers: {
          input: {
            type: "structure",
            members: {
              datasetGroupArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              eventTrackers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    eventTrackerArn: {},
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListFilters: {
          input: {
            type: "structure",
            members: {
              datasetGroupArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    filterArn: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    datasetGroupArn: {},
                    failureReason: {},
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListRecipes: {
          input: {
            type: "structure",
            members: {
              recipeProvider: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              recipes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    recipeArn: {},
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListSchemas: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              schemas: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    schemaArn: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListSolutionVersions: {
          input: {
            type: "structure",
            members: {
              solutionArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              solutionVersions: {
                type: "list",
                member: {
                  shape: "S41"
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListSolutions: {
          input: {
            type: "structure",
            members: {
              datasetGroupArn: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              solutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    solutionArn: {},
                    status: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        StopSolutionVersionCreation: {
          input: {
            type: "structure",
            required: [
              "solutionVersionArn"
            ],
            members: {
              solutionVersionArn: {}
            }
          },
          idempotent: true
        },
        UpdateCampaign: {
          input: {
            type: "structure",
            required: [
              "campaignArn"
            ],
            members: {
              campaignArn: {},
              solutionVersionArn: {},
              minProvisionedTPS: {
                type: "integer"
              },
              campaignConfig: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              campaignArn: {}
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S5: {
          type: "structure",
          required: [
            "s3DataSource"
          ],
          members: {
            s3DataSource: {
              shape: "S6"
            }
          }
        },
        S6: {
          type: "structure",
          required: [
            "path"
          ],
          members: {
            path: {},
            kmsKeyArn: {}
          }
        },
        S9: {
          type: "structure",
          required: [
            "s3DataDestination"
          ],
          members: {
            s3DataDestination: {
              shape: "S6"
            }
          }
        },
        Sb: {
          type: "structure",
          members: {
            itemExplorationConfig: {
              shape: "Sc"
            }
          }
        },
        Sc: {
          type: "map",
          key: {},
          value: {}
        },
        Si: {
          type: "structure",
          members: {
            itemExplorationConfig: {
              shape: "Sc"
            }
          }
        },
        Sp: {
          type: "structure",
          required: [
            "s3DataDestination"
          ],
          members: {
            s3DataDestination: {
              shape: "S6"
            }
          }
        },
        Su: {
          type: "structure",
          members: {
            dataLocation: {}
          }
        },
        S10: {
          type: "string",
          sensitive: true
        },
        S19: {
          type: "structure",
          members: {
            eventValueThreshold: {},
            hpoConfig: {
              type: "structure",
              members: {
                hpoObjective: {
                  type: "structure",
                  members: {
                    type: {},
                    metricName: {},
                    metricRegex: {}
                  }
                },
                hpoResourceConfig: {
                  type: "structure",
                  members: {
                    maxNumberOfTrainingJobs: {},
                    maxParallelTrainingJobs: {}
                  }
                },
                algorithmHyperParameterRanges: {
                  type: "structure",
                  members: {
                    integerHyperParameterRanges: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          minValue: {
                            type: "integer"
                          },
                          maxValue: {
                            type: "integer"
                          }
                        }
                      }
                    },
                    continuousHyperParameterRanges: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          minValue: {
                            type: "double"
                          },
                          maxValue: {
                            type: "double"
                          }
                        }
                      }
                    },
                    categoricalHyperParameterRanges: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          values: {
                            shape: "S1t"
                          }
                        }
                      }
                    }
                  }
                }
              }
            },
            algorithmHyperParameters: {
              shape: "Sc"
            },
            featureTransformationParameters: {
              type: "map",
              key: {},
              value: {}
            },
            autoMLConfig: {
              type: "structure",
              members: {
                metricName: {},
                recipeList: {
                  type: "list",
                  member: {}
                }
              }
            },
            optimizationObjective: {
              type: "structure",
              members: {
                itemAttribute: {},
                objectiveSensitivity: {}
              }
            }
          }
        },
        S1t: {
          type: "list",
          member: {}
        },
        S41: {
          type: "structure",
          members: {
            solutionVersionArn: {},
            status: {},
            creationDateTime: {
              type: "timestamp"
            },
            lastUpdatedDateTime: {
              type: "timestamp"
            },
            failureReason: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/personalize-2018-05-22.paginators.json
var require_personalize_2018_05_22_paginators = __commonJS({
  "node_modules/aws-sdk/apis/personalize-2018-05-22.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListBatchInferenceJobs: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "batchInferenceJobs"
        },
        ListCampaigns: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "campaigns"
        },
        ListDatasetExportJobs: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "datasetExportJobs"
        },
        ListDatasetGroups: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "datasetGroups"
        },
        ListDatasetImportJobs: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "datasetImportJobs"
        },
        ListDatasets: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "datasets"
        },
        ListEventTrackers: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "eventTrackers"
        },
        ListFilters: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "Filters"
        },
        ListRecipes: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "recipes"
        },
        ListSchemas: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "schemas"
        },
        ListSolutionVersions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "solutionVersions"
        },
        ListSolutions: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "solutions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/personalize.js
var require_personalize = __commonJS({
  "node_modules/aws-sdk/clients/personalize.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["personalize"] = {};
    AWS3.Personalize = Service.defineService("personalize", ["2018-05-22"]);
    Object.defineProperty(apiLoader.services["personalize"], "2018-05-22", {
      get: function get() {
        var model = require_personalize_2018_05_22_min();
        model.paginators = require_personalize_2018_05_22_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Personalize;
  }
});

// node_modules/aws-sdk/apis/personalize-events-2018-03-22.min.json
var require_personalize_events_2018_03_22_min = __commonJS({
  "node_modules/aws-sdk/apis/personalize-events-2018-03-22.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-03-22",
        endpointPrefix: "personalize-events",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Personalize Events",
        serviceId: "Personalize Events",
        signatureVersion: "v4",
        signingName: "personalize",
        uid: "personalize-events-2018-03-22"
      },
      operations: {
        PutEvents: {
          http: {
            requestUri: "/events"
          },
          input: {
            type: "structure",
            required: [
              "trackingId",
              "sessionId",
              "eventList"
            ],
            members: {
              trackingId: {},
              userId: {},
              sessionId: {},
              eventList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "eventType",
                    "sentAt"
                  ],
                  members: {
                    eventId: {},
                    eventType: {},
                    eventValue: {
                      type: "float"
                    },
                    itemId: {},
                    properties: {
                      jsonvalue: true
                    },
                    sentAt: {
                      type: "timestamp"
                    },
                    recommendationId: {},
                    impression: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        PutItems: {
          http: {
            requestUri: "/items"
          },
          input: {
            type: "structure",
            required: [
              "datasetArn",
              "items"
            ],
            members: {
              datasetArn: {},
              items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "itemId"
                  ],
                  members: {
                    itemId: {},
                    properties: {
                      jsonvalue: true
                    }
                  }
                }
              }
            }
          }
        },
        PutUsers: {
          http: {
            requestUri: "/users"
          },
          input: {
            type: "structure",
            required: [
              "datasetArn",
              "users"
            ],
            members: {
              datasetArn: {},
              users: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "userId"
                  ],
                  members: {
                    userId: {},
                    properties: {
                      jsonvalue: true
                    }
                  }
                }
              }
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/personalize-events-2018-03-22.paginators.json
var require_personalize_events_2018_03_22_paginators = __commonJS({
  "node_modules/aws-sdk/apis/personalize-events-2018-03-22.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/personalizeevents.js
var require_personalizeevents = __commonJS({
  "node_modules/aws-sdk/clients/personalizeevents.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["personalizeevents"] = {};
    AWS3.PersonalizeEvents = Service.defineService("personalizeevents", ["2018-03-22"]);
    Object.defineProperty(apiLoader.services["personalizeevents"], "2018-03-22", {
      get: function get() {
        var model = require_personalize_events_2018_03_22_min();
        model.paginators = require_personalize_events_2018_03_22_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.PersonalizeEvents;
  }
});

// node_modules/aws-sdk/apis/personalize-runtime-2018-05-22.min.json
var require_personalize_runtime_2018_05_22_min = __commonJS({
  "node_modules/aws-sdk/apis/personalize-runtime-2018-05-22.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-22",
        endpointPrefix: "personalize-runtime",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Personalize Runtime",
        serviceId: "Personalize Runtime",
        signatureVersion: "v4",
        signingName: "personalize",
        uid: "personalize-runtime-2018-05-22"
      },
      operations: {
        GetPersonalizedRanking: {
          http: {
            requestUri: "/personalize-ranking"
          },
          input: {
            type: "structure",
            required: [
              "campaignArn",
              "inputList",
              "userId"
            ],
            members: {
              campaignArn: {},
              inputList: {
                type: "list",
                member: {}
              },
              userId: {},
              context: {
                shape: "S6"
              },
              filterArn: {},
              filterValues: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              personalizedRanking: {
                shape: "Sd"
              },
              recommendationId: {}
            }
          },
          idempotent: true
        },
        GetRecommendations: {
          http: {
            requestUri: "/recommendations"
          },
          input: {
            type: "structure",
            required: [
              "campaignArn"
            ],
            members: {
              campaignArn: {},
              itemId: {},
              userId: {},
              numResults: {
                type: "integer"
              },
              context: {
                shape: "S6"
              },
              filterArn: {},
              filterValues: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              itemList: {
                shape: "Sd"
              },
              recommendationId: {}
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S6: {
          type: "map",
          key: {},
          value: {
            type: "string",
            sensitive: true
          }
        },
        S9: {
          type: "map",
          key: {},
          value: {
            type: "string",
            sensitive: true
          }
        },
        Sd: {
          type: "list",
          member: {
            type: "structure",
            members: {
              itemId: {},
              score: {
                type: "double"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/personalize-runtime-2018-05-22.paginators.json
var require_personalize_runtime_2018_05_22_paginators = __commonJS({
  "node_modules/aws-sdk/apis/personalize-runtime-2018-05-22.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/personalizeruntime.js
var require_personalizeruntime = __commonJS({
  "node_modules/aws-sdk/clients/personalizeruntime.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["personalizeruntime"] = {};
    AWS3.PersonalizeRuntime = Service.defineService("personalizeruntime", ["2018-05-22"]);
    Object.defineProperty(apiLoader.services["personalizeruntime"], "2018-05-22", {
      get: function get() {
        var model = require_personalize_runtime_2018_05_22_min();
        model.paginators = require_personalize_runtime_2018_05_22_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.PersonalizeRuntime;
  }
});

// node_modules/aws-sdk/apis/application-insights-2018-11-25.min.json
var require_application_insights_2018_11_25_min = __commonJS({
  "node_modules/aws-sdk/apis/application-insights-2018-11-25.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-11-25",
        endpointPrefix: "applicationinsights",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Application Insights",
        serviceFullName: "Amazon CloudWatch Application Insights",
        serviceId: "Application Insights",
        signatureVersion: "v4",
        signingName: "applicationinsights",
        targetPrefix: "EC2WindowsBarleyService",
        uid: "application-insights-2018-11-25"
      },
      operations: {
        CreateApplication: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName"
            ],
            members: {
              ResourceGroupName: {},
              OpsCenterEnabled: {
                type: "boolean"
              },
              CWEMonitorEnabled: {
                type: "boolean"
              },
              OpsItemSNSTopicArn: {},
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationInfo: {
                shape: "Sb"
              }
            }
          }
        },
        CreateComponent: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "ComponentName",
              "ResourceList"
            ],
            members: {
              ResourceGroupName: {},
              ComponentName: {},
              ResourceList: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateLogPattern: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "PatternSetName",
              "PatternName",
              "Pattern",
              "Rank"
            ],
            members: {
              ResourceGroupName: {},
              PatternSetName: {},
              PatternName: {},
              Pattern: {},
              Rank: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LogPattern: {
                shape: "Sp"
              },
              ResourceGroupName: {}
            }
          }
        },
        DeleteApplication: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName"
            ],
            members: {
              ResourceGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteComponent: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "ComponentName"
            ],
            members: {
              ResourceGroupName: {},
              ComponentName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLogPattern: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "PatternSetName",
              "PatternName"
            ],
            members: {
              ResourceGroupName: {},
              PatternSetName: {},
              PatternName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeApplication: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName"
            ],
            members: {
              ResourceGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationInfo: {
                shape: "Sb"
              }
            }
          }
        },
        DescribeComponent: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "ComponentName"
            ],
            members: {
              ResourceGroupName: {},
              ComponentName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationComponent: {
                shape: "S11"
              },
              ResourceList: {
                shape: "Sg"
              }
            }
          }
        },
        DescribeComponentConfiguration: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "ComponentName"
            ],
            members: {
              ResourceGroupName: {},
              ComponentName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Monitor: {
                type: "boolean"
              },
              Tier: {},
              ComponentConfiguration: {}
            }
          }
        },
        DescribeComponentConfigurationRecommendation: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "ComponentName",
              "Tier"
            ],
            members: {
              ResourceGroupName: {},
              ComponentName: {},
              Tier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ComponentConfiguration: {}
            }
          }
        },
        DescribeLogPattern: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "PatternSetName",
              "PatternName"
            ],
            members: {
              ResourceGroupName: {},
              PatternSetName: {},
              PatternName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceGroupName: {},
              LogPattern: {
                shape: "Sp"
              }
            }
          }
        },
        DescribeObservation: {
          input: {
            type: "structure",
            required: [
              "ObservationId"
            ],
            members: {
              ObservationId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Observation: {
                shape: "S1k"
              }
            }
          }
        },
        DescribeProblem: {
          input: {
            type: "structure",
            required: [
              "ProblemId"
            ],
            members: {
              ProblemId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Problem: {
                shape: "S2w"
              }
            }
          }
        },
        DescribeProblemObservations: {
          input: {
            type: "structure",
            required: [
              "ProblemId"
            ],
            members: {
              ProblemId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RelatedObservations: {
                type: "structure",
                members: {
                  ObservationList: {
                    type: "list",
                    member: {
                      shape: "S1k"
                    }
                  }
                }
              }
            }
          }
        },
        ListApplications: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationInfoList: {
                type: "list",
                member: {
                  shape: "Sb"
                }
              },
              NextToken: {}
            }
          }
        },
        ListComponents: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName"
            ],
            members: {
              ResourceGroupName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationComponentList: {
                type: "list",
                member: {
                  shape: "S11"
                }
              },
              NextToken: {}
            }
          }
        },
        ListConfigurationHistory: {
          input: {
            type: "structure",
            members: {
              ResourceGroupName: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              EventStatus: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EventList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MonitoredResourceARN: {},
                    EventStatus: {},
                    EventResourceType: {},
                    EventTime: {
                      type: "timestamp"
                    },
                    EventDetail: {},
                    EventResourceName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLogPatternSets: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName"
            ],
            members: {
              ResourceGroupName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceGroupName: {},
              LogPatternSets: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListLogPatterns: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName"
            ],
            members: {
              ResourceGroupName: {},
              PatternSetName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceGroupName: {},
              LogPatterns: {
                type: "list",
                member: {
                  shape: "Sp"
                }
              },
              NextToken: {}
            }
          }
        },
        ListProblems: {
          input: {
            type: "structure",
            members: {
              ResourceGroupName: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProblemList: {
                type: "list",
                member: {
                  shape: "S2w"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S6"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApplication: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName"
            ],
            members: {
              ResourceGroupName: {},
              OpsCenterEnabled: {
                type: "boolean"
              },
              CWEMonitorEnabled: {
                type: "boolean"
              },
              OpsItemSNSTopicArn: {},
              RemoveSNSTopic: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApplicationInfo: {
                shape: "Sb"
              }
            }
          }
        },
        UpdateComponent: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "ComponentName"
            ],
            members: {
              ResourceGroupName: {},
              ComponentName: {},
              NewComponentName: {},
              ResourceList: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateComponentConfiguration: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "ComponentName"
            ],
            members: {
              ResourceGroupName: {},
              ComponentName: {},
              Monitor: {
                type: "boolean"
              },
              Tier: {},
              ComponentConfiguration: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLogPattern: {
          input: {
            type: "structure",
            required: [
              "ResourceGroupName",
              "PatternSetName",
              "PatternName"
            ],
            members: {
              ResourceGroupName: {},
              PatternSetName: {},
              PatternName: {},
              Pattern: {},
              Rank: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceGroupName: {},
              LogPattern: {
                shape: "Sp"
              }
            }
          }
        }
      },
      shapes: {
        S6: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sb: {
          type: "structure",
          members: {
            ResourceGroupName: {},
            LifeCycle: {},
            OpsItemSNSTopicArn: {},
            OpsCenterEnabled: {
              type: "boolean"
            },
            CWEMonitorEnabled: {
              type: "boolean"
            },
            Remarks: {}
          }
        },
        Sg: {
          type: "list",
          member: {}
        },
        Sp: {
          type: "structure",
          members: {
            PatternSetName: {},
            PatternName: {},
            Pattern: {},
            Rank: {
              type: "integer"
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            ComponentName: {},
            ComponentRemarks: {},
            ResourceType: {},
            OsType: {},
            Tier: {},
            Monitor: {
              type: "boolean"
            },
            DetectedWorkload: {
              type: "map",
              key: {},
              value: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        S1k: {
          type: "structure",
          members: {
            Id: {},
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            SourceType: {},
            SourceARN: {},
            LogGroup: {},
            LineTime: {
              type: "timestamp"
            },
            LogText: {},
            LogFilter: {},
            MetricNamespace: {},
            MetricName: {},
            Unit: {},
            Value: {
              type: "double"
            },
            CloudWatchEventId: {},
            CloudWatchEventSource: {},
            CloudWatchEventDetailType: {},
            HealthEventArn: {},
            HealthService: {},
            HealthEventTypeCode: {},
            HealthEventTypeCategory: {},
            HealthEventDescription: {},
            CodeDeployDeploymentId: {},
            CodeDeployDeploymentGroup: {},
            CodeDeployState: {},
            CodeDeployApplication: {},
            CodeDeployInstanceGroupId: {},
            Ec2State: {},
            RdsEventCategories: {},
            RdsEventMessage: {},
            S3EventName: {},
            StatesExecutionArn: {},
            StatesArn: {},
            StatesStatus: {},
            StatesInput: {},
            EbsEvent: {},
            EbsResult: {},
            EbsCause: {},
            EbsRequestId: {},
            XRayFaultPercent: {
              type: "integer"
            },
            XRayThrottlePercent: {
              type: "integer"
            },
            XRayErrorPercent: {
              type: "integer"
            },
            XRayRequestCount: {
              type: "integer"
            },
            XRayRequestAverageLatency: {
              type: "long"
            },
            XRayNodeName: {},
            XRayNodeType: {}
          }
        },
        S2w: {
          type: "structure",
          members: {
            Id: {},
            Title: {},
            Insights: {},
            Status: {},
            AffectedResource: {},
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            SeverityLevel: {},
            ResourceGroupName: {},
            Feedback: {
              type: "map",
              key: {},
              value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/application-insights-2018-11-25.paginators.json
var require_application_insights_2018_11_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/application-insights-2018-11-25.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListApplications: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListComponents: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListConfigurationHistory: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListLogPatternSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListLogPatterns: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListProblems: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/applicationinsights.js
var require_applicationinsights = __commonJS({
  "node_modules/aws-sdk/clients/applicationinsights.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["applicationinsights"] = {};
    AWS3.ApplicationInsights = Service.defineService("applicationinsights", ["2018-11-25"]);
    Object.defineProperty(apiLoader.services["applicationinsights"], "2018-11-25", {
      get: function get() {
        var model = require_application_insights_2018_11_25_min();
        model.paginators = require_application_insights_2018_11_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ApplicationInsights;
  }
});

// node_modules/aws-sdk/apis/service-quotas-2019-06-24.min.json
var require_service_quotas_2019_06_24_min = __commonJS({
  "node_modules/aws-sdk/apis/service-quotas-2019-06-24.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-06-24",
        endpointPrefix: "servicequotas",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Service Quotas",
        serviceId: "Service Quotas",
        signatureVersion: "v4",
        targetPrefix: "ServiceQuotasV20190624",
        uid: "service-quotas-2019-06-24"
      },
      operations: {
        AssociateServiceQuotaTemplate: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteServiceQuotaIncreaseRequestFromTemplate: {
          input: {
            type: "structure",
            required: [
              "ServiceCode",
              "QuotaCode",
              "AwsRegion"
            ],
            members: {
              ServiceCode: {},
              QuotaCode: {},
              AwsRegion: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateServiceQuotaTemplate: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAWSDefaultServiceQuota: {
          input: {
            type: "structure",
            required: [
              "ServiceCode",
              "QuotaCode"
            ],
            members: {
              ServiceCode: {},
              QuotaCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Quota: {
                shape: "Sc"
              }
            }
          }
        },
        GetAssociationForServiceQuotaTemplate: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              ServiceQuotaTemplateAssociationStatus: {}
            }
          }
        },
        GetRequestedServiceQuotaChange: {
          input: {
            type: "structure",
            required: [
              "RequestId"
            ],
            members: {
              RequestId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RequestedQuota: {
                shape: "S13"
              }
            }
          }
        },
        GetServiceQuota: {
          input: {
            type: "structure",
            required: [
              "ServiceCode",
              "QuotaCode"
            ],
            members: {
              ServiceCode: {},
              QuotaCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Quota: {
                shape: "Sc"
              }
            }
          }
        },
        GetServiceQuotaIncreaseRequestFromTemplate: {
          input: {
            type: "structure",
            required: [
              "ServiceCode",
              "QuotaCode",
              "AwsRegion"
            ],
            members: {
              ServiceCode: {},
              QuotaCode: {},
              AwsRegion: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceQuotaIncreaseRequestInTemplate: {
                shape: "S1c"
              }
            }
          }
        },
        ListAWSDefaultServiceQuotas: {
          input: {
            type: "structure",
            required: [
              "ServiceCode"
            ],
            members: {
              ServiceCode: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Quotas: {
                shape: "S1h"
              }
            }
          }
        },
        ListRequestedServiceQuotaChangeHistory: {
          input: {
            type: "structure",
            members: {
              ServiceCode: {},
              Status: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              RequestedQuotas: {
                shape: "S1k"
              }
            }
          }
        },
        ListRequestedServiceQuotaChangeHistoryByQuota: {
          input: {
            type: "structure",
            required: [
              "ServiceCode",
              "QuotaCode"
            ],
            members: {
              ServiceCode: {},
              QuotaCode: {},
              Status: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              RequestedQuotas: {
                shape: "S1k"
              }
            }
          }
        },
        ListServiceQuotaIncreaseRequestsInTemplate: {
          input: {
            type: "structure",
            members: {
              ServiceCode: {},
              AwsRegion: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceQuotaIncreaseRequestInTemplateList: {
                type: "list",
                member: {
                  shape: "S1c"
                }
              },
              NextToken: {}
            }
          }
        },
        ListServiceQuotas: {
          input: {
            type: "structure",
            required: [
              "ServiceCode"
            ],
            members: {
              ServiceCode: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Quotas: {
                shape: "S1h"
              }
            }
          }
        },
        ListServices: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Services: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ServiceCode: {},
                    ServiceName: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                type: "list",
                member: {
                  shape: "S20"
                }
              }
            }
          }
        },
        PutServiceQuotaIncreaseRequestIntoTemplate: {
          input: {
            type: "structure",
            required: [
              "QuotaCode",
              "ServiceCode",
              "AwsRegion",
              "DesiredValue"
            ],
            members: {
              QuotaCode: {},
              ServiceCode: {},
              AwsRegion: {},
              DesiredValue: {
                type: "double"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceQuotaIncreaseRequestInTemplate: {
                shape: "S1c"
              }
            }
          }
        },
        RequestServiceQuotaIncrease: {
          input: {
            type: "structure",
            required: [
              "ServiceCode",
              "QuotaCode",
              "DesiredValue"
            ],
            members: {
              ServiceCode: {},
              QuotaCode: {},
              DesiredValue: {
                type: "double"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RequestedQuota: {
                shape: "S13"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                type: "list",
                member: {
                  shape: "S20"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sc: {
          type: "structure",
          members: {
            ServiceCode: {},
            ServiceName: {},
            QuotaArn: {},
            QuotaCode: {},
            QuotaName: {},
            Value: {
              type: "double"
            },
            Unit: {},
            Adjustable: {
              type: "boolean"
            },
            GlobalQuota: {
              type: "boolean"
            },
            UsageMetric: {
              type: "structure",
              members: {
                MetricNamespace: {},
                MetricName: {},
                MetricDimensions: {
                  type: "map",
                  key: {},
                  value: {}
                },
                MetricStatisticRecommendation: {}
              }
            },
            Period: {
              type: "structure",
              members: {
                PeriodValue: {
                  type: "integer"
                },
                PeriodUnit: {}
              }
            },
            ErrorReason: {
              type: "structure",
              members: {
                ErrorCode: {},
                ErrorMessage: {}
              }
            }
          }
        },
        S13: {
          type: "structure",
          members: {
            Id: {},
            CaseId: {},
            ServiceCode: {},
            ServiceName: {},
            QuotaCode: {},
            QuotaName: {},
            DesiredValue: {
              type: "double"
            },
            Status: {},
            Created: {
              type: "timestamp"
            },
            LastUpdated: {
              type: "timestamp"
            },
            Requester: {},
            QuotaArn: {},
            GlobalQuota: {
              type: "boolean"
            },
            Unit: {}
          }
        },
        S1c: {
          type: "structure",
          members: {
            ServiceCode: {},
            ServiceName: {},
            QuotaCode: {},
            QuotaName: {},
            DesiredValue: {
              type: "double"
            },
            AwsRegion: {},
            Unit: {},
            GlobalQuota: {
              type: "boolean"
            }
          }
        },
        S1h: {
          type: "list",
          member: {
            shape: "Sc"
          }
        },
        S1k: {
          type: "list",
          member: {
            shape: "S13"
          }
        },
        S20: {
          type: "structure",
          required: [
            "Key",
            "Value"
          ],
          members: {
            Key: {},
            Value: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/service-quotas-2019-06-24.paginators.json
var require_service_quotas_2019_06_24_paginators = __commonJS({
  "node_modules/aws-sdk/apis/service-quotas-2019-06-24.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAWSDefaultServiceQuotas: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Quotas"
        },
        ListRequestedServiceQuotaChangeHistory: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "RequestedQuotas"
        },
        ListRequestedServiceQuotaChangeHistoryByQuota: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "RequestedQuotas"
        },
        ListServiceQuotaIncreaseRequestsInTemplate: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ServiceQuotaIncreaseRequestInTemplateList"
        },
        ListServiceQuotas: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Quotas"
        },
        ListServices: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Services"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/servicequotas.js
var require_servicequotas = __commonJS({
  "node_modules/aws-sdk/clients/servicequotas.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["servicequotas"] = {};
    AWS3.ServiceQuotas = Service.defineService("servicequotas", ["2019-06-24"]);
    Object.defineProperty(apiLoader.services["servicequotas"], "2019-06-24", {
      get: function get() {
        var model = require_service_quotas_2019_06_24_min();
        model.paginators = require_service_quotas_2019_06_24_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ServiceQuotas;
  }
});

// node_modules/aws-sdk/apis/ec2-instance-connect-2018-04-02.min.json
var require_ec2_instance_connect_2018_04_02_min = __commonJS({
  "node_modules/aws-sdk/apis/ec2-instance-connect-2018-04-02.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-04-02",
        endpointPrefix: "ec2-instance-connect",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "EC2 Instance Connect",
        serviceFullName: "AWS EC2 Instance Connect",
        serviceId: "EC2 Instance Connect",
        signatureVersion: "v4",
        targetPrefix: "AWSEC2InstanceConnectService",
        uid: "ec2-instance-connect-2018-04-02"
      },
      operations: {
        SendSSHPublicKey: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "InstanceOSUser",
              "SSHPublicKey",
              "AvailabilityZone"
            ],
            members: {
              InstanceId: {},
              InstanceOSUser: {},
              SSHPublicKey: {},
              AvailabilityZone: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Success: {
                type: "boolean"
              }
            }
          }
        },
        SendSerialConsoleSSHPublicKey: {
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "SSHPublicKey"
            ],
            members: {
              InstanceId: {},
              SerialPort: {
                type: "integer"
              },
              SSHPublicKey: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RequestId: {},
              Success: {
                type: "boolean"
              }
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/ec2-instance-connect-2018-04-02.paginators.json
var require_ec2_instance_connect_2018_04_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ec2-instance-connect-2018-04-02.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/ec2instanceconnect.js
var require_ec2instanceconnect = __commonJS({
  "node_modules/aws-sdk/clients/ec2instanceconnect.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["ec2instanceconnect"] = {};
    AWS3.EC2InstanceConnect = Service.defineService("ec2instanceconnect", ["2018-04-02"]);
    Object.defineProperty(apiLoader.services["ec2instanceconnect"], "2018-04-02", {
      get: function get() {
        var model = require_ec2_instance_connect_2018_04_02_min();
        model.paginators = require_ec2_instance_connect_2018_04_02_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.EC2InstanceConnect;
  }
});

// node_modules/aws-sdk/apis/eventbridge-2015-10-07.min.json
var require_eventbridge_2015_10_07_min = __commonJS({
  "node_modules/aws-sdk/apis/eventbridge-2015-10-07.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2015-10-07",
        endpointPrefix: "events",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon EventBridge",
        serviceId: "EventBridge",
        signatureVersion: "v4",
        targetPrefix: "AWSEvents",
        uid: "eventbridge-2015-10-07"
      },
      operations: {
        ActivateEventSource: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        CancelReplay: {
          input: {
            type: "structure",
            required: [
              "ReplayName"
            ],
            members: {
              ReplayName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplayArn: {},
              State: {},
              StateReason: {}
            }
          }
        },
        CreateApiDestination: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ConnectionArn",
              "InvocationEndpoint",
              "HttpMethod"
            ],
            members: {
              Name: {},
              Description: {},
              ConnectionArn: {},
              InvocationEndpoint: {},
              HttpMethod: {},
              InvocationRateLimitPerSecond: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApiDestinationArn: {},
              ApiDestinationState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateArchive: {
          input: {
            type: "structure",
            required: [
              "ArchiveName",
              "EventSourceArn"
            ],
            members: {
              ArchiveName: {},
              EventSourceArn: {},
              Description: {},
              EventPattern: {},
              RetentionDays: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ArchiveArn: {},
              State: {},
              StateReason: {},
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateConnection: {
          input: {
            type: "structure",
            required: [
              "Name",
              "AuthorizationType",
              "AuthParameters"
            ],
            members: {
              Name: {},
              Description: {},
              AuthorizationType: {},
              AuthParameters: {
                type: "structure",
                members: {
                  BasicAuthParameters: {
                    type: "structure",
                    required: [
                      "Username",
                      "Password"
                    ],
                    members: {
                      Username: {},
                      Password: {}
                    }
                  },
                  OAuthParameters: {
                    type: "structure",
                    required: [
                      "ClientParameters",
                      "AuthorizationEndpoint",
                      "HttpMethod"
                    ],
                    members: {
                      ClientParameters: {
                        type: "structure",
                        required: [
                          "ClientID",
                          "ClientSecret"
                        ],
                        members: {
                          ClientID: {},
                          ClientSecret: {}
                        }
                      },
                      AuthorizationEndpoint: {},
                      HttpMethod: {},
                      OAuthHttpParameters: {
                        shape: "S14"
                      }
                    }
                  },
                  ApiKeyAuthParameters: {
                    type: "structure",
                    required: [
                      "ApiKeyName",
                      "ApiKeyValue"
                    ],
                    members: {
                      ApiKeyName: {},
                      ApiKeyValue: {}
                    }
                  },
                  InvocationHttpParameters: {
                    shape: "S14"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionArn: {},
              ConnectionState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateEventBus: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              EventSourceName: {},
              Tags: {
                shape: "S1m"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventBusArn: {}
            }
          }
        },
        CreatePartnerEventSource: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Account"
            ],
            members: {
              Name: {},
              Account: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EventSourceArn: {}
            }
          }
        },
        DeactivateEventSource: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DeauthorizeConnection: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionArn: {},
              ConnectionState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastAuthorizedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteApiDestination: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteArchive: {
          input: {
            type: "structure",
            required: [
              "ArchiveName"
            ],
            members: {
              ArchiveName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteConnection: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionArn: {},
              ConnectionState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastAuthorizedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteEventBus: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DeletePartnerEventSource: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Account"
            ],
            members: {
              Name: {},
              Account: {}
            }
          }
        },
        DeleteRule: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              EventBusName: {},
              Force: {
                type: "boolean"
              }
            }
          }
        },
        DescribeApiDestination: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ApiDestinationArn: {},
              Name: {},
              Description: {},
              ApiDestinationState: {},
              ConnectionArn: {},
              InvocationEndpoint: {},
              HttpMethod: {},
              InvocationRateLimitPerSecond: {
                type: "integer"
              },
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeArchive: {
          input: {
            type: "structure",
            required: [
              "ArchiveName"
            ],
            members: {
              ArchiveName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ArchiveArn: {},
              ArchiveName: {},
              EventSourceArn: {},
              Description: {},
              EventPattern: {},
              State: {},
              StateReason: {},
              RetentionDays: {
                type: "integer"
              },
              SizeBytes: {
                type: "long"
              },
              EventCount: {
                type: "long"
              },
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeConnection: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionArn: {},
              Name: {},
              Description: {},
              ConnectionState: {},
              StateReason: {},
              AuthorizationType: {},
              SecretArn: {},
              AuthParameters: {
                type: "structure",
                members: {
                  BasicAuthParameters: {
                    type: "structure",
                    members: {
                      Username: {}
                    }
                  },
                  OAuthParameters: {
                    type: "structure",
                    members: {
                      ClientParameters: {
                        type: "structure",
                        members: {
                          ClientID: {}
                        }
                      },
                      AuthorizationEndpoint: {},
                      HttpMethod: {},
                      OAuthHttpParameters: {
                        shape: "S14"
                      }
                    }
                  },
                  ApiKeyAuthParameters: {
                    type: "structure",
                    members: {
                      ApiKeyName: {}
                    }
                  },
                  InvocationHttpParameters: {
                    shape: "S14"
                  }
                }
              },
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastAuthorizedTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeEventBus: {
          input: {
            type: "structure",
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Arn: {},
              Policy: {}
            }
          }
        },
        DescribeEventSource: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreatedBy: {},
              CreationTime: {
                type: "timestamp"
              },
              ExpirationTime: {
                type: "timestamp"
              },
              Name: {},
              State: {}
            }
          }
        },
        DescribePartnerEventSource: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Name: {}
            }
          }
        },
        DescribeReplay: {
          input: {
            type: "structure",
            required: [
              "ReplayName"
            ],
            members: {
              ReplayName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ReplayName: {},
              ReplayArn: {},
              Description: {},
              State: {},
              StateReason: {},
              EventSourceArn: {},
              Destination: {
                shape: "S2w"
              },
              EventStartTime: {
                type: "timestamp"
              },
              EventEndTime: {
                type: "timestamp"
              },
              EventLastReplayedTime: {
                type: "timestamp"
              },
              ReplayStartTime: {
                type: "timestamp"
              },
              ReplayEndTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeRule: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              EventBusName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Arn: {},
              EventPattern: {},
              ScheduleExpression: {},
              State: {},
              Description: {},
              RoleArn: {},
              ManagedBy: {},
              EventBusName: {},
              CreatedBy: {}
            }
          }
        },
        DisableRule: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              EventBusName: {}
            }
          }
        },
        EnableRule: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              EventBusName: {}
            }
          }
        },
        ListApiDestinations: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              ConnectionArn: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApiDestinations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApiDestinationArn: {},
                    Name: {},
                    ApiDestinationState: {},
                    ConnectionArn: {},
                    InvocationEndpoint: {},
                    HttpMethod: {},
                    InvocationRateLimitPerSecond: {
                      type: "integer"
                    },
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListArchives: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              EventSourceArn: {},
              State: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Archives: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ArchiveName: {},
                    EventSourceArn: {},
                    State: {},
                    StateReason: {},
                    RetentionDays: {
                      type: "integer"
                    },
                    SizeBytes: {
                      type: "long"
                    },
                    EventCount: {
                      type: "long"
                    },
                    CreationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListConnections: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              ConnectionState: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connections: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConnectionArn: {},
                    Name: {},
                    ConnectionState: {},
                    StateReason: {},
                    AuthorizationType: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModifiedTime: {
                      type: "timestamp"
                    },
                    LastAuthorizedTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEventBuses: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventBuses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Arn: {},
                    Policy: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEventSources: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventSources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreatedBy: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    ExpirationTime: {
                      type: "timestamp"
                    },
                    Name: {},
                    State: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPartnerEventSourceAccounts: {
          input: {
            type: "structure",
            required: [
              "EventSourceName"
            ],
            members: {
              EventSourceName: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PartnerEventSourceAccounts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Account: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    ExpirationTime: {
                      type: "timestamp"
                    },
                    State: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPartnerEventSources: {
          input: {
            type: "structure",
            required: [
              "NamePrefix"
            ],
            members: {
              NamePrefix: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PartnerEventSources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListReplays: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              State: {},
              EventSourceArn: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Replays: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReplayName: {},
                    EventSourceArn: {},
                    State: {},
                    StateReason: {},
                    EventStartTime: {
                      type: "timestamp"
                    },
                    EventEndTime: {
                      type: "timestamp"
                    },
                    EventLastReplayedTime: {
                      type: "timestamp"
                    },
                    ReplayStartTime: {
                      type: "timestamp"
                    },
                    ReplayEndTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRuleNamesByTarget: {
          input: {
            type: "structure",
            required: [
              "TargetArn"
            ],
            members: {
              TargetArn: {},
              EventBusName: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RuleNames: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListRules: {
          input: {
            type: "structure",
            members: {
              NamePrefix: {},
              EventBusName: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Rules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Arn: {},
                    EventPattern: {},
                    State: {},
                    Description: {},
                    ScheduleExpression: {},
                    RoleArn: {},
                    ManagedBy: {},
                    EventBusName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S1m"
              }
            }
          }
        },
        ListTargetsByRule: {
          input: {
            type: "structure",
            required: [
              "Rule"
            ],
            members: {
              Rule: {},
              EventBusName: {},
              NextToken: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Targets: {
                shape: "S4l"
              },
              NextToken: {}
            }
          }
        },
        PutEvents: {
          input: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Time: {
                      type: "timestamp"
                    },
                    Source: {},
                    Resources: {
                      shape: "S6j"
                    },
                    DetailType: {},
                    Detail: {},
                    EventBusName: {},
                    TraceHeader: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEntryCount: {
                type: "integer"
              },
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        PutPartnerEvents: {
          input: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Time: {
                      type: "timestamp"
                    },
                    Source: {},
                    Resources: {
                      shape: "S6j"
                    },
                    DetailType: {},
                    Detail: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEntryCount: {
                type: "integer"
              },
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        PutPermission: {
          input: {
            type: "structure",
            members: {
              EventBusName: {},
              Action: {},
              Principal: {},
              StatementId: {},
              Condition: {
                type: "structure",
                required: [
                  "Type",
                  "Key",
                  "Value"
                ],
                members: {
                  Type: {},
                  Key: {},
                  Value: {}
                }
              },
              Policy: {}
            }
          }
        },
        PutRule: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              ScheduleExpression: {},
              EventPattern: {},
              State: {},
              Description: {},
              RoleArn: {},
              Tags: {
                shape: "S1m"
              },
              EventBusName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RuleArn: {}
            }
          }
        },
        PutTargets: {
          input: {
            type: "structure",
            required: [
              "Rule",
              "Targets"
            ],
            members: {
              Rule: {},
              EventBusName: {},
              Targets: {
                shape: "S4l"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEntryCount: {
                type: "integer"
              },
              FailedEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TargetId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        RemovePermission: {
          input: {
            type: "structure",
            members: {
              StatementId: {},
              RemoveAllPermissions: {
                type: "boolean"
              },
              EventBusName: {}
            }
          }
        },
        RemoveTargets: {
          input: {
            type: "structure",
            required: [
              "Rule",
              "Ids"
            ],
            members: {
              Rule: {},
              EventBusName: {},
              Ids: {
                type: "list",
                member: {}
              },
              Force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedEntryCount: {
                type: "integer"
              },
              FailedEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TargetId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        StartReplay: {
          input: {
            type: "structure",
            required: [
              "ReplayName",
              "EventSourceArn",
              "EventStartTime",
              "EventEndTime",
              "Destination"
            ],
            members: {
              ReplayName: {},
              Description: {},
              EventSourceArn: {},
              EventStartTime: {
                type: "timestamp"
              },
              EventEndTime: {
                type: "timestamp"
              },
              Destination: {
                shape: "S2w"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReplayArn: {},
              State: {},
              StateReason: {},
              ReplayStartTime: {
                type: "timestamp"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S1m"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TestEventPattern: {
          input: {
            type: "structure",
            required: [
              "EventPattern",
              "Event"
            ],
            members: {
              EventPattern: {},
              Event: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Result: {
                type: "boolean"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApiDestination: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              ConnectionArn: {},
              InvocationEndpoint: {},
              HttpMethod: {},
              InvocationRateLimitPerSecond: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ApiDestinationArn: {},
              ApiDestinationState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateArchive: {
          input: {
            type: "structure",
            required: [
              "ArchiveName"
            ],
            members: {
              ArchiveName: {},
              Description: {},
              EventPattern: {},
              RetentionDays: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ArchiveArn: {},
              State: {},
              StateReason: {},
              CreationTime: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateConnection: {
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              AuthorizationType: {},
              AuthParameters: {
                type: "structure",
                members: {
                  BasicAuthParameters: {
                    type: "structure",
                    members: {
                      Username: {},
                      Password: {}
                    }
                  },
                  OAuthParameters: {
                    type: "structure",
                    members: {
                      ClientParameters: {
                        type: "structure",
                        members: {
                          ClientID: {},
                          ClientSecret: {}
                        }
                      },
                      AuthorizationEndpoint: {},
                      HttpMethod: {},
                      OAuthHttpParameters: {
                        shape: "S14"
                      }
                    }
                  },
                  ApiKeyAuthParameters: {
                    type: "structure",
                    members: {
                      ApiKeyName: {},
                      ApiKeyValue: {}
                    }
                  },
                  InvocationHttpParameters: {
                    shape: "S14"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConnectionArn: {},
              ConnectionState: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModifiedTime: {
                type: "timestamp"
              },
              LastAuthorizedTime: {
                type: "timestamp"
              }
            }
          }
        }
      },
      shapes: {
        S14: {
          type: "structure",
          members: {
            HeaderParameters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {},
                  IsValueSecret: {
                    type: "boolean"
                  }
                }
              }
            },
            QueryStringParameters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {},
                  IsValueSecret: {
                    type: "boolean"
                  }
                }
              }
            },
            BodyParameters: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Key: {},
                  Value: {},
                  IsValueSecret: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S1m: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S2w: {
          type: "structure",
          required: [
            "Arn"
          ],
          members: {
            Arn: {},
            FilterArns: {
              type: "list",
              member: {}
            }
          }
        },
        S4l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Id",
              "Arn"
            ],
            members: {
              Id: {},
              Arn: {},
              RoleArn: {},
              Input: {},
              InputPath: {},
              InputTransformer: {
                type: "structure",
                required: [
                  "InputTemplate"
                ],
                members: {
                  InputPathsMap: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  InputTemplate: {}
                }
              },
              KinesisParameters: {
                type: "structure",
                required: [
                  "PartitionKeyPath"
                ],
                members: {
                  PartitionKeyPath: {}
                }
              },
              RunCommandParameters: {
                type: "structure",
                required: [
                  "RunCommandTargets"
                ],
                members: {
                  RunCommandTargets: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Key",
                        "Values"
                      ],
                      members: {
                        Key: {},
                        Values: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                }
              },
              EcsParameters: {
                type: "structure",
                required: [
                  "TaskDefinitionArn"
                ],
                members: {
                  TaskDefinitionArn: {},
                  TaskCount: {
                    type: "integer"
                  },
                  LaunchType: {},
                  NetworkConfiguration: {
                    type: "structure",
                    members: {
                      awsvpcConfiguration: {
                        type: "structure",
                        required: [
                          "Subnets"
                        ],
                        members: {
                          Subnets: {
                            shape: "S57"
                          },
                          SecurityGroups: {
                            shape: "S57"
                          },
                          AssignPublicIp: {}
                        }
                      }
                    }
                  },
                  PlatformVersion: {},
                  Group: {},
                  CapacityProviderStrategy: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "capacityProvider"
                      ],
                      members: {
                        capacityProvider: {},
                        weight: {
                          type: "integer"
                        },
                        base: {
                          type: "integer"
                        }
                      }
                    }
                  },
                  EnableECSManagedTags: {
                    type: "boolean"
                  },
                  EnableExecuteCommand: {
                    type: "boolean"
                  },
                  PlacementConstraints: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        type: {},
                        expression: {}
                      }
                    }
                  },
                  PlacementStrategy: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        type: {},
                        field: {}
                      }
                    }
                  },
                  PropagateTags: {},
                  ReferenceId: {},
                  Tags: {
                    shape: "S1m"
                  }
                }
              },
              BatchParameters: {
                type: "structure",
                required: [
                  "JobDefinition",
                  "JobName"
                ],
                members: {
                  JobDefinition: {},
                  JobName: {},
                  ArrayProperties: {
                    type: "structure",
                    members: {
                      Size: {
                        type: "integer"
                      }
                    }
                  },
                  RetryStrategy: {
                    type: "structure",
                    members: {
                      Attempts: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              SqsParameters: {
                type: "structure",
                members: {
                  MessageGroupId: {}
                }
              },
              HttpParameters: {
                type: "structure",
                members: {
                  PathParameterValues: {
                    type: "list",
                    member: {}
                  },
                  HeaderParameters: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  QueryStringParameters: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              },
              RedshiftDataParameters: {
                type: "structure",
                required: [
                  "Database",
                  "Sql"
                ],
                members: {
                  SecretManagerArn: {},
                  Database: {},
                  DbUser: {},
                  Sql: {},
                  StatementName: {},
                  WithEvent: {
                    type: "boolean"
                  }
                }
              },
              SageMakerPipelineParameters: {
                type: "structure",
                members: {
                  PipelineParameterList: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "Name",
                        "Value"
                      ],
                      members: {
                        Name: {},
                        Value: {}
                      }
                    }
                  }
                }
              },
              DeadLetterConfig: {
                type: "structure",
                members: {
                  Arn: {}
                }
              },
              RetryPolicy: {
                type: "structure",
                members: {
                  MaximumRetryAttempts: {
                    type: "integer"
                  },
                  MaximumEventAgeInSeconds: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        S57: {
          type: "list",
          member: {}
        },
        S6j: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/eventbridge-2015-10-07.paginators.json
var require_eventbridge_2015_10_07_paginators = __commonJS({
  "node_modules/aws-sdk/apis/eventbridge-2015-10-07.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/eventbridge.js
var require_eventbridge = __commonJS({
  "node_modules/aws-sdk/clients/eventbridge.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["eventbridge"] = {};
    AWS3.EventBridge = Service.defineService("eventbridge", ["2015-10-07"]);
    Object.defineProperty(apiLoader.services["eventbridge"], "2015-10-07", {
      get: function get() {
        var model = require_eventbridge_2015_10_07_min();
        model.paginators = require_eventbridge_2015_10_07_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.EventBridge;
  }
});

// node_modules/aws-sdk/apis/lakeformation-2017-03-31.min.json
var require_lakeformation_2017_03_31_min = __commonJS({
  "node_modules/aws-sdk/apis/lakeformation-2017-03-31.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-03-31",
        endpointPrefix: "lakeformation",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Lake Formation",
        serviceId: "LakeFormation",
        signatureVersion: "v4",
        signingName: "lakeformation",
        targetPrefix: "AWSLakeFormation",
        uid: "lakeformation-2017-03-31"
      },
      operations: {
        AddLFTagsToResource: {
          input: {
            type: "structure",
            required: [
              "Resource",
              "LFTags"
            ],
            members: {
              CatalogId: {},
              Resource: {
                shape: "S3"
              },
              LFTags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Failures: {
                shape: "Sp"
              }
            }
          }
        },
        BatchGrantPermissions: {
          input: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              CatalogId: {},
              Entries: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Failures: {
                shape: "S12"
              }
            }
          }
        },
        BatchRevokePermissions: {
          input: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              CatalogId: {},
              Entries: {
                shape: "Su"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Failures: {
                shape: "S12"
              }
            }
          }
        },
        CreateLFTag: {
          input: {
            type: "structure",
            required: [
              "TagKey",
              "TagValues"
            ],
            members: {
              CatalogId: {},
              TagKey: {},
              TagValues: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLFTag: {
          input: {
            type: "structure",
            required: [
              "TagKey"
            ],
            members: {
              CatalogId: {},
              TagKey: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceInfo: {
                shape: "S1e"
              }
            }
          }
        },
        GetDataLakeSettings: {
          input: {
            type: "structure",
            members: {
              CatalogId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DataLakeSettings: {
                shape: "S1j"
              }
            }
          }
        },
        GetEffectivePermissionsForPath: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              CatalogId: {},
              ResourceArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Permissions: {
                shape: "S1s"
              },
              NextToken: {}
            }
          }
        },
        GetLFTag: {
          input: {
            type: "structure",
            required: [
              "TagKey"
            ],
            members: {
              CatalogId: {},
              TagKey: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CatalogId: {},
              TagKey: {},
              TagValues: {
                shape: "Sf"
              }
            }
          }
        },
        GetResourceLFTags: {
          input: {
            type: "structure",
            required: [
              "Resource"
            ],
            members: {
              CatalogId: {},
              Resource: {
                shape: "S3"
              },
              ShowAssignedLFTags: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LFTagOnDatabase: {
                shape: "Sm"
              },
              LFTagsOnTable: {
                shape: "Sm"
              },
              LFTagsOnColumns: {
                shape: "S22"
              }
            }
          }
        },
        GrantPermissions: {
          input: {
            type: "structure",
            required: [
              "Principal",
              "Resource",
              "Permissions"
            ],
            members: {
              CatalogId: {},
              Principal: {
                shape: "Sx"
              },
              Resource: {
                shape: "S3"
              },
              Permissions: {
                shape: "Sz"
              },
              PermissionsWithGrantOption: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListLFTags: {
          input: {
            type: "structure",
            members: {
              CatalogId: {},
              ResourceShareType: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LFTags: {
                shape: "Sm"
              },
              NextToken: {}
            }
          }
        },
        ListPermissions: {
          input: {
            type: "structure",
            members: {
              CatalogId: {},
              Principal: {
                shape: "Sx"
              },
              ResourceType: {},
              Resource: {
                shape: "S3"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PrincipalResourcePermissions: {
                shape: "S1s"
              },
              NextToken: {}
            }
          }
        },
        ListResources: {
          input: {
            type: "structure",
            members: {
              FilterConditionList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Field: {},
                    ComparisonOperator: {},
                    StringValueList: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceInfoList: {
                type: "list",
                member: {
                  shape: "S1e"
                }
              },
              NextToken: {}
            }
          }
        },
        PutDataLakeSettings: {
          input: {
            type: "structure",
            required: [
              "DataLakeSettings"
            ],
            members: {
              CatalogId: {},
              DataLakeSettings: {
                shape: "S1j"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RegisterResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {},
              UseServiceLinkedRole: {
                type: "boolean"
              },
              RoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RemoveLFTagsFromResource: {
          input: {
            type: "structure",
            required: [
              "Resource",
              "LFTags"
            ],
            members: {
              CatalogId: {},
              Resource: {
                shape: "S3"
              },
              LFTags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Failures: {
                shape: "Sp"
              }
            }
          }
        },
        RevokePermissions: {
          input: {
            type: "structure",
            required: [
              "Principal",
              "Resource",
              "Permissions"
            ],
            members: {
              CatalogId: {},
              Principal: {
                shape: "Sx"
              },
              Resource: {
                shape: "S3"
              },
              Permissions: {
                shape: "Sz"
              },
              PermissionsWithGrantOption: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SearchDatabasesByLFTags: {
          input: {
            type: "structure",
            required: [
              "Expression"
            ],
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              CatalogId: {},
              Expression: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              DatabaseList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Database: {
                      shape: "S5"
                    },
                    LFTags: {
                      shape: "Sm"
                    }
                  }
                }
              }
            }
          }
        },
        SearchTablesByLFTags: {
          input: {
            type: "structure",
            required: [
              "Expression"
            ],
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              CatalogId: {},
              Expression: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              TableList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Table: {
                      shape: "S7"
                    },
                    LFTagOnDatabase: {
                      shape: "Sm"
                    },
                    LFTagsOnTable: {
                      shape: "Sm"
                    },
                    LFTagsOnColumns: {
                      shape: "S22"
                    }
                  }
                }
              }
            }
          }
        },
        UpdateLFTag: {
          input: {
            type: "structure",
            required: [
              "TagKey"
            ],
            members: {
              CatalogId: {},
              TagKey: {},
              TagValuesToDelete: {
                shape: "Sf"
              },
              TagValuesToAdd: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateResource: {
          input: {
            type: "structure",
            required: [
              "RoleArn",
              "ResourceArn"
            ],
            members: {
              RoleArn: {},
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          members: {
            Catalog: {
              type: "structure",
              members: {}
            },
            Database: {
              shape: "S5"
            },
            Table: {
              shape: "S7"
            },
            TableWithColumns: {
              type: "structure",
              required: [
                "DatabaseName",
                "Name"
              ],
              members: {
                CatalogId: {},
                DatabaseName: {},
                Name: {},
                ColumnNames: {
                  shape: "Sa"
                },
                ColumnWildcard: {
                  type: "structure",
                  members: {
                    ExcludedColumnNames: {
                      shape: "Sa"
                    }
                  }
                }
              }
            },
            DataLocation: {
              type: "structure",
              required: [
                "ResourceArn"
              ],
              members: {
                CatalogId: {},
                ResourceArn: {}
              }
            },
            LFTag: {
              type: "structure",
              required: [
                "TagKey",
                "TagValues"
              ],
              members: {
                CatalogId: {},
                TagKey: {},
                TagValues: {
                  shape: "Sf"
                }
              }
            },
            LFTagPolicy: {
              type: "structure",
              required: [
                "ResourceType",
                "Expression"
              ],
              members: {
                CatalogId: {},
                ResourceType: {},
                Expression: {
                  shape: "Sj"
                }
              }
            }
          }
        },
        S5: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            CatalogId: {},
            Name: {}
          }
        },
        S7: {
          type: "structure",
          required: [
            "DatabaseName"
          ],
          members: {
            CatalogId: {},
            DatabaseName: {},
            Name: {},
            TableWildcard: {
              type: "structure",
              members: {}
            }
          }
        },
        Sa: {
          type: "list",
          member: {}
        },
        Sf: {
          type: "list",
          member: {}
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "TagKey",
              "TagValues"
            ],
            members: {
              TagKey: {},
              TagValues: {
                shape: "Sf"
              }
            }
          }
        },
        Sm: {
          type: "list",
          member: {
            shape: "Sn"
          }
        },
        Sn: {
          type: "structure",
          required: [
            "TagKey",
            "TagValues"
          ],
          members: {
            CatalogId: {},
            TagKey: {},
            TagValues: {
              shape: "Sf"
            }
          }
        },
        Sp: {
          type: "list",
          member: {
            type: "structure",
            members: {
              LFTag: {
                shape: "Sn"
              },
              Error: {
                shape: "Sr"
              }
            }
          }
        },
        Sr: {
          type: "structure",
          members: {
            ErrorCode: {},
            ErrorMessage: {}
          }
        },
        Su: {
          type: "list",
          member: {
            shape: "Sv"
          }
        },
        Sv: {
          type: "structure",
          required: [
            "Id"
          ],
          members: {
            Id: {},
            Principal: {
              shape: "Sx"
            },
            Resource: {
              shape: "S3"
            },
            Permissions: {
              shape: "Sz"
            },
            PermissionsWithGrantOption: {
              shape: "Sz"
            }
          }
        },
        Sx: {
          type: "structure",
          members: {
            DataLakePrincipalIdentifier: {}
          }
        },
        Sz: {
          type: "list",
          member: {}
        },
        S12: {
          type: "list",
          member: {
            type: "structure",
            members: {
              RequestEntry: {
                shape: "Sv"
              },
              Error: {
                shape: "Sr"
              }
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            ResourceArn: {},
            RoleArn: {},
            LastModified: {
              type: "timestamp"
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            DataLakeAdmins: {
              type: "list",
              member: {
                shape: "Sx"
              }
            },
            CreateDatabaseDefaultPermissions: {
              shape: "S1l"
            },
            CreateTableDefaultPermissions: {
              shape: "S1l"
            },
            TrustedResourceOwners: {
              type: "list",
              member: {}
            }
          }
        },
        S1l: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Principal: {
                shape: "Sx"
              },
              Permissions: {
                shape: "Sz"
              }
            }
          }
        },
        S1s: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Principal: {
                shape: "Sx"
              },
              Resource: {
                shape: "S3"
              },
              Permissions: {
                shape: "Sz"
              },
              PermissionsWithGrantOption: {
                shape: "Sz"
              },
              AdditionalDetails: {
                type: "structure",
                members: {
                  ResourceShare: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        S22: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              LFTags: {
                shape: "Sm"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/lakeformation-2017-03-31.paginators.json
var require_lakeformation_2017_03_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/lakeformation-2017-03-31.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetEffectivePermissionsForPath: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPermissions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListResources: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/lakeformation.js
var require_lakeformation = __commonJS({
  "node_modules/aws-sdk/clients/lakeformation.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["lakeformation"] = {};
    AWS3.LakeFormation = Service.defineService("lakeformation", ["2017-03-31"]);
    Object.defineProperty(apiLoader.services["lakeformation"], "2017-03-31", {
      get: function get() {
        var model = require_lakeformation_2017_03_31_min();
        model.paginators = require_lakeformation_2017_03_31_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.LakeFormation;
  }
});

// node_modules/aws-sdk/apis/forecast-2018-06-26.min.json
var require_forecast_2018_06_26_min = __commonJS({
  "node_modules/aws-sdk/apis/forecast-2018-06-26.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-06-26",
        endpointPrefix: "forecast",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Forecast Service",
        serviceId: "forecast",
        signatureVersion: "v4",
        signingName: "forecast",
        targetPrefix: "AmazonForecast",
        uid: "forecast-2018-06-26"
      },
      operations: {
        CreateDataset: {
          input: {
            type: "structure",
            required: [
              "DatasetName",
              "Domain",
              "DatasetType",
              "Schema"
            ],
            members: {
              DatasetName: {},
              Domain: {},
              DatasetType: {},
              DataFrequency: {},
              Schema: {
                shape: "S6"
              },
              EncryptionConfig: {
                shape: "Sa"
              },
              Tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetArn: {}
            }
          }
        },
        CreateDatasetGroup: {
          input: {
            type: "structure",
            required: [
              "DatasetGroupName",
              "Domain"
            ],
            members: {
              DatasetGroupName: {},
              Domain: {},
              DatasetArns: {
                shape: "Sj"
              },
              Tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetGroupArn: {}
            }
          }
        },
        CreateDatasetImportJob: {
          input: {
            type: "structure",
            required: [
              "DatasetImportJobName",
              "DatasetArn",
              "DataSource"
            ],
            members: {
              DatasetImportJobName: {},
              DatasetArn: {},
              DataSource: {
                shape: "Sm"
              },
              TimestampFormat: {},
              TimeZone: {},
              UseGeolocationForTimeZone: {
                type: "boolean"
              },
              GeolocationFormat: {},
              Tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetImportJobArn: {}
            }
          }
        },
        CreateForecast: {
          input: {
            type: "structure",
            required: [
              "ForecastName",
              "PredictorArn"
            ],
            members: {
              ForecastName: {},
              PredictorArn: {},
              ForecastTypes: {
                shape: "Sv"
              },
              Tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ForecastArn: {}
            }
          }
        },
        CreateForecastExportJob: {
          input: {
            type: "structure",
            required: [
              "ForecastExportJobName",
              "ForecastArn",
              "Destination"
            ],
            members: {
              ForecastExportJobName: {},
              ForecastArn: {},
              Destination: {
                shape: "Sz"
              },
              Tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ForecastExportJobArn: {}
            }
          }
        },
        CreatePredictor: {
          input: {
            type: "structure",
            required: [
              "PredictorName",
              "ForecastHorizon",
              "InputDataConfig",
              "FeaturizationConfig"
            ],
            members: {
              PredictorName: {},
              AlgorithmArn: {},
              ForecastHorizon: {
                type: "integer"
              },
              ForecastTypes: {
                shape: "Sv"
              },
              PerformAutoML: {
                type: "boolean"
              },
              AutoMLOverrideStrategy: {},
              PerformHPO: {
                type: "boolean"
              },
              TrainingParameters: {
                shape: "S15"
              },
              EvaluationParameters: {
                shape: "S18"
              },
              HPOConfig: {
                shape: "S19"
              },
              InputDataConfig: {
                shape: "S1l"
              },
              FeaturizationConfig: {
                shape: "S1o"
              },
              EncryptionConfig: {
                shape: "Sa"
              },
              Tags: {
                shape: "Sd"
              },
              OptimizationMetric: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PredictorArn: {}
            }
          }
        },
        CreatePredictorBacktestExportJob: {
          input: {
            type: "structure",
            required: [
              "PredictorBacktestExportJobName",
              "PredictorArn",
              "Destination"
            ],
            members: {
              PredictorBacktestExportJobName: {},
              PredictorArn: {},
              Destination: {
                shape: "Sz"
              },
              Tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PredictorBacktestExportJobArn: {}
            }
          }
        },
        DeleteDataset: {
          input: {
            type: "structure",
            required: [
              "DatasetArn"
            ],
            members: {
              DatasetArn: {}
            }
          },
          idempotent: true
        },
        DeleteDatasetGroup: {
          input: {
            type: "structure",
            required: [
              "DatasetGroupArn"
            ],
            members: {
              DatasetGroupArn: {}
            }
          },
          idempotent: true
        },
        DeleteDatasetImportJob: {
          input: {
            type: "structure",
            required: [
              "DatasetImportJobArn"
            ],
            members: {
              DatasetImportJobArn: {}
            }
          },
          idempotent: true
        },
        DeleteForecast: {
          input: {
            type: "structure",
            required: [
              "ForecastArn"
            ],
            members: {
              ForecastArn: {}
            }
          },
          idempotent: true
        },
        DeleteForecastExportJob: {
          input: {
            type: "structure",
            required: [
              "ForecastExportJobArn"
            ],
            members: {
              ForecastExportJobArn: {}
            }
          },
          idempotent: true
        },
        DeletePredictor: {
          input: {
            type: "structure",
            required: [
              "PredictorArn"
            ],
            members: {
              PredictorArn: {}
            }
          },
          idempotent: true
        },
        DeletePredictorBacktestExportJob: {
          input: {
            type: "structure",
            required: [
              "PredictorBacktestExportJobArn"
            ],
            members: {
              PredictorBacktestExportJobArn: {}
            }
          },
          idempotent: true
        },
        DeleteResourceTree: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          idempotent: true
        },
        DescribeDataset: {
          input: {
            type: "structure",
            required: [
              "DatasetArn"
            ],
            members: {
              DatasetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetArn: {},
              DatasetName: {},
              Domain: {},
              DatasetType: {},
              DataFrequency: {},
              Schema: {
                shape: "S6"
              },
              EncryptionConfig: {
                shape: "Sa"
              },
              Status: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DescribeDatasetGroup: {
          input: {
            type: "structure",
            required: [
              "DatasetGroupArn"
            ],
            members: {
              DatasetGroupArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetGroupName: {},
              DatasetGroupArn: {},
              DatasetArns: {
                shape: "Sj"
              },
              Domain: {},
              Status: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DescribeDatasetImportJob: {
          input: {
            type: "structure",
            required: [
              "DatasetImportJobArn"
            ],
            members: {
              DatasetImportJobArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetImportJobName: {},
              DatasetImportJobArn: {},
              DatasetArn: {},
              TimestampFormat: {},
              TimeZone: {},
              UseGeolocationForTimeZone: {
                type: "boolean"
              },
              GeolocationFormat: {},
              DataSource: {
                shape: "Sm"
              },
              EstimatedTimeRemainingInMinutes: {
                type: "long"
              },
              FieldStatistics: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    Count: {
                      type: "integer"
                    },
                    CountDistinct: {
                      type: "integer"
                    },
                    CountNull: {
                      type: "integer"
                    },
                    CountNan: {
                      type: "integer"
                    },
                    Min: {},
                    Max: {},
                    Avg: {
                      type: "double"
                    },
                    Stddev: {
                      type: "double"
                    },
                    CountLong: {
                      type: "long"
                    },
                    CountDistinctLong: {
                      type: "long"
                    },
                    CountNullLong: {
                      type: "long"
                    },
                    CountNanLong: {
                      type: "long"
                    }
                  }
                }
              },
              DataSize: {
                type: "double"
              },
              Status: {},
              Message: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DescribeForecast: {
          input: {
            type: "structure",
            required: [
              "ForecastArn"
            ],
            members: {
              ForecastArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ForecastArn: {},
              ForecastName: {},
              ForecastTypes: {
                shape: "Sv"
              },
              PredictorArn: {},
              DatasetGroupArn: {},
              EstimatedTimeRemainingInMinutes: {
                type: "long"
              },
              Status: {},
              Message: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DescribeForecastExportJob: {
          input: {
            type: "structure",
            required: [
              "ForecastExportJobArn"
            ],
            members: {
              ForecastExportJobArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ForecastExportJobArn: {},
              ForecastExportJobName: {},
              ForecastArn: {},
              Destination: {
                shape: "Sz"
              },
              Message: {},
              Status: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        DescribePredictor: {
          input: {
            type: "structure",
            required: [
              "PredictorArn"
            ],
            members: {
              PredictorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PredictorArn: {},
              PredictorName: {},
              AlgorithmArn: {},
              ForecastHorizon: {
                type: "integer"
              },
              ForecastTypes: {
                shape: "Sv"
              },
              PerformAutoML: {
                type: "boolean"
              },
              AutoMLOverrideStrategy: {},
              PerformHPO: {
                type: "boolean"
              },
              TrainingParameters: {
                shape: "S15"
              },
              EvaluationParameters: {
                shape: "S18"
              },
              HPOConfig: {
                shape: "S19"
              },
              InputDataConfig: {
                shape: "S1l"
              },
              FeaturizationConfig: {
                shape: "S1o"
              },
              EncryptionConfig: {
                shape: "Sa"
              },
              PredictorExecutionDetails: {
                type: "structure",
                members: {
                  PredictorExecutions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        AlgorithmArn: {},
                        TestWindows: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              TestWindowStart: {
                                type: "timestamp"
                              },
                              TestWindowEnd: {
                                type: "timestamp"
                              },
                              Status: {},
                              Message: {}
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              EstimatedTimeRemainingInMinutes: {
                type: "long"
              },
              DatasetImportJobArns: {
                shape: "Sj"
              },
              AutoMLAlgorithmArns: {
                shape: "Sj"
              },
              Status: {},
              Message: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              },
              OptimizationMetric: {}
            }
          },
          idempotent: true
        },
        DescribePredictorBacktestExportJob: {
          input: {
            type: "structure",
            required: [
              "PredictorBacktestExportJobArn"
            ],
            members: {
              PredictorBacktestExportJobArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PredictorBacktestExportJobArn: {},
              PredictorBacktestExportJobName: {},
              PredictorArn: {},
              Destination: {
                shape: "Sz"
              },
              Message: {},
              Status: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              }
            }
          },
          idempotent: true
        },
        GetAccuracyMetrics: {
          input: {
            type: "structure",
            required: [
              "PredictorArn"
            ],
            members: {
              PredictorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PredictorEvaluationResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AlgorithmArn: {},
                    TestWindows: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          TestWindowStart: {
                            type: "timestamp"
                          },
                          TestWindowEnd: {
                            type: "timestamp"
                          },
                          ItemCount: {
                            type: "integer"
                          },
                          EvaluationType: {},
                          Metrics: {
                            type: "structure",
                            members: {
                              RMSE: {
                                deprecated: true,
                                deprecatedMessage: "This property is deprecated, please refer to ErrorMetrics for both RMSE and WAPE",
                                type: "double"
                              },
                              WeightedQuantileLosses: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    Quantile: {
                                      type: "double"
                                    },
                                    LossValue: {
                                      type: "double"
                                    }
                                  }
                                }
                              },
                              ErrorMetrics: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  members: {
                                    ForecastType: {},
                                    WAPE: {
                                      type: "double"
                                    },
                                    RMSE: {
                                      type: "double"
                                    },
                                    MASE: {
                                      type: "double"
                                    },
                                    MAPE: {
                                      type: "double"
                                    }
                                  }
                                }
                              },
                              AverageWeightedQuantileLoss: {
                                type: "double"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              AutoMLOverrideStrategy: {},
              OptimizationMetric: {}
            }
          },
          idempotent: true
        },
        ListDatasetGroups: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DatasetGroupArn: {},
                    DatasetGroupName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListDatasetImportJobs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S3i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetImportJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DatasetImportJobArn: {},
                    DatasetImportJobName: {},
                    DataSource: {
                      shape: "Sm"
                    },
                    Status: {},
                    Message: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListDatasets: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Datasets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DatasetArn: {},
                    DatasetName: {},
                    DatasetType: {},
                    Domain: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListForecastExportJobs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S3i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ForecastExportJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ForecastExportJobArn: {},
                    ForecastExportJobName: {},
                    Destination: {
                      shape: "Sz"
                    },
                    Status: {},
                    Message: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListForecasts: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S3i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Forecasts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ForecastArn: {},
                    ForecastName: {},
                    PredictorArn: {},
                    DatasetGroupArn: {},
                    Status: {},
                    Message: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListPredictorBacktestExportJobs: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S3i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PredictorBacktestExportJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PredictorBacktestExportJobArn: {},
                    PredictorBacktestExportJobName: {},
                    Destination: {
                      shape: "Sz"
                    },
                    Status: {},
                    Message: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListPredictors: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Filters: {
                shape: "S3i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Predictors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PredictorArn: {},
                    PredictorName: {},
                    DatasetGroupArn: {},
                    Status: {},
                    Message: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          idempotent: true
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sd"
              }
            }
          }
        },
        StopResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          idempotent: true
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {
                  shape: "Sf"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDatasetGroup: {
          input: {
            type: "structure",
            required: [
              "DatasetGroupArn",
              "DatasetArns"
            ],
            members: {
              DatasetGroupArn: {},
              DatasetArns: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        }
      },
      shapes: {
        S6: {
          type: "structure",
          members: {
            Attributes: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  AttributeName: {},
                  AttributeType: {}
                }
              }
            }
          }
        },
        Sa: {
          type: "structure",
          required: [
            "RoleArn",
            "KMSKeyArn"
          ],
          members: {
            RoleArn: {},
            KMSKeyArn: {}
          }
        },
        Sd: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {
                shape: "Sf"
              },
              Value: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        Sf: {
          type: "string",
          sensitive: true
        },
        Sj: {
          type: "list",
          member: {}
        },
        Sm: {
          type: "structure",
          required: [
            "S3Config"
          ],
          members: {
            S3Config: {
              shape: "Sn"
            }
          }
        },
        Sn: {
          type: "structure",
          required: [
            "Path",
            "RoleArn"
          ],
          members: {
            Path: {},
            RoleArn: {},
            KMSKeyArn: {}
          }
        },
        Sv: {
          type: "list",
          member: {}
        },
        Sz: {
          type: "structure",
          required: [
            "S3Config"
          ],
          members: {
            S3Config: {
              shape: "Sn"
            }
          }
        },
        S15: {
          type: "map",
          key: {},
          value: {}
        },
        S18: {
          type: "structure",
          members: {
            NumberOfBacktestWindows: {
              type: "integer"
            },
            BackTestWindowOffset: {
              type: "integer"
            }
          }
        },
        S19: {
          type: "structure",
          members: {
            ParameterRanges: {
              type: "structure",
              members: {
                CategoricalParameterRanges: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Name",
                      "Values"
                    ],
                    members: {
                      Name: {},
                      Values: {
                        type: "list",
                        member: {}
                      }
                    }
                  }
                },
                ContinuousParameterRanges: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Name",
                      "MaxValue",
                      "MinValue"
                    ],
                    members: {
                      Name: {},
                      MaxValue: {
                        type: "double"
                      },
                      MinValue: {
                        type: "double"
                      },
                      ScalingType: {}
                    }
                  }
                },
                IntegerParameterRanges: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Name",
                      "MaxValue",
                      "MinValue"
                    ],
                    members: {
                      Name: {},
                      MaxValue: {
                        type: "integer"
                      },
                      MinValue: {
                        type: "integer"
                      },
                      ScalingType: {}
                    }
                  }
                }
              }
            }
          }
        },
        S1l: {
          type: "structure",
          required: [
            "DatasetGroupArn"
          ],
          members: {
            DatasetGroupArn: {},
            SupplementaryFeatures: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "Value"
                ],
                members: {
                  Name: {},
                  Value: {}
                }
              }
            }
          }
        },
        S1o: {
          type: "structure",
          required: [
            "ForecastFrequency"
          ],
          members: {
            ForecastFrequency: {},
            ForecastDimensions: {
              type: "list",
              member: {}
            },
            Featurizations: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "AttributeName"
                ],
                members: {
                  AttributeName: {},
                  FeaturizationPipeline: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "FeaturizationMethodName"
                      ],
                      members: {
                        FeaturizationMethodName: {},
                        FeaturizationMethodParameters: {
                          type: "map",
                          key: {},
                          value: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S3i: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value",
              "Condition"
            ],
            members: {
              Key: {},
              Value: {},
              Condition: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/forecast-2018-06-26.paginators.json
var require_forecast_2018_06_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/forecast-2018-06-26.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListDatasetGroups: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DatasetGroups"
        },
        ListDatasetImportJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "DatasetImportJobs"
        },
        ListDatasets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Datasets"
        },
        ListForecastExportJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ForecastExportJobs"
        },
        ListForecasts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Forecasts"
        },
        ListPredictorBacktestExportJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PredictorBacktestExportJobs"
        },
        ListPredictors: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Predictors"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/forecastservice.js
var require_forecastservice = __commonJS({
  "node_modules/aws-sdk/clients/forecastservice.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["forecastservice"] = {};
    AWS3.ForecastService = Service.defineService("forecastservice", ["2018-06-26"]);
    Object.defineProperty(apiLoader.services["forecastservice"], "2018-06-26", {
      get: function get() {
        var model = require_forecast_2018_06_26_min();
        model.paginators = require_forecast_2018_06_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ForecastService;
  }
});

// node_modules/aws-sdk/apis/forecastquery-2018-06-26.min.json
var require_forecastquery_2018_06_26_min = __commonJS({
  "node_modules/aws-sdk/apis/forecastquery-2018-06-26.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-06-26",
        endpointPrefix: "forecastquery",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Forecast Query Service",
        serviceId: "forecastquery",
        signatureVersion: "v4",
        signingName: "forecast",
        targetPrefix: "AmazonForecastRuntime",
        uid: "forecastquery-2018-06-26"
      },
      operations: {
        QueryForecast: {
          input: {
            type: "structure",
            required: [
              "ForecastArn",
              "Filters"
            ],
            members: {
              ForecastArn: {},
              StartDate: {},
              EndDate: {},
              Filters: {
                type: "map",
                key: {},
                value: {}
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Forecast: {
                type: "structure",
                members: {
                  Predictions: {
                    type: "map",
                    key: {},
                    value: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Timestamp: {},
                          Value: {
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/forecastquery-2018-06-26.paginators.json
var require_forecastquery_2018_06_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/forecastquery-2018-06-26.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/forecastqueryservice.js
var require_forecastqueryservice = __commonJS({
  "node_modules/aws-sdk/clients/forecastqueryservice.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["forecastqueryservice"] = {};
    AWS3.ForecastQueryService = Service.defineService("forecastqueryservice", ["2018-06-26"]);
    Object.defineProperty(apiLoader.services["forecastqueryservice"], "2018-06-26", {
      get: function get() {
        var model = require_forecastquery_2018_06_26_min();
        model.paginators = require_forecastquery_2018_06_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ForecastQueryService;
  }
});

// node_modules/aws-sdk/apis/qldb-2019-01-02.min.json
var require_qldb_2019_01_02_min = __commonJS({
  "node_modules/aws-sdk/apis/qldb-2019-01-02.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-01-02",
        endpointPrefix: "qldb",
        jsonVersion: "1.0",
        protocol: "rest-json",
        serviceAbbreviation: "QLDB",
        serviceFullName: "Amazon QLDB",
        serviceId: "QLDB",
        signatureVersion: "v4",
        signingName: "qldb",
        uid: "qldb-2019-01-02"
      },
      operations: {
        CancelJournalKinesisStream: {
          http: {
            method: "DELETE",
            requestUri: "/ledgers/{name}/journal-kinesis-streams/{streamId}"
          },
          input: {
            type: "structure",
            required: [
              "LedgerName",
              "StreamId"
            ],
            members: {
              LedgerName: {
                location: "uri",
                locationName: "name"
              },
              StreamId: {
                location: "uri",
                locationName: "streamId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StreamId: {}
            }
          }
        },
        CreateLedger: {
          http: {
            requestUri: "/ledgers"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "PermissionsMode"
            ],
            members: {
              Name: {},
              Tags: {
                shape: "S6"
              },
              PermissionsMode: {},
              DeletionProtection: {
                type: "boolean"
              },
              KmsKey: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Arn: {},
              State: {},
              CreationDateTime: {
                type: "timestamp"
              },
              PermissionsMode: {},
              DeletionProtection: {
                type: "boolean"
              },
              KmsKeyArn: {}
            }
          }
        },
        DeleteLedger: {
          http: {
            method: "DELETE",
            requestUri: "/ledgers/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          }
        },
        DescribeJournalKinesisStream: {
          http: {
            method: "GET",
            requestUri: "/ledgers/{name}/journal-kinesis-streams/{streamId}"
          },
          input: {
            type: "structure",
            required: [
              "LedgerName",
              "StreamId"
            ],
            members: {
              LedgerName: {
                location: "uri",
                locationName: "name"
              },
              StreamId: {
                location: "uri",
                locationName: "streamId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Stream: {
                shape: "Sj"
              }
            }
          }
        },
        DescribeJournalS3Export: {
          http: {
            method: "GET",
            requestUri: "/ledgers/{name}/journal-s3-exports/{exportId}"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "ExportId"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              ExportId: {
                location: "uri",
                locationName: "exportId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ExportDescription"
            ],
            members: {
              ExportDescription: {
                shape: "Sr"
              }
            }
          }
        },
        DescribeLedger: {
          http: {
            method: "GET",
            requestUri: "/ledgers/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Arn: {},
              State: {},
              CreationDateTime: {
                type: "timestamp"
              },
              PermissionsMode: {},
              DeletionProtection: {
                type: "boolean"
              },
              EncryptionDescription: {
                shape: "S10"
              }
            }
          }
        },
        ExportJournalToS3: {
          http: {
            requestUri: "/ledgers/{name}/journal-s3-exports"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "InclusiveStartTime",
              "ExclusiveEndTime",
              "S3ExportConfiguration",
              "RoleArn"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              InclusiveStartTime: {
                type: "timestamp"
              },
              ExclusiveEndTime: {
                type: "timestamp"
              },
              S3ExportConfiguration: {
                shape: "St"
              },
              RoleArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ExportId"
            ],
            members: {
              ExportId: {}
            }
          }
        },
        GetBlock: {
          http: {
            requestUri: "/ledgers/{name}/block"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "BlockAddress"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              BlockAddress: {
                shape: "S15"
              },
              DigestTipAddress: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Block"
            ],
            members: {
              Block: {
                shape: "S15"
              },
              Proof: {
                shape: "S15"
              }
            }
          }
        },
        GetDigest: {
          http: {
            requestUri: "/ledgers/{name}/digest"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Digest",
              "DigestTipAddress"
            ],
            members: {
              Digest: {
                type: "blob"
              },
              DigestTipAddress: {
                shape: "S15"
              }
            }
          }
        },
        GetRevision: {
          http: {
            requestUri: "/ledgers/{name}/revision"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "BlockAddress",
              "DocumentId"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              BlockAddress: {
                shape: "S15"
              },
              DocumentId: {},
              DigestTipAddress: {
                shape: "S15"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Revision"
            ],
            members: {
              Proof: {
                shape: "S15"
              },
              Revision: {
                shape: "S15"
              }
            }
          }
        },
        ListJournalKinesisStreamsForLedger: {
          http: {
            method: "GET",
            requestUri: "/ledgers/{name}/journal-kinesis-streams"
          },
          input: {
            type: "structure",
            required: [
              "LedgerName"
            ],
            members: {
              LedgerName: {
                location: "uri",
                locationName: "name"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Streams: {
                type: "list",
                member: {
                  shape: "Sj"
                }
              },
              NextToken: {}
            }
          }
        },
        ListJournalS3Exports: {
          http: {
            method: "GET",
            requestUri: "/journal-s3-exports"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JournalS3Exports: {
                shape: "S1k"
              },
              NextToken: {}
            }
          }
        },
        ListJournalS3ExportsForLedger: {
          http: {
            method: "GET",
            requestUri: "/ledgers/{name}/journal-s3-exports"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JournalS3Exports: {
                shape: "S1k"
              },
              NextToken: {}
            }
          }
        },
        ListLedgers: {
          http: {
            method: "GET",
            requestUri: "/ledgers"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Ledgers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    State: {},
                    CreationDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S6"
              }
            }
          }
        },
        StreamJournalToKinesis: {
          http: {
            requestUri: "/ledgers/{name}/journal-kinesis-streams"
          },
          input: {
            type: "structure",
            required: [
              "LedgerName",
              "RoleArn",
              "InclusiveStartTime",
              "KinesisConfiguration",
              "StreamName"
            ],
            members: {
              LedgerName: {
                location: "uri",
                locationName: "name"
              },
              RoleArn: {},
              Tags: {
                shape: "S6"
              },
              InclusiveStartTime: {
                type: "timestamp"
              },
              ExclusiveEndTime: {
                type: "timestamp"
              },
              KinesisConfiguration: {
                shape: "Sl"
              },
              StreamName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              StreamId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLedger: {
          http: {
            method: "PATCH",
            requestUri: "/ledgers/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              DeletionProtection: {
                type: "boolean"
              },
              KmsKey: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Arn: {},
              State: {},
              CreationDateTime: {
                type: "timestamp"
              },
              DeletionProtection: {
                type: "boolean"
              },
              EncryptionDescription: {
                shape: "S10"
              }
            }
          }
        },
        UpdateLedgerPermissionsMode: {
          http: {
            method: "PATCH",
            requestUri: "/ledgers/{name}/permissions-mode"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "PermissionsMode"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              PermissionsMode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Arn: {},
              PermissionsMode: {}
            }
          }
        }
      },
      shapes: {
        S6: {
          type: "map",
          key: {},
          value: {}
        },
        Sj: {
          type: "structure",
          required: [
            "LedgerName",
            "RoleArn",
            "StreamId",
            "Status",
            "KinesisConfiguration",
            "StreamName"
          ],
          members: {
            LedgerName: {},
            CreationTime: {
              type: "timestamp"
            },
            InclusiveStartTime: {
              type: "timestamp"
            },
            ExclusiveEndTime: {
              type: "timestamp"
            },
            RoleArn: {},
            StreamId: {},
            Arn: {},
            Status: {},
            KinesisConfiguration: {
              shape: "Sl"
            },
            ErrorCause: {},
            StreamName: {}
          }
        },
        Sl: {
          type: "structure",
          required: [
            "StreamArn"
          ],
          members: {
            StreamArn: {},
            AggregationEnabled: {
              type: "boolean"
            }
          }
        },
        Sr: {
          type: "structure",
          required: [
            "LedgerName",
            "ExportId",
            "ExportCreationTime",
            "Status",
            "InclusiveStartTime",
            "ExclusiveEndTime",
            "S3ExportConfiguration",
            "RoleArn"
          ],
          members: {
            LedgerName: {},
            ExportId: {},
            ExportCreationTime: {
              type: "timestamp"
            },
            Status: {},
            InclusiveStartTime: {
              type: "timestamp"
            },
            ExclusiveEndTime: {
              type: "timestamp"
            },
            S3ExportConfiguration: {
              shape: "St"
            },
            RoleArn: {}
          }
        },
        St: {
          type: "structure",
          required: [
            "Bucket",
            "Prefix",
            "EncryptionConfiguration"
          ],
          members: {
            Bucket: {},
            Prefix: {},
            EncryptionConfiguration: {
              type: "structure",
              required: [
                "ObjectEncryptionType"
              ],
              members: {
                ObjectEncryptionType: {},
                KmsKeyArn: {}
              }
            }
          }
        },
        S10: {
          type: "structure",
          required: [
            "KmsKeyArn",
            "EncryptionStatus"
          ],
          members: {
            KmsKeyArn: {},
            EncryptionStatus: {},
            InaccessibleKmsKeyDateTime: {
              type: "timestamp"
            }
          }
        },
        S15: {
          type: "structure",
          members: {
            IonText: {
              type: "string",
              sensitive: true
            }
          },
          sensitive: true
        },
        S1k: {
          type: "list",
          member: {
            shape: "Sr"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/qldb-2019-01-02.paginators.json
var require_qldb_2019_01_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/qldb-2019-01-02.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListJournalKinesisStreamsForLedger: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListJournalS3Exports: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListJournalS3ExportsForLedger: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListLedgers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/qldb.js
var require_qldb = __commonJS({
  "node_modules/aws-sdk/clients/qldb.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["qldb"] = {};
    AWS3.QLDB = Service.defineService("qldb", ["2019-01-02"]);
    Object.defineProperty(apiLoader.services["qldb"], "2019-01-02", {
      get: function get() {
        var model = require_qldb_2019_01_02_min();
        model.paginators = require_qldb_2019_01_02_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.QLDB;
  }
});

// node_modules/aws-sdk/apis/qldb-session-2019-07-11.min.json
var require_qldb_session_2019_07_11_min = __commonJS({
  "node_modules/aws-sdk/apis/qldb-session-2019-07-11.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-07-11",
        endpointPrefix: "session.qldb",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "QLDB Session",
        serviceFullName: "Amazon QLDB Session",
        serviceId: "QLDB Session",
        signatureVersion: "v4",
        signingName: "qldb",
        targetPrefix: "QLDBSession",
        uid: "qldb-session-2019-07-11"
      },
      operations: {
        SendCommand: {
          input: {
            type: "structure",
            members: {
              SessionToken: {},
              StartSession: {
                type: "structure",
                required: [
                  "LedgerName"
                ],
                members: {
                  LedgerName: {}
                }
              },
              StartTransaction: {
                type: "structure",
                members: {}
              },
              EndSession: {
                type: "structure",
                members: {}
              },
              CommitTransaction: {
                type: "structure",
                required: [
                  "TransactionId",
                  "CommitDigest"
                ],
                members: {
                  TransactionId: {},
                  CommitDigest: {
                    type: "blob"
                  }
                }
              },
              AbortTransaction: {
                type: "structure",
                members: {}
              },
              ExecuteStatement: {
                type: "structure",
                required: [
                  "TransactionId",
                  "Statement"
                ],
                members: {
                  TransactionId: {},
                  Statement: {},
                  Parameters: {
                    type: "list",
                    member: {
                      shape: "Se"
                    }
                  }
                }
              },
              FetchPage: {
                type: "structure",
                required: [
                  "TransactionId",
                  "NextPageToken"
                ],
                members: {
                  TransactionId: {},
                  NextPageToken: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              StartSession: {
                type: "structure",
                members: {
                  SessionToken: {},
                  TimingInformation: {
                    shape: "Sl"
                  }
                }
              },
              StartTransaction: {
                type: "structure",
                members: {
                  TransactionId: {},
                  TimingInformation: {
                    shape: "Sl"
                  }
                }
              },
              EndSession: {
                type: "structure",
                members: {
                  TimingInformation: {
                    shape: "Sl"
                  }
                }
              },
              CommitTransaction: {
                type: "structure",
                members: {
                  TransactionId: {},
                  CommitDigest: {
                    type: "blob"
                  },
                  TimingInformation: {
                    shape: "Sl"
                  },
                  ConsumedIOs: {
                    shape: "Sq"
                  }
                }
              },
              AbortTransaction: {
                type: "structure",
                members: {
                  TimingInformation: {
                    shape: "Sl"
                  }
                }
              },
              ExecuteStatement: {
                type: "structure",
                members: {
                  FirstPage: {
                    shape: "Sv"
                  },
                  TimingInformation: {
                    shape: "Sl"
                  },
                  ConsumedIOs: {
                    shape: "Sq"
                  }
                }
              },
              FetchPage: {
                type: "structure",
                members: {
                  Page: {
                    shape: "Sv"
                  },
                  TimingInformation: {
                    shape: "Sl"
                  },
                  ConsumedIOs: {
                    shape: "Sq"
                  }
                }
              }
            }
          }
        }
      },
      shapes: {
        Se: {
          type: "structure",
          members: {
            IonBinary: {
              type: "blob"
            },
            IonText: {}
          }
        },
        Sl: {
          type: "structure",
          members: {
            ProcessingTimeMilliseconds: {
              type: "long"
            }
          }
        },
        Sq: {
          type: "structure",
          members: {
            ReadIOs: {
              type: "long"
            },
            WriteIOs: {
              type: "long"
            }
          }
        },
        Sv: {
          type: "structure",
          members: {
            Values: {
              type: "list",
              member: {
                shape: "Se"
              }
            },
            NextPageToken: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/qldb-session-2019-07-11.paginators.json
var require_qldb_session_2019_07_11_paginators = __commonJS({
  "node_modules/aws-sdk/apis/qldb-session-2019-07-11.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/qldbsession.js
var require_qldbsession = __commonJS({
  "node_modules/aws-sdk/clients/qldbsession.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["qldbsession"] = {};
    AWS3.QLDBSession = Service.defineService("qldbsession", ["2019-07-11"]);
    Object.defineProperty(apiLoader.services["qldbsession"], "2019-07-11", {
      get: function get() {
        var model = require_qldb_session_2019_07_11_min();
        model.paginators = require_qldb_session_2019_07_11_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.QLDBSession;
  }
});

// node_modules/aws-sdk/apis/workmailmessageflow-2019-05-01.min.json
var require_workmailmessageflow_2019_05_01_min = __commonJS({
  "node_modules/aws-sdk/apis/workmailmessageflow-2019-05-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-05-01",
        endpointPrefix: "workmailmessageflow",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon WorkMail Message Flow",
        serviceId: "WorkMailMessageFlow",
        signatureVersion: "v4",
        uid: "workmailmessageflow-2019-05-01"
      },
      operations: {
        GetRawMessageContent: {
          http: {
            method: "GET",
            requestUri: "/messages/{messageId}"
          },
          input: {
            type: "structure",
            required: [
              "messageId"
            ],
            members: {
              messageId: {
                location: "uri",
                locationName: "messageId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "messageContent"
            ],
            members: {
              messageContent: {
                type: "blob",
                streaming: true
              }
            },
            payload: "messageContent"
          }
        },
        PutRawMessageContent: {
          http: {
            requestUri: "/messages/{messageId}"
          },
          input: {
            type: "structure",
            required: [
              "messageId",
              "content"
            ],
            members: {
              messageId: {
                location: "uri",
                locationName: "messageId"
              },
              content: {
                type: "structure",
                required: [
                  "s3Reference"
                ],
                members: {
                  s3Reference: {
                    type: "structure",
                    required: [
                      "bucket",
                      "key"
                    ],
                    members: {
                      bucket: {},
                      key: {},
                      objectVersion: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/workmailmessageflow-2019-05-01.paginators.json
var require_workmailmessageflow_2019_05_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/workmailmessageflow-2019-05-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/workmailmessageflow.js
var require_workmailmessageflow = __commonJS({
  "node_modules/aws-sdk/clients/workmailmessageflow.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["workmailmessageflow"] = {};
    AWS3.WorkMailMessageFlow = Service.defineService("workmailmessageflow", ["2019-05-01"]);
    Object.defineProperty(apiLoader.services["workmailmessageflow"], "2019-05-01", {
      get: function get() {
        var model = require_workmailmessageflow_2019_05_01_min();
        model.paginators = require_workmailmessageflow_2019_05_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.WorkMailMessageFlow;
  }
});

// node_modules/aws-sdk/apis/codestar-notifications-2019-10-15.min.json
var require_codestar_notifications_2019_10_15_min = __commonJS({
  "node_modules/aws-sdk/apis/codestar-notifications-2019-10-15.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-10-15",
        endpointPrefix: "codestar-notifications",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS CodeStar Notifications",
        serviceId: "codestar notifications",
        signatureVersion: "v4",
        signingName: "codestar-notifications",
        uid: "codestar-notifications-2019-10-15"
      },
      operations: {
        CreateNotificationRule: {
          http: {
            requestUri: "/createNotificationRule"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "EventTypeIds",
              "Resource",
              "Targets",
              "DetailType"
            ],
            members: {
              Name: {
                shape: "S2"
              },
              EventTypeIds: {
                shape: "S3"
              },
              Resource: {},
              Targets: {
                shape: "S6"
              },
              DetailType: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sc"
              },
              Status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          }
        },
        DeleteNotificationRule: {
          http: {
            requestUri: "/deleteNotificationRule"
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          }
        },
        DeleteTarget: {
          http: {
            requestUri: "/deleteTarget"
          },
          input: {
            type: "structure",
            required: [
              "TargetAddress"
            ],
            members: {
              TargetAddress: {
                shape: "S9"
              },
              ForceUnsubscribeAll: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeNotificationRule: {
          http: {
            requestUri: "/describeNotificationRule"
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {},
              Name: {
                shape: "S2"
              },
              EventTypes: {
                shape: "Sp"
              },
              Resource: {},
              Targets: {
                shape: "Su"
              },
              DetailType: {},
              CreatedBy: {},
              Status: {},
              CreatedTimestamp: {
                type: "timestamp"
              },
              LastModifiedTimestamp: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        ListEventTypes: {
          http: {
            requestUri: "/listEventTypes"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Value"
                  ],
                  members: {
                    Name: {},
                    Value: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventTypes: {
                shape: "Sp"
              },
              NextToken: {}
            }
          }
        },
        ListNotificationRules: {
          http: {
            requestUri: "/listNotificationRules"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Value"
                  ],
                  members: {
                    Name: {},
                    Value: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              NotificationRules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Arn: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            requestUri: "/listTagsForResource"
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        ListTargets: {
          http: {
            requestUri: "/listTargets"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Value"
                  ],
                  members: {
                    Name: {},
                    Value: {}
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Targets: {
                shape: "Su"
              },
              NextToken: {}
            }
          }
        },
        Subscribe: {
          http: {
            requestUri: "/subscribe"
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "Target"
            ],
            members: {
              Arn: {},
              Target: {
                shape: "S7"
              },
              ClientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tagResource"
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "Tags"
            ],
            members: {
              Arn: {},
              Tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        Unsubscribe: {
          http: {
            requestUri: "/unsubscribe"
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "TargetAddress"
            ],
            members: {
              Arn: {},
              TargetAddress: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {}
            }
          }
        },
        UntagResource: {
          http: {
            requestUri: "/untagResource"
          },
          input: {
            type: "structure",
            required: [
              "Arn",
              "TagKeys"
            ],
            members: {
              Arn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateNotificationRule: {
          http: {
            requestUri: "/updateNotificationRule"
          },
          input: {
            type: "structure",
            required: [
              "Arn"
            ],
            members: {
              Arn: {},
              Name: {
                shape: "S2"
              },
              Status: {},
              EventTypeIds: {
                shape: "S3"
              },
              Targets: {
                shape: "S6"
              },
              DetailType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S2: {
          type: "string",
          sensitive: true
        },
        S3: {
          type: "list",
          member: {}
        },
        S6: {
          type: "list",
          member: {
            shape: "S7"
          }
        },
        S7: {
          type: "structure",
          members: {
            TargetType: {},
            TargetAddress: {
              shape: "S9"
            }
          }
        },
        S9: {
          type: "string",
          sensitive: true
        },
        Sc: {
          type: "map",
          key: {},
          value: {}
        },
        Sp: {
          type: "list",
          member: {
            type: "structure",
            members: {
              EventTypeId: {},
              ServiceName: {},
              EventTypeName: {},
              ResourceType: {}
            }
          }
        },
        Su: {
          type: "list",
          member: {
            type: "structure",
            members: {
              TargetAddress: {
                shape: "S9"
              },
              TargetType: {},
              TargetStatus: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codestar-notifications-2019-10-15.paginators.json
var require_codestar_notifications_2019_10_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codestar-notifications-2019-10-15.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListEventTypes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "EventTypes"
        },
        ListNotificationRules: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "NotificationRules"
        },
        ListTargets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Targets"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/codestarnotifications.js
var require_codestarnotifications = __commonJS({
  "node_modules/aws-sdk/clients/codestarnotifications.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["codestarnotifications"] = {};
    AWS3.CodeStarNotifications = Service.defineService("codestarnotifications", ["2019-10-15"]);
    Object.defineProperty(apiLoader.services["codestarnotifications"], "2019-10-15", {
      get: function get() {
        var model = require_codestar_notifications_2019_10_15_min();
        model.paginators = require_codestar_notifications_2019_10_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CodeStarNotifications;
  }
});

// node_modules/aws-sdk/apis/savingsplans-2019-06-28.min.json
var require_savingsplans_2019_06_28_min = __commonJS({
  "node_modules/aws-sdk/apis/savingsplans-2019-06-28.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-06-28",
        endpointPrefix: "savingsplans",
        globalEndpoint: "savingsplans.amazonaws.com",
        jsonVersion: "1.0",
        protocol: "rest-json",
        serviceAbbreviation: "AWSSavingsPlans",
        serviceFullName: "AWS Savings Plans",
        serviceId: "savingsplans",
        signatureVersion: "v4",
        uid: "savingsplans-2019-06-28"
      },
      operations: {
        CreateSavingsPlan: {
          http: {
            requestUri: "/CreateSavingsPlan"
          },
          input: {
            type: "structure",
            required: [
              "savingsPlanOfferingId",
              "commitment"
            ],
            members: {
              savingsPlanOfferingId: {},
              commitment: {},
              upfrontPaymentAmount: {},
              purchaseTime: {
                type: "timestamp"
              },
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              savingsPlanId: {}
            }
          }
        },
        DeleteQueuedSavingsPlan: {
          http: {
            requestUri: "/DeleteQueuedSavingsPlan"
          },
          input: {
            type: "structure",
            required: [
              "savingsPlanId"
            ],
            members: {
              savingsPlanId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeSavingsPlanRates: {
          http: {
            requestUri: "/DescribeSavingsPlanRates"
          },
          input: {
            type: "structure",
            required: [
              "savingsPlanId"
            ],
            members: {
              savingsPlanId: {},
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      shape: "Sh"
                    }
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              savingsPlanId: {},
              searchResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    rate: {},
                    currency: {},
                    unit: {},
                    productType: {},
                    serviceCode: {},
                    usageType: {},
                    operation: {},
                    properties: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          value: {}
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeSavingsPlans: {
          http: {
            requestUri: "/DescribeSavingsPlans"
          },
          input: {
            type: "structure",
            members: {
              savingsPlanArns: {
                type: "list",
                member: {}
              },
              savingsPlanIds: {
                type: "list",
                member: {}
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              states: {
                type: "list",
                member: {}
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      shape: "Sh"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              savingsPlans: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    offeringId: {},
                    savingsPlanId: {},
                    savingsPlanArn: {},
                    description: {},
                    start: {},
                    end: {},
                    state: {},
                    region: {},
                    ec2InstanceFamily: {},
                    savingsPlanType: {},
                    paymentOption: {},
                    productTypes: {
                      shape: "S1e"
                    },
                    currency: {},
                    commitment: {},
                    upfrontPaymentAmount: {},
                    recurringPaymentAmount: {},
                    termDurationInSeconds: {
                      type: "long"
                    },
                    tags: {
                      shape: "S6"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeSavingsPlansOfferingRates: {
          http: {
            requestUri: "/DescribeSavingsPlansOfferingRates"
          },
          input: {
            type: "structure",
            members: {
              savingsPlanOfferingIds: {
                shape: "S1h"
              },
              savingsPlanPaymentOptions: {
                shape: "S1j"
              },
              savingsPlanTypes: {
                shape: "S1k"
              },
              products: {
                shape: "S1e"
              },
              serviceCodes: {
                type: "list",
                member: {}
              },
              usageTypes: {
                type: "list",
                member: {}
              },
              operations: {
                type: "list",
                member: {}
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      shape: "S1r"
                    }
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              searchResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    savingsPlanOffering: {
                      type: "structure",
                      members: {
                        offeringId: {},
                        paymentOption: {},
                        planType: {},
                        durationSeconds: {
                          type: "long"
                        },
                        currency: {},
                        planDescription: {}
                      }
                    },
                    rate: {},
                    unit: {},
                    productType: {},
                    serviceCode: {},
                    usageType: {},
                    operation: {},
                    properties: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          value: {}
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeSavingsPlansOfferings: {
          http: {
            requestUri: "/DescribeSavingsPlansOfferings"
          },
          input: {
            type: "structure",
            members: {
              offeringIds: {
                shape: "S1h"
              },
              paymentOptions: {
                shape: "S1j"
              },
              productType: {},
              planTypes: {
                shape: "S1k"
              },
              durations: {
                type: "list",
                member: {
                  type: "long"
                }
              },
              currencies: {
                type: "list",
                member: {}
              },
              descriptions: {
                type: "list",
                member: {}
              },
              serviceCodes: {
                type: "list",
                member: {}
              },
              usageTypes: {
                type: "list",
                member: {}
              },
              operations: {
                type: "list",
                member: {}
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      shape: "S1r"
                    }
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              searchResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    offeringId: {},
                    productTypes: {
                      shape: "S1e"
                    },
                    planType: {},
                    description: {},
                    paymentOption: {},
                    durationSeconds: {
                      type: "long"
                    },
                    currency: {},
                    serviceCode: {},
                    usageType: {},
                    operation: {},
                    properties: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          value: {}
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            requestUri: "/ListTagsForResource"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S6"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/TagResource"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            requestUri: "/UntagResource"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S6: {
          type: "map",
          key: {},
          value: {}
        },
        Sh: {
          type: "list",
          member: {}
        },
        S1e: {
          type: "list",
          member: {}
        },
        S1h: {
          type: "list",
          member: {}
        },
        S1j: {
          type: "list",
          member: {}
        },
        S1k: {
          type: "list",
          member: {}
        },
        S1r: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/savingsplans-2019-06-28.paginators.json
var require_savingsplans_2019_06_28_paginators = __commonJS({
  "node_modules/aws-sdk/apis/savingsplans-2019-06-28.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/savingsplans.js
var require_savingsplans = __commonJS({
  "node_modules/aws-sdk/clients/savingsplans.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["savingsplans"] = {};
    AWS3.SavingsPlans = Service.defineService("savingsplans", ["2019-06-28"]);
    Object.defineProperty(apiLoader.services["savingsplans"], "2019-06-28", {
      get: function get() {
        var model = require_savingsplans_2019_06_28_min();
        model.paginators = require_savingsplans_2019_06_28_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SavingsPlans;
  }
});

// node_modules/aws-sdk/apis/sso-2019-06-10.min.json
var require_sso_2019_06_10_min = __commonJS({
  "node_modules/aws-sdk/apis/sso-2019-06-10.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-06-10",
        endpointPrefix: "portal.sso",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "SSO",
        serviceFullName: "AWS Single Sign-On",
        serviceId: "SSO",
        signatureVersion: "v4",
        signingName: "awsssoportal",
        uid: "sso-2019-06-10"
      },
      operations: {
        GetRoleCredentials: {
          http: {
            method: "GET",
            requestUri: "/federation/credentials"
          },
          input: {
            type: "structure",
            required: [
              "roleName",
              "accountId",
              "accessToken"
            ],
            members: {
              roleName: {
                location: "querystring",
                locationName: "role_name"
              },
              accountId: {
                location: "querystring",
                locationName: "account_id"
              },
              accessToken: {
                shape: "S4",
                location: "header",
                locationName: "x-amz-sso_bearer_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              roleCredentials: {
                type: "structure",
                members: {
                  accessKeyId: {},
                  secretAccessKey: {
                    type: "string",
                    sensitive: true
                  },
                  sessionToken: {
                    type: "string",
                    sensitive: true
                  },
                  expiration: {
                    type: "long"
                  }
                }
              }
            }
          },
          authtype: "none"
        },
        ListAccountRoles: {
          http: {
            method: "GET",
            requestUri: "/assignment/roles"
          },
          input: {
            type: "structure",
            required: [
              "accessToken",
              "accountId"
            ],
            members: {
              nextToken: {
                location: "querystring",
                locationName: "next_token"
              },
              maxResults: {
                location: "querystring",
                locationName: "max_result",
                type: "integer"
              },
              accessToken: {
                shape: "S4",
                location: "header",
                locationName: "x-amz-sso_bearer_token"
              },
              accountId: {
                location: "querystring",
                locationName: "account_id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              roleList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    roleName: {},
                    accountId: {}
                  }
                }
              }
            }
          },
          authtype: "none"
        },
        ListAccounts: {
          http: {
            method: "GET",
            requestUri: "/assignment/accounts"
          },
          input: {
            type: "structure",
            required: [
              "accessToken"
            ],
            members: {
              nextToken: {
                location: "querystring",
                locationName: "next_token"
              },
              maxResults: {
                location: "querystring",
                locationName: "max_result",
                type: "integer"
              },
              accessToken: {
                shape: "S4",
                location: "header",
                locationName: "x-amz-sso_bearer_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              accountList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {},
                    accountName: {},
                    emailAddress: {}
                  }
                }
              }
            }
          },
          authtype: "none"
        },
        Logout: {
          http: {
            requestUri: "/logout"
          },
          input: {
            type: "structure",
            required: [
              "accessToken"
            ],
            members: {
              accessToken: {
                shape: "S4",
                location: "header",
                locationName: "x-amz-sso_bearer_token"
              }
            }
          },
          authtype: "none"
        }
      },
      shapes: {
        S4: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sso-2019-06-10.paginators.json
var require_sso_2019_06_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sso-2019-06-10.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAccountRoles: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "roleList"
        },
        ListAccounts: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "accountList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/sso.js
var require_sso = __commonJS({
  "node_modules/aws-sdk/clients/sso.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["sso"] = {};
    AWS3.SSO = Service.defineService("sso", ["2019-06-10"]);
    Object.defineProperty(apiLoader.services["sso"], "2019-06-10", {
      get: function get() {
        var model = require_sso_2019_06_10_min();
        model.paginators = require_sso_2019_06_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SSO;
  }
});

// node_modules/aws-sdk/apis/sso-oidc-2019-06-10.min.json
var require_sso_oidc_2019_06_10_min = __commonJS({
  "node_modules/aws-sdk/apis/sso-oidc-2019-06-10.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-06-10",
        endpointPrefix: "oidc",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "SSO OIDC",
        serviceFullName: "AWS SSO OIDC",
        serviceId: "SSO OIDC",
        signatureVersion: "v4",
        signingName: "awsssooidc",
        uid: "sso-oidc-2019-06-10"
      },
      operations: {
        CreateToken: {
          http: {
            requestUri: "/token"
          },
          input: {
            type: "structure",
            required: [
              "clientId",
              "clientSecret",
              "grantType",
              "deviceCode"
            ],
            members: {
              clientId: {},
              clientSecret: {},
              grantType: {},
              deviceCode: {},
              code: {},
              refreshToken: {},
              scope: {
                shape: "S8"
              },
              redirectUri: {}
            }
          },
          output: {
            type: "structure",
            members: {
              accessToken: {},
              tokenType: {},
              expiresIn: {
                type: "integer"
              },
              refreshToken: {},
              idToken: {}
            }
          },
          authtype: "none"
        },
        RegisterClient: {
          http: {
            requestUri: "/client/register"
          },
          input: {
            type: "structure",
            required: [
              "clientName",
              "clientType"
            ],
            members: {
              clientName: {},
              clientType: {},
              scopes: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              clientId: {},
              clientSecret: {},
              clientIdIssuedAt: {
                type: "long"
              },
              clientSecretExpiresAt: {
                type: "long"
              },
              authorizationEndpoint: {},
              tokenEndpoint: {}
            }
          },
          authtype: "none"
        },
        StartDeviceAuthorization: {
          http: {
            requestUri: "/device_authorization"
          },
          input: {
            type: "structure",
            required: [
              "clientId",
              "clientSecret",
              "startUrl"
            ],
            members: {
              clientId: {},
              clientSecret: {},
              startUrl: {}
            }
          },
          output: {
            type: "structure",
            members: {
              deviceCode: {},
              userCode: {},
              verificationUri: {},
              verificationUriComplete: {},
              expiresIn: {
                type: "integer"
              },
              interval: {
                type: "integer"
              }
            }
          },
          authtype: "none"
        }
      },
      shapes: {
        S8: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sso-oidc-2019-06-10.paginators.json
var require_sso_oidc_2019_06_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sso-oidc-2019-06-10.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/ssooidc.js
var require_ssooidc = __commonJS({
  "node_modules/aws-sdk/clients/ssooidc.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["ssooidc"] = {};
    AWS3.SSOOIDC = Service.defineService("ssooidc", ["2019-06-10"]);
    Object.defineProperty(apiLoader.services["ssooidc"], "2019-06-10", {
      get: function get() {
        var model = require_sso_oidc_2019_06_10_min();
        model.paginators = require_sso_oidc_2019_06_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SSOOIDC;
  }
});

// node_modules/aws-sdk/apis/marketplace-catalog-2018-09-17.min.json
var require_marketplace_catalog_2018_09_17_min = __commonJS({
  "node_modules/aws-sdk/apis/marketplace-catalog-2018-09-17.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-09-17",
        endpointPrefix: "catalog.marketplace",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "AWS Marketplace Catalog",
        serviceFullName: "AWS Marketplace Catalog Service",
        serviceId: "Marketplace Catalog",
        signatureVersion: "v4",
        signingName: "aws-marketplace",
        uid: "marketplace-catalog-2018-09-17"
      },
      operations: {
        CancelChangeSet: {
          http: {
            method: "PATCH",
            requestUri: "/CancelChangeSet"
          },
          input: {
            type: "structure",
            required: [
              "Catalog",
              "ChangeSetId"
            ],
            members: {
              Catalog: {
                location: "querystring",
                locationName: "catalog"
              },
              ChangeSetId: {
                location: "querystring",
                locationName: "changeSetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeSetId: {},
              ChangeSetArn: {}
            }
          }
        },
        DescribeChangeSet: {
          http: {
            method: "GET",
            requestUri: "/DescribeChangeSet"
          },
          input: {
            type: "structure",
            required: [
              "Catalog",
              "ChangeSetId"
            ],
            members: {
              Catalog: {
                location: "querystring",
                locationName: "catalog"
              },
              ChangeSetId: {
                location: "querystring",
                locationName: "changeSetId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeSetId: {},
              ChangeSetArn: {},
              ChangeSetName: {},
              StartTime: {},
              EndTime: {},
              Status: {},
              FailureCode: {},
              FailureDescription: {},
              ChangeSet: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ChangeType: {},
                    Entity: {
                      shape: "Sg"
                    },
                    Details: {},
                    ErrorDetailList: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ErrorCode: {},
                          ErrorMessage: {}
                        }
                      }
                    },
                    ChangeName: {}
                  }
                }
              }
            }
          }
        },
        DescribeEntity: {
          http: {
            method: "GET",
            requestUri: "/DescribeEntity"
          },
          input: {
            type: "structure",
            required: [
              "Catalog",
              "EntityId"
            ],
            members: {
              Catalog: {
                location: "querystring",
                locationName: "catalog"
              },
              EntityId: {
                location: "querystring",
                locationName: "entityId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EntityType: {},
              EntityIdentifier: {},
              EntityArn: {},
              LastModifiedDate: {},
              Details: {}
            }
          }
        },
        ListChangeSets: {
          http: {
            requestUri: "/ListChangeSets"
          },
          input: {
            type: "structure",
            required: [
              "Catalog"
            ],
            members: {
              Catalog: {},
              FilterList: {
                shape: "Sr"
              },
              Sort: {
                shape: "Sw"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeSetSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ChangeSetId: {},
                    ChangeSetArn: {},
                    ChangeSetName: {},
                    StartTime: {},
                    EndTime: {},
                    Status: {},
                    EntityIdList: {
                      type: "list",
                      member: {}
                    },
                    FailureCode: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEntities: {
          http: {
            requestUri: "/ListEntities"
          },
          input: {
            type: "structure",
            required: [
              "Catalog",
              "EntityType"
            ],
            members: {
              Catalog: {},
              EntityType: {},
              FilterList: {
                shape: "Sr"
              },
              Sort: {
                shape: "Sw"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EntitySummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    EntityType: {},
                    EntityId: {},
                    EntityArn: {},
                    LastModifiedDate: {},
                    Visibility: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        StartChangeSet: {
          http: {
            requestUri: "/StartChangeSet"
          },
          input: {
            type: "structure",
            required: [
              "Catalog",
              "ChangeSet"
            ],
            members: {
              Catalog: {},
              ChangeSet: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ChangeType",
                    "Entity",
                    "Details"
                  ],
                  members: {
                    ChangeType: {},
                    Entity: {
                      shape: "Sg"
                    },
                    Details: {},
                    ChangeName: {}
                  }
                }
              },
              ChangeSetName: {},
              ClientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ChangeSetId: {},
              ChangeSetArn: {}
            }
          }
        }
      },
      shapes: {
        Sg: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Type: {},
            Identifier: {}
          }
        },
        Sr: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              ValueList: {
                type: "list",
                member: {}
              }
            }
          }
        },
        Sw: {
          type: "structure",
          members: {
            SortBy: {},
            SortOrder: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/marketplace-catalog-2018-09-17.paginators.json
var require_marketplace_catalog_2018_09_17_paginators = __commonJS({
  "node_modules/aws-sdk/apis/marketplace-catalog-2018-09-17.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListChangeSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListEntities: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/marketplacecatalog.js
var require_marketplacecatalog = __commonJS({
  "node_modules/aws-sdk/clients/marketplacecatalog.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["marketplacecatalog"] = {};
    AWS3.MarketplaceCatalog = Service.defineService("marketplacecatalog", ["2018-09-17"]);
    Object.defineProperty(apiLoader.services["marketplacecatalog"], "2018-09-17", {
      get: function get() {
        var model = require_marketplace_catalog_2018_09_17_min();
        model.paginators = require_marketplace_catalog_2018_09_17_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.MarketplaceCatalog;
  }
});

// node_modules/aws-sdk/apis/dataexchange-2017-07-25.min.json
var require_dataexchange_2017_07_25_min = __commonJS({
  "node_modules/aws-sdk/apis/dataexchange-2017-07-25.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2017-07-25",
        endpointPrefix: "dataexchange",
        signingName: "dataexchange",
        serviceFullName: "AWS Data Exchange",
        serviceId: "DataExchange",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "dataexchange-2017-07-25",
        signatureVersion: "v4"
      },
      operations: {
        CancelJob: {
          http: {
            method: "DELETE",
            requestUri: "/v1/jobs/{JobId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              JobId: {
                location: "uri",
                locationName: "JobId"
              }
            },
            required: [
              "JobId"
            ]
          }
        },
        CreateDataSet: {
          http: {
            requestUri: "/v1/data-sets",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              AssetType: {},
              Description: {},
              Name: {},
              Tags: {
                shape: "S7"
              }
            },
            required: [
              "AssetType",
              "Description",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AssetType: {},
              CreatedAt: {
                shape: "Sa"
              },
              Description: {},
              Id: {},
              Name: {},
              Origin: {},
              OriginDetails: {
                shape: "Sd"
              },
              SourceId: {},
              Tags: {
                shape: "S7"
              },
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        CreateEventAction: {
          http: {
            requestUri: "/v1/event-actions",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Action: {
                shape: "Sf"
              },
              Event: {
                shape: "Sk"
              }
            },
            required: [
              "Action",
              "Event"
            ]
          },
          output: {
            type: "structure",
            members: {
              Action: {
                shape: "Sf"
              },
              Arn: {},
              CreatedAt: {
                shape: "Sa"
              },
              Event: {
                shape: "Sk"
              },
              Id: {},
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        CreateJob: {
          http: {
            requestUri: "/v1/jobs",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Details: {
                type: "structure",
                members: {
                  ExportAssetToSignedUrl: {
                    type: "structure",
                    members: {
                      AssetId: {},
                      DataSetId: {},
                      RevisionId: {}
                    },
                    required: [
                      "DataSetId",
                      "AssetId",
                      "RevisionId"
                    ]
                  },
                  ExportAssetsToS3: {
                    type: "structure",
                    members: {
                      AssetDestinations: {
                        shape: "Sr"
                      },
                      DataSetId: {},
                      Encryption: {
                        shape: "Sh"
                      },
                      RevisionId: {}
                    },
                    required: [
                      "AssetDestinations",
                      "DataSetId",
                      "RevisionId"
                    ]
                  },
                  ExportRevisionsToS3: {
                    type: "structure",
                    members: {
                      DataSetId: {},
                      Encryption: {
                        shape: "Sh"
                      },
                      RevisionDestinations: {
                        shape: "Su"
                      }
                    },
                    required: [
                      "RevisionDestinations",
                      "DataSetId"
                    ]
                  },
                  ImportAssetFromSignedUrl: {
                    type: "structure",
                    members: {
                      AssetName: {},
                      DataSetId: {},
                      Md5Hash: {},
                      RevisionId: {}
                    },
                    required: [
                      "DataSetId",
                      "Md5Hash",
                      "AssetName",
                      "RevisionId"
                    ]
                  },
                  ImportAssetsFromS3: {
                    type: "structure",
                    members: {
                      AssetSources: {
                        shape: "S10"
                      },
                      DataSetId: {},
                      RevisionId: {}
                    },
                    required: [
                      "DataSetId",
                      "AssetSources",
                      "RevisionId"
                    ]
                  }
                }
              },
              Type: {}
            },
            required: [
              "Type",
              "Details"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreatedAt: {
                shape: "Sa"
              },
              Details: {
                shape: "S14"
              },
              Errors: {
                shape: "S1a"
              },
              Id: {},
              State: {},
              Type: {},
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        CreateRevision: {
          http: {
            requestUri: "/v1/data-sets/{DataSetId}/revisions",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Comment: {},
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              Tags: {
                shape: "S7"
              }
            },
            required: [
              "DataSetId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Comment: {},
              CreatedAt: {
                shape: "Sa"
              },
              DataSetId: {},
              Finalized: {
                type: "boolean"
              },
              Id: {},
              SourceId: {},
              Tags: {
                shape: "S7"
              },
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        DeleteAsset: {
          http: {
            method: "DELETE",
            requestUri: "/v1/data-sets/{DataSetId}/revisions/{RevisionId}/assets/{AssetId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              AssetId: {
                location: "uri",
                locationName: "AssetId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              RevisionId: {
                location: "uri",
                locationName: "RevisionId"
              }
            },
            required: [
              "RevisionId",
              "AssetId",
              "DataSetId"
            ]
          }
        },
        DeleteDataSet: {
          http: {
            method: "DELETE",
            requestUri: "/v1/data-sets/{DataSetId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              }
            },
            required: [
              "DataSetId"
            ]
          }
        },
        DeleteEventAction: {
          http: {
            method: "DELETE",
            requestUri: "/v1/event-actions/{EventActionId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              EventActionId: {
                location: "uri",
                locationName: "EventActionId"
              }
            },
            required: [
              "EventActionId"
            ]
          }
        },
        DeleteRevision: {
          http: {
            method: "DELETE",
            requestUri: "/v1/data-sets/{DataSetId}/revisions/{RevisionId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              RevisionId: {
                location: "uri",
                locationName: "RevisionId"
              }
            },
            required: [
              "RevisionId",
              "DataSetId"
            ]
          }
        },
        GetAsset: {
          http: {
            method: "GET",
            requestUri: "/v1/data-sets/{DataSetId}/revisions/{RevisionId}/assets/{AssetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AssetId: {
                location: "uri",
                locationName: "AssetId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              RevisionId: {
                location: "uri",
                locationName: "RevisionId"
              }
            },
            required: [
              "RevisionId",
              "AssetId",
              "DataSetId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AssetDetails: {
                shape: "S1t"
              },
              AssetType: {},
              CreatedAt: {
                shape: "Sa"
              },
              DataSetId: {},
              Id: {},
              Name: {},
              RevisionId: {},
              SourceId: {},
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        GetDataSet: {
          http: {
            method: "GET",
            requestUri: "/v1/data-sets/{DataSetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              }
            },
            required: [
              "DataSetId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AssetType: {},
              CreatedAt: {
                shape: "Sa"
              },
              Description: {},
              Id: {},
              Name: {},
              Origin: {},
              OriginDetails: {
                shape: "Sd"
              },
              SourceId: {},
              Tags: {
                shape: "S7"
              },
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        GetEventAction: {
          http: {
            method: "GET",
            requestUri: "/v1/event-actions/{EventActionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              EventActionId: {
                location: "uri",
                locationName: "EventActionId"
              }
            },
            required: [
              "EventActionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Action: {
                shape: "Sf"
              },
              Arn: {},
              CreatedAt: {
                shape: "Sa"
              },
              Event: {
                shape: "Sk"
              },
              Id: {},
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        GetJob: {
          http: {
            method: "GET",
            requestUri: "/v1/jobs/{JobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              JobId: {
                location: "uri",
                locationName: "JobId"
              }
            },
            required: [
              "JobId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              CreatedAt: {
                shape: "Sa"
              },
              Details: {
                shape: "S14"
              },
              Errors: {
                shape: "S1a"
              },
              Id: {},
              State: {},
              Type: {},
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        GetRevision: {
          http: {
            method: "GET",
            requestUri: "/v1/data-sets/{DataSetId}/revisions/{RevisionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              RevisionId: {
                location: "uri",
                locationName: "RevisionId"
              }
            },
            required: [
              "RevisionId",
              "DataSetId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Comment: {},
              CreatedAt: {
                shape: "Sa"
              },
              DataSetId: {},
              Finalized: {
                type: "boolean"
              },
              Id: {},
              SourceId: {},
              Tags: {
                shape: "S7"
              },
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        ListDataSetRevisions: {
          http: {
            method: "GET",
            requestUri: "/v1/data-sets/{DataSetId}/revisions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "DataSetId"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Revisions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Comment: {},
                    CreatedAt: {
                      shape: "Sa"
                    },
                    DataSetId: {},
                    Finalized: {
                      type: "boolean"
                    },
                    Id: {},
                    SourceId: {},
                    UpdatedAt: {
                      shape: "Sa"
                    }
                  },
                  required: [
                    "CreatedAt",
                    "DataSetId",
                    "Id",
                    "Arn",
                    "UpdatedAt"
                  ]
                }
              }
            }
          }
        },
        ListDataSets: {
          http: {
            method: "GET",
            requestUri: "/v1/data-sets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              Origin: {
                location: "querystring",
                locationName: "origin"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataSets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    AssetType: {},
                    CreatedAt: {
                      shape: "Sa"
                    },
                    Description: {},
                    Id: {},
                    Name: {},
                    Origin: {},
                    OriginDetails: {
                      shape: "Sd"
                    },
                    SourceId: {},
                    UpdatedAt: {
                      shape: "Sa"
                    }
                  },
                  required: [
                    "Origin",
                    "AssetType",
                    "Description",
                    "CreatedAt",
                    "Id",
                    "Arn",
                    "UpdatedAt",
                    "Name"
                  ]
                }
              },
              NextToken: {}
            }
          }
        },
        ListEventActions: {
          http: {
            method: "GET",
            requestUri: "/v1/event-actions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              EventSourceId: {
                location: "querystring",
                locationName: "eventSourceId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventActions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Action: {
                      shape: "Sf"
                    },
                    Arn: {},
                    CreatedAt: {
                      shape: "Sa"
                    },
                    Event: {
                      shape: "Sk"
                    },
                    Id: {},
                    UpdatedAt: {
                      shape: "Sa"
                    }
                  },
                  required: [
                    "Action",
                    "CreatedAt",
                    "Event",
                    "Id",
                    "Arn",
                    "UpdatedAt"
                  ]
                }
              },
              NextToken: {}
            }
          }
        },
        ListJobs: {
          http: {
            method: "GET",
            requestUri: "/v1/jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DataSetId: {
                location: "querystring",
                locationName: "dataSetId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RevisionId: {
                location: "querystring",
                locationName: "revisionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Jobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreatedAt: {
                      shape: "Sa"
                    },
                    Details: {
                      shape: "S14"
                    },
                    Errors: {
                      shape: "S1a"
                    },
                    Id: {},
                    State: {},
                    Type: {},
                    UpdatedAt: {
                      shape: "Sa"
                    }
                  },
                  required: [
                    "Type",
                    "Details",
                    "State",
                    "CreatedAt",
                    "Id",
                    "Arn",
                    "UpdatedAt"
                  ]
                }
              },
              NextToken: {}
            }
          }
        },
        ListRevisionAssets: {
          http: {
            method: "GET",
            requestUri: "/v1/data-sets/{DataSetId}/revisions/{RevisionId}/assets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RevisionId: {
                location: "uri",
                locationName: "RevisionId"
              }
            },
            required: [
              "RevisionId",
              "DataSetId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Assets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    AssetDetails: {
                      shape: "S1t"
                    },
                    AssetType: {},
                    CreatedAt: {
                      shape: "Sa"
                    },
                    DataSetId: {},
                    Id: {},
                    Name: {},
                    RevisionId: {},
                    SourceId: {},
                    UpdatedAt: {
                      shape: "Sa"
                    }
                  },
                  required: [
                    "AssetType",
                    "CreatedAt",
                    "DataSetId",
                    "Id",
                    "Arn",
                    "AssetDetails",
                    "UpdatedAt",
                    "RevisionId",
                    "Name"
                  ]
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S7",
                locationName: "tags"
              }
            }
          }
        },
        StartJob: {
          http: {
            method: "PATCH",
            requestUri: "/v1/jobs/{JobId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              JobId: {
                location: "uri",
                locationName: "JobId"
              }
            },
            required: [
              "JobId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              Tags: {
                shape: "S7",
                locationName: "tags"
              }
            },
            required: [
              "ResourceArn",
              "Tags"
            ]
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ]
          }
        },
        UpdateAsset: {
          http: {
            method: "PATCH",
            requestUri: "/v1/data-sets/{DataSetId}/revisions/{RevisionId}/assets/{AssetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AssetId: {
                location: "uri",
                locationName: "AssetId"
              },
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              Name: {},
              RevisionId: {
                location: "uri",
                locationName: "RevisionId"
              }
            },
            required: [
              "RevisionId",
              "AssetId",
              "DataSetId",
              "Name"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AssetDetails: {
                shape: "S1t"
              },
              AssetType: {},
              CreatedAt: {
                shape: "Sa"
              },
              DataSetId: {},
              Id: {},
              Name: {},
              RevisionId: {},
              SourceId: {},
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        UpdateDataSet: {
          http: {
            method: "PATCH",
            requestUri: "/v1/data-sets/{DataSetId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              Description: {},
              Name: {}
            },
            required: [
              "DataSetId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              AssetType: {},
              CreatedAt: {
                shape: "Sa"
              },
              Description: {},
              Id: {},
              Name: {},
              Origin: {},
              OriginDetails: {
                shape: "Sd"
              },
              SourceId: {},
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        UpdateEventAction: {
          http: {
            method: "PATCH",
            requestUri: "/v1/event-actions/{EventActionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Action: {
                shape: "Sf"
              },
              EventActionId: {
                location: "uri",
                locationName: "EventActionId"
              }
            },
            required: [
              "EventActionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Action: {
                shape: "Sf"
              },
              Arn: {},
              CreatedAt: {
                shape: "Sa"
              },
              Event: {
                shape: "Sk"
              },
              Id: {},
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        },
        UpdateRevision: {
          http: {
            method: "PATCH",
            requestUri: "/v1/data-sets/{DataSetId}/revisions/{RevisionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Comment: {},
              DataSetId: {
                location: "uri",
                locationName: "DataSetId"
              },
              Finalized: {
                type: "boolean"
              },
              RevisionId: {
                location: "uri",
                locationName: "RevisionId"
              }
            },
            required: [
              "RevisionId",
              "DataSetId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Comment: {},
              CreatedAt: {
                shape: "Sa"
              },
              DataSetId: {},
              Finalized: {
                type: "boolean"
              },
              Id: {},
              SourceId: {},
              UpdatedAt: {
                shape: "Sa"
              }
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "map",
          key: {},
          value: {}
        },
        Sa: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sd: {
          type: "structure",
          members: {
            ProductId: {}
          },
          required: [
            "ProductId"
          ]
        },
        Sf: {
          type: "structure",
          members: {
            ExportRevisionToS3: {
              type: "structure",
              members: {
                Encryption: {
                  shape: "Sh"
                },
                RevisionDestination: {
                  type: "structure",
                  members: {
                    Bucket: {},
                    KeyPattern: {}
                  },
                  required: [
                    "Bucket"
                  ]
                }
              },
              required: [
                "RevisionDestination"
              ]
            }
          }
        },
        Sh: {
          type: "structure",
          members: {
            KmsKeyArn: {},
            Type: {}
          },
          required: [
            "Type"
          ]
        },
        Sk: {
          type: "structure",
          members: {
            RevisionPublished: {
              type: "structure",
              members: {
                DataSetId: {}
              },
              required: [
                "DataSetId"
              ]
            }
          }
        },
        Sr: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AssetId: {},
              Bucket: {},
              Key: {}
            },
            required: [
              "Bucket",
              "AssetId"
            ]
          }
        },
        Su: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Bucket: {},
              KeyPattern: {},
              RevisionId: {}
            },
            required: [
              "Bucket",
              "RevisionId"
            ]
          }
        },
        S10: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Bucket: {},
              Key: {}
            },
            required: [
              "Bucket",
              "Key"
            ]
          }
        },
        S14: {
          type: "structure",
          members: {
            ExportAssetToSignedUrl: {
              type: "structure",
              members: {
                AssetId: {},
                DataSetId: {},
                RevisionId: {},
                SignedUrl: {},
                SignedUrlExpiresAt: {
                  shape: "Sa"
                }
              },
              required: [
                "DataSetId",
                "AssetId",
                "RevisionId"
              ]
            },
            ExportAssetsToS3: {
              type: "structure",
              members: {
                AssetDestinations: {
                  shape: "Sr"
                },
                DataSetId: {},
                Encryption: {
                  shape: "Sh"
                },
                RevisionId: {}
              },
              required: [
                "AssetDestinations",
                "DataSetId",
                "RevisionId"
              ]
            },
            ExportRevisionsToS3: {
              type: "structure",
              members: {
                DataSetId: {},
                Encryption: {
                  shape: "Sh"
                },
                RevisionDestinations: {
                  shape: "Su"
                }
              },
              required: [
                "RevisionDestinations",
                "DataSetId"
              ]
            },
            ImportAssetFromSignedUrl: {
              type: "structure",
              members: {
                AssetName: {},
                DataSetId: {},
                Md5Hash: {},
                RevisionId: {},
                SignedUrl: {},
                SignedUrlExpiresAt: {
                  shape: "Sa"
                }
              },
              required: [
                "DataSetId",
                "AssetName",
                "RevisionId"
              ]
            },
            ImportAssetsFromS3: {
              type: "structure",
              members: {
                AssetSources: {
                  shape: "S10"
                },
                DataSetId: {},
                RevisionId: {}
              },
              required: [
                "DataSetId",
                "AssetSources",
                "RevisionId"
              ]
            }
          }
        },
        S1a: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Code: {},
              Details: {
                type: "structure",
                members: {
                  ImportAssetFromSignedUrlJobErrorDetails: {
                    type: "structure",
                    members: {
                      AssetName: {}
                    },
                    required: [
                      "AssetName"
                    ]
                  },
                  ImportAssetsFromS3JobErrorDetails: {
                    shape: "S10"
                  }
                }
              },
              LimitName: {},
              LimitValue: {
                type: "double"
              },
              Message: {},
              ResourceId: {},
              ResourceType: {}
            },
            required: [
              "Message",
              "Code"
            ]
          }
        },
        S1t: {
          type: "structure",
          members: {
            S3SnapshotAsset: {
              type: "structure",
              members: {
                Size: {
                  type: "double"
                }
              },
              required: [
                "Size"
              ]
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/dataexchange-2017-07-25.paginators.json
var require_dataexchange_2017_07_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/dataexchange-2017-07-25.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListDataSetRevisions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Revisions"
        },
        ListDataSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DataSets"
        },
        ListEventActions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "EventActions"
        },
        ListJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Jobs"
        },
        ListRevisionAssets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Assets"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/dataexchange.js
var require_dataexchange = __commonJS({
  "node_modules/aws-sdk/clients/dataexchange.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["dataexchange"] = {};
    AWS3.DataExchange = Service.defineService("dataexchange", ["2017-07-25"]);
    Object.defineProperty(apiLoader.services["dataexchange"], "2017-07-25", {
      get: function get() {
        var model = require_dataexchange_2017_07_25_min();
        model.paginators = require_dataexchange_2017_07_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.DataExchange;
  }
});

// node_modules/aws-sdk/apis/sesv2-2019-09-27.min.json
var require_sesv2_2019_09_27_min = __commonJS({
  "node_modules/aws-sdk/apis/sesv2-2019-09-27.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-09-27",
        endpointPrefix: "email",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon SES V2",
        serviceFullName: "Amazon Simple Email Service",
        serviceId: "SESv2",
        signatureVersion: "v4",
        signingName: "ses",
        uid: "sesv2-2019-09-27"
      },
      operations: {
        CreateConfigurationSet: {
          http: {
            requestUri: "/v2/email/configuration-sets"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {},
              TrackingOptions: {
                shape: "S3"
              },
              DeliveryOptions: {
                shape: "S5"
              },
              ReputationOptions: {
                shape: "S8"
              },
              SendingOptions: {
                shape: "Sb"
              },
              Tags: {
                shape: "Sc"
              },
              SuppressionOptions: {
                shape: "Sg"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateConfigurationSetEventDestination: {
          http: {
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}/event-destinations"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestinationName",
              "EventDestination"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              EventDestinationName: {},
              EventDestination: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateContact: {
          http: {
            requestUri: "/v2/email/contact-lists/{ContactListName}/contacts"
          },
          input: {
            type: "structure",
            required: [
              "ContactListName",
              "EmailAddress"
            ],
            members: {
              ContactListName: {
                location: "uri",
                locationName: "ContactListName"
              },
              EmailAddress: {},
              TopicPreferences: {
                shape: "S13"
              },
              UnsubscribeAll: {
                type: "boolean"
              },
              AttributesData: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateContactList: {
          http: {
            requestUri: "/v2/email/contact-lists"
          },
          input: {
            type: "structure",
            required: [
              "ContactListName"
            ],
            members: {
              ContactListName: {},
              Topics: {
                shape: "S1b"
              },
              Description: {},
              Tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateCustomVerificationEmailTemplate: {
          http: {
            requestUri: "/v2/email/custom-verification-email-templates"
          },
          input: {
            type: "structure",
            required: [
              "TemplateName",
              "FromEmailAddress",
              "TemplateSubject",
              "TemplateContent",
              "SuccessRedirectionURL",
              "FailureRedirectionURL"
            ],
            members: {
              TemplateName: {},
              FromEmailAddress: {},
              TemplateSubject: {},
              TemplateContent: {},
              SuccessRedirectionURL: {},
              FailureRedirectionURL: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDedicatedIpPool: {
          http: {
            requestUri: "/v2/email/dedicated-ip-pools"
          },
          input: {
            type: "structure",
            required: [
              "PoolName"
            ],
            members: {
              PoolName: {},
              Tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDeliverabilityTestReport: {
          http: {
            requestUri: "/v2/email/deliverability-dashboard/test"
          },
          input: {
            type: "structure",
            required: [
              "FromEmailAddress",
              "Content"
            ],
            members: {
              ReportName: {},
              FromEmailAddress: {},
              Content: {
                shape: "S1r"
              },
              Tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ReportId",
              "DeliverabilityTestStatus"
            ],
            members: {
              ReportId: {},
              DeliverabilityTestStatus: {}
            }
          }
        },
        CreateEmailIdentity: {
          http: {
            requestUri: "/v2/email/identities"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {},
              Tags: {
                shape: "Sc"
              },
              DkimSigningAttributes: {
                shape: "S26"
              },
              ConfigurationSetName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityType: {},
              VerifiedForSendingStatus: {
                type: "boolean"
              },
              DkimAttributes: {
                shape: "S2c"
              }
            }
          }
        },
        CreateEmailIdentityPolicy: {
          http: {
            requestUri: "/v2/email/identities/{EmailIdentity}/policies/{PolicyName}"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity",
              "PolicyName",
              "Policy"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              PolicyName: {
                location: "uri",
                locationName: "PolicyName"
              },
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateEmailTemplate: {
          http: {
            requestUri: "/v2/email/templates"
          },
          input: {
            type: "structure",
            required: [
              "TemplateName",
              "TemplateContent"
            ],
            members: {
              TemplateName: {},
              TemplateContent: {
                shape: "S2n"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateImportJob: {
          http: {
            requestUri: "/v2/email/import-jobs"
          },
          input: {
            type: "structure",
            required: [
              "ImportDestination",
              "ImportDataSource"
            ],
            members: {
              ImportDestination: {
                shape: "S2s"
              },
              ImportDataSource: {
                shape: "S2x"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {}
            }
          }
        },
        DeleteConfigurationSet: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteConfigurationSetEventDestination: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}/event-destinations/{EventDestinationName}"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestinationName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              EventDestinationName: {
                location: "uri",
                locationName: "EventDestinationName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteContact: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/contact-lists/{ContactListName}/contacts/{EmailAddress}"
          },
          input: {
            type: "structure",
            required: [
              "ContactListName",
              "EmailAddress"
            ],
            members: {
              ContactListName: {
                location: "uri",
                locationName: "ContactListName"
              },
              EmailAddress: {
                location: "uri",
                locationName: "EmailAddress"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteContactList: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/contact-lists/{ContactListName}"
          },
          input: {
            type: "structure",
            required: [
              "ContactListName"
            ],
            members: {
              ContactListName: {
                location: "uri",
                locationName: "ContactListName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteCustomVerificationEmailTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/custom-verification-email-templates/{TemplateName}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateName"
            ],
            members: {
              TemplateName: {
                location: "uri",
                locationName: "TemplateName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDedicatedIpPool: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/dedicated-ip-pools/{PoolName}"
          },
          input: {
            type: "structure",
            required: [
              "PoolName"
            ],
            members: {
              PoolName: {
                location: "uri",
                locationName: "PoolName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEmailIdentity: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/identities/{EmailIdentity}"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEmailIdentityPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/identities/{EmailIdentity}/policies/{PolicyName}"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity",
              "PolicyName"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              PolicyName: {
                location: "uri",
                locationName: "PolicyName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEmailTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/templates/{TemplateName}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateName"
            ],
            members: {
              TemplateName: {
                location: "uri",
                locationName: "TemplateName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSuppressedDestination: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/suppression/addresses/{EmailAddress}"
          },
          input: {
            type: "structure",
            required: [
              "EmailAddress"
            ],
            members: {
              EmailAddress: {
                location: "uri",
                locationName: "EmailAddress"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAccount: {
          http: {
            method: "GET",
            requestUri: "/v2/email/account"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              DedicatedIpAutoWarmupEnabled: {
                type: "boolean"
              },
              EnforcementStatus: {},
              ProductionAccessEnabled: {
                type: "boolean"
              },
              SendQuota: {
                type: "structure",
                members: {
                  Max24HourSend: {
                    type: "double"
                  },
                  MaxSendRate: {
                    type: "double"
                  },
                  SentLast24Hours: {
                    type: "double"
                  }
                }
              },
              SendingEnabled: {
                type: "boolean"
              },
              SuppressionAttributes: {
                type: "structure",
                members: {
                  SuppressedReasons: {
                    shape: "Sh"
                  }
                }
              },
              Details: {
                type: "structure",
                members: {
                  MailType: {},
                  WebsiteURL: {
                    shape: "S3w"
                  },
                  ContactLanguage: {},
                  UseCaseDescription: {
                    shape: "S3y"
                  },
                  AdditionalContactEmailAddresses: {
                    shape: "S3z"
                  },
                  ReviewDetails: {
                    type: "structure",
                    members: {
                      Status: {},
                      CaseId: {}
                    }
                  }
                }
              }
            }
          }
        },
        GetBlacklistReports: {
          http: {
            method: "GET",
            requestUri: "/v2/email/deliverability-dashboard/blacklist-report"
          },
          input: {
            type: "structure",
            required: [
              "BlacklistItemNames"
            ],
            members: {
              BlacklistItemNames: {
                location: "querystring",
                locationName: "BlacklistItemNames",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "BlacklistReport"
            ],
            members: {
              BlacklistReport: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      RblName: {},
                      ListingTime: {
                        type: "timestamp"
                      },
                      Description: {}
                    }
                  }
                }
              }
            }
          }
        },
        GetConfigurationSet: {
          http: {
            method: "GET",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationSetName: {},
              TrackingOptions: {
                shape: "S3"
              },
              DeliveryOptions: {
                shape: "S5"
              },
              ReputationOptions: {
                shape: "S8"
              },
              SendingOptions: {
                shape: "Sb"
              },
              Tags: {
                shape: "Sc"
              },
              SuppressionOptions: {
                shape: "Sg"
              }
            }
          }
        },
        GetConfigurationSetEventDestinations: {
          http: {
            method: "GET",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}/event-destinations"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventDestinations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "MatchingEventTypes"
                  ],
                  members: {
                    Name: {},
                    Enabled: {
                      type: "boolean"
                    },
                    MatchingEventTypes: {
                      shape: "Sn"
                    },
                    KinesisFirehoseDestination: {
                      shape: "Sp"
                    },
                    CloudWatchDestination: {
                      shape: "Sr"
                    },
                    SnsDestination: {
                      shape: "Sx"
                    },
                    PinpointDestination: {
                      shape: "Sy"
                    }
                  }
                }
              }
            }
          }
        },
        GetContact: {
          http: {
            method: "GET",
            requestUri: "/v2/email/contact-lists/{ContactListName}/contacts/{EmailAddress}"
          },
          input: {
            type: "structure",
            required: [
              "ContactListName",
              "EmailAddress"
            ],
            members: {
              ContactListName: {
                location: "uri",
                locationName: "ContactListName"
              },
              EmailAddress: {
                location: "uri",
                locationName: "EmailAddress"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactListName: {},
              EmailAddress: {},
              TopicPreferences: {
                shape: "S13"
              },
              TopicDefaultPreferences: {
                shape: "S13"
              },
              UnsubscribeAll: {
                type: "boolean"
              },
              AttributesData: {},
              CreatedTimestamp: {
                type: "timestamp"
              },
              LastUpdatedTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        GetContactList: {
          http: {
            method: "GET",
            requestUri: "/v2/email/contact-lists/{ContactListName}"
          },
          input: {
            type: "structure",
            required: [
              "ContactListName"
            ],
            members: {
              ContactListName: {
                location: "uri",
                locationName: "ContactListName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactListName: {},
              Topics: {
                shape: "S1b"
              },
              Description: {},
              CreatedTimestamp: {
                type: "timestamp"
              },
              LastUpdatedTimestamp: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        GetCustomVerificationEmailTemplate: {
          http: {
            method: "GET",
            requestUri: "/v2/email/custom-verification-email-templates/{TemplateName}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateName"
            ],
            members: {
              TemplateName: {
                location: "uri",
                locationName: "TemplateName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateName: {},
              FromEmailAddress: {},
              TemplateSubject: {},
              TemplateContent: {},
              SuccessRedirectionURL: {},
              FailureRedirectionURL: {}
            }
          }
        },
        GetDedicatedIp: {
          http: {
            method: "GET",
            requestUri: "/v2/email/dedicated-ips/{IP}"
          },
          input: {
            type: "structure",
            required: [
              "Ip"
            ],
            members: {
              Ip: {
                location: "uri",
                locationName: "IP"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DedicatedIp: {
                shape: "S4s"
              }
            }
          }
        },
        GetDedicatedIps: {
          http: {
            method: "GET",
            requestUri: "/v2/email/dedicated-ips"
          },
          input: {
            type: "structure",
            members: {
              PoolName: {
                location: "querystring",
                locationName: "PoolName"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DedicatedIps: {
                type: "list",
                member: {
                  shape: "S4s"
                }
              },
              NextToken: {}
            }
          }
        },
        GetDeliverabilityDashboardOptions: {
          http: {
            method: "GET",
            requestUri: "/v2/email/deliverability-dashboard"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "DashboardEnabled"
            ],
            members: {
              DashboardEnabled: {
                type: "boolean"
              },
              SubscriptionExpiryDate: {
                type: "timestamp"
              },
              AccountStatus: {},
              ActiveSubscribedDomains: {
                shape: "S53"
              },
              PendingExpirationSubscribedDomains: {
                shape: "S53"
              }
            }
          }
        },
        GetDeliverabilityTestReport: {
          http: {
            method: "GET",
            requestUri: "/v2/email/deliverability-dashboard/test-reports/{ReportId}"
          },
          input: {
            type: "structure",
            required: [
              "ReportId"
            ],
            members: {
              ReportId: {
                location: "uri",
                locationName: "ReportId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DeliverabilityTestReport",
              "OverallPlacement",
              "IspPlacements"
            ],
            members: {
              DeliverabilityTestReport: {
                shape: "S5b"
              },
              OverallPlacement: {
                shape: "S5d"
              },
              IspPlacements: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IspName: {},
                    PlacementStatistics: {
                      shape: "S5d"
                    }
                  }
                }
              },
              Message: {},
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        GetDomainDeliverabilityCampaign: {
          http: {
            method: "GET",
            requestUri: "/v2/email/deliverability-dashboard/campaigns/{CampaignId}"
          },
          input: {
            type: "structure",
            required: [
              "CampaignId"
            ],
            members: {
              CampaignId: {
                location: "uri",
                locationName: "CampaignId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainDeliverabilityCampaign"
            ],
            members: {
              DomainDeliverabilityCampaign: {
                shape: "S5l"
              }
            }
          }
        },
        GetDomainStatisticsReport: {
          http: {
            method: "GET",
            requestUri: "/v2/email/deliverability-dashboard/statistics-report/{Domain}"
          },
          input: {
            type: "structure",
            required: [
              "Domain",
              "StartDate",
              "EndDate"
            ],
            members: {
              Domain: {
                location: "uri",
                locationName: "Domain"
              },
              StartDate: {
                location: "querystring",
                locationName: "StartDate",
                type: "timestamp"
              },
              EndDate: {
                location: "querystring",
                locationName: "EndDate",
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "OverallVolume",
              "DailyVolumes"
            ],
            members: {
              OverallVolume: {
                type: "structure",
                members: {
                  VolumeStatistics: {
                    shape: "S5v"
                  },
                  ReadRatePercent: {
                    type: "double"
                  },
                  DomainIspPlacements: {
                    shape: "S5w"
                  }
                }
              },
              DailyVolumes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StartDate: {
                      type: "timestamp"
                    },
                    VolumeStatistics: {
                      shape: "S5v"
                    },
                    DomainIspPlacements: {
                      shape: "S5w"
                    }
                  }
                }
              }
            }
          }
        },
        GetEmailIdentity: {
          http: {
            method: "GET",
            requestUri: "/v2/email/identities/{EmailIdentity}"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IdentityType: {},
              FeedbackForwardingStatus: {
                type: "boolean"
              },
              VerifiedForSendingStatus: {
                type: "boolean"
              },
              DkimAttributes: {
                shape: "S2c"
              },
              MailFromAttributes: {
                type: "structure",
                required: [
                  "MailFromDomain",
                  "MailFromDomainStatus",
                  "BehaviorOnMxFailure"
                ],
                members: {
                  MailFromDomain: {},
                  MailFromDomainStatus: {},
                  BehaviorOnMxFailure: {}
                }
              },
              Policies: {
                shape: "S66"
              },
              Tags: {
                shape: "Sc"
              },
              ConfigurationSetName: {}
            }
          }
        },
        GetEmailIdentityPolicies: {
          http: {
            method: "GET",
            requestUri: "/v2/email/identities/{EmailIdentity}/policies"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policies: {
                shape: "S66"
              }
            }
          }
        },
        GetEmailTemplate: {
          http: {
            method: "GET",
            requestUri: "/v2/email/templates/{TemplateName}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateName"
            ],
            members: {
              TemplateName: {
                location: "uri",
                locationName: "TemplateName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TemplateName",
              "TemplateContent"
            ],
            members: {
              TemplateName: {},
              TemplateContent: {
                shape: "S2n"
              }
            }
          }
        },
        GetImportJob: {
          http: {
            method: "GET",
            requestUri: "/v2/email/import-jobs/{JobId}"
          },
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {
                location: "uri",
                locationName: "JobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              ImportDestination: {
                shape: "S2s"
              },
              ImportDataSource: {
                shape: "S2x"
              },
              FailureInfo: {
                type: "structure",
                members: {
                  FailedRecordsS3Url: {},
                  ErrorMessage: {}
                }
              },
              JobStatus: {},
              CreatedTimestamp: {
                type: "timestamp"
              },
              CompletedTimestamp: {
                type: "timestamp"
              },
              ProcessedRecordsCount: {
                type: "integer"
              },
              FailedRecordsCount: {
                type: "integer"
              }
            }
          }
        },
        GetSuppressedDestination: {
          http: {
            method: "GET",
            requestUri: "/v2/email/suppression/addresses/{EmailAddress}"
          },
          input: {
            type: "structure",
            required: [
              "EmailAddress"
            ],
            members: {
              EmailAddress: {
                location: "uri",
                locationName: "EmailAddress"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "SuppressedDestination"
            ],
            members: {
              SuppressedDestination: {
                type: "structure",
                required: [
                  "EmailAddress",
                  "Reason",
                  "LastUpdateTime"
                ],
                members: {
                  EmailAddress: {},
                  Reason: {},
                  LastUpdateTime: {
                    type: "timestamp"
                  },
                  Attributes: {
                    type: "structure",
                    members: {
                      MessageId: {},
                      FeedbackId: {}
                    }
                  }
                }
              }
            }
          }
        },
        ListConfigurationSets: {
          http: {
            method: "GET",
            requestUri: "/v2/email/configuration-sets"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ConfigurationSets: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListContactLists: {
          http: {
            method: "GET",
            requestUri: "/v2/email/contact-lists"
          },
          input: {
            type: "structure",
            members: {
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ContactLists: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ContactListName: {},
                    LastUpdatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListContacts: {
          http: {
            method: "GET",
            requestUri: "/v2/email/contact-lists/{ContactListName}/contacts"
          },
          input: {
            type: "structure",
            required: [
              "ContactListName"
            ],
            members: {
              ContactListName: {
                location: "uri",
                locationName: "ContactListName"
              },
              Filter: {
                type: "structure",
                members: {
                  FilteredStatus: {},
                  TopicFilter: {
                    type: "structure",
                    members: {
                      TopicName: {},
                      UseDefaultIfPreferenceUnavailable: {
                        type: "boolean"
                      }
                    }
                  }
                }
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Contacts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EmailAddress: {},
                    TopicPreferences: {
                      shape: "S13"
                    },
                    TopicDefaultPreferences: {
                      shape: "S13"
                    },
                    UnsubscribeAll: {
                      type: "boolean"
                    },
                    LastUpdatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListCustomVerificationEmailTemplates: {
          http: {
            method: "GET",
            requestUri: "/v2/email/custom-verification-email-templates"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CustomVerificationEmailTemplates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TemplateName: {},
                    FromEmailAddress: {},
                    TemplateSubject: {},
                    SuccessRedirectionURL: {},
                    FailureRedirectionURL: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDedicatedIpPools: {
          http: {
            method: "GET",
            requestUri: "/v2/email/dedicated-ip-pools"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DedicatedIpPools: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListDeliverabilityTestReports: {
          http: {
            method: "GET",
            requestUri: "/v2/email/deliverability-dashboard/test-reports"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DeliverabilityTestReports"
            ],
            members: {
              DeliverabilityTestReports: {
                type: "list",
                member: {
                  shape: "S5b"
                }
              },
              NextToken: {}
            }
          }
        },
        ListDomainDeliverabilityCampaigns: {
          http: {
            method: "GET",
            requestUri: "/v2/email/deliverability-dashboard/domains/{SubscribedDomain}/campaigns"
          },
          input: {
            type: "structure",
            required: [
              "StartDate",
              "EndDate",
              "SubscribedDomain"
            ],
            members: {
              StartDate: {
                location: "querystring",
                locationName: "StartDate",
                type: "timestamp"
              },
              EndDate: {
                location: "querystring",
                locationName: "EndDate",
                type: "timestamp"
              },
              SubscribedDomain: {
                location: "uri",
                locationName: "SubscribedDomain"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainDeliverabilityCampaigns"
            ],
            members: {
              DomainDeliverabilityCampaigns: {
                type: "list",
                member: {
                  shape: "S5l"
                }
              },
              NextToken: {}
            }
          }
        },
        ListEmailIdentities: {
          http: {
            method: "GET",
            requestUri: "/v2/email/identities"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EmailIdentities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    IdentityType: {},
                    IdentityName: {},
                    SendingEnabled: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEmailTemplates: {
          http: {
            method: "GET",
            requestUri: "/v2/email/templates"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplatesMetadata: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TemplateName: {},
                    CreatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListImportJobs: {
          http: {
            method: "GET",
            requestUri: "/v2/email/import-jobs"
          },
          input: {
            type: "structure",
            members: {
              ImportDestinationType: {},
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ImportJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    JobId: {},
                    ImportDestination: {
                      shape: "S2s"
                    },
                    JobStatus: {},
                    CreatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSuppressedDestinations: {
          http: {
            method: "GET",
            requestUri: "/v2/email/suppression/addresses"
          },
          input: {
            type: "structure",
            members: {
              Reasons: {
                shape: "Sh",
                location: "querystring",
                locationName: "Reason"
              },
              StartDate: {
                location: "querystring",
                locationName: "StartDate",
                type: "timestamp"
              },
              EndDate: {
                location: "querystring",
                locationName: "EndDate",
                type: "timestamp"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              PageSize: {
                location: "querystring",
                locationName: "PageSize",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SuppressedDestinationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "EmailAddress",
                    "Reason",
                    "LastUpdateTime"
                  ],
                  members: {
                    EmailAddress: {},
                    Reason: {},
                    LastUpdateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/v2/email/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "querystring",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Tags"
            ],
            members: {
              Tags: {
                shape: "Sc"
              }
            }
          }
        },
        PutAccountDedicatedIpWarmupAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/account/dedicated-ips/warmup"
          },
          input: {
            type: "structure",
            members: {
              AutoWarmupEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutAccountDetails: {
          http: {
            requestUri: "/v2/email/account/details"
          },
          input: {
            type: "structure",
            required: [
              "MailType",
              "WebsiteURL",
              "UseCaseDescription"
            ],
            members: {
              MailType: {},
              WebsiteURL: {
                shape: "S3w"
              },
              ContactLanguage: {},
              UseCaseDescription: {
                shape: "S3y"
              },
              AdditionalContactEmailAddresses: {
                shape: "S3z"
              },
              ProductionAccessEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutAccountSendingAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/account/sending"
          },
          input: {
            type: "structure",
            members: {
              SendingEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutAccountSuppressionAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/account/suppression"
          },
          input: {
            type: "structure",
            members: {
              SuppressedReasons: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutConfigurationSetDeliveryOptions: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}/delivery-options"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              TlsPolicy: {},
              SendingPoolName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutConfigurationSetReputationOptions: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}/reputation-options"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              ReputationMetricsEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutConfigurationSetSendingOptions: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}/sending"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              SendingEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutConfigurationSetSuppressionOptions: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}/suppression-options"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              SuppressedReasons: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutConfigurationSetTrackingOptions: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}/tracking-options"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              CustomRedirectDomain: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutDedicatedIpInPool: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/dedicated-ips/{IP}/pool"
          },
          input: {
            type: "structure",
            required: [
              "Ip",
              "DestinationPoolName"
            ],
            members: {
              Ip: {
                location: "uri",
                locationName: "IP"
              },
              DestinationPoolName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutDedicatedIpWarmupAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/dedicated-ips/{IP}/warmup"
          },
          input: {
            type: "structure",
            required: [
              "Ip",
              "WarmupPercentage"
            ],
            members: {
              Ip: {
                location: "uri",
                locationName: "IP"
              },
              WarmupPercentage: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutDeliverabilityDashboardOption: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/deliverability-dashboard"
          },
          input: {
            type: "structure",
            required: [
              "DashboardEnabled"
            ],
            members: {
              DashboardEnabled: {
                type: "boolean"
              },
              SubscribedDomains: {
                shape: "S53"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutEmailIdentityConfigurationSetAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/identities/{EmailIdentity}/configuration-set"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              ConfigurationSetName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutEmailIdentityDkimAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/identities/{EmailIdentity}/dkim"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              SigningEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutEmailIdentityDkimSigningAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v1/email/identities/{EmailIdentity}/dkim/signing"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity",
              "SigningAttributesOrigin"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              SigningAttributesOrigin: {},
              SigningAttributes: {
                shape: "S26"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DkimStatus: {},
              DkimTokens: {
                shape: "S2e"
              }
            }
          }
        },
        PutEmailIdentityFeedbackAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/identities/{EmailIdentity}/feedback"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              EmailForwardingEnabled: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutEmailIdentityMailFromAttributes: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/identities/{EmailIdentity}/mail-from"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              MailFromDomain: {},
              BehaviorOnMxFailure: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutSuppressedDestination: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/suppression/addresses"
          },
          input: {
            type: "structure",
            required: [
              "EmailAddress",
              "Reason"
            ],
            members: {
              EmailAddress: {},
              Reason: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SendBulkEmail: {
          http: {
            requestUri: "/v2/email/outbound-bulk-emails"
          },
          input: {
            type: "structure",
            required: [
              "DefaultContent",
              "BulkEmailEntries"
            ],
            members: {
              FromEmailAddress: {},
              FromEmailAddressIdentityArn: {},
              ReplyToAddresses: {
                shape: "S92"
              },
              FeedbackForwardingEmailAddress: {},
              FeedbackForwardingEmailAddressIdentityArn: {},
              DefaultEmailTags: {
                shape: "S93"
              },
              DefaultContent: {
                type: "structure",
                members: {
                  Template: {
                    shape: "S1z"
                  }
                }
              },
              BulkEmailEntries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Destination"
                  ],
                  members: {
                    Destination: {
                      shape: "S9a"
                    },
                    ReplacementTags: {
                      shape: "S93"
                    },
                    ReplacementEmailContent: {
                      type: "structure",
                      members: {
                        ReplacementTemplate: {
                          type: "structure",
                          members: {
                            ReplacementTemplateData: {}
                          }
                        }
                      }
                    }
                  }
                }
              },
              ConfigurationSetName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "BulkEmailEntryResults"
            ],
            members: {
              BulkEmailEntryResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Status: {},
                    Error: {},
                    MessageId: {}
                  }
                }
              }
            }
          }
        },
        SendCustomVerificationEmail: {
          http: {
            requestUri: "/v2/email/outbound-custom-verification-emails"
          },
          input: {
            type: "structure",
            required: [
              "EmailAddress",
              "TemplateName"
            ],
            members: {
              EmailAddress: {},
              TemplateName: {},
              ConfigurationSetName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MessageId: {}
            }
          }
        },
        SendEmail: {
          http: {
            requestUri: "/v2/email/outbound-emails"
          },
          input: {
            type: "structure",
            required: [
              "Content"
            ],
            members: {
              FromEmailAddress: {},
              FromEmailAddressIdentityArn: {},
              Destination: {
                shape: "S9a"
              },
              ReplyToAddresses: {
                shape: "S92"
              },
              FeedbackForwardingEmailAddress: {},
              FeedbackForwardingEmailAddressIdentityArn: {},
              Content: {
                shape: "S1r"
              },
              EmailTags: {
                shape: "S93"
              },
              ConfigurationSetName: {},
              ListManagementOptions: {
                type: "structure",
                required: [
                  "ContactListName"
                ],
                members: {
                  ContactListName: {},
                  TopicName: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MessageId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/v2/email/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TestRenderEmailTemplate: {
          http: {
            requestUri: "/v2/email/templates/{TemplateName}/render"
          },
          input: {
            type: "structure",
            required: [
              "TemplateName",
              "TemplateData"
            ],
            members: {
              TemplateName: {
                location: "uri",
                locationName: "TemplateName"
              },
              TemplateData: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RenderedTemplate"
            ],
            members: {
              RenderedTemplate: {}
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/v2/email/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "querystring",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "TagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateConfigurationSetEventDestination: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/configuration-sets/{ConfigurationSetName}/event-destinations/{EventDestinationName}"
          },
          input: {
            type: "structure",
            required: [
              "ConfigurationSetName",
              "EventDestinationName",
              "EventDestination"
            ],
            members: {
              ConfigurationSetName: {
                location: "uri",
                locationName: "ConfigurationSetName"
              },
              EventDestinationName: {
                location: "uri",
                locationName: "EventDestinationName"
              },
              EventDestination: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateContact: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/contact-lists/{ContactListName}/contacts/{EmailAddress}"
          },
          input: {
            type: "structure",
            required: [
              "ContactListName",
              "EmailAddress"
            ],
            members: {
              ContactListName: {
                location: "uri",
                locationName: "ContactListName"
              },
              EmailAddress: {
                location: "uri",
                locationName: "EmailAddress"
              },
              TopicPreferences: {
                shape: "S13"
              },
              UnsubscribeAll: {
                type: "boolean"
              },
              AttributesData: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateContactList: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/contact-lists/{ContactListName}"
          },
          input: {
            type: "structure",
            required: [
              "ContactListName"
            ],
            members: {
              ContactListName: {
                location: "uri",
                locationName: "ContactListName"
              },
              Topics: {
                shape: "S1b"
              },
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateCustomVerificationEmailTemplate: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/custom-verification-email-templates/{TemplateName}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateName",
              "FromEmailAddress",
              "TemplateSubject",
              "TemplateContent",
              "SuccessRedirectionURL",
              "FailureRedirectionURL"
            ],
            members: {
              TemplateName: {
                location: "uri",
                locationName: "TemplateName"
              },
              FromEmailAddress: {},
              TemplateSubject: {},
              TemplateContent: {},
              SuccessRedirectionURL: {},
              FailureRedirectionURL: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEmailIdentityPolicy: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/identities/{EmailIdentity}/policies/{PolicyName}"
          },
          input: {
            type: "structure",
            required: [
              "EmailIdentity",
              "PolicyName",
              "Policy"
            ],
            members: {
              EmailIdentity: {
                location: "uri",
                locationName: "EmailIdentity"
              },
              PolicyName: {
                location: "uri",
                locationName: "PolicyName"
              },
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEmailTemplate: {
          http: {
            method: "PUT",
            requestUri: "/v2/email/templates/{TemplateName}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateName",
              "TemplateContent"
            ],
            members: {
              TemplateName: {
                location: "uri",
                locationName: "TemplateName"
              },
              TemplateContent: {
                shape: "S2n"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          required: [
            "CustomRedirectDomain"
          ],
          members: {
            CustomRedirectDomain: {}
          }
        },
        S5: {
          type: "structure",
          members: {
            TlsPolicy: {},
            SendingPoolName: {}
          }
        },
        S8: {
          type: "structure",
          members: {
            ReputationMetricsEnabled: {
              type: "boolean"
            },
            LastFreshStart: {
              type: "timestamp"
            }
          }
        },
        Sb: {
          type: "structure",
          members: {
            SendingEnabled: {
              type: "boolean"
            }
          }
        },
        Sc: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sg: {
          type: "structure",
          members: {
            SuppressedReasons: {
              shape: "Sh"
            }
          }
        },
        Sh: {
          type: "list",
          member: {}
        },
        Sm: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            MatchingEventTypes: {
              shape: "Sn"
            },
            KinesisFirehoseDestination: {
              shape: "Sp"
            },
            CloudWatchDestination: {
              shape: "Sr"
            },
            SnsDestination: {
              shape: "Sx"
            },
            PinpointDestination: {
              shape: "Sy"
            }
          }
        },
        Sn: {
          type: "list",
          member: {}
        },
        Sp: {
          type: "structure",
          required: [
            "IamRoleArn",
            "DeliveryStreamArn"
          ],
          members: {
            IamRoleArn: {},
            DeliveryStreamArn: {}
          }
        },
        Sr: {
          type: "structure",
          required: [
            "DimensionConfigurations"
          ],
          members: {
            DimensionConfigurations: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DimensionName",
                  "DimensionValueSource",
                  "DefaultDimensionValue"
                ],
                members: {
                  DimensionName: {},
                  DimensionValueSource: {},
                  DefaultDimensionValue: {}
                }
              }
            }
          }
        },
        Sx: {
          type: "structure",
          required: [
            "TopicArn"
          ],
          members: {
            TopicArn: {}
          }
        },
        Sy: {
          type: "structure",
          members: {
            ApplicationArn: {}
          }
        },
        S13: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "TopicName",
              "SubscriptionStatus"
            ],
            members: {
              TopicName: {},
              SubscriptionStatus: {}
            }
          }
        },
        S1b: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "TopicName",
              "DisplayName",
              "DefaultSubscriptionStatus"
            ],
            members: {
              TopicName: {},
              DisplayName: {},
              Description: {},
              DefaultSubscriptionStatus: {}
            }
          }
        },
        S1r: {
          type: "structure",
          members: {
            Simple: {
              type: "structure",
              required: [
                "Subject",
                "Body"
              ],
              members: {
                Subject: {
                  shape: "S1t"
                },
                Body: {
                  type: "structure",
                  members: {
                    Text: {
                      shape: "S1t"
                    },
                    Html: {
                      shape: "S1t"
                    }
                  }
                }
              }
            },
            Raw: {
              type: "structure",
              required: [
                "Data"
              ],
              members: {
                Data: {
                  type: "blob"
                }
              }
            },
            Template: {
              shape: "S1z"
            }
          }
        },
        S1t: {
          type: "structure",
          required: [
            "Data"
          ],
          members: {
            Data: {},
            Charset: {}
          }
        },
        S1z: {
          type: "structure",
          members: {
            TemplateName: {},
            TemplateArn: {},
            TemplateData: {}
          }
        },
        S26: {
          type: "structure",
          members: {
            DomainSigningSelector: {},
            DomainSigningPrivateKey: {
              type: "string",
              sensitive: true
            },
            NextSigningKeyLength: {}
          }
        },
        S2c: {
          type: "structure",
          members: {
            SigningEnabled: {
              type: "boolean"
            },
            Status: {},
            Tokens: {
              shape: "S2e"
            },
            SigningAttributesOrigin: {},
            NextSigningKeyLength: {},
            CurrentSigningKeyLength: {},
            LastKeyGenerationTimestamp: {
              type: "timestamp"
            }
          }
        },
        S2e: {
          type: "list",
          member: {}
        },
        S2n: {
          type: "structure",
          members: {
            Subject: {},
            Text: {},
            Html: {}
          }
        },
        S2s: {
          type: "structure",
          members: {
            SuppressionListDestination: {
              type: "structure",
              required: [
                "SuppressionListImportAction"
              ],
              members: {
                SuppressionListImportAction: {}
              }
            },
            ContactListDestination: {
              type: "structure",
              required: [
                "ContactListName",
                "ContactListImportAction"
              ],
              members: {
                ContactListName: {},
                ContactListImportAction: {}
              }
            }
          }
        },
        S2x: {
          type: "structure",
          required: [
            "S3Url",
            "DataFormat"
          ],
          members: {
            S3Url: {},
            DataFormat: {}
          }
        },
        S3w: {
          type: "string",
          sensitive: true
        },
        S3y: {
          type: "string",
          sensitive: true
        },
        S3z: {
          type: "list",
          member: {
            type: "string",
            sensitive: true
          },
          sensitive: true
        },
        S4s: {
          type: "structure",
          required: [
            "Ip",
            "WarmupStatus",
            "WarmupPercentage"
          ],
          members: {
            Ip: {},
            WarmupStatus: {},
            WarmupPercentage: {
              type: "integer"
            },
            PoolName: {}
          }
        },
        S53: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Domain: {},
              SubscriptionStartDate: {
                type: "timestamp"
              },
              InboxPlacementTrackingOption: {
                type: "structure",
                members: {
                  Global: {
                    type: "boolean"
                  },
                  TrackedIsps: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          }
        },
        S5b: {
          type: "structure",
          members: {
            ReportId: {},
            ReportName: {},
            Subject: {},
            FromEmailAddress: {},
            CreateDate: {
              type: "timestamp"
            },
            DeliverabilityTestStatus: {}
          }
        },
        S5d: {
          type: "structure",
          members: {
            InboxPercentage: {
              type: "double"
            },
            SpamPercentage: {
              type: "double"
            },
            MissingPercentage: {
              type: "double"
            },
            SpfPercentage: {
              type: "double"
            },
            DkimPercentage: {
              type: "double"
            }
          }
        },
        S5l: {
          type: "structure",
          members: {
            CampaignId: {},
            ImageUrl: {},
            Subject: {},
            FromAddress: {},
            SendingIps: {
              type: "list",
              member: {}
            },
            FirstSeenDateTime: {
              type: "timestamp"
            },
            LastSeenDateTime: {
              type: "timestamp"
            },
            InboxCount: {
              type: "long"
            },
            SpamCount: {
              type: "long"
            },
            ReadRate: {
              type: "double"
            },
            DeleteRate: {
              type: "double"
            },
            ReadDeleteRate: {
              type: "double"
            },
            ProjectedVolume: {
              type: "long"
            },
            Esps: {
              type: "list",
              member: {}
            }
          }
        },
        S5v: {
          type: "structure",
          members: {
            InboxRawCount: {
              type: "long"
            },
            SpamRawCount: {
              type: "long"
            },
            ProjectedInbox: {
              type: "long"
            },
            ProjectedSpam: {
              type: "long"
            }
          }
        },
        S5w: {
          type: "list",
          member: {
            type: "structure",
            members: {
              IspName: {},
              InboxRawCount: {
                type: "long"
              },
              SpamRawCount: {
                type: "long"
              },
              InboxPercentage: {
                type: "double"
              },
              SpamPercentage: {
                type: "double"
              }
            }
          }
        },
        S66: {
          type: "map",
          key: {},
          value: {}
        },
        S92: {
          type: "list",
          member: {}
        },
        S93: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        S9a: {
          type: "structure",
          members: {
            ToAddresses: {
              shape: "S92"
            },
            CcAddresses: {
              shape: "S92"
            },
            BccAddresses: {
              shape: "S92"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sesv2-2019-09-27.paginators.json
var require_sesv2_2019_09_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sesv2-2019-09-27.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetDedicatedIps: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListConfigurationSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListContactLists: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListContacts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListCustomVerificationEmailTemplates: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListDedicatedIpPools: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListDeliverabilityTestReports: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListDomainDeliverabilityCampaigns: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListEmailIdentities: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListEmailTemplates: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListImportJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        },
        ListSuppressedDestinations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "PageSize"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/sesv2.js
var require_sesv2 = __commonJS({
  "node_modules/aws-sdk/clients/sesv2.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["sesv2"] = {};
    AWS3.SESV2 = Service.defineService("sesv2", ["2019-09-27"]);
    Object.defineProperty(apiLoader.services["sesv2"], "2019-09-27", {
      get: function get() {
        var model = require_sesv2_2019_09_27_min();
        model.paginators = require_sesv2_2019_09_27_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SESV2;
  }
});

// node_modules/aws-sdk/apis/migrationhub-config-2019-06-30.min.json
var require_migrationhub_config_2019_06_30_min = __commonJS({
  "node_modules/aws-sdk/apis/migrationhub-config-2019-06-30.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-06-30",
        endpointPrefix: "migrationhub-config",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS Migration Hub Config",
        serviceId: "MigrationHub Config",
        signatureVersion: "v4",
        signingName: "mgh",
        targetPrefix: "AWSMigrationHubMultiAccountService",
        uid: "migrationhub-config-2019-06-30"
      },
      operations: {
        CreateHomeRegionControl: {
          input: {
            type: "structure",
            required: [
              "HomeRegion",
              "Target"
            ],
            members: {
              HomeRegion: {},
              Target: {
                shape: "S3"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HomeRegionControl: {
                shape: "S8"
              }
            }
          }
        },
        DescribeHomeRegionControls: {
          input: {
            type: "structure",
            members: {
              ControlId: {},
              HomeRegion: {},
              Target: {
                shape: "S3"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              HomeRegionControls: {
                type: "list",
                member: {
                  shape: "S8"
                }
              },
              NextToken: {}
            }
          }
        },
        GetHomeRegion: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              HomeRegion: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Type: {},
            Id: {}
          }
        },
        S8: {
          type: "structure",
          members: {
            ControlId: {},
            HomeRegion: {},
            Target: {
              shape: "S3"
            },
            RequestedTime: {
              type: "timestamp"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/migrationhub-config-2019-06-30.paginators.json
var require_migrationhub_config_2019_06_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/migrationhub-config-2019-06-30.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeHomeRegionControls: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/migrationhubconfig.js
var require_migrationhubconfig = __commonJS({
  "node_modules/aws-sdk/clients/migrationhubconfig.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["migrationhubconfig"] = {};
    AWS3.MigrationHubConfig = Service.defineService("migrationhubconfig", ["2019-06-30"]);
    Object.defineProperty(apiLoader.services["migrationhubconfig"], "2019-06-30", {
      get: function get() {
        var model = require_migrationhub_config_2019_06_30_min();
        model.paginators = require_migrationhub_config_2019_06_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.MigrationHubConfig;
  }
});

// node_modules/aws-sdk/apis/connectparticipant-2018-09-07.min.json
var require_connectparticipant_2018_09_07_min = __commonJS({
  "node_modules/aws-sdk/apis/connectparticipant-2018-09-07.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-09-07",
        endpointPrefix: "participant.connect",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon Connect Participant",
        serviceFullName: "Amazon Connect Participant Service",
        serviceId: "ConnectParticipant",
        signatureVersion: "v4",
        signingName: "execute-api",
        uid: "connectparticipant-2018-09-07"
      },
      operations: {
        CompleteAttachmentUpload: {
          http: {
            requestUri: "/participant/complete-attachment-upload"
          },
          input: {
            type: "structure",
            required: [
              "AttachmentIds",
              "ClientToken",
              "ConnectionToken"
            ],
            members: {
              AttachmentIds: {
                type: "list",
                member: {}
              },
              ClientToken: {
                idempotencyToken: true
              },
              ConnectionToken: {
                location: "header",
                locationName: "X-Amz-Bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateParticipantConnection: {
          http: {
            requestUri: "/participant/connection"
          },
          input: {
            type: "structure",
            required: [
              "Type",
              "ParticipantToken"
            ],
            members: {
              Type: {
                type: "list",
                member: {}
              },
              ParticipantToken: {
                location: "header",
                locationName: "X-Amz-Bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Websocket: {
                type: "structure",
                members: {
                  Url: {},
                  ConnectionExpiry: {}
                }
              },
              ConnectionCredentials: {
                type: "structure",
                members: {
                  ConnectionToken: {},
                  Expiry: {}
                }
              }
            }
          }
        },
        DisconnectParticipant: {
          http: {
            requestUri: "/participant/disconnect"
          },
          input: {
            type: "structure",
            required: [
              "ConnectionToken"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              ConnectionToken: {
                location: "header",
                locationName: "X-Amz-Bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAttachment: {
          http: {
            requestUri: "/participant/attachment"
          },
          input: {
            type: "structure",
            required: [
              "AttachmentId",
              "ConnectionToken"
            ],
            members: {
              AttachmentId: {},
              ConnectionToken: {
                location: "header",
                locationName: "X-Amz-Bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Url: {},
              UrlExpiry: {}
            }
          }
        },
        GetTranscript: {
          http: {
            requestUri: "/participant/transcript"
          },
          input: {
            type: "structure",
            required: [
              "ConnectionToken"
            ],
            members: {
              ContactId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ScanDirection: {},
              SortOrder: {},
              StartPosition: {
                type: "structure",
                members: {
                  Id: {},
                  AbsoluteTime: {},
                  MostRecent: {
                    type: "integer"
                  }
                }
              },
              ConnectionToken: {
                location: "header",
                locationName: "X-Amz-Bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InitialContactId: {},
              Transcript: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AbsoluteTime: {},
                    Content: {},
                    ContentType: {},
                    Id: {},
                    Type: {},
                    ParticipantId: {},
                    DisplayName: {},
                    ParticipantRole: {},
                    Attachments: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ContentType: {},
                          AttachmentId: {},
                          AttachmentName: {},
                          Status: {}
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        SendEvent: {
          http: {
            requestUri: "/participant/event"
          },
          input: {
            type: "structure",
            required: [
              "ContentType",
              "ConnectionToken"
            ],
            members: {
              ContentType: {},
              Content: {},
              ClientToken: {
                idempotencyToken: true
              },
              ConnectionToken: {
                location: "header",
                locationName: "X-Amz-Bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              AbsoluteTime: {}
            }
          }
        },
        SendMessage: {
          http: {
            requestUri: "/participant/message"
          },
          input: {
            type: "structure",
            required: [
              "ContentType",
              "Content",
              "ConnectionToken"
            ],
            members: {
              ContentType: {},
              Content: {},
              ClientToken: {
                idempotencyToken: true
              },
              ConnectionToken: {
                location: "header",
                locationName: "X-Amz-Bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              AbsoluteTime: {}
            }
          }
        },
        StartAttachmentUpload: {
          http: {
            requestUri: "/participant/start-attachment-upload"
          },
          input: {
            type: "structure",
            required: [
              "ContentType",
              "AttachmentSizeInBytes",
              "AttachmentName",
              "ClientToken",
              "ConnectionToken"
            ],
            members: {
              ContentType: {},
              AttachmentSizeInBytes: {
                type: "long"
              },
              AttachmentName: {},
              ClientToken: {
                idempotencyToken: true
              },
              ConnectionToken: {
                location: "header",
                locationName: "X-Amz-Bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AttachmentId: {},
              UploadMetadata: {
                type: "structure",
                members: {
                  Url: {},
                  UrlExpiry: {},
                  HeadersToInclude: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/connectparticipant-2018-09-07.paginators.json
var require_connectparticipant_2018_09_07_paginators = __commonJS({
  "node_modules/aws-sdk/apis/connectparticipant-2018-09-07.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetTranscript: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/connectparticipant.js
var require_connectparticipant = __commonJS({
  "node_modules/aws-sdk/clients/connectparticipant.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["connectparticipant"] = {};
    AWS3.ConnectParticipant = Service.defineService("connectparticipant", ["2018-09-07"]);
    Object.defineProperty(apiLoader.services["connectparticipant"], "2018-09-07", {
      get: function get() {
        var model = require_connectparticipant_2018_09_07_min();
        model.paginators = require_connectparticipant_2018_09_07_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ConnectParticipant;
  }
});

// node_modules/aws-sdk/apis/appconfig-2019-10-09.min.json
var require_appconfig_2019_10_09_min = __commonJS({
  "node_modules/aws-sdk/apis/appconfig-2019-10-09.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-10-09",
        endpointPrefix: "appconfig",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "AppConfig",
        serviceFullName: "Amazon AppConfig",
        serviceId: "AppConfig",
        signatureVersion: "v4",
        signingName: "appconfig",
        uid: "appconfig-2019-10-09"
      },
      operations: {
        CreateApplication: {
          http: {
            requestUri: "/applications",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            shape: "S7"
          }
        },
        CreateConfigurationProfile: {
          http: {
            requestUri: "/applications/{ApplicationId}/configurationprofiles",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "Name",
              "LocationUri"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              Name: {},
              Description: {},
              LocationUri: {},
              RetrievalRoleArn: {},
              Validators: {
                shape: "Sc"
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            shape: "Sg"
          }
        },
        CreateDeploymentStrategy: {
          http: {
            requestUri: "/deploymentstrategies",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "DeploymentDurationInMinutes",
              "GrowthFactor",
              "ReplicateTo"
            ],
            members: {
              Name: {},
              Description: {},
              DeploymentDurationInMinutes: {
                type: "integer"
              },
              FinalBakeTimeInMinutes: {
                type: "integer"
              },
              GrowthFactor: {
                type: "float"
              },
              GrowthType: {},
              ReplicateTo: {},
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            shape: "Sm"
          }
        },
        CreateEnvironment: {
          http: {
            requestUri: "/applications/{ApplicationId}/environments",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "Name"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              Name: {},
              Description: {},
              Monitors: {
                shape: "Sp"
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            shape: "Ss"
          }
        },
        CreateHostedConfigurationVersion: {
          http: {
            requestUri: "/applications/{ApplicationId}/configurationprofiles/{ConfigurationProfileId}/hostedconfigurationversions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "ConfigurationProfileId",
              "Content",
              "ContentType"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              ConfigurationProfileId: {
                location: "uri",
                locationName: "ConfigurationProfileId"
              },
              Description: {
                location: "header",
                locationName: "Description"
              },
              Content: {
                shape: "Sv"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              LatestVersionNumber: {
                location: "header",
                locationName: "Latest-Version-Number",
                type: "integer"
              }
            },
            payload: "Content"
          },
          output: {
            shape: "Sy"
          }
        },
        DeleteApplication: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{ApplicationId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              }
            }
          }
        },
        DeleteConfigurationProfile: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{ApplicationId}/configurationprofiles/{ConfigurationProfileId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "ConfigurationProfileId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              ConfigurationProfileId: {
                location: "uri",
                locationName: "ConfigurationProfileId"
              }
            }
          }
        },
        DeleteDeploymentStrategy: {
          http: {
            method: "DELETE",
            requestUri: "/deployementstrategies/{DeploymentStrategyId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "DeploymentStrategyId"
            ],
            members: {
              DeploymentStrategyId: {
                location: "uri",
                locationName: "DeploymentStrategyId"
              }
            }
          }
        },
        DeleteEnvironment: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{ApplicationId}/environments/{EnvironmentId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "EnvironmentId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              EnvironmentId: {
                location: "uri",
                locationName: "EnvironmentId"
              }
            }
          }
        },
        DeleteHostedConfigurationVersion: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{ApplicationId}/configurationprofiles/{ConfigurationProfileId}/hostedconfigurationversions/{VersionNumber}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "ConfigurationProfileId",
              "VersionNumber"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              ConfigurationProfileId: {
                location: "uri",
                locationName: "ConfigurationProfileId"
              },
              VersionNumber: {
                location: "uri",
                locationName: "VersionNumber",
                type: "integer"
              }
            }
          }
        },
        GetApplication: {
          http: {
            method: "GET",
            requestUri: "/applications/{ApplicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              }
            }
          },
          output: {
            shape: "S7"
          }
        },
        GetConfiguration: {
          http: {
            method: "GET",
            requestUri: "/applications/{Application}/environments/{Environment}/configurations/{Configuration}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Application",
              "Environment",
              "Configuration",
              "ClientId"
            ],
            members: {
              Application: {
                location: "uri",
                locationName: "Application"
              },
              Environment: {
                location: "uri",
                locationName: "Environment"
              },
              Configuration: {
                location: "uri",
                locationName: "Configuration"
              },
              ClientId: {
                location: "querystring",
                locationName: "client_id"
              },
              ClientConfigurationVersion: {
                location: "querystring",
                locationName: "client_configuration_version"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Content: {
                shape: "Sv"
              },
              ConfigurationVersion: {
                location: "header",
                locationName: "Configuration-Version"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              }
            },
            payload: "Content"
          }
        },
        GetConfigurationProfile: {
          http: {
            method: "GET",
            requestUri: "/applications/{ApplicationId}/configurationprofiles/{ConfigurationProfileId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "ConfigurationProfileId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              ConfigurationProfileId: {
                location: "uri",
                locationName: "ConfigurationProfileId"
              }
            }
          },
          output: {
            shape: "Sg"
          }
        },
        GetDeployment: {
          http: {
            method: "GET",
            requestUri: "/applications/{ApplicationId}/environments/{EnvironmentId}/deployments/{DeploymentNumber}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "EnvironmentId",
              "DeploymentNumber"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              EnvironmentId: {
                location: "uri",
                locationName: "EnvironmentId"
              },
              DeploymentNumber: {
                location: "uri",
                locationName: "DeploymentNumber",
                type: "integer"
              }
            }
          },
          output: {
            shape: "S1d"
          }
        },
        GetDeploymentStrategy: {
          http: {
            method: "GET",
            requestUri: "/deploymentstrategies/{DeploymentStrategyId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DeploymentStrategyId"
            ],
            members: {
              DeploymentStrategyId: {
                location: "uri",
                locationName: "DeploymentStrategyId"
              }
            }
          },
          output: {
            shape: "Sm"
          }
        },
        GetEnvironment: {
          http: {
            method: "GET",
            requestUri: "/applications/{ApplicationId}/environments/{EnvironmentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "EnvironmentId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              EnvironmentId: {
                location: "uri",
                locationName: "EnvironmentId"
              }
            }
          },
          output: {
            shape: "Ss"
          }
        },
        GetHostedConfigurationVersion: {
          http: {
            method: "GET",
            requestUri: "/applications/{ApplicationId}/configurationprofiles/{ConfigurationProfileId}/hostedconfigurationversions/{VersionNumber}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "ConfigurationProfileId",
              "VersionNumber"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              ConfigurationProfileId: {
                location: "uri",
                locationName: "ConfigurationProfileId"
              },
              VersionNumber: {
                location: "uri",
                locationName: "VersionNumber",
                type: "integer"
              }
            }
          },
          output: {
            shape: "Sy"
          }
        },
        ListApplications: {
          http: {
            method: "GET",
            requestUri: "/applications",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  shape: "S7"
                }
              },
              NextToken: {}
            }
          }
        },
        ListConfigurationProfiles: {
          http: {
            method: "GET",
            requestUri: "/applications/{ApplicationId}/configurationprofiles",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationId: {},
                    Id: {},
                    Name: {},
                    LocationUri: {},
                    ValidatorTypes: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDeploymentStrategies: {
          http: {
            method: "GET",
            requestUri: "/deploymentstrategies",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  shape: "Sm"
                }
              },
              NextToken: {}
            }
          }
        },
        ListDeployments: {
          http: {
            method: "GET",
            requestUri: "/applications/{ApplicationId}/environments/{EnvironmentId}/deployments",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "EnvironmentId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              EnvironmentId: {
                location: "uri",
                locationName: "EnvironmentId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DeploymentNumber: {
                      type: "integer"
                    },
                    ConfigurationName: {},
                    ConfigurationVersion: {},
                    DeploymentDurationInMinutes: {
                      type: "integer"
                    },
                    GrowthType: {},
                    GrowthFactor: {
                      type: "float"
                    },
                    FinalBakeTimeInMinutes: {
                      type: "integer"
                    },
                    State: {},
                    PercentageComplete: {
                      type: "float"
                    },
                    StartedAt: {
                      shape: "S1j"
                    },
                    CompletedAt: {
                      shape: "S1j"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEnvironments: {
          http: {
            method: "GET",
            requestUri: "/applications/{ApplicationId}/environments",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  shape: "Ss"
                }
              },
              NextToken: {}
            }
          }
        },
        ListHostedConfigurationVersions: {
          http: {
            method: "GET",
            requestUri: "/applications/{ApplicationId}/configurationprofiles/{ConfigurationProfileId}/hostedconfigurationversions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "ConfigurationProfileId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              ConfigurationProfileId: {
                location: "uri",
                locationName: "ConfigurationProfileId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max_results",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "next_token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ApplicationId: {},
                    ConfigurationProfileId: {},
                    VersionNumber: {
                      type: "integer"
                    },
                    Description: {},
                    ContentType: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S4"
              }
            }
          }
        },
        StartDeployment: {
          http: {
            requestUri: "/applications/{ApplicationId}/environments/{EnvironmentId}/deployments",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "EnvironmentId",
              "DeploymentStrategyId",
              "ConfigurationProfileId",
              "ConfigurationVersion"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              EnvironmentId: {
                location: "uri",
                locationName: "EnvironmentId"
              },
              DeploymentStrategyId: {},
              ConfigurationProfileId: {},
              ConfigurationVersion: {},
              Description: {},
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            shape: "S1d"
          }
        },
        StopDeployment: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{ApplicationId}/environments/{EnvironmentId}/deployments/{DeploymentNumber}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "EnvironmentId",
              "DeploymentNumber"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              EnvironmentId: {
                location: "uri",
                locationName: "EnvironmentId"
              },
              DeploymentNumber: {
                location: "uri",
                locationName: "DeploymentNumber",
                type: "integer"
              }
            }
          },
          output: {
            shape: "S1d"
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "S4"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          }
        },
        UpdateApplication: {
          http: {
            method: "PATCH",
            requestUri: "/applications/{ApplicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              Name: {},
              Description: {}
            }
          },
          output: {
            shape: "S7"
          }
        },
        UpdateConfigurationProfile: {
          http: {
            method: "PATCH",
            requestUri: "/applications/{ApplicationId}/configurationprofiles/{ConfigurationProfileId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "ConfigurationProfileId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              ConfigurationProfileId: {
                location: "uri",
                locationName: "ConfigurationProfileId"
              },
              Name: {},
              Description: {},
              RetrievalRoleArn: {},
              Validators: {
                shape: "Sc"
              }
            }
          },
          output: {
            shape: "Sg"
          }
        },
        UpdateDeploymentStrategy: {
          http: {
            method: "PATCH",
            requestUri: "/deploymentstrategies/{DeploymentStrategyId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DeploymentStrategyId"
            ],
            members: {
              DeploymentStrategyId: {
                location: "uri",
                locationName: "DeploymentStrategyId"
              },
              Description: {},
              DeploymentDurationInMinutes: {
                type: "integer"
              },
              FinalBakeTimeInMinutes: {
                type: "integer"
              },
              GrowthFactor: {
                type: "float"
              },
              GrowthType: {}
            }
          },
          output: {
            shape: "Sm"
          }
        },
        UpdateEnvironment: {
          http: {
            method: "PATCH",
            requestUri: "/applications/{ApplicationId}/environments/{EnvironmentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "EnvironmentId"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              EnvironmentId: {
                location: "uri",
                locationName: "EnvironmentId"
              },
              Name: {},
              Description: {},
              Monitors: {
                shape: "Sp"
              }
            }
          },
          output: {
            shape: "Ss"
          }
        },
        ValidateConfiguration: {
          http: {
            requestUri: "/applications/{ApplicationId}/configurationprofiles/{ConfigurationProfileId}/validators",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ApplicationId",
              "ConfigurationProfileId",
              "ConfigurationVersion"
            ],
            members: {
              ApplicationId: {
                location: "uri",
                locationName: "ApplicationId"
              },
              ConfigurationProfileId: {
                location: "uri",
                locationName: "ConfigurationProfileId"
              },
              ConfigurationVersion: {
                location: "querystring",
                locationName: "configuration_version"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "map",
          key: {},
          value: {}
        },
        S7: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            Description: {}
          }
        },
        Sc: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Type",
              "Content"
            ],
            members: {
              Type: {},
              Content: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        Sg: {
          type: "structure",
          members: {
            ApplicationId: {},
            Id: {},
            Name: {},
            Description: {},
            LocationUri: {},
            RetrievalRoleArn: {},
            Validators: {
              shape: "Sc"
            }
          }
        },
        Sm: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            Description: {},
            DeploymentDurationInMinutes: {
              type: "integer"
            },
            GrowthType: {},
            GrowthFactor: {
              type: "float"
            },
            FinalBakeTimeInMinutes: {
              type: "integer"
            },
            ReplicateTo: {}
          }
        },
        Sp: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AlarmArn: {},
              AlarmRoleArn: {}
            }
          }
        },
        Ss: {
          type: "structure",
          members: {
            ApplicationId: {},
            Id: {},
            Name: {},
            Description: {},
            State: {},
            Monitors: {
              shape: "Sp"
            }
          }
        },
        Sv: {
          type: "blob",
          sensitive: true
        },
        Sy: {
          type: "structure",
          members: {
            ApplicationId: {
              location: "header",
              locationName: "Application-Id"
            },
            ConfigurationProfileId: {
              location: "header",
              locationName: "Configuration-Profile-Id"
            },
            VersionNumber: {
              location: "header",
              locationName: "Version-Number",
              type: "integer"
            },
            Description: {
              location: "header",
              locationName: "Description"
            },
            Content: {
              shape: "Sv"
            },
            ContentType: {
              location: "header",
              locationName: "Content-Type"
            }
          },
          payload: "Content"
        },
        S1d: {
          type: "structure",
          members: {
            ApplicationId: {},
            EnvironmentId: {},
            DeploymentStrategyId: {},
            ConfigurationProfileId: {},
            DeploymentNumber: {
              type: "integer"
            },
            ConfigurationName: {},
            ConfigurationLocationUri: {},
            ConfigurationVersion: {},
            Description: {},
            DeploymentDurationInMinutes: {
              type: "integer"
            },
            GrowthType: {},
            GrowthFactor: {
              type: "float"
            },
            FinalBakeTimeInMinutes: {
              type: "integer"
            },
            State: {},
            EventLog: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  EventType: {},
                  TriggeredBy: {},
                  Description: {},
                  OccurredAt: {
                    shape: "S1j"
                  }
                }
              }
            },
            PercentageComplete: {
              type: "float"
            },
            StartedAt: {
              shape: "S1j"
            },
            CompletedAt: {
              shape: "S1j"
            }
          }
        },
        S1j: {
          type: "timestamp",
          timestampFormat: "iso8601"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/appconfig-2019-10-09.paginators.json
var require_appconfig_2019_10_09_paginators = __commonJS({
  "node_modules/aws-sdk/apis/appconfig-2019-10-09.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListApplications: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListConfigurationProfiles: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDeploymentStrategies: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDeployments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListEnvironments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListHostedConfigurationVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/appconfig.js
var require_appconfig = __commonJS({
  "node_modules/aws-sdk/clients/appconfig.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["appconfig"] = {};
    AWS3.AppConfig = Service.defineService("appconfig", ["2019-10-09"]);
    Object.defineProperty(apiLoader.services["appconfig"], "2019-10-09", {
      get: function get() {
        var model = require_appconfig_2019_10_09_min();
        model.paginators = require_appconfig_2019_10_09_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.AppConfig;
  }
});

// node_modules/aws-sdk/apis/iotsecuretunneling-2018-10-05.min.json
var require_iotsecuretunneling_2018_10_05_min = __commonJS({
  "node_modules/aws-sdk/apis/iotsecuretunneling-2018-10-05.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-10-05",
        endpointPrefix: "api.tunneling.iot",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "AWS IoT Secure Tunneling",
        serviceId: "IoTSecureTunneling",
        signatureVersion: "v4",
        signingName: "IoTSecuredTunneling",
        targetPrefix: "IoTSecuredTunneling",
        uid: "iotsecuretunneling-2018-10-05"
      },
      operations: {
        CloseTunnel: {
          input: {
            type: "structure",
            required: [
              "tunnelId"
            ],
            members: {
              tunnelId: {},
              delete: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeTunnel: {
          input: {
            type: "structure",
            required: [
              "tunnelId"
            ],
            members: {
              tunnelId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tunnel: {
                type: "structure",
                members: {
                  tunnelId: {},
                  tunnelArn: {},
                  status: {},
                  sourceConnectionState: {
                    shape: "Sa"
                  },
                  destinationConnectionState: {
                    shape: "Sa"
                  },
                  description: {},
                  destinationConfig: {
                    shape: "Se"
                  },
                  timeoutConfig: {
                    shape: "Si"
                  },
                  tags: {
                    shape: "Sk"
                  },
                  createdAt: {
                    type: "timestamp"
                  },
                  lastUpdatedAt: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sk"
              }
            }
          }
        },
        ListTunnels: {
          input: {
            type: "structure",
            members: {
              thingName: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tunnelSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    tunnelId: {},
                    tunnelArn: {},
                    status: {},
                    description: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        OpenTunnel: {
          input: {
            type: "structure",
            members: {
              description: {},
              tags: {
                shape: "Sk"
              },
              destinationConfig: {
                shape: "Se"
              },
              timeoutConfig: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tunnelId: {},
              tunnelArn: {},
              sourceAccessToken: {
                shape: "Sz"
              },
              destinationAccessToken: {
                shape: "Sz"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sa: {
          type: "structure",
          members: {
            status: {},
            lastUpdatedAt: {
              type: "timestamp"
            }
          }
        },
        Se: {
          type: "structure",
          required: [
            "services"
          ],
          members: {
            thingName: {},
            services: {
              type: "list",
              member: {}
            }
          }
        },
        Si: {
          type: "structure",
          members: {
            maxLifetimeTimeoutMinutes: {
              type: "integer"
            }
          }
        },
        Sk: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sz: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotsecuretunneling-2018-10-05.paginators.json
var require_iotsecuretunneling_2018_10_05_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iotsecuretunneling-2018-10-05.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListTunnels: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iotsecuretunneling.js
var require_iotsecuretunneling = __commonJS({
  "node_modules/aws-sdk/clients/iotsecuretunneling.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["iotsecuretunneling"] = {};
    AWS3.IoTSecureTunneling = Service.defineService("iotsecuretunneling", ["2018-10-05"]);
    Object.defineProperty(apiLoader.services["iotsecuretunneling"], "2018-10-05", {
      get: function get() {
        var model = require_iotsecuretunneling_2018_10_05_min();
        model.paginators = require_iotsecuretunneling_2018_10_05_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.IoTSecureTunneling;
  }
});

// node_modules/aws-sdk/apis/wafv2-2019-07-29.min.json
var require_wafv2_2019_07_29_min = __commonJS({
  "node_modules/aws-sdk/apis/wafv2-2019-07-29.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-07-29",
        endpointPrefix: "wafv2",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "WAFV2",
        serviceFullName: "AWS WAFV2",
        serviceId: "WAFV2",
        signatureVersion: "v4",
        targetPrefix: "AWSWAF_20190729",
        uid: "wafv2-2019-07-29"
      },
      operations: {
        AssociateWebACL: {
          input: {
            type: "structure",
            required: [
              "WebACLArn",
              "ResourceArn"
            ],
            members: {
              WebACLArn: {},
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CheckCapacity: {
          input: {
            type: "structure",
            required: [
              "Scope",
              "Rules"
            ],
            members: {
              Scope: {},
              Rules: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Capacity: {
                type: "long"
              }
            }
          }
        },
        CreateIPSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "IPAddressVersion",
              "Addresses"
            ],
            members: {
              Name: {},
              Scope: {},
              Description: {},
              IPAddressVersion: {},
              Addresses: {
                shape: "S2j"
              },
              Tags: {
                shape: "S2l"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Summary: {
                shape: "S2q"
              }
            }
          }
        },
        CreateRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "RegularExpressionList"
            ],
            members: {
              Name: {},
              Scope: {},
              Description: {},
              RegularExpressionList: {
                shape: "S2u"
              },
              Tags: {
                shape: "S2l"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Summary: {
                shape: "S2x"
              }
            }
          }
        },
        CreateRuleGroup: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Capacity",
              "VisibilityConfig"
            ],
            members: {
              Name: {},
              Scope: {},
              Capacity: {
                type: "long"
              },
              Description: {},
              Rules: {
                shape: "S6"
              },
              VisibilityConfig: {
                shape: "S2b"
              },
              Tags: {
                shape: "S2l"
              },
              CustomResponseBodies: {
                shape: "S30"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Summary: {
                shape: "S35"
              }
            }
          }
        },
        CreateWebACL: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "DefaultAction",
              "VisibilityConfig"
            ],
            members: {
              Name: {},
              Scope: {},
              DefaultAction: {
                shape: "S37"
              },
              Description: {},
              Rules: {
                shape: "S6"
              },
              VisibilityConfig: {
                shape: "S2b"
              },
              Tags: {
                shape: "S2l"
              },
              CustomResponseBodies: {
                shape: "S30"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Summary: {
                shape: "S39"
              }
            }
          }
        },
        DeleteFirewallManagerRuleGroups: {
          input: {
            type: "structure",
            required: [
              "WebACLArn",
              "WebACLLockToken"
            ],
            members: {
              WebACLArn: {},
              WebACLLockToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextWebACLLockToken: {}
            }
          }
        },
        DeleteIPSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id",
              "LockToken"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {},
              LockToken: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLoggingConfiguration: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePermissionPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id",
              "LockToken"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {},
              LockToken: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRuleGroup: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id",
              "LockToken"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {},
              LockToken: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWebACL: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id",
              "LockToken"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {},
              LockToken: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeManagedRuleGroup: {
          input: {
            type: "structure",
            required: [
              "VendorName",
              "Name",
              "Scope"
            ],
            members: {
              VendorName: {},
              Name: {},
              Scope: {},
              VersionName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              VersionName: {},
              SnsTopicArn: {},
              Capacity: {
                type: "long"
              },
              Rules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Action: {
                      shape: "S1v"
                    }
                  }
                }
              },
              LabelNamespace: {},
              AvailableLabels: {
                shape: "S3s"
              },
              ConsumedLabels: {
                shape: "S3s"
              }
            }
          }
        },
        DisassociateWebACL: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetIPSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IPSet: {
                type: "structure",
                required: [
                  "Name",
                  "Id",
                  "ARN",
                  "IPAddressVersion",
                  "Addresses"
                ],
                members: {
                  Name: {},
                  Id: {},
                  ARN: {},
                  Description: {},
                  IPAddressVersion: {},
                  Addresses: {
                    shape: "S2j"
                  }
                }
              },
              LockToken: {}
            }
          }
        },
        GetLoggingConfiguration: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfiguration: {
                shape: "S41"
              }
            }
          }
        },
        GetManagedRuleSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ManagedRuleSet: {
                type: "structure",
                required: [
                  "Name",
                  "Id",
                  "ARN"
                ],
                members: {
                  Name: {},
                  Id: {},
                  ARN: {},
                  Description: {},
                  PublishedVersions: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        AssociatedRuleGroupArn: {},
                        Capacity: {
                          type: "long"
                        },
                        ForecastedLifetime: {
                          type: "integer"
                        },
                        PublishTimestamp: {
                          type: "timestamp"
                        },
                        LastUpdateTimestamp: {
                          type: "timestamp"
                        },
                        ExpiryTimestamp: {
                          type: "timestamp"
                        }
                      }
                    }
                  },
                  RecommendedVersion: {},
                  LabelNamespace: {}
                }
              },
              LockToken: {}
            }
          }
        },
        GetPermissionPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          }
        },
        GetRateBasedStatementManagedKeys: {
          input: {
            type: "structure",
            required: [
              "Scope",
              "WebACLName",
              "WebACLId",
              "RuleName"
            ],
            members: {
              Scope: {},
              WebACLName: {},
              WebACLId: {},
              RuleGroupRuleName: {},
              RuleName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ManagedKeysIPV4: {
                shape: "S4q"
              },
              ManagedKeysIPV6: {
                shape: "S4q"
              }
            }
          }
        },
        GetRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RegexPatternSet: {
                type: "structure",
                members: {
                  Name: {},
                  Id: {},
                  ARN: {},
                  Description: {},
                  RegularExpressionList: {
                    shape: "S2u"
                  }
                }
              },
              LockToken: {}
            }
          }
        },
        GetRuleGroup: {
          input: {
            type: "structure",
            members: {
              Name: {},
              Scope: {},
              Id: {},
              ARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              RuleGroup: {
                type: "structure",
                required: [
                  "Name",
                  "Id",
                  "Capacity",
                  "ARN",
                  "VisibilityConfig"
                ],
                members: {
                  Name: {},
                  Id: {},
                  Capacity: {
                    type: "long"
                  },
                  ARN: {},
                  Description: {},
                  Rules: {
                    shape: "S6"
                  },
                  VisibilityConfig: {
                    shape: "S2b"
                  },
                  LabelNamespace: {},
                  CustomResponseBodies: {
                    shape: "S30"
                  },
                  AvailableLabels: {
                    shape: "S3s"
                  },
                  ConsumedLabels: {
                    shape: "S3s"
                  }
                }
              },
              LockToken: {}
            }
          }
        },
        GetSampledRequests: {
          input: {
            type: "structure",
            required: [
              "WebAclArn",
              "RuleMetricName",
              "Scope",
              "TimeWindow",
              "MaxItems"
            ],
            members: {
              WebAclArn: {},
              RuleMetricName: {},
              Scope: {},
              TimeWindow: {
                shape: "S4y"
              },
              MaxItems: {
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SampledRequests: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Request",
                    "Weight"
                  ],
                  members: {
                    Request: {
                      type: "structure",
                      members: {
                        ClientIP: {},
                        Country: {},
                        URI: {},
                        Method: {},
                        HTTPVersion: {},
                        Headers: {
                          shape: "S59"
                        }
                      }
                    },
                    Weight: {
                      type: "long"
                    },
                    Timestamp: {
                      type: "timestamp"
                    },
                    Action: {},
                    RuleNameWithinRuleGroup: {},
                    RequestHeadersInserted: {
                      shape: "S59"
                    },
                    ResponseCodeSent: {
                      type: "integer"
                    },
                    Labels: {
                      shape: "S28"
                    }
                  }
                }
              },
              PopulationSize: {
                type: "long"
              },
              TimeWindow: {
                shape: "S4y"
              }
            }
          }
        },
        GetWebACL: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WebACL: {
                shape: "S5i"
              },
              LockToken: {}
            }
          }
        },
        GetWebACLForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WebACL: {
                shape: "S5i"
              }
            }
          }
        },
        ListAvailableManagedRuleGroupVersions: {
          input: {
            type: "structure",
            required: [
              "VendorName",
              "Name",
              "Scope"
            ],
            members: {
              VendorName: {},
              Name: {},
              Scope: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              Versions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    LastUpdateTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListAvailableManagedRuleGroups: {
          input: {
            type: "structure",
            required: [
              "Scope"
            ],
            members: {
              Scope: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              ManagedRuleGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VendorName: {},
                    Name: {},
                    Description: {}
                  }
                }
              }
            }
          }
        },
        ListIPSets: {
          input: {
            type: "structure",
            required: [
              "Scope"
            ],
            members: {
              Scope: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              IPSets: {
                type: "list",
                member: {
                  shape: "S2q"
                }
              }
            }
          }
        },
        ListLoggingConfigurations: {
          input: {
            type: "structure",
            members: {
              Scope: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfigurations: {
                type: "list",
                member: {
                  shape: "S41"
                }
              },
              NextMarker: {}
            }
          }
        },
        ListManagedRuleSets: {
          input: {
            type: "structure",
            required: [
              "Scope"
            ],
            members: {
              Scope: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              ManagedRuleSets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Id: {},
                    Description: {},
                    LockToken: {},
                    ARN: {},
                    LabelNamespace: {}
                  }
                }
              }
            }
          }
        },
        ListRegexPatternSets: {
          input: {
            type: "structure",
            required: [
              "Scope"
            ],
            members: {
              Scope: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              RegexPatternSets: {
                type: "list",
                member: {
                  shape: "S2x"
                }
              }
            }
          }
        },
        ListResourcesForWebACL: {
          input: {
            type: "structure",
            required: [
              "WebACLArn"
            ],
            members: {
              WebACLArn: {},
              ResourceType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceArns: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListRuleGroups: {
          input: {
            type: "structure",
            required: [
              "Scope"
            ],
            members: {
              Scope: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              RuleGroups: {
                type: "list",
                member: {
                  shape: "S35"
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              NextMarker: {},
              Limit: {
                type: "integer"
              },
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              TagInfoForResource: {
                type: "structure",
                members: {
                  ResourceARN: {},
                  TagList: {
                    shape: "S2l"
                  }
                }
              }
            }
          }
        },
        ListWebACLs: {
          input: {
            type: "structure",
            required: [
              "Scope"
            ],
            members: {
              Scope: {},
              NextMarker: {},
              Limit: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextMarker: {},
              WebACLs: {
                type: "list",
                member: {
                  shape: "S39"
                }
              }
            }
          }
        },
        PutLoggingConfiguration: {
          input: {
            type: "structure",
            required: [
              "LoggingConfiguration"
            ],
            members: {
              LoggingConfiguration: {
                shape: "S41"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoggingConfiguration: {
                shape: "S41"
              }
            }
          }
        },
        PutManagedRuleSetVersions: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id",
              "LockToken"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {},
              LockToken: {},
              RecommendedVersion: {},
              VersionsToPublish: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    AssociatedRuleGroupArn: {},
                    ForecastedLifetime: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextLockToken: {}
            }
          }
        },
        PutPermissionPolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Policy"
            ],
            members: {
              ResourceArn: {},
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S2l"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateIPSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id",
              "Addresses",
              "LockToken"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {},
              Description: {},
              Addresses: {
                shape: "S2j"
              },
              LockToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextLockToken: {}
            }
          }
        },
        UpdateManagedRuleSetVersionExpiryDate: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id",
              "LockToken",
              "VersionToExpire",
              "ExpiryTimestamp"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {},
              LockToken: {},
              VersionToExpire: {},
              ExpiryTimestamp: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ExpiringVersion: {},
              ExpiryTimestamp: {
                type: "timestamp"
              },
              NextLockToken: {}
            }
          }
        },
        UpdateRegexPatternSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id",
              "RegularExpressionList",
              "LockToken"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {},
              Description: {},
              RegularExpressionList: {
                shape: "S2u"
              },
              LockToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextLockToken: {}
            }
          }
        },
        UpdateRuleGroup: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id",
              "VisibilityConfig",
              "LockToken"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {},
              Description: {},
              Rules: {
                shape: "S6"
              },
              VisibilityConfig: {
                shape: "S2b"
              },
              LockToken: {},
              CustomResponseBodies: {
                shape: "S30"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextLockToken: {}
            }
          }
        },
        UpdateWebACL: {
          input: {
            type: "structure",
            required: [
              "Name",
              "Scope",
              "Id",
              "DefaultAction",
              "VisibilityConfig",
              "LockToken"
            ],
            members: {
              Name: {},
              Scope: {},
              Id: {},
              DefaultAction: {
                shape: "S37"
              },
              Description: {},
              Rules: {
                shape: "S6"
              },
              VisibilityConfig: {
                shape: "S2b"
              },
              LockToken: {},
              CustomResponseBodies: {
                shape: "S30"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextLockToken: {}
            }
          }
        }
      },
      shapes: {
        S6: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Priority",
              "Statement",
              "VisibilityConfig"
            ],
            members: {
              Name: {},
              Priority: {
                type: "integer"
              },
              Statement: {
                shape: "Sa"
              },
              Action: {
                shape: "S1v"
              },
              OverrideAction: {
                shape: "S26"
              },
              RuleLabels: {
                shape: "S28"
              },
              VisibilityConfig: {
                shape: "S2b"
              }
            }
          }
        },
        Sa: {
          type: "structure",
          members: {
            ByteMatchStatement: {
              type: "structure",
              required: [
                "SearchString",
                "FieldToMatch",
                "TextTransformations",
                "PositionalConstraint"
              ],
              members: {
                SearchString: {
                  type: "blob"
                },
                FieldToMatch: {
                  shape: "Sd"
                },
                TextTransformations: {
                  shape: "St"
                },
                PositionalConstraint: {}
              }
            },
            SqliMatchStatement: {
              type: "structure",
              required: [
                "FieldToMatch",
                "TextTransformations"
              ],
              members: {
                FieldToMatch: {
                  shape: "Sd"
                },
                TextTransformations: {
                  shape: "St"
                }
              }
            },
            XssMatchStatement: {
              type: "structure",
              required: [
                "FieldToMatch",
                "TextTransformations"
              ],
              members: {
                FieldToMatch: {
                  shape: "Sd"
                },
                TextTransformations: {
                  shape: "St"
                }
              }
            },
            SizeConstraintStatement: {
              type: "structure",
              required: [
                "FieldToMatch",
                "ComparisonOperator",
                "Size",
                "TextTransformations"
              ],
              members: {
                FieldToMatch: {
                  shape: "Sd"
                },
                ComparisonOperator: {},
                Size: {
                  type: "long"
                },
                TextTransformations: {
                  shape: "St"
                }
              }
            },
            GeoMatchStatement: {
              type: "structure",
              members: {
                CountryCodes: {
                  type: "list",
                  member: {}
                },
                ForwardedIPConfig: {
                  shape: "S16"
                }
              }
            },
            RuleGroupReferenceStatement: {
              shape: "S19"
            },
            IPSetReferenceStatement: {
              type: "structure",
              required: [
                "ARN"
              ],
              members: {
                ARN: {},
                IPSetForwardedIPConfig: {
                  type: "structure",
                  required: [
                    "HeaderName",
                    "FallbackBehavior",
                    "Position"
                  ],
                  members: {
                    HeaderName: {},
                    FallbackBehavior: {},
                    Position: {}
                  }
                }
              }
            },
            RegexPatternSetReferenceStatement: {
              type: "structure",
              required: [
                "ARN",
                "FieldToMatch",
                "TextTransformations"
              ],
              members: {
                ARN: {},
                FieldToMatch: {
                  shape: "Sd"
                },
                TextTransformations: {
                  shape: "St"
                }
              }
            },
            RateBasedStatement: {
              type: "structure",
              required: [
                "Limit",
                "AggregateKeyType"
              ],
              members: {
                Limit: {
                  type: "long"
                },
                AggregateKeyType: {},
                ScopeDownStatement: {
                  shape: "Sa"
                },
                ForwardedIPConfig: {
                  shape: "S16"
                }
              }
            },
            AndStatement: {
              type: "structure",
              required: [
                "Statements"
              ],
              members: {
                Statements: {
                  shape: "S1k"
                }
              }
            },
            OrStatement: {
              type: "structure",
              required: [
                "Statements"
              ],
              members: {
                Statements: {
                  shape: "S1k"
                }
              }
            },
            NotStatement: {
              type: "structure",
              required: [
                "Statement"
              ],
              members: {
                Statement: {
                  shape: "Sa"
                }
              }
            },
            ManagedRuleGroupStatement: {
              shape: "S1n"
            },
            LabelMatchStatement: {
              type: "structure",
              required: [
                "Scope",
                "Key"
              ],
              members: {
                Scope: {},
                Key: {}
              }
            },
            RegexMatchStatement: {
              type: "structure",
              required: [
                "RegexString",
                "FieldToMatch",
                "TextTransformations"
              ],
              members: {
                RegexString: {},
                FieldToMatch: {
                  shape: "Sd"
                },
                TextTransformations: {
                  shape: "St"
                }
              }
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            SingleHeader: {
              type: "structure",
              required: [
                "Name"
              ],
              members: {
                Name: {}
              }
            },
            SingleQueryArgument: {
              type: "structure",
              required: [
                "Name"
              ],
              members: {
                Name: {}
              }
            },
            AllQueryArguments: {
              type: "structure",
              members: {}
            },
            UriPath: {
              type: "structure",
              members: {}
            },
            QueryString: {
              type: "structure",
              members: {}
            },
            Body: {
              type: "structure",
              members: {}
            },
            Method: {
              type: "structure",
              members: {}
            },
            JsonBody: {
              type: "structure",
              required: [
                "MatchPattern",
                "MatchScope"
              ],
              members: {
                MatchPattern: {
                  type: "structure",
                  members: {
                    All: {
                      type: "structure",
                      members: {}
                    },
                    IncludedPaths: {
                      type: "list",
                      member: {}
                    }
                  }
                },
                MatchScope: {},
                InvalidFallbackBehavior: {}
              }
            }
          }
        },
        St: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Priority",
              "Type"
            ],
            members: {
              Priority: {
                type: "integer"
              },
              Type: {}
            }
          }
        },
        S16: {
          type: "structure",
          required: [
            "HeaderName",
            "FallbackBehavior"
          ],
          members: {
            HeaderName: {},
            FallbackBehavior: {}
          }
        },
        S19: {
          type: "structure",
          required: [
            "ARN"
          ],
          members: {
            ARN: {},
            ExcludedRules: {
              shape: "S1a"
            }
          }
        },
        S1a: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        S1k: {
          type: "list",
          member: {
            shape: "Sa"
          }
        },
        S1n: {
          type: "structure",
          required: [
            "VendorName",
            "Name"
          ],
          members: {
            VendorName: {},
            Name: {},
            Version: {},
            ExcludedRules: {
              shape: "S1a"
            },
            ScopeDownStatement: {
              shape: "Sa"
            }
          }
        },
        S1v: {
          type: "structure",
          members: {
            Block: {
              shape: "S1w"
            },
            Allow: {
              shape: "S23"
            },
            Count: {
              shape: "S25"
            }
          }
        },
        S1w: {
          type: "structure",
          members: {
            CustomResponse: {
              type: "structure",
              required: [
                "ResponseCode"
              ],
              members: {
                ResponseCode: {
                  type: "integer"
                },
                CustomResponseBodyKey: {},
                ResponseHeaders: {
                  shape: "S1z"
                }
              }
            }
          }
        },
        S1z: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Value"
            ],
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        S23: {
          type: "structure",
          members: {
            CustomRequestHandling: {
              shape: "S24"
            }
          }
        },
        S24: {
          type: "structure",
          required: [
            "InsertHeaders"
          ],
          members: {
            InsertHeaders: {
              shape: "S1z"
            }
          }
        },
        S25: {
          type: "structure",
          members: {
            CustomRequestHandling: {
              shape: "S24"
            }
          }
        },
        S26: {
          type: "structure",
          members: {
            Count: {
              shape: "S25"
            },
            None: {
              type: "structure",
              members: {}
            }
          }
        },
        S28: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        S2b: {
          type: "structure",
          required: [
            "SampledRequestsEnabled",
            "CloudWatchMetricsEnabled",
            "MetricName"
          ],
          members: {
            SampledRequestsEnabled: {
              type: "boolean"
            },
            CloudWatchMetricsEnabled: {
              type: "boolean"
            },
            MetricName: {}
          }
        },
        S2j: {
          type: "list",
          member: {}
        },
        S2l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S2q: {
          type: "structure",
          members: {
            Name: {},
            Id: {},
            Description: {},
            LockToken: {},
            ARN: {}
          }
        },
        S2u: {
          type: "list",
          member: {
            type: "structure",
            members: {
              RegexString: {}
            }
          }
        },
        S2x: {
          type: "structure",
          members: {
            Name: {},
            Id: {},
            Description: {},
            LockToken: {},
            ARN: {}
          }
        },
        S30: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "ContentType",
              "Content"
            ],
            members: {
              ContentType: {},
              Content: {}
            }
          }
        },
        S35: {
          type: "structure",
          members: {
            Name: {},
            Id: {},
            Description: {},
            LockToken: {},
            ARN: {}
          }
        },
        S37: {
          type: "structure",
          members: {
            Block: {
              shape: "S1w"
            },
            Allow: {
              shape: "S23"
            }
          }
        },
        S39: {
          type: "structure",
          members: {
            Name: {},
            Id: {},
            Description: {},
            LockToken: {},
            ARN: {}
          }
        },
        S3s: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {}
            }
          }
        },
        S41: {
          type: "structure",
          required: [
            "ResourceArn",
            "LogDestinationConfigs"
          ],
          members: {
            ResourceArn: {},
            LogDestinationConfigs: {
              type: "list",
              member: {}
            },
            RedactedFields: {
              type: "list",
              member: {
                shape: "Sd"
              }
            },
            ManagedByFirewallManager: {
              type: "boolean"
            },
            LoggingFilter: {
              type: "structure",
              required: [
                "Filters",
                "DefaultBehavior"
              ],
              members: {
                Filters: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Behavior",
                      "Requirement",
                      "Conditions"
                    ],
                    members: {
                      Behavior: {},
                      Requirement: {},
                      Conditions: {
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            ActionCondition: {
                              type: "structure",
                              required: [
                                "Action"
                              ],
                              members: {
                                Action: {}
                              }
                            },
                            LabelNameCondition: {
                              type: "structure",
                              required: [
                                "LabelName"
                              ],
                              members: {
                                LabelName: {}
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                },
                DefaultBehavior: {}
              }
            }
          }
        },
        S4q: {
          type: "structure",
          members: {
            IPAddressVersion: {},
            Addresses: {
              shape: "S2j"
            }
          }
        },
        S4y: {
          type: "structure",
          required: [
            "StartTime",
            "EndTime"
          ],
          members: {
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            }
          }
        },
        S59: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Value: {}
            }
          }
        },
        S5i: {
          type: "structure",
          required: [
            "Name",
            "Id",
            "ARN",
            "DefaultAction",
            "VisibilityConfig"
          ],
          members: {
            Name: {},
            Id: {},
            ARN: {},
            DefaultAction: {
              shape: "S37"
            },
            Description: {},
            Rules: {
              shape: "S6"
            },
            VisibilityConfig: {
              shape: "S2b"
            },
            Capacity: {
              type: "long"
            },
            PreProcessFirewallManagerRuleGroups: {
              shape: "S5j"
            },
            PostProcessFirewallManagerRuleGroups: {
              shape: "S5j"
            },
            ManagedByFirewallManager: {
              type: "boolean"
            },
            LabelNamespace: {},
            CustomResponseBodies: {
              shape: "S30"
            }
          }
        },
        S5j: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Priority",
              "FirewallManagerStatement",
              "OverrideAction",
              "VisibilityConfig"
            ],
            members: {
              Name: {},
              Priority: {
                type: "integer"
              },
              FirewallManagerStatement: {
                type: "structure",
                members: {
                  ManagedRuleGroupStatement: {
                    shape: "S1n"
                  },
                  RuleGroupReferenceStatement: {
                    shape: "S19"
                  }
                }
              },
              OverrideAction: {
                shape: "S26"
              },
              VisibilityConfig: {
                shape: "S2b"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/wafv2-2019-07-29.paginators.json
var require_wafv2_2019_07_29_paginators = __commonJS({
  "node_modules/aws-sdk/apis/wafv2-2019-07-29.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/wafv2.js
var require_wafv2 = __commonJS({
  "node_modules/aws-sdk/clients/wafv2.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["wafv2"] = {};
    AWS3.WAFV2 = Service.defineService("wafv2", ["2019-07-29"]);
    Object.defineProperty(apiLoader.services["wafv2"], "2019-07-29", {
      get: function get() {
        var model = require_wafv2_2019_07_29_min();
        model.paginators = require_wafv2_2019_07_29_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.WAFV2;
  }
});

// node_modules/aws-sdk/apis/elastic-inference-2017-07-25.min.json
var require_elastic_inference_2017_07_25_min = __commonJS({
  "node_modules/aws-sdk/apis/elastic-inference-2017-07-25.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-25",
        endpointPrefix: "api.elastic-inference",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon Elastic Inference",
        serviceFullName: "Amazon Elastic  Inference",
        serviceId: "Elastic Inference",
        signatureVersion: "v4",
        signingName: "elastic-inference",
        uid: "elastic-inference-2017-07-25"
      },
      operations: {
        DescribeAcceleratorOfferings: {
          http: {
            requestUri: "/describe-accelerator-offerings"
          },
          input: {
            type: "structure",
            required: [
              "locationType"
            ],
            members: {
              locationType: {},
              acceleratorTypes: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              acceleratorTypeOfferings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    acceleratorType: {},
                    locationType: {},
                    location: {}
                  }
                }
              }
            }
          }
        },
        DescribeAcceleratorTypes: {
          http: {
            method: "GET",
            requestUri: "/describe-accelerator-types"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              acceleratorTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    acceleratorTypeName: {},
                    memoryInfo: {
                      type: "structure",
                      members: {
                        sizeInMiB: {
                          type: "integer"
                        }
                      }
                    },
                    throughputInfo: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          key: {},
                          value: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeAccelerators: {
          http: {
            requestUri: "/describe-accelerators"
          },
          input: {
            type: "structure",
            members: {
              acceleratorIds: {
                type: "list",
                member: {}
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              acceleratorSet: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    acceleratorHealth: {
                      type: "structure",
                      members: {
                        status: {}
                      }
                    },
                    acceleratorType: {},
                    acceleratorId: {},
                    availabilityZone: {},
                    attachedResource: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S13"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S13"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S13: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/elastic-inference-2017-07-25.paginators.json
var require_elastic_inference_2017_07_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/elastic-inference-2017-07-25.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeAccelerators: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "acceleratorSet"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/elasticinference.js
var require_elasticinference = __commonJS({
  "node_modules/aws-sdk/clients/elasticinference.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["elasticinference"] = {};
    AWS3.ElasticInference = Service.defineService("elasticinference", ["2017-07-25"]);
    Object.defineProperty(apiLoader.services["elasticinference"], "2017-07-25", {
      get: function get() {
        var model = require_elastic_inference_2017_07_25_min();
        model.paginators = require_elastic_inference_2017_07_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ElasticInference;
  }
});

// node_modules/aws-sdk/apis/imagebuilder-2019-12-02.min.json
var require_imagebuilder_2019_12_02_min = __commonJS({
  "node_modules/aws-sdk/apis/imagebuilder-2019-12-02.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-12-02",
        endpointPrefix: "imagebuilder",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "imagebuilder",
        serviceFullName: "EC2 Image Builder",
        serviceId: "imagebuilder",
        signatureVersion: "v4",
        signingName: "imagebuilder",
        uid: "imagebuilder-2019-12-02"
      },
      operations: {
        CancelImageCreation: {
          http: {
            method: "PUT",
            requestUri: "/CancelImageCreation"
          },
          input: {
            type: "structure",
            required: [
              "imageBuildVersionArn",
              "clientToken"
            ],
            members: {
              imageBuildVersionArn: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              imageBuildVersionArn: {}
            }
          }
        },
        CreateComponent: {
          http: {
            method: "PUT",
            requestUri: "/CreateComponent"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "semanticVersion",
              "platform",
              "clientToken"
            ],
            members: {
              name: {},
              semanticVersion: {},
              description: {},
              changeDescription: {},
              platform: {},
              supportedOsVersions: {
                shape: "Sa"
              },
              data: {},
              uri: {},
              kmsKeyId: {},
              tags: {
                shape: "Se"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              componentBuildVersionArn: {}
            }
          }
        },
        CreateContainerRecipe: {
          http: {
            method: "PUT",
            requestUri: "/CreateContainerRecipe"
          },
          input: {
            type: "structure",
            required: [
              "containerType",
              "name",
              "semanticVersion",
              "components",
              "parentImage",
              "targetRepository",
              "clientToken"
            ],
            members: {
              containerType: {},
              name: {},
              description: {},
              semanticVersion: {},
              components: {
                shape: "Sl"
              },
              instanceConfiguration: {
                shape: "St"
              },
              dockerfileTemplateData: {},
              dockerfileTemplateUri: {},
              platformOverride: {},
              imageOsVersionOverride: {},
              parentImage: {},
              tags: {
                shape: "Se"
              },
              workingDirectory: {},
              targetRepository: {
                shape: "S14"
              },
              kmsKeyId: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              containerRecipeArn: {}
            }
          }
        },
        CreateDistributionConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/CreateDistributionConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "distributions",
              "clientToken"
            ],
            members: {
              name: {},
              description: {},
              distributions: {
                shape: "S19"
              },
              tags: {
                shape: "Se"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              distributionConfigurationArn: {}
            }
          }
        },
        CreateImage: {
          http: {
            method: "PUT",
            requestUri: "/CreateImage"
          },
          input: {
            type: "structure",
            required: [
              "infrastructureConfigurationArn",
              "clientToken"
            ],
            members: {
              imageRecipeArn: {},
              containerRecipeArn: {},
              distributionConfigurationArn: {},
              infrastructureConfigurationArn: {},
              imageTestsConfiguration: {
                shape: "S1t"
              },
              enhancedImageMetadataEnabled: {
                type: "boolean"
              },
              tags: {
                shape: "Se"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              imageBuildVersionArn: {}
            }
          }
        },
        CreateImagePipeline: {
          http: {
            method: "PUT",
            requestUri: "/CreateImagePipeline"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "infrastructureConfigurationArn",
              "clientToken"
            ],
            members: {
              name: {},
              description: {},
              imageRecipeArn: {},
              containerRecipeArn: {},
              infrastructureConfigurationArn: {},
              distributionConfigurationArn: {},
              imageTestsConfiguration: {
                shape: "S1t"
              },
              enhancedImageMetadataEnabled: {
                type: "boolean"
              },
              schedule: {
                shape: "S1x"
              },
              status: {},
              tags: {
                shape: "Se"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              imagePipelineArn: {}
            }
          }
        },
        CreateImageRecipe: {
          http: {
            method: "PUT",
            requestUri: "/CreateImageRecipe"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "semanticVersion",
              "components",
              "parentImage",
              "clientToken"
            ],
            members: {
              name: {},
              description: {},
              semanticVersion: {},
              components: {
                shape: "Sl"
              },
              parentImage: {},
              blockDeviceMappings: {
                shape: "Su"
              },
              tags: {
                shape: "Se"
              },
              workingDirectory: {},
              additionalInstanceConfiguration: {
                shape: "S24"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              imageRecipeArn: {}
            }
          }
        },
        CreateInfrastructureConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/CreateInfrastructureConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "instanceProfileName",
              "clientToken"
            ],
            members: {
              name: {},
              description: {},
              instanceTypes: {
                shape: "S29"
              },
              instanceProfileName: {},
              securityGroupIds: {
                shape: "S2c"
              },
              subnetId: {},
              logging: {
                shape: "S2d"
              },
              keyPair: {},
              terminateInstanceOnFailure: {
                type: "boolean"
              },
              snsTopicArn: {},
              resourceTags: {
                shape: "S2g"
              },
              instanceMetadataOptions: {
                shape: "S2h"
              },
              tags: {
                shape: "Se"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              infrastructureConfigurationArn: {}
            }
          }
        },
        DeleteComponent: {
          http: {
            method: "DELETE",
            requestUri: "/DeleteComponent"
          },
          input: {
            type: "structure",
            required: [
              "componentBuildVersionArn"
            ],
            members: {
              componentBuildVersionArn: {
                location: "querystring",
                locationName: "componentBuildVersionArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              componentBuildVersionArn: {}
            }
          }
        },
        DeleteContainerRecipe: {
          http: {
            method: "DELETE",
            requestUri: "/DeleteContainerRecipe"
          },
          input: {
            type: "structure",
            required: [
              "containerRecipeArn"
            ],
            members: {
              containerRecipeArn: {
                location: "querystring",
                locationName: "containerRecipeArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              containerRecipeArn: {}
            }
          }
        },
        DeleteDistributionConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/DeleteDistributionConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "distributionConfigurationArn"
            ],
            members: {
              distributionConfigurationArn: {
                location: "querystring",
                locationName: "distributionConfigurationArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              distributionConfigurationArn: {}
            }
          }
        },
        DeleteImage: {
          http: {
            method: "DELETE",
            requestUri: "/DeleteImage"
          },
          input: {
            type: "structure",
            required: [
              "imageBuildVersionArn"
            ],
            members: {
              imageBuildVersionArn: {
                location: "querystring",
                locationName: "imageBuildVersionArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imageBuildVersionArn: {}
            }
          }
        },
        DeleteImagePipeline: {
          http: {
            method: "DELETE",
            requestUri: "/DeleteImagePipeline"
          },
          input: {
            type: "structure",
            required: [
              "imagePipelineArn"
            ],
            members: {
              imagePipelineArn: {
                location: "querystring",
                locationName: "imagePipelineArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imagePipelineArn: {}
            }
          }
        },
        DeleteImageRecipe: {
          http: {
            method: "DELETE",
            requestUri: "/DeleteImageRecipe"
          },
          input: {
            type: "structure",
            required: [
              "imageRecipeArn"
            ],
            members: {
              imageRecipeArn: {
                location: "querystring",
                locationName: "imageRecipeArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imageRecipeArn: {}
            }
          }
        },
        DeleteInfrastructureConfiguration: {
          http: {
            method: "DELETE",
            requestUri: "/DeleteInfrastructureConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "infrastructureConfigurationArn"
            ],
            members: {
              infrastructureConfigurationArn: {
                location: "querystring",
                locationName: "infrastructureConfigurationArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              infrastructureConfigurationArn: {}
            }
          }
        },
        GetComponent: {
          http: {
            method: "GET",
            requestUri: "/GetComponent"
          },
          input: {
            type: "structure",
            required: [
              "componentBuildVersionArn"
            ],
            members: {
              componentBuildVersionArn: {
                location: "querystring",
                locationName: "componentBuildVersionArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              component: {
                type: "structure",
                members: {
                  arn: {},
                  name: {},
                  version: {},
                  description: {},
                  changeDescription: {},
                  type: {},
                  platform: {},
                  supportedOsVersions: {
                    shape: "Sa"
                  },
                  state: {
                    shape: "S34"
                  },
                  parameters: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "name",
                        "type"
                      ],
                      members: {
                        name: {},
                        type: {},
                        defaultValue: {
                          shape: "Sr"
                        },
                        description: {}
                      }
                    }
                  },
                  owner: {},
                  data: {},
                  kmsKeyId: {},
                  encrypted: {
                    type: "boolean"
                  },
                  dateCreated: {},
                  tags: {
                    shape: "Se"
                  }
                }
              }
            }
          }
        },
        GetComponentPolicy: {
          http: {
            method: "GET",
            requestUri: "/GetComponentPolicy"
          },
          input: {
            type: "structure",
            required: [
              "componentArn"
            ],
            members: {
              componentArn: {
                location: "querystring",
                locationName: "componentArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              policy: {}
            }
          }
        },
        GetContainerRecipe: {
          http: {
            method: "GET",
            requestUri: "/GetContainerRecipe"
          },
          input: {
            type: "structure",
            required: [
              "containerRecipeArn"
            ],
            members: {
              containerRecipeArn: {
                location: "querystring",
                locationName: "containerRecipeArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              containerRecipe: {
                shape: "S3h"
              }
            }
          }
        },
        GetContainerRecipePolicy: {
          http: {
            method: "GET",
            requestUri: "/GetContainerRecipePolicy"
          },
          input: {
            type: "structure",
            required: [
              "containerRecipeArn"
            ],
            members: {
              containerRecipeArn: {
                location: "querystring",
                locationName: "containerRecipeArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              policy: {}
            }
          }
        },
        GetDistributionConfiguration: {
          http: {
            method: "GET",
            requestUri: "/GetDistributionConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "distributionConfigurationArn"
            ],
            members: {
              distributionConfigurationArn: {
                location: "querystring",
                locationName: "distributionConfigurationArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              distributionConfiguration: {
                shape: "S3n"
              }
            }
          }
        },
        GetImage: {
          http: {
            method: "GET",
            requestUri: "/GetImage"
          },
          input: {
            type: "structure",
            required: [
              "imageBuildVersionArn"
            ],
            members: {
              imageBuildVersionArn: {
                location: "querystring",
                locationName: "imageBuildVersionArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              image: {
                type: "structure",
                members: {
                  arn: {},
                  type: {},
                  name: {},
                  version: {},
                  platform: {},
                  enhancedImageMetadataEnabled: {
                    type: "boolean"
                  },
                  osVersion: {},
                  state: {
                    shape: "S3u"
                  },
                  imageRecipe: {
                    shape: "S3w"
                  },
                  containerRecipe: {
                    shape: "S3h"
                  },
                  sourcePipelineName: {},
                  sourcePipelineArn: {},
                  infrastructureConfiguration: {
                    shape: "S3y"
                  },
                  distributionConfiguration: {
                    shape: "S3n"
                  },
                  imageTestsConfiguration: {
                    shape: "S1t"
                  },
                  dateCreated: {},
                  outputResources: {
                    shape: "S3z"
                  },
                  tags: {
                    shape: "Se"
                  }
                }
              }
            }
          }
        },
        GetImagePipeline: {
          http: {
            method: "GET",
            requestUri: "/GetImagePipeline"
          },
          input: {
            type: "structure",
            required: [
              "imagePipelineArn"
            ],
            members: {
              imagePipelineArn: {
                location: "querystring",
                locationName: "imagePipelineArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imagePipeline: {
                shape: "S46"
              }
            }
          }
        },
        GetImagePolicy: {
          http: {
            method: "GET",
            requestUri: "/GetImagePolicy"
          },
          input: {
            type: "structure",
            required: [
              "imageArn"
            ],
            members: {
              imageArn: {
                location: "querystring",
                locationName: "imageArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              policy: {}
            }
          }
        },
        GetImageRecipe: {
          http: {
            method: "GET",
            requestUri: "/GetImageRecipe"
          },
          input: {
            type: "structure",
            required: [
              "imageRecipeArn"
            ],
            members: {
              imageRecipeArn: {
                location: "querystring",
                locationName: "imageRecipeArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imageRecipe: {
                shape: "S3w"
              }
            }
          }
        },
        GetImageRecipePolicy: {
          http: {
            method: "GET",
            requestUri: "/GetImageRecipePolicy"
          },
          input: {
            type: "structure",
            required: [
              "imageRecipeArn"
            ],
            members: {
              imageRecipeArn: {
                location: "querystring",
                locationName: "imageRecipeArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              policy: {}
            }
          }
        },
        GetInfrastructureConfiguration: {
          http: {
            method: "GET",
            requestUri: "/GetInfrastructureConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "infrastructureConfigurationArn"
            ],
            members: {
              infrastructureConfigurationArn: {
                location: "querystring",
                locationName: "infrastructureConfigurationArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              infrastructureConfiguration: {
                shape: "S3y"
              }
            }
          }
        },
        ImportComponent: {
          http: {
            method: "PUT",
            requestUri: "/ImportComponent"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "semanticVersion",
              "type",
              "format",
              "platform",
              "clientToken"
            ],
            members: {
              name: {},
              semanticVersion: {},
              description: {},
              changeDescription: {},
              type: {},
              format: {},
              platform: {},
              data: {},
              uri: {},
              kmsKeyId: {},
              tags: {
                shape: "Se"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              componentBuildVersionArn: {}
            }
          }
        },
        ListComponentBuildVersions: {
          http: {
            requestUri: "/ListComponentBuildVersions"
          },
          input: {
            type: "structure",
            required: [
              "componentVersionArn"
            ],
            members: {
              componentVersionArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              componentSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    version: {},
                    platform: {},
                    supportedOsVersions: {
                      shape: "Sa"
                    },
                    state: {
                      shape: "S34"
                    },
                    type: {},
                    owner: {},
                    description: {},
                    changeDescription: {},
                    dateCreated: {},
                    tags: {
                      shape: "Se"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListComponents: {
          http: {
            requestUri: "/ListComponents"
          },
          input: {
            type: "structure",
            members: {
              owner: {},
              filters: {
                shape: "S4r"
              },
              byName: {
                type: "boolean"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              componentVersionList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    version: {},
                    description: {},
                    platform: {},
                    supportedOsVersions: {
                      shape: "Sa"
                    },
                    type: {},
                    owner: {},
                    dateCreated: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListContainerRecipes: {
          http: {
            requestUri: "/ListContainerRecipes"
          },
          input: {
            type: "structure",
            members: {
              owner: {},
              filters: {
                shape: "S4r"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              containerRecipeSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    containerType: {},
                    name: {},
                    platform: {},
                    owner: {},
                    parentImage: {},
                    dateCreated: {},
                    tags: {
                      shape: "Se"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDistributionConfigurations: {
          http: {
            requestUri: "/ListDistributionConfigurations"
          },
          input: {
            type: "structure",
            members: {
              filters: {
                shape: "S4r"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              distributionConfigurationSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    description: {},
                    dateCreated: {},
                    dateUpdated: {},
                    tags: {
                      shape: "Se"
                    },
                    regions: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListImageBuildVersions: {
          http: {
            requestUri: "/ListImageBuildVersions"
          },
          input: {
            type: "structure",
            required: [
              "imageVersionArn"
            ],
            members: {
              imageVersionArn: {},
              filters: {
                shape: "S4r"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imageSummaryList: {
                shape: "S5b"
              },
              nextToken: {}
            }
          }
        },
        ListImagePackages: {
          http: {
            requestUri: "/ListImagePackages"
          },
          input: {
            type: "structure",
            required: [
              "imageBuildVersionArn"
            ],
            members: {
              imageBuildVersionArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imagePackageList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    packageName: {},
                    packageVersion: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListImagePipelineImages: {
          http: {
            requestUri: "/ListImagePipelineImages"
          },
          input: {
            type: "structure",
            required: [
              "imagePipelineArn"
            ],
            members: {
              imagePipelineArn: {},
              filters: {
                shape: "S4r"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imageSummaryList: {
                shape: "S5b"
              },
              nextToken: {}
            }
          }
        },
        ListImagePipelines: {
          http: {
            requestUri: "/ListImagePipelines"
          },
          input: {
            type: "structure",
            members: {
              filters: {
                shape: "S4r"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imagePipelineList: {
                type: "list",
                member: {
                  shape: "S46"
                }
              },
              nextToken: {}
            }
          }
        },
        ListImageRecipes: {
          http: {
            requestUri: "/ListImageRecipes"
          },
          input: {
            type: "structure",
            members: {
              owner: {},
              filters: {
                shape: "S4r"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imageRecipeSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    platform: {},
                    owner: {},
                    parentImage: {},
                    dateCreated: {},
                    tags: {
                      shape: "Se"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListImages: {
          http: {
            requestUri: "/ListImages"
          },
          input: {
            type: "structure",
            members: {
              owner: {},
              filters: {
                shape: "S4r"
              },
              byName: {
                type: "boolean"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              includeDeprecated: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imageVersionList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    type: {},
                    version: {},
                    platform: {},
                    osVersion: {},
                    owner: {},
                    dateCreated: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListInfrastructureConfigurations: {
          http: {
            requestUri: "/ListInfrastructureConfigurations"
          },
          input: {
            type: "structure",
            members: {
              filters: {
                shape: "S4r"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              infrastructureConfigurationSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    description: {},
                    dateCreated: {},
                    dateUpdated: {},
                    resourceTags: {
                      shape: "S2g"
                    },
                    tags: {
                      shape: "Se"
                    },
                    instanceTypes: {
                      shape: "S29"
                    },
                    instanceProfileName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Se"
              }
            }
          }
        },
        PutComponentPolicy: {
          http: {
            method: "PUT",
            requestUri: "/PutComponentPolicy"
          },
          input: {
            type: "structure",
            required: [
              "componentArn",
              "policy"
            ],
            members: {
              componentArn: {},
              policy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              componentArn: {}
            }
          }
        },
        PutContainerRecipePolicy: {
          http: {
            method: "PUT",
            requestUri: "/PutContainerRecipePolicy"
          },
          input: {
            type: "structure",
            required: [
              "containerRecipeArn",
              "policy"
            ],
            members: {
              containerRecipeArn: {},
              policy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              containerRecipeArn: {}
            }
          }
        },
        PutImagePolicy: {
          http: {
            method: "PUT",
            requestUri: "/PutImagePolicy"
          },
          input: {
            type: "structure",
            required: [
              "imageArn",
              "policy"
            ],
            members: {
              imageArn: {},
              policy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imageArn: {}
            }
          }
        },
        PutImageRecipePolicy: {
          http: {
            method: "PUT",
            requestUri: "/PutImageRecipePolicy"
          },
          input: {
            type: "structure",
            required: [
              "imageRecipeArn",
              "policy"
            ],
            members: {
              imageRecipeArn: {},
              policy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              imageRecipeArn: {}
            }
          }
        },
        StartImagePipelineExecution: {
          http: {
            method: "PUT",
            requestUri: "/StartImagePipelineExecution"
          },
          input: {
            type: "structure",
            required: [
              "imagePipelineArn",
              "clientToken"
            ],
            members: {
              imagePipelineArn: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              imageBuildVersionArn: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDistributionConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/UpdateDistributionConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "distributionConfigurationArn",
              "distributions",
              "clientToken"
            ],
            members: {
              distributionConfigurationArn: {},
              description: {},
              distributions: {
                shape: "S19"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              distributionConfigurationArn: {}
            }
          }
        },
        UpdateImagePipeline: {
          http: {
            method: "PUT",
            requestUri: "/UpdateImagePipeline"
          },
          input: {
            type: "structure",
            required: [
              "imagePipelineArn",
              "infrastructureConfigurationArn",
              "clientToken"
            ],
            members: {
              imagePipelineArn: {},
              description: {},
              imageRecipeArn: {},
              containerRecipeArn: {},
              infrastructureConfigurationArn: {},
              distributionConfigurationArn: {},
              imageTestsConfiguration: {
                shape: "S1t"
              },
              enhancedImageMetadataEnabled: {
                type: "boolean"
              },
              schedule: {
                shape: "S1x"
              },
              status: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              imagePipelineArn: {}
            }
          }
        },
        UpdateInfrastructureConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/UpdateInfrastructureConfiguration"
          },
          input: {
            type: "structure",
            required: [
              "infrastructureConfigurationArn",
              "instanceProfileName",
              "clientToken"
            ],
            members: {
              infrastructureConfigurationArn: {},
              description: {},
              instanceTypes: {
                shape: "S29"
              },
              instanceProfileName: {},
              securityGroupIds: {
                shape: "S2c"
              },
              subnetId: {},
              logging: {
                shape: "S2d"
              },
              keyPair: {},
              terminateInstanceOnFailure: {
                type: "boolean"
              },
              snsTopicArn: {},
              clientToken: {
                idempotencyToken: true
              },
              resourceTags: {
                shape: "S2g"
              },
              instanceMetadataOptions: {
                shape: "S2h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              requestId: {},
              clientToken: {},
              infrastructureConfigurationArn: {}
            }
          }
        }
      },
      shapes: {
        Sa: {
          type: "list",
          member: {}
        },
        Se: {
          type: "map",
          key: {},
          value: {}
        },
        Sl: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "componentArn"
            ],
            members: {
              componentArn: {},
              parameters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "value"
                  ],
                  members: {
                    name: {},
                    value: {
                      shape: "Sr"
                    }
                  }
                }
              }
            }
          }
        },
        Sr: {
          type: "list",
          member: {}
        },
        St: {
          type: "structure",
          members: {
            image: {},
            blockDeviceMappings: {
              shape: "Su"
            }
          }
        },
        Su: {
          type: "list",
          member: {
            type: "structure",
            members: {
              deviceName: {},
              ebs: {
                type: "structure",
                members: {
                  encrypted: {
                    type: "boolean"
                  },
                  deleteOnTermination: {
                    type: "boolean"
                  },
                  iops: {
                    type: "integer"
                  },
                  kmsKeyId: {},
                  snapshotId: {},
                  volumeSize: {
                    type: "integer"
                  },
                  volumeType: {},
                  throughput: {
                    type: "integer"
                  }
                }
              },
              virtualName: {},
              noDevice: {}
            }
          }
        },
        S14: {
          type: "structure",
          required: [
            "service",
            "repositoryName"
          ],
          members: {
            service: {},
            repositoryName: {}
          }
        },
        S19: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "region"
            ],
            members: {
              region: {},
              amiDistributionConfiguration: {
                type: "structure",
                members: {
                  name: {},
                  description: {},
                  targetAccountIds: {
                    shape: "S1d"
                  },
                  amiTags: {
                    shape: "Se"
                  },
                  kmsKeyId: {},
                  launchPermission: {
                    type: "structure",
                    members: {
                      userIds: {
                        shape: "S1d"
                      },
                      userGroups: {
                        shape: "S1g"
                      }
                    }
                  }
                }
              },
              containerDistributionConfiguration: {
                type: "structure",
                required: [
                  "targetRepository"
                ],
                members: {
                  description: {},
                  containerTags: {
                    shape: "S1g"
                  },
                  targetRepository: {
                    shape: "S14"
                  }
                }
              },
              licenseConfigurationArns: {
                type: "list",
                member: {}
              },
              launchTemplateConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "launchTemplateId"
                  ],
                  members: {
                    launchTemplateId: {},
                    accountId: {},
                    setDefaultVersion: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        S1d: {
          type: "list",
          member: {}
        },
        S1g: {
          type: "list",
          member: {}
        },
        S1t: {
          type: "structure",
          members: {
            imageTestsEnabled: {
              type: "boolean"
            },
            timeoutMinutes: {
              type: "integer"
            }
          }
        },
        S1x: {
          type: "structure",
          members: {
            scheduleExpression: {},
            timezone: {},
            pipelineExecutionStartCondition: {}
          }
        },
        S24: {
          type: "structure",
          members: {
            systemsManagerAgent: {
              type: "structure",
              members: {
                uninstallAfterBuild: {
                  type: "boolean"
                }
              }
            },
            userDataOverride: {}
          }
        },
        S29: {
          type: "list",
          member: {}
        },
        S2c: {
          type: "list",
          member: {}
        },
        S2d: {
          type: "structure",
          members: {
            s3Logs: {
              type: "structure",
              members: {
                s3BucketName: {},
                s3KeyPrefix: {}
              }
            }
          }
        },
        S2g: {
          type: "map",
          key: {},
          value: {}
        },
        S2h: {
          type: "structure",
          members: {
            httpTokens: {},
            httpPutResponseHopLimit: {
              type: "integer"
            }
          }
        },
        S34: {
          type: "structure",
          members: {
            status: {},
            reason: {}
          }
        },
        S3h: {
          type: "structure",
          members: {
            arn: {},
            containerType: {},
            name: {},
            description: {},
            platform: {},
            owner: {},
            version: {},
            components: {
              shape: "Sl"
            },
            instanceConfiguration: {
              shape: "St"
            },
            dockerfileTemplateData: {},
            kmsKeyId: {},
            encrypted: {
              type: "boolean"
            },
            parentImage: {},
            dateCreated: {},
            tags: {
              shape: "Se"
            },
            workingDirectory: {},
            targetRepository: {
              shape: "S14"
            }
          }
        },
        S3n: {
          type: "structure",
          required: [
            "timeoutMinutes"
          ],
          members: {
            arn: {},
            name: {},
            description: {},
            distributions: {
              shape: "S19"
            },
            timeoutMinutes: {
              type: "integer"
            },
            dateCreated: {},
            dateUpdated: {},
            tags: {
              shape: "Se"
            }
          }
        },
        S3u: {
          type: "structure",
          members: {
            status: {},
            reason: {}
          }
        },
        S3w: {
          type: "structure",
          members: {
            arn: {},
            type: {},
            name: {},
            description: {},
            platform: {},
            owner: {},
            version: {},
            components: {
              shape: "Sl"
            },
            parentImage: {},
            blockDeviceMappings: {
              shape: "Su"
            },
            dateCreated: {},
            tags: {
              shape: "Se"
            },
            workingDirectory: {},
            additionalInstanceConfiguration: {
              shape: "S24"
            }
          }
        },
        S3y: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            description: {},
            instanceTypes: {
              shape: "S29"
            },
            instanceProfileName: {},
            securityGroupIds: {
              shape: "S2c"
            },
            subnetId: {},
            logging: {
              shape: "S2d"
            },
            keyPair: {},
            terminateInstanceOnFailure: {
              type: "boolean"
            },
            snsTopicArn: {},
            dateCreated: {},
            dateUpdated: {},
            resourceTags: {
              shape: "S2g"
            },
            instanceMetadataOptions: {
              shape: "S2h"
            },
            tags: {
              shape: "Se"
            }
          }
        },
        S3z: {
          type: "structure",
          members: {
            amis: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  region: {},
                  image: {},
                  name: {},
                  description: {},
                  state: {
                    shape: "S3u"
                  },
                  accountId: {}
                }
              }
            },
            containers: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  region: {},
                  imageUris: {
                    shape: "S1g"
                  }
                }
              }
            }
          }
        },
        S46: {
          type: "structure",
          members: {
            arn: {},
            name: {},
            description: {},
            platform: {},
            enhancedImageMetadataEnabled: {
              type: "boolean"
            },
            imageRecipeArn: {},
            containerRecipeArn: {},
            infrastructureConfigurationArn: {},
            distributionConfigurationArn: {},
            imageTestsConfiguration: {
              shape: "S1t"
            },
            schedule: {
              shape: "S1x"
            },
            status: {},
            dateCreated: {},
            dateUpdated: {},
            dateLastRun: {},
            dateNextRun: {},
            tags: {
              shape: "Se"
            }
          }
        },
        S4r: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S5b: {
          type: "list",
          member: {
            type: "structure",
            members: {
              arn: {},
              name: {},
              type: {},
              version: {},
              platform: {},
              osVersion: {},
              state: {
                shape: "S3u"
              },
              owner: {},
              dateCreated: {},
              outputResources: {
                shape: "S3z"
              },
              tags: {
                shape: "Se"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/imagebuilder-2019-12-02.paginators.json
var require_imagebuilder_2019_12_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/imagebuilder-2019-12-02.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListComponentBuildVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "componentSummaryList"
        },
        ListComponents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "componentVersionList"
        },
        ListContainerRecipes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "containerRecipeSummaryList"
        },
        ListDistributionConfigurations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "distributionConfigurationSummaryList"
        },
        ListImageBuildVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "imageSummaryList"
        },
        ListImagePackages: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "imagePackageList"
        },
        ListImagePipelineImages: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "imageSummaryList"
        },
        ListImagePipelines: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "imagePipelineList"
        },
        ListImageRecipes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "imageRecipeSummaryList"
        },
        ListImages: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "imageVersionList"
        },
        ListInfrastructureConfigurations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "infrastructureConfigurationSummaryList"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/imagebuilder.js
var require_imagebuilder = __commonJS({
  "node_modules/aws-sdk/clients/imagebuilder.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["imagebuilder"] = {};
    AWS3.Imagebuilder = Service.defineService("imagebuilder", ["2019-12-02"]);
    Object.defineProperty(apiLoader.services["imagebuilder"], "2019-12-02", {
      get: function get() {
        var model = require_imagebuilder_2019_12_02_min();
        model.paginators = require_imagebuilder_2019_12_02_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Imagebuilder;
  }
});

// node_modules/aws-sdk/apis/schemas-2019-12-02.min.json
var require_schemas_2019_12_02_min = __commonJS({
  "node_modules/aws-sdk/apis/schemas-2019-12-02.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2019-12-02",
        endpointPrefix: "schemas",
        signingName: "schemas",
        serviceFullName: "Schemas",
        serviceId: "schemas",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "schemas-2019-12-02",
        signatureVersion: "v4"
      },
      operations: {
        CreateDiscoverer: {
          http: {
            requestUri: "/v1/discoverers",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Description: {},
              SourceArn: {},
              CrossAccount: {
                type: "boolean"
              },
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            },
            required: [
              "SourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Description: {},
              DiscovererArn: {},
              DiscovererId: {},
              SourceArn: {},
              State: {},
              CrossAccount: {
                type: "boolean"
              },
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          }
        },
        CreateRegistry: {
          http: {
            requestUri: "/v1/registries/name/{registryName}",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Description: {},
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            },
            required: [
              "RegistryName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Description: {},
              RegistryArn: {},
              RegistryName: {},
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          }
        },
        CreateSchema: {
          http: {
            requestUri: "/v1/registries/name/{registryName}/schemas/name/{schemaName}",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Content: {},
              Description: {},
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaName: {
                location: "uri",
                locationName: "schemaName"
              },
              Tags: {
                shape: "S5",
                locationName: "tags"
              },
              Type: {}
            },
            required: [
              "RegistryName",
              "SchemaName",
              "Type",
              "Content"
            ]
          },
          output: {
            type: "structure",
            members: {
              Description: {},
              LastModified: {
                shape: "Sf"
              },
              SchemaArn: {},
              SchemaName: {},
              SchemaVersion: {},
              Tags: {
                shape: "S5",
                locationName: "tags"
              },
              Type: {},
              VersionCreatedDate: {
                shape: "Sf"
              }
            }
          }
        },
        DeleteDiscoverer: {
          http: {
            method: "DELETE",
            requestUri: "/v1/discoverers/id/{discovererId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              DiscovererId: {
                location: "uri",
                locationName: "discovererId"
              }
            },
            required: [
              "DiscovererId"
            ]
          }
        },
        DeleteRegistry: {
          http: {
            method: "DELETE",
            requestUri: "/v1/registries/name/{registryName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              }
            },
            required: [
              "RegistryName"
            ]
          }
        },
        DeleteResourcePolicy: {
          http: {
            method: "DELETE",
            requestUri: "/v1/policy",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              RegistryName: {
                location: "querystring",
                locationName: "registryName"
              }
            }
          }
        },
        DeleteSchema: {
          http: {
            method: "DELETE",
            requestUri: "/v1/registries/name/{registryName}/schemas/name/{schemaName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaName: {
                location: "uri",
                locationName: "schemaName"
              }
            },
            required: [
              "RegistryName",
              "SchemaName"
            ]
          }
        },
        DeleteSchemaVersion: {
          http: {
            method: "DELETE",
            requestUri: "/v1/registries/name/{registryName}/schemas/name/{schemaName}/version/{schemaVersion}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaName: {
                location: "uri",
                locationName: "schemaName"
              },
              SchemaVersion: {
                location: "uri",
                locationName: "schemaVersion"
              }
            },
            required: [
              "SchemaVersion",
              "RegistryName",
              "SchemaName"
            ]
          }
        },
        DescribeCodeBinding: {
          http: {
            method: "GET",
            requestUri: "/v1/registries/name/{registryName}/schemas/name/{schemaName}/language/{language}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Language: {
                location: "uri",
                locationName: "language"
              },
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaName: {
                location: "uri",
                locationName: "schemaName"
              },
              SchemaVersion: {
                location: "querystring",
                locationName: "schemaVersion"
              }
            },
            required: [
              "RegistryName",
              "SchemaName",
              "Language"
            ]
          },
          output: {
            type: "structure",
            members: {
              CreationDate: {
                shape: "Sf"
              },
              LastModified: {
                shape: "Sf"
              },
              SchemaVersion: {},
              Status: {}
            }
          }
        },
        DescribeDiscoverer: {
          http: {
            method: "GET",
            requestUri: "/v1/discoverers/id/{discovererId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DiscovererId: {
                location: "uri",
                locationName: "discovererId"
              }
            },
            required: [
              "DiscovererId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Description: {},
              DiscovererArn: {},
              DiscovererId: {},
              SourceArn: {},
              State: {},
              CrossAccount: {
                type: "boolean"
              },
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          }
        },
        DescribeRegistry: {
          http: {
            method: "GET",
            requestUri: "/v1/registries/name/{registryName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              }
            },
            required: [
              "RegistryName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Description: {},
              RegistryArn: {},
              RegistryName: {},
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          }
        },
        DescribeSchema: {
          http: {
            method: "GET",
            requestUri: "/v1/registries/name/{registryName}/schemas/name/{schemaName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaName: {
                location: "uri",
                locationName: "schemaName"
              },
              SchemaVersion: {
                location: "querystring",
                locationName: "schemaVersion"
              }
            },
            required: [
              "RegistryName",
              "SchemaName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Content: {},
              Description: {},
              LastModified: {
                shape: "Sf"
              },
              SchemaArn: {},
              SchemaName: {},
              SchemaVersion: {},
              Tags: {
                shape: "S5",
                locationName: "tags"
              },
              Type: {},
              VersionCreatedDate: {
                shape: "Sf"
              }
            }
          }
        },
        ExportSchema: {
          http: {
            method: "GET",
            requestUri: "/v1/registries/name/{registryName}/schemas/name/{schemaName}/export",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaName: {
                location: "uri",
                locationName: "schemaName"
              },
              SchemaVersion: {
                location: "querystring",
                locationName: "schemaVersion"
              },
              Type: {
                location: "querystring",
                locationName: "type"
              }
            },
            required: [
              "RegistryName",
              "SchemaName",
              "Type"
            ]
          },
          output: {
            type: "structure",
            members: {
              Content: {},
              SchemaArn: {},
              SchemaName: {},
              SchemaVersion: {},
              Type: {}
            }
          }
        },
        GetCodeBindingSource: {
          http: {
            method: "GET",
            requestUri: "/v1/registries/name/{registryName}/schemas/name/{schemaName}/language/{language}/source",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Language: {
                location: "uri",
                locationName: "language"
              },
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaName: {
                location: "uri",
                locationName: "schemaName"
              },
              SchemaVersion: {
                location: "querystring",
                locationName: "schemaVersion"
              }
            },
            required: [
              "RegistryName",
              "SchemaName",
              "Language"
            ]
          },
          output: {
            type: "structure",
            members: {
              Body: {
                type: "blob"
              }
            },
            payload: "Body"
          }
        },
        GetDiscoveredSchema: {
          http: {
            requestUri: "/v1/discover",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Events: {
                type: "list",
                member: {}
              },
              Type: {}
            },
            required: [
              "Type",
              "Events"
            ]
          },
          output: {
            type: "structure",
            members: {
              Content: {}
            }
          }
        },
        GetResourcePolicy: {
          http: {
            method: "GET",
            requestUri: "/v1/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RegistryName: {
                location: "querystring",
                locationName: "registryName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                jsonvalue: true
              },
              RevisionId: {}
            }
          }
        },
        ListDiscoverers: {
          http: {
            method: "GET",
            requestUri: "/v1/discoverers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DiscovererIdPrefix: {
                location: "querystring",
                locationName: "discovererIdPrefix"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              SourceArnPrefix: {
                location: "querystring",
                locationName: "sourceArnPrefix"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Discoverers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DiscovererArn: {},
                    DiscovererId: {},
                    SourceArn: {},
                    State: {},
                    CrossAccount: {
                      type: "boolean"
                    },
                    Tags: {
                      shape: "S5",
                      locationName: "tags"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRegistries: {
          http: {
            method: "GET",
            requestUri: "/v1/registries",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RegistryNamePrefix: {
                location: "querystring",
                locationName: "registryNamePrefix"
              },
              Scope: {
                location: "querystring",
                locationName: "scope"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Registries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RegistryArn: {},
                    RegistryName: {},
                    Tags: {
                      shape: "S5",
                      locationName: "tags"
                    }
                  }
                }
              }
            }
          }
        },
        ListSchemaVersions: {
          http: {
            method: "GET",
            requestUri: "/v1/registries/name/{registryName}/schemas/name/{schemaName}/versions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaName: {
                location: "uri",
                locationName: "schemaName"
              }
            },
            required: [
              "RegistryName",
              "SchemaName"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              SchemaVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SchemaArn: {},
                    SchemaName: {},
                    SchemaVersion: {},
                    Type: {}
                  }
                }
              }
            }
          }
        },
        ListSchemas: {
          http: {
            method: "GET",
            requestUri: "/v1/registries/name/{registryName}/schemas",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaNamePrefix: {
                location: "querystring",
                locationName: "schemaNamePrefix"
              }
            },
            required: [
              "RegistryName"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Schemas: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LastModified: {
                      shape: "Sf"
                    },
                    SchemaArn: {},
                    SchemaName: {},
                    Tags: {
                      shape: "S5",
                      locationName: "tags"
                    },
                    VersionCount: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          }
        },
        PutCodeBinding: {
          http: {
            requestUri: "/v1/registries/name/{registryName}/schemas/name/{schemaName}/language/{language}",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              Language: {
                location: "uri",
                locationName: "language"
              },
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaName: {
                location: "uri",
                locationName: "schemaName"
              },
              SchemaVersion: {
                location: "querystring",
                locationName: "schemaVersion"
              }
            },
            required: [
              "RegistryName",
              "SchemaName",
              "Language"
            ]
          },
          output: {
            type: "structure",
            members: {
              CreationDate: {
                shape: "Sf"
              },
              LastModified: {
                shape: "Sf"
              },
              SchemaVersion: {},
              Status: {}
            }
          }
        },
        PutResourcePolicy: {
          http: {
            method: "PUT",
            requestUri: "/v1/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Policy: {
                jsonvalue: true
              },
              RegistryName: {
                location: "querystring",
                locationName: "registryName"
              },
              RevisionId: {}
            },
            required: [
              "Policy"
            ]
          },
          output: {
            type: "structure",
            members: {
              Policy: {
                jsonvalue: true
              },
              RevisionId: {}
            }
          }
        },
        SearchSchemas: {
          http: {
            method: "GET",
            requestUri: "/v1/registries/name/{registryName}/schemas/search",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Keywords: {
                location: "querystring",
                locationName: "keywords"
              },
              Limit: {
                location: "querystring",
                locationName: "limit",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              }
            },
            required: [
              "RegistryName",
              "Keywords"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Schemas: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RegistryName: {},
                    SchemaArn: {},
                    SchemaName: {},
                    SchemaVersions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          CreatedDate: {
                            shape: "Sf"
                          },
                          SchemaVersion: {},
                          Type: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        StartDiscoverer: {
          http: {
            requestUri: "/v1/discoverers/id/{discovererId}/start",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DiscovererId: {
                location: "uri",
                locationName: "discovererId"
              }
            },
            required: [
              "DiscovererId"
            ]
          },
          output: {
            type: "structure",
            members: {
              DiscovererId: {},
              State: {}
            }
          }
        },
        StopDiscoverer: {
          http: {
            requestUri: "/v1/discoverers/id/{discovererId}/stop",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DiscovererId: {
                location: "uri",
                locationName: "discovererId"
              }
            },
            required: [
              "DiscovererId"
            ]
          },
          output: {
            type: "structure",
            members: {
              DiscovererId: {},
              State: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            },
            required: [
              "ResourceArn",
              "Tags"
            ]
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ]
          }
        },
        UpdateDiscoverer: {
          http: {
            method: "PUT",
            requestUri: "/v1/discoverers/id/{discovererId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Description: {},
              DiscovererId: {
                location: "uri",
                locationName: "discovererId"
              },
              CrossAccount: {
                type: "boolean"
              }
            },
            required: [
              "DiscovererId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Description: {},
              DiscovererArn: {},
              DiscovererId: {},
              SourceArn: {},
              State: {},
              CrossAccount: {
                type: "boolean"
              },
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          }
        },
        UpdateRegistry: {
          http: {
            method: "PUT",
            requestUri: "/v1/registries/name/{registryName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Description: {},
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              }
            },
            required: [
              "RegistryName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Description: {},
              RegistryArn: {},
              RegistryName: {},
              Tags: {
                shape: "S5",
                locationName: "tags"
              }
            }
          }
        },
        UpdateSchema: {
          http: {
            method: "PUT",
            requestUri: "/v1/registries/name/{registryName}/schemas/name/{schemaName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClientTokenId: {
                idempotencyToken: true
              },
              Content: {},
              Description: {},
              RegistryName: {
                location: "uri",
                locationName: "registryName"
              },
              SchemaName: {
                location: "uri",
                locationName: "schemaName"
              },
              Type: {}
            },
            required: [
              "RegistryName",
              "SchemaName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Description: {},
              LastModified: {
                shape: "Sf"
              },
              SchemaArn: {},
              SchemaName: {},
              SchemaVersion: {},
              Tags: {
                shape: "S5",
                locationName: "tags"
              },
              Type: {},
              VersionCreatedDate: {
                shape: "Sf"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "map",
          key: {},
          value: {}
        },
        Sf: {
          type: "timestamp",
          timestampFormat: "iso8601"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/schemas-2019-12-02.paginators.json
var require_schemas_2019_12_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/schemas-2019-12-02.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListDiscoverers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Discoverers"
        },
        ListRegistries: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Registries"
        },
        ListSchemaVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "SchemaVersions"
        },
        ListSchemas: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Schemas"
        },
        SearchSchemas: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "Limit",
          result_key: "Schemas"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/schemas-2019-12-02.waiters2.json
var require_schemas_2019_12_02_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/schemas-2019-12-02.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        CodeBindingExists: {
          description: "Wait until code binding is generated",
          delay: 2,
          operation: "DescribeCodeBinding",
          maxAttempts: 30,
          acceptors: [
            {
              expected: "CREATE_COMPLETE",
              matcher: "path",
              state: "success",
              argument: "Status"
            },
            {
              expected: "CREATE_IN_PROGRESS",
              matcher: "path",
              state: "retry",
              argument: "Status"
            },
            {
              expected: "CREATE_FAILED",
              matcher: "path",
              state: "failure",
              argument: "Status"
            },
            {
              matcher: "error",
              expected: "NotFoundException",
              state: "failure"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/schemas.js
var require_schemas = __commonJS({
  "node_modules/aws-sdk/clients/schemas.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["schemas"] = {};
    AWS3.Schemas = Service.defineService("schemas", ["2019-12-02"]);
    Object.defineProperty(apiLoader.services["schemas"], "2019-12-02", {
      get: function get() {
        var model = require_schemas_2019_12_02_min();
        model.paginators = require_schemas_2019_12_02_paginators().pagination;
        model.waiters = require_schemas_2019_12_02_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Schemas;
  }
});

// node_modules/aws-sdk/apis/accessanalyzer-2019-11-01.min.json
var require_accessanalyzer_2019_11_01_min = __commonJS({
  "node_modules/aws-sdk/apis/accessanalyzer-2019-11-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-11-01",
        endpointPrefix: "access-analyzer",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Access Analyzer",
        serviceId: "AccessAnalyzer",
        signatureVersion: "v4",
        signingName: "access-analyzer",
        uid: "accessanalyzer-2019-11-01"
      },
      operations: {
        ApplyArchiveRule: {
          http: {
            method: "PUT",
            requestUri: "/archive-rule",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerArn",
              "ruleName"
            ],
            members: {
              analyzerArn: {},
              clientToken: {
                idempotencyToken: true
              },
              ruleName: {}
            }
          },
          idempotent: true
        },
        CancelPolicyGeneration: {
          http: {
            method: "PUT",
            requestUri: "/policy/generation/{jobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        CreateAccessPreview: {
          http: {
            method: "PUT",
            requestUri: "/access-preview",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerArn",
              "configurations"
            ],
            members: {
              analyzerArn: {},
              clientToken: {
                idempotencyToken: true
              },
              configurations: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          idempotent: true
        },
        CreateAnalyzer: {
          http: {
            method: "PUT",
            requestUri: "/analyzer",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerName",
              "type"
            ],
            members: {
              analyzerName: {},
              archiveRules: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "filter",
                    "ruleName"
                  ],
                  members: {
                    filter: {
                      shape: "S1l"
                    },
                    ruleName: {}
                  }
                }
              },
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "S1o"
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {}
            }
          },
          idempotent: true
        },
        CreateArchiveRule: {
          http: {
            method: "PUT",
            requestUri: "/analyzer/{analyzerName}/archive-rule",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerName",
              "filter",
              "ruleName"
            ],
            members: {
              analyzerName: {
                location: "uri",
                locationName: "analyzerName"
              },
              clientToken: {
                idempotencyToken: true
              },
              filter: {
                shape: "S1l"
              },
              ruleName: {}
            }
          },
          idempotent: true
        },
        DeleteAnalyzer: {
          http: {
            method: "DELETE",
            requestUri: "/analyzer/{analyzerName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerName"
            ],
            members: {
              analyzerName: {
                location: "uri",
                locationName: "analyzerName"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          idempotent: true
        },
        DeleteArchiveRule: {
          http: {
            method: "DELETE",
            requestUri: "/analyzer/{analyzerName}/archive-rule/{ruleName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerName",
              "ruleName"
            ],
            members: {
              analyzerName: {
                location: "uri",
                locationName: "analyzerName"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              },
              ruleName: {
                location: "uri",
                locationName: "ruleName"
              }
            }
          },
          idempotent: true
        },
        GetAccessPreview: {
          http: {
            method: "GET",
            requestUri: "/access-preview/{accessPreviewId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accessPreviewId",
              "analyzerArn"
            ],
            members: {
              accessPreviewId: {
                location: "uri",
                locationName: "accessPreviewId"
              },
              analyzerArn: {
                location: "querystring",
                locationName: "analyzerArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "accessPreview"
            ],
            members: {
              accessPreview: {
                type: "structure",
                required: [
                  "analyzerArn",
                  "configurations",
                  "createdAt",
                  "id",
                  "status"
                ],
                members: {
                  analyzerArn: {},
                  configurations: {
                    shape: "S9"
                  },
                  createdAt: {
                    shape: "S1x"
                  },
                  id: {},
                  status: {},
                  statusReason: {
                    shape: "S1z"
                  }
                }
              }
            }
          }
        },
        GetAnalyzedResource: {
          http: {
            method: "GET",
            requestUri: "/analyzed-resource",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerArn",
              "resourceArn"
            ],
            members: {
              analyzerArn: {
                location: "querystring",
                locationName: "analyzerArn"
              },
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resource: {
                type: "structure",
                required: [
                  "analyzedAt",
                  "createdAt",
                  "isPublic",
                  "resourceArn",
                  "resourceOwnerAccount",
                  "resourceType",
                  "updatedAt"
                ],
                members: {
                  actions: {
                    shape: "S25"
                  },
                  analyzedAt: {
                    shape: "S1x"
                  },
                  createdAt: {
                    shape: "S1x"
                  },
                  error: {},
                  isPublic: {
                    type: "boolean"
                  },
                  resourceArn: {},
                  resourceOwnerAccount: {},
                  resourceType: {},
                  sharedVia: {
                    type: "list",
                    member: {}
                  },
                  status: {},
                  updatedAt: {
                    shape: "S1x"
                  }
                }
              }
            }
          }
        },
        GetAnalyzer: {
          http: {
            method: "GET",
            requestUri: "/analyzer/{analyzerName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerName"
            ],
            members: {
              analyzerName: {
                location: "uri",
                locationName: "analyzerName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "analyzer"
            ],
            members: {
              analyzer: {
                shape: "S2b"
              }
            }
          }
        },
        GetArchiveRule: {
          http: {
            method: "GET",
            requestUri: "/analyzer/{analyzerName}/archive-rule/{ruleName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerName",
              "ruleName"
            ],
            members: {
              analyzerName: {
                location: "uri",
                locationName: "analyzerName"
              },
              ruleName: {
                location: "uri",
                locationName: "ruleName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "archiveRule"
            ],
            members: {
              archiveRule: {
                shape: "S2h"
              }
            }
          }
        },
        GetFinding: {
          http: {
            method: "GET",
            requestUri: "/finding/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerArn",
              "id"
            ],
            members: {
              analyzerArn: {
                location: "querystring",
                locationName: "analyzerArn"
              },
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              finding: {
                type: "structure",
                required: [
                  "analyzedAt",
                  "condition",
                  "createdAt",
                  "id",
                  "resourceOwnerAccount",
                  "resourceType",
                  "status",
                  "updatedAt"
                ],
                members: {
                  action: {
                    shape: "S25"
                  },
                  analyzedAt: {
                    shape: "S1x"
                  },
                  condition: {
                    shape: "S2m"
                  },
                  createdAt: {
                    shape: "S1x"
                  },
                  error: {},
                  id: {},
                  isPublic: {
                    type: "boolean"
                  },
                  principal: {
                    shape: "S2n"
                  },
                  resource: {},
                  resourceOwnerAccount: {},
                  resourceType: {},
                  sources: {
                    shape: "S2o"
                  },
                  status: {},
                  updatedAt: {
                    shape: "S1x"
                  }
                }
              }
            }
          }
        },
        GetGeneratedPolicy: {
          http: {
            method: "GET",
            requestUri: "/policy/generation/{jobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              includeResourcePlaceholders: {
                location: "querystring",
                locationName: "includeResourcePlaceholders",
                type: "boolean"
              },
              includeServiceLevelTemplate: {
                location: "querystring",
                locationName: "includeServiceLevelTemplate",
                type: "boolean"
              },
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "generatedPolicyResult",
              "jobDetails"
            ],
            members: {
              generatedPolicyResult: {
                type: "structure",
                required: [
                  "properties"
                ],
                members: {
                  generatedPolicies: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "policy"
                      ],
                      members: {
                        policy: {}
                      }
                    }
                  },
                  properties: {
                    type: "structure",
                    required: [
                      "principalArn"
                    ],
                    members: {
                      cloudTrailProperties: {
                        type: "structure",
                        required: [
                          "endTime",
                          "startTime",
                          "trailProperties"
                        ],
                        members: {
                          endTime: {
                            shape: "S1x"
                          },
                          startTime: {
                            shape: "S1x"
                          },
                          trailProperties: {
                            type: "list",
                            member: {
                              type: "structure",
                              required: [
                                "cloudTrailArn"
                              ],
                              members: {
                                allRegions: {
                                  type: "boolean"
                                },
                                cloudTrailArn: {},
                                regions: {
                                  shape: "S32"
                                }
                              }
                            }
                          }
                        }
                      },
                      isComplete: {
                        type: "boolean"
                      },
                      principalArn: {}
                    }
                  }
                }
              },
              jobDetails: {
                type: "structure",
                required: [
                  "jobId",
                  "startedOn",
                  "status"
                ],
                members: {
                  completedOn: {
                    shape: "S1x"
                  },
                  jobError: {
                    type: "structure",
                    required: [
                      "code",
                      "message"
                    ],
                    members: {
                      code: {},
                      message: {}
                    }
                  },
                  jobId: {},
                  startedOn: {
                    shape: "S1x"
                  },
                  status: {}
                }
              }
            }
          }
        },
        ListAccessPreviewFindings: {
          http: {
            requestUri: "/access-preview/{accessPreviewId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accessPreviewId",
              "analyzerArn"
            ],
            members: {
              accessPreviewId: {
                location: "uri",
                locationName: "accessPreviewId"
              },
              analyzerArn: {},
              filter: {
                shape: "S1l"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "findings"
            ],
            members: {
              findings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "changeType",
                    "createdAt",
                    "id",
                    "resourceOwnerAccount",
                    "resourceType",
                    "status"
                  ],
                  members: {
                    action: {
                      shape: "S25"
                    },
                    changeType: {},
                    condition: {
                      shape: "S2m"
                    },
                    createdAt: {
                      shape: "S1x"
                    },
                    error: {},
                    existingFindingId: {},
                    existingFindingStatus: {},
                    id: {},
                    isPublic: {
                      type: "boolean"
                    },
                    principal: {
                      shape: "S2n"
                    },
                    resource: {},
                    resourceOwnerAccount: {},
                    resourceType: {},
                    sources: {
                      shape: "S2o"
                    },
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAccessPreviews: {
          http: {
            method: "GET",
            requestUri: "/access-preview",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerArn"
            ],
            members: {
              analyzerArn: {
                location: "querystring",
                locationName: "analyzerArn"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "accessPreviews"
            ],
            members: {
              accessPreviews: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "analyzerArn",
                    "createdAt",
                    "id",
                    "status"
                  ],
                  members: {
                    analyzerArn: {},
                    createdAt: {
                      shape: "S1x"
                    },
                    id: {},
                    status: {},
                    statusReason: {
                      shape: "S1z"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAnalyzedResources: {
          http: {
            requestUri: "/analyzed-resource",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerArn"
            ],
            members: {
              analyzerArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              resourceType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "analyzedResources"
            ],
            members: {
              analyzedResources: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "resourceArn",
                    "resourceOwnerAccount",
                    "resourceType"
                  ],
                  members: {
                    resourceArn: {},
                    resourceOwnerAccount: {},
                    resourceType: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAnalyzers: {
          http: {
            method: "GET",
            requestUri: "/analyzer",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              type: {
                location: "querystring",
                locationName: "type"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "analyzers"
            ],
            members: {
              analyzers: {
                type: "list",
                member: {
                  shape: "S2b"
                }
              },
              nextToken: {}
            }
          }
        },
        ListArchiveRules: {
          http: {
            method: "GET",
            requestUri: "/analyzer/{analyzerName}/archive-rule",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerName"
            ],
            members: {
              analyzerName: {
                location: "uri",
                locationName: "analyzerName"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "archiveRules"
            ],
            members: {
              archiveRules: {
                type: "list",
                member: {
                  shape: "S2h"
                }
              },
              nextToken: {}
            }
          }
        },
        ListFindings: {
          http: {
            requestUri: "/finding",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerArn"
            ],
            members: {
              analyzerArn: {},
              filter: {
                shape: "S1l"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              sort: {
                type: "structure",
                members: {
                  attributeName: {},
                  orderBy: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "findings"
            ],
            members: {
              findings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "analyzedAt",
                    "condition",
                    "createdAt",
                    "id",
                    "resourceOwnerAccount",
                    "resourceType",
                    "status",
                    "updatedAt"
                  ],
                  members: {
                    action: {
                      shape: "S25"
                    },
                    analyzedAt: {
                      shape: "S1x"
                    },
                    condition: {
                      shape: "S2m"
                    },
                    createdAt: {
                      shape: "S1x"
                    },
                    error: {},
                    id: {},
                    isPublic: {
                      type: "boolean"
                    },
                    principal: {
                      shape: "S2n"
                    },
                    resource: {},
                    resourceOwnerAccount: {},
                    resourceType: {},
                    sources: {
                      shape: "S2o"
                    },
                    status: {},
                    updatedAt: {
                      shape: "S1x"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListPolicyGenerations: {
          http: {
            method: "GET",
            requestUri: "/policy/generation",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              principalArn: {
                location: "querystring",
                locationName: "principalArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "policyGenerations"
            ],
            members: {
              nextToken: {},
              policyGenerations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "jobId",
                    "principalArn",
                    "startedOn",
                    "status"
                  ],
                  members: {
                    completedOn: {
                      shape: "S1x"
                    },
                    jobId: {},
                    principalArn: {},
                    startedOn: {
                      shape: "S1x"
                    },
                    status: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S1o"
              }
            }
          }
        },
        StartPolicyGeneration: {
          http: {
            method: "PUT",
            requestUri: "/policy/generation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "policyGenerationDetails"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              cloudTrailDetails: {
                type: "structure",
                required: [
                  "accessRole",
                  "startTime",
                  "trails"
                ],
                members: {
                  accessRole: {},
                  endTime: {
                    shape: "S1x"
                  },
                  startTime: {
                    shape: "S1x"
                  },
                  trails: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "cloudTrailArn"
                      ],
                      members: {
                        allRegions: {
                          type: "boolean"
                        },
                        cloudTrailArn: {},
                        regions: {
                          shape: "S32"
                        }
                      }
                    }
                  }
                }
              },
              policyGenerationDetails: {
                type: "structure",
                required: [
                  "principalArn"
                ],
                members: {
                  principalArn: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {}
            }
          },
          idempotent: true
        },
        StartResourceScan: {
          http: {
            requestUri: "/resource/scan",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerArn",
              "resourceArn"
            ],
            members: {
              analyzerArn: {},
              resourceArn: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateArchiveRule: {
          http: {
            method: "PUT",
            requestUri: "/analyzer/{analyzerName}/archive-rule/{ruleName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerName",
              "filter",
              "ruleName"
            ],
            members: {
              analyzerName: {
                location: "uri",
                locationName: "analyzerName"
              },
              clientToken: {
                idempotencyToken: true
              },
              filter: {
                shape: "S1l"
              },
              ruleName: {
                location: "uri",
                locationName: "ruleName"
              }
            }
          },
          idempotent: true
        },
        UpdateFindings: {
          http: {
            method: "PUT",
            requestUri: "/finding",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "analyzerArn",
              "status"
            ],
            members: {
              analyzerArn: {},
              clientToken: {
                idempotencyToken: true
              },
              ids: {
                type: "list",
                member: {}
              },
              resourceArn: {},
              status: {}
            }
          },
          idempotent: true
        },
        ValidatePolicy: {
          http: {
            requestUri: "/policy/validation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "policyDocument",
              "policyType"
            ],
            members: {
              locale: {},
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              policyDocument: {},
              policyType: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "findings"
            ],
            members: {
              findings: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "findingDetails",
                    "findingType",
                    "issueCode",
                    "learnMoreLink",
                    "locations"
                  ],
                  members: {
                    findingDetails: {},
                    findingType: {},
                    issueCode: {},
                    learnMoreLink: {},
                    locations: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "path",
                          "span"
                        ],
                        members: {
                          path: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                index: {
                                  type: "integer"
                                },
                                key: {},
                                substring: {
                                  type: "structure",
                                  required: [
                                    "length",
                                    "start"
                                  ],
                                  members: {
                                    length: {
                                      type: "integer"
                                    },
                                    start: {
                                      type: "integer"
                                    }
                                  }
                                },
                                value: {}
                              },
                              union: true
                            }
                          },
                          span: {
                            type: "structure",
                            required: [
                              "end",
                              "start"
                            ],
                            members: {
                              end: {
                                shape: "S54"
                              },
                              start: {
                                shape: "S54"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        }
      },
      shapes: {
        S9: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              iamRole: {
                type: "structure",
                members: {
                  trustPolicy: {}
                }
              },
              kmsKey: {
                type: "structure",
                members: {
                  grants: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "granteePrincipal",
                        "issuingAccount",
                        "operations"
                      ],
                      members: {
                        constraints: {
                          type: "structure",
                          members: {
                            encryptionContextEquals: {
                              shape: "Si"
                            },
                            encryptionContextSubset: {
                              shape: "Si"
                            }
                          }
                        },
                        granteePrincipal: {},
                        issuingAccount: {},
                        operations: {
                          type: "list",
                          member: {}
                        },
                        retiringPrincipal: {}
                      }
                    }
                  },
                  keyPolicies: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              },
              s3Bucket: {
                type: "structure",
                members: {
                  accessPoints: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        accessPointPolicy: {},
                        networkOrigin: {
                          type: "structure",
                          members: {
                            internetConfiguration: {
                              type: "structure",
                              members: {}
                            },
                            vpcConfiguration: {
                              type: "structure",
                              required: [
                                "vpcId"
                              ],
                              members: {
                                vpcId: {}
                              }
                            }
                          },
                          union: true
                        },
                        publicAccessBlock: {
                          shape: "S12"
                        }
                      }
                    }
                  },
                  bucketAclGrants: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "grantee",
                        "permission"
                      ],
                      members: {
                        grantee: {
                          type: "structure",
                          members: {
                            id: {},
                            uri: {}
                          },
                          union: true
                        },
                        permission: {}
                      }
                    }
                  },
                  bucketPolicy: {},
                  bucketPublicAccessBlock: {
                    shape: "S12"
                  }
                }
              },
              secretsManagerSecret: {
                type: "structure",
                members: {
                  kmsKeyId: {},
                  secretPolicy: {}
                }
              },
              sqsQueue: {
                type: "structure",
                members: {
                  queuePolicy: {}
                }
              }
            },
            union: true
          }
        },
        Si: {
          type: "map",
          key: {},
          value: {}
        },
        S12: {
          type: "structure",
          required: [
            "ignorePublicAcls",
            "restrictPublicBuckets"
          ],
          members: {
            ignorePublicAcls: {
              type: "boolean"
            },
            restrictPublicBuckets: {
              type: "boolean"
            }
          }
        },
        S1l: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              contains: {
                shape: "S1n"
              },
              eq: {
                shape: "S1n"
              },
              exists: {
                type: "boolean"
              },
              neq: {
                shape: "S1n"
              }
            }
          }
        },
        S1n: {
          type: "list",
          member: {}
        },
        S1o: {
          type: "map",
          key: {},
          value: {}
        },
        S1x: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S1z: {
          type: "structure",
          required: [
            "code"
          ],
          members: {
            code: {}
          }
        },
        S25: {
          type: "list",
          member: {}
        },
        S2b: {
          type: "structure",
          required: [
            "arn",
            "createdAt",
            "name",
            "status",
            "type"
          ],
          members: {
            arn: {},
            createdAt: {
              shape: "S1x"
            },
            lastResourceAnalyzed: {},
            lastResourceAnalyzedAt: {
              shape: "S1x"
            },
            name: {},
            status: {},
            statusReason: {
              type: "structure",
              required: [
                "code"
              ],
              members: {
                code: {}
              }
            },
            tags: {
              shape: "S1o"
            },
            type: {}
          }
        },
        S2h: {
          type: "structure",
          required: [
            "createdAt",
            "filter",
            "ruleName",
            "updatedAt"
          ],
          members: {
            createdAt: {
              shape: "S1x"
            },
            filter: {
              shape: "S1l"
            },
            ruleName: {},
            updatedAt: {
              shape: "S1x"
            }
          }
        },
        S2m: {
          type: "map",
          key: {},
          value: {}
        },
        S2n: {
          type: "map",
          key: {},
          value: {}
        },
        S2o: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "type"
            ],
            members: {
              detail: {
                type: "structure",
                members: {
                  accessPointArn: {}
                }
              },
              type: {}
            }
          }
        },
        S32: {
          type: "list",
          member: {}
        },
        S54: {
          type: "structure",
          required: [
            "column",
            "line",
            "offset"
          ],
          members: {
            column: {
              type: "integer"
            },
            line: {
              type: "integer"
            },
            offset: {
              type: "integer"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/accessanalyzer-2019-11-01.paginators.json
var require_accessanalyzer_2019_11_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/accessanalyzer-2019-11-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAccessPreviewFindings: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "findings"
        },
        ListAccessPreviews: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "accessPreviews"
        },
        ListAnalyzedResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "analyzedResources"
        },
        ListAnalyzers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "analyzers"
        },
        ListArchiveRules: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "archiveRules"
        },
        ListFindings: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "findings"
        },
        ListPolicyGenerations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "policyGenerations"
        },
        ValidatePolicy: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "findings"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/accessanalyzer.js
var require_accessanalyzer = __commonJS({
  "node_modules/aws-sdk/clients/accessanalyzer.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["accessanalyzer"] = {};
    AWS3.AccessAnalyzer = Service.defineService("accessanalyzer", ["2019-11-01"]);
    Object.defineProperty(apiLoader.services["accessanalyzer"], "2019-11-01", {
      get: function get() {
        var model = require_accessanalyzer_2019_11_01_min();
        model.paginators = require_accessanalyzer_2019_11_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.AccessAnalyzer;
  }
});

// node_modules/aws-sdk/apis/codeguru-reviewer-2019-09-19.min.json
var require_codeguru_reviewer_2019_09_19_min = __commonJS({
  "node_modules/aws-sdk/apis/codeguru-reviewer-2019-09-19.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-09-19",
        endpointPrefix: "codeguru-reviewer",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "CodeGuruReviewer",
        serviceFullName: "Amazon CodeGuru Reviewer",
        serviceId: "CodeGuru Reviewer",
        signatureVersion: "v4",
        signingName: "codeguru-reviewer",
        uid: "codeguru-reviewer-2019-09-19"
      },
      operations: {
        AssociateRepository: {
          http: {
            requestUri: "/associations"
          },
          input: {
            type: "structure",
            required: [
              "Repository"
            ],
            members: {
              Repository: {
                type: "structure",
                members: {
                  CodeCommit: {
                    type: "structure",
                    required: [
                      "Name"
                    ],
                    members: {
                      Name: {}
                    }
                  },
                  Bitbucket: {
                    shape: "S5"
                  },
                  GitHubEnterpriseServer: {
                    shape: "S5"
                  },
                  S3Bucket: {
                    type: "structure",
                    required: [
                      "Name",
                      "BucketName"
                    ],
                    members: {
                      Name: {},
                      BucketName: {}
                    }
                  }
                }
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sb"
              },
              KMSKeyDetails: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RepositoryAssociation: {
                shape: "Si"
              },
              Tags: {
                shape: "Sb"
              }
            }
          }
        },
        CreateCodeReview: {
          http: {
            requestUri: "/codereviews"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "RepositoryAssociationArn",
              "Type"
            ],
            members: {
              Name: {},
              RepositoryAssociationArn: {},
              Type: {
                type: "structure",
                required: [
                  "RepositoryAnalysis"
                ],
                members: {
                  RepositoryAnalysis: {
                    type: "structure",
                    members: {
                      RepositoryHead: {
                        shape: "Sy"
                      },
                      SourceCodeType: {
                        shape: "S10"
                      }
                    }
                  },
                  AnalysisTypes: {
                    shape: "S1c"
                  }
                }
              },
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CodeReview: {
                shape: "S1f"
              }
            }
          }
        },
        DescribeCodeReview: {
          http: {
            method: "GET",
            requestUri: "/codereviews/{CodeReviewArn}"
          },
          input: {
            type: "structure",
            required: [
              "CodeReviewArn"
            ],
            members: {
              CodeReviewArn: {
                location: "uri",
                locationName: "CodeReviewArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CodeReview: {
                shape: "S1f"
              }
            }
          }
        },
        DescribeRecommendationFeedback: {
          http: {
            method: "GET",
            requestUri: "/feedback/{CodeReviewArn}"
          },
          input: {
            type: "structure",
            required: [
              "CodeReviewArn",
              "RecommendationId"
            ],
            members: {
              CodeReviewArn: {
                location: "uri",
                locationName: "CodeReviewArn"
              },
              RecommendationId: {
                location: "querystring",
                locationName: "RecommendationId"
              },
              UserId: {
                location: "querystring",
                locationName: "UserId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecommendationFeedback: {
                type: "structure",
                members: {
                  CodeReviewArn: {},
                  RecommendationId: {},
                  Reactions: {
                    shape: "S1t"
                  },
                  UserId: {},
                  CreatedTimeStamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimeStamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeRepositoryAssociation: {
          http: {
            method: "GET",
            requestUri: "/associations/{AssociationArn}"
          },
          input: {
            type: "structure",
            required: [
              "AssociationArn"
            ],
            members: {
              AssociationArn: {
                location: "uri",
                locationName: "AssociationArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RepositoryAssociation: {
                shape: "Si"
              },
              Tags: {
                shape: "Sb"
              }
            }
          }
        },
        DisassociateRepository: {
          http: {
            method: "DELETE",
            requestUri: "/associations/{AssociationArn}"
          },
          input: {
            type: "structure",
            required: [
              "AssociationArn"
            ],
            members: {
              AssociationArn: {
                location: "uri",
                locationName: "AssociationArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RepositoryAssociation: {
                shape: "Si"
              },
              Tags: {
                shape: "Sb"
              }
            }
          }
        },
        ListCodeReviews: {
          http: {
            method: "GET",
            requestUri: "/codereviews"
          },
          input: {
            type: "structure",
            required: [
              "Type"
            ],
            members: {
              ProviderTypes: {
                shape: "S20",
                location: "querystring",
                locationName: "ProviderTypes"
              },
              States: {
                location: "querystring",
                locationName: "States",
                type: "list",
                member: {}
              },
              RepositoryNames: {
                location: "querystring",
                locationName: "RepositoryNames",
                type: "list",
                member: {}
              },
              Type: {
                location: "querystring",
                locationName: "Type"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CodeReviewSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    CodeReviewArn: {},
                    RepositoryName: {},
                    Owner: {},
                    ProviderType: {},
                    State: {},
                    CreatedTimeStamp: {
                      type: "timestamp"
                    },
                    LastUpdatedTimeStamp: {
                      type: "timestamp"
                    },
                    Type: {},
                    PullRequestId: {},
                    MetricsSummary: {
                      type: "structure",
                      members: {
                        MeteredLinesOfCodeCount: {
                          type: "long"
                        },
                        FindingsCount: {
                          type: "long"
                        }
                      }
                    },
                    SourceCodeType: {
                      shape: "S10"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRecommendationFeedback: {
          http: {
            method: "GET",
            requestUri: "/feedback/{CodeReviewArn}/RecommendationFeedback"
          },
          input: {
            type: "structure",
            required: [
              "CodeReviewArn"
            ],
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              CodeReviewArn: {
                location: "uri",
                locationName: "CodeReviewArn"
              },
              UserIds: {
                location: "querystring",
                locationName: "UserIds",
                type: "list",
                member: {}
              },
              RecommendationIds: {
                location: "querystring",
                locationName: "RecommendationIds",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecommendationFeedbackSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RecommendationId: {},
                    Reactions: {
                      shape: "S1t"
                    },
                    UserId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRecommendations: {
          http: {
            method: "GET",
            requestUri: "/codereviews/{CodeReviewArn}/Recommendations"
          },
          input: {
            type: "structure",
            required: [
              "CodeReviewArn"
            ],
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              CodeReviewArn: {
                location: "uri",
                locationName: "CodeReviewArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RecommendationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FilePath: {},
                    RecommendationId: {},
                    StartLine: {
                      type: "integer"
                    },
                    EndLine: {
                      type: "integer"
                    },
                    Description: {},
                    RecommendationCategory: {},
                    RuleMetadata: {
                      type: "structure",
                      members: {
                        RuleId: {},
                        RuleName: {},
                        ShortDescription: {},
                        LongDescription: {},
                        RuleTags: {
                          type: "list",
                          member: {}
                        }
                      }
                    },
                    Severity: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRepositoryAssociations: {
          http: {
            method: "GET",
            requestUri: "/associations"
          },
          input: {
            type: "structure",
            members: {
              ProviderTypes: {
                shape: "S20",
                location: "querystring",
                locationName: "ProviderType"
              },
              States: {
                location: "querystring",
                locationName: "State",
                type: "list",
                member: {}
              },
              Names: {
                location: "querystring",
                locationName: "Name",
                type: "list",
                member: {}
              },
              Owners: {
                location: "querystring",
                locationName: "Owner",
                type: "list",
                member: {}
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RepositoryAssociationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AssociationArn: {},
                    ConnectionArn: {},
                    LastUpdatedTimeStamp: {
                      type: "timestamp"
                    },
                    AssociationId: {},
                    Name: {},
                    Owner: {},
                    ProviderType: {},
                    State: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sb"
              }
            }
          }
        },
        PutRecommendationFeedback: {
          http: {
            method: "PUT",
            requestUri: "/feedback"
          },
          input: {
            type: "structure",
            required: [
              "CodeReviewArn",
              "RecommendationId",
              "Reactions"
            ],
            members: {
              CodeReviewArn: {},
              RecommendationId: {},
              Reactions: {
                shape: "S1t"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "Tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "TagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          required: [
            "Name",
            "ConnectionArn",
            "Owner"
          ],
          members: {
            Name: {},
            ConnectionArn: {},
            Owner: {}
          }
        },
        Sb: {
          type: "map",
          key: {},
          value: {}
        },
        Se: {
          type: "structure",
          members: {
            KMSKeyId: {},
            EncryptionOption: {}
          }
        },
        Si: {
          type: "structure",
          members: {
            AssociationId: {},
            AssociationArn: {},
            ConnectionArn: {},
            Name: {},
            Owner: {},
            ProviderType: {},
            State: {},
            StateReason: {},
            LastUpdatedTimeStamp: {
              type: "timestamp"
            },
            CreatedTimeStamp: {
              type: "timestamp"
            },
            KMSKeyDetails: {
              shape: "Se"
            },
            S3RepositoryDetails: {
              shape: "Sp"
            }
          }
        },
        Sp: {
          type: "structure",
          members: {
            BucketName: {},
            CodeArtifacts: {
              type: "structure",
              required: [
                "SourceCodeArtifactsObjectKey"
              ],
              members: {
                SourceCodeArtifactsObjectKey: {},
                BuildArtifactsObjectKey: {}
              }
            }
          }
        },
        Sy: {
          type: "structure",
          required: [
            "BranchName"
          ],
          members: {
            BranchName: {}
          }
        },
        S10: {
          type: "structure",
          members: {
            CommitDiff: {
              type: "structure",
              members: {
                SourceCommit: {},
                DestinationCommit: {},
                MergeBaseCommit: {}
              }
            },
            RepositoryHead: {
              shape: "Sy"
            },
            BranchDiff: {
              type: "structure",
              required: [
                "SourceBranchName",
                "DestinationBranchName"
              ],
              members: {
                SourceBranchName: {},
                DestinationBranchName: {}
              }
            },
            S3BucketRepository: {
              type: "structure",
              required: [
                "Name"
              ],
              members: {
                Name: {},
                Details: {
                  shape: "Sp"
                }
              }
            },
            RequestMetadata: {
              type: "structure",
              members: {
                RequestId: {},
                Requester: {},
                EventInfo: {
                  type: "structure",
                  members: {
                    Name: {},
                    State: {}
                  }
                },
                VendorName: {}
              }
            }
          }
        },
        S1c: {
          type: "list",
          member: {}
        },
        S1f: {
          type: "structure",
          members: {
            Name: {},
            CodeReviewArn: {},
            RepositoryName: {},
            Owner: {},
            ProviderType: {},
            State: {},
            StateReason: {},
            CreatedTimeStamp: {
              type: "timestamp"
            },
            LastUpdatedTimeStamp: {
              type: "timestamp"
            },
            Type: {},
            PullRequestId: {},
            SourceCodeType: {
              shape: "S10"
            },
            AssociationArn: {},
            Metrics: {
              type: "structure",
              members: {
                MeteredLinesOfCodeCount: {
                  type: "long"
                },
                FindingsCount: {
                  type: "long"
                }
              }
            },
            AnalysisTypes: {
              shape: "S1c"
            }
          }
        },
        S1t: {
          type: "list",
          member: {}
        },
        S20: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codeguru-reviewer-2019-09-19.paginators.json
var require_codeguru_reviewer_2019_09_19_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codeguru-reviewer-2019-09-19.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListCodeReviews: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListRecommendationFeedback: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListRecommendations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListRepositoryAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RepositoryAssociationSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codeguru-reviewer-2019-09-19.waiters2.json
var require_codeguru_reviewer_2019_09_19_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/codeguru-reviewer-2019-09-19.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        RepositoryAssociationSucceeded: {
          description: "Wait until a repository association is complete.",
          operation: "DescribeRepositoryAssociation",
          delay: 10,
          maxAttempts: 20,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "RepositoryAssociation.State",
              expected: "Associated"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "RepositoryAssociation.State",
              expected: "Associating"
            }
          ]
        },
        CodeReviewCompleted: {
          description: "Wait until a code review is complete.",
          operation: "DescribeCodeReview",
          delay: 10,
          maxAttempts: 60,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "CodeReview.State",
              expected: "Completed"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "CodeReview.State",
              expected: "Pending"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/codegurureviewer.js
var require_codegurureviewer = __commonJS({
  "node_modules/aws-sdk/clients/codegurureviewer.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["codegurureviewer"] = {};
    AWS3.CodeGuruReviewer = Service.defineService("codegurureviewer", ["2019-09-19"]);
    Object.defineProperty(apiLoader.services["codegurureviewer"], "2019-09-19", {
      get: function get() {
        var model = require_codeguru_reviewer_2019_09_19_min();
        model.paginators = require_codeguru_reviewer_2019_09_19_paginators().pagination;
        model.waiters = require_codeguru_reviewer_2019_09_19_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CodeGuruReviewer;
  }
});

// node_modules/aws-sdk/apis/codeguruprofiler-2019-07-18.min.json
var require_codeguruprofiler_2019_07_18_min = __commonJS({
  "node_modules/aws-sdk/apis/codeguruprofiler-2019-07-18.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-07-18",
        endpointPrefix: "codeguru-profiler",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon CodeGuru Profiler",
        serviceId: "CodeGuruProfiler",
        signatureVersion: "v4",
        signingName: "codeguru-profiler",
        uid: "codeguruprofiler-2019-07-18"
      },
      operations: {
        AddNotificationChannels: {
          http: {
            requestUri: "/profilingGroups/{profilingGroupName}/notificationConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channels",
              "profilingGroupName"
            ],
            members: {
              channels: {
                shape: "S2"
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              notificationConfiguration: {
                shape: "Sa"
              }
            }
          }
        },
        BatchGetFrameMetricData: {
          http: {
            requestUri: "/profilingGroups/{profilingGroupName}/frames/-/metrics",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "profilingGroupName"
            ],
            members: {
              endTime: {
                shape: "Sc",
                location: "querystring",
                locationName: "endTime"
              },
              frameMetrics: {
                type: "list",
                member: {
                  shape: "Se"
                }
              },
              period: {
                location: "querystring",
                locationName: "period"
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              },
              startTime: {
                shape: "Sc",
                location: "querystring",
                locationName: "startTime"
              },
              targetResolution: {
                location: "querystring",
                locationName: "targetResolution"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "endTime",
              "endTimes",
              "frameMetricData",
              "resolution",
              "startTime",
              "unprocessedEndTimes"
            ],
            members: {
              endTime: {
                shape: "Sc"
              },
              endTimes: {
                shape: "Sl"
              },
              frameMetricData: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "frameMetric",
                    "values"
                  ],
                  members: {
                    frameMetric: {
                      shape: "Se"
                    },
                    values: {
                      type: "list",
                      member: {
                        type: "double"
                      }
                    }
                  }
                }
              },
              resolution: {},
              startTime: {
                shape: "Sc"
              },
              unprocessedEndTimes: {
                type: "map",
                key: {},
                value: {
                  shape: "Sl"
                }
              }
            }
          }
        },
        ConfigureAgent: {
          http: {
            requestUri: "/profilingGroups/{profilingGroupName}/configureAgent",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "profilingGroupName"
            ],
            members: {
              fleetInstanceId: {},
              metadata: {
                type: "map",
                key: {},
                value: {}
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "configuration"
            ],
            members: {
              configuration: {
                type: "structure",
                required: [
                  "periodInSeconds",
                  "shouldProfile"
                ],
                members: {
                  agentParameters: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  periodInSeconds: {
                    type: "integer"
                  },
                  shouldProfile: {
                    type: "boolean"
                  }
                }
              }
            },
            payload: "configuration"
          }
        },
        CreateProfilingGroup: {
          http: {
            requestUri: "/profilingGroups",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "clientToken",
              "profilingGroupName"
            ],
            members: {
              agentOrchestrationConfig: {
                shape: "S13"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              },
              computePlatform: {},
              profilingGroupName: {},
              tags: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "profilingGroup"
            ],
            members: {
              profilingGroup: {
                shape: "S18"
              }
            },
            payload: "profilingGroup"
          },
          idempotent: true
        },
        DeleteProfilingGroup: {
          http: {
            method: "DELETE",
            requestUri: "/profilingGroups/{profilingGroupName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "profilingGroupName"
            ],
            members: {
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DescribeProfilingGroup: {
          http: {
            method: "GET",
            requestUri: "/profilingGroups/{profilingGroupName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "profilingGroupName"
            ],
            members: {
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "profilingGroup"
            ],
            members: {
              profilingGroup: {
                shape: "S18"
              }
            },
            payload: "profilingGroup"
          }
        },
        GetFindingsReportAccountSummary: {
          http: {
            method: "GET",
            requestUri: "/internal/findingsReports",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              dailyReportsOnly: {
                location: "querystring",
                locationName: "dailyReportsOnly",
                type: "boolean"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "reportSummaries"
            ],
            members: {
              nextToken: {},
              reportSummaries: {
                shape: "S1k"
              }
            }
          }
        },
        GetNotificationConfiguration: {
          http: {
            method: "GET",
            requestUri: "/profilingGroups/{profilingGroupName}/notificationConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "profilingGroupName"
            ],
            members: {
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "notificationConfiguration"
            ],
            members: {
              notificationConfiguration: {
                shape: "Sa"
              }
            }
          }
        },
        GetPolicy: {
          http: {
            method: "GET",
            requestUri: "/profilingGroups/{profilingGroupName}/policy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "profilingGroupName"
            ],
            members: {
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "policy",
              "revisionId"
            ],
            members: {
              policy: {},
              revisionId: {}
            }
          }
        },
        GetProfile: {
          http: {
            method: "GET",
            requestUri: "/profilingGroups/{profilingGroupName}/profile",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "profilingGroupName"
            ],
            members: {
              accept: {
                location: "header",
                locationName: "Accept"
              },
              endTime: {
                shape: "Sc",
                location: "querystring",
                locationName: "endTime"
              },
              maxDepth: {
                location: "querystring",
                locationName: "maxDepth",
                type: "integer"
              },
              period: {
                location: "querystring",
                locationName: "period"
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              },
              startTime: {
                shape: "Sc",
                location: "querystring",
                locationName: "startTime"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "contentType",
              "profile"
            ],
            members: {
              contentEncoding: {
                location: "header",
                locationName: "Content-Encoding"
              },
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              profile: {
                type: "blob"
              }
            },
            payload: "profile"
          }
        },
        GetRecommendations: {
          http: {
            method: "GET",
            requestUri: "/internal/profilingGroups/{profilingGroupName}/recommendations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "endTime",
              "profilingGroupName",
              "startTime"
            ],
            members: {
              endTime: {
                shape: "Sc",
                location: "querystring",
                locationName: "endTime"
              },
              locale: {
                location: "querystring",
                locationName: "locale"
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              },
              startTime: {
                shape: "Sc",
                location: "querystring",
                locationName: "startTime"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "anomalies",
              "profileEndTime",
              "profileStartTime",
              "profilingGroupName",
              "recommendations"
            ],
            members: {
              anomalies: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "instances",
                    "metric",
                    "reason"
                  ],
                  members: {
                    instances: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "id",
                          "startTime"
                        ],
                        members: {
                          endTime: {
                            shape: "Sc"
                          },
                          id: {},
                          startTime: {
                            shape: "Sc"
                          },
                          userFeedback: {
                            type: "structure",
                            required: [
                              "type"
                            ],
                            members: {
                              type: {}
                            }
                          }
                        }
                      }
                    },
                    metric: {
                      type: "structure",
                      required: [
                        "frameName",
                        "threadStates",
                        "type"
                      ],
                      members: {
                        frameName: {},
                        threadStates: {
                          shape: "S26"
                        },
                        type: {}
                      }
                    },
                    reason: {}
                  }
                }
              },
              profileEndTime: {
                shape: "Sc"
              },
              profileStartTime: {
                shape: "Sc"
              },
              profilingGroupName: {},
              recommendations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "allMatchesCount",
                    "allMatchesSum",
                    "endTime",
                    "pattern",
                    "startTime",
                    "topMatches"
                  ],
                  members: {
                    allMatchesCount: {
                      type: "integer"
                    },
                    allMatchesSum: {
                      type: "double"
                    },
                    endTime: {
                      shape: "Sc"
                    },
                    pattern: {
                      type: "structure",
                      members: {
                        countersToAggregate: {
                          shape: "S26"
                        },
                        description: {},
                        id: {},
                        name: {},
                        resolutionSteps: {},
                        targetFrames: {
                          type: "list",
                          member: {
                            type: "list",
                            member: {}
                          }
                        },
                        thresholdPercent: {
                          type: "double"
                        }
                      }
                    },
                    startTime: {
                      shape: "Sc"
                    },
                    topMatches: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          frameAddress: {},
                          targetFramesIndex: {
                            type: "integer"
                          },
                          thresholdBreachValue: {
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListFindingsReports: {
          http: {
            method: "GET",
            requestUri: "/internal/profilingGroups/{profilingGroupName}/findingsReports",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "endTime",
              "profilingGroupName",
              "startTime"
            ],
            members: {
              dailyReportsOnly: {
                location: "querystring",
                locationName: "dailyReportsOnly",
                type: "boolean"
              },
              endTime: {
                shape: "Sc",
                location: "querystring",
                locationName: "endTime"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              },
              startTime: {
                shape: "Sc",
                location: "querystring",
                locationName: "startTime"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "findingsReportSummaries"
            ],
            members: {
              findingsReportSummaries: {
                shape: "S1k"
              },
              nextToken: {}
            }
          }
        },
        ListProfileTimes: {
          http: {
            method: "GET",
            requestUri: "/profilingGroups/{profilingGroupName}/profileTimes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "endTime",
              "period",
              "profilingGroupName",
              "startTime"
            ],
            members: {
              endTime: {
                shape: "Sc",
                location: "querystring",
                locationName: "endTime"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              orderBy: {
                location: "querystring",
                locationName: "orderBy"
              },
              period: {
                location: "querystring",
                locationName: "period"
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              },
              startTime: {
                shape: "Sc",
                location: "querystring",
                locationName: "startTime"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "profileTimes"
            ],
            members: {
              nextToken: {},
              profileTimes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    start: {
                      shape: "Sc"
                    }
                  }
                }
              }
            }
          }
        },
        ListProfilingGroups: {
          http: {
            method: "GET",
            requestUri: "/profilingGroups",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              includeDescription: {
                location: "querystring",
                locationName: "includeDescription",
                type: "boolean"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "profilingGroupNames"
            ],
            members: {
              nextToken: {},
              profilingGroupNames: {
                type: "list",
                member: {}
              },
              profilingGroups: {
                type: "list",
                member: {
                  shape: "S18"
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S16"
              }
            }
          }
        },
        PostAgentProfile: {
          http: {
            requestUri: "/profilingGroups/{profilingGroupName}/agentProfile",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "agentProfile",
              "contentType",
              "profilingGroupName"
            ],
            members: {
              agentProfile: {
                type: "blob"
              },
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              profileToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "profileToken"
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              }
            },
            payload: "agentProfile"
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutPermission: {
          http: {
            method: "PUT",
            requestUri: "/profilingGroups/{profilingGroupName}/policy/{actionGroup}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "actionGroup",
              "principals",
              "profilingGroupName"
            ],
            members: {
              actionGroup: {
                location: "uri",
                locationName: "actionGroup"
              },
              principals: {
                type: "list",
                member: {}
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              },
              revisionId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "policy",
              "revisionId"
            ],
            members: {
              policy: {},
              revisionId: {}
            }
          },
          idempotent: true
        },
        RemoveNotificationChannel: {
          http: {
            method: "DELETE",
            requestUri: "/profilingGroups/{profilingGroupName}/notificationConfiguration/{channelId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channelId",
              "profilingGroupName"
            ],
            members: {
              channelId: {
                location: "uri",
                locationName: "channelId"
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              notificationConfiguration: {
                shape: "Sa"
              }
            }
          },
          idempotent: true
        },
        RemovePermission: {
          http: {
            method: "DELETE",
            requestUri: "/profilingGroups/{profilingGroupName}/policy/{actionGroup}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "actionGroup",
              "profilingGroupName",
              "revisionId"
            ],
            members: {
              actionGroup: {
                location: "uri",
                locationName: "actionGroup"
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              },
              revisionId: {
                location: "querystring",
                locationName: "revisionId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "policy",
              "revisionId"
            ],
            members: {
              policy: {},
              revisionId: {}
            }
          }
        },
        SubmitFeedback: {
          http: {
            requestUri: "/internal/profilingGroups/{profilingGroupName}/anomalies/{anomalyInstanceId}/feedback",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "anomalyInstanceId",
              "profilingGroupName",
              "type"
            ],
            members: {
              anomalyInstanceId: {
                location: "uri",
                locationName: "anomalyInstanceId"
              },
              comment: {},
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateProfilingGroup: {
          http: {
            method: "PUT",
            requestUri: "/profilingGroups/{profilingGroupName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "agentOrchestrationConfig",
              "profilingGroupName"
            ],
            members: {
              agentOrchestrationConfig: {
                shape: "S13"
              },
              profilingGroupName: {
                location: "uri",
                locationName: "profilingGroupName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "profilingGroup"
            ],
            members: {
              profilingGroup: {
                shape: "S18"
              }
            },
            payload: "profilingGroup"
          },
          idempotent: true
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "eventPublishers",
              "uri"
            ],
            members: {
              eventPublishers: {
                type: "list",
                member: {}
              },
              id: {},
              uri: {}
            }
          }
        },
        Sa: {
          type: "structure",
          members: {
            channels: {
              shape: "S2"
            }
          }
        },
        Sc: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Se: {
          type: "structure",
          required: [
            "frameName",
            "threadStates",
            "type"
          ],
          members: {
            frameName: {},
            threadStates: {
              type: "list",
              member: {}
            },
            type: {}
          }
        },
        Sl: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "value"
            ],
            members: {
              value: {
                shape: "Sc"
              }
            }
          }
        },
        S13: {
          type: "structure",
          required: [
            "profilingEnabled"
          ],
          members: {
            profilingEnabled: {
              type: "boolean"
            }
          }
        },
        S16: {
          type: "map",
          key: {},
          value: {}
        },
        S18: {
          type: "structure",
          members: {
            agentOrchestrationConfig: {
              shape: "S13"
            },
            arn: {},
            computePlatform: {},
            createdAt: {
              shape: "Sc"
            },
            name: {},
            profilingStatus: {
              type: "structure",
              members: {
                latestAgentOrchestratedAt: {
                  shape: "Sc"
                },
                latestAgentProfileReportedAt: {
                  shape: "Sc"
                },
                latestAggregatedProfile: {
                  type: "structure",
                  members: {
                    period: {},
                    start: {
                      shape: "Sc"
                    }
                  }
                }
              }
            },
            tags: {
              shape: "S16"
            },
            updatedAt: {
              shape: "Sc"
            }
          }
        },
        S1k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              profileEndTime: {
                shape: "Sc"
              },
              profileStartTime: {
                shape: "Sc"
              },
              profilingGroupName: {},
              totalNumberOfFindings: {
                type: "integer"
              }
            }
          }
        },
        S26: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codeguruprofiler-2019-07-18.paginators.json
var require_codeguruprofiler_2019_07_18_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codeguruprofiler-2019-07-18.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetFindingsReportAccountSummary: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListFindingsReports: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListProfileTimes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "profileTimes"
        },
        ListProfilingGroups: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/codeguruprofiler.js
var require_codeguruprofiler = __commonJS({
  "node_modules/aws-sdk/clients/codeguruprofiler.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["codeguruprofiler"] = {};
    AWS3.CodeGuruProfiler = Service.defineService("codeguruprofiler", ["2019-07-18"]);
    Object.defineProperty(apiLoader.services["codeguruprofiler"], "2019-07-18", {
      get: function get() {
        var model = require_codeguruprofiler_2019_07_18_min();
        model.paginators = require_codeguruprofiler_2019_07_18_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CodeGuruProfiler;
  }
});

// node_modules/aws-sdk/apis/compute-optimizer-2019-11-01.min.json
var require_compute_optimizer_2019_11_01_min = __commonJS({
  "node_modules/aws-sdk/apis/compute-optimizer-2019-11-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-11-01",
        endpointPrefix: "compute-optimizer",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "AWS Compute Optimizer",
        serviceId: "Compute Optimizer",
        signatureVersion: "v4",
        signingName: "compute-optimizer",
        targetPrefix: "ComputeOptimizerService",
        uid: "compute-optimizer-2019-11-01"
      },
      operations: {
        DescribeRecommendationExportJobs: {
          input: {
            type: "structure",
            members: {
              jobIds: {
                type: "list",
                member: {}
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      shape: "S7"
                    }
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              recommendationExportJobs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    jobId: {},
                    destination: {
                      type: "structure",
                      members: {
                        s3: {
                          shape: "Sf"
                        }
                      }
                    },
                    resourceType: {},
                    status: {},
                    creationTimestamp: {
                      type: "timestamp"
                    },
                    lastUpdatedTimestamp: {
                      type: "timestamp"
                    },
                    failureReason: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ExportAutoScalingGroupRecommendations: {
          input: {
            type: "structure",
            required: [
              "s3DestinationConfig"
            ],
            members: {
              accountIds: {
                shape: "Sp"
              },
              filters: {
                shape: "Sr"
              },
              fieldsToExport: {
                type: "list",
                member: {}
              },
              s3DestinationConfig: {
                shape: "Sw"
              },
              fileFormat: {},
              includeMemberAccounts: {
                type: "boolean"
              },
              recommendationPreferences: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobId: {},
              s3Destination: {
                shape: "Sf"
              }
            }
          }
        },
        ExportEBSVolumeRecommendations: {
          input: {
            type: "structure",
            required: [
              "s3DestinationConfig"
            ],
            members: {
              accountIds: {
                shape: "Sp"
              },
              filters: {
                shape: "S15"
              },
              fieldsToExport: {
                type: "list",
                member: {}
              },
              s3DestinationConfig: {
                shape: "Sw"
              },
              fileFormat: {},
              includeMemberAccounts: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobId: {},
              s3Destination: {
                shape: "Sf"
              }
            }
          }
        },
        ExportEC2InstanceRecommendations: {
          input: {
            type: "structure",
            required: [
              "s3DestinationConfig"
            ],
            members: {
              accountIds: {
                shape: "Sp"
              },
              filters: {
                shape: "Sr"
              },
              fieldsToExport: {
                type: "list",
                member: {}
              },
              s3DestinationConfig: {
                shape: "Sw"
              },
              fileFormat: {},
              includeMemberAccounts: {
                type: "boolean"
              },
              recommendationPreferences: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobId: {},
              s3Destination: {
                shape: "Sf"
              }
            }
          }
        },
        ExportLambdaFunctionRecommendations: {
          input: {
            type: "structure",
            required: [
              "s3DestinationConfig"
            ],
            members: {
              accountIds: {
                shape: "Sp"
              },
              filters: {
                shape: "S1g"
              },
              fieldsToExport: {
                type: "list",
                member: {}
              },
              s3DestinationConfig: {
                shape: "Sw"
              },
              fileFormat: {},
              includeMemberAccounts: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobId: {},
              s3Destination: {
                shape: "Sf"
              }
            }
          }
        },
        GetAutoScalingGroupRecommendations: {
          input: {
            type: "structure",
            members: {
              accountIds: {
                shape: "Sp"
              },
              autoScalingGroupArns: {
                type: "list",
                member: {}
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "Sr"
              },
              recommendationPreferences: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              autoScalingGroupRecommendations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {},
                    autoScalingGroupArn: {},
                    autoScalingGroupName: {},
                    finding: {},
                    utilizationMetrics: {
                      shape: "S1u"
                    },
                    lookBackPeriodInDays: {
                      type: "double"
                    },
                    currentConfiguration: {
                      shape: "S20"
                    },
                    recommendationOptions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          configuration: {
                            shape: "S20"
                          },
                          projectedUtilizationMetrics: {
                            shape: "S27"
                          },
                          performanceRisk: {
                            type: "double"
                          },
                          rank: {
                            type: "integer"
                          }
                        }
                      }
                    },
                    lastRefreshTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              errors: {
                shape: "S2b"
              }
            }
          }
        },
        GetEBSVolumeRecommendations: {
          input: {
            type: "structure",
            members: {
              volumeArns: {
                type: "list",
                member: {}
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "S15"
              },
              accountIds: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              volumeRecommendations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    volumeArn: {},
                    accountId: {},
                    currentConfiguration: {
                      shape: "S2m"
                    },
                    finding: {},
                    utilizationMetrics: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          statistic: {},
                          value: {
                            type: "double"
                          }
                        }
                      }
                    },
                    lookBackPeriodInDays: {
                      type: "double"
                    },
                    volumeRecommendationOptions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          configuration: {
                            shape: "S2m"
                          },
                          performanceRisk: {
                            type: "double"
                          },
                          rank: {
                            type: "integer"
                          }
                        }
                      }
                    },
                    lastRefreshTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              errors: {
                shape: "S2b"
              }
            }
          }
        },
        GetEC2InstanceRecommendations: {
          input: {
            type: "structure",
            members: {
              instanceArns: {
                type: "list",
                member: {}
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              },
              filters: {
                shape: "Sr"
              },
              accountIds: {
                shape: "Sp"
              },
              recommendationPreferences: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              instanceRecommendations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    instanceArn: {},
                    accountId: {},
                    instanceName: {},
                    currentInstanceType: {},
                    finding: {},
                    findingReasonCodes: {
                      type: "list",
                      member: {}
                    },
                    utilizationMetrics: {
                      shape: "S1u"
                    },
                    lookBackPeriodInDays: {
                      type: "double"
                    },
                    recommendationOptions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          instanceType: {},
                          projectedUtilizationMetrics: {
                            shape: "S27"
                          },
                          platformDifferences: {
                            type: "list",
                            member: {}
                          },
                          performanceRisk: {
                            type: "double"
                          },
                          rank: {
                            type: "integer"
                          }
                        }
                      }
                    },
                    recommendationSources: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          recommendationSourceArn: {},
                          recommendationSourceType: {}
                        }
                      }
                    },
                    lastRefreshTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              errors: {
                shape: "S2b"
              }
            }
          }
        },
        GetEC2RecommendationProjectedMetrics: {
          input: {
            type: "structure",
            required: [
              "instanceArn",
              "stat",
              "period",
              "startTime",
              "endTime"
            ],
            members: {
              instanceArn: {},
              stat: {},
              period: {
                type: "integer"
              },
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              recommendationPreferences: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              recommendedOptionProjectedMetrics: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    recommendedInstanceType: {},
                    rank: {
                      type: "integer"
                    },
                    projectedMetrics: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          timestamps: {
                            type: "list",
                            member: {
                              type: "timestamp"
                            }
                          },
                          values: {
                            type: "list",
                            member: {
                              type: "double"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetEnrollmentStatus: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              status: {},
              statusReason: {},
              memberAccountsEnrolled: {
                type: "boolean"
              },
              lastUpdatedTimestamp: {
                type: "timestamp"
              },
              numberOfMemberAccountsOptedIn: {
                type: "integer"
              }
            }
          }
        },
        GetEnrollmentStatusesForOrganization: {
          input: {
            type: "structure",
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    values: {
                      shape: "S7"
                    }
                  }
                }
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              accountEnrollmentStatuses: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {},
                    status: {},
                    statusReason: {},
                    lastUpdatedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetLambdaFunctionRecommendations: {
          input: {
            type: "structure",
            members: {
              functionArns: {
                type: "list",
                member: {}
              },
              accountIds: {
                shape: "Sp"
              },
              filters: {
                shape: "S1g"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              lambdaFunctionRecommendations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    functionArn: {},
                    functionVersion: {},
                    accountId: {},
                    currentMemorySize: {
                      type: "integer"
                    },
                    numberOfInvocations: {
                      type: "long"
                    },
                    utilizationMetrics: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          statistic: {},
                          value: {
                            type: "double"
                          }
                        }
                      }
                    },
                    lookbackPeriodInDays: {
                      type: "double"
                    },
                    lastRefreshTimestamp: {
                      type: "timestamp"
                    },
                    finding: {},
                    findingReasonCodes: {
                      type: "list",
                      member: {}
                    },
                    memorySizeRecommendationOptions: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          rank: {
                            type: "integer"
                          },
                          memorySize: {
                            type: "integer"
                          },
                          projectedUtilizationMetrics: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                name: {},
                                statistic: {},
                                value: {
                                  type: "double"
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetRecommendationSummaries: {
          input: {
            type: "structure",
            members: {
              accountIds: {
                shape: "Sp"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              recommendationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    summaries: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          value: {
                            type: "double"
                          },
                          reasonCodeSummaries: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                name: {},
                                value: {
                                  type: "double"
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    recommendationResourceType: {},
                    accountId: {}
                  }
                }
              }
            }
          }
        },
        UpdateEnrollmentStatus: {
          input: {
            type: "structure",
            required: [
              "status"
            ],
            members: {
              status: {},
              includeMemberAccounts: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              status: {},
              statusReason: {}
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "list",
          member: {}
        },
        Sf: {
          type: "structure",
          members: {
            bucket: {},
            key: {},
            metadataKey: {}
          }
        },
        Sp: {
          type: "list",
          member: {}
        },
        Sr: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              values: {
                shape: "S7"
              }
            }
          }
        },
        Sw: {
          type: "structure",
          members: {
            bucket: {},
            keyPrefix: {}
          }
        },
        S10: {
          type: "structure",
          members: {
            cpuVendorArchitectures: {
              type: "list",
              member: {}
            }
          }
        },
        S15: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              values: {
                shape: "S7"
              }
            }
          }
        },
        S1g: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              values: {
                shape: "S7"
              }
            }
          }
        },
        S1u: {
          type: "list",
          member: {
            shape: "S1v"
          }
        },
        S1v: {
          type: "structure",
          members: {
            name: {},
            statistic: {},
            value: {
              type: "double"
            }
          }
        },
        S20: {
          type: "structure",
          members: {
            desiredCapacity: {
              type: "integer"
            },
            minSize: {
              type: "integer"
            },
            maxSize: {
              type: "integer"
            },
            instanceType: {}
          }
        },
        S27: {
          type: "list",
          member: {
            shape: "S1v"
          }
        },
        S2b: {
          type: "list",
          member: {
            type: "structure",
            members: {
              identifier: {},
              code: {},
              message: {}
            }
          }
        },
        S2m: {
          type: "structure",
          members: {
            volumeType: {},
            volumeSize: {
              type: "integer"
            },
            volumeBaselineIOPS: {
              type: "integer"
            },
            volumeBurstIOPS: {
              type: "integer"
            },
            volumeBaselineThroughput: {
              type: "integer"
            },
            volumeBurstThroughput: {
              type: "integer"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/compute-optimizer-2019-11-01.paginators.json
var require_compute_optimizer_2019_11_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/compute-optimizer-2019-11-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/computeoptimizer.js
var require_computeoptimizer = __commonJS({
  "node_modules/aws-sdk/clients/computeoptimizer.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["computeoptimizer"] = {};
    AWS3.ComputeOptimizer = Service.defineService("computeoptimizer", ["2019-11-01"]);
    Object.defineProperty(apiLoader.services["computeoptimizer"], "2019-11-01", {
      get: function get() {
        var model = require_compute_optimizer_2019_11_01_min();
        model.paginators = require_compute_optimizer_2019_11_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ComputeOptimizer;
  }
});

// node_modules/aws-sdk/apis/frauddetector-2019-11-15.min.json
var require_frauddetector_2019_11_15_min = __commonJS({
  "node_modules/aws-sdk/apis/frauddetector-2019-11-15.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-11-15",
        endpointPrefix: "frauddetector",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Amazon Fraud Detector",
        serviceId: "FraudDetector",
        signatureVersion: "v4",
        targetPrefix: "AWSHawksNestServiceFacade",
        uid: "frauddetector-2019-11-15"
      },
      operations: {
        BatchCreateVariable: {
          input: {
            type: "structure",
            required: [
              "variableEntries"
            ],
            members: {
              variableEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    dataType: {},
                    dataSource: {},
                    defaultValue: {},
                    description: {},
                    variableType: {}
                  }
                }
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    code: {
                      type: "integer"
                    },
                    message: {}
                  }
                }
              }
            }
          }
        },
        BatchGetVariable: {
          input: {
            type: "structure",
            required: [
              "names"
            ],
            members: {
              names: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              variables: {
                shape: "Sg"
              },
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    code: {
                      type: "integer"
                    },
                    message: {}
                  }
                }
              }
            }
          }
        },
        CancelBatchImportJob: {
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CancelBatchPredictionJob: {
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateBatchImportJob: {
          input: {
            type: "structure",
            required: [
              "jobId",
              "inputPath",
              "outputPath",
              "eventTypeName",
              "iamRoleArn"
            ],
            members: {
              jobId: {},
              inputPath: {},
              outputPath: {},
              eventTypeName: {},
              iamRoleArn: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateBatchPredictionJob: {
          input: {
            type: "structure",
            required: [
              "jobId",
              "inputPath",
              "outputPath",
              "eventTypeName",
              "detectorName",
              "iamRoleArn"
            ],
            members: {
              jobId: {},
              inputPath: {},
              outputPath: {},
              eventTypeName: {},
              detectorName: {},
              detectorVersion: {},
              iamRoleArn: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDetectorVersion: {
          input: {
            type: "structure",
            required: [
              "detectorId",
              "rules"
            ],
            members: {
              detectorId: {},
              description: {},
              externalModelEndpoints: {
                shape: "S12"
              },
              rules: {
                shape: "S13"
              },
              modelVersions: {
                shape: "S15"
              },
              ruleExecutionMode: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              detectorId: {},
              detectorVersionId: {},
              status: {}
            }
          }
        },
        CreateModel: {
          input: {
            type: "structure",
            required: [
              "modelId",
              "modelType",
              "eventTypeName"
            ],
            members: {
              modelId: {},
              modelType: {},
              description: {},
              eventTypeName: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateModelVersion: {
          input: {
            type: "structure",
            required: [
              "modelId",
              "modelType",
              "trainingDataSource",
              "trainingDataSchema"
            ],
            members: {
              modelId: {},
              modelType: {},
              trainingDataSource: {},
              trainingDataSchema: {
                shape: "S1h"
              },
              externalEventsDetail: {
                shape: "S1m"
              },
              ingestedEventsDetail: {
                shape: "S1n"
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              modelId: {},
              modelType: {},
              modelVersionNumber: {},
              status: {}
            }
          }
        },
        CreateRule: {
          input: {
            type: "structure",
            required: [
              "ruleId",
              "detectorId",
              "expression",
              "language",
              "outcomes"
            ],
            members: {
              ruleId: {},
              detectorId: {},
              description: {},
              expression: {
                shape: "S1r"
              },
              language: {},
              outcomes: {
                shape: "S1k"
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              rule: {
                shape: "S14"
              }
            }
          }
        },
        CreateVariable: {
          input: {
            type: "structure",
            required: [
              "name",
              "dataType",
              "dataSource",
              "defaultValue"
            ],
            members: {
              name: {},
              dataType: {},
              dataSource: {},
              defaultValue: {},
              description: {},
              variableType: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteBatchImportJob: {
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteBatchPredictionJob: {
          input: {
            type: "structure",
            required: [
              "jobId"
            ],
            members: {
              jobId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDetector: {
          input: {
            type: "structure",
            required: [
              "detectorId"
            ],
            members: {
              detectorId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDetectorVersion: {
          input: {
            type: "structure",
            required: [
              "detectorId",
              "detectorVersionId"
            ],
            members: {
              detectorId: {},
              detectorVersionId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEntityType: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEvent: {
          input: {
            type: "structure",
            required: [
              "eventId",
              "eventTypeName"
            ],
            members: {
              eventId: {},
              eventTypeName: {},
              deleteAuditHistory: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEventType: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEventsByEventType: {
          input: {
            type: "structure",
            required: [
              "eventTypeName"
            ],
            members: {
              eventTypeName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              eventTypeName: {},
              eventsDeletionStatus: {}
            }
          }
        },
        DeleteExternalModel: {
          input: {
            type: "structure",
            required: [
              "modelEndpoint"
            ],
            members: {
              modelEndpoint: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteLabel: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteModel: {
          input: {
            type: "structure",
            required: [
              "modelId",
              "modelType"
            ],
            members: {
              modelId: {},
              modelType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteModelVersion: {
          input: {
            type: "structure",
            required: [
              "modelId",
              "modelType",
              "modelVersionNumber"
            ],
            members: {
              modelId: {},
              modelType: {},
              modelVersionNumber: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteOutcome: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRule: {
          input: {
            type: "structure",
            required: [
              "rule"
            ],
            members: {
              rule: {
                shape: "S14"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteVariable: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeDetector: {
          input: {
            type: "structure",
            required: [
              "detectorId"
            ],
            members: {
              detectorId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              detectorId: {},
              detectorVersionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    detectorVersionId: {},
                    status: {},
                    description: {},
                    lastUpdatedTime: {}
                  }
                }
              },
              nextToken: {},
              arn: {}
            }
          }
        },
        DescribeModelVersions: {
          input: {
            type: "structure",
            members: {
              modelId: {},
              modelVersionNumber: {},
              modelType: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              modelVersionDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    modelId: {},
                    modelType: {},
                    modelVersionNumber: {},
                    status: {},
                    trainingDataSource: {},
                    trainingDataSchema: {
                      shape: "S1h"
                    },
                    externalEventsDetail: {
                      shape: "S1m"
                    },
                    ingestedEventsDetail: {
                      shape: "S1n"
                    },
                    trainingResult: {
                      type: "structure",
                      members: {
                        dataValidationMetrics: {
                          type: "structure",
                          members: {
                            fileLevelMessages: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  title: {},
                                  content: {},
                                  type: {}
                                }
                              }
                            },
                            fieldLevelMessages: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  fieldName: {},
                                  identifier: {},
                                  title: {},
                                  content: {},
                                  type: {}
                                }
                              }
                            }
                          }
                        },
                        trainingMetrics: {
                          type: "structure",
                          members: {
                            auc: {
                              type: "float"
                            },
                            metricDataPoints: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  fpr: {
                                    type: "float"
                                  },
                                  precision: {
                                    type: "float"
                                  },
                                  tpr: {
                                    type: "float"
                                  },
                                  threshold: {
                                    type: "float"
                                  }
                                }
                              }
                            }
                          }
                        },
                        variableImportanceMetrics: {
                          type: "structure",
                          members: {
                            logOddsMetrics: {
                              type: "list",
                              member: {
                                type: "structure",
                                required: [
                                  "variableName",
                                  "variableType",
                                  "variableImportance"
                                ],
                                members: {
                                  variableName: {},
                                  variableType: {},
                                  variableImportance: {
                                    type: "float"
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    lastUpdatedTime: {},
                    createdTime: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetBatchImportJobs: {
          input: {
            type: "structure",
            members: {
              jobId: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              batchImports: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    jobId: {},
                    status: {},
                    failureReason: {},
                    startTime: {},
                    completionTime: {},
                    inputPath: {},
                    outputPath: {},
                    eventTypeName: {},
                    iamRoleArn: {},
                    arn: {},
                    processedRecordsCount: {
                      type: "integer"
                    },
                    failedRecordsCount: {
                      type: "integer"
                    },
                    totalRecordsCount: {
                      type: "integer"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetBatchPredictionJobs: {
          input: {
            type: "structure",
            members: {
              jobId: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              batchPredictions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    jobId: {},
                    status: {},
                    failureReason: {},
                    startTime: {},
                    completionTime: {},
                    lastHeartbeatTime: {},
                    inputPath: {},
                    outputPath: {},
                    eventTypeName: {},
                    detectorName: {},
                    detectorVersion: {},
                    iamRoleArn: {},
                    arn: {},
                    processedRecordsCount: {
                      type: "integer"
                    },
                    totalRecordsCount: {
                      type: "integer"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetDeleteEventsByEventTypeStatus: {
          input: {
            type: "structure",
            required: [
              "eventTypeName"
            ],
            members: {
              eventTypeName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              eventTypeName: {},
              eventsDeletionStatus: {}
            }
          }
        },
        GetDetectorVersion: {
          input: {
            type: "structure",
            required: [
              "detectorId",
              "detectorVersionId"
            ],
            members: {
              detectorId: {},
              detectorVersionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              detectorId: {},
              detectorVersionId: {},
              description: {},
              externalModelEndpoints: {
                shape: "S12"
              },
              modelVersions: {
                shape: "S15"
              },
              rules: {
                shape: "S13"
              },
              status: {},
              lastUpdatedTime: {},
              createdTime: {},
              ruleExecutionMode: {},
              arn: {}
            }
          }
        },
        GetDetectors: {
          input: {
            type: "structure",
            members: {
              detectorId: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              detectors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    detectorId: {},
                    description: {},
                    eventTypeName: {},
                    lastUpdatedTime: {},
                    createdTime: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetEntityTypes: {
          input: {
            type: "structure",
            members: {
              name: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              entityTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    description: {},
                    lastUpdatedTime: {},
                    createdTime: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetEvent: {
          input: {
            type: "structure",
            required: [
              "eventId",
              "eventTypeName"
            ],
            members: {
              eventId: {},
              eventTypeName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              event: {
                type: "structure",
                members: {
                  eventId: {},
                  eventTypeName: {},
                  eventTimestamp: {},
                  eventVariables: {
                    type: "map",
                    key: {},
                    value: {
                      type: "string",
                      sensitive: true
                    }
                  },
                  currentLabel: {},
                  labelTimestamp: {},
                  entities: {
                    shape: "S4b"
                  }
                }
              }
            }
          }
        },
        GetEventPrediction: {
          input: {
            type: "structure",
            required: [
              "detectorId",
              "eventId",
              "eventTypeName",
              "entities",
              "eventTimestamp",
              "eventVariables"
            ],
            members: {
              detectorId: {},
              detectorVersionId: {},
              eventId: {},
              eventTypeName: {},
              entities: {
                shape: "S4b"
              },
              eventTimestamp: {},
              eventVariables: {
                shape: "S4g"
              },
              externalModelEndpointDataBlobs: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    byteBuffer: {
                      type: "blob"
                    },
                    contentType: {}
                  }
                },
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              modelScores: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    modelVersion: {
                      shape: "S16"
                    },
                    scores: {
                      type: "map",
                      key: {},
                      value: {
                        type: "float"
                      }
                    }
                  }
                }
              },
              ruleResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ruleId: {},
                    outcomes: {
                      shape: "S12"
                    }
                  }
                }
              },
              externalModelOutputs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    externalModel: {
                      type: "structure",
                      members: {
                        modelEndpoint: {},
                        modelSource: {}
                      }
                    },
                    outputs: {
                      type: "map",
                      key: {},
                      value: {}
                    }
                  }
                }
              }
            }
          }
        },
        GetEventTypes: {
          input: {
            type: "structure",
            members: {
              name: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              eventTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    description: {},
                    eventVariables: {
                      shape: "S12"
                    },
                    labels: {
                      shape: "S12"
                    },
                    entityTypes: {
                      shape: "S1k"
                    },
                    eventIngestion: {},
                    ingestedEventStatistics: {
                      type: "structure",
                      members: {
                        numberOfEvents: {
                          type: "long"
                        },
                        eventDataSizeInBytes: {
                          type: "long"
                        },
                        leastRecentEvent: {},
                        mostRecentEvent: {},
                        lastUpdatedTime: {}
                      }
                    },
                    lastUpdatedTime: {},
                    createdTime: {},
                    arn: {}
                  },
                  sensitive: true
                }
              },
              nextToken: {}
            }
          }
        },
        GetExternalModels: {
          input: {
            type: "structure",
            members: {
              modelEndpoint: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              externalModels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    modelEndpoint: {},
                    modelSource: {},
                    invokeModelEndpointRoleArn: {},
                    inputConfiguration: {
                      shape: "S5b"
                    },
                    outputConfiguration: {
                      shape: "S5f"
                    },
                    modelEndpointStatus: {},
                    lastUpdatedTime: {},
                    createdTime: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetKMSEncryptionKey: {
          output: {
            type: "structure",
            members: {
              kmsKey: {
                type: "structure",
                members: {
                  kmsEncryptionKeyArn: {}
                }
              }
            }
          }
        },
        GetLabels: {
          input: {
            type: "structure",
            members: {
              name: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              labels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    description: {},
                    lastUpdatedTime: {},
                    createdTime: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetModelVersion: {
          input: {
            type: "structure",
            required: [
              "modelId",
              "modelType",
              "modelVersionNumber"
            ],
            members: {
              modelId: {},
              modelType: {},
              modelVersionNumber: {}
            }
          },
          output: {
            type: "structure",
            members: {
              modelId: {},
              modelType: {},
              modelVersionNumber: {},
              trainingDataSource: {},
              trainingDataSchema: {
                shape: "S1h"
              },
              externalEventsDetail: {
                shape: "S1m"
              },
              ingestedEventsDetail: {
                shape: "S1n"
              },
              status: {},
              arn: {}
            }
          }
        },
        GetModels: {
          input: {
            type: "structure",
            members: {
              modelId: {},
              modelType: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              models: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    modelId: {},
                    modelType: {},
                    description: {},
                    eventTypeName: {},
                    createdTime: {},
                    lastUpdatedTime: {},
                    arn: {}
                  }
                }
              }
            }
          }
        },
        GetOutcomes: {
          input: {
            type: "structure",
            members: {
              name: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              outcomes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    description: {},
                    lastUpdatedTime: {},
                    createdTime: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetRules: {
          input: {
            type: "structure",
            required: [
              "detectorId"
            ],
            members: {
              ruleId: {},
              detectorId: {},
              ruleVersion: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ruleDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ruleId: {},
                    description: {},
                    detectorId: {},
                    ruleVersion: {},
                    expression: {
                      shape: "S1r"
                    },
                    language: {},
                    outcomes: {
                      shape: "S1k"
                    },
                    lastUpdatedTime: {},
                    createdTime: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetVariables: {
          input: {
            type: "structure",
            members: {
              name: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              variables: {
                shape: "Sg"
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceARN"
            ],
            members: {
              resourceARN: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S5"
              },
              nextToken: {}
            }
          }
        },
        PutDetector: {
          input: {
            type: "structure",
            required: [
              "detectorId",
              "eventTypeName"
            ],
            members: {
              detectorId: {},
              description: {},
              eventTypeName: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutEntityType: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutEventType: {
          input: {
            type: "structure",
            required: [
              "name",
              "eventVariables",
              "entityTypes"
            ],
            members: {
              name: {},
              description: {},
              eventVariables: {
                shape: "S1k"
              },
              labels: {
                shape: "S12"
              },
              entityTypes: {
                shape: "S1k"
              },
              eventIngestion: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutExternalModel: {
          input: {
            type: "structure",
            required: [
              "modelEndpoint",
              "modelSource",
              "invokeModelEndpointRoleArn",
              "inputConfiguration",
              "outputConfiguration",
              "modelEndpointStatus"
            ],
            members: {
              modelEndpoint: {},
              modelSource: {},
              invokeModelEndpointRoleArn: {},
              inputConfiguration: {
                shape: "S5b"
              },
              outputConfiguration: {
                shape: "S5f"
              },
              modelEndpointStatus: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutKMSEncryptionKey: {
          input: {
            type: "structure",
            required: [
              "kmsEncryptionKeyArn"
            ],
            members: {
              kmsEncryptionKeyArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutLabel: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutOutcome: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SendEvent: {
          input: {
            type: "structure",
            required: [
              "eventId",
              "eventTypeName",
              "eventTimestamp",
              "eventVariables",
              "entities"
            ],
            members: {
              eventId: {},
              eventTypeName: {},
              eventTimestamp: {},
              eventVariables: {
                shape: "S4g"
              },
              assignedLabel: {},
              labelTimestamp: {},
              entities: {
                shape: "S4b"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceARN",
              "tags"
            ],
            members: {
              resourceARN: {},
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceARN",
              "tagKeys"
            ],
            members: {
              resourceARN: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDetectorVersion: {
          input: {
            type: "structure",
            required: [
              "detectorId",
              "detectorVersionId",
              "externalModelEndpoints",
              "rules"
            ],
            members: {
              detectorId: {},
              detectorVersionId: {},
              externalModelEndpoints: {
                shape: "S12"
              },
              rules: {
                shape: "S13"
              },
              description: {},
              modelVersions: {
                shape: "S15"
              },
              ruleExecutionMode: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDetectorVersionMetadata: {
          input: {
            type: "structure",
            required: [
              "detectorId",
              "detectorVersionId",
              "description"
            ],
            members: {
              detectorId: {},
              detectorVersionId: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDetectorVersionStatus: {
          input: {
            type: "structure",
            required: [
              "detectorId",
              "detectorVersionId",
              "status"
            ],
            members: {
              detectorId: {},
              detectorVersionId: {},
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEventLabel: {
          input: {
            type: "structure",
            required: [
              "eventId",
              "eventTypeName",
              "assignedLabel",
              "labelTimestamp"
            ],
            members: {
              eventId: {},
              eventTypeName: {},
              assignedLabel: {},
              labelTimestamp: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateModel: {
          input: {
            type: "structure",
            required: [
              "modelId",
              "modelType"
            ],
            members: {
              modelId: {},
              modelType: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateModelVersion: {
          input: {
            type: "structure",
            required: [
              "modelId",
              "modelType",
              "majorVersionNumber"
            ],
            members: {
              modelId: {},
              modelType: {},
              majorVersionNumber: {},
              externalEventsDetail: {
                shape: "S1m"
              },
              ingestedEventsDetail: {
                shape: "S1n"
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              modelId: {},
              modelType: {},
              modelVersionNumber: {},
              status: {}
            }
          }
        },
        UpdateModelVersionStatus: {
          input: {
            type: "structure",
            required: [
              "modelId",
              "modelType",
              "modelVersionNumber",
              "status"
            ],
            members: {
              modelId: {},
              modelType: {},
              modelVersionNumber: {},
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRuleMetadata: {
          input: {
            type: "structure",
            required: [
              "rule",
              "description"
            ],
            members: {
              rule: {
                shape: "S14"
              },
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRuleVersion: {
          input: {
            type: "structure",
            required: [
              "rule",
              "expression",
              "language",
              "outcomes"
            ],
            members: {
              rule: {
                shape: "S14"
              },
              description: {},
              expression: {
                shape: "S1r"
              },
              language: {},
              outcomes: {
                shape: "S1k"
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              rule: {
                shape: "S14"
              }
            }
          }
        },
        UpdateVariable: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              defaultValue: {},
              description: {},
              variableType: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        Sg: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              dataType: {},
              dataSource: {},
              defaultValue: {},
              description: {},
              variableType: {},
              lastUpdatedTime: {},
              createdTime: {},
              arn: {}
            }
          }
        },
        S12: {
          type: "list",
          member: {}
        },
        S13: {
          type: "list",
          member: {
            shape: "S14"
          }
        },
        S14: {
          type: "structure",
          required: [
            "detectorId",
            "ruleId",
            "ruleVersion"
          ],
          members: {
            detectorId: {},
            ruleId: {},
            ruleVersion: {}
          }
        },
        S15: {
          type: "list",
          member: {
            shape: "S16"
          }
        },
        S16: {
          type: "structure",
          required: [
            "modelId",
            "modelType",
            "modelVersionNumber"
          ],
          members: {
            modelId: {},
            modelType: {},
            modelVersionNumber: {},
            arn: {}
          }
        },
        S1h: {
          type: "structure",
          required: [
            "modelVariables",
            "labelSchema"
          ],
          members: {
            modelVariables: {
              shape: "S12"
            },
            labelSchema: {
              type: "structure",
              required: [
                "labelMapper"
              ],
              members: {
                labelMapper: {
                  type: "map",
                  key: {},
                  value: {
                    shape: "S1k"
                  }
                },
                unlabeledEventsTreatment: {}
              }
            }
          }
        },
        S1k: {
          type: "list",
          member: {}
        },
        S1m: {
          type: "structure",
          required: [
            "dataLocation",
            "dataAccessRoleArn"
          ],
          members: {
            dataLocation: {},
            dataAccessRoleArn: {}
          }
        },
        S1n: {
          type: "structure",
          required: [
            "ingestedEventsTimeWindow"
          ],
          members: {
            ingestedEventsTimeWindow: {
              type: "structure",
              required: [
                "startTime",
                "endTime"
              ],
              members: {
                startTime: {},
                endTime: {}
              }
            }
          }
        },
        S1r: {
          type: "string",
          sensitive: true
        },
        S4b: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "entityType",
              "entityId"
            ],
            members: {
              entityType: {},
              entityId: {}
            },
            sensitive: true
          }
        },
        S4g: {
          type: "map",
          key: {},
          value: {
            type: "string",
            sensitive: true
          }
        },
        S5b: {
          type: "structure",
          required: [
            "useEventVariables"
          ],
          members: {
            eventTypeName: {},
            format: {},
            useEventVariables: {
              type: "boolean"
            },
            jsonInputTemplate: {},
            csvInputTemplate: {}
          }
        },
        S5f: {
          type: "structure",
          required: [
            "format"
          ],
          members: {
            format: {},
            jsonKeyToVariableMap: {
              type: "map",
              key: {},
              value: {}
            },
            csvIndexToVariableMap: {
              type: "map",
              key: {},
              value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/frauddetector-2019-11-15.paginators.json
var require_frauddetector_2019_11_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/frauddetector-2019-11-15.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeModelVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetBatchImportJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetBatchPredictionJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetDetectors: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetEntityTypes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetEventTypes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetExternalModels: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetLabels: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetModels: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetOutcomes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetRules: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetVariables: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListTagsForResource: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/frauddetector.js
var require_frauddetector = __commonJS({
  "node_modules/aws-sdk/clients/frauddetector.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["frauddetector"] = {};
    AWS3.FraudDetector = Service.defineService("frauddetector", ["2019-11-15"]);
    Object.defineProperty(apiLoader.services["frauddetector"], "2019-11-15", {
      get: function get() {
        var model = require_frauddetector_2019_11_15_min();
        model.paginators = require_frauddetector_2019_11_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.FraudDetector;
  }
});

// node_modules/aws-sdk/apis/kendra-2019-02-03.min.json
var require_kendra_2019_02_03_min = __commonJS({
  "node_modules/aws-sdk/apis/kendra-2019-02-03.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-02-03",
        endpointPrefix: "kendra",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "kendra",
        serviceFullName: "AWSKendraFrontendService",
        serviceId: "kendra",
        signatureVersion: "v4",
        signingName: "kendra",
        targetPrefix: "AWSKendraFrontendService",
        uid: "kendra-2019-02-03"
      },
      operations: {
        BatchDeleteDocument: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "DocumentIdList"
            ],
            members: {
              IndexId: {},
              DocumentIdList: {
                type: "list",
                member: {}
              },
              DataSourceSyncJobMetricTarget: {
                type: "structure",
                required: [
                  "DataSourceId"
                ],
                members: {
                  DataSourceId: {},
                  DataSourceSyncJobId: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedDocuments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchGetDocumentStatus: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "DocumentInfoList"
            ],
            members: {
              IndexId: {},
              DocumentInfoList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DocumentId"
                  ],
                  members: {
                    DocumentId: {},
                    Attributes: {
                      shape: "Sg"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DocumentId: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              },
              DocumentStatusList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DocumentId: {},
                    DocumentStatus: {},
                    FailureCode: {},
                    FailureReason: {}
                  }
                }
              }
            }
          }
        },
        BatchPutDocument: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "Documents"
            ],
            members: {
              IndexId: {},
              RoleArn: {},
              Documents: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id"
                  ],
                  members: {
                    Id: {},
                    Title: {},
                    Blob: {
                      type: "blob"
                    },
                    S3Path: {
                      shape: "S11"
                    },
                    Attributes: {
                      shape: "Sg"
                    },
                    AccessControlList: {
                      shape: "S14"
                    },
                    HierarchicalAccessControlList: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "PrincipalList"
                        ],
                        members: {
                          PrincipalList: {
                            shape: "S14"
                          }
                        }
                      }
                    },
                    ContentType: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FailedDocuments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        ClearQuerySuggestions: {
          input: {
            type: "structure",
            required: [
              "IndexId"
            ],
            members: {
              IndexId: {}
            }
          }
        },
        CreateDataSource: {
          input: {
            type: "structure",
            required: [
              "Name",
              "IndexId",
              "Type"
            ],
            members: {
              Name: {},
              IndexId: {},
              Type: {},
              Configuration: {
                shape: "S1j"
              },
              Description: {},
              Schedule: {},
              RoleArn: {},
              Tags: {
                shape: "S4n"
              },
              ClientToken: {
                idempotencyToken: true
              },
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          }
        },
        CreateFaq: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "Name",
              "S3Path",
              "RoleArn"
            ],
            members: {
              IndexId: {},
              Name: {},
              Description: {},
              S3Path: {
                shape: "S11"
              },
              RoleArn: {},
              Tags: {
                shape: "S4n"
              },
              FileFormat: {},
              ClientToken: {
                idempotencyToken: true
              },
              LanguageCode: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {}
            }
          }
        },
        CreateIndex: {
          input: {
            type: "structure",
            required: [
              "Name",
              "RoleArn"
            ],
            members: {
              Name: {},
              Edition: {},
              RoleArn: {},
              ServerSideEncryptionConfiguration: {
                shape: "S52"
              },
              Description: {},
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S4n"
              },
              UserTokenConfigurations: {
                shape: "S54"
              },
              UserContextPolicy: {},
              UserGroupResolutionConfiguration: {
                shape: "S5e"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {}
            }
          }
        },
        CreateQuerySuggestionsBlockList: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "Name",
              "SourceS3Path",
              "RoleArn"
            ],
            members: {
              IndexId: {},
              Name: {},
              Description: {},
              SourceS3Path: {
                shape: "S11"
              },
              ClientToken: {
                idempotencyToken: true
              },
              RoleArn: {},
              Tags: {
                shape: "S4n"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {}
            }
          }
        },
        CreateThesaurus: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "Name",
              "RoleArn",
              "SourceS3Path"
            ],
            members: {
              IndexId: {},
              Name: {},
              Description: {},
              RoleArn: {},
              Tags: {
                shape: "S4n"
              },
              SourceS3Path: {
                shape: "S11"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {}
            }
          }
        },
        DeleteDataSource: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {}
            }
          }
        },
        DeleteFaq: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {}
            }
          }
        },
        DeleteIndex: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          }
        },
        DeletePrincipalMapping: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "GroupId"
            ],
            members: {
              IndexId: {},
              DataSourceId: {},
              GroupId: {},
              OrderingId: {
                type: "long"
              }
            }
          }
        },
        DeleteQuerySuggestionsBlockList: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "Id"
            ],
            members: {
              IndexId: {},
              Id: {}
            }
          }
        },
        DeleteThesaurus: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {}
            }
          }
        },
        DescribeDataSource: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              IndexId: {},
              Name: {},
              Type: {},
              Configuration: {
                shape: "S1j"
              },
              CreatedAt: {
                type: "timestamp"
              },
              UpdatedAt: {
                type: "timestamp"
              },
              Description: {},
              Status: {},
              Schedule: {},
              RoleArn: {},
              ErrorMessage: {},
              LanguageCode: {}
            }
          }
        },
        DescribeFaq: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              IndexId: {},
              Name: {},
              Description: {},
              CreatedAt: {
                type: "timestamp"
              },
              UpdatedAt: {
                type: "timestamp"
              },
              S3Path: {
                shape: "S11"
              },
              Status: {},
              RoleArn: {},
              ErrorMessage: {},
              FileFormat: {},
              LanguageCode: {}
            }
          }
        },
        DescribeIndex: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Id: {},
              Edition: {},
              RoleArn: {},
              ServerSideEncryptionConfiguration: {
                shape: "S52"
              },
              Status: {},
              Description: {},
              CreatedAt: {
                type: "timestamp"
              },
              UpdatedAt: {
                type: "timestamp"
              },
              DocumentMetadataConfigurations: {
                shape: "S66"
              },
              IndexStatistics: {
                type: "structure",
                required: [
                  "FaqStatistics",
                  "TextDocumentStatistics"
                ],
                members: {
                  FaqStatistics: {
                    type: "structure",
                    required: [
                      "IndexedQuestionAnswersCount"
                    ],
                    members: {
                      IndexedQuestionAnswersCount: {
                        type: "integer"
                      }
                    }
                  },
                  TextDocumentStatistics: {
                    type: "structure",
                    required: [
                      "IndexedTextDocumentsCount",
                      "IndexedTextBytes"
                    ],
                    members: {
                      IndexedTextDocumentsCount: {
                        type: "integer"
                      },
                      IndexedTextBytes: {
                        type: "long"
                      }
                    }
                  }
                }
              },
              ErrorMessage: {},
              CapacityUnits: {
                shape: "S6o"
              },
              UserTokenConfigurations: {
                shape: "S54"
              },
              UserContextPolicy: {},
              UserGroupResolutionConfiguration: {
                shape: "S5e"
              }
            }
          }
        },
        DescribePrincipalMapping: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "GroupId"
            ],
            members: {
              IndexId: {},
              DataSourceId: {},
              GroupId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IndexId: {},
              DataSourceId: {},
              GroupId: {},
              GroupOrderingIdSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Status: {},
                    LastUpdatedAt: {
                      type: "timestamp"
                    },
                    ReceivedAt: {
                      type: "timestamp"
                    },
                    OrderingId: {
                      type: "long"
                    },
                    FailureReason: {}
                  }
                }
              }
            }
          }
        },
        DescribeQuerySuggestionsBlockList: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "Id"
            ],
            members: {
              IndexId: {},
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IndexId: {},
              Id: {},
              Name: {},
              Description: {},
              Status: {},
              ErrorMessage: {},
              CreatedAt: {
                type: "timestamp"
              },
              UpdatedAt: {
                type: "timestamp"
              },
              SourceS3Path: {
                shape: "S11"
              },
              ItemCount: {
                type: "integer"
              },
              FileSizeBytes: {
                type: "long"
              },
              RoleArn: {}
            }
          }
        },
        DescribeQuerySuggestionsConfig: {
          input: {
            type: "structure",
            required: [
              "IndexId"
            ],
            members: {
              IndexId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Mode: {},
              Status: {},
              QueryLogLookBackWindowInDays: {
                type: "integer"
              },
              IncludeQueriesWithoutUserInformation: {
                type: "boolean"
              },
              MinimumNumberOfQueryingUsers: {
                type: "integer"
              },
              MinimumQueryCount: {
                type: "integer"
              },
              LastSuggestionsBuildTime: {
                type: "timestamp"
              },
              LastClearTime: {
                type: "timestamp"
              },
              TotalSuggestionsCount: {
                type: "integer"
              }
            }
          }
        },
        DescribeThesaurus: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              IndexId: {},
              Name: {},
              Description: {},
              Status: {},
              ErrorMessage: {},
              CreatedAt: {
                type: "timestamp"
              },
              UpdatedAt: {
                type: "timestamp"
              },
              RoleArn: {},
              SourceS3Path: {
                shape: "S11"
              },
              FileSizeBytes: {
                type: "long"
              },
              TermCount: {
                type: "long"
              },
              SynonymRuleCount: {
                type: "long"
              }
            }
          }
        },
        GetQuerySuggestions: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "QueryText"
            ],
            members: {
              IndexId: {},
              QueryText: {},
              MaxSuggestionsCount: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              QuerySuggestionsId: {},
              Suggestions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Value: {
                      type: "structure",
                      members: {
                        Text: {
                          type: "structure",
                          members: {
                            Text: {},
                            Highlights: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  BeginOffset: {
                                    type: "integer"
                                  },
                                  EndOffset: {
                                    type: "integer"
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListDataSourceSyncJobs: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              StartTimeFilter: {
                type: "structure",
                members: {
                  StartTime: {
                    type: "timestamp"
                  },
                  EndTime: {
                    type: "timestamp"
                  }
                }
              },
              StatusFilter: {}
            }
          },
          output: {
            type: "structure",
            members: {
              History: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ExecutionId: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    EndTime: {
                      type: "timestamp"
                    },
                    Status: {},
                    ErrorMessage: {},
                    ErrorCode: {},
                    DataSourceErrorCode: {},
                    Metrics: {
                      type: "structure",
                      members: {
                        DocumentsAdded: {},
                        DocumentsModified: {},
                        DocumentsDeleted: {},
                        DocumentsFailed: {},
                        DocumentsScanned: {}
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDataSources: {
          input: {
            type: "structure",
            required: [
              "IndexId"
            ],
            members: {
              IndexId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SummaryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Id: {},
                    Type: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    },
                    Status: {},
                    LanguageCode: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListFaqs: {
          input: {
            type: "structure",
            required: [
              "IndexId"
            ],
            members: {
              IndexId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              FaqSummaryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Status: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    },
                    FileFormat: {},
                    LanguageCode: {}
                  }
                }
              }
            }
          }
        },
        ListGroupsOlderThanOrderingId: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "OrderingId"
            ],
            members: {
              IndexId: {},
              DataSourceId: {},
              OrderingId: {
                type: "long"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GroupsSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    GroupId: {},
                    OrderingId: {
                      type: "long"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListIndices: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IndexConfigurationSummaryItems: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CreatedAt",
                    "UpdatedAt",
                    "Status"
                  ],
                  members: {
                    Name: {},
                    Id: {},
                    Edition: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    },
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListQuerySuggestionsBlockLists: {
          input: {
            type: "structure",
            required: [
              "IndexId"
            ],
            members: {
              IndexId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BlockListSummaryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Status: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    },
                    ItemCount: {
                      type: "integer"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S4n"
              }
            }
          }
        },
        ListThesauri: {
          input: {
            type: "structure",
            required: [
              "IndexId"
            ],
            members: {
              IndexId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ThesaurusSummaryItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Name: {},
                    Status: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        PutPrincipalMapping: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "GroupId",
              "GroupMembers"
            ],
            members: {
              IndexId: {},
              DataSourceId: {},
              GroupId: {},
              GroupMembers: {
                type: "structure",
                members: {
                  MemberGroups: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "GroupId"
                      ],
                      members: {
                        GroupId: {},
                        DataSourceId: {}
                      }
                    }
                  },
                  MemberUsers: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "UserId"
                      ],
                      members: {
                        UserId: {}
                      }
                    }
                  },
                  S3PathforGroupMembers: {
                    shape: "S11"
                  }
                }
              },
              OrderingId: {
                type: "long"
              },
              RoleArn: {}
            }
          }
        },
        Query: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "QueryText"
            ],
            members: {
              IndexId: {},
              QueryText: {},
              AttributeFilter: {
                shape: "S92"
              },
              Facets: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DocumentAttributeKey: {}
                  }
                }
              },
              RequestedDocumentAttributes: {
                type: "list",
                member: {}
              },
              QueryResultTypeFilter: {},
              DocumentRelevanceOverrideConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Relevance"
                  ],
                  members: {
                    Name: {},
                    Relevance: {
                      shape: "S6a"
                    }
                  }
                }
              },
              PageNumber: {
                type: "integer"
              },
              PageSize: {
                type: "integer"
              },
              SortingConfiguration: {
                type: "structure",
                required: [
                  "DocumentAttributeKey",
                  "SortOrder"
                ],
                members: {
                  DocumentAttributeKey: {},
                  SortOrder: {}
                }
              },
              UserContext: {
                type: "structure",
                members: {
                  Token: {},
                  UserId: {},
                  Groups: {
                    type: "list",
                    member: {}
                  },
                  DataSourceGroups: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "GroupId",
                        "DataSourceId"
                      ],
                      members: {
                        GroupId: {},
                        DataSourceId: {}
                      }
                    }
                  }
                }
              },
              VisitorId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              QueryId: {},
              ResultItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Type: {},
                    AdditionalAttributes: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Key",
                          "ValueType",
                          "Value"
                        ],
                        members: {
                          Key: {},
                          ValueType: {},
                          Value: {
                            type: "structure",
                            members: {
                              TextWithHighlightsValue: {
                                shape: "S9q"
                              }
                            }
                          }
                        }
                      }
                    },
                    DocumentId: {},
                    DocumentTitle: {
                      shape: "S9q"
                    },
                    DocumentExcerpt: {
                      shape: "S9q"
                    },
                    DocumentURI: {},
                    DocumentAttributes: {
                      shape: "Sg"
                    },
                    ScoreAttributes: {
                      type: "structure",
                      members: {
                        ScoreConfidence: {}
                      }
                    },
                    FeedbackToken: {}
                  }
                }
              },
              FacetResults: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DocumentAttributeKey: {},
                    DocumentAttributeValueType: {},
                    DocumentAttributeValueCountPairs: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          DocumentAttributeValue: {
                            shape: "Sj"
                          },
                          Count: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  }
                }
              },
              TotalNumberOfResults: {
                type: "integer"
              }
            }
          }
        },
        StartDataSourceSyncJob: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExecutionId: {}
            }
          }
        },
        StopDataSourceSyncJob: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              IndexId: {}
            }
          }
        },
        SubmitFeedback: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "QueryId"
            ],
            members: {
              IndexId: {},
              QueryId: {},
              ClickFeedbackItems: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ResultId",
                    "ClickTime"
                  ],
                  members: {
                    ResultId: {},
                    ClickTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              RelevanceFeedbackItems: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ResultId",
                    "RelevanceValue"
                  ],
                  members: {
                    ResultId: {},
                    RelevanceValue: {}
                  }
                }
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S4n"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDataSource: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              Name: {},
              IndexId: {},
              Configuration: {
                shape: "S1j"
              },
              Description: {},
              Schedule: {},
              RoleArn: {},
              LanguageCode: {}
            }
          }
        },
        UpdateIndex: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {},
              Name: {},
              RoleArn: {},
              Description: {},
              DocumentMetadataConfigurationUpdates: {
                shape: "S66"
              },
              CapacityUnits: {
                shape: "S6o"
              },
              UserTokenConfigurations: {
                shape: "S54"
              },
              UserContextPolicy: {},
              UserGroupResolutionConfiguration: {
                shape: "S5e"
              }
            }
          }
        },
        UpdateQuerySuggestionsBlockList: {
          input: {
            type: "structure",
            required: [
              "IndexId",
              "Id"
            ],
            members: {
              IndexId: {},
              Id: {},
              Name: {},
              Description: {},
              SourceS3Path: {
                shape: "S11"
              },
              RoleArn: {}
            }
          }
        },
        UpdateQuerySuggestionsConfig: {
          input: {
            type: "structure",
            required: [
              "IndexId"
            ],
            members: {
              IndexId: {},
              Mode: {},
              QueryLogLookBackWindowInDays: {
                type: "integer"
              },
              IncludeQueriesWithoutUserInformation: {
                type: "boolean"
              },
              MinimumNumberOfQueryingUsers: {
                type: "integer"
              },
              MinimumQueryCount: {
                type: "integer"
              }
            }
          }
        },
        UpdateThesaurus: {
          input: {
            type: "structure",
            required: [
              "Id",
              "IndexId"
            ],
            members: {
              Id: {},
              Name: {},
              IndexId: {},
              Description: {},
              RoleArn: {},
              SourceS3Path: {
                shape: "S11"
              }
            }
          }
        }
      },
      shapes: {
        Sg: {
          type: "list",
          member: {
            shape: "Sh"
          }
        },
        Sh: {
          type: "structure",
          required: [
            "Key",
            "Value"
          ],
          members: {
            Key: {},
            Value: {
              shape: "Sj"
            }
          }
        },
        Sj: {
          type: "structure",
          members: {
            StringValue: {},
            StringListValue: {
              type: "list",
              member: {}
            },
            LongValue: {
              type: "long"
            },
            DateValue: {
              type: "timestamp"
            }
          }
        },
        S11: {
          type: "structure",
          required: [
            "Bucket",
            "Key"
          ],
          members: {
            Bucket: {},
            Key: {}
          }
        },
        S14: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Type",
              "Access"
            ],
            members: {
              Name: {},
              Type: {},
              Access: {},
              DataSourceId: {}
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            S3Configuration: {
              type: "structure",
              required: [
                "BucketName"
              ],
              members: {
                BucketName: {},
                InclusionPrefixes: {
                  shape: "S1l"
                },
                InclusionPatterns: {
                  shape: "S1l"
                },
                ExclusionPatterns: {
                  shape: "S1l"
                },
                DocumentsMetadataConfiguration: {
                  type: "structure",
                  members: {
                    S3Prefix: {}
                  }
                },
                AccessControlListConfiguration: {
                  type: "structure",
                  members: {
                    KeyPath: {}
                  }
                }
              }
            },
            SharePointConfiguration: {
              type: "structure",
              required: [
                "SharePointVersion",
                "Urls",
                "SecretArn"
              ],
              members: {
                SharePointVersion: {},
                Urls: {
                  type: "list",
                  member: {}
                },
                SecretArn: {},
                CrawlAttachments: {
                  type: "boolean"
                },
                UseChangeLog: {
                  type: "boolean"
                },
                InclusionPatterns: {
                  shape: "S1l"
                },
                ExclusionPatterns: {
                  shape: "S1l"
                },
                VpcConfiguration: {
                  shape: "S1v"
                },
                FieldMappings: {
                  shape: "S20"
                },
                DocumentTitleFieldName: {},
                DisableLocalGroups: {
                  type: "boolean"
                },
                SslCertificateS3Path: {
                  shape: "S11"
                }
              }
            },
            DatabaseConfiguration: {
              type: "structure",
              required: [
                "DatabaseEngineType",
                "ConnectionConfiguration",
                "ColumnConfiguration"
              ],
              members: {
                DatabaseEngineType: {},
                ConnectionConfiguration: {
                  type: "structure",
                  required: [
                    "DatabaseHost",
                    "DatabasePort",
                    "DatabaseName",
                    "TableName",
                    "SecretArn"
                  ],
                  members: {
                    DatabaseHost: {},
                    DatabasePort: {
                      type: "integer"
                    },
                    DatabaseName: {},
                    TableName: {},
                    SecretArn: {}
                  }
                },
                VpcConfiguration: {
                  shape: "S1v"
                },
                ColumnConfiguration: {
                  type: "structure",
                  required: [
                    "DocumentIdColumnName",
                    "DocumentDataColumnName",
                    "ChangeDetectingColumns"
                  ],
                  members: {
                    DocumentIdColumnName: {},
                    DocumentDataColumnName: {},
                    DocumentTitleColumnName: {},
                    FieldMappings: {
                      shape: "S20"
                    },
                    ChangeDetectingColumns: {
                      type: "list",
                      member: {}
                    }
                  }
                },
                AclConfiguration: {
                  type: "structure",
                  required: [
                    "AllowedGroupsColumnName"
                  ],
                  members: {
                    AllowedGroupsColumnName: {}
                  }
                },
                SqlConfiguration: {
                  type: "structure",
                  members: {
                    QueryIdentifiersEnclosingOption: {}
                  }
                }
              }
            },
            SalesforceConfiguration: {
              type: "structure",
              required: [
                "ServerUrl",
                "SecretArn"
              ],
              members: {
                ServerUrl: {},
                SecretArn: {},
                StandardObjectConfigurations: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Name",
                      "DocumentDataFieldName"
                    ],
                    members: {
                      Name: {},
                      DocumentDataFieldName: {},
                      DocumentTitleFieldName: {},
                      FieldMappings: {
                        shape: "S20"
                      }
                    }
                  }
                },
                KnowledgeArticleConfiguration: {
                  type: "structure",
                  required: [
                    "IncludedStates"
                  ],
                  members: {
                    IncludedStates: {
                      type: "list",
                      member: {}
                    },
                    StandardKnowledgeArticleTypeConfiguration: {
                      type: "structure",
                      required: [
                        "DocumentDataFieldName"
                      ],
                      members: {
                        DocumentDataFieldName: {},
                        DocumentTitleFieldName: {},
                        FieldMappings: {
                          shape: "S20"
                        }
                      }
                    },
                    CustomKnowledgeArticleTypeConfigurations: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Name",
                          "DocumentDataFieldName"
                        ],
                        members: {
                          Name: {},
                          DocumentDataFieldName: {},
                          DocumentTitleFieldName: {},
                          FieldMappings: {
                            shape: "S20"
                          }
                        }
                      }
                    }
                  }
                },
                ChatterFeedConfiguration: {
                  type: "structure",
                  required: [
                    "DocumentDataFieldName"
                  ],
                  members: {
                    DocumentDataFieldName: {},
                    DocumentTitleFieldName: {},
                    FieldMappings: {
                      shape: "S20"
                    },
                    IncludeFilterTypes: {
                      type: "list",
                      member: {}
                    }
                  }
                },
                CrawlAttachments: {
                  type: "boolean"
                },
                StandardObjectAttachmentConfiguration: {
                  type: "structure",
                  members: {
                    DocumentTitleFieldName: {},
                    FieldMappings: {
                      shape: "S20"
                    }
                  }
                },
                IncludeAttachmentFilePatterns: {
                  shape: "S1l"
                },
                ExcludeAttachmentFilePatterns: {
                  shape: "S1l"
                }
              }
            },
            OneDriveConfiguration: {
              type: "structure",
              required: [
                "TenantDomain",
                "SecretArn",
                "OneDriveUsers"
              ],
              members: {
                TenantDomain: {},
                SecretArn: {},
                OneDriveUsers: {
                  type: "structure",
                  members: {
                    OneDriveUserList: {
                      type: "list",
                      member: {}
                    },
                    OneDriveUserS3Path: {
                      shape: "S11"
                    }
                  }
                },
                InclusionPatterns: {
                  shape: "S1l"
                },
                ExclusionPatterns: {
                  shape: "S1l"
                },
                FieldMappings: {
                  shape: "S20"
                },
                DisableLocalGroups: {
                  type: "boolean"
                }
              }
            },
            ServiceNowConfiguration: {
              type: "structure",
              required: [
                "HostUrl",
                "SecretArn",
                "ServiceNowBuildVersion"
              ],
              members: {
                HostUrl: {},
                SecretArn: {},
                ServiceNowBuildVersion: {},
                KnowledgeArticleConfiguration: {
                  type: "structure",
                  required: [
                    "DocumentDataFieldName"
                  ],
                  members: {
                    CrawlAttachments: {
                      type: "boolean"
                    },
                    IncludeAttachmentFilePatterns: {
                      shape: "S1l"
                    },
                    ExcludeAttachmentFilePatterns: {
                      shape: "S1l"
                    },
                    DocumentDataFieldName: {},
                    DocumentTitleFieldName: {},
                    FieldMappings: {
                      shape: "S20"
                    },
                    FilterQuery: {}
                  }
                },
                ServiceCatalogConfiguration: {
                  type: "structure",
                  required: [
                    "DocumentDataFieldName"
                  ],
                  members: {
                    CrawlAttachments: {
                      type: "boolean"
                    },
                    IncludeAttachmentFilePatterns: {
                      shape: "S1l"
                    },
                    ExcludeAttachmentFilePatterns: {
                      shape: "S1l"
                    },
                    DocumentDataFieldName: {},
                    DocumentTitleFieldName: {},
                    FieldMappings: {
                      shape: "S20"
                    }
                  }
                },
                AuthenticationType: {}
              }
            },
            ConfluenceConfiguration: {
              type: "structure",
              required: [
                "ServerUrl",
                "SecretArn",
                "Version"
              ],
              members: {
                ServerUrl: {},
                SecretArn: {},
                Version: {},
                SpaceConfiguration: {
                  type: "structure",
                  members: {
                    CrawlPersonalSpaces: {
                      type: "boolean"
                    },
                    CrawlArchivedSpaces: {
                      type: "boolean"
                    },
                    IncludeSpaces: {
                      shape: "S3c"
                    },
                    ExcludeSpaces: {
                      shape: "S3c"
                    },
                    SpaceFieldMappings: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          DataSourceFieldName: {},
                          DateFieldFormat: {},
                          IndexFieldName: {}
                        }
                      }
                    }
                  }
                },
                PageConfiguration: {
                  type: "structure",
                  members: {
                    PageFieldMappings: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          DataSourceFieldName: {},
                          DateFieldFormat: {},
                          IndexFieldName: {}
                        }
                      }
                    }
                  }
                },
                BlogConfiguration: {
                  type: "structure",
                  members: {
                    BlogFieldMappings: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          DataSourceFieldName: {},
                          DateFieldFormat: {},
                          IndexFieldName: {}
                        }
                      }
                    }
                  }
                },
                AttachmentConfiguration: {
                  type: "structure",
                  members: {
                    CrawlAttachments: {
                      type: "boolean"
                    },
                    AttachmentFieldMappings: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          DataSourceFieldName: {},
                          DateFieldFormat: {},
                          IndexFieldName: {}
                        }
                      }
                    }
                  }
                },
                VpcConfiguration: {
                  shape: "S1v"
                },
                InclusionPatterns: {
                  shape: "S1l"
                },
                ExclusionPatterns: {
                  shape: "S1l"
                }
              }
            },
            GoogleDriveConfiguration: {
              type: "structure",
              required: [
                "SecretArn"
              ],
              members: {
                SecretArn: {},
                InclusionPatterns: {
                  shape: "S1l"
                },
                ExclusionPatterns: {
                  shape: "S1l"
                },
                FieldMappings: {
                  shape: "S20"
                },
                ExcludeMimeTypes: {
                  type: "list",
                  member: {}
                },
                ExcludeUserAccounts: {
                  type: "list",
                  member: {}
                },
                ExcludeSharedDrives: {
                  type: "list",
                  member: {}
                }
              }
            },
            WebCrawlerConfiguration: {
              type: "structure",
              required: [
                "Urls"
              ],
              members: {
                Urls: {
                  type: "structure",
                  members: {
                    SeedUrlConfiguration: {
                      type: "structure",
                      required: [
                        "SeedUrls"
                      ],
                      members: {
                        SeedUrls: {
                          type: "list",
                          member: {}
                        },
                        WebCrawlerMode: {}
                      }
                    },
                    SiteMapsConfiguration: {
                      type: "structure",
                      required: [
                        "SiteMaps"
                      ],
                      members: {
                        SiteMaps: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                },
                CrawlDepth: {
                  type: "integer"
                },
                MaxLinksPerPage: {
                  type: "integer"
                },
                MaxContentSizePerPageInMegaBytes: {
                  type: "float"
                },
                MaxUrlsPerMinuteCrawlRate: {
                  type: "integer"
                },
                UrlInclusionPatterns: {
                  shape: "S1l"
                },
                UrlExclusionPatterns: {
                  shape: "S1l"
                },
                ProxyConfiguration: {
                  type: "structure",
                  required: [
                    "Host",
                    "Port"
                  ],
                  members: {
                    Host: {},
                    Port: {
                      type: "integer"
                    },
                    Credentials: {}
                  }
                },
                AuthenticationConfiguration: {
                  type: "structure",
                  members: {
                    BasicAuthentication: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Host",
                          "Port",
                          "Credentials"
                        ],
                        members: {
                          Host: {},
                          Port: {
                            type: "integer"
                          },
                          Credentials: {}
                        }
                      }
                    }
                  }
                }
              }
            },
            WorkDocsConfiguration: {
              type: "structure",
              required: [
                "OrganizationId"
              ],
              members: {
                OrganizationId: {},
                CrawlComments: {
                  type: "boolean"
                },
                UseChangeLog: {
                  type: "boolean"
                },
                InclusionPatterns: {
                  shape: "S1l"
                },
                ExclusionPatterns: {
                  shape: "S1l"
                },
                FieldMappings: {
                  shape: "S20"
                }
              }
            }
          }
        },
        S1l: {
          type: "list",
          member: {}
        },
        S1v: {
          type: "structure",
          required: [
            "SubnetIds",
            "SecurityGroupIds"
          ],
          members: {
            SubnetIds: {
              type: "list",
              member: {}
            },
            SecurityGroupIds: {
              type: "list",
              member: {}
            }
          }
        },
        S20: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DataSourceFieldName",
              "IndexFieldName"
            ],
            members: {
              DataSourceFieldName: {},
              DateFieldFormat: {},
              IndexFieldName: {}
            }
          }
        },
        S3c: {
          type: "list",
          member: {}
        },
        S4n: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S52: {
          type: "structure",
          members: {
            KmsKeyId: {
              type: "string",
              sensitive: true
            }
          }
        },
        S54: {
          type: "list",
          member: {
            type: "structure",
            members: {
              JwtTokenTypeConfiguration: {
                type: "structure",
                required: [
                  "KeyLocation"
                ],
                members: {
                  KeyLocation: {},
                  URL: {},
                  SecretManagerArn: {},
                  UserNameAttributeField: {},
                  GroupAttributeField: {},
                  Issuer: {},
                  ClaimRegex: {}
                }
              },
              JsonTokenTypeConfiguration: {
                type: "structure",
                required: [
                  "UserNameAttributeField",
                  "GroupAttributeField"
                ],
                members: {
                  UserNameAttributeField: {},
                  GroupAttributeField: {}
                }
              }
            }
          }
        },
        S5e: {
          type: "structure",
          required: [
            "UserGroupResolutionMode"
          ],
          members: {
            UserGroupResolutionMode: {}
          }
        },
        S66: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name",
              "Type"
            ],
            members: {
              Name: {},
              Type: {},
              Relevance: {
                shape: "S6a"
              },
              Search: {
                type: "structure",
                members: {
                  Facetable: {
                    type: "boolean"
                  },
                  Searchable: {
                    type: "boolean"
                  },
                  Displayable: {
                    type: "boolean"
                  },
                  Sortable: {
                    type: "boolean"
                  }
                }
              }
            }
          }
        },
        S6a: {
          type: "structure",
          members: {
            Freshness: {
              type: "boolean"
            },
            Importance: {
              type: "integer"
            },
            Duration: {},
            RankOrder: {},
            ValueImportanceMap: {
              type: "map",
              key: {},
              value: {
                type: "integer"
              }
            }
          }
        },
        S6o: {
          type: "structure",
          required: [
            "StorageCapacityUnits",
            "QueryCapacityUnits"
          ],
          members: {
            StorageCapacityUnits: {
              type: "integer"
            },
            QueryCapacityUnits: {
              type: "integer"
            }
          }
        },
        S92: {
          type: "structure",
          members: {
            AndAllFilters: {
              shape: "S93"
            },
            OrAllFilters: {
              shape: "S93"
            },
            NotFilter: {
              shape: "S92"
            },
            EqualsTo: {
              shape: "Sh"
            },
            ContainsAll: {
              shape: "Sh"
            },
            ContainsAny: {
              shape: "Sh"
            },
            GreaterThan: {
              shape: "Sh"
            },
            GreaterThanOrEquals: {
              shape: "Sh"
            },
            LessThan: {
              shape: "Sh"
            },
            LessThanOrEquals: {
              shape: "Sh"
            }
          }
        },
        S93: {
          type: "list",
          member: {
            shape: "S92"
          }
        },
        S9q: {
          type: "structure",
          members: {
            Text: {},
            Highlights: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "BeginOffset",
                  "EndOffset"
                ],
                members: {
                  BeginOffset: {
                    type: "integer"
                  },
                  EndOffset: {
                    type: "integer"
                  },
                  TopAnswer: {
                    type: "boolean"
                  },
                  Type: {}
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kendra-2019-02-03.paginators.json
var require_kendra_2019_02_03_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kendra-2019-02-03.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListDataSourceSyncJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDataSources: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListIndices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/kendra.js
var require_kendra = __commonJS({
  "node_modules/aws-sdk/clients/kendra.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["kendra"] = {};
    AWS3.Kendra = Service.defineService("kendra", ["2019-02-03"]);
    Object.defineProperty(apiLoader.services["kendra"], "2019-02-03", {
      get: function get() {
        var model = require_kendra_2019_02_03_min();
        model.paginators = require_kendra_2019_02_03_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Kendra;
  }
});

// node_modules/aws-sdk/apis/networkmanager-2019-07-05.min.json
var require_networkmanager_2019_07_05_min = __commonJS({
  "node_modules/aws-sdk/apis/networkmanager-2019-07-05.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-07-05",
        endpointPrefix: "networkmanager",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "NetworkManager",
        serviceFullName: "AWS Network Manager",
        serviceId: "NetworkManager",
        signatureVersion: "v4",
        signingName: "networkmanager",
        uid: "networkmanager-2019-07-05"
      },
      operations: {
        AssociateCustomerGateway: {
          http: {
            requestUri: "/global-networks/{globalNetworkId}/customer-gateway-associations"
          },
          input: {
            type: "structure",
            required: [
              "CustomerGatewayArn",
              "GlobalNetworkId",
              "DeviceId"
            ],
            members: {
              CustomerGatewayArn: {},
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              DeviceId: {},
              LinkId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CustomerGatewayAssociation: {
                shape: "S4"
              }
            }
          }
        },
        AssociateLink: {
          http: {
            requestUri: "/global-networks/{globalNetworkId}/link-associations"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "DeviceId",
              "LinkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              DeviceId: {},
              LinkId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LinkAssociation: {
                shape: "S8"
              }
            }
          }
        },
        AssociateTransitGatewayConnectPeer: {
          http: {
            requestUri: "/global-networks/{globalNetworkId}/transit-gateway-connect-peer-associations"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "TransitGatewayConnectPeerArn",
              "DeviceId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              TransitGatewayConnectPeerArn: {},
              DeviceId: {},
              LinkId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayConnectPeerAssociation: {
                shape: "Sc"
              }
            }
          }
        },
        CreateConnection: {
          http: {
            requestUri: "/global-networks/{globalNetworkId}/connections"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "DeviceId",
              "ConnectedDeviceId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              DeviceId: {},
              ConnectedDeviceId: {},
              LinkId: {},
              ConnectedLinkId: {},
              Description: {},
              Tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "Sk"
              }
            }
          }
        },
        CreateDevice: {
          http: {
            requestUri: "/global-networks/{globalNetworkId}/devices"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              AWSLocation: {
                shape: "So"
              },
              Description: {},
              Type: {},
              Vendor: {},
              Model: {},
              SerialNumber: {},
              Location: {
                shape: "Sp"
              },
              SiteId: {},
              Tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Device: {
                shape: "Sr"
              }
            }
          }
        },
        CreateGlobalNetwork: {
          http: {
            requestUri: "/global-networks"
          },
          input: {
            type: "structure",
            members: {
              Description: {},
              Tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GlobalNetwork: {
                shape: "Sv"
              }
            }
          }
        },
        CreateLink: {
          http: {
            requestUri: "/global-networks/{globalNetworkId}/links"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "Bandwidth",
              "SiteId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              Description: {},
              Type: {},
              Bandwidth: {
                shape: "Sy"
              },
              Provider: {},
              SiteId: {},
              Tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Link: {
                shape: "S11"
              }
            }
          }
        },
        CreateSite: {
          http: {
            requestUri: "/global-networks/{globalNetworkId}/sites"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              Description: {},
              Location: {
                shape: "Sp"
              },
              Tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Site: {
                shape: "S15"
              }
            }
          }
        },
        DeleteConnection: {
          http: {
            method: "DELETE",
            requestUri: "/global-networks/{globalNetworkId}/connections/{connectionId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "ConnectionId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              ConnectionId: {
                location: "uri",
                locationName: "connectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "Sk"
              }
            }
          }
        },
        DeleteDevice: {
          http: {
            method: "DELETE",
            requestUri: "/global-networks/{globalNetworkId}/devices/{deviceId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "DeviceId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              DeviceId: {
                location: "uri",
                locationName: "deviceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Device: {
                shape: "Sr"
              }
            }
          }
        },
        DeleteGlobalNetwork: {
          http: {
            method: "DELETE",
            requestUri: "/global-networks/{globalNetworkId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GlobalNetwork: {
                shape: "Sv"
              }
            }
          }
        },
        DeleteLink: {
          http: {
            method: "DELETE",
            requestUri: "/global-networks/{globalNetworkId}/links/{linkId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "LinkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              LinkId: {
                location: "uri",
                locationName: "linkId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Link: {
                shape: "S11"
              }
            }
          }
        },
        DeleteSite: {
          http: {
            method: "DELETE",
            requestUri: "/global-networks/{globalNetworkId}/sites/{siteId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "SiteId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              SiteId: {
                location: "uri",
                locationName: "siteId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Site: {
                shape: "S15"
              }
            }
          }
        },
        DeregisterTransitGateway: {
          http: {
            method: "DELETE",
            requestUri: "/global-networks/{globalNetworkId}/transit-gateway-registrations/{transitGatewayArn}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "TransitGatewayArn"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              TransitGatewayArn: {
                location: "uri",
                locationName: "transitGatewayArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayRegistration: {
                shape: "S1j"
              }
            }
          }
        },
        DescribeGlobalNetworks: {
          http: {
            method: "GET",
            requestUri: "/global-networks"
          },
          input: {
            type: "structure",
            members: {
              GlobalNetworkIds: {
                shape: "S1n",
                location: "querystring",
                locationName: "globalNetworkIds"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GlobalNetworks: {
                type: "list",
                member: {
                  shape: "Sv"
                }
              },
              NextToken: {}
            }
          }
        },
        DisassociateCustomerGateway: {
          http: {
            method: "DELETE",
            requestUri: "/global-networks/{globalNetworkId}/customer-gateway-associations/{customerGatewayArn}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "CustomerGatewayArn"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              CustomerGatewayArn: {
                location: "uri",
                locationName: "customerGatewayArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CustomerGatewayAssociation: {
                shape: "S4"
              }
            }
          }
        },
        DisassociateLink: {
          http: {
            method: "DELETE",
            requestUri: "/global-networks/{globalNetworkId}/link-associations"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "DeviceId",
              "LinkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              DeviceId: {
                location: "querystring",
                locationName: "deviceId"
              },
              LinkId: {
                location: "querystring",
                locationName: "linkId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LinkAssociation: {
                shape: "S8"
              }
            }
          }
        },
        DisassociateTransitGatewayConnectPeer: {
          http: {
            method: "DELETE",
            requestUri: "/global-networks/{globalNetworkId}/transit-gateway-connect-peer-associations/{transitGatewayConnectPeerArn}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "TransitGatewayConnectPeerArn"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              TransitGatewayConnectPeerArn: {
                location: "uri",
                locationName: "transitGatewayConnectPeerArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayConnectPeerAssociation: {
                shape: "Sc"
              }
            }
          }
        },
        GetConnections: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/connections"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              ConnectionIds: {
                shape: "S1n",
                location: "querystring",
                locationName: "connectionIds"
              },
              DeviceId: {
                location: "querystring",
                locationName: "deviceId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connections: {
                type: "list",
                member: {
                  shape: "Sk"
                }
              },
              NextToken: {}
            }
          }
        },
        GetCustomerGatewayAssociations: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/customer-gateway-associations"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              CustomerGatewayArns: {
                shape: "S1n",
                location: "querystring",
                locationName: "customerGatewayArns"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CustomerGatewayAssociations: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              NextToken: {}
            }
          }
        },
        GetDevices: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/devices"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              DeviceIds: {
                shape: "S1n",
                location: "querystring",
                locationName: "deviceIds"
              },
              SiteId: {
                location: "querystring",
                locationName: "siteId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Devices: {
                type: "list",
                member: {
                  shape: "Sr"
                }
              },
              NextToken: {}
            }
          }
        },
        GetLinkAssociations: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/link-associations"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              DeviceId: {
                location: "querystring",
                locationName: "deviceId"
              },
              LinkId: {
                location: "querystring",
                locationName: "linkId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LinkAssociations: {
                type: "list",
                member: {
                  shape: "S8"
                }
              },
              NextToken: {}
            }
          }
        },
        GetLinks: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/links"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              LinkIds: {
                shape: "S1n",
                location: "querystring",
                locationName: "linkIds"
              },
              SiteId: {
                location: "querystring",
                locationName: "siteId"
              },
              Type: {
                location: "querystring",
                locationName: "type"
              },
              Provider: {
                location: "querystring",
                locationName: "provider"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Links: {
                type: "list",
                member: {
                  shape: "S11"
                }
              },
              NextToken: {}
            }
          }
        },
        GetSites: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/sites"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              SiteIds: {
                shape: "S1n",
                location: "querystring",
                locationName: "siteIds"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Sites: {
                type: "list",
                member: {
                  shape: "S15"
                }
              },
              NextToken: {}
            }
          }
        },
        GetTransitGatewayConnectPeerAssociations: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/transit-gateway-connect-peer-associations"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              TransitGatewayConnectPeerArns: {
                shape: "S1n",
                location: "querystring",
                locationName: "transitGatewayConnectPeerArns"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayConnectPeerAssociations: {
                type: "list",
                member: {
                  shape: "Sc"
                }
              },
              NextToken: {}
            }
          }
        },
        GetTransitGatewayRegistrations: {
          http: {
            method: "GET",
            requestUri: "/global-networks/{globalNetworkId}/transit-gateway-registrations"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              TransitGatewayArns: {
                shape: "S1n",
                location: "querystring",
                locationName: "transitGatewayArns"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayRegistrations: {
                type: "list",
                member: {
                  shape: "S1j"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "Sf"
              }
            }
          }
        },
        RegisterTransitGateway: {
          http: {
            requestUri: "/global-networks/{globalNetworkId}/transit-gateway-registrations"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "TransitGatewayArn"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              TransitGatewayArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TransitGatewayRegistration: {
                shape: "S1j"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateConnection: {
          http: {
            method: "PATCH",
            requestUri: "/global-networks/{globalNetworkId}/connections/{connectionId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "ConnectionId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              ConnectionId: {
                location: "uri",
                locationName: "connectionId"
              },
              LinkId: {},
              ConnectedLinkId: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "Sk"
              }
            }
          }
        },
        UpdateDevice: {
          http: {
            method: "PATCH",
            requestUri: "/global-networks/{globalNetworkId}/devices/{deviceId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "DeviceId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              DeviceId: {
                location: "uri",
                locationName: "deviceId"
              },
              AWSLocation: {
                shape: "So"
              },
              Description: {},
              Type: {},
              Vendor: {},
              Model: {},
              SerialNumber: {},
              Location: {
                shape: "Sp"
              },
              SiteId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Device: {
                shape: "Sr"
              }
            }
          }
        },
        UpdateGlobalNetwork: {
          http: {
            method: "PATCH",
            requestUri: "/global-networks/{globalNetworkId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              GlobalNetwork: {
                shape: "Sv"
              }
            }
          }
        },
        UpdateLink: {
          http: {
            method: "PATCH",
            requestUri: "/global-networks/{globalNetworkId}/links/{linkId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "LinkId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              LinkId: {
                location: "uri",
                locationName: "linkId"
              },
              Description: {},
              Type: {},
              Bandwidth: {
                shape: "Sy"
              },
              Provider: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Link: {
                shape: "S11"
              }
            }
          }
        },
        UpdateSite: {
          http: {
            method: "PATCH",
            requestUri: "/global-networks/{globalNetworkId}/sites/{siteId}"
          },
          input: {
            type: "structure",
            required: [
              "GlobalNetworkId",
              "SiteId"
            ],
            members: {
              GlobalNetworkId: {
                location: "uri",
                locationName: "globalNetworkId"
              },
              SiteId: {
                location: "uri",
                locationName: "siteId"
              },
              Description: {},
              Location: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Site: {
                shape: "S15"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            CustomerGatewayArn: {},
            GlobalNetworkId: {},
            DeviceId: {},
            LinkId: {},
            State: {}
          }
        },
        S8: {
          type: "structure",
          members: {
            GlobalNetworkId: {},
            DeviceId: {},
            LinkId: {},
            LinkAssociationState: {}
          }
        },
        Sc: {
          type: "structure",
          members: {
            TransitGatewayConnectPeerArn: {},
            GlobalNetworkId: {},
            DeviceId: {},
            LinkId: {},
            State: {}
          }
        },
        Sf: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sk: {
          type: "structure",
          members: {
            ConnectionId: {},
            ConnectionArn: {},
            GlobalNetworkId: {},
            DeviceId: {},
            ConnectedDeviceId: {},
            LinkId: {},
            ConnectedLinkId: {},
            Description: {},
            CreatedAt: {
              type: "timestamp"
            },
            State: {},
            Tags: {
              shape: "Sf"
            }
          }
        },
        So: {
          type: "structure",
          members: {
            Zone: {},
            SubnetArn: {}
          }
        },
        Sp: {
          type: "structure",
          members: {
            Address: {},
            Latitude: {},
            Longitude: {}
          },
          sensitive: true
        },
        Sr: {
          type: "structure",
          members: {
            DeviceId: {},
            DeviceArn: {},
            GlobalNetworkId: {},
            AWSLocation: {
              shape: "So"
            },
            Description: {},
            Type: {},
            Vendor: {},
            Model: {},
            SerialNumber: {},
            Location: {
              shape: "Sp"
            },
            SiteId: {},
            CreatedAt: {
              type: "timestamp"
            },
            State: {},
            Tags: {
              shape: "Sf"
            }
          }
        },
        Sv: {
          type: "structure",
          members: {
            GlobalNetworkId: {},
            GlobalNetworkArn: {},
            Description: {},
            CreatedAt: {
              type: "timestamp"
            },
            State: {},
            Tags: {
              shape: "Sf"
            }
          }
        },
        Sy: {
          type: "structure",
          members: {
            UploadSpeed: {
              type: "integer"
            },
            DownloadSpeed: {
              type: "integer"
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            LinkId: {},
            LinkArn: {},
            GlobalNetworkId: {},
            SiteId: {},
            Description: {},
            Type: {},
            Bandwidth: {
              shape: "Sy"
            },
            Provider: {},
            CreatedAt: {
              type: "timestamp"
            },
            State: {},
            Tags: {
              shape: "Sf"
            }
          }
        },
        S15: {
          type: "structure",
          members: {
            SiteId: {},
            SiteArn: {},
            GlobalNetworkId: {},
            Description: {},
            Location: {
              shape: "Sp"
            },
            CreatedAt: {
              type: "timestamp"
            },
            State: {},
            Tags: {
              shape: "Sf"
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            GlobalNetworkId: {},
            TransitGatewayArn: {},
            State: {
              type: "structure",
              members: {
                Code: {},
                Message: {}
              }
            }
          }
        },
        S1n: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/networkmanager-2019-07-05.paginators.json
var require_networkmanager_2019_07_05_paginators = __commonJS({
  "node_modules/aws-sdk/apis/networkmanager-2019-07-05.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeGlobalNetworks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "GlobalNetworks"
        },
        GetConnections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Connections"
        },
        GetCustomerGatewayAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "CustomerGatewayAssociations"
        },
        GetDevices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Devices"
        },
        GetLinkAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "LinkAssociations"
        },
        GetLinks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Links"
        },
        GetSites: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Sites"
        },
        GetTransitGatewayConnectPeerAssociations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TransitGatewayConnectPeerAssociations"
        },
        GetTransitGatewayRegistrations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "TransitGatewayRegistrations"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/networkmanager.js
var require_networkmanager = __commonJS({
  "node_modules/aws-sdk/clients/networkmanager.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["networkmanager"] = {};
    AWS3.NetworkManager = Service.defineService("networkmanager", ["2019-07-05"]);
    Object.defineProperty(apiLoader.services["networkmanager"], "2019-07-05", {
      get: function get() {
        var model = require_networkmanager_2019_07_05_min();
        model.paginators = require_networkmanager_2019_07_05_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.NetworkManager;
  }
});

// node_modules/aws-sdk/apis/outposts-2019-12-03.min.json
var require_outposts_2019_12_03_min = __commonJS({
  "node_modules/aws-sdk/apis/outposts-2019-12-03.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-12-03",
        endpointPrefix: "outposts",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Outposts",
        serviceFullName: "AWS Outposts",
        serviceId: "Outposts",
        signatureVersion: "v4",
        signingName: "outposts",
        uid: "outposts-2019-12-03"
      },
      operations: {
        CreateOrder: {
          http: {
            requestUri: "/orders"
          },
          input: {
            type: "structure",
            required: [
              "OutpostIdentifier",
              "LineItems",
              "PaymentOption"
            ],
            members: {
              OutpostIdentifier: {},
              LineItems: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CatalogItemId: {},
                    Quantity: {
                      type: "integer"
                    }
                  }
                }
              },
              PaymentOption: {},
              PaymentTerm: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Order: {
                type: "structure",
                members: {
                  OutpostId: {},
                  OrderId: {},
                  Status: {},
                  LineItems: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        CatalogItemId: {},
                        LineItemId: {},
                        Quantity: {
                          type: "integer"
                        },
                        Status: {}
                      }
                    }
                  },
                  PaymentOption: {},
                  OrderSubmissionDate: {
                    type: "timestamp"
                  },
                  OrderFulfilledDate: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        CreateOutpost: {
          http: {
            requestUri: "/outposts"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "SiteId"
            ],
            members: {
              Name: {},
              Description: {},
              SiteId: {},
              AvailabilityZone: {},
              AvailabilityZoneId: {},
              Tags: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Outpost: {
                shape: "St"
              }
            }
          }
        },
        DeleteOutpost: {
          http: {
            method: "DELETE",
            requestUri: "/outposts/{OutpostId}"
          },
          input: {
            type: "structure",
            required: [
              "OutpostId"
            ],
            members: {
              OutpostId: {
                location: "uri",
                locationName: "OutpostId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSite: {
          http: {
            method: "DELETE",
            requestUri: "/sites/{SiteId}"
          },
          input: {
            type: "structure",
            required: [
              "SiteId"
            ],
            members: {
              SiteId: {
                location: "uri",
                locationName: "SiteId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetOutpost: {
          http: {
            method: "GET",
            requestUri: "/outposts/{OutpostId}"
          },
          input: {
            type: "structure",
            required: [
              "OutpostId"
            ],
            members: {
              OutpostId: {
                location: "uri",
                locationName: "OutpostId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Outpost: {
                shape: "St"
              }
            }
          }
        },
        GetOutpostInstanceTypes: {
          http: {
            method: "GET",
            requestUri: "/outposts/{OutpostId}/instanceTypes"
          },
          input: {
            type: "structure",
            required: [
              "OutpostId"
            ],
            members: {
              OutpostId: {
                location: "uri",
                locationName: "OutpostId"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceTypes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InstanceType: {}
                  }
                }
              },
              NextToken: {},
              OutpostId: {},
              OutpostArn: {}
            }
          }
        },
        ListOutposts: {
          http: {
            method: "GET",
            requestUri: "/outposts"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              LifeCycleStatusFilter: {
                location: "querystring",
                locationName: "LifeCycleStatusFilter",
                type: "list",
                member: {}
              },
              AvailabilityZoneFilter: {
                location: "querystring",
                locationName: "AvailabilityZoneFilter",
                type: "list",
                member: {}
              },
              AvailabilityZoneIdFilter: {
                location: "querystring",
                locationName: "AvailabilityZoneIdFilter",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Outposts: {
                type: "list",
                member: {
                  shape: "St"
                }
              },
              NextToken: {}
            }
          }
        },
        ListSites: {
          http: {
            method: "GET",
            requestUri: "/sites"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Sites: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SiteId: {},
                    AccountId: {},
                    Name: {},
                    Description: {},
                    Tags: {
                      shape: "Sp"
                    },
                    SiteArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sp"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sp: {
          type: "map",
          key: {},
          value: {}
        },
        St: {
          type: "structure",
          members: {
            OutpostId: {},
            OwnerId: {},
            OutpostArn: {},
            SiteId: {},
            Name: {},
            Description: {},
            LifeCycleStatus: {},
            AvailabilityZone: {},
            AvailabilityZoneId: {},
            Tags: {
              shape: "Sp"
            },
            SiteArn: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/outposts-2019-12-03.paginators.json
var require_outposts_2019_12_03_paginators = __commonJS({
  "node_modules/aws-sdk/apis/outposts-2019-12-03.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListOutposts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSites: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/outposts.js
var require_outposts = __commonJS({
  "node_modules/aws-sdk/clients/outposts.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["outposts"] = {};
    AWS3.Outposts = Service.defineService("outposts", ["2019-12-03"]);
    Object.defineProperty(apiLoader.services["outposts"], "2019-12-03", {
      get: function get() {
        var model = require_outposts_2019_12_03_min();
        model.paginators = require_outposts_2019_12_03_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Outposts;
  }
});

// node_modules/aws-sdk/apis/sagemaker-a2i-runtime-2019-11-07.min.json
var require_sagemaker_a2i_runtime_2019_11_07_min = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-a2i-runtime-2019-11-07.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-11-07",
        endpointPrefix: "a2i-runtime.sagemaker",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Augmented AI Runtime",
        serviceId: "SageMaker A2I Runtime",
        signatureVersion: "v4",
        signingName: "sagemaker",
        uid: "sagemaker-a2i-runtime-2019-11-07"
      },
      operations: {
        DeleteHumanLoop: {
          http: {
            method: "DELETE",
            requestUri: "/human-loops/{HumanLoopName}"
          },
          input: {
            type: "structure",
            required: [
              "HumanLoopName"
            ],
            members: {
              HumanLoopName: {
                location: "uri",
                locationName: "HumanLoopName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeHumanLoop: {
          http: {
            method: "GET",
            requestUri: "/human-loops/{HumanLoopName}"
          },
          input: {
            type: "structure",
            required: [
              "HumanLoopName"
            ],
            members: {
              HumanLoopName: {
                location: "uri",
                locationName: "HumanLoopName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreationTime",
              "HumanLoopStatus",
              "HumanLoopName",
              "HumanLoopArn",
              "FlowDefinitionArn"
            ],
            members: {
              CreationTime: {
                type: "timestamp"
              },
              FailureReason: {},
              FailureCode: {},
              HumanLoopStatus: {},
              HumanLoopName: {},
              HumanLoopArn: {},
              FlowDefinitionArn: {},
              HumanLoopOutput: {
                type: "structure",
                required: [
                  "OutputS3Uri"
                ],
                members: {
                  OutputS3Uri: {}
                }
              }
            }
          }
        },
        ListHumanLoops: {
          http: {
            method: "GET",
            requestUri: "/human-loops"
          },
          input: {
            type: "structure",
            required: [
              "FlowDefinitionArn"
            ],
            members: {
              CreationTimeAfter: {
                location: "querystring",
                locationName: "CreationTimeAfter",
                type: "timestamp"
              },
              CreationTimeBefore: {
                location: "querystring",
                locationName: "CreationTimeBefore",
                type: "timestamp"
              },
              FlowDefinitionArn: {
                location: "querystring",
                locationName: "FlowDefinitionArn"
              },
              SortOrder: {
                location: "querystring",
                locationName: "SortOrder"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "HumanLoopSummaries"
            ],
            members: {
              HumanLoopSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    HumanLoopName: {},
                    HumanLoopStatus: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    FailureReason: {},
                    FlowDefinitionArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        StartHumanLoop: {
          http: {
            requestUri: "/human-loops"
          },
          input: {
            type: "structure",
            required: [
              "HumanLoopName",
              "FlowDefinitionArn",
              "HumanLoopInput"
            ],
            members: {
              HumanLoopName: {},
              FlowDefinitionArn: {},
              HumanLoopInput: {
                type: "structure",
                required: [
                  "InputContent"
                ],
                members: {
                  InputContent: {}
                }
              },
              DataAttributes: {
                type: "structure",
                required: [
                  "ContentClassifiers"
                ],
                members: {
                  ContentClassifiers: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HumanLoopArn: {}
            }
          }
        },
        StopHumanLoop: {
          http: {
            requestUri: "/human-loops/stop"
          },
          input: {
            type: "structure",
            required: [
              "HumanLoopName"
            ],
            members: {
              HumanLoopName: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/sagemaker-a2i-runtime-2019-11-07.paginators.json
var require_sagemaker_a2i_runtime_2019_11_07_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-a2i-runtime-2019-11-07.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListHumanLoops: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "HumanLoopSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/augmentedairuntime.js
var require_augmentedairuntime = __commonJS({
  "node_modules/aws-sdk/clients/augmentedairuntime.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["augmentedairuntime"] = {};
    AWS3.AugmentedAIRuntime = Service.defineService("augmentedairuntime", ["2019-11-07"]);
    Object.defineProperty(apiLoader.services["augmentedairuntime"], "2019-11-07", {
      get: function get() {
        var model = require_sagemaker_a2i_runtime_2019_11_07_min();
        model.paginators = require_sagemaker_a2i_runtime_2019_11_07_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.AugmentedAIRuntime;
  }
});

// node_modules/aws-sdk/apis/ebs-2019-11-02.min.json
var require_ebs_2019_11_02_min = __commonJS({
  "node_modules/aws-sdk/apis/ebs-2019-11-02.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-11-02",
        endpointPrefix: "ebs",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon EBS",
        serviceFullName: "Amazon Elastic Block Store",
        serviceId: "EBS",
        signatureVersion: "v4",
        uid: "ebs-2019-11-02"
      },
      operations: {
        CompleteSnapshot: {
          http: {
            requestUri: "/snapshots/completion/{snapshotId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "SnapshotId",
              "ChangedBlocksCount"
            ],
            members: {
              SnapshotId: {
                location: "uri",
                locationName: "snapshotId"
              },
              ChangedBlocksCount: {
                location: "header",
                locationName: "x-amz-ChangedBlocksCount",
                type: "integer"
              },
              Checksum: {
                location: "header",
                locationName: "x-amz-Checksum"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-Checksum-Algorithm"
              },
              ChecksumAggregationMethod: {
                location: "header",
                locationName: "x-amz-Checksum-Aggregation-Method"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        },
        GetSnapshotBlock: {
          http: {
            method: "GET",
            requestUri: "/snapshots/{snapshotId}/blocks/{blockIndex}"
          },
          input: {
            type: "structure",
            required: [
              "SnapshotId",
              "BlockIndex",
              "BlockToken"
            ],
            members: {
              SnapshotId: {
                location: "uri",
                locationName: "snapshotId"
              },
              BlockIndex: {
                location: "uri",
                locationName: "blockIndex",
                type: "integer"
              },
              BlockToken: {
                location: "querystring",
                locationName: "blockToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataLength: {
                location: "header",
                locationName: "x-amz-Data-Length",
                type: "integer"
              },
              BlockData: {
                shape: "Se"
              },
              Checksum: {
                location: "header",
                locationName: "x-amz-Checksum"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-Checksum-Algorithm"
              }
            },
            payload: "BlockData"
          }
        },
        ListChangedBlocks: {
          http: {
            method: "GET",
            requestUri: "/snapshots/{secondSnapshotId}/changedblocks"
          },
          input: {
            type: "structure",
            required: [
              "SecondSnapshotId"
            ],
            members: {
              FirstSnapshotId: {
                location: "querystring",
                locationName: "firstSnapshotId"
              },
              SecondSnapshotId: {
                location: "uri",
                locationName: "secondSnapshotId"
              },
              NextToken: {
                location: "querystring",
                locationName: "pageToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              StartingBlockIndex: {
                location: "querystring",
                locationName: "startingBlockIndex",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChangedBlocks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    BlockIndex: {
                      type: "integer"
                    },
                    FirstBlockToken: {},
                    SecondBlockToken: {}
                  },
                  sensitive: true
                }
              },
              ExpiryTime: {
                type: "timestamp"
              },
              VolumeSize: {
                type: "long"
              },
              BlockSize: {
                type: "integer"
              },
              NextToken: {}
            }
          }
        },
        ListSnapshotBlocks: {
          http: {
            method: "GET",
            requestUri: "/snapshots/{snapshotId}/blocks"
          },
          input: {
            type: "structure",
            required: [
              "SnapshotId"
            ],
            members: {
              SnapshotId: {
                location: "uri",
                locationName: "snapshotId"
              },
              NextToken: {
                location: "querystring",
                locationName: "pageToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              StartingBlockIndex: {
                location: "querystring",
                locationName: "startingBlockIndex",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Blocks: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    BlockIndex: {
                      type: "integer"
                    },
                    BlockToken: {}
                  }
                },
                sensitive: true
              },
              ExpiryTime: {
                type: "timestamp"
              },
              VolumeSize: {
                type: "long"
              },
              BlockSize: {
                type: "integer"
              },
              NextToken: {}
            }
          }
        },
        PutSnapshotBlock: {
          http: {
            method: "PUT",
            requestUri: "/snapshots/{snapshotId}/blocks/{blockIndex}",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "SnapshotId",
              "BlockIndex",
              "BlockData",
              "DataLength",
              "Checksum",
              "ChecksumAlgorithm"
            ],
            members: {
              SnapshotId: {
                location: "uri",
                locationName: "snapshotId"
              },
              BlockIndex: {
                location: "uri",
                locationName: "blockIndex",
                type: "integer"
              },
              BlockData: {
                shape: "Se"
              },
              DataLength: {
                location: "header",
                locationName: "x-amz-Data-Length",
                type: "integer"
              },
              Progress: {
                location: "header",
                locationName: "x-amz-Progress",
                type: "integer"
              },
              Checksum: {
                location: "header",
                locationName: "x-amz-Checksum"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-Checksum-Algorithm"
              }
            },
            payload: "BlockData"
          },
          output: {
            type: "structure",
            members: {
              Checksum: {
                location: "header",
                locationName: "x-amz-Checksum"
              },
              ChecksumAlgorithm: {
                location: "header",
                locationName: "x-amz-Checksum-Algorithm"
              }
            }
          },
          authtype: "v4-unsigned-body"
        },
        StartSnapshot: {
          http: {
            requestUri: "/snapshots",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "VolumeSize"
            ],
            members: {
              VolumeSize: {
                type: "long"
              },
              ParentSnapshotId: {},
              Tags: {
                shape: "Sw"
              },
              Description: {},
              ClientToken: {
                idempotencyToken: true
              },
              Encrypted: {
                type: "boolean"
              },
              KmsKeyArn: {
                shape: "S13"
              },
              Timeout: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Description: {},
              SnapshotId: {},
              OwnerId: {},
              Status: {},
              StartTime: {
                type: "timestamp"
              },
              VolumeSize: {
                type: "long"
              },
              BlockSize: {
                type: "integer"
              },
              Tags: {
                shape: "Sw"
              },
              ParentSnapshotId: {},
              KmsKeyArn: {
                shape: "S13"
              }
            }
          }
        }
      },
      shapes: {
        Se: {
          type: "blob",
          sensitive: true,
          streaming: true
        },
        Sw: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S13: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ebs-2019-11-02.paginators.json
var require_ebs_2019_11_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ebs-2019-11-02.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListChangedBlocks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSnapshotBlocks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ebs.js
var require_ebs = __commonJS({
  "node_modules/aws-sdk/clients/ebs.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["ebs"] = {};
    AWS3.EBS = Service.defineService("ebs", ["2019-11-02"]);
    Object.defineProperty(apiLoader.services["ebs"], "2019-11-02", {
      get: function get() {
        var model = require_ebs_2019_11_02_min();
        model.paginators = require_ebs_2019_11_02_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.EBS;
  }
});

// node_modules/aws-sdk/apis/kinesis-video-signaling-2019-12-04.min.json
var require_kinesis_video_signaling_2019_12_04_min = __commonJS({
  "node_modules/aws-sdk/apis/kinesis-video-signaling-2019-12-04.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-12-04",
        endpointPrefix: "kinesisvideo",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon Kinesis Video Signaling Channels",
        serviceFullName: "Amazon Kinesis Video Signaling Channels",
        serviceId: "Kinesis Video Signaling",
        signatureVersion: "v4",
        uid: "kinesis-video-signaling-2019-12-04"
      },
      operations: {
        GetIceServerConfig: {
          http: {
            requestUri: "/v1/get-ice-server-config"
          },
          input: {
            type: "structure",
            required: [
              "ChannelARN"
            ],
            members: {
              ChannelARN: {},
              ClientId: {},
              Service: {},
              Username: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IceServerList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Uris: {
                      type: "list",
                      member: {}
                    },
                    Username: {},
                    Password: {},
                    Ttl: {
                      type: "integer"
                    }
                  }
                }
              }
            }
          }
        },
        SendAlexaOfferToMaster: {
          http: {
            requestUri: "/v1/send-alexa-offer-to-master"
          },
          input: {
            type: "structure",
            required: [
              "ChannelARN",
              "SenderClientId",
              "MessagePayload"
            ],
            members: {
              ChannelARN: {},
              SenderClientId: {},
              MessagePayload: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Answer: {}
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/kinesis-video-signaling-2019-12-04.paginators.json
var require_kinesis_video_signaling_2019_12_04_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kinesis-video-signaling-2019-12-04.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/kinesisvideosignalingchannels.js
var require_kinesisvideosignalingchannels = __commonJS({
  "node_modules/aws-sdk/clients/kinesisvideosignalingchannels.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["kinesisvideosignalingchannels"] = {};
    AWS3.KinesisVideoSignalingChannels = Service.defineService("kinesisvideosignalingchannels", ["2019-12-04"]);
    Object.defineProperty(apiLoader.services["kinesisvideosignalingchannels"], "2019-12-04", {
      get: function get() {
        var model = require_kinesis_video_signaling_2019_12_04_min();
        model.paginators = require_kinesis_video_signaling_2019_12_04_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.KinesisVideoSignalingChannels;
  }
});

// node_modules/aws-sdk/apis/detective-2018-10-26.min.json
var require_detective_2018_10_26_min = __commonJS({
  "node_modules/aws-sdk/apis/detective-2018-10-26.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-10-26",
        endpointPrefix: "api.detective",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Detective",
        serviceId: "Detective",
        signatureVersion: "v4",
        signingName: "detective",
        uid: "detective-2018-10-26"
      },
      operations: {
        AcceptInvitation: {
          http: {
            method: "PUT",
            requestUri: "/invitation"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn"
            ],
            members: {
              GraphArn: {}
            }
          }
        },
        CreateGraph: {
          http: {
            requestUri: "/graph"
          },
          input: {
            type: "structure",
            members: {
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GraphArn: {}
            }
          }
        },
        CreateMembers: {
          http: {
            requestUri: "/graph/members"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn",
              "Accounts"
            ],
            members: {
              GraphArn: {},
              Message: {},
              DisableEmailNotification: {
                type: "boolean"
              },
              Accounts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "AccountId",
                    "EmailAddress"
                  ],
                  members: {
                    AccountId: {},
                    EmailAddress: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Members: {
                shape: "Sg"
              },
              UnprocessedAccounts: {
                shape: "Sn"
              }
            }
          }
        },
        DeleteGraph: {
          http: {
            requestUri: "/graph/removal"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn"
            ],
            members: {
              GraphArn: {}
            }
          }
        },
        DeleteMembers: {
          http: {
            requestUri: "/graph/members/removal"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn",
              "AccountIds"
            ],
            members: {
              GraphArn: {},
              AccountIds: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccountIds: {
                shape: "Ss"
              },
              UnprocessedAccounts: {
                shape: "Sn"
              }
            }
          }
        },
        DisassociateMembership: {
          http: {
            requestUri: "/membership/removal"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn"
            ],
            members: {
              GraphArn: {}
            }
          }
        },
        GetMembers: {
          http: {
            requestUri: "/graph/members/get"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn",
              "AccountIds"
            ],
            members: {
              GraphArn: {},
              AccountIds: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MemberDetails: {
                shape: "Sg"
              },
              UnprocessedAccounts: {
                shape: "Sn"
              }
            }
          }
        },
        ListGraphs: {
          http: {
            requestUri: "/graphs/list"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              GraphList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreatedTime: {
                      shape: "Sk"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListInvitations: {
          http: {
            requestUri: "/invitations/list"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Invitations: {
                shape: "Sg"
              },
              NextToken: {}
            }
          }
        },
        ListMembers: {
          http: {
            requestUri: "/graph/members/list"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn"
            ],
            members: {
              GraphArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MemberDetails: {
                shape: "Sg"
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S4"
              }
            }
          }
        },
        RejectInvitation: {
          http: {
            requestUri: "/invitation/removal"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn"
            ],
            members: {
              GraphArn: {}
            }
          }
        },
        StartMonitoringMember: {
          http: {
            requestUri: "/graph/member/monitoringstate"
          },
          input: {
            type: "structure",
            required: [
              "GraphArn",
              "AccountId"
            ],
            members: {
              GraphArn: {},
              AccountId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S4: {
          type: "map",
          key: {},
          value: {}
        },
        Sg: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AccountId: {},
              EmailAddress: {},
              GraphArn: {},
              MasterId: {
                deprecated: true,
                deprecatedMessage: "This property is deprecated. Use AdministratorId instead."
              },
              AdministratorId: {},
              Status: {},
              DisabledReason: {},
              InvitedTime: {
                shape: "Sk"
              },
              UpdatedTime: {
                shape: "Sk"
              },
              VolumeUsageInBytes: {
                type: "long"
              },
              VolumeUsageUpdatedTime: {
                shape: "Sk"
              },
              PercentOfGraphUtilization: {
                deprecated: true,
                deprecatedMessage: "This property is deprecated. Use VolumeUsageInBytes instead.",
                type: "double"
              },
              PercentOfGraphUtilizationUpdatedTime: {
                shape: "Sk",
                deprecated: true,
                deprecatedMessage: "This property is deprecated. Use VolumeUsageUpdatedTime instead."
              }
            }
          }
        },
        Sk: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sn: {
          type: "list",
          member: {
            type: "structure",
            members: {
              AccountId: {},
              Reason: {}
            }
          }
        },
        Ss: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/detective-2018-10-26.paginators.json
var require_detective_2018_10_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/detective-2018-10-26.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListGraphs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListInvitations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMembers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/detective.js
var require_detective = __commonJS({
  "node_modules/aws-sdk/clients/detective.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["detective"] = {};
    AWS3.Detective = Service.defineService("detective", ["2018-10-26"]);
    Object.defineProperty(apiLoader.services["detective"], "2018-10-26", {
      get: function get() {
        var model = require_detective_2018_10_26_min();
        model.paginators = require_detective_2018_10_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Detective;
  }
});

// node_modules/aws-sdk/apis/codestar-connections-2019-12-01.min.json
var require_codestar_connections_2019_12_01_min = __commonJS({
  "node_modules/aws-sdk/apis/codestar-connections-2019-12-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-12-01",
        endpointPrefix: "codestar-connections",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "AWS CodeStar connections",
        serviceId: "CodeStar connections",
        signatureVersion: "v4",
        signingName: "codestar-connections",
        targetPrefix: "com.amazonaws.codestar.connections.CodeStar_connections_20191201",
        uid: "codestar-connections-2019-12-01"
      },
      operations: {
        CreateConnection: {
          input: {
            type: "structure",
            required: [
              "ConnectionName"
            ],
            members: {
              ProviderType: {},
              ConnectionName: {},
              Tags: {
                shape: "S4"
              },
              HostArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ConnectionArn"
            ],
            members: {
              ConnectionArn: {},
              Tags: {
                shape: "S4"
              }
            }
          }
        },
        CreateHost: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ProviderType",
              "ProviderEndpoint"
            ],
            members: {
              Name: {},
              ProviderType: {},
              ProviderEndpoint: {},
              VpcConfiguration: {
                shape: "Se"
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HostArn: {},
              Tags: {
                shape: "S4"
              }
            }
          }
        },
        DeleteConnection: {
          input: {
            type: "structure",
            required: [
              "ConnectionArn"
            ],
            members: {
              ConnectionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteHost: {
          input: {
            type: "structure",
            required: [
              "HostArn"
            ],
            members: {
              HostArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetConnection: {
          input: {
            type: "structure",
            required: [
              "ConnectionArn"
            ],
            members: {
              ConnectionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "Ss"
              }
            }
          }
        },
        GetHost: {
          input: {
            type: "structure",
            required: [
              "HostArn"
            ],
            members: {
              HostArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Status: {},
              ProviderType: {},
              ProviderEndpoint: {},
              VpcConfiguration: {
                shape: "Se"
              }
            }
          }
        },
        ListConnections: {
          input: {
            type: "structure",
            members: {
              ProviderTypeFilter: {},
              HostArnFilter: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Connections: {
                type: "list",
                member: {
                  shape: "Ss"
                }
              },
              NextToken: {}
            }
          }
        },
        ListHosts: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Hosts: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    HostArn: {},
                    ProviderType: {},
                    ProviderEndpoint: {},
                    VpcConfiguration: {
                      shape: "Se"
                    },
                    Status: {},
                    StatusMessage: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S4"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateHost: {
          input: {
            type: "structure",
            required: [
              "HostArn"
            ],
            members: {
              HostArn: {},
              ProviderEndpoint: {},
              VpcConfiguration: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Se: {
          type: "structure",
          required: [
            "VpcId",
            "SubnetIds",
            "SecurityGroupIds"
          ],
          members: {
            VpcId: {},
            SubnetIds: {
              type: "list",
              member: {}
            },
            SecurityGroupIds: {
              type: "list",
              member: {}
            },
            TlsCertificate: {}
          }
        },
        Ss: {
          type: "structure",
          members: {
            ConnectionName: {},
            ConnectionArn: {},
            ProviderType: {},
            OwnerAccountId: {},
            ConnectionStatus: {},
            HostArn: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codestar-connections-2019-12-01.paginators.json
var require_codestar_connections_2019_12_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codestar-connections-2019-12-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListConnections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListHosts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/codestarconnections.js
var require_codestarconnections = __commonJS({
  "node_modules/aws-sdk/clients/codestarconnections.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["codestarconnections"] = {};
    AWS3.CodeStarconnections = Service.defineService("codestarconnections", ["2019-12-01"]);
    Object.defineProperty(apiLoader.services["codestarconnections"], "2019-12-01", {
      get: function get() {
        var model = require_codestar_connections_2019_12_01_min();
        model.paginators = require_codestar_connections_2019_12_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CodeStarconnections;
  }
});

// node_modules/aws-sdk/apis/synthetics-2017-10-11.min.json
var require_synthetics_2017_10_11_min = __commonJS({
  "node_modules/aws-sdk/apis/synthetics-2017-10-11.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-10-11",
        endpointPrefix: "synthetics",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Synthetics",
        serviceFullName: "Synthetics",
        serviceId: "synthetics",
        signatureVersion: "v4",
        signingName: "synthetics",
        uid: "synthetics-2017-10-11"
      },
      operations: {
        CreateCanary: {
          http: {
            requestUri: "/canary"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Code",
              "ArtifactS3Location",
              "ExecutionRoleArn",
              "Schedule",
              "RuntimeVersion"
            ],
            members: {
              Name: {},
              Code: {
                shape: "S3"
              },
              ArtifactS3Location: {},
              ExecutionRoleArn: {},
              Schedule: {
                shape: "S7"
              },
              RunConfig: {
                shape: "S9"
              },
              SuccessRetentionPeriodInDays: {
                type: "integer"
              },
              FailureRetentionPeriodInDays: {
                type: "integer"
              },
              RuntimeVersion: {},
              VpcConfig: {
                shape: "Sh"
              },
              Tags: {
                shape: "Sm"
              },
              ArtifactConfig: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Canary: {
                shape: "Su"
              }
            }
          }
        },
        DeleteCanary: {
          http: {
            method: "DELETE",
            requestUri: "/canary/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeCanaries: {
          http: {
            requestUri: "/canaries"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Canaries: {
                type: "list",
                member: {
                  shape: "Su"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeCanariesLastRun: {
          http: {
            requestUri: "/canaries/last-run"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CanariesLastRun: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CanaryName: {},
                    LastRun: {
                      shape: "S1p"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeRuntimeVersions: {
          http: {
            requestUri: "/runtime-versions"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              RuntimeVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    VersionName: {},
                    Description: {},
                    ReleaseDate: {
                      type: "timestamp"
                    },
                    DeprecationDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetCanary: {
          http: {
            method: "GET",
            requestUri: "/canary/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Canary: {
                shape: "Su"
              }
            }
          }
        },
        GetCanaryRuns: {
          http: {
            requestUri: "/canary/{name}/runs"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CanaryRuns: {
                type: "list",
                member: {
                  shape: "S1p"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sm"
              }
            }
          }
        },
        StartCanary: {
          http: {
            requestUri: "/canary/{name}/start"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StopCanary: {
          http: {
            requestUri: "/canary/{name}/stop"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateCanary: {
          http: {
            method: "PATCH",
            requestUri: "/canary/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              Code: {
                shape: "S3"
              },
              ExecutionRoleArn: {},
              RuntimeVersion: {},
              Schedule: {
                shape: "S7"
              },
              RunConfig: {
                shape: "S9"
              },
              SuccessRetentionPeriodInDays: {
                type: "integer"
              },
              FailureRetentionPeriodInDays: {
                type: "integer"
              },
              VpcConfig: {
                shape: "Sh"
              },
              VisualReference: {
                type: "structure",
                required: [
                  "BaseCanaryRunId"
                ],
                members: {
                  BaseScreenshots: {
                    shape: "S18"
                  },
                  BaseCanaryRunId: {}
                }
              },
              ArtifactS3Location: {},
              ArtifactConfig: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          required: [
            "Handler"
          ],
          members: {
            S3Bucket: {},
            S3Key: {},
            S3Version: {},
            ZipFile: {
              type: "blob"
            },
            Handler: {}
          }
        },
        S7: {
          type: "structure",
          required: [
            "Expression"
          ],
          members: {
            Expression: {},
            DurationInSeconds: {
              type: "long"
            }
          }
        },
        S9: {
          type: "structure",
          members: {
            TimeoutInSeconds: {
              type: "integer"
            },
            MemoryInMB: {
              type: "integer"
            },
            ActiveTracing: {
              type: "boolean"
            },
            EnvironmentVariables: {
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        Sh: {
          type: "structure",
          members: {
            SubnetIds: {
              shape: "Si"
            },
            SecurityGroupIds: {
              shape: "Sk"
            }
          }
        },
        Si: {
          type: "list",
          member: {}
        },
        Sk: {
          type: "list",
          member: {}
        },
        Sm: {
          type: "map",
          key: {},
          value: {}
        },
        Sp: {
          type: "structure",
          members: {
            S3Encryption: {
              shape: "Sq"
            }
          }
        },
        Sq: {
          type: "structure",
          members: {
            EncryptionMode: {},
            KmsKeyArn: {}
          }
        },
        Su: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            Code: {
              type: "structure",
              members: {
                SourceLocationArn: {},
                Handler: {}
              }
            },
            ExecutionRoleArn: {},
            Schedule: {
              type: "structure",
              members: {
                Expression: {},
                DurationInSeconds: {
                  type: "long"
                }
              }
            },
            RunConfig: {
              type: "structure",
              members: {
                TimeoutInSeconds: {
                  type: "integer"
                },
                MemoryInMB: {
                  type: "integer"
                },
                ActiveTracing: {
                  type: "boolean"
                }
              }
            },
            SuccessRetentionPeriodInDays: {
              type: "integer"
            },
            FailureRetentionPeriodInDays: {
              type: "integer"
            },
            Status: {
              type: "structure",
              members: {
                State: {},
                StateReason: {},
                StateReasonCode: {}
              }
            },
            Timeline: {
              type: "structure",
              members: {
                Created: {
                  type: "timestamp"
                },
                LastModified: {
                  type: "timestamp"
                },
                LastStarted: {
                  type: "timestamp"
                },
                LastStopped: {
                  type: "timestamp"
                }
              }
            },
            ArtifactS3Location: {},
            EngineArn: {},
            RuntimeVersion: {},
            VpcConfig: {
              type: "structure",
              members: {
                VpcId: {},
                SubnetIds: {
                  shape: "Si"
                },
                SecurityGroupIds: {
                  shape: "Sk"
                }
              }
            },
            VisualReference: {
              type: "structure",
              members: {
                BaseScreenshots: {
                  shape: "S18"
                },
                BaseCanaryRunId: {}
              }
            },
            Tags: {
              shape: "Sm"
            },
            ArtifactConfig: {
              type: "structure",
              members: {
                S3Encryption: {
                  shape: "Sq"
                }
              }
            }
          }
        },
        S18: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ScreenshotName"
            ],
            members: {
              ScreenshotName: {},
              IgnoreCoordinates: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S1p: {
          type: "structure",
          members: {
            Id: {},
            Name: {},
            Status: {
              type: "structure",
              members: {
                State: {},
                StateReason: {},
                StateReasonCode: {}
              }
            },
            Timeline: {
              type: "structure",
              members: {
                Started: {
                  type: "timestamp"
                },
                Completed: {
                  type: "timestamp"
                }
              }
            },
            ArtifactS3Location: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/synthetics-2017-10-11.paginators.json
var require_synthetics_2017_10_11_paginators = __commonJS({
  "node_modules/aws-sdk/apis/synthetics-2017-10-11.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeCanaries: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        DescribeCanariesLastRun: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        DescribeRuntimeVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        },
        GetCanaryRuns: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/synthetics.js
var require_synthetics = __commonJS({
  "node_modules/aws-sdk/clients/synthetics.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["synthetics"] = {};
    AWS3.Synthetics = Service.defineService("synthetics", ["2017-10-11"]);
    Object.defineProperty(apiLoader.services["synthetics"], "2017-10-11", {
      get: function get() {
        var model = require_synthetics_2017_10_11_min();
        model.paginators = require_synthetics_2017_10_11_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Synthetics;
  }
});

// node_modules/aws-sdk/apis/iotsitewise-2019-12-02.min.json
var require_iotsitewise_2019_12_02_min = __commonJS({
  "node_modules/aws-sdk/apis/iotsitewise-2019-12-02.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-12-02",
        endpointPrefix: "iotsitewise",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS IoT SiteWise",
        serviceId: "IoTSiteWise",
        signatureVersion: "v4",
        signingName: "iotsitewise",
        uid: "iotsitewise-2019-12-02"
      },
      operations: {
        AssociateAssets: {
          http: {
            requestUri: "/assets/{assetId}/associate"
          },
          input: {
            type: "structure",
            required: [
              "assetId",
              "hierarchyId",
              "childAssetId"
            ],
            members: {
              assetId: {
                location: "uri",
                locationName: "assetId"
              },
              hierarchyId: {},
              childAssetId: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        BatchAssociateProjectAssets: {
          http: {
            requestUri: "/projects/{projectId}/assets/associate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "projectId",
              "assetIds"
            ],
            members: {
              projectId: {
                location: "uri",
                locationName: "projectId"
              },
              assetIds: {
                shape: "S5"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  shape: "S8"
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        BatchDisassociateProjectAssets: {
          http: {
            requestUri: "/projects/{projectId}/assets/disassociate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "projectId",
              "assetIds"
            ],
            members: {
              projectId: {
                location: "uri",
                locationName: "projectId"
              },
              assetIds: {
                shape: "S5"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  shape: "S8"
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        BatchPutAssetPropertyValue: {
          http: {
            requestUri: "/properties"
          },
          input: {
            type: "structure",
            required: [
              "entries"
            ],
            members: {
              entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "entryId",
                    "propertyValues"
                  ],
                  members: {
                    entryId: {},
                    assetId: {},
                    propertyId: {},
                    propertyAlias: {},
                    propertyValues: {
                      type: "list",
                      member: {
                        shape: "Sk"
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "errorEntries"
            ],
            members: {
              errorEntries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "entryId",
                    "errors"
                  ],
                  members: {
                    entryId: {},
                    errors: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "errorCode",
                          "errorMessage",
                          "timestamps"
                        ],
                        members: {
                          errorCode: {},
                          errorMessage: {},
                          timestamps: {
                            type: "list",
                            member: {
                              shape: "Sq"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "data."
          }
        },
        CreateAccessPolicy: {
          http: {
            requestUri: "/access-policies",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "accessPolicyIdentity",
              "accessPolicyResource",
              "accessPolicyPermission"
            ],
            members: {
              accessPolicyIdentity: {
                shape: "S13"
              },
              accessPolicyResource: {
                shape: "S1a"
              },
              accessPolicyPermission: {},
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "accessPolicyId",
              "accessPolicyArn"
            ],
            members: {
              accessPolicyId: {},
              accessPolicyArn: {}
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        CreateAsset: {
          http: {
            requestUri: "/assets",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "assetName",
              "assetModelId"
            ],
            members: {
              assetName: {},
              assetModelId: {},
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetId",
              "assetArn",
              "assetStatus"
            ],
            members: {
              assetId: {},
              assetArn: {},
              assetStatus: {
                shape: "S1l"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        CreateAssetModel: {
          http: {
            requestUri: "/asset-models",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "assetModelName"
            ],
            members: {
              assetModelName: {},
              assetModelDescription: {},
              assetModelProperties: {
                shape: "S1v"
              },
              assetModelHierarchies: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "childAssetModelId"
                  ],
                  members: {
                    name: {},
                    childAssetModelId: {}
                  }
                }
              },
              assetModelCompositeModels: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "type"
                  ],
                  members: {
                    name: {},
                    description: {},
                    type: {},
                    properties: {
                      shape: "S1v"
                    }
                  }
                }
              },
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetModelId",
              "assetModelArn",
              "assetModelStatus"
            ],
            members: {
              assetModelId: {},
              assetModelArn: {},
              assetModelStatus: {
                shape: "S2q"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        CreateDashboard: {
          http: {
            requestUri: "/dashboards",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "projectId",
              "dashboardName",
              "dashboardDefinition"
            ],
            members: {
              projectId: {},
              dashboardName: {},
              dashboardDescription: {},
              dashboardDefinition: {},
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "dashboardId",
              "dashboardArn"
            ],
            members: {
              dashboardId: {},
              dashboardArn: {}
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        CreateGateway: {
          http: {
            requestUri: "/20200301/gateways",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "gatewayName",
              "gatewayPlatform"
            ],
            members: {
              gatewayName: {},
              gatewayPlatform: {
                shape: "S2w"
              },
              tags: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "gatewayId",
              "gatewayArn"
            ],
            members: {
              gatewayId: {},
              gatewayArn: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        CreatePortal: {
          http: {
            requestUri: "/portals",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "portalName",
              "portalContactEmail",
              "roleArn"
            ],
            members: {
              portalName: {},
              portalDescription: {},
              portalContactEmail: {},
              clientToken: {
                idempotencyToken: true
              },
              portalLogoImageFile: {
                shape: "S33"
              },
              roleArn: {},
              tags: {
                shape: "S1e"
              },
              portalAuthMode: {},
              notificationSenderEmail: {},
              alarms: {
                shape: "S37"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "portalId",
              "portalArn",
              "portalStartUrl",
              "portalStatus",
              "ssoApplicationId"
            ],
            members: {
              portalId: {},
              portalArn: {},
              portalStartUrl: {},
              portalStatus: {
                shape: "S3a"
              },
              ssoApplicationId: {}
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        CreateProject: {
          http: {
            requestUri: "/projects",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "portalId",
              "projectName"
            ],
            members: {
              portalId: {},
              projectName: {},
              projectDescription: {},
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "projectId",
              "projectArn"
            ],
            members: {
              projectId: {},
              projectArn: {}
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        DeleteAccessPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/access-policies/{accessPolicyId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "accessPolicyId"
            ],
            members: {
              accessPolicyId: {
                location: "uri",
                locationName: "accessPolicyId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        DeleteAsset: {
          http: {
            method: "DELETE",
            requestUri: "/assets/{assetId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "assetId"
            ],
            members: {
              assetId: {
                location: "uri",
                locationName: "assetId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetStatus"
            ],
            members: {
              assetStatus: {
                shape: "S1l"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DeleteAssetModel: {
          http: {
            method: "DELETE",
            requestUri: "/asset-models/{assetModelId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "assetModelId"
            ],
            members: {
              assetModelId: {
                location: "uri",
                locationName: "assetModelId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetModelStatus"
            ],
            members: {
              assetModelStatus: {
                shape: "S2q"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DeleteDashboard: {
          http: {
            method: "DELETE",
            requestUri: "/dashboards/{dashboardId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "dashboardId"
            ],
            members: {
              dashboardId: {
                location: "uri",
                locationName: "dashboardId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        DeleteGateway: {
          http: {
            method: "DELETE",
            requestUri: "/20200301/gateways/{gatewayId}"
          },
          input: {
            type: "structure",
            required: [
              "gatewayId"
            ],
            members: {
              gatewayId: {
                location: "uri",
                locationName: "gatewayId"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DeletePortal: {
          http: {
            method: "DELETE",
            requestUri: "/portals/{portalId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "portalId"
            ],
            members: {
              portalId: {
                location: "uri",
                locationName: "portalId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "portalStatus"
            ],
            members: {
              portalStatus: {
                shape: "S3a"
              }
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        DeleteProject: {
          http: {
            method: "DELETE",
            requestUri: "/projects/{projectId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "projectId"
            ],
            members: {
              projectId: {
                location: "uri",
                locationName: "projectId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        DescribeAccessPolicy: {
          http: {
            method: "GET",
            requestUri: "/access-policies/{accessPolicyId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accessPolicyId"
            ],
            members: {
              accessPolicyId: {
                location: "uri",
                locationName: "accessPolicyId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "accessPolicyId",
              "accessPolicyArn",
              "accessPolicyIdentity",
              "accessPolicyResource",
              "accessPolicyPermission",
              "accessPolicyCreationDate",
              "accessPolicyLastUpdateDate"
            ],
            members: {
              accessPolicyId: {},
              accessPolicyArn: {},
              accessPolicyIdentity: {
                shape: "S13"
              },
              accessPolicyResource: {
                shape: "S1a"
              },
              accessPolicyPermission: {},
              accessPolicyCreationDate: {
                type: "timestamp"
              },
              accessPolicyLastUpdateDate: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        DescribeAsset: {
          http: {
            method: "GET",
            requestUri: "/assets/{assetId}"
          },
          input: {
            type: "structure",
            required: [
              "assetId"
            ],
            members: {
              assetId: {
                location: "uri",
                locationName: "assetId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetId",
              "assetArn",
              "assetName",
              "assetModelId",
              "assetProperties",
              "assetHierarchies",
              "assetCreationDate",
              "assetLastUpdateDate",
              "assetStatus"
            ],
            members: {
              assetId: {},
              assetArn: {},
              assetName: {},
              assetModelId: {},
              assetProperties: {
                shape: "S40"
              },
              assetHierarchies: {
                shape: "S46"
              },
              assetCompositeModels: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "type",
                    "properties"
                  ],
                  members: {
                    name: {},
                    description: {},
                    type: {},
                    properties: {
                      shape: "S40"
                    }
                  }
                }
              },
              assetCreationDate: {
                type: "timestamp"
              },
              assetLastUpdateDate: {
                type: "timestamp"
              },
              assetStatus: {
                shape: "S1l"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DescribeAssetModel: {
          http: {
            method: "GET",
            requestUri: "/asset-models/{assetModelId}"
          },
          input: {
            type: "structure",
            required: [
              "assetModelId"
            ],
            members: {
              assetModelId: {
                location: "uri",
                locationName: "assetModelId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetModelId",
              "assetModelArn",
              "assetModelName",
              "assetModelDescription",
              "assetModelProperties",
              "assetModelHierarchies",
              "assetModelCreationDate",
              "assetModelLastUpdateDate",
              "assetModelStatus"
            ],
            members: {
              assetModelId: {},
              assetModelArn: {},
              assetModelName: {},
              assetModelDescription: {},
              assetModelProperties: {
                shape: "S4c"
              },
              assetModelHierarchies: {
                shape: "S4e"
              },
              assetModelCompositeModels: {
                shape: "S4g"
              },
              assetModelCreationDate: {
                type: "timestamp"
              },
              assetModelLastUpdateDate: {
                type: "timestamp"
              },
              assetModelStatus: {
                shape: "S2q"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DescribeAssetProperty: {
          http: {
            method: "GET",
            requestUri: "/assets/{assetId}/properties/{propertyId}"
          },
          input: {
            type: "structure",
            required: [
              "assetId",
              "propertyId"
            ],
            members: {
              assetId: {
                location: "uri",
                locationName: "assetId"
              },
              propertyId: {
                location: "uri",
                locationName: "propertyId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetId",
              "assetName",
              "assetModelId"
            ],
            members: {
              assetId: {},
              assetName: {},
              assetModelId: {},
              assetProperty: {
                shape: "S4k"
              },
              compositeModel: {
                type: "structure",
                required: [
                  "name",
                  "type",
                  "assetProperty"
                ],
                members: {
                  name: {},
                  type: {},
                  assetProperty: {
                    shape: "S4k"
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DescribeDashboard: {
          http: {
            method: "GET",
            requestUri: "/dashboards/{dashboardId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "dashboardId"
            ],
            members: {
              dashboardId: {
                location: "uri",
                locationName: "dashboardId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "dashboardId",
              "dashboardArn",
              "dashboardName",
              "projectId",
              "dashboardDefinition",
              "dashboardCreationDate",
              "dashboardLastUpdateDate"
            ],
            members: {
              dashboardId: {},
              dashboardArn: {},
              dashboardName: {},
              projectId: {},
              dashboardDescription: {},
              dashboardDefinition: {},
              dashboardCreationDate: {
                type: "timestamp"
              },
              dashboardLastUpdateDate: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        DescribeDefaultEncryptionConfiguration: {
          http: {
            method: "GET",
            requestUri: "/configuration/account/encryption"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "encryptionType",
              "configurationStatus"
            ],
            members: {
              encryptionType: {},
              kmsKeyArn: {},
              configurationStatus: {
                shape: "S4r"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DescribeGateway: {
          http: {
            method: "GET",
            requestUri: "/20200301/gateways/{gatewayId}"
          },
          input: {
            type: "structure",
            required: [
              "gatewayId"
            ],
            members: {
              gatewayId: {
                location: "uri",
                locationName: "gatewayId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "gatewayId",
              "gatewayName",
              "gatewayArn",
              "gatewayCapabilitySummaries",
              "creationDate",
              "lastUpdateDate"
            ],
            members: {
              gatewayId: {},
              gatewayName: {},
              gatewayArn: {},
              gatewayPlatform: {
                shape: "S2w"
              },
              gatewayCapabilitySummaries: {
                shape: "S4w"
              },
              creationDate: {
                type: "timestamp"
              },
              lastUpdateDate: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DescribeGatewayCapabilityConfiguration: {
          http: {
            method: "GET",
            requestUri: "/20200301/gateways/{gatewayId}/capability/{capabilityNamespace}"
          },
          input: {
            type: "structure",
            required: [
              "gatewayId",
              "capabilityNamespace"
            ],
            members: {
              gatewayId: {
                location: "uri",
                locationName: "gatewayId"
              },
              capabilityNamespace: {
                location: "uri",
                locationName: "capabilityNamespace"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "gatewayId",
              "capabilityNamespace",
              "capabilityConfiguration",
              "capabilitySyncStatus"
            ],
            members: {
              gatewayId: {},
              capabilityNamespace: {},
              capabilityConfiguration: {},
              capabilitySyncStatus: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DescribeLoggingOptions: {
          http: {
            method: "GET",
            requestUri: "/logging"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "loggingOptions"
            ],
            members: {
              loggingOptions: {
                shape: "S55"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DescribePortal: {
          http: {
            method: "GET",
            requestUri: "/portals/{portalId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "portalId"
            ],
            members: {
              portalId: {
                location: "uri",
                locationName: "portalId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "portalId",
              "portalArn",
              "portalName",
              "portalClientId",
              "portalStartUrl",
              "portalContactEmail",
              "portalStatus",
              "portalCreationDate",
              "portalLastUpdateDate"
            ],
            members: {
              portalId: {},
              portalArn: {},
              portalName: {},
              portalDescription: {},
              portalClientId: {},
              portalStartUrl: {},
              portalContactEmail: {},
              portalStatus: {
                shape: "S3a"
              },
              portalCreationDate: {
                type: "timestamp"
              },
              portalLastUpdateDate: {
                type: "timestamp"
              },
              portalLogoImageLocation: {
                type: "structure",
                required: [
                  "id",
                  "url"
                ],
                members: {
                  id: {},
                  url: {}
                }
              },
              roleArn: {},
              portalAuthMode: {},
              notificationSenderEmail: {},
              alarms: {
                shape: "S37"
              }
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        DescribeProject: {
          http: {
            method: "GET",
            requestUri: "/projects/{projectId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "projectId"
            ],
            members: {
              projectId: {
                location: "uri",
                locationName: "projectId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "projectId",
              "projectArn",
              "projectName",
              "portalId",
              "projectCreationDate",
              "projectLastUpdateDate"
            ],
            members: {
              projectId: {},
              projectArn: {},
              projectName: {},
              portalId: {},
              projectDescription: {},
              projectCreationDate: {
                type: "timestamp"
              },
              projectLastUpdateDate: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        DescribeStorageConfiguration: {
          http: {
            method: "GET",
            requestUri: "/configuration/account/storage"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "storageType",
              "configurationStatus"
            ],
            members: {
              storageType: {},
              multiLayerStorage: {
                shape: "S5g"
              },
              configurationStatus: {
                shape: "S4r"
              },
              lastUpdateDate: {
                type: "timestamp"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        DisassociateAssets: {
          http: {
            requestUri: "/assets/{assetId}/disassociate"
          },
          input: {
            type: "structure",
            required: [
              "assetId",
              "hierarchyId",
              "childAssetId"
            ],
            members: {
              assetId: {
                location: "uri",
                locationName: "assetId"
              },
              hierarchyId: {},
              childAssetId: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        GetAssetPropertyAggregates: {
          http: {
            method: "GET",
            requestUri: "/properties/aggregates"
          },
          input: {
            type: "structure",
            required: [
              "aggregateTypes",
              "resolution",
              "startDate",
              "endDate"
            ],
            members: {
              assetId: {
                location: "querystring",
                locationName: "assetId"
              },
              propertyId: {
                location: "querystring",
                locationName: "propertyId"
              },
              propertyAlias: {
                location: "querystring",
                locationName: "propertyAlias"
              },
              aggregateTypes: {
                location: "querystring",
                locationName: "aggregateTypes",
                type: "list",
                member: {}
              },
              resolution: {
                location: "querystring",
                locationName: "resolution"
              },
              qualities: {
                shape: "S5n",
                location: "querystring",
                locationName: "qualities"
              },
              startDate: {
                location: "querystring",
                locationName: "startDate",
                type: "timestamp"
              },
              endDate: {
                location: "querystring",
                locationName: "endDate",
                type: "timestamp"
              },
              timeOrdering: {
                location: "querystring",
                locationName: "timeOrdering"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "aggregatedValues"
            ],
            members: {
              aggregatedValues: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "timestamp",
                    "value"
                  ],
                  members: {
                    timestamp: {
                      type: "timestamp"
                    },
                    quality: {},
                    value: {
                      type: "structure",
                      members: {
                        average: {
                          type: "double"
                        },
                        count: {
                          type: "double"
                        },
                        maximum: {
                          type: "double"
                        },
                        minimum: {
                          type: "double"
                        },
                        sum: {
                          type: "double"
                        },
                        standardDeviation: {
                          type: "double"
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "data."
          }
        },
        GetAssetPropertyValue: {
          http: {
            method: "GET",
            requestUri: "/properties/latest"
          },
          input: {
            type: "structure",
            members: {
              assetId: {
                location: "querystring",
                locationName: "assetId"
              },
              propertyId: {
                location: "querystring",
                locationName: "propertyId"
              },
              propertyAlias: {
                location: "querystring",
                locationName: "propertyAlias"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              propertyValue: {
                shape: "Sk"
              }
            }
          },
          endpoint: {
            hostPrefix: "data."
          }
        },
        GetAssetPropertyValueHistory: {
          http: {
            method: "GET",
            requestUri: "/properties/history"
          },
          input: {
            type: "structure",
            members: {
              assetId: {
                location: "querystring",
                locationName: "assetId"
              },
              propertyId: {
                location: "querystring",
                locationName: "propertyId"
              },
              propertyAlias: {
                location: "querystring",
                locationName: "propertyAlias"
              },
              startDate: {
                location: "querystring",
                locationName: "startDate",
                type: "timestamp"
              },
              endDate: {
                location: "querystring",
                locationName: "endDate",
                type: "timestamp"
              },
              qualities: {
                shape: "S5n",
                location: "querystring",
                locationName: "qualities"
              },
              timeOrdering: {
                location: "querystring",
                locationName: "timeOrdering"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetPropertyValueHistory"
            ],
            members: {
              assetPropertyValueHistory: {
                type: "list",
                member: {
                  shape: "Sk"
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "data."
          }
        },
        GetInterpolatedAssetPropertyValues: {
          http: {
            method: "GET",
            requestUri: "/properties/interpolated"
          },
          input: {
            type: "structure",
            required: [
              "startTimeInSeconds",
              "endTimeInSeconds",
              "quality",
              "intervalInSeconds",
              "type"
            ],
            members: {
              assetId: {
                location: "querystring",
                locationName: "assetId"
              },
              propertyId: {
                location: "querystring",
                locationName: "propertyId"
              },
              propertyAlias: {
                location: "querystring",
                locationName: "propertyAlias"
              },
              startTimeInSeconds: {
                location: "querystring",
                locationName: "startTimeInSeconds",
                type: "long"
              },
              startTimeOffsetInNanos: {
                location: "querystring",
                locationName: "startTimeOffsetInNanos",
                type: "integer"
              },
              endTimeInSeconds: {
                location: "querystring",
                locationName: "endTimeInSeconds",
                type: "long"
              },
              endTimeOffsetInNanos: {
                location: "querystring",
                locationName: "endTimeOffsetInNanos",
                type: "integer"
              },
              quality: {
                location: "querystring",
                locationName: "quality"
              },
              intervalInSeconds: {
                location: "querystring",
                locationName: "intervalInSeconds",
                type: "long"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              type: {
                location: "querystring",
                locationName: "type"
              },
              intervalWindowInSeconds: {
                location: "querystring",
                locationName: "intervalWindowInSeconds",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "interpolatedAssetPropertyValues"
            ],
            members: {
              interpolatedAssetPropertyValues: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "timestamp",
                    "value"
                  ],
                  members: {
                    timestamp: {
                      shape: "Sq"
                    },
                    value: {
                      shape: "Sl"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "data."
          }
        },
        ListAccessPolicies: {
          http: {
            method: "GET",
            requestUri: "/access-policies",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              identityType: {
                location: "querystring",
                locationName: "identityType"
              },
              identityId: {
                location: "querystring",
                locationName: "identityId"
              },
              resourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              resourceId: {
                location: "querystring",
                locationName: "resourceId"
              },
              iamArn: {
                location: "querystring",
                locationName: "iamArn"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "accessPolicySummaries"
            ],
            members: {
              accessPolicySummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "identity",
                    "resource",
                    "permission"
                  ],
                  members: {
                    id: {},
                    identity: {
                      shape: "S13"
                    },
                    resource: {
                      shape: "S1a"
                    },
                    permission: {},
                    creationDate: {
                      type: "timestamp"
                    },
                    lastUpdateDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        ListAssetModels: {
          http: {
            method: "GET",
            requestUri: "/asset-models"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetModelSummaries"
            ],
            members: {
              assetModelSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "arn",
                    "name",
                    "description",
                    "creationDate",
                    "lastUpdateDate",
                    "status"
                  ],
                  members: {
                    id: {},
                    arn: {},
                    name: {},
                    description: {},
                    creationDate: {
                      type: "timestamp"
                    },
                    lastUpdateDate: {
                      type: "timestamp"
                    },
                    status: {
                      shape: "S2q"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListAssetRelationships: {
          http: {
            method: "GET",
            requestUri: "/assets/{assetId}/assetRelationships"
          },
          input: {
            type: "structure",
            required: [
              "assetId",
              "traversalType"
            ],
            members: {
              assetId: {
                location: "uri",
                locationName: "assetId"
              },
              traversalType: {
                location: "querystring",
                locationName: "traversalType"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetRelationshipSummaries"
            ],
            members: {
              assetRelationshipSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "relationshipType"
                  ],
                  members: {
                    hierarchyInfo: {
                      type: "structure",
                      members: {
                        parentAssetId: {},
                        childAssetId: {}
                      }
                    },
                    relationshipType: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListAssets: {
          http: {
            method: "GET",
            requestUri: "/assets"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              assetModelId: {
                location: "querystring",
                locationName: "assetModelId"
              },
              filter: {
                location: "querystring",
                locationName: "filter"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetSummaries"
            ],
            members: {
              assetSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "arn",
                    "name",
                    "assetModelId",
                    "creationDate",
                    "lastUpdateDate",
                    "status",
                    "hierarchies"
                  ],
                  members: {
                    id: {},
                    arn: {},
                    name: {},
                    assetModelId: {},
                    creationDate: {
                      type: "timestamp"
                    },
                    lastUpdateDate: {
                      type: "timestamp"
                    },
                    status: {
                      shape: "S1l"
                    },
                    hierarchies: {
                      shape: "S46"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListAssociatedAssets: {
          http: {
            method: "GET",
            requestUri: "/assets/{assetId}/hierarchies"
          },
          input: {
            type: "structure",
            required: [
              "assetId"
            ],
            members: {
              assetId: {
                location: "uri",
                locationName: "assetId"
              },
              hierarchyId: {
                location: "querystring",
                locationName: "hierarchyId"
              },
              traversalDirection: {
                location: "querystring",
                locationName: "traversalDirection"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetSummaries"
            ],
            members: {
              assetSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "arn",
                    "name",
                    "assetModelId",
                    "creationDate",
                    "lastUpdateDate",
                    "status",
                    "hierarchies"
                  ],
                  members: {
                    id: {},
                    arn: {},
                    name: {},
                    assetModelId: {},
                    creationDate: {
                      type: "timestamp"
                    },
                    lastUpdateDate: {
                      type: "timestamp"
                    },
                    status: {
                      shape: "S1l"
                    },
                    hierarchies: {
                      shape: "S46"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListDashboards: {
          http: {
            method: "GET",
            requestUri: "/dashboards",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "projectId"
            ],
            members: {
              projectId: {
                location: "querystring",
                locationName: "projectId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "dashboardSummaries"
            ],
            members: {
              dashboardSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "name"
                  ],
                  members: {
                    id: {},
                    name: {},
                    description: {},
                    creationDate: {
                      type: "timestamp"
                    },
                    lastUpdateDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        ListGateways: {
          http: {
            method: "GET",
            requestUri: "/20200301/gateways"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "gatewaySummaries"
            ],
            members: {
              gatewaySummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "gatewayId",
                    "gatewayName",
                    "creationDate",
                    "lastUpdateDate"
                  ],
                  members: {
                    gatewayId: {},
                    gatewayName: {},
                    gatewayPlatform: {
                      shape: "S2w"
                    },
                    gatewayCapabilitySummaries: {
                      shape: "S4w"
                    },
                    creationDate: {
                      type: "timestamp"
                    },
                    lastUpdateDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListPortals: {
          http: {
            method: "GET",
            requestUri: "/portals",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              portalSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "name",
                    "startUrl",
                    "status"
                  ],
                  members: {
                    id: {},
                    name: {},
                    description: {},
                    startUrl: {},
                    creationDate: {
                      type: "timestamp"
                    },
                    lastUpdateDate: {
                      type: "timestamp"
                    },
                    roleArn: {},
                    status: {
                      shape: "S3a"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        ListProjectAssets: {
          http: {
            method: "GET",
            requestUri: "/projects/{projectId}/assets",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "projectId"
            ],
            members: {
              projectId: {
                location: "uri",
                locationName: "projectId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetIds"
            ],
            members: {
              assetIds: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        ListProjects: {
          http: {
            method: "GET",
            requestUri: "/projects",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "portalId"
            ],
            members: {
              portalId: {
                location: "querystring",
                locationName: "portalId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "projectSummaries"
            ],
            members: {
              projectSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "id",
                    "name"
                  ],
                  members: {
                    id: {},
                    name: {},
                    description: {},
                    creationDate: {
                      type: "timestamp"
                    },
                    lastUpdateDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S1e"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        PutDefaultEncryptionConfiguration: {
          http: {
            requestUri: "/configuration/account/encryption"
          },
          input: {
            type: "structure",
            required: [
              "encryptionType"
            ],
            members: {
              encryptionType: {},
              kmsKeyId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "encryptionType",
              "configurationStatus"
            ],
            members: {
              encryptionType: {},
              kmsKeyArn: {},
              configurationStatus: {
                shape: "S4r"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        PutLoggingOptions: {
          http: {
            method: "PUT",
            requestUri: "/logging"
          },
          input: {
            type: "structure",
            required: [
              "loggingOptions"
            ],
            members: {
              loggingOptions: {
                shape: "S55"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        PutStorageConfiguration: {
          http: {
            requestUri: "/configuration/account/storage"
          },
          input: {
            type: "structure",
            required: [
              "storageType"
            ],
            members: {
              storageType: {},
              multiLayerStorage: {
                shape: "S5g"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "storageType",
              "configurationStatus"
            ],
            members: {
              storageType: {},
              multiLayerStorage: {
                shape: "S5g"
              },
              configurationStatus: {
                shape: "S4r"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UpdateAccessPolicy: {
          http: {
            method: "PUT",
            requestUri: "/access-policies/{accessPolicyId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "accessPolicyId",
              "accessPolicyIdentity",
              "accessPolicyResource",
              "accessPolicyPermission"
            ],
            members: {
              accessPolicyId: {
                location: "uri",
                locationName: "accessPolicyId"
              },
              accessPolicyIdentity: {
                shape: "S13"
              },
              accessPolicyResource: {
                shape: "S1a"
              },
              accessPolicyPermission: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        UpdateAsset: {
          http: {
            method: "PUT",
            requestUri: "/assets/{assetId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "assetId",
              "assetName"
            ],
            members: {
              assetId: {
                location: "uri",
                locationName: "assetId"
              },
              assetName: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetStatus"
            ],
            members: {
              assetStatus: {
                shape: "S1l"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UpdateAssetModel: {
          http: {
            method: "PUT",
            requestUri: "/asset-models/{assetModelId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "assetModelId",
              "assetModelName"
            ],
            members: {
              assetModelId: {
                location: "uri",
                locationName: "assetModelId"
              },
              assetModelName: {},
              assetModelDescription: {},
              assetModelProperties: {
                shape: "S4c"
              },
              assetModelHierarchies: {
                shape: "S4e"
              },
              assetModelCompositeModels: {
                shape: "S4g"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assetModelStatus"
            ],
            members: {
              assetModelStatus: {
                shape: "S2q"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UpdateAssetProperty: {
          http: {
            method: "PUT",
            requestUri: "/assets/{assetId}/properties/{propertyId}"
          },
          input: {
            type: "structure",
            required: [
              "assetId",
              "propertyId"
            ],
            members: {
              assetId: {
                location: "uri",
                locationName: "assetId"
              },
              propertyId: {
                location: "uri",
                locationName: "propertyId"
              },
              propertyAlias: {},
              propertyNotificationState: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UpdateDashboard: {
          http: {
            method: "PUT",
            requestUri: "/dashboards/{dashboardId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "dashboardId",
              "dashboardName",
              "dashboardDefinition"
            ],
            members: {
              dashboardId: {
                location: "uri",
                locationName: "dashboardId"
              },
              dashboardName: {},
              dashboardDescription: {},
              dashboardDefinition: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        UpdateGateway: {
          http: {
            method: "PUT",
            requestUri: "/20200301/gateways/{gatewayId}"
          },
          input: {
            type: "structure",
            required: [
              "gatewayId",
              "gatewayName"
            ],
            members: {
              gatewayId: {
                location: "uri",
                locationName: "gatewayId"
              },
              gatewayName: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UpdateGatewayCapabilityConfiguration: {
          http: {
            requestUri: "/20200301/gateways/{gatewayId}/capability",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "gatewayId",
              "capabilityNamespace",
              "capabilityConfiguration"
            ],
            members: {
              gatewayId: {
                location: "uri",
                locationName: "gatewayId"
              },
              capabilityNamespace: {},
              capabilityConfiguration: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "capabilityNamespace",
              "capabilitySyncStatus"
            ],
            members: {
              capabilityNamespace: {},
              capabilitySyncStatus: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UpdatePortal: {
          http: {
            method: "PUT",
            requestUri: "/portals/{portalId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "portalId",
              "portalName",
              "portalContactEmail",
              "roleArn"
            ],
            members: {
              portalId: {
                location: "uri",
                locationName: "portalId"
              },
              portalName: {},
              portalDescription: {},
              portalContactEmail: {},
              portalLogoImage: {
                type: "structure",
                members: {
                  id: {},
                  file: {
                    shape: "S33"
                  }
                }
              },
              roleArn: {},
              clientToken: {
                idempotencyToken: true
              },
              notificationSenderEmail: {},
              alarms: {
                shape: "S37"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "portalStatus"
            ],
            members: {
              portalStatus: {
                shape: "S3a"
              }
            }
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        },
        UpdateProject: {
          http: {
            method: "PUT",
            requestUri: "/projects/{projectId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "projectId",
              "projectName"
            ],
            members: {
              projectId: {
                location: "uri",
                locationName: "projectId"
              },
              projectName: {},
              projectDescription: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "monitor."
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {}
        },
        S8: {
          type: "structure",
          required: [
            "assetId",
            "code",
            "message"
          ],
          members: {
            assetId: {},
            code: {},
            message: {}
          }
        },
        Sk: {
          type: "structure",
          required: [
            "value",
            "timestamp"
          ],
          members: {
            value: {
              shape: "Sl"
            },
            timestamp: {
              shape: "Sq"
            },
            quality: {}
          }
        },
        Sl: {
          type: "structure",
          members: {
            stringValue: {},
            integerValue: {
              type: "integer"
            },
            doubleValue: {
              type: "double"
            },
            booleanValue: {
              type: "boolean"
            }
          }
        },
        Sq: {
          type: "structure",
          required: [
            "timeInSeconds"
          ],
          members: {
            timeInSeconds: {
              type: "long"
            },
            offsetInNanos: {
              type: "integer"
            }
          }
        },
        S13: {
          type: "structure",
          members: {
            user: {
              type: "structure",
              required: [
                "id"
              ],
              members: {
                id: {}
              }
            },
            group: {
              type: "structure",
              required: [
                "id"
              ],
              members: {
                id: {}
              }
            },
            iamUser: {
              type: "structure",
              required: [
                "arn"
              ],
              members: {
                arn: {}
              }
            },
            iamRole: {
              type: "structure",
              required: [
                "arn"
              ],
              members: {
                arn: {}
              }
            }
          }
        },
        S1a: {
          type: "structure",
          members: {
            portal: {
              type: "structure",
              required: [
                "id"
              ],
              members: {
                id: {}
              }
            },
            project: {
              type: "structure",
              required: [
                "id"
              ],
              members: {
                id: {}
              }
            }
          }
        },
        S1e: {
          type: "map",
          key: {},
          value: {}
        },
        S1l: {
          type: "structure",
          required: [
            "state"
          ],
          members: {
            state: {},
            error: {
              shape: "S1n"
            }
          }
        },
        S1n: {
          type: "structure",
          required: [
            "code",
            "message"
          ],
          members: {
            code: {},
            message: {},
            details: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "code",
                  "message"
                ],
                members: {
                  code: {},
                  message: {}
                }
              }
            }
          }
        },
        S1v: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "dataType",
              "type"
            ],
            members: {
              name: {},
              dataType: {},
              dataTypeSpec: {},
              unit: {},
              type: {
                shape: "S1z"
              }
            }
          }
        },
        S1z: {
          type: "structure",
          members: {
            attribute: {
              type: "structure",
              members: {
                defaultValue: {}
              }
            },
            measurement: {
              type: "structure",
              members: {
                processingConfig: {
                  type: "structure",
                  required: [
                    "forwardingConfig"
                  ],
                  members: {
                    forwardingConfig: {
                      shape: "S24"
                    }
                  }
                }
              }
            },
            transform: {
              type: "structure",
              required: [
                "expression",
                "variables"
              ],
              members: {
                expression: {},
                variables: {
                  shape: "S28"
                },
                processingConfig: {
                  type: "structure",
                  required: [
                    "computeLocation"
                  ],
                  members: {
                    computeLocation: {},
                    forwardingConfig: {
                      shape: "S24"
                    }
                  }
                }
              }
            },
            metric: {
              type: "structure",
              required: [
                "expression",
                "variables",
                "window"
              ],
              members: {
                expression: {},
                variables: {
                  shape: "S28"
                },
                window: {
                  type: "structure",
                  members: {
                    tumbling: {
                      type: "structure",
                      required: [
                        "interval"
                      ],
                      members: {
                        interval: {},
                        offset: {}
                      }
                    }
                  }
                },
                processingConfig: {
                  type: "structure",
                  required: [
                    "computeLocation"
                  ],
                  members: {
                    computeLocation: {}
                  }
                }
              }
            }
          }
        },
        S24: {
          type: "structure",
          required: [
            "state"
          ],
          members: {
            state: {}
          }
        },
        S28: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "value"
            ],
            members: {
              name: {},
              value: {
                type: "structure",
                required: [
                  "propertyId"
                ],
                members: {
                  propertyId: {},
                  hierarchyId: {}
                }
              }
            }
          }
        },
        S2q: {
          type: "structure",
          required: [
            "state"
          ],
          members: {
            state: {},
            error: {
              shape: "S1n"
            }
          }
        },
        S2w: {
          type: "structure",
          members: {
            greengrass: {
              type: "structure",
              required: [
                "groupArn"
              ],
              members: {
                groupArn: {}
              }
            },
            greengrassV2: {
              type: "structure",
              required: [
                "coreDeviceThingName"
              ],
              members: {
                coreDeviceThingName: {}
              }
            }
          }
        },
        S33: {
          type: "structure",
          required: [
            "data",
            "type"
          ],
          members: {
            data: {
              type: "blob"
            },
            type: {}
          }
        },
        S37: {
          type: "structure",
          required: [
            "alarmRoleArn"
          ],
          members: {
            alarmRoleArn: {},
            notificationLambdaArn: {}
          }
        },
        S3a: {
          type: "structure",
          required: [
            "state"
          ],
          members: {
            state: {},
            error: {
              type: "structure",
              members: {
                code: {},
                message: {}
              }
            }
          }
        },
        S40: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "id",
              "name",
              "dataType"
            ],
            members: {
              id: {},
              name: {},
              alias: {},
              notification: {
                shape: "S43"
              },
              dataType: {},
              dataTypeSpec: {},
              unit: {}
            }
          }
        },
        S43: {
          type: "structure",
          required: [
            "topic",
            "state"
          ],
          members: {
            topic: {},
            state: {}
          }
        },
        S46: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              id: {},
              name: {}
            }
          }
        },
        S4c: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "dataType",
              "type"
            ],
            members: {
              id: {},
              name: {},
              dataType: {},
              dataTypeSpec: {},
              unit: {},
              type: {
                shape: "S1z"
              }
            }
          }
        },
        S4e: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "childAssetModelId"
            ],
            members: {
              id: {},
              name: {},
              childAssetModelId: {}
            }
          }
        },
        S4g: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "type"
            ],
            members: {
              name: {},
              description: {},
              type: {},
              properties: {
                shape: "S4c"
              }
            }
          }
        },
        S4k: {
          type: "structure",
          required: [
            "id",
            "name",
            "dataType"
          ],
          members: {
            id: {},
            name: {},
            alias: {},
            notification: {
              shape: "S43"
            },
            dataType: {},
            unit: {},
            type: {
              shape: "S1z"
            }
          }
        },
        S4r: {
          type: "structure",
          required: [
            "state"
          ],
          members: {
            state: {},
            error: {
              type: "structure",
              required: [
                "code",
                "message"
              ],
              members: {
                code: {},
                message: {}
              }
            }
          }
        },
        S4w: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "capabilityNamespace",
              "capabilitySyncStatus"
            ],
            members: {
              capabilityNamespace: {},
              capabilitySyncStatus: {}
            }
          }
        },
        S55: {
          type: "structure",
          required: [
            "level"
          ],
          members: {
            level: {}
          }
        },
        S5g: {
          type: "structure",
          required: [
            "customerManagedS3Storage"
          ],
          members: {
            customerManagedS3Storage: {
              type: "structure",
              required: [
                "s3ResourceArn",
                "roleArn"
              ],
              members: {
                s3ResourceArn: {},
                roleArn: {}
              }
            }
          }
        },
        S5n: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotsitewise-2019-12-02.paginators.json
var require_iotsitewise_2019_12_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iotsitewise-2019-12-02.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetAssetPropertyAggregates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "aggregatedValues"
        },
        GetAssetPropertyValueHistory: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assetPropertyValueHistory"
        },
        GetInterpolatedAssetPropertyValues: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "interpolatedAssetPropertyValues"
        },
        ListAccessPolicies: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "accessPolicySummaries"
        },
        ListAssetModels: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assetModelSummaries"
        },
        ListAssetRelationships: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assetRelationshipSummaries"
        },
        ListAssets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assetSummaries"
        },
        ListAssociatedAssets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assetSummaries"
        },
        ListDashboards: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "dashboardSummaries"
        },
        ListGateways: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "gatewaySummaries"
        },
        ListPortals: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "portalSummaries"
        },
        ListProjectAssets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assetIds"
        },
        ListProjects: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "projectSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotsitewise-2019-12-02.waiters2.json
var require_iotsitewise_2019_12_02_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/iotsitewise-2019-12-02.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        AssetModelNotExists: {
          delay: 3,
          maxAttempts: 20,
          operation: "DescribeAssetModel",
          acceptors: [
            {
              state: "success",
              matcher: "error",
              expected: "ResourceNotFoundException"
            }
          ]
        },
        AssetModelActive: {
          delay: 3,
          maxAttempts: 20,
          operation: "DescribeAssetModel",
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "assetModelStatus.state",
              expected: "ACTIVE"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "assetModelStatus.state",
              expected: "FAILED"
            }
          ]
        },
        AssetNotExists: {
          delay: 3,
          maxAttempts: 20,
          operation: "DescribeAsset",
          acceptors: [
            {
              state: "success",
              matcher: "error",
              expected: "ResourceNotFoundException"
            }
          ]
        },
        AssetActive: {
          delay: 3,
          maxAttempts: 20,
          operation: "DescribeAsset",
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "assetStatus.state",
              expected: "ACTIVE"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "assetStatus.state",
              expected: "FAILED"
            }
          ]
        },
        PortalNotExists: {
          delay: 3,
          maxAttempts: 20,
          operation: "DescribePortal",
          acceptors: [
            {
              state: "success",
              matcher: "error",
              expected: "ResourceNotFoundException"
            }
          ]
        },
        PortalActive: {
          delay: 3,
          maxAttempts: 20,
          operation: "DescribePortal",
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "portalStatus.state",
              expected: "ACTIVE"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iotsitewise.js
var require_iotsitewise = __commonJS({
  "node_modules/aws-sdk/clients/iotsitewise.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["iotsitewise"] = {};
    AWS3.IoTSiteWise = Service.defineService("iotsitewise", ["2019-12-02"]);
    Object.defineProperty(apiLoader.services["iotsitewise"], "2019-12-02", {
      get: function get() {
        var model = require_iotsitewise_2019_12_02_min();
        model.paginators = require_iotsitewise_2019_12_02_paginators().pagination;
        model.waiters = require_iotsitewise_2019_12_02_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.IoTSiteWise;
  }
});

// node_modules/aws-sdk/apis/macie2-2020-01-01.min.json
var require_macie2_2020_01_01_min = __commonJS({
  "node_modules/aws-sdk/apis/macie2-2020-01-01.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2020-01-01",
        endpointPrefix: "macie2",
        signingName: "macie2",
        serviceFullName: "Amazon Macie 2",
        serviceId: "Macie2",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "macie2-2020-01-01",
        signatureVersion: "v4"
      },
      operations: {
        AcceptInvitation: {
          http: {
            requestUri: "/invitations/accept",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              administratorAccountId: {
                locationName: "administratorAccountId"
              },
              invitationId: {
                locationName: "invitationId"
              },
              masterAccount: {
                locationName: "masterAccount"
              }
            },
            required: [
              "invitationId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        BatchGetCustomDataIdentifiers: {
          http: {
            requestUri: "/custom-data-identifiers/get",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ids: {
                shape: "S5",
                locationName: "ids"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              customDataIdentifiers: {
                locationName: "customDataIdentifiers",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {
                      locationName: "arn"
                    },
                    createdAt: {
                      shape: "S9",
                      locationName: "createdAt"
                    },
                    deleted: {
                      locationName: "deleted",
                      type: "boolean"
                    },
                    description: {
                      locationName: "description"
                    },
                    id: {
                      locationName: "id"
                    },
                    name: {
                      locationName: "name"
                    }
                  }
                }
              },
              notFoundIdentifierIds: {
                shape: "S5",
                locationName: "notFoundIdentifierIds"
              }
            }
          }
        },
        CreateClassificationJob: {
          http: {
            requestUri: "/jobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                locationName: "clientToken",
                idempotencyToken: true
              },
              customDataIdentifierIds: {
                shape: "S5",
                locationName: "customDataIdentifierIds"
              },
              description: {
                locationName: "description"
              },
              initialRun: {
                locationName: "initialRun",
                type: "boolean"
              },
              jobType: {
                locationName: "jobType"
              },
              managedDataIdentifierIds: {
                shape: "S5",
                locationName: "managedDataIdentifierIds"
              },
              managedDataIdentifierSelector: {
                locationName: "managedDataIdentifierSelector"
              },
              name: {
                locationName: "name"
              },
              s3JobDefinition: {
                shape: "Se",
                locationName: "s3JobDefinition"
              },
              samplingPercentage: {
                locationName: "samplingPercentage",
                type: "integer"
              },
              scheduleFrequency: {
                shape: "S12",
                locationName: "scheduleFrequency"
              },
              tags: {
                shape: "S17",
                locationName: "tags"
              }
            },
            required: [
              "s3JobDefinition",
              "jobType",
              "clientToken",
              "name"
            ]
          },
          output: {
            type: "structure",
            members: {
              jobArn: {
                locationName: "jobArn"
              },
              jobId: {
                locationName: "jobId"
              }
            }
          }
        },
        CreateCustomDataIdentifier: {
          http: {
            requestUri: "/custom-data-identifiers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                locationName: "clientToken",
                idempotencyToken: true
              },
              description: {
                locationName: "description"
              },
              ignoreWords: {
                shape: "S5",
                locationName: "ignoreWords"
              },
              keywords: {
                shape: "S5",
                locationName: "keywords"
              },
              maximumMatchDistance: {
                locationName: "maximumMatchDistance",
                type: "integer"
              },
              name: {
                locationName: "name"
              },
              regex: {
                locationName: "regex"
              },
              tags: {
                shape: "S17",
                locationName: "tags"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              customDataIdentifierId: {
                locationName: "customDataIdentifierId"
              }
            }
          }
        },
        CreateFindingsFilter: {
          http: {
            requestUri: "/findingsfilters",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              action: {
                locationName: "action"
              },
              clientToken: {
                locationName: "clientToken",
                idempotencyToken: true
              },
              description: {
                locationName: "description"
              },
              findingCriteria: {
                shape: "S1d",
                locationName: "findingCriteria"
              },
              name: {
                locationName: "name"
              },
              position: {
                locationName: "position",
                type: "integer"
              },
              tags: {
                shape: "S17",
                locationName: "tags"
              }
            },
            required: [
              "action",
              "findingCriteria",
              "name"
            ]
          },
          output: {
            type: "structure",
            members: {
              arn: {
                locationName: "arn"
              },
              id: {
                locationName: "id"
              }
            }
          }
        },
        CreateInvitations: {
          http: {
            requestUri: "/invitations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              accountIds: {
                shape: "S5",
                locationName: "accountIds"
              },
              disableEmailNotification: {
                locationName: "disableEmailNotification",
                type: "boolean"
              },
              message: {
                locationName: "message"
              }
            },
            required: [
              "accountIds"
            ]
          },
          output: {
            type: "structure",
            members: {
              unprocessedAccounts: {
                shape: "S1k",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        CreateMember: {
          http: {
            requestUri: "/members",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              account: {
                locationName: "account",
                type: "structure",
                members: {
                  accountId: {
                    locationName: "accountId"
                  },
                  email: {
                    locationName: "email"
                  }
                },
                required: [
                  "email",
                  "accountId"
                ]
              },
              tags: {
                shape: "S17",
                locationName: "tags"
              }
            },
            required: [
              "account"
            ]
          },
          output: {
            type: "structure",
            members: {
              arn: {
                locationName: "arn"
              }
            }
          }
        },
        CreateSampleFindings: {
          http: {
            requestUri: "/findings/sample",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              findingTypes: {
                locationName: "findingTypes",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeclineInvitations: {
          http: {
            requestUri: "/invitations/decline",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              accountIds: {
                shape: "S5",
                locationName: "accountIds"
              }
            },
            required: [
              "accountIds"
            ]
          },
          output: {
            type: "structure",
            members: {
              unprocessedAccounts: {
                shape: "S1k",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        DeleteCustomDataIdentifier: {
          http: {
            method: "DELETE",
            requestUri: "/custom-data-identifiers/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteFindingsFilter: {
          http: {
            method: "DELETE",
            requestUri: "/findingsfilters/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteInvitations: {
          http: {
            requestUri: "/invitations/delete",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              accountIds: {
                shape: "S5",
                locationName: "accountIds"
              }
            },
            required: [
              "accountIds"
            ]
          },
          output: {
            type: "structure",
            members: {
              unprocessedAccounts: {
                shape: "S1k",
                locationName: "unprocessedAccounts"
              }
            }
          }
        },
        DeleteMember: {
          http: {
            method: "DELETE",
            requestUri: "/members/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeBuckets: {
          http: {
            requestUri: "/datasources/s3",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              criteria: {
                locationName: "criteria",
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    eq: {
                      shape: "S5",
                      locationName: "eq"
                    },
                    gt: {
                      locationName: "gt",
                      type: "long"
                    },
                    gte: {
                      locationName: "gte",
                      type: "long"
                    },
                    lt: {
                      locationName: "lt",
                      type: "long"
                    },
                    lte: {
                      locationName: "lte",
                      type: "long"
                    },
                    neq: {
                      shape: "S5",
                      locationName: "neq"
                    },
                    prefix: {
                      locationName: "prefix"
                    }
                  }
                }
              },
              maxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                locationName: "nextToken"
              },
              sortCriteria: {
                locationName: "sortCriteria",
                type: "structure",
                members: {
                  attributeName: {
                    locationName: "attributeName"
                  },
                  orderBy: {
                    locationName: "orderBy"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              buckets: {
                locationName: "buckets",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {
                      locationName: "accountId"
                    },
                    allowsUnencryptedObjectUploads: {
                      locationName: "allowsUnencryptedObjectUploads"
                    },
                    bucketArn: {
                      locationName: "bucketArn"
                    },
                    bucketCreatedAt: {
                      shape: "S9",
                      locationName: "bucketCreatedAt"
                    },
                    bucketName: {
                      locationName: "bucketName"
                    },
                    classifiableObjectCount: {
                      locationName: "classifiableObjectCount",
                      type: "long"
                    },
                    classifiableSizeInBytes: {
                      locationName: "classifiableSizeInBytes",
                      type: "long"
                    },
                    errorCode: {
                      locationName: "errorCode"
                    },
                    errorMessage: {
                      locationName: "errorMessage"
                    },
                    jobDetails: {
                      shape: "S2e",
                      locationName: "jobDetails"
                    },
                    lastUpdated: {
                      shape: "S9",
                      locationName: "lastUpdated"
                    },
                    objectCount: {
                      locationName: "objectCount",
                      type: "long"
                    },
                    objectCountByEncryptionType: {
                      shape: "S2h",
                      locationName: "objectCountByEncryptionType"
                    },
                    publicAccess: {
                      shape: "S2i",
                      locationName: "publicAccess"
                    },
                    region: {
                      locationName: "region"
                    },
                    replicationDetails: {
                      locationName: "replicationDetails",
                      type: "structure",
                      members: {
                        replicated: {
                          locationName: "replicated",
                          type: "boolean"
                        },
                        replicatedExternally: {
                          locationName: "replicatedExternally",
                          type: "boolean"
                        },
                        replicationAccounts: {
                          shape: "S5",
                          locationName: "replicationAccounts"
                        }
                      }
                    },
                    serverSideEncryption: {
                      locationName: "serverSideEncryption",
                      type: "structure",
                      members: {
                        kmsMasterKeyId: {
                          locationName: "kmsMasterKeyId"
                        },
                        type: {
                          locationName: "type"
                        }
                      }
                    },
                    sharedAccess: {
                      locationName: "sharedAccess"
                    },
                    sizeInBytes: {
                      locationName: "sizeInBytes",
                      type: "long"
                    },
                    sizeInBytesCompressed: {
                      locationName: "sizeInBytesCompressed",
                      type: "long"
                    },
                    tags: {
                      locationName: "tags",
                      type: "list",
                      member: {
                        shape: "S2v"
                      }
                    },
                    unclassifiableObjectCount: {
                      shape: "S2w",
                      locationName: "unclassifiableObjectCount"
                    },
                    unclassifiableObjectSizeInBytes: {
                      shape: "S2w",
                      locationName: "unclassifiableObjectSizeInBytes"
                    },
                    versioning: {
                      locationName: "versioning",
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        DescribeClassificationJob: {
          http: {
            method: "GET",
            requestUri: "/jobs/{jobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            },
            required: [
              "jobId"
            ]
          },
          output: {
            type: "structure",
            members: {
              clientToken: {
                locationName: "clientToken",
                idempotencyToken: true
              },
              createdAt: {
                shape: "S9",
                locationName: "createdAt"
              },
              customDataIdentifierIds: {
                shape: "S5",
                locationName: "customDataIdentifierIds"
              },
              description: {
                locationName: "description"
              },
              initialRun: {
                locationName: "initialRun",
                type: "boolean"
              },
              jobArn: {
                locationName: "jobArn"
              },
              jobId: {
                locationName: "jobId"
              },
              jobStatus: {
                locationName: "jobStatus"
              },
              jobType: {
                locationName: "jobType"
              },
              lastRunErrorStatus: {
                shape: "S30",
                locationName: "lastRunErrorStatus"
              },
              lastRunTime: {
                shape: "S9",
                locationName: "lastRunTime"
              },
              managedDataIdentifierIds: {
                shape: "S5",
                locationName: "managedDataIdentifierIds"
              },
              managedDataIdentifierSelector: {
                locationName: "managedDataIdentifierSelector"
              },
              name: {
                locationName: "name"
              },
              s3JobDefinition: {
                shape: "Se",
                locationName: "s3JobDefinition"
              },
              samplingPercentage: {
                locationName: "samplingPercentage",
                type: "integer"
              },
              scheduleFrequency: {
                shape: "S12",
                locationName: "scheduleFrequency"
              },
              statistics: {
                locationName: "statistics",
                type: "structure",
                members: {
                  approximateNumberOfObjectsToProcess: {
                    locationName: "approximateNumberOfObjectsToProcess",
                    type: "double"
                  },
                  numberOfRuns: {
                    locationName: "numberOfRuns",
                    type: "double"
                  }
                }
              },
              tags: {
                shape: "S17",
                locationName: "tags"
              },
              userPausedDetails: {
                shape: "S34",
                locationName: "userPausedDetails"
              }
            }
          }
        },
        DescribeOrganizationConfiguration: {
          http: {
            method: "GET",
            requestUri: "/admin/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              autoEnable: {
                locationName: "autoEnable",
                type: "boolean"
              },
              maxAccountLimitReached: {
                locationName: "maxAccountLimitReached",
                type: "boolean"
              }
            }
          }
        },
        DisableMacie: {
          http: {
            method: "DELETE",
            requestUri: "/macie",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisableOrganizationAdminAccount: {
          http: {
            method: "DELETE",
            requestUri: "/admin",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              adminAccountId: {
                location: "querystring",
                locationName: "adminAccountId"
              }
            },
            required: [
              "adminAccountId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateFromAdministratorAccount: {
          http: {
            requestUri: "/administrator/disassociate",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateFromMasterAccount: {
          http: {
            requestUri: "/master/disassociate",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateMember: {
          http: {
            requestUri: "/members/disassociate/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableMacie: {
          http: {
            requestUri: "/macie",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                locationName: "clientToken",
                idempotencyToken: true
              },
              findingPublishingFrequency: {
                locationName: "findingPublishingFrequency"
              },
              status: {
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        EnableOrganizationAdminAccount: {
          http: {
            requestUri: "/admin",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              adminAccountId: {
                locationName: "adminAccountId"
              },
              clientToken: {
                locationName: "clientToken",
                idempotencyToken: true
              }
            },
            required: [
              "adminAccountId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAdministratorAccount: {
          http: {
            method: "GET",
            requestUri: "/administrator",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              administrator: {
                shape: "S3p",
                locationName: "administrator"
              }
            }
          }
        },
        GetBucketStatistics: {
          http: {
            requestUri: "/datasources/s3/statistics",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              accountId: {
                locationName: "accountId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              bucketCount: {
                locationName: "bucketCount",
                type: "long"
              },
              bucketCountByEffectivePermission: {
                locationName: "bucketCountByEffectivePermission",
                type: "structure",
                members: {
                  publiclyAccessible: {
                    locationName: "publiclyAccessible",
                    type: "long"
                  },
                  publiclyReadable: {
                    locationName: "publiclyReadable",
                    type: "long"
                  },
                  publiclyWritable: {
                    locationName: "publiclyWritable",
                    type: "long"
                  },
                  unknown: {
                    locationName: "unknown",
                    type: "long"
                  }
                }
              },
              bucketCountByEncryptionType: {
                locationName: "bucketCountByEncryptionType",
                type: "structure",
                members: {
                  kmsManaged: {
                    locationName: "kmsManaged",
                    type: "long"
                  },
                  s3Managed: {
                    locationName: "s3Managed",
                    type: "long"
                  },
                  unencrypted: {
                    locationName: "unencrypted",
                    type: "long"
                  },
                  unknown: {
                    locationName: "unknown",
                    type: "long"
                  }
                }
              },
              bucketCountByObjectEncryptionRequirement: {
                locationName: "bucketCountByObjectEncryptionRequirement",
                type: "structure",
                members: {
                  allowsUnencryptedObjectUploads: {
                    locationName: "allowsUnencryptedObjectUploads",
                    type: "long"
                  },
                  deniesUnencryptedObjectUploads: {
                    locationName: "deniesUnencryptedObjectUploads",
                    type: "long"
                  },
                  unknown: {
                    locationName: "unknown",
                    type: "long"
                  }
                }
              },
              bucketCountBySharedAccessType: {
                locationName: "bucketCountBySharedAccessType",
                type: "structure",
                members: {
                  external: {
                    locationName: "external",
                    type: "long"
                  },
                  internal: {
                    locationName: "internal",
                    type: "long"
                  },
                  notShared: {
                    locationName: "notShared",
                    type: "long"
                  },
                  unknown: {
                    locationName: "unknown",
                    type: "long"
                  }
                }
              },
              classifiableObjectCount: {
                locationName: "classifiableObjectCount",
                type: "long"
              },
              classifiableSizeInBytes: {
                locationName: "classifiableSizeInBytes",
                type: "long"
              },
              lastUpdated: {
                shape: "S9",
                locationName: "lastUpdated"
              },
              objectCount: {
                locationName: "objectCount",
                type: "long"
              },
              sizeInBytes: {
                locationName: "sizeInBytes",
                type: "long"
              },
              sizeInBytesCompressed: {
                locationName: "sizeInBytesCompressed",
                type: "long"
              },
              unclassifiableObjectCount: {
                shape: "S2w",
                locationName: "unclassifiableObjectCount"
              },
              unclassifiableObjectSizeInBytes: {
                shape: "S2w",
                locationName: "unclassifiableObjectSizeInBytes"
              }
            }
          }
        },
        GetClassificationExportConfiguration: {
          http: {
            method: "GET",
            requestUri: "/classification-export-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              configuration: {
                shape: "S3z",
                locationName: "configuration"
              }
            }
          }
        },
        GetCustomDataIdentifier: {
          http: {
            method: "GET",
            requestUri: "/custom-data-identifiers/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {
              arn: {
                locationName: "arn"
              },
              createdAt: {
                shape: "S9",
                locationName: "createdAt"
              },
              deleted: {
                locationName: "deleted",
                type: "boolean"
              },
              description: {
                locationName: "description"
              },
              id: {
                locationName: "id"
              },
              ignoreWords: {
                shape: "S5",
                locationName: "ignoreWords"
              },
              keywords: {
                shape: "S5",
                locationName: "keywords"
              },
              maximumMatchDistance: {
                locationName: "maximumMatchDistance",
                type: "integer"
              },
              name: {
                locationName: "name"
              },
              regex: {
                locationName: "regex"
              },
              tags: {
                shape: "S17",
                locationName: "tags"
              }
            }
          }
        },
        GetFindingStatistics: {
          http: {
            requestUri: "/findings/statistics",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              findingCriteria: {
                shape: "S1d",
                locationName: "findingCriteria"
              },
              groupBy: {
                locationName: "groupBy"
              },
              size: {
                locationName: "size",
                type: "integer"
              },
              sortCriteria: {
                locationName: "sortCriteria",
                type: "structure",
                members: {
                  attributeName: {
                    locationName: "attributeName"
                  },
                  orderBy: {
                    locationName: "orderBy"
                  }
                }
              }
            },
            required: [
              "groupBy"
            ]
          },
          output: {
            type: "structure",
            members: {
              countsByGroup: {
                locationName: "countsByGroup",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    count: {
                      locationName: "count",
                      type: "long"
                    },
                    groupKey: {
                      locationName: "groupKey"
                    }
                  }
                }
              }
            }
          }
        },
        GetFindings: {
          http: {
            requestUri: "/findings/describe",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              findingIds: {
                shape: "S5",
                locationName: "findingIds"
              },
              sortCriteria: {
                shape: "S4b",
                locationName: "sortCriteria"
              }
            },
            required: [
              "findingIds"
            ]
          },
          output: {
            type: "structure",
            members: {
              findings: {
                locationName: "findings",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {
                      locationName: "accountId"
                    },
                    archived: {
                      locationName: "archived",
                      type: "boolean"
                    },
                    category: {
                      locationName: "category"
                    },
                    classificationDetails: {
                      locationName: "classificationDetails",
                      type: "structure",
                      members: {
                        detailedResultsLocation: {
                          locationName: "detailedResultsLocation"
                        },
                        jobArn: {
                          locationName: "jobArn"
                        },
                        jobId: {
                          locationName: "jobId"
                        },
                        result: {
                          locationName: "result",
                          type: "structure",
                          members: {
                            additionalOccurrences: {
                              locationName: "additionalOccurrences",
                              type: "boolean"
                            },
                            customDataIdentifiers: {
                              locationName: "customDataIdentifiers",
                              type: "structure",
                              members: {
                                detections: {
                                  locationName: "detections",
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      arn: {
                                        locationName: "arn"
                                      },
                                      count: {
                                        locationName: "count",
                                        type: "long"
                                      },
                                      name: {
                                        locationName: "name"
                                      },
                                      occurrences: {
                                        shape: "S4l",
                                        locationName: "occurrences"
                                      }
                                    }
                                  }
                                },
                                totalCount: {
                                  locationName: "totalCount",
                                  type: "long"
                                }
                              }
                            },
                            mimeType: {
                              locationName: "mimeType"
                            },
                            sensitiveData: {
                              locationName: "sensitiveData",
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  category: {
                                    locationName: "category"
                                  },
                                  detections: {
                                    locationName: "detections",
                                    type: "list",
                                    member: {
                                      type: "structure",
                                      members: {
                                        count: {
                                          locationName: "count",
                                          type: "long"
                                        },
                                        occurrences: {
                                          shape: "S4l",
                                          locationName: "occurrences"
                                        },
                                        type: {
                                          locationName: "type"
                                        }
                                      }
                                    }
                                  },
                                  totalCount: {
                                    locationName: "totalCount",
                                    type: "long"
                                  }
                                }
                              }
                            },
                            sizeClassified: {
                              locationName: "sizeClassified",
                              type: "long"
                            },
                            status: {
                              locationName: "status",
                              type: "structure",
                              members: {
                                code: {
                                  locationName: "code"
                                },
                                reason: {
                                  locationName: "reason"
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    count: {
                      locationName: "count",
                      type: "long"
                    },
                    createdAt: {
                      shape: "S9",
                      locationName: "createdAt"
                    },
                    description: {
                      locationName: "description"
                    },
                    id: {
                      locationName: "id"
                    },
                    partition: {
                      locationName: "partition"
                    },
                    policyDetails: {
                      locationName: "policyDetails",
                      type: "structure",
                      members: {
                        action: {
                          locationName: "action",
                          type: "structure",
                          members: {
                            actionType: {
                              locationName: "actionType"
                            },
                            apiCallDetails: {
                              locationName: "apiCallDetails",
                              type: "structure",
                              members: {
                                api: {
                                  locationName: "api"
                                },
                                apiServiceName: {
                                  locationName: "apiServiceName"
                                },
                                firstSeen: {
                                  shape: "S9",
                                  locationName: "firstSeen"
                                },
                                lastSeen: {
                                  shape: "S9",
                                  locationName: "lastSeen"
                                }
                              }
                            }
                          }
                        },
                        actor: {
                          locationName: "actor",
                          type: "structure",
                          members: {
                            domainDetails: {
                              locationName: "domainDetails",
                              type: "structure",
                              members: {
                                domainName: {
                                  locationName: "domainName"
                                }
                              }
                            },
                            ipAddressDetails: {
                              locationName: "ipAddressDetails",
                              type: "structure",
                              members: {
                                ipAddressV4: {
                                  locationName: "ipAddressV4"
                                },
                                ipCity: {
                                  locationName: "ipCity",
                                  type: "structure",
                                  members: {
                                    name: {
                                      locationName: "name"
                                    }
                                  }
                                },
                                ipCountry: {
                                  locationName: "ipCountry",
                                  type: "structure",
                                  members: {
                                    code: {
                                      locationName: "code"
                                    },
                                    name: {
                                      locationName: "name"
                                    }
                                  }
                                },
                                ipGeoLocation: {
                                  locationName: "ipGeoLocation",
                                  type: "structure",
                                  members: {
                                    lat: {
                                      locationName: "lat",
                                      type: "double"
                                    },
                                    lon: {
                                      locationName: "lon",
                                      type: "double"
                                    }
                                  }
                                },
                                ipOwner: {
                                  locationName: "ipOwner",
                                  type: "structure",
                                  members: {
                                    asn: {
                                      locationName: "asn"
                                    },
                                    asnOrg: {
                                      locationName: "asnOrg"
                                    },
                                    isp: {
                                      locationName: "isp"
                                    },
                                    org: {
                                      locationName: "org"
                                    }
                                  }
                                }
                              }
                            },
                            userIdentity: {
                              locationName: "userIdentity",
                              type: "structure",
                              members: {
                                assumedRole: {
                                  locationName: "assumedRole",
                                  type: "structure",
                                  members: {
                                    accessKeyId: {
                                      locationName: "accessKeyId"
                                    },
                                    accountId: {
                                      locationName: "accountId"
                                    },
                                    arn: {
                                      locationName: "arn"
                                    },
                                    principalId: {
                                      locationName: "principalId"
                                    },
                                    sessionContext: {
                                      shape: "S5d",
                                      locationName: "sessionContext"
                                    }
                                  }
                                },
                                awsAccount: {
                                  locationName: "awsAccount",
                                  type: "structure",
                                  members: {
                                    accountId: {
                                      locationName: "accountId"
                                    },
                                    principalId: {
                                      locationName: "principalId"
                                    }
                                  }
                                },
                                awsService: {
                                  locationName: "awsService",
                                  type: "structure",
                                  members: {
                                    invokedBy: {
                                      locationName: "invokedBy"
                                    }
                                  }
                                },
                                federatedUser: {
                                  locationName: "federatedUser",
                                  type: "structure",
                                  members: {
                                    accessKeyId: {
                                      locationName: "accessKeyId"
                                    },
                                    accountId: {
                                      locationName: "accountId"
                                    },
                                    arn: {
                                      locationName: "arn"
                                    },
                                    principalId: {
                                      locationName: "principalId"
                                    },
                                    sessionContext: {
                                      shape: "S5d",
                                      locationName: "sessionContext"
                                    }
                                  }
                                },
                                iamUser: {
                                  locationName: "iamUser",
                                  type: "structure",
                                  members: {
                                    accountId: {
                                      locationName: "accountId"
                                    },
                                    arn: {
                                      locationName: "arn"
                                    },
                                    principalId: {
                                      locationName: "principalId"
                                    },
                                    userName: {
                                      locationName: "userName"
                                    }
                                  }
                                },
                                root: {
                                  locationName: "root",
                                  type: "structure",
                                  members: {
                                    accountId: {
                                      locationName: "accountId"
                                    },
                                    arn: {
                                      locationName: "arn"
                                    },
                                    principalId: {
                                      locationName: "principalId"
                                    }
                                  }
                                },
                                type: {
                                  locationName: "type"
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    region: {
                      locationName: "region"
                    },
                    resourcesAffected: {
                      locationName: "resourcesAffected",
                      type: "structure",
                      members: {
                        s3Bucket: {
                          locationName: "s3Bucket",
                          type: "structure",
                          members: {
                            allowsUnencryptedObjectUploads: {
                              locationName: "allowsUnencryptedObjectUploads"
                            },
                            arn: {
                              locationName: "arn"
                            },
                            createdAt: {
                              shape: "S9",
                              locationName: "createdAt"
                            },
                            defaultServerSideEncryption: {
                              shape: "S5o",
                              locationName: "defaultServerSideEncryption"
                            },
                            name: {
                              locationName: "name"
                            },
                            owner: {
                              locationName: "owner",
                              type: "structure",
                              members: {
                                displayName: {
                                  locationName: "displayName"
                                },
                                id: {
                                  locationName: "id"
                                }
                              }
                            },
                            publicAccess: {
                              shape: "S2i",
                              locationName: "publicAccess"
                            },
                            tags: {
                              shape: "S5r",
                              locationName: "tags"
                            }
                          }
                        },
                        s3Object: {
                          locationName: "s3Object",
                          type: "structure",
                          members: {
                            bucketArn: {
                              locationName: "bucketArn"
                            },
                            eTag: {
                              locationName: "eTag"
                            },
                            extension: {
                              locationName: "extension"
                            },
                            key: {
                              locationName: "key"
                            },
                            lastModified: {
                              shape: "S9",
                              locationName: "lastModified"
                            },
                            path: {
                              locationName: "path"
                            },
                            publicAccess: {
                              locationName: "publicAccess",
                              type: "boolean"
                            },
                            serverSideEncryption: {
                              shape: "S5o",
                              locationName: "serverSideEncryption"
                            },
                            size: {
                              locationName: "size",
                              type: "long"
                            },
                            storageClass: {
                              locationName: "storageClass"
                            },
                            tags: {
                              shape: "S5r",
                              locationName: "tags"
                            },
                            versionId: {
                              locationName: "versionId"
                            }
                          }
                        }
                      }
                    },
                    sample: {
                      locationName: "sample",
                      type: "boolean"
                    },
                    schemaVersion: {
                      locationName: "schemaVersion"
                    },
                    severity: {
                      locationName: "severity",
                      type: "structure",
                      members: {
                        description: {
                          locationName: "description"
                        },
                        score: {
                          locationName: "score",
                          type: "long"
                        }
                      }
                    },
                    title: {
                      locationName: "title"
                    },
                    type: {
                      locationName: "type"
                    },
                    updatedAt: {
                      shape: "S9",
                      locationName: "updatedAt"
                    }
                  }
                }
              }
            }
          }
        },
        GetFindingsFilter: {
          http: {
            method: "GET",
            requestUri: "/findingsfilters/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {
              action: {
                locationName: "action"
              },
              arn: {
                locationName: "arn"
              },
              description: {
                locationName: "description"
              },
              findingCriteria: {
                shape: "S1d",
                locationName: "findingCriteria"
              },
              id: {
                locationName: "id"
              },
              name: {
                locationName: "name"
              },
              position: {
                locationName: "position",
                type: "integer"
              },
              tags: {
                shape: "S17",
                locationName: "tags"
              }
            }
          }
        },
        GetFindingsPublicationConfiguration: {
          http: {
            method: "GET",
            requestUri: "/findings-publication-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              securityHubConfiguration: {
                shape: "S60",
                locationName: "securityHubConfiguration"
              }
            }
          }
        },
        GetInvitationsCount: {
          http: {
            method: "GET",
            requestUri: "/invitations/count",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              invitationsCount: {
                locationName: "invitationsCount",
                type: "long"
              }
            }
          }
        },
        GetMacieSession: {
          http: {
            method: "GET",
            requestUri: "/macie",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              createdAt: {
                shape: "S9",
                locationName: "createdAt"
              },
              findingPublishingFrequency: {
                locationName: "findingPublishingFrequency"
              },
              serviceRole: {
                locationName: "serviceRole"
              },
              status: {
                locationName: "status"
              },
              updatedAt: {
                shape: "S9",
                locationName: "updatedAt"
              }
            }
          }
        },
        GetMasterAccount: {
          http: {
            method: "GET",
            requestUri: "/master",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              master: {
                shape: "S3p",
                locationName: "master"
              }
            }
          }
        },
        GetMember: {
          http: {
            method: "GET",
            requestUri: "/members/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {
              accountId: {
                locationName: "accountId"
              },
              administratorAccountId: {
                locationName: "administratorAccountId"
              },
              arn: {
                locationName: "arn"
              },
              email: {
                locationName: "email"
              },
              invitedAt: {
                shape: "S9",
                locationName: "invitedAt"
              },
              masterAccountId: {
                locationName: "masterAccountId"
              },
              relationshipStatus: {
                locationName: "relationshipStatus"
              },
              tags: {
                shape: "S17",
                locationName: "tags"
              },
              updatedAt: {
                shape: "S9",
                locationName: "updatedAt"
              }
            }
          }
        },
        GetUsageStatistics: {
          http: {
            requestUri: "/usage/statistics",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filterBy: {
                locationName: "filterBy",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    comparator: {
                      locationName: "comparator"
                    },
                    key: {
                      locationName: "key"
                    },
                    values: {
                      shape: "S5",
                      locationName: "values"
                    }
                  }
                }
              },
              maxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                locationName: "nextToken"
              },
              sortBy: {
                locationName: "sortBy",
                type: "structure",
                members: {
                  key: {
                    locationName: "key"
                  },
                  orderBy: {
                    locationName: "orderBy"
                  }
                }
              },
              timeRange: {
                locationName: "timeRange"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {
                locationName: "nextToken"
              },
              records: {
                locationName: "records",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {
                      locationName: "accountId"
                    },
                    freeTrialStartDate: {
                      shape: "S9",
                      locationName: "freeTrialStartDate"
                    },
                    usage: {
                      locationName: "usage",
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          currency: {
                            locationName: "currency"
                          },
                          estimatedCost: {
                            locationName: "estimatedCost"
                          },
                          serviceLimit: {
                            locationName: "serviceLimit",
                            type: "structure",
                            members: {
                              isServiceLimited: {
                                locationName: "isServiceLimited",
                                type: "boolean"
                              },
                              unit: {
                                locationName: "unit"
                              },
                              value: {
                                locationName: "value",
                                type: "long"
                              }
                            }
                          },
                          type: {
                            locationName: "type"
                          }
                        }
                      }
                    }
                  }
                }
              },
              timeRange: {
                locationName: "timeRange"
              }
            }
          }
        },
        GetUsageTotals: {
          http: {
            method: "GET",
            requestUri: "/usage",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              timeRange: {
                location: "querystring",
                locationName: "timeRange"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              timeRange: {
                locationName: "timeRange"
              },
              usageTotals: {
                locationName: "usageTotals",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    currency: {
                      locationName: "currency"
                    },
                    estimatedCost: {
                      locationName: "estimatedCost"
                    },
                    type: {
                      locationName: "type"
                    }
                  }
                }
              }
            }
          }
        },
        ListClassificationJobs: {
          http: {
            requestUri: "/jobs/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filterCriteria: {
                locationName: "filterCriteria",
                type: "structure",
                members: {
                  excludes: {
                    shape: "S6w",
                    locationName: "excludes"
                  },
                  includes: {
                    shape: "S6w",
                    locationName: "includes"
                  }
                }
              },
              maxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                locationName: "nextToken"
              },
              sortCriteria: {
                locationName: "sortCriteria",
                type: "structure",
                members: {
                  attributeName: {
                    locationName: "attributeName"
                  },
                  orderBy: {
                    locationName: "orderBy"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    bucketDefinitions: {
                      shape: "Sf",
                      locationName: "bucketDefinitions"
                    },
                    createdAt: {
                      shape: "S9",
                      locationName: "createdAt"
                    },
                    jobId: {
                      locationName: "jobId"
                    },
                    jobStatus: {
                      locationName: "jobStatus"
                    },
                    jobType: {
                      locationName: "jobType"
                    },
                    lastRunErrorStatus: {
                      shape: "S30",
                      locationName: "lastRunErrorStatus"
                    },
                    name: {
                      locationName: "name"
                    },
                    userPausedDetails: {
                      shape: "S34",
                      locationName: "userPausedDetails"
                    },
                    bucketCriteria: {
                      shape: "Ss",
                      locationName: "bucketCriteria"
                    }
                  }
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListCustomDataIdentifiers: {
          http: {
            requestUri: "/custom-data-identifiers/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {
                      locationName: "arn"
                    },
                    createdAt: {
                      shape: "S9",
                      locationName: "createdAt"
                    },
                    description: {
                      locationName: "description"
                    },
                    id: {
                      locationName: "id"
                    },
                    name: {
                      locationName: "name"
                    }
                  }
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListFindings: {
          http: {
            requestUri: "/findings",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              findingCriteria: {
                shape: "S1d",
                locationName: "findingCriteria"
              },
              maxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                locationName: "nextToken"
              },
              sortCriteria: {
                shape: "S4b",
                locationName: "sortCriteria"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              findingIds: {
                shape: "S5",
                locationName: "findingIds"
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListFindingsFilters: {
          http: {
            method: "GET",
            requestUri: "/findingsfilters",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              findingsFilterListItems: {
                locationName: "findingsFilterListItems",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    action: {
                      locationName: "action"
                    },
                    arn: {
                      locationName: "arn"
                    },
                    id: {
                      locationName: "id"
                    },
                    name: {
                      locationName: "name"
                    },
                    tags: {
                      shape: "S17",
                      locationName: "tags"
                    }
                  }
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListInvitations: {
          http: {
            method: "GET",
            requestUri: "/invitations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              invitations: {
                locationName: "invitations",
                type: "list",
                member: {
                  shape: "S3p"
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListManagedDataIdentifiers: {
          http: {
            requestUri: "/managed-data-identifiers/list",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                locationName: "items",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    category: {
                      locationName: "category"
                    },
                    id: {
                      locationName: "id"
                    }
                  }
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListMembers: {
          http: {
            method: "GET",
            requestUri: "/members",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              onlyAssociated: {
                location: "querystring",
                locationName: "onlyAssociated"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              members: {
                locationName: "members",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {
                      locationName: "accountId"
                    },
                    administratorAccountId: {
                      locationName: "administratorAccountId"
                    },
                    arn: {
                      locationName: "arn"
                    },
                    email: {
                      locationName: "email"
                    },
                    invitedAt: {
                      shape: "S9",
                      locationName: "invitedAt"
                    },
                    masterAccountId: {
                      locationName: "masterAccountId"
                    },
                    relationshipStatus: {
                      locationName: "relationshipStatus"
                    },
                    tags: {
                      shape: "S17",
                      locationName: "tags"
                    },
                    updatedAt: {
                      shape: "S9",
                      locationName: "updatedAt"
                    }
                  }
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListOrganizationAdminAccounts: {
          http: {
            method: "GET",
            requestUri: "/admin",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              adminAccounts: {
                locationName: "adminAccounts",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    accountId: {
                      locationName: "accountId"
                    },
                    status: {
                      locationName: "status"
                    }
                  }
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            },
            required: [
              "resourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S17",
                locationName: "tags"
              }
            }
          }
        },
        PutClassificationExportConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/classification-export-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              configuration: {
                shape: "S3z",
                locationName: "configuration"
              }
            },
            required: [
              "configuration"
            ]
          },
          output: {
            type: "structure",
            members: {
              configuration: {
                shape: "S3z",
                locationName: "configuration"
              }
            }
          }
        },
        PutFindingsPublicationConfiguration: {
          http: {
            method: "PUT",
            requestUri: "/findings-publication-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                locationName: "clientToken",
                idempotencyToken: true
              },
              securityHubConfiguration: {
                shape: "S60",
                locationName: "securityHubConfiguration"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SearchResources: {
          http: {
            requestUri: "/datasources/search-resources",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              bucketCriteria: {
                locationName: "bucketCriteria",
                type: "structure",
                members: {
                  excludes: {
                    shape: "S83",
                    locationName: "excludes"
                  },
                  includes: {
                    shape: "S83",
                    locationName: "includes"
                  }
                }
              },
              maxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                locationName: "nextToken"
              },
              sortCriteria: {
                locationName: "sortCriteria",
                type: "structure",
                members: {
                  attributeName: {
                    locationName: "attributeName"
                  },
                  orderBy: {
                    locationName: "orderBy"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              matchingResources: {
                locationName: "matchingResources",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    matchingBucket: {
                      locationName: "matchingBucket",
                      type: "structure",
                      members: {
                        accountId: {
                          locationName: "accountId"
                        },
                        bucketName: {
                          locationName: "bucketName"
                        },
                        classifiableObjectCount: {
                          locationName: "classifiableObjectCount",
                          type: "long"
                        },
                        classifiableSizeInBytes: {
                          locationName: "classifiableSizeInBytes",
                          type: "long"
                        },
                        errorCode: {
                          locationName: "errorCode"
                        },
                        errorMessage: {
                          locationName: "errorMessage"
                        },
                        jobDetails: {
                          shape: "S2e",
                          locationName: "jobDetails"
                        },
                        objectCount: {
                          locationName: "objectCount",
                          type: "long"
                        },
                        objectCountByEncryptionType: {
                          shape: "S2h",
                          locationName: "objectCountByEncryptionType"
                        },
                        sizeInBytes: {
                          locationName: "sizeInBytes",
                          type: "long"
                        },
                        sizeInBytesCompressed: {
                          locationName: "sizeInBytesCompressed",
                          type: "long"
                        },
                        unclassifiableObjectCount: {
                          shape: "S2w",
                          locationName: "unclassifiableObjectCount"
                        },
                        unclassifiableObjectSizeInBytes: {
                          shape: "S2w",
                          locationName: "unclassifiableObjectSizeInBytes"
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S17",
                locationName: "tags"
              }
            },
            required: [
              "resourceArn",
              "tags"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TestCustomDataIdentifier: {
          http: {
            requestUri: "/custom-data-identifiers/test",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ignoreWords: {
                shape: "S5",
                locationName: "ignoreWords"
              },
              keywords: {
                shape: "S5",
                locationName: "keywords"
              },
              maximumMatchDistance: {
                locationName: "maximumMatchDistance",
                type: "integer"
              },
              regex: {
                locationName: "regex"
              },
              sampleText: {
                locationName: "sampleText"
              }
            },
            required: [
              "regex",
              "sampleText"
            ]
          },
          output: {
            type: "structure",
            members: {
              matchCount: {
                locationName: "matchCount",
                type: "integer"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                shape: "S5",
                location: "querystring",
                locationName: "tagKeys"
              }
            },
            required: [
              "tagKeys",
              "resourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateClassificationJob: {
          http: {
            method: "PATCH",
            requestUri: "/jobs/{jobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              jobId: {
                location: "uri",
                locationName: "jobId"
              },
              jobStatus: {
                locationName: "jobStatus"
              }
            },
            required: [
              "jobId",
              "jobStatus"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateFindingsFilter: {
          http: {
            method: "PATCH",
            requestUri: "/findingsfilters/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              action: {
                locationName: "action"
              },
              description: {
                locationName: "description"
              },
              findingCriteria: {
                shape: "S1d",
                locationName: "findingCriteria"
              },
              id: {
                location: "uri",
                locationName: "id"
              },
              name: {
                locationName: "name"
              },
              position: {
                locationName: "position",
                type: "integer"
              },
              clientToken: {
                locationName: "clientToken",
                idempotencyToken: true
              }
            },
            required: [
              "id"
            ]
          },
          output: {
            type: "structure",
            members: {
              arn: {
                locationName: "arn"
              },
              id: {
                locationName: "id"
              }
            }
          }
        },
        UpdateMacieSession: {
          http: {
            method: "PATCH",
            requestUri: "/macie",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              findingPublishingFrequency: {
                locationName: "findingPublishingFrequency"
              },
              status: {
                locationName: "status"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateMemberSession: {
          http: {
            method: "PATCH",
            requestUri: "/macie/members/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              status: {
                locationName: "status"
              }
            },
            required: [
              "id",
              "status"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateOrganizationConfiguration: {
          http: {
            method: "PATCH",
            requestUri: "/admin/configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              autoEnable: {
                locationName: "autoEnable",
                type: "boolean"
              }
            },
            required: [
              "autoEnable"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {}
        },
        S9: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Se: {
          type: "structure",
          members: {
            bucketDefinitions: {
              shape: "Sf",
              locationName: "bucketDefinitions"
            },
            scoping: {
              locationName: "scoping",
              type: "structure",
              members: {
                excludes: {
                  shape: "Si",
                  locationName: "excludes"
                },
                includes: {
                  shape: "Si",
                  locationName: "includes"
                }
              }
            },
            bucketCriteria: {
              shape: "Ss",
              locationName: "bucketCriteria"
            }
          }
        },
        Sf: {
          type: "list",
          member: {
            type: "structure",
            members: {
              accountId: {
                locationName: "accountId"
              },
              buckets: {
                shape: "S5",
                locationName: "buckets"
              }
            },
            required: [
              "accountId",
              "buckets"
            ]
          }
        },
        Si: {
          type: "structure",
          members: {
            and: {
              locationName: "and",
              type: "list",
              member: {
                type: "structure",
                members: {
                  simpleScopeTerm: {
                    locationName: "simpleScopeTerm",
                    type: "structure",
                    members: {
                      comparator: {
                        locationName: "comparator"
                      },
                      key: {
                        locationName: "key"
                      },
                      values: {
                        shape: "S5",
                        locationName: "values"
                      }
                    }
                  },
                  tagScopeTerm: {
                    locationName: "tagScopeTerm",
                    type: "structure",
                    members: {
                      comparator: {
                        locationName: "comparator"
                      },
                      key: {
                        locationName: "key"
                      },
                      tagValues: {
                        locationName: "tagValues",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            key: {
                              locationName: "key"
                            },
                            value: {
                              locationName: "value"
                            }
                          }
                        }
                      },
                      target: {
                        locationName: "target"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Ss: {
          type: "structure",
          members: {
            excludes: {
              shape: "St",
              locationName: "excludes"
            },
            includes: {
              shape: "St",
              locationName: "includes"
            }
          }
        },
        St: {
          type: "structure",
          members: {
            and: {
              locationName: "and",
              type: "list",
              member: {
                type: "structure",
                members: {
                  simpleCriterion: {
                    locationName: "simpleCriterion",
                    type: "structure",
                    members: {
                      comparator: {
                        locationName: "comparator"
                      },
                      key: {
                        locationName: "key"
                      },
                      values: {
                        shape: "S5",
                        locationName: "values"
                      }
                    }
                  },
                  tagCriterion: {
                    locationName: "tagCriterion",
                    type: "structure",
                    members: {
                      comparator: {
                        locationName: "comparator"
                      },
                      tagValues: {
                        locationName: "tagValues",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            key: {
                              locationName: "key"
                            },
                            value: {
                              locationName: "value"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            dailySchedule: {
              locationName: "dailySchedule",
              type: "structure",
              members: {}
            },
            monthlySchedule: {
              locationName: "monthlySchedule",
              type: "structure",
              members: {
                dayOfMonth: {
                  locationName: "dayOfMonth",
                  type: "integer"
                }
              }
            },
            weeklySchedule: {
              locationName: "weeklySchedule",
              type: "structure",
              members: {
                dayOfWeek: {
                  locationName: "dayOfWeek"
                }
              }
            }
          }
        },
        S17: {
          type: "map",
          key: {},
          value: {}
        },
        S1d: {
          type: "structure",
          members: {
            criterion: {
              locationName: "criterion",
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  eq: {
                    shape: "S5",
                    locationName: "eq"
                  },
                  eqExactMatch: {
                    shape: "S5",
                    locationName: "eqExactMatch"
                  },
                  gt: {
                    locationName: "gt",
                    type: "long"
                  },
                  gte: {
                    locationName: "gte",
                    type: "long"
                  },
                  lt: {
                    locationName: "lt",
                    type: "long"
                  },
                  lte: {
                    locationName: "lte",
                    type: "long"
                  },
                  neq: {
                    shape: "S5",
                    locationName: "neq"
                  }
                }
              }
            }
          }
        },
        S1k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              accountId: {
                locationName: "accountId"
              },
              errorCode: {
                locationName: "errorCode"
              },
              errorMessage: {
                locationName: "errorMessage"
              }
            }
          }
        },
        S2e: {
          type: "structure",
          members: {
            isDefinedInJob: {
              locationName: "isDefinedInJob"
            },
            isMonitoredByJob: {
              locationName: "isMonitoredByJob"
            },
            lastJobId: {
              locationName: "lastJobId"
            },
            lastJobRunTime: {
              shape: "S9",
              locationName: "lastJobRunTime"
            }
          }
        },
        S2h: {
          type: "structure",
          members: {
            customerManaged: {
              locationName: "customerManaged",
              type: "long"
            },
            kmsManaged: {
              locationName: "kmsManaged",
              type: "long"
            },
            s3Managed: {
              locationName: "s3Managed",
              type: "long"
            },
            unencrypted: {
              locationName: "unencrypted",
              type: "long"
            },
            unknown: {
              locationName: "unknown",
              type: "long"
            }
          }
        },
        S2i: {
          type: "structure",
          members: {
            effectivePermission: {
              locationName: "effectivePermission"
            },
            permissionConfiguration: {
              locationName: "permissionConfiguration",
              type: "structure",
              members: {
                accountLevelPermissions: {
                  locationName: "accountLevelPermissions",
                  type: "structure",
                  members: {
                    blockPublicAccess: {
                      shape: "S2m",
                      locationName: "blockPublicAccess"
                    }
                  }
                },
                bucketLevelPermissions: {
                  locationName: "bucketLevelPermissions",
                  type: "structure",
                  members: {
                    accessControlList: {
                      locationName: "accessControlList",
                      type: "structure",
                      members: {
                        allowsPublicReadAccess: {
                          locationName: "allowsPublicReadAccess",
                          type: "boolean"
                        },
                        allowsPublicWriteAccess: {
                          locationName: "allowsPublicWriteAccess",
                          type: "boolean"
                        }
                      }
                    },
                    blockPublicAccess: {
                      shape: "S2m",
                      locationName: "blockPublicAccess"
                    },
                    bucketPolicy: {
                      locationName: "bucketPolicy",
                      type: "structure",
                      members: {
                        allowsPublicReadAccess: {
                          locationName: "allowsPublicReadAccess",
                          type: "boolean"
                        },
                        allowsPublicWriteAccess: {
                          locationName: "allowsPublicWriteAccess",
                          type: "boolean"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S2m: {
          type: "structure",
          members: {
            blockPublicAcls: {
              locationName: "blockPublicAcls",
              type: "boolean"
            },
            blockPublicPolicy: {
              locationName: "blockPublicPolicy",
              type: "boolean"
            },
            ignorePublicAcls: {
              locationName: "ignorePublicAcls",
              type: "boolean"
            },
            restrictPublicBuckets: {
              locationName: "restrictPublicBuckets",
              type: "boolean"
            }
          }
        },
        S2v: {
          type: "structure",
          members: {
            key: {
              locationName: "key"
            },
            value: {
              locationName: "value"
            }
          }
        },
        S2w: {
          type: "structure",
          members: {
            fileType: {
              locationName: "fileType",
              type: "long"
            },
            storageClass: {
              locationName: "storageClass",
              type: "long"
            },
            total: {
              locationName: "total",
              type: "long"
            }
          }
        },
        S30: {
          type: "structure",
          members: {
            code: {
              locationName: "code"
            }
          }
        },
        S34: {
          type: "structure",
          members: {
            jobExpiresAt: {
              shape: "S9",
              locationName: "jobExpiresAt"
            },
            jobImminentExpirationHealthEventArn: {
              locationName: "jobImminentExpirationHealthEventArn"
            },
            jobPausedAt: {
              shape: "S9",
              locationName: "jobPausedAt"
            }
          }
        },
        S3p: {
          type: "structure",
          members: {
            accountId: {
              locationName: "accountId"
            },
            invitationId: {
              locationName: "invitationId"
            },
            invitedAt: {
              shape: "S9",
              locationName: "invitedAt"
            },
            relationshipStatus: {
              locationName: "relationshipStatus"
            }
          }
        },
        S3z: {
          type: "structure",
          members: {
            s3Destination: {
              locationName: "s3Destination",
              type: "structure",
              members: {
                bucketName: {
                  locationName: "bucketName"
                },
                keyPrefix: {
                  locationName: "keyPrefix"
                },
                kmsKeyArn: {
                  locationName: "kmsKeyArn"
                }
              },
              required: [
                "bucketName",
                "kmsKeyArn"
              ]
            }
          }
        },
        S4b: {
          type: "structure",
          members: {
            attributeName: {
              locationName: "attributeName"
            },
            orderBy: {
              locationName: "orderBy"
            }
          }
        },
        S4l: {
          type: "structure",
          members: {
            cells: {
              locationName: "cells",
              type: "list",
              member: {
                type: "structure",
                members: {
                  cellReference: {
                    locationName: "cellReference"
                  },
                  column: {
                    locationName: "column",
                    type: "long"
                  },
                  columnName: {
                    locationName: "columnName"
                  },
                  row: {
                    locationName: "row",
                    type: "long"
                  }
                }
              }
            },
            lineRanges: {
              shape: "S4o",
              locationName: "lineRanges"
            },
            offsetRanges: {
              shape: "S4o",
              locationName: "offsetRanges"
            },
            pages: {
              locationName: "pages",
              type: "list",
              member: {
                type: "structure",
                members: {
                  lineRange: {
                    shape: "S4p",
                    locationName: "lineRange"
                  },
                  offsetRange: {
                    shape: "S4p",
                    locationName: "offsetRange"
                  },
                  pageNumber: {
                    locationName: "pageNumber",
                    type: "long"
                  }
                }
              }
            },
            records: {
              locationName: "records",
              type: "list",
              member: {
                type: "structure",
                members: {
                  jsonPath: {
                    locationName: "jsonPath"
                  },
                  recordIndex: {
                    locationName: "recordIndex",
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S4o: {
          type: "list",
          member: {
            shape: "S4p"
          }
        },
        S4p: {
          type: "structure",
          members: {
            end: {
              locationName: "end",
              type: "long"
            },
            start: {
              locationName: "start",
              type: "long"
            },
            startColumn: {
              locationName: "startColumn",
              type: "long"
            }
          }
        },
        S5d: {
          type: "structure",
          members: {
            attributes: {
              locationName: "attributes",
              type: "structure",
              members: {
                creationDate: {
                  shape: "S9",
                  locationName: "creationDate"
                },
                mfaAuthenticated: {
                  locationName: "mfaAuthenticated",
                  type: "boolean"
                }
              }
            },
            sessionIssuer: {
              locationName: "sessionIssuer",
              type: "structure",
              members: {
                accountId: {
                  locationName: "accountId"
                },
                arn: {
                  locationName: "arn"
                },
                principalId: {
                  locationName: "principalId"
                },
                type: {
                  locationName: "type"
                },
                userName: {
                  locationName: "userName"
                }
              }
            }
          }
        },
        S5o: {
          type: "structure",
          members: {
            encryptionType: {
              locationName: "encryptionType"
            },
            kmsMasterKeyId: {
              locationName: "kmsMasterKeyId"
            }
          }
        },
        S5r: {
          type: "list",
          member: {
            shape: "S2v"
          }
        },
        S60: {
          type: "structure",
          members: {
            publishClassificationFindings: {
              locationName: "publishClassificationFindings",
              type: "boolean"
            },
            publishPolicyFindings: {
              locationName: "publishPolicyFindings",
              type: "boolean"
            }
          },
          required: [
            "publishPolicyFindings",
            "publishClassificationFindings"
          ]
        },
        S6w: {
          type: "list",
          member: {
            type: "structure",
            members: {
              comparator: {
                locationName: "comparator"
              },
              key: {
                locationName: "key"
              },
              values: {
                shape: "S5",
                locationName: "values"
              }
            }
          }
        },
        S83: {
          type: "structure",
          members: {
            and: {
              locationName: "and",
              type: "list",
              member: {
                type: "structure",
                members: {
                  simpleCriterion: {
                    locationName: "simpleCriterion",
                    type: "structure",
                    members: {
                      comparator: {
                        locationName: "comparator"
                      },
                      key: {
                        locationName: "key"
                      },
                      values: {
                        shape: "S5",
                        locationName: "values"
                      }
                    }
                  },
                  tagCriterion: {
                    locationName: "tagCriterion",
                    type: "structure",
                    members: {
                      comparator: {
                        locationName: "comparator"
                      },
                      tagValues: {
                        locationName: "tagValues",
                        type: "list",
                        member: {
                          type: "structure",
                          members: {
                            key: {
                              locationName: "key"
                            },
                            value: {
                              locationName: "value"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/macie2-2020-01-01.paginators.json
var require_macie2_2020_01_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/macie2-2020-01-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeBuckets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "buckets"
        },
        GetUsageStatistics: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "records"
        },
        ListClassificationJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListCustomDataIdentifiers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        ListFindings: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "findingIds"
        },
        ListFindingsFilters: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "findingsFilterListItems"
        },
        ListInvitations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "invitations"
        },
        ListMembers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "members"
        },
        ListOrganizationAdminAccounts: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "adminAccounts"
        },
        SearchResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "matchingResources"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/macie2.js
var require_macie2 = __commonJS({
  "node_modules/aws-sdk/clients/macie2.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["macie2"] = {};
    AWS3.Macie2 = Service.defineService("macie2", ["2020-01-01"]);
    Object.defineProperty(apiLoader.services["macie2"], "2020-01-01", {
      get: function get() {
        var model = require_macie2_2020_01_01_min();
        model.paginators = require_macie2_2020_01_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Macie2;
  }
});

// node_modules/aws-sdk/apis/codeartifact-2018-09-22.min.json
var require_codeartifact_2018_09_22_min = __commonJS({
  "node_modules/aws-sdk/apis/codeartifact-2018-09-22.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-09-22",
        endpointPrefix: "codeartifact",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "CodeArtifact",
        serviceId: "codeartifact",
        signatureVersion: "v4",
        signingName: "codeartifact",
        uid: "codeartifact-2018-09-22"
      },
      operations: {
        AssociateExternalConnection: {
          http: {
            requestUri: "/v1/repository/external-connection"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "externalConnection"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              externalConnection: {
                location: "querystring",
                locationName: "external-connection"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S7"
              }
            }
          }
        },
        CopyPackageVersions: {
          http: {
            requestUri: "/v1/package/versions/copy"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "sourceRepository",
              "destinationRepository",
              "format",
              "package"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              sourceRepository: {
                location: "querystring",
                locationName: "source-repository"
              },
              destinationRepository: {
                location: "querystring",
                locationName: "destination-repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              versions: {
                shape: "Sj"
              },
              versionRevisions: {
                shape: "Sl"
              },
              allowOverwrite: {
                type: "boolean"
              },
              includeFromUpstream: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              successfulVersions: {
                shape: "Sp"
              },
              failedVersions: {
                shape: "St"
              }
            }
          }
        },
        CreateDomain: {
          http: {
            requestUri: "/v1/domain"
          },
          input: {
            type: "structure",
            required: [
              "domain"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              encryptionKey: {},
              tags: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              domain: {
                shape: "S13"
              }
            }
          }
        },
        CreateRepository: {
          http: {
            requestUri: "/v1/repository"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              description: {},
              upstreams: {
                shape: "S19"
              },
              tags: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S7"
              }
            }
          }
        },
        DeleteDomain: {
          http: {
            method: "DELETE",
            requestUri: "/v1/domain"
          },
          input: {
            type: "structure",
            required: [
              "domain"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              domain: {
                shape: "S13"
              }
            }
          }
        },
        DeleteDomainPermissionsPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/v1/domain/permissions/policy"
          },
          input: {
            type: "structure",
            required: [
              "domain"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              policyRevision: {
                location: "querystring",
                locationName: "policy-revision"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policy: {
                shape: "S1h"
              }
            }
          }
        },
        DeletePackageVersions: {
          http: {
            requestUri: "/v1/package/versions/delete"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package",
              "versions"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              versions: {
                shape: "Sj"
              },
              expectedStatus: {}
            }
          },
          output: {
            type: "structure",
            members: {
              successfulVersions: {
                shape: "Sp"
              },
              failedVersions: {
                shape: "St"
              }
            }
          }
        },
        DeleteRepository: {
          http: {
            method: "DELETE",
            requestUri: "/v1/repository"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S7"
              }
            }
          }
        },
        DeleteRepositoryPermissionsPolicy: {
          http: {
            method: "DELETE",
            requestUri: "/v1/repository/permissions/policies"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              policyRevision: {
                location: "querystring",
                locationName: "policy-revision"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policy: {
                shape: "S1h"
              }
            }
          }
        },
        DescribeDomain: {
          http: {
            method: "GET",
            requestUri: "/v1/domain"
          },
          input: {
            type: "structure",
            required: [
              "domain"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              domain: {
                shape: "S13"
              }
            }
          }
        },
        DescribePackageVersion: {
          http: {
            method: "GET",
            requestUri: "/v1/package/version"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package",
              "packageVersion"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              packageVersion: {
                location: "querystring",
                locationName: "version"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "packageVersion"
            ],
            members: {
              packageVersion: {
                type: "structure",
                members: {
                  format: {},
                  namespace: {},
                  packageName: {},
                  displayName: {},
                  version: {},
                  summary: {},
                  homePage: {},
                  sourceCodeRepository: {},
                  publishedTime: {
                    type: "timestamp"
                  },
                  licenses: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        name: {},
                        url: {}
                      }
                    }
                  },
                  revision: {},
                  status: {}
                }
              }
            }
          }
        },
        DescribeRepository: {
          http: {
            method: "GET",
            requestUri: "/v1/repository"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S7"
              }
            }
          }
        },
        DisassociateExternalConnection: {
          http: {
            method: "DELETE",
            requestUri: "/v1/repository/external-connection"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "externalConnection"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              externalConnection: {
                location: "querystring",
                locationName: "external-connection"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S7"
              }
            }
          }
        },
        DisposePackageVersions: {
          http: {
            requestUri: "/v1/package/versions/dispose"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package",
              "versions"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              versions: {
                shape: "Sj"
              },
              versionRevisions: {
                shape: "Sl"
              },
              expectedStatus: {}
            }
          },
          output: {
            type: "structure",
            members: {
              successfulVersions: {
                shape: "Sp"
              },
              failedVersions: {
                shape: "St"
              }
            }
          }
        },
        GetAuthorizationToken: {
          http: {
            requestUri: "/v1/authorization-token"
          },
          input: {
            type: "structure",
            required: [
              "domain"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              durationSeconds: {
                location: "querystring",
                locationName: "duration",
                type: "long"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              authorizationToken: {},
              expiration: {
                type: "timestamp"
              }
            }
          }
        },
        GetDomainPermissionsPolicy: {
          http: {
            method: "GET",
            requestUri: "/v1/domain/permissions/policy"
          },
          input: {
            type: "structure",
            required: [
              "domain"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policy: {
                shape: "S1h"
              }
            }
          }
        },
        GetPackageVersionAsset: {
          http: {
            method: "GET",
            requestUri: "/v1/package/version/asset"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package",
              "packageVersion",
              "asset"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              packageVersion: {
                location: "querystring",
                locationName: "version"
              },
              asset: {
                location: "querystring",
                locationName: "asset"
              },
              packageVersionRevision: {
                location: "querystring",
                locationName: "revision"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              asset: {
                type: "blob",
                streaming: true
              },
              assetName: {
                location: "header",
                locationName: "X-AssetName"
              },
              packageVersion: {
                location: "header",
                locationName: "X-PackageVersion"
              },
              packageVersionRevision: {
                location: "header",
                locationName: "X-PackageVersionRevision"
              }
            },
            payload: "asset"
          }
        },
        GetPackageVersionReadme: {
          http: {
            method: "GET",
            requestUri: "/v1/package/version/readme"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package",
              "packageVersion"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              packageVersion: {
                location: "querystring",
                locationName: "version"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              format: {},
              namespace: {},
              package: {},
              version: {},
              versionRevision: {},
              readme: {}
            }
          }
        },
        GetRepositoryEndpoint: {
          http: {
            method: "GET",
            requestUri: "/v1/repository/endpoint"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repositoryEndpoint: {}
            }
          }
        },
        GetRepositoryPermissionsPolicy: {
          http: {
            method: "GET",
            requestUri: "/v1/repository/permissions/policy"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              policy: {
                shape: "S1h"
              }
            }
          }
        },
        ListDomains: {
          http: {
            requestUri: "/v1/domains"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              domains: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    owner: {},
                    arn: {},
                    status: {},
                    createdTime: {
                      type: "timestamp"
                    },
                    encryptionKey: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListPackageVersionAssets: {
          http: {
            requestUri: "/v1/package/version/assets"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package",
              "packageVersion"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              packageVersion: {
                location: "querystring",
                locationName: "version"
              },
              maxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              format: {},
              namespace: {},
              package: {},
              version: {},
              versionRevision: {},
              nextToken: {},
              assets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name"
                  ],
                  members: {
                    name: {},
                    size: {
                      type: "long"
                    },
                    hashes: {
                      type: "map",
                      key: {},
                      value: {}
                    }
                  }
                }
              }
            }
          }
        },
        ListPackageVersionDependencies: {
          http: {
            requestUri: "/v1/package/version/dependencies"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package",
              "packageVersion"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              packageVersion: {
                location: "querystring",
                locationName: "version"
              },
              nextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              format: {},
              namespace: {},
              package: {},
              version: {},
              versionRevision: {},
              nextToken: {},
              dependencies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    namespace: {},
                    package: {},
                    dependencyType: {},
                    versionRequirement: {}
                  }
                }
              }
            }
          }
        },
        ListPackageVersions: {
          http: {
            requestUri: "/v1/package/versions"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              status: {
                location: "querystring",
                locationName: "status"
              },
              sortBy: {
                location: "querystring",
                locationName: "sortBy"
              },
              maxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              defaultDisplayVersion: {},
              format: {},
              namespace: {},
              package: {},
              versions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "version",
                    "status"
                  ],
                  members: {
                    version: {},
                    revision: {},
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListPackages: {
          http: {
            requestUri: "/v1/packages"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              packagePrefix: {
                location: "querystring",
                locationName: "package-prefix"
              },
              maxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              packages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    format: {},
                    namespace: {},
                    package: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRepositories: {
          http: {
            requestUri: "/v1/repositories"
          },
          input: {
            type: "structure",
            members: {
              repositoryPrefix: {
                location: "querystring",
                locationName: "repository-prefix"
              },
              maxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repositories: {
                shape: "S3f"
              },
              nextToken: {}
            }
          }
        },
        ListRepositoriesInDomain: {
          http: {
            requestUri: "/v1/domain/repositories"
          },
          input: {
            type: "structure",
            required: [
              "domain"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              administratorAccount: {
                location: "querystring",
                locationName: "administrator-account"
              },
              repositoryPrefix: {
                location: "querystring",
                locationName: "repository-prefix"
              },
              maxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repositories: {
                shape: "S3f"
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            requestUri: "/v1/tags"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sy"
              }
            }
          }
        },
        PutDomainPermissionsPolicy: {
          http: {
            method: "PUT",
            requestUri: "/v1/domain/permissions/policy"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "policyDocument"
            ],
            members: {
              domain: {},
              domainOwner: {},
              policyRevision: {},
              policyDocument: {}
            }
          },
          output: {
            type: "structure",
            members: {
              policy: {
                shape: "S1h"
              }
            }
          }
        },
        PutRepositoryPermissionsPolicy: {
          http: {
            method: "PUT",
            requestUri: "/v1/repository/permissions/policy"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "policyDocument"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              policyRevision: {},
              policyDocument: {}
            }
          },
          output: {
            type: "structure",
            members: {
              policy: {
                shape: "S1h"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/v1/tag"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            requestUri: "/v1/untag"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdatePackageVersionsStatus: {
          http: {
            requestUri: "/v1/package/versions/update_status"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository",
              "format",
              "package",
              "versions",
              "targetStatus"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              format: {
                location: "querystring",
                locationName: "format"
              },
              namespace: {
                location: "querystring",
                locationName: "namespace"
              },
              package: {
                location: "querystring",
                locationName: "package"
              },
              versions: {
                shape: "Sj"
              },
              versionRevisions: {
                shape: "Sl"
              },
              expectedStatus: {},
              targetStatus: {}
            }
          },
          output: {
            type: "structure",
            members: {
              successfulVersions: {
                shape: "Sp"
              },
              failedVersions: {
                shape: "St"
              }
            }
          }
        },
        UpdateRepository: {
          http: {
            method: "PUT",
            requestUri: "/v1/repository"
          },
          input: {
            type: "structure",
            required: [
              "domain",
              "repository"
            ],
            members: {
              domain: {
                location: "querystring",
                locationName: "domain"
              },
              domainOwner: {
                location: "querystring",
                locationName: "domain-owner"
              },
              repository: {
                location: "querystring",
                locationName: "repository"
              },
              description: {},
              upstreams: {
                shape: "S19"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S7"
              }
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "structure",
          members: {
            name: {},
            administratorAccount: {},
            domainName: {},
            domainOwner: {},
            arn: {},
            description: {},
            upstreams: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  repositoryName: {}
                }
              }
            },
            externalConnections: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  externalConnectionName: {},
                  packageFormat: {},
                  status: {}
                }
              }
            }
          }
        },
        Sj: {
          type: "list",
          member: {}
        },
        Sl: {
          type: "map",
          key: {},
          value: {}
        },
        Sp: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              revision: {},
              status: {}
            }
          }
        },
        St: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              errorCode: {},
              errorMessage: {}
            }
          }
        },
        Sy: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        S13: {
          type: "structure",
          members: {
            name: {},
            owner: {},
            arn: {},
            status: {},
            createdTime: {
              type: "timestamp"
            },
            encryptionKey: {},
            repositoryCount: {
              type: "integer"
            },
            assetSizeBytes: {
              type: "long"
            },
            s3BucketArn: {}
          }
        },
        S19: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {}
            }
          }
        },
        S1h: {
          type: "structure",
          members: {
            resourceArn: {},
            revision: {},
            document: {}
          }
        },
        S3f: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {},
              administratorAccount: {},
              domainName: {},
              domainOwner: {},
              arn: {},
              description: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/codeartifact-2018-09-22.paginators.json
var require_codeartifact_2018_09_22_paginators = __commonJS({
  "node_modules/aws-sdk/apis/codeartifact-2018-09-22.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListDomains: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "domains"
        },
        ListPackageVersionAssets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assets"
        },
        ListPackageVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "versions"
        },
        ListPackages: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "packages"
        },
        ListRepositories: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "repositories"
        },
        ListRepositoriesInDomain: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "repositories"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/codeartifact.js
var require_codeartifact = __commonJS({
  "node_modules/aws-sdk/clients/codeartifact.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["codeartifact"] = {};
    AWS3.CodeArtifact = Service.defineService("codeartifact", ["2018-09-22"]);
    Object.defineProperty(apiLoader.services["codeartifact"], "2018-09-22", {
      get: function get() {
        var model = require_codeartifact_2018_09_22_min();
        model.paginators = require_codeartifact_2018_09_22_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CodeArtifact;
  }
});

// node_modules/aws-sdk/apis/honeycode-2020-03-01.min.json
var require_honeycode_2020_03_01_min = __commonJS({
  "node_modules/aws-sdk/apis/honeycode-2020-03-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-03-01",
        endpointPrefix: "honeycode",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Honeycode",
        serviceFullName: "Amazon Honeycode",
        serviceId: "Honeycode",
        signatureVersion: "v4",
        signingName: "honeycode",
        uid: "honeycode-2020-03-01"
      },
      operations: {
        BatchCreateTableRows: {
          http: {
            requestUri: "/workbooks/{workbookId}/tables/{tableId}/rows/batchcreate"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "tableId",
              "rowsToCreate"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              tableId: {
                location: "uri",
                locationName: "tableId"
              },
              rowsToCreate: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "batchItemId",
                    "cellsToCreate"
                  ],
                  members: {
                    batchItemId: {},
                    cellsToCreate: {
                      shape: "S6"
                    }
                  }
                }
              },
              clientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "workbookCursor",
              "createdRows"
            ],
            members: {
              workbookCursor: {
                type: "long"
              },
              createdRows: {
                type: "map",
                key: {},
                value: {}
              },
              failedBatchItems: {
                shape: "Se"
              }
            }
          }
        },
        BatchDeleteTableRows: {
          http: {
            requestUri: "/workbooks/{workbookId}/tables/{tableId}/rows/batchdelete"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "tableId",
              "rowIds"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              tableId: {
                location: "uri",
                locationName: "tableId"
              },
              rowIds: {
                shape: "Si"
              },
              clientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "workbookCursor"
            ],
            members: {
              workbookCursor: {
                type: "long"
              },
              failedBatchItems: {
                shape: "Se"
              }
            }
          }
        },
        BatchUpdateTableRows: {
          http: {
            requestUri: "/workbooks/{workbookId}/tables/{tableId}/rows/batchupdate"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "tableId",
              "rowsToUpdate"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              tableId: {
                location: "uri",
                locationName: "tableId"
              },
              rowsToUpdate: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "rowId",
                    "cellsToUpdate"
                  ],
                  members: {
                    rowId: {},
                    cellsToUpdate: {
                      shape: "S6"
                    }
                  }
                }
              },
              clientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "workbookCursor"
            ],
            members: {
              workbookCursor: {
                type: "long"
              },
              failedBatchItems: {
                shape: "Se"
              }
            }
          }
        },
        BatchUpsertTableRows: {
          http: {
            requestUri: "/workbooks/{workbookId}/tables/{tableId}/rows/batchupsert"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "tableId",
              "rowsToUpsert"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              tableId: {
                location: "uri",
                locationName: "tableId"
              },
              rowsToUpsert: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "batchItemId",
                    "filter",
                    "cellsToUpdate"
                  ],
                  members: {
                    batchItemId: {},
                    filter: {
                      shape: "Sr"
                    },
                    cellsToUpdate: {
                      shape: "S6"
                    }
                  }
                }
              },
              clientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "rows",
              "workbookCursor"
            ],
            members: {
              rows: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "rowIds",
                    "upsertAction"
                  ],
                  members: {
                    rowIds: {
                      shape: "Si"
                    },
                    upsertAction: {}
                  }
                }
              },
              workbookCursor: {
                type: "long"
              },
              failedBatchItems: {
                shape: "Se"
              }
            }
          }
        },
        DescribeTableDataImportJob: {
          http: {
            method: "GET",
            requestUri: "/workbooks/{workbookId}/tables/{tableId}/import/{jobId}"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "tableId",
              "jobId"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              tableId: {
                location: "uri",
                locationName: "tableId"
              },
              jobId: {
                location: "uri",
                locationName: "jobId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "jobStatus",
              "message",
              "jobMetadata"
            ],
            members: {
              jobStatus: {},
              message: {},
              jobMetadata: {
                type: "structure",
                required: [
                  "submitter",
                  "submitTime",
                  "importOptions",
                  "dataSource"
                ],
                members: {
                  submitter: {
                    type: "structure",
                    members: {
                      email: {
                        type: "string",
                        sensitive: true
                      },
                      userArn: {}
                    }
                  },
                  submitTime: {
                    type: "timestamp"
                  },
                  importOptions: {
                    shape: "S17"
                  },
                  dataSource: {
                    shape: "S1h"
                  }
                }
              }
            }
          }
        },
        GetScreenData: {
          http: {
            requestUri: "/screendata"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "appId",
              "screenId"
            ],
            members: {
              workbookId: {},
              appId: {},
              screenId: {},
              variables: {
                shape: "S1l"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "results",
              "workbookCursor"
            ],
            members: {
              results: {
                type: "map",
                key: {
                  shape: "S1t"
                },
                value: {
                  type: "structure",
                  required: [
                    "headers",
                    "rows"
                  ],
                  members: {
                    headers: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "name",
                          "format"
                        ],
                        members: {
                          name: {
                            shape: "S1t"
                          },
                          format: {}
                        }
                      }
                    },
                    rows: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "dataItems"
                        ],
                        members: {
                          rowId: {},
                          dataItems: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                overrideFormat: {},
                                rawValue: {},
                                formattedValue: {}
                              },
                              sensitive: true
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              workbookCursor: {
                type: "long"
              },
              nextToken: {}
            }
          }
        },
        InvokeScreenAutomation: {
          http: {
            requestUri: "/workbooks/{workbookId}/apps/{appId}/screens/{screenId}/automations/{automationId}"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "appId",
              "screenId",
              "screenAutomationId"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              appId: {
                location: "uri",
                locationName: "appId"
              },
              screenId: {
                location: "uri",
                locationName: "screenId"
              },
              screenAutomationId: {
                location: "uri",
                locationName: "automationId"
              },
              variables: {
                shape: "S1l"
              },
              rowId: {},
              clientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "workbookCursor"
            ],
            members: {
              workbookCursor: {
                type: "long"
              }
            }
          }
        },
        ListTableColumns: {
          http: {
            method: "GET",
            requestUri: "/workbooks/{workbookId}/tables/{tableId}/columns"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "tableId"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              tableId: {
                location: "uri",
                locationName: "tableId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tableColumns"
            ],
            members: {
              tableColumns: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    tableColumnId: {},
                    tableColumnName: {},
                    format: {}
                  }
                }
              },
              nextToken: {},
              workbookCursor: {
                type: "long"
              }
            }
          }
        },
        ListTableRows: {
          http: {
            requestUri: "/workbooks/{workbookId}/tables/{tableId}/rows/list"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "tableId"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              tableId: {
                location: "uri",
                locationName: "tableId"
              },
              rowIds: {
                shape: "Si"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "columnIds",
              "rows",
              "workbookCursor"
            ],
            members: {
              columnIds: {
                shape: "S2c"
              },
              rows: {
                shape: "S2d"
              },
              rowIdsNotFound: {
                shape: "Si"
              },
              nextToken: {},
              workbookCursor: {
                type: "long"
              }
            }
          }
        },
        ListTables: {
          http: {
            method: "GET",
            requestUri: "/workbooks/{workbookId}/tables"
          },
          input: {
            type: "structure",
            required: [
              "workbookId"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tables"
            ],
            members: {
              tables: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    tableId: {},
                    tableName: {}
                  }
                }
              },
              nextToken: {},
              workbookCursor: {
                type: "long"
              }
            }
          }
        },
        QueryTableRows: {
          http: {
            requestUri: "/workbooks/{workbookId}/tables/{tableId}/rows/query"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "tableId",
              "filterFormula"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              tableId: {
                location: "uri",
                locationName: "tableId"
              },
              filterFormula: {
                shape: "Sr"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "columnIds",
              "rows",
              "workbookCursor"
            ],
            members: {
              columnIds: {
                shape: "S2c"
              },
              rows: {
                shape: "S2d"
              },
              nextToken: {},
              workbookCursor: {
                type: "long"
              }
            }
          }
        },
        StartTableDataImportJob: {
          http: {
            requestUri: "/workbooks/{workbookId}/tables/{tableId}/import"
          },
          input: {
            type: "structure",
            required: [
              "workbookId",
              "dataSource",
              "dataFormat",
              "destinationTableId",
              "importOptions",
              "clientRequestToken"
            ],
            members: {
              workbookId: {
                location: "uri",
                locationName: "workbookId"
              },
              dataSource: {
                shape: "S1h"
              },
              dataFormat: {},
              destinationTableId: {
                location: "uri",
                locationName: "tableId"
              },
              importOptions: {
                shape: "S17"
              },
              clientRequestToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "jobId",
              "jobStatus"
            ],
            members: {
              jobId: {},
              jobStatus: {}
            }
          }
        }
      },
      shapes: {
        S6: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              fact: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        Se: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "id",
              "errorMessage"
            ],
            members: {
              id: {},
              errorMessage: {}
            }
          }
        },
        Si: {
          type: "list",
          member: {}
        },
        Sr: {
          type: "structure",
          required: [
            "formula"
          ],
          members: {
            formula: {
              shape: "Ss"
            },
            contextRowId: {}
          }
        },
        Ss: {
          type: "string",
          sensitive: true
        },
        S17: {
          type: "structure",
          members: {
            destinationOptions: {
              type: "structure",
              members: {
                columnMap: {
                  type: "map",
                  key: {},
                  value: {
                    type: "structure",
                    members: {
                      columnIndex: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            },
            delimitedTextOptions: {
              type: "structure",
              required: [
                "delimiter"
              ],
              members: {
                delimiter: {},
                hasHeaderRow: {
                  type: "boolean"
                },
                ignoreEmptyRows: {
                  type: "boolean"
                },
                dataCharacterEncoding: {}
              }
            }
          }
        },
        S1h: {
          type: "structure",
          required: [
            "dataSourceConfig"
          ],
          members: {
            dataSourceConfig: {
              type: "structure",
              members: {
                dataSourceUrl: {}
              }
            }
          }
        },
        S1l: {
          type: "map",
          key: {
            type: "string",
            sensitive: true
          },
          value: {
            type: "structure",
            required: [
              "rawValue"
            ],
            members: {
              rawValue: {}
            },
            sensitive: true
          },
          sensitive: true
        },
        S1t: {
          type: "string",
          sensitive: true
        },
        S2c: {
          type: "list",
          member: {}
        },
        S2d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "rowId",
              "cells"
            ],
            members: {
              rowId: {},
              cells: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    formula: {
                      shape: "Ss"
                    },
                    format: {},
                    rawValue: {},
                    formattedValue: {}
                  },
                  sensitive: true
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/honeycode-2020-03-01.paginators.json
var require_honeycode_2020_03_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/honeycode-2020-03-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListTableColumns: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "tableColumns"
        },
        ListTableRows: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "rows"
        },
        ListTables: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "tables"
        },
        QueryTableRows: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "rows"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/honeycode.js
var require_honeycode = __commonJS({
  "node_modules/aws-sdk/clients/honeycode.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["honeycode"] = {};
    AWS3.Honeycode = Service.defineService("honeycode", ["2020-03-01"]);
    Object.defineProperty(apiLoader.services["honeycode"], "2020-03-01", {
      get: function get() {
        var model = require_honeycode_2020_03_01_min();
        model.paginators = require_honeycode_2020_03_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Honeycode;
  }
});

// node_modules/aws-sdk/apis/ivs-2020-07-14.min.json
var require_ivs_2020_07_14_min = __commonJS({
  "node_modules/aws-sdk/apis/ivs-2020-07-14.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-07-14",
        endpointPrefix: "ivs",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon IVS",
        serviceFullName: "Amazon Interactive Video Service",
        serviceId: "ivs",
        signatureVersion: "v4",
        signingName: "ivs",
        uid: "ivs-2020-07-14"
      },
      operations: {
        BatchGetChannel: {
          http: {
            requestUri: "/BatchGetChannel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arns"
            ],
            members: {
              arns: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              channels: {
                type: "list",
                member: {
                  shape: "S6"
                }
              },
              errors: {
                shape: "Sh"
              }
            }
          }
        },
        BatchGetStreamKey: {
          http: {
            requestUri: "/BatchGetStreamKey",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arns"
            ],
            members: {
              arns: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                shape: "Sh"
              },
              streamKeys: {
                type: "list",
                member: {
                  shape: "Sr"
                }
              }
            }
          }
        },
        CreateChannel: {
          http: {
            requestUri: "/CreateChannel",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              authorized: {
                type: "boolean"
              },
              latencyMode: {},
              name: {},
              recordingConfigurationArn: {},
              tags: {
                shape: "Sd"
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              channel: {
                shape: "S6"
              },
              streamKey: {
                shape: "Sr"
              }
            }
          }
        },
        CreateRecordingConfiguration: {
          http: {
            requestUri: "/CreateRecordingConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "destinationConfiguration"
            ],
            members: {
              destinationConfiguration: {
                shape: "Sx"
              },
              name: {},
              tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              recordingConfiguration: {
                shape: "S12"
              }
            }
          }
        },
        CreateStreamKey: {
          http: {
            requestUri: "/CreateStreamKey",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channelArn"
            ],
            members: {
              channelArn: {},
              tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              streamKey: {
                shape: "Sr"
              }
            }
          }
        },
        DeleteChannel: {
          http: {
            requestUri: "/DeleteChannel",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          }
        },
        DeletePlaybackKeyPair: {
          http: {
            requestUri: "/DeletePlaybackKeyPair",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRecordingConfiguration: {
          http: {
            requestUri: "/DeleteRecordingConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          }
        },
        DeleteStreamKey: {
          http: {
            requestUri: "/DeleteStreamKey",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          }
        },
        GetChannel: {
          http: {
            requestUri: "/GetChannel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              channel: {
                shape: "S6"
              }
            }
          }
        },
        GetPlaybackKeyPair: {
          http: {
            requestUri: "/GetPlaybackKeyPair",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              keyPair: {
                shape: "S1h"
              }
            }
          }
        },
        GetRecordingConfiguration: {
          http: {
            requestUri: "/GetRecordingConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              recordingConfiguration: {
                shape: "S12"
              }
            }
          }
        },
        GetStream: {
          http: {
            requestUri: "/GetStream",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channelArn"
            ],
            members: {
              channelArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              stream: {
                type: "structure",
                members: {
                  channelArn: {},
                  health: {},
                  playbackUrl: {},
                  startTime: {
                    shape: "S1q"
                  },
                  state: {},
                  viewerCount: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        GetStreamKey: {
          http: {
            requestUri: "/GetStreamKey",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              streamKey: {
                shape: "Sr"
              }
            }
          }
        },
        ImportPlaybackKeyPair: {
          http: {
            requestUri: "/ImportPlaybackKeyPair",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "publicKeyMaterial"
            ],
            members: {
              name: {},
              publicKeyMaterial: {},
              tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              keyPair: {
                shape: "S1h"
              }
            }
          }
        },
        ListChannels: {
          http: {
            requestUri: "/ListChannels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filterByName: {},
              filterByRecordingConfigurationArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "channels"
            ],
            members: {
              channels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    authorized: {
                      type: "boolean"
                    },
                    latencyMode: {},
                    name: {},
                    recordingConfigurationArn: {},
                    tags: {
                      shape: "Sd"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListPlaybackKeyPairs: {
          http: {
            requestUri: "/ListPlaybackKeyPairs",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "keyPairs"
            ],
            members: {
              keyPairs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    name: {},
                    tags: {
                      shape: "Sd"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRecordingConfigurations: {
          http: {
            requestUri: "/ListRecordingConfigurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "recordingConfigurations"
            ],
            members: {
              nextToken: {},
              recordingConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "destinationConfiguration",
                    "state"
                  ],
                  members: {
                    arn: {},
                    destinationConfiguration: {
                      shape: "Sx"
                    },
                    name: {},
                    state: {},
                    tags: {
                      shape: "Sd"
                    }
                  }
                }
              }
            }
          }
        },
        ListStreamKeys: {
          http: {
            requestUri: "/ListStreamKeys",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channelArn"
            ],
            members: {
              channelArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "streamKeys"
            ],
            members: {
              nextToken: {},
              streamKeys: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    channelArn: {},
                    tags: {
                      shape: "Sd"
                    }
                  }
                }
              }
            }
          }
        },
        ListStreams: {
          http: {
            requestUri: "/ListStreams",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "streams"
            ],
            members: {
              nextToken: {},
              streams: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    channelArn: {},
                    health: {},
                    startTime: {
                      shape: "S1q"
                    },
                    state: {},
                    viewerCount: {
                      type: "long"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              tags: {
                shape: "Sd"
              }
            }
          }
        },
        PutMetadata: {
          http: {
            requestUri: "/PutMetadata",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channelArn",
              "metadata"
            ],
            members: {
              channelArn: {},
              metadata: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        StopStream: {
          http: {
            requestUri: "/StopStream",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "channelArn"
            ],
            members: {
              channelArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateChannel: {
          http: {
            requestUri: "/UpdateChannel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              authorized: {
                type: "boolean"
              },
              latencyMode: {},
              name: {},
              recordingConfigurationArn: {},
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              channel: {
                shape: "S6"
              }
            }
          }
        }
      },
      shapes: {
        S6: {
          type: "structure",
          members: {
            arn: {},
            authorized: {
              type: "boolean"
            },
            ingestEndpoint: {},
            latencyMode: {},
            name: {},
            playbackUrl: {},
            recordingConfigurationArn: {},
            tags: {
              shape: "Sd"
            },
            type: {}
          }
        },
        Sd: {
          type: "map",
          key: {},
          value: {}
        },
        Sh: {
          type: "list",
          member: {
            type: "structure",
            members: {
              arn: {},
              code: {},
              message: {}
            }
          }
        },
        Sr: {
          type: "structure",
          members: {
            arn: {},
            channelArn: {},
            tags: {
              shape: "Sd"
            },
            value: {
              type: "string",
              sensitive: true
            }
          }
        },
        Sx: {
          type: "structure",
          members: {
            s3: {
              type: "structure",
              required: [
                "bucketName"
              ],
              members: {
                bucketName: {}
              }
            }
          }
        },
        S12: {
          type: "structure",
          required: [
            "arn",
            "destinationConfiguration",
            "state"
          ],
          members: {
            arn: {},
            destinationConfiguration: {
              shape: "Sx"
            },
            name: {},
            state: {},
            tags: {
              shape: "Sd"
            }
          }
        },
        S1h: {
          type: "structure",
          members: {
            arn: {},
            fingerprint: {},
            name: {},
            tags: {
              shape: "Sd"
            }
          }
        },
        S1q: {
          type: "timestamp",
          timestampFormat: "iso8601"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ivs-2020-07-14.paginators.json
var require_ivs_2020_07_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ivs-2020-07-14.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListChannels: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListPlaybackKeyPairs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListRecordingConfigurations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListStreamKeys: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListStreams: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ivs.js
var require_ivs = __commonJS({
  "node_modules/aws-sdk/clients/ivs.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["ivs"] = {};
    AWS3.IVS = Service.defineService("ivs", ["2020-07-14"]);
    Object.defineProperty(apiLoader.services["ivs"], "2020-07-14", {
      get: function get() {
        var model = require_ivs_2020_07_14_min();
        model.paginators = require_ivs_2020_07_14_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.IVS;
  }
});

// node_modules/aws-sdk/apis/braket-2019-09-01.min.json
var require_braket_2019_09_01_min = __commonJS({
  "node_modules/aws-sdk/apis/braket-2019-09-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-09-01",
        endpointPrefix: "braket",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Braket",
        serviceId: "Braket",
        signatureVersion: "v4",
        signingName: "braket",
        uid: "braket-2019-09-01"
      },
      operations: {
        CancelQuantumTask: {
          http: {
            method: "PUT",
            requestUri: "/quantum-task/{quantumTaskArn}/cancel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "clientToken",
              "quantumTaskArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              quantumTaskArn: {
                location: "uri",
                locationName: "quantumTaskArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "cancellationStatus",
              "quantumTaskArn"
            ],
            members: {
              cancellationStatus: {},
              quantumTaskArn: {}
            }
          },
          idempotent: true
        },
        CreateQuantumTask: {
          http: {
            requestUri: "/quantum-task",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "action",
              "clientToken",
              "deviceArn",
              "outputS3Bucket",
              "outputS3KeyPrefix",
              "shots"
            ],
            members: {
              action: {
                jsonvalue: true
              },
              clientToken: {
                idempotencyToken: true
              },
              deviceArn: {},
              deviceParameters: {
                jsonvalue: true
              },
              outputS3Bucket: {},
              outputS3KeyPrefix: {},
              shots: {
                type: "long"
              },
              tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "quantumTaskArn"
            ],
            members: {
              quantumTaskArn: {}
            }
          }
        },
        GetDevice: {
          http: {
            method: "GET",
            requestUri: "/device/{deviceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "deviceArn"
            ],
            members: {
              deviceArn: {
                location: "uri",
                locationName: "deviceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "deviceArn",
              "deviceCapabilities",
              "deviceName",
              "deviceStatus",
              "deviceType",
              "providerName"
            ],
            members: {
              deviceArn: {},
              deviceCapabilities: {
                jsonvalue: true
              },
              deviceName: {},
              deviceStatus: {},
              deviceType: {},
              providerName: {}
            }
          }
        },
        GetQuantumTask: {
          http: {
            method: "GET",
            requestUri: "/quantum-task/{quantumTaskArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "quantumTaskArn"
            ],
            members: {
              quantumTaskArn: {
                location: "uri",
                locationName: "quantumTaskArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "createdAt",
              "deviceArn",
              "deviceParameters",
              "outputS3Bucket",
              "outputS3Directory",
              "quantumTaskArn",
              "shots",
              "status"
            ],
            members: {
              createdAt: {
                shape: "Sm"
              },
              deviceArn: {},
              deviceParameters: {
                jsonvalue: true
              },
              endedAt: {
                shape: "Sm"
              },
              failureReason: {},
              outputS3Bucket: {},
              outputS3Directory: {},
              quantumTaskArn: {},
              shots: {
                type: "long"
              },
              status: {},
              tags: {
                shape: "Sd"
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sd"
              }
            }
          }
        },
        SearchDevices: {
          http: {
            requestUri: "/devices",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "filters"
            ],
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values"
                  ],
                  members: {
                    name: {},
                    values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "devices"
            ],
            members: {
              devices: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "deviceArn",
                    "deviceName",
                    "deviceStatus",
                    "deviceType",
                    "providerName"
                  ],
                  members: {
                    deviceArn: {},
                    deviceName: {},
                    deviceStatus: {},
                    deviceType: {},
                    providerName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        SearchQuantumTasks: {
          http: {
            requestUri: "/quantum-tasks",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "filters"
            ],
            members: {
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "operator",
                    "values"
                  ],
                  members: {
                    name: {},
                    operator: {},
                    values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "quantumTasks"
            ],
            members: {
              nextToken: {},
              quantumTasks: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "createdAt",
                    "deviceArn",
                    "outputS3Bucket",
                    "outputS3Directory",
                    "quantumTaskArn",
                    "shots",
                    "status"
                  ],
                  members: {
                    createdAt: {
                      shape: "Sm"
                    },
                    deviceArn: {},
                    endedAt: {
                      shape: "Sm"
                    },
                    outputS3Bucket: {},
                    outputS3Directory: {},
                    quantumTaskArn: {},
                    shots: {
                      type: "long"
                    },
                    status: {},
                    tags: {
                      shape: "Sd"
                    }
                  }
                }
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        }
      },
      shapes: {
        Sd: {
          type: "map",
          key: {},
          value: {}
        },
        Sm: {
          type: "timestamp",
          timestampFormat: "iso8601"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/braket-2019-09-01.paginators.json
var require_braket_2019_09_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/braket-2019-09-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        SearchDevices: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "devices"
        },
        SearchQuantumTasks: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "quantumTasks"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/braket.js
var require_braket = __commonJS({
  "node_modules/aws-sdk/clients/braket.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["braket"] = {};
    AWS3.Braket = Service.defineService("braket", ["2019-09-01"]);
    Object.defineProperty(apiLoader.services["braket"], "2019-09-01", {
      get: function get() {
        var model = require_braket_2019_09_01_min();
        model.paginators = require_braket_2019_09_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Braket;
  }
});

// node_modules/aws-sdk/apis/identitystore-2020-06-15.min.json
var require_identitystore_2020_06_15_min = __commonJS({
  "node_modules/aws-sdk/apis/identitystore-2020-06-15.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-06-15",
        endpointPrefix: "identitystore",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "IdentityStore",
        serviceFullName: "AWS SSO Identity Store",
        serviceId: "identitystore",
        signatureVersion: "v4",
        signingName: "identitystore",
        targetPrefix: "AWSIdentityStore",
        uid: "identitystore-2020-06-15"
      },
      operations: {
        DescribeGroup: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId",
              "GroupId"
            ],
            members: {
              IdentityStoreId: {},
              GroupId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "GroupId",
              "DisplayName"
            ],
            members: {
              GroupId: {},
              DisplayName: {}
            }
          }
        },
        DescribeUser: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId",
              "UserId"
            ],
            members: {
              IdentityStoreId: {},
              UserId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "UserName",
              "UserId"
            ],
            members: {
              UserName: {
                shape: "S8"
              },
              UserId: {}
            }
          }
        },
        ListGroups: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId"
            ],
            members: {
              IdentityStoreId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Groups"
            ],
            members: {
              Groups: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "GroupId",
                    "DisplayName"
                  ],
                  members: {
                    GroupId: {},
                    DisplayName: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListUsers: {
          input: {
            type: "structure",
            required: [
              "IdentityStoreId"
            ],
            members: {
              IdentityStoreId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filters: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Users"
            ],
            members: {
              Users: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "UserName",
                    "UserId"
                  ],
                  members: {
                    UserName: {
                      shape: "S8"
                    },
                    UserId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        }
      },
      shapes: {
        S8: {
          type: "string",
          sensitive: true
        },
        Sc: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AttributePath",
              "AttributeValue"
            ],
            members: {
              AttributePath: {},
              AttributeValue: {
                type: "string",
                sensitive: true
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/identitystore-2020-06-15.paginators.json
var require_identitystore_2020_06_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/identitystore-2020-06-15.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListUsers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/identitystore.js
var require_identitystore = __commonJS({
  "node_modules/aws-sdk/clients/identitystore.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["identitystore"] = {};
    AWS3.IdentityStore = Service.defineService("identitystore", ["2020-06-15"]);
    Object.defineProperty(apiLoader.services["identitystore"], "2020-06-15", {
      get: function get() {
        var model = require_identitystore_2020_06_15_min();
        model.paginators = require_identitystore_2020_06_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.IdentityStore;
  }
});

// node_modules/aws-sdk/apis/appflow-2020-08-23.min.json
var require_appflow_2020_08_23_min = __commonJS({
  "node_modules/aws-sdk/apis/appflow-2020-08-23.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-08-23",
        endpointPrefix: "appflow",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Appflow",
        serviceId: "Appflow",
        signatureVersion: "v4",
        signingName: "appflow",
        uid: "appflow-2020-08-23"
      },
      operations: {
        CreateConnectorProfile: {
          http: {
            requestUri: "/create-connector-profile"
          },
          input: {
            type: "structure",
            required: [
              "connectorProfileName",
              "connectorType",
              "connectionMode",
              "connectorProfileConfig"
            ],
            members: {
              connectorProfileName: {},
              kmsArn: {},
              connectorType: {},
              connectionMode: {},
              connectorProfileConfig: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              connectorProfileArn: {}
            }
          }
        },
        CreateFlow: {
          http: {
            requestUri: "/create-flow"
          },
          input: {
            type: "structure",
            required: [
              "flowName",
              "triggerConfig",
              "sourceFlowConfig",
              "destinationFlowConfigList",
              "tasks"
            ],
            members: {
              flowName: {},
              description: {},
              kmsArn: {},
              triggerConfig: {
                shape: "S2g"
              },
              sourceFlowConfig: {
                shape: "S2p"
              },
              destinationFlowConfigList: {
                shape: "S3a"
              },
              tasks: {
                shape: "S42"
              },
              tags: {
                shape: "S4r"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              flowArn: {},
              flowStatus: {}
            }
          }
        },
        DeleteConnectorProfile: {
          http: {
            requestUri: "/delete-connector-profile"
          },
          input: {
            type: "structure",
            required: [
              "connectorProfileName"
            ],
            members: {
              connectorProfileName: {},
              forceDelete: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteFlow: {
          http: {
            requestUri: "/delete-flow"
          },
          input: {
            type: "structure",
            required: [
              "flowName"
            ],
            members: {
              flowName: {},
              forceDelete: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeConnectorEntity: {
          http: {
            requestUri: "/describe-connector-entity"
          },
          input: {
            type: "structure",
            required: [
              "connectorEntityName"
            ],
            members: {
              connectorEntityName: {},
              connectorType: {},
              connectorProfileName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "connectorEntityFields"
            ],
            members: {
              connectorEntityFields: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "identifier"
                  ],
                  members: {
                    identifier: {},
                    label: {},
                    supportedFieldTypeDetails: {
                      type: "structure",
                      required: [
                        "v1"
                      ],
                      members: {
                        v1: {
                          type: "structure",
                          required: [
                            "fieldType",
                            "filterOperators"
                          ],
                          members: {
                            fieldType: {},
                            filterOperators: {
                              type: "list",
                              member: {}
                            },
                            supportedValues: {
                              type: "list",
                              member: {}
                            }
                          }
                        }
                      }
                    },
                    description: {},
                    sourceProperties: {
                      type: "structure",
                      members: {
                        isRetrievable: {
                          type: "boolean"
                        },
                        isQueryable: {
                          type: "boolean"
                        }
                      }
                    },
                    destinationProperties: {
                      type: "structure",
                      members: {
                        isCreatable: {
                          type: "boolean"
                        },
                        isNullable: {
                          type: "boolean"
                        },
                        isUpsertable: {
                          type: "boolean"
                        },
                        isUpdatable: {
                          type: "boolean"
                        },
                        supportedWriteOperations: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeConnectorProfiles: {
          http: {
            requestUri: "/describe-connector-profiles"
          },
          input: {
            type: "structure",
            members: {
              connectorProfileNames: {
                type: "list",
                member: {}
              },
              connectorType: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              connectorProfileDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    connectorProfileArn: {},
                    connectorProfileName: {},
                    connectorType: {},
                    connectionMode: {},
                    credentialsArn: {},
                    connectorProfileProperties: {
                      shape: "S7"
                    },
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    privateConnectionProvisioningState: {
                      type: "structure",
                      members: {
                        status: {},
                        failureMessage: {},
                        failureCause: {}
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeConnectors: {
          http: {
            requestUri: "/describe-connectors"
          },
          input: {
            type: "structure",
            members: {
              connectorTypes: {
                shape: "S5v"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              connectorConfigurations: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    canUseAsSource: {
                      type: "boolean"
                    },
                    canUseAsDestination: {
                      type: "boolean"
                    },
                    supportedDestinationConnectors: {
                      shape: "S5v"
                    },
                    supportedSchedulingFrequencies: {
                      type: "list",
                      member: {}
                    },
                    isPrivateLinkEnabled: {
                      type: "boolean"
                    },
                    isPrivateLinkEndpointUrlRequired: {
                      type: "boolean"
                    },
                    supportedTriggerTypes: {
                      type: "list",
                      member: {}
                    },
                    connectorMetadata: {
                      type: "structure",
                      members: {
                        Amplitude: {
                          type: "structure",
                          members: {}
                        },
                        Datadog: {
                          type: "structure",
                          members: {}
                        },
                        Dynatrace: {
                          type: "structure",
                          members: {}
                        },
                        GoogleAnalytics: {
                          type: "structure",
                          members: {
                            oAuthScopes: {
                              shape: "S18"
                            }
                          }
                        },
                        InforNexus: {
                          type: "structure",
                          members: {}
                        },
                        Marketo: {
                          type: "structure",
                          members: {}
                        },
                        Redshift: {
                          type: "structure",
                          members: {}
                        },
                        S3: {
                          type: "structure",
                          members: {}
                        },
                        Salesforce: {
                          type: "structure",
                          members: {
                            oAuthScopes: {
                              shape: "S18"
                            }
                          }
                        },
                        ServiceNow: {
                          type: "structure",
                          members: {}
                        },
                        Singular: {
                          type: "structure",
                          members: {}
                        },
                        Slack: {
                          type: "structure",
                          members: {
                            oAuthScopes: {
                              shape: "S18"
                            }
                          }
                        },
                        Snowflake: {
                          type: "structure",
                          members: {
                            supportedRegions: {
                              type: "list",
                              member: {}
                            }
                          }
                        },
                        Trendmicro: {
                          type: "structure",
                          members: {}
                        },
                        Veeva: {
                          type: "structure",
                          members: {}
                        },
                        Zendesk: {
                          type: "structure",
                          members: {
                            oAuthScopes: {
                              shape: "S18"
                            }
                          }
                        },
                        EventBridge: {
                          type: "structure",
                          members: {}
                        },
                        Upsolver: {
                          type: "structure",
                          members: {}
                        },
                        CustomerProfiles: {
                          type: "structure",
                          members: {}
                        },
                        Honeycode: {
                          type: "structure",
                          members: {
                            oAuthScopes: {
                              shape: "S18"
                            }
                          }
                        },
                        SAPOData: {
                          type: "structure",
                          members: {}
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeFlow: {
          http: {
            requestUri: "/describe-flow"
          },
          input: {
            type: "structure",
            required: [
              "flowName"
            ],
            members: {
              flowName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              flowArn: {},
              description: {},
              flowName: {},
              kmsArn: {},
              flowStatus: {},
              flowStatusMessage: {},
              sourceFlowConfig: {
                shape: "S2p"
              },
              destinationFlowConfigList: {
                shape: "S3a"
              },
              lastRunExecutionDetails: {
                shape: "S6s"
              },
              triggerConfig: {
                shape: "S2g"
              },
              tasks: {
                shape: "S42"
              },
              createdAt: {
                type: "timestamp"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              createdBy: {},
              lastUpdatedBy: {},
              tags: {
                shape: "S4r"
              }
            }
          }
        },
        DescribeFlowExecutionRecords: {
          http: {
            requestUri: "/describe-flow-execution-records"
          },
          input: {
            type: "structure",
            required: [
              "flowName"
            ],
            members: {
              flowName: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              flowExecutions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    executionId: {},
                    executionStatus: {},
                    executionResult: {
                      type: "structure",
                      members: {
                        errorInfo: {
                          type: "structure",
                          members: {
                            putFailuresCount: {
                              type: "long"
                            },
                            executionMessage: {}
                          }
                        },
                        bytesProcessed: {
                          type: "long"
                        },
                        bytesWritten: {
                          type: "long"
                        },
                        recordsProcessed: {
                          type: "long"
                        }
                      }
                    },
                    startedAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    dataPullStartTime: {
                      type: "timestamp"
                    },
                    dataPullEndTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListConnectorEntities: {
          http: {
            requestUri: "/list-connector-entities"
          },
          input: {
            type: "structure",
            members: {
              connectorProfileName: {},
              connectorType: {},
              entitiesPath: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "connectorEntityMap"
            ],
            members: {
              connectorEntityMap: {
                type: "map",
                key: {},
                value: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "name"
                    ],
                    members: {
                      name: {},
                      label: {},
                      hasNestedEntities: {
                        type: "boolean"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListFlows: {
          http: {
            requestUri: "/list-flows"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              flows: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    flowArn: {},
                    description: {},
                    flowName: {},
                    flowStatus: {},
                    sourceConnectorType: {},
                    destinationConnectorType: {},
                    triggerType: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    },
                    createdBy: {},
                    lastUpdatedBy: {},
                    tags: {
                      shape: "S4r"
                    },
                    lastRunExecutionDetails: {
                      shape: "S6s"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S4r"
              }
            }
          }
        },
        StartFlow: {
          http: {
            requestUri: "/start-flow"
          },
          input: {
            type: "structure",
            required: [
              "flowName"
            ],
            members: {
              flowName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              flowArn: {},
              flowStatus: {},
              executionId: {}
            }
          }
        },
        StopFlow: {
          http: {
            requestUri: "/stop-flow"
          },
          input: {
            type: "structure",
            required: [
              "flowName"
            ],
            members: {
              flowName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              flowArn: {},
              flowStatus: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S4r"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateConnectorProfile: {
          http: {
            requestUri: "/update-connector-profile"
          },
          input: {
            type: "structure",
            required: [
              "connectorProfileName",
              "connectionMode",
              "connectorProfileConfig"
            ],
            members: {
              connectorProfileName: {},
              connectionMode: {},
              connectorProfileConfig: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              connectorProfileArn: {}
            }
          }
        },
        UpdateFlow: {
          http: {
            requestUri: "/update-flow"
          },
          input: {
            type: "structure",
            required: [
              "flowName",
              "triggerConfig",
              "sourceFlowConfig",
              "destinationFlowConfigList",
              "tasks"
            ],
            members: {
              flowName: {},
              description: {},
              triggerConfig: {
                shape: "S2g"
              },
              sourceFlowConfig: {
                shape: "S2p"
              },
              destinationFlowConfigList: {
                shape: "S3a"
              },
              tasks: {
                shape: "S42"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              flowStatus: {}
            }
          }
        }
      },
      shapes: {
        S6: {
          type: "structure",
          required: [
            "connectorProfileProperties",
            "connectorProfileCredentials"
          ],
          members: {
            connectorProfileProperties: {
              shape: "S7"
            },
            connectorProfileCredentials: {
              type: "structure",
              members: {
                Amplitude: {
                  type: "structure",
                  required: [
                    "apiKey",
                    "secretKey"
                  ],
                  members: {
                    apiKey: {},
                    secretKey: {
                      type: "string",
                      sensitive: true
                    }
                  }
                },
                Datadog: {
                  type: "structure",
                  required: [
                    "apiKey",
                    "applicationKey"
                  ],
                  members: {
                    apiKey: {},
                    applicationKey: {}
                  }
                },
                Dynatrace: {
                  type: "structure",
                  required: [
                    "apiToken"
                  ],
                  members: {
                    apiToken: {}
                  }
                },
                GoogleAnalytics: {
                  type: "structure",
                  required: [
                    "clientId",
                    "clientSecret"
                  ],
                  members: {
                    clientId: {},
                    clientSecret: {
                      shape: "S1k"
                    },
                    accessToken: {
                      shape: "S1l"
                    },
                    refreshToken: {},
                    oAuthRequest: {
                      shape: "S1n"
                    }
                  }
                },
                Honeycode: {
                  type: "structure",
                  members: {
                    accessToken: {
                      shape: "S1l"
                    },
                    refreshToken: {},
                    oAuthRequest: {
                      shape: "S1n"
                    }
                  }
                },
                InforNexus: {
                  type: "structure",
                  required: [
                    "accessKeyId",
                    "userId",
                    "secretAccessKey",
                    "datakey"
                  ],
                  members: {
                    accessKeyId: {
                      type: "string",
                      sensitive: true
                    },
                    userId: {},
                    secretAccessKey: {},
                    datakey: {}
                  }
                },
                Marketo: {
                  type: "structure",
                  required: [
                    "clientId",
                    "clientSecret"
                  ],
                  members: {
                    clientId: {},
                    clientSecret: {
                      shape: "S1k"
                    },
                    accessToken: {
                      shape: "S1l"
                    },
                    oAuthRequest: {
                      shape: "S1n"
                    }
                  }
                },
                Redshift: {
                  type: "structure",
                  required: [
                    "username",
                    "password"
                  ],
                  members: {
                    username: {},
                    password: {
                      shape: "S1x"
                    }
                  }
                },
                Salesforce: {
                  type: "structure",
                  members: {
                    accessToken: {
                      shape: "S1l"
                    },
                    refreshToken: {},
                    oAuthRequest: {
                      shape: "S1n"
                    },
                    clientCredentialsArn: {
                      type: "string",
                      sensitive: true
                    }
                  }
                },
                ServiceNow: {
                  type: "structure",
                  required: [
                    "username",
                    "password"
                  ],
                  members: {
                    username: {},
                    password: {
                      shape: "S1x"
                    }
                  }
                },
                Singular: {
                  type: "structure",
                  required: [
                    "apiKey"
                  ],
                  members: {
                    apiKey: {}
                  }
                },
                Slack: {
                  type: "structure",
                  required: [
                    "clientId",
                    "clientSecret"
                  ],
                  members: {
                    clientId: {},
                    clientSecret: {
                      shape: "S1k"
                    },
                    accessToken: {
                      shape: "S1l"
                    },
                    oAuthRequest: {
                      shape: "S1n"
                    }
                  }
                },
                Snowflake: {
                  type: "structure",
                  required: [
                    "username",
                    "password"
                  ],
                  members: {
                    username: {},
                    password: {
                      shape: "S1x"
                    }
                  }
                },
                Trendmicro: {
                  type: "structure",
                  required: [
                    "apiSecretKey"
                  ],
                  members: {
                    apiSecretKey: {
                      type: "string",
                      sensitive: true
                    }
                  }
                },
                Veeva: {
                  type: "structure",
                  required: [
                    "username",
                    "password"
                  ],
                  members: {
                    username: {},
                    password: {
                      shape: "S1x"
                    }
                  }
                },
                Zendesk: {
                  type: "structure",
                  required: [
                    "clientId",
                    "clientSecret"
                  ],
                  members: {
                    clientId: {},
                    clientSecret: {
                      shape: "S1k"
                    },
                    accessToken: {
                      shape: "S1l"
                    },
                    oAuthRequest: {
                      shape: "S1n"
                    }
                  }
                },
                SAPOData: {
                  type: "structure",
                  members: {
                    basicAuthCredentials: {
                      type: "structure",
                      required: [
                        "username",
                        "password"
                      ],
                      members: {
                        username: {},
                        password: {
                          shape: "S1x"
                        }
                      }
                    },
                    oAuthCredentials: {
                      type: "structure",
                      required: [
                        "clientId",
                        "clientSecret"
                      ],
                      members: {
                        clientId: {},
                        clientSecret: {
                          shape: "S1k"
                        },
                        accessToken: {
                          shape: "S1l"
                        },
                        refreshToken: {},
                        oAuthRequest: {
                          shape: "S1n"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S7: {
          type: "structure",
          members: {
            Amplitude: {
              type: "structure",
              members: {}
            },
            Datadog: {
              type: "structure",
              required: [
                "instanceUrl"
              ],
              members: {
                instanceUrl: {}
              }
            },
            Dynatrace: {
              type: "structure",
              required: [
                "instanceUrl"
              ],
              members: {
                instanceUrl: {}
              }
            },
            GoogleAnalytics: {
              type: "structure",
              members: {}
            },
            Honeycode: {
              type: "structure",
              members: {}
            },
            InforNexus: {
              type: "structure",
              required: [
                "instanceUrl"
              ],
              members: {
                instanceUrl: {}
              }
            },
            Marketo: {
              type: "structure",
              required: [
                "instanceUrl"
              ],
              members: {
                instanceUrl: {}
              }
            },
            Redshift: {
              type: "structure",
              required: [
                "databaseUrl",
                "bucketName",
                "roleArn"
              ],
              members: {
                databaseUrl: {},
                bucketName: {},
                bucketPrefix: {},
                roleArn: {}
              }
            },
            Salesforce: {
              type: "structure",
              members: {
                instanceUrl: {},
                isSandboxEnvironment: {
                  type: "boolean"
                }
              }
            },
            ServiceNow: {
              type: "structure",
              required: [
                "instanceUrl"
              ],
              members: {
                instanceUrl: {}
              }
            },
            Singular: {
              type: "structure",
              members: {}
            },
            Slack: {
              type: "structure",
              required: [
                "instanceUrl"
              ],
              members: {
                instanceUrl: {}
              }
            },
            Snowflake: {
              type: "structure",
              required: [
                "warehouse",
                "stage",
                "bucketName"
              ],
              members: {
                warehouse: {},
                stage: {},
                bucketName: {},
                bucketPrefix: {},
                privateLinkServiceName: {},
                accountName: {},
                region: {}
              }
            },
            Trendmicro: {
              type: "structure",
              members: {}
            },
            Veeva: {
              type: "structure",
              required: [
                "instanceUrl"
              ],
              members: {
                instanceUrl: {}
              }
            },
            Zendesk: {
              type: "structure",
              required: [
                "instanceUrl"
              ],
              members: {
                instanceUrl: {}
              }
            },
            SAPOData: {
              type: "structure",
              required: [
                "applicationHostUrl",
                "applicationServicePath",
                "portNumber",
                "clientNumber"
              ],
              members: {
                applicationHostUrl: {},
                applicationServicePath: {},
                portNumber: {
                  type: "integer"
                },
                clientNumber: {},
                logonLanguage: {},
                privateLinkServiceName: {},
                oAuthProperties: {
                  type: "structure",
                  required: [
                    "tokenUrl",
                    "authCodeUrl",
                    "oAuthScopes"
                  ],
                  members: {
                    tokenUrl: {},
                    authCodeUrl: {},
                    oAuthScopes: {
                      shape: "S18"
                    }
                  }
                }
              }
            }
          }
        },
        S18: {
          type: "list",
          member: {}
        },
        S1k: {
          type: "string",
          sensitive: true
        },
        S1l: {
          type: "string",
          sensitive: true
        },
        S1n: {
          type: "structure",
          members: {
            authCode: {},
            redirectUri: {}
          }
        },
        S1x: {
          type: "string",
          sensitive: true
        },
        S2g: {
          type: "structure",
          required: [
            "triggerType"
          ],
          members: {
            triggerType: {},
            triggerProperties: {
              type: "structure",
              members: {
                Scheduled: {
                  type: "structure",
                  required: [
                    "scheduleExpression"
                  ],
                  members: {
                    scheduleExpression: {},
                    dataPullMode: {},
                    scheduleStartTime: {
                      type: "timestamp"
                    },
                    scheduleEndTime: {
                      type: "timestamp"
                    },
                    timezone: {},
                    scheduleOffset: {
                      type: "long"
                    },
                    firstExecutionFrom: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        S2p: {
          type: "structure",
          required: [
            "connectorType",
            "sourceConnectorProperties"
          ],
          members: {
            connectorType: {},
            connectorProfileName: {},
            sourceConnectorProperties: {
              type: "structure",
              members: {
                Amplitude: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                Datadog: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                Dynatrace: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                GoogleAnalytics: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                InforNexus: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                Marketo: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                S3: {
                  type: "structure",
                  required: [
                    "bucketName"
                  ],
                  members: {
                    bucketName: {},
                    bucketPrefix: {}
                  }
                },
                Salesforce: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {},
                    enableDynamicFieldUpdate: {
                      type: "boolean"
                    },
                    includeDeletedRecords: {
                      type: "boolean"
                    }
                  }
                },
                ServiceNow: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                Singular: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                Slack: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                Trendmicro: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                Veeva: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {},
                    documentType: {},
                    includeSourceFiles: {
                      type: "boolean"
                    },
                    includeRenditions: {
                      type: "boolean"
                    },
                    includeAllVersions: {
                      type: "boolean"
                    }
                  }
                },
                Zendesk: {
                  type: "structure",
                  required: [
                    "object"
                  ],
                  members: {
                    object: {}
                  }
                },
                SAPOData: {
                  type: "structure",
                  members: {
                    objectPath: {}
                  }
                }
              }
            },
            incrementalPullConfig: {
              type: "structure",
              members: {
                datetimeTypeFieldName: {}
              }
            }
          }
        },
        S3a: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "connectorType",
              "destinationConnectorProperties"
            ],
            members: {
              connectorType: {},
              connectorProfileName: {},
              destinationConnectorProperties: {
                type: "structure",
                members: {
                  Redshift: {
                    type: "structure",
                    required: [
                      "object",
                      "intermediateBucketName"
                    ],
                    members: {
                      object: {},
                      intermediateBucketName: {},
                      bucketPrefix: {},
                      errorHandlingConfig: {
                        shape: "S3e"
                      }
                    }
                  },
                  S3: {
                    type: "structure",
                    required: [
                      "bucketName"
                    ],
                    members: {
                      bucketName: {},
                      bucketPrefix: {},
                      s3OutputFormatConfig: {
                        type: "structure",
                        members: {
                          fileType: {},
                          prefixConfig: {
                            shape: "S3i"
                          },
                          aggregationConfig: {
                            shape: "S3l"
                          }
                        }
                      }
                    }
                  },
                  Salesforce: {
                    type: "structure",
                    required: [
                      "object"
                    ],
                    members: {
                      object: {},
                      idFieldNames: {
                        shape: "S3o"
                      },
                      errorHandlingConfig: {
                        shape: "S3e"
                      },
                      writeOperationType: {}
                    }
                  },
                  Snowflake: {
                    type: "structure",
                    required: [
                      "object",
                      "intermediateBucketName"
                    ],
                    members: {
                      object: {},
                      intermediateBucketName: {},
                      bucketPrefix: {},
                      errorHandlingConfig: {
                        shape: "S3e"
                      }
                    }
                  },
                  EventBridge: {
                    type: "structure",
                    required: [
                      "object"
                    ],
                    members: {
                      object: {},
                      errorHandlingConfig: {
                        shape: "S3e"
                      }
                    }
                  },
                  LookoutMetrics: {
                    type: "structure",
                    members: {}
                  },
                  Upsolver: {
                    type: "structure",
                    required: [
                      "bucketName",
                      "s3OutputFormatConfig"
                    ],
                    members: {
                      bucketName: {},
                      bucketPrefix: {},
                      s3OutputFormatConfig: {
                        type: "structure",
                        required: [
                          "prefixConfig"
                        ],
                        members: {
                          fileType: {},
                          prefixConfig: {
                            shape: "S3i"
                          },
                          aggregationConfig: {
                            shape: "S3l"
                          }
                        }
                      }
                    }
                  },
                  Honeycode: {
                    type: "structure",
                    required: [
                      "object"
                    ],
                    members: {
                      object: {},
                      errorHandlingConfig: {
                        shape: "S3e"
                      }
                    }
                  },
                  CustomerProfiles: {
                    type: "structure",
                    required: [
                      "domainName"
                    ],
                    members: {
                      domainName: {},
                      objectTypeName: {}
                    }
                  },
                  Zendesk: {
                    type: "structure",
                    required: [
                      "object"
                    ],
                    members: {
                      object: {},
                      idFieldNames: {
                        shape: "S3o"
                      },
                      errorHandlingConfig: {
                        shape: "S3e"
                      },
                      writeOperationType: {}
                    }
                  }
                }
              }
            }
          }
        },
        S3e: {
          type: "structure",
          members: {
            failOnFirstDestinationError: {
              type: "boolean"
            },
            bucketPrefix: {},
            bucketName: {}
          }
        },
        S3i: {
          type: "structure",
          members: {
            prefixType: {},
            prefixFormat: {}
          }
        },
        S3l: {
          type: "structure",
          members: {
            aggregationType: {}
          }
        },
        S3o: {
          type: "list",
          member: {}
        },
        S42: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "sourceFields",
              "taskType"
            ],
            members: {
              sourceFields: {
                type: "list",
                member: {}
              },
              connectorOperator: {
                type: "structure",
                members: {
                  Amplitude: {},
                  Datadog: {},
                  Dynatrace: {},
                  GoogleAnalytics: {},
                  InforNexus: {},
                  Marketo: {},
                  S3: {},
                  Salesforce: {},
                  ServiceNow: {},
                  Singular: {},
                  Slack: {},
                  Trendmicro: {},
                  Veeva: {},
                  Zendesk: {},
                  SAPOData: {}
                }
              },
              destinationField: {},
              taskType: {},
              taskProperties: {
                type: "map",
                key: {},
                value: {}
              }
            }
          }
        },
        S4r: {
          type: "map",
          key: {},
          value: {}
        },
        S5v: {
          type: "list",
          member: {}
        },
        S6s: {
          type: "structure",
          members: {
            mostRecentExecutionMessage: {},
            mostRecentExecutionTime: {
              type: "timestamp"
            },
            mostRecentExecutionStatus: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/appflow-2020-08-23.paginators.json
var require_appflow_2020_08_23_paginators = __commonJS({
  "node_modules/aws-sdk/apis/appflow-2020-08-23.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeConnectorProfiles: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        DescribeConnectors: {
          input_token: "nextToken",
          output_token: "nextToken"
        },
        DescribeFlowExecutionRecords: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListFlows: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/appflow.js
var require_appflow = __commonJS({
  "node_modules/aws-sdk/clients/appflow.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["appflow"] = {};
    AWS3.Appflow = Service.defineService("appflow", ["2020-08-23"]);
    Object.defineProperty(apiLoader.services["appflow"], "2020-08-23", {
      get: function get() {
        var model = require_appflow_2020_08_23_min();
        model.paginators = require_appflow_2020_08_23_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Appflow;
  }
});

// node_modules/aws-sdk/apis/redshift-data-2019-12-20.min.json
var require_redshift_data_2019_12_20_min = __commonJS({
  "node_modules/aws-sdk/apis/redshift-data-2019-12-20.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-12-20",
        endpointPrefix: "redshift-data",
        jsonVersion: "1.1",
        protocol: "json",
        serviceFullName: "Redshift Data API Service",
        serviceId: "Redshift Data",
        signatureVersion: "v4",
        signingName: "redshift-data",
        targetPrefix: "RedshiftData",
        uid: "redshift-data-2019-12-20"
      },
      operations: {
        BatchExecuteStatement: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "Database",
              "Sqls"
            ],
            members: {
              ClusterIdentifier: {},
              Database: {},
              DbUser: {},
              SecretArn: {},
              Sqls: {
                type: "list",
                member: {}
              },
              StatementName: {},
              WithEvent: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClusterIdentifier: {},
              CreatedAt: {
                type: "timestamp"
              },
              Database: {},
              DbUser: {},
              Id: {},
              SecretArn: {}
            }
          }
        },
        CancelStatement: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {
                type: "boolean"
              }
            }
          }
        },
        DescribeStatement: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              ClusterIdentifier: {},
              CreatedAt: {
                type: "timestamp"
              },
              Database: {},
              DbUser: {},
              Duration: {
                type: "long"
              },
              Error: {},
              HasResultSet: {
                type: "boolean"
              },
              Id: {},
              QueryParameters: {
                shape: "Sh"
              },
              QueryString: {},
              RedshiftPid: {
                type: "long"
              },
              RedshiftQueryId: {
                type: "long"
              },
              ResultRows: {
                type: "long"
              },
              ResultSize: {
                type: "long"
              },
              SecretArn: {},
              Status: {},
              SubStatements: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id"
                  ],
                  members: {
                    CreatedAt: {
                      type: "timestamp"
                    },
                    Duration: {
                      type: "long"
                    },
                    Error: {},
                    HasResultSet: {
                      type: "boolean"
                    },
                    Id: {},
                    QueryString: {},
                    RedshiftQueryId: {
                      type: "long"
                    },
                    ResultRows: {
                      type: "long"
                    },
                    ResultSize: {
                      type: "long"
                    },
                    Status: {},
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              UpdatedAt: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeTable: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "Database"
            ],
            members: {
              ClusterIdentifier: {},
              ConnectedDatabase: {},
              Database: {},
              DbUser: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Schema: {},
              SecretArn: {},
              Table: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ColumnList: {
                type: "list",
                member: {
                  shape: "St"
                }
              },
              NextToken: {},
              TableName: {}
            }
          }
        },
        ExecuteStatement: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "Database",
              "Sql"
            ],
            members: {
              ClusterIdentifier: {},
              Database: {},
              DbUser: {},
              Parameters: {
                shape: "Sh"
              },
              SecretArn: {},
              Sql: {},
              StatementName: {},
              WithEvent: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ClusterIdentifier: {},
              CreatedAt: {
                type: "timestamp"
              },
              Database: {},
              DbUser: {},
              Id: {},
              SecretArn: {}
            }
          }
        },
        GetStatementResult: {
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Records"
            ],
            members: {
              ColumnMetadata: {
                type: "list",
                member: {
                  shape: "St"
                }
              },
              NextToken: {},
              Records: {
                type: "list",
                member: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      blobValue: {
                        type: "blob"
                      },
                      booleanValue: {
                        type: "boolean"
                      },
                      doubleValue: {
                        type: "double"
                      },
                      isNull: {
                        type: "boolean"
                      },
                      longValue: {
                        type: "long"
                      },
                      stringValue: {}
                    },
                    union: true
                  }
                }
              },
              TotalNumRows: {
                type: "long"
              }
            }
          }
        },
        ListDatabases: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "Database"
            ],
            members: {
              ClusterIdentifier: {},
              Database: {},
              DbUser: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SecretArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Databases: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListSchemas: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "Database"
            ],
            members: {
              ClusterIdentifier: {},
              ConnectedDatabase: {},
              Database: {},
              DbUser: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SchemaPattern: {},
              SecretArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Schemas: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListStatements: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              RoleLevel: {
                type: "boolean"
              },
              StatementName: {},
              Status: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Statements"
            ],
            members: {
              NextToken: {},
              Statements: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Id"
                  ],
                  members: {
                    CreatedAt: {
                      type: "timestamp"
                    },
                    Id: {},
                    IsBatchStatement: {
                      type: "boolean"
                    },
                    QueryParameters: {
                      shape: "Sh"
                    },
                    QueryString: {},
                    QueryStrings: {
                      type: "list",
                      member: {}
                    },
                    SecretArn: {},
                    StatementName: {},
                    Status: {},
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListTables: {
          input: {
            type: "structure",
            required: [
              "ClusterIdentifier",
              "Database"
            ],
            members: {
              ClusterIdentifier: {},
              ConnectedDatabase: {},
              Database: {},
              DbUser: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              SchemaPattern: {},
              SecretArn: {},
              TablePattern: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Tables: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    schema: {},
                    type: {}
                  }
                }
              }
            }
          }
        }
      },
      shapes: {
        Sh: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "value"
            ],
            members: {
              name: {},
              value: {}
            }
          }
        },
        St: {
          type: "structure",
          members: {
            columnDefault: {},
            isCaseSensitive: {
              type: "boolean"
            },
            isCurrency: {
              type: "boolean"
            },
            isSigned: {
              type: "boolean"
            },
            label: {},
            length: {
              type: "integer"
            },
            name: {},
            nullable: {
              type: "integer"
            },
            precision: {
              type: "integer"
            },
            scale: {
              type: "integer"
            },
            schemaName: {},
            tableName: {},
            typeName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/redshift-data-2019-12-20.paginators.json
var require_redshift_data_2019_12_20_paginators = __commonJS({
  "node_modules/aws-sdk/apis/redshift-data-2019-12-20.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeTable: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ColumnList"
        },
        GetStatementResult: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Records"
        },
        ListDatabases: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Databases"
        },
        ListSchemas: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Schemas"
        },
        ListStatements: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Statements"
        },
        ListTables: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Tables"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/redshiftdata.js
var require_redshiftdata = __commonJS({
  "node_modules/aws-sdk/clients/redshiftdata.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["redshiftdata"] = {};
    AWS3.RedshiftData = Service.defineService("redshiftdata", ["2019-12-20"]);
    Object.defineProperty(apiLoader.services["redshiftdata"], "2019-12-20", {
      get: function get() {
        var model = require_redshift_data_2019_12_20_min();
        model.paginators = require_redshift_data_2019_12_20_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.RedshiftData;
  }
});

// node_modules/aws-sdk/apis/sso-admin-2020-07-20.min.json
var require_sso_admin_2020_07_20_min = __commonJS({
  "node_modules/aws-sdk/apis/sso-admin-2020-07-20.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-07-20",
        endpointPrefix: "sso",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "SSO Admin",
        serviceFullName: "AWS Single Sign-On Admin",
        serviceId: "SSO Admin",
        signatureVersion: "v4",
        signingName: "sso",
        targetPrefix: "SWBExternalService",
        uid: "sso-admin-2020-07-20"
      },
      operations: {
        AttachManagedPolicyToPermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn",
              "ManagedPolicyArn"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {},
              ManagedPolicyArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateAccountAssignment: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "TargetId",
              "TargetType",
              "PermissionSetArn",
              "PrincipalType",
              "PrincipalId"
            ],
            members: {
              InstanceArn: {},
              TargetId: {},
              TargetType: {},
              PermissionSetArn: {},
              PrincipalType: {},
              PrincipalId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccountAssignmentCreationStatus: {
                shape: "Sc"
              }
            }
          }
        },
        CreateInstanceAccessControlAttributeConfiguration: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "InstanceAccessControlAttributeConfiguration"
            ],
            members: {
              InstanceArn: {},
              InstanceAccessControlAttributeConfiguration: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreatePermissionSet: {
          input: {
            type: "structure",
            required: [
              "Name",
              "InstanceArn"
            ],
            members: {
              Name: {},
              Description: {},
              InstanceArn: {},
              SessionDuration: {},
              RelayState: {},
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PermissionSet: {
                shape: "S10"
              }
            }
          }
        },
        DeleteAccountAssignment: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "TargetId",
              "TargetType",
              "PermissionSetArn",
              "PrincipalType",
              "PrincipalId"
            ],
            members: {
              InstanceArn: {},
              TargetId: {},
              TargetType: {},
              PermissionSetArn: {},
              PrincipalType: {},
              PrincipalId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccountAssignmentDeletionStatus: {
                shape: "Sc"
              }
            }
          }
        },
        DeleteInlinePolicyFromPermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteInstanceAccessControlAttributeConfiguration: {
          input: {
            type: "structure",
            required: [
              "InstanceArn"
            ],
            members: {
              InstanceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeletePermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeAccountAssignmentCreationStatus: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "AccountAssignmentCreationRequestId"
            ],
            members: {
              InstanceArn: {},
              AccountAssignmentCreationRequestId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccountAssignmentCreationStatus: {
                shape: "Sc"
              }
            }
          }
        },
        DescribeAccountAssignmentDeletionStatus: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "AccountAssignmentDeletionRequestId"
            ],
            members: {
              InstanceArn: {},
              AccountAssignmentDeletionRequestId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccountAssignmentDeletionStatus: {
                shape: "Sc"
              }
            }
          }
        },
        DescribeInstanceAccessControlAttributeConfiguration: {
          input: {
            type: "structure",
            required: [
              "InstanceArn"
            ],
            members: {
              InstanceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {},
              StatusReason: {},
              InstanceAccessControlAttributeConfiguration: {
                shape: "Si"
              }
            }
          }
        },
        DescribePermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PermissionSet: {
                shape: "S10"
              }
            }
          }
        },
        DescribePermissionSetProvisioningStatus: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "ProvisionPermissionSetRequestId"
            ],
            members: {
              InstanceArn: {},
              ProvisionPermissionSetRequestId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PermissionSetProvisioningStatus: {
                shape: "S1l"
              }
            }
          }
        },
        DetachManagedPolicyFromPermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn",
              "ManagedPolicyArn"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {},
              ManagedPolicyArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetInlinePolicyForPermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InlinePolicy: {
                shape: "S1r"
              }
            }
          }
        },
        ListAccountAssignmentCreationStatus: {
          input: {
            type: "structure",
            required: [
              "InstanceArn"
            ],
            members: {
              InstanceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filter: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccountAssignmentsCreationStatus: {
                shape: "S1x"
              },
              NextToken: {}
            }
          }
        },
        ListAccountAssignmentDeletionStatus: {
          input: {
            type: "structure",
            required: [
              "InstanceArn"
            ],
            members: {
              InstanceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filter: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AccountAssignmentsDeletionStatus: {
                shape: "S1x"
              },
              NextToken: {}
            }
          }
        },
        ListAccountAssignments: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "AccountId",
              "PermissionSetArn"
            ],
            members: {
              InstanceArn: {},
              AccountId: {},
              PermissionSetArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccountAssignments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AccountId: {},
                    PermissionSetArn: {},
                    PrincipalType: {},
                    PrincipalId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAccountsForProvisionedPermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {},
              ProvisioningStatus: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AccountIds: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListInstances: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Instances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InstanceArn: {},
                    IdentityStoreId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListManagedPoliciesInPermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AttachedManagedPolicies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Arn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPermissionSetProvisioningStatus: {
          input: {
            type: "structure",
            required: [
              "InstanceArn"
            ],
            members: {
              InstanceArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Filter: {
                shape: "S1v"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PermissionSetsProvisioningStatus: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Status: {},
                    RequestId: {},
                    CreatedDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPermissionSets: {
          input: {
            type: "structure",
            required: [
              "InstanceArn"
            ],
            members: {
              InstanceArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PermissionSets: {
                shape: "S2p"
              },
              NextToken: {}
            }
          }
        },
        ListPermissionSetsProvisionedToAccount: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "AccountId"
            ],
            members: {
              InstanceArn: {},
              AccountId: {},
              ProvisioningStatus: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              PermissionSets: {
                shape: "S2p"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "ResourceArn"
            ],
            members: {
              InstanceArn: {},
              ResourceArn: {},
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sv"
              },
              NextToken: {}
            }
          }
        },
        ProvisionPermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn",
              "TargetType"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {},
              TargetId: {},
              TargetType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PermissionSetProvisioningStatus: {
                shape: "S1l"
              }
            }
          }
        },
        PutInlinePolicyToPermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn",
              "InlinePolicy"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {},
              InlinePolicy: {
                shape: "S1r"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "ResourceArn",
              "Tags"
            ],
            members: {
              InstanceArn: {},
              ResourceArn: {},
              Tags: {
                shape: "Sv"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              InstanceArn: {},
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateInstanceAccessControlAttributeConfiguration: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "InstanceAccessControlAttributeConfiguration"
            ],
            members: {
              InstanceArn: {},
              InstanceAccessControlAttributeConfiguration: {
                shape: "Si"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdatePermissionSet: {
          input: {
            type: "structure",
            required: [
              "InstanceArn",
              "PermissionSetArn"
            ],
            members: {
              InstanceArn: {},
              PermissionSetArn: {},
              Description: {},
              SessionDuration: {},
              RelayState: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sc: {
          type: "structure",
          members: {
            Status: {},
            RequestId: {},
            FailureReason: {},
            TargetId: {},
            TargetType: {},
            PermissionSetArn: {},
            PrincipalType: {},
            PrincipalId: {},
            CreatedDate: {
              type: "timestamp"
            }
          }
        },
        Si: {
          type: "structure",
          required: [
            "AccessControlAttributes"
          ],
          members: {
            AccessControlAttributes: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Key",
                  "Value"
                ],
                members: {
                  Key: {},
                  Value: {
                    type: "structure",
                    required: [
                      "Source"
                    ],
                    members: {
                      Source: {
                        type: "list",
                        member: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sv: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S10: {
          type: "structure",
          members: {
            Name: {},
            PermissionSetArn: {},
            Description: {},
            CreatedDate: {
              type: "timestamp"
            },
            SessionDuration: {},
            RelayState: {}
          }
        },
        S1l: {
          type: "structure",
          members: {
            Status: {},
            RequestId: {},
            AccountId: {},
            PermissionSetArn: {},
            FailureReason: {},
            CreatedDate: {
              type: "timestamp"
            }
          }
        },
        S1r: {
          type: "string",
          sensitive: true
        },
        S1v: {
          type: "structure",
          members: {
            Status: {}
          }
        },
        S1x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Status: {},
              RequestId: {},
              CreatedDate: {
                type: "timestamp"
              }
            }
          }
        },
        S2p: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sso-admin-2020-07-20.paginators.json
var require_sso_admin_2020_07_20_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sso-admin-2020-07-20.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAccountAssignmentCreationStatus: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AccountAssignmentsCreationStatus"
        },
        ListAccountAssignmentDeletionStatus: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AccountAssignmentsDeletionStatus"
        },
        ListAccountAssignments: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AccountAssignments"
        },
        ListAccountsForProvisionedPermissionSet: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AccountIds"
        },
        ListInstances: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Instances"
        },
        ListManagedPoliciesInPermissionSet: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "AttachedManagedPolicies"
        },
        ListPermissionSetProvisioningStatus: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PermissionSetsProvisioningStatus"
        },
        ListPermissionSets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PermissionSets"
        },
        ListPermissionSetsProvisionedToAccount: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "PermissionSets"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Tags"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ssoadmin.js
var require_ssoadmin = __commonJS({
  "node_modules/aws-sdk/clients/ssoadmin.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["ssoadmin"] = {};
    AWS3.SSOAdmin = Service.defineService("ssoadmin", ["2020-07-20"]);
    Object.defineProperty(apiLoader.services["ssoadmin"], "2020-07-20", {
      get: function get() {
        var model = require_sso_admin_2020_07_20_min();
        model.paginators = require_sso_admin_2020_07_20_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SSOAdmin;
  }
});

// node_modules/aws-sdk/apis/timestream-query-2018-11-01.min.json
var require_timestream_query_2018_11_01_min = __commonJS({
  "node_modules/aws-sdk/apis/timestream-query-2018-11-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-11-01",
        endpointPrefix: "query.timestream",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "Timestream Query",
        serviceFullName: "Amazon Timestream Query",
        serviceId: "Timestream Query",
        signatureVersion: "v4",
        signingName: "timestream",
        targetPrefix: "Timestream_20181101",
        uid: "timestream-query-2018-11-01"
      },
      operations: {
        CancelQuery: {
          input: {
            type: "structure",
            required: [
              "QueryId"
            ],
            members: {
              QueryId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              CancellationMessage: {}
            }
          },
          endpointdiscovery: {
            required: true
          },
          idempotent: true
        },
        DescribeEndpoints: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "Endpoints"
            ],
            members: {
              Endpoints: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Address",
                    "CachePeriodInMinutes"
                  ],
                  members: {
                    Address: {},
                    CachePeriodInMinutes: {
                      type: "long"
                    }
                  }
                }
              }
            }
          },
          endpointoperation: true
        },
        Query: {
          input: {
            type: "structure",
            required: [
              "QueryString"
            ],
            members: {
              QueryString: {
                type: "string",
                sensitive: true
              },
              ClientToken: {
                idempotencyToken: true,
                type: "string",
                sensitive: true
              },
              NextToken: {},
              MaxRows: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "QueryId",
              "Rows",
              "ColumnInfo"
            ],
            members: {
              QueryId: {},
              NextToken: {},
              Rows: {
                type: "list",
                member: {
                  shape: "Sg"
                }
              },
              ColumnInfo: {
                shape: "So"
              },
              QueryStatus: {
                type: "structure",
                members: {
                  ProgressPercentage: {
                    type: "double"
                  },
                  CumulativeBytesScanned: {
                    type: "long"
                  },
                  CumulativeBytesMetered: {
                    type: "long"
                  }
                }
              }
            }
          },
          endpointdiscovery: {
            required: true
          },
          idempotent: true
        }
      },
      shapes: {
        Sg: {
          type: "structure",
          required: [
            "Data"
          ],
          members: {
            Data: {
              shape: "Sh"
            }
          }
        },
        Sh: {
          type: "list",
          member: {
            shape: "Si"
          }
        },
        Si: {
          type: "structure",
          members: {
            ScalarValue: {},
            TimeSeriesValue: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Time",
                  "Value"
                ],
                members: {
                  Time: {},
                  Value: {
                    shape: "Si"
                  }
                }
              }
            },
            ArrayValue: {
              shape: "Sh"
            },
            RowValue: {
              shape: "Sg"
            },
            NullValue: {
              type: "boolean"
            }
          }
        },
        So: {
          type: "list",
          member: {
            shape: "Sp"
          }
        },
        Sp: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Name: {},
            Type: {
              type: "structure",
              members: {
                ScalarType: {},
                ArrayColumnInfo: {
                  shape: "Sp"
                },
                TimeSeriesMeasureValueColumnInfo: {
                  shape: "Sp"
                },
                RowColumnInfo: {
                  shape: "So"
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/timestream-query-2018-11-01.paginators.json
var require_timestream_query_2018_11_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/timestream-query-2018-11-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        Query: {
          input_token: "NextToken",
          limit_key: "MaxRows",
          non_aggregate_keys: [
            "ColumnInfo",
            "QueryId",
            "QueryStatus"
          ],
          output_token: "NextToken",
          result_key: "Rows"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/timestreamquery.js
var require_timestreamquery = __commonJS({
  "node_modules/aws-sdk/clients/timestreamquery.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["timestreamquery"] = {};
    AWS3.TimestreamQuery = Service.defineService("timestreamquery", ["2018-11-01"]);
    Object.defineProperty(apiLoader.services["timestreamquery"], "2018-11-01", {
      get: function get() {
        var model = require_timestream_query_2018_11_01_min();
        model.paginators = require_timestream_query_2018_11_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.TimestreamQuery;
  }
});

// node_modules/aws-sdk/apis/timestream-write-2018-11-01.min.json
var require_timestream_write_2018_11_01_min = __commonJS({
  "node_modules/aws-sdk/apis/timestream-write-2018-11-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-11-01",
        endpointPrefix: "ingest.timestream",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "Timestream Write",
        serviceFullName: "Amazon Timestream Write",
        serviceId: "Timestream Write",
        signatureVersion: "v4",
        signingName: "timestream",
        targetPrefix: "Timestream_20181101",
        uid: "timestream-write-2018-11-01"
      },
      operations: {
        CreateDatabase: {
          input: {
            type: "structure",
            required: [
              "DatabaseName"
            ],
            members: {
              DatabaseName: {},
              KmsKeyId: {},
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Database: {
                shape: "S9"
              }
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        CreateTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              DatabaseName: {},
              TableName: {},
              RetentionProperties: {
                shape: "Se"
              },
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Table: {
                shape: "Si"
              }
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        DeleteDatabase: {
          input: {
            type: "structure",
            required: [
              "DatabaseName"
            ],
            members: {
              DatabaseName: {}
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        DeleteTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              DatabaseName: {},
              TableName: {}
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        DescribeDatabase: {
          input: {
            type: "structure",
            required: [
              "DatabaseName"
            ],
            members: {
              DatabaseName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Database: {
                shape: "S9"
              }
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        DescribeEndpoints: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "Endpoints"
            ],
            members: {
              Endpoints: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Address",
                    "CachePeriodInMinutes"
                  ],
                  members: {
                    Address: {},
                    CachePeriodInMinutes: {
                      type: "long"
                    }
                  }
                }
              }
            }
          },
          endpointoperation: true
        },
        DescribeTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              DatabaseName: {},
              TableName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Table: {
                shape: "Si"
              }
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        ListDatabases: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Databases: {
                type: "list",
                member: {
                  shape: "S9"
                }
              },
              NextToken: {}
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        ListTables: {
          input: {
            type: "structure",
            members: {
              DatabaseName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tables: {
                type: "list",
                member: {
                  shape: "Si"
                }
              },
              NextToken: {}
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S4"
              }
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpointdiscovery: {
            required: true
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpointdiscovery: {
            required: true
          }
        },
        UpdateDatabase: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "KmsKeyId"
            ],
            members: {
              DatabaseName: {},
              KmsKeyId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Database: {
                shape: "S9"
              }
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        UpdateTable: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "RetentionProperties"
            ],
            members: {
              DatabaseName: {},
              TableName: {},
              RetentionProperties: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Table: {
                shape: "Si"
              }
            }
          },
          endpointdiscovery: {
            required: true
          }
        },
        WriteRecords: {
          input: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName",
              "Records"
            ],
            members: {
              DatabaseName: {},
              TableName: {},
              CommonAttributes: {
                shape: "S1e"
              },
              Records: {
                type: "list",
                member: {
                  shape: "S1e"
                }
              }
            }
          },
          endpointdiscovery: {
            required: true
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S9: {
          type: "structure",
          members: {
            Arn: {},
            DatabaseName: {},
            TableCount: {
              type: "long"
            },
            KmsKeyId: {},
            CreationTime: {
              type: "timestamp"
            },
            LastUpdatedTime: {
              type: "timestamp"
            }
          }
        },
        Se: {
          type: "structure",
          required: [
            "MemoryStoreRetentionPeriodInHours",
            "MagneticStoreRetentionPeriodInDays"
          ],
          members: {
            MemoryStoreRetentionPeriodInHours: {
              type: "long"
            },
            MagneticStoreRetentionPeriodInDays: {
              type: "long"
            }
          }
        },
        Si: {
          type: "structure",
          members: {
            Arn: {},
            TableName: {},
            DatabaseName: {},
            TableStatus: {},
            RetentionProperties: {
              shape: "Se"
            },
            CreationTime: {
              type: "timestamp"
            },
            LastUpdatedTime: {
              type: "timestamp"
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            Dimensions: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Name",
                  "Value"
                ],
                members: {
                  Name: {},
                  Value: {},
                  DimensionValueType: {}
                }
              }
            },
            MeasureName: {},
            MeasureValue: {},
            MeasureValueType: {},
            Time: {},
            TimeUnit: {},
            Version: {
              type: "long"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/timestream-write-2018-11-01.paginators.json
var require_timestream_write_2018_11_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/timestream-write-2018-11-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListDatabases: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListTables: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/timestreamwrite.js
var require_timestreamwrite = __commonJS({
  "node_modules/aws-sdk/clients/timestreamwrite.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["timestreamwrite"] = {};
    AWS3.TimestreamWrite = Service.defineService("timestreamwrite", ["2018-11-01"]);
    Object.defineProperty(apiLoader.services["timestreamwrite"], "2018-11-01", {
      get: function get() {
        var model = require_timestream_write_2018_11_01_min();
        model.paginators = require_timestream_write_2018_11_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.TimestreamWrite;
  }
});

// node_modules/aws-sdk/apis/s3outposts-2017-07-25.min.json
var require_s3outposts_2017_07_25_min = __commonJS({
  "node_modules/aws-sdk/apis/s3outposts-2017-07-25.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-25",
        endpointPrefix: "s3-outposts",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon S3 Outposts",
        serviceFullName: "Amazon S3 on Outposts",
        serviceId: "S3Outposts",
        signatureVersion: "v4",
        signingName: "s3-outposts",
        uid: "s3outposts-2017-07-25"
      },
      operations: {
        CreateEndpoint: {
          http: {
            requestUri: "/S3Outposts/CreateEndpoint"
          },
          input: {
            type: "structure",
            required: [
              "OutpostId",
              "SubnetId",
              "SecurityGroupId"
            ],
            members: {
              OutpostId: {},
              SubnetId: {},
              SecurityGroupId: {},
              AccessType: {},
              CustomerOwnedIpv4Pool: {}
            }
          },
          output: {
            type: "structure",
            members: {
              EndpointArn: {}
            }
          }
        },
        DeleteEndpoint: {
          http: {
            method: "DELETE",
            requestUri: "/S3Outposts/DeleteEndpoint"
          },
          input: {
            type: "structure",
            required: [
              "EndpointId",
              "OutpostId"
            ],
            members: {
              EndpointId: {
                location: "querystring",
                locationName: "endpointId"
              },
              OutpostId: {
                location: "querystring",
                locationName: "outpostId"
              }
            }
          }
        },
        ListEndpoints: {
          http: {
            method: "GET",
            requestUri: "/S3Outposts/ListEndpoints"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Endpoints: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EndpointArn: {},
                    OutpostsId: {},
                    CidrBlock: {},
                    Status: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    NetworkInterfaces: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          NetworkInterfaceId: {}
                        }
                      }
                    },
                    VpcId: {},
                    SubnetId: {},
                    SecurityGroupId: {},
                    AccessType: {},
                    CustomerOwnedIpv4Pool: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/s3outposts-2017-07-25.paginators.json
var require_s3outposts_2017_07_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/s3outposts-2017-07-25.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListEndpoints: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Endpoints"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/s3outposts.js
var require_s3outposts = __commonJS({
  "node_modules/aws-sdk/clients/s3outposts.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["s3outposts"] = {};
    AWS3.S3Outposts = Service.defineService("s3outposts", ["2017-07-25"]);
    Object.defineProperty(apiLoader.services["s3outposts"], "2017-07-25", {
      get: function get() {
        var model = require_s3outposts_2017_07_25_min();
        model.paginators = require_s3outposts_2017_07_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.S3Outposts;
  }
});

// node_modules/aws-sdk/apis/databrew-2017-07-25.min.json
var require_databrew_2017_07_25_min = __commonJS({
  "node_modules/aws-sdk/apis/databrew-2017-07-25.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-25",
        endpointPrefix: "databrew",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Glue DataBrew",
        serviceId: "DataBrew",
        signatureVersion: "v4",
        signingName: "databrew",
        uid: "databrew-2017-07-25"
      },
      operations: {
        BatchDeleteRecipeVersion: {
          http: {
            requestUri: "/recipes/{name}/batchDeleteRecipeVersion"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "RecipeVersions"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              RecipeVersions: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ErrorCode: {},
                    ErrorMessage: {},
                    RecipeVersion: {}
                  }
                }
              }
            }
          }
        },
        CreateDataset: {
          http: {
            requestUri: "/datasets"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Input"
            ],
            members: {
              Name: {},
              Format: {},
              FormatOptions: {
                shape: "Sd"
              },
              Input: {
                shape: "So"
              },
              PathOptions: {
                shape: "Sz"
              },
              Tags: {
                shape: "S1i"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        CreateProfileJob: {
          http: {
            requestUri: "/profileJobs"
          },
          input: {
            type: "structure",
            required: [
              "DatasetName",
              "Name",
              "OutputLocation",
              "RoleArn"
            ],
            members: {
              DatasetName: {},
              EncryptionKeyArn: {},
              EncryptionMode: {},
              Name: {},
              LogSubscription: {},
              MaxCapacity: {
                type: "integer"
              },
              MaxRetries: {
                type: "integer"
              },
              OutputLocation: {
                shape: "Sp"
              },
              Configuration: {
                shape: "S1t"
              },
              RoleArn: {},
              Tags: {
                shape: "S1i"
              },
              Timeout: {
                type: "integer"
              },
              JobSample: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        CreateProject: {
          http: {
            requestUri: "/projects"
          },
          input: {
            type: "structure",
            required: [
              "DatasetName",
              "Name",
              "RecipeName",
              "RoleArn"
            ],
            members: {
              DatasetName: {},
              Name: {},
              RecipeName: {},
              Sample: {
                shape: "S2f"
              },
              RoleArn: {},
              Tags: {
                shape: "S1i"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        CreateRecipe: {
          http: {
            requestUri: "/recipes"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Steps"
            ],
            members: {
              Description: {},
              Name: {},
              Steps: {
                shape: "S2l"
              },
              Tags: {
                shape: "S1i"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        CreateRecipeJob: {
          http: {
            requestUri: "/recipeJobs"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "RoleArn"
            ],
            members: {
              DatasetName: {},
              EncryptionKeyArn: {},
              EncryptionMode: {},
              Name: {},
              LogSubscription: {},
              MaxCapacity: {
                type: "integer"
              },
              MaxRetries: {
                type: "integer"
              },
              Outputs: {
                shape: "S2v"
              },
              DataCatalogOutputs: {
                shape: "S33"
              },
              DatabaseOutputs: {
                shape: "S37"
              },
              ProjectName: {},
              RecipeReference: {
                shape: "S3a"
              },
              RoleArn: {},
              Tags: {
                shape: "S1i"
              },
              Timeout: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        CreateSchedule: {
          http: {
            requestUri: "/schedules"
          },
          input: {
            type: "structure",
            required: [
              "CronExpression",
              "Name"
            ],
            members: {
              JobNames: {
                shape: "S3d"
              },
              CronExpression: {},
              Tags: {
                shape: "S1i"
              },
              Name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DeleteDataset: {
          http: {
            method: "DELETE",
            requestUri: "/datasets/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DeleteJob: {
          http: {
            method: "DELETE",
            requestUri: "/jobs/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DeleteProject: {
          http: {
            method: "DELETE",
            requestUri: "/projects/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DeleteRecipeVersion: {
          http: {
            method: "DELETE",
            requestUri: "/recipes/{name}/recipeVersion/{recipeVersion}"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "RecipeVersion"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              RecipeVersion: {
                location: "uri",
                locationName: "recipeVersion"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name",
              "RecipeVersion"
            ],
            members: {
              Name: {},
              RecipeVersion: {}
            }
          }
        },
        DeleteSchedule: {
          http: {
            method: "DELETE",
            requestUri: "/schedules/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        DescribeDataset: {
          http: {
            method: "GET",
            requestUri: "/datasets/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name",
              "Input"
            ],
            members: {
              CreatedBy: {},
              CreateDate: {
                type: "timestamp"
              },
              Name: {},
              Format: {},
              FormatOptions: {
                shape: "Sd"
              },
              Input: {
                shape: "So"
              },
              LastModifiedDate: {
                type: "timestamp"
              },
              LastModifiedBy: {},
              Source: {},
              PathOptions: {
                shape: "Sz"
              },
              Tags: {
                shape: "S1i"
              },
              ResourceArn: {}
            }
          }
        },
        DescribeJob: {
          http: {
            method: "GET",
            requestUri: "/jobs/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              CreateDate: {
                type: "timestamp"
              },
              CreatedBy: {},
              DatasetName: {},
              EncryptionKeyArn: {},
              EncryptionMode: {},
              Name: {},
              Type: {},
              LastModifiedBy: {},
              LastModifiedDate: {
                type: "timestamp"
              },
              LogSubscription: {},
              MaxCapacity: {
                type: "integer"
              },
              MaxRetries: {
                type: "integer"
              },
              Outputs: {
                shape: "S2v"
              },
              DataCatalogOutputs: {
                shape: "S33"
              },
              DatabaseOutputs: {
                shape: "S37"
              },
              ProjectName: {},
              ProfileConfiguration: {
                shape: "S1t"
              },
              RecipeReference: {
                shape: "S3a"
              },
              ResourceArn: {},
              RoleArn: {},
              Tags: {
                shape: "S1i"
              },
              Timeout: {
                type: "integer"
              },
              JobSample: {
                shape: "S29"
              }
            }
          }
        },
        DescribeJobRun: {
          http: {
            method: "GET",
            requestUri: "/jobs/{name}/jobRun/{runId}"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "RunId"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              RunId: {
                location: "uri",
                locationName: "runId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobName"
            ],
            members: {
              Attempt: {
                type: "integer"
              },
              CompletedOn: {
                type: "timestamp"
              },
              DatasetName: {},
              ErrorMessage: {},
              ExecutionTime: {
                type: "integer"
              },
              JobName: {},
              ProfileConfiguration: {
                shape: "S1t"
              },
              RunId: {},
              State: {},
              LogSubscription: {},
              LogGroupName: {},
              Outputs: {
                shape: "S2v"
              },
              DataCatalogOutputs: {
                shape: "S33"
              },
              DatabaseOutputs: {
                shape: "S37"
              },
              RecipeReference: {
                shape: "S3a"
              },
              StartedBy: {},
              StartedOn: {
                type: "timestamp"
              },
              JobSample: {
                shape: "S29"
              }
            }
          }
        },
        DescribeProject: {
          http: {
            method: "GET",
            requestUri: "/projects/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              CreateDate: {
                type: "timestamp"
              },
              CreatedBy: {},
              DatasetName: {},
              LastModifiedDate: {
                type: "timestamp"
              },
              LastModifiedBy: {},
              Name: {},
              RecipeName: {},
              ResourceArn: {},
              Sample: {
                shape: "S2f"
              },
              RoleArn: {},
              Tags: {
                shape: "S1i"
              },
              SessionStatus: {},
              OpenedBy: {},
              OpenDate: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeRecipe: {
          http: {
            method: "GET",
            requestUri: "/recipes/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              RecipeVersion: {
                location: "querystring",
                locationName: "recipeVersion"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              CreatedBy: {},
              CreateDate: {
                type: "timestamp"
              },
              LastModifiedBy: {},
              LastModifiedDate: {
                type: "timestamp"
              },
              ProjectName: {},
              PublishedBy: {},
              PublishedDate: {
                type: "timestamp"
              },
              Description: {},
              Name: {},
              Steps: {
                shape: "S2l"
              },
              Tags: {
                shape: "S1i"
              },
              ResourceArn: {},
              RecipeVersion: {}
            }
          }
        },
        DescribeSchedule: {
          http: {
            method: "GET",
            requestUri: "/schedules/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              CreateDate: {
                type: "timestamp"
              },
              CreatedBy: {},
              JobNames: {
                shape: "S3d"
              },
              LastModifiedBy: {},
              LastModifiedDate: {
                type: "timestamp"
              },
              ResourceArn: {},
              CronExpression: {},
              Tags: {
                shape: "S1i"
              },
              Name: {}
            }
          }
        },
        ListDatasets: {
          http: {
            method: "GET",
            requestUri: "/datasets"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Datasets"
            ],
            members: {
              Datasets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Input"
                  ],
                  members: {
                    AccountId: {},
                    CreatedBy: {},
                    CreateDate: {
                      type: "timestamp"
                    },
                    Name: {},
                    Format: {},
                    FormatOptions: {
                      shape: "Sd"
                    },
                    Input: {
                      shape: "So"
                    },
                    LastModifiedDate: {
                      type: "timestamp"
                    },
                    LastModifiedBy: {},
                    Source: {},
                    PathOptions: {
                      shape: "Sz"
                    },
                    Tags: {
                      shape: "S1i"
                    },
                    ResourceArn: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListJobRuns: {
          http: {
            method: "GET",
            requestUri: "/jobs/{name}/jobRuns"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobRuns"
            ],
            members: {
              JobRuns: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Attempt: {
                      type: "integer"
                    },
                    CompletedOn: {
                      type: "timestamp"
                    },
                    DatasetName: {},
                    ErrorMessage: {},
                    ExecutionTime: {
                      type: "integer"
                    },
                    JobName: {},
                    RunId: {},
                    State: {},
                    LogSubscription: {},
                    LogGroupName: {},
                    Outputs: {
                      shape: "S2v"
                    },
                    DataCatalogOutputs: {
                      shape: "S33"
                    },
                    DatabaseOutputs: {
                      shape: "S37"
                    },
                    RecipeReference: {
                      shape: "S3a"
                    },
                    StartedBy: {},
                    StartedOn: {
                      type: "timestamp"
                    },
                    JobSample: {
                      shape: "S29"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListJobs: {
          http: {
            method: "GET",
            requestUri: "/jobs"
          },
          input: {
            type: "structure",
            members: {
              DatasetName: {
                location: "querystring",
                locationName: "datasetName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ProjectName: {
                location: "querystring",
                locationName: "projectName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Jobs"
            ],
            members: {
              Jobs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name"
                  ],
                  members: {
                    AccountId: {},
                    CreatedBy: {},
                    CreateDate: {
                      type: "timestamp"
                    },
                    DatasetName: {},
                    EncryptionKeyArn: {},
                    EncryptionMode: {},
                    Name: {},
                    Type: {},
                    LastModifiedBy: {},
                    LastModifiedDate: {
                      type: "timestamp"
                    },
                    LogSubscription: {},
                    MaxCapacity: {
                      type: "integer"
                    },
                    MaxRetries: {
                      type: "integer"
                    },
                    Outputs: {
                      shape: "S2v"
                    },
                    DataCatalogOutputs: {
                      shape: "S33"
                    },
                    DatabaseOutputs: {
                      shape: "S37"
                    },
                    ProjectName: {},
                    RecipeReference: {
                      shape: "S3a"
                    },
                    ResourceArn: {},
                    RoleArn: {},
                    Timeout: {
                      type: "integer"
                    },
                    Tags: {
                      shape: "S1i"
                    },
                    JobSample: {
                      shape: "S29"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProjects: {
          http: {
            method: "GET",
            requestUri: "/projects"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Projects"
            ],
            members: {
              Projects: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "RecipeName"
                  ],
                  members: {
                    AccountId: {},
                    CreateDate: {
                      type: "timestamp"
                    },
                    CreatedBy: {},
                    DatasetName: {},
                    LastModifiedDate: {
                      type: "timestamp"
                    },
                    LastModifiedBy: {},
                    Name: {},
                    RecipeName: {},
                    ResourceArn: {},
                    Sample: {
                      shape: "S2f"
                    },
                    Tags: {
                      shape: "S1i"
                    },
                    RoleArn: {},
                    OpenedBy: {},
                    OpenDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRecipeVersions: {
          http: {
            method: "GET",
            requestUri: "/recipeVersions"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              Name: {
                location: "querystring",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Recipes"
            ],
            members: {
              NextToken: {},
              Recipes: {
                shape: "S53"
              }
            }
          }
        },
        ListRecipes: {
          http: {
            method: "GET",
            requestUri: "/recipes"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RecipeVersion: {
                location: "querystring",
                locationName: "recipeVersion"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Recipes"
            ],
            members: {
              Recipes: {
                shape: "S53"
              },
              NextToken: {}
            }
          }
        },
        ListSchedules: {
          http: {
            method: "GET",
            requestUri: "/schedules"
          },
          input: {
            type: "structure",
            members: {
              JobName: {
                location: "querystring",
                locationName: "jobName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Schedules"
            ],
            members: {
              Schedules: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name"
                  ],
                  members: {
                    AccountId: {},
                    CreatedBy: {},
                    CreateDate: {
                      type: "timestamp"
                    },
                    JobNames: {
                      shape: "S3d"
                    },
                    LastModifiedBy: {},
                    LastModifiedDate: {
                      type: "timestamp"
                    },
                    ResourceArn: {},
                    CronExpression: {},
                    Tags: {
                      shape: "S1i"
                    },
                    Name: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S1i"
              }
            }
          }
        },
        PublishRecipe: {
          http: {
            requestUri: "/recipes/{name}/publishRecipe"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Description: {},
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        SendProjectSessionAction: {
          http: {
            method: "PUT",
            requestUri: "/projects/{name}/sendProjectSessionAction"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Preview: {
                type: "boolean"
              },
              Name: {
                location: "uri",
                locationName: "name"
              },
              RecipeStep: {
                shape: "S2m"
              },
              StepIndex: {
                type: "integer"
              },
              ClientSessionId: {},
              ViewFrame: {
                type: "structure",
                required: [
                  "StartColumnIndex"
                ],
                members: {
                  StartColumnIndex: {
                    type: "integer"
                  },
                  ColumnRange: {
                    type: "integer"
                  },
                  HiddenColumns: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Result: {},
              Name: {},
              ActionId: {
                type: "integer"
              }
            }
          }
        },
        StartJobRun: {
          http: {
            requestUri: "/jobs/{name}/startJobRun"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RunId"
            ],
            members: {
              RunId: {}
            }
          }
        },
        StartProjectSession: {
          http: {
            method: "PUT",
            requestUri: "/projects/{name}/startProjectSession"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              AssumeControl: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              ClientSessionId: {}
            }
          }
        },
        StopJobRun: {
          http: {
            requestUri: "/jobs/{name}/jobRun/{runId}/stopJobRun"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "RunId"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              RunId: {
                location: "uri",
                locationName: "runId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "RunId"
            ],
            members: {
              RunId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "S1i"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDataset: {
          http: {
            method: "PUT",
            requestUri: "/datasets/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "Input"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "name"
              },
              Format: {},
              FormatOptions: {
                shape: "Sd"
              },
              Input: {
                shape: "So"
              },
              PathOptions: {
                shape: "Sz"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        UpdateProfileJob: {
          http: {
            method: "PUT",
            requestUri: "/profileJobs/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "OutputLocation",
              "RoleArn"
            ],
            members: {
              Configuration: {
                shape: "S1t"
              },
              EncryptionKeyArn: {},
              EncryptionMode: {},
              Name: {
                location: "uri",
                locationName: "name"
              },
              LogSubscription: {},
              MaxCapacity: {
                type: "integer"
              },
              MaxRetries: {
                type: "integer"
              },
              OutputLocation: {
                shape: "Sp"
              },
              RoleArn: {},
              Timeout: {
                type: "integer"
              },
              JobSample: {
                shape: "S29"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        UpdateProject: {
          http: {
            method: "PUT",
            requestUri: "/projects/{name}"
          },
          input: {
            type: "structure",
            required: [
              "RoleArn",
              "Name"
            ],
            members: {
              Sample: {
                shape: "S2f"
              },
              RoleArn: {},
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              LastModifiedDate: {
                type: "timestamp"
              },
              Name: {}
            }
          }
        },
        UpdateRecipe: {
          http: {
            method: "PUT",
            requestUri: "/recipes/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Description: {},
              Name: {
                location: "uri",
                locationName: "name"
              },
              Steps: {
                shape: "S2l"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        UpdateRecipeJob: {
          http: {
            method: "PUT",
            requestUri: "/recipeJobs/{name}"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "RoleArn"
            ],
            members: {
              EncryptionKeyArn: {},
              EncryptionMode: {},
              Name: {
                location: "uri",
                locationName: "name"
              },
              LogSubscription: {},
              MaxCapacity: {
                type: "integer"
              },
              MaxRetries: {
                type: "integer"
              },
              Outputs: {
                shape: "S2v"
              },
              DataCatalogOutputs: {
                shape: "S33"
              },
              DatabaseOutputs: {
                shape: "S37"
              },
              RoleArn: {},
              Timeout: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        },
        UpdateSchedule: {
          http: {
            method: "PUT",
            requestUri: "/schedules/{name}"
          },
          input: {
            type: "structure",
            required: [
              "CronExpression",
              "Name"
            ],
            members: {
              JobNames: {
                shape: "S3d"
              },
              CronExpression: {},
              Name: {
                location: "uri",
                locationName: "name"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {}
            }
          }
        }
      },
      shapes: {
        Sd: {
          type: "structure",
          members: {
            Json: {
              type: "structure",
              members: {
                MultiLine: {
                  type: "boolean"
                }
              }
            },
            Excel: {
              type: "structure",
              members: {
                SheetNames: {
                  type: "list",
                  member: {}
                },
                SheetIndexes: {
                  type: "list",
                  member: {
                    type: "integer"
                  }
                },
                HeaderRow: {
                  type: "boolean"
                }
              }
            },
            Csv: {
              type: "structure",
              members: {
                Delimiter: {},
                HeaderRow: {
                  type: "boolean"
                }
              }
            }
          }
        },
        So: {
          type: "structure",
          members: {
            S3InputDefinition: {
              shape: "Sp"
            },
            DataCatalogInputDefinition: {
              type: "structure",
              required: [
                "DatabaseName",
                "TableName"
              ],
              members: {
                CatalogId: {},
                DatabaseName: {},
                TableName: {},
                TempDirectory: {
                  shape: "Sp"
                }
              }
            },
            DatabaseInputDefinition: {
              type: "structure",
              required: [
                "GlueConnectionName",
                "DatabaseTableName"
              ],
              members: {
                GlueConnectionName: {},
                DatabaseTableName: {},
                TempDirectory: {
                  shape: "Sp"
                }
              }
            }
          }
        },
        Sp: {
          type: "structure",
          required: [
            "Bucket"
          ],
          members: {
            Bucket: {},
            Key: {}
          }
        },
        Sz: {
          type: "structure",
          members: {
            LastModifiedDateCondition: {
              shape: "S10"
            },
            FilesLimit: {
              type: "structure",
              required: [
                "MaxFiles"
              ],
              members: {
                MaxFiles: {
                  type: "integer"
                },
                OrderedBy: {},
                Order: {}
              }
            },
            Parameters: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                required: [
                  "Name",
                  "Type"
                ],
                members: {
                  Name: {},
                  Type: {},
                  DatetimeOptions: {
                    type: "structure",
                    required: [
                      "Format"
                    ],
                    members: {
                      Format: {},
                      TimezoneOffset: {},
                      LocaleCode: {}
                    }
                  },
                  CreateColumn: {
                    type: "boolean"
                  },
                  Filter: {
                    shape: "S10"
                  }
                }
              }
            }
          }
        },
        S10: {
          type: "structure",
          required: [
            "Expression",
            "ValuesMap"
          ],
          members: {
            Expression: {},
            ValuesMap: {
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        S1i: {
          type: "map",
          key: {},
          value: {}
        },
        S1t: {
          type: "structure",
          members: {
            DatasetStatisticsConfiguration: {
              shape: "S1u"
            },
            ProfileColumns: {
              shape: "S22"
            },
            ColumnStatisticsConfigurations: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Statistics"
                ],
                members: {
                  Selectors: {
                    shape: "S22"
                  },
                  Statistics: {
                    shape: "S1u"
                  }
                }
              }
            }
          }
        },
        S1u: {
          type: "structure",
          members: {
            IncludedStatistics: {
              type: "list",
              member: {}
            },
            Overrides: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Statistic",
                  "Parameters"
                ],
                members: {
                  Statistic: {},
                  Parameters: {
                    shape: "S1z"
                  }
                }
              }
            }
          }
        },
        S1z: {
          type: "map",
          key: {},
          value: {}
        },
        S22: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Regex: {},
              Name: {}
            }
          }
        },
        S29: {
          type: "structure",
          members: {
            Mode: {},
            Size: {
              type: "long"
            }
          }
        },
        S2f: {
          type: "structure",
          required: [
            "Type"
          ],
          members: {
            Size: {
              type: "integer"
            },
            Type: {}
          }
        },
        S2l: {
          type: "list",
          member: {
            shape: "S2m"
          }
        },
        S2m: {
          type: "structure",
          required: [
            "Action"
          ],
          members: {
            Action: {
              type: "structure",
              required: [
                "Operation"
              ],
              members: {
                Operation: {},
                Parameters: {
                  shape: "S1z"
                }
              }
            },
            ConditionExpressions: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "Condition",
                  "TargetColumn"
                ],
                members: {
                  Condition: {},
                  Value: {},
                  TargetColumn: {}
                }
              }
            }
          }
        },
        S2v: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Location"
            ],
            members: {
              CompressionFormat: {},
              Format: {},
              PartitionColumns: {
                type: "list",
                member: {}
              },
              Location: {
                shape: "Sp"
              },
              Overwrite: {
                type: "boolean"
              },
              FormatOptions: {
                type: "structure",
                members: {
                  Csv: {
                    type: "structure",
                    members: {
                      Delimiter: {}
                    }
                  }
                }
              }
            }
          }
        },
        S33: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DatabaseName",
              "TableName"
            ],
            members: {
              CatalogId: {},
              DatabaseName: {},
              TableName: {},
              S3Options: {
                type: "structure",
                required: [
                  "Location"
                ],
                members: {
                  Location: {
                    shape: "Sp"
                  }
                }
              },
              DatabaseOptions: {
                shape: "S36"
              },
              Overwrite: {
                type: "boolean"
              }
            }
          }
        },
        S36: {
          type: "structure",
          required: [
            "TableName"
          ],
          members: {
            TempDirectory: {
              shape: "Sp"
            },
            TableName: {}
          }
        },
        S37: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "GlueConnectionName",
              "DatabaseOptions"
            ],
            members: {
              GlueConnectionName: {},
              DatabaseOptions: {
                shape: "S36"
              },
              DatabaseOutputMode: {}
            }
          }
        },
        S3a: {
          type: "structure",
          required: [
            "Name"
          ],
          members: {
            Name: {},
            RecipeVersion: {}
          }
        },
        S3d: {
          type: "list",
          member: {}
        },
        S53: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              CreatedBy: {},
              CreateDate: {
                type: "timestamp"
              },
              LastModifiedBy: {},
              LastModifiedDate: {
                type: "timestamp"
              },
              ProjectName: {},
              PublishedBy: {},
              PublishedDate: {
                type: "timestamp"
              },
              Description: {},
              Name: {},
              ResourceArn: {},
              Steps: {
                shape: "S2l"
              },
              Tags: {
                shape: "S1i"
              },
              RecipeVersion: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/databrew-2017-07-25.paginators.json
var require_databrew_2017_07_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/databrew-2017-07-25.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListDatasets: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Datasets"
        },
        ListJobRuns: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "JobRuns"
        },
        ListJobs: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Jobs"
        },
        ListProjects: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Projects"
        },
        ListRecipeVersions: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Recipes"
        },
        ListRecipes: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Recipes"
        },
        ListSchedules: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Schedules"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/databrew.js
var require_databrew = __commonJS({
  "node_modules/aws-sdk/clients/databrew.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["databrew"] = {};
    AWS3.DataBrew = Service.defineService("databrew", ["2017-07-25"]);
    Object.defineProperty(apiLoader.services["databrew"], "2017-07-25", {
      get: function get() {
        var model = require_databrew_2017_07_25_min();
        model.paginators = require_databrew_2017_07_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.DataBrew;
  }
});

// node_modules/aws-sdk/apis/servicecatalog-appregistry-2020-06-24.min.json
var require_servicecatalog_appregistry_2020_06_24_min = __commonJS({
  "node_modules/aws-sdk/apis/servicecatalog-appregistry-2020-06-24.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-06-24",
        endpointPrefix: "servicecatalog-appregistry",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "AppRegistry",
        serviceFullName: "AWS Service Catalog App Registry",
        serviceId: "Service Catalog AppRegistry",
        signatureVersion: "v4",
        signingName: "servicecatalog",
        uid: "AWS242AppRegistry-2020-06-24"
      },
      operations: {
        AssociateAttributeGroup: {
          http: {
            method: "PUT",
            requestUri: "/applications/{application}/attribute-groups/{attributeGroup}"
          },
          input: {
            type: "structure",
            required: [
              "application",
              "attributeGroup"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              },
              attributeGroup: {
                location: "uri",
                locationName: "attributeGroup"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationArn: {},
              attributeGroupArn: {}
            }
          }
        },
        AssociateResource: {
          http: {
            method: "PUT",
            requestUri: "/applications/{application}/resources/{resourceType}/{resource}"
          },
          input: {
            type: "structure",
            required: [
              "application",
              "resourceType",
              "resource"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              },
              resourceType: {
                location: "uri",
                locationName: "resourceType"
              },
              resource: {
                location: "uri",
                locationName: "resource"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationArn: {},
              resourceArn: {}
            }
          }
        },
        CreateApplication: {
          http: {
            requestUri: "/applications",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name",
              "clientToken"
            ],
            members: {
              name: {},
              description: {},
              tags: {
                shape: "Sf"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              application: {
                shape: "Sk"
              }
            }
          }
        },
        CreateAttributeGroup: {
          http: {
            requestUri: "/attribute-groups",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "name",
              "attributes",
              "clientToken"
            ],
            members: {
              name: {},
              description: {},
              attributes: {},
              tags: {
                shape: "Sf"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              attributeGroup: {
                shape: "Sq"
              }
            }
          }
        },
        DeleteApplication: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{application}"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              application: {
                shape: "Su"
              }
            }
          }
        },
        DeleteAttributeGroup: {
          http: {
            method: "DELETE",
            requestUri: "/attribute-groups/{attributeGroup}"
          },
          input: {
            type: "structure",
            required: [
              "attributeGroup"
            ],
            members: {
              attributeGroup: {
                location: "uri",
                locationName: "attributeGroup"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              attributeGroup: {
                shape: "Sx"
              }
            }
          }
        },
        DisassociateAttributeGroup: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{application}/attribute-groups/{attributeGroup}"
          },
          input: {
            type: "structure",
            required: [
              "application",
              "attributeGroup"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              },
              attributeGroup: {
                location: "uri",
                locationName: "attributeGroup"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationArn: {},
              attributeGroupArn: {}
            }
          }
        },
        DisassociateResource: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{application}/resources/{resourceType}/{resource}"
          },
          input: {
            type: "structure",
            required: [
              "application",
              "resourceType",
              "resource"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              },
              resourceType: {
                location: "uri",
                locationName: "resourceType"
              },
              resource: {
                location: "uri",
                locationName: "resource"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationArn: {},
              resourceArn: {}
            }
          }
        },
        GetApplication: {
          http: {
            method: "GET",
            requestUri: "/applications/{application}"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              arn: {},
              name: {},
              description: {},
              creationTime: {
                shape: "Sm"
              },
              lastUpdateTime: {
                shape: "Sm"
              },
              associatedResourceCount: {
                type: "integer"
              },
              tags: {
                shape: "Sf"
              },
              integrations: {
                type: "structure",
                members: {
                  resourceGroup: {
                    shape: "S16"
                  }
                }
              }
            }
          }
        },
        GetAssociatedResource: {
          http: {
            method: "GET",
            requestUri: "/applications/{application}/resources/{resourceType}/{resource}"
          },
          input: {
            type: "structure",
            required: [
              "application",
              "resourceType",
              "resource"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              },
              resourceType: {
                location: "uri",
                locationName: "resourceType"
              },
              resource: {
                location: "uri",
                locationName: "resource"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resource: {
                type: "structure",
                members: {
                  name: {},
                  arn: {},
                  associationTime: {
                    shape: "Sm"
                  },
                  integrations: {
                    type: "structure",
                    members: {
                      resourceGroup: {
                        shape: "S16"
                      }
                    }
                  }
                }
              }
            }
          },
          idempotent: true
        },
        GetAttributeGroup: {
          http: {
            method: "GET",
            requestUri: "/attribute-groups/{attributeGroup}"
          },
          input: {
            type: "structure",
            required: [
              "attributeGroup"
            ],
            members: {
              attributeGroup: {
                location: "uri",
                locationName: "attributeGroup"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              arn: {},
              name: {},
              description: {},
              attributes: {},
              creationTime: {
                shape: "Sm"
              },
              lastUpdateTime: {
                shape: "Sm"
              },
              tags: {
                shape: "Sf"
              }
            }
          }
        },
        ListApplications: {
          http: {
            method: "GET",
            requestUri: "/applications"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applications: {
                type: "list",
                member: {
                  shape: "Su"
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListAssociatedAttributeGroups: {
          http: {
            method: "GET",
            requestUri: "/applications/{application}/attribute-groups"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              attributeGroups: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListAssociatedResources: {
          http: {
            method: "GET",
            requestUri: "/applications/{application}/resources"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListAttributeGroups: {
          http: {
            method: "GET",
            requestUri: "/attribute-groups"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              attributeGroups: {
                type: "list",
                member: {
                  shape: "Sx"
                }
              },
              nextToken: {}
            }
          },
          idempotent: true
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sf"
              }
            }
          }
        },
        SyncResource: {
          http: {
            requestUri: "/sync/{resourceType}/{resource}"
          },
          input: {
            type: "structure",
            required: [
              "resourceType",
              "resource"
            ],
            members: {
              resourceType: {
                location: "uri",
                locationName: "resourceType"
              },
              resource: {
                location: "uri",
                locationName: "resource"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationArn: {},
              resourceArn: {},
              actionTaken: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApplication: {
          http: {
            method: "PATCH",
            requestUri: "/applications/{application}"
          },
          input: {
            type: "structure",
            required: [
              "application"
            ],
            members: {
              application: {
                location: "uri",
                locationName: "application"
              },
              name: {},
              description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              application: {
                shape: "Sk"
              }
            }
          }
        },
        UpdateAttributeGroup: {
          http: {
            method: "PATCH",
            requestUri: "/attribute-groups/{attributeGroup}"
          },
          input: {
            type: "structure",
            required: [
              "attributeGroup"
            ],
            members: {
              attributeGroup: {
                location: "uri",
                locationName: "attributeGroup"
              },
              name: {},
              description: {},
              attributes: {}
            }
          },
          output: {
            type: "structure",
            members: {
              attributeGroup: {
                shape: "Sq"
              }
            }
          }
        }
      },
      shapes: {
        Sf: {
          type: "map",
          key: {},
          value: {}
        },
        Sk: {
          type: "structure",
          members: {
            id: {},
            arn: {},
            name: {},
            description: {},
            creationTime: {
              shape: "Sm"
            },
            lastUpdateTime: {
              shape: "Sm"
            },
            tags: {
              shape: "Sf"
            }
          }
        },
        Sm: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sq: {
          type: "structure",
          members: {
            id: {},
            arn: {},
            name: {},
            description: {},
            creationTime: {
              shape: "Sm"
            },
            lastUpdateTime: {
              shape: "Sm"
            },
            tags: {
              shape: "Sf"
            }
          }
        },
        Su: {
          type: "structure",
          members: {
            id: {},
            arn: {},
            name: {},
            description: {},
            creationTime: {
              shape: "Sm"
            },
            lastUpdateTime: {
              shape: "Sm"
            }
          }
        },
        Sx: {
          type: "structure",
          members: {
            id: {},
            arn: {},
            name: {},
            description: {},
            creationTime: {
              shape: "Sm"
            },
            lastUpdateTime: {
              shape: "Sm"
            }
          }
        },
        S16: {
          type: "structure",
          members: {
            state: {},
            arn: {},
            errorMessage: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/servicecatalog-appregistry-2020-06-24.paginators.json
var require_servicecatalog_appregistry_2020_06_24_paginators = __commonJS({
  "node_modules/aws-sdk/apis/servicecatalog-appregistry-2020-06-24.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListApplications: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "applications"
        },
        ListAssociatedAttributeGroups: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "attributeGroups"
        },
        ListAssociatedResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "resources"
        },
        ListAttributeGroups: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "attributeGroups"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/servicecatalogappregistry.js
var require_servicecatalogappregistry = __commonJS({
  "node_modules/aws-sdk/clients/servicecatalogappregistry.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["servicecatalogappregistry"] = {};
    AWS3.ServiceCatalogAppRegistry = Service.defineService("servicecatalogappregistry", ["2020-06-24"]);
    Object.defineProperty(apiLoader.services["servicecatalogappregistry"], "2020-06-24", {
      get: function get() {
        var model = require_servicecatalog_appregistry_2020_06_24_min();
        model.paginators = require_servicecatalog_appregistry_2020_06_24_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ServiceCatalogAppRegistry;
  }
});

// node_modules/aws-sdk/apis/network-firewall-2020-11-12.min.json
var require_network_firewall_2020_11_12_min = __commonJS({
  "node_modules/aws-sdk/apis/network-firewall-2020-11-12.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-11-12",
        endpointPrefix: "network-firewall",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "Network Firewall",
        serviceFullName: "AWS Network Firewall",
        serviceId: "Network Firewall",
        signatureVersion: "v4",
        signingName: "network-firewall",
        targetPrefix: "NetworkFirewall_20201112",
        uid: "network-firewall-2020-11-12"
      },
      operations: {
        AssociateFirewallPolicy: {
          input: {
            type: "structure",
            required: [
              "FirewallPolicyArn"
            ],
            members: {
              UpdateToken: {},
              FirewallArn: {},
              FirewallName: {},
              FirewallPolicyArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallArn: {},
              FirewallName: {},
              FirewallPolicyArn: {},
              UpdateToken: {}
            }
          }
        },
        AssociateSubnets: {
          input: {
            type: "structure",
            required: [
              "SubnetMappings"
            ],
            members: {
              UpdateToken: {},
              FirewallArn: {},
              FirewallName: {},
              SubnetMappings: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallArn: {},
              FirewallName: {},
              SubnetMappings: {
                shape: "S7"
              },
              UpdateToken: {}
            }
          }
        },
        CreateFirewall: {
          input: {
            type: "structure",
            required: [
              "FirewallName",
              "FirewallPolicyArn",
              "VpcId",
              "SubnetMappings"
            ],
            members: {
              FirewallName: {},
              FirewallPolicyArn: {},
              VpcId: {},
              SubnetMappings: {
                shape: "S7"
              },
              DeleteProtection: {
                type: "boolean"
              },
              SubnetChangeProtection: {
                type: "boolean"
              },
              FirewallPolicyChangeProtection: {
                type: "boolean"
              },
              Description: {},
              Tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Firewall: {
                shape: "Sk"
              },
              FirewallStatus: {
                shape: "Sm"
              }
            }
          }
        },
        CreateFirewallPolicy: {
          input: {
            type: "structure",
            required: [
              "FirewallPolicyName",
              "FirewallPolicy"
            ],
            members: {
              FirewallPolicyName: {},
              FirewallPolicy: {
                shape: "S10"
              },
              Description: {},
              Tags: {
                shape: "Sf"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UpdateToken",
              "FirewallPolicyResponse"
            ],
            members: {
              UpdateToken: {},
              FirewallPolicyResponse: {
                shape: "S1j"
              }
            }
          }
        },
        CreateRuleGroup: {
          input: {
            type: "structure",
            required: [
              "RuleGroupName",
              "Type",
              "Capacity"
            ],
            members: {
              RuleGroupName: {},
              RuleGroup: {
                shape: "S1o"
              },
              Rules: {},
              Type: {},
              Description: {},
              Capacity: {
                type: "integer"
              },
              Tags: {
                shape: "Sf"
              },
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UpdateToken",
              "RuleGroupResponse"
            ],
            members: {
              UpdateToken: {},
              RuleGroupResponse: {
                shape: "S32"
              }
            }
          }
        },
        DeleteFirewall: {
          input: {
            type: "structure",
            members: {
              FirewallName: {},
              FirewallArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Firewall: {
                shape: "Sk"
              },
              FirewallStatus: {
                shape: "Sm"
              }
            }
          }
        },
        DeleteFirewallPolicy: {
          input: {
            type: "structure",
            members: {
              FirewallPolicyName: {},
              FirewallPolicyArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "FirewallPolicyResponse"
            ],
            members: {
              FirewallPolicyResponse: {
                shape: "S1j"
              }
            }
          }
        },
        DeleteResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRuleGroup: {
          input: {
            type: "structure",
            members: {
              RuleGroupName: {},
              RuleGroupArn: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RuleGroupResponse"
            ],
            members: {
              RuleGroupResponse: {
                shape: "S32"
              }
            }
          }
        },
        DescribeFirewall: {
          input: {
            type: "structure",
            members: {
              FirewallName: {},
              FirewallArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              UpdateToken: {},
              Firewall: {
                shape: "Sk"
              },
              FirewallStatus: {
                shape: "Sm"
              }
            }
          }
        },
        DescribeFirewallPolicy: {
          input: {
            type: "structure",
            members: {
              FirewallPolicyName: {},
              FirewallPolicyArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "UpdateToken",
              "FirewallPolicyResponse"
            ],
            members: {
              UpdateToken: {},
              FirewallPolicyResponse: {
                shape: "S1j"
              },
              FirewallPolicy: {
                shape: "S10"
              }
            }
          }
        },
        DescribeLoggingConfiguration: {
          input: {
            type: "structure",
            members: {
              FirewallArn: {},
              FirewallName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallArn: {},
              LoggingConfiguration: {
                shape: "S3h"
              }
            }
          }
        },
        DescribeResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Policy: {}
            }
          }
        },
        DescribeRuleGroup: {
          input: {
            type: "structure",
            members: {
              RuleGroupName: {},
              RuleGroupArn: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "UpdateToken",
              "RuleGroupResponse"
            ],
            members: {
              UpdateToken: {},
              RuleGroup: {
                shape: "S1o"
              },
              RuleGroupResponse: {
                shape: "S32"
              }
            }
          }
        },
        DisassociateSubnets: {
          input: {
            type: "structure",
            required: [
              "SubnetIds"
            ],
            members: {
              UpdateToken: {},
              FirewallArn: {},
              FirewallName: {},
              SubnetIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallArn: {},
              FirewallName: {},
              SubnetMappings: {
                shape: "S7"
              },
              UpdateToken: {}
            }
          }
        },
        ListFirewallPolicies: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              FirewallPolicies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Arn: {}
                  }
                }
              }
            }
          }
        },
        ListFirewalls: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              VpcIds: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Firewalls: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    FirewallName: {},
                    FirewallArn: {}
                  }
                }
              }
            }
          }
        },
        ListRuleGroups: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              RuleGroups: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Arn: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Tags: {
                shape: "Sf"
              }
            }
          }
        },
        PutResourcePolicy: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Policy"
            ],
            members: {
              ResourceArn: {},
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateFirewallDeleteProtection: {
          input: {
            type: "structure",
            required: [
              "DeleteProtection"
            ],
            members: {
              UpdateToken: {},
              FirewallArn: {},
              FirewallName: {},
              DeleteProtection: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallArn: {},
              FirewallName: {},
              DeleteProtection: {
                type: "boolean"
              },
              UpdateToken: {}
            }
          }
        },
        UpdateFirewallDescription: {
          input: {
            type: "structure",
            members: {
              UpdateToken: {},
              FirewallArn: {},
              FirewallName: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallArn: {},
              FirewallName: {},
              Description: {},
              UpdateToken: {}
            }
          }
        },
        UpdateFirewallPolicy: {
          input: {
            type: "structure",
            required: [
              "UpdateToken",
              "FirewallPolicy"
            ],
            members: {
              UpdateToken: {},
              FirewallPolicyArn: {},
              FirewallPolicyName: {},
              FirewallPolicy: {
                shape: "S10"
              },
              Description: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UpdateToken",
              "FirewallPolicyResponse"
            ],
            members: {
              UpdateToken: {},
              FirewallPolicyResponse: {
                shape: "S1j"
              }
            }
          }
        },
        UpdateFirewallPolicyChangeProtection: {
          input: {
            type: "structure",
            required: [
              "FirewallPolicyChangeProtection"
            ],
            members: {
              UpdateToken: {},
              FirewallArn: {},
              FirewallName: {},
              FirewallPolicyChangeProtection: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpdateToken: {},
              FirewallArn: {},
              FirewallName: {},
              FirewallPolicyChangeProtection: {
                type: "boolean"
              }
            }
          }
        },
        UpdateLoggingConfiguration: {
          input: {
            type: "structure",
            members: {
              FirewallArn: {},
              FirewallName: {},
              LoggingConfiguration: {
                shape: "S3h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              FirewallArn: {},
              FirewallName: {},
              LoggingConfiguration: {
                shape: "S3h"
              }
            }
          }
        },
        UpdateRuleGroup: {
          input: {
            type: "structure",
            required: [
              "UpdateToken"
            ],
            members: {
              UpdateToken: {},
              RuleGroupArn: {},
              RuleGroupName: {},
              RuleGroup: {
                shape: "S1o"
              },
              Rules: {},
              Type: {},
              Description: {},
              DryRun: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "UpdateToken",
              "RuleGroupResponse"
            ],
            members: {
              UpdateToken: {},
              RuleGroupResponse: {
                shape: "S32"
              }
            }
          }
        },
        UpdateSubnetChangeProtection: {
          input: {
            type: "structure",
            required: [
              "SubnetChangeProtection"
            ],
            members: {
              UpdateToken: {},
              FirewallArn: {},
              FirewallName: {},
              SubnetChangeProtection: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpdateToken: {},
              FirewallArn: {},
              FirewallName: {},
              SubnetChangeProtection: {
                type: "boolean"
              }
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "SubnetId"
            ],
            members: {
              SubnetId: {}
            }
          }
        },
        Sf: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sk: {
          type: "structure",
          required: [
            "FirewallPolicyArn",
            "VpcId",
            "SubnetMappings",
            "FirewallId"
          ],
          members: {
            FirewallName: {},
            FirewallArn: {},
            FirewallPolicyArn: {},
            VpcId: {},
            SubnetMappings: {
              shape: "S7"
            },
            DeleteProtection: {
              type: "boolean"
            },
            SubnetChangeProtection: {
              type: "boolean"
            },
            FirewallPolicyChangeProtection: {
              type: "boolean"
            },
            Description: {},
            FirewallId: {},
            Tags: {
              shape: "Sf"
            }
          }
        },
        Sm: {
          type: "structure",
          required: [
            "Status",
            "ConfigurationSyncStateSummary"
          ],
          members: {
            Status: {},
            ConfigurationSyncStateSummary: {},
            SyncStates: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  Attachment: {
                    type: "structure",
                    members: {
                      SubnetId: {},
                      EndpointId: {},
                      Status: {}
                    }
                  },
                  Config: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        SyncStatus: {},
                        UpdateToken: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S10: {
          type: "structure",
          required: [
            "StatelessDefaultActions",
            "StatelessFragmentDefaultActions"
          ],
          members: {
            StatelessRuleGroupReferences: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ResourceArn",
                  "Priority"
                ],
                members: {
                  ResourceArn: {},
                  Priority: {
                    type: "integer"
                  }
                }
              }
            },
            StatelessDefaultActions: {
              shape: "S14"
            },
            StatelessFragmentDefaultActions: {
              shape: "S14"
            },
            StatelessCustomActions: {
              shape: "S15"
            },
            StatefulRuleGroupReferences: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "ResourceArn"
                ],
                members: {
                  ResourceArn: {},
                  Priority: {
                    type: "integer"
                  }
                }
              }
            },
            StatefulDefaultActions: {
              type: "list",
              member: {}
            },
            StatefulEngineOptions: {
              type: "structure",
              members: {
                RuleOrder: {}
              }
            }
          }
        },
        S14: {
          type: "list",
          member: {}
        },
        S15: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "ActionName",
              "ActionDefinition"
            ],
            members: {
              ActionName: {},
              ActionDefinition: {
                type: "structure",
                members: {
                  PublishMetricAction: {
                    type: "structure",
                    required: [
                      "Dimensions"
                    ],
                    members: {
                      Dimensions: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "Value"
                          ],
                          members: {
                            Value: {}
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S1j: {
          type: "structure",
          required: [
            "FirewallPolicyName",
            "FirewallPolicyArn",
            "FirewallPolicyId"
          ],
          members: {
            FirewallPolicyName: {},
            FirewallPolicyArn: {},
            FirewallPolicyId: {},
            Description: {},
            FirewallPolicyStatus: {},
            Tags: {
              shape: "Sf"
            },
            ConsumedStatelessRuleCapacity: {
              type: "integer"
            },
            ConsumedStatefulRuleCapacity: {
              type: "integer"
            },
            NumberOfAssociations: {
              type: "integer"
            }
          }
        },
        S1o: {
          type: "structure",
          required: [
            "RulesSource"
          ],
          members: {
            RuleVariables: {
              type: "structure",
              members: {
                IPSets: {
                  type: "map",
                  key: {},
                  value: {
                    type: "structure",
                    required: [
                      "Definition"
                    ],
                    members: {
                      Definition: {
                        shape: "S1t"
                      }
                    }
                  }
                },
                PortSets: {
                  type: "map",
                  key: {},
                  value: {
                    type: "structure",
                    members: {
                      Definition: {
                        shape: "S1t"
                      }
                    }
                  }
                }
              }
            },
            RulesSource: {
              type: "structure",
              members: {
                RulesString: {},
                RulesSourceList: {
                  type: "structure",
                  required: [
                    "Targets",
                    "TargetTypes",
                    "GeneratedRulesType"
                  ],
                  members: {
                    Targets: {
                      type: "list",
                      member: {}
                    },
                    TargetTypes: {
                      type: "list",
                      member: {}
                    },
                    GeneratedRulesType: {}
                  }
                },
                StatefulRules: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "Action",
                      "Header",
                      "RuleOptions"
                    ],
                    members: {
                      Action: {},
                      Header: {
                        type: "structure",
                        required: [
                          "Protocol",
                          "Source",
                          "SourcePort",
                          "Direction",
                          "Destination",
                          "DestinationPort"
                        ],
                        members: {
                          Protocol: {},
                          Source: {},
                          SourcePort: {},
                          Direction: {},
                          Destination: {},
                          DestinationPort: {}
                        }
                      },
                      RuleOptions: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "Keyword"
                          ],
                          members: {
                            Keyword: {},
                            Settings: {
                              type: "list",
                              member: {}
                            }
                          }
                        }
                      }
                    }
                  }
                },
                StatelessRulesAndCustomActions: {
                  type: "structure",
                  required: [
                    "StatelessRules"
                  ],
                  members: {
                    StatelessRules: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "RuleDefinition",
                          "Priority"
                        ],
                        members: {
                          RuleDefinition: {
                            type: "structure",
                            required: [
                              "MatchAttributes",
                              "Actions"
                            ],
                            members: {
                              MatchAttributes: {
                                type: "structure",
                                members: {
                                  Sources: {
                                    shape: "S2n"
                                  },
                                  Destinations: {
                                    shape: "S2n"
                                  },
                                  SourcePorts: {
                                    shape: "S2q"
                                  },
                                  DestinationPorts: {
                                    shape: "S2q"
                                  },
                                  Protocols: {
                                    type: "list",
                                    member: {
                                      type: "integer"
                                    }
                                  },
                                  TCPFlags: {
                                    type: "list",
                                    member: {
                                      type: "structure",
                                      required: [
                                        "Flags"
                                      ],
                                      members: {
                                        Flags: {
                                          shape: "S2x"
                                        },
                                        Masks: {
                                          shape: "S2x"
                                        }
                                      }
                                    }
                                  }
                                }
                              },
                              Actions: {
                                shape: "S14"
                              }
                            }
                          },
                          Priority: {
                            type: "integer"
                          }
                        }
                      }
                    },
                    CustomActions: {
                      shape: "S15"
                    }
                  }
                }
              }
            },
            StatefulRuleOptions: {
              type: "structure",
              members: {
                RuleOrder: {}
              }
            }
          }
        },
        S1t: {
          type: "list",
          member: {}
        },
        S2n: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "AddressDefinition"
            ],
            members: {
              AddressDefinition: {}
            }
          }
        },
        S2q: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "FromPort",
              "ToPort"
            ],
            members: {
              FromPort: {
                type: "integer"
              },
              ToPort: {
                type: "integer"
              }
            }
          }
        },
        S2x: {
          type: "list",
          member: {}
        },
        S32: {
          type: "structure",
          required: [
            "RuleGroupArn",
            "RuleGroupName",
            "RuleGroupId"
          ],
          members: {
            RuleGroupArn: {},
            RuleGroupName: {},
            RuleGroupId: {},
            Description: {},
            Type: {},
            Capacity: {
              type: "integer"
            },
            RuleGroupStatus: {},
            Tags: {
              shape: "Sf"
            },
            ConsumedCapacity: {
              type: "integer"
            },
            NumberOfAssociations: {
              type: "integer"
            }
          }
        },
        S3h: {
          type: "structure",
          required: [
            "LogDestinationConfigs"
          ],
          members: {
            LogDestinationConfigs: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "LogType",
                  "LogDestinationType",
                  "LogDestination"
                ],
                members: {
                  LogType: {},
                  LogDestinationType: {},
                  LogDestination: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/network-firewall-2020-11-12.paginators.json
var require_network_firewall_2020_11_12_paginators = __commonJS({
  "node_modules/aws-sdk/apis/network-firewall-2020-11-12.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListFirewallPolicies: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "FirewallPolicies"
        },
        ListFirewalls: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Firewalls"
        },
        ListRuleGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RuleGroups"
        },
        ListTagsForResource: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Tags"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/networkfirewall.js
var require_networkfirewall = __commonJS({
  "node_modules/aws-sdk/clients/networkfirewall.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["networkfirewall"] = {};
    AWS3.NetworkFirewall = Service.defineService("networkfirewall", ["2020-11-12"]);
    Object.defineProperty(apiLoader.services["networkfirewall"], "2020-11-12", {
      get: function get() {
        var model = require_network_firewall_2020_11_12_min();
        model.paginators = require_network_firewall_2020_11_12_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.NetworkFirewall;
  }
});

// node_modules/aws-sdk/apis/mwaa-2020-07-01.min.json
var require_mwaa_2020_07_01_min = __commonJS({
  "node_modules/aws-sdk/apis/mwaa-2020-07-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-07-01",
        endpointPrefix: "airflow",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AmazonMWAA",
        serviceId: "MWAA",
        signatureVersion: "v4",
        signingName: "airflow",
        uid: "mwaa-2020-07-01"
      },
      operations: {
        CreateCliToken: {
          http: {
            requestUri: "/clitoken/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CliToken: {
                type: "string",
                sensitive: true
              },
              WebServerHostname: {}
            }
          },
          endpoint: {
            hostPrefix: "env."
          }
        },
        CreateEnvironment: {
          http: {
            method: "PUT",
            requestUri: "/environments/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DagS3Path",
              "ExecutionRoleArn",
              "Name",
              "NetworkConfiguration",
              "SourceBucketArn"
            ],
            members: {
              AirflowConfigurationOptions: {
                type: "map",
                key: {},
                value: {},
                sensitive: true
              },
              AirflowVersion: {},
              DagS3Path: {},
              EnvironmentClass: {},
              ExecutionRoleArn: {},
              KmsKey: {},
              LoggingConfiguration: {
                shape: "Sf"
              },
              MaxWorkers: {
                type: "integer"
              },
              MinWorkers: {
                type: "integer"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              },
              NetworkConfiguration: {
                shape: "Sl"
              },
              PluginsS3ObjectVersion: {},
              PluginsS3Path: {},
              RequirementsS3ObjectVersion: {},
              RequirementsS3Path: {},
              Schedulers: {
                type: "integer"
              },
              SourceBucketArn: {},
              Tags: {
                shape: "St"
              },
              WebserverAccessMode: {},
              WeeklyMaintenanceWindowStart: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          },
          idempotent: true
        },
        CreateWebLoginToken: {
          http: {
            requestUri: "/webtoken/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WebServerHostname: {},
              WebToken: {
                type: "string",
                sensitive: true
              }
            }
          },
          endpoint: {
            hostPrefix: "env."
          },
          idempotent: true
        },
        DeleteEnvironment: {
          http: {
            method: "DELETE",
            requestUri: "/environments/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          },
          idempotent: true
        },
        GetEnvironment: {
          http: {
            method: "GET",
            requestUri: "/environments/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Environment: {
                type: "structure",
                members: {
                  AirflowConfigurationOptions: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  AirflowVersion: {},
                  Arn: {},
                  CreatedAt: {
                    type: "timestamp"
                  },
                  DagS3Path: {},
                  EnvironmentClass: {},
                  ExecutionRoleArn: {},
                  KmsKey: {},
                  LastUpdate: {
                    type: "structure",
                    members: {
                      CreatedAt: {
                        type: "timestamp"
                      },
                      Error: {
                        type: "structure",
                        members: {
                          ErrorCode: {},
                          ErrorMessage: {}
                        }
                      },
                      Status: {}
                    }
                  },
                  LoggingConfiguration: {
                    type: "structure",
                    members: {
                      DagProcessingLogs: {
                        shape: "S1h"
                      },
                      SchedulerLogs: {
                        shape: "S1h"
                      },
                      TaskLogs: {
                        shape: "S1h"
                      },
                      WebserverLogs: {
                        shape: "S1h"
                      },
                      WorkerLogs: {
                        shape: "S1h"
                      }
                    }
                  },
                  MaxWorkers: {
                    type: "integer"
                  },
                  MinWorkers: {
                    type: "integer"
                  },
                  Name: {},
                  NetworkConfiguration: {
                    shape: "Sl"
                  },
                  PluginsS3ObjectVersion: {},
                  PluginsS3Path: {},
                  RequirementsS3ObjectVersion: {},
                  RequirementsS3Path: {},
                  Schedulers: {
                    type: "integer"
                  },
                  ServiceRoleArn: {},
                  SourceBucketArn: {},
                  Status: {},
                  Tags: {
                    shape: "St"
                  },
                  WebserverAccessMode: {},
                  WebserverUrl: {},
                  WeeklyMaintenanceWindowStart: {}
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListEnvironments: {
          http: {
            method: "GET",
            requestUri: "/environments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Environments"
            ],
            members: {
              Environments: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "St"
              }
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        PublishMetrics: {
          http: {
            requestUri: "/metrics/environments/{EnvironmentName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "EnvironmentName",
              "MetricData"
            ],
            members: {
              EnvironmentName: {
                location: "uri",
                locationName: "EnvironmentName"
              },
              MetricData: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "MetricName",
                    "Timestamp"
                  ],
                  members: {
                    Dimensions: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Name",
                          "Value"
                        ],
                        members: {
                          Name: {},
                          Value: {}
                        }
                      }
                    },
                    MetricName: {},
                    StatisticValues: {
                      type: "structure",
                      members: {
                        Maximum: {
                          type: "double"
                        },
                        Minimum: {
                          type: "double"
                        },
                        SampleCount: {
                          type: "integer"
                        },
                        Sum: {
                          type: "double"
                        }
                      }
                    },
                    Timestamp: {
                      type: "timestamp"
                    },
                    Unit: {},
                    Value: {
                      type: "double"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "ops."
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "tagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "api."
          },
          idempotent: true
        },
        UpdateEnvironment: {
          http: {
            method: "PATCH",
            requestUri: "/environments/{Name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              AirflowConfigurationOptions: {
                type: "map",
                key: {},
                value: {},
                sensitive: true
              },
              AirflowVersion: {},
              DagS3Path: {},
              EnvironmentClass: {},
              ExecutionRoleArn: {},
              LoggingConfiguration: {
                shape: "Sf"
              },
              MaxWorkers: {
                type: "integer"
              },
              MinWorkers: {
                type: "integer"
              },
              Name: {
                location: "uri",
                locationName: "Name"
              },
              NetworkConfiguration: {
                type: "structure",
                required: [
                  "SecurityGroupIds"
                ],
                members: {
                  SecurityGroupIds: {
                    shape: "Sm"
                  }
                }
              },
              PluginsS3ObjectVersion: {},
              PluginsS3Path: {},
              RequirementsS3ObjectVersion: {},
              RequirementsS3Path: {},
              Schedulers: {
                type: "integer"
              },
              SourceBucketArn: {},
              WebserverAccessMode: {},
              WeeklyMaintenanceWindowStart: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {}
            }
          },
          endpoint: {
            hostPrefix: "api."
          }
        }
      },
      shapes: {
        Sf: {
          type: "structure",
          members: {
            DagProcessingLogs: {
              shape: "Sg"
            },
            SchedulerLogs: {
              shape: "Sg"
            },
            TaskLogs: {
              shape: "Sg"
            },
            WebserverLogs: {
              shape: "Sg"
            },
            WorkerLogs: {
              shape: "Sg"
            }
          }
        },
        Sg: {
          type: "structure",
          required: [
            "Enabled",
            "LogLevel"
          ],
          members: {
            Enabled: {
              type: "boolean"
            },
            LogLevel: {}
          }
        },
        Sl: {
          type: "structure",
          members: {
            SecurityGroupIds: {
              shape: "Sm"
            },
            SubnetIds: {
              type: "list",
              member: {}
            }
          }
        },
        Sm: {
          type: "list",
          member: {}
        },
        St: {
          type: "map",
          key: {},
          value: {}
        },
        S1h: {
          type: "structure",
          members: {
            CloudWatchLogGroupArn: {},
            Enabled: {
              type: "boolean"
            },
            LogLevel: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mwaa-2020-07-01.paginators.json
var require_mwaa_2020_07_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mwaa-2020-07-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListEnvironments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Environments"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mwaa.js
var require_mwaa = __commonJS({
  "node_modules/aws-sdk/clients/mwaa.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["mwaa"] = {};
    AWS3.MWAA = Service.defineService("mwaa", ["2020-07-01"]);
    Object.defineProperty(apiLoader.services["mwaa"], "2020-07-01", {
      get: function get() {
        var model = require_mwaa_2020_07_01_min();
        model.paginators = require_mwaa_2020_07_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.MWAA;
  }
});

// node_modules/aws-sdk/apis/amplifybackend-2020-08-11.min.json
var require_amplifybackend_2020_08_11_min = __commonJS({
  "node_modules/aws-sdk/apis/amplifybackend-2020-08-11.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2020-08-11",
        endpointPrefix: "amplifybackend",
        signingName: "amplifybackend",
        serviceFullName: "AmplifyBackend",
        serviceId: "AmplifyBackend",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "amplifybackend-2020-08-11",
        signatureVersion: "v4"
      },
      operations: {
        CloneBackend: {
          http: {
            requestUri: "/backend/{appId}/environments/{backendEnvironmentName}/clone",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              TargetEnvironmentName: {
                locationName: "targetEnvironmentName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "TargetEnvironmentName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        CreateBackend: {
          http: {
            requestUri: "/backend",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              AppName: {
                locationName: "appName"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              ResourceConfig: {
                locationName: "resourceConfig",
                type: "structure",
                members: {}
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "AppName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        CreateBackendAPI: {
          http: {
            requestUri: "/backend/{appId}/api",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              ResourceConfig: {
                shape: "S8",
                locationName: "resourceConfig"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "ResourceName",
              "BackendEnvironmentName",
              "ResourceConfig"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        CreateBackendAuth: {
          http: {
            requestUri: "/backend/{appId}/auth",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              ResourceConfig: {
                shape: "Si",
                locationName: "resourceConfig"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "ResourceName",
              "BackendEnvironmentName",
              "ResourceConfig"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        CreateBackendConfig: {
          http: {
            requestUri: "/backend/{appId}/config",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendManagerAppId: {
                locationName: "backendManagerAppId"
              }
            },
            required: [
              "AppId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              JobId: {
                locationName: "jobId"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        CreateToken: {
          http: {
            requestUri: "/backend/{appId}/challenge",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              }
            },
            required: [
              "AppId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              ChallengeCode: {
                locationName: "challengeCode"
              },
              SessionId: {
                locationName: "sessionId"
              },
              Ttl: {
                locationName: "ttl"
              }
            }
          }
        },
        DeleteBackend: {
          http: {
            requestUri: "/backend/{appId}/environments/{backendEnvironmentName}/remove",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        DeleteBackendAPI: {
          http: {
            requestUri: "/backend/{appId}/api/{backendEnvironmentName}/remove",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              ResourceConfig: {
                shape: "S8",
                locationName: "resourceConfig"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "ResourceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        DeleteBackendAuth: {
          http: {
            requestUri: "/backend/{appId}/auth/{backendEnvironmentName}/remove",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "ResourceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        DeleteToken: {
          http: {
            requestUri: "/backend/{appId}/challenge/{sessionId}/remove",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              SessionId: {
                location: "uri",
                locationName: "sessionId"
              }
            },
            required: [
              "SessionId",
              "AppId"
            ]
          },
          output: {
            type: "structure",
            members: {
              IsSuccess: {
                locationName: "isSuccess",
                type: "boolean"
              }
            }
          }
        },
        GenerateBackendAPIModels: {
          http: {
            requestUri: "/backend/{appId}/api/{backendEnvironmentName}/generateModels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "ResourceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        GetBackend: {
          http: {
            requestUri: "/backend/{appId}/details",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              }
            },
            required: [
              "AppId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AmplifyFeatureFlags: {
                locationName: "amplifyFeatureFlags"
              },
              AmplifyMetaConfig: {
                locationName: "amplifyMetaConfig"
              },
              AppId: {
                locationName: "appId"
              },
              AppName: {
                locationName: "appName"
              },
              BackendEnvironmentList: {
                shape: "S11",
                locationName: "backendEnvironmentList"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              }
            }
          }
        },
        GetBackendAPI: {
          http: {
            requestUri: "/backend/{appId}/api/{backendEnvironmentName}/details",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              ResourceConfig: {
                shape: "S8",
                locationName: "resourceConfig"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "ResourceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              ResourceConfig: {
                shape: "S8",
                locationName: "resourceConfig"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            }
          }
        },
        GetBackendAPIModels: {
          http: {
            requestUri: "/backend/{appId}/api/{backendEnvironmentName}/getModels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "ResourceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Models: {
                locationName: "models"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        GetBackendAuth: {
          http: {
            requestUri: "/backend/{appId}/auth/{backendEnvironmentName}/details",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "ResourceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              ResourceConfig: {
                shape: "Si",
                locationName: "resourceConfig"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            }
          }
        },
        GetBackendJob: {
          http: {
            method: "GET",
            requestUri: "/backend/{appId}/job/{backendEnvironmentName}/{jobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              JobId: {
                location: "uri",
                locationName: "jobId"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "JobId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              CreateTime: {
                locationName: "createTime"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              },
              UpdateTime: {
                locationName: "updateTime"
              }
            }
          }
        },
        GetToken: {
          http: {
            method: "GET",
            requestUri: "/backend/{appId}/challenge/{sessionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              SessionId: {
                location: "uri",
                locationName: "sessionId"
              }
            },
            required: [
              "SessionId",
              "AppId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              ChallengeCode: {
                locationName: "challengeCode"
              },
              SessionId: {
                locationName: "sessionId"
              },
              Ttl: {
                locationName: "ttl"
              }
            }
          }
        },
        ImportBackendAuth: {
          http: {
            requestUri: "/backend/{appId}/auth/{backendEnvironmentName}/import",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              IdentityPoolId: {
                locationName: "identityPoolId"
              },
              NativeClientId: {
                locationName: "nativeClientId"
              },
              UserPoolId: {
                locationName: "userPoolId"
              },
              WebClientId: {
                locationName: "webClientId"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "UserPoolId",
              "NativeClientId",
              "WebClientId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        ListBackendJobs: {
          http: {
            requestUri: "/backend/{appId}/job/{backendEnvironmentName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              JobId: {
                locationName: "jobId"
              },
              MaxResults: {
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                locationName: "nextToken"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Jobs: {
                locationName: "jobs",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AppId: {
                      locationName: "appId"
                    },
                    BackendEnvironmentName: {
                      locationName: "backendEnvironmentName"
                    },
                    CreateTime: {
                      locationName: "createTime"
                    },
                    Error: {
                      locationName: "error"
                    },
                    JobId: {
                      locationName: "jobId"
                    },
                    Operation: {
                      locationName: "operation"
                    },
                    Status: {
                      locationName: "status"
                    },
                    UpdateTime: {
                      locationName: "updateTime"
                    }
                  },
                  required: [
                    "AppId",
                    "BackendEnvironmentName"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        RemoveAllBackends: {
          http: {
            requestUri: "/backend/{appId}/remove",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              CleanAmplifyApp: {
                locationName: "cleanAmplifyApp",
                type: "boolean"
              }
            },
            required: [
              "AppId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        RemoveBackendConfig: {
          http: {
            requestUri: "/backend/{appId}/config/remove",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              }
            },
            required: [
              "AppId"
            ]
          },
          output: {
            type: "structure",
            members: {
              Error: {
                locationName: "error"
              }
            }
          }
        },
        UpdateBackendAPI: {
          http: {
            requestUri: "/backend/{appId}/api/{backendEnvironmentName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              ResourceConfig: {
                shape: "S8",
                locationName: "resourceConfig"
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "ResourceName"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        UpdateBackendAuth: {
          http: {
            requestUri: "/backend/{appId}/auth/{backendEnvironmentName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              ResourceConfig: {
                locationName: "resourceConfig",
                type: "structure",
                members: {
                  AuthResources: {
                    locationName: "authResources"
                  },
                  IdentityPoolConfigs: {
                    locationName: "identityPoolConfigs",
                    type: "structure",
                    members: {
                      UnauthenticatedLogin: {
                        locationName: "unauthenticatedLogin",
                        type: "boolean"
                      }
                    }
                  },
                  Service: {
                    locationName: "service"
                  },
                  UserPoolConfigs: {
                    locationName: "userPoolConfigs",
                    type: "structure",
                    members: {
                      ForgotPassword: {
                        locationName: "forgotPassword",
                        type: "structure",
                        members: {
                          DeliveryMethod: {
                            locationName: "deliveryMethod"
                          },
                          EmailSettings: {
                            shape: "Sq",
                            locationName: "emailSettings"
                          },
                          SmsSettings: {
                            shape: "Sr",
                            locationName: "smsSettings"
                          }
                        }
                      },
                      Mfa: {
                        locationName: "mfa",
                        type: "structure",
                        members: {
                          MFAMode: {},
                          Settings: {
                            shape: "Su",
                            locationName: "settings"
                          }
                        }
                      },
                      OAuth: {
                        locationName: "oAuth",
                        type: "structure",
                        members: {
                          DomainPrefix: {
                            locationName: "domainPrefix"
                          },
                          OAuthGrantType: {
                            locationName: "oAuthGrantType"
                          },
                          OAuthScopes: {
                            shape: "Sz",
                            locationName: "oAuthScopes"
                          },
                          RedirectSignInURIs: {
                            shape: "S11",
                            locationName: "redirectSignInURIs"
                          },
                          RedirectSignOutURIs: {
                            shape: "S11",
                            locationName: "redirectSignOutURIs"
                          },
                          SocialProviderSettings: {
                            shape: "S12",
                            locationName: "socialProviderSettings"
                          }
                        }
                      },
                      PasswordPolicy: {
                        locationName: "passwordPolicy",
                        type: "structure",
                        members: {
                          AdditionalConstraints: {
                            shape: "S16",
                            locationName: "additionalConstraints"
                          },
                          MinimumLength: {
                            locationName: "minimumLength",
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                },
                required: [
                  "AuthResources",
                  "UserPoolConfigs",
                  "Service"
                ]
              },
              ResourceName: {
                locationName: "resourceName"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "ResourceName",
              "ResourceConfig"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            }
          }
        },
        UpdateBackendConfig: {
          http: {
            requestUri: "/backend/{appId}/config/update",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              LoginAuthConfig: {
                shape: "S2q",
                locationName: "loginAuthConfig"
              }
            },
            required: [
              "AppId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendManagerAppId: {
                locationName: "backendManagerAppId"
              },
              Error: {
                locationName: "error"
              },
              LoginAuthConfig: {
                shape: "S2q",
                locationName: "loginAuthConfig"
              }
            }
          }
        },
        UpdateBackendJob: {
          http: {
            requestUri: "/backend/{appId}/job/{backendEnvironmentName}/{jobId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AppId: {
                location: "uri",
                locationName: "appId"
              },
              BackendEnvironmentName: {
                location: "uri",
                locationName: "backendEnvironmentName"
              },
              JobId: {
                location: "uri",
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              }
            },
            required: [
              "AppId",
              "BackendEnvironmentName",
              "JobId"
            ]
          },
          output: {
            type: "structure",
            members: {
              AppId: {
                locationName: "appId"
              },
              BackendEnvironmentName: {
                locationName: "backendEnvironmentName"
              },
              CreateTime: {
                locationName: "createTime"
              },
              Error: {
                locationName: "error"
              },
              JobId: {
                locationName: "jobId"
              },
              Operation: {
                locationName: "operation"
              },
              Status: {
                locationName: "status"
              },
              UpdateTime: {
                locationName: "updateTime"
              }
            }
          }
        }
      },
      shapes: {
        S8: {
          type: "structure",
          members: {
            AdditionalAuthTypes: {
              locationName: "additionalAuthTypes",
              type: "list",
              member: {
                shape: "Sa"
              }
            },
            ApiName: {
              locationName: "apiName"
            },
            ConflictResolution: {
              locationName: "conflictResolution",
              type: "structure",
              members: {
                ResolutionStrategy: {
                  locationName: "resolutionStrategy"
                }
              }
            },
            DefaultAuthType: {
              shape: "Sa",
              locationName: "defaultAuthType"
            },
            Service: {
              locationName: "service"
            },
            TransformSchema: {
              locationName: "transformSchema"
            }
          }
        },
        Sa: {
          type: "structure",
          members: {
            Mode: {
              locationName: "mode"
            },
            Settings: {
              locationName: "settings",
              type: "structure",
              members: {
                CognitoUserPoolId: {
                  locationName: "cognitoUserPoolId"
                },
                Description: {
                  locationName: "description"
                },
                ExpirationTime: {
                  locationName: "expirationTime",
                  type: "double"
                },
                OpenIDAuthTTL: {
                  locationName: "openIDAuthTTL"
                },
                OpenIDClientId: {
                  locationName: "openIDClientId"
                },
                OpenIDIatTTL: {
                  locationName: "openIDIatTTL"
                },
                OpenIDIssueURL: {
                  locationName: "openIDIssueURL"
                },
                OpenIDProviderName: {
                  locationName: "openIDProviderName"
                }
              }
            }
          }
        },
        Si: {
          type: "structure",
          members: {
            AuthResources: {
              locationName: "authResources"
            },
            IdentityPoolConfigs: {
              locationName: "identityPoolConfigs",
              type: "structure",
              members: {
                IdentityPoolName: {
                  locationName: "identityPoolName"
                },
                UnauthenticatedLogin: {
                  locationName: "unauthenticatedLogin",
                  type: "boolean"
                }
              },
              required: [
                "UnauthenticatedLogin",
                "IdentityPoolName"
              ]
            },
            Service: {
              locationName: "service"
            },
            UserPoolConfigs: {
              locationName: "userPoolConfigs",
              type: "structure",
              members: {
                ForgotPassword: {
                  locationName: "forgotPassword",
                  type: "structure",
                  members: {
                    DeliveryMethod: {
                      locationName: "deliveryMethod"
                    },
                    EmailSettings: {
                      shape: "Sq",
                      locationName: "emailSettings"
                    },
                    SmsSettings: {
                      shape: "Sr",
                      locationName: "smsSettings"
                    }
                  },
                  required: [
                    "DeliveryMethod"
                  ]
                },
                Mfa: {
                  locationName: "mfa",
                  type: "structure",
                  members: {
                    MFAMode: {},
                    Settings: {
                      shape: "Su",
                      locationName: "settings"
                    }
                  },
                  required: [
                    "MFAMode"
                  ]
                },
                OAuth: {
                  locationName: "oAuth",
                  type: "structure",
                  members: {
                    DomainPrefix: {
                      locationName: "domainPrefix"
                    },
                    OAuthGrantType: {
                      locationName: "oAuthGrantType"
                    },
                    OAuthScopes: {
                      shape: "Sz",
                      locationName: "oAuthScopes"
                    },
                    RedirectSignInURIs: {
                      shape: "S11",
                      locationName: "redirectSignInURIs"
                    },
                    RedirectSignOutURIs: {
                      shape: "S11",
                      locationName: "redirectSignOutURIs"
                    },
                    SocialProviderSettings: {
                      shape: "S12",
                      locationName: "socialProviderSettings"
                    }
                  },
                  required: [
                    "RedirectSignOutURIs",
                    "RedirectSignInURIs",
                    "OAuthGrantType",
                    "OAuthScopes"
                  ]
                },
                PasswordPolicy: {
                  locationName: "passwordPolicy",
                  type: "structure",
                  members: {
                    AdditionalConstraints: {
                      shape: "S16",
                      locationName: "additionalConstraints"
                    },
                    MinimumLength: {
                      locationName: "minimumLength",
                      type: "double"
                    }
                  },
                  required: [
                    "MinimumLength"
                  ]
                },
                RequiredSignUpAttributes: {
                  locationName: "requiredSignUpAttributes",
                  type: "list",
                  member: {}
                },
                SignInMethod: {
                  locationName: "signInMethod"
                },
                UserPoolName: {
                  locationName: "userPoolName"
                }
              },
              required: [
                "RequiredSignUpAttributes",
                "SignInMethod",
                "UserPoolName"
              ]
            }
          },
          required: [
            "AuthResources",
            "UserPoolConfigs",
            "Service"
          ]
        },
        Sq: {
          type: "structure",
          members: {
            EmailMessage: {
              locationName: "emailMessage"
            },
            EmailSubject: {
              locationName: "emailSubject"
            }
          }
        },
        Sr: {
          type: "structure",
          members: {
            SmsMessage: {
              locationName: "smsMessage"
            }
          }
        },
        Su: {
          type: "structure",
          members: {
            MfaTypes: {
              locationName: "mfaTypes",
              type: "list",
              member: {}
            },
            SmsMessage: {
              locationName: "smsMessage"
            }
          }
        },
        Sz: {
          type: "list",
          member: {}
        },
        S11: {
          type: "list",
          member: {}
        },
        S12: {
          type: "structure",
          members: {
            Facebook: {
              shape: "S13"
            },
            Google: {
              shape: "S13"
            },
            LoginWithAmazon: {
              shape: "S13"
            },
            SignInWithApple: {
              type: "structure",
              members: {
                ClientId: {
                  locationName: "client_id"
                },
                KeyId: {
                  locationName: "key_id"
                },
                PrivateKey: {
                  locationName: "private_key"
                },
                TeamId: {
                  locationName: "team_id"
                }
              }
            }
          }
        },
        S13: {
          type: "structure",
          members: {
            ClientId: {
              locationName: "client_id"
            },
            ClientSecret: {
              locationName: "client_secret"
            }
          }
        },
        S16: {
          type: "list",
          member: {}
        },
        S2q: {
          type: "structure",
          members: {
            AwsCognitoIdentityPoolId: {
              locationName: "aws_cognito_identity_pool_id"
            },
            AwsCognitoRegion: {
              locationName: "aws_cognito_region"
            },
            AwsUserPoolsId: {
              locationName: "aws_user_pools_id"
            },
            AwsUserPoolsWebClientId: {
              locationName: "aws_user_pools_web_client_id"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/amplifybackend-2020-08-11.paginators.json
var require_amplifybackend_2020_08_11_paginators = __commonJS({
  "node_modules/aws-sdk/apis/amplifybackend-2020-08-11.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListBackendJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Jobs"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/amplifybackend.js
var require_amplifybackend = __commonJS({
  "node_modules/aws-sdk/clients/amplifybackend.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["amplifybackend"] = {};
    AWS3.AmplifyBackend = Service.defineService("amplifybackend", ["2020-08-11"]);
    Object.defineProperty(apiLoader.services["amplifybackend"], "2020-08-11", {
      get: function get() {
        var model = require_amplifybackend_2020_08_11_min();
        model.paginators = require_amplifybackend_2020_08_11_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.AmplifyBackend;
  }
});

// node_modules/aws-sdk/apis/appintegrations-2020-07-29.min.json
var require_appintegrations_2020_07_29_min = __commonJS({
  "node_modules/aws-sdk/apis/appintegrations-2020-07-29.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-07-29",
        endpointPrefix: "app-integrations",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon AppIntegrations Service",
        serviceId: "AppIntegrations",
        signatureVersion: "v4",
        signingName: "app-integrations",
        uid: "appintegrations-2020-07-29"
      },
      operations: {
        CreateDataIntegration: {
          http: {
            requestUri: "/dataIntegrations"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {},
              Description: {},
              KmsKey: {},
              SourceURI: {},
              ScheduleConfig: {
                shape: "S5"
              },
              Tags: {
                shape: "S8"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {},
              Name: {},
              Description: {},
              KmsKey: {},
              SourceURI: {},
              ScheduleConfiguration: {
                shape: "S5"
              },
              Tags: {
                shape: "S8"
              },
              ClientToken: {}
            }
          }
        },
        CreateEventIntegration: {
          http: {
            requestUri: "/eventIntegrations"
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "EventFilter",
              "EventBridgeBus"
            ],
            members: {
              Name: {},
              Description: {},
              EventFilter: {
                shape: "Sg"
              },
              EventBridgeBus: {},
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventIntegrationArn: {}
            }
          }
        },
        DeleteDataIntegration: {
          http: {
            method: "DELETE",
            requestUri: "/dataIntegrations/{Identifier}"
          },
          input: {
            type: "structure",
            required: [
              "DataIntegrationIdentifier"
            ],
            members: {
              DataIntegrationIdentifier: {
                location: "uri",
                locationName: "Identifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteEventIntegration: {
          http: {
            method: "DELETE",
            requestUri: "/eventIntegrations/{Name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetDataIntegration: {
          http: {
            method: "GET",
            requestUri: "/dataIntegrations/{Identifier}"
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "Identifier"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {},
              Name: {},
              Description: {},
              KmsKey: {},
              SourceURI: {},
              ScheduleConfiguration: {
                shape: "S5"
              },
              Tags: {
                shape: "S8"
              }
            }
          }
        },
        GetEventIntegration: {
          http: {
            method: "GET",
            requestUri: "/eventIntegrations/{Name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Description: {},
              EventIntegrationArn: {},
              EventBridgeBus: {},
              EventFilter: {
                shape: "Sg"
              },
              Tags: {
                shape: "S8"
              }
            }
          }
        },
        ListDataIntegrationAssociations: {
          http: {
            method: "GET",
            requestUri: "/dataIntegrations/{Identifier}/associations"
          },
          input: {
            type: "structure",
            required: [
              "DataIntegrationIdentifier"
            ],
            members: {
              DataIntegrationIdentifier: {
                location: "uri",
                locationName: "Identifier"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataIntegrationAssociations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DataIntegrationAssociationArn: {},
                    DataIntegrationArn: {},
                    ClientId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListDataIntegrations: {
          http: {
            method: "GET",
            requestUri: "/dataIntegrations"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DataIntegrations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {},
                    SourceURI: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEventIntegrationAssociations: {
          http: {
            method: "GET",
            requestUri: "/eventIntegrations/{Name}/associations"
          },
          input: {
            type: "structure",
            required: [
              "EventIntegrationName"
            ],
            members: {
              EventIntegrationName: {
                location: "uri",
                locationName: "Name"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventIntegrationAssociations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventIntegrationAssociationArn: {},
                    EventIntegrationAssociationId: {},
                    EventIntegrationName: {},
                    ClientId: {},
                    EventBridgeRuleName: {},
                    ClientAssociationMetadata: {
                      type: "map",
                      key: {},
                      value: {}
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEventIntegrations: {
          http: {
            method: "GET",
            requestUri: "/eventIntegrations"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              EventIntegrations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EventIntegrationArn: {},
                    Name: {},
                    Description: {},
                    EventFilter: {
                      shape: "Sg"
                    },
                    EventBridgeBus: {},
                    Tags: {
                      shape: "S8"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S8"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S8"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDataIntegration: {
          http: {
            method: "PATCH",
            requestUri: "/dataIntegrations/{Identifier}"
          },
          input: {
            type: "structure",
            required: [
              "Identifier"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "Identifier"
              },
              Name: {},
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEventIntegration: {
          http: {
            method: "PATCH",
            requestUri: "/eventIntegrations/{Name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              Description: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            FirstExecutionFrom: {},
            Object: {},
            ScheduleExpression: {}
          }
        },
        S8: {
          type: "map",
          key: {},
          value: {}
        },
        Sg: {
          type: "structure",
          required: [
            "Source"
          ],
          members: {
            Source: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/appintegrations-2020-07-29.paginators.json
var require_appintegrations_2020_07_29_paginators = __commonJS({
  "node_modules/aws-sdk/apis/appintegrations-2020-07-29.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/appintegrations.js
var require_appintegrations = __commonJS({
  "node_modules/aws-sdk/clients/appintegrations.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["appintegrations"] = {};
    AWS3.AppIntegrations = Service.defineService("appintegrations", ["2020-07-29"]);
    Object.defineProperty(apiLoader.services["appintegrations"], "2020-07-29", {
      get: function get() {
        var model = require_appintegrations_2020_07_29_min();
        model.paginators = require_appintegrations_2020_07_29_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.AppIntegrations;
  }
});

// node_modules/aws-sdk/apis/connect-contact-lens-2020-08-21.min.json
var require_connect_contact_lens_2020_08_21_min = __commonJS({
  "node_modules/aws-sdk/apis/connect-contact-lens-2020-08-21.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-08-21",
        endpointPrefix: "contact-lens",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Amazon Connect Contact Lens",
        serviceFullName: "Amazon Connect Contact Lens",
        serviceId: "Connect Contact Lens",
        signatureVersion: "v4",
        signingName: "connect",
        uid: "connect-contact-lens-2020-08-21"
      },
      operations: {
        ListRealtimeContactAnalysisSegments: {
          http: {
            requestUri: "/realtime-contact-analysis/analysis-segments"
          },
          input: {
            type: "structure",
            required: [
              "InstanceId",
              "ContactId"
            ],
            members: {
              InstanceId: {},
              ContactId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Segments"
            ],
            members: {
              Segments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Transcript: {
                      type: "structure",
                      required: [
                        "Id",
                        "ParticipantId",
                        "ParticipantRole",
                        "Content",
                        "BeginOffsetMillis",
                        "EndOffsetMillis",
                        "Sentiment"
                      ],
                      members: {
                        Id: {},
                        ParticipantId: {},
                        ParticipantRole: {},
                        Content: {},
                        BeginOffsetMillis: {
                          type: "integer"
                        },
                        EndOffsetMillis: {
                          type: "integer"
                        },
                        Sentiment: {},
                        IssuesDetected: {
                          type: "list",
                          member: {
                            type: "structure",
                            required: [
                              "CharacterOffsets"
                            ],
                            members: {
                              CharacterOffsets: {
                                type: "structure",
                                required: [
                                  "BeginOffsetChar",
                                  "EndOffsetChar"
                                ],
                                members: {
                                  BeginOffsetChar: {
                                    type: "integer"
                                  },
                                  EndOffsetChar: {
                                    type: "integer"
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    Categories: {
                      type: "structure",
                      required: [
                        "MatchedCategories",
                        "MatchedDetails"
                      ],
                      members: {
                        MatchedCategories: {
                          type: "list",
                          member: {}
                        },
                        MatchedDetails: {
                          type: "map",
                          key: {},
                          value: {
                            type: "structure",
                            required: [
                              "PointsOfInterest"
                            ],
                            members: {
                              PointsOfInterest: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  required: [
                                    "BeginOffsetMillis",
                                    "EndOffsetMillis"
                                  ],
                                  members: {
                                    BeginOffsetMillis: {
                                      type: "integer"
                                    },
                                    EndOffsetMillis: {
                                      type: "integer"
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/connect-contact-lens-2020-08-21.paginators.json
var require_connect_contact_lens_2020_08_21_paginators = __commonJS({
  "node_modules/aws-sdk/apis/connect-contact-lens-2020-08-21.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListRealtimeContactAnalysisSegments: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/connectcontactlens.js
var require_connectcontactlens = __commonJS({
  "node_modules/aws-sdk/clients/connectcontactlens.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["connectcontactlens"] = {};
    AWS3.ConnectContactLens = Service.defineService("connectcontactlens", ["2020-08-21"]);
    Object.defineProperty(apiLoader.services["connectcontactlens"], "2020-08-21", {
      get: function get() {
        var model = require_connect_contact_lens_2020_08_21_min();
        model.paginators = require_connect_contact_lens_2020_08_21_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ConnectContactLens;
  }
});

// node_modules/aws-sdk/apis/devops-guru-2020-12-01.min.json
var require_devops_guru_2020_12_01_min = __commonJS({
  "node_modules/aws-sdk/apis/devops-guru-2020-12-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-12-01",
        endpointPrefix: "devops-guru",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon DevOps Guru",
        serviceId: "DevOps Guru",
        signatureVersion: "v4",
        signingName: "devops-guru",
        uid: "devops-guru-2020-12-01"
      },
      operations: {
        AddNotificationChannel: {
          http: {
            method: "PUT",
            requestUri: "/channels",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Config"
            ],
            members: {
              Config: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {}
            }
          }
        },
        DescribeAccountHealth: {
          http: {
            method: "GET",
            requestUri: "/accounts/health",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "OpenReactiveInsights",
              "OpenProactiveInsights",
              "MetricsAnalyzed",
              "ResourceHours"
            ],
            members: {
              OpenReactiveInsights: {
                type: "integer"
              },
              OpenProactiveInsights: {
                type: "integer"
              },
              MetricsAnalyzed: {
                type: "integer"
              },
              ResourceHours: {
                type: "long"
              }
            }
          }
        },
        DescribeAccountOverview: {
          http: {
            requestUri: "/accounts/overview",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FromTime"
            ],
            members: {
              FromTime: {
                type: "timestamp"
              },
              ToTime: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ReactiveInsights",
              "ProactiveInsights",
              "MeanTimeToRecoverInMilliseconds"
            ],
            members: {
              ReactiveInsights: {
                type: "integer"
              },
              ProactiveInsights: {
                type: "integer"
              },
              MeanTimeToRecoverInMilliseconds: {
                type: "long"
              }
            }
          }
        },
        DescribeAnomaly: {
          http: {
            method: "GET",
            requestUri: "/anomalies/{Id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProactiveAnomaly: {
                type: "structure",
                members: {
                  Id: {},
                  Severity: {},
                  Status: {},
                  UpdateTime: {
                    type: "timestamp"
                  },
                  AnomalyTimeRange: {
                    shape: "Sp"
                  },
                  AnomalyReportedTimeRange: {
                    shape: "Sq"
                  },
                  PredictionTimeRange: {
                    shape: "Sr"
                  },
                  SourceDetails: {
                    shape: "Ss"
                  },
                  AssociatedInsightId: {},
                  ResourceCollection: {
                    shape: "S15"
                  },
                  Limit: {
                    type: "double"
                  }
                }
              },
              ReactiveAnomaly: {
                type: "structure",
                members: {
                  Id: {},
                  Severity: {},
                  Status: {},
                  AnomalyTimeRange: {
                    shape: "Sp"
                  },
                  AnomalyReportedTimeRange: {
                    shape: "Sq"
                  },
                  SourceDetails: {
                    shape: "Ss"
                  },
                  AssociatedInsightId: {},
                  ResourceCollection: {
                    shape: "S15"
                  }
                }
              }
            }
          }
        },
        DescribeFeedback: {
          http: {
            requestUri: "/feedback",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InsightId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              InsightFeedback: {
                shape: "S1d"
              }
            }
          }
        },
        DescribeInsight: {
          http: {
            method: "GET",
            requestUri: "/insights/{Id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProactiveInsight: {
                type: "structure",
                members: {
                  Id: {},
                  Name: {},
                  Severity: {},
                  Status: {},
                  InsightTimeRange: {
                    shape: "S1l"
                  },
                  PredictionTimeRange: {
                    shape: "Sr"
                  },
                  ResourceCollection: {
                    shape: "S15"
                  },
                  SsmOpsItemId: {}
                }
              },
              ReactiveInsight: {
                type: "structure",
                members: {
                  Id: {},
                  Name: {},
                  Severity: {},
                  Status: {},
                  InsightTimeRange: {
                    shape: "S1l"
                  },
                  ResourceCollection: {
                    shape: "S15"
                  },
                  SsmOpsItemId: {}
                }
              }
            }
          }
        },
        DescribeResourceCollectionHealth: {
          http: {
            method: "GET",
            requestUri: "/accounts/health/resource-collection/{ResourceCollectionType}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceCollectionType"
            ],
            members: {
              ResourceCollectionType: {
                location: "uri",
                locationName: "ResourceCollectionType"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CloudFormation"
            ],
            members: {
              CloudFormation: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StackName: {},
                    Insight: {
                      type: "structure",
                      members: {
                        OpenProactiveInsights: {
                          type: "integer"
                        },
                        OpenReactiveInsights: {
                          type: "integer"
                        },
                        MeanTimeToRecoverInMilliseconds: {
                          type: "long"
                        }
                      }
                    }
                  }
                }
              },
              Service: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ServiceName: {},
                    Insight: {
                      type: "structure",
                      members: {
                        OpenProactiveInsights: {
                          type: "integer"
                        },
                        OpenReactiveInsights: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeServiceIntegration: {
          http: {
            method: "GET",
            requestUri: "/service-integrations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              ServiceIntegration: {
                type: "structure",
                members: {
                  OpsCenter: {
                    type: "structure",
                    members: {
                      OptInStatus: {}
                    }
                  }
                }
              }
            }
          }
        },
        GetCostEstimation: {
          http: {
            method: "GET",
            requestUri: "/cost-estimation",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceCollection: {
                shape: "S26"
              },
              Status: {},
              Costs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    State: {},
                    Count: {
                      type: "integer"
                    },
                    UnitCost: {
                      type: "double"
                    },
                    Cost: {
                      type: "double"
                    }
                  }
                }
              },
              TimeRange: {
                type: "structure",
                members: {
                  StartTime: {
                    type: "timestamp"
                  },
                  EndTime: {
                    type: "timestamp"
                  }
                }
              },
              TotalCost: {
                type: "double"
              },
              NextToken: {}
            }
          }
        },
        GetResourceCollection: {
          http: {
            method: "GET",
            requestUri: "/resource-collections/{ResourceCollectionType}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceCollectionType"
            ],
            members: {
              ResourceCollectionType: {
                location: "uri",
                locationName: "ResourceCollectionType"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceCollection: {
                type: "structure",
                members: {
                  CloudFormation: {
                    type: "structure",
                    members: {
                      StackNames: {
                        shape: "S17"
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAnomaliesForInsight: {
          http: {
            requestUri: "/anomalies/insight/{InsightId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "InsightId"
            ],
            members: {
              InsightId: {
                location: "uri",
                locationName: "InsightId"
              },
              StartTimeRange: {
                shape: "S2m"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProactiveAnomalies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Severity: {},
                    Status: {},
                    UpdateTime: {
                      type: "timestamp"
                    },
                    AnomalyTimeRange: {
                      shape: "Sp"
                    },
                    AnomalyReportedTimeRange: {
                      shape: "Sq"
                    },
                    PredictionTimeRange: {
                      shape: "Sr"
                    },
                    SourceDetails: {
                      shape: "Ss"
                    },
                    AssociatedInsightId: {},
                    ResourceCollection: {
                      shape: "S15"
                    },
                    Limit: {
                      type: "double"
                    }
                  }
                }
              },
              ReactiveAnomalies: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Severity: {},
                    Status: {},
                    AnomalyTimeRange: {
                      shape: "Sp"
                    },
                    AnomalyReportedTimeRange: {
                      shape: "Sq"
                    },
                    SourceDetails: {
                      shape: "Ss"
                    },
                    AssociatedInsightId: {},
                    ResourceCollection: {
                      shape: "S15"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListEvents: {
          http: {
            requestUri: "/events",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Filters"
            ],
            members: {
              Filters: {
                type: "structure",
                members: {
                  InsightId: {},
                  EventTimeRange: {
                    type: "structure",
                    required: [
                      "FromTime",
                      "ToTime"
                    ],
                    members: {
                      FromTime: {
                        type: "timestamp"
                      },
                      ToTime: {
                        type: "timestamp"
                      }
                    }
                  },
                  EventClass: {},
                  EventSource: {},
                  DataSource: {},
                  ResourceCollection: {
                    shape: "S15"
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Events"
            ],
            members: {
              Events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceCollection: {
                      shape: "S15"
                    },
                    Id: {},
                    Time: {
                      type: "timestamp"
                    },
                    EventSource: {},
                    Name: {},
                    DataSource: {},
                    EventClass: {},
                    Resources: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Type: {},
                          Name: {},
                          Arn: {}
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListInsights: {
          http: {
            requestUri: "/insights",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "StatusFilter"
            ],
            members: {
              StatusFilter: {
                type: "structure",
                members: {
                  Ongoing: {
                    type: "structure",
                    required: [
                      "Type"
                    ],
                    members: {
                      Type: {}
                    }
                  },
                  Closed: {
                    type: "structure",
                    required: [
                      "Type",
                      "EndTimeRange"
                    ],
                    members: {
                      Type: {},
                      EndTimeRange: {
                        type: "structure",
                        members: {
                          FromTime: {
                            type: "timestamp"
                          },
                          ToTime: {
                            type: "timestamp"
                          }
                        }
                      }
                    }
                  },
                  Any: {
                    type: "structure",
                    required: [
                      "Type",
                      "StartTimeRange"
                    ],
                    members: {
                      Type: {},
                      StartTimeRange: {
                        shape: "S2m"
                      }
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProactiveInsights: {
                shape: "S3j"
              },
              ReactiveInsights: {
                shape: "S3n"
              },
              NextToken: {}
            }
          }
        },
        ListNotificationChannels: {
          http: {
            requestUri: "/channels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Channels: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Config: {
                      shape: "S2"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListRecommendations: {
          http: {
            requestUri: "/recommendations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "InsightId"
            ],
            members: {
              InsightId: {},
              NextToken: {},
              Locale: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Recommendations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Description: {},
                    Link: {},
                    Name: {},
                    Reason: {},
                    RelatedEvents: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Name: {},
                          Resources: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {},
                                Type: {}
                              }
                            }
                          }
                        }
                      }
                    },
                    RelatedAnomalies: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          Resources: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                Name: {},
                                Type: {}
                              }
                            }
                          },
                          SourceDetails: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                CloudWatchMetrics: {
                                  type: "list",
                                  member: {
                                    type: "structure",
                                    members: {
                                      MetricName: {},
                                      Namespace: {}
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        PutFeedback: {
          http: {
            method: "PUT",
            requestUri: "/feedback",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              InsightFeedback: {
                shape: "S1d"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        RemoveNotificationChannel: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{Id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SearchInsights: {
          http: {
            requestUri: "/insights/search",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "StartTimeRange",
              "Type"
            ],
            members: {
              StartTimeRange: {
                shape: "S2m"
              },
              Filters: {
                type: "structure",
                members: {
                  Severities: {
                    type: "list",
                    member: {}
                  },
                  Statuses: {
                    type: "list",
                    member: {}
                  },
                  ResourceCollection: {
                    shape: "S15"
                  },
                  ServiceCollection: {
                    shape: "S3l"
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProactiveInsights: {
                shape: "S3j"
              },
              ReactiveInsights: {
                shape: "S3n"
              },
              NextToken: {}
            }
          }
        },
        StartCostEstimation: {
          http: {
            method: "PUT",
            requestUri: "/cost-estimation",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceCollection"
            ],
            members: {
              ResourceCollection: {
                shape: "S26"
              },
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateResourceCollection: {
          http: {
            method: "PUT",
            requestUri: "/resource-collections",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Action",
              "ResourceCollection"
            ],
            members: {
              Action: {},
              ResourceCollection: {
                type: "structure",
                members: {
                  CloudFormation: {
                    type: "structure",
                    members: {
                      StackNames: {
                        type: "list",
                        member: {}
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateServiceIntegration: {
          http: {
            method: "PUT",
            requestUri: "/service-integrations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ServiceIntegration"
            ],
            members: {
              ServiceIntegration: {
                type: "structure",
                members: {
                  OpsCenter: {
                    type: "structure",
                    members: {
                      OptInStatus: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          required: [
            "Sns"
          ],
          members: {
            Sns: {
              type: "structure",
              members: {
                TopicArn: {}
              }
            }
          }
        },
        Sp: {
          type: "structure",
          required: [
            "StartTime"
          ],
          members: {
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            }
          }
        },
        Sq: {
          type: "structure",
          required: [
            "OpenTime"
          ],
          members: {
            OpenTime: {
              type: "timestamp"
            },
            CloseTime: {
              type: "timestamp"
            }
          }
        },
        Sr: {
          type: "structure",
          required: [
            "StartTime"
          ],
          members: {
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            }
          }
        },
        Ss: {
          type: "structure",
          members: {
            CloudWatchMetrics: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  MetricName: {},
                  Namespace: {},
                  Dimensions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        Value: {}
                      }
                    }
                  },
                  Stat: {},
                  Unit: {},
                  Period: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        S15: {
          type: "structure",
          members: {
            CloudFormation: {
              type: "structure",
              members: {
                StackNames: {
                  shape: "S17"
                }
              }
            }
          }
        },
        S17: {
          type: "list",
          member: {}
        },
        S1d: {
          type: "structure",
          members: {
            Id: {},
            Feedback: {}
          }
        },
        S1l: {
          type: "structure",
          required: [
            "StartTime"
          ],
          members: {
            StartTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            }
          }
        },
        S26: {
          type: "structure",
          members: {
            CloudFormation: {
              type: "structure",
              members: {
                StackNames: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        S2m: {
          type: "structure",
          members: {
            FromTime: {
              type: "timestamp"
            },
            ToTime: {
              type: "timestamp"
            }
          }
        },
        S3j: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {},
              Name: {},
              Severity: {},
              Status: {},
              InsightTimeRange: {
                shape: "S1l"
              },
              PredictionTimeRange: {
                shape: "Sr"
              },
              ResourceCollection: {
                shape: "S15"
              },
              ServiceCollection: {
                shape: "S3l"
              }
            }
          }
        },
        S3l: {
          type: "structure",
          members: {
            ServiceNames: {
              type: "list",
              member: {}
            }
          }
        },
        S3n: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Id: {},
              Name: {},
              Severity: {},
              Status: {},
              InsightTimeRange: {
                shape: "S1l"
              },
              ResourceCollection: {
                shape: "S15"
              },
              ServiceCollection: {
                shape: "S3l"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/devops-guru-2020-12-01.paginators.json
var require_devops_guru_2020_12_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/devops-guru-2020-12-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeResourceCollectionHealth: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: [
            "CloudFormation",
            "Service"
          ]
        },
        GetCostEstimation: {
          input_token: "NextToken",
          non_aggregate_keys: [
            "Status",
            "TotalCost",
            "TimeRange",
            "ResourceCollection"
          ],
          output_token: "NextToken",
          result_key: [
            "Costs"
          ]
        },
        GetResourceCollection: {
          input_token: "NextToken",
          non_aggregate_keys: [
            "ResourceCollection"
          ],
          output_token: "NextToken",
          result_key: [
            "ResourceCollection.CloudFormation.StackNames"
          ]
        },
        ListAnomaliesForInsight: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: [
            "ReactiveAnomalies",
            "ProactiveAnomalies"
          ]
        },
        ListEvents: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Events"
        },
        ListInsights: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: [
            "ProactiveInsights",
            "ReactiveInsights"
          ]
        },
        ListNotificationChannels: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Channels"
        },
        ListRecommendations: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Recommendations"
        },
        SearchInsights: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: [
            "ProactiveInsights",
            "ReactiveInsights"
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/devopsguru.js
var require_devopsguru = __commonJS({
  "node_modules/aws-sdk/clients/devopsguru.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["devopsguru"] = {};
    AWS3.DevOpsGuru = Service.defineService("devopsguru", ["2020-12-01"]);
    Object.defineProperty(apiLoader.services["devopsguru"], "2020-12-01", {
      get: function get() {
        var model = require_devops_guru_2020_12_01_min();
        model.paginators = require_devops_guru_2020_12_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.DevOpsGuru;
  }
});

// node_modules/aws-sdk/apis/ecr-public-2020-10-30.min.json
var require_ecr_public_2020_10_30_min = __commonJS({
  "node_modules/aws-sdk/apis/ecr-public-2020-10-30.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-10-30",
        endpointPrefix: "api.ecr-public",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Amazon ECR Public",
        serviceFullName: "Amazon Elastic Container Registry Public",
        serviceId: "ECR PUBLIC",
        signatureVersion: "v4",
        signingName: "ecr-public",
        targetPrefix: "SpencerFrontendService",
        uid: "ecr-public-2020-10-30"
      },
      operations: {
        BatchCheckLayerAvailability: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "layerDigests"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              layerDigests: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              layers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    layerDigest: {},
                    layerAvailability: {},
                    layerSize: {
                      type: "long"
                    },
                    mediaType: {}
                  }
                }
              },
              failures: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    layerDigest: {},
                    failureCode: {},
                    failureReason: {}
                  }
                }
              }
            }
          }
        },
        BatchDeleteImage: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "imageIds"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageIds: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              imageIds: {
                shape: "Sj"
              },
              failures: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    imageId: {
                      shape: "Sk"
                    },
                    failureCode: {},
                    failureReason: {}
                  }
                }
              }
            }
          }
        },
        CompleteLayerUpload: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "uploadId",
              "layerDigests"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              uploadId: {},
              layerDigests: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              uploadId: {},
              layerDigest: {}
            }
          }
        },
        CreateRepository: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              repositoryName: {},
              catalogData: {
                shape: "Sx"
              },
              tags: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S1b"
              },
              catalogData: {
                shape: "S1f"
              }
            }
          }
        },
        DeleteRepository: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repository: {
                shape: "S1b"
              }
            }
          }
        },
        DeleteRepositoryPolicy: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              policyText: {}
            }
          }
        },
        DescribeImageTags: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              imageTagDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    imageTag: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    imageDetail: {
                      type: "structure",
                      members: {
                        imageDigest: {},
                        imageSizeInBytes: {
                          type: "long"
                        },
                        imagePushedAt: {
                          type: "timestamp"
                        },
                        imageManifestMediaType: {},
                        artifactMediaType: {}
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeImages: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageIds: {
                shape: "Sj"
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              imageDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    registryId: {},
                    repositoryName: {},
                    imageDigest: {},
                    imageTags: {
                      type: "list",
                      member: {}
                    },
                    imageSizeInBytes: {
                      type: "long"
                    },
                    imagePushedAt: {
                      type: "timestamp"
                    },
                    imageManifestMediaType: {},
                    artifactMediaType: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeRegistries: {
          input: {
            type: "structure",
            members: {
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "registries"
            ],
            members: {
              registries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "registryId",
                    "registryArn",
                    "registryUri",
                    "verified",
                    "aliases"
                  ],
                  members: {
                    registryId: {},
                    registryArn: {},
                    registryUri: {},
                    verified: {
                      type: "boolean"
                    },
                    aliases: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "name",
                          "status",
                          "primaryRegistryAlias",
                          "defaultRegistryAlias"
                        ],
                        members: {
                          name: {},
                          status: {},
                          primaryRegistryAlias: {
                            type: "boolean"
                          },
                          defaultRegistryAlias: {
                            type: "boolean"
                          }
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeRepositories: {
          input: {
            type: "structure",
            members: {
              registryId: {},
              repositoryNames: {
                type: "list",
                member: {}
              },
              nextToken: {},
              maxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              repositories: {
                type: "list",
                member: {
                  shape: "S1b"
                }
              },
              nextToken: {}
            }
          }
        },
        GetAuthorizationToken: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              authorizationData: {
                type: "structure",
                members: {
                  authorizationToken: {},
                  expiresAt: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        GetRegistryCatalogData: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            required: [
              "registryCatalogData"
            ],
            members: {
              registryCatalogData: {
                shape: "S2o"
              }
            }
          }
        },
        GetRepositoryCatalogData: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              catalogData: {
                shape: "S1f"
              }
            }
          }
        },
        GetRepositoryPolicy: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              policyText: {}
            }
          }
        },
        InitiateLayerUpload: {
          input: {
            type: "structure",
            required: [
              "repositoryName"
            ],
            members: {
              registryId: {},
              repositoryName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              uploadId: {},
              partSize: {
                type: "long"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S16"
              }
            }
          }
        },
        PutImage: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "imageManifest"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              imageManifest: {},
              imageManifestMediaType: {},
              imageTag: {},
              imageDigest: {}
            }
          },
          output: {
            type: "structure",
            members: {
              image: {
                type: "structure",
                members: {
                  registryId: {},
                  repositoryName: {},
                  imageId: {
                    shape: "Sk"
                  },
                  imageManifest: {},
                  imageManifestMediaType: {}
                }
              }
            }
          }
        },
        PutRegistryCatalogData: {
          input: {
            type: "structure",
            members: {
              displayName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "registryCatalogData"
            ],
            members: {
              registryCatalogData: {
                shape: "S2o"
              }
            }
          }
        },
        PutRepositoryCatalogData: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "catalogData"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              catalogData: {
                shape: "Sx"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              catalogData: {
                shape: "S1f"
              }
            }
          }
        },
        SetRepositoryPolicy: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "policyText"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              policyText: {},
              force: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              policyText: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UploadLayerPart: {
          input: {
            type: "structure",
            required: [
              "repositoryName",
              "uploadId",
              "partFirstByte",
              "partLastByte",
              "layerPartBlob"
            ],
            members: {
              registryId: {},
              repositoryName: {},
              uploadId: {},
              partFirstByte: {
                type: "long"
              },
              partLastByte: {
                type: "long"
              },
              layerPartBlob: {
                type: "blob"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              registryId: {},
              repositoryName: {},
              uploadId: {},
              lastByteReceived: {
                type: "long"
              }
            }
          }
        }
      },
      shapes: {
        Sj: {
          type: "list",
          member: {
            shape: "Sk"
          }
        },
        Sk: {
          type: "structure",
          members: {
            imageDigest: {},
            imageTag: {}
          }
        },
        Sx: {
          type: "structure",
          members: {
            description: {},
            architectures: {
              shape: "Sz"
            },
            operatingSystems: {
              shape: "S11"
            },
            logoImageBlob: {
              type: "blob"
            },
            aboutText: {},
            usageText: {}
          }
        },
        Sz: {
          type: "list",
          member: {}
        },
        S11: {
          type: "list",
          member: {}
        },
        S16: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S1b: {
          type: "structure",
          members: {
            repositoryArn: {},
            registryId: {},
            repositoryName: {},
            repositoryUri: {},
            createdAt: {
              type: "timestamp"
            }
          }
        },
        S1f: {
          type: "structure",
          members: {
            description: {},
            architectures: {
              shape: "Sz"
            },
            operatingSystems: {
              shape: "S11"
            },
            logoUrl: {},
            aboutText: {},
            usageText: {},
            marketplaceCertified: {
              type: "boolean"
            }
          }
        },
        S2o: {
          type: "structure",
          members: {
            displayName: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ecr-public-2020-10-30.paginators.json
var require_ecr_public_2020_10_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ecr-public-2020-10-30.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeImageTags: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "imageTagDetails"
        },
        DescribeImages: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "imageDetails"
        },
        DescribeRegistries: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "registries"
        },
        DescribeRepositories: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "repositories"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ecrpublic.js
var require_ecrpublic = __commonJS({
  "node_modules/aws-sdk/clients/ecrpublic.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["ecrpublic"] = {};
    AWS3.ECRPUBLIC = Service.defineService("ecrpublic", ["2020-10-30"]);
    Object.defineProperty(apiLoader.services["ecrpublic"], "2020-10-30", {
      get: function get() {
        var model = require_ecr_public_2020_10_30_min();
        model.paginators = require_ecr_public_2020_10_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ECRPUBLIC;
  }
});

// node_modules/aws-sdk/apis/lookoutvision-2020-11-20.min.json
var require_lookoutvision_2020_11_20_min = __commonJS({
  "node_modules/aws-sdk/apis/lookoutvision-2020-11-20.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-11-20",
        endpointPrefix: "lookoutvision",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Lookout for Vision",
        serviceId: "LookoutVision",
        signatureVersion: "v4",
        signingName: "lookoutvision",
        uid: "lookoutvision-2020-11-20"
      },
      operations: {
        CreateDataset: {
          http: {
            requestUri: "/2020-11-20/projects/{projectName}/datasets",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "DatasetType"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              DatasetType: {},
              DatasetSource: {
                type: "structure",
                members: {
                  GroundTruthManifest: {
                    type: "structure",
                    members: {
                      S3Object: {
                        type: "structure",
                        required: [
                          "Bucket",
                          "Key"
                        ],
                        members: {
                          Bucket: {},
                          Key: {},
                          VersionId: {}
                        }
                      }
                    }
                  }
                }
              },
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetMetadata: {
                shape: "Sc"
              }
            }
          }
        },
        CreateModel: {
          http: {
            requestUri: "/2020-11-20/projects/{projectName}/models",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "OutputConfig"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              Description: {},
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              },
              OutputConfig: {
                shape: "Si"
              },
              KmsKeyId: {},
              Tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ModelMetadata: {
                shape: "Sr"
              }
            }
          }
        },
        CreateProject: {
          http: {
            requestUri: "/2020-11-20/projects"
          },
          input: {
            type: "structure",
            required: [
              "ProjectName"
            ],
            members: {
              ProjectName: {},
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProjectMetadata: {
                shape: "S10"
              }
            }
          }
        },
        DeleteDataset: {
          http: {
            method: "DELETE",
            requestUri: "/2020-11-20/projects/{projectName}/datasets/{datasetType}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "DatasetType"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              DatasetType: {
                location: "uri",
                locationName: "datasetType"
              },
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteModel: {
          http: {
            method: "DELETE",
            requestUri: "/2020-11-20/projects/{projectName}/models/{modelVersion}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "ModelVersion"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              ModelVersion: {
                location: "uri",
                locationName: "modelVersion"
              },
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ModelArn: {}
            }
          }
        },
        DeleteProject: {
          http: {
            method: "DELETE",
            requestUri: "/2020-11-20/projects/{projectName}"
          },
          input: {
            type: "structure",
            required: [
              "ProjectName"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProjectArn: {}
            }
          }
        },
        DescribeDataset: {
          http: {
            method: "GET",
            requestUri: "/2020-11-20/projects/{projectName}/datasets/{datasetType}"
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "DatasetType"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              DatasetType: {
                location: "uri",
                locationName: "datasetType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetDescription: {
                type: "structure",
                members: {
                  ProjectName: {},
                  DatasetType: {},
                  CreationTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  },
                  Status: {},
                  StatusMessage: {},
                  ImageStats: {
                    type: "structure",
                    members: {
                      Total: {
                        type: "integer"
                      },
                      Labeled: {
                        type: "integer"
                      },
                      Normal: {
                        type: "integer"
                      },
                      Anomaly: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeModel: {
          http: {
            method: "GET",
            requestUri: "/2020-11-20/projects/{projectName}/models/{modelVersion}"
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "ModelVersion"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              ModelVersion: {
                location: "uri",
                locationName: "modelVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ModelDescription: {
                type: "structure",
                members: {
                  ModelVersion: {},
                  ModelArn: {},
                  CreationTimestamp: {
                    type: "timestamp"
                  },
                  Description: {},
                  Status: {},
                  StatusMessage: {},
                  Performance: {
                    shape: "Sw"
                  },
                  OutputConfig: {
                    shape: "Si"
                  },
                  EvaluationManifest: {
                    shape: "S1g"
                  },
                  EvaluationResult: {
                    shape: "S1g"
                  },
                  EvaluationEndTimestamp: {
                    type: "timestamp"
                  },
                  KmsKeyId: {}
                }
              }
            }
          }
        },
        DescribeProject: {
          http: {
            method: "GET",
            requestUri: "/2020-11-20/projects/{projectName}"
          },
          input: {
            type: "structure",
            required: [
              "ProjectName"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProjectDescription: {
                type: "structure",
                members: {
                  ProjectArn: {},
                  ProjectName: {},
                  CreationTimestamp: {
                    type: "timestamp"
                  },
                  Datasets: {
                    type: "list",
                    member: {
                      shape: "Sc"
                    }
                  }
                }
              }
            }
          }
        },
        DetectAnomalies: {
          http: {
            requestUri: "/2020-11-20/projects/{projectName}/models/{modelVersion}/detect"
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "ModelVersion",
              "Body",
              "ContentType"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              ModelVersion: {
                location: "uri",
                locationName: "modelVersion"
              },
              Body: {
                type: "blob",
                requiresLength: true,
                streaming: true
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              }
            },
            payload: "Body"
          },
          output: {
            type: "structure",
            members: {
              DetectAnomalyResult: {
                type: "structure",
                members: {
                  Source: {
                    type: "structure",
                    members: {
                      Type: {}
                    }
                  },
                  IsAnomalous: {
                    type: "boolean"
                  },
                  Confidence: {
                    type: "float"
                  }
                }
              }
            }
          }
        },
        ListDatasetEntries: {
          http: {
            method: "GET",
            requestUri: "/2020-11-20/projects/{projectName}/datasets/{datasetType}/entries"
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "DatasetType"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              DatasetType: {
                location: "uri",
                locationName: "datasetType"
              },
              Labeled: {
                location: "querystring",
                locationName: "labeled",
                type: "boolean"
              },
              AnomalyClass: {
                location: "querystring",
                locationName: "anomalyClass"
              },
              BeforeCreationDate: {
                location: "querystring",
                locationName: "createdBefore",
                type: "timestamp"
              },
              AfterCreationDate: {
                location: "querystring",
                locationName: "createdAfter",
                type: "timestamp"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              SourceRefContains: {
                location: "querystring",
                locationName: "sourceRefContains"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetEntries: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          }
        },
        ListModels: {
          http: {
            method: "GET",
            requestUri: "/2020-11-20/projects/{projectName}/models"
          },
          input: {
            type: "structure",
            required: [
              "ProjectName"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Models: {
                type: "list",
                member: {
                  shape: "Sr"
                }
              },
              NextToken: {}
            }
          }
        },
        ListProjects: {
          http: {
            method: "GET",
            requestUri: "/2020-11-20/projects"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Projects: {
                type: "list",
                member: {
                  shape: "S10"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2020-11-20/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sm"
              }
            }
          }
        },
        StartModel: {
          http: {
            requestUri: "/2020-11-20/projects/{projectName}/models/{modelVersion}/start",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "ModelVersion",
              "MinInferenceUnits"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              ModelVersion: {
                location: "uri",
                locationName: "modelVersion"
              },
              MinInferenceUnits: {
                type: "integer"
              },
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        },
        StopModel: {
          http: {
            requestUri: "/2020-11-20/projects/{projectName}/models/{modelVersion}/stop",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "ModelVersion"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              ModelVersion: {
                location: "uri",
                locationName: "modelVersion"
              },
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/2020-11-20/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/2020-11-20/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDatasetEntries: {
          http: {
            method: "PATCH",
            requestUri: "/2020-11-20/projects/{projectName}/datasets/{datasetType}/entries",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "ProjectName",
              "DatasetType",
              "Changes"
            ],
            members: {
              ProjectName: {
                location: "uri",
                locationName: "projectName"
              },
              DatasetType: {
                location: "uri",
                locationName: "datasetType"
              },
              Changes: {
                type: "blob"
              },
              ClientToken: {
                idempotencyToken: true,
                location: "header",
                locationName: "X-Amzn-Client-Token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Status: {}
            }
          }
        }
      },
      shapes: {
        Sc: {
          type: "structure",
          members: {
            DatasetType: {},
            CreationTimestamp: {
              type: "timestamp"
            },
            Status: {},
            StatusMessage: {}
          }
        },
        Si: {
          type: "structure",
          required: [
            "S3Location"
          ],
          members: {
            S3Location: {
              type: "structure",
              required: [
                "Bucket"
              ],
              members: {
                Bucket: {},
                Prefix: {}
              }
            }
          }
        },
        Sm: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sr: {
          type: "structure",
          members: {
            CreationTimestamp: {
              type: "timestamp"
            },
            ModelVersion: {},
            ModelArn: {},
            Description: {},
            Status: {},
            StatusMessage: {},
            Performance: {
              shape: "Sw"
            }
          }
        },
        Sw: {
          type: "structure",
          members: {
            F1Score: {
              type: "float"
            },
            Recall: {
              type: "float"
            },
            Precision: {
              type: "float"
            }
          }
        },
        S10: {
          type: "structure",
          members: {
            ProjectArn: {},
            ProjectName: {},
            CreationTimestamp: {
              type: "timestamp"
            }
          }
        },
        S1g: {
          type: "structure",
          required: [
            "Bucket",
            "Key"
          ],
          members: {
            Bucket: {},
            Key: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/lookoutvision-2020-11-20.paginators.json
var require_lookoutvision_2020_11_20_paginators = __commonJS({
  "node_modules/aws-sdk/apis/lookoutvision-2020-11-20.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListDatasetEntries: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "DatasetEntries"
        },
        ListModels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Models"
        },
        ListProjects: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Projects"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/lookoutvision.js
var require_lookoutvision = __commonJS({
  "node_modules/aws-sdk/clients/lookoutvision.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["lookoutvision"] = {};
    AWS3.LookoutVision = Service.defineService("lookoutvision", ["2020-11-20"]);
    Object.defineProperty(apiLoader.services["lookoutvision"], "2020-11-20", {
      get: function get() {
        var model = require_lookoutvision_2020_11_20_min();
        model.paginators = require_lookoutvision_2020_11_20_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.LookoutVision;
  }
});

// node_modules/aws-sdk/apis/sagemaker-featurestore-runtime-2020-07-01.min.json
var require_sagemaker_featurestore_runtime_2020_07_01_min = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-featurestore-runtime-2020-07-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-07-01",
        endpointPrefix: "featurestore-runtime.sagemaker",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon SageMaker Feature Store Runtime",
        serviceId: "SageMaker FeatureStore Runtime",
        signatureVersion: "v4",
        signingName: "sagemaker",
        uid: "sagemaker-featurestore-runtime-2020-07-01"
      },
      operations: {
        BatchGetRecord: {
          http: {
            requestUri: "/BatchGetRecord"
          },
          input: {
            type: "structure",
            required: [
              "Identifiers"
            ],
            members: {
              Identifiers: {
                type: "list",
                member: {
                  shape: "S3"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Records",
              "Errors",
              "UnprocessedIdentifiers"
            ],
            members: {
              Records: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "FeatureGroupName",
                    "RecordIdentifierValueAsString",
                    "Record"
                  ],
                  members: {
                    FeatureGroupName: {},
                    RecordIdentifierValueAsString: {},
                    Record: {
                      shape: "Sc"
                    }
                  }
                }
              },
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "FeatureGroupName",
                    "RecordIdentifierValueAsString",
                    "ErrorCode",
                    "ErrorMessage"
                  ],
                  members: {
                    FeatureGroupName: {},
                    RecordIdentifierValueAsString: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              },
              UnprocessedIdentifiers: {
                type: "list",
                member: {
                  shape: "S3"
                }
              }
            }
          }
        },
        DeleteRecord: {
          http: {
            method: "DELETE",
            requestUri: "/FeatureGroup/{FeatureGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "FeatureGroupName",
              "RecordIdentifierValueAsString",
              "EventTime"
            ],
            members: {
              FeatureGroupName: {
                location: "uri",
                locationName: "FeatureGroupName"
              },
              RecordIdentifierValueAsString: {
                location: "querystring",
                locationName: "RecordIdentifierValueAsString"
              },
              EventTime: {
                location: "querystring",
                locationName: "EventTime"
              }
            }
          }
        },
        GetRecord: {
          http: {
            method: "GET",
            requestUri: "/FeatureGroup/{FeatureGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "FeatureGroupName",
              "RecordIdentifierValueAsString"
            ],
            members: {
              FeatureGroupName: {
                location: "uri",
                locationName: "FeatureGroupName"
              },
              RecordIdentifierValueAsString: {
                location: "querystring",
                locationName: "RecordIdentifierValueAsString"
              },
              FeatureNames: {
                shape: "S7",
                location: "querystring",
                locationName: "FeatureName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Record: {
                shape: "Sc"
              }
            }
          }
        },
        PutRecord: {
          http: {
            method: "PUT",
            requestUri: "/FeatureGroup/{FeatureGroupName}"
          },
          input: {
            type: "structure",
            required: [
              "FeatureGroupName",
              "Record"
            ],
            members: {
              FeatureGroupName: {
                location: "uri",
                locationName: "FeatureGroupName"
              },
              Record: {
                shape: "Sc"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          required: [
            "FeatureGroupName",
            "RecordIdentifiersValueAsString"
          ],
          members: {
            FeatureGroupName: {},
            RecordIdentifiersValueAsString: {
              type: "list",
              member: {}
            },
            FeatureNames: {
              shape: "S7"
            }
          }
        },
        S7: {
          type: "list",
          member: {}
        },
        Sc: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "FeatureName",
              "ValueAsString"
            ],
            members: {
              FeatureName: {},
              ValueAsString: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sagemaker-featurestore-runtime-2020-07-01.paginators.json
var require_sagemaker_featurestore_runtime_2020_07_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-featurestore-runtime-2020-07-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/sagemakerfeaturestoreruntime.js
var require_sagemakerfeaturestoreruntime = __commonJS({
  "node_modules/aws-sdk/clients/sagemakerfeaturestoreruntime.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["sagemakerfeaturestoreruntime"] = {};
    AWS3.SageMakerFeatureStoreRuntime = Service.defineService("sagemakerfeaturestoreruntime", ["2020-07-01"]);
    Object.defineProperty(apiLoader.services["sagemakerfeaturestoreruntime"], "2020-07-01", {
      get: function get() {
        var model = require_sagemaker_featurestore_runtime_2020_07_01_min();
        model.paginators = require_sagemaker_featurestore_runtime_2020_07_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SageMakerFeatureStoreRuntime;
  }
});

// node_modules/aws-sdk/apis/customer-profiles-2020-08-15.min.json
var require_customer_profiles_2020_08_15_min = __commonJS({
  "node_modules/aws-sdk/apis/customer-profiles-2020-08-15.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-08-15",
        endpointPrefix: "profile",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Customer Profiles",
        serviceFullName: "Amazon Connect Customer Profiles",
        serviceId: "Customer Profiles",
        signatureVersion: "v4",
        signingName: "profile",
        uid: "customer-profiles-2020-08-15"
      },
      operations: {
        AddProfileKey: {
          http: {
            requestUri: "/domains/{DomainName}/profiles/keys"
          },
          input: {
            type: "structure",
            required: [
              "ProfileId",
              "KeyName",
              "Values",
              "DomainName"
            ],
            members: {
              ProfileId: {},
              KeyName: {},
              Values: {
                shape: "S4"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              KeyName: {},
              Values: {
                shape: "S4"
              }
            }
          }
        },
        CreateDomain: {
          http: {
            requestUri: "/domains/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "DefaultExpirationDays"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              DefaultExpirationDays: {
                type: "integer"
              },
              DefaultEncryptionKey: {},
              DeadLetterQueueUrl: {},
              Matching: {
                shape: "Sb"
              },
              Tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainName",
              "DefaultExpirationDays",
              "CreatedAt",
              "LastUpdatedAt"
            ],
            members: {
              DomainName: {},
              DefaultExpirationDays: {
                type: "integer"
              },
              DefaultEncryptionKey: {},
              DeadLetterQueueUrl: {},
              Matching: {
                shape: "Sh"
              },
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sd"
              }
            }
          }
        },
        CreateProfile: {
          http: {
            requestUri: "/domains/{DomainName}/profiles"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              AccountNumber: {},
              AdditionalInformation: {},
              PartyType: {},
              BusinessName: {},
              FirstName: {},
              MiddleName: {},
              LastName: {},
              BirthDate: {},
              Gender: {},
              PhoneNumber: {},
              MobilePhoneNumber: {},
              HomePhoneNumber: {},
              BusinessPhoneNumber: {},
              EmailAddress: {},
              PersonalEmailAddress: {},
              BusinessEmailAddress: {},
              Address: {
                shape: "Sn"
              },
              ShippingAddress: {
                shape: "Sn"
              },
              MailingAddress: {
                shape: "Sn"
              },
              BillingAddress: {
                shape: "Sn"
              },
              Attributes: {
                shape: "So"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ProfileId"
            ],
            members: {
              ProfileId: {}
            }
          }
        },
        DeleteDomain: {
          http: {
            method: "DELETE",
            requestUri: "/domains/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Message"
            ],
            members: {
              Message: {}
            }
          }
        },
        DeleteIntegration: {
          http: {
            requestUri: "/domains/{DomainName}/integrations/delete"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Uri"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              Uri: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Message"
            ],
            members: {
              Message: {}
            }
          }
        },
        DeleteProfile: {
          http: {
            requestUri: "/domains/{DomainName}/profiles/delete"
          },
          input: {
            type: "structure",
            required: [
              "ProfileId",
              "DomainName"
            ],
            members: {
              ProfileId: {},
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Message: {}
            }
          }
        },
        DeleteProfileKey: {
          http: {
            requestUri: "/domains/{DomainName}/profiles/keys/delete"
          },
          input: {
            type: "structure",
            required: [
              "ProfileId",
              "KeyName",
              "Values",
              "DomainName"
            ],
            members: {
              ProfileId: {},
              KeyName: {},
              Values: {
                shape: "S4"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Message: {}
            }
          }
        },
        DeleteProfileObject: {
          http: {
            requestUri: "/domains/{DomainName}/profiles/objects/delete"
          },
          input: {
            type: "structure",
            required: [
              "ProfileId",
              "ProfileObjectUniqueKey",
              "ObjectTypeName",
              "DomainName"
            ],
            members: {
              ProfileId: {},
              ProfileObjectUniqueKey: {},
              ObjectTypeName: {},
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Message: {}
            }
          }
        },
        DeleteProfileObjectType: {
          http: {
            method: "DELETE",
            requestUri: "/domains/{DomainName}/object-types/{ObjectTypeName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ObjectTypeName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              ObjectTypeName: {
                location: "uri",
                locationName: "ObjectTypeName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Message"
            ],
            members: {
              Message: {}
            }
          }
        },
        GetDomain: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainName",
              "CreatedAt",
              "LastUpdatedAt"
            ],
            members: {
              DomainName: {},
              DefaultExpirationDays: {
                type: "integer"
              },
              DefaultEncryptionKey: {},
              DeadLetterQueueUrl: {},
              Stats: {
                type: "structure",
                members: {
                  ProfileCount: {
                    type: "long"
                  },
                  MeteringProfileCount: {
                    type: "long"
                  },
                  ObjectCount: {
                    type: "long"
                  },
                  TotalSize: {
                    type: "long"
                  }
                }
              },
              Matching: {
                shape: "Sh"
              },
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sd"
              }
            }
          }
        },
        GetIntegration: {
          http: {
            requestUri: "/domains/{DomainName}/integrations"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "Uri"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              Uri: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainName",
              "Uri",
              "ObjectTypeName",
              "CreatedAt",
              "LastUpdatedAt"
            ],
            members: {
              DomainName: {},
              Uri: {},
              ObjectTypeName: {},
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sd"
              }
            }
          }
        },
        GetMatches: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}/matches"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              MatchGenerationDate: {
                type: "timestamp"
              },
              PotentialMatches: {
                type: "integer"
              },
              Matches: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MatchId: {},
                    ProfileIds: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              }
            }
          }
        },
        GetProfileObjectType: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}/object-types/{ObjectTypeName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ObjectTypeName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              ObjectTypeName: {
                location: "uri",
                locationName: "ObjectTypeName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ObjectTypeName",
              "Description"
            ],
            members: {
              ObjectTypeName: {},
              Description: {},
              TemplateId: {},
              ExpirationDays: {
                type: "integer"
              },
              EncryptionKey: {},
              AllowProfileCreation: {
                type: "boolean"
              },
              Fields: {
                shape: "S1m"
              },
              Keys: {
                shape: "S1p"
              },
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sd"
              }
            }
          }
        },
        GetProfileObjectTypeTemplate: {
          http: {
            method: "GET",
            requestUri: "/templates/{TemplateId}"
          },
          input: {
            type: "structure",
            required: [
              "TemplateId"
            ],
            members: {
              TemplateId: {
                location: "uri",
                locationName: "TemplateId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TemplateId: {},
              SourceName: {},
              SourceObject: {},
              AllowProfileCreation: {
                type: "boolean"
              },
              Fields: {
                shape: "S1m"
              },
              Keys: {
                shape: "S1p"
              }
            }
          }
        },
        ListAccountIntegrations: {
          http: {
            requestUri: "/integrations"
          },
          input: {
            type: "structure",
            required: [
              "Uri"
            ],
            members: {
              Uri: {},
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                shape: "S1z"
              },
              NextToken: {}
            }
          }
        },
        ListDomains: {
          http: {
            method: "GET",
            requestUri: "/domains"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DomainName",
                    "CreatedAt",
                    "LastUpdatedAt"
                  ],
                  members: {
                    DomainName: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    LastUpdatedAt: {
                      type: "timestamp"
                    },
                    Tags: {
                      shape: "Sd"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListIntegrations: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}/integrations"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                shape: "S1z"
              },
              NextToken: {}
            }
          }
        },
        ListProfileObjectTypeTemplates: {
          http: {
            method: "GET",
            requestUri: "/templates"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TemplateId: {},
                    SourceName: {},
                    SourceObject: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProfileObjectTypes: {
          http: {
            method: "GET",
            requestUri: "/domains/{DomainName}/object-types"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ObjectTypeName",
                    "Description"
                  ],
                  members: {
                    ObjectTypeName: {},
                    Description: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    LastUpdatedAt: {
                      type: "timestamp"
                    },
                    Tags: {
                      shape: "Sd"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListProfileObjects: {
          http: {
            requestUri: "/domains/{DomainName}/profiles/objects"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ObjectTypeName",
              "ProfileId"
            ],
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              ObjectTypeName: {},
              ProfileId: {},
              ObjectFilter: {
                type: "structure",
                required: [
                  "KeyName",
                  "Values"
                ],
                members: {
                  KeyName: {},
                  Values: {
                    shape: "S4"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ObjectTypeName: {},
                    ProfileObjectUniqueKey: {},
                    Object: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sd"
              }
            }
          }
        },
        MergeProfiles: {
          http: {
            requestUri: "/domains/{DomainName}/profiles/objects/merge"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "MainProfileId",
              "ProfileIdsToBeMerged"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              MainProfileId: {},
              ProfileIdsToBeMerged: {
                type: "list",
                member: {}
              },
              FieldSourceProfileIds: {
                type: "structure",
                members: {
                  AccountNumber: {},
                  AdditionalInformation: {},
                  PartyType: {},
                  BusinessName: {},
                  FirstName: {},
                  MiddleName: {},
                  LastName: {},
                  BirthDate: {},
                  Gender: {},
                  PhoneNumber: {},
                  MobilePhoneNumber: {},
                  HomePhoneNumber: {},
                  BusinessPhoneNumber: {},
                  EmailAddress: {},
                  PersonalEmailAddress: {},
                  BusinessEmailAddress: {},
                  Address: {},
                  ShippingAddress: {},
                  MailingAddress: {},
                  BillingAddress: {},
                  Attributes: {
                    type: "map",
                    key: {},
                    value: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Message: {}
            }
          }
        },
        PutIntegration: {
          http: {
            method: "PUT",
            requestUri: "/domains/{DomainName}/integrations"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ObjectTypeName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              Uri: {},
              ObjectTypeName: {},
              Tags: {
                shape: "Sd"
              },
              FlowDefinition: {
                type: "structure",
                required: [
                  "FlowName",
                  "KmsArn",
                  "SourceFlowConfig",
                  "Tasks",
                  "TriggerConfig"
                ],
                members: {
                  Description: {},
                  FlowName: {},
                  KmsArn: {},
                  SourceFlowConfig: {
                    type: "structure",
                    required: [
                      "ConnectorType",
                      "SourceConnectorProperties"
                    ],
                    members: {
                      ConnectorProfileName: {},
                      ConnectorType: {},
                      IncrementalPullConfig: {
                        type: "structure",
                        members: {
                          DatetimeTypeFieldName: {}
                        }
                      },
                      SourceConnectorProperties: {
                        type: "structure",
                        members: {
                          Marketo: {
                            type: "structure",
                            required: [
                              "Object"
                            ],
                            members: {
                              Object: {}
                            }
                          },
                          S3: {
                            type: "structure",
                            required: [
                              "BucketName"
                            ],
                            members: {
                              BucketName: {},
                              BucketPrefix: {}
                            }
                          },
                          Salesforce: {
                            type: "structure",
                            required: [
                              "Object"
                            ],
                            members: {
                              Object: {},
                              EnableDynamicFieldUpdate: {
                                type: "boolean"
                              },
                              IncludeDeletedRecords: {
                                type: "boolean"
                              }
                            }
                          },
                          ServiceNow: {
                            type: "structure",
                            required: [
                              "Object"
                            ],
                            members: {
                              Object: {}
                            }
                          },
                          Zendesk: {
                            type: "structure",
                            required: [
                              "Object"
                            ],
                            members: {
                              Object: {}
                            }
                          }
                        }
                      }
                    }
                  },
                  Tasks: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "SourceFields",
                        "TaskType"
                      ],
                      members: {
                        ConnectorOperator: {
                          type: "structure",
                          members: {
                            Marketo: {},
                            S3: {},
                            Salesforce: {},
                            ServiceNow: {},
                            Zendesk: {}
                          }
                        },
                        DestinationField: {},
                        SourceFields: {
                          type: "list",
                          member: {}
                        },
                        TaskProperties: {
                          type: "map",
                          key: {},
                          value: {}
                        },
                        TaskType: {}
                      }
                    }
                  },
                  TriggerConfig: {
                    type: "structure",
                    required: [
                      "TriggerType"
                    ],
                    members: {
                      TriggerType: {},
                      TriggerProperties: {
                        type: "structure",
                        members: {
                          Scheduled: {
                            type: "structure",
                            required: [
                              "ScheduleExpression"
                            ],
                            members: {
                              ScheduleExpression: {},
                              DataPullMode: {},
                              ScheduleStartTime: {
                                type: "timestamp"
                              },
                              ScheduleEndTime: {
                                type: "timestamp"
                              },
                              Timezone: {},
                              ScheduleOffset: {
                                type: "long"
                              },
                              FirstExecutionFrom: {
                                type: "timestamp"
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainName",
              "Uri",
              "ObjectTypeName",
              "CreatedAt",
              "LastUpdatedAt"
            ],
            members: {
              DomainName: {},
              Uri: {},
              ObjectTypeName: {},
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sd"
              }
            }
          }
        },
        PutProfileObject: {
          http: {
            method: "PUT",
            requestUri: "/domains/{DomainName}/profiles/objects"
          },
          input: {
            type: "structure",
            required: [
              "ObjectTypeName",
              "Object",
              "DomainName"
            ],
            members: {
              ObjectTypeName: {},
              Object: {},
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProfileObjectUniqueKey: {}
            }
          }
        },
        PutProfileObjectType: {
          http: {
            method: "PUT",
            requestUri: "/domains/{DomainName}/object-types/{ObjectTypeName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ObjectTypeName",
              "Description"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              ObjectTypeName: {
                location: "uri",
                locationName: "ObjectTypeName"
              },
              Description: {},
              TemplateId: {},
              ExpirationDays: {
                type: "integer"
              },
              EncryptionKey: {},
              AllowProfileCreation: {
                type: "boolean"
              },
              Fields: {
                shape: "S1m"
              },
              Keys: {
                shape: "S1p"
              },
              Tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ObjectTypeName",
              "Description"
            ],
            members: {
              ObjectTypeName: {},
              Description: {},
              TemplateId: {},
              ExpirationDays: {
                type: "integer"
              },
              EncryptionKey: {},
              AllowProfileCreation: {
                type: "boolean"
              },
              Fields: {
                shape: "S1m"
              },
              Keys: {
                shape: "S1p"
              },
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sd"
              }
            }
          }
        },
        SearchProfiles: {
          http: {
            requestUri: "/domains/{DomainName}/profiles/search"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "KeyName",
              "Values"
            ],
            members: {
              NextToken: {
                location: "querystring",
                locationName: "next-token"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              KeyName: {},
              Values: {
                shape: "S4"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ProfileId: {},
                    AccountNumber: {},
                    AdditionalInformation: {},
                    PartyType: {},
                    BusinessName: {},
                    FirstName: {},
                    MiddleName: {},
                    LastName: {},
                    BirthDate: {},
                    Gender: {},
                    PhoneNumber: {},
                    MobilePhoneNumber: {},
                    HomePhoneNumber: {},
                    BusinessPhoneNumber: {},
                    EmailAddress: {},
                    PersonalEmailAddress: {},
                    BusinessEmailAddress: {},
                    Address: {
                      shape: "Sn"
                    },
                    ShippingAddress: {
                      shape: "Sn"
                    },
                    MailingAddress: {
                      shape: "Sn"
                    },
                    BillingAddress: {
                      shape: "Sn"
                    },
                    Attributes: {
                      shape: "So"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDomain: {
          http: {
            method: "PUT",
            requestUri: "/domains/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              DefaultExpirationDays: {
                type: "integer"
              },
              DefaultEncryptionKey: {},
              DeadLetterQueueUrl: {},
              Matching: {
                shape: "Sb"
              },
              Tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainName",
              "CreatedAt",
              "LastUpdatedAt"
            ],
            members: {
              DomainName: {},
              DefaultExpirationDays: {
                type: "integer"
              },
              DefaultEncryptionKey: {},
              DeadLetterQueueUrl: {},
              Matching: {
                shape: "Sh"
              },
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sd"
              }
            }
          }
        },
        UpdateProfile: {
          http: {
            method: "PUT",
            requestUri: "/domains/{DomainName}/profiles"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "ProfileId"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              ProfileId: {},
              AdditionalInformation: {},
              AccountNumber: {},
              PartyType: {},
              BusinessName: {},
              FirstName: {},
              MiddleName: {},
              LastName: {},
              BirthDate: {},
              Gender: {},
              PhoneNumber: {},
              MobilePhoneNumber: {},
              HomePhoneNumber: {},
              BusinessPhoneNumber: {},
              EmailAddress: {},
              PersonalEmailAddress: {},
              BusinessEmailAddress: {},
              Address: {
                shape: "S4j"
              },
              ShippingAddress: {
                shape: "S4j"
              },
              MailingAddress: {
                shape: "S4j"
              },
              BillingAddress: {
                shape: "S4j"
              },
              Attributes: {
                type: "map",
                key: {},
                value: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ProfileId"
            ],
            members: {
              ProfileId: {}
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "list",
          member: {}
        },
        Sb: {
          type: "structure",
          required: [
            "Enabled"
          ],
          members: {
            Enabled: {
              type: "boolean"
            }
          }
        },
        Sd: {
          type: "map",
          key: {},
          value: {}
        },
        Sh: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            }
          }
        },
        Sn: {
          type: "structure",
          members: {
            Address1: {},
            Address2: {},
            Address3: {},
            Address4: {},
            City: {},
            County: {},
            State: {},
            Province: {},
            Country: {},
            PostalCode: {}
          }
        },
        So: {
          type: "map",
          key: {},
          value: {}
        },
        S1m: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              Source: {},
              Target: {},
              ContentType: {}
            }
          }
        },
        S1p: {
          type: "map",
          key: {},
          value: {
            type: "list",
            member: {
              type: "structure",
              members: {
                StandardIdentifiers: {
                  type: "list",
                  member: {}
                },
                FieldNames: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        S1z: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "DomainName",
              "Uri",
              "ObjectTypeName",
              "CreatedAt",
              "LastUpdatedAt"
            ],
            members: {
              DomainName: {},
              Uri: {},
              ObjectTypeName: {},
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Tags: {
                shape: "Sd"
              }
            }
          }
        },
        S4j: {
          type: "structure",
          members: {
            Address1: {},
            Address2: {},
            Address3: {},
            Address4: {},
            City: {},
            County: {},
            State: {},
            Province: {},
            Country: {},
            PostalCode: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/customer-profiles-2020-08-15.paginators.json
var require_customer_profiles_2020_08_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/customer-profiles-2020-08-15.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/customerprofiles.js
var require_customerprofiles = __commonJS({
  "node_modules/aws-sdk/clients/customerprofiles.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["customerprofiles"] = {};
    AWS3.CustomerProfiles = Service.defineService("customerprofiles", ["2020-08-15"]);
    Object.defineProperty(apiLoader.services["customerprofiles"], "2020-08-15", {
      get: function get() {
        var model = require_customer_profiles_2020_08_15_min();
        model.paginators = require_customer_profiles_2020_08_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CustomerProfiles;
  }
});

// node_modules/aws-sdk/apis/auditmanager-2017-07-25.min.json
var require_auditmanager_2017_07_25_min = __commonJS({
  "node_modules/aws-sdk/apis/auditmanager-2017-07-25.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-25",
        endpointPrefix: "auditmanager",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Audit Manager",
        serviceId: "AuditManager",
        signatureVersion: "v4",
        signingName: "auditmanager",
        uid: "auditmanager-2017-07-25"
      },
      operations: {
        AssociateAssessmentReportEvidenceFolder: {
          http: {
            method: "PUT",
            requestUri: "/assessments/{assessmentId}/associateToAssessmentReport"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "evidenceFolderId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              evidenceFolderId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        BatchAssociateAssessmentReportEvidence: {
          http: {
            method: "PUT",
            requestUri: "/assessments/{assessmentId}/batchAssociateToAssessmentReport"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "evidenceFolderId",
              "evidenceIds"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              evidenceFolderId: {},
              evidenceIds: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              evidenceIds: {
                shape: "S5"
              },
              errors: {
                shape: "S7"
              }
            }
          }
        },
        BatchCreateDelegationByAssessment: {
          http: {
            requestUri: "/assessments/{assessmentId}/delegations"
          },
          input: {
            type: "structure",
            required: [
              "createDelegationRequests",
              "assessmentId"
            ],
            members: {
              createDelegationRequests: {
                type: "list",
                member: {
                  shape: "Sd"
                }
              },
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              delegations: {
                shape: "Sj"
              },
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    createDelegationRequest: {
                      shape: "Sd"
                    },
                    errorCode: {},
                    errorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchDeleteDelegationByAssessment: {
          http: {
            method: "PUT",
            requestUri: "/assessments/{assessmentId}/delegations"
          },
          input: {
            type: "structure",
            required: [
              "delegationIds",
              "assessmentId"
            ],
            members: {
              delegationIds: {
                type: "list",
                member: {}
              },
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    delegationId: {},
                    errorCode: {},
                    errorMessage: {}
                  }
                }
              }
            }
          }
        },
        BatchDisassociateAssessmentReportEvidence: {
          http: {
            method: "PUT",
            requestUri: "/assessments/{assessmentId}/batchDisassociateFromAssessmentReport"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "evidenceFolderId",
              "evidenceIds"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              evidenceFolderId: {},
              evidenceIds: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              evidenceIds: {
                shape: "S5"
              },
              errors: {
                shape: "S7"
              }
            }
          }
        },
        BatchImportEvidenceToAssessmentControl: {
          http: {
            requestUri: "/assessments/{assessmentId}/controlSets/{controlSetId}/controls/{controlId}/evidence"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "controlSetId",
              "controlId",
              "manualEvidence"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              controlSetId: {
                location: "uri",
                locationName: "controlSetId"
              },
              controlId: {
                location: "uri",
                locationName: "controlId"
              },
              manualEvidence: {
                type: "list",
                member: {
                  shape: "S10"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    manualEvidence: {
                      shape: "S10"
                    },
                    errorCode: {},
                    errorMessage: {}
                  }
                }
              }
            }
          }
        },
        CreateAssessment: {
          http: {
            requestUri: "/assessments"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "assessmentReportsDestination",
              "scope",
              "roles",
              "frameworkId"
            ],
            members: {
              name: {},
              description: {},
              assessmentReportsDestination: {
                shape: "S17"
              },
              scope: {
                shape: "S19"
              },
              roles: {
                shape: "S1i"
              },
              frameworkId: {},
              tags: {
                shape: "S1k"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assessment: {
                shape: "S1o"
              }
            }
          }
        },
        CreateAssessmentFramework: {
          http: {
            requestUri: "/assessmentFrameworks"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "controlSets"
            ],
            members: {
              name: {},
              description: {},
              complianceType: {},
              controlSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name"
                  ],
                  members: {
                    name: {},
                    controls: {
                      shape: "S2j"
                    }
                  }
                }
              },
              tags: {
                shape: "S1k"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              framework: {
                shape: "S2m"
              }
            }
          }
        },
        CreateAssessmentReport: {
          http: {
            requestUri: "/assessments/{assessmentId}/reports"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "assessmentId"
            ],
            members: {
              name: {},
              description: {},
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assessmentReport: {
                type: "structure",
                members: {
                  id: {},
                  name: {},
                  description: {},
                  awsAccountId: {},
                  assessmentId: {},
                  assessmentName: {},
                  author: {},
                  status: {},
                  creationTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        CreateControl: {
          http: {
            requestUri: "/controls"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "controlMappingSources"
            ],
            members: {
              name: {},
              description: {},
              testingInformation: {},
              actionPlanTitle: {},
              actionPlanInstructions: {},
              controlMappingSources: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    sourceName: {},
                    sourceDescription: {},
                    sourceSetUpOption: {},
                    sourceType: {},
                    sourceKeyword: {
                      shape: "S33"
                    },
                    sourceFrequency: {},
                    troubleshootingText: {}
                  }
                }
              },
              tags: {
                shape: "S1k"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              control: {
                shape: "S2s"
              }
            }
          }
        },
        DeleteAssessment: {
          http: {
            method: "DELETE",
            requestUri: "/assessments/{assessmentId}"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAssessmentFramework: {
          http: {
            method: "DELETE",
            requestUri: "/assessmentFrameworks/{frameworkId}"
          },
          input: {
            type: "structure",
            required: [
              "frameworkId"
            ],
            members: {
              frameworkId: {
                location: "uri",
                locationName: "frameworkId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAssessmentReport: {
          http: {
            method: "DELETE",
            requestUri: "/assessments/{assessmentId}/reports/{assessmentReportId}"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "assessmentReportId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              assessmentReportId: {
                location: "uri",
                locationName: "assessmentReportId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteControl: {
          http: {
            method: "DELETE",
            requestUri: "/controls/{controlId}"
          },
          input: {
            type: "structure",
            required: [
              "controlId"
            ],
            members: {
              controlId: {
                location: "uri",
                locationName: "controlId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeregisterAccount: {
          http: {
            requestUri: "/account/deregisterAccount"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          }
        },
        DeregisterOrganizationAdminAccount: {
          http: {
            requestUri: "/account/deregisterOrganizationAdminAccount"
          },
          input: {
            type: "structure",
            members: {
              adminAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateAssessmentReportEvidenceFolder: {
          http: {
            method: "PUT",
            requestUri: "/assessments/{assessmentId}/disassociateFromAssessmentReport"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "evidenceFolderId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              evidenceFolderId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetAccountStatus: {
          http: {
            method: "GET",
            requestUri: "/account/status"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          }
        },
        GetAssessment: {
          http: {
            method: "GET",
            requestUri: "/assessments/{assessmentId}"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assessment: {
                shape: "S1o"
              },
              userRole: {
                shape: "S1j"
              }
            }
          }
        },
        GetAssessmentFramework: {
          http: {
            method: "GET",
            requestUri: "/assessmentFrameworks/{frameworkId}"
          },
          input: {
            type: "structure",
            required: [
              "frameworkId"
            ],
            members: {
              frameworkId: {
                location: "uri",
                locationName: "frameworkId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              framework: {
                shape: "S2m"
              }
            }
          }
        },
        GetAssessmentReportUrl: {
          http: {
            method: "GET",
            requestUri: "/assessments/{assessmentId}/reports/{assessmentReportId}/url"
          },
          input: {
            type: "structure",
            required: [
              "assessmentReportId",
              "assessmentId"
            ],
            members: {
              assessmentReportId: {
                location: "uri",
                locationName: "assessmentReportId"
              },
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              preSignedUrl: {
                type: "structure",
                members: {
                  hyperlinkName: {},
                  link: {}
                }
              }
            }
          }
        },
        GetChangeLogs: {
          http: {
            method: "GET",
            requestUri: "/assessments/{assessmentId}/changelogs"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              controlSetId: {
                location: "querystring",
                locationName: "controlSetId"
              },
              controlId: {
                location: "querystring",
                locationName: "controlId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              changeLogs: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    objectType: {},
                    objectName: {},
                    action: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    createdBy: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetControl: {
          http: {
            method: "GET",
            requestUri: "/controls/{controlId}"
          },
          input: {
            type: "structure",
            required: [
              "controlId"
            ],
            members: {
              controlId: {
                location: "uri",
                locationName: "controlId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              control: {
                shape: "S2s"
              }
            }
          }
        },
        GetDelegations: {
          http: {
            method: "GET",
            requestUri: "/delegations"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              delegations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    assessmentName: {},
                    assessmentId: {},
                    status: {},
                    roleArn: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    controlSetName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        GetEvidence: {
          http: {
            method: "GET",
            requestUri: "/assessments/{assessmentId}/controlSets/{controlSetId}/evidenceFolders/{evidenceFolderId}/evidence/{evidenceId}"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "controlSetId",
              "evidenceFolderId",
              "evidenceId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              controlSetId: {
                location: "uri",
                locationName: "controlSetId"
              },
              evidenceFolderId: {
                location: "uri",
                locationName: "evidenceFolderId"
              },
              evidenceId: {
                location: "uri",
                locationName: "evidenceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              evidence: {
                shape: "S4p"
              }
            }
          }
        },
        GetEvidenceByEvidenceFolder: {
          http: {
            method: "GET",
            requestUri: "/assessments/{assessmentId}/controlSets/{controlSetId}/evidenceFolders/{evidenceFolderId}/evidence"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "controlSetId",
              "evidenceFolderId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              controlSetId: {
                location: "uri",
                locationName: "controlSetId"
              },
              evidenceFolderId: {
                location: "uri",
                locationName: "evidenceFolderId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              evidence: {
                type: "list",
                member: {
                  shape: "S4p"
                }
              },
              nextToken: {}
            }
          }
        },
        GetEvidenceFolder: {
          http: {
            method: "GET",
            requestUri: "/assessments/{assessmentId}/controlSets/{controlSetId}/evidenceFolders/{evidenceFolderId}"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "controlSetId",
              "evidenceFolderId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              controlSetId: {
                location: "uri",
                locationName: "controlSetId"
              },
              evidenceFolderId: {
                location: "uri",
                locationName: "evidenceFolderId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              evidenceFolder: {
                shape: "S53"
              }
            }
          }
        },
        GetEvidenceFoldersByAssessment: {
          http: {
            method: "GET",
            requestUri: "/assessments/{assessmentId}/evidenceFolders"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              evidenceFolders: {
                shape: "S57"
              },
              nextToken: {}
            }
          }
        },
        GetEvidenceFoldersByAssessmentControl: {
          http: {
            method: "GET",
            requestUri: "/assessments/{assessmentId}/evidenceFolders-by-assessment-control/{controlSetId}/{controlId}"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "controlSetId",
              "controlId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              controlSetId: {
                location: "uri",
                locationName: "controlSetId"
              },
              controlId: {
                location: "uri",
                locationName: "controlId"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              evidenceFolders: {
                shape: "S57"
              },
              nextToken: {}
            }
          }
        },
        GetOrganizationAdminAccount: {
          http: {
            method: "GET",
            requestUri: "/account/organizationAdminAccount"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              adminAccountId: {},
              organizationId: {}
            }
          }
        },
        GetServicesInScope: {
          http: {
            method: "GET",
            requestUri: "/services"
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              serviceMetadata: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    displayName: {},
                    description: {},
                    category: {}
                  }
                }
              }
            }
          }
        },
        GetSettings: {
          http: {
            method: "GET",
            requestUri: "/settings/{attribute}"
          },
          input: {
            type: "structure",
            required: [
              "attribute"
            ],
            members: {
              attribute: {
                location: "uri",
                locationName: "attribute"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              settings: {
                shape: "S5k"
              }
            }
          }
        },
        ListAssessmentFrameworks: {
          http: {
            method: "GET",
            requestUri: "/assessmentFrameworks"
          },
          input: {
            type: "structure",
            required: [
              "frameworkType"
            ],
            members: {
              frameworkType: {
                location: "querystring",
                locationName: "frameworkType"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              frameworkMetadataList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    id: {},
                    type: {},
                    name: {},
                    description: {},
                    logo: {},
                    complianceType: {},
                    controlsCount: {
                      type: "integer"
                    },
                    controlSetsCount: {
                      type: "integer"
                    },
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAssessmentReports: {
          http: {
            method: "GET",
            requestUri: "/assessmentReports"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assessmentReports: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    name: {},
                    description: {},
                    assessmentId: {},
                    assessmentName: {},
                    author: {},
                    status: {},
                    creationTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAssessments: {
          http: {
            method: "GET",
            requestUri: "/assessments"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assessmentMetadata: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    name: {},
                    id: {},
                    complianceType: {},
                    status: {},
                    roles: {
                      shape: "S1i"
                    },
                    delegations: {
                      shape: "Sj"
                    },
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdated: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListControls: {
          http: {
            method: "GET",
            requestUri: "/controls"
          },
          input: {
            type: "structure",
            required: [
              "controlType"
            ],
            members: {
              controlType: {
                location: "querystring",
                locationName: "controlType"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              controlMetadataList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    id: {},
                    name: {},
                    controlSources: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListKeywordsForDataSource: {
          http: {
            method: "GET",
            requestUri: "/dataSourceKeywords"
          },
          input: {
            type: "structure",
            required: [
              "source"
            ],
            members: {
              source: {
                location: "querystring",
                locationName: "source"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              keywords: {
                type: "list",
                member: {}
              },
              nextToken: {}
            }
          }
        },
        ListNotifications: {
          http: {
            method: "GET",
            requestUri: "/notifications"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              notifications: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    assessmentId: {},
                    assessmentName: {},
                    controlSetId: {},
                    controlSetName: {},
                    description: {},
                    eventTime: {
                      type: "timestamp"
                    },
                    source: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S1k"
              }
            }
          }
        },
        RegisterAccount: {
          http: {
            requestUri: "/account/registerAccount"
          },
          input: {
            type: "structure",
            members: {
              kmsKey: {},
              delegatedAdminAccount: {}
            }
          },
          output: {
            type: "structure",
            members: {
              status: {}
            }
          }
        },
        RegisterOrganizationAdminAccount: {
          http: {
            requestUri: "/account/registerOrganizationAdminAccount"
          },
          input: {
            type: "structure",
            required: [
              "adminAccountId"
            ],
            members: {
              adminAccountId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              adminAccountId: {},
              organizationId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S1k"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAssessment: {
          http: {
            method: "PUT",
            requestUri: "/assessments/{assessmentId}"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "scope"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              assessmentName: {},
              assessmentDescription: {},
              scope: {
                shape: "S19"
              },
              assessmentReportsDestination: {
                shape: "S17"
              },
              roles: {
                shape: "S1i"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assessment: {
                shape: "S1o"
              }
            }
          }
        },
        UpdateAssessmentControl: {
          http: {
            method: "PUT",
            requestUri: "/assessments/{assessmentId}/controlSets/{controlSetId}/controls/{controlId}"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "controlSetId",
              "controlId"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              controlSetId: {
                location: "uri",
                locationName: "controlSetId"
              },
              controlId: {
                location: "uri",
                locationName: "controlId"
              },
              controlStatus: {},
              commentBody: {}
            }
          },
          output: {
            type: "structure",
            members: {
              control: {
                shape: "S22"
              }
            }
          }
        },
        UpdateAssessmentControlSetStatus: {
          http: {
            method: "PUT",
            requestUri: "/assessments/{assessmentId}/controlSets/{controlSetId}/status"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "controlSetId",
              "status",
              "comment"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              controlSetId: {
                location: "uri",
                locationName: "controlSetId"
              },
              status: {},
              comment: {}
            }
          },
          output: {
            type: "structure",
            members: {
              controlSet: {
                shape: "S1y"
              }
            }
          }
        },
        UpdateAssessmentFramework: {
          http: {
            method: "PUT",
            requestUri: "/assessmentFrameworks/{frameworkId}"
          },
          input: {
            type: "structure",
            required: [
              "frameworkId",
              "name",
              "controlSets"
            ],
            members: {
              frameworkId: {
                location: "uri",
                locationName: "frameworkId"
              },
              name: {},
              description: {},
              complianceType: {},
              controlSets: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name"
                  ],
                  members: {
                    id: {},
                    name: {},
                    controls: {
                      shape: "S2j"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              framework: {
                shape: "S2m"
              }
            }
          }
        },
        UpdateAssessmentStatus: {
          http: {
            method: "PUT",
            requestUri: "/assessments/{assessmentId}/status"
          },
          input: {
            type: "structure",
            required: [
              "assessmentId",
              "status"
            ],
            members: {
              assessmentId: {
                location: "uri",
                locationName: "assessmentId"
              },
              status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              assessment: {
                shape: "S1o"
              }
            }
          }
        },
        UpdateControl: {
          http: {
            method: "PUT",
            requestUri: "/controls/{controlId}"
          },
          input: {
            type: "structure",
            required: [
              "controlId",
              "name",
              "controlMappingSources"
            ],
            members: {
              controlId: {
                location: "uri",
                locationName: "controlId"
              },
              name: {},
              description: {},
              testingInformation: {},
              actionPlanTitle: {},
              actionPlanInstructions: {},
              controlMappingSources: {
                shape: "S2x"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              control: {
                shape: "S2s"
              }
            }
          }
        },
        UpdateSettings: {
          http: {
            method: "PUT",
            requestUri: "/settings"
          },
          input: {
            type: "structure",
            members: {
              snsTopic: {},
              defaultAssessmentReportsDestination: {
                shape: "S17"
              },
              defaultProcessOwners: {
                shape: "S1i"
              },
              kmsKey: {}
            }
          },
          output: {
            type: "structure",
            members: {
              settings: {
                shape: "S5k"
              }
            }
          }
        },
        ValidateAssessmentReportIntegrity: {
          http: {
            requestUri: "/assessmentReports/integrity"
          },
          input: {
            type: "structure",
            required: [
              "s3RelativePath"
            ],
            members: {
              s3RelativePath: {}
            }
          },
          output: {
            type: "structure",
            members: {
              signatureValid: {
                type: "boolean"
              },
              signatureAlgorithm: {},
              signatureDateTime: {},
              signatureKeyId: {},
              validationErrors: {
                type: "list",
                member: {}
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "list",
          member: {}
        },
        S7: {
          type: "list",
          member: {
            type: "structure",
            members: {
              evidenceId: {},
              errorCode: {},
              errorMessage: {}
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            comment: {},
            controlSetId: {},
            roleArn: {},
            roleType: {}
          }
        },
        Sj: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {},
              assessmentName: {},
              assessmentId: {},
              status: {},
              roleArn: {},
              roleType: {},
              creationTime: {
                type: "timestamp"
              },
              lastUpdated: {
                type: "timestamp"
              },
              controlSetId: {},
              comment: {},
              createdBy: {}
            }
          }
        },
        S10: {
          type: "structure",
          members: {
            s3ResourcePath: {}
          }
        },
        S17: {
          type: "structure",
          members: {
            destinationType: {},
            destination: {}
          }
        },
        S19: {
          type: "structure",
          members: {
            awsAccounts: {
              type: "list",
              member: {
                shape: "S1b"
              }
            },
            awsServices: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  serviceName: {}
                }
              }
            }
          }
        },
        S1b: {
          type: "structure",
          members: {
            id: {},
            emailAddress: {},
            name: {}
          }
        },
        S1i: {
          type: "list",
          member: {
            shape: "S1j"
          }
        },
        S1j: {
          type: "structure",
          members: {
            roleType: {},
            roleArn: {}
          }
        },
        S1k: {
          type: "map",
          key: {},
          value: {}
        },
        S1o: {
          type: "structure",
          members: {
            arn: {},
            awsAccount: {
              shape: "S1b"
            },
            metadata: {
              type: "structure",
              members: {
                name: {},
                id: {},
                description: {},
                complianceType: {},
                status: {},
                assessmentReportsDestination: {
                  shape: "S17"
                },
                scope: {
                  shape: "S19"
                },
                roles: {
                  shape: "S1i"
                },
                delegations: {
                  shape: "Sj"
                },
                creationTime: {
                  type: "timestamp"
                },
                lastUpdated: {
                  type: "timestamp"
                }
              }
            },
            framework: {
              type: "structure",
              members: {
                id: {},
                arn: {},
                metadata: {
                  type: "structure",
                  members: {
                    name: {},
                    description: {},
                    logo: {},
                    complianceType: {}
                  }
                },
                controlSets: {
                  type: "list",
                  member: {
                    shape: "S1y"
                  }
                }
              }
            },
            tags: {
              shape: "S1k"
            }
          }
        },
        S1y: {
          type: "structure",
          members: {
            id: {},
            description: {},
            status: {},
            roles: {
              shape: "S1i"
            },
            controls: {
              type: "list",
              member: {
                shape: "S22"
              }
            },
            delegations: {
              shape: "Sj"
            },
            systemEvidenceCount: {
              type: "integer"
            },
            manualEvidenceCount: {
              type: "integer"
            }
          }
        },
        S22: {
          type: "structure",
          members: {
            id: {},
            name: {},
            description: {},
            status: {},
            response: {},
            comments: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  authorName: {},
                  commentBody: {},
                  postedDate: {
                    type: "timestamp"
                  }
                }
              }
            },
            evidenceSources: {
              type: "list",
              member: {}
            },
            evidenceCount: {
              type: "integer"
            },
            assessmentReportEvidenceCount: {
              type: "integer"
            }
          }
        },
        S2j: {
          type: "list",
          member: {
            type: "structure",
            members: {
              id: {}
            }
          }
        },
        S2m: {
          type: "structure",
          members: {
            arn: {},
            id: {},
            name: {},
            type: {},
            complianceType: {},
            description: {},
            logo: {},
            controlSources: {},
            controlSets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  id: {},
                  name: {},
                  controls: {
                    type: "list",
                    member: {
                      shape: "S2s"
                    }
                  }
                }
              }
            },
            createdAt: {
              type: "timestamp"
            },
            lastUpdatedAt: {
              type: "timestamp"
            },
            createdBy: {},
            lastUpdatedBy: {},
            tags: {
              shape: "S1k"
            }
          }
        },
        S2s: {
          type: "structure",
          members: {
            arn: {},
            id: {},
            type: {},
            name: {},
            description: {},
            testingInformation: {},
            actionPlanTitle: {},
            actionPlanInstructions: {},
            controlSources: {},
            controlMappingSources: {
              shape: "S2x"
            },
            createdAt: {
              type: "timestamp"
            },
            lastUpdatedAt: {
              type: "timestamp"
            },
            createdBy: {},
            lastUpdatedBy: {},
            tags: {
              shape: "S1k"
            }
          }
        },
        S2x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              sourceId: {},
              sourceName: {},
              sourceDescription: {},
              sourceSetUpOption: {},
              sourceType: {},
              sourceKeyword: {
                shape: "S33"
              },
              sourceFrequency: {},
              troubleshootingText: {}
            }
          }
        },
        S33: {
          type: "structure",
          members: {
            keywordInputType: {},
            keywordValue: {}
          }
        },
        S4p: {
          type: "structure",
          members: {
            dataSource: {},
            evidenceAwsAccountId: {},
            time: {
              type: "timestamp"
            },
            eventSource: {},
            eventName: {},
            evidenceByType: {},
            resourcesIncluded: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  arn: {},
                  value: {}
                }
              }
            },
            attributes: {
              type: "map",
              key: {},
              value: {}
            },
            iamId: {},
            complianceCheck: {},
            awsOrganization: {},
            awsAccountId: {},
            evidenceFolderId: {},
            id: {},
            assessmentReportSelection: {}
          }
        },
        S53: {
          type: "structure",
          members: {
            name: {},
            date: {
              type: "timestamp"
            },
            assessmentId: {},
            controlSetId: {},
            controlId: {},
            id: {},
            dataSource: {},
            author: {},
            totalEvidence: {
              type: "integer"
            },
            assessmentReportSelectionCount: {
              type: "integer"
            },
            controlName: {},
            evidenceResourcesIncludedCount: {
              type: "integer"
            },
            evidenceByTypeConfigurationDataCount: {
              type: "integer"
            },
            evidenceByTypeManualCount: {
              type: "integer"
            },
            evidenceByTypeComplianceCheckCount: {
              type: "integer"
            },
            evidenceByTypeComplianceCheckIssuesCount: {
              type: "integer"
            },
            evidenceByTypeUserActivityCount: {
              type: "integer"
            },
            evidenceAwsServiceSourceCount: {
              type: "integer"
            }
          }
        },
        S57: {
          type: "list",
          member: {
            shape: "S53"
          }
        },
        S5k: {
          type: "structure",
          members: {
            isAwsOrgEnabled: {
              type: "boolean"
            },
            snsTopic: {},
            defaultAssessmentReportsDestination: {
              shape: "S17"
            },
            defaultProcessOwners: {
              shape: "S1i"
            },
            kmsKey: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/auditmanager-2017-07-25.paginators.json
var require_auditmanager_2017_07_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/auditmanager-2017-07-25.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetChangeLogs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetDelegations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetEvidenceByEvidenceFolder: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetEvidenceFoldersByAssessment: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        GetEvidenceFoldersByAssessmentControl: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAssessmentFrameworks: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAssessmentReports: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListAssessments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListControls: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListKeywordsForDataSource: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListNotifications: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/auditmanager.js
var require_auditmanager = __commonJS({
  "node_modules/aws-sdk/clients/auditmanager.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["auditmanager"] = {};
    AWS3.AuditManager = Service.defineService("auditmanager", ["2017-07-25"]);
    Object.defineProperty(apiLoader.services["auditmanager"], "2017-07-25", {
      get: function get() {
        var model = require_auditmanager_2017_07_25_min();
        model.paginators = require_auditmanager_2017_07_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.AuditManager;
  }
});

// node_modules/aws-sdk/apis/emr-containers-2020-10-01.min.json
var require_emr_containers_2020_10_01_min = __commonJS({
  "node_modules/aws-sdk/apis/emr-containers-2020-10-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-10-01",
        endpointPrefix: "emr-containers",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon EMR Containers",
        serviceId: "EMR containers",
        signatureVersion: "v4",
        signingName: "emr-containers",
        uid: "emr-containers-2020-10-01"
      },
      operations: {
        CancelJobRun: {
          http: {
            method: "DELETE",
            requestUri: "/virtualclusters/{virtualClusterId}/jobruns/{jobRunId}"
          },
          input: {
            type: "structure",
            required: [
              "id",
              "virtualClusterId"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "jobRunId"
              },
              virtualClusterId: {
                location: "uri",
                locationName: "virtualClusterId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              virtualClusterId: {}
            }
          }
        },
        CreateManagedEndpoint: {
          http: {
            requestUri: "/virtualclusters/{virtualClusterId}/endpoints"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "virtualClusterId",
              "type",
              "releaseLabel",
              "executionRoleArn",
              "certificateArn",
              "clientToken"
            ],
            members: {
              name: {},
              virtualClusterId: {
                location: "uri",
                locationName: "virtualClusterId"
              },
              type: {},
              releaseLabel: {},
              executionRoleArn: {},
              certificateArn: {},
              configurationOverrides: {
                shape: "Sa"
              },
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              name: {},
              arn: {},
              virtualClusterId: {}
            }
          }
        },
        CreateVirtualCluster: {
          http: {
            requestUri: "/virtualclusters"
          },
          input: {
            type: "structure",
            required: [
              "name",
              "containerProvider",
              "clientToken"
            ],
            members: {
              name: {},
              containerProvider: {
                shape: "St"
              },
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              name: {},
              arn: {}
            }
          }
        },
        DeleteManagedEndpoint: {
          http: {
            method: "DELETE",
            requestUri: "/virtualclusters/{virtualClusterId}/endpoints/{endpointId}"
          },
          input: {
            type: "structure",
            required: [
              "id",
              "virtualClusterId"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "endpointId"
              },
              virtualClusterId: {
                location: "uri",
                locationName: "virtualClusterId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              virtualClusterId: {}
            }
          }
        },
        DeleteVirtualCluster: {
          http: {
            method: "DELETE",
            requestUri: "/virtualclusters/{virtualClusterId}"
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "virtualClusterId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {}
            }
          }
        },
        DescribeJobRun: {
          http: {
            method: "GET",
            requestUri: "/virtualclusters/{virtualClusterId}/jobruns/{jobRunId}"
          },
          input: {
            type: "structure",
            required: [
              "id",
              "virtualClusterId"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "jobRunId"
              },
              virtualClusterId: {
                location: "uri",
                locationName: "virtualClusterId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobRun: {
                shape: "S17"
              }
            }
          }
        },
        DescribeManagedEndpoint: {
          http: {
            method: "GET",
            requestUri: "/virtualclusters/{virtualClusterId}/endpoints/{endpointId}"
          },
          input: {
            type: "structure",
            required: [
              "id",
              "virtualClusterId"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "endpointId"
              },
              virtualClusterId: {
                location: "uri",
                locationName: "virtualClusterId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              endpoint: {
                shape: "S1l"
              }
            }
          }
        },
        DescribeVirtualCluster: {
          http: {
            method: "GET",
            requestUri: "/virtualclusters/{virtualClusterId}"
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "virtualClusterId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualCluster: {
                shape: "S1q"
              }
            }
          }
        },
        ListJobRuns: {
          http: {
            method: "GET",
            requestUri: "/virtualclusters/{virtualClusterId}/jobruns"
          },
          input: {
            type: "structure",
            required: [
              "virtualClusterId"
            ],
            members: {
              virtualClusterId: {
                location: "uri",
                locationName: "virtualClusterId"
              },
              createdBefore: {
                shape: "S1g",
                location: "querystring",
                locationName: "createdBefore"
              },
              createdAfter: {
                shape: "S1g",
                location: "querystring",
                locationName: "createdAfter"
              },
              name: {
                location: "querystring",
                locationName: "name"
              },
              states: {
                location: "querystring",
                locationName: "states",
                type: "list",
                member: {}
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              jobRuns: {
                type: "list",
                member: {
                  shape: "S17"
                }
              },
              nextToken: {}
            }
          }
        },
        ListManagedEndpoints: {
          http: {
            method: "GET",
            requestUri: "/virtualclusters/{virtualClusterId}/endpoints"
          },
          input: {
            type: "structure",
            required: [
              "virtualClusterId"
            ],
            members: {
              virtualClusterId: {
                location: "uri",
                locationName: "virtualClusterId"
              },
              createdBefore: {
                shape: "S1g",
                location: "querystring",
                locationName: "createdBefore"
              },
              createdAfter: {
                shape: "S1g",
                location: "querystring",
                locationName: "createdAfter"
              },
              types: {
                location: "querystring",
                locationName: "types",
                type: "list",
                member: {}
              },
              states: {
                location: "querystring",
                locationName: "states",
                type: "list",
                member: {}
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              endpoints: {
                type: "list",
                member: {
                  shape: "S1l"
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sn"
              }
            }
          }
        },
        ListVirtualClusters: {
          http: {
            method: "GET",
            requestUri: "/virtualclusters"
          },
          input: {
            type: "structure",
            members: {
              containerProviderId: {
                location: "querystring",
                locationName: "containerProviderId"
              },
              containerProviderType: {
                location: "querystring",
                locationName: "containerProviderType"
              },
              createdAfter: {
                shape: "S1g",
                location: "querystring",
                locationName: "createdAfter"
              },
              createdBefore: {
                shape: "S1g",
                location: "querystring",
                locationName: "createdBefore"
              },
              states: {
                location: "querystring",
                locationName: "states",
                type: "list",
                member: {}
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              virtualClusters: {
                type: "list",
                member: {
                  shape: "S1q"
                }
              },
              nextToken: {}
            }
          }
        },
        StartJobRun: {
          http: {
            requestUri: "/virtualclusters/{virtualClusterId}/jobruns"
          },
          input: {
            type: "structure",
            required: [
              "virtualClusterId",
              "clientToken",
              "executionRoleArn",
              "releaseLabel",
              "jobDriver"
            ],
            members: {
              name: {},
              virtualClusterId: {
                location: "uri",
                locationName: "virtualClusterId"
              },
              clientToken: {
                idempotencyToken: true
              },
              executionRoleArn: {},
              releaseLabel: {},
              jobDriver: {
                shape: "S1a"
              },
              configurationOverrides: {
                shape: "Sa"
              },
              tags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              id: {},
              name: {},
              arn: {},
              virtualClusterId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sa: {
          type: "structure",
          members: {
            applicationConfiguration: {
              shape: "Sb"
            },
            monitoringConfiguration: {
              type: "structure",
              members: {
                persistentAppUI: {},
                cloudWatchMonitoringConfiguration: {
                  type: "structure",
                  required: [
                    "logGroupName"
                  ],
                  members: {
                    logGroupName: {},
                    logStreamNamePrefix: {}
                  }
                },
                s3MonitoringConfiguration: {
                  type: "structure",
                  required: [
                    "logUri"
                  ],
                  members: {
                    logUri: {}
                  }
                }
              }
            }
          }
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "classification"
            ],
            members: {
              classification: {},
              properties: {
                type: "map",
                key: {},
                value: {},
                sensitive: true
              },
              configurations: {
                shape: "Sb"
              }
            }
          }
        },
        Sn: {
          type: "map",
          key: {},
          value: {}
        },
        St: {
          type: "structure",
          required: [
            "type",
            "id"
          ],
          members: {
            type: {},
            id: {},
            info: {
              type: "structure",
              members: {
                eksInfo: {
                  type: "structure",
                  members: {
                    namespace: {}
                  }
                }
              },
              union: true
            }
          }
        },
        S17: {
          type: "structure",
          members: {
            id: {},
            name: {},
            virtualClusterId: {},
            arn: {},
            state: {},
            clientToken: {},
            executionRoleArn: {},
            releaseLabel: {},
            configurationOverrides: {
              shape: "Sa"
            },
            jobDriver: {
              shape: "S1a"
            },
            createdAt: {
              shape: "S1g"
            },
            createdBy: {},
            finishedAt: {
              shape: "S1g"
            },
            stateDetails: {},
            failureReason: {},
            tags: {
              shape: "Sn"
            }
          }
        },
        S1a: {
          type: "structure",
          members: {
            sparkSubmitJobDriver: {
              type: "structure",
              required: [
                "entryPoint"
              ],
              members: {
                entryPoint: {
                  type: "string",
                  sensitive: true
                },
                entryPointArguments: {
                  type: "list",
                  member: {
                    type: "string",
                    sensitive: true
                  }
                },
                sparkSubmitParameters: {
                  type: "string",
                  sensitive: true
                }
              }
            }
          }
        },
        S1g: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S1l: {
          type: "structure",
          members: {
            id: {},
            name: {},
            arn: {},
            virtualClusterId: {},
            type: {},
            state: {},
            releaseLabel: {},
            executionRoleArn: {},
            certificateArn: {},
            configurationOverrides: {
              shape: "Sa"
            },
            serverUrl: {},
            createdAt: {
              shape: "S1g"
            },
            securityGroup: {},
            subnetIds: {
              type: "list",
              member: {}
            },
            stateDetails: {},
            failureReason: {},
            tags: {
              shape: "Sn"
            }
          }
        },
        S1q: {
          type: "structure",
          members: {
            id: {},
            name: {},
            arn: {},
            state: {},
            containerProvider: {
              shape: "St"
            },
            createdAt: {
              shape: "S1g"
            },
            tags: {
              shape: "Sn"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/emr-containers-2020-10-01.paginators.json
var require_emr_containers_2020_10_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/emr-containers-2020-10-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListJobRuns: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "jobRuns"
        },
        ListManagedEndpoints: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "endpoints"
        },
        ListVirtualClusters: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "virtualClusters"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/emrcontainers.js
var require_emrcontainers = __commonJS({
  "node_modules/aws-sdk/clients/emrcontainers.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["emrcontainers"] = {};
    AWS3.EMRcontainers = Service.defineService("emrcontainers", ["2020-10-01"]);
    Object.defineProperty(apiLoader.services["emrcontainers"], "2020-10-01", {
      get: function get() {
        var model = require_emr_containers_2020_10_01_min();
        model.paginators = require_emr_containers_2020_10_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.EMRcontainers;
  }
});

// node_modules/aws-sdk/apis/healthlake-2017-07-01.min.json
var require_healthlake_2017_07_01_min = __commonJS({
  "node_modules/aws-sdk/apis/healthlake-2017-07-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-01",
        endpointPrefix: "healthlake",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "HealthLake",
        serviceFullName: "Amazon HealthLake",
        serviceId: "HealthLake",
        signatureVersion: "v4",
        signingName: "healthlake",
        targetPrefix: "HealthLake",
        uid: "healthlake-2017-07-01"
      },
      operations: {
        CreateFHIRDatastore: {
          input: {
            type: "structure",
            required: [
              "DatastoreTypeVersion"
            ],
            members: {
              DatastoreName: {},
              DatastoreTypeVersion: {},
              SseConfiguration: {
                shape: "S4"
              },
              PreloadDataConfig: {
                shape: "S8"
              },
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DatastoreId",
              "DatastoreArn",
              "DatastoreStatus",
              "DatastoreEndpoint"
            ],
            members: {
              DatastoreId: {},
              DatastoreArn: {},
              DatastoreStatus: {},
              DatastoreEndpoint: {}
            }
          }
        },
        DeleteFHIRDatastore: {
          input: {
            type: "structure",
            members: {
              DatastoreId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DatastoreId",
              "DatastoreArn",
              "DatastoreStatus",
              "DatastoreEndpoint"
            ],
            members: {
              DatastoreId: {},
              DatastoreArn: {},
              DatastoreStatus: {},
              DatastoreEndpoint: {}
            }
          }
        },
        DescribeFHIRDatastore: {
          input: {
            type: "structure",
            members: {
              DatastoreId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DatastoreProperties"
            ],
            members: {
              DatastoreProperties: {
                shape: "So"
              }
            }
          }
        },
        DescribeFHIRExportJob: {
          input: {
            type: "structure",
            required: [
              "DatastoreId",
              "JobId"
            ],
            members: {
              DatastoreId: {},
              JobId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ExportJobProperties"
            ],
            members: {
              ExportJobProperties: {
                shape: "Su"
              }
            }
          }
        },
        DescribeFHIRImportJob: {
          input: {
            type: "structure",
            required: [
              "DatastoreId",
              "JobId"
            ],
            members: {
              DatastoreId: {},
              JobId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ImportJobProperties"
            ],
            members: {
              ImportJobProperties: {
                shape: "S14"
              }
            }
          }
        },
        ListFHIRDatastores: {
          input: {
            type: "structure",
            members: {
              Filter: {
                type: "structure",
                members: {
                  DatastoreName: {},
                  DatastoreStatus: {},
                  CreatedBefore: {
                    type: "timestamp"
                  },
                  CreatedAfter: {
                    type: "timestamp"
                  }
                }
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DatastorePropertiesList"
            ],
            members: {
              DatastorePropertiesList: {
                type: "list",
                member: {
                  shape: "So"
                }
              },
              NextToken: {}
            }
          }
        },
        ListFHIRExportJobs: {
          input: {
            type: "structure",
            required: [
              "DatastoreId"
            ],
            members: {
              DatastoreId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              JobName: {},
              JobStatus: {},
              SubmittedBefore: {
                type: "timestamp"
              },
              SubmittedAfter: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ExportJobPropertiesList"
            ],
            members: {
              ExportJobPropertiesList: {
                type: "list",
                member: {
                  shape: "Su"
                }
              },
              NextToken: {}
            }
          }
        },
        ListFHIRImportJobs: {
          input: {
            type: "structure",
            required: [
              "DatastoreId"
            ],
            members: {
              DatastoreId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              JobName: {},
              JobStatus: {},
              SubmittedBefore: {
                type: "timestamp"
              },
              SubmittedAfter: {
                type: "timestamp"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ImportJobPropertiesList"
            ],
            members: {
              ImportJobPropertiesList: {
                type: "list",
                member: {
                  shape: "S14"
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sb"
              }
            }
          }
        },
        StartFHIRExportJob: {
          input: {
            type: "structure",
            required: [
              "OutputDataConfig",
              "DatastoreId",
              "DataAccessRoleArn",
              "ClientToken"
            ],
            members: {
              JobName: {},
              OutputDataConfig: {
                shape: "Sx"
              },
              DatastoreId: {},
              DataAccessRoleArn: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobId",
              "JobStatus"
            ],
            members: {
              JobId: {},
              JobStatus: {},
              DatastoreId: {}
            }
          }
        },
        StartFHIRImportJob: {
          input: {
            type: "structure",
            required: [
              "InputDataConfig",
              "JobOutputDataConfig",
              "DatastoreId",
              "DataAccessRoleArn",
              "ClientToken"
            ],
            members: {
              JobName: {},
              InputDataConfig: {
                shape: "S15"
              },
              JobOutputDataConfig: {
                shape: "Sx"
              },
              DatastoreId: {},
              DataAccessRoleArn: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "JobId",
              "JobStatus"
            ],
            members: {
              JobId: {},
              JobStatus: {},
              DatastoreId: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "Sb"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "KmsEncryptionConfig"
          ],
          members: {
            KmsEncryptionConfig: {
              type: "structure",
              required: [
                "CmkType"
              ],
              members: {
                CmkType: {},
                KmsKeyId: {}
              }
            }
          }
        },
        S8: {
          type: "structure",
          required: [
            "PreloadDataType"
          ],
          members: {
            PreloadDataType: {}
          }
        },
        Sb: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        So: {
          type: "structure",
          required: [
            "DatastoreId",
            "DatastoreArn",
            "DatastoreStatus",
            "DatastoreTypeVersion",
            "DatastoreEndpoint"
          ],
          members: {
            DatastoreId: {},
            DatastoreArn: {},
            DatastoreName: {},
            DatastoreStatus: {},
            CreatedAt: {
              type: "timestamp"
            },
            DatastoreTypeVersion: {},
            DatastoreEndpoint: {},
            SseConfiguration: {
              shape: "S4"
            },
            PreloadDataConfig: {
              shape: "S8"
            }
          }
        },
        Su: {
          type: "structure",
          required: [
            "JobId",
            "JobStatus",
            "SubmitTime",
            "DatastoreId",
            "OutputDataConfig"
          ],
          members: {
            JobId: {},
            JobName: {},
            JobStatus: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            DatastoreId: {},
            OutputDataConfig: {
              shape: "Sx"
            },
            DataAccessRoleArn: {},
            Message: {}
          }
        },
        Sx: {
          type: "structure",
          members: {
            S3Configuration: {
              type: "structure",
              required: [
                "S3Uri",
                "KmsKeyId"
              ],
              members: {
                S3Uri: {},
                KmsKeyId: {}
              }
            }
          },
          union: true
        },
        S14: {
          type: "structure",
          required: [
            "JobId",
            "JobStatus",
            "SubmitTime",
            "DatastoreId",
            "InputDataConfig"
          ],
          members: {
            JobId: {},
            JobName: {},
            JobStatus: {},
            SubmitTime: {
              type: "timestamp"
            },
            EndTime: {
              type: "timestamp"
            },
            DatastoreId: {},
            InputDataConfig: {
              shape: "S15"
            },
            JobOutputDataConfig: {
              shape: "Sx"
            },
            DataAccessRoleArn: {},
            Message: {}
          }
        },
        S15: {
          type: "structure",
          members: {
            S3Uri: {}
          },
          union: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/healthlake-2017-07-01.paginators.json
var require_healthlake_2017_07_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/healthlake-2017-07-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListFHIRDatastores: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListFHIRExportJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListFHIRImportJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/healthlake.js
var require_healthlake = __commonJS({
  "node_modules/aws-sdk/clients/healthlake.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["healthlake"] = {};
    AWS3.HealthLake = Service.defineService("healthlake", ["2017-07-01"]);
    Object.defineProperty(apiLoader.services["healthlake"], "2017-07-01", {
      get: function get() {
        var model = require_healthlake_2017_07_01_min();
        model.paginators = require_healthlake_2017_07_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.HealthLake;
  }
});

// node_modules/aws-sdk/apis/sagemaker-edge-2020-09-23.min.json
var require_sagemaker_edge_2020_09_23_min = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-edge-2020-09-23.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-09-23",
        endpointPrefix: "edge.sagemaker",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Sagemaker Edge Manager",
        serviceId: "Sagemaker Edge",
        signatureVersion: "v4",
        signingName: "sagemaker",
        uid: "sagemaker-edge-2020-09-23"
      },
      operations: {
        GetDeviceRegistration: {
          http: {
            requestUri: "/GetDeviceRegistration"
          },
          input: {
            type: "structure",
            required: [
              "DeviceName",
              "DeviceFleetName"
            ],
            members: {
              DeviceName: {},
              DeviceFleetName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DeviceRegistration: {},
              CacheTTL: {}
            }
          }
        },
        SendHeartbeat: {
          http: {
            requestUri: "/SendHeartbeat"
          },
          input: {
            type: "structure",
            required: [
              "AgentVersion",
              "DeviceName",
              "DeviceFleetName"
            ],
            members: {
              AgentMetrics: {
                shape: "S8"
              },
              Models: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ModelName: {},
                    ModelVersion: {},
                    LatestSampleTime: {
                      type: "timestamp"
                    },
                    LatestInference: {
                      type: "timestamp"
                    },
                    ModelMetrics: {
                      shape: "S8"
                    }
                  }
                }
              },
              AgentVersion: {},
              DeviceName: {},
              DeviceFleetName: {}
            }
          }
        }
      },
      shapes: {
        S8: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Dimension: {},
              MetricName: {},
              Value: {
                type: "double"
              },
              Timestamp: {
                type: "timestamp"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/sagemaker-edge-2020-09-23.paginators.json
var require_sagemaker_edge_2020_09_23_paginators = __commonJS({
  "node_modules/aws-sdk/apis/sagemaker-edge-2020-09-23.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/sagemakeredge.js
var require_sagemakeredge = __commonJS({
  "node_modules/aws-sdk/clients/sagemakeredge.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["sagemakeredge"] = {};
    AWS3.SagemakerEdge = Service.defineService("sagemakeredge", ["2020-09-23"]);
    Object.defineProperty(apiLoader.services["sagemakeredge"], "2020-09-23", {
      get: function get() {
        var model = require_sagemaker_edge_2020_09_23_min();
        model.paginators = require_sagemaker_edge_2020_09_23_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SagemakerEdge;
  }
});

// node_modules/aws-sdk/apis/amp-2020-08-01.min.json
var require_amp_2020_08_01_min = __commonJS({
  "node_modules/aws-sdk/apis/amp-2020-08-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-08-01",
        endpointPrefix: "aps",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Prometheus Service",
        serviceId: "amp",
        signatureVersion: "v4",
        signingName: "aps",
        uid: "amp-2020-08-01"
      },
      operations: {
        CreateAlertManagerDefinition: {
          http: {
            requestUri: "/workspaces/{workspaceId}/alertmanager/definition",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "data",
              "workspaceId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              data: {
                type: "blob"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "status"
            ],
            members: {
              status: {
                shape: "S6"
              }
            }
          },
          idempotent: true
        },
        CreateRuleGroupsNamespace: {
          http: {
            requestUri: "/workspaces/{workspaceId}/rulegroupsnamespaces",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "data",
              "name",
              "workspaceId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              data: {
                type: "blob"
              },
              name: {},
              tags: {
                shape: "Sc"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "name",
              "status"
            ],
            members: {
              arn: {},
              name: {},
              status: {
                shape: "Sh"
              },
              tags: {
                shape: "Sc"
              }
            }
          },
          idempotent: true
        },
        CreateWorkspace: {
          http: {
            requestUri: "/workspaces",
            responseCode: 202
          },
          input: {
            type: "structure",
            members: {
              alias: {},
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "status",
              "workspaceId"
            ],
            members: {
              arn: {},
              status: {
                shape: "Sn"
              },
              tags: {
                shape: "Sc"
              },
              workspaceId: {}
            }
          },
          idempotent: true
        },
        DeleteAlertManagerDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/workspaces/{workspaceId}/alertmanager/definition",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          idempotent: true
        },
        DeleteRuleGroupsNamespace: {
          http: {
            method: "DELETE",
            requestUri: "/workspaces/{workspaceId}/rulegroupsnamespaces/{name}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "name",
              "workspaceId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              },
              name: {
                location: "uri",
                locationName: "name"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          idempotent: true
        },
        DeleteWorkspace: {
          http: {
            method: "DELETE",
            requestUri: "/workspaces/{workspaceId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          idempotent: true
        },
        DescribeAlertManagerDefinition: {
          http: {
            method: "GET",
            requestUri: "/workspaces/{workspaceId}/alertmanager/definition",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "alertManagerDefinition"
            ],
            members: {
              alertManagerDefinition: {
                type: "structure",
                required: [
                  "createdAt",
                  "data",
                  "modifiedAt",
                  "status"
                ],
                members: {
                  createdAt: {
                    type: "timestamp"
                  },
                  data: {
                    type: "blob"
                  },
                  modifiedAt: {
                    type: "timestamp"
                  },
                  status: {
                    shape: "S6"
                  }
                }
              }
            }
          }
        },
        DescribeRuleGroupsNamespace: {
          http: {
            method: "GET",
            requestUri: "/workspaces/{workspaceId}/rulegroupsnamespaces/{name}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "workspaceId"
            ],
            members: {
              name: {
                location: "uri",
                locationName: "name"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ruleGroupsNamespace"
            ],
            members: {
              ruleGroupsNamespace: {
                type: "structure",
                required: [
                  "arn",
                  "createdAt",
                  "data",
                  "modifiedAt",
                  "name",
                  "status"
                ],
                members: {
                  arn: {},
                  createdAt: {
                    type: "timestamp"
                  },
                  data: {
                    type: "blob"
                  },
                  modifiedAt: {
                    type: "timestamp"
                  },
                  name: {},
                  status: {
                    shape: "Sh"
                  },
                  tags: {
                    shape: "Sc"
                  }
                }
              }
            }
          }
        },
        DescribeWorkspace: {
          http: {
            method: "GET",
            requestUri: "/workspaces/{workspaceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspace"
            ],
            members: {
              workspace: {
                type: "structure",
                required: [
                  "arn",
                  "createdAt",
                  "status",
                  "workspaceId"
                ],
                members: {
                  alias: {},
                  arn: {},
                  createdAt: {
                    type: "timestamp"
                  },
                  prometheusEndpoint: {},
                  status: {
                    shape: "Sn"
                  },
                  tags: {
                    shape: "Sc"
                  },
                  workspaceId: {}
                }
              }
            }
          }
        },
        ListRuleGroupsNamespaces: {
          http: {
            method: "GET",
            requestUri: "/workspaces/{workspaceId}/rulegroupsnamespaces",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              name: {
                location: "querystring",
                locationName: "name"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ruleGroupsNamespaces"
            ],
            members: {
              nextToken: {},
              ruleGroupsNamespaces: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "modifiedAt",
                    "name",
                    "status"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    modifiedAt: {
                      type: "timestamp"
                    },
                    name: {},
                    status: {
                      shape: "Sh"
                    },
                    tags: {
                      shape: "Sc"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sc"
              }
            }
          }
        },
        ListWorkspaces: {
          http: {
            method: "GET",
            requestUri: "/workspaces",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              alias: {
                location: "querystring",
                locationName: "alias"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspaces"
            ],
            members: {
              nextToken: {},
              workspaces: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "status",
                    "workspaceId"
                  ],
                  members: {
                    alias: {},
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    status: {
                      shape: "Sn"
                    },
                    tags: {
                      shape: "Sc"
                    },
                    workspaceId: {}
                  }
                }
              }
            }
          }
        },
        PutAlertManagerDefinition: {
          http: {
            method: "PUT",
            requestUri: "/workspaces/{workspaceId}/alertmanager/definition",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "data",
              "workspaceId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              data: {
                type: "blob"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "status"
            ],
            members: {
              status: {
                shape: "S6"
              }
            }
          },
          idempotent: true
        },
        PutRuleGroupsNamespace: {
          http: {
            method: "PUT",
            requestUri: "/workspaces/{workspaceId}/rulegroupsnamespaces/{name}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "data",
              "name",
              "workspaceId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              data: {
                type: "blob"
              },
              name: {
                location: "uri",
                locationName: "name"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "name",
              "status"
            ],
            members: {
              arn: {},
              name: {},
              status: {
                shape: "Sh"
              },
              tags: {
                shape: "Sc"
              }
            }
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateWorkspaceAlias: {
          http: {
            requestUri: "/workspaces/{workspaceId}/alias",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              alias: {},
              clientToken: {
                idempotencyToken: true
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S6: {
          type: "structure",
          required: [
            "statusCode"
          ],
          members: {
            statusCode: {},
            statusReason: {}
          }
        },
        Sc: {
          type: "map",
          key: {},
          value: {}
        },
        Sh: {
          type: "structure",
          required: [
            "statusCode"
          ],
          members: {
            statusCode: {},
            statusReason: {}
          }
        },
        Sn: {
          type: "structure",
          required: [
            "statusCode"
          ],
          members: {
            statusCode: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/amp-2020-08-01.paginators.json
var require_amp_2020_08_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/amp-2020-08-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListRuleGroupsNamespaces: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "ruleGroupsNamespaces"
        },
        ListWorkspaces: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "workspaces"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/amp-2020-08-01.waiters2.json
var require_amp_2020_08_01_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/amp-2020-08-01.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        WorkspaceActive: {
          description: "Wait until a workspace reaches ACTIVE status",
          delay: 2,
          maxAttempts: 60,
          operation: "DescribeWorkspace",
          acceptors: [{
            matcher: "path",
            argument: "workspace.status.statusCode",
            state: "success",
            expected: "ACTIVE"
          }, {
            matcher: "path",
            argument: "workspace.status.statusCode",
            state: "retry",
            expected: "UPDATING"
          }, {
            matcher: "path",
            argument: "workspace.status.statusCode",
            state: "retry",
            expected: "CREATING"
          }]
        },
        WorkspaceDeleted: {
          description: "Wait until a workspace reaches DELETED status",
          delay: 2,
          maxAttempts: 60,
          operation: "DescribeWorkspace",
          acceptors: [{
            matcher: "error",
            state: "success",
            expected: "ResourceNotFoundException"
          }, {
            matcher: "path",
            argument: "workspace.status.statusCode",
            state: "retry",
            expected: "DELETING"
          }]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/amp.js
var require_amp = __commonJS({
  "node_modules/aws-sdk/clients/amp.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["amp"] = {};
    AWS3.Amp = Service.defineService("amp", ["2020-08-01"]);
    Object.defineProperty(apiLoader.services["amp"], "2020-08-01", {
      get: function get() {
        var model = require_amp_2020_08_01_min();
        model.paginators = require_amp_2020_08_01_paginators().pagination;
        model.waiters = require_amp_2020_08_01_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Amp;
  }
});

// node_modules/aws-sdk/apis/greengrassv2-2020-11-30.min.json
var require_greengrassv2_2020_11_30_min = __commonJS({
  "node_modules/aws-sdk/apis/greengrassv2-2020-11-30.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-11-30",
        endpointPrefix: "greengrass",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "AWS GreengrassV2",
        serviceFullName: "AWS IoT Greengrass V2",
        serviceId: "GreengrassV2",
        signatureVersion: "v4",
        uid: "greengrassv2-2020-11-30"
      },
      operations: {
        BatchAssociateClientDeviceWithCoreDevice: {
          http: {
            requestUri: "/greengrass/v2/coreDevices/{coreDeviceThingName}/associateClientDevices",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "coreDeviceThingName"
            ],
            members: {
              entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "thingName"
                  ],
                  members: {
                    thingName: {}
                  }
                }
              },
              coreDeviceThingName: {
                location: "uri",
                locationName: "coreDeviceThingName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errorEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    thingName: {},
                    code: {},
                    message: {}
                  }
                }
              }
            }
          }
        },
        BatchDisassociateClientDeviceFromCoreDevice: {
          http: {
            requestUri: "/greengrass/v2/coreDevices/{coreDeviceThingName}/disassociateClientDevices",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "coreDeviceThingName"
            ],
            members: {
              entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "thingName"
                  ],
                  members: {
                    thingName: {}
                  }
                }
              },
              coreDeviceThingName: {
                location: "uri",
                locationName: "coreDeviceThingName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errorEntries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    thingName: {},
                    code: {},
                    message: {}
                  }
                }
              }
            }
          }
        },
        CancelDeployment: {
          http: {
            requestUri: "/greengrass/v2/deployments/{deploymentId}/cancel"
          },
          input: {
            type: "structure",
            required: [
              "deploymentId"
            ],
            members: {
              deploymentId: {
                location: "uri",
                locationName: "deploymentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              message: {}
            }
          }
        },
        CreateComponentVersion: {
          http: {
            requestUri: "/greengrass/v2/createComponentVersion",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              inlineRecipe: {
                type: "blob"
              },
              lambdaFunction: {
                type: "structure",
                required: [
                  "lambdaArn"
                ],
                members: {
                  lambdaArn: {},
                  componentName: {},
                  componentVersion: {},
                  componentPlatforms: {
                    shape: "Sn"
                  },
                  componentDependencies: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        versionRequirement: {},
                        dependencyType: {}
                      }
                    }
                  },
                  componentLambdaParameters: {
                    type: "structure",
                    members: {
                      eventSources: {
                        type: "list",
                        member: {
                          type: "structure",
                          required: [
                            "topic",
                            "type"
                          ],
                          members: {
                            topic: {},
                            type: {}
                          }
                        }
                      },
                      maxQueueSize: {
                        type: "integer"
                      },
                      maxInstancesCount: {
                        type: "integer"
                      },
                      maxIdleTimeInSeconds: {
                        type: "integer"
                      },
                      timeoutInSeconds: {
                        type: "integer"
                      },
                      statusTimeoutInSeconds: {
                        type: "integer"
                      },
                      pinned: {
                        type: "boolean"
                      },
                      inputPayloadEncodingType: {},
                      execArgs: {
                        type: "list",
                        member: {}
                      },
                      environmentVariables: {
                        type: "map",
                        key: {},
                        value: {}
                      },
                      linuxProcessParams: {
                        type: "structure",
                        members: {
                          isolationMode: {},
                          containerParams: {
                            type: "structure",
                            members: {
                              memorySizeInKB: {
                                type: "integer"
                              },
                              mountROSysfs: {
                                type: "boolean"
                              },
                              volumes: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  required: [
                                    "sourcePath",
                                    "destinationPath"
                                  ],
                                  members: {
                                    sourcePath: {},
                                    destinationPath: {},
                                    permission: {},
                                    addGroupOwner: {
                                      type: "boolean"
                                    }
                                  }
                                }
                              },
                              devices: {
                                type: "list",
                                member: {
                                  type: "structure",
                                  required: [
                                    "path"
                                  ],
                                  members: {
                                    path: {},
                                    permission: {},
                                    addGroupOwner: {
                                      type: "boolean"
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              tags: {
                shape: "S1e"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "componentName",
              "componentVersion",
              "creationTimestamp",
              "status"
            ],
            members: {
              arn: {},
              componentName: {},
              componentVersion: {},
              creationTimestamp: {
                type: "timestamp"
              },
              status: {
                shape: "S1l"
              }
            }
          }
        },
        CreateDeployment: {
          http: {
            requestUri: "/greengrass/v2/deployments",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "targetArn"
            ],
            members: {
              targetArn: {},
              deploymentName: {},
              components: {
                shape: "S1q"
              },
              iotJobConfiguration: {
                shape: "S20"
              },
              deploymentPolicies: {
                shape: "S2h"
              },
              tags: {
                shape: "S1e"
              },
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deploymentId: {},
              iotJobId: {},
              iotJobArn: {}
            }
          }
        },
        DeleteComponent: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/v2/components/{arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {
                location: "uri",
                locationName: "arn"
              }
            }
          }
        },
        DeleteCoreDevice: {
          http: {
            method: "DELETE",
            requestUri: "/greengrass/v2/coreDevices/{coreDeviceThingName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "coreDeviceThingName"
            ],
            members: {
              coreDeviceThingName: {
                location: "uri",
                locationName: "coreDeviceThingName"
              }
            }
          }
        },
        DescribeComponent: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/components/{arn}/metadata"
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {
                location: "uri",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              arn: {},
              componentName: {},
              componentVersion: {},
              creationTimestamp: {
                type: "timestamp"
              },
              publisher: {},
              description: {},
              status: {
                shape: "S1l"
              },
              platforms: {
                shape: "Sn"
              },
              tags: {
                shape: "S1e"
              }
            }
          }
        },
        GetComponent: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/components/{arn}"
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              recipeOutputFormat: {
                location: "querystring",
                locationName: "recipeOutputFormat"
              },
              arn: {
                location: "uri",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "recipeOutputFormat",
              "recipe"
            ],
            members: {
              recipeOutputFormat: {},
              recipe: {
                type: "blob"
              },
              tags: {
                shape: "S1e"
              }
            }
          }
        },
        GetComponentVersionArtifact: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/components/{arn}/artifacts/{artifactName+}"
          },
          input: {
            type: "structure",
            required: [
              "arn",
              "artifactName"
            ],
            members: {
              arn: {
                location: "uri",
                locationName: "arn"
              },
              artifactName: {
                location: "uri",
                locationName: "artifactName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "preSignedUrl"
            ],
            members: {
              preSignedUrl: {}
            }
          }
        },
        GetCoreDevice: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/coreDevices/{coreDeviceThingName}"
          },
          input: {
            type: "structure",
            required: [
              "coreDeviceThingName"
            ],
            members: {
              coreDeviceThingName: {
                location: "uri",
                locationName: "coreDeviceThingName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              coreDeviceThingName: {},
              coreVersion: {},
              platform: {},
              architecture: {},
              status: {},
              lastStatusUpdateTimestamp: {
                type: "timestamp"
              },
              tags: {
                shape: "S1e"
              }
            }
          }
        },
        GetDeployment: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/deployments/{deploymentId}"
          },
          input: {
            type: "structure",
            required: [
              "deploymentId"
            ],
            members: {
              deploymentId: {
                location: "uri",
                locationName: "deploymentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              targetArn: {},
              revisionId: {},
              deploymentId: {},
              deploymentName: {},
              deploymentStatus: {},
              iotJobId: {},
              iotJobArn: {},
              components: {
                shape: "S1q"
              },
              deploymentPolicies: {
                shape: "S2h"
              },
              iotJobConfiguration: {
                shape: "S20"
              },
              creationTimestamp: {
                type: "timestamp"
              },
              isLatestForTarget: {
                type: "boolean"
              },
              tags: {
                shape: "S1e"
              }
            }
          }
        },
        ListClientDevicesAssociatedWithCoreDevice: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/coreDevices/{coreDeviceThingName}/associatedClientDevices",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "coreDeviceThingName"
            ],
            members: {
              coreDeviceThingName: {
                location: "uri",
                locationName: "coreDeviceThingName"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              associatedClientDevices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    thingName: {},
                    associationTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListComponentVersions: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/components/{arn}/versions"
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {
                location: "uri",
                locationName: "arn"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              componentVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    componentName: {},
                    componentVersion: {},
                    arn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListComponents: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/components"
          },
          input: {
            type: "structure",
            members: {
              scope: {
                location: "querystring",
                locationName: "scope"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              components: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    componentName: {},
                    latestVersion: {
                      type: "structure",
                      members: {
                        arn: {},
                        componentVersion: {},
                        creationTimestamp: {
                          type: "timestamp"
                        },
                        description: {},
                        publisher: {},
                        platforms: {
                          shape: "Sn"
                        }
                      }
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListCoreDevices: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/coreDevices"
          },
          input: {
            type: "structure",
            members: {
              thingGroupArn: {
                location: "querystring",
                locationName: "thingGroupArn"
              },
              status: {
                location: "querystring",
                locationName: "status"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              coreDevices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    coreDeviceThingName: {},
                    status: {},
                    lastStatusUpdateTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListDeployments: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/deployments"
          },
          input: {
            type: "structure",
            members: {
              targetArn: {
                location: "querystring",
                locationName: "targetArn"
              },
              historyFilter: {
                location: "querystring",
                locationName: "historyFilter"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              deployments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    targetArn: {},
                    revisionId: {},
                    deploymentId: {},
                    deploymentName: {},
                    creationTimestamp: {
                      type: "timestamp"
                    },
                    deploymentStatus: {},
                    isLatestForTarget: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListEffectiveDeployments: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/coreDevices/{coreDeviceThingName}/effectiveDeployments"
          },
          input: {
            type: "structure",
            required: [
              "coreDeviceThingName"
            ],
            members: {
              coreDeviceThingName: {
                location: "uri",
                locationName: "coreDeviceThingName"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              effectiveDeployments: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "deploymentId",
                    "deploymentName",
                    "targetArn",
                    "coreDeviceExecutionStatus",
                    "creationTimestamp",
                    "modifiedTimestamp"
                  ],
                  members: {
                    deploymentId: {},
                    deploymentName: {},
                    iotJobId: {},
                    iotJobArn: {},
                    description: {},
                    targetArn: {},
                    coreDeviceExecutionStatus: {},
                    reason: {},
                    creationTimestamp: {
                      type: "timestamp"
                    },
                    modifiedTimestamp: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListInstalledComponents: {
          http: {
            method: "GET",
            requestUri: "/greengrass/v2/coreDevices/{coreDeviceThingName}/installedComponents"
          },
          input: {
            type: "structure",
            required: [
              "coreDeviceThingName"
            ],
            members: {
              coreDeviceThingName: {
                location: "uri",
                locationName: "coreDeviceThingName"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              installedComponents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    componentName: {},
                    componentVersion: {},
                    lifecycleState: {},
                    lifecycleStateDetails: {},
                    isRoot: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S1e"
              }
            }
          }
        },
        ResolveComponentCandidates: {
          http: {
            requestUri: "/greengrass/v2/resolveComponentCandidates"
          },
          input: {
            type: "structure",
            required: [
              "platform",
              "componentCandidates"
            ],
            members: {
              platform: {
                shape: "So"
              },
              componentCandidates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    componentName: {},
                    componentVersion: {},
                    versionRequirements: {
                      type: "map",
                      key: {},
                      value: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resolvedComponentVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    arn: {},
                    componentName: {},
                    componentVersion: {},
                    recipe: {
                      type: "blob"
                    }
                  }
                }
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S1e"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sn: {
          type: "list",
          member: {
            shape: "So"
          }
        },
        So: {
          type: "structure",
          members: {
            name: {},
            attributes: {
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        S1e: {
          type: "map",
          key: {},
          value: {}
        },
        S1l: {
          type: "structure",
          members: {
            componentState: {},
            message: {},
            errors: {
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        S1q: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              componentVersion: {},
              configurationUpdate: {
                type: "structure",
                members: {
                  merge: {},
                  reset: {
                    type: "list",
                    member: {}
                  }
                }
              },
              runWith: {
                type: "structure",
                members: {
                  posixUser: {},
                  systemResourceLimits: {
                    type: "structure",
                    members: {
                      memory: {
                        type: "long"
                      },
                      cpus: {
                        type: "double"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S20: {
          type: "structure",
          members: {
            jobExecutionsRolloutConfig: {
              type: "structure",
              members: {
                exponentialRate: {
                  type: "structure",
                  required: [
                    "baseRatePerMinute",
                    "incrementFactor",
                    "rateIncreaseCriteria"
                  ],
                  members: {
                    baseRatePerMinute: {
                      type: "integer"
                    },
                    incrementFactor: {
                      type: "double"
                    },
                    rateIncreaseCriteria: {
                      type: "structure",
                      members: {
                        numberOfNotifiedThings: {
                          type: "integer"
                        },
                        numberOfSucceededThings: {
                          type: "integer"
                        }
                      }
                    }
                  }
                },
                maximumPerMinute: {
                  type: "integer"
                }
              }
            },
            abortConfig: {
              type: "structure",
              required: [
                "criteriaList"
              ],
              members: {
                criteriaList: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "failureType",
                      "action",
                      "thresholdPercentage",
                      "minNumberOfExecutedThings"
                    ],
                    members: {
                      failureType: {},
                      action: {},
                      thresholdPercentage: {
                        type: "double"
                      },
                      minNumberOfExecutedThings: {
                        type: "integer"
                      }
                    }
                  }
                }
              }
            },
            timeoutConfig: {
              type: "structure",
              members: {
                inProgressTimeoutInMinutes: {
                  type: "long"
                }
              }
            }
          }
        },
        S2h: {
          type: "structure",
          members: {
            failureHandlingPolicy: {},
            componentUpdatePolicy: {
              type: "structure",
              members: {
                timeoutInSeconds: {
                  type: "integer"
                },
                action: {}
              }
            },
            configurationValidationPolicy: {
              type: "structure",
              members: {
                timeoutInSeconds: {
                  type: "integer"
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/greengrassv2-2020-11-30.paginators.json
var require_greengrassv2_2020_11_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/greengrassv2-2020-11-30.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListClientDevicesAssociatedWithCoreDevice: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "associatedClientDevices"
        },
        ListComponentVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "componentVersions"
        },
        ListComponents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "components"
        },
        ListCoreDevices: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "coreDevices"
        },
        ListDeployments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "deployments"
        },
        ListEffectiveDeployments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "effectiveDeployments"
        },
        ListInstalledComponents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "installedComponents"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/greengrassv2.js
var require_greengrassv2 = __commonJS({
  "node_modules/aws-sdk/clients/greengrassv2.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["greengrassv2"] = {};
    AWS3.GreengrassV2 = Service.defineService("greengrassv2", ["2020-11-30"]);
    Object.defineProperty(apiLoader.services["greengrassv2"], "2020-11-30", {
      get: function get() {
        var model = require_greengrassv2_2020_11_30_min();
        model.paginators = require_greengrassv2_2020_11_30_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.GreengrassV2;
  }
});

// node_modules/aws-sdk/apis/iotdeviceadvisor-2020-09-18.min.json
var require_iotdeviceadvisor_2020_09_18_min = __commonJS({
  "node_modules/aws-sdk/apis/iotdeviceadvisor-2020-09-18.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-09-18",
        endpointPrefix: "api.iotdeviceadvisor",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "AWSIoTDeviceAdvisor",
        serviceFullName: "AWS IoT Core Device Advisor",
        serviceId: "IotDeviceAdvisor",
        signatureVersion: "v4",
        signingName: "iotdeviceadvisor",
        uid: "iotdeviceadvisor-2020-09-18"
      },
      operations: {
        CreateSuiteDefinition: {
          http: {
            requestUri: "/suiteDefinitions"
          },
          input: {
            type: "structure",
            members: {
              suiteDefinitionConfiguration: {
                shape: "S2"
              },
              tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              suiteDefinitionId: {},
              suiteDefinitionArn: {},
              suiteDefinitionName: {},
              createdAt: {
                type: "timestamp"
              }
            }
          }
        },
        DeleteSuiteDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/suiteDefinitions/{suiteDefinitionId}"
          },
          input: {
            type: "structure",
            required: [
              "suiteDefinitionId"
            ],
            members: {
              suiteDefinitionId: {
                location: "uri",
                locationName: "suiteDefinitionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetSuiteDefinition: {
          http: {
            method: "GET",
            requestUri: "/suiteDefinitions/{suiteDefinitionId}"
          },
          input: {
            type: "structure",
            required: [
              "suiteDefinitionId"
            ],
            members: {
              suiteDefinitionId: {
                location: "uri",
                locationName: "suiteDefinitionId"
              },
              suiteDefinitionVersion: {
                location: "querystring",
                locationName: "suiteDefinitionVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              suiteDefinitionId: {},
              suiteDefinitionArn: {},
              suiteDefinitionVersion: {},
              latestVersion: {},
              suiteDefinitionConfiguration: {
                shape: "S2"
              },
              createdAt: {
                type: "timestamp"
              },
              lastModifiedAt: {
                type: "timestamp"
              },
              tags: {
                shape: "S9"
              }
            }
          }
        },
        GetSuiteRun: {
          http: {
            method: "GET",
            requestUri: "/suiteDefinitions/{suiteDefinitionId}/suiteRuns/{suiteRunId}"
          },
          input: {
            type: "structure",
            required: [
              "suiteDefinitionId",
              "suiteRunId"
            ],
            members: {
              suiteDefinitionId: {
                location: "uri",
                locationName: "suiteDefinitionId"
              },
              suiteRunId: {
                location: "uri",
                locationName: "suiteRunId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              suiteDefinitionId: {},
              suiteDefinitionVersion: {},
              suiteRunId: {},
              suiteRunArn: {},
              suiteRunConfiguration: {
                shape: "Sm"
              },
              testResult: {
                type: "structure",
                members: {
                  groups: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        groupId: {},
                        groupName: {},
                        tests: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              testCaseRunId: {},
                              testCaseDefinitionId: {},
                              testCaseDefinitionName: {},
                              status: {},
                              startTime: {
                                type: "timestamp"
                              },
                              endTime: {
                                type: "timestamp"
                              },
                              logUrl: {},
                              warnings: {},
                              failure: {}
                            }
                          }
                        }
                      }
                    }
                  }
                }
              },
              startTime: {
                type: "timestamp"
              },
              endTime: {
                type: "timestamp"
              },
              status: {},
              errorReason: {},
              tags: {
                shape: "S9"
              }
            }
          }
        },
        GetSuiteRunReport: {
          http: {
            method: "GET",
            requestUri: "/suiteDefinitions/{suiteDefinitionId}/suiteRuns/{suiteRunId}/report"
          },
          input: {
            type: "structure",
            required: [
              "suiteDefinitionId",
              "suiteRunId"
            ],
            members: {
              suiteDefinitionId: {
                location: "uri",
                locationName: "suiteDefinitionId"
              },
              suiteRunId: {
                location: "uri",
                locationName: "suiteRunId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              qualificationReportDownloadUrl: {}
            }
          }
        },
        ListSuiteDefinitions: {
          http: {
            method: "GET",
            requestUri: "/suiteDefinitions"
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              suiteDefinitionInformationList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    suiteDefinitionId: {},
                    suiteDefinitionName: {},
                    defaultDevices: {
                      shape: "S4"
                    },
                    intendedForQualification: {
                      type: "boolean"
                    },
                    createdAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSuiteRuns: {
          http: {
            method: "GET",
            requestUri: "/suiteRuns"
          },
          input: {
            type: "structure",
            members: {
              suiteDefinitionId: {
                location: "querystring",
                locationName: "suiteDefinitionId"
              },
              suiteDefinitionVersion: {
                location: "querystring",
                locationName: "suiteDefinitionVersion"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              suiteRunsList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    suiteDefinitionId: {},
                    suiteDefinitionVersion: {},
                    suiteDefinitionName: {},
                    suiteRunId: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    startedAt: {
                      type: "timestamp"
                    },
                    endAt: {
                      type: "timestamp"
                    },
                    status: {},
                    passed: {
                      type: "integer"
                    },
                    failed: {
                      type: "integer"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S9"
              }
            }
          }
        },
        StartSuiteRun: {
          http: {
            requestUri: "/suiteDefinitions/{suiteDefinitionId}/suiteRuns"
          },
          input: {
            type: "structure",
            required: [
              "suiteDefinitionId"
            ],
            members: {
              suiteDefinitionId: {
                location: "uri",
                locationName: "suiteDefinitionId"
              },
              suiteDefinitionVersion: {},
              suiteRunConfiguration: {
                shape: "Sm"
              },
              tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              suiteRunId: {},
              suiteRunArn: {},
              createdAt: {
                type: "timestamp"
              }
            }
          }
        },
        StopSuiteRun: {
          http: {
            requestUri: "/suiteDefinitions/{suiteDefinitionId}/suiteRuns/{suiteRunId}/stop"
          },
          input: {
            type: "structure",
            required: [
              "suiteDefinitionId",
              "suiteRunId"
            ],
            members: {
              suiteDefinitionId: {
                location: "uri",
                locationName: "suiteDefinitionId"
              },
              suiteRunId: {
                location: "uri",
                locationName: "suiteRunId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateSuiteDefinition: {
          http: {
            method: "PATCH",
            requestUri: "/suiteDefinitions/{suiteDefinitionId}"
          },
          input: {
            type: "structure",
            required: [
              "suiteDefinitionId"
            ],
            members: {
              suiteDefinitionId: {
                location: "uri",
                locationName: "suiteDefinitionId"
              },
              suiteDefinitionConfiguration: {
                shape: "S2"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              suiteDefinitionId: {},
              suiteDefinitionArn: {},
              suiteDefinitionName: {},
              suiteDefinitionVersion: {},
              createdAt: {
                type: "timestamp"
              },
              lastUpdatedAt: {
                type: "timestamp"
              }
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          members: {
            suiteDefinitionName: {},
            devices: {
              shape: "S4"
            },
            intendedForQualification: {
              type: "boolean"
            },
            rootGroup: {},
            devicePermissionRoleArn: {}
          }
        },
        S4: {
          type: "list",
          member: {
            shape: "S5"
          }
        },
        S5: {
          type: "structure",
          members: {
            thingArn: {},
            certificateArn: {}
          }
        },
        S9: {
          type: "map",
          key: {},
          value: {}
        },
        Sm: {
          type: "structure",
          members: {
            primaryDevice: {
              shape: "S5"
            },
            selectedTestList: {
              type: "list",
              member: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotdeviceadvisor-2020-09-18.paginators.json
var require_iotdeviceadvisor_2020_09_18_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iotdeviceadvisor-2020-09-18.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListSuiteDefinitions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListSuiteRuns: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iotdeviceadvisor.js
var require_iotdeviceadvisor = __commonJS({
  "node_modules/aws-sdk/clients/iotdeviceadvisor.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["iotdeviceadvisor"] = {};
    AWS3.IotDeviceAdvisor = Service.defineService("iotdeviceadvisor", ["2020-09-18"]);
    Object.defineProperty(apiLoader.services["iotdeviceadvisor"], "2020-09-18", {
      get: function get() {
        var model = require_iotdeviceadvisor_2020_09_18_min();
        model.paginators = require_iotdeviceadvisor_2020_09_18_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.IotDeviceAdvisor;
  }
});

// node_modules/aws-sdk/apis/iotfleethub-2020-11-03.min.json
var require_iotfleethub_2020_11_03_min = __commonJS({
  "node_modules/aws-sdk/apis/iotfleethub-2020-11-03.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-11-03",
        endpointPrefix: "api.fleethub.iot",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS IoT Fleet Hub",
        serviceId: "IoTFleetHub",
        signatureVersion: "v4",
        signingName: "iotfleethub",
        uid: "iotfleethub-2020-11-03"
      },
      operations: {
        CreateApplication: {
          http: {
            requestUri: "/applications",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "applicationName",
              "roleArn"
            ],
            members: {
              applicationName: {},
              applicationDescription: {},
              clientToken: {
                idempotencyToken: true
              },
              roleArn: {},
              tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "applicationId",
              "applicationArn"
            ],
            members: {
              applicationId: {},
              applicationArn: {}
            }
          }
        },
        DeleteApplication: {
          http: {
            method: "DELETE",
            requestUri: "/applications/{applicationId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              clientToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "clientToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeApplication: {
          http: {
            method: "GET",
            requestUri: "/applications/{applicationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "applicationId",
              "applicationArn",
              "applicationName",
              "applicationUrl",
              "applicationState",
              "applicationCreationDate",
              "applicationLastUpdateDate",
              "roleArn"
            ],
            members: {
              applicationId: {},
              applicationArn: {},
              applicationName: {},
              applicationDescription: {},
              applicationUrl: {},
              applicationState: {},
              applicationCreationDate: {
                type: "long"
              },
              applicationLastUpdateDate: {
                type: "long"
              },
              roleArn: {},
              ssoClientId: {},
              errorMessage: {},
              tags: {
                shape: "S6"
              }
            }
          }
        },
        ListApplications: {
          http: {
            method: "GET",
            requestUri: "/applications",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              applicationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "applicationId",
                    "applicationName",
                    "applicationUrl"
                  ],
                  members: {
                    applicationId: {},
                    applicationName: {},
                    applicationDescription: {},
                    applicationUrl: {},
                    applicationCreationDate: {
                      type: "long"
                    },
                    applicationLastUpdateDate: {
                      type: "long"
                    },
                    applicationState: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S6"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateApplication: {
          http: {
            method: "PATCH",
            requestUri: "/applications/{applicationId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "applicationId"
            ],
            members: {
              applicationId: {
                location: "uri",
                locationName: "applicationId"
              },
              applicationName: {},
              applicationDescription: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S6: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotfleethub-2020-11-03.paginators.json
var require_iotfleethub_2020_11_03_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iotfleethub-2020-11-03.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListApplications: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "applicationSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iotfleethub.js
var require_iotfleethub = __commonJS({
  "node_modules/aws-sdk/clients/iotfleethub.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["iotfleethub"] = {};
    AWS3.IoTFleetHub = Service.defineService("iotfleethub", ["2020-11-03"]);
    Object.defineProperty(apiLoader.services["iotfleethub"], "2020-11-03", {
      get: function get() {
        var model = require_iotfleethub_2020_11_03_min();
        model.paginators = require_iotfleethub_2020_11_03_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.IoTFleetHub;
  }
});

// node_modules/aws-sdk/apis/iotwireless-2020-11-22.min.json
var require_iotwireless_2020_11_22_min = __commonJS({
  "node_modules/aws-sdk/apis/iotwireless-2020-11-22.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-11-22",
        endpointPrefix: "api.iotwireless",
        protocol: "rest-json",
        serviceFullName: "AWS IoT Wireless",
        serviceId: "IoT Wireless",
        signatureVersion: "v4",
        signingName: "iotwireless",
        uid: "iotwireless-2020-11-22"
      },
      operations: {
        AssociateAwsAccountWithPartnerAccount: {
          http: {
            requestUri: "/partner-accounts"
          },
          input: {
            type: "structure",
            required: [
              "Sidewalk"
            ],
            members: {
              Sidewalk: {
                shape: "S2"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Sidewalk: {
                shape: "S2"
              },
              Arn: {}
            }
          }
        },
        AssociateWirelessDeviceWithThing: {
          http: {
            method: "PUT",
            requestUri: "/wireless-devices/{Id}/thing",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "ThingArn"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              ThingArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        AssociateWirelessGatewayWithCertificate: {
          http: {
            method: "PUT",
            requestUri: "/wireless-gateways/{Id}/certificate"
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "IotCertificateId"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              IotCertificateId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              IotCertificateId: {}
            }
          }
        },
        AssociateWirelessGatewayWithThing: {
          http: {
            method: "PUT",
            requestUri: "/wireless-gateways/{Id}/thing",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "ThingArn"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              ThingArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateDestination: {
          http: {
            requestUri: "/destinations",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "ExpressionType",
              "Expression",
              "RoleArn"
            ],
            members: {
              Name: {},
              ExpressionType: {},
              Expression: {},
              Description: {},
              RoleArn: {},
              Tags: {
                shape: "S6"
              },
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Name: {}
            }
          }
        },
        CreateDeviceProfile: {
          http: {
            requestUri: "/device-profiles",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Name: {},
              LoRaWAN: {
                shape: "Sw"
              },
              Tags: {
                shape: "S6"
              },
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {}
            }
          }
        },
        CreateServiceProfile: {
          http: {
            requestUri: "/service-profiles",
            responseCode: 201
          },
          input: {
            type: "structure",
            members: {
              Name: {},
              LoRaWAN: {
                type: "structure",
                members: {
                  AddGwMetadata: {
                    type: "boolean"
                  }
                }
              },
              Tags: {
                shape: "S6"
              },
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {}
            }
          }
        },
        CreateWirelessDevice: {
          http: {
            requestUri: "/wireless-devices",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Type",
              "DestinationName"
            ],
            members: {
              Type: {},
              Name: {},
              Description: {},
              DestinationName: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              LoRaWAN: {
                shape: "S1u"
              },
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {}
            }
          }
        },
        CreateWirelessGateway: {
          http: {
            requestUri: "/wireless-gateways",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "LoRaWAN"
            ],
            members: {
              Name: {},
              Description: {},
              LoRaWAN: {
                shape: "S2g"
              },
              Tags: {
                shape: "S6"
              },
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Id: {}
            }
          }
        },
        CreateWirelessGatewayTask: {
          http: {
            requestUri: "/wireless-gateways/{Id}/tasks",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "WirelessGatewayTaskDefinitionId"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              WirelessGatewayTaskDefinitionId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WirelessGatewayTaskDefinitionId: {},
              Status: {}
            }
          }
        },
        CreateWirelessGatewayTaskDefinition: {
          http: {
            requestUri: "/wireless-gateway-task-definitions",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AutoCreateTasks"
            ],
            members: {
              AutoCreateTasks: {
                type: "boolean"
              },
              Name: {},
              Update: {
                shape: "S2x"
              },
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Id: {},
              Arn: {}
            }
          }
        },
        DeleteDestination: {
          http: {
            method: "DELETE",
            requestUri: "/destinations/{Name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteDeviceProfile: {
          http: {
            method: "DELETE",
            requestUri: "/device-profiles/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteServiceProfile: {
          http: {
            method: "DELETE",
            requestUri: "/service-profiles/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWirelessDevice: {
          http: {
            method: "DELETE",
            requestUri: "/wireless-devices/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWirelessGateway: {
          http: {
            method: "DELETE",
            requestUri: "/wireless-gateways/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWirelessGatewayTask: {
          http: {
            method: "DELETE",
            requestUri: "/wireless-gateways/{Id}/tasks",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteWirelessGatewayTaskDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/wireless-gateway-task-definitions/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateAwsAccountFromPartnerAccount: {
          http: {
            method: "DELETE",
            requestUri: "/partner-accounts/{PartnerAccountId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "PartnerAccountId",
              "PartnerType"
            ],
            members: {
              PartnerAccountId: {
                location: "uri",
                locationName: "PartnerAccountId"
              },
              PartnerType: {
                location: "querystring",
                locationName: "partnerType"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateWirelessDeviceFromThing: {
          http: {
            method: "DELETE",
            requestUri: "/wireless-devices/{Id}/thing",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateWirelessGatewayFromCertificate: {
          http: {
            method: "DELETE",
            requestUri: "/wireless-gateways/{Id}/certificate",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DisassociateWirelessGatewayFromThing: {
          http: {
            method: "DELETE",
            requestUri: "/wireless-gateways/{Id}/thing",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetDestination: {
          http: {
            method: "GET",
            requestUri: "/destinations/{Name}"
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Name: {},
              Expression: {},
              ExpressionType: {},
              Description: {},
              RoleArn: {}
            }
          }
        },
        GetDeviceProfile: {
          http: {
            method: "GET",
            requestUri: "/device-profiles/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Name: {},
              Id: {},
              LoRaWAN: {
                shape: "Sw"
              }
            }
          }
        },
        GetLogLevelsByResourceTypes: {
          http: {
            method: "GET",
            requestUri: "/log-levels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              DefaultLogLevel: {},
              WirelessGatewayLogOptions: {
                shape: "S43"
              },
              WirelessDeviceLogOptions: {
                shape: "S49"
              }
            }
          }
        },
        GetPartnerAccount: {
          http: {
            method: "GET",
            requestUri: "/partner-accounts/{PartnerAccountId}"
          },
          input: {
            type: "structure",
            required: [
              "PartnerAccountId",
              "PartnerType"
            ],
            members: {
              PartnerAccountId: {
                location: "uri",
                locationName: "PartnerAccountId"
              },
              PartnerType: {
                location: "querystring",
                locationName: "partnerType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Sidewalk: {
                shape: "S4g"
              },
              AccountLinked: {
                type: "boolean"
              }
            }
          }
        },
        GetResourceLogLevel: {
          http: {
            method: "GET",
            requestUri: "/log-levels/{ResourceIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceIdentifier",
              "ResourceType"
            ],
            members: {
              ResourceIdentifier: {
                location: "uri",
                locationName: "ResourceIdentifier"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LogLevel: {}
            }
          }
        },
        GetServiceEndpoint: {
          http: {
            method: "GET",
            requestUri: "/service-endpoint"
          },
          input: {
            type: "structure",
            members: {
              ServiceType: {
                location: "querystring",
                locationName: "serviceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceType: {},
              ServiceEndpoint: {},
              ServerTrust: {}
            }
          }
        },
        GetServiceProfile: {
          http: {
            method: "GET",
            requestUri: "/service-profiles/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Arn: {},
              Name: {},
              Id: {},
              LoRaWAN: {
                type: "structure",
                members: {
                  UlRate: {
                    type: "integer"
                  },
                  UlBucketSize: {
                    type: "integer"
                  },
                  UlRatePolicy: {},
                  DlRate: {
                    type: "integer"
                  },
                  DlBucketSize: {
                    type: "integer"
                  },
                  DlRatePolicy: {},
                  AddGwMetadata: {
                    type: "boolean"
                  },
                  DevStatusReqFreq: {
                    type: "integer"
                  },
                  ReportDevStatusBattery: {
                    type: "boolean"
                  },
                  ReportDevStatusMargin: {
                    type: "boolean"
                  },
                  DrMin: {
                    type: "integer"
                  },
                  DrMax: {
                    type: "integer"
                  },
                  ChannelMask: {},
                  PrAllowed: {
                    type: "boolean"
                  },
                  HrAllowed: {
                    type: "boolean"
                  },
                  RaAllowed: {
                    type: "boolean"
                  },
                  NwkGeoLoc: {
                    type: "boolean"
                  },
                  TargetPer: {
                    type: "integer"
                  },
                  MinGwDiversity: {
                    type: "integer"
                  }
                }
              }
            }
          }
        },
        GetWirelessDevice: {
          http: {
            method: "GET",
            requestUri: "/wireless-devices/{Identifier}"
          },
          input: {
            type: "structure",
            required: [
              "Identifier",
              "IdentifierType"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "Identifier"
              },
              IdentifierType: {
                location: "querystring",
                locationName: "identifierType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Type: {},
              Name: {},
              Description: {},
              DestinationName: {},
              Id: {},
              Arn: {},
              ThingName: {},
              ThingArn: {},
              LoRaWAN: {
                shape: "S1u"
              },
              Sidewalk: {
                type: "structure",
                members: {
                  AmazonId: {},
                  SidewalkId: {},
                  SidewalkManufacturingSn: {},
                  DeviceCertificates: {
                    shape: "S5l"
                  }
                }
              }
            }
          }
        },
        GetWirelessDeviceStatistics: {
          http: {
            method: "GET",
            requestUri: "/wireless-devices/{Id}/statistics",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "WirelessDeviceId"
            ],
            members: {
              WirelessDeviceId: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WirelessDeviceId: {},
              LastUplinkReceivedAt: {},
              LoRaWAN: {
                type: "structure",
                members: {
                  DevEui: {},
                  FPort: {
                    type: "integer"
                  },
                  DataRate: {
                    type: "integer"
                  },
                  Frequency: {
                    type: "integer"
                  },
                  Timestamp: {},
                  Gateways: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        GatewayEui: {},
                        Snr: {
                          type: "double"
                        },
                        Rssi: {
                          type: "double"
                        }
                      }
                    }
                  }
                }
              },
              Sidewalk: {
                type: "structure",
                members: {
                  Rssi: {
                    type: "integer"
                  },
                  BatteryLevel: {},
                  Event: {},
                  DeviceState: {}
                }
              }
            }
          }
        },
        GetWirelessGateway: {
          http: {
            method: "GET",
            requestUri: "/wireless-gateways/{Identifier}"
          },
          input: {
            type: "structure",
            required: [
              "Identifier",
              "IdentifierType"
            ],
            members: {
              Identifier: {
                location: "uri",
                locationName: "Identifier"
              },
              IdentifierType: {
                location: "querystring",
                locationName: "identifierType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Name: {},
              Id: {},
              Description: {},
              LoRaWAN: {
                shape: "S2g"
              },
              Arn: {},
              ThingName: {},
              ThingArn: {}
            }
          }
        },
        GetWirelessGatewayCertificate: {
          http: {
            method: "GET",
            requestUri: "/wireless-gateways/{Id}/certificate"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              IotCertificateId: {},
              LoRaWANNetworkServerCertificateId: {}
            }
          }
        },
        GetWirelessGatewayFirmwareInformation: {
          http: {
            method: "GET",
            requestUri: "/wireless-gateways/{Id}/firmware-information"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LoRaWAN: {
                type: "structure",
                members: {
                  CurrentVersion: {
                    shape: "S32"
                  }
                }
              }
            }
          }
        },
        GetWirelessGatewayStatistics: {
          http: {
            method: "GET",
            requestUri: "/wireless-gateways/{Id}/statistics",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "WirelessGatewayId"
            ],
            members: {
              WirelessGatewayId: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WirelessGatewayId: {},
              LastUplinkReceivedAt: {},
              ConnectionStatus: {}
            }
          }
        },
        GetWirelessGatewayTask: {
          http: {
            method: "GET",
            requestUri: "/wireless-gateways/{Id}/tasks"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WirelessGatewayId: {},
              WirelessGatewayTaskDefinitionId: {},
              LastUplinkReceivedAt: {},
              TaskCreatedAt: {},
              Status: {}
            }
          }
        },
        GetWirelessGatewayTaskDefinition: {
          http: {
            method: "GET",
            requestUri: "/wireless-gateway-task-definitions/{Id}"
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AutoCreateTasks: {
                type: "boolean"
              },
              Name: {},
              Update: {
                shape: "S2x"
              },
              Arn: {}
            }
          }
        },
        ListDestinations: {
          http: {
            method: "GET",
            requestUri: "/destinations"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              DestinationList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {},
                    ExpressionType: {},
                    Expression: {},
                    Description: {},
                    RoleArn: {}
                  }
                }
              }
            }
          }
        },
        ListDeviceProfiles: {
          http: {
            method: "GET",
            requestUri: "/device-profiles"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              DeviceProfileList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {},
                    Id: {}
                  }
                }
              }
            }
          }
        },
        ListPartnerAccounts: {
          http: {
            method: "GET",
            requestUri: "/partner-accounts"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Sidewalk: {
                type: "list",
                member: {
                  shape: "S4g"
                }
              }
            }
          }
        },
        ListServiceProfiles: {
          http: {
            method: "GET",
            requestUri: "/service-profiles"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ServiceProfileList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Name: {},
                    Id: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags"
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S6"
              }
            }
          }
        },
        ListWirelessDevices: {
          http: {
            method: "GET",
            requestUri: "/wireless-devices"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              DestinationName: {
                location: "querystring",
                locationName: "destinationName"
              },
              DeviceProfileId: {
                location: "querystring",
                locationName: "deviceProfileId"
              },
              ServiceProfileId: {
                location: "querystring",
                locationName: "serviceProfileId"
              },
              WirelessDeviceType: {
                location: "querystring",
                locationName: "wirelessDeviceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              WirelessDeviceList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Id: {},
                    Type: {},
                    Name: {},
                    DestinationName: {},
                    LastUplinkReceivedAt: {},
                    LoRaWAN: {
                      type: "structure",
                      members: {
                        DevEui: {}
                      }
                    },
                    Sidewalk: {
                      type: "structure",
                      members: {
                        AmazonId: {},
                        SidewalkId: {},
                        SidewalkManufacturingSn: {},
                        DeviceCertificates: {
                          shape: "S5l"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListWirelessGatewayTaskDefinitions: {
          http: {
            method: "GET",
            requestUri: "/wireless-gateway-task-definitions"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              TaskDefinitionType: {
                location: "querystring",
                locationName: "taskDefinitionType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              TaskDefinitions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    LoRaWAN: {
                      type: "structure",
                      members: {
                        CurrentVersion: {
                          shape: "S32"
                        },
                        UpdateVersion: {
                          shape: "S32"
                        }
                      }
                    },
                    Arn: {}
                  }
                }
              }
            }
          }
        },
        ListWirelessGateways: {
          http: {
            method: "GET",
            requestUri: "/wireless-gateways"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              WirelessGatewayList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    Id: {},
                    Name: {},
                    Description: {},
                    LoRaWAN: {
                      shape: "S2g"
                    },
                    LastUplinkReceivedAt: {}
                  }
                }
              }
            }
          }
        },
        PutResourceLogLevel: {
          http: {
            method: "PUT",
            requestUri: "/log-levels/{ResourceIdentifier}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceIdentifier",
              "ResourceType",
              "LogLevel"
            ],
            members: {
              ResourceIdentifier: {
                location: "uri",
                locationName: "ResourceIdentifier"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              },
              LogLevel: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ResetAllResourceLogLevels: {
          http: {
            method: "DELETE",
            requestUri: "/log-levels",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ResetResourceLogLevel: {
          http: {
            method: "DELETE",
            requestUri: "/log-levels/{ResourceIdentifier}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceIdentifier",
              "ResourceType"
            ],
            members: {
              ResourceIdentifier: {
                location: "uri",
                locationName: "ResourceIdentifier"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SendDataToWirelessDevice: {
          http: {
            requestUri: "/wireless-devices/{Id}/data",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "Id",
              "TransmitMode",
              "PayloadData"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              TransmitMode: {
                type: "integer"
              },
              PayloadData: {},
              WirelessMetadata: {
                type: "structure",
                members: {
                  LoRaWAN: {
                    type: "structure",
                    members: {
                      FPort: {
                        type: "integer"
                      }
                    }
                  },
                  Sidewalk: {
                    type: "structure",
                    members: {
                      Seq: {
                        type: "integer"
                      },
                      MessageType: {}
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MessageId: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "S6"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TestWirelessDevice: {
          http: {
            requestUri: "/wireless-devices/{Id}/test",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Result: {}
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDestination: {
          http: {
            method: "PATCH",
            requestUri: "/destinations/{Name}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Name"
            ],
            members: {
              Name: {
                location: "uri",
                locationName: "Name"
              },
              ExpressionType: {},
              Expression: {},
              Description: {},
              RoleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLogLevelsByResourceTypes: {
          http: {
            requestUri: "/log-levels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              DefaultLogLevel: {},
              WirelessDeviceLogOptions: {
                shape: "S49"
              },
              WirelessGatewayLogOptions: {
                shape: "S43"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdatePartnerAccount: {
          http: {
            method: "PATCH",
            requestUri: "/partner-accounts/{PartnerAccountId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Sidewalk",
              "PartnerAccountId",
              "PartnerType"
            ],
            members: {
              Sidewalk: {
                type: "structure",
                members: {
                  AppServerPrivateKey: {
                    shape: "S4"
                  }
                }
              },
              PartnerAccountId: {
                location: "uri",
                locationName: "PartnerAccountId"
              },
              PartnerType: {
                location: "querystring",
                locationName: "partnerType"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateWirelessDevice: {
          http: {
            method: "PATCH",
            requestUri: "/wireless-devices/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              DestinationName: {},
              Name: {},
              Description: {},
              LoRaWAN: {
                type: "structure",
                members: {
                  DeviceProfileId: {},
                  ServiceProfileId: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateWirelessGateway: {
          http: {
            method: "PATCH",
            requestUri: "/wireless-gateways/{Id}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "Id"
            ],
            members: {
              Id: {
                location: "uri",
                locationName: "Id"
              },
              Name: {},
              Description: {},
              JoinEuiFilters: {
                shape: "S2i"
              },
              NetIdFilters: {
                shape: "S2k"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        S2: {
          type: "structure",
          members: {
            AmazonId: {},
            AppServerPrivateKey: {
              shape: "S4"
            }
          }
        },
        S4: {
          type: "string",
          sensitive: true
        },
        S6: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sw: {
          type: "structure",
          members: {
            SupportsClassB: {
              type: "boolean"
            },
            ClassBTimeout: {
              type: "integer"
            },
            PingSlotPeriod: {
              type: "integer"
            },
            PingSlotDr: {
              type: "integer"
            },
            PingSlotFreq: {
              type: "integer"
            },
            SupportsClassC: {
              type: "boolean"
            },
            ClassCTimeout: {
              type: "integer"
            },
            MacVersion: {},
            RegParamsRevision: {},
            RxDelay1: {
              type: "integer"
            },
            RxDrOffset1: {
              type: "integer"
            },
            RxDataRate2: {
              type: "integer"
            },
            RxFreq2: {
              type: "integer"
            },
            FactoryPresetFreqsList: {
              type: "list",
              member: {
                type: "integer"
              }
            },
            MaxEirp: {
              type: "integer"
            },
            MaxDutyCycle: {
              type: "integer"
            },
            RfRegion: {},
            SupportsJoin: {
              type: "boolean"
            },
            Supports32BitFCnt: {
              type: "boolean"
            }
          }
        },
        S1u: {
          type: "structure",
          members: {
            DevEui: {},
            DeviceProfileId: {},
            ServiceProfileId: {},
            OtaaV1_1: {
              type: "structure",
              members: {
                AppKey: {},
                NwkKey: {},
                JoinEui: {}
              }
            },
            OtaaV1_0_x: {
              type: "structure",
              members: {
                AppKey: {},
                AppEui: {}
              }
            },
            AbpV1_1: {
              type: "structure",
              members: {
                DevAddr: {},
                SessionKeys: {
                  type: "structure",
                  members: {
                    FNwkSIntKey: {},
                    SNwkSIntKey: {},
                    NwkSEncKey: {},
                    AppSKey: {}
                  }
                }
              }
            },
            AbpV1_0_x: {
              type: "structure",
              members: {
                DevAddr: {},
                SessionKeys: {
                  type: "structure",
                  members: {
                    NwkSKey: {},
                    AppSKey: {}
                  }
                }
              }
            }
          }
        },
        S2g: {
          type: "structure",
          members: {
            GatewayEui: {},
            RfRegion: {},
            JoinEuiFilters: {
              shape: "S2i"
            },
            NetIdFilters: {
              shape: "S2k"
            },
            SubBands: {
              type: "list",
              member: {
                type: "integer"
              }
            }
          }
        },
        S2i: {
          type: "list",
          member: {
            type: "list",
            member: {}
          }
        },
        S2k: {
          type: "list",
          member: {}
        },
        S2x: {
          type: "structure",
          members: {
            UpdateDataSource: {},
            UpdateDataRole: {},
            LoRaWAN: {
              type: "structure",
              members: {
                UpdateSignature: {},
                SigKeyCrc: {
                  type: "long"
                },
                CurrentVersion: {
                  shape: "S32"
                },
                UpdateVersion: {
                  shape: "S32"
                }
              }
            }
          }
        },
        S32: {
          type: "structure",
          members: {
            PackageVersion: {},
            Model: {},
            Station: {}
          }
        },
        S43: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Type",
              "LogLevel"
            ],
            members: {
              Type: {},
              LogLevel: {},
              Events: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Event",
                    "LogLevel"
                  ],
                  members: {
                    Event: {},
                    LogLevel: {}
                  }
                }
              }
            }
          }
        },
        S49: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Type",
              "LogLevel"
            ],
            members: {
              Type: {},
              LogLevel: {},
              Events: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Event",
                    "LogLevel"
                  ],
                  members: {
                    Event: {},
                    LogLevel: {}
                  }
                }
              }
            }
          }
        },
        S4g: {
          type: "structure",
          members: {
            AmazonId: {},
            Fingerprint: {
              type: "string",
              sensitive: true
            },
            Arn: {}
          }
        },
        S5l: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "SigningAlg",
              "Value"
            ],
            members: {
              SigningAlg: {},
              Value: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/iotwireless-2020-11-22.paginators.json
var require_iotwireless_2020_11_22_paginators = __commonJS({
  "node_modules/aws-sdk/apis/iotwireless-2020-11-22.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListDestinations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDeviceProfiles: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListServiceProfiles: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListWirelessDevices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListWirelessGateways: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/iotwireless.js
var require_iotwireless = __commonJS({
  "node_modules/aws-sdk/clients/iotwireless.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["iotwireless"] = {};
    AWS3.IoTWireless = Service.defineService("iotwireless", ["2020-11-22"]);
    Object.defineProperty(apiLoader.services["iotwireless"], "2020-11-22", {
      get: function get() {
        var model = require_iotwireless_2020_11_22_min();
        model.paginators = require_iotwireless_2020_11_22_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.IoTWireless;
  }
});

// node_modules/aws-sdk/apis/location-2020-11-19.min.json
var require_location_2020_11_19_min = __commonJS({
  "node_modules/aws-sdk/apis/location-2020-11-19.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-11-19",
        endpointPrefix: "geo",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Location Service",
        serviceId: "Location",
        signatureVersion: "v4",
        signingName: "geo",
        uid: "location-2020-11-19"
      },
      operations: {
        AssociateTrackerConsumer: {
          http: {
            requestUri: "/tracking/v0/trackers/{TrackerName}/consumers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ConsumerArn",
              "TrackerName"
            ],
            members: {
              ConsumerArn: {},
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "tracking."
          }
        },
        BatchDeleteDevicePositionHistory: {
          http: {
            requestUri: "/tracking/v0/trackers/{TrackerName}/delete-positions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DeviceIds",
              "TrackerName"
            ],
            members: {
              DeviceIds: {
                type: "list",
                member: {}
              },
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Errors"
            ],
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DeviceId",
                    "Error"
                  ],
                  members: {
                    DeviceId: {},
                    Error: {
                      shape: "Sb"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "tracking."
          }
        },
        BatchDeleteGeofence: {
          http: {
            requestUri: "/geofencing/v0/collections/{CollectionName}/delete-geofences",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CollectionName",
              "GeofenceIds"
            ],
            members: {
              CollectionName: {
                location: "uri",
                locationName: "CollectionName"
              },
              GeofenceIds: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Errors"
            ],
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Error",
                    "GeofenceId"
                  ],
                  members: {
                    Error: {
                      shape: "Sb"
                    },
                    GeofenceId: {}
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "geofencing."
          }
        },
        BatchEvaluateGeofences: {
          http: {
            requestUri: "/geofencing/v0/collections/{CollectionName}/positions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CollectionName",
              "DevicePositionUpdates"
            ],
            members: {
              CollectionName: {
                location: "uri",
                locationName: "CollectionName"
              },
              DevicePositionUpdates: {
                type: "list",
                member: {
                  shape: "Sl"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Errors"
            ],
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DeviceId",
                    "Error",
                    "SampleTime"
                  ],
                  members: {
                    DeviceId: {},
                    Error: {
                      shape: "Sb"
                    },
                    SampleTime: {
                      shape: "So"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "geofencing."
          }
        },
        BatchGetDevicePosition: {
          http: {
            requestUri: "/tracking/v0/trackers/{TrackerName}/get-positions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DeviceIds",
              "TrackerName"
            ],
            members: {
              DeviceIds: {
                type: "list",
                member: {}
              },
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DevicePositions",
              "Errors"
            ],
            members: {
              DevicePositions: {
                shape: "Sw"
              },
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DeviceId",
                    "Error"
                  ],
                  members: {
                    DeviceId: {},
                    Error: {
                      shape: "Sb"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "tracking."
          }
        },
        BatchPutGeofence: {
          http: {
            requestUri: "/geofencing/v0/collections/{CollectionName}/put-geofences",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CollectionName",
              "Entries"
            ],
            members: {
              CollectionName: {
                location: "uri",
                locationName: "CollectionName"
              },
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "GeofenceId",
                    "Geometry"
                  ],
                  members: {
                    GeofenceId: {},
                    Geometry: {
                      shape: "S13"
                    }
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Errors",
              "Successes"
            ],
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Error",
                    "GeofenceId"
                  ],
                  members: {
                    Error: {
                      shape: "Sb"
                    },
                    GeofenceId: {}
                  }
                }
              },
              Successes: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CreateTime",
                    "GeofenceId",
                    "UpdateTime"
                  ],
                  members: {
                    CreateTime: {
                      shape: "So"
                    },
                    GeofenceId: {},
                    UpdateTime: {
                      shape: "So"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "geofencing."
          }
        },
        BatchUpdateDevicePosition: {
          http: {
            requestUri: "/tracking/v0/trackers/{TrackerName}/positions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TrackerName",
              "Updates"
            ],
            members: {
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              },
              Updates: {
                type: "list",
                member: {
                  shape: "Sl"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Errors"
            ],
            members: {
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DeviceId",
                    "Error",
                    "SampleTime"
                  ],
                  members: {
                    DeviceId: {},
                    Error: {
                      shape: "Sb"
                    },
                    SampleTime: {
                      shape: "So"
                    }
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "tracking."
          }
        },
        CalculateRoute: {
          http: {
            requestUri: "/routes/v0/calculators/{CalculatorName}/calculate/route",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CalculatorName",
              "DeparturePosition",
              "DestinationPosition"
            ],
            members: {
              CalculatorName: {
                location: "uri",
                locationName: "CalculatorName"
              },
              CarModeOptions: {
                type: "structure",
                members: {
                  AvoidFerries: {
                    type: "boolean"
                  },
                  AvoidTolls: {
                    type: "boolean"
                  }
                }
              },
              DepartNow: {
                type: "boolean"
              },
              DeparturePosition: {
                shape: "Sm"
              },
              DepartureTime: {
                shape: "So"
              },
              DestinationPosition: {
                shape: "Sm"
              },
              DistanceUnit: {},
              IncludeLegGeometry: {
                type: "boolean"
              },
              TravelMode: {},
              TruckModeOptions: {
                type: "structure",
                members: {
                  AvoidFerries: {
                    type: "boolean"
                  },
                  AvoidTolls: {
                    type: "boolean"
                  },
                  Dimensions: {
                    type: "structure",
                    members: {
                      Height: {
                        type: "double"
                      },
                      Length: {
                        type: "double"
                      },
                      Unit: {},
                      Width: {
                        type: "double"
                      }
                    }
                  },
                  Weight: {
                    type: "structure",
                    members: {
                      Total: {
                        type: "double"
                      },
                      Unit: {}
                    }
                  }
                }
              },
              WaypointPositions: {
                type: "list",
                member: {
                  shape: "Sm"
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Legs",
              "Summary"
            ],
            members: {
              Legs: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Distance",
                    "DurationSeconds",
                    "EndPosition",
                    "StartPosition",
                    "Steps"
                  ],
                  members: {
                    Distance: {
                      type: "double"
                    },
                    DurationSeconds: {
                      type: "double"
                    },
                    EndPosition: {
                      shape: "Sm"
                    },
                    Geometry: {
                      type: "structure",
                      members: {
                        LineString: {
                          type: "list",
                          member: {
                            shape: "Sm"
                          }
                        }
                      }
                    },
                    StartPosition: {
                      shape: "Sm"
                    },
                    Steps: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "Distance",
                          "DurationSeconds",
                          "EndPosition",
                          "StartPosition"
                        ],
                        members: {
                          Distance: {
                            type: "double"
                          },
                          DurationSeconds: {
                            type: "double"
                          },
                          EndPosition: {
                            shape: "Sm"
                          },
                          GeometryOffset: {
                            type: "integer"
                          },
                          StartPosition: {
                            shape: "Sm"
                          }
                        }
                      }
                    }
                  }
                }
              },
              Summary: {
                type: "structure",
                required: [
                  "DataSource",
                  "Distance",
                  "DistanceUnit",
                  "DurationSeconds",
                  "RouteBBox"
                ],
                members: {
                  DataSource: {},
                  Distance: {
                    type: "double"
                  },
                  DistanceUnit: {},
                  DurationSeconds: {
                    type: "double"
                  },
                  RouteBBox: {
                    shape: "S2a"
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "routes."
          }
        },
        CreateGeofenceCollection: {
          http: {
            requestUri: "/geofencing/v0/collections",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CollectionName",
              "PricingPlan"
            ],
            members: {
              CollectionName: {},
              Description: {},
              KmsKeyId: {},
              PricingPlan: {},
              PricingPlanDataSource: {},
              Tags: {
                shape: "S2f"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CollectionArn",
              "CollectionName",
              "CreateTime"
            ],
            members: {
              CollectionArn: {},
              CollectionName: {},
              CreateTime: {
                shape: "So"
              }
            }
          },
          endpoint: {
            hostPrefix: "geofencing."
          },
          idempotent: true
        },
        CreateMap: {
          http: {
            requestUri: "/maps/v0/maps",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "Configuration",
              "MapName",
              "PricingPlan"
            ],
            members: {
              Configuration: {
                shape: "S2k"
              },
              Description: {},
              MapName: {},
              PricingPlan: {},
              Tags: {
                shape: "S2f"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreateTime",
              "MapArn",
              "MapName"
            ],
            members: {
              CreateTime: {
                shape: "So"
              },
              MapArn: {},
              MapName: {}
            }
          },
          endpoint: {
            hostPrefix: "maps."
          },
          idempotent: true
        },
        CreatePlaceIndex: {
          http: {
            requestUri: "/places/v0/indexes",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DataSource",
              "IndexName",
              "PricingPlan"
            ],
            members: {
              DataSource: {},
              DataSourceConfiguration: {
                shape: "S2o"
              },
              Description: {},
              IndexName: {},
              PricingPlan: {},
              Tags: {
                shape: "S2f"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreateTime",
              "IndexArn",
              "IndexName"
            ],
            members: {
              CreateTime: {
                shape: "So"
              },
              IndexArn: {},
              IndexName: {}
            }
          },
          endpoint: {
            hostPrefix: "places."
          },
          idempotent: true
        },
        CreateRouteCalculator: {
          http: {
            requestUri: "/routes/v0/calculators",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CalculatorName",
              "DataSource",
              "PricingPlan"
            ],
            members: {
              CalculatorName: {},
              DataSource: {},
              Description: {},
              PricingPlan: {},
              Tags: {
                shape: "S2f"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CalculatorArn",
              "CalculatorName",
              "CreateTime"
            ],
            members: {
              CalculatorArn: {},
              CalculatorName: {},
              CreateTime: {
                shape: "So"
              }
            }
          },
          endpoint: {
            hostPrefix: "routes."
          },
          idempotent: true
        },
        CreateTracker: {
          http: {
            requestUri: "/tracking/v0/trackers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "PricingPlan",
              "TrackerName"
            ],
            members: {
              Description: {},
              KmsKeyId: {},
              PositionFiltering: {},
              PricingPlan: {},
              PricingPlanDataSource: {},
              Tags: {
                shape: "S2f"
              },
              TrackerName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "CreateTime",
              "TrackerArn",
              "TrackerName"
            ],
            members: {
              CreateTime: {
                shape: "So"
              },
              TrackerArn: {},
              TrackerName: {}
            }
          },
          endpoint: {
            hostPrefix: "tracking."
          },
          idempotent: true
        },
        DeleteGeofenceCollection: {
          http: {
            method: "DELETE",
            requestUri: "/geofencing/v0/collections/{CollectionName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CollectionName"
            ],
            members: {
              CollectionName: {
                location: "uri",
                locationName: "CollectionName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "geofencing."
          },
          idempotent: true
        },
        DeleteMap: {
          http: {
            method: "DELETE",
            requestUri: "/maps/v0/maps/{MapName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MapName"
            ],
            members: {
              MapName: {
                location: "uri",
                locationName: "MapName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "maps."
          },
          idempotent: true
        },
        DeletePlaceIndex: {
          http: {
            method: "DELETE",
            requestUri: "/places/v0/indexes/{IndexName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IndexName"
            ],
            members: {
              IndexName: {
                location: "uri",
                locationName: "IndexName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "places."
          },
          idempotent: true
        },
        DeleteRouteCalculator: {
          http: {
            method: "DELETE",
            requestUri: "/routes/v0/calculators/{CalculatorName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CalculatorName"
            ],
            members: {
              CalculatorName: {
                location: "uri",
                locationName: "CalculatorName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "routes."
          },
          idempotent: true
        },
        DeleteTracker: {
          http: {
            method: "DELETE",
            requestUri: "/tracking/v0/trackers/{TrackerName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TrackerName"
            ],
            members: {
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "tracking."
          },
          idempotent: true
        },
        DescribeGeofenceCollection: {
          http: {
            method: "GET",
            requestUri: "/geofencing/v0/collections/{CollectionName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CollectionName"
            ],
            members: {
              CollectionName: {
                location: "uri",
                locationName: "CollectionName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CollectionArn",
              "CollectionName",
              "CreateTime",
              "Description",
              "PricingPlan",
              "UpdateTime"
            ],
            members: {
              CollectionArn: {},
              CollectionName: {},
              CreateTime: {
                shape: "So"
              },
              Description: {},
              KmsKeyId: {},
              PricingPlan: {},
              PricingPlanDataSource: {},
              Tags: {
                shape: "S2f"
              },
              UpdateTime: {
                shape: "So"
              }
            }
          },
          endpoint: {
            hostPrefix: "geofencing."
          }
        },
        DescribeMap: {
          http: {
            method: "GET",
            requestUri: "/maps/v0/maps/{MapName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MapName"
            ],
            members: {
              MapName: {
                location: "uri",
                locationName: "MapName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Configuration",
              "CreateTime",
              "DataSource",
              "Description",
              "MapArn",
              "MapName",
              "PricingPlan",
              "UpdateTime"
            ],
            members: {
              Configuration: {
                shape: "S2k"
              },
              CreateTime: {
                shape: "So"
              },
              DataSource: {},
              Description: {},
              MapArn: {},
              MapName: {},
              PricingPlan: {},
              Tags: {
                shape: "S2f"
              },
              UpdateTime: {
                shape: "So"
              }
            }
          },
          endpoint: {
            hostPrefix: "maps."
          }
        },
        DescribePlaceIndex: {
          http: {
            method: "GET",
            requestUri: "/places/v0/indexes/{IndexName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IndexName"
            ],
            members: {
              IndexName: {
                location: "uri",
                locationName: "IndexName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreateTime",
              "DataSource",
              "DataSourceConfiguration",
              "Description",
              "IndexArn",
              "IndexName",
              "PricingPlan",
              "UpdateTime"
            ],
            members: {
              CreateTime: {
                shape: "So"
              },
              DataSource: {},
              DataSourceConfiguration: {
                shape: "S2o"
              },
              Description: {},
              IndexArn: {},
              IndexName: {},
              PricingPlan: {},
              Tags: {
                shape: "S2f"
              },
              UpdateTime: {
                shape: "So"
              }
            }
          },
          endpoint: {
            hostPrefix: "places."
          }
        },
        DescribeRouteCalculator: {
          http: {
            method: "GET",
            requestUri: "/routes/v0/calculators/{CalculatorName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CalculatorName"
            ],
            members: {
              CalculatorName: {
                location: "uri",
                locationName: "CalculatorName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CalculatorArn",
              "CalculatorName",
              "CreateTime",
              "DataSource",
              "Description",
              "PricingPlan",
              "UpdateTime"
            ],
            members: {
              CalculatorArn: {},
              CalculatorName: {},
              CreateTime: {
                shape: "So"
              },
              DataSource: {},
              Description: {},
              PricingPlan: {},
              Tags: {
                shape: "S2f"
              },
              UpdateTime: {
                shape: "So"
              }
            }
          },
          endpoint: {
            hostPrefix: "routes."
          }
        },
        DescribeTracker: {
          http: {
            method: "GET",
            requestUri: "/tracking/v0/trackers/{TrackerName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TrackerName"
            ],
            members: {
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreateTime",
              "Description",
              "PricingPlan",
              "TrackerArn",
              "TrackerName",
              "UpdateTime"
            ],
            members: {
              CreateTime: {
                shape: "So"
              },
              Description: {},
              KmsKeyId: {},
              PositionFiltering: {},
              PricingPlan: {},
              PricingPlanDataSource: {},
              Tags: {
                shape: "S2f"
              },
              TrackerArn: {},
              TrackerName: {},
              UpdateTime: {
                shape: "So"
              }
            }
          },
          endpoint: {
            hostPrefix: "tracking."
          }
        },
        DisassociateTrackerConsumer: {
          http: {
            method: "DELETE",
            requestUri: "/tracking/v0/trackers/{TrackerName}/consumers/{ConsumerArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ConsumerArn",
              "TrackerName"
            ],
            members: {
              ConsumerArn: {
                location: "uri",
                locationName: "ConsumerArn"
              },
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "tracking."
          }
        },
        GetDevicePosition: {
          http: {
            method: "GET",
            requestUri: "/tracking/v0/trackers/{TrackerName}/devices/{DeviceId}/positions/latest",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DeviceId",
              "TrackerName"
            ],
            members: {
              DeviceId: {
                location: "uri",
                locationName: "DeviceId"
              },
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Position",
              "ReceivedTime",
              "SampleTime"
            ],
            members: {
              DeviceId: {},
              Position: {
                shape: "Sm"
              },
              ReceivedTime: {
                shape: "So"
              },
              SampleTime: {
                shape: "So"
              }
            }
          },
          endpoint: {
            hostPrefix: "tracking."
          }
        },
        GetDevicePositionHistory: {
          http: {
            requestUri: "/tracking/v0/trackers/{TrackerName}/devices/{DeviceId}/list-positions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "DeviceId",
              "TrackerName"
            ],
            members: {
              DeviceId: {
                location: "uri",
                locationName: "DeviceId"
              },
              EndTimeExclusive: {
                shape: "So"
              },
              NextToken: {},
              StartTimeInclusive: {
                shape: "So"
              },
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DevicePositions"
            ],
            members: {
              DevicePositions: {
                shape: "Sw"
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "tracking."
          }
        },
        GetGeofence: {
          http: {
            method: "GET",
            requestUri: "/geofencing/v0/collections/{CollectionName}/geofences/{GeofenceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CollectionName",
              "GeofenceId"
            ],
            members: {
              CollectionName: {
                location: "uri",
                locationName: "CollectionName"
              },
              GeofenceId: {
                location: "uri",
                locationName: "GeofenceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreateTime",
              "GeofenceId",
              "Geometry",
              "Status",
              "UpdateTime"
            ],
            members: {
              CreateTime: {
                shape: "So"
              },
              GeofenceId: {},
              Geometry: {
                shape: "S13"
              },
              Status: {},
              UpdateTime: {
                shape: "So"
              }
            }
          },
          endpoint: {
            hostPrefix: "geofencing."
          }
        },
        GetMapGlyphs: {
          http: {
            method: "GET",
            requestUri: "/maps/v0/maps/{MapName}/glyphs/{FontStack}/{FontUnicodeRange}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FontStack",
              "FontUnicodeRange",
              "MapName"
            ],
            members: {
              FontStack: {
                location: "uri",
                locationName: "FontStack"
              },
              FontUnicodeRange: {
                location: "uri",
                locationName: "FontUnicodeRange"
              },
              MapName: {
                location: "uri",
                locationName: "MapName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Blob: {
                type: "blob"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              }
            },
            payload: "Blob"
          },
          endpoint: {
            hostPrefix: "maps."
          }
        },
        GetMapSprites: {
          http: {
            method: "GET",
            requestUri: "/maps/v0/maps/{MapName}/sprites/{FileName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "FileName",
              "MapName"
            ],
            members: {
              FileName: {
                location: "uri",
                locationName: "FileName"
              },
              MapName: {
                location: "uri",
                locationName: "MapName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Blob: {
                type: "blob"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              }
            },
            payload: "Blob"
          },
          endpoint: {
            hostPrefix: "maps."
          }
        },
        GetMapStyleDescriptor: {
          http: {
            method: "GET",
            requestUri: "/maps/v0/maps/{MapName}/style-descriptor",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MapName"
            ],
            members: {
              MapName: {
                location: "uri",
                locationName: "MapName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Blob: {
                type: "blob"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              }
            },
            payload: "Blob"
          },
          endpoint: {
            hostPrefix: "maps."
          }
        },
        GetMapTile: {
          http: {
            method: "GET",
            requestUri: "/maps/v0/maps/{MapName}/tiles/{Z}/{X}/{Y}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MapName",
              "X",
              "Y",
              "Z"
            ],
            members: {
              MapName: {
                location: "uri",
                locationName: "MapName"
              },
              X: {
                location: "uri",
                locationName: "X"
              },
              Y: {
                location: "uri",
                locationName: "Y"
              },
              Z: {
                location: "uri",
                locationName: "Z"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Blob: {
                type: "blob"
              },
              ContentType: {
                location: "header",
                locationName: "Content-Type"
              }
            },
            payload: "Blob"
          },
          endpoint: {
            hostPrefix: "maps."
          }
        },
        ListDevicePositions: {
          http: {
            requestUri: "/tracking/v0/trackers/{TrackerName}/list-positions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TrackerName"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "DeviceId",
                    "Position",
                    "SampleTime"
                  ],
                  members: {
                    DeviceId: {},
                    Position: {
                      shape: "Sm"
                    },
                    SampleTime: {
                      shape: "So"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "tracking."
          }
        },
        ListGeofenceCollections: {
          http: {
            requestUri: "/geofencing/v0/list-collections",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CollectionName",
                    "CreateTime",
                    "Description",
                    "PricingPlan",
                    "UpdateTime"
                  ],
                  members: {
                    CollectionName: {},
                    CreateTime: {
                      shape: "So"
                    },
                    Description: {},
                    PricingPlan: {},
                    PricingPlanDataSource: {},
                    UpdateTime: {
                      shape: "So"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "geofencing."
          }
        },
        ListGeofences: {
          http: {
            requestUri: "/geofencing/v0/collections/{CollectionName}/list-geofences",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CollectionName"
            ],
            members: {
              CollectionName: {
                location: "uri",
                locationName: "CollectionName"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CreateTime",
                    "GeofenceId",
                    "Geometry",
                    "Status",
                    "UpdateTime"
                  ],
                  members: {
                    CreateTime: {
                      shape: "So"
                    },
                    GeofenceId: {},
                    Geometry: {
                      shape: "S13"
                    },
                    Status: {},
                    UpdateTime: {
                      shape: "So"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "geofencing."
          }
        },
        ListMaps: {
          http: {
            requestUri: "/maps/v0/list-maps",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CreateTime",
                    "DataSource",
                    "Description",
                    "MapName",
                    "PricingPlan",
                    "UpdateTime"
                  ],
                  members: {
                    CreateTime: {
                      shape: "So"
                    },
                    DataSource: {},
                    Description: {},
                    MapName: {},
                    PricingPlan: {},
                    UpdateTime: {
                      shape: "So"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "maps."
          }
        },
        ListPlaceIndexes: {
          http: {
            requestUri: "/places/v0/list-indexes",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CreateTime",
                    "DataSource",
                    "Description",
                    "IndexName",
                    "PricingPlan",
                    "UpdateTime"
                  ],
                  members: {
                    CreateTime: {
                      shape: "So"
                    },
                    DataSource: {},
                    Description: {},
                    IndexName: {},
                    PricingPlan: {},
                    UpdateTime: {
                      shape: "So"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "places."
          }
        },
        ListRouteCalculators: {
          http: {
            requestUri: "/routes/v0/list-calculators",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CalculatorName",
                    "CreateTime",
                    "DataSource",
                    "Description",
                    "PricingPlan",
                    "UpdateTime"
                  ],
                  members: {
                    CalculatorName: {},
                    CreateTime: {
                      shape: "So"
                    },
                    DataSource: {},
                    Description: {},
                    PricingPlan: {},
                    UpdateTime: {
                      shape: "So"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "routes."
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S2f"
              }
            }
          },
          endpoint: {
            hostPrefix: "metadata."
          }
        },
        ListTrackerConsumers: {
          http: {
            requestUri: "/tracking/v0/trackers/{TrackerName}/list-consumers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TrackerName"
            ],
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ConsumerArns"
            ],
            members: {
              ConsumerArns: {
                type: "list",
                member: {}
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "tracking."
          }
        },
        ListTrackers: {
          http: {
            requestUri: "/tracking/v0/list-trackers",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Entries"
            ],
            members: {
              Entries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "CreateTime",
                    "Description",
                    "PricingPlan",
                    "TrackerName",
                    "UpdateTime"
                  ],
                  members: {
                    CreateTime: {
                      shape: "So"
                    },
                    Description: {},
                    PricingPlan: {},
                    PricingPlanDataSource: {},
                    TrackerName: {},
                    UpdateTime: {
                      shape: "So"
                    }
                  }
                }
              },
              NextToken: {}
            }
          },
          endpoint: {
            hostPrefix: "tracking."
          }
        },
        PutGeofence: {
          http: {
            method: "PUT",
            requestUri: "/geofencing/v0/collections/{CollectionName}/geofences/{GeofenceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CollectionName",
              "GeofenceId",
              "Geometry"
            ],
            members: {
              CollectionName: {
                location: "uri",
                locationName: "CollectionName"
              },
              GeofenceId: {
                location: "uri",
                locationName: "GeofenceId"
              },
              Geometry: {
                shape: "S13"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "CreateTime",
              "GeofenceId",
              "UpdateTime"
            ],
            members: {
              CreateTime: {
                shape: "So"
              },
              GeofenceId: {},
              UpdateTime: {
                shape: "So"
              }
            }
          },
          endpoint: {
            hostPrefix: "geofencing."
          }
        },
        SearchPlaceIndexForPosition: {
          http: {
            requestUri: "/places/v0/indexes/{IndexName}/search/position",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IndexName",
              "Position"
            ],
            members: {
              IndexName: {
                location: "uri",
                locationName: "IndexName"
              },
              MaxResults: {
                type: "integer"
              },
              Position: {
                shape: "Sm"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Results",
              "Summary"
            ],
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Place"
                  ],
                  members: {
                    Place: {
                      shape: "S5e"
                    }
                  }
                }
              },
              Summary: {
                type: "structure",
                required: [
                  "DataSource",
                  "Position"
                ],
                members: {
                  DataSource: {},
                  MaxResults: {
                    type: "integer"
                  },
                  Position: {
                    shape: "Sm"
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "places."
          }
        },
        SearchPlaceIndexForText: {
          http: {
            requestUri: "/places/v0/indexes/{IndexName}/search/text",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IndexName",
              "Text"
            ],
            members: {
              BiasPosition: {
                shape: "Sm"
              },
              FilterBBox: {
                shape: "S2a"
              },
              FilterCountries: {
                shape: "S5i"
              },
              IndexName: {
                location: "uri",
                locationName: "IndexName"
              },
              MaxResults: {
                type: "integer"
              },
              Text: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Results",
              "Summary"
            ],
            members: {
              Results: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Place"
                  ],
                  members: {
                    Place: {
                      shape: "S5e"
                    }
                  }
                }
              },
              Summary: {
                type: "structure",
                required: [
                  "DataSource",
                  "Text"
                ],
                members: {
                  BiasPosition: {
                    shape: "Sm"
                  },
                  DataSource: {},
                  FilterBBox: {
                    shape: "S2a"
                  },
                  FilterCountries: {
                    shape: "S5i"
                  },
                  MaxResults: {
                    type: "integer"
                  },
                  ResultBBox: {
                    shape: "S2a"
                  },
                  Text: {
                    type: "string",
                    sensitive: true
                  }
                }
              }
            }
          },
          endpoint: {
            hostPrefix: "places."
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              Tags: {
                shape: "S2f"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "metadata."
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{ResourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "ResourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          endpoint: {
            hostPrefix: "metadata."
          },
          idempotent: true
        },
        UpdateGeofenceCollection: {
          http: {
            method: "PATCH",
            requestUri: "/geofencing/v0/collections/{CollectionName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CollectionName"
            ],
            members: {
              CollectionName: {
                location: "uri",
                locationName: "CollectionName"
              },
              Description: {},
              PricingPlan: {},
              PricingPlanDataSource: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "CollectionArn",
              "CollectionName",
              "UpdateTime"
            ],
            members: {
              CollectionArn: {},
              CollectionName: {},
              UpdateTime: {
                shape: "So"
              }
            }
          },
          endpoint: {
            hostPrefix: "geofencing."
          },
          idempotent: true
        },
        UpdateMap: {
          http: {
            method: "PATCH",
            requestUri: "/maps/v0/maps/{MapName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "MapName"
            ],
            members: {
              Description: {},
              MapName: {
                location: "uri",
                locationName: "MapName"
              },
              PricingPlan: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "MapArn",
              "MapName",
              "UpdateTime"
            ],
            members: {
              MapArn: {},
              MapName: {},
              UpdateTime: {
                shape: "So"
              }
            }
          },
          endpoint: {
            hostPrefix: "maps."
          },
          idempotent: true
        },
        UpdatePlaceIndex: {
          http: {
            method: "PATCH",
            requestUri: "/places/v0/indexes/{IndexName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "IndexName"
            ],
            members: {
              DataSourceConfiguration: {
                shape: "S2o"
              },
              Description: {},
              IndexName: {
                location: "uri",
                locationName: "IndexName"
              },
              PricingPlan: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "IndexArn",
              "IndexName",
              "UpdateTime"
            ],
            members: {
              IndexArn: {},
              IndexName: {},
              UpdateTime: {
                shape: "So"
              }
            }
          },
          endpoint: {
            hostPrefix: "places."
          },
          idempotent: true
        },
        UpdateRouteCalculator: {
          http: {
            method: "PATCH",
            requestUri: "/routes/v0/calculators/{CalculatorName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "CalculatorName"
            ],
            members: {
              CalculatorName: {
                location: "uri",
                locationName: "CalculatorName"
              },
              Description: {},
              PricingPlan: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "CalculatorArn",
              "CalculatorName",
              "UpdateTime"
            ],
            members: {
              CalculatorArn: {},
              CalculatorName: {},
              UpdateTime: {
                shape: "So"
              }
            }
          },
          endpoint: {
            hostPrefix: "routes."
          },
          idempotent: true
        },
        UpdateTracker: {
          http: {
            method: "PATCH",
            requestUri: "/tracking/v0/trackers/{TrackerName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "TrackerName"
            ],
            members: {
              Description: {},
              PositionFiltering: {},
              PricingPlan: {},
              PricingPlanDataSource: {},
              TrackerName: {
                location: "uri",
                locationName: "TrackerName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "TrackerArn",
              "TrackerName",
              "UpdateTime"
            ],
            members: {
              TrackerArn: {},
              TrackerName: {},
              UpdateTime: {
                shape: "So"
              }
            }
          },
          endpoint: {
            hostPrefix: "tracking."
          },
          idempotent: true
        }
      },
      shapes: {
        Sb: {
          type: "structure",
          members: {
            Code: {},
            Message: {}
          }
        },
        Sl: {
          type: "structure",
          required: [
            "DeviceId",
            "Position",
            "SampleTime"
          ],
          members: {
            DeviceId: {},
            Position: {
              shape: "Sm"
            },
            SampleTime: {
              shape: "So"
            }
          }
        },
        Sm: {
          type: "list",
          member: {
            type: "double"
          },
          sensitive: true
        },
        So: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sw: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Position",
              "ReceivedTime",
              "SampleTime"
            ],
            members: {
              DeviceId: {},
              Position: {
                shape: "Sm"
              },
              ReceivedTime: {
                shape: "So"
              },
              SampleTime: {
                shape: "So"
              }
            }
          }
        },
        S13: {
          type: "structure",
          members: {
            Polygon: {
              type: "list",
              member: {
                type: "list",
                member: {
                  shape: "Sm"
                }
              }
            }
          }
        },
        S2a: {
          type: "list",
          member: {
            type: "double"
          },
          sensitive: true
        },
        S2f: {
          type: "map",
          key: {},
          value: {}
        },
        S2k: {
          type: "structure",
          required: [
            "Style"
          ],
          members: {
            Style: {}
          }
        },
        S2o: {
          type: "structure",
          members: {
            IntendedUse: {}
          }
        },
        S5e: {
          type: "structure",
          required: [
            "Geometry"
          ],
          members: {
            AddressNumber: {},
            Country: {},
            Geometry: {
              type: "structure",
              members: {
                Point: {
                  shape: "Sm"
                }
              }
            },
            Label: {},
            Municipality: {},
            Neighborhood: {},
            PostalCode: {},
            Region: {},
            Street: {},
            SubRegion: {}
          }
        },
        S5i: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/location-2020-11-19.paginators.json
var require_location_2020_11_19_paginators = __commonJS({
  "node_modules/aws-sdk/apis/location-2020-11-19.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetDevicePositionHistory: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "DevicePositions"
        },
        ListDevicePositions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Entries"
        },
        ListGeofenceCollections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Entries"
        },
        ListGeofences: {
          input_token: "NextToken",
          output_token: "NextToken",
          result_key: "Entries"
        },
        ListMaps: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Entries"
        },
        ListPlaceIndexes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Entries"
        },
        ListRouteCalculators: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Entries"
        },
        ListTrackerConsumers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ConsumerArns"
        },
        ListTrackers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Entries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/location.js
var require_location = __commonJS({
  "node_modules/aws-sdk/clients/location.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["location"] = {};
    AWS3.Location = Service.defineService("location", ["2020-11-19"]);
    Object.defineProperty(apiLoader.services["location"], "2020-11-19", {
      get: function get() {
        var model = require_location_2020_11_19_min();
        model.paginators = require_location_2020_11_19_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Location;
  }
});

// node_modules/aws-sdk/apis/wellarchitected-2020-03-31.min.json
var require_wellarchitected_2020_03_31_min = __commonJS({
  "node_modules/aws-sdk/apis/wellarchitected-2020-03-31.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-03-31",
        endpointPrefix: "wellarchitected",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Well-Architected",
        serviceFullName: "AWS Well-Architected Tool",
        serviceId: "WellArchitected",
        signatureVersion: "v4",
        signingName: "wellarchitected",
        uid: "wellarchitected-2020-03-31"
      },
      operations: {
        AssociateLenses: {
          http: {
            method: "PATCH",
            requestUri: "/workloads/{WorkloadId}/associateLenses"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensAliases"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              LensAliases: {
                shape: "S3"
              }
            }
          }
        },
        CreateMilestone: {
          http: {
            requestUri: "/workloads/{WorkloadId}/milestones"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "MilestoneName",
              "ClientRequestToken"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              MilestoneName: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              MilestoneNumber: {
                type: "integer"
              }
            }
          }
        },
        CreateWorkload: {
          http: {
            requestUri: "/workloads"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadName",
              "Description",
              "Environment",
              "ReviewOwner",
              "Lenses",
              "ClientRequestToken"
            ],
            members: {
              WorkloadName: {},
              Description: {},
              Environment: {},
              AccountIds: {
                shape: "Se"
              },
              AwsRegions: {
                shape: "Sg"
              },
              NonAwsRegions: {
                shape: "Si"
              },
              PillarPriorities: {
                shape: "Sk"
              },
              ArchitecturalDesign: {},
              ReviewOwner: {},
              IndustryType: {},
              Industry: {},
              Lenses: {
                shape: "Sq"
              },
              Notes: {},
              ClientRequestToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              WorkloadArn: {}
            }
          }
        },
        CreateWorkloadShare: {
          http: {
            requestUri: "/workloads/{WorkloadId}/shares"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "SharedWith",
              "PermissionType",
              "ClientRequestToken"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              SharedWith: {},
              PermissionType: {},
              ClientRequestToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              ShareId: {}
            }
          }
        },
        DeleteWorkload: {
          http: {
            method: "DELETE",
            requestUri: "/workloads/{WorkloadId}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "ClientRequestToken"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              ClientRequestToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "ClientRequestToken"
              }
            }
          }
        },
        DeleteWorkloadShare: {
          http: {
            method: "DELETE",
            requestUri: "/workloads/{WorkloadId}/shares/{ShareId}"
          },
          input: {
            type: "structure",
            required: [
              "ShareId",
              "WorkloadId",
              "ClientRequestToken"
            ],
            members: {
              ShareId: {
                location: "uri",
                locationName: "ShareId"
              },
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              ClientRequestToken: {
                idempotencyToken: true,
                location: "querystring",
                locationName: "ClientRequestToken"
              }
            }
          }
        },
        DisassociateLenses: {
          http: {
            method: "PATCH",
            requestUri: "/workloads/{WorkloadId}/disassociateLenses"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensAliases"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              LensAliases: {
                shape: "S3"
              }
            }
          }
        },
        GetAnswer: {
          http: {
            method: "GET",
            requestUri: "/workloads/{WorkloadId}/lensReviews/{LensAlias}/answers/{QuestionId}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensAlias",
              "QuestionId"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              QuestionId: {
                location: "uri",
                locationName: "QuestionId"
              },
              MilestoneNumber: {
                location: "querystring",
                locationName: "MilestoneNumber",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              MilestoneNumber: {
                type: "integer"
              },
              LensAlias: {},
              Answer: {
                shape: "S18"
              }
            }
          }
        },
        GetLensReview: {
          http: {
            method: "GET",
            requestUri: "/workloads/{WorkloadId}/lensReviews/{LensAlias}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensAlias"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              MilestoneNumber: {
                location: "querystring",
                locationName: "MilestoneNumber",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              MilestoneNumber: {
                type: "integer"
              },
              LensReview: {
                shape: "S1t"
              }
            }
          }
        },
        GetLensReviewReport: {
          http: {
            method: "GET",
            requestUri: "/workloads/{WorkloadId}/lensReviews/{LensAlias}/report"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensAlias"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              MilestoneNumber: {
                location: "querystring",
                locationName: "MilestoneNumber",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              MilestoneNumber: {
                type: "integer"
              },
              LensReviewReport: {
                type: "structure",
                members: {
                  LensAlias: {},
                  Base64String: {}
                }
              }
            }
          }
        },
        GetLensVersionDifference: {
          http: {
            method: "GET",
            requestUri: "/lenses/{LensAlias}/versionDifference"
          },
          input: {
            type: "structure",
            required: [
              "LensAlias",
              "BaseLensVersion"
            ],
            members: {
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              BaseLensVersion: {
                location: "querystring",
                locationName: "BaseLensVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LensAlias: {},
              BaseLensVersion: {},
              LatestLensVersion: {},
              VersionDifferences: {
                type: "structure",
                members: {
                  PillarDifferences: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        PillarId: {},
                        DifferenceStatus: {},
                        QuestionDifferences: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              QuestionId: {},
                              QuestionTitle: {},
                              DifferenceStatus: {}
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetMilestone: {
          http: {
            method: "GET",
            requestUri: "/workloads/{WorkloadId}/milestones/{MilestoneNumber}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "MilestoneNumber"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              MilestoneNumber: {
                location: "uri",
                locationName: "MilestoneNumber",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              Milestone: {
                type: "structure",
                members: {
                  MilestoneNumber: {
                    type: "integer"
                  },
                  MilestoneName: {},
                  RecordedAt: {
                    type: "timestamp"
                  },
                  Workload: {
                    shape: "S2j"
                  }
                }
              }
            }
          }
        },
        GetWorkload: {
          http: {
            method: "GET",
            requestUri: "/workloads/{WorkloadId}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Workload: {
                shape: "S2j"
              }
            }
          }
        },
        ListAnswers: {
          http: {
            method: "GET",
            requestUri: "/workloads/{WorkloadId}/lensReviews/{LensAlias}/answers"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensAlias"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              PillarId: {
                location: "querystring",
                locationName: "PillarId"
              },
              MilestoneNumber: {
                location: "querystring",
                locationName: "MilestoneNumber",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              MilestoneNumber: {
                type: "integer"
              },
              LensAlias: {},
              AnswerSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    QuestionId: {},
                    PillarId: {},
                    QuestionTitle: {},
                    Choices: {
                      shape: "S1d"
                    },
                    SelectedChoices: {
                      shape: "S1i"
                    },
                    ChoiceAnswerSummaries: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          ChoiceId: {},
                          Status: {},
                          Reason: {}
                        }
                      }
                    },
                    IsApplicable: {
                      type: "boolean"
                    },
                    Risk: {},
                    Reason: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLensReviewImprovements: {
          http: {
            method: "GET",
            requestUri: "/workloads/{WorkloadId}/lensReviews/{LensAlias}/improvements"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensAlias"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              PillarId: {
                location: "querystring",
                locationName: "PillarId"
              },
              MilestoneNumber: {
                location: "querystring",
                locationName: "MilestoneNumber",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              MilestoneNumber: {
                type: "integer"
              },
              LensAlias: {},
              ImprovementSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    QuestionId: {},
                    PillarId: {},
                    QuestionTitle: {},
                    Risk: {},
                    ImprovementPlanUrl: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLensReviews: {
          http: {
            method: "GET",
            requestUri: "/workloads/{WorkloadId}/lensReviews"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              MilestoneNumber: {
                location: "querystring",
                locationName: "MilestoneNumber",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              MilestoneNumber: {
                type: "integer"
              },
              LensReviewSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LensAlias: {},
                    LensVersion: {},
                    LensName: {},
                    LensStatus: {},
                    UpdatedAt: {
                      type: "timestamp"
                    },
                    RiskCounts: {
                      shape: "S20"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListLenses: {
          http: {
            method: "GET",
            requestUri: "/lenses"
          },
          input: {
            type: "structure",
            members: {
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LensSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LensAlias: {},
                    LensVersion: {},
                    LensName: {},
                    Description: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListMilestones: {
          http: {
            requestUri: "/workloads/{WorkloadId}/milestonesSummaries"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              MilestoneSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MilestoneNumber: {
                      type: "integer"
                    },
                    MilestoneName: {},
                    RecordedAt: {
                      type: "timestamp"
                    },
                    WorkloadSummary: {
                      shape: "S3f"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListNotifications: {
          http: {
            requestUri: "/notifications"
          },
          input: {
            type: "structure",
            members: {
              WorkloadId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NotificationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Type: {},
                    LensUpgradeSummary: {
                      type: "structure",
                      members: {
                        WorkloadId: {},
                        WorkloadName: {},
                        LensAlias: {},
                        CurrentLensVersion: {},
                        LatestLensVersion: {}
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListShareInvitations: {
          http: {
            method: "GET",
            requestUri: "/shareInvitations"
          },
          input: {
            type: "structure",
            members: {
              WorkloadNamePrefix: {
                location: "querystring",
                locationName: "WorkloadNamePrefix"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ShareInvitationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ShareInvitationId: {},
                    SharedBy: {},
                    SharedWith: {},
                    PermissionType: {},
                    WorkloadName: {},
                    WorkloadId: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{WorkloadArn}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadArn"
            ],
            members: {
              WorkloadArn: {
                location: "uri",
                locationName: "WorkloadArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Ss"
              }
            }
          }
        },
        ListWorkloadShares: {
          http: {
            method: "GET",
            requestUri: "/workloads/{WorkloadId}/shares"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              SharedWithPrefix: {
                location: "querystring",
                locationName: "SharedWithPrefix"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              WorkloadShareSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ShareId: {},
                    SharedWith: {},
                    PermissionType: {},
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListWorkloads: {
          http: {
            requestUri: "/workloadsSummaries"
          },
          input: {
            type: "structure",
            members: {
              WorkloadNamePrefix: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadSummaries: {
                type: "list",
                member: {
                  shape: "S3f"
                }
              },
              NextToken: {}
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{WorkloadArn}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadArn",
              "Tags"
            ],
            members: {
              WorkloadArn: {
                location: "uri",
                locationName: "WorkloadArn"
              },
              Tags: {
                shape: "Ss"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{WorkloadArn}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadArn",
              "TagKeys"
            ],
            members: {
              WorkloadArn: {
                location: "uri",
                locationName: "WorkloadArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAnswer: {
          http: {
            method: "PATCH",
            requestUri: "/workloads/{WorkloadId}/lensReviews/{LensAlias}/answers/{QuestionId}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensAlias",
              "QuestionId"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              QuestionId: {
                location: "uri",
                locationName: "QuestionId"
              },
              SelectedChoices: {
                shape: "S1i"
              },
              ChoiceUpdates: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "Status"
                  ],
                  members: {
                    Status: {},
                    Reason: {},
                    Notes: {}
                  }
                }
              },
              Notes: {},
              IsApplicable: {
                type: "boolean"
              },
              Reason: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              LensAlias: {},
              Answer: {
                shape: "S18"
              }
            }
          }
        },
        UpdateLensReview: {
          http: {
            method: "PATCH",
            requestUri: "/workloads/{WorkloadId}/lensReviews/{LensAlias}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensAlias"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              LensNotes: {},
              PillarNotes: {
                type: "map",
                key: {},
                value: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              LensReview: {
                shape: "S1t"
              }
            }
          }
        },
        UpdateShareInvitation: {
          http: {
            method: "PATCH",
            requestUri: "/shareInvitations/{ShareInvitationId}"
          },
          input: {
            type: "structure",
            required: [
              "ShareInvitationId",
              "ShareInvitationAction"
            ],
            members: {
              ShareInvitationId: {
                location: "uri",
                locationName: "ShareInvitationId"
              },
              ShareInvitationAction: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ShareInvitation: {
                type: "structure",
                members: {
                  ShareInvitationId: {},
                  WorkloadId: {}
                }
              }
            }
          }
        },
        UpdateWorkload: {
          http: {
            method: "PATCH",
            requestUri: "/workloads/{WorkloadId}"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              WorkloadName: {},
              Description: {},
              Environment: {},
              AccountIds: {
                shape: "Se"
              },
              AwsRegions: {
                shape: "Sg"
              },
              NonAwsRegions: {
                shape: "Si"
              },
              PillarPriorities: {
                shape: "Sk"
              },
              ArchitecturalDesign: {},
              ReviewOwner: {},
              IsReviewOwnerUpdateAcknowledged: {
                type: "boolean"
              },
              IndustryType: {},
              Industry: {},
              Notes: {},
              ImprovementStatus: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Workload: {
                shape: "S2j"
              }
            }
          }
        },
        UpdateWorkloadShare: {
          http: {
            method: "PATCH",
            requestUri: "/workloads/{WorkloadId}/shares/{ShareId}"
          },
          input: {
            type: "structure",
            required: [
              "ShareId",
              "WorkloadId",
              "PermissionType"
            ],
            members: {
              ShareId: {
                location: "uri",
                locationName: "ShareId"
              },
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              PermissionType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              WorkloadId: {},
              WorkloadShare: {
                type: "structure",
                members: {
                  ShareId: {},
                  SharedBy: {},
                  SharedWith: {},
                  PermissionType: {},
                  Status: {},
                  WorkloadName: {},
                  WorkloadId: {}
                }
              }
            }
          }
        },
        UpgradeLensReview: {
          http: {
            method: "PUT",
            requestUri: "/workloads/{WorkloadId}/lensReviews/{LensAlias}/upgrade"
          },
          input: {
            type: "structure",
            required: [
              "WorkloadId",
              "LensAlias",
              "MilestoneName"
            ],
            members: {
              WorkloadId: {
                location: "uri",
                locationName: "WorkloadId"
              },
              LensAlias: {
                location: "uri",
                locationName: "LensAlias"
              },
              MilestoneName: {},
              ClientRequestToken: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        Se: {
          type: "list",
          member: {}
        },
        Sg: {
          type: "list",
          member: {}
        },
        Si: {
          type: "list",
          member: {}
        },
        Sk: {
          type: "list",
          member: {}
        },
        Sq: {
          type: "list",
          member: {}
        },
        Ss: {
          type: "map",
          key: {},
          value: {}
        },
        S18: {
          type: "structure",
          members: {
            QuestionId: {},
            PillarId: {},
            QuestionTitle: {},
            QuestionDescription: {},
            ImprovementPlanUrl: {},
            HelpfulResourceUrl: {},
            Choices: {
              shape: "S1d"
            },
            SelectedChoices: {
              shape: "S1i"
            },
            ChoiceAnswers: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  ChoiceId: {},
                  Status: {},
                  Reason: {},
                  Notes: {}
                }
              }
            },
            IsApplicable: {
              type: "boolean"
            },
            Risk: {},
            Notes: {},
            Reason: {}
          }
        },
        S1d: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ChoiceId: {},
              Title: {},
              Description: {}
            }
          }
        },
        S1i: {
          type: "list",
          member: {}
        },
        S1t: {
          type: "structure",
          members: {
            LensAlias: {},
            LensVersion: {},
            LensName: {},
            LensStatus: {},
            PillarReviewSummaries: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  PillarId: {},
                  PillarName: {},
                  Notes: {},
                  RiskCounts: {
                    shape: "S20"
                  }
                }
              }
            },
            UpdatedAt: {
              type: "timestamp"
            },
            Notes: {},
            RiskCounts: {
              shape: "S20"
            },
            NextToken: {}
          }
        },
        S20: {
          type: "map",
          key: {},
          value: {
            type: "integer"
          }
        },
        S2j: {
          type: "structure",
          members: {
            WorkloadId: {},
            WorkloadArn: {},
            WorkloadName: {},
            Description: {},
            Environment: {},
            UpdatedAt: {
              type: "timestamp"
            },
            AccountIds: {
              shape: "Se"
            },
            AwsRegions: {
              shape: "Sg"
            },
            NonAwsRegions: {
              shape: "Si"
            },
            ArchitecturalDesign: {},
            ReviewOwner: {},
            ReviewRestrictionDate: {
              type: "timestamp"
            },
            IsReviewOwnerUpdateAcknowledged: {
              type: "boolean"
            },
            IndustryType: {},
            Industry: {},
            Notes: {},
            ImprovementStatus: {},
            RiskCounts: {
              shape: "S20"
            },
            PillarPriorities: {
              shape: "Sk"
            },
            Lenses: {
              shape: "Sq"
            },
            Owner: {},
            ShareInvitationId: {},
            Tags: {
              shape: "Ss"
            }
          }
        },
        S3f: {
          type: "structure",
          members: {
            WorkloadId: {},
            WorkloadArn: {},
            WorkloadName: {},
            Owner: {},
            UpdatedAt: {
              type: "timestamp"
            },
            Lenses: {
              shape: "Sq"
            },
            RiskCounts: {
              shape: "S20"
            },
            ImprovementStatus: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/wellarchitected-2020-03-31.paginators.json
var require_wellarchitected_2020_03_31_paginators = __commonJS({
  "node_modules/aws-sdk/apis/wellarchitected-2020-03-31.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAnswers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListLensReviewImprovements: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListLensReviews: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListLenses: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMilestones: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListNotifications: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListShareInvitations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListWorkloadShares: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListWorkloads: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/wellarchitected.js
var require_wellarchitected = __commonJS({
  "node_modules/aws-sdk/clients/wellarchitected.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["wellarchitected"] = {};
    AWS3.WellArchitected = Service.defineService("wellarchitected", ["2020-03-31"]);
    Object.defineProperty(apiLoader.services["wellarchitected"], "2020-03-31", {
      get: function get() {
        var model = require_wellarchitected_2020_03_31_min();
        model.paginators = require_wellarchitected_2020_03_31_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.WellArchitected;
  }
});

// node_modules/aws-sdk/lib/services/lexmodelsv2.js
var require_lexmodelsv2 = __commonJS({
  "node_modules/aws-sdk/lib/services/lexmodelsv2.js"() {
    var AWS3 = require_core();
    AWS3.util.update(AWS3.LexModelsV2.prototype, {
      setupRequestListeners: function setupRequestListeners(request) {
        request.addListener("build", this.modifyContentType);
      },
      modifyContentType: function modifyContentType(request) {
        if (request.httpRequest.headers["Content-Type"] === "application/json") {
          request.httpRequest.headers["Content-Type"] = "application/x-amz-json-1.1";
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/models.lex.v2-2020-08-07.min.json
var require_models_lex_v2_2020_08_07_min = __commonJS({
  "node_modules/aws-sdk/apis/models.lex.v2-2020-08-07.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-08-07",
        endpointPrefix: "models-v2-lex",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Lex Models V2",
        serviceFullName: "Amazon Lex Model Building V2",
        serviceId: "Lex Models V2",
        signatureVersion: "v4",
        signingName: "lex",
        uid: "models.lex.v2-2020-08-07"
      },
      operations: {
        BuildBotLocale: {
          http: {
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              botLocaleStatus: {},
              lastBuildSubmittedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateBot: {
          http: {
            method: "PUT",
            requestUri: "/bots/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botName",
              "roleArn",
              "dataPrivacy",
              "idleSessionTTLInSeconds"
            ],
            members: {
              botName: {},
              description: {},
              roleArn: {},
              dataPrivacy: {
                shape: "Sc"
              },
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              botTags: {
                shape: "Sf"
              },
              testBotAliasTags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botName: {},
              description: {},
              roleArn: {},
              dataPrivacy: {
                shape: "Sc"
              },
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              botStatus: {},
              creationDateTime: {
                type: "timestamp"
              },
              botTags: {
                shape: "Sf"
              },
              testBotAliasTags: {
                shape: "Sf"
              }
            }
          }
        },
        CreateBotAlias: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botaliases/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botAliasName",
              "botId"
            ],
            members: {
              botAliasName: {},
              description: {},
              botVersion: {},
              botAliasLocaleSettings: {
                shape: "Sm"
              },
              conversationLogSettings: {
                shape: "St"
              },
              sentimentAnalysisSettings: {
                shape: "S16"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botAliasId: {},
              botAliasName: {},
              description: {},
              botVersion: {},
              botAliasLocaleSettings: {
                shape: "Sm"
              },
              conversationLogSettings: {
                shape: "St"
              },
              sentimentAnalysisSettings: {
                shape: "S16"
              },
              botAliasStatus: {},
              botId: {},
              creationDateTime: {
                type: "timestamp"
              },
              tags: {
                shape: "Sf"
              }
            }
          }
        },
        CreateBotLocale: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId",
              "nluIntentConfidenceThreshold"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {},
              description: {},
              nluIntentConfidenceThreshold: {
                type: "double"
              },
              voiceSettings: {
                shape: "S1c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeName: {},
              localeId: {},
              description: {},
              nluIntentConfidenceThreshold: {
                type: "double"
              },
              voiceSettings: {
                shape: "S1c"
              },
              botLocaleStatus: {},
              creationDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateBotVersion: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersionLocaleSpecification"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              description: {},
              botVersionLocaleSpecification: {
                shape: "S1h"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              description: {},
              botVersion: {},
              botVersionLocaleSpecification: {
                shape: "S1h"
              },
              botStatus: {},
              creationDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateExport: {
          http: {
            method: "PUT",
            requestUri: "/exports/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "resourceSpecification",
              "fileFormat"
            ],
            members: {
              resourceSpecification: {
                shape: "S1m"
              },
              fileFormat: {},
              filePassword: {
                shape: "S1q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              exportId: {},
              resourceSpecification: {
                shape: "S1m"
              },
              fileFormat: {},
              exportStatus: {},
              creationDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateIntent: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/intents/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "intentName",
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              intentName: {},
              description: {},
              parentIntentSignature: {},
              sampleUtterances: {
                shape: "S1v"
              },
              dialogCodeHook: {
                shape: "S1y"
              },
              fulfillmentCodeHook: {
                shape: "S1z"
              },
              intentConfirmationSetting: {
                shape: "S2q"
              },
              intentClosingSetting: {
                shape: "S2t"
              },
              inputContexts: {
                shape: "S2u"
              },
              outputContexts: {
                shape: "S2w"
              },
              kendraConfiguration: {
                shape: "S30"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              intentId: {},
              intentName: {},
              description: {},
              parentIntentSignature: {},
              sampleUtterances: {
                shape: "S1v"
              },
              dialogCodeHook: {
                shape: "S1y"
              },
              fulfillmentCodeHook: {
                shape: "S1z"
              },
              intentConfirmationSetting: {
                shape: "S2q"
              },
              intentClosingSetting: {
                shape: "S2t"
              },
              inputContexts: {
                shape: "S2u"
              },
              outputContexts: {
                shape: "S2w"
              },
              kendraConfiguration: {
                shape: "S30"
              },
              botId: {},
              botVersion: {},
              localeId: {},
              creationDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateResourcePolicy: {
          http: {
            requestUri: "/policy/{resourceArn}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "policy"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              policy: {}
            }
          },
          output: {
            type: "structure",
            members: {
              resourceArn: {},
              revisionId: {}
            }
          }
        },
        CreateResourcePolicyStatement: {
          http: {
            requestUri: "/policy/{resourceArn}/statements/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "statementId",
              "effect",
              "principal",
              "action"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              statementId: {},
              effect: {},
              principal: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    service: {},
                    arn: {}
                  }
                }
              },
              action: {
                type: "list",
                member: {}
              },
              condition: {
                type: "map",
                key: {},
                value: {
                  type: "map",
                  key: {},
                  value: {}
                }
              },
              expectedRevisionId: {
                location: "querystring",
                locationName: "expectedRevisionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceArn: {},
              revisionId: {}
            }
          }
        },
        CreateSlot: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/intents/{intentId}/slots/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "slotName",
              "slotTypeId",
              "valueElicitationSetting",
              "botId",
              "botVersion",
              "localeId",
              "intentId"
            ],
            members: {
              slotName: {},
              description: {},
              slotTypeId: {},
              valueElicitationSetting: {
                shape: "S3p"
              },
              obfuscationSetting: {
                shape: "S3z"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              intentId: {
                location: "uri",
                locationName: "intentId"
              },
              multipleValuesSetting: {
                shape: "S41"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              slotId: {},
              slotName: {},
              description: {},
              slotTypeId: {},
              valueElicitationSetting: {
                shape: "S3p"
              },
              obfuscationSetting: {
                shape: "S3z"
              },
              botId: {},
              botVersion: {},
              localeId: {},
              intentId: {},
              creationDateTime: {
                type: "timestamp"
              },
              multipleValuesSetting: {
                shape: "S41"
              }
            }
          }
        },
        CreateSlotType: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/slottypes/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "slotTypeName",
              "valueSelectionSetting",
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              slotTypeName: {},
              description: {},
              slotTypeValues: {
                shape: "S44"
              },
              valueSelectionSetting: {
                shape: "S49"
              },
              parentSlotTypeSignature: {},
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              slotTypeId: {},
              slotTypeName: {},
              description: {},
              slotTypeValues: {
                shape: "S44"
              },
              valueSelectionSetting: {
                shape: "S49"
              },
              parentSlotTypeSignature: {},
              botId: {},
              botVersion: {},
              localeId: {},
              creationDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        CreateUploadUrl: {
          http: {
            requestUri: "/createuploadurl/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              importId: {},
              uploadUrl: {}
            }
          }
        },
        DeleteBot: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              skipResourceInUseCheck: {
                location: "querystring",
                locationName: "skipResourceInUseCheck",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botStatus: {}
            }
          }
        },
        DeleteBotAlias: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botId}/botaliases/{botAliasId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botAliasId",
              "botId"
            ],
            members: {
              botAliasId: {
                location: "uri",
                locationName: "botAliasId"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              skipResourceInUseCheck: {
                location: "querystring",
                locationName: "skipResourceInUseCheck",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botAliasId: {},
              botId: {},
              botAliasStatus: {}
            }
          }
        },
        DeleteBotLocale: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              botLocaleStatus: {}
            }
          }
        },
        DeleteBotVersion: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botId}/botversions/{botVersion}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              skipResourceInUseCheck: {
                location: "querystring",
                locationName: "skipResourceInUseCheck",
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              botStatus: {}
            }
          }
        },
        DeleteExport: {
          http: {
            method: "DELETE",
            requestUri: "/exports/{exportId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "exportId"
            ],
            members: {
              exportId: {
                location: "uri",
                locationName: "exportId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              exportId: {},
              exportStatus: {}
            }
          }
        },
        DeleteImport: {
          http: {
            method: "DELETE",
            requestUri: "/imports/{importId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "importId"
            ],
            members: {
              importId: {
                location: "uri",
                locationName: "importId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              importId: {},
              importStatus: {}
            }
          }
        },
        DeleteIntent: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/intents/{intentId}/",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "intentId",
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              intentId: {
                location: "uri",
                locationName: "intentId"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              }
            }
          }
        },
        DeleteResourcePolicy: {
          http: {
            method: "DELETE",
            requestUri: "/policy/{resourceArn}/",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              expectedRevisionId: {
                location: "querystring",
                locationName: "expectedRevisionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceArn: {},
              revisionId: {}
            }
          }
        },
        DeleteResourcePolicyStatement: {
          http: {
            method: "DELETE",
            requestUri: "/policy/{resourceArn}/statements/{statementId}/",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "statementId"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              statementId: {
                location: "uri",
                locationName: "statementId"
              },
              expectedRevisionId: {
                location: "querystring",
                locationName: "expectedRevisionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceArn: {},
              revisionId: {}
            }
          }
        },
        DeleteSlot: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/intents/{intentId}/slots/{slotId}/",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "slotId",
              "botId",
              "botVersion",
              "localeId",
              "intentId"
            ],
            members: {
              slotId: {
                location: "uri",
                locationName: "slotId"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              intentId: {
                location: "uri",
                locationName: "intentId"
              }
            }
          }
        },
        DeleteSlotType: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/slottypes/{slotTypeId}/",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "slotTypeId",
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              slotTypeId: {
                location: "uri",
                locationName: "slotTypeId"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              skipResourceInUseCheck: {
                location: "querystring",
                locationName: "skipResourceInUseCheck",
                type: "boolean"
              }
            }
          }
        },
        DeleteUtterances: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botId}/utterances/",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "botId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              localeId: {
                location: "querystring",
                locationName: "localeId"
              },
              sessionId: {
                location: "querystring",
                locationName: "sessionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeBot: {
          http: {
            method: "GET",
            requestUri: "/bots/{botId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botName: {},
              description: {},
              roleArn: {},
              dataPrivacy: {
                shape: "Sc"
              },
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              botStatus: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeBotAlias: {
          http: {
            method: "GET",
            requestUri: "/bots/{botId}/botaliases/{botAliasId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botAliasId",
              "botId"
            ],
            members: {
              botAliasId: {
                location: "uri",
                locationName: "botAliasId"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botAliasId: {},
              botAliasName: {},
              description: {},
              botVersion: {},
              botAliasLocaleSettings: {
                shape: "Sm"
              },
              conversationLogSettings: {
                shape: "St"
              },
              sentimentAnalysisSettings: {
                shape: "S16"
              },
              botAliasHistoryEvents: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    botVersion: {},
                    startDate: {
                      type: "timestamp"
                    },
                    endDate: {
                      type: "timestamp"
                    }
                  }
                }
              },
              botAliasStatus: {},
              botId: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeBotLocale: {
          http: {
            method: "GET",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              localeName: {},
              description: {},
              nluIntentConfidenceThreshold: {
                type: "double"
              },
              voiceSettings: {
                shape: "S1c"
              },
              intentsCount: {
                type: "integer"
              },
              slotTypesCount: {
                type: "integer"
              },
              botLocaleStatus: {},
              failureReasons: {
                shape: "S5f"
              },
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              },
              lastBuildSubmittedDateTime: {
                type: "timestamp"
              },
              botLocaleHistoryEvents: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "event",
                    "eventDate"
                  ],
                  members: {
                    event: {},
                    eventDate: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeBotVersion: {
          http: {
            method: "GET",
            requestUri: "/bots/{botId}/botversions/{botVersion}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botName: {},
              botVersion: {},
              description: {},
              roleArn: {},
              dataPrivacy: {
                shape: "Sc"
              },
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              botStatus: {},
              failureReasons: {
                shape: "S5f"
              },
              creationDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeExport: {
          http: {
            method: "GET",
            requestUri: "/exports/{exportId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "exportId"
            ],
            members: {
              exportId: {
                location: "uri",
                locationName: "exportId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              exportId: {},
              resourceSpecification: {
                shape: "S1m"
              },
              fileFormat: {},
              exportStatus: {},
              failureReasons: {
                shape: "S5f"
              },
              downloadUrl: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeImport: {
          http: {
            method: "GET",
            requestUri: "/imports/{importId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "importId"
            ],
            members: {
              importId: {
                location: "uri",
                locationName: "importId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              importId: {},
              resourceSpecification: {
                shape: "S5q"
              },
              importedResourceId: {},
              importedResourceName: {},
              mergeStrategy: {},
              importStatus: {},
              failureReasons: {
                shape: "S5f"
              },
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeIntent: {
          http: {
            method: "GET",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/intents/{intentId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "intentId",
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              intentId: {
                location: "uri",
                locationName: "intentId"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              intentId: {},
              intentName: {},
              description: {},
              parentIntentSignature: {},
              sampleUtterances: {
                shape: "S1v"
              },
              dialogCodeHook: {
                shape: "S1y"
              },
              fulfillmentCodeHook: {
                shape: "S1z"
              },
              slotPriorities: {
                shape: "S5x"
              },
              intentConfirmationSetting: {
                shape: "S2q"
              },
              intentClosingSetting: {
                shape: "S2t"
              },
              inputContexts: {
                shape: "S2u"
              },
              outputContexts: {
                shape: "S2w"
              },
              kendraConfiguration: {
                shape: "S30"
              },
              botId: {},
              botVersion: {},
              localeId: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribeResourcePolicy: {
          http: {
            method: "GET",
            requestUri: "/policy/{resourceArn}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceArn: {},
              policy: {},
              revisionId: {}
            }
          }
        },
        DescribeSlot: {
          http: {
            method: "GET",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/intents/{intentId}/slots/{slotId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "slotId",
              "botId",
              "botVersion",
              "localeId",
              "intentId"
            ],
            members: {
              slotId: {
                location: "uri",
                locationName: "slotId"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              intentId: {
                location: "uri",
                locationName: "intentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              slotId: {},
              slotName: {},
              description: {},
              slotTypeId: {},
              valueElicitationSetting: {
                shape: "S3p"
              },
              obfuscationSetting: {
                shape: "S3z"
              },
              botId: {},
              botVersion: {},
              localeId: {},
              intentId: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              },
              multipleValuesSetting: {
                shape: "S41"
              }
            }
          }
        },
        DescribeSlotType: {
          http: {
            method: "GET",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/slottypes/{slotTypeId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "slotTypeId",
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              slotTypeId: {
                location: "uri",
                locationName: "slotTypeId"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              slotTypeId: {},
              slotTypeName: {},
              description: {},
              slotTypeValues: {
                shape: "S44"
              },
              valueSelectionSetting: {
                shape: "S49"
              },
              parentSlotTypeSignature: {},
              botId: {},
              botVersion: {},
              localeId: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        ListAggregatedUtterances: {
          http: {
            requestUri: "/bots/{botId}/aggregatedutterances/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "localeId",
              "aggregationDuration"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botAliasId: {},
              botVersion: {},
              localeId: {},
              aggregationDuration: {
                shape: "S67"
              },
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values",
                    "operator"
                  ],
                  members: {
                    name: {},
                    values: {
                      shape: "S6h"
                    },
                    operator: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botAliasId: {},
              botVersion: {},
              localeId: {},
              aggregationDuration: {
                shape: "S67"
              },
              aggregationWindowStartTime: {
                type: "timestamp"
              },
              aggregationWindowEndTime: {
                type: "timestamp"
              },
              aggregationLastRefreshedDateTime: {
                type: "timestamp"
              },
              aggregatedUtterancesSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    utterance: {},
                    hitCount: {
                      type: "integer"
                    },
                    missedCount: {
                      type: "integer"
                    },
                    utteranceFirstRecordedInAggregationDuration: {
                      type: "timestamp"
                    },
                    utteranceLastRecordedInAggregationDuration: {
                      type: "timestamp"
                    },
                    containsDataFromDeletedResources: {
                      type: "boolean"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListBotAliases: {
          http: {
            requestUri: "/bots/{botId}/botaliases/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botAliasSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    botAliasId: {},
                    botAliasName: {},
                    description: {},
                    botVersion: {},
                    botAliasStatus: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {},
              botId: {}
            }
          }
        },
        ListBotLocales: {
          http: {
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values",
                    "operator"
                  ],
                  members: {
                    name: {},
                    values: {
                      shape: "S6h"
                    },
                    operator: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              nextToken: {},
              botLocaleSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    localeId: {},
                    localeName: {},
                    description: {},
                    botLocaleStatus: {},
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    },
                    lastBuildSubmittedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListBotVersions: {
          http: {
            requestUri: "/bots/{botId}/botversions/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    botName: {},
                    botVersion: {},
                    description: {},
                    botStatus: {},
                    creationDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListBots: {
          http: {
            requestUri: "/bots/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values",
                    "operator"
                  ],
                  members: {
                    name: {},
                    values: {
                      shape: "S6h"
                    },
                    operator: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    botId: {},
                    botName: {},
                    description: {},
                    botStatus: {},
                    latestBotVersion: {},
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListBuiltInIntents: {
          http: {
            requestUri: "/builtins/locales/{localeId}/intents/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "localeId"
            ],
            members: {
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              builtInIntentSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    intentSignature: {},
                    description: {}
                  }
                }
              },
              nextToken: {},
              localeId: {}
            }
          }
        },
        ListBuiltInSlotTypes: {
          http: {
            requestUri: "/builtins/locales/{localeId}/slottypes/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "localeId"
            ],
            members: {
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              builtInSlotTypeSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    slotTypeSignature: {},
                    description: {}
                  }
                }
              },
              nextToken: {},
              localeId: {}
            }
          }
        },
        ListExports: {
          http: {
            requestUri: "/exports/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values",
                    "operator"
                  ],
                  members: {
                    name: {},
                    values: {
                      shape: "S6h"
                    },
                    operator: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              exportSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    exportId: {},
                    resourceSpecification: {
                      shape: "S1m"
                    },
                    fileFormat: {},
                    exportStatus: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListImports: {
          http: {
            requestUri: "/imports/",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values",
                    "operator"
                  ],
                  members: {
                    name: {},
                    values: {
                      shape: "S6h"
                    },
                    operator: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              importSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    importId: {},
                    importedResourceId: {},
                    importedResourceName: {},
                    importStatus: {},
                    mergeStrategy: {},
                    creationDateTime: {
                      type: "timestamp"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListIntents: {
          http: {
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/intents/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values",
                    "operator"
                  ],
                  members: {
                    name: {},
                    values: {
                      shape: "S6h"
                    },
                    operator: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              intentSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    intentId: {},
                    intentName: {},
                    description: {},
                    parentIntentSignature: {},
                    inputContexts: {
                      shape: "S2u"
                    },
                    outputContexts: {
                      shape: "S2w"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSlotTypes: {
          http: {
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/slottypes/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values",
                    "operator"
                  ],
                  members: {
                    name: {},
                    values: {
                      shape: "S6h"
                    },
                    operator: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              slotTypeSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    slotTypeId: {},
                    slotTypeName: {},
                    description: {},
                    parentSlotTypeSignature: {},
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListSlots: {
          http: {
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/intents/{intentId}/slots/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId",
              "intentId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              intentId: {
                location: "uri",
                locationName: "intentId"
              },
              sortBy: {
                type: "structure",
                required: [
                  "attribute",
                  "order"
                ],
                members: {
                  attribute: {},
                  order: {}
                }
              },
              filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "name",
                    "values",
                    "operator"
                  ],
                  members: {
                    name: {},
                    values: {
                      shape: "S6h"
                    },
                    operator: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              intentId: {},
              slotSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    slotId: {},
                    slotName: {},
                    description: {},
                    slotConstraint: {},
                    slotTypeId: {},
                    valueElicitationPromptSpecification: {
                      shape: "S2r"
                    },
                    lastUpdatedDateTime: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceARN}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceARN"
            ],
            members: {
              resourceARN: {
                location: "uri",
                locationName: "resourceARN"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sf"
              }
            }
          }
        },
        StartImport: {
          http: {
            method: "PUT",
            requestUri: "/imports/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "importId",
              "resourceSpecification",
              "mergeStrategy"
            ],
            members: {
              importId: {},
              resourceSpecification: {
                shape: "S5q"
              },
              mergeStrategy: {},
              filePassword: {
                shape: "S1q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              importId: {},
              resourceSpecification: {
                shape: "S5q"
              },
              mergeStrategy: {},
              importStatus: {},
              creationDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceARN}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceARN",
              "tags"
            ],
            members: {
              resourceARN: {
                location: "uri",
                locationName: "resourceARN"
              },
              tags: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceARN}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceARN",
              "tagKeys"
            ],
            members: {
              resourceARN: {
                location: "uri",
                locationName: "resourceARN"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateBot: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botName",
              "roleArn",
              "dataPrivacy",
              "idleSessionTTLInSeconds"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botName: {},
              description: {},
              roleArn: {},
              dataPrivacy: {
                shape: "Sc"
              },
              idleSessionTTLInSeconds: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botName: {},
              description: {},
              roleArn: {},
              dataPrivacy: {
                shape: "Sc"
              },
              idleSessionTTLInSeconds: {
                type: "integer"
              },
              botStatus: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateBotAlias: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botaliases/{botAliasId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botAliasId",
              "botAliasName",
              "botId"
            ],
            members: {
              botAliasId: {
                location: "uri",
                locationName: "botAliasId"
              },
              botAliasName: {},
              description: {},
              botVersion: {},
              botAliasLocaleSettings: {
                shape: "Sm"
              },
              conversationLogSettings: {
                shape: "St"
              },
              sentimentAnalysisSettings: {
                shape: "S16"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botAliasId: {},
              botAliasName: {},
              description: {},
              botVersion: {},
              botAliasLocaleSettings: {
                shape: "Sm"
              },
              conversationLogSettings: {
                shape: "St"
              },
              sentimentAnalysisSettings: {
                shape: "S16"
              },
              botAliasStatus: {},
              botId: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateBotLocale: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botVersion",
              "localeId",
              "nluIntentConfidenceThreshold"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              description: {},
              nluIntentConfidenceThreshold: {
                type: "double"
              },
              voiceSettings: {
                shape: "S1c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botVersion: {},
              localeId: {},
              localeName: {},
              description: {},
              nluIntentConfidenceThreshold: {
                type: "double"
              },
              voiceSettings: {
                shape: "S1c"
              },
              botLocaleStatus: {},
              failureReasons: {
                shape: "S5f"
              },
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateExport: {
          http: {
            method: "PUT",
            requestUri: "/exports/{exportId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "exportId"
            ],
            members: {
              exportId: {
                location: "uri",
                locationName: "exportId"
              },
              filePassword: {
                shape: "S1q"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              exportId: {},
              resourceSpecification: {
                shape: "S1m"
              },
              fileFormat: {},
              exportStatus: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateIntent: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/intents/{intentId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "intentId",
              "intentName",
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              intentId: {
                location: "uri",
                locationName: "intentId"
              },
              intentName: {},
              description: {},
              parentIntentSignature: {},
              sampleUtterances: {
                shape: "S1v"
              },
              dialogCodeHook: {
                shape: "S1y"
              },
              fulfillmentCodeHook: {
                shape: "S1z"
              },
              slotPriorities: {
                shape: "S5x"
              },
              intentConfirmationSetting: {
                shape: "S2q"
              },
              intentClosingSetting: {
                shape: "S2t"
              },
              inputContexts: {
                shape: "S2u"
              },
              outputContexts: {
                shape: "S2w"
              },
              kendraConfiguration: {
                shape: "S30"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              intentId: {},
              intentName: {},
              description: {},
              parentIntentSignature: {},
              sampleUtterances: {
                shape: "S1v"
              },
              dialogCodeHook: {
                shape: "S1y"
              },
              fulfillmentCodeHook: {
                shape: "S1z"
              },
              slotPriorities: {
                shape: "S5x"
              },
              intentConfirmationSetting: {
                shape: "S2q"
              },
              intentClosingSetting: {
                shape: "S2t"
              },
              inputContexts: {
                shape: "S2u"
              },
              outputContexts: {
                shape: "S2w"
              },
              kendraConfiguration: {
                shape: "S30"
              },
              botId: {},
              botVersion: {},
              localeId: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateResourcePolicy: {
          http: {
            method: "PUT",
            requestUri: "/policy/{resourceArn}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "policy"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              policy: {},
              expectedRevisionId: {
                location: "querystring",
                locationName: "expectedRevisionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              resourceArn: {},
              revisionId: {}
            }
          }
        },
        UpdateSlot: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/intents/{intentId}/slots/{slotId}/",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "slotId",
              "slotName",
              "slotTypeId",
              "valueElicitationSetting",
              "botId",
              "botVersion",
              "localeId",
              "intentId"
            ],
            members: {
              slotId: {
                location: "uri",
                locationName: "slotId"
              },
              slotName: {},
              description: {},
              slotTypeId: {},
              valueElicitationSetting: {
                shape: "S3p"
              },
              obfuscationSetting: {
                shape: "S3z"
              },
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              intentId: {
                location: "uri",
                locationName: "intentId"
              },
              multipleValuesSetting: {
                shape: "S41"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              slotId: {},
              slotName: {},
              description: {},
              slotTypeId: {},
              valueElicitationSetting: {
                shape: "S3p"
              },
              obfuscationSetting: {
                shape: "S3z"
              },
              botId: {},
              botVersion: {},
              localeId: {},
              intentId: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              },
              multipleValuesSetting: {
                shape: "S41"
              }
            }
          }
        },
        UpdateSlotType: {
          http: {
            method: "PUT",
            requestUri: "/bots/{botId}/botversions/{botVersion}/botlocales/{localeId}/slottypes/{slotTypeId}/",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "slotTypeId",
              "slotTypeName",
              "valueSelectionSetting",
              "botId",
              "botVersion",
              "localeId"
            ],
            members: {
              slotTypeId: {
                location: "uri",
                locationName: "slotTypeId"
              },
              slotTypeName: {},
              description: {},
              slotTypeValues: {
                shape: "S44"
              },
              valueSelectionSetting: {
                shape: "S49"
              },
              parentSlotTypeSignature: {},
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botVersion: {
                location: "uri",
                locationName: "botVersion"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              slotTypeId: {},
              slotTypeName: {},
              description: {},
              slotTypeValues: {
                shape: "S44"
              },
              valueSelectionSetting: {
                shape: "S49"
              },
              parentSlotTypeSignature: {},
              botId: {},
              botVersion: {},
              localeId: {},
              creationDateTime: {
                type: "timestamp"
              },
              lastUpdatedDateTime: {
                type: "timestamp"
              }
            }
          }
        }
      },
      shapes: {
        Sc: {
          type: "structure",
          required: [
            "childDirected"
          ],
          members: {
            childDirected: {
              type: "boolean"
            }
          }
        },
        Sf: {
          type: "map",
          key: {},
          value: {}
        },
        Sm: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "enabled"
            ],
            members: {
              enabled: {
                type: "boolean"
              },
              codeHookSpecification: {
                type: "structure",
                required: [
                  "lambdaCodeHook"
                ],
                members: {
                  lambdaCodeHook: {
                    type: "structure",
                    required: [
                      "lambdaARN",
                      "codeHookInterfaceVersion"
                    ],
                    members: {
                      lambdaARN: {},
                      codeHookInterfaceVersion: {}
                    }
                  }
                }
              }
            }
          }
        },
        St: {
          type: "structure",
          members: {
            textLogSettings: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "enabled",
                  "destination"
                ],
                members: {
                  enabled: {
                    type: "boolean"
                  },
                  destination: {
                    type: "structure",
                    required: [
                      "cloudWatch"
                    ],
                    members: {
                      cloudWatch: {
                        type: "structure",
                        required: [
                          "cloudWatchLogGroupArn",
                          "logPrefix"
                        ],
                        members: {
                          cloudWatchLogGroupArn: {},
                          logPrefix: {}
                        }
                      }
                    }
                  }
                }
              }
            },
            audioLogSettings: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "enabled",
                  "destination"
                ],
                members: {
                  enabled: {
                    type: "boolean"
                  },
                  destination: {
                    type: "structure",
                    required: [
                      "s3Bucket"
                    ],
                    members: {
                      s3Bucket: {
                        type: "structure",
                        required: [
                          "s3BucketArn",
                          "logPrefix"
                        ],
                        members: {
                          kmsKeyArn: {},
                          s3BucketArn: {},
                          logPrefix: {}
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S16: {
          type: "structure",
          required: [
            "detectSentiment"
          ],
          members: {
            detectSentiment: {
              type: "boolean"
            }
          }
        },
        S1c: {
          type: "structure",
          required: [
            "voiceId"
          ],
          members: {
            voiceId: {}
          }
        },
        S1h: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            required: [
              "sourceBotVersion"
            ],
            members: {
              sourceBotVersion: {}
            }
          }
        },
        S1m: {
          type: "structure",
          members: {
            botExportSpecification: {
              type: "structure",
              required: [
                "botId",
                "botVersion"
              ],
              members: {
                botId: {},
                botVersion: {}
              }
            },
            botLocaleExportSpecification: {
              type: "structure",
              required: [
                "botId",
                "botVersion",
                "localeId"
              ],
              members: {
                botId: {},
                botVersion: {},
                localeId: {}
              }
            }
          }
        },
        S1q: {
          type: "string",
          sensitive: true
        },
        S1v: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "utterance"
            ],
            members: {
              utterance: {}
            }
          }
        },
        S1y: {
          type: "structure",
          required: [
            "enabled"
          ],
          members: {
            enabled: {
              type: "boolean"
            }
          }
        },
        S1z: {
          type: "structure",
          required: [
            "enabled"
          ],
          members: {
            enabled: {
              type: "boolean"
            },
            postFulfillmentStatusSpecification: {
              type: "structure",
              members: {
                successResponse: {
                  shape: "S21"
                },
                failureResponse: {
                  shape: "S21"
                },
                timeoutResponse: {
                  shape: "S21"
                }
              }
            },
            fulfillmentUpdatesSpecification: {
              type: "structure",
              required: [
                "active"
              ],
              members: {
                active: {
                  type: "boolean"
                },
                startResponse: {
                  type: "structure",
                  required: [
                    "delayInSeconds",
                    "messageGroups"
                  ],
                  members: {
                    delayInSeconds: {
                      type: "integer"
                    },
                    messageGroups: {
                      shape: "S22"
                    },
                    allowInterrupt: {
                      type: "boolean"
                    }
                  }
                },
                updateResponse: {
                  type: "structure",
                  required: [
                    "frequencyInSeconds",
                    "messageGroups"
                  ],
                  members: {
                    frequencyInSeconds: {
                      type: "integer"
                    },
                    messageGroups: {
                      shape: "S22"
                    },
                    allowInterrupt: {
                      type: "boolean"
                    }
                  }
                },
                timeoutInSeconds: {
                  type: "integer"
                }
              }
            }
          }
        },
        S21: {
          type: "structure",
          required: [
            "messageGroups"
          ],
          members: {
            messageGroups: {
              shape: "S22"
            },
            allowInterrupt: {
              type: "boolean"
            }
          }
        },
        S22: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "message"
            ],
            members: {
              message: {
                shape: "S24"
              },
              variations: {
                type: "list",
                member: {
                  shape: "S24"
                }
              }
            }
          }
        },
        S24: {
          type: "structure",
          members: {
            plainTextMessage: {
              type: "structure",
              required: [
                "value"
              ],
              members: {
                value: {}
              }
            },
            customPayload: {
              type: "structure",
              required: [
                "value"
              ],
              members: {
                value: {}
              }
            },
            ssmlMessage: {
              type: "structure",
              required: [
                "value"
              ],
              members: {
                value: {}
              }
            },
            imageResponseCard: {
              type: "structure",
              required: [
                "title"
              ],
              members: {
                title: {},
                subtitle: {},
                imageUrl: {},
                buttons: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "text",
                      "value"
                    ],
                    members: {
                      text: {},
                      value: {}
                    }
                  }
                }
              }
            }
          }
        },
        S2q: {
          type: "structure",
          required: [
            "promptSpecification",
            "declinationResponse"
          ],
          members: {
            promptSpecification: {
              shape: "S2r"
            },
            declinationResponse: {
              shape: "S21"
            },
            active: {
              type: "boolean"
            }
          }
        },
        S2r: {
          type: "structure",
          required: [
            "messageGroups",
            "maxRetries"
          ],
          members: {
            messageGroups: {
              shape: "S22"
            },
            maxRetries: {
              type: "integer"
            },
            allowInterrupt: {
              type: "boolean"
            }
          }
        },
        S2t: {
          type: "structure",
          required: [
            "closingResponse"
          ],
          members: {
            closingResponse: {
              shape: "S21"
            },
            active: {
              type: "boolean"
            }
          }
        },
        S2u: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          }
        },
        S2w: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "name",
              "timeToLiveInSeconds",
              "turnsToLive"
            ],
            members: {
              name: {},
              timeToLiveInSeconds: {
                type: "integer"
              },
              turnsToLive: {
                type: "integer"
              }
            }
          }
        },
        S30: {
          type: "structure",
          required: [
            "kendraIndex"
          ],
          members: {
            kendraIndex: {},
            queryFilterStringEnabled: {
              type: "boolean"
            },
            queryFilterString: {}
          }
        },
        S3p: {
          type: "structure",
          required: [
            "slotConstraint"
          ],
          members: {
            defaultValueSpecification: {
              type: "structure",
              required: [
                "defaultValueList"
              ],
              members: {
                defaultValueList: {
                  type: "list",
                  member: {
                    type: "structure",
                    required: [
                      "defaultValue"
                    ],
                    members: {
                      defaultValue: {}
                    }
                  }
                }
              }
            },
            slotConstraint: {},
            promptSpecification: {
              shape: "S2r"
            },
            sampleUtterances: {
              shape: "S1v"
            },
            waitAndContinueSpecification: {
              type: "structure",
              required: [
                "waitingResponse",
                "continueResponse"
              ],
              members: {
                waitingResponse: {
                  shape: "S21"
                },
                continueResponse: {
                  shape: "S21"
                },
                stillWaitingResponse: {
                  type: "structure",
                  required: [
                    "messageGroups",
                    "frequencyInSeconds",
                    "timeoutInSeconds"
                  ],
                  members: {
                    messageGroups: {
                      shape: "S22"
                    },
                    frequencyInSeconds: {
                      type: "integer"
                    },
                    timeoutInSeconds: {
                      type: "integer"
                    },
                    allowInterrupt: {
                      type: "boolean"
                    }
                  }
                },
                active: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S3z: {
          type: "structure",
          required: [
            "obfuscationSettingType"
          ],
          members: {
            obfuscationSettingType: {}
          }
        },
        S41: {
          type: "structure",
          members: {
            allowMultipleValues: {
              type: "boolean"
            }
          }
        },
        S44: {
          type: "list",
          member: {
            type: "structure",
            members: {
              sampleValue: {
                shape: "S46"
              },
              synonyms: {
                type: "list",
                member: {
                  shape: "S46"
                }
              }
            }
          }
        },
        S46: {
          type: "structure",
          required: [
            "value"
          ],
          members: {
            value: {}
          }
        },
        S49: {
          type: "structure",
          required: [
            "resolutionStrategy"
          ],
          members: {
            resolutionStrategy: {},
            regexFilter: {
              type: "structure",
              required: [
                "pattern"
              ],
              members: {
                pattern: {}
              }
            }
          }
        },
        S5f: {
          type: "list",
          member: {}
        },
        S5q: {
          type: "structure",
          members: {
            botImportSpecification: {
              type: "structure",
              required: [
                "botName",
                "roleArn",
                "dataPrivacy"
              ],
              members: {
                botName: {},
                roleArn: {},
                dataPrivacy: {
                  shape: "Sc"
                },
                idleSessionTTLInSeconds: {
                  type: "integer"
                },
                botTags: {
                  shape: "Sf"
                },
                testBotAliasTags: {
                  shape: "Sf"
                }
              }
            },
            botLocaleImportSpecification: {
              type: "structure",
              required: [
                "botId",
                "botVersion",
                "localeId"
              ],
              members: {
                botId: {},
                botVersion: {},
                localeId: {},
                nluIntentConfidenceThreshold: {
                  type: "double"
                },
                voiceSettings: {
                  shape: "S1c"
                }
              }
            }
          }
        },
        S5x: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "priority",
              "slotId"
            ],
            members: {
              priority: {
                type: "integer"
              },
              slotId: {}
            }
          }
        },
        S67: {
          type: "structure",
          required: [
            "relativeAggregationDuration"
          ],
          members: {
            relativeAggregationDuration: {
              type: "structure",
              required: [
                "timeDimension",
                "timeValue"
              ],
              members: {
                timeDimension: {},
                timeValue: {
                  type: "integer"
                }
              }
            }
          }
        },
        S6h: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/models.lex.v2-2020-08-07.paginators.json
var require_models_lex_v2_2020_08_07_paginators = __commonJS({
  "node_modules/aws-sdk/apis/models.lex.v2-2020-08-07.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAggregatedUtterances: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListBotAliases: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListBotLocales: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListBotVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListBots: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListBuiltInIntents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListBuiltInSlotTypes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListExports: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListImports: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListIntents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListSlotTypes: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListSlots: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/models.lex.v2-2020-08-07.waiters2.json
var require_models_lex_v2_2020_08_07_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/models.lex.v2-2020-08-07.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        BotAvailable: {
          delay: 10,
          operation: "DescribeBot",
          maxAttempts: 35,
          description: "Wait until a bot is available",
          acceptors: [
            {
              expected: "Available",
              matcher: "path",
              state: "success",
              argument: "botStatus"
            },
            {
              expected: "Deleting",
              matcher: "path",
              state: "failure",
              argument: "botStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "botStatus"
            },
            {
              expected: "Inactive",
              matcher: "path",
              state: "failure",
              argument: "botStatus"
            }
          ]
        },
        BotAliasAvailable: {
          delay: 10,
          operation: "DescribeBotAlias",
          maxAttempts: 35,
          description: "Wait until a bot alias is available",
          acceptors: [
            {
              expected: "Available",
              matcher: "path",
              state: "success",
              argument: "botAliasStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "botAliasStatus"
            },
            {
              expected: "Deleting",
              matcher: "path",
              state: "failure",
              argument: "botAliasStatus"
            }
          ]
        },
        BotExportCompleted: {
          delay: 10,
          operation: "DescribeExport",
          maxAttempts: 35,
          description: "Wait until a bot has been exported",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "exportStatus"
            },
            {
              expected: "Deleting",
              matcher: "path",
              state: "failure",
              argument: "exportStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "exportStatus"
            }
          ]
        },
        BotImportCompleted: {
          delay: 10,
          operation: "DescribeImport",
          maxAttempts: 35,
          description: "Wait until a bot has been imported",
          acceptors: [
            {
              expected: "Completed",
              matcher: "path",
              state: "success",
              argument: "importStatus"
            },
            {
              expected: "Deleting",
              matcher: "path",
              state: "failure",
              argument: "importStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "importStatus"
            }
          ]
        },
        BotLocaleBuilt: {
          delay: 10,
          operation: "DescribeBotLocale",
          maxAttempts: 35,
          description: "Wait until a bot locale is built",
          acceptors: [
            {
              expected: "Built",
              matcher: "path",
              state: "success",
              argument: "botLocaleStatus"
            },
            {
              expected: "Deleting",
              matcher: "path",
              state: "failure",
              argument: "botLocaleStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "botLocaleStatus"
            },
            {
              expected: "NotBuilt",
              matcher: "path",
              state: "failure",
              argument: "botLocaleStatus"
            }
          ]
        },
        BotLocaleExpressTestingAvailable: {
          delay: 10,
          operation: "DescribeBotLocale",
          maxAttempts: 35,
          description: "Wait until a bot locale build is ready for express testing",
          acceptors: [
            {
              expected: "Built",
              matcher: "path",
              state: "success",
              argument: "botLocaleStatus"
            },
            {
              expected: "ReadyExpressTesting",
              matcher: "path",
              state: "success",
              argument: "botLocaleStatus"
            },
            {
              expected: "Deleting",
              matcher: "path",
              state: "failure",
              argument: "botLocaleStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "botLocaleStatus"
            },
            {
              expected: "NotBuilt",
              matcher: "path",
              state: "failure",
              argument: "botLocaleStatus"
            }
          ]
        },
        BotVersionAvailable: {
          delay: 10,
          operation: "DescribeBotVersion",
          maxAttempts: 35,
          description: "Wait until a bot version is available",
          acceptors: [
            {
              expected: "Available",
              matcher: "path",
              state: "success",
              argument: "botStatus"
            },
            {
              expected: "Deleting",
              matcher: "path",
              state: "failure",
              argument: "botStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "botStatus"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 404
            }
          ]
        },
        BotLocaleCreated: {
          delay: 10,
          operation: "DescribeBotLocale",
          maxAttempts: 35,
          description: "Wait unit a bot locale is created",
          acceptors: [
            {
              expected: "Built",
              matcher: "path",
              state: "success",
              argument: "botLocaleStatus"
            },
            {
              expected: "ReadyExpressTesting",
              matcher: "path",
              state: "success",
              argument: "botLocaleStatus"
            },
            {
              expected: "NotBuilt",
              matcher: "path",
              state: "success",
              argument: "botLocaleStatus"
            },
            {
              expected: "Deleting",
              matcher: "path",
              state: "failure",
              argument: "botLocaleStatus"
            },
            {
              expected: "Failed",
              matcher: "path",
              state: "failure",
              argument: "botLocaleStatus"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/lexmodelsv2.js
var require_lexmodelsv22 = __commonJS({
  "node_modules/aws-sdk/clients/lexmodelsv2.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["lexmodelsv2"] = {};
    AWS3.LexModelsV2 = Service.defineService("lexmodelsv2", ["2020-08-07"]);
    require_lexmodelsv2();
    Object.defineProperty(apiLoader.services["lexmodelsv2"], "2020-08-07", {
      get: function get() {
        var model = require_models_lex_v2_2020_08_07_min();
        model.paginators = require_models_lex_v2_2020_08_07_paginators().pagination;
        model.waiters = require_models_lex_v2_2020_08_07_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.LexModelsV2;
  }
});

// node_modules/aws-sdk/apis/runtime.lex.v2-2020-08-07.min.json
var require_runtime_lex_v2_2020_08_07_min = __commonJS({
  "node_modules/aws-sdk/apis/runtime.lex.v2-2020-08-07.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-08-07",
        endpointPrefix: "runtime-v2-lex",
        jsonVersion: "1.1",
        protocol: "rest-json",
        protocolSettings: {
          h2: "eventstream"
        },
        serviceAbbreviation: "Lex Runtime V2",
        serviceFullName: "Amazon Lex Runtime V2",
        serviceId: "Lex Runtime V2",
        signatureVersion: "v4",
        signingName: "lex",
        uid: "runtime.lex.v2-2020-08-07"
      },
      operations: {
        DeleteSession: {
          http: {
            method: "DELETE",
            requestUri: "/bots/{botId}/botAliases/{botAliasId}/botLocales/{localeId}/sessions/{sessionId}"
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botAliasId",
              "sessionId",
              "localeId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botAliasId: {
                location: "uri",
                locationName: "botAliasId"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              botId: {},
              botAliasId: {},
              localeId: {},
              sessionId: {}
            }
          }
        },
        GetSession: {
          http: {
            method: "GET",
            requestUri: "/bots/{botId}/botAliases/{botAliasId}/botLocales/{localeId}/sessions/{sessionId}"
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botAliasId",
              "localeId",
              "sessionId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botAliasId: {
                location: "uri",
                locationName: "botAliasId"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              sessionId: {},
              messages: {
                shape: "Sa"
              },
              interpretations: {
                shape: "Sl"
              },
              sessionState: {
                shape: "S11"
              }
            }
          }
        },
        PutSession: {
          http: {
            requestUri: "/bots/{botId}/botAliases/{botAliasId}/botLocales/{localeId}/sessions/{sessionId}"
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botAliasId",
              "localeId",
              "sessionState",
              "sessionId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botAliasId: {
                location: "uri",
                locationName: "botAliasId"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              },
              messages: {
                shape: "Sa"
              },
              sessionState: {
                shape: "S11"
              },
              requestAttributes: {
                shape: "S1c"
              },
              responseContentType: {
                location: "header",
                locationName: "ResponseContentType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              messages: {
                location: "header",
                locationName: "x-amz-lex-messages"
              },
              sessionState: {
                location: "header",
                locationName: "x-amz-lex-session-state"
              },
              requestAttributes: {
                location: "header",
                locationName: "x-amz-lex-request-attributes"
              },
              sessionId: {
                location: "header",
                locationName: "x-amz-lex-session-id"
              },
              audioStream: {
                shape: "S1g"
              }
            },
            payload: "audioStream"
          }
        },
        RecognizeText: {
          http: {
            requestUri: "/bots/{botId}/botAliases/{botAliasId}/botLocales/{localeId}/sessions/{sessionId}/text"
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botAliasId",
              "localeId",
              "text",
              "sessionId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botAliasId: {
                location: "uri",
                locationName: "botAliasId"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              },
              text: {
                shape: "Sc"
              },
              sessionState: {
                shape: "S11"
              },
              requestAttributes: {
                shape: "S1c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              messages: {
                shape: "Sa"
              },
              sessionState: {
                shape: "S11"
              },
              interpretations: {
                shape: "Sl"
              },
              requestAttributes: {
                shape: "S1c"
              },
              sessionId: {}
            }
          }
        },
        RecognizeUtterance: {
          http: {
            requestUri: "/bots/{botId}/botAliases/{botAliasId}/botLocales/{localeId}/sessions/{sessionId}/utterance"
          },
          input: {
            type: "structure",
            required: [
              "botId",
              "botAliasId",
              "localeId",
              "requestContentType",
              "sessionId"
            ],
            members: {
              botId: {
                location: "uri",
                locationName: "botId"
              },
              botAliasId: {
                location: "uri",
                locationName: "botAliasId"
              },
              localeId: {
                location: "uri",
                locationName: "localeId"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              },
              sessionState: {
                shape: "S1k",
                location: "header",
                locationName: "x-amz-lex-session-state"
              },
              requestAttributes: {
                shape: "S1k",
                location: "header",
                locationName: "x-amz-lex-request-attributes"
              },
              requestContentType: {
                location: "header",
                locationName: "Content-Type"
              },
              responseContentType: {
                location: "header",
                locationName: "Response-Content-Type"
              },
              inputStream: {
                shape: "S1g"
              }
            },
            payload: "inputStream"
          },
          output: {
            type: "structure",
            members: {
              inputMode: {
                location: "header",
                locationName: "x-amz-lex-input-mode"
              },
              contentType: {
                location: "header",
                locationName: "Content-Type"
              },
              messages: {
                location: "header",
                locationName: "x-amz-lex-messages"
              },
              interpretations: {
                location: "header",
                locationName: "x-amz-lex-interpretations"
              },
              sessionState: {
                location: "header",
                locationName: "x-amz-lex-session-state"
              },
              requestAttributes: {
                location: "header",
                locationName: "x-amz-lex-request-attributes"
              },
              sessionId: {
                location: "header",
                locationName: "x-amz-lex-session-id"
              },
              inputTranscript: {
                location: "header",
                locationName: "x-amz-lex-input-transcript"
              },
              audioStream: {
                shape: "S1g"
              }
            },
            payload: "audioStream"
          },
          authtype: "v4-unsigned-body"
        }
      },
      shapes: {
        Sa: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "contentType"
            ],
            members: {
              content: {
                shape: "Sc"
              },
              contentType: {},
              imageResponseCard: {
                type: "structure",
                required: [
                  "title"
                ],
                members: {
                  title: {},
                  subtitle: {},
                  imageUrl: {},
                  buttons: {
                    type: "list",
                    member: {
                      type: "structure",
                      required: [
                        "text",
                        "value"
                      ],
                      members: {
                        text: {},
                        value: {}
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sc: {
          type: "string",
          sensitive: true
        },
        Sl: {
          type: "list",
          member: {
            type: "structure",
            members: {
              nluConfidence: {
                type: "structure",
                members: {
                  score: {
                    type: "double"
                  }
                }
              },
              sentimentResponse: {
                type: "structure",
                members: {
                  sentiment: {},
                  sentimentScore: {
                    type: "structure",
                    members: {
                      positive: {
                        type: "double"
                      },
                      negative: {
                        type: "double"
                      },
                      neutral: {
                        type: "double"
                      },
                      mixed: {
                        type: "double"
                      }
                    }
                  }
                }
              },
              intent: {
                shape: "Ss"
              }
            }
          }
        },
        Ss: {
          type: "structure",
          required: [
            "name"
          ],
          members: {
            name: {},
            slots: {
              type: "map",
              key: {},
              value: {
                shape: "Su"
              }
            },
            state: {},
            confirmationState: {}
          }
        },
        Su: {
          type: "structure",
          members: {
            value: {
              type: "structure",
              required: [
                "interpretedValue"
              ],
              members: {
                originalValue: {},
                interpretedValue: {},
                resolvedValues: {
                  type: "list",
                  member: {}
                }
              }
            },
            shape: {},
            values: {
              type: "list",
              member: {
                shape: "Su"
              }
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            dialogAction: {
              type: "structure",
              required: [
                "type"
              ],
              members: {
                type: {},
                slotToElicit: {}
              }
            },
            intent: {
              shape: "Ss"
            },
            activeContexts: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "name",
                  "timeToLive",
                  "contextAttributes"
                ],
                members: {
                  name: {},
                  timeToLive: {
                    type: "structure",
                    required: [
                      "timeToLiveInSeconds",
                      "turnsToLive"
                    ],
                    members: {
                      timeToLiveInSeconds: {
                        type: "integer"
                      },
                      turnsToLive: {
                        type: "integer"
                      }
                    }
                  },
                  contextAttributes: {
                    type: "map",
                    key: {},
                    value: {
                      shape: "Sc"
                    }
                  }
                }
              }
            },
            sessionAttributes: {
              shape: "S1c"
            },
            originatingRequestId: {}
          }
        },
        S1c: {
          type: "map",
          key: {},
          value: {}
        },
        S1g: {
          type: "blob",
          streaming: true
        },
        S1k: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/runtime.lex.v2-2020-08-07.paginators.json
var require_runtime_lex_v2_2020_08_07_paginators = __commonJS({
  "node_modules/aws-sdk/apis/runtime.lex.v2-2020-08-07.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/lexruntimev2.js
var require_lexruntimev2 = __commonJS({
  "node_modules/aws-sdk/clients/lexruntimev2.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["lexruntimev2"] = {};
    AWS3.LexRuntimeV2 = Service.defineService("lexruntimev2", ["2020-08-07"]);
    Object.defineProperty(apiLoader.services["lexruntimev2"], "2020-08-07", {
      get: function get() {
        var model = require_runtime_lex_v2_2020_08_07_min();
        model.paginators = require_runtime_lex_v2_2020_08_07_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.LexRuntimeV2;
  }
});

// node_modules/aws-sdk/apis/fis-2020-12-01.min.json
var require_fis_2020_12_01_min = __commonJS({
  "node_modules/aws-sdk/apis/fis-2020-12-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-12-01",
        endpointPrefix: "fis",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "FIS",
        serviceFullName: "AWS Fault Injection Simulator",
        serviceId: "fis",
        signatureVersion: "v4",
        signingName: "fis",
        uid: "fis-2020-12-01"
      },
      operations: {
        CreateExperimentTemplate: {
          http: {
            requestUri: "/experimentTemplates",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "clientToken",
              "description",
              "stopConditions",
              "actions",
              "roleArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              stopConditions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "source"
                  ],
                  members: {
                    source: {},
                    value: {}
                  }
                }
              },
              targets: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "resourceType",
                    "selectionMode"
                  ],
                  members: {
                    resourceType: {},
                    resourceArns: {
                      shape: "Sc"
                    },
                    resourceTags: {
                      shape: "Se"
                    },
                    filters: {
                      shape: "Sh"
                    },
                    selectionMode: {}
                  }
                }
              },
              actions: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "actionId"
                  ],
                  members: {
                    actionId: {},
                    description: {},
                    parameters: {
                      shape: "Ss"
                    },
                    targets: {
                      shape: "Sv"
                    },
                    startAfter: {
                      shape: "Sx"
                    }
                  }
                }
              },
              roleArn: {},
              tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              experimentTemplate: {
                shape: "S11"
              }
            }
          }
        },
        DeleteExperimentTemplate: {
          http: {
            method: "DELETE",
            requestUri: "/experimentTemplates/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              experimentTemplate: {
                shape: "S11"
              }
            }
          }
        },
        GetAction: {
          http: {
            method: "GET",
            requestUri: "/actions/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              action: {
                type: "structure",
                members: {
                  id: {},
                  description: {},
                  parameters: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      members: {
                        description: {},
                        required: {
                          type: "boolean"
                        }
                      }
                    }
                  },
                  targets: {
                    shape: "S1o"
                  },
                  tags: {
                    shape: "Se"
                  }
                }
              }
            }
          }
        },
        GetExperiment: {
          http: {
            method: "GET",
            requestUri: "/experiments/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              experiment: {
                shape: "S1v"
              }
            }
          }
        },
        GetExperimentTemplate: {
          http: {
            method: "GET",
            requestUri: "/experimentTemplates/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              experimentTemplate: {
                shape: "S11"
              }
            }
          }
        },
        ListActions: {
          http: {
            method: "GET",
            requestUri: "/actions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              actions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    description: {},
                    targets: {
                      shape: "S1o"
                    },
                    tags: {
                      shape: "Se"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListExperimentTemplates: {
          http: {
            method: "GET",
            requestUri: "/experimentTemplates",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              experimentTemplates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    description: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    lastUpdateTime: {
                      type: "timestamp"
                    },
                    tags: {
                      shape: "Se"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListExperiments: {
          http: {
            method: "GET",
            requestUri: "/experiments",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              experiments: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    id: {},
                    experimentTemplateId: {},
                    state: {
                      shape: "S1w"
                    },
                    creationTime: {
                      type: "timestamp"
                    },
                    tags: {
                      shape: "Se"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Se"
              }
            }
          }
        },
        StartExperiment: {
          http: {
            requestUri: "/experiments",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "clientToken",
              "experimentTemplateId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              experimentTemplateId: {},
              tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              experiment: {
                shape: "S1v"
              }
            }
          }
        },
        StopExperiment: {
          http: {
            method: "DELETE",
            requestUri: "/experiments/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              experiment: {
                shape: "S1v"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Se"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateExperimentTemplate: {
          http: {
            method: "PATCH",
            requestUri: "/experimentTemplates/{id}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {
                location: "uri",
                locationName: "id"
              },
              description: {},
              stopConditions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "source"
                  ],
                  members: {
                    source: {},
                    value: {}
                  }
                }
              },
              targets: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  required: [
                    "resourceType",
                    "selectionMode"
                  ],
                  members: {
                    resourceType: {},
                    resourceArns: {
                      shape: "Sc"
                    },
                    resourceTags: {
                      shape: "Se"
                    },
                    filters: {
                      shape: "Sh"
                    },
                    selectionMode: {}
                  }
                }
              },
              actions: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    actionId: {},
                    description: {},
                    parameters: {
                      shape: "Ss"
                    },
                    targets: {
                      shape: "Sv"
                    },
                    startAfter: {
                      shape: "Sx"
                    }
                  }
                }
              },
              roleArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              experimentTemplate: {
                shape: "S11"
              }
            }
          }
        }
      },
      shapes: {
        Sc: {
          type: "list",
          member: {}
        },
        Se: {
          type: "map",
          key: {},
          value: {}
        },
        Sh: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "path",
              "values"
            ],
            members: {
              path: {},
              values: {
                shape: "Sk"
              }
            }
          }
        },
        Sk: {
          type: "list",
          member: {}
        },
        Ss: {
          type: "map",
          key: {},
          value: {}
        },
        Sv: {
          type: "map",
          key: {},
          value: {}
        },
        Sx: {
          type: "list",
          member: {}
        },
        S11: {
          type: "structure",
          members: {
            id: {},
            description: {},
            targets: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  resourceType: {},
                  resourceArns: {
                    shape: "Sc"
                  },
                  resourceTags: {
                    shape: "Se"
                  },
                  filters: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        path: {},
                        values: {
                          shape: "Sk"
                        }
                      }
                    }
                  },
                  selectionMode: {}
                }
              }
            },
            actions: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  actionId: {},
                  description: {},
                  parameters: {
                    shape: "Ss"
                  },
                  targets: {
                    shape: "Sv"
                  },
                  startAfter: {
                    shape: "Sx"
                  }
                }
              }
            },
            stopConditions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  source: {},
                  value: {}
                }
              }
            },
            creationTime: {
              type: "timestamp"
            },
            lastUpdateTime: {
              type: "timestamp"
            },
            roleArn: {},
            tags: {
              shape: "Se"
            }
          }
        },
        S1o: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              resourceType: {}
            }
          }
        },
        S1v: {
          type: "structure",
          members: {
            id: {},
            experimentTemplateId: {},
            roleArn: {},
            state: {
              shape: "S1w"
            },
            targets: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  resourceType: {},
                  resourceArns: {
                    shape: "Sc"
                  },
                  resourceTags: {
                    shape: "Se"
                  },
                  filters: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        path: {},
                        values: {
                          type: "list",
                          member: {}
                        }
                      }
                    }
                  },
                  selectionMode: {}
                }
              }
            },
            actions: {
              type: "map",
              key: {},
              value: {
                type: "structure",
                members: {
                  actionId: {},
                  description: {},
                  parameters: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  targets: {
                    type: "map",
                    key: {},
                    value: {}
                  },
                  startAfter: {
                    type: "list",
                    member: {}
                  },
                  state: {
                    type: "structure",
                    members: {
                      status: {},
                      reason: {}
                    }
                  }
                }
              }
            },
            stopConditions: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  source: {},
                  value: {}
                }
              }
            },
            creationTime: {
              type: "timestamp"
            },
            startTime: {
              type: "timestamp"
            },
            endTime: {
              type: "timestamp"
            },
            tags: {
              shape: "Se"
            }
          }
        },
        S1w: {
          type: "structure",
          members: {
            status: {},
            reason: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/fis-2020-12-01.paginators.json
var require_fis_2020_12_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/fis-2020-12-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListActions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListExperimentTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        },
        ListExperiments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/fis.js
var require_fis = __commonJS({
  "node_modules/aws-sdk/clients/fis.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["fis"] = {};
    AWS3.Fis = Service.defineService("fis", ["2020-12-01"]);
    Object.defineProperty(apiLoader.services["fis"], "2020-12-01", {
      get: function get() {
        var model = require_fis_2020_12_01_min();
        model.paginators = require_fis_2020_12_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Fis;
  }
});

// node_modules/aws-sdk/lib/services/lookoutmetrics.js
var require_lookoutmetrics = __commonJS({
  "node_modules/aws-sdk/lib/services/lookoutmetrics.js"() {
    var AWS3 = require_core();
    AWS3.util.update(AWS3.LookoutMetrics.prototype, {
      setupRequestListeners: function setupRequestListeners(request) {
        request.addListener("build", this.modifyContentType);
      },
      modifyContentType: function modifyContentType(request) {
        if (request.httpRequest.headers["Content-Type"] === "application/json") {
          request.httpRequest.headers["Content-Type"] = "application/x-amz-json-1.1";
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/lookoutmetrics-2017-07-25.min.json
var require_lookoutmetrics_2017_07_25_min = __commonJS({
  "node_modules/aws-sdk/apis/lookoutmetrics-2017-07-25.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2017-07-25",
        endpointPrefix: "lookoutmetrics",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "LookoutMetrics",
        serviceFullName: "Amazon Lookout for Metrics",
        serviceId: "LookoutMetrics",
        signatureVersion: "v4",
        signingName: "lookoutmetrics",
        uid: "lookoutmetrics-2017-07-25"
      },
      operations: {
        ActivateAnomalyDetector: {
          http: {
            requestUri: "/ActivateAnomalyDetector"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn"
            ],
            members: {
              AnomalyDetectorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        BackTestAnomalyDetector: {
          http: {
            requestUri: "/BackTestAnomalyDetector"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn"
            ],
            members: {
              AnomalyDetectorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateAlert: {
          http: {
            requestUri: "/CreateAlert"
          },
          input: {
            type: "structure",
            required: [
              "AlertName",
              "AlertSensitivityThreshold",
              "AnomalyDetectorArn",
              "Action"
            ],
            members: {
              AlertName: {},
              AlertSensitivityThreshold: {
                type: "integer"
              },
              AlertDescription: {},
              AnomalyDetectorArn: {},
              Action: {
                shape: "Sa"
              },
              Tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AlertArn: {}
            }
          }
        },
        CreateAnomalyDetector: {
          http: {
            requestUri: "/CreateAnomalyDetector"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorName",
              "AnomalyDetectorConfig"
            ],
            members: {
              AnomalyDetectorName: {},
              AnomalyDetectorDescription: {},
              AnomalyDetectorConfig: {
                shape: "Sk"
              },
              KmsKeyArn: {},
              Tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AnomalyDetectorArn: {}
            }
          }
        },
        CreateMetricSet: {
          http: {
            requestUri: "/CreateMetricSet"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn",
              "MetricSetName",
              "MetricList",
              "MetricSource"
            ],
            members: {
              AnomalyDetectorArn: {},
              MetricSetName: {},
              MetricSetDescription: {},
              MetricList: {
                shape: "Sr"
              },
              Offset: {
                type: "integer"
              },
              TimestampColumn: {
                shape: "Sx"
              },
              DimensionList: {
                shape: "Sz"
              },
              MetricSetFrequency: {},
              MetricSource: {
                shape: "S10"
              },
              Timezone: {},
              Tags: {
                shape: "Sd"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MetricSetArn: {}
            }
          }
        },
        DeleteAlert: {
          http: {
            requestUri: "/DeleteAlert"
          },
          input: {
            type: "structure",
            required: [
              "AlertArn"
            ],
            members: {
              AlertArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteAnomalyDetector: {
          http: {
            requestUri: "/DeleteAnomalyDetector"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn"
            ],
            members: {
              AnomalyDetectorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeAlert: {
          http: {
            requestUri: "/DescribeAlert"
          },
          input: {
            type: "structure",
            required: [
              "AlertArn"
            ],
            members: {
              AlertArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Alert: {
                type: "structure",
                members: {
                  Action: {
                    shape: "Sa"
                  },
                  AlertDescription: {},
                  AlertArn: {},
                  AnomalyDetectorArn: {},
                  AlertName: {},
                  AlertSensitivityThreshold: {
                    type: "integer"
                  },
                  AlertType: {},
                  AlertStatus: {},
                  LastModificationTime: {
                    type: "timestamp"
                  },
                  CreationTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeAnomalyDetectionExecutions: {
          http: {
            requestUri: "/DescribeAnomalyDetectionExecutions"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn"
            ],
            members: {
              AnomalyDetectorArn: {},
              Timestamp: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ExecutionList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Timestamp: {},
                    Status: {},
                    FailureReason: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeAnomalyDetector: {
          http: {
            requestUri: "/DescribeAnomalyDetector"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn"
            ],
            members: {
              AnomalyDetectorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AnomalyDetectorArn: {},
              AnomalyDetectorName: {},
              AnomalyDetectorDescription: {},
              AnomalyDetectorConfig: {
                type: "structure",
                members: {
                  AnomalyDetectorFrequency: {}
                }
              },
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              },
              Status: {},
              FailureReason: {},
              KmsKeyArn: {}
            }
          }
        },
        DescribeMetricSet: {
          http: {
            requestUri: "/DescribeMetricSet"
          },
          input: {
            type: "structure",
            required: [
              "MetricSetArn"
            ],
            members: {
              MetricSetArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MetricSetArn: {},
              AnomalyDetectorArn: {},
              MetricSetName: {},
              MetricSetDescription: {},
              CreationTime: {
                type: "timestamp"
              },
              LastModificationTime: {
                type: "timestamp"
              },
              Offset: {
                type: "integer"
              },
              MetricList: {
                shape: "Sr"
              },
              TimestampColumn: {
                shape: "Sx"
              },
              DimensionList: {
                shape: "Sz"
              },
              MetricSetFrequency: {},
              Timezone: {},
              MetricSource: {
                shape: "S10"
              }
            }
          }
        },
        GetAnomalyGroup: {
          http: {
            requestUri: "/GetAnomalyGroup"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyGroupId",
              "AnomalyDetectorArn"
            ],
            members: {
              AnomalyGroupId: {},
              AnomalyDetectorArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AnomalyGroup: {
                type: "structure",
                members: {
                  StartTime: {},
                  EndTime: {},
                  AnomalyGroupId: {},
                  AnomalyGroupScore: {
                    type: "double"
                  },
                  PrimaryMetricName: {},
                  MetricLevelImpactList: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        MetricName: {},
                        NumTimeSeries: {
                          type: "integer"
                        },
                        ContributionMatrix: {
                          type: "structure",
                          members: {
                            DimensionContributionList: {
                              type: "list",
                              member: {
                                type: "structure",
                                members: {
                                  DimensionName: {},
                                  DimensionValueContributionList: {
                                    type: "list",
                                    member: {
                                      type: "structure",
                                      members: {
                                        DimensionValue: {},
                                        ContributionScore: {
                                          type: "double"
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        GetFeedback: {
          http: {
            requestUri: "/GetFeedback"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn",
              "AnomalyGroupTimeSeriesFeedback"
            ],
            members: {
              AnomalyDetectorArn: {},
              AnomalyGroupTimeSeriesFeedback: {
                type: "structure",
                required: [
                  "AnomalyGroupId"
                ],
                members: {
                  AnomalyGroupId: {},
                  TimeSeriesId: {}
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AnomalyGroupTimeSeriesFeedback: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    TimeSeriesId: {},
                    IsAnomaly: {
                      type: "boolean"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetSampleData: {
          http: {
            requestUri: "/GetSampleData"
          },
          input: {
            type: "structure",
            members: {
              S3SourceConfig: {
                type: "structure",
                required: [
                  "RoleArn",
                  "FileFormatDescriptor"
                ],
                members: {
                  RoleArn: {},
                  TemplatedPathList: {
                    shape: "S12"
                  },
                  HistoricalDataPathList: {
                    shape: "S14"
                  },
                  FileFormatDescriptor: {
                    shape: "S16"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              HeaderValues: {
                type: "list",
                member: {}
              },
              SampleRows: {
                type: "list",
                member: {
                  type: "list",
                  member: {}
                }
              }
            }
          }
        },
        ListAlerts: {
          http: {
            requestUri: "/ListAlerts"
          },
          input: {
            type: "structure",
            members: {
              AnomalyDetectorArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AlertSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AlertArn: {},
                    AnomalyDetectorArn: {},
                    AlertName: {},
                    AlertSensitivityThreshold: {
                      type: "integer"
                    },
                    AlertType: {},
                    AlertStatus: {},
                    LastModificationTime: {
                      type: "timestamp"
                    },
                    CreationTime: {
                      type: "timestamp"
                    },
                    Tags: {
                      shape: "Sd"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAnomalyDetectors: {
          http: {
            requestUri: "/ListAnomalyDetectors"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AnomalyDetectorSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AnomalyDetectorArn: {},
                    AnomalyDetectorName: {},
                    AnomalyDetectorDescription: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    },
                    Status: {},
                    Tags: {
                      shape: "Sd"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAnomalyGroupSummaries: {
          http: {
            requestUri: "/ListAnomalyGroupSummaries"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn",
              "SensitivityThreshold"
            ],
            members: {
              AnomalyDetectorArn: {},
              SensitivityThreshold: {
                type: "integer"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AnomalyGroupSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    StartTime: {},
                    EndTime: {},
                    AnomalyGroupId: {},
                    AnomalyGroupScore: {
                      type: "double"
                    },
                    PrimaryMetricName: {}
                  }
                }
              },
              AnomalyGroupStatistics: {
                type: "structure",
                members: {
                  EvaluationStartDate: {},
                  TotalCount: {
                    type: "integer"
                  },
                  ItemizedMetricStatsList: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        MetricName: {},
                        OccurrenceCount: {
                          type: "integer"
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListAnomalyGroupTimeSeries: {
          http: {
            requestUri: "/ListAnomalyGroupTimeSeries"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn",
              "AnomalyGroupId",
              "MetricName"
            ],
            members: {
              AnomalyDetectorArn: {},
              AnomalyGroupId: {},
              MetricName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AnomalyGroupId: {},
              MetricName: {},
              TimestampList: {
                type: "list",
                member: {}
              },
              NextToken: {},
              TimeSeriesList: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "TimeSeriesId",
                    "DimensionList",
                    "MetricValueList"
                  ],
                  members: {
                    TimeSeriesId: {},
                    DimensionList: {
                      type: "list",
                      member: {
                        type: "structure",
                        required: [
                          "DimensionName",
                          "DimensionValue"
                        ],
                        members: {
                          DimensionName: {},
                          DimensionValue: {}
                        }
                      }
                    },
                    MetricValueList: {
                      type: "list",
                      member: {
                        type: "double"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        ListMetricSets: {
          http: {
            requestUri: "/ListMetricSets"
          },
          input: {
            type: "structure",
            members: {
              AnomalyDetectorArn: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              MetricSetSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MetricSetArn: {},
                    AnomalyDetectorArn: {},
                    MetricSetDescription: {},
                    MetricSetName: {},
                    CreationTime: {
                      type: "timestamp"
                    },
                    LastModificationTime: {
                      type: "timestamp"
                    },
                    Tags: {
                      shape: "Sd"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sd",
                locationName: "Tags"
              }
            }
          }
        },
        PutFeedback: {
          http: {
            requestUri: "/PutFeedback"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn",
              "AnomalyGroupTimeSeriesFeedback"
            ],
            members: {
              AnomalyDetectorArn: {},
              AnomalyGroupTimeSeriesFeedback: {
                type: "structure",
                required: [
                  "AnomalyGroupId",
                  "TimeSeriesId",
                  "IsAnomaly"
                ],
                members: {
                  AnomalyGroupId: {},
                  TimeSeriesId: {},
                  IsAnomaly: {
                    type: "boolean"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              Tags: {
                shape: "Sd",
                locationName: "tags"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              TagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateAnomalyDetector: {
          http: {
            requestUri: "/UpdateAnomalyDetector"
          },
          input: {
            type: "structure",
            required: [
              "AnomalyDetectorArn"
            ],
            members: {
              AnomalyDetectorArn: {},
              KmsKeyArn: {},
              AnomalyDetectorDescription: {},
              AnomalyDetectorConfig: {
                shape: "Sk"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AnomalyDetectorArn: {}
            }
          }
        },
        UpdateMetricSet: {
          http: {
            requestUri: "/UpdateMetricSet"
          },
          input: {
            type: "structure",
            required: [
              "MetricSetArn"
            ],
            members: {
              MetricSetArn: {},
              MetricSetDescription: {},
              MetricList: {
                shape: "Sr"
              },
              Offset: {
                type: "integer"
              },
              TimestampColumn: {
                shape: "Sx"
              },
              DimensionList: {
                shape: "Sz"
              },
              MetricSetFrequency: {},
              MetricSource: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              MetricSetArn: {}
            }
          }
        }
      },
      shapes: {
        Sa: {
          type: "structure",
          members: {
            SNSConfiguration: {
              type: "structure",
              required: [
                "RoleArn",
                "SnsTopicArn"
              ],
              members: {
                RoleArn: {},
                SnsTopicArn: {}
              }
            },
            LambdaConfiguration: {
              type: "structure",
              required: [
                "RoleArn",
                "LambdaArn"
              ],
              members: {
                RoleArn: {},
                LambdaArn: {}
              }
            }
          }
        },
        Sd: {
          type: "map",
          key: {},
          value: {}
        },
        Sk: {
          type: "structure",
          members: {
            AnomalyDetectorFrequency: {}
          }
        },
        Sr: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "MetricName",
              "AggregationFunction"
            ],
            members: {
              MetricName: {},
              AggregationFunction: {},
              Namespace: {}
            }
          }
        },
        Sx: {
          type: "structure",
          members: {
            ColumnName: {},
            ColumnFormat: {}
          }
        },
        Sz: {
          type: "list",
          member: {}
        },
        S10: {
          type: "structure",
          members: {
            S3SourceConfig: {
              type: "structure",
              required: [
                "RoleArn"
              ],
              members: {
                RoleArn: {},
                TemplatedPathList: {
                  shape: "S12"
                },
                HistoricalDataPathList: {
                  shape: "S14"
                },
                FileFormatDescriptor: {
                  shape: "S16"
                }
              }
            },
            AppFlowConfig: {
              type: "structure",
              required: [
                "RoleArn",
                "FlowName"
              ],
              members: {
                RoleArn: {},
                FlowName: {}
              }
            },
            CloudWatchConfig: {
              type: "structure",
              required: [
                "RoleArn"
              ],
              members: {
                RoleArn: {}
              }
            },
            RDSSourceConfig: {
              type: "structure",
              required: [
                "DBInstanceIdentifier",
                "DatabaseHost",
                "DatabasePort",
                "SecretManagerArn",
                "DatabaseName",
                "TableName",
                "RoleArn",
                "VpcConfiguration"
              ],
              members: {
                DBInstanceIdentifier: {},
                DatabaseHost: {},
                DatabasePort: {
                  type: "integer"
                },
                SecretManagerArn: {},
                DatabaseName: {},
                TableName: {},
                RoleArn: {},
                VpcConfiguration: {
                  shape: "S1q"
                }
              }
            },
            RedshiftSourceConfig: {
              type: "structure",
              required: [
                "ClusterIdentifier",
                "DatabaseHost",
                "DatabasePort",
                "SecretManagerArn",
                "DatabaseName",
                "TableName",
                "RoleArn",
                "VpcConfiguration"
              ],
              members: {
                ClusterIdentifier: {},
                DatabaseHost: {},
                DatabasePort: {
                  type: "integer"
                },
                SecretManagerArn: {},
                DatabaseName: {},
                TableName: {},
                RoleArn: {},
                VpcConfiguration: {
                  shape: "S1q"
                }
              }
            }
          }
        },
        S12: {
          type: "list",
          member: {}
        },
        S14: {
          type: "list",
          member: {}
        },
        S16: {
          type: "structure",
          members: {
            CsvFormatDescriptor: {
              type: "structure",
              members: {
                FileCompression: {},
                Charset: {},
                ContainsHeader: {
                  type: "boolean"
                },
                Delimiter: {},
                HeaderList: {
                  type: "list",
                  member: {}
                },
                QuoteSymbol: {}
              }
            },
            JsonFormatDescriptor: {
              type: "structure",
              members: {
                FileCompression: {},
                Charset: {}
              }
            }
          }
        },
        S1q: {
          type: "structure",
          required: [
            "SubnetIdList",
            "SecurityGroupIdList"
          ],
          members: {
            SubnetIdList: {
              type: "list",
              member: {}
            },
            SecurityGroupIdList: {
              type: "list",
              member: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/lookoutmetrics-2017-07-25.paginators.json
var require_lookoutmetrics_2017_07_25_paginators = __commonJS({
  "node_modules/aws-sdk/apis/lookoutmetrics-2017-07-25.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeAnomalyDetectionExecutions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        GetFeedback: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAlerts: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAnomalyDetectors: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAnomalyGroupSummaries: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAnomalyGroupTimeSeries: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListMetricSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/lookoutmetrics.js
var require_lookoutmetrics2 = __commonJS({
  "node_modules/aws-sdk/clients/lookoutmetrics.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["lookoutmetrics"] = {};
    AWS3.LookoutMetrics = Service.defineService("lookoutmetrics", ["2017-07-25"]);
    require_lookoutmetrics();
    Object.defineProperty(apiLoader.services["lookoutmetrics"], "2017-07-25", {
      get: function get() {
        var model = require_lookoutmetrics_2017_07_25_min();
        model.paginators = require_lookoutmetrics_2017_07_25_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.LookoutMetrics;
  }
});

// node_modules/aws-sdk/apis/mgn-2020-02-26.min.json
var require_mgn_2020_02_26_min = __commonJS({
  "node_modules/aws-sdk/apis/mgn-2020-02-26.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-02-26",
        endpointPrefix: "mgn",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "mgn",
        serviceFullName: "Application Migration Service",
        serviceId: "mgn",
        signatureVersion: "v4",
        signingName: "mgn",
        uid: "mgn-2020-02-26"
      },
      operations: {
        ChangeServerLifeCycleState: {
          http: {
            requestUri: "/ChangeServerLifeCycleState",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "lifeCycle",
              "sourceServerID"
            ],
            members: {
              lifeCycle: {
                type: "structure",
                required: [
                  "state"
                ],
                members: {
                  state: {}
                }
              },
              sourceServerID: {}
            }
          },
          output: {
            shape: "S5"
          }
        },
        CreateReplicationConfigurationTemplate: {
          http: {
            requestUri: "/CreateReplicationConfigurationTemplate",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "associateDefaultSecurityGroup",
              "bandwidthThrottling",
              "createPublicIP",
              "dataPlaneRouting",
              "defaultLargeStagingDiskType",
              "ebsEncryption",
              "replicationServerInstanceType",
              "replicationServersSecurityGroupsIDs",
              "stagingAreaSubnetId",
              "stagingAreaTags",
              "useDedicatedReplicationServer"
            ],
            members: {
              associateDefaultSecurityGroup: {
                type: "boolean"
              },
              bandwidthThrottling: {
                type: "long"
              },
              createPublicIP: {
                type: "boolean"
              },
              dataPlaneRouting: {},
              defaultLargeStagingDiskType: {},
              ebsEncryption: {},
              ebsEncryptionKeyArn: {},
              replicationServerInstanceType: {},
              replicationServersSecurityGroupsIDs: {
                shape: "S1j"
              },
              stagingAreaSubnetId: {},
              stagingAreaTags: {
                shape: "S1c"
              },
              tags: {
                shape: "S1c"
              },
              useDedicatedReplicationServer: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S1m"
          }
        },
        DeleteJob: {
          http: {
            requestUri: "/DeleteJob",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "jobID"
            ],
            members: {
              jobID: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteReplicationConfigurationTemplate: {
          http: {
            requestUri: "/DeleteReplicationConfigurationTemplate",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "replicationConfigurationTemplateID"
            ],
            members: {
              replicationConfigurationTemplateID: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteSourceServer: {
          http: {
            requestUri: "/DeleteSourceServer",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              sourceServerID: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DescribeJobLogItems: {
          http: {
            requestUri: "/DescribeJobLogItems",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "jobID"
            ],
            members: {
              jobID: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    event: {},
                    eventData: {
                      type: "structure",
                      members: {
                        conversionServerID: {},
                        rawError: {},
                        sourceServerID: {},
                        targetInstanceID: {}
                      }
                    },
                    logDateTime: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeJobs: {
          http: {
            requestUri: "/DescribeJobs",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "filters"
            ],
            members: {
              filters: {
                type: "structure",
                members: {
                  fromDate: {},
                  jobIDs: {
                    type: "list",
                    member: {}
                  },
                  toDate: {}
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  shape: "S27"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeReplicationConfigurationTemplates: {
          http: {
            requestUri: "/DescribeReplicationConfigurationTemplates",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "replicationConfigurationTemplateIDs"
            ],
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              replicationConfigurationTemplateIDs: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  shape: "S1m"
                }
              },
              nextToken: {}
            }
          }
        },
        DescribeSourceServers: {
          http: {
            requestUri: "/DescribeSourceServers",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "filters"
            ],
            members: {
              filters: {
                type: "structure",
                members: {
                  isArchived: {
                    type: "boolean"
                  },
                  sourceServerIDs: {
                    type: "list",
                    member: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              items: {
                type: "list",
                member: {
                  shape: "S5"
                }
              },
              nextToken: {}
            }
          }
        },
        DisconnectFromService: {
          http: {
            requestUri: "/DisconnectFromService",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              sourceServerID: {}
            }
          },
          output: {
            shape: "S5"
          }
        },
        FinalizeCutover: {
          http: {
            requestUri: "/FinalizeCutover",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              sourceServerID: {}
            }
          },
          output: {
            shape: "S5"
          }
        },
        GetLaunchConfiguration: {
          http: {
            requestUri: "/GetLaunchConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              sourceServerID: {}
            }
          },
          output: {
            shape: "S2q"
          }
        },
        GetReplicationConfiguration: {
          http: {
            requestUri: "/GetReplicationConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              sourceServerID: {}
            }
          },
          output: {
            shape: "S2w"
          }
        },
        InitializeService: {
          http: {
            requestUri: "/InitializeService",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S1c"
              }
            }
          }
        },
        MarkAsArchived: {
          http: {
            requestUri: "/MarkAsArchived",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              sourceServerID: {}
            }
          },
          output: {
            shape: "S5"
          }
        },
        RetryDataReplication: {
          http: {
            requestUri: "/RetryDataReplication",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              sourceServerID: {}
            }
          },
          output: {
            shape: "S5"
          }
        },
        StartCutover: {
          http: {
            requestUri: "/StartCutover",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "sourceServerIDs"
            ],
            members: {
              sourceServerIDs: {
                type: "list",
                member: {}
              },
              tags: {
                shape: "S1c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              job: {
                shape: "S27"
              }
            }
          }
        },
        StartTest: {
          http: {
            requestUri: "/StartTest",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "sourceServerIDs"
            ],
            members: {
              sourceServerIDs: {
                type: "list",
                member: {}
              },
              tags: {
                shape: "S1c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              job: {
                shape: "S27"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S1c"
              }
            }
          },
          idempotent: true
        },
        TerminateTargetInstances: {
          http: {
            requestUri: "/TerminateTargetInstances",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "sourceServerIDs"
            ],
            members: {
              sourceServerIDs: {
                type: "list",
                member: {}
              },
              tags: {
                shape: "S1c"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              job: {
                shape: "S27"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {},
                sensitive: true
              }
            }
          },
          idempotent: true
        },
        UpdateLaunchConfiguration: {
          http: {
            requestUri: "/UpdateLaunchConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              copyPrivateIp: {
                type: "boolean"
              },
              copyTags: {
                type: "boolean"
              },
              launchDisposition: {},
              licensing: {
                shape: "S2s"
              },
              name: {},
              sourceServerID: {},
              targetInstanceTypeRightSizingMethod: {}
            }
          },
          output: {
            shape: "S2q"
          },
          idempotent: true
        },
        UpdateReplicationConfiguration: {
          http: {
            requestUri: "/UpdateReplicationConfiguration",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "sourceServerID"
            ],
            members: {
              associateDefaultSecurityGroup: {
                type: "boolean"
              },
              bandwidthThrottling: {
                type: "long"
              },
              createPublicIP: {
                type: "boolean"
              },
              dataPlaneRouting: {},
              defaultLargeStagingDiskType: {},
              ebsEncryption: {},
              ebsEncryptionKeyArn: {},
              name: {},
              replicatedDisks: {
                shape: "S2x"
              },
              replicationServerInstanceType: {},
              replicationServersSecurityGroupsIDs: {
                shape: "S1j"
              },
              sourceServerID: {},
              stagingAreaSubnetId: {},
              stagingAreaTags: {
                shape: "S1c"
              },
              useDedicatedReplicationServer: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S2w"
          },
          idempotent: true
        },
        UpdateReplicationConfigurationTemplate: {
          http: {
            requestUri: "/UpdateReplicationConfigurationTemplate",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "replicationConfigurationTemplateID"
            ],
            members: {
              arn: {},
              associateDefaultSecurityGroup: {
                type: "boolean"
              },
              bandwidthThrottling: {
                type: "long"
              },
              createPublicIP: {
                type: "boolean"
              },
              dataPlaneRouting: {},
              defaultLargeStagingDiskType: {},
              ebsEncryption: {},
              ebsEncryptionKeyArn: {},
              replicationConfigurationTemplateID: {},
              replicationServerInstanceType: {},
              replicationServersSecurityGroupsIDs: {
                shape: "S1j"
              },
              stagingAreaSubnetId: {},
              stagingAreaTags: {
                shape: "S1c"
              },
              useDedicatedReplicationServer: {
                type: "boolean"
              }
            }
          },
          output: {
            shape: "S1m"
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            arn: {},
            dataReplicationInfo: {
              type: "structure",
              members: {
                dataReplicationError: {
                  type: "structure",
                  members: {
                    error: {},
                    rawError: {}
                  }
                },
                dataReplicationInitiation: {
                  type: "structure",
                  members: {
                    nextAttemptDateTime: {},
                    startDateTime: {},
                    steps: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          name: {},
                          status: {}
                        }
                      }
                    }
                  }
                },
                dataReplicationState: {},
                etaDateTime: {},
                lagDuration: {},
                replicatedDisks: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      backloggedStorageBytes: {
                        type: "long"
                      },
                      deviceName: {},
                      replicatedStorageBytes: {
                        type: "long"
                      },
                      rescannedStorageBytes: {
                        type: "long"
                      },
                      totalStorageBytes: {
                        type: "long"
                      }
                    }
                  }
                }
              }
            },
            isArchived: {
              type: "boolean"
            },
            launchedInstance: {
              type: "structure",
              members: {
                ec2InstanceID: {},
                firstBoot: {},
                jobID: {}
              }
            },
            lifeCycle: {
              type: "structure",
              members: {
                addedToServiceDateTime: {},
                elapsedReplicationDuration: {},
                firstByteDateTime: {},
                lastCutover: {
                  type: "structure",
                  members: {
                    finalized: {
                      type: "structure",
                      members: {
                        apiCallDateTime: {}
                      }
                    },
                    initiated: {
                      type: "structure",
                      members: {
                        apiCallDateTime: {},
                        jobID: {}
                      }
                    },
                    reverted: {
                      type: "structure",
                      members: {
                        apiCallDateTime: {}
                      }
                    }
                  }
                },
                lastSeenByServiceDateTime: {},
                lastTest: {
                  type: "structure",
                  members: {
                    finalized: {
                      type: "structure",
                      members: {
                        apiCallDateTime: {}
                      }
                    },
                    initiated: {
                      type: "structure",
                      members: {
                        apiCallDateTime: {},
                        jobID: {}
                      }
                    },
                    reverted: {
                      type: "structure",
                      members: {
                        apiCallDateTime: {}
                      }
                    }
                  }
                },
                state: {}
              }
            },
            sourceProperties: {
              type: "structure",
              members: {
                cpus: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      cores: {
                        type: "long"
                      },
                      modelName: {}
                    }
                  }
                },
                disks: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      bytes: {
                        type: "long"
                      },
                      deviceName: {}
                    }
                  }
                },
                identificationHints: {
                  type: "structure",
                  members: {
                    awsInstanceID: {},
                    fqdn: {},
                    hostname: {},
                    vmWareUuid: {}
                  }
                },
                lastUpdatedDateTime: {},
                networkInterfaces: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      ips: {
                        type: "list",
                        member: {}
                      },
                      isPrimary: {
                        type: "boolean"
                      },
                      macAddress: {}
                    }
                  }
                },
                os: {
                  type: "structure",
                  members: {
                    fullString: {}
                  }
                },
                ramBytes: {
                  type: "long"
                },
                recommendedInstanceType: {}
              }
            },
            sourceServerID: {},
            tags: {
              shape: "S1c"
            }
          }
        },
        S1c: {
          type: "map",
          key: {},
          value: {},
          sensitive: true
        },
        S1j: {
          type: "list",
          member: {}
        },
        S1m: {
          type: "structure",
          required: [
            "replicationConfigurationTemplateID"
          ],
          members: {
            arn: {},
            associateDefaultSecurityGroup: {
              type: "boolean"
            },
            bandwidthThrottling: {
              type: "long"
            },
            createPublicIP: {
              type: "boolean"
            },
            dataPlaneRouting: {},
            defaultLargeStagingDiskType: {},
            ebsEncryption: {},
            ebsEncryptionKeyArn: {},
            replicationConfigurationTemplateID: {},
            replicationServerInstanceType: {},
            replicationServersSecurityGroupsIDs: {
              shape: "S1j"
            },
            stagingAreaSubnetId: {},
            stagingAreaTags: {
              shape: "S1c"
            },
            tags: {
              shape: "S1c"
            },
            useDedicatedReplicationServer: {
              type: "boolean"
            }
          }
        },
        S27: {
          type: "structure",
          required: [
            "jobID"
          ],
          members: {
            arn: {},
            creationDateTime: {},
            endDateTime: {},
            initiatedBy: {},
            jobID: {},
            participatingServers: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  launchStatus: {},
                  sourceServerID: {}
                }
              }
            },
            status: {},
            tags: {
              shape: "S1c"
            },
            type: {}
          }
        },
        S2q: {
          type: "structure",
          members: {
            copyPrivateIp: {
              type: "boolean"
            },
            copyTags: {
              type: "boolean"
            },
            ec2LaunchTemplateID: {},
            launchDisposition: {},
            licensing: {
              shape: "S2s"
            },
            name: {},
            sourceServerID: {},
            targetInstanceTypeRightSizingMethod: {}
          }
        },
        S2s: {
          type: "structure",
          members: {
            osByol: {
              type: "boolean"
            }
          }
        },
        S2w: {
          type: "structure",
          members: {
            associateDefaultSecurityGroup: {
              type: "boolean"
            },
            bandwidthThrottling: {
              type: "long"
            },
            createPublicIP: {
              type: "boolean"
            },
            dataPlaneRouting: {},
            defaultLargeStagingDiskType: {},
            ebsEncryption: {},
            ebsEncryptionKeyArn: {},
            name: {},
            replicatedDisks: {
              shape: "S2x"
            },
            replicationServerInstanceType: {},
            replicationServersSecurityGroupsIDs: {
              shape: "S1j"
            },
            sourceServerID: {},
            stagingAreaSubnetId: {},
            stagingAreaTags: {
              shape: "S1c"
            },
            useDedicatedReplicationServer: {
              type: "boolean"
            }
          }
        },
        S2x: {
          type: "list",
          member: {
            type: "structure",
            members: {
              deviceName: {},
              iops: {
                type: "long"
              },
              isBootDisk: {
                type: "boolean"
              },
              stagingDiskType: {}
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/mgn-2020-02-26.paginators.json
var require_mgn_2020_02_26_paginators = __commonJS({
  "node_modules/aws-sdk/apis/mgn-2020-02-26.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeJobLogItems: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        DescribeJobs: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        DescribeReplicationConfigurationTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        },
        DescribeSourceServers: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "items"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/mgn.js
var require_mgn = __commonJS({
  "node_modules/aws-sdk/clients/mgn.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["mgn"] = {};
    AWS3.Mgn = Service.defineService("mgn", ["2020-02-26"]);
    Object.defineProperty(apiLoader.services["mgn"], "2020-02-26", {
      get: function get() {
        var model = require_mgn_2020_02_26_min();
        model.paginators = require_mgn_2020_02_26_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Mgn;
  }
});

// node_modules/aws-sdk/apis/lookoutequipment-2020-12-15.min.json
var require_lookoutequipment_2020_12_15_min = __commonJS({
  "node_modules/aws-sdk/apis/lookoutequipment-2020-12-15.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-12-15",
        endpointPrefix: "lookoutequipment",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "LookoutEquipment",
        serviceFullName: "Amazon Lookout for Equipment",
        serviceId: "LookoutEquipment",
        signatureVersion: "v4",
        targetPrefix: "AWSLookoutEquipmentFrontendService",
        uid: "lookoutequipment-2020-12-15"
      },
      operations: {
        CreateDataset: {
          input: {
            type: "structure",
            required: [
              "DatasetName",
              "DatasetSchema",
              "ClientToken"
            ],
            members: {
              DatasetName: {},
              DatasetSchema: {
                shape: "S3"
              },
              ServerSideKmsKeyId: {},
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetName: {},
              DatasetArn: {},
              Status: {}
            }
          }
        },
        CreateInferenceScheduler: {
          input: {
            type: "structure",
            required: [
              "ModelName",
              "InferenceSchedulerName",
              "DataUploadFrequency",
              "DataInputConfiguration",
              "DataOutputConfiguration",
              "RoleArn",
              "ClientToken"
            ],
            members: {
              ModelName: {},
              InferenceSchedulerName: {},
              DataDelayOffsetInMinutes: {
                type: "long"
              },
              DataUploadFrequency: {},
              DataInputConfiguration: {
                shape: "Sj"
              },
              DataOutputConfiguration: {
                shape: "Sr"
              },
              RoleArn: {},
              ServerSideKmsKeyId: {},
              ClientToken: {
                idempotencyToken: true
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InferenceSchedulerArn: {},
              InferenceSchedulerName: {},
              Status: {}
            }
          }
        },
        CreateModel: {
          input: {
            type: "structure",
            required: [
              "ModelName",
              "DatasetName",
              "ClientToken"
            ],
            members: {
              ModelName: {},
              DatasetName: {},
              DatasetSchema: {
                shape: "S3"
              },
              LabelsInputConfiguration: {
                shape: "Sz"
              },
              ClientToken: {
                idempotencyToken: true
              },
              TrainingDataStartTime: {
                type: "timestamp"
              },
              TrainingDataEndTime: {
                type: "timestamp"
              },
              EvaluationDataStartTime: {
                type: "timestamp"
              },
              EvaluationDataEndTime: {
                type: "timestamp"
              },
              RoleArn: {},
              DataPreProcessingConfiguration: {
                shape: "S12"
              },
              ServerSideKmsKeyId: {},
              Tags: {
                shape: "S7"
              },
              OffCondition: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ModelArn: {},
              Status: {}
            }
          }
        },
        DeleteDataset: {
          input: {
            type: "structure",
            required: [
              "DatasetName"
            ],
            members: {
              DatasetName: {}
            }
          }
        },
        DeleteInferenceScheduler: {
          input: {
            type: "structure",
            required: [
              "InferenceSchedulerName"
            ],
            members: {
              InferenceSchedulerName: {}
            }
          }
        },
        DeleteModel: {
          input: {
            type: "structure",
            required: [
              "ModelName"
            ],
            members: {
              ModelName: {}
            }
          }
        },
        DescribeDataIngestionJob: {
          input: {
            type: "structure",
            required: [
              "JobId"
            ],
            members: {
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              DatasetArn: {},
              IngestionInputConfiguration: {
                shape: "S1f"
              },
              RoleArn: {},
              CreatedAt: {
                type: "timestamp"
              },
              Status: {},
              FailedReason: {}
            }
          }
        },
        DescribeDataset: {
          input: {
            type: "structure",
            required: [
              "DatasetName"
            ],
            members: {
              DatasetName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DatasetName: {},
              DatasetArn: {},
              CreatedAt: {
                type: "timestamp"
              },
              LastUpdatedAt: {
                type: "timestamp"
              },
              Status: {},
              Schema: {
                jsonvalue: true
              },
              ServerSideKmsKeyId: {},
              IngestionInputConfiguration: {
                shape: "S1f"
              }
            }
          }
        },
        DescribeInferenceScheduler: {
          input: {
            type: "structure",
            required: [
              "InferenceSchedulerName"
            ],
            members: {
              InferenceSchedulerName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ModelArn: {},
              ModelName: {},
              InferenceSchedulerName: {},
              InferenceSchedulerArn: {},
              Status: {},
              DataDelayOffsetInMinutes: {
                type: "long"
              },
              DataUploadFrequency: {},
              CreatedAt: {
                type: "timestamp"
              },
              UpdatedAt: {
                type: "timestamp"
              },
              DataInputConfiguration: {
                shape: "Sj"
              },
              DataOutputConfiguration: {
                shape: "Sr"
              },
              RoleArn: {},
              ServerSideKmsKeyId: {}
            }
          }
        },
        DescribeModel: {
          input: {
            type: "structure",
            required: [
              "ModelName"
            ],
            members: {
              ModelName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ModelName: {},
              ModelArn: {},
              DatasetName: {},
              DatasetArn: {},
              Schema: {
                jsonvalue: true
              },
              LabelsInputConfiguration: {
                shape: "Sz"
              },
              TrainingDataStartTime: {
                type: "timestamp"
              },
              TrainingDataEndTime: {
                type: "timestamp"
              },
              EvaluationDataStartTime: {
                type: "timestamp"
              },
              EvaluationDataEndTime: {
                type: "timestamp"
              },
              RoleArn: {},
              DataPreProcessingConfiguration: {
                shape: "S12"
              },
              Status: {},
              TrainingExecutionStartTime: {
                type: "timestamp"
              },
              TrainingExecutionEndTime: {
                type: "timestamp"
              },
              FailedReason: {},
              ModelMetrics: {
                jsonvalue: true
              },
              LastUpdatedTime: {
                type: "timestamp"
              },
              CreatedAt: {
                type: "timestamp"
              },
              ServerSideKmsKeyId: {},
              OffCondition: {}
            }
          }
        },
        ListDataIngestionJobs: {
          input: {
            type: "structure",
            members: {
              DatasetName: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              DataIngestionJobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    JobId: {},
                    DatasetName: {},
                    DatasetArn: {},
                    IngestionInputConfiguration: {
                      shape: "S1f"
                    },
                    Status: {}
                  }
                }
              }
            }
          }
        },
        ListDatasets: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              DatasetNameBeginsWith: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              DatasetSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DatasetName: {},
                    DatasetArn: {},
                    Status: {},
                    CreatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListInferenceExecutions: {
          input: {
            type: "structure",
            required: [
              "InferenceSchedulerName"
            ],
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              InferenceSchedulerName: {},
              DataStartTimeAfter: {
                type: "timestamp"
              },
              DataEndTimeBefore: {
                type: "timestamp"
              },
              Status: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              InferenceExecutionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ModelName: {},
                    ModelArn: {},
                    InferenceSchedulerName: {},
                    InferenceSchedulerArn: {},
                    ScheduledStartTime: {
                      type: "timestamp"
                    },
                    DataStartTime: {
                      type: "timestamp"
                    },
                    DataEndTime: {
                      type: "timestamp"
                    },
                    DataInputConfiguration: {
                      shape: "Sj"
                    },
                    DataOutputConfiguration: {
                      shape: "Sr"
                    },
                    CustomerResultObject: {
                      type: "structure",
                      required: [
                        "Bucket",
                        "Key"
                      ],
                      members: {
                        Bucket: {},
                        Key: {}
                      }
                    },
                    Status: {},
                    FailedReason: {}
                  }
                }
              }
            }
          }
        },
        ListInferenceSchedulers: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              InferenceSchedulerNameBeginsWith: {},
              ModelName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              InferenceSchedulerSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ModelName: {},
                    ModelArn: {},
                    InferenceSchedulerName: {},
                    InferenceSchedulerArn: {},
                    Status: {},
                    DataDelayOffsetInMinutes: {
                      type: "long"
                    },
                    DataUploadFrequency: {}
                  }
                }
              }
            }
          }
        },
        ListModels: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              Status: {},
              ModelNameBeginsWith: {},
              DatasetNameBeginsWith: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ModelSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ModelName: {},
                    ModelArn: {},
                    DatasetName: {},
                    DatasetArn: {},
                    Status: {},
                    CreatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S7"
              }
            }
          }
        },
        StartDataIngestionJob: {
          input: {
            type: "structure",
            required: [
              "DatasetName",
              "IngestionInputConfiguration",
              "RoleArn",
              "ClientToken"
            ],
            members: {
              DatasetName: {},
              IngestionInputConfiguration: {
                shape: "S1f"
              },
              RoleArn: {},
              ClientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              JobId: {},
              Status: {}
            }
          }
        },
        StartInferenceScheduler: {
          input: {
            type: "structure",
            required: [
              "InferenceSchedulerName"
            ],
            members: {
              InferenceSchedulerName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ModelArn: {},
              ModelName: {},
              InferenceSchedulerName: {},
              InferenceSchedulerArn: {},
              Status: {}
            }
          }
        },
        StopInferenceScheduler: {
          input: {
            type: "structure",
            required: [
              "InferenceSchedulerName"
            ],
            members: {
              InferenceSchedulerName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ModelArn: {},
              ModelName: {},
              InferenceSchedulerName: {},
              InferenceSchedulerArn: {},
              Status: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateInferenceScheduler: {
          input: {
            type: "structure",
            required: [
              "InferenceSchedulerName"
            ],
            members: {
              InferenceSchedulerName: {},
              DataDelayOffsetInMinutes: {
                type: "long"
              },
              DataUploadFrequency: {},
              DataInputConfiguration: {
                shape: "Sj"
              },
              DataOutputConfiguration: {
                shape: "Sr"
              },
              RoleArn: {}
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "structure",
          members: {
            InlineDataSchema: {
              jsonvalue: true
            }
          }
        },
        S7: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sj: {
          type: "structure",
          members: {
            S3InputConfiguration: {
              type: "structure",
              required: [
                "Bucket"
              ],
              members: {
                Bucket: {},
                Prefix: {}
              }
            },
            InputTimeZoneOffset: {},
            InferenceInputNameConfiguration: {
              type: "structure",
              members: {
                TimestampFormat: {},
                ComponentTimestampDelimiter: {}
              }
            }
          }
        },
        Sr: {
          type: "structure",
          required: [
            "S3OutputConfiguration"
          ],
          members: {
            S3OutputConfiguration: {
              type: "structure",
              required: [
                "Bucket"
              ],
              members: {
                Bucket: {},
                Prefix: {}
              }
            },
            KmsKeyId: {}
          }
        },
        Sz: {
          type: "structure",
          required: [
            "S3InputConfiguration"
          ],
          members: {
            S3InputConfiguration: {
              type: "structure",
              required: [
                "Bucket"
              ],
              members: {
                Bucket: {},
                Prefix: {}
              }
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            TargetSamplingRate: {}
          }
        },
        S1f: {
          type: "structure",
          required: [
            "S3InputConfiguration"
          ],
          members: {
            S3InputConfiguration: {
              type: "structure",
              required: [
                "Bucket"
              ],
              members: {
                Bucket: {},
                Prefix: {}
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/lookoutequipment-2020-12-15.paginators.json
var require_lookoutequipment_2020_12_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/lookoutequipment-2020-12-15.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListDataIngestionJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDatasets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListInferenceExecutions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListInferenceSchedulers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListModels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/lookoutequipment.js
var require_lookoutequipment = __commonJS({
  "node_modules/aws-sdk/clients/lookoutequipment.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["lookoutequipment"] = {};
    AWS3.LookoutEquipment = Service.defineService("lookoutequipment", ["2020-12-15"]);
    Object.defineProperty(apiLoader.services["lookoutequipment"], "2020-12-15", {
      get: function get() {
        var model = require_lookoutequipment_2020_12_15_min();
        model.paginators = require_lookoutequipment_2020_12_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.LookoutEquipment;
  }
});

// node_modules/aws-sdk/apis/nimble-2020-08-01.min.json
var require_nimble_2020_08_01_min = __commonJS({
  "node_modules/aws-sdk/apis/nimble-2020-08-01.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2020-08-01",
        endpointPrefix: "nimble",
        signingName: "nimble",
        serviceFullName: "AmazonNimbleStudio",
        serviceId: "nimble",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "nimble-2020-08-01",
        signatureVersion: "v4"
      },
      operations: {
        AcceptEulas: {
          http: {
            requestUri: "/2020-08-01/studios/{studioId}/eula-acceptances",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              eulaIds: {
                shape: "S3",
                locationName: "eulaIds"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId"
            ]
          },
          output: {
            type: "structure",
            members: {
              eulaAcceptances: {
                shape: "S6",
                locationName: "eulaAcceptances"
              }
            }
          }
        },
        CreateLaunchProfile: {
          http: {
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              description: {
                locationName: "description"
              },
              ec2SubnetIds: {
                shape: "Sd",
                locationName: "ec2SubnetIds"
              },
              launchProfileProtocolVersions: {
                shape: "Sf",
                locationName: "launchProfileProtocolVersions"
              },
              name: {
                locationName: "name"
              },
              streamConfiguration: {
                shape: "Si",
                locationName: "streamConfiguration"
              },
              studioComponentIds: {
                shape: "Sp",
                locationName: "studioComponentIds"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              },
              tags: {
                shape: "Sq",
                locationName: "tags"
              }
            },
            required: [
              "ec2SubnetIds",
              "studioComponentIds",
              "studioId",
              "launchProfileProtocolVersions",
              "name",
              "streamConfiguration"
            ]
          },
          output: {
            type: "structure",
            members: {
              launchProfile: {
                shape: "Ss",
                locationName: "launchProfile"
              }
            }
          }
        },
        CreateStreamingImage: {
          http: {
            requestUri: "/2020-08-01/studios/{studioId}/streaming-images",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              description: {
                locationName: "description"
              },
              ec2ImageId: {
                locationName: "ec2ImageId"
              },
              name: {
                locationName: "name"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              },
              tags: {
                shape: "Sq",
                locationName: "tags"
              }
            },
            required: [
              "studioId",
              "name",
              "ec2ImageId"
            ]
          },
          output: {
            type: "structure",
            members: {
              streamingImage: {
                shape: "S12",
                locationName: "streamingImage"
              }
            }
          }
        },
        CreateStreamingSession: {
          http: {
            requestUri: "/2020-08-01/studios/{studioId}/streaming-sessions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              ec2InstanceType: {
                locationName: "ec2InstanceType"
              },
              launchProfileId: {
                locationName: "launchProfileId"
              },
              ownedBy: {
                locationName: "ownedBy"
              },
              streamingImageId: {
                locationName: "streamingImageId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              },
              tags: {
                shape: "Sq",
                locationName: "tags"
              }
            },
            required: [
              "studioId"
            ]
          },
          output: {
            type: "structure",
            members: {
              session: {
                shape: "S1c",
                locationName: "session"
              }
            }
          }
        },
        CreateStreamingSessionStream: {
          http: {
            requestUri: "/2020-08-01/studios/{studioId}/streaming-sessions/{sessionId}/streams",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              expirationInSeconds: {
                locationName: "expirationInSeconds",
                type: "integer"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "sessionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              stream: {
                shape: "S1j",
                locationName: "stream"
              }
            }
          }
        },
        CreateStudio: {
          http: {
            requestUri: "/2020-08-01/studios",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              adminRoleArn: {
                locationName: "adminRoleArn"
              },
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              displayName: {
                locationName: "displayName"
              },
              studioEncryptionConfiguration: {
                shape: "S1o",
                locationName: "studioEncryptionConfiguration"
              },
              studioName: {
                locationName: "studioName"
              },
              tags: {
                shape: "Sq",
                locationName: "tags"
              },
              userRoleArn: {
                locationName: "userRoleArn"
              }
            },
            required: [
              "displayName",
              "studioName",
              "userRoleArn",
              "adminRoleArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              studio: {
                shape: "S1t",
                locationName: "studio"
              }
            }
          }
        },
        CreateStudioComponent: {
          http: {
            requestUri: "/2020-08-01/studios/{studioId}/studio-components",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              configuration: {
                shape: "S1y",
                locationName: "configuration"
              },
              description: {
                locationName: "description"
              },
              ec2SecurityGroupIds: {
                shape: "S2c",
                locationName: "ec2SecurityGroupIds"
              },
              initializationScripts: {
                shape: "S2e",
                locationName: "initializationScripts"
              },
              name: {
                locationName: "name"
              },
              scriptParameters: {
                shape: "S2k",
                locationName: "scriptParameters"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              },
              subtype: {
                locationName: "subtype"
              },
              tags: {
                shape: "Sq",
                locationName: "tags"
              },
              type: {
                locationName: "type"
              }
            },
            required: [
              "studioId",
              "name",
              "type"
            ]
          },
          output: {
            type: "structure",
            members: {
              studioComponent: {
                shape: "S2r",
                locationName: "studioComponent"
              }
            }
          }
        },
        DeleteLaunchProfile: {
          http: {
            method: "DELETE",
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles/{launchProfileId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              launchProfileId: {
                location: "uri",
                locationName: "launchProfileId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "launchProfileId"
            ]
          },
          output: {
            type: "structure",
            members: {
              launchProfile: {
                shape: "Ss",
                locationName: "launchProfile"
              }
            }
          }
        },
        DeleteLaunchProfileMember: {
          http: {
            method: "DELETE",
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles/{launchProfileId}/membership/{principalId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              launchProfileId: {
                location: "uri",
                locationName: "launchProfileId"
              },
              principalId: {
                location: "uri",
                locationName: "principalId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "principalId",
              "launchProfileId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteStreamingImage: {
          http: {
            method: "DELETE",
            requestUri: "/2020-08-01/studios/{studioId}/streaming-images/{streamingImageId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              streamingImageId: {
                location: "uri",
                locationName: "streamingImageId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "streamingImageId"
            ]
          },
          output: {
            type: "structure",
            members: {
              streamingImage: {
                shape: "S12",
                locationName: "streamingImage"
              }
            }
          }
        },
        DeleteStreamingSession: {
          http: {
            method: "DELETE",
            requestUri: "/2020-08-01/studios/{studioId}/streaming-sessions/{sessionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "sessionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              session: {
                shape: "S1c",
                locationName: "session"
              }
            }
          }
        },
        DeleteStudio: {
          http: {
            method: "DELETE",
            requestUri: "/2020-08-01/studios/{studioId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId"
            ]
          },
          output: {
            type: "structure",
            members: {
              studio: {
                shape: "S1t",
                locationName: "studio"
              }
            }
          }
        },
        DeleteStudioComponent: {
          http: {
            method: "DELETE",
            requestUri: "/2020-08-01/studios/{studioId}/studio-components/{studioComponentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              studioComponentId: {
                location: "uri",
                locationName: "studioComponentId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "studioComponentId"
            ]
          },
          output: {
            type: "structure",
            members: {
              studioComponent: {
                shape: "S2r",
                locationName: "studioComponent"
              }
            }
          }
        },
        DeleteStudioMember: {
          http: {
            method: "DELETE",
            requestUri: "/2020-08-01/studios/{studioId}/membership/{principalId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              principalId: {
                location: "uri",
                locationName: "principalId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "principalId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetEula: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/eulas/{eulaId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              eulaId: {
                location: "uri",
                locationName: "eulaId"
              }
            },
            required: [
              "eulaId"
            ]
          },
          output: {
            type: "structure",
            members: {
              eula: {
                shape: "S3b",
                locationName: "eula"
              }
            }
          }
        },
        GetLaunchProfile: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles/{launchProfileId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              launchProfileId: {
                location: "uri",
                locationName: "launchProfileId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "launchProfileId"
            ]
          },
          output: {
            type: "structure",
            members: {
              launchProfile: {
                shape: "Ss",
                locationName: "launchProfile"
              }
            }
          }
        },
        GetLaunchProfileDetails: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles/{launchProfileId}/details",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              launchProfileId: {
                location: "uri",
                locationName: "launchProfileId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "launchProfileId"
            ]
          },
          output: {
            type: "structure",
            members: {
              launchProfile: {
                shape: "Ss",
                locationName: "launchProfile"
              },
              streamingImages: {
                shape: "S3h",
                locationName: "streamingImages"
              },
              studioComponentSummaries: {
                locationName: "studioComponentSummaries",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    createdAt: {
                      shape: "S8",
                      locationName: "createdAt"
                    },
                    createdBy: {
                      locationName: "createdBy"
                    },
                    description: {
                      locationName: "description"
                    },
                    name: {
                      locationName: "name"
                    },
                    studioComponentId: {
                      locationName: "studioComponentId"
                    },
                    subtype: {
                      locationName: "subtype"
                    },
                    type: {
                      locationName: "type"
                    },
                    updatedAt: {
                      shape: "S8",
                      locationName: "updatedAt"
                    },
                    updatedBy: {
                      locationName: "updatedBy"
                    }
                  }
                }
              }
            }
          }
        },
        GetLaunchProfileInitialization: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles/{launchProfileId}/init",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              launchProfileId: {
                location: "uri",
                locationName: "launchProfileId"
              },
              launchProfileProtocolVersions: {
                shape: "S3l",
                location: "querystring",
                locationName: "launchProfileProtocolVersions"
              },
              launchPurpose: {
                location: "querystring",
                locationName: "launchPurpose"
              },
              platform: {
                location: "querystring",
                locationName: "platform"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "launchProfileProtocolVersions",
              "launchPurpose",
              "launchProfileId",
              "platform"
            ]
          },
          output: {
            type: "structure",
            members: {
              launchProfileInitialization: {
                locationName: "launchProfileInitialization",
                type: "structure",
                members: {
                  activeDirectory: {
                    locationName: "activeDirectory",
                    type: "structure",
                    members: {
                      computerAttributes: {
                        shape: "S20",
                        locationName: "computerAttributes"
                      },
                      directoryId: {
                        locationName: "directoryId"
                      },
                      directoryName: {
                        locationName: "directoryName"
                      },
                      dnsIpAddresses: {
                        locationName: "dnsIpAddresses",
                        type: "list",
                        member: {}
                      },
                      organizationalUnitDistinguishedName: {
                        locationName: "organizationalUnitDistinguishedName"
                      },
                      studioComponentId: {
                        locationName: "studioComponentId"
                      },
                      studioComponentName: {
                        locationName: "studioComponentName"
                      }
                    }
                  },
                  ec2SecurityGroupIds: {
                    locationName: "ec2SecurityGroupIds",
                    type: "list",
                    member: {}
                  },
                  launchProfileId: {
                    locationName: "launchProfileId"
                  },
                  launchProfileProtocolVersion: {
                    locationName: "launchProfileProtocolVersion"
                  },
                  launchPurpose: {
                    locationName: "launchPurpose"
                  },
                  name: {
                    locationName: "name"
                  },
                  platform: {
                    locationName: "platform"
                  },
                  systemInitializationScripts: {
                    shape: "S3t",
                    locationName: "systemInitializationScripts"
                  },
                  userInitializationScripts: {
                    shape: "S3t",
                    locationName: "userInitializationScripts"
                  }
                }
              }
            }
          }
        },
        GetLaunchProfileMember: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles/{launchProfileId}/membership/{principalId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              launchProfileId: {
                location: "uri",
                locationName: "launchProfileId"
              },
              principalId: {
                location: "uri",
                locationName: "principalId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "principalId",
              "launchProfileId"
            ]
          },
          output: {
            type: "structure",
            members: {
              member: {
                shape: "S3x",
                locationName: "member"
              }
            }
          }
        },
        GetStreamingImage: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/streaming-images/{streamingImageId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              streamingImageId: {
                location: "uri",
                locationName: "streamingImageId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "streamingImageId"
            ]
          },
          output: {
            type: "structure",
            members: {
              streamingImage: {
                shape: "S12",
                locationName: "streamingImage"
              }
            }
          }
        },
        GetStreamingSession: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/streaming-sessions/{sessionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "sessionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              session: {
                shape: "S1c",
                locationName: "session"
              }
            }
          }
        },
        GetStreamingSessionStream: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/streaming-sessions/{sessionId}/streams/{streamId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              },
              streamId: {
                location: "uri",
                locationName: "streamId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "streamId",
              "sessionId"
            ]
          },
          output: {
            type: "structure",
            members: {
              stream: {
                shape: "S1j",
                locationName: "stream"
              }
            }
          }
        },
        GetStudio: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId"
            ]
          },
          output: {
            type: "structure",
            members: {
              studio: {
                shape: "S1t",
                locationName: "studio"
              }
            }
          }
        },
        GetStudioComponent: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/studio-components/{studioComponentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              studioComponentId: {
                location: "uri",
                locationName: "studioComponentId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "studioComponentId"
            ]
          },
          output: {
            type: "structure",
            members: {
              studioComponent: {
                shape: "S2r",
                locationName: "studioComponent"
              }
            }
          }
        },
        GetStudioMember: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/membership/{principalId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              principalId: {
                location: "uri",
                locationName: "principalId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "principalId"
            ]
          },
          output: {
            type: "structure",
            members: {
              member: {
                shape: "S4b",
                locationName: "member"
              }
            }
          }
        },
        ListEulaAcceptances: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/eula-acceptances",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              eulaIds: {
                shape: "S3l",
                location: "querystring",
                locationName: "eulaIds"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId"
            ]
          },
          output: {
            type: "structure",
            members: {
              eulaAcceptances: {
                shape: "S6",
                locationName: "eulaAcceptances"
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListEulas: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/eulas",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              eulaIds: {
                shape: "S3l",
                location: "querystring",
                locationName: "eulaIds"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              eulas: {
                locationName: "eulas",
                type: "list",
                member: {
                  shape: "S3b"
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListLaunchProfileMembers: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles/{launchProfileId}/membership",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              launchProfileId: {
                location: "uri",
                locationName: "launchProfileId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "launchProfileId"
            ]
          },
          output: {
            type: "structure",
            members: {
              members: {
                locationName: "members",
                type: "list",
                member: {
                  shape: "S3x"
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListLaunchProfiles: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              principalId: {
                location: "querystring",
                locationName: "principalId"
              },
              states: {
                shape: "S3l",
                location: "querystring",
                locationName: "states"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId"
            ]
          },
          output: {
            type: "structure",
            members: {
              launchProfiles: {
                locationName: "launchProfiles",
                type: "list",
                member: {
                  shape: "Ss"
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListStreamingImages: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/streaming-images",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              owner: {
                location: "querystring",
                locationName: "owner"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId"
            ]
          },
          output: {
            type: "structure",
            members: {
              nextToken: {
                locationName: "nextToken"
              },
              streamingImages: {
                shape: "S3h",
                locationName: "streamingImages"
              }
            }
          }
        },
        ListStreamingSessions: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/streaming-sessions",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              createdBy: {
                location: "querystring",
                locationName: "createdBy"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ownedBy: {
                location: "querystring",
                locationName: "ownedBy"
              },
              sessionIds: {
                location: "querystring",
                locationName: "sessionIds"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId"
            ]
          },
          output: {
            type: "structure",
            members: {
              nextToken: {
                locationName: "nextToken"
              },
              sessions: {
                locationName: "sessions",
                type: "list",
                member: {
                  shape: "S1c"
                }
              }
            }
          }
        },
        ListStudioComponents: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/studio-components",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              states: {
                shape: "S3l",
                location: "querystring",
                locationName: "states"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              },
              types: {
                shape: "S3l",
                location: "querystring",
                locationName: "types"
              }
            },
            required: [
              "studioId"
            ]
          },
          output: {
            type: "structure",
            members: {
              nextToken: {
                locationName: "nextToken"
              },
              studioComponents: {
                locationName: "studioComponents",
                type: "list",
                member: {
                  shape: "S2r"
                }
              }
            }
          }
        },
        ListStudioMembers: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios/{studioId}/membership",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId"
            ]
          },
          output: {
            type: "structure",
            members: {
              members: {
                locationName: "members",
                type: "list",
                member: {
                  shape: "S4b"
                }
              },
              nextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListStudios: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/studios",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {
                locationName: "nextToken"
              },
              studios: {
                locationName: "studios",
                type: "list",
                member: {
                  shape: "S1t"
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/2020-08-01/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            },
            required: [
              "resourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sq",
                locationName: "tags"
              }
            }
          }
        },
        PutLaunchProfileMembers: {
          http: {
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles/{launchProfileId}/membership",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              identityStoreId: {
                locationName: "identityStoreId"
              },
              launchProfileId: {
                location: "uri",
                locationName: "launchProfileId"
              },
              members: {
                locationName: "members",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    persona: {
                      locationName: "persona"
                    },
                    principalId: {
                      locationName: "principalId"
                    }
                  },
                  required: [
                    "persona",
                    "principalId"
                  ]
                }
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "members",
              "launchProfileId",
              "identityStoreId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        PutStudioMembers: {
          http: {
            requestUri: "/2020-08-01/studios/{studioId}/membership",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              identityStoreId: {
                locationName: "identityStoreId"
              },
              members: {
                locationName: "members",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    persona: {
                      locationName: "persona"
                    },
                    principalId: {
                      locationName: "principalId"
                    }
                  },
                  required: [
                    "persona",
                    "principalId"
                  ]
                }
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "members",
              "identityStoreId"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartStudioSSOConfigurationRepair: {
          http: {
            method: "PUT",
            requestUri: "/2020-08-01/studios/{studioId}/sso-configuration",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId"
            ]
          },
          output: {
            type: "structure",
            members: {
              studio: {
                shape: "S1t",
                locationName: "studio"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/2020-08-01/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sq",
                locationName: "tags"
              }
            },
            required: [
              "resourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/2020-08-01/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                shape: "S3l",
                location: "querystring",
                locationName: "tagKeys"
              }
            },
            required: [
              "tagKeys",
              "resourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateLaunchProfile: {
          http: {
            method: "PATCH",
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles/{launchProfileId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              description: {
                locationName: "description"
              },
              launchProfileId: {
                location: "uri",
                locationName: "launchProfileId"
              },
              launchProfileProtocolVersions: {
                shape: "Sf",
                locationName: "launchProfileProtocolVersions"
              },
              name: {
                locationName: "name"
              },
              streamConfiguration: {
                shape: "Si",
                locationName: "streamConfiguration"
              },
              studioComponentIds: {
                shape: "Sp",
                locationName: "studioComponentIds"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "launchProfileId"
            ]
          },
          output: {
            type: "structure",
            members: {
              launchProfile: {
                shape: "Ss",
                locationName: "launchProfile"
              }
            }
          }
        },
        UpdateLaunchProfileMember: {
          http: {
            method: "PATCH",
            requestUri: "/2020-08-01/studios/{studioId}/launch-profiles/{launchProfileId}/membership/{principalId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              launchProfileId: {
                location: "uri",
                locationName: "launchProfileId"
              },
              persona: {
                locationName: "persona"
              },
              principalId: {
                location: "uri",
                locationName: "principalId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "persona",
              "principalId",
              "launchProfileId"
            ]
          },
          output: {
            type: "structure",
            members: {
              member: {
                shape: "S3x",
                locationName: "member"
              }
            }
          }
        },
        UpdateStreamingImage: {
          http: {
            method: "PATCH",
            requestUri: "/2020-08-01/studios/{studioId}/streaming-images/{streamingImageId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              description: {
                locationName: "description"
              },
              name: {
                locationName: "name"
              },
              streamingImageId: {
                location: "uri",
                locationName: "streamingImageId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              }
            },
            required: [
              "studioId",
              "streamingImageId"
            ]
          },
          output: {
            type: "structure",
            members: {
              streamingImage: {
                shape: "S12",
                locationName: "streamingImage"
              }
            }
          }
        },
        UpdateStudio: {
          http: {
            method: "PATCH",
            requestUri: "/2020-08-01/studios/{studioId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              adminRoleArn: {
                locationName: "adminRoleArn"
              },
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              displayName: {
                locationName: "displayName"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              },
              userRoleArn: {
                locationName: "userRoleArn"
              }
            },
            required: [
              "studioId"
            ]
          },
          output: {
            type: "structure",
            members: {
              studio: {
                shape: "S1t",
                locationName: "studio"
              }
            }
          }
        },
        UpdateStudioComponent: {
          http: {
            method: "PATCH",
            requestUri: "/2020-08-01/studios/{studioId}/studio-components/{studioComponentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              clientToken: {
                location: "header",
                locationName: "X-Amz-Client-Token",
                idempotencyToken: true
              },
              configuration: {
                shape: "S1y",
                locationName: "configuration"
              },
              description: {
                locationName: "description"
              },
              ec2SecurityGroupIds: {
                shape: "S2c",
                locationName: "ec2SecurityGroupIds"
              },
              initializationScripts: {
                shape: "S2e",
                locationName: "initializationScripts"
              },
              name: {
                locationName: "name"
              },
              scriptParameters: {
                shape: "S2k",
                locationName: "scriptParameters"
              },
              studioComponentId: {
                location: "uri",
                locationName: "studioComponentId"
              },
              studioId: {
                location: "uri",
                locationName: "studioId"
              },
              subtype: {
                locationName: "subtype"
              },
              type: {
                locationName: "type"
              }
            },
            required: [
              "studioId",
              "studioComponentId"
            ]
          },
          output: {
            type: "structure",
            members: {
              studioComponent: {
                shape: "S2r",
                locationName: "studioComponent"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        S6: {
          type: "list",
          member: {
            type: "structure",
            members: {
              acceptedAt: {
                shape: "S8",
                locationName: "acceptedAt"
              },
              acceptedBy: {
                locationName: "acceptedBy"
              },
              accepteeId: {
                locationName: "accepteeId"
              },
              eulaAcceptanceId: {
                locationName: "eulaAcceptanceId"
              },
              eulaId: {
                locationName: "eulaId"
              }
            }
          }
        },
        S8: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        Sd: {
          type: "list",
          member: {}
        },
        Sf: {
          type: "list",
          member: {}
        },
        Si: {
          type: "structure",
          members: {
            clipboardMode: {
              locationName: "clipboardMode"
            },
            ec2InstanceTypes: {
              shape: "Sk",
              locationName: "ec2InstanceTypes"
            },
            maxSessionLengthInMinutes: {
              locationName: "maxSessionLengthInMinutes",
              type: "integer"
            },
            streamingImageIds: {
              shape: "Sn",
              locationName: "streamingImageIds"
            }
          },
          required: [
            "clipboardMode",
            "streamingImageIds",
            "ec2InstanceTypes"
          ]
        },
        Sk: {
          type: "list",
          member: {}
        },
        Sn: {
          type: "list",
          member: {}
        },
        Sp: {
          type: "list",
          member: {}
        },
        Sq: {
          type: "map",
          key: {},
          value: {}
        },
        Ss: {
          type: "structure",
          members: {
            arn: {
              locationName: "arn"
            },
            createdAt: {
              shape: "S8",
              locationName: "createdAt"
            },
            createdBy: {
              locationName: "createdBy"
            },
            description: {
              locationName: "description"
            },
            ec2SubnetIds: {
              shape: "Sd",
              locationName: "ec2SubnetIds"
            },
            launchProfileId: {
              locationName: "launchProfileId"
            },
            launchProfileProtocolVersions: {
              shape: "Sf",
              locationName: "launchProfileProtocolVersions"
            },
            name: {
              locationName: "name"
            },
            state: {
              locationName: "state"
            },
            statusCode: {
              locationName: "statusCode"
            },
            statusMessage: {
              locationName: "statusMessage"
            },
            streamConfiguration: {
              locationName: "streamConfiguration",
              type: "structure",
              members: {
                clipboardMode: {
                  locationName: "clipboardMode"
                },
                ec2InstanceTypes: {
                  shape: "Sk",
                  locationName: "ec2InstanceTypes"
                },
                maxSessionLengthInMinutes: {
                  locationName: "maxSessionLengthInMinutes",
                  type: "integer"
                },
                streamingImageIds: {
                  shape: "Sn",
                  locationName: "streamingImageIds"
                }
              }
            },
            studioComponentIds: {
              shape: "Sp",
              locationName: "studioComponentIds"
            },
            tags: {
              shape: "Sq",
              locationName: "tags"
            },
            updatedAt: {
              shape: "S8",
              locationName: "updatedAt"
            },
            updatedBy: {
              locationName: "updatedBy"
            }
          }
        },
        S12: {
          type: "structure",
          members: {
            arn: {
              locationName: "arn"
            },
            description: {
              locationName: "description"
            },
            ec2ImageId: {
              locationName: "ec2ImageId"
            },
            encryptionConfiguration: {
              locationName: "encryptionConfiguration",
              type: "structure",
              members: {
                keyArn: {
                  locationName: "keyArn"
                },
                keyType: {
                  locationName: "keyType"
                }
              },
              required: [
                "keyType"
              ]
            },
            eulaIds: {
              shape: "S3",
              locationName: "eulaIds"
            },
            name: {
              locationName: "name"
            },
            owner: {
              locationName: "owner"
            },
            platform: {
              locationName: "platform"
            },
            state: {
              locationName: "state"
            },
            statusCode: {
              locationName: "statusCode"
            },
            statusMessage: {
              locationName: "statusMessage"
            },
            streamingImageId: {
              locationName: "streamingImageId"
            },
            tags: {
              shape: "Sq",
              locationName: "tags"
            }
          }
        },
        S1c: {
          type: "structure",
          members: {
            arn: {
              locationName: "arn"
            },
            createdAt: {
              shape: "S8",
              locationName: "createdAt"
            },
            createdBy: {
              locationName: "createdBy"
            },
            ec2InstanceType: {
              locationName: "ec2InstanceType"
            },
            launchProfileId: {
              locationName: "launchProfileId"
            },
            ownedBy: {
              locationName: "ownedBy"
            },
            sessionId: {
              locationName: "sessionId"
            },
            state: {
              locationName: "state"
            },
            statusCode: {
              locationName: "statusCode"
            },
            statusMessage: {
              locationName: "statusMessage"
            },
            streamingImageId: {
              locationName: "streamingImageId"
            },
            tags: {
              shape: "Sq",
              locationName: "tags"
            },
            terminateAt: {
              shape: "S8",
              locationName: "terminateAt"
            },
            updatedAt: {
              shape: "S8",
              locationName: "updatedAt"
            },
            updatedBy: {
              locationName: "updatedBy"
            }
          }
        },
        S1j: {
          type: "structure",
          members: {
            createdAt: {
              shape: "S8",
              locationName: "createdAt"
            },
            createdBy: {
              locationName: "createdBy"
            },
            expiresAt: {
              shape: "S8",
              locationName: "expiresAt"
            },
            ownedBy: {
              locationName: "ownedBy"
            },
            state: {
              locationName: "state"
            },
            statusCode: {
              locationName: "statusCode"
            },
            streamId: {
              locationName: "streamId"
            },
            url: {
              locationName: "url"
            }
          }
        },
        S1o: {
          type: "structure",
          members: {
            keyArn: {
              locationName: "keyArn"
            },
            keyType: {
              locationName: "keyType"
            }
          },
          required: [
            "keyType"
          ]
        },
        S1t: {
          type: "structure",
          members: {
            adminRoleArn: {
              locationName: "adminRoleArn"
            },
            arn: {
              locationName: "arn"
            },
            createdAt: {
              shape: "S8",
              locationName: "createdAt"
            },
            displayName: {
              locationName: "displayName"
            },
            homeRegion: {
              locationName: "homeRegion"
            },
            ssoClientId: {
              locationName: "ssoClientId"
            },
            state: {
              locationName: "state"
            },
            statusCode: {
              locationName: "statusCode"
            },
            statusMessage: {
              locationName: "statusMessage"
            },
            studioEncryptionConfiguration: {
              shape: "S1o",
              locationName: "studioEncryptionConfiguration"
            },
            studioId: {
              locationName: "studioId"
            },
            studioName: {
              locationName: "studioName"
            },
            studioUrl: {
              locationName: "studioUrl"
            },
            tags: {
              shape: "Sq",
              locationName: "tags"
            },
            updatedAt: {
              shape: "S8",
              locationName: "updatedAt"
            },
            userRoleArn: {
              locationName: "userRoleArn"
            }
          }
        },
        S1y: {
          type: "structure",
          members: {
            activeDirectoryConfiguration: {
              locationName: "activeDirectoryConfiguration",
              type: "structure",
              members: {
                computerAttributes: {
                  shape: "S20",
                  locationName: "computerAttributes"
                },
                directoryId: {
                  locationName: "directoryId"
                },
                organizationalUnitDistinguishedName: {
                  locationName: "organizationalUnitDistinguishedName"
                }
              }
            },
            computeFarmConfiguration: {
              locationName: "computeFarmConfiguration",
              type: "structure",
              members: {
                activeDirectoryUser: {
                  locationName: "activeDirectoryUser"
                },
                endpoint: {
                  locationName: "endpoint"
                }
              }
            },
            licenseServiceConfiguration: {
              locationName: "licenseServiceConfiguration",
              type: "structure",
              members: {
                endpoint: {
                  locationName: "endpoint"
                }
              }
            },
            sharedFileSystemConfiguration: {
              locationName: "sharedFileSystemConfiguration",
              type: "structure",
              members: {
                endpoint: {
                  locationName: "endpoint"
                },
                fileSystemId: {
                  locationName: "fileSystemId"
                },
                linuxMountPoint: {
                  locationName: "linuxMountPoint"
                },
                shareName: {
                  locationName: "shareName"
                },
                windowsMountDrive: {
                  locationName: "windowsMountDrive"
                }
              }
            }
          },
          union: true
        },
        S20: {
          type: "list",
          member: {
            type: "structure",
            members: {
              name: {
                locationName: "name"
              },
              value: {
                locationName: "value"
              }
            }
          }
        },
        S2c: {
          type: "list",
          member: {}
        },
        S2e: {
          type: "list",
          member: {
            type: "structure",
            members: {
              launchProfileProtocolVersion: {
                locationName: "launchProfileProtocolVersion"
              },
              platform: {
                locationName: "platform"
              },
              runContext: {
                locationName: "runContext"
              },
              script: {
                locationName: "script"
              }
            }
          }
        },
        S2k: {
          type: "list",
          member: {
            type: "structure",
            members: {
              key: {
                locationName: "key"
              },
              value: {
                locationName: "value"
              }
            }
          }
        },
        S2r: {
          type: "structure",
          members: {
            arn: {
              locationName: "arn"
            },
            configuration: {
              shape: "S1y",
              locationName: "configuration"
            },
            createdAt: {
              shape: "S8",
              locationName: "createdAt"
            },
            createdBy: {
              locationName: "createdBy"
            },
            description: {
              locationName: "description"
            },
            ec2SecurityGroupIds: {
              shape: "S2c",
              locationName: "ec2SecurityGroupIds"
            },
            initializationScripts: {
              shape: "S2e",
              locationName: "initializationScripts"
            },
            name: {
              locationName: "name"
            },
            scriptParameters: {
              shape: "S2k",
              locationName: "scriptParameters"
            },
            state: {
              locationName: "state"
            },
            statusCode: {
              locationName: "statusCode"
            },
            statusMessage: {
              locationName: "statusMessage"
            },
            studioComponentId: {
              locationName: "studioComponentId"
            },
            subtype: {
              locationName: "subtype"
            },
            tags: {
              shape: "Sq",
              locationName: "tags"
            },
            type: {
              locationName: "type"
            },
            updatedAt: {
              shape: "S8",
              locationName: "updatedAt"
            },
            updatedBy: {
              locationName: "updatedBy"
            }
          }
        },
        S3b: {
          type: "structure",
          members: {
            content: {
              locationName: "content"
            },
            createdAt: {
              shape: "S8",
              locationName: "createdAt"
            },
            eulaId: {
              locationName: "eulaId"
            },
            name: {
              locationName: "name"
            },
            updatedAt: {
              shape: "S8",
              locationName: "updatedAt"
            }
          }
        },
        S3h: {
          type: "list",
          member: {
            shape: "S12"
          }
        },
        S3l: {
          type: "list",
          member: {}
        },
        S3t: {
          type: "list",
          member: {
            type: "structure",
            members: {
              script: {
                locationName: "script"
              },
              studioComponentId: {
                locationName: "studioComponentId"
              },
              studioComponentName: {
                locationName: "studioComponentName"
              }
            }
          }
        },
        S3x: {
          type: "structure",
          members: {
            identityStoreId: {
              locationName: "identityStoreId"
            },
            persona: {
              locationName: "persona"
            },
            principalId: {
              locationName: "principalId"
            }
          }
        },
        S4b: {
          type: "structure",
          members: {
            identityStoreId: {
              locationName: "identityStoreId"
            },
            persona: {
              locationName: "persona"
            },
            principalId: {
              locationName: "principalId"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/nimble-2020-08-01.paginators.json
var require_nimble_2020_08_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/nimble-2020-08-01.paginators.json"(exports, module2) {
    module2.exports = {
      metadata: {
        endpointPrefix: "nimble",
        serviceFullName: "AmazonNimbleStudio",
        serviceId: "nimble",
        uid: "nimble-2020-08-01"
      },
      pagination: {
        ListEulaAcceptances: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "eulaAcceptances"
        },
        ListEulas: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "eulas"
        },
        ListLaunchProfileMembers: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "members"
        },
        ListLaunchProfiles: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "launchProfiles"
        },
        ListStreamingImages: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "streamingImages"
        },
        ListStreamingSessions: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "sessions"
        },
        ListStudioComponents: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "studioComponents"
        },
        ListStudioMembers: {
          input_token: "nextToken",
          limit_key: "maxResults",
          output_token: "nextToken",
          result_key: "members"
        },
        ListStudios: {
          input_token: "nextToken",
          output_token: "nextToken",
          result_key: "studios"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/nimble.js
var require_nimble = __commonJS({
  "node_modules/aws-sdk/clients/nimble.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["nimble"] = {};
    AWS3.Nimble = Service.defineService("nimble", ["2020-08-01"]);
    Object.defineProperty(apiLoader.services["nimble"], "2020-08-01", {
      get: function get() {
        var model = require_nimble_2020_08_01_min();
        model.paginators = require_nimble_2020_08_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Nimble;
  }
});

// node_modules/aws-sdk/lib/services/finspace.js
var require_finspace = __commonJS({
  "node_modules/aws-sdk/lib/services/finspace.js"() {
    var AWS3 = require_core();
    AWS3.util.update(AWS3.Finspace.prototype, {
      setupRequestListeners: function setupRequestListeners(request) {
        request.addListener("build", this.modifyContentType);
      },
      modifyContentType: function modifyContentType(request) {
        if (request.httpRequest.headers["Content-Type"] === "application/json") {
          request.httpRequest.headers["Content-Type"] = "application/x-amz-json-1.1";
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/finspace-2021-03-12.min.json
var require_finspace_2021_03_12_min = __commonJS({
  "node_modules/aws-sdk/apis/finspace-2021-03-12.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-03-12",
        endpointPrefix: "finspace",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "finspace",
        serviceFullName: "FinSpace User Environment Management service",
        serviceId: "finspace",
        signatureVersion: "v4",
        signingName: "finspace",
        uid: "finspace-2021-03-12"
      },
      operations: {
        CreateEnvironment: {
          http: {
            requestUri: "/environment"
          },
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {},
              description: {},
              kmsKeyId: {},
              tags: {
                shape: "S5"
              },
              federationMode: {},
              federationParameters: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environmentId: {},
              environmentArn: {},
              environmentUrl: {}
            }
          }
        },
        DeleteEnvironment: {
          http: {
            method: "DELETE",
            requestUri: "/environment/{environmentId}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        GetEnvironment: {
          http: {
            method: "GET",
            requestUri: "/environment/{environmentId}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environment: {
                shape: "Sn"
              }
            }
          }
        },
        ListEnvironments: {
          http: {
            method: "GET",
            requestUri: "/environment"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environments: {
                type: "list",
                member: {
                  shape: "Sn"
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S5"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}"
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateEnvironment: {
          http: {
            method: "PUT",
            requestUri: "/environment/{environmentId}"
          },
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              environmentId: {
                location: "uri",
                locationName: "environmentId"
              },
              name: {},
              description: {},
              federationMode: {},
              federationParameters: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              environment: {
                shape: "Sn"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "map",
          key: {},
          value: {}
        },
        S9: {
          type: "structure",
          members: {
            samlMetadataDocument: {},
            samlMetadataURL: {},
            applicationCallBackURL: {},
            federationURN: {},
            federationProviderName: {},
            attributeMap: {
              type: "map",
              key: {},
              value: {}
            }
          }
        },
        Sn: {
          type: "structure",
          members: {
            name: {},
            environmentId: {},
            awsAccountId: {},
            status: {},
            environmentUrl: {},
            description: {},
            environmentArn: {},
            sageMakerStudioDomainUrl: {},
            kmsKeyId: {},
            dedicatedServiceAccountId: {},
            federationMode: {},
            federationParameters: {
              shape: "S9"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/finspace-2021-03-12.paginators.json
var require_finspace_2021_03_12_paginators = __commonJS({
  "node_modules/aws-sdk/apis/finspace-2021-03-12.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/finspace.js
var require_finspace2 = __commonJS({
  "node_modules/aws-sdk/clients/finspace.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["finspace"] = {};
    AWS3.Finspace = Service.defineService("finspace", ["2021-03-12"]);
    require_finspace();
    Object.defineProperty(apiLoader.services["finspace"], "2021-03-12", {
      get: function get() {
        var model = require_finspace_2021_03_12_min();
        model.paginators = require_finspace_2021_03_12_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Finspace;
  }
});

// node_modules/aws-sdk/lib/services/finspacedata.js
var require_finspacedata = __commonJS({
  "node_modules/aws-sdk/lib/services/finspacedata.js"() {
    var AWS3 = require_core();
    AWS3.util.update(AWS3.Finspacedata.prototype, {
      setupRequestListeners: function setupRequestListeners(request) {
        request.addListener("build", this.modifyContentType);
      },
      modifyContentType: function modifyContentType(request) {
        if (request.httpRequest.headers["Content-Type"] === "application/json") {
          request.httpRequest.headers["Content-Type"] = "application/x-amz-json-1.1";
        }
      }
    });
  }
});

// node_modules/aws-sdk/apis/finspace-data-2020-07-13.min.json
var require_finspace_data_2020_07_13_min = __commonJS({
  "node_modules/aws-sdk/apis/finspace-data-2020-07-13.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-07-13",
        endpointPrefix: "finspace-api",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "FinSpace Data",
        serviceFullName: "FinSpace Public API",
        serviceId: "finspace data",
        signatureVersion: "v4",
        signingName: "finspace-api",
        uid: "finspace-2020-07-13"
      },
      operations: {
        CreateChangeset: {
          http: {
            requestUri: "/datasets/{datasetId}/changesets"
          },
          input: {
            type: "structure",
            required: [
              "datasetId",
              "changeType",
              "sourceType",
              "sourceParams"
            ],
            members: {
              datasetId: {
                location: "uri",
                locationName: "datasetId"
              },
              changeType: {},
              sourceType: {},
              sourceParams: {
                shape: "S5"
              },
              formatType: {},
              formatParams: {
                shape: "S5"
              },
              tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              changeset: {
                type: "structure",
                members: {
                  id: {},
                  changesetArn: {},
                  datasetId: {},
                  changeType: {},
                  sourceType: {},
                  sourceParams: {
                    shape: "S5"
                  },
                  formatType: {},
                  formatParams: {
                    shape: "S5"
                  },
                  createTimestamp: {
                    type: "timestamp"
                  },
                  status: {},
                  errorInfo: {
                    type: "structure",
                    members: {
                      errorMessage: {},
                      errorCategory: {}
                    }
                  },
                  changesetLabels: {
                    shape: "S5"
                  },
                  updatesChangesetId: {},
                  updatedByChangesetId: {}
                }
              }
            }
          }
        },
        GetProgrammaticAccessCredentials: {
          http: {
            method: "GET",
            requestUri: "/credentials/programmatic"
          },
          input: {
            type: "structure",
            required: [
              "environmentId"
            ],
            members: {
              durationInMinutes: {
                location: "querystring",
                locationName: "durationInMinutes",
                type: "long"
              },
              environmentId: {
                location: "querystring",
                locationName: "environmentId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              credentials: {
                type: "structure",
                members: {
                  accessKeyId: {},
                  secretAccessKey: {},
                  sessionToken: {}
                }
              },
              durationInMinutes: {
                type: "long"
              }
            }
          }
        },
        GetWorkingLocation: {
          http: {
            requestUri: "/workingLocationV1"
          },
          input: {
            type: "structure",
            members: {
              locationType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              s3Uri: {},
              s3Path: {},
              s3Bucket: {}
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "map",
          key: {},
          value: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/finspace-data-2020-07-13.paginators.json
var require_finspace_data_2020_07_13_paginators = __commonJS({
  "node_modules/aws-sdk/apis/finspace-data-2020-07-13.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/finspacedata.js
var require_finspacedata2 = __commonJS({
  "node_modules/aws-sdk/clients/finspacedata.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["finspacedata"] = {};
    AWS3.Finspacedata = Service.defineService("finspacedata", ["2020-07-13"]);
    require_finspacedata();
    Object.defineProperty(apiLoader.services["finspacedata"], "2020-07-13", {
      get: function get() {
        var model = require_finspace_data_2020_07_13_min();
        model.paginators = require_finspace_data_2020_07_13_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Finspacedata;
  }
});

// node_modules/aws-sdk/apis/ssm-contacts-2021-05-03.min.json
var require_ssm_contacts_2021_05_03_min = __commonJS({
  "node_modules/aws-sdk/apis/ssm-contacts-2021-05-03.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-05-03",
        endpointPrefix: "ssm-contacts",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "SSM Contacts",
        serviceFullName: "AWS Systems Manager Incident Manager Contacts",
        serviceId: "SSM Contacts",
        signatureVersion: "v4",
        signingName: "ssm-contacts",
        targetPrefix: "SSMContacts",
        uid: "ssm-contacts-2021-05-03"
      },
      operations: {
        AcceptPage: {
          input: {
            type: "structure",
            required: [
              "PageId",
              "AcceptType",
              "AcceptCode"
            ],
            members: {
              PageId: {},
              ContactChannelId: {},
              AcceptType: {},
              Note: {},
              AcceptCode: {},
              AcceptCodeValidation: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        ActivateContactChannel: {
          input: {
            type: "structure",
            required: [
              "ContactChannelId",
              "ActivationCode"
            ],
            members: {
              ContactChannelId: {},
              ActivationCode: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        CreateContact: {
          input: {
            type: "structure",
            required: [
              "Alias",
              "Type",
              "Plan"
            ],
            members: {
              Alias: {},
              DisplayName: {},
              Type: {},
              Plan: {
                shape: "Sf"
              },
              Tags: {
                shape: "Sp"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ContactArn"
            ],
            members: {
              ContactArn: {}
            }
          }
        },
        CreateContactChannel: {
          input: {
            type: "structure",
            required: [
              "ContactId",
              "Name",
              "Type",
              "DeliveryAddress"
            ],
            members: {
              ContactId: {},
              Name: {},
              Type: {},
              DeliveryAddress: {
                shape: "Sy"
              },
              DeferActivation: {
                type: "boolean"
              },
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ContactChannelArn"
            ],
            members: {
              ContactChannelArn: {}
            }
          }
        },
        DeactivateContactChannel: {
          input: {
            type: "structure",
            required: [
              "ContactChannelId"
            ],
            members: {
              ContactChannelId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteContact: {
          input: {
            type: "structure",
            required: [
              "ContactId"
            ],
            members: {
              ContactId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteContactChannel: {
          input: {
            type: "structure",
            required: [
              "ContactChannelId"
            ],
            members: {
              ContactChannelId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeEngagement: {
          input: {
            type: "structure",
            required: [
              "EngagementId"
            ],
            members: {
              EngagementId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ContactArn",
              "EngagementArn",
              "Sender",
              "Subject",
              "Content"
            ],
            members: {
              ContactArn: {},
              EngagementArn: {},
              Sender: {},
              Subject: {},
              Content: {},
              PublicSubject: {},
              PublicContent: {},
              IncidentId: {},
              StartTime: {
                type: "timestamp"
              },
              StopTime: {
                type: "timestamp"
              }
            }
          }
        },
        DescribePage: {
          input: {
            type: "structure",
            required: [
              "PageId"
            ],
            members: {
              PageId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "PageArn",
              "EngagementArn",
              "ContactArn",
              "Sender",
              "Subject",
              "Content"
            ],
            members: {
              PageArn: {},
              EngagementArn: {},
              ContactArn: {},
              Sender: {},
              Subject: {},
              Content: {},
              PublicSubject: {},
              PublicContent: {},
              IncidentId: {},
              SentTime: {
                type: "timestamp"
              },
              ReadTime: {
                type: "timestamp"
              },
              DeliveryTime: {
                type: "timestamp"
              }
            }
          }
        },
        GetContact: {
          input: {
            type: "structure",
            required: [
              "ContactId"
            ],
            members: {
              ContactId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ContactArn",
              "Alias",
              "Type",
              "Plan"
            ],
            members: {
              ContactArn: {},
              Alias: {},
              DisplayName: {},
              Type: {},
              Plan: {
                shape: "Sf"
              }
            }
          }
        },
        GetContactChannel: {
          input: {
            type: "structure",
            required: [
              "ContactChannelId"
            ],
            members: {
              ContactChannelId: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ContactArn",
              "ContactChannelArn",
              "Name",
              "Type",
              "DeliveryAddress"
            ],
            members: {
              ContactArn: {},
              ContactChannelArn: {},
              Name: {},
              Type: {},
              DeliveryAddress: {
                shape: "Sy"
              },
              ActivationStatus: {}
            }
          }
        },
        GetContactPolicy: {
          input: {
            type: "structure",
            required: [
              "ContactArn"
            ],
            members: {
              ContactArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ContactArn: {},
              Policy: {}
            }
          }
        },
        ListContactChannels: {
          input: {
            type: "structure",
            required: [
              "ContactId"
            ],
            members: {
              ContactId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ContactChannels"
            ],
            members: {
              NextToken: {},
              ContactChannels: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ContactChannelArn",
                    "ContactArn",
                    "Name",
                    "DeliveryAddress",
                    "ActivationStatus"
                  ],
                  members: {
                    ContactChannelArn: {},
                    ContactArn: {},
                    Name: {},
                    Type: {},
                    DeliveryAddress: {
                      shape: "Sy"
                    },
                    ActivationStatus: {}
                  }
                }
              }
            }
          }
        },
        ListContacts: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              AliasPrefix: {},
              Type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Contacts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ContactArn",
                    "Alias",
                    "Type"
                  ],
                  members: {
                    ContactArn: {},
                    Alias: {},
                    DisplayName: {},
                    Type: {}
                  }
                }
              }
            }
          }
        },
        ListEngagements: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              IncidentId: {},
              TimeRangeValue: {
                type: "structure",
                members: {
                  StartTime: {
                    type: "timestamp"
                  },
                  EndTime: {
                    type: "timestamp"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Engagements"
            ],
            members: {
              NextToken: {},
              Engagements: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "EngagementArn",
                    "ContactArn",
                    "Sender"
                  ],
                  members: {
                    EngagementArn: {},
                    ContactArn: {},
                    Sender: {},
                    IncidentId: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    StopTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListPageReceipts: {
          input: {
            type: "structure",
            required: [
              "PageId"
            ],
            members: {
              PageId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Receipts: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "ReceiptType",
                    "ReceiptTime"
                  ],
                  members: {
                    ContactChannelArn: {},
                    ReceiptType: {},
                    ReceiptInfo: {},
                    ReceiptTime: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListPagesByContact: {
          input: {
            type: "structure",
            required: [
              "ContactId"
            ],
            members: {
              ContactId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Pages"
            ],
            members: {
              NextToken: {},
              Pages: {
                shape: "S2d"
              }
            }
          }
        },
        ListPagesByEngagement: {
          input: {
            type: "structure",
            required: [
              "EngagementId"
            ],
            members: {
              EngagementId: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Pages"
            ],
            members: {
              NextToken: {},
              Pages: {
                shape: "S2d"
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN"
            ],
            members: {
              ResourceARN: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sp"
              }
            }
          }
        },
        PutContactPolicy: {
          input: {
            type: "structure",
            required: [
              "ContactArn",
              "Policy"
            ],
            members: {
              ContactArn: {},
              Policy: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SendActivationCode: {
          input: {
            type: "structure",
            required: [
              "ContactChannelId"
            ],
            members: {
              ContactChannelId: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        StartEngagement: {
          input: {
            type: "structure",
            required: [
              "ContactId",
              "Sender",
              "Subject",
              "Content"
            ],
            members: {
              ContactId: {},
              Sender: {},
              Subject: {},
              Content: {},
              PublicSubject: {},
              PublicContent: {},
              IncidentId: {},
              IdempotencyToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "EngagementArn"
            ],
            members: {
              EngagementArn: {}
            }
          }
        },
        StopEngagement: {
          input: {
            type: "structure",
            required: [
              "EngagementId"
            ],
            members: {
              EngagementId: {},
              Reason: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "Tags"
            ],
            members: {
              ResourceARN: {},
              Tags: {
                shape: "Sp"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceARN",
              "TagKeys"
            ],
            members: {
              ResourceARN: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateContact: {
          input: {
            type: "structure",
            required: [
              "ContactId"
            ],
            members: {
              ContactId: {},
              DisplayName: {},
              Plan: {
                shape: "Sf"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateContactChannel: {
          input: {
            type: "structure",
            required: [
              "ContactChannelId"
            ],
            members: {
              ContactChannelId: {},
              Name: {},
              DeliveryAddress: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {
        Sf: {
          type: "structure",
          required: [
            "Stages"
          ],
          members: {
            Stages: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "DurationInMinutes",
                  "Targets"
                ],
                members: {
                  DurationInMinutes: {
                    type: "integer"
                  },
                  Targets: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ChannelTargetInfo: {
                          type: "structure",
                          required: [
                            "ContactChannelId"
                          ],
                          members: {
                            ContactChannelId: {},
                            RetryIntervalInMinutes: {
                              type: "integer"
                            }
                          }
                        },
                        ContactTargetInfo: {
                          type: "structure",
                          required: [
                            "IsEssential"
                          ],
                          members: {
                            ContactId: {},
                            IsEssential: {
                              type: "boolean"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        Sp: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sy: {
          type: "structure",
          members: {
            SimpleAddress: {}
          }
        },
        S2d: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "PageArn",
              "EngagementArn",
              "ContactArn",
              "Sender"
            ],
            members: {
              PageArn: {},
              EngagementArn: {},
              ContactArn: {},
              Sender: {},
              IncidentId: {},
              SentTime: {
                type: "timestamp"
              },
              DeliveryTime: {
                type: "timestamp"
              },
              ReadTime: {
                type: "timestamp"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ssm-contacts-2021-05-03.paginators.json
var require_ssm_contacts_2021_05_03_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ssm-contacts-2021-05-03.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListContactChannels: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "ContactChannels"
        },
        ListContacts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Contacts"
        },
        ListEngagements: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Engagements"
        },
        ListPageReceipts: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Receipts"
        },
        ListPagesByContact: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Pages"
        },
        ListPagesByEngagement: {
          input_token: "NextToken",
          limit_key: "MaxResults",
          output_token: "NextToken",
          result_key: "Pages"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ssmcontacts.js
var require_ssmcontacts = __commonJS({
  "node_modules/aws-sdk/clients/ssmcontacts.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["ssmcontacts"] = {};
    AWS3.SSMContacts = Service.defineService("ssmcontacts", ["2021-05-03"]);
    Object.defineProperty(apiLoader.services["ssmcontacts"], "2021-05-03", {
      get: function get() {
        var model = require_ssm_contacts_2021_05_03_min();
        model.paginators = require_ssm_contacts_2021_05_03_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SSMContacts;
  }
});

// node_modules/aws-sdk/apis/ssm-incidents-2018-05-10.min.json
var require_ssm_incidents_2018_05_10_min = __commonJS({
  "node_modules/aws-sdk/apis/ssm-incidents-2018-05-10.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2018-05-10",
        endpointPrefix: "ssm-incidents",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "SSM Incidents",
        serviceFullName: "AWS Systems Manager Incident Manager",
        serviceId: "SSM Incidents",
        signatureVersion: "v4",
        signingName: "ssm-incidents",
        uid: "ssm-incidents-2018-05-10"
      },
      operations: {
        CreateReplicationSet: {
          http: {
            requestUri: "/createReplicationSet",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "regions"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              regions: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    sseKmsKeyId: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          }
        },
        CreateResponsePlan: {
          http: {
            requestUri: "/createResponsePlan",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "incidentTemplate",
              "name"
            ],
            members: {
              actions: {
                shape: "Sa"
              },
              chatChannel: {
                shape: "Sl"
              },
              clientToken: {
                idempotencyToken: true
              },
              displayName: {},
              engagements: {
                shape: "Sq"
              },
              incidentTemplate: {
                shape: "Ss"
              },
              name: {},
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          idempotent: true
        },
        CreateTimelineEvent: {
          http: {
            requestUri: "/createTimelineEvent",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "eventData",
              "eventTime",
              "eventType",
              "incidentRecordArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              eventData: {},
              eventTime: {
                type: "timestamp"
              },
              eventType: {},
              incidentRecordArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "eventId",
              "incidentRecordArn"
            ],
            members: {
              eventId: {},
              incidentRecordArn: {}
            }
          },
          idempotent: true
        },
        DeleteIncidentRecord: {
          http: {
            requestUri: "/deleteIncidentRecord",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteReplicationSet: {
          http: {
            requestUri: "/deleteReplicationSet",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {
                location: "querystring",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteResourcePolicy: {
          http: {
            requestUri: "/deleteResourcePolicy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "policyId",
              "resourceArn"
            ],
            members: {
              policyId: {},
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteResponsePlan: {
          http: {
            requestUri: "/deleteResponsePlan",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteTimelineEvent: {
          http: {
            requestUri: "/deleteTimelineEvent",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "eventId",
              "incidentRecordArn"
            ],
            members: {
              eventId: {},
              incidentRecordArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetIncidentRecord: {
          http: {
            method: "GET",
            requestUri: "/getIncidentRecord",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {
                location: "querystring",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "incidentRecord"
            ],
            members: {
              incidentRecord: {
                type: "structure",
                required: [
                  "arn",
                  "creationTime",
                  "dedupeString",
                  "impact",
                  "incidentRecordSource",
                  "lastModifiedBy",
                  "lastModifiedTime",
                  "status",
                  "title"
                ],
                members: {
                  arn: {},
                  automationExecutions: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        ssmExecutionArn: {}
                      },
                      union: true
                    }
                  },
                  chatChannel: {
                    shape: "Sl"
                  },
                  creationTime: {
                    type: "timestamp"
                  },
                  dedupeString: {},
                  impact: {
                    type: "integer"
                  },
                  incidentRecordSource: {
                    shape: "S1q"
                  },
                  lastModifiedBy: {},
                  lastModifiedTime: {
                    type: "timestamp"
                  },
                  notificationTargets: {
                    shape: "Sv"
                  },
                  resolvedTime: {
                    type: "timestamp"
                  },
                  status: {},
                  summary: {},
                  title: {}
                }
              }
            }
          }
        },
        GetReplicationSet: {
          http: {
            method: "GET",
            requestUri: "/getReplicationSet",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {
                location: "querystring",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "replicationSet"
            ],
            members: {
              replicationSet: {
                type: "structure",
                required: [
                  "createdBy",
                  "createdTime",
                  "deletionProtected",
                  "lastModifiedBy",
                  "lastModifiedTime",
                  "regionMap",
                  "status"
                ],
                members: {
                  arn: {},
                  createdBy: {},
                  createdTime: {
                    type: "timestamp"
                  },
                  deletionProtected: {
                    type: "boolean"
                  },
                  lastModifiedBy: {},
                  lastModifiedTime: {
                    type: "timestamp"
                  },
                  regionMap: {
                    type: "map",
                    key: {},
                    value: {
                      type: "structure",
                      required: [
                        "status",
                        "statusUpdateDateTime"
                      ],
                      members: {
                        sseKmsKeyId: {},
                        status: {},
                        statusMessage: {},
                        statusUpdateDateTime: {
                          type: "timestamp"
                        }
                      }
                    }
                  },
                  status: {}
                }
              }
            }
          }
        },
        GetResourcePolicies: {
          http: {
            requestUri: "/getResourcePolicies",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              resourceArn: {
                location: "querystring",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "resourcePolicies"
            ],
            members: {
              nextToken: {},
              resourcePolicies: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "policyDocument",
                    "policyId",
                    "ramResourceShareRegion"
                  ],
                  members: {
                    policyDocument: {},
                    policyId: {},
                    ramResourceShareRegion: {}
                  }
                }
              }
            }
          }
        },
        GetResponsePlan: {
          http: {
            method: "GET",
            requestUri: "/getResponsePlan",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {
                location: "querystring",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "arn",
              "incidentTemplate",
              "name"
            ],
            members: {
              actions: {
                shape: "Sa"
              },
              arn: {},
              chatChannel: {
                shape: "Sl"
              },
              displayName: {},
              engagements: {
                shape: "Sq"
              },
              incidentTemplate: {
                shape: "Ss"
              },
              name: {}
            }
          }
        },
        GetTimelineEvent: {
          http: {
            method: "GET",
            requestUri: "/getTimelineEvent",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "eventId",
              "incidentRecordArn"
            ],
            members: {
              eventId: {
                location: "querystring",
                locationName: "eventId"
              },
              incidentRecordArn: {
                location: "querystring",
                locationName: "incidentRecordArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "event"
            ],
            members: {
              event: {
                type: "structure",
                required: [
                  "eventData",
                  "eventId",
                  "eventTime",
                  "eventType",
                  "eventUpdatedTime",
                  "incidentRecordArn"
                ],
                members: {
                  eventData: {},
                  eventId: {},
                  eventTime: {
                    type: "timestamp"
                  },
                  eventType: {},
                  eventUpdatedTime: {
                    type: "timestamp"
                  },
                  incidentRecordArn: {}
                }
              }
            }
          }
        },
        ListIncidentRecords: {
          http: {
            requestUri: "/listIncidentRecords",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              filters: {
                shape: "S2f"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "incidentRecordSummaries"
            ],
            members: {
              incidentRecordSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "creationTime",
                    "impact",
                    "incidentRecordSource",
                    "status",
                    "title"
                  ],
                  members: {
                    arn: {},
                    creationTime: {
                      type: "timestamp"
                    },
                    impact: {
                      type: "integer"
                    },
                    incidentRecordSource: {
                      shape: "S1q"
                    },
                    resolvedTime: {
                      type: "timestamp"
                    },
                    status: {},
                    title: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListRelatedItems: {
          http: {
            requestUri: "/listRelatedItems",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "incidentRecordArn"
            ],
            members: {
              incidentRecordArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "relatedItems"
            ],
            members: {
              nextToken: {},
              relatedItems: {
                shape: "S2t"
              }
            }
          }
        },
        ListReplicationSets: {
          http: {
            requestUri: "/listReplicationSets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "replicationSetArns"
            ],
            members: {
              nextToken: {},
              replicationSetArns: {
                type: "list",
                member: {}
              }
            }
          }
        },
        ListResponsePlans: {
          http: {
            requestUri: "/listResponsePlans",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "responsePlanSummaries"
            ],
            members: {
              nextToken: {},
              responsePlanSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "name"
                  ],
                  members: {
                    arn: {},
                    displayName: {},
                    name: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              tags: {
                shape: "S10"
              }
            }
          }
        },
        ListTimelineEvents: {
          http: {
            requestUri: "/listTimelineEvents",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "incidentRecordArn"
            ],
            members: {
              filters: {
                shape: "S2f"
              },
              incidentRecordArn: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              sortBy: {},
              sortOrder: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "eventSummaries"
            ],
            members: {
              eventSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "eventId",
                    "eventTime",
                    "eventType",
                    "eventUpdatedTime",
                    "incidentRecordArn"
                  ],
                  members: {
                    eventId: {},
                    eventTime: {
                      type: "timestamp"
                    },
                    eventType: {},
                    eventUpdatedTime: {
                      type: "timestamp"
                    },
                    incidentRecordArn: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        PutResourcePolicy: {
          http: {
            requestUri: "/putResourcePolicy",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "policy",
              "resourceArn"
            ],
            members: {
              policy: {},
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "policyId"
            ],
            members: {
              policyId: {}
            }
          }
        },
        StartIncident: {
          http: {
            requestUri: "/startIncident",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "responsePlanArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              impact: {
                type: "integer"
              },
              relatedItems: {
                shape: "S2t"
              },
              responsePlanArn: {},
              title: {},
              triggerDetails: {
                type: "structure",
                required: [
                  "source",
                  "timestamp"
                ],
                members: {
                  rawData: {},
                  source: {},
                  timestamp: {
                    type: "timestamp"
                  },
                  triggerArn: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "incidentRecordArn"
            ],
            members: {
              incidentRecordArn: {}
            }
          },
          idempotent: true
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S10"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateDeletionProtection: {
          http: {
            requestUri: "/updateDeletionProtection",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "arn",
              "deletionProtected"
            ],
            members: {
              arn: {},
              clientToken: {
                idempotencyToken: true
              },
              deletionProtected: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateIncidentRecord: {
          http: {
            requestUri: "/updateIncidentRecord",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              arn: {},
              chatChannel: {
                shape: "Sl"
              },
              clientToken: {
                idempotencyToken: true
              },
              impact: {
                type: "integer"
              },
              notificationTargets: {
                shape: "Sv"
              },
              status: {},
              summary: {},
              title: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateRelatedItems: {
          http: {
            requestUri: "/updateRelatedItems",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "incidentRecordArn",
              "relatedItemsUpdate"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              incidentRecordArn: {},
              relatedItemsUpdate: {
                type: "structure",
                members: {
                  itemToAdd: {
                    shape: "S2u"
                  },
                  itemToRemove: {
                    shape: "S2v"
                  }
                },
                union: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateReplicationSet: {
          http: {
            requestUri: "/updateReplicationSet",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "actions",
              "arn"
            ],
            members: {
              actions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    addRegionAction: {
                      type: "structure",
                      required: [
                        "regionName"
                      ],
                      members: {
                        regionName: {},
                        sseKmsKeyId: {}
                      }
                    },
                    deleteRegionAction: {
                      type: "structure",
                      required: [
                        "regionName"
                      ],
                      members: {
                        regionName: {}
                      }
                    }
                  },
                  union: true
                }
              },
              arn: {},
              clientToken: {
                idempotencyToken: true
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateResponsePlan: {
          http: {
            requestUri: "/updateResponsePlan",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "arn"
            ],
            members: {
              actions: {
                shape: "Sa"
              },
              arn: {},
              chatChannel: {
                shape: "Sl"
              },
              clientToken: {
                idempotencyToken: true
              },
              displayName: {},
              engagements: {
                shape: "Sq"
              },
              incidentTemplateDedupeString: {},
              incidentTemplateImpact: {
                type: "integer"
              },
              incidentTemplateNotificationTargets: {
                shape: "Sv"
              },
              incidentTemplateSummary: {},
              incidentTemplateTitle: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateTimelineEvent: {
          http: {
            requestUri: "/updateTimelineEvent",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "eventId",
              "incidentRecordArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              eventData: {},
              eventId: {},
              eventTime: {
                type: "timestamp"
              },
              eventType: {},
              incidentRecordArn: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        }
      },
      shapes: {
        Sa: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ssmAutomation: {
                type: "structure",
                required: [
                  "documentName",
                  "roleArn"
                ],
                members: {
                  documentName: {},
                  documentVersion: {},
                  parameters: {
                    type: "map",
                    key: {},
                    value: {
                      type: "list",
                      member: {}
                    }
                  },
                  roleArn: {},
                  targetAccount: {}
                }
              }
            },
            union: true
          }
        },
        Sl: {
          type: "structure",
          members: {
            chatbotSns: {
              type: "list",
              member: {}
            },
            empty: {
              type: "structure",
              members: {}
            }
          },
          union: true
        },
        Sq: {
          type: "list",
          member: {}
        },
        Ss: {
          type: "structure",
          required: [
            "impact",
            "title"
          ],
          members: {
            dedupeString: {},
            impact: {
              type: "integer"
            },
            notificationTargets: {
              shape: "Sv"
            },
            summary: {},
            title: {}
          }
        },
        Sv: {
          type: "list",
          member: {
            type: "structure",
            members: {
              snsTopicArn: {}
            },
            union: true
          }
        },
        S10: {
          type: "map",
          key: {},
          value: {}
        },
        S1q: {
          type: "structure",
          required: [
            "createdBy",
            "source"
          ],
          members: {
            createdBy: {},
            invokedBy: {},
            resourceArn: {},
            source: {}
          }
        },
        S2f: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "condition",
              "key"
            ],
            members: {
              condition: {
                type: "structure",
                members: {
                  after: {
                    type: "timestamp"
                  },
                  before: {
                    type: "timestamp"
                  },
                  equals: {
                    type: "structure",
                    members: {
                      integerValues: {
                        type: "list",
                        member: {
                          type: "integer"
                        }
                      },
                      stringValues: {
                        type: "list",
                        member: {}
                      }
                    },
                    union: true
                  }
                },
                union: true
              },
              key: {}
            }
          }
        },
        S2t: {
          type: "list",
          member: {
            shape: "S2u"
          }
        },
        S2u: {
          type: "structure",
          required: [
            "identifier"
          ],
          members: {
            identifier: {
              shape: "S2v"
            },
            title: {}
          }
        },
        S2v: {
          type: "structure",
          required: [
            "type",
            "value"
          ],
          members: {
            type: {},
            value: {
              type: "structure",
              members: {
                arn: {},
                metricDefinition: {},
                url: {}
              },
              union: true
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ssm-incidents-2018-05-10.paginators.json
var require_ssm_incidents_2018_05_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/ssm-incidents-2018-05-10.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        GetResourcePolicies: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "resourcePolicies"
        },
        ListIncidentRecords: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "incidentRecordSummaries"
        },
        ListRelatedItems: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "relatedItems"
        },
        ListReplicationSets: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "replicationSetArns"
        },
        ListResponsePlans: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "responsePlanSummaries"
        },
        ListTimelineEvents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "eventSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/ssm-incidents-2018-05-10.waiters2.json
var require_ssm_incidents_2018_05_10_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/ssm-incidents-2018-05-10.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        WaitForReplicationSetActive: {
          description: "Wait for a replication set to become ACTIVE",
          delay: 30,
          maxAttempts: 5,
          operation: "GetReplicationSet",
          acceptors: [{
            matcher: "path",
            argument: "replicationSet.status",
            state: "success",
            expected: "ACTIVE"
          }, {
            matcher: "path",
            argument: "replicationSet.status",
            state: "retry",
            expected: "CREATING"
          }, {
            matcher: "path",
            argument: "replicationSet.status",
            state: "retry",
            expected: "UPDATING"
          }, {
            matcher: "path",
            argument: "replicationSet.status",
            state: "failure",
            expected: "FAILED"
          }]
        },
        WaitForReplicationSetDeleted: {
          description: "Wait for a replication set to be deleted",
          delay: 30,
          maxAttempts: 5,
          operation: "GetReplicationSet",
          acceptors: [{
            matcher: "error",
            state: "success",
            expected: "ResourceNotFoundException"
          }, {
            matcher: "path",
            argument: "replicationSet.status",
            state: "retry",
            expected: "DELETING"
          }, {
            matcher: "path",
            argument: "replicationSet.status",
            state: "failure",
            expected: "FAILED"
          }]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/ssmincidents.js
var require_ssmincidents = __commonJS({
  "node_modules/aws-sdk/clients/ssmincidents.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["ssmincidents"] = {};
    AWS3.SSMIncidents = Service.defineService("ssmincidents", ["2018-05-10"]);
    Object.defineProperty(apiLoader.services["ssmincidents"], "2018-05-10", {
      get: function get() {
        var model = require_ssm_incidents_2018_05_10_min();
        model.paginators = require_ssm_incidents_2018_05_10_paginators().pagination;
        model.waiters = require_ssm_incidents_2018_05_10_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SSMIncidents;
  }
});

// node_modules/aws-sdk/apis/applicationcostprofiler-2020-09-10.min.json
var require_applicationcostprofiler_2020_09_10_min = __commonJS({
  "node_modules/aws-sdk/apis/applicationcostprofiler-2020-09-10.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-09-10",
        endpointPrefix: "application-cost-profiler",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Application Cost Profiler",
        serviceId: "ApplicationCostProfiler",
        signatureVersion: "v4",
        signingName: "application-cost-profiler",
        uid: "AWSApplicationCostProfiler-2020-09-10"
      },
      operations: {
        DeleteReportDefinition: {
          http: {
            method: "DELETE",
            requestUri: "/reportDefinition/{reportId}"
          },
          input: {
            type: "structure",
            required: [
              "reportId"
            ],
            members: {
              reportId: {
                location: "uri",
                locationName: "reportId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              reportId: {}
            }
          }
        },
        GetReportDefinition: {
          http: {
            method: "GET",
            requestUri: "/reportDefinition/{reportId}"
          },
          input: {
            type: "structure",
            required: [
              "reportId"
            ],
            members: {
              reportId: {
                location: "uri",
                locationName: "reportId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "reportId",
              "reportDescription",
              "reportFrequency",
              "format",
              "destinationS3Location",
              "createdAt",
              "lastUpdated"
            ],
            members: {
              reportId: {},
              reportDescription: {},
              reportFrequency: {},
              format: {},
              destinationS3Location: {
                shape: "S9"
              },
              createdAt: {
                type: "timestamp"
              },
              lastUpdated: {
                type: "timestamp"
              }
            }
          }
        },
        ImportApplicationUsage: {
          http: {
            requestUri: "/importApplicationUsage"
          },
          input: {
            type: "structure",
            required: [
              "sourceS3Location"
            ],
            members: {
              sourceS3Location: {
                type: "structure",
                required: [
                  "bucket",
                  "key"
                ],
                members: {
                  bucket: {},
                  key: {},
                  region: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "importId"
            ],
            members: {
              importId: {}
            }
          }
        },
        ListReportDefinitions: {
          http: {
            method: "GET",
            requestUri: "/reportDefinition"
          },
          input: {
            type: "structure",
            members: {
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              reportDefinitions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    reportId: {},
                    reportDescription: {},
                    reportFrequency: {},
                    format: {},
                    destinationS3Location: {
                      shape: "S9"
                    },
                    createdAt: {
                      type: "timestamp"
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        PutReportDefinition: {
          http: {
            requestUri: "/reportDefinition"
          },
          input: {
            type: "structure",
            required: [
              "reportId",
              "reportDescription",
              "reportFrequency",
              "format",
              "destinationS3Location"
            ],
            members: {
              reportId: {},
              reportDescription: {},
              reportFrequency: {},
              format: {},
              destinationS3Location: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              reportId: {}
            }
          }
        },
        UpdateReportDefinition: {
          http: {
            method: "PUT",
            requestUri: "/reportDefinition/{reportId}"
          },
          input: {
            type: "structure",
            required: [
              "reportId",
              "reportDescription",
              "reportFrequency",
              "format",
              "destinationS3Location"
            ],
            members: {
              reportId: {
                location: "uri",
                locationName: "reportId"
              },
              reportDescription: {},
              reportFrequency: {},
              format: {},
              destinationS3Location: {
                shape: "S9"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              reportId: {}
            }
          }
        }
      },
      shapes: {
        S9: {
          type: "structure",
          required: [
            "bucket",
            "prefix"
          ],
          members: {
            bucket: {},
            prefix: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/applicationcostprofiler-2020-09-10.paginators.json
var require_applicationcostprofiler_2020_09_10_paginators = __commonJS({
  "node_modules/aws-sdk/apis/applicationcostprofiler-2020-09-10.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListReportDefinitions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "reportDefinitions"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/applicationcostprofiler.js
var require_applicationcostprofiler = __commonJS({
  "node_modules/aws-sdk/clients/applicationcostprofiler.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["applicationcostprofiler"] = {};
    AWS3.ApplicationCostProfiler = Service.defineService("applicationcostprofiler", ["2020-09-10"]);
    Object.defineProperty(apiLoader.services["applicationcostprofiler"], "2020-09-10", {
      get: function get() {
        var model = require_applicationcostprofiler_2020_09_10_min();
        model.paginators = require_applicationcostprofiler_2020_09_10_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ApplicationCostProfiler;
  }
});

// node_modules/aws-sdk/apis/apprunner-2020-05-15.min.json
var require_apprunner_2020_05_15_min = __commonJS({
  "node_modules/aws-sdk/apis/apprunner-2020-05-15.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-05-15",
        endpointPrefix: "apprunner",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "AWS App Runner",
        serviceId: "AppRunner",
        signatureVersion: "v4",
        signingName: "apprunner",
        targetPrefix: "AppRunner",
        uid: "apprunner-2020-05-15"
      },
      operations: {
        AssociateCustomDomain: {
          input: {
            type: "structure",
            required: [
              "ServiceArn",
              "DomainName"
            ],
            members: {
              ServiceArn: {},
              DomainName: {},
              EnableWWWSubdomain: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DNSTarget",
              "ServiceArn",
              "CustomDomain"
            ],
            members: {
              DNSTarget: {},
              ServiceArn: {},
              CustomDomain: {
                shape: "S7"
              }
            }
          }
        },
        CreateAutoScalingConfiguration: {
          input: {
            type: "structure",
            required: [
              "AutoScalingConfigurationName"
            ],
            members: {
              AutoScalingConfigurationName: {},
              MaxConcurrency: {
                type: "integer"
              },
              MinSize: {
                type: "integer"
              },
              MaxSize: {
                type: "integer"
              },
              Tags: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "AutoScalingConfiguration"
            ],
            members: {
              AutoScalingConfiguration: {
                shape: "Sm"
              }
            }
          }
        },
        CreateConnection: {
          input: {
            type: "structure",
            required: [
              "ConnectionName",
              "ProviderType"
            ],
            members: {
              ConnectionName: {},
              ProviderType: {},
              Tags: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Connection"
            ],
            members: {
              Connection: {
                shape: "Sv"
              }
            }
          }
        },
        CreateService: {
          input: {
            type: "structure",
            required: [
              "ServiceName",
              "SourceConfiguration"
            ],
            members: {
              ServiceName: {},
              SourceConfiguration: {
                shape: "Sz"
              },
              InstanceConfiguration: {
                shape: "S1i"
              },
              Tags: {
                shape: "Sh"
              },
              EncryptionConfiguration: {
                shape: "S1l"
              },
              HealthCheckConfiguration: {
                shape: "S1n"
              },
              AutoScalingConfigurationArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Service",
              "OperationId"
            ],
            members: {
              Service: {
                shape: "S1v"
              },
              OperationId: {}
            }
          }
        },
        DeleteAutoScalingConfiguration: {
          input: {
            type: "structure",
            required: [
              "AutoScalingConfigurationArn"
            ],
            members: {
              AutoScalingConfigurationArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AutoScalingConfiguration"
            ],
            members: {
              AutoScalingConfiguration: {
                shape: "Sm"
              }
            }
          }
        },
        DeleteConnection: {
          input: {
            type: "structure",
            required: [
              "ConnectionArn"
            ],
            members: {
              ConnectionArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "Sv"
              }
            }
          }
        },
        DeleteService: {
          input: {
            type: "structure",
            required: [
              "ServiceArn"
            ],
            members: {
              ServiceArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Service",
              "OperationId"
            ],
            members: {
              Service: {
                shape: "S1v"
              },
              OperationId: {}
            }
          }
        },
        DescribeAutoScalingConfiguration: {
          input: {
            type: "structure",
            required: [
              "AutoScalingConfigurationArn"
            ],
            members: {
              AutoScalingConfigurationArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AutoScalingConfiguration"
            ],
            members: {
              AutoScalingConfiguration: {
                shape: "Sm"
              }
            }
          }
        },
        DescribeCustomDomains: {
          input: {
            type: "structure",
            required: [
              "ServiceArn"
            ],
            members: {
              ServiceArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DNSTarget",
              "ServiceArn",
              "CustomDomains"
            ],
            members: {
              DNSTarget: {},
              ServiceArn: {},
              CustomDomains: {
                type: "list",
                member: {
                  shape: "S7"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeService: {
          input: {
            type: "structure",
            required: [
              "ServiceArn"
            ],
            members: {
              ServiceArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Service"
            ],
            members: {
              Service: {
                shape: "S1v"
              }
            }
          }
        },
        DisassociateCustomDomain: {
          input: {
            type: "structure",
            required: [
              "ServiceArn",
              "DomainName"
            ],
            members: {
              ServiceArn: {},
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "DNSTarget",
              "ServiceArn",
              "CustomDomain"
            ],
            members: {
              DNSTarget: {},
              ServiceArn: {},
              CustomDomain: {
                shape: "S7"
              }
            }
          }
        },
        ListAutoScalingConfigurations: {
          input: {
            type: "structure",
            members: {
              AutoScalingConfigurationName: {},
              LatestOnly: {
                type: "boolean"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "AutoScalingConfigurationSummaryList"
            ],
            members: {
              AutoScalingConfigurationSummaryList: {
                type: "list",
                member: {
                  shape: "S1y"
                }
              },
              NextToken: {}
            }
          }
        },
        ListConnections: {
          input: {
            type: "structure",
            members: {
              ConnectionName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "ConnectionSummaryList"
            ],
            members: {
              ConnectionSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ConnectionName: {},
                    ConnectionArn: {},
                    ProviderType: {},
                    Status: {},
                    CreatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListOperations: {
          input: {
            type: "structure",
            required: [
              "ServiceArn"
            ],
            members: {
              ServiceArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              OperationSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Id: {},
                    Type: {},
                    Status: {},
                    TargetArn: {},
                    StartedAt: {
                      type: "timestamp"
                    },
                    EndedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListServices: {
          input: {
            type: "structure",
            members: {
              NextToken: {},
              MaxResults: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "ServiceSummaryList"
            ],
            members: {
              ServiceSummaryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ServiceName: {},
                    ServiceId: {},
                    ServiceArn: {},
                    ServiceUrl: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    },
                    Status: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "Sh"
              }
            }
          }
        },
        PauseService: {
          input: {
            type: "structure",
            required: [
              "ServiceArn"
            ],
            members: {
              ServiceArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Service"
            ],
            members: {
              Service: {
                shape: "S1v"
              },
              OperationId: {}
            }
          }
        },
        ResumeService: {
          input: {
            type: "structure",
            required: [
              "ServiceArn"
            ],
            members: {
              ServiceArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "Service"
            ],
            members: {
              Service: {
                shape: "S1v"
              },
              OperationId: {}
            }
          }
        },
        StartDeployment: {
          input: {
            type: "structure",
            required: [
              "ServiceArn"
            ],
            members: {
              ServiceArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "OperationId"
            ],
            members: {
              OperationId: {}
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sh"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateService: {
          input: {
            type: "structure",
            required: [
              "ServiceArn"
            ],
            members: {
              ServiceArn: {},
              SourceConfiguration: {
                shape: "Sz"
              },
              InstanceConfiguration: {
                shape: "S1i"
              },
              AutoScalingConfigurationArn: {},
              HealthCheckConfiguration: {
                shape: "S1n"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "Service",
              "OperationId"
            ],
            members: {
              Service: {
                shape: "S1v"
              },
              OperationId: {}
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "structure",
          required: [
            "DomainName",
            "EnableWWWSubdomain",
            "Status"
          ],
          members: {
            DomainName: {},
            EnableWWWSubdomain: {
              type: "boolean"
            },
            CertificateValidationRecords: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {},
                  Type: {},
                  Value: {},
                  Status: {}
                }
              }
            },
            Status: {}
          }
        },
        Sh: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sm: {
          type: "structure",
          members: {
            AutoScalingConfigurationArn: {},
            AutoScalingConfigurationName: {},
            AutoScalingConfigurationRevision: {
              type: "integer"
            },
            Latest: {
              type: "boolean"
            },
            Status: {},
            MaxConcurrency: {
              type: "integer"
            },
            MinSize: {
              type: "integer"
            },
            MaxSize: {
              type: "integer"
            },
            CreatedAt: {
              type: "timestamp"
            },
            DeletedAt: {
              type: "timestamp"
            }
          }
        },
        Sv: {
          type: "structure",
          members: {
            ConnectionName: {},
            ConnectionArn: {},
            ProviderType: {},
            Status: {},
            CreatedAt: {
              type: "timestamp"
            }
          }
        },
        Sz: {
          type: "structure",
          members: {
            CodeRepository: {
              type: "structure",
              required: [
                "RepositoryUrl",
                "SourceCodeVersion"
              ],
              members: {
                RepositoryUrl: {},
                SourceCodeVersion: {
                  type: "structure",
                  required: [
                    "Type",
                    "Value"
                  ],
                  members: {
                    Type: {},
                    Value: {}
                  }
                },
                CodeConfiguration: {
                  type: "structure",
                  required: [
                    "ConfigurationSource"
                  ],
                  members: {
                    ConfigurationSource: {},
                    CodeConfigurationValues: {
                      type: "structure",
                      required: [
                        "Runtime"
                      ],
                      members: {
                        Runtime: {},
                        BuildCommand: {
                          type: "string",
                          sensitive: true
                        },
                        StartCommand: {
                          type: "string",
                          sensitive: true
                        },
                        Port: {},
                        RuntimeEnvironmentVariables: {
                          shape: "S19"
                        }
                      }
                    }
                  }
                }
              }
            },
            ImageRepository: {
              type: "structure",
              required: [
                "ImageIdentifier",
                "ImageRepositoryType"
              ],
              members: {
                ImageIdentifier: {},
                ImageConfiguration: {
                  type: "structure",
                  members: {
                    RuntimeEnvironmentVariables: {
                      shape: "S19"
                    },
                    StartCommand: {},
                    Port: {}
                  }
                },
                ImageRepositoryType: {}
              }
            },
            AutoDeploymentsEnabled: {
              type: "boolean"
            },
            AuthenticationConfiguration: {
              type: "structure",
              members: {
                ConnectionArn: {},
                AccessRoleArn: {}
              }
            }
          }
        },
        S19: {
          type: "map",
          key: {
            type: "string",
            sensitive: true
          },
          value: {
            type: "string",
            sensitive: true
          }
        },
        S1i: {
          type: "structure",
          members: {
            Cpu: {},
            Memory: {},
            InstanceRoleArn: {}
          }
        },
        S1l: {
          type: "structure",
          required: [
            "KmsKey"
          ],
          members: {
            KmsKey: {}
          }
        },
        S1n: {
          type: "structure",
          members: {
            Protocol: {},
            Path: {},
            Interval: {
              type: "integer"
            },
            Timeout: {
              type: "integer"
            },
            HealthyThreshold: {
              type: "integer"
            },
            UnhealthyThreshold: {
              type: "integer"
            }
          }
        },
        S1v: {
          type: "structure",
          required: [
            "ServiceName",
            "ServiceId",
            "ServiceArn",
            "ServiceUrl",
            "CreatedAt",
            "UpdatedAt",
            "Status",
            "SourceConfiguration",
            "InstanceConfiguration",
            "AutoScalingConfigurationSummary"
          ],
          members: {
            ServiceName: {},
            ServiceId: {},
            ServiceArn: {},
            ServiceUrl: {},
            CreatedAt: {
              type: "timestamp"
            },
            UpdatedAt: {
              type: "timestamp"
            },
            DeletedAt: {
              type: "timestamp"
            },
            Status: {},
            SourceConfiguration: {
              shape: "Sz"
            },
            InstanceConfiguration: {
              shape: "S1i"
            },
            EncryptionConfiguration: {
              shape: "S1l"
            },
            HealthCheckConfiguration: {
              shape: "S1n"
            },
            AutoScalingConfigurationSummary: {
              shape: "S1y"
            }
          }
        },
        S1y: {
          type: "structure",
          members: {
            AutoScalingConfigurationArn: {},
            AutoScalingConfigurationName: {},
            AutoScalingConfigurationRevision: {
              type: "integer"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/apprunner-2020-05-15.paginators.json
var require_apprunner_2020_05_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/apprunner-2020-05-15.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeCustomDomains: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAutoScalingConfigurations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListConnections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListOperations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListServices: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/apprunner.js
var require_apprunner = __commonJS({
  "node_modules/aws-sdk/clients/apprunner.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["apprunner"] = {};
    AWS3.AppRunner = Service.defineService("apprunner", ["2020-05-15"]);
    Object.defineProperty(apiLoader.services["apprunner"], "2020-05-15", {
      get: function get() {
        var model = require_apprunner_2020_05_15_min();
        model.paginators = require_apprunner_2020_05_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.AppRunner;
  }
});

// node_modules/aws-sdk/apis/proton-2020-07-20.min.json
var require_proton_2020_07_20_min = __commonJS({
  "node_modules/aws-sdk/apis/proton-2020-07-20.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-07-20",
        endpointPrefix: "proton",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "AWS Proton",
        serviceId: "Proton",
        signatureVersion: "v4",
        signingName: "proton",
        targetPrefix: "AwsProton20200720",
        uid: "proton-2020-07-20"
      },
      operations: {
        AcceptEnvironmentAccountConnection: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentAccountConnection"
            ],
            members: {
              environmentAccountConnection: {
                shape: "S4"
              }
            }
          },
          idempotent: true
        },
        CancelEnvironmentDeployment: {
          input: {
            type: "structure",
            required: [
              "environmentName"
            ],
            members: {
              environmentName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environment"
            ],
            members: {
              environment: {
                shape: "Sd"
              }
            }
          }
        },
        CancelServiceInstanceDeployment: {
          input: {
            type: "structure",
            required: [
              "serviceInstanceName",
              "serviceName"
            ],
            members: {
              serviceInstanceName: {},
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceInstance"
            ],
            members: {
              serviceInstance: {
                shape: "Sn"
              }
            }
          }
        },
        CancelServicePipelineDeployment: {
          input: {
            type: "structure",
            required: [
              "serviceName"
            ],
            members: {
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "pipeline"
            ],
            members: {
              pipeline: {
                shape: "Sr"
              }
            }
          }
        },
        CreateEnvironment: {
          input: {
            type: "structure",
            required: [
              "name",
              "spec",
              "templateMajorVersion",
              "templateName"
            ],
            members: {
              description: {
                shape: "Sh"
              },
              environmentAccountConnectionId: {},
              name: {},
              protonServiceRoleArn: {},
              spec: {
                shape: "Sj"
              },
              tags: {
                shape: "St"
              },
              templateMajorVersion: {},
              templateMinorVersion: {},
              templateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environment"
            ],
            members: {
              environment: {
                shape: "Sd"
              }
            }
          },
          idempotent: true
        },
        CreateEnvironmentAccountConnection: {
          input: {
            type: "structure",
            required: [
              "environmentName",
              "managementAccountId",
              "roleArn"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              environmentName: {},
              managementAccountId: {},
              roleArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentAccountConnection"
            ],
            members: {
              environmentAccountConnection: {
                shape: "S4"
              }
            }
          },
          idempotent: true
        },
        CreateEnvironmentTemplate: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              description: {
                shape: "Sh"
              },
              displayName: {
                shape: "S12"
              },
              encryptionKey: {},
              name: {},
              provisioning: {},
              tags: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentTemplate"
            ],
            members: {
              environmentTemplate: {
                shape: "S14"
              }
            }
          },
          idempotent: true
        },
        CreateEnvironmentTemplateVersion: {
          input: {
            type: "structure",
            required: [
              "source",
              "templateName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {
                shape: "Sh"
              },
              majorVersion: {},
              source: {
                shape: "S18"
              },
              tags: {
                shape: "St"
              },
              templateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentTemplateVersion"
            ],
            members: {
              environmentTemplateVersion: {
                shape: "S1d"
              }
            }
          },
          idempotent: true
        },
        CreateService: {
          input: {
            type: "structure",
            required: [
              "name",
              "spec",
              "templateMajorVersion",
              "templateName"
            ],
            members: {
              branchName: {},
              description: {
                shape: "Sh"
              },
              name: {},
              repositoryConnectionArn: {},
              repositoryId: {},
              spec: {
                shape: "Sj"
              },
              tags: {
                shape: "St"
              },
              templateMajorVersion: {},
              templateMinorVersion: {},
              templateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "service"
            ],
            members: {
              service: {
                shape: "S1l"
              }
            }
          },
          idempotent: true
        },
        CreateServiceTemplate: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              description: {
                shape: "Sh"
              },
              displayName: {
                shape: "S12"
              },
              encryptionKey: {},
              name: {},
              pipelineProvisioning: {},
              tags: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceTemplate"
            ],
            members: {
              serviceTemplate: {
                shape: "S1q"
              }
            }
          },
          idempotent: true
        },
        CreateServiceTemplateVersion: {
          input: {
            type: "structure",
            required: [
              "compatibleEnvironmentTemplates",
              "source",
              "templateName"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              compatibleEnvironmentTemplates: {
                shape: "S1t"
              },
              description: {
                shape: "Sh"
              },
              majorVersion: {},
              source: {
                shape: "S18"
              },
              tags: {
                shape: "St"
              },
              templateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceTemplateVersion"
            ],
            members: {
              serviceTemplateVersion: {
                shape: "S1w"
              }
            }
          },
          idempotent: true
        },
        DeleteEnvironment: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              environment: {
                shape: "Sd"
              }
            }
          },
          idempotent: true
        },
        DeleteEnvironmentAccountConnection: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            members: {
              environmentAccountConnection: {
                shape: "S4"
              }
            }
          },
          idempotent: true
        },
        DeleteEnvironmentTemplate: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              environmentTemplate: {
                shape: "S14"
              }
            }
          },
          idempotent: true
        },
        DeleteEnvironmentTemplateVersion: {
          input: {
            type: "structure",
            required: [
              "majorVersion",
              "minorVersion",
              "templateName"
            ],
            members: {
              majorVersion: {},
              minorVersion: {},
              templateName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              environmentTemplateVersion: {
                shape: "S1d"
              }
            }
          },
          idempotent: true
        },
        DeleteService: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              service: {
                shape: "S1l"
              }
            }
          },
          idempotent: true
        },
        DeleteServiceTemplate: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              serviceTemplate: {
                shape: "S1q"
              }
            }
          },
          idempotent: true
        },
        DeleteServiceTemplateVersion: {
          input: {
            type: "structure",
            required: [
              "majorVersion",
              "minorVersion",
              "templateName"
            ],
            members: {
              majorVersion: {},
              minorVersion: {},
              templateName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              serviceTemplateVersion: {
                shape: "S1w"
              }
            }
          },
          idempotent: true
        },
        GetAccountSettings: {
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              accountSettings: {
                shape: "S2g"
              }
            }
          }
        },
        GetEnvironment: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environment"
            ],
            members: {
              environment: {
                shape: "Sd"
              }
            }
          }
        },
        GetEnvironmentAccountConnection: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentAccountConnection"
            ],
            members: {
              environmentAccountConnection: {
                shape: "S4"
              }
            }
          }
        },
        GetEnvironmentTemplate: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentTemplate"
            ],
            members: {
              environmentTemplate: {
                shape: "S14"
              }
            }
          }
        },
        GetEnvironmentTemplateVersion: {
          input: {
            type: "structure",
            required: [
              "majorVersion",
              "minorVersion",
              "templateName"
            ],
            members: {
              majorVersion: {},
              minorVersion: {},
              templateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentTemplateVersion"
            ],
            members: {
              environmentTemplateVersion: {
                shape: "S1d"
              }
            }
          }
        },
        GetService: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              service: {
                shape: "S1l"
              }
            }
          }
        },
        GetServiceInstance: {
          input: {
            type: "structure",
            required: [
              "name",
              "serviceName"
            ],
            members: {
              name: {},
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceInstance"
            ],
            members: {
              serviceInstance: {
                shape: "Sn"
              }
            }
          }
        },
        GetServiceTemplate: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceTemplate"
            ],
            members: {
              serviceTemplate: {
                shape: "S1q"
              }
            }
          }
        },
        GetServiceTemplateVersion: {
          input: {
            type: "structure",
            required: [
              "majorVersion",
              "minorVersion",
              "templateName"
            ],
            members: {
              majorVersion: {},
              minorVersion: {},
              templateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceTemplateVersion"
            ],
            members: {
              serviceTemplateVersion: {
                shape: "S1w"
              }
            }
          }
        },
        ListEnvironmentAccountConnections: {
          input: {
            type: "structure",
            required: [
              "requestedBy"
            ],
            members: {
              environmentName: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              requestedBy: {},
              statuses: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentAccountConnections"
            ],
            members: {
              environmentAccountConnections: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "environmentAccountId",
                    "environmentName",
                    "id",
                    "lastModifiedAt",
                    "managementAccountId",
                    "requestedAt",
                    "roleArn",
                    "status"
                  ],
                  members: {
                    arn: {},
                    environmentAccountId: {},
                    environmentName: {},
                    id: {},
                    lastModifiedAt: {
                      type: "timestamp"
                    },
                    managementAccountId: {},
                    requestedAt: {
                      type: "timestamp"
                    },
                    roleArn: {},
                    status: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListEnvironmentTemplateVersions: {
          input: {
            type: "structure",
            required: [
              "templateName"
            ],
            members: {
              majorVersion: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              templateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "templateVersions"
            ],
            members: {
              nextToken: {},
              templateVersions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastModifiedAt",
                    "majorVersion",
                    "minorVersion",
                    "status",
                    "templateName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    description: {
                      shape: "Sh"
                    },
                    lastModifiedAt: {
                      type: "timestamp"
                    },
                    majorVersion: {},
                    minorVersion: {},
                    recommendedMinorVersion: {},
                    status: {},
                    statusMessage: {
                      shape: "Sg"
                    },
                    templateName: {}
                  }
                }
              }
            }
          }
        },
        ListEnvironmentTemplates: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "templates"
            ],
            members: {
              nextToken: {},
              templates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastModifiedAt",
                    "name"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    description: {
                      shape: "Sh"
                    },
                    displayName: {
                      shape: "S12"
                    },
                    lastModifiedAt: {
                      type: "timestamp"
                    },
                    name: {},
                    provisioning: {},
                    recommendedVersion: {}
                  }
                }
              }
            }
          }
        },
        ListEnvironments: {
          input: {
            type: "structure",
            members: {
              environmentTemplates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "majorVersion",
                    "templateName"
                  ],
                  members: {
                    majorVersion: {},
                    templateName: {}
                  }
                }
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environments"
            ],
            members: {
              environments: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "deploymentStatus",
                    "lastDeploymentAttemptedAt",
                    "lastDeploymentSucceededAt",
                    "name",
                    "templateMajorVersion",
                    "templateMinorVersion",
                    "templateName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    deploymentStatus: {},
                    deploymentStatusMessage: {
                      shape: "Sg"
                    },
                    description: {
                      shape: "Sh"
                    },
                    environmentAccountConnectionId: {},
                    environmentAccountId: {},
                    lastDeploymentAttemptedAt: {
                      type: "timestamp"
                    },
                    lastDeploymentSucceededAt: {
                      type: "timestamp"
                    },
                    name: {},
                    protonServiceRoleArn: {},
                    provisioning: {},
                    templateMajorVersion: {},
                    templateMinorVersion: {},
                    templateName: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListServiceInstances: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              serviceName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceInstances"
            ],
            members: {
              nextToken: {},
              serviceInstances: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "deploymentStatus",
                    "environmentName",
                    "lastDeploymentAttemptedAt",
                    "lastDeploymentSucceededAt",
                    "name",
                    "serviceName",
                    "templateMajorVersion",
                    "templateMinorVersion",
                    "templateName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    deploymentStatus: {},
                    deploymentStatusMessage: {
                      shape: "Sg"
                    },
                    environmentName: {},
                    lastDeploymentAttemptedAt: {
                      type: "timestamp"
                    },
                    lastDeploymentSucceededAt: {
                      type: "timestamp"
                    },
                    name: {},
                    serviceName: {},
                    templateMajorVersion: {},
                    templateMinorVersion: {},
                    templateName: {}
                  }
                }
              }
            }
          }
        },
        ListServiceTemplateVersions: {
          input: {
            type: "structure",
            required: [
              "templateName"
            ],
            members: {
              majorVersion: {},
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              templateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "templateVersions"
            ],
            members: {
              nextToken: {},
              templateVersions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastModifiedAt",
                    "majorVersion",
                    "minorVersion",
                    "status",
                    "templateName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    description: {
                      shape: "Sh"
                    },
                    lastModifiedAt: {
                      type: "timestamp"
                    },
                    majorVersion: {},
                    minorVersion: {},
                    recommendedMinorVersion: {},
                    status: {},
                    statusMessage: {
                      shape: "Sg"
                    },
                    templateName: {}
                  }
                }
              }
            }
          }
        },
        ListServiceTemplates: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "templates"
            ],
            members: {
              nextToken: {},
              templates: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastModifiedAt",
                    "name"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    description: {
                      shape: "Sh"
                    },
                    displayName: {
                      shape: "S12"
                    },
                    lastModifiedAt: {
                      type: "timestamp"
                    },
                    name: {},
                    pipelineProvisioning: {},
                    recommendedVersion: {}
                  }
                }
              }
            }
          }
        },
        ListServices: {
          input: {
            type: "structure",
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "services"
            ],
            members: {
              nextToken: {},
              services: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "arn",
                    "createdAt",
                    "lastModifiedAt",
                    "name",
                    "status",
                    "templateName"
                  ],
                  members: {
                    arn: {},
                    createdAt: {
                      type: "timestamp"
                    },
                    description: {
                      shape: "Sh"
                    },
                    lastModifiedAt: {
                      type: "timestamp"
                    },
                    name: {},
                    status: {},
                    statusMessage: {
                      shape: "Sg"
                    },
                    templateName: {}
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              resourceArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "tags"
            ],
            members: {
              nextToken: {},
              tags: {
                shape: "St"
              }
            }
          }
        },
        RejectEnvironmentAccountConnection: {
          input: {
            type: "structure",
            required: [
              "id"
            ],
            members: {
              id: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentAccountConnection"
            ],
            members: {
              environmentAccountConnection: {
                shape: "S4"
              }
            }
          },
          idempotent: true
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {},
              tags: {
                shape: "St"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {},
              tagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateAccountSettings: {
          input: {
            type: "structure",
            members: {
              pipelineServiceRoleArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "accountSettings"
            ],
            members: {
              accountSettings: {
                shape: "S2g"
              }
            }
          }
        },
        UpdateEnvironment: {
          input: {
            type: "structure",
            required: [
              "deploymentType",
              "name"
            ],
            members: {
              deploymentType: {},
              description: {
                shape: "Sh"
              },
              environmentAccountConnectionId: {},
              name: {},
              protonServiceRoleArn: {},
              spec: {
                shape: "Sj"
              },
              templateMajorVersion: {},
              templateMinorVersion: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environment"
            ],
            members: {
              environment: {
                shape: "Sd"
              }
            }
          }
        },
        UpdateEnvironmentAccountConnection: {
          input: {
            type: "structure",
            required: [
              "id",
              "roleArn"
            ],
            members: {
              id: {},
              roleArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentAccountConnection"
            ],
            members: {
              environmentAccountConnection: {
                shape: "S4"
              }
            }
          },
          idempotent: true
        },
        UpdateEnvironmentTemplate: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              description: {
                shape: "Sh"
              },
              displayName: {
                shape: "S12"
              },
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentTemplate"
            ],
            members: {
              environmentTemplate: {
                shape: "S14"
              }
            }
          }
        },
        UpdateEnvironmentTemplateVersion: {
          input: {
            type: "structure",
            required: [
              "majorVersion",
              "minorVersion",
              "templateName"
            ],
            members: {
              description: {
                shape: "Sh"
              },
              majorVersion: {},
              minorVersion: {},
              status: {},
              templateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "environmentTemplateVersion"
            ],
            members: {
              environmentTemplateVersion: {
                shape: "S1d"
              }
            }
          }
        },
        UpdateService: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              description: {
                shape: "Sh"
              },
              name: {},
              spec: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "service"
            ],
            members: {
              service: {
                shape: "S1l"
              }
            }
          }
        },
        UpdateServiceInstance: {
          input: {
            type: "structure",
            required: [
              "deploymentType",
              "name",
              "serviceName"
            ],
            members: {
              deploymentType: {},
              name: {},
              serviceName: {},
              spec: {
                shape: "Sj"
              },
              templateMajorVersion: {},
              templateMinorVersion: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceInstance"
            ],
            members: {
              serviceInstance: {
                shape: "Sn"
              }
            }
          }
        },
        UpdateServicePipeline: {
          input: {
            type: "structure",
            required: [
              "deploymentType",
              "serviceName",
              "spec"
            ],
            members: {
              deploymentType: {},
              serviceName: {},
              spec: {
                shape: "Sj"
              },
              templateMajorVersion: {},
              templateMinorVersion: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "pipeline"
            ],
            members: {
              pipeline: {
                shape: "Sr"
              }
            }
          }
        },
        UpdateServiceTemplate: {
          input: {
            type: "structure",
            required: [
              "name"
            ],
            members: {
              description: {
                shape: "Sh"
              },
              displayName: {
                shape: "S12"
              },
              name: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceTemplate"
            ],
            members: {
              serviceTemplate: {
                shape: "S1q"
              }
            }
          }
        },
        UpdateServiceTemplateVersion: {
          input: {
            type: "structure",
            required: [
              "majorVersion",
              "minorVersion",
              "templateName"
            ],
            members: {
              compatibleEnvironmentTemplates: {
                shape: "S1t"
              },
              description: {
                shape: "Sh"
              },
              majorVersion: {},
              minorVersion: {},
              status: {},
              templateName: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "serviceTemplateVersion"
            ],
            members: {
              serviceTemplateVersion: {
                shape: "S1w"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          required: [
            "arn",
            "environmentAccountId",
            "environmentName",
            "id",
            "lastModifiedAt",
            "managementAccountId",
            "requestedAt",
            "roleArn",
            "status"
          ],
          members: {
            arn: {},
            environmentAccountId: {},
            environmentName: {},
            id: {},
            lastModifiedAt: {
              type: "timestamp"
            },
            managementAccountId: {},
            requestedAt: {
              type: "timestamp"
            },
            roleArn: {},
            status: {}
          }
        },
        Sd: {
          type: "structure",
          required: [
            "arn",
            "createdAt",
            "deploymentStatus",
            "lastDeploymentAttemptedAt",
            "lastDeploymentSucceededAt",
            "name",
            "templateMajorVersion",
            "templateMinorVersion",
            "templateName"
          ],
          members: {
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            deploymentStatus: {},
            deploymentStatusMessage: {
              shape: "Sg"
            },
            description: {
              shape: "Sh"
            },
            environmentAccountConnectionId: {},
            environmentAccountId: {},
            lastDeploymentAttemptedAt: {
              type: "timestamp"
            },
            lastDeploymentSucceededAt: {
              type: "timestamp"
            },
            name: {},
            protonServiceRoleArn: {},
            provisioning: {},
            spec: {
              shape: "Sj"
            },
            templateMajorVersion: {},
            templateMinorVersion: {},
            templateName: {}
          }
        },
        Sg: {
          type: "string",
          sensitive: true
        },
        Sh: {
          type: "string",
          sensitive: true
        },
        Sj: {
          type: "string",
          sensitive: true
        },
        Sn: {
          type: "structure",
          required: [
            "arn",
            "createdAt",
            "deploymentStatus",
            "environmentName",
            "lastDeploymentAttemptedAt",
            "lastDeploymentSucceededAt",
            "name",
            "serviceName",
            "templateMajorVersion",
            "templateMinorVersion",
            "templateName"
          ],
          members: {
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            deploymentStatus: {},
            deploymentStatusMessage: {
              shape: "Sg"
            },
            environmentName: {},
            lastDeploymentAttemptedAt: {
              type: "timestamp"
            },
            lastDeploymentSucceededAt: {
              type: "timestamp"
            },
            name: {},
            serviceName: {},
            spec: {
              shape: "Sj"
            },
            templateMajorVersion: {},
            templateMinorVersion: {},
            templateName: {}
          }
        },
        Sr: {
          type: "structure",
          required: [
            "arn",
            "createdAt",
            "deploymentStatus",
            "lastDeploymentAttemptedAt",
            "lastDeploymentSucceededAt",
            "templateMajorVersion",
            "templateMinorVersion",
            "templateName"
          ],
          members: {
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            deploymentStatus: {},
            deploymentStatusMessage: {
              shape: "Sg"
            },
            lastDeploymentAttemptedAt: {
              type: "timestamp"
            },
            lastDeploymentSucceededAt: {
              type: "timestamp"
            },
            spec: {
              shape: "Sj"
            },
            templateMajorVersion: {},
            templateMinorVersion: {},
            templateName: {}
          }
        },
        St: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "key",
              "value"
            ],
            members: {
              key: {},
              value: {}
            }
          }
        },
        S12: {
          type: "string",
          sensitive: true
        },
        S14: {
          type: "structure",
          required: [
            "arn",
            "createdAt",
            "lastModifiedAt",
            "name"
          ],
          members: {
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            description: {
              shape: "Sh"
            },
            displayName: {
              shape: "S12"
            },
            encryptionKey: {},
            lastModifiedAt: {
              type: "timestamp"
            },
            name: {},
            provisioning: {},
            recommendedVersion: {}
          }
        },
        S18: {
          type: "structure",
          members: {
            s3: {
              type: "structure",
              required: [
                "bucket",
                "key"
              ],
              members: {
                bucket: {},
                key: {}
              }
            }
          },
          union: true
        },
        S1d: {
          type: "structure",
          required: [
            "arn",
            "createdAt",
            "lastModifiedAt",
            "majorVersion",
            "minorVersion",
            "status",
            "templateName"
          ],
          members: {
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            description: {
              shape: "Sh"
            },
            lastModifiedAt: {
              type: "timestamp"
            },
            majorVersion: {},
            minorVersion: {},
            recommendedMinorVersion: {},
            schema: {
              shape: "S1f"
            },
            status: {},
            statusMessage: {
              shape: "Sg"
            },
            templateName: {}
          }
        },
        S1f: {
          type: "string",
          sensitive: true
        },
        S1l: {
          type: "structure",
          required: [
            "arn",
            "createdAt",
            "lastModifiedAt",
            "name",
            "spec",
            "status",
            "templateName"
          ],
          members: {
            arn: {},
            branchName: {},
            createdAt: {
              type: "timestamp"
            },
            description: {
              shape: "Sh"
            },
            lastModifiedAt: {
              type: "timestamp"
            },
            name: {},
            pipeline: {
              shape: "Sr"
            },
            repositoryConnectionArn: {},
            repositoryId: {},
            spec: {
              shape: "Sj"
            },
            status: {},
            statusMessage: {
              shape: "Sg"
            },
            templateName: {}
          }
        },
        S1q: {
          type: "structure",
          required: [
            "arn",
            "createdAt",
            "lastModifiedAt",
            "name"
          ],
          members: {
            arn: {},
            createdAt: {
              type: "timestamp"
            },
            description: {
              shape: "Sh"
            },
            displayName: {
              shape: "S12"
            },
            encryptionKey: {},
            lastModifiedAt: {
              type: "timestamp"
            },
            name: {},
            pipelineProvisioning: {},
            recommendedVersion: {}
          }
        },
        S1t: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "majorVersion",
              "templateName"
            ],
            members: {
              majorVersion: {},
              templateName: {}
            }
          }
        },
        S1w: {
          type: "structure",
          required: [
            "arn",
            "compatibleEnvironmentTemplates",
            "createdAt",
            "lastModifiedAt",
            "majorVersion",
            "minorVersion",
            "status",
            "templateName"
          ],
          members: {
            arn: {},
            compatibleEnvironmentTemplates: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "majorVersion",
                  "templateName"
                ],
                members: {
                  majorVersion: {},
                  templateName: {}
                }
              }
            },
            createdAt: {
              type: "timestamp"
            },
            description: {
              shape: "Sh"
            },
            lastModifiedAt: {
              type: "timestamp"
            },
            majorVersion: {},
            minorVersion: {},
            recommendedMinorVersion: {},
            schema: {
              shape: "S1f"
            },
            status: {},
            statusMessage: {
              shape: "Sg"
            },
            templateName: {}
          }
        },
        S2g: {
          type: "structure",
          members: {
            pipelineServiceRoleArn: {}
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/proton-2020-07-20.paginators.json
var require_proton_2020_07_20_paginators = __commonJS({
  "node_modules/aws-sdk/apis/proton-2020-07-20.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListEnvironmentAccountConnections: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "environmentAccountConnections"
        },
        ListEnvironmentTemplateVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "templateVersions"
        },
        ListEnvironmentTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "templates"
        },
        ListEnvironments: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "environments"
        },
        ListServiceInstances: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "serviceInstances"
        },
        ListServiceTemplateVersions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "templateVersions"
        },
        ListServiceTemplates: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "templates"
        },
        ListServices: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "services"
        },
        ListTagsForResource: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "tags"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/proton-2020-07-20.waiters2.json
var require_proton_2020_07_20_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/proton-2020-07-20.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        EnvironmentDeployed: {
          description: "Wait until an Environment is deployed. Use this after invoking CreateEnvironment or UpdateEnvironment",
          delay: 5,
          maxAttempts: 999,
          operation: "GetEnvironment",
          acceptors: [{
            matcher: "path",
            argument: "environment.deploymentStatus",
            state: "success",
            expected: "SUCCEEDED"
          }, {
            matcher: "path",
            argument: "environment.deploymentStatus",
            state: "failure",
            expected: "FAILED"
          }]
        },
        EnvironmentTemplateVersionRegistered: {
          description: "Wait until an EnvironmentTemplateVersion is registered. Use this after invoking CreateEnvironmentTemplateVersion",
          delay: 2,
          maxAttempts: 150,
          operation: "GetEnvironmentTemplateVersion",
          acceptors: [{
            matcher: "path",
            argument: "environmentTemplateVersion.status",
            state: "success",
            expected: "DRAFT"
          }, {
            matcher: "path",
            argument: "environmentTemplateVersion.status",
            state: "success",
            expected: "PUBLISHED"
          }, {
            matcher: "path",
            argument: "environmentTemplateVersion.status",
            state: "failure",
            expected: "REGISTRATION_FAILED"
          }]
        },
        ServiceCreated: {
          description: "Wait until an Service has deployed its instances and possibly pipeline. Use this after invoking CreateService",
          delay: 5,
          maxAttempts: 999,
          operation: "GetService",
          acceptors: [{
            matcher: "path",
            argument: "service.status",
            state: "success",
            expected: "ACTIVE"
          }, {
            matcher: "path",
            argument: "service.status",
            state: "failure",
            expected: "CREATE_FAILED_CLEANUP_COMPLETE"
          }, {
            matcher: "path",
            argument: "service.status",
            state: "failure",
            expected: "CREATE_FAILED_CLEANUP_FAILED"
          }, {
            matcher: "path",
            argument: "service.status",
            state: "failure",
            expected: "CREATE_FAILED"
          }]
        },
        ServiceDeleted: {
          description: "Wait until a Service, its instances, and possibly pipeline have been deleted after DeleteService is invoked",
          delay: 5,
          maxAttempts: 999,
          operation: "GetService",
          acceptors: [{
            matcher: "error",
            state: "success",
            expected: "ResourceNotFoundException"
          }, {
            matcher: "path",
            argument: "service.status",
            state: "failure",
            expected: "DELETE_FAILED"
          }]
        },
        ServiceInstanceDeployed: {
          description: "Wait until a ServiceInstance is deployed. Use this after invoking CreateService or UpdateServiceInstance",
          delay: 5,
          maxAttempts: 999,
          operation: "GetServiceInstance",
          acceptors: [{
            matcher: "path",
            argument: "serviceInstance.deploymentStatus",
            state: "success",
            expected: "SUCCEEDED"
          }, {
            matcher: "path",
            argument: "serviceInstance.deploymentStatus",
            state: "failure",
            expected: "FAILED"
          }]
        },
        ServicePipelineDeployed: {
          description: "Wait until an ServicePipeline is deployed. Use this after invoking CreateService or UpdateServicePipeline",
          delay: 10,
          maxAttempts: 360,
          operation: "GetService",
          acceptors: [{
            matcher: "path",
            argument: "service.pipeline.deploymentStatus",
            state: "success",
            expected: "SUCCEEDED"
          }, {
            matcher: "path",
            argument: "service.pipeline.deploymentStatus",
            state: "failure",
            expected: "FAILED"
          }]
        },
        ServiceTemplateVersionRegistered: {
          description: "Wait until a ServiceTemplateVersion is registered. Use this after invoking CreateServiceTemplateVersion",
          delay: 2,
          maxAttempts: 150,
          operation: "GetServiceTemplateVersion",
          acceptors: [{
            matcher: "path",
            argument: "serviceTemplateVersion.status",
            state: "success",
            expected: "DRAFT"
          }, {
            matcher: "path",
            argument: "serviceTemplateVersion.status",
            state: "success",
            expected: "PUBLISHED"
          }, {
            matcher: "path",
            argument: "serviceTemplateVersion.status",
            state: "failure",
            expected: "REGISTRATION_FAILED"
          }]
        },
        ServiceUpdated: {
          description: "Wait until a Service, its instances, and possibly pipeline have been deployed after UpdateService is invoked",
          delay: 5,
          maxAttempts: 999,
          operation: "GetService",
          acceptors: [{
            matcher: "path",
            argument: "service.status",
            state: "success",
            expected: "ACTIVE"
          }, {
            matcher: "path",
            argument: "service.status",
            state: "failure",
            expected: "UPDATE_FAILED_CLEANUP_COMPLETE"
          }, {
            matcher: "path",
            argument: "service.status",
            state: "failure",
            expected: "UPDATE_FAILED_CLEANUP_FAILED"
          }, {
            matcher: "path",
            argument: "service.status",
            state: "failure",
            expected: "UPDATE_FAILED"
          }, {
            matcher: "path",
            argument: "service.status",
            state: "failure",
            expected: "UPDATE_COMPLETE_CLEANUP_FAILED"
          }]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/proton.js
var require_proton = __commonJS({
  "node_modules/aws-sdk/clients/proton.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["proton"] = {};
    AWS3.Proton = Service.defineService("proton", ["2020-07-20"]);
    Object.defineProperty(apiLoader.services["proton"], "2020-07-20", {
      get: function get() {
        var model = require_proton_2020_07_20_min();
        model.paginators = require_proton_2020_07_20_paginators().pagination;
        model.waiters = require_proton_2020_07_20_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Proton;
  }
});

// node_modules/aws-sdk/apis/route53-recovery-cluster-2019-12-02.min.json
var require_route53_recovery_cluster_2019_12_02_min = __commonJS({
  "node_modules/aws-sdk/apis/route53-recovery-cluster-2019-12-02.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2019-12-02",
        endpointPrefix: "route53-recovery-cluster",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "Route53 Recovery Cluster",
        serviceId: "Route53 Recovery Cluster",
        signatureVersion: "v4",
        signingName: "route53-recovery-cluster",
        targetPrefix: "ToggleCustomerAPI",
        uid: "route53-recovery-cluster-2019-12-02"
      },
      operations: {
        GetRoutingControlState: {
          input: {
            type: "structure",
            required: [
              "RoutingControlArn"
            ],
            members: {
              RoutingControlArn: {}
            }
          },
          output: {
            type: "structure",
            required: [
              "RoutingControlArn",
              "RoutingControlState"
            ],
            members: {
              RoutingControlArn: {},
              RoutingControlState: {}
            }
          }
        },
        UpdateRoutingControlState: {
          input: {
            type: "structure",
            required: [
              "RoutingControlArn",
              "RoutingControlState"
            ],
            members: {
              RoutingControlArn: {},
              RoutingControlState: {}
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateRoutingControlStates: {
          input: {
            type: "structure",
            required: [
              "UpdateRoutingControlStateEntries"
            ],
            members: {
              UpdateRoutingControlStateEntries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "RoutingControlArn",
                    "RoutingControlState"
                  ],
                  members: {
                    RoutingControlArn: {},
                    RoutingControlState: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        }
      },
      shapes: {}
    };
  }
});

// node_modules/aws-sdk/apis/route53-recovery-cluster-2019-12-02.paginators.json
var require_route53_recovery_cluster_2019_12_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/route53-recovery-cluster-2019-12-02.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/route53recoverycluster.js
var require_route53recoverycluster = __commonJS({
  "node_modules/aws-sdk/clients/route53recoverycluster.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["route53recoverycluster"] = {};
    AWS3.Route53RecoveryCluster = Service.defineService("route53recoverycluster", ["2019-12-02"]);
    Object.defineProperty(apiLoader.services["route53recoverycluster"], "2019-12-02", {
      get: function get() {
        var model = require_route53_recovery_cluster_2019_12_02_min();
        model.paginators = require_route53_recovery_cluster_2019_12_02_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Route53RecoveryCluster;
  }
});

// node_modules/aws-sdk/apis/route53-recovery-control-config-2020-11-02.min.json
var require_route53_recovery_control_config_2020_11_02_min = __commonJS({
  "node_modules/aws-sdk/apis/route53-recovery-control-config-2020-11-02.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2020-11-02",
        endpointPrefix: "route53-recovery-control-config",
        signingName: "route53-recovery-control-config",
        serviceFullName: "AWS Route53 Recovery Control Config",
        serviceId: "Route53 Recovery Control Config",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "route53-recovery-control-config-2020-11-02",
        signatureVersion: "v4"
      },
      operations: {
        CreateCluster: {
          http: {
            requestUri: "/cluster",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              ClusterName: {}
            },
            required: [
              "ClusterName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "S5"
              }
            }
          }
        },
        CreateControlPanel: {
          http: {
            requestUri: "/controlpanel",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              ClusterArn: {},
              ControlPanelName: {}
            },
            required: [
              "ClusterArn",
              "ControlPanelName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ControlPanel: {
                shape: "Se"
              }
            }
          }
        },
        CreateRoutingControl: {
          http: {
            requestUri: "/routingcontrol",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              ClusterArn: {},
              ControlPanelArn: {},
              RoutingControlName: {}
            },
            required: [
              "ClusterArn",
              "RoutingControlName"
            ]
          },
          output: {
            type: "structure",
            members: {
              RoutingControl: {
                shape: "Sj"
              }
            }
          }
        },
        CreateSafetyRule: {
          http: {
            requestUri: "/safetyrule",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AssertionRule: {
                type: "structure",
                members: {
                  AssertedControls: {
                    shape: "Sm"
                  },
                  ControlPanelArn: {},
                  Name: {},
                  RuleConfig: {
                    shape: "Sn"
                  },
                  WaitPeriodMs: {
                    type: "integer"
                  }
                },
                required: [
                  "ControlPanelArn",
                  "AssertedControls",
                  "RuleConfig",
                  "WaitPeriodMs",
                  "Name"
                ]
              },
              ClientToken: {
                idempotencyToken: true
              },
              GatingRule: {
                type: "structure",
                members: {
                  ControlPanelArn: {},
                  GatingControls: {
                    shape: "Sm"
                  },
                  Name: {},
                  RuleConfig: {
                    shape: "Sn"
                  },
                  TargetControls: {
                    shape: "Sm"
                  },
                  WaitPeriodMs: {
                    type: "integer"
                  }
                },
                required: [
                  "TargetControls",
                  "ControlPanelArn",
                  "GatingControls",
                  "RuleConfig",
                  "WaitPeriodMs",
                  "Name"
                ]
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssertionRule: {
                shape: "Sr"
              },
              GatingRule: {
                shape: "Ss"
              }
            }
          }
        },
        DeleteCluster: {
          http: {
            method: "DELETE",
            requestUri: "/cluster/{ClusterArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "ClusterArn"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteControlPanel: {
          http: {
            method: "DELETE",
            requestUri: "/controlpanel/{ControlPanelArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ControlPanelArn: {
                location: "uri",
                locationName: "ControlPanelArn"
              }
            },
            required: [
              "ControlPanelArn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteRoutingControl: {
          http: {
            method: "DELETE",
            requestUri: "/routingcontrol/{RoutingControlArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RoutingControlArn: {
                location: "uri",
                locationName: "RoutingControlArn"
              }
            },
            required: [
              "RoutingControlArn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteSafetyRule: {
          http: {
            method: "DELETE",
            requestUri: "/safetyrule/{SafetyRuleArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              SafetyRuleArn: {
                location: "uri",
                locationName: "SafetyRuleArn"
              }
            },
            required: [
              "SafetyRuleArn"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DescribeCluster: {
          http: {
            method: "GET",
            requestUri: "/cluster/{ClusterArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "uri",
                locationName: "ClusterArn"
              }
            },
            required: [
              "ClusterArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "S5"
              }
            }
          }
        },
        DescribeControlPanel: {
          http: {
            method: "GET",
            requestUri: "/controlpanel/{ControlPanelArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ControlPanelArn: {
                location: "uri",
                locationName: "ControlPanelArn"
              }
            },
            required: [
              "ControlPanelArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              ControlPanel: {
                shape: "Se"
              }
            }
          }
        },
        DescribeRoutingControl: {
          http: {
            method: "GET",
            requestUri: "/routingcontrol/{RoutingControlArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RoutingControlArn: {
                location: "uri",
                locationName: "RoutingControlArn"
              }
            },
            required: [
              "RoutingControlArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              RoutingControl: {
                shape: "Sj"
              }
            }
          }
        },
        DescribeSafetyRule: {
          http: {
            method: "GET",
            requestUri: "/safetyrule/{SafetyRuleArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              SafetyRuleArn: {
                location: "uri",
                locationName: "SafetyRuleArn"
              }
            },
            required: [
              "SafetyRuleArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              AssertionRule: {
                shape: "Sr"
              },
              GatingRule: {
                shape: "Ss"
              }
            }
          }
        },
        ListAssociatedRoute53HealthChecks: {
          http: {
            method: "GET",
            requestUri: "/routingcontrol/{RoutingControlArn}/associatedRoute53HealthChecks",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              },
              RoutingControlArn: {
                location: "uri",
                locationName: "RoutingControlArn"
              }
            },
            required: [
              "RoutingControlArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              HealthCheckIds: {
                shape: "Sm"
              },
              NextToken: {}
            }
          }
        },
        ListClusters: {
          http: {
            method: "GET",
            requestUri: "/cluster",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Clusters: {
                type: "list",
                member: {
                  shape: "S5"
                }
              },
              NextToken: {}
            }
          }
        },
        ListControlPanels: {
          http: {
            method: "GET",
            requestUri: "/controlpanels",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ClusterArn: {
                location: "querystring",
                locationName: "ClusterArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ControlPanels: {
                type: "list",
                member: {
                  shape: "Se"
                }
              },
              NextToken: {}
            }
          }
        },
        ListRoutingControls: {
          http: {
            method: "GET",
            requestUri: "/controlpanel/{ControlPanelArn}/routingcontrols",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ControlPanelArn: {
                location: "uri",
                locationName: "ControlPanelArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "ControlPanelArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              RoutingControls: {
                type: "list",
                member: {
                  shape: "Sj"
                }
              }
            }
          }
        },
        ListSafetyRules: {
          http: {
            method: "GET",
            requestUri: "/controlpanel/{ControlPanelArn}/safetyrules",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ControlPanelArn: {
                location: "uri",
                locationName: "ControlPanelArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "MaxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "NextToken"
              }
            },
            required: [
              "ControlPanelArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              SafetyRules: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ASSERTION: {
                      shape: "Sr"
                    },
                    GATING: {
                      shape: "Ss"
                    }
                  }
                }
              }
            }
          }
        },
        UpdateControlPanel: {
          http: {
            method: "PUT",
            requestUri: "/controlpanel",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ControlPanelArn: {},
              ControlPanelName: {}
            },
            required: [
              "ControlPanelArn",
              "ControlPanelName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ControlPanel: {
                shape: "Se"
              }
            }
          }
        },
        UpdateRoutingControl: {
          http: {
            method: "PUT",
            requestUri: "/routingcontrol",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RoutingControlArn: {},
              RoutingControlName: {}
            },
            required: [
              "RoutingControlName",
              "RoutingControlArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              RoutingControl: {
                shape: "Sj"
              }
            }
          }
        },
        UpdateSafetyRule: {
          http: {
            method: "PUT",
            requestUri: "/safetyrule",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              AssertionRuleUpdate: {
                type: "structure",
                members: {
                  Name: {},
                  SafetyRuleArn: {},
                  WaitPeriodMs: {
                    type: "integer"
                  }
                },
                required: [
                  "SafetyRuleArn",
                  "WaitPeriodMs",
                  "Name"
                ]
              },
              GatingRuleUpdate: {
                type: "structure",
                members: {
                  Name: {},
                  SafetyRuleArn: {},
                  WaitPeriodMs: {
                    type: "integer"
                  }
                },
                required: [
                  "SafetyRuleArn",
                  "WaitPeriodMs",
                  "Name"
                ]
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AssertionRule: {
                shape: "Sr"
              },
              GatingRule: {
                shape: "Ss"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            ClusterArn: {},
            ClusterEndpoints: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Endpoint: {},
                  Region: {}
                }
              }
            },
            Name: {},
            Status: {}
          }
        },
        Se: {
          type: "structure",
          members: {
            ClusterArn: {},
            ControlPanelArn: {},
            DefaultControlPanel: {
              type: "boolean"
            },
            Name: {},
            RoutingControlCount: {
              type: "integer"
            },
            Status: {}
          }
        },
        Sj: {
          type: "structure",
          members: {
            ControlPanelArn: {},
            Name: {},
            RoutingControlArn: {},
            Status: {}
          }
        },
        Sm: {
          type: "list",
          member: {}
        },
        Sn: {
          type: "structure",
          members: {
            Inverted: {
              type: "boolean"
            },
            Threshold: {
              type: "integer"
            },
            Type: {}
          },
          required: [
            "Type",
            "Inverted",
            "Threshold"
          ]
        },
        Sr: {
          type: "structure",
          members: {
            AssertedControls: {
              shape: "Sm"
            },
            ControlPanelArn: {},
            Name: {},
            RuleConfig: {
              shape: "Sn"
            },
            SafetyRuleArn: {},
            Status: {},
            WaitPeriodMs: {
              type: "integer"
            }
          },
          required: [
            "Status",
            "ControlPanelArn",
            "SafetyRuleArn",
            "AssertedControls",
            "RuleConfig",
            "WaitPeriodMs",
            "Name"
          ]
        },
        Ss: {
          type: "structure",
          members: {
            ControlPanelArn: {},
            GatingControls: {
              shape: "Sm"
            },
            Name: {},
            RuleConfig: {
              shape: "Sn"
            },
            SafetyRuleArn: {},
            Status: {},
            TargetControls: {
              shape: "Sm"
            },
            WaitPeriodMs: {
              type: "integer"
            }
          },
          required: [
            "Status",
            "TargetControls",
            "ControlPanelArn",
            "SafetyRuleArn",
            "GatingControls",
            "RuleConfig",
            "WaitPeriodMs",
            "Name"
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/route53-recovery-control-config-2020-11-02.paginators.json
var require_route53_recovery_control_config_2020_11_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/route53-recovery-control-config-2020-11-02.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAssociatedRoute53HealthChecks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListClusters: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListControlPanels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListRoutingControls: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSafetyRules: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/route53-recovery-control-config-2020-11-02.waiters2.json
var require_route53_recovery_control_config_2020_11_02_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/route53-recovery-control-config-2020-11-02.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ClusterCreated: {
          description: "Wait until a cluster is created",
          operation: "DescribeCluster",
          delay: 5,
          maxAttempts: 26,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "Cluster.Status",
              expected: "DEPLOYED"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "Cluster.Status",
              expected: "PENDING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        ClusterDeleted: {
          description: "Wait for a cluster to be deleted",
          operation: "DescribeCluster",
          delay: 5,
          maxAttempts: 26,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 404
            },
            {
              state: "retry",
              matcher: "path",
              argument: "Cluster.Status",
              expected: "PENDING_DELETION"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        ControlPanelCreated: {
          description: "Wait until a control panel is created",
          operation: "DescribeControlPanel",
          delay: 5,
          maxAttempts: 26,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "ControlPanel.Status",
              expected: "DEPLOYED"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "ControlPanel.Status",
              expected: "PENDING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        ControlPanelDeleted: {
          description: "Wait until a control panel is deleted",
          operation: "DescribeControlPanel",
          delay: 5,
          maxAttempts: 26,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 404
            },
            {
              state: "retry",
              matcher: "path",
              argument: "ControlPanel.Status",
              expected: "PENDING_DELETION"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        RoutingControlCreated: {
          description: "Wait until a routing control is created",
          operation: "DescribeRoutingControl",
          delay: 5,
          maxAttempts: 26,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "RoutingControl.Status",
              expected: "DEPLOYED"
            },
            {
              state: "retry",
              matcher: "path",
              argument: "RoutingControl.Status",
              expected: "PENDING"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        },
        RoutingControlDeleted: {
          description: "Wait for a routing control to be deleted",
          operation: "DescribeRoutingControl",
          delay: 5,
          maxAttempts: 26,
          acceptors: [
            {
              state: "success",
              matcher: "status",
              expected: 404
            },
            {
              state: "retry",
              matcher: "path",
              argument: "RoutingControl.Status",
              expected: "PENDING_DELETION"
            },
            {
              state: "retry",
              matcher: "status",
              expected: 500
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/route53recoverycontrolconfig.js
var require_route53recoverycontrolconfig = __commonJS({
  "node_modules/aws-sdk/clients/route53recoverycontrolconfig.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["route53recoverycontrolconfig"] = {};
    AWS3.Route53RecoveryControlConfig = Service.defineService("route53recoverycontrolconfig", ["2020-11-02"]);
    Object.defineProperty(apiLoader.services["route53recoverycontrolconfig"], "2020-11-02", {
      get: function get() {
        var model = require_route53_recovery_control_config_2020_11_02_min();
        model.paginators = require_route53_recovery_control_config_2020_11_02_paginators().pagination;
        model.waiters = require_route53_recovery_control_config_2020_11_02_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Route53RecoveryControlConfig;
  }
});

// node_modules/aws-sdk/apis/route53-recovery-readiness-2019-12-02.min.json
var require_route53_recovery_readiness_2019_12_02_min = __commonJS({
  "node_modules/aws-sdk/apis/route53-recovery-readiness-2019-12-02.min.json"(exports, module2) {
    module2.exports = {
      metadata: {
        apiVersion: "2019-12-02",
        endpointPrefix: "route53-recovery-readiness",
        signingName: "route53-recovery-readiness",
        serviceFullName: "AWS Route53 Recovery Readiness",
        serviceId: "Route53 Recovery Readiness",
        protocol: "rest-json",
        jsonVersion: "1.1",
        uid: "route53-recovery-readiness-2019-12-02",
        signatureVersion: "v4"
      },
      operations: {
        CreateCell: {
          http: {
            requestUri: "/cells",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CellName: {
                locationName: "cellName"
              },
              Cells: {
                shape: "S3",
                locationName: "cells"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            },
            required: [
              "CellName"
            ]
          },
          output: {
            type: "structure",
            members: {
              CellArn: {
                locationName: "cellArn"
              },
              CellName: {
                locationName: "cellName"
              },
              Cells: {
                shape: "S3",
                locationName: "cells"
              },
              ParentReadinessScopes: {
                shape: "S3",
                locationName: "parentReadinessScopes"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        CreateCrossAccountAuthorization: {
          http: {
            requestUri: "/crossaccountauthorizations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CrossAccountAuthorization: {
                locationName: "crossAccountAuthorization"
              }
            },
            required: [
              "CrossAccountAuthorization"
            ]
          },
          output: {
            type: "structure",
            members: {
              CrossAccountAuthorization: {
                locationName: "crossAccountAuthorization"
              }
            }
          }
        },
        CreateReadinessCheck: {
          http: {
            requestUri: "/readinesschecks",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ReadinessCheckName: {
                locationName: "readinessCheckName"
              },
              ResourceSetName: {
                locationName: "resourceSetName"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            },
            required: [
              "ResourceSetName",
              "ReadinessCheckName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ReadinessCheckArn: {
                locationName: "readinessCheckArn"
              },
              ReadinessCheckName: {
                locationName: "readinessCheckName"
              },
              ResourceSet: {
                locationName: "resourceSet"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        CreateRecoveryGroup: {
          http: {
            requestUri: "/recoverygroups",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Cells: {
                shape: "S3",
                locationName: "cells"
              },
              RecoveryGroupName: {
                locationName: "recoveryGroupName"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            },
            required: [
              "RecoveryGroupName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Cells: {
                shape: "S3",
                locationName: "cells"
              },
              RecoveryGroupArn: {
                locationName: "recoveryGroupArn"
              },
              RecoveryGroupName: {
                locationName: "recoveryGroupName"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        CreateResourceSet: {
          http: {
            requestUri: "/resourcesets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceSetName: {
                locationName: "resourceSetName"
              },
              ResourceSetType: {
                locationName: "resourceSetType"
              },
              Resources: {
                shape: "Sh",
                locationName: "resources"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            },
            required: [
              "ResourceSetType",
              "ResourceSetName",
              "Resources"
            ]
          },
          output: {
            type: "structure",
            members: {
              ResourceSetArn: {
                locationName: "resourceSetArn"
              },
              ResourceSetName: {
                locationName: "resourceSetName"
              },
              ResourceSetType: {
                locationName: "resourceSetType"
              },
              Resources: {
                shape: "Sh",
                locationName: "resources"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        DeleteCell: {
          http: {
            method: "DELETE",
            requestUri: "/cells/{cellName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              CellName: {
                location: "uri",
                locationName: "cellName"
              }
            },
            required: [
              "CellName"
            ]
          }
        },
        DeleteCrossAccountAuthorization: {
          http: {
            method: "DELETE",
            requestUri: "/crossaccountauthorizations/{crossAccountAuthorization}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CrossAccountAuthorization: {
                location: "uri",
                locationName: "crossAccountAuthorization"
              }
            },
            required: [
              "CrossAccountAuthorization"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        DeleteReadinessCheck: {
          http: {
            method: "DELETE",
            requestUri: "/readinesschecks/{readinessCheckName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ReadinessCheckName: {
                location: "uri",
                locationName: "readinessCheckName"
              }
            },
            required: [
              "ReadinessCheckName"
            ]
          }
        },
        DeleteRecoveryGroup: {
          http: {
            method: "DELETE",
            requestUri: "/recoverygroups/{recoveryGroupName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              RecoveryGroupName: {
                location: "uri",
                locationName: "recoveryGroupName"
              }
            },
            required: [
              "RecoveryGroupName"
            ]
          }
        },
        DeleteResourceSet: {
          http: {
            method: "DELETE",
            requestUri: "/resourcesets/{resourceSetName}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceSetName: {
                location: "uri",
                locationName: "resourceSetName"
              }
            },
            required: [
              "ResourceSetName"
            ]
          }
        },
        GetArchitectureRecommendations: {
          http: {
            method: "GET",
            requestUri: "/recoverygroups/{recoveryGroupName}/architectureRecommendations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RecoveryGroupName: {
                location: "uri",
                locationName: "recoveryGroupName"
              }
            },
            required: [
              "RecoveryGroupName"
            ]
          },
          output: {
            type: "structure",
            members: {
              LastAuditTimestamp: {
                locationName: "lastAuditTimestamp",
                type: "timestamp",
                timestampFormat: "iso8601"
              },
              NextToken: {
                locationName: "nextToken"
              },
              Recommendations: {
                locationName: "recommendations",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    RecommendationText: {
                      locationName: "recommendationText"
                    }
                  },
                  required: [
                    "RecommendationText"
                  ]
                }
              }
            }
          }
        },
        GetCell: {
          http: {
            method: "GET",
            requestUri: "/cells/{cellName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CellName: {
                location: "uri",
                locationName: "cellName"
              }
            },
            required: [
              "CellName"
            ]
          },
          output: {
            type: "structure",
            members: {
              CellArn: {
                locationName: "cellArn"
              },
              CellName: {
                locationName: "cellName"
              },
              Cells: {
                shape: "S3",
                locationName: "cells"
              },
              ParentReadinessScopes: {
                shape: "S3",
                locationName: "parentReadinessScopes"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        GetCellReadinessSummary: {
          http: {
            method: "GET",
            requestUri: "/cellreadiness/{cellName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CellName: {
                location: "uri",
                locationName: "cellName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            },
            required: [
              "CellName"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Readiness: {
                locationName: "readiness"
              },
              ReadinessChecks: {
                shape: "S15",
                locationName: "readinessChecks"
              }
            }
          }
        },
        GetReadinessCheck: {
          http: {
            method: "GET",
            requestUri: "/readinesschecks/{readinessCheckName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ReadinessCheckName: {
                location: "uri",
                locationName: "readinessCheckName"
              }
            },
            required: [
              "ReadinessCheckName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ReadinessCheckArn: {
                locationName: "readinessCheckArn"
              },
              ReadinessCheckName: {
                locationName: "readinessCheckName"
              },
              ResourceSet: {
                locationName: "resourceSet"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        GetReadinessCheckResourceStatus: {
          http: {
            method: "GET",
            requestUri: "/readinesschecks/{readinessCheckName}/resource/{resourceIdentifier}/status",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ReadinessCheckName: {
                location: "uri",
                locationName: "readinessCheckName"
              },
              ResourceIdentifier: {
                location: "uri",
                locationName: "resourceIdentifier"
              }
            },
            required: [
              "ReadinessCheckName",
              "ResourceIdentifier"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Readiness: {
                locationName: "readiness"
              },
              Rules: {
                locationName: "rules",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    LastCheckedTimestamp: {
                      shape: "S1d",
                      locationName: "lastCheckedTimestamp"
                    },
                    Messages: {
                      shape: "S1e",
                      locationName: "messages"
                    },
                    Readiness: {
                      locationName: "readiness"
                    },
                    RuleId: {
                      locationName: "ruleId"
                    }
                  },
                  required: [
                    "Messages",
                    "Readiness",
                    "RuleId",
                    "LastCheckedTimestamp"
                  ]
                }
              }
            }
          }
        },
        GetReadinessCheckStatus: {
          http: {
            method: "GET",
            requestUri: "/readinesschecks/{readinessCheckName}/status",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ReadinessCheckName: {
                location: "uri",
                locationName: "readinessCheckName"
              }
            },
            required: [
              "ReadinessCheckName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Messages: {
                shape: "S1e",
                locationName: "messages"
              },
              NextToken: {
                locationName: "nextToken"
              },
              Readiness: {
                locationName: "readiness"
              },
              Resources: {
                locationName: "resources",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ComponentId: {
                      locationName: "componentId"
                    },
                    LastCheckedTimestamp: {
                      shape: "S1d",
                      locationName: "lastCheckedTimestamp"
                    },
                    Readiness: {
                      locationName: "readiness"
                    },
                    ResourceArn: {
                      locationName: "resourceArn"
                    }
                  },
                  required: [
                    "Readiness",
                    "LastCheckedTimestamp"
                  ]
                }
              }
            }
          }
        },
        GetRecoveryGroup: {
          http: {
            method: "GET",
            requestUri: "/recoverygroups/{recoveryGroupName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              RecoveryGroupName: {
                location: "uri",
                locationName: "recoveryGroupName"
              }
            },
            required: [
              "RecoveryGroupName"
            ]
          },
          output: {
            type: "structure",
            members: {
              Cells: {
                shape: "S3",
                locationName: "cells"
              },
              RecoveryGroupArn: {
                locationName: "recoveryGroupArn"
              },
              RecoveryGroupName: {
                locationName: "recoveryGroupName"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        GetRecoveryGroupReadinessSummary: {
          http: {
            method: "GET",
            requestUri: "/recoverygroupreadiness/{recoveryGroupName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              RecoveryGroupName: {
                location: "uri",
                locationName: "recoveryGroupName"
              }
            },
            required: [
              "RecoveryGroupName"
            ]
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Readiness: {
                locationName: "readiness"
              },
              ReadinessChecks: {
                shape: "S15",
                locationName: "readinessChecks"
              }
            }
          }
        },
        GetResourceSet: {
          http: {
            method: "GET",
            requestUri: "/resourcesets/{resourceSetName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceSetName: {
                location: "uri",
                locationName: "resourceSetName"
              }
            },
            required: [
              "ResourceSetName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ResourceSetArn: {
                locationName: "resourceSetArn"
              },
              ResourceSetName: {
                locationName: "resourceSetName"
              },
              ResourceSetType: {
                locationName: "resourceSetType"
              },
              Resources: {
                shape: "Sh",
                locationName: "resources"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        ListCells: {
          http: {
            method: "GET",
            requestUri: "/cells",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Cells: {
                locationName: "cells",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CellArn: {
                      locationName: "cellArn"
                    },
                    CellName: {
                      locationName: "cellName"
                    },
                    Cells: {
                      shape: "S3",
                      locationName: "cells"
                    },
                    ParentReadinessScopes: {
                      shape: "S3",
                      locationName: "parentReadinessScopes"
                    },
                    Tags: {
                      shape: "S4",
                      locationName: "tags"
                    }
                  },
                  required: [
                    "ParentReadinessScopes",
                    "CellArn",
                    "CellName",
                    "Cells"
                  ]
                }
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListCrossAccountAuthorizations: {
          http: {
            method: "GET",
            requestUri: "/crossaccountauthorizations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CrossAccountAuthorizations: {
                locationName: "crossAccountAuthorizations",
                type: "list",
                member: {}
              },
              NextToken: {
                locationName: "nextToken"
              }
            }
          }
        },
        ListReadinessChecks: {
          http: {
            method: "GET",
            requestUri: "/readinesschecks",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              ReadinessChecks: {
                locationName: "readinessChecks",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReadinessCheckArn: {
                      locationName: "readinessCheckArn"
                    },
                    ReadinessCheckName: {
                      locationName: "readinessCheckName"
                    },
                    ResourceSet: {
                      locationName: "resourceSet"
                    },
                    Tags: {
                      shape: "S4",
                      locationName: "tags"
                    }
                  },
                  required: [
                    "ReadinessCheckArn",
                    "ResourceSet"
                  ]
                }
              }
            }
          }
        },
        ListRecoveryGroups: {
          http: {
            method: "GET",
            requestUri: "/recoverygroups",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              RecoveryGroups: {
                locationName: "recoveryGroups",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Cells: {
                      shape: "S3",
                      locationName: "cells"
                    },
                    RecoveryGroupArn: {
                      locationName: "recoveryGroupArn"
                    },
                    RecoveryGroupName: {
                      locationName: "recoveryGroupName"
                    },
                    Tags: {
                      shape: "S4",
                      locationName: "tags"
                    }
                  },
                  required: [
                    "RecoveryGroupArn",
                    "RecoveryGroupName",
                    "Cells"
                  ]
                }
              }
            }
          }
        },
        ListResourceSets: {
          http: {
            method: "GET",
            requestUri: "/resourcesets",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              ResourceSets: {
                locationName: "resourceSets",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceSetArn: {
                      locationName: "resourceSetArn"
                    },
                    ResourceSetName: {
                      locationName: "resourceSetName"
                    },
                    ResourceSetType: {
                      locationName: "resourceSetType"
                    },
                    Resources: {
                      shape: "Sh",
                      locationName: "resources"
                    },
                    Tags: {
                      shape: "S4",
                      locationName: "tags"
                    }
                  },
                  required: [
                    "ResourceSetType",
                    "ResourceSetName",
                    "ResourceSetArn",
                    "Resources"
                  ]
                }
              }
            }
          }
        },
        ListRules: {
          http: {
            method: "GET",
            requestUri: "/rules",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              ResourceType: {
                location: "querystring",
                locationName: "resourceType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {
                locationName: "nextToken"
              },
              Rules: {
                locationName: "rules",
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ResourceType: {
                      locationName: "resourceType"
                    },
                    RuleDescription: {
                      locationName: "ruleDescription"
                    },
                    RuleId: {
                      locationName: "ruleId"
                    }
                  },
                  required: [
                    "RuleDescription",
                    "RuleId",
                    "ResourceType"
                  ]
                }
              }
            }
          }
        },
        ListTagsForResources: {
          http: {
            method: "GET",
            requestUri: "/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              }
            },
            required: [
              "ResourceArn"
            ]
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resource-arn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            },
            required: [
              "ResourceArn",
              "Tags"
            ]
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resource-arn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            members: {
              ResourceArn: {
                location: "uri",
                locationName: "resource-arn"
              },
              TagKeys: {
                shape: "S3",
                location: "querystring",
                locationName: "tagKeys"
              }
            },
            required: [
              "TagKeys",
              "ResourceArn"
            ]
          }
        },
        UpdateCell: {
          http: {
            method: "PUT",
            requestUri: "/cells/{cellName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              CellName: {
                location: "uri",
                locationName: "cellName"
              },
              Cells: {
                shape: "S3",
                locationName: "cells"
              }
            },
            required: [
              "CellName",
              "Cells"
            ]
          },
          output: {
            type: "structure",
            members: {
              CellArn: {
                locationName: "cellArn"
              },
              CellName: {
                locationName: "cellName"
              },
              Cells: {
                shape: "S3",
                locationName: "cells"
              },
              ParentReadinessScopes: {
                shape: "S3",
                locationName: "parentReadinessScopes"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        UpdateReadinessCheck: {
          http: {
            method: "PUT",
            requestUri: "/readinesschecks/{readinessCheckName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ReadinessCheckName: {
                location: "uri",
                locationName: "readinessCheckName"
              },
              ResourceSetName: {
                locationName: "resourceSetName"
              }
            },
            required: [
              "ReadinessCheckName",
              "ResourceSetName"
            ]
          },
          output: {
            type: "structure",
            members: {
              ReadinessCheckArn: {
                locationName: "readinessCheckArn"
              },
              ReadinessCheckName: {
                locationName: "readinessCheckName"
              },
              ResourceSet: {
                locationName: "resourceSet"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        UpdateRecoveryGroup: {
          http: {
            method: "PUT",
            requestUri: "/recoverygroups/{recoveryGroupName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              Cells: {
                shape: "S3",
                locationName: "cells"
              },
              RecoveryGroupName: {
                location: "uri",
                locationName: "recoveryGroupName"
              }
            },
            required: [
              "RecoveryGroupName",
              "Cells"
            ]
          },
          output: {
            type: "structure",
            members: {
              Cells: {
                shape: "S3",
                locationName: "cells"
              },
              RecoveryGroupArn: {
                locationName: "recoveryGroupArn"
              },
              RecoveryGroupName: {
                locationName: "recoveryGroupName"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        },
        UpdateResourceSet: {
          http: {
            method: "PUT",
            requestUri: "/resourcesets/{resourceSetName}",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              ResourceSetName: {
                location: "uri",
                locationName: "resourceSetName"
              },
              ResourceSetType: {
                locationName: "resourceSetType"
              },
              Resources: {
                shape: "Sh",
                locationName: "resources"
              }
            },
            required: [
              "ResourceSetName",
              "ResourceSetType",
              "Resources"
            ]
          },
          output: {
            type: "structure",
            members: {
              ResourceSetArn: {
                locationName: "resourceSetArn"
              },
              ResourceSetName: {
                locationName: "resourceSetName"
              },
              ResourceSetType: {
                locationName: "resourceSetType"
              },
              Resources: {
                shape: "Sh",
                locationName: "resources"
              },
              Tags: {
                shape: "S4",
                locationName: "tags"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "list",
          member: {}
        },
        S4: {
          type: "map",
          key: {},
          value: {}
        },
        Sh: {
          type: "list",
          member: {
            type: "structure",
            members: {
              ComponentId: {
                locationName: "componentId"
              },
              DnsTargetResource: {
                locationName: "dnsTargetResource",
                type: "structure",
                members: {
                  DomainName: {
                    locationName: "domainName"
                  },
                  HostedZoneArn: {
                    locationName: "hostedZoneArn"
                  },
                  RecordSetId: {
                    locationName: "recordSetId"
                  },
                  RecordType: {
                    locationName: "recordType"
                  },
                  TargetResource: {
                    locationName: "targetResource",
                    type: "structure",
                    members: {
                      NLBResource: {
                        locationName: "nLBResource",
                        type: "structure",
                        members: {
                          Arn: {
                            locationName: "arn"
                          }
                        }
                      },
                      R53Resource: {
                        locationName: "r53Resource",
                        type: "structure",
                        members: {
                          DomainName: {
                            locationName: "domainName"
                          },
                          RecordSetId: {
                            locationName: "recordSetId"
                          }
                        }
                      }
                    }
                  }
                }
              },
              ReadinessScopes: {
                shape: "S3",
                locationName: "readinessScopes"
              },
              ResourceArn: {
                locationName: "resourceArn"
              }
            }
          }
        },
        S15: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Readiness: {
                locationName: "readiness"
              },
              ReadinessCheckName: {
                locationName: "readinessCheckName"
              }
            }
          }
        },
        S1d: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S1e: {
          type: "list",
          member: {
            type: "structure",
            members: {
              MessageText: {
                locationName: "messageText"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/route53-recovery-readiness-2019-12-02.paginators.json
var require_route53_recovery_readiness_2019_12_02_paginators = __commonJS({
  "node_modules/aws-sdk/apis/route53-recovery-readiness-2019-12-02.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListReadinessChecks: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ReadinessChecks"
        },
        ListResourceSets: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ResourceSets"
        },
        ListCells: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Cells"
        },
        ListRecoveryGroups: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "RecoveryGroups"
        },
        ListRules: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Rules"
        },
        ListCrossAccountAuthorizations: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "CrossAccountAuthorizations"
        },
        GetCellReadinessSummary: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ReadinessChecks",
          non_aggregate_keys: [
            "Readiness"
          ]
        },
        GetRecoveryGroupReadinessSummary: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "ReadinessChecks",
          non_aggregate_keys: [
            "Readiness"
          ]
        },
        GetReadinessCheckStatus: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Resources",
          non_aggregate_keys: [
            "Readiness",
            "Messages"
          ]
        },
        GetReadinessCheckResourceStatus: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults",
          result_key: "Rules",
          non_aggregate_keys: [
            "Readiness"
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/route53recoveryreadiness.js
var require_route53recoveryreadiness = __commonJS({
  "node_modules/aws-sdk/clients/route53recoveryreadiness.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["route53recoveryreadiness"] = {};
    AWS3.Route53RecoveryReadiness = Service.defineService("route53recoveryreadiness", ["2019-12-02"]);
    Object.defineProperty(apiLoader.services["route53recoveryreadiness"], "2019-12-02", {
      get: function get() {
        var model = require_route53_recovery_readiness_2019_12_02_min();
        model.paginators = require_route53_recovery_readiness_2019_12_02_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Route53RecoveryReadiness;
  }
});

// node_modules/aws-sdk/apis/chime-sdk-identity-2021-04-20.min.json
var require_chime_sdk_identity_2021_04_20_min = __commonJS({
  "node_modules/aws-sdk/apis/chime-sdk-identity-2021-04-20.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-04-20",
        endpointPrefix: "identity-chime",
        protocol: "rest-json",
        serviceFullName: "Amazon Chime SDK Identity",
        serviceId: "Chime SDK Identity",
        signatureVersion: "v4",
        signingName: "chime",
        uid: "chime-sdk-identity-2021-04-20"
      },
      operations: {
        CreateAppInstance: {
          http: {
            requestUri: "/app-instances",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "Name",
              "ClientRequestToken"
            ],
            members: {
              Name: {
                shape: "S2"
              },
              Metadata: {
                shape: "S3"
              },
              ClientRequestToken: {
                shape: "S4",
                idempotencyToken: true
              },
              Tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceArn: {}
            }
          }
        },
        CreateAppInstanceAdmin: {
          http: {
            requestUri: "/app-instances/{appInstanceArn}/admins",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceAdminArn",
              "AppInstanceArn"
            ],
            members: {
              AppInstanceAdminArn: {},
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceAdmin: {
                shape: "Sd"
              },
              AppInstanceArn: {}
            }
          }
        },
        CreateAppInstanceUser: {
          http: {
            requestUri: "/app-instance-users",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "AppInstanceUserId",
              "Name",
              "ClientRequestToken"
            ],
            members: {
              AppInstanceArn: {},
              AppInstanceUserId: {
                type: "string",
                sensitive: true
              },
              Name: {
                shape: "Sh"
              },
              Metadata: {
                shape: "S3"
              },
              ClientRequestToken: {
                shape: "S4",
                idempotencyToken: true
              },
              Tags: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceUserArn: {}
            }
          }
        },
        DeleteAppInstance: {
          http: {
            method: "DELETE",
            requestUri: "/app-instances/{appInstanceArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          }
        },
        DeleteAppInstanceAdmin: {
          http: {
            method: "DELETE",
            requestUri: "/app-instances/{appInstanceArn}/admins/{appInstanceAdminArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceAdminArn",
              "AppInstanceArn"
            ],
            members: {
              AppInstanceAdminArn: {
                location: "uri",
                locationName: "appInstanceAdminArn"
              },
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          }
        },
        DeleteAppInstanceUser: {
          http: {
            method: "DELETE",
            requestUri: "/app-instance-users/{appInstanceUserArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceUserArn"
            ],
            members: {
              AppInstanceUserArn: {
                location: "uri",
                locationName: "appInstanceUserArn"
              }
            }
          }
        },
        DescribeAppInstance: {
          http: {
            method: "GET",
            requestUri: "/app-instances/{appInstanceArn}"
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstance: {
                type: "structure",
                members: {
                  AppInstanceArn: {},
                  Name: {
                    shape: "S2"
                  },
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  },
                  Metadata: {
                    shape: "S3"
                  }
                }
              }
            }
          }
        },
        DescribeAppInstanceAdmin: {
          http: {
            method: "GET",
            requestUri: "/app-instances/{appInstanceArn}/admins/{appInstanceAdminArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceAdminArn",
              "AppInstanceArn"
            ],
            members: {
              AppInstanceAdminArn: {
                location: "uri",
                locationName: "appInstanceAdminArn"
              },
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceAdmin: {
                type: "structure",
                members: {
                  Admin: {
                    shape: "Sd"
                  },
                  AppInstanceArn: {},
                  CreatedTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeAppInstanceUser: {
          http: {
            method: "GET",
            requestUri: "/app-instance-users/{appInstanceUserArn}"
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceUserArn"
            ],
            members: {
              AppInstanceUserArn: {
                location: "uri",
                locationName: "appInstanceUserArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceUser: {
                type: "structure",
                members: {
                  AppInstanceUserArn: {},
                  Name: {
                    shape: "Sh"
                  },
                  Metadata: {
                    shape: "S3"
                  },
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        GetAppInstanceRetentionSettings: {
          http: {
            method: "GET",
            requestUri: "/app-instances/{appInstanceArn}/retention-settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceRetentionSettings: {
                shape: "Sy"
              },
              InitiateDeletionTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        ListAppInstanceAdmins: {
          http: {
            method: "GET",
            requestUri: "/app-instances/{appInstanceArn}/admins",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S13",
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceArn: {},
              AppInstanceAdmins: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Admin: {
                      shape: "Sd"
                    }
                  }
                }
              },
              NextToken: {
                shape: "S13"
              }
            }
          }
        },
        ListAppInstanceUsers: {
          http: {
            method: "GET",
            requestUri: "/app-instance-users"
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn"
            ],
            members: {
              AppInstanceArn: {
                location: "querystring",
                locationName: "app-instance-arn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S13",
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceArn: {},
              AppInstanceUsers: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AppInstanceUserArn: {},
                    Name: {
                      shape: "Sh"
                    },
                    Metadata: {
                      shape: "S3"
                    }
                  }
                }
              },
              NextToken: {
                shape: "S13"
              }
            }
          }
        },
        ListAppInstances: {
          http: {
            method: "GET",
            requestUri: "/app-instances"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S13",
                location: "querystring",
                locationName: "next-token"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AppInstanceArn: {},
                    Name: {
                      shape: "S2"
                    },
                    Metadata: {
                      shape: "S3"
                    }
                  }
                }
              },
              NextToken: {
                shape: "S13"
              }
            }
          }
        },
        PutAppInstanceRetentionSettings: {
          http: {
            method: "PUT",
            requestUri: "/app-instances/{appInstanceArn}/retention-settings",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "AppInstanceRetentionSettings"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              },
              AppInstanceRetentionSettings: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceRetentionSettings: {
                shape: "Sy"
              },
              InitiateDeletionTimestamp: {
                type: "timestamp"
              }
            }
          }
        },
        UpdateAppInstance: {
          http: {
            method: "PUT",
            requestUri: "/app-instances/{appInstanceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "Name",
              "Metadata"
            ],
            members: {
              AppInstanceArn: {
                location: "uri",
                locationName: "appInstanceArn"
              },
              Name: {
                shape: "S2"
              },
              Metadata: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceArn: {}
            }
          }
        },
        UpdateAppInstanceUser: {
          http: {
            method: "PUT",
            requestUri: "/app-instance-users/{appInstanceUserArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceUserArn",
              "Name",
              "Metadata"
            ],
            members: {
              AppInstanceUserArn: {
                location: "uri",
                locationName: "appInstanceUserArn"
              },
              Name: {
                shape: "Sh"
              },
              Metadata: {
                shape: "S3"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              AppInstanceUserArn: {}
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "string",
          sensitive: true
        },
        S3: {
          type: "string",
          sensitive: true
        },
        S4: {
          type: "string",
          sensitive: true
        },
        S5: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {
                type: "string",
                sensitive: true
              },
              Value: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        Sd: {
          type: "structure",
          members: {
            Arn: {},
            Name: {
              type: "string",
              sensitive: true
            }
          }
        },
        Sh: {
          type: "string",
          sensitive: true
        },
        Sy: {
          type: "structure",
          members: {
            ChannelRetentionSettings: {
              type: "structure",
              members: {
                RetentionDays: {
                  type: "integer"
                }
              }
            }
          }
        },
        S13: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/chime-sdk-identity-2021-04-20.paginators.json
var require_chime_sdk_identity_2021_04_20_paginators = __commonJS({
  "node_modules/aws-sdk/apis/chime-sdk-identity-2021-04-20.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAppInstanceAdmins: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAppInstanceUsers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListAppInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/chimesdkidentity.js
var require_chimesdkidentity = __commonJS({
  "node_modules/aws-sdk/clients/chimesdkidentity.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["chimesdkidentity"] = {};
    AWS3.ChimeSDKIdentity = Service.defineService("chimesdkidentity", ["2021-04-20"]);
    Object.defineProperty(apiLoader.services["chimesdkidentity"], "2021-04-20", {
      get: function get() {
        var model = require_chime_sdk_identity_2021_04_20_min();
        model.paginators = require_chime_sdk_identity_2021_04_20_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ChimeSDKIdentity;
  }
});

// node_modules/aws-sdk/apis/chime-sdk-messaging-2021-05-15.min.json
var require_chime_sdk_messaging_2021_05_15_min = __commonJS({
  "node_modules/aws-sdk/apis/chime-sdk-messaging-2021-05-15.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-05-15",
        endpointPrefix: "messaging-chime",
        protocol: "rest-json",
        serviceFullName: "Amazon Chime SDK Messaging",
        serviceId: "Chime SDK Messaging",
        signatureVersion: "v4",
        signingName: "chime",
        uid: "chime-sdk-messaging-2021-05-15"
      },
      operations: {
        BatchCreateChannelMembership: {
          http: {
            requestUri: "/channels/{channelArn}/memberships?operation=batch-create",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArns",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              Type: {},
              MemberArns: {
                type: "list",
                member: {}
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              BatchChannelMemberships: {
                type: "structure",
                members: {
                  InvitedBy: {
                    shape: "S7"
                  },
                  Type: {},
                  Members: {
                    type: "list",
                    member: {
                      shape: "S7"
                    }
                  },
                  ChannelArn: {}
                }
              },
              Errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MemberArn: {},
                    ErrorCode: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        CreateChannel: {
          http: {
            requestUri: "/channels",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "Name",
              "ClientRequestToken",
              "ChimeBearer"
            ],
            members: {
              AppInstanceArn: {},
              Name: {
                shape: "Sf"
              },
              Mode: {},
              Privacy: {},
              Metadata: {
                shape: "Si"
              },
              ClientRequestToken: {
                shape: "Sj",
                idempotencyToken: true
              },
              Tags: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Key",
                    "Value"
                  ],
                  members: {
                    Key: {
                      type: "string",
                      sensitive: true
                    },
                    Value: {
                      type: "string",
                      sensitive: true
                    }
                  }
                }
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {}
            }
          }
        },
        CreateChannelBan: {
          http: {
            requestUri: "/channels/{channelArn}/bans",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {},
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              Member: {
                shape: "S7"
              }
            }
          }
        },
        CreateChannelMembership: {
          http: {
            requestUri: "/channels/{channelArn}/memberships",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn",
              "Type",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {},
              Type: {},
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              Member: {
                shape: "S7"
              }
            }
          }
        },
        CreateChannelModerator: {
          http: {
            requestUri: "/channels/{channelArn}/moderators",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChannelModeratorArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChannelModeratorArn: {},
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              ChannelModerator: {
                shape: "S7"
              }
            }
          }
        },
        DeleteChannel: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          }
        },
        DeleteChannelBan: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}/bans/{memberArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {
                location: "uri",
                locationName: "memberArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          }
        },
        DeleteChannelMembership: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}/memberships/{memberArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {
                location: "uri",
                locationName: "memberArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          }
        },
        DeleteChannelMessage: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}/messages/{messageId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MessageId",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          }
        },
        DeleteChannelModerator: {
          http: {
            method: "DELETE",
            requestUri: "/channels/{channelArn}/moderators/{channelModeratorArn}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChannelModeratorArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChannelModeratorArn: {
                location: "uri",
                locationName: "channelModeratorArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          }
        },
        DescribeChannel: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channel: {
                type: "structure",
                members: {
                  Name: {
                    shape: "Sf"
                  },
                  ChannelArn: {},
                  Mode: {},
                  Privacy: {},
                  Metadata: {
                    shape: "Si"
                  },
                  CreatedBy: {
                    shape: "S7"
                  },
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastMessageTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeChannelBan: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/bans/{memberArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {
                location: "uri",
                locationName: "memberArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelBan: {
                type: "structure",
                members: {
                  Member: {
                    shape: "S7"
                  },
                  ChannelArn: {},
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  CreatedBy: {
                    shape: "S7"
                  }
                }
              }
            }
          }
        },
        DescribeChannelMembership: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/memberships/{memberArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MemberArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MemberArn: {
                location: "uri",
                locationName: "memberArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelMembership: {
                type: "structure",
                members: {
                  InvitedBy: {
                    shape: "S7"
                  },
                  Type: {},
                  Member: {
                    shape: "S7"
                  },
                  ChannelArn: {},
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  }
                }
              }
            }
          }
        },
        DescribeChannelMembershipForAppInstanceUser: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}?scope=app-instance-user-membership",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "AppInstanceUserArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              AppInstanceUserArn: {
                location: "querystring",
                locationName: "app-instance-user-arn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelMembership: {
                shape: "S1d"
              }
            }
          }
        },
        DescribeChannelModeratedByAppInstanceUser: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}?scope=app-instance-user-moderated-channel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "AppInstanceUserArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              AppInstanceUserArn: {
                location: "querystring",
                locationName: "app-instance-user-arn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channel: {
                shape: "S1i"
              }
            }
          }
        },
        DescribeChannelModerator: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/moderators/{channelModeratorArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChannelModeratorArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChannelModeratorArn: {
                location: "uri",
                locationName: "channelModeratorArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelModerator: {
                type: "structure",
                members: {
                  Moderator: {
                    shape: "S7"
                  },
                  ChannelArn: {},
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  CreatedBy: {
                    shape: "S7"
                  }
                }
              }
            }
          }
        },
        GetChannelMessage: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/messages/{messageId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MessageId",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelMessage: {
                type: "structure",
                members: {
                  ChannelArn: {},
                  MessageId: {},
                  Content: {
                    shape: "S1p"
                  },
                  Metadata: {
                    shape: "Si"
                  },
                  Type: {},
                  CreatedTimestamp: {
                    type: "timestamp"
                  },
                  LastEditedTimestamp: {
                    type: "timestamp"
                  },
                  LastUpdatedTimestamp: {
                    type: "timestamp"
                  },
                  Sender: {
                    shape: "S7"
                  },
                  Redacted: {
                    type: "boolean"
                  },
                  Persistence: {}
                }
              }
            }
          }
        },
        GetMessagingSessionEndpoint: {
          http: {
            method: "GET",
            requestUri: "/endpoints/messaging-session",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {}
          },
          output: {
            type: "structure",
            members: {
              Endpoint: {
                type: "structure",
                members: {
                  Url: {}
                }
              }
            }
          }
        },
        ListChannelBans: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/bans",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S1z",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              NextToken: {
                shape: "S1z"
              },
              ChannelBans: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Member: {
                      shape: "S7"
                    }
                  }
                }
              }
            }
          }
        },
        ListChannelMemberships: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/memberships",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              Type: {
                location: "querystring",
                locationName: "type"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S1z",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              ChannelMemberships: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Member: {
                      shape: "S7"
                    }
                  }
                }
              },
              NextToken: {
                shape: "S1z"
              }
            }
          }
        },
        ListChannelMembershipsForAppInstanceUser: {
          http: {
            method: "GET",
            requestUri: "/channels?scope=app-instance-user-memberships",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChimeBearer"
            ],
            members: {
              AppInstanceUserArn: {
                location: "querystring",
                locationName: "app-instance-user-arn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S1z",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelMemberships: {
                type: "list",
                member: {
                  shape: "S1d"
                }
              },
              NextToken: {
                shape: "S1z"
              }
            }
          }
        },
        ListChannelMessages: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/messages",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              SortOrder: {
                location: "querystring",
                locationName: "sort-order"
              },
              NotBefore: {
                location: "querystring",
                locationName: "not-before",
                type: "timestamp"
              },
              NotAfter: {
                location: "querystring",
                locationName: "not-after",
                type: "timestamp"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S1z",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              NextToken: {
                shape: "S1z"
              },
              ChannelMessages: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    MessageId: {},
                    Content: {
                      shape: "S1p"
                    },
                    Metadata: {
                      shape: "Si"
                    },
                    Type: {},
                    CreatedTimestamp: {
                      type: "timestamp"
                    },
                    LastUpdatedTimestamp: {
                      type: "timestamp"
                    },
                    LastEditedTimestamp: {
                      type: "timestamp"
                    },
                    Sender: {
                      shape: "S7"
                    },
                    Redacted: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        ListChannelModerators: {
          http: {
            method: "GET",
            requestUri: "/channels/{channelArn}/moderators",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S1z",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              NextToken: {
                shape: "S1z"
              },
              ChannelModerators: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Moderator: {
                      shape: "S7"
                    }
                  }
                }
              }
            }
          }
        },
        ListChannels: {
          http: {
            method: "GET",
            requestUri: "/channels",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AppInstanceArn",
              "ChimeBearer"
            ],
            members: {
              AppInstanceArn: {
                location: "querystring",
                locationName: "app-instance-arn"
              },
              Privacy: {
                location: "querystring",
                locationName: "privacy"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S1z",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channels: {
                type: "list",
                member: {
                  shape: "S1e"
                }
              },
              NextToken: {
                shape: "S1z"
              }
            }
          }
        },
        ListChannelsModeratedByAppInstanceUser: {
          http: {
            method: "GET",
            requestUri: "/channels?scope=app-instance-user-moderated-channels",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChimeBearer"
            ],
            members: {
              AppInstanceUserArn: {
                location: "querystring",
                locationName: "app-instance-user-arn"
              },
              MaxResults: {
                location: "querystring",
                locationName: "max-results",
                type: "integer"
              },
              NextToken: {
                shape: "S1z",
                location: "querystring",
                locationName: "next-token"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Channels: {
                type: "list",
                member: {
                  shape: "S1i"
                }
              },
              NextToken: {
                shape: "S1z"
              }
            }
          }
        },
        RedactChannelMessage: {
          http: {
            requestUri: "/channels/{channelArn}/messages/{messageId}?operation=redact",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MessageId",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              MessageId: {}
            }
          }
        },
        SendChannelMessage: {
          http: {
            requestUri: "/channels/{channelArn}/messages",
            responseCode: 201
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "Content",
              "Type",
              "Persistence",
              "ClientRequestToken",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              Content: {
                type: "string",
                sensitive: true
              },
              Type: {},
              Persistence: {},
              Metadata: {
                shape: "Si"
              },
              ClientRequestToken: {
                shape: "Sj",
                idempotencyToken: true
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              MessageId: {}
            }
          }
        },
        UpdateChannel: {
          http: {
            method: "PUT",
            requestUri: "/channels/{channelArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "Name",
              "Mode",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              Name: {
                shape: "Sf"
              },
              Mode: {},
              Metadata: {
                shape: "Si"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {}
            }
          }
        },
        UpdateChannelMessage: {
          http: {
            method: "PUT",
            requestUri: "/channels/{channelArn}/messages/{messageId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "MessageId",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              MessageId: {
                location: "uri",
                locationName: "messageId"
              },
              Content: {
                shape: "S1p"
              },
              Metadata: {
                shape: "Si"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {},
              MessageId: {}
            }
          }
        },
        UpdateChannelReadMarker: {
          http: {
            method: "PUT",
            requestUri: "/channels/{channelArn}/readMarker",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "ChannelArn",
              "ChimeBearer"
            ],
            members: {
              ChannelArn: {
                location: "uri",
                locationName: "channelArn"
              },
              ChimeBearer: {
                location: "header",
                locationName: "x-amz-chime-bearer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ChannelArn: {}
            }
          }
        }
      },
      shapes: {
        S7: {
          type: "structure",
          members: {
            Arn: {},
            Name: {
              type: "string",
              sensitive: true
            }
          }
        },
        Sf: {
          type: "string",
          sensitive: true
        },
        Si: {
          type: "string",
          sensitive: true
        },
        Sj: {
          type: "string",
          sensitive: true
        },
        S1d: {
          type: "structure",
          members: {
            ChannelSummary: {
              shape: "S1e"
            },
            AppInstanceUserMembershipSummary: {
              type: "structure",
              members: {
                Type: {},
                ReadMarkerTimestamp: {
                  type: "timestamp"
                }
              }
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            Name: {
              shape: "Sf"
            },
            ChannelArn: {},
            Mode: {},
            Privacy: {},
            Metadata: {
              shape: "Si"
            },
            LastMessageTimestamp: {
              type: "timestamp"
            }
          }
        },
        S1i: {
          type: "structure",
          members: {
            ChannelSummary: {
              shape: "S1e"
            }
          }
        },
        S1p: {
          type: "string",
          sensitive: true
        },
        S1z: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/chime-sdk-messaging-2021-05-15.paginators.json
var require_chime_sdk_messaging_2021_05_15_paginators = __commonJS({
  "node_modules/aws-sdk/apis/chime-sdk-messaging-2021-05-15.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListChannelBans: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelMemberships: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelMembershipsForAppInstanceUser: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelMessages: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelModerators: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannels: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListChannelsModeratedByAppInstanceUser: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/chimesdkmessaging.js
var require_chimesdkmessaging = __commonJS({
  "node_modules/aws-sdk/clients/chimesdkmessaging.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["chimesdkmessaging"] = {};
    AWS3.ChimeSDKMessaging = Service.defineService("chimesdkmessaging", ["2021-05-15"]);
    Object.defineProperty(apiLoader.services["chimesdkmessaging"], "2021-05-15", {
      get: function get() {
        var model = require_chime_sdk_messaging_2021_05_15_min();
        model.paginators = require_chime_sdk_messaging_2021_05_15_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.ChimeSDKMessaging;
  }
});

// node_modules/aws-sdk/apis/snow-device-management-2021-08-04.min.json
var require_snow_device_management_2021_08_04_min = __commonJS({
  "node_modules/aws-sdk/apis/snow-device-management-2021-08-04.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-08-04",
        endpointPrefix: "snow-device-management",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Snow Device Management",
        serviceId: "Snow Device Management",
        signatureVersion: "v4",
        signingName: "snow-device-management",
        uid: "snow-device-management-2021-08-04"
      },
      operations: {
        CancelTask: {
          http: {
            requestUri: "/task/{taskId}/cancel",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskId: {}
            }
          }
        },
        CreateTask: {
          http: {
            requestUri: "/task",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "command",
              "targets"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              command: {
                type: "structure",
                members: {
                  reboot: {
                    type: "structure",
                    members: {}
                  },
                  unlock: {
                    type: "structure",
                    members: {}
                  }
                },
                union: true
              },
              description: {},
              tags: {
                shape: "Sb"
              },
              targets: {
                shape: "Sc"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              taskArn: {},
              taskId: {}
            }
          }
        },
        DescribeDevice: {
          http: {
            requestUri: "/managed-device/{managedDeviceId}/describe",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "managedDeviceId"
            ],
            members: {
              managedDeviceId: {
                location: "uri",
                locationName: "managedDeviceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              associatedWithJob: {},
              deviceCapacities: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    available: {
                      type: "long"
                    },
                    name: {},
                    total: {
                      type: "long"
                    },
                    unit: {},
                    used: {
                      type: "long"
                    }
                  }
                }
              },
              deviceState: {},
              deviceType: {},
              lastReachedOutAt: {
                type: "timestamp"
              },
              lastUpdatedAt: {
                type: "timestamp"
              },
              managedDeviceArn: {},
              managedDeviceId: {},
              physicalNetworkInterfaces: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    defaultGateway: {},
                    ipAddress: {},
                    ipAddressAssignment: {},
                    macAddress: {},
                    netmask: {},
                    physicalConnectorType: {},
                    physicalNetworkInterfaceId: {}
                  }
                }
              },
              software: {
                type: "structure",
                members: {
                  installState: {},
                  installedVersion: {},
                  installingVersion: {}
                }
              },
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        DescribeDeviceEc2Instances: {
          http: {
            requestUri: "/managed-device/{managedDeviceId}/resources/ec2/describe",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "instanceIds",
              "managedDeviceId"
            ],
            members: {
              instanceIds: {
                type: "list",
                member: {}
              },
              managedDeviceId: {
                location: "uri",
                locationName: "managedDeviceId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              instances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    instance: {
                      type: "structure",
                      members: {
                        amiLaunchIndex: {
                          type: "integer"
                        },
                        blockDeviceMappings: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              deviceName: {},
                              ebs: {
                                type: "structure",
                                members: {
                                  attachTime: {
                                    type: "timestamp"
                                  },
                                  deleteOnTermination: {
                                    type: "boolean"
                                  },
                                  status: {},
                                  volumeId: {}
                                }
                              }
                            }
                          }
                        },
                        cpuOptions: {
                          type: "structure",
                          members: {
                            coreCount: {
                              type: "integer"
                            },
                            threadsPerCore: {
                              type: "integer"
                            }
                          }
                        },
                        createdAt: {
                          type: "timestamp"
                        },
                        imageId: {},
                        instanceId: {},
                        instanceType: {},
                        privateIpAddress: {},
                        publicIpAddress: {},
                        rootDeviceName: {},
                        securityGroups: {
                          type: "list",
                          member: {
                            type: "structure",
                            members: {
                              groupId: {},
                              groupName: {}
                            }
                          }
                        },
                        state: {
                          type: "structure",
                          members: {
                            code: {
                              type: "integer"
                            },
                            name: {}
                          }
                        },
                        updatedAt: {
                          type: "timestamp"
                        }
                      }
                    },
                    lastUpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeExecution: {
          http: {
            requestUri: "/task/{taskId}/execution/{managedDeviceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "managedDeviceId",
              "taskId"
            ],
            members: {
              managedDeviceId: {
                location: "uri",
                locationName: "managedDeviceId"
              },
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              executionId: {},
              lastUpdatedAt: {
                type: "timestamp"
              },
              managedDeviceId: {},
              startedAt: {
                type: "timestamp"
              },
              state: {},
              taskId: {}
            }
          }
        },
        DescribeTask: {
          http: {
            requestUri: "/task/{taskId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              taskId: {
                location: "uri",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              completedAt: {
                type: "timestamp"
              },
              createdAt: {
                type: "timestamp"
              },
              description: {},
              lastUpdatedAt: {
                type: "timestamp"
              },
              state: {},
              tags: {
                shape: "Sb"
              },
              targets: {
                shape: "Sc"
              },
              taskArn: {},
              taskId: {}
            }
          }
        },
        ListDeviceResources: {
          http: {
            method: "GET",
            requestUri: "/managed-device/{managedDeviceId}/resources",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "managedDeviceId"
            ],
            members: {
              managedDeviceId: {
                location: "uri",
                locationName: "managedDeviceId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              type: {
                location: "querystring",
                locationName: "type"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              resources: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "resourceType"
                  ],
                  members: {
                    arn: {},
                    id: {},
                    resourceType: {}
                  }
                }
              }
            }
          }
        },
        ListDevices: {
          http: {
            method: "GET",
            requestUri: "/managed-devices",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              jobId: {
                location: "querystring",
                locationName: "jobId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              devices: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    associatedWithJob: {},
                    managedDeviceArn: {},
                    managedDeviceId: {},
                    tags: {
                      shape: "Sb"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListExecutions: {
          http: {
            method: "GET",
            requestUri: "/executions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "taskId"
            ],
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              state: {
                location: "querystring",
                locationName: "state"
              },
              taskId: {
                location: "querystring",
                locationName: "taskId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              executions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    executionId: {},
                    managedDeviceId: {},
                    state: {},
                    taskId: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        ListTasks: {
          http: {
            method: "GET",
            requestUri: "/tasks",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              state: {
                location: "querystring",
                locationName: "state"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              tasks: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "taskId"
                  ],
                  members: {
                    state: {},
                    tags: {
                      shape: "Sb"
                    },
                    taskArn: {},
                    taskId: {}
                  }
                }
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "Sb"
              }
            }
          }
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        Sb: {
          type: "map",
          key: {},
          value: {}
        },
        Sc: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/snow-device-management-2021-08-04.paginators.json
var require_snow_device_management_2021_08_04_paginators = __commonJS({
  "node_modules/aws-sdk/apis/snow-device-management-2021-08-04.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListDeviceResources: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "resources"
        },
        ListDevices: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "devices"
        },
        ListExecutions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "executions"
        },
        ListTasks: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "tasks"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/snowdevicemanagement.js
var require_snowdevicemanagement = __commonJS({
  "node_modules/aws-sdk/clients/snowdevicemanagement.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["snowdevicemanagement"] = {};
    AWS3.SnowDeviceManagement = Service.defineService("snowdevicemanagement", ["2021-08-04"]);
    Object.defineProperty(apiLoader.services["snowdevicemanagement"], "2021-08-04", {
      get: function get() {
        var model = require_snow_device_management_2021_08_04_min();
        model.paginators = require_snow_device_management_2021_08_04_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.SnowDeviceManagement;
  }
});

// node_modules/aws-sdk/apis/memorydb-2021-01-01.min.json
var require_memorydb_2021_01_01_min = __commonJS({
  "node_modules/aws-sdk/apis/memorydb-2021-01-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-01-01",
        endpointPrefix: "memory-db",
        jsonVersion: "1.1",
        protocol: "json",
        serviceAbbreviation: "Amazon MemoryDB",
        serviceFullName: "Amazon MemoryDB",
        serviceId: "MemoryDB",
        signatureVersion: "v4",
        signingName: "memorydb",
        targetPrefix: "AmazonMemoryDB",
        uid: "memorydb-2021-01-01"
      },
      operations: {
        BatchUpdateCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterNames"
            ],
            members: {
              ClusterNames: {
                shape: "S2"
              },
              ServiceUpdate: {
                type: "structure",
                members: {
                  ServiceUpdateNameToApply: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProcessedClusters: {
                shape: "S6"
              },
              UnprocessedClusters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ClusterName: {},
                    ErrorType: {},
                    ErrorMessage: {}
                  }
                }
              }
            }
          }
        },
        CopySnapshot: {
          input: {
            type: "structure",
            required: [
              "SourceSnapshotName",
              "TargetSnapshotName"
            ],
            members: {
              SourceSnapshotName: {},
              TargetSnapshotName: {},
              TargetBucket: {},
              KmsKeyId: {},
              Tags: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Snapshot: {
                shape: "S11"
              }
            }
          }
        },
        CreateACL: {
          input: {
            type: "structure",
            required: [
              "ACLName"
            ],
            members: {
              ACLName: {},
              UserNames: {
                shape: "S17"
              },
              Tags: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ACL: {
                shape: "S1a"
              }
            }
          }
        },
        CreateCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterName",
              "NodeType",
              "ACLName"
            ],
            members: {
              ClusterName: {},
              NodeType: {},
              ParameterGroupName: {},
              Description: {},
              NumShards: {
                type: "integer"
              },
              NumReplicasPerShard: {
                type: "integer"
              },
              SubnetGroupName: {},
              SecurityGroupIds: {
                shape: "S1f"
              },
              MaintenanceWindow: {},
              Port: {
                type: "integer"
              },
              SnsTopicArn: {},
              TLSEnabled: {
                type: "boolean"
              },
              KmsKeyId: {},
              SnapshotArns: {
                type: "list",
                member: {}
              },
              SnapshotName: {},
              SnapshotRetentionLimit: {
                type: "integer"
              },
              Tags: {
                shape: "Sy"
              },
              SnapshotWindow: {},
              ACLName: {},
              EngineVersion: {},
              AutoMinorVersionUpgrade: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "S7"
              }
            }
          }
        },
        CreateParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName",
              "Family"
            ],
            members: {
              ParameterGroupName: {},
              Family: {},
              Description: {},
              Tags: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ParameterGroup: {
                shape: "S1k"
              }
            }
          }
        },
        CreateSnapshot: {
          input: {
            type: "structure",
            required: [
              "ClusterName",
              "SnapshotName"
            ],
            members: {
              ClusterName: {},
              SnapshotName: {},
              KmsKeyId: {},
              Tags: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Snapshot: {
                shape: "S11"
              }
            }
          }
        },
        CreateSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "SubnetGroupName",
              "SubnetIds"
            ],
            members: {
              SubnetGroupName: {},
              Description: {},
              SubnetIds: {
                shape: "S1o"
              },
              Tags: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SubnetGroup: {
                shape: "S1q"
              }
            }
          }
        },
        CreateUser: {
          input: {
            type: "structure",
            required: [
              "UserName",
              "AuthenticationMode",
              "AccessString"
            ],
            members: {
              UserName: {},
              AuthenticationMode: {
                shape: "S1v"
              },
              AccessString: {},
              Tags: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S20"
              }
            }
          }
        },
        DeleteACL: {
          input: {
            type: "structure",
            required: [
              "ACLName"
            ],
            members: {
              ACLName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ACL: {
                shape: "S1a"
              }
            }
          }
        },
        DeleteCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterName"
            ],
            members: {
              ClusterName: {},
              FinalSnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "S7"
              }
            }
          }
        },
        DeleteParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName"
            ],
            members: {
              ParameterGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ParameterGroup: {
                shape: "S1k"
              }
            }
          }
        },
        DeleteSnapshot: {
          input: {
            type: "structure",
            required: [
              "SnapshotName"
            ],
            members: {
              SnapshotName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Snapshot: {
                shape: "S11"
              }
            }
          }
        },
        DeleteSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "SubnetGroupName"
            ],
            members: {
              SubnetGroupName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              SubnetGroup: {
                shape: "S1q"
              }
            }
          }
        },
        DeleteUser: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S20"
              }
            }
          }
        },
        DescribeACLs: {
          input: {
            type: "structure",
            members: {
              ACLName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ACLs: {
                type: "list",
                member: {
                  shape: "S1a"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeClusters: {
          input: {
            type: "structure",
            members: {
              ClusterName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ShowShardDetails: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Clusters: {
                shape: "S6"
              }
            }
          }
        },
        DescribeEngineVersions: {
          input: {
            type: "structure",
            members: {
              EngineVersion: {},
              ParameterGroupFamily: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              DefaultOnly: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              EngineVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    EngineVersion: {},
                    EnginePatchVersion: {},
                    ParameterGroupFamily: {}
                  }
                }
              }
            }
          }
        },
        DescribeEvents: {
          input: {
            type: "structure",
            members: {
              SourceName: {},
              SourceType: {},
              StartTime: {
                type: "timestamp"
              },
              EndTime: {
                type: "timestamp"
              },
              Duration: {
                type: "integer"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Events: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceName: {},
                    SourceType: {},
                    Message: {},
                    Date: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeParameterGroups: {
          input: {
            type: "structure",
            members: {
              ParameterGroupName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ParameterGroups: {
                type: "list",
                member: {
                  shape: "S1k"
                }
              }
            }
          }
        },
        DescribeParameters: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName"
            ],
            members: {
              ParameterGroupName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Parameters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Value: {},
                    Description: {},
                    DataType: {},
                    AllowedValues: {},
                    MinimumEngineVersion: {}
                  }
                }
              }
            }
          }
        },
        DescribeServiceUpdates: {
          input: {
            type: "structure",
            members: {
              ServiceUpdateName: {},
              ClusterNames: {
                shape: "S2"
              },
              Status: {
                type: "list",
                member: {}
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ServiceUpdates: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ClusterName: {},
                    ServiceUpdateName: {},
                    ReleaseDate: {
                      type: "timestamp"
                    },
                    Description: {},
                    Status: {},
                    Type: {},
                    NodesUpdated: {},
                    AutoUpdateStartDate: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeSnapshots: {
          input: {
            type: "structure",
            members: {
              ClusterName: {},
              SnapshotName: {},
              Source: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ShowDetail: {
                type: "boolean"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              Snapshots: {
                type: "list",
                member: {
                  shape: "S11"
                }
              }
            }
          }
        },
        DescribeSubnetGroups: {
          input: {
            type: "structure",
            members: {
              SubnetGroupName: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              SubnetGroups: {
                type: "list",
                member: {
                  shape: "S1q"
                }
              }
            }
          }
        },
        DescribeUsers: {
          input: {
            type: "structure",
            members: {
              UserName: {},
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "Name",
                    "Values"
                  ],
                  members: {
                    Name: {},
                    Values: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Users: {
                type: "list",
                member: {
                  shape: "S20"
                }
              },
              NextToken: {}
            }
          }
        },
        FailoverShard: {
          input: {
            type: "structure",
            required: [
              "ClusterName",
              "ShardName"
            ],
            members: {
              ClusterName: {},
              ShardName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "S7"
              }
            }
          }
        },
        ListAllowedNodeTypeUpdates: {
          input: {
            type: "structure",
            required: [
              "ClusterName"
            ],
            members: {
              ClusterName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ScaleUpNodeTypes: {
                shape: "S3q"
              },
              ScaleDownNodeTypes: {
                shape: "S3q"
              }
            }
          }
        },
        ListTags: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "Sy"
              }
            }
          }
        },
        ResetParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName"
            ],
            members: {
              ParameterGroupName: {},
              AllParameters: {
                type: "boolean"
              },
              ParameterNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ParameterGroup: {
                shape: "S1k"
              }
            }
          }
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "Sy"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "Sy"
              }
            }
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "Sy"
              }
            }
          }
        },
        UpdateACL: {
          input: {
            type: "structure",
            required: [
              "ACLName"
            ],
            members: {
              ACLName: {},
              UserNamesToAdd: {
                shape: "S17"
              },
              UserNamesToRemove: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ACL: {
                shape: "S1a"
              }
            }
          }
        },
        UpdateCluster: {
          input: {
            type: "structure",
            required: [
              "ClusterName"
            ],
            members: {
              ClusterName: {},
              Description: {},
              SecurityGroupIds: {
                shape: "S1f"
              },
              MaintenanceWindow: {},
              SnsTopicArn: {},
              SnsTopicStatus: {},
              ParameterGroupName: {},
              SnapshotWindow: {},
              SnapshotRetentionLimit: {
                type: "integer"
              },
              NodeType: {},
              EngineVersion: {},
              ReplicaConfiguration: {
                type: "structure",
                members: {
                  ReplicaCount: {
                    type: "integer"
                  }
                }
              },
              ShardConfiguration: {
                type: "structure",
                members: {
                  ShardCount: {
                    type: "integer"
                  }
                }
              },
              ACLName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Cluster: {
                shape: "S7"
              }
            }
          }
        },
        UpdateParameterGroup: {
          input: {
            type: "structure",
            required: [
              "ParameterGroupName",
              "ParameterNameValues"
            ],
            members: {
              ParameterGroupName: {},
              ParameterNameValues: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ParameterName: {},
                    ParameterValue: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ParameterGroup: {
                shape: "S1k"
              }
            }
          }
        },
        UpdateSubnetGroup: {
          input: {
            type: "structure",
            required: [
              "SubnetGroupName"
            ],
            members: {
              SubnetGroupName: {},
              Description: {},
              SubnetIds: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              SubnetGroup: {
                shape: "S1q"
              }
            }
          }
        },
        UpdateUser: {
          input: {
            type: "structure",
            required: [
              "UserName"
            ],
            members: {
              UserName: {},
              AuthenticationMode: {
                shape: "S1v"
              },
              AccessString: {}
            }
          },
          output: {
            type: "structure",
            members: {
              User: {
                shape: "S20"
              }
            }
          }
        }
      },
      shapes: {
        S2: {
          type: "list",
          member: {}
        },
        S6: {
          type: "list",
          member: {
            shape: "S7"
          }
        },
        S7: {
          type: "structure",
          members: {
            Name: {},
            Description: {},
            Status: {},
            PendingUpdates: {
              type: "structure",
              members: {
                Resharding: {
                  type: "structure",
                  members: {
                    SlotMigration: {
                      type: "structure",
                      members: {
                        ProgressPercentage: {
                          type: "double"
                        }
                      }
                    }
                  }
                },
                ACLs: {
                  type: "structure",
                  members: {
                    ACLToApply: {}
                  }
                },
                ServiceUpdates: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      ServiceUpdateName: {},
                      Status: {}
                    }
                  }
                }
              }
            },
            NumberOfShards: {
              type: "integer"
            },
            Shards: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Name: {},
                  Status: {},
                  Slots: {},
                  Nodes: {
                    type: "list",
                    member: {
                      type: "structure",
                      members: {
                        Name: {},
                        Status: {},
                        AvailabilityZone: {},
                        CreateTime: {
                          type: "timestamp"
                        },
                        Endpoint: {
                          shape: "Sn"
                        }
                      }
                    }
                  },
                  NumberOfNodes: {
                    type: "integer"
                  }
                }
              }
            },
            AvailabilityMode: {},
            ClusterEndpoint: {
              shape: "Sn"
            },
            NodeType: {},
            EngineVersion: {},
            EnginePatchVersion: {},
            ParameterGroupName: {},
            ParameterGroupStatus: {},
            SecurityGroups: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  SecurityGroupId: {},
                  Status: {}
                }
              }
            },
            SubnetGroupName: {},
            TLSEnabled: {
              type: "boolean"
            },
            KmsKeyId: {},
            ARN: {},
            SnsTopicArn: {},
            SnsTopicStatus: {},
            SnapshotRetentionLimit: {
              type: "integer"
            },
            MaintenanceWindow: {},
            SnapshotWindow: {},
            ACLName: {},
            AutoMinorVersionUpgrade: {
              type: "boolean"
            }
          }
        },
        Sn: {
          type: "structure",
          members: {
            Address: {},
            Port: {
              type: "integer"
            }
          }
        },
        Sy: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        S11: {
          type: "structure",
          members: {
            Name: {},
            Status: {},
            Source: {},
            KmsKeyId: {},
            ARN: {},
            ClusterConfiguration: {
              type: "structure",
              members: {
                Name: {},
                Description: {},
                NodeType: {},
                EngineVersion: {},
                MaintenanceWindow: {},
                TopicArn: {},
                Port: {
                  type: "integer"
                },
                ParameterGroupName: {},
                SubnetGroupName: {},
                VpcId: {},
                SnapshotRetentionLimit: {
                  type: "integer"
                },
                SnapshotWindow: {},
                NumShards: {
                  type: "integer"
                },
                Shards: {
                  type: "list",
                  member: {
                    type: "structure",
                    members: {
                      Name: {},
                      Configuration: {
                        type: "structure",
                        members: {
                          Slots: {},
                          ReplicaCount: {
                            type: "integer"
                          }
                        }
                      },
                      Size: {},
                      SnapshotCreationTime: {
                        type: "timestamp"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        S17: {
          type: "list",
          member: {}
        },
        S1a: {
          type: "structure",
          members: {
            Name: {},
            Status: {},
            UserNames: {
              shape: "S1b"
            },
            MinimumEngineVersion: {},
            PendingChanges: {
              type: "structure",
              members: {
                UserNamesToRemove: {
                  shape: "S1b"
                },
                UserNamesToAdd: {
                  shape: "S1b"
                }
              }
            },
            Clusters: {
              type: "list",
              member: {}
            },
            ARN: {}
          }
        },
        S1b: {
          type: "list",
          member: {}
        },
        S1f: {
          type: "list",
          member: {}
        },
        S1k: {
          type: "structure",
          members: {
            Name: {},
            Family: {},
            Description: {},
            ARN: {}
          }
        },
        S1o: {
          type: "list",
          member: {}
        },
        S1q: {
          type: "structure",
          members: {
            Name: {},
            Description: {},
            VpcId: {},
            Subnets: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  Identifier: {},
                  AvailabilityZone: {
                    type: "structure",
                    members: {
                      Name: {}
                    }
                  }
                }
              }
            },
            ARN: {}
          }
        },
        S1v: {
          type: "structure",
          members: {
            Type: {},
            Passwords: {
              type: "list",
              member: {}
            }
          }
        },
        S20: {
          type: "structure",
          members: {
            Name: {},
            Status: {},
            AccessString: {},
            ACLNames: {
              type: "list",
              member: {}
            },
            MinimumEngineVersion: {},
            Authentication: {
              type: "structure",
              members: {
                Type: {},
                PasswordCount: {
                  type: "integer"
                }
              }
            },
            ARN: {}
          }
        },
        S3q: {
          type: "list",
          member: {}
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/memorydb-2021-01-01.paginators.json
var require_memorydb_2021_01_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/memorydb-2021-01-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/memorydb.js
var require_memorydb = __commonJS({
  "node_modules/aws-sdk/clients/memorydb.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["memorydb"] = {};
    AWS3.MemoryDB = Service.defineService("memorydb", ["2021-01-01"]);
    Object.defineProperty(apiLoader.services["memorydb"], "2021-01-01", {
      get: function get() {
        var model = require_memorydb_2021_01_01_min();
        model.paginators = require_memorydb_2021_01_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.MemoryDB;
  }
});

// node_modules/aws-sdk/apis/opensearch-2021-01-01.min.json
var require_opensearch_2021_01_01_min = __commonJS({
  "node_modules/aws-sdk/apis/opensearch-2021-01-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-01-01",
        endpointPrefix: "es",
        protocol: "rest-json",
        serviceFullName: "Amazon OpenSearch Service",
        serviceId: "OpenSearch",
        signatureVersion: "v4",
        uid: "opensearch-2021-01-01"
      },
      operations: {
        AcceptInboundConnection: {
          http: {
            method: "PUT",
            requestUri: "/2021-01-01/opensearch/cc/inboundConnection/{ConnectionId}/accept"
          },
          input: {
            type: "structure",
            required: [
              "ConnectionId"
            ],
            members: {
              ConnectionId: {
                location: "uri",
                locationName: "ConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "S4"
              }
            }
          }
        },
        AddTags: {
          http: {
            requestUri: "/2021-01-01/tags"
          },
          input: {
            type: "structure",
            required: [
              "ARN",
              "TagList"
            ],
            members: {
              ARN: {},
              TagList: {
                shape: "Sf"
              }
            }
          }
        },
        AssociatePackage: {
          http: {
            requestUri: "/2021-01-01/packages/associate/{PackageID}/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "PackageID",
              "DomainName"
            ],
            members: {
              PackageID: {
                location: "uri",
                locationName: "PackageID"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainPackageDetails: {
                shape: "Sm"
              }
            }
          }
        },
        CancelServiceSoftwareUpdate: {
          http: {
            requestUri: "/2021-01-01/opensearch/serviceSoftwareUpdate/cancel"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceSoftwareOptions: {
                shape: "Sy"
              }
            }
          }
        },
        CreateDomain: {
          http: {
            requestUri: "/2021-01-01/opensearch/domain"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {},
              EngineVersion: {},
              ClusterConfig: {
                shape: "S15"
              },
              EBSOptions: {
                shape: "S1b"
              },
              AccessPolicies: {},
              SnapshotOptions: {
                shape: "S1e"
              },
              VPCOptions: {
                shape: "S1f"
              },
              CognitoOptions: {
                shape: "S1h"
              },
              EncryptionAtRestOptions: {
                shape: "S1l"
              },
              NodeToNodeEncryptionOptions: {
                shape: "S1n"
              },
              AdvancedOptions: {
                shape: "S1o"
              },
              LogPublishingOptions: {
                shape: "S1p"
              },
              DomainEndpointOptions: {
                shape: "S1t"
              },
              AdvancedSecurityOptions: {
                shape: "S1w"
              },
              TagList: {
                shape: "Sf"
              },
              AutoTuneOptions: {
                type: "structure",
                members: {
                  DesiredState: {},
                  MaintenanceSchedules: {
                    shape: "S27"
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainStatus: {
                shape: "S2e"
              }
            }
          }
        },
        CreateOutboundConnection: {
          http: {
            requestUri: "/2021-01-01/opensearch/cc/outboundConnection"
          },
          input: {
            type: "structure",
            required: [
              "LocalDomainInfo",
              "RemoteDomainInfo",
              "ConnectionAlias"
            ],
            members: {
              LocalDomainInfo: {
                shape: "S5"
              },
              RemoteDomainInfo: {
                shape: "S5"
              },
              ConnectionAlias: {}
            }
          },
          output: {
            type: "structure",
            members: {
              LocalDomainInfo: {
                shape: "S5"
              },
              RemoteDomainInfo: {
                shape: "S5"
              },
              ConnectionAlias: {},
              ConnectionStatus: {
                shape: "S2q"
              },
              ConnectionId: {}
            }
          }
        },
        CreatePackage: {
          http: {
            requestUri: "/2021-01-01/packages"
          },
          input: {
            type: "structure",
            required: [
              "PackageName",
              "PackageType",
              "PackageSource"
            ],
            members: {
              PackageName: {},
              PackageType: {},
              PackageDescription: {},
              PackageSource: {
                shape: "S2u"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PackageDetails: {
                shape: "S2y"
              }
            }
          }
        },
        DeleteDomain: {
          http: {
            method: "DELETE",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainStatus: {
                shape: "S2e"
              }
            }
          }
        },
        DeleteInboundConnection: {
          http: {
            method: "DELETE",
            requestUri: "/2021-01-01/opensearch/cc/inboundConnection/{ConnectionId}"
          },
          input: {
            type: "structure",
            required: [
              "ConnectionId"
            ],
            members: {
              ConnectionId: {
                location: "uri",
                locationName: "ConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "S4"
              }
            }
          }
        },
        DeleteOutboundConnection: {
          http: {
            method: "DELETE",
            requestUri: "/2021-01-01/opensearch/cc/outboundConnection/{ConnectionId}"
          },
          input: {
            type: "structure",
            required: [
              "ConnectionId"
            ],
            members: {
              ConnectionId: {
                location: "uri",
                locationName: "ConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "S37"
              }
            }
          }
        },
        DeletePackage: {
          http: {
            method: "DELETE",
            requestUri: "/2021-01-01/packages/{PackageID}"
          },
          input: {
            type: "structure",
            required: [
              "PackageID"
            ],
            members: {
              PackageID: {
                location: "uri",
                locationName: "PackageID"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PackageDetails: {
                shape: "S2y"
              }
            }
          }
        },
        DescribeDomain: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainStatus"
            ],
            members: {
              DomainStatus: {
                shape: "S2e"
              }
            }
          }
        },
        DescribeDomainAutoTunes: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/autoTunes"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AutoTunes: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    AutoTuneType: {},
                    AutoTuneDetails: {
                      type: "structure",
                      members: {
                        ScheduledAutoTuneDetails: {
                          type: "structure",
                          members: {
                            Date: {
                              type: "timestamp"
                            },
                            ActionType: {},
                            Action: {},
                            Severity: {}
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeDomainConfig: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/config"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainConfig"
            ],
            members: {
              DomainConfig: {
                shape: "S3r"
              }
            }
          }
        },
        DescribeDomains: {
          http: {
            requestUri: "/2021-01-01/opensearch/domain-info"
          },
          input: {
            type: "structure",
            required: [
              "DomainNames"
            ],
            members: {
              DomainNames: {
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainStatusList"
            ],
            members: {
              DomainStatusList: {
                type: "list",
                member: {
                  shape: "S2e"
                }
              }
            }
          }
        },
        DescribeInboundConnections: {
          http: {
            requestUri: "/2021-01-01/opensearch/cc/inboundConnection/search"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4i"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Connections: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeInstanceTypeLimits: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/instanceTypeLimits/{EngineVersion}/{InstanceType}"
          },
          input: {
            type: "structure",
            required: [
              "InstanceType",
              "EngineVersion"
            ],
            members: {
              DomainName: {
                location: "querystring",
                locationName: "domainName"
              },
              InstanceType: {
                location: "uri",
                locationName: "InstanceType"
              },
              EngineVersion: {
                location: "uri",
                locationName: "EngineVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              LimitsByRole: {
                type: "map",
                key: {},
                value: {
                  type: "structure",
                  members: {
                    StorageTypes: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          StorageTypeName: {},
                          StorageSubTypeName: {},
                          StorageTypeLimits: {
                            type: "list",
                            member: {
                              type: "structure",
                              members: {
                                LimitName: {},
                                LimitValues: {
                                  shape: "S50"
                                }
                              }
                            }
                          }
                        }
                      }
                    },
                    InstanceLimits: {
                      type: "structure",
                      members: {
                        InstanceCountLimits: {
                          type: "structure",
                          members: {
                            MinimumInstanceCount: {
                              type: "integer"
                            },
                            MaximumInstanceCount: {
                              type: "integer"
                            }
                          }
                        }
                      }
                    },
                    AdditionalLimits: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          LimitName: {},
                          LimitValues: {
                            shape: "S50"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        DescribeOutboundConnections: {
          http: {
            requestUri: "/2021-01-01/opensearch/cc/outboundConnection/search"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                shape: "S4i"
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Connections: {
                type: "list",
                member: {
                  shape: "S37"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribePackages: {
          http: {
            requestUri: "/2021-01-01/packages/describe"
          },
          input: {
            type: "structure",
            members: {
              Filters: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Name: {},
                    Value: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PackageDetailsList: {
                type: "list",
                member: {
                  shape: "S2y"
                }
              },
              NextToken: {}
            }
          }
        },
        DescribeReservedInstanceOfferings: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/reservedInstanceOfferings"
          },
          input: {
            type: "structure",
            members: {
              ReservedInstanceOfferingId: {
                location: "querystring",
                locationName: "offeringId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ReservedInstanceOfferings: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReservedInstanceOfferingId: {},
                    InstanceType: {},
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    UsagePrice: {
                      type: "double"
                    },
                    CurrencyCode: {},
                    PaymentOption: {},
                    RecurringCharges: {
                      shape: "S5r"
                    }
                  }
                }
              }
            }
          }
        },
        DescribeReservedInstances: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/reservedInstances"
          },
          input: {
            type: "structure",
            members: {
              ReservedInstanceId: {
                location: "querystring",
                locationName: "reservationId"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              ReservedInstances: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    ReservationName: {},
                    ReservedInstanceId: {},
                    BillingSubscriptionId: {
                      type: "long"
                    },
                    ReservedInstanceOfferingId: {},
                    InstanceType: {},
                    StartTime: {
                      type: "timestamp"
                    },
                    Duration: {
                      type: "integer"
                    },
                    FixedPrice: {
                      type: "double"
                    },
                    UsagePrice: {
                      type: "double"
                    },
                    CurrencyCode: {},
                    InstanceCount: {
                      type: "integer"
                    },
                    State: {},
                    PaymentOption: {},
                    RecurringCharges: {
                      shape: "S5r"
                    }
                  }
                }
              }
            }
          }
        },
        DissociatePackage: {
          http: {
            requestUri: "/2021-01-01/packages/dissociate/{PackageID}/{DomainName}"
          },
          input: {
            type: "structure",
            required: [
              "PackageID",
              "DomainName"
            ],
            members: {
              PackageID: {
                location: "uri",
                locationName: "PackageID"
              },
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainPackageDetails: {
                shape: "Sm"
              }
            }
          }
        },
        GetCompatibleVersions: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/compatibleVersions"
          },
          input: {
            type: "structure",
            members: {
              DomainName: {
                location: "querystring",
                locationName: "domainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              CompatibleVersions: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    SourceVersion: {},
                    TargetVersions: {
                      shape: "S65"
                    }
                  }
                }
              }
            }
          }
        },
        GetPackageVersionHistory: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/packages/{PackageID}/history"
          },
          input: {
            type: "structure",
            required: [
              "PackageID"
            ],
            members: {
              PackageID: {
                location: "uri",
                locationName: "PackageID"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              PackageID: {},
              PackageVersionHistoryList: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    PackageVersion: {},
                    CommitMessage: {},
                    CreatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetUpgradeHistory: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/upgradeDomain/{DomainName}/history"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpgradeHistories: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    UpgradeName: {},
                    StartTimestamp: {
                      type: "timestamp"
                    },
                    UpgradeStatus: {},
                    StepsList: {
                      type: "list",
                      member: {
                        type: "structure",
                        members: {
                          UpgradeStep: {},
                          UpgradeStepStatus: {},
                          Issues: {
                            type: "list",
                            member: {}
                          },
                          ProgressPercent: {
                            type: "double"
                          }
                        }
                      }
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        GetUpgradeStatus: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/upgradeDomain/{DomainName}/status"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpgradeStep: {},
              StepStatus: {},
              UpgradeName: {}
            }
          }
        },
        ListDomainNames: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/domain"
          },
          input: {
            type: "structure",
            members: {
              EngineType: {
                location: "querystring",
                locationName: "engineType"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainNames: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    DomainName: {},
                    EngineType: {}
                  }
                }
              }
            }
          }
        },
        ListDomainsForPackage: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/packages/{PackageID}/domains"
          },
          input: {
            type: "structure",
            required: [
              "PackageID"
            ],
            members: {
              PackageID: {
                location: "uri",
                locationName: "PackageID"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainPackageDetailsList: {
                shape: "S6w"
              },
              NextToken: {}
            }
          }
        },
        ListInstanceTypeDetails: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/instanceTypeDetails/{EngineVersion}"
          },
          input: {
            type: "structure",
            required: [
              "EngineVersion"
            ],
            members: {
              EngineVersion: {
                location: "uri",
                locationName: "EngineVersion"
              },
              DomainName: {
                location: "querystring",
                locationName: "domainName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              InstanceTypeDetails: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    InstanceType: {},
                    EncryptionEnabled: {
                      type: "boolean"
                    },
                    CognitoEnabled: {
                      type: "boolean"
                    },
                    AppLogsEnabled: {
                      type: "boolean"
                    },
                    AdvancedSecurityEnabled: {
                      type: "boolean"
                    },
                    WarmEnabled: {
                      type: "boolean"
                    },
                    InstanceRole: {
                      type: "list",
                      member: {}
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListPackagesForDomain: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/domain/{DomainName}/packages"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              DomainPackageDetailsList: {
                shape: "S6w"
              },
              NextToken: {}
            }
          }
        },
        ListTags: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/tags/"
          },
          input: {
            type: "structure",
            required: [
              "ARN"
            ],
            members: {
              ARN: {
                location: "querystring",
                locationName: "arn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TagList: {
                shape: "Sf"
              }
            }
          }
        },
        ListVersions: {
          http: {
            method: "GET",
            requestUri: "/2021-01-01/opensearch/versions"
          },
          input: {
            type: "structure",
            members: {
              MaxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              NextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Versions: {
                shape: "S65"
              },
              NextToken: {}
            }
          }
        },
        PurchaseReservedInstanceOffering: {
          http: {
            requestUri: "/2021-01-01/opensearch/purchaseReservedInstanceOffering"
          },
          input: {
            type: "structure",
            required: [
              "ReservedInstanceOfferingId",
              "ReservationName"
            ],
            members: {
              ReservedInstanceOfferingId: {},
              ReservationName: {},
              InstanceCount: {
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ReservedInstanceId: {},
              ReservationName: {}
            }
          }
        },
        RejectInboundConnection: {
          http: {
            method: "PUT",
            requestUri: "/2021-01-01/opensearch/cc/inboundConnection/{ConnectionId}/reject"
          },
          input: {
            type: "structure",
            required: [
              "ConnectionId"
            ],
            members: {
              ConnectionId: {
                location: "uri",
                locationName: "ConnectionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Connection: {
                shape: "S4"
              }
            }
          }
        },
        RemoveTags: {
          http: {
            requestUri: "/2021-01-01/tags-removal"
          },
          input: {
            type: "structure",
            required: [
              "ARN",
              "TagKeys"
            ],
            members: {
              ARN: {},
              TagKeys: {
                shape: "S1g"
              }
            }
          }
        },
        StartServiceSoftwareUpdate: {
          http: {
            requestUri: "/2021-01-01/opensearch/serviceSoftwareUpdate/start"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ServiceSoftwareOptions: {
                shape: "Sy"
              }
            }
          }
        },
        UpdateDomainConfig: {
          http: {
            requestUri: "/2021-01-01/opensearch/domain/{DomainName}/config"
          },
          input: {
            type: "structure",
            required: [
              "DomainName"
            ],
            members: {
              DomainName: {
                location: "uri",
                locationName: "DomainName"
              },
              ClusterConfig: {
                shape: "S15"
              },
              EBSOptions: {
                shape: "S1b"
              },
              SnapshotOptions: {
                shape: "S1e"
              },
              VPCOptions: {
                shape: "S1f"
              },
              CognitoOptions: {
                shape: "S1h"
              },
              AdvancedOptions: {
                shape: "S1o"
              },
              AccessPolicies: {},
              LogPublishingOptions: {
                shape: "S1p"
              },
              EncryptionAtRestOptions: {
                shape: "S1l"
              },
              DomainEndpointOptions: {
                shape: "S1t"
              },
              NodeToNodeEncryptionOptions: {
                shape: "S1n"
              },
              AdvancedSecurityOptions: {
                shape: "S1w"
              },
              AutoTuneOptions: {
                shape: "S4a"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "DomainConfig"
            ],
            members: {
              DomainConfig: {
                shape: "S3r"
              }
            }
          }
        },
        UpdatePackage: {
          http: {
            requestUri: "/2021-01-01/packages/update"
          },
          input: {
            type: "structure",
            required: [
              "PackageID",
              "PackageSource"
            ],
            members: {
              PackageID: {},
              PackageSource: {
                shape: "S2u"
              },
              PackageDescription: {},
              CommitMessage: {}
            }
          },
          output: {
            type: "structure",
            members: {
              PackageDetails: {
                shape: "S2y"
              }
            }
          }
        },
        UpgradeDomain: {
          http: {
            requestUri: "/2021-01-01/opensearch/upgradeDomain"
          },
          input: {
            type: "structure",
            required: [
              "DomainName",
              "TargetVersion"
            ],
            members: {
              DomainName: {},
              TargetVersion: {},
              PerformCheckOnly: {
                type: "boolean"
              },
              AdvancedOptions: {
                shape: "S1o"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              UpgradeId: {},
              DomainName: {},
              TargetVersion: {},
              PerformCheckOnly: {
                type: "boolean"
              },
              AdvancedOptions: {
                shape: "S1o"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            LocalDomainInfo: {
              shape: "S5"
            },
            RemoteDomainInfo: {
              shape: "S5"
            },
            ConnectionId: {},
            ConnectionStatus: {
              type: "structure",
              members: {
                StatusCode: {},
                Message: {}
              }
            }
          }
        },
        S5: {
          type: "structure",
          members: {
            AWSDomainInformation: {
              type: "structure",
              required: [
                "DomainName"
              ],
              members: {
                OwnerId: {},
                DomainName: {},
                Region: {}
              }
            }
          }
        },
        Sf: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {},
              Value: {}
            }
          }
        },
        Sm: {
          type: "structure",
          members: {
            PackageID: {},
            PackageName: {},
            PackageType: {},
            LastUpdated: {
              type: "timestamp"
            },
            DomainName: {},
            DomainPackageStatus: {},
            PackageVersion: {},
            ReferencePath: {},
            ErrorDetails: {
              shape: "St"
            }
          }
        },
        St: {
          type: "structure",
          members: {
            ErrorType: {},
            ErrorMessage: {}
          }
        },
        Sy: {
          type: "structure",
          members: {
            CurrentVersion: {},
            NewVersion: {},
            UpdateAvailable: {
              type: "boolean"
            },
            Cancellable: {
              type: "boolean"
            },
            UpdateStatus: {},
            Description: {},
            AutomatedUpdateDate: {
              type: "timestamp"
            },
            OptionalDeployment: {
              type: "boolean"
            }
          }
        },
        S15: {
          type: "structure",
          members: {
            InstanceType: {},
            InstanceCount: {
              type: "integer"
            },
            DedicatedMasterEnabled: {
              type: "boolean"
            },
            ZoneAwarenessEnabled: {
              type: "boolean"
            },
            ZoneAwarenessConfig: {
              type: "structure",
              members: {
                AvailabilityZoneCount: {
                  type: "integer"
                }
              }
            },
            DedicatedMasterType: {},
            DedicatedMasterCount: {
              type: "integer"
            },
            WarmEnabled: {
              type: "boolean"
            },
            WarmType: {},
            WarmCount: {
              type: "integer"
            },
            ColdStorageOptions: {
              type: "structure",
              required: [
                "Enabled"
              ],
              members: {
                Enabled: {
                  type: "boolean"
                }
              }
            }
          }
        },
        S1b: {
          type: "structure",
          members: {
            EBSEnabled: {
              type: "boolean"
            },
            VolumeType: {},
            VolumeSize: {
              type: "integer"
            },
            Iops: {
              type: "integer"
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            AutomatedSnapshotStartHour: {
              type: "integer"
            }
          }
        },
        S1f: {
          type: "structure",
          members: {
            SubnetIds: {
              shape: "S1g"
            },
            SecurityGroupIds: {
              shape: "S1g"
            }
          }
        },
        S1g: {
          type: "list",
          member: {}
        },
        S1h: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            UserPoolId: {},
            IdentityPoolId: {},
            RoleArn: {}
          }
        },
        S1l: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            KmsKeyId: {}
          }
        },
        S1n: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            }
          }
        },
        S1o: {
          type: "map",
          key: {},
          value: {}
        },
        S1p: {
          type: "map",
          key: {},
          value: {
            type: "structure",
            members: {
              CloudWatchLogsLogGroupArn: {},
              Enabled: {
                type: "boolean"
              }
            }
          }
        },
        S1t: {
          type: "structure",
          members: {
            EnforceHTTPS: {
              type: "boolean"
            },
            TLSSecurityPolicy: {},
            CustomEndpointEnabled: {
              type: "boolean"
            },
            CustomEndpoint: {},
            CustomEndpointCertificateArn: {}
          }
        },
        S1w: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            InternalUserDatabaseEnabled: {
              type: "boolean"
            },
            MasterUserOptions: {
              type: "structure",
              members: {
                MasterUserARN: {},
                MasterUserName: {
                  shape: "S1y"
                },
                MasterUserPassword: {
                  type: "string",
                  sensitive: true
                }
              }
            },
            SAMLOptions: {
              type: "structure",
              members: {
                Enabled: {
                  type: "boolean"
                },
                Idp: {
                  shape: "S21"
                },
                MasterUserName: {
                  shape: "S1y"
                },
                MasterBackendRole: {},
                SubjectKey: {},
                RolesKey: {},
                SessionTimeoutMinutes: {
                  type: "integer"
                }
              }
            }
          }
        },
        S1y: {
          type: "string",
          sensitive: true
        },
        S21: {
          type: "structure",
          required: [
            "MetadataContent",
            "EntityId"
          ],
          members: {
            MetadataContent: {},
            EntityId: {}
          }
        },
        S27: {
          type: "list",
          member: {
            type: "structure",
            members: {
              StartAt: {
                type: "timestamp"
              },
              Duration: {
                type: "structure",
                members: {
                  Value: {
                    type: "long"
                  },
                  Unit: {}
                }
              },
              CronExpressionForRecurrence: {}
            }
          }
        },
        S2e: {
          type: "structure",
          required: [
            "DomainId",
            "DomainName",
            "ARN",
            "ClusterConfig"
          ],
          members: {
            DomainId: {},
            DomainName: {},
            ARN: {},
            Created: {
              type: "boolean"
            },
            Deleted: {
              type: "boolean"
            },
            Endpoint: {},
            Endpoints: {
              type: "map",
              key: {},
              value: {}
            },
            Processing: {
              type: "boolean"
            },
            UpgradeProcessing: {
              type: "boolean"
            },
            EngineVersion: {},
            ClusterConfig: {
              shape: "S15"
            },
            EBSOptions: {
              shape: "S1b"
            },
            AccessPolicies: {},
            SnapshotOptions: {
              shape: "S1e"
            },
            VPCOptions: {
              shape: "S2i"
            },
            CognitoOptions: {
              shape: "S1h"
            },
            EncryptionAtRestOptions: {
              shape: "S1l"
            },
            NodeToNodeEncryptionOptions: {
              shape: "S1n"
            },
            AdvancedOptions: {
              shape: "S1o"
            },
            LogPublishingOptions: {
              shape: "S1p"
            },
            ServiceSoftwareOptions: {
              shape: "Sy"
            },
            DomainEndpointOptions: {
              shape: "S1t"
            },
            AdvancedSecurityOptions: {
              shape: "S2j"
            },
            AutoTuneOptions: {
              type: "structure",
              members: {
                State: {},
                ErrorMessage: {}
              }
            }
          }
        },
        S2i: {
          type: "structure",
          members: {
            VPCId: {},
            SubnetIds: {
              shape: "S1g"
            },
            AvailabilityZones: {
              shape: "S1g"
            },
            SecurityGroupIds: {
              shape: "S1g"
            }
          }
        },
        S2j: {
          type: "structure",
          members: {
            Enabled: {
              type: "boolean"
            },
            InternalUserDatabaseEnabled: {
              type: "boolean"
            },
            SAMLOptions: {
              type: "structure",
              members: {
                Enabled: {
                  type: "boolean"
                },
                Idp: {
                  shape: "S21"
                },
                SubjectKey: {},
                RolesKey: {},
                SessionTimeoutMinutes: {
                  type: "integer"
                }
              }
            }
          }
        },
        S2q: {
          type: "structure",
          members: {
            StatusCode: {},
            Message: {}
          }
        },
        S2u: {
          type: "structure",
          members: {
            S3BucketName: {},
            S3Key: {}
          }
        },
        S2y: {
          type: "structure",
          members: {
            PackageID: {},
            PackageName: {},
            PackageType: {},
            PackageDescription: {},
            PackageStatus: {},
            CreatedAt: {
              type: "timestamp"
            },
            LastUpdatedAt: {
              type: "timestamp"
            },
            AvailablePackageVersion: {},
            ErrorDetails: {
              shape: "St"
            }
          }
        },
        S37: {
          type: "structure",
          members: {
            LocalDomainInfo: {
              shape: "S5"
            },
            RemoteDomainInfo: {
              shape: "S5"
            },
            ConnectionId: {},
            ConnectionAlias: {},
            ConnectionStatus: {
              shape: "S2q"
            }
          }
        },
        S3r: {
          type: "structure",
          members: {
            EngineVersion: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {},
                Status: {
                  shape: "S3t"
                }
              }
            },
            ClusterConfig: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S15"
                },
                Status: {
                  shape: "S3t"
                }
              }
            },
            EBSOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1b"
                },
                Status: {
                  shape: "S3t"
                }
              }
            },
            AccessPolicies: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {},
                Status: {
                  shape: "S3t"
                }
              }
            },
            SnapshotOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1e"
                },
                Status: {
                  shape: "S3t"
                }
              }
            },
            VPCOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S2i"
                },
                Status: {
                  shape: "S3t"
                }
              }
            },
            CognitoOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1h"
                },
                Status: {
                  shape: "S3t"
                }
              }
            },
            EncryptionAtRestOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1l"
                },
                Status: {
                  shape: "S3t"
                }
              }
            },
            NodeToNodeEncryptionOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1n"
                },
                Status: {
                  shape: "S3t"
                }
              }
            },
            AdvancedOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1o"
                },
                Status: {
                  shape: "S3t"
                }
              }
            },
            LogPublishingOptions: {
              type: "structure",
              members: {
                Options: {
                  shape: "S1p"
                },
                Status: {
                  shape: "S3t"
                }
              }
            },
            DomainEndpointOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S1t"
                },
                Status: {
                  shape: "S3t"
                }
              }
            },
            AdvancedSecurityOptions: {
              type: "structure",
              required: [
                "Options",
                "Status"
              ],
              members: {
                Options: {
                  shape: "S2j"
                },
                Status: {
                  shape: "S3t"
                }
              }
            },
            AutoTuneOptions: {
              type: "structure",
              members: {
                Options: {
                  shape: "S4a"
                },
                Status: {
                  type: "structure",
                  required: [
                    "CreationDate",
                    "UpdateDate",
                    "State"
                  ],
                  members: {
                    CreationDate: {
                      type: "timestamp"
                    },
                    UpdateDate: {
                      type: "timestamp"
                    },
                    UpdateVersion: {
                      type: "integer"
                    },
                    State: {},
                    ErrorMessage: {},
                    PendingDeletion: {
                      type: "boolean"
                    }
                  }
                }
              }
            }
          }
        },
        S3t: {
          type: "structure",
          required: [
            "CreationDate",
            "UpdateDate",
            "State"
          ],
          members: {
            CreationDate: {
              type: "timestamp"
            },
            UpdateDate: {
              type: "timestamp"
            },
            UpdateVersion: {
              type: "integer"
            },
            State: {},
            PendingDeletion: {
              type: "boolean"
            }
          }
        },
        S4a: {
          type: "structure",
          members: {
            DesiredState: {},
            RollbackOnDisable: {},
            MaintenanceSchedules: {
              shape: "S27"
            }
          }
        },
        S4i: {
          type: "list",
          member: {
            type: "structure",
            members: {
              Name: {},
              Values: {
                type: "list",
                member: {}
              }
            }
          }
        },
        S50: {
          type: "list",
          member: {}
        },
        S5r: {
          type: "list",
          member: {
            type: "structure",
            members: {
              RecurringChargeAmount: {
                type: "double"
              },
              RecurringChargeFrequency: {}
            }
          }
        },
        S65: {
          type: "list",
          member: {}
        },
        S6w: {
          type: "list",
          member: {
            shape: "Sm"
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/opensearch-2021-01-01.paginators.json
var require_opensearch_2021_01_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/opensearch-2021-01-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        DescribeDomainAutoTunes: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeInboundConnections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeOutboundConnections: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribePackages: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeReservedInstanceOfferings: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        DescribeReservedInstances: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        GetPackageVersionHistory: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        GetUpgradeHistory: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListDomainsForPackage: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListInstanceTypeDetails: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListPackagesForDomain: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListVersions: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/opensearch.js
var require_opensearch = __commonJS({
  "node_modules/aws-sdk/clients/opensearch.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["opensearch"] = {};
    AWS3.OpenSearch = Service.defineService("opensearch", ["2021-01-01"]);
    Object.defineProperty(apiLoader.services["opensearch"], "2021-01-01", {
      get: function get() {
        var model = require_opensearch_2021_01_01_min();
        model.paginators = require_opensearch_2021_01_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.OpenSearch;
  }
});

// node_modules/aws-sdk/apis/kafkaconnect-2021-09-14.min.json
var require_kafkaconnect_2021_09_14_min = __commonJS({
  "node_modules/aws-sdk/apis/kafkaconnect-2021-09-14.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-09-14",
        endpointPrefix: "kafkaconnect",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceAbbreviation: "Kafka Connect",
        serviceFullName: "Managed Streaming for Kafka Connect",
        serviceId: "KafkaConnect",
        signatureVersion: "v4",
        signingName: "kafkaconnect",
        uid: "kafkaconnect-2021-09-14"
      },
      operations: {
        CreateConnector: {
          http: {
            requestUri: "/v1/connectors",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "capacity",
              "connectorConfiguration",
              "connectorName",
              "kafkaCluster",
              "kafkaClusterClientAuthentication",
              "kafkaClusterEncryptionInTransit",
              "kafkaConnectVersion",
              "plugins",
              "serviceExecutionRoleArn"
            ],
            members: {
              capacity: {
                type: "structure",
                members: {
                  autoScaling: {
                    type: "structure",
                    required: [
                      "maxWorkerCount",
                      "mcuCount",
                      "minWorkerCount"
                    ],
                    members: {
                      maxWorkerCount: {
                        type: "integer"
                      },
                      mcuCount: {
                        type: "integer"
                      },
                      minWorkerCount: {
                        type: "integer"
                      },
                      scaleInPolicy: {
                        type: "structure",
                        required: [
                          "cpuUtilizationPercentage"
                        ],
                        members: {
                          cpuUtilizationPercentage: {
                            type: "integer"
                          }
                        }
                      },
                      scaleOutPolicy: {
                        type: "structure",
                        required: [
                          "cpuUtilizationPercentage"
                        ],
                        members: {
                          cpuUtilizationPercentage: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  },
                  provisionedCapacity: {
                    type: "structure",
                    required: [
                      "mcuCount",
                      "workerCount"
                    ],
                    members: {
                      mcuCount: {
                        type: "integer"
                      },
                      workerCount: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              connectorConfiguration: {
                shape: "Sa"
              },
              connectorDescription: {},
              connectorName: {},
              kafkaCluster: {
                type: "structure",
                required: [
                  "apacheKafkaCluster"
                ],
                members: {
                  apacheKafkaCluster: {
                    type: "structure",
                    required: [
                      "bootstrapServers",
                      "vpc"
                    ],
                    members: {
                      bootstrapServers: {},
                      vpc: {
                        type: "structure",
                        required: [
                          "subnets"
                        ],
                        members: {
                          securityGroups: {
                            shape: "Sh"
                          },
                          subnets: {
                            shape: "Sh"
                          }
                        }
                      }
                    }
                  }
                }
              },
              kafkaClusterClientAuthentication: {
                type: "structure",
                required: [
                  "authenticationType"
                ],
                members: {
                  authenticationType: {}
                }
              },
              kafkaClusterEncryptionInTransit: {
                type: "structure",
                required: [
                  "encryptionType"
                ],
                members: {
                  encryptionType: {}
                }
              },
              kafkaConnectVersion: {},
              logDelivery: {
                type: "structure",
                required: [
                  "workerLogDelivery"
                ],
                members: {
                  workerLogDelivery: {
                    type: "structure",
                    members: {
                      cloudWatchLogs: {
                        type: "structure",
                        required: [
                          "enabled"
                        ],
                        members: {
                          enabled: {
                            type: "boolean"
                          },
                          logGroup: {}
                        }
                      },
                      firehose: {
                        type: "structure",
                        required: [
                          "enabled"
                        ],
                        members: {
                          deliveryStream: {},
                          enabled: {
                            type: "boolean"
                          }
                        }
                      },
                      s3: {
                        type: "structure",
                        required: [
                          "enabled"
                        ],
                        members: {
                          bucket: {},
                          enabled: {
                            type: "boolean"
                          },
                          prefix: {}
                        }
                      }
                    }
                  }
                }
              },
              plugins: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "customPlugin"
                  ],
                  members: {
                    customPlugin: {
                      type: "structure",
                      required: [
                        "customPluginArn",
                        "revision"
                      ],
                      members: {
                        customPluginArn: {},
                        revision: {
                          type: "long"
                        }
                      }
                    }
                  }
                }
              },
              serviceExecutionRoleArn: {},
              workerConfiguration: {
                type: "structure",
                required: [
                  "revision",
                  "workerConfigurationArn"
                ],
                members: {
                  revision: {
                    type: "long"
                  },
                  workerConfigurationArn: {}
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              connectorArn: {},
              connectorName: {},
              connectorState: {}
            }
          }
        },
        CreateCustomPlugin: {
          http: {
            requestUri: "/v1/custom-plugins",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contentType",
              "location",
              "name"
            ],
            members: {
              contentType: {},
              description: {},
              location: {
                type: "structure",
                required: [
                  "s3Location"
                ],
                members: {
                  s3Location: {
                    type: "structure",
                    required: [
                      "bucketArn",
                      "fileKey"
                    ],
                    members: {
                      bucketArn: {},
                      fileKey: {},
                      objectVersion: {}
                    }
                  }
                }
              },
              name: {}
            }
          },
          output: {
            type: "structure",
            members: {
              customPluginArn: {},
              customPluginState: {},
              name: {},
              revision: {
                type: "long"
              }
            }
          }
        },
        CreateWorkerConfiguration: {
          http: {
            requestUri: "/v1/worker-configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "propertiesFileContent"
            ],
            members: {
              description: {},
              name: {},
              propertiesFileContent: {}
            }
          },
          output: {
            type: "structure",
            members: {
              creationTime: {
                shape: "S18"
              },
              latestRevision: {
                shape: "S19"
              },
              name: {},
              workerConfigurationArn: {}
            }
          }
        },
        DeleteConnector: {
          http: {
            method: "DELETE",
            requestUri: "/v1/connectors/{connectorArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "connectorArn"
            ],
            members: {
              connectorArn: {
                location: "uri",
                locationName: "connectorArn"
              },
              currentVersion: {
                location: "querystring",
                locationName: "currentVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              connectorArn: {},
              connectorState: {}
            }
          },
          idempotent: true
        },
        DescribeConnector: {
          http: {
            method: "GET",
            requestUri: "/v1/connectors/{connectorArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "connectorArn"
            ],
            members: {
              connectorArn: {
                location: "uri",
                locationName: "connectorArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              capacity: {
                shape: "S1e"
              },
              connectorArn: {},
              connectorConfiguration: {
                shape: "Sa"
              },
              connectorDescription: {},
              connectorName: {},
              connectorState: {},
              creationTime: {
                shape: "S18"
              },
              currentVersion: {},
              kafkaCluster: {
                shape: "S1k"
              },
              kafkaClusterClientAuthentication: {
                shape: "S1n"
              },
              kafkaClusterEncryptionInTransit: {
                shape: "S1o"
              },
              kafkaConnectVersion: {},
              logDelivery: {
                shape: "S1p"
              },
              plugins: {
                shape: "S1u"
              },
              serviceExecutionRoleArn: {},
              workerConfiguration: {
                shape: "S1x"
              }
            }
          }
        },
        DescribeCustomPlugin: {
          http: {
            method: "GET",
            requestUri: "/v1/custom-plugins/{customPluginArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "customPluginArn"
            ],
            members: {
              customPluginArn: {
                location: "uri",
                locationName: "customPluginArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              creationTime: {
                shape: "S18"
              },
              customPluginArn: {},
              customPluginState: {},
              description: {},
              latestRevision: {
                shape: "S20"
              },
              name: {}
            }
          }
        },
        DescribeWorkerConfiguration: {
          http: {
            method: "GET",
            requestUri: "/v1/worker-configurations/{workerConfigurationArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workerConfigurationArn"
            ],
            members: {
              workerConfigurationArn: {
                location: "uri",
                locationName: "workerConfigurationArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              creationTime: {
                shape: "S18"
              },
              description: {},
              latestRevision: {
                type: "structure",
                members: {
                  creationTime: {
                    shape: "S18"
                  },
                  description: {},
                  propertiesFileContent: {},
                  revision: {
                    type: "long"
                  }
                }
              },
              name: {},
              workerConfigurationArn: {}
            }
          }
        },
        ListConnectors: {
          http: {
            method: "GET",
            requestUri: "/v1/connectors",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              connectorNamePrefix: {
                location: "querystring",
                locationName: "connectorNamePrefix"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              connectors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    capacity: {
                      shape: "S1e"
                    },
                    connectorArn: {},
                    connectorDescription: {},
                    connectorName: {},
                    connectorState: {},
                    creationTime: {
                      shape: "S18"
                    },
                    currentVersion: {},
                    kafkaCluster: {
                      shape: "S1k"
                    },
                    kafkaClusterClientAuthentication: {
                      shape: "S1n"
                    },
                    kafkaClusterEncryptionInTransit: {
                      shape: "S1o"
                    },
                    kafkaConnectVersion: {},
                    logDelivery: {
                      shape: "S1p"
                    },
                    plugins: {
                      shape: "S1u"
                    },
                    serviceExecutionRoleArn: {},
                    workerConfiguration: {
                      shape: "S1x"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListCustomPlugins: {
          http: {
            method: "GET",
            requestUri: "/v1/custom-plugins",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              customPlugins: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    creationTime: {
                      shape: "S18"
                    },
                    customPluginArn: {},
                    customPluginState: {},
                    description: {},
                    latestRevision: {
                      shape: "S20"
                    },
                    name: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListWorkerConfigurations: {
          http: {
            method: "GET",
            requestUri: "/v1/worker-configurations",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              nextToken: {},
              workerConfigurations: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    creationTime: {
                      shape: "S18"
                    },
                    description: {},
                    latestRevision: {
                      shape: "S19"
                    },
                    name: {},
                    workerConfigurationArn: {}
                  }
                }
              }
            }
          }
        },
        UpdateConnector: {
          http: {
            method: "PUT",
            requestUri: "/v1/connectors/{connectorArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "capacity",
              "connectorArn",
              "currentVersion"
            ],
            members: {
              capacity: {
                type: "structure",
                members: {
                  autoScaling: {
                    type: "structure",
                    required: [
                      "maxWorkerCount",
                      "mcuCount",
                      "minWorkerCount",
                      "scaleInPolicy",
                      "scaleOutPolicy"
                    ],
                    members: {
                      maxWorkerCount: {
                        type: "integer"
                      },
                      mcuCount: {
                        type: "integer"
                      },
                      minWorkerCount: {
                        type: "integer"
                      },
                      scaleInPolicy: {
                        type: "structure",
                        required: [
                          "cpuUtilizationPercentage"
                        ],
                        members: {
                          cpuUtilizationPercentage: {
                            type: "integer"
                          }
                        }
                      },
                      scaleOutPolicy: {
                        type: "structure",
                        required: [
                          "cpuUtilizationPercentage"
                        ],
                        members: {
                          cpuUtilizationPercentage: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  },
                  provisionedCapacity: {
                    type: "structure",
                    required: [
                      "mcuCount",
                      "workerCount"
                    ],
                    members: {
                      mcuCount: {
                        type: "integer"
                      },
                      workerCount: {
                        type: "integer"
                      }
                    }
                  }
                }
              },
              connectorArn: {
                location: "uri",
                locationName: "connectorArn"
              },
              currentVersion: {
                location: "querystring",
                locationName: "currentVersion"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              connectorArn: {},
              connectorState: {}
            }
          },
          idempotent: true
        }
      },
      shapes: {
        Sa: {
          type: "map",
          key: {},
          value: {}
        },
        Sh: {
          type: "list",
          member: {}
        },
        S18: {
          type: "timestamp",
          timestampFormat: "iso8601"
        },
        S19: {
          type: "structure",
          members: {
            creationTime: {
              shape: "S18"
            },
            description: {},
            revision: {
              type: "long"
            }
          }
        },
        S1e: {
          type: "structure",
          members: {
            autoScaling: {
              type: "structure",
              members: {
                maxWorkerCount: {
                  type: "integer"
                },
                mcuCount: {
                  type: "integer"
                },
                minWorkerCount: {
                  type: "integer"
                },
                scaleInPolicy: {
                  type: "structure",
                  members: {
                    cpuUtilizationPercentage: {
                      type: "integer"
                    }
                  }
                },
                scaleOutPolicy: {
                  type: "structure",
                  members: {
                    cpuUtilizationPercentage: {
                      type: "integer"
                    }
                  }
                }
              }
            },
            provisionedCapacity: {
              type: "structure",
              members: {
                mcuCount: {
                  type: "integer"
                },
                workerCount: {
                  type: "integer"
                }
              }
            }
          }
        },
        S1k: {
          type: "structure",
          members: {
            apacheKafkaCluster: {
              type: "structure",
              members: {
                bootstrapServers: {},
                vpc: {
                  type: "structure",
                  members: {
                    securityGroups: {
                      shape: "Sh"
                    },
                    subnets: {
                      shape: "Sh"
                    }
                  }
                }
              }
            }
          }
        },
        S1n: {
          type: "structure",
          members: {
            authenticationType: {}
          }
        },
        S1o: {
          type: "structure",
          members: {
            encryptionType: {}
          }
        },
        S1p: {
          type: "structure",
          members: {
            workerLogDelivery: {
              type: "structure",
              members: {
                cloudWatchLogs: {
                  type: "structure",
                  members: {
                    enabled: {
                      type: "boolean"
                    },
                    logGroup: {}
                  }
                },
                firehose: {
                  type: "structure",
                  members: {
                    deliveryStream: {},
                    enabled: {
                      type: "boolean"
                    }
                  }
                },
                s3: {
                  type: "structure",
                  members: {
                    bucket: {},
                    enabled: {
                      type: "boolean"
                    },
                    prefix: {}
                  }
                }
              }
            }
          }
        },
        S1u: {
          type: "list",
          member: {
            type: "structure",
            members: {
              customPlugin: {
                type: "structure",
                members: {
                  customPluginArn: {},
                  revision: {
                    type: "long"
                  }
                }
              }
            }
          }
        },
        S1x: {
          type: "structure",
          members: {
            revision: {
              type: "long"
            },
            workerConfigurationArn: {}
          }
        },
        S20: {
          type: "structure",
          members: {
            contentType: {},
            creationTime: {
              shape: "S18"
            },
            description: {},
            fileDescription: {
              type: "structure",
              members: {
                fileMd5: {},
                fileSize: {
                  type: "long"
                }
              }
            },
            location: {
              type: "structure",
              members: {
                s3Location: {
                  type: "structure",
                  members: {
                    bucketArn: {},
                    fileKey: {},
                    objectVersion: {}
                  }
                }
              }
            },
            revision: {
              type: "long"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/kafkaconnect-2021-09-14.paginators.json
var require_kafkaconnect_2021_09_14_paginators = __commonJS({
  "node_modules/aws-sdk/apis/kafkaconnect-2021-09-14.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListConnectors: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "connectors"
        },
        ListCustomPlugins: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "customPlugins"
        },
        ListWorkerConfigurations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "workerConfigurations"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/kafkaconnect.js
var require_kafkaconnect = __commonJS({
  "node_modules/aws-sdk/clients/kafkaconnect.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["kafkaconnect"] = {};
    AWS3.KafkaConnect = Service.defineService("kafkaconnect", ["2021-09-14"]);
    Object.defineProperty(apiLoader.services["kafkaconnect"], "2021-09-14", {
      get: function get() {
        var model = require_kafkaconnect_2021_09_14_min();
        model.paginators = require_kafkaconnect_2021_09_14_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.KafkaConnect;
  }
});

// node_modules/aws-sdk/apis/voice-id-2021-09-27.min.json
var require_voice_id_2021_09_27_min = __commonJS({
  "node_modules/aws-sdk/apis/voice-id-2021-09-27.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-09-27",
        endpointPrefix: "voiceid",
        jsonVersion: "1.0",
        protocol: "json",
        serviceFullName: "Amazon Voice ID",
        serviceId: "Voice ID",
        signatureVersion: "v4",
        signingName: "voiceid",
        targetPrefix: "VoiceID",
        uid: "voice-id-2021-09-27"
      },
      operations: {
        CreateDomain: {
          input: {
            type: "structure",
            required: [
              "Name",
              "ServerSideEncryptionConfiguration"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              Description: {
                shape: "S3"
              },
              Name: {
                shape: "S4"
              },
              ServerSideEncryptionConfiguration: {
                shape: "S5"
              },
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Domain: {
                shape: "Sc"
              }
            }
          },
          idempotent: true
        },
        DeleteDomain: {
          input: {
            type: "structure",
            required: [
              "DomainId"
            ],
            members: {
              DomainId: {}
            }
          }
        },
        DeleteFraudster: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "FraudsterId"
            ],
            members: {
              DomainId: {},
              FraudsterId: {
                shape: "Sj"
              }
            }
          }
        },
        DeleteSpeaker: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "SpeakerId"
            ],
            members: {
              DomainId: {},
              SpeakerId: {
                shape: "Sl"
              }
            }
          }
        },
        DescribeDomain: {
          input: {
            type: "structure",
            required: [
              "DomainId"
            ],
            members: {
              DomainId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Domain: {
                shape: "Sc"
              }
            }
          }
        },
        DescribeFraudster: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "FraudsterId"
            ],
            members: {
              DomainId: {},
              FraudsterId: {
                shape: "Sj"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Fraudster: {
                type: "structure",
                members: {
                  CreatedAt: {
                    type: "timestamp"
                  },
                  DomainId: {},
                  GeneratedFraudsterId: {}
                }
              }
            }
          }
        },
        DescribeFraudsterRegistrationJob: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "JobId"
            ],
            members: {
              DomainId: {},
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Job: {
                shape: "Sv"
              }
            }
          }
        },
        DescribeSpeaker: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "SpeakerId"
            ],
            members: {
              DomainId: {},
              SpeakerId: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Speaker: {
                shape: "S1b"
              }
            }
          }
        },
        DescribeSpeakerEnrollmentJob: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "JobId"
            ],
            members: {
              DomainId: {},
              JobId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Job: {
                shape: "S1h"
              }
            }
          }
        },
        EvaluateSession: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "SessionNameOrId"
            ],
            members: {
              DomainId: {},
              SessionNameOrId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AuthenticationResult: {
                type: "structure",
                members: {
                  AudioAggregationEndedAt: {
                    type: "timestamp"
                  },
                  AudioAggregationStartedAt: {
                    type: "timestamp"
                  },
                  AuthenticationResultId: {},
                  Configuration: {
                    type: "structure",
                    required: [
                      "AcceptanceThreshold"
                    ],
                    members: {
                      AcceptanceThreshold: {
                        type: "integer"
                      }
                    }
                  },
                  CustomerSpeakerId: {
                    shape: "S1c"
                  },
                  Decision: {},
                  GeneratedSpeakerId: {},
                  Score: {
                    type: "integer"
                  }
                }
              },
              DomainId: {},
              FraudDetectionResult: {
                type: "structure",
                members: {
                  AudioAggregationEndedAt: {
                    type: "timestamp"
                  },
                  AudioAggregationStartedAt: {
                    type: "timestamp"
                  },
                  Configuration: {
                    type: "structure",
                    required: [
                      "RiskThreshold"
                    ],
                    members: {
                      RiskThreshold: {
                        type: "integer"
                      }
                    }
                  },
                  Decision: {},
                  FraudDetectionResultId: {},
                  Reasons: {
                    type: "list",
                    member: {}
                  },
                  RiskDetails: {
                    type: "structure",
                    required: [
                      "KnownFraudsterRisk"
                    ],
                    members: {
                      KnownFraudsterRisk: {
                        type: "structure",
                        required: [
                          "RiskScore"
                        ],
                        members: {
                          GeneratedFraudsterId: {},
                          RiskScore: {
                            type: "integer"
                          }
                        }
                      }
                    }
                  }
                }
              },
              SessionId: {},
              SessionName: {},
              StreamingStatus: {}
            }
          }
        },
        ListDomains: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              DomainSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    Arn: {},
                    CreatedAt: {
                      type: "timestamp"
                    },
                    Description: {
                      shape: "S3"
                    },
                    DomainId: {},
                    DomainStatus: {},
                    Name: {
                      shape: "S4"
                    },
                    ServerSideEncryptionConfiguration: {
                      shape: "S5"
                    },
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListFraudsterRegistrationJobs: {
          input: {
            type: "structure",
            required: [
              "DomainId"
            ],
            members: {
              DomainId: {},
              JobStatus: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedAt: {
                      type: "timestamp"
                    },
                    DomainId: {},
                    EndedAt: {
                      type: "timestamp"
                    },
                    FailureDetails: {
                      shape: "Sx"
                    },
                    JobId: {},
                    JobName: {
                      shape: "S12"
                    },
                    JobProgress: {
                      shape: "S13"
                    },
                    JobStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSpeakerEnrollmentJobs: {
          input: {
            type: "structure",
            required: [
              "DomainId"
            ],
            members: {
              DomainId: {},
              JobStatus: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              JobSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedAt: {
                      type: "timestamp"
                    },
                    DomainId: {},
                    EndedAt: {
                      type: "timestamp"
                    },
                    FailureDetails: {
                      shape: "Sx"
                    },
                    JobId: {},
                    JobName: {
                      shape: "S12"
                    },
                    JobProgress: {
                      shape: "S13"
                    },
                    JobStatus: {}
                  }
                }
              },
              NextToken: {}
            }
          }
        },
        ListSpeakers: {
          input: {
            type: "structure",
            required: [
              "DomainId"
            ],
            members: {
              DomainId: {},
              MaxResults: {
                type: "integer"
              },
              NextToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              NextToken: {},
              SpeakerSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    CreatedAt: {
                      type: "timestamp"
                    },
                    CustomerSpeakerId: {
                      shape: "S1c"
                    },
                    DomainId: {},
                    GeneratedSpeakerId: {},
                    Status: {},
                    UpdatedAt: {
                      type: "timestamp"
                    }
                  }
                }
              }
            }
          }
        },
        ListTagsForResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn"
            ],
            members: {
              ResourceArn: {}
            }
          },
          output: {
            type: "structure",
            members: {
              Tags: {
                shape: "S7"
              }
            }
          }
        },
        OptOutSpeaker: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "SpeakerId"
            ],
            members: {
              DomainId: {},
              SpeakerId: {
                shape: "Sl"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Speaker: {
                shape: "S1b"
              }
            }
          }
        },
        StartFraudsterRegistrationJob: {
          input: {
            type: "structure",
            required: [
              "DataAccessRoleArn",
              "DomainId",
              "InputDataConfig",
              "OutputDataConfig"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              DataAccessRoleArn: {},
              DomainId: {},
              InputDataConfig: {
                shape: "S10"
              },
              JobName: {
                shape: "S12"
              },
              OutputDataConfig: {
                shape: "S16"
              },
              RegistrationConfig: {
                shape: "S17"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Job: {
                shape: "Sv"
              }
            }
          },
          idempotent: true
        },
        StartSpeakerEnrollmentJob: {
          input: {
            type: "structure",
            required: [
              "DataAccessRoleArn",
              "DomainId",
              "InputDataConfig",
              "OutputDataConfig"
            ],
            members: {
              ClientToken: {
                idempotencyToken: true
              },
              DataAccessRoleArn: {},
              DomainId: {},
              EnrollmentConfig: {
                shape: "S1i"
              },
              InputDataConfig: {
                shape: "S10"
              },
              JobName: {
                shape: "S12"
              },
              OutputDataConfig: {
                shape: "S16"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Job: {
                shape: "S1h"
              }
            }
          },
          idempotent: true
        },
        TagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "Tags"
            ],
            members: {
              ResourceArn: {},
              Tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UntagResource: {
          input: {
            type: "structure",
            required: [
              "ResourceArn",
              "TagKeys"
            ],
            members: {
              ResourceArn: {},
              TagKeys: {
                type: "list",
                member: {
                  shape: "S9"
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        UpdateDomain: {
          input: {
            type: "structure",
            required: [
              "DomainId",
              "Name",
              "ServerSideEncryptionConfiguration"
            ],
            members: {
              Description: {
                shape: "S3"
              },
              DomainId: {},
              Name: {
                shape: "S4"
              },
              ServerSideEncryptionConfiguration: {
                shape: "S5"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              Domain: {
                shape: "Sc"
              }
            }
          }
        }
      },
      shapes: {
        S3: {
          type: "string",
          sensitive: true
        },
        S4: {
          type: "string",
          sensitive: true
        },
        S5: {
          type: "structure",
          required: [
            "KmsKeyId"
          ],
          members: {
            KmsKeyId: {}
          }
        },
        S7: {
          type: "list",
          member: {
            type: "structure",
            required: [
              "Key",
              "Value"
            ],
            members: {
              Key: {
                shape: "S9"
              },
              Value: {
                type: "string",
                sensitive: true
              }
            }
          }
        },
        S9: {
          type: "string",
          sensitive: true
        },
        Sc: {
          type: "structure",
          members: {
            Arn: {},
            CreatedAt: {
              type: "timestamp"
            },
            Description: {
              shape: "S3"
            },
            DomainId: {},
            DomainStatus: {},
            Name: {
              shape: "S4"
            },
            ServerSideEncryptionConfiguration: {
              shape: "S5"
            },
            UpdatedAt: {
              type: "timestamp"
            }
          }
        },
        Sj: {
          type: "string",
          sensitive: true
        },
        Sl: {
          type: "string",
          sensitive: true
        },
        Sv: {
          type: "structure",
          members: {
            CreatedAt: {
              type: "timestamp"
            },
            DataAccessRoleArn: {},
            DomainId: {},
            EndedAt: {
              type: "timestamp"
            },
            FailureDetails: {
              shape: "Sx"
            },
            InputDataConfig: {
              shape: "S10"
            },
            JobId: {},
            JobName: {
              shape: "S12"
            },
            JobProgress: {
              shape: "S13"
            },
            JobStatus: {},
            OutputDataConfig: {
              shape: "S16"
            },
            RegistrationConfig: {
              shape: "S17"
            }
          }
        },
        Sx: {
          type: "structure",
          members: {
            Message: {},
            StatusCode: {
              type: "integer"
            }
          }
        },
        S10: {
          type: "structure",
          required: [
            "S3Uri"
          ],
          members: {
            S3Uri: {}
          }
        },
        S12: {
          type: "string",
          sensitive: true
        },
        S13: {
          type: "structure",
          members: {
            PercentComplete: {
              type: "integer"
            }
          }
        },
        S16: {
          type: "structure",
          required: [
            "S3Uri"
          ],
          members: {
            KmsKeyId: {},
            S3Uri: {}
          }
        },
        S17: {
          type: "structure",
          members: {
            DuplicateRegistrationAction: {},
            FraudsterSimilarityThreshold: {
              type: "integer"
            }
          }
        },
        S1b: {
          type: "structure",
          members: {
            CreatedAt: {
              type: "timestamp"
            },
            CustomerSpeakerId: {
              shape: "S1c"
            },
            DomainId: {},
            GeneratedSpeakerId: {},
            Status: {},
            UpdatedAt: {
              type: "timestamp"
            }
          }
        },
        S1c: {
          type: "string",
          sensitive: true
        },
        S1h: {
          type: "structure",
          members: {
            CreatedAt: {
              type: "timestamp"
            },
            DataAccessRoleArn: {},
            DomainId: {},
            EndedAt: {
              type: "timestamp"
            },
            EnrollmentConfig: {
              shape: "S1i"
            },
            FailureDetails: {
              shape: "Sx"
            },
            InputDataConfig: {
              shape: "S10"
            },
            JobId: {},
            JobName: {
              shape: "S12"
            },
            JobProgress: {
              shape: "S13"
            },
            JobStatus: {},
            OutputDataConfig: {
              shape: "S16"
            }
          }
        },
        S1i: {
          type: "structure",
          members: {
            ExistingEnrollmentAction: {},
            FraudDetectionConfig: {
              type: "structure",
              members: {
                FraudDetectionAction: {},
                RiskThreshold: {
                  type: "integer"
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/voice-id-2021-09-27.paginators.json
var require_voice_id_2021_09_27_paginators = __commonJS({
  "node_modules/aws-sdk/apis/voice-id-2021-09-27.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListDomains: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListFraudsterRegistrationJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSpeakerEnrollmentJobs: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListSpeakers: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/voiceid.js
var require_voiceid = __commonJS({
  "node_modules/aws-sdk/clients/voiceid.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["voiceid"] = {};
    AWS3.VoiceID = Service.defineService("voiceid", ["2021-09-27"]);
    Object.defineProperty(apiLoader.services["voiceid"], "2021-09-27", {
      get: function get() {
        var model = require_voice_id_2021_09_27_min();
        model.paginators = require_voice_id_2021_09_27_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.VoiceID;
  }
});

// node_modules/aws-sdk/apis/wisdom-2020-10-19.min.json
var require_wisdom_2020_10_19_min = __commonJS({
  "node_modules/aws-sdk/apis/wisdom-2020-10-19.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-10-19",
        endpointPrefix: "wisdom",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Connect Wisdom Service",
        serviceId: "Wisdom",
        signatureVersion: "v4",
        signingName: "wisdom",
        uid: "wisdom-2020-10-19"
      },
      operations: {
        CreateAssistant: {
          http: {
            requestUri: "/assistants",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "name",
              "type"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              name: {},
              serverSideEncryptionConfiguration: {
                shape: "S5"
              },
              tags: {
                shape: "S7"
              },
              type: {}
            }
          },
          output: {
            type: "structure",
            members: {
              assistant: {
                shape: "Sc"
              }
            }
          },
          idempotent: true
        },
        CreateAssistantAssociation: {
          http: {
            requestUri: "/assistants/{assistantId}/associations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "association",
              "associationType"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              association: {
                type: "structure",
                members: {
                  knowledgeBaseId: {}
                },
                union: true
              },
              associationType: {},
              clientToken: {
                idempotencyToken: true
              },
              tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assistantAssociation: {
                shape: "Sl"
              }
            }
          },
          idempotent: true
        },
        CreateContent: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/contents",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "name",
              "uploadId"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              metadata: {
                shape: "Sp"
              },
              name: {},
              overrideLinkOutUri: {},
              tags: {
                shape: "S7"
              },
              title: {},
              uploadId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              content: {
                shape: "St"
              }
            }
          },
          idempotent: true
        },
        CreateKnowledgeBase: {
          http: {
            requestUri: "/knowledgeBases",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseType",
              "name"
            ],
            members: {
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              knowledgeBaseType: {},
              name: {},
              renderingConfiguration: {
                shape: "S10"
              },
              serverSideEncryptionConfiguration: {
                shape: "S5"
              },
              sourceConfiguration: {
                shape: "S11"
              },
              tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              knowledgeBase: {
                shape: "S16"
              }
            }
          },
          idempotent: true
        },
        CreateSession: {
          http: {
            requestUri: "/assistants/{assistantId}/sessions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "name"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              clientToken: {
                idempotencyToken: true
              },
              description: {},
              name: {},
              tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              session: {
                shape: "S1a"
              }
            }
          },
          idempotent: true
        },
        DeleteAssistant: {
          http: {
            method: "DELETE",
            requestUri: "/assistants/{assistantId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "assistantId"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteAssistantAssociation: {
          http: {
            method: "DELETE",
            requestUri: "/assistants/{assistantId}/associations/{assistantAssociationId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "assistantAssociationId",
              "assistantId"
            ],
            members: {
              assistantAssociationId: {
                location: "uri",
                locationName: "assistantAssociationId"
              },
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteContent: {
          http: {
            method: "DELETE",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/contents/{contentId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "contentId",
              "knowledgeBaseId"
            ],
            members: {
              contentId: {
                location: "uri",
                locationName: "contentId"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        DeleteKnowledgeBase: {
          http: {
            method: "DELETE",
            requestUri: "/knowledgeBases/{knowledgeBaseId}",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        GetAssistant: {
          http: {
            method: "GET",
            requestUri: "/assistants/{assistantId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assistant: {
                shape: "Sc"
              }
            }
          }
        },
        GetAssistantAssociation: {
          http: {
            method: "GET",
            requestUri: "/assistants/{assistantId}/associations/{assistantAssociationId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantAssociationId",
              "assistantId"
            ],
            members: {
              assistantAssociationId: {
                location: "uri",
                locationName: "assistantAssociationId"
              },
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              assistantAssociation: {
                shape: "Sl"
              }
            }
          }
        },
        GetContent: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/contents/{contentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contentId",
              "knowledgeBaseId"
            ],
            members: {
              contentId: {
                location: "uri",
                locationName: "contentId"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              content: {
                shape: "St"
              }
            }
          }
        },
        GetContentSummary: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/contents/{contentId}/summary",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contentId",
              "knowledgeBaseId"
            ],
            members: {
              contentId: {
                location: "uri",
                locationName: "contentId"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              contentSummary: {
                shape: "S1r"
              }
            }
          }
        },
        GetKnowledgeBase: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases/{knowledgeBaseId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              knowledgeBase: {
                shape: "S16"
              }
            }
          }
        },
        GetRecommendations: {
          http: {
            method: "GET",
            requestUri: "/assistants/{assistantId}/sessions/{sessionId}/recommendations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "sessionId"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              },
              waitTimeSeconds: {
                location: "querystring",
                locationName: "waitTimeSeconds",
                type: "integer"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "recommendations"
            ],
            members: {
              recommendations: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "document",
                    "recommendationId"
                  ],
                  members: {
                    document: {
                      shape: "S20"
                    },
                    recommendationId: {},
                    relevanceLevel: {},
                    relevanceScore: {
                      type: "double"
                    }
                  }
                }
              }
            }
          }
        },
        GetSession: {
          http: {
            method: "GET",
            requestUri: "/assistants/{assistantId}/sessions/{sessionId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "sessionId"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              session: {
                shape: "S1a"
              }
            }
          }
        },
        ListAssistantAssociations: {
          http: {
            method: "GET",
            requestUri: "/assistants/{assistantId}/associations",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assistantAssociationSummaries"
            ],
            members: {
              assistantAssociationSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "assistantArn",
                    "assistantAssociationArn",
                    "assistantAssociationId",
                    "assistantId",
                    "associationData",
                    "associationType"
                  ],
                  members: {
                    assistantArn: {},
                    assistantAssociationArn: {},
                    assistantAssociationId: {},
                    assistantId: {},
                    associationData: {
                      shape: "Sm"
                    },
                    associationType: {},
                    tags: {
                      shape: "S7"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListAssistants: {
          http: {
            method: "GET",
            requestUri: "/assistants",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "assistantSummaries"
            ],
            members: {
              assistantSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "assistantArn",
                    "assistantId",
                    "name",
                    "status",
                    "type"
                  ],
                  members: {
                    assistantArn: {},
                    assistantId: {},
                    description: {},
                    name: {},
                    serverSideEncryptionConfiguration: {
                      shape: "S5"
                    },
                    status: {},
                    tags: {
                      shape: "S7"
                    },
                    type: {}
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListContents: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/contents",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "contentSummaries"
            ],
            members: {
              contentSummaries: {
                shape: "S2n"
              },
              nextToken: {}
            }
          }
        },
        ListKnowledgeBases: {
          http: {
            method: "GET",
            requestUri: "/knowledgeBases",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "knowledgeBaseSummaries"
            ],
            members: {
              knowledgeBaseSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "knowledgeBaseArn",
                    "knowledgeBaseId",
                    "knowledgeBaseType",
                    "name",
                    "status"
                  ],
                  members: {
                    description: {},
                    knowledgeBaseArn: {},
                    knowledgeBaseId: {},
                    knowledgeBaseType: {},
                    name: {},
                    renderingConfiguration: {
                      shape: "S10"
                    },
                    serverSideEncryptionConfiguration: {
                      shape: "S5"
                    },
                    sourceConfiguration: {
                      shape: "S11"
                    },
                    status: {},
                    tags: {
                      shape: "S7"
                    }
                  }
                }
              },
              nextToken: {}
            }
          }
        },
        ListTagsForResource: {
          http: {
            method: "GET",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              tags: {
                shape: "S7"
              }
            }
          }
        },
        NotifyRecommendationsReceived: {
          http: {
            requestUri: "/assistants/{assistantId}/sessions/{sessionId}/recommendations/notify",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "recommendationIds",
              "sessionId"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              recommendationIds: {
                shape: "S2v"
              },
              sessionId: {
                location: "uri",
                locationName: "sessionId"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  members: {
                    message: {},
                    recommendationId: {}
                  }
                }
              },
              recommendationIds: {
                shape: "S2v"
              }
            }
          },
          idempotent: true
        },
        QueryAssistant: {
          http: {
            requestUri: "/assistants/{assistantId}/query",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "queryText"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              maxResults: {
                type: "integer"
              },
              nextToken: {},
              queryText: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "results"
            ],
            members: {
              nextToken: {},
              results: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "document",
                    "resultId"
                  ],
                  members: {
                    document: {
                      shape: "S20"
                    },
                    relevanceScore: {
                      type: "double"
                    },
                    resultId: {}
                  }
                }
              }
            }
          }
        },
        RemoveKnowledgeBaseTemplateUri: {
          http: {
            method: "DELETE",
            requestUri: "/knowledgeBases/{knowledgeBaseId}/templateUri",
            responseCode: 204
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          }
        },
        SearchContent: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/search",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "searchExpression"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              searchExpression: {
                shape: "S38"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "contentSummaries"
            ],
            members: {
              contentSummaries: {
                shape: "S2n"
              },
              nextToken: {}
            }
          }
        },
        SearchSessions: {
          http: {
            requestUri: "/assistants/{assistantId}/searchSessions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "assistantId",
              "searchExpression"
            ],
            members: {
              assistantId: {
                location: "uri",
                locationName: "assistantId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              searchExpression: {
                shape: "S38"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "sessionSummaries"
            ],
            members: {
              nextToken: {},
              sessionSummaries: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "assistantArn",
                    "assistantId",
                    "sessionArn",
                    "sessionId"
                  ],
                  members: {
                    assistantArn: {},
                    assistantId: {},
                    sessionArn: {},
                    sessionId: {}
                  }
                }
              }
            }
          }
        },
        StartContentUpload: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/upload",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contentType",
              "knowledgeBaseId"
            ],
            members: {
              contentType: {},
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "headersToInclude",
              "uploadId",
              "url",
              "urlExpiry"
            ],
            members: {
              headersToInclude: {
                type: "map",
                key: {},
                value: {}
              },
              uploadId: {},
              url: {
                type: "string",
                sensitive: true
              },
              urlExpiry: {
                shape: "Sx"
              }
            }
          }
        },
        TagResource: {
          http: {
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tags"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tags: {
                shape: "S7"
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UntagResource: {
          http: {
            method: "DELETE",
            requestUri: "/tags/{resourceArn}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "resourceArn",
              "tagKeys"
            ],
            members: {
              resourceArn: {
                location: "uri",
                locationName: "resourceArn"
              },
              tagKeys: {
                location: "querystring",
                locationName: "tagKeys",
                type: "list",
                member: {}
              }
            }
          },
          output: {
            type: "structure",
            members: {}
          },
          idempotent: true
        },
        UpdateContent: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/contents/{contentId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "contentId",
              "knowledgeBaseId"
            ],
            members: {
              contentId: {
                location: "uri",
                locationName: "contentId"
              },
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              metadata: {
                shape: "Sp"
              },
              overrideLinkOutUri: {},
              removeOverrideLinkOutUri: {
                type: "boolean"
              },
              revisionId: {},
              title: {},
              uploadId: {}
            }
          },
          output: {
            type: "structure",
            members: {
              content: {
                shape: "St"
              }
            }
          }
        },
        UpdateKnowledgeBaseTemplateUri: {
          http: {
            requestUri: "/knowledgeBases/{knowledgeBaseId}/templateUri",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "knowledgeBaseId",
              "templateUri"
            ],
            members: {
              knowledgeBaseId: {
                location: "uri",
                locationName: "knowledgeBaseId"
              },
              templateUri: {}
            }
          },
          output: {
            type: "structure",
            members: {
              knowledgeBase: {
                shape: "S16"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          members: {
            kmsKeyId: {}
          }
        },
        S7: {
          type: "map",
          key: {},
          value: {}
        },
        Sc: {
          type: "structure",
          required: [
            "assistantArn",
            "assistantId",
            "name",
            "status",
            "type"
          ],
          members: {
            assistantArn: {},
            assistantId: {},
            description: {},
            name: {},
            serverSideEncryptionConfiguration: {
              shape: "S5"
            },
            status: {},
            tags: {
              shape: "S7"
            },
            type: {}
          }
        },
        Sl: {
          type: "structure",
          required: [
            "assistantArn",
            "assistantAssociationArn",
            "assistantAssociationId",
            "assistantId",
            "associationData",
            "associationType"
          ],
          members: {
            assistantArn: {},
            assistantAssociationArn: {},
            assistantAssociationId: {},
            assistantId: {},
            associationData: {
              shape: "Sm"
            },
            associationType: {},
            tags: {
              shape: "S7"
            }
          }
        },
        Sm: {
          type: "structure",
          members: {
            knowledgeBaseAssociation: {
              type: "structure",
              members: {
                knowledgeBaseArn: {},
                knowledgeBaseId: {}
              }
            }
          },
          union: true
        },
        Sp: {
          type: "map",
          key: {},
          value: {}
        },
        St: {
          type: "structure",
          required: [
            "contentArn",
            "contentId",
            "contentType",
            "knowledgeBaseArn",
            "knowledgeBaseId",
            "metadata",
            "name",
            "revisionId",
            "status",
            "title",
            "url",
            "urlExpiry"
          ],
          members: {
            contentArn: {},
            contentId: {},
            contentType: {},
            knowledgeBaseArn: {},
            knowledgeBaseId: {},
            linkOutUri: {},
            metadata: {
              shape: "Sp"
            },
            name: {},
            revisionId: {},
            status: {},
            tags: {
              shape: "S7"
            },
            title: {},
            url: {
              type: "string",
              sensitive: true
            },
            urlExpiry: {
              shape: "Sx"
            }
          }
        },
        Sx: {
          type: "timestamp",
          timestampFormat: "unixTimestamp"
        },
        S10: {
          type: "structure",
          members: {
            templateUri: {}
          }
        },
        S11: {
          type: "structure",
          members: {
            appIntegrations: {
              type: "structure",
              required: [
                "appIntegrationArn",
                "objectFields"
              ],
              members: {
                appIntegrationArn: {},
                objectFields: {
                  type: "list",
                  member: {}
                }
              }
            }
          },
          union: true
        },
        S16: {
          type: "structure",
          required: [
            "knowledgeBaseArn",
            "knowledgeBaseId",
            "knowledgeBaseType",
            "name",
            "status"
          ],
          members: {
            description: {},
            knowledgeBaseArn: {},
            knowledgeBaseId: {},
            knowledgeBaseType: {},
            lastContentModificationTime: {
              shape: "Sx"
            },
            name: {},
            renderingConfiguration: {
              shape: "S10"
            },
            serverSideEncryptionConfiguration: {
              shape: "S5"
            },
            sourceConfiguration: {
              shape: "S11"
            },
            status: {},
            tags: {
              shape: "S7"
            }
          }
        },
        S1a: {
          type: "structure",
          required: [
            "name",
            "sessionArn",
            "sessionId"
          ],
          members: {
            description: {},
            name: {},
            sessionArn: {},
            sessionId: {},
            tags: {
              shape: "S7"
            }
          }
        },
        S1r: {
          type: "structure",
          required: [
            "contentArn",
            "contentId",
            "contentType",
            "knowledgeBaseArn",
            "knowledgeBaseId",
            "metadata",
            "name",
            "revisionId",
            "status",
            "title"
          ],
          members: {
            contentArn: {},
            contentId: {},
            contentType: {},
            knowledgeBaseArn: {},
            knowledgeBaseId: {},
            metadata: {
              shape: "Sp"
            },
            name: {},
            revisionId: {},
            status: {},
            tags: {
              shape: "S7"
            },
            title: {}
          }
        },
        S20: {
          type: "structure",
          required: [
            "contentReference"
          ],
          members: {
            contentReference: {
              type: "structure",
              members: {
                contentArn: {},
                contentId: {},
                knowledgeBaseArn: {},
                knowledgeBaseId: {}
              }
            },
            excerpt: {
              shape: "S22"
            },
            title: {
              shape: "S22"
            }
          }
        },
        S22: {
          type: "structure",
          members: {
            highlights: {
              type: "list",
              member: {
                type: "structure",
                members: {
                  beginOffsetInclusive: {
                    type: "integer"
                  },
                  endOffsetExclusive: {
                    type: "integer"
                  }
                }
              }
            },
            text: {
              type: "string",
              sensitive: true
            }
          }
        },
        S2n: {
          type: "list",
          member: {
            shape: "S1r"
          }
        },
        S2v: {
          type: "list",
          member: {}
        },
        S38: {
          type: "structure",
          required: [
            "filters"
          ],
          members: {
            filters: {
              type: "list",
              member: {
                type: "structure",
                required: [
                  "field",
                  "operator",
                  "value"
                ],
                members: {
                  field: {},
                  operator: {},
                  value: {}
                }
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/wisdom-2020-10-19.paginators.json
var require_wisdom_2020_10_19_paginators = __commonJS({
  "node_modules/aws-sdk/apis/wisdom-2020-10-19.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListAssistantAssociations: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assistantAssociationSummaries"
        },
        ListAssistants: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "assistantSummaries"
        },
        ListContents: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "contentSummaries"
        },
        ListKnowledgeBases: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "knowledgeBaseSummaries"
        },
        QueryAssistant: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "results"
        },
        SearchContent: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "contentSummaries"
        },
        SearchSessions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "sessionSummaries"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/wisdom.js
var require_wisdom = __commonJS({
  "node_modules/aws-sdk/clients/wisdom.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["wisdom"] = {};
    AWS3.Wisdom = Service.defineService("wisdom", ["2020-10-19"]);
    Object.defineProperty(apiLoader.services["wisdom"], "2020-10-19", {
      get: function get() {
        var model = require_wisdom_2020_10_19_min();
        model.paginators = require_wisdom_2020_10_19_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Wisdom;
  }
});

// node_modules/aws-sdk/apis/account-2021-02-01.min.json
var require_account_2021_02_01_min = __commonJS({
  "node_modules/aws-sdk/apis/account-2021-02-01.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-02-01",
        endpointPrefix: "account",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "AWS Account",
        serviceId: "Account",
        signatureVersion: "v4",
        signingName: "account",
        uid: "account-2021-02-01"
      },
      operations: {
        DeleteAlternateContact: {
          http: {
            requestUri: "/deleteAlternateContact",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AlternateContactType"
            ],
            members: {
              AccountId: {},
              AlternateContactType: {}
            }
          },
          idempotent: true
        },
        GetAlternateContact: {
          http: {
            requestUri: "/getAlternateContact",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AlternateContactType"
            ],
            members: {
              AccountId: {},
              AlternateContactType: {}
            }
          },
          output: {
            type: "structure",
            members: {
              AlternateContact: {
                type: "structure",
                members: {
                  AlternateContactType: {},
                  EmailAddress: {
                    shape: "S7"
                  },
                  Name: {
                    shape: "S8"
                  },
                  PhoneNumber: {
                    shape: "S9"
                  },
                  Title: {
                    shape: "Sa"
                  }
                }
              }
            }
          }
        },
        PutAlternateContact: {
          http: {
            requestUri: "/putAlternateContact",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "AlternateContactType",
              "EmailAddress",
              "Name",
              "PhoneNumber",
              "Title"
            ],
            members: {
              AccountId: {},
              AlternateContactType: {},
              EmailAddress: {
                shape: "S7"
              },
              Name: {
                shape: "S8"
              },
              PhoneNumber: {
                shape: "S9"
              },
              Title: {
                shape: "Sa"
              }
            }
          },
          idempotent: true
        }
      },
      shapes: {
        S7: {
          type: "string",
          sensitive: true
        },
        S8: {
          type: "string",
          sensitive: true
        },
        S9: {
          type: "string",
          sensitive: true
        },
        Sa: {
          type: "string",
          sensitive: true
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/account-2021-02-01.paginators.json
var require_account_2021_02_01_paginators = __commonJS({
  "node_modules/aws-sdk/apis/account-2021-02-01.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {}
    };
  }
});

// node_modules/aws-sdk/clients/account.js
var require_account = __commonJS({
  "node_modules/aws-sdk/clients/account.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["account"] = {};
    AWS3.Account = Service.defineService("account", ["2021-02-01"]);
    Object.defineProperty(apiLoader.services["account"], "2021-02-01", {
      get: function get() {
        var model = require_account_2021_02_01_min();
        model.paginators = require_account_2021_02_01_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Account;
  }
});

// node_modules/aws-sdk/apis/cloudcontrol-2021-09-30.min.json
var require_cloudcontrol_2021_09_30_min = __commonJS({
  "node_modules/aws-sdk/apis/cloudcontrol-2021-09-30.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2021-09-30",
        endpointPrefix: "cloudcontrolapi",
        jsonVersion: "1.0",
        protocol: "json",
        serviceAbbreviation: "CloudControlApi",
        serviceFullName: "AWS Cloud Control API",
        serviceId: "CloudControl",
        signatureVersion: "v4",
        signingName: "cloudcontrolapi",
        targetPrefix: "CloudApiService",
        uid: "cloudcontrol-2021-09-30"
      },
      operations: {
        CancelResourceRequest: {
          input: {
            type: "structure",
            required: [
              "RequestToken"
            ],
            members: {
              RequestToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProgressEvent: {
                shape: "S4"
              }
            }
          },
          idempotent: true
        },
        CreateResource: {
          input: {
            type: "structure",
            required: [
              "TypeName",
              "DesiredState"
            ],
            members: {
              TypeName: {},
              TypeVersionId: {},
              RoleArn: {},
              ClientToken: {
                idempotencyToken: true
              },
              DesiredState: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProgressEvent: {
                shape: "S4"
              }
            }
          }
        },
        DeleteResource: {
          input: {
            type: "structure",
            required: [
              "TypeName",
              "Identifier"
            ],
            members: {
              TypeName: {},
              TypeVersionId: {},
              RoleArn: {},
              ClientToken: {
                idempotencyToken: true
              },
              Identifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProgressEvent: {
                shape: "S4"
              }
            }
          }
        },
        GetResource: {
          input: {
            type: "structure",
            required: [
              "TypeName",
              "Identifier"
            ],
            members: {
              TypeName: {},
              TypeVersionId: {},
              RoleArn: {},
              Identifier: {}
            }
          },
          output: {
            type: "structure",
            members: {
              TypeName: {},
              ResourceDescription: {
                shape: "Sm"
              }
            }
          }
        },
        GetResourceRequestStatus: {
          input: {
            type: "structure",
            required: [
              "RequestToken"
            ],
            members: {
              RequestToken: {}
            }
          },
          output: {
            type: "structure",
            members: {
              ProgressEvent: {
                shape: "S4"
              }
            }
          }
        },
        ListResourceRequests: {
          input: {
            type: "structure",
            members: {
              MaxResults: {
                type: "integer"
              },
              NextToken: {},
              ResourceRequestStatusFilter: {
                type: "structure",
                members: {
                  Operations: {
                    type: "list",
                    member: {}
                  },
                  OperationStatuses: {
                    type: "list",
                    member: {}
                  }
                }
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ResourceRequestStatusSummaries: {
                type: "list",
                member: {
                  shape: "S4"
                }
              },
              NextToken: {}
            }
          }
        },
        ListResources: {
          input: {
            type: "structure",
            required: [
              "TypeName"
            ],
            members: {
              TypeName: {},
              TypeVersionId: {},
              RoleArn: {},
              NextToken: {},
              MaxResults: {
                type: "integer"
              },
              ResourceModel: {
                shape: "Sa"
              }
            }
          },
          output: {
            type: "structure",
            members: {
              TypeName: {},
              ResourceDescriptions: {
                type: "list",
                member: {
                  shape: "Sm"
                }
              },
              NextToken: {}
            }
          }
        },
        UpdateResource: {
          input: {
            type: "structure",
            required: [
              "TypeName",
              "Identifier",
              "PatchDocument"
            ],
            members: {
              TypeName: {},
              TypeVersionId: {},
              RoleArn: {},
              ClientToken: {
                idempotencyToken: true
              },
              Identifier: {},
              PatchDocument: {
                type: "string",
                sensitive: true
              }
            }
          },
          output: {
            type: "structure",
            members: {
              ProgressEvent: {
                shape: "S4"
              }
            }
          }
        }
      },
      shapes: {
        S4: {
          type: "structure",
          members: {
            TypeName: {},
            Identifier: {},
            RequestToken: {},
            Operation: {},
            OperationStatus: {},
            EventTime: {
              type: "timestamp"
            },
            ResourceModel: {
              shape: "Sa"
            },
            StatusMessage: {},
            ErrorCode: {},
            RetryAfter: {
              type: "timestamp"
            }
          }
        },
        Sa: {
          type: "string",
          sensitive: true
        },
        Sm: {
          type: "structure",
          members: {
            Identifier: {},
            Properties: {
              shape: "Sa"
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudcontrol-2021-09-30.paginators.json
var require_cloudcontrol_2021_09_30_paginators = __commonJS({
  "node_modules/aws-sdk/apis/cloudcontrol-2021-09-30.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListResourceRequests: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        },
        ListResources: {
          input_token: "NextToken",
          output_token: "NextToken",
          limit_key: "MaxResults"
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/cloudcontrol-2021-09-30.waiters2.json
var require_cloudcontrol_2021_09_30_waiters2 = __commonJS({
  "node_modules/aws-sdk/apis/cloudcontrol-2021-09-30.waiters2.json"(exports, module2) {
    module2.exports = {
      version: 2,
      waiters: {
        ResourceRequestSuccess: {
          description: "Wait until resource operation request is successful",
          operation: "GetResourceRequestStatus",
          delay: 5,
          maxAttempts: 720,
          acceptors: [
            {
              state: "success",
              matcher: "path",
              argument: "ProgressEvent.OperationStatus",
              expected: "SUCCESS"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "ProgressEvent.OperationStatus",
              expected: "FAILED"
            },
            {
              state: "failure",
              matcher: "path",
              argument: "ProgressEvent.OperationStatus",
              expected: "CANCEL_COMPLETE"
            }
          ]
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/cloudcontrol.js
var require_cloudcontrol = __commonJS({
  "node_modules/aws-sdk/clients/cloudcontrol.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["cloudcontrol"] = {};
    AWS3.CloudControl = Service.defineService("cloudcontrol", ["2021-09-30"]);
    Object.defineProperty(apiLoader.services["cloudcontrol"], "2021-09-30", {
      get: function get() {
        var model = require_cloudcontrol_2021_09_30_min();
        model.paginators = require_cloudcontrol_2021_09_30_paginators().pagination;
        model.waiters = require_cloudcontrol_2021_09_30_waiters2().waiters;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.CloudControl;
  }
});

// node_modules/aws-sdk/apis/grafana-2020-08-18.min.json
var require_grafana_2020_08_18_min = __commonJS({
  "node_modules/aws-sdk/apis/grafana-2020-08-18.min.json"(exports, module2) {
    module2.exports = {
      version: "2.0",
      metadata: {
        apiVersion: "2020-08-18",
        endpointPrefix: "grafana",
        jsonVersion: "1.1",
        protocol: "rest-json",
        serviceFullName: "Amazon Managed Grafana",
        serviceId: "grafana",
        signatureVersion: "v4",
        signingName: "grafana",
        uid: "grafana-2020-08-18"
      },
      operations: {
        AssociateLicense: {
          http: {
            requestUri: "/workspaces/{workspaceId}/licenses/{licenseType}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "licenseType",
              "workspaceId"
            ],
            members: {
              licenseType: {
                location: "uri",
                locationName: "licenseType"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspace"
            ],
            members: {
              workspace: {
                shape: "S5"
              }
            }
          }
        },
        CreateWorkspace: {
          http: {
            requestUri: "/workspaces",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "accountAccessType",
              "authenticationProviders",
              "permissionType"
            ],
            members: {
              accountAccessType: {},
              authenticationProviders: {
                shape: "S8"
              },
              clientToken: {
                idempotencyToken: true
              },
              organizationRoleName: {
                shape: "Sl"
              },
              permissionType: {},
              stackSetName: {},
              workspaceDataSources: {
                shape: "Sc"
              },
              workspaceDescription: {
                shape: "Se"
              },
              workspaceName: {
                shape: "Si"
              },
              workspaceNotificationDestinations: {
                shape: "Sj"
              },
              workspaceOrganizationalUnits: {
                shape: "Sm"
              },
              workspaceRoleArn: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspace"
            ],
            members: {
              workspace: {
                shape: "S5"
              }
            }
          },
          idempotent: true
        },
        DeleteWorkspace: {
          http: {
            method: "DELETE",
            requestUri: "/workspaces/{workspaceId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspace"
            ],
            members: {
              workspace: {
                shape: "S5"
              }
            }
          },
          idempotent: true
        },
        DescribeWorkspace: {
          http: {
            method: "GET",
            requestUri: "/workspaces/{workspaceId}",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspace"
            ],
            members: {
              workspace: {
                shape: "S5"
              }
            }
          }
        },
        DescribeWorkspaceAuthentication: {
          http: {
            method: "GET",
            requestUri: "/workspaces/{workspaceId}/authentication",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "authentication"
            ],
            members: {
              authentication: {
                shape: "S11"
              }
            }
          }
        },
        DisassociateLicense: {
          http: {
            method: "DELETE",
            requestUri: "/workspaces/{workspaceId}/licenses/{licenseType}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "licenseType",
              "workspaceId"
            ],
            members: {
              licenseType: {
                location: "uri",
                locationName: "licenseType"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspace"
            ],
            members: {
              workspace: {
                shape: "S5"
              }
            }
          }
        },
        ListPermissions: {
          http: {
            method: "GET",
            requestUri: "/workspaces/{workspaceId}/permissions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              groupId: {
                location: "querystring",
                locationName: "groupId"
              },
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              },
              userId: {
                location: "querystring",
                locationName: "userId"
              },
              userType: {
                location: "querystring",
                locationName: "userType"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "permissions"
            ],
            members: {
              nextToken: {},
              permissions: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "role",
                    "user"
                  ],
                  members: {
                    role: {},
                    user: {
                      shape: "S1s"
                    }
                  }
                }
              }
            }
          }
        },
        ListWorkspaces: {
          http: {
            method: "GET",
            requestUri: "/workspaces",
            responseCode: 200
          },
          input: {
            type: "structure",
            members: {
              maxResults: {
                location: "querystring",
                locationName: "maxResults",
                type: "integer"
              },
              nextToken: {
                location: "querystring",
                locationName: "nextToken"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspaces"
            ],
            members: {
              nextToken: {},
              workspaces: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "authentication",
                    "created",
                    "endpoint",
                    "grafanaVersion",
                    "id",
                    "modified",
                    "status"
                  ],
                  members: {
                    authentication: {
                      shape: "S7"
                    },
                    created: {
                      type: "timestamp"
                    },
                    description: {
                      shape: "Se"
                    },
                    endpoint: {},
                    grafanaVersion: {},
                    id: {},
                    modified: {
                      type: "timestamp"
                    },
                    name: {
                      shape: "Si"
                    },
                    notificationDestinations: {
                      shape: "Sj"
                    },
                    status: {}
                  }
                }
              }
            }
          }
        },
        UpdatePermissions: {
          http: {
            method: "PATCH",
            requestUri: "/workspaces/{workspaceId}/permissions",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "updateInstructionBatch",
              "workspaceId"
            ],
            members: {
              updateInstructionBatch: {
                type: "list",
                member: {
                  shape: "S20"
                }
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "errors"
            ],
            members: {
              errors: {
                type: "list",
                member: {
                  type: "structure",
                  required: [
                    "causedBy",
                    "code",
                    "message"
                  ],
                  members: {
                    causedBy: {
                      shape: "S20"
                    },
                    code: {
                      type: "integer"
                    },
                    message: {}
                  }
                }
              }
            }
          }
        },
        UpdateWorkspace: {
          http: {
            method: "PUT",
            requestUri: "/workspaces/{workspaceId}",
            responseCode: 202
          },
          input: {
            type: "structure",
            required: [
              "workspaceId"
            ],
            members: {
              accountAccessType: {},
              organizationRoleName: {
                shape: "Sl"
              },
              permissionType: {},
              stackSetName: {},
              workspaceDataSources: {
                shape: "Sc"
              },
              workspaceDescription: {
                shape: "Se"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              },
              workspaceName: {
                shape: "Si"
              },
              workspaceNotificationDestinations: {
                shape: "Sj"
              },
              workspaceOrganizationalUnits: {
                shape: "Sm"
              },
              workspaceRoleArn: {
                shape: "Sr"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "workspace"
            ],
            members: {
              workspace: {
                shape: "S5"
              }
            }
          }
        },
        UpdateWorkspaceAuthentication: {
          http: {
            requestUri: "/workspaces/{workspaceId}/authentication",
            responseCode: 200
          },
          input: {
            type: "structure",
            required: [
              "authenticationProviders",
              "workspaceId"
            ],
            members: {
              authenticationProviders: {
                shape: "S8"
              },
              samlConfiguration: {
                shape: "S15"
              },
              workspaceId: {
                location: "uri",
                locationName: "workspaceId"
              }
            }
          },
          output: {
            type: "structure",
            required: [
              "authentication"
            ],
            members: {
              authentication: {
                shape: "S11"
              }
            }
          }
        }
      },
      shapes: {
        S5: {
          type: "structure",
          required: [
            "authentication",
            "created",
            "dataSources",
            "endpoint",
            "grafanaVersion",
            "id",
            "modified",
            "status"
          ],
          members: {
            accountAccessType: {},
            authentication: {
              shape: "S7"
            },
            created: {
              type: "timestamp"
            },
            dataSources: {
              shape: "Sc"
            },
            description: {
              shape: "Se"
            },
            endpoint: {},
            freeTrialConsumed: {
              type: "boolean"
            },
            freeTrialExpiration: {
              type: "timestamp"
            },
            grafanaVersion: {},
            id: {},
            licenseExpiration: {
              type: "timestamp"
            },
            licenseType: {},
            modified: {
              type: "timestamp"
            },
            name: {
              shape: "Si"
            },
            notificationDestinations: {
              shape: "Sj"
            },
            organizationRoleName: {
              shape: "Sl"
            },
            organizationalUnits: {
              shape: "Sm"
            },
            permissionType: {},
            stackSetName: {},
            status: {},
            workspaceRoleArn: {
              shape: "Sr"
            }
          }
        },
        S7: {
          type: "structure",
          required: [
            "providers"
          ],
          members: {
            providers: {
              shape: "S8"
            },
            samlConfigurationStatus: {}
          }
        },
        S8: {
          type: "list",
          member: {}
        },
        Sc: {
          type: "list",
          member: {}
        },
        Se: {
          type: "string",
          sensitive: true
        },
        Si: {
          type: "string",
          sensitive: true
        },
        Sj: {
          type: "list",
          member: {}
        },
        Sl: {
          type: "string",
          sensitive: true
        },
        Sm: {
          type: "list",
          member: {},
          sensitive: true
        },
        Sr: {
          type: "string",
          sensitive: true
        },
        S11: {
          type: "structure",
          required: [
            "providers"
          ],
          members: {
            awsSso: {
              type: "structure",
              members: {
                ssoClientId: {}
              }
            },
            providers: {
              shape: "S8"
            },
            saml: {
              type: "structure",
              required: [
                "status"
              ],
              members: {
                configuration: {
                  shape: "S15"
                },
                status: {}
              }
            }
          }
        },
        S15: {
          type: "structure",
          required: [
            "idpMetadata"
          ],
          members: {
            allowedOrganizations: {
              type: "list",
              member: {}
            },
            assertionAttributes: {
              type: "structure",
              members: {
                email: {},
                groups: {},
                login: {},
                name: {},
                org: {},
                role: {}
              }
            },
            idpMetadata: {
              type: "structure",
              members: {
                url: {},
                xml: {}
              },
              union: true
            },
            loginValidityDuration: {
              type: "integer"
            },
            roleValues: {
              type: "structure",
              members: {
                admin: {
                  shape: "S1f"
                },
                editor: {
                  shape: "S1f"
                }
              }
            }
          }
        },
        S1f: {
          type: "list",
          member: {}
        },
        S1s: {
          type: "structure",
          required: [
            "id",
            "type"
          ],
          members: {
            id: {},
            type: {}
          }
        },
        S20: {
          type: "structure",
          required: [
            "action",
            "role",
            "users"
          ],
          members: {
            action: {},
            role: {},
            users: {
              type: "list",
              member: {
                shape: "S1s"
              }
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-sdk/apis/grafana-2020-08-18.paginators.json
var require_grafana_2020_08_18_paginators = __commonJS({
  "node_modules/aws-sdk/apis/grafana-2020-08-18.paginators.json"(exports, module2) {
    module2.exports = {
      pagination: {
        ListPermissions: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "permissions"
        },
        ListWorkspaces: {
          input_token: "nextToken",
          output_token: "nextToken",
          limit_key: "maxResults",
          result_key: "workspaces"
        }
      }
    };
  }
});

// node_modules/aws-sdk/clients/grafana.js
var require_grafana = __commonJS({
  "node_modules/aws-sdk/clients/grafana.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    var Service = AWS3.Service;
    var apiLoader = AWS3.apiLoader;
    apiLoader.services["grafana"] = {};
    AWS3.Grafana = Service.defineService("grafana", ["2020-08-18"]);
    Object.defineProperty(apiLoader.services["grafana"], "2020-08-18", {
      get: function get() {
        var model = require_grafana_2020_08_18_min();
        model.paginators = require_grafana_2020_08_18_paginators().pagination;
        return model;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = AWS3.Grafana;
  }
});

// node_modules/aws-sdk/clients/all.js
var require_all = __commonJS({
  "node_modules/aws-sdk/clients/all.js"(exports, module2) {
    require_node_loader();
    module2.exports = {
      ACM: require_acm(),
      APIGateway: require_apigateway2(),
      ApplicationAutoScaling: require_applicationautoscaling(),
      AppStream: require_appstream(),
      AutoScaling: require_autoscaling(),
      Batch: require_batch(),
      Budgets: require_budgets(),
      CloudDirectory: require_clouddirectory(),
      CloudFormation: require_cloudformation(),
      CloudFront: require_cloudfront2(),
      CloudHSM: require_cloudhsm(),
      CloudSearch: require_cloudsearch(),
      CloudSearchDomain: require_cloudsearchdomain2(),
      CloudTrail: require_cloudtrail(),
      CloudWatch: require_cloudwatch(),
      CloudWatchEvents: require_cloudwatchevents(),
      CloudWatchLogs: require_cloudwatchlogs(),
      CodeBuild: require_codebuild(),
      CodeCommit: require_codecommit(),
      CodeDeploy: require_codedeploy(),
      CodePipeline: require_codepipeline(),
      CognitoIdentity: require_cognitoidentity(),
      CognitoIdentityServiceProvider: require_cognitoidentityserviceprovider(),
      CognitoSync: require_cognitosync(),
      ConfigService: require_configservice(),
      CUR: require_cur(),
      DataPipeline: require_datapipeline(),
      DeviceFarm: require_devicefarm(),
      DirectConnect: require_directconnect(),
      DirectoryService: require_directoryservice(),
      Discovery: require_discovery(),
      DMS: require_dms(),
      DynamoDB: require_dynamodb2(),
      DynamoDBStreams: require_dynamodbstreams(),
      EC2: require_ec22(),
      ECR: require_ecr(),
      ECS: require_ecs(),
      EFS: require_efs(),
      ElastiCache: require_elasticache(),
      ElasticBeanstalk: require_elasticbeanstalk(),
      ELB: require_elb(),
      ELBv2: require_elbv2(),
      EMR: require_emr(),
      ES: require_es(),
      ElasticTranscoder: require_elastictranscoder(),
      Firehose: require_firehose(),
      GameLift: require_gamelift(),
      Glacier: require_glacier2(),
      Health: require_health(),
      IAM: require_iam(),
      ImportExport: require_importexport(),
      Inspector: require_inspector(),
      Iot: require_iot(),
      IotData: require_iotdata2(),
      Kinesis: require_kinesis(),
      KinesisAnalytics: require_kinesisanalytics(),
      KMS: require_kms(),
      Lambda: require_lambda2(),
      LexRuntime: require_lexruntime(),
      Lightsail: require_lightsail(),
      MachineLearning: require_machinelearning2(),
      MarketplaceCommerceAnalytics: require_marketplacecommerceanalytics(),
      MarketplaceMetering: require_marketplacemetering(),
      MTurk: require_mturk(),
      MobileAnalytics: require_mobileanalytics(),
      OpsWorks: require_opsworks(),
      OpsWorksCM: require_opsworkscm(),
      Organizations: require_organizations(),
      Pinpoint: require_pinpoint(),
      Polly: require_polly2(),
      RDS: require_rds2(),
      Redshift: require_redshift(),
      Rekognition: require_rekognition(),
      ResourceGroupsTaggingAPI: require_resourcegroupstaggingapi(),
      Route53: require_route532(),
      Route53Domains: require_route53domains(),
      S3: require_s33(),
      S3Control: require_s3control2(),
      ServiceCatalog: require_servicecatalog(),
      SES: require_ses(),
      Shield: require_shield(),
      SimpleDB: require_simpledb(),
      SMS: require_sms(),
      Snowball: require_snowball(),
      SNS: require_sns(),
      SQS: require_sqs2(),
      SSM: require_ssm(),
      StorageGateway: require_storagegateway(),
      StepFunctions: require_stepfunctions(),
      STS: require_sts2(),
      Support: require_support(),
      SWF: require_swf2(),
      XRay: require_xray(),
      WAF: require_waf(),
      WAFRegional: require_wafregional(),
      WorkDocs: require_workdocs(),
      WorkSpaces: require_workspaces(),
      CodeStar: require_codestar(),
      LexModelBuildingService: require_lexmodelbuildingservice(),
      MarketplaceEntitlementService: require_marketplaceentitlementservice(),
      Athena: require_athena(),
      Greengrass: require_greengrass(),
      DAX: require_dax(),
      MigrationHub: require_migrationhub(),
      CloudHSMV2: require_cloudhsmv2(),
      Glue: require_glue(),
      Mobile: require_mobile(),
      Pricing: require_pricing(),
      CostExplorer: require_costexplorer(),
      MediaConvert: require_mediaconvert(),
      MediaLive: require_medialive(),
      MediaPackage: require_mediapackage(),
      MediaStore: require_mediastore(),
      MediaStoreData: require_mediastoredata(),
      AppSync: require_appsync(),
      GuardDuty: require_guardduty(),
      MQ: require_mq(),
      Comprehend: require_comprehend(),
      IoTJobsDataPlane: require_iotjobsdataplane(),
      KinesisVideoArchivedMedia: require_kinesisvideoarchivedmedia(),
      KinesisVideoMedia: require_kinesisvideomedia(),
      KinesisVideo: require_kinesisvideo(),
      SageMakerRuntime: require_sagemakerruntime(),
      SageMaker: require_sagemaker(),
      Translate: require_translate2(),
      ResourceGroups: require_resourcegroups(),
      AlexaForBusiness: require_alexaforbusiness(),
      Cloud9: require_cloud9(),
      ServerlessApplicationRepository: require_serverlessapplicationrepository(),
      ServiceDiscovery: require_servicediscovery(),
      WorkMail: require_workmail(),
      AutoScalingPlans: require_autoscalingplans(),
      TranscribeService: require_transcribeservice(),
      Connect: require_connect(),
      ACMPCA: require_acmpca(),
      FMS: require_fms(),
      SecretsManager: require_secretsmanager(),
      IoTAnalytics: require_iotanalytics(),
      IoT1ClickDevicesService: require_iot1clickdevicesservice(),
      IoT1ClickProjects: require_iot1clickprojects(),
      PI: require_pi(),
      Neptune: require_neptune2(),
      MediaTailor: require_mediatailor(),
      EKS: require_eks(),
      Macie: require_macie(),
      DLM: require_dlm(),
      Signer: require_signer3(),
      Chime: require_chime(),
      PinpointEmail: require_pinpointemail(),
      RAM: require_ram(),
      Route53Resolver: require_route53resolver(),
      PinpointSMSVoice: require_pinpointsmsvoice(),
      QuickSight: require_quicksight(),
      RDSDataService: require_rdsdataservice2(),
      Amplify: require_amplify(),
      DataSync: require_datasync(),
      RoboMaker: require_robomaker(),
      Transfer: require_transfer(),
      GlobalAccelerator: require_globalaccelerator(),
      ComprehendMedical: require_comprehendmedical(),
      KinesisAnalyticsV2: require_kinesisanalyticsv2(),
      MediaConnect: require_mediaconnect(),
      FSx: require_fsx(),
      SecurityHub: require_securityhub(),
      AppMesh: require_appmesh(),
      LicenseManager: require_licensemanager(),
      Kafka: require_kafka(),
      ApiGatewayManagementApi: require_apigatewaymanagementapi(),
      ApiGatewayV2: require_apigatewayv2(),
      DocDB: require_docdb2(),
      Backup: require_backup(),
      WorkLink: require_worklink(),
      Textract: require_textract(),
      ManagedBlockchain: require_managedblockchain(),
      MediaPackageVod: require_mediapackagevod(),
      GroundStation: require_groundstation(),
      IoTThingsGraph: require_iotthingsgraph(),
      IoTEvents: require_iotevents(),
      IoTEventsData: require_ioteventsdata(),
      Personalize: require_personalize(),
      PersonalizeEvents: require_personalizeevents(),
      PersonalizeRuntime: require_personalizeruntime(),
      ApplicationInsights: require_applicationinsights(),
      ServiceQuotas: require_servicequotas(),
      EC2InstanceConnect: require_ec2instanceconnect(),
      EventBridge: require_eventbridge(),
      LakeFormation: require_lakeformation(),
      ForecastService: require_forecastservice(),
      ForecastQueryService: require_forecastqueryservice(),
      QLDB: require_qldb(),
      QLDBSession: require_qldbsession(),
      WorkMailMessageFlow: require_workmailmessageflow(),
      CodeStarNotifications: require_codestarnotifications(),
      SavingsPlans: require_savingsplans(),
      SSO: require_sso(),
      SSOOIDC: require_ssooidc(),
      MarketplaceCatalog: require_marketplacecatalog(),
      DataExchange: require_dataexchange(),
      SESV2: require_sesv2(),
      MigrationHubConfig: require_migrationhubconfig(),
      ConnectParticipant: require_connectparticipant(),
      AppConfig: require_appconfig(),
      IoTSecureTunneling: require_iotsecuretunneling(),
      WAFV2: require_wafv2(),
      ElasticInference: require_elasticinference(),
      Imagebuilder: require_imagebuilder(),
      Schemas: require_schemas(),
      AccessAnalyzer: require_accessanalyzer(),
      CodeGuruReviewer: require_codegurureviewer(),
      CodeGuruProfiler: require_codeguruprofiler(),
      ComputeOptimizer: require_computeoptimizer(),
      FraudDetector: require_frauddetector(),
      Kendra: require_kendra(),
      NetworkManager: require_networkmanager(),
      Outposts: require_outposts(),
      AugmentedAIRuntime: require_augmentedairuntime(),
      EBS: require_ebs(),
      KinesisVideoSignalingChannels: require_kinesisvideosignalingchannels(),
      Detective: require_detective(),
      CodeStarconnections: require_codestarconnections(),
      Synthetics: require_synthetics(),
      IoTSiteWise: require_iotsitewise(),
      Macie2: require_macie2(),
      CodeArtifact: require_codeartifact(),
      Honeycode: require_honeycode(),
      IVS: require_ivs(),
      Braket: require_braket(),
      IdentityStore: require_identitystore(),
      Appflow: require_appflow(),
      RedshiftData: require_redshiftdata(),
      SSOAdmin: require_ssoadmin(),
      TimestreamQuery: require_timestreamquery(),
      TimestreamWrite: require_timestreamwrite(),
      S3Outposts: require_s3outposts(),
      DataBrew: require_databrew(),
      ServiceCatalogAppRegistry: require_servicecatalogappregistry(),
      NetworkFirewall: require_networkfirewall(),
      MWAA: require_mwaa(),
      AmplifyBackend: require_amplifybackend(),
      AppIntegrations: require_appintegrations(),
      ConnectContactLens: require_connectcontactlens(),
      DevOpsGuru: require_devopsguru(),
      ECRPUBLIC: require_ecrpublic(),
      LookoutVision: require_lookoutvision(),
      SageMakerFeatureStoreRuntime: require_sagemakerfeaturestoreruntime(),
      CustomerProfiles: require_customerprofiles(),
      AuditManager: require_auditmanager(),
      EMRcontainers: require_emrcontainers(),
      HealthLake: require_healthlake(),
      SagemakerEdge: require_sagemakeredge(),
      Amp: require_amp(),
      GreengrassV2: require_greengrassv2(),
      IotDeviceAdvisor: require_iotdeviceadvisor(),
      IoTFleetHub: require_iotfleethub(),
      IoTWireless: require_iotwireless(),
      Location: require_location(),
      WellArchitected: require_wellarchitected(),
      LexModelsV2: require_lexmodelsv22(),
      LexRuntimeV2: require_lexruntimev2(),
      Fis: require_fis(),
      LookoutMetrics: require_lookoutmetrics2(),
      Mgn: require_mgn(),
      LookoutEquipment: require_lookoutequipment(),
      Nimble: require_nimble(),
      Finspace: require_finspace2(),
      Finspacedata: require_finspacedata2(),
      SSMContacts: require_ssmcontacts(),
      SSMIncidents: require_ssmincidents(),
      ApplicationCostProfiler: require_applicationcostprofiler(),
      AppRunner: require_apprunner(),
      Proton: require_proton(),
      Route53RecoveryCluster: require_route53recoverycluster(),
      Route53RecoveryControlConfig: require_route53recoverycontrolconfig(),
      Route53RecoveryReadiness: require_route53recoveryreadiness(),
      ChimeSDKIdentity: require_chimesdkidentity(),
      ChimeSDKMessaging: require_chimesdkmessaging(),
      SnowDeviceManagement: require_snowdevicemanagement(),
      MemoryDB: require_memorydb(),
      OpenSearch: require_opensearch(),
      KafkaConnect: require_kafkaconnect(),
      VoiceID: require_voiceid(),
      Wisdom: require_wisdom(),
      Account: require_account(),
      CloudControl: require_cloudcontrol(),
      Grafana: require_grafana()
    };
  }
});

// node_modules/aws-sdk/lib/aws.js
var require_aws = __commonJS({
  "node_modules/aws-sdk/lib/aws.js"(exports, module2) {
    require_node_loader();
    var AWS3 = require_core();
    require_all();
    module2.exports = AWS3;
  }
});

// node_modules/shimmer/index.js
var require_shimmer = __commonJS({
  "node_modules/shimmer/index.js"(exports, module2) {
    "use strict";
    function isFunction(funktion) {
      return typeof funktion === "function";
    }
    var logger = console.error.bind(console);
    function defineProperty(obj, name, value) {
      var enumerable = !!obj[name] && obj.propertyIsEnumerable(name);
      Object.defineProperty(obj, name, {
        configurable: true,
        enumerable,
        writable: true,
        value
      });
    }
    function shimmer(options) {
      if (options && options.logger) {
        if (!isFunction(options.logger))
          logger("new logger isn't a function, not replacing");
        else
          logger = options.logger;
      }
    }
    function wrap(nodule, name, wrapper) {
      if (!nodule || !nodule[name]) {
        logger("no original function " + name + " to wrap");
        return;
      }
      if (!wrapper) {
        logger("no wrapper function");
        logger(new Error().stack);
        return;
      }
      if (!isFunction(nodule[name]) || !isFunction(wrapper)) {
        logger("original object and wrapper must be functions");
        return;
      }
      var original = nodule[name];
      var wrapped = wrapper(original, name);
      defineProperty(wrapped, "__original", original);
      defineProperty(wrapped, "__unwrap", function() {
        if (nodule[name] === wrapped)
          defineProperty(nodule, name, original);
      });
      defineProperty(wrapped, "__wrapped", true);
      defineProperty(nodule, name, wrapped);
      return wrapped;
    }
    function massWrap(nodules, names, wrapper) {
      if (!nodules) {
        logger("must provide one or more modules to patch");
        logger(new Error().stack);
        return;
      } else if (!Array.isArray(nodules)) {
        nodules = [nodules];
      }
      if (!(names && Array.isArray(names))) {
        logger("must provide one or more functions to wrap on modules");
        return;
      }
      nodules.forEach(function(nodule) {
        names.forEach(function(name) {
          wrap(nodule, name, wrapper);
        });
      });
    }
    function unwrap(nodule, name) {
      if (!nodule || !nodule[name]) {
        logger("no function to unwrap.");
        logger(new Error().stack);
        return;
      }
      if (!nodule[name].__unwrap) {
        logger("no original to unwrap to -- has " + name + " already been unwrapped?");
      } else {
        return nodule[name].__unwrap();
      }
    }
    function massUnwrap(nodules, names) {
      if (!nodules) {
        logger("must provide one or more modules to patch");
        logger(new Error().stack);
        return;
      } else if (!Array.isArray(nodules)) {
        nodules = [nodules];
      }
      if (!(names && Array.isArray(names))) {
        logger("must provide one or more functions to unwrap on modules");
        return;
      }
      nodules.forEach(function(nodule) {
        names.forEach(function(name) {
          unwrap(nodule, name);
        });
      });
    }
    shimmer.wrap = wrap;
    shimmer.massWrap = massWrap;
    shimmer.unwrap = unwrap;
    shimmer.massUnwrap = massUnwrap;
    module2.exports = shimmer;
  }
});

// node_modules/emitter-listener/listener.js
var require_listener = __commonJS({
  "node_modules/emitter-listener/listener.js"(exports, module2) {
    "use strict";
    var shimmer = require_shimmer();
    var wrap = shimmer.wrap;
    var unwrap = shimmer.unwrap;
    var SYMBOL = "wrap@before";
    function defineProperty(obj, name, value) {
      var enumerable = !!obj[name] && obj.propertyIsEnumerable(name);
      Object.defineProperty(obj, name, {
        configurable: true,
        enumerable,
        writable: true,
        value
      });
    }
    function _process(self2, listeners) {
      var l = listeners.length;
      for (var p = 0; p < l; p++) {
        var listener = listeners[p];
        var before = self2[SYMBOL];
        if (typeof before === "function") {
          before(listener);
        } else if (Array.isArray(before)) {
          var length = before.length;
          for (var i = 0; i < length; i++)
            before[i](listener);
        }
      }
    }
    function _listeners(self2, event) {
      var listeners;
      listeners = self2._events && self2._events[event];
      if (!Array.isArray(listeners)) {
        if (listeners) {
          listeners = [listeners];
        } else {
          listeners = [];
        }
      }
      return listeners;
    }
    function _findAndProcess(self2, event, before) {
      var after = _listeners(self2, event);
      var unprocessed = after.filter(function(fn) {
        return before.indexOf(fn) === -1;
      });
      if (unprocessed.length > 0)
        _process(self2, unprocessed);
    }
    function _wrap(unwrapped, visit) {
      if (!unwrapped)
        return;
      var wrapped = unwrapped;
      if (typeof unwrapped === "function") {
        wrapped = visit(unwrapped);
      } else if (Array.isArray(unwrapped)) {
        wrapped = [];
        for (var i = 0; i < unwrapped.length; i++) {
          wrapped[i] = visit(unwrapped[i]);
        }
      }
      return wrapped;
    }
    module2.exports = function wrapEmitter(emitter, onAddListener, onEmit) {
      if (!emitter || !emitter.on || !emitter.addListener || !emitter.removeListener || !emitter.emit) {
        throw new Error("can only wrap real EEs");
      }
      if (!onAddListener)
        throw new Error("must have function to run on listener addition");
      if (!onEmit)
        throw new Error("must have function to wrap listeners when emitting");
      function adding(on) {
        return function added(event, listener) {
          var existing = _listeners(this, event).slice();
          try {
            var returned = on.call(this, event, listener);
            _findAndProcess(this, event, existing);
            return returned;
          } finally {
            if (!this.on.__wrapped)
              wrap(this, "on", adding);
            if (!this.addListener.__wrapped)
              wrap(this, "addListener", adding);
          }
        };
      }
      function emitting(emit) {
        return function emitted(event) {
          if (!this._events || !this._events[event])
            return emit.apply(this, arguments);
          var unwrapped = this._events[event];
          function remover(removeListener) {
            return function removed() {
              this._events[event] = unwrapped;
              try {
                return removeListener.apply(this, arguments);
              } finally {
                unwrapped = this._events[event];
                this._events[event] = _wrap(unwrapped, onEmit);
              }
            };
          }
          wrap(this, "removeListener", remover);
          try {
            this._events[event] = _wrap(unwrapped, onEmit);
            return emit.apply(this, arguments);
          } finally {
            unwrap(this, "removeListener");
            this._events[event] = unwrapped;
          }
        };
      }
      if (!emitter[SYMBOL]) {
        defineProperty(emitter, SYMBOL, onAddListener);
      } else if (typeof emitter[SYMBOL] === "function") {
        defineProperty(emitter, SYMBOL, [emitter[SYMBOL], onAddListener]);
      } else if (Array.isArray(emitter[SYMBOL])) {
        emitter[SYMBOL].push(onAddListener);
      }
      if (!emitter.__wrapped) {
        wrap(emitter, "addListener", adding);
        wrap(emitter, "on", adding);
        wrap(emitter, "emit", emitting);
        defineProperty(emitter, "__unwrap", function() {
          unwrap(emitter, "addListener");
          unwrap(emitter, "on");
          unwrap(emitter, "emit");
          delete emitter[SYMBOL];
          delete emitter.__wrapped;
        });
        defineProperty(emitter, "__wrapped", true);
      }
    };
  }
});

// node_modules/cls-hooked/context.js
var require_context = __commonJS({
  "node_modules/cls-hooked/context.js"(exports, module2) {
    "use strict";
    var util = require("util");
    var assert = require("assert");
    var wrapEmitter = require_listener();
    var async_hooks = require("async_hooks");
    var CONTEXTS_SYMBOL = "cls@contexts";
    var ERROR_SYMBOL = "error@context";
    var DEBUG_CLS_HOOKED = process.env.DEBUG_CLS_HOOKED;
    var currentUid = -1;
    module2.exports = {
      getNamespace,
      createNamespace,
      destroyNamespace,
      reset,
      ERROR_SYMBOL
    };
    function Namespace(name) {
      this.name = name;
      this.active = null;
      this._set = [];
      this.id = null;
      this._contexts = new Map();
      this._indent = 0;
    }
    Namespace.prototype.set = function set(key, value) {
      if (!this.active) {
        throw new Error("No context available. ns.run() or ns.bind() must be called first.");
      }
      this.active[key] = value;
      if (DEBUG_CLS_HOOKED) {
        const indentStr = " ".repeat(this._indent < 0 ? 0 : this._indent);
        debug2(indentStr + "CONTEXT-SET KEY:" + key + "=" + value + " in ns:" + this.name + " currentUid:" + currentUid + " active:" + util.inspect(this.active, { showHidden: true, depth: 2, colors: true }));
      }
      return value;
    };
    Namespace.prototype.get = function get(key) {
      if (!this.active) {
        if (DEBUG_CLS_HOOKED) {
          const asyncHooksCurrentId = async_hooks.currentId();
          const triggerId = async_hooks.triggerAsyncId();
          const indentStr = " ".repeat(this._indent < 0 ? 0 : this._indent);
          debug2(`${indentStr}CONTEXT-GETTING KEY NO ACTIVE NS: (${this.name}) ${key}=undefined currentUid:${currentUid} asyncHooksCurrentId:${asyncHooksCurrentId} triggerId:${triggerId} len:${this._set.length}`);
        }
        return void 0;
      }
      if (DEBUG_CLS_HOOKED) {
        const asyncHooksCurrentId = async_hooks.executionAsyncId();
        const triggerId = async_hooks.triggerAsyncId();
        const indentStr = " ".repeat(this._indent < 0 ? 0 : this._indent);
        debug2(indentStr + "CONTEXT-GETTING KEY:" + key + "=" + this.active[key] + " (" + this.name + ") currentUid:" + currentUid + " active:" + util.inspect(this.active, { showHidden: true, depth: 2, colors: true }));
        debug2(`${indentStr}CONTEXT-GETTING KEY: (${this.name}) ${key}=${this.active[key]} currentUid:${currentUid} asyncHooksCurrentId:${asyncHooksCurrentId} triggerId:${triggerId} len:${this._set.length} active:${util.inspect(this.active)}`);
      }
      return this.active[key];
    };
    Namespace.prototype.createContext = function createContext() {
      let context = Object.create(this.active ? this.active : Object.prototype);
      context._ns_name = this.name;
      context.id = currentUid;
      if (DEBUG_CLS_HOOKED) {
        const asyncHooksCurrentId = async_hooks.executionAsyncId();
        const triggerId = async_hooks.triggerAsyncId();
        const indentStr = " ".repeat(this._indent < 0 ? 0 : this._indent);
        debug2(`${indentStr}CONTEXT-CREATED Context: (${this.name}) currentUid:${currentUid} asyncHooksCurrentId:${asyncHooksCurrentId} triggerId:${triggerId} len:${this._set.length} context:${util.inspect(context, { showHidden: true, depth: 2, colors: true })}`);
      }
      return context;
    };
    Namespace.prototype.run = function run(fn) {
      let context = this.createContext();
      this.enter(context);
      try {
        if (DEBUG_CLS_HOOKED) {
          const triggerId = async_hooks.triggerAsyncId();
          const asyncHooksCurrentId = async_hooks.executionAsyncId();
          const indentStr = " ".repeat(this._indent < 0 ? 0 : this._indent);
          debug2(`${indentStr}CONTEXT-RUN BEGIN: (${this.name}) currentUid:${currentUid} triggerId:${triggerId} asyncHooksCurrentId:${asyncHooksCurrentId} len:${this._set.length} context:${util.inspect(context)}`);
        }
        fn(context);
        return context;
      } catch (exception) {
        if (exception) {
          exception[ERROR_SYMBOL] = context;
        }
        throw exception;
      } finally {
        if (DEBUG_CLS_HOOKED) {
          const triggerId = async_hooks.triggerAsyncId();
          const asyncHooksCurrentId = async_hooks.executionAsyncId();
          const indentStr = " ".repeat(this._indent < 0 ? 0 : this._indent);
          debug2(`${indentStr}CONTEXT-RUN END: (${this.name}) currentUid:${currentUid} triggerId:${triggerId} asyncHooksCurrentId:${asyncHooksCurrentId} len:${this._set.length} ${util.inspect(context)}`);
        }
        this.exit(context);
      }
    };
    Namespace.prototype.runAndReturn = function runAndReturn(fn) {
      let value;
      this.run(function(context) {
        value = fn(context);
      });
      return value;
    };
    Namespace.prototype.runPromise = function runPromise(fn) {
      let context = this.createContext();
      this.enter(context);
      let promise = fn(context);
      if (!promise || !promise.then || !promise.catch) {
        throw new Error("fn must return a promise.");
      }
      if (DEBUG_CLS_HOOKED) {
        debug2("CONTEXT-runPromise BEFORE: (" + this.name + ") currentUid:" + currentUid + " len:" + this._set.length + " " + util.inspect(context));
      }
      return promise.then((result) => {
        if (DEBUG_CLS_HOOKED) {
          debug2("CONTEXT-runPromise AFTER then: (" + this.name + ") currentUid:" + currentUid + " len:" + this._set.length + " " + util.inspect(context));
        }
        this.exit(context);
        return result;
      }).catch((err) => {
        err[ERROR_SYMBOL] = context;
        if (DEBUG_CLS_HOOKED) {
          debug2("CONTEXT-runPromise AFTER catch: (" + this.name + ") currentUid:" + currentUid + " len:" + this._set.length + " " + util.inspect(context));
        }
        this.exit(context);
        throw err;
      });
    };
    Namespace.prototype.bind = function bindFactory(fn, context) {
      if (!context) {
        if (!this.active) {
          context = this.createContext();
        } else {
          context = this.active;
        }
      }
      let self2 = this;
      return function clsBind() {
        self2.enter(context);
        try {
          return fn.apply(this, arguments);
        } catch (exception) {
          if (exception) {
            exception[ERROR_SYMBOL] = context;
          }
          throw exception;
        } finally {
          self2.exit(context);
        }
      };
    };
    Namespace.prototype.enter = function enter(context) {
      assert.ok(context, "context must be provided for entering");
      if (DEBUG_CLS_HOOKED) {
        const asyncHooksCurrentId = async_hooks.executionAsyncId();
        const triggerId = async_hooks.triggerAsyncId();
        const indentStr = " ".repeat(this._indent < 0 ? 0 : this._indent);
        debug2(`${indentStr}CONTEXT-ENTER: (${this.name}) currentUid:${currentUid} triggerId:${triggerId} asyncHooksCurrentId:${asyncHooksCurrentId} len:${this._set.length} ${util.inspect(context)}`);
      }
      this._set.push(this.active);
      this.active = context;
    };
    Namespace.prototype.exit = function exit(context) {
      assert.ok(context, "context must be provided for exiting");
      if (DEBUG_CLS_HOOKED) {
        const asyncHooksCurrentId = async_hooks.executionAsyncId();
        const triggerId = async_hooks.triggerAsyncId();
        const indentStr = " ".repeat(this._indent < 0 ? 0 : this._indent);
        debug2(`${indentStr}CONTEXT-EXIT: (${this.name}) currentUid:${currentUid} triggerId:${triggerId} asyncHooksCurrentId:${asyncHooksCurrentId} len:${this._set.length} ${util.inspect(context)}`);
      }
      if (this.active === context) {
        assert.ok(this._set.length, "can't remove top context");
        this.active = this._set.pop();
        return;
      }
      let index = this._set.lastIndexOf(context);
      if (index < 0) {
        if (DEBUG_CLS_HOOKED) {
          debug2("??ERROR?? context exiting but not entered - ignoring: " + util.inspect(context));
        }
        assert.ok(index >= 0, "context not currently entered; can't exit. \n" + util.inspect(this) + "\n" + util.inspect(context));
      } else {
        assert.ok(index, "can't remove top context");
        this._set.splice(index, 1);
      }
    };
    Namespace.prototype.bindEmitter = function bindEmitter(emitter) {
      assert.ok(emitter.on && emitter.addListener && emitter.emit, "can only bind real EEs");
      let namespace = this;
      let thisSymbol = "context@" + this.name;
      function attach(listener) {
        if (!listener) {
          return;
        }
        if (!listener[CONTEXTS_SYMBOL]) {
          listener[CONTEXTS_SYMBOL] = Object.create(null);
        }
        listener[CONTEXTS_SYMBOL][thisSymbol] = {
          namespace,
          context: namespace.active
        };
      }
      function bind(unwrapped) {
        if (!(unwrapped && unwrapped[CONTEXTS_SYMBOL])) {
          return unwrapped;
        }
        let wrapped = unwrapped;
        let unwrappedContexts = unwrapped[CONTEXTS_SYMBOL];
        Object.keys(unwrappedContexts).forEach(function(name) {
          let thunk = unwrappedContexts[name];
          wrapped = thunk.namespace.bind(wrapped, thunk.context);
        });
        return wrapped;
      }
      wrapEmitter(emitter, attach, bind);
    };
    Namespace.prototype.fromException = function fromException(exception) {
      return exception[ERROR_SYMBOL];
    };
    function getNamespace(name) {
      return process.namespaces[name];
    }
    function createNamespace(name) {
      assert.ok(name, "namespace must be given a name.");
      if (DEBUG_CLS_HOOKED) {
        debug2(`NS-CREATING NAMESPACE (${name})`);
      }
      let namespace = new Namespace(name);
      namespace.id = currentUid;
      const hook = async_hooks.createHook({
        init(asyncId, type, triggerId, resource) {
          currentUid = async_hooks.executionAsyncId();
          if (namespace.active) {
            namespace._contexts.set(asyncId, namespace.active);
            if (DEBUG_CLS_HOOKED) {
              const indentStr = " ".repeat(namespace._indent < 0 ? 0 : namespace._indent);
              debug2(`${indentStr}INIT [${type}] (${name}) asyncId:${asyncId} currentUid:${currentUid} triggerId:${triggerId} active:${util.inspect(namespace.active, { showHidden: true, depth: 2, colors: true })} resource:${resource}`);
            }
          } else if (currentUid === 0) {
            const triggerId2 = async_hooks.triggerAsyncId();
            const triggerIdContext = namespace._contexts.get(triggerId2);
            if (triggerIdContext) {
              namespace._contexts.set(asyncId, triggerIdContext);
              if (DEBUG_CLS_HOOKED) {
                const indentStr = " ".repeat(namespace._indent < 0 ? 0 : namespace._indent);
                debug2(`${indentStr}INIT USING CONTEXT FROM TRIGGERID [${type}] (${name}) asyncId:${asyncId} currentUid:${currentUid} triggerId:${triggerId2} active:${util.inspect(namespace.active, { showHidden: true, depth: 2, colors: true })} resource:${resource}`);
              }
            } else if (DEBUG_CLS_HOOKED) {
              const indentStr = " ".repeat(namespace._indent < 0 ? 0 : namespace._indent);
              debug2(`${indentStr}INIT MISSING CONTEXT [${type}] (${name}) asyncId:${asyncId} currentUid:${currentUid} triggerId:${triggerId2} active:${util.inspect(namespace.active, { showHidden: true, depth: 2, colors: true })} resource:${resource}`);
            }
          }
          if (DEBUG_CLS_HOOKED && type === "PROMISE") {
            debug2(util.inspect(resource, { showHidden: true }));
            const parentId = resource.parentId;
            const indentStr = " ".repeat(namespace._indent < 0 ? 0 : namespace._indent);
            debug2(`${indentStr}INIT RESOURCE-PROMISE [${type}] (${name}) parentId:${parentId} asyncId:${asyncId} currentUid:${currentUid} triggerId:${triggerId} active:${util.inspect(namespace.active, { showHidden: true, depth: 2, colors: true })} resource:${resource}`);
          }
        },
        before(asyncId) {
          currentUid = async_hooks.executionAsyncId();
          let context;
          context = namespace._contexts.get(asyncId) || namespace._contexts.get(currentUid);
          if (context) {
            if (DEBUG_CLS_HOOKED) {
              const triggerId = async_hooks.triggerAsyncId();
              const indentStr = " ".repeat(namespace._indent < 0 ? 0 : namespace._indent);
              debug2(`${indentStr}BEFORE (${name}) asyncId:${asyncId} currentUid:${currentUid} triggerId:${triggerId} active:${util.inspect(namespace.active, { showHidden: true, depth: 2, colors: true })} context:${util.inspect(context)}`);
              namespace._indent += 2;
            }
            namespace.enter(context);
          } else if (DEBUG_CLS_HOOKED) {
            const triggerId = async_hooks.triggerAsyncId();
            const indentStr = " ".repeat(namespace._indent < 0 ? 0 : namespace._indent);
            debug2(`${indentStr}BEFORE MISSING CONTEXT (${name}) asyncId:${asyncId} currentUid:${currentUid} triggerId:${triggerId} active:${util.inspect(namespace.active, { showHidden: true, depth: 2, colors: true })} namespace._contexts:${util.inspect(namespace._contexts, { showHidden: true, depth: 2, colors: true })}`);
            namespace._indent += 2;
          }
        },
        after(asyncId) {
          currentUid = async_hooks.executionAsyncId();
          let context;
          context = namespace._contexts.get(asyncId) || namespace._contexts.get(currentUid);
          if (context) {
            if (DEBUG_CLS_HOOKED) {
              const triggerId = async_hooks.triggerAsyncId();
              namespace._indent -= 2;
              const indentStr = " ".repeat(namespace._indent < 0 ? 0 : namespace._indent);
              debug2(`${indentStr}AFTER (${name}) asyncId:${asyncId} currentUid:${currentUid} triggerId:${triggerId} active:${util.inspect(namespace.active, { showHidden: true, depth: 2, colors: true })} context:${util.inspect(context)}`);
            }
            namespace.exit(context);
          } else if (DEBUG_CLS_HOOKED) {
            const triggerId = async_hooks.triggerAsyncId();
            namespace._indent -= 2;
            const indentStr = " ".repeat(namespace._indent < 0 ? 0 : namespace._indent);
            debug2(`${indentStr}AFTER MISSING CONTEXT (${name}) asyncId:${asyncId} currentUid:${currentUid} triggerId:${triggerId} active:${util.inspect(namespace.active, { showHidden: true, depth: 2, colors: true })} context:${util.inspect(context)}`);
          }
        },
        destroy(asyncId) {
          currentUid = async_hooks.executionAsyncId();
          if (DEBUG_CLS_HOOKED) {
            const triggerId = async_hooks.triggerAsyncId();
            const indentStr = " ".repeat(namespace._indent < 0 ? 0 : namespace._indent);
            debug2(`${indentStr}DESTROY (${name}) currentUid:${currentUid} asyncId:${asyncId} triggerId:${triggerId} active:${util.inspect(namespace.active, { showHidden: true, depth: 2, colors: true })} context:${util.inspect(namespace._contexts.get(currentUid))}`);
          }
          namespace._contexts.delete(asyncId);
        }
      });
      hook.enable();
      process.namespaces[name] = namespace;
      return namespace;
    }
    function destroyNamespace(name) {
      let namespace = getNamespace(name);
      assert.ok(namespace, `can't delete nonexistent namespace! "` + name + '"');
      assert.ok(namespace.id, "don't assign to process.namespaces directly! " + util.inspect(namespace));
      process.namespaces[name] = null;
    }
    function reset() {
      if (process.namespaces) {
        Object.keys(process.namespaces).forEach(function(name) {
          destroyNamespace(name);
        });
      }
      process.namespaces = Object.create(null);
    }
    process.namespaces = {};
    function debug2(...args) {
      if (DEBUG_CLS_HOOKED) {
        process._rawDebug(`${util.format(...args)}`);
      }
    }
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/logger.js
var require_logger = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/logger.js"(exports, module2) {
    "use strict";
    var validLogLevels = ["debug", "info", "warn", "error", "silent"];
    var defaultLogLevel = validLogLevels.indexOf("error");
    var logLevel = calculateLogLevel(process.env.AWS_XRAY_DEBUG_MODE ? "debug" : process.env.AWS_XRAY_LOG_LEVEL);
    var logger = {
      error: createLoggerForLevel("error"),
      info: createLoggerForLevel("info"),
      warn: createLoggerForLevel("warn"),
      debug: createLoggerForLevel("debug")
    };
    function createLoggerForLevel(level) {
      var loggerLevel = validLogLevels.indexOf(level);
      var consoleMethod = console[level] || console.log || (() => {
      });
      if (loggerLevel >= logLevel) {
        return (message, meta) => {
          if (message || meta) {
            consoleMethod(formatLogMessage(level, message, meta));
          }
        };
      } else {
        return () => {
        };
      }
    }
    function calculateLogLevel(level) {
      if (level) {
        var normalisedLevel = level.toLowerCase();
        var index = validLogLevels.indexOf(normalisedLevel);
        return index >= 0 ? index : defaultLogLevel;
      }
      return defaultLogLevel;
    }
    function createTimestamp(date) {
      var tzo = -date.getTimezoneOffset(), dif = tzo >= 0 ? "+" : "-", pad = function(num) {
        var norm = Math.floor(Math.abs(num));
        return (norm < 10 ? "0" : "") + norm;
      };
      return new Date(date.getTime() + tzo * 60 * 1e3).toISOString().replace(/T/, " ").replace(/Z/, " ") + dif + pad(tzo / 60) + ":" + pad(tzo % 60);
    }
    function isLambdaFunction() {
      return process.env.LAMBDA_TASK_ROOT !== void 0;
    }
    function formatLogMessage(level, message, meta) {
      var messageParts = [];
      if (!isLambdaFunction()) {
        messageParts.push(createTimestamp(new Date()));
        messageParts.push(`[${level.toUpperCase()}]`);
      }
      if (message) {
        messageParts.push(message);
      }
      var logString = messageParts.join(" ");
      var metaDataString = formatMetaData(meta);
      return [logString, metaDataString].filter((str) => str.length > 0).join("\n  ");
    }
    function formatMetaData(meta) {
      if (!meta) {
        return "";
      }
      return typeof meta === "string" ? meta : JSON.stringify(meta);
    }
    var logging = {
      setLogger: function setLogger(logObj) {
        logger = logObj;
      },
      getLogger: function getLogger() {
        return logger;
      }
    };
    module2.exports = logging;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/segments/attributes/captured_exception.js
var require_captured_exception = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/segments/attributes/captured_exception.js"(exports, module2) {
    "use strict";
    function CapturedException(err, remote) {
      this.init(err, remote);
    }
    CapturedException.prototype.init = function init(err, remote) {
      var e = typeof err === "string" || err instanceof String ? { message: err, name: "" } : err;
      this.message = e.message;
      this.type = e.name;
      this.stack = [];
      this.remote = !!remote;
      if (e.stack) {
        var stack = e.stack.split("\n");
        stack.shift();
        var self2 = this;
        stack.forEach(function(stackline) {
          var line = stackline.trim().replace(/\(|\)/g, "");
          line = line.substring(line.indexOf(" ") + 1);
          var label = line.lastIndexOf(" ") >= 0 ? line.slice(0, line.lastIndexOf(" ")) : null;
          var path2 = Array.isArray(label) && !label.length ? line : line.slice(line.lastIndexOf(" ") + 1);
          path2 = path2.split(":");
          var entry = {
            path: path2[0],
            line: parseInt(path2[1]),
            label: label || "anonymous"
          };
          self2.stack.push(entry);
        });
      }
    };
    module2.exports = CapturedException;
  }
});

// node_modules/atomic-batcher/index.js
var require_atomic_batcher = __commonJS({
  "node_modules/atomic-batcher/index.js"(exports, module2) {
    module2.exports = batcher;
    function batcher(run) {
      var running = false;
      var pendingBatch = null;
      var pendingCallbacks = null;
      var callbacks = null;
      return append;
      function done(err) {
        if (callbacks)
          callAll(callbacks, err);
        running = false;
        callbacks = pendingCallbacks;
        var nextBatch = pendingBatch;
        pendingBatch = null;
        pendingCallbacks = null;
        if (!nextBatch || !nextBatch.length) {
          if (!callbacks || !callbacks.length) {
            callbacks = null;
            return;
          }
          if (!nextBatch)
            nextBatch = [];
        }
        running = true;
        run(nextBatch, done);
      }
      function append(val, cb) {
        if (running) {
          if (!pendingBatch) {
            pendingBatch = [];
            pendingCallbacks = [];
          }
          pushAll(pendingBatch, val);
          if (cb)
            pendingCallbacks.push(cb);
        } else {
          if (cb)
            callbacks = [cb];
          running = true;
          run(Array.isArray(val) ? val : [val], done);
        }
      }
    }
    function pushAll(list, val) {
      if (Array.isArray(val))
        pushArray(list, val);
      else
        list.push(val);
    }
    function pushArray(list, val) {
      for (var i = 0; i < val.length; i++)
        list.push(val[i]);
    }
    function callAll(list, err) {
      for (var i = 0; i < list.length; i++)
        list[i](err);
    }
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/daemon_config.js
var require_daemon_config = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/daemon_config.js"(exports, module2) {
    "use strict";
    var logger = require_logger();
    var DaemonConfig = {
      udp_ip: "127.0.0.1",
      udp_port: 2e3,
      tcp_ip: "127.0.0.1",
      tcp_port: 2e3,
      setDaemonAddress: function setDaemonAddress(address) {
        if (!process.env.AWS_XRAY_DAEMON_ADDRESS) {
          processAddress(address);
          logger.getLogger().info("Configured daemon address to " + address + ".");
        } else {
          logger.getLogger().warn("Ignoring call to setDaemonAddress as AWS_XRAY_DAEMON_ADDRESS is set. The current daemon address will not be changed.");
        }
      }
    };
    var processAddress = function processAddress2(address) {
      if (address.indexOf(":") === -1) {
        throw new Error("Invalid Daemon Address. You must specify an ip and port.");
      } else {
        var splitAddress = address.split(" ");
        if (splitAddress.length === 1) {
          if (address.indexOf("udp") > -1 || address.indexOf("tcp") > -1) {
            throw new Error("Invalid Daemon Address. You must specify both tcp and udp addresses.");
          }
          var addr = address.split(":");
          if (!addr[0])
            throw new Error("Invalid Daemon Address. You must specify an ip.");
          DaemonConfig.udp_ip = addr[0];
          DaemonConfig.tcp_ip = addr[0];
          DaemonConfig.udp_port = addr[1];
          DaemonConfig.tcp_port = addr[1];
        } else if (splitAddress.length === 2) {
          var part_1 = splitAddress[0].split(":");
          var part_2 = splitAddress[1].split(":");
          var addr_map = {};
          addr_map[part_1[0]] = part_1;
          addr_map[part_2[0]] = part_2;
          DaemonConfig.udp_ip = addr_map["udp"][1];
          DaemonConfig.udp_port = parseInt(addr_map["udp"][2]);
          DaemonConfig.tcp_ip = addr_map["tcp"][1];
          DaemonConfig.tcp_port = parseInt(addr_map["tcp"][2]);
          if (!DaemonConfig.udp_port || !DaemonConfig.tcp_port) {
            throw new Error("Invalid Daemon Address. You must specify port number.");
          }
        }
      }
    };
    if (process.env.AWS_XRAY_DAEMON_ADDRESS)
      processAddress(process.env.AWS_XRAY_DAEMON_ADDRESS);
    module2.exports = DaemonConfig;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/segment_emitter.js
var require_segment_emitter = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/segment_emitter.js"(exports, module2) {
    "use strict";
    var dgram = require("dgram");
    var batcher = require_atomic_batcher();
    var logger = require_logger();
    var PROTOCOL_HEADER = '{"format":"json","version":1}';
    var PROTOCOL_DELIMITER = "\n";
    function batchSendData(ops, callback) {
      var client = dgram.createSocket("udp4");
      executeSendData(client, ops, 0, function() {
        try {
          client.close();
        } finally {
          callback();
        }
      });
    }
    function executeSendData(client, ops, index, callback) {
      if (index >= ops.length) {
        callback();
        return;
      }
      sendMessage(client, ops[index], function() {
        executeSendData(client, ops, index + 1, callback);
      });
    }
    function sendMessage(client, data, batchCallback) {
      var msg = data.msg;
      var offset = data.offset;
      var length = data.length;
      var port = data.port;
      var address = data.address;
      var callback = data.callback;
      client.send(msg, offset, length, port, address, function(err) {
        try {
          callback(err);
        } finally {
          batchCallback();
        }
      });
    }
    function BatchingTemporarySocket() {
      this.batchSend = batcher(batchSendData);
    }
    BatchingTemporarySocket.prototype.send = function(msg, offset, length, port, address, callback) {
      var work = {
        msg,
        offset,
        length,
        port,
        address,
        callback
      };
      this.batchSend(work);
    };
    var SegmentEmitter = {
      daemonConfig: require_daemon_config(),
      format: function format(segment) {
        return PROTOCOL_HEADER + PROTOCOL_DELIMITER + segment.toString();
      },
      send: function send(segment) {
        if (!this.socket) {
          if (this.useBatchingTemporarySocket) {
            this.socket = new BatchingTemporarySocket();
          } else {
            this.socket = dgram.createSocket("udp4").unref();
          }
        }
        var client = this.socket;
        var formatted = segment.format();
        var data = PROTOCOL_HEADER + PROTOCOL_DELIMITER + formatted;
        var message = Buffer.from(data);
        var short = '{"trace_id:"' + segment.trace_id + '","id":"' + segment.id + '"}';
        var type = segment.type === "subsegment" ? "Subsegment" : "Segment";
        client.send(message, 0, message.length, this.daemonConfig.udp_port, this.daemonConfig.udp_ip, function(err) {
          if (err) {
            if (err.code === "EMSGSIZE")
              logger.getLogger().error(type + " too large to send: " + short + " (" + message.length + " bytes).");
            else
              logger.getLogger().error("Error occured sending segment: ", err);
          } else {
            logger.getLogger().debug(type + ' sent: {"trace_id:"' + segment.trace_id + '","id":"' + segment.id + '"}');
            logger.getLogger().debug("UDP message sent: " + segment);
          }
        });
      },
      setDaemonAddress: function setDaemonAddress(address) {
        this.daemonConfig.setDaemonAddress(address);
      },
      getIp: function getIp() {
        return this.daemonConfig.udp_ip;
      },
      getPort: function getPort() {
        return this.daemonConfig.udp_port;
      },
      disableReusableSocket: function() {
        this.useBatchingTemporarySocket = true;
      }
    };
    module2.exports = SegmentEmitter;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/segments/attributes/trace_id.js
var require_trace_id = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/segments/attributes/trace_id.js"(exports, module2) {
    "use strict";
    var crypto = require("crypto");
    var logger = require_logger();
    var TraceID = class {
      constructor(tsHex, numberhex) {
        this.version = 1;
        this.timestamp = tsHex || Math.round(new Date().getTime() / 1e3).toString(16);
        this.id = numberhex || crypto.randomBytes(12).toString("hex");
      }
      static Invalid() {
        return new TraceID("00000000", "000000000000000000000000");
      }
      static FromString(rawID) {
        const DELIMITER = "-";
        var traceID = new TraceID();
        var version, timestamp;
        if (!rawID || typeof rawID !== "string") {
          logger.getLogger().error("Empty or non-string trace ID provided");
          return traceID;
        }
        const parts = rawID.trim().split(DELIMITER);
        if (parts.length !== 3) {
          logger.getLogger().error("Unrecognized trace ID format");
          return traceID;
        }
        version = parseInt(parts[0]);
        if (version === NaN || version < 1) {
          logger.getLogger().error("Trace ID version must be positive integer");
          return traceID;
        }
        timestamp = parseInt(parts[1], 16).toString(16);
        if (timestamp === "NaN") {
          logger.getLogger().error("Trace ID timestamp must be a hex-encoded value");
          return traceID;
        }
        traceID.version = version;
        traceID.timestamp = timestamp;
        traceID.id = parts[2];
        return traceID;
      }
      toString() {
        return `${this.version.toString()}-${this.timestamp}-${this.id}`;
      }
    };
    module2.exports = TraceID;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/utils.js
var require_utils4 = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/utils.js"(exports, module2) {
    "use strict";
    var crypto = require("crypto");
    var logger = require_logger();
    var TraceID = require_trace_id();
    var utils = {
      getCauseTypeFromHttpStatus: function getCauseTypeFromHttpStatus(status) {
        var stat = status.toString();
        if (stat.match(/^[4][0-9]{2}$/) !== null)
          return "error";
        else if (stat.match(/^[5][0-9]{2}$/) !== null)
          return "fault";
      },
      stripQueryStringFromPath: function stripQueryStringFromPath(path2) {
        return path2 ? path2.split("?")[0] : "";
      },
      wildcardMatch: function wildcardMatch(pattern, text) {
        if (pattern === void 0 || text === void 0)
          return false;
        if (pattern.length === 1 && pattern.charAt(0) === "*")
          return true;
        var patternLength = pattern.length;
        var textLength = text.length;
        var indexOfGlob = pattern.indexOf("*");
        pattern = pattern.toLowerCase();
        text = text.toLowerCase();
        if (indexOfGlob === -1 || indexOfGlob === patternLength - 1) {
          var match = function simpleWildcardMatch() {
            var j2 = 0;
            for (var i2 = 0; i2 < patternLength; i2++) {
              var patternChar2 = pattern.charAt(i2);
              if (patternChar2 === "*") {
                return true;
              } else if (patternChar2 === "?") {
                if (j2 === textLength)
                  return false;
                j2++;
              } else {
                if (j2 >= textLength || patternChar2 != text.charAt(j2))
                  return false;
                j2++;
              }
            }
            return j2 === textLength;
          };
          return match();
        }
        var matchArray = [];
        matchArray[0] = true;
        for (var j = 0; j < patternLength; j++) {
          var i;
          var patternChar = pattern.charAt(j);
          if (patternChar != "*") {
            for (i = textLength - 1; i >= 0; i--)
              matchArray[i + 1] = !!matchArray[i] && (patternChar === "?" || patternChar === text.charAt(i));
          } else {
            i = 0;
            while (i <= textLength && !matchArray[i])
              i++;
            for (i; i <= textLength; i++)
              matchArray[i] = true;
          }
          matchArray[0] = matchArray[0] && patternChar === "*";
        }
        return matchArray[textLength];
      },
      LambdaUtils: {
        validTraceData: function(xAmznTraceId) {
          var valid = false;
          if (xAmznTraceId) {
            var data = utils.processTraceData(xAmznTraceId);
            valid = !!(data && data.root && data.parent && data.sampled);
          }
          return valid;
        },
        populateTraceData: function(segment, xAmznTraceId) {
          logger.getLogger().debug("Lambda trace data found: " + xAmznTraceId);
          var data = utils.processTraceData(xAmznTraceId);
          var valid = false;
          if (!data) {
            data = {};
            logger.getLogger().error("_X_AMZN_TRACE_ID is empty or has an invalid format");
          } else if (!data.root || !data.parent || !data.sampled) {
            logger.getLogger().error("_X_AMZN_TRACE_ID is missing required information");
          } else {
            valid = true;
          }
          segment.trace_id = TraceID.FromString(data.root).toString();
          segment.id = data.parent || crypto.randomBytes(8).toString("hex");
          if (data.root && segment.trace_id !== data.root) {
            logger.getLogger().error("_X_AMZN_TRACE_ID contains invalid trace ID");
            valid = false;
          }
          if (!parseInt(data.sampled))
            segment.notTraced = true;
          else
            delete segment.notTraced;
          logger.getLogger().debug("Segment started: " + JSON.stringify(data));
          return valid;
        }
      },
      processTraceData: function processTraceData(traceData) {
        var amznTraceData = {};
        var reservedKeywords = ["root", "parent", "sampled", "self"];
        var remainingBytes = 256;
        if (!(typeof traceData === "string" && traceData))
          return amznTraceData;
        traceData.split(";").forEach(function(header) {
          if (!header)
            return;
          var pair = header.split("=");
          if (pair[0] && pair[1]) {
            var key = pair[0].trim().toLowerCase();
            var value = pair[1].trim().toLowerCase();
            var reserved = reservedKeywords.indexOf(key) !== -1;
            if (reserved) {
              amznTraceData[key] = value;
            } else if (!reserved && remainingBytes - (key.length + value.length) >= 0) {
              amznTraceData[key] = value;
              remainingBytes -= key.length + value.length;
            }
          }
        });
        return amznTraceData;
      },
      objectWithoutProperties: function objectWithoutProperties(obj, keys, preservePrototype) {
        keys = Array.isArray(keys) ? keys : [];
        preservePrototype = typeof preservePrototype === "boolean" ? preservePrototype : false;
        var target = preservePrototype ? Object.create(Object.getPrototypeOf(obj)) : {};
        for (var property in obj) {
          if (keys.indexOf(property) >= 0)
            continue;
          if (!Object.prototype.hasOwnProperty.call(obj, property))
            continue;
          target[property] = obj[property];
        }
        return target;
      },
      safeParseInt: (val) => {
        if (!val || isNaN(val)) {
          return 0;
        }
        return parseInt(val);
      }
    };
    module2.exports = utils;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/segments/segment_utils.js
var require_segment_utils = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/segments/segment_utils.js"(exports, module2) {
    "use strict";
    var { safeParseInt } = require_utils4();
    var logger = require_logger();
    var DEFAULT_STREAMING_THRESHOLD = 100;
    var utils = {
      streamingThreshold: DEFAULT_STREAMING_THRESHOLD,
      getCurrentTime: function getCurrentTime() {
        return Date.now() / 1e3;
      },
      setOrigin: function setOrigin(origin) {
        this.origin = origin;
      },
      setPluginData: function setPluginData(pluginData) {
        this.pluginData = pluginData;
      },
      setSDKData: function setSDKData(sdkData) {
        this.sdkData = sdkData;
      },
      setServiceData: function setServiceData(serviceData) {
        this.serviceData = serviceData;
      },
      setStreamingThreshold: function setStreamingThreshold(threshold) {
        if (isFinite(threshold) && threshold >= 0) {
          utils.streamingThreshold = threshold;
          logger.getLogger().debug("Subsegment streaming threshold set to: " + threshold);
        } else {
          logger.getLogger().error("Invalid threshold: " + threshold + ". Must be a whole number >= 0.");
        }
      },
      getStreamingThreshold: function getStreamingThreshold() {
        return utils.streamingThreshold;
      },
      getHttpResponseData: (res) => {
        const ret = {};
        if (!res) {
          return ret;
        }
        const status = safeParseInt(res.statusCode);
        if (status !== 0) {
          ret.status = status;
        }
        if (res.headers && res.headers["content-length"]) {
          ret.content_length = safeParseInt(res.headers["content-length"]);
        }
        return ret;
      }
    };
    module2.exports = utils;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/segments/attributes/remote_request_data.js
var require_remote_request_data = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/segments/attributes/remote_request_data.js"(exports, module2) {
    "use strict";
    var { getHttpResponseData } = require_segment_utils();
    var { stripQueryStringFromPath } = require_utils4();
    function RemoteRequestData(req, res, downstreamXRayEnabled) {
      this.init(req, res, downstreamXRayEnabled);
    }
    RemoteRequestData.prototype.init = function init(req, res, downstreamXRayEnabled) {
      this.request = {
        url: req.agent && req.agent.protocol ? req.agent.protocol + "//" + req.getHeader("host") + stripQueryStringFromPath(req.path) : "",
        method: req.method || ""
      };
      if (downstreamXRayEnabled) {
        this.request.traced = true;
      }
      if (res) {
        this.response = getHttpResponseData(res);
      }
    };
    module2.exports = RemoteRequestData;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/segments/attributes/subsegment.js
var require_subsegment = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/segments/attributes/subsegment.js"(exports, module2) {
    "use strict";
    var crypto = require("crypto");
    var CapturedException = require_captured_exception();
    var RemoteRequestData = require_remote_request_data();
    var SegmentEmitter = require_segment_emitter();
    var SegmentUtils = require_segment_utils();
    var Utils = require_utils4();
    var logger = require_logger();
    function Subsegment(name) {
      this.init(name);
    }
    Subsegment.prototype.init = function init(name) {
      if (typeof name != "string")
        throw new Error("Subsegment name must be of type string.");
      this.id = crypto.randomBytes(8).toString("hex");
      this.name = name;
      this.start_time = SegmentUtils.getCurrentTime();
      this.in_progress = true;
      this.counter = 0;
    };
    Subsegment.prototype.addNewSubsegment = function addNewSubsegment(name) {
      var subsegment = new Subsegment(name);
      this.addSubsegment(subsegment);
      return subsegment;
    };
    Subsegment.prototype.addSubsegment = function(subsegment) {
      if (!(subsegment instanceof Subsegment)) {
        throw new Error("Failed to add subsegment:" + subsegment + ' to subsegment "' + this.name + '".  Not a subsegment.');
      }
      if (this.subsegments === void 0)
        this.subsegments = [];
      subsegment.segment = this.segment;
      subsegment.parent = this;
      if (subsegment.end_time === void 0) {
        this.incrementCounter(subsegment.counter);
      }
      this.subsegments.push(subsegment);
    };
    Subsegment.prototype.removeSubsegment = function removeSubsegment(subsegment) {
      if (!(subsegment instanceof Subsegment)) {
        throw new Error("Failed to remove subsegment:" + subsegment + ' from subsegment "' + this.name + '".  Not a subsegment.');
      }
      if (this.subsegments !== void 0) {
        var index = this.subsegments.indexOf(subsegment);
        if (index >= 0)
          this.subsegments.splice(index, 1);
      }
    };
    Subsegment.prototype.addAttribute = function addAttribute(name, data) {
      this[name] = data;
    };
    Subsegment.prototype.addPrecursorId = function(id) {
      if (typeof id !== "string")
        logger.getLogger().error("Failed to add id:" + id + " to subsegment " + this.name + ".  Precursor Ids must be of type string.");
      if (this.precursor_ids === void 0)
        this.precursor_ids = [];
      this.precursor_ids.push(id);
    };
    Subsegment.prototype.addAnnotation = function(key, value) {
      if (!(typeof value === "boolean" || typeof value === "string" || typeof value === "number" && isFinite(value))) {
        throw new Error("Failed to add annotation key: " + key + " value: " + value + " to subsegment " + this.name + ". Value must be of type string, number or boolean.");
      } else if (typeof key !== "string") {
        throw new Error("Failed to add annotation key: " + key + " value: " + value + " to subsegment " + this.name + ". Key must be of type string.");
      }
      if (this.annotations === void 0)
        this.annotations = {};
      this.annotations[key] = value;
    };
    Subsegment.prototype.addMetadata = function(key, value, namespace) {
      if (typeof key !== "string") {
        throw new Error("Failed to add annotation key: " + key + " value: " + value + " to subsegment " + this.name + ". Key must be of type string.");
      } else if (namespace && typeof namespace !== "string") {
        throw new Error("Failed to add annotation key: " + key + " value: " + value + "namespace: " + namespace + " to subsegment " + this.name + ". Namespace must be of type string.");
      }
      var ns = namespace || "default";
      if (!this.metadata) {
        this.metadata = {};
      }
      if (!this.metadata[ns]) {
        this.metadata[ns] = {};
      }
      this.metadata[ns][key] = value;
    };
    Subsegment.prototype.addSqlData = function addSqlData(sqlData) {
      this.sql = sqlData;
    };
    Subsegment.prototype.addError = function addError(err, remote) {
      if (err == null || typeof err !== "object" && typeof err !== "string") {
        throw new Error("Failed to add error:" + err + ' to subsegment "' + this.name + '".  Not an object or string literal.');
      }
      this.addFaultFlag();
      if (this.segment && this.segment.exception) {
        if (err === this.segment.exception.ex) {
          this.fault = true;
          this.cause = { id: this.segment.exception.cause };
          return;
        }
        delete this.segment.exception;
      }
      if (this.segment) {
        this.segment.exception = {
          ex: err,
          cause: this.id
        };
      } else {
      }
      if (this.cause === void 0) {
        this.cause = {
          working_directory: process.cwd(),
          exceptions: []
        };
      }
      this.cause.exceptions.unshift(new CapturedException(err, remote));
    };
    Subsegment.prototype.addRemoteRequestData = function addRemoteRequestData(req, res, downstreamXRayEnabled) {
      this.http = new RemoteRequestData(req, res, downstreamXRayEnabled);
      if ("traced" in this.http.request) {
        this.traced = this.http.request.traced;
        delete this.http.request.traced;
      }
    };
    Subsegment.prototype.addFaultFlag = function addFaultFlag() {
      this.fault = true;
    };
    Subsegment.prototype.addErrorFlag = function addErrorFlag() {
      this.error = true;
    };
    Subsegment.prototype.addThrottleFlag = function addThrottleFlag() {
      this.throttle = true;
    };
    Subsegment.prototype.close = function close(err, remote) {
      var root = this.segment;
      this.end_time = SegmentUtils.getCurrentTime();
      delete this.in_progress;
      if (err)
        this.addError(err, remote);
      if (this.parent)
        this.parent.decrementCounter();
      if (root && root.counter > SegmentUtils.getStreamingThreshold()) {
        if (this.streamSubsegments() && this.parent)
          this.parent.removeSubsegment(this);
      }
    };
    Subsegment.prototype.incrementCounter = function incrementCounter(additional) {
      this.counter = additional ? this.counter + additional + 1 : this.counter + 1;
      if (this.parent)
        this.parent.incrementCounter(additional);
    };
    Subsegment.prototype.decrementCounter = function decrementCounter() {
      this.counter--;
      if (this.parent)
        this.parent.decrementCounter();
    };
    Subsegment.prototype.isClosed = function isClosed() {
      return !this.in_progress;
    };
    Subsegment.prototype.flush = function flush() {
      if (!this.parent || !this.segment) {
        throw new Error("Failed to flush subsegment: " + this.name + ". Subsegment must be added to a segment chain to flush.");
      }
      if (this.segment.trace_id) {
        if (this.segment.notTraced !== true) {
          SegmentEmitter.send(this);
        } else {
          logger.getLogger().debug("Ignoring flush on subsegment " + this.id + ". Associated segment is marked as not sampled.");
        }
      } else {
        logger.getLogger().debug("Ignoring flush on subsegment " + this.id + ". Associated segment is missing a trace ID.");
      }
    };
    Subsegment.prototype.streamSubsegments = function streamSubsegments() {
      if (this.isClosed() && this.counter <= 0) {
        this.flush();
        return true;
      } else if (this.subsegments && this.subsegments.length > 0) {
        var open = [];
        this.subsegments.forEach(function(child) {
          if (!child.streamSubsegments())
            open.push(child);
        });
        this.subsegments = open;
      }
    };
    Subsegment.prototype.format = function format() {
      this.type = "subsegment";
      if (this.parent)
        this.parent_id = this.parent.id;
      if (this.segment)
        this.trace_id = this.segment.trace_id;
      return JSON.stringify(this);
    };
    Subsegment.prototype.toString = function toString() {
      return JSON.stringify(this);
    };
    Subsegment.prototype.toJSON = function toJSON() {
      var ignore = ["segment", "parent", "counter"];
      if (this.subsegments == null || this.subsegments.length === 0)
        ignore.push("subsegments");
      var thisCopy = Utils.objectWithoutProperties(this, ignore, false);
      return thisCopy;
    };
    module2.exports = Subsegment;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/segments/segment.js
var require_segment = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/segments/segment.js"(exports, module2) {
    "use strict";
    var crypto = require("crypto");
    var CapturedException = require_captured_exception();
    var SegmentEmitter = require_segment_emitter();
    var SegmentUtils = require_segment_utils();
    var Subsegment = require_subsegment();
    var TraceID = require_trace_id();
    var Utils = require_utils4();
    var logger = require_logger();
    function Segment(name, rootId, parentId) {
      this.init(name, rootId, parentId);
    }
    Segment.prototype.init = function init(name, rootId, parentId) {
      if (typeof name != "string")
        throw new Error("Segment name must be of type string.");
      var traceId;
      if (rootId && typeof rootId == "string") {
        traceId = TraceID.FromString(rootId);
      } else {
        traceId = new TraceID();
      }
      var id = crypto.randomBytes(8).toString("hex");
      var startTime = SegmentUtils.getCurrentTime();
      this.trace_id = traceId.toString();
      this.id = id;
      this.start_time = startTime;
      this.name = name || "";
      this.in_progress = true;
      this.counter = 0;
      if (parentId)
        this.parent_id = parentId;
      if (SegmentUtils.serviceData)
        this.setServiceData(SegmentUtils.serviceData);
      if (SegmentUtils.pluginData)
        this.addPluginData(SegmentUtils.pluginData);
      if (SegmentUtils.origin)
        this.origin = SegmentUtils.origin;
      if (SegmentUtils.sdkData)
        this.setSDKData(SegmentUtils.sdkData);
    };
    Segment.prototype.addIncomingRequestData = function addIncomingRequestData(data) {
      this.http = data;
    };
    Segment.prototype.addAnnotation = function addAnnotation(key, value) {
      if (typeof value !== "boolean" && typeof value !== "string" && !isFinite(value)) {
        logger.getLogger().error("Add annotation key: " + key + " value: " + value + " failed. Annotations must be of type string, number or boolean.");
        return;
      }
      if (this.annotations === void 0)
        this.annotations = {};
      this.annotations[key] = value;
    };
    Segment.prototype.setUser = function(user) {
      if (typeof user !== "string") {
        logger.getLogger().error("Set user: " + user + " failed. User IDs must be of type string.");
      }
      this.user = user;
    };
    Segment.prototype.addMetadata = function(key, value, namespace) {
      if (typeof key !== "string") {
        throw new Error("Failed to add annotation key: " + key + " value: " + value + " to subsegment " + this.name + ". Key must be of type string.");
      } else if (namespace && typeof namespace !== "string") {
        throw new Error("Failed to add annotation key: " + key + " value: " + value + "namespace: " + namespace + " to subsegment " + this.name + ". Namespace must be of type string.");
      }
      var ns = namespace || "default";
      if (!this.metadata) {
        this.metadata = {};
      }
      if (!this.metadata[ns]) {
        this.metadata[ns] = {};
      }
      this.metadata[ns][key] = value;
    };
    Segment.prototype.setSDKData = function setSDKData(data) {
      if (!data) {
        logger.getLogger().error("Add SDK data: " + data + " failed.Must not be empty.");
        return;
      }
      if (!this.aws)
        this.aws = {};
      this.aws.xray = data;
    };
    Segment.prototype.setMatchedSamplingRule = function setMatchedSamplingRule(ruleName) {
      if (this.aws)
        this.aws = JSON.parse(JSON.stringify(this.aws));
      if (this.aws && this.aws["xray"])
        this.aws.xray["rule_name"] = ruleName;
      else
        this.aws = { xray: { "rule_name": ruleName } };
    };
    Segment.prototype.setServiceData = function setServiceData(data) {
      if (!data) {
        logger.getLogger().error("Add service data: " + data + " failed.Must not be empty.");
        return;
      }
      this.service = data;
    };
    Segment.prototype.addPluginData = function addPluginData(data) {
      if (this.aws === void 0)
        this.aws = {};
      Object.assign(this.aws, data);
    };
    Segment.prototype.addNewSubsegment = function addNewSubsegment(name) {
      var subsegment = new Subsegment(name);
      this.addSubsegment(subsegment);
      return subsegment;
    };
    Segment.prototype.addSubsegment = function addSubsegment(subsegment) {
      if (!(subsegment instanceof Subsegment))
        throw new Error("Cannot add subsegment: " + subsegment + ". Not a subsegment.");
      if (this.subsegments === void 0)
        this.subsegments = [];
      subsegment.segment = this;
      subsegment.parent = this;
      this.subsegments.push(subsegment);
      if (!subsegment.end_time)
        this.incrementCounter(subsegment.counter);
    };
    Segment.prototype.removeSubsegment = function removeSubsegment(subsegment) {
      if (!(subsegment instanceof Subsegment)) {
        throw new Error("Failed to remove subsegment:" + subsegment + ' from subsegment "' + this.name + '".  Not a subsegment.');
      }
      if (this.subsegments !== void 0) {
        var index = this.subsegments.indexOf(subsegment);
        if (index >= 0)
          this.subsegments.splice(index, 1);
      }
    };
    Segment.prototype.addError = function addError(err, remote) {
      if (err == null || typeof err !== "object" && typeof err !== "string") {
        throw new Error("Failed to add error:" + err + ' to subsegment "' + this.name + '".  Not an object or string literal.');
      }
      this.addFaultFlag();
      if (this.exception) {
        if (err === this.exception.ex) {
          this.cause = { id: this.exception.cause };
          delete this.exception;
          return;
        }
        delete this.exception;
      }
      if (this.cause === void 0) {
        this.cause = {
          working_directory: process.cwd(),
          exceptions: []
        };
      }
      this.cause.exceptions.push(new CapturedException(err, remote));
    };
    Segment.prototype.addFaultFlag = function addFaultFlag() {
      this.fault = true;
    };
    Segment.prototype.addErrorFlag = function addErrorFlag() {
      this.error = true;
    };
    Segment.prototype.addThrottleFlag = function addThrottleFlag() {
      this.throttle = true;
    };
    Segment.prototype.isClosed = function isClosed() {
      return !this.in_progress;
    };
    Segment.prototype.incrementCounter = function incrementCounter(additional) {
      this.counter = additional ? this.counter + additional + 1 : this.counter + 1;
      if (this.counter > SegmentUtils.streamingThreshold && this.subsegments && this.subsegments.length > 0) {
        var open = [];
        this.subsegments.forEach(function(child) {
          if (!child.streamSubsegments())
            open.push(child);
        });
        this.subsegments = open;
      }
    };
    Segment.prototype.decrementCounter = function decrementCounter() {
      this.counter--;
      if (this.counter <= 0 && this.isClosed()) {
        this.flush();
      }
    };
    Segment.prototype.close = function(err, remote) {
      if (!this.end_time)
        this.end_time = SegmentUtils.getCurrentTime();
      if (err !== void 0)
        this.addError(err, remote);
      delete this.in_progress;
      delete this.exception;
      if (this.counter <= 0) {
        this.flush();
      }
    };
    Segment.prototype.flush = function flush() {
      if (this.notTraced !== true) {
        delete this.exception;
        var thisCopy = Utils.objectWithoutProperties(this, ["counter", "notTraced"], true);
        SegmentEmitter.send(thisCopy);
      }
    };
    Segment.prototype.format = function format() {
      var ignore = ["segment", "parent", "counter"];
      if (this.subsegments == null || this.subsegments.length === 0)
        ignore.push("subsegments");
      var thisCopy = Utils.objectWithoutProperties(this, ignore, false);
      return JSON.stringify(thisCopy);
    };
    Segment.prototype.toString = function toString() {
      return JSON.stringify(this);
    };
    module2.exports = Segment;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/context_utils.js
var require_context_utils = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/context_utils.js"(exports, module2) {
    "use strict";
    var cls = require_context();
    var logger = require_logger();
    var Segment = require_segment();
    var Subsegment = require_subsegment();
    var cls_mode = true;
    var NAMESPACE = "AWSXRay";
    var SEGMENT = "segment";
    var contextOverride = false;
    var contextUtils = {
      CONTEXT_MISSING_STRATEGY: {
        RUNTIME_ERROR: {
          contextMissing: function contextMissingRuntimeError(message) {
            throw new Error(message);
          }
        },
        LOG_ERROR: {
          contextMissing: function contextMissingLogError(message) {
            var err = new Error(message);
            logger.getLogger().error(err.stack);
          }
        },
        IGNORE_ERROR: {
          contextMissing: function contextMissingIgnoreError(message) {
          }
        }
      },
      contextMissingStrategy: {},
      resolveManualSegmentParams: function resolveManualSegmentParams(params) {
        if (params && !contextUtils.isAutomaticMode()) {
          var xraySegment = params.XRaySegment || params.XraySegment;
          var segment = params.Segment;
          var found = null;
          if (xraySegment && (xraySegment instanceof Segment || xraySegment instanceof Subsegment)) {
            found = xraySegment;
            delete params.XRaySegment;
            delete params.XraySegment;
          } else if (segment && (segment instanceof Segment || segment instanceof Subsegment)) {
            found = segment;
            delete params.Segment;
          }
          return found;
        }
      },
      getNamespace: function getNamespace() {
        return cls.getNamespace(NAMESPACE) || cls.createNamespace(NAMESPACE);
      },
      resolveSegment: function resolveSegment(segment) {
        if (cls_mode) {
          return this.getSegment();
        } else if (segment && !cls_mode) {
          return segment;
        } else if (!segment && !cls_mode) {
          contextUtils.contextMissingStrategy.contextMissing("No sub/segment specified. A sub/segment must be provided for manual mode.");
        }
      },
      getSegment: function getSegment() {
        if (cls_mode) {
          var segment = contextUtils.getNamespace(NAMESPACE).get(SEGMENT);
          if (!segment) {
            contextUtils.contextMissingStrategy.contextMissing("Failed to get the current sub/segment from the context.");
          } else if (segment instanceof Segment && process.env.LAMBDA_TASK_ROOT && segment.facade == true) {
            segment.resolveLambdaTraceData();
          }
          return segment;
        } else {
          contextUtils.contextMissingStrategy.contextMissing("Cannot get sub/segment from context. Not supported in manual mode.");
        }
      },
      setSegment: function setSegment(segment) {
        if (cls_mode) {
          if (!contextUtils.getNamespace(NAMESPACE).set(SEGMENT, segment))
            logger.getLogger().warn("Failed to set the current sub/segment on the context.");
        } else {
          contextUtils.contextMissingStrategy.contextMissing("Cannot set sub/segment on context. Not supported in manual mode.");
        }
      },
      isAutomaticMode: function isAutomaticMode() {
        return cls_mode;
      },
      enableAutomaticMode: function enableAutomaticMode() {
        cls_mode = true;
        contextUtils.getNamespace(NAMESPACE);
        logger.getLogger().debug("Overriding AWS X-Ray SDK mode. Set to automatic mode.");
      },
      enableManualMode: function enableManualMode() {
        cls_mode = false;
        if (cls.getNamespace(NAMESPACE))
          cls.destroyNamespace(NAMESPACE);
        logger.getLogger().debug("Overriding AWS X-Ray SDK mode. Set to manual mode.");
      },
      setContextMissingStrategy: function setContextMissingStrategy2(strategy) {
        if (!contextOverride) {
          if (typeof strategy === "string") {
            var lookupStrategy = contextUtils.CONTEXT_MISSING_STRATEGY[strategy.toUpperCase()];
            if (lookupStrategy) {
              contextUtils.contextMissingStrategy.contextMissing = lookupStrategy.contextMissing;
              if (process.env.AWS_XRAY_CONTEXT_MISSING)
                logger.getLogger().debug("AWS_XRAY_CONTEXT_MISSING is set. Configured context missing strategy to " + process.env.AWS_XRAY_CONTEXT_MISSING + ".");
              else
                logger.getLogger().debug("Configured context missing strategy to: " + strategy);
            } else {
              throw new Error("Invalid context missing strategy: " + strategy + ". Valid values are " + Object.keys(contextUtils.CONTEXT_MISSING_STRATEGY) + ".");
            }
          } else if (typeof strategy === "function") {
            contextUtils.contextMissingStrategy.contextMissing = strategy;
            logger.getLogger().info("Configured custom context missing strategy to function: " + strategy.name);
          } else {
            throw new Error("Context missing strategy must be either a string or a custom function.");
          }
        } else {
          logger.getLogger().warn("Ignoring call to setContextMissingStrategy as AWS_XRAY_CONTEXT_MISSING is set. The current context missing strategy will not be changed.");
        }
      }
    };
    cls.createNamespace(NAMESPACE);
    logger.getLogger().debug("Starting the AWS X-Ray SDK in automatic mode (default).");
    if (process.env.AWS_XRAY_CONTEXT_MISSING) {
      contextUtils.setContextMissingStrategy(process.env.AWS_XRAY_CONTEXT_MISSING);
      contextOverride = true;
    } else {
      contextUtils.contextMissingStrategy.contextMissing = contextUtils.CONTEXT_MISSING_STRATEGY.RUNTIME_ERROR.contextMissing;
      logger.getLogger().debug("Using default context missing strategy: RUNTIME_ERROR");
    }
    module2.exports = contextUtils;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/middleware/incoming_request_data.js
var require_incoming_request_data = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/middleware/incoming_request_data.js"(exports, module2) {
    "use strict";
    var { getHttpResponseData } = require_segment_utils();
    function IncomingRequestData(req) {
      this.init(req);
    }
    IncomingRequestData.prototype.init = function init(req) {
      var forwarded = !!req.headers["x-forwarded-for"];
      var url;
      if (req.connection)
        url = (req.connection.secure || req.connection.encrypted ? "https://" : "http://") + ((req.headers["host"] || "") + (req.url || ""));
      this.request = {
        method: req.method || "",
        user_agent: req.headers["user-agent"] || "",
        client_ip: getClientIp(req) || "",
        url: url || ""
      };
      if (forwarded)
        this.request.x_forwarded_for = forwarded;
    };
    var getClientIp = function getClientIp2(req) {
      var clientIp;
      if (req.headers["x-forwarded-for"])
        clientIp = (req.headers["x-forwarded-for"] || "").split(",")[0];
      else if (req.connection && req.connection.remoteAddress)
        clientIp = req.connection.remoteAddress;
      else if (req.socket && req.socket.remoteAddress)
        clientIp = req.socket.remoteAddress;
      else if (req.connection && req.connection.socket && req.connection.socket.remoteAddress)
        clientIp = req.connection.socket.remoteAddress;
      return clientIp;
    };
    IncomingRequestData.prototype.close = function close(res) {
      this.response = getHttpResponseData(res);
    };
    module2.exports = IncomingRequestData;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/middleware/sampling/local_reservoir.js
var require_local_reservoir = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/middleware/sampling/local_reservoir.js"(exports, module2) {
    "use strict";
    function LocalReservoir(fixedTarget, fallbackRate) {
      this.init(fixedTarget, fallbackRate);
    }
    LocalReservoir.prototype.init = function init(fixedTarget, fallbackRate) {
      this.usedThisSecond = 0;
      if (typeof fixedTarget === "number" && fixedTarget % 1 === 0 && fixedTarget >= 0)
        this.fixedTarget = fixedTarget;
      else
        throw new Error('Error in sampling file. Rule attribute "fixed_target" must be a non-negative integer.');
      if (typeof fallbackRate === "number" && fallbackRate >= 0 && fallbackRate <= 1)
        this.fallbackRate = fallbackRate;
      else
        throw new Error('Error in sampling file. Rule attribute "rate" must be a number between 0 and 1 inclusive.');
    };
    LocalReservoir.prototype.isSampled = function isSampled() {
      var now = Math.round(new Date().getTime() / 1e3);
      if (now !== this.thisSecond) {
        this.usedThisSecond = 0;
        this.thisSecond = now;
      }
      if (this.usedThisSecond >= this.fixedTarget)
        return Math.random() < this.fallbackRate;
      this.usedThisSecond++;
      return true;
    };
    module2.exports = LocalReservoir;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/resources/default_sampling_rules.json
var require_default_sampling_rules = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/resources/default_sampling_rules.json"(exports, module2) {
    module2.exports = {
      default: {
        fixed_target: 1,
        rate: 0.05
      },
      version: 2
    };
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/middleware/sampling/local_sampler.js
var require_local_sampler = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/middleware/sampling/local_sampler.js"(exports, module2) {
    "use strict";
    var fs2 = require("fs");
    var LocalReservoir = require_local_reservoir();
    var Utils = require_utils4();
    var defaultRules = require_default_sampling_rules();
    var logger = require_logger();
    var LocalSampler = {
      shouldSample: function shouldSample(sampleRequest) {
        var host = sampleRequest.host;
        var httpMethod = sampleRequest.httpMethod;
        var urlPath = sampleRequest.urlPath;
        var formatted = "{ http_method: " + httpMethod + ", host: " + host + ", url_path: " + urlPath + " }";
        var matched;
        this.rules.some(function(rule) {
          if (rule.default || (host == null || Utils.wildcardMatch(rule.host, host) && (httpMethod == null || Utils.wildcardMatch(rule.http_method, httpMethod)) && (urlPath == null || Utils.wildcardMatch(rule.url_path, urlPath)))) {
            matched = rule.reservoir;
            logger.getLogger().debug("Local sampling rule match found for " + formatted + ". Matched " + (rule.default ? "default" : "{ http_method: " + rule.http_method + ", host: " + rule.host + ", url_path: " + rule.url_path + " }") + ". Using fixed_target: " + matched.fixedTarget + " and rate: " + matched.fallbackRate + ".");
            return true;
          }
        });
        if (matched) {
          return matched.isSampled();
        } else {
          logger.getLogger().debug("No sampling rule matched for " + formatted);
          return false;
        }
      },
      setLocalRules: function setLocalRules(source) {
        if (source) {
          if (typeof source === "string") {
            logger.getLogger().info("Using custom sampling rules file: " + source);
            this.rules = loadRulesConfig(JSON.parse(fs2.readFileSync(source, "utf8")));
          } else {
            logger.getLogger().info("Using custom sampling rules source.");
            this.rules = loadRulesConfig(source);
          }
        } else
          this.rules = parseRulesConfig(defaultRules);
      }
    };
    var loadRulesConfig = function loadRulesConfig2(config) {
      if (!config.version)
        throw new Error('Error in sampling file. Missing "version" attribute.');
      if (config.version === 1 || config.version === 2)
        return parseRulesConfig(config);
      else
        throw new Error('Error in sampling file. Unknown version "' + config.version + '".');
    };
    var parseRulesConfig = function parseRulesConfig2(config) {
      var defaultRule;
      var rules = [];
      if (config.default) {
        var missing = [];
        for (var key in config.default) {
          if (key !== "fixed_target" && key !== "rate") {
            throw new Error("Error in sampling file. Invalid attribute for default: " + key + '. Valid attributes for default are "fixed_target" and "rate".');
          } else if (typeof config.default[key] !== "number") {
            throw new Error("Error in sampling file. Default " + key + " must be a number.");
          }
        }
        if (typeof config.default.fixed_target === "undefined")
          missing.push("fixed_target");
        if (typeof config.default.rate === "undefined")
          missing.push("rate");
        if (missing.length !== 0)
          throw new Error("Error in sampling file. Missing required attributes for default: " + missing + ".");
        defaultRule = { default: true, reservoir: new LocalReservoir(config.default.fixed_target, config.default.rate) };
      } else {
        throw new Error('Error in sampling file. Expecting "default" object to be defined with attributes "fixed_target" and "rate".');
      }
      if (Array.isArray(config.rules)) {
        config.rules.forEach(function(rawRule) {
          var params = {};
          var required;
          if (config.version === 2)
            required = { host: 1, http_method: 1, url_path: 1, fixed_target: 1, rate: 1 };
          if (config.version === 1)
            required = { service_name: 1, http_method: 1, url_path: 1, fixed_target: 1, rate: 1 };
          for (var key2 in rawRule) {
            var value = rawRule[key2];
            if (!required[key2] && key2 != "description")
              throw new Error("Error in sampling file. Rule " + JSON.stringify(rawRule) + " has invalid attribute: " + key2 + ".");
            else if (key2 != "description" && !value && value !== 0)
              throw new Error("Error in sampling file. Rule " + JSON.stringify(rawRule) + ' attribute "' + key2 + '" has invalid value: ' + value + ".");
            else {
              if (config.version === 2)
                params[key2] = value;
              if (config.version === 1 && key2 === "service_name")
                params["host"] = value;
              else
                params[key2] = value;
              delete required[key2];
            }
          }
          if (Object.keys(required).length !== 0 && required.constructor === Object)
            throw new Error("Error in sampling file. Rule " + JSON.stringify(rawRule) + " is missing required attributes: " + Object.keys(required) + ".");
          var rule = params;
          rule.reservoir = new LocalReservoir(rawRule.fixed_target, rawRule.rate);
          rules.push(rule);
        });
      }
      rules.push(defaultRule);
      return rules;
    };
    LocalSampler.setLocalRules();
    module2.exports = LocalSampler;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/middleware/sampling/reservoir.js
var require_reservoir = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/middleware/sampling/reservoir.js"(exports, module2) {
    "use strict";
    function Reservoir() {
      this.init();
    }
    Reservoir.prototype.init = function init() {
      this.quota = null;
      this.TTL = null;
      this.takenThisSec = 0;
      this.borrowedThisSec = 0;
      this.reportInterval = 1;
      this.reportElapsed = 0;
    };
    Reservoir.prototype.borrowOrTake = function borrowOrTake(now, canBorrow) {
      this.adjustThisSec(now);
      if (this.quota >= 0 && this.TTL >= now) {
        if (this.takenThisSec >= this.quota)
          return false;
        this.takenThisSec++;
        return "take";
      }
      if (canBorrow) {
        if (this.borrowedThisSec >= 1)
          return false;
        this.borrowedThisSec++;
        return "borrow";
      }
    };
    Reservoir.prototype.adjustThisSec = function adjustThisSec(now) {
      if (now !== this.thisSec) {
        this.takenThisSec = 0;
        this.borrowedThisSec = 0;
        this.thisSec = now;
      }
    };
    Reservoir.prototype.loadNewQuota = function loadNewQuota(quota, TTL, interval) {
      if (quota)
        this.quota = quota;
      if (TTL)
        this.TTL = TTL;
      if (interval)
        this.reportInterval = interval / 10;
    };
    Reservoir.prototype.timeToReport = function timeToReport() {
      if (this.reportElapsed + 1 >= this.reportInterval) {
        this.reportElapsed = 0;
        return true;
      } else {
        this.reportElapsed += 1;
        return false;
      }
    };
    module2.exports = Reservoir;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/middleware/sampling/sampling_rule.js
var require_sampling_rule = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/middleware/sampling/sampling_rule.js"(exports, module2) {
    "use strict";
    var Utils = require_utils4();
    var Reservoir = require_reservoir();
    function SamplingRule(name, priority, rate, reservoirSize, host, httpMethod, urlPath, serviceName, serviceType) {
      this.init(name, priority, rate, reservoirSize, host, httpMethod, urlPath, serviceName, serviceType);
    }
    SamplingRule.prototype.init = function init(name, priority, rate, reservoirSize, host, httpMethod, urlPath, serviceName, serviceType) {
      this.name = name;
      this.priority = priority;
      this.rate = rate;
      this.host = host;
      this.httpMethod = httpMethod;
      this.urlPath = urlPath;
      this.serviceName = serviceName;
      this.serviceType = serviceType;
      this.reservoir = new Reservoir();
      this.borrow = !!reservoirSize;
      this.resetStatistics();
    };
    SamplingRule.prototype.match = function match(sampleRequest) {
      var host = sampleRequest.host;
      var httpMethod = sampleRequest.httpMethod;
      var serviceName = sampleRequest.serviceName;
      var urlPath = sampleRequest.urlPath;
      var serviceType = sampleRequest.serviceType;
      return this.isDefault() || (!host || Utils.wildcardMatch(this.host, host)) && (!httpMethod || Utils.wildcardMatch(this.httpMethod, httpMethod)) && (!serviceName || Utils.wildcardMatch(this.serviceName, serviceName)) && (!urlPath || Utils.wildcardMatch(this.urlPath, urlPath)) && (!serviceType || Utils.wildcardMatch(this.serviceType, serviceType));
    };
    SamplingRule.prototype.snapshotStatistics = function snapshotStatistics() {
      var statistics = {
        requestCount: this.requestCount,
        borrowCount: this.borrowCount,
        sampledCount: this.sampledCount
      };
      this.resetStatistics();
      return statistics;
    };
    SamplingRule.prototype.merge = function merge(rule) {
      this.reservoir = rule.reservoir;
      this.requestCount = rule.requestCount;
      this.borrowCount = rule.borrowCount;
      this.sampledCount = rule.sampledCount;
      rule = null;
    };
    SamplingRule.prototype.isDefault = function isDefault() {
      return this.name === "Default";
    };
    SamplingRule.prototype.incrementRequestCount = function incrementRequestCount() {
      this.requestCount++;
    };
    SamplingRule.prototype.incrementBorrowCount = function incrementBorrowCount() {
      this.borrowCount++;
    };
    SamplingRule.prototype.incrementSampledCount = function incrementSampledCount() {
      this.sampledCount++;
    };
    SamplingRule.prototype.setRate = function setRate(rate) {
      this.rate = rate;
    };
    SamplingRule.prototype.getRate = function getRate() {
      return this.rate;
    };
    SamplingRule.prototype.getName = function getName() {
      return this.name;
    };
    SamplingRule.prototype.getPriority = function getPriority() {
      return this.priority;
    };
    SamplingRule.prototype.getReservoir = function getReservoir() {
      return this.reservoir;
    };
    SamplingRule.prototype.resetStatistics = function resetStatistics() {
      this.requestCount = 0;
      this.borrowCount = 0;
      this.sampledCount = 0;
    };
    SamplingRule.prototype.canBorrow = function canBorrow() {
      return this.borrow;
    };
    SamplingRule.prototype.everMatched = function everMatched() {
      return this.requestCount > 0;
    };
    SamplingRule.prototype.timeToReport = function timeToReport() {
      return this.reservoir.timeToReport();
    };
    module2.exports = SamplingRule;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/middleware/sampling/service_connector.js
var require_service_connector = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/middleware/sampling/service_connector.js"(exports, module2) {
    "use strict";
    var crypto = require("crypto");
    var logger = require_logger();
    var SamplingRule = require_sampling_rule();
    var DaemonConfig = require_daemon_config();
    var util = require("util");
    var http = require("http");
    var ServiceConnector = {
      clientId: crypto.randomBytes(12).toString("hex"),
      samplingRulesPath: "/GetSamplingRules",
      samplingTargetsPath: "/SamplingTargets",
      logger,
      httpClient: http,
      fetchSamplingRules: function fetchSamplingRules(callback) {
        const body = "{}";
        const options = getOptions(this.samplingRulesPath, body.length);
        const httpReq = this.httpClient.__request ? this.httpClient.__request : this.httpClient.request;
        const req = httpReq(options, (res) => {
          var data = "";
          res.on("data", (d) => {
            data += d;
          });
          res.on("error", (error) => {
            callback(error);
          });
          res.on("end", () => {
            var dataObj;
            try {
              dataObj = JSON.parse(data);
            } catch (err) {
              callback(err);
              return;
            }
            if (!dataObj) {
              callback(new Error("AWS X-Ray GetSamplingRules API returned empty response"));
              return;
            }
            var newRules = assembleRules(dataObj);
            callback(null, newRules);
          });
        });
        req.on("error", (err) => {
          callback(new Error(`Failed to connect to X-Ray daemon at ${options.hostname}:${options.port} to get sampling rules.`));
        });
        req.write(body);
        req.end();
      },
      fetchTargets: function fetchTargets(rules, callback) {
        const body = JSON.stringify(constructStatisticsDocs(rules));
        const options = getOptions(this.samplingTargetsPath, body.length);
        const httpReq = this.httpClient.__request ? this.httpClient.__request : this.httpClient.request;
        const req = httpReq(options, (res) => {
          var data = "";
          res.on("data", (d) => {
            data += d;
          });
          res.on("error", (error) => {
            callback(error);
          });
          res.on("end", () => {
            var dataObj;
            try {
              dataObj = JSON.parse(data);
            } catch (err) {
              callback(err);
              return;
            }
            if (!dataObj || typeof dataObj["LastRuleModification"] != "number") {
              callback(new Error("AWS X-Ray SamplingTargets API returned invalid response"));
              return;
            }
            var targetsMapping = assembleTargets(dataObj);
            var ruleFreshness = dateToEpoch(dataObj["LastRuleModification"]);
            callback(null, targetsMapping, ruleFreshness);
          });
        });
        req.on("error", (err) => {
          callback(new Error(`Failed to connect to X-Ray daemon at ${options.hostname}:${options.port} to get sampling targets.`));
        });
        req.write(body);
        req.end();
      }
    };
    var constructStatisticsDocs = function constructStatisticsDocs2(rules) {
      var documents = [];
      var now = Math.floor(new Date().getTime() / 1e3);
      rules.forEach(function(rule) {
        var statistics = rule.snapshotStatistics();
        var doc = {
          "RuleName": rule.getName(),
          "ClientID": ServiceConnector.clientId,
          "RequestCount": statistics.requestCount,
          "BorrowCount": statistics.borrowCount,
          "SampledCount": statistics.sampledCount,
          "Timestamp": now
        };
        documents.push(doc);
      });
      return { SamplingStatisticsDocuments: documents };
    };
    var assembleRules = function assembleRules2(data) {
      var newRules = [];
      var ruleList = data["SamplingRuleRecords"] || [];
      ruleList.forEach(function(ruleRecord) {
        ruleRecord = ruleRecord["SamplingRule"];
        if (isRuleValid(ruleRecord)) {
          var newRule = new SamplingRule(ruleRecord["RuleName"], ruleRecord["Priority"], ruleRecord["FixedRate"], ruleRecord["ReservoirSize"], ruleRecord["Host"], ruleRecord["HTTPMethod"], ruleRecord["URLPath"], ruleRecord["ServiceName"], ruleRecord["ServiceType"]);
          newRules.push(newRule);
        }
      });
      return newRules;
    };
    var assembleTargets = function assembleTargets2(data) {
      var docs = data["SamplingTargetDocuments"] || [];
      var targetsMapping = {};
      docs.forEach(function(doc) {
        var newTarget = {
          rate: doc["FixedRate"],
          quota: doc["ReservoirQuota"],
          TTL: dateToEpoch(doc["ReservoirQuotaTTL"]),
          interval: doc["Interval"]
        };
        targetsMapping[doc["RuleName"]] = newTarget;
      });
      return targetsMapping;
    };
    var isRuleValid = function isRuleValid2(record) {
      return record["Version"] === 1 && record["ResourceARN"] === "*" && record["Attributes"] && Object.keys(record["Attributes"]).length === 0 && record["ServiceType"] && record["RuleName"] && record["Priority"] && typeof record["FixedRate"] == "number";
    };
    var dateToEpoch = function dateToEpoch2(date) {
      return new Date(date).getTime() / 1e3;
    };
    var getOptions = function getOptions2(path2, contentLength) {
      const options = {
        hostname: DaemonConfig.tcp_ip,
        port: DaemonConfig.tcp_port,
        method: "POST",
        path: path2,
        headers: {
          "Content-Type": "application/json",
          "Content-Length": contentLength,
          "Host": util.format("%s:%d", DaemonConfig.tcp_ip, DaemonConfig.tcp_port)
        }
      };
      return options;
    };
    module2.exports = ServiceConnector;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/middleware/sampling/rule_cache.js
var require_rule_cache = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/middleware/sampling/rule_cache.js"(exports, module2) {
    "use strict";
    var TTL = 60 * 60;
    var RuleCache = {
      rules: [],
      lastUpdated: null,
      getMatchedRule: function getMatchedRule(sampleRequest, now) {
        if (isExpired(now))
          return null;
        var matchedRule;
        this.rules.forEach(function(rule) {
          if (!matchedRule && rule.match(sampleRequest))
            matchedRule = rule;
          if (rule.isDefault() && !matchedRule)
            matchedRule = rule;
        });
        return matchedRule;
      },
      loadRules: function loadRules(rules) {
        var oldRules = {};
        this.rules.forEach(function(rule) {
          oldRules[rule.getName()] = rule;
        });
        this.rules = rules;
        this.rules.forEach(function(rule) {
          var oldRule = oldRules[rule.getName()];
          if (oldRule)
            rule.merge(oldRule);
        });
        this.rules.sort(function(a, b) {
          var v = a.getPriority() - b.getPriority();
          if (v !== 0)
            return v;
          if (a.getName() > b.getName())
            return 1;
          else
            return -1;
        });
      },
      loadTargets: function loadTargets(targetsMapping) {
        this.rules.forEach(function(rule) {
          var target = targetsMapping[rule.getName()];
          if (target) {
            rule.getReservoir().loadNewQuota(target.quota, target.TTL, target.interval);
            rule.setRate(target.rate);
          }
        });
      },
      getRules: function getRules() {
        return this.rules;
      },
      timestamp: function timestamp(now) {
        this.lastUpdated = now;
      },
      getLastUpdated: function getLastUpdated() {
        return this.lastUpdated;
      }
    };
    var isExpired = function isExpired2(now) {
      if (!RuleCache.getLastUpdated())
        return true;
      return now > RuleCache.getLastUpdated() + TTL;
    };
    module2.exports = RuleCache;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/middleware/sampling/rule_poller.js
var require_rule_poller = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/middleware/sampling/rule_poller.js"(exports, module2) {
    "use strict";
    var logger = require_logger();
    var ServiceConnector = require_service_connector();
    var ruleCache = require_rule_cache();
    var DEFAULT_INTERVAL = 5 * 60 * 1e3;
    var RulePoller = {
      start: function start() {
        if (this.poller)
          clearInterval(this.poller);
        refresh(false);
        this.poller = setInterval(refresh, DEFAULT_INTERVAL);
        this.poller.unref();
      }
    };
    var refresh = function refresh2(jitter) {
      jitter = typeof jitter === "undefined" ? true : jitter;
      if (jitter) {
        var delay = getJitter();
        setTimeout(refreshWithFirewall, delay);
      } else
        refreshWithFirewall();
    };
    var refreshWithFirewall = function refreshWithFirewall2() {
      try {
        refreshCache();
      } catch (e) {
        logger.getLogger().warn("Encountered unexpected exception when fetching sampling rules: " + e);
      }
    };
    var refreshCache = function refreshCache2() {
      var now = Math.floor(new Date().getTime() / 1e3);
      ServiceConnector.fetchSamplingRules(function(err, newRules) {
        if (err) {
          logger.getLogger().warn("Failed to retrieve sampling rules from X-Ray service:", err);
        } else if (newRules.length !== 0) {
          ruleCache.loadRules(newRules);
          ruleCache.timestamp(now);
          logger.getLogger().info("Successfully refreshed centralized sampling rule cache.");
        }
      });
    };
    var getJitter = function getJitter2() {
      return Math.random() * 5;
    };
    module2.exports = RulePoller;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/middleware/sampling/target_poller.js
var require_target_poller = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/middleware/sampling/target_poller.js"(exports, module2) {
    "use strict";
    var rulePoller = require_rule_poller();
    var serviceConnector = require_service_connector();
    var ruleCache = require_rule_cache();
    var logger = require_logger();
    var DEFAULT_INTERVAL = 10 * 1e3;
    var TargetPoller = {
      interval: DEFAULT_INTERVAL,
      start: function start() {
        this.poller = setInterval(refreshWithFirewall, DEFAULT_INTERVAL + getJitter());
        this.poller.unref();
      }
    };
    var refreshWithFirewall = function refreshWithFirewall2() {
      try {
        refresh();
      } catch (e) {
        logger.getLogger().warn("Encountered unexpected exception when fetching sampling targets: " + e);
      }
    };
    var refresh = function refresh2() {
      var candidates = getCandidates();
      if (candidates && candidates.length > 0) {
        serviceConnector.fetchTargets(candidates, function(err, targetsMapping, ruleFreshness) {
          if (err) {
            logger.getLogger().warn("Failed to retrieve sampling targets from X-Ray service:", err);
            return;
          }
          ruleCache.loadTargets(targetsMapping);
          if (ruleFreshness > ruleCache.getLastUpdated()) {
            logger.getLogger().info("Performing out-of-band sampling rule polling to fetch updated rules.");
            rulePoller.start();
          }
          logger.getLogger().info("Successfully reported rule statistics to get new sampling quota.");
        });
      }
    };
    var getCandidates = function getCandidates2() {
      var rules = ruleCache.getRules();
      var candidates = [];
      rules.forEach(function(rule) {
        if (rule.everMatched() && rule.timeToReport())
          candidates.push(rule);
      });
      return candidates;
    };
    var getJitter = function getJitter2() {
      return Math.random() / TargetPoller.interval;
    };
    module2.exports = TargetPoller;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/middleware/sampling/default_sampler.js
var require_default_sampler = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/middleware/sampling/default_sampler.js"(exports, module2) {
    "use strict";
    var logger = require_logger();
    var util = require("util");
    var SegmentUtils = require_segment_utils();
    var DefaultSampler = {
      localSampler: require_local_sampler(),
      rulePoller: require_rule_poller(),
      targetPoller: require_target_poller(),
      ruleCache: require_rule_cache(),
      started: false,
      shouldSample: function shouldSample(sampleRequest) {
        try {
          if (!this.started)
            this.start();
          if (!sampleRequest.serviceType)
            sampleRequest.serviceType = SegmentUtils.origin;
          var now = Math.floor(new Date().getTime() / 1e3);
          var matchedRule = this.ruleCache.getMatchedRule(sampleRequest, now);
          if (matchedRule) {
            logger.getLogger().debug(util.format("Rule %s is matched.", matchedRule.getName()));
            return processMatchedRule(matchedRule, now);
          } else {
            logger.getLogger().info("No effective centralized sampling rule match. Fallback to local rules.");
            return this.localSampler.shouldSample(sampleRequest);
          }
        } catch (err) {
          logger.getLogger().error("Unhandled exception by the SDK during making sampling decisions: " + err);
        }
      },
      setLocalRules: function setLocalRules(source) {
        this.localSampler.setLocalRules(source);
      },
      start: function start() {
        if (!this.started) {
          this.rulePoller.start();
          this.targetPoller.start();
          this.started = true;
        }
      }
    };
    var processMatchedRule = function processMatchedRule2(rule, now) {
      rule.incrementRequestCount();
      var reservoir = rule.getReservoir();
      var sample = true;
      var decision = reservoir.borrowOrTake(now, rule.canBorrow());
      if (decision === "borrow")
        rule.incrementBorrowCount();
      else if (decision === "take")
        rule.incrementSampledCount();
      else if (Math.random() <= rule.getRate())
        rule.incrementSampledCount();
      else
        sample = false;
      if (sample)
        return rule.getName();
      else
        return false;
    };
    module2.exports = DefaultSampler;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/middleware/mw_utils.js
var require_mw_utils = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/middleware/mw_utils.js"(exports, module2) {
    "use strict";
    var Segment = require_segment();
    var IncomingRequestData = require_incoming_request_data();
    var logger = require_logger();
    var coreUtils = require_utils4();
    var wildcardMatch = require_utils4().wildcardMatch;
    var processTraceData = require_utils4().processTraceData;
    var XRAY_HEADER = "x-amzn-trace-id";
    var overrideFlag = !!process.env.AWS_XRAY_TRACING_NAME;
    var utils = {
      defaultName: process.env.AWS_XRAY_TRACING_NAME,
      dynamicNaming: false,
      hostPattern: null,
      sampler: require_default_sampler(),
      enableDynamicNaming: function(hostPattern) {
        this.dynamicNaming = true;
        if (hostPattern && typeof hostPattern !== "string")
          throw new Error("Host pattern must be a string.");
        this.hostPattern = hostPattern || null;
      },
      processHeaders: function processHeaders(req) {
        var amznTraceHeader = {};
        if (req && req.headers && req.headers[XRAY_HEADER]) {
          amznTraceHeader = processTraceData(req.headers[XRAY_HEADER]);
        }
        return amznTraceHeader;
      },
      resolveName: function resolveName(hostHeader) {
        var name;
        if (this.dynamicNaming && hostHeader)
          name = this.hostPattern ? wildcardMatch(this.hostPattern, hostHeader) ? hostHeader : this.defaultName : hostHeader;
        else
          name = this.defaultName;
        return name;
      },
      resolveSampling: function resolveSampling(amznTraceHeader, segment, res) {
        var isSampled;
        if (amznTraceHeader.sampled === "1")
          isSampled = true;
        else if (amznTraceHeader.sampled === "0")
          isSampled = false;
        else {
          var sampleRequest = {
            host: res.req.headers.host,
            httpMethod: res.req.method,
            urlPath: res.req.url,
            serviceName: segment.name
          };
          isSampled = this.sampler.shouldSample(sampleRequest);
          if (isSampled instanceof String || typeof isSampled === "string") {
            segment.setMatchedSamplingRule(isSampled);
            isSampled = true;
          }
        }
        if (amznTraceHeader.sampled === "?")
          res.header[XRAY_HEADER] = "Root=" + amznTraceHeader.root + ";Sampled=" + (isSampled ? "1" : "0");
        if (!isSampled)
          segment.notTraced = true;
      },
      setDefaultName: function setDefaultName(name) {
        if (!overrideFlag)
          this.defaultName = name;
      },
      disableCentralizedSampling: function disableCentralizedSampling() {
        this.sampler = require_local_sampler();
      },
      setSamplingRules: function setSamplingRules(source) {
        if (!source || source instanceof String || !(typeof source === "string" || source instanceof Object))
          throw new Error("Please specify a path to the local sampling rules file, or supply an object containing the rules.");
        this.sampler.setLocalRules(source);
      },
      middlewareLog: function middlewareLog(message, url, segment) {
        logger.getLogger().debug(message + ": { url: " + url + ", name: " + segment.name + ", trace_id: " + segment.trace_id + ", id: " + segment.id + ", sampled: " + !segment.notTraced + " }");
      },
      traceRequestResponseCycle: function traceRequestResponseCycle(req, res) {
        var amznTraceHeader = this.processHeaders(req);
        var name = this.resolveName(req.headers.host);
        var segment = new Segment(name, amznTraceHeader.root, amznTraceHeader.parent);
        var responseWithEmbeddedRequest = Object.assign({}, res, { req });
        this.resolveSampling(amznTraceHeader, segment, responseWithEmbeddedRequest);
        segment.addIncomingRequestData(new IncomingRequestData(req));
        this.middlewareLog("Starting middleware segment", req.url, segment);
        var middlewareLog = this.middlewareLog;
        var didEnd = false;
        var endSegment = function() {
          if (didEnd)
            return;
          didEnd = true;
          if (res.statusCode === 429) {
            segment.addThrottleFlag();
          }
          const cause = coreUtils.getCauseTypeFromHttpStatus(res.statusCode);
          if (cause) {
            segment[cause] = true;
          }
          segment.http.close(res);
          segment.close();
          middlewareLog("Closed middleware segment successfully", req.url, segment);
        };
        res.on("finish", endSegment);
        res.on("close", endSegment);
        return segment;
      }
    };
    module2.exports = utils;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/env/aws_lambda.js
var require_aws_lambda = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/env/aws_lambda.js"(exports, module2) {
    "use strict";
    var contextUtils = require_context_utils();
    var mwUtils = require_mw_utils();
    var LambdaUtils = require_utils4().LambdaUtils;
    var Segment = require_segment();
    var SegmentEmitter = require_segment_emitter();
    var SegmentUtils = require_segment_utils();
    var logger = require_logger();
    var TraceID = require_trace_id();
    var xAmznTraceIdPrev = null;
    module2.exports.init = function init() {
      contextUtils.enableManualMode = function() {
        logger.getLogger().warn("AWS Lambda does not support AWS X-Ray manual mode.");
      };
      SegmentEmitter.disableReusableSocket();
      SegmentUtils.setStreamingThreshold(0);
      logger.getLogger().info("Disabling centralized sampling in Lambda environment.");
      mwUtils.disableCentralizedSampling();
      var namespace = contextUtils.getNamespace();
      namespace.enter(namespace.createContext());
      contextUtils.setSegment(facadeSegment());
    };
    var facadeSegment = function facadeSegment2() {
      var segment = new Segment("facade");
      var whitelistFcn = ["addNewSubsegment", "addSubsegment", "removeSubsegment", "toString"];
      var silentFcn = ["incrementCounter", "decrementCounter", "isClosed", "close", "format", "flush"];
      var xAmznTraceId = process.env._X_AMZN_TRACE_ID;
      for (var key in segment) {
        if (typeof segment[key] === "function" && whitelistFcn.indexOf(key) === -1) {
          if (silentFcn.indexOf(key) === -1) {
            segment[key] = function() {
              var func = key;
              return function facade() {
                logger.getLogger().warn('Function "' + func + '" cannot be called on an AWS Lambda segment. Please use a subsegment to record data.');
                return;
              };
            }();
          } else {
            segment[key] = function facade() {
              return;
            };
          }
        }
      }
      segment.trace_id = TraceID.Invalid().toString();
      segment.isClosed = function() {
        return true;
      };
      segment.in_progress = false;
      segment.counter = 1;
      segment.notTraced = true;
      segment.facade = true;
      segment.reset = function reset() {
        this.trace_id = TraceID.Invalid().toString();
        this.id = "00000000";
        delete this.subsegments;
        this.notTraced = true;
      };
      segment.resolveLambdaTraceData = function resolveLambdaTraceData() {
        var xAmznLambda = process.env._X_AMZN_TRACE_ID;
        if (xAmznLambda) {
          if (xAmznLambda != xAmznTraceIdPrev) {
            this.reset();
            if (LambdaUtils.populateTraceData(segment, xAmznLambda))
              xAmznTraceIdPrev = xAmznLambda;
          }
        } else {
          this.reset();
          contextUtils.contextMissingStrategy.contextMissing("Missing AWS Lambda trace data for X-Ray. Ensure Active Tracing is enabled and no subsegments are created outside the function handler.");
        }
      };
      if (LambdaUtils.validTraceData(xAmznTraceId)) {
        if (LambdaUtils.populateTraceData(segment, xAmznTraceId))
          xAmznTraceIdPrev = xAmznTraceId;
      }
      return segment;
    };
  }
});

// node_modules/aws-xray-sdk-core/package.json
var require_package3 = __commonJS({
  "node_modules/aws-xray-sdk-core/package.json"(exports, module2) {
    module2.exports = {
      name: "aws-xray-sdk-core",
      version: "3.3.3",
      description: "AWS X-Ray SDK for Javascript",
      author: "Amazon Web Services",
      contributors: [
        "Sandra McMullen <mcmuls@amazon.com>",
        "William Armiros <armiros@amazon.com>",
        "Moritz Onken <onken@netcubed.de>"
      ],
      files: [
        "dist/lib/**/*",
        "LICENSE",
        "README.md"
      ],
      main: "dist/lib/index.js",
      types: "dist/lib/index.d.ts",
      engines: {
        node: ">= 10.x"
      },
      directories: {
        test: "test"
      },
      "//": "@types/cls-hooked is exposed in API so must be in dependencies, not devDependencies",
      dependencies: {
        "@aws-sdk/service-error-classification": "^3.4.1",
        "@aws-sdk/types": "^3.4.1",
        "@types/cls-hooked": "^4.3.3",
        "atomic-batcher": "^1.0.2",
        "cls-hooked": "^4.2.2",
        semver: "^5.3.0"
      },
      scripts: {
        prepare: "npm run compile",
        compile: "tsc && npm run copy-lib && npm run copy-test",
        "copy-lib": "find lib -type f \\( -name '*.d.ts' -o -name '*.json' \\) | xargs -I % ../../scripts/cp-with-structure.sh % dist",
        "copy-test": "find test -name '*.json' | xargs -I % ../../scripts/cp-with-structure.sh % dist",
        test: "npm run compile && mocha --recursive ./dist/test/ -R spec && tsd && mocha --recursive ./dist/test_async/ -R spec",
        "test-d": "tsd",
        "test-async": "npm run compile && mocha --recursive ./dist/test_async/ -R spec",
        clean: "rm -rf dist && rm -rf node_modules",
        testcov: "nyc npm run test",
        reportcov: "nyc report --reporter=text-lcov > coverage.lcov && codecov"
      },
      keywords: [
        "amazon",
        "api",
        "aws",
        "core",
        "xray",
        "x-ray",
        "x ray"
      ],
      license: "Apache-2.0",
      repository: "https://github.com/aws/aws-xray-sdk-node/tree/master/packages/core",
      gitHead: "ff228eeee2009711553cbcac5033d525206aba96"
    };
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/segments/plugins/plugin.js
var require_plugin = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/segments/plugins/plugin.js"(exports, module2) {
    "use strict";
    var http = require("http");
    var Plugin = {
      METADATA_TIMEOUT: 1e3,
      getPluginMetadata: function(options, callback) {
        const METADATA_RETRY_TIMEOUT = 250;
        const METADATA_RETRIES = 5;
        var retries = METADATA_RETRIES;
        var getMetadata = function() {
          var httpReq = http.__request ? http.__request : http.request;
          var req = httpReq(options, function(res) {
            var body = "";
            res.on("data", function(chunk) {
              body += chunk;
            });
            res.on("end", function() {
              if (this.statusCode === 200 || this.statusCode === 300) {
                try {
                  body = JSON.parse(body);
                } catch (e) {
                  callback(e);
                  return;
                }
                callback(null, body);
              } else if (retries > 0 && Math.floor(this.statusCode / 100) === 5) {
                retries--;
                setTimeout(getMetadata, METADATA_RETRY_TIMEOUT);
              } else {
                callback(new Error(`Failed to retrieve metadata with options: ${options}`));
              }
            });
          });
          req.on("error", function(err) {
            callback(err);
          });
          req.on("timeout", function() {
            req.abort();
          });
          req.setTimeout(Plugin.METADATA_TIMEOUT);
          req.end();
        };
        getMetadata();
      }
    };
    module2.exports = Plugin;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/segments/plugins/ec2_plugin.js
var require_ec2_plugin = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/segments/plugins/ec2_plugin.js"(exports, module2) {
    "use strict";
    var Plugin = require_plugin();
    var logger = require_logger();
    var http = require("http");
    var EC2Plugin = {
      getData: function(callback) {
        const METADATA_PATH = "/latest/dynamic/instance-identity/document";
        function populateMetadata(token) {
          const options = getOptions(METADATA_PATH, "GET", token ? { "X-aws-ec2-metadata-token": token } : {});
          Plugin.getPluginMetadata(options, function(err, data) {
            if (err || !data) {
              logger.getLogger().error("Error loading EC2 plugin metadata: ", err ? err.toString() : "Could not retrieve data from IMDS.");
              callback();
              return;
            }
            const metadata = {
              ec2: {
                instance_id: data.instanceId,
                availability_zone: data.availabilityZone,
                instance_size: data.instanceType,
                ami_id: data.imageId
              }
            };
            callback(metadata);
          });
        }
        getToken(function(token) {
          if (token === null) {
            logger.getLogger().debug("EC2Plugin failed to get token from IMDSv2. Falling back to IMDSv1.");
          }
          populateMetadata(token);
        });
      },
      originName: "AWS::EC2::Instance"
    };
    function getToken(callback) {
      const httpReq = http.__request ? http.__request : http.request;
      const TTL = 60;
      const TOKEN_PATH = "/latest/api/token";
      const options = getOptions(TOKEN_PATH, "PUT", {
        "X-aws-ec2-metadata-token-ttl-seconds": TTL
      });
      let req = httpReq(options, function(res) {
        let body = "";
        res.on("data", function(chunk) {
          body += chunk;
        });
        res.on("end", function() {
          if (this.statusCode === 200 || this.statusCode === 300) {
            callback(body);
          } else {
            callback(null);
          }
        });
      });
      req.on("error", function() {
        callback(null);
      });
      req.on("timeout", function() {
        req.abort();
        callback(null);
      });
      req.setTimeout(Plugin.METADATA_TIMEOUT);
      req.end();
    }
    function getOptions(path2, method, headers) {
      if (!method) {
        method = "GET";
      }
      if (!headers) {
        headers = {};
      }
      return {
        host: "169.254.169.254",
        path: path2,
        method,
        headers
      };
    }
    module2.exports = EC2Plugin;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/segments/plugins/ecs_plugin.js
var require_ecs_plugin = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/segments/plugins/ecs_plugin.js"(exports, module2) {
    "use strict";
    var os2 = require("os");
    var ECSPlugin = {
      getData: function(callback) {
        callback({ ecs: { container: os2.hostname() } });
      },
      originName: "AWS::ECS::Container"
    };
    module2.exports = ECSPlugin;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/segments/plugins/elastic_beanstalk_plugin.js
var require_elastic_beanstalk_plugin = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/segments/plugins/elastic_beanstalk_plugin.js"(exports, module2) {
    "use strict";
    var fs2 = require("fs");
    var logger = require_logger();
    var ENV_CONFIG_LOCATION = "/var/elasticbeanstalk/xray/environment.conf";
    var ElasticBeanstalkPlugin = {
      getData: function(callback) {
        fs2.readFile(ENV_CONFIG_LOCATION, "utf8", function(err, rawData) {
          if (err) {
            logger.getLogger().error("Error loading Elastic Beanstalk plugin:", err.stack);
            callback();
          } else {
            var data = JSON.parse(rawData);
            var metadata = {
              elastic_beanstalk: {
                environment: data.environment_name,
                version_label: data.version_label,
                deployment_id: data.deployment_id
              }
            };
            callback(metadata);
          }
        });
      },
      originName: "AWS::ElasticBeanstalk::Environment"
    };
    module2.exports = ElasticBeanstalkPlugin;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/resources/aws_whitelist.json
var require_aws_whitelist = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/resources/aws_whitelist.json"(exports, module2) {
    module2.exports = {
      services: {
        dynamodb: {
          operations: {
            batchGetItem: {
              request_descriptors: {
                RequestItems: {
                  get_keys: true,
                  rename_to: "table_names"
                }
              },
              response_parameters: [
                "ConsumedCapacity"
              ]
            },
            batchWriteItem: {
              request_descriptors: {
                RequestItems: {
                  get_keys: true,
                  rename_to: "table_names"
                }
              },
              response_parameters: [
                "ConsumedCapacity",
                "ItemCollectionMetrics"
              ]
            },
            createTable: {
              request_parameters: [
                "GlobalSecondaryIndexes",
                "LocalSecondaryIndexes",
                "ProvisionedThroughput",
                "TableName"
              ]
            },
            deleteItem: {
              request_parameters: [
                "TableName"
              ],
              response_parameters: [
                "ConsumedCapacity",
                "ItemCollectionMetrics"
              ]
            },
            deleteTable: {
              request_parameters: [
                "TableName"
              ]
            },
            describeTable: {
              request_parameters: [
                "TableName"
              ]
            },
            getItem: {
              request_parameters: [
                "ConsistentRead",
                "ProjectionExpression",
                "TableName"
              ],
              response_parameters: [
                "ConsumedCapacity"
              ]
            },
            listTables: {
              request_parameters: [
                "ExclusiveStartTableName",
                "Limit"
              ],
              response_descriptors: {
                TableNames: {
                  list: true,
                  get_count: true,
                  rename_to: "table_count"
                }
              }
            },
            putItem: {
              request_parameters: [
                "TableName"
              ],
              response_parameters: [
                "ConsumedCapacity",
                "ItemCollectionMetrics"
              ]
            },
            query: {
              request_parameters: [
                "AttributesToGet",
                "ConsistentRead",
                "IndexName",
                "Limit",
                "ProjectionExpression",
                "ScanIndexForward",
                "Select",
                "TableName"
              ],
              response_parameters: [
                "ConsumedCapacity"
              ]
            },
            scan: {
              request_parameters: [
                "AttributesToGet",
                "ConsistentRead",
                "IndexName",
                "Limit",
                "ProjectionExpression",
                "Segment",
                "Select",
                "TableName",
                "TotalSegments"
              ],
              response_parameters: [
                "ConsumedCapacity",
                "Count",
                "ScannedCount"
              ]
            },
            updateItem: {
              request_parameters: [
                "TableName"
              ],
              response_parameters: [
                "ConsumedCapacity",
                "ItemCollectionMetrics"
              ]
            },
            updateTable: {
              request_parameters: [
                "AttributeDefinitions",
                "GlobalSecondaryIndexUpdates",
                "ProvisionedThroughput",
                "TableName"
              ]
            }
          }
        },
        sqs: {
          operations: {
            addPermission: {
              request_parameters: [
                "Label",
                "QueueUrl"
              ]
            },
            changeMessageVisibility: {
              request_parameters: [
                "QueueUrl",
                "VisibilityTimeout"
              ]
            },
            changeMessageVisibilityBatch: {
              request_parameters: [
                "QueueUrl"
              ],
              response_parameters: [
                "Failed"
              ]
            },
            createQueue: {
              request_parameters: [
                "Attributes",
                "QueueName"
              ]
            },
            deleteMessage: {
              request_parameters: [
                "QueueUrl"
              ]
            },
            deleteMessageBatch: {
              request_parameters: [
                "QueueUrl"
              ],
              response_parameters: [
                "Failed"
              ]
            },
            deleteQueue: {
              request_parameters: [
                "QueueUrl"
              ]
            },
            getQueueAttributes: {
              request_parameters: [
                "QueueUrl"
              ],
              response_parameters: [
                "Attributes"
              ]
            },
            getQueueUrl: {
              request_parameters: [
                "QueueName",
                "QueueOwnerAWSAccountId"
              ],
              response_parameters: [
                "QueueUrl"
              ]
            },
            listDeadLetterSourceQueues: {
              request_parameters: [
                "QueueUrl"
              ],
              response_parameters: [
                "QueueUrls"
              ]
            },
            listQueues: {
              request_parameters: [
                "QueueNamePrefix"
              ],
              response_descriptors: {
                QueueUrls: {
                  list: true,
                  get_count: true,
                  rename_to: "queue_count"
                }
              }
            },
            purgeQueue: {
              request_parameters: [
                "QueueUrl"
              ]
            },
            receiveMessage: {
              request_parameters: [
                "AttributeNames",
                "MaxNumberOfMessages",
                "MessageAttributeNames",
                "QueueUrl",
                "VisibilityTimeout",
                "WaitTimeSeconds"
              ],
              response_descriptors: {
                Messages: {
                  list: true,
                  get_count: true,
                  rename_to: "message_count"
                }
              }
            },
            removePermission: {
              request_parameters: [
                "QueueUrl"
              ]
            },
            sendMessage: {
              request_parameters: [
                "DelaySeconds",
                "QueueUrl"
              ],
              request_descriptors: {
                MessageAttributes: {
                  get_keys: true,
                  rename_to: "message_attribute_names"
                }
              },
              response_parameters: [
                "MessageId"
              ]
            },
            sendMessageBatch: {
              request_parameters: [
                "QueueUrl"
              ],
              request_descriptors: {
                Entries: {
                  list: true,
                  get_count: true,
                  rename_to: "message_count"
                }
              },
              response_descriptors: {
                Failed: {
                  list: true,
                  get_count: true,
                  rename_to: "failed_count"
                },
                Successful: {
                  list: true,
                  get_count: true,
                  rename_to: "successful_count"
                }
              }
            },
            setQueueAttributes: {
              request_parameters: [
                "QueueUrl"
              ],
              request_descriptors: {
                Attributes: {
                  get_keys: true,
                  rename_to: "attribute_names"
                }
              }
            }
          }
        },
        sns: {
          operations: {
            publish: {
              request_parameters: [
                "TopicArn"
              ]
            }
          }
        },
        lambda: {
          operations: {
            invoke: {
              request_parameters: [
                "FunctionName",
                "InvocationType",
                "LogType",
                "Qualifier"
              ],
              response_parameters: [
                "FunctionError",
                "StatusCode"
              ]
            },
            invokeAsync: {
              request_parameters: [
                "FunctionName"
              ],
              response_parameters: [
                "Status"
              ]
            }
          }
        },
        s3: {
          operations: {
            abortMultipartUpload: {
              request_parameters: [
                "Key"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            completeMultipartUpload: {
              request_parameters: [
                "Key"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            copyObject: {
              request_parameters: [
                "CopySource",
                "Key"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            createBucket: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            createMultipartUpload: {
              request_parameters: [
                "Key"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            deleteBucket: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            deleteBucketAnalyticsConfiguration: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            deleteBucketCors: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            deleteBucketEncryption: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            deleteBucketInventoryConfiguration: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            deleteBucketLifecycle: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            deleteBucketMetricsConfiguration: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            deleteBucketPolicy: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            deleteBucketReplication: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            deleteBucketTagging: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            deleteBucketWebsite: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            deleteObject: {
              request_parameters: [
                "Key",
                "VersionId"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            deleteObjectTagging: {
              request_parameters: [
                "Key",
                "VersionId"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            deleteObjects: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getBucketAccelerateConfiguration: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getBucketAcl: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getBucketAnalyticsConfiguration: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getBucketCors: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getBucketEncryption: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getBucketInventoryConfiguration: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getBucketLifecycle: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getBucketLifecycleConfiguration: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getBucketLocation: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getBucketLogging: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getBucketMetricsConfiguration: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getBucketNotification: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getBucketNotificationConfiguration: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getBucketPolicy: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getBucketReplication: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getBucketRequestPayment: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getBucketTagging: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getBucketVersioning: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getBucketWebsite: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getObject: {
              request_parameters: [
                "Key",
                "VersionId"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getObjectAcl: {
              request_parameters: [
                "Key",
                "VersionId"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getObjectTagging: {
              request_parameters: [
                "Key",
                "VersionId"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            getObjectTorrent: {
              request_parameters: [
                "Key"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            headBucket: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            headObject: {
              request_parameters: [
                "Key",
                "VersionId"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            listBucketAnalyticsConfigurations: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            listBucketInventoryConfigurations: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            listBucketMetricsConfigurations: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            listMultipartUploads: {
              request_parameters: [
                "Prefix"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            listObjectVersions: {
              request_parameters: [
                "Prefix"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            listObjects: {
              request_parameters: [
                "Prefix"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            listObjectsV2: {
              request_parameters: [
                "Prefix"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            listParts: {
              request_parameters: [
                "Key"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putBucketAccelerateConfiguration: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putBucketAcl: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putBucketAnalyticsConfiguration: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putBucketCors: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putBucketEncryption: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putBucketInventoryConfiguration: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putBucketLifecycle: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putBucketLifecycleConfiguration: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putBucketLogging: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putBucketMetricsConfiguration: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putBucketNotification: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putBucketNotificationConfiguration: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putBucketPolicy: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putBucketReplication: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putBucketRequestPayment: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putBucketTagging: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putBucketVersioning: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putBucketWebsite: {
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putObject: {
              request_parameters: [
                "Key"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putObjectAcl: {
              request_parameters: [
                "Key",
                "VersionId"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            putObjectTagging: {
              request_parameters: [
                "Key",
                "VersionId"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            restoreObject: {
              request_parameters: [
                "Key",
                "VersionId"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            uploadPart: {
              request_parameters: [
                "Key"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            },
            uploadPartCopy: {
              request_parameters: [
                "CopySource",
                "Key"
              ],
              request_descriptors: {
                Bucket: {
                  rename_to: "bucket_name"
                }
              }
            }
          }
        },
        sagemakerruntime: {
          operations: {
            invokeEndpoint: {
              request_parameters: [
                "EndpointName"
              ]
            }
          }
        }
      }
    };
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/patchers/call_capturer.js
var require_call_capturer = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/patchers/call_capturer.js"(exports, module2) {
    "use strict";
    var fs2 = require("fs");
    var logger = require_logger();
    var whitelist = require_aws_whitelist();
    var paramTypes = {
      REQ_DESC: "request_descriptors",
      REQ_PARAMS: "request_parameters",
      RES_DESC: "response_descriptors",
      RES_PARAMS: "response_parameters"
    };
    function CallCapturer(source) {
      this.init(source);
    }
    CallCapturer.prototype.init = function init(source) {
      if (source) {
        if (typeof source === "string") {
          logger.getLogger().info("Using custom AWS whitelist file: " + source);
          this.services = loadWhitelist(JSON.parse(fs2.readFileSync(source, "utf8")));
        } else {
          logger.getLogger().info("Using custom AWS whitelist source.");
          this.services = loadWhitelist(source);
        }
      } else
        this.services = whitelist.services;
    };
    CallCapturer.prototype.append = function append(source) {
      var newServices = {};
      if (typeof source === "string") {
        logger.getLogger().info("Appending AWS whitelist with custom file: " + source);
        newServices = loadWhitelist(JSON.parse(fs2.readFileSync(source, "utf8")));
      } else {
        logger.getLogger().info("Appending AWS whitelist with a custom source.");
        newServices = loadWhitelist(source);
      }
      for (var attribute in newServices) {
        this.services[attribute] = newServices[attribute];
      }
    };
    CallCapturer.prototype.capture = function capture(serviceName, response) {
      var operation = response.request.operation;
      var call = this.services[serviceName] !== void 0 ? this.services[serviceName].operations[operation] : null;
      if (call === null) {
        logger.getLogger().debug('Call "' + serviceName + "." + operation + '" is not whitelisted for additional data capturing. Ignoring.');
        return;
      }
      var dataCaptured = {};
      for (var paramType in call) {
        var params = call[paramType];
        if (paramType === paramTypes.REQ_PARAMS) {
          captureCallParams(params, response.request.params, dataCaptured);
        } else if (paramType === paramTypes.REQ_DESC) {
          captureDescriptors(params, response.request.params, dataCaptured);
        } else if (paramType === paramTypes.RES_PARAMS) {
          if (response.data) {
            captureCallParams(params, response.data, dataCaptured);
          }
        } else if (paramType === paramTypes.RES_DESC) {
          if (response.data) {
            captureDescriptors(params, response.data, dataCaptured);
          }
        } else {
          logger.getLogger().error('Unknown parameter type "' + paramType + '". Must be "request_descriptors", "response_descriptors", "request_parameters" or "response_parameters".');
        }
      }
      return dataCaptured;
    };
    function captureCallParams(params, call, data) {
      params.forEach(function(param) {
        if (typeof call[param] !== "undefined") {
          var formatted = toSnakeCase(param);
          this[formatted] = call[param];
        }
      }, data);
    }
    function captureDescriptors(descriptors, params, data) {
      for (var paramName in descriptors) {
        var attributes = descriptors[paramName];
        if (typeof params[paramName] !== "undefined") {
          var paramData;
          if (attributes.list && attributes.get_count)
            paramData = params[paramName] ? params[paramName].length : 0;
          else
            paramData = attributes.get_keys === true ? Object.keys(params[paramName]) : params[paramName];
          if (typeof attributes.rename_to === "string") {
            data[attributes.rename_to] = paramData;
          } else {
            var formatted = toSnakeCase(paramName);
            data[formatted] = paramData;
          }
        }
      }
    }
    function toSnakeCase(param) {
      if (param === "IPAddress")
        return "ip_address";
      else
        return param.split(/(?=[A-Z])/).join("_").toLowerCase();
    }
    function loadWhitelist(source) {
      var doc = source;
      if (doc.services === void 0)
        throw new Error('Document formatting is incorrect. Expecting "services" param.');
      return doc.services;
    }
    module2.exports = CallCapturer;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/segments/attributes/aws.js
var require_aws2 = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/segments/attributes/aws.js"(exports, module2) {
    "use strict";
    var CallCapturer = require_call_capturer();
    var capturer = new CallCapturer();
    function Aws(res, serviceName) {
      this.init(res, serviceName);
    }
    Aws.prototype.init = function init(res, serviceName) {
      this.operation = formatOperation(res.request.operation) || "";
      if (res && res.request && res.request.httpRequest && res.request.httpRequest.region) {
        this.region = res.request.httpRequest.region;
      }
      if (res && res.requestId) {
        this.request_id = res.requestId;
      }
      this.retries = res.retryCount || 0;
      if (res.extendedRequestId && serviceName && serviceName.toLowerCase() === "s3")
        this.id_2 = res.extendedRequestId;
      this.addData(capturer.capture(serviceName, res));
    };
    Aws.prototype.addData = function addData(data) {
      for (var attribute in data) {
        this[attribute] = data[attribute];
      }
    };
    var setAWSWhitelist = function setAWSWhitelist2(source) {
      if (!source || source instanceof String || !(typeof source === "string" || source instanceof Object))
        throw new Error("Please specify a path to the local whitelist file, or supply a whitelist source object.");
      capturer = new CallCapturer(source);
    };
    var appendAWSWhitelist = function appendAWSWhitelist2(source) {
      if (!source || source instanceof String || !(typeof source === "string" || source instanceof Object))
        throw new Error("Please specify a path to the local whitelist file, or supply a whitelist source object.");
      capturer.append(source);
    };
    function formatOperation(operation) {
      if (!operation)
        return;
      return operation.charAt(0).toUpperCase() + operation.slice(1);
    }
    module2.exports = Aws;
    module2.exports.appendAWSWhitelist = appendAWSWhitelist;
    module2.exports.setAWSWhitelist = setAWSWhitelist;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/capture.js
var require_capture = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/capture.js"(exports, module2) {
    "use strict";
    var contextUtils = require_context_utils();
    var logger = require_logger();
    var captureFunc = function captureFunc2(name, fcn, parent) {
      validate(name, fcn);
      var current, executeFcn;
      var parentSeg = contextUtils.resolveSegment(parent);
      if (!parentSeg) {
        logger.getLogger().warn("Failed to capture function.");
        return fcn();
      }
      current = parentSeg.addNewSubsegment(name);
      executeFcn = captureFcn(fcn, current);
      try {
        const response = executeFcn(current);
        current.close();
        return response;
      } catch (e) {
        current.close(e);
        throw e;
      }
    };
    var captureAsyncFunc = function captureAsyncFunc2(name, fcn, parent) {
      validate(name, fcn);
      var current, executeFcn;
      var parentSeg = contextUtils.resolveSegment(parent);
      if (!parentSeg) {
        logger.getLogger().warn("Failed to capture async function.");
        return fcn();
      }
      current = parentSeg.addNewSubsegment(name);
      executeFcn = captureFcn(fcn, current);
      try {
        return executeFcn(current);
      } catch (e) {
        current.close(e);
        throw e;
      }
    };
    var captureCallbackFunc = function captureCallbackFunc2(name, fcn, parent) {
      validate(name, fcn);
      var base = contextUtils.resolveSegment(parent);
      if (!base) {
        logger.getLogger().warn("Failed to capture callback function.");
        return fcn;
      }
      base.incrementCounter();
      return function() {
        var parentSeg = contextUtils.resolveSegment(parent);
        var args = Array.prototype.slice.call(arguments);
        captureFunc(name, fcn.bind.apply(fcn, [null].concat(args)), parentSeg);
        base.decrementCounter();
      }.bind(this);
    };
    function captureFcn(fcn, current) {
      var executeFcn;
      if (contextUtils.isAutomaticMode()) {
        var session = contextUtils.getNamespace();
        var contextFcn = function() {
          var value;
          session.run(function() {
            contextUtils.setSegment(current);
            value = fcn(current);
          });
          return value;
        };
        executeFcn = contextFcn;
      } else {
        executeFcn = fcn;
      }
      return executeFcn;
    }
    function validate(name, fcn) {
      var error;
      if (!name || typeof name !== "string") {
        error = 'Param "name" must be a non-empty string.';
        logger.getLogger().error(error);
        throw new Error(error);
      } else if (typeof fcn !== "function") {
        error = 'Param "fcn" must be a function.';
        logger.getLogger().error(error);
        throw new Error(error);
      }
    }
    module2.exports.captureFunc = captureFunc;
    module2.exports.captureAsyncFunc = captureAsyncFunc;
    module2.exports.captureCallbackFunc = captureCallbackFunc;
  }
});

// node_modules/aws-xray-sdk-core/node_modules/semver/semver.js
var require_semver = __commonJS({
  "node_modules/aws-xray-sdk-core/node_modules/semver/semver.js"(exports, module2) {
    exports = module2.exports = SemVer;
    var debug;
    if (typeof process === "object" && process.env && process.env.NODE_DEBUG && /\bsemver\b/i.test(process.env.NODE_DEBUG)) {
      debug = function() {
        var args = Array.prototype.slice.call(arguments, 0);
        args.unshift("SEMVER");
        console.log.apply(console, args);
      };
    } else {
      debug = function() {
      };
    }
    exports.SEMVER_SPEC_VERSION = "2.0.0";
    var MAX_LENGTH = 256;
    var MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || 9007199254740991;
    var MAX_SAFE_COMPONENT_LENGTH = 16;
    var re = exports.re = [];
    var src = exports.src = [];
    var R = 0;
    var NUMERICIDENTIFIER = R++;
    src[NUMERICIDENTIFIER] = "0|[1-9]\\d*";
    var NUMERICIDENTIFIERLOOSE = R++;
    src[NUMERICIDENTIFIERLOOSE] = "[0-9]+";
    var NONNUMERICIDENTIFIER = R++;
    src[NONNUMERICIDENTIFIER] = "\\d*[a-zA-Z-][a-zA-Z0-9-]*";
    var MAINVERSION = R++;
    src[MAINVERSION] = "(" + src[NUMERICIDENTIFIER] + ")\\.(" + src[NUMERICIDENTIFIER] + ")\\.(" + src[NUMERICIDENTIFIER] + ")";
    var MAINVERSIONLOOSE = R++;
    src[MAINVERSIONLOOSE] = "(" + src[NUMERICIDENTIFIERLOOSE] + ")\\.(" + src[NUMERICIDENTIFIERLOOSE] + ")\\.(" + src[NUMERICIDENTIFIERLOOSE] + ")";
    var PRERELEASEIDENTIFIER = R++;
    src[PRERELEASEIDENTIFIER] = "(?:" + src[NUMERICIDENTIFIER] + "|" + src[NONNUMERICIDENTIFIER] + ")";
    var PRERELEASEIDENTIFIERLOOSE = R++;
    src[PRERELEASEIDENTIFIERLOOSE] = "(?:" + src[NUMERICIDENTIFIERLOOSE] + "|" + src[NONNUMERICIDENTIFIER] + ")";
    var PRERELEASE = R++;
    src[PRERELEASE] = "(?:-(" + src[PRERELEASEIDENTIFIER] + "(?:\\." + src[PRERELEASEIDENTIFIER] + ")*))";
    var PRERELEASELOOSE = R++;
    src[PRERELEASELOOSE] = "(?:-?(" + src[PRERELEASEIDENTIFIERLOOSE] + "(?:\\." + src[PRERELEASEIDENTIFIERLOOSE] + ")*))";
    var BUILDIDENTIFIER = R++;
    src[BUILDIDENTIFIER] = "[0-9A-Za-z-]+";
    var BUILD = R++;
    src[BUILD] = "(?:\\+(" + src[BUILDIDENTIFIER] + "(?:\\." + src[BUILDIDENTIFIER] + ")*))";
    var FULL = R++;
    var FULLPLAIN = "v?" + src[MAINVERSION] + src[PRERELEASE] + "?" + src[BUILD] + "?";
    src[FULL] = "^" + FULLPLAIN + "$";
    var LOOSEPLAIN = "[v=\\s]*" + src[MAINVERSIONLOOSE] + src[PRERELEASELOOSE] + "?" + src[BUILD] + "?";
    var LOOSE = R++;
    src[LOOSE] = "^" + LOOSEPLAIN + "$";
    var GTLT = R++;
    src[GTLT] = "((?:<|>)?=?)";
    var XRANGEIDENTIFIERLOOSE = R++;
    src[XRANGEIDENTIFIERLOOSE] = src[NUMERICIDENTIFIERLOOSE] + "|x|X|\\*";
    var XRANGEIDENTIFIER = R++;
    src[XRANGEIDENTIFIER] = src[NUMERICIDENTIFIER] + "|x|X|\\*";
    var XRANGEPLAIN = R++;
    src[XRANGEPLAIN] = "[v=\\s]*(" + src[XRANGEIDENTIFIER] + ")(?:\\.(" + src[XRANGEIDENTIFIER] + ")(?:\\.(" + src[XRANGEIDENTIFIER] + ")(?:" + src[PRERELEASE] + ")?" + src[BUILD] + "?)?)?";
    var XRANGEPLAINLOOSE = R++;
    src[XRANGEPLAINLOOSE] = "[v=\\s]*(" + src[XRANGEIDENTIFIERLOOSE] + ")(?:\\.(" + src[XRANGEIDENTIFIERLOOSE] + ")(?:\\.(" + src[XRANGEIDENTIFIERLOOSE] + ")(?:" + src[PRERELEASELOOSE] + ")?" + src[BUILD] + "?)?)?";
    var XRANGE = R++;
    src[XRANGE] = "^" + src[GTLT] + "\\s*" + src[XRANGEPLAIN] + "$";
    var XRANGELOOSE = R++;
    src[XRANGELOOSE] = "^" + src[GTLT] + "\\s*" + src[XRANGEPLAINLOOSE] + "$";
    var COERCE = R++;
    src[COERCE] = "(?:^|[^\\d])(\\d{1," + MAX_SAFE_COMPONENT_LENGTH + "})(?:\\.(\\d{1," + MAX_SAFE_COMPONENT_LENGTH + "}))?(?:\\.(\\d{1," + MAX_SAFE_COMPONENT_LENGTH + "}))?(?:$|[^\\d])";
    var LONETILDE = R++;
    src[LONETILDE] = "(?:~>?)";
    var TILDETRIM = R++;
    src[TILDETRIM] = "(\\s*)" + src[LONETILDE] + "\\s+";
    re[TILDETRIM] = new RegExp(src[TILDETRIM], "g");
    var tildeTrimReplace = "$1~";
    var TILDE = R++;
    src[TILDE] = "^" + src[LONETILDE] + src[XRANGEPLAIN] + "$";
    var TILDELOOSE = R++;
    src[TILDELOOSE] = "^" + src[LONETILDE] + src[XRANGEPLAINLOOSE] + "$";
    var LONECARET = R++;
    src[LONECARET] = "(?:\\^)";
    var CARETTRIM = R++;
    src[CARETTRIM] = "(\\s*)" + src[LONECARET] + "\\s+";
    re[CARETTRIM] = new RegExp(src[CARETTRIM], "g");
    var caretTrimReplace = "$1^";
    var CARET = R++;
    src[CARET] = "^" + src[LONECARET] + src[XRANGEPLAIN] + "$";
    var CARETLOOSE = R++;
    src[CARETLOOSE] = "^" + src[LONECARET] + src[XRANGEPLAINLOOSE] + "$";
    var COMPARATORLOOSE = R++;
    src[COMPARATORLOOSE] = "^" + src[GTLT] + "\\s*(" + LOOSEPLAIN + ")$|^$";
    var COMPARATOR = R++;
    src[COMPARATOR] = "^" + src[GTLT] + "\\s*(" + FULLPLAIN + ")$|^$";
    var COMPARATORTRIM = R++;
    src[COMPARATORTRIM] = "(\\s*)" + src[GTLT] + "\\s*(" + LOOSEPLAIN + "|" + src[XRANGEPLAIN] + ")";
    re[COMPARATORTRIM] = new RegExp(src[COMPARATORTRIM], "g");
    var comparatorTrimReplace = "$1$2$3";
    var HYPHENRANGE = R++;
    src[HYPHENRANGE] = "^\\s*(" + src[XRANGEPLAIN] + ")\\s+-\\s+(" + src[XRANGEPLAIN] + ")\\s*$";
    var HYPHENRANGELOOSE = R++;
    src[HYPHENRANGELOOSE] = "^\\s*(" + src[XRANGEPLAINLOOSE] + ")\\s+-\\s+(" + src[XRANGEPLAINLOOSE] + ")\\s*$";
    var STAR = R++;
    src[STAR] = "(<|>)?=?\\s*\\*";
    for (i = 0; i < R; i++) {
      debug(i, src[i]);
      if (!re[i]) {
        re[i] = new RegExp(src[i]);
      }
    }
    var i;
    exports.parse = parse;
    function parse(version, options) {
      if (!options || typeof options !== "object") {
        options = {
          loose: !!options,
          includePrerelease: false
        };
      }
      if (version instanceof SemVer) {
        return version;
      }
      if (typeof version !== "string") {
        return null;
      }
      if (version.length > MAX_LENGTH) {
        return null;
      }
      var r = options.loose ? re[LOOSE] : re[FULL];
      if (!r.test(version)) {
        return null;
      }
      try {
        return new SemVer(version, options);
      } catch (er) {
        return null;
      }
    }
    exports.valid = valid;
    function valid(version, options) {
      var v = parse(version, options);
      return v ? v.version : null;
    }
    exports.clean = clean;
    function clean(version, options) {
      var s = parse(version.trim().replace(/^[=v]+/, ""), options);
      return s ? s.version : null;
    }
    exports.SemVer = SemVer;
    function SemVer(version, options) {
      if (!options || typeof options !== "object") {
        options = {
          loose: !!options,
          includePrerelease: false
        };
      }
      if (version instanceof SemVer) {
        if (version.loose === options.loose) {
          return version;
        } else {
          version = version.version;
        }
      } else if (typeof version !== "string") {
        throw new TypeError("Invalid Version: " + version);
      }
      if (version.length > MAX_LENGTH) {
        throw new TypeError("version is longer than " + MAX_LENGTH + " characters");
      }
      if (!(this instanceof SemVer)) {
        return new SemVer(version, options);
      }
      debug("SemVer", version, options);
      this.options = options;
      this.loose = !!options.loose;
      var m = version.trim().match(options.loose ? re[LOOSE] : re[FULL]);
      if (!m) {
        throw new TypeError("Invalid Version: " + version);
      }
      this.raw = version;
      this.major = +m[1];
      this.minor = +m[2];
      this.patch = +m[3];
      if (this.major > MAX_SAFE_INTEGER || this.major < 0) {
        throw new TypeError("Invalid major version");
      }
      if (this.minor > MAX_SAFE_INTEGER || this.minor < 0) {
        throw new TypeError("Invalid minor version");
      }
      if (this.patch > MAX_SAFE_INTEGER || this.patch < 0) {
        throw new TypeError("Invalid patch version");
      }
      if (!m[4]) {
        this.prerelease = [];
      } else {
        this.prerelease = m[4].split(".").map(function(id) {
          if (/^[0-9]+$/.test(id)) {
            var num = +id;
            if (num >= 0 && num < MAX_SAFE_INTEGER) {
              return num;
            }
          }
          return id;
        });
      }
      this.build = m[5] ? m[5].split(".") : [];
      this.format();
    }
    SemVer.prototype.format = function() {
      this.version = this.major + "." + this.minor + "." + this.patch;
      if (this.prerelease.length) {
        this.version += "-" + this.prerelease.join(".");
      }
      return this.version;
    };
    SemVer.prototype.toString = function() {
      return this.version;
    };
    SemVer.prototype.compare = function(other) {
      debug("SemVer.compare", this.version, this.options, other);
      if (!(other instanceof SemVer)) {
        other = new SemVer(other, this.options);
      }
      return this.compareMain(other) || this.comparePre(other);
    };
    SemVer.prototype.compareMain = function(other) {
      if (!(other instanceof SemVer)) {
        other = new SemVer(other, this.options);
      }
      return compareIdentifiers(this.major, other.major) || compareIdentifiers(this.minor, other.minor) || compareIdentifiers(this.patch, other.patch);
    };
    SemVer.prototype.comparePre = function(other) {
      if (!(other instanceof SemVer)) {
        other = new SemVer(other, this.options);
      }
      if (this.prerelease.length && !other.prerelease.length) {
        return -1;
      } else if (!this.prerelease.length && other.prerelease.length) {
        return 1;
      } else if (!this.prerelease.length && !other.prerelease.length) {
        return 0;
      }
      var i2 = 0;
      do {
        var a = this.prerelease[i2];
        var b = other.prerelease[i2];
        debug("prerelease compare", i2, a, b);
        if (a === void 0 && b === void 0) {
          return 0;
        } else if (b === void 0) {
          return 1;
        } else if (a === void 0) {
          return -1;
        } else if (a === b) {
          continue;
        } else {
          return compareIdentifiers(a, b);
        }
      } while (++i2);
    };
    SemVer.prototype.inc = function(release, identifier) {
      switch (release) {
        case "premajor":
          this.prerelease.length = 0;
          this.patch = 0;
          this.minor = 0;
          this.major++;
          this.inc("pre", identifier);
          break;
        case "preminor":
          this.prerelease.length = 0;
          this.patch = 0;
          this.minor++;
          this.inc("pre", identifier);
          break;
        case "prepatch":
          this.prerelease.length = 0;
          this.inc("patch", identifier);
          this.inc("pre", identifier);
          break;
        case "prerelease":
          if (this.prerelease.length === 0) {
            this.inc("patch", identifier);
          }
          this.inc("pre", identifier);
          break;
        case "major":
          if (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) {
            this.major++;
          }
          this.minor = 0;
          this.patch = 0;
          this.prerelease = [];
          break;
        case "minor":
          if (this.patch !== 0 || this.prerelease.length === 0) {
            this.minor++;
          }
          this.patch = 0;
          this.prerelease = [];
          break;
        case "patch":
          if (this.prerelease.length === 0) {
            this.patch++;
          }
          this.prerelease = [];
          break;
        case "pre":
          if (this.prerelease.length === 0) {
            this.prerelease = [0];
          } else {
            var i2 = this.prerelease.length;
            while (--i2 >= 0) {
              if (typeof this.prerelease[i2] === "number") {
                this.prerelease[i2]++;
                i2 = -2;
              }
            }
            if (i2 === -1) {
              this.prerelease.push(0);
            }
          }
          if (identifier) {
            if (this.prerelease[0] === identifier) {
              if (isNaN(this.prerelease[1])) {
                this.prerelease = [identifier, 0];
              }
            } else {
              this.prerelease = [identifier, 0];
            }
          }
          break;
        default:
          throw new Error("invalid increment argument: " + release);
      }
      this.format();
      this.raw = this.version;
      return this;
    };
    exports.inc = inc;
    function inc(version, release, loose, identifier) {
      if (typeof loose === "string") {
        identifier = loose;
        loose = void 0;
      }
      try {
        return new SemVer(version, loose).inc(release, identifier).version;
      } catch (er) {
        return null;
      }
    }
    exports.diff = diff;
    function diff(version1, version2) {
      if (eq(version1, version2)) {
        return null;
      } else {
        var v1 = parse(version1);
        var v2 = parse(version2);
        var prefix = "";
        if (v1.prerelease.length || v2.prerelease.length) {
          prefix = "pre";
          var defaultResult = "prerelease";
        }
        for (var key in v1) {
          if (key === "major" || key === "minor" || key === "patch") {
            if (v1[key] !== v2[key]) {
              return prefix + key;
            }
          }
        }
        return defaultResult;
      }
    }
    exports.compareIdentifiers = compareIdentifiers;
    var numeric = /^[0-9]+$/;
    function compareIdentifiers(a, b) {
      var anum = numeric.test(a);
      var bnum = numeric.test(b);
      if (anum && bnum) {
        a = +a;
        b = +b;
      }
      return a === b ? 0 : anum && !bnum ? -1 : bnum && !anum ? 1 : a < b ? -1 : 1;
    }
    exports.rcompareIdentifiers = rcompareIdentifiers;
    function rcompareIdentifiers(a, b) {
      return compareIdentifiers(b, a);
    }
    exports.major = major;
    function major(a, loose) {
      return new SemVer(a, loose).major;
    }
    exports.minor = minor;
    function minor(a, loose) {
      return new SemVer(a, loose).minor;
    }
    exports.patch = patch;
    function patch(a, loose) {
      return new SemVer(a, loose).patch;
    }
    exports.compare = compare;
    function compare(a, b, loose) {
      return new SemVer(a, loose).compare(new SemVer(b, loose));
    }
    exports.compareLoose = compareLoose;
    function compareLoose(a, b) {
      return compare(a, b, true);
    }
    exports.rcompare = rcompare;
    function rcompare(a, b, loose) {
      return compare(b, a, loose);
    }
    exports.sort = sort;
    function sort(list, loose) {
      return list.sort(function(a, b) {
        return exports.compare(a, b, loose);
      });
    }
    exports.rsort = rsort;
    function rsort(list, loose) {
      return list.sort(function(a, b) {
        return exports.rcompare(a, b, loose);
      });
    }
    exports.gt = gt;
    function gt(a, b, loose) {
      return compare(a, b, loose) > 0;
    }
    exports.lt = lt;
    function lt(a, b, loose) {
      return compare(a, b, loose) < 0;
    }
    exports.eq = eq;
    function eq(a, b, loose) {
      return compare(a, b, loose) === 0;
    }
    exports.neq = neq;
    function neq(a, b, loose) {
      return compare(a, b, loose) !== 0;
    }
    exports.gte = gte;
    function gte(a, b, loose) {
      return compare(a, b, loose) >= 0;
    }
    exports.lte = lte;
    function lte(a, b, loose) {
      return compare(a, b, loose) <= 0;
    }
    exports.cmp = cmp;
    function cmp(a, op, b, loose) {
      switch (op) {
        case "===":
          if (typeof a === "object")
            a = a.version;
          if (typeof b === "object")
            b = b.version;
          return a === b;
        case "!==":
          if (typeof a === "object")
            a = a.version;
          if (typeof b === "object")
            b = b.version;
          return a !== b;
        case "":
        case "=":
        case "==":
          return eq(a, b, loose);
        case "!=":
          return neq(a, b, loose);
        case ">":
          return gt(a, b, loose);
        case ">=":
          return gte(a, b, loose);
        case "<":
          return lt(a, b, loose);
        case "<=":
          return lte(a, b, loose);
        default:
          throw new TypeError("Invalid operator: " + op);
      }
    }
    exports.Comparator = Comparator;
    function Comparator(comp, options) {
      if (!options || typeof options !== "object") {
        options = {
          loose: !!options,
          includePrerelease: false
        };
      }
      if (comp instanceof Comparator) {
        if (comp.loose === !!options.loose) {
          return comp;
        } else {
          comp = comp.value;
        }
      }
      if (!(this instanceof Comparator)) {
        return new Comparator(comp, options);
      }
      debug("comparator", comp, options);
      this.options = options;
      this.loose = !!options.loose;
      this.parse(comp);
      if (this.semver === ANY) {
        this.value = "";
      } else {
        this.value = this.operator + this.semver.version;
      }
      debug("comp", this);
    }
    var ANY = {};
    Comparator.prototype.parse = function(comp) {
      var r = this.options.loose ? re[COMPARATORLOOSE] : re[COMPARATOR];
      var m = comp.match(r);
      if (!m) {
        throw new TypeError("Invalid comparator: " + comp);
      }
      this.operator = m[1];
      if (this.operator === "=") {
        this.operator = "";
      }
      if (!m[2]) {
        this.semver = ANY;
      } else {
        this.semver = new SemVer(m[2], this.options.loose);
      }
    };
    Comparator.prototype.toString = function() {
      return this.value;
    };
    Comparator.prototype.test = function(version) {
      debug("Comparator.test", version, this.options.loose);
      if (this.semver === ANY) {
        return true;
      }
      if (typeof version === "string") {
        version = new SemVer(version, this.options);
      }
      return cmp(version, this.operator, this.semver, this.options);
    };
    Comparator.prototype.intersects = function(comp, options) {
      if (!(comp instanceof Comparator)) {
        throw new TypeError("a Comparator is required");
      }
      if (!options || typeof options !== "object") {
        options = {
          loose: !!options,
          includePrerelease: false
        };
      }
      var rangeTmp;
      if (this.operator === "") {
        rangeTmp = new Range(comp.value, options);
        return satisfies(this.value, rangeTmp, options);
      } else if (comp.operator === "") {
        rangeTmp = new Range(this.value, options);
        return satisfies(comp.semver, rangeTmp, options);
      }
      var sameDirectionIncreasing = (this.operator === ">=" || this.operator === ">") && (comp.operator === ">=" || comp.operator === ">");
      var sameDirectionDecreasing = (this.operator === "<=" || this.operator === "<") && (comp.operator === "<=" || comp.operator === "<");
      var sameSemVer = this.semver.version === comp.semver.version;
      var differentDirectionsInclusive = (this.operator === ">=" || this.operator === "<=") && (comp.operator === ">=" || comp.operator === "<=");
      var oppositeDirectionsLessThan = cmp(this.semver, "<", comp.semver, options) && ((this.operator === ">=" || this.operator === ">") && (comp.operator === "<=" || comp.operator === "<"));
      var oppositeDirectionsGreaterThan = cmp(this.semver, ">", comp.semver, options) && ((this.operator === "<=" || this.operator === "<") && (comp.operator === ">=" || comp.operator === ">"));
      return sameDirectionIncreasing || sameDirectionDecreasing || sameSemVer && differentDirectionsInclusive || oppositeDirectionsLessThan || oppositeDirectionsGreaterThan;
    };
    exports.Range = Range;
    function Range(range, options) {
      if (!options || typeof options !== "object") {
        options = {
          loose: !!options,
          includePrerelease: false
        };
      }
      if (range instanceof Range) {
        if (range.loose === !!options.loose && range.includePrerelease === !!options.includePrerelease) {
          return range;
        } else {
          return new Range(range.raw, options);
        }
      }
      if (range instanceof Comparator) {
        return new Range(range.value, options);
      }
      if (!(this instanceof Range)) {
        return new Range(range, options);
      }
      this.options = options;
      this.loose = !!options.loose;
      this.includePrerelease = !!options.includePrerelease;
      this.raw = range;
      this.set = range.split(/\s*\|\|\s*/).map(function(range2) {
        return this.parseRange(range2.trim());
      }, this).filter(function(c) {
        return c.length;
      });
      if (!this.set.length) {
        throw new TypeError("Invalid SemVer Range: " + range);
      }
      this.format();
    }
    Range.prototype.format = function() {
      this.range = this.set.map(function(comps) {
        return comps.join(" ").trim();
      }).join("||").trim();
      return this.range;
    };
    Range.prototype.toString = function() {
      return this.range;
    };
    Range.prototype.parseRange = function(range) {
      var loose = this.options.loose;
      range = range.trim();
      var hr = loose ? re[HYPHENRANGELOOSE] : re[HYPHENRANGE];
      range = range.replace(hr, hyphenReplace);
      debug("hyphen replace", range);
      range = range.replace(re[COMPARATORTRIM], comparatorTrimReplace);
      debug("comparator trim", range, re[COMPARATORTRIM]);
      range = range.replace(re[TILDETRIM], tildeTrimReplace);
      range = range.replace(re[CARETTRIM], caretTrimReplace);
      range = range.split(/\s+/).join(" ");
      var compRe = loose ? re[COMPARATORLOOSE] : re[COMPARATOR];
      var set = range.split(" ").map(function(comp) {
        return parseComparator(comp, this.options);
      }, this).join(" ").split(/\s+/);
      if (this.options.loose) {
        set = set.filter(function(comp) {
          return !!comp.match(compRe);
        });
      }
      set = set.map(function(comp) {
        return new Comparator(comp, this.options);
      }, this);
      return set;
    };
    Range.prototype.intersects = function(range, options) {
      if (!(range instanceof Range)) {
        throw new TypeError("a Range is required");
      }
      return this.set.some(function(thisComparators) {
        return thisComparators.every(function(thisComparator) {
          return range.set.some(function(rangeComparators) {
            return rangeComparators.every(function(rangeComparator) {
              return thisComparator.intersects(rangeComparator, options);
            });
          });
        });
      });
    };
    exports.toComparators = toComparators;
    function toComparators(range, options) {
      return new Range(range, options).set.map(function(comp) {
        return comp.map(function(c) {
          return c.value;
        }).join(" ").trim().split(" ");
      });
    }
    function parseComparator(comp, options) {
      debug("comp", comp, options);
      comp = replaceCarets(comp, options);
      debug("caret", comp);
      comp = replaceTildes(comp, options);
      debug("tildes", comp);
      comp = replaceXRanges(comp, options);
      debug("xrange", comp);
      comp = replaceStars(comp, options);
      debug("stars", comp);
      return comp;
    }
    function isX(id) {
      return !id || id.toLowerCase() === "x" || id === "*";
    }
    function replaceTildes(comp, options) {
      return comp.trim().split(/\s+/).map(function(comp2) {
        return replaceTilde(comp2, options);
      }).join(" ");
    }
    function replaceTilde(comp, options) {
      var r = options.loose ? re[TILDELOOSE] : re[TILDE];
      return comp.replace(r, function(_, M, m, p, pr) {
        debug("tilde", comp, _, M, m, p, pr);
        var ret;
        if (isX(M)) {
          ret = "";
        } else if (isX(m)) {
          ret = ">=" + M + ".0.0 <" + (+M + 1) + ".0.0";
        } else if (isX(p)) {
          ret = ">=" + M + "." + m + ".0 <" + M + "." + (+m + 1) + ".0";
        } else if (pr) {
          debug("replaceTilde pr", pr);
          ret = ">=" + M + "." + m + "." + p + "-" + pr + " <" + M + "." + (+m + 1) + ".0";
        } else {
          ret = ">=" + M + "." + m + "." + p + " <" + M + "." + (+m + 1) + ".0";
        }
        debug("tilde return", ret);
        return ret;
      });
    }
    function replaceCarets(comp, options) {
      return comp.trim().split(/\s+/).map(function(comp2) {
        return replaceCaret(comp2, options);
      }).join(" ");
    }
    function replaceCaret(comp, options) {
      debug("caret", comp, options);
      var r = options.loose ? re[CARETLOOSE] : re[CARET];
      return comp.replace(r, function(_, M, m, p, pr) {
        debug("caret", comp, _, M, m, p, pr);
        var ret;
        if (isX(M)) {
          ret = "";
        } else if (isX(m)) {
          ret = ">=" + M + ".0.0 <" + (+M + 1) + ".0.0";
        } else if (isX(p)) {
          if (M === "0") {
            ret = ">=" + M + "." + m + ".0 <" + M + "." + (+m + 1) + ".0";
          } else {
            ret = ">=" + M + "." + m + ".0 <" + (+M + 1) + ".0.0";
          }
        } else if (pr) {
          debug("replaceCaret pr", pr);
          if (M === "0") {
            if (m === "0") {
              ret = ">=" + M + "." + m + "." + p + "-" + pr + " <" + M + "." + m + "." + (+p + 1);
            } else {
              ret = ">=" + M + "." + m + "." + p + "-" + pr + " <" + M + "." + (+m + 1) + ".0";
            }
          } else {
            ret = ">=" + M + "." + m + "." + p + "-" + pr + " <" + (+M + 1) + ".0.0";
          }
        } else {
          debug("no pr");
          if (M === "0") {
            if (m === "0") {
              ret = ">=" + M + "." + m + "." + p + " <" + M + "." + m + "." + (+p + 1);
            } else {
              ret = ">=" + M + "." + m + "." + p + " <" + M + "." + (+m + 1) + ".0";
            }
          } else {
            ret = ">=" + M + "." + m + "." + p + " <" + (+M + 1) + ".0.0";
          }
        }
        debug("caret return", ret);
        return ret;
      });
    }
    function replaceXRanges(comp, options) {
      debug("replaceXRanges", comp, options);
      return comp.split(/\s+/).map(function(comp2) {
        return replaceXRange(comp2, options);
      }).join(" ");
    }
    function replaceXRange(comp, options) {
      comp = comp.trim();
      var r = options.loose ? re[XRANGELOOSE] : re[XRANGE];
      return comp.replace(r, function(ret, gtlt, M, m, p, pr) {
        debug("xRange", comp, ret, gtlt, M, m, p, pr);
        var xM = isX(M);
        var xm = xM || isX(m);
        var xp = xm || isX(p);
        var anyX = xp;
        if (gtlt === "=" && anyX) {
          gtlt = "";
        }
        if (xM) {
          if (gtlt === ">" || gtlt === "<") {
            ret = "<0.0.0";
          } else {
            ret = "*";
          }
        } else if (gtlt && anyX) {
          if (xm) {
            m = 0;
          }
          p = 0;
          if (gtlt === ">") {
            gtlt = ">=";
            if (xm) {
              M = +M + 1;
              m = 0;
              p = 0;
            } else {
              m = +m + 1;
              p = 0;
            }
          } else if (gtlt === "<=") {
            gtlt = "<";
            if (xm) {
              M = +M + 1;
            } else {
              m = +m + 1;
            }
          }
          ret = gtlt + M + "." + m + "." + p;
        } else if (xm) {
          ret = ">=" + M + ".0.0 <" + (+M + 1) + ".0.0";
        } else if (xp) {
          ret = ">=" + M + "." + m + ".0 <" + M + "." + (+m + 1) + ".0";
        }
        debug("xRange return", ret);
        return ret;
      });
    }
    function replaceStars(comp, options) {
      debug("replaceStars", comp, options);
      return comp.trim().replace(re[STAR], "");
    }
    function hyphenReplace($0, from, fM, fm, fp, fpr, fb, to, tM, tm, tp, tpr, tb) {
      if (isX(fM)) {
        from = "";
      } else if (isX(fm)) {
        from = ">=" + fM + ".0.0";
      } else if (isX(fp)) {
        from = ">=" + fM + "." + fm + ".0";
      } else {
        from = ">=" + from;
      }
      if (isX(tM)) {
        to = "";
      } else if (isX(tm)) {
        to = "<" + (+tM + 1) + ".0.0";
      } else if (isX(tp)) {
        to = "<" + tM + "." + (+tm + 1) + ".0";
      } else if (tpr) {
        to = "<=" + tM + "." + tm + "." + tp + "-" + tpr;
      } else {
        to = "<=" + to;
      }
      return (from + " " + to).trim();
    }
    Range.prototype.test = function(version) {
      if (!version) {
        return false;
      }
      if (typeof version === "string") {
        version = new SemVer(version, this.options);
      }
      for (var i2 = 0; i2 < this.set.length; i2++) {
        if (testSet(this.set[i2], version, this.options)) {
          return true;
        }
      }
      return false;
    };
    function testSet(set, version, options) {
      for (var i2 = 0; i2 < set.length; i2++) {
        if (!set[i2].test(version)) {
          return false;
        }
      }
      if (version.prerelease.length && !options.includePrerelease) {
        for (i2 = 0; i2 < set.length; i2++) {
          debug(set[i2].semver);
          if (set[i2].semver === ANY) {
            continue;
          }
          if (set[i2].semver.prerelease.length > 0) {
            var allowed = set[i2].semver;
            if (allowed.major === version.major && allowed.minor === version.minor && allowed.patch === version.patch) {
              return true;
            }
          }
        }
        return false;
      }
      return true;
    }
    exports.satisfies = satisfies;
    function satisfies(version, range, options) {
      try {
        range = new Range(range, options);
      } catch (er) {
        return false;
      }
      return range.test(version);
    }
    exports.maxSatisfying = maxSatisfying;
    function maxSatisfying(versions, range, options) {
      var max = null;
      var maxSV = null;
      try {
        var rangeObj = new Range(range, options);
      } catch (er) {
        return null;
      }
      versions.forEach(function(v) {
        if (rangeObj.test(v)) {
          if (!max || maxSV.compare(v) === -1) {
            max = v;
            maxSV = new SemVer(max, options);
          }
        }
      });
      return max;
    }
    exports.minSatisfying = minSatisfying;
    function minSatisfying(versions, range, options) {
      var min = null;
      var minSV = null;
      try {
        var rangeObj = new Range(range, options);
      } catch (er) {
        return null;
      }
      versions.forEach(function(v) {
        if (rangeObj.test(v)) {
          if (!min || minSV.compare(v) === 1) {
            min = v;
            minSV = new SemVer(min, options);
          }
        }
      });
      return min;
    }
    exports.minVersion = minVersion;
    function minVersion(range, loose) {
      range = new Range(range, loose);
      var minver = new SemVer("0.0.0");
      if (range.test(minver)) {
        return minver;
      }
      minver = new SemVer("0.0.0-0");
      if (range.test(minver)) {
        return minver;
      }
      minver = null;
      for (var i2 = 0; i2 < range.set.length; ++i2) {
        var comparators = range.set[i2];
        comparators.forEach(function(comparator) {
          var compver = new SemVer(comparator.semver.version);
          switch (comparator.operator) {
            case ">":
              if (compver.prerelease.length === 0) {
                compver.patch++;
              } else {
                compver.prerelease.push(0);
              }
              compver.raw = compver.format();
            case "":
            case ">=":
              if (!minver || gt(minver, compver)) {
                minver = compver;
              }
              break;
            case "<":
            case "<=":
              break;
            default:
              throw new Error("Unexpected operation: " + comparator.operator);
          }
        });
      }
      if (minver && range.test(minver)) {
        return minver;
      }
      return null;
    }
    exports.validRange = validRange;
    function validRange(range, options) {
      try {
        return new Range(range, options).range || "*";
      } catch (er) {
        return null;
      }
    }
    exports.ltr = ltr;
    function ltr(version, range, options) {
      return outside(version, range, "<", options);
    }
    exports.gtr = gtr;
    function gtr(version, range, options) {
      return outside(version, range, ">", options);
    }
    exports.outside = outside;
    function outside(version, range, hilo, options) {
      version = new SemVer(version, options);
      range = new Range(range, options);
      var gtfn, ltefn, ltfn, comp, ecomp;
      switch (hilo) {
        case ">":
          gtfn = gt;
          ltefn = lte;
          ltfn = lt;
          comp = ">";
          ecomp = ">=";
          break;
        case "<":
          gtfn = lt;
          ltefn = gte;
          ltfn = gt;
          comp = "<";
          ecomp = "<=";
          break;
        default:
          throw new TypeError('Must provide a hilo val of "<" or ">"');
      }
      if (satisfies(version, range, options)) {
        return false;
      }
      for (var i2 = 0; i2 < range.set.length; ++i2) {
        var comparators = range.set[i2];
        var high = null;
        var low = null;
        comparators.forEach(function(comparator) {
          if (comparator.semver === ANY) {
            comparator = new Comparator(">=0.0.0");
          }
          high = high || comparator;
          low = low || comparator;
          if (gtfn(comparator.semver, high.semver, options)) {
            high = comparator;
          } else if (ltfn(comparator.semver, low.semver, options)) {
            low = comparator;
          }
        });
        if (high.operator === comp || high.operator === ecomp) {
          return false;
        }
        if ((!low.operator || low.operator === comp) && ltefn(version, low.semver)) {
          return false;
        } else if (low.operator === ecomp && ltfn(version, low.semver)) {
          return false;
        }
      }
      return true;
    }
    exports.prerelease = prerelease;
    function prerelease(version, options) {
      var parsed = parse(version, options);
      return parsed && parsed.prerelease.length ? parsed.prerelease : null;
    }
    exports.intersects = intersects;
    function intersects(r1, r2, options) {
      r1 = new Range(r1, options);
      r2 = new Range(r2, options);
      return r1.intersects(r2);
    }
    exports.coerce = coerce;
    function coerce(version) {
      if (version instanceof SemVer) {
        return version;
      }
      if (typeof version !== "string") {
        return null;
      }
      var match = version.match(re[COERCE]);
      if (match == null) {
        return null;
      }
      return parse(match[1] + "." + (match[2] || "0") + "." + (match[3] || "0"));
    }
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/patchers/aws_p.js
var require_aws_p = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/patchers/aws_p.js"(exports, module2) {
    "use strict";
    var semver = require_semver();
    var Aws = require_aws2();
    var contextUtils = require_context_utils();
    var Utils = require_utils4();
    var logger = require_logger();
    var minVersion = "2.7.15";
    var throttledErrorDefault = function throttledErrorDefault2() {
      return false;
    };
    var captureAWS2 = function captureAWS3(awssdk) {
      if (!semver.gte(awssdk.VERSION, minVersion))
        throw new Error("AWS SDK version " + minVersion + " or greater required.");
      for (var prop in awssdk) {
        if (awssdk[prop].serviceIdentifier) {
          var Service = awssdk[prop];
          Service.prototype.customizeRequests(captureAWSRequest);
        }
      }
      return awssdk;
    };
    var captureAWSClient = function captureAWSClient2(service) {
      service.customizeRequests(captureAWSRequest);
      return service;
    };
    function captureAWSRequest(req) {
      var parent = contextUtils.resolveSegment(contextUtils.resolveManualSegmentParams(req.params));
      if (!parent) {
        var output = this.serviceIdentifier + "." + req.operation;
        if (!contextUtils.isAutomaticMode()) {
          logger.getLogger().info("Call " + output + ' requires a segment object on the request params as "XRaySegment" for tracing in manual mode. Ignoring.');
        } else {
          logger.getLogger().info("Call " + output + " is missing the sub/segment context for automatic mode. Ignoring.");
        }
        return req;
      }
      var throttledError = this.throttledError || throttledErrorDefault;
      var stack = new Error().stack;
      var subsegment = parent.addNewSubsegment(this.serviceIdentifier);
      var traceId = parent.segment ? parent.segment.trace_id : parent.trace_id;
      var buildListener = function(req2) {
        req2.httpRequest.headers["X-Amzn-Trace-Id"] = "Root=" + traceId + ";Parent=" + subsegment.id + ";Sampled=" + (subsegment.segment.notTraced ? "0" : "1");
      };
      var completeListener = function(res) {
        subsegment.addAttribute("namespace", "aws");
        subsegment.addAttribute("aws", new Aws(res, subsegment.name));
        var httpRes = res.httpResponse;
        if (httpRes) {
          subsegment.addAttribute("http", new HttpResponse(httpRes));
          if (httpRes.statusCode === 429 || res.error && throttledError(res.error))
            subsegment.addThrottleFlag();
        }
        if (res.error) {
          var err = { message: res.error.message, name: res.error.code, stack };
          if (httpRes && httpRes.statusCode) {
            if (Utils.getCauseTypeFromHttpStatus(httpRes.statusCode) == "error") {
              subsegment.addErrorFlag();
            }
            subsegment.close(err, true);
          } else
            subsegment.close(err);
        } else {
          if (httpRes && httpRes.statusCode) {
            var cause = Utils.getCauseTypeFromHttpStatus(httpRes.statusCode);
            if (cause)
              subsegment[cause] = true;
          }
          subsegment.close();
        }
      };
      req.on("beforePresign", function(req2) {
        parent.removeSubsegment(subsegment);
        parent.decrementCounter();
        req2.removeListener("build", buildListener);
        req2.removeListener("complete", completeListener);
      });
      req.on("build", buildListener).on("complete", completeListener);
      if (!req.__send) {
        req.__send = req.send;
        req.send = function(callback) {
          if (contextUtils.isAutomaticMode()) {
            var session = contextUtils.getNamespace();
            session.run(function() {
              contextUtils.setSegment(subsegment);
              req.__send(callback);
            });
          } else {
            req.__send(callback);
          }
        };
      }
    }
    function HttpResponse(res) {
      this.init(res);
    }
    HttpResponse.prototype.init = function init(res) {
      this.response = {
        status: res.statusCode || ""
      };
      if (res.headers && res.headers["content-length"])
        this.response.content_length = res.headers["content-length"];
    };
    module2.exports.captureAWSClient = captureAWSClient;
    module2.exports.captureAWS = captureAWS2;
  }
});

// node_modules/@aws-sdk/service-error-classification/dist-cjs/constants.js
var require_constants2 = __commonJS({
  "node_modules/@aws-sdk/service-error-classification/dist-cjs/constants.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.TRANSIENT_ERROR_STATUS_CODES = exports.TRANSIENT_ERROR_CODES = exports.THROTTLING_ERROR_CODES = exports.CLOCK_SKEW_ERROR_CODES = void 0;
    exports.CLOCK_SKEW_ERROR_CODES = [
      "AuthFailure",
      "InvalidSignatureException",
      "RequestExpired",
      "RequestInTheFuture",
      "RequestTimeTooSkewed",
      "SignatureDoesNotMatch"
    ];
    exports.THROTTLING_ERROR_CODES = [
      "BandwidthLimitExceeded",
      "EC2ThrottledException",
      "LimitExceededException",
      "PriorRequestNotComplete",
      "ProvisionedThroughputExceededException",
      "RequestLimitExceeded",
      "RequestThrottled",
      "RequestThrottledException",
      "SlowDown",
      "ThrottledException",
      "Throttling",
      "ThrottlingException",
      "TooManyRequestsException",
      "TransactionInProgressException"
    ];
    exports.TRANSIENT_ERROR_CODES = ["AbortError", "TimeoutError", "RequestTimeout", "RequestTimeoutException"];
    exports.TRANSIENT_ERROR_STATUS_CODES = [500, 502, 503, 504];
  }
});

// node_modules/@aws-sdk/service-error-classification/dist-cjs/index.js
var require_dist_cjs = __commonJS({
  "node_modules/@aws-sdk/service-error-classification/dist-cjs/index.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.isTransientError = exports.isThrottlingError = exports.isClockSkewError = exports.isRetryableByTrait = void 0;
    var constants_1 = require_constants2();
    var isRetryableByTrait = (error) => error.$retryable !== void 0;
    exports.isRetryableByTrait = isRetryableByTrait;
    var isClockSkewError = (error) => constants_1.CLOCK_SKEW_ERROR_CODES.includes(error.name);
    exports.isClockSkewError = isClockSkewError;
    var isThrottlingError = (error) => {
      var _a, _b;
      return ((_a = error.$metadata) === null || _a === void 0 ? void 0 : _a.httpStatusCode) === 429 || constants_1.THROTTLING_ERROR_CODES.includes(error.name) || ((_b = error.$retryable) === null || _b === void 0 ? void 0 : _b.throttling) == true;
    };
    exports.isThrottlingError = isThrottlingError;
    var isTransientError = (error) => {
      var _a;
      return constants_1.TRANSIENT_ERROR_CODES.includes(error.name) || constants_1.TRANSIENT_ERROR_STATUS_CODES.includes(((_a = error.$metadata) === null || _a === void 0 ? void 0 : _a.httpStatusCode) || 0);
    };
    exports.isTransientError = isTransientError;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/patchers/aws3_p.js
var require_aws3_p = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/patchers/aws3_p.js"(exports) {
    "use strict";
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { "default": mod };
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.captureAWSClient = void 0;
    var service_error_classification_1 = require_dist_cjs();
    var aws_1 = __importDefault(require_aws2());
    var querystring_1 = require("querystring");
    var subsegment_1 = __importDefault(require_subsegment());
    var contextUtils = require_context_utils();
    var logger = require_logger();
    var { safeParseInt } = require_utils4();
    var utils_1 = require_utils4();
    var XRAY_PLUGIN_NAME = "XRaySDKInstrumentation";
    var buildAttributesFromMetadata = async (service, operation, region, res, error) => {
      var _a, _b, _c;
      const { extendedRequestId, requestId, httpStatusCode: statusCode, attempts } = ((_a = res === null || res === void 0 ? void 0 : res.output) === null || _a === void 0 ? void 0 : _a.$metadata) || (error === null || error === void 0 ? void 0 : error.$metadata);
      const aws2 = new aws_1.default({
        extendedRequestId,
        requestId,
        retryCount: attempts,
        request: {
          operation,
          httpRequest: {
            region,
            statusCode
          }
        }
      }, service);
      const http = {};
      if (statusCode) {
        http.response = {};
        http.response.status = statusCode;
      }
      if (((_b = res === null || res === void 0 ? void 0 : res.response) === null || _b === void 0 ? void 0 : _b.headers) && ((_c = res === null || res === void 0 ? void 0 : res.response) === null || _c === void 0 ? void 0 : _c.headers["content-length"]) !== void 0) {
        if (!http.response) {
          http.response = {};
        }
        http.response.content_length = safeParseInt(res.response.headers["content-length"]);
      }
      return [aws2, http];
    };
    function addFlags(http, subsegment, err) {
      var _a, _b, _c;
      if (err && service_error_classification_1.isThrottlingError(err)) {
        subsegment.addThrottleFlag();
      } else if (safeParseInt((_a = http.response) === null || _a === void 0 ? void 0 : _a.status) === 429 || safeParseInt((_b = err === null || err === void 0 ? void 0 : err.$metadata) === null || _b === void 0 ? void 0 : _b.httpStatusCode) === 429) {
        subsegment.addThrottleFlag();
      }
      const cause = utils_1.getCauseTypeFromHttpStatus(safeParseInt((_c = http.response) === null || _c === void 0 ? void 0 : _c.status));
      if (cause === "fault") {
        subsegment.addFaultFlag();
      } else if (cause === "error") {
        subsegment.addErrorFlag();
      }
    }
    var getXRayMiddleware = (config, manualSegment) => (next, context) => async (args) => {
      const segment = contextUtils.isAutomaticMode() ? contextUtils.resolveSegment() : manualSegment;
      const { clientName, commandName } = context;
      const operation = commandName.slice(0, -7);
      const service = clientName.slice(0, -6);
      if (!segment) {
        const output = service + "." + operation.charAt(0).toLowerCase() + operation.slice(1);
        if (!contextUtils.isAutomaticMode()) {
          logger.getLogger().info("Call " + output + " requires a segment object passed to captureAWSv3Client for tracing in manual mode. Ignoring.");
        } else {
          logger.getLogger().info("Call " + output + " is missing the sub/segment context for automatic mode. Ignoring.");
        }
        return next(args);
      }
      const subsegment = segment.addNewSubsegment(service);
      subsegment.addAttribute("namespace", "aws");
      const parent = segment instanceof subsegment_1.default ? segment.segment : segment;
      args.request.headers["X-Amzn-Trace-Id"] = querystring_1.stringify({
        Root: parent.trace_id,
        Parent: subsegment.id,
        Sampled: parent.notTraced ? "0" : "1"
      }, ";");
      let res;
      try {
        res = await next(args);
        if (!res)
          throw new Error("Failed to get response from instrumented AWS Client.");
        const [aws2, http] = await buildAttributesFromMetadata(service, operation, await config.region(), res, null);
        subsegment.addAttribute("aws", aws2);
        subsegment.addAttribute("http", http);
        addFlags(http, subsegment);
        subsegment.close();
        return res;
      } catch (err) {
        if (err.$metadata) {
          const [aws2, http] = await buildAttributesFromMetadata(service, operation, await config.region(), null, err);
          subsegment.addAttribute("aws", aws2);
          subsegment.addAttribute("http", http);
          addFlags(http, subsegment, err);
        }
        const errObj = { message: err.message, name: err.name, stack: err.stack || new Error().stack };
        subsegment.close(errObj, true);
        throw err;
      }
    };
    var xRayMiddlewareOptions = {
      name: XRAY_PLUGIN_NAME,
      step: "build"
    };
    var getXRayPlugin = (config, manualSegment) => ({
      applyToStack: (stack) => {
        stack.add(getXRayMiddleware(config, manualSegment), xRayMiddlewareOptions);
      }
    });
    function captureAWSClient(client, manualSegment) {
      client.middlewareStack.remove(XRAY_PLUGIN_NAME);
      client.middlewareStack.use(getXRayPlugin(client.config, manualSegment));
      return client;
    }
    exports.captureAWSClient = captureAWSClient;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/patchers/http_p.js
var require_http_p = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/patchers/http_p.js"(exports, module2) {
    "use strict";
    var url = require("url");
    var contextUtils = require_context_utils();
    var Utils = require_utils4();
    var logger = require_logger();
    var events = require("events");
    var captureHTTPsGlobal = function captureHTTPsGlobal2(module3, downstreamXRayEnabled, subsegmentCallback) {
      if (!module3.__request)
        enableCapture(module3, downstreamXRayEnabled, subsegmentCallback);
    };
    var captureHTTPs = function captureHTTPs2(module3, downstreamXRayEnabled, subsegmentCallback) {
      if (module3.__request)
        return module3;
      var tracedModule = {};
      Object.keys(module3).forEach(function(val) {
        tracedModule[val] = module3[val];
      });
      enableCapture(tracedModule, downstreamXRayEnabled, subsegmentCallback);
      return tracedModule;
    };
    function enableCapture(module3, downstreamXRayEnabled, subsegmentCallback) {
      function captureOutgoingHTTPs(baseFunc, ...args) {
        let options;
        let callback;
        let hasUrl;
        let urlObj;
        let arg0 = args[0];
        if (typeof args[1] === "object") {
          hasUrl = true;
          urlObj = typeof arg0 === "string" ? new url.URL(arg0) : arg0;
          options = args[1], callback = args[2];
        } else {
          hasUrl = false;
          options = arg0;
          callback = args[1];
        }
        if (!options || options.headers && options.headers["X-Amzn-Trace-Id"]) {
          return baseFunc(...args);
        }
        if (typeof options === "string") {
          options = new url.URL(options);
        }
        if (!hasUrl) {
          urlObj = options;
        }
        const parent = contextUtils.resolveSegment(contextUtils.resolveManualSegmentParams(options));
        const hostname = options.hostname || options.host || urlObj.hostname || urlObj.host || "Unknown host";
        if (!parent) {
          let output = "[ host: " + hostname;
          output = options.method ? output + ", method: " + options.method : output;
          output += ", path: " + (urlObj.pathname || Utils.stripQueryStringFromPath(options.path)) + " ]";
          if (!contextUtils.isAutomaticMode()) {
            logger.getLogger().info("Options for request " + output + ' requires a segment object on the options params as "XRaySegment" for tracing in manual mode. Ignoring.');
          } else {
            logger.getLogger().info("Options for request " + output + " is missing the sub/segment context for automatic mode. Ignoring.");
          }
          return baseFunc(...args);
        }
        const subsegment = parent.addNewSubsegment(hostname);
        const root = parent.segment ? parent.segment : parent;
        subsegment.namespace = "remote";
        if (!options.headers)
          options.headers = {};
        options.headers["X-Amzn-Trace-Id"] = "Root=" + root.trace_id + ";Parent=" + subsegment.id + ";Sampled=" + (!root.notTraced ? "1" : "0");
        const errorCapturer = function errorCapturer2(e) {
          if (subsegmentCallback)
            subsegmentCallback(subsegment, this, null, e);
          if (subsegment.http && subsegment.http.response) {
            if (Utils.getCauseTypeFromHttpStatus(subsegment.http.response.status) === "error") {
              subsegment.addErrorFlag();
            }
            subsegment.close(e, true);
          } else {
            const madeItToDownstream = e.code !== "ECONNREFUSED";
            subsegment.addRemoteRequestData(this, null, madeItToDownstream && downstreamXRayEnabled);
            subsegment.close(e);
          }
          if (!events.errorMonitor && this.listenerCount("error") <= 1) {
            this.removeListener("error", errorCapturer2);
            this.emit("error", e);
          }
        };
        const optionsCopy = Utils.objectWithoutProperties(options, ["Segment"], true);
        let req = baseFunc(...hasUrl ? [arg0, optionsCopy] : [options], function(res) {
          res.on("end", function() {
            if (subsegmentCallback)
              subsegmentCallback(subsegment, this.req, res);
            if (res.statusCode === 429)
              subsegment.addThrottleFlag();
            const cause = Utils.getCauseTypeFromHttpStatus(res.statusCode);
            if (cause)
              subsegment[cause] = true;
            subsegment.addRemoteRequestData(res.req, res, !!downstreamXRayEnabled);
            subsegment.close();
          });
          if (typeof callback === "function") {
            if (contextUtils.isAutomaticMode()) {
              const session = contextUtils.getNamespace();
              session.run(function() {
                contextUtils.setSegment(subsegment);
                callback(res);
              });
            } else {
              callback(res);
            }
          } else if (res.req && res.req.listenerCount("response") === 0) {
            res.resume();
          }
        });
        req.on(events.errorMonitor || "error", errorCapturer);
        return req;
      }
      module3.__request = module3.request;
      module3.request = function captureHTTPsRequest(...args) {
        return captureOutgoingHTTPs(module3.__request, ...args);
      };
      module3.__get = module3.get;
      module3.get = function captureHTTPsGet(...args) {
        return captureOutgoingHTTPs(module3.__get, ...args);
      };
    }
    module2.exports.captureHTTPsGlobal = captureHTTPsGlobal;
    module2.exports.captureHTTPs = captureHTTPs;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/patchers/promise_p.js
var require_promise_p = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/patchers/promise_p.js"(exports, module2) {
    "use strict";
    var contextUtils = require_context_utils();
    var originalThen = Symbol("original then");
    var originalCatch = Symbol("original catch");
    function patchPromise(Promise2) {
      const then = Promise2.prototype.then;
      if (!then[originalThen]) {
        Promise2.prototype.then = function(onFulfilled, onRejected) {
          if (contextUtils.isAutomaticMode() && tryGetCurrentSegment()) {
            const ns = contextUtils.getNamespace();
            onFulfilled = onFulfilled && ns.bind(onFulfilled);
            onRejected = onRejected && ns.bind(onRejected);
          }
          return then.call(this, onFulfilled, onRejected);
        };
        Promise2.prototype.then[originalThen] = then;
      }
      const origCatch = Promise2.prototype.catch;
      if (origCatch && !origCatch[originalCatch]) {
        Promise2.prototype.catch = function(onRejected) {
          if (contextUtils.isAutomaticMode() && tryGetCurrentSegment()) {
            const ns = contextUtils.getNamespace();
            onRejected = onRejected && ns.bind(onRejected);
          }
          return origCatch.call(this, onRejected);
        };
        Promise2.prototype.catch[originalCatch] = origCatch;
      }
    }
    function unpatchPromise(Promise2) {
      const then = Promise2.prototype.then;
      if (then[originalThen]) {
        Promise2.prototype.then = then[originalThen];
      }
      const origCatch = Promise2.prototype.catch;
      if (origCatch && origCatch[originalCatch]) {
        Promise2.prototype.catch = origCatch[originalCatch];
      }
    }
    function tryGetCurrentSegment() {
      try {
        return contextUtils.getSegment();
      } catch (e) {
        return void 0;
      }
    }
    function capturePromise() {
      patchPromise(Promise);
    }
    function uncapturePromise() {
      unpatchPromise(Promise);
    }
    capturePromise.patchThirdPartyPromise = patchPromise;
    module2.exports.capturePromise = capturePromise;
    module2.exports.uncapturePromise = uncapturePromise;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/database/sql_data.js
var require_sql_data = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/database/sql_data.js"(exports, module2) {
    "use strict";
    function SqlData(databaseVer, driverVer, user, url, queryType) {
      this.init(databaseVer, driverVer, user, url, queryType);
    }
    SqlData.prototype.init = function init(databaseVer, driverVer, user, url, queryType) {
      if (databaseVer)
        this.database_version = databaseVer;
      if (driverVer)
        this.driver_version = driverVer;
      if (queryType)
        this.preparation = queryType;
      this.url = url;
      this.user = user;
    };
    module2.exports = SqlData;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/aws-xray.js
var require_aws_xray = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/aws-xray.js"(exports, module2) {
    "use strict";
    var contextUtils = require_context_utils();
    var logging = require_logger();
    var segmentUtils = require_segment_utils();
    var utils = require_utils4();
    var LambdaEnv = require_aws_lambda();
    var pkginfo = {};
    try {
      pkginfo = require_package3();
    } catch (err) {
      logging.getLogger().debug("Failed to load SDK data:", err);
    }
    var UNKNOWN = "unknown";
    var AWSXRay2 = {
      plugins: {
        EC2Plugin: require_ec2_plugin(),
        ECSPlugin: require_ecs_plugin(),
        ElasticBeanstalkPlugin: require_elastic_beanstalk_plugin()
      },
      config: function(plugins) {
        var pluginData = {};
        plugins.forEach(function(plugin) {
          plugin.getData(function(data) {
            if (data) {
              for (var attribute in data) {
                pluginData[attribute] = data[attribute];
              }
            }
          });
          segmentUtils.setOrigin(plugin.originName);
          segmentUtils.setPluginData(pluginData);
        });
      },
      setAWSWhitelist: require_aws2().setAWSWhitelist,
      appendAWSWhitelist: require_aws2().appendAWSWhitelist,
      setStreamingThreshold: segmentUtils.setStreamingThreshold,
      setLogger: logging.setLogger,
      getLogger: logging.getLogger,
      setDaemonAddress: require_daemon_config().setDaemonAddress,
      captureFunc: require_capture().captureFunc,
      captureAsyncFunc: require_capture().captureAsyncFunc,
      captureCallbackFunc: require_capture().captureCallbackFunc,
      captureAWS: require_aws_p().captureAWS,
      captureAWSClient: require_aws_p().captureAWSClient,
      captureAWSv3Client: require_aws3_p().captureAWSClient,
      captureHTTPs: require_http_p().captureHTTPs,
      captureHTTPsGlobal: require_http_p().captureHTTPsGlobal,
      capturePromise: require_promise_p().capturePromise,
      utils,
      database: {
        SqlData: require_sql_data()
      },
      middleware: require_mw_utils(),
      getNamespace: contextUtils.getNamespace,
      resolveSegment: contextUtils.resolveSegment,
      getSegment: contextUtils.getSegment,
      setSegment: contextUtils.setSegment,
      isAutomaticMode: contextUtils.isAutomaticMode,
      enableAutomaticMode: contextUtils.enableAutomaticMode,
      enableManualMode: contextUtils.enableManualMode,
      setContextMissingStrategy: contextUtils.setContextMissingStrategy,
      Segment: require_segment(),
      Subsegment: require_subsegment(),
      SegmentUtils: segmentUtils
    };
    AWSXRay2.middleware.IncomingRequestData = require_incoming_request_data(), function() {
      var data = {
        runtime: process.release && process.release.name ? process.release.name : UNKNOWN,
        runtime_version: process.version,
        version: process.env.npm_package_version || UNKNOWN,
        name: process.env.npm_package_name || UNKNOWN
      };
      var sdkData = {
        sdk: "X-Ray for Node.js",
        sdk_version: pkginfo.version ? pkginfo.version : UNKNOWN,
        package: pkginfo.name ? pkginfo.name : UNKNOWN
      };
      segmentUtils.setSDKData(sdkData);
      segmentUtils.setServiceData(data);
      if (process.env.LAMBDA_TASK_ROOT)
        LambdaEnv.init();
    }();
    module2.exports = AWSXRay2;
  }
});

// node_modules/aws-xray-sdk-core/dist/lib/index.js
var require_lib13 = __commonJS({
  "node_modules/aws-xray-sdk-core/dist/lib/index.js"(exports, module2) {
    "use strict";
    module2.exports = require_aws_xray();
  }
});

// src/backend/transliterator/transliterator.ecstask.ts
__export(exports, {
  handler: () => handler
});
var os = __toModule(require("os"));
var path = __toModule(require("path"));
var import_zlib = __toModule(require("zlib"));
var import_aws_embedded_metrics = __toModule(require_lib());
var fs = __toModule(require_lib2());
var docgen = __toModule(require_lib11());

// src/backend/shared/aws.lambda-shared.ts
var _AWS = __toModule(require_aws());
var AWSXRay = __toModule(require_lib13());
AWSXRay.setContextMissingStrategy(() => {
});
var AWS2 = AWSXRay.captureAWS(_AWS);
var _s3;
function s3() {
  if (_s3 == null) {
    _s3 = new AWS2.S3();
  }
  return _s3;
}

// src/backend/shared/code-artifact.lambda-shared.ts
var import_aws_sdk = __toModule(require_aws());

// src/backend/shared/shell-out.lambda-shared.ts
var import_child_process = __toModule(require("child_process"));
function shellOut(cmd, ...args) {
  return new Promise((ok, ko) => {
    const child = (0, import_child_process.spawn)(cmd, args, { stdio: ["ignore", "inherit", "inherit"] });
    child.once("error", ko);
    child.once("close", (code, signal) => {
      if (code === 0) {
        return ok();
      }
      const reason = code != null ? `exit code ${code}` : `signal ${signal}`;
      ko(new Error(`Command "${cmd} ${args.join(" ")}" failed with ${reason}`));
    });
  });
}

// src/backend/shared/code-artifact.lambda-shared.ts
async function logInWithCodeArtifact({ endpoint, domain, domainOwner, apiEndpoint }) {
  const protoRelativeEndpoint = endpoint.replace(/^[^:]+:/, "");
  const { authorizationToken } = await new import_aws_sdk.CodeArtifact({ endpoint: apiEndpoint }).getAuthorizationToken({
    domain,
    domainOwner,
    durationSeconds: 0
  }).promise();
  await shellOut("npm", "config", "set", `registry=${endpoint}`);
  await shellOut("npm", "config", "set", `${protoRelativeEndpoint}:_authToken=${authorizationToken}`);
  await shellOut("npm", "config", "set", `${protoRelativeEndpoint}:always-auth=true`);
}

// src/backend/shared/language.ts
var _DocumentationLanguage = class {
  constructor(lang) {
    this.lang = lang;
  }
  static fromString(lang) {
    switch (lang) {
      case _DocumentationLanguage.TYPESCRIPT.toString():
        return _DocumentationLanguage.TYPESCRIPT;
      case _DocumentationLanguage.PYTHON.toString():
        return _DocumentationLanguage.PYTHON;
      case _DocumentationLanguage.JAVA.toString():
        return _DocumentationLanguage.JAVA;
      default:
        throw new UnsupportedLanguageError(lang, _DocumentationLanguage.ALL);
    }
  }
  toString() {
    return this.lang;
  }
};
var DocumentationLanguage = _DocumentationLanguage;
DocumentationLanguage.TYPESCRIPT = new _DocumentationLanguage("typescript");
DocumentationLanguage.PYTHON = new _DocumentationLanguage("python");
DocumentationLanguage.JAVA = new _DocumentationLanguage("java");
DocumentationLanguage.ALL = [
  _DocumentationLanguage.TYPESCRIPT,
  _DocumentationLanguage.PYTHON,
  _DocumentationLanguage.JAVA
];
var UnsupportedLanguageError = class extends Error {
  constructor(lang, supported) {
    super(`Unsupported language: ${lang}. Supported languages are: [${supported}]`);
  }
};

// src/backend/shared/constants.ts
var STORAGE_KEY_PREFIX = "data/";
var ASSEMBLY_KEY_SUFFIX = "/assembly.json";
var DOCS_KEY_SUFFIX_TYPESCRIPT = docsKeySuffix(DocumentationLanguage.TYPESCRIPT);
var DOCS_KEY_SUFFIX_PYTHON = docsKeySuffix(DocumentationLanguage.PYTHON);
var DOCS_KEY_SUFFIX_JAVA = docsKeySuffix(DocumentationLanguage.JAVA);
var DOCS_KEY_SUFFIX_ANY = docsKeySuffix("*");
function docsKeySuffix(lang, submodule) {
  return `/docs-${submodule ? `${submodule}-` : ""}${lang}.md`;
}
var NOT_SUPPORTED_SUFFIX = ".not-supported";
var STORAGE_KEY_FORMAT_REGEX = new RegExp(`^${STORAGE_KEY_PREFIX}((?:@[^/]+/)?[^/]+)/v([^/]+)/.*$`);

// src/backend/shared/env.lambda-shared.ts
var import_process = __toModule(require("process"));
function requireEnv(name) {
  const result = import_process.env[name];
  if (!result) {
    throw new Error(`No value specified for required environment variable: ${name}`);
  }
  return result;
}

// src/backend/transliterator/constants.ts
var METRICS_NAMESPACE = "ConstructHub/DocGen";
var MetricName;
(function(MetricName2) {
  MetricName2["DOCUMENT_SIZE"] = "DocumentSizeBytes";
  MetricName2["COMPRESSED_DOCUMENT_SIZE"] = "CompressedDocumentSizeBytes";
})(MetricName || (MetricName = {}));

// src/backend/transliterator/transliterator.ecstask.ts
var ASSEMBLY_KEY_REGEX = new RegExp(`^${STORAGE_KEY_PREFIX}((?:@[^/]+/)?[^/]+)/v([^/]+)${ASSEMBLY_KEY_SUFFIX}$`);
function handler(event) {
  console.log(JSON.stringify(event, null, 2));
  return ensureWritableHome(async () => {
    var _a, _b;
    const endpoint = process.env.CODE_ARTIFACT_REPOSITORY_ENDPOINT;
    if (!endpoint) {
      console.log("No CodeArtifact endpoint configured - using npm's default registry");
    } else {
      console.log(`Using CodeArtifact registry: ${endpoint}`);
      const domain = requireEnv("CODE_ARTIFACT_DOMAIN_NAME");
      const domainOwner = process.env.CODE_ARTIFACT_DOMAIN_OWNER;
      const apiEndpoint = process.env.CODE_ARTIFACT_API_ENDPOINT;
      await logInWithCodeArtifact({ endpoint, domain, domainOwner, apiEndpoint });
    }
    const npmCacheDir = process.env.NPM_CACHE;
    if (npmCacheDir) {
      await fs.mkdirp(npmCacheDir);
      console.log(`Using shared NPM cache at: ${npmCacheDir}`);
      await shellOut("npm", "config", "set", `cache=${npmCacheDir}`);
    }
    const language = requireEnv("TARGET_LANGUAGE");
    const created = new Array();
    const [, packageName, packageVersion] = (_a = event.assembly.key.match(ASSEMBLY_KEY_REGEX)) != null ? _a : [];
    if (packageName == null) {
      throw new Error(`Invalid object key: "${event.assembly.key}". It was expected to match ${ASSEMBLY_KEY_REGEX}!`);
    }
    const packageFqn = `${packageName}@${packageVersion}`;
    console.log(`Source Bucket:  ${event.bucket}`);
    console.log(`Source Key:     ${event.assembly.key}`);
    console.log(`Source Version: ${event.assembly.versionId}`);
    console.log(`Fetching assembly: ${event.assembly.key}`);
    const assemblyResponse = await s3().getObject({ Bucket: event.bucket, Key: event.assembly.key }).promise();
    if (!assemblyResponse.Body) {
      throw new Error(`Response body for assembly at key ${event.assembly.key} is empty`);
    }
    const assembly = JSON.parse(assemblyResponse.Body.toString("utf-8"));
    const submodules = Object.keys((_b = assembly.submodules) != null ? _b : {}).map((s) => s.split(".")[1]);
    if (language !== "typescript" && assembly.targets[language] == null) {
      console.error(`Package ${assembly.name}@${assembly.version} does not support ${language}, skipping!`);
      console.log(`Assembly targets: ${JSON.stringify(assembly.targets, null, 2)}`);
      for (const submodule of [void 0, ...submodules]) {
        const key = event.assembly.key.replace(/\/[^/]+$/, docsKeySuffix(DocumentationLanguage.fromString(language), submodule)) + NOT_SUPPORTED_SUFFIX;
        const response = await uploadFile(event.bucket, key, event.assembly.versionId);
        created.push({ bucket: event.bucket, key, versionId: response.VersionId });
      }
      return created;
    }
    const generateDocs = (0, import_aws_embedded_metrics.metricScope)((metrics) => async (lang) => {
      metrics.setDimensions();
      metrics.setNamespace(METRICS_NAMESPACE);
      const uploads = new Map();
      const docs = await docgen.Documentation.forPackage(packageFqn, { language: docgen.Language.fromString(lang) });
      function renderAndDispatch(submodule) {
        console.log(`Rendering documentation in ${lang} for ${packageFqn} (submodule: ${submodule})`);
        const page = Buffer.from(docs.render({ submodule, linkFormatter: linkFormatter(docs) }).render());
        metrics.putMetric(MetricName.DOCUMENT_SIZE, page.length, import_aws_embedded_metrics.Unit.Bytes);
        const { buffer: body, contentEncoding } = compressContent(page);
        metrics.putMetric(MetricName.COMPRESSED_DOCUMENT_SIZE, body.length, import_aws_embedded_metrics.Unit.Bytes);
        const key = event.assembly.key.replace(/\/[^/]+$/, docsKeySuffix(DocumentationLanguage.fromString(lang), submodule));
        console.log(`Uploading ${key}`);
        const upload = uploadFile(event.bucket, key, event.assembly.versionId, body, contentEncoding);
        uploads.set(key, upload);
      }
      renderAndDispatch();
      for (const submodule of submodules) {
        renderAndDispatch(submodule);
      }
      for (const [key, upload] of uploads.entries()) {
        const response = await upload;
        created.push({ bucket: event.bucket, key, versionId: response.VersionId });
        console.log(`Finished uploading ${key} (Version ID: ${response.VersionId})`);
      }
    });
    await generateDocs(language);
    return created;
  });
}
function compressContent(buffer) {
  if (buffer.length < 1024) {
    return { buffer };
  }
  const gz = (0, import_zlib.gzipSync)(buffer, { level: 9 });
  if (gz.length >= buffer.length) {
    return { buffer };
  }
  return { buffer, contentEncoding: "gzip" };
}
async function ensureWritableHome(cb) {
  const fakeHome = await fs.mkdtemp(path.join(os.tmpdir(), "fake-home"));
  console.log(`Made temporary $HOME directory: ${fakeHome}`);
  const oldHome = process.env.HOME;
  try {
    process.env.HOME = fakeHome;
    return await cb();
  } finally {
    process.env.HOME = oldHome;
    await fs.remove(fakeHome);
    console.log(`Cleaned-up temporary $HOME directory: ${fakeHome}`);
  }
}
function uploadFile(bucket, key, sourceVersionId, body, contentEncoding) {
  return s3().putObject({
    Bucket: bucket,
    Key: key,
    Body: body,
    CacheControl: "public",
    ContentEncoding: contentEncoding,
    ContentType: "text/markdown; charset=UTF-8",
    Metadata: {
      "Origin-Version-Id": sourceVersionId != null ? sourceVersionId : "N/A"
    }
  }).promise();
}
function linkFormatter(docs) {
  function _formatter(type) {
    const packageName = type.source.assembly.name;
    const packageVersion = type.source.assembly.version;
    const hash = sanitize(type.fqn);
    if (docs.assembly.name === packageName) {
      return `#${hash}`;
    }
    return `/packages/${packageName}/v/${packageVersion}?lang=${type.language.toString()}${type.submodule ? `&submodule=${type.submodule}` : ""}#${hash}`;
  }
  return _formatter;
}
function sanitize(input) {
  return input.toLowerCase().replace(/[^a-zA-Z0-9 ]/g, "").replace(/ /g, "-");
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  handler
});
/* commonmark 0.30.0 https://github.com/commonmark/commonmark.js @license BSD3 */
/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/*! Case - v1.6.2 - 2020-03-24
* Copyright (c) 2020 Nathan Bubna; Licensed MIT, GPL */
/*! http://mths.be/fromcodepoint v0.1.0 by @mathias */
/*! http://mths.be/fromcodepoint v0.2.1 by @mathias */
/*! http://mths.be/repeat v0.2.0 by @mathias */
//# sourceMappingURL=index.js.map
